if $leg_is_restart
then
    trc_restart=".TRUE."
else
    trc_restart=".FALSE."
fi

cat << EOF
!!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
!! NEMO/TOP1 :   - tracer run information                (namtrc_run)
!!               - tracer definition                     (namtrc    )
!!               - tracer data initialisation            (namtrc_dta)
!!               - tracer advection                      (namtrc_adv)
!!               - tracer lateral diffusion              (namtrc_ldf)
!!               - tracer vertical physics               (namtrc_zdf)
!!               - tracer newtonian damping              (namtrc_dmp)
!!               - dynamical tracer trends               (namtrc_trd)
!!               - tracer output diagonstics             (namtrc_dia)
!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
!-----------------------------------------------------------------------
&namtrc_run     !   run information
!-----------------------------------------------------------------------
   nn_dttrc      =  1        !  time step frequency for passive sn_tracers
   nn_writetrc   =  5475     !  time step frequency for sn_tracer outputs
   ln_top_euler  = .false.    !  use Euler time-stepping for TOP
   ln_rsttr      = $trc_restart !  start from a restart file (T) or not (F)
   nn_rsttr      =   0       !  restart control = 0 initial time step is not compared to the restart file value
                           !                  = 1 do not use the value in the restart file
                           !                  = 2 calendar parameters read in the restart file
   cn_trcrst_in  = "restart_trc"   !  suffix of pass. sn_tracer restart name (input)
   cn_trcrst_indir = "."           !  directory from which to read input passive tracer restarts
   cn_trcrst_out = "restart_trc"   !  suffix of pass. sn_tracer restart name (output)
   cn_trcrst_outdir = "."          !  directory to which to write output passive tracer restarts
/
!-----------------------------------------------------------------------
&namtrc     !   tracers definition
!-----------------------------------------------------------------------
   ln_trcdta     =   .true.  !  Initialisation from data input file (T) or not (F)
   ln_trcdmp     =  .false.  !  add a damping termn (T) or not (F)
   ln_trcdmp_clo =  .false.  !  damping term (T) or not (F) on closed seas
/
!-----------------------------------------------------------------------
&namtrc_dta      !    Initialisation from data input file
!-----------------------------------------------------------------------
!
   cn_dir        =  './'      !  root directory for the location of the data files
/
!-----------------------------------------------------------------------
&namtrc_adv    !   advection scheme for passive tracer 
!-----------------------------------------------------------------------
   ln_trcadv_cen2    =  .false.  !  2nd order centered scheme   
   ln_trcadv_tvd     =  .true.  !  TVD scheme
   ln_trcadv_muscl   =  .false.   !  MUSCL scheme
   ln_trcadv_muscl2  =  .false.  !  MUSCL2 scheme + cen2 at boundaries
   ln_trcadv_ubs     =  .false.  !  UBS scheme
   ln_trcadv_qck     =  .false.  !  QUICKEST scheme
   ln_trcadv_msc_ups =  .false.  !  use upstream scheme within muscl
/
!-----------------------------------------------------------------------
&namtrc_ldf    !   lateral diffusion scheme for passive tracer 
!-----------------------------------------------------------------------
!                               !  Type of the operator : 
   ln_trcldf_lap    =  .true.   !     laplacian operator       
   ln_trcldf_bilap  =  .false.  !     bilaplacian operator     
                                !  Direction of action  :
   ln_trcldf_level  =  .false.  !     iso-level                
   ln_trcldf_hor    =  .false.  !     horizontal (geopotential)         (require "key_ldfslp" when ln_sco=T)
   ln_trcldf_iso    =  .true.   !     iso-neutral                       (require "key_ldfslp")
!                               !  Coefficient
   rn_ahtrc_0       =  2000.    !  horizontal eddy diffusivity for tracers [m2/s]
   rn_ahtrb_0       =     0.    !     background eddy diffusivity for ldf_iso [m2/s]
   rn_fact_lap      =     1.    !     enhanced zonal eddy diffusivity
/
!-----------------------------------------------------------------------
&namtrc_zdf        !   vertical physics
!-----------------------------------------------------------------------
   ln_trczdf_exp   =  .false.  !  split explicit (T) or implicit (F) time stepping
   nn_trczdf_exp   =   3       !  number of sub-timestep for ln_trczdfexp=T
/
!-----------------------------------------------------------------------
&namtrc_rad        !  treatment of negative concentrations 
!-----------------------------------------------------------------------
   ln_trcrad   =  .true.  !  artificially correct negative concentrations (T) or not (F)
/
!-----------------------------------------------------------------------
&namtrc_dmp    !   passive tracer newtonian damping   
!-----------------------------------------------------------------------
   nn_zdmp_tr  =    1      !  vertical   shape =0    damping throughout the water column
                           !                   =1 no damping in the mixing layer (kz  criteria)
                           !                   =2 no damping in the mixed  layer (rho crieria)
   cn_resto_tr  = 'resto_tr.nc'    !  create a damping.coeff NetCDF file (=1) or not (=0)
/
!-----------------------------------------------------------------------
&namtrc_ice       !    Representation of sea ice growth & melt effects
!-----------------------------------------------------------------------
   nn_ice_tr   =  -1        !  tracer concentration in sea ice 
                           !    =-1 (no vvl: identical cc in ice and ocean / vvl: cc_ice = 0)
                           !    = 0 (no vvl: cc_ice = zero / vvl: cc_ice = )
                           !    = 1 prescribed to a namelist value (implemented in pisces only)
/
!-----------------------------------------------------------------------
&namtrc_trd       !   diagnostics on tracer trends        ('key_trdtrc')
!                          or mixed-layer trends          ('key_trdmld_trc')
!----------------------------------------------------------------------
   nn_trd_trc  =  5475      !  time step frequency and tracers trends
   nn_ctls_trc =   0        !  control surface type in mixed-layer trends (0,1 or n<jpk)
   rn_ucf_trc  =   1        !  unit conversion factor (=1 -> /seconds ; =86400. -> /day)
   ln_trdmld_trc_restart = .false.  !  restart for ML diagnostics
   ln_trdmld_trc_instant = .true.  !  flag to diagnose trends of instantantaneous or mean ML T/S
   ln_trdtrc(1)  =   .true.
   ln_trdtrc(2)  =   .true.
   ln_trdtrc(23) =   .true.
/
!-----------------------------------------------------------------------
&namtrc_dia       !   parameters for passive tracer additional diagnostics
!----------------------------------------------------------------------
   ln_diatrc     =  .true.   !  save additional diag. (T) or not (F)
   ln_diabio     =  .true.   !  output biological trends
   nn_writedia   =  5475     !  time step frequency for diagnostics
   nn_writebio   =    10     !: frequency of biological outputs
/
!----------------------------------------------------------------------
! namtrc_bc       !   data for boundary conditions
!-----------------------------------------------------------------------
&namtrc_bc
!
   cn_dir        =  './'      !  root directory for the location of the data files
/
EOF
