      subroutine dd (prosca,ctonb,ctcab,n,sscale,nm,depl,aux,jmin,jmax,
     &               precos,diag,alpha,ybar,sbar)
c----
c
c     calcule le produit H.g ou
c         . H est une matrice construite par la formule de bfgs inverse
c           a nm memoires a partir de la matrice diagonale diag
c           dans un espace hilbertien dont le produit scalaire
c           est donne par prosca
c           (cf. J. Nocedal, Math. of Comp. 35/151 (1980) 773-782)
c         . g est un vecteur de dimension n (en general le gradient)
c
c     la matrice diag apparait donc comme un preconditionneur diagonal
c
c     depl = g (en entree), = H g (en sortie)
c
c     la matrice H est memorisee par les vecteurs des tableaux
c     ybar, sbar et les pointeurs jmin, jmax
c
c     alpha(nm) est une zone de travail
c
c     izs(1),rzs(1),dzs(1) sont des zones de travail pour prosca
c
c----
      use control_vectors
      implicit none
c
c         arguments
c
      logical sscale
      integer n,nm,jmin,jmax        
      real precos,alpha(nm)
      type (control_vector) :: depl,diag,aux
      type (control_vector),dimension(nm) :: ybar,sbar
      external prosca,ctonb,ctcab
c
c         variables locales
c
      integer jfin,i,j,jp
      real r,ps

      call ctonb (n,depl,aux)

      jfin=jmax
      if (jfin.lt.jmin) jfin=jmax+nm
c
c         phase de descente
c
      do j=jfin,jmin,-1
          jp=j
          if (jp.gt.nm) jp=jp-nm
          ps = DOT_PRODUCT (aux,sbar(jp))
          r=ps
          alpha(jp)=r
          aux%data = aux%data -r * ybar(jp)%data
      enddo
c
c         preconditionnement
c
      if (sscale) then
          aux%data = aux%data * precos
      else
          aux%data = aux%data * diag%data
      endif
c
c         remontee
c
      do j=jmin,jfin
          jp=j
          if (jp.gt.nm) jp=jp-nm
          ps = DOT_PRODUCT (aux,ybar(jp))
          r=alpha(jp)-ps
          aux%data = aux%data + r * sbar(jp)%data
      enddo

      call ctcab (n,aux,depl)

      return
      end
c
c-----------------------------------------------------------------------
c

