      subroutine ddsr (proscar,ctonbr,ctcabr,n,sscale,nm,depl,aux,jmin,
     &                 jmax,precos,diag,alpha,ybar,sbar)
c----
c
c     This subroutine has the same role as ddr (computation of the
c     product H.g). It supposes however that the (y,s) pairs are not
c     stored in core memory, but on a devise chosen by the user.
c     The access to this devise is performed via the subroutine ystbl.
c
c----
c
c         arguments
c
      logical sscale
      integer n,nm,jmin,jmax        
      real depl(n),precos,diag(n),alpha(nm),ybar(n),sbar(n),        
     &     aux(n)
      external proscar,ctonbr,ctcabr
c
c         variables locales
c
      integer jfin,i,j,jp
      real r
      real ps
c
      jfin=jmax
      if (jfin.lt.jmin) jfin=jmax+nm
c
c         phase de descente
c
      do 100 j=jfin,jmin,-1
          jp=j
          if (jp.gt.nm) jp=jp-nm
          call ystblr (.false.,ybar,sbar,n,jp)
          call proscar (n,depl,sbar,ps)
          r=ps
          alpha(jp)=r
          do 20 i=1,n
              depl(i)=depl(i)-r*ybar(i)
20        continue
100   continue
c
c         preconditionnement
c
      if (sscale) then
          do 150 i=1,n
              depl(i)=depl(i)*precos
  150     continue
      else
          call ctonbr (n,depl,aux)
          do 151 i=1,n
              aux(i)=aux(i)*diag(i)
  151     continue
          call ctcabr (n,aux,depl)
      endif
c
c         remontee
c
      do 200 j=jmin,jfin
          jp=j
          if (jp.gt.nm) jp=jp-nm
          call ystblr (.false.,ybar,sbar,n,jp)
          call proscar (n,depl,ybar(1),ps)
          r=alpha(jp)-ps
          do 120 i=1,n
              depl(i)=depl(i)+r*sbar(i)
120       continue
200   continue
      return
      end
c
c-----------------------------------------------------------------------
c

