      subroutine m1qn3a (simul,prosca,ctonb,ctcab,n,x,f,g,dxmin,df1,
     /                   epsg,impres,io,mode,niter,nsim,inmemo,m,jmin,
     /                   jmax,d,gg,diag,aux,alpha,ybar,sbar)
c----
c
c     Code d'optimisation proprement dit.
c
c----
      use control_vectors
      implicit none
c
c         arguments
c
      logical inmemo
      integer n,impres,io,mode,niter,nsim,m,jmin,jmax,iprint       
      real f,dxmin,df1,epsg,alpha(m)
      external simul,prosca,ctonb,ctcab
      type (control_vector) :: x,g,d,gg,diag,aux
      type (control_vector),dimension(m) :: ybar,sbar
c
c         variables locales
c
      logical sscale,cold,warm
      integer i,itmax,moderl,isim,jcour,indic
      real r1,t,tmin,tmax,gnorm,eps1,ff,preco,precos,ys,den,dk,dk1
      real ps,ps2,hp0
      type (control_vector) :: ztemp
c
c         parametres
c
      real rm1,rm2
      parameter (rm1=0.0001,rm2=0.9)
      real pi
      parameter (pi=3.1415927)
      real rmin
c
c---- initialisation
c
      call allocate_ctlvec(ztemp,x)
      rmin=1.e-20
c
      sscale=.true.
      if (mod(mode,2).eq.0) sscale=.false.
c
      warm=.false.
      if (mode/2.eq.1) warm=.true.
      cold=.not.warm
c
      itmax=niter
      niter=0
      isim=1
      eps1=1.
c
      call prosca (n,g,g,ps)

      gnorm=sqrt(ps)
      if (impres.ge.1) write (io,900) f,gnorm
  900 format (5x,"f         = ",e15.8
     /       /5x,"norm of g = ",e15.8)
      if (gnorm.lt.rmin) then
          mode=2
          if (impres.ge.1) write (io,901)
          goto 1000
      endif
  901 format (/" >>> m1qn3a: initial gradient is too small")
c
c     --- initialisation pour dd
c
      if (cold) then
          jmin=1
          jmax=0
      endif
      jcour=1
      if (inmemo) jcour=jmax
c
c     --- mise a l'echelle de la premiere direction de descente
c
      if (cold) then
c
c         --- use Fletcher's scaling and initialize diag to 1.
c
          precos=2.*df1/gnorm**2
          d%data  = -g%data * precos
          diag = 1.
c
          if (impres.ge.5) write(io,902) precos
  902     format (/" m1qn3a: descent direction -g: precon = ",e10.3)
      else
c
c         --- use the matrix stored in [diag and] the (y,s) pairs
c
          if (sscale) then
              ps = DOT_PRODUCT (ybar(jcour),ybar(jcour))
              precos=1./ps
          endif
          d%data = -g%data
          if (inmemo) then
              call dd (prosca,ctonb,ctcab,n,sscale,m,d,aux,jmin,jmax,
     /                 precos,diag,alpha,ybar,sbar)
          else
              call dds (prosca,ctonb,ctcab,n,sscale,m,d,aux,jmin,jmax,
     /                  precos,diag,alpha,ybar(1),sbar(1))
          endif
      endif
c
      if (impres.eq.3) then
          write(io,903)
          write(io,904)
      endif
      if (impres.eq.4) write(io,903)
  903 format (/1x,79("-"))
  904 format (1x)
c
c     --- initialisation pour mlis0
c
      tmax=1.e+20
      call prosca (n,d,g,hp0)
      if (hp0.ge.0.0) then
          mode=7
          if (impres.ge.1) write (io,905) niter,hp0
          goto 1000
      endif
  905 format (/" >>> m1qn3 (iteration ",i2,"): "
     /        /5x," the search direction d is not a ",
     /         "descent direction: (g,d) = ",d12.5)
c
c     --- compute the angle (-g,d)
c
      if (warm.and.impres.ge.5) then
          call prosca (n,g,g,ps)
          ps=sqrt(ps)
          call prosca (n,d,d,ps2)
          ps2=sqrt(ps2)
          ps=hp0/ps/ps2
          ps=min(-ps,1.0)
          ps=acos(ps)
          r1=ps
          r1=r1*180./pi
          write (io,906) r1
      endif
  906 format (/" m1qn3: descent direction d: ",
     /        "angle(-g,d) = ",f5.1," degrees")

c---- Initialize run-time predictor

      call predict_runtime (0,itmax,eps1,epsg)
c
c---- Debut de l'iteration. on cherche x(k+1) de la forme x(k) + t*d,
c     avec t > 0. On connait d.
c
c         Debut de la boucle: etiquette 100,
c         Sortie de la boucle: goto 1000.
c

      iter_loop:do

      niter=niter+1
      if (impres.lt.0) then
          if (mod(niter,-impres).eq.0) then
              indic=1
              call simul (indic,n,x,f,g,niter)
              cycle
          endif
      endif
      if (impres.ge.5) write(io,903)
      if (impres.ge.4) write(io,904)
      if (impres.ge.3) write (io,910) niter,isim,f,hp0
  910 format (" m1qn3: iter ",i3,", simul ",i3,
     /        ", f=",e15.8,", h'(0)=",d12.5)

      gg = g
      ff=f
c
c     --- recherche lineaire et nouveau point x(k+1)
c
      if (impres.ge.5) write (io,911)
  911 format (/" m1qn3: line search")
c
c         --- calcul de tmin
c
      ztemp%data=abs(d%data)
      tmin=maxval(ztemp)
      tmin=dxmin/tmin
      t=1.
      r1=hp0
c
      call mlis0 (n,simul,prosca,x,f,r1,t,tmin,tmax,d,g,rm2,rm1,
     /           impres,io,moderl,isim,nsim,aux,niter,ztemp)
c
c         --- mlis0 renvoie les nouvelles valeurs de x, f et g
c
      if (moderl.ne.0) then
          if (moderl.lt.0) then
c
c             --- calcul impossible
c                 t, g: ou les calculs sont impossibles
c                 x, f: ceux du t_gauche (donc f <= ff)
c
              mode=moderl
          elseif (moderl.eq.1) then
c
c             --- descente bloquee sur tmax
c                 [sortie rare (!!) d'apres le code de mlis0]
c
              mode=3
              if (impres.ge.1) write(io,912) niter
  912         format (/" >>> m1qn3 (iteration ",i3,
     /                "): line search blocked on tmax: ",
     /                "decrease the scaling")
          elseif (moderl.eq.4) then
c
c             --- nsim atteint
c                 x, f: ceux du t_gauche (donc f <= ff)
c
              mode=5
          elseif (moderl.eq.5) then
c
c             --- arret demande par l'utilisateur (indic = 0)
c                 x, f: ceux en sortie du simulateur
c
              mode=0
          elseif (moderl.eq.6) then
c
c             --- arret sur dxmin ou appel incoherent
c                 x, f: ceux du t_gauche (donc f <= ff)
c
              mode=6
          endif
          exit
      endif
c
c NOTE: stopping tests are now done after having updated the matrix, so
c that update information can be stored in case of a later warm restart
c
c     --- mise a jour de la matrice
c
      if (m.gt.0) then
c
c         --- mise a jour des pointeurs
c
          jmax=jmax+1
          if (jmax.gt.m) jmax=jmax-m
          if ((cold.and.niter.gt.m).or.(warm.and.jmin.eq.jmax)) then
              jmin=jmin+1
              if (jmin.gt.m) jmin=jmin-m
          endif
          if (inmemo) jcour=jmax
c
c         --- y, s et (y,s)
c
          ztemp%data = t * d%data
          call ctonb (n,ztemp,sbar(jcour))

          ztemp%data = g%data - gg%data
          call ctonb (n,ztemp,ybar(jcour))

          if (impres.ge.5) then
              ps = DOT_PRODUCT (sbar(jcour),sbar(jcour))
              dk1=sqrt(ps)
              if (niter.gt.1) write (io,930) dk1/dk
  930         format (/" m1qn3: convergence rate, s(k)/s(k-1) = ",
     /                e12.5)
              dk=dk1
          endif
          ps = DOT_PRODUCT (ybar(jcour),sbar(jcour))
          ys=ps
          if (ys.le.0.) then
              mode=7
              if (impres.ge.1) write (io,931) niter,ys
  931         format (/" >>> m1qn3 (iteration ",i2,
     /                "): the scalar product (y,s) = ",e12.5
     /                /27x,"is not positive")
              exit
          endif
c
c         --- ybar et sbar
c
          r1=sqrt(1./ys)
          sbar(jcour)%data = r1 * sbar(jcour)%data
          ybar(jcour)%data = r1 * ybar(jcour)%data
          if (.not.inmemo) stop 'ystbl:dead code'
c         if (.not.inmemo) call ystbl (.true.,ybar,sbar,n,jmax)
c
c         --- compute the scalar or diagonal preconditioner
c
          if (impres.ge.5) write(io,932)
  932     format (/" m1qn3: matrix update:")
c
c             --- Here is the Oren-Spedicato factor, for scalar scaling
c
          if (sscale) then
              ps = DOT_PRODUCT (ybar(jcour),ybar(jcour))
              precos=1./ps
c
              if (impres.ge.5) write (io,933) precos
  933         format (5x,"Oren-Spedicato factor = ",e10.3)
c
c             --- Scale the diagonal to Rayleigh's ellipsoid.
c                 Initially (niter.eq.1) and for a cold start, this is
c                 equivalent to an Oren-Spedicato scaling of the
c                 identity matrix.
c
          else
              aux = ybar(jcour)
              ps=0.0
              ztemp%data = aux%data ** 2
              ps = dot_product(diag,ztemp)
              r1=1.0/ps
              if (impres.ge.5) then
                  write (io,934) r1
  934             format(5x,"fitting the ellipsoid: factor = ",e10.3)
              endif
              diag%data = diag%data * r1
c
c             --- update the diagonal
c                 (gg is used as an auxiliary vector)
c
              gg = sbar(jcour)
              ps=0.0
              ztemp%data = gg%data / diag%data
              ps = dot_product(gg,ztemp)
              den=ps
              IPRINT=0
              
!OCL NOALIAS
              do i=1,diag%nsizel
                  diag%data(i)=1./
     &            (1./diag%data(i)+aux%data(i)**2
     &           -(gg%data(i)/diag%data(i))**2/den)
                  if (diag%data(i).le.0.) then
                      diag%data(i)=rmin
                      IPRINT=I
                  endif
              enddo
              IF(IPRINT.NE.0) THEN
                if (impres.ge.5) write (io,935) IPRINT,
     &           diag%data(IPRINT),rmin
              ENDIF

  935         format (/" >>> m1qn3-WARNING: diagonal element ",i8,
     &                 " is negative (",e10.3,"), reset to ",e10.3)
c
              if (impres.ge.5) then
                  ps = sum(diag)
                  ps=ps/n
                  preco=ps
c
                  ztemp%data=(diag%data-ps)**2
                  ps2=sum(ztemp)
                  ps2=sqrt(ps2/n)
                  write (io,936) preco,ps2
  936             format (5x,"updated diagonal: average value = ",e10.3,
     &                   ", sqrt(variance) = ",e10.3)
              endif
          endif
      endif
c
c     --- tests d'arret
c
      call prosca(n,g,g,ps)
      eps1=ps
      eps1=sqrt(eps1)/gnorm
c
      if (impres.ge.5) write (io,940) eps1
  940 format (/" m1qn3: stopping criterion on g: ",e12.5)
      if (eps1.lt.epsg) then
          mode=1
          exit
      endif
      if (niter.eq.itmax) then
          mode=4
          if (impres.ge.1) write (io,941) niter
  941     format (/" >>> m1qn3 (iteration ",i3,
     /            "): maximal number of iterations")
          exit
      endif
      if (isim.gt.nsim) then
          mode=5
          if (impres.ge.1) write (io,942) niter,isim
  942     format (/" >>> m1qn3 (iteration ",i3,"): ",i6,
     /            " simulations (maximal number reached)")
          exit
      endif
c
c     --- calcul de la nouvelle direction de descente d = - H.g
c
      if (m.eq.0) then
          preco=2.*(ff-f)/(eps1*gnorm)**2
          d%data = -g%data * preco
      else 
          d%data = -g%data
          if (inmemo) then
              call dd (prosca,ctonb,ctcab,n,sscale,m,d,aux,jmin,jmax,
     /                 precos,diag,alpha,ybar,sbar)
          else
              call dds (prosca,ctonb,ctcab,n,sscale,m,d,aux,jmin,jmax,
     /                  precos,diag,alpha,ybar(1),sbar(1))
          endif
      endif
c
c         --- test: la direction d est-elle de descente ?
c             hp0 sera utilise par mlis0
c
      call prosca (n,d,g,hp0)
      if (hp0.ge.0.0) then
          mode=7
          if (impres.ge.1) write (io,905) niter,hp0
          exit
      endif
      if (impres.ge.5) then
          call prosca (n,g,g,ps)
          ps=sqrt(ps)
          call prosca (n,d,d,ps2)
          ps2=sqrt(ps2)
          ps=hp0/ps/ps2
          ps=min(-ps,1.0)
          ps=acos(ps)
          r1=ps
          r1=r1*180./pi
          write (io,906) r1
      endif

c---- Predict remaining runtime

      call predict_runtime (niter,itmax,eps1,epsg)
c
c
c---- on poursuit les iterations
c
      enddo iter_loop
c
c---- retour
c
 1000 continue
      nsim=isim
      epsg=eps1
      call deallocate_ctlvec(ztemp)
      return
      end
c
c-----------------------------------------------------------------------
c

