MODULE SPECTRAL_FIELDS_DATA

!     Purpose.
!     --------
!       Type definition and data for SPECTRAL_FIELDS_MOD.
!
!     Author.
!     -------
!       Y. Tremolet
!
!     Modifications.
!     --------------
!       Original    11-Mar-2004
! ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE
SAVE

TYPE SPECTRAL_FIELD
  REAL(KIND=JPRB), POINTER :: SP2D(:,:)
  REAL(KIND=JPRB), POINTER :: SP3D(:,:,:)
  REAL(KIND=JPRB), POINTER :: SP1D(:,:)
  INTEGER(KIND=JPIM) :: NSMAX
  INTEGER(KIND=JPIM) :: NMSMAX
  INTEGER(KIND=JPIM) :: NS2D
  INTEGER(KIND=JPIM) :: NS3D
  INTEGER(KIND=JPIM) :: NS1D
  INTEGER(KIND=JPIM) :: NS2G
  INTEGER(KIND=JPIM) :: NFLEVL
  INTEGER(KIND=JPIM) :: NFLEVG
  INTEGER(KIND=JPIM) :: NSPEC2
  INTEGER(KIND=JPIM) :: NSPEC2G
  INTEGER(KIND=JPIM) :: NUMP
  INTEGER(KIND=JPIM), POINTER :: NS2L(:)
  INTEGER(KIND=JPIM), POINTER :: NASM0(:)
  INTEGER(KIND=JPIM), POINTER :: NASM0G(:)
  INTEGER(KIND=JPIM), POINTER :: NESM0(:)
  INTEGER(KIND=JPIM), POINTER :: NESM0G(:)
  INTEGER(KIND=JPIM), POINTER :: NCPL4M(:)
  INTEGER(KIND=JPIM), POINTER :: NUMPP(:)
  INTEGER(KIND=JPIM), POINTER :: MS_PROC(:,:)  ! same as NALLMS, just easier to use
  INTEGER(KIND=JPIM), POINTER :: NUMLL(:)
  INTEGER(KIND=JPIM), POINTER :: NPTRLL(:)
  INTEGER(KIND=JPIM), POINTER :: NGRIB(:), NGRIB2(:), NGRIB3(:)
  INTEGER(KIND=JPIM), POINTER :: NPARAMID(:), NPARAMID2(:), NPARAMID3(:)
  INTEGER(KIND=JPIM) :: NSPSIZEL, NSPSIZEG
  REAL(KIND=JPRB), POINTER :: DIV(:,:)
  REAL(KIND=JPRB), POINTER :: VOR(:,:)
  REAL(KIND=JPRB), POINTER :: TEM(:,:)
  REAL(KIND=JPRB), POINTER :: HUM(:,:)
  REAL(KIND=JPRB), POINTER :: OZN(:,:)
  REAL(KIND=JPRB), POINTER :: SPR(:)
  REAL(KIND=JPRB), POINTER :: SCAL(:,:,:)  ! Scalar fields (for transforms)
END TYPE SPECTRAL_FIELD

INTEGER(KIND=JPIM) :: NPRTRV, NPRTRW, MYSETV, MYSETW, NFLEVL, NFLEVG
INTEGER(KIND=JPIM), ALLOCATABLE :: NALLMS(:), NPTRMS(:), NUMLL(:), NPTRLL(:), NPSURF(:)
INTEGER(KIND=JPIM), ALLOCATABLE :: MYMS(:), MYLEVS(:)
INTEGER(KIND=JPIM) :: NGRBVO, NGRBD, NGRBT, NGRBQ, NGRBO3, NGRBLNSP
INTEGER(KIND=JPIM) :: NULOUT
LOGICAL :: LSPRT, LELAM

END MODULE SPECTRAL_FIELDS_DATA
