!**** *LARCHE_HLP -  semi-LAgrangian scheme:
!                    interface with routines of library MASS;
!                    these routines being called for example in routine LARCHE.

!     Purpose.
!     --------
!      Routines JFH_VMOD,JFH_VIF2,VEXP_,VASIN_

!**   Interface.
!     ----------

!        Explicit arguments :
!        --------------------

!        Implicit arguments :
!        --------------------

!     Method.
!     -------
!        See documentation

!     Externals.
!     ----------

!     Reference.
!     ----------

!     Author.
!     -------
!        ???

!     Modifications.
!     --------------
!        Original : SEPTEMBER 2003.
!        Modified : 22 Sep 2003 K. YESSAD: rewrite in DOCTOR norm.
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     ------------------------------------------------------------------

! ======================================================================

#ifdef RS6K
@process OPT(3),STRICT
#endif

SUBROUTINE JFH_VMOD(PF,PC,KN)
USE PARKIND1  ,ONLY : JPIM     ,JPRB
!     USE XLF_FP_UTIL
!     ------------------------------------------------------------------
IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KN 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PF(KN) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PC 
INTEGER(KIND=JPIM) :: JI
REAL(KIND=JPRB) :: ZT,ZX

REAL(KIND=JPRB) :: PPRND
PARAMETER(PPRND=2.0_JPRB**52+2.0_JPRB**51)
!     ------------------------------------------------------------------
!     MODE=SET_ROUND_MODE(FP_RND_RN)
DO JI=1,KN
  ZT=PF(JI)*(1.0_JPRB/PC)
  ZX=ZT-SIGN(0.5_JPRB,ZT)
  ZT=ZT-((PPRND+ZX)-PPRND)
  PF(JI)=PC*ZT
ENDDO
!     MODE=SET_ROUND_MODE(MODE)
!     ------------------------------------------------------------------
END SUBROUTINE JFH_VMOD

! ======================================================================

#ifdef RS6K
@process OPT(3),NOSTRICT
#endif
SUBROUTINE JFH_VIF2(PA,KN)
USE PARKIND1  ,ONLY : JPIM     ,JPRB
!     ------------------------------------------------------------------
IMPLICIT NONE
! * DUMMY:
INTEGER(KIND=JPIM),INTENT(IN) :: KN
REAL(KIND=JPRB),INTENT(INOUT) :: PA(KN)
INTEGER(KIND=JPIM) :: J
!     ------------------------------------------------------------------
DO J=1,KN
  PA(J)=MIN(1.0_JPRB,MAX(PA(J),-1.0_JPRB))
ENDDO
!     ------------------------------------------------------------------
END SUBROUTINE JFH_VIF2

! ======================================================================

