SUBROUTINE SPAWR

!**** *SPAWR* - Write SPAx tables to the SPAxPCO tables
!     Purpose :  It saves the original content of SPAx temporarily
!     -------    in core: there is no I/O scheme developed.
!                Used for LPC_OLD=T only.
!                Note that this ARPEGE version of ESPAWR stores
!                 data in the arrays SPA(1,2,3)PCO and not in SPA(1,2,3)BC.
!                 (name "PCO" for PC_OLD).

!** Interface :
!   ----------
!              *CALL* *SPAWR

!     Explicit arguments :   None
!     -------------------

!     Implicit arguments :  None
!     -------------------

!     Method.
!     ------

!     Externals.
!     ---------
!            None

!     Reference.
!     ---------
!     Documentation of ARPEGE/ALADIN

!     Author.
!     ------
!        K. Yessad (after ESPAWR)

!     Modifications.
!     -------------
!        Original : 13-Dec-2004
!----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMDIM   , ONLY : NFLSUR   ,NSPEC2   ,NS3D     ,NS2D
USE YOMSP    , ONLY : SPA3     ,SPA2     
USE YOMSPPCO , ONLY : SPA3PCO  ,SPA2PCO  

IMPLICIT NONE

!----------------------------------------------------------------------

REAL(KIND=JPRB) :: ZHOOK_HANDLE

!----------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SPAWR',0,ZHOOK_HANDLE)

!----------------------------------------------------------------------

!*    1. Allocate SPA3PCO, SPA2PCO:
!     -----------------------------

ALLOCATE(SPA3PCO(NFLSUR,NSPEC2,NS3D))
ALLOCATE(SPA2PCO(NSPEC2,NS2D))

!----------------------------------------------------------------------

!*    2. Save the content of SPA3, SPA2:
!    -----------------------------------

SPA3PCO(:,:,:)=SPA3(:,:,:)
SPA2PCO(:,:)=SPA2(:,:)

!----------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('SPAWR',1,ZHOOK_HANDLE)
END SUBROUTINE SPAWR
