INTERFACE
SUBROUTINE  ARO_SHALLOW_MF( KLON,KLEV, KRR, KRRL, KRRI, KSV,          &
                HMF_UPDRAFT, HMF_CLOUD, OMIXUV,                       &
                KTCOUNT, PTSTEP,                                      &
                PZZ, PZZF,                                            &
		PRHODJ,PRHODREF,                                      &
                PPABSM, PEXNM,                                        &
                PSFTH,PSFRV,                                          &
                PTHM,PRM,                                             &
		PUM,PVM,PTKEM,PSVM,                                   &
                PMF_UP,PTHETAL_UP,PTHETAV_UP,PRT_UP,                  &
                PRC_UP,PRI_UP,PU_UP,PV_UP,                            &
                PRTHS,PRRS,                                           &
		PRUS,PRVS,PRSVS,                                      &
                PSIGMF,PRC_MF,PCF_MF,PFLXZTHVMF                       &
                 )
USE PARKIND1  ,ONLY : JPIM     ,JPRB
INTEGER(KIND=JPIM), INTENT(IN) :: KLON
INTEGER(KIND=JPIM), INTENT(IN) :: KLEV
INTEGER(KIND=JPIM), INTENT(IN) :: KRR
INTEGER(KIND=JPIM), INTENT(IN) :: KRRL
INTEGER(KIND=JPIM), INTENT(IN) :: KRRI
INTEGER(KIND=JPIM), INTENT(IN) :: KSV

CHARACTER (LEN=4), INTENT(IN)   :: HMF_UPDRAFT  ! Type of Mass Flux Scheme
CHARACTER (LEN=4), INTENT(IN)   :: HMF_CLOUD    ! Type of statistical cloud scheme
LOGICAL,                        INTENT(IN)   :: OMIXUV    ! True if mixing of momentum

INTEGER(KIND=JPIM), INTENT(IN) :: KTCOUNT
REAL(KIND=JPRB), INTENT(IN) :: PTSTEP

REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2), INTENT(IN) :: PZZ
REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2), INTENT(IN) :: PZZF

REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2), INTENT(IN) :: PRHODJ
REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2), INTENT(IN) :: PRHODREF

REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2), INTENT(IN) :: PPABSM
REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2), INTENT(IN) :: PEXNM   ! Exner function

REAL(KIND=JPRB), DIMENSION(KLON,1), INTENT(IN) :: PSFTH,PSFRV
REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2), INTENT(IN):: PMF_UP,PTHETAL_UP 
REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2), INTENT(IN)::  PRT_UP, PRC_UP, PRI_UP 
REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2), INTENT(IN):: PU_UP, PV_UP,PTHETAV_UP 
REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2), INTENT(INOUT) :: PTHM
REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2,KRR), INTENT(INOUT) :: PRM
REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2), INTENT(IN) :: PUM,PVM
REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2), INTENT(IN) :: PTKEM
REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2,KSV), INTENT(INOUT) :: PSVM

REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2), INTENT(INOUT) :: PRTHS
REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2,KRR), INTENT(INOUT) :: PRRS
REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2), INTENT(INOUT) :: PRUS,PRVS
REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2,KSV), INTENT(INOUT) :: PRSVS
REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2), INTENT(OUT)     ::  PSIGMF, PRC_MF,PCF_MF
REAL(KIND=JPRB), DIMENSION(KLON,1,KLEV+2), INTENT(OUT)     ::  PFLXZTHVMF

END SUBROUTINE ARO_SHALLOW_MF
END INTERFACE
