SUBROUTINE DEALCLIA

!     PURPOSE.
!     --------

!       This routine deallocates arrays in PTRSPOR
!       (used in the computation of spectral orography)

!**   INTERFACE.
!     ----------

!     CALL DEALCLIA

!     METHOD.
!     -------

!     EXTERNALS.
!     ----------

!     AUTHORS.
!     --------

!        D. GIARD  16 NOV 01 from SUALCLIA
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE PTRSPOR  , ONLY : XRNM     ,XSNM     ,XREV     ,XPDS     ,&
 & XEXT     ,XPDL  

IMPLICIT NONE

REAL(KIND=JPRB) :: ZHOOK_HANDLE

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('DEALCLIA',0,ZHOOK_HANDLE)

DEALLOCATE ( XRNM )
DEALLOCATE ( XSNM )
DEALLOCATE ( XPDL )
DEALLOCATE ( XREV )
DEALLOCATE ( XPDS )
DEALLOCATE ( XEXT )

IF (LHOOK) CALL DR_HOOK('DEALCLIA',1,ZHOOK_HANDLE)
END SUBROUTINE DEALCLIA
