SUBROUTINE CA0DGU
!****------------------------------------------------------------------------
!****  DK CA0DGU : INITIALISATION DES PARAMETRES STATISTIQUES D'EDITION
!****     ------
!****   Auteur :     VC 04/94   FT 06/95
!****------------------------------------------------------------------------

!  BUT : INITIALISATION DES VALEURS MOYENNES, MINIMALES, MAXIMALES
!  ---   DU CHAMP DEMANDE.

!****------------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMDIM   , ONLY : NFLEVG
USE YOMCT0   , ONLY : NTASKS
USE QAPDGU   , ONLY : JPNUMAX  ,NBPOINT  ,RMOY1    ,RMOY2    ,&
 & RMIN     ,RMAX     ,RPLACE   ,NBNIV  

IMPLICIT NONE

INTEGER(KIND=JPIM) :: JIP
REAL(KIND=JPRB) :: ZHOOK_HANDLE

!**--------------------------------------------------------------------------
!**  1.  Allocation et initialisations diverses.
!**      --------------------------------------

IF (LHOOK) CALL DR_HOOK('CA0DGU',0,ZHOOK_HANDLE)
ALLOCATE(NBPOINT(JPNUMAX,NTASKS))
ALLOCATE(RMOY1  (NFLEVG,JPNUMAX,NTASKS))
ALLOCATE(RMOY2  (NFLEVG,JPNUMAX,NTASKS))
ALLOCATE(RMIN   (NFLEVG,JPNUMAX,NTASKS))
ALLOCATE(RMAX   (NFLEVG,JPNUMAX,NTASKS))
ALLOCATE(RPLACE (NFLEVG,4,JPNUMAX,NTASKS))

NBPOINT = 0
RMOY1   = 0.0_JPRB
RMOY2   = 0.0_JPRB
RMIN    = +1.E+12_JPRB
RMAX    = -1.E+12_JPRB

!**--------------------------------------------------------------------------
!**  2.  Mise a jour des parametres statistiques.
!**      ---------------------------------------

DO JIP = 6 , 19
  NBNIV(JIP)=NFLEVG
ENDDO

!**---------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('CA0DGU',1,ZHOOK_HANDLE)
END SUBROUTINE CA0DGU
