SUBROUTINE CADAVR
!-----------------------------------------------------------------------
! DK CADAVR : DETERMINATION, ADAPTATION ET VERIFICATION DES RESIDUS
!    ------
!  Auteurs : AAD team
!-----------------------------------------------------------------------
!   BUT   : ROUTINE DE CONTROLE DES RESIDUS OBSERVES DE NIVEAU 4
!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMLUN   , ONLY : NULOUT
USE QALBAR   , ONLY : LRESCPL

IMPLICIT NONE

CHARACTER :: CLCONF*9
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "cancer.intfb.h"
#include "stepo.intfb.h"

!-----------------------------------------------------------------------
!  - 1 -  Impressions suivant le type des residus calcules
!         ------------------------------------------------

IF (LHOOK) CALL DR_HOOK('CADAVR',0,ZHOOK_HANDLE)
WRITE (NULOUT,101)
101 FORMAT(//,5X,' ************************************** ',/,&
 & 5X,' *      Initialisation de NCMxxx      * ',/,&
 & 5X,' ************************************** ',/)  

!-----------------------------------------------------------------------
!  - 2 -  Appel a STEPO dans la configuration 'OBS'
!         -----------------------------------------

IF ( LRESCPL ) THEN
  WRITE(NULOUT,'('' Interpolation guess (s/p STEPO)'')')
ELSE
  WRITE(NULOUT,'('' Interpolation analyse (s/p STEPO)'')')
ENDIF

CLCONF(1:9)='0M100C000'

CALL STEPO(CLCONF)

!-----------------------------------------------------------------------
!  - 3 -  Verification des residus et ecriture des flags
!         ----------------------------------------------

WRITE(NULOUT,'(/,'' Verification des residus (s/p CANCER)'')')
CALL CANCER

!-----------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('CADAVR',1,ZHOOK_HANDLE)
END SUBROUTINE CADAVR
