SUBROUTINE CAIFC1
!--------------------------------------------------------------------
!   CAIFC1 : Initialisation de NCMIFC1(1) a partir de NCMOMF
!   ------   
!  auteur        : Ph. Caille    12/96
!  modifications : F. Taillefer  09/00  passage CMAFOC --> ODB
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!--------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMDIMO  , ONLY : NOBTOT
USE YOMOBA   , ONLY : MOBDD1
USE YOMDB
USE YOMCMDDR , ONLY : NCD1NUP

IMPLICIT NONE

INTEGER(KIND=JPIM) :: IBODY, INFO(1), INLV, IRET, JO, JW

REAL(KIND=JPRB) :: ZINFO(1)
REAL(KIND=JPRB) :: ZHOOK_HANDLE

INTERFACE
#include "getdb.h"
#include "putdb.h"
END INTERFACE

#include "openmp_obs.h"

!--------------------------------------------------------------------

MOBDD1(NCD1NUP) = 0

IF (LHOOK) CALL DR_HOOK('CAIFC1',0,ZHOOK_HANDLE)
CALL GETDB('CAIFC1', 0, IRET, INFO, 0, ZINFO, 0, -1, -1, -1, -1, -1, -1)

DO JO = 1,NOBTOT
  INLV = MLNKH2B(JO+1)-MLNKH2B(JO)
  DO JW=1,INLV
    IBODY = MLNKH2B(JO)+JW-1
    ROBODY(IBODY,MDBIFC1(1)) = ROBODY(IBODY,MDBOMF)
  ENDDO
ENDDO

CALL PUTDB('CAIFC1', 0, IRET, INFO, 0, ZINFO, 0)

!--------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('CAIFC1',1,ZHOOK_HANDLE)
END SUBROUTINE CAIFC1
