SUBROUTINE CANAPE
!****------------------------------------------------------------------------
!****  CANAPE : DEFINITION DU MODELE STATISTIQUE  (called by CALIFE)
!****  ------
!****------------------------------------------------------------------------
!  BUT : INITIALISATION DES DIFFERENTS COEFFICIENTS POUR LA DEFINITION DU
!  ---   MODELE STATISTIQUE (module QAREF):
!            - PORTEES HORIZONTALES ET VERTICALES,
!            - ECART-TYPES,
!            - NIVEAUX PRESSIONS DE REFERENCE.
!****------------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMCST   , ONLY : ROMEGA   ,RG       ,RD
USE YOMLUN   , ONLY : NULOUT   ,NULNAM
USE QAPASS   , ONLY : JPNVS
USE QAREF    , ONLY : REF_STAT ,&
 & REF_S_SST,REF_S_SN ,REF_S_T2 ,REF_S_H2 ,REF_S_V1  ,&
 & REF_A_SST,REF_A_SN ,REF_A_T2 ,REF_A_H2 ,REF_A_VOR1,&
 & REF_A_DIV1,REF_NU_BL,REF_KP_BL,&
 & REF_MU1  ,REF_MU2  ,REF_MU3  ,REF_NU1  ,&
 & REF_NU2  ,REF_NU3  ,REF_PHUD ,REF_PHHU ,&
 & REF_PVH  ,REF_COEFN,REF_COEFT,REF_COEFS,REF_AP_SN  

IMPLICIT NONE

#include "nam_canape.h"

INTEGER(KIND=JPIM) :: JI, JJ
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "abor1.intfb.h"
#include "posnam.intfb.h"

!**--------------------------------------------------------------------------
!**  - 1 - Initialisation des valeurs de reference.
!**        ---------------------------------------

IF (LHOOK) CALL DR_HOOK('CANAPE',0,ZHOOK_HANDLE)
REF_STAT( 1,1) = 100000._JPRB
REF_STAT( 2,1) =  95000._JPRB
REF_STAT( 3,1) =  90000._JPRB
REF_STAT( 4,1) =  85000._JPRB
REF_STAT( 5,1) =  80000._JPRB
REF_STAT( 6,1) =  70000._JPRB
REF_STAT( 7,1) =  60000._JPRB
REF_STAT( 8,1) =  50000._JPRB
REF_STAT( 9,1) =  40000._JPRB
REF_STAT(10,1) =  30000._JPRB
REF_STAT(11,1) =  25000._JPRB
REF_STAT(12,1) =  20000._JPRB
REF_STAT(13,1) =  15000._JPRB
REF_STAT(14,1) =  10000._JPRB
REF_STAT(15,1) =   7000._JPRB
REF_STAT(16,1) =   5000._JPRB
REF_STAT(17,1) =   3000._JPRB
REF_STAT(18,1) =   2000._JPRB
REF_STAT(19,1) =   1000._JPRB

REF_STAT( 1,2) =  8.00_JPRB
REF_STAT( 2,2) =  8.20_JPRB
REF_STAT( 3,2) =  8.60_JPRB
REF_STAT( 4,2) =  9.00_JPRB
REF_STAT( 5,2) =  9.40_JPRB
REF_STAT( 6,2) =  9.90_JPRB
REF_STAT( 7,2) = 11.50_JPRB
REF_STAT( 8,2) = 12.80_JPRB
REF_STAT( 9,2) = 14.40_JPRB
REF_STAT(10,2) = 16.40_JPRB
REF_STAT(11,2) = 17.70_JPRB
REF_STAT(12,2) = 19.20_JPRB
REF_STAT(13,2) = 22.60_JPRB
REF_STAT(14,2) = 25.00_JPRB
REF_STAT(15,2) = 27.40_JPRB
REF_STAT(16,2) = 30.00_JPRB
REF_STAT(17,2) = 33.00_JPRB
REF_STAT(18,2) = 35.50_JPRB
REF_STAT(19,2) = 40.00_JPRB

REF_STAT( 1,3) = 1.90_JPRB
REF_STAT( 2,3) = 1.80_JPRB
REF_STAT( 3,3) = 1.70_JPRB
REF_STAT( 4,3) = 1.60_JPRB
REF_STAT( 5,3) = 1.50_JPRB
REF_STAT( 6,3) = 1.40_JPRB
REF_STAT( 7,3) = 1.40_JPRB
REF_STAT( 8,3) = 1.40_JPRB
REF_STAT( 9,3) = 1.40_JPRB
REF_STAT(10,3) = 1.50_JPRB
REF_STAT(11,3) = 1.60_JPRB
REF_STAT(12,3) = 1.70_JPRB
REF_STAT(13,3) = 1.80_JPRB
REF_STAT(14,3) = 1.90_JPRB
REF_STAT(15,3) = 2.00_JPRB
REF_STAT(16,3) = 2.10_JPRB
REF_STAT(17,3) = 2.20_JPRB
REF_STAT(18,3) = 2.30_JPRB
REF_STAT(19,3) = 2.40_JPRB

REF_STAT( 1,4) = 2.30_JPRB
REF_STAT( 2,4) = 2.30_JPRB
REF_STAT( 3,4) = 2.30_JPRB
REF_STAT( 4,4) = 2.30_JPRB
REF_STAT( 5,4) = 2.40_JPRB
REF_STAT( 6,4) = 2.50_JPRB
REF_STAT( 7,4) = 2.75_JPRB
REF_STAT( 8,4) = 3.00_JPRB
REF_STAT( 9,4) = 3.30_JPRB
REF_STAT(10,4) = 3.60_JPRB
REF_STAT(11,4) = 3.50_JPRB
REF_STAT(12,4) = 3.50_JPRB
REF_STAT(13,4) = 3.40_JPRB
REF_STAT(14,4) = 3.30_JPRB
REF_STAT(15,4) = 3.20_JPRB
REF_STAT(16,4) = 3.70_JPRB
REF_STAT(17,4) = 4.40_JPRB
REF_STAT(18,4) = 4.70_JPRB
REF_STAT(19,4) = 5.40_JPRB

REF_STAT( 1,5) = 0.17_JPRB
REF_STAT( 2,5) = 0.18_JPRB
REF_STAT( 3,5) = 0.19_JPRB
REF_STAT( 4,5) = 0.20_JPRB
REF_STAT( 5,5) = 0.20_JPRB
REF_STAT( 6,5) = 0.21_JPRB
REF_STAT( 7,5) = 0.21_JPRB
REF_STAT( 8,5) = 0.22_JPRB
REF_STAT( 9,5) = 0.22_JPRB
REF_STAT(10,5) = 0.22_JPRB
REF_STAT(11,5) = 0.22_JPRB
REF_STAT(12,5) = 0.22_JPRB
REF_STAT(13,5) = 0.22_JPRB
REF_STAT(14,5) = 0.22_JPRB
REF_STAT(15,5) = 0.22_JPRB
REF_STAT(16,5) = 0.22_JPRB
REF_STAT(17,5) = 0.22_JPRB
REF_STAT(18,5) = 0.22_JPRB
REF_STAT(19,5) = 0.22_JPRB

REF_S_SST = 0.8_JPRB
REF_S_SN  = 5.0_JPRB
REF_S_T2  = 3.0_JPRB
REF_S_H2  = 0.3_JPRB
REF_S_V1  = 6.0_JPRB

REF_A_SST = 300000._JPRB
REF_A_SN  =  50000._JPRB
REF_A_T2  =  50000._JPRB
REF_A_H2  =  50000._JPRB
REF_A_VOR1=  50000._JPRB
REF_A_DIV1=  50000._JPRB

REF_AP_SN = 0.05_JPRB

REF_NU_BL = 1._JPRB
REF_KP_BL = 100._JPRB

REF_MU1   = 1.00_JPRB
REF_MU2   = 0.15_JPRB
REF_MU3   = 90000._JPRB
REF_NU1   = 0.3_JPRB
REF_NU2   = 0.6_JPRB
REF_NU3   = 90000._JPRB
REF_PHUD  = 0.7_JPRB
REF_PHHU  = 0.8_JPRB
REF_PVH   = 6.0_JPRB
REF_COEFN = 1.2_JPRB
REF_COEFT = 0.6_JPRB
REF_COEFS = 1.4_JPRB

CALL POSNAM(NULNAM, 'NAM_CANAPE')
READ (NULNAM, NAM_CANAPE)

IF ((REF_MU3<REF_STAT(19,1)).OR.(REF_MU3>=REF_STAT(1,1))) &
 & CALL ABOR1('CANAPE: UNAUTHORISED VALUE OF REF_MU3')  
IF ((REF_NU3<REF_STAT(19,1)).OR.(REF_NU3>=REF_STAT(1,1))) &
 & CALL ABOR1('CANAPE: UNAUTHORISED VALUE OF REF_NU3')  

!**--------------------------------------------------------------------------
!**  - 2 - Normalisation de ces valeurs de reference.
!**        -----------------------------------------

DO JI = 1 , JPNVS
  REF_STAT(JI,2) = RG * REF_STAT(JI,2)
  REF_STAT(JI,6) = 0.5_JPRB * (RD*REF_STAT(JI,3)/REF_STAT(JI,2))**2
  REF_STAT(JI,6) = REAL(NINT( REF_STAT(JI,6) * 100._JPRB ),JPRB) * 0.01_JPRB
  REF_STAT(JI,7) = REF_STAT(JI,2) / (REF_STAT(JI,4) * ROMEGA)
  REF_STAT(JI,7) = REAL(NINT(REF_STAT(JI,7)*0.0001_JPRB),JPRB) * 10000._JPRB
ENDDO

!**--------------------------------------------------------------------------
!**  - 3 - Impressions.
!**        -----------

WRITE(NULOUT,'('' CANAPE : definition du modele statistique '')')
WRITE(NULOUT,'(/,A73,/,(6F10.2),3X,F10.2)')&
 & ' pression   sigmaphi   sigmattt  sigmavuv  sigmahhu     kp      portee   ',&
 & ((REF_STAT(JJ,JI),JI=1,7),JJ=1,JPNVS)  
WRITE(NULOUT,'(/,A63,/,A15,F6.2,(4F10.2),/,A12,(5F10.0),/)')&
 & '                 SST      neige       T2        H2       vent  ',&
 & '  ecart-type   ',REF_S_SST, REF_S_SN, REF_S_T2, REF_S_H2, REF_S_V1,&
 & '  portee (m)',REF_A_SST, REF_A_SN, REF_A_T2, REF_A_H2, REF_A_VOR1  
WRITE(NULOUT,'(A12,F7.2)') '  ref_ap_sn = ', REF_AP_SN
WRITE(NULOUT,'(A12,F7.2)') '  ref_nu_bl = ', REF_NU_BL
WRITE(NULOUT,'(A12,F7.2)') '  ref_kp_bl = ', REF_KP_BL
WRITE(NULOUT,'(A12,F7.2)') '  ref_mu1   = ', REF_MU1
WRITE(NULOUT,'(A12,F7.2)') '  ref_mu2   = ', REF_MU2
WRITE(NULOUT,'(A12,F7.0)') '  ref_mu3   = ', REF_MU3
WRITE(NULOUT,'(A12,F7.2)') '  ref_nu1   = ', REF_NU1
WRITE(NULOUT,'(A12,F7.2)') '  ref_nu2   = ', REF_NU2
WRITE(NULOUT,'(A12,F7.0)') '  ref_nu3   = ', REF_NU3
WRITE(NULOUT,'(A12,F7.2)') '  ref_phud  = ', REF_PHUD
WRITE(NULOUT,'(A12,F7.2)') '  ref_phhu  = ', REF_PHHU
WRITE(NULOUT,'(A12,F7.2)') '  ref_pvh   = ', REF_PVH
WRITE(NULOUT,'(A12,F7.2)') '  ref_coefn = ', REF_COEFN
WRITE(NULOUT,'(A12,F7.2)') '  ref_coeft = ', REF_COEFT
WRITE(NULOUT,'(A12,F7.2)') '  ref_coefs = ', REF_COEFS

!**--------------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('CANAPE',1,ZHOOK_HANDLE)
END SUBROUTINE CANAPE
