SUBROUTINE CAPOTX ( KTSK, KNBPT,&
 & PUT, PVT, PTT, PQT, PLT, PIT, PRT,  PST,  PSPT,&
 & PSP_SB,PSP_SG,PSP_RR,PSP_CI,PSP_X2,PSD_VF,PSD_VV,PSD_VX,&
 & PGM, PGELAT, PGELAM, PGNORDL, PGNORDM, PRCORI,&
 & PGEMU, PCAGUE, PESIG, PSGPHI, PSGHUM)  

!****-------------------------------------------------------------------
!****   CAPOTX : ROUTINE MENU DE L'ANALYSE
!****   ------
!****  Auteurs :     P.MOLL 05/92, VC 03/93,08/94
!      Modif   :     LG  03/00 LAESNM not in the if for call caclsi
!        R. El Khatib : 01-08-07 Pruning options
!        Y. Bouteloup : add QL and QI  (PLT and PIT !) in the call to caclsi
!        Y. Bouteloup : add PRT and PST
!****-------------------------------------------------------------------
!***  ARGUMENTS : IN      KTSK  : numero de la tache (1 si MP)
!***  ---------   IN      KNBPT : nb de points a traiter
!***              IN/OUT  PUT,PVT,PTT,PQT,PLT,PIT,PSPT : zoom champs du modele
!***              IN/OUT  PSP_SB,PSP_SG,PSP_RR,PSP_CI,PSP_X2,PSD_VF,PSD_VV,PSD_VX : 
!***                      zoom champs buffer physique du modele
!***              IN      PGM,PGELAT,PGELAM,PGEMU,} geometrie du modele
!***                      PGNORDL,PGNORDM,PRCORI  } sur domaine de travail
!***              IN      PCAGUE,PESIG : zoom entrees analyse
!***              OUT     PSGPHI,PSGHUM: extraits diagnostics
!***
!***  Sous-programme amont : SCAN2MSM - SCAN2M
!***  --------------------
!***  Sous-programmes aval : CACLSI-CACDGU-CANEVA
!***  --------------------   CAPSAX-CAVTAX-CAHUAX-CAT2AS-CAHUAS-CAV1AS
!***                         CASNAS-CASTAS-CACSTS
!****-------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMDIM   , ONLY : NFLEVG   ,NPROMA
USE YOMGEM   , ONLY : VBH      ,VAH
USE QACTEX   , ONLY : LAEPDS   ,LAEUVT   ,LAEHUM   ,LAET2M   ,&
 & LAEH2M   ,LAEV1M   ,LAESNM   ,LAESST   ,LAEICS   ,&
 & LAECDS   ,RCLIMCA  ,RCLISST  
USE QADIAG   , ONLY : RCATSL   ,RCARES   ,RCASIG
USE QADOCK   , ONLY : NMXGBA   ,NMXGQA   ,QDSTRA   ,QDSTVA
USE SURFACE_FIELDS_MIX, ONLY : YSP_SGD, YSP_SG, YSP_RRD,YSD_VVD, &
 & YSD_VFD,  YSP_CID, YSP_CI, YSP_X2D, YSP_SBD, &
 & YSD_VXD
!lg
IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KNBPT 
INTEGER(KIND=JPIM),INTENT(IN)    :: KTSK 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PUT(NPROMA,NFLEVG) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PVT(NPROMA,NFLEVG) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTT(NPROMA,NFLEVG) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQT(NPROMA,NFLEVG) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PLT(NPROMA,NFLEVG)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PIT(NPROMA,NFLEVG)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PRT(NPROMA,NFLEVG)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PST(NPROMA,NFLEVG)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSPT(NPROMA) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSP_SB(NPROMA,YSP_SBD%NLEVS,YSP_SBD%NDIM)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSP_SG(NPROMA,YSP_SGD%NDIM)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSP_RR(NPROMA,YSP_RRD%NDIM)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSP_CI(NPROMA,YSP_CID%NDIM)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSP_X2(NPROMA,YSP_X2D%NDIM)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSD_VF(NPROMA,YSD_VFD%NDIM)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSD_VV(NPROMA,YSD_VVD%NDIM)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSD_VX(NPROMA,YSD_VXD%NDIM)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGM(KNBPT) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGELAT(KNBPT) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGELAM(KNBPT) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGNORDL(KNBPT) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGNORDM(KNBPT) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PRCORI(KNBPT) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGEMU(KNBPT) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PCAGUE(2,KNBPT) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PESIG(2*NFLEVG+5,KNBPT) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSGPHI(NFLEVG,KNBPT) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSGHUM(NFLEVG,KNBPT) 
INTEGER(KIND=JPIM) :: INPR(KNBPT), JROF
REAL(KIND=JPRB) :: ZOLDT(KNBPT,NFLEVG), ZPSPS(NPROMA), ZPSLN(NPROMA)
REAL(KIND=JPRB) :: ZPRESH(KNBPT,0:NFLEVG), ZPRESF(KNBPT,NFLEVG)
REAL(KIND=JPRB) :: ZPRESFLN(KNBPT,NFLEVG), Zxxx
REAL(KIND=JPRB) :: ZT2INC(KNBPT), ZH2INC(KNBPT)

INTEGER(KIND=JPIM) :: IQUOI, ITYP, Ixx(1)
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "cacdgu.intfb.h"
#include "caclsi.intfb.h"
#include "cacsts.intfb.h"
#include "cah2as.intfb.h"
#include "cahuax.intfb.h"
#include "caneva.intfb.h"
#include "capsax.intfb.h"
#include "casnas.intfb.h"
#include "castas.intfb.h"
#include "cat2as.intfb.h"
#include "cav1as.intfb.h"
#include "cavtax.intfb.h"
#include "gppre.intfb.h"

!**------------------------------------------------------------------------
!**  - 1 - PREPARATIFS.
!**        -----------

IF (LHOOK) CALL DR_HOOK('CAPOTX',0,ZHOOK_HANDLE)
ZPSPS(1:KNBPT) = EXP(PSPT(1:KNBPT))
ZPSLN(1:KNBPT) = PSPT(1:KNBPT)

! calculs de couche limite
IF ( LAET2M .OR. LAEH2M .OR. LAEV1M .OR. LAEICS ) THEN
! lg - LAESNM excluded
!IF ( LAET2M .OR. LAEH2M .OR. LAEV1M .OR. LAESNM .OR. LAEICS ) THEN
  CALL CACLSI(KNBPT,NPROMA,PUT,PVT,PTT,PQT,PLT,PIT,PRT,PST,ZPSPS,PGM,&
   & PSP_SG,PSP_RR,PSD_VF,PSD_VV,PSP_CI)
ENDIF

IF ( LAEHUM ) THEN
  ZOLDT(1:KNBPT,:) = PTT(1:KNBPT,:)
ENDIF
IQUOI = 0
ITYP  = 0

! selection geographique
CALL CANEVA(IQUOI,ITYP,KTSK,QDSTRA(1),&
 & QDSTVA(1),Zxxx,NMXGBA(1),NMXGQA(1),&
 & Zxxx,PCAGUE,PGELAT,PGELAM,&
 & ZT2INC,KNBPT,1,&
 & Ixx,1,Ixx,1,Ixx,ZT2INC,ZT2INC,ZT2INC,INPR)  

IF ( LAEICS ) THEN
  ZT2INC(:) = 0.0_JPRB
  ZH2INC(:) = 0.0_JPRB
ENDIF

!**------------------------------------------------------------------------
!**  - 2 - ANALYSE de PRESSION de SURFACE.
!**        ------------------------------

CALL CACDGU(KTSK, 'PS GUESS        ', 1, ZPSPS,&
 & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
IF ( LAEPDS ) THEN
  CALL CAPSAX(NPROMA,KNBPT,KTSK,PSP_CI,&
   & PTT(1,NFLEVG),PQT(1,NFLEVG),ZPSPS,ZPSLN,&
   & PESIG,PCAGUE,PGELAT,PGELAM)  
  PSPT(1:KNBPT) = ZPSLN(1:KNBPT)

  CALL CACDGU(KTSK, 'PS ANALYSE      ', 2, ZPSPS,&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'PS TAILLE SL    ', 3, RCATSL(1,1,KTSK),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'PS RES ANA      ', 4, RCARES(1,1,KTSK),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'PS SIGA/SIGP    ', 5, RCASIG(1,1,KTSK),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
ENDIF

IF ( LAEUVT .OR. LAEHUM ) THEN
  DO JROF = 1 , KNBPT
    ZPRESH(JROF,NFLEVG) = ZPSPS(JROF)
  ENDDO
  CALL GPPRE(KNBPT,1,KNBPT, NFLEVG, VAH, VBH, ZPRESH, ZPRESF)
  ZPRESFLN(1:KNBPT,:) = LOG (ZPRESF(1:KNBPT,:))
ENDIF

!**------------------------------------------------------------------------
!**  - 3 - ANALYSE de VENT/TEMPERATURE.
!**        ---------------------------

CALL CACDGU(KTSK, 'TT GUESS        ', 6, PTT,&
 & NPROMA, KNBPT, 1, NFLEVG, PGELAM, PGELAT)  
CALL CACDGU(KTSK, 'UU GUESS        ', 7, PUT,&
 & NPROMA, KNBPT, 1, NFLEVG, PGELAM, PGELAT)  
CALL CACDGU(KTSK, 'VV GUESS        ', 8, PVT,&
 & NPROMA, KNBPT, 1, NFLEVG, PGELAM, PGELAT)  
IF ( LAEUVT ) THEN
  CALL CAVTAX(NPROMA,KNBPT,KTSK,&
   & PUT,PVT,PTT,ZPRESFLN,&
   & PGNORDL,PGNORDM,PGM,PGELAT,PGELAM,PRCORI,&
   & PCAGUE,PESIG,PSGPHI)  
  CALL CACDGU(KTSK, 'TT ANALYSE      ', 9, PTT,&
   & NPROMA, KNBPT, 1, NFLEVG, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'UU ANALYSE      ',10, PUT,&
   & NPROMA, KNBPT, 1, NFLEVG, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'VV ANALYSE      ',11, PVT,&
   & NPROMA, KNBPT, 1, NFLEVG, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'TT TAILLE SL    ',12, RCATSL(1,1,KTSK),&
   & NPROMA, KNBPT, 1, NFLEVG, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'TT RES ANA      ',13, RCARES(1,1,KTSK),&
   & NPROMA, KNBPT, 1, NFLEVG, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'TT SIGA/SIGP    ',14, RCASIG(1,1,KTSK),&
   & NPROMA, KNBPT, 1, NFLEVG, PGELAM, PGELAT)  
ENDIF

!**------------------------------------------------------------------------
!**  - 4 - ANALYSE d'HUMIDITE.
!**        -------------------

CALL CACDGU(KTSK, 'QQ GUESS        ',15, PQT,&
 & NPROMA, KNBPT, 1, NFLEVG, PGELAM, PGELAT)  
IF ( LAEHUM ) THEN
  CALL CAHUAX(NPROMA,KNBPT,KTSK,&
   & PTT,PQT,ZPRESF,ZPRESFLN,ZOLDT,&
   & PGELAT,PGELAM,PCAGUE,PESIG,PSGHUM)  
  CALL CACDGU(KTSK, 'QQ ANALYSE      ',16, PQT,&
   & NPROMA, KNBPT, 1, NFLEVG, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'HU TAILLE SL    ',17, RCATSL(1,1,KTSK),&
   & NPROMA, KNBPT, 1, NFLEVG, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'HU RES ANA      ',18, RCARES(1,1,KTSK),&
   & NPROMA, KNBPT, 1, NFLEVG, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'HU SIGA/SIGP    ',19, RCASIG(1,1,KTSK),&
   & NPROMA, KNBPT, 1, NFLEVG, PGELAM, PGELAT)  
ENDIF

!**------------------------------------------------------------------------
!**  - 5 - ANALYSE de T2M.
!**        --------------

CALL CACDGU(KTSK, 'T2 GUESS        ',20, PSP_CI(1,YSP_CI%YCI(4)%MP0),&
 & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
IF ( LAET2M ) THEN
  CALL CAT2AS(NPROMA,KNBPT,KTSK,ZPSLN,ZT2INC,PSP_CI,PESIG,PCAGUE,PGELAT,PGELAM)
  CALL CACDGU(KTSK, 'T2 ANALYSE      ',21, PSP_CI(1,YSP_CI%YCI(4)%MP0),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'T2 TAILLE SL    ',22, RCATSL(1,1,KTSK),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'T2 RES ANA      ',23, RCARES(1,1,KTSK),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'T2 SIGA/SIGP    ',24, RCASIG(1,1,KTSK),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
ENDIF

!**------------------------------------------------------------------------
!**  - 6 - ANALYSE de H2M.
!**        --------------

CALL CACDGU(KTSK, 'H2 GUESS        ',25, PSP_CI(1,YSP_CI%YCI(5)%MP0),&
 & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
IF ( LAEH2M ) THEN
  CALL CAH2AS(NPROMA,KNBPT,KTSK,ZPSLN,ZH2INC,PSP_CI,PESIG,PCAGUE,PGELAT,PGELAM)
  CALL CACDGU(KTSK, 'H2 ANALYSE      ',26, PSP_CI(1,YSP_CI%YCI(5)%MP0),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'H2 TAILLE SL    ',27, RCATSL(1,1,KTSK),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'H2 RES ANA      ',28, RCARES(1,1,KTSK),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'H2 SIGA/SIGP    ',29, RCASIG(1,1,KTSK),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
ENDIF

!**------------------------------------------------------------------------
!**  - 7 - ANALYSE de V10M.
!**        ---------------

IF ( LAEV1M ) THEN
  CALL CACDGU(KTSK, 'V1 GUESS        ',30, PSP_CI(1,YSP_CI%YCI(7)%MP0),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
  CALL CAV1AS(NPROMA,KNBPT,KTSK,ZPSLN,PSP_CI,PESIG,PCAGUE,&
   & PGELAT,PGELAM,PGNORDL,PGNORDM,PGM)  
  CALL CACDGU(KTSK, 'V1 ANALYSE      ',31, PSP_CI(1,YSP_CI%YCI(7)%MP0),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'V1 TAILLE SL    ',32, RCATSL(1,1,KTSK),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
ENDIF

!**------------------------------------------------------------------------
!**  - 8 - ANALYSE de HAUTEUR DE NEIGE.
!**        ---------------------------

IF ( LAESNM ) THEN
  CALL CACDGU(KTSK, 'SN GUESS        ',33, PSP_SG(1,YSP_SG%YF%MP0),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
  CALL CASNAS(NPROMA,KNBPT,KTSK,ZPSLN,PSP_SG,PSD_VF,PESIG,PCAGUE,PGELAT,PGELAM)
  CALL CACDGU(KTSK, 'SN ANALYSE      ',34, PSP_SG(1,YSP_SG%YF%MP0),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'SN TAILLE SL    ',35, RCATSL(1,1,KTSK),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'SN RES ANA      ',36, RCARES(1,1,KTSK),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'SN SIGA/SIGP    ',37, RCASIG(1,1,KTSK),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
ENDIF

!**------------------------------------------------------------------------
!**  - 9 - ANALYSE de SST.
!**        --------------

IF ( LAESST ) THEN
  CALL CASTAS(NPROMA,KNBPT,KTSK,ZPSLN,PSP_SB,PSP_RR,PSD_VF,PESIG,PCAGUE,PGELAT,PGELAM)
  CALL CACDGU(KTSK, 'SST TAILLE SL   ',50, RCATSL(1,1,KTSK),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'SST RES ANA     ',51, RCARES(1,1,KTSK),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
  CALL CACDGU(KTSK, 'SST SIGA/SIGP   ',52, RCASIG(1,1,KTSK),&
   & NPROMA, KNBPT, 1, 1, PGELAM, PGELAT)  
ENDIF

!**--------------------------------------------------------------------------
!**  - 10 - CHAMPS DE SURFACE.
!**         -----------------

IF ( LAEICS .OR. RCLIMCA > 0.0_JPRB .OR. RCLISST > 0.0_JPRB ) THEN
  CALL CACSTS(NPROMA,KNBPT,KTSK,ZT2INC,ZH2INC,&
 & PSP_SB,PSP_SG,PSP_RR,PSP_CI,PSP_X2,PSD_VF,PSD_VV,PSD_VX,&
 & PGELAT,PGELAM,PGEMU)
ENDIF

!**--------------------------------------------------------------------------
!**  - 11 - DIAGNOSTICS.
!**         -----------

IF ( LAECDS ) THEN
  CALL CACLSI(KNBPT,NPROMA,PUT,PVT,PTT,PQT,PLT,PIT,PRT,PST,ZPSPS,PGM,&
   & PSP_SG,PSP_RR,PSD_VF,PSD_VV,PSP_CI)
ENDIF

!**---------------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('CAPOTX',1,ZHOOK_HANDLE)
END SUBROUTINE CAPOTX
