SUBROUTINE CAPREDI(KNVYS, KNVYE, KPOS, KNLYJ, KNYJ)
!****-------------------------------------------------------------------
!**   AUTEUR : V. CASSE
!**   ------
!**   ROUTINE APPELANTE : - CANAMI -
!**   -----------------
!**   COMMONS :  - YOMANCS - VALEURS DONNEES MANQUANTES
!**   -------    - YOMLUN -  UNITES LOGIQUES FICHIERS
!**              - QAPAVU -  DIMENSIONS ET INDICES RELATIFS A *QAVARA*.
!**              - QAVARA -  TABLEAUX DE PREDICTEURS ET DE PREDICTANTS.
!****-------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE QAPAVU   , ONLY : JPNINV
USE QAVARA   , ONLY : NVXINV
USE YOMLUN   , ONLY : NULOUT
USE YOMANCS  , ONLY : NMDI

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KPOS 
INTEGER(KIND=JPIM),INTENT(IN)    :: KNVYS(JPNINV) 
INTEGER(KIND=JPIM),INTENT(IN)    :: KNVYE(KPOS) 
INTEGER(KIND=JPIM),INTENT(OUT)   :: KNLYJ 
INTEGER(KIND=JPIM),INTENT(INOUT) :: KNYJ(JPNINV) 
INTEGER(KIND=JPIM) :: IDEM, J, JDEM, JE, JS
REAL(KIND=JPRB) :: ZHOOK_HANDLE

!**---------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('CAPREDI',0,ZHOOK_HANDLE)
DO JDEM = 0,JPNINV-1
  IDEM = JDEM
  IF (KNVYS(JDEM+1)  ==  NMDI) EXIT
ENDDO

WRITE (NULOUT, 9001) (KNVYS(J), J=1,IDEM)

KNLYJ = 0
PRED_LOOP: DO JS = 1,IDEM
! les predicteurs demandes ont-ils un modele statistique associe ?
  IF (NVXINV(KNVYS(JS))  /=  0) THEN
    DO JE = 1,KPOS
!     figurent-ils dans la liste des predicteurs possibles ?
      IF (KNVYS(JS)  ==  KNVYE(JE)) THEN
        KNLYJ = KNLYJ + 1
        KNYJ(KNLYJ) = KNVYE(JE)
        CYCLE PRED_LOOP
      ENDIF
    ENDDO
  ENDIF
ENDDO PRED_LOOP

IF (KNLYJ == 0) THEN
  WRITE (NULOUT,9002) KPOS,(KNVYE(J),J=1,KPOS)
ELSE
  WRITE (NULOUT,9003) KNLYJ,(KNYJ(J),J=1,KNLYJ)
ENDIF

!**---------------------------------------------------------------------
9001 FORMAT(/,' PREDICTEURS DEMANDES : ', 10I4)
9002 FORMAT(' *** ATTENTION ***: PAS DE PREDICTEURS CORRECTS ',&
 & /,'SEULS SONT POSSIBLES LES ',I3,' SUIVANTS : ',15I4)  
9003 FORMAT(' NB DE PREDICTEURS RETENUS POUR CETTE PARTIE : ',I2,&
 & /,' PORTANT LES NUMEROS : ',15I4)  
!**---------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('CAPREDI',1,ZHOOK_HANDLE)
END SUBROUTINE CAPREDI
