SUBROUTINE CARCFO
!-----------------------------------------------------------------------
!   CARCFO : Mise a jour finale des observations a l'issue de CANARI
!   ------
!   auteur : Ph.Caille  01/92 
!-----------------------------------------------------------------------
!  Sequence d'appel     : CALL CARCFO
!  ----------------
!  Sous-programme amont : CANARI
!  --------------------
!  Modifications        : Ph. Caille  08/96  passage du cmafoc au cmafoc
!  -------------          D. Paradis  11/97  retrait du halo si LMESSP=T
!                         F.Taillefer 12/00  passage CMAFOC --> ODB
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMDB
USE YOMVNMB  , ONLY : NVNUMB
USE YOMLUN   , ONLY : NULOUT
USE YOMANCS  , ONLY : RMDI

IMPLICIT NONE

INTEGER(KIND=JPIM) :: INWAG, INFO(1), IRET, IVNM, JW

REAL(KIND=JPRB) :: ZINFO(1)
REAL(KIND=JPRB) :: ZHOOK_HANDLE

INTERFACE
#include "getdb.h"
#include "putdb.h"
END INTERFACE

#include "writeoba.intfb.h"

#include "openmp_obs.h"

!-----------------------------------------------------------------------
!  - 1 -  Recuperation des observations en memoire.
!         ----------------------------------------

IF (LHOOK) CALL DR_HOOK('CARCFO',0,ZHOOK_HANDLE)
WRITE (NULOUT,101)

CALL GETDB('CARCFO',0, IRET, INFO, 0, ZINFO, 0, -1, -1, -1, -1, -1, -1)

101 FORMAT(/,6X,23('*'),/,6X,'*   Debut de CARCFO   *',/,6X,23('*'))

!-----------------------------------------------------------------------
!  - 2 -  Conversion des pressions ( Log P en P ).
!         ------------------------

INWAG=SIZE(ROBODY,1)-1

DO JW = 1 , INWAG
  IVNM = ROBODY(JW,MDBVNM)
  IF ( ROBODY(JW,MDBRBPIO) /= RMDI ) &
   & ROBODY(JW,MDBRBPIO) = EXP (ROBODY(JW,MDBRBPIO))  
  IF ( IVNM == NVNUMB(4) .AND. ROBODY(JW,MDBPRL) /= RMDI ) &
   & ROBODY(JW,MDBPRL) = NINT ( EXP(ROBODY(JW,MDBPRL)) )  
ENDDO

!-----------------------------------------------------------------------
!  - 3 -  Sauvegarde des pressions des observations.
!         -----------------------------------------

CALL PUTDB('CARCFO', 0, IRET, INFO, 0, ZINFO, 0)

WRITE (NULOUT,301) INWAG

301 FORMAT(/,2X,I15,' parametres traites')

!-----------------------------------------------------------------------
!  - 4 -  Mise a jour definitive de la base des observations.
!         --------------------------------------------------

CALL WRITEOBA
WRITE (NULOUT,402)

402 FORMAT(/,6X,21('*'),/,6X,'*  Fin de CARCFO  *',/,6X,21('*'),//)

!-----------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('CARCFO',1,ZHOOK_HANDLE)
END SUBROUTINE CARCFO
