SUBROUTINE CARCLI
!****-------------------------------------------------------------------
!****  CARCLI : Reactualisation des champs de constantes de surface 
!****  ------    pour ISBA (cycle annuel)
!****
!****  Auteur :     DG 08/95
!***--------------------------------------------------------------------
!**  CONDITIONS : - le premier jour du mois; pas de variation continue
!**  ----------      (introduction ulterieure si utile)
!**               - disponiblite du fichier clim du mois courant
!****-------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMLUN   , ONLY : NULOUT   ,NULERR
USE YOMCT0   , ONLY : CNMEXP
USE YOMRIP   , ONLY : NINDAT

IMPLICIT NONE

CHARACTER (LEN = 13) ::  CLCLIM
LOGICAL :: LLEX

REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "fcttim.h"

#include "sugridva.intfb.h"

!-------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('CARCLI',0,ZHOOK_HANDLE)

! Condition 1 : premier jour et premier reseau du mois courant

IF (NDD(NINDAT) <= 1) THEN
! Condition 2 : disponibilite du fichier clim du mois courant
  CLCLIM= 'ICMSH'//CNMEXP(1:4)//'CLIM'
  LLEX= .FALSE.
  INQUIRE(FILE=CLCLIM,EXIST=LLEX)
  IF (LLEX) THEN
!   lecture des champs
    WRITE(UNIT=NULOUT,FMT='(&
     & '' MISE A JOUR DES CHAMPS DESCRIPTIFS DE LA VEGETATION'',/,&
     & '' ---------------------------------------------------'')')
    CALL SUGRIDVA
    WRITE(UNIT=NULOUT,FMT='('' Mise a jour terminee '',/)')  
  ELSE
    WRITE(UNIT=NULOUT,FMT='(/,&
     & '' PAS DE MISE A JOUR DES CHAMPS DESCRIPTIFS'',&
     & '' DE LA VEGETATION'',/,&
     & '' -----------------------------------------'',&
     & ''-----------------'',/,&
     & ''              ( FICHIER CLIM. ABSENT )'',//)')  
    WRITE(UNIT=NULERR,FMT='(/,&
     & '' Pas de mise a jour des champs descriptifs'',&
     & '' de la vegetation !'',/)')  
  ENDIF
ENDIF

IF (LHOOK) CALL DR_HOOK('CARCLI',1,ZHOOK_HANDLE)

END SUBROUTINE CARCLI
