SUBROUTINE CASINO
!-----------------------------------------------------------------------
!   CASINO : Initialisations de variables relatives aux observations
!   ------   et a leur utilisation dans CANARI
!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE QAPABO   , ONLY : JPBLAN   ,JPBLAS   ,JPBLOE   ,JPBLOW   ,&
 & NBODLA   ,NBODLO   ,NBONLB   ,NBONLP  
USE YOMLUN   , ONLY : NULOUT
USE YOMOBA   , ONLY : MNBOTP
USE YOMANCS  , ONLY : RADIANS
USE QAKEKI   , ONLY : NDBCVS   ,NDBCVPR  ,NDBCVF   ,NDBCVCQ  ,&
 & NDBCVCQM ,NDBCVACQ ,NDBCVAU  ,NDBPAS   ,NDBPAPR  ,&
 & NDBPAF   ,NDBPACQ  ,NDBPACQM ,NDBPAACQ ,NDBPAAU  ,&
 & NCQFCO   ,NCQFPC   ,NCQFPI   ,NCQFIN   ,NCQECO   ,&
 & NCQEPC   ,NCQEPI   ,NCQEIN   ,NCQKCO   ,NCQKPC   ,&
 & NCQKPI   ,NCQKIN   ,NCQVCO   ,NCQVPC   ,NCQVPI   ,&
 & NCQVIN   ,NCLNCO   ,NCLNPC   ,NCLNPI   ,NCLNIN   ,&
 & NCUPS    ,NCUUVT   ,NCUHU    ,NCUT2M   ,NCUH2M   ,&
 & NCUV10   ,NCURR    ,NCUSN    ,NCUSST  
USE QABOIT   , ONLY : MPROBO   ,MNBOBO
USE QALOLA   , ONLY : RLAB     ,RLOB
USE QAVARA   , ONLY : NVMXINV

IMPLICIT NONE

INTEGER(KIND=JPIM) :: ILAR, ILOT, J
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "abor1.intfb.h"

!----------------------------------------------------------------------
!  - 1 -  Initialisation partielle du common "YOMOBA"
!         -------------------------------------------

IF (LHOOK) CALL DR_HOOK('CASINO',0,ZHOOK_HANDLE)
MNBOTP(:) = 0

!----------------------------------------------------------------------
!  - 2 -  Initialisation du common "QABOIT"
!         ---------------------------------

MNBOBO(:,:) = 0
MPROBO(:,:) = 0

!-----------------------------------------------------------------------
!  - 3 -  Initialisation du common "QALOLA"
!         ---------------------------------

!  - 3.1 -  test sur la repartition des boites

ILOT = MOD( (JPBLOE-JPBLOW) , NBODLO )
ILAR = MOD( (JPBLAN-JPBLAS) , NBODLA )

IF ( ILOT /= 0 .OR. ILAR /= 0 ) THEN
  WRITE (NULOUT,311) JPBLAN,JPBLAS,JPBLOE,JPBLOW,NBODLA,NBODLO
  311 FORMAT(/,' ***** CASINO : PB DEFINITION BOITE *****',&
   & /,10X,'Latitude maximale nord    : ',I5,&
   & /,10X,'Latitude minimale sud     : ',I5,&
   & /,10X,'Longitude maximale est    : ',I5,&
   & /,10X,'Longitude maximale ouest  : ',I5,&
   & /,10X,'Long. boite sur meridien  : ',I5,&
   & /,10X,'Long. boite sur parallele : ',I5,/)  
  CALL ABOR1 (' ***** CASINO : PROBLEME BOITE ***** ')
ENDIF

!  - 3.2 -  calcul des latitudes et longitudes des bords des boites

DO J = 1 , NBONLB
  RLAB(J) = REAL( JPBLAN-((J-1)*NBODLA) ,JPRB) * RADIANS
ENDDO

DO J = 1 , NBONLP
  RLOB(J) = REAL( JPBLOW+((J-1)*NBODLO) ,JPRB) * RADIANS
ENDDO

!-----------------------------------------------------------------------
!  - 4 -  Initialisation du common "QAVARA"
!         ---------------------------------

NVMXINV(:) = 0

NVMXINV(   3 ) =  1
NVMXINV(   4 ) =  2
NVMXINV(   1 ) =  3
NVMXINV(  57 ) =  4
NVMXINV(  29 ) =  5
NVMXINV(   9 ) =  6
NVMXINV(  58 ) =  7
NVMXINV(   2 ) =  8
NVMXINV(  59 ) =  9
NVMXINV(  39 ) = 10
NVMXINV(  40 ) = 11
NVMXINV(  11 ) = 12
NVMXINV(  30 ) = 13
NVMXINV(  60 ) = 14
NVMXINV(  61 ) = 15
NVMXINV(  62 ) = 16
NVMXINV(  63 ) = 17
NVMXINV(  64 ) = 18
NVMXINV(  65 ) = 19
NVMXINV(  66 ) = 20
NVMXINV(  67 ) = 21
NVMXINV(  68 ) = 22
NVMXINV(  69 ) = 23
NVMXINV(  70 ) = 24
NVMXINV(  71 ) = 25
NVMXINV(  72 ) = 26
NVMXINV(  73 ) = 27
NVMXINV(  74 ) = 28
NVMXINV(  75 ) = 29
NVMXINV(  76 ) = 30
NVMXINV(  77 ) = 31
NVMXINV(  78 ) = 32
NVMXINV(  79 ) = 33
NVMXINV(  80 ) = 34
NVMXINV(  81 ) = 35
NVMXINV(  82 ) = 36
NVMXINV(  83 ) = 37
NVMXINV(  84 ) = 38
NVMXINV(  85 ) = 39
NVMXINV(  86 ) = 40
NVMXINV(  87 ) = 41
NVMXINV(  88 ) = 42
NVMXINV(  89 ) = 43
NVMXINV(  90 ) = 44
NVMXINV(  91 ) = 45
NVMXINV(  92 ) = 46
NVMXINV( 110 ) = 47
NVMXINV( 111 ) = 48
NVMXINV( 112 ) = 49
NVMXINV( 119 ) = 50
NVMXINV( 120 ) = 51
NVMXINV( 121 ) = 52
NVMXINV( 122 ) = 53
NVMXINV(   5 ) = 54
NVMXINV(   6 ) = 55
NVMXINV(  41 ) = 56
NVMXINV(  42 ) = 57
NVMXINV(  19 ) = 58
NVMXINV( 200 ) = 59
NVMXINV( 123 ) = 60
NVMXINV( 124 ) = 61
NVMXINV( 125 ) = 62
NVMXINV(   7 ) = 63
NVMXINV( 126 ) = 64
NVMXINV( 127 ) = 65
NVMXINV(   8 ) = 66
NVMXINV(  56 ) = 67
NVMXINV( 130 ) = 68

!-----------------------------------------------------------------------
!  - 5 -  Initialisation du common "QAKEKI"
!         ---------------------------------

NDBCVS   =  1
NDBCVPR  =  2
NDBCVF   =  3
NDBCVCQ  =  4
NDBCVCQM =  6
NDBCVACQ =  7
NDBCVAU  =  9
NDBPAS   = 16
NDBPAPR  = 17
NDBPAF   = 18
NDBPACQ  = 19
NDBPACQM = 21
NDBPAACQ = 22
NDBPAAU  = 24

NCQFCO   =  1
NCQFPC   =  2
NCQFPI   =  3
NCQFIN   =  4
NCQECO   =  5
NCQEPC   =  6
NCQEPI   =  7
NCQEIN   =  8
NCQKCO   =  9
NCQKPC   = 10
NCQKPI   = 11
NCQKIN   = 12
NCQVCO   = 13
NCQVPC   = 14
NCQVPI   = 15
NCQVIN   = 16
NCLNCO   = 17
NCLNPC   = 18
NCLNPI   = 19
NCLNIN   = 20
NCUPS    = 21
NCUUVT   = 22
NCUHU    = 23
NCUT2M   = 24
NCUH2M   = 25
NCUV10   = 26
NCURR    = 27
NCUSN    = 28
NCUSST   = 29

!----------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('CASINO',1,ZHOOK_HANDLE)
END SUBROUTINE CASINO
