!*** Note: MAKE SURE ALL VARIABLES ARE IN lowercase !!
!    Please make sure that variable lengths do not exceed 31 chars (a F90-std limit) !
!    If you want to know what is what, please look at odb/cma2odb/initmdb.F90
CHARACTER(LEN=128) :: cactiveretr
logical :: lactiveretr
logical :: allocated_satpred
!***  Observational array lengths
INTEGER(KIND=JPIM) :: nrows_robhdr
INTEGER(KIND=JPIM) :: ncols_robhdr
INTEGER(KIND=JPIM) :: nrows_satpred
INTEGER(KIND=JPIM) :: ncols_satpred
INTEGER(KIND=JPIM) :: nrows_satbody
INTEGER(KIND=JPIM) :: ncols_satbody
INTEGER(KIND=JPIM) :: nrows_sathdr
INTEGER(KIND=JPIM) :: ncols_sathdr
INTEGER(KIND=JPIM) :: nrows_robody
INTEGER(KIND=JPIM) :: ncols_robody
INTEGER(KIND=JPIM) :: nrows_robsu
INTEGER(KIND=JPIM) :: ncols_robsu
INTEGER(KIND=JPIM) :: nrows_robddr
INTEGER(KIND=JPIM) :: ncols_robddr
!***  observational arrays
REAL(KIND=JPRB)   , pointer :: robhdr(:,:)
REAL(KIND=JPRB)   , pointer :: satpred(:,:)
REAL(KIND=JPRB)   , pointer :: satbody(:,:)
REAL(KIND=JPRB)   , pointer :: sathdr(:,:) ! sometimes TARGET
REAL(KIND=JPRB)   , pointer :: robody(:,:)
!***  for obs-setup retrievals obs_boxes, obatabs, mkglobstab, suobarea, ecset, smtov
REAL(KIND=JPRB),    pointer :: robsu(:,:)
!***  link between header & body (the length is normally NROWS_ROBHDR + 1)
INTEGER(KIND=JPIM), pointer :: mlnkh2b(:)
!***  The "JOBS" of the given "JBODY" (the length is normally NROWS_ROBODY)
INTEGER(KIND=JPIM), pointer :: mbodyjobs(:)

!***  ddrs
REAL(KIND=JPRB), pointer :: robddr(:,:)

!*** auxiliary ROBAUX<n>, up to JPMAX_AUX_CASES
INTEGER(KIND=JPIM) :: nrows_robaux(JPMAX_AUX_CASES)
INTEGER(KIND=JPIM) :: ncols_robaux(JPMAX_AUX_CASES)
TYPE(robaux_t) :: iml(JPMAX_AUX_CASES) ! iml == InterMediateLayer

!*** dynamic mdb-pointers

! Aeolus_hdr, scalars
INTEGER(KIND=JPIM) :: mdb_track_at_aeolus_hdr       !  'track@aeolus_hdr'
INTEGER(KIND=JPIM) :: mdb_cellno_at_aeolus_hdr      !  'cellno@aeolus_hdr'
INTEGER(KIND=JPIM) :: mdb_prodflag_at_aeolus_hdr    !  'prodflag@aeolus_hdr'
INTEGER(KIND=JPIM) :: mdb_azimuth_at_aeolus_hdr     !  'azimuth@aeolus_hdr'
!
INTEGER(KIND=JPIM) :: mdb_aeo_hdrflag_at_aeolus_hdr !  'aeo_hdrflag@aeolus_hdr'
INTEGER(KIND=JPIM) :: mdb_geoid_seprtn_at_aeolus_hdr ! 'geoid_seprtn@aeolus_hdr'
!
INTEGER(KIND=JPIM) :: mdb_mie_gwdhls_at_aeolus_hdr   ! 'mie_gwdhls@aeolus_hdr'
INTEGER(KIND=JPIM) :: mdb_mie_gwdhlswt_at_aeolus_hdr ! 'mie_gwdhlswt@aeolus_hdr'
INTEGER(KIND=JPIM) :: mdb_ray_gwdhls_at_aeolus_hdr   ! 'ray_gwdhls@aeolus_hdr'
INTEGER(KIND=JPIM) :: mdb_ray_gwdhlswt_at_aeolus_hdr ! 'ray_gwdhlswt@aeolus_hdr'
!
INTEGER(KIND=JPIM) :: mdb_laser_wavlen_at_aeolus_hdr ! 'laser_wavlen@aeolus_hdr'
!
INTEGER(KIND=JPIM) :: mdb_mie_cal_valid_at_aeolus_hdr
!
INTEGER(KIND=JPIM) :: mdb_mie_msmnsens_at_aeolus_hdr ! 'mie_msmnsens@aeolus_hdr'
INTEGER(KIND=JPIM) :: mdb_mie_mszrfreq_at_aeolus_hdr ! 'mie_mszrfreq@aeolus_hdr'
INTEGER(KIND=JPIM) :: mdb_mie_msrspesd_at_aeolus_hdr ! 'mie_msrpsesd@aeolus_hdr'
INTEGER(KIND=JPIM) :: mdb_mie_rpmnsens_at_aeolus_hdr ! 'mie_rpmnsens@aeolus_hdr'
!
INTEGER(KIND=JPIM) :: mdb_ray_cal_valid_at_aeolus_hdr
!
INTEGER(KIND=JPIM) :: mdb_ray_msmnsens_at_aeolus_hdr ! 'ray_msmnsens@aeolus_hdr'
INTEGER(KIND=JPIM) :: mdb_ray_mszrfreq_at_aeolus_hdr ! 'ray_mszrfreq@aeolus_hdr'
INTEGER(KIND=JPIM) :: mdb_ray_msrspesd_at_aeolus_hdr ! 'ray_mszrfreq@aeolus_hdr'
INTEGER(KIND=JPIM) :: mdb_ray_rpmnsens_at_aeolus_hdr ! 'ray_rpmnsens@aeolus_hdr'
!
INTEGER(KIND=JPIM) :: mdb_dem_int_lat_at_aeolus_hdr  ! 'dem_int_lat@aeolus_hdr'
INTEGER(KIND=JPIM) :: mdb_dem_int_lon_at_aeolus_hdr  ! 'dem_int_lon@aeolus_hdr'
INTEGER(KIND=JPIM) :: mdb_dem_int_alt_at_aeolus_hdr  ! 'dem_int_alt@aeolus_hdr'

! Aeolus_hdr, vectors
INTEGER(KIND=JPIM) :: mdb_productname_at_aeolus_hdr(8)   ! 'product_name@aeolus_hdr'
INTEGER(KIND=JPIM) :: mdb_mie_errquant_at_aeolus_hdr(3)  ! 'mie_errquant@aeolus_hdr'
INTEGER(KIND=JPIM) :: mdb_ray_errquant_at_aeolus_hdr(4)  ! 'ray_errquant@aeolus_hdr'
INTEGER(KIND=JPIM) :: mdb_tripod_corrn_at_aeolus_hdr(16) ! 'tripod_corrn@aeolus_hdr'

! Aeolus_hdr, links
! 
INTEGER(KIND=JPIM) :: mlnk_sat2aeolus_hdr(2)
INTEGER(KIND=JPIM) :: mlnk_aeolus_hdr2aeolus_hdr_cal(2)
INTEGER(KIND=JPIM) :: mlnk_aeolus_hdr2aeolus_1b(2)
INTEGER(KIND=JPIM) :: mlnk_aeolus_hdr2aeolus_auxmet(2)
INTEGER(KIND=JPIM) :: mlnk_aeolus_hdr2aeolus_2b(2)

! Aeolus_hdr_calib, scalars
! Not yet implemented.

! Aeolus_1b, scalars
INTEGER(KIND=JPIM) :: mdb_azimuth_at_aeolus_1b         !  'azimuth@aeolus_1b'
INTEGER(KIND=JPIM) :: mdb_channel_at_aeolus_1b         !  'channel@aeolus_1b'
INTEGER(KIND=JPIM) :: mdb_aeolus_bin1b_at_aeolus_1b    !  'aeolus_bin1b@aeolus_1b'
INTEGER(KIND=JPIM) :: mdb_aeolus_meas_at_aeolus_1b     !  'aeolus_meas@aeolus_1b'
INTEGER(KIND=JPIM) :: mdb_lat_at_aeolus_1b             !  'lat@aeolus_1b'
INTEGER(KIND=JPIM) :: mdb_lon_at_aeolus_1b             !  'lon@aeolus_1b'
INTEGER(KIND=JPIM) :: mdb_altitude_at_aeolus_1b         !  'altitude@aeolus_1b'
INTEGER(KIND=JPIM) :: mdb_doppler_shift_at_aeolus_1b   !  'doppler_shift@aeolus_1b'
INTEGER(KIND=JPIM) :: mdb_aocs_los_veloc_at_aeolus_1b !  'aocs_los_veloc@aeolus_1b'
INTEGER(KIND=JPIM) :: mdb_scat_ratio_at_aeolus_1b     !  'scat_ratio@aeolus_1b'
INTEGER(KIND=JPIM) :: mdb_raya_refpulse_at_aeolus_1b  !  'raya_refpulse@aeolus_1b'
INTEGER(KIND=JPIM) :: mdb_rayb_refpulse_at_aeolus_1b  !  'rayb_refpulse@aeolus_1b'
INTEGER(KIND=JPIM) :: mdb_mie_usefulsig_at_aeolus_1b  !  'mie_usefulsig@aeolus_1b'
INTEGER(KIND=JPIM) :: mdb_raya_usefulsig_at_aeolus_1b !  'raya_usefulsig@aeolus_1b'
INTEGER(KIND=JPIM) :: mdb_rayb_usefulsig_at_aeolus_1b !  'rayb_usefulsig@aeolus_1b'

INTEGER(KIND=JPIM) :: mdb_msbininvalid_at_aeolus_1b   !  'msbininvalid@aeolus_1b'
INTEGER(KIND=JPIM) :: mdb_mie_snr_at_aeolus_1b        !  'mie_snr@aeolus_1b'
INTEGER(KIND=JPIM) :: mdb_raya_snr_at_aeolus_1b       !  'raya_snr@aeolus_1b'
INTEGER(KIND=JPIM) :: mdb_rayb_snr_at_aeolus_1b       !  'rayb_snr@aeolus_1b'

! Aeolus_1b, vectors
INTEGER(KIND=JPIM) :: mdb_mie_ref_pulse_at_aeolus_1b(20)  ! 'mie_ref_pulse@aeolus_1b' 
INTEGER(KIND=JPIM) :: mdb_mie_meas_data_at_aeolus_1b(20)  ! 'mie_meas_data@aeolus_1b' 

! Aeolus_auxmet, all scalars
INTEGER(KIND=JPIM) :: mdb_lat_at_aeolus_auxmet     !  'lat@aeolus_auxmet'
INTEGER(KIND=JPIM) :: mdb_lon_at_aeolus_auxmet     !  'lon@aeolus_auxmet'
INTEGER(KIND=JPIM) :: mdb_lev_at_aeolus_auxmet     !  'lev@aeolus_auxmet'
INTEGER(KIND=JPIM) :: mdb_ptop_at_aeolus_auxmet    !  'ptop@aeolus_auxmet'
INTEGER(KIND=JPIM) :: mdb_pnom_at_aeolus_auxmet    !  'pnom@aeolus_auxmet'
INTEGER(KIND=JPIM) :: mdb_ztop_at_aeolus_auxmet    !  'ztop@aeolus_auxmet'
INTEGER(KIND=JPIM) :: mdb_znom_at_aeolus_auxmet    !  'znom@aeolus_auxmet'
INTEGER(KIND=JPIM) :: mdb_u_at_aeolus_auxmet       !  'u@aeolus_auxmet'
INTEGER(KIND=JPIM) :: mdb_v_at_aeolus_auxmet       !  'v@aeolus_auxmet'
!
INTEGER(KIND=JPIM) :: mdb_t_at_aeolus_auxmet       !  't@aeolus_auxmet'
INTEGER(KIND=JPIM) :: mdb_rh_at_aeolus_auxmet      !  'rh@aeolus_auxmet'
INTEGER(KIND=JPIM) :: mdb_q_at_aeolus_auxmet       !  'q@aeolus_auxmet'
INTEGER(KIND=JPIM) :: mdb_cc_at_aeolus_auxmet      !  'cc@aeolus_auxmet'
INTEGER(KIND=JPIM) :: mdb_clwc_at_aeolus_auxmet    !  'clwc@aeolus_auxmet'
INTEGER(KIND=JPIM) :: mdb_ciwc_at_aeolus_auxmet    !  'ciwc@aeolus_auxmet'
!
INTEGER(KIND=JPIM) :: mdb_error_t_at_aeolus_auxmet       !  'error_t@aeolus_auxmet'
INTEGER(KIND=JPIM) :: mdb_error_rh_at_aeolus_auxmet      !  'error_rh@aeolus_auxmet'
INTEGER(KIND=JPIM) :: mdb_error_p_at_aeolus_auxmet       !  'error_p@aeolus_auxmet'

! Aeolus_2b, scalars
INTEGER(KIND=JPIM) :: mdb_azimuth_at_aeolus_2b         !  'azimuth@aeolus_2b'
INTEGER(KIND=JPIM) :: mdb_channel_at_aeolus_2b         !  'channel@aeolus_2b'
INTEGER(KIND=JPIM) :: mdb_bin2b_at_aeolus_2b           !  'bin2b@aeolus_2b'
INTEGER(KIND=JPIM) :: mdb_hlos_method_at_aeolus_2b     !  'hlos_method@aeolus_2b'
INTEGER(KIND=JPIM) :: mdb_cog_lat_at_aeolus_2b         !  'cog_lat@aeolus_2b'
INTEGER(KIND=JPIM) :: mdb_cog_lon_at_aeolus_2b         !  'cog_lon@aeolus_2b'
INTEGER(KIND=JPIM) :: mdb_cog_zbase_at_aeolus_2b       !  'cog_zbase@aeolus_2b'
INTEGER(KIND=JPIM) :: mdb_cog_ztop_at_aeolus_2b        !  'cog_ztop@aeolus_2b'
INTEGER(KIND=JPIM) :: mdb_hlos_at_aeolus_2b            !  'hlos@aeolus_2b'
INTEGER(KIND=JPIM) :: mdb_hlos_err_at_aeolus_2b        !  'hlos_err@aeolus_2b'


! enkf scalars
INTEGER(KIND=JPIM) :: mdb_member_at_enkf(jpmxenkf)   ! 'member@enkf[$NENKF]'
INTEGER(KIND=JPIM) :: mdb_hprior_at_enkf(jpmxenkf)   ! 'hprior@enkf[$NENKF]'

INTEGER(KIND=JPIM) :: mdb_albedo  ! 'albedo@modsurf' 
INTEGER(KIND=JPIM) :: mdb_andate_at_desc  ! 'andate@desc' 
INTEGER(KIND=JPIM) :: mdb_antime_at_desc  ! 'antime@desc' 
INTEGER(KIND=JPIM) :: mdb_inidate_at_desc  ! 'inidate@desc' 
INTEGER(KIND=JPIM) :: mdb_initime_at_desc  ! 'initime@desc' 
INTEGER(KIND=JPIM) :: mdb_expver_at_desc ! 'expver@desc' 
INTEGER(KIND=JPIM) :: mdb_class_at_desc  ! 'class@desc'
INTEGER(KIND=JPIM) :: mdb_stream_at_desc ! 'stream@desc'
INTEGER(KIND=JPIM) :: mdb_type_at_desc   ! 'type@desc'
INTEGER(KIND=JPIM) :: mdbonm ! 'seqno@hdr'
INTEGER(KIND=JPIM) :: mdbotp ! 'obstype@hdr'
!INTEGER_M :: mdboch ! 'obschar@hdr'
INTEGER(KIND=JPIM) :: mdbdat ! 'date@hdr'
INTEGER(KIND=JPIM) :: mdbetm ! 'time@hdr'
INTEGER(KIND=JPIM) :: mdbrfl ! 'report_rdbflag@hdr'
INTEGER(KIND=JPIM) :: mdbrst ! 'report_status@hdr'
INTEGER(KIND=JPIM) :: mdbrev1 ! 'report_event1@hdr'
INTEGER(KIND=JPIM) :: mdbrble ! 'report_blacklist@hdr'
INTEGER(KIND=JPIM) :: mdbbox ! 'sortbox@hdr'
INTEGER(KIND=JPIM) :: mdbstd ! 'sitedep@hdr'
INTEGER(KIND=JPIM) :: mdbsid ! 'statid@hdr'
INTEGER(KIND=JPIM) :: mdblat ! 'lat@hdr'
INTEGER(KIND=JPIM) :: mdblon ! 'lon@hdr'
INTEGER(KIND=JPIM) :: mdbalt ! 'stalt@hdr'
INTEGER(KIND=JPIM) :: mdb_lsm ! 'lsm@modsurf'
INTEGER(KIND=JPIM) :: mdb_orography ! 'orography@modsurf'
INTEGER(KIND=JPIM) :: mdb_snow_depth ! 'snow_depth@modsurf'
INTEGER(KIND=JPIM) :: mdb_t2m ! 't2m@modsurf'
INTEGER(KIND=JPIM) :: mdb_windspeed10m ! 'windspeed10m@modsurf'
INTEGER(KIND=JPIM) :: mdbtla ! 'trlat@hdr'
INTEGER(KIND=JPIM) :: mdbtlo ! 'trlon@hdr'
INTEGER(KIND=JPIM) :: mdbrev2 ! 'report_event2@hdr'
!-- Due to the faster MAPVARDB, a column name must be mapped only once to a MDB-pointer
INTEGER(KIND=JPIM) :: mdbhoans ! 'anemoht@hdr'
!!INTEGER(KIND=JPIM) :: mdbhoand ! 'anemoht@hdr'
!!INTEGER(KIND=JPIM) :: mdbhoant ! 'anemoht@hdr'
!!INTEGER(KIND=JPIM) :: mdbhoanp ! 'anemoht@hdr'
!-- Due to the faster MAPVARDB, a column name must be mapped only once to a MDB-pointer
INTEGER(KIND=JPIM) :: mdbhobas ! 'baroht@hdr'
!!INTEGER(KIND=JPIM) :: mdbhobad ! 'baroht@hdr'
!!INTEGER(KIND=JPIM) :: mdbhobat ! 'baroht@hdr'
!!INTEGER(KIND=JPIM) :: mdbhobap ! 'baroht@hdr'
INTEGER(KIND=JPIM) :: mdbsbcmm ! 'comp_method@satob'
INTEGER(KIND=JPIM) :: mdbsbiup ! 'instdata@satob'
INTEGER(KIND=JPIM) :: mdbsbdpt ! 'dataproc@satob'
INTEGER(KIND=JPIM) :: mdbsbqi1 ! 'qi_1@satob'
INTEGER(KIND=JPIM) :: mdbsbqi2 ! 'qi_2@satob'
INTEGER(KIND=JPIM) :: mdbsbqi3 ! 'qi_3@satob'
INTEGER(KIND=JPIM) ::   mdb_tb_at_satob ! 'tb@satob' 
INTEGER(KIND=JPIM) ::   mdb_t_at_satob ! 't@satob' 
INTEGER(KIND=JPIM) ::   mdb_shear_at_satob ! 'shear@satob' 
INTEGER(KIND=JPIM) ::   mdb_t200_at_satob  ! 't200@satob' 
INTEGER(KIND=JPIM) ::   mdb_t500_at_satob ! 't500@satob' 
INTEGER(KIND=JPIM) ::   mdb_top_mean_t_at_satob ! 'top_mean_t@satob' 
INTEGER(KIND=JPIM) ::   mdb_top_wv_at_satob ! 'top_wv@satob' 
INTEGER(KIND=JPIM) ::   mdb_dt_by_dp_at_satob ! 'dt_by_dp@satob' 
INTEGER(KIND=JPIM) ::   mdb_p_best_at_satob ! 'p_best@satob' 
INTEGER(KIND=JPIM) ::   mdb_u_best_at_satob ! 'u_best@satob' 
INTEGER(KIND=JPIM) ::   mdb_v_best_at_satob ! 'v_best@satob' 
INTEGER(KIND=JPIM) ::   mdb_p_old_at_satob ! 'p_old@satob' 
INTEGER(KIND=JPIM) ::   mdb_u_old_at_satob ! 'u_old@satob' 
INTEGER(KIND=JPIM) ::   mdb_v_old_at_satob ! 'v_old@satob' 
INTEGER(KIND=JPIM) ::   mdb_height_assignment_method_at_satob ! 'height_assignment_method@satob'
INTEGER(KIND=JPIM) ::   mdb_tracer_correlation_method_at_satob ! 'tracer_correlation_method@satob
INTEGER(KIND=JPIM) ::   mdb_land_sea_at_satob ! 'land_sea@satob
INTEGER(KIND=JPIM) ::   mdb_weight_at_satob(jpmx_satob_weight) ! 'weight@satob' 
INTEGER(KIND=JPIM) :: mdbssia ! 'sensor@hdr'
INTEGER(KIND=JPIM) :: mdb1bcp3a ! 'predictor_3@atovs_pred'
INTEGER(KIND=JPIM) :: mdb1bcp5a ! 'predictor_5@atovs_pred'
INTEGER(KIND=JPIM) :: mdb1bcp9a ! 'predictor_9@atovs_pred'
INTEGER(KIND=JPIM) :: mdb1bcp10a ! 'predictor_10@atovs_pred'
INTEGER(KIND=JPIM) :: mdb1bcp11a ! 'predictor_11@atovs_pred'
INTEGER(KIND=JPIM) :: mdb1bcp12a ! 'predictor_12@atovs_pred'
INTEGER(KIND=JPIM) :: mdb1bcp13a ! 'predictor_13@atovs_pred'
INTEGER(KIND=JPIM) :: mdb1bcp14a ! 'predictor_14@atovs_pred'
INTEGER(KIND=JPIM) :: mdb1bcp15a ! 'predictor_15@atovs_pred'
INTEGER(KIND=JPIM) :: mdb1bcp16a ! 'predictor_16@atovs_pred'
INTEGER(KIND=JPIM) :: mdb1bcpts1(jpmxup) ! skintemp[$NMXUPD]@atovs_pred
INTEGER(KIND=JPIM) :: mdbsccno ! 'cellno@scatt'
INTEGER(KIND=JPIM) :: mdbscpfl ! 'prodflag@scatt'
!%INTEGER(KIND=JPIM) :: mdb1derr ! 'rainrate_1dvar@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe1la ! 'lat_1@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe1lo ! 'lon_1@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe1tq ! 'timequal_1@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe1da ! 'date_1@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe1ti ! 'time_1@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe1ts ! 'surftype_1@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe1vs ! 'vertsign_1@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe1bt1 ! 'temp1_1@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe1bt2 ! 'temp2_1@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe2la ! 'lat_2@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe2lo ! 'lon_2@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe2tq ! 'timequal_2@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe2da ! 'date_2@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe2ti ! 'time_2@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe2ts ! 'surftype_2@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe2vs ! 'vertsign_2@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe2bt1 ! 'temp1_2@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe2bt2 ! 'temp2_2@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe3la ! 'lat_3@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe3lo ! 'lon_3@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe3tq ! 'timequal_3@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe3da ! 'date_3@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe3ti ! 'time_3@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe3ts ! 'surftype_3@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe3vs ! 'vertsign_3@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe3bt1 ! 'temp1_3@ssmi'
!%INTEGER(KIND=JPIM) :: mdbe3bt2 ! 'temp2_3@ssmi'
!%INTEGER(KIND=JPIM) :: mdbssmst ! 'surftype@ssmi'
!%INTEGER(KIND=JPIM) :: mdb1dstq ! 'qc_surftype@ssmi'
INTEGER(KIND=JPIM) :: mdb1dnit ! 'iterno_conv_1dvar@ssmi'
INTEGER(KIND=JPIM) :: mdb1dnis ! 'simno_conv_1dvar@ssmi'
INTEGER(KIND=JPIM) :: mdb1deps ! 'epsg_1dvar@ssmi'
INTEGER(KIND=JPIM) :: mdb1dfin ! 'failure_1dvar@ssmi'
INTEGER(KIND=JPIM) :: mdb1dfim ! 'minim_status_1dvar@ssmi'
!%INTEGER(KIND=JPIM) :: mdbies ! 'scattering_1dvar@ssmi'
!%INTEGER(KIND=JPIM) :: mdbssisi ! 'scattering_indep@ssmi'
!%INTEGER(KIND=JPIM) :: mdbsserr ! 'rainrate_indep@ssmi'
!%INTEGER(KIND=JPIM) :: mdb1drep ! 'tpw_1dvar@ssmi'
!%INTEGER(KIND=JPIM) :: mdb1drew ! 'wspeed_1dvar@ssmi'
!%INTEGER(KIND=JPIM) :: mdb1drec ! 'clwpath_1dvar@ssmi'
!%INTEGER(KIND=JPIM) :: mdbierep ! 'tpw_indep@ssmi'
!%INTEGER(KIND=JPIM) :: mdbierew ! 'wspeed_indep@ssmi'
!%INTEGER(KIND=JPIM) :: mdbierec ! 'clwpath_indep@ssmi'
INTEGER(KIND=JPIM) :: mdb1bps ! 'surfpress_1@ssmi' !c
INTEGER(KIND=JPIM) :: mdb1bsts ! 'skintemp_1@ssmi' !c
!%INTEGER(KIND=JPIM) :: mdb1b2ts ! 't2m_1@ssmi_slev'
!%INTEGER(KIND=JPIM) :: mdb1b2qs ! 'q2m_1@ssmi_slev'
!%INTEGER(KIND=JPIM) :: mdb1bpws ! 'pwc_1@ssmi_slev'
!%INTEGER(KIND=JPIM) :: mdb1bcls ! 'clw_1@ssmi_slev'
INTEGER(KIND=JPIM) :: mdb1bsus(2) ! 'u10m[2]@ssmi' !n
INTEGER(KIND=JPIM) :: mdb1bsvs(2) ! 'v10m[2]@ssmi' !n
!%INTEGER(KIND=JPIM) :: mdb1a2qs ! 'q2m_2@ssmi_slev'
!%INTEGER(KIND=JPIM) :: mdb1apws ! 'pwc_2@ssmi_slev'
!%INTEGER(KIND=JPIM) :: mdb1acls ! 'clw_2@ssmi_slev'
!%INTEGER(KIND=JPIM) :: mdb1asws ! 'wspeed10m_2@ssmi_slev'
!%INTEGER(KIND=JPIM) :: mdbsipws ! 'indep_pwc@ssmi_slev'
!%INTEGER(KIND=JPIM) :: mdbsicls ! 'indep_clw@ssmi_slev'
!%INTEGER(KIND=JPIM) :: mdbsisws ! 'indep_wspeed10m@ssmi_slev'
INTEGER(KIND=JPIM) :: mdb1dvps ! 'press@ssmi_body' !c
INTEGER(KIND=JPIM) :: mdb1dvbt ! 'temp_1@ssmi_body' !c
INTEGER(KIND=JPIM) :: mdb1dvat ! 'temp_2@ssmi_body' !c
INTEGER(KIND=JPIM) :: mdb1dvbq ! 'q_1@ssmi_body' !c
INTEGER(KIND=JPIM) :: mdb1dvaq ! 'q_2@ssmi_body' !c
!%INTEGER(KIND=JPIM) :: mdb1dvbc ! 'clw_1@ssmi_mlev'
!%INTEGER(KIND=JPIM) :: mdb1dvac ! 'clw_2@ssmi_mlev'
INTEGER(KIND=JPIM) :: mdb_procid_at_index  ! 'procid@index' 
INTEGER(KIND=JPIM) :: mdb_target_at_index  ! 'target@index' 
INTEGER(KIND=JPIM) :: mdb_distribid_at_hdr  ! 'distribid@hdr'
INTEGER(KIND=JPIM) :: mdb_distribtype_at_hdr  ! 'distribtype@hdr'
INTEGER(KIND=JPIM) :: mdb_gp_dist ! 'gp_dist@hdr'
INTEGER(KIND=JPIM) :: mdb_gp_number ! 'gp_number@hdr'
INTEGER(KIND=JPIM) :: mdb_kset_at_index  ! 'kset@index' 
INTEGER(KIND=JPIM) :: mdb_tslot_at_index  ! 'timeslot@index' 
INTEGER(KIND=JPIM) :: mdb_abnob_at_index  ! 'abnob@index' 
INTEGER(KIND=JPIM) :: mdb_mapomm_at_index ! 'mapomm@index'
INTEGER(KIND=JPIM) :: mdb_thinningkey_at_hdr(jp_numthbox) ! 'thinningkey@hdr' 
INTEGER(KIND=JPIM) :: mdb_thinningtimekey_at_hdr ! 'thinningtimekey@hdr' 
INTEGER(KIND=JPIM) :: mlnk_index2hdr(2) 
INTEGER(KIND=JPIM) :: mlnk_hdr2body(2) 
INTEGER(KIND=JPIM) :: mlnk_hdr2update(2,jpmxup) 
INTEGER(KIND=JPIM) :: mlnk_hdr2enkf(2,jpmxenkf) 
INTEGER(KIND=JPIM) :: mlnk_hdr2errstat(2) 
INTEGER(KIND=JPIM) :: mlnk_hdr2sat(2) 
INTEGER(KIND=JPIM) :: mlnk_sat2atovs(2) 
INTEGER(KIND=JPIM) :: mlnk_sat2limb(2) 
INTEGER(KIND=JPIM) :: mlnk_sat2reo3(2)
INTEGER(KIND=JPIM) :: mlnk_sat2smos(2)
INTEGER(KIND=JPIM) :: mlnk_sat2ssmi(2) 
INTEGER(KIND=JPIM) :: mlnk_sat2scatt(2) 
INTEGER(KIND=JPIM) :: mlnk_sat2satob(2) 
INTEGER(KIND=JPIM) :: mlnk_atovs2atovs_pred(2) 
INTEGER(KIND=JPIM) :: mlnk_atovs2atovs_body(2) 
INTEGER(KIND=JPIM) :: mlnk_ssmi2ssmi_body(2) 
INTEGER(KIND=JPIM) :: mlnk_scatt2scatt_body(2) 
!*AF new tables
INTEGER(KIND=JPIM) :: mlnk_radiance2surfemiss(2)
INTEGER(KIND=JPIM) :: mlnk_radiance2allsky(2)
INTEGER(KIND=JPIM) :: mlnk_allsky2allsky_body(2)
INTEGER(KIND=JPIM) :: mlnk_surfemiss2surfemiss_body(2)
INTEGER(KIND=JPIM) :: mlnk_hdr2auxiliary(2)
INTEGER(KIND=JPIM) :: mlnk_auxiliary2auxiliary_body(2)
INTEGER(KIND=JPIM) :: mlnk_radiance2co2_sink(2)
INTEGER(KIND=JPIM) :: mlnk_radiance2cloud_sink(2)
INTEGER(KIND=JPIM) :: mlnk_radiance2iasi(2)
INTEGER(KIND=JPIM) :: mlnk_hdr2modsurf(2)
INTEGER(KIND=JPIM) :: mlnk_sat2radiance(2)
!*AF END
INTEGER(KIND=JPIM) :: mdbvnm ! 'varno@body'
INTEGER(KIND=JPIM) :: mdbvco ! 'vertco_type@body'
INTEGER(KIND=JPIM) :: mdbrdfl ! 'datum_rdbflag@body'
INTEGER(KIND=JPIM) :: mdbflg ! 'datum_anflag@body'
INTEGER(KIND=JPIM) :: mdbdsta ! 'datum_status@body'
INTEGER(KIND=JPIM) :: mdbdev1 ! 'datum_event1@body'
INTEGER(KIND=JPIM) :: mdbdble ! 'datum_blacklist@body'
INTEGER(KIND=JPIM) :: mdbesqn ! 'entryno@body'
INTEGER(KIND=JPIM) :: mdbppp ! 'vertco_reference_1@body'
INTEGER(KIND=JPIM) :: mdbprl ! 'vertco_reference_2@body'
INTEGER(KIND=JPIM) :: mdbvar ! 'obsvalue@body'
INTEGER(KIND=JPIM) :: mdbomn ! 'an_depar@body'
INTEGER(KIND=JPIM) :: mdbomf ! 'fg_depar@body'
INTEGER(KIND=JPIM) :: mdbaso ! 'an_sens_obs@body'
INTEGER(KIND=JPIM) :: mdbfso ! 'fc_sens_obs@body'
INTEGER(KIND=JPIM) :: mdbfoe ! 'final_obs_error@errstat'
INTEGER(KIND=JPIM) :: mdboer ! 'obs_error@errstat'
INTEGER(KIND=JPIM) :: mdbrer ! 'repres_error@errstat'
INTEGER(KIND=JPIM) :: mdbper ! 'pers_error@errstat'
INTEGER(KIND=JPIM) :: mdbfge ! 'fg_error@errstat'
INTEGER(KIND=JPIM) :: mdb_obscorev_at_errstat(jp_numev) ! 'obs_corr_ev[$NUMEV]@errstat'
INTEGER(KIND=JPIM) :: mdb_obscormask_at_errstat ! 'obs_corr_mask@errstat'
INTEGER(KIND=JPIM) :: mdb_qc_a! 'qc_a@body'
INTEGER(KIND=JPIM) :: mdb_qc_l ! 'qc_l@body'
INTEGER(KIND=JPIM) :: mdb_qc_pge ! 'qc_pge@body'
INTEGER(KIND=JPIM) ::    mdbiom0(jpmxup) ! initial@update[$NMXUPD]
INTEGER(KIND=JPIM) ::    mdbifc1(jpmxup) ! hires@update[$NMXUPD]
INTEGER(KIND=JPIM) ::    mdbifc2(jpmxup) ! lores@update[$NMXUPD]
INTEGER(KIND=JPIM) ::    mdbiomn(jpmxup) ! final@update[$NMXUPD]
INTEGER(KIND=JPIM) :: mdbrbvc ! 'mf_vertco_type@body'
INTEGER(KIND=JPIM) :: mdbrbpio ! 'mf_log_p@body'
INTEGER(KIND=JPIM) :: mdbrboe ! 'mf_stddev@body'
INTEGER(KIND=JPIM) :: mdbdev2 ! 'event2@body'
INTEGER(KIND=JPIM) :: mdbsypc ! 'ppcode@body'
!-- Due to the faster MAPVARDB, a column name must be mapped only once to a MDB-pointer
INTEGER(KIND=JPIM) :: mdbtelid ! 'level@body'
!!INTEGER(KIND=JPIM) :: mdbpilid ! 'level@body'
!-- Due to the faster MAPVARDB, a column name must be mapped only once to a MDB-pointer
INTEGER(KIND=JPIM) :: mdbtorb ! 'biascorr@body'
!!INTEGER(KIND=JPIM) :: mdbtorba ! 'biascorr@body'
!!INTEGER(KIND=JPIM) :: mdbssrb ! 'biascorr@body'
INTEGER(KIND=JPIM) :: mdbs1dvc ! 'radcost@ssmi_body'
!%INTEGER(KIND=JPIM) :: mdbssrde ! 'depar@ssmi_body'
INTEGER(KIND=JPIM) :: mdbssccf ! 'frequency@ssmi_body'
INTEGER(KIND=JPIM) :: mdbsscbw ! 'bandwidth@ssmi_body'
INTEGER(KIND=JPIM) :: mdbssanp ! 'polarisation@ssmi_body'
INTEGER(KIND=JPIM) :: mdbscbaa ! 'azimuth@scatt_body'
INTEGER(KIND=JPIM) :: mdbscbia ! 'incidence@scatt_body'
INTEGER(KIND=JPIM) :: mdbsckp ! 'kp@scatt_body'
INTEGER(KIND=JPIM) :: mdbscres ! 'invresid@scatt_body'
INTEGER(KIND=JPIM) :: mdbscdis ! 'dirskill@scatt_body'
INTEGER(KIND=JPIM) :: mdbsckpq ! 'kp_qf@scatt_body'
INTEGER(KIND=JPIM) :: mdbscs0q ! 'sigma0_qf@scatt_body'
INTEGER(KIND=JPIM) :: mdbscsm  ! 'sigma0_sm@scatt_body'
INTEGER(KIND=JPIM) :: mdbscsms ! 'soilmoist_sd@scatt_body'
INTEGER(KIND=JPIM) :: mdbscsmc ! 'soilmoist_cf@scatt_body'
INTEGER(KIND=JPIM) :: mdbscsmp ! 'soilmoist_pf@scatt_body'
INTEGER(KIND=JPIM) :: mdbsclfr ! 'land_fraction@scatt_body'
INTEGER(KIND=JPIM) :: mdb_likelihood_at_scatt_body ! 'likelihood@scatt_body'
INTEGER(KIND=JPIM) :: mdbscsmw ! 'wetland_fraction@scatt_body'
INTEGER(KIND=JPIM) :: mdbscsmt ! 'topo_complex@scatt_body'
INTEGER(KIND=JPIM) :: mdb_satid_at_sat  ! 'satellite_identifier@sat'
INTEGER(KIND=JPIM) :: mdb_satinst_at_sat ! 'satellite_instrument@sat'
INTEGER(KIND=JPIM) :: mdb_gen_centre_at_sat  ! 'gen_centre@sat'
INTEGER(KIND=JPIM) :: mdb_gen_subcentre_at_sat  ! 'gen_subcentre@sat'
INTEGER(KIND=JPIM) :: mdb_datastream_at_sat      ! 'datastream@sat'
INTEGER(KIND=JPIM) ::   mdb_cldptop1_at_atovs  ! 'cldptop1@atovs' 
INTEGER(KIND=JPIM) ::   mdb_cldne1_at_atovs  ! 'cldne1@atovs' 
INTEGER(KIND=JPIM) ::   mdb_cldptop2_at_atovs  ! 'cldptop2@atovs' 
INTEGER(KIND=JPIM) ::   mdb_cldne2_at_atovs  ! 'cldne2@atovs' 
INTEGER(KIND=JPIM) ::   mdb_cldptop3_at_atovs  ! 'cldptop3@atovs' 
INTEGER(KIND=JPIM) ::   mdb_cldne3_at_atovs  ! 'cldne3@atovs' 
INTEGER(KIND=JPIM) :: mdbro3it ! 'instrument_type@reo3'
INTEGER(KIND=JPIM) :: mdbro3pt ! 'product_type@reo3'
INTEGER(KIND=JPIM) :: mdbro3la1 ! 'lat_fovcorner_1@reo3'
INTEGER(KIND=JPIM) :: mdbro3lo1 ! 'lon_fovcorner_1@reo3'
INTEGER(KIND=JPIM) :: mdbro3la2 ! 'lat_fovcorner_2@reo3'
INTEGER(KIND=JPIM) :: mdbro3lo2 ! 'lon_fovcorner_2@reo3'
INTEGER(KIND=JPIM) :: mdbro3la3 ! 'lat_fovcorner_3@reo3'
INTEGER(KIND=JPIM) :: mdbro3lo3 ! 'lon_fovcorner_3@reo3'
INTEGER(KIND=JPIM) :: mdbro3la4 ! 'lat_fovcorner_4@reo3'
INTEGER(KIND=JPIM) :: mdbro3lo4 ! 'lon_fovcorner_4@reo3'
INTEGER(KIND=JPIM) :: mdbro3soe ! 'solar_elevation@reo3'
INTEGER(KIND=JPIM) :: mdbro3fov ! 'scanpos@reo3'
INTEGER(KIND=JPIM) :: mdbro3clc ! 'cloud_cover@reo3'
INTEGER(KIND=JPIM) :: mdbro3cp ! 'cloud_top_press@reo3'
INTEGER(KIND=JPIM) :: mdbro3qr ! 'quality_retrieval@reo3'
INTEGER(KIND=JPIM) :: mdbro3nl ! 'number_layers@reo3'
INTEGER(KIND=JPIM) :: mdbaersii ! 'snow_ice_indicator@reo3'
INTEGER(KIND=JPIM) :: mdbaerstf ! 'surface_type_indicator@reo3'
INTEGER(KIND=JPIM) :: mdb_source_at_desc    ! 'source@desc' 
INTEGER(KIND=JPIM) :: mdb_version_at_desc   ! 'version@desc' 
INTEGER(KIND=JPIM) :: mdb_acl_at_desc       ! 'acl@desc' 
INTEGER(KIND=JPIM) :: mdb_creadate_at_desc  ! 'creadate@desc' 
INTEGER(KIND=JPIM) :: mdb_creatime_at_desc  ! 'creatime@desc' 
INTEGER(KIND=JPIM) :: mdb_creaby_at_desc    ! 'creaby@desc' 
INTEGER(KIND=JPIM) :: mdb_moddate_at_desc   ! 'moddate@desc' 
INTEGER(KIND=JPIM) :: mdb_modtime_at_desc   ! 'modtime@desc' 
INTEGER(KIND=JPIM) :: mdb_modby_at_desc     ! 'modby@desc' 
INTEGER(KIND=JPIM) :: mdb_fulldesc_at_desc(jp_maxdesc)  ! 'fulldesc@desc' 
INTEGER(KIND=JPIM) :: mlnk_desc2hdr(2) 
INTEGER(KIND=JPIM) :: mlnk_hdr2bufr(2) 
INTEGER(KIND=JPIM) :: mdb_subclass_at_hdr  ! 'subclass@hdr' 
INTEGER(KIND=JPIM) :: mdb_rdbtype_at_hdr   ! 'rdbtype@hdr' 
INTEGER(KIND=JPIM) :: mdb_subtype_at_hdr   ! 'subtype@hdr' 
INTEGER(KIND=JPIM) :: mdb_bufrtype_at_hdr  ! 'bufrtype@hdr' 
INTEGER(KIND=JPIM) :: mdb_groupid_at_hdr   ! 'groupid@hdr'
INTEGER(KIND=JPIM) :: mdb_reportype_at_hdr ! 'reportype@hdr'
INTEGER(KIND=JPIM) :: mdb_flag_at_hdr      ! 'flag@hdr' 
INTEGER(KIND=JPIM) :: mdb_numlev_at_hdr    ! 'numlev@hdr' 
INTEGER(KIND=JPIM) :: mdb_numactiveb_at_hdr ! 'numactiveb@hdr'
INTEGER(KIND=JPIM) :: mdb_duplseqno_at_hdr(jp_maxdupl)  ! 'duplseqno@hdr' 
INTEGER(KIND=JPIM) :: mdb_msg_at_bufr      ! 'msg@bufr' 
INTEGER(KIND=JPIM) :: mdb_thinbox_at_hdr   ! 'thinbox@hdr' 
INTEGER(KIND=JPIM) :: mdb_msec_at_hdr      ! 'msec@hdr' 
INTEGER(KIND=JPIM) :: mlnk_hdr2inbufr(2)  
INTEGER(KIND=JPIM) :: mdb_msg_at_inbufr    ! 'msg@inbufr' 
INTEGER(KIND=JPIM) :: mlnk_hdr2outbufr(2) 
INTEGER(KIND=JPIM) :: mdb_msg_at_outbufr   ! 'msg@outbufr' 
!*** New items added due to direct BUFR2ODB conversion
INTEGER(KIND=JPIM) :: mdb_station_type_at_hdr ! 'station_type@hdr' 
INTEGER(KIND=JPIM) :: mdb_sonde_type_at_hdr ! 'sonde_type@hdr' 
INTEGER(KIND=JPIM) :: mdb_mpc_at_scatt_body ! 'mpc@scatt_body' 
INTEGER(KIND=JPIM) :: mdb_wvc_qf ! 'wvc_qf@scatt' 
INTEGER(KIND=JPIM) :: mdb_nretr_amb ! 'nretr_amb@scatt' 
INTEGER(KIND=JPIM) :: mdb_subsetno_at_hdr ! 'subsetno@hdr' 
INTEGER(KIND=JPIM) :: mdb_flight_phase_at_hdr  ! flight_phase@hdr
!*** New items added due to Poolmasking
INTEGER(KIND=JPIM) :: mlnk_desc2poolmask(2)
INTEGER(KIND=JPIM) :: mdb_poolno_at_poolmask ! 'poolno@poolmask' 
INTEGER(KIND=JPIM) :: mdb_obstype_at_poolmask ! 'obstype@poolmask' 
INTEGER(KIND=JPIM) :: mdb_codetype_at_poolmask ! 'codetype@poolmask' 
INTEGER(KIND=JPIM) :: mdb_sensor_at_poolmask ! 'sensor@poolmask' 
INTEGER(KIND=JPIM) :: mdb_tslot_at_poolmask ! 'timeslot@poolmask' 
INTEGER(KIND=JPIM) :: mdb_subtype_at_poolmask ! 'subtype@poolmask' 
INTEGER(KIND=JPIM) :: mdb_bufrtype_at_poolmask ! 'bufrtype@poolmask' 
INTEGER(KIND=JPIM) :: mdb_hdr_count_at_poolmask ! 'hdr_count@poolmask' 
INTEGER(KIND=JPIM) :: mdb_body_count_at_poolmask ! 'body_count@poolmask' 
INTEGER(KIND=JPIM) :: mdb_max_bodylen_at_poolmask ! 'max_bodylen@poolmask' 
!*** New items added due to introduction of 'timeslot_index'-table
INTEGER(KIND=JPIM) :: mdb_timeslot_at_timeslot_index ! 'timeslot@timeslot_index' 
INTEGER(KIND=JPIM) :: mdb_enddate_at_timeslot_index ! 'enddate@timeslot_index' 
INTEGER(KIND=JPIM) :: mdb_endtime_at_timeslot_index ! 'endtime@timeslot_index' 
INTEGER(KIND=JPIM) :: mlnk_desc2timeslot_index(2)
INTEGER(KIND=JPIM) :: mlnk_timeslot_index2index(2)
!*** Commonly needed subwords/members of 'obschar.*@hdr'
!INTEGER_M :: mdb_obschar_d_codetype_at_hdr  ! 'obschar.codetype@hdr' ! 'obschar_d_codetype@hdr' 
!INTEGER_M :: mdb_obschar_d_instype_at_hdr   ! 'obschar.instype@hdr' ! 'obschar_d_instype@hdr' 
!INTEGER_M :: mdb_obschar_d_retrtype_at_hdr  ! 'obschar.retrtype@hdr' ! 'obschar_d_retrtype@hdr' 
!INTEGER_M :: mdb_obschar_d_datagroup_at_hdr ! 'obschar.datagroup@hdr' ! 'obschar_d_datagroup@hdr' 
!*** obschar is replaced by 4 new entries
INTEGER(KIND=JPIM) :: mdb_codetype_at_hdr ! 'codetype@hdr'
INTEGER(KIND=JPIM) :: mdb_insttype_at_hdr ! 'instrument_type@hdr'
INTEGER(KIND=JPIM) :: mdb_retrtype_at_hdr ! 'retrtype@hdr'
INTEGER(KIND=JPIM) :: mdb_areatype_at_hdr ! 'areatype@hdr'
!*** Additional @satob entries requested by Niels Bormann  [20/11/2001]
INTEGER(KIND=JPIM) :: mdb_segment_size_x_at_satob ! 'segment_size_x@satob' 
INTEGER(KIND=JPIM) :: mdb_segment_size_y_at_satob ! 'segment_size_y@satob' 
!*** New item(s)
INTEGER(KIND=JPIM) :: mdb_zone_at_hdr ! 'zone@hdr'
INTEGER(KIND=JPIM) :: mdb_satinst_at_hdr      ! 'satellite_instrument@hdr' 
INTEGER(KIND=JPIM) :: mdb_satinst_at_poolmask ! 'satellite_instrument@hpoolmask' 
INTEGER(KIND=JPIM) :: mdb_report_description_at_hdr(4)      ! 'report_description@hdr' 
!*** New @satob table item suggested by Niels Bormann [7/11/2002]
INTEGER(KIND=JPIM) :: mdb_chan_freq_at_satob ! 'chan_freq@satob'
!*** New @body & @atovs entries proposed by Christina Koepken [26/11/2002]
INTEGER(KIND=JPIM) :: mdb_cld_fg_depar_at_body ! 'cld_fg_depar@body'
INTEGER(KIND=JPIM) :: mdb_surfemiss_at_body ! 'surfemiss@body'
INTEGER(KIND=JPIM) :: mdb_csr_pclear_at_body ! 'csr_pclear@body'
INTEGER(KIND=JPIM) :: mdb_csr_pcloudy_at_body ! 'csr_pcloudy@body'
!*** New @desc & @hdr entries pushed in by Sami Saarinen [17/02/2004]
INTEGER(KIND=JPIM) :: mdb_mxup_traj_at_desc ! 'mxup_traj@desc'
INTEGER(KIND=JPIM) :: mdb_numtsl_at_desc ! 'numtsl@desc'
INTEGER(KIND=JPIM) :: mdb_source_at_hdr     ! 'source@hdr'
!*** VarBC-related @body entries by Dick Dee [23/10/2007]
INTEGER(KIND=JPIM) :: mdb_biasctrl_at_body  ! 'biasctrl@body'
INTEGER(KIND=JPIM) :: mdb_varbc_ix_at_body  ! 'varbc_ix@body'
!*** Table @satem removed and items moved into @hdr with different names
!    (for old SATEM) by Sami Saarinen [26/6/2003]
INTEGER(KIND=JPIM) :: mdb_satem_dataproc_at_hdr ! 'satem_dataproc@hdr' 
INTEGER(KIND=JPIM) :: mdb_satem_instdata_at_hdr ! 'satem_instdata@hdr' 
!*** MDB_AUX1_AT_BODY obsolete (except PREODB)
!    Elsewhere replaced by (vector) of MDB_AUX_AT_BODY [23/1/04 SS]
INTEGER(KIND=JPIM) :: mdb_aux_at_body(jp_numaux)  ! 'aux@body' 
INTEGER(KIND=JPIM) :: mdb_aux1_at_body  ! 'aux1@body' 
!*** latlon_rad@desc added to flag whether (lat,lon) are in radians or not [23/1/04 SS]
INTEGER(KIND=JPIM) ::  mdb_latlon_rad_at_desc ! 'latlon_rad@desc'
!*** SSM/I reorganization (Peter Bauer/Sami Saarinen) [11/3/04]
!    New entries (!n), Changed entries (!c), Removed entries (!%)
INTEGER(KIND=JPIM) :: mdb_prec_st_at_ssmi(2) ! 'prec_st[2]@ssmi' !n
INTEGER(KIND=JPIM) :: mdb_prec_cv_at_ssmi(2) ! 'prec_cv[2]@ssmi' !n
INTEGER(KIND=JPIM) :: mdb_rain_at_ssmi_body(2) ! 'rain[2]@ssmi_body' !n
INTEGER(KIND=JPIM) :: mdb_snow_at_ssmi_body(2) ! 'snow[2]@ssmi_body' !n
INTEGER(KIND=JPIM) :: mdb_clw_at_ssmi_body(2) ! 'clw[2]@ssmi_body' !n
INTEGER(KIND=JPIM) :: mdb_ciw_at_ssmi_body(2) ! 'ciw[2]@ssmi_body' !n
INTEGER(KIND=JPIM) :: mdb_cc_at_ssmi_body(2) ! 'cc[2]@ssmi_body' !n
INTEGER(KIND=JPIM) :: mdb1d_cost ! 'cost@ssmi' !n
INTEGER(KIND=JPIM) :: mdb1d_sfc_rain_3d_fg ! 'sfc_rain_3d_fg@ssmi' !n
INTEGER(KIND=JPIM) :: mdb1d_sfc_snow_3d_fg ! 'sfc_snow_3d_fg@ssmi' !n
INTEGER(KIND=JPIM) :: mdb1d_sfc_rain_3d_an ! 'sfc_rain_3d_an@ssmi' !n
INTEGER(KIND=JPIM) :: mdb1d_sfc_snow_3d_an ! 'sfc_snow_3d_an@ssmi' !n
INTEGER(KIND=JPIM) :: mdb1d_rwp(4) ! 'rwp@ssmi' !n
INTEGER(KIND=JPIM) :: mdb1d_swp(4) ! 'swp@ssmi' !n
INTEGER(KIND=JPIM) :: mdb1d_cwp(4) ! 'cwp@ssmi' !n
INTEGER(KIND=JPIM) :: mdb1d_iwp(4) ! 'iwp@ssmi' !n
INTEGER(KIND=JPIM) :: mdb_rad_obs_at_ssmi_body ! 'rad_obs@ssmi_body' !n
INTEGER(KIND=JPIM) :: mdb_rad_fg_3d_at_ssmi_body ! 'rad_fg_3d@ssmi_body' !n
INTEGER(KIND=JPIM) :: mdb_rad_4dan_at_ssmi_body ! 'rad_4dan@ssmi_body' !n
INTEGER(KIND=JPIM) :: mdb1bpws ! 'tcwv_obs@ssmi_body' !n
INTEGER(KIND=JPIM) :: mdb1drep ! 'tcwv_fg@ssmi_body' !n
INTEGER(KIND=JPIM) :: mdb_rad_fg_depar_at_ssmi_body ! 'rad_fg_depar@ssmi_body' !n
INTEGER(KIND=JPIM) :: mdb_rad_an_depar_at_ssmi_body ! 'rad_an_depar@ssmi_body' !n
INTEGER(KIND=JPIM) :: mdb_rad_obs_err_at_ssmi_body ! 'rad_obs_err@ssmi_body' !n
INTEGER(KIND=JPIM) :: mdb_rad_bias_at_ssmi_body ! 'rad_bias@ssmi_body' !n
!*** checksum@hdr-word added to get over reproducibility problems for good [18/3/04 SS]
!    contains the SUM(obsvalue) WHERE press IS NOT NULL and obsvalue IS NOT NULL
!    just after bufr2odb (in mergeodb; routine odb/cma2odb/update_obsdb.F90)
INTEGER(KIND=JPIM) :: mdb_checksum_at_hdr ! 'checksum@hdr'
!*** New item for SMOS proposed by J. Muñoz Sabater [06/10/2009]
INTEGER(KIND=JPIM) :: mdb_tb_flag_smos      ! 'report_tbflag@smos'
INTEGER(KIND=JPIM) :: mdb_tb_ang_smos       ! 'incidence_angle@smos'
INTEGER(KIND=JPIM) :: mdb_polarisation_at_smos  ! 'polarisation@smos'
INTEGER(KIND=JPIM) :: mdb_tbvalue_smos           ! 'tbvalue@smos'
!*** New item for radio occultation SBH [27/10/2004]
INTEGER(KIND=JPIM) :: mdbradcurv            ! 'radcurv@hdr'
INTEGER(KIND=JPIM) :: mdb_limb_azimuth      ! 'limb_azimuth@hdr'
INTEGER(KIND=JPIM) :: mdb_undulation        ! 'undulation@hdr'
INTEGER(KIND=JPIM) :: mdb_anaprop_at_radar_body
INTEGER(KIND=JPIM) :: mdb_antenht_at_radar_station
INTEGER(KIND=JPIM) :: mdb_beamwidth_at_radar_station
INTEGER(KIND=JPIM) :: mdb_distance_at_radar_body
INTEGER(KIND=JPIM) :: mdb_elevation_at_radar_body
INTEGER(KIND=JPIM) :: mdb_failure_1dv_at_radar
INTEGER(KIND=JPIM) :: mdb_flgdyn_at_radar_body
INTEGER(KIND=JPIM) :: mdb_frequency_at_radar_station
INTEGER(KIND=JPIM) :: mdb_ident_at_radar_station
INTEGER(KIND=JPIM) :: mdb_iternoconv_1dv_at_radar
INTEGER(KIND=JPIM) :: mdb_lat_at_radar_station
INTEGER(KIND=JPIM) :: mdb_lon_at_radar_station
INTEGER(KIND=JPIM) :: mdb_polarisation_at_radar_body
INTEGER(KIND=JPIM) :: mdb_azimuth_at_radar_body
INTEGER(KIND=JPIM) :: mdb_press_at_radar_body
INTEGER(KIND=JPIM) :: mdb_q1_at_radar_body
INTEGER(KIND=JPIM) :: mdb_q2_at_radar_body
INTEGER(KIND=JPIM) :: mdb_q_1dv_at_radar_body
INTEGER(KIND=JPIM) :: mdb_reflcost_at_radar_body
INTEGER(KIND=JPIM) :: mdb_stalt_at_radar_station
INTEGER(KIND=JPIM) :: mdb_temp1_at_radar_body
INTEGER(KIND=JPIM) :: mdb_temp2_at_radar_body
INTEGER(KIND=JPIM) :: mdb_temp_1dv_at_radar_body
INTEGER(KIND=JPIM) :: mdb_time_at_radar_body
INTEGER(KIND=JPIM) :: mdb_type_at_radar_station
INTEGER(KIND=JPIM) :: mlnk_sat2radar_station(2)
INTEGER(KIND=JPIM) :: mlnk_sat2radar(2)
INTEGER(KIND=JPIM) :: mlnk_radar2radar_body(2)
!*AF entries for gnssro (MF) to be moved to gnssro tables...
INTEGER(KIND=JPIM) :: mdb_obs_tvalue_at_robody          ! 'obs_tvalue@body'
INTEGER(KIND=JPIM) :: mdb_obs_zvalue_at_robody          ! 'obs_zvalue@body'
INTEGER(KIND=JPIM) :: mdb_bg_tvalue_at_robody           ! 'bg_tvalue@body'
INTEGER(KIND=JPIM) :: mdb_obs_dndz_at_robody            ! 'obs_dndz@body'
INTEGER(KIND=JPIM) :: mdb_obs_refractivity_at_robody    ! 'obs_refractivity@body'
INTEGER(KIND=JPIM) :: mdb_bg_dndz_at_robody             ! 'bg_dndz@body'
INTEGER(KIND=JPIM) :: mdb_bg_refractivity_at_robody     ! 'bg_refractivity@body'
INTEGER(KIND=JPIM) :: mdb_bg_layerno_at_robody          ! 'bg_layerno@body'
!*** New item for radar
INTEGER(KIND=JPIM) :: mdb_qmod_at_radar(jpmx_radar_niv)     ! 'qmod@radar'
INTEGER(KIND=JPIM) :: mdb_zsimp_at_radar(jpmx_radar_niv)    ! 'zsimp@radar'
!*** New item for radio occultation SBH [27/10/2004]
INTEGER(KIND=JPIM) :: mdb_ntan_at_limb      ! 'ntan@limb'
INTEGER(KIND=JPIM) :: mdb_ztan_at_limb(jpmx_limb_tan) ! 'ztan@limb'
INTEGER(KIND=JPIM) :: mdb_ptan_at_limb(jpmx_limb_tan) ! 'ptan@limb'
INTEGER(KIND=JPIM) :: mdb_thtan_at_limb(jpmx_limb_tan) ! 'thtan@limb'
INTEGER(KIND=JPIM) :: mdb_cloud_index_at_limb(jpmx_limb_tan) ! 'cloud_index@limb'
INTEGER(KIND=JPIM) :: mdb_window_rad_at_limb(jpmx_limb_tan) ! 'window_rad@limb'

!*** New @atovs entry proposed by Thomas Auligne [03/02/2005]
INTEGER(KIND=JPIM) :: mdb_cldcover_at_atovs ! 'cldcover@atovs'

!*** New @atovs entries proposed by Andrew Collard [29/09/2008]

INTEGER(KIND=JPIM) :: mdb_avhrr_num_clusters_at_iasi  ! 'avhrr_num_clusters@iasi'
INTEGER(KIND=JPIM) :: mdb_avhrr_max_cluster_at_iasi   ! 'avhrr_max_cluster@iasi'
INTEGER(KIND=JPIM) :: mdb_avhrr_mean_ir_at_iasi       ! 'avhrr_mean_ir@iasi'
INTEGER(KIND=JPIM) :: mdb_avhrr_stddev_ir_at_iasi     ! 'avhrr_stddev_ir@iasi'
INTEGER(KIND=JPIM) :: mdb_avhrr_mean_vis_at_iasi      ! 'avhrr_mean_vis@iasi'
INTEGER(KIND=JPIM) :: mdb_avhrr_stddev_vis_at_iasi    ! 'avhrr_stddev_vis@iasi'
INTEGER(KIND=JPIM) :: mdb_avhrr_cold_cluster_at_iasi  ! 'avhrr_coldest_cluster_ir@iasi'
INTEGER(KIND=JPIM) :: mdb_avhrr_warm_cluster_at_iasi  ! 'avhrr_warmest_cluster_ir@iasi'
INTEGER(KIND=JPIM) :: mdb_avhrr_larg_cluster_at_iasi  ! 'avhrr_largest_cluster_ir@iasi'
INTEGER(KIND=JPIM) :: mdb_provider_qc_at_iasi         ! 'provider_qc@iasi'


!*** New items for CO2 sink variable by Richard Engelen [09/06/2004]

INTEGER(KIND=JPIM) :: mdb_co2bg_s_at_co2_sink ! 'co2bg_s@co2_sink'
INTEGER(KIND=JPIM) :: mdb_co2er_s_at_co2_sink ! 'co2er_s@co2_sink'
INTEGER(KIND=JPIM) :: mdb_co2aner_s_at_co2_sink ! 'co2aner_s@co2_sink'
INTEGER(KIND=JPIM) :: mdb_co2inc_s_at_co2_sink ! 'co2inc_s@co2_sink'
INTEGER(KIND=JPIM) :: mdb_co2_s_at_co2_sink(jpmxup) ! 'co2_s@co2_sink'
INTEGER(KIND=JPIM) :: mdb_co2bg_t_at_co2_sink ! 'co2bg_t@co2_sink'
INTEGER(KIND=JPIM) :: mdb_co2er_t_at_co2_sink ! 'co2er_t@co2_sink'
INTEGER(KIND=JPIM) :: mdb_co2aner_t_at_co2_sink ! 'co2aner_t@co2_sink'
INTEGER(KIND=JPIM) :: mdb_co2inc_t_at_co2_sink ! 'co2inc_t@co2_sink'
INTEGER(KIND=JPIM) :: mdb_co2_t_at_co2_sink(jpmxup) ! 'co2_t@co2_sink'
INTEGER(KIND=JPIM) :: mdb_tropo_at_co2_sink ! 'tropo@co2_sink'

!*** New items for cloud  sink variable from Tony Mc
INTEGER(KIND=JPIM) :: mdb_ctopbg_at_cloud_sink ! 'ctopbg@cloud_sink'
INTEGER(KIND=JPIM) :: mdb_ctoper_at_cloud_sink ! 'ctoper@cloud_sink'
INTEGER(KIND=JPIM) :: mdb_ctopinc_at_cloud_sink ! 'ctopinc@cloud_sink'
INTEGER(KIND=JPIM) :: mdb_ctop_at_cloud_sink(jpmxup) ! 'ctop@cloud_sink'
INTEGER(KIND=JPIM) :: mdb_camtbg_at_cloud_sink ! 'camtbg@cloud_sink'
INTEGER(KIND=JPIM) :: mdb_camter_at_cloud_sink ! 'camter@cloud_sink'
INTEGER(KIND=JPIM) :: mdb_camtinc_at_cloud_sink ! 'camtinc@cloud_sink'
INTEGER(KIND=JPIM) :: mdb_camt_at_cloud_sink(jpmxup) ! 'camt@cloud_sink'

!*** Ensemble Data Assimilation (enda) by Sami Saarinen [26/08/2005]
INTEGER(KIND=JPIM) :: mdb_enda_member_at_desc ! 'enda_member@desc'
INTEGER(KIND=JPIM) :: mdb_enda_count_at_hdr   ! 'enda_count@hdr'
INTEGER(KIND=JPIM) :: mdb_enda_count_at_body  ! 'enda_count@body'

!*** Dialing country code for the future speedup of SELECT ... WHERE inside(lat,lon,'country_name') [28/09/2005/SS]

!*** New @body entries proposed by Richard Engelen [07/07/2006]
INTEGER(KIND=JPIM) :: mdb_tausfc_at_body ! 'tausfc@body'
!*** New items added for new table reo3_body by Antje Dethof [20/02/2006]
INTEGER(KIND=JPIM) :: mdb_nak_at_reo3_body ! 'nak@reo3_body'
INTEGER(KIND=JPIM) :: mdb_pak_at_reo3_body(jpmx_ak) ! 'pak@reo3_body'
INTEGER(KIND=JPIM) :: mdb_wak_at_reo3_body(jpmx_ak) ! 'wak@reo3_body'
INTEGER(KIND=JPIM) :: mlnk_reo32reo3_body(2)

!*** Yannick : Note: hardcoded #2 ;-(
INTEGER(KIND=JPIM) ::  mdb_obs_diags(2,jpmxup) ! f.ex. obs_diags[7]@update[5] i.e. obs_diags@update_5 :== ROBODY(JBODY, MDB_OBS_DIAGS(7,5))
!*** Changes due to BoM/MetOffice -compatibility (by SS, from their odb_CY32R2.039.tgz around 21-Nov-2007)
INTEGER(KIND=JPIM) :: mdb_dd_best_at_satob ! 'dd_best@satob'
INTEGER(KIND=JPIM) :: mdb_ff_best_at_satob ! 'ff_best@satob'
INTEGER(KIND=JPIM) :: mdb_sel_wnd_indx_at_scatt_body ! 'sel_wnd_indx@scatt_body'
INTEGER(KIND=JPIM) :: mdb_prcp_prob_at_scatt_body ! 'prcp_prob@scatt_body'

!*** New entry to hdr table for extended GEMS reo3 bufr by A. Dethof [05/03/2007]
INTEGER(KIND=JPIM) :: mdb_retrsource_at_reo3 ! retrsource@reo3
!*** New entry to errstat table for extended GEMS reo3 bufr by A. Dethof [05/03/2007]
INTEGER(KIND=JPIM) :: mdb_obs_ak_error_at_errstat ! obs_ak_error@errstat
!*** New entry to reo3 table for Sciamachy CH4 correction factor by R. Engelen [11/02/2008]
INTEGER(KIND=JPIM) :: mdb_ch4cor_at_reo3 ! 'methane_correction@reo3'
!*** New @atovs_body entry proposed by Fatima Karbou [16/04/2007]
INTEGER(KIND=JPIM) :: mdb_mwemis_atlas1  ! mwemis_atlas@surfemiss_body
INTEGER(KIND=JPIM) :: mdb_mwemis_atlas2
INTEGER(KIND=JPIM) :: mdb_mwemis_atlas3
INTEGER(KIND=JPIM) :: mdb_mwemis_atlas4
INTEGER(KIND=JPIM) :: mdb_mwemis_sat1    ! mwemis_sat@surfemiss_body
INTEGER(KIND=JPIM) :: mdb_mwemis_sat2
INTEGER(KIND=JPIM) :: mdb_mwskin1        ! mwskin@surfemiss_body
INTEGER(KIND=JPIM) :: mdb_mwskin2
INTEGER(KIND=JPIM) :: mdb_mwatmo_trans   ! mwatmo_trans@surfemiss_body

!*** Add prior profile to reo3 averaging kernels by Richard Engelen [22/10/2008]
INTEGER(KIND=JPIM) :: mdb_apak_at_reo3_body(jpmx_ak) ! 'apak@reo3_body'
INTEGER(KIND=JPIM) :: mdb_sfc_height_at_reo3 ! 'surface_height@reo3'
!*** New @atovs entries with model cloud water Blazej Krzeminski [07/08/2008]
INTEGER(KIND=JPIM) :: mdb_clw_at_atovs  ! clw@atovs
INTEGER(KIND=JPIM) :: mdb_ciw_at_atovs  ! ciw@atovs
!*** New entry to body table for layer number by R. Dragani [21/01/2009]
INTEGER(KIND=JPIM) :: mdb_nlayer_at_body ! nlayer@body
!*** AF [31/10/2008]  New entry in hdr to keep a copy of seqno (subwindows --> Yannick)
INTEGER(KIND=JPIM) :: mdb_subseqno_at_hdr      ! 'subseqno@hdr'
!*** AF [07/04/2010]  New entries in sat
INTEGER(KIND=JPIM) :: mdb_zenith_at_sat          ! zenith@sat
INTEGER(KIND=JPIM) :: mdb_azimuth_at_sat         ! azimuth@sat
INTEGER(KIND=JPIM) :: mdb_solar_zenith_at_sat    ! solar_zenith@sat
INTEGER(KIND=JPIM) :: mdb_solar_azimuth_at_sat   ! solar_azimuth@sat
!*** AF [07/04/2010]  New entries in allsky
INTEGER(KIND=JPIM) :: mdb_fg_rain_rate          ! fg_rain_rate@allsky
INTEGER(KIND=JPIM) :: mdb_fg_snow_rate          ! fg_snow_rate@allsky
INTEGER(KIND=JPIM) :: mdb_fg_tcwv               ! fg_tcwv@allsky
INTEGER(KIND=JPIM) :: mdb_fg_cwp                ! fg_cwp@allsky
INTEGER(KIND=JPIM) :: mdb_fg_iwp                ! fg_iwp@allsky
INTEGER(KIND=JPIM) :: mdb_fg_rwp                ! fg_rwp@allsky
INTEGER(KIND=JPIM) :: mdb_fg_swp                ! fg_swp@allsky
INTEGER(KIND=JPIM) :: mdb_fg_rttov_cld_frac     ! fg_rttov_cld_fraction@allsky

INTEGER(KIND=JPIM) :: mdb_an_rain_rate          ! an_rain_rate@allsky
INTEGER(KIND=JPIM) :: mdb_an_snow_rate          ! an_snow_rate@allsky
INTEGER(KIND=JPIM) :: mdb_an_tcwv               ! an_tcwv@allsky
INTEGER(KIND=JPIM) :: mdb_an_cwp                ! an_cwp@allsky
INTEGER(KIND=JPIM) :: mdb_an_iwp                ! an_iwp@allsky
INTEGER(KIND=JPIM) :: mdb_an_rwp                ! an_rwp@allsky
INTEGER(KIND=JPIM) :: mdb_an_swp                ! an_swp@allsky
INTEGER(KIND=JPIM) :: mdb_an_rttov_cld_frac     ! an_rttov_cld_fraction@allsky

INTEGER(KIND=JPIM) :: mdb_gnorm_10mwind         ! gnorm_10mwind@allsky
INTEGER(KIND=JPIM) :: mdb_gnorm_skintemp        ! gnorm_skintemp@allsky
INTEGER(KIND=JPIM) :: mdb_gnorm_temp            ! gnorm_temp@allsky
INTEGER(KIND=JPIM) :: mdb_gnorm_q               ! gnorm_q@allsky
INTEGER(KIND=JPIM) :: mdb_gnorm_rainflux        ! gnorm_rainflux@allsky
INTEGER(KIND=JPIM) :: mdb_gnorm_snowflux        ! gnorm_snowflux@allsky
INTEGER(KIND=JPIM) :: mdb_gnorm_clw             ! gnorm_clw@allsky
INTEGER(KIND=JPIM) :: mdb_gnorm_ciw             ! gnorm_ciw@allsky
INTEGER(KIND=JPIM) :: mdb_gnorm_cc              ! gnorm_cc@allsky

INTEGER(KIND=JPIM) :: mdb_ob_p19                ! ob_p19@allsky
INTEGER(KIND=JPIM) :: mdb_fg_p19                ! fg_p19@allsky
INTEGER(KIND=JPIM) :: mdb_an_p19                ! an_p19@allsky
INTEGER(KIND=JPIM) :: mdb_ob_p37                ! ob_p37@allsky
INTEGER(KIND=JPIM) :: mdb_fg_p37                ! fg_p37@allsky
INTEGER(KIND=JPIM) :: mdb_an_p37                ! an_p37@allsky
INTEGER(KIND=JPIM) :: mdb_report_tbcloud        ! report_tbcloud@allsky
INTEGER(KIND=JPIM) :: mdb_tbvalue               ! tbvalue@allsky
INTEGER(KIND=JPIM) :: mdb_tbvaluead             ! tbvaluead@allsky
INTEGER(KIND=JPIM) :: mdb_tbvaluetl             ! tbvaluetl@allsky
INTEGER(KIND=JPIM) :: mdb_datum_tbflag          ! datum_tbflag@allsky

! Auxiliary table entries
INTEGER(KIND=JPIM) :: mdb_aux_at_auxiliary(jp_numaux) ! report_aux@auxiliary
INTEGER(KIND=JPIM) :: mdb_aux_at_auxiliary_body(jp_numaux) ! datum_aux@auxiliary_body

!*AF new entries in radiance table
INTEGER(KIND=JPIM) :: mdb_scanline_at_radiance          ! scanline@radiance
INTEGER(KIND=JPIM) :: mdb_scanpos_at_radiance           ! scanpos@radiance
INTEGER(KIND=JPIM) :: mdb_orbit_at_radiance             ! orbit@radiance
INTEGER(KIND=JPIM) :: mdb_typesurf_at_radiance          ! typesurf@radiance

!*** New @body entries proposed by Tony McNally [29/11/2002]  TO BE CLEANED for AIRS AND IASI ONLY!!!
INTEGER(KIND=JPIM) :: mdb_rank_cld_at_body ! 'rank_cld@body' 

