SUBROUTINE CNMIAD

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMINI   , ONLY : LINITER

#ifdef DOC

!**** *CNMIAD*  - CONTROL NORMAL MODE INITIALIZATION - ADJOINT

!     Purpose.
!     --------

!        To control the normal mode initialization.

!**   Interface.
!     ----------
!        *CALL* *CNMIAD

!        Explicit arguments :
!        --------------------
!        None

!        Implicit arguments :
!        --------------------
!        None

!     Method.
!     -------
!        See documentation

!     Externals.
!     ----------
!        *CMACAD*     -  NORMAL-MODE INITIALIZATION

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     Author.
!     -------
!        Florence Rabier *METEO FRANCE*

!     Modifications.
!     --------------
!        Original : 91-09-09
!        D. Giard : 99-07-19 LINITER moved from YOMNMIA to YOMINI
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      01-Dec-2003 CY28R1 Cleaning
!     ------------------------------------------------------------------
#endif

IMPLICIT NONE

REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "cmacad.intfb.h"
!      -----------------------------------------------------------

!*       1.    SET SWITCHES FOR INITIALIZATION.
!              --------------------------------

IF (LHOOK) CALL DR_HOOK('CNMIAD',0,ZHOOK_HANDLE)
LINITER = .TRUE.

!      -----------------------------------------------------------

!*       2.    NORMAL-MODE INITIALIZATION.
!              ---------------------------

!     Project the contents of the SP3 arrays onto normal-modes,
!     initialize and project initialized fields back into spectral space.

CALL CMACAD

!      -----------------------------------------------------------

!*       3.    RESET MODEL SWITCHES TO ORIGINAL SETTINGS.
!              ------------------------------------------

LINITER = .FALSE.
!      -----------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('CNMIAD',1,ZHOOK_HANDLE)
END SUBROUTINE CNMIAD

