SUBROUTINE CNMITL

!**** *CNMITL*  - CONTROL NORMAL MODE INITIALIZATION- Tangent linear.

!     Purpose.
!     --------

!        To control the normal mode initialization- Tangent linear.

!**   Interface.
!     ----------
!        *CALL* *CNMITL

!        Explicit arguments :
!        --------------------
!        None

!        Implicit arguments :
!        --------------------
!        None

!     Method.
!     -------
!        See documentation

!     Externals.
!     ----------
!        *CMACTL*     -  NORMAL-MODE INITIALIZATION

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     Author.
!     -------
!        F. Rabier    *Meteo France*

!     Modifications.
!     --------------
!        Original : 91-08-30
!        D. Giard : 99-07-19 LINITER moved from YOMNMIA to YOMINI
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      01-Dec-2003 CY28R1 Cleaning

!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMINI   , ONLY : LINITER

IMPLICIT NONE

REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "cmactl.intfb.h"
!      -----------------------------------------------------------

!*       1.    SET SWITCHES FOR INITIALIZATION.
!              --------------------------------

IF (LHOOK) CALL DR_HOOK('CNMITL',0,ZHOOK_HANDLE)
LINITER = .TRUE.

!      -----------------------------------------------------------

!*       2.    NORMAL-MODE INITIALIZATION.
!              ---------------------------

!     Project the contents of the SP3 arrays onto normal-modes,
!     initialize and project initialized fields back into spectral space.

CALL CMACTL

!      -----------------------------------------------------------

!*       3.    RESET MODEL SWITCHES TO ORIGINAL SETTINGS.
!              ------------------------------------------

LINITER = .FALSE.
!      -----------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('CNMITL',1,ZHOOK_HANDLE)
END SUBROUTINE CNMITL

