SUBROUTINE CNT2

!**** *CNT2*  -  Controls integration job at level 2.

!     Purpose.
!     --------
!           Controls integration job at level 2.

!**   Interface.
!     ----------
!        *CALL* *CNT2

!        Explicit arguments :
!        --------------------
!        None

!        Implicit arguments :
!        --------------------
!        None

!     Method.
!     -------
!        See documentation

!     Externals.    SU2YOM - initialize level 2 commons
!     ----------    CNT3   - controls direct integration on level 3

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     Author.
!     -------
!        Mats Hamrud and Philippe Courtier  *ECMWF*

!     Modifications.
!     --------------
!        Original : 87-10-15
!        Modified : 91-09-25 Jean-Noel THEPAUT. cleaning of TL and AD.
!        Modified : 96-09-25 Florence Rabier. allocation for nconf=801
!        Modified : 98-08    Thierry Bergot. allocation for nconf=601 
!        Modified : 03-09-30 C. Fischer remove call to suellt
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      01-Dec-2003 CY28R1 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMVAR, ONLY : LMODERR

IMPLICIT NONE

REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "cnt3.intfb.h"
#include "su2yom.intfb.h"
#include "suinimoderr.intfb.h"
!     ------------------------------------------------------------------

!*       1.    Initialization.
!              ---------------

!*       1.1   Initialize YOMCT2.


IF (LHOOK) CALL DR_HOOK('CNT2',0,ZHOOK_HANDLE)
CALL SU2YOM

IF (LMODERR) CALL SUINIMODERR

!     ------------------------------------------------------------------

!*       2.    Call level 3 control routine.
!              -----------------------------

CALL CNT3

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('CNT2',1,ZHOOK_HANDLE)
END SUBROUTINE CNT2
