SUBROUTINE CSTA

!**** *CSTA*  - START OF THE MODEL

!     Purpose.
!     --------

!**   Interface.
!     ----------
!        *CALL* *CSTA

!        Explicit arguments :
!        --------------------
!        None

!        Implicit arguments :
!        --------------------
!        None

!     Method.
!     -------
!        See documentation

!     Externals.    SUINIF - initialize model fields
!     ----------    NOR    - change orography

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     Author.
!     -------
!        Mats Hamrud and Philippe Courtier  *ECMWF*

!     Modifications.
!     --------------
!        Original : 87-10-15
!        M.Hamrud : 99-07-25 Remove LNOR
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        K.Yessad  : June 2006   Possibility to read purely gp ARPEGE files
!        M.Drusch      17-Jan-2007 introduce nconf 302
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCT0   , ONLY : LFPART2, NCONF   ,NPRINTLEV,LARPEGEF_RDGP_INIT
USE YOMLUN   , ONLY : NULOUT

!      -----------------------------------------------------------

IMPLICIT NONE
REAL(KIND=JPRB) :: ZHOOK_HANDLE

!      -----------------------------------------------------------

#include "suinif.intfb.h"

!      -----------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('CSTA',0,ZHOOK_HANDLE)

!      -----------------------------------------------------------

IF (.NOT.LFPART2) THEN
  IF (NCONF/100==0.OR.NCONF/100==2.OR.NCONF==302) THEN
    CALL SUINIF(0,LDRDGRIDSP=LARPEGEF_RDGP_INIT)
    IF (NPRINTLEV >=2) THEN
      WRITE(NULOUT,*) ' CSTA: SUINIF(0) called '
      CALL FLUSH(NULOUT)
    ENDIF
  ENDIF
ELSE
  CALL SUINIF(5)
  IF (NPRINTLEV >=2) THEN
    WRITE(NULOUT,*) ' CSTA: SUINIF(5) called '
    CALL FLUSH(NULOUT)
  ENDIF
ENDIF

!      -----------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('CSTA',1,ZHOOK_HANDLE)
END SUBROUTINE CSTA
