SUBROUTINE CTL1

!**** *CTL1*  - Controls the job to test tangent linear at linear 1.

!     PURPOSE.
!     --------
!           CONTROLS THE JOB AT LEVEL 1.
!           TEST OF THE TANGENT LINEAR

!**   INTERFACE.
!     ----------
!        *CALL* *CTL1

!        EXPLICIT ARGUMENTS :
!        --------------------
!        NONE

!        IMPLICIT ARGUMENTS :
!        --------------------
!        NONE

!     METHOD.
!     -------
!        SEE DOCUMENTATION

!     EXTERNALS.     TESTLI - LEVEL 2 CONTROL ROUTINE FOR TEST OF TAN. LIN.
!     ----------     SU1YOM - INITIALIZE LEVEL 1 COMMONS

!     REFERENCE.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     AUTHOR.
!     -------
!        Patrck Moll  *DMN*

!     MODIFICATIONS.
!     --------------
!        ORIGINAL : 89-04-15
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      01-Dec-2003 CY28R1 Cleaning

!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCT1   , ONLY : N1POS    ,N1GDI    ,N1SDI
USE YOMTLEVOL, ONLY : LTLEVOL

IMPLICIT NONE

REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "su1yom.intfb.h"
#include "testli.intfb.h"
#include "testlievol.intfb.h"

!     ------------------------------------------------------------------

!*       1.    INITIALIZE YOMCT1.
!              ------------------

IF (LHOOK) CALL DR_HOOK('CTL1',0,ZHOOK_HANDLE)
CALL SU1YOM
IF (LTLEVOL) THEN
  N1POS=1
ELSE
  N1POS=0
ENDIF

N1GDI=0
N1SDI=1
!      ------------------------------------------------------------------

!*       2.    CALL LEVEL 2 CONTROL ROUTINE.
!              -----------------------------

IF (LTLEVOL) THEN
  CALL TESTLIEVOL
ELSE
  CALL TESTLI
ENDIF

!      ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('CTL1',1,ZHOOK_HANDLE)
END SUBROUTINE CTL1
