SUBROUTINE RESET_SPERT(KSTEP)

!     PURPOSE
!     -------
!           RESET SURFACE PERTURBATIONS TO ZERO

!**   INTERFACE
!     ---------
!     *CALL* *RESETSPERT(
!    I                 KSTEP)
!     EXPLICIT ARGUMENTS
!     ------------------
!     KSTEP              - TIMESTEP                               (INPUT)

!     IMPLICIT ARGUMENTS :  NONE.
!     --------------------

!     AUTHOR.
!     -------
!        HANS HERSBACH *ECMWF*

!        ORIGINAL   : 26-11-2009
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMGEM   , ONLY : NGPTOT
USE YOMDIM   , ONLY : NPROMA
USE YOMLUN   , ONLY : NULOUT
USE SURFACE_FIELDS_MIX, ONLY : GPOPER, TYPE_SFL_COMM, YDUPD

IMPLICIT NONE

INTEGER(KIND=JPIM), INTENT(IN)      :: KSTEP

! Local variables
INTEGER(KIND=JPIM) ::JKGLO,IBL

REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('RESET_SPERT',0,ZHOOK_HANDLE)

WRITE(NULOUT,*)"RESET SURFACE PERTURBATIONS FOR NSTEP:",KSTEP
YDUPD%VALUE = 0.0_JPRB
YDUPD%L_OK  = .FALSE.

!$OMP PARALLEL DO SCHEDULE(DYNAMIC,1) PRIVATE(JKGLO,IBL)
DO JKGLO=1,NGPTOT,NPROMA
   IBL=(JKGLO-1)/NPROMA+1
   CALL GPOPER('SETPERTOVAL',KBL=IBL,YDCOM=YDUPD)
ENDDO
!$OMP END PARALLEL DO

!     ------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('RESET_SPERT',1,ZHOOK_HANDLE)
END SUBROUTINE RESET_SPERT
