MODULE CPLNG_FINALIZE_MOD

    IMPLICIT NONE

    PRIVATE

    PUBLIC CPLNG_FINALIZE

CONTAINS

SUBROUTINE CPLNG_FINALIZE
    
    USE PARKIND1, ONLY: JPIM
    USE MOD_OASIS
    USE CPLNG_DATA_MOD

    INTEGER(KIND=JPIM) :: IERROR
    CHARACTER(LEN=3)   :: CERRSTR

    ! Early exit if CPLNG not active
    IF (.NOT.CPLNG_ACTIVE) RETURN

    ! Finalize by calling OASIS terminate routine
    CALL OASIS_TERMINATE(IERROR)

    ! Check error code
    IF (IERROR/=OASIS_OK) THEN
        WRITE (CERRSTR,'(I3)') IERROR
        CALL ABOR1("CPLNG_FINALIZE: OASIS_TERMINATE returns error code: "//CERRSTR)
    ENDIF

END SUBROUTINE CPLNG_FINALIZE

END MODULE CPLNG_FINALIZE_MOD
