SUBROUTINE DEALLDFI(KULOUT)

!**** *DEALLDFI*  - Dellocate arrays used as accumulators by the digital
!     Purpose.
!     --------

!**   Interface.
!     ----------
!        *CALL* *DEALLDFI

!        Explicit arguments :
!        --------------------
!        KULOUT:  logical unit used for output

!        Implicit arguments :  Common YOMJCDFI
!        --------------------

!     Method.
!     -------

!     Externals.
!     ----------

!     Reference.
!     ----------

!     Author.
!     -------
!        P. Gauthier   *CNRM/GMAP*

!     Modifications.
!     --------------
!        Original : 98-10-21
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        Y.Tremolet    27-Nov-2008 Jc-DFI for long windows
!     ------------------------------------------------------------------
USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMJCDFI  , ONLY: RACCSPA3, RACCSPA2, RACCSPA1
USE YOMCT0  , ONLY: NPRINTLEV

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KULOUT 
LOGICAL :: LLALLOC,LLP
REAL(KIND=JPRB) :: ZHOOK_HANDLE

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('DEALLDFI',0,ZHOOK_HANDLE)
LLP = NPRINTLEV >= 1

LLALLOC = ALLOCATED(RACCSPA3 )
IF(LLALLOC) THEN
  IF(LLP) WRITE(KULOUT,*)'  DEALLDFI-  deallocating RACCSPA3'
  DEALLOCATE(RACCSPA3)
ENDIF

LLALLOC = ALLOCATED(RACCSPA2 )
IF(LLALLOC) THEN
  IF(LLP) WRITE(KULOUT,*)'  DEALLDFI-  deallocating RACCSPA2'
  DEALLOCATE(RACCSPA2)
ENDIF

LLALLOC = ALLOCATED(RACCSPA1 )
IF(LLALLOC) THEN
  IF(LLP) WRITE(KULOUT,*)'  DEALLDFI-  deallocating RACCSPA1'
  DEALLOCATE(RACCSPA1)
ENDIF

IF (LHOOK) CALL DR_HOOK('DEALLDFI',1,ZHOOK_HANDLE)
END SUBROUTINE DEALLDFI
