FUNCTION GEE(KL,KN)

!**** *GEE* -  Used by Remez exchange algorithm

!  Explicit arguments :  KL (Input) :  reference/current index
!  -------------------   KN (Input) :  number of points

!  Implicit arguments :  GRID , AD , AX , AY (Input)
!  -------------------   ( common YOMOPF )

!  Modifications :
!  -------------
!      G. Radnoti : 93-01-20  copy and adaptation
!      D. Giard   : 95-04-07  splitting,doctor form,single precision
!      M.Hamrud      01-Oct-2003 CY28 Cleaning
!      A.Bogatchev : 25-Oct-2007 removing of severe breaks of coding rools
!----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMOPF   , ONLY : AD       ,AX       ,AY       ,GRID     ,R2PI

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN) :: KL
INTEGER(KIND=JPIM),INTENT(IN) :: KN

REAL(KIND=JPRB) :: GEE

INTEGER(KIND=JPIM) :: J

REAL(KIND=JPRB) :: ZE, ZN, ZT, ZX
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('GEE',0,ZHOOK_HANDLE)
ZX = COS(R2PI*GRID(KL))
ZN = 0.0_JPRB
ZE = 0.0_JPRB
DO J =1,KN
  ZT = AD(J)/(ZX-AX(J))
  ZN = ZN+ZT
  ZE = ZE+ZT*AY(J)
ENDDO
GEE = ZE/ZN

IF (LHOOK) CALL DR_HOOK('GEE',1,ZHOOK_HANDLE)
END FUNCTION GEE
