SUBROUTINE PPSTAT

!**** *PPSTAT*  - Print post processing statistics

!     Purpose.
!     --------
!     Print post processing statistics

!        Explicit arguments :     
!        --------------------    

!     Method.
!     -------
!        See documentation

!     Externals.  
!     ----------

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     Author.
!     -------
!        George Mozdzynski *ECMWF*

!     Modifications.
!     --------------
!       Original : 97-10-15 
!        M.Hamrud      01-Oct-2003 CY28 Cleaning

!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMIO    , ONLY : NPPFILES ,NPPBUFWRI,RPPBUFWRT,RPPBUFWAT
USE YOMLUN   , ONLY : NULOUT

IMPLICIT NONE

INTEGER(KIND=JPIM) :: IWRI, J

LOGICAL :: LLHEAD

REAL(KIND=JPRB) :: ZTOT, ZWAT, ZWRT
REAL(KIND=JPRB) :: ZHOOK_HANDLE

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('PPSTAT',0,ZHOOK_HANDLE)
IWRI=0
ZWRT=0.0_JPRB
ZWAT=0.0_JPRB
ZTOT=0.0_JPRB
LLHEAD=.TRUE.
DO J=1,NPPFILES
  IF( NPPBUFWRI(J) > 0 )THEN
    IF( LLHEAD )THEN
      WRITE(NULOUT,'(" ")')
      WRITE(NULOUT,'("POST PROCESSING STATISTICS")')
      WRITE(NULOUT,'(" ")')
      WRITE(NULOUT,'("  FILE  WRITES  WRITE_TIME  WAIT_TIME"," TOTAL_TIME")')
      LLHEAD=.FALSE.
    ENDIF
    WRITE(NULOUT,'(3X,I2,2X,I6,3(3X,F8.3))')&
     & J,NPPBUFWRI(J),RPPBUFWRT(J),RPPBUFWAT(J),&
     & RPPBUFWRT(J)+RPPBUFWAT(J)  
    IWRI=IWRI+NPPBUFWRI(J)
    ZWRT=ZWRT+RPPBUFWRT(J)
    ZWAT=ZWAT+RPPBUFWAT(J)
    ZTOT=ZTOT+RPPBUFWRT(J)+RPPBUFWAT(J)
  ENDIF
ENDDO
IF( IWRI > 0 )THEN
  WRITE(NULOUT,'("TOTAL",2X,I6,3(3X,F8.3))')IWRI,ZWRT,ZWAT,ZTOT
ENDIF

IF (LHOOK) CALL DR_HOOK('PPSTAT',1,ZHOOK_HANDLE)
END SUBROUTINE PPSTAT
