SUBROUTINE SUFPCUF

!**** *SUFPCUF*  - 

!     PURPOSE.
!     --------
!     CUF diagnostics (for monitoring of update frequency of the ALADIN
!     coupling files): update TFP_CUF... and TFP_DYNDS(TFP_CUF...).


!**   INTERFACE.
!     ----------
!       *CALL* *SUFPCUF*

!        EXPLICIT ARGUMENTS
!        --------------------

!        IMPLICIT ARGUMENTS
!        --------------------
      

!     METHOD.
!     -------
!        SEE DOCUMENTATION

!     EXTERNALS.
!     ----------

!     AUTHOR.
!     -------
!        Rachida El Ouaraini & Ryad El Khatib : 05-07-29

!     MODIFICATIONS.
!     --------------
!     K. Yessad (Dec 2008): add comments + cleanings
!-----------------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK      ,DR_HOOK
USE YOMAFN   , ONLY : TFP_DYNDS  ,TFP_CUF1  ,TFP_CUF2  ,TFP_CUF3  ,TFP_CUF4  ,&
 & TFP_CUF5
USE YOMMCUF  , ONLY : LREACUF    ,NCUFNR

!-----------------------------------------------------------------------------

IMPLICIT NONE

REAL(KIND=JPRB) :: ZHOOK_HANDLE

!-----------------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('SUFPCUF',0,ZHOOK_HANDLE)
!-----------------------------------------------------------------------------

IF (LREACUF) THEN
  IF (NCUFNR >=1) THEN
    TFP_CUF1%ILMOD=1
    TFP_DYNDS(TFP_CUF1%ICOD)%ILMOD=1
  ENDIF
  IF (NCUFNR >=2) THEN
    TFP_CUF2%ILMOD=1
    TFP_DYNDS(TFP_CUF2%ICOD)%ILMOD=1
  ENDIF
  IF (NCUFNR >=3) THEN
    TFP_CUF3%ILMOD=1
    TFP_DYNDS(TFP_CUF3%ICOD)%ILMOD=1
  ENDIF
  IF (NCUFNR >=4) THEN
    TFP_CUF4%ILMOD=1
    TFP_DYNDS(TFP_CUF4%ICOD)%ILMOD=1
  ENDIF
  IF (NCUFNR >=5) THEN
    TFP_CUF5%ILMOD=1
    TFP_DYNDS(TFP_CUF5%ICOD)%ILMOD=1
  ENDIF
ENDIF

!-----------------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('SUFPCUF',1,ZHOOK_HANDLE)
END SUBROUTINE SUFPCUF
