SUBROUTINE SUFPIOS

!**** *SUFPIOS* - SET UP FULLPOS I/O SCHEME

!     Purpose.   TO SET UP COMMMON BLOCK YOMFPIOS WHICH CONTAINS   -
!     --------   PARAMETERS FOR USING THE MIO PACKAGE ON WORK
!                FILES. OPENS WORK FILES.
!                SET UP CONTROL ARRAYS AND LENGHTS OF BUFFERS
!                IF NO WORKFILES

!**   Interface.
!     ----------
!        *CALL* *SUFPIOS*

!        Explicit arguments :  None.
!        --------------------

!        Implicit arguments :
!        --------------------
!         See modules above.

!     Method.
!     -------

!     Externals.
!     ----------
!       SUFPSC2B.

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS
!        Documentaion of the MIO package

!     Author.
!     -------
!        RYAD EL KHATIB *METEO-FRANCE*

!     Modifications.
!     --------------
!        ORIGINAL : 94-04-08
!        Modified : 95-11-08 R. El Khatib (NFPXFLD moved to YOMFPIOS)
!        Modified : 95-11-08 R. El Khatib (Cray switch)
!        Modified by K. YESSAD (MARCH 1997): parallelisation of FULL-POS.
!        Modified : 98-09-09 G. Radnoti (I/O scheme for EZONE)
!        R. El Khatib : 98-10-08 New purpose for SUFPSC2B
!        D.Dent       : 00-01-10 Control printouts with LTRACEFP 
!        R. El Khatib : 01-08-07 Pruning options
!    R. El Khatib : 02-21-20 Fullpos B-level distribution + remove IO scheme
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMLUN   , ONLY : NULOUT   ,NULNAM
USE YOMFPIOS , ONLY : NFPXFLD

IMPLICIT NONE

#include "namfpios.h"
!     ------------------------------------------------------------------

!*       1.    I/O PARAMETERS UNDER USER CONTROL.
!              ----------------------------------

!*       1.1   SET DEFAULT VALUE (< 0 <=> max value)

REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "posnam.intfb.h"
IF (LHOOK) CALL DR_HOOK('SUFPIOS',0,ZHOOK_HANDLE)
NFPXFLD=-999

!*       1.2   READ NAMELIST.

CALL POSNAM(NULNAM,'NAMFPIOS')
READ(NULNAM,NAMFPIOS)

!*       4.  PRINT OUT FINAL VALUES

WRITE(UNIT=NULOUT,FMT='(A)') ' '
WRITE(NULOUT,'('' SUFPIOS PRINTS OUT'')')
WRITE(NULOUT,'('' NFPXFLD = '',I6)') NFPXFLD

IF (LHOOK) CALL DR_HOOK('SUFPIOS',1,ZHOOK_HANDLE)
END SUBROUTINE SUFPIOS
