SUBROUTINE SUFPPHQ

!**** *SUFPPHQ  * - ROUTINE TO INITIALIZE THE CONTROL OF POST-PROCESS
!                   OF PHYSICAL QUANTITIES

!**   INTERFACE.
!     ----------
!        *CALL* *SUFPPHQ*

!     EXPLICIT ARGUMENTS :  KULOUT
!     --------------------

!     IMPLICIT ARGUMENTS :
!     --------------------

!     METHOD.
!     -------

!     EXTERNALS.
!     ----------

!     REFERENCE.
!     ----------
!        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE IFS

!     AUTHOR.
!     -------
!        G.HELLO 07/07

!     MODIFICATIONS.
!     --------------
!        ORIGINAL : 07/07
!------------------------------------------------------------------------
USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCT0    ,ONLY : LFPOS 
USE YOMAFN    ,ONLY : TFP_MSAT7C1,TFP_MSAT7C2,&
 & TFP_MSAT8C1,TFP_MSAT8C2,TFP_MSAT8C3,TFP_MSAT8C4,&
 & TFP_MSAT8C5,TFP_MSAT8C6,TFP_MSAT8C7,TFP_MSAT8C8,&
 & TFP_MSAT9C1,TFP_MSAT9C2,TFP_MSAT9C3,TFP_MSAT9C4,&
 & TFP_MSAT9C5,TFP_MSAT9C6,TFP_MSAT9C7,TFP_MSAT9C8,&
 & TFP_GOES11C1,TFP_GOES11C2,TFP_GOES11C3,TFP_GOES11C4,&
 & TFP_GOES12C1,TFP_GOES12C2,TFP_GOES12C3,TFP_GOES12C4,&
 & TFP_MTSAT1C1,TFP_MTSAT1C2,TFP_MTSAT1C3,TFP_MTSAT1C4
USE YOMFPC    ,ONLY : CFP2DF, NFP2DF
USE YOMMTS    ,ONLY : LMTS,LMTSCL

IMPLICIT NONE
INTEGER(KIND=JPIM) :: JFLD
REAL(KIND=JPRB) :: ZHOOK_HANDLE
! ------------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('SUFPPHQ',0,ZHOOK_HANDLE)
LMTS=.FALSE.
LMTSCL=.FALSE.
IF (LFPOS) THEN
  DO JFLD=1,NFP2DF
     IF (  CFP2DF(JFLD) == TFP_MSAT7C1%CLNAME .OR. CFP2DF(JFLD) == TFP_MSAT7C2%CLNAME .OR. &
       & CFP2DF(JFLD) == TFP_MSAT8C1%CLNAME .OR. CFP2DF(JFLD) == TFP_MSAT8C2%CLNAME .OR. &
       & CFP2DF(JFLD) == TFP_MSAT8C3%CLNAME .OR. CFP2DF(JFLD) == TFP_MSAT8C4%CLNAME .OR. &
       & CFP2DF(JFLD) == TFP_MSAT8C5%CLNAME .OR. CFP2DF(JFLD) == TFP_MSAT8C6%CLNAME .OR. &
       & CFP2DF(JFLD) == TFP_MSAT8C7%CLNAME .OR. CFP2DF(JFLD) == TFP_MSAT8C8%CLNAME .OR. &
       & CFP2DF(JFLD) == TFP_MSAT9C1%CLNAME .OR. CFP2DF(JFLD) == TFP_MSAT9C2%CLNAME .OR. &
       & CFP2DF(JFLD) == TFP_MSAT9C3%CLNAME .OR. CFP2DF(JFLD) == TFP_MSAT9C4%CLNAME .OR. &
       & CFP2DF(JFLD) == TFP_MSAT9C5%CLNAME .OR. CFP2DF(JFLD) == TFP_MSAT9C6%CLNAME .OR. &
       & CFP2DF(JFLD) == TFP_MSAT9C7%CLNAME .OR. CFP2DF(JFLD) == TFP_MSAT9C8%CLNAME .OR. &
       & CFP2DF(JFLD) == TFP_GOES11C1%CLNAME .OR. CFP2DF(JFLD) == TFP_GOES11C2%CLNAME .OR. &
       & CFP2DF(JFLD) == TFP_GOES11C3%CLNAME .OR. CFP2DF(JFLD) == TFP_GOES11C4%CLNAME .OR. &
       & CFP2DF(JFLD) == TFP_GOES12C1%CLNAME .OR. CFP2DF(JFLD) == TFP_GOES12C2%CLNAME .OR. &
       & CFP2DF(JFLD) == TFP_GOES12C3%CLNAME .OR. CFP2DF(JFLD) == TFP_GOES12C4%CLNAME .OR. &
       & CFP2DF(JFLD) == TFP_MTSAT1C1%CLNAME .OR. CFP2DF(JFLD) == TFP_MTSAT1C2%CLNAME .OR. &
       & CFP2DF(JFLD) == TFP_MTSAT1C3%CLNAME .OR. CFP2DF(JFLD) == TFP_MTSAT1C4%CLNAME      &
       &) THEN
      LMTS=.TRUE.
      LMTSCL=.TRUE.
    ENDIF
  ENDDO
ENDIF

IF (LHOOK) CALL DR_HOOK('SUFPPHQ',1,ZHOOK_HANDLE)
END SUBROUTINE SUFPPHQ


