!*
!     ------------------------------------------------------------------
#ifdef DOC
!     TANGENT LINEAR OF THERMODYNAMICAL FUNCTIONS .

!     Pressure of water vapour at saturation
!        INPUT : PTARET = TEMPERATURE PERTURBATION
!                PTARE5 = TRAJECTORY TEMPERATURE
!                PALFATL= TL OF THE ALFA OPERATOR
#endif
REAL(KIND=JPRB) :: FESW,FESI,FESWTL,FESITL,FOEEWMTL,FOEEWMOTL
REAL(KIND=JPRB) :: FOEALFATL,FOEALFCUTL,FOELHMTL,FOELHMCUTL
REAL(KIND=JPRB) :: FOEEWMCUTL
REAL(KIND=JPRB) :: PTARET,PTARE5,PALFATL

FESW(PTARET) = R2ES * EXP(R3LES*(PTARET-RTT)/(PTARET-R4LES))
FESI(PTARET) = R2ES * EXP(R3IES*(PTARET-RTT)/(PTARET-R4IES))

FESWTL(PTARET,PTARE5) = R3LES*(RTT-R4LES)/(PTARE5-R4LES)**2 *&
                      &PTARET * FESW(PTARE5)
FESITL(PTARET,PTARE5) = R3IES*(RTT-R4IES)/(PTARE5-R4IES)**2 *&
                      &PTARET * FESI(PTARE5)
FOEEWMTL(PTARET,PTARE5,PALFATL) =&
                  &FOEALFA(PTARE5)*FESWTL(PTARET,PTARE5) +&
                  &FESW(PTARE5)*PALFATL +&
                  &(1.0_JPRB-FOEALFA(PTARE5))*FESITL(PTARET,PTARE5) -&
                  &FESI(PTARE5)*PALFATL

FOEEWMCUTL(PTARET,PTARE5,PALFATL) =&
                  &FOEALFCU(PTARE5)*FESWTL(PTARET,PTARE5) +&
                  &FESW(PTARE5)*PALFATL +&
                  &(1.0_JPRB-FOEALFCU(PTARE5))*FESITL(PTARET,PTARE5) -&
                  &FESI(PTARE5)*PALFATL

FOEEWMOTL(PTARET,PTARE5)=FESWTL(PTARET,PTARE5)

FOEALFATL(PTARET,PTARE5) = (0.5_JPRB+SIGN(0.5_JPRB,PTARE5-RTICE)) &
              & * (0.5_JPRB-SIGN(0.5_JPRB,PTARE5-RTWAT)) & 
              & * 2.0_JPRB*(PTARE5-RTICE)*PTARET/(RTWAT-RTICE)**2

FOEALFCUTL(PTARET,PTARE5) = (0.5_JPRB+SIGN(0.5_JPRB,PTARE5-RTICECU)) &
              & * (0.5_JPRB-SIGN(0.5_JPRB,PTARE5-RTWAT)) & 
              & * 2.0_JPRB*(PTARE5-RTICECU)*PTARET*(RTWAT_RTICECU_R)**2

FOELHMTL(PTARET,PTARE5) = FOEALFATL(PTARET,PTARE5)*(RLVTT-RLSTT)

FOELHMCUTL(PTARET,PTARE5) = FOEALFCUTL(PTARET,PTARE5)*(RLVTT-RLSTT)
