INTERFACE
  SUBROUTINE CMIP6_PIAER_MXR_INTERP & 
 &( KIDIA , KFDIA , KLON , KLEV, &
 & KRINT , KSHIFT, &
 & PAPRS , PGELAM, PSINLAT  ,&
 & PINUM_KS,  PINUM_AS,  PINUM_CS, &
 & PIMSO4_KS, PIMSO4_AS, PIMSO4_CS, &
 & PIMBC_KS,  PIMBC_AS,  PIMBC_CS, PIMBC_KI, &
 & PIMOC_KS,  PIMOC_AS,  PIMOC_CS, PIMOC_KI, &
 & PIMSS_AS,  PIMSS_CS, &
 & PIMDU_AS,  PIMDU_CS,  PIMDU_AI, PIMDU_CI, &
 & PIMNO3,    PIMMSA )


    !--- inherited types, functions and data
    USE PARKIND1  ,ONLY : JPIM     ,JPRB
    USE YOMHOOK, ONLY : LHOOK, DR_HOOK
    USE YOMLUN,  ONLY : NULOUT
    USE YOMRIP,  ONLY : NINDAT, NSTADD

    USE YOMCST,  ONLY : RPI    
    USE YOMMP,   ONLY : MYPROC

    USE YOMDIM,  ONLY: NPROMA, NFLEVG, NGPBLKS
    USE YOMGEM, ONLY : NGPTOT
    USE YOERAD, ONLY : NRPROMA
    USE YOERAD, ONLY : TM5_NLON , TM5_NLAT, TM5_NLEV , TM5_NMON , NWVL,        &
&                      TM5_LON, TM5_LAT, TM5_LEV, TM5_HYA, TM5_HYB, TM5_HYAI,  &
&                      TM5_HYBI, TM5_P0, TM5_PS, TM5_PPS, TM5_PPSF,            &
&                      TM5_NUM_KS,  TM5_NUM_AS,  TM5_NUM_CS,                   &
&                      TM5_MSO4_KS, TM5_MSO4_AS, TM5_MSO4_CS,                  &
&                      TM5_MBC_KS,  TM5_MBC_AS,  TM5_MBC_CS, TM5_MBC_KI,       &
&                      TM5_MOC_KS,  TM5_MOC_AS,  TM5_MOC_CS, TM5_MOC_KI,       &
&                      TM5_MSS_AS,  TM5_MSS_CS,                                &
&                      TM5_MDU_AS,  TM5_MDU_CS,  TM5_MDU_AI, TM5_MDU_CI,       &
&                      TM5_MNO3,    TM5_MMSA    


    USE YOMCT3   , ONLY : NSTEP

    IMPLICIT NONE

     INTEGER(KIND=JPIM),INTENT(IN)    :: KLON 
     INTEGER(KIND=JPIM),INTENT(IN)    :: KLEV 
     INTEGER(KIND=JPIM),INTENT(IN)    :: KIDIA 
     INTEGER(KIND=JPIM),INTENT(IN)    :: KFDIA 
     INTEGER(KIND=JPIM),INTENT(IN)    :: KRINT 
     INTEGER(KIND=JPIM),INTENT(IN)    :: KSHIFT 
     REAL(KIND=JPRB)   ,INTENT(IN)    :: PAPRS(KLON,KLEV+1) 
     REAL(KIND=JPRB)   ,INTENT(IN)    :: PGELAM(KLON)
     REAL(KIND=JPRB)   ,INTENT(IN)    :: PSINLAT(KLON)

     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PINUM_KS(KLON,KLEV)
     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PINUM_AS(KLON,KLEV)
     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PINUM_CS(KLON,KLEV)

     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PIMSO4_KS(KLON,KLEV)
     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PIMSO4_AS(KLON,KLEV)
     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PIMSO4_CS(KLON,KLEV)

     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PIMBC_KS(KLON,KLEV)
     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PIMBC_AS(KLON,KLEV)
     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PIMBC_CS(KLON,KLEV)
     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PIMBC_KI(KLON,KLEV)

     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PIMOC_KS(KLON,KLEV)
     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PIMOC_AS(KLON,KLEV)
     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PIMOC_CS(KLON,KLEV)
     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PIMOC_KI(KLON,KLEV)

     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PIMSS_AS(KLON,KLEV)
     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PIMSS_CS(KLON,KLEV)

     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PIMDU_AS(KLON,KLEV)
     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PIMDU_CS(KLON,KLEV)
     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PIMDU_AI(KLON,KLEV)
     REAL(KIND=JPRB)   ,INTENT(OUT)   :: PIMDU_CI(KLON,KLEV)

     REAL(KIND=JPRB)   ,OPTIONAL, INTENT(OUT)   :: PIMNO3(KLON,KLEV)
     REAL(KIND=JPRB)   ,OPTIONAL, INTENT(OUT)   :: PIMMSA(KLON,KLEV)

END   SUBROUTINE CMIP6_PIAER_MXR_INTERP
END INTERFACE
