INTERFACE
SUBROUTINE CMIP6_STRATO_AERO_PROCESS                      &
&( KIDIA , KFDIA , KLON , KLEV,                           &
& KRINT , KSHIFT,                                         &
& KINDAT,KSTADD,                                          &
& PAPF, PAPRS , ZPT, ZPTH, PGEMU, PGELAM,                 &
& STRATAOD_M, STRATAAOD_M, STRATREFAOD_M, STRATAAOD_LW_M, &
& STRATAOD , STRATAAOD , STRATREFAOD, STRATAAOD_LW, TROPOPAUSE)

USE YOERAD ,ONLY : STRATO_CMIP6_NLAT,STRATO_CMIP6_NALT,STRATO_CMIP6_NTIME, &
                & STRATO_CMIP6_ALT,STRATO_CMIP6_LAT,STRATO_CMIP6_SB,STRATO_CMIP6_TB,&
                & STRATO_CMIP6_NSB,STRATO_CMIP6_NTB,STRATO_CMIP6_NMONTH

USE YOMCT0   , ONLY : LTWOTL ,LNF
USE YOMDYN   , ONLY : TSTEP
USE YOMCT2   , ONLY : NSTAR2
USE YOMCST   , ONLY : RDAY
USE YOMLUN   , ONLY : NULOUT
USE PARKIND1 , ONLY : JPIM,JPRB
USE YOMHOOK, ONLY : LHOOK, DR_HOOK
USE YOMCST   , ONLY : RD, RG

INTEGER(KIND=JPIM),INTENT(IN)    :: KLON 
INTEGER(KIND=JPIM),INTENT(IN)    :: KLEV 
INTEGER(KIND=JPIM),INTENT(IN)    :: KIDIA 
INTEGER(KIND=JPIM),INTENT(IN)    :: KFDIA 
INTEGER(KIND=JPIM),INTENT(IN)    :: KRINT 
INTEGER(KIND=JPIM),INTENT(IN)    :: KSHIFT
INTEGER(KIND=JPIM),INTENT(IN)    :: KINDAT
INTEGER(KIND=JPIM),INTENT(IN)    :: KSTADD
REAL(KIND=JPRB)   ,INTENT(IN)    :: PAPF(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PAPRS(KLON,KLEV+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: ZPT(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(IN)    :: ZPTH(KLON,KLEV+1)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGELAM(KLON)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGEMU(KLON)
REAL(KIND=JPRB)   ,INTENT(IN)    :: STRATAOD_M(KLON,KLEV,STRATO_CMIP6_NSB,STRATO_CMIP6_NMONTH)
REAL(KIND=JPRB)   ,INTENT(IN)    :: STRATAAOD_M(KLON,KLEV,STRATO_CMIP6_NSB,STRATO_CMIP6_NMONTH)
REAL(KIND=JPRB)   ,INTENT(IN)    :: STRATREFAOD_M(KLON,KLEV,STRATO_CMIP6_NSB,STRATO_CMIP6_NMONTH)
REAL(KIND=JPRB)   ,INTENT(IN)    :: STRATAAOD_LW_M(KLON,KLEV,STRATO_CMIP6_NTB,STRATO_CMIP6_NMONTH)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: STRATAOD(KLON,KLEV,STRATO_CMIP6_NSB)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: STRATAAOD(KLON,KLEV,STRATO_CMIP6_NSB)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: STRATREFAOD(KLON,KLEV,STRATO_CMIP6_NSB)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: STRATAAOD_LW(KLON,KLEV,STRATO_CMIP6_NTB)
INTEGER(KIND=JPIM),INTENT(OUT)   :: TROPOPAUSE(KLON)
END SUBROUTINE CMIP6_STRATO_AERO_PROCESS
END INTERFACE
