MODULE PARCLI

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!------------------------------------------------------------------------------
!     JPNAV : Number of latitude of the NAVY grid.
!     JPPOCP: Number of latitude of the NAVY grid in polar caps.
!     JPAUT : Number of latitude of the N108 grids.
!     JPNMOI: Number of months to be processed.
!     JPNFIN: Number of fixed fields in the *NAVY* data
!     JPNFIS: Number of fixed fields in the *N108* data
!     JPNMOS: Number of monthly fields in the *N108* data
!     JPNFIF: Number of fixed fields in the final data
!     JPNMOF: Number of monthly fields in the final data
!     JPNFCS: Number of fixed fields in the *N108* data which are indifferent
!             to the land/sea distribution
!     JPNFCF: Number of fixed fields in the final data which are indifferent
!             to the land/sea distribution
!     PPTSHT: Shift (in radians) of the deep yearly temperature wave.
!     PPWSHT: Shift (in radians) of the deep yearly water content wave.
!     JPLDAT: Dimension of the array *IDATEF*.

INTEGER(KIND=JPIM), PARAMETER :: JPNAV=1080
INTEGER(KIND=JPIM), PARAMETER :: JPPOCP=120
INTEGER(KIND=JPIM), PARAMETER :: JPAUT=216
INTEGER(KIND=JPIM), PARAMETER :: JPINT=2*JPAUT+4
INTEGER(KIND=JPIM), PARAMETER :: JPJNT=JPAUT+4
INTEGER(KIND=JPIM), PARAMETER :: JPNFIN=7
INTEGER(KIND=JPIM), PARAMETER :: JPNFIS=13
INTEGER(KIND=JPIM), PARAMETER :: JPNMOS=5
INTEGER(KIND=JPIM), PARAMETER :: JPNFIF=11
INTEGER(KIND=JPIM), PARAMETER :: JPNMOF=7
INTEGER(KIND=JPIM), PARAMETER :: JPNMOI=12
INTEGER(KIND=JPIM), PARAMETER :: JPNFCS=7
INTEGER(KIND=JPIM), PARAMETER :: JPNFCF=5
REAL(KIND=JPRB)   , PARAMETER :: PPTSHT=0.0786_JPRB
REAL(KIND=JPRB)   , PARAMETER :: PPWSHT=0.1969_JPRB
INTEGER(KIND=JPIM), PARAMETER :: JPLDAT=11

END MODULE PARCLI
