MODULE PARCMA
!ODB LEVEL 22R1
!ODB SET $MDI = 2147483647
!==ODB ALIAS tovs IS rtovs
USE PARKIND1  ,ONLY : JPIM 

USE PARDIMO, ONLY : JPXTIM, JPNOTP, JPNUMV

IMPLICIT NONE

SAVE

!*    PARCMA - CMA VARIOUS PARAMETERS

!        D. VASILJEVIC    ECMWF    19/09/94

!     NAME                    MEANING
!     ----                    -------

!     CMA ARRAY/FILE PARAMETERS:
!     ---------------------

!     JPMXGICL    MAX. LEN. OF "GLOBAL" INTEGER CMA ARRAY
!     JPMXGRCL    MAX. LEN. OF "GLOBAL" REAL CMA ARRAY
!     JPMXICRL    MAX. LEN. OF INPUT CMA REPORT
!     JPMXICHL    MAX. LEN. OF INPUT CMA REPORT HEADER
!     JPMXICBL    MAX. LEN. OF INPUT CMA REPORT BODY ENTRY
!     JPMXICDL    MAX. LEN. OF INPUT CMA  DDR
!     JPMXOCRL    MAX. LEN. OF OUTPUT CMA REPORT
!     JPMXOCHL    MAX. LEN. OF OUTPUT CMA REPORT HEADER
!     JPMXOCBL    MAX. LEN. OF OUTPUT CMA REPORT BODY ENTRY
!     JPMXOCDL    MAX. LEN. OF OUTPUT CMA  DDR
!     JPMXDEPL    MAX. LEN. OF DEPARTURE LIST

INTEGER(KIND=JPIM) :: JPMXGICL
INTEGER(KIND=JPIM) :: JPMXGRCL
INTEGER(KIND=JPIM) :: JPMXICRL
INTEGER(KIND=JPIM) :: JPMXICHL
INTEGER(KIND=JPIM) :: JPMXICBL
INTEGER(KIND=JPIM) :: JPMXICDL
INTEGER(KIND=JPIM) :: JPMXOCRL
INTEGER(KIND=JPIM) :: JPMXOCHL
INTEGER(KIND=JPIM) :: JPMXOCBL
INTEGER(KIND=JPIM) :: JPMXOCDL
INTEGER(KIND=JPIM) :: JPMXDEPL
PARAMETER (JPMXGICL=1)
PARAMETER (JPMXGRCL=2000000)
PARAMETER (JPMXICRL=164811)
PARAMETER (JPMXICHL=581)
PARAMETER (JPMXICBL=72)
PARAMETER (JPMXICDL=3072)
PARAMETER (JPMXOCRL=164811)
PARAMETER (JPMXOCHL=581)
PARAMETER (JPMXOCBL=72)
PARAMETER (JPMXOCDL=3072)
PARAMETER (JPMXDEPL=319)

!-----------------------------------------------------------------------

!     CMA EVENTS, FLAGS, CODES ETC. PARAMETERS:
!     -----------------------------------------

!     JPMXLID     MAX. NO. OF LEVEL ID CODES
!     JPMXPCD     MAX. NO. OF PRESSURE CODES
!     JPMXRE1     MAX. NO. REPORT (PART 1) EVENTS
!     JPMXRE2     MAX. NO. REPORT (PART 2) EVENTS
!     JPMXDE1     MAX. NO. DATUM (PART 1) EVENTS
!     JPMXDE2     MAX. NO. DATUM (PART 2) EVENTS
!     JPMXRBLE    MAX. NO. REPORT BLACKLIST EVENTS
!     JPMXDBLE    MAX. NO. DATUM BLACKLIST EVENTS
!     JPMXRDF     MAX. NO. RDB REPORT FLAGS
!     JPMXDDF     MAX. NO. RDB PRESSURE/VARIABLE FLAGS
!     JPMXADF     MAX. NO. ANALYSIS VARIABLE FLAGS
!     JPMXSBI1    MAX. NO. OF SATOB I1 CODES
!     JPMXSBI2    MAX. NO. OF SATOB I2I2 CODES
!     JPMXSMI2    MAX. NO. OF SATEM I2 CODES
!     JPMXSMV     MAX. NO. OF SATEM V CODES
!     JPMXSMW     MAX. NO. OF SATEM W CODES
!     JPMXSMX     MAX. NO. OF SATEM X CODES
!     JPMXSMY     MAX. NO. OF SATEM Y CODES
!     JPMXSMA     MAX. NO. OF SATEM A CODES
!     JPMXSMB     MAX. NO. OF SATEM B CODES
!     JPMXSMC     MAX. NO. OF SATEM C CODES

INTEGER(KIND=JPIM) :: JPMXLID
INTEGER(KIND=JPIM) :: JPMXPCD
INTEGER(KIND=JPIM) :: JPMXRE1
INTEGER(KIND=JPIM) :: JPMXRE2
INTEGER(KIND=JPIM) :: JPMXDE1
INTEGER(KIND=JPIM) :: JPMXDE2
INTEGER(KIND=JPIM) :: JPMXRBLE
INTEGER(KIND=JPIM) :: JPMXDBLE
INTEGER(KIND=JPIM) :: JPMXRDF
INTEGER(KIND=JPIM) :: JPMXDDF
INTEGER(KIND=JPIM) :: JPMXADF
INTEGER(KIND=JPIM) :: JPMXSBI2
INTEGER(KIND=JPIM) :: JPMXSMI2
INTEGER(KIND=JPIM) :: JPMXSMV
INTEGER(KIND=JPIM) :: JPMXSMW
INTEGER(KIND=JPIM) :: JPMXSMX
INTEGER(KIND=JPIM) :: JPMXSMY
INTEGER(KIND=JPIM) :: JPMXSMA
INTEGER(KIND=JPIM) :: JPMXSMB
INTEGER(KIND=JPIM) :: JPMXSMC
INTEGER(KIND=JPIM) :: JPMXSBI1
PARAMETER (JPMXLID=9)
PARAMETER (JPMXPCD=13)
PARAMETER (JPMXRE1=30)
PARAMETER (JPMXRE2=30)
PARAMETER (JPMXDE1=30)
PARAMETER (JPMXDE2=30)
PARAMETER (JPMXRBLE=31)
PARAMETER (JPMXDBLE=30)
PARAMETER (JPMXRDF=5)
PARAMETER (JPMXDDF=7)
PARAMETER (JPMXADF=7)
PARAMETER (JPMXSBI2=5)
PARAMETER (JPMXSMI2=4)
PARAMETER (JPMXSMV=3)
PARAMETER (JPMXSMW=3)
PARAMETER (JPMXSMX=5)
PARAMETER (JPMXSMY=7)
PARAMETER (JPMXSMA=3)
PARAMETER (JPMXSMB=3)
PARAMETER (JPMXSMC=3)
PARAMETER (JPMXSBI1=5)

!-----------------------------------------------------------------------

!     CMA NO. OF OBS./CODE TYPES, UPDATES, ADD. DEP. ETC. PARAMETERS:
!     --------------------------------------------------------------

!     JPMXOTP     MAX. NO. OF OBS. TYPES
!     JPMXOCT     MAX. NO. OF OBS. CODE TYPES
!     JPMXUP      MAX. NO. UPDATES
!     JPMXENDA    MAX. NO. ensembles
!     JPMXAD      MAX. NO. OF ADDITIONAL DEPARTURES
!     JPMXVAR     MAX. NO. OF CMA VARIABLES
!     JPMXTOCH    MAX. NO. RAD1C CHANNELS (was TOVS CHANNELS)
!     JPMXSSCH    MAX. NO. SSMI CHANNELS
!     JPMXTRCH    MAX. NO. TRMM CHANNELS
!     JPXSFPTS    MAX. NO. OF SIM. OBS. FILES PER 6HR TIME SLOT
!     JPXTSL      MAX. NO. OF OUTPUT/INPUT TIME SLOTS
!     JPXCMA      MAX. NO. OF OUTPUT/INPUT CMA FILES
!     JPXSATS     MAX. NO. OF SATELLITES
!     JPMX_SATOB_WEIGHT  MAX. NO. OF WEIGHT LEVELS FOR SATOB/AMVs
!     JPMX_LIMB_TAN      MAX. NO. OF TANS IN LIMB TABLE
!     JPMX_AK      MAX. elements of averaging kernels for reo3 data
!     JPMX_RADAR_NIV     MAX. NO. OF LEVELS IN RADAR TABLE
!     JP_NUMEV      MAX. NO. OF RETAINED EIGENVECTORS OF OBS ERR CORR MATRIX
INTEGER(KIND=JPIM) :: JPMXOTP
INTEGER(KIND=JPIM) :: JPMXOCT
INTEGER(KIND=JPIM) :: JPMXUP
INTEGER(KIND=JPIM) :: JPMXENKF
INTEGER(KIND=JPIM) :: JPMXAD
INTEGER(KIND=JPIM) :: JPMXVAR
INTEGER(KIND=JPIM) :: JPMXTOCH
INTEGER(KIND=JPIM) :: JPMXSSCH
INTEGER(KIND=JPIM) :: JPMXTRCH
INTEGER(KIND=JPIM) :: JPXTSL
INTEGER(KIND=JPIM) :: JPXCMA
INTEGER(KIND=JPIM) :: JPXSATS
INTEGER(KIND=JPIM) :: JPMX_SATOB_WEIGHT
INTEGER(KIND=JPIM) :: JPMX_LIMB_TAN
INTEGER(KIND=JPIM) :: JPMX_AK
INTEGER(KIND=JPIM) :: JPMX_RADAR_NIV
INTEGER(KIND=JPIM) :: JP_NUMEV
PARAMETER (JPMXOTP=JPNOTP)
PARAMETER (JPMXOCT=13)
PARAMETER (JPMXUP=10)
PARAMETER (JPMXENKF=100)
PARAMETER (JPMXAD=20)
PARAMETER (JPMXVAR=JPNUMV)
PARAMETER (JPMXTOCH=8461)
PARAMETER (JPMXSSCH=7)
PARAMETER (JPMXTRCH=9)
PARAMETER (JPXTSL=JPXTIM)
PARAMETER (JPXCMA=1)
PARAMETER (JPXSATS=6)
PARAMETER (JPMX_SATOB_WEIGHT=50)
PARAMETER (JPMX_LIMB_TAN=17)
PARAMETER (JPMX_AK=50)
PARAMETER (JPMX_RADAR_NIV=15)
PARAMETER (JP_NUMEV=1)
!-----------------------------------------------------------------------

END MODULE PARCMA
