MODULE PARERSCA

USE PARKIND1  ,ONLY : JPIM

IMPLICIT NONE

SAVE

!*** BLOCK PARERSCA 
!     parameters needed for dimensioning arrays of common block yomersca
!     JPSAT       NUMBER OF ERS SATELLITES (2 FOR ERS-1/ERS-2)
!     JPERS1      SATID  OF AMI SCAT ON ERS-1: 1
!     JPERS2      SATID  OF AMI SCAT ON ERS-2: 2
!     JPCELL      NUMBER OF ERS WAVE VECTOR CELLS
!     JPASCAT     NUMBER OF METOP SATELLITES (CURRENTLY 1 FOR METOP-A, EVENTUALLY 3)
!     JPAMETOPA   SATID  OF ASCAT ON METOP-A: 4
!     JPAMETOPB   SATID  OF ASCAT ON METOP-B: 3? TO BE CONFIRMED
!     JPAMETOPC   SATID  OF ASCAT ON METOP-C: 5? TO BE CONFIRMED
!     JPACELL     NUMBER OF ASCAT WIND VECTOR CELLS
!     JPACELL_HR  NUMBER OF ASCAT WIND VECTOR CELLS IN HIGH-RESOLUTION
!     JPQCELL     NUMBER OF QSCAT WIND VECTOR CELLS
!     JPICELL     NUMBER OF OCEANSAT-2 WIND VECTOR CELLS
!     JPANT       NUMBER OF ANTENNAE
!     JPVIT       NUMBER OF WIND SPEEDS IN THE SIGMA0 TABLE
!     JPPHI       NUMBER OF WIND DIRECTIONS "        "
!     JPTETA      NUMBER OF INCIDENCE ANGLES "        "
!     JPCMOD4     NUMBER OF BASIC COEFFICIENTS FOR BACKSCATTER MODEL CMOD4
!     JPBIAS1     INDEX OF FIRST COEFFICIENT FOR INCIDENCE SIGMA0 BIAS CORRECTION
!     JPBIAS2     INDEX OF LAST COEFFICIENT FOR INCIDENCE SIGMA0 BIAS CORRECTION
!     JPSPL       NUMBER OF SPLINE COEFFICIENTS FOR WIND SPEED BIAS CORRECTION
!     JPHEAD      NUMBER OF LINES IN NEW SPEED BIAS FILE HEADER
!     JPSPEEDMAX  MAXIMUM WIND SPEED FOR ERS AND ASCAT BIAS CORRECTION
!     JPSOLMAX    MAXIMUM NUMBER OF WIND VECTOR SOLUTIONS
!     JPDIRMAX    MAXIMUM NUMBER OF DISCRETIZED WIND DIRECTIONS
!     JPBRADS     NO. OF RADAR SCAT. SECTIONS
!     JPBESAS     NO. OF ESA SCAT. SECTIONS
!     JPBRSWI     NO. OF RETRIEVED SCAT. BUFR WINDS
!     JPBARSWI    NO. OF RETRIEVED ASCAT BUFR WINDS
!     JPBRNSWI    NO. OF RETRIEVED NSCAT BUFR WINDS
!     JPEBODYS0   NUMBER OF SIGMA0 BODIES PER REPORT FOR ERS   ( 3 )
!     JPABODYS0   NUMBER OF SIGMA0 BODIES PER REPORT FOR ASCAT ( 3 )
!     JPABODYSM   NUMBER OF SOIL MOISTURE BODIES PER REPORT FOR ASCAT ( 1 )
!     JPQBODYS0   NUMBER OF SIGMA0 BODIES PER REPORT FOR QSCAT ( NONE )
!     JPIBODYS0   NUMBER OF SIGMA0 BODIES PER REPORT FOR OCEANSAT-2 ( NONE )


INTEGER(KIND=JPIM), PARAMETER :: JPSAT=2
INTEGER(KIND=JPIM), PARAMETER :: JPERS1=1
INTEGER(KIND=JPIM), PARAMETER :: JPERS2=2
INTEGER(KIND=JPIM), PARAMETER :: JPCELL=19
INTEGER(KIND=JPIM), PARAMETER :: JPASCAT=1
INTEGER(KIND=JPIM), PARAMETER :: JPAMETOPA=4
INTEGER(KIND=JPIM), PARAMETER :: JPAMETOPB=3
INTEGER(KIND=JPIM), PARAMETER :: JPAMETOPC=5
INTEGER(KIND=JPIM), PARAMETER :: JPACELL=42
INTEGER(KIND=JPIM), PARAMETER :: JPACELL_HR=82
INTEGER(KIND=JPIM), PARAMETER :: JPQCELL=38
INTEGER(KIND=JPIM), PARAMETER :: JPICELL=36
INTEGER(KIND=JPIM), PARAMETER :: JPANT=3
INTEGER(KIND=JPIM), PARAMETER :: JPVIT=119
INTEGER(KIND=JPIM), PARAMETER :: JPPHI=37
INTEGER(KIND=JPIM), PARAMETER :: JPTETA=55
INTEGER(KIND=JPIM), PARAMETER :: JPCMOD4=18
INTEGER(KIND=JPIM), PARAMETER :: JPBIAS1=17
INTEGER(KIND=JPIM), PARAMETER :: JPBIAS2=58
INTEGER(KIND=JPIM), PARAMETER :: JPSPL=5
INTEGER(KIND=JPIM), PARAMETER :: JPHEAD=5
INTEGER(KIND=JPIM), PARAMETER :: JPSPEEDMAX=25
INTEGER(KIND=JPIM), PARAMETER :: JPSOLMAX=6
INTEGER(KIND=JPIM), PARAMETER :: JPDIRMAX=360
INTEGER(KIND=JPIM), PARAMETER :: JPBRADS=3
INTEGER(KIND=JPIM), PARAMETER :: JPBESAS=1
INTEGER(KIND=JPIM), PARAMETER :: JPBRSWI=2
INTEGER(KIND=JPIM), PARAMETER :: JPBRASWI=2
INTEGER(KIND=JPIM), PARAMETER :: JPBRNSWI=4
INTEGER(KIND=JPIM), PARAMETER :: JPEBODYS0=3
INTEGER(KIND=JPIM), PARAMETER :: JPABODYS0=3
INTEGER(KIND=JPIM), PARAMETER :: JPABODYSM=1
INTEGER(KIND=JPIM), PARAMETER :: JPQBODYS0=0
INTEGER(KIND=JPIM), PARAMETER :: JPIBODYS0=0
END MODULE PARERSCA
