module paronedvar

use parkind1, only: jpim, jprb

implicit none

save

integer (kind=jpim), parameter :: nmax_channels = 30  ! max. number of channels

integer (kind=jpim), parameter :: n_max      = 20    ! max. number of 1d-var iterations
integer (kind=jpim), parameter :: npred_bias =  3    ! polyn. degree for bias correction
integer (kind=jpim), parameter :: n_err      =  2    ! polyn. degree for AN error fit
integer (kind=jpim), parameter :: n_mode     =  0

integer (kind=jpim), parameter :: nmax_satsens = 10   ! max. number of satellites*sensors

real (kind=jprb) :: rt_min = 100.0_JPRB             ! minimum allowed T, see satrad/module/rttov_const
real (kind=jprb) :: rt_max = 350.0_JPRB             ! maximum allowed T
real (kind=jprb) :: rq_min = 1.0E-10_JPRB           ! minimum allowed q
real (kind=jprb) :: rq_max = 0.373_JPRB             ! maximum allowed q

real (kind=jprb), parameter :: rmissing_angle= -999.0_JPRB

end module paronedvar
