MODULE PTRGFU

USE PARKIND1  ,ONLY : JPIM

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------

!*    DIAGNOSTICS DE CUMUL DE FLUX

INTEGER(KIND=JPIM) :: MSTRDU  ! FLUX GWD DE U
INTEGER(KIND=JPIM) :: MSTRDV  ! FLUX GWD DE V
INTEGER(KIND=JPIM) :: MSTRCU  ! FLUX CONVECTIF DE U
INTEGER(KIND=JPIM) :: MSTRCV  ! FLUX CONVECTIF DE V
INTEGER(KIND=JPIM) :: MFDICQ  ! FLUX CONVECTIF DE Q
INTEGER(KIND=JPIM) :: MFDICS  ! FLUX CONVECTIF DE Cp.T
INTEGER(KIND=JPIM) :: MSTRTU  ! FLUX TURBULENT DE U
INTEGER(KIND=JPIM) :: MSTRTV  ! FLUX TURBULENT DE V
INTEGER(KIND=JPIM) :: MFDITQ  ! FLUX TURBULENT DE Q
INTEGER(KIND=JPIM) :: MFDITS  ! FLUX TURBULENT DE Cp.T
INTEGER(KIND=JPIM) :: MFPLCL  ! PLUIE CONVECTIVE
INTEGER(KIND=JPIM) :: MFPLSL  ! PLUIE STRATIFORME
INTEGER(KIND=JPIM) :: MFPLCN  ! NEIGE CONVECTIVE
INTEGER(KIND=JPIM) :: MFPLSN  ! NEIGE STRATIFORME
INTEGER(KIND=JPIM) :: MFPLCG  ! GRAUIPEL CONVECTIVE
INTEGER(KIND=JPIM) :: MFPLSG  ! GRAUPEL STRATIFORME
INTEGER(KIND=JPIM) :: MFPLCH  ! GRELE CONVECTIVE
INTEGER(KIND=JPIM) :: MFPLSH  ! GRELE STRATIFORME
INTEGER(KIND=JPIM) :: MFCCQL  ! CONDENSATION LIQUIDE LIEE A LA CONVECTION
INTEGER(KIND=JPIM) :: MFCCQN  ! CONDENSATION SOLIDE  LIEE A LA CONVECTION.
INTEGER(KIND=JPIM) :: MFCSQL  ! CONDENSATION LIQUIDE DE GRANDE ECHELLE
INTEGER(KIND=JPIM) :: MFCSQN  ! CONDENSATION SOLIDE  DE GRANDE ECHELLE
INTEGER(KIND=JPIM) :: MFRSO   ! FLUX RAYONNEMENT SOLAIRE
INTEGER(KIND=JPIM) :: MFRTH   ! FLUX RAYONNEMENT TERRESTRE
INTEGER(KIND=JPIM) :: MFNEB   ! NEBULOSITE DE ARANEB
INTEGER(KIND=JPIM) :: MWS     ! CONTENU EN EAU DU RESERVOIR DE SURFACE/SOIL MOISTURE
INTEGER(KIND=JPIM) :: MSNS    ! RESERVOIR EN NEIGE/SNOW MASS
INTEGER(KIND=JPIM) :: MQTOT   ! TOTAL EAU PRECIPITABLE/TOTAL PRECIPITABLE WATER
INTEGER(KIND=JPIM) :: MFNEBT  ! NEBULOSITE TOTALE/TOTAL CLOUDINESS
INTEGER(KIND=JPIM) :: MOZONT  ! TOTAL OZONE
INTEGER(KIND=JPIM) :: MSPRES  ! PRESSION SOL/SURFACE PRESSURE
INTEGER(KIND=JPIM) :: MFCL    ! FLUX DE CHALEUR LATENTE/LATENT HEAT FLUX
INTEGER(KIND=JPIM) :: MFCS    ! FLUX DE CHALEUR SENSIBLE/SENSIBLE HEAT FLUX
INTEGER(KIND=JPIM) :: MFDISH  ! FLUX D'ENTHALPIE DE SURFACE 
                     ! DUE A LA DISSIPATION D'ENERGIE CINETIQUE
INTEGER(KIND=JPIM) :: MFTOPH  ! FLUX MESOSPHERIQUE D'ENTHALPIE AU SOMMET (+DISSIPATION)
INTEGER(KIND=JPIM) :: MQICE   ! HUMIDITE SPECIFIQUE SOLIDE
INTEGER(KIND=JPIM) :: MQLI    ! HUMIDITE SPECIFIQUE LIQUIDE
INTEGER(KIND=JPIM) :: MFRSOC0 ! FLUX RADIATIF SOLAIRE PAR CIEL CLAIR AU SOMMET
INTEGER(KIND=JPIM) :: MFRTHC0 ! FLUX RADIATIF THERMIQUE PAR CIEL CLAIR AU SOMMET
INTEGER(KIND=JPIM) :: MFRSOC1 ! FLUX RADIATIF SOLAIRE PAR CIEL CLAIR AU SOL
INTEGER(KIND=JPIM) :: MFRTHC1 ! FLUX RADIATIF SOLAIRE PAR CIEL CLAIR AU SOL
INTEGER(KIND=JPIM) :: MFRSOPS ! FLUX SOLAIRE DIRECT SURFACE
INTEGER(KIND=JPIM) :: MFRSOPT ! FLUX SOLAIRE DIRECT SOMMET
INTEGER(KIND=JPIM) :: MFRSOLU ! FLUX DESCENDANT LUNAIRE EN SURFACE
INTEGER(KIND=JPIM) :: MFRSODS ! FLUX SOLAIRE DESCENDANT SURFACE
INTEGER(KIND=JPIM) :: MFRTHDS ! FLUX THERMIQUE DESCENDANT SURFACE
INTEGER(KIND=JPIM) :: MFCLL   ! FLUX DE CHALEUR LATENTE LIQUIDE
INTEGER(KIND=JPIM) :: MFCLN   ! FLUX DE CHALEUR LATENTE NEIGE
INTEGER(KIND=JPIM) :: MFEVL   ! FLUX D'EVAPORATION LIQUIDE
INTEGER(KIND=JPIM) :: MFEVN   ! FLUX D'EVAPORATION NEIGE
INTEGER(KIND=JPIM) :: MFONTE  ! FLUX DE FONTE DE LA NEIGE
INTEGER(KIND=JPIM) :: MFCHSP  ! FLUX DE CHALEUR DANS LE SOL
INTEGER(KIND=JPIM) :: MFEVV   ! FLUX D'EVAPOTRANSPIRATION  (si LSOLV)
INTEGER(KIND=JPIM) :: MFLWSP  ! FLUX D'EAU DANS LE SOL
INTEGER(KIND=JPIM) :: MFTR    ! FLUX DE TRANSPIRATION (si LSOLV)
INTEGER(KIND=JPIM) :: MRUISL  ! RUISELLEMENT DU RESERVOIR D'INTERCEPTION (si LSOLV)
INTEGER(KIND=JPIM) :: MRUISP  ! RUISELLEMENT DU RESERVOIR PROFOND
INTEGER(KIND=JPIM) :: MRUISS  ! RUISELLEMENT DU RESERVOIR SUPERFICIEL
INTEGER(KIND=JPIM) :: MNEBCON ! CONVECTIVE CLOUDINESS
INTEGER(KIND=JPIM) :: MNEBHAU ! HIGH STAGE CLOUDINESS
INTEGER(KIND=JPIM) :: MNEBMOY ! MEAN STAGE CLOUDINESS
INTEGER(KIND=JPIM) :: MNEBBAS ! LOW  STAGE CLOUDINESS
INTEGER(KIND=JPIM) :: MFGEL   ! FLUX DE GEL DU RESERVOIR PROFOND
INTEGER(KIND=JPIM) :: MFGELS  ! FLUX DE GEL DU RESERVOIR DE SURFACE
INTEGER(KIND=JPIM) :: MFDUTP  ! Filtered duration of total precipitations

!     -----------------------------------------------------------------
END MODULE PTRGFU
