MODULE PTRSPOR

USE PARKIND1  ,ONLY : JPRB

IMPLICIT NONE

SAVE

! -----------------------------------------------------------------------------

! Variables used in the minimization of orography in configuration 923.

! * Spectral variables:
! XRNM: spectral orography (to be found by a minimization).
! XSNM: gradient of the cost-function (the cost-function being to be minimized).
! XPDL: weight used in the spectral part of the cost-function (smoothing)

REAL(KIND=JPRB),ALLOCATABLE:: XRNM(:)
REAL(KIND=JPRB),ALLOCATABLE:: XSNM(:)
REAL(KIND=JPRB),ALLOCATABLE:: XPDL(:)

! * Grid-point variables:
! XREV: grid-point orography (interpolated from a file)
!       which is used as a first guess for the
!       minimization (this orography has an envelope
!       if an orography with an envelope is asked for).
! XPDS: weight given at each grid-point in the minimization.
! XEXT: is an index array (in grid-point space) telling if the point is in C+I;
!       in ARPEGE contains 1 everywhere;
!       in ALADIN contains 1 in C+I, 0 in the extension zone.

REAL(KIND=JPRB),ALLOCATABLE:: XREV(:)
REAL(KIND=JPRB),ALLOCATABLE:: XPDS(:)
REAL(KIND=JPRB),ALLOCATABLE:: XEXT(:,:)

! -----------------------------------------------------------------------------

END MODULE PTRSPOR
