MODULE QACOSS

USE PARKIND1, ONLY : JPRB
USE QAPASS,   ONLY : JPNVS, JPBLS

IMPLICIT NONE

SAVE

!****-------------------------------------------------------------------
!****   QACOSS : Parametres servant au calcul des covariances d'erreur de
!****   ------   prevision et niveaux pression sur lesquels ils sont definis
!****-------------------------------------------------------------------
!***  XPPRS  : PRESSION DES JPNVS NIVEAUX
!***  XPLRS  : LOG(XPPRS)
!***  XPOHZ  : PORTEE HORIZONTALE POUR LE GEOPOTENTIEL
!***  XPOHUD : PORTEE HORIZONTALE POUR LE VENT DIVERGENT
!***  XPOSST : PORTEE HORIZONTALE POUR LA SST
!***  XPOHSN : PORTEE HORIZONTALE POUR LA NEIGE SN
!***  XPOHHU : PORTEE HORIZONTALE POUR L'HUMIDITE
!***  XRMU   : COEFFICIENT D'AGEOSTROPHISME
!***  XRNU   : RAPPORT (ECART-TYPE DU VENT ROT / E.-T. DU VENT DIV)
!***  XPOVZ  : PORTEE VERTICALE POUR LE GEOPOTENTIEL
!***  XPOVH  : PORTEE VERTICALE POUR L'HUMIDITE
!***  XPOHPSN: PORTEE "VERTICALE" POUR LA NEIGE SN
!****-------------------------------------------------------------------
REAL(KIND=JPRB) :: XPPRS(JPNVS)
REAL(KIND=JPRB) :: XPLRS(JPNVS)
REAL(KIND=JPRB) :: XPOHZ(-JPBLS:JPBLS+1,JPNVS)
REAL(KIND=JPRB) :: XPOHUD(-JPBLS:JPBLS+1,JPNVS)
REAL(KIND=JPRB) :: XPOSST(-JPBLS:JPBLS+1)
REAL(KIND=JPRB) :: XPOHHU(-JPBLS:JPBLS+1,JPNVS)
REAL(KIND=JPRB) :: XRMU(-JPBLS:JPBLS+1,JPNVS)
REAL(KIND=JPRB) :: XRNU(-JPBLS:JPBLS+1,JPNVS)
REAL(KIND=JPRB) :: XPOVZ(-JPBLS:JPBLS+1,JPNVS)
REAL(KIND=JPRB) :: XPOVH(-JPBLS:JPBLS+1,JPNVS)
REAL(KIND=JPRB) :: XPOHT2(-JPBLS:JPBLS+1)
REAL(KIND=JPRB) :: XPOHH2(-JPBLS:JPBLS+1)
REAL(KIND=JPRB) :: XPOHSN(-JPBLS:JPBLS+1)
REAL(KIND=JPRB) :: XPOHV1(-JPBLS:JPBLS+1)
REAL(KIND=JPRB) :: XPOVORBL(-JPBLS:JPBLS+1)
REAL(KIND=JPRB) :: XPODIVBL(-JPBLS:JPBLS+1)
REAL(KIND=JPRB) :: XNUBL(-JPBLS:JPBLS+1)
REAL(KIND=JPRB) :: XKPBL(-JPBLS:JPBLS+1)
REAL(KIND=JPRB) :: XPOHPSN(-JPBLS:JPBLS+1)
!****-------------------------------------------------------------------
END MODULE QACOSS
