MODULE QADORE

USE PARKIND1  ,ONLY : JPIM     ,JPRB

USE PARDIMO

USE QAPAVU

IMPLICIT NONE

SAVE

!****-------------------------------------------------------------------
!**** CD QADORE : DONNEES POUR LA RECHERCHE DES OBSERVATIONS
!**** ---------   DANS LE CADRE DU CONTROLE DES OBSERVATIONS.
!**** AUTEURS   : JH 03/90, PB 11/90, PC, VC 03/93
!****-------------------------------------------------------------------
!  PARAMETRES INITIALISES DANS CARATK INDISPENSABLES POUR LES APPELS A CANEVA.
! ---------------------------
!  TABLEAUX DEFINISSANT LES PREDICTANDS ET PREDICTEURS POUR CANEVA.

!  MPNVP : NOMBRE DE PREDICTEURS NECESSAIRES PAR TYPE D'OBS.
!  MINM  : NOMBRE DE PREDICTEURS PAR PREDICTANTS ET PAR TYPE D'OBS.
!  MIPNVP: NUMEROS DU CODE "NVNUMB" DES PREDICTEURS, PAR TYPE D'OBS.
!  MOPT  : OPTION POUR LE CONTROLE DES TYPES D'OBS (CF CARNAK)

!  TABLEAUX DE CONTRAINTES GEOGRAPHIQUES ET STATISTIQUES.

!  NMXGSL: NBRE MAX OBS POUR L'EXTRACTION PRIMAIRE (BOITE + VOISINES)
!  NMXGQ : NBRE MAX D'OBS PAR SECTEUR (CELA PEUT IMPOSER UNE SELECTION)
!  QDISTR: DISTANCE MAX DE SELECTION DU NUAGE DE PTS   (EN METRES)
!  QDISTV: DISTANCE MAX DE SELECTION EN PRESSION       (EN HPA)
!****-------------------------------------------------------------------
INTEGER(KIND=JPIM) :: MPNVP(JPNOTP)
INTEGER(KIND=JPIM) :: MINM(JPNVX,JPNOTP)
INTEGER(KIND=JPIM) :: MIPNVP(JPNVY,JPNOTP)
INTEGER(KIND=JPIM) :: MOPT(JPNOTP)

INTEGER(KIND=JPIM) :: NMXGSL(JPNOTP,JPNOTP)
INTEGER(KIND=JPIM) :: NMXGQ(JPNOTP,JPNOTP)
REAL(KIND=JPRB) :: QDISTR(JPNOTP,JPNOTP)
REAL(KIND=JPRB) :: QDISTV(JPNOTP,JPNOTP)
!****-------------------------------------------------------------------
END MODULE QADORE
