MODULE QAETEO

USE PARKIND1  ,ONLY : JPIM     ,JPRB

USE PARDIMO

USE QAPASS

IMPLICIT NONE

SAVE

!--------------------------------------------------------------------
!  QAETEO : comdeck  contenant  les tableaux  des ecarts-types
!  ------   d'erreurs d'observation

!  Auteur : Ph. Caille   03/91
!  modif  : LG 03/00   - obs error for snow quantity added(JPEOPO=6)
!--------------------------------------------------------------------
!   JPEOTO : nombre de sous-types d'observations (egal au maximum
!            des nombres de sous-types pour chaque type d'obs.)
!   JPEOPO : nombre  de parametres  (Z, T, etc...)  pour lesquels
!            les ecart-types d'erreur d'obs.  sont disponibles.
!   ECTERO : ecart-types d'erreur d'observation, ranges par types
!            d'observations, sous-types d'observations, parametres
!            et niveaux de pression
!   ETEOST : idem, specifique aux SATEM pour les epaisseurs
!   ETEOHU : idem, specifique aux SATEM pour les humidites

! Pour de plus amples  informations voir les commentaires  dans le
! sous-programme "CABIYO"
!--------------------------------------------------------------qaeteo
INTEGER(KIND=JPIM), PARAMETER :: JPEOTO=5
INTEGER(KIND=JPIM), PARAMETER :: JPEOPO=6

REAL(KIND=JPRB) :: ECTERO(JPNOTP,JPEOTO,JPEOPO,JPNVS)
REAL(KIND=JPRB) :: ETEOST(JPNVS*(JPNVS-1)/2)
REAL(KIND=JPRB) :: ETEOHU(3)

END MODULE QAETEO
