MODULE QAKEKI

USE PARKIND1  ,ONLY : JPIM

IMPLICIT NONE

SAVE

!-----------------------------------------------------------------------
!  CD QAKEKI : Positions  des divers codes  qualite  particuliers
!  ---------   dans les codes qualite parametre
!  Auteur                : Ph. Caille  05/90
!  Derniere modification : Ph. Caille  05/96
!                          F.Taillefer 02/01  ajout NCUSN
!-----------------------------------------------------------------------

!  Code qualite base de donnees      NCMRDFL
!  ----------------------------
!    nom de la var.     bit       signification
!        NDBCVS          1      supervision
!        NDBCVPR         2      correction pretraitement
!        NDBCVF          3      forcage
!        NDBCVCQ         4      code qualite BDM
!        NDBCVCQM        6      type de controle de qualite
!        NDBCVACQ        7      code qualite analyse precedente
!        NDBCVAU         9      code utilisation analyse precedente

!        NDBPAS         16      supervision
!        NDBPAPR        17      correction pretraitement
!        NDBPAF         18      forcage
!        NDBPACQ        19      code qualite BDM
!        NDBPACQM       21      type de controle de qualite
!        NDBPAACQ       22      code qualite analyse precedente
!        NDBPAAU        24      code utilisation analyse precedente

!  Code qualite parametre            NCMFLG
!  ----------------------
!    nom de la var.     bit       signification
!        NCQFCO          1      code final analyse correct
!        NCQFPC          2      code final analyse probablement correct
!        NCQFPI          3      code final analyse probablement incorrect
!        NCQFIN          4      code final analyse incorrect
!        NCQECO          5      code controle ebauche correct
!        NCQEPC          6      code controle ebauche probablement correct
!        NCQEPI          7      code controle ebauche probablement incorrect
!        NCQEIN          8      code controle ebauche incorrect
!        NCQKCO          9      code controle coherence spatiale correct
!        NCQKPC         10      code controle coherence spatiale probablement correct
!        NCQKPI         11      code controle coherence spatiale probablement incorrect 
!        NCQKIN         12      code controle coherence spatiale incorrect
!        NCQVCO         13      code controle dans variationnel correct
!        NCQVPC         14      code controle dans variationnel probablement correct
!        NCQVPI         15      code controle dans variationnel probablement incorrect
!        NCQVIN         16      code controle dans variationnel incorrect 
!        NCLNCO         17      code liste noire correct
!        NCLNPC         18      code liste noire probablement correct
!        NCLNPI         19      code liste noire probablement incorrect
!        NCLNIN         20      code liste noire incorrect
!        NCUPS          21      code d'utilisation analyse Psol
!        NCUUVT         22      code d'utilisation analyse uvT
!        NCUHU          23      code d'utilisation analyse Hu
!        NCUT2M         24      code d'utilisation analyse T 2m
!        NCUH2M         25      code d'utilisation analyse Hu 2m
!        NCUV10         26      code d'utilisation analyse V 10m
!        NCURR          27      code d'utilisation analyse precipitations
!        NCUSN          28      code d'utilisation analyse neige
!        NCUSST         29      code d'utilisation analyse SST
!-----------------------------------------------------------------------
INTEGER(KIND=JPIM) :: NDBCVS
INTEGER(KIND=JPIM) :: NDBCVPR
INTEGER(KIND=JPIM) :: NDBCVF
INTEGER(KIND=JPIM) :: NDBCVCQ
INTEGER(KIND=JPIM) :: NDBCVCQM
INTEGER(KIND=JPIM) :: NDBCVACQ
INTEGER(KIND=JPIM) :: NDBCVAU
INTEGER(KIND=JPIM) :: NDBPAS
INTEGER(KIND=JPIM) :: NDBPAPR
INTEGER(KIND=JPIM) :: NDBPAF
INTEGER(KIND=JPIM) :: NDBPACQ
INTEGER(KIND=JPIM) :: NDBPACQM
INTEGER(KIND=JPIM) :: NDBPAACQ
INTEGER(KIND=JPIM) :: NDBPAAU
INTEGER(KIND=JPIM) :: NCQFCO
INTEGER(KIND=JPIM) :: NCQFPC
INTEGER(KIND=JPIM) :: NCQFPI
INTEGER(KIND=JPIM) :: NCQFIN
INTEGER(KIND=JPIM) :: NCQECO
INTEGER(KIND=JPIM) :: NCQEPC
INTEGER(KIND=JPIM) :: NCQEPI
INTEGER(KIND=JPIM) :: NCQEIN
INTEGER(KIND=JPIM) :: NCQKCO
INTEGER(KIND=JPIM) :: NCQKPC
INTEGER(KIND=JPIM) :: NCQKPI
INTEGER(KIND=JPIM) :: NCQKIN
INTEGER(KIND=JPIM) :: NCQVCO
INTEGER(KIND=JPIM) :: NCQVPC
INTEGER(KIND=JPIM) :: NCQVPI
INTEGER(KIND=JPIM) :: NCQVIN
INTEGER(KIND=JPIM) :: NCLNCO
INTEGER(KIND=JPIM) :: NCLNPC
INTEGER(KIND=JPIM) :: NCLNPI
INTEGER(KIND=JPIM) :: NCLNIN
INTEGER(KIND=JPIM) :: NCUPS
INTEGER(KIND=JPIM) :: NCUUVT
INTEGER(KIND=JPIM) :: NCUHU
INTEGER(KIND=JPIM) :: NCUT2M
INTEGER(KIND=JPIM) :: NCUH2M
INTEGER(KIND=JPIM) :: NCUV10
INTEGER(KIND=JPIM) :: NCURR
INTEGER(KIND=JPIM) :: NCUSN
INTEGER(KIND=JPIM) :: NCUSST

END MODULE QAKEKI
