MODULE QAPABO

USE PARKIND1  ,ONLY : JPIM

IMPLICIT NONE

SAVE

!****----------------------------------------------------------------
!****   QAPABO : Definition geographique des boites d'observations
!****   ------
!****   Auteur                : Ph. Caille                  31/07/89
!****   Derniere modification : Ph. Caille                  19/03/91
!****----------------------------------------------------------------
!***
!***  Les latitudes  et longitudes sont exprimees en degres. Dans une
!***  boite, les  bords nord et  ouest appartiennent a  la boite, pas
!***  ceux sud et est.
!***
!***   JPBLAN :  latitude maximale nord autorisee
!***   JPBLAS :  latitude minimale sud autorisee
!***   JPBLOE :  longitude maximale est autorisee
!***   JPBLOW :  longitude minimale ouest autorisee
!***   NBODLA :  longueur d'une boite sur un meridien
!***   NBODLO :  longueur d'une boite sur un parallele
!***   NBONLA :  nombre de boites sur un meridien
!***   NBONLO :  nombre de boites sur un parallele
!***   NBONBT :  nombre total de boites
!***   NBONLB :  ( = NBONLA + 1 ), utilise pour dimensionner certains
!***             tableaux
!***   NBONLP :  ( = NBONLO + 1 ), utilise pour dimensionner certains
!***             tableaux
!***   NBONBU :  ( = NBONBT + 1 ), utilise pour dimensionner certains
!***             tableaux
!***
!***-----------------------------------------------------------------

INTEGER(KIND=JPIM), PARAMETER :: JPBLAN=90
INTEGER(KIND=JPIM), PARAMETER :: JPBLAS=-90
INTEGER(KIND=JPIM), PARAMETER :: JPBLOE=360
INTEGER(KIND=JPIM), PARAMETER :: JPBLOW=0
INTEGER(KIND=JPIM) :: NBODLA
INTEGER(KIND=JPIM) :: NBODLO
INTEGER(KIND=JPIM) :: NBONLA
INTEGER(KIND=JPIM) :: NBONLO
INTEGER(KIND=JPIM) :: NBONBT
INTEGER(KIND=JPIM) :: NBONLB
INTEGER(KIND=JPIM) :: NBONLP
INTEGER(KIND=JPIM) :: NBONBU

END MODULE QAPABO
