MODULE QAPREX

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!****-----------------------------------------------------------------------
!**** CD QAPREX : CONTIENT LES PREDICTEURS POUR CHAQUE ANALYSE
!****    ------
!**** Auteurs :     P.MOLL 05/92, V.CASSE 03/93, 08/94
!****-----------------------------------------------------------------------
!** JPNPRE nombre maximum de predicteurs
!** JPCHEK nombre de classes de parametres a controler(ZUV,T,Hu,Dz,SST,SN,QQ,T2,H2,V1)
!** JPANAL nombre d'analyses (PS,UV,TT,HU,T2,H2,V10,SN,SST,QQ)
!** NJPP relie les JPCHEK analyses au 1er modele statistique JPP.. correspondant
!** NPREK donne les predicteurs utilisables pour les JPCHEK analyses
!** NBPREK nombre de ces predicteurs
!** NPREA donne les predicteurs utilisables pour les JPANAL analyses
!** NBPREA nombre de ces predicteurs
!****-----------------------------------------------------------------------
INTEGER(KIND=JPIM), PARAMETER :: JPNPRE=17
INTEGER(KIND=JPIM), PARAMETER :: JPCHEK=10
INTEGER(KIND=JPIM), PARAMETER :: JPANAL=10

INTEGER(KIND=JPIM) :: NJPP(JPCHEK)
INTEGER(KIND=JPIM) :: NPREK(JPNPRE,JPCHEK)
INTEGER(KIND=JPIM) :: NBPREK(JPCHEK)
INTEGER(KIND=JPIM) :: NPREA(JPNPRE,JPANAL)
INTEGER(KIND=JPIM) :: NBPREA(JPANAL)
INTEGER(KIND=JPIM) :: NKZV
INTEGER(KIND=JPIM) :: NKTT
INTEGER(KIND=JPIM) :: NKHU
INTEGER(KIND=JPIM) :: NKDZ
INTEGER(KIND=JPIM) :: NKST
INTEGER(KIND=JPIM) :: NKSN
INTEGER(KIND=JPIM) :: NAPS
INTEGER(KIND=JPIM) :: NATT
INTEGER(KIND=JPIM) :: NAUV
INTEGER(KIND=JPIM) :: NAHU
INTEGER(KIND=JPIM) :: NAT2
INTEGER(KIND=JPIM) :: NAH2
INTEGER(KIND=JPIM) :: NAV1
INTEGER(KIND=JPIM) :: NASN
INTEGER(KIND=JPIM) :: NAST
INTEGER(KIND=JPIM) :: NKT2
INTEGER(KIND=JPIM) :: NKH2
INTEGER(KIND=JPIM) :: NKV1
INTEGER(KIND=JPIM) :: NKQQ
INTEGER(KIND=JPIM) :: NAQQ
!****-----------------------------------------------------------------------
END MODULE QAPREX
