MODULE RT6SVALUES

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!     -----------------------------------------------------------------------
!*    ** 6SVALUES ** - DEFINITION AND INITIALIZATION OF CONSTANTS USED IN 6S
!     -----------------------------------------------------------------------

INTEGER(KIND=JPIM), PARAMETER :: KLEV=60, KLON=1, KWL=1, KNT=26
INTEGER(KIND=JPIM),PARAMETER  :: KMU=25, KMU2=48, KNP=49, KNANG=80, KNBMU=83
INTEGER(KIND=JPIM),PARAMETER :: ICTE=5         ! IN VERTDISC
INTEGER(KIND=JPIM),PARAMETER :: IDIV=ICTE*KNT  ! IN VERTDISC
INTEGER(KIND=JPIM),PARAMETER :: SCATORD=20     ! MAXIMUM NUMBER OF SCATTERING TERMS TO BE CONSIDERED (OS & ISO)
REAL(KIND=JPRB), PARAMETER :: ZPI=3.141592653589_JPRB, RAC3=1.7320508_JPRB
REAL(KIND=JPRB), PARAMETER :: PEPS=3.E-14              ! PRECISION OF THE MACHINE
REAL(KIND=JPRB), PARAMETER :: ZEPS=1.E-30              ! 
REAL(KIND=JPRB), PARAMETER :: PWL550=0.55d-6           ! REFERENCE WAVELENGTH
REAL(KIND=JPRB), PARAMETER :: DELTA=0.0279_JPRB             ! DEPOLARIZATION FACTOR
REAL(KIND=JPRB), PARAMETER :: ZXBETA2=0.5_JPRB
REAL(KIND=JPRB), PARAMETER :: ACCU=1.E-20, ACCU2=1.E-3, ACCU4=1.E-04, ACCU5=1.E-05 ! USED IN OS
REAL(KIND=JPRB), PARAMETER :: ACCU3=1.E-06 !USED IN OS
INTEGER(KIND=JPIM),PARAMETER :: NORD=5         ! FIXED ORDER OF SCATTERING IN ISO AND OS
INTEGER(KIND=JPIM),PARAMETER :: NFOUR=4        ! NUMBER OF TERMS IN THE FOURIER SERIES USED IN OS


END MODULE RT6SVALUES
