MODULE VARBC_table
!-----------------------------------------------------------------------
!   VARBC_table - Module for variational bias correction
!
!   Purpose. 
!   --------
!   Set up some basic parameters for variational bias correction
!
!   Author.
!   -------
!   Alan Geer 11-Jun-2009 - Needed to avoid circular dependencies between 
!                           varbc_pred and varbc_setup
!
!   Modifications.
!   --------------
!
!------------------------------------------------------------------------

USE parkind1, ONLY : JPIM, JPRB

IMPLICIT NONE
SAVE

PRIVATE
PUBLIC NOBGROUP, JPMXNGROUP

INTEGER(KIND=JPIM), PARAMETER :: jpmxngroup = 10000 ! max number of bias groups
INTEGER(KIND=JPIM) :: nobgroup   ! total number of bias groups

END MODULE VARBC_table
