MODULE YEMCT3

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!----------------------------------------------------------
!    Control variables for the LAM model  - changed at level 3

!     NETLS1 : Time step of the first set of lateral boundary  fields.
!     NETLS2 : Time step of the second set of lateral boundary fields.
!              The current step NSTEP is between NETLS1 and NETLS2,
!              and NETLS2-NETLS1=NEFRCL.

!     EWB1   : Weight for lateral boundary fields at time NETLS1
!              in the linear interpolation in time.
!     EWB2   : Weight for lateral boundary fields at time NETLS2 in
!              the linear interpolation in time.

!     LESWLS : Logical to know if the time NETLS2 is at the beginning of
!              the  I/O work file or the buffer (.TRUE. in that case)
!          OR  at the end of the I/O work file or buffer (.FALSE. in that case).

REAL(KIND=JPRB) :: EWB1
REAL(KIND=JPRB) :: EWB2
INTEGER(KIND=JPIM) :: NETLS1
INTEGER(KIND=JPIM) :: NETLS2
LOGICAL :: LESWLS
!-----------------------------------------------------------------------------
END MODULE YEMCT3
