MODULE YEMGGCM

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!----- Comdeck YEMGGCM *** FOR INTERNAL USE IN EGG GROUP ONLY

INTEGER(KIND=JPIM) :: NYMGGI
INTEGER(KIND=JPIM) :: NYMGGR
INTEGER(KIND=JPIM) :: NYMGGWH
REAL(KIND=JPRB) :: XLATR
REAL(KIND=JPRB) :: XLONR
REAL(KIND=JPRB) :: XGGPK
REAL(KIND=JPRB) :: XRPKSM
REAL(KIND=JPRB) :: XLAT0R
REAL(KIND=JPRB) :: XLON0R
REAL(KIND=JPRB) :: XLON0U
REAL(KIND=JPRB) :: XIPORE
REAL(KIND=JPRB) :: XJPORE
REAL(KIND=JPRB) :: XGGM0
REAL(KIND=JPRB) :: XLON1R
REAL(KIND=JPRB) :: XLON1U
REAL(KIND=JPRB) :: XLAT1R
REAL(KIND=JPRB) :: XLON2R
REAL(KIND=JPRB) :: HSUD
REAL(KIND=JPRB) :: XBETA

!      INTERNAL TO EGGX  ROUTINES
!     --------------------------------
!     THIS  BLOCK SHOULD NOT BE CONFUSED WITH THE COMMON OF
!     EFFECTIVE GEOGRAPHICAL PARAMETERS FOR ARPEGE-ALADIN

!     NYMGGI = 10 WHEN THE  HAS BEEN INITIALIZED
!     NYMGGR : COPY OF KROTEQ
!     NYMGGWH = 0, DOMAIN AWAY FROM GREENWICH
!             = 1, DOMAIN ASTRIDE GREENWICH
!     XLATR  : COPY OF PLATR
!     XLONR  : COPY OF PLONR
!     XGGPK  : EFFECTIVE PROJECTION PARAMETER PRPK
!     XRPKSM : NORMALISED PROJECTOR AMPLITUDE IN LAMBERT PROJECTION
!     XLAT0R : ROTATED PROJECTION REFERENCE LATITUDE
!     XLON0R : ROTATED PROJECTION REFERENCE LONGITUDE
!     XLON0U : AS XLON0R BUT INCREASED BY 2*RPI IF ASTRIDE GREENWICH
!     XIPORE : LOCATION OF GRID ORIGIN IN X (POLE IF STEREO-LAMBERT)
!              XIPORE = (IP - NDLUNG)
!     XJPORE : LOCATION OF GRID ORIGIN IN Y
!              XJPORE = (JP - NDGUNG)
!     XGGM0  : SCALE OF MAP FACTOR FUNCTION
!     XLON1R : ROTATED LONGITUDE OF SW CORNER OF DOMAIN
!     XLON1U : ROTATED LONGITUDE OF SW CORNER MODIFIED IF ASTRIDE GREENWICH
!     XLAT1R : ROTATED LATITUDE OF SW CORNER OF DOMAIN
!     XLON2R : ROTATED LONGITUDE OF NE CORNER OF DOMAIN
!     HSUD    = 1., DOMAIN IN NORTH HEMISPHERE OR IN TROPICAL BAND
!             = -1., DOMAIN PROJECTED BY STEREO/LAMBERT WITH RESPECT TO
!                   SOUTH POLE
!     XBETA  : ANGLE BETWEEN X-AXIS AND LATITUDE AT LONG. XLON0R

END MODULE YEMGGCM
