MODULE YEMGSL

USE PARKIND1  ,ONLY : JPRB

IMPLICIT NONE

SAVE

!----- Comdeck YEMGSL  *** FOR SEMI-LAGRANGIAN

REAL(KIND=JPRB) :: RIPORE
REAL(KIND=JPRB) :: RJPORE
REAL(KIND=JPRB) :: REGPK
REAL(KIND=JPRB) :: RNOBILE
REAL(KIND=JPRB) :: RLON0R
REAL(KIND=JPRB) :: RHSUD
REAL(KIND=JPRB) :: RMERCAT
REAL(KIND=JPRB) :: RLONC    
REAL(KIND=JPRB) :: RLATC 


!      FOR EFFICIENT REVERSE PROJECTION    
!     ---------------------------------------
!     THIS  BLOCK SHOULD NOT BE CONFUSED WITH ANY OTHER    
!     GEOMETRICAL  BLOCK! IT HOLDS EFFECTIVE GEOMETRICAL
!     PARAMETERS NEEDED IN ALADIN. ININTIALIZED IN SUEGEO.  

!     RIPORE : COPY OF XIPORE, X-location of the pole (Stereo/Lambert)
!     RJPORE : COPY OF XJPORE, Y-location of the pole (Stereo/Lambert)
!     REGPK  : COPY OF XGGPK , effective projection parameter
!     RNOBILE: QUANTITY TO SCALE THE DISTANCE TO THE POLE
!              r**2 * RNOBILE = [(1-sin(phi))/(1+sin(phi))]**REGPK  
!     RLON0R : ROTATED PROJECTION REFERENCE LONGITUDE (COPY OF XLON0R)                                   
!     RHSUD  : COPY OF HSUD                                      
!     RMERCAT: QUANTITY TO SCALE THE DISTANCE IN MERCATOR PROJECTION
!              x * RMERCAT = lon - lon0
!              y * RMERCAT = - ln(cos(phi)/(1.+sin(phi)))

END MODULE YEMGSL
