MODULE YEMGT3B

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

! ------------------------------------------------------
!   GMVCPL, GMVSCPL, GFLCPL replace GT3BUF. They are built like 
!             GMV with dimension YT0%NDIM, 
!             GMVS with dimension YT0%NDIMS,
!             GFL with dimension NDIMCPL  
!   GT3GRD (NLENGT3B) : Buffer for gradients of lateral boundary fields.
!   NLENGT3B : Length of the  buffer for lateral boundary fields.
!   NEDLST   : Nb. of points in E+I area (local var.) 
!   NLATGPP,NLONGPP: global lat,lon indx of a jproma,jgpblks point in gp-space 
!   NLATGT3,NLONGT3: global lat,lon index of coupling points
!   EALFAGT3,GMGT3 : ALFA and GM array of coupling points
!   SP3UBC : spectral boundary fields of geopotential on top of the atmosphere
!   NSP3UBC: number of fields stored in SP3UBC
! *****************************************************************************

INTEGER(KIND=JPIM),ALLOCATABLE:: NLATGPP(:,:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NLONGPP(:,:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NLATGT3(:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NLONGT3(:)
!*   Buffer for Lateral boundary field arrays.

INTEGER(KIND=JPIM) :: NEDLST

REAL(KIND=JPRB),ALLOCATABLE:: GMVCPL(:,:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: GMVSCPL(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: GFLCPL(:,:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: EALFAGT3(:,:)
REAL(KIND=JPRB),ALLOCATABLE:: GMGT3(:)
INTEGER(KIND=JPIM) :: NSP3UBC
REAL(KIND=JPRB), ALLOCATABLE :: SP3UBC(:,:,:)

!  ------------------------------------------------------------
END MODULE YEMGT3B

