MODULE YEMSPCPL

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------

!   NEK0   : LOWER LIMIT OF TOTAL WAVENUMBER FOR SPECTRAL COUPLING
!   NEK1   : UPPER      "
!   NEFRSPCPL: FREQUENCY OF SPECTRAL COUPLING
!   NLENGT3BSP: Length of the buffer for spectral coupling
!   NEDLSTSP  : Nb. of spectral coefficients in spectral buffer
!   NEN1   : Lower model level for spectral nudging 
!   NEN2   : Upper    "
!   GT3SPBUF (NLENGT3BSP) : Buffer for spectral boundary fields
!   SPNUDVOR : nudging coeficient for vorticity (spectral nudging) 
!   SPNUDDIV : nudging coeficient for divergence (spectral nudging) 
!   SPNUDT   : nudging coeficient for temperature (spectral nudging) 
!   SPNUDQ   : nudging coeficient for specific humidity (spectral nudging) 
!   SPNUDSP  : nudging coeficient for surface pressure (spectral nudging) 
INTEGER(KIND=JPIM) :: NEK0
INTEGER(KIND=JPIM) :: NEK1
INTEGER(KIND=JPIM) :: NEFRSPCPL
INTEGER(KIND=JPIM) :: NLENGT3BSP
INTEGER(KIND=JPIM) :: NEDLSTSP
INTEGER(KIND=JPIM) :: NEN1
INTEGER(KIND=JPIM) :: NEN2
REAL(KIND=JPRB),ALLOCATABLE :: GT3SPBUF(:)
REAL(KIND=JPRB) :: SPNUDVOR
REAL(KIND=JPRB) :: SPNUDDIV
REAL(KIND=JPRB) :: SPNUDT
REAL(KIND=JPRB) :: SPNUDQ
REAL(KIND=JPRB) :: SPNUDSP
!     ------------------------------------------------------------------
END MODULE YEMSPCPL
