! Library:phys $Id: yhlconst.F90 5170 2007-05-31 09:22:45Z towil $

module yhlconst

use parkind1,  only : jprb

implicit none
save

!*
!     ------------------------------------------------------------------
!     CONSTANTS USED IN HIRLAM PHYSICS 
!     (initialized in subroutine "suhlconst" by means of ARPEGE general
!     constants from modules "yomcst" and "yomphy0" for consistency.
!     ------------------------------------------------------------------

!       pi      : Half the curvature distance around a circle of unit   
!               : radius.
!       latvap  : Specific latent heat of fusion 
!               : 
!       rair    : Specific gas constant of dry air
!               : 
!       cpair   : Specific heat capacity at constant pressure (dry air)
!               : 
!       ccpq    : Ratio of specific heat capacity of dry water vapor and 
!                 of dry air minus 1 (used to define heat capacity of
!                 moist air). 
!               : 
!       epsilo  : ratio of molecular weight of water to that of dry air. 
!               :  
!       gravit  : acceleraktion of gravity.
!               : 
!       tmelt   : melting temperature of water.
!               : 
!       latice  : Specific heat of melting of ice.
!               : 
!       rhowater: Density of water.   
!               :
!       solar   : solar flux constant 
!               : 
!       stebol  : Stefan Boltzmann's constant 
!               : 
!       carman  : Von Karman's constant 
!               : 
!       rearth  : Radius of planet earth. 
!               : 
!       omega   : angular velocity for the earth rotation. 
!               :
!       cpv     :

real(kind=jprb) :: pi
real(kind=jprb) :: latvap
real(kind=jprb) :: rair
real(kind=jprb) :: cpair
real(kind=jprb) :: ccpq
real(kind=jprb) :: epsilo
real(kind=jprb) :: gravit
real(kind=jprb) :: tmelt
real(kind=jprb) :: latice
real(kind=jprb) :: rhowater
real(kind=jprb) :: solar
real(kind=jprb) :: stebol
real(kind=jprb) :: carman
real(kind=jprb) :: rearth
real(kind=jprb) :: omega
real(kind=jprb) :: cpv


end module yhlconst
