! Library:phys $Id: yhloption.F90 4917 2007-02-07 13:05:42Z towil $

module yhloption

!  Initialize basic logical switches for using HIRLAM physics.

use parkind1, only :  jpim

implicit none
save

!     ------------------------------------------------------------
!        LHL          : CLE ACTIVANT LA PHYSIQUE HIRLAM
!                     : KEY ACTIVATING THE HIRLAM PHYSICS
!                     :
!        LHLORIG      : CLE ACTIVANT ORIGINAL HIRLAM METHODE
!                       KEY ACTIVATING ORIGINAL HIRLAM METHOD
!                     :
!        LHLTEND      : CLE ACTIVANT HIRLAM TENDANCE ACCUMULATION 
!                       POUR LES PROCESSES RADIATIVE, TURBULENCE ET 
!                       CONDENSATION/CONVECTION AU LIEU DE ACCUMULA-
!                       ION DE FLUX (IMPLEMENTATION ALADIN).
!                       KEY ACTIVATING ACCULATION OF TENDENCIES 
!                       FOR THE PROCESSES OF RADIATION, TURBULENCE,
!                       AND CONDENSATION/CONVECTION 
!                       (IMPLEMENTATION IN ALADIN).
!                     :
!        HLPRT        : KEY ACTIVATING HIRLAM DIAGNOSTIC PRINTING
!                     :
!        JSCHEME      : PARAMETER DESCRIBING THE MAXIMUM NUMBER 
!                       OF DIFFERENT HIRLAM PHYSICAL PROCESSES 
!                       WHICH MAY BE IMPLEMENTED.
!                     : 
!        HLOPTION     : INTEGER ARRAY DESCRIBING CHOICES FOR 
!                       PARAMETERIZATION SCHEMES. THE NUMBER OF
!                       POSSIBLE PROCESSES EACH OF WHICH MAY 
!                       BE DESCRIBED BY SOME PARAMETERIZATION 
!                       ARE GIVEN BY THE PARAMETER DIMENSION 
!                       JSCHEME.         


logical                        :: lhl
logical                        :: lhlorig
logical                        :: lhltend
integer(kind=jpim)             :: hlprt
integer(kind=jpim), parameter  :: jscheme = 20
integer(kind=jpim)             :: hloption(1:jscheme)

end module yhloption
