MODULE YOE_PI_AERO


USE PARKIND1 ,ONLY : JPIM  , JPRB

IMPLICIT NONE

!---preindustrial aerosol optical properties
REAL(KIND=JPRB), ALLOCATABLE, PUBLIC :: PI_AOD(:,:,:,:)
REAL(KIND=JPRB), ALLOCATABLE, PUBLIC :: PI_ABS(:,:,:,:)
REAL(KIND=JPRB), ALLOCATABLE, PUBLIC :: PI_XASY(:,:,:,:)
  
!---preindustrial aerosol mass and number mixing ratios
REAL(KIND=JPRB), ALLOCATABLE, PUBLIC :: PI_AERO(:,:,:,:)
!---same thing on the full physics grid
REAL(KIND=JPRB), ALLOCATABLE, PUBLIC :: PI_AERO_PHY(:,:,:,:)

INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: NPIAERO = 22

!---flag to tell whether TM5 data have been updated
LOGICAL :: LPI_AERO_UPDATED

!---indices for aerosol mass/number field PI_AERO 
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPINUM_KS = 1
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPINUM_AS = 2
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPINUM_CS = 3
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMSO4_KS = 4
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMSO4_AS = 5
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMSO4_CS = 6
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMBC_KS = 7
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMBC_AS = 8
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMBC_CS = 9
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMBC_KI = 10
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMOC_KS = 11
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMOC_AS = 12
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMOC_CS = 13
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMOC_KI = 14
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMSS_AS = 15
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMSS_CS = 16
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMDU_AS = 17
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMDU_CS = 18
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMDU_AI = 19
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMDU_CI = 20
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMNO3 = 21
INTEGER(KIND=JPIM), PARAMETER, PUBLIC :: IPIMMSA = 22


END MODULE YOE_PI_AERO
