MODULE YOEAERATM

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------
!*    ** *YOEAERATM* - CONTROL PARAMETERS FOR AEROSOLS IN THE ATMOSPHERE
!     ------------------------------------------------------------------

INTEGER(KIND=JPIM) :: NAERCONF
INTEGER(KIND=JPIM) :: NINIDAY   
INTEGER(KIND=JPIM) :: NXT3DAER

REAL(KIND=JPRB) :: RGRATE
REAL(KIND=JPRB) :: RMASSE(15)

REAL(KIND=JPRB) :: REPSCAER

LOGICAL :: LAERCLIMG, LAERCLIMZ, LAERCLIST, LAERDRYDP, LAERHYGRO, LAERLISI 
LOGICAL :: LAERNGAT , LAERSCAV , LAERSEDIM, LAERSURF, LAER6SDIA
LOGICAL :: LAERGTOP , LAERRAD  , LAERCCN  , LAEROPT(8)
LOGICAL :: LAERUVP  , LUVINDX

!     ------------------------------------------------------------------
! RGRATE     : transformation rate from hygrophopic to hygrophilic for BC and OM aerosols
! RMASSE     : Molar mass: N.B.: either g/mol or Avogadro number

! REPSCAER   : security on aerosol concentration: always >= 1.E-15

! LAERCLIMG  : .T. to start prognostic aerosols with geographical monthly 
!                  mean climatology
! LAERCLIMZ  : .T. to start prognostic aerosols with zonal annual mean 
!                  climatology
! LAERCLIST  : .T. to start prognostic aerosols with geographical monthly 
!                  mean climatology for background stratospheric only
! LAERDRYDP  : .T. dry deposition is active
! LAERHYDRO  : .T. hygroscopic effects on BC and OM aerosols
! LAERNGAT   : .T. prevents negative aerosol concentrations
! LAERSCAV   : .T. in-cloud and below cloud scavenging is active
! LAERSEDIM  : .T. sedimentation is active
! LAERSURF   : .T. if surface emissions
! LAER6SDIA  : .T. if radiance diagnostics with 6S
! LAERGTOP   : .T. if gas-to-particle conversion for SO2/SO4
! LAERRAD    : .T. if there is any prognostic aerosols used for RT
! LAEROPT(.) : .T. if a given aerosol type is radiatively interactive
! LAERCCN    : .T. if prognostic aerosols are used to define the Re of liq.wat.clds
! LAERUVP    : .T. if prognostic aerosols are used in UV-processor
!     ------------------------------------------------------------------
END MODULE YOEAERATM

