MODULE YOEAERC

USE PARKIND1  ,ONLY : JPRB

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------
!*    ** *YOEAERC* - TEGEN/GISS AEROSOL CLIMATOLOGY
!     ------------------------------------------------------------------

REAL(KIND=JPRB) :: RAERBC(72,46,12), RAEROR(72,46,12), RAERSD(72,46,12)
REAL(KIND=JPRB) :: RAERSS(72,46,12), RAERSU(72,46,12)
REAL(KIND=JPRB) :: REPAER
REAL(KIND=JPRB) :: RTAEBC(72,46)   , RTAEOR(72,46)   , RTAESD(72,46)
REAL(KIND=JPRB) :: RTAESS(72,46)   , RTAESU(72,46)   , RTAEVO(46)
REAL(KIND=JPRB) :: RTAESO4(96,73)  , RVOLCDEC

!        * E.C.M.W.F. PHYSICS PACKAGE *

!     J.-J. MORCRETTE       E.C.M.W.F.      98/12/21

!  NAME     TYPE    PURPOSE
!  ----  :  ----  : ---------------------------------------------------
! RAERBC : REAL   : OPTICAL THICKNESS BLACK CARBON TYPE AEROSOL
! RAEROR : REAL   : OPTICAL THICKNESS ORGANIC TYPE AEROSOL
! RAERSD : REAL   : OPTICAL THICKNESS SOIL-DUST TYPE AEROSOL
! RAERSS : REAL   : OPTICAL THICKNESS SEA-SALT TYPE AEROSOL
! RAERSU : REAL   : OPTICAL THICKNESS SULFATE-TYPE AEROSOL
! REPAER : REAL   : SECURITY PARAMETER FOR AEROSOLS
! RTAEBC : REAL   : TIME-INTERPOLATED BLACK CARBON OPTICAL THICKNESS
! RTAEOR : REAL   : TIME-INTERPOLATED ORGANIC OPTICAL THICKNESS
! RTAESD : REAL   : TIME-INTERPOLATED SOIL-DUST OPTICAL THICKNESS
! RTAESS : REAL   : TIME-INTERPOLATED SEA-SALT OPTICAL THICKNESS
! RTAESU : REAL   : TIME-INTERPOLATED SULFATE CARBON OPTICAL THICKNESS
! RTAEVO : REAL   : TIME-INTERPOLATED STRATOS.VOLCANIC OPTICAL THICKNESS
! RTAESO4: REAL   : TIME-INTERPOLATED SULPHATE AMOUNT (O.BOUCHER'S CLIMATOLOGY)
! RVOLCDEC : REAL : Factor that multiplies the volcanic aerosol depth
!                   (needed for exponential decay if NVOLCSTOP is set)
!     ------------------------------------------------------------------
END MODULE YOEAERC

