MODULE YOEAERLID

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------
!*    ** *YOEAERLID* - PARAMETERS AND COEFFICIENTS FOR GEMS/MACC LIDAR 
!                      SIMULATOR OF AEROSOL EFFECTS
!     ------------------------------------------------------------------
!
!     JJMorcrette, 20090702

INTEGER(KIND=JPIM) :: NWLID, JWLID(3)
REAL(KIND=JPRB) :: RWLID(3)
REAL(KIND=JPRB) :: RLICO2(6)
REAL(KIND=JPRB) :: RLIO2(6)
REAL(KIND=JPRB) :: RLINO2(5,3)
REAL(KIND=JPRB) :: RLIO3(5,3)

REAL(KIND=JPRB) :: RLICLS, RLIDELT, RLINS, RLIPREF, RLITREF, RLIT0

!     ------------------------------------------------------------------
! NWLID   : NUMBER OF WAVELENGTHS IN THE LIDAR SIMULATOR
! JWLID   : INDICES OF WAVELENGTHS FOR LIDAR SIMULATOR
! RWLID   : WAVELENGTHS FOR LIDAR SIMULATOR
! RLICLS  : CALIBRATION FACTOR FOR LIDAR 
! RLICO2  : CO2 ABSORPTION COEFFICIENTS (MALKMUS MODEL) 
! RLIO2   : O2 ABSORPTION COEFFCIENTS   (MALKMUS MODEL)
! RLINO2  : NO2 ABSORPTION CROSS-SECTION (CM2/MOLEC)
! RLIO3   : O3 ABSORPTION CROSS-SECTION (CM2/MOLEC)
! RLIDELT : PARAMETER IN EXPRESSION OF RAYLEIGH SCATTERING OPTICAL THICKNESS
! RLINS   : PARAMETER IN EXPRESSION OF RAYLEIGH SCATTERING OPTICAL THICKNESS
! RLIPREF : REFERENCE PRESSURE	(RAYLEIGH)
! RLITREF : REFERENCE TEMPERATURE (RAYLEIGH)
! RLIT0   : REFERENCE TEMPERATURE (MALKMUS MODEL)
!     ------------------------------------------------------------------
END MODULE YOEAERLID
