MODULE YOECLOP550

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------
!     * YOECLOP550* PARAMETERS FOR CLOUD OPTICAL PROPERTIES
!     ------------------------------------------------------------------

REAL(KIND=JPRB) :: RSA55, RSB55, RSC55, RSD55, RSE55, RSF55

REAL(KIND=JPRB) :: RFA55(2), RFB55(4), RFC55(4), RFD55(4)

!*    SLINGO (1989) WATER CLOUD OPTICAL PROPERTIES

! RSA :  REAL   : C1 IN OPTICAL THICKNESS FORMULA
! RSB :  REAL   : C2 IN OPTICAL THICKNESS FORMULA
! RSC :  REAL   : SINGLE SCATTERING ALBEDO PARAMETER
! RSD :  REAL   : SINGLE SCATTERING ALBEDO PARAMETER
! RSE :  REAL   : ASSYMETRY FACTOR 
! RSF :  REAL   : ASSYMETRY FACTOR

!*    ICE CLOUD OPTICAL PROPERTIES DERIVED FROM FU (1996)

! RFA :  REAL   : COEFFICIENTS IN EXPRESSION FOR SW EXTINCTION COEFF.
! RFB :  REAL   : COEFFICIENTS IN EXPRESSION FOR SW SINGLE SCATT.ALB.
! RFC :  REAL   : COEFFICIENTS IN EXPRESSION FOR SW ASSYMETRY FACTOR
! RFD :  REAL   : COEFFICIENTS IN EXPRESSION FOR SW DELTA FUNCTION

!     -----------------------------------------------------------------
END MODULE YOECLOP550
