MODULE YOEGWD

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!     -----------------------------------------------------------------
!*    ** *YOEGWD* - PARAMETERS FOR GRAVITY WAVE DRAG CALCULATIONS
!     -----------------------------------------------------------------

INTEGER(KIND=JPIM) :: NKTOPG
INTEGER(KIND=JPIM) :: NGWDLIM
INTEGER(KIND=JPIM) :: NGWDTOP
REAL(KIND=JPRB) :: GFRCRIT
REAL(KIND=JPRB) :: GRCRIT
REAL(KIND=JPRB) :: GKDRAG
REAL(KIND=JPRB) :: GKWAKE
REAL(KIND=JPRB) :: GSSEC
REAL(KIND=JPRB) :: GTSEC
REAL(KIND=JPRB) :: GVSEC
REAL(KIND=JPRB) :: GTENLIM
REAL(KIND=JPRB) :: GRFPLM

!        * E.C.M.W.F. PHYSICS PACKAGE *

!     M. J. MILLER          E.C.M.W.F.      89/12/14

!  NAME     TYPE     PURPOSE
!  ----  :  ----   : ---------------------------------------------------

! GFRCRIT: CRITICAL FROUDE NUMBER
! GRCRIT : CRITICAL RICHARDSON NUMBER FOR ONSET OF WAVE TURBULENCE.
! GKDRAG : DRAG CONSTANT (PROPORTIONAL TO WAVENUMBER)
! GKWAKE : DRAG COEFFICIENT FOR LOWLEVEL WAKE DRAG
! NKTOPG : NUMBER OF TOPMOST LAYER USED TO DEFINE LOW-LEVEL FLOW
! NGWDLIM: VERTICAL LEVEL ABOVE WHICH THE WIND TENDENCIES WILL BE LIMITED 
!          TO GTENLIM
! GTENLIM: LIMITER FOR WIND TENDENCIES IN THE STRATOSPHERE AND MESOSPHERE
! GRFPLM : PRESUURE LIMIT FOR RAYLEIGH FRICTION
! NGWDTOP: INDEX FOR GRFPLM


!*    SECURITY PARAMETERS.
!     --------------------

! GSSEC  : TO SECURE STABILITY.
! GTSEC  : TO SECURE THE STRESS CALCULATION.
! GVSEC  : TO SECURE THE PROJECTION CALCULATION.
!     -----------------------------------------------------------------
END MODULE YOEGWD
