MODULE YOM_REO3_BCOR

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!  Module containing structures and parameters used for bias correction
!  of ozone data (reo3)

!  April 2003       Antje Dethof
!======================================================================

INTEGER(KIND=JPIM), PARAMETER     :: jpmax_nam_len=12     ! Length of predictor/inst names
INTEGER(KIND=JPIM), PARAMETER     :: jpmax_regfile_len=128! Length of correction file names
INTEGER(KIND=JPIM), PARAMETER     :: jpmax_npreds=1       ! Maximum number of predictors

TYPE reo3_bc_info                 ! Structure for o3 bias correction info
INTEGER(KIND=JPIM)                              :: sat_id    ! Satellite ID
INTEGER(KIND=JPIM)                              :: sensor    ! Sensor ID
INTEGER(KIND=JPIM)                              :: varno     ! Variable Number
INTEGER(KIND=JPIM)                              :: npreds    ! Number of predictors
CHARACTER(LEN=jpmax_nam_len), DIMENSION(jpmax_npreds) :: pred_name
REAL(KIND=JPRB), DIMENSION(jpmax_npreds)        :: pred_min(jpmax_npreds)
!                                       ! min pred value to use
REAL(KIND=JPRB), DIMENSION(jpmax_npreds)        :: pred_max(jpmax_npreds)
!                                       ! max pred value to use
CHARACTER(LEN=jpmax_nam_len)         :: bcor_inst ! Name of instrument 
!                                                     used for bcor
REAL(KIND=JPRB), DIMENSION(0:jpmax_npreds)      :: coef      ! Coefficients
END TYPE reo3_bc_info

TYPE(reo3_bc_info), ALLOCATABLE, DIMENSION(:)            :: o3bc_info
TYPE(reo3_bc_info), ALLOCATABLE, DIMENSION(:)            :: ch4bc_info
  ! Array containing the bcor info to be used

INTEGER(KIND=JPIM)                :: nbc_info  ! Number of reassignment infos to be used
INTEGER(KIND=JPIM)                :: nch4bc_info  ! Number of reassignment infos to be used

END MODULE YOM_REO3_BCOR
