MODULE YOM_REO3_THIN

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!  Module containing structures and parameters used for thinning
!  of ozone data (reo3)

!  August 2004      Antje Dethof
!======================================================================

TYPE reo3_thin_info           ! Structure for o3 thinning info
  INTEGER(KIND=JPIM)          :: sensor   ! Sensor ID
  INTEGER(KIND=JPIM)          :: varno    ! variable number
  REAL(KIND=JPRB)             :: rmind    ! size of first thinning box in degrees
  REAL(KIND=JPRB)             :: rfind    ! size of 2nd thinning box in degrees
END TYPE reo3_thin_info

TYPE(reo3_thin_info), ALLOCATABLE, DIMENSION(:)       :: o3thin_info
  ! Array containing the bcor info to be used

INTEGER(KIND=JPIM)            :: n_reo3_thin_info  ! Number of thinning infos to be used

END MODULE YOM_REO3_THIN
