MODULE YOMANEB

USE PARKIND1  ,ONLY : JPIM

USE GRIDPOINT_BUFFERS_MIX , ONLY : gridpoint_buffer
USE YOM_YGFL, ONLY : JPGHG, JPGRG

USE YOMJG, ONLY : JPAEROCV

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------

!*    Buffer for gridpoint workfile for analysis and new forecast errors

! ANEBUF                : buffer
! NANEBU                : locates u errors in buffer
! NANEBV                : locates v errors in buffer
! NANEBZ                : locates geopotential errors in buffer
! NANEBQ                : locates Q errors in buffer
! NANEBR                : locates RH errors in buffer
! NANEBT                : locates T errors in buffer
! NANEBVO               : locates vorticity errors in buffer
! NANEBRAD              : locates TOVS radiance errors in buffer
! NANEBTCW              : locates Total Column Water errors in buffer
! NANEBRH2              : locates 2M Relative Humidity errors in buffer
! NANEBU10              : locates 10M u-component errors in buffer
! NANEBV10              : locates 10M v-component errors in buffer
! NANEBT2               : locates 2M temperature errors in buffer
! NANEBO3               : locates ozone errors in buffer
! NANEBGRG              : locates GRG in buffer
! NANEBAERO             : locates AERO in buffer
! NANEBTO3              : locates total column ozone errors in buffer
! NANEBSP               : locates surface pressure errors in buffer
! NANEVARS              : number of analysis error variables
! NANERADS              : number of analysis error radiances
! NANERADL              : list of analysis error radiances channels

INTEGER(KIND=JPIM) :: NANEBU
INTEGER(KIND=JPIM) :: NANEBV
INTEGER(KIND=JPIM) :: NANEBZ
INTEGER(KIND=JPIM) :: NANEBQ
INTEGER(KIND=JPIM) :: NANEBR
INTEGER(KIND=JPIM) :: NANEBT
INTEGER(KIND=JPIM) :: NANEBVO
INTEGER(KIND=JPIM) :: NANEBRAD
INTEGER(KIND=JPIM) :: NANEBTCW
INTEGER(KIND=JPIM) :: NANEBRH2
INTEGER(KIND=JPIM) :: NANEBU10
INTEGER(KIND=JPIM) :: NANEBV10
INTEGER(KIND=JPIM) :: NANEBT2
INTEGER(KIND=JPIM) :: NANEBO3
INTEGER(KIND=JPIM), DIMENSION(JPGHG) :: NANEBGHG
INTEGER(KIND=JPIM), DIMENSION(JPGRG) :: NANEBGRG
INTEGER(KIND=JPIM), DIMENSION(JPAEROCV) :: NANEBAERO
INTEGER(KIND=JPIM) :: NANEBTO3
INTEGER(KIND=JPIM) :: NANEBSP
INTEGER(KIND=JPIM) :: NANEVARS
INTEGER(KIND=JPIM) :: NANERADS

TYPE(gridpoint_buffer) :: ANEBUF
INTEGER(KIND=JPIM),ALLOCATABLE:: NANERADL(:)

!     ------------------------------------------------------------------
END MODULE YOMANEB
