MODULE YOMARG

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE PARDIM    ,ONLY : JPMXLE   ,JPMXGL

IMPLICIT NONE

SAVE

!     ----------------------------------------------------------------

!*    Command line arguments - File frame information

!    NARGS      : Number of arguments in command line

!    Arguments to be got from command line :

!    NUCONF     : Configuration for 3D integration.
!    UTSTEP     : Time step in second
!    NUSLAG     : Semi lagrangian switch
!    NUSTOP     : Number of time step (can be given in hours)
!    NUECMWF    : Switch to discrimine the user : ECMWF or METEO-FRANCE
!    CUNMEXP    : Name of the experiment
!    LUELAM     : .TRUE. if model is LELAM

!    Information coming frome matrix file (for stretched coordinates)

!    NUTMAX     : Truncation order for tendencies
!    NUCMAX     : Maximum truncation

!    Information coming frome input file

!    NUDGL      : Number of latitudes
!    NUDLON     : Number of longitudes
!    NUFLEV     : Number of vertical levels
!    NUSMAX     : Nominal troncation
!    NUHTYP     : Type of grid (reduced or not)
!    NULOEN     : number of points on each latitude
!    NUMEN      : number of Fourier wavenumbers on each latitude
!    USTRET     : Stretching factor
!    UMUCEN     : Sine of latitude of the pole of stretching
!    ULOCEN     : Cosine of longitude of the pole of stretching
!    NUSTTYP    : Type of transformation (rotated or not)
!    UVALH      : Vertical function *A*
!    UVBH       : Vertical function *B*

!    NINDAT     : Date
!    NUDATE     : Time

!    NULIM      : Limited Area characteristics
!    UGEMU      : Horizontal geometry characteristics
!    UBETA      : map orientation characteristics

INTEGER(KIND=JPIM) :: NULOEN(JPMXGL/2)
INTEGER(KIND=JPIM) :: NUMEN(JPMXGL/2)
INTEGER(KIND=JPIM) :: NULIM(8)
INTEGER(KIND=JPIM):: NUCONF=-1
INTEGER(KIND=JPIM):: NUSTOP=-9
INTEGER(KIND=JPIM):: NUECMWF=-1
INTEGER(KIND=JPIM):: NUSLAG=-1
INTEGER(KIND=JPIM):: NARGS=0
CHARACTER (LEN = 4):: CUNMEXP='-9'
LOGICAL:: LUELAM=.FALSE.
REAL(KIND=JPRB) :: UVALH(0:JPMXLE)
REAL(KIND=JPRB) :: UVBH(0:JPMXLE)
REAL(KIND=JPRB) :: UGEMU(JPMXGL/2)
REAL(KIND=JPRB):: UTSTEP=-9._JPRB

INTEGER(KIND=JPIM) :: NUTMAX
INTEGER(KIND=JPIM) :: NUCMAX
INTEGER(KIND=JPIM) :: NUDGL
INTEGER(KIND=JPIM) :: NUDLON
INTEGER(KIND=JPIM) :: NUFLEV
INTEGER(KIND=JPIM) :: NUSMAX
INTEGER(KIND=JPIM) :: NUHTYP
INTEGER(KIND=JPIM) :: NUSTTYP
INTEGER(KIND=JPIM) :: NUDATE
INTEGER(KIND=JPIM) :: NUSSSS
REAL(KIND=JPRB) :: USTRET
REAL(KIND=JPRB) :: UMUCEN
REAL(KIND=JPRB) :: ULOCEN
REAL(KIND=JPRB) :: UBETA
!     ------------------------------------------------------------------
END MODULE YOMARG
