MODULE YOMASCATSM

USE PARKIND1  ,ONLY : JPIM, JPRB
USE PARDIM    ,ONLY : JPMXGL

IMPLICIT NONE

SAVE

!*    -----------------------------------------------------------
!*    Variables for the ASCAT Soil Moisture Observation Operator
!*    -----------------------------------------------------------

!     A, B - parameters for linear scaling of Scatterometer soil moisture
!            derived from an offline analysis (stored in grib fields at T159 res.)

!     INROWS, ILONE, ZLAT0, ZLATI0 - definition of the geometry of the A, B grib fields


!     Author:
!     K. Scipal *ECMWF* 30/11/07
!     ------------------------------------------------------------------


REAL(KIND=JPRB), allocatable :: A(:), B(:)

INTEGER(KIND=JPIM)           :: INROWS
INTEGER(KIND=JPIM)           :: ILONE(JPMXGL)
REAL(KIND=JPRB)              :: ZLAT0, ZLATI0

END MODULE YOMASCATSM
