MODULE YOMCFU

USE PARKIND1,    ONLY : JPIM
USE TYPE_FLUXES, ONLY : fluxes_descriptor

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------

!*    CONTROLS FLUX ACCUMULATION

! LCUMFU = .F.   ===> EVERYTHING SWITCH OFF
! LREACFU= .T.   ===> READ FIRST INPUT ON HISTORY FILE

! LSTRD  = .T.   ===> GRAVITY WAVE DRAG MOMENTUM FLUX
! LTSTRD  = .T.       => AT ALL LEVELS
! LSTRC  = .T.   ===> CONVECTIVE  Q,CPT,MOMENTUM FLUXES
! LTSTRC  = .T.       => AT ALL LEVELS
! LSTRT  = .T.   ===> TURBULENT   Q,CPT,MOMENTUM FLUXES
! LTSTRT  = .T.       => AT ALL LEVELS
! LFPLC  = .T.   ===> CONVECTIVE PRECIP
! LTFPLC  = .T.       => AT ALL LEVELS
! LFPLCG  = .T.   ===> CONVECTIVE PRECIP as GRAUPEL
! LFPLCH  = .T.   ===> CONVECTIVE PRECIP as HAIL
! LFPLS  = .T.   ===> STRATIFORM PRECIP
! LTFPLS  = .T.       => AT ALL LEVELS
! LFPLSG  = .T.   ===> STRATIFORM PRECIP as GRAUPEL
! LFPLSH  = .T.   ===> STRATIFORM PRECIP as HAIL
! LFR    = .T.   ===> RADIATION FLUXES
! LTFR    = .T.       => AT ALL LEVELS
! LTNEB   = .T.   ===> CLOUDINESS AT ALL LEVELS
! LNEBTT = .T.   ===> TOTAL CLOUDINESS
! LNEBPAR= .T.   ===> PARTIAL CLOUDINESS
! LFSF   = .T.   ===> SURFACE FLUXES
! LFSOIL = .T.   ===> SOIL FLUXES
! LAMIP  = .T.   ===> AMIP OUTPUT
! LFRRC  = .T.   ===> CLEAR SKY RADIATION CALCULATION
! LRAYS  = .T.   ===> MORE RADIATIVE FLUXES
! LRAYD  = .T.   ===> DOWNWARDS SURFACE RADIATIVE FLUXES
! LFDUTP = .T.   ===> FILTERED DURATION OF TOTAL PRECIPITATIONS
! LMOON = .T.    ===> MOON RADIATION

! NFRRC               FREQUENCY FOR CLEAR SKY RADIATION CALCULATION

! NFRCFU  : FREQUENCY OF WRITE UP OF FLUX DIAGNOSTICS
! NCFUTS  : ARRAY CONTAINING FLUX ACCUMULATION WRITE-UP STEPS
!     SEE YOMCT0 FOR EXPLANATION

! NFDCFU : total number of fields in buffer
! NTYPCFU: number of fluxes types in buffer

INTEGER(KIND=JPIM), PARAMETER :: JPFUST=40
INTEGER(KIND=JPIM), PARAMETER :: JPMXCFU=99
INTEGER(KIND=JPIM) :: NCFUTS(0:JPFUST)
INTEGER(KIND=JPIM) :: NFRRC
INTEGER(KIND=JPIM) :: NFRCFU
INTEGER(KIND=JPIM) :: NFDCFU
INTEGER(KIND=JPIM) :: NTYPCFU

TYPE(fluxes_descriptor) :: TYPE_CFU(JPMXCFU)

LOGICAL :: LCUMFU
LOGICAL :: LREACFU
LOGICAL :: LSTRD
LOGICAL :: LSTRC
LOGICAL :: LSTRT
LOGICAL :: LFPLC
LOGICAL :: LFPLCG
LOGICAL :: LFPLCH
LOGICAL :: LFPLS
LOGICAL :: LFPLSG
LOGICAL :: LFPLSH
LOGICAL :: LFR
LOGICAL :: LAMIP
LOGICAL :: LRAYS
LOGICAL :: LRAYD
LOGICAL :: LNEBTT
LOGICAL :: LFSF
LOGICAL :: LFSOIL
LOGICAL :: LNEBPAR
LOGICAL :: LTSTRD
LOGICAL :: LTSTRC
LOGICAL :: LTSTRT
LOGICAL :: LTFPLC
LOGICAL :: LTFPLS
LOGICAL :: LTFR
LOGICAL :: LTNEB
LOGICAL :: LFDUTP
LOGICAL :: LMOON
LOGICAL :: LFRRC

!     ------------------------------------------------------------
END MODULE YOMCFU
