MODULE YOMCHCOD

USE PARCMA, ONLY : JPMXLID, JPMXPCD

IMPLICIT NONE

SAVE

!*     YOMCHCOD - VARIOUS CMA CODES (CHARACTER VERSION)

!        D. VASILJEVIC   ECMWF     15/09/94

!     UPPER AIR (TEMP AND PILOT) LEVEL IDENTIFIER CODES:

!     NAME        TYPE                   MEANING
!     ----        ----                   -------
!     CIDLEV  ( 1)  C    'MAX WIND LEVEL'
!     CIDLEV  ( 2)  C    'TROPOPAUSE'
!     CIDLEV  ( 3)  C    'D PART'
!     CIDLEV  ( 4)  C    'C PART'
!     CIDLEV  ( 5)  C    'B PART'
!     CIDLEV  ( 6)  C    'A PART'
!     CIDLEV  ( 7)  C    'SURFACE LEVEL'
!     CIDLEV  ( 8)  C    'SIGNIFICANT WIND LEVEL'
!     CIDLEV  ( 9)  C    'SIGNIFICANT TEMPERATURE LEVEL'

!     SYNOP PRESSURE CODES:

!     NAME        TYPE                   MEANING
!     ----        ----                   -------
!     CPRESCD ( 1)  C    ' 0 - SEA LEVEL'
!     CPRESCD ( 2)  C    ' 1 - STATION LEVEL PRESSURE'
!     CPRESCD ( 3)  C    ' 2 - 850MB GEOPOTENTIAL'
!     CPRESCD ( 4)  C    ' 3 - 700MB GEOPOTENTIAL'
!     CPRESCD ( 5)  C    ' 4 - 500GPM PRESSURE'
!     CPRESCD ( 6)  C    ' 5 - 1000GPM PRESSURE'
!     CPRESCD ( 7)  C    ' 6 - 2000GPM PRESSURE'
!     CPRESCD ( 8)  C    ' 7 - 3000GPM PRESSURE'
!     CPRESCD ( 9)  C    ' 8 - 4000GPM PRESSURE'
!     CPRESCD (10)  C    ' 9 - 900MB GEOPOTENTIAL'
!     CPRESCD (11)  C    '10 - 1000MB GEOPOTENTIAL'
!     CPRESCD (12)  C    '11 - 500MB GEOPOTENTIAL'
!     CPRESCD (13)  C    '12 - 925MB GEOPOTENTIAL'

CHARACTER (LEN = 64) ::  CIDLEV (JPMXLID)
CHARACTER (LEN = 64) ::  CPRESCD(JPMXPCD)

!-----------------------------------------------------------------------

END MODULE YOMCHCOD
