MODULE YOMCHEV

USE PARCMA, ONLY : JPMXRE1, JPMXRE2, JPMXOTP, JPMXRBLE, JPMXDE1, JPMXDE2, JPMXDBLE

IMPLICIT NONE

SAVE

!*     YOMCHEV - CMA EVENTS (CHARACTER VERSION)

!        D. VASILJEVIC   ECMWF     15/09/94

!     REPORT EVENTS PART 1:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------
!     CR1EVENT( 1)      C     ' 1=NO DATA IN THE REPORT'
!     CR1EVENT( 2)      C     ' 2=ALL DATA REJECTED'
!     CR1EVENT( 3)      C     ' 3=BAD REPORTING PRACTICE'
!     CR1EVENT( 4)      C     ' 4=REJECTED DUE TO RDB FLAG'
!     CR1EVENT( 5)      C     ' 5=ACTIVATED DUE TO RDB FLAG' 
!     CR1EVENT( 6)      C     ' 6=ACTIVATED BY WHITELIST' 
!     CR1EVENT( 7)      C     ' 7=HORIZONTAL POSITION OUT OF RANGE'
!     CR1EVENT( 8)      C     ' 8=VERTICAL POSITION OUT OF RANGE'
!     CR1EVENT( 9)      C     ' 9=TIME OUT OF RANGE'
!     CR1EVENT(10)      C     '10=REDUNDANT REPORT'
!     CR1EVENT(11)      C     '11=REPORT OVER LAND'
!     CR1EVENT(12)      C     '12=REPORT OVER SEA'
!     CR1EVENT(13)      C     '13=MISSING STATION ALTITUDE'
!     CR1EVENT(14)      C     '14=MODEL SUR. TOO FAR FROM STAT. ALT.'
!     CR1EVENT(15)      C     '15=REPORT REJECTED THROUGH THE NAMELIST'
!     CR1EVENT(16)      C     '16=FAILED QUALITY CONTROL'

!     REPORT EVENTS PART 2:

!     SYNOP EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------

!     AIREP EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------

!     SATOB EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------

!     DRIBU EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------

!     TEMP EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------
!     CR2EVENT( 1, 5)   C     ' 1=OLD STYLE Z BIAS CORRECTION APPLIED'
!     CR2EVENT( 2, 5)   C     ' 2=NEW STYLE T BIAS CORRECTION APPLIED'
!     CR2EVENT( 3, 5)   C     ' 2=H BIAS CORRECTION APPLIED'

!     PILOT EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------

!     SATEM EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------

!     PAOB EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------

!     SCATT. EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------
!     CR2EVENT( 1, 9)   C     ' 1=THINNED REPORT'

!     LIMB EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------

!     DATA EVENTS PART 1:

!     NAME            TYPE               MEANING
!     ----            ----               -------
!     CH1EVENT( 1)      C    ' 1=MISSING VERTICAL COORDINATE'
!     CH1EVENT( 2)      C    ' 2=MISSING OBSERVED VALUE'
!     CH1EVENT( 3)      C    ' 3=MISSING FIRST GUESS VALUE'
!     CH1EVENT( 4)      C    ' 4=REJECTED DUE TO RDB FLAG'
!     CH1EVENT( 5)      C    ' 5=ACTIVATED DUE TO RDB FLAG'
!     CH1EVENT( 6)      C    ' 6=ACTIVATED BY WHITELIST'
!     CH1EVENT( 7)      C    ' 7=BAD REPORTING PRACTICE'
!     CH1EVENT( 8)      C    ' 8=VERTICAL POSITION OUT OF RANGE'
!     CH1EVENT( 9)      C    ' 9=REFERENCE LEVEL POSITION OUT OF RANGE'
!     CH1EVENT(10)      C    '10=TOO BIG FIRST GUESS DEPARTURE'
!     CH1EVENT(11)      C    '11=TOO BIG DEPARTURE IN ASSIMILATION'
!     CH1EVENT(12)      C    '12=TOO BIG OBSERVATION ERROR'
!     CH1EVENT(13)      C    '13=REDUNDANT DATUM'
!     CH1EVENT(14)      C    '14=REDUNDANT LEVEL'
!     CH1EVENT(15)      C    '15=REPORT OVER LAND'
!     CH1EVENT(16)      C    '16=REPORT OVER SEA'
!     CH1EVENT(17)      C    '17=NOT AN ANALYSIS VARIABLE'
!     CH1EVENT(18)      C    '18=DUPLICATED DATUM/LEVEL'
!     CH1EVENT(19)      C    '19=TOO MANY SURFACE DATA/LEVELS'
!     CH1EVENT(20)      C    '20=MULTI LEVEL CHECK'
!     CH1EVENT(21)      C    '21=LEVEL SELECTION'
!     CH1EVENT(22)      C    '22=VERTICAL CONSISTENCY CHECK'
!     CH1EVENT(23)      C    '23=VERTICAL COORDINATE CHANGED FROM Z TO P'
!     CH1EVENT(24)      C    '24=DATUM REJECTED THROUGH THE NAMELIST'
!     CH1EVENT(25)      C    '25=COMBINED FLAGGING'
!     CH1EVENT(26)      C    '26=DATUM REJECTED DUE TO REJECTED REPORT'
!     CH1EVENT(27)      C    '27=VARIATIONAL QC PERFORMED'

!     DATA EVENTS PART 2:

!     SYNOP EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------

!     AIREP EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------

!     SATOB EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------

!     DRIBU EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------

!     TEMP EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------
!     CD2EVENT( 1, 5)   C    ' 1=BIAS CORRECTED VALUE USED'

!     PILOT EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------

!     SATEM EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------
!     CD2EVENT( 1, 7)   C    ' 1=NOT PREDEFINED LAYER'
!     CD2EVENT( 2, 7)   C    ' 2=LAYER FORMED BY THINNING UP'
!     CD2EVENT( 3, 7)   C    ' 3=LAYER FORMED BY SUMMING UP'
!     CD2EVENT( 4, 7)   C    ' 4=CHANNEL NOT USED IN ANALYSIS'
!     CD2EVENT( 5, 7)   C    ' 5=OVERWRITTEN BY ADVAR'

!     PAOB EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------

!     SCATT EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------

!     LIMB EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------

!     REPORT BLACKLIST EVENTS:

!     NAME            TYPE                   MEANING
!     ----            ----                   -------
!     CRBLEVEN( 1)      C    ' 1=MONTHLY MONITORING'
!     CRBLEVEN( 2)      C    ' 2=CONSTANT BLACKLISTING'
!     CRBLEVEN( 3)      C    ' 3=EXPERIMENTAL BLACKLISTING'
!     CRBLEVEN( 4)      C    ' 4=WHITELISTING'
!     CRBLEVEN( 5)      C    ' 5=EXPERIMENTAL WHITELISTING'
!     CRBLEVEN( 6)      C    ' 6=OBSERVATION TYPE BLACKLISTED'
!     CRBLEVEN( 7)      C    ' 7=STATION ID BLACKLISTED'
!     CRBLEVEN( 8)      C    ' 8=CODE TYPE BLACKLISTED'
!     CRBLEVEN( 9)      C    ' 9=INSTRUMENT TYPE BLACKLISTED'
!     CRBLEVEN(10)      C    '10=DATE BLACKLISTED'
!     CRBLEVEN(11)      C    '11=TIME BLACKLISTED'
!     CRBLEVEN(12)      C    '12=LATITUDE BLACKLISTED'
!     CRBLEVEN(13)      C    '13=LONGITUDE BLACKLISTED'
!     CRBLEVEN(14)      C    '14=STATION ALTITUDE BLACKLISTED'
!     CRBLEVEN(15)      C    '15=BLACKLISTED DUE TO LAND/SEA MASK'
!     CRBLEVEN(16)      C    '16=BLACKLISTED DUE TO MODEL OROGRAPHY'
!     CRBLEVEN(17)      C    '17=BLACKLISTED DUE TO DISTANCE FROM REF. POINT'

!     DATA BLACKLIST EVENTS:

!     NAME            TYPE               MEANING
!     ----            ----               -------
!     CDBLEVEN( 1)      C    ' 1=PRESSURE BLACKLISTED'
!     CRBLEVEN( 2)      C    ' 2=VARIABLE NAME BLACKLISTED'
!     CRBLEVEN( 3)      C    ' 3=BLACKLISTED DUE TO PRESSURE CODE'
!     CRBLEVEN( 4)      C    ' 4=BLACKLISTED DUE TO TYPE OF VERTICAL COORDINATE'
!     CRBLEVEN( 5)      C    ' 5=BLACKLISTED DUE TO OBSERVED VALUE'
!     CRBLEVEN( 6)      C    ' 6=BLACKLISTED DUE TO FIRST GUESS DEPARTURE'

CHARACTER (LEN = 64) ::  CR1EVENT(JPMXRE1)
CHARACTER (LEN = 64) ::  CR2EVENT(JPMXRE2,JPMXOTP)
CHARACTER (LEN = 64) ::  CRBLEVEN(JPMXRBLE)
CHARACTER (LEN = 64) ::  CH1EVENT(JPMXDE1)
CHARACTER (LEN = 64) ::  CH2EVENT(JPMXDE2,JPMXOTP)
CHARACTER (LEN = 64) ::  CHDBLEVE(JPMXDBLE)

!-----------------------------------------------------------------------

END MODULE YOMCHEV
