MODULE YOMCLMICST

USE PARKIND1,ONLY : JPRB
USE YOMHOOK ,ONLY : LHOOK, DR_HOOK
!USE YOMGAMMA , ONLY : GENERALIZED_GAMMA
IMPLICIT NONE

SAVE

REAL(KIND=JPRB) ::  RXAR,RXBR,RXCCR,RXAI,RXBI,RXAS,RXBS,RXCCS,RXCXS
REAL(KIND=JPRB) ::  RXAG,RXBG,RXCCG,RXCXG,RXALPHAR,RXNUR,RXALPHAI,RXNUI
REAL(KIND=JPRB) ::  RXALPHAS,RXNUS,RXALPHAG,RXNUG,RXLBEXR,RXLBR,RXLBEXI
REAL(KIND=JPRB) ::  RXLBI, RXLBEXS,RXLBS,RXLBEXG,RXLBG
REAL(KIND=JPRB), DIMENSION(:),ALLOCATABLE :: RXRTMIN

PUBLIC MOMG

CONTAINS
!  FUNCTION MOMG(PALPHA,PNU,PP) RESULT (PMOMG)!
   FUNCTION MOMG(PALPHA,PNU,PP)
! auxiliary routine used to compute the Pth moment order of the generalized
! gamma law

  IMPLICIT NONE

  REAL(KIND=JPRB),INTENT(IN)     :: PALPHA ! first shape parameter of the dimensionnal distribution
  REAL(KIND=JPRB),INTENT(IN)     :: PNU    ! second shape parameter of the dimensionnal distribution
  REAL(KIND=JPRB),INTENT(IN)     :: PP     ! order of the moment

  ! Result
  REAL(KIND=JPRB) :: MOMG

  REAL(KIND=JPRB) :: ZHOOK_HANDLE
  REAL(KIND=JPRB) :: FCGENERALIZED_GAMMA

  IF (LHOOK) CALL DR_HOOK('YOMCLMICST:MOMG',0,ZHOOK_HANDLE)

  MOMG = FCGENERALIZED_GAMMA(PNU+PP/PALPHA)/FCGENERALIZED_GAMMA(PNU)

  IF (LHOOK) CALL DR_HOOK('YOMCLMICST:MOMG',1,ZHOOK_HANDLE)
   
  END FUNCTION MOMG

END MODULE YOMCLMICST
