MODULE YOMDB

USE PARKIND1  ,ONLY : JPIM     ,JPRB

USE PARCMA, ONLY : JPMXUP, JPMXENKF, JPXTSL, JPMX_SATOB_WEIGHT, JPMX_LIMB_TAN, &
  & JPMX_RADAR_NIV, JPMX_AK, JP_NUMEV
USE OML_MOD , ONLY : OML_MY_THREAD
IMPLICIT NONE
SAVE
PUBLIC

LOGICAL :: LODB = .TRUE.
INTEGER(KIND=JPIM)       , PARAMETER :: MDIDB = 2147483647
INTEGER(KIND=JPIM)       , PARAMETER :: JPMAXTSLDB = JPXTSL
INTEGER(KIND=JPIM), PRIVATE :: i
INTEGER(KIND=JPIM), PARAMETER :: JPMAXSIMVIEWS = 24
INTEGER(KIND=JPIM), parameter :: JPMAX_AUX_CASES = 5 ! How many ROBAUX<n> : ROBAUX1, ROBAUX2, ..., ROBAUX5
INTEGER(KIND=JPIM), PARAMETER :: JP_MAXDESC = 10
INTEGER(KIND=JPIM), PARAMETER :: JP_MAXDUPL = 16
INTEGER(KIND=JPIM), PARAMETER :: JP_NUMAUX   = 9 ! Must be the same as $NUMAUX in odb/ddl/cma.h
INTEGER(KIND=JPIM), PARAMETER :: JP_NUMTHBOX = 3 ! Must be the same as $NUMTHBOX in odb/ddl/cma.h
INTEGER(KIND=JPIM), PARAMETER :: JP_NMWAVE_DIAG = 16 ! Must be the same as $NUMRAINTBDIAG in odb/ddl/cma.h 
                                                     ! and 2 * NMWAVE_DIAG in ifs/module/parmwave.F90
INTEGER(KIND=JPIM), PARAMETER :: JP_NMWAVE_P     = 3 ! Must be the same as $NUMRAINTBP in odb/ddl/cma.h 

!*** Disable UNMAPDB-function
LOGICAL :: LUNMAPDB_DO = .TRUE.

!***  Database handles
INTEGER(KIND=JPIM),PARAMETER :: JPMAXSIMDB = 5   ! Max. no. of simultaneously opened DBs
INTEGER(KIND=JPIM)           :: NUMSIMDB  =  0   ! No. of presently opened DBs
INTEGER(KIND=JPIM) :: NHANDLEDB(JPMAXSIMDB) = (/( 0 , i=1,JPMAXSIMDB)/)
INTEGER(KIND=JPIM) :: NPOOLSDB(JPMAXSIMDB)  = (/( 0 , i=1,JPMAXSIMDB)/)
CHARACTER(LEN= 20) :: COPENDB(JPMAXSIMDB)   = (/(' ', i=1,JPMAXSIMDB)/)
CHARACTER(LEN= 20) :: CSTATUSDB(JPMAXSIMDB) = (/(' ', i=1,JPMAXSIMDB)/)

!***  For each thread
INTEGER(KIND=JPIM), allocatable :: nactivedb(:) ! Index to NHANDLEDB() for active DB
CHARACTER(LEN= 20), allocatable :: cactivedb(:) ! Say 'ECMA' or 'CCMA'

!***  NPOOLS_* for most common databases
INTEGER(KIND=JPIM) :: NPOOLS_CCMA    = 0
INTEGER(KIND=JPIM) :: NPOOLS_ECMA    = 0
INTEGER(KIND=JPIM) :: NPOOLS_ECMASCR = 0
!***  Miscellaneous
LOGICAL :: L_DEBUG   = .FALSE.
LOGICAL :: L_SWAPOUT = .FALSE.
LOGICAL :: L_CANARI  = .FALSE.
LOGICAL :: L_CANALT  = .FALSE.
LOGICAL :: L_REDUC   = .FALSE.
LOGICAL :: L_DEGREES = .FALSE.
LOGICAL :: L_ACTIVE  = .FALSE.

TYPE robaux_t
SEQUENCE
REAL(KIND=JPRB), pointer :: robaux(:,:)
END TYPE robaux_t

TYPE yomdb_t
SEQUENCE
#include "yomdb_vars.h"
END TYPE yomdb_t

TYPE(yomdb_t), allocatable :: o_(:)

END MODULE YOMDB
