MODULE YOMFOUTC

USE PARKIND1  ,ONLY : JPRB

IMPLICIT NONE

SAVE

! -------------------------------------------------------------------------

! Name of Fourier coefficients arrays containing transmission coefficients:
! These arrays are DM-local.

! RFORAB3C: Clear-sky parallel/diffuse reflectivity on layers (code 'RAB3C').
!           Equivalent coefficients from bottom to given layer.
! RFORAB4C: Clear-sky diffuse transmissivity on layers (code 'RAB4C').
!           Equivalent coefficients from bottom to given layer.
! RFORAB6C: Clear-sky diffuse reflectivity on layers (code 'RAB6C').
!           Equivalent coefficients from bottom to given layer.
! RFORAB3N: Cloudy parallel/diffuse reflectivity on layers (code 'RAB3N').
!           Equivalent coefficients from bottom to given layer.
! RFORAB4N: Cloudy diffuse transmissivity on layers (code 'RAB4N').
!           Equivalent coefficients from bottom to given layer.
! RFORAB6N: Cloudy diffuse reflectivity on layers (code 'RAB6N').
!           Equivalent coefficients from bottom to given layer.
! RFORAT1C: Clear-sky parallel transmissivity on layers (code 'RAT1C').
!           Equivalent coefficients from top to given layer.
! RFORAT2C: Clear-sky parallel/diffuse transmissivity on layers (code 'RAT2C')
!           Equivalent coefficients from top to given layer.
! RFORAT3C: Clear-sky parallel/diffuse reflectivity on layers (code 'RAT3C').
!           Equivalent coefficients from top to given layer.
! RFORAT4C: Clear-sky diffuse transmissivity on layers (code 'RAT4C').
!           Equivalent coefficients from top to given layer.
! RFORAT5C: Clear-sky diffuse reflectivity on layers (code 'RAT5C').
!           Equivalent coefficients from top to given layer.
! RFORAT1N: Cloudy parallel transmissivity on layers (code 'RAT1N').
!           Equivalent coefficients from top to given layer.
! RFORAT2N: Cloudy parallel/diffuse transmissivity on layers (code 'RAT2N').
!           Equivalent coefficients from top to given layer.
! RFORAT3N: Cloudy parallel/diffuse reflectivity on layers (code 'RAT3N').
!           Equivalent coefficients from top to given layer.
! RFORAT4N: Cloudy diffuse transmissivity on layers (code 'RAT4N').
!           Equivalent coefficients from top to given layer.
! RFORAT5N: Cloudy diffuse reflectivity on layers (code 'RAT5N').
!           Equivalent coefficients from top to given layer.
! RFOCOR  : Correction for cloudiness for thermal radiation (code 'COR').
! RFOAC   : Transmission coefficients matrix for thermal radiation
!           for clear sky (code 'AC').

! -------------------------------------------------------------------------

REAL(KIND=JPRB),ALLOCATABLE:: RFORAB3C(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RFORAB4C(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RFORAB6C(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RFORAB3N(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RFORAB4N(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RFORAB6N(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RFORAT1C(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RFORAT2C(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RFORAT3C(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RFORAT4C(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RFORAT5C(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RFORAT1N(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RFORAT2N(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RFORAT3N(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RFORAT4N(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RFORAT5N(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RFOCOR(:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RFOAC(:,:,:)

!     -------------------------------------------------------------------------
END MODULE YOMFOUTC
