MODULE YOMFPDIM

USE PARKIND1  ,ONLY : JPIM

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------

! === Full-POS DIMENSIONNING ====

! NFPGT1 : number of fields out of vertical post-processing
! NFPAUXB: number of vertically post-processed fields to remain unfited (Both 2D and 3D)
! NFPVEC : number of vector fields to be fitted
! NFPVECG: global number of vector fields to be fitted
! NFPSCA : number of scalar fields to be fitted
! NFPSCAG: global number of scalar fields to be fitted
! NFPUVMN: number of pairs of true (ie : U,V not Vor, Div) wind components to be fitted
! NFPSPD : number of derived vertically pp. fields to be fited, for one horizontal subdomain.
! NFPSPB : number of derived vertically pp. fields to be fited, for the max. number of horizontal domains.
! NFPGT0B: number of fields to be horizontally post-processed (Both 2D and 3D)
! NFPDYNB: number of post-processed dynamic fields.
! NFPIVEC: number of spectral vector fields to be transformed in gridpoints
! NFPISCA: number of spectral scalar fields to be transformed in gridpoints
! NFPIVECG: global number of spectral vector fields to be transformed in gridpoints
! NFPISCAG: global number of spectral scalar fields to be transformed in gridpoints
! NAFPOS : number of primitive fields for post-processing on surface-dependent levels
! NFPBFIN: number of gridpoint fields in interpolation buffer
! NFPBFOUT:number of gridpoint fields in output gridpoint buffer 

! NB : NFPSPD,NFPSPB,NFPSCA,NFPVEC,NFPISCA,NFPIVEC  are local per V-set.

INTEGER(KIND=JPIM) :: NFPGT1
INTEGER(KIND=JPIM) :: NFPAUXB
INTEGER(KIND=JPIM) :: NFPVEC
INTEGER(KIND=JPIM) :: NFPSCA
INTEGER(KIND=JPIM) :: NFPSPD
INTEGER(KIND=JPIM) :: NFPSPB
INTEGER(KIND=JPIM) :: NFPGT0B
INTEGER(KIND=JPIM) :: NFPDYNB
INTEGER(KIND=JPIM) :: NFPSCAG
INTEGER(KIND=JPIM) :: NFPVECG
INTEGER(KIND=JPIM) :: NFPIVEC
INTEGER(KIND=JPIM) :: NFPISCA
INTEGER(KIND=JPIM) :: NFPIVECG
INTEGER(KIND=JPIM) :: NFPISCAG
INTEGER(KIND=JPIM) :: NAFPOS
INTEGER(KIND=JPIM) :: NFPUVMN
INTEGER(KIND=JPIM) :: NFPBFIN
INTEGER(KIND=JPIM) :: NFPBFOUT

!     ------------------------------------------------------------------
END MODULE YOMFPDIM
