MODULE YOMFPEZO

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------

!*    variables related to postprocessing on ezone of output geometry

! NFPEL    : number of gridpoints  in local ezone
! NFPEX    : maximum number of gridpoints  in local ezone
! NFPEG    : number of gridpoints  in global ezone
! NFPSTAE  : start indexes of local extension zones within global extension zone
! NSTREFP  : number of processors for the DM computations of pp. ext. zone
! NFPEBLKS : number of blocks in local extension zone buffer
! NFPROMEL : max; lenght of a block in local extension zone buffer
! NEFPSTART: Start index of points in a working array
! NEFPEND  : End index of points in a working array
! EFPGM    : map-factor over local/global extension zone  
! EFPNORX  : compass (first component)  over local/global extension zone
! EFPNORY  : compass (second component)  over local/global extension zon

INTEGER(KIND=JPIM) :: NFPEL
INTEGER(KIND=JPIM) :: NFPEX
INTEGER(KIND=JPIM) :: NFPEG
INTEGER(KIND=JPIM) :: NSTREFP
INTEGER(KIND=JPIM) :: NFPEBLKS
INTEGER(KIND=JPIM) :: NFPROMEL

INTEGER(KIND=JPIM), ALLOCATABLE:: NFPSTAE(:)
INTEGER(KIND=JPIM),ALLOCATABLE :: NEFPSTART(:)
INTEGER(KIND=JPIM),ALLOCATABLE :: NEFPEND(:)
REAL(KIND=JPRB), ALLOCATABLE:: EFPGM(:)
REAL(KIND=JPRB), ALLOCATABLE:: EFPNORX(:)
REAL(KIND=JPRB), ALLOCATABLE:: EFPNORY(:)

END MODULE YOMFPEZO
