MODULE YOMFPF

USE PARKIND1, ONLY : JPIM, JPRB
USE PARFPOS,  ONLY : JPOSDOM

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------

!*    Full-POS spectral filter

! NFMAX  : maximum truncation of the output subdomains.
!          If negative : means no filter at all.
! NFPCMAX : maximum truncation in the homogenous resolution of the input model

! LFPFIL : .TRUE. if the filter for dilated fields is active (arpege only) for
!          the corresponding (sub)domain
! RFPEXPC : list of the spectrum coefficients to use in the exponent for the
!           gaussian filter
! RFPFIL : value of the filter for each zonal wavenumber and each subdomain

! LFPBED :  .TRUE. to use the old "THX" filter on the homogenous resolution
!           space (arpege only) ; else the new 
!           gaussian filter is used.
! RFPBED : coefficient of the exponential function in the old "THX" filter.
! RFPLTF : coefficient of the exponential function in the new gaussian filter
!          Also used for the current exponential function in aladin when fields
!          are post-processed on a surface to be filtered.
! LFPMAT : .TRUE. if filtering matrix in the homogenous resolution space must be computed
! RFPMAT : Filtering matrix in the homogenous resolution space (ARPEGE only)

! LFPWRFIL : Write out filtering matrixes on files
! LFPRDFIL : Read filtering matrixes from files
! NFPGLFI  : granularity factor for LFI filtering matrixes

LOGICAL :: LFPBED
LOGICAL :: LFPMAT
LOGICAL :: LFPWRFIL
LOGICAL :: LFPRDFIL
LOGICAL, ALLOCATABLE :: LFPFIL(:)

INTEGER(KIND=JPIM) :: NFPGLFI
INTEGER(KIND=JPIM) :: NFPCMAX
INTEGER(KIND=JPIM) :: NFMAX(JPOSDOM)

REAL(KIND=JPRB) :: RFPLTF
REAL(KIND=JPRB) :: RFPBED
REAL(KIND=JPRB), ALLOCATABLE :: RFPEXPC(:)
REAL(KIND=JPRB), ALLOCATABLE :: RFPFIL(:,:)
REAL(KIND=JPRB), ALLOCATABLE :: RFPMAT(:,:)

!     ------------------------------------------------------------------
END MODULE YOMFPF
