MODULE YOMGCO

USE PARKIND1  ,ONLY : JPRB

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------

!*    DIAGNOSTICS POUR COUPLAGE

! STRSU    STRESS SURFACE DE U
! STRSV    STRESS SURFACE DE V
! FCHAS    FLUX CHALEUR SURFACE
! FRSOS    FLUX RAYT SOLAIRE SURFACE
! FHUMS    FLUX HUMIDITE SURFACE
! RUIST    RUISSELLEMENT TOTAL
! FCHLL    FLUX CHALEUR LATENTE EAU LIQUIDE
! FCHLN    FLUX CHALEUR LATENTE NEIGE
! FCHSS    FLUX CHALEUR SENSIBLE
! FHUML    FLUX PRECIPITATIONS EAU LIQUIDE
! FHUMN    FLUX PRECIPITATIONS NEIGE
! FRLDS    FLUX RAYT IR SURFACE DESCENDANT
! QWPRO    RESERVOIR PROFOND
! TMAX2    TEMPERATURE CLS MAXI
! TMIN2    TEMPERATURE CLS MINI
! HSNOW    HAUTEUR NEIGE
! TSUR2    TEMPERATURE DE SURFACE
! TSTS     TSURF2*TSUR2
! TSFL     TSUR2*FCHAS
! XPUQ     U*Q
! XPVQ     V*Q

!*    DIAGNOSTICS POUR "CLOUD FORCING" : =(Flux)-(Flux)_(clear-sky)

! FCRFTH   PFRTH-PFRTHC
! FCRFSO   PFRSO-PFRSOC

REAL(KIND=JPRB),ALLOCATABLE:: STRSU(:)
REAL(KIND=JPRB),ALLOCATABLE:: STRSV(:)
REAL(KIND=JPRB),ALLOCATABLE:: FCHAS(:,:)
REAL(KIND=JPRB),ALLOCATABLE:: FRSOS(:,:)
REAL(KIND=JPRB),ALLOCATABLE:: FHUMS(:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RUIST(:)
REAL(KIND=JPRB),ALLOCATABLE:: FCHLL(:,:)
REAL(KIND=JPRB),ALLOCATABLE:: FCHLN(:,:)
REAL(KIND=JPRB),ALLOCATABLE:: FCHSS(:,:)
REAL(KIND=JPRB),ALLOCATABLE:: FHUML(:)
REAL(KIND=JPRB),ALLOCATABLE:: FHUMN(:)
REAL(KIND=JPRB),ALLOCATABLE:: FRLDS(:)
REAL(KIND=JPRB),ALLOCATABLE:: QWPRO(:)
REAL(KIND=JPRB),ALLOCATABLE:: TMAX2(:)
REAL(KIND=JPRB),ALLOCATABLE:: TMIN2(:)
REAL(KIND=JPRB),ALLOCATABLE:: HSNOW(:)
REAL(KIND=JPRB),ALLOCATABLE:: TSUR2(:)
REAL(KIND=JPRB),ALLOCATABLE:: TSTS(:)
REAL(KIND=JPRB),ALLOCATABLE:: TSFL(:)
REAL(KIND=JPRB),ALLOCATABLE:: XPUQ(:)
REAL(KIND=JPRB),ALLOCATABLE:: XPVQ(:)

REAL(KIND=JPRB),ALLOCATABLE:: FCRFTH(:,:)
REAL(KIND=JPRB),ALLOCATABLE:: FCRFSO(:,:)

!     -----------------------------------------------------------------
END MODULE YOMGCO
