MODULE YOMINI

USE PARKIND1  ,ONLY : JPIM

IMPLICIT NONE

SAVE

!**************  COMDECK YOMINI  ************

!     NEINI : 0  NO INITIALIZATION
!             1  NORMAL MODE INITIALIZATION
!             2  DIGITAL FILTER INITIALIZATION
!             3  NO INITIALIZATION BUT NORMAL MODES ARE COMPUTED
!             4  DIGITAL FILTER INITIALIZATION AND NORMAL MODES ARE COMPUTED

!     LBIAS :    COMPUTING INITIALIZATION INCREMENT (Xi-Xa)
!     LINCR :    INCREMENTAL INITIALIZATION ( -> Xi-Z , Z=Yi-Ya )

!     LINITER :  TRUE during initialization, FALSE else (internal switch)
!     LSCRINI :  TRUE if screening prepared in digital filter finalisation

INTEGER(KIND=JPIM) :: NEINI
LOGICAL :: LBIAS
LOGICAL :: LINCR
LOGICAL :: LINITER
LOGICAL :: LSCRINI

END MODULE YOMINI
