MODULE YOMIO

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

! common yomio - input and postprocessing 

! lpptsf      : Post processing time step file
!             : true=generate files per post-processing timestep (default)
!             : false=generate files for all post-processing timesteps
! nppouttype  : pp file output type at time of open
! nppbuflen   : size in integer words of a single pp file buffer
! nppfiles    : maximum number of pp file buffers
! nppbuf      : pp file buffer
! nppbufl     : pp file buffer length of data
! nppbufh     : pp file buffer handle
! nppbufs     : pp file buffer status 0=unused, 1=used
! nppbuf2     : pp file buffer section currently being filled
! nppbufa     : pp file buffer info (for async operations)
!             : 1=request
!             : 2=status (0=no active write,1=active write)
! cpplfn      : pp file names
! nppbufwri   : pp file writes issued
! rppbufwrt   : pp file write time
! rppbufwat   : pp file write wait time (async only)

INTEGER(KIND=JPIM) :: NPPBUFLEN
INTEGER(KIND=JPIM) :: NPPFILES
LOGICAL :: LPPTSF
INTEGER(KIND=JPIM),ALLOCATABLE:: NPPOUTTYPE(:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NPPBUF(:,:,:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NPPBUFL(:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NPPBUFH(:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NPPBUFS(:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NPPBUF2(:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NPPBUFA(:,:,:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NPPBUFWRI(:)
REAL(KIND=JPRB),ALLOCATABLE:: RPPBUFWRT(:)
REAL(KIND=JPRB),ALLOCATABLE:: RPPBUFWAT(:)
CHARACTER(LEN=24),ALLOCATABLE:: CPPLFN(:)
END MODULE YOMIO
