MODULE YOMJBCHVAR

USE PARKIND1  ,ONLY : JPRB

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------
!*    Coefficients of the change of variable for the 
!     background constraint Jb. Calculated in sujbchvar.F90

!     Humidity change of variable:
!     RQS(0:L)            : TROPOPAUSE TRANSITION OF SIGMA REDUCTION FOR Q
!     RQT(0:K)            : TROPOPAUSE TRANSITION OF BALANCE COEFFICIENT
!                           BETWEEN Q AND T
!     RQTBAL (NFLEVG,0:N) : BALANCE COEFFICIENT BETWEEN Q AND T
!     RQLMIN(NFLEVG)      : MINIMUM Q/Q_s, SUBSATURATED   (RH^b<1.x)
!     RQLMAX(NFLEVG)      : MAXIMUM Q/Q_s, SUBSATURATED   (RH^b<1.x)
!     RQLSTD (NFLEVG,0:N) : NORMALIZATION STANDARD DEVIATION COEFFICIENTS (RH^b<1.x)
!     RQHMIN(NFLEVG)      : MINIMUM Q/Q_s, SUPERSATURATED (RH^b>1.x)
!     RQHMAX(NFLEVG)      : MAXIMUM Q/Q_s, SUPERSATURATED (RH^b>1.x)
!     RQHSTD (NFLEVG,0:N) : NORMALIZATION STANDARD DEVIATION COEFFICIENTS (RH^b<1.x)
!     RO3MIN(NFLEVG)      : MINIMUM O3
!     RO3STD(NFLEVG,0:M)  : NORMALIZATION STANDARD DEVIATION COEFFICIENTS FOR O3
!                            

REAL(KIND=JPRB),ALLOCATABLE:: RQS(:)
REAL(KIND=JPRB),ALLOCATABLE:: RQT(:)
REAL(KIND=JPRB),ALLOCATABLE:: RQTBAL(:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RQLMIN(:)
REAL(KIND=JPRB),ALLOCATABLE:: RQLMAX(:)
REAL(KIND=JPRB),ALLOCATABLE:: RQLSTD(:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RQHMIN(:)
REAL(KIND=JPRB),ALLOCATABLE:: RQHMAX(:)
REAL(KIND=JPRB),ALLOCATABLE:: RQHSTD(:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RO3MIN(:)
REAL(KIND=JPRB),ALLOCATABLE:: RO3STD(:,:)

!     ------------------------------------------------------------------
END MODULE YOMJBCHVAR
