MODULE YOMJR

USE PARKIND1  ,ONLY : JPRB

IMPLICIT NONE

SAVE

! AVNORM*: Definition of the norms used for Jr

! norms for 1D variables.
REAL(KIND=JPRB), ALLOCATABLE, TARGET  :: AVNORM1(:,:)
! norms for 2D variables.
REAL(KIND=JPRB), ALLOCATABLE, TARGET  :: AVNORM2(:,:)
! norms for 3D variables.
REAL(KIND=JPRB), ALLOCATABLE, TARGET  :: AVNORM3(:,:,:)

! AVARC Gradient tables

REAL(KIND=JPRB), ALLOCATABLE, TARGET  :: AGRAVOR(:,:,:) ! for vorticity
REAL(KIND=JPRB), ALLOCATABLE, TARGET  :: AGRADIV(:,:,:) ! for hor. divergence
REAL(KIND=JPRB), ALLOCATABLE, TARGET  :: AGRAT  (:,:,:) ! for temperature
REAL(KIND=JPRB), ALLOCATABLE, TARGET  :: AGRAQ  (:,:,:) ! for humidity
REAL(KIND=JPRB), ALLOCATABLE, TARGET  :: AGRASP (:,:)   ! for surface pressure

! AVARC trajectory tables

REAL(KIND=JPRB), ALLOCATABLE, TARGET  :: ATRAVOR(:,:,:) ! for vorticity
REAL(KIND=JPRB), ALLOCATABLE, TARGET  :: ATRADIV(:,:,:) ! for hor. divergence
REAL(KIND=JPRB), ALLOCATABLE, TARGET  :: ATRAT  (:,:,:) ! for temperature
REAL(KIND=JPRB), ALLOCATABLE, TARGET  :: ATRAQ  (:,:,:) ! for humidity
REAL(KIND=JPRB), ALLOCATABLE, TARGET  :: ATRASP (:,:)   ! for surface pressure

END MODULE YOMJR
