MODULE YOMLEVSE

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!*     YOMLEVSE - LEVEL SELECTION
!                       SETUP IN SUBROUTINE*SUSCRE

!        HEIKKI JARVINEN   ECMWF     15/3/95

!     NAME      TYPE                  MEANING
!     ----      ----                  -------

!     NSTDPL      I    NO. OF STANDARD PRESSURE LEVELS
!     NLLNVA      I    NO. OF DIFFERENT VARIABLES IN LEVEL SELECTION
!     NLLNDA      I    MAX. NO. OF DATUMS WITHIN A LAYER (OF ONE VARIABLE)
!     N2MUPNT     I    2 METRE U-COMPONENT POINTER
!     N2MVPNT     I    2 METRE V-COMPONENT POINTER
!     N2MTPNT     I    2 METRE TEMPERATURE POINTER
!     N2MRPNT     I    2 METRE HUMIDITY    POINTER
!     NUPNT       I    U-COMPONENT POINTER
!     NVPNT       I    V-COMPONENT POINTER
!     NZPNT       I    HEIGHT      POINTER
!     NTPNT       I    TEMPERATURE POINTER
!     NRPNT       I    HUMIDITY    POINTER

!     NVCOUN      I    COUNTER FOR DIFFERENT VARIABLES
!     NVPOIN      I    POINTERS FOR REPORTS AND VARIABLES
!     RSTDPL      R    STANDARD PRESSURE LEVELS
!     GVDIST      R    DISTANCES TO STD-LEVELS

INTEGER(KIND=JPIM) :: NSTDPL
INTEGER(KIND=JPIM) :: NLLNVA
INTEGER(KIND=JPIM) :: NLLNDA
INTEGER(KIND=JPIM) :: N2MUPNT
INTEGER(KIND=JPIM) :: N2MVPNT
INTEGER(KIND=JPIM) :: N2MTPNT
INTEGER(KIND=JPIM) :: N2MRPNT
INTEGER(KIND=JPIM) :: NUPNT
INTEGER(KIND=JPIM) :: NVPNT
INTEGER(KIND=JPIM) :: NZPNT
INTEGER(KIND=JPIM) :: NTPNT
INTEGER(KIND=JPIM) :: NRPNT

INTEGER(KIND=JPIM),ALLOCATABLE:: NVCOUN(:,:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NVPOIN(:,:,:,:)
REAL(KIND=JPRB),ALLOCATABLE:: RSTDPL(:)
REAL(KIND=JPRB),ALLOCATABLE:: GVDIST(:,:,:)

!-----------------------------------------------------------------------

END MODULE YOMLEVSE
