MODULE YOMLVLY

USE PARKIND1, ONLY : JPIM, JPRB
USE PARLVLY,  ONLY : JPMXSTLV, JPMXLAYE

IMPLICIT NONE

SAVE

!*     YOMLVLY - OBSERVATION LEVEL/LAYERS

!        D. VASILJEVIC   ECMWF     15/9/94

!     NAME      TYPE                  MEANING
!     ----      ----                  -------
!     LOBTHLAY    L      OBSERVED/PREDEFINED THICKNESS LAYERS SWITCH
!     LOBPWLAY    L      OBSERVED/PREDEFINED PWC LAYERS SWITCH

!     NMXSTLV     I      MAX. NO. OF STANDARD LEVELS
!     STPLEV      R      STANDARD PRESSURE LEVELS
!     STPLEVL     R      LN. OF STANDARD PRESSURE LEVELS

!     NMXLAYER    I      MAX. NO. OF LAYERS
!     NOTHLAY     I      ACTUAL NO. OF THICKNESS LAYERS
!     TTHLAY      R      THICKNESS LAYERS TOP PRESSURES
!     BTHLAY      R      THICKNESS LAYERS BOTTOM PRESSURES
!     NOPWLAY     I      ACTUAL NO. OF PWC LAYERS
!     TPWLAY      R      PWC LAYERS TOP PRESSURES
!     BPWLAY      R      PWC LAYERS BOTTOM PRESSURES

LOGICAL :: LOBTHLAY
LOGICAL :: LOBPWLAY
INTEGER(KIND=JPIM) :: NMXSTLV
INTEGER(KIND=JPIM) :: NMXLAYER
INTEGER(KIND=JPIM) :: NOTHLAY
INTEGER(KIND=JPIM) :: NOPWLAY
REAL(KIND=JPRB) :: STPRELV(JPMXSTLV)
REAL(KIND=JPRB) :: STPRELVL(JPMXSTLV)
REAL(KIND=JPRB) :: TTHLAY(JPMXLAYE)
REAL(KIND=JPRB) :: BTHLAY(JPMXLAYE)
REAL(KIND=JPRB) :: TPWLAY(JPMXLAYE)
REAL(KIND=JPRB) :: BPWLAY(JPMXLAYE)

!-----------------------------------------------------------------------

END MODULE YOMLVLY
