MODULE YOMMASS

USE PARKIND1  ,ONLY : JPRB

IMPLICIT NONE

SAVE

!-----------------------------------------------------------------------

!*    Global mass variables required for mass correction,
!     to prevent mass-drift in extended integrations.

!     Global average values are calculated in spnorm
!     Nils Wedi, 2008-02-08

! GMASSI    : mass at start of integration.
! GMASS0    : mass at current timestep.
! GMASSINC  : mass increment to be applied at current time step

! LMASCOR   : .T. apply mass correction
! LMASDRY   : .F. by default, if .T. only correct the dry mass by subtracting
!             the total mass of water vapour (see cormass2 used at Meteo-France)


LOGICAL         :: LMASCOR
LOGICAL         :: LMASDRY

REAL(KIND=JPRB) :: GMASSI
REAL(KIND=JPRB) :: GMASS0
REAL(KIND=JPRB) :: GMASSINC

!-----------------------------------------------------------------------
END MODULE YOMMASS
