MODULE YOMOBSET

USE PARKIND1  ,ONLY : JPIM

IMPLICIT NONE

SAVE

!*

!     /YOMOBSET/  J. PAILLEUX 90/02/14
!                       P. MOLL     90/04/11
!                       J. PAILLEUX 90/04/22
!                       J. PAILLEUX 90/04/23
!                       J. PAILLEUX 90/05/02
!                       J. PAILLEUX 90/06/09 CORRECTION DE NOMS.

!     TABLES DEFINING OBSERVATION SETS
!     TABLEAUX DEFINISSANT LES PAQUETS D'OBSERVATIONS.

!   COMMENTAIRES:
!   ------------

!     NSETOT  : NOMBRE DE PAQUETS D'OBSERVATIONS
!     MTYPOB(NMXSET)  : (OBS-TYPE + 100*CODE TYPE) DE CHAQUE SATEM PAQUET
!                JUST OBS-TYPE OTHERWISE
!     MLNSET(NMXSET)  : TAILLE DE CHAQUE PAQUET
!     MABNOB(NMXLEN,NMXSET)  : NUMERO ABSOLU DE CHAQUE OBS COMPOSANT CHAQUE PAQUET

!  LES VARIABLES ET LES PARAMETRES UTILISES POUR DIMENSIONNER CES
!  TABLEAUX SONT RESPECTIVEMENT DEFINIS DANS LES COMDECKS " YOMDIMO"
!  ET "PARDIMO".

!   COMMENTS:
!   --------

!     NSETOT  : ACTUAL NUMBER (NOMBRE) OF OBSERVATION SETS
!     MTYPOB(NMXSET)  : (OBS-TYPE + 100*CODE TYPE) OF EACH SATEM SET
!                JUST OBS-TYPE OF OTHER SETS
!     MLNSET(NMXSET)  : ACTUAL NUMBER (NOMBRE) OF OBSERVATIONS IN EACH SET
!     MABNOB(NMXLEN,NMXSET)  : ABSOLUTE NUMBER (NUMERO) FOR EACH OBSERVATION
!                              IN EACH SET (obsolete; fetched from ODB)
!     MMXBDY(NMXSET)  : MAX NUMBER OF BODIES, IN EACH SET
!     MTSLSET(NMXSET) : TIMESLOT OF A SET (or -1 if not applicable)

!  VARIABLES AND PARAMETERS USED AS DIMENSIONS IN THESE ARRAYS ARE
!  RESPECTIVELY DEFINED IN COMDECKS "YOMDIMO" AND "PARDIMO".

INTEGER(KIND=JPIM),ALLOCATABLE:: MTYPOB(:)
INTEGER(KIND=JPIM),ALLOCATABLE:: MLNSET(:)
!!INTEGER_M,ALLOCATABLE:: MABNOB(:,:)
INTEGER(KIND=JPIM),ALLOCATABLE:: MMXBDY(:)
INTEGER(KIND=JPIM),ALLOCATABLE:: MTSLSET(:)

INTEGER(KIND=JPIM) :: NSETOT

!     ------------------------------------------------------------------

END MODULE YOMOBSET
