MODULE YOMOBSET_THSAFE

!-- Thread safe/specific YOMOBSET (by Sami Saarinen, 15-Dec-2004)
!   For explanations of items, see yomobset.F90

USE PARKIND1  ,ONLY : JPIM

IMPLICIT NONE
PUBLIC
SAVE

TYPE yomobset_thsafe_t
! * (obs-type + 100*code type) of each SATEM set.
INTEGER(KIND=JPIM),POINTER:: MTYPOB(:)
! * actual number of observations in each set.
INTEGER(KIND=JPIM),POINTER:: MLNSET(:)
! * max number of bodies, in each set.
INTEGER(KIND=JPIM),POINTER:: MMXBDY(:)
! * timeslot of a set (or -1 if not applicable).
INTEGER(KIND=JPIM),POINTER:: MTSLSET(:)
! * actual number of observation sets.
INTEGER(KIND=JPIM) :: NSETOT
END TYPE yomobset_thsafe_t

! * OBSET: observation sets array.
TYPE(yomobset_thsafe_t), allocatable :: obset(:) ! Allocated per thread

!     ------------------------------------------------------------------

END MODULE YOMOBSET_THSAFE
