MODULE YOMOERR

USE PARKIND1  ,ONLY : JPIM     ,JPRB

USE PARCMA

USE PARERR

IMPLICIT NONE

SAVE

!*     YOMOERR - OBSERVATION ERROR

!        D. VASILJEVIC   ECMWF     15/9/94

!     NAME      TYPE                  MEANING
!     ----      ----                  -------
!     NMXESTLV    I       MAX. NO. OF OBS. ERROR STANDARD LEVELS
!     NMXESTLY    I       MAX. NO. OF OBS. ERROR STANDARD LAYERS
!     NMXEAREA    I       MAX. NO. OF OBS. ERROR AREAS

!     OEWIND      R       WIND OBSERVATION ERROR
!     OETEMP      R       TEMPERATURE OBSERVATION ERROR
!     OEHEIG      R       HEIGHT OBSERVATION ERROR
!     OECLETH     R       CLEAR SATEM/TOVS THICKNESS OBS. ERROR
!     OECLOTH     R       CLOUDY SATEM/TOVS THICKNESS OBS. ERROR
!     OEMICTH     R       MICROWAVE SATEM/TOVS THICKNESS OBS. ERROR

!     RHERRY      R       HUMIDITY ERROR FOR SYNOP
!     RHERR1      R       HUMIDITY ERROR 1
!     RHERR2      R       HUMIDITY ERROR 2
!     RHERR3      R       HUMIDITY ERROR 3

!     RROUND      R       PWC ROUNDING ERROR

INTEGER(KIND=JPIM) :: NMXESTLV
INTEGER(KIND=JPIM) :: NMXESTLY
INTEGER(KIND=JPIM) :: NMXEAREA
REAL(KIND=JPRB) :: OEWIND(JPMXESLV,JPMXEARE,JPMXOCT,JPMXOTP)
REAL(KIND=JPRB) :: OETEMP(JPMXESLV,JPMXEARE,JPMXOCT,JPMXOTP)
REAL(KIND=JPRB) :: OEHEIG(JPMXESLV,JPMXEARE,JPMXOCT,JPMXOTP)
REAL(KIND=JPRB) :: OECLETH(JPMXESLY,JPMXEARE,JPMXOCT,JPMXOTP)
REAL(KIND=JPRB) :: OECLOTH(JPMXESLY,JPMXEARE,JPMXOCT,JPMXOTP)
REAL(KIND=JPRB) :: OEMICTH(JPMXESLY,JPMXEARE,JPMXOCT,JPMXOTP)
REAL(KIND=JPRB) :: RHERRY
REAL(KIND=JPRB) :: RHERR1
REAL(KIND=JPRB) :: RHERR2
REAL(KIND=JPRB) :: RHERR3
REAL(KIND=JPRB) :: RROUND

!-----------------------------------------------------------------------

END MODULE YOMOERR
