MODULE YOMPERR

USE PARKIND1  ,ONLY : JPRB

IMPLICIT NONE

SAVE

!*     YOMPERR - PERSISTENCE ERROR

!        D. VASILJEVIC   ECMWF     15/9/94

!     NAME      TYPE                  MEANING
!     ----      ----                  -------
!     UPM10070    R      MAX. PER. ERR. OVER 24HR (U) 1000-700hPa
!     UPM69925    R      MAX. PER. ERR. OVER 24HR (U)  699-250hPa
!     UPM24900    R      MAX. PER. ERR. OVER 24HR (U)  249-  0hPa
!     VPM10070    R      MAX. PER. ERR. OVER 24HR (V) 1000-700hPa
!     VPM69925    R      MAX. PER. ERR. OVER 24HR (V)  699-250hPa
!     VPM24900    R      MAX. PER. ERR. OVER 24HR (V)  249-  0hPa
!     GPM10070    R      MAX. PER. ERR. OVER 24HR (GEOP.) 1000-700hPa
!     GPM69925    R      MAX. PER. ERR. OVER 24HR (GEOP.)  699-250hPa
!     GPM24900    R      MAX. PER. ERR. OVER 24HR (GEOP.)  249-  0hPa
!     TPM10070    R      MAX. PER. ERR. OVER 24HR (T) 1000-700hPa
!     TPM69925    R      MAX. PER. ERR. OVER 24HR (T)  699-250hPa
!     TPM24900    R      MAX. PER. ERR. OVER 24HR (T)  249-  0hPa

!     UP110070    R      MAX. PER. ERR. OVER 1HR (U) 1000-700hPa
!     UP169925    R      MAX. PER. ERR. OVER 1HR (U)  699-250hPa
!     UP124900    R      MAX. PER. ERR. OVER 1HR (U)  249-  0hPa
!     VP110070    R      MAX. PER. ERR. OVER 1HR (V) 1000-700hPa
!     VP169925    R      MAX. PER. ERR. OVER 1HR (V)  699-250hPa
!     VP124900    R      MAX. PER. ERR. OVER 1HR (V)  249-  0hPa
!     GP110070    R      MAX. PER. ERR. OVER 1HR (GEOP.) 1000-700hPa
!     GP169925    R      MAX. PER. ERR. OVER 1HR (GEOP.)  699-250hPa
!     GP124900    R      MAX. PER. ERR. OVER 1HR (GEOP.)  249-  0hPa
!     TP110070    R      MAX. PER. ERR. OVER 1HR (T) 1000-700hPa
!     TP169925    R      MAX. PER. ERR. OVER 1HR (T)  699-250hPa
!     TP124900    R      MAX. PER. ERR. OVER 1HR (T)  249-  0hPa

REAL(KIND=JPRB) :: UPM10070
REAL(KIND=JPRB) :: UPM69925
REAL(KIND=JPRB) :: UPM24900
REAL(KIND=JPRB) :: VPM10070
REAL(KIND=JPRB) :: VPM69925
REAL(KIND=JPRB) :: VPM24900
REAL(KIND=JPRB) :: GPM10070
REAL(KIND=JPRB) :: GPM69925
REAL(KIND=JPRB) :: GPM24900
REAL(KIND=JPRB) :: TPM10070
REAL(KIND=JPRB) :: TPM69925
REAL(KIND=JPRB) :: TPM24900
REAL(KIND=JPRB) :: UP110070
REAL(KIND=JPRB) :: UP169925
REAL(KIND=JPRB) :: UP124900
REAL(KIND=JPRB) :: VP110070
REAL(KIND=JPRB) :: VP169925
REAL(KIND=JPRB) :: VP124900
REAL(KIND=JPRB) :: GP110070
REAL(KIND=JPRB) :: GP169925
REAL(KIND=JPRB) :: GP124900
REAL(KIND=JPRB) :: TP110070
REAL(KIND=JPRB) :: TP169925
REAL(KIND=JPRB) :: TP124900
REAL(KIND=JPRB) :: RPERER1

!-----------------------------------------------------------------------

END MODULE YOMPERR
