MODULE YOMPONG

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!------------- sponge function ---------------------------

!  REPONGH(0:NFLEVG) - sponge function at half levels
!  REPONGF(  NFLEVG) - sponge function at full levels

!------------- background fields -------------------------

!  RT_SPNG(NFLEVG)   - background temperature profile
!  RU_SPNG(NFLEVG)   - background U-wind profile
!  RV_SPNG(NFLEVG)   - background V-wind profile

!------------- sponge coefficients -----------------------

!  REPONBT           - bottom of the sponge layer [m]
!  REPONTP           - top of the sponge layer    [m]
!  REPONTAU          - time scale of absorption   [s]

!------------- sponge activation -------------------------

!  NSPONGE           - sponge activation:
!                        0 - sponge off
!                        2 - sponge on
!---------------------------------------------------------

INTEGER(KIND=JPIM) :: NSPONGE

REAL(KIND=JPRB) :: REPONBT, REPONTP, REPONTAU

REAL(KIND=JPRB), ALLOCATABLE :: REPONGH(:)
REAL(KIND=JPRB), ALLOCATABLE :: REPONGF(:)
REAL(KIND=JPRB), ALLOCATABLE :: RT_SPNG(:)
REAL(KIND=JPRB), ALLOCATABLE :: RU_SPNG(:)
REAL(KIND=JPRB), ALLOCATABLE :: RV_SPNG(:)

!---------------------------------------------------------

END MODULE YOMPONG

