MODULE YOMPPC

USE PARKIND1  ,ONLY : JPIM

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------
!*    POST PROCESSING CONTROL 

! LOPPCNT: .TRUE. if post-processing namelists are being read from files
! LRSUP  : .TRUE. if surface post-processing requested
! LRSACC : .TRUE. if accumulated fluxes are reset at post-processing time
! NO2DGG : number of 2-D gaussian grid fields requested
! M2DGGP : array containing field codes for 2-D gaussian grid fields
! NO3DGGM: number of 3-D gaussian grid fields requested
! M3DGGM : array containing field codes for 3-D gaussian grid fields
! MPLEV  : array containing pressure levels (in Pascal)
! NO3DSPM: number of spherical harmonic fields requested (model level pp.)
! M3DSPM : array containing field codes for 3-D and 2-D fields (model lev. pp.)
! NO2DGGL: number of gaussian grid fields requested (pp. in lagged mode)
! M2DGGPL: array cont. field codes for gaussian grid fields (pp. in lagged mode)
! LMOVIE : If TRUE, grid point post-processing output instead of FA
!          or FDB on unit NPPPSH, for animation.
! LMOVPH : If TRUE output of physical fields for movies
!           at the present time only thermical radiation at the top

INTEGER(KIND=JPIM), PARAMETER :: JPOPLEV=200
INTEGER(KIND=JPIM), PARAMETER :: JPO2DGG=91
INTEGER(KIND=JPIM), PARAMETER :: JPO3DSPM=10
INTEGER(KIND=JPIM), PARAMETER :: JPO3DGG=30

INTEGER(KIND=JPIM) :: MPLEV(JPOPLEV)
INTEGER(KIND=JPIM) :: M2DGGP(JPO2DGG)
INTEGER(KIND=JPIM) :: M3DSPM(JPO3DSPM)
INTEGER(KIND=JPIM) :: M2DGGPL(JPO2DGG)
INTEGER(KIND=JPIM) :: M3DGGM(JPO3DGG)

INTEGER(KIND=JPIM) :: NO2DGG
INTEGER(KIND=JPIM) :: NO3DSPM
INTEGER(KIND=JPIM) :: NO2DGGL
INTEGER(KIND=JPIM) :: NO3DGGM
LOGICAL :: LRSUP
LOGICAL :: LMSLP
LOGICAL :: LMOVIE
LOGICAL :: LMOVPH
LOGICAL :: LOPPCNT
LOGICAL :: LRSACC
!     ------------------------------------------------------------------
END MODULE YOMPPC
