MODULE YOMRES

USE PARKIND1  ,ONLY : JPIM

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------

!*    Control variables for the restart control

! NFRRES  : frequency of restart write_ups (time-steps)
! NRESTS  : array containing restart write-up steps

! NUMRFS  :  maximum number of concurrent restart files

! NFLREST :  flag set non-zero by signal to indicate that
!            restart files should be written

! NFLSTOP :  flag set non-zero by signal to indicate that
!            execution should stop after writing restart files

! LSDHM   :  .TRUE. if time stamp is written as 'ddddhhmm' ;
!            otherwise time stamp is controled by LINC

! LDELRES :  .TRUE. if old restart files are deleted

INTEGER(KIND=JPIM), PARAMETER :: JPNWST=40
INTEGER(KIND=JPIM), PARAMETER :: JPNRF=4
INTEGER(KIND=JPIM) :: NRESTS(0:JPNWST)

CHARACTER (LEN = 8)  :: CRFTIME(JPNRF)
CHARACTER (LEN = 14) :: CTIME
CHARACTER (LEN = 9)  :: CSTEP
CHARACTER (LEN = 10) :: COPY
LOGICAL :: LRSTEP
INTEGER(KIND=JPIM) :: NUMRFS
INTEGER(KIND=JPIM) :: N1RFS
INTEGER(KIND=JPIM) :: N2RFS
INTEGER(KIND=JPIM) :: NFRRES
INTEGER(KIND=JPIM) :: NFLSTOP
INTEGER(KIND=JPIM) :: NFLREST
LOGICAL :: LSDHM
LOGICAL :: LDELRES

END MODULE YOMRES
