MODULE YOMSCREE

USE PARKIND1  ,ONLY : JPIM

IMPLICIT NONE

SAVE

!*     YOMSCREE - SCREENING PARAMETERS
!                       SETUP IN SUBROUTINE*SUSCRE

!        HEIKKI JARVINEN   ECMWF     15/3/95

!     NAME      TYPE                  MEANING
!     ----      ----                  -------

!     NGLSYN      I    NO. REPORTS IN GLOBAL SYNPTIC TIME-LOCATION ARRAY
!     NGLSHI      I    NO. REPORTS IN GLOBAL SHIP    TIME-LOCATION ARRAY
!     NGLAIR      I    NO. REPORTS IN GLOBAL AIREP   TIME-LOCATION ARRAY
!     NGLDRI      I    NO. REPORTS IN GLOBAL DRIBU   TIME-LOCATION ARRAY
!     NGLTOV      I    NO. REPORTS IN GLOBAL TOVS    TIME-LOCATION ARRAY
!     NGLGEO      I    NO. REPORTS IN GLOBAL GEOS    TIME-LOCATION ARRAY
!     NGLSSM      I    NO. REPORTS IN GLOBAL SSMI    TIME-LOCATION ARRAY
!     NGLSAT      I    NO. REPORTS IN GLOBAL SATOB   TIME-LOCATION ARRAY
!     NGLSAM      I    NO. REPORTS IN GLOBAL SATAM   TIME-LOCATION ARRAY

!     NCDYTL      I    NO. ITEMS PER REPORT IN SYNOPTIC TIME-LOCATION ARRAY
!     NCDSTL      I    NO. ITEMS PER REPORT IN SHIP     TIME-LOCATION ARRAY
!     NCDATL      I    NO. ITEMS PER REPORT IN AIREP    TIME-LOCATION ARRAY
!     NCDDTL      I    NO. ITEMS PER REPORT IN DRIBU    TIME-LOCATION ARRAY
!     NCDTTL      I    NO. ITEMS PER REPORT IN TOVS     TIME-LOCATION ARRAY
!     NCDGTL      I    NO. ITEMS PER REPORT IN GEOS     TIME-LOCATION ARRAY
!     NCDITL      I    NO. ITEMS PER REPORT IN SSMI     TIME-LOCATION ARRAY
!     NCDWTL      I    NO. ITEMS PER REPORT IN SATOB    TIME-LOCATION ARRAY
!     NCDMTL      I    NO. ITEMS PER REPORT IN SATAM    TIME-LOCATION ARRAY

!     NAMBPL      I    NUMBER OF AMBIGUOUS PLATFORMS
!     CAMBPL      C    LIST OF AMBIGUOUS PLATFORMS
!     NSUPERSONIC I    NUMBER OF SUPERSONIC AIRCRAFTS
!     CSUPERSONIC C    LIST OF SUPERSONIC AIRCRAFTS

!     NRDBRR      I    REJECTED REPORTS DUE TO RDB-FLAGS
!     NRDBRD      I    REJECTED DATUMS  DUE TO RDB-FLAGS
!     NREVTOT     I    SUMMING UP REPORT EVENTS
!     NDEVTOT     I    SUMMING UP DATUM  EVENTS
!     NDOBVA      I    SUMMING UP VARIABLES IN EACH OBSERVATION TYPE
!     NDEPEX      I    SUMMING UP DATUM WHERE DEPARTURE EXISTS
!     NDEPNE      I    SUMMING UP DATUM WHERE DEPARTURE DOES NOT EXIST
!     NA1DQS      I    AN ARRAY FOR 1DVAR QUALITY STATISTICS
!     CA1DQS      C    LIST OF SATELLITE ID'S ON THAT ARRAY
!     ND1DQS      I    SECOND DIMENSION OF THAT ARRAY
!     NDFLMX      I    MAXIMUM VALUE OF A DATUM FLAG
!     NDFLMN      I    MINIMUM VALUE OF A DATUM FLAG

INTEGER(KIND=JPIM) :: NGLSYN
INTEGER(KIND=JPIM) :: NGLSHI
INTEGER(KIND=JPIM) :: NGLAIR
INTEGER(KIND=JPIM) :: NGLDRI
INTEGER(KIND=JPIM) :: NGLTOV
INTEGER(KIND=JPIM) :: NGLGEO
INTEGER(KIND=JPIM) :: NGLSSM
INTEGER(KIND=JPIM) :: NGLSAT
INTEGER(KIND=JPIM) :: NGLSAM
INTEGER(KIND=JPIM) :: NCDYTL
INTEGER(KIND=JPIM) :: NCDSTL
INTEGER(KIND=JPIM) :: NCDATL
INTEGER(KIND=JPIM) :: NCDDTL
INTEGER(KIND=JPIM) :: NCDTTL
INTEGER(KIND=JPIM) :: NCDGTL
INTEGER(KIND=JPIM) :: NCDITL
INTEGER(KIND=JPIM) :: NCDWTL
INTEGER(KIND=JPIM) :: NCDMTL
INTEGER(KIND=JPIM) :: NAMBPL
INTEGER(KIND=JPIM) :: NSUPERSONIC
INTEGER(KIND=JPIM) :: ND1DQS
INTEGER(KIND=JPIM) :: NDFLMX
INTEGER(KIND=JPIM) :: NDFLMN

INTEGER(KIND=JPIM),ALLOCATABLE:: NRDBRR(:,:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NRDBRD(:,:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NREVTOT(:,:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NDEVTOT(:,:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NDOBVA(:,:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NDEPEX(:,:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NDEPNE(:,:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NA1DQS(:,:)

CHARACTER(LEN=8),ALLOCATABLE:: CAMBPL(:)
CHARACTER(LEN=8),ALLOCATABLE:: CSUPERSONIC(:)
CHARACTER(LEN=8),ALLOCATABLE:: CA1DQS(:)

!-----------------------------------------------------------------------

END MODULE YOMSCREE
