MODULE YOMSPJB

USE PARKIND1  ,ONLY : JPRB
USE SPECTRAL_FIELDS_MOD

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------

!*    Spectral Jb arrays

TYPE(SPECTRAL_FIELD) :: SPJB

!     ------------------------------------------------------------------

! -   Background fields


REAL(KIND=JPRB),ALLOCATABLE,TARGET:: SP7A3(:,:,:)  ! 3D spectral variables.
REAL(KIND=JPRB),ALLOCATABLE,TARGET:: SP7A2(:,:)    ! 2D spectral variables.
REAL(KIND=JPRB),ALLOCATABLE,TARGET:: SP7A1(:,:)    ! mean values of (U,V).
REAL(KIND=JPRB),ALLOCATABLE,TARGET:: GP7A3(:,:,:,:) ! 3D gridpoint variables

!     ------------------------------------------------------------------

! -   Splitting of the background variables

REAL(KIND=JPRB),POINTER:: SP7VOR(:,:)              ! Vorticity.
REAL(KIND=JPRB),POINTER:: SP7DIV(:,:)              ! Divergence.
REAL(KIND=JPRB),POINTER:: SP7HV(:,:,:)             ! GMV thermodynamic var.
REAL(KIND=JPRB),POINTER:: SP7T(:,:)                ! Temperature.
REAL(KIND=JPRB),POINTER:: SP7SPD(:,:)              ! Pressure departure var.
REAL(KIND=JPRB),POINTER:: SP7SVD(:,:)              ! Vertical divergence var.
REAL(KIND=JPRB),POINTER:: SP7Q(:,:)                ! Specific humidity.
REAL(KIND=JPRB),POINTER:: SP7O3(:,:)               ! Ozone.
REAL(KIND=JPRB),POINTER:: SP7L(:,:)                ! Liquid water.
REAL(KIND=JPRB),POINTER:: SP7I(:,:)                ! Ice.
REAL(KIND=JPRB),POINTER:: SP7D2D(:,:)              ! 2D variables.
REAL(KIND=JPRB),POINTER:: SP7SP(:)                 ! Log of surface pressure.
REAL(KIND=JPRB),POINTER:: SP7VELT1(:)              ! etadot dprehyd/deta.
REAL(KIND=JPRB),POINTER:: SP7UB(:)                 ! mean value of U.
REAL(KIND=JPRB),POINTER:: SP7VB(:)                 ! mean value of V.

!     ------------------------------------------------------------------
END MODULE YOMSPJB
