MODULE YOMSSMI

USE PARKIND1  ,ONLY : JPIM

USE PARSSMI

IMPLICIT NONE

SAVE

!*     YOMSSMI - VARIOUS SSMI PARAMETERS/ARRAYS

!          D. VASILJEVIC   ECMWF     19/9/94

!     NAME            TYPE          MEANING
!     ----            ----          -------
!     NMXSMLI            I      MAX NUMBER OF SSM/I LINES IN 1 ORBIT
!     NMXSMEL            I      MAX NUMBER OF ELEMENTS IN 1 SCAN

!     NSSMISKI           I      NUMBER OF POINTS TO SKIP ALONG/ACROSS

!     LSSMITHI           L      SSMI THINNING SWITCH

!     LSSMILMA           L      SSMI LINE MASK
!     LSSMIEMA           L      SSMI ELEMENT MASK  

INTEGER(KIND=JPIM) :: NMXSMLI
INTEGER(KIND=JPIM) :: NMXSMEL
INTEGER(KIND=JPIM) :: NSSMISKI

LOGICAL :: LSSMITHI
LOGICAL :: LSSMILMA(JPMXSMLI)
LOGICAL :: LSSMIEMA(JPMXSMEL)

!-----------------------------------------------------------------------

END MODULE YOMSSMI
