MODULE YOMTPHY

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!   -----------------------------------------------------------------

!*   Buffer for trajectory array at time t-dt

!    NLENGT95B                    : length of buffer for 3D fields
!    NLENGTT5B                    : length of buffer for phys.tendencies
!    NLENGTS5B                    : length of buffer for surface fields
!    TRAJPHYS(NLENGT95B,0:NSTOP)  : buffer for 3D fields
!    TRAJPHTE(NLENGTT5B,0:NSTOP)  : buffer for 3D phys.tendencies
!    TRAJPHSF(NLENGTS5B,0:NSTOP+1): buffer for surface fields
!    NSTAGT95B(NDGSAG:NDGENG)     : start adresses for packets within buffer
!                                   for 3D fields
!    NSTAGTT5B(NDGSAG:NDGENG)     : start adresses for packets within buffer
!                                   for 3D phys. tendencies 
!    NSTAGTS5B(NDGSAG:NDGENG)     : start adresses for packets within buffer
!                                   for surface fields

INTEGER(KIND=JPIM) :: NLENGT95B
INTEGER(KIND=JPIM) :: NLENGTT5B
INTEGER(KIND=JPIM) :: NLENGTS5B

REAL(KIND=JPRB),ALLOCATABLE:: TRAJPHYS(:,:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NSTAGT95B(:)
REAL(KIND=JPRB),ALLOCATABLE:: TRAJPHTE(:,:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NSTAGTT5B(:)
REAL(KIND=JPRB),ALLOCATABLE:: TRAJPHSF(:,:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NSTAGTS5B(:)

!     containing pointers

!   ----------------------------------------------------------------
END MODULE YOMTPHY
