MODULE YOMTS
USE PARKIND1  ,ONLY : JPIM      ,JPRB

IMPLICIT NONE

SAVE

!*

!       /YOMTS/  L. AUGER

!       TABLES DEFINING ALL THE LOGISTICS FOR INCLUDING TS IN CONTROL VARIABLE

!   COMMENTS:
!   --------
! TSCVX:     Surface temperature (TS) at observation points
! TSCVER:    TS control variable, standard deviation of error in background
! TSCVBG:    TS control variable, background
! TSCVX5:    Surface temperature (TS) at observation points: trajectory part
! NVATSOFF:  Offset to TS data in control variable

REAL(KIND=JPRB),ALLOCATABLE :: TSCVX(:)
REAL(KIND=JPRB) :: TSCVER
REAL(KIND=JPRB),ALLOCATABLE :: TSCVBG(:)
REAL(KIND=JPRB),ALLOCATABLE :: TSCVX5(:)
INTEGER(KIND=JPIM),ALLOCATABLE :: NVATSOFF(:)

!       ------------------------------------------------------------------

END MODULE YOMTS
