MODULE YOMVRTL

USE PARKIND1  ,ONLY : JPRB

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------

!*    Switches for variational assimilation: use of tangent linear model
! L131TL  : .T. = the incremental is to be run with the tangent model.
! L801TL  : .T. = the sensitivity  is to be run with the tangent model.
! LTLINT  : .T. = Flag telling if we are in the tangent integration
!                 of the model (incremental)
! LOBSTL  : .T. = we use the tangent linear of the observation operators
!                 (otherwise a finite-difference approximation is used)
LOGICAL :: L131TL
LOGICAL :: L801TL
LOGICAL :: LTLINT
LOGICAL :: LOBSTL

!*    Alterations of the TL and AD models
LOGICAL :: LDRYTL       ! .T. = remove the coupling of q and T in the dynamics

!*    Switches for variational assimilation: incremental convergence filter
LOGICAL :: LINCV        ! .T.= reject obs with bad incremental convergence
LOGICAL :: LINCVDBG     ! .T.= print debugging diagnostics
REAL(KIND=JPRB) :: RINCVLIM   ! rejection threshold for incremental convergence ratio
REAL(KIND=JPRB) :: RINCVSLOP  ! stiffness of the rejection

!     ------------------------------------------------------------------
END MODULE YOMVRTL
