MODULE YOMWFPDS

! Internal control of horizontal interpolations

! LQUAD   : .TRUE. if any quadratic interpolation
! LWSTD04 : .TRUE. if any bilinear interpolation (*) without any mask
! LWLAN04 : .TRUE. if any bilinear interpolation (*) with land mask
! LWSEA04 : .TRUE. if any bilinear interpolation (*) with sea mask
! LWSTD12 : .TRUE. if any quadratic interpolation without any mask
! LWLAN12 : .TRUE. if any quadratic interpolation with land mask
! LWSEA12 : .TRUE. if any quadratic interpolation with sea mask 
! LWIC    : .TRUE. if isolated lakes/islands array is allocated and computed

! NFPWIDE : Number of extra-rows for horizontal interpolations
!           Should be 3 (one on the left, two on the right) to enable both
!           quadratic and bilinear interpolations in the same job, unless
!           horizontal interpolations mechanism is switched off.

! (*) or no interpolations but "nearest point" research.
 
!-----------------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM

IMPLICIT NONE

SAVE


LOGICAL :: LQUAD
LOGICAL :: LWSTD04
LOGICAL :: LWLAN04
LOGICAL :: LWSEA04
LOGICAL :: LWSTD12
LOGICAL :: LWLAN12
LOGICAL :: LWSEA12
LOGICAL :: LWIC

INTEGER(KIND=JPIM) :: NFPWIDE

!-----------------------------------------------------------------------------

END MODULE YOMWFPDS
