!****--------------------------------------------------------------------
!**** NAMCUMFS : Namelist for the simplified convection scheme
!**** 
!****  Author   : P. Lopez  ECMWF 01/2002 
!****
!****  Modifications:
!**** 
!****  P. Lopez   06-Oct-2005   Removed microphysics parameters
!****  P. Lopez   22-Oct-2007   Added implcitness factors
!****
!****--------------------------------------------------------------------
#ifdef DOC
!***
!***  LECUMFS  : SWITCH ON SIMPLIFIED CONVECTIVE MASS-FLUX SCHEME IN TRAJECTORY
!***  LECUMFS2 : SWITCH ON SIMPLIFIED CONVECTIVE MASS-FLUX SCHEME IN TL AND AD
!***  LREGCV   : SWITCH ON REGULARIZATIONS OF SIMPLIFIED CONVECTION SCHEME 
!***             IN TANGENT-LINEAR AND ADJOINT CALCULATIONS
!***  RMFSOLUV2: implicitness factor for mass flux solver for momentum
!***  RMFSOLTQ2: implicitness factor for mass flux solver for T and q
!***  RMFSOLCT2: implicitness factor for chemical tracers
!***  RMFCFL2  : Mass-flux limiter for T and q (times CFL criterion)
!***
!***---------------------------------------------------------------------
#endif
NAMELIST / NAMCUMFS / LECUMFS, LECUMFS2, LREGCV, &
                    & RMFSOLUV2, RMFSOLTQ2, RMFSOLCT2, RMFCFL2


