!*    NAMELIST NAMOBS - RUN OBSERVATION CONTROL PARAMETERS

!        D. VASILJEVIC   ECMWF     01/03/1990

#ifdef DOC

!     NAME                 MEANING                         DEFAULT
!     ----                 -------                         -------


!     LSLREJ   SEA/LAND REJECTION SWITCH                    TRUE
!     LSLRW10  SEA/LAND 10M WIND REJ. SWITCH                TRUE
!     LSLRT2   SEA/LAND 2M TEMP. REJ. SWITCH                TRUE
!     LSLRRH2  SEA/LAND 2M REL. HUM. REJ. SWITCH            TRUE
!     LHDREJ   HEIGHT DIFFERENCE REJECTION SWITCH           TRUE
!     LHDRW10  HEIGHT DIFFERENCE 10M WIND REJ. SWITCH       TRUE
!     LHDRT2   HEIGHT DIFFERENCE 2M TEMP. REJ. SWITCH       TRUE
!     LHDRRH2  HEIGHT DIFFERENCE 2M REL. HUM. REJ. SWITCH   TRUE
!     LCAPACH  .TRUE. USE OF APACHE in HOP
!     LCACHMT  .TRUE. USE OF ACHMT  in HOP
!     LOBCLN   .TRUE. CLEANING NON WANTED OBS FOR MF
!     NCENHO   CENTRAL HOUR IN 4-D PERIOD FROM START OF PERIOD OR DAY
!     NCENDA   CENTRAL DAY OF 4-D PERIOD FROM THE START
!     LMFSCRE  METEO-FRANCE SCREENING (according to obs. types)
!     NOBSHOR  OBSERVATION INTERPOLATION NO.
!                201 =  4 POINTS INTERPOLATION
!                203 = 12 POINTS INTERPOLATION
!     LMKCMARPL   L MAKECMA REPLACEMENT
!     LMKCMARPLO  L RUN MAKECMA REPLACEMENT ONLY
!     LRPLSWAPOUT L SWAP OUT DB AFTER MKCMARPL
!     LTHINNER_PRINT   L LOCAL PRINTING SWITCH FOR THINNER
!     LSATOBTHIN_NO_SQ L SATOB THINNING BUT NOT USING OBS SQ NO.
!     LSATAMTHIN_NO_SQ L SATAM(SATOB) THINNING BUT NOT USING OBS SQ NO.
!     LTOVSTHIN_NO_SQ  L TOVS THINNING BUT NOT USING OBS SQ NO.
!     LRAD1CTHIN_NO_SQ L RAD1C THINNING BUT NOT USING OBS SQ NO.
!     LSSMITHIN_NO_SQ  L SSMI THINNING BUT NOT USING OBS SQ NO.
!     LSCATTTHIN_NO_SQ L SCATT THINNING BUT NOT USING OBS SQ NO.
!     LSCATT_NEUTRAL   L ASSIMILATE SCATT AS NEUTRAL WIND
!     LSATEMTHIN_NO_SQ L SATEM THINNING BUT NOT USING OBS SQ NO.
!     LREO3THIN_NO_SQ  L REO3 THINNING BUT NOT USING OBS SQ NO.
!     LGPSROTHIN_NO_SQ L GPSRO THINNING BUT NOT USING OBS SQ NO.
!     LSYNOPPAOB_RED_NO_SQ    L SYNOP/PAOB REDUNDANCY CHECK NO SEQUENCE NO. USED
!     LSYNOPPAOB_REDRP_NO_SQ  L SYNOP/PAOB (1) REDUNDANCY CHECK NO SEQUENCE NO. USED
!     LSYNOPPAOB_REDRP1_NO_SQ L SYNOP/PAOB (2) REDUNDANCY CHECK NO SEQUENCE NO. USED
!     LSHIP_NO_SQ          L SHIP REDUNDANCY CHECK NO SEQUENCE NO. USED
!     LAIREPS_NO_SQ        L AIREPS THINNING NO SEQUENCE NO. USED
!     LAIREPS_DUP_NO_SQ    L AIREPS REDUNDANCY CHECK NO SEQUENCE NO. USED
!     LDRIBUS_NO_SQ        L DRIBUS REDUNDANCY CHECK NO SEQUENCE NO. USED
!     LTEMPPILOT_NO_SQ     L TEMP/PILOT REDUNDANCY CHECK NO SEQUENCE NO. USED
!     LTEMPSYNOP_NO_SQ     L TEMP/SYNOP REDUNDANCY CHECK NO SEQUENCE NO. USED
!
!     L_F_SCR_WORK_TS      L FINAL SCREENING WORK TO BE DONE WITHIN TIMESLOT LOOP
!     LRSTBIAS_ODB         L RS T BIAS USING ODB
!     LMKCMARPL_OPENMP        L TO RUN MKCMARPL TIMESLOTS IN OPENMP-MODE (suobs.F90)
!     L_OBS_ERR_INCREASE_Hretr L FOR SYNOP Z OBS ERR TO BE INCREASED IN Hretr rther than in Prech
!     LAMSUB_FULL              L USE OF AMSUB DATA IN FULL RESOLUTION (90 FOV)
!     LSOE                 FLAG TO ACTIVATE RIGHT CALCULATION OF SOLAR ANGLE IN BLACKLIST, IF FALSE, SOE IS PUT AT 90

!     LVDFTRAJ             L GET SURFACE INFO FOR IFSTRAJ FROM VDFMAIN      IN EC_PHYS
!     LVDFMIN              L GET SURFACE PERTS FOR IFSMIN FROM VDFMAINTL/AD IN EC_PHYS_TL/AD
!     LZ0FC                L USE FORECAST, RATHER THAN CLIMAT. SURF. ROUGHNESS IN OBS OPERATORS

#endif

NAMELIST/NAMOBS/&
& LCAPACH, LCACHMT, LOBCLN &
&,LMFSCRE ,NOBSHOR &
&,LSLREJ  ,LSLRW10 ,LSLRT2  ,LSLRRH2 &
&,LHDREJ  ,LHDRW10 ,LHDRT2  ,LHDRRH2 &
&,LMKCMARPL, LMKCMARPLO, LRPLSWAPOUT &
&,LSATOBTHIN_NO_SQ, LSATAMTHIN_NO_SQ, LTOVSTHIN_NO_SQ &
&,LRAD1CTHIN_NO_SQ, LSSMITHIN_NO_SQ , LSCATTTHIN_NO_SQ, LSCATT_NEUTRAL  &
&,LSATEMTHIN_NO_SQ, LREO3THIN_NO_SQ , LGPSROTHIN_NO_SQ &
&,LTHINNER_PRINT &
&,LSYNOPPAOB_RED_NO_SQ, LSYNOPPAOB_REDRP_NO_SQ, LSYNOPPAOB_REDRP1_NO_SQ &
&,LSHIP_NO_SQ, LAIREPS_NO_SQ, LAIREPS_DUP_NO_SQ &
&,LDRIBUS_NO_SQ, LTEMPPILOT_NO_SQ, LTEMPSYNOP_NO_SQ, L_F_SCR_WORK_TS &
&,LRSTBIAS_ODB &
&,L_OBS_ERR_INCREASE_Hretr,LMKCMARPL_OPENMP,LAMSUB_FULL,LSOE &
&,LVDFTRAJ,LVDFMIN,LZ0FC

!     ------------------------------------------------------------------


