SUBROUTINE SU_ERRORS

!**** SUBROUTINE SU_ERRORS - OBSERVATION AND PERSISTENCE ERRORS

!        D. VASILJEVIC    ECMWF    17/10/1994

!     PURPOSE
!     -------

!        SET OBSERVATION AND PERSISTENCE ERRORS

!**   INTERFACE
!     ---------

!        SU_ERRORS IS CALLED BY SUBROUTINE MAKECMA

!     METHOD
!     ------

!        SET ALL OBS./PERSISTENCE ERROR CONSTANTS/PARAMETERS.

!**   EXTERNALS
!     ---------

!        READNL  - READ NAMELIST
!        SUPERERR- DEFINE PERSISTENCE ERRORS
!        SUOBSERR- DEFINE OBS. ERRORS

!**   HISTORY
!     -------

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMERR   , ONLY : LERRTHI  ,LERRPWC  ,LHEAREAD ,LRHERRMO
USE YOMLUN   , ONLY : NULOUT

IMPLICIT NONE
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "suobserr.intfb.h"
#include "supererr.intfb.h"

!-----------------------------------------------------------------------
!*

!        1.       GET ERRORS NAMELIST
!                 -------------------


IF (LHOOK) CALL DR_HOOK('SU_ERRORS',0,ZHOOK_HANDLE)
LERRTHI = .FALSE.
LERRPWC = .FALSE.
LHEAREAD= .FALSE.
LRHERRMO= .TRUE.
!CALL READNL('NAMERR')
!*
!-----------------------------------------------------------------------

!        2.       DEFINE PERSISTENCE ERRORS
!                 -------------------------

CALL SUPERERR
!*
!-----------------------------------------------------------------------

!        3.       DEFINE OBSERVATION ERRORS
!                 -------------------------

CALL SUOBSERR
!*
!-----------------------------------------------------------------------

!        4.       SETUP DONE
!                 ----------

WRITE(NULOUT,'(''0OBSERVATION AND PERSISTENCE ERRORS SETUP'')')
!*
!-----------------------------------------------------------------------

!        5.       RETURN
!                 ------

IF (LHOOK) CALL DR_HOOK('SU_ERRORS',1,ZHOOK_HANDLE)
END SUBROUTINE SU_ERRORS
