SUBROUTINE CCSETOD(KOUT)

!**** SUBROUTINE CCSETOD - CROSS-CHECK SOME ODB COMMON VARIABLES

!        D. VASILJEVIC   ECMWF     05/9/94

!     PURPOSE
!     -------

!        CROSS-CHECK SOME DEFINED GENERAL ODB COMMON VARIABLES

!**   INTERFACE
!     ---------

!        CALL CCSETOD(KOUT)
!     WHERE:
!           KOUT  = OUTPUT UNIT

!        CCSETOD IS CALLED FROM SUBROUTINES

!**   METHOD
!     ------

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE PARCMA   , ONLY : JPMXOTP  ,JPMXOCT  ,JPMXUP   ,JPMXAD   ,JPMXVAR
USE YOMCMA   , ONLY : NMXDEP   ,NMXUPD   ,&
 & NMXNVO   ,NMXOTP   ,NMXOCT   ,&
 & NMXTOCH  ,NMXATOCH ,NMXSSMCH ,NMXMSUCH ,&
 & NMXSSUCH ,NMXAMSUCH,NMXASSUCH,&
 & NMXTRMCH  

!*
!-----------------------------------------------------------------------

!        1.       CROSS-CHECK SOME ODB GENERAL COMMON VARIABLES
!                 ---------------------------------------------

!*          1.21  CROSS CHECK VALUES

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KOUT 
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('CCSETOD',0,ZHOOK_HANDLE)
IF(NMXDEP > JPMXAD)     THEN
  WRITE(KOUT,'(''0ERROR IN SUBROUTINE CCSETOD'')')
  WRITE(KOUT,'(''MAX. NO. OF ADD. DEPART. TOO BIG'')')
  WRITE(KOUT,'('' MAX. NO. OF ADD. DEPARTURES'','' SET:'',I10)') NMXDEP
  WRITE(KOUT,'('' MAX. NO. OF ADD. DEPARTURES'','' EXPECTED:'',I10)') JPMXAD
!  CALL ABOR1('SUBROUTINE CCSETOD')
ENDIF

IF(NMXUPD > JPMXUP)     THEN
  WRITE(KOUT,'(''0ERROR IN SUBROUTINE CCSETOD'')')
  WRITE(KOUT,'('' MAX. NO. OF UPDATES TOO BIG'')')
  WRITE(KOUT,'('' MAX. NO. OF UPDATES'','' SET:'',I10)') NMXUPD
  WRITE(KOUT,'('' MAX. NO. OF UPDATES'','' EXPECTED:'',I10)') JPMXUP
! CALL ABOR1('SUBROUTINE CCSETOD')
ENDIF

IF(NMXOTP > JPMXOTP)    THEN
  WRITE(KOUT,'(''0ERROR IN SUBROUTINE CCSETOD'')')
  WRITE(KOUT,'('' MAX. NO. OF ODB OBS. TYPES TOO BIG'')')
  WRITE(KOUT,'('' MAX. NO. OF OBS. TYPES'','' SET:'',I10)') NMXOTP
  WRITE(KOUT,'('' MAX. NO. OF OBS. TYPES'','' EXPECTED:'',I10)') JPMXOTP
! CALL ABOR1('SUBROUTINE CCSETOD')
ENDIF

IF(NMXOCT > JPMXOCT)    THEN
  WRITE(KOUT,'(''0ERROR IN SUBROUTINE CCSETOD'')')
  WRITE(KOUT,'('' MAX. NO. OF ODB CODE TYPES TOO BIG'')')
  WRITE(KOUT,'('' MAX. NO. OF CODE TYPES'','' SET:'',I10)') NMXOCT
  WRITE(KOUT,'('' MAX. NO. OF CODE TYPES'','' EXPECTED:'',I10)') JPMXOCT
! CALL ABOR1('SUBROUTINE CCSETOD')
ENDIF

!*          1.22  PRINT VALUES

WRITE(KOUT,'(''0SUBROUTINE CCSETOD; ODB SETUP RELATED'','' VALUES:'')')
WRITE(KOUT,'('' MAX. NO. OF ADD. DEPARTURES    :'',I10)') NMXDEP
WRITE(KOUT,'('' MAX. NO. OF UPDATES            :'',I10)') NMXUPD
WRITE(KOUT,'('' MAX. NO. OF LEVELS             :'',I10)') NMXNVO
WRITE(KOUT,'('' MAX. NO. OF VARIABLES          :'',I10)') JPMXVAR
WRITE(KOUT,'('' MAX. NO. OF OBS. TYPES         :'',I10)') NMXOTP
WRITE(KOUT,'('' MAX. NO. OF OBS. CODE TYPES    :'',I10)') NMXOCT
WRITE(KOUT,'('' MAX. NO. OF TOVS CHANNELS      :'',I10)') NMXTOCH
WRITE(KOUT,'('' MAX. NO. OF MSU CHANNELS       :'',I10)') NMXMSUCH
WRITE(KOUT,'('' MAX. NO. OF SSU CHANNELS       :'',I10)') NMXSSUCH
WRITE(KOUT,'('' MAX. NO. OF LEVEL-1C/GEOS CHANS:'',I10)') NMXATOCH
WRITE(KOUT,'('' MAX. NO. OF AMSU CHANNELS      :'',I10)') NMXAMSUCH
WRITE(KOUT,'('' MAX. NO. OF ASSU CHANNELS      :'',I10)') NMXASSUCH
WRITE(KOUT,'('' MAX. NO. OF SSMI CHANNELS      :'',I10)') NMXSSMCH
WRITE(KOUT,'('' MAX. NO. OF TRMM CHANNELS      :'',I10)') NMXTRMCH
!*
!-----------------------------------------------------------------------

!        2.       RETURN
!                 ------

IF (LHOOK) CALL DR_HOOK('CCSETOD',1,ZHOOK_HANDLE)
END SUBROUTINE CCSETOD
