SUBROUTINE CHDEVE(PREPORT,KRLN,KSQN,KEVENT)

!**** SUBROUTINE CHDEVE - CHANGE (ADD) DATUM EVENT

!          HEIKKI JARVINEN   ECMWF          15/MAR/1995

!*    PURPOSE
!     -------

!        CHANGE DATUM EVENT

!**   INTERFACE
!     ---------

!     ***CALL CHDEVE(PREPORT,KRLN,KSQN,KEVENT)
!     WHERE PREPORT = THE WHOLE REPORT IN AN REAL ARRAY
!           KRLN    = THE REPORT LENGTH
!           KSQN    = SEQUENCE NUMBER OF THE DATUM
!           KEVENT  = NUMBER OF DATUM EVENT TO BE ADDED

!        CHDEVE IS CALLED BY SUBROUTINES PRECH, SELEC, ...

!*    METHOD
!     ------

!*    EXTERNALS
!     ---------

!**   MODIFICATIONS
!     -------------
!        H. Jarvinen 12 Dec 1996 : A modified subroutine call
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMCMHDR , ONLY : NCMHLN   ,NCMBLN   ,NCMNLV
USE YOMCMBDY , ONLY : NCMDEV1  ,NCMESQN

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KRLN 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PREPORT(KRLN) 
INTEGER(KIND=JPIM),INTENT(IN)    :: KSQN 
INTEGER(KIND=JPIM),INTENT(IN)    :: KEVENT 
#include "fcobs.h"

INTEGER(KIND=JPIM) :: IBLN, ICMDEV1, IHLN, INLV, IPOS, ISQN, J
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "abor1.intfb.h"

!*
!     ------------------------------------------------------------------

!        1.       INITIALIZE
!                 ----------

!*          1.0   INTIALIZE

IF (LHOOK) CALL DR_HOOK('CHDEVE',0,ZHOOK_HANDLE)
IHLN = INTREA(PREPORT(NCMHLN))
IBLN = INTREA(PREPORT(NCMBLN))
INLV = INTREA(PREPORT(NCMNLV))

!*          1.1   FOR EXTENDED CMA

IF(KSQN <= INLV) THEN
  IPOS = IHLN + (KSQN-1)*IBLN
  ISQN = INTREA(PREPORT(IPOS+NCMESQN))
  IF(ISQN == KSQN) GOTO 2
ENDIF

!*          1.2   FOR COMPRESSED CMA

DO J = 1, INLV
  IPOS = IHLN + (J-1)*IBLN
  ISQN = INTREA(PREPORT(IPOS+NCMESQN))
  IF(ISQN == KSQN) GOTO 2
ENDDO

!*          1.5   SOMETHING IS WRONG

CALL ABOR1(' CHDEVE : SEQUENCE NUMBER NOT FOUND ')
!*
!     ------------------------------------------------------------------

!        2.       CHANGE DATUM EVENT
!                 ------------------

!*          2.0   INTIALIZE

2 CONTINUE
INVAL   = 1
ICMDEV1 = INTREA(PREPORT(IPOS+NCMDEV1))

!*          2.1   INSERT THE EVENT

ICMDEV1 = INSERT(ICMDEV1, INVAL, KEVENT-1)
PREPORT(IPOS+NCMDEV1) = REAINT(ICMDEV1)
!*
!     ------------------------------------------------------------------

!        3.       RETURN
!                 ------
IF (LHOOK) CALL DR_HOOK('CHDEVE',1,ZHOOK_HANDLE)
END SUBROUTINE CHDEVE

