SUBROUTINE EXTRAPAD(P_ADPROFIN, P_ADPROFOUT, KNPF )

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

IMPLICIT NONE

INTEGER(KIND=JPIM), PARAMETER :: JPLEV =43
INTEGER(KIND=JPIM), PARAMETER :: JPMOTOP =8
INTEGER(KIND=JPIM), PARAMETER :: JPMOLEV =43-JPMOTOP+1
INTEGER(KIND=JPIM),INTENT(IN)    :: KNPF 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: P_ADPROFIN(KNPF,JPMOLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: P_ADPROFOUT(KNPF,JPLEV) 
INTEGER(KIND=JPIM), PARAMETER :: JPXTLVIN =18
INTEGER(KIND=JPIM), PARAMETER :: JPXTLVOU =7
INTEGER(KIND=JPIM), PARAMETER :: JPXTOUMX =9
REAL(KIND=JPRB) :: Z_COEFF(JPXTLVIN,JPXTOUMX)
INTEGER(KIND=JPIM) :: JI
INTEGER(KIND=JPIM) :: JJ

REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('EXTRAPAD',0,ZHOOK_HANDLE)
Z_COEFF(1:JPXTLVIN, 1) = &
 & (/-0.5439_JPRB,0.0986_JPRB,0.2883_JPRB,0.2490_JPRB,0.0137_JPRB, &
 & -0.3474_JPRB,-0.2183_JPRB,-0.0916_JPRB,0.0580_JPRB,0.2026_JPRB,&
 & 0.2813_JPRB,0.3344_JPRB,-0.0961_JPRB,-0.4738_JPRB,0.2504_JPRB,&
 & 0.3186_JPRB,0.0006_JPRB,-0.3001_JPRB/)  
Z_COEFF(1:JPXTLVIN, 2) = &
 & (/0.0880_JPRB,0.0314_JPRB,-0.0469_JPRB,-0.1341_JPRB,-0.0834_JPRB, &
 & 0.0611_JPRB,-0.0304_JPRB,-0.0843_JPRB,0.0998_JPRB,0.2731_JPRB,&
 & 0.2598_JPRB,0.1852_JPRB,-0.0118_JPRB,-0.1806_JPRB,0.0151_JPRB,&
 & 0.1037_JPRB,  0.1282_JPRB,  0.1532_JPRB/)  
Z_COEFF(1:JPXTLVIN, 3) = &
 & (/0.6220_JPRB,-0.0697_JPRB,-0.3213_JPRB,-0.3509_JPRB,-0.1239_JPRB,&
 & 0.2714_JPRB, 0.0909_JPRB,-0.0374_JPRB,0.1594_JPRB,0.3408_JPRB,&
 & 0.2351_JPRB, 0.0390_JPRB,0.0536_JPRB, 0.0784_JPRB,-0.1803_JPRB,&
 & -0.0724_JPRB, 0.2489_JPRB, 0.5551_JPRB/)  
Z_COEFF(1:JPXTLVIN, 4) = &
 & (/1.2860_JPRB,-0.3116_JPRB,-0.6370_JPRB,-0.3330_JPRB,-0.0400_JPRB, &
 & 0.2315_JPRB, 0.1073_JPRB, 0.0161_JPRB,0.1668_JPRB,0.3014_JPRB,&
 & 0.1870_JPRB,-0.0052_JPRB,0.1122_JPRB,0.2133_JPRB, -0.3026_JPRB,&
 & -0.1904_JPRB,0.2886_JPRB,0.7436_JPRB/)  
Z_COEFF(1:JPXTLVIN, 5) = &
 & (/1.7806_JPRB,-0.4868_JPRB,-0.8326_JPRB,-0.2319_JPRB,0.0540_JPRB, &
 & 0.1063_JPRB,0.0949_JPRB, 0.0808_JPRB,0.1200_JPRB,0.1491_JPRB,&
 & 0.1030_JPRB,0.0336_JPRB,0.1411_JPRB,0.2033_JPRB, -0.3388_JPRB,&
 & -0.2399_JPRB,0.2338_JPRB,0.6844_JPRB/)  
Z_COEFF(1:JPXTLVIN, 6) = &
 & (/1.8949_JPRB,-0.4038_JPRB,-0.7716_JPRB,-0.1868_JPRB,0.0578_JPRB, &
 & 0.0515_JPRB, 0.0826_JPRB,0.0956_JPRB,0.0677_JPRB,0.0351_JPRB,&
 & 0.0108_JPRB,-0.0102_JPRB,0.1004_JPRB,0.1710_JPRB,-0.2467_JPRB,&
 & -0.1952_JPRB,0.1315_JPRB,0.4446_JPRB/)  
Z_COEFF(1:JPXTLVIN, 7) = &
 & (/1.7767_JPRB,-0.2038_JPRB,-0.6043_JPRB,-0.2209_JPRB,0.0272_JPRB, &
 & 0.1665_JPRB,0.0840_JPRB, 0.0053_JPRB,-0.0204_JPRB,-0.0484_JPRB,&
 & -0.0228_JPRB,0.0193_JPRB,0.0729_JPRB,0.0912_JPRB, -0.1542_JPRB,&
 & -0.1243_JPRB,0.0682_JPRB,0.2558_JPRB/)  
Z_COEFF(1:JPXTLVIN, 8) = &
 & (/1.5776_JPRB,-0.1120_JPRB,-0.4432_JPRB,-0.1009_JPRB,0.0476_JPRB, &
 & 0.0507_JPRB,0.0471_JPRB, 0.0312_JPRB,-0.0225_JPRB,-0.0755_JPRB,&
 & -0.0393_JPRB,0.0248_JPRB,0.0461_JPRB,0.0397_JPRB,  -0.0892_JPRB,&
 & -0.0694_JPRB,0.0387_JPRB,0.1460_JPRB/)  
Z_COEFF(1:JPXTLVIN, 9) = &
 & (/1.2832_JPRB,-0.0175_JPRB,-0.2829_JPRB,-0.0348_JPRB,0.0495_JPRB, &
 & 0.0123_JPRB,0.0183_JPRB, 0.0155_JPRB,-0.0098_JPRB,-0.0354_JPRB, &
 & -0.0177_JPRB,0.0135_JPRB,0.0220_JPRB,0.0174_JPRB,  -0.0423_JPRB,&
 & -0.0334_JPRB,0.0168_JPRB,0.0685_JPRB /)  

!----------------------------------------------
! ADJOINT COMPUTATIONS
!----------------------------------------------
DO JJ = 1, JPXTLVOU
  DO JI = 1, JPXTLVIN
    P_ADPROFIN(1:KNPF,JI+2) = P_ADPROFIN(1:KNPF,JI+2)+ &
     & P_ADPROFOUT(1:KNPF,JJ)*Z_COEFF(JI,JJ)  
  ENDDO
ENDDO
DO JJ = 1, JPXTLVOU
  P_ADPROFOUT(1:KNPF,JJ) = 0.0_JPRB
ENDDO
DO JI = JPXTLVOU+1, JPLEV
  P_ADPROFIN(1:KNPF,JI-JPMOTOP+1) = P_ADPROFIN(1:KNPF,JI-JPMOTOP+1)+&
   & P_ADPROFOUT(1:KNPF,JI)  
  P_ADPROFOUT(1:KNPF,JI) = 0.0_JPRB
ENDDO
IF (LHOOK) CALL DR_HOOK('EXTRAPAD',1,ZHOOK_HANDLE)

END SUBROUTINE EXTRAPAD
