SUBROUTINE IFSODBDDR1S(KCMDDR1)

!**** SUBROUTINE IFSODBDDR1S - ODB FIRST DDR CREATION (SHORT MODIFICATION)

!        D. VASILJEVIC     ECMWF    30/08/1994

!     PURPOSE
!     -------

!        MODIFIY ODB FIRST DDR (SHORT)

!**   INTERFACE
!     ---------

!        CALL IFSODBDDR1S(KCMDDR1)

!     WHERE:
!           KCMDDR1 = FIRST ODB DDR

!        IFSODBDDR1S IS CALLED BY OBADAT

!     METHOD
!     ------

!        ODB FIRST DDR IS MODIFIED

!     EXTERNALS
!     ---------

!     MODIFICATIONS
!     -------------
!        M.Hamrud      01-Oct-2003 CY28 Cleaning

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMCMA
USE YOMMKODB
USE YOMCMDDR
USE YOMCT0   , ONLY : LCANARI  ,LSCREEN
USE YOMANCS  , ONLY :      NMINPHOU ,NDAYFINH 
USE YOMLUN   , ONLY : NULOUT

IMPLICIT NONE


!-----------------------------------------------------------------------

INTEGER(KIND=JPIM),INTENT(INOUT) :: KCMDDR1(NMXDCL) 
REAL(KIND=JPRB) :: ZHOOK_HANDLE

!-----------------------------------------------------------------------

!*

!WRITE (NULOUT,'('' IFSODBDDR1S; DDR 1 IN '')')
!DO JPR = 1 , 1024
!  WRITE (NULOUT,'('' '',i4,1x,i10)') JPR,KCMDDR1(JPR)
!ENDDO

!                 FIRST ODB DDR MODIFICATION
!                 --------------------------

!*          1.1   FIRST DDR LEN.

!*          1.2   NO. OF NON INTEGER SECTIONS

!*          1.3   TYPE OF FIRST NON INTERGER SECTION

!*          1.4   TYPE OF SECOND NON INTERGER SECTION

!*          1.5   LEN. OF INTERGER SECTION

!*          1.6   LEN. OF FIRST NON INTERGER SECTION

!*          1.7   LEN. OF SECOND NON INTERGER SECTION

!*          1.8   LEN. OF NEXT DDR

!*          1.9   CREATION TIME

!*          1.10  CREATION DATE

!*          1.11  TIME OF THE MIDDLE OF OBS. PERIOD

!*          1.12  DATE OF THE MIDDLE OF OBS. PERIOD

!*          1.13  NO. OF SEC. PER TIME UNIT

!*          1.14  LEN. OF OBS. PERIOD IN TIME UNITS

IF (LHOOK) CALL DR_HOOK('IFSODBDDR1S',0,ZHOOK_HANDLE)
IF(LSCREEN) THEN
  WRITE (NULOUT,'('' WORD 14 (LEN. OF OBS. PERIOD IN TIME UNITS) '')')
  IF(L3DVAR)    THEN 
    WRITE (NULOUT,'('' CHANGED FORM:'',I10,'' TO:'',I10)') &
     & KCMDDR1(NCD1OP ),NDAYFINH * NMINPHOU  
    KCMDDR1(NCD1OP )=  NDAYFINH * NMINPHOU
  ELSE
    WRITE (NULOUT,'('' CHANGED FORM:'',I10,'' TO:'',I10)') &
     & KCMDDR1(NCD1OP ),N4DMIN  
    KCMDDR1(NCD1OP )=  N4DMIN 
  ENDIF
  CALL FLUSH(NULOUT)
ENDIF

!*          1.15  NO. OF PLANNED UPDATES

!*          1.16  NO. OF PERFORMED UPDATES

WRITE (NULOUT,'('' WORD 16 (NO. OF PERFORMED UPDATES) '')')
IF(.NOT.LSCREEN) THEN
  WRITE (NULOUT,'('' NOT CHANGED FORM:'',I10,'' TO:'',I10, &
   & '' FOR NON-SCREENING RUN'')') KCMDDR1(NCD1NUP),0  
! KCMDDR1(NCD1NUP)= 0
ELSE
  WRITE (NULOUT,'('' NOT CHANGED FORM:'',I10,'' TO:'',I10, &
   & '' FOR     SCREENING RUN'')') KCMDDR1(NCD1NUP),-1  
! KCMDDR1(NCD1NUP)= -1
ENDIF
CALL FLUSH(NULOUT)

!*          1.17  NO. OF ADDITIONAL DEPATRURES

!*          1.18  NO. OF DDRS  

!*          1.19  NO. OF DATA RECORDS

!*          1.20  MAX. LEN. OF DDR

!*          1.21  MAX. LEN. OF DATA REC.

!*          1.22  MAX. LEN. OF CMA REPORT

!*          1.23  TOTAL NO. OF CMA FILES

!*          1.24  CMA FILE SQ. NO.

!*          1.25  NO. OF TIME SLOTS

!*          1.26  MAX. NO. OF OBS. TYPES

!*          1.27  TOTAL NO. OF OBS.

!*          1.28  NO. OF SYNOP OBS.

!*          1.29  NO. OF AIREP OBS.

!*          1.30  NO. OF SATOB OBS.

!*          1.31  NO. OF DRIBU OBS.

!*          1.32  NO. OF TEMP OBS.

!*          1.33  NO. OF PILOT OBS.

!*          1.34  NO. OF SATEM (NON-RADIANCE) OBS.

!*          1.35  NO. OF SATEM (RADIANCE) OBS.

!*          1.36  NO. OF PAOB OBS.

!*          1.37  NO. OF SCATT. OBS.

!*          1.38  NO. OF LIMB OBS.

!*          1.39  NO. OF SSMI/TRMM OBS.

!*          1.40  NO. OF LEVEL-1C/GEOS OBS.

!*          1.41  NO. OF RETRIEVED OZONE LAYERS OBS.

!*          1.42  42-50 RESERVED

!*          1.51  TOTAL LENGTH OF CMA

!*          1.52  TYPE OF ANAL. (OI/VARIATIONAL/ETC.)

IF(LCANARI)     THEN
  WRITE (NULOUT,'('' WORD 52 (TYPE OF ANAL. (OI/VARIATIONAL/ETC.) '')')
  WRITE (NULOUT,'('' CHANGED FORM:'',I10,'' TO:'',I10)') &
   & KCMDDR1(NCD1TVA),1  
  KCMDDR1(NCD1TVA)=  1
ELSE
  IF(LSCREEN) THEN
    WRITE (NULOUT,'('' WORD 52 (TYPE OF ANAL. (OI/VARIATIONAL/ETC.) '')')
    IF(L3DVAR) THEN
      WRITE (NULOUT,'('' CHANGED FORM:'',I10,'' TO:'',I10)') &
       & KCMDDR1(NCD1TVA),3  
      KCMDDR1(NCD1TVA)=  3
    ELSE
      WRITE (NULOUT,'('' CHANGED FORM:'',I10,'' TO:'',I10)') &
       & KCMDDR1(NCD1TVA),4  
      KCMDDR1(NCD1TVA)=  4
    ENDIF
  ENDIF
ENDIF
CALL FLUSH(NULOUT)

!*          1.53  IFS CONF. NO.

!*          1.54  IFS NO. OF TIME STEPS

!*          1.55  BASIC LEN. OF REP. HEADER

!*          1.56  BASIC LEN. OF REP. BODY ENTRY

!*          1.57  NO. OF 1D VAR (TOVS) RETREIVED LEVELS

!*          1.58  NO. OF 1D VAR (TOVS) UPPERAIR RETREIVED VARIABLES

!*          1.59  NO. OF 1D VAR (TOVS) SINGLE LEVEL RETREIVED VARIABLES

!*          1.60  MODEL PROFILES

!*          1.61  NO. OF MODEL SURFACE VARIABLES

!*          1.62  NO. OF MODEL LEVELS

!*          1.63  NO. OF MODEL UPPERAIR VARIABLES

!*          1.64  64 NO. OF BUFR INPUT 6HR TIME SLOTS

!*          1.65  65-74 BUFR TIME SLOT DATES AND TIMES

!*          1.75  NO. OF 1D VAR (SSMI/TRMM) RETREIVED LEVELS

!*          1.76  NO. OF 1D VAR (SSMI/TRMM) UPPERAIR RETREIVED VARIABLES

!*          1.77  NO. OF 1D VAR (SSMI/TRMM) SINGLE LEVEL RETREIVED VARIABLES

!*          1.78  NO. OF 1D VAR (LEVEL-1C/GEOS) RETREIVED LEVELS

!*          1.79  NO. OF 1D VAR (LEVEL-1C/GEOS) UPPERAIR RETREIVED VARIABLES

!*          1.80  NO. OF 1D VAR (LEVEL-1C/GEOS) SINGLE LEVEL RETREIVED VARIABLES

!*          1.81  TOVS/LEVEL-1C/GEOS/SSMI/TRMM CMA OPTIONAL HEADER PART CONTENT

!*          1.82  82-100 SET TO MISSING

!*          1.101 TIME SLOTTING ! to be dealt with JUST SET TO 7

!-----------------------------------------------------------------------

!        2.       FIRST ODB DDR FORMAT (REAL SECTION)
!                 ------------------------------------

!*
!-----------------------------------------------------------------------

!        3.       FIRST ODB DDR FORMAT (CHARACTER SECTION)
!                 -----------------------------------------

!*
!-----------------------------------------------------------------------

!        4.       RETURN
!                 ------

!WRITE (NULOUT,'('' IFSODBDDR1S; DDR 1 OUT '')')
!DO JPR = 1 , 1024
!  WRITE (NULOUT,'('' '',i4,1x,i10)') JPR,KCMDDR1(JPR)
!ENDDO
 
IF (LHOOK) CALL DR_HOOK('IFSODBDDR1S',1,ZHOOK_HANDLE)
END SUBROUTINE IFSODBDDR1S
