SUBROUTINE IFSODBDDR2S(KCMDDR2)

!**** SUBROUTINE IFSODBDDR2S - SHORT MODIFICATION OF ODB SECOND DDR

!        D. VASILJEVIC     ECMWF    30/08/1994

!     PURPOSE
!     -------

!        ODB SECOND DDR SHORT MODIFICATION

!**   INTERFACE
!     ---------

!        CALL IFSODBDDR2S(KCMDDR2)
!           KCMDDR2 =

!        IFSODBDDR2S IS CALLED BY OBADAT

!     METHOD
!     ------

!        ODB SECOND DDR IS MODIFIED

!     EXTERNALS
!     ---------

!     MODIFICATIONS
!     -------------
!        M.Hamrud      01-Oct-2003 CY28 Cleaning

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMCMA   , ONLY : NMXDCL
USE YOMCMDDR
USE YOMLUN   , ONLY : NULOUT

IMPLICIT NONE

!-----------------------------------------------------------------------

INTEGER(KIND=JPIM)               :: KCMDDR2(NMXDCL) ! Argument NOT used
REAL(KIND=JPRB) :: ZHOOK_HANDLE

!-----------------------------------------------------------------------

!*

!WRITE (NULOUT,'('' IFSODBDDR2S: DDR 2 IN '')')
!DO JPR = 1 , 1024
!  WRITE (NULOUT,'('' '',i4,1x,i10)') JPR,KCMDDR2(JPR)
!ENDDO

!        1.       SECOND ODB DDR FORMAT (INTEGER SECTION)
!                 ---------------------------------------

!*          1.1   LEN. OF SECOND DDR

!*          1.2   NO. OF NON-INTEGER SECTIONS

!*          1.3   TYPE OF FIRST NON-INTEGER SECTION

!*          1.4   TYPE OF SECOND NON-INTEGER SECTION

!*          1.5   LEN. OF INTEGER SECTION

!*          1.6   LEN. OF FIRST NON-INTEGER SECTION

!*          1.7   LEN. OF SECOND NON-INTEGER SECTION

!*          1.8   LEN. OF NEXT DDR ! LOOKS OK

!*          1.9   NO. OF CLEAR SATEM THICKNESS LAYERS

!*          1.10  NO. OF CLOUDY SATEM THICKNESS LAYERS

!*          1.11  NO. OF MICROWAVE SATEM THICKNESS LAYERS

!*          1.12  SATELLITE ID's AND NO. OF REPORTS (NOT USED)

!*          1.24  24-25 RESERVED

!*          1.26  NO. OF SIMULATIONS PERFORMED

!*          1.27  NO. OF THE FOLLOWING WORDS USED TO STORE BIT MAP
!                 INDICATING ADDITIONAL DEPARTURS CREATED

!*          1.28  28-NS BIT MAP

!*          1.NS  NS-1024 NOT DEFINED

!*
!-----------------------------------------------------------------------

!        2.       SECOND ODB DDR FORMAT (REAL SECTION)
!                 ------------------------------------

!*
!-----------------------------------------------------------------------

!        3.       SECOND ODB DDR FORMAT (CHARACTER SECTION)
!                 -----------------------------------------

!*
!-----------------------------------------------------------------------

!        4.       RETURN
!                 ------
IF (LHOOK) CALL DR_HOOK('IFSODBDDR2S',0,ZHOOK_HANDLE)
WRITE (NULOUT,'('' IFSODBDDR2S; NOTHING TO MODIFY FOR NOW '')')
!WRITE (NULOUT,'('' IFSODBDDR2S: DDR 2 OUT '')')
!DO JPR = 1 , 1024
! WRITE (NULOUT,'('' '',i4,1x,i10)') JPR,KCMDDR2(JPR)
!ENDDO
CALL FLUSH(NULOUT)

IF (LHOOK) CALL DR_HOOK('IFSODBDDR2S',1,ZHOOK_HANDLE)
END SUBROUTINE IFSODBDDR2S
