SUBROUTINE MISCE(KSET)

!**** SUBROUTINE MISCE - PERFORM A MISCELLANEOUS COLLECTION OF CHECKS

!          HEIKKI JARVINEN   ECMWF          15/AUG/1995
!          DRASKO VASILJEVIC ECMWF          21/10/1999

!*    PURPOSE
!     -------

!        PERFORM A MISCELLANEOUS COLLECTION OF INDEPENDENT OBSERVATION
!     CHECKS.

!*    INTERFACE
!     ---------

!     ***CALL MISCE(KSET)
!     WHERE KSET  = ECSET

!        MISCE IS CALLED BY SUBROUTINE DECIS

!*    METHOD
!     ------

!        PERFORM THE FOLLOWING CHECKS:

!**   EXTERNALS
!     ---------

!        REDSL - REMOVE REDUNDANT SURFACE LEVELS FROM TEMP/PILOT

!**   MODIFICATIONS
!     -------------

!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMLUN   , ONLY : NULOUT
USE YOMSCC   , ONLY : LSCDPR

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KSET 
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "redsl.intfb.h"

!*
!     ------------------------------------------------------------------

!        1.       INITIALIZE
!                 ----------

!*          1.0   INFORM

IF (LHOOK) CALL DR_HOOK('MISCE',0,ZHOOK_HANDLE)
IF(LSCDPR) WRITE(NULOUT,'(''     MISCELLANEOUS CHECKS '')')
!*
!     ------------------------------------------------------------------

!        2.       PERFORM CHECKS
!                 --------------

!*          2.1   REMOVE REDUNDANT SURFACE LEVELS FROM TEMP/PILOT

CALL REDSL(KSET)
!*
!     ------------------------------------------------------------------

!        3.      RETURN
!                ------
IF (LHOOK) CALL DR_HOOK('MISCE',1,ZHOOK_HANDLE)
END SUBROUTINE MISCE
