SUBROUTINE NGEDEVE2(KDEVEN2,KEVENT,KLIST)

!**** SUBROUTINE NGEDEVE2 - GET ALL DATUM EVENTS FROM EVENT WORD NUMBER 2

!          HEIKKI JARVINEN   ECMWF          15/MAR/1995
!          DRASKO VASILJEVIC ECMWF          21/10/1999

!*    PURPOSE
!     -------

!        GET ALL DATUM EVENTS

!**   INTERFACE
!     ---------

!     ***CALL NGEDEVE2(KDEVEN2,KEVENT,KLIST)
!     WHERE KDEVEN2 = DATUM EVENT 2
!           KEVENT  = NUMBER OF DATUM EVENTS FOUND
!           KLIST   = BINARY LIST OF DATUM EVENTS

!        NGEDEVE2 IS CALLED BY SUBROUTINES

!*    METHOD
!     ------

!*    EXTERNALS
!     ---------

!**   MODIFICATIONS
!     -------------

!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE PARCMA   , ONLY : JPMXDE2

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KDEVEN2 
INTEGER(KIND=JPIM),INTENT(OUT)   :: KEVENT 
INTEGER(KIND=JPIM),INTENT(OUT)   :: KLIST(JPMXDE2) 
INTEGER(KIND=JPIM) :: J, IEVE
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "fcobs.h"

!*
!     ------------------------------------------------------------------

!        1.       INITIALIZE
!                 ----------

!*          1.1   INITIALIZE EVENT LIST

IF (LHOOK) CALL DR_HOOK('NGEDEVE2',0,ZHOOK_HANDLE)
KEVENT = 0
KLIST(:) = 0

!*
!     ------------------------------------------------------------------

!        2.       GET DATUM EVENTS 2
!                 ------------------

!IDEVEN2 = ROBODY(KOBS,MDBDEV2)
IF(KDEVEN2 == 0) GOTO 3
DO J = 1, JPMXDE2
  IEVE = IBITS(KDEVEN2, J-1, 1)
  IF(IEVE == 1) THEN
    KEVENT   = KEVENT +1
    KLIST(J) = 1
  ENDIF
ENDDO

!*
!     ------------------------------------------------------------------

!        3.       RETURN
!                 ------
3 CONTINUE
IF (LHOOK) CALL DR_HOOK('NGEDEVE2',1,ZHOOK_HANDLE)
END SUBROUTINE NGEDEVE2

