SUBROUTINE NGEREVE(KCMREV1,KEVENT,KLIST)

!**** SUBROUTINE NGEREVE - GET ALL REPORT EVENTS

!          HEIKKI JARVINEN   ECMWF          15/MAR/1995
!          DRASKO VASILJEVIC ECMWF          21/10/1999

!*    PURPOSE
!     -------

!        GET ALL REPORT EVENTS

!**   INTERFACE
!     ---------

!     ***CALL NGEREVE(KCMREV1,KEVENT,KLIST)
!     WHERE KCMREV1 = REPORT EVENT 1
!           KEVENT  = NUMBER OF REPORT EVENTS FOUND
!           KLIST   = BINARY LIST OF REPORT EVENTS

!        NGEREVE IS CALLED BY SUBROUTINES

!*    METHOD
!     ------

!*    EXTERNALS
!     ---------

!**   MODIFICATIONS
!     -------------
!        H. Jarvinen 12 Dec 1996 : Renew the subroutine call
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KCMREV1 
INTEGER(KIND=JPIM),INTENT(OUT)   :: KEVENT 
INTEGER(KIND=JPIM),INTENT(OUT)   :: KLIST(32) 
INTEGER(KIND=JPIM) :: IEVE, J
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "fcobs.h"

!*
!     ------------------------------------------------------------------

!        1.       INITIALIZE
!                 ----------

IF (LHOOK) CALL DR_HOOK('NGEREVE',0,ZHOOK_HANDLE)
KEVENT = 0
KLIST(:) = 0
!*
!     ------------------------------------------------------------------

!        2.       GET REPORT EVENTS
!                 -----------------

!ICMREV1 = ROBHDR(KOBS,MDBREV1)
IF(KCMREV1 == 0) GOTO 3
DO J = 1, 32
  IEVE = IBITS(KCMREV1, J-1, 1)
  IF(IEVE == 1) THEN
    KEVENT   = KEVENT +1
    KLIST(J) = 1
  ENDIF
ENDDO
!*
!     ------------------------------------------------------------------

!        3.       RETURN
!                 ------
3 CONTINUE
IF (LHOOK) CALL DR_HOOK('NGEREVE',1,ZHOOK_HANDLE)
END SUBROUTINE NGEREVE
