SUBROUTINE NGEREVE2(KREVEN2,KOBTYP,KCDTYP,KREPEV2)

!**** SUBROUTINE NGEREVE2 - GET ALL DATUM EVENTS FROM EVENT WORD NUMBER 2

!          HEIKKI JARVINEN   ECMWF          15/MAR/1995
!          DRASKO VASILJEVIC ECMWF          21/10/1999

!*    PURPOSE
!     -------

!        GET ALL DATUM EVENTS

!**   INTERFACE
!     ---------

!     ***CALL NGEREVE2(KREVEN2,KOBTYP,KCDTYP,KREPEV2)
!     WHERE KREVEN2 = REPORT EVENT 2
!           KOBTYP  = OBSERVATION TYPE
!           KCDTYP  = OBSERVATION CODETYPE
!           KREPEV2 = LIST OF REPORT EVENTS IN EVENT WORD 2

!        NGEREVE2 IS CALLED BY SUBROUTINES

!*    METHOD
!     ------

!*    EXTERNALS
!     ---------

!**   MODIFICATIONS
!     -------------

!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE PARCMA   , ONLY : JPMXRE2
USE YOMLUN   , ONLY : NULOUT
USE YOMNMEV  , ONLY : NMXREV2  ,NR2EVENT

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KREVEN2, KOBTYP, KCDTYP
INTEGER(KIND=JPIM),INTENT(OUT)   :: KREPEV2(JPMXRE2)
INTEGER(KIND=JPIM) :: ICDSQNO, IOTSQNO, JRE2
INTEGER(KIND=JPIM) :: IOBTYP , ICDTYP
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "cmoctmap.intfb.h"

#include "fcobs.h"

!*
!     ------------------------------------------------------------------

!        1.       INITIALIZE
!                 ----------

IF (LHOOK) CALL DR_HOOK('NGEREVE2',0,ZHOOK_HANDLE)
KREPEV2(:) = 0

!*
!     ------------------------------------------------------------------

!        2.       GET REPORT EVENTS FROM EVENT WORD 2
!                 -----------------------------------

!IOBTYP = ROBHDR(KOBS,MDBOTP)
IOBTYP = KOBTYP
!ICDTYP = ROBHDR(KOBS,MDB_CODETYPE_AT_HDR)
ICDTYP = KCDTYP
CALL CMOCTMAP('CODETOSQ',NULOUT,IOBTYP,ICDTYP,IOTSQNO,ICDSQNO)
!IREVEN2 = ROBHDR(KOBS,MDBREV2)
DO JRE2 = 1, NMXREV2
  CALL SRGEVENT('GET E',KREVEN2,NR2EVENT(JRE2,IOTSQNO),KREPEV2(JRE2))
ENDDO
!*
!     ------------------------------------------------------------------

!        3.       RETURN
!                 ------
IF (LHOOK) CALL DR_HOOK('NGEREVE2',1,ZHOOK_HANDLE)
END SUBROUTINE NGEREVE2
