SUBROUTINE OPM_OBSCOR(KSIZE,PX,PY)

!**** *OPM*  - Matrix M in Lanczos code (A*x=l*M*x)

!     Purpose.
!     --------
!           For input PX gives the output PY=M*PX

!**   Interface.
!     ----------
!        *CALL* *OPM(,KSIZE,PX,PY)

!        Explicit arguments :
!        --------------------
!        PX   : input vector (do NOT modify inside the subroutine)
!        PY   : output vector

!     Implicit arguments : none
!     --------------------

!     Method.
!     -------
!        See documentation

!     Externals.
!     ----------

!     None   

!     Reference.
!     ----------
!        Lanczos code

!     Author.
!     -------
!        G. Radnoti ECMWF
!     Modifications.
!     --------------
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KSIZE
REAL(KIND=JPRB), INTENT(IN) :: PX(KSIZE) 
REAL(KIND=JPRB), INTENT(OUT) :: PY(KSIZE)

PY(1:KSIZE)=PX(1:KSIZE)
!     ------------------------------------------------------------------
END SUBROUTINE OPM_OBSCOR
!     ------------------------------------------------------------------

