SUBROUTINE P_4_SORT(KOBS,POBPPP)

!**** SUBROUTINE P_4_SORT - GET PRESSURE FOR SORTING

!          DRASKO VASILJEVIC ECMWF          16/12/2002

!*    PURPOSE
!     -------

!        PRESORT OBS FOR THINNING/REDUNDANCY

!**   INTERFACE
!     ---------

!     ***CALL*P_4_SORT(KOBS,POBPPP)
!     WHERE KOBS       = OBS POINTER
!           POBPPP     = OBSERVED PRESSURE

!        P_4_SORT IS CALLED BY

!*    METHOD
!     ------

!*    EXTERNALS
!     ---------

!**   MODIFICATIONS
!     -------------

!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMCMBDY , ONLY : NCMDACBP ,NCMDACOC ,NCMDPABP ,NCMDPAOC ,&
 & NCMDREBP ,NCMDREOC ,NCMDBLBP ,NCMDBLOC  
USE YOMDB
USE YOMANCS  , ONLY :      RMDI
USE YOMOBS
USE YOMVNMB  , ONLY : NVNUMB

IMPLICIT NONE

!     DUMMY VARIABLES
INTEGER(KIND=JPIM),INTENT(IN)    :: KOBS 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: POBPPP 
!     LOCAL VARIABLES

LOGICAL :: LLACT, LLPAS, LLREJ, LLBLA

INTEGER(KIND=JPIM) ::  &
 & IVNM, IPASS, JLEV  
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "fcobs.h"

#include "openmp_obs.h"
!*
!     ------------------------------------------------------------------

!        0.       INITIALIZE
!                 ----------
!*
!           0.1   LOCAL VARIABLES

!     ------------------------------------------------------------------

!        2.       SORT OBS PER DATE, TIME, LAT AND LON

IF (LHOOK) CALL DR_HOOK('P_4_SORT',0,ZHOOK_HANDLE)
IVNM   = NVNUMB( 1)
IPASS  = 1
POBPPP = RMDI
210 CONTINUE
IF(IPASS > 2)  GO TO 3
IF(IPASS == 2) IVNM  = NVNUMB( 8)
LEV_LOOP: DO JLEV = MLNKH2B(KOBS),MLNKH2B(KOBS+1)-1
  IF(ROBODY(JLEV,MDBVNM) /= IVNM) CYCLE LEV_LOOP
  LLACT = IBITS(INT(ROBODY(JLEV,MDBDSTA)), NCMDACBP, NCMDACOC) == 1
  LLPAS = IBITS(INT(ROBODY(JLEV,MDBDSTA)), NCMDPABP, NCMDPAOC) == 1
  LLREJ = IBITS(INT(ROBODY(JLEV,MDBDSTA)), NCMDREBP, NCMDREOC) == 1
  LLBLA = IBITS(INT(ROBODY(JLEV,MDBDSTA)), NCMDBLBP, NCMDBLOC) == 1
  IF((LLPAS .OR. LLREJ .OR. LLBLA) .AND. .NOT.LLACT) CYCLE LEV_LOOP
  POBPPP = ROBODY(JLEV,MDBPPP)
  GO TO 3
ENDDO LEV_LOOP
IPASS = IPASS + 1
GO TO 210

!     ------------------------------------------------------------------

!        3.       RETURN
!                 ------
3 CONTINUE
IF (LHOOK) CALL DR_HOOK('P_4_SORT',1,ZHOOK_HANDLE)
END SUBROUTINE P_4_SORT
