SUBROUTINE SETCOM

!**** SUBROUTINE SETCOM - DEFINE GENERAL OBS. PROCESSING COMMON VARIABLES

!        D. VASILJEVIC   ECMWF     05/9/94

!     PURPOSE
!     -------

!        DEFINE GENERAL COMMON VARIABLES

!**   INTERFACE
!     ---------

!        CALL SETCOM

!        SETCOM IS CALLED FROM SUBROUTINE SUOBS

!**   EXTERNALS
!     ---------

!        ENDRUN   - ABORT
!        SETCOMCM - SET CMA SHARED COMMON VARIABLES
!        READNL   - NAMELIST READ
!        CCSETCM  - CROSS-CHECK CMA SHARED COMMON VARIABLES
!        SETCOMBU - SET BUFR SHARED COMMON VARIABLES
!        CCSETBU  - CROSS-CHECK BUFR SHARED COMMON VARIABLES

!**   METHOD
!     ------

!        GENERAL COMMON VARIABLES ARE DEFINED.

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMCMA   , ONLY : NMXTOCH  ,NMXATOCH ,NMXSSMCH ,NMXTRMCH
USE YOMLVLY  , ONLY : NMXSTLV  ,NMXLAYER
USE YOMLUN   , ONLY : NULOUT

IMPLICIT NONE

!*
!-----------------------------------------------------------------------

!        1.         CMA (ODB) GENERAL COMMON VARIABLES
!                   ----------------------------------

REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "ccsetod.intfb.h"
#include "setcomod.intfb.h"
IF (LHOOK) CALL DR_HOOK('SETCOM',0,ZHOOK_HANDLE)
1 CONTINUE

!*          1.1   SHARED VARIABLES

CALL SETCOMOD(NULOUT)

!*          1.2     TOVS/LEVEL-1C/GEOS CHANNELS

!*          1.2.1   MAX. NO. TOVS CHANNELS

NMXTOCH  =       27

!*          1.2.2   MAX. NO. OF TOVS MSU CHANNELS

!*          1.2.3   MAX. NO. OF TOVS SSU CHANNELS

!*          1.2.4   MAX. NO. LEVEL-1C/GEOS  CHANNELS

NMXATOCH =       20

!*          1.2.5   MAX. NO. OF LEVEL-1C/GEOS MSU CHANNELS

!*          1.2.6   MAX. NO. OF LEVEL-1C/GEOS SSU CHANNELS

!*          1.3     SSMI CHANNELS

NMXSSMCH =        7

!*          1.4     TRMM CHANNELS

NMXTRMCH =        9

!*          1.5     MAX. NO. OF STANDARD LEVELS/LAYERS

NMXSTLV  =      15
NMXLAYER =      14

!*          1.20    GET NAMELIST VALUES

!CALL READNL('NAMCMA')

!*          1.21    CROSS CHECK VALUES

CALL CCSETOD(NULOUT)
!*
!-----------------------------------------------------------------------

!        2.         BUFR GENERAL COMMON VARIABLES (NOT NEEDED)
!                   ------------------------------------------

!*
!-----------------------------------------------------------------------

!        3.         SIM. OBS. GENERAL COMMON VARIABLES (NOT NEEDED)
!                   ----------------------------------------------

!-----------------------------------------------------------------------

!        4.         OLD CMA OBS. GENERAL COMMON VARIABLES (NOT NEEDED)
!                   --------------------------------------------------

!*
!-----------------------------------------------------------------------

!        5.         OTHER GENERAL COMMON VARIABLES
!                   ------------------------------

!*
!-----------------------------------------------------------------------

!        6.         RETURN
!                   ------

IF (LHOOK) CALL DR_HOOK('SETCOM',1,ZHOOK_HANDLE)
END SUBROUTINE SETCOM
