SUBROUTINE SETCOMOD(KOUT)

!**** SUBROUTINE SETCOMOD - DEFINE SOME ODB GENERAL COMMON VARIABLES

!        D. VASILJEVIC   ECMWF     05/9/94

!     PURPOSE
!     -------

!        DEFINE SOME ODB GENERAL COMMON VARIABLES

!**   INTERFACE
!     ---------

!        CALL SETCOMOD(KOUT)
!     WHERE:
!           KOUT = OUTPUT UNIT

!        SETCOMOD IS CALLED FROM SUBROUTINES

!**   METHOD
!     ------

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMCMA   , ONLY : NMXNVO   ,&
 & NMXTOCH  ,NMXATOCH ,NMXSSMCH ,NMXMSUCH ,&
 & NMXSSUCH ,NMXAMSUCH,NMXASSUCH,NMXTRMCH  

!*
!-----------------------------------------------------------------------

!        1.       SHARED ODB GENERAL COMMON VARIABLES
!                 -----------------------------------

!*          1.1   MAX. NO. OF ADDITIONAL OBS. DEPARTURES

IMPLICIT NONE

INTEGER(KIND=JPIM)               :: KOUT ! Argument NOT used
REAL(KIND=JPRB) :: ZHOOK_HANDLE

!*          1.2   MAX. NO. OF UPDATES

!*          1.3   MAX. NO. OF LEVELS

IF (LHOOK) CALL DR_HOOK('SETCOMOD',0,ZHOOK_HANDLE)
NMXNVO  =      300

!*          1.4   MAX. NO. OF VARIABLES (JPMXVAR)

!*          1.4.1 MAX. NO. OF VARIABLES PER LEVEL

!*          1.5   MAX. NO. OF OBS. TYPES

!*          1.6   MAX. NO. OF OBS. CODE TYPES

!*          1.7   MAX. NO. TOVS/ATOVS(LEVEL 1C/GEOS)/SSMI/TRMM CHANNELS

!*          1.7.1   TOVS CHANNELS

!*          1.7.1.1 MAX. NO. TOVS CHANNELS

NMXTOCH =       27

!*          1.7.1.2 MAX. NO. OF MSU CHANNELS

NMXMSUCH=        4

!*          1.7.1.3 MAX. NO. OF SSU CHANNELS

NMXSSUCH=        3

!*          1.7.2   ATOVS (LEVEL 1C/GEOS) CHANNELS

!*          1.7.2.1 MAX. NO. TOVS CHANNELS

NMXATOCH =       27

!*          1.7.2.2 MAX. NO. OF MSU CHANNELS

NMXAMSUCH=        4

!*          1.7.2.3 MAX. NO. OF SSU CHANNELS

NMXASSUCH=        3

!*          1.7.3   SSMI CHANNELS

NMXSSMCH=        7

!*          1.7.4   TRMM CHANNELS

NMXTRMCH=        9

!*          1.8   MAX. LENGTH OF ODB REPORT BODY ENTRY

!*          1.8.1 MAX. LENGTH OF ODB FIXED PART OF A BODY ENTRY

!*
!-----------------------------------------------------------------------

!        2.       RETURN
!                 ------

IF (LHOOK) CALL DR_HOOK('SETCOMOD',1,ZHOOK_HANDLE)
END SUBROUTINE SETCOMOD
