SUBROUTINE SUFGER(KTSLOT)

!**** SUBROUTINE SUFGER - SETUP THE FIRST GUESS ERRORS INTO OBSERVATIONS

!          HEIKKI JARVINEN   ECMWF          15/MAR/1996
!          DRASKO VASILJEVIC ECMWF          01/NOV/1999

!*    METHOD
!     ------

!        THE FIRST GUESS ERRORS, AS PRODUCED BY OI OR BY THE CONJUGATE
!     GRADIENT METHOD INBEDDED INTO IFS, ARE READ IN AND INTERPOLATED
!     INTO OBSERVATION LOCATIONS.

!*    INTERFACE
!     ---------

!     ***CALL*SUFGER(KTSLOT)
!     WHERE KTSLOT = TIME SLOT

!*    EXTERNALS
!     ---------

!        GETDB  - GET DB
!        GEFGER  - FIRST GUESS ERRORS
!        PUTDB  - STORE DB

!        SUFGER IS CALLED BY SUBROUTINE SCREEN

!**   MODIFICATIONS
!     -------------

!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMLUN   , ONLY : NULOUT

IMPLICIT NONE

INTEGER(KIND=JPIM)               :: KTSLOT ! UNDETERMINED INTENT
INTEGER(KIND=JPIM) :: INFO(1), IRET

INTEGER(KIND=JPIM) :: ILEN

LOGICAL :: LLGEFGER

REAL(KIND=JPRB) :: ZINFO(1)
REAL(KIND=JPRB) :: ZHOOK_HANDLE

INTERFACE
#include "getdb.h"
#include "putdb.h"
END INTERFACE

#include "gefger.intfb.h"

!     ------------------------------------------------------------------

!*       1.       GET THE FIRST GUESS ERRORS
!                 --------------------------

!*          1.0   INFORM

IF (LHOOK) CALL DR_HOOK('SUFGER',0,ZHOOK_HANDLE)
WRITE(NULOUT,'('' *** SUFGER; FIRST GUESS ERRORS'')')
WRITE(NULOUT,'(''     ALL SETS'')')
LLGEFGER= .TRUE.

!*          1.1   INITIALIZE DB (LOCALL; ALL REPs)

IRET = 0
!CALL GETDB('SUFGER',1,IRET,INFO,0,ZINFO,0,&
! & -1, KTSLOT, -1, -1, -1, -1)  

!IF(IRET == 0) THEN
!  WRITE(NULOUT,'(''     NO REPORTS (ANY TYPE) AVAILABLE '')')
!ELSE
!  WRITE(NULOUT,'(''     REPORTS (ALL TYPES) FOUND: '',I10)') IRET
!ENDIF
!ILEN = IRET

!*          1.2   READ AND INTERPOLATE THE FIRST GUESS ERRORS

IF(LLGEFGER) THEN
  CALL GEFGER(KTSLOT)
ENDIF

!           1.3   PUT THE DB AWAY

!CALL PUTDB('SUFGER',1,IRET,INFO,0,ZINFO,0)

!*
!     ------------------------------------------------------------------

!        2.       RETURN
!                 ------

IF (LHOOK) CALL DR_HOOK('SUFGER',1,ZHOOK_HANDLE)
END SUBROUTINE SUFGER
