SUBROUTINE SUOBSC1

!**** *SUOBSC1*  - Sets up observations in configuration NCONF=1.

!     Purpose.
!     --------
!           Sets up observations in configuration NCONF=1

!**   Interface.
!     ----------
!        *CALL* *SUOBSC1 (from CNT1)

!        Explicit arguments :
!        --------------------
!        None

!        Implicit arguments :
!        --------------------
!        None

!     Method.
!     -------
!        See documentation

!     Externals.   SUOBS  - initialize obs processing
!     ----------

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     Author.
!     -------
!        Jean-Noel Thepaut  *ECMWF*

!     Modifications.
!     --------------
!        Original : 92-11-26
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      01-Dec-2003 CY28R1 Cleaning 
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCT0   , ONLY : LOBS

IMPLICIT NONE


REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "suobs.intfb.h"

!     ------------------------------------------------------------------

!*          1.   INITIALISE THE PROCESSING FOR THE OBSERVATIONS

IF (LHOOK) CALL DR_HOOK('SUOBSC1',0,ZHOOK_HANDLE)
IF(LOBS) CALL SUOBS

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SUOBSC1',1,ZHOOK_HANDLE)
END SUBROUTINE SUOBSC1
