SUBROUTINE UPDOBS(KSLOT)

!**** SUBROUTINE UPDOBS - UPDATE OBS. (CMA) DDR

!        D. VASILJEVIC   ECMWF     20/01/1992

!     PURPOSE
!     -------

!        UPDATE CMA DDRS

!**   INTERFACE
!     ---------

!        CALL UPDOBS(KSLOT)
!     WHERE KSLOT = SLOT NUMBER

!        UPDOBS IS CALLED FROM SUBROUTINE STEPO

!     METHOD
!     ------

!     EXTERNALS
!     ---------

!**   MODIFICATIONS
!     -------------

!        Heikki Jarvinen 95-09-20 : New CMA- file format
!        MATS HAMRUD     95-09-20 : New CMA- file format

!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMCT0   , ONLY : CNMEXP   ,NCONF    ,NSTOP    ,LOBSC1   ,LOBSREF
USE YOMVAR   , ONLY : NSIM4D   ,NDIAG    ,NSIM4DL  ,NUPTRA
USE YOMOBA   , ONLY : MOBDD1   ,MOBDD2   ,COBDD1
USE YOMCMDDR , ONLY : NCD1NUP  ,NCD1CON  ,NCD1NST  ,NCD1EN1  ,&
 & NCD1EN16 ,NCD2NS  
USE YOMANCS  , ONLY : NMDI

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KSLOT 
INTEGER(KIND=JPIM) :: ISLOT
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "fcobs.h"
!     ------------------------------------------------------------------

!        1.       FIRST DDR.
!                 ----------

IF (LHOOK) CALL DR_HOOK('UPDOBS',0,ZHOOK_HANDLE)
ISLOT=KSLOT
!*          1.1  NO. OF UPDATES 

MOBDD1(NCD1NUP) = NUPTRA

!*          1.2  EXP. NAME

COBDD1(NCD1EN1:NCD1EN16) = CNMEXP

!*          1.3  IFS CONFIGURATION

MOBDD1(NCD1CON) = NCONF

!*          1.4  NSTOP

MOBDD1(NCD1NST) = NSTOP

!     ------------------------------------------------------------------

!        2.       SECOND DDR.
!                 -----------

!*          2.1  NO OF SIMULATIONS PERFORMED

IF(MOBDD2(NCD2NS) /= NMDI)                  THEN
  IF(NDIAG /= 0.AND..NOT.LOBSC1.AND..NOT.LOBSREF) THEN
    IF(NSIM4D /= NSIM4DL)                         THEN
      MOBDD2  (NCD2NS) = NSIM4D + 1
    ELSE
      MOBDD2  (NCD2NS) = MOBDD2(NCD2NS) + 1
    ENDIF
  ENDIF
ENDIF

IF (LHOOK) CALL DR_HOOK('UPDOBS',1,ZHOOK_HANDLE)
END SUBROUTINE UPDOBS

