SUBROUTINE SUGCO0

!**** *SUGCO0 * - ROUTINE TO RESET TO 0 THE COUPLED FIELDS

!     PURPOSE.
!     --------
!        RESET YOMGCO ARRAY TO 0

!**   INTERFACE.
!     ----------
!        *CALL* *SUGCO0*

!     EXPLICIT ARGUMENTS :  NONE
!     --------------------

!     IMPLICIT ARGUMENTS :
!     --------------------
!        COMMON  YOMGCO

!     METHOD.
!     -------
!     EXTERNALS.
!     ----------

!     REFERENCE.
!     ----------
!        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE
!     "IN CORE MODEL"

!     AUTHOR.
!     -------
!        C. DREVETON D'APRES SUGFU0 (25.05.92)
!        Modified 94-07-08 by M. Deque (additional diagnostics for sea-ice)
!        Modified 95-04-20 by M. Deque (additional diagnostics)
!        Modified 96-09-18 by P. Marquet : Unsigned modifs (15R2) of G.
!                                Mosdzynski : (JLON,JGL) -> (JL) loops
!        Modified 97-03-20 by M. Deque (fix of the above modifs)
!        Modified 97-04-29 by J.Ph. Piedelievre (Distributed Memory Version)
!        Modified 00-02-03 by S. Tyteca (new diagnostics)
!        Modified 03-04-22 by P. Marquet (Cloud Forcing diag. in CUMCODM)

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMGCO   , ONLY : STRSU    ,STRSV    ,FCHAS    ,FRSOS    ,&
 & FHUMS    ,RUIST    ,FCHLL    ,FCHLN    ,FCHSS    ,&
 & FHUML    ,FHUMN    ,FRLDS    ,QWPRO    ,TMAX2    ,&
 & TMIN2    ,HSNOW    ,TSUR2    ,TSTS     ,TSFL     ,&
 & XPUQ     ,XPVQ     ,FCRFTH   ,FCRFSO

IMPLICIT NONE

!      ----------------------------------------------------------------

!*       1.    SET YOMGCO TO 0.
!              ---------------

REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SUGCO0',0,ZHOOK_HANDLE)
FCHAS=0._JPRB
FRSOS=0._JPRB
FHUMS=0._JPRB
FCHLL=0._JPRB
FCHLN=0._JPRB
FCHSS=0._JPRB

STRSU=0._JPRB
STRSV=0._JPRB
RUIST=0._JPRB
FHUML=0._JPRB
FHUMN=0._JPRB
FRLDS=0._JPRB
QWPRO=0._JPRB
TMAX2=-1000._JPRB
TMIN2=1000._JPRB
HSNOW=0._JPRB
TSUR2=0._JPRB
TSTS =0._JPRB
TSFL =0._JPRB
XPUQ =0._JPRB
XPVQ =0._JPRB
FCRFTH=0._JPRB
FCRFSO=0._JPRB

IF (LHOOK) CALL DR_HOOK('SUGCO0',1,ZHOOK_HANDLE)
END SUBROUTINE SUGCO0
