! SUBROUTINE CONV2D_2_1D & SUBROUTINE CONV1D_2_2D
! Purpose :
! -------
! Conversions (2D->1D & 1D->2D) for nn weights

! Interface :
! ---------
! PWIH : Weights between Input & Hidden layers 
! PWHO : Weights between Hidden & Output layers
! PW   : Global 1D Weights

! Externals :
! ---------

! Method :
! ------

! Reference :
! ---------

! Author :
! ------
! 17-March-2004  Thomas Auligne         *METEO-FRANCE*

! Modifications :
! -------------

! ---------------------------------------------------------------------------------------------

SUBROUTINE CONV2D_2_1D(PWIH,PWHO,PW)
USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMNNE, ONLY : NINPPB, NHIDDEN, NDIM
IMPLICIT NONE
REAL(KIND=JPRB)   ,INTENT(IN)    :: PWIH(NINPPB,NHIDDEN) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PWHO(NHIDDEN+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PW(NDIM) 
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('CONV2D_2_1D',0,ZHOOK_HANDLE)
PW(1:NINPPB*NHIDDEN)=RESHAPE(PWIH,(/NINPPB*NHIDDEN/))
PW(NINPPB*NHIDDEN+1:NDIM)=PWHO
IF (LHOOK) CALL DR_HOOK('CONV2D_2_1D',1,ZHOOK_HANDLE)
END SUBROUTINE CONV2D_2_1D

!xxxxxxxxxxxxxxxxxxxxxxxxx
SUBROUTINE CONV1D_2_2D(PW,PWIH,PWHO)
USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMNNE, ONLY : NINPPB, NHIDDEN, NDIM
IMPLICIT NONE
REAL(KIND=JPRB), INTENT(IN) :: PW(NDIM)
REAL(KIND=JPRB),INTENT(OUT) :: PWIH(NINPPB,NHIDDEN),PWHO(NHIDDEN+1)
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('CONV1D_2_2D',0,ZHOOK_HANDLE)
PWIH=RESHAPE(PW(1:NINPPB*NHIDDEN),(/NINPPB,NHIDDEN/))
PWHO=PW(NINPPB*NHIDDEN+1:(NINPPB+1)*NHIDDEN)
IF (LHOOK) CALL DR_HOOK('CONV1D_2_2D',1,ZHOOK_HANDLE)
END SUBROUTINE CONV1D_2_2D
