FUNCTION fcintgtrap(PABSX,PORDY,KNUM)

!    PURPOSE
!    -------
!     The purpose of this funtion is to compute an integration of
!     a tabulated function by a trapezoidal rule (unequally spaced)

!**  INTERFACE
!     ---------

!  fcintgtrap(PABSX,PORDY,KNUM) where PABSX,PORDY,KNUM are arguments

!**  METHOD
!    ------

!    EXTERNAL
!    --------
!      NONE

!    IMPLICIT ARGUMENTS
!    ------------------
!      None

!    REFERENCE
!    ---------
      

!    AUTHOR
!    ------
!      Eric Wattrelot * CNRM/GMAP/OBS *

!    MODIFICATIONS
!    -------------
!      Original     28/09/06
! ----------------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM , JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

! ----------------------------------------------------------------------------

IMPLICIT NONE

INTEGER(KIND=JPIM), INTENT(IN)       :: KNUM 
REAL(KIND=JPRB), INTENT(IN)          :: PABSX(KNUM), PORDY(KNUM) 

! ----------------------------------------------------------------------------

INTEGER(KIND=JPIM)        :: JJ ! Loop index
REAL(KIND=JPRB)           :: fcintgtrap
REAL(KIND=JPRB) :: ZHOOK_HANDLE

! ----------------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('FCINTGTRAP',0,ZHOOK_HANDLE)
! ----------------------------------------------------------------------------

fcintgtrap = 0.0_JPRB
DO JJ = 1 , KNUM-1
   fcintgtrap = fcintgtrap + (PABSX(JJ+1)-PABSX(JJ))*(PORDY(JJ+1)+PORDY(JJ))
ENDDO

fcintgtrap = 0.5_JPRB * fcintgtrap

! ----------------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('FCINTGTRAP',1,ZHOOK_HANDLE)
END FUNCTION  fcintgtrap

