SUBROUTINE COMMFCE2(PEGRID,KNPTE,KNFLDS)

!**** *COMMFCE2* Communicates Forecast error grid parameters - part 2

!     Purpose.
!     --------

!**   Interface.
!     ----------
!        *CALL* *COMMFCE2(..) 

!        Explicit arguments : PEGRID  - data
!        -------------------- KNPTE, KNFLDS  - dimensions

!        Implicit arguments :
!        --------------------

!     Method.
!     -------
!        See documentation

!     Externals.
!     ----------

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     Author.
!     -------
!        L. Isaksen  *ECMWF*

!     Modifications.
!     --------------
!        Original: 96-05-05 
!        Modified: 00-09-01 by D.Dent : MPE to MPL conversion
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMCT0   , ONLY : NPROC
USE YOMTAG   , ONLY : MTAGFCE
USE MPL_MODULE , ONLY : MPL_BROADCAST

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KNPTE 
INTEGER(KIND=JPIM),INTENT(IN)    :: KNFLDS 
REAL(KIND=JPRB),INTENT(INOUT)    :: PEGRID(KNPTE*KNFLDS)
INTEGER(KIND=JPIM) ::  IOMASTER, ITAG1
REAL(KIND=JPRB) :: ZHOOK_HANDLE


IF (LHOOK) CALL DR_HOOK('COMMFCE2',0,ZHOOK_HANDLE)

IOMASTER=1
ITAG1=MTAGFCE+2

IF (NPROC > 1) THEN
  CALL GSTATS_BARRIER(776)
  CALL GSTATS(665,0)
  CALL MPL_BROADCAST(PEGRID,KROOT=IOMASTER,KTAG=ITAG1, &
   & CDSTRING='COMMFCE2:')  
  CALL GSTATS(665,1)
  CALL GSTATS_BARRIER2(776)
ENDIF

IF (LHOOK) CALL DR_HOOK('COMMFCE2',1,ZHOOK_HANDLE)
END SUBROUTINE COMMFCE2
