SUBROUTINE PACKMSG(CD_CNOMA,KNOMA,PVALCO,KDIM,KLONGD,PMESS,K_MSGLON)

!**** *PACKMSG*  - 

!     PURPOSE.
!     --------
!     Collects data in array PMESS.

!**   INTERFACE.
!     ----------
!       *CALL* *PACKMSG*

!        EXPLICIT ARGUMENTS
!        --------------------
!        Input:
!         KDIM                        : dimension of array PVALCO.
!         K_MSGLON                    : dimension of array PMESS.
!         KLONGD,CD_CNOMA,KNOMA,PVALCO: data to be collected in PMESS.
!        Output:
!         PMESS

!        IMPLICIT ARGUMENTS
!        --------------------

!     METHOD.
!     -------
!        SEE DOCUMENTATION

!     EXTERNALS.
!     ----------

!     AUTHOR.
!     -------
!        ???

!     MODIFICATIONS.
!     --------------
!     K. Yessad (Dec 2008): add comments + cleanings
!-----------------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

!-----------------------------------------------------------------------------

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KDIM 
INTEGER(KIND=JPIM),INTENT(IN)    :: KLONGD 
INTEGER(KIND=JPIM),INTENT(IN)    :: K_MSGLON 
CHARACTER(LEN=16) ,INTENT(IN)    :: CD_CNOMA 
INTEGER(KIND=JPIM),INTENT(IN)    :: KNOMA 
REAL(KIND=JPRB),   INTENT(IN)    :: PVALCO(KDIM) 
REAL(KIND=JPRB),   INTENT(OUT)   :: PMESS(K_MSGLON) 

!-----------------------------------------------------------------------------

INTEGER(KIND=JPIM) :: ISHFT, J
INTEGER(KIND=JPIM) :: ILEN
REAL(KIND=JPRB) :: ZHOOK_HANDLE

!-----------------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('PACKMSG',0,ZHOOK_HANDLE)
!-----------------------------------------------------------------------------

PMESS(1) = KNOMA
PMESS(2) = KLONGD
PMESS(3) = K_MSGLON

DO J=1,KNOMA
  PMESS(J+3)=ICHAR (CD_CNOMA(J:J))
ENDDO
ISHFT=KNOMA+3
ILEN=  KLONGD
PMESS(ISHFT+1:ISHFT+ILEN)=PVALCO(1:KLONGD)

!-----------------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('PACKMSG',1,ZHOOK_HANDLE)
END SUBROUTINE PACKMSG
