SUBROUTINE UNPKMSG(CD_CNOMA,KNOMA,PVALCO,KDIM,KLONGD,PMESS,K_MSGMAX)

!**** *UNPKMSG*  - 

!     PURPOSE.
!     --------
!     Reverse task of PACKMSG.

!**   INTERFACE.
!     ----------
!       *CALL* *UNPKMSG*

!        EXPLICIT ARGUMENTS
!        --------------------
!        Input:
!         KDIM                        : dimension of array PVALCO.
!         K_MSGLON                    : dimension of array PMESS.
!         PMESS                       : data to be read.
!        Output:
!         KLONGD,CD_CNOMA,KNOMA,PVALCO: data to be recovered from PMESS.

!        IMPLICIT ARGUMENTS
!        --------------------

!     METHOD.
!     -------
!        SEE DOCUMENTATION

!     EXTERNALS.
!     ----------

!     AUTHOR.
!     -------
!        ???

!     MODIFICATIONS.
!     --------------
!     K. Yessad (Dec 2008): add comments + cleanings
!-----------------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

!-----------------------------------------------------------------------------

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KDIM
INTEGER(KIND=JPIM),INTENT(INOUT) :: KLONGD 
INTEGER(KIND=JPIM),INTENT(IN)    :: K_MSGMAX 
CHARACTER(LEN=16) ,INTENT(OUT)   :: CD_CNOMA 
INTEGER(KIND=JPIM),INTENT(OUT)   :: KNOMA 
REAL(KIND=JPRB),   INTENT(OUT)   :: PVALCO(KDIM)
REAL(KIND=JPRB),   INTENT(IN)    :: PMESS(K_MSGMAX) 

!-----------------------------------------------------------------------------

INTEGER(KIND=JPIM) :: ISHFT, J
INTEGER(KIND=JPIM) :: ILEN
REAL(KIND=JPRB) :: ZHOOK_HANDLE

!-----------------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('UNPKMSG',0,ZHOOK_HANDLE)
!-----------------------------------------------------------------------------

KNOMA = PMESS(1)
KLONGD = PMESS(2)

DO J=1,KNOMA
  CD_CNOMA(J:J)=CHAR(INT(PMESS(J+3)))
ENDDO
ISHFT=KNOMA+3
ILEN=  KLONGD
PVALCO(1:KLONGD)=PMESS(ISHFT+1:ISHFT+ILEN)

!-----------------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('UNPKMSG',1,ZHOOK_HANDLE)
END SUBROUTINE UNPKMSG
