SUBROUTINE WHICHPROC(KYPROC)

!**** ** WHICHPROC - 

!     Purpose.
!     --------
!        To send back proc number

!**   Interface.
!     ----------
!        *CALL* *WHICHPROC*

!        Explicit arguments :
!        --------------------

!            KYPROC  :my proc number (usefull for the externalised
!                     surface to know if I am a writting proc!)

!        Implicit arguments :
!        --------------------

!     Method.
!     -------
!        See documentation

!     Externals.
!     ----------

!     Reference.
!     ----------

!     Author.
!     -------
!         S.Malardel *METEO-FRANCE*

!     Modifications.
!     --------------
!        ORIGINAL : 29-04-04 from WRGP2FA
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMMP    , ONLY : MYPROC

!     ------------------------------------------------------------------

IMPLICIT NONE
INTEGER(KIND=JPIM),INTENT(OUT)   :: KYPROC 

!     ------------------------------------------------------------------

REAL(KIND=JPRB) :: ZHOOK_HANDLE

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('WHICHPROC',0,ZHOOK_HANDLE)

!     ------------------------------------------------------------------

!     1.    PROC NUMBER TO SEND TO THE SURFACE

KYPROC=MYPROC

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('WHICHPROC',1,ZHOOK_HANDLE)
END SUBROUTINE WHICHPROC
