!OPTIONS XOPT(NOEVAL)
SUBROUTINE APL2PHY ( KIDIA , KFDIA  , KLON   ,&
 & KTDIA  , KLEV   , KPOSI  , KGL1   , KGL2   , KVCLIA ,&
 & KVCLIG , KVCLIS , KVCLIV , KNEBH  , KSTART , KSTEP  ,&
 & KSGST  , KCSS   , KWORK  ,&
 !---------------------------------------------------------------------
 ! - SPECIFIC INPUTS .
 & PLAND  , PTSOC  ,&
 !---------------------------------------------------------------------
 ! - APLPAR INPUTS
 & PAPHI  , PAPRS  , PAPHIF , PAPRSF , PALPH  , PARG   , PD2    ,&
 & PDELP  , PIVEG  , PLAI   , PLNPR  , PRDELP , PRSMIN , PSAB   ,&
 & PGZ0H  , PAESEA , PAELAN , PAEURB , PAEDES , PRCORI ,&
 & PGCHSS , PGEVAP , PGICFR , PGIRUP , PGSOUP , PGTAUX , PGTAUY ,&
 & PU     , PV     , PT     , PQ     , PQI    , PQL    , PO3    ,&
 & PCP    , PCVGQ  , PR     , PKOZO  , PSGST  , PNEBH  ,&
 & PSNS   , PALBNS , PRHONS ,&
 & PTP    , PTS    , PWL    , PWP    , PWPI   , PWS    , PWSI   ,&
 & PHV    ,&
 & PTC    ,&
 & PWC    , PVERVEL, PEMTD  , PEMTU  , PTRSO  , PCLON  , PSLON  ,&
 & PALBF  , PALBSF , PEMISF , PGETRL , PLSM   , PVEG0  ,&
 & PGZ0F  , PGZ0RLF, PVRLAN ,&
 & PVRLDI , PMU0   , PMU0LU , PMU0M  , PGEMU  , PWORK  , PGM    ,&
 & POMPAC , PAC    , PCOR   , PMMU0  , PDHSF  ,&
 & PRAB3C , PRAB3N , PRAB4C , PRAB4N , PRAB6C , PRAB6N ,&
 & PRAT1C , PRAT1N , PRAT2C , PRAT2N , PRAT3C , PRAT3N ,&
 & PRAT4C , PRAT4N , PRAT5C , PRAT5N,&
 !---------------------------------------------------------------------
 ! - APLPAR OUTPUTS
 & PDIFCQ , PDIFCQN, PDIFCQL, PDIFCS , PDIFTQ , PDIFTQN, PDIFTQL,&
 & PDIFTS , PFCCQL , PFCCQN , PFCSQL , PFCSQN , PFCQNG , PFCQNNG,&
 & PFCQLNG, PFPLCL , PFPLCN , PFPLSL , PFPLSN , PFRSO  , PFRSOC ,&
 & PFRTH  , PFRTHC , PSTRCU , PSTRCV , PSTRDU , PSTRDV , PSTRTU ,&
 & PSTRTV , PSTRMU , PSTRMV , PFRMH  , PFCHOZ , PCPS   , PLHS   ,&
 & PRS    , PLH    , PLSCPE , PNEB   , PQICE  , PQLI   , PQSAT  ,&
 & PQW    , PRH    , PTW    , PALB   , PCD    , PCDN   , PCH    ,&
 & PC1    , PC2    , PCT    , PEMIS  , PFCHSP , PFCLL  , PFCLN  ,&
 & PFCS   , PFEVI  , PFEVL  , PFEVN  , PFEVV  , PFTR   , PFLWSP ,&
 & PFONTE , PFGEL  , PFGELS ,&
 & PFRSODS, PFRSOPS, PFRSOPT, PFRSOLU, PFRTHDS, PGZ0   , PNEIJ  , PVEG   ,&
 & PQS    ,&
 & PQSATS , PRUISL , PRUISP , PRUISS , PUCLS  , PVCLS  , PTCLS  ,&
 & PQCLS  , PRHCLS , PCLCT  , PCLCH  , PCLCM  , PCLCL  , PCLCC  ,&
 !---------------------------------------------------------------------
 ! - OUTPUTS (SEA) FOR COUPLING
 & P2FPLCL ,P2FPLCN ,P2FPLSL ,P2FPLSN ,&
 & P2FRSO  ,P2FRTH  ,&
 & P2STRDU ,P2STRDV ,P2STRTU ,P2STRTV ,&
 & P2FCLL  ,P2FCLN  ,P2FCS   ,P2FEVL  ,P2FEVN  ,&
 & P2FRTHDS,&
 & P2RUISP ,P2RUISS ,&
 & P2TCLS  ,&
 !---------------------------------------------------------------------
 !   OUTPUTS (LAND SURFACE VARIABLES)
 & P1FPLCL ,P1FPLCN ,P1FPLSL ,P1FPLSN ,P1FRSO  ,P1FRTH  ,&
 & P1C1    ,P1C2    ,P1CT    ,P1FCHSP ,P1FCLL  ,P1FCLN  ,P1FCS   ,&
 & P1FEVI  ,P1FEVL  ,P1FEVN  ,P1FEVV  ,P1FTR   ,P1FLWSP ,P1FONTE ,&
 & P1FGEL  ,&
 & P1FGELS ,P1VEG   ,&
 & P1RUISL ,P1RUISP ,P1RUISS ,&
 ! - LOCK ARGUMENTS .
 & CDLOCK)  

!**** *APL2PHY *

!    Sujet.
!    ------

!    - PREPARE LES ENTREES & SORTIES  D'APLPAR POUR FAIRE DEUX CALCULS DE LA
!          PHYSIQUE SUR LES POINTS TERRE/OCEAN.
!    - PREPARE IPUTS & OUTPUTS OF APLPAR TO CALCULATE TWICE THE PHYSICS ON
!          EARTH/OCEAN POINTS.

!**  Interface.
!    ----------
!      *CALL* *APL2PHY*

!-----------------------------------------------------------------------

! -   ARGUMENTS D'ENTREE ENTIERS
! -   INTEGER INPUT ARGUMENTS.
!     --------------------------

! - NOM DES PARAMETRES DE DIMENSIONNEMENT DE LA PHYSIQUE.
! - DIMENSIONS.

! KIDIA, KFDIA : BORNES BOUCLES HORIZONTALES   (IST,IEND DANS CPG).
! KIDIA, KFDIA : START/END OF HORIZONTAL LOOP  (IST,IEND IN *CPG*).
! KLON : DIMENSION HORIZONTALE                 (NPROMA DANS CPG).
! KLON : HORIZONTAL DIMENSION                  (NPROMA IN *CPG*).
! KLON: IDEM BUT FOR ARRAYS USED SOLELY BY DMN PHYSICS
! KTDIA : DEBUT BOUCLE VERTICALE DANS LA PHYSIQUE.
! KTDIA : START OF THE VERTICAL LOOP IN THE PHYSICS (IF SOME LEVELS ARE
!                     SKIPPED AT THE TOP OF THE MODEL).
! KLEV : FIN BOUCLE VERTICE ET DIMENSION VERTICALE (NFLEVG DANS CPG).
! KLEV : END OF VERTICAL LOOP AND VERTICAL DIMENSION(NFLEVG IN *CPG*).
! KGL1, KGL2 : BORNES BANDES LATITUDES CONCATENEES DANS BOUCLE (1,KLON)
! KGL1, KGL2 : START/END CONCATENATED LATITUDES IN VECTOR OF KLON LENGTH
! KVCLIA     : NOMBRE DE CHAMPS POUR LES AEROSOLS (NVCLIA DANS CPG).
! KVCLIA     : NUMBER OF FIELDS FOR AEROSOLS (NVCLIA IN CPG).
! KVCLIS     : NOMBRE DE CHAMPS POUR LA PHOTO-CHIMIE DE L'OZONE.
!                     (NVCLIS DANS CPG).
! KVCLIS     : NUMBER OF FIELDS FOR OZONE PHOTO-CHEMISTRY.
!                     (NVCLIS IN CPG).
! KVCLIV     : NOMBRE DE CHAMPS POUR LA VEGETATION (NVCLIV DANS CPG).
! KVCLIV     : NUMBER OF FIELDS FOR VEGETATION (NVCLIV IN CPG).
! KNEBH      : NOMBRE DE CHAMPS (1D) DANS PNEBH (NVCLIN DANS CPG).
! KNEBH      : NUMBER OF FIELDS (1D) IN   PNEBH (NVCLIN IN   CPG).
! KSGST      : NOMBRE DE TEMPERATURES ET DE FLUX DE SURFACE SOUS-MAILLE
!                     (NTSSG DANS CPG)
! KSGST      : NUMBER OF SUBGRID SURFACE TEMPERATURES AND FLUXES
!                     (NTSSG IN *CPG*)
! KCSS       : NBRE DE NIVEAUX DANS LE SOL PROFOND
! KCSS       : NBR OF VERTICAL LAYERS IN THE DEEP SOIL

!-----------------------------------------------------------------------

! -   ARGUMENTS D'ENTREE SPECIFIQUES
! -   SPECIFIC INPUT ARGUMENTS.
!     ------------------------------

! PLAND      : FRACTION OF LAND
! PTSOC      : SEA SURFACE TEMPERATURE

!-----------------------------------------------------------------------

! -   ARGUMENTS D'ENTREE D'APLPAR
! -   APLPAR  INPUT ARGUMENTS.
!     ---------------------------

! - NOM DES VARIABLES DE LA PHYSIQUE (PAR ORDRE ALPHABETIQUE DANS CHAQUE
!   CATEGORIE).

! - 2D (0:KLEV) .

! PAPHI      : GEOPOTENTIEL AUX DEMI-NIVEAUX.
! PAPHI      : GEOPOTENTIAL ON HALF-LEVELS.
! PAPRS      : PRESSION AUX DEMI-NIVEAUX.
! PAPRS      : PRESSURE ON HALF-LEVELS.

! - 2D (1:KLEV) .

! PAPHIF     : GEOPOTENTIEL AUX NIVEAUX DES COUCHES.
! PAPHIF     : GEOPOTENTIAL ON FULL LEVELS.
! PAPRSF     : PRESSION AUX NIVEAUX DES COUCHES.
! PAPRSF     : PRESSURE ON FULL LEVELS.
! PALPH      : LOG(PAPRS(JLEV)/PAPRSF(JLEV)) (POUR L'HYDROSTATIQUE).
! PALPH      : LOG(PAPRS(JLEV)/PAPRSF(JLEV)) (FOR HYDROSTATICS).
! PDELP      : EPAISSEUR EN PRESSION DE LA COUCHE.
! PDELP      : LAYER THICKNESS IN PRESSURE UNITS.
! PLNPR      : LOG(PAPRS(JLEV)/PAPRS(JLEV-1)) (POUR L'HYDROSTATIQUE).
! PLNPR      : LOG(PAPRS(JLEV)/PAPRS(JLEV-1)) (FOR HYDROSTATICS).
! PRDELP     : INVERSE DE L'EPAISSEUR EN PRESSION DE LA COUCHE.
! PRDELP     : INVERSE OF PDELP.
! PU         : COMPOSANTE EN X DU VENT.
! PU         : X-COMPONENT OF WIND.
! PV         : COMPOSANTE EN Y DU VENT.
! PV         : Y-COMPONENT OF WIND.
! PT         : TEMPERATURE.
! PQ         : HUMIDITE SPECIFIQUE DE LA VAPEUR D'EAU.
! PQ         : SPECIFIC HUMIDITY OF WATER VAPOUR.
! PQI        : GLACE.
! PQI        : ICE.
! PQL        : EAU LIQUIDE.
! PQL        : LIQUID WATER.
! PO3        : GFL OZONE.
! PCP        : CHALEUR MASSIQUE A PRESSION CONSTANTE DE L'AIR.
! PCP        : SPECIFIC HEAT AT CONSTANT PRESSURE FOR AIR.
! PCVGQ      : CONVERGENCE D'HUMIDITE (CONDITION DE "KUO").
! PCVGQ      : CONVERGENCE OF HUMIDITY ("KUO" CONDITION).
! PKOZO      : CHAMPS POUR LA PHOTOCHIMIE DE L'OZONE (KVCLIS CHAMPS).
! PKOZO      : FIELDS FOR PHOTOCHEMISTERY OF OZONE   (KVCLIS FIELDS).
! PR         : CONSTANTE DES GAZ POUR L'AIR.
! PR         : GAS CONSTANT FOR AIR.
! PSGST      : TEMPERATURE DE SURFACE SOUS-MAILLE (KSGST CHAMPS)
! PSGST      : SUBGRID SURFACE TEMPERATURE (KSGST CHAMPS)

! - 1D (PROGNOSTIQUE) .
! - 1D (PROGNOSTIC QUANTITIES) .

! PALBNS     : ALBEDO DE LA NEIGE.
! PALBNS     : SNOW ALBEDO.
! PRHONS     : DENSITE DE LA NEIGE.
! PRHONS     : SNOW DENSITY.
! PSNS       : MASSE PAR UNITE DE SURFACE DE LA COUCHE NEIGEUSE.
! PSNS       : MASS OF SNOW PER UNIT SURFACE.
! PTP        : TEMPERATURE EN PROFONDEUR.
! PTP        : DEEP-LAYER TEMPERATURE.
! PTS        : TEMPERATURE DE SURFACE.
! PTS        : SURFACE LAYER TEMPERATURE.
! PWL        : CONTENU EN EAU DU RESERVOIR SUPERFICIEL
! PWL        : SKIN RESERVOIR WATER CONTENT
! PWP        : CONTENU EN EAU DU RESERVOIR EN PROFONDEUR.
! PWP        : DEEP-LAYER WATER CONTENT.
! PWPI       : CONTENU EN GLACE DU RESERVOIR EN PROFONDEUR.
! PWPI       : DEEP-LAYER ICE CONTENT.
! PWS        : CONTENU EN EAU DU RESERVOIR DE SURFACE.
! PWS        : SURFACE LAYER WATER CONTENT.
! PWSI       : CONTENU EN EAU GELEE DU RESERVOIR DE SURFACE.
! PWSI       : SURFACE LAYER ICE CONTENT.
! PTC        : TEMPERATURE DE RAPPEL CLIMATOLOGIQUE
! PTC        : CLIMATOLOGICAL DEEP SOIL TEMPERATURE
! PWC        : CONTENU EN EAU DU RESERVOIR DE RAPPEL CLIMATOLOGIQUE
! PWC        : CLIMATOLOGICAL DEEP SOIL WATER CONTENT.

! - 1D (GEOGRAPHIQUE) .
! - 1D (GEOGRAPHICAL DISTRIBUTION) .

! PAESEA     : AEROSOLS MARINS (SI KVCLIA >= 4)
! PAESEA     : MARINE AEROSOLS (IF KVCLIA >= 4)
! PAELAN     : AEROSOLS CONTINENTAUX (SI KVCLIA >= 4)
! PAELAN     : CONTINENTAL AEROSOLS (IF KVCLIA >= 4)
! PAEURB     : AEROSOLS URBAINS (SI KVCLIA >= 4)
! PAEURB     : URBAN AEROSOLS (IF KVCLIA >= 4)
! PAEDES     : AEROSOLS DESERTIQUES (SI KVCLIA >= 4)
! PAEDES     : DESERT AEROSOLS (IF KVCLIA >= 4)
! PALBF      : ALBEDO FIXE (SOL SANS NEIGE).
! PALBF      : BACKGROUND SURFACE SHORTWAVE ALBEDO (SNOW-FREE).
! PALBSF     : ALBEDO FIXE DU SOL (SOL SANS NEIGE).
! PALBSF     : BACKGROUND SOIL SHORTWAVE ALBEDO (SNOW-FREE).
! PARG       : POURCENTAGE D'ARGILE DANS LE SOL.
! PARG       : SILT PERCENTAGE WITHIN THE SOIL.
! PD2        : EPAISSEUR DU RESERVOIR PROFOND.
! PD2        : DEEP-LAYER OF THE OF THE PROFOUND WATER-TANK.
! PEMISF     : EMISSIVITE FIXE (SOL SANS NEIGE).
! PEMISF     : BACKGROUND SURFACE LONGWAVE EMISSIVITY (SNOW-FREE).
! PGETRL     : ECART TYPE DE L'OROGRAPHIE (EN J/KG).
! PGETRL     : STANDARD DEVIATION OF OROGRAPHY  (UNIT: J/KG).
! PGCHSS     : CHALEUR SENSIBLE SUR BANQUISE (SI KVCLIG >=7)
! PGCHSS     : SENSIBLE HEAT OVER SEA-ICE (IF KVCLIG >=7)
! PGEVAP     : EVAPORATION SUR BANQUISE (SI KVCLIG >=7)
! PGEVAP     : EVAPORATION OVER SEA-ICE (IF KVCLIG >=7)
! PGICFR     : FRACTION DE BANQUISE (SI KVCLIG >=7)
! PGICFR     : FRACTION OF SEA-ICE (IF KVCLIG >=7)
! PGIRUP     : FLUX IR MONTANT SUR BANQUISE (SI KVCLIG >=7)
! PGIRUP     : UPWARD IR FLUX OVER SEA-ICE (IF KVCLIG >=7)
! PGSOUP     : FLUX SOLAIRE MONTANT SUR BANQUISE (SI KVCLIG >=7)
! PGSOUP     : UPWARD SOLAR FLUX OVER SEA-ICE (IF KVCLIG >=7)
! PGTAUX     : TENSION U SUR BANQUISE (SI KVCLIG >=7)
! PGTAUX     : U-STRESS OVER SEA-ICE (IF KVCLIG >=7)
! PGTAUY     : TENSION V SUR BANQUISE (SI KVCLIG >=7)
! PGTAUY     : V-STRESS OVER SEA-ICE (IF KVCLIG >=7)
! PLSM       : INDICE TERRE/MER.
! PLSM       : LAND/SEA MASK.
! PIVEG      : TYPE DE VEGETATION.
! PIVEG      : TYPE OF VEGETATION.
! PLAI       : INDICE FOLIAIRE.
! PLAI       : FOLIAIRE INDICE.
! PRSMIN     : RESISTANCE STOMATIQUE MINIMALE.
! PRSMIN     : STOMATAL MINIMAL RESISTANCE.
! PRCORI     : FACTEUR DE CORIOLIS.
! PRCORI     : CORIOLIS FACTOR.
! PSAB       : POURCENTAGE DE SABLE DANS LE SOL.
! PSAB       : PERCENTAGE OF SAND WITHIN THE SOIL.
! PVEG0      : PROPORTION DE SOL COUVERTE DE VEGETATION.
! PVEG0      : FRACTIONAL COVER BY VEGETATION.
! PVRLAN     : ANISOTROPIE DU RELIEF SOUS MAILLE.
! PVRLDI     : ANGLE DE LA DIRECTION DU RELIEF AVEC L'AXE DES X.
! PGZ0F      : GRAVITY * ROUGHNESS LENGTH (TIME VARIABLE).
! PGZ0F      : CHAMP TEMPOREL DE G FOIS LA LONGUEUR DE RUGOSITE.
! PGZ0RLF    : GRAVITY * RELIEF ROUGHNESS LENGTH (TIME VARIABLE).
! PGZ0RLF    : CHAMP TEMPOREL DE G FOIS LA LONGUEUR DE RUGOSITE
!              DUE AU RELIEF.
! PGZ0H      : G*LONGUEUR DE RUGOSITE THERMIQUE (SI KVCLIV >= 8)
! PGZ0H      : G*THERMAL ROUGHNESS LENGTH (IF KVCLIV >= 8)

! - 1D (DIAGNOSTIQUE) .
! - 1D (DIAGNOSTIC QUANTITIES).

! PHV        : RESISTANCE A L'EVAPOTRANSPIRATION.
! PHV        : RESISTANCE TO EVAPOTRANSPIRATION.
! PMU0       : COSINUS LOCAL INSTANTANE DE L'ANGLE ZENITHAL SOLAIRE.
! PMU0LU     : COSINUS LOCAL INSTANTANE DE L'ANGLE ZENITHAL LUNAIRE.
! PMU0       : LOCAL COSINE OF INSTANTANEOUS SOLAR ZENITH ANGLE.
! PMU0LU     : LOCAL COSINE OF INSTANTANEOUS LUNAR ZENITH ANGLE.
! PMU0M      : COSINUS LOCAL MOYEN DE L'ANGLE ZENITHAL.
! PMU0M      : LOCAL COSINE OF AVERAGED SOLAR ZENITH ANGLE.
! PNEBH      : CHAMP "HISTORIQUE" POUR LA NEBULOSITE CONVECTIVE.
! PNEBH      : CONVECTIVE CLOUDINESS.

! PMMU0      : MEAN SOLAR ANGLE FOR GIVEN GRID POINT FOR SIMPL.
!              RADIATION SCHEME.
! PDHSF      : DISTRIBUTION OF HORIZONTAL MEAN WEIGHTS USED FOR
!              SIMPLIFIED RADIATION SCHEME.

! POMPAC    : Horizontally variable Curtis matrix for thermal rad. (clear sky)
! PAC       : Horizontally cst Curtis matrix for thermal rad. (clear sky)
! PCOR      : CORRECTION FOR CLOUDINESS FOR THERMAL RADIATION

! PRAB3C    : CLEAR-SKY PARALLEL/DIFFUSE REFLECTIVITY.  ---
! PRAB4C    : CLEAR-SKY DIFFUSE TRANSMISSIVITY.            | equivalent
! PRAB6C    : CLEAR-SKY DIFFUSE REFLECTIVITY.              | coefficients
! PRAB3N    : CLOUDY PARALLEL/DIFFUSE REFLECTIVITY.        | from bottom
! PRAB4N    : CLOUDY DIFFUSE TRANSMISSIVITY.               | to given
! PRAB6N    : CLOUDY DIFFUSE REFLECTIVITY.              ---  level

! PRAT1C    : CLEAR-SKY PARALLEL TRANSMISSIVITY.        ---
! PRAT2C    : CLEAR-SKY PARALLEL/DIFFUSE TRANSMISSIVITY.   |
! PRAT3C    : CLEAR-SKY PARALLEL/DIFFUSE REFLECTIVITY.     |
! PRAT4C    : CLEAR-SKY DIFFUSE TRANSMISSIVITY.            | equivalent
! PRAT5C    : CLEAR-SKY DIFFUSE REFLECTIVITY.              | coefficients
! PRAT1N    : CLOUDY PARALLEL TRANSMISSIVITY.              | from top
! PRAT2N    : CLOUDY PARALLEL/DIFFUSE TRANSMISSIVITY.      | to given
! PRAT3N    : CLOUDY PARALLEL/DIFFUSE REFLECTIVITY.        | level
! PRAT4N    : CLOUDY DIFFUSE TRANSMISSIVITY.               |
! PRAT5N    : CLOUDY DIFFUSE REFLECTIVITY.              ---
!-----------------------------------------------------------------------

! -   ARGUMENTS DE SORTIE D'APLPAR
! -   APLPAR OUTPUT ARGUMENTS.
!     ----------------------------

! - NOM DES VARIABLES DE LA PHYSIQUE (PAR ORDRE ALPHABETIQUE DANS CHAQUE
!   CATEGORIE).

! - 2D (0:KLEV) .

! PDIFCQ     : FLUX CONVECTIF D'HUMIDITE SPECIFIQUE (HORS PLUIE/NEIGE).
! PDIFCQ     : CONVECTIVE FLUX OF SPECIFIC HUMIDITY (NOT RAIN/SNOW).
! PDIFCQN    : FLUX CONVECTIF D'EAU SOLIDE (HORS PLUIE/NEIGE).
! PDIFCQN    : CONVECTIVE FLUX OF SOLID WATER (NOT RAIN/SNOW).
! PDIFCQL    : FLUX CONVECTIF D'EAU LIQUIDE (HORS PLUIE/NEIGE).
! PDIFCQL    : CONVECTIVE FLUX OF LIQUID WATER (NOT RAIN/SNOW).
! PDIFCS     : FLUX CONVECTIF D'ENTHALPIE (HORS PLUIE/NEIGE).
! PDIFCS     : CONVECTIVE FLUX OF ENTHALPY (NOT RAIN/SNOW).
! PDIFTQ     : FLUX TURBULENT (ET Q NEGATIF) D'HUMIDITE SPECIFIQUE.
! PDIFTQ     : TURBULENT FLUX (INC. Q NEGATIVE) OF SPECIFIC HUMIDITY.
! PDIFTQN    : FLUX TURBULENT (ET Q NEGATIF) D'EAU GLACE.
! PDIFTQN    : TURBULENT FLUX (INC. Q NEGATIVE) OF SOLID WATER.
! PDIFTQL    : FLUX TURBULENT (ET Q NEGATIF) D'EAU LIQUIDE.
! PDIFTQL    : TURBULENT FLUX (INC. Q NEGATIVE) OF LIQUID WATER.
! PDIFTS     : FLUX TURBULENT D'ENTHALPIE (OU D'ENERGIE STATIQUE SECHE).
! PDIFTS     : TURBULENT FLUX OF ENTHALPY (OR DRY STATIC ENERGY).
! PFCHOZ     : FLUX PHOTO-CHIMIQUE D'OZONE.
! PFCHOZ     : OZONE PHOTO-CHEMICAL FLUX.
! PFCCQN     : FLUX DE CONDENSATION LIE AUX RR CONVECTIVES NEIGEUSES.
! PFCCQN     : CONVECTIVE CONDENSATION FLUX FOR ICE.
! PFCCQL     : FLUX DE CONDENSATION LIE AUX RR CONVECTIVES LIQUIDES.
! PFCCQL     : CONVECTIVE CONDENSATION FLUX FOR LIQUID WATER.
! PFCQNG     : FLUX FICTIF DE VAPEUR POUR CORRIGER LES Q<0.
! PFCQNG     : PSEUDO-FLUX OF WATER TO CORRECT FOR Q<0.
! PFCQNNG    : FLUX FICTIF DE GLACE POUR CORRIGER LES QI<0.
! PFCQNNG    : PSEUDO-FLUX OF ICE TO CORRECT FOR QI<0.
! PFCQLNG    : FLUX FICTIF D'EAU LIQUIDE POUR CORRIGER LES QL<0.
! PFCQLNG    : PSEUDO-FLUX OF LIQUID WATER TO CORRECT FOR QL<0.
! PFPLCL     : PRECIPITATIONS CONVECTIVES SOUS FORME LIQUIDE.
! PFPLCL     : CONVECTIVE PRECIPITATION AS RAIN.
! PFPLCN     : PRECIPITATIONS CONVECTIVES SOUS FORME NEIGE.
! PFPLCN     : CONVECTIVE PRECIPITATION AS SNOW.
! PFPLSL     : PRECIPITATIONS STRATIFORMES SOUS FORME LIQUIDE.
! PFPLSL     : STRATIFORM PRECIPITATION AS RAIN.
! PFPLSN     : PRECIPITATIONS STRATIFORMES SOUS FORME NEIGE.
! PFPLSN     : STRATIFORM PRECIPITATION AS SNOW.
! PFRMH      : FLUX MESOSPHERIQUE D'ENTHALPIE.
! PFRMH      : MESOSPHERIC ENTHALPY FLUX.
! PFRSO      : FLUX DE RAYONNEMENT SOLAIRE.
! PFRSO      : SHORTWAVE RADIATIVE FLUX.
! PFRTH      : FLUX DE RAYONNEMENT THERMIQUE.
! PFRTH      : LONGWAVE RADIATIVE FLUX.
! PFCSQN     : FLUX DE CONDENSATION LIE AUX RR STRATIFORMES NEIGEUSES.
! PFCSQN     : STRATIFORM CONDENSATION FLUX FOR ICE.
! PFCSQL     : FLUX DE CONDENSATION LIE AUX RR STRATIFORMES LIQUIDES.
! PFCSQL     : STRATIFORM CONDENSATION FLUX FOR LIQUID WATER.
! PSTRCU     : FLUX CONVECTIF DE QUANTITE DE MOUVEMENT "U".
! PSTRCU     : CONVECTIVE FLUX OF MOMENTUM "U".
! PSTRCV     : FLUX CONVECTIF DE QUANTITE DE MOUVEMENT "V".
! PSTRCV     : CONVECTIVE FLUX OF MOMENTUM "V".
! PSTRDU     : FLUX "GRAVITY WAVE DRAG" "U".
! PSTRDU     : GRAVITY WAVE DRAG FLUX "U".
! PSTRDV     : FLUX "GRAVITY WAVE DRAG" "V".
! PSTRDV     : GRAVITY WAVE DRAG FLUX "V".
! PSTRTU     : FLUX TURBULENT DE QUANTITE DE MOUVEMENT "U".
! PSTRTU     : TURBULENT FLUX OF MOMENTUM "U".
! PSTRTV     : FLUX TURBULENT DE QUANTITE DE MOUVEMENT "V".
! PSTRTV     : TURBULENT FLUX OF MOMENTUM "V".
! PSTRMU     : FLUX MESOSPHERIQUE DE QUANTITE DE MOUVEMENT "U".
! PSTRMU     : MESOSPHERIC FLUX FOR "U"-MOMENTUM.
! PSTRMV     : FLUX MESOSPHERIQUE DE QUANTITE DE MOUVEMENT "V".
! PSTRMV     : MESOSPHERIC FLUX FOR "V"-MOMENTUM.

! - 2D (1:KLEV) .

! PLH        : CHALEUR LATENTE A LA TEMPERATURE DE L'AIR.
! PLH        : LATENT HEAT AT AIR TEMPERATURE.
! PLSCPE     : RAPPORT EFECTIF DES L ET CP EN CONDENSATION/EVAPORATION.
! PLSCPE     : EFFECTIVE RATIO OF L AND CP FOR CONDENSATION/EVAPORATION.
! PNEB       : NEBULOSITE PARTIELLE "RADIATIVE".
! PNEB       : FRACTIONAL CLOUDINESS FOR RADIATION.
! PQICE      : HUMIDITE SPECIFIQUE SOLIDE "RADIATIVE".
! PQICE      : SPECIFIC HUMIDITY OF SOLID WATER FOR RADIATION.
! PQLI       : HUMIDITE SPECIFIQUE LIQUIDE "RADIATIVE".
! PQLI       : SPECIFIC HUMIDITY OF LIQUID WATER FOR RADIATION.
! PQSAT      : HUMIDITE SPECIFIQUE DE SATURATION.
! PQSAT      : SPECIFIC HUMIDITY AT SATURATION.
! PQW        : HUMIDITE SPECIFIQUE DU THERMOMETRE MOUILLE.
! PQW        : SPECIFIC HUMIDITY OF THE WET THERMOMETER.
! PRH        : HUMIDITE RELATIVE.
! PRH        : RELATIVE HUMIDITY.
! PTW        : TEMPERATURE DU THERMOMETRE MOUILLE.
! PTW        : TEMPERATURE OF THE WET THERMOMETER.

! - 2D (CLOUD AND RADIATION I/O FOR ECMWF PHYSICS)

! PEMTD      : DOWNWARD LONGWAVE EMISSIVITY
! PEMTU      : UPWARD   LONGWAVE EMISSIVITY
! PTRSO      : SHORTWAVE TRANSMISSIVITY
! ZTENT      : TENDENCY OF TEMPERATURE.

! - 2D (0:1)
! PFRSOC     : SHORTWAVE CLEAR SKY RADIATIVE FLUX
! PFRTHC     : LONGWAVE CLEAR SKY RADIATIVE FLUX

! - 1D (DIAGNOSTIQUE) .

! PALB       : ALBEDO DE SURFACE COURANT.
! PALB       : MODEL SURFACE SHORTWAVE ALBEDO.
! PCD        : COEFFICIENT D'ECHANGE EN SURFACE POUR U ET V.
! PCD        : EXCHANGE COEFFICIENT AT SURFACE LEVEL FOR U AND V.
! PCDN       : COEFFICIENT NEUTRE D'ECHANGE EN SURFACE.
! PCDN       : EXCHANGE COEFF. AT SURFACE LEVEL IN NEUTRAL CONDITIONS.
! PCH        : COEFFICIENT D'ECHANGE EN SURFACE POUR T ET Q.
! PCH        : EXCHANGE COEFFICIENT AT SURFACE LEVEL FOR T AND Q.
! PCPS       : CHALEUR MASSIQUE DE L'AIR EN SURFACE.
! PC1        : COEFF. HYDRIQUE REPRESENTANT L'INTENSITE AVEC LAQUELLE
!              LES FLUX DE SURFACE PARTICIPENT A L'EVOLUTION DE WS.
! PC1        : HYDROLOGICAL COEFF. SHOWING THE CONTRIBUTION OF SURFACE
!              FLUXES IN THE WS EVOLUTION.
! PC2        : COEFF. HYDRIQUE TRADUISANT LA RAPIDITE DES TRANSFERTS
!              D'EAU ENTRE LES DEUX RESERVOIRS.
! PC2        : HYDROLOGICAL COEFFICIENT SHOWING THE QUICKNESS OF WATER
!              TRANSFERS BETWEEN BOTH TANKS.
! PCT        : COEFFICIENT THERMIQUE DU MILIEU SOL-VEGETATION.
! PCT        : THERMICAL COEFFICIENT OF SOIL-VEGETATION MIDDEL.
! PEMIS      : EMISSIVITE DE SURFACE COURANTE.
! PEMIS      : MODEL SURFACE LONGWAVE EMISSIVITY.
! PFCHSP     : FLUX DE CHALEUR DE LA SURFACE VERS LE SOL PROFOND.
! PFCHSP     : HEAT FLUX FROM SURFACE TO DEEP SOIL.
! PFCLL      : FLUX DE CHALEUR LATENTE SUR EAU LIQUIDE (OU SOL HUMIDE).
! PFCLL      : LATENT HEAT FLUX OVER LIQUID WATER (OR WET SOIL).
! PFCLN      : FLUX DE CHALEUR LATENTE SUR NEIGE (OU GLACE).
! PFCLN      : LATENT HEAT FLUX OVER SNOW (OR ICE).
! PFCS       : FLUX DE CHALEUR SENSIBLE EN SURFACE.
! PFCS       : SENSIBLE HEAT FLUX AT SURFACE LEVEL.
! PFEVI      : FLUX DE VAPEUR D'EAU SUR GLACE (SOL GELE).
! PFEVI      : WATER VAPOUR FLUX OVER ICE (FROZEN SOIL).
! PFEVL      : FLUX DE VAPEUR D'EAU SUR EAU LIQUIDE (OU SOL HUMIDE).
! PFEVL      : WATER VAPOUR FLUX OVER LIQUID WATER (OR WET SOIL)
! PFEVN      : FLUX DE VAPEUR D'EAU SUR NEIGE (OU GLACE).
! PFEVV      : FLUX D'EVAPOTRANSPIRATION.
! PFEVV      : EVAPOTRANSPIRATION FLUX.
! PFTR       : FLUX DE TRANSPIRATION.
! PFTR       : TRANSPIRATION FLUX.
! PFEVN      : WATER VAPOUR FLUX OVER SNOW (OR ICE).
! PFLWSP     : FLUX D'EAU LIQUIDE DE LA SURFACE VERS LE SOL PROFOND.
! PFLWSP     : WATER FLUX FROM SURFACE TO DEEP SOIL.
! PFONTE     : FLUX D'EAU CORRESPONDANT A LA FONTE DE NEIGE EN SURFACE.
! PFONTE     : WATER FLUX CORRESPONDING TO SURFACE SNOW MELT.
! PFGEL      : FLUX D'EAU CORRESPONDANT A LA FONTE DE GLACE DANS LE SOL
! PFGEL      : WATER FLUX CORRESPONDING TO SURFACE ICE MELT.
! PFGELS     : FLUX DE GEL DE L'EAU DU RESERVOIR DE SURFACE.
! PFGELS     : FREEZING FLUX OF SOIL WATER AT SURFACE LEVEL.
! PFRSODS    : FLUX SOLAIRE DESCENDANT EN SURFACE
! PFRSODS    : SURFACE DOWNWARDS SOLAR FLUX
! PFRSOPS    : FLUX SOLAIRE PARALLELE EN SURFACE
! PFRSOPS    : SURFACE PARALLEL SOLAR FLUX
! PFRTHDS    : FLUX IR DESCENDANT EN SURFACE
! PFRTHDS    : SURFACE DOWNWARDS IR FLUX
! PGZ0       : G FOIS LA LONGUEUR DE RUGOSITE COURANTE.
! PGZ0       : G * ROUGHNESS LENGTH (CURRENT).
! PLHS       : CHALEUR LATENTE EN SURFACE.
! PNEIJ      : PROPORTION DE SOL ENNEIGE.
! PNEIJ      : FRACTION OF SOIL COVERED BY SNOW.
! PVEG       : FRACTION DE VEGETATION APPARENTE.
! PVEG       : FRACTIONAL COVER BY APPARENT VEGETATION.
! PQS        : HUMIDITE SPECIFIQUE DE SURFACE.
! PQS        : SPECIFIC HUMIDITY AT SURFACE LEVEL.
! PQSATS     : HUMIDITE SPECIFIQUE DE SATURATION EN SURFACE.
! PQSATS     : SATURATED SPECIFIC HUMIDITY AT SURFACE LEVEL.
! PRS        : CONSTANTE DES GAZ DE L'AIR EN SURFACE.
! PRUISP     : FLUX DE RUISSELLEMENT EN PROFONDEUR.
! PRUISP     : RUN-OFF FLUX IN SOIL.
! PRUISL     : FLUX DE RUISSELLEMENT DU RESERVOIR D'INTERCEPTION.
! PRUISL     : RUN-OFF FLUX OUT THE INTERCEPTION WATER-TANK.
! PRUISS     : FLUX DE RUISSELLEMENT EN SURFACE.
! PRUISS     : RUN-OFF FLUX AT SURFACE LEVEL.
! PUCLS      : SORTIE DIAGNOSTIQUE DU VENT EN X A HUV METEO.
! PUCLS      : U-COMPONENT OF WIND AT 10 METERS (DIAGNOSTIC).
! PVCLS      : SORTIE DIAGNOSTIQUE DU VENT EN Y A HUV METEO.
! PVCLS      : V-COMPONENT OF WIND AT 10 METERS (DIAGNOSTIC).
! PTCLS      : SORTIE DIAGNOSTIQUE DE LA TEMPERATURE A HTQ METEO.
! PTCLS      : TEMPERATURE AT 2 METERS (DIAGNOSTIC).
! PQCLS      : SORTIE DIAGNOSTIQUE DE L'HUMIDITE SPECIFIQUE A HTQ METEO.
! PQCLS      : SPECIFIC HUMIDITY AT 2 METERS (DIAGNOSTIC).
! PRHCLS     : SORTIE DIAGNOSTIQUE DE L'HUMIDITE RELATIVE A HTQ METEO.
! PRHCLS     : RELATIVE HUMIDITY AT 2 METERS (DIAGNOSTIC).
! PCLCC      : SORTIE DIAGNOSTIQUE DE LA NEBULOSITE CONVECTIVE.
! PCLCC      : CONVECTIVE CLOUD COVER (DIAGNOSTIC).
! PCLCH      : SORTIE DIAGNOSTIQUE DE LA NEBULOSITE HAUTE.
! PCLCH      : HIGH CLOUD COVER (DIAGNOSTIC).
! PCLCL      : SORTIE DIAGNOSTIQUE DE LA NEBULOSITE BASSE.
! PCLCL      : LOW CLOUD COVER (DIAGNOSTIC).
! PCLCM      : SORTIE DIAGNOSTIQUE DE LA NEBULOSITE MOYENNE.
! PCLCM      : MEDIUM CLOUD COVER (DIAGNOSTIC).
! PCLCT      : SORTIE DIAGNOSTIQUE DE LA NEBULOSITE TOTALE.
! PCLCT      : TOTAL CLOUD COVER (DIAGNOSTIC).

!-----------------------------------------------------------------------

! -   ARGUMENTS DE SORTIE POUR LE COUPLAGE OCEANIQUE
! -   OUTPUT ARGUMENTS FOR OCEANIC COUPLING
!     ----------------------------------------------

! SAME NOMENCLATURE WITH '2'

!-----------------------------------------------------------------------

! -   ARGUMENTS DE SORTIE POUR LE SOL
! -   OUTPUT ARGUMENTS FOR SOIL
!     -------------------------------

! SAME NOMENCLATURE WITH '1'
!-----------------------------------------------------------------------

!     Externes.
!     ---------

!     Methode.
!     --------

!        If PLAND (proportion of land) is not 0 or 1, the physics are
!      calculated twice and the flux obtained are linearly combined.

!     Auteur.
!     -------

!     01-03-96: T. LAGARDE

!     Modifications.
!     --------------
!        M.Hamrud      01-Oct-2003 CY28 Cleaning

!     11-04-97: utilisation de NTVGLA (M. Deque)
!     11-05-97: rayt FMR gele         (M. Deque)
!     03-12-97: Appel a APLPAR modifie pour le gel
!               de l'eau du sol (E. Bazile)
!     04-12-97: adapation pour gel  de l'eau du sol (Deque)
!     17-02-99: Appel a APLPAR modifie pour le gel de surface
!               (E. Bazile)
!     19-04-99: Moon radiation (J.M. Piriou)
!     31-03-2000: Appel a APLPAR pour sortir la CAPE (E. Bazile)
!     13-06-2000: hauteur de la cls & rafales (R. El khatib)
!     2004-07-06 K. Yessad: use GFL ozone instead of obsolete pas. scalar one.

! -----------------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMCST   , ONLY : RG
USE YOMPHY   , ONLY : LRAYFM   ,LRAYFM15 ,LSOLV
USE YOMPHY1  , ONLY : ALBGLA   ,ALBMER   ,EMMGLA   ,EMMMER   ,&
 & RD1      ,RD2GLA   ,RD2MER   ,RZ0GLA   ,RZ0MER   ,&
 & RZHZ0G   ,RZHZ0M   ,TMERGL   ,WPMX     ,WSMX     ,&
 & NTVGLA   ,NTVMER  
USE YOMDIM   , ONLY :    NPROMB   ,NPROMC
USE YOMMCC   , ONLY : LMCC02

! -----------------------------------------------------------------------------

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KLON 
INTEGER(KIND=JPIM),INTENT(IN)    :: KLEV 
INTEGER(KIND=JPIM),INTENT(IN)    :: KVCLIS 
INTEGER(KIND=JPIM),INTENT(IN)    :: KNEBH 
INTEGER(KIND=JPIM),INTENT(IN)    :: KSGST 
INTEGER(KIND=JPIM),INTENT(IN)    :: KCSS 
INTEGER(KIND=JPIM),INTENT(IN)    :: KWORK 
INTEGER(KIND=JPIM),INTENT(IN)    :: KIDIA 
INTEGER(KIND=JPIM),INTENT(IN)    :: KFDIA 
INTEGER(KIND=JPIM)               :: KTDIA ! Argument NOT used
INTEGER(KIND=JPIM)               :: KPOSI ! Argument NOT used
INTEGER(KIND=JPIM)               :: KGL1 ! Argument NOT used
INTEGER(KIND=JPIM)               :: KGL2 ! Argument NOT used
INTEGER(KIND=JPIM),INTENT(IN)    :: KVCLIA 
INTEGER(KIND=JPIM),INTENT(IN)    :: KVCLIG 
INTEGER(KIND=JPIM)               :: KVCLIV ! Argument NOT used
INTEGER(KIND=JPIM)               :: KSTART ! Argument NOT used
INTEGER(KIND=JPIM)               :: KSTEP ! Argument NOT used
REAL(KIND=JPRB)   ,INTENT(IN)    :: PLAND(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PTSOC(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PAPHI(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PAPRS(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PAPHIF(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PAPRSF(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PALPH(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PARG(KLON) 
REAL(KIND=JPRB)                  :: PD2(KLON) ! Argument NOT used
REAL(KIND=JPRB)   ,INTENT(IN)    :: PDELP(KLON,KLEV) 
REAL(KIND=JPRB)                  :: PIVEG(KLON) ! Argument NOT used
REAL(KIND=JPRB)                  :: PLAI(KLON) ! Argument NOT used
REAL(KIND=JPRB)   ,INTENT(IN)    :: PLNPR(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PRDELP(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PRSMIN(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSAB(KLON) 
REAL(KIND=JPRB)                  :: PGZ0H(KLON) ! Argument NOT used
REAL(KIND=JPRB)   ,INTENT(IN)    :: PAESEA(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PAELAN(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PAEURB(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PAEDES(KLON) 
REAL(KIND=JPRB)                  :: PRCORI(KLON) ! Argument NOT used
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGCHSS(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGEVAP(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGICFR(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGIRUP(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGSOUP(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGTAUX(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGTAUY(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PU(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PV(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PT(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PQ(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PQI(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PQL(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PO3(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PCP(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PCVGQ(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PR(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PKOZO(KLON,KLEV,KVCLIS) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSGST(KLON,KSGST) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PNEBH(KLON,KNEBH) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSNS(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PALBNS(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PRHONS(KLON) 
REAL(KIND=JPRB)                  :: PTP(KLON,KCSS) ! Argument NOT used
REAL(KIND=JPRB)   ,INTENT(IN)    :: PTS(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PWL(KLON) 
REAL(KIND=JPRB)                  :: PWP(KLON) ! Argument NOT used
REAL(KIND=JPRB)                  :: PWPI(KLON) ! Argument NOT used
REAL(KIND=JPRB)                  :: PWS(KLON) ! Argument NOT used
REAL(KIND=JPRB)                  :: PWSI(KLON) ! Argument NOT used
REAL(KIND=JPRB)   ,INTENT(IN)    :: PHV(KLON) 
REAL(KIND=JPRB)                  :: PTC(KLON) ! Argument NOT used
REAL(KIND=JPRB)                  :: PWC(KLON) ! Argument NOT used
REAL(KIND=JPRB)   ,INTENT(IN)    :: PVERVEL(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PEMTD(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PEMTU(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTRSO(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PCLON(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSLON(KLON) 
REAL(KIND=JPRB)                  :: PALBF(KLON) ! Argument NOT used
REAL(KIND=JPRB)   ,INTENT(IN)    :: PALBSF(KLON) 
REAL(KIND=JPRB)                  :: PEMISF(KLON) ! Argument NOT used
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGETRL(KLON) 
REAL(KIND=JPRB)                  :: PLSM(KLON) ! Argument NOT used
REAL(KIND=JPRB)                  :: PVEG0(KLON) ! Argument NOT used
REAL(KIND=JPRB)                  :: PGZ0F(KLON) ! Argument NOT used
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGZ0RLF(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PVRLAN(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PVRLDI(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PMU0(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PMU0LU(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PMU0M(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGEMU(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PWORK(KWORK) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGM(KLON) 
REAL(KIND=JPRB)               :: POMPAC(KLON,0:KLEV,0:KLEV) ! Argument NOT used
REAL(KIND=JPRB)                  :: PAC(KLEV+1,KLEV+1) ! Argument NOT used
REAL(KIND=JPRB)                  :: PCOR(KLON,KLEV) ! Argument NOT used
REAL(KIND=JPRB)                  :: PMMU0(KLON) ! Argument NOT used
REAL(KIND=JPRB)                  :: PDHSF(KLON) ! Argument NOT used
REAL(KIND=JPRB)                  :: PRAB3C(KLON,KLEV) ! Argument NOT used
REAL(KIND=JPRB)                  :: PRAB3N(KLON,KLEV) ! Argument NOT used
REAL(KIND=JPRB)                  :: PRAB4C(KLON,KLEV) ! Argument NOT used
REAL(KIND=JPRB)                  :: PRAB4N(KLON,KLEV) ! Argument NOT used
REAL(KIND=JPRB)                  :: PRAB6C(KLON,KLEV) ! Argument NOT used
REAL(KIND=JPRB)                  :: PRAB6N(KLON,KLEV) ! Argument NOT used
REAL(KIND=JPRB)                  :: PRAT1C(KLON,KLEV) ! Argument NOT used
REAL(KIND=JPRB)                  :: PRAT1N(KLON,KLEV) ! Argument NOT used
REAL(KIND=JPRB)                  :: PRAT2C(KLON,KLEV) ! Argument NOT used
REAL(KIND=JPRB)                  :: PRAT2N(KLON,KLEV) ! Argument NOT used
REAL(KIND=JPRB)                  :: PRAT3C(KLON,KLEV) ! Argument NOT used
REAL(KIND=JPRB)                  :: PRAT3N(KLON,KLEV) ! Argument NOT used
REAL(KIND=JPRB)                  :: PRAT4C(KLON,KLEV) ! Argument NOT used
REAL(KIND=JPRB)                  :: PRAT4N(KLON,KLEV) ! Argument NOT used
REAL(KIND=JPRB)                  :: PRAT5C(KLON,KLEV) ! Argument NOT used
REAL(KIND=JPRB)                  :: PRAT5N(KLON,KLEV) ! Argument NOT used
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFCQ(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFCQN(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFCQL(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFCS(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFTQ(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFTQN(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFTQL(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFTS(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCCQL(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCCQN(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCSQL(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCSQN(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCQNG(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCQNNG(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCQLNG(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPLCL(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPLCN(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPLSL(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPLSN(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFRSO(KLON,0:KLEV,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFRSOC(KLON,0:1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFRTH(KLON,0:KLEV,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFRTHC(KLON,0:1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSTRCU(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSTRCV(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSTRDU(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSTRDV(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSTRTU(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSTRTV(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSTRMU(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSTRMV(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFRMH(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCHOZ(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCPS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PLHS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PRS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PLH(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PLSCPE(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PNEB(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQICE(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQLI(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQSAT(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQW(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PRH(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTW(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PALB(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCD(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCDN(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCH(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PC1(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PC2(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCT(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PEMIS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCHSP(KLON,KCSS) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCLL(KLON,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCLN(KLON,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCS(KLON,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PFEVI(KLON,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFEVL(KLON,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFEVN(KLON,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFEVV(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFTR(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFLWSP(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFONTE(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFGEL(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFGELS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFRSODS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFRSOPS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFRSOPT(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFRSOLU(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFRTHDS(KLON) 
REAL(KIND=JPRB)                  :: PGZ0(KLON) ! Argument NOT used
REAL(KIND=JPRB)                  :: PNEIJ(KLON) ! Argument NOT used
REAL(KIND=JPRB)   ,INTENT(IN)    :: PVEG(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQSATS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PRUISL(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PRUISP(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PRUISS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PUCLS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PVCLS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTCLS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQCLS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PRHCLS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCLCT(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCLCH(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCLCM(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCLCL(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCLCC(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2FPLCL(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2FPLCN(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2FPLSL(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2FPLSN(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2FRSO(NPROMB,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2FRTH(NPROMB,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2STRDU(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2STRDV(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2STRTU(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2STRTV(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2FCLL(NPROMB,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2FCLN(NPROMB,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2FCS(NPROMB,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2FEVL(NPROMB,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2FEVN(NPROMB,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2FRTHDS(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2RUISP(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2RUISS(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P2TCLS(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FPLCL(NPROMB,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FPLCN(NPROMB,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FPLSL(NPROMB,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FPLSN(NPROMB,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FRSO(NPROMB,0:KLEV,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FRTH(NPROMB,0:KLEV,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1C1(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1C2(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1CT(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FCHSP(NPROMB,KCSS) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FCLL(NPROMB,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FCLN(NPROMB,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FCS(NPROMB,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FEVI(NPROMB,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FEVL(NPROMB,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FEVN(NPROMB,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FEVV(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FTR(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FLWSP(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FONTE(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FGEL(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1FGELS(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1VEG(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1RUISL(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1RUISP(NPROMB) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: P1RUISS(NPROMB) 
CHARACTER(LEN=7)  ,INTENT(IN)    :: CDLOCK 

! -----------------------------------------------------------------------------

INTEGER(KIND=JPIM) :: I_TAB(NPROMC)
INTEGER(KIND=JPIM) :: I_IDIA,I_FDIA

!    APLPAR INPUTS

REAL(KIND=JPRB) :: Z_APHI(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_APRS(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_APHIF(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_APRSF(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_ALPH(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_ARG(NPROMC)
REAL(KIND=JPRB) :: Z_D2(NPROMC)
REAL(KIND=JPRB) :: Z_DELP(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_IVEG(NPROMC)
REAL(KIND=JPRB) :: Z_LAI(NPROMC)
REAL(KIND=JPRB) :: Z_LNPR(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_RDELP(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_RSMIN(NPROMC)
REAL(KIND=JPRB) :: Z_SAB(NPROMC)
REAL(KIND=JPRB) :: Z_GZ0H(NPROMC)
REAL(KIND=JPRB) :: Z_AESEA(NPROMC)
REAL(KIND=JPRB) :: Z_AELAN(NPROMC)
REAL(KIND=JPRB) :: Z_AEURB(NPROMC)
REAL(KIND=JPRB) :: Z_AEDES(NPROMC)
REAL(KIND=JPRB) :: Z_GCHSS(NPROMC)
REAL(KIND=JPRB) :: Z_GEVAP(NPROMC)
REAL(KIND=JPRB) :: Z_GICFR(NPROMC)
REAL(KIND=JPRB) :: Z_GIRUP(NPROMC)
REAL(KIND=JPRB) :: Z_GSOUP(NPROMC)
REAL(KIND=JPRB) :: Z_GTAUX(NPROMC)
REAL(KIND=JPRB) :: Z_GTAUY(NPROMC)
REAL(KIND=JPRB) :: Z_U(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_V(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_T(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_Q(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_QI(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_QL(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_O3(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_CP(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_CVGQ(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_R(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_KOZO(NPROMC,KLEV,KVCLIS)
REAL(KIND=JPRB) :: Z_SGST(NPROMC,KSGST)
REAL(KIND=JPRB) :: Z_NEBH(NPROMC,KNEBH)
REAL(KIND=JPRB) :: Z_SNS(NPROMC)
REAL(KIND=JPRB) :: Z_ALBNS(NPROMC)
REAL(KIND=JPRB) :: Z_RHONS(NPROMC)
REAL(KIND=JPRB) :: Z_TP(NPROMC,KCSS)
REAL(KIND=JPRB) :: Z_TS(NPROMC)
REAL(KIND=JPRB) :: Z_WL(NPROMC)
REAL(KIND=JPRB) :: Z_WI(NPROMC)
REAL(KIND=JPRB) :: Z_WP(NPROMC)
REAL(KIND=JPRB) :: Z_WS(NPROMC)
REAL(KIND=JPRB) :: Z_WSI(NPROMC)
REAL(KIND=JPRB) :: Z_HV(NPROMC)
REAL(KIND=JPRB) :: Z_TC(NPROMC)
REAL(KIND=JPRB) :: Z_WC(NPROMC)
REAL(KIND=JPRB) :: Z_VERVEL(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_EMTD (NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_EMTU (NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_TRSO (NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_CLON(NPROMC)
REAL(KIND=JPRB) :: Z_SLON(NPROMC)
REAL(KIND=JPRB) :: Z_ALBF(NPROMC)
REAL(KIND=JPRB) :: Z_ALBSF(NPROMC)
REAL(KIND=JPRB) :: Z_EMISF(NPROMC)
REAL(KIND=JPRB) :: Z_GETRL(NPROMC)
REAL(KIND=JPRB) :: Z_LSM(NPROMC)
REAL(KIND=JPRB) :: Z_VEG0(NPROMC)
REAL(KIND=JPRB) :: Z_GZ0F(NPROMC)
REAL(KIND=JPRB) :: Z_GZ0RLF(NPROMC)
REAL(KIND=JPRB) :: Z_VRLAN(NPROMC)
REAL(KIND=JPRB) :: Z_VRLDI(NPROMC)
REAL(KIND=JPRB) :: Z_MU0(NPROMC)
REAL(KIND=JPRB) :: Z_MU0LU(NPROMC)
REAL(KIND=JPRB) :: Z_MU0M(NPROMC)
REAL(KIND=JPRB) :: Z_GEMU(NPROMC)
REAL(KIND=JPRB) :: Z_WORK(KWORK)
REAL(KIND=JPRB) :: Z_GM(NPROMC)

!   APLPAR OUTPUTS

REAL(KIND=JPRB) :: Z_ALB(NPROMC)
REAL(KIND=JPRB) :: Z_C1(NPROMC)
REAL(KIND=JPRB) :: Z_C2(NPROMC)
REAL(KIND=JPRB) :: Z_CD(NPROMC)
REAL(KIND=JPRB) :: Z_CDN(NPROMC)
REAL(KIND=JPRB) :: Z_CH(NPROMC)
REAL(KIND=JPRB) :: Z_CLCC(NPROMC)
REAL(KIND=JPRB) :: Z_CLCH(NPROMC)
REAL(KIND=JPRB) :: Z_CLCL(NPROMC)
REAL(KIND=JPRB) :: Z_CLCM(NPROMC)
REAL(KIND=JPRB) :: Z_CLCT(NPROMC)
REAL(KIND=JPRB) :: Z_CPS(NPROMC)
REAL(KIND=JPRB) :: Z_CT(NPROMC)
REAL(KIND=JPRB) :: Z_DIFCQ(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_DIFCQL(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_DIFCQN(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_DIFCS(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_DIFTQ(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_DIFTQL(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_DIFTQN(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_DIFTS(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_EMIS(NPROMC)
REAL(KIND=JPRB) :: Z_FCCQL(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_FCCQN(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_FCHOZ(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_FCHSP(NPROMC,KCSS)
REAL(KIND=JPRB) :: Z_FCLL(NPROMC,KSGST+1)
REAL(KIND=JPRB) :: Z_FCLN(NPROMC,KSGST+1)
REAL(KIND=JPRB) :: Z_FCQLNG(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_FCQNG(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_FCQNNG(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_FCS(NPROMC,KSGST+1)
REAL(KIND=JPRB) :: Z_FCSQL(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_FCSQN(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_FEVL(NPROMC,KSGST+1)
REAL(KIND=JPRB) :: Z_FEVN(NPROMC,KSGST+1)
REAL(KIND=JPRB) :: Z_FEVV(NPROMC)
REAL(KIND=JPRB) :: Z_FLWSP(NPROMC)
REAL(KIND=JPRB) :: Z_FONTE(NPROMC)
REAL(KIND=JPRB) :: Z_FGEL(NPROMC)
REAL(KIND=JPRB) :: Z_FGELS(NPROMC)
REAL(KIND=JPRB) :: Z_FPLCL(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_FPLCN(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_FPLSL(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_FPLSN(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_FRMH(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_FRSO(NPROMC,0:KLEV,KSGST+1)
REAL(KIND=JPRB) :: Z_FRSOC(NPROMC,0:1)
REAL(KIND=JPRB) :: Z_FRSODS(NPROMC)
REAL(KIND=JPRB) :: Z_FRSOPS(NPROMC)
REAL(KIND=JPRB) :: Z_FRSOPT(NPROMC)
REAL(KIND=JPRB) :: Z_FRSOLU(NPROMC)
REAL(KIND=JPRB) :: Z_FRTH(NPROMC,0:KLEV,KSGST+1)
REAL(KIND=JPRB) :: Z_FRTHC(NPROMC,0:1)
REAL(KIND=JPRB) :: Z_FRTHDS(NPROMC)
REAL(KIND=JPRB) :: Z_FTR(NPROMC)
REAL(KIND=JPRB) :: Z_LH(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_LHS(NPROMC)
REAL(KIND=JPRB) :: Z_LSCPE(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_NEB(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_QCLS(NPROMC)
REAL(KIND=JPRB) :: Z_QICE(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_QLI(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_QS(NPROMC)
REAL(KIND=JPRB) :: Z_QSAT(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_QSATS(NPROMC)
REAL(KIND=JPRB) :: Z_QW(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_RH(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_RHCLS(NPROMC)
REAL(KIND=JPRB) :: Z_RS(NPROMC)
REAL(KIND=JPRB) :: Z_RUISL(NPROMC)
REAL(KIND=JPRB) :: Z_RUISP(NPROMC)
REAL(KIND=JPRB) :: Z_RUISS(NPROMC)
REAL(KIND=JPRB) :: Z_STRCU(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_STRCV(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_STRDU(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_STRDV(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_STRMU(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_STRMV(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_STRTU(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_STRTV(NPROMC,0:KLEV)
REAL(KIND=JPRB) :: Z_TCLS(NPROMC)
REAL(KIND=JPRB) :: Z_TW(NPROMC,KLEV)
REAL(KIND=JPRB) :: Z_UCLS(NPROMC)
REAL(KIND=JPRB) :: Z_VCLS(NPROMC)
INTEGER(KIND=JPIM) :: ITVGLAM, JCSS, JF, JI, JK, JL, JLEV,&
 & JLON, JNEBH, JSGST, JVCLIS, JWORK, J_LON  

LOGICAL :: LLMIXTE

REAL(KIND=JPRB) :: Z1, Z2, ZA, ZB, ZLWTOT, ZMAX, ZSWTOT, ZWXGLA, ZWXMER, ZWXSUR
REAL(KIND=JPRB) :: ZHOOK_HANDLE

! -----------------------------------------------------------------------------

#include "abor1.intfb.h"

! -----------------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('APL2PHY',0,ZHOOK_HANDLE)

! -----------------------------------------------------------------------------

!     CHECK RELIABILITY OF INPUT ARGUMENTS.
IF(CDLOCK /= 'APL2PHY ') CALL ABOR1('BAD NUMBER OF ARGUMENTS!')

! -----------------------------------------------------------------------------

!***************************************************************
!       CONSTANTES DE LA PROCEDURE
!***************************************************************

!       Proportion de terre pour determiner les points mixtes
!       Prendre 1 en couple
ZMAX=0.9_JPRB

!       Reservoirs
IF(LSOLV) THEN
  ZWXMER=1000._JPRB*RD2MER
  ZWXGLA=1000._JPRB*RD2GLA
  ZWXSUR=1000._JPRB*RD1
ELSE
  ZWXMER=WPMX
  ZWXGLA=WPMX
  ZWXSUR=WSMX
ENDIF

!***************************************************************
!     RECOPIE DES POINTS MIXTES
!***************************************************************

ITVGLAM=10*NTVGLA+1
I_IDIA=KIDIA
J_LON=I_IDIA-1
DO JLON=KIDIA,KFDIA
  LLMIXTE=((PLSM(JLON) == 1.0_JPRB).AND.(PLAND(JLON) < ZMAX))
  LLMIXTE=((LLMIXTE).AND.((NINT(10*(PIVEG(JLON)))) /= ITVGLAM))
  IF (LLMIXTE) THEN
    J_LON=J_LON+1
    I_TAB(J_LON)=JLON
    DO JLEV=0,KLEV
      Z_APHI(J_LON,JLEV)=PAPHI(JLON,JLEV)
      Z_APRS(J_LON,JLEV)=PAPRS(JLON,JLEV)
      Z_EMTD(J_LON,JLEV)=PEMTD(JLON,JLEV)
      Z_EMTU(J_LON,JLEV)=PEMTU(JLON,JLEV)
      Z_TRSO(J_LON,JLEV)=PTRSO(JLON,JLEV)
    ENDDO
    DO JLEV=1,KLEV
      Z_APHIF(J_LON,JLEV)=PAPHIF(JLON,JLEV)
      Z_APRSF(J_LON,JLEV)=PAPRSF(JLON,JLEV)
      Z_ALPH(J_LON,JLEV)=PALPH(JLON,JLEV)
      Z_DELP(J_LON,JLEV)=PDELP(JLON,JLEV)
      Z_LNPR(J_LON,JLEV)=PLNPR(JLON,JLEV)
      Z_RDELP(J_LON,JLEV)=PRDELP(JLON,JLEV)
      Z_U(J_LON,JLEV)=PU(JLON,JLEV)
      Z_V(J_LON,JLEV)=PV(JLON,JLEV)
      Z_T(J_LON,JLEV)=PT(JLON,JLEV)
      Z_Q(J_LON,JLEV)=PQ(JLON,JLEV)
      Z_QI(J_LON,JLEV)=PQI(JLON,JLEV)
      Z_QL(J_LON,JLEV)=PQL(JLON,JLEV)
      Z_CP(J_LON,JLEV)=PCP(JLON,JLEV)
      Z_CVGQ(J_LON,JLEV)=PCVGQ(JLON,JLEV)
      Z_R(J_LON,JLEV)=PR(JLON,JLEV)
      Z_VERVEL(J_LON,JLEV)=PVERVEL(JLON,JLEV)
      Z_O3(J_LON,JLEV)=PO3(JLON,JLEV)
      DO JVCLIS=1,KVCLIS
        Z_KOZO(J_LON,JLEV,JVCLIS)=PKOZO(JLON,JLEV,JVCLIS)
      ENDDO
    ENDDO
    Z_ARG(J_LON)=PARG(JLON)
    Z_RSMIN(J_LON)=PRSMIN(JLON)
    Z_SAB(J_LON)=PSAB(JLON)
    IF (KVCLIA  >  3) THEN
      Z_AESEA(J_LON)=PAESEA(JLON)
      Z_AELAN(J_LON)=PAELAN(JLON)
      Z_AEURB(J_LON)=PAEURB(JLON)
      Z_AEDES(J_LON)=PAEDES(JLON)
    ENDIF
    IF (KVCLIG  >  6) THEN
      Z_GCHSS(J_LON)=PGCHSS(JLON)
      Z_GEVAP(J_LON)=PGEVAP(JLON)
      Z_GICFR(J_LON)=PGICFR(JLON)
      Z_GIRUP(J_LON)=PGIRUP(JLON)
      Z_GSOUP(J_LON)=PGSOUP(JLON)
      Z_GTAUX(J_LON)=PGTAUX(JLON)
      Z_GTAUY(J_LON)=PGTAUY(JLON)
    ENDIF
    DO JSGST=1,KSGST
      Z_SGST(J_LON,JSGST)=PSGST(JLON,JSGST)
    ENDDO
    DO JNEBH=1,KNEBH
      Z_NEBH(J_LON,JNEBH)=PNEBH(JLON,JNEBH)
    ENDDO
    Z_ALBNS(J_LON)=PALBNS(JLON)
    Z_RHONS(J_LON)=PRHONS(JLON)
    Z_WL(J_LON)=PWL(JLON)
    Z_HV(J_LON)=PHV(JLON)
    Z_CLON(J_LON)=PCLON(JLON)
    Z_SLON(J_LON)=PSLON(JLON)
    Z_ALBSF(J_LON)=PALBSF(JLON)
    Z_GETRL(J_LON)=PGETRL(JLON)
    Z_GZ0RLF(J_LON)=PGZ0RLF(JLON)
    Z_VRLAN(J_LON)=PVRLAN(JLON)
    Z_VRLDI(J_LON)=PVRLDI(JLON)
    Z_MU0(J_LON)=PMU0(JLON)
    Z_MU0LU(J_LON)=PMU0LU(JLON)
    Z_MU0M(J_LON)=PMU0M(JLON)
    Z_GEMU(J_LON)=PGEMU(JLON)
    Z_GM(J_LON)=PGM(JLON)
!          Z_D2(J_LON)=PD2(JLON)
!          Z_IVEG(J_LON)=PIVEG(JLON)
!          Z_LAI(J_LON)=PLAI(JLON)
!          Z_GZ0H(J_LON)=PGZ0H(JLON)
!          Z_SNS(J_LON)=PSNS(JLON)
!          Z_TS(J_LON)=PTS(JLON)
!          Z_WP(J_LON)=PWP(JLON)
!          Z_WS(J_LON)=PWS(JLON)
!          Z_TC(J_LON)=PTC(JLON)
!          Z_WC(J_LON)=PWC(JLON)
!          Z_ALBF(J_LON)=PALBF(JLON)
!          Z_LSM(J_LON)=PLSM(JLON)
!          Z_VEG0(J_LON)=PVEG0(JLON)
!          Z_GZ0F(J_LON)=PGZ0F(JLON)
!          Z_EMISF(J_LON)=PEMISF(JLON)
!          DO JCSS=1,KCSS
!            Z_TP(J_LON,JCSS)=PTP(JLON,JCSS)
!          ENDDO

!***************************************************************
!     CONDITIONS AUX LIMITES OCEANIQUES FIXES
!***************************************************************

    IF (PTSOC(JLON) > TMERGL)THEN
!            Sea
      Z_LSM(J_LON)=0.0_JPRB
      Z_GZ0F(J_LON)=RZ0MER*RG
      Z_ALBF(J_LON)=ALBMER
      Z_EMISF(J_LON)=EMMMER
      Z_TS(J_LON)=PTSOC(JLON)
      Z_WS(J_LON)=ZWXSUR
      Z_WP(J_LON)=ZWXMER
      Z_WI(J_LON)=0.0_JPRB
      Z_WSI(J_LON)=0.0_JPRB
      Z_FGEL(J_LON)=0.0_JPRB
      Z_FGELS(J_LON)=0.0_JPRB
      Z_SNS(J_LON)=0.0_JPRB
      Z_TC(J_LON)=PTSOC(JLON)
      Z_WC(J_LON)=WPMX
      DO JCSS=1,KCSS
        Z_TP(J_LON,JCSS)=Z_TS(J_LON)
      ENDDO
      IF (LSOLV) THEN
        Z_IVEG(J_LON)=REAL(NTVMER,JPRB)
        Z_D2(J_LON)=RD2MER
        Z_LAI(J_LON)=0.0_JPRB
        Z_VEG0(J_LON)=0.0_JPRB
        Z_GZ0H(J_LON)=RZHZ0M*RZ0MER*RG
      ENDIF
    ELSE
!            Sea Ice
      IF (LMCC02) THEN
        Z_LSM(J_LON)=1.0_JPRB
      ENDIF
      Z_GZ0F(J_LON)=RZ0GLA*RG
      Z_ALBF(J_LON)=ALBGLA
      Z_EMISF(J_LON)=EMMGLA
      Z_TS(J_LON)=PTSOC(JLON)
      Z_WS(J_LON)=ZWXSUR
      Z_WP(J_LON)=ZWXGLA
      Z_WI(J_LON)=ZWXGLA
      Z_WSI(J_LON)=ZWXGLA
      Z_SNS(J_LON)=PSNS(JLON)
      Z_TC(J_LON)=TMERGL
      Z_WC(J_LON)=WPMX
      DO JCSS=1,KCSS
        Z_TP(J_LON,JCSS)=Z_TS(J_LON)
      ENDDO
      IF (LSOLV) THEN
        Z_IVEG(J_LON)=REAL(NTVGLA,JPRB)+.1_JPRB
        Z_D2(J_LON)=RD2GLA
        Z_LAI(J_LON)=0.0_JPRB
        Z_VEG0(J_LON)=0.0_JPRB
        Z_GZ0H(J_LON)=RZHZ0G*RZ0GLA*RG
      ENDIF
    ENDIF
  ENDIF
ENDDO

DO JWORK=1,KWORK
  Z_WORK(JWORK)=PWORK(JWORK)
ENDDO

I_FDIA=J_LON

!***************************************************************
!     APPEL DES DEUX PHYSIQUES
!***************************************************************

IF (I_IDIA <= I_FDIA) THEN
  CALL ABOR1('APL2PHY : CALL TO APLPAR BROKEN-1/MH')
!!$  CALL APLPAR(I_IDIA , I_FDIA , NPROMC ,&
!!$   &KTDIA  , KLEV    , KPOSI  , KGL1   , KGL2   , KVCLIA ,&
!!$   &KVCLIG , KVCLIS  , KVCLIV , KNEBH  , KSTART , KSTEP  ,&
!!$   &KSGST  , KCSS    , &
!!$   &Z_APHI , Z_APRS  , Z_APHIF, Z_APRSF, Z_ALPH , Z_ARG  , Z_D2   ,&
!!$   &Z_DELP , Z_IVEG  , Z_LAI  , Z_LNPR , Z_RDELP, Z_RSMIN, Z_SAB  ,&
!!$   &Z_GZ0H , Z_AESEA , Z_AELAN, Z_AEURB, Z_AEDES, PRCORI ,&
!!$   &Z_GCHSS, Z_GEVAP , Z_GICFR, Z_GIRUP, Z_GSOUP, Z_GTAUX, Z_GTAUY,&
!!$   &Z_U    , Z_V     , Z_T    , Z_Q    , Z_QI   , Z_QL   , Z_O3   ,&
!!$   &Z_CP   , Z_CVGQ  , Z_R    , Z_KOZO , Z_SGST , Z_NEBH ,&
!!$   &Z_SNS  , Z_ALBNS , Z_RHONS,&
!!$   &Z_TP   , Z_TS    , Z_WL   , Z_WP   , Z_WI   ,Z_WS   , Z_WSI   ,&
!!$   &Z_HV    ,Z_TC   ,&
!!$   &Z_WC   , Z_VERVEL, Z_EMTD , Z_EMTU , Z_TRSO , Z_CLON , Z_SLON ,&
!!$   &Z_ALBF , Z_ALBSF , Z_EMISF, Z_GETRL, Z_LSM  , Z_VEG0 ,&
!!$   &Z_GZ0F , Z_GZ0RLF, Z_VRLAN,&
!!$   &Z_VRLDI, Z_MU0   , Z_MU0LU , Z_MU0M , Z_GEMU , Z_WORK , Z_GM   ,&
!!$   &POMPAC , PAC    , PCOR    , PMMU0  , PDHSF  ,&
!!$   &PRAB3C , PRAB3N , PRAB4C , PRAB4N , PRAB6C , PRAB6N ,&
!!$   &PRAT1C , PRAT1N , PRAT2C , PRAT2N , PRAT3C , PRAT3N ,&
!!$   &PRAT4C , PRAT4N , PRAT5C , PRAT5N,&
!!$   &Z_DIFCQ ,Z_DIFCQN ,Z_DIFCQL,Z_DIFCS ,Z_DIFTQ ,Z_DIFTQN,&
!!$   &Z_DIFTQL,&
!!$   &Z_DIFTS ,Z_FCCQL  ,Z_FCCQN ,Z_FCSQL ,Z_FCSQN ,Z_FCQNG ,&
!!$   &Z_FCQNNG,&
!!$   &Z_FCQLNG,Z_FPLCL  ,Z_FPLCN ,Z_FPLSL ,Z_FPLSN ,Z_FRSO  ,&
!!$   &Z_FRSOC ,&
!!$   &Z_FRTH  ,Z_FRTHC  ,Z_STRCU ,Z_STRCV ,Z_STRDU ,Z_STRDV ,&
!!$   &Z_STRTU ,&
!!$   &Z_STRTV ,Z_STRMU  ,Z_STRMV ,Z_FRMH  ,Z_FCHOZ ,Z_CPS   ,&
!!$   &Z_LHS   ,&
!!$   &Z_RS    ,Z_LH     ,Z_LSCPE ,Z_NEB   ,Z_QICE  ,Z_QLI   ,&
!!$   &Z_QSAT  ,&
!!$   &Z_QW    ,Z_RH     ,Z_TW    ,Z_ALB   ,Z_CD    ,Z_CDN   ,&
!!$   &Z_CH    ,&
!!$   &Z_C1    ,Z_C2     ,Z_CT    ,Z_EMIS  ,Z_FCHSP ,Z_FCLL  ,&
!!$   &Z_FCLN  ,&
!!$   &Z_FCS   ,Z_FEVI   ,Z_FEVL   ,Z_FEVN  ,Z_FEVV  ,Z_FTR   ,&
!!$   &Z_FLWSP ,&
!!$   &Z_FONTE , Z_FGEL   ,Z_FGELS ,&
!!$   &Z_FRSODS,Z_FRSOPS ,Z_FRSOPT,Z_FRSOLU,Z_FRTHDS,Z_GZ0   ,Z_NEIJ  ,&
!!$   &Z_VEG   ,&
!!$   &Z_QS    ,&
!!$   &Z_QSATS ,Z_RUISL  ,Z_RUISP ,Z_RUISS ,Z_UCLS  ,Z_VCLS  ,&
!!$   &Z_TCLS  ,&
!!$   &Z_QCLS  ,Z_RHCLS  ,Z_CLCT  ,Z_CLCH  ,Z_CLCM  ,Z_CLCL  ,&
!!$   &Z_CLCC  ,Z_CAPE   ,J_CLPH ,Z_GCLP  ,Z_UGST  ,Z_VGST  ,&
!!$   &'APLPAR')
ENDIF

CALL ABOR1('APL2PHY : CALL TO APLPAR BROKEN-2/MH')
!!$CALL APLPAR( KIDIA , KFDIA  , NPROMA ,&
!!$ &KTDIA  , KLEV    , KPOSI  , KGL1   , KGL2   , KVCLIA ,&
!!$ &KVCLIG , KVCLIS  , KVCLIV , KNEBH  , KSTART , KSTEP  ,&
!!$ &KSGST  , KCSS    , &
!!$ &PAPHI , PAPRS  , PAPHIF, PAPRSF, PALPH , PARG  , PD2   ,&
!!$ &PDELP , PIVEG  , PLAI  , PLNPR , PRDELP, PRSMIN, PSAB  ,&
!!$ &PGZ0H , PAESEA , PAELAN, PAEURB, PAEDES, PRCORI,&
!!$ &PGCHSS, PGEVAP , PGICFR, PGIRUP, PGSOUP, PGTAUX, PGTAUY,&
!!$ &PU    , PV     , PT    , PQ    , PQI   , PQL   , PO3   ,&
!!$ &PCP   , PCVGQ  , PR    , PKOZO , PSGST , PNEBH ,&
!!$ &PSNS  , PALBNS , PRHONS,&
!!$ &PTP   , PTS    , PWL   , PWP   , PWPI  ,PWS    , PWSI  ,&
!!$ &PHV   , PTC   ,&
!!$ &PWC   , PVERVEL, PEMTD , PEMTU , PTRSO , PCLON , PSLON ,&
!!$ &PALBF , PALBSF , PEMISF, PGETRL, PLSM  , PVEG0 ,&
!!$ &PGZ0F , PGZ0RLF, PVRLAN,&
!!$ &PVRLDI, PMU0 , PMU0LU  , PMU0M , PGEMU , PWORK , PGM   ,&
!!$ &POMPAC , PAC    , PCOR   , PMMU0  , PDHSF  ,&
!!$ &PRAB3C , PRAB3N , PRAB4C , PRAB4N , PRAB6C , PRAB6N ,&
!!$ &PRAT1C , PRAT1N , PRAT2C , PRAT2N , PRAT3C , PRAT3N ,&
!!$ &PRAT4C , PRAT4N , PRAT5C , PRAT5N,&
!!$ &PDIFCQ ,PDIFCQN ,PDIFCQL,PDIFCS ,PDIFTQ ,PDIFTQN,PDIFTQL,&
!!$ &PDIFTS ,PFCCQL  ,PFCCQN ,PFCSQL ,PFCSQN ,PFCQNG ,PFCQNNG,&
!!$ &PFCQLNG,PFPLCL  ,PFPLCN ,PFPLSL ,PFPLSN ,PFRSO  ,PFRSOC ,&
!!$ &PFRTH  ,PFRTHC  ,PSTRCU ,PSTRCV ,PSTRDU ,PSTRDV ,PSTRTU ,&
!!$ &PSTRTV ,PSTRMU  ,PSTRMV ,PFRMH  ,PFCHOZ ,PCPS   ,PLHS   ,&
!!$ &PRS    ,PLH     ,PLSCPE ,PNEB   ,PQICE  ,PQLI   ,PQSAT  ,&
!!$ &PQW    ,PRH     ,PTW    ,PALB   ,PCD    ,PCDN   ,PCH    ,&
!!$ &PC1    ,PC2     ,PCT    ,PEMIS  ,PFCHSP ,PFCLL  ,PFCLN  ,&
!!$ &PFCS   ,PFEVI   ,PFEVL   ,PFEVN  ,PFEVV  ,PFTR   ,PFLWSP,&
!!$ &PFONTE ,PFGEL  ,PFGELS  ,&
!!$ &PFRSODS,PFRSOPS ,PFRSOPT,PFRSOLU,PFRTHDS,PGZ0   ,PNEIJ  ,PVEG   ,&
!!$ &PQS    ,&
!!$ &PQSATS ,PRUISL  ,PRUISP ,PRUISS ,PUCLS  ,PVCLS  ,PTCLS  ,&
!!$ &PQCLS  ,PRHCLS  ,PCLCT  ,PCLCH  ,PCLCM  ,PCLCL  ,PCLCC  ,&
!!$ &PCAPE  ,KCLPH   ,PGCLP  ,PUGST  ,PVGST  ,&
!!$ &'APLPAR')

!***************************************************************
!    CORRECTION OF RADIATIVE FLUX
!***************************************************************

DO JF=I_IDIA,I_FDIA
  JK=I_TAB(JF)
  Z1=PLAND(JK)
  Z2=1.0_JPRB-Z1
  DO JI=1,KSGST+1
    ZSWTOT=Z1*PFRSO(JK,KLEV,JI)+Z2*Z_FRSO(JF,KLEV,JI)
    ZLWTOT=Z1*PFRTH(JK,KLEV,JI)+Z2*Z_FRTH(JF,KLEV,JI)
    ZA=1-PALB(JK)
    ZB=1-Z_ALB(JF)
    PFRSO(JK,KLEV,JI)=ZSWTOT/(Z1*ZA+Z2*ZB)*ZA
    Z_FRSO(JF,KLEV,JI)=ZSWTOT/(Z1*ZA+Z2*ZB)*ZB
    ZA=PEMIS(JK)*PTS(JK)**4
    ZB=Z_EMIS(JF)*Z_TS(JF)**4
    PFRTH(JK,KLEV,JI)=ZLWTOT/(Z1*ZA+Z2*ZB)*ZA
    Z_FRTH(JF,KLEV,JI)=ZLWTOT/(Z1*ZA+Z2*ZB)*ZB
  ENDDO
ENDDO

!***************************************************************
!    COPY OF LAND SUFACE VALUES
!***************************************************************

DO JK=KIDIA,KFDIA
  DO JL=0,KLEV
    P1FPLCL(JK,JL)=PFPLCL(JK,JL)
    P1FPLCN(JK,JL)=PFPLCN(JK,JL)
    P1FPLSL(JK,JL)=PFPLSL(JK,JL)
    P1FPLSN(JK,JL)=PFPLSN(JK,JL)
  ENDDO
  DO JI=1,KSGST+1
    DO JL=0,KLEV
      P1FRSO(JK,JL,JI)=PFRSO(JK,JL,JI)
      P1FRTH(JK,JL,JI)=PFRTH(JK,JL,JI)
    ENDDO
  ENDDO
  DO JL=1,KCSS
    P1FCHSP(JK,JL)=PFCHSP(JK,JL)
  ENDDO
  DO JI=1,KSGST+1
    P1FCLL(JK,JI)=PFCLL(JK,JI)
    P1FCLN(JK,JI)=PFCLN(JK,JI)
    P1FCS(JK,JI)=PFCS(JK,JI)
    P1FEVI(JK,JI)=PFEVI(JK,JI)
    P1FEVL(JK,JI)=PFEVL(JK,JI)
    P1FEVN(JK,JI)=PFEVN(JK,JI)
  ENDDO
  P1C1(JK)=PC1(JK)
  P1C2(JK)=PC2(JK)
  P1CT(JK)=PCT(JK)
  P1FEVV(JK)=PFEVV(JK)
  P1FTR(JK)=PFTR(JK)
  P1FLWSP(JK)=PFLWSP(JK)
  P1FONTE(JK)=PFONTE(JK)
  P1FGEL(JK)=PFGEL(JK)
  P1FGELS(JK)=PFGELS(JK)
  P1VEG(JK)=PVEG(JK)
  P1RUISL(JK)=PRUISL(JK)
  P1RUISP(JK)=PRUISP(JK)
  P1RUISS(JK)=PRUISS(JK)
ENDDO

!***************************************************************
!    COPY OF SEA VALUES
!***************************************************************

DO JK=KIDIA,KFDIA
  P2FPLCL(JK)=PFPLCL(JK,KLEV)
  P2FPLCN(JK)=PFPLCN(JK,KLEV)
  P2FPLSL(JK)=PFPLSL(JK,KLEV)
  P2FPLSN(JK)=PFPLSN(JK,KLEV)
  P2STRDU(JK)=PSTRDU(JK,KLEV)
  P2STRDV(JK)=PSTRDV(JK,KLEV)
  P2STRTU(JK)=PSTRTU(JK,KLEV)
  P2STRTV(JK)=PSTRTV(JK,KLEV)
  P2FRTHDS(JK)=PFRTHDS(JK)
  P2RUISP(JK)=PRUISP(JK)
  P2RUISS(JK)=PRUISS(JK)
  P2TCLS(JK)=PTCLS(JK)
  DO JI=1,KSGST+1
    P2FRSO(JK,JI)=PFRSO(JK,KLEV,JI)
    P2FRTH(JK,JI)=PFRTH(JK,KLEV,JI)
    P2FCLL(JK,JI)=PFCLL(JK,JI)
    P2FCLN(JK,JI)=PFCLN(JK,JI)
    P2FCS(JK,JI)=PFCS(JK,JI)
    P2FEVL(JK,JI)=PFEVL(JK,JI)
    P2FEVN(JK,JI)=PFEVN(JK,JI)
  ENDDO
ENDDO

!***************************************************************
!    COPY OF SEA VALUES OF MIX POINTS FOR COUPLING
!***************************************************************

DO JF=I_IDIA,I_FDIA
  JK=I_TAB(JF)
  P2FPLCL(JK)=Z_FPLCL(JF,KLEV)
  P2FPLCN(JK)=Z_FPLCN(JF,KLEV)
  P2FPLSL(JK)=Z_FPLSL(JF,KLEV)
  P2FPLSN(JK)=Z_FPLSN(JF,KLEV)
  P2STRDU(JK)=Z_STRDU(JF,KLEV)
  P2STRDV(JK)=Z_STRDV(JF,KLEV)
  P2STRTU(JK)=Z_STRTU(JF,KLEV)
  P2STRTV(JK)=Z_STRTV(JF,KLEV)
  P2FRTHDS(JK)=Z_FRTHDS(JF)
  P2RUISP(JK)=Z_RUISP(JF)
  P2RUISS(JK)=Z_RUISS(JF)
  P2TCLS(JK)=Z_TCLS(JF)
  DO JI=1,KSGST+1
    P2FRSO(JK,JI)=Z_FRSO(JF,KLEV,JI)
    P2FRTH(JK,JI)=Z_FRTH(JF,KLEV,JI)
    P2FCLL(JK,JI)=Z_FCLL(JF,JI)
    P2FCLN(JK,JI)=Z_FCLN(JF,JI)
    P2FCS(JK,JI)=Z_FCS(JF,JI)
    P2FEVL(JK,JI)=Z_FEVL(JF,JI)
    P2FEVN(JK,JI)=Z_FEVN(JF,JI)
  ENDDO
ENDDO

!***************************************************************
!    LINEAR COMBINATION
!***************************************************************

DO JF=I_IDIA,I_FDIA
  JK=I_TAB(JF)
  Z1=PLAND(JK)
  Z2=1-Z1
  DO JL=1,KLEV
    PLH(JK,JL)=Z1*PLH(JK,JL)+Z2*Z_LH(JF,JL)
    PLSCPE(JK,JL)=Z1*PLSCPE(JK,JL)+Z2*Z_LSCPE(JF,JL)
    PNEB(JK,JL)=Z1*PNEB(JK,JL)+Z2*Z_NEB(JF,JL)
    PQICE(JK,JL)=Z1*PQICE(JK,JL)+Z2*Z_QICE(JF,JL)
    PQLI(JK,JL)=Z1*PQLI(JK,JL)+Z2*Z_QLI(JF,JL)
    PQSAT(JK,JL)=Z1*PQSAT(JK,JL)+Z2*Z_QSAT(JF,JL)
    PQW(JK,JL)=Z1*PQW(JK,JL)+Z2*Z_QW(JF,JL)
    PRH(JK,JL)=Z1*PRH(JK,JL)+Z2*Z_RH(JF,JL)
    PTW(JK,JL)=Z1*PTW(JK,JL)+Z2*Z_TW(JF,JL)
  ENDDO
  DO JL=1,KNEBH
    PNEBH(JK,JL)=Z1*PNEBH(JK,JL)+Z2*Z_NEBH(JF,JL)
  ENDDO
  DO JL=1,KCSS
    PFCHSP(JK,JL)=Z1*PFCHSP(JK,JL)+Z2*Z_FCHSP(JF,JL)
  ENDDO
  DO JL=0,1
    PFRSOC(JK,JL)=Z1*PFRSOC(JK,JL)+Z2*Z_FRSOC(JF,JL)
    PFRTHC(JK,JL)=Z1*PFRTHC(JK,JL)+Z2*Z_FRTHC(JF,JL)
  ENDDO
  DO JL=0,KLEV
    PDIFCQ(JK,JL)=Z1*PDIFCQ(JK,JL)+Z2*Z_DIFCQ(JF,JL)
    PDIFCQL(JK,JL)=Z1*PDIFCQL(JK,JL)+Z2*Z_DIFCQL(JF,JL)
    PDIFCQN(JK,JL)=Z1*PDIFCQN(JK,JL)+Z2*Z_DIFCQN(JF,JL)
    PDIFCS(JK,JL)=Z1*PDIFCS(JK,JL)+Z2*Z_DIFCS(JF,JL)
    PDIFTQ(JK,JL)=Z1*PDIFTQ(JK,JL)+Z2*Z_DIFTQ(JF,JL)
    PDIFTQL(JK,JL)=Z1*PDIFTQL(JK,JL)+Z2*Z_DIFTQL(JF,JL)
    PDIFTQN(JK,JL)=Z1*PDIFTQN(JK,JL)+Z2*Z_DIFTQN(JF,JL)
    PDIFTS(JK,JL)=Z1*PDIFTS(JK,JL)+Z2*Z_DIFTS(JF,JL)
    PFCCQL(JK,JL)=Z1*PFCCQL(JK,JL)+Z2*Z_FCCQL(JF,JL)
    PFCCQN(JK,JL)=Z1*PFCCQN(JK,JL)+Z2*Z_FCCQN(JF,JL)
    PFCHOZ(JK,JL)=Z1*PFCHOZ(JK,JL)+Z2*Z_FCHOZ(JF,JL)
    PFCQLNG(JK,JL)=Z1*PFCQLNG(JK,JL)+Z2*Z_FCQLNG(JF,JL)
    PFCQNG(JK,JL)=Z1*PFCQNG(JK,JL)+Z2*Z_FCQNG(JF,JL)
    PFCQNNG(JK,JL)=Z1*PFCQNNG(JK,JL)+Z2*Z_FCQNNG(JF,JL)
    PFCSQL(JK,JL)=Z1*PFCSQL(JK,JL)+Z2*Z_FCSQL(JF,JL)
    PFCSQN(JK,JL)=Z1*PFCSQN(JK,JL)+Z2*Z_FCSQN(JF,JL)
    PFPLCL(JK,JL)=Z1*PFPLCL(JK,JL)+Z2*Z_FPLCL(JF,JL)
    PFPLCN(JK,JL)=Z1*PFPLCN(JK,JL)+Z2*Z_FPLCN(JF,JL)
    PFPLSL(JK,JL)=Z1*PFPLSL(JK,JL)+Z2*Z_FPLSL(JF,JL)
    PFPLSN(JK,JL)=Z1*PFPLSN(JK,JL)+Z2*Z_FPLSN(JF,JL)
    PFRMH(JK,JL)=Z1*PFRMH(JK,JL)+Z2*Z_FRMH(JF,JL)
    PSTRCU(JK,JL)=Z1*PSTRCU(JK,JL)+Z2*Z_STRCU(JF,JL)
    PSTRCV(JK,JL)=Z1*PSTRCV(JK,JL)+Z2*Z_STRCV(JF,JL)
    PSTRDU(JK,JL)=Z1*PSTRDU(JK,JL)+Z2*Z_STRDU(JF,JL)
    PSTRDV(JK,JL)=Z1*PSTRDV(JK,JL)+Z2*Z_STRDV(JF,JL)
    PSTRMU(JK,JL)=Z1*PSTRMU(JK,JL)+Z2*Z_STRMU(JF,JL)
    PSTRMV(JK,JL)=Z1*PSTRMV(JK,JL)+Z2*Z_STRMV(JF,JL)
    PSTRTU(JK,JL)=Z1*PSTRTU(JK,JL)+Z2*Z_STRTU(JF,JL)
    PSTRTV(JK,JL)=Z1*PSTRTV(JK,JL)+Z2*Z_STRTV(JF,JL)
  ENDDO
  IF (LRAYFM.OR.LRAYFM15) THEN
    DO JL=0,KLEV
      PEMTD(JK,JL)=Z1*PEMTD(JK,JL)+Z2*Z_EMTD(JF,JL)
      PEMTU(JK,JL)=Z1*PEMTU(JK,JL)+Z2*Z_EMTU(JF,JL)
      PTRSO(JK,JL)=Z1*PTRSO(JK,JL)+Z2*Z_TRSO(JF,JL)
    ENDDO
  ENDIF
  PC1(JK)=Z1*PC1(JK)+Z2*Z_C1(JF)
  PC2(JK)=Z1*PC2(JK)+Z2*Z_C2(JF)
  PCD(JK)=Z1*PCD(JK)+Z2*Z_CD(JF)
  PCDN(JK)=Z1*PCDN(JK)+Z2*Z_CDN(JF)
  PCH(JK)=Z1*PCH(JK)+Z2*Z_CH(JF)
  PCLCC(JK)=Z1*PCLCC(JK)+Z2*Z_CLCC(JF)
  PCLCH(JK)=Z1*PCLCH(JK)+Z2*Z_CLCH(JF)
  PCLCL(JK)=Z1*PCLCL(JK)+Z2*Z_CLCL(JF)
  PCLCM(JK)=Z1*PCLCM(JK)+Z2*Z_CLCM(JF)
  PCLCT(JK)=Z1*PCLCT(JK)+Z2*Z_CLCT(JF)
  PCPS(JK)=Z1*PCPS(JK)+Z2*Z_CPS(JF)
  PCT(JK)=Z1*PCT(JK)+Z2*Z_CT(JF)
  PFEVV(JK)=Z1*PFEVV(JK)+Z2*Z_FEVV(JF)
  PFLWSP(JK)=Z1*PFLWSP(JK)+Z2*Z_FLWSP(JF)
  PFONTE(JK)=Z1*PFONTE(JK)+Z2*Z_FONTE(JF)
  PFGEL(JK)=Z1*PFGEL(JK)+Z2*Z_FGEL(JF)
  PFGELS(JK)=Z1*PFGELS(JK)+Z2*Z_FGELS(JF)
  PFRSODS(JK)=Z1*PFRSODS(JK)+Z2*Z_FRSODS(JF)
  PFRSOPS(JK)=Z1*PFRSOPS(JK)+Z2*Z_FRSOPS(JF)
  PFRSOPT(JK)=Z1*PFRSOPT(JK)+Z2*Z_FRSOPT(JF)
  PFRSOLU(JK)=Z1*PFRSOLU(JK)+Z2*Z_FRSOLU(JF)
  PFRTHDS(JK)=Z1*PFRTHDS(JK)+Z2*Z_FRTHDS(JF)
  PFTR(JK)=Z1*PFTR(JK)+Z2*Z_FTR(JF)
  PLHS(JK)=Z1*PLHS(JK)+Z2*Z_LHS(JF)
  PQCLS(JK)=Z1*PQCLS(JK)+Z2*Z_QCLS(JF)
  PQS(JK)=Z1*PQS(JK)+Z2*Z_QS(JF)
  PQSATS(JK)=Z1*PQSATS(JK)+Z2*Z_QSATS(JF)
  PRHCLS(JK)=Z1*PRHCLS(JK)+Z2*Z_RHCLS(JF)
  PRS(JK)=Z1*PRS(JK)+Z2*Z_RS(JF)
  PRUISL(JK)=Z1*PRUISL(JK)+Z2*Z_RUISL(JF)
  PRUISP(JK)=Z1*PRUISP(JK)+Z2*Z_RUISP(JF)
  PRUISS(JK)=Z1*PRUISS(JK)+Z2*Z_RUISS(JF)
  PTCLS(JK)=Z1*PTCLS(JK)+Z2*Z_TCLS(JF)
  PUCLS(JK)=Z1*PUCLS(JK)+Z2*Z_UCLS(JF)
  PVCLS(JK)=Z1*PVCLS(JK)+Z2*Z_VCLS(JF)
!        PNEIJ(JK)=Z1*PNEIJ(JK)+Z2*Z_NEIJ(JF)
!        PHV(JK)=Z1*PHV(JK)+CZ2*Z_HV(JF)
!        PGZ0(JK)=Z1*PGZ0(JK)+Z2*Z_GZ0(JF)
!        PEMIS(JK)=Z1*PEMIS(JK)+Z2*Z_EMIS(JF)
!        PALB(JK)=Z1*PALB(JK)+Z2*Z_ALB(JF)
!        PVEG(JK)=Z1*PVEG(JK)+Z2*Z_VEG(JF)
  DO JI=1,KSGST+1
    DO JL=0,KLEV
      PFRSO(JK,JL,JI)=Z1*PFRSO(JK,JL,JI)+Z2*Z_FRSO(JF,JL,JI)
      PFRTH(JK,JL,JI)=Z1*PFRTH(JK,JL,JI)+Z2*Z_FRTH(JF,JL,JI)
    ENDDO
    PFCLL(JK,JI)=Z1*PFCLL(JK,JI)+Z2*Z_FCLL(JF,JI)
    PFCLN(JK,JI)=Z1*PFCLN(JK,JI)+Z2*Z_FCLN(JF,JI)
    PFCS(JK,JI)=Z1*PFCS(JK,JI)+Z2*Z_FCS(JF,JI)
    PFEVL(JK,JI)=Z1*PFEVL(JK,JI)+Z2*Z_FEVL(JF,JI)
    PFEVN(JK,JI)=Z1*PFEVN(JK,JI)+Z2*Z_FEVN(JF,JI)
  ENDDO
ENDDO

! -----------------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('APL2PHY',1,ZHOOK_HANDLE)
END SUBROUTINE APL2PHY
