!OPTIONS XOPT(NOEVAL)
SUBROUTINE ECRADFR15

!**** *ECRADFR15*   - MODIFY FREQUENCY OF FULL-RADIATION COMPUTATIONS
!****                 FROZEN VERSION (CYCLE 15) OF ECRADFR

!     PURPOSE.
!     --------

!**   INTERFACE.
!     ----------
!        CALL *ECRADFR15* FROM *CNT4*
!              -------        ----

!        EXPLICIT ARGUMENTS :
!        --------------------
!        NONE

!        IMPLICIT ARGUMENTS :
!        --------------------
!        COMMONS YOMDIM, YOMCT3, YOMRAD15

!     METHOD.
!     -------
!        SEE DOCUMENTATION

!     EXTERNALS.
!     ----------
!        NONE

!     REFERENCE.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     AUTHOR.
!     -------
!        96-11: Ph. Dandin. Meteo-France
!        ORIGINAL : 92-11-25 BY JEAN-JACQUES MORCRETTE  *ECMWF*

!     MODIFICATIONS.
!     --------------
!        M.Hamrud      01-Oct-2003 CY28 Cleaning

!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMDIM   , ONLY : NSMAX
USE YOMCT3   , ONLY : NSTEP
USE YOMRAD15 , ONLY : NRADFR15 ,NRADNFR15,NRADSFR15,LERAD6H15
USE YOMDYN   , ONLY : TSTEP

IMPLICIT NONE

!      ----------------------------------------------------------------

REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "updtier15.intfb.h"
IF (LHOOK) CALL DR_HOOK('ECRADFR15',0,ZHOOK_HANDLE)
IF (NSMAX >= 63.AND. LERAD6H15) THEN
  IF (NSTEP*TSTEP < 6._JPRB*3600._JPRB) THEN
    NRADFR15=NRADSFR15
  ELSE
    NRADFR15=NRADNFR15
  ENDIF
ENDIF

CALL UPDTIER15 ( NSTEP,NRADFR15,TSTEP )

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('ECRADFR15',1,ZHOOK_HANDLE)
END SUBROUTINE ECRADFR15
