!OPTIONS XOPT(NOEVAL)
SUBROUTINE HL_APLPAR ( KIDIA , KFDIA  , KLON ,&
 & KTDIA  , KLEV   ,&
 & KVCLIS , KVCLIV ,&
 & KSTEP  ,&
 & KSGST  , KCSS   ,&
 & KBL    , KGPCOMP,&
 & PVERVEL ,&
 !---------------------------------------------------------------------
 ! - INPUT .
 & PAPHI  , PAPRS  , PAPHIF , PAPRSF , PALPH  , PARG   , PD2    ,&
 & PDELP  , PIVEG  , PLAI   , PLNPR  , PRDELP , PRSMIN , PSAB   ,&
 & PGZ0HF , PRCORI ,&
 & PU     , PV     , PT     , PQ     , PQI    , PQL    ,&
 & PS     , PRR    , PTKE   , PCVV ,&
 & PA     , PQVA   , &  
 & PO3    , &
 & PCP    , PCVGQ  , PCVGQL , PCVGQI , PCVGT  , PR     ,PKOZO  ,&
 & PFPLCH , PFPLSH ,&
 & PTENDU , PTENDV , PTENDT , PTENDTKE, PTENDQ , PTENDQL, PTENDQI,&
 & PTENDH , &
 & PENTCH , PUNEBH ,&
 & PTCCH  , PSCCH  , PBCCH  , PFHPS  ,&
 & PPBLH  ,&
 & PGPAR  ,&
 & PSNS   , PALBNS , PRHONS ,&
 & PTP    , PTS    , PWL    , PWP    , PWPI   , PWS    , PWSI   ,&
 & PHV    ,&
 & PALV   , PALBF  , PALBSF , PEMISF , PGETRL ,&
 & PLSM   , PVEG0  ,&
 & PGZ0F  , PGZ0RLF, PVRLAN ,&
 & PVRLDI , PVO3ABC, PMU0   , PGELAM , &
 & PGEMU  , &
 & POROG  , & 
 ! - OUTPUT .
 & PDIFCQ , PDIFCQI, PDIFCQL, PDIFCS , PDIFTQ , PDIFTQI, PDIFTQL,&
 & PDIFTS , PFCCQL , PFCCQN , PFCSQL , PFCSQN , &
 & PFPLCL , PFPLCN , PFPLSL , PFPLSN , PFRSO  , &
 & PFRTH  , PSTRCU , PSTRCV , PSTRDU , PSTRDV , PSTRTU ,&
 & PSTRTV , PSTRMU , PSTRMV , PFRMH  , PFRMQ  ,&
 & PFCHOZ , PCPS   , PLHS   ,&
 & PRS    , PLH    , PLSCPE , PNEB   , PQICE  , PQLI   , PQSAT  ,&
 & PQW    , PRH    , PTW    , PALB   , PCD    , PCDN   , PCH    ,&
 & PC1    , PC2    , PCT    , PEMIS  , PFCHSP , PFCLL  , PFCLN  ,&
 & PFCS   , PFEVI  , PFEVL  , PFEVN  , PFEVV  , PFTR   , PFLWSP ,&
 & PFONTE , PALBH  ,&
 & PFGEL  , PFGELS , PFRSODS, PFRSOPT, PFRTHDS,&
 & PFTKE  , PGZ0   , PGZ0H  , PNEIJ  , PVEG   , PQS    ,&
 & PQSATS , PRUISL , PRUISP , PRUISS , PUCLS  , PVCLS  , PTCLS  ,&
 & PQCLS  , PRHCLS , PCLCT  , PCLCH  , PCLCM  , PCLCL  , &
 & KCLPH  , PCLPH  , PUGST  , PVGST  ,&
 & PTENDPTKE,&
 & PDERNSHF, & 
 ! - LOCK ARGUMENTS .
 & CDLOCK)  

!**** *HL_APLPAR * - APPEL DES PARAMETRISATIONS PHYSIQUES.

!     Sujet.
!     ------
!     - APPEL DES SOUS-PROGRAMMES DE PARAMETRISATION
!       INTERFACE AVEC LES PARAMETRISATIONS PHYSIQUES (IALPP).
!     - CALL THE SUBROUTINES OF THE E.C.M.W.F. PHYSICS PACKAGE.

!**   Interface.
!     ----------
!        *CALL* *HL_APLPAR*

!-----------------------------------------------------------------------

! -   ARGUMENTS D'ENTREE.
! -   INPUT ARGUMENTS.
!     -------------------

! - NOM DES PARAMETRES DE DIMENSIONNEMENT DE LA PHYSIQUE.
! - DIMENSIONS.

! KBL  : NUMERO DE BLOC NPROMA
! KBL  : NPROMA-PACKETS NUMBER
! KGPCOMP : NOMBRE TOTAL DE POINTS DE GRILLE SUR LE DOMAINE
! KGPCOMP : TOTAL GRID POINTS NUMBER IN THE DOMAIN
! KIDIA, KFDIA : BORNES BOUCLES HORIZONTALES   (IST,IEND DANS CPG).
! KIDIA, KFDIA : START/END OF HORIZONTAL LOOP  (IST,IEND IN *CPG*).
! KLON : DIMENSION HORIZONTALE                 (NPROMA DANS CPG).
! KLON : HORIZONTAL DIMENSION                  (NPROMA IN *CPG*).
! KLON: IDEM BUT FOR ARRAYS USED SOLELY BY DMN PHYSICS
! KTDIA : DEBUT BOUCLE VERTICALE DANS LA PHYSIQUE.
! KTDIA : START OF THE VERTICAL LOOP IN THE PHYSICS (IF SOME LEVELS ARE
!                     SKIPPED AT THE TOP OF THE MODEL).
! KLEV : FIN BOUCLE VERTICE ET DIMENSION VERTICALE (NFLEVG DANS CPG).
! KLEV : END OF VERTICAL LOOP AND VERTICAL DIMENSION(NFLEVG IN *CPG*).
! KVCLIS     : NOMBRE DE CHAMPS POUR LA PHOTO-CHIMIE DE L'OZONE.
!                     (NVCLIS DANS CPG).
! KVCLIS     : NUMBER OF FIELDS FOR OZONE PHOTO-CHEMISTRY.
!                     (NVCLIS IN CPG).
! KVCLIV     : NOMBRE DE CHAMPS POUR LA VEGETATION (NVCLIV DANS CPG).
! KVCLIV     : NUMBER OF FIELDS FOR VEGETATION (NVCLIV IN CPG).
! KSGST      : NOMBRE DE TEMPERATURES ET DE FLUX DE SURFACE SOUS-MAILLE
!                     (NTSSG DANS CPG)
! KSGST      : NUMBER OF SUBGRID SURFACE TEMPERATURES AND FLUXES
!                     (NTSSG IN *CPG*)
! KCSS       : NBRE DE NIVEAUX DANS LE SOL PROFOND
! KCSS       : NBR OF VERTICAL LAYERS IN THE DEEP SOIL

! - NOM DES VARIABLES DE LA PHYSIQUE (PAR ORDRE ALPHABETIQUE DANS CHAQUE
!   CATEGORIE).

! - 2D (0:KLEV) .
! PVERVEL    : (OMEGA/P) VERT. VEL. DIVIDED BY PRESSURE.
! PAPHI      : GEOPOTENTIEL AUX DEMI-NIVEAUX.
! PAPHI      : GEOPOTENTIAL ON HALF-LEVELS.
! PAPRS      : PRESSION AUX DEMI-NIVEAUX.
! PAPRS      : PRESSURE ON HALF-LEVELS.

! - 2D (1:KLEV) .

! PAPHIF     : GEOPOTENTIEL AUX NIVEAUX DES COUCHES.
! PAPHIF     : GEOPOTENTIAL ON FULL LEVELS.
! PAPRSF     : PRESSION AUX NIVEAUX DES COUCHES.
! PAPRSF     : PRESSURE ON FULL LEVELS.
! PALPH      : LOG(PAPRS(JLEV)/PAPRSF(JLEV)) (POUR L'HYDROSTATIQUE).
! PALPH      : LOG(PAPRS(JLEV)/PAPRSF(JLEV)) (FOR HYDROSTATICS).
! PDDAL      : FRACTION DE LA MAILLE POUR LE DOWNDRAUGHT
! PDDAL      : DOWNDRAUGHT MESH FRACTION
! PDDOM      : VITESSE VERTICALE DU DOWNDRAUGHT
! PDDOM      : DOWNDRAUGHT VERTICAL VELOCITY
! PDELP      : EPAISSEUR EN PRESSION DE LA COUCHE.
! PDELP      : LAYER THICKNESS IN PRESSURE UNITS.
! PENTCH     : L'ENTRAINMENT PRONOSTIQUE/ PSEUDO HISTORIQUE
! PENTCH     : PROGNOSTIC/ PSEUDO HISTORIC  ENTRAINMENT
! PLNPR      : LOG(PAPRS(JLEV)/PAPRS(JLEV-1)) (POUR L'HYDROSTATIQUE).
! PLNPR      : LOG(PAPRS(JLEV)/PAPRS(JLEV-1)) (FOR HYDROSTATICS).
! PRDELP     : INVERSE DE L'EPAISSEUR EN PRESSION DE LA COUCHE.
! PRDELP     : INVERSE OF PDELP.
! PU         : COMPOSANTE EN X DU VENT.
! PU         : X-COMPONENT OF WIND.
! PUDAL      : FRACTION DE LA MAILLE POUR L'UPDRAUGHT 
! PUDAL      : UPDRAUGHT MESH FRACTION
! PUDOM      : VITESSE VERTICALE DE L'UPDRAUGHT
! PUDOM      : UPDRAUGHT VERTICAL VELOCITY
! PUNEBH     : NEBULOSITE CONVECTIVE (PSEUDO) HISTORIQUE
! PUNEBH     : (PSEUDO) HISTORIC CONVECTIVE CLOUDINESS
! PV         : COMPOSANTE EN Y DU VENT.
! PV         : Y-COMPONENT OF WIND.
! PT         : TEMPERATURE.
! PQ         : HUMIDITE SPECIFIQUE DE LA VAPEUR D'EAU.
! PQ         : SPECIFIC HUMIDITY OF WATER VAPOUR.
! PQI        : GLACE.
! PQI        : ICE.
! PS         : NEIGE
! PS         : SNOW
! PRR        : RAIN (PR is already used by gas constant !)
! PRR        : PLUIE
! PTENDPTKE  : INCREMENT DE LA ENERGIE CINETIQUE TURBULENTE (schema pTKE)
! PTENDPTKE  : TKE INCREMENT (USED BY PSEUDOPROGNOSTIC TKE SCHEME)
! PTKE       : Energie Cinetique Turbulente
! PTKE       : TKE
! PA         : 3-D cloud cover
! PQVA       : amplitude of total specific humidity variation
! PQL        : EAU LIQUIDE.
! PQL        : LIQUID WATER.
! PVORT0     : TOURBILLON RELATIF.
! PVORT0     : RELATIVE VORTICITY.
! PCVV       : Convective Vertical Velocity
! PO3        : GFL OZONE.
! PCP        : CHALEUR MASSIQUE A PRESSION CONSTANTE DE L'AIR.
! PCP        : SPECIFIC HEAT AT CONSTANT PRESSURE FOR AIR.
! PCVGQ      : CONVERGENCE D'HUMIDITE (CONDITION DE "KUO").
! PCVGQ      : CONVERGENCE OF HUMIDITY ("KUO" CONDITION).

! PCVGQL     : prelim tendance de condensee liquide
! PCVGQL     : prelim. specific cloud water tendency
! PCVGT      : prelim. tendance de temperature
! PCVGT      : prelim. temperature tendency
! PCVGQI     : prelim. tendance de condensee solide
! PCVGQI     : prelim. cloud ice tendency
! PTENDU     : tendance u de la physique (accumulation)
! PTENDU     : accumulated u tendency due to physics
! PTENDV     : tendance v de la physique (accumulation)
! PTENDV     : accumulated v tendency due to physics
! PTENDT     : tendance T de la physique (accumulation)
! PTENDT     : accumulated temperature tendency due to physics
! PTENDH       tendance enthalpie de la physique (accumulation)
! PTENDH     : accumulated enthalpy flux due to physics (if computed)
! PTENDTKE   : tendance de l'energie kinetique turbulent (accumulation)
! PTENDTKE   : accumulated turbulent kinetic energy tendency due to physics
! PTENDQ     : tendance de l'humidite specifique de la physique (accumulation)
! PTENDQ     : accumulated specific humidity tendency due to physics
! PTENDQL    : tendance de l'humidite liquid specifique de la physique (accumulation)
! PTENDQL    : accumualted specific liquid water tendency due to physics
! PTENDQI    : tendance de l'humidite solide specifique de la physique (accumulation)
! PTENDQI    : accumualed specific cloud ice tendency due to physics.

! PKOZO      : CHAMPS POUR LA PHOTOCHIMIE DE L'OZONE (KVCLIS CHAMPS).
! PKOZO      : FIELDS FOR PHOTOCHEMISTERY OF OZONE   (KVCLIS FIELDS).
! PR         : CONSTANTE DES GAZ POUR L'AIR.
! PR         : GAS CONSTANT FOR AIR.

! - 1D (PROGNOSTIQUE) .
! - 1D (PROGNOSTIC QUANTITIES) .

! PALBNS     : ALBEDO DE LA NEIGE.
! PALBNS     : SNOW ALBEDO.
! PRHONS     : DENSITE DE LA NEIGE.
! PRHONS     : SNOW DENSITY.
! PSNS       : MASSE PAR UNITE DE SURFACE DE LA COUCHE NEIGEUSE.
! PSNS       : MASS OF SNOW PER UNIT SURFACE.
! PTP        : TEMPERATURE EN PROFONDEUR.
! PTP        : DEEP-LAYER TEMPERATURE.
! PTS        : TEMPERATURE DE SURFACE.
! PTS        : SURFACE LAYER TEMPERATURE.
! PWL        : CONTENU EN EAU DU RESERVOIR SUPERFICIEL
! PWL        : SKIN RESERVOIR WATER CONTENT
! PWP        : CONTENU EN EAU DU RESERVOIR EN PROFONDEUR.
! PWP        : DEEP-LAYER WATER CONTENT.
! PWPI       : CONTENU EN EAU GELEE DU RESERVOIR EN PROFONDEUR.
! PWPI       : DEEP-LAYER ICE CONTENT.
! PWS        : CONTENU EN EAU DU RESERVOIR DE SURFACE.
! PWS        : SURFACE LAYER WATER CONTENT.
! PWSI       : CONTENU EN EAU GELEE DU RESERVOIR DE SURFACE.
! PWSI       : SURFACE LAYER ICE CONTENT.

! - 1D (GEOGRAPHIQUE) .
! - 1D (GEOGRAPHICAL DISTRIBUTION) .

! PAESEA     : AEROSOLS MARINS (SI LAEROSEA=.T.)
! PAESEA     : MARINE AEROSOLS (IF LAEROSEA=.T.)
! PAELAN     : AEROSOLS CONTINENTAUX (SI LAEROLAN=.T.)
! PAELAN     : CONTINENTAL AEROSOLS (IF LAEROLAN=.T.) 
! PAESOO     : AEROSOLS CARBONES (SI LAEROSOO=.T.)
! PAESOO     : SOOT AEROSOLS (IF LAEROSOO=.T.)
! PAEDES     : AEROSOLS DESERTIQUES (SI LAERODES=.T.)
! PAEDES     : DESERT AEROSOLS (IF LAERODES=.T.=
! PAESUL     : AEROSOLS SULFATES (SI LAEROSUL=.T.)
! PAESUL     : SULFATE AEROSOLS  (IF LAEROSUL=.T.)
! PAEVOL     : AEROSOLS VOLCAN   (SI LAEROVOL=.T.)
! PAEVOL     : VOLCANO AEROSOLS  (IF LAEROVOL=.T.)
! PALV       : ALBEDO DE LA VEGETATION.
! PALV       : VEGETATION ALBEDO.
! PALBF      : ALBEDO FIXE (SOL SANS NEIGE).
! PALBF      : BACKGROUND SURFACE SHORTWAVE ALBEDO (SNOW-FREE).
! PALBSF     : ALBEDO FIXE DU SOL (SOL SANS NEIGE).
! PALBSF     : BACKGROUND SOIL SHORTWAVE ALBEDO (SNOW-FREE).
! PARG       : POURCENTAGE D'ARGILE DANS LE SOL.
! PARG       : SILT PERCENTAGE WITHIN THE SOIL.
! PD2        : EPAISSEUR DU RESERVOIR PROFOND.
! PD2        : DEEP-LAYER OF THE OF THE PROFOUND WATER-TANK.
! PEMISF     : EMISSIVITE FIXE (SOL SANS NEIGE).
! PEMISF     : BACKGROUND SURFACE LONGWAVE EMISSIVITY (SNOW-FREE).
! PGETRL     : ECART TYPE DE L'OROGRAPHIE (EN J/KG).
! PGETRL     : STANDARD DEVIATION OF OROGRAPHY  (UNIT: J/KG).
! PLSM       : INDICE TERRE/MER.
! PLSM       : LAND/SEA MASK.
! PIVEG      : TYPE DE VEGETATION.
! PIVEG      : TYPE OF VEGETATION.
! PLAI       : INDICE FOLIAIRE.
! PLAI       : FOLIAIRE INDICE.
! PRCORI     : FACTEUR DE CORIOLIS.
! PRCORI     : CORIOLIS FACTOR.
! PRSMIN     : RESISTANCE STOMATIQUE MINIMALE.
! PRSMIN     : STOMATAL MINIMAL RESISTANCE.
! PSAB       : POURCENTAGE DE SABLE DANS LE SOL.
! PSAB       : PERCENTAGE OF SAND WITHIN THE SOIL.
! PVEG0      : PROPORTION DE SOL COUVERTE DE VEGETATION.
! PVEG0      : FRACTIONAL COVER BY VEGETATION.
! PVRLAN     : ANISOTROPIE DU RELIEF SOUS MAILLE.
! PVRLDI     : ANGLE DE LA DIRECTION DU RELIEF AVEC L'AXE DES X.
! PVO3ABC    : A,B and C coef for climatological ozone profiles
! PGZ0F      : GRAVITY * ROUGHNESS LENGTH (TIME VARIABLE).
! PGZ0F      : CHAMP TEMPOREL DE G FOIS LA LONGUEUR DE RUGOSITE.
! PGZ0RLF    : GRAVITY * RELIEF ROUGHNESS LENGTH (TIME VARIABLE).
! PGZ0RLF    : CHAMP TEMPOREL DE G FOIS LA LONGUEUR DE RUGOSITE
!              DUE AU RELIEF.
! PGZ0HF     : G*LONGUEUR DE RUGOSITE THERMIQUE (SI KVCLIV >= 8)
! PGZ0HF     : G*THERMAL ROUGHNESS LENGTH (IF KVCLIV >= 8)

! - 1D (DIAGNOSTIQUE) .
! - 1D (DIAGNOSTIC QUANTITIES).

! PHV        : RESISTANCE A L'EVAPOTRANSPIRATION.
! PHV        : RESISTANCE TO EVAPOTRANSPIRATION.
! PMU0       : COSINUS LOCAL INSTANTANE DE L'ANGLE ZENITHAL SOLAIRE.
! PMU0       : LOCAL COSINE OF INSTANTANEOUS SOLAR ZENITH ANGLE.
! PFPLCH     : CHAMP "HISTORIQUE" POUR LES PRECIPITATIONS CONVECTIVES.
! PFPLCH     : HISTORICAL FIELD FOR CONVECTIVE PRECIPITATIONS.
! PFPLSH     : CHAMP "HISTORIQUE" POUR LES PRECIPITATIONS STRATIFORMES.
! PFPLSH     : HISTORICAL FIELD FOR STRATIFORM PRECIPITATIONS.
! PGPAR       : BUFFER FOR 2D FIELDS - CONTAINS PRECIP, ALBEDO, EMISS, TS
!             : SURFACE FLUXES

! PFHPS      : PSEUDO-HISTORICAL ARRAY FOR SURF PRECIP SENSIBLE HEAT FLUX
! PTCCH      : PSEUDO-HISTORICAL ARRAY FOR TOTAL CONVECTIVE CLOUDINESS (1D).
! PSCCH      : PSEUDO-HISTORICAL ARRAY FOR CONVECTIVE CLOUD SUMMIT (1D).
! PBCCH      : PSEUDO-HISTORICAL ARRAY FOR CONVECTIVE CLOUD BASE (1D).
! PPBLH      : PSEUDO-HISTORICAL ARRAY FOR PBL HEIGHT (1D).

! - CONSTANTES

!-----------------------------------------------------------------------

! -   ARGUMENTS DE SORTIE.
! -   OUTPUT ARGUMENTS.
!     --------------------

! - NOM DES VARIABLES DE LA PHYSIQUE (PAR ORDRE ALPHABETIQUE DANS CHAQUE
!   CATEGORIE).

! - 2D (0:KLEV) .

! PDIFCQ     : FLUX CONVECTIF D'HUMIDITE SPECIFIQUE (HORS PLUIE/NEIGE).
! PDIFCQ     : CONVECTIVE FLUX OF SPECIFIC HUMIDITY (NOT RAIN/SNOW).
! PDIFCQI    : FLUX CONVECTIF D'EAU SOLIDE (HORS PLUIE/NEIGE).
! PDIFCQI    : CONVECTIVE FLUX OF SOLID WATER (NOT RAIN/SNOW).
! PDIFCQL    : FLUX CONVECTIF D'EAU LIQUIDE (HORS PLUIE/NEIGE).
! PDIFCQL    : CONVECTIVE FLUX OF LIQUID WATER (NOT RAIN/SNOW).
! PDIFCS     : FLUX CONVECTIF D'ENTHALPIE (HORS PLUIE/NEIGE).
! PDIFCS     : CONVECTIVE FLUX OF ENTHALPY (NOT RAIN/SNOW).
! PDIFTQ     : FLUX TURBULENT (ET Q NEGATIF) D'HUMIDITE SPECIFIQUE.
! PDIFTQ     : TURBULENT FLUX (INC. Q NEGATIVE) OF SPECIFIC HUMIDITY.
! PDIFTQI    : FLUX TURBULENT (ET Q NEGATIF) D'EAU GLACE.
! PDIFTQI    : TURBULENT FLUX (INC. Q NEGATIVE) OF SOLID WATER.
! PDIFTQL    : FLUX TURBULENT (ET Q NEGATIF) D'EAU LIQUIDE.
! PDIFTQL    : TURBULENT FLUX (INC. Q NEGATIVE) OF LIQUID WATER.
! PDIFTS     : FLUX TURBULENT D'ENTHALPIE (OU D'ENERGIE STATIQUE SECHE).
! PDIFTS     : TURBULENT FLUX OF ENTHALPY (OR DRY STATIC ENERGY).
! PFCHOZ     : FLUX PHOTO-CHIMIQUE D'OZONE.
! PFCHOZ     : OZONE PHOTO-CHEMICAL FLUX.
! PFCCQN     : FLUX DE CONDENSATION LIE AUX RR CONVECTIVES NEIGEUSES.
! PFCCQN     : CONVECTIVE CONDENSATION FLUX FOR ICE.
! PFCCQL     : FLUX DE CONDENSATION LIE AUX RR CONVECTIVES LIQUIDES.
! PFCCQL     : CONVECTIVE CONDENSATION FLUX FOR LIQUID WATER.
! PFTKE      : FLUX DE TKE.
! PFTKE      : TKE FLUX.
! PFPLCL     : PRECIPITATIONS CONVECTIVES SOUS FORME LIQUIDE.
! PFPLCL     : CONVECTIVE PRECIPITATION AS RAIN.
! PFPLCN     : PRECIPITATIONS CONVECTIVES SOUS FORME NEIGE.
! PFPLCN     : CONVECTIVE PRECIPITATION AS SNOW.
! PFPLSL     : PRECIPITATIONS STRATIFORMES SOUS FORME LIQUIDE.
! PFPLSL     : STRATIFORM PRECIPITATION AS RAIN.
! PFPLSN     : PRECIPITATIONS STRATIFORMES SOUS FORME NEIGE.
! PFPLSN     : STRATIFORM PRECIPITATION AS SNOW.
! PFRMH      : FLUX MESOSPHERIQUE D'ENTHALPIE.
! PFRMH      : MESOSPHERIC ENTHALPY FLUX.
! PFRMQ      : FLUX MESOSPHERIQUE D'humidite.
! PFRMQ      : MESOSPHERIC humidity flux
! PFRSO      : FLUX DE RAYONNEMENT SOLAIRE.
! PFRSO      : SHORTWAVE RADIATIVE FLUX.
! PFRTH      : FLUX DE RAYONNEMENT THERMIQUE.
! PFRTH      : LONGWAVE RADIATIVE FLUX.
! PFCSQN     : FLUX DE CONDENSATION LIE AUX RR STRATIFORMES NEIGEUSES.
! PFCSQN     : STRATIFORM CONDENSATION FLUX FOR ICE.
! PFCSQL     : FLUX DE CONDENSATION LIE AUX RR STRATIFORMES LIQUIDES.
! PFCSQL     : STRATIFORM CONDENSATION FLUX FOR LIQUID WATER.
! PSTRCU     : FLUX CONVECTIF DE QUANTITE DE MOUVEMENT "U".
! PSTRCU     : CONVECTIVE FLUX OF MOMENTUM "U".
! PSTRCV     : FLUX CONVECTIF DE QUANTITE DE MOUVEMENT "V".
! PSTRCV     : CONVECTIVE FLUX OF MOMENTUM "V".
! PSTRDU     : FLUX "GRAVITY WAVE DRAG" "U".
! PSTRDU     : GRAVITY WAVE DRAG FLUX "U".
! PSTRDV     : FLUX "GRAVITY WAVE DRAG" "V".
! PSTRDV     : GRAVITY WAVE DRAG FLUX "V".
! PSTRTU     : FLUX TURBULENT DE QUANTITE DE MOUVEMENT "U".
! PSTRTU     : TURBULENT FLUX OF MOMENTUM "U".
! PSTRTV     : FLUX TURBULENT DE QUANTITE DE MOUVEMENT "V".
! PSTRTV     : TURBULENT FLUX OF MOMENTUM "V".
! PSTRMU     : FLUX MESOSPHERIQUE DE QUANTITE DE MOUVEMENT "U".
! PSTRMU     : MESOSPHERIC FLUX FOR "U"-MOMENTUM.
! PSTRMV     : FLUX MESOSPHERIQUE DE QUANTITE DE MOUVEMENT "V".
! PSTRMV     : MESOSPHERIC FLUX FOR "V"-MOMENTUM.

! - 2D (1:KLEV) .

! PLH        : CHALEUR LATENTE A LA TEMPERATURE DE L'AIR.
! PLH        : LATENT HEAT AT AIR TEMPERATURE.
! PLSCPE     : RAPPORT EFECTIF DES L ET CP EN CONDENSATION/EVAPORATION.
! PLSCPE     : EFFECTIVE RATIO OF L AND CP FOR CONDENSATION/EVAPORATION.
! PNEB       : NEBULOSITE PARTIELLE "RADIATIVE".
! PNEB       : FRACTIONAL CLOUDINESS FOR RADIATION.
! PQICE      : HUMIDITE SPECIFIQUE SOLIDE "RADIATIVE".
! PQICE      : SPECIFIC HUMIDITY OF SOLID WATER FOR RADIATION.
! PQLI       : HUMIDITE SPECIFIQUE LIQUIDE "RADIATIVE".
! PQLI       : SPECIFIC HUMIDITY OF LIQUID WATER FOR RADIATION.
! PQSAT      : HUMIDITE SPECIFIQUE DE SATURATION.
! PQSAT      : SPECIFIC HUMIDITY AT SATURATION.
! PQW        : HUMIDITE SPECIFIQUE DU THERMOMETRE MOUILLE.
! PQW        : SPECIFIC HUMIDITY OF THE WET THERMOMETER.
! PRH        : HUMIDITE RELATIVE.
! PRH        : RELATIVE HUMIDITY.
! PTW        : TEMPERATURE DU THERMOMETRE MOUILLE.
! PTW        : TEMPERATURE OF THE WET THERMOMETER.

! - 2D (CLOUD AND RADIATION I/O FOR ECMWF PHYSICS)

! ZTENT      : TENDENCY OF TEMPERATURE.
! PDERNSHF   : DERIVATIVE OF THE NON SOLAR SURFACE WITH RESPECT TO Tsurf

! - 1D (DIAGNOSTIQUE) .

! PALB       : ALBEDO DE SURFACE COURANT.
! PALB       : MODEL SURFACE SHORTWAVE ALBEDO.
! PCD        : COEFFICIENT D'ECHANGE EN SURFACE POUR U ET V.
! PCD        : EXCHANGE COEFFICIENT AT SURFACE LEVEL FOR U AND V.
! PCDN       : COEFFICIENT NEUTRE D'ECHANGE EN SURFACE.
! PCDN       : EXCHANGE COEFF. AT SURFACE LEVEL IN NEUTRAL CONDITIONS.
! PCH        : COEFFICIENT D'ECHANGE EN SURFACE POUR T ET Q.
! PCH        : EXCHANGE COEFFICIENT AT SURFACE LEVEL FOR T AND Q.
! PCPS       : CHALEUR MASSIQUE DE L'AIR EN SURFACE.
! PC1        : COEFF. HYDRIQUE REPRESENTANT L'INTENSITE AVEC LAQUELLE
!              LES FLUX DE SURFACE PARTICIPENT A L'EVOLUTION DE WS.
! PC1        : HYDROLOGICAL COEFF. SHOWING THE CONTRIBUTION OF SURFACE
!              FLUXES IN THE WS EVOLUTION.
! PC2        : COEFF. HYDRIQUE TRADUISANT LA RAPIDITE DES TRANSFERTS
!              D'EAU ENTRE LES DEUX RESERVOIRS.
! PC2        : HYDROLOGICAL COEFFICIENT SHOWING THE QUICKNESS OF WATER
!              TRANSFERS BETWEEN BOTH TANKS.
! PCT        : COEFFICIENT THERMIQUE DU MILIEU SOL-VEGETATION.
! PCT        : THERMICAL COEFFICIENT OF SOIL-VEGETATION MIDDEL.
! PEMIS      : EMISSIVITE DE SURFACE COURANTE.
! PEMIS      : MODEL SURFACE LONGWAVE EMISSIVITY.
! PFCHSP     : FLUX DE CHALEUR DE LA SURFACE VERS LE SOL PROFOND.
! PFCHSP     : HEAT FLUX FROM SURFACE TO DEEP SOIL.
! PFCLL      : FLUX DE CHALEUR LATENTE SUR EAU LIQUIDE (OU SOL HUMIDE).
! PFCLL      : LATENT HEAT FLUX OVER LIQUID WATER (OR WET SOIL).
! PFCLN      : FLUX DE CHALEUR LATENTE SUR NEIGE (OU GLACE).
! PFCLN      : LATENT HEAT FLUX OVER SNOW (OR ICE).
! PFCS       : FLUX DE CHALEUR SENSIBLE EN SURFACE.
! PFCS       : SENSIBLE HEAT FLUX AT SURFACE LEVEL.
! PFEVI      : FLUX DE VAPEUR D'EAU SUR SOL GELE.
! PFEVI      : WATER VAPOUR FLUX OVER FROZEN SOIL.
! PFEVL      : FLUX DE VAPEUR D'EAU SUR EAU LIQUIDE (OU SOL HUMIDE).
! PFEVL      : WATER VAPOUR FLUX OVER LIQUID WATER (OR WET SOIL)
! PFEVN      : FLUX DE VAPEUR D'EAU SUR NEIGE (OU GLACE) ET SOL GELE.
! PFEVN      : WATER VAPOUR FLUX OVER SNOW (OR ICE) AND FROZEN SOIL.
! PFEVV      : FLUX D'EVAPOTRANSPIRATION.
! PFEVV      : EVAPOTRANSPIRATION FLUX.
! PFTR       : FLUX DE TRANSPIRATION.
! PFTR       : TRANSPIRATION FLUX.
! PFLWSP     : FLUX D'EAU LIQUIDE DE LA SURFACE VERS LE SOL PROFOND.
! PFLWSP     : WATER FLUX FROM SURFACE TO DEEP SOIL.
! PFONTE     : FLUX D'EAU CORRESPONDANT A LA FONTE DE NEIGE EN SURFACE.
! PFONTE     : WATER FLUX CORRESPONDING TO SURFACE SNOW MELT.
! PALBH      : ALBEDO TOTAL UTILISE DANS LA PREVISION.
! PALBH      : TOTAL ALBEDO USED DURING THE FORECAST.
! PFRSODS    : FLUX SOLAIRE DESCENDANT EN SURFACE
! PFRSODS    : SURFACE DOWNWARDS SOLAR FLUX
! PFRTHDS    : FLUX IR DESCENDANT EN SURFACE
! PFRTHDS    : SURFACE DOWNWARDS IR FLUX
! PGZ0       : G FOIS LA LONGUEUR DE RUGOSITE COURANTE.
! PGZ0       : G * ROUGHNESS LENGTH (CURRENT).
! PGZ0H      : G*LONGUEUR DE RUGOSITE THERMIQUE COURANTE (SI KVCLIV >= 8)
! PGZ0H      : CURRENT G*THERMAL ROUGHNESS LENGTH (IF KVCLIV >= 8)
! PLHS       : CHALEUR LATENTE EN SURFACE.
! PNEIJ      : PROPORTION DE SOL ENNEIGE.
! PNEIJ      : FRACTION OF SOIL COVERED BY SNOW.
! PVEG       : FRACTION DE VEGETATION APPARENTE.
! PVEG       : FRACTIONAL COVER BY APPARENT VEGETATION.
! PQS        : HUMIDITE SPECIFIQUE DE SURFACE.
! PQS        : SPECIFIC HUMIDITY AT SURFACE LEVEL.
! PQSATS     : HUMIDITE SPECIFIQUE DE SATURATION EN SURFACE.
! PQSATS     : SATURATED SPECIFIC HUMIDITY AT SURFACE LEVEL.
! PRS        : CONSTANTE DES GAZ DE L'AIR EN SURFACE.
! PRUISP     : FLUX DE RUISSELLEMENT EN PROFONDEUR.
! PRUISP     : RUN-OFF FLUX IN SOIL.
! PRUISL     : FLUX DE RUISSELLEMENT DU RESERVOIR D'INTERCEPTION.
! PRUISL     : RUN-OFF FLUX OUT THE INTERCEPTION WATER-TANK.
! PRUISS     : FLUX DE RUISSELLEMENT EN SURFACE.
! PRUISS     : RUN-OFF FLUX AT SURFACE LEVEL.
! PFGEL      : FLUX DE GEL DE L'EAU DU SOL.
! PFGEL      : FREEZING FLUX OF SOIL WATER.
! PFGELS     : FLUX DE GEL DE L'EAU DU RESERVOIR DE SURFACE.
! PFGELS     : FREEZING FLUX OF SOIL WATER AT SURFACE LEVEL.
! PUCLS      : SORTIE DIAGNOSTIQUE DU VENT EN X A HUV METEO.
! PUCLS      : U-COMPONENT OF WIND AT 10 METERS (DIAGNOSTIC).
! PVCLS      : SORTIE DIAGNOSTIQUE DU VENT EN Y A HUV METEO.
! PVCLS      : V-COMPONENT OF WIND AT 10 METERS (DIAGNOSTIC).
! PTCLS      : SORTIE DIAGNOSTIQUE DE LA TEMPERATURE A HTQ METEO.
! PTCLS      : TEMPERATURE AT 2 METERS (DIAGNOSTIC).
! PQCLS      : SORTIE DIAGNOSTIQUE DE L'HUMIDITE SPECIFIQUE A HTQ METEO.
! PQCLS      : SPECIFIC HUMIDITY AT 2 METERS (DIAGNOSTIC).
! PRHCLS     : SORTIE DIAGNOSTIQUE DE L'HUMIDITE RELATIVE A HTQ METEO.
! PRHCLS     : RELATIVE HUMIDITY AT 2 METERS (DIAGNOSTIC).
! PCLCH      : SORTIE DIAGNOSTIQUE DE LA NEBULOSITE HAUTE.
! PCLCH      : HIGH CLOUD COVER (DIAGNOSTIC).
! PCLCL      : SORTIE DIAGNOSTIQUE DE LA NEBULOSITE BASSE.
! PCLCL      : LOW CLOUD COVER (DIAGNOSTIC).
! PCLCM      : SORTIE DIAGNOSTIQUE DE LA NEBULOSITE MOYENNE.
! PCLCM      : MEDIUM CLOUD COVER (DIAGNOSTIC).
! PCLCT      : SORTIE DIAGNOSTIQUE DE LA NEBULOSITE TOTALE.
! PCLCT      : TOTAL CLOUD COVER (DIAGNOSTIC).
! PCLPH      : HAUTEUR (EN METRES) DE LA COUCHE LIMITE PLANETAIRE
! PCLPH      : HEIGHT (IN METERS) OF THE PBL
! PUGST      : SORTIE DIAGNOSTIQUE DES RAFALES EN X
! PUGST      : U-COMPONENT OF GUSTS (DIAGNOSTIC).
! PVGST      : SORTIE DIAGNOSTIQUE DES RAFALES EN Y
! PVGST      : V-COMPONENT OF GUSTS (DIAGNOSTIC).


!-----------------------------------------------------------------------

! -   ARGUMENTS IMPLICITES.
! -   IMPLICIT ARGUMENTS.
!     ---------------------

! COMMON/YOMLUN /: UNITE NULOUT.
! COMMON/YOMCST /: CONSTANTES UNIVERSELLES.
! COMDECK/FCTTRM/: FONCTIONS THERMODYNAMIQUES METEO-FRANCE.
! COMMON/YOMPHY /: INDICATEURS LOGIQUES.
! COMMON/YOMPHY0, YOMPHY1, YOMPHY2, YOMPHY3/:
!       CONSTANTES PHYSIQUES (UTILES A L'INTERIEUR MEME DE LA PHYSIQUE)
!       ( PROVISOIREMENT, COORDONNEE VERTICALE SS DIM /YOMGEM/).
! COMMON/YOMPHY0, YOMPHY1, YOMPHY2, YOMPHY3/:
!       PHYSICAL CONSTANTS   (USED WITHIN METEO-FRANCE PHYSICS)
!       ( TEMPORARILY DIMENSIONLESS VERTICAL COORDINATE /YOMGEM/).
! COMMON/YOECON /: UNIVERSAL CONSTANTS.(OLD MODEL VALUES).
! COMDECK/FCTTRE/: THERMODYNAMICAL FUNCTIONS. ECMWF.
! COMMON/YOEPHY /: LOGICAL SWITCHES.
! COMMON/YOERAD,YOEVDF,YOECUMF,YOEGWD,ETC.../: PHYSICAL CONSTANTS ECMWF.

!-----------------------------------------------------------------------

!     Externes.
!     ---------

!     Methode.
!     --------
!     - TERMINE LES INITIALISATIONS.
!     - APPELLE LES SS-PRGMS TAMPONS SUIVANT LA LOGIQUE TROUVEE
!        DANS /YOMPHY/. EUX MEMES VONT DECLARER LES TABLEAUX DE TRAVAIL
!        ET APPELER LES PARAMETRISATIONS ELLES MEMES.
!     - FINISH UP THE INITIALIZATION.
!     - CALL THE BUFFER SUBROUTINES FOLLOWING /YOEPHY/ REQUIREMENTS
!        WHICH IN TURN CALL THE ACTUAL PHYSICS SUBROUTINES
!        (THIS LAST POINT NOT PARTIALLY DONE)

!     Auteur.
!     -------
!     90-09-28: A. Joly, *CNRM*.

!     Modifications.
!     --------------
!     91-05-21 by A.Lasserre-Bigorry (scalar variables)
!     91-06-10 by A.Lasserre-Bigorry (middle atmosphere model)
!     91-09-25 by A.Lasserre-Bigorry and M. Deque (ozone chemistry)
!     91-10: J.F. Geleyn *CNRM*.
!     91-10: ADAPTED FROM THE METEO-FRANCE VERSION
!            TO THE ECMWF PHYSICS PACKAGE BY J.-J. MORCRETTE.
!     91-11-15, Michel Deque : standardization of *ADRME* and *AOZONE*.
!     92-03-31, Ryad El Khatib : subroutine *AMHMT*.
!     92-04-01, Jean-Marcel Piriou: diagnostic de l'humidite relative.
!     92-01-28, C. Castejon and E. Gerard (cloudiness statistic scheme).
!     91-02-01, H. Giordani, P. Le Moigne, W. Maurel.
!            ( Soil-Vegetation Parametrization )
!     92-05-01, Jean-Jacques Morcrette, ECMWF Physics LEZERO=.F. config.
!     92-05-25 C.Dreveton : ajout diagnostics flux de rayonnement
!     93-03-01, Jean-Jacques Morcrette, ECMWF Physics cloud/rad. I/O
!     94-03-01  M. Deque Shallow-convection clouds
!        Modified 93-11-17 by Ph. Dandin : FMR scheme with MF physics
!     94-01-18, Jean-Marcel Piriou: modification de la CVGQ
!               en fonction de la resolution locale du modele.
!     94-07-14, E.Bazile :
!               Reecriture pour enlever la physique du CEP et pour
!               introduire l'eau liquide et les flux de condensation.
!     94-09, Ph. Dandin - Passage de l'ozone.
!     94-09-05  M. Deque: Aerosols and thermal roughness
!     94-10-17  M. Deque: 4 layer soil temperature
!     94-11     Ph. Dandin - Passage des aerosols.
!     95-01-13, H. Douville : parametrisation de la neige.
!     95-03-07, E.Bazile : Nettoyage de tableaux residuels du CEP
!     95-04-26  M. Deque: fluxes over sea-ice (from coupler)
!     95-04, Ph. Dandin - Albedos diffus/direct.
!     95-12, Ph. Dandin - Modifications ozone/aerosols/FMR
!     97-02, J.M. Piriou:
!            - Schema de nebulosite ACNEBN.
!            - Abandon de VETAH et VETAF pour VAH, VBH, VP00.
!            - Soil inertia.
!     96-11, M. Janiskova - call for computation of the coef. for simpl.
!                           radiation scheme
!     96-06, M. Deque - Modification du test pour diagnostics ciel clair
!     96-09, M. Deque - Flux "descendants" en surface pour FMR
!     96-10, J-L. Ricard - Initialisation de ZXTROV et ZXUROV
!     97-02, P. Marquet - Abandon des VETAH et VETAF -> f(VAH,VBH,VP00)
!     97-03, P. Mercier - Diffusion turbulente + deposition de l'ozone
!     97-05, M. Deque   - Gel de FMR
!     97-08, J.M. Piriou - Replace AMx routines by ACx ones, introduce CDLOCK.
!     97-09, J.M. Piriou
!       - Move ZXTROV and ZXUROV initialization to a 0:KLEV loop.
!     97-10, M. Deque  - soulevement GWD
!     97-11, E. Bazile - Soil freezing (LFGEL)
!     98-01, M. Deque  - nettoyage ACRADIN
!     98-02, M. Deque  - new convective clouds (LNEBCO+LNEBR)
!     99-02, M. Janiskova - including PDHSF(mean weights for ACRADCOEF)
!     99-01, E. Bazile - Surface soil freezing (PFGELS)
!     98-08, V. Lorant - new mixing length     (LNEBCO+LNEBR)
!     98-12, L. Gerard / E. Bazile / J.M. Piriou
!       -call Stratiform Precipitation before the Convective
!       -move LCAPE key test outside loop
!       -introduce GCOMOD exponent in PCVGQ modulation
!     99-04, J.M. Piriou: Moon radiation.
!     99-02-17, K. YESSAD - options LRETCFOU, LWRTCFOU.
!     2000-03-31, E. Bazile - Output CAPE value from convection (ACCVIMP)
!     2000-06-13, R. El Khatib PBL height, gusts
!     2000-07-20, R. El Khatib PBL height in meters.
!     2000-08-21, R. El Khatib Turbulent gusts out of ACHMT
!     2001-02-02, E. Bazile Modified input of ACDROV (PFEVI).
!     2001-08-01, R. El Khatib LGWD => call ACCOEFK to compute B.-V. frequency
!     2001-08-07  R. El Khatib : Pruning options
!     2001-08, J.M. Piriou / J.F Geleyn
!      - New definition and use of the thermal mixing length.
!     2001-11-27, J.M. Piriou
!      - add grid-scale precipitation into energy input to deep convection
!        (LSRCONT).
!     2002-06-25 F. Bouyssel Pseudo-historical variables (PFPLCH,PFPLSH,PZAUXH)
!     2002-03-30  Y.Bouteloup add PVO3ABC and LO3ABC (clim. ozone profiles)
!     2002-10-29  J.M. Piriou: change definition of PQLI and PQICE:
!       they become grid-size values.
!     2002-09-03 E. Bazile and V.S. and A.B. new snow scheme LVGSN.
!     2002-10-23  K. YESSAD: option lwrtcfou=T: allow to store a temporal
!       average of transmission coefficients.
!     2002-12-10 D. Banciu - Change number of arguments in ACCOEFK call.
!       (phasage Y. Bouteloup)
!     2003-04, M. Bellus: splitting of pseudo-historical array PNEBH
!               into PPCCH, PTCCH, PSCCH, PBCCH, PPBLH + change of
!               arguments in ACHMT, ACNEBT, ACNEBR, ACRADIN, ACNEBC
!               and ACDRAC callings + general cleaning
!     2003-10-01  M.Hamrud:  CY28 Cleaning
!     2003-09   M. Tudor removal of PPCCH, init. of pseudo hist. vars
!       and cleaning
!     2003-10   M. Tudor reintroduce LSOLV and init. of METEO heights
!       (args in ACHMT)
!     2003-12-02  J.M. Piriou: Externalize mixing lengths, use of Troen
!       and Mahrt BLH to compute these lengths for ACCOEFK.
!     2004-01-29 Y. Bouteloup
!       - CALL ACRALU moon radiation in case of use of FMR or RRTM
!     2004-03-08 E. Bazile
!       - Mise en conformite du calcul de THETAV et possibilite d'activer la
!         CLP d'Ayotte ou de Troen & Marht pour calculer la longueur de melange
!     2004-03-05 Y.Bouteloup :
!       - Snow, Rain and TKE in argument for who wants to use them
!     2004-07-06 K. Yessad: use GFL ozone instead of obsolete pas. scalar one.
!     2004-03-26 Y.Bouteloup : Introduction of MTS radiance
!     2004-09-15 F.Bouyssel : Remove initialisation if done in INITAPLPAR
!     2004-11-05 R.Brozkova : New computation of critical humidity      
!     2004-07-27 F.Bouyssel : Use 6 aerosols and introduce NSW
!     2005-03-03 F.Bouyssel : Introduction of Lopez microphysics scheme
!     2005-05-02 F.Bouyssel : Introduction of STPRE, STPREH, VP00
!     2005-10    A. Alias   :  ACDNSHF added (JF Royer)
!     2005-12-19 A. Alias   : Aerosols Modifications (sulfate and volcano added)
!     2006-01-30 F. Vana    : pTKE scheme
!     2006-01-25 F.Bouyssel : New PFPEVPL, PFPEVPN
!     2006-01-25 F.Bouyssel : Change emissivity over sea if LRAYFM
!     2006-04-11 E. Bazile & P. Marquet : TKE scheme from GMGEC (LECT).
!     2006-03-03 R.Brozkova : bug correction when CGMIXLEN='AY'
!     2006-06-01 B.Sass     : Allow HIRLAM physics components to be called
!     2006-02-06 A. Alias   : GMEGC/EAC modif.
!                J.F. Gueremy : mass-flux deep convection scheme (ACCVIMPGY)
!                               a new cloud-diffusion for conservative
!                P. Marquet - Possible call to ACCVIMP_V3 (if LCVRAV3 for 
!                             Bougeault-V3)
!                M. Deque   - Zenithal angle bugfix (ACOZONE)
!                P. Simon   : Introduction du rappel sur l'humidite (ACDRME)
!     2006-10-30 F.Bouyssel : New ACNEBSM arguments (PTS,PNEIJ,PLSM)
!     2006-10-30 F.Bouyssel : Correction of CY31 phasing bug in ACPLUIZ arguments
!     2006-08-29 R.Brozkova : pre-phasing of ALARO microphysics
!     2006-10-01 M. Bellus  : ALARO-0 phasing - 3MT; consistent correction
!                             of the negative values of water species (D. Banciu)
!     2006-08-22 A. Alias   : List of arguments for ACPLUIS has been modified
!     2006-09-19 A. Alias   : Change the test to call ACDNSHF
!     2006-10-25 A. Alias   : Introduction of aerosols logical keys replacing
!                             usage of the number of aerosols
!     2007-02-01 M.Janousek : Introduction of 3MT routines
!     2007-02-19 R.Brozkova : Cleaning obsolet features (LSRCON, LSRCONT, LNEBT,
!                             pre-ISBA, modularisation and racionalisation.
!     2007-04-17 S.Ivatek-S : Over dimensioning of PGPAR (KLON,NGPAR+1) is used
!                             boundary checking bf
!     2007-03-21 A. Alias   : Modifications for SURFEX (IGFL_EXT)
!     2007-05-07 F. Bouyssel: Several modifications for SURFEX
!     2007-05-07 F. Bouyssel: New argument in ACCOEFK
!     2007-05-15 S. Niemela : NSW replaced by NSWB_MNH to enable the SURFEX call
!                             with HIRLAM physics (ECMWF radiation not part of
!                             the HL_APLPAR)
!     2007-06-27 A. Alias   : Use NGFL_EXT instead of IGFL_EXT
!     2007-10-26 L.Bengtsson :Cleaning of arguments not used in HL_APLPAR.
!    4-Mar-2008 Y. Seity : Cleaning IR and WV similated sat radiances 
!                            (replaced by Fullpos Calculations)
!     2007-10-11 A. Alias   : New Call to ACHMT/ACPBLH (P. Marquet/JF. Gueremy)
!     2007-04-06, J.F. Gueremy : Flux MEMO sur mer (ACFLUSO/LFLUSO) +
!            and  P. Marquet   : ZCEROV as new argument in ACDIFUS
!     2008-11,   C. Payan   : Neutral Wind Diagnostic (ACHMT for SCATT)

!     End Modifications

!-----------------------------------------------------------------------
!     ******************************************************************
!     ****** IDIOSYNCRASIES *** IDIOSYNCRASIES *** IDIOSYNCRASIES ******
!     ******************************************************************
!     ***  HEALTH WARNING:                                           ***
!     ***  ===============                                           ***
!     ***  NOTE THAT WITHIN THE E.C.M.W.F. PHYSICS HALF-LEVELS       ***
!     ***  ARE INDEXED FROM 1 TO NFLEVG+1 WHILE THEY ARE BETWEEN     ***
!     ***  0 AND NFLEVG IN THE REST OF THE MODEL. THE CHANGE IS TAKEN***
!     ***  CARE OF IN THE CALL TO THE VARIOUS SUBROUTINES OF THE     ***
!     ***  PHYSICS PACKAGE                                           ***
!     ***                                                            ***
!     ***    THIS IS SUPPOSED TO BE A "TEMPORARY" FEATURE TO BE      ***
!     ***    STRAIGHTENED OUT IN THE "NEAR" FUTURE                   ***
!     ******************************************************************

!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK    ,DR_HOOK
USE YOMGEM   , ONLY : VP00
USE YOMPHY   , ONLY : LMPHYS   ,LCONDWT  ,&
 &          LGWD     ,LGWDC    ,LHMTO    ,LNEBCO   ,&
 &          LNEBN    ,LNEBR    ,NDIFFNEB ,LOZONE   ,&
 &          LRRMES   ,LSFHYD   ,LSNV     ,LSOLV    ,&
 &          LTHERMO  ,LVDIF    ,LO3ABC   ,LRRGUST  ,LVGSN    ,&
 &          LFPCOR   ,CGMIXLEN ,LHUCN    ,LECT     ,LCVPGY   ,&
 &          LPTKE    ,LRPROX   ,LPHSPSH  ,LNEWSTAT ,&
 &          LCVPRO   ,LCDDPRO  ,LENTCH
USE YOMCST   , ONLY : RG       ,RSIGMA   ,RV       ,&
 &          RCPV     ,RETV     ,RCW      ,RCS      ,RLVTT    ,&
 &          RLSTT    ,RTT      ,RALPW    ,RBETW    ,RGAMW    ,&
 &          RALPS    ,RBETS    ,RGAMS    ,RALPD    ,RBETD    ,&
 &          RGAMD    ,RCPD     ,RATM     ,RKAPPA
USE YOMMCC   , ONLY : LMCC03
USE YOMPHY0  , ONLY : NPCLO1   ,NPCLO2   ,AERCS1   ,AERCS3   ,&
 &           AERCS5  ,HUCOE    ,HUTIL    ,HUTIL1   ,HUTIL2   ,&
 &           UHDIFV  ,XMINLM   ,XMAXLM   ,XKLM
USE YOMPHY1  , ONLY : ALCRIN   ,EMCRIN   ,HSOL     ,HSOLIWR  ,&
 &          HSOLIT0  ,WPMX     ,WSMX     ,ALB1     ,ALB2     ,&
 &          RLAIMX   ,RLAI
USE YOMPHY2  , ONLY : TSPHY    ,HTCLS    ,HVCLS    ,&
 &          LRAFTUR
USE YOMPHY3  , ONLY : QCO2     ,RII0
USE YOMTOPH  , ONLY : RMESOU   ,RMESOT   ,NTQSAT  ,NTDIFU   ,&
 &          NTCOEF   ,NTDRAG   ,NTOZON   ,NTDRME  ,RMESOQ
USE YOMSTA   , ONLY : STTEM    ,STPRE    ,STPREH
USE YHLOPTION, ONLY : LHL, HLOPTION
USE YOMARPHY  ,ONLY : LMSE     ,LMPA     ,CCOUPLING
USE YOMARAR   ,ONLY : NGPAR    ,MRAIN    ,MSNOW    ,MGZ0     ,&
 &         MGZ0H     ,MVEMIS   ,MVQS     ,MVTS     ,&
 &         MALBDIR   ,MALBSCA  ,XSW_BANDS,NSWB_MNH  
USE YOMRIP   , ONLY : NINDAT   ,NSSSSS   ,RSOVR    ,RCODEC   ,RSIDEC
USE YOM_YGFL  , ONLY : NGFL_EXT

!     ------------------------------------------------------------------

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KLON 
INTEGER(KIND=JPIM),INTENT(IN)    :: KLEV 
INTEGER(KIND=JPIM),INTENT(IN)    :: KBL
INTEGER(KIND=JPIM),INTENT(IN)    :: KGPCOMP
INTEGER(KIND=JPIM),INTENT(IN)    :: KVCLIS 
INTEGER(KIND=JPIM),INTENT(IN)    :: KSGST 
INTEGER(KIND=JPIM),INTENT(IN)    :: KCSS 
INTEGER(KIND=JPIM),INTENT(IN)    :: KIDIA 
INTEGER(KIND=JPIM),INTENT(IN)    :: KFDIA 
INTEGER(KIND=JPIM),INTENT(IN)    :: KTDIA 
INTEGER(KIND=JPIM),INTENT(IN)    :: KVCLIV
INTEGER(KIND=JPIM),INTENT(IN)    :: KSTEP 

REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCVGQL(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCVGQI(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCVGT(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTENDU(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTENDV(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTENDT(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTENDH(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTENDTKE(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTENDQ(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTENDQL(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTENDQI(KLON,KLEV)

REAL(KIND=JPRB)   ,INTENT(IN)    :: PAPHI(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PAPRS(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PAPHIF(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PAPRSF(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PALPH(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PARG(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PD2(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PDELP(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PIVEG(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PLAI(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PLNPR(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PRDELP(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PRSMIN(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSAB(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PGZ0HF(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PRCORI(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PU(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PV(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PT(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQ(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PS(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PRR(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTKE(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PA(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQVA(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCVV(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQI(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQL(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PO3(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCP(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCVGQ(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PR(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PKOZO(KLON,KLEV,KVCLIS) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPLCH(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPLSH(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTCCH(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSCCH(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PBCCH(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PPBLH(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFHPS(KLON)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSNS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PGPAR(KLON,NGPAR+1)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PALBNS(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PRHONS(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PTP(KLON,KCSS) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PWL(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PWP(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PWPI(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PWS(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PWSI(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PHV(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PVERVEL(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PALV(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PALBF(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PALBSF(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PEMISF(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGETRL(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PLSM(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PVEG0(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PGZ0F(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGZ0RLF(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PVRLAN(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PVRLDI(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PVO3ABC(KLON,3) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PMU0(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGELAM(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGEMU(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: POROG(KLON)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFCQ(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFCQI(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFCQL(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFCS(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFTQ(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFTQI(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFTQL(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFTS(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCCQL(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCCQN(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCSQL(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCSQN(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPLCL(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPLCN(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPLSL(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPLSN(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFRSO(KLON,0:KLEV,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFRTH(KLON,0:KLEV,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSTRCU(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSTRCV(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSTRDU(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSTRDV(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSTRTU(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSTRTV(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSTRMU(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSTRMV(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFRMH(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFRMQ(KLON,0:KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCHOZ(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFTKE(KLON,0:KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCPS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PLHS(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRS(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PLH(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PLSCPE(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PNEB(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQICE(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQLI(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQSAT(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQW(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRH(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTW(KLON,KLEV) 
! Prognostic convection variables (MUST BE 1:KLEV for GFL)
! Unless mf_phys has copied them into a 0:KLEV array
! Up to now, we leave 1:KLEV for pentch: see later.
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PENTCH(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PUNEBH(KLON,KLEV)
!---------------------------------------------------
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PALB(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCD(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCDN(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCH(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PC1(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PC2(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCT(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PEMIS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCHSP(KLON,KCSS) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCLL(KLON,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCLN(KLON,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCS(KLON,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFEVI(KLON,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFEVL(KLON,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFEVN(KLON,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFEVV(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFTR(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFLWSP(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFONTE(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PALBH(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFGEL(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFGELS(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFRSODS(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFRSOPT(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFRTHDS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PGZ0(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PGZ0H(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PNEIJ(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PVEG(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQSATS(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRUISL(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRUISP(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRUISS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PUCLS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PVCLS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTCLS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQCLS(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRHCLS(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PCLCT(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PCLCH(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PCLCM(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PCLCL(KLON) 
INTEGER(KIND=JPIM),INTENT(OUT)   :: KCLPH(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PCLPH(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PUGST(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PVGST(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PTENDPTKE(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PDERNSHF(KLON)

CHARACTER(LEN=9)  ,INTENT(IN)    :: CDLOCK 

!     ------------------------------------------------------------------
!        ATTENTION SI KVCLIG < 7 LES CHAMPS SUIVANTS NE SONT
!        PAS REELLEMENT ALLOUES EN MEMOIRE.
!     ------------------------------------------------------------------

!     DECLARATION DES TABLEAUX LOCAUX-GLOBAUX DES PARAMETRISATIONS

INTEGER(KIND=JPIM) :: INLAB(KLON,KLEV)
REAL(KIND=JPRB) :: ZVETAH(0:KLEV)
REAL(KIND=JPRB) :: ZVETAF(KLEV)

!     ------------------------------------------------------------------
!     WARNING: THE ARRAYS ZXTROV, ZXUROV, ZKTROV,ZKUROV, ZKNROV AND ZNBVNO
!     ARE DIMENSIONNED 0:KLEV ONLY IN ORDER TO KEEP IN MIND
!     THAT THEY ARE COMPUTED AT "HALF LEVELS".
!     THEY ARE USED HOWEVER FROM 1 TO KLEV.

REAL(KIND=JPRB) :: ZXTROV(KLON,0:KLEV),ZXUROV(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZXPTKEROV(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZKTROV(KLON,0:KLEV),ZKUROV(KLON,0:KLEV),ZNBVNO(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZKNROV(KLON,0:KLEV)

!     ------------------------------------------------------------------
REAL(KIND=JPRB) :: ZNEBS(KLON,KLEV),ZQLIS(KLON,KLEV)
REAL(KIND=JPRB) :: ZNEBS0(KLON,KLEV),ZQLIS0(KLON,KLEV)
REAL(KIND=JPRB) :: ZNEBC0(KLON,KLEV)   !Nebulosite convective radiative
REAL(KIND=JPRB) :: ZNEBDIFF(KLON,KLEV) !Nebulosite: calcul de la diffusion
REAL(KIND=JPRB) :: ZFPCOR(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZFHP(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZERO(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZLMT(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZZLMT(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZLMU(KLON,0:KLEV)

REAL(KIND=JPRB) :: ZQV(KLON,KLEV)    ! corrected (for negative values) vapour
                                     ! updated value for cascading parameterization
REAL(KIND=JPRB) :: ZQI(KLON,KLEV)    ! corrected (for negative values) cloud ice
                                     ! updated value for cascading parameterization
REAL(KIND=JPRB) :: ZQL(KLON,KLEV)    ! corrected (for negative values) cloud liquid
                                     ! updated value for cascading parameterization
REAL(KIND=JPRB) :: ZQR(KLON,KLEV)    ! corrected (for negative values) rain
                                     ! updated value for cascading parameterization
REAL(KIND=JPRB) :: ZQS(KLON,KLEV)    ! corrected (for negative values) snow
                                     ! updated value for cascading parameterization
REAL(KIND=JPRB) :: ZFCQL(KLON,0:KLEV)   ! condensation flux(liquid)
REAL(KIND=JPRB) :: ZFCQLDM(KLON,0:KLEV) ! diff micro condensation flux(liquid)
REAL(KIND=JPRB) :: ZFCQI(KLON,0:KLEV)   ! condensation flux(ice)
REAL(KIND=JPRB) :: ZFCQIDM(KLON,0:KLEV) ! diff micro condensation flux(ice)

!-----------------------------------------------------------------

! - 2D (0:KLEV) .

! ZKTROV     : COEFFICIENT D'ECHANGE VERTICAL DE T ET Q EN KG/(M*M*S).
! ZKUROV     : COEFFICIENT D'ECHANGE VERTICAL DE U ET V EN KG/(M*M*S).
! ZKNROV     : COEFFICIENT D'ECHANGE VERTICAL NEUTRE EN KG/(M*M*S).
! ZNBVNO     : FREQUENCE DE BRUNT-VAISALA DIVISEE PAR G FOIS LA DENSITE.

! ZNEBS      : NEBULOSITE STRATIFORME (SCHEMA STATISTIQUE DE NUAGES).
!            : STRATIFORM CLOUDINESS (STATISTICAL CLOUD SCHEME)
! ZQLIS      : QUANTITE D'EAU LIQUIDE STRATIFORME (SCHEMA STATISTIQUE).
!            : STRATIFORM LIQUID WATER (STATISTICAL CLOUD SCHEME)

! ZCFRSO     : FLUX SOLAIRE RADIATIF EN CIEL CLAIR.
! ZCFRTH     : FLUX THERMIQUE RADIATIF EN CIEL CLAIR.

! - 2D (1:KLEV) .

! INLAB      : INDICE D'INSTABILITE CONVECTIVE.

REAL(KIND=JPRB) :: ZXDROV(KLON),ZXHROV(KLON)
REAL(KIND=JPRB) :: ZUGST(KLON),ZVGST(KLON)
REAL(KIND=JPRB) :: ZCDROV(KLON),ZCHROV(KLON),ZDQSTS(KLON),ZGWDCS(KLON),&
 & ZHQ(KLON),ZHU(KLON),ZHTR(KLON),&
 & ZRTI(KLON),ZSTAB(KLON),ZTAUX(KLON)  
REAL(KIND=JPRB) :: ZWFC(KLON),ZWPMX(KLON),ZWLMX(KLON),ZWSEQ(KLON),&
 & ZWSMX(KLON),ZWWILT(KLON),&
 & ZC3(KLON),ZCG(KLON),ZCN(KLON),&
 & ZNEIJG(KLON),ZNEIJV(KLON)  
REAL(KIND=JPRB) :: ZPCLS(KLON)
REAL(KIND=JPRB) :: ZFRSOFS(KLON)

! - 1D (DIAGNOSTIQUE) .

! ZCDROV     : PCD RENORME EN DENSITE FOIS VITESSE.
! ZCG        : COEFFICIENT THERMIQUE DU SOL NU.
! ZCG        : THERMICAL COEFFICIENT OF BARE GROUND.
! ZCN        : COEFFICIENT THERMIQUE DE LA NEIGE.
! ZCN        : THERMICAL COEFFICIENT OF SNOW.
! ZCHROV     : PCH RENORME EN DENSITE FOIS VITESSE.
! ZC3        : COEFFICIENT UTILE POUR LE CALCUL DU DRAINAGE
! ZDQSTS     : DERIVEE DE PQSATS PAR RAPPORT A LA TEMPERATURE.
! ZGWDCS     : VARIABLE DE SURFACE POUR LE DRAG OROGRAPHIQUE (RHO*N0/G).
! ZHQ        : POIDS DE L'HUMIDITE DE L'AIR DANS L'HUMIDITE DE SURFACE.
! ZHTR       : RESISTANCE A LA TRANSPIRATION DU COUVERT VEGETAL.
! ZHTR       : FOLIAGE TRANSPIRATION RESISTANCE.
! ZHU        : POIDS DE L'HUMIDITE SATURANTE DANS L'HUMIDITE DE SURFACE.
! ZNEIJG     : FRACTION DE NEIGE RECOUVRANT LE SOL.
! ZNEIJV     : FRACTION DE NEIGE RECOUVRANT LA VEGETATION.
! ZRTI       : INVERSE DE R*T.
! ZSTAB      : INDICE DE STABILITE A LA SURFACE.
! INND       : INDICE DE PRECIPITATIONS CONVECTIVES.
! ZSFRTP     : FLUX RADIATIFS SPECTRAUX AU SOMMET.
! ZSFRBM     : FLUX RADIATIFS SPECTRAUX A LA SURFACE.
! ZWFC       : TENEUR EN EAU A LA CAPACITE AUX CHAMPS.
! ZWFC       : FIELD CAPACITY WATER CONTENT.
! ZWPMX      : TENEUR EN EAU MAXIMALE DU RESERVOIR PROFOND.
! ZWPMX      : MAXIMUM WATER CONTENT OF THE DEEP WATER-TANK.
! ZWLMX      : TENEUR EN EAU MAXIMALE DU RESERVOIR D'INTERCEPTION.
! ZWLMX      : MAXIMUM WATER CONTENT OF THE INTERCEPTION WATER-TANK.
! ZWSEQ      : TENEUR EN EAU A L'EQUILIBRE (EQUILIBRE ENTRE GRAVITE ET
!              CAPILLARITE) EN SURFACE.
! ZWSEQ      : SURFACE WATER CONTENT FOR THE BALANCE BETWEEN GRAVITY
!              AND CAPILLARITY
! ZWSMX      : TENEUR EN EAU MAXIMALE DU RESERVOIR SUPERFICIEL.
! ZWSMX      : MAXIMUM WATER CONTENT FOR THE SUPERFICIAL WATER-TANK.
! ZWWILT     : TENEUR EN EAU AU POINT DE FLETRISSEMENT.
! ZWWILT     : WATER CONTENT AT THE WILTING POINT.
REAL(KIND=JPRB) :: ZDAER(KLEV), ZHUC(KLEV), ZBLH(KLON)
REAL(KIND=JPRB) :: ZQO3(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZAER(KLON,KLEV,6)
REAL(KIND=JPRB) :: ZQCO2(KLON,KLEV)
REAL(KIND=JPRB) :: ZDPHIV(KLON),ZDPHIT(KLON)

REAL(KIND=JPRB) :: ZMAN(0:KLEV), ZMAK(0:KLEV)
REAL(KIND=JPRB) :: ZMCC,ZMDD,ZMEE,ZMFF,ZMGG,ZMHH

! ZPUCLN/ZPVCLN : COMPOSANTES X/Y VENT NEUTRE
REAL(KIND=JPRB) :: ZPUCLN(KLON), ZPVCLN(KLON) 

! - (PROFILS DIAGNOSTIQUES)
! ZDAER     : EPAISSEUR OPTIQUE DES AEROSOLS STANDARDS DANS LA COUCHE
! ZDAER     : OPTICAL DEPTH OF STANDARD AEROSOLS IN THE LAYER.
! ZHUC      : HUMIDITE CRITIQUE PAR NIVEAU POUR LE CALCUL DE PNEB
! ZHUC      : CRITICAL MOISTURE FOR EACH LEVEL FOR PNEB CALCULATION.
!   ZQO3    : RAPPORT DE MELANGE MASSIQUE D'OZONE
!        (0):     "         "    MOYEN AU-DESSUS DU MODELE
!   ZQO3    : OZONE MIXING RATIO (MASS).
!        (0):AVERAGED-ABOVE      "         " .
!   ZQCO2   : RAPPORT MASSIQUE LOCAL DU CO2.
!   ZQCO2   : CO2 MIXING RATIO (MASS).

! IJN        : DIMENSION TABLEAUX ETENDUS POUR CYCLE DIURNE RAYONNEMENT
!              IJN AU PLUSL A KLON

!* INPUT ARGUMENTS FOR ACRADIN ( RAYT ECMWF POUR CLIMAT )

!            1-D ARRAYS
!            ----------

REAL(KIND=JPRB) :: ZTRSOD(KLON)

!            2-D ARRAYS
!            ----------

!* OUTPUT ARGUMENTS FOR THE ECMWF PHYSICS

!            0.2  LOCAL ARRAYS FOR ECMWF PHYSICS PACKAGE
!                 --------------------------------------

REAL(KIND=JPRB) :: ZCEMTR(KLON,0:1) , ZCTRSO(KLON,0:1)
REAL(KIND=JPRB) :: ZALBD(KLON,NSWB_MNH), ZALBP(KLON,NSWB_MNH)
REAL(KIND=JPRB) :: ZSFSWDIR (KLON,NSWB_MNH), ZSFSWDIF (KLON,NSWB_MNH)

!            1-D ARRAYS
!            ----------

REAL(KIND=JPRB) :: ZSUDU(KLON)
REAL(KIND=JPRB) :: ZTHETAVS(KLON)

!            2-D ARRAYS
!            ----------

REAL(KIND=JPRB) :: ZTENT(KLON,KLEV), ZGEOSLC(KLON,KLEV)
REAL(KIND=JPRB) :: ZTHETAV(KLON,KLEV)

!           2-D ARRAY FOR SIMPL.RADIATION SCHEME

INTEGER(KIND=JPIM) :: IJN, JCHA, JLEV, JLON, JSG

LOGICAL :: LLCLS, LLHMT

REAL(KIND=JPRB) :: ZAEN, ZAEO, ZALBV, ZCARDI, ZEPS, ZEPS0, ZEPSO3
REAL(KIND=JPRB) :: ZVNEIJ, ZCOEF, ZCFN, ZCK



!            2-D ARRAYS

! ZNEBC      : NEBULOSITE  CONVECTIVE A L'ECHELLE DE LA MAILLE.
! ZQLIC      : EAU LIQUIDE CONVECTIVE A L'ECHELLE DE LA MAILLE.
! ZFHEVPPC   : FLUX DE CHALEUR DU A L'EVAPORATION DES PREC. CONVECTIVES.
! ZFHMLTSC   : FLUX DE CHALEUR DU A LA FONTE/GEL DES PREC. CONVECTIVES.
! ZFPEVPPC   : EVAPORATION DES PREC. CONVECTIVES.
! ICIS       : INDICE DE NIVEAU D'INSTABILITE SECHE.

REAL(KIND=JPRB) :: ZNEBC(KLON,KLEV),ZQLIC(KLON,KLEV)
REAL(KIND=JPRB) :: ZFHEVPPC(KLON,0:KLEV),ZFHMLTSC(KLON,0:KLEV)&
 & ,ZFPEVPPC(KLON,0:KLEV)
INTEGER(KIND=JPIM) :: ICIS(KLON,KLEV)

!     LOCAL ARRAYS FOR FLUSO (ECUME)

REAL(KIND=JPRB) :: ZCEROV(KLON)

!           SURFEX local VARIABLES
!           ----------------------------

! Implicit coupling coefficients
INTEGER(KIND=JPIM) :: IRR
LOGICAL :: LLD_NBLOCKTOT
REAL(KIND=JPRB) :: ZCFAQ(KLON,KLEV),&
 & ZCFATH(KLON,KLEV),ZCFAU(KLON,KLEV),ZCFBQ(KLON,KLEV),&
 & ZCFBTH(KLON,KLEV),ZCFBU(KLON,KLEV),ZCFBV(KLON,KLEV)

REAL(KIND=JPRB) :: ZFEV(KLON),ZFMDU(KLON),ZFMDV(KLON)
REAL(KIND=JPRB) :: ZSRAIN(KLON), ZSSNOW(KLON), ZSGROUPEL(KLON)
REAL(KIND=JPRB) :: ZSFCO2(KLON),ZRHODREFM(KLON)
REAL(KIND=JPRB) :: ZDEPTH_HEIGHT_LOW(KLON), ZZS(KLON)
REAL(KIND=JPRB) :: ZTSN(KLON)
REAL(KIND=JPRB), DIMENSION (:,:), ALLOCATABLE  :: ZSVM
REAL(KIND=JPRB), DIMENSION (:,:), ALLOCATABLE  :: ZSFSV

CHARACTER(LEN=200) :: CLERR
REAL(KIND=JPRB) :: ZHOOK_HANDLE

!     ------------------------------------------------------------------

#include "abor1.intfb.h"
#include "acclph.intfb.h"
#include "accoefk.intfb.h"
#include "acdifoz.intfb.h"
#include "acdifus.intfb.h"
#include "acdnshf.intfb.h"
#include "acdrac.intfb.h"
#include "acdrag.intfb.h"
#include "acdrme.intfb.h"
#include "acdrov.intfb.h"
#include "achmt.intfb.h"
#include "acmixlenz.intfb.h"
#include "acmixlentm.intfb.h"
#include "acozone.intfb.h"
#include "acpblh.intfb.h"
#include "acpblhtm.intfb.h"
#include "hlrad.intfb.h"
#include "hlturb.intfb.h"
#include "hlstraco.intfb.h"
#include "hlcldia.intfb.h"
#include "acsol.intfb.h"
#include "actqsat.intfb.h"
#include "acveg.intfb.h"
#include "suozon.intfb.h"
#include "achmtls.intfb.h"
#include "aro_ground_param.h"
#include "aro_ground_diag.h"

!     ------------------------------------------------------------------

#include "fcttrm.h"

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('HL_APLPAR',0,ZHOOK_HANDLE)

!     ------------------------------------------------------------------

!     CHECK RELIABILITY OF INPUT ARGUMENTS.
IF(CDLOCK /= 'HL_APLPAR') CALL ABOR1('BAD NUMBER OF ARGUMENTS!')

! SURFEX  and passive scalar
ALLOCATE(ZSVM  (KLON,NGFL_EXT))
ALLOCATE(ZSFSV (KLON,NGFL_EXT))


!     ------------------------------------------------------------------
!     1.- INITIALISATIONS COMPLEMENTAIRES
!     -----------------------------------
IJN = KLON

!     CALCUL FIN DE IJN
!      IJN = 1
!      ZMU0 = MAX(0.,-SIGN(1.,-PMU0(KIDIA)))
!      DO 1  JLON = KIDIA+1, KFDIA
!      ZMUN = MAX(0.,-SIGN(1.,-PMU0(JLON)))
!      IJN = IJN + IABS(NINT(ZMUN)-NINT(ZMU0))
!      ZMU0 = ZMUN
!   1  CONTINUE

!*        1.1 INITIALISATION DE L'OZONE

IF (LMPHYS) THEN
  IF (LOZONE) THEN

    ! L'ozone est initialise par PO3 (ozone GFL).
    ! Ozone is computed from PO3 (GFL ozone).

    ZEPSO3=1.E-11_JPRB
    DO JLON=KIDIA,KFDIA
      ZQO3(JLON,0)=1.E-9_JPRB
    ENDDO
    DO JLEV=KTDIA,KLEV
      DO JLON=KIDIA,KFDIA
        ZQO3(JLON,JLEV) = MAX(ZEPSO3,PO3(JLON,JLEV))
      ENDDO
    ENDDO

  ELSEIF(KVCLIS == 1) THEN
    ZEPSO3=1.E-11_JPRB
    DO JLON=KIDIA,KFDIA
      ZQO3(JLON,0)=1.E-9_JPRB
    ENDDO
    DO JLEV=KTDIA,KLEV
      DO JLON=KIDIA,KFDIA
        ZQO3(JLON,JLEV) = PKOZO(JLON,JLEV,1)
      ENDDO
    ENDDO

  ELSE
    CALL SUOZON(KIDIA,KFDIA,KLON,KLEV,ZQO3,.FALSE.,PAPRS,PRDELP,LO3ABC,PVO3ABC)
  ENDIF

!     GAZ CARBONIQUE.

  DO JLEV=KTDIA,KLEV
    DO JLON=KIDIA,KFDIA
      ZQCO2(JLON,JLEV)=QCO2
    ENDDO
  ENDDO


  ! INITIALISATION DE LA COORDONNEE ETA.
  ! INITIALISATION DE LA COORDONNEE ETA.

  ZVETAH(KTDIA-1)=STPREH(KTDIA-1)/VP00
  DO JLEV=KTDIA,KLEV
    ZVETAH(JLEV)=STPREH(JLEV)/VP00
    ZVETAF(JLEV)=STPRE (JLEV)/VP00
  ENDDO

!     EPAISSEUR STD AEROSOLS
  ZAEO = AERCS1*ZVETAH(KTDIA-1) + AERCS3*ZVETAH(KTDIA-1)**3 &
   & + AERCS5*ZVETAH(KTDIA-1)**5  
  DO JLEV = KTDIA, KLEV
    ZAEN = AERCS1*ZVETAH(JLEV) + AERCS3*ZVETAH(JLEV)**3 &
     & + AERCS5*ZVETAH(JLEV)**5  
    ZDAER(JLEV) = ZAEN - ZAEO
    ZAEO = ZAEN
  ENDDO

!     HUMIDITE CRITIQUE
  ZEPS=1.E-12_JPRB
  IF(LHUCN) THEN
    DO JLEV = KTDIA, KLEV
      ZHUC(JLEV)=1.0_JPRB-MAX( HUCOE*ZVETAF(JLEV)*(1.0_JPRB-ZVETAF(JLEV))/&
       &((1.0_JPRB+HUTIL1*(ZVETAF(JLEV)-0.5_JPRB))*&
       &(1.0_JPRB+HUTIL2*(ZVETAF(JLEV)-0.5_JPRB))),ZEPS)
    ENDDO
  ELSE
    DO JLEV = KTDIA, KLEV
      ZHUC(JLEV)=1.0_JPRB-MAX( HUCOE*ZVETAF(JLEV)**NPCLO1*&
       & (1.0_JPRB-ZVETAF(JLEV))**NPCLO2*&
       & (1.0_JPRB+SQRT(HUTIL)*(ZVETAF(JLEV)-0.5_JPRB)),ZEPS)  
    ENDDO
  ENDIF

  IF ( LNEWSTAT ) THEN

!     MODELE STATISTIQUE POUR LA FORMULATION 'PNE'

    IF ( LRPROX) THEN
      ZMCC=0.14_JPRB
      ZMDD=3.5_JPRB
    ELSE
      ZMCC=0.29_JPRB
      ZMDD=2.0_JPRB
    ENDIF
    ZMEE=0.07_JPRB
    ZMFF=1.5_JPRB
    ZMGG=0.14_JPRB
    ZMHH=20._JPRB

    DO JLEV = KTDIA, KLEV-1
      ZMAN(JLEV) = ZMCC * TANH(ZMDD*ZVETAH(JLEV))
      ZMAK(JLEV) = ZMEE * ZVETAH(JLEV)**ZMFF + ZMGG * (1-ZVETAH(JLEV))**ZMHH
    ENDDO

!     MATHEMATICAL FILTER FOR THE EDGES

    IF ( LRPROX ) THEN
      DO JLEV = KTDIA, KTDIA+3
        ZMAK(JLEV) = ZMAK(JLEV) / 2**(KTDIA+4-JLEV)
      ENDDO
      DO JLEV = KLEV-4, KLEV-1
        ZMAK(JLEV) = ZMAK(JLEV) / 2**(5-KLEV+JLEV)
      ENDDO
    ENDIF
 
  ELSE
    DO JLEV = KTDIA, KLEV-1
      ZMAN(JLEV) = 0.3_JPRB*ZVETAH(JLEV)
      ZMAK(JLEV) = 0.1_JPRB
    ENDDO
  ENDIF   !LNEWSTAT

ENDIF  !LMPHYS
!**
!     ------------------------------------------------------------------
!     2.- MISES A ZERO DE SECURITE EN CAS DE NON-APPEL DES PARAMETRIS.
!     ------------------------------------------------------------------
ZEPS0=1.E-12_JPRB

DO JLEV = 0, KLEV
  DO JLON = KIDIA,KFDIA
    ZERO    (JLON,JLEV) = 0.0_JPRB
    ZFPCOR  (JLON,JLEV) = 0.0_JPRB
    ZFHP    (JLON,JLEV) = 0.0_JPRB
    ZXTROV  (JLON,JLEV) = 1.0_JPRB
    ZXUROV  (JLON,JLEV) = 1.0_JPRB
    ZLMT    (JLON,JLEV) = 0.0_JPRB
    ZZLMT   (JLON,JLEV) = 0.0_JPRB
    ZLMU    (JLON,JLEV) = 0.0_JPRB
    ZKTROV  (JLON,JLEV) = 0.0_JPRB
    ZKUROV  (JLON,JLEV) = 0.0_JPRB
    ZFHEVPPC(JLON,JLEV) = 0.0_JPRB
    ZFHMLTSC(JLON,JLEV) = 0.0_JPRB
    ZFPEVPPC(JLON,JLEV) = 0.0_JPRB
    ZFCQL   (JLON,JLEV) = 0.0_JPRB
    ZFCQLDM (JLON,JLEV) = 0.0_JPRB
    ZFCQI   (JLON,JLEV) = 0.0_JPRB
    ZFCQIDM (JLON,JLEV) = 0.0_JPRB
  ENDDO
ENDDO

DO JLEV = 1, KLEV
  DO JLON = KIDIA,KFDIA
    ZTENT   (JLON,JLEV) = 0.0_JPRB
    ZNEBS   (JLON,JLEV) = ZEPS0
    ZNEBC   (JLON,JLEV) = ZEPS0
    ZNEBS0  (JLON,JLEV) = ZEPS0
    ZNEBC0  (JLON,JLEV) = 0.0_JPRB
    ZNEBDIFF(JLON,JLEV) = 0.0_JPRB
    ZQLIS   (JLON,JLEV) = 0.0_JPRB
    ZQLIS0  (JLON,JLEV) = 0.0_JPRB
    ZCFATH  (JLON,JLEV) = 0.0_JPRB
    ZCFAU   (JLON,JLEV) = 0.0_JPRB
    ZCFBTH  (JLON,JLEV) = 0.0_JPRB
    ZCFBU   (JLON,JLEV) = 0.0_JPRB
    ZCFBV   (JLON,JLEV) = 0.0_JPRB
    ZQLIC   (JLON,JLEV) = 0.0_JPRB
    INLAB   (JLON,JLEV) = 0
    ICIS    (JLON,JLEV) = 1
  ENDDO
ENDDO

!  ---------------------------------------------------------------------
!  Correction of negative advected humidity and precipitation values
!  ---------------------------------------------------------------------


IF (LCONDWT) THEN
    DO JLEV = 1, KLEV
      DO JLON = KIDIA,KFDIA
        ZQI(JLON,JLEV)=PQI(JLON,JLEV)
        ZQL(JLON,JLEV)=PQL(JLON,JLEV)
        IF (.NOT.LHL) THEN
          ZQR(JLON,JLEV)=PRR(JLON,JLEV)
          ZQS(JLON,JLEV)=PS(JLON,JLEV)
        ENDIF
        ZQV(JLON,JLEV)=PQ(JLON,JLEV)
      ENDDO
    ENDDO
ELSE
  DO JLEV = 1, KLEV
    DO JLON = KIDIA,KFDIA
      ZQI(JLON,JLEV)=0.0_JPRB
      ZQL(JLON,JLEV)=0.0_JPRB
      ZQV(JLON,JLEV)=PQ(JLON,JLEV)
    ENDDO
  ENDDO
ENDIF ! LCONDWT  

DO JLEV = 1, KLEV
  DO JLON = KIDIA,KFDIA
!   preliminary assessment
    PCVGQL  (JLON,JLEV) = 0.0_JPRB
    PCVGQI  (JLON,JLEV) = 0.0_JPRB
    PCVGT   (JLON,JLEV) = 0.0_JPRB
!   tendencies
    PTENDU  (JLON,JLEV) = 0.0_JPRB
    PTENDV  (JLON,JLEV) = 0.0_JPRB
    PTENDT  (JLON,JLEV) = 0.0_JPRB
    PTENDH  (JLON,JLEV) = 0.0_JPRB
    PTENDTKE(JLON,JLEV) = 0.0_JPRB
    PTENDQ  (JLON,JLEV) = 0.0_JPRB
    PTENDQL (JLON,JLEV) = 0.0_JPRB
    PTENDQI (JLON,JLEV) = 0.0_JPRB
  ENDDO
ENDDO

DO JCHA = 1, 6
  DO JLEV = KTDIA, KLEV
    DO JLON = 1, KLON
      ZAER(JLON,JLEV,JCHA)=0.0_JPRB
    ENDDO
  ENDDO
ENDDO

DO JLON = KIDIA,KFDIA
  ZCEMTR  (JLON,0) = 0.0_JPRB
  ZCEMTR  (JLON,1) = 0.0_JPRB
  ZCTRSO  (JLON,0) = 0.0_JPRB
  ZCTRSO  (JLON,1) = 0.0_JPRB
  ZTRSOD  (JLON)   = 0.0_JPRB
  ZSUDU   (JLON)   = 0.0_JPRB
  ZFRSOFS (JLON)   = 0.0_JPRB
  ZXDROV  (JLON)   = 0.0_JPRB
  ZXHROV  (JLON)   = 0.0_JPRB
  ZTAUX   (JLON)   = ZEPS0
  KCLPH   (JLON)   = KLEV
ENDDO
DO JSG  = 1, NSWB_MNH
  DO JLON = KIDIA,KFDIA
    ZALBD   (JLON,JSG) = 0.0_JPRB
    ZALBP   (JLON,JSG) = 0.0_JPRB
    ZSFSWDIF(JLON,JSG) = 0.0_JPRB
    ZSFSWDIR(JLON,JSG) = 0.0_JPRB
  ENDDO
ENDDO

!  -------------------------------------------------------
!  Security values for pseudo-historical arrays at KSTEP=0
!  -------------------------------------------------------

IF((LNEBR.OR.(TRIM(CGMIXLEN) == 'TM')&
        &.OR.(TRIM(CGMIXLEN) == 'TMC')).AND.KSTEP == 0) THEN
  DO JLON=KIDIA,KFDIA
    PPBLH(JLON)=(XMINLM+XMAXLM)*0.5_JPRB
  ENDDO
ENDIF
IF((LNEBCO.OR.LGWDC).AND.KSTEP == 0) THEN
  DO JLON=KIDIA,KFDIA
    PTCCH(JLON)=0.0_JPRB
    PSCCH(JLON)=0.0_JPRB
    PBCCH(JLON)=0.0_JPRB
  ENDDO
ENDIF

IF((LNEBN.OR.LNEBR.OR.LRRGUST).AND.KSTEP == 0) THEN
  DO JLEV=KTDIA-1,KLEV
    DO JLON=KIDIA,KFDIA
      PFPLCH(JLON,JLEV)=0.0_JPRB
    ENDDO
  ENDDO
  IF (LCVPRO) THEN
    PUNEBH(KIDIA:KFDIA,:)=0.0_JPRB
  ENDIF
  IF (LENTCH) THEN
    PENTCH(KIDIA:KFDIA,:)=0.0_JPRB
  ENDIF
ENDIF
IF(LRRGUST.AND.KSTEP == 0) THEN
  DO JLEV=KTDIA-1,KLEV
    DO JLON=KIDIA,KFDIA
      PFPLSH(JLON,JLEV)=0.0_JPRB
    ENDDO
  ENDDO
ENDIF
IF(LCVPGY.AND.KSTEP == 0) THEN
  DO JLEV=KTDIA,KLEV
    DO JLON=KIDIA,KFDIA
      PCVV(JLON,JLEV)=0.0_JPRB
    ENDDO
  ENDDO
ENDIF
IF(LPHSPSH.AND.KSTEP == 0) THEN
  PFHPS(KIDIA:KFDIA)=0._JPRB
ENDIF

!     ------------------------------------------------------------------
!  The LMPHYS and LEPHYS keys should in the following be
! dispached to individual parametrizations.
IF(LMPHYS) THEN
!*
!     ------------------------------------------------------------------
!     4.- CALCULS THERMODYNAMIQUES
!     ----------------------------
  IF ( LTHERMO ) THEN
    CALL ACTQSAT ( KIDIA,KFDIA,KLON,NTQSAT,KLEV,&
     & PAPRSF, PCP, ZQV, PT,&
     & ZGEOSLC, PLH, PLSCPE, PQSAT, PQW, PRH, PTW, 'ACTQSAT' )  
  ENDIF

!*
!     ------------------------------------------------------------------
!     4.BIS. COEFFICIENTS THERMO-HYDRIQUES DU SOL
!     -------------------------------------------

  IF ( .NOT.LMSE ) THEN
    IF ( LSOLV ) THEN
      LLHMT=.FALSE.
      CALL ACSOL ( KIDIA,KFDIA,KLON,&
       & PARG,PD2,PGZ0F,PGZ0RLF,PLSM,PIVEG,&
       & PRHONS,PSAB,PSNS,PTS,PVEG0,PWP,PWPI,PWS,PWSI,&
       & LLHMT,&
       & PC1,PC2,ZC3,ZCG,ZCN,PCT,ZNEIJG,ZNEIJV,&
       & ZWFC,ZWPMX,ZWSEQ,ZWSMX,ZWWILT,'ACSOL  ')  
    ELSE

!            INITIALISATION DE L'INERTIE THERMIQUE DU SOL.

      DO JLON = KIDIA,KFDIA
        PCT(JLON)=HSOL &
         & /(1.0_JPRB+HSOLIWR*(PWS(JLON)+PWP(JLON))/(WSMX+WPMX)&
         & *EXP(-0.5_JPRB*(HSOLIT0*(PTS(JLON)-RTT))**2))  
      ENDDO
    ENDIF
  ENDIF

!*
!     ------------------------------------------------------------------
!     4.TER.- INITIALISATIONS LIEES AU SCHEMA DE SURFACE EXTERNALISE
!     ------------------------------------------------------------------

  IF ( LMSE ) THEN

!     INITIALISATION DU SCHEMA DE SURFACE EXTERNALISE ET DES
!     VARIABLES PSEUDO-HISTORIQUES ASSOCIEES

    IF ( NSWB_MNH /= 1 ) CALL ABOR1('HL_APLPAR: HLRADIA has a single SW band. &
     &                               Set NSWB_MNH = 1')

    DO JLON=KIDIA,KFDIA
      PGZ0     (JLON) = PGPAR(JLON,MGZ0)
      PGZ0H    (JLON) = PGPAR(JLON,MGZ0H)
      PEMIS    (JLON) = PGPAR(JLON,MVEMIS)
      PQS      (JLON) = PGPAR(JLON,MVQS)
      PTS      (JLON) = PGPAR(JLON,MVTS)
      ZSRAIN   (JLON) = PGPAR(JLON,MRAIN)
      ZSSNOW   (JLON) = PGPAR(JLON,MSNOW)
      ZSGROUPEL(JLON) = 0._JPRB
      ZTSN     (JLON) = PTS(JLON)
    ENDDO

    DO JSG=1,NSWB_MNH
      DO JLON=KIDIA,KFDIA
        ZALBP(JLON,JSG) = PGPAR(JLON,MALBDIR-1+JSG)
        ZALBD(JLON,JSG) = PGPAR(JLON,MALBSCA-1+JSG)
      ENDDO
    ENDDO
    PALB(JLON)=0._JPRB
    DO JLON=KIDIA,KFDIA
      DO JSG=1,NSWB_MNH
        PALB(JLON)=PALB(JLON)+0.5*(ZALBP(JLON,JSG)+ZALBD(JLON,JSG))
      ENDDO
      PALB(JLON)=PALB(JLON)/REAL(NSWB_MNH,JPRB)
    ENDDO
    DO JLON=KIDIA,KFDIA
      IF (PEMIS(JLON)==0._JPRB) THEN           
        PEMIS(JLON) = 0.99_JPRB           
        PTS  (JLON) = 288.0_JPRB         
        PALB (JLON) = 0.1_JPRB
      ENDIF
    ENDDO
  ENDIF

!*
!     ------------------------------------------------------------------
!     5.- STRUCTURE ET CHAMPS DANS LA COUCHE LIMITE DE SURFACE
!     ------------------------------------------------------------------

!        INITIALISATION DES HAUTEURS "METEO".

  IF ( LHMTO ) THEN
    DO JLON=KIDIA,KFDIA
      ZDPHIV(JLON)=RG*HVCLS
      ZDPHIT(JLON)=RG*HTCLS
    ENDDO
  ENDIF

  IF ( LVDIF.OR.LHMTO.OR.LGWD ) THEN
    LLCLS=LGWD.OR.LVDIF
    LLHMT=LHMTO
    IF (LMSE) THEN
      CALL ACHMTLS ( KIDIA,KFDIA,KLON,KLEV,&
       & PAPHI,PAPHIF,PAPRS,PAPRSF,PR,PT,PTS,PQS,ZDPHIT,LLCLS,&
       & ZNBVNO,PCPS,ZGWDCS,PLHS,ZPCLS,&
       & 'ACHMTLS ')  
    ELSE
      CALL ACHMT ( KIDIA,KFDIA,KLON,KTDIA,KLEV,KVCLIV,&
       & PAPHI, PAPHIF, PAPRS, PAPRSF, PCP, ZQV, PR, PT, PU, PV,&
       & PFPLSH,PFPLCH,&
       & ZDPHIT, ZDPHIV, PGZ0F, PGZ0HF, PGZ0RLF, PHV, PLSM,&
       & ZNEIJG, ZNEIJV, PSNS, PTS, PVEG0, ZWFC, PWS, PWSI,&
       & LLCLS, LLHMT,&
       & ZNBVNO,&
       & PCD, PCDN, ZCDROV, PCH, ZCHROV, PCPS, ZDQSTS, ZGWDCS,&
       & PGZ0, PGZ0H, ZHQ, ZHU, PNEIJ, PQCLS, PQS, PQSATS, PRHCLS,&
       & PRS, ZRTI, ZSTAB, PTCLS, PUCLS, PVCLS, ZPUCLN, ZPVCLN,&
       & ZPCLS, PVEG, ZXDROV, ZXHROV,PUGST,PVGST,'ACHMT  ')  
      DO JLON=KIDIA,KFDIA
        ZCEROV(JLON) = ZCHROV(JLON)
      ENDDO
    ENDIF
    IF((TRIM(CGMIXLEN) == 'Z').OR. &
      &(TRIM(CGMIXLEN) == 'AY').OR.(TRIM(CGMIXLEN) == 'AYC')) THEN
      DO JLEV=KTDIA,KLEV
        DO JLON=KIDIA,KFDIA
          ZTHETAV(JLON,JLEV)=PT(JLON,JLEV)*(1.0_JPRB+RETV*ZQV(JLON,JLEV)) &
           & *(RATM/PAPRSF(JLON,JLEV))**RKAPPA  
        ENDDO
      ENDDO
      DO JLON=KIDIA,KFDIA
        ZTHETAVS(JLON)=PTS(JLON)*(1.0_JPRB+RETV*PQS(JLON)) &
         & *(RATM/PAPRS(JLON,KLEV))**RKAPPA  
      ENDDO
      CALL ACCLPH ( KIDIA,KFDIA,KLON,KTDIA,KLEV,&
       & ZTHETAV,PAPHI,PAPHIF,PU,PV,ZTHETAVS, &
       & KCLPH,PCLPH,ZUGST,ZVGST,'ACCLPH ')  
      ZBLH(:)=PCLPH(:)
      IF (.NOT.LRAFTUR) THEN
        PUGST(KIDIA:KFDIA)=ZUGST(KIDIA:KFDIA)
        PVGST(KIDIA:KFDIA)=ZVGST(KIDIA:KFDIA)
      ENDIF
    ELSE
      ZBLH(:)=PPBLH(:)
    ENDIF
  ENDIF

!**
!     ------------------------------------------------------------------
!     6.- TURBULENCE: COEFFICIENTS D'ECHANGE
!     ------------------------------------------------------------------
  IF ( (LVDIF.OR.LGWD).AND.(.NOT.(LNEBR.OR.LECT)) ) THEN
    IF(TRIM(CGMIXLEN) == 'Z') THEN

      !-------------------------------------------------
      ! "z dependent" mixing length.
      !-------------------------------------------------

      ZBLH(:)=1.0_JPRB/UHDIFV
      CALL ACMIXLENZ ( KIDIA,KFDIA,KLON, 1,KLEV,&
       & PAPHI,PAPHIF,ZBLH,PGZ0,PGZ0H,ZLMU,ZLMT,'ACMIXLENZ')
    ELSEIF((TRIM(CGMIXLEN) == 'TMC').OR.(TRIM(CGMIXLEN) == 'AYC')) THEN

      ZBLH(:)=MIN(XMAXLM,MAX(XMINLM,ZBLH(:)))

!     Cubique du climat
      CALL ACMIXLENTM ( KIDIA,KFDIA,KLON, 1,KLEV,&
       &PAPHI, PAPHIF,PGZ0,PGZ0H,ZBLH,ZLMU,ZLMT,'ACMIXLENTM')
    ELSEIF(TRIM(CGMIXLEN) == 'TM') THEN
      ZBLH(:)=MIN(XMAXLM,MAX(XMINLM,ZBLH(:)))*XKLM

!     Ancienne formulation pour Lm 
      CALL ACMIXLENZ ( KIDIA,KFDIA,KLON, 1,KLEV,&
        & PAPHI,PAPHIF,ZBLH,PGZ0,PGZ0H,ZLMU,ZLMT,'ACMIXLENZ')

!     Cubique du climat pour Lh
      ZBLH(:)=ZBLH(:)/XKLM
      CALL ACMIXLENTM ( KIDIA,KFDIA,KLON, 1,KLEV,&
       &PAPHI, PAPHIF,PGZ0,PGZ0H,ZBLH,ZZLMT,ZLMT,'ACMIXLENTM')
    ELSEIF(TRIM(CGMIXLEN) == 'AY') THEN
! new Ayotte-Tudor ZBLH & mixing length
      CALL ACMIXLENZ ( KIDIA,KFDIA,KLON, 1,KLEV,&
        & PAPHI,PAPHIF,ZBLH,PGZ0,PGZ0H,ZLMU,ZLMT,'ACMIXLENZ')
    ELSE
      CLERR='HL_APLPAR: UNEXPECTED VALUE FOR CGMIXLEN: '//TRIM(CGMIXLEN)
      CALL ABOR1(CLERR)
    ENDIF

     !-------------------------------------------------
     ! Compute diffusion coefficients.
     !-------------------------------------------------
    IF (LPTKE) THEN
       PTKE(KIDIA:KFDIA,1:KLEV) = MAX(PTKE(KIDIA:KFDIA,1:KLEV),0.00000001_JPRB)
    ENDIF

    CALL ACCOEFK ( KIDIA,KFDIA,KLON,NTCOEF,KLEV,&
     & PAPHI, PAPHIF, PAPRS, PAPRSF, PCP, PDELP, PLSCPE, ZQV, ZQL, ZQI, PQSAT,&
     & PR, PT, PU, PV, PFPLSH, PFPLCH, ZLMU, ZLMT, PGZ0, PGZ0H, ZBLH,&
     & ZKTROV, ZKUROV, ZKNROV, ZNBVNO, ZXTROV, ZXUROV, ZXPTKEROV,&   
     & 'ACCOEFK')
  ENDIF

!**
!     ------------------------------------------------------------------
!     7.- RAYONNEMENT
!     ----------------

!      7.1 Albedo et emissivite en presence de neige
!          Albedo and emissivity with snow

  IF (.NOT.LMSE) THEN
  DO JLON=KIDIA,KFDIA
    IF (LSNV) THEN
      IF ((PVEG0(JLON) < 0.01_JPRB).OR.(PALBF(JLON) >= 0.60_JPRB)) THEN
        ZALBV=0.0_JPRB
        PALBSF(JLON)=PALBF(JLON)
      ELSE
        ZALBV=(PALBF(JLON)-(1.0_JPRB-PVEG0(JLON))*PALBSF(JLON))/PVEG0(JLON)
      ENDIF
      PALB(JLON)= (1.0_JPRB-PVEG0(JLON))*(1.0_JPRB-ZNEIJG(JLON)) *&
       & PALBSF(JLON)&
       & + (1.0_JPRB-PVEG0(JLON))*ZNEIJG(JLON) *&
       & MAX(PALBSF(JLON),PALBNS(JLON))&
       & + PVEG0(JLON)*ZNEIJV(JLON) *&
       & MAX(ZALBV,PALBNS(JLON))&
       & + PVEG0(JLON)*(1.0_JPRB-ZNEIJV(JLON)) * ZALBV  
      PEMIS(JLON)= (1.0_JPRB-PVEG0(JLON))*(1.0_JPRB-ZNEIJG(JLON)) *&
       & PEMISF(JLON)&
       & + (1.0_JPRB-PVEG0(JLON))*ZNEIJG(JLON) * EMCRIN &
       & + PVEG0(JLON)*ZNEIJV(JLON) * EMCRIN &
       & + PVEG0(JLON)*(1.0_JPRB-ZNEIJV(JLON)) * PEMISF(JLON)  
    ELSE
      IF (LVGSN) THEN
        ZCFN = (1.0_JPRB-MAX(0.0_JPRB,MIN(1.0_JPRB,PLAI(JLON)/RLAIMX)))*&
         & MAX(0.0_JPRB,SIGN(1.0_JPRB,PLAI(JLON)-RLAI)) + &
         & (1.0_JPRB-MAX(0.0_JPRB,SIGN(1.0_JPRB,PLAI(JLON)-RLAI)))  

        ZCK = MAX(0.0_JPRB,(ALB1-MAX(ALB2,PALBNS(JLON))))/(ALB1-ALB2)
        ZCOEF= ZCFN * ZCK + (1.0_JPRB- ZCK)

        ZVNEIJ=PNEIJ(JLON)*ZCOEF
        PALB(JLON)=PALBF(JLON)-PNEIJ(JLON)*(PALBF(JLON)&
         & -PALBNS(JLON)) &
         & +(PNEIJ(JLON)-ZVNEIJ)*PVEG0(JLON)*(PALV(JLON)-PALBNS(JLON))  

        PALB(JLON)=MIN(ABS(PIVEG(JLON)-2._JPRB),1.0_JPRB) * PALB(JLON) +&
         & (1.0_JPRB-MIN(ABS(PIVEG(JLON)-2._JPRB),1.0_JPRB)) &
         & * MAX(ALCRIN,PALB(JLON))  
        PALBH(JLON)=PALB(JLON)

        PEMIS(JLON)=PEMISF(JLON)-PNEIJ(JLON)*(PEMISF(JLON)-EMCRIN)

      ELSE
        PALB(JLON)=PALBF(JLON)-PNEIJ(JLON)*(PALBF(JLON)&
         & -MAX(PALBF(JLON),ALCRIN))  
        PEMIS(JLON)=PEMISF(JLON)-PNEIJ(JLON)*(PEMISF(JLON)-EMCRIN)
      ENDIF
    ENDIF
  ENDDO
  ENDIF
! ---------------------------------------------------------------------
! Call the HIRLAM radiation scheme

  IF( (LHL).AND.(HLOPTION(1) == 1) ) THEN

!   Make sure that cloud cover and cloud condensates
!   are non-negative as input to the radiation scheme.

    DO JLEV=KTDIA,KLEV
      DO JLON=KIDIA,KFDIA
        PA(JLON,JLEV)  = MAX( 0.0_JPRB, MIN( PA(JLON,JLEV), 1.0_JPRB ) )
        PQL(JLON,JLEV) = MAX( 0.0_JPRB, PQL(JLON,JLEV) )
        PQI(JLON,JLEV) = MAX( 0.0_JPRB, PQI(JLON,JLEV) )
      ENDDO
    ENDDO

    CALL HLRAD( KSTEP,      KLON,       KLEV,       &
 &              KIDIA,      KFDIA,      ZVETAF,     &
 &              ZVETAH,     PGELAM,     PGEMU,      &
 &              PALB,       PEMIS,      PTS,        &
 &              PT,         PQ,         PQL,        &
 &              PQI,        PAPRSF,     PAPRS,      &
 &              PLSM,       PDELP,      PA,         &
 &              PMU0,       PFRTHDS,    ZFRSOFS,    &
 &              PFRSODS,    PFRTH,      PFRSO,      &
 &              PTENDT      )

  ENDIF

! ---------------------------------------------------------------------


!*
!     ------------------------------------------------------------------

!     7.BIS. BILAN HYDRIQUE DU SOL
!     ----------------------------
!     CALCUL DES RESISTANCES A L'EVAPOTRANSPIRATION HV ET
!     A LA TRANSPIRATION
!     ------------------------------------------------------------------
!     HTR DU COUVERT VEGETAL
!     ----------------------

  IF (LSOLV.AND.(.NOT.LMSE)) THEN
    CALL ACVEG ( KIDIA,KFDIA,KLON,KLEV,&
     & PFRSO,ZQV,PQSAT,PT,&
     & PD2,PLSM,PIVEG,PLAI,PNEIJ,PVEG,PRSMIN,&
     & ZCHROV,ZGWDCS,ZWFC,PWL,ZWWILT,PWP,PQSATS,&
     & ZHQ,ZHTR,ZHU,PHV,ZWLMX,'ACVEG  ' )  
  ENDIF

!     ------------------------------------------------------------------
!     8.- DIFFUSION VERTICALE TURBULENTE
!     ----------------------------------
  IF ( LVDIF ) THEN

    IF (LMSE) THEN


      IF (LHL) THEN
        ZCARDI=QCO2
        DO JLON=KIDIA,KFDIA
          ZSFSWDIF(JLON,1) = ZFRSOFS(JLON)
          ZSFSWDIR(JLON,1) = PFRSODS(JLON) - ZFRSOFS(JLON)

          ZFEV  (JLON) =0.0_JPRB 
          ZFMDU (JLON) =0.0_JPRB 
          ZFMDV (JLON) =0.0_JPRB
        ENDDO
      ENDIF

      DO JLON=KIDIA,KFDIA
        ZRHODREFM(JLON)=PAPRSF(JLON,KLEV)/(PT(JLON,KLEV)*PR(JLON,KLEV))
        ZDEPTH_HEIGHT_LOW(JLON)=(PAPHIF(JLON,KLEV)-PAPHI(JLON,KLEV))/RG
        ZZS(JLON)=PAPHI(JLON,KLEV)/RG
      ENDDO

!     The "ZCF"-arrays not used in explicit call to 
!     externalised surface scheme and are initialized to zero.

      DO JLEV=KTDIA,KLEV
        DO JLON=KIDIA,KFDIA      
          ZCFAQ(JLON,JLEV)  = 0.0_JPRB  
          ZCFATH(JLON,JLEV) = 0.0_JPRB
          ZCFAU(JLON,JLEV)  = 0.0_JPRB 
          ZCFBQ(JLON,JLEV)  = 0.0_JPRB 
          ZCFBTH(JLON,JLEV) = 0.0_JPRB
          ZCFBU(JLON,JLEV)  = 0.0_JPRB
          ZCFBV(JLON,JLEV)  = 0.0_JPRB
        ENDDO
      ENDDO
 
      IRR=2
      LLD_NBLOCKTOT=.FALSE.

      CALL ARO_GROUND_PARAM( KBL, KGPCOMP, LLD_NBLOCKTOT, &
       & KFDIA-KIDIA+1, KIDIA, KFDIA, &
       & IRR, NSWB_MNH, NGFL_EXT, LMPA, CCOUPLING, &
       & NINDAT, REAL(NSSSSS,JPRB), RSOVR, RCODEC, RSIDEC, &
       & PU(KIDIA:KFDIA,KLEV:KLEV),PV(KIDIA:KFDIA,KLEV:KLEV), &
       & PT(KIDIA:KFDIA,KLEV:KLEV),PQ(KIDIA:KFDIA,KLEV:KLEV),&
       & ZSVM(KIDIA:KFDIA,1:NGFL_EXT), &
       & ZCARDI, &
       & ZRHODREFM(KIDIA:KFDIA), &
       & PAPRSF(KIDIA:KFDIA,KLEV:KLEV),PAPRS(KIDIA:KFDIA,KLEV:KLEV), &
       & TSPHY,ZDEPTH_HEIGHT_LOW(KIDIA:KFDIA),ZZS(KIDIA:KFDIA),&
       & PMU0(KIDIA:KFDIA),PGELAM(KIDIA:KFDIA),PGEMU(KIDIA:KFDIA),XSW_BANDS,&
       & ZSRAIN(KIDIA:KFDIA),ZSSNOW(KIDIA:KFDIA), &
       & ZSGROUPEL(KIDIA:KFDIA), &
       & PFRTHDS(KIDIA:KFDIA),ZSFSWDIF(KIDIA:KFDIA,1:NSWB_MNH), &
       & ZSFSWDIR(KIDIA:KFDIA,1:NSWB_MNH),&
       & ZCFAQ(KIDIA:KFDIA,KLEV:KLEV), ZCFATH(KIDIA:KFDIA,KLEV:KLEV), &
       & ZCFAU(KIDIA:KFDIA,KLEV:KLEV), &
       & ZCFBQ(KIDIA:KFDIA,KLEV:KLEV), ZCFBTH(KIDIA:KFDIA,KLEV:KLEV), &
       & ZCFBU(KIDIA:KFDIA,KLEV:KLEV), & 
       & ZCFBV(KIDIA:KFDIA,KLEV:KLEV), &
       & PFCS(KIDIA:KFDIA,1),ZFEV(KIDIA:KFDIA), &
       & ZSFSV(KIDIA:KFDIA,1:NGFL_EXT),ZSFCO2(KIDIA:KFDIA), &
       & ZFMDU(KIDIA:KFDIA),ZFMDV(KIDIA:KFDIA), &
       & ZALBP(KIDIA:KFDIA,1:NSWB_MNH),ZALBD(KIDIA:KFDIA,1:NSWB_MNH), &
       & PEMIS(KIDIA:KFDIA),ZTSN(KIDIA:KFDIA))

      CALL ARO_GROUND_DIAG( KBL, KGPCOMP, LLD_NBLOCKTOT, &
       & KFDIA-KIDIA+1, KIDIA, KFDIA, &
       & ZZS(KIDIA:KFDIA), PU(KIDIA:KFDIA,KLEV), PV(KIDIA:KFDIA,KLEV), &
       & PQS(KIDIA:KFDIA), PGZ0(KIDIA:KFDIA), &
       & PGZ0H(KIDIA:KFDIA), PTCLS (KIDIA:KFDIA), &
       & PQCLS(KIDIA:KFDIA), PRHCLS(KIDIA:KFDIA), &
       & PUCLS(KIDIA:KFDIA), PVCLS(KIDIA:KFDIA), &
       & PFCLL(KIDIA:KFDIA,1), PFCLN(KIDIA:KFDIA,1))
 
      DO JLON=KIDIA,KFDIA
        PGPAR(JLON,MGZ0)   = PGZ0 (JLON)
        PGPAR(JLON,MGZ0H)  = PGZ0H(JLON)
        PGPAR(JLON,MVEMIS) = PEMIS(JLON)
        PGPAR(JLON,MVTS)   = ZTSN (JLON)
        PGPAR(JLON,MVQS)   = PQS  (JLON)
      ENDDO

      DO JLON=KIDIA,KFDIA
        DO JSG=1,NSWB_MNH
          PGPAR(JLON,MALBSCA-1+JSG) = ZALBD(JLON,JSG)
          PGPAR(JLON,MALBDIR-1+JSG) = ZALBP(JLON,JSG)
        ENDDO
      ENDDO

    ELSE

    ! ------------------------------------------------------
    ! CALCUL DES FLUX TURBULENTS.
    ! ------------------------------------------------------

      IF(NDIFFNEB == 1) THEN
        ZNEBDIFF(:,:)=ZNEBS(:,:)
      ELSEIF(NDIFFNEB == 2) THEN
        ZNEBDIFF(:,:)=PNEB(:,:)
      ENDIF

      CALL ACDIFUS ( KIDIA,KFDIA,KLON,NTDIFU,KLEV,KCSS,&
       & PAPHI, PAPHIF, PCP, PDELP, PFRSO, ZKTROV, ZKUROV, ZKNROV,&
       & ZQV, PRDELP, PT, PU, PV, ZXTROV, ZXUROV, ZXPTKEROV, PALPH,&
       & PAPRSF, PAPRS, PR, ZQL, ZQI, ZNEBDIFF, PTKE, ZLMU, PLNPR,&
       & PCD, PCDN, ZCDROV, ZCHROV, ZCEROV, PCPS, PCT,ZDQSTS,&
       & PEMIS, PFHPS, ZHQ, ZHTR, ZHU, PHV,&
       & PLSM, PIVEG, PNEIJ, PQS, PQSATS, PTP, PTS, PVEG,&
       & ZXDROV, ZXHROV, PWS, PWSI,&
       & PDIFTQ, PDIFTS, PSTRTU, PSTRTV,&
       & PDIFTQL, PDIFTQI, PTENDPTKE, &
       & PFCHSP, PFCLL, PFCLN, PFCS, PFEVI, PFEVL, PFEVN, PFEVV,&
       & PFTR, PLHS, PFRTH, PGZ0F, PGZ0HF, 'ACDIFUS' )

    ENDIF


    ! ------------------------------------------------------
    ! DIAGNOSTIC DE LA HAUTEUR DE COUCHE LIMITE, SELON TROEN ET MAHRT,
    ! POUR USAGE AU PAS DE TEMPS SUIVANT.
    ! ------------------------------------------------------

    IF((TRIM(CGMIXLEN) == 'TM').OR.(TRIM(CGMIXLEN) == 'TMC')) THEN
      ZBLH(:)=MIN(XMAXLM,MAX(XMINLM,PPBLH(:)))
      CALL ACPBLHTM ( KIDIA,KFDIA,KLON,NTDIFU,KLEV,&
       & PAPHI, PAPHIF, PDELP, PCP,&
       & ZQV, PT, PU, PV,PAPRSF,PR,&
       & PSTRTU, PSTRTV,&
       & ZPCLS, PTCLS,PQCLS,&
       & PFCS,PFCLL,PFCLN,PLHS, PGZ0, &
       & KCLPH,ZBLH,ZUGST,ZVGST,'ACPBLHTM' )  
      PPBLH(:)=ZBLH(:)
      PCLPH(:)=ZBLH(:)
      IF (.NOT.LRAFTUR) THEN
        PUGST(KIDIA:KFDIA)=ZUGST(KIDIA:KFDIA)
        PVGST(KIDIA:KFDIA)=ZVGST(KIDIA:KFDIA)
      ENDIF
    ENDIF

    IF(LNEBCO.AND.LNEBR)THEN
      CALL ACPBLH ( KIDIA,KFDIA,KLON,NTDIFU,KLEV,&
       & PAPHI, PAPHIF, PCP,&
       & ZQV, PT, PU, PV,PAPRSF,PR,&
       & PSTRTU, PSTRTV,&
       & ZPCLS, PTCLS,PQCLS,&
       & PFCS,PFCLL,PFCLN,PLHS,ZRTI,PPBLH,'ACPBLH' )  
    ENDIF

  ENDIF ! LVDIF

!     DIAGNOSTIC SUPPLEMENTAIRE FLUX DE RAYONNEMENT (PFRTHDS ET PFRSOPT)
!     ADDITIONAL DIAGNOSTICS OF RADIATIVE FLUXES (PFRTHDS AND PFRSOPT)

  DO JLON=KIDIA,KFDIA
    PFRTHDS(JLON)=PFRTH(JLON,KLEV,1)+RSIGMA*PEMIS(JLON)*PTS(JLON)**4
    IF(PMU0(JLON) <= 0.0_JPRB) THEN

!     NUIT : FLUX SOLAIRE NUL
!     NIGHT: SOLAR FLUX IS EQUAL TO ZERO

      PFRSOPT(JLON)=0.0_JPRB
    ELSE
      PFRSOPT(JLON)=RII0*PMU0(JLON)
    ENDIF
  ENDDO

! ADDITIONAL DIAGNOSTIC OF THE DERIVATIVE OF THE NON SOLAR SURFACE
! HEAT FLUX WITH RESPECT TO SURFACE TEMPERATURE (PDERNSHF)

  IF(LMCC03)THEN
    CALL ACDNSHF(KIDIA, KFDIA, KLON, KTDIA, KLEV,&
     & PEMIS, PLSM, PNEIJ, ZQV, PQS, PTS, ZCHROV,  ZDQSTS,&
     & PDERNSHF, 'ACDNSHF')  
  ENDIF

! ---------------------------------------------------------------------
! Call the HIRLAM TKE based turbulence scheme 

  IF( (LHL).AND.((HLOPTION(3) == 2).OR.(HLOPTION(3) == 3)) ) THEN

!   HIRLAM TKE scheme

!   Do a final computation of tubulent transports
!   taking into account turbulent kinetic energy
!   in the formulation of the mixing process.

!   ----------------------------------------------
     CALL HLTURB( KSTEP  ,                      &
    &             LMSE   ,                      &
    &             KLON   ,  KLEV  ,   KIDIA   , &
    &             KFDIA  ,  TSPHY ,   PT      , &
    &             PQ     ,  PU    ,   PV      , &
    &             PQL    ,  PQI   ,   PTKE    , &
    &             PAPHI  ,                      &
    &             PAPHIF ,  PAPRSF,   PAPRS   , &
    &             PTS    ,  PCLPH ,             &
    &             PA     ,  PDIFTS,   PDIFTQ  , &
    &             PDIFTQL,  PDIFTQI,  PFTKE   , &
    &             PSTRTU ,  PSTRTV,   PFCS    , &
    &             ZFEV   ,  ZFMDU ,   ZFMDV   , &
    &             PTENDU ,  PTENDV,   PTENDT  , &
    &             PTENDTKE, PTENDQ,   PTENDQL , &
    &             PTENDQI,                      &
    &             'HLTURB')

  ENDIF
! ----------------------------------------------------------------------
!*
!     ------------------------------------------------------------------
!     9.- TRAINEE DES ONDES DE GRAVITE INDUITES PAR LE RELIEF
!     ------------------------------------------------------------------
  IF ( LGWD ) THEN
    CALL ACDRAG ( KIDIA,KFDIA,KLON,NTDRAG,KLEV,&
     & PAPRS, PAPRSF,&
     & PDELP, ZNBVNO, PRDELP, PU, PV,&
     & PRCORI,PGETRL, ZGWDCS,&
     & PVRLAN , PVRLDI,&
     & PSTRDU, PSTRDV, 'ACDRAG ' )  
  ENDIF

!     ---------------------------------------------------------
!     10.- PRECIPITATION
!     ---------------------------------------------------------

  IF (LHL.AND.LVDIF) THEN

!   10.1 - moisture convergence for the convection include 
!          the effect of turbulence. 

    DO JLEV = KTDIA, KLEV
      DO JLON = KIDIA, KFDIA
        PCVGQ(JLON,JLEV) = PCVGQ(JLON,JLEV)&
         & -RG*PRDELP(JLON,JLEV)&
         & *(PDIFTQ(JLON,JLEV)-PDIFTQ(JLON,JLEV-1) )
      ENDDO
    ENDDO

!  10.2 - Call the STRACO scheme for clouds, 
!         condensation and convection 

    IF( (KSTEP > 1).AND.((HLOPTION(2) == 1).OR. &
 &                      (HLOPTION(2) == 5)) ) THEN
!  -----------------------------------------------
        CALL HLSTRACO (                       &
!       scalars
       &     1,          KLON,      KLEV,     &
       &     KIDIA,      KFDIA,     KSTEP,    &
       &     TSPHY,     .true.,               & 
!       prognostic variables  
       &     PU,         PV,        PT,       &
       &     PQ,         PQL,       PQI,      & 
       &     PQVA,       PTKE,                &
!       diagnostic arrays
       &     PA,         PVERVEL,    PLSM,     &
       &     PCVGQ,      PCVGQL,    PCVGQI,   &   
       &     PCVGT,      PAPRSF,    PAPRS,    &
       &     PTENDT,     PTENDQ,    PTENDQL,  &
       &     PTENDQI,                         &
!       fluxes 
       &     PDIFTQ,     PDIFTQL,   PDIFTQI,  &
       &     PDIFTS,     PDIFCQ,    PDIFCQL,  &
       &     PDIFCQI,    PDIFCS,    PFCCQL,   & 
       &     PFCCQN,     PFCSQL,    PFCSQN,   &
       &     PFPLCL,     PFPLCN,    PFPLSL,   &
       &     PFPLSN,                          &
       &     'HLSTRACO'                       )

!       10.3 - Diagnostic cloud computations  

        CALL HLCLDIA (                        &
       &     1,          KLON,      KLEV,     &
       &     KIDIA,      KFDIA,     KSTEP,    &
       &     PA,         PAPRSF,    PAPRS,    &
       &     PCLCH,      PCLCM,     PCLCL,    &
       &     PCLCT,      'HLCLDIA'            )

    ENDIF
  ENDIF 
! ------------------------------------------------------------
!     11.- PRECIPITATIONS SOUS-MAILLES.
!     ---------------------------------

  IF ( LGWDC ) THEN
    CALL ACDRAC ( KIDIA,KFDIA,KLON,NTDRAG,KLEV,&
     & PAPRS, ZNBVNO, PRDELP, PU, PV,&
     & PFPLCL, PFPLCN, PSCCH, PBCCH,&
     & PSTRCU, PSTRCV, 'ACDRAC ' )
  ENDIF

!*
!     ------------------------------------------------------------------
!       SAUVEGARDE DES FLUX DE PRECIPITATION CONVECTIVE ET STRATIFORME.

  IF(LNEBN.OR.LNEBR.OR.LRRGUST) THEN
    IF (LFPCOR) THEN
      IF (LCDDPRO) THEN
        DO JLEV=KTDIA-1,KLEV
          DO JLON=KIDIA,KFDIA
            PFPLCH(JLON,JLEV)=PFPLCL(JLON,JLEV)+PFPLCN(JLON,JLEV)
          ENDDO
        ENDDO
      ELSE
        DO JLEV=KTDIA-1,KLEV
          DO JLON=KIDIA,KFDIA
            PFPLCH(JLON,JLEV)=ZFPCOR(JLON,JLEV)
          ENDDO
        ENDDO
      ENDIF
    ELSE
      DO JLEV=KTDIA-1,KLEV
        DO JLON=KIDIA,KFDIA
          PFPLCH(JLON,JLEV)=PFPLCL(JLON,JLEV)+PFPLCN(JLON,JLEV)
        ENDDO
      ENDDO
    ENDIF
  ENDIF

  IF(LRRGUST) THEN
    DO JLEV=KTDIA-1,KLEV
      DO JLON=KIDIA,KFDIA
        PFPLSH(JLON,JLEV)=PFPLSL(JLON,JLEV)+PFPLSN(JLON,JLEV)
      ENDDO
    ENDDO
  ENDIF


!*
!     ------------------------------------------------------------------
!     12. - BILAN HYDRIQUE DU SOL
!     ---------------------------
  IF ( LMSE ) THEN
    DO JLON=KIDIA,KFDIA
      PGPAR(JLON,MRAIN) = PFPLSL(JLON,KLEV)+PFPLCL(JLON,KLEV)
      PGPAR(JLON,MSNOW) = PFPLSN(JLON,KLEV)+PFPLCN(JLON,KLEV)
    ENDDO

  ELSE

  IF ( LSFHYD ) THEN
    IF ( LSOLV ) THEN
      CALL ACDROV ( KIDIA,KFDIA,KLON,KTDIA,KLEV,KCSS,&
       & PFPLCL, PFPLCN, PFPLSL, PFPLSN, PFRSO, PFRTH,&
       & PC1, PC2, ZC3, ZCN, PCT, PD2, PFEVV, PFTR, PLAI, PNEIJ,&
       & PVEG, ZWFC, ZWPMX, PWL, ZWLMX, ZWSEQ, ZWSMX,&
       & PFCHSP, PFCLL, PFCLN, PFCS, PFEVI, PFEVL, PFEVN, PLSM, PSNS,&
       & PTP, PTS, PWP, PWPI, PWS, PWSI,&
       & PFGEL, PFGELS,&
       & PFLWSP, PFONTE, PRUISP, PRUISL, PRUISS,'ACDROV ' )  
    ENDIF
  ENDIF

  ENDIF

!*
!-  --------------------------------------------------------------------
!     13.- DRAG MESOSPHERIQUE POUR UN MODELE POSSEDANT DES NIVEAUX
!               AU-DESSUS DE 50 KM (I.E. DANS LA MESOSPHERE)
!     ------------------------------------------------------------------
  IF ( LRRMES ) THEN
    CALL ACDRME ( KIDIA,KFDIA,KLON,NTDRME,KLEV,&
     & PCP,PDELP,PT,ZQV,PU,PV,&
     & PFRMH,PFRMQ,PSTRMU,PSTRMV,&
     & RMESOT,RMESOQ,RMESOU,STTEM,'ACDRME ')
  ENDIF

!*
!     ------------------------------------------------------------------
!     14.- FLUX PHOTO-CHIMIQUE D'OZONE
!     ------------------------------------------------------------------
  IF ( LOZONE ) THEN
    CALL ACOZONE ( KIDIA,KFDIA,KLON,NTOZON,KLEV,KVCLIS,&
     & PAPRS,PAPRSF,PDELP,PKOZO,ZQO3(1,1),PT,PMU0,&
     & PFCHOZ,'ACOZONE')  

!           DIFFUSION TURBULENTE/DEPOT SEC DE L'OZONE

    CALL ACDIFOZ ( KIDIA,KFDIA,KLON,KTDIA,KLEV,&
     & PAPRSF,PDELP,PFPLCL,PFPLSL,PFRSO,&
     & ZKTROV,ZQO3(1,1),PRDELP,PT,ZXTROV,&
     & PNEIJ,PGEMU,PIVEG,&
     & PFCHOZ,'ACDIFOZ')  
  ENDIF
!*
!     ------------------------------------------------------------------
!     15.- CALCUL DES FLUX D'ENTHALPIE ET DE CHALEUR SENSIBLE LIES AUX
!          PRECIPITATIONS EN FONCTION DES FLUX DE PRECIPITATION
!          ET DE CONDENSATION.
!     ------------------------------------------------------------------

  ! STORE THE PSEUDO-HISTORIC SURFACE PRECIPITATION SENSIBLE HEAT FLUX
  ! -------------------------------------------------------------------

  IF (LPHSPSH) THEN
    DO JLON=KIDIA, KFDIA
       PFHPS(JLON)=(PT(JLON,KLEV)-PTS(JLON)) * &
         &  ((RCW-RCPD)*(PFPLSL(JLON,KLEV)+PFPLCL(JLON,KLEV)) &
         &  +(RCS-RCPD)*(PFPLSN(JLON,KLEV)+PFPLCN(JLON,KLEV)) )
    ENDDO
  ENDIF !LPHSPSH

ENDIF

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('HL_APLPAR',1,ZHOOK_HANDLE)
END SUBROUTINE HL_APLPAR
