!OPTIONS XOPT(NOEVAL)
subroutine posct(knoir,ptimtr,plon,plat)

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KNOIR 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PTIMTR 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PLON 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PLAT 
INTEGER(KIND=JPIM) :: iok, jbouc

REAL(KIND=JPRB) :: zcondr, zelapsed, zfrac

! --------------------------------------------------------------
! --------------------------------------------------------------
! **** *posct* Compute POSition of Center of Totality.
! **** *posct* Compute POSition of Center of Totality.
! --------------------------------------------------------------
! --------------------------------------------------------------
! Sujet:
! Sujet:
! Arguments explicites:
! Arguments explicites:
! Arguments implicites:
! Arguments implicites:
! Methode:
! Methode:
! Externes:
! Externes:
! Auteur:   1999-07, J.M. Piriou.
! Auteur:   1999-07, J.M. Piriou.
! Modifications:
! Modifications:
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
! --------------------------------------------------------------
! --------------------------------------------------------------
! Input:
! Input:
! ptimtr: time since 1.1.200012 UTC (seconds).
! ptimtr: time since 1.1.200012 UTC (seconds).
! Output:
! Output:
! plon: longitude of central totality zone (rad).
! plon: longitude of central totality zone (rad).
! plat: latitude of central totality zone (rad).
! plat: latitude of central totality zone (rad).
! --------------------------------------------------------------
! --------------------------------------------------------------

REAL(KIND=JPRB) :: zhutc(36)
REAL(KIND=JPRB) :: zlat_deg(36)
REAL(KIND=JPRB) :: zlon_deg(36)
REAL(KIND=JPRB) :: zh1c(36)
REAL(KIND=JPRB) :: zh2c(36)
REAL(KIND=JPRB) :: zh3c(36)
REAL(KIND=JPRB) :: zh4c(36)
REAL(KIND=JPRB) :: ZHOOK_HANDLE

!-------------------------------------------------
!-------------------------------------------------
! "Hard-data" got from french "Bureau des Longitudes".
! "Hard-data" got from french "Bureau des Longitudes".
!-------------------------------------------------
!-------------------------------------------------

IF (LHOOK) CALL DR_HOOK('POSCT',0,ZHOOK_HANDLE)
zhutc(01)=   9.58333_JPRB
zlat_deg(01)=  45.98000_JPRB
zlon_deg(01)= -44.36167_JPRB
zh1c(01)=   8.59967_JPRB
zh2c(01)=   9.57331_JPRB
zh3c(01)=   9.59339_JPRB
zh4c(01)=  10.65775_JPRB

zhutc(02)=   9.66667_JPRB
zlat_deg(02)=  47.69167_JPRB
zlon_deg(02)= -35.03333_JPRB
zh1c(02)=   8.62994_JPRB
zh2c(02)=   9.65506_JPRB
zh3c(02)=   9.67831_JPRB
zh4c(02)=  10.80208_JPRB

zhutc(03)=   9.75000_JPRB
zlat_deg(03)=  48.74167_JPRB
zlon_deg(03)= -29.72000_JPRB
zh1c(03)=   8.67011_JPRB
zh2c(03)=   9.73714_JPRB
zh3c(03)=   9.76292_JPRB
zh4c(03)=  10.93247_JPRB

zhutc(04)=   9.83333_JPRB
zlat_deg(04)=  49.42500_JPRB
zlon_deg(04)= -23.40667_JPRB
zh1c(04)=   8.71547_JPRB
zh2c(04)=   9.81939_JPRB
zh3c(04)=   9.84733_JPRB
zh4c(04)=  11.05481_JPRB

zhutc(05)=   9.91667_JPRB
zlat_deg(05)=  49.86167_JPRB
zlon_deg(05)= -18.45167_JPRB
zh1c(05)=   8.76433_JPRB
zh2c(05)=   9.90175_JPRB
zh3c(05)=   9.93161_JPRB
zh4c(05)=  11.17122_JPRB

zhutc(06)=  10.00000_JPRB
zlat_deg(06)=  50.11167_JPRB
zlon_deg(06)= -13.03667_JPRB
zh1c(06)=   8.81589_JPRB
zh2c(06)=   9.98422_JPRB
zh3c(06)=  10.01581_JPRB
zh4c(06)=  11.28283_JPRB

zhutc(07)=  10.08333_JPRB
zlat_deg(07)=  50.21000_JPRB
zlon_deg(07)=  -9.26167_JPRB
zh1c(07)=   8.86969_JPRB
zh2c(07)=  10.06678_JPRB
zh3c(07)=  10.09992_JPRB
zh4c(07)=  11.39022_JPRB

zhutc(08)=  10.16667_JPRB
zlat_deg(08)=  50.18167_JPRB
zlon_deg(08)=  -5.19667_JPRB
zh1c(08)=   8.92547_JPRB
zh2c(08)=  10.14942_JPRB
zh3c(08)=  10.18394_JPRB
zh4c(08)=  11.49389_JPRB

zhutc(09)=  10.25000_JPRB
zlat_deg(09)=  50.04667_JPRB
zlon_deg(09)=  -2.88500_JPRB
zh1c(09)=   8.98311_JPRB
zh2c(09)=  10.23214_JPRB
zh3c(09)=  10.26789_JPRB
zh4c(09)=  11.59408_JPRB

zhutc(10)=  10.33333_JPRB
zlat_deg(10)=  49.81667_JPRB
zlon_deg(10)=   0.36000_JPRB
zh1c(10)=   9.04250_JPRB
zh2c(10)=  10.31492_JPRB
zh3c(10)=  10.35178_JPRB
zh4c(10)=  11.69108_JPRB

zhutc(11)=  10.41667_JPRB
zlat_deg(11)=  49.50333_JPRB
zlon_deg(11)=   3.64833_JPRB
zh1c(11)=   9.10367_JPRB
zh2c(11)=  10.39778_JPRB
zh3c(11)=  10.43558_JPRB
zh4c(11)=  11.78508_JPRB

zhutc(12)=  10.50000_JPRB
zlat_deg(12)=  49.11500_JPRB
zlon_deg(12)=   6.77000_JPRB
zh1c(12)=   9.16656_JPRB
zh2c(12)=  10.48067_JPRB
zh3c(12)=  10.51933_JPRB
zh4c(12)=  11.87628_JPRB

zhutc(13)=  10.58333_JPRB
zlat_deg(13)=  48.65833_JPRB
zlon_deg(13)=   9.74333_JPRB
zh1c(13)=   9.23122_JPRB
zh2c(13)=  10.56367_JPRB
zh3c(13)=  10.60303_JPRB
zh4c(13)=  11.96486_JPRB

zhutc(14)=  10.66667_JPRB
zlat_deg(14)=  48.14000_JPRB
zlon_deg(14)=  12.58167_JPRB
zh1c(14)=   9.29769_JPRB
zh2c(14)=  10.64669_JPRB
zh3c(14)=  10.68664_JPRB
zh4c(14)=  12.05094_JPRB

zhutc(15)=  10.75000_JPRB
zlat_deg(15)=  47.56500_JPRB
zlon_deg(15)=  15.30000_JPRB
zh1c(15)=   9.36606_JPRB
zh2c(15)=  10.72981_JPRB
zh3c(15)=  10.77017_JPRB
zh4c(15)=  12.13469_JPRB

zhutc(16)=  10.83333_JPRB
zlat_deg(16)=  46.93833_JPRB
zlon_deg(16)=  17.91000_JPRB
zh1c(16)=   9.43633_JPRB
zh2c(16)=  10.81300_JPRB
zh3c(16)=  10.85367_JPRB
zh4c(16)=  12.21625_JPRB

zhutc(17)=  10.91667_JPRB
zlat_deg(17)=  46.26000_JPRB
zlon_deg(17)=  20.42500_JPRB
zh1c(17)=   9.50864_JPRB
zh2c(17)=  10.89622_JPRB
zh3c(17)=  10.93708_JPRB
zh4c(17)=  12.29572_JPRB

zhutc(18)=  11.00000_JPRB
zlat_deg(18)=  45.53500_JPRB
zlon_deg(18)=  22.85500_JPRB
zh1c(18)=   9.58300_JPRB
zh2c(18)=  10.97953_JPRB
zh3c(18)=  11.02044_JPRB
zh4c(18)=  12.37328_JPRB

zhutc(19)=  11.08333_JPRB
zlat_deg(19)=  44.76667_JPRB
zlon_deg(19)=  25.21000_JPRB
zh1c(19)=   9.65956_JPRB
zh2c(19)=  11.06289_JPRB
zh3c(19)=  11.10372_JPRB
zh4c(19)=  12.44897_JPRB

zhutc(20)=  11.16667_JPRB
zlat_deg(20)=  43.95500_JPRB
zlon_deg(20)=  27.50333_JPRB
zh1c(20)=   9.73833_JPRB
zh2c(20)=  11.14633_JPRB
zh3c(20)=  11.18694_JPRB
zh4c(20)=  12.52292_JPRB

zhutc(21)=  11.25000_JPRB
zlat_deg(21)=  43.10167_JPRB
zlon_deg(21)=  29.74333_JPRB
zh1c(21)=   9.81944_JPRB
zh2c(21)=  11.22981_JPRB
zh3c(21)=  11.27011_JPRB
zh4c(21)=  12.59525_JPRB

zhutc(22)=  11.33333_JPRB
zlat_deg(22)=  42.20667_JPRB
zlon_deg(22)=  31.94167_JPRB
zh1c(22)=   9.90297_JPRB
zh2c(22)=  11.31336_JPRB
zh3c(22)=  11.35322_JPRB
zh4c(22)=  12.66597_JPRB

zhutc(23)=  11.41667_JPRB
zlat_deg(23)=  41.27167_JPRB
zlon_deg(23)=  34.11000_JPRB
zh1c(23)=   9.98900_JPRB
zh2c(23)=  11.39697_JPRB
zh3c(23)=  11.43628_JPRB
zh4c(23)=  12.73522_JPRB

zhutc(24)=  11.50000_JPRB
zlat_deg(24)=  40.29500_JPRB
zlon_deg(24)=  36.26000_JPRB
zh1c(24)=  10.07758_JPRB
zh2c(24)=  11.48067_JPRB
zh3c(24)=  11.51928_JPRB
zh4c(24)=  12.80303_JPRB

zhutc(25)=  11.58333_JPRB
zlat_deg(25)=  39.27500_JPRB
zlon_deg(25)=  38.40667_JPRB
zh1c(25)=  10.16883_JPRB
zh2c(25)=  11.56439_JPRB
zh3c(25)=  11.60219_JPRB
zh4c(25)=  12.86942_JPRB

zhutc(26)=  11.66667_JPRB
zlat_deg(26)=  38.21167_JPRB
zlon_deg(26)=  40.56167_JPRB
zh1c(26)=  10.26283_JPRB
zh2c(26)=  11.64817_JPRB
zh3c(26)=  11.68506_JPRB
zh4c(26)=  12.93444_JPRB

zhutc(27)=  11.75000_JPRB
zlat_deg(27)=  37.10167_JPRB
zlon_deg(27)=  42.74333_JPRB
zh1c(27)=  10.35964_JPRB
zh2c(27)=  11.73203_JPRB
zh3c(27)=  11.76789_JPRB
zh4c(27)=  12.99811_JPRB

zhutc(28)=  11.83333_JPRB
zlat_deg(28)=  35.94167_JPRB
zlon_deg(28)=  44.97167_JPRB
zh1c(28)=  10.45936_JPRB
zh2c(28)=  11.81594_JPRB
zh3c(28)=  11.85064_JPRB
zh4c(28)=  13.06039_JPRB

zhutc(29)=  11.91667_JPRB
zlat_deg(29)=  34.72667_JPRB
zlon_deg(29)=  47.27000_JPRB
zh1c(29)=  10.56214_JPRB
zh2c(29)=  11.89992_JPRB
zh3c(29)=  11.93333_JPRB
zh4c(29)=  13.12125_JPRB

zhutc(30)=  12.00000_JPRB
zlat_deg(30)=  33.44667_JPRB
zlon_deg(30)=  49.66833_JPRB
zh1c(30)=  10.66808_JPRB
zh2c(30)=  11.98394_JPRB
zh3c(30)=  12.01597_JPRB
zh4c(30)=  13.18061_JPRB

zhutc(31)=  12.08333_JPRB
zlat_deg(31)=  32.09667_JPRB
zlon_deg(31)=  52.20667_JPRB
zh1c(31)=  10.77742_JPRB
zh2c(31)=  12.06806_JPRB
zh3c(31)=  12.09853_JPRB
zh4c(31)=  13.23833_JPRB

zhutc(32)=  12.16667_JPRB
zlat_deg(32)=  30.65667_JPRB
zlon_deg(32)=  54.94000_JPRB
zh1c(32)=  10.89044_JPRB
zh2c(32)=  12.15222_JPRB
zh3c(32)=  12.18103_JPRB
zh4c(32)=  13.29417_JPRB

zhutc(33)=  12.25000_JPRB
zlat_deg(33)=  29.10667_JPRB
zlon_deg(33)=  57.95167_JPRB
zh1c(33)=  11.00767_JPRB
zh2c(33)=  12.23650_JPRB
zh3c(33)=  12.26342_JPRB
zh4c(33)=  13.34772_JPRB

zhutc(34)=  12.33333_JPRB
zlat_deg(34)=  27.40667_JPRB
zlon_deg(34)=  61.37333_JPRB
zh1c(34)=  11.12997_JPRB
zh2c(34)=  12.32086_JPRB
zh3c(34)=  12.34572_JPRB
zh4c(34)=  13.39833_JPRB

zhutc(35)=  12.41667_JPRB
zlat_deg(35)=  25.48667_JPRB
zlon_deg(35)=  65.46167_JPRB
zh1c(35)=  11.25906_JPRB
zh2c(35)=  12.40539_JPRB
zh3c(35)=  12.42786_JPRB
zh4c(35)=  13.44467_JPRB

zhutc(36)=  12.50000_JPRB
zlat_deg(36)=  23.17167_JPRB
zlon_deg(36)=  70.82000_JPRB
zh1c(36)=  11.39925_JPRB
zh2c(36)=  12.49017_JPRB
zh3c(36)=  12.50978_JPRB
zh4c(36)=  13.48347_JPRB

!-------------------------------------------------
!-------------------------------------------------
! Convert the elapsed time since 1.1.200012 UTC
! Convert the elapsed time since 1.1.200012 UTC
! in UTC hours.
! in UTC hours.
! -12398400. is the value of ptimtr at 11.8.19990 UTC.
! -12398400. is the value of ptimtr at 11.8.19990 UTC.
!-------------------------------------------------
!-------------------------------------------------

if(knoir == 1) then
  !
  !
  !-------------------------------------------------
  !-------------------------------------------------
  ! Eclipse on 11.8.1999 only.
  ! Eclipse on 11.8.1999 only.
  !-------------------------------------------------
  !-------------------------------------------------
  !
  !
  zelapsed=(ptimtr+12398400._JPRB)/3600._JPRB
elseif(knoir == -999) then
  !
  !
  !-------------------------------------------------
  !-------------------------------------------------
  ! Eclipse every day!...
  ! Eclipse every day!...
  !-------------------------------------------------
  !-------------------------------------------------
  !
  !
  zelapsed=(ptimtr+12398400._JPRB)/3600._JPRB
  zfrac=zelapsed/24._JPRB
  zelapsed=24._JPRB*(zfrac-nint(zfrac-0.5_JPRB))
else
  zelapsed=0.0_JPRB
endif

!-------------------------------------------------
!-------------------------------------------------
! Look for closest hard data to current time.
! Look for closest hard data to current time.
!-------------------------------------------------
!-------------------------------------------------

iok=0
do jbouc=1,35
  if(zelapsed >= zhutc(jbouc).and.zelapsed <= zhutc(jbouc+1)) iok=jbouc
enddo
if(iok /= 0) then
  !
  !
  !-------------------------------------------------
  !-------------------------------------------------
  ! Current time is between zhutc(iok) and zhutc(iok+1).
  ! Current time is between zhutc(iok) and zhutc(iok+1).
  ! Interpolate all fields at current time.
  ! Interpolate all fields at current time.
  !-------------------------------------------------
  !-------------------------------------------------
  !
  !
  zcondr=atan(1.0_JPRB)/45._JPRB
  plon=zcondr*(zlon_deg(iok)+(zlon_deg(iok+1)-zlon_deg(iok))*(zelapsed- &
   & zhutc(iok))/(zhutc(iok+1)-zhutc(iok)))  
  plat=zcondr*(zlat_deg(iok)+(zlat_deg(iok+1)-zlat_deg(iok))*(zelapsed- &
   & zhutc(iok))/(zhutc(iok+1)-zhutc(iok)))  
else
  !
  !
  !-------------------------------------------------
  !-------------------------------------------------
  ! Current time is outside hard data.
  ! Current time is outside hard data.
  !-------------------------------------------------
  !-------------------------------------------------
  !
  !
  plon=0.0_JPRB
  plat=0.0_JPRB
endif
IF (LHOOK) CALL DR_HOOK('POSCT',1,ZHOOK_HANDLE)
end subroutine posct
