#ifdef RS6K
@PROCESS NOCHECK
#endif
SUBROUTINE EC_PHYS_DRV(CDCONF,PB2,PPBUP9, PPBVP9, PPBTP9,PPBGFLP9,PEXTRADYN,&
      & PMWAVE_OBS_BUF,PMWAVE_ZEN_BUF,PMWAVE_AZI_BUF,PMWAVE_TB_BUF,PMWAVE_OERR_BUF,&
      & PMWAVE_PERS1_BUF,&
      & PMWAVE_DIAG_BUF,PMWAVE_P19_BUF,PMWAVE_P37_BUF,PMWAVE_GNORM_BUF,&
      & KMWAVE_BUF,&
      & PSMOS_OBS_BUF,PSMOS_TB_BUF,PSMOS_ANGLE,&
      & KSMOS_BUF)
USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCT0   , ONLY : NSTART   ,LPC_FULL, LPC_OLD
USE YOMCT3   , ONLY : NSTEP
USE YOMDYN   , ONLY : NSITER   ,NCURRENT_ITER
USE YOM_YGFL , ONLY : YGFL, YQ, YO3, YL, YI, YR, YS, YA, &
 & YGHG, YTRAC, YGRG, YAERO, YEXT, &
 & NGHG, NTRAC, NGRG, NAERO, NGFL_EXT
USE YOMDIM   , ONLY : NDGENL   ,NFLEVG   ,NPROMA   ,NGPBLKS, NSMAX
USE YOMGEM   , ONLY : NGPTOT, RCOLON   ,RSILON   ,RINDX    ,RINDY
USE YOMGC    , ONLY : GSQM2    ,GELAM    , GELAT, GAW  ,GECLO    ,GESLO    ,GM ,&
  &GNORDL   ,GNORDM   ,OROG     ,GEMU,  NGPLAT
USE YOMDPHY  , ONLY : NVEXTRDYN
USE YOMSC2   , ONLY : NFLDSLB2
USE YOMRADF  , ONLY : EMTD     ,TRSW     ,EMTC     ,TRSC     ,TAUAER   ,&
  & SRSWD    ,SRSWDCS  ,SRSWPAR  ,SRSWUVB  ,EDRO, SRSWPARC, SRSWTINC, SRFDIR, SRCDIR, &
  & EMTD2, TRSW2, EMTC2, TRSC2
USE OML_MOD, ONLY : OML_MY_THREAD
USE YOMGMV   , ONLY : YPH9 , GMV,GMVS,GMVT1,GMVT1S,YT1
USE YOMGFL   , ONLY : GFL,GFLSLP,GFLT1,GFLPT
USE YOMLCZ   , ONLY : GPFORCEU ,GPFORCEV ,GPFORCET , GPFORCEQ
USE STOPH_MIX , ONLY : RSTOPHU  ,RSTOPHV  ,RSTOPHT  ,RSTOPHQ, RSTOPHCA, & 
  & GPSTREAM, GPVELPOT, GPTOTDISS, GPTOTDISS_SMOOTH, GPVORTGRAD, &
  & GPTEMP
USE YOE_CUCONVCA , ONLY :  RCUCONVCA, RNLCONVCA, RCAPECONVCA
USE YOM_PTR_SSMI , ONLY : LERAIN_ACTIVE
USE YOMONEDVAR , ONLY : LERAIN_LB
USE YOMPHY2  , ONLY : TSPHY
USE YOMCOAPHY   , ONLY : NPHYINT
USE YOMRAIN_LB , ONLY : JPHLP
USE YOEPHY   , ONLY : LEO3CH, LEPCLD, NEPHYS_PCFULL
USE YOMSLPHY , ONLY : LSLPHY   ,SAVTEND  ,NVTEND, &
 & MU_SAVTEND,MV_SAVTEND,MT_SAVTEND,MSAT_SAVTEND, &
 & MU_SAVTEND_S,MV_SAVTEND_S,MT_SAVTEND_S,MSAT_SAVTEND_S,MSAVTEND_S
USE YOMMWAVE , ONLY : N_SATSENS, NMWAVE_DIAG, NMWAVE_GNRM, NMWAVE_P
USE PARMWAVE , ONLY : NMAX_CHAN
USE YOMSMOS  , ONLY : NPOL_MAX
USE YOM_PHYS_GRID ,ONLY : PHYS_GRID
USE SURFACE_FIELDS_MIX , ONLY : SP_SB,SP_SG,SP_RR,SD_WS,SD_WW,SP_EP,SP_X2,&
 & SD_VF,SD_VN,SD_VD,SD_XA,SD_X2,&
 & SP_OM,SD_V2,SD_V3   !KPP

USE YOMDYNCORE , ONLY : LHELDSUAREZ
USE YOMSPSDT , ONLY : YGPSDT, LSPSDT, LFIXSPPT

USE YOERAD   , ONLY : L2RAD
USE YOMLUN   , ONLY : NULOUT

! COSP
USE YOMCOSP_VARIABLES, ONLY : COSP_IBL,COSP_IOFF,COSP_ICEND 

!**** *EC_PHYS_DRV* - Coarse physics driver routine

!     Purpose.
!     --------
!           The motivation for this routine is primarily to call EC_PHYS.
!           It emulates RADDRV

!**   Interface.
!     ----------
!        *CALL* *EC_PHYS_DRV(CDCONF,PB2,PPBUP9, PPBVP9, PPBTP9,PPBGFLP9)*

!        Explicit arguments :
!        --------------------
!        CDCONF    : configuration of work
!        PB2       : input grid point array

!        Implicit arguments :
!        --------------------

!     Method.
!     -------
!        See documentation

!     Externals.
!     ----------
!        Called by GP_MODEL.

!     Reference.
!     ----------
!        see documentation 

!     Author.
!     -------
!        M. Hortal after George Mozdzynski's RADDRV  *ECMWF*

!     Modifications.
!     --------------
!      Original : 05-02-14
!        J. Hague      22-Nov-2005  Clean Load balancing
!        J Flemming    28-Apr-2006  GRG auxiliary array to ec_phys call
!   N. Wedi and K. Yessad (Jan 2008): different dev for NH model and PC scheme
!      JJMorcrette 20070321 Prognostic aerosols in radiation and clouds
!        A. Geer       15-Apr-2008  Multiple sensors for rainy 4D-Var
!        A. Geer       01-Oct-2008  Rainy 4D-Var tidying
!      GMozdzynski/JJMorcrette 20080128 bugfix dynamical extra fields
!        Y. Takaya     01-Feb-2009  Ocean mixed layer model
!        JJMorcrette 20091201 Total and clear-sky direct SW radiation flux at surface 
!        W. Bell       06-Mar-2009  Add Windsat azimuth angle
!        A. Geer       10-Jun-2008  Rainy 4D-Var passive mode and diagnostics
!  	 F. Karbou     16-Dec-2009  Surface emissivity estimation
!    R.Forbes/A.Tompkins  Dec 2009  Remove liq water/ice split,add snow/rain 
!     ------------------------------------------------------------------

IMPLICIT NONE

CHARACTER ,INTENT(IN)    :: CDCONF 

REAL(KIND=JPRB)   ,INTENT(INOUT) :: PB2(NPROMA,NFLDSLB2,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PPBUP9(NPROMA,NFLEVG,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PPBVP9(NPROMA,NFLEVG,NGPBLKS) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PPBTP9(NPROMA,NFLEVG,NGPBLKS) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PPBGFLP9(NPROMA,NFLEVG,YGFL%NUMFLDS,NGPBLKS) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PMWAVE_OBS_BUF(NGPTOT,NMAX_CHAN,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PMWAVE_AZI_BUF(NGPTOT,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PMWAVE_ZEN_BUF(NGPTOT,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PMWAVE_TB_BUF(NGPTOT,NMAX_CHAN,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PMWAVE_OERR_BUF(NGPTOT,NMAX_CHAN,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PMWAVE_PERS1_BUF(NGPTOT,NMAX_CHAN,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PMWAVE_DIAG_BUF(NGPTOT,NMWAVE_DIAG,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PMWAVE_P19_BUF(NGPTOT,NMWAVE_P,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PMWAVE_P37_BUF(NGPTOT,NMWAVE_P,N_SATSENS)
INTEGER(KIND=JPIM),INTENT(INOUT) :: KMWAVE_BUF(NGPTOT,NMAX_CHAN,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PMWAVE_GNORM_BUF(NGPTOT,NMWAVE_GNRM,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PEXTRADYN(NPROMA,NFLEVG,NVEXTRDYN,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSMOS_OBS_BUF(NGPTOT,0:NPOL_MAX-1)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSMOS_ANGLE(NGPTOT,0:NPOL_MAX-1)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSMOS_TB_BUF(NGPTOT,0:NPOL_MAX-1)
INTEGER(KIND=JPIM),INTENT(INOUT) :: KSMOS_BUF(NGPTOT,0:NPOL_MAX-1)

REAL(KIND=JPRB) :: ZDPTENQ(NPROMA,NFLEVG,4,2,NGPBLKS)
REAL(KIND=JPRB) :: ZGPSDT2D(NPROMA, YGPSDT%NG2D, NGPBLKS)

!     ------------------------------------------------------------------

!------ Load Balancing Variables ----------------------
INTEGER(KIND=JPIM) :: IHLPRDY(JPHLP+1),IT

INTEGER(KIND=JPIM) :: IBL,ICEND,IOFF,JKGLO,ICST

LOGICAL :: LL_CALLPAR
LOGICAL :: LL_STORE_ECPHYSTND
LOGICAL :: LL_GET_ECPHYSTND
LOGICAL :: LL_AVERAGE_ECPHYS
LOGICAL :: LL_COPY_LSLPHY
LOGICAL :: LL_SAVE_ECSURF
LOGICAL :: LLFSTEP

INTEGER(KIND=JPIM) :: IPCT,ISTC,JGFL,JLEV,JROF

REAL(KIND=JPRB),ALLOCATABLE :: ZZTENU(:,:)
REAL(KIND=JPRB),ALLOCATABLE :: ZZTENV(:,:)
REAL(KIND=JPRB),ALLOCATABLE :: ZZTENT(:,:)
REAL(KIND=JPRB),ALLOCATABLE :: ZZTENQ(:,:)
REAL(KIND=JPRB),ALLOCATABLE :: ZZTENO3(:,:)
REAL(KIND=JPRB),ALLOCATABLE :: ZZTENL(:,:)
REAL(KIND=JPRB),ALLOCATABLE :: ZZTENI(:,:)
REAL(KIND=JPRB),ALLOCATABLE :: ZZTENA(:,:)

REAL(KIND=JPRB) :: ZHOOK_HANDLE

!     ------------------------------------------------------------------

#include "abor1.intfb.h"
#include "cpg_pt.intfb.h"
#include "ec_physg.intfb.h"
#include "ec_phys.intfb.h"
#include "cpqtuv.intfb.h"
#include "gpmktend.intfb.h"
#include "sltend2.intfb.h"
#include "onedvar_raintb_prb.intfb.h"
#include "onedvar_raintb_hld.intfb.h"
#include "onedvar_raintb_hlp.intfb.h"
#include "heldsuarez.intfb.h"
#include "fixsppt.intfb.h"

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('EC_PHYS_DRV',0,ZHOOK_HANDLE)

!     ------------------------------------------------------------------

! --- lagged phys + lpc_full -------------------------------------------
! * Compute some local switches to control what must be done in the
!   different iterations of the predictor-corrector schemes:
!   - LL_CALLPAR: CALLPAR is called, and also the preliminary
!     calculations used as input to CALLPAR.
!   - LL_STORE_ECPHYSTND: stores the ECMWF physics tendencies in buffers
!     GMV and GFLPT via a call to CPG_PT.
!   - LL_GET_ECPHYSTND: gets the ECMWF physics tendencies from buffers
!     GMV and GFLPT via a call to CPG_PT.
!   - LL_AVERAGE_ECPHYS: averages the lagged and unlagged contributions
!     of the EC physics via a call to SLTEND, and increments P[X]T1
!     with the averaged diabatic contribution.
!   - LL_COPY_LSLPHY: saves the EC physics in buffers SAVTEND and
!     GFLSLP for the following timestep.
!   - LL_SAVE_ECSURF: saves the EC surface in GPPBUF.
!   Note that some different options have been currently coded to manage
!   the lagged physics in the case LPC_FULL=T, for test purposes.
!   These options are controlled by variable NEPHYS_PCFULL:
!   - NEPHYS_PCFULL=2: EC physics is done at the predictor step only,
!     the tendencies are stored in buffers and re-used for the corrector
!     steps.
!   - NEPHYS_PCFULL=3: predictor and intermediate corrector steps
!     (NCURRENT_ITER from 0 to NSITER-1) are purely adiabatic,
!     EC physics is done at the last step of the corrector only.

IF(NSTEP > 0) THEN
  LLFSTEP = .FALSE.
ELSE
  LLFSTEP = .TRUE.
ENDIF

IF (.NOT.LPC_FULL.AND..NOT.LPC_OLD) THEN
  ! * Not predictor/corrector for Non-Hydrostatic scheme
  LL_CALLPAR=.TRUE.
  LL_STORE_ECPHYSTND=.FALSE.
  LL_GET_ECPHYSTND=.FALSE.
  LL_AVERAGE_ECPHYS=.TRUE.
  LL_SAVE_ECSURF=.TRUE.
  LL_COPY_LSLPHY=.FALSE.
ELSEIF(LPC_FULL)THEN
  IF (NEPHYS_PCFULL == 2) THEN
    IF (NCURRENT_ITER == 0) THEN
      LL_CALLPAR=.TRUE.
      LL_STORE_ECPHYSTND=.TRUE.
      LL_GET_ECPHYSTND=.FALSE.
      LL_SAVE_ECSURF=.TRUE.
      LL_AVERAGE_ECPHYS=.TRUE.
      LL_COPY_LSLPHY=.FALSE.
    ELSE
      LL_CALLPAR=.FALSE.
      LL_STORE_ECPHYSTND=.FALSE.
      LL_GET_ECPHYSTND=.TRUE.
      LL_SAVE_ECSURF=.FALSE.
      LL_AVERAGE_ECPHYS=.TRUE.
      LL_COPY_LSLPHY=LSLPHY
    ENDIF
  ELSEIF (NEPHYS_PCFULL == 3) THEN
    IF (NCURRENT_ITER < NSITER) THEN
      LL_CALLPAR=.FALSE.
      LL_STORE_ECPHYSTND=.FALSE.
      LL_GET_ECPHYSTND=.FALSE.
      LL_SAVE_ECSURF=.FALSE.
      LL_AVERAGE_ECPHYS=.FALSE.
      LL_COPY_LSLPHY=.FALSE.
    ELSE
      LL_CALLPAR=.TRUE.
      LL_STORE_ECPHYSTND=.FALSE.
      LL_GET_ECPHYSTND=.FALSE.
      LL_SAVE_ECSURF=.TRUE.
      LL_AVERAGE_ECPHYS=.TRUE.
      LL_COPY_LSLPHY=.FALSE.
    ENDIF
  ENDIF
ELSEIF (LPC_OLD) THEN
  ! * EC phys not implemented for this case.
  CALL ABOR1('EC_PHYS: LPC_OLD with EC phys not implemented')
ENDIF

ICST   = 1

!  PHYSICS COMPUTATIONS

IF(LL_CALLPAR.OR.LL_AVERAGE_ECPHYS) THEN

CALL GSTATS(1063,0) 
!$OMP PARALLEL DO SCHEDULE(STATIC) PRIVATE(JKGLO,ICEND,IBL,JLEV,JROF)
DO JKGLO=1,NGPTOT,NPROMA

  IBL=(JKGLO-1)/NPROMA+1
  ICEND=MIN(NPROMA,NGPTOT-JKGLO+1)

  IF( LSLPHY .AND. LEPCLD ) THEN
    IF( LLFSTEP ) THEN
      DO JLEV=1,NFLEVG
        DO JROF=1,ICEND
          PPBGFLP9(JROF,JLEV,YL%MP,IBL)=GFL(JROF,JLEV,YL%MP9_PH,IBL)
          PPBGFLP9(JROF,JLEV,YI%MP,IBL)=GFL(JROF,JLEV,YI%MP9_PH,IBL)
          PPBGFLP9(JROF,JLEV,YR%MP,IBL)=GFL(JROF,JLEV,YR%MP9_PH,IBL)
          PPBGFLP9(JROF,JLEV,YS%MP,IBL)=GFL(JROF,JLEV,YS%MP9_PH,IBL)
        ENDDO
      ENDDO
    ENDIF
  ENDIF

  CALL GPMKTEND(1,ICEND,TSPHY,&
   & GMVT1(1,1,YT1%MU,IBL),GMVT1(1,1,YT1%MV,IBL) ,GMVT1(1,1,YT1%MT,IBL),&
   & GFLT1(1,1,1,IBL),&
   & GMV(1,1,YPH9%MU,IBL),GMV(1,1,YPH9%MV,IBL) ,GMV(1,1,YPH9%MT,IBL),&
   & GFL(1,1,1,IBL),&
   & PPBGFLP9(1,1,YL%MP,IBL),PPBGFLP9(1,1,YI%MP,IBL),&
   & PPBGFLP9(1,1,YR%MP,IBL),PPBGFLP9(1,1,YS%MP,IBL))

ENDDO
!$OMP END PARALLEL DO
CALL GSTATS(1063,1) 

ENDIF

IF (LSPSDT) THEN
  ZGPSDT2D(:,:,:)=YGPSDT%GP2D(:,:,:)
ENDIF

IF( NPHYINT > 0 )THEN

  ! * LPC_FULL not implemented for this case.
  IF(LPC_FULL)CALL ABOR1('EC_PHYS: LPC_FULL with NPHYINT >0 not implemented')

  CALL EC_PHYSG(CDCONF,NPROMA,PHYS_GRID%NPROMA,NSMAX,PHYS_GRID%NSMAX,&
   &NGPTOT,PHYS_GRID%NGPTOT,PHYS_GRID%NGPLAT,&
   & PB2,&
   & GMV,GMVS,&
   & GMVT1,GMVT1S,GFLT1,&
   & GFL,GFLSLP,&
   & SP_SB,SP_SG,SP_RR,&
   & SP_EP,SP_X2,&
   & SD_VF,SD_VN,SD_VD,&
   & SD_WS,SD_WW,&
   & SD_XA,SD_X2,&
   & SP_OM,SD_V2,SD_V3,&  !KPP
   & EMTD,TRSW,EMTC,TRSC,TAUAER,&
   & SRSWD,SRSWDCS,EDRO,&
   & SRSWPAR,SRSWUVB,SRSWPARC,SRSWTINC,SRFDIR,SRCDIR,&
   & PHYS_GRID%GEMU,&
   & PHYS_GRID%GELAM,PHYS_GRID%GELAT,PHYS_GRID%GESLO,PHYS_GRID%GECLO,PHYS_GRID%GM,&
   & OROG,PHYS_GRID%GNORDL,PHYS_GRID%GNORDM,&
   & PHYS_GRID%GSQM2,PHYS_GRID%RCOLON,PHYS_GRID%RSILON,&
   & PHYS_GRID%RINDX,PHYS_GRID%RINDY,PHYS_GRID%GAW,&
   & RSTOPHU,RSTOPHV,&
   & RSTOPHT,RSTOPHQ,&
   & RSTOPHCA,RCUCONVCA,RNLCONVCA,RCAPECONVCA,& 
   & PPBUP9,PPBVP9,&
   & PPBTP9,PPBGFLP9,&
   & ZGPSDT2D,&
   & GPSTREAM, GPTEMP,GPVELPOT, GPTOTDISS, GPTOTDISS_SMOOTH, GPVORTGRAD, &  
   & GPFORCEU(1,1,1,0),GPFORCEV(1,1,1,0),&
   & GPFORCET(1,1,1,0),GPFORCEQ(1,1,1,0),&
   & PEXTRADYN,SAVTEND,&
   & LERAIN_LB,IHLPRDY,IT,&
   & PMWAVE_OBS_BUF,PMWAVE_ZEN_BUF,PMWAVE_AZI_BUF,PMWAVE_TB_BUF,PMWAVE_OERR_BUF,&
   & PMWAVE_PERS1_BUF,&
   & PMWAVE_DIAG_BUF,PMWAVE_P19_BUF,PMWAVE_P37_BUF,PMWAVE_GNORM_BUF,&
   & KMWAVE_BUF,&
   & PSMOS_OBS_BUF,PSMOS_TB_BUF,PSMOS_ANGLE,& 
   & KSMOS_BUF,ZDPTENQ(1,1,1,1,IBL), ZDPTENQ(1,1,1,2,IBL),&
   & EMTD2,TRSW2,EMTC2,TRSC2 )

ELSE 


  IPCT=1
  ISTC=1

  CALL GSTATS(1001,0)

!$OMP PARALLEL PRIVATE(JKGLO,ICEND,IBL,IOFF,IT,IHLPRDY,ZZTENU,&
!$OMP& ZZTENV,ZZTENT,ZZTENQ,ZZTENO3,ZZTENL,ZZTENI,ZZTENA)
  IF(LPC_FULL)THEN
    ALLOCATE(ZZTENU(NPROMA,NFLEVG),ZZTENV(NPROMA,NFLEVG),ZZTENT(NPROMA,NFLEVG))
    ALLOCATE(ZZTENQ(NPROMA,NFLEVG),ZZTENO3(NPROMA,NFLEVG))
    ALLOCATE(ZZTENL(NPROMA,NFLEVG),ZZTENI(NPROMA,NFLEVG),ZZTENA(NPROMA,NFLEVG))
  ENDIF
  IT=OML_MY_THREAD()
  IHLPRDY(:)=0
  
!$OMP DO SCHEDULE(DYNAMIC,1)
  DO JKGLO=1,NGPTOT,NPROMA
    ICEND=MIN(NPROMA,NGPTOT-JKGLO+1)
    IBL=(JKGLO-1)/NPROMA+1
    IOFF=JKGLO

    COSP_IBL=IBL
    COSP_IOFF=IOFF
    COSP_ICEND=ICEND

      !--- Load Balancing ---
    IF(LERAIN_LB) CALL ONEDVAR_RAINTB_PRB(IHLPRDY,IT)
                  !--- MASTER: Probe for helpers

    IF(LL_CALLPAR)THEN

  
      IF(LL_STORE_ECPHYSTND) THEN
        ZZTENU(ICST:ICEND,1:NFLEVG)=GMVT1(ICST:ICEND,1:NFLEVG,YT1%MU,IBL)
        ZZTENV(ICST:ICEND,1:NFLEVG)=GMVT1(ICST:ICEND,1:NFLEVG,YT1%MV,IBL)
        ZZTENT(ICST:ICEND,1:NFLEVG)=GMVT1(ICST:ICEND,1:NFLEVG,YT1%MT,IBL)
        IF (YQ%LACTIVE) ZZTENQ(ICST:ICEND,1:NFLEVG)=GFLT1(ICST:ICEND,1:NFLEVG,YQ%MP1,IBL)
        IF (YO3%LACTIVE) ZZTENO3(ICST:ICEND,1:NFLEVG)=GFLT1(ICST:ICEND,1:NFLEVG,YO3%MP1,IBL)
        IF (YL%LACTIVE) ZZTENL(ICST:ICEND,1:NFLEVG)=GFLT1(ICST:ICEND,1:NFLEVG,YL%MP1,IBL)
        IF (YI%LACTIVE) ZZTENI(ICST:ICEND,1:NFLEVG)=GFLT1(ICST:ICEND,1:NFLEVG,YI%MP1,IBL)
        IF (YA%LACTIVE) ZZTENA(ICST:ICEND,1:NFLEVG)=GFLT1(ICST:ICEND,1:NFLEVG,YA%MP1,IBL)
      ENDIF

!      print *,'Entering ec_phys from ec_phys_drv IBL,ICEND,NPROMA: ',IBL,ICEND,NPROMA

      IF( LHELDSUAREZ ) THEN
        CALL HELDSUAREZ ( ISTC, ICEND, NPROMA, NFLEVG, &
         & GMV(1,1,YPH9%MU,IBL),GMV(1,1,YPH9%MV,IBL), &
         & GMV(1,1,YPH9%MT,IBL),GMVS(1,YPH9%MSP,IBL), &
         & GFL(1,1,YQ%MP9_PH,IBL), &
         & GEMU(IOFF),GESLO(IOFF),GECLO(IOFF), &
         & GMVT1(1,1,YT1%MU,IBL) ,GMVT1(1,1,YT1%MV,IBL) ,GMVT1(1,1,YT1%MT,IBL), &
         & GFLT1(1,1,YQ%MP1,IBL), &
         & SD_XA(1,1,1,IBL),SD_X2(1,1,IBL))
     ELSE

      CALL EC_PHYS(CDCONF,NPROMA,NSMAX,NGPLAT(IOFF),&
       & IBL,ICEND,JKGLO,&
       & PB2(1,1,IBL),&
       & GMV(1,1,YPH9%MU,IBL),GMV(1,1,YPH9%MV,IBL),&
       & GMV(1,1,YPH9%MT,IBL),GMVS(1,YPH9%MSP,IBL),&
       & GMVT1(1,1,1,IBL),GMVT1S(1,1,IBL),GFLT1(1,1,1,IBL),&
       & GFL(1,1,1,IBL),GFLSLP(1,1,1,IBL),&
       & SP_SB(1,1,1,IBL),SP_SG(1,1,IBL),SP_RR(1,1,IBL),&
       & SP_EP(1,1,1,IBL),SP_X2(1,1,IBL),&
       & SD_VF(1,1,IBL),SD_VN(1,1,IBL),SD_VD(1,1,IBL),&
       & SD_WS(1,1,IBL),SD_WW(1,1,IBL),&
       & SD_XA(1,1,1,IBL),SD_X2(1,1,IBL),&
       & SP_OM(1,1,1,IBL),SD_V2(1,1,IBL),SD_V3(1,1,1,IBL),&        !KPP
       & EMTD(1,1,IBL),TRSW(1,1,IBL),EMTC(1,1,IBL),TRSC(1,1,IBL),&
       & TAUAER(1,1,1,IBL),&
       & SRSWD(1,IBL),SRSWDCS(1,IBL),EDRO(1,IBL),&
       & SRSWPAR(1,IBL),SRSWUVB(1,IBL),SRSWPARC(1,IBL),SRSWTINC(1,IBL),&
       & SRFDIR(1,IBL),SRCDIR(1,IBL),&
       & GEMU(IOFF),&
       & GELAM(IOFF),GELAT(IOFF),GESLO(IOFF),GECLO(IOFF),&
       & OROG(IOFF),GNORDL(IOFF),GNORDM(IOFF),&
       & GSQM2(IOFF),GAW(IOFF),&
       & RSTOPHU(IOFF),RSTOPHV(IOFF),&
       & RSTOPHT(IOFF),RSTOPHQ(IOFF),&
       & RSTOPHCA(IOFF),RCUCONVCA(IOFF),RNLCONVCA(IOFF),RCAPECONVCA(IOFF),& 
       & PPBUP9(1,1,IBL),PPBVP9(1,1,IBL),&
       & PPBTP9(1,1,IBL),PPBGFLP9(1,1,1,IBL),&
       & ZGPSDT2D(1,1,IBL), &
       & GPSTREAM(1,1,IBL),GPTEMP(1,1,IBL),GPVELPOT(1,1,IBL), & 
       & GPTOTDISS(1,1,IBL), GPTOTDISS_SMOOTH(1,1,IBL), & 
       & GPVORTGRAD(1,1,IBL), GPVORTGRAD(1,NFLEVG+1,IBL),GPVORTGRAD(1,2*NFLEVG+1,IBL), &
       & GPFORCEU(1,1,IBL,0),GPFORCEV(1,1,IBL,0),&
       & GPFORCET(1,1,IBL,0),GPFORCEQ(1,1,IBL,0),&
       & PEXTRADYN(1,1,1,IBL),SAVTEND(1,1,1,IBL),&
       & LERAIN_LB, IHLPRDY, IT,&
       & PMWAVE_OBS_BUF,PMWAVE_ZEN_BUF,PMWAVE_AZI_BUF,PMWAVE_TB_BUF,PMWAVE_OERR_BUF,&
       & PMWAVE_PERS1_BUF,&
       & PMWAVE_DIAG_BUF,PMWAVE_P19_BUF,PMWAVE_P37_BUF,PMWAVE_GNORM_BUF,&
       & KMWAVE_BUF,&
       & PSMOS_OBS_BUF,PSMOS_TB_BUF,PSMOS_ANGLE,&
       & KSMOS_BUF,ZDPTENQ(1,1,1,1,IBL), ZDPTENQ(1,1,1,2,IBL),&
       & EMTD2(1,1,IBL),TRSW2(1,1,IBL),EMTC2(1,1,IBL),TRSC2(1,1,IBL))
      ENDIF
    ENDIF

    IF(LL_STORE_ECPHYSTND) THEN
      ZZTENU(ICST:ICEND,1:NFLEVG)=GMVT1(ICST:ICEND,1:NFLEVG,YT1%MU,IBL)-ZZTENU(ICST:ICEND,1:NFLEVG)
      ZZTENV(ICST:ICEND,1:NFLEVG)=GMVT1(ICST:ICEND,1:NFLEVG,YT1%MV,IBL)-ZZTENV(ICST:ICEND,1:NFLEVG)
      ZZTENT(ICST:ICEND,1:NFLEVG)=GMVT1(ICST:ICEND,1:NFLEVG,YT1%MT,IBL)-ZZTENT(ICST:ICEND,1:NFLEVG)
      IF (YQ%LACTIVE) ZZTENQ(ICST:ICEND,1:NFLEVG)=GFLT1(ICST:ICEND,1:NFLEVG,YQ%MP1,IBL)-ZZTENQ(ICST:ICEND,1:NFLEVG)
      IF (YO3%LACTIVE) ZZTENO3(ICST:ICEND,1:NFLEVG)=GFLT1(ICST:ICEND,1:NFLEVG,YO3%MP1,IBL)-ZZTENO3(ICST:ICEND,1:NFLEVG)
      IF (.NOT.LSLPHY) THEN
        IF (YL%LACTIVE) ZZTENL(ICST:ICEND,1:NFLEVG)=GFLT1(ICST:ICEND,1:NFLEVG,YL%MP1,IBL) & 
         & -ZZTENL(ICST:ICEND,1:NFLEVG)
        IF (YI%LACTIVE) ZZTENI(ICST:ICEND,1:NFLEVG)=GFLT1(ICST:ICEND,1:NFLEVG,YI%MP1,IBL) & 
         & -ZZTENI(ICST:ICEND,1:NFLEVG)
      ENDIF
      IF (YA%LACTIVE) ZZTENA(ICST:ICEND,1:NFLEVG)=GFLT1(ICST:ICEND,1:NFLEVG,YA%MP1,IBL)-ZZTENA(ICST:ICEND,1:NFLEVG)
   
      CALL CPG_PT( &
       & ICST,ICEND,.FALSE.,1,NFLEVG, &
       & PTENDU=ZZTENU,PTENDV=ZZTENV,PTENDT=ZZTENT, &
       & PTENDQ=ZZTENQ,PTENDO3=ZZTENO3,PTENDL=ZZTENL,PTENDI=ZZTENI,PTENDA=ZZTENA, &
       & PGFLPT=GFLPT(1,1,1,IBL),PGMV=GMV(1,1,1,IBL),PGMVS=GMVS(1,1,IBL))
    ENDIF
  
    IF(LL_GET_ECPHYSTND) THEN
      CALL CPG_PT( &
       & ICST,ICEND,.TRUE.,1,NFLEVG, &
       & PTENDU=ZZTENU,PTENDV=ZZTENV,PTENDT=ZZTENT, &
       & PTENDQ=ZZTENQ,PTENDO3=ZZTENO3,PTENDL=ZZTENL,PTENDI=ZZTENI,PTENDA=ZZTENA, &
       & PGFLPT=GFLPT(1,1,1,IBL),PGMV=GMV(1,1,1,IBL),PGMVS=GMVS(1,1,IBL))
      GMVT1(ICST:ICEND,1:NFLEVG,YT1%MU,IBL)=ZZTENU(ICST:ICEND,1:NFLEVG)+GMVT1(ICST:ICEND,1:NFLEVG,YT1%MU,IBL)
      GMVT1(ICST:ICEND,1:NFLEVG,YT1%MV,IBL)=ZZTENV(ICST:ICEND,1:NFLEVG)+GMVT1(ICST:ICEND,1:NFLEVG,YT1%MV,IBL)
      GMVT1(ICST:ICEND,1:NFLEVG,YT1%MT,IBL)=ZZTENT(ICST:ICEND,1:NFLEVG)+GMVT1(ICST:ICEND,1:NFLEVG,YT1%MT,IBL)
      IF (YQ%LACTIVE) GFLT1(ICST:ICEND,1:NFLEVG,YQ%MP1,IBL)=ZZTENQ(ICST:ICEND,1:NFLEVG)+GFLT1(ICST:ICEND,1:NFLEVG,YQ%MP1,IBL)
      IF (YO3%LACTIVE) GFLT1(ICST:ICEND,1:NFLEVG,YO3%MP1,IBL)= ZZTENO3(ICST:ICEND,1:NFLEVG)+GFLT1(ICST:ICEND,1:NFLEVG,YO3%MP1,IBL)
      IF (.NOT.LSLPHY) THEN
        IF (YL%LACTIVE) GFLT1(ICST:ICEND,1:NFLEVG,YL%MP1,IBL)=ZZTENL(ICST:ICEND,1:NFLEVG) & 
         & +GFLT1(ICST:ICEND,1:NFLEVG,YL%MP1,IBL)
        IF (YI%LACTIVE) GFLT1(ICST:ICEND,1:NFLEVG,YI%MP1,IBL)=ZZTENI(ICST:ICEND,1:NFLEVG) & 
         & +GFLT1(ICST:ICEND,1:NFLEVG,YI%MP1,IBL)
      ENDIF
      IF (YA%LACTIVE) GFLT1(ICST:ICEND,1:NFLEVG,YA%MP1,IBL)=ZZTENA(ICST:ICEND,1:NFLEVG)+GFLT1(ICST:ICEND,1:NFLEVG,YA%MP1,IBL)
    ENDIF

  ENDDO
!$OMP END DO

  IF(LFIXSPPT) THEN
     IF(NEPHYS_PCFULL /= 3) CALL ABOR1('EC_PHYS: FIXSPPT with  NEPHYS_PCFULL /= 3 not implemented')
     IF(NPHYINT > 0) CALL ABOR1('EC_PHYS: FIXSPPT with  NPHYINT>0 not implemented')
     CALL FIXSPPT(GMVS,ZDPTENQ,GFLT1,GMVT1)
  ENDIF

  IF(LPC_FULL)THEN
    DEALLOCATE(ZZTENU,ZZTENV,ZZTENT)
    DEALLOCATE(ZZTENQ,ZZTENO3)
    DEALLOCATE(ZZTENL,ZZTENI,ZZTENA)
  ENDIF

!--- Load Balancing
  IF(LERAIN_LB) CALL ONEDVAR_RAINTB_HLD(IHLPRDY,IT)
          !--- MASTER: Hold until all Helper Signals Received

!$OMP END PARALLEL 
  CALL GSTATS(1001,1)

ENDIF

IF(LERAIN_ACTIVE) THEN

  !------ Load Balancing Start --------------------
  IF(LERAIN_LB)CALL ONEDVAR_RAINTB_HLP()
    !--- MASTER: Send Done Signal
    !--- HELPER: Send Ready To Help Signal
    !--- HELPER: Get and Do Work until Done
  !------ Load Balancing End ----------------------

ENDIF ! Rain Active

CALL GSTATS_BARRIER(730) 

IF(LL_AVERAGE_ECPHYS) THEN

CALL GSTATS(1064,0)

!$OMP PARALLEL DO SCHEDULE(STATIC) PRIVATE(JKGLO,ICEND,IBL,IOFF)
  DO JKGLO=1,NGPTOT,NPROMA

    IBL=(JKGLO-1)/NPROMA+1
    IOFF=JKGLO-1
    ICEND=MIN(NPROMA,NGPTOT-JKGLO+1)

    IF (LSLPHY.AND.LPC_FULL) THEN
      CALL SLTEND2(ICST,ICEND,NPROMA,NFLEVG,NVTEND,&
       & NSTEP,NSTART,&
       & GMV(1,1,YPH9%MT,IBL),GFL(1,1,YQ%MP9_PH,IBL),GFL(1,1,YL%MP9_PH,IBL), &
       & GFL(1,1,YI%MP9_PH,IBL),GFL(1,1,YA%MP9_PH,IBL),&
       & GMVT1(1,1,YT1%MU,IBL), &
       & GMVT1(1,1,YT1%MV,IBL),GMVT1(1,1,YT1%MT,IBL),GFLT1(1,1,YQ%MP1,IBL),& 
       & GFLT1(1,1,YO3%MP1,IBL),GFLT1(1,1,YL%MP1,IBL),GFLT1(1,1,YI%MP1,IBL), &
       & GFLT1(1,1,YA%MP1,IBL),PPBUP9(1,1,IBL), &
       & PPBVP9(1,1,IBL),PPBTP9(1,1,IBL),PPBGFLP9(1,1,YQ%MP,IBL), &
       & PPBGFLP9(1,1,YO3%MP,IBL),PPBGFLP9(1,1,YA%MP,IBL),&
       & SAVTEND(1,1,1,IBL),GFLSLP(1,1,1,IBL),GMVT1S(1,YT1%MSP,IBL))
    ENDIF

    CALL CPQTUV( NPROMA, 1,ICEND,NFLEVG, TSPHY,&
     & GMV(1,1,YPH9%MU,IBL),GMV(1,1,YPH9%MV,IBL),GMV(1,1,YPH9%MT,IBL), &
     & GFL(1,1,1,IBL),&
     & GMVT1(1,1,YT1%MU,IBL),GMVT1(1,1,YT1%MV,IBL),GMVT1(1,1,YT1%MT,IBL), &
     & GFLT1(1,1,1,IBL))

   ENDDO
!$OMP END PARALLEL DO
CALL GSTATS(1064,1)
ENDIF

IF(LL_COPY_LSLPHY)THEN

!$OMP PARALLEL DO SCHEDULE(STATIC) PRIVATE(JKGLO,ICEND,IBL,IOFF)
  DO JKGLO=1,NGPTOT,NPROMA

    IBL=(JKGLO-1)/NPROMA+1
    IOFF=JKGLO-1
    ICEND=MIN(NPROMA,NGPTOT-JKGLO+1)

    SAVTEND(ICST:ICEND,1:NFLEVG,MU_SAVTEND,IBL)=SAVTEND(ICST:ICEND,1:NFLEVG,MU_SAVTEND_S,IBL)
    SAVTEND(ICST:ICEND,1:NFLEVG,MV_SAVTEND,IBL)=SAVTEND(ICST:ICEND,1:NFLEVG,MV_SAVTEND_S,IBL)
    SAVTEND(ICST:ICEND,1:NFLEVG,MT_SAVTEND,IBL)=SAVTEND(ICST:ICEND,1:NFLEVG,MT_SAVTEND_S,IBL)
    SAVTEND(ICST:ICEND,1:NFLEVG,MSAT_SAVTEND,IBL)=SAVTEND(ICST:ICEND,1:NFLEVG,MSAT_SAVTEND_S,IBL)
    GFLSLP(ICST:ICEND,1:NFLEVG,YQ%MPSLP,IBL)=GFLSLP(ICST:ICEND,1:NFLEVG,YQ%MPSLP+MSAVTEND_S,IBL)
    IF(LEO3CH)GFLSLP(ICST:ICEND,1:NFLEVG,YO3%MPSLP,IBL)=GFLSLP(ICST:ICEND,1:NFLEVG,YO3%MPSLP+MSAVTEND_S,IBL)
    IF(YL%LACTIVE)GFLSLP(ICST:ICEND,1:NFLEVG,YL%MPSLP,IBL)=GFLSLP(ICST:ICEND,1:NFLEVG,YL%MPSLP+MSAVTEND_S,IBL)
    IF(YI%LACTIVE)GFLSLP(ICST:ICEND,1:NFLEVG,YI%MPSLP,IBL)=GFLSLP(ICST:ICEND,1:NFLEVG,YI%MPSLP+MSAVTEND_S,IBL)
    IF(YR%LACTIVE)GFLSLP(ICST:ICEND,1:NFLEVG,YR%MPSLP,IBL)=GFLSLP(ICST:ICEND,1:NFLEVG,YR%MPSLP+MSAVTEND_S,IBL)
    IF(YS%LACTIVE)GFLSLP(ICST:ICEND,1:NFLEVG,YS%MPSLP,IBL)=GFLSLP(ICST:ICEND,1:NFLEVG,YS%MPSLP+MSAVTEND_S,IBL)
    IF(YA%LACTIVE)GFLSLP(ICST:ICEND,1:NFLEVG,YA%MPSLP,IBL)=GFLSLP(ICST:ICEND,1:NFLEVG,YA%MPSLP+MSAVTEND_S,IBL)
    DO JGFL=1,NGHG
      IF(YGHG(JGFL)%LPHY .AND. YGHG(JGFL)%LADV) THEN
        GFLSLP(ICST:ICEND,1:NFLEVG,YGHG(JGFL)%MPSLP,IBL)=GFLSLP(ICST:ICEND,1:NFLEVG,YGHG(JGFL)%MPSLP+MSAVTEND_S,IBL)
      ENDIF
    ENDDO
    DO JGFL=1,NTRAC
      IF(YTRAC(JGFL)%LPHY .AND. YTRAC(JGFL)%LADV) THEN
        GFLSLP(ICST:ICEND,1:NFLEVG,YTRAC(JGFL)%MPSLP,IBL)=GFLSLP(ICST:ICEND,1:NFLEVG,YTRAC(JGFL)%MPSLP+MSAVTEND_S,IBL)
      ENDIF
    ENDDO
    DO JGFL=1,NGRG
      IF(YGRG(JGFL)%LPHY .AND. YGRG(JGFL)%LADV) THEN
        GFLSLP(ICST:ICEND,1:NFLEVG,YGRG(JGFL)%MPSLP,IBL)=GFLSLP(ICST:ICEND,1:NFLEVG,YGRG(JGFL)%MPSLP+MSAVTEND_S,IBL)
      ENDIF
    ENDDO
    DO JGFL=1,NAERO
      IF(YAERO(JGFL)%LPHY .AND. YAERO(JGFL)%LADV) THEN
        GFLSLP(ICST:ICEND,1:NFLEVG,YAERO(JGFL)%MPSLP,IBL)=GFLSLP(ICST:ICEND,1:NFLEVG,YAERO(JGFL)%MPSLP+MSAVTEND_S,IBL)
      ENDIF
    ENDDO
    DO JGFL=1,NGFL_EXT
      IF(YEXT(JGFL)%LPHY .AND. YEXT(JGFL)%LADV) THEN
        GFLSLP(ICST:ICEND,1:NFLEVG,YEXT(JGFL)%MPSLP,IBL)=GFLSLP(ICST:ICEND,1:NFLEVG,YEXT(JGFL)%MPSLP+MSAVTEND_S,IBL)
      ENDIF
    ENDDO
  ENDDO
ENDIF
!print *,'About to go out of EC_PHYS_DRV'

!     ------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('EC_PHYS_DRV',1,ZHOOK_HANDLE)
END SUBROUTINE EC_PHYS_DRV
