#ifdef RS6K
@PROCESS NOCHECK
#endif
SUBROUTINE EC_PHYSG(CDCONF,KPROMA,KPROMA_PHYS,KSMAX,KSMAX_PHYS, &
 & KGPTOT,KGPTOT_PHYS,KGPLAT,&
 & PB2,&
 & PGMV,PGMVS,&
 & PGMVT1,PGMVT1S,PGFLT1,&
 & PGFL,PGFLSLP,&
 & PSP_SB,PSP_SG,PSP_RR,&
 & PSP_EP,PSP_X2,&
 & PSD_VF,PSD_VN,PSD_VD,&
 & PSD_WS,PSD_WW,&
 & PSD_XA,PSD_X2,&
 !-- KPP
 & PSP_OM,PSD_V2,PSD_V3,&
 !-- KPP
 & PEMTD,PTRSW,PEMTC,PTRSC,PTAUAER,&
 & PSRSWD,PSRSWDCS,PEDRO,&
 & PSRSWPAR,PSRSWUVB,PSRSWPARC,PSRSWTINC,PSRFDIR,PSRCDIR,&
 & PGEMU,&
 & PGELAM,PGELAT,PGESLO,PGECLO,PGM,&
 & POROG,&
 & PGNORDL,PGNORDM,&
 & PGSQM2,PCOLON,PSILON,&
 & PRINDX,PRINDY,PGAW,&
 & PSTOPHU,PSTOPHV,&
 & PSTOPHT,PSTOPHQ,&
 & PSTOPHCA,PCUCONVCA,PNLCONVCA,PCAPECONVCA,&
 & PPBUP9, PPBVP9, &
 & PPBTP9,PPBGFLP9,&
 & PGP2DSDT,&
 & PSTREAM,PTEMP, PVELPOT, PTOTDISS,  PTOTDISS_SMOOTH, &
 & PVORTGRAD, &
 & PFORCEU,PFORCEV,&
 & PFORCET,PFORCEQ,&
 & PEXTRADYN,PSAVTEND,&
 & LDRAIN_LB,KHLPRDY,KT,&
 & PMWAVE_OBS_BUF,PMWAVE_ZEN_BUF,PMWAVE_AZI_BUF,PMWAVE_TB_BUF,PMWAVE_OERR_BUF,&
 & PMWAVE_PERS1_BUF,&
 & PMWAVE_DIAG_BUF,PMWAVE_P19_BUF,PMWAVE_P37_BUF,PMWAVE_GNORM_BUF,&
 & KMWAVE_BUF,&
 & PSMOS_OBS_BUF,PSMOS_TB_BUF,PSMOS_ANGLE,&
 & KSMOS_BUF,DPTENQ0, DPTENQ1, &
 & ZEMTD2,ZTRSW2,ZEMTC2,ZTRSC2)
!
USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCT0   ,ONLY : NPROC
USE YOMSLPHY , ONLY : LSLPHY   ,NVTEND
USE YOMDIM   , ONLY : NFLEVG   ,NDGSAG ,NDGENG, NDGSAL, NDGENL, &
                    & NDGLG, NGPBLKS
USE YOM_YGFL , ONLY : YGFL, YQ, YO3, YL, YI, YA
USE YOMMP    , ONLY : NASLB1    ,NSLPROCS  ,&
 & NSLRPT    ,NSLSPT    ,NSLSENDPOS,&
 & NSLRECVPOS,NSLCOMM   ,&
 & NSLSTA    ,NSLONL    ,NSLOFF    ,NFRSTLOFF ,&
 & MYFRSTACTLAT         ,MYLSTACTLAT
USE YOM_PHYS_GRID ,ONLY : YPHYPOI, YDYNPOI, DYN_SL, PHYS_SL, PHYS_GRID
USE YOPHNC   , ONLY : LENCLD2
USE YOMGEM   , ONLY : NGPTOT, NLOENG
USE YOMMASK  , ONLY : NFIXSFLD
USE YOMDPHY  , ONLY : NVEXTRDYN
USE YOMSC2   , ONLY : NFLDSLB2
USE YOMGMV   , ONLY : YPH9,YT1,NDIMGMV,NDIMGMVS
USE YOEPHY   , ONLY : LEPCLD
USE YOEWCOU  , ONLY : LWCOU
!! USE YOMLUN   , ONLY : NULOUT
USE SURFACE_FIELDS_MIX , ONLY : YSP_SBD, YSP_SB, YSP_SGD, YSP_SG, &
 & YSP_RRD, YSP_RR, YSD_WSD, YSD_WS, YSP_EPD, &
 & YSP_X2D, YSD_VDD, YSD_VD, YSD_VFD, YSD_VF, &
 & YSD_VND, YSD_VN, YSD_WWD, YSD_WW, YSD_XAD, YSD_X2D, &
 & YSP_OMD, YSP_OM, YSD_V2D, YSD_V2, YSD_V3D, YSD_V3  ! KPP
USE YOMMWAVE , ONLY : N_SATSENS, NMWAVE_DIAG, NMWAVE_GNRM, NMWAVE_P
USE PARMWAVE , ONLY : NMAX_CHAN
USE YOMSMOS  , ONLY : NPOL_MAX
USE YOMSPSDT ,  ONLY : YGPSDT

USE YOERAD   , ONLY : L2RAD

!**** *EC_PHYSG* - ECMWF PHYSICS

!     Purpose.
!     --------
!           Calling routine for Coarser/Finer Physics

!**   Interface.
!     ----------
!        *CALL* *EC_PHYSG*

!        Explicit arguments :
!        --------------------
!        CDCONF    : configuration of work
!        KNUMB     : number of elements of arrays for which computations
!                    are performed (used in message passing version)
!        KSTGLO    : global offset (used in message passing version)
!        --- other dummy : missing some comments ---

!        Implicit arguments :
!        --------------------

!     Method.
!     -------
!        See documentation

!     Externals.
!     ----------
!        Called by GP_MODEL.

!     Reference.
!     ----------

!     Author.
!     -------
!        Mariano Hortal & Deborah Salmond *ECMWF*

!     Modifications.
!     --------------
!      Original 2005-02-25
!        D.Salmond     18-May-2007  Revised version
!        D.Salmond 20071114  Prognostic aerosols for radiation and cloud routines
!        A. Geer       15-Apr-2008  Multiple sensors for rainy 4D-Var
!        A. Geer       01-Oct-2008  Rainy 4D-Var tidying
!       GMozdzynski/JJMorcrette 20090128 bugfix dynamical extra fields
!        Y. Takaya     29-Jan-2009  Ocean mixed layer model
!        K. Yessad Dec 2008: merge the different (E)SLEXTPOL.. -> (E)SLEXTPOL.
!        JJMorcrette 20091201 Total and clear-sky direct SW radiation flux at surface 
!        W. Bell       06-Mar-2009  Add Windsat azimuth angle
!        A. Geer       10-Jun-2008  Rainy 4D-Var passive mode and diagnostics
!     ------------------------------------------------------------------

IMPLICIT NONE

CHARACTER(LEN=1)  ,INTENT(IN)    :: CDCONF 
INTEGER(KIND=JPIM),INTENT(IN)    :: KPROMA
INTEGER(KIND=JPIM),INTENT(IN)    :: KPROMA_PHYS
INTEGER(KIND=JPIM),INTENT(IN)    :: KSMAX
INTEGER(KIND=JPIM),INTENT(IN)    :: KSMAX_PHYS
INTEGER(KIND=JPIM),INTENT(IN)    :: KGPTOT
INTEGER(KIND=JPIM),INTENT(IN)    :: KGPTOT_PHYS
INTEGER(KIND=JPIM),INTENT(IN)    :: KGPLAT(KGPTOT_PHYS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PB2(KPROMA,NFLDSLB2,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGMV(KPROMA,NFLEVG,NDIMGMV,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGMVS(KPROMA,NDIMGMVS,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PGMVT1(KPROMA,NFLEVG,YT1%NDIM,NGPBLKS) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGMVT1S(KPROMA,YT1%NDIMS,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PGFLT1(KPROMA,NFLEVG,YGFL%NDIM1,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGFL(KPROMA,NFLEVG,YGFL%NDIM,NGPBLKS) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PGFLSLP(KPROMA,NFLEVG,YGFL%NDIMSLP,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSP_SB(KPROMA,YSP_SBD%NLEVS,YSP_SBD%NDIM,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSP_SG(KPROMA,YSP_SGD%NDIM,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSP_RR(KPROMA,YSP_RRD%NDIM,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSP_EP(KPROMA,YSP_EPD%NLEVS,YSP_EPD%NDIM,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSP_X2(KPROMA,YSP_X2D%NDIM,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSD_VF(KPROMA,YSD_VFD%NDIM,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSD_VN(KPROMA,YSD_VND%NDIM,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSD_VD(KPROMA,YSD_VDD%NDIM,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSD_WS(KPROMA,YSD_WSD%NDIM,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSD_WW(KPROMA,YSD_WWD%NDIM,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSD_XA(KPROMA,YSD_XAD%NLEVS,YSD_XAD%NDIM,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSD_X2(KPROMA,YSD_X2D%NDIM,NGPBLKS)

REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSP_OM(KPROMA,YSP_OMD%NLEVS,YSP_OMD%NDIM,NGPBLKS)  !KPP
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSD_V2(KPROMA,YSD_V2D%NDIM,NGPBLKS)                !KPP
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSD_V3(KPROMA,YSD_V3D%NLEVS,YSD_V3D%NDIM,NGPBLKS)  !KPP

REAL(KIND=JPRB)   ,INTENT(INOUT) :: PEMTD(KPROMA,NFLEVG+1,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTRSW(KPROMA,NFLEVG+1,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PEMTC(KPROMA,NFLEVG+1,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PTRSC(KPROMA,NFLEVG+1,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTAUAER(KPROMA,NFLEVG,6,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSRSWD(KPROMA,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSRSWDCS(KPROMA,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PEDRO(KPROMA,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSRSWPAR(KPROMA,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSRSWUVB(KPROMA,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSRSWPARC(KPROMA,NGPBLKS),PSRSWTINC(KPROMA,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSRFDIR(KPROMA,NGPBLKS)  ,PSRCDIR(KPROMA,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGEMU(KGPTOT_PHYS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGELAM(KGPTOT_PHYS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGELAT(KGPTOT_PHYS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGESLO(KGPTOT_PHYS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGECLO(KGPTOT_PHYS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGM(KGPTOT_PHYS) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: POROG(KGPTOT)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGNORDL(KGPTOT_PHYS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGNORDM(KGPTOT_PHYS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGSQM2(KGPTOT_PHYS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PCOLON(KGPTOT_PHYS) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSILON(KGPTOT_PHYS) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PRINDX(KGPTOT_PHYS) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PRINDY(KGPTOT_PHYS) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGAW(KGPTOT_PHYS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSTOPHU(KGPTOT)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSTOPHV(KGPTOT)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSTOPHT(KGPTOT)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSTOPHQ(KGPTOT)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSTOPHCA(KGPTOT)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCUCONVCA(KGPTOT)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PNLCONVCA(KGPTOT)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCAPECONVCA(KGPTOT)

REAL(KIND=JPRB)   ,INTENT(IN)    :: PPBUP9(KPROMA,NFLEVG,NGPBLKS) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PPBVP9(KPROMA,NFLEVG,NGPBLKS) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PPBTP9(KPROMA,NFLEVG,NGPBLKS) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PPBGFLP9(KPROMA,NFLEVG,YGFL%NUMFLDS,NGPBLKS) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGP2DSDT(KPROMA,YGPSDT%NG2D,NGPBLKS ) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PFORCEU(KPROMA,NFLEVG,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PFORCEV(KPROMA,NFLEVG,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PFORCET(KPROMA,NFLEVG,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PFORCEQ(KPROMA,NFLEVG,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PEXTRADYN(KPROMA,NFLEVG,NVEXTRDYN,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSAVTEND (KPROMA,NFLEVG,NVTEND,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSTREAM(KPROMA,NFLEVG,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PTEMP(KPROMA,NFLEVG,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PVELPOT(KPROMA,NFLEVG,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTOTDISS(KPROMA,NFLEVG,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTOTDISS_SMOOTH(KPROMA,NFLEVG,NGPBLKS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PVORTGRAD(KPROMA,3*NFLEVG,NGPBLKS)

REAL(KIND=JPRB)   ,INTENT(IN)    :: PMWAVE_OBS_BUF(NGPTOT,NMAX_CHAN,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PMWAVE_ZEN_BUF(NGPTOT,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PMWAVE_AZI_BUF(NGPTOT,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PMWAVE_TB_BUF(NGPTOT,NMAX_CHAN,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PMWAVE_OERR_BUF(NGPTOT,NMAX_CHAN,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PMWAVE_PERS1_BUF(NGPTOT,NMAX_CHAN,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PMWAVE_DIAG_BUF(NGPTOT,NMWAVE_DIAG,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PMWAVE_P19_BUF(NGPTOT,NMWAVE_P,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PMWAVE_P37_BUF(NGPTOT,NMWAVE_P,N_SATSENS)
INTEGER(KIND=JPIM),INTENT(INOUT) :: KMWAVE_BUF(NGPTOT,NMAX_CHAN,N_SATSENS)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PMWAVE_GNORM_BUF(NGPTOT,NMWAVE_GNRM,N_SATSENS)

REAL(KIND=JPRB)   ,INTENT(IN)    :: PSMOS_OBS_BUF(NGPTOT,0:NPOL_MAX-1)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSMOS_ANGLE(NGPTOT,0:NPOL_MAX-1)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSMOS_TB_BUF(NGPTOT,0:NPOL_MAX-1)
INTEGER(KIND=JPIM),INTENT(INOUT) :: KSMOS_BUF(NGPTOT,0:NPOL_MAX-1)
REAL(KIND=JPRB)   ,INTENT(OUT) :: DPTENQ0(KPROMA,NFLEVG,4),DPTENQ1(KPROMA,NFLEVG,4)


LOGICAL,INTENT(IN)    :: LDRAIN_LB

INTEGER(KIND=JPIM),INTENT(IN)    :: KHLPRDY(:)
INTEGER(KIND=JPIM),INTENT(IN)    :: KT

! Double radiation
REAL(KIND=JPRB), ALLOCATABLE   ,INTENT(IN) :: ZEMTD2(:,:,:)
REAL(KIND=JPRB), ALLOCATABLE   ,INTENT(IN) :: ZTRSW2(:,:,:)
REAL(KIND=JPRB), ALLOCATABLE   ,INTENT(IN) :: ZEMTC2(:,:,:)
REAL(KIND=JPRB), ALLOCATABLE   ,INTENT(IN) :: ZTRSC2(:,:,:)
REAL(KIND=JPRB), ALLOCATABLE   :: PEMTD2(:,:), PTRSW2(:,:), &
                                & PEMTC2(:,:), PTRSC2(:,:)

!     ------------------------------------------------------------------

REAL(KIND=JPRB),ALLOCATABLE :: ZBUF_SL_PHYS(:,:)
REAL(KIND=JPRB),ALLOCATABLE :: ZBUF_SL_DYN(:,:)
REAL(KIND=JPRB),ALLOCATABLE :: ZPARITY(:)
REAL(KIND=JPRB),ALLOCATABLE :: ZPB2(:,:)
REAL(KIND=JPRB), ALLOCATABLE :: ZDYN_SAVE(:,:)
REAL(KIND=JPRB),ALLOCATABLE :: ZGFLSLP(:,:,:)

INTEGER(KIND=JPIM), ALLOCATABLE :: IMASK_DYN(:),IMASK_PHYS(:)

INTEGER(KIND=JPIM) :: II, JP,JJ,JLEV,JGFL
INTEGER(KIND=JPIM) :: IFLDS_IN,IFLDS_OUT,IBL,IOFF,JKGLO
INTEGER(KIND=JPIM) :: ICEND,JFLDS
INTEGER(KIND=JPIM) :: IDUMARR(2)
INTEGER(KIND=JPIM) :: ICOUNT_FLDS
INTEGER(KIND=JPIM) :: INDEX_PB2,INDEX_OROG

INTEGER(KIND=JPIM) :: INDEX_GMV_U,INDEX_GMV_V,INDEX_GMVT1S
INTEGER(KIND=JPIM) :: INDEX_PBUP9,INDEX_PBVP9,INDEX_PBTP9,INDEX_PBGFLP9
INTEGER(KIND=JPIM) :: INDEX_GFLT1,INDEX_GFL,INDEX_GMV_T,INDEX_GMVS,INDEX_GMVT1
INTEGER(KIND=JPIM) :: INDEX_EDRO,INDEX_SRSWDCS,INDEX_SRSWD,INDEX_SRSWUVB
INTEGER(KIND=JPIM) :: INDEX_SRSWPAR,INDEX_SRSWPARC,INDEX_SRSWTINC,INDEX_EMTD,INDEX_TRSC
INTEGER(KIND=JPIM) :: INDEX_SRFDIR, INDEX_SRCDIR, INDEX_TAUAER
INTEGER(KIND=JPIM) :: INDEX_EMTC,INDEX_TRSW
INTEGER(KIND=JPIM) :: INDEX_PSAVTEND
INTEGER(KIND=JPIM) :: INDEX_PSP_SB, INDEX_PSP_EP, INDEX_PSD_XA
INTEGER(KIND=JPIM) :: INDEX_PSP_SG, INDEX_PSP_RR, INDEX_PSP_X2
INTEGER(KIND=JPIM) :: INDEX_PSD_VD, INDEX_PSD_VN, INDEX_PSD_X2
INTEGER(KIND=JPIM) :: INDEX_PSD_VF, INDEX_PSD_WS, INDEX_PSD_WW
INTEGER(KIND=JPIM) :: INDEX_PSP_OM, INDEX_PSD_V2, INDEX_PSD_V3 !KPP

INTEGER(KIND=JPIM) :: INDEX_GFLT1_OUT,INDEX_GMVT1_OUT
INTEGER(KIND=JPIM) :: INDEX_EDRO_OUT
INTEGER(KIND=JPIM) :: INDEX_EMTD_OUT,INDEX_TRSW_OUT
INTEGER(KIND=JPIM) :: INDEX_TAUAER_OUT
INTEGER(KIND=JPIM) :: INDEX_PSAVTEND_OUT
INTEGER(KIND=JPIM) :: INDEX_PSP_SB_OUT, INDEX_PSP_EP_OUT, INDEX_PSD_XA_OUT
INTEGER(KIND=JPIM) :: INDEX_PSP_SG_OUT, INDEX_PSP_RR_OUT, INDEX_PSP_X2_OUT
INTEGER(KIND=JPIM) :: INDEX_PSD_VD_OUT, INDEX_PSD_VN_OUT, INDEX_PSD_X2_OUT
INTEGER(KIND=JPIM) :: INDEX_PSD_WS_OUT, INDEX_PSD_WW_OUT, INDEX_GFLSLP_OUT
INTEGER(KIND=JPIM) :: INDEX_PSP_OM_OUT, INDEX_PSD_V2_OUT, INDEX_PSD_V3_OUT !KPP

LOGICAL :: LLINC

INTEGER(KIND=JPIM) :: IWMAX

REAL(KIND=JPRB) :: ZHOOK_HANDLE, ZWMAX

!     ------------------------------------------------------------------

#include "ec_phys.intfb.h"
#include "slextpol.intfb.h"
#include "slcomm2.intfb.h"
#include "abor1.intfb.h"

!     ------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('EC_PHYSG',0,ZHOOK_HANDLE)
!     ------------------------------------------------------------------


IF( LENCLD2 .AND. .NOT. LEPCLD ) THEN
  CALL ABOR1('NOT PROGNOSTIC CLOUD AND INTERPOLATION')
ENDIF

!     ------------------------------------------------------------------
!*       2.   AVERAGING OF DYNAMIC FIELDS IF PHYS_GRID%NSMAX < NSMAX
!             --------- -- ------- ------ -- ---------------   -----
!             Otherwise interpolate to the physics grid
!             --------- ----------- -- --- ------- ----

!*       2.1  FILL THE CORE OF THE AVERAGING BUFFER

!INPUT FIELDS

ICOUNT_FLDS=1
INDEX_GMVT1=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YT1%NDIM*NFLEVG
INDEX_GFLT1=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YGFL%NDIM1*NFLEVG
INDEX_GMV_U=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+NFLEVG
INDEX_GMV_V=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+NFLEVG
INDEX_GMV_T=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+NFLEVG
INDEX_PB2=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+NFLDSLB2
INDEX_GMVS=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+1
INDEX_GMVT1S=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YT1%NDIMS
INDEX_GFL=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YGFL%NDIM*NFLEVG
INDEX_EMTD=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+NFLEVG+1
INDEX_TRSW=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+NFLEVG+1
INDEX_EMTC=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+NFLEVG+1
INDEX_TRSC=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+NFLEVG+1
INDEX_TAUAER=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+NFLEVG*6
INDEX_SRSWD=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+1
INDEX_SRSWDCS=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+1
INDEX_EDRO=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+1
INDEX_PSP_SB=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSP_SBD%NDIM*YSP_SBD%NLEVS
INDEX_PSP_EP=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSP_EPD%NDIM*YSP_EPD%NLEVS
INDEX_PSD_XA=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSD_XAD%NDIM*YSD_XAD%NLEVS
INDEX_PSP_SG=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSP_SGD%NDIM
INDEX_PSP_RR=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSP_RRD%NDIM
INDEX_PSP_X2=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSP_X2D%NDIM
INDEX_PSD_VF=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSD_VFD%NDIM
INDEX_PSD_VN=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSD_VND%NDIM
INDEX_PSD_VD=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSD_VDD%NDIM
INDEX_PSD_WS=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSD_WSD%NDIM
INDEX_PSD_WW=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSD_WWD%NDIM
INDEX_PSD_X2=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSD_X2D%NDIM

INDEX_PSP_OM=ICOUNT_FLDS                           !KPP
ICOUNT_FLDS=ICOUNT_FLDS+YSP_OMD%NDIM*YSP_OMD%NLEVS !KPP
INDEX_PSD_V2=ICOUNT_FLDS                           !KPP
ICOUNT_FLDS=ICOUNT_FLDS+YSD_V2D%NDIM               !KPP
INDEX_PSD_V3=ICOUNT_FLDS                           !KPP
ICOUNT_FLDS=ICOUNT_FLDS+YSD_V3D%NDIM*YSD_V3D%NLEVS !KPP

INDEX_SRSWPAR=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+1
INDEX_SRSWUVB=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+1
INDEX_SRSWPARC=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+1
INDEX_SRSWTINC=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+1
INDEX_SRFDIR=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+1
INDEX_SRCDIR=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+1

IF(LSLPHY) THEN
  INDEX_PBUP9=ICOUNT_FLDS
  ICOUNT_FLDS=ICOUNT_FLDS+NFLEVG
  INDEX_PBVP9=ICOUNT_FLDS
  ICOUNT_FLDS=ICOUNT_FLDS+NFLEVG
  INDEX_PBTP9=ICOUNT_FLDS
  ICOUNT_FLDS=ICOUNT_FLDS+NFLEVG
  INDEX_PBGFLP9=ICOUNT_FLDS
  ICOUNT_FLDS=ICOUNT_FLDS+NFLEVG*YGFL%NUMFLDS
  INDEX_PSAVTEND=ICOUNT_FLDS
  ICOUNT_FLDS=ICOUNT_FLDS+NFLEVG*NVTEND
ENDIF
INDEX_OROG=ICOUNT_FLDS
IFLDS_IN=ICOUNT_FLDS

!OUTPUT FIELDS

ICOUNT_FLDS=1
INDEX_GMVT1_OUT=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YT1%NDIM*NFLEVG
INDEX_GFLT1_OUT=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YGFL%NDIM1*NFLEVG
INDEX_EMTD_OUT=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+NFLEVG+1
INDEX_TRSW_OUT=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+NFLEVG+1
INDEX_TAUAER_OUT=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+NFLEVG*6
INDEX_EDRO_OUT=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+1
INDEX_PSP_SB_OUT=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSP_SBD%NDIM*YSP_SBD%NLEVS
INDEX_PSP_EP_OUT=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSP_EPD%NDIM*YSP_EPD%NLEVS
INDEX_PSD_XA_OUT=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSD_XAD%NDIM*YSD_XAD%NLEVS
INDEX_PSP_SG_OUT=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSP_SGD%NDIM
INDEX_PSP_RR_OUT=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSP_RRD%NDIM
INDEX_PSP_X2_OUT=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSP_X2D%NDIM
INDEX_PSD_VN_OUT=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSD_VND%NDIM
INDEX_PSD_VD_OUT=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSD_VDD%NDIM
INDEX_PSD_WS_OUT=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSD_WSD%NDIM
INDEX_PSD_WW_OUT=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSD_WWD%NDIM
INDEX_PSD_X2_OUT=ICOUNT_FLDS
ICOUNT_FLDS=ICOUNT_FLDS+YSD_X2D%NDIM

INDEX_PSP_OM_OUT=ICOUNT_FLDS                       !KPP
ICOUNT_FLDS=ICOUNT_FLDS+YSP_OMD%NDIM*YSP_OMD%NLEVS !KPP
INDEX_PSD_V2_OUT=ICOUNT_FLDS                       !KPP
ICOUNT_FLDS=ICOUNT_FLDS+YSD_V2D%NDIM               !KPP
INDEX_PSD_V3_OUT=ICOUNT_FLDS                       !KPP
ICOUNT_FLDS=ICOUNT_FLDS+YSD_V3D%NDIM*YSD_V3D%NLEVS !KPP

IF(LSLPHY) THEN
  INDEX_PSAVTEND_OUT=ICOUNT_FLDS
  ICOUNT_FLDS=ICOUNT_FLDS+NFLEVG*NVTEND
  INDEX_GFLSLP_OUT=ICOUNT_FLDS
  ICOUNT_FLDS=ICOUNT_FLDS+YGFL%NDIMSLP*NFLEVG
ENDIF
IFLDS_OUT=ICOUNT_FLDS

!WRITE(NULOUT,'("EC_PHYSG: IFLDS_IN=",I6," IFLDS_OUT=",I6)')IFLDS_IN,IFLDS_OUT

ALLOCATE(ZBUF_SL_DYN(DYN_SL%NASLB1,IFLDS_IN))
ALLOCATE(ZBUF_SL_PHYS(PHYS_SL%NASLB1,IFLDS_OUT))
ALLOCATE(IMASK_DYN(DYN_SL%NASLB1+4))
ALLOCATE(IMASK_PHYS(PHYS_SL%NASLB1+4))
IMASK_DYN=0
IMASK_PHYS=0

! COPY INTO SL BUFFER

CALL GSTATS(1065,0)

!$OMP PARALLEL PRIVATE(JKGLO,IBL,IOFF,ICEND,ICOUNT_FLDS,JFLDS,JLEV,JP,JGFL)
!$OMP DO SCHEDULE(DYNAMIC,1)
DO JKGLO=1,NGPTOT,KPROMA
  IBL=(JKGLO-1)/KPROMA+1
  IOFF=JKGLO-1
  ICEND=MIN(KPROMA,NGPTOT-JKGLO+1)

  ICOUNT_FLDS=INDEX_GMVT1
  DO JFLDS=1,YT1%NDIM
    DO JLEV=1,NFLEVG
      DO JP=1,ICEND
        ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),ICOUNT_FLDS)=PGMVT1(JP,JLEV,JFLDS,IBL)
      ENDDO
      ICOUNT_FLDS=ICOUNT_FLDS+1
    ENDDO
  ENDDO

  ICOUNT_FLDS=INDEX_GFLT1
  DO JFLDS=1,YGFL%NDIM1
    DO JLEV=1,NFLEVG
      DO JP=1,ICEND
        ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),ICOUNT_FLDS)=PGFLT1(JP,JLEV,JFLDS,IBL)
      ENDDO
      ICOUNT_FLDS=ICOUNT_FLDS+1
    ENDDO
  ENDDO

  DO JLEV=1,NFLEVG
    DO JP=1,ICEND
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_GMV_U+JLEV-1)=PGMV(JP,JLEV,YPH9%MU,IBL)
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_GMV_V+JLEV-1)=PGMV(JP,JLEV,YPH9%MV,IBL)
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_GMV_T+JLEV-1)=PGMV(JP,JLEV,YPH9%MT,IBL)
    ENDDO
  ENDDO

  ICOUNT_FLDS=INDEX_PB2
  DO JFLDS=1,NFLDSLB2
    DO JP=1,ICEND
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),ICOUNT_FLDS)=PB2(JP,JFLDS,IBL)
    ENDDO
    ICOUNT_FLDS=ICOUNT_FLDS+1
  ENDDO

  ICOUNT_FLDS=INDEX_GMVS
  DO JP=1,ICEND
    ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),ICOUNT_FLDS)=PGMVS(JP,YPH9%MSP,IBL)
  ENDDO

  ICOUNT_FLDS=INDEX_GMVT1S
  DO JFLDS=1,YT1%NDIMS
    DO JP=1,ICEND
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),ICOUNT_FLDS)=PGMVT1S(JP,JFLDS,IBL)
    ENDDO
    ICOUNT_FLDS=ICOUNT_FLDS+1
  ENDDO

  ICOUNT_FLDS=INDEX_GFL
  DO JFLDS=1,YGFL%NDIM
    DO JLEV=1,NFLEVG
      DO JP=1,ICEND
        ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),ICOUNT_FLDS)=PGFL(JP,JLEV,JFLDS,IBL)
      ENDDO
      ICOUNT_FLDS=ICOUNT_FLDS+1
    ENDDO
  ENDDO

  DO JLEV=1,NFLEVG+1
    DO JP=1,ICEND
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_EMTD+JLEV-1)=PEMTD(JP,JLEV,IBL)
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_TRSW+JLEV-1)=PTRSW(JP,JLEV,IBL)
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_EMTC+JLEV-1)=PEMTC(JP,JLEV,IBL)
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_TRSC+JLEV-1)=PTRSC(JP,JLEV,IBL)
    ENDDO
  ENDDO
 
  DO II=1,6
    DO JLEV=1,NFLEVG
      DO JP=1,ICEND
        ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_TAUAER+JLEV-1+(II-1)*NFLEVG)=PTAUAER(JP,JLEV,II,IBL)
      ENDDO
    ENDDO
  ENDDO

  DO JP=1,ICEND
    ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_SRSWD)=PSRSWD(JP,IBL)
    ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_SRSWDCS)=PSRSWDCS(JP,IBL)
    ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_EDRO)=PEDRO(JP,IBL)
  ENDDO

  ICOUNT_FLDS=INDEX_PSP_SB
  DO JFLDS=1,YSP_SBD%NDIM
    DO JLEV=1,YSP_SBD%NLEVS
      DO JP=1,ICEND
        ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),ICOUNT_FLDS)=PSP_SB(JP,JLEV,JFLDS,IBL)
      ENDDO
      ICOUNT_FLDS=ICOUNT_FLDS+1
    ENDDO
  ENDDO
  ICOUNT_FLDS=INDEX_PSP_EP
  DO JFLDS=1,YSP_EPD%NDIM
    DO JLEV=1,YSP_EPD%NLEVS
      DO JP=1,ICEND
        ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),ICOUNT_FLDS)=PSP_EP(JP,JLEV,JFLDS,IBL)
      ENDDO
      ICOUNT_FLDS=ICOUNT_FLDS+1
    ENDDO
  ENDDO
  ICOUNT_FLDS=INDEX_PSD_XA
  DO JFLDS=1,YSD_XAD%NDIM
    DO JLEV=1,YSD_XAD%NLEVS
      DO JP=1,ICEND
        ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),ICOUNT_FLDS)=PSD_XA(JP,JLEV,JFLDS,IBL)
      ENDDO
      ICOUNT_FLDS=ICOUNT_FLDS+1
    ENDDO
  ENDDO

  DO JFLDS=1,YSP_SGD%NDIM
    DO JP=1,ICEND
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_PSP_SG+JFLDS-1)=PSP_SG(JP,JFLDS,IBL)
    ENDDO
  ENDDO
  DO JFLDS=1,YSP_RRD%NDIM
    DO JP=1,ICEND
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_PSP_RR+JFLDS-1)=PSP_RR(JP,JFLDS,IBL)
    ENDDO
  ENDDO
  DO JFLDS=1,YSP_X2D%NDIM
    DO JP=1,ICEND
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_PSP_X2+JFLDS-1)=PSP_X2(JP,JFLDS,IBL)
    ENDDO
  ENDDO
  DO JFLDS=1,YSD_VFD%NDIM
    DO JP=1,ICEND
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_PSD_VF+JFLDS-1)=PSD_VF(JP,JFLDS,IBL)
    ENDDO
  ENDDO
  DO JFLDS=1,YSD_VND%NDIM
    DO JP=1,ICEND
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_PSD_VN+JFLDS-1)=PSD_VN(JP,JFLDS,IBL)
    ENDDO
  ENDDO
  DO JFLDS=1,YSD_VDD%NDIM
    DO JP=1,ICEND
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_PSD_VD+JFLDS-1)=PSD_VD(JP,JFLDS,IBL)
    ENDDO
  ENDDO
  DO JFLDS=1,YSD_WSD%NDIM
    DO JP=1,ICEND
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_PSD_WS+JFLDS-1)=PSD_WS(JP,JFLDS,IBL)
    ENDDO
  ENDDO
  DO JFLDS=1,YSD_WWD%NDIM
    DO JP=1,ICEND
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_PSD_WW+JFLDS-1)=PSD_WW(JP,JFLDS,IBL)
    ENDDO
  ENDDO
  DO JFLDS=1,YSD_X2D%NDIM
    DO JP=1,ICEND
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_PSD_X2+JFLDS-1)=PSD_X2(JP,JFLDS,IBL)
    ENDDO
  ENDDO

!--- KPP
  ICOUNT_FLDS=INDEX_PSP_OM
  DO JFLDS=1,YSP_OMD%NDIM
    DO JLEV=1,YSP_OMD%NLEVS
      DO JP=1,ICEND
        ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),ICOUNT_FLDS)=PSP_OM(JP,JLEV,JFLDS,IBL)
      ENDDO
      ICOUNT_FLDS=ICOUNT_FLDS+1
    ENDDO
  ENDDO

  DO JFLDS=1,YSD_V2D%NDIM
    DO JP=1,ICEND
      ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_PSD_V2+JFLDS-1)=PSD_V2(JP,JFLDS,IBL)
    ENDDO
  ENDDO

  ICOUNT_FLDS=INDEX_PSD_V3
  DO JFLDS=1,YSD_V3D%NDIM
    DO JLEV=1,YSD_V3D%NLEVS
      DO JP=1,ICEND
        ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),ICOUNT_FLDS)=PSD_V3(JP,JLEV,JFLDS,IBL)
      ENDDO
      ICOUNT_FLDS=ICOUNT_FLDS+1
    ENDDO
  ENDDO
!--- KPP

  DO JP=1,ICEND
    ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_SRSWPAR)=PSRSWPAR(JP,IBL)
    ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_SRSWUVB)=PSRSWUVB(JP,IBL)
    ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_SRSWPARC)=PSRSWPARC(JP,IBL)
    ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_SRSWTINC)=PSRSWTINC(JP,IBL)
    ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_SRFDIR) =PSRFDIR(JP,IBL)
    ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_SRCDIR) =PSRCDIR(JP,IBL)
  ENDDO

  IF(LSLPHY) THEN
    DO JLEV=1,NFLEVG
      DO JP=1,ICEND
        ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_PBUP9+JLEV-1)=PPBUP9(JP,JLEV,IBL)
        ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_PBVP9+JLEV-1)=PPBVP9(JP,JLEV,IBL)
        ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_PBTP9+JLEV-1)=PPBTP9(JP,JLEV,IBL)
      ENDDO
    ENDDO
    ICOUNT_FLDS=INDEX_PBGFLP9
    DO JGFL=1,YGFL%NUMFLDS
      DO JLEV=1,NFLEVG
        DO JP=1,ICEND
          ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),ICOUNT_FLDS)= &
                                     &           PPBGFLP9(JP,JLEV,JGFL,IBL)
        ENDDO
        ICOUNT_FLDS=ICOUNT_FLDS+1
      ENDDO
    ENDDO

    ICOUNT_FLDS=INDEX_PSAVTEND
    DO JGFL=1,NVTEND
      DO JLEV=1,NFLEVG
        DO JP=1,ICEND
          ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),ICOUNT_FLDS)= &
                                     &           PSAVTEND(JP,JLEV,JGFL,IBL)
        ENDDO
        ICOUNT_FLDS=ICOUNT_FLDS+1
      ENDDO
    ENDDO

  ENDIF

  DO JP=1,ICEND
    ZBUF_SL_DYN(DYN_SL%NSLCORE(JP+IOFF),INDEX_OROG)=POROG(JP+IOFF)
  ENDDO

ENDDO
!$OMP END DO
!$OMP END PARALLEL
CALL GSTATS(1065,1)

!*       2.2  GET HALO

ALLOCATE(ZPARITY(IFLDS_IN))

ZPARITY=+1.0_JPRB

ICOUNT_FLDS=INDEX_GMVT1
DO JFLDS=1,YT1%NDIM
  DO JLEV=1,NFLEVG
    IF(JFLDS==YT1%MU.OR.JFLDS==YT1%MV)THEN
      ZPARITY(ICOUNT_FLDS)=-1.0_JPRB
    ENDIF
    ICOUNT_FLDS=ICOUNT_FLDS+1
  ENDDO
ENDDO

DO JLEV=1,NFLEVG
  ZPARITY(INDEX_GMV_U+JLEV-1)=-1.0_JPRB
  ZPARITY(INDEX_GMV_V+JLEV-1)=-1.0_JPRB
ENDDO

IF(LSLPHY)THEN
  DO JLEV=1,NFLEVG
    ZPARITY(INDEX_PBUP9+JLEV-1)=-1.0_JPRB
    ZPARITY(INDEX_PBVP9+JLEV-1)=-1.0_JPRB
  ENDDO

  ICOUNT_FLDS=INDEX_PSAVTEND
  DO JLEV=1,2*NFLEVG
    ZPARITY(ICOUNT_FLDS)=-1.0_JPRB
    ICOUNT_FLDS=ICOUNT_FLDS+1
  ENDDO

ENDIF

CALL GSTATS(67,0)

IF(NPROC > 1)THEN

! Set up on-demand mask

  NFIXSFLD(1)=1
  NFIXSFLD(2)=0

  CALL SLEXTPOL(DYN_SL%NSLWIDEN,DYN_SL%NSLWIDES,&
   & DYN_SL%NASLB1,NDGSAG,NDGENG,NDGSAL,NDGENL,1,&
   & DYN_SL%NSLSTA,DYN_SL%NSLONL,DYN_SL%NSLOFF,&
   & NDGLG,NLOENG,NFRSTLOFF,MYFRSTACTLAT,MYLSTACTLAT,NFIXSFLD,3,&
   & ZPARITY,ZBUF_SL_DYN,KMASK2=IMASK_DYN)

  DO JKGLO=1,KGPTOT_PHYS,KPROMA_PHYS
    IOFF=JKGLO-1
    ICEND=MIN(KPROMA_PHYS,KGPTOT_PHYS-JKGLO+1)
    DO JP=1,ICEND
      DO JJ=1,YPHYPOI(JP+IOFF)%NEIGH
        IMASK_DYN(YPHYPOI(JP+IOFF)%NL0(JJ))=1
      ENDDO
    ENDDO
  ENDDO

  LLINC=.FALSE.

  CALL SLCOMM2(DYN_SL%NASLB1,DYN_SL%NSLPROCS,&
   & DYN_SL%NSLRPT,&
   & DYN_SL%NSLSPT,DYN_SL%NSLSENDPOS,DYN_SL%NSLRECVPOS,&
   & DYN_SL%NSLSENDPTR,DYN_SL%NSLRECVPTR,DYN_SL%NSLCOMM,&
   & NFIXSFLD,IMASK_DYN,IMASK_DYN,&
   & IFLDS_IN,LLINC,ZBUF_SL_DYN)

ENDIF

CALL SLEXTPOL(DYN_SL%NSLWIDEN,DYN_SL%NSLWIDES,&
 & DYN_SL%NASLB1,NDGSAG,NDGENG,NDGSAL,NDGENL,IFLDS_IN,&
 & DYN_SL%NSLSTA,DYN_SL%NSLONL,DYN_SL%NSLOFF,&
 & NDGLG,NLOENG,NFRSTLOFF,MYFRSTACTLAT,MYLSTACTLAT,IDUMARR,1,&
 & ZPARITY,ZBUF_SL_DYN)

DEALLOCATE(ZPARITY)
CALL GSTATS(67,1)

!*       2.3  DO AVERAGING  OR INTERPOLATION


CALL GSTATS(1001,0)
!$OMP PARALLEL PRIVATE(JP,JLEV,IBL,IOFF,ICEND, &
!$OMP& ICOUNT_FLDS,JKGLO,JFLDS,JJ,ZPB2,ZDYN_SAVE,&
!$OMP& ZGFLSLP,ZWMAX,IWMAX,PEMTD2,PTRSW2,PEMTC2,PTRSC2)

ALLOCATE(ZPB2(KPROMA_PHYS,IFLDS_IN))
ALLOCATE(ZDYN_SAVE(KPROMA_PHYS,YT1%NDIM*NFLEVG+YGFL%NDIM1*NFLEVG))
IF(LSLPHY) THEN
  ALLOCATE(ZGFLSLP(KPROMA_PHYS,NFLEVG,YGFL%NDIMSLP))
  ZGFLSLP=0.0_JPRB
ENDIF

  ! Double radiation
  IF (L2RAD) THEN
     ALLOCATE(PEMTD2(KPROMA,NFLEVG+1), PTRSW2(KPROMA,NFLEVG+1),&
          &   PEMTC2(KPROMA,NFLEVG+1), PTRSC2(KPROMA,NFLEVG+1))
  END IF
  
!$OMP DO SCHEDULE(DYNAMIC,1) 
DO JKGLO=1,PHYS_GRID%NGPTOT,KPROMA_PHYS
  IBL=(JKGLO-1)/KPROMA_PHYS+1
  IOFF=JKGLO-1
  ICEND=MIN(KPROMA_PHYS,PHYS_GRID%NGPTOT-JKGLO+1)

  DO JFLDS=1,IFLDS_IN
    IF(JFLDS >= INDEX_PSD_VF .AND. JFLDS < INDEX_PSD_VF+YSD_VFD%NDIM ) THEN
      DO JP=1,ICEND
        ZWMAX=0.0
        DO JJ=1,YPHYPOI(JP+IOFF)%NEIGH
          IF(YPHYPOI(JP+IOFF)%WGT(JJ) > ZWMAX)THEN
            ZWMAX=YPHYPOI(JP+IOFF)%WGT(JJ)
            IWMAX=JJ
          ENDIF
        ENDDO
        ZPB2(JP,JFLDS)=ZBUF_SL_DYN(YPHYPOI(JP+IOFF)%NL0(IWMAX),JFLDS)
      ENDDO
    ELSE
      DO JP=1,ICEND
        ZPB2(JP,JFLDS)=0.0_JPRB
        DO JJ=1,YPHYPOI(JP+IOFF)%NEIGH
          ZPB2(JP,JFLDS)=ZPB2(JP,JFLDS)+YPHYPOI(JP+IOFF)%WGT(JJ)* &
              & ZBUF_SL_DYN(YPHYPOI(JP+IOFF)%NL0(JJ),JFLDS)
        ENDDO
      ENDDO
    ENDIF
  ENDDO

! SAVE AVERAGED or interpolated DYNAMICS TENDENCIES


  IF(KSMAX /= KSMAX_PHYS)THEN
    ICOUNT_FLDS=INDEX_GMVT1
    DO JFLDS=1,YT1%NDIM
      DO JLEV=1,NFLEVG
        DO JP=1,ICEND
          ZDYN_SAVE(JP,ICOUNT_FLDS)=ZPB2(JP,ICOUNT_FLDS)
        ENDDO
        ICOUNT_FLDS=ICOUNT_FLDS+1
      ENDDO
    ENDDO

    ICOUNT_FLDS=INDEX_GFLT1
    DO JFLDS=1,YGFL%NDIM1
      DO JLEV=1,NFLEVG
        DO JP=1,ICEND
          ZDYN_SAVE(JP,ICOUNT_FLDS)=ZPB2(JP,ICOUNT_FLDS)
        ENDDO
        ICOUNT_FLDS=ICOUNT_FLDS+1
      ENDDO
    ENDDO
  ENDIF

  ! Double radiation
  ! Copy global variables to local ones. This because otherwise the arrays
  ! for EC_PHYS(G) and CALLPAR need to be allocated even in L2RAD=.F. case
  ! (the call to EC_PHYS with a slice of the array becomes a problem)
  !
  IF (L2RAD) THEN
     DO JLEV=1,NFLEVG+1
        PEMTD2(:,JLEV)=ZEMTD2(:,JLEV,IBL)
        PTRSW2(:,JLEV)=ZTRSW2(:,JLEV,IBL)
        PEMTC2(:,JLEV)=ZEMTC2(:,JLEV,IBL)
        PTRSC2(:,JLEV)=ZTRSC2(:,JLEV,IBL)
     END DO
  END IF
      
  CALL EC_PHYS(CDCONF,KPROMA_PHYS,KSMAX_PHYS,KGPLAT(IOFF+1),&
   & IBL,ICEND,JKGLO,&
   & ZPB2(1,INDEX_PB2),&
   & ZPB2(1,INDEX_GMV_U),ZPB2(1,INDEX_GMV_V),&
   & ZPB2(1,INDEX_GMV_T),ZPB2(1,INDEX_GMVS),&
   & ZPB2(1,INDEX_GMVT1),ZPB2(1,INDEX_GMVT1S),ZPB2(1,INDEX_GFLT1),&
   & ZPB2(1,INDEX_GFL),ZGFLSLP,&
   & ZPB2(1,INDEX_PSP_SB),ZPB2(1,INDEX_PSP_SG),ZPB2(1,INDEX_PSP_RR),&
   & ZPB2(1,INDEX_PSP_EP),ZPB2(1,INDEX_PSP_X2),&
   & ZPB2(1,INDEX_PSD_VF),ZPB2(1,INDEX_PSD_VN),ZPB2(1,INDEX_PSD_VD),&
   & ZPB2(1,INDEX_PSD_WS),ZPB2(1,INDEX_PSD_WW),&
   & ZPB2(1,INDEX_PSD_XA),ZPB2(1,INDEX_PSD_X2),&
   !--- KPP
   & ZPB2(1,INDEX_PSP_OM),ZPB2(1,INDEX_PSD_V2),ZPB2(1,INDEX_PSD_V3),& !KPP
   !--- KPP
   & ZPB2(1,INDEX_EMTD),ZPB2(1,INDEX_TRSW),ZPB2(1,INDEX_EMTC),ZPB2(1,INDEX_TRSC),&
   & ZPB2(1,INDEX_TAUAER),&
   & ZPB2(1,INDEX_SRSWD),ZPB2(1,INDEX_SRSWDCS),ZPB2(1,INDEX_EDRO),&
   & ZPB2(1,INDEX_SRSWPAR),ZPB2(1,INDEX_SRSWUVB),ZPB2(1,INDEX_SRSWPARC),ZPB2(1,INDEX_SRSWTINC),&
   & ZPB2(1,INDEX_SRFDIR) ,ZPB2(1,INDEX_SRCDIR) ,&
   & PGEMU(IOFF+1), & 
   & PGELAM(IOFF+1),PGELAT(IOFF+1),PGESLO(IOFF+1),PGECLO(IOFF+1),&
   & ZPB2(1,INDEX_OROG), PGNORDL(IOFF+1),PGNORDM(IOFF+1),&
   & PGSQM2(IOFF+1),PGAW(IOFF+1),&
! NOT DONE -----------------
   & PSTOPHU(IOFF+1),PSTOPHV(IOFF+1),&
   & PSTOPHT(IOFF+1),PSTOPHQ(IOFF+1),&
   & PSTOPHCA(IOFF+1),PCUCONVCA(IOFF+1),PNLCONVCA(IOFF+1),PCAPECONVCA(IOFF+1),&
   & ZPB2(1,INDEX_PBUP9),ZPB2(1,INDEX_PBVP9),&
   & ZPB2(1,INDEX_PBTP9),ZPB2(1,INDEX_PBGFLP9),&
   & PGP2DSDT(1,1,IBL), &
   & PSTREAM(1,1,IBL), PTEMP(1,1,IBL), PVELPOT(1,1,IBL), &
   & PTOTDISS(1,1,IBL), PTOTDISS_SMOOTH(1,1,IBL), &
   & PVORTGRAD(1,1,IBL),PVORTGRAD(1,NFLEVG+1,IBL),PVORTGRAD(1,2*NFLEVG+1,IBL), &
   & PFORCEU(1,1,IBL),PFORCEV(1,1,IBL),&
   & PFORCET(1,1,IBL),PFORCEQ(1,1,IBL),&
   & PEXTRADYN(1,1,1,IBL),ZPB2(1,INDEX_PSAVTEND),&
   & LDRAIN_LB, KHLPRDY, KT,&
   & PMWAVE_OBS_BUF,PMWAVE_ZEN_BUF,PMWAVE_AZI_BUF,PMWAVE_TB_BUF,PMWAVE_OERR_BUF,&
   & PMWAVE_PERS1_BUF,&
   & PMWAVE_DIAG_BUF,PMWAVE_P19_BUF,PMWAVE_P37_BUF,PMWAVE_GNORM_BUF,&
   & KMWAVE_BUF,&
   & PSMOS_OBS_BUF,PSMOS_TB_BUF,PSMOS_ANGLE,&
   & KSMOS_BUF,DPTENQ0,DPTENQ1,&
   & PEMTD2,PTRSW2,PEMTC2,PTRSC2)
  
  IF(KSMAX /= KSMAX_PHYS)THEN
    ICOUNT_FLDS=INDEX_GMVT1
    DO JFLDS=1,YT1%NDIM*NFLEVG
      DO JP=1,ICEND
        ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_GMVT1_OUT+JFLDS-1)= &
          &    ZPB2(JP,ICOUNT_FLDS)-ZDYN_SAVE(JP,ICOUNT_FLDS)
      ENDDO
      ICOUNT_FLDS=ICOUNT_FLDS+1
    ENDDO
  
    ICOUNT_FLDS=INDEX_GFLT1
    DO JFLDS=1,YGFL%NDIM1*NFLEVG
      DO JP=1,ICEND
        ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_GFLT1_OUT+JFLDS-1)= &
          &    ZPB2(JP,ICOUNT_FLDS)-ZDYN_SAVE(JP,ICOUNT_FLDS)
      ENDDO
      ICOUNT_FLDS=ICOUNT_FLDS+1
    ENDDO
  ELSE
    ICOUNT_FLDS=INDEX_GMVT1
    DO JFLDS=1,YT1%NDIM*NFLEVG
      DO JP=1,ICEND
        ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_GMVT1_OUT+JFLDS-1)= &
          &    ZPB2(JP,ICOUNT_FLDS)
      ENDDO
      ICOUNT_FLDS=ICOUNT_FLDS+1
    ENDDO
  
    ICOUNT_FLDS=INDEX_GFLT1
    DO JFLDS=1,YGFL%NDIM1*NFLEVG
      DO JP=1,ICEND
        ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_GFLT1_OUT+JFLDS-1)= &
          &    ZPB2(JP,ICOUNT_FLDS)
      ENDDO
      ICOUNT_FLDS=ICOUNT_FLDS+1
    ENDDO
  ENDIF

  DO JLEV=1,NFLEVG+1
    DO JP=1,ICEND
      ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_EMTD_OUT+JLEV-1)= &
        &   ZPB2(JP,INDEX_EMTD+JLEV-1)
      ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_TRSW_OUT+JLEV-1)= &
        &   ZPB2(JP,INDEX_TRSW+JLEV-1)
    ENDDO
  ENDDO

  DO II=1,6
    DO JLEV=1,NFLEVG
      DO JP=1,ICEND
        ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_TAUAER_OUT+JLEV-1+(II-1)*NFLEVG)= &
          &   ZPB2(JP,INDEX_TAUAER+JLEV-1+(II-1)*NFLEVG)
      ENDDO
    ENDDO
  ENDDO

  DO JP=1,ICEND
    ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_EDRO_OUT)= &
      &   ZPB2(JP,INDEX_EDRO)
  ENDDO

  DO JFLDS=1,YSP_SBD%NDIM*YSP_SBD%NLEVS
    DO JP=1,ICEND
      ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_PSP_SB_OUT+JFLDS-1)= &
      &   ZPB2(JP,INDEX_PSP_SB+JFLDS-1)
    ENDDO
  ENDDO
  DO JFLDS=1,YSP_EPD%NDIM*YSP_EPD%NLEVS
    DO JP=1,ICEND
      ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_PSP_EP_OUT+JFLDS-1)= &
      &   ZPB2(JP,INDEX_PSP_EP+JFLDS-1)
    ENDDO
  ENDDO
  DO JFLDS=1,YSD_XAD%NDIM*YSD_XAD%NLEVS
    DO JP=1,ICEND
      ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_PSD_XA_OUT+JFLDS-1)= &
        &   ZPB2(JP,INDEX_PSD_XA+JFLDS-1)
    ENDDO
  ENDDO
  DO JFLDS=1,YSP_SGD%NDIM
    DO JP=1,ICEND
      ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_PSP_SG_OUT+JFLDS-1)= &
        &   ZPB2(JP,INDEX_PSP_SG+JFLDS-1)
    ENDDO
  ENDDO
  DO JFLDS=1,YSP_RRD%NDIM
    DO JP=1,ICEND
      ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_PSP_RR_OUT+JFLDS-1)= &
        &   ZPB2(JP,INDEX_PSP_RR+JFLDS-1)
    ENDDO
  ENDDO
  DO JFLDS=1,YSP_X2D%NDIM
    DO JP=1,ICEND
      ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_PSP_X2_OUT+JFLDS-1)= &
        &   ZPB2(JP,INDEX_PSP_X2+JFLDS-1)
    ENDDO
  ENDDO
  DO JFLDS=1,YSD_VND%NDIM
    DO JP=1,ICEND
      ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_PSD_VN_OUT+JFLDS-1)= &
        &   ZPB2(JP,INDEX_PSD_VN+JFLDS-1)
    ENDDO
  ENDDO
  DO JFLDS=1,YSD_VDD%NDIM
    DO JP=1,ICEND
      ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_PSD_VD_OUT+JFLDS-1)= &
        &   ZPB2(JP,INDEX_PSD_VD+JFLDS-1)
    ENDDO
  ENDDO
  DO JFLDS=1,YSD_WSD%NDIM
    DO JP=1,ICEND
      ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_PSD_WS_OUT+JFLDS-1)= &
        &   ZPB2(JP,INDEX_PSD_WS+JFLDS-1)
    ENDDO
  ENDDO
  DO JFLDS=1,YSD_WWD%NDIM
    DO JP=1,ICEND
      ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_PSD_WW_OUT+JFLDS-1)= &
        &   ZPB2(JP,INDEX_PSD_WW+JFLDS-1)
    ENDDO
  ENDDO
  DO JFLDS=1,YSD_X2D%NDIM
    DO JP=1,ICEND
      ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_PSD_X2_OUT+JFLDS-1)= &
        &   ZPB2(JP,INDEX_PSD_X2+JFLDS-1)
    ENDDO
  ENDDO

!--- KPP
  DO JFLDS=1,YSP_OMD%NDIM*YSP_OMD%NLEVS
    DO JP=1,ICEND
      ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_PSP_OM_OUT+JFLDS-1)= &
      &   ZPB2(JP,INDEX_PSP_OM+JFLDS-1)
    ENDDO
  ENDDO

  DO JFLDS=1,YSD_V2D%NDIM
    DO JP=1,ICEND
      ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_PSD_V2_OUT+JFLDS-1)= &
        &   ZPB2(JP,INDEX_PSD_V2+JFLDS-1)
    ENDDO
  ENDDO

  DO JFLDS=1,YSD_V3D%NDIM*YSD_V3D%NLEVS
    DO JP=1,ICEND
      ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_PSD_V3_OUT+JFLDS-1)= &
      &   ZPB2(JP,INDEX_PSD_V3+JFLDS-1)
    ENDDO
  ENDDO
!--- KPP

  IF(LSLPHY) THEN
    DO JFLDS=1,NVTEND*NFLEVG
      DO JP=1,ICEND
        ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),INDEX_PSAVTEND_OUT+JFLDS-1)= &
          &    ZPB2(JP,INDEX_PSAVTEND+JFLDS-1)
      ENDDO
    ENDDO
    ICOUNT_FLDS=INDEX_GFLSLP_OUT
    DO JFLDS=1,YGFL%NDIMSLP
      DO JLEV=1,NFLEVG
        DO JP=1,ICEND
          ZBUF_SL_PHYS(PHYS_SL%NSLCORE(JP+IOFF),ICOUNT_FLDS)= &
            &    ZGFLSLP(JP,JLEV,JFLDS)
        ENDDO
        ICOUNT_FLDS=ICOUNT_FLDS+1
      ENDDO
    ENDDO
  ENDIF
ENDDO

!$OMP END DO
DEALLOCATE(ZPB2)
DEALLOCATE(ZDYN_SAVE)
IF(LSLPHY)DEALLOCATE(ZGFLSLP)

  ! Double radiation
  IF (L2RAD) THEN
     DEALLOCATE(PEMTD2, PTRSW2,&
          &     PEMTC2, PTRSC2)
  END IF
  
!$OMP END PARALLEL
CALL GSTATS(1001,1)


!*       3.   INTERPOLATION OF PHYSICS FIELDS IF PHYS_GRID%NSMAX < NSMAX
!             ------------- -- ------- ------ -- ---------------   -----
!             Otherwise averaging to the dynamics grid
!             --------- --------- -- --- -------- ----

!*       3.2  GET HALO

ALLOCATE(ZPARITY(IFLDS_OUT))

ZPARITY=+1.0_JPRB

ICOUNT_FLDS=INDEX_GMVT1_OUT
DO JFLDS=1,YT1%NDIM
  DO JLEV=1,NFLEVG
    IF(JFLDS==YT1%MU.OR.JFLDS==YT1%MV)THEN
      ZPARITY(ICOUNT_FLDS)=-1.0_JPRB
    ENDIF
    ICOUNT_FLDS=ICOUNT_FLDS+1
  ENDDO
ENDDO

IF(LSLPHY)THEN
  ICOUNT_FLDS=INDEX_PSAVTEND_OUT
  DO JLEV=1,2*NFLEVG
    ZPARITY(ICOUNT_FLDS)=-1.0_JPRB
    ICOUNT_FLDS=ICOUNT_FLDS+1
  ENDDO
ENDIF

CALL GSTATS(68,0)

IF(NPROC > 1)THEN

! Set up on-demand mask

  NFIXSFLD(1)=1
  NFIXSFLD(2)=0
  CALL SLEXTPOL(PHYS_SL%NSLWIDEN,PHYS_SL%NSLWIDES,&
   & PHYS_SL%NASLB1,PHYS_GRID%NDGSAG,PHYS_GRID%NDGENG,&
   & PHYS_GRID%NDGSAL,PHYS_GRID%NDGENL,1,&
   & PHYS_SL%NSLSTA,PHYS_SL%NSLONL,PHYS_SL%NSLOFF,&
   & PHYS_GRID%NDGLG,PHYS_GRID%NLOENG,PHYS_GRID%NFRSTLOFF,&
   & PHYS_GRID%MYFRSTACTLAT,PHYS_GRID%MYLSTACTLAT,NFIXSFLD,3,&
   & ZPARITY,ZBUF_SL_PHYS,KMASK2=IMASK_PHYS)

  DO JKGLO=1,NGPTOT,KPROMA
    IOFF=JKGLO-1
    ICEND=MIN(KPROMA,NGPTOT-JKGLO+1)
    DO JP=1,ICEND
      DO JJ=1,YDYNPOI(JP+IOFF)%NEIGH
        IMASK_PHYS(YDYNPOI(JP+IOFF)%NL0(JJ))=1
      ENDDO
    ENDDO
  ENDDO

  LLINC=.FALSE.

  CALL SLCOMM2(PHYS_SL%NASLB1,PHYS_SL%NSLPROCS,&
   & PHYS_SL%NSLRPT,&
   & PHYS_SL%NSLSPT,PHYS_SL%NSLSENDPOS,PHYS_SL%NSLRECVPOS,&
   & PHYS_SL%NSLSENDPTR,PHYS_SL%NSLRECVPTR,PHYS_SL%NSLCOMM,&
   & NFIXSFLD,IMASK_PHYS,IMASK_PHYS,&
   & IFLDS_OUT,LLINC,ZBUF_SL_PHYS)

ENDIF

CALL SLEXTPOL(PHYS_SL%NSLWIDEN,PHYS_SL%NSLWIDES,&
 & PHYS_SL%NASLB1,PHYS_GRID%NDGSAG,PHYS_GRID%NDGENG,&
 & PHYS_GRID%NDGSAL,PHYS_GRID%NDGENL,IFLDS_OUT,&
 & PHYS_SL%NSLSTA,PHYS_SL%NSLONL,PHYS_SL%NSLOFF,&
 & PHYS_GRID%NDGLG,PHYS_GRID%NLOENG,PHYS_GRID%NFRSTLOFF,&
 & PHYS_GRID%MYFRSTACTLAT,PHYS_GRID%MYLSTACTLAT,IDUMARR,1,&
 & ZPARITY,ZBUF_SL_PHYS)

DEALLOCATE(ZPARITY)
CALL GSTATS(68,1)

!*       3.3  DO INTERPOLATION


CALL GSTATS(1066,0)
!$OMP PARALLEL PRIVATE(JP,JFLDS,JJ,IBL,IOFF,ICEND,JKGLO,JLEV,ZPB2,&
!$OMP& ICOUNT_FLDS,ZWMAX,IWMAX)

ALLOCATE(ZPB2(KPROMA,IFLDS_OUT))

!$OMP DO SCHEDULE(DYNAMIC,1) 
DO JKGLO=1,NGPTOT,KPROMA
  IBL=(JKGLO-1)/KPROMA+1
  IOFF=JKGLO-1
  ICEND=MIN(KPROMA,NGPTOT-JKGLO+1)
  DO JFLDS=1,IFLDS_OUT
    DO JP=1,ICEND
      ZPB2(JP,JFLDS)=0.0_JPRB
      DO JJ=1,YDYNPOI(JP+IOFF)%NEIGH
        ZPB2(JP,JFLDS)=ZPB2(JP,JFLDS)+YDYNPOI(JP+IOFF)%WGT(JJ)* &
                        &  ZBUF_SL_PHYS(YDYNPOI(JP+IOFF)%NL0(JJ),JFLDS)
      ENDDO
    ENDDO
  ENDDO


  IF(KSMAX /= KSMAX_PHYS)THEN
    ICOUNT_FLDS=INDEX_GMVT1_OUT
    DO JFLDS=1,YT1%NDIM
      DO JLEV=1,NFLEVG
        DO JP=1,ICEND
         PGMVT1(JP,JLEV,JFLDS,IBL)=ZPB2(JP,ICOUNT_FLDS)+PGMVT1(JP,JLEV,JFLDS,IBL)
        ENDDO
        ICOUNT_FLDS=ICOUNT_FLDS+1
      ENDDO
    ENDDO
  
    ICOUNT_FLDS=INDEX_GFLT1_OUT
    DO JFLDS=1,YGFL%NDIM1
      DO JLEV=1,NFLEVG
        DO JP=1,ICEND
          PGFLT1(JP,JLEV,JFLDS,IBL)=ZPB2(JP,ICOUNT_FLDS)+PGFLT1(JP,JLEV,JFLDS,IBL)
        ENDDO
        ICOUNT_FLDS=ICOUNT_FLDS+1
      ENDDO
    ENDDO
  ELSE
    ICOUNT_FLDS=INDEX_GMVT1_OUT
    DO JFLDS=1,YT1%NDIM
      DO JLEV=1,NFLEVG
        DO JP=1,ICEND
         PGMVT1(JP,JLEV,JFLDS,IBL)=ZPB2(JP,ICOUNT_FLDS)
        ENDDO
        ICOUNT_FLDS=ICOUNT_FLDS+1
      ENDDO
    ENDDO
  
    ICOUNT_FLDS=INDEX_GFLT1_OUT
    DO JFLDS=1,YGFL%NDIM1
      DO JLEV=1,NFLEVG
        DO JP=1,ICEND
          PGFLT1(JP,JLEV,JFLDS,IBL)=ZPB2(JP,ICOUNT_FLDS)
        ENDDO
        ICOUNT_FLDS=ICOUNT_FLDS+1
      ENDDO
    ENDDO
  ENDIF


  DO JLEV=1,NFLEVG+1
    DO JP=1,ICEND
      PEMTD(JP,JLEV,IBL)=ZPB2(JP,INDEX_EMTD_OUT+JLEV-1)
      PTRSW(JP,JLEV,IBL)=ZPB2(JP,INDEX_TRSW_OUT+JLEV-1)
    ENDDO
  ENDDO

  DO II=1,6
    DO JLEV=1,NFLEVG
      DO JP=1,ICEND
        PTAUAER(JP,JLEV,II,IBL)=ZPB2(JP,INDEX_TAUAER_OUT+JLEV-1+(II-1)*NFLEVG)
      ENDDO
    ENDDO
  ENDDO

  DO JP=1,ICEND
    PEDRO(JP,IBL)=ZPB2(JP,INDEX_EDRO_OUT)
  ENDDO

  ICOUNT_FLDS=INDEX_PSP_SB_OUT
  DO JFLDS=1,YSP_SBD%NDIM
    DO JLEV=1,YSP_SBD%NLEVS
      DO JP=1,ICEND
        PSP_SB(JP,JLEV,JFLDS,IBL)=ZPB2(JP,ICOUNT_FLDS)
      ENDDO
      ICOUNT_FLDS=ICOUNT_FLDS+1
    ENDDO
  ENDDO
  ICOUNT_FLDS=INDEX_PSP_EP_OUT
  DO JFLDS=1,YSP_EPD%NDIM
    DO JLEV=1,YSP_EPD%NLEVS
      DO JP=1,ICEND
        PSP_EP(JP,JLEV,JFLDS,IBL)=ZPB2(JP,ICOUNT_FLDS)
      ENDDO
      ICOUNT_FLDS=ICOUNT_FLDS+1
    ENDDO
  ENDDO
  ICOUNT_FLDS=INDEX_PSD_XA_OUT
  DO JFLDS=1,YSD_XAD%NDIM
    DO JLEV=1,YSD_XAD%NLEVS
      DO JP=1,ICEND
        PSD_XA(JP,JLEV,JFLDS,IBL)=ZPB2(JP,ICOUNT_FLDS)
      ENDDO
      ICOUNT_FLDS=ICOUNT_FLDS+1
    ENDDO
  ENDDO
  DO JFLDS=1,YSP_SGD%NDIM
    DO JP=1,ICEND
      PSP_SG(JP,JFLDS,IBL)=ZPB2(JP,INDEX_PSP_SG_OUT+JFLDS-1)
    ENDDO
  ENDDO
  DO JFLDS=1,YSP_RRD%NDIM
    DO JP=1,ICEND
      PSP_RR(JP,JFLDS,IBL)=ZPB2(JP,INDEX_PSP_RR_OUT+JFLDS-1)
    ENDDO
  ENDDO
  DO JFLDS=1,YSP_X2D%NDIM
    DO JP=1,ICEND
      PSP_X2(JP,JFLDS,IBL)=ZPB2(JP,INDEX_PSP_X2_OUT+JFLDS-1)
    ENDDO
  ENDDO
  DO JFLDS=1,YSD_VND%NDIM
    DO JP=1,ICEND
      PSD_VN(JP,JFLDS,IBL)=ZPB2(JP,INDEX_PSD_VN_OUT+JFLDS-1)
    ENDDO
  ENDDO
  DO JFLDS=1,YSD_VDD%NDIM
    DO JP=1,ICEND
      PSD_VD(JP,JFLDS,IBL)=ZPB2(JP,INDEX_PSD_VD_OUT+JFLDS-1)
    ENDDO
  ENDDO

  IF(LWCOU)THEN
    DO JFLDS=1,YSD_WSD%NDIM
      DO JP=1,ICEND
        PSD_WS(JP,JFLDS,IBL)=ZPB2(JP,INDEX_PSD_WS_OUT+JFLDS-1)
      ENDDO
    ENDDO
  ENDIF

  IF(LWCOU)THEN
    DO JFLDS=1,YSD_WWD%NDIM
      DO JP=1,ICEND
        PSD_WW(JP,JFLDS,IBL)=ZPB2(JP,INDEX_PSD_WW_OUT+JFLDS-1)
      ENDDO
    ENDDO
  ENDIF

  DO JFLDS=1,YSD_X2D%NDIM
    DO JP=1,ICEND
      PSD_X2(JP,JFLDS,IBL)=ZPB2(JP,INDEX_PSD_X2_OUT+JFLDS-1)
    ENDDO
  ENDDO

  !--- KPP
  ICOUNT_FLDS=INDEX_PSP_OM_OUT
  DO JFLDS=1,YSP_OMD%NDIM
    DO JLEV=1,YSP_OMD%NLEVS
      DO JP=1,ICEND
        PSP_OM(JP,JLEV,JFLDS,IBL)=ZPB2(JP,ICOUNT_FLDS)
      ENDDO
      ICOUNT_FLDS=ICOUNT_FLDS+1
    ENDDO
  ENDDO

  DO JFLDS=1,YSD_V2D%NDIM
    DO JP=1,ICEND
      PSD_V2(JP,JFLDS,IBL)=ZPB2(JP,INDEX_PSD_V2_OUT+JFLDS-1)
    ENDDO
  ENDDO

  ICOUNT_FLDS=INDEX_PSD_V3_OUT
  DO JFLDS=1,YSD_V3D%NDIM
    DO JLEV=1,YSD_V3D%NLEVS
      DO JP=1,ICEND
        PSD_V3(JP,JLEV,JFLDS,IBL)=ZPB2(JP,ICOUNT_FLDS)
      ENDDO
      ICOUNT_FLDS=ICOUNT_FLDS+1
    ENDDO
  ENDDO
  !--- KPP

  IF(LSLPHY) THEN
    ICOUNT_FLDS=INDEX_PSAVTEND_OUT
    DO JFLDS=1,NVTEND
      DO JLEV=1,NFLEVG
        DO JP=1,ICEND
          PSAVTEND(JP,JLEV,JFLDS,IBL)=ZPB2(JP,ICOUNT_FLDS)
        ENDDO
        ICOUNT_FLDS=ICOUNT_FLDS+1
      ENDDO
    ENDDO

    ICOUNT_FLDS=INDEX_GFLSLP_OUT
    DO JFLDS=1,YGFL%NDIMSLP
      DO JLEV=1,NFLEVG
        DO JP=1,ICEND
          PGFLSLP(JP,JLEV,JFLDS,IBL)=ZPB2(JP,ICOUNT_FLDS)
        ENDDO
        ICOUNT_FLDS=ICOUNT_FLDS+1
      ENDDO
    ENDDO
  ENDIF

ENDDO
!$OMP END DO
DEALLOCATE(ZPB2)
!$OMP END PARALLEL
CALL GSTATS(1066,1)

DEALLOCATE(ZBUF_SL_DYN)
DEALLOCATE(ZBUF_SL_PHYS)
DEALLOCATE(IMASK_DYN)
DEALLOCATE(IMASK_PHYS)

!     ------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('EC_PHYSG',1,ZHOOK_HANDLE)
END SUBROUTINE EC_PHYSG
