SUBROUTINE ECRADFR

!**** *ECRADFR*   - MODIFY FREQUENCY OF FULL-RADIATION COMPUTATIONS

!     PURPOSE.
!     --------

!**   INTERFACE.
!     ----------
!        CALL *ECRADFR* FROM *CNT4*
!              -------        ----

!        EXPLICIT ARGUMENTS :
!        --------------------
!        NONE

!        IMPLICIT ARGUMENTS :
!        --------------------
!        COMMONS YOMDIM, YOMCT3, YOERAD

!     METHOD.
!     -------
!        SEE DOCUMENTATION

!     EXTERNALS.
!     ----------
!        NONE

!     REFERENCE.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     AUTHOR.
!     -------
!        JEAN-JACQUES MORCRETTE  *ECMWF*

!     MODIFICATIONS.
!     --------------
!        ORIGINAL : 92-11-25
!        010129 JJMorcrette clean-up LERAD1H, NLNGR1H
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMDIM   , ONLY : NSMAX
USE YOMCT3   , ONLY : NSTEP
USE YOERAD   , ONLY : NRADFR   ,NRADNFR  ,NRADSFR  ,LERAD1H, NLNGR1H
USE YOE_UVRAD, ONLY : NRADUV
USE YOMDYN   , ONLY : TSTEP

IMPLICIT NONE

!      ----------------------------------------------------------------

REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "updtier.intfb.h"
IF (LHOOK) CALL DR_HOOK('ECRADFR',0,ZHOOK_HANDLE)
IF (NSMAX >= 63 .AND. LERAD1H) THEN
  IF (NSTEP*TSTEP < NLNGR1H *3600._JPRB) THEN
    NRADFR=NRADSFR
    NRADUV=NRADSFR
  ELSE
    NRADFR=NRADNFR
    NRADUV=NRADNFR
  ENDIF
ENDIF

CALL UPDTIER ( NSTEP,NRADFR,TSTEP )

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('ECRADFR',1,ZHOOK_HANDLE)
END SUBROUTINE ECRADFR
