SUBROUTINE GEMS_INIT_AD( KIDIA, KFDIA, KLEV, KLON, KTRAC, &
   &  PTENGFL, PCEN, PTENC, PCFLX )

!**   INTERFACE.
!     ----------
!          *GEMS_INIT_AD* IS CALLED FROM *CALLPAR/TL/AD*.

! INPUTS:
!  -------

! INPUTS/OUTPUTS:
!---------------

!-----------------------------------------------------------------------

!     Externals.
!     ---------


!     Author
!    --------
!         2008-10-15, R. Engelen 

!     Modifications :
!    ----------------

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOM_YGFL , ONLY : NAERO, NGHG, NGRG, YGRG, &
 & YGHG, YAERO, YGFL

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KIDIA
INTEGER(KIND=JPIM),INTENT(IN)    :: KFDIA
INTEGER(KIND=JPIM),INTENT(IN)    :: KLEV 
INTEGER(KIND=JPIM),INTENT(IN)    :: KLON 
REAL(KIND=JPRB), INTENT(INOUT)   :: PTENGFL(KLON,KLEV,YGFL%NDIM1)

! In the declaration below the INTENT attribute has been removed to comply 
! strict f95 standards. The attribute INTENT(INOUT) should be put back after all 
! compiler (especially NEC) support this extension. - R. El Khatib 04-Jun-2009
REAL(KIND=JPRB), POINTER :: PCEN(:,:,:),PTENC(:,:,:),PCFLX(:,:)

INTEGER(KIND=JPIM), INTENT(IN) :: KTRAC
INTEGER(KIND=JPIM) :: ITRC
INTEGER(KIND=JPIM) :: JEXT

REAL(KIND=JPRB) :: ZHOOK_HANDLE


!-----------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('GEMS_INIT_AD',0,ZHOOK_HANDLE)

ALLOCATE( PCEN(KLON,KLEV,KTRAC) )
ALLOCATE( PTENC(KLON,KLEV,KTRAC) )
ALLOCATE( PCFLX(KLON,KTRAC) )
PCFLX(KIDIA:KFDIA,1:KTRAC)=0.0_JPRB
PCEN (KIDIA:KFDIA,1:KLEV,1:KTRAC)=0.0_JPRB
PTENC(KIDIA:KFDIA,1:KLEV,1:KTRAC)=0.0_JPRB


ITRC=0
DO JEXT=1,NGHG
  ITRC=ITRC+1
  PTENC(KIDIA:KFDIA,1:KLEV,ITRC)=PTENC(KIDIA:KFDIA,1:KLEV,ITRC)+ &
  &    PTENGFL(KIDIA:KFDIA,1:KLEV,YGHG(JEXT)%MP1)
  PTENGFL(KIDIA:KFDIA,1:KLEV,YGHG(JEXT)%MP1)=0.0_JPRB
ENDDO
DO JEXT=1,NGRG
  ITRC=ITRC+1
  PTENC(KIDIA:KFDIA,1:KLEV,ITRC)=PTENC(KIDIA:KFDIA,1:KLEV,ITRC)+PTENGFL(KIDIA:KFDIA,1:KLEV,YGRG(JEXT)%MP1)
  PTENGFL(KIDIA:KFDIA,1:KLEV,YGRG(JEXT)%MP1)=0.0_JPRB
ENDDO
DO JEXT=1,NAERO
  ITRC=ITRC+1
  PTENC(KIDIA:KFDIA,1:KLEV,ITRC) =PTENC(KIDIA:KFDIA,1:KLEV,ITRC)+PTENGFL (KIDIA:KFDIA,1:KLEV,YAERO(JEXT)%MP1)
  PTENGFL (KIDIA:KFDIA,1:KLEV,YAERO(JEXT)%MP1)=0.0_JPRB
ENDDO

!-----------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('GEMS_INIT_AD',1,ZHOOK_HANDLE)
END SUBROUTINE GEMS_INIT_AD
