SUBROUTINE GEMS_TEND_AD( KIDIA, KFDIA, KLEV, KLON, &
   &  PLRCH4, PGFL, PTENGFL, PCEN, PTENC )

!**   INTERFACE.
!     ----------
!          *GEMS_TEND_AD* IS CALLED FROM *CALLPAR*.

! INPUTS:
!  -------

! INPUTS/OUTPUTS:
!---------------

!-----------------------------------------------------------------------

!     Externals.
!     ---------


!     Author
!    --------
!         2008-10-15, R. Engelen 

!     Modifications :
!    ----------------

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOM_YGFL , ONLY : NAERO, NGRG, &
 & YGHG, NGHG, YGFL, YGRG, YAERO
USE YOMGRB, ONLY : NGRBGHG
USE YOMPHY2  , ONLY : TSPHY

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KIDIA
INTEGER(KIND=JPIM),INTENT(IN)    :: KFDIA
INTEGER(KIND=JPIM),INTENT(IN)    :: KLEV 
INTEGER(KIND=JPIM),INTENT(IN)    :: KLON 
REAL(KIND=JPRB), INTENT(INOUT)   :: PGFL(KLON,KLEV,YGFL%NDIM), PTENGFL(KLON,KLEV,YGFL%NDIM1)

! In the declaration below the INTENT attribute has been removed to comply 
! strict f95 standards. The attribute INTENT(INOUT) should be put back after all 
! compiler (especially NEC) support this extension. - R. El Khatib 04-Jun-2009
REAL(KIND=JPRB), POINTER :: PCEN(:,:,:),PTENC(:,:,:)

REAL(KIND=JPRB), INTENT(IN) :: PLRCH4(KLON,KLEV)
INTEGER(KIND=JPIM) :: ITRC
INTEGER(KIND=JPIM) :: JEXT

REAL(KIND=JPRB) :: ZHOOK_HANDLE


!-----------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('GEMS_TEND_AD',0,ZHOOK_HANDLE)

ITRC=0
DO JEXT=1,NGHG
  IF(YGHG(JEXT)%IGRBCODE == NGRBGHG(2)) THEN
    ITRC=ITRC+1
    PTENGFL(KIDIA:KFDIA,1:KLEV,YGHG(JEXT)%MP1)=PTENGFL(KIDIA:KFDIA,1:KLEV,YGHG(JEXT)%MP1)+PTENC(KIDIA:KFDIA,1:KLEV,ITRC)
    PGFL   (KIDIA:KFDIA,1:KLEV,YGHG(JEXT)%MP1)=PGFL   (KIDIA:KFDIA,1:KLEV,YGHG(JEXT)%MP1)- &
    &       PTENC(KIDIA:KFDIA,1:KLEV,ITRC)*PLRCH4(KIDIA:KFDIA,1:KLEV)
    PTENC  (KIDIA:KFDIA,1:KLEV,ITRC)=0.0_JPRB
    PGFL   (KIDIA:KFDIA,1:KLEV,YGHG(JEXT)%MP9_PH)=PGFL(KIDIA:KFDIA,1:KLEV,YGHG(JEXT)%MP9_PH)+ &
    &       PCEN(KIDIA:KFDIA,1:KLEV,ITRC)-PLRCH4(KIDIA:KFDIA,1:KLEV)*PCEN(KIDIA:KFDIA,1:KLEV,ITRC)*TSPHY
    PCEN   (KIDIA:KFDIA,1:KLEV,ITRC)=0.0_JPRB
  ELSE
    ITRC=ITRC+1
    PTENGFL(KIDIA:KFDIA,1:KLEV,YGHG(JEXT)%MP1)=PTENGFL(KIDIA:KFDIA,1:KLEV,YGHG(JEXT)%MP1)+PTENC(KIDIA:KFDIA,1:KLEV,ITRC)
    PTENC(KIDIA:KFDIA,1:KLEV,ITRC)=0.0_JPRB
    PGFL(KIDIA:KFDIA,1:KLEV,YGHG(JEXT)%MP9_PH)=PGFL(KIDIA:KFDIA,1:KLEV,YGHG(JEXT)%MP9_PH)+PCEN(KIDIA:KFDIA,1:KLEV,ITRC)
    PCEN(KIDIA:KFDIA,1:KLEV,ITRC)=0.0_JPRB
  ENDIF
ENDDO
DO JEXT=1,NGRG
  ITRC=ITRC+1
  PTENGFL(KIDIA:KFDIA,1:KLEV,YGRG(JEXT)%MP1)=PTENGFL(KIDIA:KFDIA,1:KLEV,YGRG(JEXT)%MP1)+PTENC(KIDIA:KFDIA,1:KLEV,ITRC)
  PTENC(KIDIA:KFDIA,1:KLEV,ITRC)=0.0_JPRB
  PGFL(KIDIA:KFDIA,1:KLEV,YGRG(JEXT)%MP9_PH)=PGFL(KIDIA:KFDIA,1:KLEV,YGRG(JEXT)%MP9_PH)+PCEN(KIDIA:KFDIA,1:KLEV,ITRC)
  PCEN(KIDIA:KFDIA,1:KLEV,ITRC)=0.0_JPRB
ENDDO
DO JEXT=1,NAERO
  ITRC=ITRC+1
  PTENGFL(KIDIA:KFDIA,1:KLEV,YAERO(JEXT)%MP1)=PTENGFL(KIDIA:KFDIA,1:KLEV,YAERO(JEXT)%MP1)+PTENC(KIDIA:KFDIA,1:KLEV,ITRC)
  PTENC(KIDIA:KFDIA,1:KLEV,ITRC)=0.0_JPRB
  PGFL(KIDIA:KFDIA,1:KLEV,YAERO(JEXT)%MP9_PH)=PGFL(KIDIA:KFDIA,1:KLEV,YAERO(JEXT)%MP9_PH)+PCEN(KIDIA:KFDIA,1:KLEV,ITRC)
  PCEN(KIDIA:KFDIA,1:KLEV,ITRC)=0.0_JPRB
ENDDO


!-----------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('GEMS_TEND_AD',1,ZHOOK_HANDLE)
END SUBROUTINE GEMS_TEND_AD
