SUBROUTINE PHYS_AD (KLEV, KLON, &       
                 &  PT5               , & 
                 &  PQ5               , &
                 &  PP5               , &
                 &  PPH5              , &
                 &  PTENT5            , &
                 &  PTENQ5            , & 
                 &  PDIFTS5           , &
                 &  PDIFTQ5           , &
                 &  PSTRTU5           , &
                 &  PSTRTV5           , &
                 &  PRAIN3D5          , &
                 &  PSNOW3D5          , &
                 &  PDQL5             , &
                 &  PDQI5             , & 
                 &  PDCC5             , &
                 &  PFLS5             , &
                 &  PFLC5             , &
                 &  PT                , &
                 &  PQ                , &
                 &  PP                , &
                 &  PPH               , &
                 &  PTENT             , &
                 &  PTENQ             , &
                 &  PDIFTS            , &
                 &  PDIFTQ            , &
                 &  PSTRTU            , &
                 &  PSTRTV            , &
                 &  PRAIN3D           , &
                 &  PSNOW3D           , &
                 &  PDQL              , &
                 &  PDQI              , &
                 &  PDCC              , &
                 &  PFLS              , &
                 &  PFLC)
   
!* AD of physics part of the observation operator: Mass-flux convection & large scale precip: 
!*     Original (06/11/97) : J.-F. MAHFOUF
!*     Modified (06/03/98) : New physical parameterisations, P. LOPEZ
!*     Modified (31/03/04) : New Interface w/ 1D-Var TB-Obs. operator, clean-up. P.BAUER
!*     Modified (01/10/08) : LLRAIN1D name change to reflect usage. AGEER

USE PARKIND1, ONLY: JPIM, JPRB
USE YOMHOOK , ONLY: LHOOK,   DR_HOOK
USE YOMDYN  , ONLY: TSTEP

IMPLICIT NONE

INTEGER (KIND=JPIM), INTENT   ( IN)                          :: KLEV, KLON
REAL    (KIND=JPRB), INTENT   ( IN), DIMENSION (KLON,KLEV+1) :: PPH5
REAL    (KIND=JPRB), INTENT   ( IN), DIMENSION (KLON,KLEV)   :: PP5, PT5, PQ5
REAL    (KIND=JPRB), INTENT (INOUT), DIMENSION (KLON,KLEV)   :: PTENQ5, PTENT5
REAL    (KIND=JPRB), INTENT   ( IN), DIMENSION (KLON)        :: PDIFTS5, PDIFTQ5, PSTRTU5, PSTRTV5
REAL    (KIND=JPRB), INTENT (INOUT), DIMENSION (KLON,KLEV)   :: PRAIN3D5, PSNOW3D5
REAL    (KIND=JPRB), INTENT (INOUT), DIMENSION (KLON,KLEV)   :: PDQL5, PDQI5, PDCC5
REAL    (KIND=JPRB), INTENT (INOUT), DIMENSION (KLON)        :: PFLS5, PFLC5
REAL    (KIND=JPRB), INTENT (INOUT), DIMENSION (KLON,KLEV+1) :: PPH
REAL    (KIND=JPRB), INTENT (INOUT), DIMENSION (KLON,KLEV)   :: PP, PT, PQ, PTENQ, PTENT
REAL    (KIND=JPRB), INTENT (INOUT), DIMENSION (KLON)        :: PDIFTS, PDIFTQ, PSTRTU, PSTRTV
REAL    (KIND=JPRB), INTENT (INOUT), DIMENSION (KLON,KLEV)   :: PRAIN3D, PSNOW3D
REAL    (KIND=JPRB), INTENT (INOUT), DIMENSION (KLON,KLEV)   :: PDQL, PDQI, PDCC
REAL    (KIND=JPRB), INTENT (INOUT), DIMENSION (KLON)        :: PFLS, PFLC

!* Local 
REAL (KIND=JPRB), DIMENSION (KLON,KLEV)   :: ZU5, ZV5, ZW5, ZTENU5, ZTENV5, ZQSAT5, ZCAPE5
REAL (KIND=JPRB), DIMENSION (KLON,KLEV)   :: ZGEOM15, ZMFUDE_RATE5, ZMFDDE_RATE5
REAL (KIND=JPRB), DIMENSION (KLON,KLEV)   :: ZLU5, ZLUDE5, ZMFU5, ZMFD5 
REAL (KIND=JPRB), DIMENSION (KLON,KLEV+1) :: ZGEOMH5, ZFPLCL5, ZFPLCN5, ZFHPCL5, ZFHPCN5 
REAL (KIND=JPRB), DIMENSION (KLON,KLEV+1) :: ZFHPSL5, ZFHPSN5, ZFPLSL5, ZFPLSN5
REAL (KIND=JPRB), DIMENSION (KLON,KLEV+1) :: ZDIFTQ5, ZDIFTS5, ZDIFCQ5, ZDIFCS5
REAL (KIND=JPRB), DIMENSION (KLON,KLEV+1) :: ZSTRCU5, ZSTRCV5, ZFCCQL5, ZFCCQN5
REAL (KIND=JPRB), DIMENSION (KLON,KLEV)   :: ZCOVPTOT5

REAL (KIND=JPRB), DIMENSION (KLON,KLEV)   :: ZU , ZV , ZW , ZTENU , ZTENV , ZQSAT 
REAL (KIND=JPRB), DIMENSION (KLON,KLEV)   :: ZGEOM1
REAL (KIND=JPRB), DIMENSION (KLON,KLEV)   :: ZLU , ZLUDE , ZMFU , ZMFD  
REAL (KIND=JPRB), DIMENSION (KLON,KLEV+1) :: ZGEOMH , ZFPLCL , ZFPLCN , ZFHPCL , ZFHPCN  
REAL (KIND=JPRB), DIMENSION (KLON,KLEV+1) :: ZFHPSL , ZFHPSN , ZFPLSL , ZFPLSN 
REAL (KIND=JPRB), DIMENSION (KLON,KLEV+1) :: ZDIFTQ , ZDIFTS , ZDIFCQ , ZDIFCS 
REAL (KIND=JPRB), DIMENSION (KLON,KLEV+1) :: ZSTRCU , ZSTRCV , ZFCCQL , ZFCCQN 
REAL (KIND=JPRB), DIMENSION (KLON,KLEV)   :: ZCOVPTOT

REAL (KIND=JPRB), DIMENSION (KLON)        :: ZARPRC5
REAL (KIND=JPRB), DIMENSION (KLON)        :: ZARPRC

REAL (KIND=JPRB) :: ZTSPHY 

REAL (KIND=JPRB), DIMENSION (KLON,KLEV) :: ZTENT55D, ZTENQ55D, ZTENU55D, ZTENV55D
REAL (KIND=JPRB), DIMENSION (KLON,KLEV) :: ZTENT55E, ZTENQ55E 
REAL (KIND=JPRB), DIMENSION (KLON,KLEV) :: ZTENT55F, ZTENQ55F, ZTENU55F, ZTENV55F
REAL (KIND=JPRB), DIMENSION (KLON)      :: ZFACT5, ZFACT25, ZDPH5, ZFACT35
REAL (KIND=JPRB), DIMENSION (:,:,:), ALLOCATABLE :: ZCEN, ZTENC
REAL (KIND=JPRB), DIMENSION (:),     ALLOCATABLE :: ZSCAV5

INTEGER (KIND=JPIM), DIMENSION (KLON) :: IBASC, ITOPC, JTOPC, JBASEC, JBOTSC, JTYPE
INTEGER (KIND=JPIM) :: ISTEP, ISTART, IIDIA, IFDIA, ITDIA
INTEGER (KIND=JPIM) :: JL, JK , ITRAC
     
LOGICAL, DIMENSION (KLON) :: LLLAND, LLCUM, LLSC 
LOGICAL :: LLSLPHY, LLRAIN1D
      
REAL (KIND=JPRB) :: ZHOOK_HANDLE

#include "satur.intfb.h"
#include "cucalln2.intfb.h"
#include "cloudst.intfb.h"
#include "saturad.intfb.h"
#include "cucalln2ad.intfb.h"
#include "cloudstad.intfb.h"

IF (LHOOK) CALL DR_HOOK('PHYS_AD',0,ZHOOK_HANDLE)

IIDIA  =    1
IFDIA  = KLON
ITDIA  =    1
ISTEP  =    1
ISTART =    1
ITOPC  = KLEV
IBASC  =    1

LLRAIN1D = .TRUE.
LLSLPHY = .FALSE.
LLLAND  = .FALSE. ! Force the estimation of precipitation over oceans

!   TIME STEP
ZTSPHY = TSTEP

ZMFUDE_RATE5 (:,:) = 0.0_JPRB
ZMFDDE_RATE5 (:,:) = 0.0_JPRB
         
ZU5    (:,:) = 0.0_JPRB
ZV5    (:,:) = 0.0_JPRB 
ZW5    (:,:) = 0.0_JPRB 
ZTENU5 (:,:) = 0.0_JPRB
ZTENV5 (:,:) = 0.0_JPRB

!* geopotential
ZGEOMH5 (:,KLEV+1) = 0.0_JPRB
DO JK = KLEV,1,-1
  ZGEOMH5 (:,JK) = ZGEOMH5 (:,JK+1) + &
   & 287.0_JPRB*PT5(:,JK)*(1.0_JPRB+0.608_JPRB*PQ5(:,JK))/PP5(:,JK)*(PPH5(:,JK+1)-PPH5(:,JK))
ENDDO               
DO JK=1,KLEV
  ZGEOM15 (:,JK) = 0.5_JPRB * (ZGEOMH5 (:,JK+1) + ZGEOMH5 (:,JK))
ENDDO

DO JL = 1, KLON
  ZDIFTS5 (JL,KLEV+1) = PDIFTS5 (JL)
  ZDIFTQ5 (JL,KLEV+1) = PDIFTQ5 (JL)
ENDDO

!* Specific humidity at saturation
CALL SATUR (IIDIA, IFDIA, KLON, ITDIA, KLEV, PP5, PT5, ZQSAT5, 2)

ZTENT55D(:,:)=PTENT5(:,:)
ZTENQ55D(:,:)=PTENQ5(:,:)
ZTENU55D(:,:)=ZTENU5(:,:)
ZTENV55D(:,:)=ZTENV5(:,:)

!* Simplified convection scheme
ITRAC=0
CALL CUCALLN2 (IIDIA   , IFDIA  , KLON   , KLEV                     , &
            &  ISTEP   , ISTART , LLLAND , LLSLPHY, LLRAIN1D        , &
            &  ZTSPHY                                               , &
            &  PT5     , PQ5    , ZU5    , ZV5                      , &
            &  ZW5     , ZDIFTQ5, ZDIFTS5, PPH5                     , &
            &  PP5     , PPH5   , ZGEOM15, ZGEOMH5                  , &
            &  PTENT5  , PTENQ5 , ZTENU5 , ZTENV5 , ZARPRC5         , &
            &  ITOPC   , IBASC  , JTYPE                             , &
            &  JBASEC  , JTOPC  , JBOTSC , LLCUM  , LLSC            , & 
            &  ZLU5    , ZLUDE5 , ZMFU5  , ZMFD5                    , &
            &  ZDIFCQ5 , ZDIFCS5, ZFHPCL5, ZFHPCN5                  , &
            &  ZFPLCL5 , ZFPLCN5, ZSTRCU5, ZSTRCV5, ZFCCQL5, ZFCCQN5, &
            &  ZMFUDE_RATE5, ZMFDDE_RATE5, ZCAPE5                   , &
            &  ITRAC   , ZCEN   , ZTENC  , ZSCAV5)

ZTENT55E(:,:)=PTENT5(:,:)
ZTENQ55E(:,:)=PTENQ5(:,:)

ZTENT55F(:,:)=PTENT5(:,:)
ZTENQ55F(:,:)=PTENQ5(:,:)
ZTENU55F(:,:)=ZTENU5(:,:)
ZTENV55F(:,:)=ZTENV5(:,:)

!* Simplified cloud scheme
CALL CLOUDST (IIDIA  , IFDIA  , KLON   , ITDIA,  KLEV, &
            & LLSLPHY, LLRAIN1D , ZTSPHY             , &
            & PPH5   , PP5    , PQ5    , ZQSAT5, PT5 , &
            & ZLUDE5 , ZLU5                          , &
            & PTENT5 , PTENQ5                        , &
            & PDCC5  , PDQI5  , PDQL5                , &
            & ZFPLSL5, ZFPLSN5, ZFHPSL5, ZFHPSN5     , &
            & ZCOVPTOT5)
    
!* 2D/3D and strat./conv. precipitation flux 
DO JL = 1, KLON
!    DO JK = 1, KLEV + 1
!       ZFPLCL5 (JL,JK) = MAX (0.0_JPRB, ZFPLCL5 (JL,JK))
!       ZFPLCN5 (JL,JK) = MAX (0.0_JPRB, ZFPLCN5 (JL,JK))
!       ZFPLSL5 (JL,JK) = MAX (0.0_JPRB, ZFPLSL5 (JL,JK))
!       ZFPLSN5 (JL,JK) = MAX (0.0_JPRB, ZFPLSN5 (JL,JK))
!    ENDDO   
  DO JK = 1, KLEV
     PRAIN3D5(JL,JK) = (ZFPLSL5(JL,JK  ) + ZFPLCL5(JL,JK  ) &
       &             +  ZFPLSL5(JL,JK+1) + ZFPLCL5(JL,JK+1))*0.5_JPRB
     PSNOW3D5(JL,JK) = (ZFPLSN5(JL,JK  ) + ZFPLCN5(JL,JK  ) &
       &             +  ZFPLSN5(JL,JK+1) + ZFPLCN5(JL,JK+1))*0.5_JPRB
  ENDDO
  PFLC5 (JL) = ZFPLCL5 (JL,KLEV+1) + ZFPLCN5 (JL,KLEV+1)
  PFLS5 (JL) = ZFPLSL5 (JL,KLEV+1) + ZFPLSN5 (JL,KLEV+1)
ENDDO
       
!* Adjoint
ZU (:,:) = 0.0_JPRB
ZV (:,:) = 0.0_JPRB
ZW (:,:) = 0.0_JPRB

!LOP ZARPRC (:,:) = 0.0_JPRB
ZARPRC (:) = 0.0_JPRB

ZFPLCL (:,:) = 0.0_JPRB
ZFPLCN (:,:) = 0.0_JPRB
ZFPLSL (:,:) = 0.0_JPRB
ZFPLSN (:,:) = 0.0_JPRB
ZFHPSL (:,:) = 0.0_JPRB
ZFHPSN (:,:) = 0.0_JPRB
ZFHPCL (:,:) = 0.0_JPRB
ZFHPCN (:,:) = 0.0_JPRB

ZCOVPTOT(:,:) = 0.0_JPRB

ZDIFTS (:,:) = 0.0_JPRB
ZDIFTQ (:,:) = 0.0_JPRB

ZTENU (:,:) = 0.0_JPRB
ZTENV (:,:) = 0.0_JPRB

ZLU   (:,:) = 0.0_JPRB
ZLUDE (:,:) = 0.0_JPRB
ZMFU  (:,:) = 0.0_JPRB
ZMFD  (:,:) = 0.0_JPRB

ZQSAT  (:,:) = 0.0_JPRB
ZGEOMH (:,:) = 0.0_JPRB
ZGEOM1 (:,:) = 0.0_JPRB
 
DO JL = 1, KLON
  ZFPLSL (JL,KLEV+1) = ZFPLSL (JL,KLEV+1) + PFLS (JL)
  ZFPLSN (JL,KLEV+1) = ZFPLSN (JL,KLEV+1) + PFLS (JL)
  PFLS (JL) = 0.0_JPRB
  
  ZFPLCL (JL,KLEV+1) = ZFPLCL (JL,KLEV+1) + PFLC (JL)
  ZFPLCN (JL,KLEV+1) = ZFPLCN (JL,KLEV+1) + PFLC (JL)
  PFLC (JL) = 0.0_JPRB
      
  DO JK = KLEV, 1, -1
     ZFPLSN  (JL,JK+1) = ZFPLSN (JL,JK+1) + 0.5_JPRB*PSNOW3D (JL,JK)
     ZFPLCN  (JL,JK+1) = ZFPLCN (JL,JK+1) + 0.5_JPRB*PSNOW3D (JL,JK)
     ZFPLSN  (JL,JK  ) = ZFPLSN (JL,JK  ) + 0.5_JPRB*PSNOW3D (JL,JK)
     ZFPLCN  (JL,JK  ) = ZFPLCN (JL,JK  ) + 0.5_JPRB*PSNOW3D (JL,JK)
     PSNOW3D (JL,JK) = 0.0_JPRB

     ZFPLSL  (JL,JK+1) = ZFPLSL (JL,JK+1) + 0.5_JPRB*PRAIN3D (JL,JK)
     ZFPLCL  (JL,JK+1) = ZFPLCL (JL,JK+1) + 0.5_JPRB*PRAIN3D (JL,JK)
     ZFPLSL  (JL,JK  ) = ZFPLSL (JL,JK  ) + 0.5_JPRB*PRAIN3D (JL,JK)
     ZFPLCL  (JL,JK  ) = ZFPLCL (JL,JK  ) + 0.5_JPRB*PRAIN3D (JL,JK)
     PRAIN3D (JL,JK) = 0.0_JPRB
  ENDDO
ENDDO
 
CALL CLOUDSTAD (IIDIA  , IFDIA  , KLON   , ITDIA  , KLEV, &
             &  LLRAIN1D , ZTSPHY                       , &
             &  PPH5   , PP5    , PQ5    , ZQSAT5 , PT5 , &
             &  ZLUDE5 , ZLU5                           , &
             &  ZTENT55E, ZTENQ55E                      , &
             &  PDCC5  , PDQI5  , PDQL5                 , &
             &  ZFPLSL5, ZFPLSN5, ZFHPSL5, ZFHPSN5      , & 
             &  ZCOVPTOT5                               , &
             &  PPH    , PP     , PQ     , ZQSAT  , PT  , &
             &  ZLUDE  , ZLU                            , &
             &  PTENT  , PTENQ                          , &
             &  PDCC   , PDQI   , PDQL                  , &
             &  ZFPLSL , ZFPLSN , ZFHPSL , ZFHPSN       , &
             &  ZCOVPTOT)
    
CALL CUCALLN2AD (IIDIA   , IFDIA   , KLON   , KLEV                     , &
              &  ISTEP   , ISTART  , LLLAND , LLRAIN1D                 , &
              &  ZTSPHY                                                , &
              &  PT5     , PQ5     , ZU5,     ZV5                      , & 
              &  ZW5     , ZDIFTQ5 , ZDIFTS5, PPH5                     , & 
              &  PP5     , PPH5    , ZGEOM15, ZGEOMH5                  , &
              &  ZTENT55D, ZTENQ55D, ZTENU55D, ZTENV55D                , &
              &  ZTENT55F, ZTENQ55F, ZTENU55F, ZTENV55F                , &
              &  JTYPE                                                 , &
              &  JBASEC  , JTOPC   , JBOTSC , LLCUM  , LLSC            , &
              &  ZLU5    , ZLUDE5  , ZMFU5  , ZMFD5                    , &
              &  ZFPLCL5 , ZFPLCN5                                     , &
              &  ITRAC   , ZCEN    , ZTENC  , ZSCAV5                   , &
              &  PT      , PQ      , ZU ,     ZV                       , &
              &  ZW      , ZDIFTQ  , ZDIFTS , PPH                      , &
              &  PP      , PPH     , ZGEOM1 , ZGEOMH                   , &
              &  PTENT   , PTENQ   , ZTENU  , ZTENV                    , &
              &  ZLU     , ZLUDE   , ZMFU   , ZMFD                     , &
              &  ZDIFCQ  , ZDIFCS  , ZFHPCL , ZFHPCN                   , &
              &  ZFPLCL  , ZFPLCN  , ZSTRCU , ZSTRCV , ZFCCQL , ZFCCQN , &
              &  ZCEN    , ZTENC )

CALL SATURAD (IIDIA,IFDIA,KLON,ITDIA,KLEV,PP5, PT5, ZQSAT5, &
                                       &  PP , PT , ZQSAT )

DO JL = 1, KLON
  PDIFTS (JL) = PDIFTS (JL) + ZDIFTS (JL,KLEV+1)
  ZDIFTS (JL,KLEV+1) = 0.0_JPRB

  PDIFTQ (JL) = PDIFTQ (JL) + ZDIFTQ (JL,KLEV+1)
  ZDIFTQ (JL,KLEV+1) = 0.0_JPRB
ENDDO

DO JK = KLEV, 1, -1
  ZGEOMH (:,JK+1) = ZGEOMH (:,JK+1) + 0.5_JPRB * ZGEOM1 (:,JK)
  ZGEOMH (:,JK  ) = ZGEOMH (:,JK  ) + 0.5_JPRB * ZGEOM1 (:,JK)
  ZGEOM1 (:,JK  ) = 0.0_JPRB
ENDDO

DO JK = 1, KLEV
  ZFACT5  (:) = 287.0_JPRB * (1.0_JPRB + 0.608_JPRB * PQ5 (:,JK)) / PP5 (:,JK)
  ZFACT25 (:) = ZFACT5(:) * PT5 (:,JK) * ZGEOMH (:,JK)
  ZDPH5   (:) = PPH5 (:,JK+1) - PPH5 (:,JK)
  ZFACT35 (:) = ZDPH5 (:) / PP5 (:,JK)

  ZGEOMH(:,JK+1) = ZGEOMH (:,JK+1) + ZGEOMH (:,JK)
  PT  (:,JK)   = PT  (:,JK)  + ZFACT5 (:) * ZDPH5 (:) * ZGEOMH (:,JK)  
  PQ  (:,JK)   = PQ  (:,JK)  + 287.0_JPRB * 0.608_JPRB * PT5 (:,JK) * ZFACT35 (:) * ZGEOMH(:,JK)
  PP  (:,JK)   = PP  (:,JK)  - ZFACT25 (:) * ZFACT35(:)
  PPH (:,JK+1) = PPH (:,JK+1)+ ZFACT25 (:)
  PPH (:,JK  ) = PPH (:,JK  )- ZFACT25 (:)
  ZGEOMH (:,JK) = 0.0_JPRB
ENDDO               

ZGEOMH (:,KLEV+1) = 0.0_JPRB

IF (LHOOK) CALL DR_HOOK('PHYS_AD',1,ZHOOK_HANDLE)
END SUBROUTINE PHYS_AD      
