SUBROUTINE SUMETHOX

!**** *SUCLDP*   - INITIALIZE MODULE YOEMETH CONTROLLING *METHOX*

!     PURPOSE.
!     --------
!           INITIALIZE YOEMETH

!**   INTERFACE.
!     ----------
!        CALL *SUMETHOX* FROM *SUPHEC*
!              --------        ------

!        EXPLICIT ARGUMENTS :
!        --------------------
!        NONE

!        IMPLICIT ARGUMENTS :
!        --------------------
!        MODULE YOEMETH

!     METHOD.
!     -------
!        SEE DOCUMENTATION

!     EXTERNALS.
!     ----------
!        NONE

!     REFERENCE.
!     ----------
!        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE
!     "INTEGRATED FORECASTING SYSTEM"

!     AUTHOR.
!     -------
!        C.JAKOB   *ECMWF*

!     MODIFICATIONS.
!     --------------
!        ORIGINAL : 98-04-07
!        Modified : 02-01-29  A.Simmons: increase RQLIM from 3.75e-6
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOEMETH   , ONLY : RALPHA1 ,RALPHA2  ,RQLIM   ,&
 & RPBOTOX,  RPBOTPH ,RPTOPOX  ,RPTOPPH ,&
 & RALPHA3,  RLOGPPH  

!*       1.    SET VALUES
!              ----------

IMPLICIT NONE
REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('SUMETHOX',0,ZHOOK_HANDLE)
RALPHA1=(19._JPRB*LOG(10._JPRB))/(LOG(20._JPRB)**4)
RALPHA2=LOG(1.0_JPRB/3._JPRB+0.01_JPRB)
RQLIM=4.25E-6_JPRB
RPBOTOX=10000._JPRB
RPBOTPH=20._JPRB
RPTOPOX=50._JPRB
RPTOPPH=0.1_JPRB
RALPHA3=0.5_JPRB*(LOG(100._JPRB)+RALPHA2)
RLOGPPH=LOG(RPTOPPH/RPBOTPH)

!     -----------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SUMETHOX',1,ZHOOK_HANDLE)
END SUBROUTINE SUMETHOX
