#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0 
SUBROUTINE SUECSO4HIS

!**** *SUECSO4* - DEFINES NEW CLIMATOLOGICAL DISTRIBUTION OF AEROSOLS

!     PURPOSE.
!     --------

!**   INTERFACE.
!     ----------
!        CALL *SUECSO4HIS* FROM *UPDTIM*

!        EXPLICIT ARGUMENTS :
!        --------------------
!     ==== INPUTS ===
!     ==== OUTPUTS ===
!     AEROSOL TOTAL OPTICAL THICKNESS (0.55 MICRON)

!-- O.BOUCHER MONTHLY/DECENNIAL CLIMATOLOGY OF TROPOSPHERIC SULPHATE AEROSOLS

! RTAESO4 : SULFATE AEROSOL


!        IMPLICIT ARGUMENTS :   NONE
!        --------------------

!     METHOD.
!     -------

!     EXTERNALS.
!     ----------

!          NONE

!     REFERENCE.
!     ----------

!        SEE RADIATION'S PART OF THE MODEL'S DOCUMENTATION AND
!        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE "I.F.S"

!     AUTHOR.
!     -------
!     J.-J. MORCRETTE  E.C.M.W.F.    98/12/21

!     MODIFICATIONS.
!     --------------
!     990115: JJMorcrette, Volcanic aerosols
!     990525: JJMorcrette, Monthly Climatology of Tropospheric Aerosols
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     R. Elkhatib 12-10-2005 Split for faster and more robust compilation.
!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

IMPLICIT NONE

!     -----------------------------------------------------------------

!*       0.1   ARGUMENTS.
!              ----------

!*       0.2   LOCAL ARRAYS.
!              -------------

REAL(KIND=JPRB) :: ZAER(96,73,12)

REAL(KIND=JPRB) :: ZHOOK_HANDLE

LOGICAL,SAVE :: LLFIRSTCALL = .TRUE.


#include "su_so4_obs1920.intfb.h"
#include "su_so4_obs1930.intfb.h"
#include "su_so4_obs1940.intfb.h"
#include "su_so4_obs1950.intfb.h"
#include "su_so4_obs1960.intfb.h"
#include "su_so4_obs1970.intfb.h"
#include "su_so4_obs1980.intfb.h"
#include "su_so4_obs1990.intfb.h"

#include "su_so4_A1B2000.intfb.h"
#include "su_so4_A1B2010.intfb.h"
#include "su_so4_A1B2020.intfb.h"
#include "su_so4_A1B2030.intfb.h"
#include "su_so4_A1B2040.intfb.h"
#include "su_so4_A1B2050.intfb.h"
#include "su_so4_A1B2060.intfb.h"
#include "su_so4_A1B2070.intfb.h"
#include "su_so4_A1B2080.intfb.h"
#include "su_so4_A1B2090.intfb.h"
#include "su_so4_A1B2100.intfb.h"

#include "fcttim.h"      
!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SUECSO4HIS',0,ZHOOK_HANDLE)

IF(LLFIRSTCALL) THEN

  CALL SU_SO4_OBS1920 ( ZAER )
  CALL SU_SO4_OBS1930 ( ZAER )
  CALL SU_SO4_OBS1940 ( ZAER )  
  CALL SU_SO4_OBS1950 ( ZAER )  
  CALL SU_SO4_OBS1960 ( ZAER )  
  CALL SU_SO4_OBS1970 ( ZAER )
  CALL SU_SO4_OBS1980 ( ZAER )
  CALL SU_SO4_OBS1990 ( ZAER )

  CALL SU_SO4_A1B2000 ( ZAER )  
  CALL SU_SO4_A1B2010 ( ZAER )  
  CALL SU_SO4_A1B2020 ( ZAER )  
  CALL SU_SO4_A1B2030 ( ZAER )  
  CALL SU_SO4_A1B2040 ( ZAER )  
  CALL SU_SO4_A1B2050 ( ZAER )  
  CALL SU_SO4_A1B2060 ( ZAER )  
  CALL SU_SO4_A1B2070 ( ZAER )  
  CALL SU_SO4_A1B2080 ( ZAER )  
  CALL SU_SO4_A1B2090 ( ZAER )  
  CALL SU_SO4_A1B2100 ( ZAER )  

ENDIF



!     ------------------------------------------------------------------

LLFIRSTCALL = .FALSE.

IF (LHOOK) CALL DR_HOOK('SUECSO4HIS',1,ZHOOK_HANDLE)
!-----------------------------------------------------------------------------
END SUBROUTINE SUECSO4HIS


