SUBROUTINE SU2YOM

!**** *SU2YOM*  - Initialize level 2 commons and some higher

!     Purpose.
!     --------
!           Initialize level 2 commons

!**   Interface.
!     ----------
!        *CALL* *SU2YOM

!        Explicit arguments :
!        --------------------
!        None

!        Implicit arguments :  Common YOMCT2
!        --------------------

!     Method.
!     -------
!        See documentation

!     Externals.
!     ----------

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     Author.
!     -------
!        Mats Hamrud and Philippe Courtier  *ECMWF*

!     Modifications.
!     --------------
!        Original : 87-10-15
!        CLIVE TEMPERTON: 90-01-16 : CALL ADDED TO SUMODE3
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      01-Dec-2003 CY28R1 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCT0   , ONLY : NSTART   ,NSTOP
USE YOMCT2   , ONLY : NSTAR2   ,NSTOP2   ,NSTP

IMPLICIT NONE

REAL(KIND=JPRB) :: ZHOOK_HANDLE

!     ------------------------------------------------------------------

!*       1.    Initialize YOMCT2, set default values.
!              --------------------------------------

IF (LHOOK) CALL DR_HOOK('SU2YOM',0,ZHOOK_HANDLE)
NSTAR2=NSTART
NSTOP2=NSTOP
NSTP=1

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SU2YOM',1,ZHOOK_HANDLE)
END SUBROUTINE SU2YOM
