SUBROUTINE SU_GRIB_API

!**** *SU_GRIB_API* - Routine to intitialize GRIB API usage

!     Purpose.
!     --------

!**   Interface.
!     ----------
!        *CALL* *SU_GRIB_API*

!        Explicit arguments :  None.
!        --------------------

!        Implicit arguments :  
!        --------------------

!     Method.  
!     -------  

!     Externals.
!     ----------

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     Author.
!     -------
!        Mats Hamrud *ECMWF*

!     Modifications.
!     --------------
!        Original : 15 May 2007

!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
IMPLICIT NONE

REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "preset_grib_template.intfb.h"

!     ------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('SU_GRIB_API',0,ZHOOK_HANDLE)

CALL GSTATS(1977,0)
CALL PRESET_GRIB_TEMPLATE('GG')
CALL PRESET_GRIB_TEMPLATE('GG_ML')
CALL PRESET_GRIB_TEMPLATE('SH')
CALL PRESET_GRIB_TEMPLATE('SH_ML')
CALL GSTATS(1977,1)

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SU_GRIB_API',1,ZHOOK_HANDLE)
END SUBROUTINE SU_GRIB_API
