#ifdef VPP
!OCL SCALAR
#endif
SUBROUTINE SUALLO

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE PARDIM   , ONLY : JPMXLE
USE YOMCT0   , ONLY : NCONF    ,NPRINTLEV,LSLAG    ,LGUESS,&
 & LALLOPR  ,LELAM    ,LRETCFOU ,LWRTCFOU ,LNHDYN
USE YOMCT0B  , ONLY : LECMWF
USE YOMLUN   , ONLY : NULOUT
USE YOMDIM   , ONLY : NDGLG    ,NDGSAG   ,&
 & NDGENG   ,NDLSM    ,NFLEVL   ,NFLEVG   ,&
 & NMSMAX   ,NSMAX    ,NSPEC2G  ,NCMAX    ,&
 & NXMAX    ,NXPECG   ,NTMAX    ,&
 & NRLEVX
USE YOMDPHY  , ONLY : NVCLIS   ,NTOZ1D   ,NTOZ2D   ,NTOZ3D   ,&
 & NTSSG  
USE YOMLAP   , ONLY : NLSCM    ,NLACM    ,NLCM     ,NLSCN    ,&
 & NLACN    ,NLCN     ,NASN0    ,NASM0    ,&
 & NASM0G   ,NASRN    ,NACM0    ,NATM0    ,&
 & NSPZERO  ,&
 & RLAPDI   ,RLAPIN   ,RCAPDI   ,RCAPIN   ,RTAPDI   ,RTAPIN
USE YOMLEG   , ONLY : RW       ,RMU      ,R1MU2    ,R1MUI    ,&
 & R1MUA    ,RSQM2    ,R1QM2    ,RACTHE   ,RLATIG  
USE YOMNMIA  , ONLY : NVMODM   ,LNMIRQ   ,LRPIMP   ,&
 & LNPROJ   ,LCONMO   ,LNOINI  
USE YOMNMIB  , ONLY : LTYPGR   ,FREQ
USE YOMGEM   , ONLY : NLOEN    ,NLOENG   ,NMEN     ,NMENTC   ,&
 & NMENG    ,NDGLU    ,VALH     ,VBH      ,VETAH    ,VFE_ETAH ,&
 & VAH      ,VC       ,VDELB    ,VETAF    ,VCUICO   ,VCUICOH  ,&
 & NVAUTF   ,NVAUTH   ,VAF      ,VBF      ,VDELA    ,VFE_ETAF ,&
 & VFE_RDETAH,VSLD     ,VSLDW    ,VSLDH    ,VSLDWH
USE YOMSTA   , ONLY : STPRE    ,STPHI    ,STTEM    ,STDEN    ,&
 & STZ      ,STPREH
USE YOMGRB   , ONLY : NSEC2GG  ,RSEC2
USE YOMVAR   , ONLY : LJC
USE YOMTOPH  , ONLY : RMESOU   ,RMESOT   ,RMESOQ
USE YOMPHY   , ONLY : LRRMES  
USE YOEAERD  , ONLY : CVDAES   ,CVDAEL   ,CVDAEU   ,CVDAED
USE YOMAERD15, ONLY : CVDAES15 ,CVDAEL15 ,CVDAEU15 ,CVDAED15, CVDAEF15
USE YOEOVLP  , ONLY : RA1OVLP
USE YOECLD   , ONLY : CETA
USE YOEPHY   , ONLY : LAGPHY
USE YOMSC2   , ONLY : NDIST    ,NDIEND   ,NCIST    ,NCIEND
USE YOMOZO   , ONLY : TOZ1D    ,TOZ2DG   ,TOZ3DBG
USE YOMSPHB  , ONLY : NSTASPHB
USE YOMHOUB  , ONLY : NSTAHOUB
USE YOMPINB  , ONLY : NSTAPINB
USE YOMSSG   , ONLY : TSSGB
USE YOMSNU   , ONLY : XPNUDG   ,TNUDTE   ,TNUDSH   ,TNUDDI   ,&
 & TNUDVO   ,TNUDSV   ,TNUDLP  
USE YOMNUD   , ONLY : NFNUDG   ,LNUDG    ,LNUDDI   ,LNUDLP   ,&
 & LNUDSH   ,LNUDSV   ,LNUDTE   ,LNUDVO  
USE YOMCVER  , ONLY : LVERTFE  ,NVSCH    ,RINTE    ,LVSPLIP  ,&
 & RVSPTRI  ,RVSPC    ,RFAA     ,RFBB    ,RFCC     ,&
 & RFDD     ,VRDETAR  ,RDERI    ,RDERB   ,RDDERI
USE OML_MOD  , ONLY : OML_INIT_LOCK
USE YOMDYNA  , ONLY : LGWADV    ,LSLHD   ,LSLHDQUAD
USE YOM_YGFL , ONLY : NGFL_EXT

!----------------------------------  

!**** *SUALLO * - Routine to allocate space for global variables

!     Purpose.
!     --------
!           Allocate space for the global fields.

!**   Interface.
!     ----------
!        *CALL* *SUALLO*

!     Explicit arguments :  None
!     --------------------
!        Called by SU0YOMA.

!     Implicit arguments :
!     --------------------
!        Pointers of comdecks

!     Method.
!     -------
!     Externals.
!     ----------
!        SUALOBS
!        for diagnostics DDH: SUALMDH (first part : masks)

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     Author.
!     -------
!        Mats Hamrud and Philippe Courtier  *ECMWF*

!     Modifications.
!     --------------
!        Original : 87-10-26
!        CLIVE TEMPERTON : 90-02-02 : SPACE FOR NORMAL MODE FREQS. (3-D)
!        D. VASILJEVIC   : 90-06-19 : SPACE FOR OBS. RELATED ARRAYS
!        ALAIN JOLY      : 90-08-10 : DECLARATIONS MASQUES DDH
!        D. VASILJEVIC   : 90-11-20 : REORGANISATION FOR OBS/GUESS PART
!        C. BLONDIN      : 90-12-25 : Space allocation for PHYSICS arrays.
!      Modified 91-02-28 by Michel Deque (Relaxation of deep soil values)
!      Modified 91-03-15 by Michel Deque (Ozone parameterization)
!      Modified 91-04-01 by Michel Deque (pseudo-historical cloudiness)
!      MODIFIED 91-05-24 BY P.COURTIER CUMULATIVE FLUX AND FIELDS DIAGS.
!      Modified 91-05-21 by A.Lasserre-Bigorry (scalar variables)
!      Modified 91-06-10 by A.Lasserre-Bigorry (middle atmosphere model)
!      Modified 91-06-25 by A.Lasserre-Bigorry (ozone chemistry)
!      Modified 91-07-03 by Philippe Courtier cleaning
!      Modified 91-06-05 by Bill Heckley (allocation for Jc)
!      Modified 91-11-12 by J.J. Morcrette (allocation for ECMWF physics)
!      Modified 92-02-16 by M. Deque (allocation for arrays for ozone)
!      Modified 92-02-29 by J.J. Morcrette (some more  for ECMWF physics)
!      Modified 92-02-25 by D. Giard (allocation for NMI tests)
!      Modified 92-04-28 by Bill Heckley (Initialization of First-guess)
!      Modified 30/5/92 by A. Joly (introduction of YOMPPDY)
!      Modified 92-05-25 by C. Dreveton (diagnostics)
!      MODIFIED 06/92 BY O.CLARY INSTANTANEOUS FLUX AND FIELDS DIAGS.
!      Modified 92-07-02 by R. Bubnova (shift of RATATH to YOMGEM from
!                        YOMLEG, add RATATX allocation)
!      Modified 92-09-17 by J.-J. Morcrette (ECMWF cloud scheme)
!      K. Yessad: 18/12/1992. Non interpolating vertical scheme.
!      Modified 93-02-29 by Y. Bouteloup (animation of radiative flux)
!      K. Yessad: 08/03/1993. Additional horizontal diffusion
!                             on non stretched sphere.
!      Modified 92-12-24 by G. Radnoti (introduction of YEMCTEND)
!      Modified 93-03-19 by D. Giard (Legendre transf. with NTMAX)
!      Modified 93-05-19 by M. Deque (Subgrid temperatures)
!      Modified by K. YESSAD 93-12-31: (map factor and CFL criteria in ZDI)
!      Modified OCTOBER 1993 by K. YESSAD: semi-implicit scheme with
!                                          not reduced divergence.
!      Modified 93-07-30 by K. YESSAD (RPNM not allocated for conf 911).
!      Modified 94-03-03 by R. El Khatib (Full-POS implementation)
!      Modified 94-07-08 by M. Deque (additional diagnostics for sea-ice)
!      K. YESSAD (APRIL 1994): Unified horizontal diffusion scheme.
!      Modified 94-06-06 by J.L. Ricard (Allocation of FTHSOR shifted to Sudyn)
!      Modified 94-08-31 by M.Tolstykh CUD interpolation, modif. decentering
!      K. YESSAD (JAN 1995): Allocate weights RCUDWL and RCUDWM for
!          optimised computation of CUD-5 derivatives.
!      Modified 95-04-20 by M. Deque (additional diagnostics in CO)
!      K. YESSAD (MARCH 1995): Optimisation of semi-implicit computations
!          if variable decentering and remove of IMSL routines.
!      Modified 95-06-06 by L. Isaksen (Reordering of spectral arrays)
!      Modified 95-08-30 by D. Giard (suppression of some arrays)
!      Modified 95-10-19 by J.F. Mahfouf (trajectory at t-dt)
!      Modified 95-12-06 by M. Janiskova (trajectory at t-dt for
!          simpl.phys.param.)
!      Modified 96-03-15 by P. Le Moigne (disable call to sualctv if NCONF=9xx)
!      K. YESSAD (NOV 1995): removal of HDC horizontal diffusion scheme.
!      Modified 96-07-01 by M. Deque (nudging fields)
!      Modified 96-09-18 by P. Marquet : Unsigned modifs (15R2) of G.
!          Mozdzynski : section 1.17 (COUPLED DIAG.) moved to sugem2
!      Modified 96-09-18 by L. Isaksen (Distribute nudging fields)
!      Modified 97-05-18 by M. Deque   (Frozen FMR)
!      Modified 96-09 by M Janiskova and K. Yessad: spectral transforms for
!          transmission coefficients
!      Modified 98-01-19 by L. Isaksen (Bugfix for SWE)
!      Modified 97-12-16 by K. YESSAD: report of Jean Latour corrections
!          (replace NFLEVG by MAX(JPMXLE,NFLEVG) in some allocations
!          to avoid memory overwriting in some configurations of FULL-POS).
!      Modified 97-06-27 by P. Le Moigne (remove call to suelctv ALADIN)
!      C. FISCHER 97-12-01: allocation of NSE0, NDGLU, test before NFPSENDNUM
!      Modified 98-03-06 by M. Deque (nudging and distrib. memory)
!      K. YESSAD (JAN 1998): removal of arrays NFPSENDNUM and NFPRECVNUM.
!      Modified 99-02-21 by M. Janiskova: allocation for radiation coef.
!      Modified 98-10-19 by C. Temperton (trajectory storage for
!          tangent-linear and adjoint of semi-Lagrangian)
!      Modified 98-08-10 by K. YESSAD: removal of LRPOLE option.
!        - removal of LRPOLE in YOMCT0.
!        - removal of YOMPOLE and of the allocation of all arrays of YOMPOLE.
!      Modified 98-10-23 by Z. Bencetic Klaic: 1d array for ozone added (TOZ1D)
!      Modified 2000-01-20 by M. Janiskova (trajectory for phys.tendecies)
!      Modified 99-08-25 by C. Temperton (trajectory storage for
!          tangent-linear and adjoint of semi-Lagrangian - 3D version)
!      Modified 99-02-01 M. Charron non-hydrostatic
!      Modified 99-02-17 by K. YESSAD: options LRETCFOU, LWRTCFOU.
!      Modified 00-02-14 by C. Temperton: LSLAG and NCONF=601   
!      Modified NOV 1999 by K. YESSAD:
!       - in 'lacudw', compute PDLAT and ILA as in 'lascaw' =>
!         'nrlatx', 'nindlat' and 'rdllat' become useless.
!       - 'ndgl' becomes 'ndglg'.
!       - 'ndgsa' becomes 'ndgsag'.
!       - 'ndgen' becomes 'ndgeng'.
!       - 'nflev' becomes 'nflevg'.
!      C.Fischer, L. Gaytandjieva 01-04-02 remove allocation of tendchk
!      Modified 08-2002 C. Smith : use "w" as prognostic variable in the
!       semi-lag advection of vertical divergence in the NH model.
!      R. El Khatib : 02-21-20 Fullpos B-level distribution + remove IO scheme
!      Modified 02-08-14 by Y.Tremolet: moved SUALCTV to SU0YOMB
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!      Modified 04-09-15 by F.Bouyssel: allocation of STPREH
!        M.Hamrud      01-Jul-2006 Revised surface fields
!     K. Yessad 15-May-2006: memory optimisations for stretched geometry
!     M. Bellus 28-Sep-2006: ALARO-0 phasing (Smith RH for Lopez scheme)
!   N. Wedi and K. Yessad (Jan 2008): different dev for NH model and PC scheme
!   30-Jun-2008 J. Masek   Auxiliary quantities for SLHD interpolators.
!   K. Yessad (Sep 2008): LREGETA -> LREGETA + LVFE_REGETA.
!   A. Fouilloux (sep 2009) : remove call to sualobs
!     ------------------------------------------------------------------

IMPLICIT NONE

INTEGER(KIND=JPIM) :: IFLEV, ISMAX, IU

LOGICAL ::  LLNMI, LLP
REAL(KIND=JPRB) :: ZHOOK_HANDLE

!     ------------------------------------------------------------------

#include "abor1.intfb.h"
#include "sualdyn.intfb.h"

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SUALLO',0,ZHOOK_HANDLE)

!     ------------------------------------------------------------------

!*       1.    ALLOCATE SPACE FOR ARRAYS.
!              --------------------------

!*       1.1   GRID POINT FIELDS.

LLP = NPRINTLEV >= 1.OR. LALLOPR
IU = NULOUT
IF (LLP) WRITE(NULOUT,'('' SUALLO PRINTOUTS '')')

!*       1.3   LAPLACE SPACE ARRAYS - YOMLAP.

ALLOCATE(NLCM  (0:NSMAX))
IF(LLP)WRITE(IU,9) 'NLCM     ',SIZE(NLCM     ),SHAPE(NLCM     )
ALLOCATE(NLSCM (0:NSMAX))
IF(LLP)WRITE(IU,9) 'NLSCM    ',SIZE(NLSCM    ),SHAPE(NLSCM    )
ALLOCATE(NLACM (0:NSMAX))
IF(LLP)WRITE(IU,9) 'NLACM    ',SIZE(NLACM    ),SHAPE(NLACM    )
ALLOCATE(NLCN  (0:NSMAX))
IF(LLP)WRITE(IU,9) 'NLCN     ',SIZE(NLCN     ),SHAPE(NLCN     )
ALLOCATE(NLSCN (0:NSMAX))
IF(LLP)WRITE(IU,9) 'NLSCN    ',SIZE(NLSCN    ),SHAPE(NLSCN    )
ALLOCATE(NLACN (0:NSMAX))
IF(LLP)WRITE(IU,9) 'NLACN    ',SIZE(NLACN    ),SHAPE(NLACN    )
ALLOCATE(RLAPDI(-1:NSMAX+2))
IF(LLP)WRITE(IU,9) 'RLAPDI   ',SIZE(RLAPDI   ),SHAPE(RLAPDI   )
ALLOCATE(RLAPIN(-1:NSMAX+2))
IF(LLP)WRITE(IU,9) 'RLAPIN   ',SIZE(RLAPIN   ),SHAPE(RLAPIN   )
ALLOCATE(RCAPDI(0:NCMAX))
IF(LLP)WRITE(IU,9) 'RCAPDI   ',SIZE(RCAPDI   ),SHAPE(RCAPDI   )
ALLOCATE(RCAPIN(0:NCMAX))
IF(LLP)WRITE(IU,9) 'RCAPIN   ',SIZE(RCAPIN   ),SHAPE(RCAPIN   )
ALLOCATE(RTAPDI(0:NTMAX))
IF(LLP)WRITE(IU,9) 'RTAPDI   ',SIZE(RTAPDI   ),SHAPE(RTAPDI   )
ALLOCATE(RTAPIN(0:NTMAX))
IF(LLP)WRITE(IU,9) 'RTAPIN   ',SIZE(RTAPIN   ),SHAPE(RTAPIN   )
ALLOCATE(NASN0 (0:NSMAX))
IF(LLP)WRITE(IU,9) 'NASN0    ',SIZE(NASN0    ),SHAPE(NASN0    )
ALLOCATE(NASM0 (0:NSMAX))
IF(LLP)WRITE(IU,9) 'NASM0    ',SIZE(NASM0    ),SHAPE(NASM0    )
ALLOCATE(NASM0G(0:NSMAX))
IF(LLP)WRITE(IU,9) 'NASM0G   ',SIZE(NASM0G   ),SHAPE(NASM0G   )
ALLOCATE(NASRN (0:NSMAX))
IF(LLP)WRITE(IU,9) 'NASRN    ',SIZE(NASRN    ),SHAPE(NASRN    )
ALLOCATE(NACM0 (0:NCMAX))
IF(LLP)WRITE(IU,9) 'NACM0    ',SIZE(NACM0    ),SHAPE(NACM0    )
ALLOCATE(NATM0 (0:NTMAX))
IF(LLP)WRITE(IU,9) 'NATM0    ',SIZE(NATM0    ),SHAPE(NATM0    )
ALLOCATE(NSPZERO(0:NSMAX))
IF(LLP)WRITE(IU,9) 'NSPZERO  ',SIZE(NSPZERO  ),SHAPE(NSPZERO  )

ALLOCATE(RW    (NDGLG))
IF(LLP)WRITE(IU,9) 'RW       ',SIZE(RW       ),SHAPE(RW       )
ALLOCATE(RMU   (NDGSAG:NDGENG))
IF(LLP)WRITE(IU,9) 'RMU      ',SIZE(RMU      ),SHAPE(RMU      )
ALLOCATE(R1MU2 (NDGSAG:NDGENG))
IF(LLP)WRITE(IU,9) 'R1MU2    ',SIZE(R1MU2    ),SHAPE(R1MU2    )
ALLOCATE(R1MUI (NDGSAG:NDGENG))
IF(LLP)WRITE(IU,9) 'R1MUI    ',SIZE(R1MUI    ),SHAPE(R1MUI    )
ALLOCATE(R1MUA (NDGSAG:NDGENG))
IF(LLP)WRITE(IU,9) 'R1MUA    ',SIZE(R1MUA    ),SHAPE(R1MUA    )
IF (.NOT.LELAM) THEN
  ALLOCATE(RSQM2 (NDGSAG:NDGENG))
  IF(LLP)WRITE(IU,9) 'RSQM2    ',SIZE(RSQM2    ),SHAPE(RSQM2    )
ENDIF
ALLOCATE(R1QM2 (NDGSAG:NDGENG))
IF(LLP)WRITE(IU,9) 'R1QM2    ',SIZE(R1QM2    ),SHAPE(R1QM2    )
ALLOCATE(RACTHE(NDGSAG:NDGENG))
IF(LLP)WRITE(IU,9) 'RACTHE   ',SIZE(RACTHE   ),SHAPE(RACTHE   )
ALLOCATE(RLATIG(NDGSAG:NDGENG))
IF(LLP)WRITE(IU,9) 'RLATIG   ',SIZE(RLATIG   ),SHAPE(RLATIG   )

!*       1.5   NORMAL MODE INITIALIZATION - YOMNMI.

LLNMI= LNMIRQ .OR. LCONMO .OR. LNPROJ .OR.&
 & ( NCONF == 131 .AND.(LJC.OR.LGUESS) )  
IF (LLNMI) THEN
  ALLOCATE(LTYPGR(6*NXPECG,NVMODM))
  IF(LLP)WRITE(IU,9) 'LTYPGR   ',SIZE(LTYPGR   ),SHAPE(LTYPGR   )
  ALLOCATE(FREQ  (3*NXPECG,NVMODM))
  IF(LLP)WRITE(IU,9) 'FREQ     ',SIZE(FREQ     ),SHAPE(FREQ     )
ENDIF

!*       1.6   GEOMETRY - YOMGEM.

IF (LELAM) THEN
  ISMAX = NMSMAX
ELSE
  ISMAX = NSMAX
ENDIF

ALLOCATE(NLOEN  (NDGSAG:NDGENG))
IF(LLP)WRITE(IU,9) 'NLOEN    ',SIZE(NLOEN    ),SHAPE(NLOEN    )
ALLOCATE(NLOENG (NDGSAG:NDGENG))
IF(LLP)WRITE(IU,9) 'NLOENG   ',SIZE(NLOENG   ),SHAPE(NLOENG   )
ALLOCATE(NMEN   (NDGSAG:NDGENG))
IF(LLP)WRITE(IU,9) 'NMEN     ',SIZE(NMEN     ),SHAPE(NMEN     )
IF (LRETCFOU.OR.LWRTCFOU) THEN
  ALLOCATE(NMENTC (NDGSAG:NDGENG))
  IF(LLP)WRITE(IU,9) 'NMENTC   ',SIZE(NMENTC   ),SHAPE(NMENTC   )
ENDIF
ALLOCATE(NMENG  (NDGSAG:NDGENG))
IF(LLP)WRITE(IU,9) 'NMENG    ',SIZE(NMENG    ),SHAPE(NMENG    )
ALLOCATE(NDGLU  (0:ISMAX))
IF(LLP)WRITE(IU,9) 'NDGLU    ',SIZE(NDGLU    ),SHAPE(NDGLU    )
ALLOCATE(VALH   (0:MAX(JPMXLE,NFLEVG)))
IF(LLP)WRITE(IU,9) 'VALH     ',SIZE(VALH     ),SHAPE(VALH     )
ALLOCATE(VBH    (0:MAX(JPMXLE,NFLEVG)))
IF(LLP)WRITE(IU,9) 'VBH      ',SIZE(VBH      ),SHAPE(VBH      )
ALLOCATE(VETAH  (0:MAX(JPMXLE,NFLEVG)))
IF(LLP)WRITE(IU,9) 'VETAH    ',SIZE(VETAH    ),SHAPE(VETAH    )
ALLOCATE(VETAF  (0:MAX(JPMXLE,NFLEVG)+1))
IF(LLP)WRITE(IU,9) 'VETAF    ',SIZE(VETAF    ),SHAPE(VETAF    )
IF (LVERTFE) THEN
  ALLOCATE(VFE_ETAH  (0:MAX(JPMXLE,NFLEVG)))
  IF(LLP)WRITE(IU,9) 'VFE_ETAH ',SIZE(VFE_ETAH ),SHAPE(VFE_ETAH )
  ALLOCATE(VFE_ETAF  (0:MAX(JPMXLE,NFLEVG)+1))
  IF(LLP)WRITE(IU,9) 'VFE_ETAF ',SIZE(VFE_ETAF ),SHAPE(VFE_ETAF )
ENDIF
IF (LSLAG) THEN
  ALLOCATE(VCUICO (4,0:NFLEVG-1))
  IF(LLP)WRITE(IU,9) 'VCUICO   ',SIZE(VCUICO   ),SHAPE(VCUICO   )
  IF (LSLHDQUAD) THEN
    ALLOCATE(VSLD(3,0:NFLEVG-1))
    IF(LLP)WRITE(IU,9) 'VSLD     ',SIZE(VSLD     ),SHAPE(VSLD     )
  ENDIF
  IF (LSLHD) THEN
    ALLOCATE(VSLDW(3,3,0:NFLEVG-1))
    IF(LLP)WRITE(IU,9) 'VSLDW    ',SIZE(VSLDW    ),SHAPE(VSLDW    )
  ENDIF
  ALLOCATE(NVAUTF (0:NRLEVX))
  IF(LLP)WRITE(IU,9) 'NVAUTF   ',SIZE(NVAUTF   ),SHAPE(NVAUTF   )
  IF (LNHDYN.AND.LGWADV) THEN
    ALLOCATE(VCUICOH(4,0:NFLEVG))
    IF(LLP)WRITE(IU,9) 'VCUICOH  ',SIZE(VCUICOH  ),SHAPE(VCUICOH  )
    IF (LSLHDQUAD) THEN
      ALLOCATE(VSLDH(3,0:NFLEVG))
      IF(LLP)WRITE(IU,9) 'VSLDH    ',SIZE(VSLDH    ),SHAPE(VSLDH    )
    ENDIF
    IF (LSLHD) THEN
      ALLOCATE(VSLDWH(3,3,0:NFLEVG))
      IF(LLP)WRITE(IU,9) 'VSLDWH   ',SIZE(VSLDWH   ),SHAPE(VSLDWH   )
    ENDIF
    ALLOCATE(NVAUTH (0:NRLEVX))
    IF(LLP)WRITE(IU,9) 'NVAUTH   ',SIZE(NVAUTH   ),SHAPE(NVAUTH   )
  ENDIF
ENDIF

IF(LVERTFE) THEN
  ALLOCATE(VAF    (MAX(JPMXLE,NFLEVG)))
  IF(LLP)WRITE(IU,9) 'VAF      ',SIZE(VAF      ),SHAPE(VAF      )
  ALLOCATE(VBF    (MAX(JPMXLE,NFLEVG)))
  IF(LLP)WRITE(IU,9) 'VBF      ',SIZE(VBF      ),SHAPE(VBF      )
  ALLOCATE(VDELA  (MAX(JPMXLE,NFLEVG)))
  IF(LLP)WRITE(IU,9) 'VDELA    ',SIZE(VDELA    ),SHAPE(VDELA    )
  ALLOCATE(VFE_RDETAH (MAX(JPMXLE,NFLEVG)))
  IF(LLP)WRITE(IU,9) 'VFE_RDETAH',SIZE(VFE_RDETAH),SHAPE(VFE_RDETAH)
  IF(NVSCH == 1) THEN
    ALLOCATE(RINTE (NFLEVG+1,NFLEVG))
    IF(LLP)WRITE(IU,9) 'RINTE    ',SIZE(RINTE    ),SHAPE(RINTE  )
    IF (LNHDYN) THEN
      ALLOCATE(RDDERI (NFLEVG,NFLEVG))
      IF(LLP)WRITE(IU,9) 'RDDERI   ',SIZE(RDDERI    ),SHAPE(RDDERI )
    ENDIF
  ELSEIF(NVSCH == 3) THEN
    ALLOCATE(RINTE (NFLEVG+3,NFLEVG+3))
    IF(LLP)WRITE(IU,9) 'RINTE    ',SIZE(RINTE    ),SHAPE(RINTE )
    ALLOCATE(RDERI (NFLEVG,NFLEVG))
    IF(LLP)WRITE(IU,9) 'RDERI    ',SIZE(RDERI    ),SHAPE(RDERI )
    IF (LNHDYN) THEN
      ALLOCATE(RDERB (NFLEVG,NFLEVG+2))
      IF(LLP)WRITE(IU,9) 'RDERB    ',SIZE(RDERB    ),SHAPE(RDERB )
      ALLOCATE(RDDERI (NFLEVG,NFLEVG))
      IF(LLP)WRITE(IU,9) 'RDDERI   ',SIZE(RDDERI    ),SHAPE(RDDERI )
    ENDIF
  ELSE
    CALL ABOR1(' INVALID VALUE OF NVSCH')
  ENDIF
ENDIF

IF(LVSPLIP) THEN
  ALLOCATE(VRDETAR(NFLEVG))
  IF(LLP)WRITE(IU,9) 'VRDETAR ',SIZE(VRDETAR ),SHAPE(VRDETAR )
  WRITE(IU,*) ' in suallo: VRDETAR ',SIZE(VRDETAR ),SHAPE(VRDETAR )
  ALLOCATE(RVSPTRI (NFLEVG,-1:1))
  IF(LLP)WRITE(IU,9) 'RVSPTRI   ',SIZE(RVSPTRI   ),SHAPE(RVSPTRI   )
  WRITE(IU,*) ' in suallo: RVSPTRI   ',SIZE(RVSPTRI   ),SHAPE(RVSPTRI   )
  ALLOCATE(RVSPC (10))
  IF(LLP)WRITE(IU,9) 'RVSPC   ',SIZE(RVSPC   ),SHAPE(RVSPC   )
  WRITE(IU,*) ' in suallo: RVSPC   ',SIZE(RVSPC   ),SHAPE(RVSPC   )
  ALLOCATE(RFAA (4,-1:NFLEVG+2))
  IF(LLP)WRITE(IU,9) 'RFAA   ',SIZE(RFAA   ),SHAPE(RFAA   )
  WRITE(IU,*) ' in suallo: RFAA   ',SIZE(RFAA   ),SHAPE(RFAA   )
  ALLOCATE(RFBB (4,-1:NFLEVG+2))
  IF(LLP)WRITE(IU,9) 'RFBB   ',SIZE(RFBB   ),SHAPE(RFBB   )
  WRITE(IU,*) ' in suallo: RFBB   ',SIZE(RFBB   ),SHAPE(RFBB   )
  ALLOCATE(RFCC (4,-1:NFLEVG+2))
  IF(LLP)WRITE(IU,9) 'RFCC   ',SIZE(RFCC   ),SHAPE(RFCC   )
  WRITE(IU,*) ' in suallo: RFCC   ',SIZE(RFCC   ),SHAPE(RFCC   )
  ALLOCATE(RFDD (4,-1:NFLEVG+2))
  IF(LLP)WRITE(IU,9) 'RFDD   ',SIZE(RFDD   ),SHAPE(RFDD   )
  WRITE(IU,*) ' in suallo: RFDD   ',SIZE(RFDD   ),SHAPE(RFDD   )
ENDIF

ALLOCATE(VAH    (0:MAX(JPMXLE,NFLEVG)))
IF(LLP)WRITE(IU,9) 'VAH      ',SIZE(VAH      ),SHAPE(VAH      )
ALLOCATE(VC     (MAX(JPMXLE,NFLEVG)))
IF(LLP)WRITE(IU,9) 'VC       ',SIZE(VC       ),SHAPE(VC       )
ALLOCATE(VDELB  (MAX(JPMXLE,NFLEVG)))
IF(LLP)WRITE(IU,9) 'VDELB    ',SIZE(VDELB    ),SHAPE(VDELB    )

!*       1.9   DYNAMICS

CALL SUALDYN

!*       1.10  STANDARD ATMOSPHERE.

ALLOCATE(STPREH(0:NFLEVG))
IF(LLP)WRITE(IU,9) 'STPREH   ',SIZE(STPREH),SHAPE(STPREH)
ALLOCATE(STPRE(NFLEVG))
IF(LLP)WRITE(IU,9) 'STPRE    ',SIZE(STPRE),SHAPE(STPRE)
ALLOCATE(STPHI(NFLEVG))
IF(LLP)WRITE(IU,9) 'STPHI    ',SIZE(STPHI),SHAPE(STPHI)
ALLOCATE(STTEM(NFLEVG))
IF(LLP)WRITE(IU,9) 'STTEM    ',SIZE(STTEM),SHAPE(STTEM)
ALLOCATE(STDEN(NFLEVG))
IF(LLP)WRITE(IU,9) 'STDEN    ',SIZE(STDEN),SHAPE(STDEN)
ALLOCATE(STZ  (NFLEVG))
IF(LLP)WRITE(IU,9) 'STZ      ',SIZE(STZ),SHAPE(STZ)

!*       1.11  GRIB CODING COMMON.

ALLOCATE(NSEC2GG(22+NDGLG))
IF(LLP)WRITE(IU,9) 'NSEC2GG  ',SIZE(NSEC2GG),SHAPE(NSEC2GG)
ALLOCATE(RSEC2  (10+2*(NFLEVG+1)))
IF(LLP)WRITE(IU,9) 'RSEC2    ',SIZE(RSEC2),SHAPE(RSEC2)

!*       1.13  SCAN 2

ALLOCATE(NDIST  (NDGSAG:NDGENG))
IF(LLP)WRITE(IU,9) 'NDIST    ',SIZE(NDIST),SHAPE(NDIST)
ALLOCATE(NDIEND (NDGSAG:NDGENG))
IF(LLP)WRITE(IU,9) 'NDIEND   ',SIZE(NDIEND),SHAPE(NDIEND)
ALLOCATE(NCIST  (NDGSAG:NDGENG))
IF(LLP)WRITE(IU,9) 'NCIST    ',SIZE(NCIST),SHAPE(NCIST)
ALLOCATE(NCIEND (NDGSAG:NDGENG))
IF(LLP)WRITE(IU,9) 'NCIEND   ',SIZE(NCIEND),SHAPE(NCIEND)

IF(.NOT.LNOINI) THEN
  ALLOCATE(NSTASPHB(NVMODM*(NXMAX+1)))
  IF(LLP)WRITE(IU,9) 'NSTASPHB ',SIZE(NSTASPHB),SHAPE(NSTASPHB)
  ALLOCATE(NSTAHOUB(NVMODM*(NXMAX+1)))
  IF(LLP)WRITE(IU,9) 'NSTAHOUB ',SIZE(NSTAHOUB),SHAPE(NSTAHOUB)
ENDIF
IF(.NOT.LNOINI.AND.LRPIMP) THEN
  ALLOCATE(NSTAPINB(5+2*NVMODM))
  IF(LLP)WRITE(IU,9) 'NSTAPINB ',SIZE(NSTAPINB),SHAPE(NSTAPINB)
ENDIF

!*       1.14  MASK DIAGNOSTICS (DDH)

!fw   CALL SUALMDH

!*       1.16  PHYSICS

IF (LRRMES.AND..NOT.LAGPHY) THEN
  ALLOCATE(RMESOU(NFLEVG))
  IF(LLP)WRITE(IU,9) 'RMESOU   ',SIZE(RMESOU),SHAPE(RMESOU)
  ALLOCATE(RMESOT(NFLEVG))
  IF(LLP)WRITE(IU,9) 'RMESOT   ',SIZE(RMESOT),SHAPE(RMESOT)
  ALLOCATE(RMESOQ(NFLEVG))
  IF(LLP)WRITE(IU,9) 'RMESOQ   ',SIZE(RMESOQ),SHAPE(RMESOQ)
ENDIF


!*       1.18  EC PHYSICS CONSTANTS.

ALLOCATE(CETA(NFLEVG))
IF(LLP)WRITE(IU,9) 'CETA     ',SIZE(CETA),SHAPE(CETA)
ALLOCATE(CVDAES(NFLEVG+1))
IF(LLP)WRITE(IU,9) 'CVDAES   ',SIZE(CVDAES),SHAPE(CVDAES)
ALLOCATE(CVDAEL(NFLEVG+1))
IF(LLP)WRITE(IU,9) 'CVDAEL   ',SIZE(CVDAEL),SHAPE(CVDAEL)
ALLOCATE(CVDAEU(NFLEVG+1))
IF(LLP)WRITE(IU,9) 'CVDAEU   ',SIZE(CVDAEU),SHAPE(CVDAEU)
ALLOCATE(CVDAED(NFLEVG+1))
IF(LLP)WRITE(IU,9) 'CVDAED   ',SIZE(CVDAED),SHAPE(CVDAED)
ALLOCATE(CVDAES15(NFLEVG+1))
IF(LLP)WRITE(IU,9) 'CVDAES15 ',SIZE(CVDAES15),SHAPE(CVDAES15)
ALLOCATE(CVDAEL15(NFLEVG+1))
IF(LLP)WRITE(IU,9) 'CVDAEL15 ',SIZE(CVDAEL15),SHAPE(CVDAEL15)
ALLOCATE(CVDAEU15(NFLEVG+1))
IF(LLP)WRITE(IU,9) 'CVDAEU15 ',SIZE(CVDAEU15),SHAPE(CVDAEU15)
ALLOCATE(CVDAED15(NFLEVG+1))
IF(LLP)WRITE(IU,9) 'CVDAED15 ',SIZE(CVDAED15),SHAPE(CVDAED15)
ALLOCATE(CVDAEF15(NFLEVG+1))
IF(LLP)WRITE(IU,9) 'CVDAEF15 ',SIZE(CVDAEF15),SHAPE(CVDAEF15)
ALLOCATE(RA1OVLP(NFLEVG))
IF(LLP)WRITE(IU,9) 'RA1OVLP  ',SIZE(RA1OVLP),SHAPE(RA1OVLP)

!*       1.20  CLIMATOLOGICAL PHYSICS FIELDS

IF (LECMWF) THEN
  IF(NVCLIS*NTOZ3D > 0) THEN
    ALLOCATE(TOZ3DBG(0:NDLSM,NFLEVG*NVCLIS*NTOZ3D,NDGSAG:NDGENG))
    IF(LLP)WRITE(IU,9) 'TOZ3DBG  ',SIZE(TOZ3DBG),SHAPE(TOZ3DBG)
  ENDIF
  IF(NVCLIS*NTOZ2D > 0) THEN
    ALLOCATE(TOZ2DG(NFLEVG*NVCLIS*NTOZ2D,NDGSAG:NDGENG))
    IF(LLP)WRITE(IU,9) 'TOZ2DG   ',SIZE(TOZ2DG),SHAPE(TOZ2DG)
  ENDIF
  IF(NVCLIS*NTOZ1D > 0) THEN
    ALLOCATE(TOZ1D(NFLEVG*NVCLIS*NTOZ1D))
    IF(LLP)WRITE(IU,9) 'TOZ1D    ',SIZE(TOZ1D),SHAPE(TOZ1D)
  ENDIF

  IF(NTSSG > 0) THEN
    ALLOCATE(TSSGB(0:NDLSM,NTSSG,NDGSAG:NDGENG))
    IF(LLP)WRITE(IU,9) 'TSSGB    ',SIZE(TSSGB),SHAPE(TSSGB)
  ENDIF
ENDIF

!*       1.22  NUDGING (SPECTRAL FIELDS + TIME WEIGHTS)

IF(LNUDG) THEN
  IFLEV=NFLEVL
  ALLOCATE(XPNUDG(NFNUDG))
  IF(LLP)WRITE(IU,9) 'XPNUDG   ',SIZE(XPNUDG),SHAPE(XPNUDG)
  IF(LNUDTE) THEN
    ALLOCATE(TNUDTE(NSPEC2G,IFLEV,NFNUDG))
    IF(LLP)WRITE(IU,9) 'TNUDTE   ',SIZE(TNUDTE),SHAPE(TNUDTE)
  ENDIF
  IF(LNUDSH) THEN
    ALLOCATE(TNUDSH(NSPEC2G,IFLEV,NFNUDG))
    IF(LLP)WRITE(IU,9) 'TNUDSH   ',SIZE(TNUDSH),SHAPE(TNUDSH)
  ENDIF
  IF(LNUDDI) THEN
    ALLOCATE(TNUDDI(NSPEC2G,IFLEV,NFNUDG))
    IF(LLP)WRITE(IU,9) 'TNUDDI   ',SIZE(TNUDDI),SHAPE(TNUDDI)
  ENDIF
  IF(LNUDVO) THEN
    ALLOCATE(TNUDVO(NSPEC2G,IFLEV,NFNUDG))
    IF(LLP)WRITE(IU,9) 'TNUDVO   ',SIZE(TNUDVO),SHAPE(TNUDVO)
  ENDIF
  ! === obsolescent =============================================
  IF(LNUDSV) THEN
    ALLOCATE(TNUDSV(NSPEC2G,IFLEV,NGFL_EXT,NFNUDG))
    IF(LLP)WRITE(IU,9) 'TNUDSV   ',SIZE(TNUDSV),SHAPE(TNUDSV)
  ENDIF
  ! (TNUDSH+TNUDSV) have to be replaced by TNUDGFL in the future.
  ! =============================================================
  IF(LNUDLP) THEN
    ALLOCATE(TNUDLP(NSPEC2G,NFNUDG))
    IF(LLP)WRITE(IU,9) 'TNUDLP   ',SIZE(TNUDLP),SHAPE(TNUDLP)
  ENDIF
ENDIF

!     ------------------------------------------------------------------

!*       2.    ALLOCATE SPACE FOR ANALYSIS JOBS: CONT. VAR., COST FUNCTION,
!              ------------------------------------------------------------
!              OBSERVATIONS,GUESS.
!              -------------------


! Initialise lock of OpenMP
CALL OML_INIT_LOCK()

!     ------------------------------------------------------------------
9 FORMAT(1X,'ARRAY ',A10,' ALLOCATED ',8I8)

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SUALLO',1,ZHOOK_HANDLE)
END SUBROUTINE SUALLO
