SUBROUTINE SUALMP0

!**** *SUALMP0 * - Routine to allocate space for some distributed memory arrays

!     Purpose.
!     --------
!           Allocate space for some of the distributed memory control arrays
!           that are required in the initial part of the distributed memory
!           setup

!**   Interface.
!     ----------
!        *CALL* *SUALMP0*

!     Explicit arguments :  None
!     --------------------

!     Implicit arguments :
!     --------------------

!     Method.
!     -------
!     Externals.
!     ----------

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     Author.
!     -------
!        MPP Group *ECMWF*

!     Modifications.
!     --------------
!        Original : 95-10-01
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      01-Dec-2003 CY28R1 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCT0   , ONLY : NPROC    ,NPRTRV
USE YOMMP    , ONLY : NPRCIDS  ,NUMLL    ,NPSURF

IMPLICIT NONE

REAL(KIND=JPRB) :: ZHOOK_HANDLE
!     ------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('SUALMP0',0,ZHOOK_HANDLE)
ALLOCATE(NUMLL(NPRTRV+1))
ALLOCATE(NPSURF(NPRTRV))
ALLOCATE(NPRCIDS(NPROC))

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SUALMP0',1,ZHOOK_HANDLE)
END SUBROUTINE SUALMP0
