SUBROUTINE SUCMAD1

!**** SUBROUTINE SUCMAD1 - CMA FIRST DDR FORMAT

!        D. VASILJEVIC     ECMWF    30/08/1994

!**   PURPOSE
!     -------

!        SET CMA FIRST DDR FORMAT

!**   INTERFACE
!     ---------

!        CALL SUCMAD1

!        SUCMAD1 IS CALLED BY SUCMAF

!**   METHOD
!     ------

!        CMA FIRST DDR FORMAT IS SET.

!**   EXTERNALS
!     ---------

!        SUCMAD1P - CMA FIRST DDR PACKED INFO.

!**   MODIFICATIONS
!     -------------

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE PARCMA   , ONLY : JPMXOTP
USE YOMCMDDR , ONLY : NLENCD1  ,NLEND1I  ,NLEND1R  ,NLEND1C  ,&
 & NCD1LN   ,NCD1NIS  ,NCD1TF   ,NCD1TS   ,NCD1IL   ,&
 & NCD1LFS  ,NCD1LSS  ,NCD1NL   ,NCD1CT   ,NCD1CD   ,&
 & NCD1OT   ,NCD1OD   ,NCD1NS   ,NCD1OP   ,NCD1NPU  ,&
 & NCD1NUP  ,NCD1AD   ,NCD1ND   ,NCD1DR   ,NCD1LD   ,&
 & NCD1MR   ,NCD1RM   ,NCD1NF   ,NCD1SQ   ,NCD1TM   ,&
 & NCD1MOT  ,NCD1TO   ,NCD1NSY  ,NCD1NAI  ,NCD1NSA  ,&
 & NCD1NDB  ,NCD1NTE  ,NCD1NPI  ,NCD1NSM  ,NCD1NT   ,&
 & NCD1NPA  ,NCD1SC   ,NCD1NLM  ,NCD1NSSM ,NCD1NAT  ,&
 & NCD1NRO3 ,NCD1AL   ,NCD1TVA  ,NCD1CON  ,NCD1NST  ,&
 & NCD1NC   ,NCD1BLB  ,NCD11DL  ,NCD11DV  ,NCD11DS  ,&
 & NCD1MPF  ,NCD1MSV  ,NCD1MLV  ,NCD1MUV  ,NCD1NBS  ,&
 & NCD11BSD ,NCD11BST ,NCD12BSD ,NCD12BST ,NCD13BSD ,&
 & NCD13BST ,NCD14BSD ,NCD14BST ,NCD15BSD ,NCD15BST ,&
 & NCD11DLS ,NCD11DVS ,NCD11DSS ,NCD11DLA ,NCD11DVA ,&
 & NCD11DSA ,NCD1SOH  ,NCD1PV1  ,NCD1PV2  ,NCD1PV3  ,&
 & NCD1PV4  ,NCD1PV5  ,NCD1PV6  ,NCD1PV7  ,NCD1PV8  ,&
 & NCD1EN1  ,NCD1EN2  ,NCD1EN3  ,NCD1EN4  ,NCD1EN5  ,&
 & NCD1EN6  ,NCD1EN7  ,NCD1EN8  ,NCD1EN9  ,NCD1EN10 ,&
 & NCD1EN11 ,NCD1EN12 ,NCD1EN13 ,NCD1EN14 ,NCD1EN15 ,&
 & NCD1EN16 ,&
 & NCD1NRAD ,NCD1VAT  ,NTSL_STEPSIZE,NCD1TSL_WORDS,&
 & NCD1TSL_INIT_DATE,NCD1TSL_INIT_TIME,&
 & NCD1TSL_BACKWARD_TIME,NCD1TSL_FORWARD_TIME,&
 & NCD1TSL_TIME_DELTA,NCD1TSL_NUMSLOTS,&
 & NCD1TSL_TIMESLOT_NO,NCD1TSL_END_DATE,NCD1TSL_END_TIME,&
 & NCD1TSL_DATALEN,NCD1TSL_NOBS,NCD1TSL_WEIGHT,&
 & NCD1TSL_NWLAT,NCD1TSL_NWLON,NCD1TSL_SELAT,&
 & NCD1TSL_SELON,NCD1TSL_OBSTYPE1,NCD1TSL_OBSTYPE2,&
 & NCD1TSL_OBSTYPE3,NCD1TSL_OBSTYPE4,NCD1TSL_OBSTYPE5,&
 & NCD1TSL_OBSTYPE6,NCD1TSL_OBSTYPE7,NCD1TSL_OBSTYPE8,&
 & NCD1TSL_OBSTYPE9,NCD1TSL_OBSTYPE10  

IMPLICIT NONE

INTEGER(KIND=JPIM) :: IOFF
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "sucmad1p.intfb.h"

!*

!        1.       FIRST CMA DDR FORMAT (INTEGER SECTION)
!                 --------------------------------------

IF (LHOOK) CALL DR_HOOK('SUCMAD1',0,ZHOOK_HANDLE)
NLENCD1 = 3072
NLEND1I = 1024

!*          1.1   FIRST DDR LEN.

NCD1LN  =  1

!*          1.2   NO. OF NON INTEGER SECTIONS

NCD1NIS =  2

!*          1.3   TYPE OF FIRST NON INTEGER SECTION

NCD1TF  =  3

!*          1.4   TYPE OF SECOND NON INTEGER SECTION

NCD1TS  =  4

!*          1.5   LEN. OF INTEGER SECTION

NCD1IL  =  5

!*          1.6   LEN. OF FIRST NON INTEGER SECTION

NCD1LFS =  6

!*          1.7   LEN. OF SECOND NON INTEGER SECTION

NCD1LSS =  7

!*          1.8   LEN. OF NEXT DDR

NCD1NL  =  8

!*          1.9   CREATION TIME

NCD1CT  =  9

!*          1.10  CREATION DATE

NCD1CD  = 10

!*          1.11  TIME OF THE MIDDLE OF OBS. PERIOD

NCD1OT  = 11

!*          1.12  DATE OF THE MIDDLE OF OBS. PERIOD

NCD1OD  = 12

!*          1.13  NO. OF SEC. PER TIME UNIT

NCD1NS  = 13

!*          1.14  LEN. OF OBS. PERIOD IN TIME UNITS

NCD1OP  = 14

!*          1.15  NO. OF PLANNED UPDATES

NCD1NPU = 15

!*          1.16  NO. OF PERFORMED UPDATES

NCD1NUP = 16

!*          1.17  NO. OF ADDITIONAL DEPARTURES

NCD1AD  = 17

!*          1.18  NO. OF DDRS

NCD1ND  = 18

!*          1.19  NO. OF DATA RECORDS

NCD1DR  = 19

!*          1.20  MAX. LEN. OF DDR

NCD1LD  = 20

!*          1.21  MAX. LEN. OF DATA REC.

NCD1MR  = 21

!*          1.22  MAX. LEN. OF CMA REPORT

NCD1RM  = 22

!*          1.23  TOTAL NO. OF CMA FILES

NCD1NF  = 23

!*          1.24  CMA FILE SQ. NO.

NCD1SQ  = 24

!*          1.25  NO. OF TIME SLOTS

NCD1TM  = 25

!*          1.26  MAX. NO. OF OBS. TYPES

NCD1MOT = 26

!*          1.27  TOTAL NO. OF OBS.

NCD1TO  = 27

!*          1.28  NO. OF SYNOP OBS.

NCD1NSY = 28

!*          1.29  NO. OF AIREP OBS.

NCD1NAI = 29

!*          1.30  NO. OF SATOB OBS.

NCD1NSA = 30

!*          1.31  NO. OF DRIBU OBS.

NCD1NDB = 31

!*          1.32  NO. OF TEMP OBS.

NCD1NTE = 32

!*          1.33  NO. OF PILOT OBS.

NCD1NPI = 33

!*          1.34  NO. OF SATEM (NON-RADIANCE) OBS.

NCD1NSM = 34

!*          1.35  NO. OF SATEM (TOVS RADIANCE) OBS.

NCD1NT  = 35

!*          1.36  NO. OF PAOB OBS.

NCD1NPA = 36

!*          1.37  NO. OF SCATT. OBS.

NCD1SC  = 37

!*          1.38  NO. OF LIMB OBS.

NCD1NLM = 38

!*          1.39  NO. OF SATEM (SSMI/TRMM) OBS.

NCD1NSSM= 39

!*          1.40  NO. OF SATEM (LEVEL-1C/GEOS RADIANCE) OBS.

NCD1NAT = 40

!*          1.41  NO. OF SATEM (RETRIEVED OZONE LAYERS) OBS.

NCD1NRO3= 41

!*          1.42  NO. OF RADAR REFL.

NCD1NRAD= 42

!*          1.43  43-50 RESERVED

!*          1.51  TOTAL LENGTH OF CMA

NCD1AL  = 51

!*          1.52  TYPE OF VAR. ANAL.

NCD1TVA = 52

!*          1.53  IFS CONF. NO.

NCD1CON = 53

!*          1.54  IFS NO. OF TIME STEPS

NCD1NST = 54

!*          1.55  BASIC LEN. OF REP. HEADER

NCD1NC  = 55

!*          1.56  BASIC LEN. OF REP. BODY ENTRY

NCD1BLB = 56

!*          1.57  NO. OF 1D (TOVS) VAR RETREIVED LEVELS

NCD11DL = 57

!*          1.58  NO. OF 1D (TOVS) VAR UPPER AIR RETREIVED VARIABLES

NCD11DV = 58

!*          1.59  NO. OF 1D VAR (TOVS) SINGLE LEVEL RETREIVED VARIABLES

NCD11DS = 59

!*          1.60  MODEL PROFILE IND.

NCD1MPF = 60

!*          1.61  NO. OF MODEL SURFACE VARIABLES

NCD1MSV = 61

!*          1.62  NO. OF MODEL LEVELS

NCD1MLV = 62

!*          1.63  NO. OF MODEL UPPERAIR VARIABLES

NCD1MUV = 63

!*          1.64  64 NO. OF BUFR INPUT 6HR TIME SLOTS

NCD1NBS = 64

!*          1.65  65-74 BUFR TIME SLOT DATES AND TIMES

NCD11BSD= 65
NCD11BST= 66
NCD12BSD= 67
NCD12BST= 68
NCD13BSD= 69
NCD13BST= 70
NCD14BSD= 71
NCD14BST= 72
NCD15BSD= 73
NCD15BST= 74

!*          1.75  NO. OF 1D (SSMI/TRMM) VAR RETREIVED LEVELS

NCD11DLS= 75

!*          1.76  NO. OF 1D (SSMI/TRMM) VAR UPPER AIR RETREIVED
!                 VARIABLES

NCD11DVS= 76

!*          1.77  NO. OF 1D VAR (SSMI/TRMM) SINGLE LEVEL RETREIVED
!                 VARIABLES

NCD11DSS= 77

!*          1.78  NO. OF 1D (LEVEL-1C/GEOS) VAR RETREIVED LEVELS

NCD11DLA= 78

!*          1.79  NO. OF 1D (LEVEL-1C/GEOS) VAR UPPER AIR RETREIVED
!                 VARIABLES

NCD11DVA= 79

!*          1.80  NO. OF 1D VAR (LEVEL-1C/GEOS) SINGLE LEVEL RETREIVED
!                 VARIABLES

NCD11DSA= 80

!*          1.81  TOVS/SSMI/TRMM/LEVEL-1C/GEOS EXTENDED OPTIONAL HEADER
!                 PRESENCE IND.

NCD1SOH = 81

!*          1.82  82-100 NOT DEFINED

!*          1.101  TIMESLOT INFORMATION WORDS
!                  Totally : 7 + JPXTSL * (4 + MAX NO. OF OBSTYPES)
!                  - JPXTSL = 25 (defined in "parcma.h")
!                  - MAX NO. OF OBSTYPES = 10

!     See also OBSORT's "update_ddr.F" on how to use the NTSL_STEPSIZE 
!     (or NCD1TSL_WORDS) properly

NTSL_STEPSIZE         = 10 + JPMXOTP ! NO. OF WORDS PER TIMESLOT
NCD1TSL_NUMSLOTS      = 101 ! NO. OF TIMESLOT INFORMATION PRESENT
NCD1TSL_WORDS         = 102 ! ACTUAL NO. OF WORDS PER TIMESLOT
NCD1TSL_INIT_DATE     = 103 ! START DATE OF THE WHOLE ASSIMILATION PERIOD
NCD1TSL_INIT_TIME     = 104 ! START TIME OF THE WHOLE ASSIMILATION PERIOD
NCD1TSL_BACKWARD_TIME = 105 ! BACKWARD TIME (ASSIM. START TO ANALYSIS TIME)
NCD1TSL_FORWARD_TIME  = 106 ! FORWARD TIME (ANALYSIS TO ASSIM. END TIME)
NCD1TSL_TIME_DELTA    = 107 ! NOMINAL DELTA TIME OF EACH TIMESLOT
NCD1TSL_TIMESLOT_NO   = 108 ! THE TIMESLOT NUMBER IN CONCERN
NCD1TSL_END_DATE      = 109 ! END DATE OF THE TIMESLOT NO. 1
NCD1TSL_END_TIME      = 110 ! END TIME OF THE TIMESLOT NO. 1
NCD1TSL_DATALEN       = 111 ! CMA LENGTH OF THE TIMESLOT NO. 1
NCD1TSL_NOBS          = 112 ! NO. OF OBS. IN THE TIMESLOT NO. 1
NCD1TSL_WEIGHT        = 113 ! APPROX. OBS. WEIGHT FOR PART. IN THE TIMESLOT NO. 1
NCD1TSL_NWLAT         = 114 ! NORTH-WEST MILLILAT. OF THE PART. IN THE TIMESLOT NO. 1
NCD1TSL_NWLON         = 115 ! NORTH-WEST MILLILON. OF THE PART. IN THE TIMESLOT NO. 1
NCD1TSL_SELAT         = 116 ! SOUTH-EAST MILLILAT. OF THE PART. IN THE TIMESLOT NO. 1
NCD1TSL_SELON         = 117 ! SOUTH-EAST MILLILON. OF THE PART. IN THE TIMESLOT NO. 1
NCD1TSL_OBSTYPE1      = 118 ! NO. OF OBS. OF THE TYPE#1 IN THE TIMESLOT NO. 1
NCD1TSL_OBSTYPE2      = 119 ! NO. OF OBS. OF THE TYPE#2 IN THE TIMESLOT NO. 1
NCD1TSL_OBSTYPE3      = 120 ! NO. OF OBS. OF THE TYPE#3 IN THE TIMESLOT NO. 1
NCD1TSL_OBSTYPE4      = 121 ! NO. OF OBS. OF THE TYPE#4 IN THE TIMESLOT NO. 1
NCD1TSL_OBSTYPE5      = 122 ! NO. OF OBS. OF THE TYPE#5 IN THE TIMESLOT NO. 1
NCD1TSL_OBSTYPE6      = 123 ! NO. OF OBS. OF THE TYPE#6 IN THE TIMESLOT NO. 1
NCD1TSL_OBSTYPE7      = 124 ! NO. OF OBS. OF THE TYPE#7 IN THE TIMESLOT NO. 1
NCD1TSL_OBSTYPE8      = 125 ! NO. OF OBS. OF THE TYPE#8 IN THE TIMESLOT NO. 1
NCD1TSL_OBSTYPE9      = 126 ! NO. OF OBS. OF THE TYPE#9 IN THE TIMESLOT NO. 1
NCD1TSL_OBSTYPE10     = 127 ! NO. OF OBS. OF THE TYPE#10 IN THE TIMESLOT NO. 1

!*          1.608  608-1024 NOT DEFINED

!*
!-----------------------------------------------------------------------

!        2.       FIRST CMA DDR FORMAT (CHARACTER SECTION)
!                 ----------------------------------------

NLEND1C = 1024

!*          2.1   PRE-PROCESSOR VERSION

!*          2.1.1 PRE-PROCESSOR VERSION NO. (CHARACTER 1)

NCD1PV1 =  1

!*          2.1.2 PRE-PROCESSOR VERSION NO. (CHARACTER 2)

NCD1PV2 =  2

!*          2.1.3 PRE-PROCESSOR VERSION NO. (CHARACTER 3)

NCD1PV3 =  3

!*          2.1.4 PRE-PROCESSOR VERSION NO. (CHARACTER 4)

NCD1PV4 =  4

!*          2.1.5 PRE-PROCESSOR VERSION NO. (CHARACTER 5)

NCD1PV5 =  5

!*          2.1.6 PRE-PROCESSOR VERSION NO. (CHARACTER 6)

NCD1PV6 =  6

!*          2.1.7 PRE-PROCESSOR VERSION NO. (CHARACTER 7)

NCD1PV7 =  7

!*          2.1.8 PRE-PROCESSOR VERSION NO. (CHARACTER 8)

NCD1PV8 =  8

!*          2.2   EXPERIMENT NAME

IOFF    = NCD1PV8

!*          2.2.1 EXPERIMENT NAME

NCD1EN1 =  IOFF +  1

!*          2.2.2 EXPERIMENT NAME

NCD1EN2 = IOFF +   2

!*          2.2.3 EXPERIMENT NAME

NCD1EN3 = IOFF +   3

!*          2.2.4 EXPERIMENT NAME

NCD1EN4 = IOFF +   4

!*          2.2.5 EXPERIMENT NAME

NCD1EN5 = IOFF +   5

!*          2.2.6 EXPERIMENT NAME

NCD1EN6 = IOFF +   6

!*          2.2.7 EXPERIMENT NAME

NCD1EN7 = IOFF +   7

!*          2.2.8 EXPERIMENT NAME

NCD1EN8 = IOFF +   8

!*          2.2.9 EXPERIMENT NAME

NCD1EN9 = IOFF +   9

!*          2.2.10EXPERIMENT NAME

NCD1EN10= IOFF +  10

!*          2.2.11EXPERIMENT NAME

NCD1EN11= IOFF +  11

!*          2.2.12EXPERIMENT NAME

NCD1EN12= IOFF +  12

!*          2.2.13EXPERIMENT NAME

NCD1EN13= IOFF +  13

!*          2.2.14EXPERIMENT NAME

NCD1EN14= IOFF +  14

!*          2.2.15EXPERIMENT NAME

NCD1EN15= IOFF +  15

!*          2.2.16EXPERIMENT NAME

NCD1EN16= IOFF +  16

!*          2.3   VARIATIONAL JOB TYPE

IOFF    = NCD1EN16
NCD1VAT = IOFF +   1

!*          2.4   26-1024 NOT DEFINED

!*
!-----------------------------------------------------------------------

!        3.       FIRST CMA DDR FORMAT (REAL SECTION)
!                 -----------------------------------

NLEND1R = 1024

!*          3.1   1-1024 NOT DEFINED

!*
!-----------------------------------------------------------------------

!        4.       PACKED INFO. FORMAT
!                 -------------------

CALL SUCMAD1P
!*
!-----------------------------------------------------------------------

!        5.       RETURN
!                 ------

IF (LHOOK) CALL DR_HOOK('SUCMAD1',1,ZHOOK_HANDLE)
END SUBROUTINE SUCMAD1
