SUBROUTINE SUCMAD1P

!**** SUBROUTINE SUCMAD1P - CMA FIRST DDR PACKED INFO. FORMAT

!        D. VASILJEVIC     ECMWF    30/08/1994

!**   PURPOSE
!     -------

!        SET CMA FIRST DDR PACKED INFO. FORMAT

!**   INTERFACE
!     ---------

!        CALL SUCMAD1P

!        SUCMAD1P IS CALLED BY SUCMAD1

!**   METHOD
!     ------

!        CMA FIRST DDR PACKED INFO. FORMAT IS SET.

!**   EXTERNALS
!     ---------

!        NONE

!**   MODIFICATIONS
!     -------------
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      01-Dec-2003 CY28R1 Cleaning

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCMDDR , ONLY : NCMD1HO  ,NCMD1MIO ,NCMD1SO  ,NCMD1YO  ,&
 & NCMD1MOO ,NCMD1DO  

IMPLICIT NONE
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!     ------------------------------------------------------------------
!*

!        1.       CREATION TIME AND TIME OF THE MIDDLE OF OBS.
!                 --------------------------------------------
!                 PERIOD
!                 ------
!                 FORMAT: hhmmss 
!                 hh - hour
!                 mm - minute
!                 ss - seconde

!*          1.1   HOUR OFFSET

IF (LHOOK) CALL DR_HOOK('SUCMAD1P',0,ZHOOK_HANDLE)
NCMD1HO =  10**4

!*          1.2   MINUTE OFFSET

NCMD1MIO=  10**2

!*          1.3   SECONDE OFFSET

NCMD1SO =  10**0
!*
!-----------------------------------------------------------------------

!        2.       CREATION DATE AND DATE OF MIDDLE OF OBS. PERIOD
!                 -----------------------------------------------
!                 FORMAT: YYYYMMDD
!                 YYYY - YEAR
!                 MM   - MONTH
!                 DD   - DAY

!*          2.1   YEAR OFFSET

NCMD1YO = 10**4

!*          2.2   MONTH OFFSET

NCMD1MOO= 10**2

!*          2.3   DAY OFFSET

NCMD1DO = 10**0
!*
!-----------------------------------------------------------------------

!        3.       RETURN
!                 ------

IF (LHOOK) CALL DR_HOOK('SUCMAD1P',1,ZHOOK_HANDLE)
END SUBROUTINE SUCMAD1P
