SUBROUTINE SUCMAD2

!**** SUBROUTINE SUCMAD2 - CMA SECOND DDR FORMAT

!        D. VASILJEVIC     ECMWF    30/08/1994

!**   PURPOSE
!     -------

!        SET CMA SECOND DDR FORMAT

!**   INTERFACE
!     ---------

!        CALL SUCMAD2

!        SUCMAD2 IS CALLED BY SUCMAD2

!**   METHOD
!     ------

!        CMA SECOND DDR FORMAT IS SET.

!**   EXTERNALS
!     ---------


!**   MODIFICATIONS
!     -------------
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      01-Dec-2003 CY28R1 Cleaning

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCMDDR , ONLY : NLENCD2  ,NLEND2I  ,NLEND2R  ,NLEND2C  ,&
 & NCD2LN   ,NCD2NI   ,NCD2T1   ,NCD2T2   ,NCD2IL   ,&
 & NCD2LFS  ,NCD2LSS  ,NCD2LND  ,NCD2TL   ,NCD2TY   ,&
 & NCD2TM   ,NCD2SAI1 ,NCD2SAT1 ,NCD2SAI2 ,NCD2SAT2 ,&
 & NCD2SAI3 ,NCD2SAT3 ,NCD2SAI4 ,NCD2SAT4 ,NCD2SAI5 ,&
 & NCD2SAT5 ,NCD2SAI6 ,NCD2SAT6 ,NCD2NS   ,NCD2SD  

IMPLICIT NONE
REAL(KIND=JPRB) :: ZHOOK_HANDLE

!     ------------------------------------------------------------------
!*

!        1.       SECOND CMA DDR FORMAT (INTEGER SECTION)
!                 ---------------------------------------

IF (LHOOK) CALL DR_HOOK('SUCMAD2',0,ZHOOK_HANDLE)
NLENCD2 = 3072
NLEND2I = 1024

!*          1.1   LEN. OF SECOND DDR

NCD2LN  =  1

!*          1.2   NO. OF NON-INTEGER SECTIONS

NCD2NI  =  2

!*          1.3   TYPE OF FIRST NON-INTEGER SECTION

NCD2T1  =  3

!*          1.4   TYPE OF SECOND NON-INTEGER SECTION

NCD2T2  =  4

!*          1.5   LEN. OF INTEGER SECTION

NCD2IL  =  5

!*          1.6   LEN. OF FIRST NON-INTEGER SECTION

NCD2LFS =  6

!*          1.7   LEN. OF SECOND NON-INTEGER SECTION

NCD2LSS =  7

!*          1.8   LEN. OF NEXT DDR

NCD2LND =  8

!*          1.9   NO. OF CLEAR SATEM THICKNESS LAYERS

NCD2TL  =  9

!*          1.10  NO. OF CLOUDY SATEM THICKNESS LAYERS

NCD2TY  = 10

!*          1.11  NO. OF MICROWAVE SATEM THICKNESS LAYERS

NCD2TM  = 11

!*          1.12  SATELLITE X ID.

NCD2SAI1= 12

!*          1.13  NO. OF SATELLITE X REPORTS PRESENT

NCD2SAT1= 13

!*          1.14  SATELLITE Y ID.

NCD2SAI2= 14

!*          1.15  NO. OF SATELLITE Y REPORTS PRESENT

NCD2SAT2= 15

!*          1.16  SATELLITE Z ID.

NCD2SAI3= 16

!*          1.17  NO. OF SATELLITE Z REPORTS PRESENT

NCD2SAT3= 17

!*          1.18  SATELLITE P ID.

NCD2SAI4= 18

!*          1.19  NO. OF SATELLITE P REPORTS PRESENT

NCD2SAT4= 19

!*          1.20  SATELLITE R ID.

NCD2SAI5= 20

!*          1.21  NO. OF SATELLITE R REPORTS PRESENT

NCD2SAT5= 21

!*          1.22  SATELLITE Q ID.

NCD2SAI6= 22

!*          1.23  NO. OF SATELLITE Q REPORTS PRESENT

NCD2SAT6= 23

!*          1.24  24-25 RESERVED

!*          1.26  NO. OF SIMULATIONS PERFORMED

NCD2NS  = 26

!*          1.27  NO. OF THE FOLLOWING WORDS USED TO STORE BIT MAP
!                 INDICATING ADDITIONAL DEPARTURES CREATED

NCD2SD  = 27

!*          1.28  28-NS BIT MAP

!*          1.NS  NS-1024 NOT DEFINED

!*
!-----------------------------------------------------------------------

!        2.       SECOND CMA DDR FORMAT (CHARACTER SECTION)
!                 -----------------------------------------

NLEND2C = 1024

!*          2.1   1-1024 NOT-DEFINED

!*
!-----------------------------------------------------------------------

!        3.       SECOND CMA DDR FORMAT (REAL SECTION)
!                 ------------------------------------

NLEND2R = 1024

!*          3.1   1-1024 NOT-DEFINED

!*
!-----------------------------------------------------------------------

!        5.       RETURN
!                 ------

IF (LHOOK) CALL DR_HOOK('SUCMAD2',1,ZHOOK_HANDLE)
END SUBROUTINE SUCMAD2
