SUBROUTINE SUCMAHOP(KMDI)

!**** SUBROUTINE SUCMAHOP - CMA OPTIONAL PART OF HEADER PACKED
!                           INFO. FORMAT

!        D. VASILJEVIC     ECMWF    30/08/1994

!**   PURPOSE
!     -------

!        SET CMA OPTIONAL PART OF HEADER PACKED INFO. FORMAT

!**   INTERFACE
!     ---------

!        CALL SUCMAHOP(KMDI)
!     WHERE:
!           KMDI = MISSING IND.

!        SUCMAHOP IS CALLED BY SUBROUTINE SUCMAHO

!**   METHOD
!     ------

!        CMA OPTIONAL PART OF HEADER PACKED INFO. FORMAT IS SET.

!**   EXTERNALS
!     ---------

!        NONE

!**   MODIFICATIONS
!     -------------
!      Niels Bormann   23/12/2004    RARAD becomes LIMB

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMCMA   , ONLY : NMXOTP   ,NMXOCT
USE YOMCMHDR , ONLY : NCMITBP  ,NCMITOC  ,NPHFLBP  ,NPHFLOC  ,&
 & NSBI1BP  ,NSBI1OC  ,NSBI2BP  ,NSBI2OC  ,NDK2BP   ,&
 & NDK2OC   ,NDK3BP   ,NDK3OC   ,NDK4BP   ,NDK4OC   ,&
 & NPIA4BP  ,NPIA4OC  ,NSMI3BP  ,NSMI3OC  ,NSMI2BP  ,&
 & NSMI2OC  ,NSMI4BP  ,NSMI4OC  ,NSMI1BP  ,NSMI1OC  ,&
 & NTOAABP  ,NTOAAOC  ,NTOBBBP  ,NTOBBOC  ,NTOCCBP  ,&
 & NTOCCOC  ,NTOVVBP  ,NTOVVOC  ,NTOWWBP  ,NTOWWOC  ,&
 & NTOXXBP  ,NTOXXOC  ,NTOYYBP  ,NTOYYOC  ,NTOZZBP  ,&
 & NTOZZOC  
USE YOMCOCTP , ONLY : NSYNOP   ,NSYNCT   ,NAIREP   ,NAIRCT   ,&
 & NSATOB   ,NSABCT   ,NDRIBU   ,NDRICT   ,NTEMP    ,&
 & NTEMCT   ,NPILOT   ,NPILCT   ,NSATEM   ,NSAMCT   ,&
 & NPAOB    ,NPAOCT   ,NSCATT   ,NSCACT   ,NLIMB    ,&
 & NLIMBCT  

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KMDI 
INTEGER(KIND=JPIM) :: JSCT, JSET, JSOT
REAL(KIND=JPRB) :: ZHOOK_HANDLE

!*

!        0.       PRESET
!                 ------

IF (LHOOK) CALL DR_HOOK('SUCMAHOP',0,ZHOOK_HANDLE)
DO JSCT = 1 , NMXOCT
  NPHFLBP(JSCT     ) = KMDI
  NPHFLOC(JSCT     ) = KMDI
ENDDO

DO JSCT = 1 , NMXOCT
  NSBI1BP(JSCT     ) = KMDI
  NSBI1OC(JSCT     ) = KMDI
  NSBI2BP(JSCT     ) = KMDI
  NSBI2OC(JSCT     ) = KMDI
ENDDO

DO JSCT = 1 , NMXOCT
  NDK2BP (JSCT     ) = KMDI
  NDK2OC (JSCT     ) = KMDI
  NDK3BP (JSCT     ) = KMDI
  NDK3OC (JSCT     ) = KMDI
  NDK4BP (JSCT     ) = KMDI
  NDK4OC (JSCT     ) = KMDI
ENDDO

DO JSCT = 1 , NMXOCT
  NPIA4BP(JSCT     ) = KMDI
  NPIA4OC(JSCT     ) = KMDI
ENDDO

DO JSCT = 1 , NMXOCT
  NSMI3BP(JSCT     ) = KMDI
  NSMI3OC(JSCT     ) = KMDI
  NSMI2BP(JSCT     ) = KMDI
  NSMI2OC(JSCT     ) = KMDI
  NSMI4BP(JSCT     ) = KMDI
  NSMI4OC(JSCT     ) = KMDI
  NSMI1BP(JSCT     ) = KMDI
  NSMI1OC(JSCT     ) = KMDI
  NTOAABP(JSCT     ) = KMDI
  NTOAAOC(JSCT     ) = KMDI
  NTOBBBP(JSCT     ) = KMDI
  NTOBBOC(JSCT     ) = KMDI
  NTOCCBP(JSCT     ) = KMDI
  NTOCCOC(JSCT     ) = KMDI
  NTOVVBP(JSCT     ) = KMDI
  NTOVVOC(JSCT     ) = KMDI
  NTOWWBP(JSCT     ) = KMDI
  NTOWWOC(JSCT     ) = KMDI
  NTOXXBP(JSCT     ) = KMDI
  NTOXXOC(JSCT     ) = KMDI
  NTOYYBP(JSCT     ) = KMDI
  NTOYYOC(JSCT     ) = KMDI
  NTOZZBP(JSCT     ) = KMDI
  NTOZZOC(JSCT     ) = KMDI
ENDDO

DO JSOT = 1 , NMXOTP
  DO JSCT = 1 , NMXOCT
    NCMITBP(JSCT,JSOT) =  KMDI
    NCMITOC(JSCT,JSOT) =  KMDI
  ENDDO
ENDDO
!*
!-----------------------------------------------------------------------

!        1.       SYNOP
!                 -----

!*          1.1   INSTRIMENT SPECIFICATION STRUCTURE:
!                 ALL CODE TYPES HAVE THE SAME STRUCTURE FOR NOW
!                 BITS  0- 9  - INSTRUMENT TYPE
!                 BITS  7-31  - RESERVED  

DO JSET = 1 , NSYNCT
  NCMITBP(JSET,NSYNOP) =  0
  NCMITOC(JSET,NSYNOP) = 10
ENDDO

!*          1.2   EVENTS STRUCTURE:
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*
!-----------------------------------------------------------------------

!        2.       AIREP
!                 -----

!*          2.1   INSTRIMENT SPECIFICATION STRUCTURE:
!                 ALL CODE TYPES HAVE THE SAME STRUCTURE FOR NOW
!                  BITS  0- 9  - INSTRUMENT TYPE
!                  BITS 10-19  - PHASE OF THE FLIGHT
!                  BITS 20-31  - RESERVED  

!*          2.1.1 INSTRUMENT TYPE STRUCTURE

DO JSET = 1 , NAIRCT
  NCMITBP(JSET,NAIREP) =  0
  NCMITOC(JSET,NAIREP) = 10
ENDDO

!*          2.1.2 PHASE OF THE FLIGHT

DO JSET = 1 , NAIRCT
  NPHFLBP(JSET       ) = 10
  NPHFLOC(JSET       ) = 10
ENDDO

!*          2.2   EVENTS STRUCTURE:
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*
!-----------------------------------------------------------------------

!        3.       SATOB
!                 -----

!*          3.1   SATOB INSTRIMENT SPECIFICATION STRUCTURE:
!                  BITS  0- 9  - INSTRUMENT TYPE
!                  BITS 10-13  - I1
!                  BITS 14-21  - I2
!                  BITS 22-31  - RESERVED

!*          3.1.1 INSTRUMENT TYPE STRUCTURE

DO JSET = 1 , NSABCT
  NCMITBP(JSET,NSATOB) =  0
  NCMITOC(JSET,NSATOB) = 10
ENDDO

!*          3.1.2   I1 PARM. STRUCTURE

DO JSET = 1 , NSABCT
  NSBI1BP(JSET       ) = 10
  NSBI1OC(JSET       ) =  4
ENDDO

!*          3.1.3 I2 PARM. STRUCTURE

DO JSET = 1 , NSABCT
  NSBI2BP(JSET       ) =  14
  NSBI2OC(JSET       ) =   8
ENDDO

!*          3.2   EVENTS STRUCTURE
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*
!-----------------------------------------------------------------------

!        4.       DRIBU
!                 -----

!*          4.1   DRIBU INSTRIMENT SPECIFICATION STRUCTURE:
!                  BITS  0- 9  - INSTRUMENT TYPE
!                  BITS 10-13  - K1
!                  BITS 14-17  - K2
!                  BITS 18-21  - K4
!                  BITS 22-31  - RESERVED

!*          4.1.1 INSTRUMENT TYPE STRUCTURE

DO JSET = 1 , NDRICT
  NCMITBP(JSET,NDRIBU) =  0
  NCMITOC(JSET,NDRIBU) = 10
ENDDO

!*          4.1.2 K2 PARM. STRUCTURE

DO JSET = 1 , NDRICT
  NDK2BP (JSET       ) = 10
  NDK2OC (JSET       ) =  4
ENDDO

!*          4.1.3 K3 PARM. STRUCTURE

DO JSET = 1 , NDRICT
  NDK3BP (JSET       ) = 14
  NDK3OC (JSET       ) =  4
ENDDO

!*          4.1.4 K4 PARM. STRUCTURE

DO JSET = 1 , NDRICT
  NDK4BP (JSET       ) = 18
  NDK4OC (JSET       ) =  4
ENDDO

!*          4.2   EVENTS STRUCTURE
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*
!-----------------------------------------------------------------------

!        5.       TEMP
!                 ----

!*          5.1   TEMP INSTRIMENT SPECIFICATION STRUCTURE:
!                  BITS  0- 9  - INSTRUMENT TYPE
!                  BITS 10-31  - RESERVED  

DO JSET = 1 , NTEMCT
  NCMITBP(JSET,NTEMP ) =  0
  NCMITOC(JSET,NTEMP ) = 10
ENDDO

!*          5.2   EVENTS STRUCTURE
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*
!-----------------------------------------------------------------------

!        6.       PILOT
!                 -----

!*          6.1   INSTRUMENT SPECIFICATION STRUCTURE

!*          6.1.1 INSTRUMENT TYPE STRUCTURE

DO JSET = 1 , NPILCT
  NCMITBP(JSET,NPILOT) =  0
  NCMITOC(JSET,NPILOT) = 10
ENDDO

!*          6.1.2 A4 PARAM. STRUCTURE

DO JSET = 1 , NPILCT
  NPIA4BP(JSET       ) = 10
  NPIA4OC(JSET       ) =  4
ENDDO

!*          6.2   PILOT EVENTS STRUCTURE
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*
!-----------------------------------------------------------------------

!        7.       SATEM
!                 -----

!*          7.1   SATEM (NON-TOVS) INSTRIMENT SPECIFICATION STRUCTURE:
!                  BITS  0- 9  - INSTRUMENT TYPE
!                  BITS 10-13  - I3
!                  BITS 14-20  - I2I2
!                  BITS 21-24  - I4
!                  BITS 25-28  - I1
!                  BITS 29-31  - RESERVED  

!*          7.1.1 INSTRUMENT TYPE STRUCTURE

DO JSET = 1 , NSAMCT
  NCMITBP(JSET,NSATEM) =  0
  NCMITOC(JSET,NSATEM) = 10
ENDDO

!*          7.1.2 I3 PARAM. STRUCTURE

DO JSET = 1 , NSAMCT
  NSMI3BP(JSET       ) = 10
  NSMI3OC(JSET       ) =  4
ENDDO

!*         7.1.3  I2 PARAM. STRUCTURE

DO JSET = 1 , NSAMCT
  NSMI2BP(JSET       ) = 14
  NSMI2OC(JSET       ) =  7
ENDDO

!*         7.1.4  I4 PARAM. STRUCTURE

DO JSET = 1 , NSAMCT
  NSMI4BP(JSET       ) = 21
  NSMI4OC(JSET       ) =  4
ENDDO

!*         7.1.5  I1 PARAM. STRUCTURE

DO JSET = 1 , NSAMCT
  NSMI1BP(JSET       ) = 25
  NSMI1OC(JSET       ) =  4
ENDDO

!*          7.2   SATEM (TOVS) INSTRIMENT SPECIFICATION STRUCTURE:
!                  BITS  0- 9  - INSTRUMENT TYPE
!                  BITS 10-11  - A
!                  BITS 12-13  - B
!                  BITS 14-15  - C
!                  BITS 16-18  - V
!                  BITS 19-21  - W
!                  BITS 22-24  - X
!                  BITS 25-27  - Y
!                  BITS 28-30  - Z

!*          7.2.1  A PARAM. STRUCTURE

DO JSET = 1 , NSAMCT
  NTOAABP(JSET       ) = 10
  NTOAAOC(JSET       ) =  2
ENDDO

!*          7.2.2  B PARAM. STRUCTURE

DO JSET = 1 , NSAMCT
  NTOBBBP(JSET       ) = 12
  NTOBBOC(JSET       ) =  2
ENDDO

!*          7.2.3  C PARAM. STRUCTURE

DO JSET = 1 , NSAMCT
  NTOCCBP(JSET       ) = 14
  NTOCCOC(JSET       ) =  2
ENDDO

!*          7.2.4  V PARAM. STRUCTURE

DO JSET = 1 , NSAMCT
  NTOVVBP(JSET       ) = 16
  NTOVVOC(JSET       ) =  3
ENDDO

!*          7.2.5  W PARAM. STRUCTURE

DO JSET = 1 , NSAMCT
  NTOWWBP(JSET       ) = 19
  NTOWWOC(JSET       ) =  3
ENDDO

!*          7.2.6  X PARAM. STRUCTURE

DO JSET = 1 , NSAMCT
  NTOXXBP(JSET       ) = 22
  NTOXXOC(JSET       ) =  3
ENDDO

!*          7.2.7  Y PARAM. STRUCTURE

DO JSET = 1 , NSAMCT
  NTOYYBP(JSET       ) = 25
  NTOYYOC(JSET       ) =  3
ENDDO

!*          7.2.8  Z PARAM. STRUCTURE

DO JSET = 1 , NSAMCT
  NTOZZBP(JSET       ) = 28
  NTOZZOC(JSET       ) =  3
ENDDO

!*          7.3   STRUCTURE
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*
!-----------------------------------------------------------------------

!        8.       PAOB
!                 ----

!*          8.1    INSTRIMENT SPECIFICATION STRUCTURE
!                  BITS  0- 9  - INSTRUMENT TYPE
!                  BITS 10-31  - RESERVED  

DO JSET = 1 , NPAOCT
  NCMITBP(JSET,NPAOB ) =  0
  NCMITOC(JSET,NPAOB ) = 10
ENDDO

!*          8.2   EVENTS STRUCTURE
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*
!-----------------------------------------------------------------------

!        9.       SCATT.
!                 -----

!*          9.1   INSTRIMENT SPECIFICATION STRUCTURE
!                  BITS  0- 9  - INSTRUMENT TYPE
!                  BITS 10-31  - RESERVED  

DO JSET = 1 , NSCACT
  NCMITBP(JSET,NSCATT) =  0
  NCMITOC(JSET,NSCATT) = 10
ENDDO

!*          9.2   EVENTS STRUCTURE
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*
!-----------------------------------------------------------------------

!        10.      LIMB OBSERVATIONS
!                 -----------------

!*          10.1  INSTRIMENT SPECIFICATION STRUCTURE

DO JSET = 1 , NLIMBCT
  NCMITBP(JSET,NLIMB) =  0
  NCMITOC(JSET,NLIMB) = 10
ENDDO

!*          10.2  EVENTS STRUCTURE
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*
!-----------------------------------------------------------------------

!        11.      RETURN
!                 ------

IF (LHOOK) CALL DR_HOOK('SUCMAHOP',1,ZHOOK_HANDLE)
END SUBROUTINE SUCMAHOP
