SUBROUTINE SUCMBDTP

!**** SUBROUTINE SUCMBDTP - CMA OBS./CODE TYPE DEPENDENT
!                           PACKED INFO. FORMAT

!        D. VASILJEVIC     ECMWF    30/08/1994

!**   PURPOSE
!     -------

!        SET CMA OBS./CODE TYPE DEPENDENT PACKED INFO. FORMAT

!**   INTERFACE
!     ---------

!        CALL SUCMBDTP

!        SUCMBDTP IS CALLED BY SUCMABTD

!**   METHOD
!     ------

!        CMA OBS./CODE TYPE DEPENDENT PACKED INFO. FORMAT IS SET.

!**   EXTERNALS
!     ---------

!        NONE

!**   MODIFICATIONS
!     -------------
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      01-Dec-2003 CY28R1 Cleaning

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCMBDY , ONLY : NCMTETII ,NCMTELTI ,NCMTELNI ,NTLIDBP  ,&
 & NTLIDOC  ,NTMWLBP  ,NTMWLOC  ,NTTROBP  ,NTTROOC  ,&
 & NTDPABP  ,NTDPAOC  ,NTCPABP  ,NTCPAOC  ,NTBPABP  ,&
 & NTBPAOC  ,NTAPABP  ,NTAPAOC  ,NTSURBP  ,NTSUROC  ,&
 & NTSWLBP  ,NTSWLOC  ,NTSTLBP  ,NTSTLOC  ,NPLIDBP  ,&
 & NPLIDOC  ,NPMWLBP  ,NPMWLOC  ,NPTROBP  ,NPTROOC  ,&
 & NPDPABP  ,NPDPAOC  ,NPCPABP  ,NPCPAOC  ,NPBPABP  ,&
 & NPBPAOC  ,NPAPABP  ,NPAPAOC  ,NPSURBP  ,NPSUROC  ,&
 & NPSWLBP  ,NPSWLOC  ,NPSTLBP  ,NPSTLOC  

IMPLICIT NONE
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!     ------------------------------------------------------------------
!*

!        1.       SYNOP
!                 -----

!*          1.1   DATUM EVENTS (PART 2)
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*
!-----------------------------------------------------------------------

!        2.       AIREP
!                 -----

!*          2.1   DATUM EVENTS (PART 2)
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*
!-----------------------------------------------------------------------

!        3.       SATOB
!                 -----

!*          3.1   DATUM EVENTS (PART 2)
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*
!-----------------------------------------------------------------------

!        4.       DRIBU
!                 -----

!*          4.1   DATUM EVENTS (PART 2)
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*
!-----------------------------------------------------------------------

!        5.       TEMP
!                 ----

!*          5.1   DATUM EVENTS (PART 2)
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*          5.2   LEVEL ID.

IF (LHOOK) CALL DR_HOOK('SUCMBDTP',0,ZHOOK_HANDLE)
NTLIDBP  = 0
NTLIDOC  = 9

!*          5.2.1 MAX WIND LEVEL

NTMWLBP  = 0
NTMWLOC  = 1

!*          5.2.2 TROPOPAUSE

NTTROBP  = 1
NTTROOC  = 1

!*          5.2.3 D PART

NTDPABP  = 2
NTDPAOC  = 1

!*          5.2.4 C PART

NTCPABP  = 3
NTCPAOC  = 1

!*          5.2.5 B PART

NTBPABP  = 4
NTBPAOC  = 1

!*          5.2.6 A PART

NTAPABP  = 5
NTAPAOC  = 1

!*          5.2.7 SURFACE LEVEL

NTSURBP  = 6
NTSUROC  = 1

!*          5.2.8 SIGNIFICANT WIND LEVEL

NTSWLBP  = 7
NTSWLOC  = 1

!*          5.2.9 SIGNIFICANT TEMPERATURE LEVEL

NTSTLBP  = 8
NTSTLOC  = 1

!*      6.5.3     TEMP TIME INCREMENT

NCMTETII = 3

!*      6.5.4     TEMP LATITUDE INCREMENT

NCMTELTI = 4

!*      6.5.5     TEMP LONGITUDE INCREMENT

NCMTELNI = 5
!*
!-----------------------------------------------------------------------

!        6.       PILOT
!                 -----

!*          6.1   DATUM EVENTS (PART 2)
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*          6.2   LEVEL ID.

NPLIDBP  = 0
NPLIDOC  = 9

!*          6.2.1 MAX WIND LEVEL

NPMWLBP  = 0
NPMWLOC  = 1

!*          6.2.2 TROPOPAUSE

NPTROBP  = 1
NPTROOC  = 1

!*          6.2.3 D PART

NPDPABP  = 2
NPDPAOC  = 1

!*          6.2.4 C PART

NPCPABP  = 3
NPCPAOC  = 1

!*          6.2.5 B PART

NPBPABP  = 4
NPBPAOC  = 1

!*          6.2.6 A PART

NPAPABP  = 5
NPAPAOC  = 1

!*          6.2.7 SURFACE LEVEL

NPSURBP  = 6
NPSUROC  = 1

!*          6.2.8 SIGNIFICANT WIND LEVEL

NPSWLBP  = 7
NPSWLOC  = 1

!*          6.2.9 SIGNIFICANT TEMPERATURE LEVEL

NPSTLBP  = 8
NPSTLOC  = 1
!*
!-----------------------------------------------------------------------

!        7.       SATEM
!                 -----

!*          7.1   DATUM EVENTS (PART 2)
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*
!-----------------------------------------------------------------------

!        8.       PAOB
!                 ----

!*          8.1   DATUM EVENTS (PART 2)
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*
!-----------------------------------------------------------------------

!        9.       SCATTEROMETER
!                 -------------

!*          9.1   DATUM EVENTS (PART 2)
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*
!-----------------------------------------------------------------------

!        10.      LIMB OBS
!                 --------

!*          10.1  DATUM EVENTS (PART 2)
!                 STRUCTURE OF EVENTS WORD IS SUCH TAHT A PARTICULAR
!                 EVENT IS GIVEN BY ITS POSITION IN THE BIT STRING

!*
!-----------------------------------------------------------------------

!        11.      RETURN
!                 ------

IF (LHOOK) CALL DR_HOOK('SUCMBDTP',1,ZHOOK_HANDLE)
END SUBROUTINE SUCMBDTP
