SUBROUTINE SUCODES

!**** SUBROUTINE SUCODES -  VARIOUS CODES

!        D. VASILJEVIC    ECMWF    07/09/1994

!**   PURPOSE
!     -------

!        VARIOUS CODES ARE DEFINED.

!**   INTERFACE
!     ---------

!        SUCODES IS CALLED BY

!**   METHOD
!     ------

!        FOR VARIOUS CODES VALUES OR/AND EXPLANATIONS GIVEN.

!**   EXTERNALS
!     ---------

!**   MODIFICATIONS
!     -------------
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      01-Dec-2003 CY28R1 Cleaning

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMNMCOD , ONLY : NPRESCD  ,NPRESVC  ,NHEIGVC  ,NTOVCVC  ,&
 & NSCACVC  ,NMXSBI1  ,NSBI1    ,NMXSBI2  ,NSBI2I2  ,&
 & NMXSMI2  ,NSMI2I2  ,NMXSMVV  ,NSMVV    ,NMXSMWW  ,&
 & NSMWW    ,NMXSMXX  ,NSMXX    ,NMXSMYY  ,NSMYY    ,&
 & NMXSMAA  ,NSMAA    ,NMXSMBB  ,NSMBB    ,NMXSMCC  ,&
 & NSMCC    ,NINTESC  ,NREALSC  ,NCHARSC  
USE YOMCHCOD , ONLY : CIDLEV   ,CPRESCD
USE YOMINSTP , ONLY : NSYNINTP ,NSHPINTP ,NACFINTP ,NSTBITGO ,&
 & NSTBITME ,NSTBITIN ,NSTBITJA  

IMPLICIT NONE
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!     ------------------------------------------------------------------
!*       1.         UPPER AIR (TEMP AND PILOT) LEVEL IDENTIFIER
!                   -------------------------------------------

!*          1.1     TEXT EXPLANATION OF LEVEL IDENTIFIER

IF (LHOOK) CALL DR_HOOK('SUCODES',0,ZHOOK_HANDLE)
CIDLEV  ( 1) =   'MAX WIND LEVEL'
CIDLEV  ( 2) =   'TROPOPAUSE'
CIDLEV  ( 3) =   'D PART'
CIDLEV  ( 4) =   'C PART'
CIDLEV  ( 5) =   'B PART'
CIDLEV  ( 6) =   'A PART'
CIDLEV  ( 7) =   'SURFACE LEVEL'
CIDLEV  ( 8) =   'SIGNIFICANT WIND LEVEL'
CIDLEV  ( 9) =   'SIGNIFICANT TEMPERATURE LEVEL'
!*
!-----------------------------------------------------------------------

!        2.         SYNOP PRESSURE CODES
!                   --------------------

!*          2.1     CODES

NPRESCD ( 1) =   0
NPRESCD ( 2) =   1
NPRESCD ( 3) =   2
NPRESCD ( 4) =   3
NPRESCD ( 5) =   4
NPRESCD ( 6) =   5
NPRESCD ( 7) =   6
NPRESCD ( 8) =   7
NPRESCD ( 9) =   8
NPRESCD (10) =   9
NPRESCD (11) =  10
NPRESCD (12) =  11
NPRESCD (13) =  12

!*          2.2     TEXT VERSION OF CODES

CPRESCD ( 1) = ' 0 - SEA LEVEL'
CPRESCD ( 2) = ' 1 - STATION LEVEL PRESSURE'
CPRESCD ( 3) = ' 2 - 850MB GEOPOTENTIAL'
CPRESCD ( 4) = ' 3 - 700MB GEOPOTENTIAL'
CPRESCD ( 5) = ' 4 - 500GPM PRESSURE'
CPRESCD ( 6) = ' 5 - 1000GPM PRESSURE'
CPRESCD ( 7) = ' 6 - 2000GPM PRESSURE'
CPRESCD ( 8) = ' 7 - 3000GPM PRESSURE'
CPRESCD ( 9) = ' 8 - 4000GPM PRESSURE'
CPRESCD (10) = ' 9 - 900MB GEOPOTENTIAL'
CPRESCD (11) = '10 - 1000MB GEOPOTENTIAL'
CPRESCD (12) = '11 - 500MB GEOPOTENTIAL'
CPRESCD (13) = '12 - 925MB GEOPOTENTIAL'
!*
!-----------------------------------------------------------------------

!        3.         VERTICAL COORDINATE CODES
!                   -------------------------

!*          3.1     PRESSURE VERTICAL COORDINATE

NPRESVC = 1

!*          3.2     HEIGHT VERTICAL COORDINATE

NHEIGVC = 2

!*          3.3     TOVS CHANNEL

NTOVCVC = 3

!*          3.4     SCATT. CHANNEL

NSCACVC = 4
!*
!-----------------------------------------------------------------------

!        4.         SATOB I1 AND I2I2 CODES
!                   -----------------------
!                   SATOB I1, WMO CODE 1761, NAME OF COUNTRY:
!                   - I1 =   0 ; EUROPE
!                   - I1 =   1 ; JAPAN
!                   - I1 =   2 ; USA 
!                   - I1 =   3 ; USSR
!                   - I1 =   4 ; INDIA
!                   SATOB I2I2, SATELLITE INDICATOR FIGURE
!                   - I2I2 =   4 ; METEOSAT
!                   - I2I2 = 177 ; PRETORIA
!                   - I2I2 =   0 ; GOES
!                   - I2I2 =   3 ; JAPAN
!                   - I2I2 =  20 ; INDIA
!                   THEY ARE WORKED OUT FROM SATOB STATION ID.:
!                   - STID<100 --> GOES
!                   - STID<200 --> METEOSAT
!                   - STID<300 --> INDIAN SATOB
!                   - STID<500 --> JAPAN

!*          4.1     I1

NMXSBI1 = 5

!*          4.1.1   EUROPE

NSBI1  ( 1) =   0

!*          4.1.2   JAPAN

NSBI1  ( 2) = 1

!*          4.1.3   USA

NSBI1  ( 3) =   2

!*          4.1.4   USSR

NSBI1  ( 4) =   3

!*          4.1.5   INDIA

NSBI1  ( 5) =   4

!*          4.2     I2I2

NMXSBI2 = 5

!*          4.2.1   METEOSAT

NSBI2I2( 1) =   4

!*          4.2.2   PRETORIA

NSBI2I2( 2) = 177

!*          4.2.3   GOES

NSBI2I2( 3) =   0

!*          4.2.4   JAPAN

NSBI2I2( 4) =   3

!*          4.2.5   INDIA

NSBI2I2( 5) =  20
!*
!-----------------------------------------------------------------------

!        5.         PILOT A4 CODES
!                   --------------

!*          5.1     A4

!*
!-----------------------------------------------------------------------

!        6.         SATEM I1, I2I2, I4 AND I3 CODES
!                   -------------------------------

!*          6.1     I1

!*          6.2     I2I2

NMXSMI2 = 4

!*          6.2.1   NOAA- 9

NSMI2I2( 1) =  34

!*          6.2.2   NOAA-10

NSMI2I2( 2) =  35

!*          6.2.3   NOAA-11

NSMI2I2( 3) =  36

!*          6.2.4   NOAA-12

NSMI2I2( 4) =  37

!*          6.3     I4

!*          6.4     I3

!*
!-----------------------------------------------------------------------

!        7.         TOVS (PROFILES) V, W, X, Y, Z, A, B AND C CODES
!                   -----------------------------------------------

!*          7.1     V

NMXSMVV = 3

!*          7.1.1   NO RETRIEVAL

NSMVV  ( 1) =   0

!*          7.1.2   HIRS+MSU

NSMVV  ( 2) =   1

!*          7.1.3   HIRS

NSMVV  ( 3) =   2

!*          7.2     W

NMXSMWW = 3

!*          7.2.1   NO RETRIEVAL

NSMWW  ( 1) =   0

!*          7.2.2   HIRS+MSU

NSMWW  ( 2) =   1

!*          7.2.3   HIRS

NSMWW  ( 3) =   2

!*          7.3     X

NMXSMXX = 5

!*          7.3.1   NO RETRIEVAL

NSMXX  ( 1) =   0

!*          7.3.2   HIRS(1,2,3,8,9,16,17) + MSU(4)

NSMXX  ( 2) =   1

!*          7.3.3   HIRS(1,2,3,8,9,16,17)

NSMXX  ( 3) =   2

!*          7.3.4   HIRS(1,2,3,9,17) + MSU(4)

NSMXX  ( 4) =   3

!*          7.3.5   HIRS(1,2,3,9,17)

NSMXX  ( 5) =   4

!*          7.4     Y

NMXSMYY = 7

!*          7.4.1   NO RETRIEVAL

NSMYY  ( 1) =   0

!*          7.4.2   HIRS+SSU+MSU(3,4)

NSMYY  ( 2) =   1

!*          7.4.3   HIRS+MSU(3,4)

NSMYY  ( 3) =   2

!*          7.4.4   SSU+MSU(3,4)

NSMYY  ( 4) =   3

!*          7.4.5   HIRS+SSU

NSMYY  ( 5) =   4

!*          7.4.6   HIRS

NSMYY  ( 6) =   5

!*          7.4.7   MSU(3,4)

NSMYY  ( 7) =   6

!*          7.5     A

NMXSMAA = 3

!*          7.5.1   NO HIRS/2 DATA

NSMAA  ( 1) =   0

!*          7.5.2   CLEAR RAD. DERIVED FROM CLEAR SPOTS

NSMAA  ( 2) =   1

!*          7.5.3   CLEAR RAD. DERIVED FROM N* METHOD

NSMAA  ( 3) =   2

!*          7.6     B

NMXSMBB = 3

!*          7.6.1   NO HIRS/2 DATA

NSMBB  ( 1) =   0

!*          7.6.2   ALL HIRS/2 CHANNEL ARE USED

NSMBB  ( 2) =   1

!*          7.6.3   TROPOSPHERIC HIRS/2 CHANNELS WERE UNUSABLE DUE
!                   TO CLOUDS AND ONLY STRATOSPHERIC CHANNEL WERE
!                   USED

NSMBB  ( 3) =   2

!*          7.7     C

NMXSMCC = 3

!*          7.7.1   STATISTICAL RETRIEVAL

NSMCC  ( 1) =   0

!*          7.7.2   MINIMUM INFORMATION RETRIEVAL

NSMCC  ( 2) =   1

!*          7.7.3   MINIMUM INFORMATION RETRIEVAL ATTEMPTED BUT
!                   STATISTICAL RETRIEVAL USED

NSMCC  ( 3) =   2
!*
!-----------------------------------------------------------------------

!        8.         RETRIEVAL TYPE CODES
!                   --------------------

!*
!-----------------------------------------------------------------------

!        10.        GEOGRAPHICAL AREA TYPE CODES
!                   ----------_-----------------

!*
!-----------------------------------------------------------------------

!        11.        INSTRUMENT TYPE CODES
!                   ---------------------

!*          11.1    SYNOP

NSYNINTP = 32
NSHPINTP = 32

!*          11.2    AIREP

NACFINTP = 23

!*          11.3    SATOB
!                   INSTRUMENT SPECIFICATION CODES:
!                   - 60 FOR GOES
!                   - 62 FOR METEOSAT
!                   - 63 FOR INDIAN SATOB
!                   - 68 FOR JAPAN
!                   THEY ARE WORKED OUT FROM SATOB STATION ID.:
!                   - STID<100 --> GOES
!                   - STID<200 --> METEOSAT
!                   - STID<300 --> INDIAN SATOB
!                   - STID<500 --> JAPAN

NSTBITGO = 60
NSTBITME = 62
NSTBITIN = 63
NSTBITJA = 68
!*
!-----------------------------------------------------------------------

!        12.        CMA DDR INTEGER/REAL/CHARACTER SECTIONS CODES
!                   ---------------------------------------------

NINTESC = 1
NREALSC = 2
NCHARSC = 3
!*
!-----------------------------------------------------------------------

!        13.        SETUP DONE
!                   ----------

!     WRITE(NOUT,'(''0CODES SETUP'')')
!*
!-----------------------------------------------------------------------

!        14.        RETURN
!                   ------

IF (LHOOK) CALL DR_HOOK('SUCODES',1,ZHOOK_HANDLE)
END SUBROUTINE SUCODES
