SUBROUTINE SUCOM (KULOUT)

!**** *SUMCC* * - ROUTINE TO INITIALIZE VARIABLES FOR THE COM COUPLING

!     PURPOSE.
!     --------
!        SET DEFAULT VALUES, THEN READS NAMELIST NAMCOM

!**   INTERFACE.
!     ----------
!        *CALL* *SUCOM(KULOUT)*

!     EXPLICIT ARGUMENTS :  KULOUT
!     --------------------

!     IMPLICIT ARGUMENTS :
!     --------------------
!        COMMON  YOMCOM

!     METHOD.
!     -------
!     EXTERNALS.
!     ----------

!     REFERENCE.
!     ----------

!     AUTHOR.
!     -------
!        Jean-Philippe Piedelievre CNRM/GMGEC/EAC

!     MODIFICATIONS.
!     --------------
!        ORIGINAL : 99-02-24
!        Modified : 02-01-11 P. Marquet - Modifications for Climat-V4
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMCOM, ONLY : NVCOM , ALATN1, ALATN2, ALATN3, ALATN4 ,&
 & ALATS1, ALATS2, ALATS3, ALATS4, GAMAT, GAMAD  , LOMLDTH, HMEL_MIN

USE YOMLUN   , ONLY : NULNAM

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KULOUT 
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "namcom.h"
#include "posnam.intfb.h"

!-----------------------------------------------------------------------

!*     1.   SET DEFAULT VALUES.
!           ------------------

IF (LHOOK) CALL DR_HOOK('SUCOM',0,ZHOOK_HANDLE)
NVCOM=2
ALATN1=70._JPRB
ALATN2=60._JPRB
ALATN3=35._JPRB
ALATN4=25._JPRB
ALATS1=-25._JPRB
ALATS2=-35._JPRB
ALATS3=-60._JPRB
ALATS4=-70._JPRB
GAMAT=1.0_JPRB
GAMAD=1.0_JPRB

!*     2.   MODIFIES DEFAULT VALUES.
!           ------------------------

CALL POSNAM(NULNAM,'NAMCOM')
READ       (NULNAM, NAMCOM)

!*     3.   PRINTS FINAL VALUES.
!           ------------------------

WRITE(UNIT=KULOUT,FMT='('' COMMON YOMCOM '')')
WRITE(UNIT=KULOUT,FMT='(&
 & '' NVCOM  = '',I5,5X, &
 & '' GAMAT  = '',E10.3,'' GAMAD  = '',E10.3 &
 & /'' ALATN1 = '',F10.3,'' ALATN2 = '',F10.3 &
 & ,'' ALATN3 = '',F10.3,'' ALATN4 = '',F10.3 &
 & /'' ALATS1 = '',F10.3,'' ALATS2 = '',F10.3 &
 & ,'' ALATS3 = '',F10.3,'' ALATS4 = '',F10.3)')&
 & NVCOM,GAMAT,GAMAD,ALATN1,ALATN2,ALATN3,ALATN4,&
 & ALATS1,ALATS2,ALATS3,ALATS4  

IF (LHOOK) CALL DR_HOOK('SUCOM',1,ZHOOK_HANDLE)
END SUBROUTINE SUCOM
