subroutine sumpout(kulout)

!**** *sumpout*   - Sets up distributed memory variables - part 0

!     Purpose.
!     --------
!           Define basic distributed memory variables

!**   Interface.
!     ----------
!        *call* *sump0a

!        explicit arguments :
!        --------------------

!        implicit arguments :
!        --------------------

!     method.
!     -------
!        see documentation

!     externals.
!     ----------

!     reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     author.
!     -------
!        MPP Group *ECMWF*

!     modifications.
!     --------------
!        original : 95-10-01
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        R. El Khatib : 26-Feb-2008 Portability fix
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMCT0   , ONLY : NOUTPUT  ,LOUTPUT
USE YOMMP    , ONLY : MYPROC   ,MYSETA   ,MYSETB

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KULOUT 
CHARACTER (LEN = 10) ::  clout
CHARACTER (LEN = 10) ::  cldateod,cltimeod,clzoneod
INTEGER(KIND=JPIM) :: ivalues(8)

LOGICAL :: lloutp
REAL(KIND=JPRB) :: ZHOOK_HANDLE

!   NOUTPUT determines which PEs are going produce diagnostic output
!   The others do not output (LOUTPUT=.F.) or sends data to /dev/null

IF (LHOOK) CALL DR_HOOK('SUMPOUT',0,ZHOOK_HANDLE)
if (noutput <= 0) then
  lloutp=.false.
elseif (noutput == 1) then
  if (MYSETA == 1.and.MYSETB == 1) then
    lloutp=.true.
  else
    lloutp=.false.
  endif
else
  lloutp=.true.
endif

if (lloutp) then
  if (noutput>1) then
      write(clout,'(a1,i4.4)') '.',myproc-1
  else
      clout = ''
  endif
  open (unit=kulout, file='ifs.log'//trim(clout))
  loutput=.true.
  call date_and_time(cldateod,cltimeod,clzoneod,ivalues)
  write(kulout,'(/a,i4,a)')&
   & '--- Start of IFS output from processor ',&
   & myproc,' ----------------------------------'  
  write(kulout,'(a,a,'':'',a,'':'',a/)') ' TIME OF START= ',&
   & cltimeod(1:2),cltimeod(3:4),cltimeod(5:10)   
else
  open (unit=kulout, file='/dev/null')
  loutput=.false.
endif

IF (LHOOK) CALL DR_HOOK('SUMPOUT',1,ZHOOK_HANDLE)
end subroutine sumpout
