SUBROUTINE SUMSC(KULOUT)

!**** *SUMSC * - Routine to initialize machine specific constants

!     Purpose.
!     --------
!           Initialize machine (compiler) constants

!**   Interface.
!     ----------
!        *CALL* *SUMSC(KULOUT)

!        Explicit arguments :
!        --------------------

!        Implicit arguments :
!        --------------------
!        COMMON YOMMSC

!     Method.
!     -------
!        See documentation

!     Externals. N_PRECISION - returns number of bytes occupied by
!     ---------- variable of the type of its argument

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     Author.
!     -------
!        Mats Hamrud  *ECMWF*

!     Modifications.
!     --------------
!        Original : 96-03-20
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE PARKIND2  ,ONLY : JPRH
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMMSC   , ONLY : NINTLEN  ,NREALEN  ,NLOGLEN  ,NDBLLEN

IMPLICIT NONE

!     EXTERNAL INTEGER FUNCTIONS
INTEGER(KIND=JPIM),INTENT(IN)    :: KULOUT 
INTEGER(KIND=JPIM), EXTERNAL :: N_PRECISION

REAL(KIND=JPRB) :: ZZ(2)
INTEGER(KIND=JPIM) :: II(2)
REAL(KIND=JPRH) :: Z_DL(2)
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "abor1.intfb.h"

!     ------------------------------------------------------------------
!      1. INITIALIZE LENGHTS (IN BYTES) OF DIFFERENT TYPES

IF (LHOOK) CALL DR_HOOK('SUMSC',0,ZHOOK_HANDLE)
ZZ(:) = 1.0_JPRB
II(:) = 1
Z_DL(:) = 1.0_JPRH

NINTLEN = 0
NREALEN = 0
NLOGLEN = 0
NDBLLEN = 0

NINTLEN = N_PRECISION(II)
NREALEN = N_PRECISION(ZZ)
NLOGLEN = 8
!NDBLLEN = N_PRECISION(Z_DL)
NDBLLEN = 16
!!NDBLLEN = N_PRECISION(Z_DL)

WRITE(KULOUT,'(4(1X,A,I3))')&
 & 'NINTLEN=',NINTLEN,'NREALEN=',NREALEN,&
 & 'NLOGLEN=',NLOGLEN,'NDBLLEN=',NDBLLEN  

IF( NINTLEN == 0 .OR. NREALEN == 0 .OR. NLOGLEN == 0 .OR. NDBLLEN == 0 )THEN
  CALL ABOR1('SUMSC: WORD KIND LENGTH PROBLEM')
ENDIF

IF (LHOOK) CALL DR_HOOK('SUMSC',1,ZHOOK_HANDLE)
END SUBROUTINE SUMSC
