SUBROUTINE SUOAF

!**** *SUOAF*  - SETUP OBSERVATION ARRAY FORMAT

!     PURPOSE.
!     --------

!           SETUP OBSERVATION ARRAY FORMAT BY INITIALIZING COMMONS
!     RELATED TO CMA.

!**   INTERFACE.
!     ----------
!        *CALL* *SUOAF*

!        EXPLICIT ARGUMENTS
!        --------------------
!        NONE

!        IMPLICIT ARGUMENTS
!        --------------------
!        NONE

!     METHOD.
!     -------

!        SEE DOCUMENTATION

!     EXTERNALS.
!     ----------

!      SUCMA  - SETUP CMA FILE FORMAT

!     REFERENCE.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     AUTHOR.
!     -------

!        HEIKKI JARVINEN  *ECMWF*

!     MODIFICATIONS.
!     --------------
!        M.Hamrud      01-Oct-2003 CY28 Cleaning

!        ORIGINAL: 95-09-15

!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMLUN   , ONLY : NULOUT
USE YOMANCS  , ONLY : NMDI

IMPLICIT NONE

!*    ------------------------------------------------------------------

!*          1.    SETUP CMA FILE FORMAT IN INCREMENTAL MODE

REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "sucma.intfb.h"
#include "sucmoctp.intfb.h"
#include "sucodes.intfb.h"
#include "su_events.intfb.h"
#include "sufltxt.intfb.h"
IF (LHOOK) CALL DR_HOOK('SUOAF',0,ZHOOK_HANDLE)
CALL SUCMOCTP(NULOUT)
CALL SUCMA(NMDI)

!*    ------------------------------------------------------------------

!*          2.    SETUP REPORT AND DATUM EVENTS

CALL SU_EVENTS(NULOUT)

!*    ------------------------------------------------------------------

!*          3.    SETUP VARIOUS CODES

CALL SUCODES

!*    ------------------------------------------------------------------

!*          4.    SETUP FLAG RELATED TEXTS

CALL SUFLTXT(NULOUT)

!*    ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SUOAF',1,ZHOOK_HANDLE)
END SUBROUTINE SUOAF
