SUBROUTINE SUORB(KULOUT)

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMLUN   , ONLY : NULNAM
USE YOMRIP  , ONLY : NSSSSS,NINDAT,RSTATI
USE YOMCST   , ONLY : RDAY
USE YOMORB, ONLY :  LCORBMD,ORBMODE,ORBIY,ORBIYA,ORBECCEN,ORBOBLIQ,ORBMVELP, &
    & ORBORLIQR,ORBLAMBM0,ORBMVELPP,ORBCALDAY,ORBCALDAYM,ORBCYEAR, &
    & SHR_ORB_UNDEF_REAL,SHR_ORB_UNDEF_INT,SHR_ORB_PARAMS

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KULOUT 

INTEGER(KIND=JPIM) :: IJ0,IM0,IA0,IDINCR,OYY,OMM,ODD,OLMOIS(12)
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "abor1.intfb.h"
#include "posnam.intfb.h"
#include "namorb.h"
#include "fcttim.h"
!-------------------------------------------------
! 1. Default values.
!-------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SUORB',0,ZHOOK_HANDLE)

! set default value
LCORBMD = .FALSE.
ORBMODE = "fixed_year"
ORBIY = 1850
ORBIYA = 1950
ORBECCEN = 0.0
ORBOBLIQ = 0.0
ORBMVELP = 0.0
ORBCALDAY = 0.0
ORBCALDAYM = 0.0

! modify defalut value
CALL POSNAM(NULNAM,'NAMORB')
READ(NULNAM,NAMORB)

!---------------------------------------------------------------
! check orbital mode, reset unused parameters, validate settings
!---------------------------------------------------------------
IF (LCORBMD) THEN
    IF (TRIM(ORBMODE) == "fixed_year") THEN
        ORBOBLIQ = SHR_ORB_UNDEF_REAL
        ORBECCEN = SHR_ORB_UNDEF_REAL
        ORBMVELP = SHR_ORB_UNDEF_REAL
        ORBIYA = SHR_ORB_UNDEF_INT
        IF (ORBIY == SHR_ORB_UNDEF_INT) THEN
            WRITE(KULOUT,*) 'ERROR: invalid settings ORBMODE =',TRIM(ORBMODE)
            WRITE(KULOUT,*) 'ERROR: fixed_year settings = ',ORBIY
            CALL ABOR1('ERROR: invalid settings for ORBMODE')
        ENDIF
    ELSEIF (TRIM(ORBMODE) == "variable_year") THEN
        ORBOBLIQ = SHR_ORB_UNDEF_REAL
        ORBECCEN = SHR_ORB_UNDEF_REAL
        ORBMVELP = SHR_ORB_UNDEF_REAL
        IF (ORBIY == SHR_ORB_UNDEF_INT .OR. ORBIYA == SHR_ORB_UNDEF_INT) THEN
            WRITE(KULOUT,*) 'ERROR: invalid settings ORBMODE =',TRIM(ORBMODE)
            WRITE(KULOUT,*) 'ERROR: variable_year settings = ',ORBIY,ORBIYA
            CALL ABOR1('ERROR: invalid settings for ORBMODE')
        ENDIF
    ELSEIF (TRIM(ORBMODE) == "fixed_parameters") THEN
        !-- force orb_iyear to undef to make sure shr_orb_params works
        !properly
        ORBIY = SHR_ORB_UNDEF_INT
        ORBIYA = SHR_ORB_UNDEF_INT
        IF (ORBECCEN == SHR_ORB_UNDEF_REAL .OR. &
            ORBOBLIQ == SHR_ORB_UNDEF_REAL .OR. &
            ORBMVELP == SHR_ORB_UNDEF_REAL) THEN
            WRITE(KULOUT,*) 'ERROR: invalid settings ORBMODE =',TRIM(ORBMODE)
            WRITE(KULOUT,*) 'ERROR: ORBECCEN = ',ORBECCEN
            WRITE(KULOUT,*) 'ERROR: ORBOBLIQ = ',ORBOBLIQ
            WRITE(KULOUT,*) 'ERROR: ORBMVELP = ',ORBMVELP
            CALL ABOR1('ERROR: invalid settings for ORBMODE')
        ENDIF
    ELSE
        CALL ABOR1('ERROR: invalid ORBMODE')
    ENDIF

    CALL SHR_ORB_PARAMS(ORBIY,ORBECCEN,ORBOBLIQ,ORBMVELP,ORBORLIQR,ORBLAMBM0,ORBMVELPP)


    !------- print values -----------
    WRITE(KULOUT,*) "========== MODULE YOMORB ==========="
    WRITE(KULOUT,*) "LCORBMD=",LCORBMD
    WRITE(KULOUT,*) "ORBMODE=",ORBMODE," ORBCYEAR=",ORBCYEAR
    WRITE(KULOUT,*) "ORBIY=",ORBIY, " ORBIYA=",ORBIYA
    WRITE(KULOUT,*) "ORBECCEN=",ORBECCEN," ORBOBLIQ=",ORBOBLIQ
    WRITE(KULOUT,*) "ORBMVELP=",ORBMVELP," ORBORLIQR=",ORBORLIQR
    WRITE(KULOUT,*) "ORBLAMBM0=",ORBLAMBM0, " ORBMVELPP=",ORBMVELPP
    WRITE(KULOUT,*) "====================================="
ENDIF
IF (LHOOK) CALL DR_HOOK('SUORB',1,ZHOOK_HANDLE)

END SUBROUTINE SUORB

