SUBROUTINE SUSATRET

!**** SUBROUTINE SUSATRET -  SET SATELLITE RETRIEVAL CODES

!        D. VASILJEVIC    ECMWF    07/09/1994

!**   PURPOSE
!     -------

!        SATELLITE RETRIEVAL CODES

!**   INTERFACE
!     ---------

!        SUSATRET IS CALLED BY

!**   METHOD
!     ------

!        SATELLITE RETRIEVAL CODES ARE DEFINED.

!**   EXTERNALS
!     ---------

!**   MODIFICATIONS
!     -------------
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      01-Dec-2003 CY28R1 Cleaning

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMSTRE  , ONLY : RCLEAR   ,RPCLOU   ,RCLOUD   ,NCLEAR   ,&
 & NPCLOU   ,NCLOUD  

IMPLICIT NONE
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!     ------------------------------------------------------------------

!*       1.         INPUT (BUFR) RETRIEVAL CODES
!                   ----------------------------

!*          1.1     CLEAR

IF (LHOOK) CALL DR_HOOK('SUSATRET',0,ZHOOK_HANDLE)
RCLEAR       = 32._JPRB

!*          1.2     PARTLY CLOUDY

RPCLOU       = 16._JPRB

!*          1.3     CLOUDY

RCLOUD       =  8._JPRB
!*
!-----------------------------------------------------------------------

!        2.         OUTPUT (CMA/ODB) RETRIEVAL CODES
!                   ----------------------------

!*          2.1     CLEAR

NCLEAR       =  1

!*          2.2     PARTLY CLOUDY

NPCLOU       =  2

!*          2.3     CLOUDY

NCLOUD       =  3
!*
!-----------------------------------------------------------------------

!        3.         RETURN
!                   ------

IF (LHOOK) CALL DR_HOOK('SUSATRET',1,ZHOOK_HANDLE)
END SUBROUTINE SUSATRET
