SUBROUTINE SUXFU(KULOUT)

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMLUN   , ONLY : NULNAM
USE YOMDIM   , ONLY : NFLEVG
USE YOMPHY   , ONLY : LMPHYS, LNEIGE   ,LSOLV
USE YOMXFU    , ONLY : JPFUXT   ,NXFUTS   ,NFRXFU   ,TYPE_XFU ,NTYPXFU  ,&
 & NFDXFU   ,LXFU     ,LREAXFU  ,LXTRD    ,LXTRC    ,LXTRT    ,NRAZTS   ,&
 & LXPLC    ,LXPLCG   ,LXPLCH   ,LXPLS    ,LXPLSG   ,LXPLSH   ,LXR      ,&
 & LXNEBTT  ,LXSOIL   ,LXNEBPA  ,NFRRAZ   ,&
 & LTXTRD   ,LTXTRC   ,LTXTRT   ,LXICV    ,LTXR     ,LTXNEB   ,N1RAZ    ,&
 & LXCLS    ,LXCLP    ,LXTGST   ,LXTTCLS  ,LXHHCLS  ,LXQCLS   ,&
 & LTXQICE  ,LTXQLI, &
 & LXTHW
USE PTRXFU   , ONLY : MXTRDU   ,MXTRDV   ,MXTRCU   ,MXTRCV   ,MXDICQ   ,&
 & MXDICS   ,MXTRTU   ,MXTRTV   ,MXDITQ   ,MXDITS   ,MXPLCL   ,&
 & MXPLSL   ,MXPLCN   ,MXPLSN   ,MXPLCG   ,MXPLSG   ,MXPLCH   ,&
 & MXPLSH   ,MXRSO    ,MXRTH    ,MXNEB    ,&
 & MXNEBT   ,MXFEVL   ,MXFONTE  ,MXFCHSP  ,MXFEVV   ,MXFLWSP  ,&
 & MXFTR    ,MXRUISL  ,MXRUISP  ,MXRUISS  ,MXNBCON  ,MXNBHAU  ,&
 & MXNBMOY  ,MXCAPE   ,MXMOCON  ,MXNBBAS  ,MXCLPH   ,&
 & MXUGST   ,MXVGST   ,MXUCLS   ,MXVCLS   ,MXTCLS   ,MXQCLS   ,&
 & MXRHCLS  ,MXTN     ,MXTX     ,MXHUN    ,MXHUX    ,MXTHW    ,&
 & MXQICE   ,MXQLI
USE YOMCT0   , ONLY : LFPOS
USE YOMCT0B  , ONLY : LECMWF
USE YOMSTA   , ONLY : STPRE
USE YOMAFN   , ONLY : GFP_X10U ,GFP_X10V ,GFP_X2RH ,GFP_X2SH ,GFP_X2T  , &
 & GFP_XCAPE,GFP_XCCC ,GFP_XCLPH,GFP_XCP  ,GFP_XCSF ,GFP_XN2HU, &
 & GFP_XCVQ ,GFP_XCVS ,GFP_XCVU ,GFP_XCVV ,GFP_XGDU ,GFP_XGDV , &
 & GFP_XHCC ,GFP_XLCC ,GFP_XLSP ,GFP_XLSS ,GFP_XLSG ,GFP_XCSG , &
 & GFP_XLSH ,GFP_XCSH ,GFP_XMCC ,GFP_XX2HU,GFP_XTHW , &
 & GFP_XMOCO,GFP_XN2T ,GFP_XSSR ,GFP_XSTR ,GFP_XTCC ,GFP_XTUQ , &
 & GFP_XTUS ,GFP_XTUU ,GFP_XTUV ,GFP_XUGST,GFP_XVGST,GFP_XX2T

!**** *SUXFU  * - ROUTINE TO INITIALIZE THE CONTROL OF INSTANTANEOUS FLUXES

!     PURPOSE.
!     --------
!        SET DEFAULT VALUES, THEN READS NAMELIST NAMXFU AND INITIALIZE POINTERS

!**   INTERFACE.
!     ----------
!        *CALL* *SUXFU(KULOUT)*

!     EXPLICIT ARGUMENTS :  KULOUT
!     --------------------

!     IMPLICIT ARGUMENTS :
!     --------------------
!        COMMON  YOMCFU

!     METHOD.
!     -------

!     EXTERNALS.
!     ----------

!     REFERENCE.
!     ----------
!        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE IFS

!     AUTHOR.
!     -------
!        O.CLARY 06/92

!     MODIFICATIONS.
!     --------------
!        ORIGINAL : 06/92
!        R. EL Khatib : 93-04-02 Set-up defaults controled by LECMWF
!        R. EL Khatib : 93-08-19 PBL temperature extrema
!        R. El Khatib : 93-09-09 Partial cloudiness
!        R. El Khatib : 94-03-03 (LREAXFU)
!        R. El Khatib : 94-06-16 (Modify default values for Full-POS
!        EB and DG    : 94-10-07 (surface fluxes)
!        R. El Khatib : 00-03-23 Indexes of convection & Top of PBL calculation
!        R. El Khatib : 00-03 - derived types + indefined pointer set to 0 
!                               + remove redundant fields 
!        R. El Khatib : 01-04-23 LXQCLS,HUn,HUx
!        R. El Khatib : 01-08-07 pruning options
!        R. El Khatib : 03-04-17 Fullpos improvments
!        M.Hamrud     : 01-Oct-2003 CY28 Cleaning
!        Y.Bouteloup  : 26-Mars-2004 introduction of MTS radiance
!        F.Bouyssel   : 04-09-15 LXFU forced to false if .NOT.LMPHYS
!        R. El Khatib : 05-02-21 specific frequency array to reset extreme
!                                T2m and HU2m
!        F.Bouyssel   : 05-11-10 Introduction of  QICE and QLI
!        Y.Seity      : 07-01-15  add Graupel and Hail in XFU
!-----------------------------------------------------------------------

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KULOUT 
!     PARAMETERS
INTEGER(KIND=JPIM), PARAMETER :: JPKIND=6

INTEGER(KIND=JPIM) :: IP, J, IPAR, IK, INF550, INF850, JF, JL, IADD

INTEGER(KIND=JPIM) :: INLEV(NFLEVG+1,JPKIND), ILEV(JPKIND)

CHARACTER(LEN=4) :: CLPRE(NFLEVG+1,JPKIND), CLEVS(1)
CHARACTER(LEN=16) :: CLSU
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "posnam.intfb.h"
#include "seapre.intfb.h"
#include "sufpxfu.intfb.h"

#include "namxfu.h"
!      ----------------------------------------------------------------

!*       1.    SET DEFAULT VALUES.
!              -------------------

!        1.1 Set implicit default values

IF (LHOOK) CALL DR_HOOK('SUXFU',0,ZHOOK_HANDLE)
LXFU   = .FALSE.
LREAXFU= .FALSE.
LXTRD  = .FALSE.
LTXTRD = .FALSE.
LXTRC  = .FALSE.
LTXTRC = .FALSE.
LXTRT  = .FALSE.
LTXTRT = .FALSE.
LXPLC  = .FALSE.
LXPLCH = .FALSE.
LXPLCG = .FALSE.
LXPLS  = .FALSE.
LXPLSH = .FALSE.
LXPLSG = .FALSE.
LXR    = .FALSE.
LTXR   = .FALSE.
LTXNEB = .FALSE.
LTXQICE= .FALSE.
LTXQLI = .FALSE.
LXNEBTT= .FALSE.
LXNEBPA= .FALSE.
LXSOIL = .FALSE.
LXICV  = .FALSE.
LXCLS  = .FALSE.
LXQCLS = .FALSE.
LXTTCLS= .FALSE.
LXHHCLS= .FALSE.
LXCLP  = .FALSE.
LXTGST = .FALSE.
LXTHW  = .FALSE.
DO J=0,JPFUXT
  NXFUTS(J)=0
  NRAZTS(J)=0
ENDDO
NFRXFU   =20
NFRRAZ   =20
N1RAZ    =1

!        1.2 Modify default values according to LECMWF

IF (LECMWF) THEN
ELSE
  NFRXFU=9999999
  NXFUTS(0)=1
  NXFUTS(1)=1
  NRAZTS(0)=-27
! Reset every 3 hours until H54, then every 6 hours.
  NFRRAZ=1
  NRAZTS(1)=-0
  NRAZTS(2)=-3
  NRAZTS(3)=-6
  NRAZTS(4)=-9
  NRAZTS(5)=-12
  NRAZTS(6)=-15
  NRAZTS(7)=-18
  NRAZTS(8)=-21
  NRAZTS(9)=-24
  NRAZTS(10)=-27
  NRAZTS(11)=-30
  NRAZTS(12)=-33
  NRAZTS(13)=-36
  NRAZTS(14)=-39
  NRAZTS(15)=-42
  NRAZTS(16)=-45
  NRAZTS(17)=-48
  NRAZTS(18)=-51
  NRAZTS(19)=-54
  NRAZTS(20)=-60
  NRAZTS(21)=-66
  NRAZTS(22)=-72
  NRAZTS(23)=-78
  NRAZTS(24)=-84
  NRAZTS(25)=-90
  NRAZTS(26)=-96
  NRAZTS(27)=-102
ENDIF

!      ----------------------------------------------------------------

!*       2.    MODIFIES DEFAULT VALUES.
!              ------------------------

CALL POSNAM(NULNAM,'NAMXFU')
READ(NULNAM,NAMXFU)

IF (LFPOS) THEN
  CALL SUFPXFU
ENDIF
IF (LXFU .AND. .NOT.LMPHYS) THEN
  LXFU=.FALSE.
ENDIF
   
LXTRD  =LXTRD  .AND.LXFU
LXTRC  =LXTRC  .AND.LXFU
LXTRT  =LXTRT  .AND.LXFU
LXPLC  =LXPLC  .AND.LXFU
LXPLS  =LXPLS  .AND.LXFU
LXR    =LXR    .AND.LXFU
LTXNEB =LTXNEB .AND.LXFU
LTXQICE=LTXQICE.AND.LXFU
LTXQLI =LTXQLI .AND.LXFU
LXNEBTT=LXNEBTT.AND.LXFU
LXNEBPA=LXNEBPA.AND.LXFU
LXSOIL =LXSOIL .AND.LXFU
LXICV  =LXICV  .AND.LXFU 
LXCLS  =LXCLS  .AND.LXFU
LXTTCLS=LXTTCLS.AND.LXFU
LXQCLS =LXQCLS .AND.LXFU
LXHHCLS=LXHHCLS.AND.LXFU
LXCLP  =LXCLP  .AND.LXFU
LXTGST =LXTGST .AND.LXFU


!      ----------------------------------------------------------------

!*       3.    INITIALIZE DESCRIPTORS
!              ----------------------

!        3.1 Preinitialize the vertical levels and prefixes for *FA* files

CLEVS(1) = 'S   '

! On each half level :
IK=1
ILEV(IK)=NFLEVG+1
DO J=1,ILEV(IK)
  CLPRE(J,IK)=CLEVS(1)
  INLEV(J,IK)=J-1
ENDDO
! At the surface
IK=2
ILEV(IK)=1
CLPRE(1,IK)='SURF'
INLEV(1,IK)=NFLEVG
! On each full level :
IK=3
ILEV(IK)=NFLEVG
DO J=1,ILEV(IK)
  CLPRE(J,IK)=CLEVS(1)
  INLEV(J,IK)=J
ENDDO
! At the top and the surface :
IK=4
ILEV(IK)=2
CLPRE(1,IK)='SOMM'
CLPRE(2,IK)='SURF'
INLEV(1,IK)=0
INLEV(2,IK)=NFLEVG
! At a given model level
IK=5
ILEV(IK)=1
CLPRE(1,IK)=CLEVS(1)

!        3.2 Setup descripors

IP=0
IADD=1

!        3.2.1 STRess of gravity wave Drag :

MXTRDU=0
MXTRDV=0
IF (LXTRD) THEN
  IF (LTXTRD) THEN
!   On each half level : 
    IK=1 
  ELSE
!   At the surface :
    IK=2 
  ENDIF
  IPAR=1
  CLSU=GFP_XGDU%CLNAME(5:)
  CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),IPAR,MXTRDU)
  CLSU=GFP_XGDV%CLNAME(5:)
  CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),IPAR,MXTRDV)
ENDIF

!        3.2.2 STRess of Convection :

MXTRCU=0
MXTRCV=0
MXDICQ=0
MXDICS=0
IF (LXTRC) THEN
  IF (LTXTRC) THEN
!   On each half level :
    IK=1
  ELSE
!   At the model level the closest to 550 hPa :
    IK=5
    CALL SEAPRE(55000._JPRB,INF550,STPRE,NFLEVG)
    INLEV(1,IK)=INF550-1
  ENDIF
  CLSU=GFP_XCVU%CLNAME(5:)
  IPAR=1
  CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),IPAR,MXTRCU)
  CLSU=GFP_XCVV%CLNAME(5:)
  IPAR=1
  CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),IPAR,MXTRCV)
  IF (LTXTRC) THEN
!   On each half level :
    IK=1
  ELSE
!   At the model level the closest to 850 hPa :
    IK=5
    CALL SEAPRE(85000._JPRB,INF850,STPRE,NFLEVG)
    INLEV(1,IK)=INF850-1
  ENDIF
  CLSU=GFP_XCVQ%CLNAME(5:)
  IPAR=0
  CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),IPAR,MXDICQ)
  CLSU=GFP_XCVS%CLNAME(5:)
  IPAR=0
  CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),IPAR,MXDICS)
ENDIF

!        3.2.3 STRess of Turbulence, or Surface Fluxes

MXTRTU=0
MXTRTV=0
MXDITQ=0
MXDITS=0
IF (LXTRT) THEN
  IF (LTXTRT) THEN
!   On each half level :
    IK=1
  ELSE
!   At the surface :
    IK=2
  ENDIF
  CLSU=GFP_XTUU%CLNAME(5:)
  CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),1,MXTRTU)
  CLSU=GFP_XTUV%CLNAME(5:)
  CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),1,MXTRTV)
  IF (LXTRT) THEN
    CLSU=GFP_XTUQ%CLNAME(5:)
    CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),0,MXDITQ)
    CLSU=GFP_XTUS%CLNAME(5:)
    CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),0,MXDITS)
  ENDIF
ENDIF

!        3.2.4 Flux de PLuie  neige graupel et grele Convective 
!          (Convective rain snow graupel and hail) 

MXPLCL=0
MXPLCN=0
MXPLCG=0
MXPLCH=0
IF (LXPLC) THEN
  IK=2
  CLSU=GFP_XCP%CLNAME(5:)
  CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),0,MXPLCL)
  IF (LNEIGE) THEN
    CLSU=GFP_XCSF%CLNAME(5:)
    CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),0,MXPLCN)
  ENDIF
  IF (LXPLCG) THEN
    CLSU=GFP_XCSG%CLNAME(5:)
    CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),0,MXPLCG)
  ENDIF
  IF (LXPLCH) THEN
    CLSU=GFP_XCSH%CLNAME(5:)
    CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),0,MXPLCH)
  ENDIF
ENDIF

!        3.2.5 Flux de PLuie et neige graupel et grele Stratiforme
!               (Stratiform rain snow graupel and hail)

MXPLSL=0
MXPLSN=0
MXPLSG=0
MXPLSH=0
IF (LXPLS) THEN
  IK=2
  CLSU=GFP_XLSP%CLNAME(5:)
  CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),0,MXPLSL)
  IF (LNEIGE) THEN
    CLSU=GFP_XLSS%CLNAME(5:)
    CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),0,MXPLSN)
  ENDIF
  IF (LXPLSG) THEN
    CLSU=GFP_XLSG%CLNAME(5:)
    CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),0,MXPLSG)
  ENDIF
  IF (LXPLSH) THEN
    CLSU=GFP_XLSH%CLNAME(5:)
    CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),0,MXPLSH)
  ENDIF
ENDIF

!        3.2.6 Fluxes of Radiation

MXRSO=0
MXRTH=0
IF (LXR) THEN
  IF (LTXR) THEN
!   On each half level :
    IK=1
  ELSE
    IK=4
  ENDIF
  IPAR=0
  CLSU=GFP_XSSR%CLNAME(5:)
  CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),IPAR,MXRSO)
  CLSU=GFP_XSTR%CLNAME(5:)
  CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),IPAR,MXRTH)
ENDIF

!        3.2.7 NEBulosite (Cloudiness),Qice,Qliq  : as 3D variables

MXNEB=0
IF (LTXNEB) THEN
! On each full level :
  IK=3
  IPAR=0
  CLSU='NEBULOSI.TOT'
  CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),IPAR,MXNEB)
ENDIF

MXQICE=0
IF (LTXQICE) THEN
! On each full level :
  IK=3
  IPAR=0
  CLSU='HUMISOLI.TOT'
  CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),IPAR,MXQICE)
ENDIF

MXQLI=0
IF (LTXQLI) THEN
! On each full level :
  IK=3
  IPAR=0
  CLSU='HUMILIQU.TOT'
  CALL NEXTYPE3(CLPRE(1,IK),CLSU,INLEV(1,IK),ILEV(IK),IPAR,MXQLI)
ENDIF

!        3.2.8 NEBulosite Totale (Total Cloudiness) : as seen from bottom

MXNEBT=0
IF (LXNEBTT) THEN
  CALL NEXTYPE1(GFP_XTCC%CLNAME(1:4),GFP_XTCC%CLNAME(5:),0,MXNEBT)
ENDIF

!        3.2.9 SOIL fluxes

MXFONTE=0
MXFCHSP=0
MXFLWSP=0
MXFEVL =0
MXRUISS=0
MXRUISP=0
MXFEVV =0
MXFTR  =0
MXRUISL=0
IF (LXSOIL) THEN
  CALL NEXTYPE1('SURF','XFONTE NEIGE    ',0,MXFONTE)
  CALL NEXTYPE1('SURF','XCHAL. DS SOL   ',0,MXFCHSP)
  CALL NEXTYPE1('SURF','XEAU DANS SOL   ',0,MXFLWSP)
  CALL NEXTYPE1('SURF','XFLU.MEVAP.EAU  ',0,MXFEVL)
  CALL NEXTYPE1('SURF','XRUISSELLEMENT  ',0,MXRUISS)
  CALL NEXTYPE1('PROF','XRUISSELLEMENT  ',0,MXRUISP)
  IF (LSOLV) THEN
    CALL NEXTYPE1('SURF','XEVAPOTRANSPIRAT',0,MXFEVV )
    CALL NEXTYPE1('SURF','XTRANSPIRATION  ',0,MXFTR  )
    CALL NEXTYPE1('SURF','XRUISS. INTERCEP',0,MXRUISL)
  ENDIF
ENDIF

!        3.2.10 NEBulosite PARtielles (partial cloudiness)

MXNBCON=0
MXNBHAU=0
MXNBMOY=0
MXNBBAS=0
IF (LXNEBPA) THEN
  CALL NEXTYPE1(GFP_XCCC%CLNAME(1:4),GFP_XCCC%CLNAME(5:),0,MXNBCON)
  CALL NEXTYPE1(GFP_XHCC%CLNAME(1:4),GFP_XHCC%CLNAME(5:),0,MXNBHAU)
  CALL NEXTYPE1(GFP_XMCC%CLNAME(1:4),GFP_XMCC%CLNAME(5:),0,MXNBMOY)
  CALL NEXTYPE1(GFP_XLCC%CLNAME(1:4),GFP_XLCC%CLNAME(5:),0,MXNBBAS)
ENDIF

!        3.2.11 Indexes of ConVection

MXCAPE =0
MXMOCON=0
IF (LXICV) THEN
  CALL NEXTYPE1(GFP_XCAPE%CLNAME(1:4),GFP_XCAPE%CLNAME(5:),0,MXCAPE)
  CALL NEXTYPE1(GFP_XMOCO%CLNAME(1:3),GFP_XMOCO%CLNAME(4:),0,MXMOCON)
ENDIF

!        3.2.12 PBL fields 

MXUCLS=0
MXVCLS=0
MXTCLS=0
MXQCLS=0
MXRHCLS=0
MXTN=0
MXTX=0
MXHUN=0
MXHUX=0
IF (LXCLS) THEN
  CALL NEXTYPE1(GFP_X10U%CLNAME(1:3),GFP_X10U%CLNAME(4:),1,MXUCLS)
  CALL NEXTYPE1(GFP_X10V%CLNAME(1:3),GFP_X10V%CLNAME(4:),1,MXVCLS)
  CALL NEXTYPE1(GFP_X2T%CLNAME(1:3),GFP_X2T%CLNAME(4:),0,MXTCLS)
  CALL NEXTYPE1(GFP_X2RH%CLNAME(1:3),GFP_X2RH%CLNAME(4:),0,MXRHCLS)
  IF (LXQCLS) THEN
    CALL NEXTYPE1(GFP_X2SH%CLNAME(1:3),GFP_X2SH%CLNAME(4:),0,MXQCLS)
  ENDIF
ENDIF
IF (LXTTCLS) THEN
  CALL NEXTYPE1(GFP_XN2T%CLNAME(1:3),GFP_XN2T%CLNAME(4:),0,MXTN)
  CALL NEXTYPE1(GFP_XX2T%CLNAME(1:3),GFP_XX2T%CLNAME(4:),0,MXTX)
ENDIF
IF (LXHHCLS) THEN
  CALL NEXTYPE1(GFP_XN2HU%CLNAME(1:3),GFP_XN2HU%CLNAME(4:),0,MXHUN)
  CALL NEXTYPE1(GFP_XX2HU%CLNAME(1:3),GFP_XX2HU%CLNAME(4:),0,MXHUX)
ENDIF

!        3.2.13 PBL height 

MXCLPH=0
IF (LXCLP) THEN
  CALL NEXTYPE1(GFP_XCLPH%CLNAME(1:3),GFP_XCLPH%CLNAME(4:),0,MXCLPH)
ENDIF

!        3.2.14 Gusts 

MXUGST=0
MXVGST=0
IF (LXTGST) THEN
  CALL NEXTYPE1(GFP_XUGST%CLNAME(1:3),GFP_XUGST%CLNAME(4:),1,MXUGST)
  CALL NEXTYPE1(GFP_XVGST%CLNAME(1:3),GFP_XVGST%CLNAME(4:),1,MXVGST)
ENDIF

!        3.2.16 Theta'w' 

MXTHW=0
IF (LXTHW) THEN
  CALL NEXTYPE1(GFP_XTHW%CLNAME(1:3),GFP_XTHW%CLNAME(4:),0,MXTHW)
ENDIF

!        3.4 Count fields

NTYPXFU=IP
NFDXFU=IADD-1
LXFU=(NFDXFU > 0)

!      -----------------------------------------------------------

!*       4.    PRINT FINAL VALUES.
!              -------------------

WRITE(UNIT=KULOUT,FMT='('' COMMON YOMXFU '')')
WRITE(UNIT=KULOUT,FMT='('' LXFU = '',L2,'' LREAXFU = '',L2)') LXFU, LREAXFU
WRITE(UNIT=KULOUT,FMT='('' NFDXFU = '',I6,'' NTYPXFU = '',I6)') NFDXFU, NTYPXFU
WRITE(UNIT=KULOUT,FMT='('' NFRXFU = '',I7)') NFRXFU
WRITE(KULOUT,*) ' NXFUTS =  ',NXFUTS(0),(NXFUTS(J),J=1,ABS(NXFUTS(0)))
WRITE(UNIT=KULOUT,FMT='('' NFRRAZ = '',I6,'' N1RAZ = '',I6)') NFRRAZ, N1RAZ
WRITE(KULOUT,*) ' NRAZTS =  ',NRAZTS(0),(NRAZTS(J),J=1,ABS(NRAZTS(0)))
IF (LXFU) THEN
  WRITE(UNIT=KULOUT,FMT='('' LXTRD  = '',L2,'' LXTRC  = '',L2 &
   & ,'' LXTRT  = '',L2,'' LXPLC  = '',L2,'' LXPLSG = '',L2 &
   & ,'' LXTRCH = '',L2,'' LXPLS  = '',L2,'' LXPLSG = '',L2 &
   & ,'' LXPLSH = '',L2,'' LXR    = '',L2,'' LXSOIL = '',L2 &
   & ,'' LXNEBTT= '',L2,'' LXNEBPA= '',L2,'' LXICV  = '',L2 &
   & ,'' LXCLS  = '',L2,'' LXCLP  = '',L2 &
   & ,'' LXTGST = '',L2,'' LXTTCLS= '',L2,'' LXHHCLS= '',L2 &
   & ,'' LXQCLS = '',L2,'' LXTHW  = '',L2 &
   & )')&
   & LXTRD,LXTRC,LXTRT,LXPLC,LXPLCG,LXPLCH,LXPLS,LXPLSG,LXPLSH,LXR,LXSOIL,&
   & LXNEBTT,LXNEBPA,LXICV,LXCLS,LXCLP,LXTGST,LXTTCLS,LXHHCLS,LXQCLS,&
   & LXTHW 
  WRITE(UNIT=KULOUT,FMT='('' LTXTRD  = '',L2,'' LTXTRC  = '',L2 &
   & ,'' LTXTRT  = '',L2,'' LTXR    = '',L2,'' LTXNEB  = '',L2 &
   & ,'' LTXQICE = '',L2,'' LTXQLI  = '',L2)')&
   & LTXTRD,LTXTRC,LTXTRT,LTXR,LTXNEB,LTXQICE,LTXQLI
  WRITE(UNIT=KULOUT,FMT='('' MXTRDU ='',I3,'' MXTRDV ='',I3 &
   & ,'' MXTRCU ='',I3,'' MXTRCV ='',I3,'' MXDICQ ='',I3,'' MXDICS ='',I3 &
   & ,'' MXTRTU ='',I3,'' MXTRTV ='',I3,'' MXDITQ ='',I3,'' MXDITS ='',I3 &
   & ,'' MXPLCL ='',I3,'' MXPLSL ='',I3,'' MXPLCN ='',I3,'' MXPLSN ='',I3 &
   & ,'' MXRSO  ='',I3,'' MXRTH  ='',I3,'' MXNEB  ='',I3,'' MXNEBT ='',I3 &
   & ,'' MXFEVL ='',I3,'' MXFONTE='',I3,'' MXFCHSP='',I3,'' MXFEVV ='',I3 &
   & ,'' MXFLWSP='',I3,'' MXFTR  ='',I3,'' MXRUISL='',I3,'' MXRUIS ='',I3 &
   & ,'' MXRUISS='',I3,'' MXNBCON='',I3,'' MXNBHAU='',I3,'' MXNBMOY='',I3 &
   & ,'' MXNBBAS='',I3,'' MXCAPE ='',I3,'' MXMOCON='',I3,'' MXCLPH ='',I3 &
   & ,'' MXUGST ='',I3,'' MXVGST ='',I3,'' MXUCLS ='',I3 &
   & ,'' MXVCLS ='',I3,'' MXTCLS ='',I3,'' MXQCLS ='',I3,'' MXRHCLS='',I3 &
   & ,'' MXTN   ='',I3,'' MXTX   ='',I3,'' MXHUN  ='',I3,'' MXHUX  ='',I3 &
   & ,'' MXQICE ='',I3,'' MXQLI  ='',I3,'' MXTHW  ='',I3 &
   & )') &
   & MXTRDU,MXTRDV,MXTRCU,MXTRCV,MXDICQ,MXDICS,MXTRTU,MXTRTV,MXDITQ,MXDITS,&
   & MXPLCL,MXPLSL,MXPLCN,MXPLSN,MXRSO,MXRTH,MXNEB,MXNEBT,MXFEVL,&
   & MXFONTE,MXFCHSP,MXFEVV,MXFLWSP,MXFTR,MXRUISL,MXRUISP,MXRUISS,MXNBCON,&
   & MXNBHAU,MXNBMOY,MXNBBAS,MXCAPE,MXMOCON,MXCLPH,MXUGST,MXVGST,&
   & MXUCLS,MXVCLS,MXTCLS,MXQCLS,MXRHCLS,MXTN,MXTX,MXHUN,MXHUX  ,&
   & MXQICE,MXQLI,MXTHW
  WRITE(UNIT=KULOUT,&
   & FMT='('' THE FOLLOWING INSTANTANEOUS FLUXES WILL BE HANDLED : '')')  
  DO JF=1,NTYPXFU
    DO JL=1,TYPE_XFU(JF)%ILEV
      IF (TYPE_XFU(JF)%CLPREF(JL) == CLEVS(1)) THEN
        WRITE(UNIT=KULOUT,FMT='(A1,I3.3,A12,10X, ''PARITY = '',I1)') &
         & TRIM(TYPE_XFU(JF)%CLPREF(JL)),TYPE_XFU(JF)%INUMLEV(JL),&
         & TYPE_XFU(JF)%CLSUFF,TYPE_XFU(JF)%IPARITY  
      ELSE
        WRITE(UNIT=KULOUT,FMT='(A16,10X, ''PARITY = '',I1)') &
         & TRIM(TYPE_XFU(JF)%CLPREF(JL))//TYPE_XFU(JF)%CLSUFF,&
         & TYPE_XFU(JF)%IPARITY  
      ENDIF
    ENDDO
  ENDDO
ENDIF

IF (LHOOK) CALL DR_HOOK('SUXFU',1,ZHOOK_HANDLE)

!     ------------------------------------------------------------------

CONTAINS

SUBROUTINE NEXTYPE3(CDPREF,CDSUFF,KNLEV,KLEV,KPAR,KX)
                     
INTEGER(KIND=JPIM), INTENT(IN)  :: KLEV,KPAR
INTEGER(KIND=JPIM), INTENT(IN)  :: KNLEV(KLEV)
CHARACTER(LEN=*),   INTENT(IN)  :: CDPREF(KLEV)
CHARACTER(LEN=*),   INTENT(IN)  :: CDSUFF
INTEGER(KIND=JPIM), INTENT(OUT) :: KX

INTEGER(KIND=JPIM) :: J, ILEN
REAL(KIND=JPRB) :: ZHOOK_HANDLE_NEXT

IF (LHOOK) CALL DR_HOOK('SUXFU:NEXTYPE3',0,ZHOOK_HANDLE_NEXT)

IP=IP+1
DO J=1,KLEV
  ILEN=MIN(4,LEN(CDPREF(J)))
  TYPE_XFU(IP)%CLPREF(J)=CDPREF(J)(1:ILEN)
  TYPE_XFU(IP)%INUMLEV(J)=KNLEV(J)
ENDDO
ILEN=MIN(16,LEN(CDSUFF))
TYPE_XFU(IP)%CLSUFF=CDSUFF(1:ILEN)
TYPE_XFU(IP)%ILEV=KLEV
TYPE_XFU(IP)%IPARITY=KPAR
KX=IADD
IADD=IADD+KLEV

IF (LHOOK) CALL DR_HOOK('SUXFU:NEXTYPE3',1,ZHOOK_HANDLE_NEXT)

END SUBROUTINE NEXTYPE3

SUBROUTINE NEXTYPE1(CDPREF,CDSUFF,KPAR,KX)

INTEGER(KIND=JPIM), INTENT(IN)  :: KPAR
CHARACTER(LEN=*),   INTENT(IN)  :: CDPREF
CHARACTER(LEN=*),   INTENT(IN)  :: CDSUFF
INTEGER(KIND=JPIM), INTENT(OUT) :: KX

INTEGER(KIND=JPIM) :: ILEN
REAL(KIND=JPRB) :: ZHOOK_HANDLE_NEXT

IF (LHOOK) CALL DR_HOOK('SUXFU:NEXTYPE1',0,ZHOOK_HANDLE_NEXT)

IP=IP+1
ILEN=MIN(4,LEN(CDPREF))
TYPE_XFU(IP)%CLPREF(1)=CDPREF(1:ILEN)
TYPE_XFU(IP)%INUMLEV(1)=1
ILEN=MIN(16,LEN(CDSUFF))
TYPE_XFU(IP)%CLSUFF=CDSUFF(1:ILEN)
TYPE_XFU(IP)%ILEV=1
TYPE_XFU(IP)%IPARITY=KPAR
KX=IADD
IADD=IADD+1

IF (LHOOK) CALL DR_HOOK('SUXFU:NEXTYPE1',1,ZHOOK_HANDLE_NEXT)

END SUBROUTINE NEXTYPE1

END SUBROUTINE SUXFU
