SUBROUTINE WRTSV(YD_PVEIG,KEIG)

!**** *WRTSV*

!     Purpose.
!     --------
!           Write a SV file in FA format.

!**   Interface.
!     ----------
!        *CALL* *WRTSV*

!        Explicit arguments :
!        --------------------
!        None

!        Implicit arguments :
!        --------------------
!        None

!     Method.
!     -------
!        See documentation

!     Reference.
!     ----------
!        ???                                                

!     Author.
!     -------
!        Thierry Bergot :                   *Meteo France / CNRM GMME*

!     Modifications.
!     --------------
!        Original   : 98-02    
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMLUN   , ONLY : NULOUT
USE YOMVAR   , ONLY : NSIM4D, LTWLCZ, LTWGRA
USE CONTROL_VECTORS

IMPLICIT NONE

!     ------------------------------------------------------------------

TYPE(CONTROL_VECTOR),INTENT(INOUT) :: YD_PVEIG 
INTEGER(KIND=JPIM),INTENT(IN)    :: KEIG 
REAL(KIND=JPRB) :: ZNORM
INTEGER(KIND=JPIM) :: idum
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "cain.intfb.h"
#include "scaas.intfb.h"
#include "stepo.intfb.h"

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('WRTSV',0,ZHOOK_HANDLE)
idum=-999
WRITE(NULOUT,'('' >> Sub WRTSV <<'')')
WRITE(NULOUT,*) "wrtsv : ecriture en fic ARPEGE"
call SCAAS(idum,YD_PVEIG,YD_PVEIG,ZNORM)
write(nulout,*) "wrtsv : norme initiale = ",znorm
call CAIN(YD_PVEIG)
LTWLCZ=.TRUE.
LTWGRA=.FALSE.
NSIM4D=KEIG
call STEPO("A00000000")
LTWLCZ=.FALSE.

!     -----------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('WRTSV',1,ZHOOK_HANDLE)
END SUBROUTINE WRTSV
