SUBROUTINE ADDFGS

!     Purpose
!     -------
!       Add the first guess to model state

!     Author
!     ------
!       Y. Tremolet

!     Modifications
!     -------------
!       31-Oct-03: Original
!     ------------------------------------------------------------------

USE PARKIND1 , ONLY : JPRB, JPIM
USE YOMHOOK  , ONLY : LHOOK, DR_HOOK
USE YOMCT0   , ONLY : LELAM
USE YOMDIM   , ONLY : NFD2D, NS3D
USE YOMMP    , ONLY : NPSP
USE YOMSP    , ONLY : SPA3, SPA2, SP5A3, SP5A2, SPA1, SP5A1
USE YOMVAR   , ONLY : LTOVSCV
USE YOMTVRAD , ONLY : TOVSCVX, TOVSCVX5
USE YOMANCS  , ONLY : RMDI
USE TRAJECTORY_MOD, ONLY: GET_TRAJ_SPEC
USE YOMCVA   , ONLY : NVA3D

IMPLICIT NONE
REAL(KIND=JPRB) :: ZHOOK_HANDLE

!===================================
#include "abor1.intfb.h"
!===================================

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('ADDFGS',0,ZHOOK_HANDLE)

CALL GSTATS(15,0)
CALL GET_TRAJ_SPEC(SP5A3,SP5A2,SP5A1)
CALL GSTATS(15,1)

SPA3(:,:,:) = SPA3(:,:,:) + SP5A3(:,:,:)
IF (NPSP==1) THEN
  SPA2(:,1:NFD2D) = SPA2(:,1:NFD2D) + SP5A2(:,1:NFD2D)
ENDIF

! If Jb fields are spectral but model state is in grid point space
! Get initial time grid point trajectory and add to delta values
IF (NS3D/=NVA3D) CALL ABOR1 ('NS3D/=NVA3D NOT YET CODED')
!!IF (NS3D<NVA3D .AND. (YQ%LGP.AND.YQ%LSPJB).OR.(YO3%LGP.AND.YO3%LSPJB)) THEN
!!  ALLOCATE (ZGMV5(NPROMA,NFLEVG,YT5%NDIM,NGPBLKS))
!!  ALLOCATE (ZGMV5S(NPROMA,YT5%NDIMS,NGPBLKS))
!!  ALLOCATE (ZGFL5(NPROMA,NFLEVG,YGFL%NDIM5,NGPBLKS))
!!  ISTEP0=0
!!  CALL GET_TRAJ_GRID(ZGMV5,ZGMV5S,ZGFL5,KSTEP=ISTEP0)
!!  GFL(:,:,YQ%MP,:)=GFL(:,:,YQ%MP,:)+ZGFL5(:,:,YQ%MP,:)
!!  IF (YO3%LGP) GFL(:,:,YO3%MP,:)=GFL(:,:,YO3%MP,:)+ZGFL5(:,:,YO3%MP,:)
!!  DEALLOCATE(ZGMV5)
!!  DEALLOCATE(ZGMV5S)
!!  DEALLOCATE(ZGFL5)
!!ENDIF

!     1D FIELDS (MEAN WIND)
IF (LELAM) THEN
  SPA1(:,:) = SPA1(:,:) + SP5A1(:,:)
ENDIF

!     TOVS CONTROL VARIABLE
IF (LTOVSCV) THEN
  WHERE (TOVSCVX5(:,:) /= RMDI) TOVSCVX(:,:)=TOVSCVX(:,:)+TOVSCVX5(:,:)
ENDIF

IF (LHOOK) CALL DR_HOOK('ADDFGS',1,ZHOOK_HANDLE)
END SUBROUTINE ADDFGS
