SUBROUTINE DEALCOS

!**** *DEALCOS* - Deallocate the arrays for the cost function computation.

!     Purpose.
!     -------
!           Deallocation of the arrays needed to store the cost function
!     ,FJG,...

!**   Interface.
!**   ---------
!**   *CALL* * DEALCOS*
!**   DEALCOS is called from routine FREEMEM

!     Author.
!     -------
!        R. El Khatib *METEO-FRANCE*

!     Modifications.
!     --------------
!        Original : 95-09-28
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      01-Dec-2003 CY28R1 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCOSJO , ONLY : FJOS
USE YOMCOSJC , ONLY : FJCCOST  ,RINCLJC
USE YOMCOSJR , ONLY : FALTSEL  ,FSURSEL  ,FSPALT   ,FSPSUR

IMPLICIT NONE

REAL(KIND=JPRB) :: ZHOOK_HANDLE
!------------------------------------------------------

!*        1.    DEALLOCATE
!               ----------

IF (LHOOK) CALL DR_HOOK('DEALCOS',0,ZHOOK_HANDLE)
IF (ALLOCATED(FJOS   )) DEALLOCATE(FJOS)
IF (ALLOCATED(FJCCOST)) DEALLOCATE(FJCCOST)
IF (ALLOCATED(FALTSEL)) DEALLOCATE(FALTSEL)
IF (ALLOCATED(FSURSEL)) DEALLOCATE(FSURSEL)
IF (ALLOCATED(FSPALT )) DEALLOCATE(FSPALT)
IF (ALLOCATED(FSPSUR )) DEALLOCATE(FSPSUR)
IF (ALLOCATED(RINCLJC)) DEALLOCATE(RINCLJC)

IF (LHOOK) CALL DR_HOOK('DEALCOS',1,ZHOOK_HANDLE)
END SUBROUTINE DEALCOS
