SUBROUTINE DEALSC2

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMWM    , ONLY : FTHSOR
USE YOMAUXB  , ONLY : GAUXBUF
USE YOMGFUB  , ONLY : GFUBUF
USE YOMXFUB  , ONLY : XFUBUF
USE YOMSPHB  , ONLY : SPHBUF
USE YOMHOUB  , ONLY : HOUBUF
USE YOMPINB  , ONLY : RPINBUF
USE YOMLCZ   , ONLY : RLANBUF
USE YOMMP    , ONLY : NSLSTA   ,NSLONL   ,NSLOFF   ,NSLEXT   ,&
 & NFPSTA   ,NFPONL   ,NFPOFF   ,NFPEXT   ,&
 & NOBSTA   ,NOBONL   ,NOBOFF  
USE YOMSLREP , ONLY : NSLMAP   ,RSASIGN
USE YOMTPHY  , ONLY : TRAJPHYS ,TRAJPHTE ,TRAJPHSF
USE YOMTRSL  , ONLY : TRAJSL
USE YOMRCOEF , ONLY : SOLRAD   ,THERRAD  ,TRWEIGHT ,TRMATSUM
USE YOMANEB  , ONLY : ANEBUF   ,NANERADL
USE YOMNCL   , ONLY : GPCLOUD5 ,GPCLOUDIN
USE YOELWRAD , ONLY : RADLWM, RADLWM5
USE YOEGWDWMS, ONLY : TGWDWMS  ,TGWDWMS5
USE SURFACE_FIELDS_MIX, ONLY : DEALLO_SURF
USE GRIDPOINT_BUFFERS_MIX , ONLY : ALLOCATED_GRIDPOINT_BUFFER ,&
 & DEALLOCATE_GRIDPOINT_BUFFER  
USE YOENEUR  , ONLY : NBNEUR,WNELN,RAPIN,ENTREEMOY,&
 & RAPOUT,SORTIEMOY,PDFSDX  

USE YOMSEKF  , ONLY : FKF_TENT_1, FKF_TENT_2, FKF_TENT_3, FKF_TENT_4, &
 & FKF_TENT, FKF_TENQ, FKF_TENU, FKF_TENV, FKF_SURF_SO, FKF_SURF_TH, FKF_SURF_CR, &
 & FKF_SURF_LR, VOL_SM_FG, T2M_FG, TD2M_FG, &
! & VSM_FG_OBS_S, T2M_FG_OBS_S, TD2M_FG_OBS_S, VSM_FG_ANA, &
 & VSM_PERT_RES, T2M_OBS, TD2M_OBS, &
 & NOBS_TSTEP, VSM_ANAL_INC, SEKF_INC, SEKF_F, &
 & SEKF_Q, VSM_INC_L1, VSM_INC_L2, VSM_INC_L3, &
 & SEKF_DEBUG_3D, SEKF_DEBUG, &
 & SEKF_A, SEKF_B, SEKF_G, SEKF_J, NANA_TSTEP, &
! For offline Jacobians
! for VDFOUTER STORE/RESTORE
 & SKF_ZWSA,SKF_ZTSA, SKF_ZAZ0M,SKF_ZAZ0H, &
 & SKF_PVDIS,SKF_PVDISG, SKF_ZDISSGW, SKF_PFTLHEV, SKF_PFTLHSB,&
 & SKF_PFWSB,SKF_ZBIR,SKF_ZVAR, &
 & SKF_PUCFL,SKF_PVCFL,SKF_PTCFL,SKF_PDCFL,&
 & SKF_PQCFL,SKF_ZZINV,SKF_PBLH,ISKF_IHPBLN, &
 & SKF_ZFRSOTI,SKF_ZEVAPSNW,SKF_ZGUST,&
 & SKF_ZWUAVG,LSKF_LLNODECP,ISKF_IPBLTYPE, &
 & SKF_PTENT,SKF_PTENQ,SKF_ZTENL,SKF_ZTENI,SKF_ZTENA,SKF_PTENU,SKF_PTENV, &
 & SKF_PTLE1, SKF_PUSTRTI,SKF_PVSTRTI,SKF_PAHFSTI,SKF_PEVAPTI,SKF_PTSKTI, &
 & SKF_PDIFTS,SKF_PDIFTQ,SKF_PDIFTL,SKF_PDIFTI,SKF_PSTRTU,&
 & SKF_PSTRTV,SKF_PTOFDU,SKF_PTOFDV,SKF_PSTRDU,SKF_PSTRDV,SKF_zkh_vdf, &
 !for surftstp STORE/RESTORE
 & SKF_PFTG12,SKF_PFWROD,SKF_PFWRO1,SKF_PFWG12,SKF_PFWMLT,SKF_PFWEV,SKF_PENES,&
 & SKF_PDIFM, SKF_PDIFT,SKF_PDIFS, &
 & SKF_PSNSE1,SKF_PTSNE1,SKF_PASNE1,SKF_PRSNE1,SKF_PTSAE1,SKF_PTIAE1,&
 & SKF_PWLE1,SKF_PWSAE1,SKF_PTLICEE1,SKF_PTLMNWE1,&
 & SKF_PTLWMLE1,SKF_PTLBOTE1,SKF_PTLSFE1,&
 & SKF_PHLICEE1,SKF_PHLMLE1,SKF_PUOE1,SKF_PVOE1,SKF_PTOE1,SKF_PSOE1,&
! add forgotten variables of the sekf
 & SKF_PTENT_CUM,SKF_PTENQ_CUM,SKF_PU10N,SKF_PV10N,SKF_PTL,&
 & SKF_PZO,SKF_PHO,SKF_PHO_INV,SKF_PDO,SKF_PADVT,SKF_PADVS,&
 & SKF_PTRI0,SKF_PTRI1,SKF_PSWDK_SAVE,SKF_PUO0,SKF_PVO0,&
 & SKF_PTO0,SKF_PSO0,SKF_PUOC,SKF_PVOC,SKF_PUSTRC,SKF_PVSTRC



!**** *DEALSC2*   - Routine to release model gridpoint buffers and other
!                    arrays allocated in SUSC2

!     Purpose.
!     --------
!           To deallocate arrays
!**   Interface.
!     ----------
!        *CALL* *DEALSC2

!        Explicit arguments :
!        --------------------
!        None.

!        Implicit arguments :
!        --------------------

!     Method.
!     -------
!        See documentation

!     Externals.
!     ----------
!        Called by FREEMEM.

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     Author.
!     -------
!        R. El Khatib *METEO-FRANCE*

!     Modifications.
!     --------------
!        Original : 95-09-28
!        Modified JUN 1997 by K. YESSAD: add missing deallocations.
!                  2002-10-30 M. Janiskova: deallocations for linearized
!                                           radiation and cloud schemes
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      01-Dec-2003 CY28R1 Cleaning
!        M.Drusch      23-May-2005 dealocation for SEKF tendencies
!        M.Janiskova   10-Apr-2008 deallocation for linearized LW fields
!        P. de Rosnay  08-Mar-2009 dealocation for SEKF oofline Jacbians variables
!        K. Yessad (Sep 2008): prune enhanced diffusion (lfrein).
!        M.Janiskova   21-Sep-2009 dealocation for linearised non-orog.gwd
!     ------------------------------------------------------------------

IMPLICIT NONE

REAL(KIND=JPRB) :: ZHOOK_HANDLE

!      ----------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('DEALSC2',0,ZHOOK_HANDLE)
!      ----------------------------------------------------------------

!*       3.    RELEASE ARRAYS ALLOCATED IN SUDYN
!              ---------------------------------

IF (ALLOCATED(FTHSOR))     DEALLOCATE(FTHSOR)

!*       4.    RELEASE ARRAYS ALLOCATED IN SUSC2
!              ---------------------------------

CALL DEALLO_SURF

IF (ALLOCATED_GRIDPOINT_BUFFER(GAUXBUF)) &
 & CALL DEALLOCATE_GRIDPOINT_BUFFER(GAUXBUF)  
IF (ALLOCATED_GRIDPOINT_BUFFER(GFUBUF))  &
 & CALL DEALLOCATE_GRIDPOINT_BUFFER(GFUBUF)  
IF (ALLOCATED_GRIDPOINT_BUFFER(XFUBUF))  &
 & CALL DEALLOCATE_GRIDPOINT_BUFFER(XFUBUF)  
IF (ALLOCATED(NANERADL))   DEALLOCATE(NANERADL)

IF (ALLOCATED(SPHBUF))     DEALLOCATE(SPHBUF)
IF (ALLOCATED(HOUBUF))     DEALLOCATE(HOUBUF)
IF (ALLOCATED(RPINBUF))    DEALLOCATE(RPINBUF)

IF (ALLOCATED(NSLSTA))     DEALLOCATE(NSLSTA)
IF (ALLOCATED(NSLONL))     DEALLOCATE(NSLONL)
IF (ALLOCATED(NSLOFF))     DEALLOCATE(NSLOFF)
IF (ALLOCATED(NSLEXT))     DEALLOCATE(NSLEXT)
IF (ALLOCATED(NSLMAP))     DEALLOCATE(NSLMAP)
IF (ALLOCATED(RSASIGN))    DEALLOCATE(RSASIGN)
IF (ALLOCATED(NFPSTA))     DEALLOCATE(NFPSTA)
IF (ALLOCATED(NFPONL))     DEALLOCATE(NFPONL)
IF (ALLOCATED(NFPOFF))     DEALLOCATE(NFPOFF)
IF (ALLOCATED(NFPEXT))     DEALLOCATE(NFPEXT)
IF (ALLOCATED(NOBSTA))     DEALLOCATE(NOBSTA)
IF (ALLOCATED(NOBONL))     DEALLOCATE(NOBONL)
IF (ALLOCATED(NOBOFF))     DEALLOCATE(NOBOFF)
IF (ALLOCATED(TRAJPHYS))   DEALLOCATE(TRAJPHYS)
IF (ALLOCATED(TRAJPHTE))   DEALLOCATE(TRAJPHTE)
IF (ALLOCATED(TRAJPHSF))   DEALLOCATE(TRAJPHSF)
IF (ALLOCATED(TRAJSL))     DEALLOCATE(TRAJSL)
IF (ALLOCATED(GPCLOUD5))   DEALLOCATE(GPCLOUD5)
IF (ALLOCATED(GPCLOUDIN))  DEALLOCATE(GPCLOUDIN)
IF (ALLOCATED(RADLWM))     DEALLOCATE(RADLWM)
IF (ALLOCATED(RADLWM5))    DEALLOCATE(RADLWM5)
IF (ALLOCATED(TGWDWMS))    DEALLOCATE(TGWDWMS)
IF (ALLOCATED(TGWDWMS5))   DEALLOCATE(TGWDWMS5)
IF (ALLOCATED(SOLRAD))     DEALLOCATE(SOLRAD)
IF (ALLOCATED(THERRAD))    DEALLOCATE(THERRAD)
IF (ALLOCATED(TRWEIGHT))   DEALLOCATE(TRWEIGHT)
IF (ALLOCATED(TRMATSUM))   DEALLOCATE(TRMATSUM)

IF (ALLOCATED(NBNEUR))     DEALLOCATE(NBNEUR)
IF (ALLOCATED(WNELN))      DEALLOCATE(WNELN)
IF (ALLOCATED(RAPIN))      DEALLOCATE(RAPIN)
IF (ALLOCATED(ENTREEMOY))  DEALLOCATE(ENTREEMOY)
IF (ALLOCATED(RAPOUT))     DEALLOCATE(RAPOUT)
IF (ALLOCATED(SORTIEMOY))  DEALLOCATE(SORTIEMOY)
IF (ALLOCATED(PDFSDX))     DEALLOCATE(PDFSDX)

IF (ALLOCATED_GRIDPOINT_BUFFER(ANEBUF)) &
 & CALL DEALLOCATE_GRIDPOINT_BUFFER(ANEBUF)  

!*       4.    RELEASE ARRAYS ALLOCATED IN SULCZ
!              ---------------------------------

IF (ALLOCATED(RLANBUF))    DEALLOCATE(RLANBUF)

!*       5.    RELEASE ARRAYS ALLOCATED IN SUSEKF
!              ---------------------------------

IF (ALLOCATED(FKF_TENT_1))    DEALLOCATE(FKF_TENT_1)
IF (ALLOCATED(FKF_TENT_2))    DEALLOCATE(FKF_TENT_2)
IF (ALLOCATED(FKF_TENT_3))    DEALLOCATE(FKF_TENT_3)
IF (ALLOCATED(FKF_TENT_4))    DEALLOCATE(FKF_TENT_4)

IF (ALLOCATED(FKF_TENT))    DEALLOCATE(FKF_TENT)
IF (ALLOCATED(FKF_TENQ))    DEALLOCATE(FKF_TENQ)
IF (ALLOCATED(FKF_TENU))    DEALLOCATE(FKF_TENU)
IF (ALLOCATED(FKF_TENV))    DEALLOCATE(FKF_TENV)

IF (ALLOCATED(FKF_SURF_SO)) DEALLOCATE(FKF_SURF_SO)
IF (ALLOCATED(FKF_SURF_TH)) DEALLOCATE(FKF_SURF_TH)
IF (ALLOCATED(FKF_SURF_CR)) DEALLOCATE(FKF_SURF_CR)
IF (ALLOCATED(FKF_SURF_LR)) DEALLOCATE(FKF_SURF_LR)

IF (ALLOCATED(VOL_SM_FG)) DEALLOCATE(VOL_SM_FG)
IF (ALLOCATED(T2M_FG)) DEALLOCATE(T2M_FG)
IF (ALLOCATED(TD2M_FG)) DEALLOCATE(TD2M_FG)

IF (ALLOCATED(NOBS_TSTEP)) DEALLOCATE(NOBS_TSTEP)
IF (ALLOCATED(NANA_TSTEP)) DEALLOCATE(NANA_TSTEP)

IF (ALLOCATED(VSM_PERT_RES)) DEALLOCATE(VSM_PERT_RES)

!IF (ALLOCATED(VSM_FG_OBS_S)) DEALLOCATE(VSM_FG_OBS_S)
!IF (ALLOCATED(VSM_FG_ANA)) DEALLOCATE(VSM_FG_ANA)
!IF (ALLOCATED(T2M_FG_OBS_S)) DEALLOCATE(T2M_FG_OBS_S)
!IF (ALLOCATED(TD2M_FG_OBS_S)) DEALLOCATE(TD2M_FG_OBS_S)

IF (ALLOCATED(T2M_OBS)) DEALLOCATE(T2M_OBS)
IF (ALLOCATED(TD2M_OBS)) DEALLOCATE(TD2M_OBS)

IF (ALLOCATED(VSM_ANAL_INC)) DEALLOCATE(VSM_ANAL_INC)
IF (ALLOCATED(SEKF_INC)) DEALLOCATE(SEKF_INC)
IF (ALLOCATED(SEKF_F)) DEALLOCATE(SEKF_F)
IF (ALLOCATED(VSM_INC_L1)) DEALLOCATE(VSM_INC_L1)
IF (ALLOCATED(VSM_INC_L2)) DEALLOCATE(VSM_INC_L2)
IF (ALLOCATED(VSM_INC_L3)) DEALLOCATE(VSM_INC_L3)
IF (ALLOCATED(SEKF_Q)) DEALLOCATE(SEKF_Q)
IF (ALLOCATED(SEKF_DEBUG_3D)) DEALLOCATE(SEKF_DEBUG_3D)
IF (ALLOCATED(SEKF_DEBUG)) DEALLOCATE(SEKF_DEBUG)

IF (ALLOCATED(SEKF_A)) DEALLOCATE(SEKF_A)
IF (ALLOCATED(SEKF_B)) DEALLOCATE(SEKF_B)
IF (ALLOCATED(SEKF_G)) DEALLOCATE(SEKF_G)
IF (ALLOCATED(SEKF_J)) DEALLOCATE(SEKF_J)

! OFFLINE JACOBIANS:
! VDFOUTER
IF (ALLOCATED(ISKF_IHPBLN)) DEALLOCATE(ISKF_IHPBLN)
IF (ALLOCATED(ISKF_IPBLTYPE)) DEALLOCATE(ISKF_IPBLTYPE)
IF (ALLOCATED(LSKF_LLNODECP)) DEALLOCATE(LSKF_LLNODECP)

IF (ALLOCATED(SKF_ZTSA)) DEALLOCATE(SKF_ZTSA) 
IF (ALLOCATED(SKF_ZWSA)) DEALLOCATE(SKF_ZWSA)

IF (ALLOCATED(SKF_ZAZ0M)) DEALLOCATE(SKF_ZAZ0M) 
IF (ALLOCATED(SKF_ZAZ0H)) DEALLOCATE(SKF_ZAZ0H)
IF (ALLOCATED(SKF_PVDIS)) DEALLOCATE(SKF_PVDIS)
IF (ALLOCATED(SKF_PVDISG)) DEALLOCATE(SKF_PVDISG)
IF (ALLOCATED(SKF_ZDISSGW)) DEALLOCATE(SKF_ZDISSGW)
IF (ALLOCATED(SKF_PFTLHEV)) DEALLOCATE(SKF_PFTLHEV)
IF (ALLOCATED(SKF_PFTLHSB)) DEALLOCATE(SKF_PFTLHSB)
IF (ALLOCATED(SKF_PFWSB)) DEALLOCATE(SKF_PFWSB)
IF (ALLOCATED(SKF_ZBIR)) DEALLOCATE(SKF_ZBIR)
IF (ALLOCATED(SKF_ZVAR)) DEALLOCATE(SKF_ZVAR)
IF (ALLOCATED(SKF_PUCFL)) DEALLOCATE(SKF_PUCFL)
IF (ALLOCATED(SKF_PVCFL)) DEALLOCATE(SKF_PVCFL)
IF (ALLOCATED(SKF_PTCFL)) DEALLOCATE(SKF_PTCFL)
IF (ALLOCATED(SKF_PDCFL)) DEALLOCATE(SKF_PDCFL)
IF (ALLOCATED(SKF_PQCFL)) DEALLOCATE(SKF_PQCFL)
IF (ALLOCATED(SKF_ZZINV)) DEALLOCATE(SKF_ZZINV)
IF (ALLOCATED(SKF_PBLH)) DEALLOCATE(SKF_PBLH)
IF (ALLOCATED(SKF_ZFRSOTI)) DEALLOCATE(SKF_ZFRSOTI)
IF (ALLOCATED(SKF_ZEVAPSNW)) DEALLOCATE(SKF_ZEVAPSNW)
IF (ALLOCATED(SKF_ZGUST)) DEALLOCATE(SKF_ZGUST)
IF (ALLOCATED(SKF_ZWUAVG)) DEALLOCATE(SKF_ZWUAVG)
IF (ALLOCATED(SKF_PTENT)) DEALLOCATE(SKF_PTENT)
IF (ALLOCATED(SKF_PTENQ)) DEALLOCATE(SKF_PTENQ)
IF (ALLOCATED(SKF_ZTENA)) DEALLOCATE(SKF_ZTENA)
IF (ALLOCATED(SKF_ZTENI)) DEALLOCATE(SKF_ZTENI)
IF (ALLOCATED(SKF_ZTENL)) DEALLOCATE(SKF_ZTENL)
IF (ALLOCATED(SKF_PTENU)) DEALLOCATE(SKF_PTENU)
IF (ALLOCATED(SKF_PTENV)) DEALLOCATE(SKF_PTENV)
IF (ALLOCATED(SKF_PTLE1)) DEALLOCATE(SKF_PTLE1)
IF (ALLOCATED(SKF_PUSTRTI)) DEALLOCATE(SKF_PUSTRTI)
IF (ALLOCATED(SKF_PVSTRTI)) DEALLOCATE(SKF_PVSTRTI)
IF (ALLOCATED(SKF_PAHFSTI)) DEALLOCATE(SKF_PAHFSTI)
IF (ALLOCATED(SKF_PEVAPTI)) DEALLOCATE(SKF_PEVAPTI)
IF (ALLOCATED(SKF_PTSKTI)) DEALLOCATE(SKF_PTSKTI)
IF (ALLOCATED(SKF_PDIFTS)) DEALLOCATE(SKF_PDIFTS)
IF (ALLOCATED(SKF_PDIFTQ)) DEALLOCATE(SKF_PDIFTQ)
IF (ALLOCATED(SKF_PDIFTL)) DEALLOCATE(SKF_PDIFTL)
IF (ALLOCATED(SKF_PDIFTI)) DEALLOCATE(SKF_PDIFTI)
IF (ALLOCATED(SKF_PSTRTU)) DEALLOCATE(SKF_PSTRTU)
IF (ALLOCATED(SKF_PSTRTV)) DEALLOCATE(SKF_PSTRTV)
IF (ALLOCATED(SKF_PTOFDU)) DEALLOCATE(SKF_PTOFDU)
IF (ALLOCATED(SKF_PTOFDV)) DEALLOCATE(SKF_PTOFDV)
IF (ALLOCATED(SKF_PSTRDU)) DEALLOCATE(SKF_PSTRDU)
IF (ALLOCATED(SKF_PSTRDV)) DEALLOCATE(SKF_PSTRDV)
IF (ALLOCATED(SKF_ZKH_VDF)) DEALLOCATE(SKF_ZKH_VDF)
!IF (ALLOCATED(SKF_PDHTLS)) DEALLOCATE(SKF_PDHTLS)
!IF (ALLOCATED(SKF_PDHTSS)) DEALLOCATE(SKF_PDHTSS)
!IF (ALLOCATED(SKF_PDHTTS)) DEALLOCATE(SKF_PDHTTS)
!IF (ALLOCATED(SKF_PDHTIS)) DEALLOCATE(SKF_PDHTIS)

!SUFTSTP
IF (ALLOCATED(SKF_PFTG12)) DEALLOCATE(SKF_PFTG12)
IF (ALLOCATED(SKF_PFWROD)) DEALLOCATE(SKF_PFWROD)
IF (ALLOCATED(SKF_PFWRO1)) DEALLOCATE(SKF_PFWRO1)
IF (ALLOCATED(SKF_PFWG12)) DEALLOCATE(SKF_PFWG12)
IF (ALLOCATED(SKF_PFWMLT)) DEALLOCATE(SKF_PFWMLT)
IF (ALLOCATED(SKF_PFWEV)) DEALLOCATE(SKF_PFWEV)
IF (ALLOCATED(SKF_PENES)) DEALLOCATE(SKF_PENES)
IF (ALLOCATED(SKF_PDIFM)) DEALLOCATE(SKF_PDIFM)
IF (ALLOCATED(SKF_PDIFT)) DEALLOCATE(SKF_PDIFT)
IF (ALLOCATED(SKF_PDIFS)) DEALLOCATE(SKF_PDIFS)
IF (ALLOCATED(SKF_PSNSE1)) DEALLOCATE(SKF_PSNSE1)
IF (ALLOCATED(SKF_PTSNE1)) DEALLOCATE(SKF_PTSNE1)
IF (ALLOCATED(SKF_PASNE1)) DEALLOCATE(SKF_PASNE1)
IF (ALLOCATED(SKF_PRSNE1)) DEALLOCATE(SKF_PRSNE1)
IF (ALLOCATED(SKF_PTSAE1)) DEALLOCATE(SKF_PTSAE1)
IF (ALLOCATED(SKF_PTIAE1)) DEALLOCATE(SKF_PTIAE1)
IF (ALLOCATED(SKF_PWLE1)) DEALLOCATE(SKF_PWLE1)
IF (ALLOCATED(SKF_PWSAE1)) DEALLOCATE(SKF_PWSAE1)
IF (ALLOCATED(SKF_PTLICEE1)) DEALLOCATE(SKF_PTLICEE1)
IF (ALLOCATED(SKF_PTLMNWE1)) DEALLOCATE(SKF_PTLMNWE1)
IF (ALLOCATED(SKF_PTLWMLE1)) DEALLOCATE(SKF_PTLWMLE1)
IF (ALLOCATED(SKF_PTLBOTE1)) DEALLOCATE(SKF_PTLBOTE1)
IF (ALLOCATED(SKF_PTLSFE1)) DEALLOCATE(SKF_PTLSFE1)
IF (ALLOCATED(SKF_PHLICEE1)) DEALLOCATE(SKF_PHLICEE1)
IF (ALLOCATED(SKF_PHLMLE1)) DEALLOCATE(SKF_PHLMLE1)
IF (ALLOCATED(SKF_PUOE1)) DEALLOCATE(SKF_PUOE1)
IF (ALLOCATED(SKF_PVOE1)) DEALLOCATE(SKF_PVOE1)
IF (ALLOCATED(SKF_PTOE1)) DEALLOCATE(SKF_PTOE1)
IF (ALLOCATED(SKF_PSOE1)) DEALLOCATE(SKF_PSOE1)
!SEKF forgotten variable...
IF (ALLOCATED(SKF_PTENT_CUM)) DEALLOCATE(SKF_PTENT_CUM)
IF (ALLOCATED(SKF_PTENQ_CUM)) DEALLOCATE(SKF_PTENQ_CUM)
IF (ALLOCATED(SKF_PU10N)) DEALLOCATE(SKF_PU10N)
IF (ALLOCATED(SKF_PV10N)) DEALLOCATE(SKF_PV10N)
IF (ALLOCATED(SKF_PTL)) DEALLOCATE(SKF_PTL)
IF (ALLOCATED(SKF_PZO)) DEALLOCATE(SKF_PZO)
IF (ALLOCATED(SKF_PHO)) DEALLOCATE(SKF_PHO)
IF (ALLOCATED(SKF_PHO_INV)) DEALLOCATE(SKF_PHO_INV)
IF (ALLOCATED(SKF_PDO)) DEALLOCATE(SKF_PDO)
IF (ALLOCATED(SKF_PADVT)) DEALLOCATE(SKF_PADVT)
IF (ALLOCATED(SKF_PADVS)) DEALLOCATE(SKF_PADVS)
IF (ALLOCATED(SKF_PTRI0)) DEALLOCATE(SKF_PTRI0)
IF (ALLOCATED(SKF_PTRI1)) DEALLOCATE(SKF_PTRI1)
IF (ALLOCATED(SKF_PSWDK_SAVE)) DEALLOCATE(SKF_PSWDK_SAVE)
IF (ALLOCATED(SKF_PUO0)) DEALLOCATE(SKF_PUO0)
IF (ALLOCATED(SKF_PVO0)) DEALLOCATE(SKF_PVO0)
IF (ALLOCATED(SKF_PTO0)) DEALLOCATE(SKF_PTO0)
IF (ALLOCATED(SKF_PSO0)) DEALLOCATE(SKF_PSO0)
IF (ALLOCATED(SKF_PUOC)) DEALLOCATE(SKF_PUOC)
IF (ALLOCATED(SKF_PVOC)) DEALLOCATE(SKF_PVOC)
IF (ALLOCATED(SKF_PUSTRC)) DEALLOCATE(SKF_PUSTRC)
IF (ALLOCATED(SKF_PVSTRC)) DEALLOCATE(SKF_PVSTRC)



!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('DEALSC2',1,ZHOOK_HANDLE)
END SUBROUTINE DEALSC2
