SUBROUTINE DEALSEKF

!**** *FREEMEM*   - Routine to free memory used by pointer allocations

!     Purpose.
!     --------
!           To deallocate arrays

!**   Interface.
!     ----------
!        *CALL* *DEALSEKF*

!        Explicit arguments :
!        --------------------
!        None.

!        Implicit arguments :
!        --------------------

!     Method.
!     -------
!        See documentation

!     Externals.
!     ----------
!        Called by CSEKF2.

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     Author.
!     -------
!        Copy from ??? *ECMWF*

!     Modifications.
!     --------------
!        Original : 17-01-07
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCT0   , ONLY : LELAM
USE YOMRFPB  , ONLY : RFPBUF   ,NSTARFPB
USE YOMAFPB  , ONLY : AFPBUF

IMPLICIT NONE

REAL(KIND=JPRB) :: ZHOOK_HANDLE

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('DEALSEKF',0,ZHOOK_HANDLE)

!*       0.    RELEASE MD

IF (ALLOCATED(NSTARFPB)) DEALLOCATE(NSTARFPB)
IF (ALLOCATED(RFPBUF))   DEALLOCATE(RFPBUF)
IF (ALLOCATED(AFPBUF))   DEALLOCATE(AFPBUF)

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('DEALSEKF',1,ZHOOK_HANDLE)
END SUBROUTINE DEALSEKF
