SUBROUTINE PRTIME(CDGREP)

!     Purpose.
!     --------
!       Prints current date and time.

!     Author.
!     -------
!       Y. Tremolet

!     Modifications.
!     --------------
!       Original : 22-Feb-2005
! ----------------------------------------------------------------------

USE PARKIND1, ONLY: JPIM, JPIB, JPRB
USE YOMHOOK , ONLY: LHOOK, DR_HOOK
USE YOMRIP  , ONLY: NINDAT, NSSSSS, RSTATI
USE YOMCST  , ONLY: RDAY
USE YOMLUN  , ONLY: NULOUT

IMPLICIT NONE

CHARACTER(LEN=*), INTENT(IN) :: CDGREP

INTEGER(KIND=JPIM) :: iyy,imm,idd,is,im,ih
INTEGER(KIND=JPIM) :: iy0,im0,id0,inc,imon(12)
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "updcal.intfb.h"
#include "fcttim.h"

! ----------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('PRTIME',0,ZHOOK_HANDLE)

iy0=NCCAA(NINDAT)
im0=NMM(NINDAT)
id0=NDD(NINDAT)
inc=(NSSSSS+NINT(RSTATI,JPIB))/NINT(RDAY)
CALL UPDCAL(id0,im0,iy0,inc,idd,imm,iyy,imon,-1)

write(NULOUT,'(A,A,I4,2(''-'',I2.2))')CDGREP,' Current date is: ',iyy,imm,idd

is=MOD(NSSSSS+NINT(RSTATI,JPIB),NINT(RDAY))
ih=is/3600
is=is-3600*ih
im=is/60
is=is-60*im

write(NULOUT,'(A,A,3(I2.2,A))')CDGREP,' Current time is: ', &
                             & ih,'h',im,':',is,' GMT'

IF (LHOOK) CALL DR_HOOK('PRTIME',1,ZHOOK_HANDLE)
END SUBROUTINE PRTIME
