SUBROUTINE STATE2SPECAD(YDSPEC)

!    Purpose.
!    --------
!      Copy hard coded model state into spectral field (adjoint).

!    Author.
!    -------
!      Y.Tremolet

!    Modifications.
!    --------------
!      Original: 09-Dec-2005
!-----------------------------------------------------------------------

USE PARKIND1, ONLY: JPRB, JPIM
USE YOMHOOK , ONLY: LHOOK, DR_HOOK
USE YOMDIM  , ONLY: NSMAX, NS3D, NFD2D, NPROMA
USE YOMMP   , ONLY: NPSP, NBSETLEV
USE YOMSP   , ONLY: SPA3, SPA2
USE YOMGFL  , ONLY: GFL
USE YOM_YGFL, ONLY: YGFLC, YGFL ! YQ, YO3
USE SPECTRAL_FIELDS_MOD

IMPLICIT NONE
TYPE(SPECTRAL_FIELD), INTENT(INOUT) :: YDSPEC

INTEGER(KIND=JPIM) :: igrd, JF, JGFL
REAL(KIND=JPRB) :: ZHOOK_HANDLE

INTERFACE
#include "dir_transad.h"
END INTERFACE
#include "abor1.intfb.h"

!-----------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('STATE2SPECAD',0,ZHOOK_HANDLE)

IF (YDSPEC%NSMAX/=NSMAX) CALL ABOR1('STATE2SPECAD: Error resolution')
!igrd=0
!IF (YQ%LGP)  igrd=igrd+1
!IF (YO3%LGP) igrd=igrd+1
!IF (YDSPEC%NS3D/=NS3D+igrd) CALL ABOR1('STATE2SPECAD: Error 3D fields')
!IF (YDSPEC%NS2G/=NFD2D) CALL ABOR1('STATE2SPECAD: Error 2D fields')

SPA3(:,:,:)=SPA3(:,:,:)+YDSPEC%SP3D(:,:,1:NS3D)
IF (NPSP==1) SPA2(:,1:NFD2D)=SPA2(:,1:NFD2D)+YDSPEC%SP2D(:,:)

!IF (YQ%LGP) THEN
!!  GFL(:,:,YQ%MP,:)=0.0_JPRB
!  CALL DIR_TRANSAD(PGP=GFL(:,:,YQ%MP,:),PSPSCALAR=YDSPEC%HUM, &
!                 & KVSETSC=NBSETLEV,KPROMA=NPROMA)
!ENDIF

!IF (YO3%LGP) THEN
!!  GFL(:,:,YO3%MP,:)=0.0_JPRB
!  CALL DIR_TRANSAD(PGP=GFL(:,:,YO3%MP,:),PSPSCALAR=YDSPEC%OZN, &
!                 & KVSETSC=NBSETLEV,KPROMA=NPROMA)
!ENDIF

DO JF=1,YDSPEC%NS3D
  DO JGFL=1,YGFL%NUMFLDS
    print*,'STATE2SPEC - JF, JGFL, YDSPEC%NGRIB3, YGFLC%IGRBCODE:',JF, JGFL, &
    & YDSPEC%NGRIB3(JF), YGFLC(JGFL)%IGRBCODE
    IF(YDSPEC%NGRIB3(JF)==YGFLC(JGFL)%IGRBCODE .AND. YGFLC(JGFL)%LGP) THEN
      CALL DIR_TRANSAD(PGP=GFL(:,:,YGFLC(JGFL)%MP,:),PSPSCALAR=YDSPEC%SP3D(:,:,JF), &
               & KVSETSC=NBSETLEV,KPROMA=NPROMA)
    ENDIF
  ENDDO
ENDDO

IF (LHOOK) CALL DR_HOOK('STATE2SPECAD',1,ZHOOK_HANDLE)
END SUBROUTINE STATE2SPECAD
