SUBROUTINE SUALLOCUF

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMGEM   , ONLY : NGPTOT
USE YOMMCUF  , ONLY : RMCUFGP1  ,RMCUFGP2  ,RMCUFGP3  ,RMCUFGP4  ,RMCUFGP5

!Purpose:
!---------
!Allocate GRIDPoint Array for the monitoring of update frequency of the coupling files for ALADIN 

!Interface
!----------
!CALL SUALLOCUF

!Author
!-------
!Rachida El Ouaraini & Ryad El Khatib


IMPLICIT NONE

REAL(KIND=JPRB) :: ZHOOK_HANDLE


IF (LHOOK) CALL DR_HOOK('SUALLOCUF',0,ZHOOK_HANDLE)

IF (.NOT. ALLOCATED(RMCUFGP1))  ALLOCATE(RMCUFGP1(1:NGPTOT))
IF (.NOT. ALLOCATED(RMCUFGP2))  ALLOCATE(RMCUFGP2(1:NGPTOT))
IF (.NOT. ALLOCATED(RMCUFGP3))  ALLOCATE(RMCUFGP3(1:NGPTOT))
IF (.NOT. ALLOCATED(RMCUFGP4))  ALLOCATE(RMCUFGP4(1:NGPTOT))
IF (.NOT. ALLOCATED(RMCUFGP5))  ALLOCATE(RMCUFGP5(1:NGPTOT))
RMCUFGP1(:)=0._JPRB
RMCUFGP2(:)=0._JPRB
RMCUFGP3(:)=0._JPRB
RMCUFGP4(:)=0._JPRB
RMCUFGP5(:)=0._JPRB

IF (LHOOK) CALL DR_HOOK('SUALLOCUF',1,ZHOOK_HANDLE)
END SUBROUTINE SUALLOCUF
