SUBROUTINE WRVAPARAM(param,K_NPARAM,CD_CFILE)

!   Purpose.
!   --------
!     Save estimated parameters.

!   Author.
!   -------
!     Y. Tremolet

!   Modifications.
!   --------------
!     Original   03-02-21
!     D. Dee     03-11-05 : Wrapped by WRVAPARINC
! ------------------------------------------------------

USE PARKIND1, ONLY: JPIM, JPRB
USE YOMHOOK , ONLY: LHOOK, DR_HOOK
USE yomlun, ONLY :  nulerr
USE yommsc, ONLY : nrealen

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: K_NPARAM 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PARAM(K_NPARAM) 
CHARACTER(LEN=*)  ,INTENT(IN)    :: CD_CFILE 
INTEGER(KIND=JPIM) :: iunit,ierr,ilen
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "abor1.intfb.h"

IF (LHOOK) CALL DR_HOOK('WRVAPARAM',0,ZHOOK_HANDLE)
CALL PBOPEN(iunit,CD_CFILE,'w',ierr)
IF (ierr /= 0) THEN
  write(nulerr,*) 'WRVAPARAM: PBOPEN returned error code ',ierr
  CALL ABOR1 ('WRVAPARAM: error in PBOPEN')
ENDIF

ilen = K_NPARAM * nrealen
CALL PBWRITE(iunit,param,ilen,ierr)
IF (ierr < 0) THEN
  write(nulerr,*) 'WRVAPARAM: PBWRITE returned error code ',ierr
  CALL ABOR1 ('WRVAPARAM: error in PBWRITE')
ENDIF

CALL PBCLOSE(iunit,ierr)
IF (ierr /= 0) THEN
  write(nulerr,*) 'WRVAPARAM: PBCLOSE returned error code ',ierr
  CALL ABOR1 ('WRVAPARAM: error in PBCLOSE')
ENDIF

IF (LHOOK) CALL DR_HOOK('WRVAPARAM',1,ZHOOK_HANDLE)
END SUBROUTINE WRVAPARAM
