SUBROUTINE AVARCAD(KEVENT)

!**** *AVARCAD*  - adds the gradient to SPA arrays.                

!     Purpose.
!     --------
!     variational assimilation of corrections

!**   Interface.
!     ----------
!        *CALL* *AVARCAD

!        Implicit arguments :      The state variables of the model
!        --------------------

!     Method.
!     -------
!        See documentation
!     Externals.
!     ----------

!     Reference.
!     ----------
!        Symposium II Project

!     Author.
!     -------
!        Radmila Brozkova  *RC LACE*

!     Modifications.
!     --------------
!        Original : 01-06-26
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMSP    , ONLY : SPVOR   ,SPDIV   , SPT      ,SPQ, SPSP
USE YOMMP    , ONLY : NPSP   
USE YOMJR    , ONLY : AGRASP, AGRAVOR, AGRADIV, AGRAT    ,AGRAQ

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KEVENT 
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!     ------------------------------------------------------------------

!*       1.    Add  the gradient
!              ------------------
IF (LHOOK) CALL DR_HOOK('AVARCAD',0,ZHOOK_HANDLE)
SPVOR(:,:) = SPVOR(:,:) + AGRAVOR(:,:,KEVENT)
SPDIV(:,:) = SPDIV(:,:) + AGRADIV(:,:,KEVENT)
SPT  (:,:) = SPT(:,:)   + AGRAT(:,:,KEVENT)
SPQ  (:,:) = SPQ(:,:)   + AGRAQ(:,:,KEVENT)

IF(NPSP == 1) THEN
  SPSP(:) = SPSP(:) + AGRASP(:,KEVENT)
ENDIF
IF (LHOOK) CALL DR_HOOK('AVARCAD',1,ZHOOK_HANDLE)
END SUBROUTINE AVARCAD
