SUBROUTINE DEALLAV(KULOUT)

!**** *SUALLAV*  - deallocate tables for avarc gradient                 
!     Purpose.
!     --------
!           deallocate memory                                

!**   Interface.
!     ----------
!        *CALL* *DEALLAV 

!        Explicit arguments :
!        --------------------
!        KULOUT:  logical unit used for output

!        Implicit arguments :  Common YOMJR
!        --------------------

!     Method.
!     -------

!     Externals.
!     ----------

!     Reference.
!     ----------

!     Author.
!     -------
!        R. Brozkova   *CNRM/GMAP*

!     Modifications.
!     --------------
!        Original : 01-06-25
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     ------------------------------------------------------------------
USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMJR   , ONLY:  AGRAVOR, AGRADIV, AGRAT, AGRAQ, AGRASP

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KULOUT 
LOGICAL :: LLALLOC
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('DEALLAV',0,ZHOOK_HANDLE)
LLALLOC = ALLOCATED(AGRAVOR )
IF(LLALLOC) THEN
  WRITE(KULOUT,*)'  DEALLAV-  deallocating AGRAVOR. '
  DEALLOCATE(AGRAVOR)
ENDIF

LLALLOC = ALLOCATED(AGRADIV )
IF(LLALLOC) THEN
  WRITE(KULOUT,*)'  DEALLAV-  deallocating AGRADIV. '
  DEALLOCATE(AGRADIV)
ENDIF

LLALLOC = ALLOCATED(AGRAT   )
IF(LLALLOC) THEN
  WRITE(KULOUT,*)'  DEALLAV-  deallocating AGRAT. '
  DEALLOCATE(AGRAT)
ENDIF

LLALLOC = ALLOCATED(AGRAQ   )
IF(LLALLOC) THEN
  WRITE(KULOUT,*)'  DEALLAV-  deallocating AGRAQ. '
  DEALLOCATE(AGRAQ)
ENDIF

LLALLOC = ALLOCATED(AGRASP  )
IF(LLALLOC) THEN
  WRITE(KULOUT,*)'  DEALLAV-  deallocating AGRASP. '
  DEALLOCATE(AGRASP)
ENDIF

IF (LHOOK) CALL DR_HOOK('DEALLAV',1,ZHOOK_HANDLE)
END SUBROUTINE DEALLAV 
