SUBROUTINE RDPHTRAJTM (KSTEP,KSTA,KEND,KJUMP,KFIELDS,&
 & PCVGQ,&
 & PDIFCQ,PDIFCS,PDIFTQ,PDIFTS,&
 & PFCCQL,PFCCQN,PFCSQL,PFCSQN,&
 & PFPLCL,PFPLCN,PFPLSL,PFPLSN,PFRSO ,PFRTH,&
 & PSTRCU,PSTRCV,PSTRDU,PSTRDV,PSTRTU,PSTRTV,&
 & PSTRMU,PSTRMV,PFRMH,&
 & PKTROV,PKUROV,PXTROV,PXUROV,&
 & PCDROV,PCHROV,PXDROV,PXHROV,&
 & PTENDU,PTENDV,PTENDH,PTENDQ )  

!     Purpose.  Read out the trajectory of phys.tendencies 
!               to work file

!**   Interface.
!     ----------
!        *CALL* *RDPHTRAJTM(...)*

!        Explicit arguments :  KSTEP   - time step            (input)
!        --------------------  KSTA    - start adress         (input)
!                              KEND    - end adress           (input)
!                              KJUMP   - offset into gp array (input)
!                              KFIELDS - number of fields     (input)

!        Implicit arguments :  None
!        --------------------

!     Method.
!     -------

!     Externals. EMPTB    - interface to packing routines
!     ----------

!     Reference.
!     ----------

!     Author.
!     -------
!        F. Bouyssel  *METEO-FRANCE*

!     Modifications.
!     --------------
!        Original : 2000-03-09
!        Modified : 2000-12_18 M.Janiskova: renamed packing factor
!                                           for phys.tendecies 
!        Modified 01-08-30 by K. YESSAD: pruning and some other cleanings.
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      10-Jan-2004 CY28R1 Cleaning
!        ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMDIM   , ONLY : NFLEVG   ,NPROMA
USE YOMIOP   , ONLY : NPCKFPH5 ,NEXPBPH5
USE YOMTPHY  , ONLY : NLENGTT5B,TRAJPHTE

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KSTEP 
INTEGER(KIND=JPIM),INTENT(IN)    :: KSTA 
INTEGER(KIND=JPIM),INTENT(IN)    :: KEND 
INTEGER(KIND=JPIM),INTENT(IN)    :: KJUMP 
INTEGER(KIND=JPIM),INTENT(IN)    :: KFIELDS 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PCVGQ(NPROMA,NFLEVG) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PDIFCQ(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PDIFCS(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PDIFTQ(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PDIFTS(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFCCQL(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFCCQN(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFCSQL(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFCSQN(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFPLCL(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFPLCN(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFPLSL(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFPLSN(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFRSO(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFRTH(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSTRCU(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSTRCV(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSTRDU(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSTRDV(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSTRTU(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSTRTV(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSTRMU(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSTRMV(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFRMH(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PKTROV(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PKUROV(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PXTROV(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PXUROV(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PCDROV(NPROMA) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PCHROV(NPROMA) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PXDROV(NPROMA) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PXHROV(NPROMA) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PTENDU(NPROMA,NFLEVG) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PTENDV(NPROMA,NFLEVG) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PTENDH(NPROMA,NFLEVG) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PTENDQ(NPROMA,NFLEVG) 
INTEGER(KIND=JPIM) :: IBLOCKS, IJUMP, ILENB, IPCKUNIT,&
 & ISTAGPB, IWORDS, JF  
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "abor1.intfb.h"
#include "emptb.intfb.h"

!     ------------------------------------------------------------------

!*       1.    READ OUT GRIDPOINT ARRAY.
!              --------------------------

!*       1.1       CALCULATE LENGTHS

IF (LHOOK) CALL DR_HOOK('RDPHTRAJTM',0,ZHOOK_HANDLE)
IWORDS = KEND-KSTA+1

!*       1.2       WRITE OUT BUFFER

ILENB   = NLENGTT5B
IJUMP=KJUMP-1
IF (NPCKFPH5 == 1) THEN
  ISTAGPB = 1+IJUMP*KFIELDS
ELSE

!  It is assumed that TRAJPHYS data always is read/written in
!  NPROMA chunks (except for the last potentially smaller chunk).
!  Restrictions are necessary because reading/writing of packed
!  data has to start on a word boundary.
  
  IBLOCKS=IJUMP/NPROMA
  IF (IBLOCKS*NPROMA /= IJUMP)&
   & CALL ABOR1('RDPHTRAJTM: INCONSISTENT READING OF PACKED DATA')  
  IPCKUNIT = (NPROMA+NPCKFPH5-1)/NPCKFPH5
  ISTAGPB = 1+IPCKUNIT*IBLOCKS*KFIELDS
ENDIF

!        1.3      UPPER AIR 3D FIELDS

DO JF=1,NFLEVG
  CALL EMPTB(IWORDS,PCVGQ (KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PTENDU(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PTENDV(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PTENDH(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PTENDQ(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
ENDDO
DO JF=1,NFLEVG+1
  CALL EMPTB(IWORDS,PDIFCQ(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PDIFCS(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PDIFTQ(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PDIFTS(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PFCCQL(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PFCCQN(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PFCSQL(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PFCSQN(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PFPLCL(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PFPLCN(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PFPLSL(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PFPLSN(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PFRSO (KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PFRTH (KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PSTRCU(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PSTRCV(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PSTRDU(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PSTRDV(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PSTRTU(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PSTRTV(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PSTRMU(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PSTRMV(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PFRMH (KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PKTROV(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PKUROV(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PXTROV(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL EMPTB(IWORDS,PXUROV(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
ENDDO
CALL EMPTB(IWORDS,PCDROV(KSTA),TRAJPHTE(:,KSTEP),&
 & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
CALL EMPTB(IWORDS,PCHROV(KSTA),TRAJPHTE(:,KSTEP),&
 & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
CALL EMPTB(IWORDS,PXDROV(KSTA),TRAJPHTE(:,KSTEP),&
 & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
CALL EMPTB(IWORDS,PXHROV(KSTA),TRAJPHTE(:,KSTEP),&
 & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('RDPHTRAJTM',1,ZHOOK_HANDLE)
END SUBROUTINE RDPHTRAJTM
