SUBROUTINE RDRINC

!**** *RDRINC*  - reads in the increments x-xb

!     Purpose.
!     --------
!     reads in  the increments

!**   Interface.
!     ----------
!        *CALL* *RDRINC

!        Explicit arguments :      none
!        --------------------

!        Implicit arguments :      The state variables of the model
!        --------------------

!     Method.
!     -------
!        See documentation

!     Externals.
!     ----------

!     Reference.
!     ----------
!       none (yet). 

!     Author.
!     -------
!        J.N. Thepaut  from RDTRA *ECMWF*

!     Modifications.
!     --------------
!        Original : 94-07-28
!        Modified : 95-06-06 L.Isaksen   Reordering of spectral arrays
!                   96-08-01 M.Fisher    Make I/O optional
!                   99-07-15 M.Hamrud    Remove LIORINC=true
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      01-Dec-2003 CY28R1 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMSP    , ONLY : SPA3     ,SPA2
USE YOMRINC  , ONLY : SPA3I    ,SPA2I

IMPLICIT NONE

REAL(KIND=JPRB) :: ZHOOK_HANDLE
!     ------------------------------------------------------------------

!*       1.    COPY INCREMENT
!              --------------

IF (LHOOK) CALL DR_HOOK('RDRINC',0,ZHOOK_HANDLE)
SPA3(:,:,:) = SPA3I(:,:,:)
SPA2(:,:)   = SPA2I(:,:)
DEALLOCATE (SPA3I,SPA2I)

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('RDRINC',1,ZHOOK_HANDLE)
END SUBROUTINE RDRINC
