SUBROUTINE SUAEOLUS

!**** *SUAEOLUS - Set up all the logistic for Aeolus observations.
!****              

!     Purpose.
!     -------
!           Prepare the logistic parameters needed:
!           for the Aeolus HLOS processing

!**   Interface.
!**   ---------
!**   *CALL* * SUAEOLUS *

!     Authors: David Tan/Paul Poli
!     Date   : 12 Aug 2008
 
!     Externals.
!     ----------
!              AEOLUS_L2BP_SETUP_EC - SET-UP ROUTINE FOR AEOLUS

!     Modifications
!     -------------
!         12 Aug 2008    Tan/Poli     Original code

!     ------------------------------------------------------------------

USE PARKIND1 , ONLY : JPRB, JPIM
!USE YOMAEOLUS, ONLY :
!USE YOMANCS  , ONLY : RMDI, NMDI
USE YOMLUN   , ONLY : NULOUT

USE YOMHOOK  , ONLY : LHOOK, DR_HOOK

IMPLICIT NONE

REAL(KIND=JPRB)    :: ZHOOK_HANDLE
INTEGER(KIND=JPIM) :: i_error_flag

!===============================================================

IF (LHOOK) CALL DR_HOOK('SUAEOLUS',0,ZHOOK_HANDLE)

!     ------------------------------------------------------------------

!*       1. SET UP LOGISTIC PARAMETERS
!           --------------------------

call aeolus_l2bp_setup_ec(i_error_flag)

if (i_error_flag /= 0) then
   WRITE(NULOUT,*) 'aeolus_l2bp_setup_ec returned an error',i_error_flag
else
   WRITE(NULOUT,*) 'aeolus_l2bp_setup_ec completed OK'
endif

IF (LHOOK) CALL DR_HOOK('SUAEOLUS',1,ZHOOK_HANDLE)

END SUBROUTINE SUAEOLUS
