SUBROUTINE SUJC

!**** *SUJC*   - Routine to initialize cost function common - YOMCOSJC
!*               weak constraint

!     Purpose.
!     --------
!           Initialize YOMCOSJC
!**   Interface.
!     ----------
!        *CALL* *SUJC

!        Explicit arguments :
!        --------------------

!        Implicit arguments :
!        --------------------
!        COMMON YOMCOSJC

!     Method.
!     -------
!        See documentation

!     Externals.
!     ----------

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     Author.
!     -------
!        Jean-Noel Thepaut  *ECMWF*

!     Modifications.
!     --------------
!        Original   : 91-02-15
!        L. Isaksen : 96-04-04  Adapted for Message Passing
!        E. Holm    : 97-12-15  Ozone included
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      01-Dec-2003 CY28R1 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMDIM   , ONLY : NF3D     
USE YOMCOSJC , ONLY : FJCCOST  ,RINCLJC

IMPLICIT NONE

REAL(KIND=JPRB) :: ZHOOK_HANDLE
!      -----------------------------------------------------------

!*       1.    RESET COST FUNCTION to 0.
!              -------------------------

IF (LHOOK) CALL DR_HOOK('SUJC',0,ZHOOK_HANDLE)
FJCCOST(:,:)=0.0_JPRB

!      -----------------------------------------------------------

!*       2.    CONTROL OF THE COST FUNCTION
!              ----------------------------

RINCLJC(:)=0.0_JPRB

!      -----------------------------------------------------------

!*       3.    Modify default settings for constraints.
!        ----------------------------------------------

!*    3.1   VORTICITY

RINCLJC(1)=1._JPRB

!*    3.2   DIVERGENCE

RINCLJC(2)=1._JPRB

!*    3.3   TEMPERATURE

RINCLJC(3)=1._JPRB

!*    3.6   SURFACE PRESSURE

RINCLJC(NF3D+1)=1.0_JPRB

!      -----------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SUJC',1,ZHOOK_HANDLE)
END SUBROUTINE SUJC
