SUBROUTINE SUPAVARC(KULOUT)

!     Purpose.
!     --------
!**   Interface.
!     ----------
!        *CALL* *SUPAVARC

!      Explicit arguments :
!      --------------------

!     Reference.
!     ----------
!     Author.
!     -------
!        R. Brozkova   *RC LACE*

!     Modifications.
!     --------------
!        Original : 01-05-10
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMDIM  , ONLY:  NFD2D, NFLSUR, NFLEVL, NS3D, NSMAX
USE YOMJR   , ONLY:  AVNORM1, AVNORM2, AVNORM3 

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KULOUT 
INTEGER(KIND=JPIM) :: ILEN
LOGICAL :: LLALLOC
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "suqnorm.intfb.h"

!     1. Allocating space for the AVNORM

IF (LHOOK) CALL DR_HOOK('SUPAVARC',0,ZHOOK_HANDLE)
LLALLOC = ALLOCATED(AVNORM1)
IF(.NOT.LLALLOC) THEN
  ILEN = 2*NFLEVL
  WRITE(KULOUT,*)'  SUPAVARC -  allocating AVNORM1. Length = ',ILEN
  ALLOCATE(AVNORM1(NFLEVL,2))
ENDIF

LLALLOC = ALLOCATED(AVNORM2)
IF(.NOT.LLALLOC) THEN
  ILEN = (NSMAX+1)*NFD2D
  WRITE(KULOUT,*)'  SUPAVARC -  allocating AVNORM2. Length = ',ILEN
  ALLOCATE(AVNORM2(0:NSMAX,NFD2D))
ENDIF

LLALLOC = ALLOCATED(AVNORM3)
IF(.NOT.LLALLOC) THEN
  ILEN = (NSMAX+1)*NS3D*NFLSUR
  WRITE(KULOUT,*)'  SUPAVARC -  allocating AVNORM3. Length = ',ILEN
  ALLOCATE(AVNORM3(NFLSUR,0:NSMAX,NS3D))
ENDIF

!     2. Defining the norm to be used for Jr 

CALL SUQNORM(AVNORM1,AVNORM2,AVNORM3)

IF (LHOOK) CALL DR_HOOK('SUPAVARC',1,ZHOOK_HANDLE)
END SUBROUTINE SUPAVARC
