SUBROUTINE SUVWRK(KULOUT)

!**** *SURWRK*   - Routine to initialize path names for trajectory
!                -                              and for cma files
!     Purpose.
!     --------
!           Initialize path names
!**   Interface.
!     ----------
!        *CALL* *SUVWRK(KULOUT) (from SU0YOMA)

!        Explicit arguments :
!        --------------------
!        KULOUT : Logical unit for the output

!        Implicit arguments :
!        --------------------
!        COMMON YOMVWRK

!     Method.
!     -------
!        See documentation

!     Externals.
!     ----------

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     Author.
!     -------
!        Jean-Noel Thepaut *ECMWF*

!     Modifications.
!     --------------
!        Original : 92-07-13
!        Modified by R. EL Khatib : 93-04-02 Set-up defaults controled by LECMWF
!        Modified by F. Rabier    : 98-01-06 change default value for NPCKFTR
!        Modified by C. Temperton : 00-07-10 NTRSLTYPE, NPCKSLTRAJ
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOMLUN   , ONLY : NULNAM
USE YOMCT0B  , ONLY : LECMWF
USE YOMTRSL  , ONLY : NTRSLTYPE, NPCKSLTRAJ

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KULOUT 
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "posnam.intfb.h"

#include "namvwrk.h"
!      ----------------------------------------------------------------

!*       1.    SET DEFAULT VALUES.
!              -------------------

!        1.1 Set implicit default values

IF (LHOOK) CALL DR_HOOK('SUVWRK',0,ZHOOK_HANDLE)
NTRSLTYPE=2
NPCKSLTRAJ=1

!        1.2 Modify default values according to LECMWF

IF (LECMWF) THEN
ELSE
ENDIF

!      ----------------------------------------------------------------

!*       2.    Modifies default values.
!              ------------------------

CALL POSNAM(NULNAM,'NAMVWRK')
READ(NULNAM,NAMVWRK)
!      ----------------------------------------------------------------

!*       3.    Second check on the use of SSD.
!              (and possibly modify the namelist values)
!              -----------------------------------------

NPCKSLTRAJ=MIN(2,NPCKSLTRAJ)
!      ----------------------------------------------------------------

!*       4.    Print final values.
!              -------------------

WRITE(UNIT=KULOUT,FMT='('' COMMON YOMTRSL '')')
WRITE(UNIT=KULOUT,FMT='('' NTRSLTYPE ='',I2,'' NPCKSLTRAJ= '',I2)')&
 & NTRSLTYPE,NPCKSLTRAJ  

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SUVWRK',1,ZHOOK_HANDLE)
END SUBROUTINE SUVWRK

