SUBROUTINE WRPHTRAJTM (KSTEP,KSTA,KEND,KJUMP,KFIELDS,&
 & PCVGQ,&
 & PDIFCQ,PDIFCS,PDIFTQ,PDIFTS,&
 & PFCCQL,PFCCQN,PFCSQL,PFCSQN,&
 & PFPLCL,PFPLCN,PFPLSL,PFPLSN,PFRSO ,PFRTH,&
 & PSTRCU,PSTRCV,PSTRDU,PSTRDV,PSTRTU,PSTRTV,&
 & PSTRMU,PSTRMV,PFRMH,&
 & PKTROV,PKUROV,PXTROV,PXUROV,&
 & PCDROV,PCHROV,PXDROV,PXHROV,&
 & PTENDU,PTENDV,PTENDH,PTENDQ )  

!     Purpose.  Write out the trajectory of phys.tendencies 
!               to work file

!**   Interface.
!     ----------
!        *CALL* *WRPHTRAJTM(...)*

!        Explicit arguments :  KSTEP   - time step            (input)
!        --------------------  KSTA    - start adress         (input)
!                              KEND    - end adress           (input)
!                              KJUMP   - offset into gp array (input)
!                              KFIELDS - number of fields     (input)

!        Implicit arguments :  None
!        --------------------

!     Method.
!     -------

!     Externals. FILLB    - interface to packing routines
!     ----------

!     Reference.
!     ----------

!     Author.
!     -------
!        F. Bouyssel  *METEO-FRANCE*

!     Modifications.
!     --------------
!        Original : 2000-03-09
!        Modified : 2000-12-18 M.Janiskova: renamed packing factor
!                                           for phys.tendecies
!        Modified 01-08-30 by K. YESSAD: pruning and some other cleanings.
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      10-Jan-2004 CY28R1 Cleaning
!        ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMDIM   , ONLY : NFLEVG   ,NPROMA
USE YOMIOP   , ONLY : NPCKFPH5 ,NEXPBPH5
USE YOMTPHY  , ONLY : NLENGTT5B,TRAJPHTE

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KSTEP 
INTEGER(KIND=JPIM),INTENT(IN)    :: KSTA 
INTEGER(KIND=JPIM),INTENT(IN)    :: KEND 
INTEGER(KIND=JPIM),INTENT(IN)    :: KJUMP 
INTEGER(KIND=JPIM),INTENT(IN)    :: KFIELDS 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PCVGQ(NPROMA,NFLEVG) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PDIFCQ(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PDIFCS(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PDIFTQ(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PDIFTS(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PFCCQL(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PFCCQN(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PFCSQL(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PFCSQN(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PFPLCL(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PFPLCN(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PFPLSL(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PFPLSN(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PFRSO(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PFRTH(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSTRCU(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSTRCV(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSTRDU(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSTRDV(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSTRTU(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSTRTV(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSTRMU(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSTRMV(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PFRMH(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PKTROV(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PKUROV(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PXTROV(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PXUROV(NPROMA,NFLEVG+1) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PCDROV(NPROMA) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PCHROV(NPROMA) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PXDROV(NPROMA) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PXHROV(NPROMA) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PTENDU(NPROMA,NFLEVG) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PTENDV(NPROMA,NFLEVG) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PTENDH(NPROMA,NFLEVG) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PTENDQ(NPROMA,NFLEVG) 
INTEGER(KIND=JPIM) :: IBLOCKS, IJUMP, ILENB, IPCKUNIT,&
 & ISTAGPB, IWORDS, JF  
REAL(KIND=JPRB) :: ZHOOK_HANDLE

#include "abor1.intfb.h"
#include "fillb.intfb.h"

!     ------------------------------------------------------------------

!*       1.    WRITE OUT GRIDPOINT ARRAY.
!              --------------------------

!*       1.1       CALCULATE LENGTHS

IF (LHOOK) CALL DR_HOOK('WRPHTRAJTM',0,ZHOOK_HANDLE)
IWORDS = KEND-KSTA+1

!*       1.2       WRITE OUT BUFFER

ILENB   = NLENGTT5B
IJUMP=KJUMP-1
IF (NPCKFPH5 == 1) THEN
  ISTAGPB = 1+IJUMP*KFIELDS
ELSE

!  It is assumed that TRAJPHYS data always is read/written in
!  NPROMA chunks (except for the last potentially smaller chunk).
!  Restrictions are necessary because reading/writing of packed
!  data has to start on a word boundary.

  IBLOCKS=IJUMP/NPROMA
  IF (IBLOCKS*NPROMA /= IJUMP)&
   & CALL ABOR1('WRPHTRAJTM: INCONSISTENT WRITING OF PACKED DATA')  
  IPCKUNIT = (NPROMA+NPCKFPH5-1)/NPCKFPH5
  ISTAGPB = 1+IPCKUNIT*IBLOCKS*KFIELDS
ENDIF

!        1.3      UPPER AIR 3D FIELDS

DO JF=1,NFLEVG
  CALL FILLB(IWORDS,PCVGQ (KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PTENDU(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PTENDV(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PTENDH(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PTENDQ(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
ENDDO
DO JF=1,NFLEVG+1
  CALL FILLB(IWORDS,PDIFCQ(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PDIFCS(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PDIFTQ(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PDIFTS(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PFCCQL(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PFCCQN(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PFCSQL(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PFCSQN(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PFPLCL(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PFPLCN(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PFPLSL(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PFPLSN(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PFRSO (KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PFRTH (KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PSTRCU(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PSTRCV(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PSTRDU(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PSTRDV(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PSTRTU(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PSTRTV(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PSTRMU(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PSTRMV(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PFRMH (KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PKTROV(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PKUROV(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PXTROV(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
  CALL FILLB(IWORDS,PXUROV(KSTA,JF),TRAJPHTE(:,KSTEP),&
   & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
ENDDO
CALL FILLB(IWORDS,PCDROV(KSTA),TRAJPHTE(:,KSTEP),&
 & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
CALL FILLB(IWORDS,PCHROV(KSTA),TRAJPHTE(:,KSTEP),&
 & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
CALL FILLB(IWORDS,PXDROV(KSTA),TRAJPHTE(:,KSTEP),&
 & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  
CALL FILLB(IWORDS,PXHROV(KSTA),TRAJPHTE(:,KSTEP),&
 & ILENB,ISTAGPB,NPCKFPH5,NEXPBPH5)  

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('WRPHTRAJTM',1,ZHOOK_HANDLE)
END SUBROUTINE WRPHTRAJTM
