subroutine intcar(kent,cdcar,kcar)
! --------------------------------------------------------------------------
! **** *INTCAR*  - Conversion entier > chaine de caractere
! --------------------------------------------------------------------------
! Auteur:  J.M.Piriou
! -------
! Modifications.
! --------------
! Original : 95-03
! --------------------------------------------------------------------------
! En entree:
! kent entier a convertir
! En sortie:
! cdcar chaine recevant l'entier
! kcar: nombre de caracteres ecrits sur cdcar
! --------------------------------------------------------------------------
implicit none
INTEGER(KIND=4) :: IENT
INTEGER(KIND=4) :: IMOD
INTEGER(KIND=4) :: ISIGN
INTEGER(KIND=4) :: JC
INTEGER(KIND=4) :: KCAR
INTEGER(KIND=4) :: KENT

character *(*) cdcar
character*1 clint
cdcar=' '
ient=kent
kcar=0
!
! --------------------------------------------------------------------------
!
! Traitement du signe.
if(ient.lt.0) then
	isign=-1
	ient=-ient
else
	isign=1
endif
!
! --------------------------------------------------------------------------
!
! Conversion entier vers chaine de caracteres.
  100 continue
imod=mod(ient,10)
kcar=kcar+1
write(cdcar(kcar:kcar),fmt='(i1.1)') imod
ient=ient/10
if(ient.ne.0) goto 100
!
! --------------------------------------------------------------------------
!
! A ce stade, cdcar(1:kcar) contient l'entier cherche,
! mais ecrit en sens inverse.
! On va operer une symetrie centrale sur cdcar.
do jc=1,kcar/2
	clint=cdcar(jc:jc)
	cdcar(jc:jc)=cdcar(kcar-jc+1:kcar-jc+1)
	cdcar(kcar-jc+1:kcar-jc+1)=clint
enddo
!
! --------------------------------------------------------------------------
!
! Traitement du signe: ajout du "-" si necessaire.
if(isign.eq.-1) then
	cdcar='-'//cdcar(1:kcar)
	kcar=kcar+1
endif
end
