function zmodulo(px,py)
! --------------------------------------------------------------
! **** *zmodulo* fonction modulo priodique sur l'ensemble des reels.
! --------------------------------------------------------------
! Sujet:
! Arguments explicites:
! Arguments implicites:
! Methode:
! Externes:
! Auteur:   96-11, J.M. Piriou.
! Modifications:
! --------------------------------------------------------------
implicit none
REAL(KIND=8) :: ZMODULO
REAL(KIND=8) :: PX
REAL(KIND=8) :: PY

zmodulo=mod(px,py)
if(zmodulo < 0) zmodulo=zmodulo+py
end
function zmodyx(px,py,pz)
! --------------------------------------------------------------
! **** *zmodyx* amne px dans l'intervalle [py,pz[ modulo (pz-py).
! --------------------------------------------------------------
! Sujet:
! Arguments explicites:
! Arguments implicites:
! Methode:
! Externes:
! Auteur:   96-11, J.M. Piriou.
! Modifications:
! --------------------------------------------------------------
! i.e. zmodyx sera le rel tel que
! py <= zmodyx < pz, et px-zmodyx=k*(pz-py.)
! --------------------------------------------------------------
implicit none
REAL(KIND=8) :: ZMODYX
REAL(KIND=8) :: ZMODULO
REAL(KIND=8) :: PX
REAL(KIND=8) :: PY
REAL(KIND=8) :: PZ
zmodyx=py+zmodulo(px-py,pz-py)
end
function imodulo(kx,ky)
! --------------------------------------------------------------
! **** *imodulo* fonction modulo priodique sur l'ensemble des entiers.
! --------------------------------------------------------------
! Sujet:
! 	Cette fonction pallie le manque, en f77, 
! 	d'une fonction modulo priodique sur l'ensemble des entiers.
! 	En f90, ce problme a t rsolu par la fonction modulo.
! 	Il suffit alors d'appeler modulo et non imodulo.
! Limitations: le deuxime argument ky est suppos > 0.
! 	On n'a pas fait ici l'analyse de l'adquation imodulo <> modulo
! 	pour les ky <= 0, pour lesquels la fonction mathmatique
! 	n'est pas usuellement dfinie. On ne traite donc l'adquation 
! 	que pour tous les kx relatifs,  ky > 0.
! Arguments explicites:
! Arguments implicites:
! Methode:
! Externes:
! Auteur:   2001-01, J.M. Piriou.
! Modifications:
! --------------------------------------------------------------
implicit none
INTEGER(KIND=4) :: IMODULO
INTEGER(KIND=4) :: KX
INTEGER(KIND=4) :: KY

imodulo=mod(kx,ky)
if(imodulo < 0) imodulo=imodulo+ky
end
