subroutine pridocf(kdocfi,kdatef,cdnamx,pech,pechdv,kulsor)
! --------------------------------------------------------------------------
! **** *PRIDOCF* Impression du contenu de l'article de doc. DOCFICHIER.
! --------------------------------------------------------------------------
! Sujet:
! ------
! Arguments explicites: /
! ---------------------
! Arguments implicites: /
! ---------------------
! Methode:
! --------
! Externes: /
! ---------
! Original :
! ----------
! 92-03-01, J.M. Piriou.
!
! Modifications:
! --------------
! 92-06-05, J.M. Piriou: echeance en secondes lue sur article 'ECHEANCE
! 92-12-04, J.M. Piriou: adaptation au calcul sur CRAY.
!
! --------------------------------------------------------------------------
implicit none
INTEGER(KIND=4) :: ILNAMX
INTEGER(KIND=4) :: KULSOR
REAL(KIND=8) :: PECH
REAL(KIND=8) :: PECHDV
REAL(KIND=8) :: ZECH
REAL(KIND=8) :: ZECHDV

character*(*) cdnamx
INTEGER(KIND=4) kdocfi(17)
INTEGER(KIND=4) kdatef(11)
ilnamx=len_trim(cdnamx)
write(kulsor,'(3a,i4.4,4(a,i2.2),a,$)') &
& ' Run ',cdnamx(1:ilnamx),', base ',kdatef(1) &
& ,'-',kdatef(2),'-',kdatef(3),' ',kdatef(4),':',kdatef(5),','
!
!-------------------------------------------------
! Echance totale.
!-------------------------------------------------
!
if(pech < 3600.) then
	!
	! On fournit l'chance en minutes jusqu' une heure.
	!
	zech=pech/60.
	write(kulsor,'(a,f7.2,a,$)')' ech tot ',zech,' mn'
elseif(pech < 259200.) then
	!
	! On fournit l'chance en heures jusqu' 3 jours.
	!
	zech=pech/3600.
	write(kulsor,'(a,f7.2,a,$)')' ech tot ',zech,' h'
else
	!
	! On fournit l'chance en jours au-del.
	!
	zech=pech/86400.
	write(kulsor,'(a,f7.2,a,$)')' ech tot ',zech,' j'
endif
!
!-------------------------------------------------
! Echance variables.
!-------------------------------------------------
!
if(pechdv /= pech) then
	if(pechdv < 3600.) then
		!
		! On fournit l'chance en minutes jusqu' une heure.
		!
		zechdv=pechdv/60.
		write(kulsor,'(a,f7.2,a)')', ech var ',zechdv,' mn.'
	elseif(pechdv < 259200.) then
		!
		! On fournit l'chance en heures jusqu' 3 jours.
		!
		zechdv=pechdv/3600.
		write(kulsor,'(a,f7.2,a)')', ech var ',zechdv,' h.'
	else
		!
		! On fournit l'chance en jours au-del.
		!
		zechdv=pechdv/86400.
		write(kulsor,'(a,f7.2,a)')', ech var ',zechdv,' j.'
	endif
else
	write(kulsor,'(a)') '.'
endif
!
!-------------------------------------------------
! Type de domaines.
!-------------------------------------------------
!
if(kdocfi(1) == 1) then
	write(kulsor,'(a,$)')' DOMAINES LIMITES'
elseif(kdocfi(1) == 5) then
	write(kulsor,'(a,$)')' DOMAINE GLOBAL'
elseif(kdocfi(1) == 6) then
	write(kulsor,'(a,$)')' DOMAINES ZONAUX'
else
	write(kulsor,'(a,$)')' PRIDOCF/ERREUR: type de domaine inconnu!...'
endif
write(kulsor,'(i7,a,$)') kdocfi(5),' pas de temps,'
write(kulsor,'(2(i3,a))') kdocfi(6),' niveaux, ',kdocfi(15),' domaines.'
end
