      SUBROUTINE FACILE ( KREP, KNUMER, CDPREF, KNIVAU, CDSUFF, KCHAMP,
     S                    LDCOSP )
#include "facom0.h"
C****
C      Sous-programme de LECTURE d'un CHAMP HORIZONTAL sur un fichier
C     ARPEGE.
C       ( Champ d'Interet en LEcture )
C**
C    Arguments : KREP   (Sortie) ==> Code-reponse du sous-programme;
C                KNUMER (Entree) ==> Numero de l'unite logique;
C                CDPREF (Entree) ==> Prefixe eventuel du nom d'article;
C                KNIVAU (Entree) ==> Niveau vertical eventuel;
C                CDSUFF (Entree) ==> Suffixe eventuel du nom d'article;
C    ( Tableau ) KCHAMP (Sortie) ==> Valeurs REELLES du champ lu;
C                LDCOSP (Entree) ==> Vrai si le champ est represente
C                                    par des coefficients spectraux.
C     MODIF:
C     JM AUDOIN GMAP/EXT 10/05/95 intro de IVALC3 pour eviter ecrasement
C     D  PARADIS TTI/DEV 12/10/98 partie controle et decodage de l'article
C                                 demenagee dans un ss-prg a usage interne
C                                 du logiciel (FADECI).
C     D  PARADIS DSI/DEV 15/04/04 nettoyage code + declaration IVALCO en
C                                 ALLOCATABLE
#include "precision.h"
C
#include "facomp.h"
#include "facom1.h"
C
      INTEGER KREP, KNUMER, KNIVAU
C
      INTEGER IREP, ILPRFU, ILSUFU, ILNOMU, ILONGA, IRANG, INIMES
      INTEGER ILPREF, ILSUFF, IPOSEX, IRANGC
C
      INTEGER (KIND=JPDBLE) KCHAMP (*)
      INTEGER (KIND=JPDBLE), ALLOCATABLE :: IVALCO(:)
      INTEGER IB1PAR (JPLB1P)
C
      LOGICAL LLVERF, LLRLFI, LDCOSP, LLNOMU
C
      CHARACTER CDPREF*(*), CDSUFF*(*)
      CHARACTER CLPREF*(JPXNOM), CLSUFF*(JPXSUF)
C
#include "facom2.h"
C**
C     1.  -  CONTROLES ET INITIALISATIONS.
C-----------------------------------------------------------------------
C
      LLVERF=.FALSE.
      LLRLFI=.FALSE.
      LLNOMU=.FALSE.
      ILPRFU=LEN (CDPREF)
      ILSUFU=LEN (CDSUFF)
      CALL FANUMU (KNUMER,IRANG)
C
      IF (IRANG.EQ.0) THEN
        IREP=-51
        GOTO 1001
      ENDIF
C
C         Verrouillage eventuel du fichier.
C
      IF (LFAMUL) CALL LFIVER (VRFICH(IRANG),'ON')
      LLVERF=LFAMUL
C
      IF (LCREAF(IRANG)) THEN
        IREP=-85
        GOTO 1001
      ENDIF
C**
C     2.  -  FABRICATION DU NOM D'ARTICLE VIA LE SOUS-PROGRAMME "FANFAR"
C            ( controles de CDPREF, KNIVAU, CDSUFF inclus )
C-----------------------------------------------------------------------
C
      CALL FANFAR (IREP,IRANG,CDPREF,KNIVAU,CDSUFF,CLNOMA,IB1PAR(6),
     S             ILPRFU,ILSUFU,ILNOMU)
      IF (IREP.NE.0) GOTO 1001
      LLNOMU=.TRUE.
C**
C     3.  -  LECTURE DE L'ARTICLE SUR LE FICHIER
C-----------------------------------------------------------------------
C
      CALL LFINFO (IREP,KNUMER,CLNOMA(1:ILNOMU),ILONGA,IPOSEX)
C
      IF (IREP.NE.0) THEN
        LLRLFI=.TRUE.
        GOTO 1001
      ELSEIF (ILONGA.EQ.0) THEN
        IREP=-89
        GOTO 1001
      ELSEIF (ILONGA.GT.JPXCHA+2) THEN
        IREP=-90
        GOTO 1001
      ENDIF
C
C     ALLOCATE (IVALCO (2*ILONGA))
      ALLOCATE (IVALCO (ILONGA))
      CALL LFILEC (IREP,KNUMER,CLNOMA(1:ILNOMU),IVALCO,ILONGA)
      LLRLFI=IREP.NE.0
      IF (LLRLFI) GOTO 1001
C
C**
C     4.  -  CONTROLES ET DECODAGE DE L'ARTICLE
C----------------------------------------------
C
C  Controle de l'homogeneite du type de rangement de coeff. spectraux
C  parmi les champs lus/ecrits: ces champs compactes avec
C  NIGRIB=-1 ou 3 doivent etre ranges comme dans le modele ("verticalement"
C  soit selon des colonnes JM=cst consecutives) et contrairement si compactes
C  avec NIGRIB= 0,1 ou 2.
C 
      IRANGC=NUCADR(IRANG)
      IF (LDCOSP) THEN
        IF (IVALCO(1).EQ.-1.OR.IVALCO(1).EQ.3) THEN
          NRASVE(IRANG)=NRASVE(IRANG)+1
          IF (NRASVE(IRANG).EQ.1.AND.NRASHO(IRANG).GT.0) THEN
            WRITE(0,*)'------------------------------------------------'
            WRITE(0,*)' FACILE :  WARNING !!!!!           '
            WRITE(0,*)' Un champ de coeff. spectraux avec'
            WRITE(0,*)' rangement type modele va etre lu alors que'
            WRITE(0,*)' d''autres champs spec. ont un rangt different.'
            WRITE(0,*)' ***  Prenez en compte cette heterogeneite!  ***'
            WRITE(0,*)'------------------------------------------------'
          ENDIF
        ELSEIF (IVALCO(1).GE.0.AND.IVALCO(1).LE.2) THEN
          NRASHO(IRANG)=NRASHO(IRANG)+1
          IF (NRASHO(IRANG).EQ.1.AND.NRASVE(IRANG).GT.0) THEN
            WRITE(0,*)'------------------------------------------------'
            WRITE(0,*)' FACILE :  WARNING !!!!!           '
            WRITE(0,*)' Un champ de coeff. spectraux avec'
            WRITE(0,*)' rangement autre que celui du modele va etre lu'
            WRITE(0,*)' alors que d''autres champs ont le rangt modele'
            WRITE(0,*)' ***  Prenez en compte cette heterogeneite!  ***'
            WRITE(0,*)'------------------------------------------------'
          ENDIF
        ENDIF
      ENDIF
C
      IF (IVALCO(1).EQ.3) THEN
C Cas d'un champ gribe avec GRIBEX
        CALL FADECX (IREP,IRANG,CLNOMA,IVALCO,ILONGA,KCHAMP,LDCOSP)
      ELSE
        CALL FADECI (IREP,IRANG,CLNOMA,IVALCO,ILONGA,KCHAMP,LDCOSP)
      ENDIF
C
C**
C    10.  -  PHASE TERMINALE : MESSAGERIE, AVEC "ABORT" EVENTUEL,
C            VIA LE SOUS-PROGRAMME "FAIPAR" .
C-----------------------------------------------------------------------
C
 1001 CONTINUE
      IF (ALLOCATED( IVALCO )) DEALLOCATE ( IVALCO )
      KREP=IREP
      LLFATA=LLMOER (IREP,IRANG)
C
C        Deverrouillage eventuel du fichier.
C
      IF (LLVERF) CALL LFIVER (VRFICH(IRANG),'OFF')

      IF (LLFATA) THEN
        INIMES=2
      ELSE
        INIMES=IXNVMS(IRANG)
      ENDIF
C
      IF (.NOT.LLFATA.AND.INIMES.NE.2) RETURN
C
      CLNSPR='FACILE'
C
      IF (ILPRFU.GE.1) THEN
        ILPREF=MIN (ILPRFU,LEN (CLPREF))
        CLPREF(1:ILPREF)=CDPREF(1:ILPREF)
      ELSE
        ILPREF=8
        CLPREF(1:ILPREF)=CHAINC(:ILPREF)
      ENDIF
C
      IF (ILSUFU.GE.1) THEN
        ILSUFF=MIN (ILSUFU,LEN (CLSUFF))
        CLSUFF(1:ILSUFF)=CDSUFF(1:ILSUFF)
      ELSE
        ILSUFF=8
        CLSUFF(1:ILSUFF)=CHAINC(:ILSUFF)
      ENDIF
C
      IF (.NOT.LLNOMU) THEN
        ILNOMU=MIN (ILPREF,NCPCAD)
        CLNOMA(1:ILNOMU)=CLPREF(1:ILPREF)
      ENDIF
C
      WRITE (UNIT=CLMESS,FMT='(''KREP='',I5,'', KNUMER='',I3,
     S       '', CDPREF='''''',A,'''''', KNIVAU='',I6,
     S       '', CDSUFF='''''',A,'''''', LDCOSP= '',L1)')
     S   KREP,KNUMER,CLPREF(1:ILPREF),KNIVAU,CLSUFF(1:ILSUFF),LDCOSP
      CALL FAIPAR (KNUMER,INIMES,IREP,LLFATA,CLMESS,CLNSPR,
     S             CLNOMA(1:ILNOMU),LLRLFI)
C
      RETURN
      END





