C**
C---------------- VARIABLES "SIMPLES" GLOBALES -------------------------
C
C     NFIOUV = Nombre de fichiers ouverts simultanement
C     NCADEF =   "    "  cadres definis        "
C     LFAMUL = Option "utilisation du logiciel en mode multi-taches"
C     LFAMOP = Option "mode mise au point du logiciel"
C     VRGLAS = Verrou global du lociciel (en mode multi-taches)
C     NIMSGA = Niveau global de messagerie du logiciel
C     NRFAGA = Niveau de filtrage global des erreurs fatales detectees ?
C     NBIPDG = Nombre de bits IMPLICITE par valeur point-de-grille
C     NBICSP =    "   "   "   IMPLICITE par coefficient spectral
C     NSTROI = Sous-troncature non compactee IMPLICITE (coef. spectraux)
C     NPUILA = "Puissance de laplacien" IMPLICITE pour coeffi. spectraux
C     NMIDPL = Degre de modulation IMPLICITE de puissance de laplacien
C     NIGRIB = Niveau IMPLICITE de codage GRIB
C              (  0 ==> pas de codage, 1 ==> "standard", 2 => "Arpege" )
C              ( -1 ==> pas de codage (rangt coeff spec selon modele)  )
C              (  3 ==> "GRIBEX"      (rangt coeff spec selon modele)  )
C     NCPCAD = Nombre maximum de caracteres possibles par nom de cadre.
C     SPSMIN = Pression sol minimum   "     "    "     "      "    "
C     SPSMAX = Pression sol maximum   "     "    "     "      "    "
C     MPRESX = Pression maximum pour designer un niveau isobare
C     NBIMAC = Nombre de bits par mot machine
C     NBIMAX = Nombre maximum de bits par valeur elementaire compactee
C     NTYPTX = Type maximum reconnu de transformation horizontale
C     LIGARD = Option de conservation des cadres definis dynamiquement
C
C        Ci-dessous, limites en termes de dimensions reglables au niveau
C     usager, initialisees aux valeurs maximum du logiciel:
C
C     NXNIVV = Nombre maximum de niveaux verticaux au niveau usager
C     NXTRON = Troncature maximum                  "    "      "
C     NXLATI = Nombre maximum de latitudes de pole a pole "    "
C     NXLONG = Nombre maximum de longitudes par parallele "    "
C
C     CHAINC = Impression de substitut aux variables non reconnues
C**
C------------------------- TABLEAUX GLOBAUX ----------------------------
C
C     NULIND = Table d'indirection pour les autres tables "fichiers"
C     NCAIND =   "   "      "       "    "     "      "   "cadres"
C**
C--------- DESCRIPTIF DES ELEMENTS CONCERNANT UNE UNITE LOGIQUE --------
C
C     NULOGI = Numero de l'unite logique
C     NUCADR = Rang du cadre auquel le fichier est rattache
C     CIDENT = Identification (utilisateur) du fichier
C     LNOMME = Vrai si l'unite logique a un nom utilisateur (BOF...)
C     NIVOMS = Niveau de la messagerie defini par l'utilisateur
C     LERRFA = Vrai si toute erreur detectee doit etre fatale
C     LCREAF = Vrai si le fichier est en mode creation
C     NBFPDG = Nombre de bits EFFECTIF par valeur point-de-grille
C     NBFCSP =    "   "   "   EFFECTIF par coefficient spectral
C     NPUFLA = "Puissance de laplacien" EFFECTIVE pour coeffi. spectraux
C     NSTROF = Sous-troncature non compactee EFFECTIVE (coef. spectraux)
C     NMFDPL = Degre de modulation EFFECTIF de la puissance de laplacien
C     NFGRIB = Niveau EFFECTIF de codage GRIB
C     VRFICH = Verrou du fichier (en mode multi-taches)
C
C     MADATE = Contenu de l'article 'DATE'
C
C     CTNPRF = Prefixes de champ (re)connus.
C     NIVDSC = Descripteurs associes aux prefixes (re)connus.
C     NRASHO = Nombre de champs de coeff. spectraux ARPEGE ranges
C              horizontalement (donc a l'inverse du modele) detectes au
C              cours des lectures/ecritures
C     NRASVE = Nombre de champs de coeff. spectraux ARPEGE ranges
C              verticalement (donc comme le modele), detectes au cours
C              des lectures/ecritures
C
C**
C----------- DESCRIPTIF DES ELEMENTS CONSTITUANT UN CADRE --------------
C
C                     Elements DEFINISSANT un cadre:
C
C     CNOMCA = Nom du cadre (conventionnel; non ecrit sur le fichier)
C     NLCCAD = Longueur en caracteres du nom de cadre
C     NULCAD = Nombre d'unites logiques rattachees au cadre
C     MTRONC = Troncature associee aux donnees contenues dans le fichier
C     NNIVER = Nombre de niveaux verticaux
C     NLATIT =   "    "  latitudes de pole a pole
C     NXLOPA =   "    maximum de longitudes par cercle de latitude
C     NTYPTR = Type de transformation horizontale
C     SSLAPO = Sinus   de la latitude  du pole d'interet
C     SCLOPO = Cosinus  "   "     "     "    "      "
C     SSLOPO = Sinus    "   "     "     "    "      "
C     SCODIL = Coefficient de dilatation
C     SPREFE = Pression de reference (facteur multiplicatif de la premi-
C              ere fonction de la coordonnee hybride)
C     NLOPAR = Nombre de longitudes par parallele de l'hemisphere "nord"
C     NOZPAR =    "   d'onde zonal maximum "    "  "     "        "
C     SINLAT = Sinus des latitudes de la grille (*hemisphere nord seul*)
C     SFOHYB = Valeurs des fonctions "A" et "B" de la coordonnee hybride
C              (Definies aux LIMITES DE COUCHES)
C
C                Autres elements rattaches a un cadre:
C
C     NVAPDG = Nombre total de points de grille dans un champ horizontal
C     NGARDE = Option de conservation lors de la fermeture du dernier
C              fichier s'y rattachant. ( 0=Non, 1=selon LIGARD, 2=Oui )
C     LIMLAM = IMPLICIT SWITCH FOR SETTING OF GLOBAL/LAM CASE
C     NSFLAM = TOTAL NUMBER OF SPECTRAL COEFFICIENTS FOR LAM CASE
C
      INTEGER NFIOUV, NCADEF, NIMSGA, NRFAGA, NBIPDG, NBICSP, NPUILA
      INTEGER NIGRIB, NCPCAD, NSTROI, NMIDPL, NBIMAC, NBIMAX, MPRESX
      INTEGER NXNIVV, NXTRON, NXLATI, NXLONG, NTYPTX
C
      INTEGER NULIND (JPNXFA), NCAIND (JPNXCA)
      INTEGER NULOGI (JPNXFA), NUCADR (JPNXFA), NIVOMS (0:JPNXFA)
      INTEGER NBFPDG (JPNXFA), NBFCSP (JPNXFA), NPUFLA (JPNXFA)
      INTEGER NFGRIB (JPNXFA), NSTROF (JPNXFA), NMFDPL (JPNXFA)
      INTEGER NRASHO (JPNXFA), NRASVE (JPNXFA)
      INTEGER MADATE (JPLDAT,JPNXFA)
      INTEGER MTRONC (JPNXCA), NNIVER (JPNXCA), NLATIT (JPNXCA)
      INTEGER NXLOPA (JPNXCA), NULCAD (JPNXCA), NLCCAD (JPNXCA)
      INTEGER NLOPAR (JPXPAH,JPNXCA), NOZPAR (JPXIND,JPNXCA)
      INTEGER NVAPDG (JPNXCA), NTYPTR (JPNXCA), NGARDE (JPNXCA)
      INTEGER NSFLAM (JPNXCA), NIVDSC (0:4,0:JPTNIV)
C
      REAL (KIND=JPDBLR) SPSMIN, SPSMAX, VRGLAS
C
      REAL (KIND=JPDBLR) SSLAPO (JPNXCA), SCLOPO (JPNXCA)
      REAL (KIND=JPDBLR) SCODIL (JPNXCA), SINLAT (JPXGEO,JPNXCA)
      REAL (KIND=JPDBLR) SFOHYB (2,0:JPXNIV,JPNXCA), SPREFE (JPNXCA)
      REAL (KIND=JPDBLR) VRFICH (JPNXFA), SSLOPO (JPNXCA)
C
      INTEGER I1234, I5678, I3456, IXNVMS
C
      LOGICAL LFAMUL, LFAMOP, LIGARD
      LOGICAL LNOMME (JPNXFA), LERRFA (0:JPNXFA), LCREAF (JPNXFA)
      LOGICAL LLFATA, LLMOER
      LOGICAL LIMLAM (JPNXCA)
C
      CHARACTER*(JPXNOM) CNOMCA (JPNXCA), CIDENT (JPNXFA)
      CHARACTER*(JPXNOM) CLACTI, CLNOMA, CHAINC
      CHARACTER CLMESS*132, CLNSPR*6, CTNPRF (JPTNIV)*8
C
      COMMON /FADIVR/ NFIOUV, NCADEF, LFAMUL, LFAMOP, VRGLAS, NIMSGA,
     S                NRFAGA, NBIPDG, NBICSP, NPUILA, NIGRIB, NCPCAD,
     S                NSTROI, NMIDPL, SPSMIN, SPSMAX, NBIMAC, NBIMAX,
     S                MPRESX, LIGARD, NXNIVV, NXTRON, NXLATI, NXLONG,
     S                NTYPTX, NULIND, NCAIND,
     S                NULCAD, NVAPDG, NGARDE, NLCCAD,
     S                NSFLAM, LIMLAM,
     S                NULOGI, NUCADR, LNOMME, NIVOMS, LERRFA, LCREAF,
     S                NBFPDG, NBFCSP, NPUFLA, NFGRIB,
     S                NSTROF, NMFDPL, NRASHO, NRASVE, VRFICH, MADATE,
     S                MTRONC, NNIVER, NLATIT, NXLOPA, NTYPTR,
     S                SSLAPO, SCLOPO, SSLOPO, SCODIL,
     S                NLOPAR, NOZPAR, SINLAT, SFOHYB, SPREFE, NIVDSC
C
      COMMON /FACHAR/ CNOMCA, CIDENT, CHAINC, CTNPRF
C
