      SUBROUTINE FAGIOT ( KNGRIB, KNBPDG, KNBCSP, KSTRON, KPUILA,
     S                    KDMOPL )
#include "facom0.h"
C****
C        Ce sous-programme permet de modifier les options implicites
C     liees au codage GRIB des champs.
C     CES OPTIONS NE SONT UTILISEES QUE POUR (RE)ECRIRE DES CHAMPS
C     codes en GRIB, et les nouvelles valeurs implicites ne serviront
C     que LORS d'une OUVERTURE de FICHIER ULTERIEURE.
C       ( Grib, Implicites Options Techniques )
C**
C     Arguments : KNGRIB (Entree) ==> Niveau de codage GRIB (-1,0,1,2,3);
C                 KNBPDG (Entree) ==> Nombre de bits par valeur point-
C                                     de-grille;
C                 KNBCSP (Entree) ==> Nombre de bits par partie reelle/
C                                     imaginaire de coeff. spectral;
C                 KSTRON (Entree) ==> Sous-troncature non compactee;
C                 KPUILA (Entree) ==> Puissance de laplacien;
C                 KDMOPL (Entree) ==> Degre de modulation de KPUILA.
C
C     N.B.: Il doit y avoir coherence vis-a-vis des cadres deja definis
C           et vis-a-vis des limites usagers.
C           ( ce qui en pratique, ne concerne que KSTRON )
C
C     Remarque:  KSTRON egal a -1 est accepte, et dans ce cas
C                on indexera (a chaque ouverture de fichier) la sous-
C                troncature effective sur la troncature.
C
C      MODIF 30/03/2007 JM AUDOIN LFAMOP pour limiter IMPRESSION
C
#include "precision.h"
C
#include "facomp.h"
#include "facom1.h"
C
      INTEGER KNGRIB, KNBPDG, KNBCSP, KSTRON, KPUILA, KDMOPL
C
      INTEGER IMINIM, IREP, INIMES, INUMER, J, IRANGC
C
      LOGICAL LLVERG, LLPREA
C
      SAVE LLPREA
C
      DATA LLPREA / .TRUE. /
C
#include "facom2.h"
C**
C     1.  -  CONTROLES ET INITIALISATIONS.
C-----------------------------------------------------------------------
C
      IF (LLPREA) THEN
C
C          A la premiere utilisation, appel au sous-programme "FARINE".
C
        CALL FARINE(2)
        LLPREA=.FALSE.
      ENDIF
C
      LLVERG=.FALSE.
      IMINIM=MIN (2+KNGRIB,2+KNBPDG,2+KNBCSP,2+KSTRON,1+KDMOPL)
C
      IF (IMINIM.LE.0) THEN
        IREP=-64
        GOTO 1001
      ELSEIF (KNBPDG*KNBCSP.EQ.0) THEN
        IREP=-64
        GOTO 1001
      ELSEIF (KNGRIB.GT.3) THEN
        IREP=-96
        GOTO 1001
      ELSEIF (MAX (KNBPDG,KNBCSP).GT.NBIMAX) THEN
        IREP=-97
        GOTO 1001
      ELSEIF (IABS (KPUILA).GT.2**15-1) THEN
        IREP=-98
        GOTO 1001
      ENDIF
C
C         Verrouillage global eventuel.
C
      IF (LFAMUL) CALL LFIVER (VRGLAS,'ON')
      LLVERG=LFAMUL
C
      IF (KSTRON.GE.NXTRON) THEN
        IREP=-113
        GOTO 1001
      ENDIF
C
C        Coherence de "KSTRON" vis-a-vis de la troncature des cadres
C     deja definis.
C
      DO 101 J=1,NCADEF
      IRANGC=NCAIND(J)
C
      IF (KSTRON.GE.MTRONC(IRANGC)) THEN
        IREP=-99
        GOTO 1001
      ENDIF
C
  101 CONTINUE
C**
C     2.  -  STOCKAGE DES NOUVEAUX PARAMETRES.
C-----------------------------------------------------------------------
C
      IF (LFAMOP.AND.(NIGRIB.EQ.-1.OR.NIGRIB.EQ.3).AND.
     S    (KNGRIB.GT.-1.AND.KNGRIB.LT.3))     THEN
        PRINT *,'-----------------'
        PRINT *,'FAGIOT: CAUTION!! Les champs spectraux ARPEGE ne',
     S          ' devront pas etre ranges comme dans le modele ARPEGE'
        PRINT *,'-----------------'
      ENDIF
      IF (LFAMOP.AND.(KNGRIB.EQ.-1.OR.KNGRIB.EQ.3).AND.
     S    (NIGRIB.GT.-1.AND.NIGRIB.LT.3))     THEN
        PRINT *,'-----------------'
        PRINT *,'FAGIOT: CAUTION!! Les champs spectraux ARPEGE devront',
     S          ' etre ranges comme dans le modele ARPEGE'
        PRINT *,'-----------------'
      ENDIF
      NIGRIB=KNGRIB
      NBIPDG=KNBPDG
      NBICSP=KNBCSP
      NSTROI=KSTRON
      NPUILA=KPUILA
      NMIDPL=KDMOPL
      IREP=0
C**
C    10.  -  PHASE TERMINALE : MESSAGERIE, AVEC "ABORT" EVENTUEL,
C            VIA LE SOUS-PROGRAMME "FAIPAR" .
C-----------------------------------------------------------------------
C
 1001 CONTINUE
      LLFATA=LLMOER (IREP,0)
C
C        Deverrouillage global eventuel.
C
      IF (LLVERG) CALL LFIVER (VRGLAS,'OFF')
C
      IF (LLFATA) THEN
        INIMES=2
      ELSE
        INIMES=NIMSGA
      ENDIF
C
      IF (.NOT.LLFATA.AND.INIMES.NE.2) RETURN
C
      CLNSPR='FAGIOT'
C
      WRITE (UNIT=CLMESS,FMT='(''KNGRIB='',I2,'', KNBPDG='',I3,
     S       '', KNBCSP='',I3,'', KSTRON='',I2,'', KPUILA='',I3,
     S       '', KDMOPL='',I3)')
     S   KNGRIB,KNBPDG,KNBCSP,KSTRON,KPUILA,KDMOPL
      INUMER=JPNIIL
      CALL FAIPAR (INUMER,INIMES,IREP,LLFATA,CLMESS,CLNSPR,
     S             CLACTI,.FALSE.)
C
      RETURN
      END
