      SUBROUTINE FAICOR
C****
C      Sous-programme INTERNE du logiciel de Fichiers ARPEGE:
C      Initialisation des tableaux permettant la correspondance
C      entre nom du champ dans FA et ses descripteurs GRIB.
C
C      **  NBPARC ne doit pas depasser JPXPAR !! **
C**
C
      USE FAMODU   , ONLY : JPXPAR, NBPARC, CISUFF, CIPREF, NCODPA
C
      INTEGER J, INB, INBPAR
C**
C     1.  -  TRAITEMENT DES CHAMPS MONO NIVEAU
C-----------------------------------------------------------------------
C
C     1.1 -  Champs "profond"
C
      INBPAR = 0
      NBPARC = INBPAR + 7
      IF (NBPARC.GT.JPXPAR) GOTO 1001
      DO J=INBPAR+1,NBPARC
        CIPREF(J) = 'PROF'
      ENDDO
      CISUFF(INBPAR+1 ) = 'TEMPERATURE'
      CISUFF(INBPAR+2 ) = 'RESERV.GLACE'
      CISUFF(INBPAR+3 ) = 'RESERV.EAU'
      CISUFF(INBPAR+4 ) = 'RUISSELLEMEN'
      CISUFF(INBPAR+5 ) = 'FLUX DE GEL'
      CISUFF(INBPAR+6 ) = 'PROP.RMAX.EA'
      CISUFF(INBPAR+7 ) = 'XRUISSELLEME'
      NCODPA(INBPAR+1 ,1:6) = (/   1,  11, 111,  10,   0, 0 /)
      NCODPA(INBPAR+2 ,1:6) = (/   1, 152, 112,   0, 250, 0 /)
      NCODPA(INBPAR+3 ,1:6) = (/   1,  86, 112,   0, 250, 0 /)
      NCODPA(INBPAR+4 ,1:6) = (/ 149,   2, 112,  10, 300, 4 /)
      NCODPA(INBPAR+5 ,1:6) = (/ 149,  73, 112,  10, 300, 4 /)
      NCODPA(INBPAR+6 ,1:6) = (/ 149,  77, 112,  10, 300, 0 /)
      NCODPA(INBPAR+7 ,1:6) = (/ 149,  85, 112,  10, 300, 0 /)
      
C
C     1.2 -  Champs de surface
C
      INBPAR = NBPARC
      NBPARC = INBPAR + 83
      IF (NBPARC.GT.JPXPAR) GOTO 1001
      DO J=INBPAR+1,NBPARC
        CIPREF(J) = 'SURF'
      ENDDO
      CISUFF(INBPAR+1 ) = 'PRESSION'
      CISUFF(INBPAR+2 ) = 'GEOPOTENTIEL'
      CISUFF(INBPAR+3 ) = 'TEMPERATURE'
      CISUFF(INBPAR+4 ) = 'FLU.MSUBL.NE'
      CISUFF(INBPAR+5 ) = 'FLU.MEVAP.EA'
      CISUFF(INBPAR+6 ) = 'PREC.EAU.GEC'
      CISUFF(INBPAR+7 ) = 'PREC.EAU.CON'
      CISUFF(INBPAR+8 ) = 'RESERV.NEIGE'
      CISUFF(INBPAR+9 ) = 'NEBUL.TOTALE'
      CISUFF(INBPAR+10) = 'NEBUL.CONVEC'
      CISUFF(INBPAR+11) = 'NEBUL.BASSE'
      CISUFF(INBPAR+12) = 'NEBUL.MOYENN'
      CISUFF(INBPAR+13) = 'NEBUL.HAUTE'
      CISUFF(INBPAR+14) = 'PREC.NEI.CON'
      CISUFF(INBPAR+15) = 'PREC.NEI.GEC'
      CISUFF(INBPAR+16) = 'IND.TERREMER'
      CISUFF(INBPAR+17) = 'Z0.FOIS.G'
      CISUFF(INBPAR+18) = 'ALBEDO'
      CISUFF(INBPAR+19) = 'PROP.VEGETAT'
      CISUFF(INBPAR+20) = 'FLU.RAY.SOLA'
      CISUFF(INBPAR+21) = 'FLU.RAY.THER'
      CISUFF(INBPAR+22) = 'FLU.LAT.MEVA'
      CISUFF(INBPAR+23) = 'FLU.LAT.MSUB'
      CISUFF(INBPAR+24) = 'FLU.CHA.SENS'
      CISUFF(INBPAR+25) = 'ETA.GEOPOTEN'
      CISUFF(INBPAR+26) = 'ETP.GEOPOTEN'
      CISUFF(INBPAR+27) = 'TENS.DMOG.ZO'
      CISUFF(INBPAR+28) = 'TENS.TURB.ZO'
      CISUFF(INBPAR+29) = 'TENS.DMOG.ME'
      CISUFF(INBPAR+30) = 'TENS.TURB.ME'
      CISUFF(INBPAR+31) = 'RESERV.GLACE'
      CISUFF(INBPAR+32) = 'RESERV.EAU'
      CISUFF(INBPAR+33) = 'RAYT.LUNE.DE'
      CISUFF(INBPAR+34) = 'CAPE.MOD.XFU'
      CISUFF(INBPAR+35) = 'TOT.WAT.VAPO'
C Debut des champs pour Mocage :
CDP: champ TCO3 remplace par O3_TOT le 18 oct 2004 par coherence
C avec la BDAP qui venait de proceder au changement.
      CISUFF(INBPAR+36) = 'O3_TOT'
      CISUFF(INBPAR+37) = 'CH4_TOT'
      CISUFF(INBPAR+38) = 'NO_TOT'
      CISUFF(INBPAR+39) = 'NO2_TOT'
      CISUFF(INBPAR+40) = 'CO_TOT'
C Fin des champs pour Mocage
      CISUFF(INBPAR+41) = 'ALBEDO NEIGE'
      CISUFF(INBPAR+42) = 'ALBEDO HISTO'
      CISUFF(INBPAR+43) = 'ALBEDO.SOLNU'
      CISUFF(INBPAR+44) = 'ALBEDO.VEG'
      CISUFF(INBPAR+45) = 'EMISSIVITE'
      CISUFF(INBPAR+46) = 'ET.GEOPOTENT'
      CISUFF(INBPAR+47) = 'VAR.GEOP.ANI'
      CISUFF(INBPAR+48) = 'VAR.GEOP.DIR'
      CISUFF(INBPAR+49) = 'IND.VEG.DOMI'
      CISUFF(INBPAR+50) = 'RESI.STO.MIN'
      CISUFF(INBPAR+51) = 'PROP.ARGILE'
      CISUFF(INBPAR+52) = 'PROP.SABLE'
      CISUFF(INBPAR+53) = 'EPAIS.SOL'
      CISUFF(INBPAR+54) = 'IND.FOLIAIRE'
      CISUFF(INBPAR+55) = 'RES.EVAPOTRA'
      CISUFF(INBPAR+56) = 'GZ0.THERM'
      CISUFF(INBPAR+57) = 'RESERV.INTER'
      CISUFF(INBPAR+58) = 'FL.Q TURBUL'
      CISUFF(INBPAR+59) = 'FL.CT TURBUL'
      CISUFF(INBPAR+60) = 'FONTE NEIGE'
      CISUFF(INBPAR+61) = 'CHAL. DS SOL'
      CISUFF(INBPAR+62) = 'EAU DANS SOL'
      CISUFF(INBPAR+63) = 'RUISSELLEMEN'
      CISUFF(INBPAR+64) = 'EVAPOTRANSPI'
      CISUFF(INBPAR+65) = 'TRANSPIRATIO'
      CISUFF(INBPAR+66) = 'RUISS. INTER'
      CISUFF(INBPAR+67) = 'FLUX DE GEL'
      CISUFF(INBPAR+68) = 'RAYT DIR SUR'
      CISUFF(INBPAR+69) = 'RAYT DIFF DE'
      CISUFF(INBPAR+70) = 'RAYT THER DE'
      CISUFF(INBPAR+71) = 'PROP.RMAX.EA'
      CISUFF(INBPAR+72) = 'DENSIT.NEIGE'
      CISUFF(INBPAR+73) = 'CFU.Q.TURBUL'
      CISUFF(INBPAR+74) = 'CFU.CT.TURBU'
      CISUFF(INBPAR+75) = 'TIME.PREC.TO'
      CISUFF(INBPAR+76) = 'XFONTE NEIGE'
      CISUFF(INBPAR+77) = 'XCHAL. DS SO'
      CISUFF(INBPAR+78) = 'XEAU DANS SO'
      CISUFF(INBPAR+79) = 'XFLU.MEVAP.E'
      CISUFF(INBPAR+80) = 'XRUISSELLEME'
      CISUFF(INBPAR+81) = 'XEVAPOTRANSP'
      CISUFF(INBPAR+82) = 'XTRANSPIRATI'
      CISUFF(INBPAR+83) = 'XRUISS. INTE'
      NCODPA(INBPAR+1 ,1:6) = (/   1,   1,   1,   0,   0, 0 /)
      NCODPA(INBPAR+2 ,1:6) = (/   1,   8,   1,   0,   0, 0 /)
      NCODPA(INBPAR+3 ,1:6) = (/   1,  11,   1,   0,   0, 0 /)
      NCODPA(INBPAR+4 ,1:6) = (/ 149,  45,   1,   0,   0, 4 /)
      NCODPA(INBPAR+5 ,1:6) = (/ 149,  46,   1,   0,   0, 4 /)
      NCODPA(INBPAR+6 ,1:6) = (/   1,  62,   1,   0,   0, 4 /)
      NCODPA(INBPAR+7 ,1:6) = (/   1,  63,   1,   0,   0, 4 /)
      NCODPA(INBPAR+8 ,1:6) = (/   1,  65,   1,   0,   0, 0 /)
      NCODPA(INBPAR+9 ,1:6) = (/   1,  71,   1,   0,   0, 0 /)
      NCODPA(INBPAR+10,1:6) = (/   1,  72,   1,   0,   0, 0 /)
      NCODPA(INBPAR+11,1:6) = (/   1,  73,   1,   0,   0, 0 /)
      NCODPA(INBPAR+12,1:6) = (/   1,  74,   1,   0,   0, 0 /)
      NCODPA(INBPAR+13,1:6) = (/   1,  75,   1,   0,   0, 0 /)
      NCODPA(INBPAR+14,1:6) = (/   1,  78,   1,   0,   0, 4 /)
      NCODPA(INBPAR+15,1:6) = (/   1,  79,   1,   0,   0, 4 /)
      NCODPA(INBPAR+16,1:6) = (/   1,  81,   1,   0,   0, 0 /)
      NCODPA(INBPAR+17,1:6) = (/ 149,  47,   1,   0,   0, 0 /)
      NCODPA(INBPAR+18,1:6) = (/   1,  84,   1,   0,   0, 0 /)
      NCODPA(INBPAR+19,1:6) = (/   1,  87,   1,   0,   0, 0 /)
      NCODPA(INBPAR+20,1:6) = (/ 128, 111,   1,   0,   0, 4 /)
      NCODPA(INBPAR+21,1:6) = (/ 128, 112,   1,   0,   0, 4 /)
      NCODPA(INBPAR+22,1:6) = (/ 149,  52,   1,   0,   0, 4 /)
      NCODPA(INBPAR+23,1:6) = (/ 149,  53,   1,   0,   0, 4 /)
      NCODPA(INBPAR+24,1:6) = (/ 128, 122,   1,   0,   0, 4 /)
      NCODPA(INBPAR+25,1:6) = (/ 149,  54,   1,   0,   0, 0 /)
      NCODPA(INBPAR+26,1:6) = (/ 149,  55,   1,   0,   0, 0 /)
      NCODPA(INBPAR+27,1:6) = (/ 149,  56,   1,   0,   0, 4 /)
      NCODPA(INBPAR+28,1:6) = (/ 149,  57,   1,   0,   0, 4 /)
      NCODPA(INBPAR+29,1:6) = (/ 149,  58,   1,   0,   0, 4 /)
      NCODPA(INBPAR+30,1:6) = (/ 149,  59,   1,   0,   0, 4 /)
      NCODPA(INBPAR+31,1:6) = (/   1, 152,   1,   0,   0, 0 /)
      NCODPA(INBPAR+32,1:6) = (/   1,  86,   1,   0,   0, 0 /)
      NCODPA(INBPAR+33,1:6) = (/   1, 158,   1,   0,   0, 4 /)
      NCODPA(INBPAR+34,1:6) = (/   1, 160,   1,   0,   0, 0 /)
      NCODPA(INBPAR+35,1:6) = (/   1, 167,   1,   0,   0, 0 /)
      NCODPA(INBPAR+36,1:6) = (/   1,  10,   1,   0,   0, 0 /)
      NCODPA(INBPAR+37,1:6) = (/ 159,  21,   1,   0,   0, 0 /)
      NCODPA(INBPAR+38,1:6) = (/ 159,  22,   1,   0,   0, 0 /)
      NCODPA(INBPAR+39,1:6) = (/ 159,  23,   1,   0,   0, 0 /)
      NCODPA(INBPAR+40,1:6) = (/ 159,  24,   1,   0,   0, 0 /)
      NCODPA(INBPAR+41,1:6) = (/ 149,   5,   1,   0,   0, 0 /)
      NCODPA(INBPAR+42,1:6) = (/ 149,  48,   1,   0,   0, 0 /)
      NCODPA(INBPAR+43,1:6) = (/ 149,  49,   1,   0,   0, 0 /)
      NCODPA(INBPAR+44,1:6) = (/ 149,  50,   1,   0,   0, 0 /)
      NCODPA(INBPAR+45,1:6) = (/ 149,  60,   1,   0,   0, 0 /)
      NCODPA(INBPAR+46,1:6) = (/ 149,  93,   1,   0,   0, 0 /)
      NCODPA(INBPAR+47,1:6) = (/ 128, 161,   1,   0,   0, 0 /)
      NCODPA(INBPAR+48,1:6) = (/ 128, 162,   1,   0,   0, 0 /)
      NCODPA(INBPAR+49,1:6) = (/ 149,  61,   1,   0,   0, 0 /)
      NCODPA(INBPAR+50,1:6) = (/ 149,  62,   1,   0,   0, 0 /)
      NCODPA(INBPAR+51,1:6) = (/ 149,  63,   1,   0,   0, 0 /)
      NCODPA(INBPAR+52,1:6) = (/ 149,  64,   1,   0,   0, 0 /)
      NCODPA(INBPAR+53,1:6) = (/ 149,  51,   1,   0,   0, 0 /)
      NCODPA(INBPAR+54,1:6) = (/ 149,  65,   1,   0,   0, 0 /)
      NCODPA(INBPAR+55,1:6) = (/ 149,  66,   1,   0,   0, 0 /)
      NCODPA(INBPAR+56,1:6) = (/ 149,  67,   1,   0,   0, 0 /)
      NCODPA(INBPAR+57,1:6) = (/ 149,  68,   1,   0,   0, 0 /)
      NCODPA(INBPAR+58,1:6) = (/ 149,  69,   1,   0,   0, 4 /)
      NCODPA(INBPAR+59,1:6) = (/ 149,  70,   1,   0,   0, 4 /)
      NCODPA(INBPAR+60,1:6) = (/   1,  99,   1,   0,   0, 4 /)
      NCODPA(INBPAR+61,1:6) = (/ 149,   8,   1,   0,   0, 4 /)
      NCODPA(INBPAR+62,1:6) = (/   1, 150,   1,   0,   0, 4 /)
      NCODPA(INBPAR+63,1:6) = (/ 149,   2,   1,   0,   0, 4 /)
      NCODPA(INBPAR+64,1:6) = (/   1, 168,   1,   0,   0, 4 /)
      NCODPA(INBPAR+65,1:6) = (/ 149,  71,   1,   0,   0, 4 /)
      NCODPA(INBPAR+66,1:6) = (/ 149,  72,   1,   0,   0, 4 /)
      NCODPA(INBPAR+67,1:6) = (/ 149,  73,   1,   0,   0, 4 /)
      NCODPA(INBPAR+68,1:6) = (/ 149,  74,   1,   0,   0, 4 /)
      NCODPA(INBPAR+69,1:6) = (/ 149,  75,   1,   0,   0, 4 /)
      NCODPA(INBPAR+70,1:6) = (/ 149,  76,   1,   0,   0, 4 /)
      NCODPA(INBPAR+71,1:6) = (/ 149,  77,   1,   0,   0, 0 /)
      NCODPA(INBPAR+72,1:6) = (/ 149,   3,   1,   0,   0, 0 /)
      NCODPA(INBPAR+73,1:6) = (/ 149,  78,   1,   0,   0, 4 /)
      NCODPA(INBPAR+74,1:6) = (/ 149,  79,   1,   0,   0, 4 /)
      NCODPA(INBPAR+75,1:6) = (/ 149,  80,   1,   0,   0, 4 /)
      NCODPA(INBPAR+76,1:6) = (/ 149,  81,   1,   0,   0, 0 /)
      NCODPA(INBPAR+77,1:6) = (/ 149,  82,   1,   0,   0, 0 /)
      NCODPA(INBPAR+78,1:6) = (/ 149,  83,   1,   0,   0, 0 /)
      NCODPA(INBPAR+79,1:6) = (/ 149,  84,   1,   0,   0, 0 /)
      NCODPA(INBPAR+80,1:6) = (/ 149,  85,   1,   0,   0, 0 /)
      NCODPA(INBPAR+81,1:6) = (/ 149,  86,   1,   0,   0, 0 /)
      NCODPA(INBPAR+82,1:6) = (/ 149,  87,   1,   0,   0, 0 /)
      NCODPA(INBPAR+83,1:6) = (/ 149,  88,   1,   0,   0, 0 /)
C
C  Geopotentiel de surface en spectral (relief)
C
      INBPAR = NBPARC
      NBPARC = INBPAR + 1
      IF (NBPARC.GT.JPXPAR) GOTO 1001
      DO J=INBPAR+1,NBPARC
        CIPREF(J) = 'SPECSURF'
      ENDDO
      CISUFF(INBPAR+1) = 'GEOPOTEN'
      NCODPA(INBPAR+1 ,1:6) = (/   1,   8,   1,   0,   0, 0 /)
C
C     1.3 -  Champs au sommet
C
      INBPAR = NBPARC
      NBPARC = INBPAR + 2
      IF (NBPARC.GT.JPXPAR) GOTO 1001
      DO J=INBPAR+1,NBPARC
        CIPREF(J) = 'SOMM'
      ENDDO
      CISUFF(INBPAR+1 ) = 'FLU.RAY.SOLA'
      CISUFF(INBPAR+2 ) = 'FLU.RAY.THER'
      NCODPA(INBPAR+1 ,1:6) = (/ 128, 113,   8,   0,   0, 4 /)
      NCODPA(INBPAR+2 ,1:6) = (/ 128, 114,   8,   0,   0, 4 /)
C
C     1.4 -  Champs de la Couche Limite de Surface
C
      INBPAR = NBPARC
      NBPARC = INBPAR + 11
      IF (NBPARC.GT.JPXPAR) GOTO 1001
      DO J=INBPAR+1,NBPARC
        CIPREF(J) = 'CLS'
      ENDDO
      CISUFF(INBPAR+1 ) = 'TEMPERATURE'
      CISUFF(INBPAR+2 ) = 'MAXI.TEMPERAT'
      CISUFF(INBPAR+3 ) = 'MINI.TEMPERAT'
      CISUFF(INBPAR+4 ) = 'VENT.ZONAL'
      CISUFF(INBPAR+5 ) = 'VENT.MERIDIEN'
      CISUFF(INBPAR+6 ) = 'HUMI.SPECIFIQ'
      CISUFF(INBPAR+7 ) = 'HUMI.RELATIVE'
      CISUFF(INBPAR+8 ) = 'MAXI.HUMI.REL'
      CISUFF(INBPAR+9 ) = 'MINI.HUMI.REL'
      CISUFF(INBPAR+10) = 'U.RAF.MOD.XFU'
      CISUFF(INBPAR+11) = 'V.RAF.MOD.XFU'
      NCODPA(INBPAR+1 ,1:6) = (/   1,  11, 105,   2,   0, 0 /)
      NCODPA(INBPAR+2 ,1:6) = (/   1,  15, 105,   2,   0, 2 /)
      NCODPA(INBPAR+3 ,1:6) = (/   1,  16, 105,   2,   0, 2 /)
      NCODPA(INBPAR+4 ,1:6) = (/   1,  33, 105,  10,   0, 0 /)
      NCODPA(INBPAR+5 ,1:6) = (/   1,  34, 105,  10,   0, 0 /)
      NCODPA(INBPAR+6 ,1:6) = (/   1,  51, 105,   2,   0, 0 /)
      NCODPA(INBPAR+7 ,1:6) = (/   1,  52, 105,   2,   0, 0 /)
      NCODPA(INBPAR+8 ,1:6) = (/ 149,  90, 105,   2,   0, 2 /)
      NCODPA(INBPAR+9 ,1:6) = (/ 149,  91, 105,   2,   0, 2 /)
      NCODPA(INBPAR+10,1:6) = (/   1, 163, 105,  10,   0, 0 /)
      NCODPA(INBPAR+11,1:6) = (/   1, 164, 105,  10,   0, 0 /)
C
C     1.5 -  Champs au niveau tropopause
C
      INBPAR = NBPARC
      NBPARC = INBPAR + 2
      IF (NBPARC.GT.JPXPAR) GOTO 1001
      DO J=INBPAR+1,NBPARC
        CIPREF(J) = 'ICAO'
      ENDDO
      CISUFF(INBPAR+1 ) = 'TROP.PRESSUR'
      CISUFF(INBPAR+2 ) = 'TROP.TEMPERA'
      NCODPA(INBPAR+1 ,1:6) = (/   1,   1,   7,   0,   0, 0 /)
      NCODPA(INBPAR+2 ,1:6) = (/   1,  11,   7,   0,   0, 0 /)
C
C     1.6 -  Champs au niveau jet
C
      INBPAR = NBPARC
      NBPARC = INBPAR + 3
      IF (NBPARC.GT.JPXPAR) GOTO 1001
      DO J=INBPAR+1,NBPARC
        CIPREF(J) = 'JET'
      ENDDO
      CISUFF(INBPAR+1 ) = 'PRESSURE'
      CISUFF(INBPAR+2 ) = 'VENT_ZONAL'
      CISUFF(INBPAR+3 ) = 'VENT_MERIDIEN'
      NCODPA(INBPAR+1 ,1:6) = (/   1,   1,   6,   0,   0, 0 /)
      NCODPA(INBPAR+2 ,1:6) = (/   1,  33,   6,   0,   0, 0 /)
      NCODPA(INBPAR+3 ,1:6) = (/   1,  34,   6,   0,   0, 0 /)
C
C     1.7 -  Champs pour la Couche Limite Planetaire
C
      INBPAR = NBPARC
      NBPARC = INBPAR + 2
      IF (NBPARC.GT.JPXPAR) GOTO 1001
      DO J=INBPAR+1,NBPARC
        CIPREF(J) = 'CLP'
      ENDDO
      CISUFF(INBPAR+1 ) = 'MHAUT.MOD.XFU'
      CISUFF(INBPAR+2 ) = 'MOCON.MOD.XFU'
      NCODPA(INBPAR+1 ,1:6) = (/   1, 165,   1,   0,   0, 0 /)
      NCODPA(INBPAR+2 ,1:6) = (/   1, 166,   1,   0,   0, 0 /)
C
C     1.8 -  Champs au niveau mer
C
      INBPAR = NBPARC
      NBPARC = INBPAR + 1
      IF (NBPARC.GT.JPXPAR) GOTO 1001
      DO J=INBPAR+1,NBPARC
        CIPREF(J) = 'MSL'
      ENDDO
      CISUFF(INBPAR+1 ) = 'PRESSURE'
      NCODPA(INBPAR+1 ,1:6) = (/   1,   2, 102,   0,   0, 0 /)
C
C     1.9 - Relief
C
      INBPAR = NBPARC
      NBPARC = INBPAR + 1
      IF (NBPARC.GT.JPXPAR) GOTO 1001
      DO J=INBPAR+1,NBPARC
        CIPREF(J) = 'INT'
      ENDDO
      CISUFF(INBPAR+1 ) = 'SURFGEOPOTENT'
      NCODPA(INBPAR+1 ,1:6) = (/   1,   8,   1,   0,   0, 0 /)
C
C     1.10- ATMO
C
      INBPAR = NBPARC
      NBPARC = INBPAR + 4
      IF (NBPARC.GT.JPXPAR) GOTO 1001
      DO J=INBPAR+1,NBPARC
        CIPREF(J) = 'ATMO'
      ENDDO
      CISUFF(INBPAR+1 ) = 'NEBUL.CONVEC'
      CISUFF(INBPAR+2 ) = 'NEBUL.BASSE'
      CISUFF(INBPAR+3 ) = 'NEBUL.MOYENN'
      CISUFF(INBPAR+4 ) = 'NEBUL.HAUTE'
      NCODPA(INBPAR+1 ,1:6) = (/ 128,  72,   1,   0,   0, 4 /)
      NCODPA(INBPAR+2 ,1:6) = (/ 128,  73,   1,   0,   0, 4 /)
      NCODPA(INBPAR+3 ,1:6) = (/ 128,  74,   1,   0,   0, 4 /)
      NCODPA(INBPAR+4 ,1:6) = (/ 128,  75,   1,   0,   0, 4 /)
C
C     1.11- TOP
C
      INBPAR = NBPARC
      NBPARC = INBPAR + 1
      IF (NBPARC.GT.JPXPAR) GOTO 1001
      DO J=INBPAR+1,NBPARC
        CIPREF(J) = 'TOP'
      ENDDO
      CISUFF(INBPAR+1 ) = 'RAYT DIR SOM'
      NCODPA(INBPAR+1 ,1:6) = (/ 149, 174,   8,   0,   0, 4 /)
C**
C     2.  -  TRAITEMENT DES CHAMPS SUR NIVEAUX
C-----------------------------------------------------------------------
C
C     2.1 -  Champs sur un niveau isobare
C
C  ATTENTION: comme les champs HAUTEUR sont tres proches
C             des champs ISOBARE, un copier-coller sera fait
C             pour les INB champs suivants:
C             Revoir la methode si un champ PRESSION ne suivait
C             pas cette regle !!
      INB = 32
      INBPAR = NBPARC
      NBPARC = INBPAR + INB
      IF (NBPARC.GT.JPXPAR) GOTO 1001
      DO J=INBPAR+1,NBPARC
        CIPREF(J) = 'P'
      ENDDO
      CISUFF(INBPAR+1 ) = 'POT_VORTIC'
      CISUFF(INBPAR+2 ) = 'GEOPOTENTI'
      CISUFF(INBPAR+3 ) = 'TEMPERATUR'
      CISUFF(INBPAR+4 ) = 'TEMPE_POTE'
      CISUFF(INBPAR+5 ) = 'THETA_PRIM'
      CISUFF(INBPAR+6 ) = 'VENT_ZONAL'
      CISUFF(INBPAR+7 ) = 'VENT_MERID'
      CISUFF(INBPAR+8 ) = 'VITESSE_VE'
      CISUFF(INBPAR+9 ) = 'ABS_VORTIC'
      CISUFF(INBPAR+10) = 'DIVERGENCE'
      CISUFF(INBPAR+11) = 'HUMI.SPECI'
      CISUFF(INBPAR+12) = 'HUMI_RELAT'
C Debut des champs pour Mocage :
      CISUFF(INBPAR+13) = 'O3'
      CISUFF(INBPAR+14) = 'NO2'
      CISUFF(INBPAR+15) = 'NO'
      CISUFF(INBPAR+16) = 'PAN'
      CISUFF(INBPAR+17) = 'HNO3'
      CISUFF(INBPAR+18) = 'SO2'
      CISUFF(INBPAR+19) = 'CO'
      CISUFF(INBPAR+20) = 'CH4'
      CISUFF(INBPAR+21) = 'C2H6'
      CISUFF(INBPAR+22) = 'NC4H10'
      CISUFF(INBPAR+23) = 'C2H4'
      CISUFF(INBPAR+24) = 'C3H6'
      CISUFF(INBPAR+25) = 'OXYL'
      CISUFF(INBPAR+26) = 'C5H8'
      CISUFF(INBPAR+27) = 'APINEN'
      CISUFF(INBPAR+28) = 'HCHO'
      CISUFF(INBPAR+29) = 'CH3CHO'
      CISUFF(INBPAR+30) = 'GLYOX'
      CISUFF(INBPAR+31) = 'MGLYOX'
      CISUFF(INBPAR+32) = 'CH3COE'
C Fin des champs pour Mocage
      NCODPA(INBPAR+1 ,1:6) = (/   1,   4, 100,   0,   0, 0 /)
      NCODPA(INBPAR+2 ,1:6) = (/   1,   6, 100,   0,   0, 0 /)
      NCODPA(INBPAR+3 ,1:6) = (/   1,  11, 100,   0,   0, 0 /)
      NCODPA(INBPAR+4 ,1:6) = (/   1,  13, 100,   0,   0, 0 /)
      NCODPA(INBPAR+5 ,1:6) = (/   1,  15, 100,   0,   0, 0 /)
      NCODPA(INBPAR+6 ,1:6) = (/   1,  33, 100,   0,   0, 0 /)
      NCODPA(INBPAR+7 ,1:6) = (/   1,  34, 100,   0,   0, 0 /)
      NCODPA(INBPAR+8 ,1:6) = (/   1,  39, 100,   0,   0, 0 /)
      NCODPA(INBPAR+9 ,1:6) = (/   1,  41, 100,   0,   0, 0 /)
      NCODPA(INBPAR+10,1:6) = (/   1,  44, 100,   0,   0, 0 /)
      NCODPA(INBPAR+11,1:6) = (/   1,  51, 100,   0,   0, 0 /)
      NCODPA(INBPAR+12,1:6) = (/   1,  52, 100,   0,   0, 0 /)
      NCODPA(INBPAR+13,1:6) = (/ 159,   1, 100,   0,   0, 0 /)
      NCODPA(INBPAR+14,1:6) = (/ 159,   2, 100,   0,   0, 0 /)
      NCODPA(INBPAR+15,1:6) = (/ 159,   3, 100,   0,   0, 0 /)
      NCODPA(INBPAR+16,1:6) = (/ 159,   4, 100,   0,   0, 0 /)
      NCODPA(INBPAR+17,1:6) = (/ 159,   5, 100,   0,   0, 0 /)
      NCODPA(INBPAR+18,1:6) = (/ 159,   6, 100,   0,   0, 0 /)
      NCODPA(INBPAR+19,1:6) = (/ 159,   7, 100,   0,   0, 0 /)
      NCODPA(INBPAR+20,1:6) = (/ 159,   8, 100,   0,   0, 0 /)
      NCODPA(INBPAR+21,1:6) = (/ 159,   9, 100,   0,   0, 0 /)
      NCODPA(INBPAR+22,1:6) = (/ 159,  10, 100,   0,   0, 0 /)
      NCODPA(INBPAR+23,1:6) = (/ 159,  11, 100,   0,   0, 0 /)
      NCODPA(INBPAR+24,1:6) = (/ 159,  12, 100,   0,   0, 0 /)
      NCODPA(INBPAR+25,1:6) = (/ 159,  13, 100,   0,   0, 0 /)
      NCODPA(INBPAR+26,1:6) = (/ 159,  14, 100,   0,   0, 0 /)
      NCODPA(INBPAR+27,1:6) = (/ 159,  15, 100,   0,   0, 0 /)
      NCODPA(INBPAR+28,1:6) = (/ 159,  16, 100,   0,   0, 0 /)
      NCODPA(INBPAR+29,1:6) = (/ 159,  17, 100,   0,   0, 0 /)
      NCODPA(INBPAR+30,1:6) = (/ 159,  18, 100,   0,   0, 0 /)
      NCODPA(INBPAR+31,1:6) = (/ 159,  19, 100,   0,   0, 0 /)
      NCODPA(INBPAR+32,1:6) = (/ 159,  20, 100,   0,   0, 0 /)
C
C     2.2 -  Champs sur un niveau hauteur
C
C   ATTENTION: on reprend les INB definitions du niveau ISOBARE!!
C
      INBPAR = NBPARC
      NBPARC = INBPAR + INB
      IF (NBPARC.GT.JPXPAR) GOTO 1001
      DO J=INBPAR+1,NBPARC
        CIPREF(J) = 'H'
        CISUFF(J) = CISUFF(J-INB)
        NCODPA(J,1:2) = NCODPA(J-INB,1:2)
        NCODPA(J,3) = 105
        NCODPA(J,4:6) = NCODPA(J-INB,4:6)
      ENDDO
C
C     2.3 -  Champs sur un niveau iso-tourbillon-potentiel
C
C  ATTENTION: comme les champs ISENTROPE sont tres proches
C             des champs ISO-PV, un copier-coller sera fait
C             pour les INB champs suivants:
C             Revoir la methode si un champ ISO-PV ne suivait
C             pas cette regle !!
      INB = 10
      INBPAR = NBPARC
      NBPARC = INBPAR + INB
      IF (NBPARC.GT.JPXPAR) GOTO 1001
      DO J=INBPAR+1,NBPARC
        CIPREF(J) = 'V'
      ENDDO
      CISUFF(INBPAR+1 ) = 'GEOPOTENTIEL'
      CISUFF(INBPAR+2 ) = 'TEMPERATURE'
      CISUFF(INBPAR+3 ) = 'TEMPE_POTENT'
      CISUFF(INBPAR+4 ) = 'VENT_ZONAL'
      CISUFF(INBPAR+5 ) = 'VENT_MERIDIE'
      CISUFF(INBPAR+6 ) = 'VITESSE_VE'
      CISUFF(INBPAR+7 ) = 'ABS_VORTICIT'
      CISUFF(INBPAR+8 ) = 'DIVERGENCE'
      CISUFF(INBPAR+9 ) = 'HUMI.SPECI'
      CISUFF(INBPAR+10) = 'HUMI_RELAT'
      NCODPA(INBPAR+1 ,1:6) = (/   1,   6, 117,   0,   0, 0 /)
      NCODPA(INBPAR+2 ,1:6) = (/   1,  11, 117,   0,   0, 0 /)
      NCODPA(INBPAR+3 ,1:6) = (/   1,  13, 117,   0,   0, 0 /)
      NCODPA(INBPAR+4 ,1:6) = (/   1,  33, 117,   0,   0, 0 /)
      NCODPA(INBPAR+5 ,1:6) = (/   1,  34, 117,   0,   0, 0 /)
      NCODPA(INBPAR+6 ,1:6) = (/   1,  39, 117,   0,   0, 0 /)
      NCODPA(INBPAR+7 ,1:6) = (/   1,  41, 117,   0,   0, 0 /)
      NCODPA(INBPAR+8 ,1:6) = (/   1,  44, 117,   0,   0, 0 /)
      NCODPA(INBPAR+9 ,1:6) = (/   1,  51, 117,   0,   0, 0 /)
      NCODPA(INBPAR+10,1:6) = (/   1,  52, 117,   0,   0, 0 /)

C
C     2.4 -  Champs sur un niveau isentrope
C
C   ATTENTION: on reprend les INB definitions du niveau ISO-PV!!
C
      INBPAR = NBPARC
      NBPARC = INBPAR + INB
      IF (NBPARC.GT.JPXPAR) GOTO 1001
      DO J=INBPAR+1,NBPARC
        CIPREF(J) = 'T'
        CISUFF(J) = CISUFF(J-INB)
        NCODPA(J,1:2) = NCODPA(J-INB,1:2)
        NCODPA(J,3) = 113
        NCODPA(J,4:6) = NCODPA(J-INB,4:6)
      ENDDO
C Champs suppl differents de ceux d'ISO-PV
      INBPAR = NBPARC
      NBPARC = INBPAR + 1
      IF (NBPARC.GT.JPXPAR) GOTO 1001
      DO J=INBPAR+1,NBPARC
        CIPREF(J) = 'T'
      ENDDO
      CISUFF(INBPAR+1) = 'POT_VORTICIT'
      NCODPA(INBPAR+1 ,1:6) = (/   1,   4, 113,   0,   0, 0 /)
C
C     2.5 -  Champs sur un niveau modele
C
C
      INBPAR = NBPARC
      NBPARC = INBPAR + 12
      IF (NBPARC.GT.JPXPAR) GOTO 1001
      DO J=INBPAR+1,NBPARC
        CIPREF(J) = 'S'
      ENDDO
      CISUFF(INBPAR+1 ) = 'TEMPERATURE'
      CISUFF(INBPAR+2 ) = 'WIND.U.PHYS'
      CISUFF(INBPAR+3 ) = 'VENT_ZONAL'
      CISUFF(INBPAR+4 ) = 'WIND.V.PHYS'
      CISUFF(INBPAR+5 ) = 'VENT_MERIDIE'
      CISUFF(INBPAR+6 ) = 'FONC.COURANT'
      CISUFF(INBPAR+7 ) = 'POT.VITESSE'
      CISUFF(INBPAR+8 ) = 'VORTICITY'
      CISUFF(INBPAR+9 ) = 'DIVERGENCE'
      CISUFF(INBPAR+10) = 'HUMI.SPECIFI'
      CISUFF(INBPAR+11) = 'VERTIC.DIVER'
      CISUFF(INBPAR+12) = 'PRESS.DEPART'
      NCODPA(INBPAR+1 ,1:6) = (/   1,  11, 109,   0,   0, 0 /)
      NCODPA(INBPAR+2 ,1:6) = (/   1,  33, 109,   0,   0, 0 /)
      NCODPA(INBPAR+3 ,1:6) = (/   1,  33, 109,   0,   0, 0 /)
      NCODPA(INBPAR+4 ,1:6) = (/   1,  34, 109,   0,   0, 0 /)
      NCODPA(INBPAR+5 ,1:6) = (/   1,  34, 109,   0,   0, 0 /)
      NCODPA(INBPAR+6 ,1:6) = (/   1,  35, 109,   0,   0, 0 /)
      NCODPA(INBPAR+7 ,1:6) = (/   1,  36, 109,   0,   0, 0 /)
      NCODPA(INBPAR+8 ,1:6) = (/   1,  43, 109,   0,   0, 0 /)
      NCODPA(INBPAR+9 ,1:6) = (/   1,  44, 109,   0,   0, 0 /)
      NCODPA(INBPAR+10,1:6) = (/   1,  51, 109,   0,   0, 0 /)
      NCODPA(INBPAR+11,1:6) = (/ 149,  91, 109,   0,   0, 0 /)
      NCODPA(INBPAR+12,1:6) = (/ 149,  92, 109,   0,   0, 0 /)
C
C**
C    10.  -  PHASE TERMINALE
C-----------------------------------------------------------------------
C
      RETURN
C
 1001 CONTINUE
      PRINT *,'FAICOR: ERROR, ',NBPARC,' fields are initialized'
      PRINT *,'        but only ',JPXPAR,' are possible.'
      PRINT *,'        Change JPXPAR in famodu.F'
      STOP
C
      END
