      SUBROUTINE FAIENC ( KREP,   KNUMER, CDPREF, KNIVAU, CDSUFF,
     S                    PCHAMP, LDCOSP )
#include "facom0.h"
C****
C      Sous-programme d'ECRITURE d'un CHAMP HORIZONTAL sur un fichier
C     ARPEGE.
C       ( Integration par Ecriture d'un (Nouveau ?) Champ )
C**
C    Arguments : KREP   (Sortie) ==> Code-reponse du sous-programme;
C                KNUMER (Entree) ==> Numero de l'unite logique;
C                CDPREF (Entree) ==> Prefixe eventuel du nom d'article;
C                KNIVAU (Entree) ==> Niveau vertical eventuel;
C                CDSUFF (Entree) ==> Suffixe eventuel du nom d'article;
C    ( Tableau ) PCHAMP (Entree) ==> Valeurs REELLES du champ a ecrire;
C                LDCOSP (Entree) ==> Vrai si le champ est represente
C                                    par des coefficients spectraux.
C
C     Modifications
C     -------------
C
C    Avril 1998: Partie "codage" (paragraphe 3 du sous-programme)
C                demenagee dans un sous-programme a usage interne au
C                logiciel (FACINE). Le but est de pouvoir, sur machine
C                a memoire distribuee, separer codage (via FACOND) et
C                ecriture (via FAISAN) afin de paralleliser le codage.
C
C  Avril 2004, D. Paradis, DSI/DEV:
C
C    -Declaration IVALCO en ALLOCATABLE (gain memoire)
C
#include "precision.h"
C
#include "facomp.h"
#include "facom1.h"
C
      INTEGER KREP, KNUMER, KNIVAU
C
      REAL (KIND=JPDBLR) PCHAMP (*)
C
      CHARACTER CDPREF*(*), CDSUFF*(*)
C
      INTEGER IREP, ILPRFU, ILSUFU, ILNOMU, ILONGA, IRANG, INIMES
      INTEGER ILPREF, ILSUFF
C
      INTEGER (KIND=JPDBLE), ALLOCATABLE :: IVALCO(:)
      INTEGER IB1PAR (JPLB1P)
C
      INTEGER IVALC1, IRANGC, ILCHAM
C
      LOGICAL LLVERF, LLRLFI, LDCOSP, LLNOMU, LLMLAM, LLNOPA
C
      CHARACTER CLPREF*(JPXNOM), CLSUFF*(JPXSUF)
C
#include "facom2.h"
C**
C     1.  -  CONTROLES ET INITIALISATIONS.
C-----------------------------------------------------------------------
C
      LLVERF=.FALSE.
      LLRLFI=.FALSE.
      LLNOMU=.FALSE.
      LLNOPA=.FALSE.
      ILPRFU=LEN (CDPREF)
      ILSUFU=LEN (CDSUFF)
      CALL FANUMU (KNUMER,IRANG)
C
      IF (IRANG.EQ.0) THEN
        IREP=-51
        GOTO 1001
      ENDIF
C
C         Verrouillage eventuel du fichier.
C
      IF (LFAMUL) CALL LFIVER (VRFICH(IRANG),'ON')
      LLVERF=LFAMUL
C
      IF (LCREAF(IRANG)) THEN
        IREP=-85
        GOTO 1001
      ENDIF
C**
C     2.  -  FABRICATION DU NOM D'ARTICLE VIA LE SOUS-PROGRAMME "FANFAR"
C            ( controles de CDPREF, KNIVAU, CDSUFF inclus )
C-----------------------------------------------------------------------
C
      CALL FANFAR (IREP,IRANG,CDPREF,KNIVAU,CDSUFF,CLNOMA,IB1PAR(6),
     S             ILPRFU,ILSUFU,ILNOMU)
      IF (IREP.NE.0) GOTO 1001
      LLNOMU=.TRUE.
C**
C     3.  -  CALCUL D'UN MAJORANT POUR LA LONGUEUR DE L'ARTICLE (mots)
C            ( on va prendre le nombre de valeurs du champ +2 :
C              l'absence de compactage est un majorant et les 2 mots
C              correspondent a l'enrobage FA dans ce cas )
C-----------------------------------------------------------------------
C
      IVALC1=NFGRIB(IRANG)
      IRANGC=NUCADR(IRANG)
      LLMLAM=LIMLAM(IRANGC)
      IF (LDCOSP) THEN
        IF (LLMLAM) THEN
          ILCHAM=NSFLAM(IRANGC)
        ELSE
          IF (IVALC1.EQ.-1 .OR. IVALC1.EQ.3) THEN
            ILCHAM=(1+MTRONC(IRANGC))*(2+MTRONC(IRANGC))
          ELSE
            ILCHAM=(1+MTRONC(IRANGC))**2
          ENDIF
        ENDIF
      ELSE
        ILCHAM=NVAPDG(IRANGC)
      ENDIF
C
      ALLOCATE (IVALCO (ILCHAM+2))

C**
C     4.  -  FABRICATION DE L'ARTICLE A ECRIRE SUR LE FICHIER.
C-----------------------------------------------------------------------
C
C  Controle de l'homogeneite du type de rangement de coeff. spectraux
C  parmi les champs lus/ecrits: ces champs compactes avec
C  NIGRIB=-1 ou 3 doivent etre ranges comme dans le modele ("verticalement"
C  soit selon des colonnes JM=cst consecutives) et contrairement si compactes
C  avec NIGRIB= 0,1 ou 2.
C
      IRANGC=NUCADR(IRANG)
      IF (LDCOSP) THEN
        IF (NFGRIB(IRANG).EQ.-1 .OR. NFGRIB(IRANG).EQ.3) THEN
          NRASVE(IRANG)=NRASVE(IRANG)+1
          IF (NRASVE(IRANG).EQ.1 .AND. NRASHO(IRANG).GT.0) THEN
            WRITE(0,*)'------------------------------------------------'
            WRITE(0,*)' FAIENC :  WARNING !!!!!           '
            WRITE(0,*)' Un champ de coeff. spectraux avec'
            WRITE(0,*)' rangement type modele va etre ecrit alors que'
            WRITE(0,*)' les autres champs ont un rangement different.'
            WRITE(0,*)'------------------------------------------------'
          ENDIF
        ELSEIF (NFGRIB(IRANG).GE.0 .AND. NFGRIB(IRANG).LE.2) THEN
          NRASHO(IRANG)=NRASHO(IRANG)+1
          IF (NRASHO(IRANG).EQ.1 .AND. NRASVE(IRANG).GT.0) THEN
            WRITE(0,*)'------------------------------------------------'
            WRITE(0,*)' FAIENC :  WARNING !!!!!           '
            WRITE(0,*)' Un champ de coeff. spectraux avec'
            WRITE(0,*)' rangt autre que celui du modele va etre ecrit'
            WRITE(0,*)' alors que d''autres champs ont le rangt modele'
            WRITE(0,*)'------------------------------------------------'
          ENDIF
        ENDIF
      ENDIF
C
500   CONTINUE
C
      IF (NFGRIB(IRANG).EQ.3) THEN
C Cas d'un champ qu'il faut "griber" avec GRIBEX
        CALL FACODX ( IREP, IRANG, CDPREF, KNIVAU, CDSUFF, PCHAMP(1),
     S                LDCOSP, IVALCO, ILONGA)
C
C Cas particulier de l'erreur GRIBEX num 710: OUTPUT ARRAY TOO SMALL
C On s'en sert pour detecter un probleme de compactage lie a ce que
C le champ compacte + les descripteurs prennent plus de place que le
C champ non compacte...
C On sort donc du compactage (FACODX) pour demander un codage sans
C compactage (FACINE) avec rangement des valeurs selon le modele:
C NFGRIB=-1.
C
        IF (IREP==-1710) THEN
          IREP = 0
          NFGRIB(IRANG) = -1
          LLNOPA = .TRUE.
          GOTO 500
        ENDIF
      ELSE
        CALL FACINE ( IREP, IRANG, CLNOMA(1:ILNOMU), PCHAMP,
     S                LDCOSP, IVALCO, ILONGA, IB1PAR )
        IF (LLNOPA) NFGRIB(IRANG) = 3
C  Le codage num 3 avait ete demande mais se revelait etre
C  plus gourmand en place que le num -1: on avait donc force
C  l'absence de compactage (-1). On revient maintenant au codage
C  num 3 pour ce cadre IRANG et les eventuels codages suivants.
C
      ENDIF
      IF (IREP.NE.0) GOTO 1001
C**
C     5.  -  ECRITURE DE L'ARTICLE "CHAMP" SUR LE FICHIER.
C-----------------------------------------------------------------------
C
      CALL LFIECR (IREP,KNUMER,CLNOMA(1:ILNOMU),IVALCO,ILONGA)
      LLRLFI=IREP.NE.0
C**
C    10.  -  PHASE TERMINALE : MESSAGERIE, AVEC "ABORT" EVENTUEL,
C            VIA LE SOUS-PROGRAMME "FAIPAR" .
C-----------------------------------------------------------------------
C
 1001 CONTINUE
      IF (ALLOCATED( IVALCO )) DEALLOCATE ( IVALCO )
      KREP=IREP
      LLFATA=LLMOER (IREP,IRANG)
C
C        Deverrouillage eventuel du fichier.
C
      IF (LLVERF) CALL LFIVER (VRFICH(IRANG),'OFF')
C
      IF (LLFATA) THEN
        INIMES=2
      ELSE
        INIMES=IXNVMS(IRANG)
      ENDIF
C
      IF (.NOT.LLFATA.AND.INIMES.NE.2) RETURN
C
      CLNSPR='FAIENC'
C
      IF (ILPRFU.GE.1) THEN
        ILPREF=MIN (ILPRFU,LEN (CLPREF))
        CLPREF(1:ILPREF)=CDPREF(1:ILPREF)
      ELSE
        ILPREF=8
        CLPREF(1:ILPREF)=CHAINC(:ILPREF)
      ENDIF
C
      IF (ILSUFU.GE.1) THEN
        ILSUFF=MIN (ILSUFU,LEN (CLSUFF))
        CLSUFF(1:ILSUFF)=CDSUFF(1:ILSUFF)
      ELSE
        ILSUFF=8
        CLSUFF(1:ILSUFF)=CHAINC(:ILSUFF)
      ENDIF
C
      IF (.NOT.LLNOMU) THEN
        ILNOMU=MIN (ILPREF,NCPCAD)
        CLNOMA(1:ILNOMU)=CLPREF(1:ILPREF)
      ENDIF
C
      WRITE (UNIT=CLMESS,FMT='(''KREP='',I5,'', KNUMER='',I3,
     S       '', CDPREF='''''',A,'''''', KNIVAU='',I6,
     S       '', CDSUFF='''''',A,'''''', LDCOSP= '',L1)')
     S   KREP,KNUMER,CLPREF(1:ILPREF),KNIVAU,CLSUFF(1:ILSUFF),LDCOSP
      CALL FAIPAR (KNUMER,INIMES,IREP,LLFATA,CLMESS,CLNSPR,
     S             CLNOMA(1:ILNOMU),LLRLFI)
C
      RETURN
      END
