      SUBROUTINE FAIS2F ( KREP, KRANG )
#include "facom0.h"
C****
C      Ce sous-programme initialise un tableau "reference" de
C      l'en-tete GRIB, section 2.
C      (routine appelee une seule fois pour un fichier Aladin donne)
C**
C    Arguments : KREP   (Sortie) ==> Code-reponse du sous-programme;
C                KRANG  (Entree) ==> Rang de l'unite logique;
C*
C
      USE FAMODU   , ONLY : NSC2ALF, NOMPAR
C
#include "precision.h"
C
#include "facomp.h"
#include "facom1.h"
C
      INTEGER KREP, KRANG
C
      INTEGER IRANGC, JM, JMAX, ILOW, IADD, INUMER, INIMES
C
#include "facom2.h"
C**
C     0.  -  INITIALISATIONS ET CONTROLES
C-----------------------------------------------------------------------
C
      KREP=0
      IF (KRANG.LE.0.OR.KRANG.GT.JPNXFA) THEN
        KREP=-66
        GOTO 1001
      ENDIF
      IRANGC=NUCADR(KRANG)
C**
C     1.  -  INITIALISATION DU TABLEAU NSC2ALF
C-----------------------------------------------------------------------
C
C  Les valeurs de ce tableau representent les nb de pts
C le long de chaque "parallele" (ici, le nb de coeff spectraux
C pour un meme m (nb d'onde zonal), excepte le triangle et les axes non
C compactes). Il s'agit en effet de deguiser un champ spectral 
C Aladin en champ pts de grille (grille lat-lon) pour profiter
C du compactage, voire de la compression, GRIBEX.
C Le rangt des CSP est fait verticalement (par colonne de m=cst)
C et pour chaque couple (m,n) correspond 4 CSP.
C
      JMAX = (NOZPAR(6,IRANGC)-NOZPAR(5,IRANGC)+1)/4 -1
      DO JM=1,JMAX
        ILOW=2+2*JM+1
        IADD=4* MAX(NSTROF(KRANG)+1-JM,1)
C
        NSC2ALF(JM,KRANG)=NOMPAR(ILOW+1,IRANGC)-
     S                        (NOMPAR(ILOW,IRANGC)+IADD)+1
      ENDDO
C**
C    10.  -  PHASE TERMINALE : MESSAGERIE, AVEC "ABORT" EVENTUEL,
C            VIA LE SOUS-PROGRAMME "FAIPAR" .
C-----------------------------------------------------------------------
C
 1001 CONTINUE
      LLFATA=LLMOER (KREP,KRANG)
C
      IF (LFAMOP.OR.LLFATA) THEN
        INIMES=2
        CLNSPR='FAIS2F'
        INUMER=JPNIIL
C
        WRITE (UNIT=CLMESS,FMT='(''KREP='',I4,'', KRANG='',I4)')
     S     KREP, KRANG
        CALL FAIPAR (INUMER,INIMES,KREP,.FALSE.,CLMESS,CLNSPR,
     S               CLNSPR,.FALSE.)
      ENDIF
C
      RETURN
      END
