      SUBROUTINE FARINE ( KOPTIO )
#include "facom0.h"
C****
C        Ce sous-programme est charge des INITIALISATIONS du logiciel
C     de Fichiers ARPEGE FA ( Routine d'INitialisation )
C**
C        Argument : KOPTIO  ==> OPTION concernant le mode d'utilisation.
C                  (Entree)     (MULTI-TACHE ou NON)
C     VALEURS POSSIBLES : 0 ==> Mode MONO-Tache prescrit;
C                         1 ==> Mode MULTI-Taches prescrit;
C                         2 ==> Utilisation du mode par defaut si c'est
C                               le premier appel; sinon on garde le mode
C                               prescrit anterieurement .
C
      USE FAMODU   , ONLY : LIXLAP   ,LIFLAP   ,LISEC1   ,LISEC2 
     S                     ,NCODGRI  ,LISC2F
C
#include "precision.h"
C
#include "facomp.h"
#include "facom1.h"
C
      INTEGER KOPTIO
C
      INTEGER IREP, J, JN, IDEBUT, IFIN, INDM, INDN, INIMES, INUMER
      INTEGER JJPUIS, INCHIF
C
      LOGICAL LLPREA, LLDEFM, LLNMUL, LLASGN, LLREL
      SAVE LLPREA, LLDEFM
C
      DATA LLPREA /.TRUE./, LLDEFM /.FALSE./
C
#include "facom2.h"
C
      IF (KOPTIO.LT.0.OR.KOPTIO.GT.2) THEN
        IREP=-52
        GOTO 1001
      ENDIF
C
      IF (LLPREA) THEN
C
C         C'EST LE PREMIER APPEL AU sous-programme - INITIALISATIONS .
C
        NFIOUV=0
        NCADEF=0
        NRFAGA=1
        NIMSGA=1
        NBIPDG=24
        NBICSP=24
        NPUILA=1
        NSTROI=10
        NMIDPL=5
        NIGRIB=2
        LFAMOP=.FALSE.
        LERRFA(0)=.TRUE.
        NIVOMS(0)=0
        NCPCAD=LEN (CNOMCA(1))
        SPSMIN=45000.
        SPSMAX=110000.
        MPRESX=100000
        NBIMAC=64
        NBIMAX=31
        LIGARD=.FALSE.
        NTYPTX=2
        NXNIVV=JPXNIV
        NXTRON=JPXTRO
        NXLATI=JPXLAT
        NXLONG=JPXLON
C
        DO 101 J=1,JPNXFA
          NULOGI(J)=JPNIIL
          NRASHO(J)=0
          NRASVE(J)=0
  101   CONTINUE
C
        DO 102 J=1,JPNXCA
          CNOMCA(J)=' '
  102   CONTINUE
C
        DO 1020 J=1,JPXNOM
          CHAINC(J:J)='?'
 1020   CONTINUE
C
C        Descripteurs lies aux types de niveaux verticaux:
C        prefixes reconnus, extrema possibles du niveau dans le cas
C        d'une coordonnee verticale, premiers elements de xB1PAR.
C
        DO 111 J=0,JPTNIV
C
C       Initialisation par defaut pour la serie d'affectations qui suit.
C
          NIVDSC(0,J)=0
          NIVDSC(1,J)=0
          NIVDSC(2,J)=0
C
C        Tous les cas sont reputes "niveau vrai" (pas des couches).
C
          NIVDSC(4,J)=0
  111   CONTINUE
C
C           Cas du type non reconnu.
C
        NIVDSC(0,0)=0
        NIVDSC(3,0)=200
C
C           Niveau hybride.
C
        CTNPRF(1)='S'
        NIVDSC(0,1)=3
        NIVDSC(2,1)=JPXNIV
        NIVDSC(3,1)=109
C
C           Niveau isobare.
C
        CTNPRF(2)='P'
        NIVDSC(0,2)=5
        NIVDSC(1,2)=1
        NIVDSC(2,2)=10**5
        NIVDSC(3,2)=100
C
C           Niveau iso-hauteur (au-dessus d'un relief de reference).
C
        CTNPRF(3)='H'
        NIVDSC(0,3)=5
        NIVDSC(2,3)=10**5-1
        NIVDSC(3,3)=105
C
C           Niveau iso-tourbillon_potentiel.
C
        CTNPRF(4)='V'
        NIVDSC(0,4)=3
        NIVDSC(2,4)=10**3-1
        NIVDSC(3,4)=117
C
C           Niveau iso-temperature_potentielle.
C
        CTNPRF(5)='T'
        NIVDSC(0,5)=3
        NIVDSC(2,5)=10**3-1
        NIVDSC(3,5)=113
C
C           Niveau surface.
C
        CTNPRF(6)='SURF'
        NIVDSC(3,6)=1
C
C           Niveau de vent max (jet).
C
        CTNPRF(7)='JET'
        NIVDSC(3,7)=6
C
C           Niveau surface.
C
        CTNPRF(8)='TROPO'
        NIVDSC(3,8)=7
C
C           Niveau moyen de la mer.
C
        CTNPRF(9)='MER'
        NIVDSC(3,9)=102
C
C           Niveau hybride bis pour MOCAGE
C
        CTNPRF(10)='L'
        NIVDSC(0,10)=3
        NIVDSC(2,10)=JPXNIV
C
C  Initialisations pour la mise en oeuvre de GRIBEX
C
C  1/ On force GRIBEX a calculer la puissance de laplacien
        CALL GRSMKP(1)
C  2/ On retire l'arrondi du message GRIB a un multiple de 120 octets
        CALL GRSRND(0)
C
C  3/ Creation de la correspondance "nom article FA" et
C                                   "descripteurs GRIBEX"
        CALL FAICOR
C
C
C  4/ Definition du codage GRIBEX par defaut:
C
C  Il s'agit d'une compression "APAC1" (meilleure solution entre
C  l'absence de compression et la compression ligne a ligne)
C  associee a la compression "general extended", a la differentiation
C  spatiale (-1: calcul dynamique de l'ordre) et au rearrangement
C  boustrophedonique.
C
C  "APAC1"
        NCODGRI(1) = 1
        NCODGRI(2) = 16
        NCODGRI(3) = 0
        NCODGRI(4) = 0
        NCODGRI(5) = 16
        NCODGRI(6) = 0
C  compression "general extended"
        NCODGRI(7) = 8
C  arrangement boustrophedonique
        NCODGRI(8) = 4
C  differentiation spatiale
        NCODGRI( 9)= 0
        NCODGRI(10)= -1
C
C  5/ Initialisation de logiques pilotant des initialisations ulterieures
C
C  Il faudra initialiser XLAPxDx
        LIXLAP=.TRUE.
C  Il ne faut pas initialiser FLAP1Dx(): on attend l'ouverture du fichier
        LIFLAP(:)=.FALSE.
C  Il faudra initialiser le tableau NSEC1 (section 1 GRIBEX) via FAISC1
        LISEC1(:)=.TRUE.
C  Il faudra initialiser les tableaux NSEC2xxx et XSEC2
C  (section 2 GRIBEX) via FAISC2
        LISEC2(:)=.TRUE.
C  Il faudra initialiser le tableau NSC2ALF
C  (section 2 GRIBEX) via FAIS2F
        LISC2F(:)=.TRUE.
C
        LLPREA=.FALSE.
        LLNMUL=(KOPTIO.EQ.1).OR.(KOPTIO.EQ.2.AND.LLDEFM)
        LLASGN=LLNMUL
        LLREL=.FALSE.
        CALL LFIINI(KOPTIO)
C
      ELSEIF (KOPTIO.EQ.2) THEN
C
C         CE N'EST PAS LE PREMIER APPEL, MAIS COMME L'ARGUMENT VAUT 2,
C         ON LAISSE LES CHOSES EN PLACE .
C
        LLNMUL=LFAMUL
        LLASGN=.FALSE.
        LLREL =.FALSE.
C
      ELSE
        LLNMUL=KOPTIO.EQ.1
        LLASGN=LLNMUL.AND.(.NOT.LFAMUL)
        LLREL =(.NOT.LLNMUL).AND.LFAMUL
C
C     CE N'EST PAS LE PREMIER APPEL ET LE MODE EST PASSE 'EXPLICITEMENT'
C
        IF ((LLASGN.OR.LLREL).AND.NFIOUV.NE.0) THEN
          IREP=-54
          GOTO 1001
        ENDIF
C
        CALL LFIINI(KOPTIO)
C
      ENDIF
C
      LFAMUL=LLNMUL
      IREP=0
C
      IF (LLASGN) THEN
        CALL LFIVER (VRGLAS,'ASGN')
      ELSEIF (LLREL) THEN
        CALL LFIVER (VRGLAS,'REL')
      ENDIF
C
 1001 CONTINUE
C
C        MESSAGERIE EVENTUELLE, AVEC ABORT SI NECESSAIRE .
C
      LLFATA=IREP.NE.0.AND.NRFAGA.NE.2
C
      IF (LLFATA.OR.LFAMOP) THEN
        INIMES=2
      ELSEIF (IREP.NE.0) THEN
        INIMES=0
      ELSEIF (NIMSGA.EQ.2) THEN
        INIMES=2
      ELSE
        RETURN
      ENDIF
C
      CLNSPR='FARINE'
      INUMER=JPNIIL
C
      IF (MAX (INIMES,NIMSGA).EQ.2) THEN
        WRITE (UNIT=CLMESS,FMT='(''KOPTIO='',I5,'', CODE INTERNE='',I4)'
     S         ) KOPTIO,IREP
        IF (INIMES.NE.2) CALL FAIPAR (INUMER,NIMSGA,IREP,.FALSE.,CLMESS,
     S                                CLNSPR,CLACTI,.FALSE.)
      ENDIF
C
      CALL FAIPAR (INUMER,INIMES,IREP,LLFATA,CLMESS,CLNSPR,CLACTI,
     S             .FALSE.)
C
      RETURN
      END
