      SUBROUTINE GRIB_CLOSE(kunit, kret)

      implicit none

c
c***  SUBROUTINE GRIB_CLOSE(kunit, kret)
c
c     Sami Saarinen, ECMWF, 28/11/95
c
c***  Purpose:
c
c     Close the GRIB file
c
c***  Externals:
c
c     GRIB_FREE_IOBUF - Releases the I/O-buffer space (if allocated at all)
c     PBCLOSE         - Closes the GRIB file
c
c***  Notes:
c
c     Coded in Fortran-90
c
c***  Input variables
      integer, intent(in) :: kunit ! PBIO file pointer
c*** Output variables
      integer, intent(out):: kret  ! Return code
                                   !  0 = OK
                                   ! -1 = File handling error
c-----------------------------------------------------------------------
! === END OF INTERFACE BLOCK ===

      call UTIL_FREE_IOBUF(kunit, kret)
      call PBCLOSE(kunit, kret)

      END
