      SUBROUTINE SBYTE_MF(KDEST,KSOURC,KOFSET,KBYTSZ)
C*****
C*
C*    FUNCTION: STORE A SINGLE BIT FIELD FROM KSOURC INTO KDEST
C*
C*    INPUT   : KSOURC   = WORD CONTAINING  BIT FIELD RIGHT JUSTIFIED
C*              KDEST(1) = 1ST TARGET WORD
C*              KOFSET   = OFFSET IN BITS FOR START OF THE FIELD
C*              KBYTSZ   = LENGTH OF FIELD IN BITS ; .LE.WORD SIZE .....
C*
C*    OUTPUT  : KSOURC,KOFSET,KBYTSZ UNCHANGED
C*              KDEST(1) AND EVENTUALLY KDEST(2) CONTAIN FIELD
C*
C*    AUTHOR  : M.MIQUEU   08/1981 (REWRITTEN FROM J.MARTELLET'S)
C*
C*****
C
#include "precision.h"
C
      INTEGER KOFSET, KBYTSZ
      INTEGER (KIND=JPDBLE) KSOURC
C
      INTEGER (KIND=JPDBLE) KDEST(*)
C
      INTEGER INBPW, ISH1, ISH2, ISH3
C
      INBPW=64
      ISH1=KOFSET+KBYTSZ-INBPW
C
      IF (ISH1.LE.0) THEN
C
C     BYTE  DOES NOT SPAN WORDS
C
        KDEST(1)=ISHFTC(IOR(ISHFT(ISHFTC(KDEST(1),KOFSET,
     s           BIT_SIZE(KDEST(1))),KBYTSZ),
     s           IBITS (KSOURC,0,KBYTSZ)),-ISH1,
     s           BIT_SIZE(IOR(ISHFT(ISHFTC(KDEST(1),KOFSET,
     s           BIT_SIZE(KDEST(1))),KBYTSZ),IBITS (KSOURC,0,KBYTSZ))))
C
      ELSE
C
C     BYTE SPANS 2 WORDS
C
        KDEST(1)=IOR(ISHFTC(ISHFT(KDEST(1),KOFSET-INBPW),INBPW-KOFSET,
     s           BIT_SIZE(ISHFT(KDEST(1),KOFSET-INBPW))),
     s           ISHFT(IBITS(KSOURC,0,KBYTSZ),-ISH1))
C    
        KDEST(2)=ISHFTC(IOR(ISHFT(KDEST(2),ISH1),IBITS(KSOURC,0,ISH1)),
     s           -ISH1,BIT_SIZE(IOR(ISHFT(KDEST(2),ISH1),
     s           IBITS(KSOURC,0,ISH1))))
C
      ENDIF
C
      RETURN
      END
