C
C--- DESCRIPTIF DES TABLES CONCERNANT LES (PAIRES DE) PAGES D'INDEX ----
C                       ( ALIAS "P.P.I." )
C
C     CNOMAR = TABLE DES PAGES D'INDEX DE TYPE "NOMS D'ARTICLES"
C     MLGPOS = TABLE DES PAGES D'INDEX DE TYPE "LONGUEUR/POSITION"
C     MRGPIF = TABLE DES RANGS DES P.P.I. DANS LEUR FICHIER RESPECTIF
C     MCOPIF = TABLE DE CORRESPONDANCE PAGES D'INDEX/UNITES LOGIQUES
C     MRGPIM = TABLE DES RANGS EN MEMOIRE DES P.P.I. AFFECTEES
C              ( DANS *MCOPIF,MRGPIF,CNOMAR,MLGPOS,LECRPI,LPHASP* )
C     LECRPI = VRAI SI LA PAGE D'INDEX CORRESP. DOIT ETRE (RE)ECRITE
C              (.,1) ==> PAGE "NOM", (.,2) ==> PAGE "LONGUEUR/POSITION"
C     LPHASP = VRAI SI LA PAGE D'INDEX "LONG/POS" EST PHASEE EN MEMOIRE
C              AVEC LA PAGE D'INDEX "NOM" CORRESPONDANTE
C
C---------------- VARIABLES "SIMPLES" GLOBALES -------------------------
C
C     NBFIOU = Nombre d'Unites Logiques ouvertes
C     NFACTM = Somme des Facteurs Multiplicatifs utilises
C     NIMESG = NIVEAU *GLOBAL* DE LA MESSAGERIE
C     NERFAG = NIVEAU DE FILTRAGE GLOBAL DES ERREURS FATALES
C     NISTAG = NIVEAU D'IMPRESSION GLOBAL DES STATISTIQUES
C     NPISAF = NBRE DE PAIRES DE PAGES D'INDEX SUPPLEMENTAIRES AFFECTEES
C     LMULTI = VRAI SI ON DOIT TRAVAILLER EN MODE MULTI-TACHES
C     LTAMLG = OPTION PAR DEFAUT D'UTILISATION DE LA MEMOIRE TAMPON EN
C              LECTURE; VRAIE ==> UTILISATION MAXIMUM
C     LTAMEG = CF. CI-DESSUS, EN ECRITURE
C     VERGLA = VERROU GLOBAL (EN MULTI-TASKING)
C     NULOFM = Nombre d'Unites LOgiques a Facteur Multiplicat. predefini
C     CHINCO = Nom par defaut d'une variable qui devrait etre CHaracter
C     NUIMEX = Nombre d'Unites LOgiques en cours d'IMport/EXport
C
C--------- DESCRIPTIF DES ELEMENTS CONCERNANT UNE UNITE LOGIQUE --------
C
C     NUMIND = TABLE D'ADRESSAGE INDIRECT DANS LES TABLEAUX CI-DESSOUS
C     NUMERO = NUMERO DE L'UNITE LOGIQUE
C     MFACTM = FACteur Multiplicatif de la longueur physique elementaire
C     CNOMFI = NOM eventuel du FIchier associe a l'unite logique
C     CNOMSY = Idem pour le systeme, ou a defaut pour l'utilisateur.
C     NLNOMF = LONGUEUR (CARACTERES) DU NOM EVENTUEL
C     NLNOMS = Longueur (en caracteres) du Nom SYSTEME eventuel
C     NDEROP = CODE DE LA DERNIERE ACTION EFFECTUEE
C     CSTAOP = 'STATUS' DE L'OUVERTURE
C     LNOUFI = VRAI SI LE FICHIER EST NOUVEAU (AU SENS DU LOGICIEL)
C     LMODIF =  "   "   "    "    A ETE MODIFIE DEPUIS L'OUVERTURE
C     NDERCO = DERNIER CODE-REPONSE (CORRESPONDANT A LA DERNIERE ACTION)
C     MTAMPD = PAGES DE DONNEES "TAMPON"
C     NUMAPD = NUMERO D'ARTICLE PHYSIQUE CORRESPONDANT A CES PAGES
C     LECRPD = VRAI SI LA PAGE DE DONNEES CORRESP. DOIT ETRE ECRITE
C     NLONPD = LONGUEUR DE PAGE DE DONNEES REELLEMENT REMPLIE
C     NDERPD = NUMERO DE LA DERNIERE PAGE DE DONNEES UTILISEE
C     NPODPI = RANG DE LA DERNIERE PAGE D'INDEX DANS LA TABLE *MRGPIM*
C     NALDPI = NOMBRE D'ARTICLES LOGIQUES DANS LA DERNIERE PAGE D'INDEX
C     NBLECT =    "   DE LECTURES          EFFECTUEES DEPUIS L'OUVERTURE
C     NBNECR =    "   "  NOUVELLES ECRITURES    "        "       "
C     NREESP =    "   "  "VRAIES" REECRITURES SUR PLACE  "       "
C     NREECO =    "   "  REECRITURES PLUS COURTES        "       "
C     NREELO =    "   "       "      PLUS LONGUES        "       "
C     NBRENO =    "   "  FOIS OU ON A RENOMME UN ARTICLE "       "
C     NBSUPP =    "   "   "  " "  " " SUPPRIME "    "    "       "
C     NBTROU =    "   "  TROUS D'INDEX CREES             "       "
C     NIVMES = NIVEAU DE LA MESSAGERIE
C     LERFAT = VRAI SI TOUTE ERREUR DOIT ETRE FATALE
C     LISTAT = OPTION D'IMPRESSION DES STATISTIQUES ( A LA FERMETURE )
C     VERRUE = VERROU DE L'UNITE LOGIQUE (EN MODE MULTI-TASKING)
C     NPPIMM = NBRE DE PAIRES DE PAGES D'INDEX EN MEMOIRE
C     MDES1D = TABLE CONTENANT LE 1ER ARTICLE ("DESCRIPTIF")
C     NTRULZ = NOMBRE DE TROUS D'INDEX DE LONGUEUR NULLE
C     NRFPTZ = RANG PREMIERE ARTICLE AYANT LA CARACTERISTIQUE CI-DESSUS
C     NRFDTZ =   "  DERNIER     "    "    "         "         "
C     NBREAD = NOMBRE DE "READ" FORTRAN REELLEMENT EXECUTES  (DEPUIS L'
C     NBWRIT =    "      "WRITE"   "        "         "       OUVERTURE)
C     NBMOLU = NOMBRE DE MOTS UTILISATEUR LUS   CORRECTEMENT (DEPUIS L'
C     NBMOEC =    "    "   "       "      ECRITS     "        OUVERTURE)
C     LTAMPL = OPTION D'UTILISATION MAXI DE LA MEMOIRE TAMPON EN LECTURE
C     LTAMPE =    "   "      "       "   "   "    "      "    " ECRITURE
C     NDERGF = RANG DANS LE FICHIER DU DERNIER ARTICLE LOGIQUE LU
C              ou dont on a demande les caracteristiques (LFICAS/LFICAP)
C     CNDERA = NOM de ce dernier article logique de donnees
C     NSUIVF = RANG DANS LE FICHIER DU PROCHAIN ARTICLE LOGIQUE A LIRE
C              "SEQUENTIELLEMENT"
C     NPRECF = RANG DANS LE FICHIER DU PROCHAIN ARTICLE LOGIQUE
C              "PRECEDENT" A LIRE
C     LMIMAL = VRAI SI ON DOIT RECALCULER LES LONGUEURS MINI. ET MAXI.
C              DES ARTICLES LOGIQUES DE DONNEES
C     NUMAPH = NUMero d'Article PHysique (pour messages d'erreur E/S).
C     NEXPOR = Rang eventuel (d'EXPORt) dans les tables MNUIEX,NDIMPL,
C     NIMPOR =  "      "     (d'IMPORt) NDEXPL,NREXPL,CNEXPL,NIMPEX...
C
C------------------------ VARIABLES DIVERSES ---------------------------
C
C     MULOFM = Table des Unites LOgiques avec Facteur Multip. predefini
C     MFACTU =   "    "  FActeurs mUltiplicatifs associes a ces Unites
C     MNUIEX =   "    "  Numeros d'Unites logiques en Import/EXport
C     NINIEX =   "   d'adressage INdirect dans MNUIEX
C     NDIMPL = Descripteurs IMPLicites d'import/export en memoire
C     NDEXPL =      "       EXPLicites "   "   /  "    "     "
C     CNIMPL = Profil des articles a description IMPLicite
C     NAEXPL = Nombre d'articles decrits EXPLicitement
C     CNEXPL = Noms des articles decrits dans NDEXPL
C     NREXPL = Rang  "      "       "      "  NDEXPL
C     NIMPEX = Numero d'unite logique associee a l'IMPort ou l'EXport.
C     NUTRAV =    "   "   "      "    de TRAVail pour import ou export.
C     NLAPFD = Longueur d'Article Physique du fichier d'export/import.
C     NXCNLD = Nb.maX. Caracteres/Nom d'article du logiciel LFI Distant.
C     NRCFMX = Rang de la config. Imp/eXport dans CFGMXD, NBMOSD, NBCASD
C     CFGMXD = ConFiGuration pour iMport/eXport des systemes Distants.
C     NBMOSD = Nombre de Bits par MOt       des systemes Distants.
C     NBCASD =    "   "    "   "  CAractere  "     "        "    .
C     CTYPMX = Liste des types de variables valides pour Import/eXport.
C
      CHARACTER*(JPNCPN) CNOMAR (JPNXNA*JPNXPI), CNDERA (JPNXFI), CHINCO
      CHARACTER*(JPLFTX) CNOMFI (JPNXFI), CNOMSY (JPNXFI), CLACTI
      CHARACTER CSTAOP (JPNXFI)*(JPLSTX), CLNSPR*(JPLSPX), CLMESS*132
      CHARACTER CNEXPL (JPXDAM,JPIMEX)*(JPNCPN), CTYPMX*(JPTYMX)
      CHARACTER CNIMPL (JPIMEX)*(JPXMET), CFGMXD (0:JPCFMX)*(JPXCCF)
C
      COMMON /LFICHA/ CNOMAR, CNDERA, CNOMFI, CNOMSY, CSTAOP, CHINCO
     S              , CNEXPL, CNIMPL, CFGMXD, CTYPMX
C
      INTEGER NBFIOU, NFACTM, NIMESG, NERFAG, NISTAG, NPISAF, NULOFM
#ifndef f77
      INTEGER (KIND=JPDBLE) MLGPOS (JPLARD*JPNXPI)
      INTEGER (KIND=JPDBLE) MTAMPD (JPLARD*JPNPDF*JPNXFI)
      INTEGER (KIND=JPDBLE) MDES1D (JPLARD*JPNXFI)
#else
      INTEGER MLGPOS (JPLARD*JPNXPI)
      INTEGER MDES1D (JPLARD*JPNXFI), MTAMPD (JPLARD*JPNPDF*JPNXFI)
#endif
      INTEGER MRGPIM (JPNPIA+JPNPIS,JPNXFI), NDERPD (JPNXFI)
      INTEGER MCOPIF (JPNXPI), MRGPIF (JPNXPI), NLNOMS (JPNXFI)
      INTEGER NUMERO (JPNXFI), NLNOMF (JPNXFI), NDERCO (JPNXFI)
      INTEGER NPODPI (JPNXFI), NUMAPH (0:JPNXFI)
      INTEGER NALDPI (JPNXFI), NBLECT (JPNXFI), NBNECR (JPNXFI)
      INTEGER NREESP (JPNXFI), NREECO (JPNXFI), NREELO (JPNXFI)
      INTEGER NIVMES (0:JPNXFI), NDEROP (JPNXFI), NPPIMM (JPNXFI)
      INTEGER NUMAPD (0:JPNPDF-1,JPNXFI), NLONPD (0:JPNPDF-1,JPNXFI)
      INTEGER NTRULZ (JPNXFI), NRFPTZ (JPNXFI), NRFDTZ (JPNXFI)
      INTEGER NBTROU (JPNXFI), NUMIND (JPNXFI), NBREAD (JPNXFI)
      INTEGER NBWRIT (JPNXFI), NBMOLU (JPNXFI), NBMOEC (JPNXFI)
      INTEGER NDERGF (JPNXFI), NSUIVF (JPNXFI), NPRECF (JPNXFI)
      INTEGER NBRENO (JPNXFI), NBSUPP (JPNXFI), MFACTM (0:JPNXFI)
      INTEGER MULOFM (JPXUFM), MFACTU (0:JPXUFM)
      INTEGER NIMPEX (JPIMEX), NUTRAV (JPIMEX), NBMOSD (0:JPCFMX)
      INTEGER NBCASD (0:JPCFMX), NLAPFD (JPIMEX)
      INTEGER MNUIEX (JPIMEX), NINIEX (JPIMEX), NDEXPL (JPDEXP,JPIMEX)
      INTEGER NDIMPL (JPDIMP,JPIMEX), NXCNLD (JPIMEX), NAEXPL (JPIMEX)
      INTEGER NEXPOR (JPNXFI), NIMPOR (JPNXFI), NUIMEX, NRCFMX (JPIMEX)
      INTEGER NREXPL (0:JPXDAM,JPIMEX)
C
      REAL VERRUE (JPNXFI), VERGLA
C
      LOGICAL LLFATA, LMULTI, LTAMLG, LTAMEG, LECRPI (JPNXPI,2)
      LOGICAL LTAMPL (JPNXFI), LTAMPE (JPNXFI), LMODIF (JPNXFI)
      LOGICAL LNOUFI (JPNXFI), LERFAT (0:JPNXFI), LISTAT (JPNXFI)
      LOGICAL LPHASP (JPNXPI), LECRPD (0:JPNPDF-1,JPNXFI)
      LOGICAL LMIMAL (JPNXFI)
C
      COMMON /LFIDIV/ NBFIOU, NIMESG, NERFAG, NISTAG, NPISAF, LMULTI
     S              , VERGLA, LTAMLG, LTAMEG, MRGPIM, MRGPIF, NUMIND
     S              , VERRUE, MLGPOS, MDES1D, MCOPIF, LECRPI, LPHASP
     S              , NUMERO, NLNOMF, LNOUFI, NDERCO, MTAMPD, NUMAPD
     S              , NPODPI, NALDPI, NBLECT, NBNECR, NREESP, NREECO
     S              , NREELO, NIVMES, LERFAT, LISTAT, NDEROP, LMODIF
     S              , NPPIMM, NRFPTZ, NRFDTZ, NTRULZ, NBREAD, NBWRIT
     S              , LECRPD, NLONPD, NDERPD, NBTROU, NBMOLU, NBMOEC
     S              , LTAMPL, LTAMPE, NDERGF, NSUIVF, NBRENO, NBSUPP
     S              , LMIMAL, NPRECF, MFACTM, NULOFM, MULOFM, MFACTU
     S              , NLNOMS, NFACTM, NUMAPH, NEXPOR, NIMPOR, NIMPEX
     S              , NUTRAV, NBMOSD, NBCASD, NLAPFD, NXCNLD, NUIMEX
     S              , MNUIEX, NINIEX, NDEXPL, NREXPL, NDIMPL, NAEXPL
     S              , NRCFMX
C
