      SUBROUTINE LFIECR ( KREP, KNUMER, CDNOMA, KTAB, KLONG )
#include "lficomt.h"
C****
C        SOUS-PROGRAMME D'ECRITURE D'UN ARTICLE (DE DONNEES) SUR UNE
C     UNITE LOGIQUE OUVERTE POUR LE LOGICIEL DE FICHIERS INDEXES LFI;
C     L'ARTICLE DOIT ETRE UN "BLOC" DE DONNEES ADJACENTES.
C**
C    ARGUMENTS : KREP   (SORTIE) ==> CODE-REPONSE DU SOUS-PROGRAMME;
C                KNUMER (ENTREE) ==> NUMERO DE L'UNITE LOGIQUE;
C                CDNOMA (ENTREE) ==> NOM DE L'ARTICLE A ECRIRE;
C                KTAB   (ENTREE) ==> PREMIER MOT A ECRIRE
C                KLONG  (ENTREE) ==> LONGUEUR DE L'ARTICLE A ECRIRE.
C
#include "lficom0.h"
#ifndef f77
#include "precision.h"
#endif
#include "lficom1.h"
C
      CHARACTER CDNOMA*(*), CLNOMA*(JPNCPN)
C
      INTEGER KREP, KNUMER, KLONG
#ifndef f77
      INTEGER (KIND=JPDBLE)  KTAB (KLONG)
#else
      INTEGER KTAB (KLONG)
#endif
      INTEGER IRANG, IREP, ILCLNO, IDECBL, IPOSBL, INBALO, INBPIR
      INTEGER IFACTM, ILARPH, INALPP, IRPIEX, IARTEX, ILONEX, IRPIEC
      INTEGER IARTEC, IPOSEC, IDTROU, ILONUT, INPPIM, IRETIN, IRGPI, J
      INTEGER IRGPIM, ILFORC, INPILE, INAPHY, IRANGM, INAPXX, INDMAX
      INTEGER IMDESC, INIMES, ILCDNO
C
      LOGICAL LLLECT, LLECR, LLVERF
C
#include "lficom2.h"
C**
C     1.  -  CONTROLES DES PARAMETRES D'APPEL, PUIS INITIALISATIONS.
C-----------------------------------------------------------------------
C
C        Appel legerement anticipe a LFINUM, garantissant l'initialisa-
C     tion des variables globales du logiciel a la 1ere utilisation.
C
      CALL LFINUM (KNUMER,IRANG)
      LLVERF=.FALSE.
      ILCDNO=LEN (CDNOMA)
C
      IF (ILCDNO.LE.0) THEN
        IREP=-15
        CLNOMA=CHINCO(:JPNCPN)
        ILCLNO=JPNCPN
        GOTO 1001
      ELSEIF (CDNOMA.EQ.' ') THEN
        IREP=-18
        CLNOMA=' '
        ILCLNO=1
        GOTO 1001
      ENDIF
C
C        Recherche de la longueur "utile" du nom d'article specifie.
C        (c'est-a-dire sans tenir compte des blancs terminaux eventuels)
C
      IDECBL=0
C
  101 CONTINUE
      IPOSBL=IDECBL+INDEX (CDNOMA(IDECBL+1:),' ')
C
      IF (IPOSBL.LE.IDECBL) THEN
        ILCLNO=ILCDNO
      ELSEIF (CDNOMA(IPOSBL:).EQ.' ') THEN
        ILCLNO=IPOSBL-1
      ELSE
        IDECBL=IPOSBL
        GOTO 101
      ENDIF
C
      IF (ILCLNO.LE.JPNCPN) THEN
        CLNOMA=CDNOMA(:ILCLNO)
      ELSE
        CLNOMA=CDNOMA(:JPNCPN)
        ILCLNO=JPNCPN
        IREP=-15
        GOTO 1001
      ENDIF
C
      IF (KLONG.LE.0) THEN
        IREP=-14
        GOTO 1001
      ELSEIF (IRANG.EQ.0) THEN
        IREP=-1
        GOTO 1001
      ENDIF
C
       IF (LMULTI) CALL LFIVER (VERRUE(IRANG),'ON')
      LLVERF=LMULTI
C
      IF (NEXPOR(IRANG).GT.0) THEN
C
C         Fichier en cours d'export... ne devant donc pas etre modifie.
C
        IREP=-37
        GOTO 1001
      ENDIF
C
      LLLECT=.TRUE.
      LLECR =.FALSE.
      INBALO=MDES1D(IXM(JPNALO,IRANG))
      INBPIR=MDES1D(IXM(JPNPIR,IRANG))
      IFACTM=MFACTM(IRANG)
      ILARPH=JPLARD*IFACTM
      INALPP=JPNAPP*IFACTM
C**
C     2.  -  EXPLORATION DES (PAIRES DE) PAGES ET ARTICLES D'INDEX,
C            A LA RECHERCHE DE L'ARTICLE LOGIQUE ET/OU D'UN "TROU"
C            DANS L'INDEX, SUFFISANT POUR Y "CASER" LEDIT ARTICLE.
C-----------------------------------------------------------------------
C
      INAPHY=0
      CALL LFIREE (IREP,IRANG,CLNOMA(:ILCLNO),KLONG,IRPIEX,IARTEX,
     S             ILONEX,IRPIEC,IARTEC,IPOSEC,IDTROU,ILONUT,IRETIN)
C
      IF (IRETIN.EQ.1) THEN
        GOTO 903
      ELSEIF (IRETIN.EQ.2) THEN
        GOTO 904
      ELSEIF (IRETIN.NE.0) THEN
        GOTO 1001
      ENDIF
C
      INPPIM=NPPIMM(IRANG)
C
      IF (IARTEX.NE.0.AND.NEXPOR(IRANG).GT.0) THEN
C
C         Fichier en cours d'export... la seule modification acceptee
C         est l'ajout de nouveaux articles.
C
        IREP=-37
        GOTO 1001
      ENDIF
C**
C     3.  -   PARTIE ECRITURE DES DONNEES .
C-----------------------------------------------------------------------
C
      CALL LFIECD (IREP,IRANG,KTAB,KLONG,IPOSEC,IRETIN)
C
      IF (IRETIN.EQ.1) THEN
        GOTO 903
      ELSEIF (IRETIN.EQ.2) THEN
        GOTO 904
      ELSEIF (IRETIN.NE.0) THEN
        GOTO 1001
      ENDIF
C**
C     4.  -   MODIFICATION(S) EVENTUELLE(S) DE L'INDEX.
C-----------------------------------------------------------------------
C
      IF (IARTEX.NE.0.AND.IARTEC.NE.IARTEX) THEN
C*
C     4.1 - CAS OU L'ON CREE UN TROU DANS L'INDEX.
C-----------------------------------------------------------------------
C
C           RECHERCHE OU MISE EN MEMOIRE DE L'ARTICLE D'INDEX "NOMS"
C        CONTENANT LES CARACTERISTIQUES DE L'ARTICLE LOGIQUE
C        QUE L'ON "TROUE".
C
        DO 411 J=1,INPPIM
        IRGPI=MRGPIM(J,IRANG)
C
        IF (MRGPIF(IRGPI).EQ.IRPIEX) THEN
          IRGPIM=IRGPI
          GOTO 413
        ENDIF
C
  411   CONTINUE
C
        ILFORC=1
        INPILE=1
        INAPHY=0
        CALL LFIPIM (IREP,IRANG,IRANGM,IRGPIM,IRPIEX,ILFORC,INPILE,
     S               IRETIN)
C
        IF (IRETIN.EQ.1) THEN
          GOTO 903
        ELSEIF (IRETIN.EQ.2) THEN
          GOTO 904
        ELSEIF (IRETIN.NE.0) THEN
          GOTO 1001
        ENDIF
C
        INPPIM=MAX0 (INPPIM,IRANGM)
C
  413   CONTINUE
        CNOMAR(IXC(IARTEX,IRGPIM))=' '
        LECRPI(IRGPIM,1)=.TRUE.
C
        IF (ILONEX.NE.ILONUT) THEN
C
C           STOCKAGE DE LA LONGUEUR TOTALE UTILISABLE DU TROU .
C         DANS CE CAS, ON EST SUR QUE LA PAGE D'INDEX "LONG./POS."
C         EST TOUJOURS PHASEE.
C
          MLGPOS(IXM(2*IARTEX-1,IRGPIM))=ILONUT
          LECRPI(IRGPIM,2)=.TRUE.
        ENDIF
C
      ENDIF
C
      IF (INALPP*(IRPIEC-1)+IARTEC.GT.INBALO) THEN
C*
C     4.2 - CAS OU L'ON A CREE UN ARTICLE LOGIQUE SUPPLEMENTAIRE.
C-----------------------------------------------------------------------
C
        MDES1D(IXM(JPNALO,IRANG))=INBALO+1
C
        IF (INBALO.NE.0.AND.IARTEC.EQ.1) THEN
C
C             ON DOIT CREER UNE P.A.I. SUPPLEMENTAIRE.
C
          IF (IRPIEC.GT.INBPIR) THEN
C
C             CETTE NOUVELLE P.A.I. EST "EXCEDENTAIRE".
C             RECHERCHE DU PREMIER ARTICLE PHYSIQUE DISPONIBLE
C             POUR Y ECRIRE (ULTERIEUREMENT) CETTE P.A.I. EXCEDENTAIRE.
C             LE CONTROLE DE DEPASSEMENT DE CAPACITE DE L'INDEX
C             DU FICHIER A ETE FAIT DANS LE SOUS-PROGRAMME *LFIREE*.
C
            INAPXX=MDES1D(IXM(JPAXPD,IRANG))
            INDMAX=JPNIL
C
            DO 421 J=0,JPNPDF-1
C
            IF (NUMAPD(J,IRANG).GT.INAPXX) THEN
              INAPXX=NUMAPD(J,IRANG)
              INDMAX=J
            ENDIF
C
  421       CONTINUE
C
            IF (IRPIEC.GT.(INBPIR+1)) THEN
              IMDESC=MDES1D(IXM(ILARPH+2-IRPIEC+INBPIR,IRANG))
              INAPXX=MAX0 (INAPXX,IMDESC+1)
            ENDIF
C
            MDES1D(IXM(ILARPH+1-IRPIEC+INBPIR,IRANG))=INAPXX+1
C
C      L'ON A AUSSI CREE, EN GENERAL, UNE ZONE "PERDUE" (MAIS NEANMOINS
C     REUTILISABLE DANS UNE CERTAINE MESURE) A LA FIN DU DERNIER
C     ARTICLE PHYSIQUE DES DONNEES QUE L'ON VIENT D'ECRIRE.
C           IL EST ALORS NECESSAIRE DE "COMPLETER" LA ZONE PERDUE,
C     POUR NE PAS AVOIR DE PROBLEME ULTERIEUR DANS *LFIECX*.
C
            IF (INDMAX.NE.JPNIL) THEN
C
              DO 423 J=NLONPD(INDMAX,IRANG)+1,ILARPH
              MTAMPD(IXT(J,INDMAX,IRANG))=0
  423         CONTINUE
C
              NLONPD(INDMAX,IRANG)=ILARPH
            ENDIF
C
          ENDIF
C
          ILFORC=1
          INPILE=0
          INAPHY=0
          CALL LFIPIM (IREP,IRANG,IRANGM,IRGPIM,IRPIEC,ILFORC,INPILE,
     S                 IRETIN)
C
          IF (IRETIN.EQ.1) THEN
            GOTO 903
          ELSEIF (IRETIN.EQ.2) THEN
            GOTO 904
          ELSEIF (IRETIN.NE.0) THEN
            GOTO 1001
          ENDIF
C
          NPODPI(IRANG)=IRANGM
C
C           REMARQUE: LA DERNIERE P.P.I. EST TOUJOURS "PHASEE".
C
          LPHASP(IRGPIM)=.TRUE.
        ELSE
          IRGPIM=MRGPIM(NPODPI(IRANG),IRANG)
        ENDIF
C
        NALDPI(IRANG)=IARTEC
        CNOMAR(IXC(IARTEC,IRGPIM))=CLNOMA(:ILCLNO)
        MLGPOS(IXM(2*IARTEC-1,IRGPIM))=KLONG
        MLGPOS(IXM(2*IARTEC  ,IRGPIM))=IPOSEC
        LECRPI(IRGPIM,1)=.TRUE.
        LECRPI(IRGPIM,2)=.TRUE.
C
      ELSEIF (IARTEX.EQ.0.OR.KLONG.NE.ILONEX) THEN
C*
C     4.3 - CAS OU L'ON REUTILISE UN ARTICLE OU TROU QUI EXISTAIT
C           AU PREALABLE, EN MODIFIANT SES CARACTERISTIQUES DE NOM ET/OU
C           DE LONGUEUR.
C-----------------------------------------------------------------------
C
        DO 431 J=1,INPPIM
        IRGPI=MRGPIM(J,IRANG)
C
        IF (MRGPIF(IRGPI).EQ.IRPIEC) THEN
          IRANGM=J
          IRGPIM=IRGPI
C
C           L'ARTICLE D'INDEX "NOMS" CORRESPONDANT EST EN MEMOIRE...
C       PHASAGE EVENTUEL DE LA PAGE D'INDEX "LONG/POS" .
C
          INAPHY=0
C
          IF (.NOT.LPHASP(IRGPIM)) THEN
C
            CALL LFIPHA (IREP,IRANG,IRGPIM,IRETIN)
C
            IF (IRETIN.EQ.1) THEN
              GOTO 903
            ELSEIF (IRETIN.EQ.2) THEN
              GOTO 904
            ELSEIF (IRETIN.NE.0) THEN
              GOTO 1001
            ENDIF
C
          ENDIF
C
          GOTO 434
        ENDIF
C
  431   CONTINUE
C
C            ARTICLE D'INDEX CORRESPONDANT NON PRESENT EN MEMOIRE...
C         ON L'Y AMENE.
C
        ILFORC=1
        INPILE=2
        INAPHY=0
        CALL LFIPIM (IREP,IRANG,IRANGM,IRGPIM,IRPIEC,ILFORC,INPILE,
     S               IRETIN)
C
        IF (IRETIN.EQ.1) THEN
          GOTO 903
        ELSEIF (IRETIN.EQ.2) THEN
          GOTO 904
        ELSEIF (IRETIN.NE.0) THEN
          GOTO 1001
        ENDIF
C
  434   CONTINUE
C
        IF (IARTEC.NE.IARTEX.OR.IRPIEC.NE.IRPIEX) THEN
          CNOMAR(IXC(IARTEC,IRGPIM))=CLNOMA(:ILCLNO)
          LECRPI(IRGPIM,1)=.TRUE.
        ENDIF
C
        MLGPOS(IXM(2*IARTEC-1,IRGPIM))=KLONG
        LECRPI(IRGPIM,2)=.TRUE.
C
      ENDIF
C**
C     5.  -   MISE A JOUR: STATISTIQUES, TABLES, PAGE DOCUMENTAIRE.
C-----------------------------------------------------------------------
C
      IF (IARTEX.EQ.0) THEN
        NBNECR(IRANG)=NBNECR(IRANG)+1
      ELSEIF (KLONG.EQ.ILONEX) THEN
        NREESP(IRANG)=NREESP(IRANG)+1
      ELSEIF (KLONG.LT.ILONEX) THEN
        NREECO(IRANG)=NREECO(IRANG)+1
        LMIMAL(IRANG)=LMIMAL(IRANG).OR.
     S                ILONEX.EQ.MDES1D(IXM(JPLXAL,IRANG))
      ELSE
        NREELO(IRANG)=NREELO(IRANG)+1
        LMIMAL(IRANG)=LMIMAL(IRANG).OR.
     S                ILONEX.EQ.MDES1D(IXM(JPLNAL,IRANG))
      ENDIF
C
      NBTROU(IRANG)=NBTROU(IRANG)+IDTROU
      IF (LMISOP) PRINT *,
     S        'IDTROU = ',IDTROU,', ILONEX = ',ILONEX,', KLONG = ',KLONG
C
C        On met a jour ce qui a trait aux acces pseudo-sequentiels...
C
      NDERGF(IRANG)=INALPP*(IRPIEC-1)+IARTEC
      CNDERA(IRANG)=CLNOMA(:ILCLNO)
      NSUIVF(IRANG)=JPNIL
      NPRECF(IRANG)=JPNIL
C
      IMDESC=MDES1D(IXM(JPLNAL,IRANG))
      MDES1D(IXM(JPLNAL,IRANG))=MIN0 (IMDESC,KLONG)
      IMDESC=MDES1D(IXM(JPLXAL,IRANG))
      MDES1D(IXM(JPLXAL,IRANG))=MAX0 (IMDESC,KLONG)
      MDES1D(IXM(JPLTAL,IRANG))=MDES1D(IXM(JPLTAL,IRANG))+KLONG-ILONEX
      IF (INBALO.EQ.0) MDES1D(IXM(JPLNAL,IRANG))=KLONG
C
      IF (.NOT.LMODIF(IRANG)) THEN
C
C         CAS DE LA PREMIERE ECRITURE DEPUIS L'OUVERTURE DU FICHIER.
C
        LMODIF(IRANG)=.TRUE.
        INAPHY=0
        CALL LFIMOD (IREP,IRANG,IRETIN)
C
        IF (IRETIN.EQ.1) THEN
          GOTO 903
        ELSEIF (IRETIN.EQ.2) THEN
          GOTO 904
        ELSEIF (IRETIN.NE.0) THEN
          GOTO 1001
        ENDIF
C
      ENDIF
C
      IREP=0
      NBMOEC(IRANG)=NBMOEC(IRANG)+KLONG
      GOTO 1001
C**
C     9.  - CI-DESSOUS, ETIQUETTES DE BRANCHEMENT EN CAS D'ERREUR E/S.
C-----------------------------------------------------------------------
C
  903 CONTINUE
      CLACTI='WRITE'
      GOTO 909
C
  904 CONTINUE
      CLACTI='READ'
C
  909 CONTINUE
C
C      AU CAS OU, ON FORCE LE CODE-REPONSE ENTREE/SORTIE A ETRE POSITIF.
C
      IREP=IABS (IREP)
      IF (INAPHY.NE.0) NUMAPH(IRANG)=INAPHY
C**
C    10.  -  PHASE TERMINALE : MESSAGERIE, AVEC "ABORT" EVENTUEL,
C            VIA LE SOUS-PROGRAMME "LFIEMS" .
C-----------------------------------------------------------------------
C
 1001 CONTINUE
      KREP=IREP
      LLFATA=LLMOER (IREP,IRANG)
C
      IF (IRANG.NE.0) THEN
        NDEROP(IRANG)=1
        NDERCO(IRANG)=IREP
         IF (LLVERF) CALL LFIVER (VERRUE(IRANG),'OFF')
      ENDIF
C
      IF (LLFATA.OR.IXNIMS (IRANG).EQ.2) THEN
        INIMES=2
      ELSE
        RETURN
      ENDIF
C
      CLNSPR='LFIECR'
      WRITE (UNIT=CLMESS,FMT='(''KREP='',I4,'', KNUMER='',I3,
     S       '', CDNOMA='''''',A,'''''', KLONG='',I7)')
     S     KREP,KNUMER,CLNOMA(:ILCLNO),KLONG
      CALL LFIEMS (KNUMER,INIMES,IREP,LLFATA,CLMESS,CLNSPR,CLACTI)
C
      RETURN
      END
