      SUBROUTINE LFIFER ( KREP, KNUMER, CDSTTC )
#include "lficomt.h"
C****
C        SOUS-PROGRAMME DE FERMETURE D'UN FICHIER INDEXE AU SENS DU
C     LOGICIEL DE FICHIERS INDEXES LFI.
C        CETTE FERMETURE EST VITALE SI LE FICHIER A ETE MODIFIE DEPUIS
C     LA DERNIERE OUVERTURE, ET EST DE TOUTE MANIERE CHAUDEMENT
C     RECOMMANDEE AVANT DE SORTIR DU PROGRAMME UTILISATEUR.
C
C        De maniere generale, il vaut mieux fermer une unite logique
C     des que l'on n'en a plus besoin, de maniere a ne pas bloquer un
C     espace dans les tables qui pourrait faire defaut lors d'une
C     ouverture ulterieure, particulierement pour un fichier "multiple"
C     qui a besoin d'espace CONTIGU dans les tables des unites logiques.
C     Par ailleurs, tout fichier ouvert (au sens FORTRAN du terme cette
C     fois) "occupe" generalement un morceau de la memoire du programme.
C**
C    ARGUMENTS : KREP   (SORTIE) ==> CODE-REPONSE DU SOUS-PROGRAMME;
C                KNUMER (ENTREE) ==> NUMERO DE L'UNITE LOGIQUE;
C                CDSTTC (ENTREE) ==> "STATUS" EVENTUEL POUR "CLOSE".
C
C    Modifications:
C
C    02/06/97, Jean Clochard.
C
C              -Modification des impressions pour que l'annee puisse
C               etre imprimee avec 4 chiffres.
C
#include "lficom0.h"
#ifndef f77
#include "precision.h"
#endif
#include "lficom1.h"
C
      CHARACTER CDSTTC*(*), CLSTTC*(JPLSTX), CLAUXI*3
C
#ifndef f77
      INTEGER (KIND=JPDBLE) ITAMPO (JPLARX)
#else
      INTEGER ITAMPO (JPLARX)
#endif
      INTEGER KREP, KNUMER, IEXPLO (JPNPIA+JPNPIS)
      INTEGER ILSTTU, IREPX, INAPHY, IRANG, IREP, ILSTTC, IREC, INPPIM
      INTEGER IFACTM, ILARPH, INALPP, INBALO, INTPPI, INTRLZ, IDECAL, J
      INTEGER IPOTZC, IRGPFC, IRGPMC, ILFORC, INPILE, INIMES, IPOTZS, JJ
      INTEGER IRGPFS, IPOTZE, IRGPMS, INTCON, IPOSFE, JNPAGE, IRGPFE, JR
      INTEGER IRGPME, IRANGM, IDECDB, INBARE, IRGPC2, IRGPS2, IDECDC
      INTEGER INBARC, IDECDS, INBARS, INBART, INTPPN, ILOMIN, ILOMAX
      INTEGER IRPIFN, INPIME, IDEBEX, IRGPIM, IRGPIF, INLNOM, IDEBUT
      INTEGER ILONGA, INALDO, IPOSNU, IRANIE, IRETIN, IAUXIL
C
      LOGICAL LLSTTU, LLVERF, LLVERG, LLECRD, LLIMST
C
#include "lficom2.h"
C**
C     1.  -  CONTROLES DES PARAMETRES D'APPEL, PUIS INITIALISATIONS.
C-----------------------------------------------------------------------
C
      IF (LMISOP) PRINT *,'DEBUT LFIFER'
      CLNSPR='LFIFER'
      ILSTTU=MIN0 (LEN (CLSTTC), LEN (CDSTTC))
      CLSTTC=CDSTTC(:ILSTTU)
      IREPX=0
      INAPHY=0
      LLVERF=.FALSE.
      LLVERG=.FALSE.
      CALL LFINUM (KNUMER,IRANG)
C
      IF (IRANG.EQ.0) THEN
        IREP=-1
        GOTO 1001
      ENDIF
C
       IF (LMULTI) CALL LFIVER (VERRUE(IRANG),'ON')
      LLVERF=LMULTI
C
      IF (CDSTTC.EQ.'KEEP'.AND.CSTAOP(IRANG).EQ.'SCRATCH') THEN
        IREP=-19
        LLFATA=LLMOER (IREP,IRANG)
C
        IF (LLFATA) THEN
          GOTO 1001
        ELSE
C
C        SI L'ERREUR (-19) N'EST PAS FATALE, ON FERME L'UNITE LOGIQUE,
C       MAIS SANS PRECISER DE DIRECTIVE "STATUS" DANS LE "CLOSE".
C
          LLSTTU=.FALSE.
          GOTO 105
        ENDIF
C
      ELSE
        LLSTTU=CDSTTC.EQ.'KEEP'.OR.CDSTTC.EQ.'DELETE'
C
        IF (LLSTTU) THEN
          ILSTTC=INDEX (CDSTTC,' ')-1
          IF (ILSTTC.GT.0) ILSTTU=ILSTTC
          CLSTTC=CDSTTC(:ILSTTU)
        ELSE
          CLSTTC=CHINCO(:ILSTTU)
        ENDIF
C
      ENDIF
C
      IREP=0
C
  105 CONTINUE
      IREPX=IREP
      INPPIM=NPPIMM(IRANG)
      IFACTM=MFACTM(IRANG)
      ILARPH=JPLARD*IFACTM
      INALPP=JPNAPP*IFACTM
      INBALO=MDES1D(IXM(JPNALO,IRANG))
      INTPPI=(INBALO-1+INALPP)/INALPP
C**
C     2.  -  TRAITEMENT D'EVENTUELS "TROUS" D'INDEX DE LONGUEUR ZERO.
C            CES "PARASITES" PEUVENT AVOIR ETE CREES PAR LE RECYCLAGE
C            DE TROUS DANS LE FICHIER; ON VA LES SUPPRIMER.
C
C         L'ALGORITHME CHOISI N'EST PEUT-ETRE PAS LE PLUS EFFICACE;
C     MAIS A PARTIR DU MOMENT OU LA PROBABILITE DE GENERER DES TROUS
C     DE LONGUEUR NULLE EST FAIBLE, ET OU ON NE LES RETASSE
C     QU'A LA FERMETURE, IL N'Y A PAS LIEU DE RAFFINER A OUTRANCE !
C-----------------------------------------------------------------------
C
      INTRLZ=NTRULZ(IRANG)
      IF (INTRLZ.EQ.0) GOTO 300
C
      IDECAL=0
      IPOTZC=NRFPTZ(IRANG)
      IRGPFC=1+(IPOTZC-1)/INALPP
C*
C     2.1 - MISE EN MEMOIRE DE LA PREMIERE P.A.I. AYANT UN TEL TROU.
C-----------------------------------------------------------------------
C
      DO 211 J=1,INPPIM
      IRGPMC=MRGPIM(J,IRANG)
C
      IF (MRGPIF(IRGPMC).EQ.IRGPFC) THEN
C
      IF (.NOT.LPHASP(IRGPMC)) THEN
C
        CALL LFIPHA (IREP,IRANG,IRGPMC,IRETIN)
C
          IF (IRETIN.EQ.1) THEN
            GOTO 903
          ELSEIF (IRETIN.EQ.2) THEN
            GOTO 904
          ELSEIF (IRETIN.NE.0) THEN
            GOTO 1001
          ENDIF
C
        ENDIF
C
        GOTO 220
C
      ENDIF
C
  211 CONTINUE
C
      ILFORC=IRGPFC+1
      INPILE=2
      CALL LFIPIM (IREP,IRANG,IRANGM,IRGPMC,IRGPFC,ILFORC,INPILE,IRETIN)
C
      IF (IRETIN.EQ.1) THEN
        GOTO 903
      ELSEIF (IRETIN.EQ.2) THEN
        GOTO 904
      ELSEIF (IRETIN.NE.0) THEN
        GOTO 1001
      ENDIF
C
      INPPIM=MAX0 (INPPIM,IRANGM)
C
  220 CONTINUE
C*
C     2.2 - AMORCAGE DE LA RECHERCHE DU NOMBRE DE TROUS NULS CONSECUTIFS
C           ET DE L'EVENTUEL TROU NUL "SUIVANT" CE PAQUET.
C-----------------------------------------------------------------------
C
      IPOTZS=IPOTZC+IDECAL
      IRGPFS=1+(IPOTZS-1)/INALPP
      IPOTZE=IPOTZS
      IRGPMS=0
C
C       ON ELIMINE LES CAS "TRIVIAUX"
C
      IF (INTRLZ.EQ.1.OR.IPOTZE+INTRLZ.GT.INBALO) THEN
        INTCON=INTRLZ
        IPOSFE=INBALO
        GOTO 250
      ENDIF
C*
C     2.3 - DECOMPTE DU NOMBRE DE TROUS NULS CONSECUTIFS.
C-----------------------------------------------------------------------
C
      DO 235 JNPAGE=IRGPFS,INTPPI
      IRGPFE=JNPAGE
C
      DO 231 J=1,INPPIM
      IRGPME=MRGPIM(J,IRANG)
C
      IF (MRGPIF(IRGPME).EQ.IRGPFE) THEN
C
        IF (.NOT.LPHASP(IRGPME)) THEN
C
          CALL LFIPHA (IREP,IRANG,IRGPME,IRETIN)
C
          IF (IRETIN.EQ.1) THEN
            GOTO 903
          ELSEIF (IRETIN.EQ.2) THEN
            GOTO 904
          ELSEIF (IRETIN.NE.0) THEN
            GOTO 1001
          ENDIF
C
        ENDIF
C
        GOTO 233
C
      ENDIF
C
  231 CONTINUE
C
      INPILE=2
      CALL LFIPIM (IREP,IRANG,IRANGM,IRGPME,IRGPFE,IRGPFC,INPILE,IRETIN)
C
      IF (IRETIN.EQ.1) THEN
        GOTO 903
      ELSEIF (IRETIN.EQ.2) THEN
        GOTO 904
      ELSEIF (IRETIN.NE.0) THEN
        GOTO 1001
      ENDIF
C
      INPPIM=MAX0 (INPPIM,IRANGM)
C
  233 CONTINUE
      IF (IRGPMS.EQ.0) IRGPMS=IRGPME
      IDECDB=IPOTZE-1-(IRGPFE-1)*INALPP
      INBARE=MIN0 (INBALO,IRGPFE*INALPP)-IPOTZE+1
      INTCON=0
C
      DO 234 J=1,INBARE
C
      IF (MLGPOS(IXM(2*(J+IDECDB)-1,IRGPME)).NE.0) THEN
        INTCON=INTCON+J-1
        GOTO 240
      ENDIF
C
  234 CONTINUE
C
      INTCON=INTCON+INBARE
      IPOTZE=IPOTZE+INBARE
  235 CONTINUE
C*
C     2.4 - RECHERCHE DU PROCHAIN TROU NUL, APRES LE PAQUET TROUVE.
C-----------------------------------------------------------------------
C
  240 CONTINUE
      IPOTZE=IPOTZE+INTCON
C
C             D'ABORD, ELIMINATION DES CAS "TRIVIAUX"
C
      IF (INTCON.EQ.INTRLZ) THEN
C
C        ON A TROUVE TOUS LES TROUS NULS RESTANT.
C
        IPOSFE=INBALO
      ELSEIF (INTCON.EQ.(INTRLZ-1)) THEN
C
C        PLUS QU'UN SEUL TROU NUL... CE SERA DONC CELUI DE RANG MAXIMUM.
C
        IPOSFE=NRFDTZ(IRANG)-1
      ELSE
C
C          CAS GENERAL.
C
        DO 245 JNPAGE=IRGPFE,INTPPI
C
        IF (JNPAGE.NE.IRGPFE) THEN
C
          DO 241 J=1,INPPIM
          IRGPME=MRGPIM(J,IRANG)
C
          IF (MRGPIF(IRGPME).EQ.JNPAGE) THEN
C
            IF (.NOT.LPHASP(IRGPME)) THEN
C
              CALL LFIPHA (IREP,IRANG,IRGPME,IRETIN)
C
              IF (IRETIN.EQ.1) THEN
                GOTO 903
              ELSEIF (IRETIN.EQ.2) THEN
                GOTO 904
              ELSEIF (IRETIN.NE.0) THEN
                GOTO 1001
              ENDIF
C
            ENDIF
C
            GOTO 243
C
          ENDIF
C
  241     CONTINUE
C
          INPILE=2
          CALL LFIPIM (IREP,IRANG,IRANGM,IRGPME,JNPAGE,IRGPFC,INPILE,
     S                 IRETIN)
C
          IF (IRETIN.EQ.1) THEN
            GOTO 903
          ELSEIF (IRETIN.EQ.2) THEN
            GOTO 904
          ELSEIF (IRETIN.NE.0) THEN
            GOTO 1001
          ENDIF
C
          INPPIM=MAX0 (INPPIM,IRANGM)
        ENDIF
C
  243   CONTINUE
        IDECDB=IPOTZE-1-(JNPAGE-1)*INALPP
        INBARE=MIN0 (INBALO,JNPAGE*INALPP)-IPOTZE+1
C
        DO 244 J=1,INBARE
C
        IF (MLGPOS(IXM(2*(J+IDECDB)-1,IRGPME)).EQ.0) THEN
          IPOSFE=(JNPAGE-1)*INALPP+J-1
          GOTO 250
        ENDIF
C
  244   CONTINUE
C
  245   CONTINUE
C
      ENDIF
C
  250 CONTINUE
C*
C     2.5 - RETASSAGE "A GAUCHE" D'UNE PARTIE DE L'INDEX.
C-----------------------------------------------------------------------
C
      IDECAL=IDECAL+INTCON
C
  251 CONTINUE
      IPOTZS=IPOTZC+IDECAL
      IRGPC2=1+(IPOTZC-1)/INALPP
      IRGPS2=1+(IPOTZS-1)/INALPP
C
      IF (IRGPC2.NE.IRGPFC) THEN
        IRGPFC=IRGPC2
C
        DO 252 J=2,INPPIM
        IRGPMC=MRGPIM(J,IRANG)
C
        IF (MRGPIF(IRGPMC).EQ.IRGPFC) THEN
C
          IF (.NOT.LPHASP(IRGPMC)) THEN
C
            CALL LFIPHA (IREP,IRANG,IRGPMC,IRETIN)
C
            IF (IRETIN.EQ.1) THEN
              GOTO 903
            ELSEIF (IRETIN.EQ.2) THEN
              GOTO 904
            ELSEIF (IRETIN.NE.0) THEN
              GOTO 1001
            ENDIF
C
          ENDIF
C
          GOTO 254
C
        ENDIF
C
  252   CONTINUE
C
        INPILE=2
        CALL LFIPIM (IREP,IRANG,IRANGM,IRGPMC,IRGPFC,IRGPS2,INPILE,
     S               IRETIN)
C
        IF (IRETIN.EQ.1) THEN
          GOTO 903
        ELSEIF (IRETIN.EQ.2) THEN
          GOTO 904
        ELSEIF (IRETIN.NE.0) THEN
          GOTO 1001
        ENDIF
C
        INPPIM=MAX0 (INPPIM,IRANGM)
      ENDIF
C
  254 CONTINUE
C
      IF (IRGPS2.NE.IRGPFS) THEN
        IRGPFS=IRGPS2
C
        DO 255 J=2,INPPIM
        IRGPMS=MRGPIM(J,IRANG)
C
        IF (MRGPIF(IRGPMS).EQ.IRGPFS) THEN
C
          IF (.NOT.LPHASP(IRGPMS)) THEN
C
            CALL LFIPHA (IREP,IRANG,IRGPMS,IRETIN)
C
            IF (IRETIN.EQ.1) THEN
              GOTO 903
            ELSEIF (IRETIN.EQ.2) THEN
              GOTO 904
            ELSEIF (IRETIN.NE.0) THEN
              GOTO 1001
            ENDIF
C
          ENDIF
C
          GOTO 257
C
        ENDIF
C
  255   CONTINUE
C
        INPILE=2
        CALL LFIPIM (IREP,IRANG,IRANGM,IRGPMS,IRGPFS,IRGPFC,INPILE,
     S               IRETIN)
C
        IF (IRETIN.EQ.1) THEN
          GOTO 903
        ELSEIF (IRETIN.EQ.2) THEN
          GOTO 904
        ELSEIF (IRETIN.NE.0) THEN
          GOTO 1001
        ENDIF
C
        INPPIM=MAX0 (INPPIM,IRANGM)
      ENDIF
C
  257 CONTINUE
      IDECDC=IPOTZC-1+(IRGPFC-1)/INALPP
      INBARC=MIN0 (INBALO-IDECAL,IRGPFC*INALPP)-IPOTZC+1
      IDECDS=IPOTZS-1+(IRGPFS-1)/INALPP
      INBARS=MIN0 (INBALO,IRGPFS*INALPP)-IPOTZS+1
      INBART=MIN0 (INBARC,INBARS)
C
      DO 258 J=1,INBART
      CNOMAR(IXC(IDECDC+J,IRGPMC))=CNOMAR(IXC(IDECDS+J,IRGPMS))
  258 CONTINUE
C
      DO 259 J=1,2*INBART
      MLGPOS(IXM(2*IDECDC+J,IRGPMC))=MLGPOS(IXM(2*IDECDS+J,IRGPMS))
  259 CONTINUE
C
      IPOTZC=IPOTZC+INBART
C
      IF (IPOTZS+INBART.LT.IPOSFE) THEN
        GOTO 251
      ELSEIF (IPOSFE.LT.INBALO) THEN
        GOTO 220
      ENDIF
C*
C     2.6 - MISE A JOUR DE CERTAINES TABLES.
C-----------------------------------------------------------------------
C
      NBTROU(IRANG)=NBTROU(IRANG)-IDECAL
      INBALO=INBALO-IDECAL
      MDES1D(IXM(JPNALO,IRANG))=INBALO
      INTPPN=(INBALO-1+INALPP)/INALPP
      NALDPI(IRANG)=INBALO-(INTPPN-1)*INALPP
C
      IF (INTPPN.NE.INTPPI) THEN
C
C           ON A DONC LAISSE DES P.P.I. "PARASITES" EN MEMOIRE.
C        A PRIORI CE N'EST PAS GENANT, CAR ON VA BIENTOT RELACHER
C        TOUTES CELLES RELATIVES AU FICHIER QUE L'ON TRAITE.
C        NEANMOINS IL EST PREFERABLE DE REDEFINIR LE RANG EN MEMOIRE
C        DE LA DERNIERE P.P.I. DU FICHIER.
C
        NPODPI(IRANG)=IRGPMC
        INTPPI=INTPPN
      ENDIF
C
  300 CONTINUE
C**
C     3.  -  CAS OU IL FAUT RECALCULER LES LONGUEURS EXTREMES DES
C            ARTICLES DE DONNEES.
C-----------------------------------------------------------------------
C
      IF (.NOT.LMIMAL(IRANG)) GOTO 400
C*
C     3.1 - EXPLORATION DES P.P.I., PUIS EVENTUELLEMENT DES P.A.I. .
C-----------------------------------------------------------------------
C
      ILOMIN=0
      ILOMAX=0
      IRPIFN=1
      INPIME=0
C
      IF (NPODPI(IRANG).EQ.2) THEN
        IDEBEX=3
      ELSE
        IDEBEX=2
      ENDIF
C
      DO 317 JNPAGE=1,INTPPI
C
      IF (JNPAGE.LE.INPPIM) THEN
C
C           IL S'AGIT D'UNE EXPLORATION EN MEMOIRE ( PAGES D'INDEX ).
C
        IRGPIM=MRGPIM(JNPAGE,IRANG)
        IRGPIF=MRGPIF(IRGPIM)
        INPIME=INPIME+1
        IEXPLO(INPIME)=IRGPIF
        IF (IRGPIF.EQ.(IRPIFN+1)) IRPIFN=IRGPIF
C
        IF (.NOT.LPHASP(IRGPIM)) THEN
C
          CALL LFIPHA (IREP,IRANG,IRGPIM,IRETIN)
C
          IF (IRETIN.EQ.1) THEN
            GOTO 903
          ELSEIF (IRETIN.EQ.2) THEN
            GOTO 904
          ELSEIF (IRETIN.NE.0) THEN
            GOTO 1001
          ENDIF
C
        ENDIF
C
      ELSE
C
C           IL S'AGIT D'UNE EXPLORATION "HORS MEMOIRE";
C         ON CHERCHE LA PROCHAINE P.A.I. NON EXPLOREE .
C
        IF (JNPAGE.EQ.INPPIM+1) IRGPIF=IRPIFN
C
  311   CONTINUE
        IRGPIF=IRGPIF+1
C
        DO 312 J=IDEBEX,INPIME
        IF (IEXPLO(J).EQ.IRGPIF) GOTO 311
  312   CONTINUE
C
        ILFORC=1
        INPILE=2
        CALL LFIPIM (IREP,IRANG,IRANGM,IRGPIM,IRGPIF,ILFORC,INPILE,
     S               IRETIN)
C
        IF (IRETIN.EQ.1) THEN
          GOTO 903
        ELSEIF (IRETIN.EQ.2) THEN
          GOTO 904
        ELSEIF (IRETIN.NE.0) THEN
          GOTO 1001
        ENDIF
C
      ENDIF
C
      INBART=MIN0 (INALPP,INBALO-(IRGPIF-1)*INALPP)
C
      IF (ILOMIN.EQ.0) THEN
C
        DO 314 J=1,INBART
C
        IF (CNOMAR(IXC(J,IRGPIM)).NE.' ') THEN
          ILOMIN=MLGPOS(IXM(2*J-1,IRGPIM))
          ILOMAX=ILOMIN
          IDEBUT=J+1
          GOTO 315
        ENDIF
C
  314   CONTINUE
C
        GOTO 317
      ELSE
        IDEBUT=1
      ENDIF
C
  315 CONTINUE
C
      DO 316 J=IDEBUT,INBART
C
      IF (CNOMAR(IXC(J,IRGPIM)).NE.' ') THEN
        ILONGA=MLGPOS(IXM(2*J-1,IRGPIM))
        ILOMIN=MIN0 (ILONGA,ILOMIN)
        ILOMAX=MAX0 (ILONGA,ILOMAX)
      ENDIF
C
  316 CONTINUE
C
  317 CONTINUE
C*
C     3.2 - MISE A JOUR DES TABLES CONCERNEES.
C-----------------------------------------------------------------------
C
      MDES1D(IXM(JPLNAL,IRANG))=ILOMIN
      MDES1D(IXM(JPLXAL,IRANG))=ILOMAX
C
  400 CONTINUE
C**
C     4.  -  "VIDAGE" SUR FICHIER DES PAGES RESTANT A ECRIRE.
C-----------------------------------------------------------------------
C*
C     4.1 -  PAGES DE *DONNEES* RESTANT A ECRIRE.
C-----------------------------------------------------------------------
C
      DO 411 J=0,JPNPDF-1
C
      IF (LECRPD(J,IRANG)) THEN
C
        CALL LFIVID (IREP,IRANG,J,ITAMPO(1),IRETIN)
C
        IF (IRETIN.EQ.1) THEN
          GOTO 903
        ELSEIF (IRETIN.EQ.2) THEN
          GOTO 904
        ELSEIF (IRETIN.NE.0) THEN
          GOTO 1001
        ENDIF
C
      ENDIF
C
  411 CONTINUE
C*
C     4.2 -  (PAIRES DE) PAGES D'*INDEX* RESTANT A ECRIRE.
C-----------------------------------------------------------------------
C
      INPPIM=NPPIMM(IRANG)
C
      DO 423 J=1,INPPIM
      IRGPIM=MRGPIM(J,IRANG)
      IRGPIF=MRGPIF(IRGPIM)
      CALL LFIREC (IRGPIF,IRANG,IREC)
C
      IF (LECRPI(IRGPIM,1)) THEN
C
        IF (J.EQ.NPODPI(IRANG).AND.NALDPI(IRANG).NE.INALPP) THEN
C
C          COMPLEMENT DE LA DERNIERE PAGE D'INDEX NOMS AVEC UN NOM
C        CONVENTIONNEL.
C
          DO 421 JJ=NALDPI(IRANG)+1,JPNXNA*IFACTM
          CNOMAR(IXC(JJ,IRGPIM))='**FIN D''INDEX**'
  421     CONTINUE
C
        ENDIF
C
        INAPHY=IREC
        CALL LFIECC (IREP,KNUMER,IREC,CNOMAR(IXC(1,IRGPIM)),
     S               NBWRIT(IRANG),IFACTM,IRETIN)
C
        IF (IRETIN.EQ.1) THEN
          GOTO 903
        ELSEIF (IRETIN.NE.0) THEN
          GOTO 1001
        ENDIF
C
        LECRPI(IRGPIM,1)=.FALSE.
      ENDIF
C
      IF (LECRPI(IRGPIM,2).AND.LPHASP(IRGPIM)) THEN
C
        IF (J.EQ.NPODPI(IRANG).AND.NALDPI(IRANG).NE.INALPP) THEN
C
C          COMPLEMENT DE LA DERNIERE PAGE D'INDEX LONGUEUR/POSITION
C        AVEC DES ZEROS.
C
          DO 422 JJ=2*NALDPI(IRANG)+1,ILARPH
          MLGPOS(IXM(JJ,IRGPIM))=0
  422     CONTINUE
C
        ENDIF
C
        INAPHY=IREC+1
        CALL LFIEDO (IREP,KNUMER,IREC+1,MLGPOS(IXM(1,IRGPIM)),
     S               NBWRIT(IRANG),IFACTM,IRETIN)
C
        IF (IRETIN.EQ.1) THEN
          GOTO 903
        ELSEIF (IRETIN.NE.0) THEN
          GOTO 1001
        ENDIF
C
        LECRPI(IRGPIM,2)=.FALSE.
      ENDIF
C
  423 CONTINUE
C*
C     4.3 -  CAS DE L'ARTICLE DOCUMENTAIRE, SI NECESSAIRE.
C-----------------------------------------------------------------------
C
      LLECRD=LMODIF(IRANG).OR.NBWRIT(IRANG).NE.0
C
      IF (LLECRD) THEN
C
C        AU PREALABLE, MISE A JOUR DE CET ARTICLE DOCUMENTAIRE.
C
        IAUXIL=IXM(JPNRES,IRANG)
        MDES1D(IAUXIL)=MDES1D(IAUXIL)+NREESP(IRANG)
        IAUXIL=IXM(JPNREC,IRANG)
        MDES1D(IAUXIL)=MDES1D(IAUXIL)+NREECO(IRANG)
        IAUXIL=IXM(JPNREL,IRANG)
        MDES1D(IAUXIL)=MDES1D(IAUXIL)+NREELO(IRANG)
        IAUXIL=IXM(JPNTRU,IRANG)
        MDES1D(IAUXIL)=MDES1D(IAUXIL)+NBTROU(IRANG)
        CALL LFIDAH (MDES1D(IXM(JPDDMG,IRANG)),
     S               MDES1D(IXM(JPHDMG,IRANG)))
        IREC=1
        INAPHY=IREC
        CALL LFIEDO (IREP,KNUMER,IREC,MDES1D(IXM(1,IRANG)),
     S               NBWRIT(IRANG),IFACTM,IRETIN)
C
        IF (IRETIN.EQ.1) THEN
          GOTO 903
        ELSEIF (IRETIN.NE.0) THEN
          GOTO 1001
        ENDIF
C
      ENDIF
C**
C     5.  -  FERMETURE EFFECTIVE (*CLOSE*) DU FICHIER.
C-----------------------------------------------------------------------
C
      INALDO=INBALO-MDES1D(IXM(JPNTRU,IRANG))
      INAPHY=0
C
      IF (LLSTTU) THEN
        CLOSE (UNIT=KNUMER,STATUS=CLSTTC,ERR=905,IOSTAT=IREP)
      ELSE
C
        IF (INALDO.EQ.0) THEN
C
C       SI ON SE RETROUVE AVEC UN FICHIER "VIDE" ET QUE L'ON N'A PAS DE
C       PARAMETRE "STATUS" POUR LE "CLOSE", ON VA ESSAYER DE RELACHER LE
C       FICHIER, AFIN DE NE PAS LAISSER TRAINER UN TEL FICHIER "ZOMBIE".
C             ( "VIDE" = SANS ARTICLE LOGIQUE DE DONNEES )
C       ON N'A PAS DE GARANTIE D'Y ARRIVER, DANS LA MESURE OU ON N'EST
C       PAS SUR D'AVOIR DES DROITS D'ACCES SUFFISANTS.
C
          CLOSE (UNIT=KNUMER,STATUS='DELETE',ERR=511)
          CLSTTC='DELETE'
          LLSTTU=.TRUE.
          GOTO 600
        ENDIF
C
  511   CONTINUE
C
        CLOSE (UNIT=KNUMER,ERR=905,IOSTAT=IREP)
C
      ENDIF
C
  600 CONTINUE
C**
C     6.  -  IMPRESSION EVENTUELLE DE STATISTIQUES D'UTILISATION.
C-----------------------------------------------------------------------
C
      NDEROP(IRANG)=9
      NDERCO(IRANG)=IREP
      LLIMST=NISTAG.EQ.2.OR.(NISTAG.EQ.1.AND.LISTAT(IRANG))
      IF (LLIMST) CALL LFIIST (IRANG,.TRUE.)
C**
C     7.  -  "NETTOYAGE" DES TABLES AYANT PERMIS DE GERER LE FICHIER.
C            ( AU MOINS CELLES AYANT UN CARACTERE "GLOBAL"; A NOTER
C              TOUTEFOIS QU'ON NE TOUCHE PAS AUX CARACTERISTIQUES DES
C              PAGES D'INDEX PREAFFECTEES )
C-----------------------------------------------------------------------
C
       IF (LMULTI) CALL LFIVER (VERGLA,'ON')
      LLVERG=LMULTI
C
      DO 702 J=2,MIN0 (INPPIM,JPNPIA)
      IRGPIM=MRGPIM(J,IRANG)
C
      DO 701 JR=IRGPIM,IRGPIM+IFACTM-1
      MRGPIF(JR)=JPNIL
  701 CONTINUE
C
  702 CONTINUE
C
      DO 704 J=JPNPIA+1,INPPIM
      IRGPIM=MRGPIM(J,IRANG)
C
      DO 703 JR=IRGPIM,IRGPIM+IFACTM-1
      MCOPIF(JR)=JPNIL
      MRGPIF(JR)=JPNIL
  703 CONTINUE
C
  704 CONTINUE
C
      NPISAF=NPISAF-MAX0 (0,(INPPIM-JPNPIA)*IFACTM)
C
      DO 705 JR=IRANG,IRANG+IFACTM-1
      NUMERO(JR)=JPNIL
  705 CONTINUE
C
      DO 706 J=1,NBFIOU
C
      IF (NUMIND(J).EQ.IRANG) THEN
        IPOSNU=J
        GOTO 707
      ENDIF
C
  706 CONTINUE
C
      IREP=-16
      GOTO 1001
C
  707 CONTINUE
C
      NBFIOU=NBFIOU-1
      NFACTM=NFACTM-IFACTM
C
      DO 708 J=IPOSNU,NBFIOU
      NUMIND(J)=NUMIND(J+1)
  708 CONTINUE
C*
C     7.1 -  ASPECTS SPECIFIQUES AUX TABLES D'IMPORT/EXPORT.
C-----------------------------------------------------------------------
C
      IF (NEXPOR(IRANG).GT.0.OR.NIMPOR(IRANG).GT.0) THEN
        IRANIE=MAX0 (NEXPOR(IRANG),NIMPOR(IRANG))
        INIMES=IXNIMS (IRANG)
C
        IF (INIMES.GE.1) THEN
          WRITE (UNIT=CLMESS,FMT='(''KNUMER='',I3,
     S           '', ATTENTION: IMPORT/EXPORT NON TERMINE'')') KNUMER
          CALL LFIEMS (KNUMER,INIMES,IREP,.FALSE.,CLMESS,CLNSPR,CLACTI)
        ENDIF
C
        DO 711 J=1,NUIMEX
C
        IF (NINIEX(J).EQ.IRANIE) THEN
          IPOSNU=J
          GOTO 712
        ENDIF
C
  711   CONTINUE
C
        IREP=-16
        GOTO 1001
C
  712   CONTINUE
C
        MNUIEX(IRANG)=JPNIL
        NUIMEX=NUIMEX-1
C
        DO 713 J=IPOSNU,NUIMEX
        NINIEX(J)=NINIEX(J+1)
  713   CONTINUE
C
      ENDIF
C
       IF (LMULTI) THEN
         CALL LFIVER (VERRUE(IRANG),'OFF')
         CALL LFIVER (VERRUE(IRANG),'REL')
       ENDIF
C
      LLVERF=.FALSE.
      IREP=IREPX
      GOTO 1001
C**
C     9.  - CI-DESSOUS, ETIQUETTES DE BRANCHEMENT EN CAS D'ERREUR E/S.
C-----------------------------------------------------------------------
C
  903 CONTINUE
      CLACTI='WRITE'
      GOTO 909
C
  904 CONTINUE
      CLACTI='READ'
      GOTO 909
C
  905 CONTINUE
      CLACTI='CLOSE'
C
  909 CONTINUE
      IF (INAPHY.NE.0) NUMAPH(IRANG)=INAPHY
C
C      AU CAS OU, ON FORCE LE CODE-REPONSE ENTREE/SORTIE A ETRE POSITIF.
C
      IREP=IABS (IREP)
C**
C    10.  -  PHASE TERMINALE : MESSAGERIE, AVEC "ABORT" EVENTUEL,
C            VIA LE SOUS-PROGRAMME "LFIEMS" .
C-----------------------------------------------------------------------
C
 1001 CONTINUE
      KREP=IREP
      LLFATA=LLMOER (IREP,IRANG)
C
      IF (LLFATA) THEN
        INIMES=2
      ELSE
        INIMES=IXNIMS (IRANG)
      ENDIF
C
       IF (LLVERF) CALL LFIVER (VERRUE(IRANG),'OFF')
       IF (LLVERG) CALL LFIVER (VERGLA,'OFF')
C
      IF (.NOT.LLFATA.AND.INIMES.EQ.0) RETURN
C
      IF (INIMES.EQ.2) THEN
        WRITE (UNIT=CLMESS,FMT='(''KREP='',I4,'', KNUMER='',I3,
     S         '', CDSTTC='''''',A,'''''''')')
     S      KREP,KNUMER,CLSTTC(:ILSTTU)
        CALL LFIEMS (KNUMER,INIMES,IREP,LLFATA,CLMESS,CLNSPR,CLACTI)
      ENDIF
C
C       LA MESSAGERIE QUI SUIT N'EST PAS EMISE EN CAS D'ERREUR FATALE.
C
      IF (INIMES.GE.1.AND.(IREP.EQ.0.OR.IREP.EQ.-19)) THEN
        CLAUXI='   '
C
        IF (LFRANC) THEN
          WRITE (UNIT=CLMESS,FMT='(''Unite'',I3,
     S           '' traitee, Fichier'',A)')
     S            KNUMER,CLAUXI
        ELSE
          WRITE (UNIT=CLMESS,FMT='(''Unit'',I3,
     S           '' processed, File'',A)')
     S            KNUMER,CLAUXI
        ENDIF
C
        IDECAL=INDEX (CLMESS,CLAUXI)
C
        IF (INBALO.EQ.0) THEN
C
          IF (LFRANC) THEN
            CLMESS(IDECAL+1:)='*VIDE*'//CLAUXI
          ELSE
            CLMESS(IDECAL+1:)='*EMPTY*'//CLAUXI
          ENDIF
C
          IDECAL=IDECAL+INDEX (CLMESS(IDECAL+1:),CLAUXI)
        ENDIF
C
        IF (LFRANC) THEN
C
          IF (LNOUFI(IRANG)) THEN
            CLMESS(IDECAL+1:)='$CREE$ &'//CLAUXI
          ELSEIF (LLECRD) THEN
            CLMESS(IDECAL+1:)='$MODIFIE$ &'//CLAUXI
          ELSE
            CLMESS(IDECAL+1:)='non modifie &'//CLAUXI
          ENDIF
C
          IDECAL=IDECAL+INDEX (CLMESS(IDECAL+1:),CLAUXI)
C
          IF (.NOT.LLSTTU) THEN
            CLMESS(IDECAL+1:)='FERME'//CLAUXI
          ELSEIF (CLSTTC.EQ.'KEEP') THEN
            CLMESS(IDECAL+1:)='GARDE'//CLAUXI
          ELSE
            CLMESS(IDECAL+1:)='*RELACHE*'//CLAUXI
          ENDIF
C
          IF (LNOUFI(IRANG).OR.LLECRD) THEN
            IDECAL=IDECAL+INDEX (CLMESS(IDECAL+1:),CLAUXI)
            WRITE (UNIT=CLMESS(IDECAL+1:),FMT='(''a'',I9.6,''_'',I6.6,
     S       '','',I7,'' Articles de donnees,'',I9,'' mots en tout'')')
     S       MDES1D(IXM(JPDDMG,IRANG)),MDES1D(IXM(JPHDMG,IRANG)),
     S       INALDO,ILARPH*MDES1D(IXM(JPNAPH,IRANG))
          ENDIF
C
        ELSE
C
          IF (LNOUFI(IRANG)) THEN
            CLMESS(IDECAL+1:)='$CREATED$ &'//CLAUXI
          ELSEIF (LLECRD) THEN
            CLMESS(IDECAL+1:)='$MODIFIED$ &'//CLAUXI
          ELSE
            CLMESS(IDECAL+1:)='not modified &'//CLAUXI
          ENDIF
C
          IDECAL=IDECAL+INDEX (CLMESS(IDECAL+1:),CLAUXI)
C
          IF (.NOT.LLSTTU) THEN
            CLMESS(IDECAL+1:)='CLOSED'//CLAUXI
          ELSEIF (CLSTTC.EQ.'KEEP') THEN
            CLMESS(IDECAL+1:)='KEPT'//CLAUXI
          ELSE
            CLMESS(IDECAL+1:)='*RELEASED*'//CLAUXI
          ENDIF
C
          IF (LNOUFI(IRANG).OR.LLECRD) THEN
            IDECAL=IDECAL+INDEX (CLMESS(IDECAL+1:),CLAUXI)
            WRITE (UNIT=CLMESS(IDECAL+1:),FMT='(''at'',I9.6,''_'',
     S I6.6,'','',I7,'' data Records,'',I9,'' words for a whole'')')
     S       MDES1D(IXM(JPDDMG,IRANG)),MDES1D(IXM(JPHDMG,IRANG)),
     S       INALDO,ILARPH*MDES1D(IXM(JPNAPH,IRANG))
          ENDIF
C
        ENDIF
C
        CALL LFIEMS (KNUMER,INIMES,IREP,.FALSE.,CLMESS,CLNSPR,CLACTI)
C
        IF (LFRANC) THEN
          INLNOM=MIN0 (NLNOMF(IRANG),JPLFIX,LEN (CLMESS)-6)
          CLMESS='Nom='''//CNOMFI(IRANG)(1:INLNOM)//''''
        ELSE
          INLNOM=MIN0 (NLNOMF(IRANG),JPLFIX,LEN (CLMESS)-7)
          CLMESS='Name='''//CNOMFI(IRANG)(1:INLNOM)//''''
        ENDIF
C
        CALL LFIEMS (KNUMER,INIMES,IREP,.FALSE.,CLMESS,CLNSPR,CLACTI)
C
        IF (CNOMSY(IRANG)(1:NLNOMS(IRANG)).NE.
     S      CNOMFI(IRANG)(1:NLNOMF(IRANG))) THEN
C
          IF (LFRANC) THEN
            INLNOM=MIN0 (NLNOMS(IRANG),JPLFIX,LEN (CLMESS)-14)
            CLMESS='Nom SYSTEME='''//CNOMSY(IRANG)(1:INLNOM)//''''
          ELSE
            INLNOM=MIN0 (NLNOMS(IRANG),JPLFIX,LEN (CLMESS)-14)
            CLMESS='SYSTEM Name='''//CNOMSY(IRANG)(1:INLNOM)//''''
          ENDIF
C
          CALL LFIEMS (KNUMER,INIMES,IREP,.FALSE.,CLMESS,CLNSPR,CLACTI)
        ENDIF
C
      ENDIF
C
      RETURN
      END
