      SUBROUTINE LFIIST ( KRANG, LDAPFE )
#include "lficomt.h"
C****
C        SOUS-PROGRAMME IMPRIMANT LES STATISTIQUES D'UTILISATION D'UNE
C     UNITE LOGIQUE TRAITEE PAR LE LOGICIEL DE FICHIERS INDEXES LFI.
C     CE SOUS-PROGRAMME EST ***A USAGE INTERNE*** DU LOGICIEL; CELUI
C     A APPELER PAR L'UTILISATEUR QUI DESIRE AVOIR CES STATISTIQUES
C     AUTREMENT QU'A LA FERMETURE DU FICHIER EST *LFISTA* .
C**
C    ARGUMENTS : KRANG  (ENTREE) ==> RANG ( DANS LA TABLE *NUMERO* )
C                                    DE L'UNITE LOGIQUE CONCERNEE;
C                LDAPFE (ENTREE) ==> VRAI SI L'APPEL EST FAIT LORS DE
C                                    LA FERMETURE (PAR *LFIFER*) .
C
C    Modifications:
C
C    02/06/97, Jean Clochard.
C
C              -Modification des impressions pour que l'annee puisse
C               etre imprimee avec 4 chiffres.
C
#include "lficom0.h"
#ifndef f77
#include "precision.h"
#endif
#include "lficom1.h"
C
      CHARACTER CLOPER*(JPLSPX)
C
#ifndef f77
      INTEGER (KIND=JPDBLE) IIDATE, IIHEUR
#else
      INTEGER IIDATE, IIHEUR
#endif
      INTEGER KRANG, INUMER, IREP, IMDESC, IDATEM, IHEURM, IANNEE, IMOIS
      INTEGER IJOUR, IHEURE, IMINUT, ISECON, IDECAL, IDERNI, INLNOM, J
      INTEGER IDEROP, IDERCO, IDERAP, INBPIR, INBALO, IFACTM, ILARPH
      INTEGER INALPP, ILONGF, ILDONN, INTRUA, INALDO, INPPIU, INUTIL
      INTEGER INTRUO, ILOMIN, ILOMAX, IREESP, IREECO, IREELO, INALIP
      INTEGER INAMAX, INMOUL, INMOUE, INMOUT, INMOLL, INMOLE, INMOLT
      INTEGER INLECT, INECRI, INRENO, INSUPP, INIMES, INTPPI
C
      LOGICAL LDAPFE
C
#include "lficom2.h"
C**
C     1.  -  CONTROLES DES PARAMETRES D'APPEL.
C-----------------------------------------------------------------------
C
      IF (KRANG.LE.0.OR.KRANG.GT.JPNXFI) THEN
        INUMER=JPNIL
      ELSE
        INUMER=NUMERO(KRANG)
        IREP=0
      ENDIF
C
      IF (INUMER.EQ.JPNIL) THEN
        IREP=-14
        GOTO 1001
      ENDIF
C**
C     2.  -  IMPRESSION DES STATISTIQUES.
C-----------------------------------------------------------------------
C
      CALL LFIDAH (IIDATE,IIHEUR)
      IDATEM=IIDATE
      IHEURM=IIHEUR
      IANNEE=IDATEM/10000
      IJOUR =MOD (IDATEM,100)
      IMOIS =IDATEM/100-100*IANNEE
      IHEURE=IHEURM/10000
      ISECON=MOD (IHEURM,100)
      IMINUT=IHEURM/100-100*IHEURE
C
      IF (LFRANC) THEN
        PRINT 9010,INUMER,IANNEE,IMOIS,IJOUR,IHEURE,IMINUT,ISECON
C
        IF (LDAPFE) THEN
          PRINT 9020
        ELSEIF (LNOUFI(KRANG)) THEN
          PRINT 9025
        ENDIF
C
      ELSE
        PRINT 9011,INUMER,IANNEE,IMOIS,IJOUR,IHEURE,IMINUT,ISECON
C
        IF (LDAPFE) THEN
          PRINT 9021
        ELSEIF (LNOUFI(KRANG)) THEN
          PRINT 9026
        ENDIF
C
      ENDIF
C
      IF (.NOT.LDAPFE.OR.IXNIMS(KRANG).EQ.0) THEN
C
        IF (LFRANC) THEN
          CLMESS=' X NOM du Fichier='''
        ELSE
          CLMESS=' X File NAME='''
        ENDIF
C
        IDECAL=INDEX (CLMESS,'''')
        IDERNI=111
        INLNOM=MIN0 (NLNOMF(KRANG),JPLFIX,IDERNI-2-IDECAL)
        CLMESS(IDECAL+1:IDECAL+INLNOM+1)=CNOMFI(KRANG)(1:INLNOM)//''''
        CLMESS(IDERNI:IDERNI)='X'
        PRINT 9015,CLMESS
C
        IF (CNOMSY(KRANG).NE.CNOMFI(KRANG)) THEN
C
          IF (LFRANC) THEN
            CLMESS=' X NOM *SYSTEME*: '''
          ELSE
            CLMESS=' X SYSTEM NAME: '''
          ENDIF
C
          IDECAL=INDEX (CLMESS,'''')
          IDERNI=111
          INLNOM=MIN0 (NLNOMS(KRANG),JPLFIX,IDERNI-2-IDECAL)
          CLMESS(IDECAL+1:IDECAL+INLNOM+1)=CNOMSY(KRANG)(1:INLNOM)//''''
          CLMESS(IDERNI:IDERNI)='X'
          PRINT 9015,CLMESS
        ENDIF
C
      ENDIF
C
      IDEROP=NDEROP(KRANG)
C
      IF (IDEROP.EQ.0) THEN
        CLOPER='LFIOUV'
      ELSEIF (IDEROP.EQ.1) THEN
        CLOPER='LFIECR'
      ELSEIF (IDEROP.EQ.2) THEN
        CLOPER='LFILEC'
      ELSEIF (IDEROP.EQ.3) THEN
        CLOPER='LFIMST'
      ELSEIF (IDEROP.EQ.4) THEN
        CLOPER='LFIERF'
      ELSEIF (IDEROP.EQ.5) THEN
        CLOPER='LFINIM'
      ELSEIF (IDEROP.EQ.6) THEN
        CLOPER='LFITAM'
      ELSEIF (IDEROP.EQ.7) THEN
        CLOPER='LFINFO'
      ELSEIF (IDEROP.EQ.8) THEN
        CLOPER='LFISTA'
      ELSEIF (IDEROP.EQ.9) THEN
        CLOPER='LFIFER'
      ELSEIF (IDEROP.EQ.10) THEN
        CLOPER='LFILAS'
      ELSEIF (IDEROP.EQ.11) THEN
        CLOPER='LFICAS'
      ELSEIF (IDEROP.EQ.12) THEN
        CLOPER='LFINAF'
      ELSEIF (IDEROP.EQ.13) THEN
        CLOPER='LFIREN'
      ELSEIF (IDEROP.EQ.14) THEN
        CLOPER='LFIPOS'
      ELSEIF (IDEROP.EQ.15) THEN
        CLOPER='LFISUP'
      ELSEIF (IDEROP.EQ.16) THEN
        CLOPER='LFILAP'
      ELSEIF (IDEROP.EQ.17) THEN
        CLOPER='LFICAP'
      ELSEIF (IDEROP.EQ.18) THEN
        CLOPER='LFILAF'
      ELSEIF (IDEROP.EQ.19) THEN
        CLOPER='LFIOEF'
      ELSEIF (IDEROP.EQ.20) THEN
        CLOPER='LFIOSF'
      ELSEIF (IDEROP.EQ.21) THEN
        CLOPER='LFIOMF'
      ELSEIF (IDEROP.EQ.22) THEN
        CLOPER='LFIPXF'
      ELSE
        CLOPER=CHINCO(:JPLSPX)
      ENDIF
C
      IDERCO=NDERCO(KRANG)
      IDERAP=MDES1D(IXM(JPNAPH,KRANG))
      INBPIR=MDES1D(IXM(JPNPIR,KRANG))
      INBALO=MDES1D(IXM(JPNALO,KRANG))
      IFACTM=MFACTM(KRANG)
      ILARPH=JPLARD*IFACTM
      INALPP=JPNAPP*IFACTM
C
      IF (LMODIF(KRANG).AND..NOT.LDAPFE) THEN
C
C         Il faut inclure, dans la longueur totale du fichier,
C     les eventuels articles physiques (de donnees, mais aussi d'index)
C     qui n'auraient pas encore ete ecrits.
C
        DO 201 J=0,JPNPDF-1
        IDERAP=MAX0 (IDERAP,NUMAPD(J,KRANG))
  201   CONTINUE
C
        INTPPI=(INBALO-1+INALPP)/INALPP
C
        IF (INTPPI.GT.INBPIR) THEN
          IMDESC=MDES1D(IXM(ILARPH+1-INTPPI+INBPIR,KRANG))
          IDERAP=MAX0 (IDERAP,IMDESC+1)
        ENDIF
C
      ENDIF
C
      ILONGF=ILARPH*IDERAP
      ILDONN=MDES1D(IXM(JPLTAL,KRANG))
C
      IF (LDAPFE) THEN
        INTRUA=MDES1D(IXM(JPNTRU,KRANG))
      ELSE
        INTRUA=MDES1D(IXM(JPNTRU,KRANG))+NBTROU(KRANG)
      ENDIF
C
      INALDO=INBALO-INTRUA
C
C        NOMBRE DE P.P.I. "UTILES" (EN DECOMPTANT LES TROUS D'INDEX)
C
      INPPIU=(INALDO-1+INALPP)/INALPP
      INUTIL=ILONGF-ILDONN-ILARPH*(1+2*INPPIU)
      INTRUO=NBTROU(KRANG)
      ILOMIN=MDES1D(IXM(JPLNAL,KRANG))
      ILOMAX=MDES1D(IXM(JPLXAL,KRANG))
C
      IF (LFRANC) THEN
        PRINT 9030,CLOPER,IDERCO
        PRINT 9040,ILONGF,ILDONN,ILARPH,INUTIL
        PRINT 9050,INTRUA,INTRUO
C
        IF (LDAPFE.OR..NOT.LMIMAL(KRANG)) THEN
          PRINT 9060,INALDO,ILOMIN,ILOMAX
        ELSE
          PRINT 9070,INALDO,ILOMIN,ILOMAX
        ENDIF
C
      ELSE
        PRINT 9031,CLOPER,IDERCO
        PRINT 9041,ILONGF,ILDONN,ILARPH,INUTIL
        PRINT 9051,INTRUA,INTRUO
C
        IF (LDAPFE.OR..NOT.LMIMAL(KRANG)) THEN
          PRINT 9061,INALDO,ILOMIN,ILOMAX
        ELSE
          PRINT 9071,INALDO,ILOMIN,ILOMAX
        ENDIF
C
      ENDIF
C
      IF (LDAPFE) THEN
        IREESP=MDES1D(IXM(JPNRES,KRANG))-NREESP(KRANG)
        IREECO=MDES1D(IXM(JPNREC,KRANG))-NREECO(KRANG)
        IREELO=MDES1D(IXM(JPNREL,KRANG))-NREELO(KRANG)
      ELSE
        IREESP=MDES1D(IXM(JPNRES,KRANG))
        IREECO=MDES1D(IXM(JPNREC,KRANG))
        IREELO=MDES1D(IXM(JPNREC,KRANG))
      ENDIF
C
      IDATEM=MDES1D(IXM(JPDCRE,KRANG))
      IHEURM=MDES1D(IXM(JPHCRE,KRANG))
      IANNEE=IDATEM/10000
      IJOUR =MOD (IDATEM,100)
      IMOIS =IDATEM/100-100*IANNEE
      IHEURE=IHEURM/10000
      ISECON=MOD (IHEURM,100)
      IMINUT=IHEURM/100-100*IHEURE
C
      IF (LFRANC) THEN
        IF (.NOT.LNOUFI(KRANG))
     S     PRINT 9080,' AVANT',IREESP,IREECO,IREELO
        PRINT 9080,'DEPUIS',NREESP(KRANG),NREECO(KRANG),NREELO(KRANG)
        PRINT 9090,'CREATION du FICHIER (Premiere Ouverture)',
     S             IANNEE,IMOIS,IJOUR,IHEURE,IMINUT,ISECON
      ELSE
        IF (.NOT.LNOUFI(KRANG))
     S     PRINT 9081,'BEFORE',IREESP,IREECO,IREELO
        PRINT 9081,' SINCE',NREESP(KRANG),NREECO(KRANG),NREELO(KRANG)
        PRINT 9091,'FILE CREATION (Very First Opening)  ',
     S             IANNEE,IMOIS,IJOUR,IHEURE,IMINUT,ISECON
      ENDIF
C
      IF (.NOT.LNOUFI(KRANG).OR.LMODIF(KRANG)) THEN
        IDATEM=MDES1D(IXM(JPDMNG,KRANG))
        IHEURM=MDES1D(IXM(JPHMNG,KRANG))
        IANNEE=IDATEM/10000
        IJOUR =MOD (IDATEM,100)
        IMOIS =IDATEM/100-100*IANNEE
        IHEURE=IHEURM/10000
        ISECON=MOD (IHEURM,100)
        IMINUT=IHEURM/100-100*IHEURE
C
        IF (LFRANC) THEN
          PRINT 9090,'Premiere Modification "NON GARANTIE"    ',
     S               IANNEE,IMOIS,IJOUR,IHEURE,IMINUT,ISECON
        ELSE
          PRINT 9091,'First "not guaranteed" Modification  ',
     S               IANNEE,IMOIS,IJOUR,IHEURE,IMINUT,ISECON
        ENDIF
C
      ENDIF
C
      IF (LDAPFE.OR..NOT.LNOUFI(KRANG)) THEN
        IDATEM=MDES1D(IXM(JPDDMG,KRANG))
        IHEURM=MDES1D(IXM(JPHDMG,KRANG))
        IANNEE=IDATEM/10000
        IJOUR =MOD (IDATEM,100)
        IMOIS =IDATEM/100-100*IANNEE
        IHEURE=IHEURM/10000
        ISECON=MOD (IHEURM,100)
        IMINUT=IHEURM/100-100*IHEURE
C
        IF (LFRANC) THEN
          PRINT 9090,'Derniere FERMETURE apres Modification   ',
     S               IANNEE,IMOIS,IJOUR,IHEURE,IMINUT,ISECON
        ELSE
          PRINT 9091,'Last CLOSE made after a Modification',
     S               IANNEE,IMOIS,IJOUR,IHEURE,IMINUT,ISECON
        ENDIF
C
      ENDIF
C
      INALIP=INALPP*INBPIR
      INAMAX=INALIP+INALPP*(ILARPH-JPLDOC)
      INMOUL=NBMOLU(KRANG)
      INMOUE=NBMOEC(KRANG)
      INMOUT=INMOUL+INMOUE
      INMOLL=ILARPH*NBREAD(KRANG)
      INMOLE=ILARPH*NBWRIT(KRANG)
      INMOLT=INMOLL+INMOLE
      INLECT=NBLECT(KRANG)
      INECRI=NBNECR(KRANG)+NREESP(KRANG)+NREECO(KRANG)+NREELO(KRANG)
      INRENO=NBRENO(KRANG)
      INSUPP=NBSUPP(KRANG)
C
      IF (LFRANC) THEN
        PRINT 9100,INALIP,INAMAX
        PRINT 9110,'UTILISATEUR','EN LECTURE','EN ECRITURE',
     S             INMOUL,INMOUE,INMOUT
        PRINT 9110,' LOGICIEL  ','PAR "READ"','PAR "WRITE"',
     S             INMOLL,INMOLE,INMOLT
        PRINT 9120,INLECT,INECRI,INRENO,INSUPP
      ELSE
        PRINT 9101,INALIP,INAMAX
        PRINT 9111,'  USER  ',' For INPUT  ',' For OUTPUT  ',
     S             INMOUL,INMOUE,INMOUT
        PRINT 9111,'SOFTWARE','Through READ','Through WRITE',
     S             INMOLL,INMOLE,INMOLT
        PRINT 9121,INLECT,INECRI,INRENO,INSUPP
      ENDIF
C**
C    10.  -  PHASE TERMINALE : MESSAGERIE INTERNE EVENTUELLE,
C            VIA LE SOUS-PROGRAMME "LFIEMS", ET ABORT EVENTUEL.
C-----------------------------------------------------------------------
C
 1001 CONTINUE
      LLFATA=LLMOER (IREP,KRANG)
C
      IF (LMISOP.OR.LLFATA) THEN
        INIMES=2
        CLNSPR='LFIIST'
        WRITE (UNIT=CLMESS,FMT='(''IREP='',I4,'', KRANG='',I3,
     S         '', LDAPFE= '',L1)') IREP,KRANG,LDAPFE
        CALL LFIEMS (INUMER,INIMES,IREP,LLFATA,CLMESS,CLNSPR,CLACTI)
      ENDIF
C
      RETURN
C
 9010 FORMAT (/,/,T2,110('X'),/,' X',T111,'X',/,' X',T15,
     S 'Statistiques d''Utilisation de l''Unite Logique Indexee',I4,
     S ' (le',I5.2,2('/',I2.2),' a',I3.2,2(':',I2.2),')',T111,'X',
     S /,' X',T15,42('- '),'-',T111,'X',/,' X',T111,'X')
C
 9011 FORMAT (/,/,T2,110('X'),/,' X',T111,'X',/,' X',T15,
     S 'Statistics of Use for LFI Indexed Logical Unit Number',I4,
     S ' (on',I5.2,2('/',I2.2),' at',I3.2,2(':',I2.2),')',T111,'X',
     S /,' X',T15,42('- '),'-',T111,'X',/,' X',T111,'X')
C
 9015 FORMAT (A,/,' X',T111,'X')
C
 9020 FORMAT (' X',T29,
     S '----- Cette Unite Logique est en cours de FERMETURE -----',
     S T111,'X',/,' X',T111,'X')
C
 9021 FORMAT (' X',T30,
     S '----- This Logical Unit is currently being CLOSED -----',
     S T111,'X',/,' X',T111,'X')
C
 9025 FORMAT (' X',T30,
     S '----- Cette Unite Logique est en mode "CREATION" -----',
     S T111,'X',/,' X',T111,'X')
C
 9026 FORMAT (' X',T31,
     S '----- This Logical Unit is in "CREATION" Mode -----',
     S T111,'X',/,' X',T111,'X')
C
 9030 FORMAT (' X  Dernier Sous-Programme utilise: "',A6,
     S '", Code-Reponse correspondant a cet appel:',I4,
     S T111,'X',/,' X',T111,'X')
C
 9031 FORMAT (' X  Name of Last Used SUBROUTINE: "',A6,
     S '", Response Code corresponding to this call:',I4,
     S T111,'X',/,' X',T111,'X')
C
 9040 FORMAT (' X  LONGUEUR TOTALE en mots: du FICHIER=',I9,
     S ', des DONNEES=',I9,', d''un Article "PHYSIQUE"=',I6,T111,'X',
     S /,' X',T111,'X',/,' X  Mots "PERDUS" par l''Utili',
     S 'sation (Articles d''Index inutiles, Trous, Fin du fichier) =',
     S I8,T111,'X',/,' X',T111,'X')
C
 9041 FORMAT (' X  TOTAL LENGTH in words: of FILE=',I9,
     S ', of DATA=',I9,', of a "PHYSICAL" Record=',I6,T111,'X',
     S /,' X',T111,'X',/,' X  Words currently "LOST" by previous ',
     S 'Usage (Unnecessary Index Records, Holes, End of file)=',
     S I8,T111,'X',/,' X',T111,'X')
C
 9050 FORMAT (' X  Nombre de TROUS REPERTORIES: Actuellement',I6,
     S ', dont',I6,' CREE(S) et NON RECYCLE(S) depuis OUVERTURE',
     S T111,'X',/,' X',T111,'X')
C
 9051 FORMAT (' X  Number of HOLES within INDEX: Currently',I6,
     S ', among which',I6,' CREATED and NOT RE-USED since OPENING',
     S T111,'X',/,' X',T111,'X')
C
 9060 FORMAT (' X  Nombre d''ARTICLES LOGIQUES de DONNEES=',I6,
     S ', Longueur Mini/Maxi=',I7,' /',I7,T111,'X',/,' X',T111,'X')
C
 9061 FORMAT (' X  Number of LOGICAL RECORDS of DATA=',I6,
     S ', Minimum/maximum length=',I7,' /',I7,T111,'X',/,' X',T111,'X')
C
 9070 FORMAT (' X  Nombre d''ARTICLES LOGIQUES de DONNEES=',I6,
     S ', Longueur Mini/Maxi (A PRIORI)=',I7,' /',I7,
     S T111,'X',/,' X',T111,'X')
C
 9071 FORMAT (' X  Number of LOGICAL RECORDS of DATA=',I6,
     S ', Minimum/Maximum Length (A PRIORI)=',I7,' /',I7,
     S T111,'X',/,' X',T111,'X')
C
 9080 FORMAT (' X  ',A6,' Ouverture, Nombre de REECRITURES Sur PLACE/',
     S 'Plus COURTES/Plus LONGUES=',I6,2(' /',I6),
     S T111,'X',/,' X',T111,'X')
C
 9081 FORMAT (' X  ',A6,' Opening, Number of RE-WRITE(s): In PLACE/',
     S 'SHORTER/LONGER=',I6,2(' /',I6),
     S T111,'X',/,' X',T111,'X')
C
 9090 FORMAT (' X  ',A40,' le',I5.2,2('/',I2.2),' a',I3.2,2(':',I2.2),
     S T111,'X',/,' X',T111,'X')
C
 9091 FORMAT (' X  ',A36,' on',I5.2,2('/',I2.2),' at',I3.2,2(':',I2.2),
     S T111,'X',/,' X',T111,'X')
C
 9100 FORMAT(' X  Nombre d''ARTICLES LOGIQUES gerables (TROUS compris)',
     S       ' SANS/AVEC DEBORDEMENT =',I7,' /',I7,
     S T111,'X',/,' X',T111,'X')
C
 9101 FORMAT(' X  Number of LOGICAL RECORDS STORE-able (HOLES included)'
     S       ,' WITHOUT/WITH OVERFLOW=',I7,' /',I7,
     S T111,'X',/,' X',T111,'X')
C
 9110 FORMAT (' X  Nombre de Mots ',A11,' demandes ',A10,'/',A11,
     S        '/AU TOTAL=',I9,2(' /',I9),T111,'X',/,' X',T111,'X')
C
 9111 FORMAT (' X  Number of ',A8,' Words requested ',A12,'/',A13,
     S        '/TOTAL=',I9,2(' /',I9),T111,'X',/,' X',T111,'X')
C
 9120 FORMAT (' X  Nombre d''ARTICLES LOGIQUES LUS/ECRITS/RENOMMES/',
     S        'SUPPRIMES depuis Ouverture=',I6,3(' /',I6),
     S T111,'X',/,' X',T111,'X',/,T2,110('X'),/)
C
 9121 FORMAT (' X  Number of LOGICAL RECORDS: READ/WRITTEN/RENAMED/',
     S        'SUPPRESSED since Opening = ',I6,3(' /',I6),
     S T111,'X',/,' X',T111,'X',/,T2,110('X'),/)
C
      END
