      SUBROUTINE LFINAF ( KREP, KNUMER, KNALDO, KNTROU, KNARES, KNAMAX )
#include "lficomt.h"
C****
C        SOUS-PROGRAMME DONNANT DES NOMBRES D'ARTICLES LOGIQUES DIVERS
C     ( DE DONNEES, "TROUS", POSSIBLE, MAXIMUM ) POUR UNE UNITE LOGIQUE
C     OUVERTE POUR LE LOGICIEL DE FICHIERS INDEXES *LFI* .
C**
C    ARGUMENTS : KREP   (SORTIE) ==> CODE-REPONSE DU SOUS-PROGRAMME;
C                KNUMER (ENTREE) ==> NUMERO DE L'UNITE LOGIQUE;
C                KNALDO (SORTIE) ==> NOMBRE D'ARTICLES LOGIQUES
C                                  *DE DONNEES* (TROUS EXCLUS) PRESENTS;
C                KNTROU (SORTIE) ==> NOMBRE D'ARTICLES LOGIQUES QUI SONT
C                                    DEVENUS DES "TROUS", PAR SUITE DE
C                                    REECRITURES D'ARTICLES PLUS LONGUES
C                                    QU'INITIALEMENT, ET QUI N'ONT PAS
C                                    PU ETRE (ENCORE) RECYCLES;
C                KNARES (SORTIE) ==> NOMBRE D'ARTICLES LOGIQUES POUVANT
C                                    ETRE ECRITS DANS LA PARTIE "PRERER-
C                                    VEE" DE L'INDEX (TROUS COMPRIS);
C                KNAMAX (SORTIE) ==> NOMBRE D'ARTICLES LOGIQUES MAXIMUM
C                                    POUVANT ETRE ECRITS SUR L'UNITE
C                                    LOGIQUE, EN "DEBORDANT" AU MAXIMUM
C                                   DE LA PARTIE PRERESERVEE DE L'INDEX.
C                                    ( TROUS COMPRIS )
C
#include "lficom0.h"
#ifndef f77
#include "precision.h"
#endif
#include "lficom1.h"
C
      INTEGER KREP, KNUMER, KNALDO, KNTROU, KNARES, KNAMAX
      INTEGER IRANG, IREP, IFACTM, ILARPH, INALPP, INIMES
C
#include "lficom2.h"
C**
C     1.  -  CONTROLES DU PARAMETRE D'APPEL, PUIS INITIALISATIONS.
C-----------------------------------------------------------------------
C
      CALL LFINUM (KNUMER,IRANG)
C
      IF (IRANG.EQ.0) THEN
        KNTROU=0
        KNALDO=0
        KNARES=0
        KNAMAX=0
        IREP=-1
        GOTO 1001
      ENDIF
C
       IF (LMULTI) CALL LFIVER (VERRUE(IRANG),'ON')
C**
C     2.  -  CALCUL DIRECT DES ARGUMENTS DE SORTIE DU SOUS-PROGRAMME.
C-----------------------------------------------------------------------
C
      IFACTM=MFACTM(IRANG)
      ILARPH=JPLARD*IFACTM
      INALPP=JPNAPP*IFACTM
      KNTROU=MDES1D(IXM(JPNTRU,IRANG))+NBTROU(IRANG)
      KNALDO=MDES1D(IXM(JPNALO,IRANG))-KNTROU
      KNARES=INALPP*MDES1D(IXM(JPNPIR,IRANG))
      KNAMAX=KNARES+INALPP*(ILARPH-JPLDOC)
      IREP=0
C**
C    10.  -  PHASE TERMINALE : MESSAGERIE, AVEC "ABORT" EVENTUEL,
C            VIA LE SOUS-PROGRAMME "LFIEMS" .
C-----------------------------------------------------------------------
C
 1001 CONTINUE
      KREP=IREP
      LLFATA=LLMOER (IREP,IRANG)
C
      IF (IRANG.NE.0) THEN
        NDEROP(IRANG)=12
        NDERCO(IRANG)=IREP
         IF (LMULTI) CALL LFIVER (VERRUE(IRANG),'OFF')
      ENDIF
C
      IF (LLFATA.OR.IXNIMS (IRANG).EQ.2) THEN
        INIMES=2
      ELSE
        RETURN
      ENDIF
C
      CLNSPR='LFINAF'
      WRITE (UNIT=CLMESS,FMT='(''KREP='',I4,'', KNUMER='',I3,
     S       '', KNALDO='',I6,'', KNTROU='',I6,'', KNARES='',I6,
     S       '', KNAMAX='',I6)') KREP,KNUMER,KNALDO,KNTROU,KNARES,KNAMAX
      CALL LFIEMS (KNUMER,INIMES,IREP,LLFATA,CLMESS,CLNSPR,CLACTI)
C
      RETURN
      END
