      SUBROUTINE LFIOEG ( KNIVAU )
#include "lficomt.h"
C****
C        Ce sous-programme permet d'obtenir la valeur courante du NIVEAU
C      GLOBAL de traitement des ERREURS detectees par le logiciel LFI.
C**
C        ARGUMENT : KNIVAU (Sortie) ==> Niveau global de traitement des
C                                       erreurs detectees.
C
C     Valeurs possibles (par defaut, 1):
C
C     0 : Dans ce cas, toute erreur detectee sera fatale, meme si
C         l'erreur joue sur un fichier dont l'option individuelle de
C         traitement des erreurs est a .FALSE. .
C
C     1 : Seules les erreurs "globales" (c'est-a-dire non reliables a un
C         fichier deja ouvert) et les erreurs reliees a un fichier dont
C         l'option individuelle de traitement est .TRUE. seront fatales.
C
C     2 : Passer outre toute erreur detectee, meme si elle correspond
C         a un fichier dont l'option individuelle de traitement est
C         .TRUE. ; noter que dans ce dernier cas le code-reponse ne
C         sera pas nul. Par ailleurs, le code-reponse (-16) echappe a
C         ce mode de controle et est toujours fatal.
C
#include "lficom0.h"
#ifndef f77
#include "precision.h"
#endif
#include "lficom1.h"
C
      INTEGER KNIVAU, INIMES, IREP, INUMER
C
      LOGICAL LLPREA
      SAVE LLPREA
C
      DATA LLPREA /.TRUE./
C
      IF (LLPREA) THEN
        CALL LFIINI (2)
        LLPREA=.FALSE.
      ENDIF
C
      KNIVAU=NERFAG
      INIMES=NIMESG
C
      IF (INIMES.EQ.2) THEN
        IREP=0
        INUMER=JPNIL
        CLNSPR='LFIOEG'
        WRITE (UNIT=CLMESS,FMT='(''KNIVAU='',I2)') KNIVAU
        CALL LFIEMS (INUMER,INIMES,IREP,.FALSE.,CLMESS,CLNSPR,CLACTI)
      ENDIF
C
      RETURN
      END
