      SUBROUTINE LFIREE ( KREP, KRANG, CDNOMA, KLONG, KRPIEX, KARTEX,
     S                    KLONEX, KRPIEC, KARTEC, KPOSEC, KDTROU,
     S                    KLONUT, KRETIN )
#include "lficomt.h"
C****
C        SOUS-PROGRAMME *INTERNE* DU LOGICIEL DE FICHIERS INDEXES LFI
C     RECHERCHE D'UN EMPLACEMENT OU ECRIRE UN ARTICLE LOGIQUE, DANS
C     L'UNITE LOGIQUE CONCERNEE.
C**
C    ARGUMENTS : KREP   (SORTIE) ==> CODE-REPONSE DU SOUS-PROGRAMME;
C                KRANG  (ENTREE) ==> RANG ( DANS LA TABLE *NUMERO* )
C                                    DE L'UNITE LOGIQUE CONCERNEE;
C                CDNOMA (ENTREE) ==> NOM DE L'ARTICLE A RECHERCHER;
C                KLONG  (ENTREE) ==> LONGUEUR DE L'ARTICLE A ECRIRE;
C                KRPIEX (SORTIE) ==> RANG ( DANS LE FICHIER ) DE L'ARTI-
C                                    CLE S'IL EXISTAIT DEJA ( 0 SINON );
C                KARTEX (SORTIE) ==> RANG ( DANS LA PAGE D'INDEX ) DE L'
C                                    ARTICLE S'IL EXISTAIT ( 0 SINON );
C                KLONEX (SORTIE) ==> LONGUEUR DE L'ARTICLE S'IL EXISTAIT
C                                    DEJA ( 0 SINON );
C                KRPIEC (SORTIE) ==> RANG ( DANS LE FICHIER ) DE L'ARTI-
C                                    CLE A ECRIRE;
C                KARTEC (SORTIE) ==> RANG ( DANS LA PAGE D'INDEX ) DE L'
C                                    ARTICLE A ECRIRE;
C                KPOSEC (SORTIE) ==> POSITION ( DANS LE FICHIER ) OU
C                                    COMMENCER A ECRIRE L'ARTICLE;
C                KDTROU (SORTIE) ==> VARIATION DU NOMBRE DE TROUS DANS
C                                    L'INDEX, DUE A CETTE ECRITURE;
C                KLONUT (SORTIE) ==> SI L'ON VA CREER UN TROU DANS L'IN-
C                                    DEX, LONGUEUR TOTALE UTILISABLE DE
C                                    CE TROU;
C                KRETIN (SORTIE) ==> CODE-RETOUR INTERNE.
C*
C    METHODE: SI L'ARTICLE EXISTE DEJA DANS LE FICHIER, ON ESSAIE AUTANT
C             QUE POSSIBLE DE "REECRIRE" SUR PLACE, CE QUI EST POSSIBLE
C             SI L'ON A UNE LONGUEUR D'ARTICLE INFERIEURE OU EGALE A
C             CELLE EXISTANTE, MAIS EST AUSSI POSSIBLE PAR RECYCLAGE
C             DE "TROUS" DE 2 CATEGORIES: EN FIN D'ARTICLE EXISTANT
C             ( AVANT L'ARTICLE LOGIQUE OU L'ARTICLE D'INDEX SUIVANT ),
C             ET/OU S'IL EXISTE UN "TROU" REPERTORIE DANS L'INDEX CORRE-
C             SPONDANT A UN ARTICLE LOGIQUE JUSTE DERRIERE CELUI EXIS-
C             TANT.
C                SI LA REECRITURE N'EST PAS POSSIBLE, ON ESSAIE ALORS DE
C             REUTILISER UN EVENTUEL "TROU" REPERTORIE DANS L'INDEX;
C             EN DESESPOIR DE CAUSE, ON ECRIT EN FIN DE FICHIER.
C
#include "lficom0.h"
#ifndef f77
#include "precision.h"
#endif
#include "lficom1.h"
C
      CHARACTER CDNOMA*(*)
C
      INTEGER KREP, KRANG, KLONG, KRPIEX, KARTEX, KLONEX, KRPIEC, KARTEC
      INTEGER KPOSEC, KDTROU, KLONUT, ILCDNO, IRANG, ILTSUF, INTTRU, J
      INTEGER INBALO, INBPIR, IFACTM, ILARPH, INALPP, INTPPI, IRNGSU
      INTEGER INPPIM, INPIME, INTROU, INPPI1, IDEBEX, IARTIC, IRGPIF
      INTEGER INALPI, INPAGE, IRGPIM, IRPIFN, ILFORC, INBVAL, IPOSEX
      INTEGER IPOSDX, IRECPI, ILSUIV, IPOSUI, IRGPI, IRPIMS, INPILE
      INTEGER IRNGMS, INTRPI, ILTROU, IPTROU, IRPITR, IARTTR, IPOSTR
      INTEGER IRPIMD, IRPIFD, INALDP, IRETOU, INIMES, INUMER, IRANGM
      INTEGER IEXPLO (JPNPIA+JPNPIS+1), INDICE (JPNAPX), KRETIN, IRETIN
C
      LOGICAL LLTSUF, LLTOPT, LLTTRU, LLRCHA
C
#include "lficom2.h"
C**
C     1.  -  CONTROLES DES PARAMETRES D'APPEL ET INITIALISATIONS.
C-----------------------------------------------------------------------
C
      ILCDNO=LEN (CDNOMA)
C
      IF (KRANG.LE.0.OR.KRANG.GT.JPNXFI.OR.KLONG.LE.0.OR.
     S    ILCDNO.LE.0.OR.ILCDNO.GT.JPNCPN.OR.CDNOMA.EQ.' ') THEN
        KREP=-16
        GOTO 1001
      ENDIF
C
      IRANG=KRANG
      KREP=0
      LLTSUF=.FALSE.
      LLTOPT=.FALSE.
      KARTEX=0
      KARTEC=0
      KRPIEC=0
      KRPIEX=0
      KLONEX=0
      KLONUT=JPNIL
      IRETOU=0
      ILTSUF=0
      INTTRU=MDES1D(IXM(JPNTRU,IRANG))+NBTROU(IRANG)
      INBALO=MDES1D(IXM(JPNALO,IRANG))
      INBPIR=MDES1D(IXM(JPNPIR,IRANG))
      LLTTRU=INTTRU.EQ.0
      IFACTM=MFACTM(IRANG)
      ILARPH=JPLARD*IFACTM
      INALPP=JPNAPP*IFACTM
      INTPPI=(INBALO-1+INALPP)/INALPP
      IF (LMISOP) PRINT *,
     S        'INBALO= ',INBALO,', INTTRU= ',INTTRU,', INTPPI= ',INTPPI,
     S        ', INBPIR= ',INBPIR
C
      IF (INBALO.EQ.0) GOTO 240
C
      IRNGSU=0
      IRPIFN=1
      INPPIM=NPPIMM(IRANG)
      INPIME=0
      INTROU=0
C
C**
C     2.  -  EXPLORATION DES (PAIRES DE) PAGES ET ARTICLES D'INDEX,
C            A LA RECHERCHE DE L'ARTICLE ET/OU D'UN "TROU" DANS L'INDEX,
C            SUFFISANT POUR Y "CASER" L'ARTICLE. ( ON COMMENCE
C            PAR EXPLORER LES PAGES D'INDEX )
C-----------------------------------------------------------------------
C
      INPPI1=INPPIM
      LLRCHA=.TRUE.
C
      IF (NPODPI(IRANG).EQ.2) THEN
        IDEBEX=3
      ELSE
        IDEBEX=2
      ENDIF
C
      IF (LLTTRU) THEN
C
        CALL LFIRAN (KREP,IRANG,CDNOMA,IRGPIM,IARTIC,IRETIN)
C
        IF (IRETIN.EQ.1) THEN
          GOTO 903
        ELSEIF (IRETIN.EQ.2) THEN
          GOTO 904
        ELSEIF (IRETIN.NE.0) THEN
          GOTO 1001
        ELSEIF (IARTIC.NE.0) THEN
C
C         ARTICLE TROUVE.
C
          IRGPIF=MRGPIF(IRGPIM)
          INALPI=MIN0 (INALPP,INBALO-(IRGPIF-1)*INALPP)
C
C         La ligne ci-dessous sert a eviter les ennuis entre les
C         etiquettes 213 et 215.
C
          INPAGE=INTPPI+1
          GOTO 212
        ELSE
C
C         IL VA FALLOIR CREER UN ARTICLE SUPPLEMENTAIRE.
C
          GOTO 240
        ENDIF
C
      ENDIF
C
C     ... DEBUT D'UNE STRUCTURE DE TYPE "BOUCLE" SUR INPAGE,
C         QUI NE PEUT PAS (PLUS) ETRE UNE BOUCLE "DO" A PARTIR DU
C         MOMENT OU ON VEUT UTILISER, DES QUE POSSIBLE, "LFIRAN"
C         POUR UNE RECHERCHE D'ARTICLE MOINS COUTEUSE, SURTOUT LORSQUE
C         L'ARTICLE QUE L'ON CHERCHE ETAIT LE DERNIER TRAITE ...
C
      INPAGE=1
C
  201 CONTINUE
C
      IF (INPAGE.LE.INPPI1) THEN
C
C           IL S'AGIT D'UNE EXPLORATION EN MEMOIRE ( PAGES D'INDEX ) .
C
        IRGPIM=MRGPIM(INPAGE,IRANG)
        IRGPIF=MRGPIF(IRGPIM)
        INPIME=INPIME+1
        IEXPLO(INPIME)=IRGPIF
        IF (IRGPIF.EQ.(IRPIFN+1)) IRPIFN=IRGPIF
      ELSE
C
C           IL S'AGIT D'UNE EXPLORATION "HORS MEMOIRE";
C         ON CHERCHE LA PROCHAINE P.A.I. NON EXPLOREE .
C
        IF (INPAGE.EQ.INPPI1+1) THEN
C
          IF (IRNGSU.EQ.0) THEN
            IRGPIF=IRPIFN
          ELSE
C
C          Cas ou il y a eu, dans la recherche "en memoire",
C        recyclage d'une P.P.I. que l'on avait exploree precedemment.
C          Cette P.P.I. est restee sur place, n'a pas ete exploree,
C        et il serait bete de l'oublier, au risque de la dupliquer...
C
            IRGPIM=MRGPIM(IRNGSU,IRANG)
            IRGPIF=MRGPIF(IRGPIM)
            INPIME=INPIME+1
            IEXPLO(INPIME)=IRGPIF
            IF (IRGPIF.EQ.(IRPIFN+1)) IRPIFN=IRGPIF
            GOTO 210
          ENDIF
C
        ENDIF
C
  202   CONTINUE
        IRGPIF=IRGPIF+1
C
        DO 203 J=IDEBEX,INPIME
        IF (IEXPLO(J).EQ.IRGPIF) GOTO 202
  203   CONTINUE
C
        ILFORC=1
        INPILE=1
        CALL LFIPIM (KREP,IRANG,IRANGM,IRGPIM,IRGPIF,ILFORC,INPILE,
     S               IRETIN)
C
        IF (IRETIN.EQ.1) THEN
          GOTO 903
        ELSEIF (IRETIN.EQ.2) THEN
          GOTO 904
        ELSEIF (IRETIN.NE.0) THEN
          GOTO 1001
        ENDIF
C
        INPPIM=MAX0 (INPPIM,IRANGM)
      ENDIF
C*
C     2.1 -  "BOUCLE" DE RECHERCHE SUR LES ARTICLES PRESENTS DANS
C             LA (PAIRE DE) PAGE D'INDEX DE RANG IRGPIF DANS LE FICHIER.
C-----------------------------------------------------------------------
C
  210 CONTINUE
      INALPI=MIN0 (INALPP,INBALO-(IRGPIF-1)*INALPP)
      IARTIC=0
C
      IF (LLRCHA) THEN
C
        DO 211 J=1,INALPI
C
        IF (CNOMAR(IXC(J,IRGPIM)).EQ.CDNOMA) THEN
          IARTIC=J
          GOTO 212
        ENDIF
C
  211   CONTINUE
C
      ENDIF
C
  212 CONTINUE
C
      IF (IARTIC.NE.0) THEN
C
C        ON A TROUVE DANS LE FICHIER UN ARTICLE DE MEME NOM QUE CELUI A
C        ECRIRE.
C
        LLRCHA=.FALSE.
C
        IF (.NOT.LPHASP(IRGPIM)) THEN
C
          CALL LFIPHA (KREP,IRANG,IRGPIM,IRETIN)
C
          IF (IRETIN.EQ.1) THEN
            GOTO 903
          ELSEIF (IRETIN.EQ.2) THEN
            GOTO 904
          ELSEIF (IRETIN.NE.0) THEN
            GOTO 1001
          ENDIF
C
        ENDIF
C
        KRPIEX=IRGPIF
        KLONEX=MLGPOS(IXM(2*IARTIC-1,IRGPIM))
        IPOSEX=MLGPOS(IXM(2*IARTIC,IRGPIM))
        KARTEX=IARTIC
C
        IF (KLONG.LE.KLONEX) THEN
C
C       L'ARTICLE TROUVE EST AU MOINS AUSSI LONG QUE CELUI QUE L'ON VEUT
C       ECRIRE: UNE ECRITURE AU MEME EMPLACEMENT EST DONC POSSIBLE.
C
          KRPIEC=IRGPIF
          KARTEC=IARTIC
          KPOSEC=IPOSEX
          GOTO 240
        ELSE
C
C     CAS DE REECRITURE + LONGUE QUE L'ARTICLE EXISTANT SUR LE FICHIER.
C
          IPOSDX=MLGPOS(IXM(2*IARTIC,IRGPIM))+KLONG-1
C
          IF (IARTIC.EQ.1.AND.IRGPIF.GT.INBPIR) THEN
C
C            IL Y A EU DEBORDEMENT DES P.A.I. PREALLOUEES, ET IL Y A
C        EN OUTRE UNE P.A.I. SUR LE FICHIER, JUSTE DERRIERE L'ARTICLE
C        LOGIQUE AUQUEL ON S'INTERESSE. ON REGARDE S'IL Y A ASSEZ DE
C        PLACE AVANT LA P.A.I. POUR UNE REECRITURE AU MEME ENDROIT.
C        ( P.A.I. = PAIRE D'ARTICLES D'INDEX )
C
            IRECPI=MDES1D(IXM(ILARPH+1-(IRGPIF-INBPIR),IRANG))
            KLONUT=ILARPH*(IRECPI-1)-IPOSEX+1
C
            IF (KLONG.LE.KLONUT) THEN
              KRPIEC=IRGPIF
              KARTEC=IARTIC
              KPOSEC=IPOSEX
              GOTO 240
            ELSE
              GOTO 216
            ENDIF
C
          ELSEIF (IARTIC.EQ.INALPI.AND.IRGPIF.EQ.INTPPI) THEN
C
C           CAS OU L'ARTICLE TROUVE EST LE DERNIER ARTICLE LOGIQUE DE
C        DONNEES, SANS P.A.I. JUSTE DERRIERE. IL Y A DE LA PLACE DONC...
C
            KRPIEC=IRGPIF
            KARTEC=IARTIC
            KPOSEC=IPOSEX
            GOTO 240
          ENDIF
C
        ENDIF
C
C            EN ARRIVANT ICI, ON EST DONC SUR QUE L'ARTICLE TROUVE
C          N'EST PAS LE DERNIER ARTICLE LOGIQUE.
C
C     ON VA REGARDER SI, PAR CHANCE, L'ARTICLE LOGIQUE SUIVANT N'EST
C     PAS UN TROU SUFFISANT POUR "CASER" L'EXCEDENT DE DONNEES,
C     OU S'IL N'Y A PAS UN TROU DE DONNEES ( NON ASSOCIE A UN TROU DANS
C     LA PARTIE "NOMS" DE L'INDEX ) SUFFISANT EN FIN D'ARTICLE EXISTANT,
C     AVANT L'ARTICLE LOGIQUE SUIVANT...
C
        IF (IARTIC.NE.INALPI) THEN
C
C             L'ARTICLE SUIVANT EST DANS LA MEME PAGE D'INDEX...
C
          ILSUIV=MLGPOS(IXM(2*IARTIC+1,IRGPIM))
          IPOSUI=MLGPOS(IXM(2*IARTIC+2,IRGPIM))
          KLONUT=IPOSUI-IPOSEX
C
          IF (KLONG.LE.KLONUT) THEN
C
C     ... ET IL Y A UN "TROU" SUFFISANT AVANT CET ARTICLE POUR POUVOIR
C         ECRIRE LES DONNEES EXCEDENTAIRES.
C
            KRPIEC=IRGPIF
            KARTEC=IARTIC
            KPOSEC=IPOSEX
            GOTO 240
C
          ELSEIF (CNOMAR(IXC(IARTIC+1,IRGPIM)).EQ.' '
     S            .AND.KLONG.LE.(KLONUT+ILSUIV)) THEN
C
C     ... ET C'EST UN TROU QUI PERMET, AVEC L'AIDE EVENTUELLE
C         D'UNE ZONE DE DONNEES "MORTE" ENTRE LES 2 ARTICLES,
C         DE MENAGER UNE PLACE SUFFISANTE POUR L'EXCES DE DONNEES.
C
            MLGPOS(IXM(2*IARTIC+1,IRGPIM))=IPOSUI+ILSUIV-(IPOSDX+1)
            MLGPOS(IXM(2*IARTIC+2,IRGPIM))=IPOSDX+1
            LECRPI(IRGPIM,2)=.TRUE.
            KRPIEC=IRGPIF
            KARTEC=IARTIC
            KPOSEC=IPOSEX
C
            IF (MLGPOS(IXM(2*IARTIC+1,IRGPIM)).EQ.0) THEN
              GOTO 230
            ELSE
              GOTO 240
            ENDIF
C
          ENDIF
C
C     ... L'ARTICLE SUIVANT N'EST PAS EXPLOITABLE POUR ECRIRE L'EXCES
C         DE DONNEES.
C
          GOTO 216
        ELSE
C
C     L'ARTICLE TROUVE EST CERTES TROP COURT, MAIS IL EST EN PLUS EN FIN
C     DE PAGE D'INDEX...
C
          DO 213 J=2,INPPIM
          IRGPI=MRGPIM(J,IRANG)
C
          IF (MRGPIF(IRGPI).EQ.(IRGPIF+1)) THEN
C
            IRPIMS=IRGPI
C
            IF (.NOT.LPHASP(IRPIMS)) THEN
C
              CALL LFIPHA (KREP,IRANG,IRPIMS,IRETIN)
C
              IF (IRETIN.EQ.1) THEN
                GOTO 903
              ELSEIF (IRETIN.EQ.2) THEN
                GOTO 904
              ELSEIF (IRETIN.NE.0) THEN
                GOTO 1001
              ENDIF
C
            ENDIF
C
            GOTO 215
C
          ENDIF
C
  213     CONTINUE
C
C             LA P.A.I. SUIVANTE (EN RANG DANS LE FICHIER) N'EST PAS
C          EN MEMOIRE; DECIDEMENT, CELA SE GATE ! ... ON L'Y MET.
C
C             Noter que ce cas de figure ne peut se presenter q'une
C          seule fois par exploration de l'index.
C
          INPILE=2
          CALL LFIPIM (KREP,IRANG,IRNGMS,IRPIMS,IRGPIF+1,IRGPIF,INPILE,
     S                 IRETIN)
C
          IF (IRETIN.EQ.1) THEN
            GOTO 903
          ELSEIF (IRETIN.EQ.2) THEN
            GOTO 904
          ELSEIF (IRETIN.NE.0) THEN
            GOTO 1001
          ENDIF
C
          IF (INPAGE.LE.INPPIM) THEN
C
C               On est dans le cadre d'une exploration "en memoire"...
C
            IF (IRNGMS.GT.INPPIM) THEN
C
C               ... et il y aura une P.P.I. a explorer en plus,
C                   a la fin du balayage "en memoire".
C
              INPPI1=INPPI1+1
            ELSEIF (IRNGMS.LT.INPAGE) THEN
C
C               ... et il y aura une P.P.I. a explorer en plus,
C                   mais apres le balayage "en memoire".
C
              IRNGSU=IRNGMS
            ENDIF
C
          ENDIF
C
          INPPIM=MAX0 (INPPIM,IRNGMS)
C
  215     CONTINUE
C
C            LA PAIRE D'ARTICLES D'INDEX SUIVANTE EST EN MEMOIRE.
C
          ILSUIV=MLGPOS(IXM(1,IRPIMS))
          IPOSUI=MLGPOS(IXM(2,IRPIMS))
          KLONUT=IPOSUI-IPOSEX
C
          IF (KLONG.LE.KLONUT) THEN
C
C     ... ET IL Y A UN "TROU" SUFFISANT AVANT CETTE PAIRE POUR POUVOIR
C         ECRIRE LES DONNEES EXCEDENTAIRES.
C
            KRPIEC=IRGPIF
            KARTEC=IARTIC
            KPOSEC=IPOSEX
            GOTO 240
C
          ELSEIF (CNOMAR(IXC(1,IRPIMS)).EQ.' '
     S           .AND.KLONG.LE.(KLONUT+ILSUIV)) THEN
C
C     ... ET C'EST UN TROU QUI PERMET, AVEC L'AIDE EVENTUELLE
C         D'UNE ZONE DE DONNEES "MORTE" ENTRE LES 2 ARTICLES,
C         DE MENAGER UNE PLACE SUFFISANTE POUR L'EXCES DE DONNEES.
C
            MLGPOS(IXM(1,IRPIMS))=IPOSUI+ILSUIV-(IPOSDX+1)
            MLGPOS(IXM(2,IRPIMS))=IPOSDX+1
            LECRPI(IRPIMS,2)=.TRUE.
            KRPIEC=IRGPIF
            KARTEC=IARTIC
            KPOSEC=IPOSEX
C
            IF (MLGPOS(IXM(1,IRPIMS)).EQ.0) THEN
              GOTO 230
            ELSE
              GOTO 240
            ENDIF
C
          ENDIF
C
C              SI ON ARRIVE ICI, IL FAUT PASSER A LA PAGE SUIVANTE .
C
        ENDIF
C
      ENDIF
C
  216 CONTINUE
C
C        RECHERCHE EVENTUELLE DE TROUS D'INDEX DE LONGUEUR ADEQUATE.
C
      IF (LLTTRU.OR.LLTOPT) THEN
C
        IF (.NOT.LLRCHA) THEN
          GOTO 240
        ELSE
          GOTO 229
        ENDIF
C
      ELSE
        INTRPI=0
C
        DO 217 J=1,INALPI
C
        IF (CNOMAR(IXC(J,IRGPIM)).EQ.' ') THEN
          INTRPI=INTRPI+1
          INDICE(INTRPI)=J
        ENDIF
C
  217   CONTINUE
C
      ENDIF
C
      IF (INTRPI.NE.0) THEN
C
        IF (.NOT.LPHASP(IRGPIM)) THEN
C
          CALL LFIPHA (KREP,IRANG,IRGPIM,IRETIN)
C
          IF (IRETIN.EQ.1) THEN
            GOTO 903
          ELSEIF (IRETIN.EQ.2) THEN
            GOTO 904
          ELSEIF (IRETIN.NE.0) THEN
            GOTO 1001
          ENDIF
C
        ENDIF
C
        DO 218 J=1,INTRPI
        IARTIC=INDICE(J)
        ILTROU=MLGPOS(IXM(2*IARTIC-1,IRGPIM))
        IPTROU=MLGPOS(IXM(2*IARTIC,IRGPIM))
C
        IF (ILTROU.GE.KLONG) THEN
C
C             "TROU" D'INDEX DE LONGUEUR SUFFISANTE POUR L'ARTICLE.
C
          IF (.NOT.LLTSUF) THEN
            LLTSUF=.TRUE.
            ILTSUF=ILTROU+1
          ENDIF
C
          IF (ILTROU.LT.ILTSUF) THEN
            ILTSUF=ILTROU
            IRPITR=IRGPIF
            IARTTR=IARTIC
            IPOSTR=IPTROU
          ENDIF
C
          LLTOPT=ILTSUF.EQ.KLONG
        ENDIF
C
  218   CONTINUE
C
        INTROU=INTROU+INTRPI
        LLTTRU=INTROU.EQ.INTTRU
      ENDIF
C
C      SI L'ARTICLE A ETE TROUVE PRECEDEMMENT DANS LE FICHIER MAIS TROP
C     COURT, ET SI ON A EXPLORE TOUS LES TROUS REFERENCES DANS L'INDEX,
C     ON ARRETE L'EXPLORATION DE L'INDEX.
C
      IF (LLTTRU.AND.KARTEX.NE.0) GOTO 240
C
C     .... FIN DE "BOUCLE", ON REMONTE POUR UNE EVENTUELLE SUITE ...
C
  229 CONTINUE
      INPAGE=INPAGE+1
C
      IF (INPAGE.LE.INTPPI) THEN
        GOTO 201
      ELSE
        GOTO 240
      ENDIF
C
  230 CONTINUE
C*
C     2.3 - CAS OU L'ON A CREE UN TROU DE LONGUEUR NULLE DANS L'INDEX
C           ON STOCKE DE QUOI S'EN OCCUPER PLUS TARD, A LA FERMETURE.
C-----------------------------------------------------------------------
C
      IF (NTRULZ(IRANG).EQ.0) THEN
        NRFPTZ(IRANG)=IPOSEX
        NRFDTZ(IRANG)=IPOSEX
      ELSE
        NRFPTZ(IRANG)=MIN0 (NRFPTZ(IRANG),IPOSEX)
        NRFDTZ(IRANG)=MAX0 (NRFDTZ(IRANG),IPOSEX)
      ENDIF
C
      NTRULZ(IRANG)=NTRULZ(IRANG)+1
C
  240 CONTINUE
      IF (LMISOP) PRINT *,'LFIREE - APRES ETIQUETTE 240'
C*
C     2.4 - CALCUL DE LA VARIATION DU NOMBRE DE TROUS REFERENCES
C           DANS L'INDEX.
C-----------------------------------------------------------------------
C
      IF (KARTEX.NE.0.AND.KARTEC.EQ.0.AND..NOT.LLTSUF) THEN
        KDTROU=1
      ELSEIF (KARTEX.EQ.0.AND.LLTSUF) THEN
        KDTROU=-1
      ELSE
        KDTROU=0
      ENDIF
C*
C     2.5  -   QUAND AUCUN EMPLACEMENT CONVENABLE N'A ETE TROUVE,
C              IL RESTE A DEFINIR LE RANG DE L'ARTICLE DANS LE FICHIER,
C              AINSI QUE LA POSITION DU PREMIER MOT DE DONNEES A ECRIRE.
C-----------------------------------------------------------------------
C
      IF (KARTEC.EQ.0) THEN
C
        IF (LLTSUF) THEN
          KRPIEC=IRPITR
          KARTEC=IARTTR
          KPOSEC=IPOSTR
        ELSE
          KRPIEC=1+INBALO/INALPP
          KARTEC=INBALO+1-INALPP*(KRPIEC-1)
C
          IF (NALDPI(IRANG).EQ.INALPP
     S        .AND.INTPPI.EQ.(INBPIR+ILARPH-JPLDOC)) THEN
            KREP=-17
            GOTO 1001
          ENDIF
C
C     DEFINITION DE LA POSITION OU ECRIRE, DANS LE CAS D'UN ARTICLE
C     LOGIQUE SUPPLEMENTAIRE.
C
          IF (INBALO.EQ.0) THEN
            KPOSEC=(1+2*INBPIR)*ILARPH+1
          ELSE
            IRPIMD=MRGPIM(NPODPI(IRANG),IRANG)
            INALDP=NALDPI(IRANG)
            KPOSEC=MLGPOS(IXM(2*INALDP,IRPIMD))
     S             +MLGPOS(IXM(2*INALDP-1,IRPIMD))
C
            IF (INTPPI.GT.INBPIR) THEN
              IRPIFD=MDES1D(IXM(ILARPH+1-(INTPPI-INBPIR),IRANG))+1
              KPOSEC=MAX0 (KPOSEC,1+ILARPH*IRPIFD)
            ENDIF
C
          ENDIF
C
        ENDIF
C
      ENDIF
C
      GOTO 1001
C**
C     9.  - CI-DESSOUS, ETIQUETTES DE BRANCHEMENT EN CAS D'ERREUR E/S.
C      AU CAS OU, ON FORCE LE CODE-REPONSE ENTREE/SORTIE A ETRE POSITIF.
C-----------------------------------------------------------------------
C
  903 CONTINUE
      IRETOU=1
      CLACTI='WRITE'
      GOTO 909
C
  904 CONTINUE
      IRETOU=2
      CLACTI='READ'
C
  909 CONTINUE
      KREP=IABS (KREP)
C**
C    10.  -  PHASE TERMINALE : MESSAGERIE INTERNE EVENTUELLE,
C            VIA LE SOUS-PROGRAMME "LFIEMS", PUIS RETOUR.
C-----------------------------------------------------------------------
C
 1001 CONTINUE
      LLFATA=LLMOER (KREP,KRANG)
C
      IF (KREP.EQ.0) THEN
        KRETIN=0
      ELSEIF (KREP.GT.0) THEN
        KRETIN=IRETOU
      ELSE
        KRETIN=3
      ENDIF
C
      IF (LMISOP.OR.LLFATA) THEN
        INIMES=2
        CLNSPR='LFIREE'
        WRITE (UNIT=CLMESS,FMT='(''ARGUMENTS='',I4,'','',I3,'','''''',
     S         A,'''''','',I7,'','',I4,'','',I4,'','',I7,'','',I4,'','',
     S         I4,'','',I9,'','',SP,I2,SS,'','',I7,'','',I2)')
     S  KREP,KRANG,CDNOMA,KLONG,KRPIEX,KARTEX,KLONEX,
     S  KRPIEC,KARTEC,KPOSEC,KDTROU,KLONUT,KRETIN
        INUMER=NUMERO(KRANG)
        CALL LFIEMS (INUMER,INIMES,KREP,.FALSE.,CLMESS,CLNSPR,CLACTI)
      ENDIF
C
      RETURN
C
      END
