MODULE YOMECEARTH

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------
!*    Flag to tell if we are doing a coupled run with EC-EARTH

LOGICAL :: LECEARTH = .FALSE.
LOGICAL :: LECEARTH_UNCOUP = .FALSE.
LOGICAL :: LAMIP = .FALSE.
LOGICAL :: LTM5 = .FALSE.
LOGICAL :: LLPJG = .FALSE.
LOGICAL :: LLPJGFB = .FALSE.
LOGICAL :: LPISM =.FALSE.

! should the 4 components of the MODIS albedo be read from the ICMCL file
! LRDALB is set in namelist NAMMCC
LOGICAL :: LRDALB = .FALSE.

! should vegetation cover and type be read from the ICMCL file
! LRDVEG is set in namelist NAMMCC
! LRDVEG is not used if LLPJGFB=TRUE
LOGICAL :: LRDVEG = .TRUE.

! select method for computing the effective vegetation fraction
! N_COMPUTE_EFF_VEG_FRACTION = 0        don't compute eff veg cover, input is
!                                       already eff veg cover (this is the case
!                                       for vegetation from LPJG) 
!
! N_COMPUTE_EFF_VEG_FRACTION = 1        compute eff veg cover with
!                                       climatological veg density (default in
!                                       IFS)
!
! N_COMPUTE_EFF_VEG_FRACTION = 2        compute eff veg cover with LAI as
!                                       described in #185
!
! N_COMPUTE_EFF_VEG_FRACTION is set in namelist NAEPHY
INTEGER :: N_COMPUTE_EFF_VEG_FRACTION = 1

! LPISM activates coupling to PISM ice sheet model (including surface melt of snow-free land ice surface)
! LPISM is set in namelist NAMMCC: 
! The variable snow albedo can be applied over land ice which can be either read in from the initial file (when LRDLANDICE is on) 
! or is defined as the snow depth exceeding a certain threshold (9 meters) 
! LVAR_SNOW_ALB is set in namelist NAMMCC
LOGICAL :: LLANDICE = .FALSE.

! LRDLANDICE is set in namelist NAMMCC
! IF LRDLANDICE is activated, an ice sheet mask is read in from the initial ICMGG file
LOGICAL :: LRDLANDICE = .FALSE.

END MODULE YOMECEARTH

