!**** PRISM_DUMMY_MOD.F90
!
!     Purpose.
!     --------
!
!     
!     Contains   
!     ----------
!     
!      MODULE PRISM_CONSTANTS 
!
!     Reference:
!     ---------
!       S. Valcke, 2006: OASIS4 User Guide  
!       PRISM Support Initiative Report No 3,
!       CERFACS, Toulouse, France, 64 pp.
!
!     Author:
!     -------
!       Johannes Flemming 
!
!     Modifications.
!     --------------

!**************************************************************************

MODULE YOMPRISM

USE PARKIND1 , ONLY : JPIM , JPRB  
IMPLICIT NONE
SAVE
  
   TYPE PRISM_Time_Struct
      REAL(KIND=JPRB)   :: second
      INTEGER(KIND=JPIM)            :: minute
      INTEGER(KIND=JPIM)            :: hour
      INTEGER(KIND=JPIM)            :: day
      INTEGER(KIND=JPIM)            :: month
      INTEGER(KIND=JPIM)            :: year
   END TYPE PRISM_Time_Struct

 
   TYPE(PRISM_Time_Struct) :: PRISM_Initial_date
   TYPE(PRISM_Time_Struct) :: PRISM_Jobstart_date
   TYPE(PRISM_Time_Struct) :: PRISM_Jobend_date

   INTEGER(KIND=JPIM), PARAMETER :: PRISM_Gridless                = 8
   INTEGER(KIND=JPIM), PARAMETER :: PRISM_Gaussreduced_regvrt   = 9
   INTEGER(KIND=JPIM), PARAMETER :: PRISM_Double_Precision =  5
   INTEGER(KIND=JPIM), PARAMETER :: PRISM_Undefined = -65535

END MODULE YOMPRISM

