!OPTIONS NODOUBLE
subroutine longa(cdcar,knivv)
! --------------------------------------------------------------------------
! **** *LONGA  * Type d'article DDH > nombre de niveaux correspondant.
! --------------------------------------------------------------------------
! Sujet:
! ------
! Arguments explicites: /
! ---------------------
! Arguments implicites: /
! ---------------------
! Methode:
! --------
! Externes: /
! ---------
! Original :
! ----------
! 92-12-07, J.M. Piriou.
!
! Modifications:
! --------------
!
! --------------------------------------------------------------------------
implicit none
CHARACTER*1 cdcar
INTEGER(KIND=4) :: KNIVV

! Determination de la longueur de champ
if(cdcar == 'V') then
	! Champ de type variable: N niveaux.
	knivv=0
elseif(cdcar == 'T') then
	! Champ de type tendance: N niveaux.
	knivv=0
elseif(cdcar == 'F') then
	! Champ de type flux    : N+1 niveaux.
	knivv=1
elseif(cdcar == 'P') then
	! Champ de type cumul de masse: N niveaux.
	knivv=0
else
	! Attention: cas de champ non prevu.
	print*,'ddht/LONGA/ATTENTION:'
	print*,'cdcar=',cdcar
	print*,'Type de champ non prevu.'
	knivv=-1
endif
end




program ddht
! --------------------------------------------------------------------------
! **** *ddht   * DDH-Transformations: utilitaires de somme, difference, etc.
! --------------------------------------------------------------------------
! Sujet:
! ------
! Arguments explicites: /
! ---------------------
! Arguments implicites: /
! ---------------------
! Methode:
! --------
! Externes: /
! ---------
! Original :
! ----------
! 92-03-01, J.M. Piriou.
!
! Modifications:
! --------------
! 92-12-04, J.M. Piriou: adaptation au calcul sur CRAY.
! 94-10-27, J.M. Piriou: adaptation au calcul sur lfa.
! 96-02-14, J.M. Piriou: implmentation de la sparation
! en termes principal et complmentaire.
! 97-02-10, J.M. Piriou: implmentation de la fonctionnalit calculatrice
! dirige par le fichier-liste.
! --------------------------------------------------------------------------
implicit none

#include"ddhpar.h"
#include"ddht_yom_ent.h"
CHARACTER*200 :: CGCONF
CHARACTER*200 :: CGNFE1
CHARACTER*200 :: CGNFE2
CHARACTER*200 :: CGNFLC,clficc
CHARACTER*200 :: CLLOC,cli,cllis,cllisde,cgnfso,clc

LOGICAL :: LGDEBU
LOGICAL :: LGFILAF,llex
LOGICAL :: LGRENS
CHARACTER*240 clarg(jparg)
CHARACTER *80 cllisct(jpnomct)
CHARACTER *80 clmot(60)
CHARACTER *03 clconvs
INTEGER(KIND=4) :: IDIM
INTEGER(KIND=4) :: IERR
INTEGER(KIND=4) :: ILARG
INTEGER(KIND=4) :: ILLOC
INTEGER(KIND=4) :: JARG
LOGICAL :: LLPREMR
LOGICAL :: LLTOUS
INTEGER(KIND=4) :: ILISCT
INTEGER(KIND=4) :: IMES
INTEGER(KIND=4) :: IUL1
INTEGER(KIND=4) :: IUL2
INTEGER(KIND=4) :: IUL3
INTEGER(KIND=4) :: IULFICC
INTEGER(KIND=4) :: JPROD
CHARACTER*200 :: CLNAMX1
INTEGER(KIND=4) :: IFINL
INTEGER(KIND=4) :: ILISCT0
INTEGER(KIND=4) :: ILLIS
INTEGER(KIND=4) :: IPLUS
INTEGER(KIND=4) :: IREP
INTEGER(KIND=4) :: JLISCT
INTEGER(KIND=4) :: IBASE1
INTEGER(KIND=4) :: IDOM1
INTEGER(KIND=4) :: ILEV1
INTEGER(KIND=4) :: ILONG
CHARACTER*200 :: CLTYPE
INTEGER(KIND=4) :: IMAXV1
INTEGER(KIND=4) :: INDOMA
REAL(KIND=8) :: ZECH1
CHARACTER*200 :: CLADCOU
CHARACTER*200 :: CLNAMX2
INTEGER(KIND=4) :: JDOC
REAL(KIND=8) :: ZECHDV1
CHARACTER*200 :: CLNAMX3
CHARACTER*200 :: CLTITA
INTEGER(KIND=4) :: IBASE3
INTEGER(KIND=4) :: IDOM2
INTEGER(KIND=4) :: IDOM3
INTEGER(KIND=4) :: IECARTM
INTEGER(KIND=4) :: IERRD
INTEGER(KIND=4) :: ILC
INTEGER(KIND=4) :: ILEV2
INTEGER(KIND=4) :: ILEV3
INTEGER(KIND=4) :: ILMOT
INTEGER(KIND=4) :: JDATE
INTEGER(KIND=4) :: JINDOMA
INTEGER(KIND=4) :: IB
INTEGER(KIND=4) :: IDOMCOU
INTEGER(KIND=4) :: IERR1
INTEGER(KIND=4) :: IERR2
INTEGER(KIND=4) :: ILART
INTEGER(KIND=4) :: ILEV
INTEGER(KIND=4) :: ILEVCOU
INTEGER(KIND=4) :: ILONES
INTEGER(KIND=4) :: IMOD
INTEGER(KIND=4) :: IMODV
INTEGER(KIND=4) :: INIVV
INTEGER(KIND=4) :: INOMNS
INTEGER(KIND=4) :: IPROD3
INTEGER(KIND=4) :: J1
INTEGER(KIND=4) :: J2
INTEGER(KIND=4) :: JB
INTEGER(KIND=4) :: JLEV
REAL(KIND=8) :: ZNORM
REAL(KIND=8) :: ZSOM
REAL(KIND=8) :: ZTMP
REAL(KIND=8) :: ZVAL
INTEGER(KIND=4) :: JMOT
REAL(KIND=8) :: ZECH2
REAL(KIND=8) :: ZECH3
REAL(KIND=8) :: ZECHDV2
REAL(KIND=8) :: ZECHDV3

!
INTEGER(KIND=4) idatef1(11) ! documentation sur les dates.
INTEGER(KIND=4) idatef2(11)
INTEGER(KIND=4) idatef3(11),jdom
!
INTEGER(KIND=4) idocfi1(17) ! documentation sur les dimensions des champs diag.
INTEGER(KIND=4) idocfi2(17)
INTEGER(KIND=4) idocfi3(17)
!
INTEGER(KIND=4) idoma(jpdom) ! domaine a extraire (option -cEXTRAIT_DOMAIN).
!
REAL(KIND=8) zdocd1(jpdoc,jpdom) ! documentation sur les domaines.
REAL(KIND=8) zdocd3(jpdoc,jpdom) ! documentation sur les domaines.
REAL(KIND=8) zdocd(jpdoc) ! documentation sur les domaines: pour lfalec.
!
REAL(KIND=8) zprod1(jpprod) ! donnees du fichier d'entree 1.
REAL(KIND=8) zprod2(jpprod) ! donnees du fichier d'entree 2.
REAL(KIND=8) zprod3(jpprod) ! donnees du fichier de sortie 3.
REAL(KIND=8) zcumt(jpprod) ! tendance cumulee (cas separ_pr_compl).
REAL(KIND=8) zcalcx(jpprod) ! calculatrice: pile X.
REAL(KIND=8) zcalcy(jpprod) ! calculatrice: pile Y.
REAL(KIND=8) zcalcz(jpprod) ! calculatrice: pile Z.
REAL(KIND=8) zcalct(jpprod) ! calculatrice: pile T.
REAL(KIND=8) zcalcu(jpprod) ! calculatrice: pile U.
REAL(KIND=8) zcalcv(jpprod) ! calculatrice: pile V.
REAL(KIND=8) zpre_ini_1(jpprod) ! VPP0 fichier 1.
REAL(KIND=8) zpre_fin_1(jpprod) ! VPP1 fichier 1.
REAL(KIND=8) zpre_cum_1(jpprod) ! PPP fichier 1.
REAL(KIND=8) zpre_ini_2(jpprod) ! VPP0 fichier 2.
REAL(KIND=8) zpre_fin_2(jpprod) ! VPP1 fichier 2.
REAL(KIND=8) zpre_cum_2(jpprod) ! PPP fichier 2.
REAL(KIND=8) zep_ini_1(jpprod) ! VEP0 fichier 1.
REAL(KIND=8) zep_ini_2(jpprod) ! VEP0 fichier 2.
!
! Initialisation.
!
idoma=0
!
! **   Initialisation par defaut des variables d'entree.
!
idocfi1(16)=0 ; idocfi1(17)=0
idocfi2(16)=0 ; idocfi2(17)=0
idocfi3(16)=0 ; idocfi3(17)=0
cgconf='DIFFE_EXP_REFE'
cgnfe1='ddh1'
cgnfe2='ddh2'
cgnflc='lc'
cgnfso='ddht.lfa'
lgrens=.true.
lgdebu=.false.
clconvs='NON'
lltous=.true. ! vrai si tous les champs du fichier d'entre  traiter.
llpremr=.true. ! vrai si premier mot de la liste des oprations "calculatrice" rencontr.
cllisde='1,2,4' ! liste des domaines (resp niveaux) a extraire (option -cEXTRAIT_DOMAIN (resp -cEXTRAIT_NIVEAUX)).
!
! Obtention des parametres d'entree par ligne de commande.
!
ierr=0
do jarg=1,jparg
	clarg(jarg)=' '
	call getargp(jarg,clarg(jarg))
	ilarg=len_trim(clarg(jarg))
	if(clarg(jarg)(1:1) /= ' ') then
		! L'argument numero jarg est non vide.
		if(clarg(jarg)(1:2) == '-c') then
			clloc=clarg(jarg)(3:)
			illoc=len_trim(clloc)
			if(clloc(1:illoc) == 'SOMME_PONDEREE') then
			elseif(clloc(1:illoc) == 'SOMME_CONTIGUE') then
			elseif(clloc(1:illoc) == 'DIFFE_EXP_REFE') then
			elseif(clloc(1:illoc) == 'DIFFE_EC2_EC1') then
			elseif(clloc(1:illoc) == 'DIFFE_PONDEREE') then
			elseif(clloc(1:illoc) == 'SEPAR_PR_COMPL') then
			elseif(clloc(1:illoc) == 'MOY_VERTIC') then
			elseif(clloc(1:illoc) == 'MOY_HORIZ') then
			elseif(clloc(1:illoc) == 'EXTRAIT_DOMAIN') then
			elseif(clloc(1:illoc) == 'EXTRAIT_NIVEAUX') then
			elseif(clloc(1:illoc) == 'CALC') then
			else
				ierr=1
				print*,'ddht/ERREUR: argument -c errone!...'
			endif
			cgconf=clloc
		elseif(clarg(jarg)(1:2) == '-1') then
			cgnfe1=clarg(jarg)(3:)
		elseif(clarg(jarg)(1:2) == '-2') then
			cgnfe2=clarg(jarg)(3:)
		elseif(clarg(jarg)(1:2) == '-l') then
			lltous=.false.
			cgnflc=clarg(jarg)(3:)
		elseif(clarg(jarg)(1:2) == '-L') then
			clloc=clarg(jarg)(3:)
			illoc=len_trim(clloc)
			if(clloc(1:illoc) == 'TOUS') then
				lltous=.true.
			elseif(clloc(1:illoc) == 'PAR_FICHIER') then
				lltous=.false.
			else
				ierr=1
				print*,'ddht/ERREUR: argument -L errone!...'
			endif
		elseif(clarg(jarg)(1:2) == '-E') then
			cllisde=clarg(jarg)(3:)
		elseif(clarg(jarg)(1:2) == '-s') then
			cgnfso=clarg(jarg)(3:)
		elseif(clarg(jarg)(1:2) == '-r') then
			clloc=clarg(jarg)(3:)
			illoc=len_trim(clloc)
			if(clloc(1:illoc) == 'OUI') then
				lgrens=.true.
			elseif(clloc(1:illoc) == 'NON') then
				lgrens=.false.
			else
				ierr=1
				print*,'ddht/ERREUR: argument -r errone!...'
			endif
		elseif(clarg(jarg)(1:2) == '-S') then
			clloc=clarg(jarg)(3:)
			illoc=len_trim(clloc)
			if(clloc(1:illoc) == 'OUI') then
			elseif(clloc(1:illoc) == 'NON') then
			else
				ierr=1
				print*,'ddht/ERREUR: argument -S errone!...'
			endif
			clconvs=clloc
		elseif(clarg(jarg)(1:2) == '-d') then
			clloc=clarg(jarg)(3:)
			illoc=len_trim(clloc)
			if(clloc(1:illoc) == 'OUI') then
				lgdebu=.true.
			elseif(clloc(1:illoc) == 'NON') then
				lgdebu=.false.
			else
				ierr=1
				print*,'ddht/ERREUR: argument -d errone!...'
			endif
		else
			ierr=1
			print*,'ddht/ERREUR: argument d''entree ' &
& 				,clarg(jarg)(1:ilarg),' errone!...'
		endif
	endif
enddo
if(clarg(1)(1:1) == ' '.or.ierr == 1) then
	! L'utilisateur n'a tape aucun argument.
	print*,' '
	print*,'Transformation de fichiers de DDH.'
	print* &
& 		,'Permet de calculer les somme ou difference de deux fichiers de DDH,'
	print*,'effectuer des moyennes verticale ou horizontale,'
	print*,'extraire des domaines ou niveaux,'
	print*,'ou additionner n termes d''un bilan.'
	print* &
& 		,'Les fichiers d''entre et de sortie sont des fichiers de DDH.'
	print*,' '
	print*,'Utilisation: ddht -c -1 -2 -l -S -s -r -d'
	print*,' '
	print*,'avec'
	print*,'  -c configuration (SOMME_PONDEREE, SOMME_CONTIGUE,'
	print*,'                    DIFFE_EXP_REFE, DIFFE_EC2_EC1,'
	print*,'                    DIFFE_PONDEREE, SEPAR_PR_COMPL,'
	print*,'                    MOY_VERTIC,     MOY_HORIZ,'
	print*,'                    EXTRAIT_DOMAIN, EXTRAIT_NIVEAUX, CALC).'
	print*,'     Defaut: DIFFE_EXP_REFE.'
	print* &
& 		,'     Les diffrences effectuent fichier 2 moins fichier 1,'
	print*,'     au sens des arguments ci-dessous.'
	print*,'  -1 fichier d''entree 1.'
	print*,'     Defaut: ddh1.'
	print*,'  -2 fichier d''entree 2.'
	print*,'     Defaut: ddh2.'
	print*,'  -L liste des champs a traiter (TOUS, PAR_FICHIER).'
	print* &
& 		,'     TOUS: tous les champs du fichier d''entree seront traites.'
	print* &
& 		,'       En ce cas l''option -S est inutile: elle est force  OUI.'
	print* &
& 		,'     PAR_FICHIER: les champs dont la liste est dans le fichier'
	print*,'       de nom fourni par -l ci-dessous seront traites.'
	print*,'     Defaut: TOUS.'
	print*,'  -l fichier-liste des champs a traiter'
	print*,'     dans le cas -LPAR_FICHIER,'
	print* &
& 		,'     ou liste des operations a effectuer dans le cas -cCALC.'
	print*,'     Defaut: lc.'
	print*,'     Les articles (VPP0, VPP1, PPP, VEP0, VEP1) '
	print*,'     seront traites quelle que soit la liste d''entree.'
	print*,'  -S traitement des champs sol (OUI, NON).'
	print*,'     Defaut: NON.'
	print*,'  -E dans le cas des options -cEXTRAIT_DOMAIN'
	print* &
& 		,'     ou -cEXTRAIT_NIVEAUX, liste des domaines ou niveaux a extraire.'
	print* &
& 		,'     On entre les niveaux ou domaines sous la forme 1,2,4'
	print*,'     pour avoir les domaines 1, 2 et 4,'
	print*,'     ou 7-11 pour avoir les domaines 7 a 11.'
	print*,'     Defaut: 1,2,4.'
	print*,'  -s fichier de sortie.'
	print*,'     Defaut: ddht.lfa.'
	print*,'  -r renseignements en clair (OUI, NON).'
	print*,'     Defaut: OUI.'
	print*,'  -d mode debug (OUI, NON).'
	print*,'     Defaut: NON.'
	print*,'Exemples:'
	print*,'	ddht -cMOY_HORIZ -1monfic -sficsor -llc2 -rOUI.'
	print*,'	ddht -cEXTRAIT_DOMAIN -1f1 -sresul -E5,6,7.'
	print*,'	ddht -cCALC -1f1 -sresul -lliste_des_oper.'
	print*,'------------------------------------------------------'
	stop
endif
lgrens=lgrens.or.lgdebu
!
! **   Impression des valeurs de namelist.
!
if(lgrens) then
	print*, '----------------------'
	print*, '------ddht------------'
	print*, '----------------------'
	print*, 'CGCONF   =',cgconf(1:len_trim(cgconf))
	print*, 'LGRENS   =',lgrens
	print*, 'LGDEBU   =',lgdebu
	print*, 'CGNFE1   =',cgnfe1(1:index(cgnfe1,' ')-1)
	print*, 'CGNFE2   =',cgnfe2(1:index(cgnfe2,' ')-1)
	print*, 'CGNFLC   =',cgnflc(1:index(cgnflc,' ')-1)
	print*, 'CGNFSO   =',cgnfso(1:index(cgnfso,' ')-1)
endif
if(clloc(1:illoc) == 'CALC') then
	!
	! Calculatrice.
	! Mise  zro de la pile de calcul.
	!
	idim=0
	do jprod=1,jpprod
		zcalcx(jprod)=0.
		zcalcy(jprod)=0.
		zcalcz(jprod)=0.
		zcalct(jprod)=0.
		zcalcu(jprod)=0.
		zcalcv(jprod)=0.
	enddo
endif
!
! **   Initialisation.
!
! Unites logiques.
!
iulficc=3 ! unite logique du fichier-liste des champs.
iul1=13 ! fichier d'entree 1.
iul2=14 ! fichier d'entree 2.
iul3=15 ! fichier de sortie.
!
! **   Ouverture du fichier d'entree 1.
!
imes=1 ! niveau de messagerie du logiciel lfa.
call lfaouv(iul1,cgnfe1,'R')	
call lfames(iul1,imes)
!
! Fichier-liste des champs a estimer et(ou) tracer
! sur le tableau cllisct
!
ilisct=0
if(.not.lltous) then
	!
	! L'utilisateur fournit la liste des champs  traiter
	! dans un fichier.
	!
	clficc=cgnflc
	inquire(file=clficc,exist=llex)
	if(llex) then
		open(iulficc,file=clficc,form='formatted')
  635 		continue
		read(iulficc,fmt='(a)',end=130) cli
		!
		! On cherche la position d'un ventuel caractre
		! marquant le dbut d'une zone commentaire
		! sur la ligne.
		!
		if(cli(1:1) /= '#'.and.cli(1:1) /= '	') then
			!
			! Le premier caractre n'est ni un blanc, ni une tabulation
			! ni un '#'. La ligne n'est donc pas commente.
			!
			! Y a-t-il un "#" sur cette ligne?
			!
			irep=index(cli,'#')
			if(irep == 0) then
				!
				! Pas de "#" sur la ligne.
				!
				ifinl=len_trim(cli)
			else
				!
				! "#" sur la ligne.
				!
				ifinl=irep-1
			endif
			!
			! Une ligne de plus sur la liste des champs  traiter.
			!
			ilisct=ilisct+1
			if(ilisct > jpnomct) then
				print* &
& 					,'ddht/ERREUR: recompiler avec une valeur plus grande de jpnomct!...'
				print*,ilisct,jpnomct
				stop 'call abort'
			endif
			!
			! On saisit la ligne jusqu' son ventuel commentaire.
			!
			cllisct(ilisct)=cli(1:ifinl)
		endif
		goto 635
  130 		continue
	else
		print*,'ddht/ERREUR: fichier-liste des champs inexistant!...'
		print*,clficc
		stop 'call abort'
	endif
else
	!
	! L'utilisateur souhaite traiter tous les champs du fichier d'entre.
	! Etablissement de la liste de ces champs.
	!
	call lfalaft(iul1,cllisct,jpnomct,ilisct0)
	!
	! On va ne garder de cette liste que les noms diffrents
	! au sens DDH du terme, i.e.
	! ceux de nom tel que 'DATE' ne seront pas conservs.
	!
	ilisct=0
	do jlisct=1,ilisct0
		cllis=cllisct(jlisct)
		illis=len_trim(cllis)
		if(cllis(1:illis) /= 'DATE' &
& 			.and.cllis(1:illis) /= 'DOCFICHIER' &
& 			.and.cllis(1:illis) /= 'INDICE EXPERIENCE' &
& 			.and.cllis(1:illis) /= 'SVGFS' &
& 			.and.cllis(1:illis) /= 'SFGFS' &
& 			.and.cllis(1:4) /= 'DOCD' &
& 			.and.(cllis(1:1) /= 'S'.or.cllis(4:4) /= '_'.or.(cllis(5:5) &
& 			 /= '0'.and.cllis(5:5) /= '1')) &
& 			.and.(cllis(1:1) /= 'G'.or.illis /= 3) &
& 			.and.cllis(1:illis) /= 'ECHEANCE' &
& 			.and.cllis(1:illis) /= 'ECHEANCEDV') then
			!
			! Il s'agit d'un article de champ rel DDH.
			! On le porte sur la liste de sortie.
			!
			ilisct=ilisct+1
			cllisct(ilisct)=cllisct(jlisct)
		endif
	enddo
endif
if(lgrens) then
	print*,ilisct,' articles lus sur le fichier-liste.'
endif
if (cgconf(1:len_trim(cgconf)) /= 'SEPAR_PR_COMPL'.and.cgconf(1:len_trim(cgconf)) /= 'CALC'.and..not.lltous) then
	! On ajoute systematiquement a la liste les articles de coordonnees
	! car ils sont necessaires aux eventuels traces ulterieurs.
	iplus=5
	if(ilisct+iplus > jpnomct) then
		print* &
& 			,'ddht/ERREUR "iplus": recompiler avec une valeur plus grande de jpnomct!...'
		print*,ilisct+iplus,jpnomct
		stop 'call abort'
	endif
	do jlisct=ilisct,1,-1
		cllisct(jlisct+iplus)=cllisct(jlisct)
	enddo
	ilisct=ilisct+iplus
	cllisct(1)='VPP0         '
	cllisct(2)='VEP0         '
	cllisct(3)='VPP1         '
	cllisct(4)='VEP1         '
	cllisct(5)='PPP          '
endif
!
! Lecture des articles de documentation.
!
! Lecture du premier article: indice en 4 lettres de l'experience.
!
call lfalecc(iul1,'INDICE EXPERIENCE',1,clnamx1,ilong,irep)
!
! Lecture du 2eme    article: DATE.
!
call lfaleci(iul1,'DATE',11,idatef1,ilong,irep)
ibase1=idatef1(1)*1000000 &
& 	+idatef1(2)*10000 &
& 	+idatef1(3)*100 &
& 	+idatef1(4)
!
! Lecture du 3eme    article: DOCFICHIER.
!
call lfaleci(iul1,'DOCFICHIER',17,idocfi1,ilong,irep)
ilev1=idocfi1(6)
idom1=idocfi1(15)
imaxv1=idom1*ilev1
if(ilev1 > jplev) then
	print* &
& 		,'ddht/ERREUR: recompiler avec une valeur plus grande de jplev!...'
	print*,ilev1,jplev
	stop 'call abort'
endif
if(idom1 > jpdom) then
	print* &
& 		,'ddht/ERREUR: recompiler avec une valeur plus grande de jpdom!...'
	print*,idom1,jpdom
	stop 'call abort'
endif
!
! Initialisation des domaines ou niveaux a extraire.
!
call inide(cllisde,idoma,jpdom,indoma)
!
!-------------------------------------------------
! Contrle que la demande d'extraction
! de l'utilisateur est compatible avec les domaines/niveaux
! effectivement prsents dans le fichier.
!-------------------------------------------------
!
if(cgconf(1:len_trim(cgconf)) == 'EXTRAIT_NIVEAUX') then
	if(maxval(idoma) > ilev1) then
		print*,'ddht/ERREUR: demande d''extraction de niveau impossible:'
		print*,'	niveau ',maxval(idoma),' demand, or ',ilev1,' niveaux dans le fichier!...'
		stop 'call abort'
	endif
elseif(cgconf(1:len_trim(cgconf)) == 'EXTRAIT_DOMAIN') then
	if(maxval(idoma) > idom1) then
		print*,'ddht/ERREUR: demande d''extraction de domaine impossible:'
		print*,'	domaine ',maxval(idoma),' demand, or ',idom1,' domaines dans le fichier!...'
		stop 'call abort'
	endif
endif
!
! Lecture du 4eme    article: ECHEANCE.
!
call lfalecr(iul1,'ECHEANCE',1,zech1,ilong,irep)
!
! Echance caractristique des "delta de variables".
!
call lfacas(iul1,'ECHEANCEDV',cltype,ilong,irep) ! on regarde si l'article est dans le fichier.
if(irep == 0) then
	!
	! L'article est dans le fichier.
	! On y lit l'chance.
	!
	call lfalecr(iul1,'ECHEANCEDV',1,zechdv1,ilong,irep)
else
	!
	! L'article n'est pas dans le fichier.
	! L'chance est prise gale  l'cheance nominale 'ECHEANCE'.
	!
	zechdv1=zech1
endif
!
! Lecture des documentations sur les domaines.
!
do jdom=1,idom1
	write(cladcou,fmt='(A4,I3.3)') 'DOCD',jdom
	call lfalecr(iul1,cladcou,jpdoc,zdocd,ilong,irep)
	do jdoc=1,jpdoc
		zdocd1(jdoc,jdom)=zdocd(jdoc)
		zdocd3(jdoc,jdom)=zdocd(jdoc)
	enddo
enddo
!
! Lecture des champs de masse.
!
call lfalecr(iul1,'VPP0',jpprod,zpre_ini_1,ilong,irep)
call lfalecr(iul1,'VPP1',jpprod,zpre_fin_1,ilong,irep)
call lfalecr(iul1,'PPP',jpprod,zpre_cum_1,ilong,irep)
call lfalecr(iul1,'VEP0',jpprod,zep_ini_1,ilong,irep)
!
! On rend non fatale toute erreur de lecture du fichier.
!
call lfaerf(iul1,.false.)
!
! ** Ouverture du fichier d'entree 2.
!
if (cgconf(1:5) == 'SOMME'.or.cgconf(1:5) == 'DIFFE') then
	!
	! Deux fichiers en entree.
	! On ouvre le deuxieme.
	!
	call lfaouv(iul2,cgnfe2,'R')	
	!
	! Lecture des articles de documentation.
	!
	! Lecture du premier article: indice en 4 lettres de l'experience.
	!
	call lfalecc(iul2,'INDICE EXPERIENCE',1,clnamx2,ilong,irep)
	!
	! Lecture du 2eme    article: DATE.
	!
	call lfaleci(iul2,'DATE',11,idatef2,ilong,irep)
	!
	! Lecture du 3eme    article: DOCFICHIER.
	!
	call lfaleci(iul2,'DOCFICHIER',17,idocfi2,ilong,irep)
	ilev2=idocfi2(6)
	idom2=idocfi2(15)
	!
	! Test de cohrence de dimensions entre les deux fichiers
	! d'entre.
	!
	ierrd=0
	if(ilev1 /= ilev2) then
		write(*,'(a)') &
& 			' ddht/ERREUR: nombre de niveaux diffrent entre les deux fichiers d''entre!...'
		print*,ilev1,ilev2
		ierrd=1
	endif
	if(idom1 /= idom2) then
		write(*,'(a)') &
& 			' ddht/ERREUR: nombre de domaines diffrent entre les deux fichiers d''entre!...'
		print*,idom1,idom2
		ierrd=1
	endif
	if(ierrd == 1) stop 'call abort'
	!
	! Lecture du 4eme    article: ECHEANCE.
	!
	call lfalecr(iul2,'ECHEANCE',1,zech2,ilong,irep)
	!
	! Echance caractristique des "delta de variables".
	!
	call lfacas(iul2,'ECHEANCEDV',cltype,ilong,irep) ! on regarde si l'article est dans le fichier.
	if(irep == 0) then
		!
		! L'article est dans le fichier.
		! On y lit l'chance.
		!
		call lfalecr(iul2,'ECHEANCEDV',1,zechdv2,ilong,irep)
	else
		!
		! L'article n'est pas dans le fichier.
		! L'chance est prise gale  l'cheance nominale 'ECHEANCE'.
		!
		zechdv2=zech2
	endif
	!
	! Lecture des champs de masse.
	!
	call lfalecr(iul2,'VPP0',jpprod,zpre_ini_2,ilong,irep)
	call lfalecr(iul2,'VPP1',jpprod,zpre_fin_2,ilong,irep)
	call lfalecr(iul2,'PPP',jpprod,zpre_cum_2,ilong,irep)
	call lfalecr(iul2,'VEP0',jpprod,zep_ini_2,ilong,irep)
	!
	! On rend non fatale toute erreur de lecture du fichier.
	!
	call lfaerf(iul2,.false.)
	!
	! Nouvel indice experience.
	!
	if(clnamx1 == clnamx2) then
		clnamx3=clnamx1
	else
		clnamx3=cgconf
	endif
else
	!
	! Un seul fichier en entree.
	!
	! Nouvel indice experience.
	!
	clnamx3=clnamx1
endif
!
! ** Combinaison des articles de documentation.
!
! * Determination de la base du fichier resultant.
!
if(cgconf(1:len_trim(cgconf)) == 'DIFFE_EC2_EC1') then
	!
	! Nouvelle base: celle du fichier 1 + echeance 1.
	!
	iecartm=nint(zech1/3600.) ! ecart en heures.
	call daplus(ibase1,2,iecartm,ibase3)
else
	!
	! Nouvelle base: celle du fichier 1.
	!
	ibase3=ibase1
endif
!
! * Determination des articles idatef et idocfi.
!
do jdate=1,11
	idatef3(jdate)=idatef1(jdate)
enddo
do jdoc=1,17
	idocfi3(jdoc)=idocfi1(jdoc)
enddo
idom3=idom1
ilev3=ilev1
if(cgconf(1:len_trim(cgconf)) == 'DIFFE_PONDEREE' &
& 	.or.cgconf(1:len_trim(cgconf)) == 'DIFFE_EC2_EC1') then
	! Difference des articles extensifs dans le temps.
	idatef3(7)=idatef2(7)-idatef1(7)
	idatef3(10)=idatef2(10)-idatef1(10)
	idocfi3(5)=idocfi2(5)-idocfi1(5)
elseif(cgconf(1:5) == 'SOMME') then
	! Somme des articles extensifs dans le temps.
	idatef3(7)=idatef2(7)+idatef1(7)
	idatef3(10)=idatef2(10)+idatef1(10)
	idocfi3(5)=idocfi2(5)+idocfi1(5)
elseif(cgconf(1:len_trim(cgconf)) == 'MOY_VERTIC') then
	ilev3=1 ! on porte a 1 le nombre de niveaux verticaux.
	idocfi3(6)=ilev3
elseif(cgconf(1:len_trim(cgconf)) == 'MOY_HORIZ') then
	if(idocfi1(1) == 5) then
		!
		! L'utilisateur veut faire un profil vertical
		! d'un fichier deja global, operation
		! denuee de sens...
		!
		! print*,'ddht/ERREUR: profil vertical de fichier global!...'
		! stop 'call abort'
		idom3=1
		idocfi3(1)=5
		idocfi3(15)=idom3
		do jdoc=1,jpdoc
			zdocd3(jdoc,1)=0.
		enddo
	elseif(idocfi1(1) == 6) then
		!
		! Profil vertical de fichier zonal.
		! Le resultat est un fichier global.
		!
		idom3=1
		idocfi3(1)=5
		idocfi3(15)=idom3
		do jdoc=1,jpdoc
			zdocd3(jdoc,1)=0.
		enddo
	elseif(idocfi1(1) == 1) then
		!
		! Profil vertical de fichier domaine limite.
		! Le resultat est un fichier limite a 1 domaine.
		!
		idom3=1
		idocfi3(1)=1
		idocfi3(15)=idom3
		do jdoc=1,jpdoc
			zdocd3(jdoc,1)=0.
		enddo
		do jdoc=1,jpdoc
			do jdom=1,idom1
				zdocd3(jdoc,1)=zdocd3(jdoc,1) &
& 					+zdocd1(jdoc,jdom)/idom1
			enddo
		enddo
	endif
elseif(cgconf(1:len_trim(cgconf)) == 'EXTRAIT_DOMAIN') then
	idom3=indoma
	idocfi3(1)=1 ! le fichier de sortie devient un fichier type "domaines limites".
	idocfi3(15)=indoma ! nombre de domaines presents dans le fichier de sortie.
elseif(cgconf(1:len_trim(cgconf)) == 'EXTRAIT_NIVEAUX') then
	idocfi3(6)=indoma ! le fichier de sortie devient un fichier a indoma niveaux.
endif
idatef3(4)=mod(ibase3,100)
ibase3=ibase3/100
idatef3(3)=mod(ibase3,100)
ibase3=ibase3/100
idatef3(2)=mod(ibase3,100)
idatef3(1)=ibase3/100
!
! * Determination de la nouvelle echeance.
!
if(cgconf(1:len_trim(cgconf)) == 'SOMME_PONDEREE') then
	zech3=zech1+zech2 ! flux/tendances ajouts.
	zechdv3=(zechdv1*zech1+zechdv2*zech2)/(zech1+zech2) ! variables moyennes.
elseif(cgconf(1:len_trim(cgconf)) == 'SOMME_CONTIGUE') then
	zech3=zech1+zech2 ! flux/tendances ajouts.
	zechdv3=zechdv1+zechdv2 ! variables recopies.
elseif(cgconf(1:len_trim(cgconf)) == 'DIFFE_EXP_REFE') then
	!
	! Difference de fichiers de meme echeance.
	!
	zech3=zech1 ! flux/tendances.
	zechdv3=zechdv1 ! variables diffrencies.
	if(cgconf(1:len_trim(cgconf)) == 'DIFFE_EXP_REFE') then
		!
		!-------------------------------------------------
		! On effectue le test d'galit des cheances.
		!-------------------------------------------------
		!
		if(abs((zech2-zech1)/zech1) > 1.e-5) then
			print*,'ddht/ERREUR: DIFFE_EXP_REFE de deux fichiers d''chances diffrentes!...'
			print*,zech1,zech2
			stop 'call abort'
		endif
	endif
elseif(cgconf(1:len_trim(cgconf)) == 'DIFFE_PONDEREE') then
	zech3=zech2-zech1 ! flux/tendances retranchs.
	zechdv3=zechdv2-zechdv1 ! variables retranches.
elseif(cgconf(1:len_trim(cgconf)) == 'DIFFE_EC2_EC1') then
	zech3=zech2-zech1 ! flux/tendances retranchs.
	zechdv3=zechdv2-zechdv1 ! variables retranches.
else
	zech3=zech1
	zechdv3=zechdv1
endif
!
! * Determination des articles de documentation des domaines.
!
if(cgconf(1:len_trim(cgconf)) == 'MOY_VERTIC') then
	!
	! Les articles de documentation des domaines
	! sont a modifier.
	!
elseif(cgconf(1:len_trim(cgconf)) == 'MOY_HORIZ') then
	!
	! Les articles de documentation des domaines
	! sont a modifier.
	!
elseif(cgconf(1:len_trim(cgconf)) == 'EXTRAIT_DOMAIN') then
	!
	! Les articles de documentation des domaines
	! sont a modifier.
	!
	do jindoma=1,indoma
		!
		! Le domaine courant est a recopier dans le fichier de sortie.
		!
		do jdoc=1,jpdoc
			zdocd3(jdoc,jindoma)=zdocd1(jdoc,idoma(jindoma))
		enddo
	enddo
else
	!
	! Dans tous les autres cas, la documentation
	! des domaines est celle du fichier d'entree 1.
	!
	idom3=idom1
	do jdom=1,idom3
		do jdoc=1,jpdoc
			zdocd3(jdoc,jdom)=zdocd1(jdoc,jdom)
		enddo
	enddo
endif
!
! ** Ecriture des articles documentaires du fichier de sortie.
!
call lfaouv(iul3,cgnfso,'W')
call lfapreci(iul3,jpprecint)
call lfaprecr(iul3,jpprecree)
call lfames(iul3,imes)
call lfaecrc(iul3,'INDICE EXPERIENCE',clnamx3,1)
call lfaecri(iul3,'DATE',idatef3,11)
call lfaecri(iul3,'DOCFICHIER',idocfi3,17)
call lfaecrr(iul3,'ECHEANCE',zech3,1)
call lfaecrr(iul3,'ECHEANCEDV',zechdv3,1)
do jdom=1,idom3
	do jdoc=1,jpdoc
		zdocd(jdoc)=zdocd3(jdoc,jdom)
	enddo
	write(cladcou,fmt='(A4,I3.3)') 'DOCD',jdom
	call lfaecrr(iul3,cladcou,zdocd,jpdoc)
enddo
if(cgconf(1:len_trim(cgconf)) == 'SEPAR_PR_COMPL') then
	!
	! On crit sur le lfa de sortie les articles
	! de coordonnes permettant le trac
	! ultrieur.
	!
	cladcou='VPP0'
	call lfalecr(iul1,cladcou,jpprod,zpre_ini_1,ilong,irep)
	call lfaecrr(iul3,cladcou,zpre_ini_1,ilong)
	cladcou='VEP0'
	call lfalecr(iul1,cladcou,jpprod,zprod1,ilong,irep)
	call lfaecrr(iul3,cladcou,zprod1,ilong)
	cladcou='VPP1'
	call lfalecr(iul1,cladcou,jpprod,zpre_fin_1,ilong,irep)
	call lfaecrr(iul3,cladcou,zpre_fin_1,ilong)
	cladcou='VEP1'
	call lfalecr(iul1,cladcou,jpprod,zprod1,ilong,irep)
	call lfaecrr(iul3,cladcou,zprod1,ilong)
	cladcou='PPP'
	call lfalecr(iul1,cladcou,jpprod,zpre_cum_1,ilong,irep)
	call lfaecrr(iul3,cladcou,zpre_cum_1,ilong)
endif
!
! ** Traitement des articles scientifiques.
!
! Boucle sur les champs.
!
do jlisct=1,ilisct
	clc=cllisct(jlisct)
	if((clc(2:3) == 'A1'.and.idocfi3(3) == 0) &
		&.or.(clc(2:3) == 'A2'.and.idocfi3(3) == 0) &
		&.or.(clc(2:3) == 'A3'.and.idocfi3(3) == 0) &
		&.or.(clc(2:3) == 'SS'.and.idocfi3(4) == 0) &
		&.or.clc(1:9) == 'DYNAMIQUE' &
		&.or.clc(1:1) == 'S' &
		&) then
		!
		! L'utilisateur a demand de traiter
		! des champs qui, d'aprs l'autodocumentation
		! du fichier, ne peuvent y tre.
		! Afin de ne pas lancer de lecture inutile,
		! on passe directement au champ suivant.
		!
		if(clc(1:5) /= 'SVGFS' .and. clc(1:5) /= 'SFGFS') then
			print*,'ddht: ATTENTION: champ ',clc(1:13),' ignor.'
		endif
		goto 755
	endif
	if (cgconf(1:len_trim(cgconf)) == 'SEPAR_PR_COMPL') then
		!
		! Separation de la tendance totale en termes
		! principal et complementaire.
		! Le terme principal est celui
		! donne explicitement par la
		! liste des champs cllisct().
		! Le terme complementaire est (Vxx1-Vxx0-principal).
		!
		if(lltous) then
			print* &
& 				,'ddht/ERREUR: pour les sparations de tendance il faut fournir'
			print*,'une liste explicite de champs. L''option -LTOUS'
			print*,'n''est donc pas autorise!...'
			stop 'call abort'
		endif
		if(jlisct == 1) then
			!
			! Debut de liste des champs a traiter.
			!
			cladcou=cllisct(1)(1:4)
			call lfalecr(iul1,cladcou,jpprod,zprod1,ilong,irep)
			call lfaecrr(iul3,cladcou,zprod1,ilong)
			cladcou=cllisct(2)(1:4)
			call lfalecr(iul1,cladcou,jpprod,zprod2,ilong,irep)
			call lfaecrr(iul3,cladcou,zprod2,ilong)
			!
			! Il faut initialiser a zero le tableau de cumul.
			!
			do jprod=1,jpprod
				zcumt(jprod)=0.
			enddo
		else
			if(clc(1:1) == 'T'.and.clc(4:9) == 'DELTAP') then
				!
				! L'article  cumuler est la tendance
				! due a la variation de masse:
				! -0.5*(Vx0/VPP0+Vx1/VPP1)*(VPP1-VPP0)*t_flux/t_var.
				!
				do jprod=1,imaxv1
					zprod3(jprod)=-0.5*(zprod1(jprod)/zpre_ini_1(jprod)+ &
& 						zprod2(jprod)/zpre_fin_1(jprod))*(zpre_fin_1(jprod)-zpre_ini_1(jprod))*zech1/ &
& 						zechdv1
				enddo
				!
				! Cumul de l'article de ddh dans le tableau de tendance zcumt.
				!
				call cumul(clc,jpprod,zprod3,imaxv1,idom1,ilev1,zcumt)
			elseif(clc(1:1) == 'F'.or.clc(1:1) == 'T') then
				!
				! Lecture de l'article.
				!
				call lfalecr(iul1,clc,jpprod,zprod3,ilong,irep)
				if(irep /= 0) then
					!
					!-------------------------------------------------
					! L'article n'existe pas. On le met  une valeur nulle.
					!-------------------------------------------------
					!
					zprod3=0.
					!
					!-------------------------------------------------
					! Afin de fournir la valeur correcte de ilong, on la prend
					! sur une variable ou un flux.
					!-------------------------------------------------
					!
					if(clc(1:1) == 'F') then
						call lfacas(iul1,'FCTRAYSOL1',cltype,ilong,irep)
					elseif(clc(1:1) == 'T') then
						call lfacas(iul1,'TCTDIVFLUHOR',cltype,ilong,irep)
					else
						write(*,fmt=*) 'ddht/ERREUR: type de variable non attendu!...'
						write(*,fmt=*) clc(1:1)
						stop 'call abort'
					endif
				endif
				!
				! Cumul de l'article de ddh dans le tableau de tendance zcumt.
				!
				call cumul(clc,jpprod,zprod3,ilong,idom1,ilev1,zcumt)
			endif
		endif
		if(jlisct == ilisct) then
			!
			! On a lu le dernier article de la liste des champs.
			! Le resultat courant est donc a porter dans le fichier de DDH.
			!
			write(cltita,fmt='(A1,A2,A10)') 'T',cllisct(1)(2:3) &
& 				,'PRINCIPAL '
			call lfaecrr(iul3,cltita,zcumt,imaxv1)
			!
			! Calcul du terme complementaire: COMPLEMENT =  Xfinal-Xinitial-PRINCIPAL
			!
			do jprod=1,imaxv1
				zprod2(jprod)=(zprod2(jprod)/zpre_fin_1(jprod)-zprod1(jprod)/ &
& 					zpre_ini_1(jprod))/zechdv1*zpre_cum_1(jprod)-zcumt(jprod)
			enddo
			write(cltita,fmt='(A1,A2,A10)') 'T',cllisct(1)(2:3) &
& 				,'COMPLEMENT'
			call lfaecrr(iul3,cltita,zprod2,imaxv1)
		endif
  669 		continue
	elseif(cgconf(1:len_trim(cgconf)) == 'CALC') then
		!
		! Fonction calculatrice.
		! On rend fatale toute erreur de lecture du fichier.
		!
		call lfaerf(iul1,.true.)
		!
		! On casse la chane en ses diffrents mots:
		! il peut y avoir plusieurs ordres par ligne.
		!
		call casc(clc,1,clmot,ilmot)
		!
		! Boucle sur les diffrents ordres de la ligne.
		!
		do jmot=1,ilmot
			clc=clmot(jmot)
			ilc=len_trim(clc)
			if(jmot == 1.and.llpremr) then
				!
				! Premier mot de la premire ligne rencontr.
				!
				if(clc(1:ilc) == 'NCOORD') then
					!
					! L'utilisateur veut que les coordonnes
					! (champs VPP0, 1, PPP, etc...)
					! ne soient pas recopies dans le fichier de sortie.
					!
				else
					!
					! L'utilisateur veut que les coordonnes
					! (champs VPP0, 1, PPP, etc...)
					! soient recopies dans le fichier de sortie.
					!
					! On crit sur le lfa de sortie les articles
					! de coordonnes permettant le trac
					! ultrieur.
					!
					cladcou='VPP0'
					call lfalecr(iul1,cladcou,jpprod,zpre_ini_1,ilong,irep)
					call lfaecrr(iul3,cladcou,zpre_ini_1,ilong)
					cladcou='VEP0'
					call lfalecr(iul1,cladcou,jpprod,zprod1,ilong,irep)
					call lfaecrr(iul3,cladcou,zprod1,ilong)
					cladcou='VPP1'
					call lfalecr(iul1,cladcou,jpprod,zpre_fin_1,ilong,irep)
					call lfaecrr(iul3,cladcou,zpre_fin_1,ilong)
					cladcou='VEP1'
					call lfalecr(iul1,cladcou,jpprod,zprod1,ilong,irep)
					call lfaecrr(iul3,cladcou,zprod1,ilong)
					cladcou='PPP'
					call lfalecr(iul1,cladcou,jpprod,zpre_cum_1,ilong,irep)
					call lfaecrr(iul3,cladcou,zpre_cum_1,ilong)
				endif
				llpremr=.false.
			endif
			if(clc(1:ilc) == 'NCOORD') then
			elseif(clc(1:ilc) == '+') then
				!
				! Addition.
				!
				do jprod=1,jpprod
					zcalcx(jprod)=zcalcx(jprod)+zcalcy(jprod)
					zcalcy(jprod)=zcalcz(jprod)
					zcalcz(jprod)=zcalct(jprod)
					zcalct(jprod)=zcalcu(jprod)
					zcalcu(jprod)=zcalcv(jprod)
				enddo
			elseif(clc(1:ilc) == '-') then
				!
				! Soustraction.
				!
				do jprod=1,jpprod
					zcalcx(jprod)=zcalcy(jprod)-zcalcx(jprod)
					zcalcy(jprod)=zcalcz(jprod)
					zcalcz(jprod)=zcalct(jprod)
					zcalct(jprod)=zcalcu(jprod)
					zcalcu(jprod)=zcalcv(jprod)
				enddo
			elseif(clc(1:ilc) == '/') then
				!
				! Division.
				!
				do jprod=1,jpprod
					zcalcx(jprod)=zcalcy(jprod)/zcalcx(jprod)
					zcalcy(jprod)=zcalcz(jprod)
					zcalcz(jprod)=zcalct(jprod)
					zcalct(jprod)=zcalcu(jprod)
					zcalcu(jprod)=zcalcv(jprod)
				enddo
			elseif(clc(1:ilc) == '*') then
				!
				! Multiplication.
				!
				do jprod=1,jpprod
					zcalcx(jprod)=zcalcy(jprod)*zcalcx(jprod)
					zcalcy(jprod)=zcalcz(jprod)
					zcalcz(jprod)=zcalct(jprod)
					zcalct(jprod)=zcalcu(jprod)
					zcalcu(jprod)=zcalcv(jprod)
				enddo
			elseif(clc(1:ilc) == 'X<>Y') then
				!
				! Permutation d'X et Y.
				!
				do jprod=1,jpprod
					ztmp=zcalcx(jprod)
					zcalcx(jprod)=zcalcy(jprod)
					zcalcy(jprod)=ztmp
				enddo
			elseif(clc(1:ilc) == 'ECHEANCE') then
				do jprod=1,jpprod
					zcalcv(jprod)=zcalcu(jprod)
					zcalcu(jprod)=zcalct(jprod)
					zcalct(jprod)=zcalcz(jprod)
					zcalcz(jprod)=zcalcy(jprod)
					zcalcy(jprod)=zcalcx(jprod)
					zcalcx(jprod)=zech1
				enddo
			elseif(clc(1:ilc) == 'ECHEANCEDV') then
				do jprod=1,jpprod
					zcalcv(jprod)=zcalcu(jprod)
					zcalcu(jprod)=zcalct(jprod)
					zcalct(jprod)=zcalcz(jprod)
					zcalcz(jprod)=zcalcy(jprod)
					zcalcy(jprod)=zcalcx(jprod)
					zcalcx(jprod)=zechdv1
				enddo
			elseif(clc(1:4) == 'ECR"') then
				!
				! La valeur de la pile X soit tre porte sur fichier.
				!
				cladcou=clc(5:ilc-1)
				call lfaecrr(iul3,cladcou,zcalcx,idim)
			elseif(clc(1:4) == 'F>V') then
				!
				! Passage d'un flux  une tendance sur les niveaux de variables.
				!
				if(idim /= (ilev1+1)*idom1) then
					print* &
& 						,'ddht/ERREUR: passage flux > tendance sur champ non de flux!...'
					print*,idim,clc
					stop 'call abort'
				endif
				!
				! On initialise  0 le tableau de cumul.
				!
				do jprod=1,jpprod
					zcumt(jprod)=0.
				enddo
				!
				! On cumule dedans le flux avec opration
				! de diffrenciation verticale.
				!
				call cumul(clc,jpprod,zcalcx,idim,idom1,ilev1,zcumt)
				!
				! Le rsultat zcumt est port sur la pile X.
				!
				do jprod=1,jpprod
					zcalcx(jprod)=zcumt(jprod)
				enddo
				idim=ilev1*idom1 ! dimension de sortie (variable).
			elseif(clc(1:1) == 'V'.or.clc(1:1) == 'T'.or.clc(1:1) == 'F') then
				!
				! Lecture sur fichier d'un article de DDH.
				!
				do jprod=1,jpprod
					zcalcv(jprod)=zcalcu(jprod)
					zcalcu(jprod)=zcalct(jprod)
					zcalct(jprod)=zcalcz(jprod)
					zcalcz(jprod)=zcalcy(jprod)
					zcalcy(jprod)=zcalcx(jprod)
				enddo
				if(clc(4:9) == 'DELTAP') then
					!
					! L'article souhait est la tendance
					! due a la variation de masse:
					! -0.5*(Vx0/VPP0+Vx1/VPP1)*(VPP1-VPP0)*t_flux/t_var.
					!
					cladcou='V'//clc(2:3)//'0'
					call lfalecr(iul1,cladcou,jpprod,zprod1,ilong,irep)
					cladcou='V'//clc(2:3)//'1'
					call lfalecr(iul1,cladcou,jpprod,zprod2,ilong,irep)
					idim=ilong
					do jprod=1,idim
						zcalcx(jprod)=-0.5*(zprod1(jprod)/zpre_ini_1(jprod)+ &
& 							zprod2(jprod)/zpre_fin_1(jprod))*(zpre_fin_1(jprod)-zpre_ini_1(jprod))*zech1/ &
& 							zechdv1
					enddo
					do jprod=idim+1,jpprod
						zcalcx(jprod)=0.
					enddo
				else
					!
					! L'article souhait est une simple
					! lecture sur fichier DDH.
					!
					call lfalecr(iul1,clc,jpprod,zcalcx,ilong,irep)
					idim=ilong
				endif
			elseif(clc(1:ilc) == 'COMPLEMENT') then
				!
				! Calcul du complment  l'aide
				! des valeurs de la pile X, Y et Z,
				! par PPP/echdv*(Y/VPP1-Z/VPP0)-X.
				!
				if(idim /= ilev1*idom1) then
					print* &
& 						,'ddht/ERREUR: le champ en X doit tre de dimension de variable!...'
					stop 'call abort'
				endif
				do jprod=1,jpprod
					zcalcx(jprod)=(zcalcy(jprod)/zpre_fin_1(jprod)-zcalcz(jprod) &
& 						/zpre_ini_1(jprod))/zechdv1*zpre_cum_1(jprod)-zcalcx(jprod)
					zcalcz(jprod)=zcalct(jprod)
					zcalcy(jprod)=zcalct(jprod)
					zcalct(jprod)=zcalcu(jprod)
					zcalcu(jprod)=zcalcv(jprod)
				enddo
			else
				!
				! Entre numrique.
				!
				call carree(clc,ilc,zval)
				do jprod=1,jpprod
					zcalcv(jprod)=zcalcu(jprod)
					zcalcu(jprod)=zcalct(jprod)
					zcalct(jprod)=zcalcz(jprod)
					zcalcz(jprod)=zcalcy(jprod)
					zcalcy(jprod)=zcalcx(jprod)
					zcalcx(jprod)=zval
				enddo
				if(idim == 0) idim=1 ! cas d'une entre numrique avant celle d'un champ DDH.
			endif
		enddo
	else
		!
		! On n'est pas dans le cas d'une separation de tendance
		! ni de la calculatrice.
		! Lecture d'article sur le fichier d'entree 1.
		!
		cladcou=clc
		call longa(cladcou(1:1),inivv)
		ilev1=inivv+idocfi1(6)
		call lfalecr(iul1,cladcou,jpprod,zprod1,ilong,irep)
		if(irep == 0.and.inivv >= 0) then
			!
			! L'article existe dans le fichier 1.
			! On le lit eventuellement dans le fichier 2.
			!
			if (cgconf(1:5) == 'SOMME'.or.cgconf(1:5) == 'DIFFE') then
				!
				! Il faut lire l'article du fichier 2.
				!
				call lfalecr(iul2,cladcou,jpprod,zprod2,ilong,irep)
				if(irep == 0) call somd_alt(zprod1,zprod2,jpprod,ilong,ilev1 &
& 					,idom1 &
& 					,cladcou,cgconf,len_trim(cgconf),zech1,zech2,iul3 &
& 					,zpre_ini_1,zpre_fin_1,zpre_cum_1 &
& 					,zpre_ini_2,zpre_fin_2,zpre_cum_2 &
& 					)
			elseif(cgconf(1:len_trim(cgconf)) == 'MOY_VERTIC') then
				!
				! Profil horizontal.
				! On va moyenner sur la verticale.
				!
				ib=0
				imodv=ilong/idom1 ! nombre de niveaux verticaux du champ courant.
				if(cladcou(1:1) == 'F') then
					!
					! Flux sur les inter-niveaux;
					! on conserve les deux valeurs sommet et base.
					!
					do jb=1,ilong
						imod=mod(jb-1,imodv)
						if(imod == 0.or.imod == imodv-1) then
							ib=ib+1
							zprod3(ib)=zprod1(jb)
						endif
					enddo
				else
					!
					! Variables ou tendances sur les niveaux;
					! on effectue la somme verticale.
					!
					do jb=1,ilong
						imod=mod(jb-1,imodv)
						if(imod == 0) zsom=0.
						zsom=zsom+zprod1(jb)
						if(imod == imodv-1) then
							ib=ib+1
							zprod3(ib)=zsom
						endif
					enddo
				endif
				!
				! Ecriture du tableau resultat.
				!
				call lfaecrr(iul3,cladcou,zprod3,ib)
			elseif(cgconf(1:len_trim(cgconf)) == 'MOY_HORIZ') then
				!
				! Profil vertical.
				! On va moyenner sur l'horizontale.
				!
				imodv=ilong/idom1 ! nombre de niveaux verticaux du champ courant.
				znorm=1./float(idom1)
				do jlev=1,imodv
					zprod3(jlev)=0.
				enddo
				do jb=1,ilong
					ilev=mod(jb-1,imodv)+1
					zprod3(ilev)=zprod3(ilev)+zprod1(jb)*znorm
				enddo
				!
				! Ecriture du tableau resultat.
				!
				call lfaecrr(iul3,cladcou,zprod3,imodv)
			elseif(cgconf(1:len_trim(cgconf)) == 'EXTRAIT_DOMAIN') then
				!
				! Extraction de certains domaines du fichier lfa d'entree.
				!
				imodv=ilong/idom1 ! nombre de niveaux verticaux du champ courant.
				ilones=imodv*indoma ! longueur a ecrire en sortie.
				do jb=1,ilong
					idomcou=(jb-1)/ilev1+1 ! numero du domaine courant.
					do jindoma=1,indoma
						if(idomcou == idoma(jindoma)) then
							!
							! Le domaine courant est a recopier dans le fichier de sortie.
							!
							ilev=mod(jb-1,imodv)+1 ! niveau vertical du point courant.
							iprod3=(jindoma-1)*ilev1+ilev ! abscisse du point courant dans le tableau de cumul unidimensionnel.
							zprod3(iprod3)=zprod1(jb)
						endif
					enddo
				enddo
				!
				! Ecriture du tableau resultat.
				!
				call lfaecrr(iul3,cladcou,zprod3,ilones)
			elseif(cgconf(1:len_trim(cgconf)) == 'EXTRAIT_NIVEAUX') then
				!
				! Extraction de certains niveaux du fichier lfa d'entree.
				!
				imodv=ilong/idom1 ! nombre de niveaux verticaux du champ courant.
				inomns=indoma+inivv ! nombre de niveaux en sortie.
				ilones=idom1*inomns ! longueur a ecrire en sortie.
				iprod3=0
				do j1=1,idom1
					do j2=1,inomns
						iprod3=iprod3+1
						if(j2 == inomns.and.inivv == 1) then
							ilevcou=idoma(indoma)+1
						else
							ilevcou=idoma(j2)
						endif
						ib=(j1-1)*imodv+ilevcou
						zprod3(iprod3)=zprod1(ib)
					enddo
				enddo
				!
				! Ecriture du tableau resultat.
				!
				call lfaecrr(iul3,cladcou,zprod3,ilones)
			endif
		endif
	endif
  755 	continue
enddo
if(clconvs == 'OUI'.or.lltous) then
	!
	!-------------------------------------------------
	! Traitement des champs sol.
	!-------------------------------------------------
	!
	!
	if(lgrens) print*,'CHAMPS SOL'
	call lfacas(iul1,'S01_0',cltype,ilart,ierr1)
	if(cgconf(1:5) == 'SOMME'.or.cgconf(1:5) == 'DIFFE') then
		!
		! Il faut lire le deuxieme fichier.
		!
		call lfacas(iul2,'S01_0',cltype,ilart,ierr2)
	else
		ierr2=0
	endif
	if(ierr1 == 0.and.ierr2 == 0) then
		!
		! Les champs sol sont prsents dans les deux fichiers.
		!
		call somd_sol(iul1,iul2,iul3,idocfi1(12),idocfi1(14),zech1,zech2,idom1)
	else
		!
		! Les champs sol sont absents d'au moins un des deux fichiers.
		!
		print*,'ddht/ATTENTION: champs sol absents de l''un au moins des fichiers!...'
	endif
	!
	!-------------------------------------------------
	! Traitement des champs libres.
	!-------------------------------------------------
	!
	!
	if(lgrens) print*,'CHAMPS LIBRES'
	call lfacas(iul1,'SVGFS01',cltype,ilart,ierr1)
	if(cgconf(1:5) == 'SOMME'.or.cgconf(1:5) == 'DIFFE') then
		!
		! Il faut lire le deuxieme fichier.
		!
		call lfacas(iul2,'SVGFS01',cltype,ilart,ierr2)
	else
		ierr2=0
	endif
	if(ierr1 == 0.and.ierr2 == 0) then
		!
		! Les champs libres sont prsents dans les deux fichiers.
		!
		call somd_libres(iul1,iul2,iul3,idocfi1(16),idocfi1(17),zech1,zech2,idom1)
	else
		!
		! Les champs libres sont absents d'au moins un des deux fichiers.
		!
		print*,'ddht/ATTENTION: champs libres absents de l''un au moins des fichiers!...'
	endif
endif
!
! ** Fermeture du fichier d'entree.
!
call lfafer(iul1)
!
! ** Fermeture du fichier de sortie.
!
call lfafer(iul3)
end

subroutine cumul(cdc,kprod,pprod,klong,kdom1,klev1,pcumt)
! --------------------------------------------------------------------------
! **** *CUMUL* Cumul de tendances ou flux sur un tableau 2D.
! --------------------------------------------------------------------------
! Sujet:
! ------
! Arguments explicites: /
! ---------------------
! Arguments implicites: /
! ---------------------
! Methode:
! --------
! Externes: /
! ---------
! Original :
! ----------
! 96-02-14, J.M. Piriou.
!
! Modifications:
! --------------
! --------------------------------------------------------------------------
! En entree:
! cdc       nom de l'article  cumuler.
! kprod     dimension du tableau pprod.
! pprod     tableau des rels  cumuler.
! klong     nombre de rels  lire sur pprod.
! kdom1     nombre de domaines du champ  cumuler.
! klev1     nombre de niveaux du champ  cumuler.
!
! En sortie:
! pcumt     tableau recevant le cumul.
! --------------------------------------------------------------------------
implicit none
INTEGER(KIND=4) :: KDOM1
INTEGER(KIND=4) :: KLEV1
INTEGER(KIND=4) :: KPROD
INTEGER(KIND=4) :: IFLUX
INTEGER(KIND=4) :: ILEV
INTEGER(KIND=4) :: IPROD
INTEGER(KIND=4) :: JDOM
INTEGER(KIND=4) :: JLEV
INTEGER(KIND=4) :: KLONG

REAL(KIND=8) pprod(kprod)
REAL(KIND=8) pcumt(kprod)
REAL(KIND=8) zinterm(kdom1,klev1+1)
CHARACTER*(*) cdc
if(cdc(1:1) == 'F') then
	!
	! Champ de flux.
	!
	ilev=klev1+1
	iflux=1
else
	!
	! Champ de tendance.
	!
	ilev=klev1
	iflux=0
endif
!
! On copie le tableau 1D lu sur le fichier
! sur un tableau 2D afin de faciliter la diffrenciation.
!
iprod=0
do jdom=1,kdom1
	do jlev=1,ilev
		iprod=iprod+1
		zinterm(jdom,jlev)=pprod(iprod)
	enddo
enddo
if(iprod /= klong) then
	print*,'ddht/CUMUL/ERREUR: longueurs fausses: ',iprod,klong
	stop 'call abort'
endif
if(iflux == 1) then
	!
	! Champ de flux.
	! On opre la diffrenciation sur la verticale.
	!
	do jdom=1,kdom1
		do jlev=1,klev1
			zinterm(jdom,jlev)=zinterm(jdom,jlev)-zinterm(jdom,jlev+1)
		enddo
	enddo
endif
!
! Cumul sur le tableau de sortie.
!
iprod=0
do jdom=1,kdom1
	do jlev=1,klev1
		iprod=iprod+1
		pcumt(iprod)=pcumt(iprod)+zinterm(jdom,jlev)
	enddo
enddo
end

subroutine inide(cdlisde,kdoma,kdom,kndoma)
! --------------------------------------------------------------------------
! **** *INIDE* Initialisation des domaines a extraire.
! --------------------------------------------------------------------------
! Sujet:
! ------
! Arguments explicites: /
! ---------------------
! Arguments implicites: /
! ---------------------
! Methode:
! --------
! Externes: /
! ---------
! Original :
! ----------
! 95-03-15, J.M. Piriou.
!
! Modifications:
! --------------
! --------------------------------------------------------------------------
! En entree:
! cdlisde   chaine contenant les domaines a extraire.
!
! En sortie:
! kdoma     tableau contenant les domaines a extraire.
! kdom      dimension physique de kdoma.
! kndoma    nombre d'entiers ecrits sur kdoma (i.e. nombre total de domaines a extraire).
!
! Exemple:
! cdlisde='1,2,4' ==> kndoma=3, kdom(1)=1, kdom(2)=2, kdom(3)=4.
! cdlisde='7-9' ==> kndoma=3, kdom(1)=7, kdom(2)=8, kdom(3)=9.
!
! Remarque:
! Les chiffres sont separes par l'algorithme par des caracteres "non chiffres", donc
! cdlisde='1,2,4' ou cdlisde='#1  2._004' conduisent au meme resultat.
! --------------------------------------------------------------------------
implicit none
INTEGER(KIND=4) :: KDOM
CHARACTER*(*) cdlisde
CHARACTER*1 cl1
INTEGER(KIND=4) kdoma(kdom)
LOGICAL llcarcnc
LOGICAL llmoins
INTEGER(KIND=4) :: IDOM1
INTEGER(KIND=4) :: ITMP
INTEGER(KIND=4) :: J1
INTEGER(KIND=4) :: J2
INTEGER(KIND=4) :: JC
INTEGER(KIND=4) :: JDOM
INTEGER(KIND=4) :: KNDOMA

kndoma=0
llcarcnc=.true. ! vrai si le caractere precedent est un non chiffre.
!
! llmoins: vrai si l'utilisateur a fourni la liste des niveaux de la faon "7-9".
! llmoins: faux si l'utilisateur a fourni la liste des niveaux de la faon "7,8,9".
!
llmoins=.false.
do jc=1,len(cdlisde)
	cl1=cdlisde(jc:jc)
	if(cl1 >= '0'.and.cl1 <= '9') then
		if(llcarcnc) then
			kndoma=kndoma+1
			kdoma(kndoma)=ichar(cl1)-48
		else
			kdoma(kndoma)=kdoma(kndoma)*10+ichar(cl1)-48
		endif
		llcarcnc=.false.
	elseif(cl1 == ',') then
		llcarcnc=.true.
		llmoins=.false.
	elseif(cl1 == '-') then
		llcarcnc=.true.
		llmoins=.true.
	elseif(cl1 == ' ') then
	else
		print* &
& 			,'ddht/INIDE/ERREUR: caractre non attendu dans la liste des niveaux/domaines.'
		print*,cl1
		stop 'call abort'
	endif
enddo
!
! Tri de la liste.
!
do j1=1,kndoma
	do j2=j1,kndoma
		if(kdoma(j1) > kdoma(j2)) then
			itmp=kdoma(j1)
			kdoma(j1)=kdoma(j2)
			kdoma(j2)=itmp
		endif
	enddo
enddo
if(llmoins) then
	!
	! L'utilisateur a fourni une liste de type 27-34.
	! Or  ce niveau on n'a que 2 valeurs dans kdoma,
	! 27 et 34. On restaure ci-dessous la liste complte.
	!
	if(kndoma /= 2) then
		print* &
& 			,'ddht/INIDE/ERREUR: fourniture de niveaux avec un moins,'
		print* &
& 			,'or le nombre de niveaux de part et d''autre de ce moins '
		print*,'n''est pas gal  2!...'
		stop 'call abort'
	endif
	kndoma=kdoma(2)-kdoma(1)+1
	idom1=kdoma(1)
	do jdom=1,kndoma
		kdoma(jdom)=idom1+jdom-1
	enddo
endif
end

subroutine somd_alt(pprod1,pprod2,kprod,klong,klev1,kdom1 &
& 	,cdadcou,cdconf,klconf,pech1,pech2,kul3 &
& 	,ppre_ini_1,ppre_fin_1,ppre_cum_1 &
& 	,ppre_ini_2,ppre_fin_2,ppre_cum_2 &
& 	)
! --------------------------------------------------------------------------
! **** *somd_alt* Somme ou difference de deux fichiers de DDH, champs d'altitude.
! --------------------------------------------------------------------------
! Sujet:
! ------
! Arguments explicites: /
! ---------------------
! Arguments implicites: /
! ---------------------
! Methode:
! --------
! Externes: /
! ---------
! Original :
! ----------
! 92-03-01, J.M. Piriou.
!
! Modifications:
! --------------
! 92-12-04, J.M. Piriou: adaptation au calcul sur CRAY.
! 94-10-27, J.M. Piriou: adaptation au calcul sur lfa.
!
! --------------------------------------------------------------------------
! En entree:
! pprod1, pprod2: champs scientifiques a additionner
! ou retrancher.
! kprod: taille physique de ces tableaux.
! klong: taille reelle de ces tableaux.
! klev1: nombre de niveaux.
! kdom1: nombre de domaines.
! cdadcou: nom de l'article.
! cdconf: configuration de travail a effectuer.
! klconf: nb de car. ecrits sur cdconf.
! pech1: echeance du fichier 1.
! pech2: echeance du fichier 2.
! kul3: unite logique de sortie.
! ppre_ini_1 VPP0 fichier 1.
! ppre_fin_1 VPP1 fichier 1.
! ppre_cum_1 PPP fichier 1.
! ppre_ini_2 VPP0 fichier 2.
! ppre_fin_2 VPP1 fichier 2.
! ppre_cum_2 PPP fichier 2.
! En sortie:
! ecriture d'un article sur l'unite logique kul3.
! --------------------------------------------------------------------------
implicit none
#include"ddhpar.h"
INTEGER(KIND=4) :: KPROD
INTEGER(KIND=4) :: JPROD
INTEGER(KIND=4) :: KDOM1
INTEGER(KIND=4) :: KLCONF
INTEGER(KIND=4) :: KLEV1
INTEGER(KIND=4) :: KLONG
INTEGER(KIND=4) :: KUL3
REAL(KIND=8) :: PECH1
REAL(KIND=8) :: PECH2
REAL(KIND=8) :: ZCORR
REAL(KIND=8) :: ZDENO
REAL(KIND=8) :: ZPOIE1
REAL(KIND=8) :: ZPOIE2
REAL(KIND=8) :: ZPOIV1
REAL(KIND=8) :: ZPOIV2

REAL(KIND=8) pprod1(kprod)
REAL(KIND=8) pprod2(kprod)
REAL(KIND=8) zprod3(jpprod)
REAL(KIND=8) ppre_ini_1(kprod) ! VPP0 fichier 1.
REAL(KIND=8) ppre_fin_1(kprod) ! VPP1 fichier 1.
REAL(KIND=8) ppre_cum_1(kprod) ! PPP fichier 1.
REAL(KIND=8) ppre_ini_2(kprod) ! VPP0 fichier 2.
REAL(KIND=8) ppre_fin_2(kprod) ! VPP1 fichier 2.
REAL(KIND=8) ppre_cum_2(kprod) ! PPP fichier 2.
CHARACTER*(*) cdadcou,cdconf
!
! Calcul des poids  appliquer lors de sommes ou diffrences.
!
call calpasd(cdconf,klconf,pech1,pech2,zpoiv1,zpoiv2,zdeno,zpoie1 &
& 	,zpoie2)
if(cdadcou(1:1) == 'V'.and.cdconf(1:len_trim(cdconf)) == 'DIFFE_EXP_REFE') then
	!
	! Article de type variable, configuration="DIFFE_EXP_REFE".
	!
	do jprod=1,klong
		if(cdadcou(4:4) == '0') then
			zcorr=ppre_ini_1(jprod)/ppre_ini_2(jprod)
		elseif(cdadcou(4:4) == '1') then
			zcorr=ppre_fin_1(jprod)/ppre_fin_2(jprod)
		else
			print*,'DDHT/ERREUR: caractre 4 non attendu dans ',cdadcou(1:len_trim(cdadcou))
			stop 'call abort'
		endif
		zprod3(jprod)=(pprod1(jprod)*zpoiv1+pprod2(jprod)*zpoiv2*zcorr)/zdeno
	enddo
elseif(cdadcou(1:1) == 'V') then
	!
	! Article de type variable, autres configurations.
	!
	do jprod=1,klong
		zprod3(jprod)=(pprod1(jprod)*zpoiv1+pprod2(jprod)*zpoiv2)/zdeno
	enddo
else
	!
	! Article de type extensif dans le temps.
	!
	do jprod=1,klong
		zprod3(jprod)=pprod1(jprod)*zpoie1+pprod2(jprod)*zpoie2
	enddo
endif
!
! Ecriture du champ combine sur le fichier de sortie.
! ---------------------------------------------------
!
if(cdadcou(1:3) == 'VPP'.or.cdadcou(1:3) == 'VEP') then
	!
	! Variables de coordonnees instantanees.
	!
	if(cdconf(1:14) == 'SOMME_PONDEREE' &
& 		.or.cdconf(1:14) == 'DIFFE_PONDEREE') then
		call lfaecrr(kul3,cdadcou,zprod3,klong)
	elseif(cdconf(1:14) == 'DIFFE_EC2_EC1 ' &
& 		.and.cdadcou(4:4) == '1') then
		call lfaecrr(kul3,cdadcou,pprod2,klong)
		cdadcou(4:4)='0'
		call lfaecrr(kul3,cdadcou,pprod1,klong)
	elseif(cdconf(1:14) == 'DIFFE_EC2_EC1 ' &
& 		.and.cdadcou(4:4) == '0') then
		!
		! Rien a faire: ce champ n'a pas sa place
		! dans le fichier resultant.
		!
	elseif(cdconf(1:14) == 'DIFFE_EXP_REFE') then
		call lfaecrr(kul3,cdadcou,pprod1,klong)
	elseif(cdconf(1:14) == 'SOMME_CONTIGUE' &
& 		.and.cdadcou(4:4) == '0') then
		call lfaecrr(kul3,cdadcou,pprod1,klong)
	elseif(cdconf(1:14) == 'SOMME_CONTIGUE' &
& 		.and.cdadcou(4:4) == '1') then
		call lfaecrr(kul3,cdadcou,pprod2,klong)
	else
		print*,'DDHT/SOMDD/ERREUR: var. non coord.'
		stop 'call abort'
	endif
elseif(cdadcou(1:1) == 'V') then
	!
	! Variables non de coordonnees instantanees.
	!
	if(cdconf(1:14) == 'DIFFE_EXP_REFE' &
& 		.or.cdconf(1:14) == 'DIFFE_PONDEREE' &
& 		.or.cdconf(1:14) == 'SOMME_PONDEREE') then
		call lfaecrr(kul3,cdadcou,zprod3,klong)
	elseif(cdconf(1:14) == 'DIFFE_EC2_EC1 ' &
& 		.and.cdadcou(4:4) == '1') then
		call lfaecrr(kul3,cdadcou,pprod2,klong)
		cdadcou(4:4)='0'
		call lfaecrr(kul3,cdadcou,pprod1,klong)
	elseif(cdconf(1:14) == 'DIFFE_EC2_EC1 ' &
& 		.and.cdadcou(4:4) == '0') then
		! Rien a lfare: ce champ n'a pas sa place
		! dans le fichier resultant.
	elseif(cdconf(1:14) == 'SOMME_CONTIGUE' &
& 		.and.cdadcou(4:4) == '0') then
		call lfaecrr(kul3,cdadcou,pprod1,klong)
	elseif(cdconf(1:14) == 'SOMME_CONTIGUE' &
& 		.and.cdadcou(4:4) == '1') then
		call lfaecrr(kul3,cdadcou,pprod2,klong)
	else
		print*,'DDHT/SOMDD/ERREUR: var. ccord.'
		stop 'call abort'
	endif
elseif(cdadcou(1:1) == 'P') then
	!
	! Masse cumulee.
	!
	if(cdconf(1:14) == 'DIFFE_EXP_REFE') then
		call lfaecrr(kul3,cdadcou,pprod1,klong)
	else
		call lfaecrr(kul3,cdadcou,zprod3,klong)
	endif
elseif(cdadcou(1:1) == 'F'.or.cdadcou(1:1) == 'T') then
	!
	! Flux ou tendance.
	!
	call lfaecrr(kul3,cdadcou,zprod3,klong)
else
	!
	! Erreur: type de champ non prevu.
	!
	print* &
& 		,'DDHT/SOMDD/ERREUR: champ non prevu lors de somme/difference.'
	print*,cdadcou
	stop 'call abort'
endif
end

subroutine calpasd(cgconf,klconf,pech1,pech2,ppoiv1,ppoiv2,pdeno, &
& 	ppoie1,ppoie2)
! --------------------------------------------------------------
! **** *calpasd* Calcul des poids  appliquer lors de sommes ou diffrences.
! --------------------------------------------------------------
! Sujet:
! Arguments explicites:
! Arguments implicites:
! Methode:
! Externes:
! Auteur:   96-03, J.M. Piriou.
! Modifications:
! --------------------------------------------------------------
! En entree:
! cgconf(1:klconf): ex: 'DIFFE_PONDEREE'
! pech1, pech2: chances des fichiers d'entre.
! En sortie:
! ppoiv1, ppoiv2: poids  appliquer aux variables des fichiers 1 et 2 pour les combiner.
! pdeno: dnominateur de normalisation.
! ppoie1, ppoie2: poids  appliquer aux champs extensifs dans le temps des fichiers 1 et 2 pour les combiner.
! --------------------------------------------------------------
implicit none
INTEGER(KIND=4) :: KLCONF
REAL(KIND=8) :: PDENO
REAL(KIND=8) :: PECH1
REAL(KIND=8) :: PECH2
REAL(KIND=8) :: PPOIE1
REAL(KIND=8) :: PPOIE2
REAL(KIND=8) :: PPOIV1
REAL(KIND=8) :: PPOIV2
CHARACTER*(*) cgconf
if(cgconf(1:klconf) == 'DIFFE_PONDEREE') then
	!
	! On effectue la difference ponderee entre les deux fichiers.
	!
	ppoiv1=-pech1
	ppoiv2=pech2
	pdeno=ppoiv1+ppoiv2
	ppoie1=-1.
	ppoie2= 1.
elseif(cgconf(1:5) == 'DIFFE') then
	!
	! On effectue la difference entre les deux fichiers.
	!
	ppoiv1=-1.
	ppoiv2= 1.
	pdeno= 1.
	ppoie1=-1.
	ppoie2= 1.
elseif(cgconf(1:5) == 'SOMME') then
	ppoiv1=pech1
	ppoiv2=pech2
	pdeno=ppoiv1+ppoiv2
	ppoie1= 1.
	ppoie2= 1.
else
	print*,'ddht/ERREUR dans calpasd: options de combinee.'
	stop 'call abort'
endif
end

subroutine somd_sol(kul1,kul2,kul3,knomvif,knomf,pech1,pech2,kdom)
! --------------------------------------------------------------------------
! **** *somd_sol* Traitement des champs sol.
! --------------------------------------------------------------------------
! Sujet:
! ------
! Arguments explicites: /
! ---------------------
! Arguments implicites: /
! ---------------------
! Methode:
! --------
! Externes: /
! ---------
! Original :
! ----------
! 94-11-16, J.M. Piriou.
!
! Modifications:
! --------------
! 96-03-26, J.M. Piriou: autres options que DIFFE_EC2_EC1.
! --------------------------------------------------------------------------
! En entree:
! kul1     unite logique du fichier d'entree 1.
! kul2     unite logique du fichier d'entree 2.
! kul3     unite logique du fichier de sortie 3.
! knomvif  nombre de variables initiales ou finales.
! knomf    nombre de flux.
! pech1    chance du fichier 1.
! pech2    chance du fichier 2.
! En sortie:
! ecriture des champs sol modifies sur le fichier de sortie kul3.
! --------------------------------------------------------------------------
implicit none
#include"ddhpar.h"
#include"ddht_yom_ent.h"
!
INTEGER(KIND=4) :: KUL1
INTEGER(KIND=4) :: KUL2
INTEGER(KIND=4) :: KUL3
INTEGER(KIND=4) :: KNOMF
INTEGER(KIND=4) :: KNOMVIF
REAL(KIND=8) :: PECH1
INTEGER(KIND=4) :: KDOM
REAL(KIND=8) :: PECH2
REAL(KIND=8) :: ZPOIV1
REAL(KIND=8) :: ZDENO
REAL(KIND=8) :: ZPOIE1
REAL(KIND=8) :: ZPOIV2
INTEGER(KIND=4) :: INOMVS
INTEGER(KIND=4) :: JVAR
REAL(KIND=8) :: ZPOIE2
CHARACTER*200 :: CLSOL
INTEGER(KIND=4) :: ILONG
INTEGER(KIND=4) :: JCHAMP
INTEGER(KIND=4) :: IREP
INTEGER(KIND=4) :: JDOM
REAL(KIND=8) :: ZMOY

CHARACTER*200 :: CGCONF
CHARACTER*200 :: CGNFE1
CHARACTER*200 :: CGNFE2
CHARACTER*200 :: CGNFLC
CHARACTER*200 :: CGNFSO
LOGICAL :: LGDEBU
LOGICAL :: LGFILAF
LOGICAL :: LGRENS

REAL(KIND=8) zsols1(jpdom) ! tableau de donnees au sol.
REAL(KIND=8) zsols2(jpdom) ! tableau de donnees au sol.
REAL(KIND=8) zsols3(jpdom) ! tableau de donnees au sol.
!
! On rend fatale toute erreur de lecture du fichier.
!
call lfaerf(kul1,.true.)
if(cgconf(1:5) == 'SOMME'.or.cgconf(1:5) == 'DIFFE') then
	!
	! Il faut lire le deuxieme champ.
	!
	call lfaerf(kul2,.true.)
	!
	! Calcul des poids  appliquer lors de sommes ou diffrences.
	!
	call calpasd(cgconf,len_trim(cgconf),pech1,pech2,zpoiv1,zpoiv2,zdeno, &
& 		zpoie1,zpoie2)
	!
	! Traitement des variables.
	!
	inomvs=knomvif ! nombre de variables initiales ou finales.
	do jvar=0,1
		do jchamp=1,inomvs
			!
			! Lecture des deux champs d'entre.
			!
			write(clsol,fmt='(a,i2.2,a,i1.1)') 'S',jchamp,'_',jvar
			call lfalecr(kul1,clsol,jpdom,zsols1,ilong,irep)
			call lfalecr(kul2,clsol,jpdom,zsols2,ilong,irep)
			!
			! On combine les deux champs d'entre.
			!
			do jdom=1,kdom
				zsols3(jdom)=(zsols1(jdom)*zpoiv1+zsols2(jdom)*zpoiv2)/zdeno
			enddo
			if(cgconf(1:14) == 'DIFFE_EXP_REFE' &
& 				.or.cgconf(1:14) == 'DIFFE_PONDEREE' &
& 				.or.cgconf(1:14) == 'SOMME_PONDEREE') then
				write(clsol,fmt='(a,i2.2,a,i1.1)') 'S',jchamp,'_',jvar
				call lfaecrr(kul3,clsol,zsols3,kdom)
			elseif(cgconf(1:14) == 'DIFFE_EC2_EC1 '.and.jvar == 1) then
				write(clsol,fmt='(a,i2.2,a,i1.1)') 'S',jchamp,'_',1
				call lfaecrr(kul3,clsol,zsols2,kdom)
				write(clsol,fmt='(a,i2.2,a,i1.1)') 'S',jchamp,'_',0
				call lfaecrr(kul3,clsol,zsols1,kdom)
			elseif(cgconf(1:14) == 'DIFFE_EC2_EC1 '.and.jvar == 0) then
				! Rien a lfare: ce champ n'a pas sa place
				! dans le fichier resultant.
			elseif(cgconf(1:14) == 'SOMME_CONTIGUE'.and.jvar == 0) then
				write(clsol,fmt='(a,i2.2,a,i1.1)') 'S',jchamp,'_',0
				call lfaecrr(kul3,clsol,zsols1,kdom)
			elseif(cgconf(1:14) == 'SOMME_CONTIGUE'.and.jvar == 1) then
				write(clsol,fmt='(a,i2.2,a,i1.1)') 'S',jchamp,'_',1
				call lfaecrr(kul3,clsol,zsols2,kdom)
			else
				!
				! Autres cas; ils sont non prevus.
				!
				print*,'ddht/ATTENTION: traitement des champs sol de l''option ', &
& 					cgconf(1:len_trim(cgconf)),' non encore implemente.'
				return
			endif
		enddo
	enddo
	!
	! Traitement des flux.
	!
	inomvs=knomf ! nombre de flux.
	do jchamp=1,inomvs
		!
		! Lecture des deux champs d'entre.
		!
		write(clsol,fmt='(a,i2.2)') 'G',jchamp
		call lfalecr(kul1,clsol,jpdom,zsols1,ilong,irep)
		call lfalecr(kul2,clsol,jpdom,zsols2,ilong,irep)
		!
		! On combine les deux champs d'entre.
		!
		do jdom=1,kdom
			zsols3(jdom)=zsols1(jdom)*zpoie1+zsols2(jdom)*zpoie2
		enddo
		call lfaecrr(kul3,clsol,zsols3,kdom)
	enddo
elseif(cgconf(1:len_trim(cgconf)) == 'MOY_HORIZ') then
	!
	! Traitement des variables.
	!
	inomvs=knomvif ! nombre de variables initiales ou finales.
	do jvar=0,1
		do jchamp=1,inomvs
			write(clsol,fmt='(a,i2.2,a,i1.1)') 'S',jchamp,'_',jvar
			call lfalecr(kul1,clsol,jpdom,zsols1,ilong,irep)
			!
			! Operation a effectuer sur le champ sol
			! et reecriture d'icelui sur
			! le fichier de sortie.
			!
			! On va moyenner selon l'horizontale.
			!
			zmoy=0.
			do jdom=1,ilong
				zmoy=zmoy+zsols1(jdom)/float(ilong)
			enddo
			call lfaecrr(kul3,clsol,zmoy,1)
		enddo
	enddo
	!
	! Traitement des flux.
	!
	inomvs=knomf ! nombre de flux.
	do jchamp=1,inomvs
		write(clsol,fmt='(a,i2.2)') 'G',jchamp
		call lfalecr(kul1,clsol,jpdom,zsols1,ilong,irep)
		!
		! Operation a effectuer sur le champ sol
		! et reecriture d'icelui sur
		! le fichier de sortie.
		!
		! On va moyenner selon l'horizontale.
		!
		zmoy=0.
		do jdom=1,ilong
			zmoy=zmoy+zsols1(jdom)/float(ilong)
		enddo
		call lfaecrr(kul3,clsol,zmoy,1)
	enddo
elseif(cgconf(1:len_trim(cgconf)) == 'MOY_VERTIC') then
	!
	! Traitement des variables.
	!
	inomvs=knomvif ! nombre de variables initiales ou finales.
	do jvar=0,1
		do jchamp=1,inomvs
			write(clsol,fmt='(a,i2.2,a,i1.1)') 'S',jchamp,'_',jvar
			!
			!-------------------------------------------------
			! Simple recopie d'un article d'un fichier  l'autre.
			!-------------------------------------------------
			!
			call lfacop(kul1,clsol,clsol,kul3)
		enddo
	enddo
	!
	! Traitement des flux.
	!
	inomvs=knomf ! nombre de flux.
	do jchamp=1,inomvs
		write(clsol,fmt='(a,i2.2)') 'G',jchamp
		!
		!-------------------------------------------------
		! Simple recopie d'un article d'un fichier  l'autre.
		!-------------------------------------------------
		!
		call lfacop(kul1,clsol,clsol,kul3)
	enddo
else
	!
	! Autres cas; ils sont non prevus.
	!
	print* &
& 		,'ddht/ATTENTION: traitement des champs sol de l''option ', &
& 		cgconf(1:len_trim(cgconf)),' non encore implemente.'
	return
endif
end

subroutine somd_libres(kul1,kul2,kul3,knomvif,knomf,pech1,pech2,kdom)
! --------------------------------------------------------------------------
! **** *somd_libres* Traitement des champs libres.
! --------------------------------------------------------------------------
! Sujet:
! ------
! Arguments explicites: /
! ---------------------
! Arguments implicites: /
! ---------------------
! Methode:
! --------
! Externes: /
! ---------
! Original :
! ----------
! 2003-10-29, J.M. Piriou.
!
! Modifications:
! --------------
! --------------------------------------------------------------------------
! En entree:
! kul1     unite logique du fichier d'entree 1.
! kul2     unite logique du fichier d'entree 2.
! kul3     unite logique du fichier de sortie 3.
! knomvif  nombre de variables finales.
! knomf    nombre de flux.
! pech1    chance du fichier 1.
! pech2    chance du fichier 2.
! En sortie:
! ecriture des champs libres modifies sur le fichier de sortie kul3.
! --------------------------------------------------------------------------
implicit none
#include"ddhpar.h"
#include"ddht_yom_ent.h"
!
CHARACTER*200 :: CGCONF
CHARACTER*200 :: CGNFE1
CHARACTER*200 :: CGNFE2
CHARACTER*200 :: CGNFLC
CHARACTER*200 :: CGNFSO
LOGICAL :: LGDEBU
LOGICAL :: LGFILAF
LOGICAL :: LGRENS
INTEGER(KIND=4) :: KNOMF
INTEGER(KIND=4) :: KNOMVIF
INTEGER(KIND=4) :: KUL1
INTEGER(KIND=4) :: KUL2
INTEGER(KIND=4) :: KUL3
REAL(KIND=8) :: PECH1
REAL(KIND=8) :: PECH2
INTEGER(KIND=4) :: INOMVS
INTEGER(KIND=4) :: KDOM
REAL(KIND=8) :: ZDENO
REAL(KIND=8) :: ZPOIE1
REAL(KIND=8) :: ZPOIE2
REAL(KIND=8) :: ZPOIV1
REAL(KIND=8) :: ZPOIV2
CHARACTER*200 :: CLLIBRE
INTEGER(KIND=4) :: ILONG
INTEGER(KIND=4) :: IREP
INTEGER(KIND=4) :: JCHAMP
INTEGER(KIND=4) :: JDOM
REAL(KIND=8) :: ZMOY

REAL(KIND=8) zlibres1(jpdom)
REAL(KIND=8) zlibres2(jpdom)
REAL(KIND=8) zlibres3(jpdom)
!
! On rend fatale toute erreur de lecture du fichier.
!
call lfaerf(kul1,.true.)
if(cgconf(1:5) == 'SOMME'.or.cgconf(1:5) == 'DIFFE') then
	!
	! Il faut lire le deuxieme champ.
	!
	call lfaerf(kul2,.true.)
	!
	! Calcul des poids  appliquer lors de sommes ou diffrences.
	!
	call calpasd(cgconf,len_trim(cgconf),pech1,pech2,zpoiv1,zpoiv2,zdeno, &
& 		zpoie1,zpoie2)
	!
	! Traitement des variables.
	!
	inomvs=knomvif ! nombre de variables initiales ou finales.
	do jchamp=1,inomvs
		!
		! Lecture des deux champs d'entre.
		!
		write(cllibre,fmt='(a,i2.2)') 'SVGFS',jchamp
		call lfalecr(kul1,cllibre,jpdom,zlibres1,ilong,irep)
		call lfalecr(kul2,cllibre,jpdom,zlibres2,ilong,irep)
		!
		! On combine les deux champs d'entre.
		!
		do jdom=1,kdom
			zlibres3(jdom)=(zlibres1(jdom)*zpoiv1+zlibres2(jdom)*zpoiv2)/zdeno
		enddo
		if(cgconf(1:14) == 'DIFFE_EXP_REFE' &
& 				.or.cgconf(1:14) == 'DIFFE_PONDEREE' &
& 				.or.cgconf(1:14) == 'SOMME_PONDEREE') then
			write(cllibre,fmt='(a,i2.2)') 'SVGFS',jchamp
			call lfaecrr(kul3,cllibre,zlibres3,kdom)
		elseif(cgconf(1:14) == 'DIFFE_EC2_EC1 ') then
			write(cllibre,fmt='(a,i2.2)') 'SVGFS',jchamp
			call lfaecrr(kul3,cllibre,zlibres2,kdom)
		elseif(cgconf(1:14) == 'SOMME_CONTIGUE') then
			write(cllibre,fmt='(a,i2.2)') 'SVGFS',jchamp
			call lfaecrr(kul3,cllibre,zlibres2,kdom)
		else
			!
			! Autres cas; ils sont non prevus.
			!
			print*,'ddht/ATTENTION: traitement des champs libres de l''option ', &
& 					cgconf(1:len_trim(cgconf)),' non encore implemente.'
			return
		endif
	enddo
	!
	! Traitement des flux.
	!
	inomvs=knomf ! nombre de flux.
	do jchamp=1,inomvs
		!
		! Lecture des deux champs d'entre.
		!
		write(cllibre,fmt='(a,i2.2)') 'SFGFS',jchamp
		call lfalecr(kul1,cllibre,jpdom,zlibres1,ilong,irep)
		call lfalecr(kul2,cllibre,jpdom,zlibres2,ilong,irep)
		!
		! On combine les deux champs d'entre.
		!
		do jdom=1,kdom
			zlibres3(jdom)=zlibres1(jdom)*zpoie1+zlibres2(jdom)*zpoie2
		enddo
		call lfaecrr(kul3,cllibre,zlibres3,kdom)
	enddo
elseif(cgconf(1:len_trim(cgconf)) == 'MOY_HORIZ') then
	!
	! Traitement des variables.
	!
	inomvs=knomvif ! nombre de variables initiales ou finales.
	do jchamp=1,inomvs
		write(cllibre,fmt='(a,i2.2)') 'SVGFS',jchamp
		call lfalecr(kul1,cllibre,jpdom,zlibres1,ilong,irep)
		!
		! Operation a effectuer sur le champ libre
		! et reecriture d'icelui sur
		! le fichier de sortie.
		!
		! On va moyenner selon l'horizontale.
		!
		zmoy=0.
		do jdom=1,ilong
			zmoy=zmoy+zlibres1(jdom)/float(ilong)
		enddo
		call lfaecrr(kul3,cllibre,zmoy,1)
	enddo
	!
	! Traitement des flux.
	!
	inomvs=knomf ! nombre de flux.
	do jchamp=1,inomvs
		write(cllibre,fmt='(a,i2.2)') 'SVGFS',jchamp
		call lfalecr(kul1,cllibre,jpdom,zlibres1,ilong,irep)
		!
		! Operation a effectuer sur le champ libre
		! et reecriture d'icelui sur
		! le fichier de sortie.
		!
		! On va moyenner selon l'horizontale.
		!
		zmoy=0.
		do jdom=1,ilong
			zmoy=zmoy+zlibres1(jdom)/float(ilong)
		enddo
		call lfaecrr(kul3,cllibre,zmoy,1)
	enddo
elseif(cgconf(1:len_trim(cgconf)) == 'MOY_VERTIC') then
	!
	! Traitement des variables.
	!
	inomvs=knomvif ! nombre de variables initiales ou finales.
	do jchamp=1,inomvs
		write(cllibre,fmt='(a,i2.2)') 'SVGFS',jchamp
		!
		!-------------------------------------------------
		! Simple recopie d'un article d'un fichier  l'autre.
		!-------------------------------------------------
		!
		call lfacop(kul1,cllibre,cllibre,kul3)
	enddo
	!
	! Traitement des flux.
	!
	inomvs=knomf ! nombre de flux.
	do jchamp=1,inomvs
		write(cllibre,fmt='(a,i2.2)') 'SFGFS',jchamp
		!
		!-------------------------------------------------
		! Simple recopie d'un article d'un fichier  l'autre.
		!-------------------------------------------------
		!
		call lfacop(kul1,cllibre,cllibre,kul3)
	enddo
else
	!
	! Autres cas; ils sont non prevus.
	!
	print* &
& 		,'ddht/ATTENTION: traitement des champs libres de l''option ', &
& 		cgconf(1:len_trim(cgconf)),' non encore implemente.'
	return
endif
end
