      PROGRAM TESTFA
C****
C        Programme *TESTFA* - programme interactif de test
C     des interfaces de fichier ARPEGE.
C
#include "precision.h"
C
#include "facom0.h"
#include "facomp.h"
#include "facom1.h"
C
C Nombre maximal de valeurs dans un champ ARPEGE traite par testfa
C C'est soit 2*(nb latitudes)**2, soit (troncature + 1)*(troncature + 2)
C sachant que nb de latitudes = 1/2 * (2*troncature + 1) pour une
C grille lineaire et reguliere.
C (pour Aladin, nb de latitudes = 2*troncature + 1).
C
C JPXVAL remplace JPXCHA dans testfa (Avril 2004) pour ne pas demander
C trop de memoire lors des tests. Cela permet aussi de mesurer
C correctement l'impact memoire d'un changement de JPXTRO ou JPXLAT.
C
      INTEGER JPXVAL
      PARAMETER ( JPXVAL=2*(359**2) )
C
      INTEGER IREP, INPUT, J, INULOG, INUMER, INIMES, INBARP, INBARI, I1
      INTEGER INIVAU, INGRIB, INBITS, ISTRON, IPUILA, INUME1, I2
      INTEGER INUME2, ITYPTR, ITRONC, INLATI, INXLON, INIVER, INPARH, I3
      INTEGER INOZMX, INPAHE, INIMPL, INGEOM, INALDO, INTROU, INARES
      INTEGER INAMAX, IXNIVV, IXTRON, IXLATI, IXLONG, INBPDG, INBCSP
      INTEGER IDMOPL, ILONG, IPOSEX, ILONUT, IMULT, IADD, IOPTIO, INPUT2
      INTEGER ILNOMA, IDECAL, IAUXIL, IFACTM, IFACMD, IRANGC, IVAL, IOPT
C
      INTEGER INLOPA (JPXPAH), INOZPA (JPXIND), IDATEF (JPLDAT)
      INTEGER ICODPA (6)
      INTEGER (KIND=JPDBLE) IVALCO (2+JPXVAL)
C
      REAL (KIND=JPDBLR) ZPIS2, ZSLAPO, ZCLOPO, ZSLOPO, ZCODIL, ZPREFE
      REAL (KIND=JPDBLR) ZCOSLA, ZCOEFF, ZLATIT
C
      REAL (KIND=JPDBLR) ZTAB (JPXVAL), ZAHYBR (0:JPXNIV)
      REAL (KIND=JPDBLR) ZBHYBR (0:JPXNIV)
      REAL (KIND=JPDBLR) ZSINLA (JPXGEO), ZVALCO (2+JPXVAL)
C
      CHARACTER CLNOMF*128, CLSTTU*7, CLOPER*4, CLCLEF*5
      CHARACTER*(JPXNOM) CLNOM1, CLNOM2, CLNOMC, CLPREF, CLSUFF, CLIDEN
C
      LOGICAL LLNOMM, LLERFA, LLIMST, LLAVAN, LLDEBU, LLRECU, LLCOSP
      LOGICAL LLGARD, LLTOUT, LLEXIS, LLFRAN, LLOUVR
C
      LOGICAL LLMLAM, LLOPT
C
      EQUIVALENCE (IVALCO,ZVALCO)
C
      SAVE IDATEF
C
      DATA IDATEF / 1990,  2, 15, 12,  0,   1,  0, 24,   1, 0, 0 /
C
      ZPIS2=ASIN (1.)
      IREP=JPNIIL
      NFIOUV=0
      INPUT=5
C
   10 CONTINUE
C
      DO 20 J=1,JPXVAL
      ZTAB(J)=J
   20 CONTINUE
C
  100 PRINT *,'ACTION ?'
      READ (UNIT=INPUT,FMT='(A4)',ERR=1000,END=1000) CLOPER
C
      IF (CLOPER.EQ.'STOP') THEN
        PRINT *,
     S  '/// ARRET D''EXECUTION DU PROGRAMME DE TEST PAR ORDRE ''STOP'''
        GOTO 1000
C
      ELSEIF (CLOPER.EQ.'CLOS') THEN
  101   PRINT *,'Numero d''unite logique ?'
        READ (UNIT=INPUT,FMT=*,END=100) INULOG
        IF (INULOG.EQ.INPUT) GOTO 101
        CLOSE (UNIT=INULOG,IOSTAT=IREP)
C
      ELSEIF (CLOPER.EQ.'REWI') THEN
  102   PRINT *,'Numero d''unite logique ?'
        READ (UNIT=INPUT,FMT=*,END=100) INULOG
        IF (INULOG.EQ.INPUT) GOTO 102
        REWIND (UNIT=INULOG,IOSTAT=IREP)
C
      ELSEIF (CLOPER.EQ.'OUV'.OR.CLOPER.EQ.'ITOU') THEN
        PRINT *,
     S'INUMER, LLNOMM, CLNOMF, CLSTTU, LLERFA, LLIMST, INIMES, INBARP,',
     S' CLNOMC ?'
        READ (UNIT=INPUT,FMT=*,END=100)
     S INUMER,LLNOMM,CLNOMF,CLSTTU,LLERFA,LLIMST,INIMES,INBARP,CLNOMC
        CALL FAITOU (IREP,INUMER,LLNOMM,CLNOMF,CLSTTU,LLERFA,LLIMST,
     S               INIMES,INBARP,INBARI,CLNOMC)
C
      ELSEIF (CLOPER.EQ.'ISAN') THEN
C
        PRINT *,'INUMER, CLNOMA, ILONG ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER,CLNOMA,ILONG
        IF (ILONG.GT.JPXVAL) GOTO 800
        CALL FAISAN (IREP,INUMER,CLNOMA,ZTAB,ILONG)
C
      ELSEIF (CLOPER.EQ.'ISAS') THEN
C
        PRINT *,'INUMER ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER
        IF (ILONG.GT.JPXVAL) GOTO 800
        CALL FAISAN (IREP,INUMER,CLNOMA(:ILNOMA),ZVALCO,ILONG)
C
      ELSEIF (CLOPER.EQ.'UTIF') THEN
C
        PRINT *,'INUMER, CLIDEN ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER,CLIDEN
        CALL FAUTIF (IREP,INUMER,CLIDEN)
C
      ELSEIF (CLOPER.EQ.'LSIF') THEN
C
        PRINT *,'INUMER ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER
        CALL FALSIF (IREP,INUMER,CLIDEN)
        PRINT *,'Identificateur du Fichier = ',CLIDEN
C
      ELSEIF (CLOPER.EQ.'NION') THEN
C
        PRINT *,'INUMER, CLPREF, INIVAU, CLSUFF ?'
        READ (UNIT=INPUT,FMT=*,END=100)
     S    INUMER,CLPREF,INIVAU,CLSUFF
        CALL FANION (IREP,INUMER,CLPREF,INIVAU,CLSUFF,LLEXIS,LLCOSP,
     S               INGRIB,INBITS,ISTRON,IPUILA)
        PRINT *,'LLEXIS= ',LLEXIS,', LLCOSP= ',LLCOSP,
     S               ',INGRIB= ',INGRIB,', INBITS= ',INBITS,
     S ',ISTRON= ',ISTRON,', IPUILA= ',IPUILA
C
      ELSEIF (CLOPER.EQ.'COCH') THEN
C
        PRINT *,'INUME1, INUME2, CLPREF, INIVAU, CLSUFF ?'
        READ (UNIT=INPUT,FMT=*,END=100)
     S    INUME1,INUME2,CLPREF,INIVAU,CLSUFF
        CALL FACOCH (IREP,INUME1,INUME2,CLPREF,INIVAU,CLSUFF)
C
      ELSEIF (CLOPER.EQ.'IENC') THEN
C
        PRINT *,'INUMER, CLPREF, INIVAU, CLSUFF, LLCOSP ?'
        READ (UNIT=INPUT,FMT=*,END=100)
     S    INUMER,CLPREF,INIVAU,CLSUFF,LLCOSP
        CALL FAIENC (IREP,INUMER,CLPREF,INIVAU,CLSUFF,ZTAB,LLCOSP)
C
      ELSEIF (CLOPER.EQ.'TRAN') THEN
C
        PRINT *,'INUMER, LLOPT ?'
        PRINT *,'(si LLOPT=.T., le champ passe du rangt selon modele',
     S          ' (vertic.) au rangt selon FA+GRIBversion0)'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER, LLOPT
C On transfere les donnees de ZTAB dans ZVALCO pour pouvoir
C recuperer le champ transpose dans ZTAB
        ZVALCO(1:JPXVAL)=ZTAB
        CALL FATRAN (IREP,INUMER,ZVALCO,ZTAB,LLOPT)
C
      ELSEIF (CLOPER.EQ.'RPAR') THEN
C
        PRINT *,'CLPREF, CLSUFF, ICODPA(1:6) ?'
        PRINT *,' Attention, un parametre a la fois!'
        PRINT *,'            et penser a donner les 6 descripteurs',
     S          ' GRIBEX: KSEC1(1,6:9 et 18)'
        PRINT *,'  soit : version de la tab par.+ indic. parametre'
        PRINT *,'      + indicateur type de nv + niveau'
        PRINT *,'      + 2ieme nv si couche + indic. type de champ'
        READ (UNIT=INPUT,FMT=*,END=100) CLPREF, CLSUFF, ICODPA(1:6)
        J = 1
        CALL FARPAR ( IREP, CLPREF, CLSUFF, ICODPA, J )
        PRINT *,' FARPAR: il est encore possible de definir ',J,
     S          ' parametres nouveaux'
C
      ELSEIF (CLOPER.EQ.'COND') THEN
C
        PRINT *,'INUMER, CLPREF, INIVAU, CLSUFF, LLCOSP ?'
        READ (UNIT=INPUT,FMT=*,END=100)
     S    INUMER,CLPREF,INIVAU,CLSUFF,LLCOSP
        CALL FACOND (IREP,INUMER,CLPREF,INIVAU,CLSUFF,ZTAB,LLCOSP,
     S               CLNOMA,ILNOMA,ZVALCO,ILONG)
        PRINT *,'ILNOMA=',ILNOMA,', CLNOMA="',CLNOMA(:ILNOMA),'"',
     S          ', ILONG=',ILONG
C
        IF (IVALCO(1).EQ.0) THEN
          PRINT *,'IVALCO(1:2)=',(IVALCO(J),J=1,2)
        ELSE
C
          IF (IVALCO(2).EQ.1) THEN
            IDECAL=5
          ELSE
            IDECAL=3
          ENDIF
C
          PRINT *,'IVALCO(1:',IDECAL,')=',(IVALCO(J),J=1,IDECAL)
C
          IF (IVALCO(1).EQ.2) THEN
            PRINT *,'ZVALCO(',IDECAL+1,':',IDECAL+2,')=',
     S              (ZVALCO(IDECAL+J),J=1,2)
          ENDIF
C
        ENDIF
C
      ELSEIF (CLOPER.EQ.'LAIS') THEN
C
        PRINT *,'INUMER, CLNOMA, ILONG ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER,CLNOMA,ILONG
        IF (ILONG.GT.JPXVAL) GOTO 800
        CALL FALAIS (IREP,INUMER,CLNOMA,ZTAB,ILONG)
C
      ELSEIF (CLOPER.EQ.'LAID') THEN
C
        PRINT *,'INUMER, CLNOMA, ILONG ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER,CLNOMA,ILONG
        IF (ILONG.GT.JPXVAL) GOTO 800
        CALL FALAIS (IREP,INUMER,CLNOMA,ZVALCO,ILONG)
C
      ELSEIF (CLOPER.EQ.'CILE') THEN
C
        PRINT *,'INUMER, CLPREF, INIVAU, CLSUFF, LLCOSP ?'
        READ (UNIT=INPUT,FMT=*,END=100)
     S    INUMER,CLPREF,INIVAU,CLSUFF,LLCOSP
        CALL FACILE (IREP,INUMER,CLPREF,INIVAU,CLSUFF,ZTAB,LLCOSP)
C
      ELSEIF (CLOPER.EQ.'DECO') THEN
C
C
        IF (IVALCO(1).EQ.0) THEN
          PRINT *,'IVALCO(1:2)=',(IVALCO(J),J=1,2)
        ELSE
C
          IF (IVALCO(2).EQ.1) THEN
            IDECAL=5
          ELSE
            IDECAL=3
          ENDIF
C
          PRINT *,'IVALCO(1:',IDECAL,')=',(IVALCO(J),J=1,IDECAL)
C
          IF (IVALCO(1).EQ.2) THEN
            PRINT *,'ZVALCO(',IDECAL+1,':',IDECAL+2,')=',
     S              (ZVALCO(IDECAL+J),J=1,2)
          ENDIF
C
        ENDIF
        PRINT *,'******               ATTENTION                *******'
        PRINT *,'* IL FAUT AVOIR EXECUTE L''ACTION LAID AU PREALABLE *'
        PRINT *,'*     (OBTENTION DES VALEURS BRUTES DU CHAMP)       *'
        PRINT *
        PRINT *,'INUMER, CLPREF, INIVAU, CLSUFF, LLCOSP ?'
        READ (UNIT=INPUT,FMT=*,END=100)
     S    INUMER,CLPREF,INIVAU,CLSUFF,LLCOSP
        CALL FADECO (IREP,INUMER,CLPREF,INIVAU,CLSUFF,LLCOSP,CLNOMA,
     S               ILNOMA,ZVALCO,ILONG,ZTAB)
        PRINT *,'CLNOMA(:',ILNOMA,') = "',CLNOMA(:ILNOMA),'"'
C
      ELSEIF (CLOPER.EQ.'CADE') THEN
C
        PRINT *,
     S'CLNOMC, ITYPTR, ZSLAPO, ZCLOPO, ZSLOPO, ZCODIL, ITRONC, INLATI,',
     S' INXLON, INIVER, LLGARD ?'
        READ (UNIT=INPUT,FMT=*,END=100)
     S CLNOMC,ITYPTR,ZSLAPO,ZCLOPO,ZSLOPO,ZCODIL,ITRONC,INLATI,
     S INXLON,INIVER,LLGARD
C
        IF (ITYPTR .LE. -1) THEN
           LLMLAM=.TRUE.
        ELSE
           LLMLAM=.FALSE.
        ENDIF
C
        INIVAU=MIN (JPXNIV,MAX (1,INIVER))
        INLATI=MIN (JPXLAT,INLATI)
        INPARH=(1+INLATI)/2
        INOZMX=(INXLON-1)/3
        ZPREFE=1.E+5
C
C         On definit en fait une coordonnee sigma.
C
        DO 111 J=0,INIVAU
        ZAHYBR(J)=0.
        ZBHYBR(J)=REAL (J) / REAL (INIVAU)
  111   CONTINUE
C
        IF (.NOT.LLMLAM) THEN

C       Nombre de points effectivement variable en latitude.
C
        ZCOEFF=ZPIS2/REAL (2*(INLATI/2))
C
        DO 112 J=1,INPARH
        ZLATIT=ZCOEFF*REAL (INLATI+1-2*J)
        ZSINLA(J)=SIN (ZLATIT)
        ZCOSLA=COS (ZLATIT)
        IAUXIL=INT ( REAL (INOZMX) * (ZCOSLA+1.E-12) )
        INOZPA(J)= MAX ( 5, IAUXIL )
        INLOPA(J)=3*INOZPA(J)+3
  112   CONTINUE
C
        ELSE
C
        DO 151 J=1,JPXIND
           INOZPA(J)=0
  151   CONTINUE
C
        INLOPA(1)=10
        INLOPA(2)=1
        INLOPA(3)=1
        INLOPA(4)=119
        INLOPA(5)=1
        INLOPA(6)=119
        INLOPA(7)=15
        INLOPA(8)=15
        DO 153 J=9,JPXPAH
           INLOPA(J)=0
  153   CONTINUE
C
        ZSINLA(1)=0.
        ZSINLA(2)=0.
        ZSINLA(3)=0.
        ZSINLA(4)=-.18
        ZSINLA(5)=.4238
        ZSINLA(6)=.769
        ZSINLA(7)=1.034
        ZSINLA(8)=.17453
        ZSINLA(9)=1.047
        ZSINLA(10)=1.
        ZSINLA(11)=1.
        ZSINLA(13)=5448300.
        ZSINLA(14)=5448300.
        ZSINLA(15)=38100.
        ZSINLA(16)=38100.
        ZSINLA(17)=0.1153238E-05
        ZSINLA(18)=0.1153238E-05
        DO 155 J=13,JPXGEO
           ZSINLA(J)=0.
  155   CONTINUE
C
        ENDIF
C
        CALL FACADE (CLNOMC,ITYPTR,ZSLAPO,ZCLOPO,ZSLOPO,ZCODIL,ITRONC,
     S               INLATI,INXLON,INLOPA,INOZPA,ZSINLA,INIVER,ZPREFE,
     S               ZAHYBR,ZBHYBR,LLGARD)
C
      ELSEIF (CLOPER.EQ.'CIES') THEN
C
        PRINT *,'CLNOMC ?'
        READ (UNIT=INPUT,FMT=*,END=100) CLNOMC
        CALL FACIES (CLNOMC,ITYPTR,ZSLAPO,ZCLOPO,ZSLOPO,ZCODIL,ITRONC,
     S               INLATI,INXLON,INLOPA,INOZPA,ZSINLA,INIVER,ZPREFE,
     S               ZAHYBR,ZBHYBR,LLGARD)
C
        IF (ITYPTR .LE. -1) THEN
           LLMLAM=.TRUE.
        ELSE
           LLMLAM=.FALSE.
        ENDIF
C
        IF (.NOT.LLMLAM) THEN
           INPAHE=(1+INLATI)/2
           INIMPL=INPAHE
           INGEOM=INPAHE
        ELSE
           INPAHE=8
           INGEOM=18
           INIMPL=2*INOZPA(1)+4
        ENDIF
C
        PRINT *,'ITYPTR= ',ITYPTR,', ZSLAPO= ',ZSLAPO,', ZCLOPO= ',
     S  ZCLOPO,', ZSLOPO= ',ZSLOPO,', ZCODIL= ',ZCODIL
        PRINT *,', ITRONC= ',ITRONC,', INLATI= ',INLATI,', INXLON=
     S ',INXLON,', LLGARD= ',LLGARD
        PRINT *,'INLOPA= ',(INLOPA(J),J=1,INPAHE)
        PRINT *,'INOZPA= ',(INOZPA(J),J=1,INIMPL)
        PRINT *,'ZSINLA= ',(ZSINLA(J),J=1,INGEOM)
        PRINT *,'ZAHYBR= ',(ZAHYBR(J),J=0,INIVER)
        PRINT *,'ZBHYBR= ',(ZBHYBR(J),J=0,INIVER)
        CALL FANUCA (CLNOMC,IRANGC,.TRUE.)
        PRINT *,'IRANGC= ',IRANGC,', NVAPDG= ',NVAPDG(MAX(1,IRANGC))
C
      ELSEIF (CLOPER.EQ.'CTUM') THEN
C
        PRINT *,'CLNOMC ?'
        READ (UNIT=INPUT,FMT=*,END=100) CLNOMC
        CALL FACTUM (CLNOMC)
C
      ELSEIF (CLOPER.EQ.'CAGE') THEN
C
        PRINT *,'CLNOMC, LLGARD ?'
        READ (UNIT=INPUT,FMT=*,END=100) CLNOMC,LLGARD
        CALL FACAGE (CLNOMC,LLGARD)
C
      ELSEIF (CLOPER.EQ.'AFM') THEN
        PRINT *,'INUMER, IFACTM ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER,IFACTM
        CALL LFIAFM (IREP,INUMER,IFACTM)
C
      ELSEIF (CLOPER.EQ.'SFM') THEN
        PRINT *,'INUMER ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER
        CALL LFISFM (IREP,INUMER)
C
      ELSEIF (CLOPER.EQ.'FMD') THEN
        PRINT *,'IFACMD ?'
        READ (UNIT=INPUT,FMT=*,END=100) IFACMD
        CALL LFIFMD (IFACMD)
C
      ELSEIF (CLOPER.EQ.'FRA') THEN
        PRINT *,'LLFRAN ?'
        READ (UNIT=INPUT,FMT=*,END=100) LLFRAN
        CALL LFIFRA (LLFRAN)
C
      ELSEIF (CLOPER.EQ.'OEF') THEN
        PRINT *,'INUMER ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER
        CALL LFIOEF (IREP,INUMER,LLERFA)
        PRINT *,'LLERFA= ',LLERFA
C
      ELSEIF (CLOPER.EQ.'OMF') THEN
        PRINT *,'INUMER ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER
        CALL LFIOMF (IREP,INUMER,INIMES)
        PRINT *,'INIMES= ',INIMES
C
      ELSEIF (CLOPER.EQ.'OSF') THEN
        PRINT *,'INUMER ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER
        CALL LFIOSF (IREP,INUMER,LLIMST)
        PRINT *,'LLIMST= ',LLIMST
C
      ELSEIF (CLOPER.EQ.'OEF') THEN
        PRINT *,'INUMER ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER
        CALL LFIOEF (IREP,INUMER,LLERFA)
        PRINT *,'LLERFA= ',LLERFA
C
      ELSEIF (CLOPER.EQ.'OEG') THEN
        CALL LFIOEG (INIVAU)
        PRINT *,'INIVAU= ',INIVAU
C
      ELSEIF (CLOPER.EQ.'OMG') THEN
        CALL LFIOMG (INIVAU)
        PRINT *,'INIVAU= ',INIVAU
C
      ELSEIF (CLOPER.EQ.'OSG') THEN
        CALL LFIOSG (INIVAU)
        PRINT *,'INIVAU= ',INIVAU
C
      ELSEIF (CLOPER.EQ.'CFG') THEN
        CALL LFICFG
C
      ELSEIF (CLOPER.EQ.'OFM') THEN
        PRINT *,'INUMER ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER
        CALL LFIOFM (IREP,INUMER,IFACTM,LLOUVR)
        PRINT *,'IFACTM= ',IFACTM,', LLOUVR= ',LLOUVR
C
      ELSEIF (CLOPER.EQ.'OFD') THEN
        CALL LFIOFD (IFACMD)
        PRINT *,'IFACMD= ',IFACMD
C
      ELSEIF (CLOPER.EQ.'NAF') THEN
        PRINT *,'INUMER ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER
        CALL LFINAF (IREP,INUMER,INALDO,INTROU,INARES,INAMAX)
        PRINT *,'INALDO = ',INALDO,', INTROU = ',INTROU,
     S ', INARES = ',INARES,', INAMAX = ',INAMAX
C
      ELSEIF (CLOPER.EQ.'NDAR') THEN
C
        PRINT *,'INUMER, IDATEF ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER, IDATEF
        CALL FANDAR (IREP,INUMER,IDATEF)
C
      ELSEIF (CLOPER.EQ.'RFLU') THEN
C
        PRINT *,
     S 'IXNIVV, IXTRON, IXLATI, IXLONG ?'
        READ (UNIT=INPUT,FMT=*,END=100)
     S  IXNIVV, IXTRON, IXLATI, IXLONG
        CALL FARFLU (IXNIVV,IXTRON,IXLATI,IXLONG)
C
      ELSEIF (CLOPER.EQ.'LIMU') THEN
C
        CALL FALIMU (IXNIVV,IXTRON,IXLATI,IXLONG)
        PRINT *,'IXNIVV = ',IXNIVV,', IXTRON = ',IXTRON,
     S ', IXLATI = ',IXLATI,', IXLONG = ',IXLONG
C
      ELSEIF (CLOPER.EQ.'GOTE') THEN
C
        PRINT *,
     S 'INUMER, INGRIB, INBPDG, INBCSP, ISTRON, IPUILA, IDMOPL ?'
        READ (UNIT=INPUT,FMT=*,END=100)
     S  INUMER, INGRIB, INBPDG, INBCSP, ISTRON, IPUILA, IDMOPL
        CALL FAGOTE (IREP,INUMER,INGRIB,INBPDG,INBCSP,ISTRON,IPUILA,
     S               IDMOPL)
C
      ELSEIF (CLOPER.EQ.'VEUR') THEN
C
        PRINT *,'INUMER ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER
        CALL FAVEUR (IREP,INUMER,INGRIB,INBPDG,INBCSP,ISTRON,IPUILA,
     S               IDMOPL)
        PRINT *,'INGRIB = ',INGRIB,', INBPDG = ',INBPDG,
     S ', INBCSP = ',INBCSP,', ISTRON = ',ISTRON,
     S ', IDMOPL = ',IDMOPL
C
      ELSEIF (CLOPER.EQ.'GIOT') THEN
C
        PRINT *,
     S 'INGRIB, INBPDG, INBCSP, ISTRON, IPUILA, IDMOPL ?'
        READ (UNIT=INPUT,FMT=*,END=100)
     S  INGRIB, INBPDG, INBCSP, ISTRON, IPUILA, IDMOPL
        CALL FAGIOT (INGRIB,INBPDG,INBCSP,ISTRON,IPUILA,IDMOPL)
C
      ELSEIF (CLOPER.EQ.'VORI') THEN
C
        CALL FAVORI (INGRIB,INBPDG,INBCSP,ISTRON,IPUILA,IDMOPL)
        PRINT *,'INGRIB = ',INGRIB,', INBPDG = ',INBPDG,', INBCSP = ',
     S          INBCSP,', ISTRON = ',ISTRON,', IDMOPL = ',IDMOPL
C
      ELSEIF (CLOPER.EQ.'REGU') THEN
C
        PRINT *, 'INUMER, CLCLEF, IVAL, IOPT ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER, CLCLEF, IVAL, IOPT
        CALL FAREGU (INUMER, CLCLEF, IVAL, IOPT)
        IF (IOPT.EQ.0) PRINT *,'INUMER = ',INUMER,' CLCLEF = ',
     S                         CLCLEF,' IVAL = ',IVAL
C
      ELSEIF (CLOPER.EQ.'REGI') THEN
C
        PRINT *, 'CLCLEF, IVAL, IOPT ?'
        READ (UNIT=INPUT,FMT=*,END=100) CLCLEF, IVAL, IOPT
        CALL FAREGI ( CLCLEF, IVAL, IOPT)
        IF (IOPT.EQ.0) PRINT *,' CLCLEF = ',CLCLEF,' IVAL = ',IVAL
C
      ELSEIF (CLOPER.EQ.'DIES') THEN
C
        PRINT *,'INUMER ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER
        CALL FADIES (IREP,INUMER,IDATEF)
        PRINT *,' IDATEF= ', IDATEF
C
      ELSEIF (CLOPER.EQ.'LAP') THEN
        PRINT *,'INUMER, ILONG ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER, ILONG
        IF (ILONG.GT.JPXVAL) GOTO 800
        CALL LFILAP (IREP,INUMER,CLNOMA,ZTAB,ILONG)
        PRINT *,'CLNOMA = "',CLNOMA,'"'
C
      ELSEIF (CLOPER.EQ.'LAS') THEN
        PRINT *,'INUMER, ILONG ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER, ILONG
        IF (ILONG.GT.JPXVAL) GOTO 800
        CALL LFILAS (IREP,INUMER,CLNOMA,ZTAB,ILONG)
        PRINT *,'CLNOMA = "',CLNOMA,'"'
C
      ELSEIF (CLOPER.EQ.'CAP') THEN
        PRINT *,'INUMER, LLRECU ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER, LLRECU
        CALL LFICAP (IREP,INUMER,CLNOMA,ILONG,IPOSEX,LLRECU)
        PRINT *,'CLNOMA = "',CLNOMA,'", ILONG = ',ILONG,
     S ', IPOSEX = ',IPOSEX
C
      ELSEIF (CLOPER.EQ.'CAS') THEN
        PRINT *,'INUMER, LLAVAN ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER, LLAVAN
        CALL LFICAS (IREP,INUMER,CLNOMA,ILONG,IPOSEX,LLAVAN)
        PRINT *,'CLNOMA = "',CLNOMA,'", ILONG = ',ILONG,
     S ', IPOSEX = ',IPOSEX
C
      ELSEIF (CLOPER.EQ.'NFO') THEN
        PRINT *,'INUMER, CLNOMA ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER, CLNOMA
        CALL LFINFO (IREP,INUMER,CLNOMA,ILONG,IPOSEX)
        PRINT *,'ILONG = ',ILONG,', IPOSEX = ',IPOSEX
C
      ELSEIF (CLOPER.EQ.'LAF') THEN
        PRINT *,'INUMER, LLTOUT ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER,LLTOUT
        CALL LFILAF (IREP,INUMER,LLTOUT)
C
      ELSEIF (CLOPER.EQ.'REN') THEN
        PRINT *,'INUMER, CLNOM1, CLNOM2 ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER, CLNOM1,CLNOM2
        CALL LFIREN (IREP,INUMER,CLNOM1,CLNOM2)
C
      ELSEIF (CLOPER.EQ.'SUP') THEN
        PRINT *,'INUMER, CLNOMA ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER, CLNOMA
        CALL LFISUP (IREP,INUMER,CLNOMA,ILONUT)
        PRINT *,'ILONUT = ',ILONUT
C
      ELSEIF (CLOPER.EQ.'POS') THEN
        PRINT *,'INUMER ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER
        CALL LFIPOS (IREP,INUMER)
      ELSEIF (CLOPER.EQ.'PRI') THEN
        PRINT *,'I1, I2, I3 ?'
        READ (UNIT=INPUT,FMT=*,END=100) I1, I2, I3
        I1=MAX (1, MIN (JPXVAL,I1))
        I2=MAX (1, MIN (JPXVAL,I2))
        PRINT *,(ZTAB(J),J=I1,I2,I3)
      ELSEIF (CLOPER.EQ.'INIT') THEN
        GOTO 10
C
      ELSEIF (CLOPER.EQ.'RAZ') THEN
C
        DO 201 J=1,JPXVAL
        ZTAB(J)=0
  201   CONTINUE
C
      ELSEIF (CLOPER.EQ.'TAB') THEN
        PRINT *,'IMULT, IADD, I1, I2, I3 ?'
        READ (UNIT=INPUT,FMT=*,END=100) IMULT,IADD,I1,I2,I3
        I1=MAX (1, MIN (JPXVAL,I1))
        I2=MAX (1, MIN (JPXVAL,I2))
C
        DO 202 J=I1,I2,I3
        ZTAB(J)=IMULT*J+IADD
  202   CONTINUE
C
      ELSEIF (CLOPER.EQ.'FER'.OR.CLOPER.EQ.'IRME') THEN
        PRINT *,'INUMER, CLSTTU ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER, CLSTTU
        CALL FAIRME (IREP,INUMER,CLSTTU)
      ELSEIF (CLOPER.EQ.'STA') THEN
        PRINT *,'INUMER ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER
        CALL LFISTA (IREP,INUMER)
      ELSEIF (CLOPER.EQ.'INI'.OR.CLOPER.EQ.'RINE') THEN
        PRINT *,'IOPTIO ?'
        READ (UNIT=INPUT,FMT=*,END=100) IOPTIO
        CALL FARINE (IOPTIO)
      ELSEIF (CLOPER.EQ.'NSG') THEN
        PRINT *,'INIVAU ?'
        READ (UNIT=INPUT,FMT=*,END=100) INIVAU
        CALL LFINSG (INIVAU)
      ELSEIF (CLOPER.EQ.'NEG') THEN
        PRINT *,'INIVAU ?'
        READ (UNIT=INPUT,FMT=*,END=100) INIVAU
        CALL LFINEG (INIVAU)
      ELSEIF (CLOPER.EQ.'NMSG') THEN
        PRINT *,'INIVAU ?'
        READ (UNIT=INPUT,FMT=*,END=100) INIVAU
        CALL FANMSG (INIVAU)
      ELSEIF (CLOPER.EQ.'NERG') THEN
        PRINT *,'INIVAU ?'
        READ (UNIT=INPUT,FMT=*,END=100) INIVAU
        CALL FANERG (INIVAU)
      ELSEIF (CLOPER.EQ.'NMG') THEN
        PRINT *,'INIVAU ?'
        READ (UNIT=INPUT,FMT=*,END=100) INIVAU
        CALL LFINMG (INIVAU)
      ELSEIF (CLOPER.EQ.'MISO') THEN
        PRINT *,'LLDEBU ?'
        READ (UNIT=INPUT,FMT=*,END=100) LLDEBU
        CALL FAMISO (LLDEBU)
      ELSEIF (CLOPER.EQ.'DEB') THEN
        PRINT *,'LLDEBU ?'
        READ (UNIT=INPUT,FMT=*,END=100) LLDEBU
        CALL LFIDEB (LLDEBU)
      ELSEIF (CLOPER.EQ.'MST') THEN
        PRINT *,'INUMER, LLIMST ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER,LLIMST
        CALL LFIMST (IREP,INUMER,LLIMST)
      ELSEIF (CLOPER.EQ.'TALE') THEN
        PRINT *,'INUMER, LLERFA ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER,LLERFA
        CALL FATALE (IREP,INUMER,LLERFA)
      ELSEIF (CLOPER.EQ.'ERF') THEN
        PRINT *,'INUMER, LLERFA ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER,LLERFA
        CALL LFIERF (IREP,INUMER,LLERFA)
      ELSEIF (CLOPER.EQ.'NIME') THEN
        PRINT *,'INUMER, INIVAU ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER,INIVAU
        CALL FANIME (IREP,INUMER,INIVAU)
      ELSEIF (CLOPER.EQ.'NIM') THEN
        PRINT *,'INUMER, INIMES ?'
        READ (UNIT=INPUT,FMT=*,END=100) INUMER,INIMES
        CALL LFINIM (IREP,INUMER,INIMES)
      ELSEIF (CLOPER.EQ.'CHU') THEN
        PRINT *,'NOUVELLE UNITE LOGIQUE D''INPUT ?'
        READ (UNIT=INPUT,FMT=*,END=100) INPUT2
        INPUT=INPUT2
      ELSEIF (CLOPER.EQ.'FIN'.OR.CLOPER.EQ.'END') THEN
        GOTO 1000
      ELSE
        PRINT *,'ACTION NON PREVUE'
      ENDIF
C
      IF (CLOPER.NE.'INI'.AND.CLOPER.NE.'NSG'.AND.CLOPER.NE.'NEG'
     S    .AND.CLOPER.NE.'NMG') PRINT *,'IREP = ',IREP
      PRINT *,'NFIOUV = ',NFIOUV,' NULOGI = ',
     S         (NULOGI(NULIND(J)),J=1,NFIOUV)
      GOTO 100
C
  800 CONTINUE
      PRINT *,
     S 'Longueur d''article trop grande - maximum du programme = ',
     S            JPXVAL
      GOTO 100
C
 1000 CONTINUE
C
      STOP
      END
