      SUBROUTINE ctor(cDChar_v, Preal_v, K)
C                                                                               
C**** SUBROUTINE ctor - To convert from CHAR to 64-bit REAL
C                                                                               
C        S.Saarinen     ECMWF     27/6/95                                  
C                                                                               
C**   INTERFACE                                                                 
C     ---------                                                                 
C                                                                               
C        CALL ctor(cdChar_v, Preal_v, K)
C     WHERE:
C           cDChar_v = A character-string (INPUT) which contains the
C                      the ASCII-chars to be converted
C           Preal_v  = 64-bit REAL-vector (OUTPUT) of n elements
C                      each holding one ASCII-value [0..255]
C                      of a character after conversion
C           K        = length of the REAL-vector and character-string
C                                                                               
C                                                                               
C-----------------------------------------------------------------------        
C                                                                               
      implicit none
      integer K
c-- The following MUST be 64-bit REALs [i.e. REAL(8) on Fortran-90]
C#ifdef F90
C      real(8) Preal_v(K)
C#else
      real  Preal_v(K)
C#endif
      character*(*) cDChar_v
      integer i

      do i=1,K
         Preal_v(i) = ichar(cdChar_v(i:i))
      enddo
      END
