      SUBROUTINE itor(int_v, real_v, n)
C                                                                               
C**** SUBROUTINE itor - To convert from INTEGER to 64-bit REAL
C                                                                               
C        S.Saarinen     ECMWF     27/6/95                                  
C                                                                               
C**   INTERFACE                                                                 
C     ---------                                                                 
C                                                                               
C        CALL itor(int_v, real_v, n)
C     WHERE:
C           int_v  = Integer vector (INPUT) of n elements:
C                    Only 32-bit range is accepted i.e.
C                    [-2147483648 ... 2147483647] which is the same as
C                    [-2**31 ... 2**31 - 1]
C           real_v = 64-bit REAL-vector (OUTPUT) of n elements
C                    each holding one integer value after conversion
C           n      = length of the vectors
C                                                                               
C                                                                               
C-----------------------------------------------------------------------        
C                                                                               
      implicit none
      integer n
c-- The following MUST be 64-bit REALs [i.e. REAL(8) on Fortran-90]
      real  real_v(n)
      integer int_v(n)
      integer i

      do i=1,n
         real_v(i) = min(max(-2147483647,int_v(i)),2147483647)
      enddo

      return
      END
