MODULE SUSTHF_MOD
CONTAINS
SUBROUTINE SUSTHF

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOS_CST  , ONLY : RATM, RD, RV, RTT
USE YOS_THF  , ONLY : RHOH2O, RVTMP2, R2ES, R3LES, R3IES, R4LES, R4IES &
                  & , R5LES, R5IES

#ifdef DOC
!**   *SUSTHF* IS THE SET-UP ROUTINE FOR COMMON BLOCK *YOS_CST*
!              This contains the fundamental model constants

!     INTERFACE.
!     ----------
!     CALL *SUSTHF* FROM *SUSURF*

!     METHOD.
!     -------

!     EXTERNALS.
!     ----------

!     REFERENCE.
!     ----------

!     Original    P. Viterbo      May 2005
!        Based on the IFS suphec

#endif

IMPLICIT NONE

REAL(KIND=JPRB) :: ZHOOK_HANDLE

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SUSTHF_MOD:SUSTHF',0,ZHOOK_HANDLE)

!  DEFINE FUNDAMENTAL CONSTANTS.
!RVTMP2=RCPV/RCPD-1.0_JPRB   !use cp,moist
RVTMP2=0.0_JPRB              !neglect cp,moist
RHOH2O=RATM/100._JPRB
R2ES=611.21_JPRB*RD/RV
R3LES=17.502_JPRB
R3IES=22.587_JPRB
R4LES=32.19_JPRB
R4IES=-0.7_JPRB
R5LES=R3LES*(RTT-R4LES)
R5IES=R3IES*(RTT-R4IES)


IF (LHOOK) CALL DR_HOOK('SUSTHF_MOD:SUSTHF',1,ZHOOK_HANDLE)

!     ------------------------------------------------------------------

END SUBROUTINE SUSTHF
END MODULE SUSTHF_MOD
