MODULE YOS_EXC
 
USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------
!*    ** *YOS_EXC* CONTAINS CONSTANTS NEEDED BY *V....*
!     ------------------------------------------------------------------

LOGICAL :: LELWDD           ! TRUE when longwave downward derivative is used for skin temperature
LOGICAL :: LEOCWA           ! TRUE if WARM OCEAN LAYER PARAMETRIZATION active
LOGICAL :: LEOCCO           ! TRUE if COOL OCEAN SKIN PARAMETRIZATION active
LOGICAL :: LEOCSA           ! TRUE if SALINTY EFFECT ON SATURATION AT OCEAN SURFACE active
LOGICAL :: LEOCLA           ! TRUE if LANGMUIR CIRCULATION EFFIECT active
LOGICAL :: LSCMEC           ! TRUE if ECMWF Single Column Model
LOGICAL :: LROUGH           ! TRUE if externally specified roughness lengths
REAL(KIND=JPRB) :: REXTZ0M  ! roughness length for momentum (if LROUGH)
REAL(KIND=JPRB) :: REXTZ0H  ! roughness length for heat and moisture (if LROUGH)
REAL(KIND=JPRB) :: RKAP     ! VONKARMAN CONSTANT
REAL(KIND=JPRB) :: REPDU2   ! MINIMUM VELOCITY DIFFERENCE IN RI-NUMBER
REAL(KIND=JPRB) :: RPARZI   ! ANSATZ FOR PBL-H IN W* COMPUTATION
REAL(KIND=JPRB) :: RZ0ICE   ! ROUGHNESS OVER SEA ICE
REAL(KIND=JPRB) :: REPUST   ! MINIMUM FRICTION VELOCITY (SECURITY PARAMETER)
REAL(KIND=JPRB) :: RNUM     ! SMOOTH SURFACE CONSTANT IN Z0M=RNUM/U
REAL(KIND=JPRB) :: RNUH     ! SMOOTH SURFACE CONSTANT IN Z0H=RNUH/U
REAL(KIND=JPRB) :: RNUQ     ! SMOOTH SURFACE CONSTANT IN Z0Q=RNUQ/U
REAL(KIND=JPRB) :: RCHAR    ! CHARNOCK CONSTANT
                            !  (simplified physics only)

!*     *YOS_EXC* CONTAINS CONSTANTS NEEDED BY *V....*
!     FOR THE COMPUTATION OF SURFACE DIFFUSION EXCHANGE COEFFICIENTS

!     A.C.M. BELJAARS      E.C.M.W.F.    14/12/89
!     OBUKHOV-L UPDATE     ACMB          26/03/90.
!     surf externalisation P. Viterbo    09/06/2005

END MODULE YOS_EXC
