MODULE YOS_VEG
 
USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

INTEGER(KIND=JPIM) :: NVTYPES                ! Number of vegetation (surface cover) types

REAL(KIND=JPRB),ALLOCATABLE :: RVCOV(:)      ! VEGETATION COVER FOR EACH TYPE
REAL(KIND=JPRB),ALLOCATABLE :: RVLAI(:)      ! LEAF AREA INDEX
REAL(KIND=JPRB),ALLOCATABLE :: RVROOTSA(:,:) ! PERCENTAGE OF ROOTS IN EACH SOIL LAYER
REAL(KIND=JPRB),ALLOCATABLE :: RVLAMSK(:)    ! Unstable SKIN LAYER CONDUCT. FOR EACH TILE
REAL(KIND=JPRB),ALLOCATABLE :: RVLAMSKS(:)   ! Stable SKIN LAYER CONDUCT. FOR EACH TILE
REAL(KIND=JPRB),ALLOCATABLE :: RVTRSR(:)     ! TRANSMISSION OF NET SOLAR RAD. 
                                             ! THROUGH VEG.
REAL(KIND=JPRB),ALLOCATABLE :: RVZ0M(:)      ! ROUGHNESS LENGTH FOR MOMENTUM
REAL(KIND=JPRB),ALLOCATABLE :: RVZ0H(:)      ! ROUGHNESS LENGTH FOR HEAT 
REAL(KIND=JPRB) :: REPEVAP                   ! MINIMUM ATMOSPHERIC DEMAND
REAL(KIND=JPRB) :: RVINTER                   ! EFFICIENCY OF INTERCEPTION OF PRECIPITATION
REAL(KIND=JPRB) :: RCEPSW                    ! MINIMUM RELATIVE HUMIDITY
REAL(KIND=JPRB),ALLOCATABLE :: RVRSMIN(:)    ! MIN STOMATAL RESISTANCE FOR EACH VEG. TYPE (S/M)
REAL(KIND=JPRB),ALLOCATABLE :: RVHSTR(:)     ! HUMIDITY STRESS FUNCTION PARAMETER (M/S kgkg-1)
REAL(KIND=JPRB) :: RLHAERO                   ! Unstable Aerodyn. lambda between high canopy and surface
REAL(KIND=JPRB) :: RLHAEROS                  ! Stable Aerodyn. lambda between high canopy and surface
REAL(KIND=JPRB) :: RCVC                      ! MINIMUM STOMATAL RESIsTANCE
                                             !  (Simplified physics only)
REAL(KIND=JPRB) :: RVLT                      ! Leaf Area index
                                             !  (Simplified physics only)
REAL(KIND=JPRB) :: RVRAD                     ! FRACTION OF THE NET SW RADIATION
                                             !  CONTRIBUTING TO PAR
                                             !  (Simplified physics only)
REAL(KIND=JPRB) :: REPSR                     ! MINIMUM VALUE FOR SW RADIATION IN
                                             !  THE CANOPY RESISTANCE COMPUTATION
                                             !  (Simplified physics only)
LOGICAL         :: LELAIV                    ! VARIABLE LAI
REAL(KIND=JPRB) :: KCVL                      ! k coefficient for Beer's law - low vegetation
REAL(KIND=JPRB) :: KCVH                      ! k coefficient for Beer's law - high vegetation
REAL(KIND=JPRB) :: ALCVL                     ! alpha coefficient for Beer's law - low vegetation
REAL(KIND=JPRB) :: ALCVH                     ! alpha coefficient for Beer's law - high vegetation
REAL(KIND=JPRB),ALLOCATABLE :: RVVEGALB(:,:) ! parameters for computing ALBEDO from vegetation types
END MODULE YOS_VEG
