SUBROUTINE CNT01S
USE PARKIND1  ,ONLY : JPIM     ,JPRB

#ifdef DOC

!**** *CNT01S*  - Routine which controls the job at level 0.

!     Purpose.
!     --------
!          Controls the job at level 0, the lowest level.

!***  Interface.
!     ----------
!        *CALL* *CNT01S

!        Explicit arguments :
!        --------------------
!        None

!        Implicit arguments :
!        --------------------
!        None

!     Method.
!     -------
!        See documentation

!     Externals.
!     ----------
!        *SU0YOM1S
!        *CNT21S

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the 1D surface model

!     Author.
!     -------
!        Pedro Viterbo and Jean-Francois Mahfouf  *ECMWF*

!     Modifications.
!     --------------
!        Original : 95-03-01
!        Bart vd Hurk (KNMI): Writing of restart file
!     ------------------------------------------------------------------
#endif

#include "su0yom1s.intfb.h"
#include "cnt21s.intfb.h"
#include "cntend.intfb.h"

!     ------------------------------------------------------------------

!*       1.    Initialize commons.
!              -------------------

CALL SU0YOM1S

!     ------------------------------------------------------------------

!*       2.    Proceed with the work.
!              ----------------------

CALL CNT21S

!     ------------------------------------------------------------------

!*       3.    Close datafiles.
!              ---------------

CALL CNTEND

!      -----------------------------------------------------------

RETURN
END SUBROUTINE CNT01S


