SUBROUTINE SU0YOM1S
USE PARKIND1  ,ONLY : JPIM     ,JPRB

USE YOMLUN1S , ONLY : NULOUT   ,NULNAM
USE YOMRIP   , ONLY : NINDAT   ,NSSSSS

#ifdef DOC

!**** *SU0YOM1S*  - INITIALIZE LEVEL 0 COMMONS

!     PURPOSE.
!     --------
!           INITIALIZE LEVEL 0 COMMONS (CONSTANT ALONG ALL THE JOB).

!**   INTERFACE.
!     ----------
!        *CALL* *SU0YOM1S*

!        EXPLICIT ARGUMENTS
!        --------------------
!        NONE

!        IMPLICIT ARGUMENTS
!        --------------------
!        NONE

!     METHOD.
!     -------
!        SEE DOCUMENTATION

!     EXTERNALS.
!     ----------
!      SUCST   - INITIALIZE CONSTANTS
!      SU1S    - INITIALIZE LOGICAL SWITCHES
!      SULUN1S - INITIALIZE LOGICAL UNITS
!      SURIP   - INITIALIZE MODEL TIME
!      SUPHEC  - INITIALIZE PHYSICS

!     REFERENCE.
!     ----------
!        ECMWF Research Department documentation of the 1D-surface model

!     AUTHOR.
!     -------
!        Jean Francois Mahfouf and Pedro Viterbo  *ECMWF*

!     MODIFICATIONS.
!     --------------
!        ORIGINAL   : 95-03-01
!        BART VD HURK (KNMI): ADJUSTED FOR MULTI-COLUMN MODE
!     ------------------------------------------------------------------
#endif

IMPLICIT NONE

#include "su1s.intfb.h"
#include "surip.intfb.h"
#include "sucst.intfb.h"
#include "su0phy1s.intfb.h"
#include "sudim1s.intfb.h"
#include "sulun1s.intfb.h"
#include "suphec.intfb.h"

!     ------------------------------------------------------------------

!*       1.    INITIALIZE COMMON YOMLOG1S
!              --------------------------

NULNAM     =  4
OPEN(NULNAM,FILE='input',STATUS='OLD')
NULOUT = 6

CALL SU1S

!*       3.    INITIALIZE MODEL TIME 
!              --------------------- 

CALL SURIP(NULOUT)


!*       4.    INITIALIZE CONSTANTS.
!              ---------------------

CALL SUCST(NULOUT,NINDAT,NSSSSS,0)

!*       5.    INITIALIZE COMMON YOEPHY 
!              ------------------------ 

CALL SU0PHY1S(NULOUT)


!*       6.    INITIALIZE DIMENSIONS.
!              ----------------------

CALL SUDIM1S



!*       7.    INITIALIZE PHYSICS.
!              -------------------

CALL SUPHEC(NULOUT)

!*       2.    INITIALIZE COMMON YOMLUN1S (MOVED AFTER SUDIM1S)
!              --------------------------

CALL SULUN1S


!     -------------------------------------------------------------------

RETURN
END SUBROUTINE SU0YOM1S
