SUBROUTINE SUVDF

!     ------------------------------------------------------------------

!**   *SUVDF* IS THE SET-UP ROUTINE FOR COMMON BLOCK *YOEVDF*

!     A.C.M. BELJAARS         E.C.M.W.F.       2/11/89

!     PURPOSE
!     -------

!          THIS ROUTINE INITIALIZES THE CONSTANTS IN COMMON BLOCK
!     *YOEVDF*

!     INTERFACE.
!     ----------

!     CALL *SUVDF* FROM *SUPHEC*

!     METHOD.
!     -------

!     EXTERNALS.
!     ----------

!     NONE.

!     REFERENCE.
!     ----------

!     MODIFICATIONS
!     -------------
!     J.-J. MORCRETTE         E.C.M.W.F.      91/07/14
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE YOEVDF   , ONLY : RLAM     ,RKAP     ,RVDIFTS  ,&
 & REPDU2   ,RENTR    ,&
 & RPAR     ,RPAR1    ,RPARSRF 

IMPLICIT NONE

REAL(KIND=JPRB) :: ZHOOK_HANDLE

!     ------------------------------------------------------------------

!*         1.     SET FIRST SET OF CONSTANTS
!                 --------------------------

IF (LHOOK) CALL DR_HOOK('SUVDF',0,ZHOOK_HANDLE)

RLAM   =150._JPRB
RKAP   =0.4_JPRB
RVDIFTS=1.5_JPRB

!     ------------------------------------------------------------------

!*         2.      SET OTHER CONSTANTS
!                  -------------------

REPDU2 =(0.1_JPRB)**2

!     ENTRAINMENT PARAMETRIZATION

RENTR=0.20_JPRB
RPAR=2._JPRB
RPAR1=0.6_JPRB
RPARSRF=0.1_JPRB

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SUVDF',1,ZHOOK_HANDLE)
END SUBROUTINE SUVDF
