MODULE YOMDYN1S
USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE
SAVE

!     ------------------------------------------------------------------

!*    Control variables for the temporal evolution

!=========== TIME STEPPING ================

! NSTEP   : current timestep of model
! TSTEP   : length of the timestep in seconds
! TDT     : 2*TSTEP except at the first time step where it is TSTEP
! NACCTYPE: accumulation type for the forcing fluxes w.r.t. timestamp
!           0=centred ; 1=forward ; 2=backward
!           |--x--|     |x----|     |----x|
!           0 is default for 1d site (forcing Tstep is short)
!           1 is for GSWP2 runs ; 2 for IFS based runs (ERA-40, AMMA, ...)
! LSWINT   L : LOGICAL:  INTERPOLATE SOLAR DOWNWARD RADIATION FOLLOWING SOLAR ZENITH ANGLE, DEFAULT = FALSE 
! LPREINT  L : LOGICAL:  DISTRIBUTE PRECIPITATION, DEFAULT = FALSE
! LFLXINT  L : LOGICAL:  Linear Interpolation for solar rad and thermal rad (works for for NACCTYPE 0 and 2

INTEGER(KIND=JPIM) :: NSTEP
REAL(KIND=JPRB) :: TSTEP
REAL(KIND=JPRB) :: TDT
INTEGER(KIND=JPIM) :: NACCTYPE
LOGICAL LPREINT 
LOGICAL LSWINT
LOGICAL LFLXINT


!     ------------------------------------------------------------------
END MODULE YOMDYN1S
