MODULE YOMGP1S1
USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE
SAVE

!*    Grid point array at time t+dt in the surface physics

REAL(KIND=JPRB),ALLOCATABLE,TARGET:: GP1(:,:)

! -   Splitting of the array GP1

!     TSLNU*  -  SOIL TEMPERATURE  
!     QLINU*  -  SOIL WETNESS
!     TILNU*  -  SEA-ICE TEMPERATURE  
!     FSNNU*  -  SNOW DEPTH
!     TSNNU* -  SNOW TEMPERATURE
!     WSNNU*  - SNOW WATER CONTENT
!     ASNNU* -  SNOW ALBEDO
!     RSNNU* -  SNOW DENSITY
!     TRENU*  -  SKIN TEMPERATURE
!     WRENU*  -  SKIN RESERVOIR WATER CONTENT

!     TLICENU* - LAKE ICE TEMPERATURE
!     TLMNWNU* - LAKE MEAN WATER TEMPERATURE
!     TLWMLNU* - LAKE MIXED LAYER TEMPERATURE
!     TLBOTNU* - LAKE BOTTOM TEMPERATURE 
!     TLSFNU*  - LAKE TEMPERATURE SHAPE FACTOR 
!     HLICENU* - LAKE ICE THICKNESS 
!     HLMLNU*  -  LAKE MIXED LAYER THICKNESS

!     UONU*     - VELOCITY OF OCEAN MIXED LAYER MODEL    !KPP
!     VONU*     - VELOCITY OF OCEAN MIXED LAYER MODEL    !KPP
!     TONU*     - TEMPERATURE OF OCEAN MIXED LAYER MODEL !KPP
!     SONU*     - SALINITY OF OCEAN MIXED LAYER MODEL    !KPP

!     LAINU*  -  LAI
!     BSTRNU* - ABOVE GROUND STRUCTURAL BIOMASS
!     BSTR2NU*- BELOW GROUND STRUCTURAL BIOMASS


REAL(KIND=JPRB),POINTER:: TSLNU1(:,:)
REAL(KIND=JPRB),POINTER:: QLINU1(:,:)
REAL(KIND=JPRB),POINTER:: TILNU1(:,:)
REAL(KIND=JPRB),POINTER:: FSNNU1(:,:)
REAL(KIND=JPRB),POINTER:: TSNNU1(:,:)
REAL(KIND=JPRB),POINTER:: WSNNU1(:,:)
REAL(KIND=JPRB),POINTER:: ASNNU1(:)
REAL(KIND=JPRB),POINTER:: RSNNU1(:,:)
REAL(KIND=JPRB),POINTER:: TRENU1(:)
REAL(KIND=JPRB),POINTER:: WRENU1(:)

REAL(KIND=JPRB),POINTER:: TLICENU1(:)
REAL(KIND=JPRB),POINTER:: TLMNWNU1(:)
REAL(KIND=JPRB),POINTER:: TLWMLNU1(:)
REAL(KIND=JPRB),POINTER:: TLBOTNU1(:)
REAL(KIND=JPRB),POINTER:: TLSFNU1(:)
REAL(KIND=JPRB),POINTER:: HLICENU1(:)
REAL(KIND=JPRB),POINTER:: HLMLNU1(:)

REAL(KIND=JPRB),POINTER:: UONU1(:,:)  !KPP
REAL(KIND=JPRB),POINTER:: VONU1(:,:)  !KPP
REAL(KIND=JPRB),POINTER:: TONU1(:,:)  !KPP
REAL(KIND=JPRB),POINTER:: SONU1(:,:)  !KPP

REAL(KIND=JPRB),POINTER:: LAINU1(:,:)
REAL(KIND=JPRB),POINTER:: BSTRNU1(:,:)
REAL(KIND=JPRB),POINTER:: BSTR2NU1(:,:)

END MODULE YOMGP1S1
