MODULE YOMGP1SA
USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE
SAVE

!*    Grid point array of accumulated prognostics

REAL(KIND=JPRB),ALLOCATABLE,TARGET:: GPA(:,:)

! -   Splitting of the array GPA

!     TSLNU*  -  SOIL TEMPERATURE  
!     QLINU*  -  SOIL WETNESS
!     TILNU*  -  SEA-ICE TEMPERATURE  
!     FSNNU*  -  SNOW DEPTH
!     TSNNU* -  SNOW TEMPERATURE
!     WSNNU*  - SNOW WATER CONTENT
!     ASNNU* -  SNOW ALBEDO
!     RSNNU* -  SNOW DENSITY
!     TRENU*  -  SKIN TEMPERATURE
!     WRENU*  -  SKIN RESERVOIR WATER CONTENT
!     QLQNU*  -  LIQUID SOIL WATER CONTENT

!     TLICENU* - LAKE ICE TEMPERATURE
!     TLMNWNU* - LAKE MEAN WATER TEMPERATURE
!     TLWMLNU* - LAKE MIXED LAYER TEMPERATURE
!     TLBOTNU* - LAKE BOTTOM TEMPERATURE 
!     TLSFNU*  - LAKE TEMPERATURE SHAPE FACTOR 
!     HLICENU* - LAKE ICE THICKNESS 
!     HLMLNU*  -  LAKE MIXED LAYER THICKNESS

!     LAINU*  -  LAI
!     BSTRNU* - ABOVE GROUND STRUCTURAL BIOMASS
!     BSTR2NU*- BELOW GROUND STRUCTURAL BIOMASS


REAL(KIND=JPRB),POINTER:: TSLNUA(:,:)
REAL(KIND=JPRB),POINTER:: QLINUA(:,:)
REAL(KIND=JPRB),POINTER:: TILNUA(:,:)
REAL(KIND=JPRB),POINTER:: FSNNUA(:,:)
REAL(KIND=JPRB),POINTER:: TSNNUA(:,:)
REAL(KIND=JPRB),POINTER:: WSNNUA(:,:)
REAL(KIND=JPRB),POINTER:: ASNNUA(:)
REAL(KIND=JPRB),POINTER:: RSNNUA(:,:)
REAL(KIND=JPRB),POINTER:: TRENUA(:)
REAL(KIND=JPRB),POINTER:: WRENUA(:)
REAL(KIND=JPRB),POINTER:: QLQNUA(:,:)

REAL(KIND=JPRB),POINTER:: TLICENUA(:)
REAL(KIND=JPRB),POINTER:: TLMNWNUA(:)
REAL(KIND=JPRB),POINTER:: TLWMLNUA(:)
REAL(KIND=JPRB),POINTER:: TLBOTNUA(:)
REAL(KIND=JPRB),POINTER:: TLSFNUA(:)
REAL(KIND=JPRB),POINTER:: HLICENUA(:)
REAL(KIND=JPRB),POINTER:: HLMLNUA(:)

REAL(KIND=JPRB),POINTER:: UONUA(:,:)  !KPP
REAL(KIND=JPRB),POINTER:: VONUA(:,:)  !KPP
REAL(KIND=JPRB),POINTER:: TONUA(:,:)  !KPP
REAL(KIND=JPRB),POINTER:: SONUA(:,:)  !KPP

REAL(KIND=JPRB),POINTER:: LAINUA(:,:)
REAL(KIND=JPRB),POINTER:: BSTRNUA(:,:)
REAL(KIND=JPRB),POINTER:: BSTR2NUA(:,:)


END MODULE YOMGP1SA
