MODULE YOMLOG1S

USE PARKIND1  ,ONLY : JPIM     ,JPRB
IMPLICIT NONE
SAVE

!     -----------------------------------------------------------------
!**   ** *YOMLOG1S* - SWITCHES RELATED TO 1D SURFACE MODEL
!     -----------------------------------------------------------------

CHARACTER*100 CFFORC,CFOUT,CFSURF,CFINIT,CSITE

CHARACTER*20  CMODID,CVERID
LOGICAL LDBGS1
INTEGER IDBGS1
LOGICAL LACCUMW
LOGICAL LSEMISS
LOGICAL LRESET
LOGICAL LNCSNC
INTEGER(KIND=JPIM) ::  NACCUR,NDLEVEL,NCDFTYPE
INTEGER(KIND=JPIM) ::  NDIMCDF
LOGICAL LWREFL
LOGICAL LWRWAT
LOGICAL LWRSUS
LOGICAL LWRSUB
LOGICAL LWREVA
LOGICAL LWRCLD
LOGICAL LWRGG
LOGICAL LWRCLM
LOGICAL LOFFL
LOGICAL LWRLKE
LOGICAL LWROCP
LOGICAL LWROCD
LOGICAL LWROCR
LOGICAL LWRCO2
LOGICAL LWRBIO
LOGICAL LWRVEG
LOGICAL LWRFRA
LOGICAL LWREXT
LOGICAL LWRTIL
LOGICAL LWRVTY
LOGICAL LWRFOR
LOGICAL LWRD2M
LOGICAL LWRGGD
LOGICAL LREADDAY

!    NAME       TYPE      PURPOSE
!    ----    :  ----   : ----------------------------------------------
! LDBGS1   L : LOGICAL : PRINT DEBUG INFO, EG FORCING DATA (DEFAULT=FALSE)
! LACCUMW  L : LOGICAL : WRITE OUT ACCUMULATED FLUXES (DEFAULT=TRUE)
! LRESET   L : LOGICAL : RESET ACCUMULATION EVERY WRITE OUT TIME STEP
!                        (DEFAULT=TRUE)
! LSEMISS  L : LOGICAL : EMISSIVITY SET TO CONSTANT VALUE REMISS
! CSITE    C : CHARACTER: IN CASE OF EXPERIMENTAL SITE IDENTIFIES THE SITE
! CFFORC   C : CHARACTER: IDENTIFIES THE FORCING DATA SET
! CFOUT    C : CHARACTER: IDENTIFIES THE OUTPUT DATA SET
! CFSURF   C : CHARACTER: IDENTIFIES THE SURFACE CLIMATOLOGY DATA SET
! CFINIT   C : CHARACTER: IDENTIFIES THE INITIALIZATION DATA SET
! CMODID   C : CHARACTER: MODEL IDENTIFICATION
! CVERID   C : CHARACTER: VERSION IDENTIFICATION
! NACCUR   I : INTEGER : OUTPUT CDF ACCURACY: 1=SINGLE PREC, 2=DOUBLE PREC
! NDLEVEL   I : INTEGER : Netcdf4 deflation level, 0 no delfation, 9 max deflation
! NDIMCDF  I : INTEGER : NR OF GRID DIMENSIONS
! LWREFL   L : LOGICAL:  WRITE EFL-OUTPUT? DEFAULT = TRUE
! LWRWAT   L : LOGICAL:  WRITE WAT-OUTPUT? DEFAULT = TRUE
! LWRSUS   L : LOGICAL:  WRITE SUS-OUTPUT? DEFAULT = TRUE
! LWRSUB   L : LOGICAL:  WRITE SUB-OUTPUT? DEFAULT = TRUE
! LWREVA   L : LOGICAL:  WRITE EVA-OUTPUT? DEFAULT = TRUE
! LWRCLD   L : LOGICAL:  WRITE CLD-OUTPUT? DEFAULT = TRUE
! LWRGG    L : LOGICAL:  WRITE GG-OUTPUT? DEFAULT = TRUE
! LWROCP   L : LOGICAL:  WRITE OCD-OUTPUT? DEFAULT = FALSE  !KPP
! LWROCD   L : LOGICAL:  WRITE OCD-OUTPUT? DEFAULT = FALSE  !KPP
! LWROCR   L : LOGICAL:  WRITE OCR-OUTPUT? DEFAULT = FALSE  !KPP
! LWRCLM   L : LOGICAL:  WRITE FIXED CLIMATE FIELDS? DEFAULT = TRUE
! LOFFL    L : LOGICAL:  OFFLINE MODE
! LWRLKE   L : LOGICAL:  WRITE LKE-OUTPUT? DEFAULT = TRUE
! LWRCO2   L : LOGICAL:  WRITE CO2-OUTPUT? DEFAULT = TRUE
! LWRBIO   L : LOGICAL:  WRITE BIO-OUTPUT? DEFAULT = TRUE
! LWRVEG   L : LOGICAL:  WRITE VEG-OUTPUT? DEFAULT = TRUE
! LWRFRA   L : LOGICAL:  WRITE FRA-OUTPUT? DEFAULT = TRUE
! LWRTIL   L : LOGICAL:  WRITE TIL-OUTPUT? DEFAULT = TRUE
! LWRVTY   L : LOGICAL:  WRITE VTY-OUTPUT? DEFAULT = TRUE
! LWRFOR   L : LOGICAL:  WRITE FORCING? DEFAULT = TRUE
! LWRD2M   L : LOGICAL:  WRITE DIAGNOSTICS at 2m and 10 m, Default = TRUE

!    ------------------------------------------------------------------
END MODULE YOMLOG1S
