#!/bin/ksh
#
#   Job to post-process output, convert netcdf to grib and clean 
#   Emanuel Dutra, November 2017
#

set -exu

. config.ksh 


cd $RUNDIR

python << EOF
from convNc2Grb import *

write2grb(CFSURF="$FIXDIR/surfclim",
          CFTEMP="$FIXDIR/init.grb",
          CFBASE="$RUNDIR",
          ZMISS=9999,
          FCTYPE='AN',
          FGOUT='out.grb',
          PARAMS=['39.128','40.128','41.128','42.128',
                  '139.128','170.128','183.128','236.128',
                  '235.128','238.128','141.128','33.128','32.128',
                  '167.128','243.128','168.128','66.128','67.128',
                  '176.128','177.128','147.128','146.128','182.128',
                  '205.128','169.128','175.128','144.128'],
         LACUM=False,LRESET=-1,DATE0=None,TIME0=0)
EOF
grib_copy -B "date:i asc, time asc" out.grb out1.grb; mv out1.grb out.grb 
mv out.grb $DATA/OSM${EXPNAME}+${YM}
## cleanup 
find -type l -delete
rm -f o_*.nc master1s.exe
ncks -4 -L 6 restartout.nc tmp.nc ; mv tmp.nc restartout.nc 
exit 0
