MODULE SET_RESOL_MOD
CONTAINS
SUBROUTINE SET_RESOL(KRESOL)
USE PARKIND1  ,ONLY : JPIM     ,JPRB

USE TPM_GEN
USE TPM_DIM
USE TPM_TRANS
USE TPM_DISTR
USE TPM_GEOMETRY
USE TPM_FIELDS
USE TPM_FFT
USE ABORT_TRANS_MOD

IMPLICIT NONE

! Declaration of arguments

INTEGER(KIND=JPIM) ,OPTIONAL, INTENT(IN) :: KRESOL

! Local varaibles
INTEGER(KIND=JPIM) :: IRESOL

!     ------------------------------------------------------------------

IF(MSETUP0 == 0) CALL ABORT_TRANS('SET_RESOL:TRANS NOT SETUP')
IRESOL = 1
IF(PRESENT(KRESOL)) THEN
  IRESOL = KRESOL
ENDIF
IF(IRESOL < 1 .OR. IRESOL > NDEF_RESOL) THEN
  WRITE(NOUT,*)'SET_RESOL: UNKNOWN RESOLUTION ',IRESOL,NDEF_RESOL
  CALL ABORT_TRANS('SET_RESOL:IRESOL < 1 .OR. KRESOL > NNDEF_RESOL')
ENDIF
IF(IRESOL /= NCUR_RESOL) THEN
  NCUR_RESOL = IRESOL 
  R => DIM_RESOL(NCUR_RESOL)
  F => FIELDS_RESOL(NCUR_RESOL)
  G => GEOM_RESOL(NCUR_RESOL)
  D => DISTR_RESOL(NCUR_RESOL)
  T => FFT_RESOL(NCUR_RESOL)
ENDIF

END SUBROUTINE SET_RESOL
END MODULE SET_RESOL_MOD
