program test
USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE MPL_MODULE
implicit none

INTEGER(KIND=JPIM) :: nsmax,ndgl,nproc,nprgpns,nprgpew,nprtrw,nprtrv
INTEGER(KIND=JPIM) :: ierror,nout,myproc,NSPECG,NSPEC2G
INTEGER(KIND=JPIM) :: nflev,IUNITSH,NINTLEN,I1SPEC,IGRIBLEN,IPARAM,ILEVEL
INTEGER(KIND=JPIM) :: iret,iword,ierr,ilons,jlev,JGL,jl,ii,j,NFLEVG
INTEGER(KIND=JPIM) :: ISEC0(2),ISEC1(55),ISEC2(22+96),ISEC3(2),ISEC4(42)
INTEGER(KIND=JPIM) :: nspec2,ngptot,nproma,ngpblks,mysetv
REAL(KIND=JPRB) :: ZSEC2(10+2*(60+1)),ZSEC3(2),zlev
INTEGER(KIND=JPIM) ,allocatable :: nloen(:),igribs(:)
REAL(KIND=JPRB) , allocatable :: zspec(:,:),zf(:,:),zvor(:,:),zdiv(:,:),zu(:,:)
REAL(KIND=JPRB) , allocatable :: zspecg(:,:),zspec2(:,:),znorm(:)
REAL(KIND=JPRB) , allocatable :: ZFPDAT(:),zg(:,:,:),zvorg(:,:),zdivg(:,:)
INTEGER(KIND=JPIM) :: ifrom(1000),ivset(1000)

CHARACTER*1 CLDMODE
CHARACTER*16 CLFN

character*6 clname
interface
#include "setup_trans0.h"
#include "setup_trans.h"
#include "inv_trans.h"
#include "dir_trans.h"
#include "dist_spec.h"
#include "gath_spec.h"
#include "trans_inq.h"
#include "specnorm.h"
end interface
nsmax=21
ndgl=32
nproma=8
NSPECG=(NSMAX+1)*(NSMAX+2)/2
NSPEC2G=NSPECG*2
nproc=9
nprgpns = 3
nprgpew = 3
nprtrw = 3
nprtrv = 3
if(nproc > 1 ) then
  call mpl_init
  myproc = mpl_myrank()
  nout = 20
  write(clname,'(a,i2.2)') 'out.',myproc
  open(nout,file=clname)
else
  nout = 6
  myproc=1
endif
mysetv=mod(myproc-1,nprtrv)+1
nflevg=19
allocate(zspecg(nflevg,NSPEC2G))
allocate(zvorg(nflevg,NSPEC2G))
allocate(zdivg(nflevg,NSPEC2G))

allocate(IGRIBS(NSPEC2G+500))
allocate(ZFPDAT(4*NSPECG))
allocate(nloen(ndgl))
allocate(znorm(nflevg))
nloen(:) = 2*ndgl
call setup_trans0(kout=nout,kerr=0,kprintlev=2,kmax_resol=2,&
&                 KPRGPNS=nprgpns,KPRGPEW=nprgpew,KPRTRW=nprtrw)
call setup_trans(KSMAX=nsmax,KDGL=ndgl,KLOEN=nloen,LDSPLIT=.true.)
!call setup_trans(KSMAX=11,KDGL=16)
call trans_inq(kspec2=nspec2,kgptot=ngptot)
ngpblks= (NGPTOT-1)/NPROMA+1
write(nout,*) 'nspec2=',nspec2,' ngptot=',ngptot
write(nout,*) 'setup finished'
call flush(nout)
nflev=0
do j=1,nflevg
  ivset(j)=mod(j,nprtrv)+1
  if(ivset(j) == mysetv) nflev=nflev+1
enddo
write(nout,*)' nflev=',nflev
allocate(zspec(nflev,NSPEC2))
allocate(zspec2(nflev,NSPEC2))
allocate(zvor(nflev,NSPEC2))
allocate(zdiv(nflev,NSPEC2))
if(myproc == 1) then
  CALL PBOPEN(IUNITSH,'/scratch/rd/nar/ifs_sgi/ICMSHt211INIT','r',IRET)
  do jlev=1,3*19+2
    !do jlev=1,nflev
    !do jlev=1,0
    NINTLEN=4
    I1SPEC=4*NSPECG*4
    CALL PBGRIB(IUNITSH,IGRIBS,I1SPEC,ILONS,IRET)
    IGRIBLEN=(ILONS+(NINTLEN-1))/NINTLEN
    CLDMODE='D'
    CALL GRIBEX(ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,&
     &ZFPDAT,NSPEC2G,IGRIBS,IGRIBLEN,IWORD,CLDMODE,IERR)
    IPARAM=ISEC1(6)
    ILEVEL=ISEC1(8)
    print *,'iparam,ilevel ',iparam,ilevel
    if(IPARAM == 130 ) then
      print *,'temp found',ilevel
      zspecg(ilevel,:)=ZFPDAT(1:NSPEC2G)
    endif
    if(IPARAM == 138 ) then
      print *,'vor found',ilevel
      zvorg(ilevel,:)=ZFPDAT(1:NSPEC2G)
    endif
    if(IPARAM == 155 ) then
      print *,'div found',ilevel
      zdivg(ilevel,:)=ZFPDAT(1:NSPEC2G)
    endif
    print *,'jlev',jlev
  enddo
  write(nout,*) 'reading finished'
  call flush(nout)
endif
ifrom(1:nflevg)=1
!do jlev=1,nflevg
!  zlev=jlev
!  zspecg(jlev,:)=zlev
!enddo
zspec=300.0
call dist_spec(pspecg=zspecg,kfdistg=nflevg,kfrom=ifrom,pspec=zspec,kvset=ivset)
call dist_spec(pspecg=zvorg,kfdistg=nflevg,kfrom=ifrom,pspec=zvor,kvset=ivset)
call dist_spec(pspecg=zdivg,kfdistg=nflevg,kfrom=ifrom,pspec=zdiv,kvset=ivset)
write(nout,*) 'distr finished'
call flush(nout)

call specnorm(pspec=zspec,kvset=ivset(1:nflevg),pnorm=znorm)
if(myproc == 1) write(nout,*) 'znorm t ',znorm
call specnorm(pspec=zvor,kvset=ivset(1:nflevg),pnorm=znorm)
if(myproc == 1) write(nout,*) 'znorm vor ',znorm
call specnorm(pspec=zdiv,kvset=ivset(1:nflevg),pnorm=znorm)
if(myproc == 1) write(nout,*) 'znorm div ',znorm
call flush(nout)
!zspecg=-17.0
!call gath_spec(pspecg=zspecg,kfdistg=nflevg,kto=ifrom,pspec=zspec,kvset=ivset)
!if(myproc == 1) then
!do jlev=1,nflevg
!  zlev=jlev
!  do j=1,nspec2g
!    if(zspecg(jlev,j) /= zlev) then
!      write(nout,*)jlev,j,zspecg(jlev,j)
!    endif
!  enddo
!enddo
!endif
!write(nout,*) 'all finished'
!call flush(nout)
!call ABORT_TRANS('ok')
!allocate(zg(2*ndgl*ndgl,3*nflevg,1))
allocate(zg(nproma,3*nflevg,ngpblks))
!allocate(zu(ngptot,nflevg,1))
!allocate(zv(ngptot,nflevg,1))
!zg(:,1,1) = 1.0
!zg(:,2,1) = 2.0
zg=0.0
call inv_trans(pspvor=zvor,pspdiv=zdiv,pspscalar=zspec,pgp=zg,kproma=nproma,&
 & kvsetsc=ivset(1:nflevg), kvsetuv=ivset(1:nflevg))

zspec=0.0
zvor=0.0
zdiv=0.0
call dir_trans(pspvor=zvor,pspdiv=zdiv,pspscalar=zspec,pgp=zg,kproma=nproma,&
 & kvsetsc=ivset(1:nflevg), kvsetuv=ivset(1:nflevg))


call specnorm(pspec=zspec,kvset=ivset(1:nflevg),pnorm=znorm)
if(myproc == 1) write(nout,*) 'znorm2 t',znorm
call specnorm(pspec=zvor,kvset=ivset(1:nflevg),pnorm=znorm)
if(myproc == 1) write(nout,*) 'znorm2 vor',znorm
call specnorm(pspec=zdiv,kvset=ivset(1:nflevg),pnorm=znorm)
if(myproc == 1) write(nout,*) 'znorm2 div',znorm

100 continue
if(nproc > 1 ) then
 call mpl_barrier()
 call mpl_end
endif


end program test




