////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// \file cropphenology.h
/// \brief Crop phenology including phu calculations
/// \author Mats Lindeskog
/// $Date: 2018-02-02 18:01:35 +0100 (Fri, 02 Feb 2018) $
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef LPJ_GUESS_CROPPHENOLOGY_H
#define LPJ_GUESS_CROPPHENOLOGY_H

/// Calculation of down-scaling of lai during crop senescence
double senescence_curve(Pft& pft, double fphu);
/// Handles heat unit and harvest index calculation and identifies harvest, senescence and intercrop events.
void crop_phenology(Patch& patch);
/// Updates crop phen from yesterday's lai_daily
void leaf_phenology_crop(Pft& pft, Patch& patch);

#endif // LPJ_GUESS_CROPPHENOLOGY_H
