!
#define TRACEBACK write (gol,'("in ",a," (",a,", line",i5,")")') rname, __FILE__, __LINE__; call goErr
#define IF_NOTOK_RETURN(action) if (status/=0) then; TRACEBACK; action; return; end if
#define IF_ERROR_RETURN(action) if (status> 0) then; TRACEBACK; action; return; end if
!
#include "tm5.inc"
!
!-----------------------------------------------------------------------------
!                    TM5                                                     !
!-----------------------------------------------------------------------------
!BOP
!
! !MODULE:      USER_INPUT
!
! !DESCRIPTION: provide dummy routine for user to specify his/her own startup
!               values. 
!\\
!\\
! !INTERFACE: 
!
module user_input
  !
  ! !USES:
  !
  use GO, only : gol, goPr, goErr

  implicit none
  private
  !
  ! !PUBLIC MEMBER FUNCTIONS:
  !
  public  ::  user_input_start
  !
  ! !PRIVATE DATA MEMBERS:
  !
  character(len=*), parameter  ::  mname = 'user_input'
  !
  ! !REVISION HISTORY: 
  !   10 Oct 2011 - P. Le Sager - TM5-MP version
  !
  ! !REMARKS:
  !
  !EOP
  !------------------------------------------------------------------------
  
contains
  
  !--------------------------------------------------------------------------
  !                    TM5                                                  !
  !--------------------------------------------------------------------------
  !BOP
  !
  ! !IROUTINE:  user_input_start
  !
  ! !DESCRIPTION: 
  !\\
  !\\
  ! !INTERFACE:
  !
  subroutine user_input_start( status )
    !
    ! !USES:
    !
    use GO         , only : gol, goPr, goErr
    use dims       , only : nregions
    use global_data, only : mass_dat, chem_dat
    !
    ! !OUTPUT PARAMETERS:
    !
    integer, intent(out)      ::  status
    !
    ! !REVISION HISTORY: 
    !   10 Oct 2011 - P. Le Sager - TM5-MP version
    !
    ! !REMARKS:
    !
    !EOP
    !------------------------------------------------------------------------
    !BOC

    character(len=*), parameter ::  rname = mname//'/user_input_start'

    ! info ...
    write (gol,'("WARNING - user_input_start not implemented yet;")'); call goPr
    write (gol,'("WARNING -   leave all concentrations at zero ...")'); call goPr

    ! dummy
!IDEE     mass_datDD%rm   = 0.0
!IDEE #ifdef slopes
!IDEE     mass_datDD%rxm  = 0.0
!IDEE     mass_datDD%rym  = 0.0
!IDEE     mass_datDD%rzm  = 0.0
!IDEE #ifdef secmom
!IDEE     mass_datDD%rxxm = 0.0
!IDEE     mass_datDD%rxym = 0.0
!IDEE     mass_datDD%rxzm = 0.0
!IDEE     mass_datDD%ryym = 0.0
!IDEE     mass_datDD%ryzm = 0.0
!IDEE     mass_datDD%rzzm = 0.0
!IDEE #endif
!IDEE #endif

    ! ok
    status=0

  end subroutine user_input_start
  !EOC

end module user_input
