#include "tm5.inc"
!
! Levels.
!

module dims_levels

  use const_ec_v, only : lme, a_ec, b_ec
  
  use dims_grid, only : nregions_all
  
  implicit none
  
  ! --- in/out ------------------------------
  
  public
  
  
  ! --- const -------------------------------
  
  
  integer, parameter ::  lm(nregions_all) = 31

  ! Only lowest layers are used for convec calculations (sub files)
  ! to avoid memory problems.
#ifdef without_lmax_conv
  ! don't bother about computation time and storage ...
  integer,parameter :: lmax_conv = 31
#else
  ! Quote Michiel van Weele:
  !     "..., convectie kan wel tot ~70 hPa (19km) gaan in de tropen."
  integer,parameter :: lmax_conv = 28
#endif

  ! select ECMWF half levels;
  ! TM levels are number bottom-up:
  integer, parameter   ::  echlevs(0:lm(1)) = (/ &
                                                             31, 30, &
                             29, 28, 27, 26, 25, 24, 23, 22, 21, 20, &
                             19, 18, 17, 16, 15, 14, 13, 12, 11, 10, &
                              9,  8,  7,  6,  5,  4,  3,  2,  1,  0 /)

  !real, parameter  :: bt(1:lm(1)+1) = b_ec(echlevs)
  !real, parameter  :: at(1:lm(1)+1) = a_ec(echlevs)

  real  :: bt(1:31+1)
  real  :: at(1:31+1)


end module dims_levels
