#include "tm5.inc"
!
! Levels.
!

module dims_levels

  use const_ec_v, only : lme, a_ec, b_ec
  use dims_grid, only : nregions_all
  
  implicit none
  
  ! --- in/out ------------------------------
  
  public
  
  
  ! --- const -------------------------------
  
  
  integer, parameter ::  lm(0:nregions_all) = 34

  ! Only lowest layers are used for convec calculations (sub files)
  ! to avoid memory problems.
#ifdef without_lmax_conv
  ! don't bother about computation time and storage ...
  integer,parameter :: lmax_conv = 34
#else
  ! Quote Michiel van Weele:
  !     "..., convectie kan wel tot ~70 hPa (19km) gaan in de tropen."
  integer,parameter :: lmax_conv = 23
#endif

  ! select ECMWF half levels;
  ! TM levels are number bottom-up:
  integer, parameter   ::  echlevs(0:34) = (/ &
                                                 34, 33, 32, 31, 30, &
                             29, 28, 27, 26, 25, 24, 23, 22, 21, 20, &
                             19, 18, 17, 16, 15, 14, 13, 12, 11, 10, &
                              9,  8,  7,  6,  5,  4,  3,  2,  1,  0 /)

  ! values filled in module geometry ...
  real  :: bt(1:34+1)
  real  :: at(1:34+1)


end module dims_levels
