#include "tm5.inc"
!
! Levels.
!

module dims_levels

  use const_ec_v, only : lme, a_ec, b_ec
  use dims_grid, only : nregions_all
  
  implicit none
  
  ! --- in/out ------------------------------
  
  public
  
  
  ! --- const -------------------------------
  
  integer, parameter ::  lm(0:nregions_all) = 25

  ! lmax_conv determines to what level the clouds and convection 
  ! are stored in the meteo files...
#ifdef without_lmax_conv
    ! don't bother about computation time and storage ...
  integer,parameter :: lmax_conv = 25
#else
  ! Quote Michiel van Weele:
  !     "..., convectie kan wel tot ~70 hPa (19km) gaan in de tropen."
  integer,parameter :: lmax_conv = 19
#endif

  integer,parameter :: echlevs(0:25) = (/ &
       60,     58,       &
       56,     54,       &
       52,     50,       &
       48,     46,       &
       44,     42,       &
       40,     38,       &
       36,     34,       &
       32,     30,       &
       28,     26,       &
       24,     22,       &
       20,               &
       16,               &
       12,               &
       8,               &
       4,               &
       0 /)

  ! values filled in module geometry ...
  real  :: at(1:25+1)
  real  :: bt(1:25+1)


end module dims_levels
