#include "tm5.inc"
!
! Levels.
!

module dims_levels

  use const_ec_v, only : lme, a_ec, b_ec
  use dims_grid, only : nregions_all
  
  implicit none
  
  ! --- in/out ------------------------------
  
  public
  
  
  ! --- const -------------------------------
  
  
  integer, parameter ::  lm(0:nregions_all) = 62

  ! Only lowest layers are used for convec calculations (sub files)
  ! to avoid memory problems.
#ifdef without_lmax_conv
  ! don't bother about computation time and storage ...
  integer,parameter :: lmax_conv = 62
#else
  ! Quote Michiel van Weele:
  !     "..., convectie kan wel tot ~70 hPa (19km) gaan in de tropen."
  integer,parameter :: lmax_conv = 55
#endif

  ! select ECMWF half levels;
  ! TM levels are number bottom-up:
  integer, parameter   ::  echlevs(0:62) = (/ &
                                                         62, 61, 60, &
                             59, 58, 57, 56, 55, 54, 53, 52, 51, 50, &
                             49, 48, 47, 46, 45, 44, 43, 42, 41, 40, &
                             39, 38, 37, 36, 35, 34, 33, 32, 31, 30, &
                             29, 28, 27, 26, 25, 24, 23, 22, 21, 20, &
                             19, 18, 17, 16, 15, 14, 13, 12, 11, 10, &
                              9,  8,  7,  6,  5,  4,  3,  2,  1,  0 /)

  ! values filled in module geometry ...
  real  :: bt(1:62+1)
  real  :: at(1:62+1)


end module dims_levels
