#include "tm5.inc"
!
! 31 Levels out of the 62 from IFS
!

module dims_levels

  use const_ec_v, only : lme, a_ec, b_ec
  use dims_grid, only : nregions_all
  
  implicit none
  
  ! --- in/out ------------------------------
  
  public
  
  
  ! --- const -------------------------------
  
  integer, parameter ::  lm(0:nregions_all) = 31

  ! lmax_conv determines to what level the clouds and convection 
  ! are stored in the meteo files...
#ifdef without_lmax_conv
    ! don't bother about computation time and storage ...
  integer,parameter :: lmax_conv = 31
#else
  ! Quote Michiel van Weele:
  !     "..., convectie kan wel tot ~70 hPa (19km) gaan in de tropen."
  integer,parameter :: lmax_conv = 25
#endif

  integer,parameter :: echlevs(0:31) = (/ &
       62,     60,       &
       57,     54,       &
       51,     48,       &
       45,     42,       &
       39,     36,       &
       33,     30,       &
       27,     25,       &
       23,     21,       &
       19,     17,       &
       15,     13,       &
       11,     10,       &
        9,      8,       &
        7,      6,       &
        5,      4,       &
        3,      2,       &
        1,      0 /)

  ! values filled in module geometry ...
  real  :: at(1:31+1)
  real  :: bt(1:31+1)


end module dims_levels
