#include "tm5.inc"
!
! Levels.
!

module dims_levels

  use const_ec_v, only : lme, a_ec, b_ec
  use dims_grid, only : nregions_all
  
  implicit none
  
  ! --- in/out ------------------------------
  
  public
  
  
  ! --- const -------------------------------
  
  
  integer, parameter ::  lm(0:nregions_all) = 34

  ! Only lowest layers are used for convec calculations (sub files)
  ! to avoid memory problems.
#ifdef without_lmax_conv
  ! don't bother about computation time and storage ...
  integer,parameter :: lmax_conv = 34
#else
  ! Quote Michiel van Weele:
  !     "..., convectie kan wel tot ~70 hPa (19km) gaan in de tropen."
  integer,parameter :: lmax_conv = 23
#endif

  ! select ECMWF half levels;
  ! TM levels are number bottom-up:
  integer, parameter   ::  echlevs(0:34) = (/ &
                                                             91,     &
                             89,         86,         83,         80, &
                                     77,         74,         71,     &
                                 68,         65,         62,         &
                             59,         56,     54,     52,     50, &
                                 48,     46,     44,     42,     40, &
                                 38,     36,     34,     32,         &
                             29,         26,         23,         20, &
                                     17,         14,         11,     &
                                  8,          5,                  0 /)

  ! values filled in module geometry ...
  real  :: at(1:34+1)
  real  :: bt(1:34+1)


end module dims_levels

