!
#define TRACEBACK write (gol,'("in ",a," (",a,", line",i5,")")') rname, __FILE__, __LINE__; call goErr
#define IF_NOTOK_RETURN(action) if (status/=0) then; TRACEBACK; action; return; end if
#define IF_ERROR_RETURN(action) if (status> 0) then; TRACEBACK; action; return; end if
!
#include "tm5.inc"
!
module reaction_data

  implicit none

  public

  integer, parameter :: nreac=112      !number of thermal reactions
  integer, parameter :: nreacw=4       !number of aqueous phase reactions
  integer, parameter :: nthigh=320
  integer, parameter :: ntlow=165
  integer, parameter :: ntemp=nthigh-ntlow
  integer, parameter :: nrat=nreac+50
  character(len=10), dimension(nreac),parameter :: ratnam=(/&
       'RNOO3     ','RHO2NO    ','RMO2NO    ','RNO2OH    ','ROHHNO3   ',&
       'RNO2O3    ','RNONO3    ','RNO2NO3   ','RN2O5     ','RHNO4OH   ',&
       'RNO2HO2   ','RHNO4M    ','RODM      ','RH2OOD    ','RO3HO2    ',&
       'RCOOH     ','RO3OH     ','RHPOH     ','RFRMOH    ','RCH4OH    ',&
       'ROHMPER   ','ROHROOH   ','RMO2HO2a  ','RMO2HO2b  ','RMO2MO2   ',&
       'RHO2OH    ','RHO2HO2   ','RN2O5L    ','RH2OH     ','RC41      ',&
       'RC43      ','RC44      ','RC46      ','RC47      ','RC48      ',&
       'RC49      ','RC50      ','RC52      ','RC53      ','RC54      ',&
       'RC57      ','RC58      ','RC59      ','RC61      ','RC62      ',&
       'RC73      ','RC76      ','RC77      ','RC78      ','RC79      ',&
       'RC80      ','RC81      ','RC82      ','RC83      ','RC84      ',&
       'RC85      ','Rdmsoha   ','Rdmsohb   ','Rdmsno3   ','Rso2oh    ',&
       'RCnh3so4  ','RCnh3oh   ','RCnh2oh   ','RCnh2no   ','RCnh2no2  ',&
       'RCnh2ho2  ','RCnh2o2   ','RCnh2o3   ','ROHCH3OH  ','ROHHCOOH  ',&
       'RNO3HO2   ','RNO3MO2   ','RNO3C2O3  ','RNO3XO2   ','RMCOOH    ',&
       'ROHC2H6   ','ROHETHOH  ','ROHC3H8   ','ROHC3H6   ','RO3C3H6   ',&
       'RNO3C3H6  ','ROHTERP   ','RO3TERP   ','RNO3TERP  ','ROHISPD   ',&
       'RO3ISPD   ','RNO3ISPD  ','DRN222    ','RCO3PO3   ','RCO3PO2   ',&
       'ROHACET   ','RACO2HO2  ','RACO2MO2  ','RACO2NO   ','RACO2XO2  ',&
       'RXO2XO2N  ','RXO2N     ','RC3H7O2NO ','C3H7O2HO2 ','RHYPO2NO  ',&
       'RHYPO2HO2 ','RN2O5AER  ','RNO3_AER  ','RHO2_AER  ','RHO2_L    ',&
       'RNH2O2NO  ','RNH2O2O3  ','RNH2O2HO2 ','RHONO     ','ROHHONO   ',&
       'RMO2NO2   ','RMO2NO2M  '/)
  character(len=8), dimension(nreacw),parameter :: rwnam = &
       (/'kso2o3  ','kso2hp  ','knh3so4 ','void    '/)
  !
  ! reaction rates
  !
  integer, parameter :: KNOO3=1
  integer, parameter :: KHO2NO=2
  integer, parameter :: KMO2NO=3
  integer, parameter :: KNO2OH=4
  integer, parameter :: KOHHNO3=5 
  integer, parameter :: KNO2O3=6
  integer, parameter :: KNONO3=7
  integer, parameter :: KNO2NO3=8
  integer, parameter :: KN2O5=9
  integer, parameter :: KHNO4OH=10 
  integer, parameter :: KNO2HO2=11
  integer, parameter :: KHNO4M=12
  integer, parameter :: KODM=13
  integer, parameter :: KH2OOD=14
  integer, parameter :: KO3HO2=15 
  integer, parameter :: KCOOH=16
  integer, parameter :: KO3OH=17
  integer, parameter :: KHPOH=18
  integer, parameter :: KFRMOH=19
  integer, parameter :: KCH4OH=20 
  integer, parameter :: KOHMPER=21
  integer, parameter :: KOHROOH=22
  integer, parameter :: KMO2HO2A=23
  integer, parameter :: KMO2HO2B=24  
  integer, parameter :: KMO2MO2=25 
  integer, parameter :: KHO2OH=26 
  integer, parameter :: KHO2HO2=27
  integer, parameter :: KN2O5L=28
  integer, parameter :: KH2OH=29
  integer, parameter :: KC41=30
  integer, parameter :: KC43=31
  integer, parameter :: KC44=32
  integer, parameter :: KC46=33
  integer, parameter :: KC47=34 
  integer, parameter :: KC48=35 
  integer, parameter :: KC49=36
  integer, parameter :: KC50=37
  integer, parameter :: KC52=38
  integer, parameter :: KC53=39
  integer, parameter :: KC54=40
  integer, parameter :: KC57=41 
  integer, parameter :: KC58=42
  integer, parameter :: KC59=43
  integer, parameter :: KC61=44
  integer, parameter :: KC62=45
  integer, parameter :: KC73=46
  integer, parameter :: KC76=47 
  integer, parameter :: KC77=48
  integer, parameter :: KC78=49
  integer, parameter :: KC79=50
  integer, parameter :: KC80=51
  integer, parameter :: KC81=52
  integer, parameter :: KC82=53 
  integer, parameter :: KC83=54
  integer, parameter :: KC84=55
  integer, parameter :: KC85=56
  integer, parameter :: Kdmsoha=57
  integer, parameter :: Kdmsohb=58
  integer, parameter :: Kdmsno3=59
  integer, parameter :: Kso2oh=60
  integer, parameter :: Knh3so4=61
  integer, parameter :: Knh3oh=62
  integer, parameter :: knh2oh=63
  integer, parameter :: Knh2no=64
  integer, parameter :: Knh2no2=65
  integer, parameter :: Knh2ho2=66
  integer, parameter :: Knh2o2=67
  integer, parameter :: Knh2o3=68
  ! additional oxidation of BVOC
  integer, parameter :: kohch3oh=69
  integer, parameter :: kohhcooh=70
  !
  ! additional NO3 reactions
  !
  integer, parameter :: kno3ho2=71
  integer, parameter :: kno3mo2=72
  integer, parameter :: kno3c2o3=73
  integer, parameter :: kno3xo2=74
  !
  !
  integer, parameter :: kohmcooh=75
  integer, parameter :: kohc2h6=76
  integer, parameter :: kohethoh=77
  !
  ! C3 
  !
  integer, parameter :: kohc3h8=78
  integer, parameter :: kohc3h6=79
  integer, parameter :: ko3c3h6=80
  integer, parameter :: kno3c3h6=81 
  !
  ! TERP
  !
  integer, parameter :: kohterp=82
  integer, parameter :: ko3terp=83
  integer, parameter :: kno3terp=84
  
  integer, parameter :: kohispd=85
  integer, parameter :: ko3ispd=86
  integer, parameter :: kno3ispd=87
  !
  integer, parameter :: krn222=88
  ! for JO2
  integer, parameter :: ko3po3=89
  integer, parameter :: ko3po2=90
  ! Acetone
  integer, parameter :: kohacet=91
  integer, parameter :: kaco2ho2=92
  integer, parameter :: kaco2mo2=93
  integer, parameter :: kaco2no=94
  integer, parameter :: kaco2xo2=95 ! JEW : ACO2 + XO2 ->   (same as for XO2N)
  !
  ! From CB05
  !
  integer, parameter :: kxo2xo2n=96
  integer, parameter :: kxo2n=97
  !
  ! extra peroxy reactions to form acetone
  integer, parameter :: kc3h7o2no=98
  integer, parameter :: kc3h7o2ho2=99
  integer, parameter :: khypo2no=100
  integer, parameter :: khypo2ho2=101
  !
  ! extra heterogeneous recations
  ! 
  integer, parameter :: kn2o5_aer=102
  integer, parameter :: kno3_aer=103
  integer, parameter :: kho2_aer=104
  integer, parameter :: kho2_l=105
  integer, parameter :: knh2o2no=106
  integer, parameter :: knh2o2o3=107
  integer, parameter :: knh2o2ho2=108
  !
  ! HONO
  !
  integer, parameter :: khono=109
  integer, parameter :: kohhono=110
  !
  ! methyl peroxy nitrate
  !
  integer, parameter :: kmo2no2=111
  integer, parameter :: kch3o2no2m=112 
  
  !
  ! additional parameters needed for 3-body and other reactions
  !
  integer, parameter :: KNO2OHA=nreac+1
  integer, parameter :: KNO2OHB=nreac+2
  integer, parameter :: KOHHNO3A=nreac+3
  integer, parameter :: KOHHNO3B=nreac+4
  integer, parameter :: KOHHNO3C=nreac+5
  integer, parameter :: KNO2NO3A=nreac+6   
  integer, parameter :: KNO2NO3B=nreac+7
  integer, parameter :: KN2O5A=nreac+8
  integer, parameter :: KN2O5B=nreac+9
  integer, parameter :: KNO2HO2A=nreac+10
  integer, parameter :: KNO2HO2B=nreac+11
  integer, parameter :: KHNO4A=nreac+12
  integer, parameter :: KHNO4B=nreac+13
  integer, parameter :: KHONOA=nreac+14
  integer, parameter :: KHONOB=nreac+15      
  integer, parameter :: KHO2HO2A=nreac+16
  integer, parameter :: KHO2HO2B=nreac+17
  integer, parameter :: KHO2HO2C=nreac+18
  integer, parameter :: KC47A=nreac+19
  integer, parameter :: KC47B=nreac+20
  integer, parameter :: KC48A=nreac+21
  integer, parameter :: KC48B=nreac+22  
  integer, parameter :: KC61A=nreac+23
  integer, parameter :: KC61B=nreac+24 
  integer, parameter :: kso2oha=nreac+25
  integer, parameter :: kso2ohb=nreac+26
  integer, parameter :: kdmsohc=nreac+27
  !JEW new parameters needed for the new CO + OH formulation  
  integer, parameter :: kcooha=nreac+28 
  integer, parameter :: kcoohb=nreac+29
  integer, parameter :: kcoohc=nreac+30
  integer, parameter :: kcoohd=nreac+31  
!JEW new parameters needed for the update to OH + organics  
  integer, parameter :: kohmcho=nreac+32 
  integer, parameter :: kohmch2cho=nreac+33
  
  integer, parameter  :: kno3mcho=nreac+34 
  integer, parameter  :: kno3mch2cho=nreac+35
! JEW ; OLE reactions now calcuated using MVK and MACR rates to
!       account for link of OLE to ISOP oxidation . For NO3
!       these are fed directly into to rr in chem_rates.F90     
  integer, parameter  :: kohole=nreac+36 
  integer, parameter  :: ko3ole=nreac+37  
  integer, parameter  :: kno3ole=nreac+38
  
  integer, parameter  :: kohaceta=nreac+39
  integer, parameter  :: kohacetb=nreac+40         

  integer, parameter  :: kohc3h6a=nreac+41
  integer, parameter  :: kohc3h6b=nreac+42
  integer, parameter  :: ko3mvk=nreac+43
  integer, parameter  :: ko3macr=nreac+44
  integer, parameter  :: kohmvk=nreac+45
  integer, parameter  :: kohmacr=nreac+46           
  
  integer, parameter  :: kmo2no2a=nreac+47
  integer, parameter  :: kmo2no2b=nreac+48
   
  integer, parameter  :: kch3o2no2a=nreac+49
  integer, parameter  :: kch3o2no2b=nreac+50  
      
  integer, parameter :: kso2hp=2
  integer, parameter :: kso2o3=1

  ! rates_lut : for reaction rate look up table !WP!
  real,dimension(nrat,ntemp) :: rates_lut

  ! for N2O5 removal on aerosol parameterisation:
  ! nr_interval : number of interval for intergration over aerosol size 
  integer,parameter          :: nr_interval=13
  ! np_interval : number of interval for integration over pressure 
  integer,parameter          :: np_interval=11
  integer,parameter          :: ncomponent=2
  ! aerdens : density of aerosols(g/cm3) (water 1.0 )
  real,parameter             :: aerdens=1.8
  ! rra     : lookup table radius..
  real,dimension(nr_interval):: rra = &
       (/1.0,1.25,1.5,1.75,2.0,2.25,2.5,2.75,3.,4.,5.,10.,15./)
  ! hetrem  : heterogeneous removal coefficient [s-1]
  !           for 1 ppbv NH4HSO4 at given aerosol radius and pressure
  real,dimension(nr_interval,np_interval,ncomponent) :: hetrem

  real,dimension(180,12)     :: h2_lat
  data h2_lat(1:180,1) /545.6847, 545.6823, 545.6799, 545.6778, 545.6754, 545.6731, 545.6709, 545.6686, 545.6663, 545.664,  545.6618, 545.6594, 545.6572, 545.655, &
                    545.6526, 545.6503, 545.6481, 545.6458, 545.6435, 545.6413, 545.639,  545.6367, 545.6344, 545.6321, 545.6298, 545.6032, 545.5523, 545.5013, &
                    545.4503, 545.3994, 545.3484, 545.2974, 545.2463, 545.1953, 545.1444, 545.0934, 545.0425, 544.9916, 544.9406, 544.8895, 544.8386, 544.7876, &
                    544.7366, 544.6857, 544.6347, 544.5837, 544.5327, 544.4818, 544.4308, 544.3798, 544.3288, 544.2778, 544.2268, 544.1759, 544.1249, 544.0739, & 
                    544.0229, 543.972,  543.921,  543.8699, 543.819,  543.768,  543.717,  543.6661, 543.6151, 543.5641, 543.5131, 543.4622, 543.4113, 543.3602, & 
                    543.3093, 543.2583, 543.2073, 543.1562, 543.1053, 543.0543, 542.7801, 542.2826, 541.7851, 541.2877, 540.7902, 540.2926, 539.7951, 539.2977, &
                    538.8001, 538.3026, 537.8052, 537.3076, 536.8102, 536.3127, 535.8152, 535.3176, 534.8202, 534.3227, 533.8251, 533.3276, 532.8302, 532.3327, &
                    531.8352, 531.3376, 530.8402, 530.3428, 529.8451, 529.3477, 528.8503, 528.3527, 527.8552, 527.3578, 526.8602, 526.3627, 525.7585, 525.0474, & 
                    524.3364, 523.6252, 522.9142, 522.2032, 521.4922, 520.7811, 520.0701, 519.3591, 518.648,  517.937,  517.2259, 516.5148, 515.8038, 515.0928, &
                    514.3817, 513.6707, 512.9596, 512.2486, 511.4813, 510.6577, 509.834,  509.0103, 508.1867, 507.3629, 506.5393, 505.7157, 504.892,  504.0684, &
                    503.2448, 502.4212, 501.5975, 500.7738, 499.9502, 499.1265, 498.303,  497.4792, 496.6556, 495.8319, 495.0083, 494.1847, 493.361,  492.5374, &
                    491.7137, 490.8901, 490.0663, 489.2428, 488.4191, 487.5955, 487.1837, 487.1837, 487.1837, 487.1837, 487.1837, 487.1837, 487.1837, 487.1837, &
                    487.1837, 487.1837, 487.1837, 487.1837, 487.1837, 487.1837, 487.1837, 487.1837, 487.1837, 487.1837, 487.1837, 487.1837/
 data h2_lat(1:180,2) /546.3832, 546.4077, 546.4323, 546.4571, 546.4817, 546.5063, 546.531, 546.5557, 546.5803, 546.605, 546.6297, 546.6543, 546.679, 546.7036, & 
                    546.7283, 546.7529, 546.7776, 546.8022, 546.8269, 546.8516, 546.8762, 546.9009, 546.9255, 546.9503, 546.9749, 546.9255, 546.8022, 546.6788, & 
                    546.5555, 546.4321, 546.3088, 546.1854, 546.062,  545.9386, 545.8153, 545.692,  545.5686, 545.4454, 545.3219, 545.1984, 545.0752, 544.9518, &
                    544.8284, 544.7051, 544.5818, 544.4584, 544.335,  544.2117, 544.0883, 543.965,  543.8416, 543.7181, 543.5948, 543.4715, 543.3481, 543.2247, & 
                    543.1014, 542.9781, 542.8547, 542.7313, 542.608,  542.4846, 542.3612, 542.2379, 542.1144, 541.9911, 541.8677, 541.7444, 541.6212, 541.4977, & 
                    541.3744, 541.251,  541.1276, 541.0042, 540.8809, 540.7575, 540.5496, 540.2568, 539.9642, 539.6716, 539.3789, 539.0861, 538.7935, 538.5009, & 
                    538.2081, 537.9154, 537.6228, 537.3301, 537.0374, 536.7448, 536.4521, 536.1594, 535.8667, 535.574,  535.2813, 534.9886, 534.696,  534.4033, & 
                    534.1107, 533.8179, 533.5253, 533.2327, 532.9398, 532.6472, 532.3546, 532.0619, 531.7692, 531.4766, 531.1838, 530.8912, 530.3141, 529.4526, & 
                    528.591,  527.7293, 526.8678, 526.0063, 525.1448, 524.2833, 523.4216, 522.5601, 521.6986, 520.837,  519.9755, 519.114,  518.2524, 517.3909, & 
                    516.5293, 515.6678, 514.8062, 513.9447, 513.2912, 512.8458, 512.4003, 511.9549, 511.5095, 511.064,  510.6187, 510.1732, 509.7278, 509.2823, &
                    508.837, 508.3916,  507.9461, 507.5007, 507.0553, 506.6098, 506.1645, 505.719,  505.2736, 504.8281, 504.3828, 503.9373, 503.4919, 503.0464, & 
                    502.6011, 502.1556, 501.7101, 501.2648, 500.8193, 500.374,  500.1512, 500.1512, 500.1512, 500.1512, 500.1512, 500.1512, 500.1512, 500.1512, & 
                    500.1512, 500.1512, 500.1512, 500.1512, 500.1512, 500.1512, 500.1512, 500.1512, 500.1512, 500.1512, 500.1512, 500.1512/
 data h2_lat(1:180,3) /544.8172, 544.8079, 544.7986, 544.7896, 544.7803, 544.7711, 544.7619, 544.7527, 544.7435, 544.7343, 544.7252, 544.7159, 544.7068, 544.6976, &
                    544.6884, 544.6791, 544.67,   544.6608, 544.6516, 544.6424, 544.6332, 544.624,  544.6147, 544.6057, 544.5964, 544.5524, 544.4738, 544.3951, &
                    544.3164, 544.2377, 544.1591, 544.0804, 544.0016, 543.9229, 543.8442, 543.7656, 543.6869, 543.6084, 543.5296, 543.4508, 543.3723, 543.2935, & 
                    543.2148, 543.1362, 543.0575, 542.9788, 542.9001, 542.8214, 542.7427, 542.6641, 542.5853, 542.5066, 542.4279, 542.3493, 542.2706, 542.1919, &
                    542.1133, 542.0346, 541.9559, 541.8771, 541.7985, 541.7198, 541.6411, 541.5624, 541.4837, 541.4051, 541.3264, 541.2477, 541.1691, 541.0903, &
                    541.0117, 540.933,  540.8542, 540.7755, 540.6968, 540.6182, 540.4709, 540.2548, 540.0388, 539.8229, 539.6068, 539.3907, 539.1746, 538.9587, & 
                    538.7426, 538.5266, 538.3106, 538.0945, 537.8785, 537.6625, 537.4464, 537.2303, 537.0143, 536.7983, 536.5823, 536.3661, 536.1502, 535.9341, & 
                    535.7181, 535.5021, 535.2861, 535.0701, 534.8539, 534.6379, 534.422,  534.2059, 533.9899, 533.7739, 533.5577, 533.3418, 532.848,  532.0765, &
                    531.3049, 530.5332, 529.7617, 528.9902, 528.2187, 527.4471, 526.6755, 525.904,  525.1324, 524.3609, 523.5894, 522.8177, 522.0462, 521.2747, & 
                    520.5031, 519.7316, 518.96,   518.1885, 517.6494, 517.3428, 517.0361, 516.7293, 516.4227, 516.116,  515.8094, 515.5027, 515.196,  514.8893, & 
                    514.5828, 514.2761, 513.9694, 513.6627, 513.3561, 513.0494, 512.7428, 512.4361, 512.1294, 511.8227, 511.5161, 511.2094, 510.9027, 510.5961, & 
                    510.2895, 509.9828, 509.676,  509.3695, 509.0627, 508.7562, 508.6028, 508.6028, 508.6028, 508.6028, 508.6028, 508.6028, 508.6028, 508.6028, & 
                    508.6028, 508.6028, 508.6028, 508.6028, 508.6028, 508.6028, 508.6028, 508.6028, 508.6028, 508.6028, 508.6028, 508.6028/
 data h2_lat(1:180,4) /541.3416, 541.2589, 541.1764, 541.094, 541.0115, 540.9289, 540.8464, 540.764, 540.6815, 540.5989, 540.5165, 540.434, 540.3515, 540.269, &
                    540.1865, 540.1039, 540.0216, 539.939,  539.8565, 539.7741, 539.6915, 539.609,  539.5266, 539.4441, 539.3615, 539.3212, 539.3232, 539.325, &
                    539.3269, 539.3288, 539.3307, 539.3326, 539.3344, 539.3362, 539.3381, 539.34,   539.3419, 539.3439, 539.3456, 539.3474, 539.3494, 539.3513, & 
                    539.3531, 539.3551, 539.3569, 539.3588, 539.3607, 539.3625, 539.3644, 539.3663, 539.3681, 539.3699, 539.3718, 539.3738, 539.3756, 539.3775, & 
                    539.3794, 539.3813, 539.3832, 539.3849, 539.3869, 539.3887, 539.3906, 539.3925, 539.3943, 539.3962, 539.3981, 539.4,    539.402,  539.4037, & 
                    539.4056, 539.4075, 539.4094, 539.4111, 539.4131, 539.415,  539.356,  539.2363, 539.1165, 538.9967, 538.8769, 538.757,  538.6372, 538.5175, &
                    538.3976, 538.2778, 538.1581, 538.0382, 537.9184, 537.7986, 537.6788, 537.559,  537.4392, 537.3194, 537.1995, 537.0797, 536.96,   536.8401, & 
                    536.7203, 536.6005, 536.4808, 536.361,  536.241,  536.1213, 536.0016, 535.8817, 535.7619, 535.6422, 535.5222, 535.4025, 535.0604, 534.4958, &
                    533.9312, 533.3666, 532.802,  532.2375, 531.673,  531.1085, 530.5438, 529.9793, 529.4148, 528.8502, 528.2856, 527.7211, 527.1566, 526.592, &
                    526.0274, 525.463,  524.8983, 524.3338, 523.8645, 523.4905, 523.1164, 522.7423, 522.3683, 521.9942, 521.6202, 521.2462, 520.8721, 520.4981,& 
                    520.1241, 519.7501, 519.376,  519.002,  518.6279, 518.2538, 517.8799, 517.5058, 517.1318, 516.7576, 516.3837, 516.0096, 515.6356, 515.2616, &
                    514.8876, 514.5135, 514.1394, 513.7655, 513.3914, 513.0173, 512.8303, 512.8303, 512.8303, 512.8303, 512.8303, 512.8303, 512.8303, 512.8303, & 
                    512.8303, 512.8303, 512.8303, 512.8303, 512.8303, 512.8303, 512.8303, 512.8303, 512.8303, 512.8303, 512.8303, 512.8303/
 data h2_lat(1:180,5) /534.4771, 534.4755, 534.4741, 534.4728, 534.4714, 534.47, 534.4686, 534.4672, 534.4658, 534.4644, 534.4631, 534.4616, 534.4603, 534.4589, & 
                    534.4575, 534.4561, 534.4548, 534.4533, 534.4519, 534.4506, 534.4491, 534.4478, 534.4464, 534.445, 534.4435,  534.4635, 534.5049, 534.5462, & 
                    534.5875, 534.6289, 534.6702, 534.7116, 534.7528, 534.7941, 534.8355, 534.8769, 534.9182, 534.9597, 535.0009, 535.0421, 535.0836, 535.1249, &
                    535.1663, 535.2076, 535.249,  535.2902, 535.3316, 535.3729, 535.4142, 535.4556, 535.4969, 535.5382, 535.5795, 535.621,  535.6622, 535.7036, & 
                    535.7449, 535.7863, 535.8276, 535.8688, 535.9103, 535.9515, 535.9929, 536.0342, 536.0756, 536.1169, 536.1582, 536.1996, 536.241,  536.2822, & 
                    536.3236, 536.365,  536.4062, 536.4475, 536.4889, 536.5302, 536.5631, 536.5875, 536.6119, 536.6363, 536.6607, 536.6849, 536.7094, 536.7338, & 
                    536.7581, 536.7825, 536.8069, 536.8312, 536.8556, 536.8799, 536.9044, 536.9286, 536.9531, 536.9775, 537.0018, 537.0261, 537.0505, 537.0749, & 
                    537.0993, 537.1236, 537.148,  537.1725, 537.1967, 537.2211, 537.2455, 537.2698, 537.2943, 537.3187, 537.3429, 537.3674, 537.1082, 536.5656, &
                    536.0229, 535.4801, 534.9374, 534.3949, 533.8522, 533.3096, 532.7668, 532.2242, 531.6816, 531.1389, 530.5963, 530.0536, 529.5109, 528.9683, & 
                    528.4256, 527.883,  527.3403, 526.7977, 526.3599, 526.0271, 525.6943, 525.3614, 525.0286, 524.6957, 524.363,  524.0302, 523.6973, 523.3645, &
                    523.0318, 522.699,  522.3661, 522.0333, 521.7005, 521.3676, 521.035,  520.702,  520.3693, 520.0363, 519.7036, 519.3708, 519.0379, 518.7051, &
                    518.3724, 518.0396, 517.7066, 517.374,  517.0411, 516.7083, 516.5418, 516.5418, 516.5418, 516.5418, 516.5418, 516.5418, 516.5418, 516.5418, &
                    516.5418, 516.5418, 516.5418, 516.5418, 516.5418, 516.5418, 516.5418, 516.5418, 516.5418, 516.5418, 516.5418, 516.5418/
 data h2_lat(1:180,6) /528.9905, 529.0618, 529.1333, 529.2048, 529.2762, 529.3477, 529.4192, 529.4907, 529.5621, 529.6336, 529.7051, 529.7766, 529.848, 529.9195, & 
                    529.991,  530.0624, 530.134,  530.2054, 530.2769, 530.3484, 530.4197, 530.4912, 530.5627, 530.6342, 530.7056, 530.7879, 530.881, 530.9739, &
                    531.067,  531.16,   531.2531, 531.3461, 531.4391, 531.532,  531.6252, 531.7182, 531.8112, 531.9044, 531.9973, 532.0903, 532.1834, 532.2764, & 
                    532.3694, 532.4626, 532.5555, 532.6485, 532.7416, 532.8346, 532.9277, 533.0207, 533.1137, 533.2067, 533.2997, 533.3928, 533.4858, 533.5789, & 
                    533.6719, 533.765,  533.858,  533.9509, 534.044,  534.137,  534.23,   534.3231, 534.4161, 534.5092, 534.6022, 534.6952, 534.7884, 534.8812, 534.9743,& 
                    535.0674, 535.1603, 535.2533, 535.3464, 535.4395, 535.5298, 535.6174, 535.705,  535.7927, 535.8802, 535.9678, 536.0554, 536.1431, 536.2306, & 
                    536.3182, 536.4058, 536.4934, 536.581,  536.6686, 536.7562, 536.8438, 536.9314, 537.019,  537.1066, 537.1941, 537.2818, 537.3694, 537.457, & 
                    537.5446, 537.6322, 537.7198, 537.8073, 537.895,  537.9826, 538.0702, 538.1578, 538.2455, 538.3329, 538.4206, 538.2084, 537.6962, 537.184, & 
                    536.6717, 536.1595, 535.6475, 535.1353, 534.6232, 534.111,  533.5988, 533.0867, 532.5745, 532.0623, 531.5502, 531.038,  530.5258, 530.0137, & 
                    529.5015, 528.9893, 528.4772, 527.9321, 527.3542, 526.7761, 526.1981, 525.6202, 525.0421, 524.4642, 523.8862, 523.3082, 522.7302, 522.1523, & 
                    521.5743, 520.9963, 520.4182, 519.8403, 519.2622, 518.6844, 518.1063, 517.5283, 516.9502, 516.3724, 515.7943, 515.2163, 514.6384, 514.0604, & 
                    513.4824, 512.9043, 512.3265, 511.7484, 511.1704, 510.8814, 510.8814, 510.8814, 510.8814, 510.8814, 510.8814, 510.8814, 510.8814, 510.8814, & 
                    510.8814, 510.8814, 510.8814, 510.8814, 510.8814, 510.8814, 510.8814, 510.8814, 510.8814, 510.8814, 510.8814/
 data h2_lat(1:180,7) /528.1784, 528.1115, 528.0446, 527.978, 527.9111, 527.8442, 527.7775, 527.7108, 527.6439, 527.5771, 527.5104, 527.4435, 527.3768, 527.3101, &
                    527.2432, 527.1764, 527.1097, 527.0428, 526.9761, 526.9094, 526.8425, 526.7757, 526.7089, 526.6422, 526.5753, 526.6195, 526.7747, 526.9299, & 
                    527.085,  527.2402, 527.3954, 527.5505, 527.7056, 527.8607, 528.0159, 528.1711, 528.3263, 528.4816, 528.6366, 528.7917, 528.947,  529.1021, & 
                    529.2572, 529.4125, 529.5676, 529.7227, 529.8779, 530.033,  530.1882, 530.3434, 530.4985, 530.6536, 530.8088, 530.964,  531.1191, 531.2743, & 
                    531.4294, 531.5846, 531.7398, 531.8948, 532.05,   532.2052, 532.3604, 532.5155, 532.6707, 532.8259, 532.981,  533.1362, 533.2914, 533.4464, &
                    533.6017, 533.7568, 533.9119, 534.067,  534.2222, 534.3774, 534.4937, 534.5709, 534.6481, 534.7255, 534.8027, 534.8798, 534.9571, 535.0344, & 
                    535.1116, 535.1888, 535.2661, 535.3433, 535.4206, 535.4978, 535.5751, 535.6523, 535.7296, 535.8068, 535.884,  535.9612, 536.0385, 536.1158, & 
                    536.193,  536.2702, 536.3475, 536.4248, 536.5019, 536.5792, 536.6565, 536.7337, 536.811,  536.8883, 536.9654, 537.0427, 536.8989, 536.5341, & 
                    536.1691, 535.8041, 535.4393, 535.0745, 534.7097, 534.3448, 533.9799, 533.6151, 533.2501, 532.8853, 532.5204, 532.1555, 531.7906, 531.4258, & 
                    531.0609, 530.6961, 530.3311, 529.9663, 529.149,  527.8792, 526.6093, 525.3394, 524.0696, 522.7997, 521.53,   520.2601, 518.9903, 517.7205, & 
                    516.4507, 515.1809, 513.9109, 512.6411, 511.3713, 510.1015, 508.8318, 507.5618, 506.292,  505.0221, 503.7524, 502.4825, 501.2126, 499.9428, & 
                    498.6731, 497.4032, 496.1333, 494.8636, 493.5937, 492.3239, 491.6889, 491.6889, 491.6889, 491.6889, 491.6889, 491.6889, 491.6889, 491.6889, & 
                    491.6889, 491.6889, 491.6889, 491.6889, 491.6889, 491.6889, 491.6889, 491.6889, 491.6889, 491.6889, 491.6889, 491.6889/
 data h2_lat(1:180,8) /528.6539, 528.5361, 528.4184, 528.3008, 528.183, 528.0653, 527.9477, 527.83, 527.7123, 527.5946, 527.477, 527.3592, 527.2416, 527.1239,  &
                    527.0062, 526.8884, 526.7709, 526.6531, 526.5355, 526.4178, 526.3,    526.1824, 526.0647, 525.947,  525.8293, 525.834,  525.9611, 526.088,  &
                    526.215,  526.342,  526.4691, 526.5961, 526.723,  526.85,   526.9771, 527.1041, 527.2311, 527.3583, 527.4852, 527.6121, 527.7392, 527.8661, & 
                    527.9932, 528.1202, 528.2473, 528.3742, 528.5012, 528.6282, 528.7552, 528.8823, 529.0093, 529.1362, 529.2632, 529.3903, 529.5173, 529.6443, & 
                    529.7714, 529.8984, 530.0254, 530.1523, 530.2794, 530.4063, 530.5334, 530.6604, 530.7874, 530.9144, 531.0414, 531.1684, 531.2955, 531.4224, & 
                    531.5495, 531.6765, 531.8035, 531.9304, 532.0574, 532.1845, 532.2175, 532.1564, 532.0953, 532.0342, 531.9731, 531.9119, 531.8508, 531.7898, & 
                    531.7286, 531.6674, 531.6064, 531.5452, 531.4841, 531.423,  531.3619, 531.3007, 531.2397, 531.1786, 531.1174, 531.0562, 530.9952, 530.9341, &
                    530.873,  530.8118, 530.7507, 530.6897, 530.6284, 530.5674, 530.5063, 530.4451, 530.384,  530.3231, 530.2618, 530.2007, 529.99,   529.6296, & 
                    529.2692, 528.9088, 528.5483, 528.1881, 527.8278, 527.4673, 527.1069, 526.7466, 526.3862, 526.0258, 525.6655, 525.3051, 524.9447, 524.5844, & 
                    524.2239, 523.8636, 523.5032, 523.1429, 522.1282, 520.4591, 518.79,   517.1209, 515.4518, 513.7827, 512.1137, 510.4446, 508.7755, 507.1065, & 
                    505.4375, 503.7684, 502.0993, 500.4302, 498.7611, 497.092,  495.423,  493.7539, 492.0848, 490.4157, 488.7467, 487.0776, 485.4085, 483.7394, & 
                    482.0704, 480.4013, 478.7322, 477.0632, 475.394,  473.725,  472.8905, 472.8905, 472.8905, 472.8905, 472.8905, 472.8905, 472.8905, 472.8905, & 
                    472.8905, 472.8905, 472.8905, 472.8905, 472.8905, 472.8905, 472.8905, 472.8905, 472.8905, 472.8905, 472.8905, 472.8905/
 data h2_lat(1:180,9) /527.6614, 527.6564, 527.6516, 527.6469, 527.6419, 527.637, 527.6323, 527.6274, 527.6226, 527.6178, 527.613, 527.6081, 527.6033, 527.5985, &
                    527.5937, 527.5888, 527.5841, 527.5792, 527.5743, 527.5696, 527.5647, 527.5599, 527.5551, 527.5503, 527.5454, 527.606,  527.7322, 527.8583, &
                    527.9844, 528.1105, 528.2367, 528.3629, 528.4888, 528.6149, 528.7411, 528.8672, 528.9933, 529.1196, 529.2456, 529.3716, 529.4979, 529.624, & 
                    529.7501, 529.8763, 530.0024, 530.1284, 530.2546, 530.3807, 530.5068, 530.6329, 530.759,  530.8851, 531.0112, 531.1375, 531.2635, 531.3896, & 
                    531.5157, 531.6419, 531.768,  531.894,  532.0202, 532.1463, 532.2725, 532.3986, 532.5247, 532.6508, 532.7769, 532.903,  533.0293, 533.1552, & 
                    533.2814, 533.4076, 533.5336, 533.6597, 533.7858, 533.912,  533.8359, 533.5576, 533.2794, 533.0011, 532.7228, 532.4444, 532.1661, 531.8879, & 
                    531.6096, 531.3312, 531.053,  530.7747, 530.4964, 530.2181, 529.9398, 529.6615, 529.3832, 529.105,  528.8266, 528.5483, 528.27,   527.9918, & 
                    527.7134, 527.4351, 527.1569, 526.8787, 526.6002, 526.322,  526.0437, 525.7654, 525.4871, 525.2089, 524.9305, 524.6522, 524.1245, 523.3474, & 
                    522.5701, 521.7928, 521.0157, 520.2386, 519.4614, 518.6842, 517.907,  517.1299, 516.3527, 515.5755, 514.7983, 514.0211, 513.244,  512.4667, & 
                    511.6896, 510.9124, 510.1352, 509.3581, 508.2245, 506.7346, 505.2447, 503.7547, 502.2649, 500.7749, 499.285,  497.7951, 496.3052, 494.8153, & 
                    493.3254, 491.8355, 490.3456, 488.8556, 487.3657, 485.8758, 484.386,  482.896,  481.4061, 479.916,  478.4262, 476.9363, 475.4463, 473.9565, &
                    472.4666, 470.9767, 469.4866, 467.9969, 466.5069, 465.017,  464.272,  464.272,  464.272,  464.272,  464.272,  464.272,  464.272,  464.272, & 
                    464.272,  464.272,  464.272,  464.272,  464.272,  464.272,  464.272,  464.272,  464.272,  464.272,  464.272,  464.272/
 data h2_lat(1:180,10) /  528.5276, 528.5571, 528.5867, 528.6165, 528.646, 528.6756, 528.7053, 528.7349, 528.7645, 528.7942, 528.8239, 528.8534, 528.8831, 528.9127, &
                    528.9424, 528.9719, 529.0017, 529.0312, 529.0609, 529.0906, 529.1202, 529.1498, 529.1794, 529.2091, 529.2386, 529.3627, 529.5812, 529.7996, &
                    530.0179, 530.2364, 530.4548, 530.6732, 530.8915, 531.1099, 531.3283, 531.5468, 531.7651, 531.9837, 532.202,  532.4203, 532.6388, 532.8572, & 
                    533.0756, 533.2941, 533.5125, 533.7308, 533.9492, 534.1676, 534.386,  534.6044, 534.8228, 535.0411, 535.2596, 535.478,  535.6964, 535.9148, & 
                    536.1332, 536.3517, 536.5701, 536.7884, 537.0068, 537.2252, 537.4436, 537.662,  537.8804, 538.0989, 538.3172, 538.5356, 538.7542, 538.9724, & 
                    539.1909, 539.4093, 539.6277, 539.8459, 540.0645, 540.2828, 540.1044, 539.5292, 538.9539, 538.3786, 537.8033, 537.2279, 536.6526, 536.0775, & 
                    535.502,  534.9268, 534.3515, 533.7762, 533.2009, 532.6255, 532.0503, 531.4749, 530.8997, 530.3244, 529.749,  529.1737, 528.5984, 528.0232, & 
                    527.4479, 526.8725, 526.2973, 525.722,  525.1466, 524.5714, 523.9961, 523.4208, 522.8455, 522.2703, 521.6948, 521.1196, 520.3181, 519.2905, & 
                    518.2628, 517.235,  516.2073, 515.1797, 514.152,  513.1243, 512.0966, 511.069,  510.0413, 509.0136, 507.9859, 506.9582, 505.9305, 504.9028, & 
                    503.8752, 502.8475, 501.8198, 500.7921, 499.6252, 498.3189, 497.0126, 495.7062, 494.4,   493.0936,  491.7874, 490.4811, 489.1748, 487.8685, & 
                    486.5623, 485.256, 483.9496, 482.6433, 481.3371, 480.0308, 478.7246, 477.4182, 476.1119, 474.8055,  473.4994, 472.1931, 470.8867, 469.5804, & 
                    468.2742, 466.9679, 465.6615, 464.3554, 463.049, 461.7428, 461.0896, 461.0896, 461.0896, 461.0896, 461.0896, 461.0896, 461.0896, 461.0896, & 
                    461.0896, 461.0896, 461.0896, 461.0896, 461.0896, 461.0896, 461.0896, 461.0896, 461.0896, 461.0896, 461.0896, 461.0896/
 data h2_lat(1:180,11) /533.6163, 533.6492, 533.6822, 533.7154, 533.7484, 533.7814, 533.8145, 533.8475, 533.8806, 533.9136, 533.9468, 533.9797, 534.0129, 534.0459, &
                    534.079,  534.112,  534.1451, 534.1782, 534.2112, 534.2443, 534.2773, 534.3104, 534.3434, 534.3765, 534.4095, 534.5023, 534.655,  534.8076, &
                    534.9602, 535.1129, 535.2654, 535.4181, 535.5706, 535.7231, 535.8759, 536.0284, 536.1811, 536.3338, 536.4863, 536.6388, 536.7916, 536.9441, &
                    537.0967, 537.2495, 537.402,  537.5546, 537.7072, 537.8598, 538.0124, 538.165,  538.3176, 538.4702, 538.6228, 538.7755, 538.928,  539.0806, &
                    539.2333, 539.3859, 539.5385, 539.691,  539.8437, 539.9963, 540.1489, 540.3015, 540.454,  540.6068, 540.7593, 540.9119, 541.0647, 541.2171, &
                    541.3698, 541.5224, 541.675,  541.8275, 541.9802, 542.1328, 541.882,  541.2277, 540.5734, 539.9191, 539.2648, 538.6104, 537.9561, 537.3019, &
                    536.6475, 535.9932, 535.339,  534.6846, 534.0303, 533.376,  532.7217, 532.0674, 531.4131, 530.7589, 530.1045, 529.4501, 528.7959, 528.1416, &
                    527.4873, 526.8329, 526.1787, 525.5245, 524.87,   524.2158, 523.5615, 522.9072, 522.2529, 521.5987, 520.9442, 520.29,   519.4531, 518.4333, & 
                    517.4136, 516.3939, 515.3741, 514.3546, 513.3349, 512.3152, 511.2954, 510.2758, 509.2561, 508.2365, 507.2168, 506.197,  505.1773, 504.1577, & 
                    503.138,  502.1183, 501.0986, 500.0789, 499.0187, 497.9179, 496.8171, 495.7162, 494.6155, 493.5146, 492.4139, 491.313,  490.2122, 489.1115, & 
                    488.0107, 486.91,   485.8091, 484.7083, 483.6075, 482.5067, 481.406,  480.3051, 479.2043, 478.1034, 477.0027, 475.9019, 474.8011, 473.7003, & 
                    472.5995, 471.4987, 470.3978, 469.2972, 468.1963, 467.0956, 466.5451, 466.5451, 466.5451, 466.5451, 466.5451, 466.5451, 466.5451, 466.5451, & 
                    466.5451, 466.5451, 466.5451, 466.5451, 466.5451, 466.5451, 466.5451, 466.5451, 466.5451, 466.5451, 466.5451, 466.5451/
 data h2_lat(1:180,12) /539.8811, 539.8895, 539.8982, 539.9069, 539.9155, 539.9241, 539.9327, 539.9414, 539.95, 539.9587, 539.9673, 539.976, 539.9846, 539.9933, &
                    540.0019, 540.0105, 540.0192, 540.0278, 540.0364, 540.0451, 540.0537, 540.0623, 540.071, 540.0797, 540.0883, 540.1172, 540.1665, 540.2157, &
                    540.265,  540.3142, 540.3635, 540.4127, 540.4619, 540.5111, 540.5604, 540.6097, 540.6589, 540.7083, 540.7574, 540.8066, 540.856, 540.9052, & 
                    540.9544, 541.0037, 541.0529, 541.1021, 541.1514, 541.2006, 541.2499, 541.2992, 541.3484, 541.3976, 541.4468, 541.4962, 541.5453, 541.5946, & 
                    541.6439, 541.6931, 541.7424, 541.7915, 541.8408, 541.89,   541.9393, 541.9886, 542.0378, 542.0871, 542.1363, 542.1855, 542.2349, 542.284, & 
                    542.3333, 542.3826, 542.4318, 542.4809, 542.5302, 542.5795, 542.3266, 541.7715, 541.2165, 540.6615, 540.1064, 539.5512, 538.9962, 538.4412, & 
                    537.886,  537.331,  536.7759, 536.2208, 535.6658, 535.1107, 534.5557, 534.0005, 533.4455, 532.8904, 532.3353, 531.7802, 531.2252, 530.6701, & 
                    530.1151, 529.5599, 529.0049, 528.4499, 527.8947, 527.3397, 526.7847, 526.2295, 525.6744, 525.1195, 524.5643, 524.0093, 523.2617, 522.3215, &
                    521.3813, 520.4409, 519.5007, 518.5607, 517.6205, 516.6803, 515.74,   514.7999, 513.8597, 512.9195, 511.9793, 511.0391, 510.0989, 509.1587, & 
                    508.2185, 507.2784, 506.3381, 505.398,  504.4366, 503.4541, 502.4716, 501.489,  500.5066, 499.524,  498.5415, 497.559,  496.5765, 495.594, & 
                    494.6116, 493.6291, 492.6465, 491.664,  490.6815, 489.699,  488.7166, 487.734,  486.7515, 485.7689, 484.7865, 483.804,  482.8214, 481.8389, & 
                    480.8565, 479.8739, 478.8914, 477.909,  476.9264, 475.944,  475.4527, 475.4527, 475.4527, 475.4527, 475.4527, 475.4527, 475.4527, 475.4527, & 
                    475.4527, 475.4527, 475.4527, 475.4527, 475.4527, 475.4527, 475.4527, 475.4527, 475.4527, 475.4527, 475.4527, 475.4527/


end module reaction_data
