#include "tm5.inc"
MODULE mo_m7_box

  ! *mo_m7_box* contains parameters and switches for the
  !             m7 interface *m7_int*
  !
  ! Author:
  ! -------
  ! E. Vignati							  2005
  ! Philip Stier, MPI                     2001
  !
  !               
  !--- 1) Time control: -------------------------------------------------------------------------
 
  REAL,    PARAMETER :: sunrise = 6.,            & ! Dawn
                        sunset  = 18.,           & ! Dusk
                        start   = 6.,            & ! Initial time of day of the simulation
                        timetot = 3600.*24.*15., & ! Total time of simulation
                        tprint  = 1800.            ! Printing interval
                      ! tprint  = 3600.*6.         ! Printing interval

  !--- 2) Chemical constants: -------------------------------------------------------------------

  REAL,    PARAMETER :: ck1=1.1e-12               ! Constant of reaction between oh and so2

END MODULE mo_m7_box
