!
! Test xml reader.
!

! data stored in a single global type ?
#define globaltype

program test

  use Standard_Name_Table, only : Standard_Name_Table_Init, Standard_Name_Table_Done
#ifdef globaltype
  use Standard_Name_Table, only : T_Standard_Name_Table
#else
  use Standard_Name_Table, only : version_number, last_modified, institution, contact
  use Standard_Name_Table, only : entry, alias
#endif

  implicit none
  
  ! --- const ------------------------------------
  
  character(len=*), parameter   ::  xml_file = '../data/cf-standard-name-table-v12.xml'
  
  ! --- local ------------------------------------
  
  integer                         ::  status
  integer                         ::  i
  integer                         ::  n
#ifdef globaltype
  type(T_Standard_Name_Table)     ::  tab
#endif
  
  ! --- begin ------------------------------------

  write (*,'("test: begin")')
  
  ! read file into module variables:
  write (*,'("test: read ",a," ...")') trim(xml_file)
#ifdef globaltype
  call Standard_Name_Table_Init( tab, xml_file, status )
  if (status/=0) stop 'error from reader'
#else
  call Standard_Name_Table_Init( xml_file, status )
  if (status/=0) stop 'error from reader'
#endif
  
  ! info ...
  write (*,'("test: content: ")')
  write (*,'("test:   meta: ")')
#ifdef globaltype
  write (*,'("test:     version_number = ",i6)') tab%version_number
  write (*,'("test:     last_modified  = ",a)') trim(tab%last_modified)
  write (*,'("test:     institution    = ",a)') trim(tab%institution)
  write (*,'("test:     contact        = ",a)') trim(tab%contact)
#else
  write (*,'("test:     version_number = ",i6)') version_number
  write (*,'("test:     last_modified  = ",a)') trim(last_modified)
  write (*,'("test:     institution    = ",a)') trim(institution)
  write (*,'("test:     contact        = ",a)') trim(contact)
#endif
  write (*,'("test:   entries:")')
#ifdef globaltype
  n = size(tab%entry)
#else
  n = size(entry)
#endif
  do i = 1, n
    if ( (i <= 3) .or. (i >= n-2) ) then
#ifdef globaltype
      write (*,'("test:   ",i6,"  : ",a," [",a,"]")') i, trim(tab%entry(i)%id), trim(tab%entry(i)%canonical_units)
#else
      write (*,'("test:   ",i6,"  : ",a," [",a,"]")') i, trim(entry(i)%id), trim(entry(i)%canonical_units)
#endif
    else if ( i == 4 ) then
      write (*,'("test:        :")')
    end if
  end do
  write (*,'("test:   alia:")')
#ifdef globaltype
  n = size(tab%alias)
#else
  n = size(alias)
#endif
  do i = 1, n
    if ( (i <= 3) .or. (i >= n-2) ) then
#ifdef globaltype
      write (*,'("test:   ",i6,"  : ",a," -> ",a)') i, trim(tab%alias(i)%id), trim(tab%alias(i)%entry_id)
#else
      write (*,'("test:   ",i6,"  : ",a," -> ",a)') i, trim(alias(i)%id), trim(alias(i)%entry_id)
#endif
    else if ( i == 4 ) then
      write (*,'("test:        :")')
    end if
  end do
  
  ! destroy
  write (*,'("test: done ...")')
#ifdef globaltype
  call Standard_Name_Table_Done( tab, status )
  if (status/=0) stop 'error from reader'
#else
  call Standard_Name_Table_Done( status )
  if (status/=0) stop 'error from reader'
#endif
  
  write (*,'("test: end")')

end program test
