#ifndef  __MPI_ROUTING_HPP__
#define  __MPI_ROUTING_HPP__

#include <mpi.h>

class CMPIRouting
{
public:

	MPI_Comm communicator;
	int mpiRank;
	int mpiSize;

	int  nbSource;
	int *sourceRank;
	int *nbSourceElement;
	int  totalSourceElement;
	int *sourceElementIndex;

	int  nbTarget;
	int *targetRank;
	int *nbTargetElement;
	int *targetElementIndex;
	int  totalTargetElement;


	CMPIRouting(MPI_Comm comm);
	~CMPIRouting();
	void init(int *route, int nbElements);
	int getTotalSourceElement(void);

	template<typename T> void transferToTarget(T *targetElement, T *sourceElement);
	template<typename T, typename t_pack, typename t_unpack> void transferToTarget(T *targetElement, T *sourceElement, t_pack pack, t_unpack unpack);

	template<typename T> void transferFromSource(T *targetElement, T *sourceElement);
	template<typename T, typename t_pack, typename t_unpack> void transferFromSource(T *targetElement, T *sourceElement, t_pack pack, t_unpack unpack);

};

#endif
