#ifndef  __PARALLEL_TREE_HPP__
#define  __PARALLEL_TREE_HPP__ 

#include "tree.hpp" // for local tree and routing tree
#include "sample_tree.hpp"

class CParallelTree
{
public:
	~CParallelTree();

	void buildParallelTree(vector<Node>& node, vector<Node>& node2);
	void getNeighbours();

	int nbLocalElements;
	Elt* localElements;

	int nbNeighbourElements;
	Elt* neighbourElements;

	CBasicTree routeTree;
	CBasicTree localTree;

private:
	void buildLocalTree(vector<Node>& node);
	void buildRouteTree();
	void assignId(vector<Node>& node);

	CSampleTree sampleTree;

	/** the parallel tree, as a distributed data-structure with operations on neighbours, needs ghost cells
	    The elements in this array will be inserted to the local tree, but not saved in its leaf array.
	*/
	vector<Node> neighbourNodes; 
};


#endif
