#ifndef  __SAMPLE_TREE_HPP__
#define  __SAMPLE_TREE_HPP__ 

#include "tree.hpp"

class CSampleTree : public CBasicTree
{
public:
	CSampleTree(MPI_Comm comm=MPI_COMM_WORLD); // communicator is provided since the sample tree will use a different one for grouping
	~CSampleTree() { if (sampleTree) delete sampleTree; };
	
	void buildParallelSampleTree(vector<Node>& sampleNodes); 
	void parallelRouteNode(vector<Node>& node);

private:
	MPI_Comm communicator; // current communicator
	int mpiRank;  // rank in current communicator
	int mpiSize;  // size of current communicator

	void buildSampleTree(int keepNodes, vector<Node>& node, MPI_Comm communicator);
	void assignRoute(int* rank, int assignLevel);

	bool hasChildTree;
	CSampleTree* sampleTree; /* uses different MPI communicator */

};

#endif
