#ifndef  __TREE_HPP__
#define __TREE_HPP__
#include "mpi.h" // some compiler fails if mpi.h is not the first header to be included
#include <list>
#include <deque>
#include <vector>
#include "elt.h"
#include "node.h"
#include "mpi_routing.hpp"

using namespace std;

class CBasicTree
{
public:

	NodePtr root; /* The main tree is stored as Nodes which can be reached through traversal starting here */
	NodePtr ref; // FIXME this reference, set by a node is odd, try to remove
	int ri; /** this is set to one by a node in case of reinsertion */
	vector<int> levelSize; /** e.g. levelSize[0] == leafs.size() */
	vector<Node> leafs; /** leafs are stored in vector for easy access and rest of the tree nodes as separate allocations, only reachable through tree traversal */

	CBasicTree(); 
	~CBasicTree(); 
	/* FIXME/TODO: try to replace isSmalpeTree stuff with defining new method in derived function */
	void build(vector<Node>& nodes, bool isSampleTree=false, int assignLevel=-1, int keepNodes=-1);
	void insertNodes(vector<Node>& node, bool isSampleTree=false, int assignLevel=-1, int keepNodes=-1);

	void routeNodes(vector<Node>& nodes, int assignLevel);

	void push_back(NodePtr node);
	void push_front(NodePtr node);
	void increaseLevelSize(int level);
	void decreaseLevelSize(int level);
	void newRoot(int level);

private:
	deque<NodePtr > pool;
	void emptyPool();

};

class CTree : public CBasicTree
{
public:
};


#endif
