!OPTIONS XOPT(NOEVAL)
SUBROUTINE APLPAR ( KIDIA , KFDIA  , KLON      ,&
 & KTDIA  , KLEV   , KGL1   , KGL2   ,  KSTGLO ,&
 & KVCLIS , KVCLIV , KSTEP  ,&
 & KSGST  , KCSS   ,&
 & KBL    , KGPCOMP,&
 !---------------------------------------------------------------------
 ! - INPUT .
 & PAPHI  , PAPRS  , PAPHIF , PAPRSF , PALPH  , PARG   , PD2    ,&
 & PDELP  , PIVEG  , PLAI   , PLNPR  , PRDELP , PRSMIN , PSAB   ,&
 & PGZ0HF , PAESEA , PAELAN , PAESOO , PAEDES , PAESUL , PAEVOL , PRCORI ,&
 & PU     , PV     , PT     , PQ     , PQI    , PQL    ,&
 & PS     , PRR    , PTKE   , PSDSAT , PCVV ,&
 & PO3    , PVORT0 , &
 & PCP    , PCVGQ  , PR     , PKOZO  ,&
 & PFPLCH , PFPLSH ,&
 & PDDAL  , PDDOM  , PENTCH , PUDAL  , PUDOM  , PUNEBH, PEVEL0, &
 & PTCCH  , PSCCH  , PBCCH  , PFHPS  ,&
 & PPBLH  ,&
 & PGPAR  ,&
 & PSNS   , PALBNS , PRHONS ,&
 & PTP    , PTS    , PWL    , PWP    , PWPI   , PWS    , PWSI   ,&
 & PHV    , PVERVEL, &
 & PEMTD  , PEMTU  , PTRSO  , PCLON  ,&
 & PSLON  , PALV   , PALBF  , PALBSF , PEMISF , PGETRL ,&
 & PLSM   , PVEG0  ,&
 & PGZ0F  , PGZ0RLF, PVRLAN ,&
 & PVRLDI , PVO3ABC, PVRMOON, PMU0   , PMU0LU , PMU0M  , PGAW, PGELAM , &
 & PGEMU  , PGM    , POMPAC , PAC    , PCOR   , PMMU0  , PDHSF  ,&
 & PRAB3C , PRAB3N , PRAB4C , PRAB4N , PRAB6C , PRAB6N ,&
 & PRAT1C , PRAT1N , PRAT2C , PRAT2N , PRAT3C , PRAT3N ,&
 & PRAT4C , PRAT4N , PRAT5C , PRAT5N,&
 & POROG  , & 
 ! - OUTPUT .
 & PDIFCQ , PDIFCQI, PDIFCQL, PDIFCS , PDIFTQ , PDIFTQI, PDIFTQL,&
 & PDIFTS , PFCCQL , PFCCQN , PFCSQL , PFCSQN , PFCQVNG , PFCQING,&
 & PFCQLNG, PFCQRNG, PFCQSNG,&
 & PFPLCL , PFPLCN , PFPLSL , PFPLSN , PFRSO  , PFRSOC ,&
 & PFRTH  , PFRTHC , PSTRCU , PSTRCV , PSTRDU , PSTRDV , PSTRTU ,&
 & PSTRTV , PSTRMU , PSTRMV , PFRMH  , PFRMQ  ,&
 & PFCHOZ , PCPS   , PLHS   ,&
 & PRS    , PLH    , PLSCPE , PNEB   , PQICE  , PQLI   , PQSAT  ,&
 & PQW    , PRH    , PTW    , PALB   , PCD    , PCDN   , PCH    ,&
 & PC1    , PC2    , PCT    , PEMIS  , PFCHSP , PFCLL  , PFCLN  ,&
 & PFCS   , PFEVI  , PFEVL  , PFEVN  , PFEVV  , PFTR   , PFLWSP ,&
 & PFONTE , PALBH  ,&
 & PFGEL  , PFGELS , PFRSODS, PFRSOPS, PFRSOPT, PFRSOLU, PFRTHDS,&
 & PFPFPSL, PFPFPSN, PFPFPCL, PFPFPCN, PFPEVPSL,PFPEVPSN,PFPEVPCL,&
 & PFPEVPCN,PFTKE  , PGZ0   , PGZ0H  , PNEIJ  , PVEG   , PQS    ,&
 & PQSATS , PRUISL , PRUISP , PRUISS , PUCLS  , PVCLS  , PTCLS  ,&
 & PQCLS  , PRHCLS , PCLCT  , PCLCH  , PCLCM  , PCLCL  , PCLCC  ,&
 & PCAPE  , KCLPH  , PCLPH  , PUGST  , PVGST  ,&
 & PTENDPTKE,&
 & PDERNSHF, & 
 ! - LOCK ARGUMENTS .
 & CDLOCK)  

!**** *APLPAR * - APPEL DES PARAMETRISATIONS PHYSIQUES.

!     Sujet.
!     ------
!     - APPEL DES SOUS-PROGRAMMES DE PARAMETRISATION
!       INTERFACE AVEC LES PARAMETRISATIONS PHYSIQUES (IALPP).
!     - CALL THE SUBROUTINES OF THE E.C.M.W.F. PHYSICS PACKAGE.

!**   Interface.
!     ----------
!        *CALL* *APLPAR*

!-----------------------------------------------------------------------

! -   ARGUMENTS D'ENTREE.
! -   INPUT ARGUMENTS.
!     -------------------

! - NOM DES PARAMETRES DE DIMENSIONNEMENT DE LA PHYSIQUE.
! - DIMENSIONS.

! KBL  : NUMERO DE BLOC NPROMA
! KBL  : NPROMA-PACKETS NUMBER
! KGPCOMP : NOMBRE TOTAL DE POINTS DE GRILLE SUR LE DOMAINE
! KGPCOMP : TOTAL GRID POINTS NUMBER IN THE DOMAIN
! KIDIA, KFDIA : BORNES BOUCLES HORIZONTALES   (IST,IEND DANS CPG).
! KIDIA, KFDIA : START/END OF HORIZONTAL LOOP  (IST,IEND IN *CPG*).
! KLON : DIMENSION HORIZONTALE                 (NPROMA DANS CPG).
! KLON : HORIZONTAL DIMENSION                  (NPROMA IN *CPG*).
! KLON: IDEM BUT FOR ARRAYS USED SOLELY BY DMN PHYSICS
! KTDIA : DEBUT BOUCLE VERTICALE DANS LA PHYSIQUE.
! KTDIA : START OF THE VERTICAL LOOP IN THE PHYSICS (IF SOME LEVELS ARE
!                     SKIPPED AT THE TOP OF THE MODEL).
! KLEV : FIN BOUCLE VERTICE ET DIMENSION VERTICALE (NFLEVG DANS CPG).
! KLEV : END OF VERTICAL LOOP AND VERTICAL DIMENSION(NFLEVG IN *CPG*).
! KGL1, KGL2 : BORNES BANDES LATITUDES CONCATENEES DANS BOUCLE (1,KLON)
! KGL1, KGL2 : START/END CONCATENATED LATITUDES IN VECTOR OF KLON LENGTH
! KSTGLO     : global offset.
! KVCLIS     : NOMBRE DE CHAMPS POUR LA PHOTO-CHIMIE DE L'OZONE.
!                     (NVCLIS DANS CPG).
! KVCLIS     : NUMBER OF FIELDS FOR OZONE PHOTO-CHEMISTRY.
!                     (NVCLIS IN CPG).
! KVCLIV     : NOMBRE DE CHAMPS POUR LA VEGETATION (NVCLIV DANS CPG).
! KVCLIV     : NUMBER OF FIELDS FOR VEGETATION (NVCLIV IN CPG).
! KSGST      : NOMBRE DE TEMPERATURES ET DE FLUX DE SURFACE SOUS-MAILLE
!                     (NTSSG DANS CPG)
! KSGST      : NUMBER OF SUBGRID SURFACE TEMPERATURES AND FLUXES
!                     (NTSSG IN *CPG*)
! KCSS       : NBRE DE NIVEAUX DANS LE SOL PROFOND
! KCSS       : NBR OF VERTICAL LAYERS IN THE DEEP SOIL

! - NOM DES VARIABLES DE LA PHYSIQUE (PAR ORDRE ALPHABETIQUE DANS CHAQUE
!   CATEGORIE).

! - 2D (0:KLEV) .

! PAPHI      : GEOPOTENTIEL AUX DEMI-NIVEAUX.
! PAPHI      : GEOPOTENTIAL ON HALF-LEVELS.
! PAPRS      : PRESSION AUX DEMI-NIVEAUX.
! PAPRS      : PRESSURE ON HALF-LEVELS.

! - 2D (1:KLEV) .

! PAPHIF     : GEOPOTENTIEL AUX NIVEAUX DES COUCHES.
! PAPHIF     : GEOPOTENTIAL ON FULL LEVELS.
! PAPRSF     : PRESSION AUX NIVEAUX DES COUCHES.
! PAPRSF     : PRESSURE ON FULL LEVELS.
! PALPH      : LOG(PAPRS(JLEV)/PAPRSF(JLEV)) (POUR L'HYDROSTATIQUE).
! PALPH      : LOG(PAPRS(JLEV)/PAPRSF(JLEV)) (FOR HYDROSTATICS).
! PDDAL      : FRACTION DE LA MAILLE POUR LE DOWNDRAUGHT
! PDDAL      : DOWNDRAUGHT MESH FRACTION
! PDDOM      : VITESSE VERTICALE DU DOWNDRAUGHT
! PDDOM      : DOWNDRAUGHT VERTICAL VELOCITY
! PDELP      : EPAISSEUR EN PRESSION DE LA COUCHE.
! PDELP      : LAYER THICKNESS IN PRESSURE UNITS.
! PENTCH     : L'ENTRAINMENT PRONOSTIQUE/ PSEUDO HISTORIQUE
! PENTCH     : PROGNOSTIC/ PSEUDO HISTORIC  ENTRAINMENT
! PEVEL0     : ETA_dot*d(Pi)/d(ETA) aux niveaux des couches
! PEVEL0     : ETA_dot*d(Pi)/d(ETA)at full levels
! PLNPR      : LOG(PAPRS(JLEV)/PAPRS(JLEV-1)) (POUR L'HYDROSTATIQUE).
! PLNPR      : LOG(PAPRS(JLEV)/PAPRS(JLEV-1)) (FOR HYDROSTATICS).
! PRDELP     : INVERSE DE L'EPAISSEUR EN PRESSION DE LA COUCHE.
! PRDELP     : INVERSE OF PDELP.
! PU         : COMPOSANTE EN X DU VENT.
! PU         : X-COMPONENT OF WIND.
! PUDAL      : FRACTION DE LA MAILLE POUR L'UPDRAUGHT 
! PUDAL      : UPDRAUGHT MESH FRACTION
! PUDOM      : VITESSE VERTICALE DE L'UPDRAUGHT
! PUDOM      : UPDRAUGHT VERTICAL VELOCITY
! PUNEBH     : FRACTION DETRAINEE (PSEUDO) HISTORIQUE
! PUNEBH     : (PSEUDO) HISTORIC DETRAINED FRACTION
! PV         : COMPOSANTE EN Y DU VENT.
! PV         : Y-COMPONENT OF WIND.
! PT         : TEMPERATURE.
! PQ         : HUMIDITE SPECIFIQUE DE LA VAPEUR D'EAU.
! PQ         : SPECIFIC HUMIDITY OF WATER VAPOUR.
! PQI        : GLACE.
! PQI        : ICE.
! PS         : NEIGE
! PS         : SNOW
! PRR        : RAIN (PR is already used by gas constant !)
! PRR        : PLUIE
! PTENDPTKE  : INCREMENT DE LA ENERGIE CINETIQUE TURBULENTE (schema pTKE)
! PTENDPTKE  : TKE INCREMENT (USED BY PSEUDOPROGNOSTIC TKE SCHEME)
! PTKE       : Energie Cinetique Turbulente
! PTKE       : TKE
! PQL        : EAU LIQUIDE.
! PQL        : LIQUID WATER.
! PVORT0     : TOURBILLON RELATIF.
! PVORT0     : RELATIVE VORTICITY.
! PSDSAT     : Standard deviation of the Saturation Depression
! PCVV       : Convective Vertical Velocity
! PO3        : GFL OZONE.
! PCP        : CHALEUR MASSIQUE A PRESSION CONSTANTE DE L'AIR.
! PCP        : SPECIFIC HEAT AT CONSTANT PRESSURE FOR AIR.
! PCVGQ      : CONVERGENCE D'HUMIDITE (CONDITION DE "KUO").
! PCVGQ      : CONVERGENCE OF HUMIDITY ("KUO" CONDITION).
! PKOZO      : CHAMPS POUR LA PHOTOCHIMIE DE L'OZONE (KVCLIS CHAMPS).
! PKOZO      : FIELDS FOR PHOTOCHEMISTERY OF OZONE   (KVCLIS FIELDS).
! PR         : CONSTANTE DES GAZ POUR L'AIR.
! PR         : GAS CONSTANT FOR AIR.

! - 1D (PROGNOSTIQUE) .
! - 1D (PROGNOSTIC QUANTITIES) .

! PALBNS     : ALBEDO DE LA NEIGE.
! PALBNS     : SNOW ALBEDO.
! PRHONS     : DENSITE DE LA NEIGE.
! PRHONS     : SNOW DENSITY.
! PSNS       : MASSE PAR UNITE DE SURFACE DE LA COUCHE NEIGEUSE.
! PSNS       : MASS OF SNOW PER UNIT SURFACE.
! PTP        : TEMPERATURE EN PROFONDEUR.
! PTP        : DEEP-LAYER TEMPERATURE.
! PTS        : TEMPERATURE DE SURFACE.
! PTS        : SURFACE LAYER TEMPERATURE.
! PWL        : CONTENU EN EAU DU RESERVOIR SUPERFICIEL
! PWL        : SKIN RESERVOIR WATER CONTENT
! PWP        : CONTENU EN EAU DU RESERVOIR EN PROFONDEUR.
! PWP        : DEEP-LAYER WATER CONTENT.
! PWPI       : CONTENU EN EAU GELEE DU RESERVOIR EN PROFONDEUR.
! PWPI       : DEEP-LAYER ICE CONTENT.
! PWS        : CONTENU EN EAU DU RESERVOIR DE SURFACE.
! PWS        : SURFACE LAYER WATER CONTENT.
! PWSI       : CONTENU EN EAU GELEE DU RESERVOIR DE SURFACE.
! PWSI       : SURFACE LAYER ICE CONTENT.

! - 1D (GEOGRAPHIQUE) .
! - 1D (GEOGRAPHICAL DISTRIBUTION) .

! PAESEA     : AEROSOLS MARINS (SI LAEROSEA=.T.)
! PAESEA     : MARINE AEROSOLS (IF LAEROSEA=.T.)
! PAELAN     : AEROSOLS CONTINENTAUX (SI LAEROLAN=.T.)
! PAELAN     : CONTINENTAL AEROSOLS (IF LAEROLAN=.T.) 
! PAESOO     : AEROSOLS CARBONES (SI LAEROSOO=.T.)
! PAESOO     : SOOT AEROSOLS (IF LAEROSOO=.T.)
! PAEDES     : AEROSOLS DESERTIQUES (SI LAERODES=.T.)
! PAEDES     : DESERT AEROSOLS (IF LAERODES=.T.=
! PAESUL     : AEROSOLS SULFATES (SI LAEROSUL=.T.)
! PAESUL     : SULFATE AEROSOLS  (IF LAEROSUL=.T.)
! PAEVOL     : AEROSOLS VOLCAN   (SI LAEROVOL=.T.)
! PAEVOL     : VOLCANO AEROSOLS  (IF LAEROVOL=.T.)
! PALV       : ALBEDO DE LA VEGETATION.
! PALV       : VEGETATION ALBEDO.
! PALBF      : ALBEDO FIXE (SOL SANS NEIGE).
! PALBF      : BACKGROUND SURFACE SHORTWAVE ALBEDO (SNOW-FREE).
! PALBSF     : ALBEDO FIXE DU SOL (SOL SANS NEIGE).
! PALBSF     : BACKGROUND SOIL SHORTWAVE ALBEDO (SNOW-FREE).
! PARG       : POURCENTAGE D'ARGILE DANS LE SOL.
! PARG       : SILT PERCENTAGE WITHIN THE SOIL.
! PD2        : EPAISSEUR DU RESERVOIR PROFOND.
! PD2        : DEEP-LAYER OF THE OF THE PROFOUND WATER-TANK.
! PEMISF     : EMISSIVITE FIXE (SOL SANS NEIGE).
! PEMISF     : BACKGROUND SURFACE LONGWAVE EMISSIVITY (SNOW-FREE).
! PGETRL     : ECART TYPE DE L'OROGRAPHIE (EN J/KG).
! PGETRL     : STANDARD DEVIATION OF OROGRAPHY  (UNIT: J/KG).
! PLSM       : INDICE TERRE/MER.
! PLSM       : LAND/SEA MASK.
! PIVEG      : TYPE DE VEGETATION.
! PIVEG      : TYPE OF VEGETATION.
! PLAI       : INDICE FOLIAIRE.
! PLAI       : FOLIAIRE INDICE.
! PRCORI     : FACTEUR DE CORIOLIS.
! PRCORI     : CORIOLIS FACTOR.
! PRSMIN     : RESISTANCE STOMATIQUE MINIMALE.
! PRSMIN     : STOMATAL MINIMAL RESISTANCE.
! PSAB       : POURCENTAGE DE SABLE DANS LE SOL.
! PSAB       : PERCENTAGE OF SAND WITHIN THE SOIL.
! PVEG0      : PROPORTION DE SOL COUVERTE DE VEGETATION.
! PVEG0      : FRACTIONAL COVER BY VEGETATION.
! PVRLAN     : ANISOTROPIE DU RELIEF SOUS MAILLE.
! PVRLDI     : ANGLE DE LA DIRECTION DU RELIEF AVEC L'AXE DES X.
! PVO3ABC    : A,B and C coef for climatological ozone profiles
! PVRMOON    : Moon radiation
! PGZ0F      : GRAVITY * ROUGHNESS LENGTH (TIME VARIABLE).
! PGZ0F      : CHAMP TEMPOREL DE G FOIS LA LONGUEUR DE RUGOSITE.
! PGZ0RLF    : GRAVITY * RELIEF ROUGHNESS LENGTH (TIME VARIABLE).
! PGZ0RLF    : CHAMP TEMPOREL DE G FOIS LA LONGUEUR DE RUGOSITE
!              DUE AU RELIEF.
! PGZ0HF     : G*LONGUEUR DE RUGOSITE THERMIQUE (SI KVCLIV >= 8)
! PGZ0HF     : G*THERMAL ROUGHNESS LENGTH (IF KVCLIV >= 8)

! - 1D (DIAGNOSTIQUE) .
! - 1D (DIAGNOSTIC QUANTITIES).

! PHV        : RESISTANCE A L'EVAPOTRANSPIRATION.
! PHV        : RESISTANCE TO EVAPOTRANSPIRATION.
! PVERVEL    : (OMEGA/P) VERT. VEL. DIVIDED BY PRESSURE.
! PMU0       : COSINUS LOCAL INSTANTANE DE L'ANGLE ZENITHAL SOLAIRE.
! PMU0LU     : COSINUS LOCAL INSTANTANE DE L'ANGLE ZENITHAL LUNAIRE.
! PMU0       : LOCAL COSINE OF INSTANTANEOUS SOLAR ZENITH ANGLE.
! PMU0LU     : LOCAL COSINE OF INSTANTANEOUS LUNAR ZENITH ANGLE.
! PMU0M      : COSINUS LOCAL MOYEN DE L'ANGLE ZENITHAL.
! PMU0M      : LOCAL COSINE OF AVERAGED SOLAR ZENITH ANGLE.
! PFPLCH     : CHAMP "HISTORIQUE" POUR LES PRECIPITATIONS CONVECTIVES.
! PFPLCH     : HISTORICAL FIELD FOR CONVECTIVE PRECIPITATIONS.
! PFPLSH     : CHAMP "HISTORIQUE" POUR LES PRECIPITATIONS STRATIFORMES.
! PFPLSH     : HISTORICAL FIELD FOR STRATIFORM PRECIPITATIONS.
! PGPAR       : BUFFER FOR 2D FIELDS - CONTAINS PRECIP, ALBEDO, EMISS, TS
!             : SURFACE FLUXES

! PMMU0      : MEAN SOLAR ANGLE FOR GIVEN GRID POINT FOR SIMPL.
!              RADIATION SCHEME.
! PDHSF      : DISTRIBUTION OF HORIZONTAL MEAN WEIGHTS USED FOR
!              SIMPLIFIED RADIATION SCHEME.

! PFHPS      : PSEUDO-HISTORICAL ARRAY FOR SURF PRECIP SENSIBLE HEAT FLUX
! PTCCH      : PSEUDO-HISTORICAL ARRAY FOR TOTAL CONVECTIVE CLOUDINESS (1D).
! PSCCH      : PSEUDO-HISTORICAL ARRAY FOR CONVECTIVE CLOUD SUMMIT (1D).
! PBCCH      : PSEUDO-HISTORICAL ARRAY FOR CONVECTIVE CLOUD BASE (1D).
! PPBLH      : PSEUDO-HISTORICAL ARRAY FOR PBL HEIGHT (1D).

! - CONSTANTES

! POMPAC    : Horizontally variable Curtis matrix for thermal rad. (clear sky)
! PAC       : Horizontally cst Curtis matrix for thermal rad. (clear sky)
! PCOR      : CORRECTION FOR CLOUDINESS FOR THERMAL RADIATION

! PRAB3C    : CLEAR-SKY PARALLEL/DIFFUSE REFLECTIVITY.  ---
! PRAB4C    : CLEAR-SKY DIFFUSE TRANSMISSIVITY.            | equivalent
! PRAB6C    : CLEAR-SKY DIFFUSE REFLECTIVITY.              | coefficients
! PRAB3N    : CLOUDY PARALLEL/DIFFUSE REFLECTIVITY.        | from bottom
! PRAB4N    : CLOUDY DIFFUSE TRANSMISSIVITY.               | to given
! PRAB6N    : CLOUDY DIFFUSE REFLECTIVITY.              ---  level

! PRAT1C    : CLEAR-SKY PARALLEL TRANSMISSIVITY.        ---
! PRAT2C    : CLEAR-SKY PARALLEL/DIFFUSE TRANSMISSIVITY.   |
! PRAT3C    : CLEAR-SKY PARALLEL/DIFFUSE REFLECTIVITY.     |
! PRAT4C    : CLEAR-SKY DIFFUSE TRANSMISSIVITY.            | equivalent
! PRAT5C    : CLEAR-SKY DIFFUSE REFLECTIVITY.              | coefficients
! PRAT1N    : CLOUDY PARALLEL TRANSMISSIVITY.              | from top
! PRAT2N    : CLOUDY PARALLEL/DIFFUSE TRANSMISSIVITY.      | to given
! PRAT3N    : CLOUDY PARALLEL/DIFFUSE REFLECTIVITY.        | level
! PRAT4N    : CLOUDY DIFFUSE TRANSMISSIVITY.               |
! PRAT5N    : CLOUDY DIFFUSE REFLECTIVITY.              ---

!-----------------------------------------------------------------------

! -   ARGUMENTS DE SORTIE.
! -   OUTPUT ARGUMENTS.
!     --------------------

! - NOM DES VARIABLES DE LA PHYSIQUE (PAR ORDRE ALPHABETIQUE DANS CHAQUE
!   CATEGORIE).

! - 2D (0:KLEV) .

! PDIFCQ     : FLUX CONVECTIF D'HUMIDITE SPECIFIQUE (HORS PLUIE/NEIGE).
! PDIFCQ     : CONVECTIVE FLUX OF SPECIFIC HUMIDITY (NOT RAIN/SNOW).
! PDIFCQI    : FLUX CONVECTIF D'EAU SOLIDE (HORS PLUIE/NEIGE).
! PDIFCQI    : CONVECTIVE FLUX OF SOLID WATER (NOT RAIN/SNOW).
! PDIFCQL    : FLUX CONVECTIF D'EAU LIQUIDE (HORS PLUIE/NEIGE).
! PDIFCQL    : CONVECTIVE FLUX OF LIQUID WATER (NOT RAIN/SNOW).
! PDIFCS     : FLUX CONVECTIF D'ENTHALPIE (HORS PLUIE/NEIGE).
! PDIFCS     : CONVECTIVE FLUX OF ENTHALPY (NOT RAIN/SNOW).
! PDIFTQ     : FLUX TURBULENT (ET Q NEGATIF) D'HUMIDITE SPECIFIQUE.
! PDIFTQ     : TURBULENT FLUX (INC. Q NEGATIVE) OF SPECIFIC HUMIDITY.
! PDIFTQI    : FLUX TURBULENT (ET Q NEGATIF) D'EAU GLACE.
! PDIFTQI    : TURBULENT FLUX (INC. Q NEGATIVE) OF SOLID WATER.
! PDIFTQL    : FLUX TURBULENT (ET Q NEGATIF) D'EAU LIQUIDE.
! PDIFTQL    : TURBULENT FLUX (INC. Q NEGATIVE) OF LIQUID WATER.
! PDIFTS     : FLUX TURBULENT D'ENTHALPIE (OU D'ENERGIE STATIQUE SECHE).
! PDIFTS     : TURBULENT FLUX OF ENTHALPY (OR DRY STATIC ENERGY).
! PFCHOZ     : FLUX PHOTO-CHIMIQUE D'OZONE.
! PFCHOZ     : OZONE PHOTO-CHEMICAL FLUX.
! PFCCQN     : FLUX DE CONDENSATION LIE AUX RR CONVECTIVES NEIGEUSES.
! PFCCQN     : CONVECTIVE CONDENSATION FLUX FOR ICE.
! PFCCQL     : FLUX DE CONDENSATION LIE AUX RR CONVECTIVES LIQUIDES.
! PFCCQL     : CONVECTIVE CONDENSATION FLUX FOR LIQUID WATER.
! PFCQVNG    : FLUX FICTIF DE VAPEUR POUR CORRIGER LES Q<0.
! PFCQVNG    : PSEUDO-FLUX OF WATER VAPOUR TO CORRECT FOR Q<0.
! PFCQING    : FLUX FICTIF DE GLACE POUR CORRIGER LES QI<0.
! PFCQING    : PSEUDO-FLUX OF ICE TO CORRECT FOR QI<0.
! PFCQLNG    : FLUX FICTIF D'EAU LIQUIDE POUR CORRIGER LES QL<0.
! PFCQLNG    : PSEUDO-FLUX OF LIQUID WATER TO CORRECT FOR QL<0.
! PFCQSNG    : FLUX FICTIF DE GLACE POUR CORRIGER LES QS<0.
! PFCQSNG    : PSEUDO-FLUX OF ICE TO CORRECT FOR QS<0.
! PFCQRNG    : FLUX FICTIF D'EAU LIQUIDE POUR CORRIGER LES QR<0.
! PFCQRNG    : PSEUDO-FLUX OF LIQUID WATER TO CORRECT FOR QR<0.
! PFPEVPSL   : FLUX DE PRECIPITATIONS DU A L'EVAPORATION RESOLUE.
! PFPEVPSL   : PRECIPITATION FLUX DUE TO RESOLVED EVAPORATION.
! PFPEVPSN   : FLUX DE PRECIPITATIONS DU A LA SUBLIMATION RESOLUE.
! PFPEVPSN   : PRECIPITATION FLUX DUE TO RESOLVED SUBLIMATION.
! PFPEVPCL   : FLUX DE PRECIPITATIONS DU A L'EVAPORATION CONVECTIVE.
! PFPEVPCL   : PRECIPITATION FLUX DUE TO CONVECTIVE EVAPORATION.
! PFPEVPCN   : FLUX DE PRECIPITATIONS DU A LA SUBLIMATION CONVECTIVE.
! PFPEVPCN   : PRECIPITATION FLUX DUE TO CONVECTIVE SUBLIMATION.
! PFTKE      : FLUX DE TKE.
! PFTKE      : TKE FLUX.
! PFPFPSL    : FLUX DE PRECIPITATION RESOLUE : TERME DE GENERATION/FORMATION. 
! PFPFPSL    : FLUX OF RESOLVED PRECIPITATION : THE GENERATION TERM. 
! PFPFPSN    : FLUX DE PRECIPITATION RESOLUE : TERME DE GENERATION/FORMATION. 
! PFPFPSN    : FLUX OF RESOLVED PRECIPITATION : THE GENERATION TERM. 
! PFPFPCL    : FLUX DE PRECIPITATION CONVECTIVE: TERME DE GENERATION/FORMATION. 
! PFPFPCL    : FLUX OF CONVECTIVE PRECIPITATION : THE GENERATION TERM. 
! PFPFPCN    : FLUX DE PRECIPITATION CONVECTIVE: TERME DE GENERATION/FORMATION. 
! PFPFPCN    : FLUX OF CONVECTIVE PRECIPITATION : THE GENERATION TERM. 
! PFPLCL     : PRECIPITATIONS CONVECTIVES SOUS FORME LIQUIDE.
! PFPLCL     : CONVECTIVE PRECIPITATION AS RAIN.
! PFPLCN     : PRECIPITATIONS CONVECTIVES SOUS FORME NEIGE.
! PFPLCN     : CONVECTIVE PRECIPITATION AS SNOW.
! PFPLSL     : PRECIPITATIONS STRATIFORMES SOUS FORME LIQUIDE.
! PFPLSL     : STRATIFORM PRECIPITATION AS RAIN.
! PFPLSN     : PRECIPITATIONS STRATIFORMES SOUS FORME NEIGE.
! PFPLSN     : STRATIFORM PRECIPITATION AS SNOW.
! PFRMH      : FLUX MESOSPHERIQUE D'ENTHALPIE.
! PFRMH      : MESOSPHERIC ENTHALPY FLUX.
! PFRMQ      : FLUX MESOSPHERIQUE D'humidite.
! PFRMQ      : MESOSPHERIC humidity flux
! PFRSO      : FLUX DE RAYONNEMENT SOLAIRE.
! PFRSO      : SHORTWAVE RADIATIVE FLUX.
! PFRTH      : FLUX DE RAYONNEMENT THERMIQUE.
! PFRTH      : LONGWAVE RADIATIVE FLUX.
! PFCSQN     : FLUX DE CONDENSATION LIE AUX RR STRATIFORMES NEIGEUSES.
! PFCSQN     : STRATIFORM CONDENSATION FLUX FOR ICE.
! PFCSQL     : FLUX DE CONDENSATION LIE AUX RR STRATIFORMES LIQUIDES.
! PFCSQL     : STRATIFORM CONDENSATION FLUX FOR LIQUID WATER.
! PSTRCU     : FLUX CONVECTIF DE QUANTITE DE MOUVEMENT "U".
! PSTRCU     : CONVECTIVE FLUX OF MOMENTUM "U".
! PSTRCV     : FLUX CONVECTIF DE QUANTITE DE MOUVEMENT "V".
! PSTRCV     : CONVECTIVE FLUX OF MOMENTUM "V".
! PSTRDU     : FLUX "GRAVITY WAVE DRAG" "U".
! PSTRDU     : GRAVITY WAVE DRAG FLUX "U".
! PSTRDV     : FLUX "GRAVITY WAVE DRAG" "V".
! PSTRDV     : GRAVITY WAVE DRAG FLUX "V".
! PSTRTU     : FLUX TURBULENT DE QUANTITE DE MOUVEMENT "U".
! PSTRTU     : TURBULENT FLUX OF MOMENTUM "U".
! PSTRTV     : FLUX TURBULENT DE QUANTITE DE MOUVEMENT "V".
! PSTRTV     : TURBULENT FLUX OF MOMENTUM "V".
! PSTRMU     : FLUX MESOSPHERIQUE DE QUANTITE DE MOUVEMENT "U".
! PSTRMU     : MESOSPHERIC FLUX FOR "U"-MOMENTUM.
! PSTRMV     : FLUX MESOSPHERIQUE DE QUANTITE DE MOUVEMENT "V".
! PSTRMV     : MESOSPHERIC FLUX FOR "V"-MOMENTUM.

! - 2D (1:KLEV) .

! PLH        : CHALEUR LATENTE A LA TEMPERATURE DE L'AIR.
! PLH        : LATENT HEAT AT AIR TEMPERATURE.
! PLSCPE     : RAPPORT EFECTIF DES L ET CP EN CONDENSATION/EVAPORATION.
! PLSCPE     : EFFECTIVE RATIO OF L AND CP FOR CONDENSATION/EVAPORATION.
! PNEB       : NEBULOSITE PARTIELLE "RADIATIVE".
! PNEB       : FRACTIONAL CLOUDINESS FOR RADIATION.
! PQICE      : HUMIDITE SPECIFIQUE SOLIDE "RADIATIVE".
! PQICE      : SPECIFIC HUMIDITY OF SOLID WATER FOR RADIATION.
! PQLI       : HUMIDITE SPECIFIQUE LIQUIDE "RADIATIVE".
! PQLI       : SPECIFIC HUMIDITY OF LIQUID WATER FOR RADIATION.
! PQSAT      : HUMIDITE SPECIFIQUE DE SATURATION.
! PQSAT      : SPECIFIC HUMIDITY AT SATURATION.
! PQW        : HUMIDITE SPECIFIQUE DU THERMOMETRE MOUILLE.
! PQW        : SPECIFIC HUMIDITY OF THE WET THERMOMETER.
! PRH        : HUMIDITE RELATIVE.
! PRH        : RELATIVE HUMIDITY.
! PTW        : TEMPERATURE DU THERMOMETRE MOUILLE.
! PTW        : TEMPERATURE OF THE WET THERMOMETER.

! - 2D (CLOUD AND RADIATION I/O FOR ECMWF PHYSICS)

! PEMTD      : DOWNWARD LONGWAVE EMISSIVITY
! PEMTU      : UPWARD   LONGWAVE EMISSIVITY
! PTRSO      : SHORTWAVE TRANSMISSIVITY
! ZTENT      : TENDENCY OF TEMPERATURE.
! PDERNSHF   : DERIVATIVE OF THE NON SOLAR SURFACE WITH RESPECT TO Tsurf

! - 2D (0:1)
! PFRSOC     : SHORTWAVE CLEAR SKY RADIATIVE FLUX
! PFRTHC     : LONGWAVE CLEAR SKY RADIATIVE FLUX

! - 1D (DIAGNOSTIQUE) .

! PALB       : ALBEDO DE SURFACE COURANT.
! PALB       : MODEL SURFACE SHORTWAVE ALBEDO.
! PCD        : COEFFICIENT D'ECHANGE EN SURFACE POUR U ET V.
! PCD        : EXCHANGE COEFFICIENT AT SURFACE LEVEL FOR U AND V.
! PCDN       : COEFFICIENT NEUTRE D'ECHANGE EN SURFACE.
! PCDN       : EXCHANGE COEFF. AT SURFACE LEVEL IN NEUTRAL CONDITIONS.
! PCH        : COEFFICIENT D'ECHANGE EN SURFACE POUR T ET Q.
! PCH        : EXCHANGE COEFFICIENT AT SURFACE LEVEL FOR T AND Q.
! PCPS       : CHALEUR MASSIQUE DE L'AIR EN SURFACE.
! PC1        : COEFF. HYDRIQUE REPRESENTANT L'INTENSITE AVEC LAQUELLE
!              LES FLUX DE SURFACE PARTICIPENT A L'EVOLUTION DE WS.
! PC1        : HYDROLOGICAL COEFF. SHOWING THE CONTRIBUTION OF SURFACE
!              FLUXES IN THE WS EVOLUTION.
! PC2        : COEFF. HYDRIQUE TRADUISANT LA RAPIDITE DES TRANSFERTS
!              D'EAU ENTRE LES DEUX RESERVOIRS.
! PC2        : HYDROLOGICAL COEFFICIENT SHOWING THE QUICKNESS OF WATER
!              TRANSFERS BETWEEN BOTH TANKS.
! PCT        : COEFFICIENT THERMIQUE DU MILIEU SOL-VEGETATION.
! PCT        : THERMICAL COEFFICIENT OF SOIL-VEGETATION MIDDEL.
! PEMIS      : EMISSIVITE DE SURFACE COURANTE.
! PEMIS      : MODEL SURFACE LONGWAVE EMISSIVITY.
! PFCHSP     : FLUX DE CHALEUR DE LA SURFACE VERS LE SOL PROFOND.
! PFCHSP     : HEAT FLUX FROM SURFACE TO DEEP SOIL.
! PFCLL      : FLUX DE CHALEUR LATENTE SUR EAU LIQUIDE (OU SOL HUMIDE).
! PFCLL      : LATENT HEAT FLUX OVER LIQUID WATER (OR WET SOIL).
! PFCLN      : FLUX DE CHALEUR LATENTE SUR NEIGE (OU GLACE).
! PFCLN      : LATENT HEAT FLUX OVER SNOW (OR ICE).
! PFCS       : FLUX DE CHALEUR SENSIBLE EN SURFACE.
! PFCS       : SENSIBLE HEAT FLUX AT SURFACE LEVEL.
! PFEVI      : FLUX DE VAPEUR D'EAU SUR SOL GELE.
! PFEVI      : WATER VAPOUR FLUX OVER FROZEN SOIL.
! PFEVL      : FLUX DE VAPEUR D'EAU SUR EAU LIQUIDE (OU SOL HUMIDE).
! PFEVL      : WATER VAPOUR FLUX OVER LIQUID WATER (OR WET SOIL)
! PFEVN      : FLUX DE VAPEUR D'EAU SUR NEIGE (OU GLACE) ET SOL GELE.
! PFEVN      : WATER VAPOUR FLUX OVER SNOW (OR ICE) AND FROZEN SOIL.
! PFEVV      : FLUX D'EVAPOTRANSPIRATION.
! PFEVV      : EVAPOTRANSPIRATION FLUX.
! PFTR       : FLUX DE TRANSPIRATION.
! PFTR       : TRANSPIRATION FLUX.
! PFLWSP     : FLUX D'EAU LIQUIDE DE LA SURFACE VERS LE SOL PROFOND.
! PFLWSP     : WATER FLUX FROM SURFACE TO DEEP SOIL.
! PFONTE     : FLUX D'EAU CORRESPONDANT A LA FONTE DE NEIGE EN SURFACE.
! PFONTE     : WATER FLUX CORRESPONDING TO SURFACE SNOW MELT.
! PALBH      : ALBEDO TOTAL UTILISE DANS LA PREVISION.
! PALBH      : TOTAL ALBEDO USED DURING THE FORECAST.
! PFRSODS    : FLUX SOLAIRE DESCENDANT EN SURFACE
! PFRSODS    : SURFACE DOWNWARDS SOLAR FLUX
! PFRSOPS    : FLUX SOLAIRE PARALLELE EN SURFACE
! PFRSOPS    : SURFACE PARALLEL SOLAR FLUX
! PFRTHDS    : FLUX IR DESCENDANT EN SURFACE
! PFRTHDS    : SURFACE DOWNWARDS IR FLUX
! PGZ0       : G FOIS LA LONGUEUR DE RUGOSITE COURANTE.
! PGZ0       : G * ROUGHNESS LENGTH (CURRENT).
! PGZ0H      : G*LONGUEUR DE RUGOSITE THERMIQUE COURANTE (SI KVCLIV >= 8)
! PGZ0H      : CURRENT G*THERMAL ROUGHNESS LENGTH (IF KVCLIV >= 8)
! PLHS       : CHALEUR LATENTE EN SURFACE.
! PNEIJ      : PROPORTION DE SOL ENNEIGE.
! PNEIJ      : FRACTION OF SOIL COVERED BY SNOW.
! PVEG       : FRACTION DE VEGETATION APPARENTE.
! PVEG       : FRACTIONAL COVER BY APPARENT VEGETATION.
! PQS        : HUMIDITE SPECIFIQUE DE SURFACE.
! PQS        : SPECIFIC HUMIDITY AT SURFACE LEVEL.
! PQSATS     : HUMIDITE SPECIFIQUE DE SATURATION EN SURFACE.
! PQSATS     : SATURATED SPECIFIC HUMIDITY AT SURFACE LEVEL.
! PRS        : CONSTANTE DES GAZ DE L'AIR EN SURFACE.
! PRUISP     : FLUX DE RUISSELLEMENT EN PROFONDEUR.
! PRUISP     : RUN-OFF FLUX IN SOIL.
! PRUISL     : FLUX DE RUISSELLEMENT DU RESERVOIR D'INTERCEPTION.
! PRUISL     : RUN-OFF FLUX OUT THE INTERCEPTION WATER-TANK.
! PRUISS     : FLUX DE RUISSELLEMENT EN SURFACE.
! PRUISS     : RUN-OFF FLUX AT SURFACE LEVEL.
! PFGEL      : FLUX DE GEL DE L'EAU DU SOL.
! PFGEL      : FREEZING FLUX OF SOIL WATER.
! PFGELS     : FLUX DE GEL DE L'EAU DU RESERVOIR DE SURFACE.
! PFGELS     : FREEZING FLUX OF SOIL WATER AT SURFACE LEVEL.
! PUCLS      : SORTIE DIAGNOSTIQUE DU VENT EN X A HUV METEO.
! PUCLS      : U-COMPONENT OF WIND AT 10 METERS (DIAGNOSTIC).
! PVCLS      : SORTIE DIAGNOSTIQUE DU VENT EN Y A HUV METEO.
! PVCLS      : V-COMPONENT OF WIND AT 10 METERS (DIAGNOSTIC).
! PTCLS      : SORTIE DIAGNOSTIQUE DE LA TEMPERATURE A HTQ METEO.
! PTCLS      : TEMPERATURE AT 2 METERS (DIAGNOSTIC).
! PQCLS      : SORTIE DIAGNOSTIQUE DE L'HUMIDITE SPECIFIQUE A HTQ METEO.
! PQCLS      : SPECIFIC HUMIDITY AT 2 METERS (DIAGNOSTIC).
! PRHCLS     : SORTIE DIAGNOSTIQUE DE L'HUMIDITE RELATIVE A HTQ METEO.
! PRHCLS     : RELATIVE HUMIDITY AT 2 METERS (DIAGNOSTIC).
! PCLCC      : SORTIE DIAGNOSTIQUE DE LA NEBULOSITE CONVECTIVE.
! PCLCC      : CONVECTIVE CLOUD COVER (DIAGNOSTIC).
! PCLCH      : SORTIE DIAGNOSTIQUE DE LA NEBULOSITE HAUTE.
! PCLCH      : HIGH CLOUD COVER (DIAGNOSTIC).
! PCLCL      : SORTIE DIAGNOSTIQUE DE LA NEBULOSITE BASSE.
! PCLCL      : LOW CLOUD COVER (DIAGNOSTIC).
! PCLCM      : SORTIE DIAGNOSTIQUE DE LA NEBULOSITE MOYENNE.
! PCLCM      : MEDIUM CLOUD COVER (DIAGNOSTIC).
! PCLCT      : SORTIE DIAGNOSTIQUE DE LA NEBULOSITE TOTALE.
! PCLCT      : TOTAL CLOUD COVER (DIAGNOSTIC).
! PCAPE      : CAPE.
! PCLPH      : HAUTEUR (EN METRES) DE LA COUCHE LIMITE PLANETAIRE
! PCLPH      : HEIGHT (IN METERS) OF THE PBL
! PUGST      : SORTIE DIAGNOSTIQUE DES RAFALES EN X
! PUGST      : U-COMPONENT OF GUSTS (DIAGNOSTIC).
! PVGST      : SORTIE DIAGNOSTIQUE DES RAFALES EN Y
! PVGST      : V-COMPONENT OF GUSTS (DIAGNOSTIC).


!-----------------------------------------------------------------------

! -   ARGUMENTS IMPLICITES.
! -   IMPLICIT ARGUMENTS.
!     ---------------------

! COMMON/YOMLUN /: UNITE NULOUT.
! COMMON/YOMCST /: CONSTANTES UNIVERSELLES.
! COMDECK/FCTTRM/: FONCTIONS THERMODYNAMIQUES METEO-FRANCE.
! COMMON/YOMPHY /: INDICATEURS LOGIQUES.
! COMMON/YOMPHY0, YOMPHY1, YOMPHY2, YOMPHY3/:
!       CONSTANTES PHYSIQUES (UTILES A L'INTERIEUR MEME DE LA PHYSIQUE)
!       ( PROVISOIREMENT, COORDONNEE VERTICALE SS DIM /YOMGEM/).
! COMMON/YOMPHY0, YOMPHY1, YOMPHY2, YOMPHY3/:
!       PHYSICAL CONSTANTS   (USED WITHIN METEO-FRANCE PHYSICS)
!       ( TEMPORARILY DIMENSIONLESS VERTICAL COORDINATE /YOMGEM/).
! COMMON/YOECON /: UNIVERSAL CONSTANTS.(OLD MODEL VALUES).
! COMDECK/FCTTRE/: THERMODYNAMICAL FUNCTIONS. ECMWF.
! COMMON/YOEPHY /: LOGICAL SWITCHES.
! COMMON/YOERAD,YOEVDF,YOECUMF,YOEGWD,ETC.../: PHYSICAL CONSTANTS ECMWF.

!-----------------------------------------------------------------------

!     Externes.
!     ---------

!     Methode.
!     --------
!     - TERMINE LES INITIALISATIONS.
!     - APPELLE LES SS-PRGMS TAMPONS SUIVANT LA LOGIQUE TROUVEE
!        DANS /YOMPHY/. EUX MEMES VONT DECLARER LES TABLEAUX DE TRAVAIL
!        ET APPELER LES PARAMETRISATIONS ELLES MEMES.
!     - FINISH UP THE INITIALIZATION.
!     - CALL THE BUFFER SUBROUTINES FOLLOWING /YOEPHY/ REQUIREMENTS
!        WHICH IN TURN CALL THE ACTUAL PHYSICS SUBROUTINES
!        (THIS LAST POINT NOT PARTIALLY DONE)

!     Auteur.
!     -------
!     90-09-28: A. Joly, *CNRM*.

!     Modifications.
!     --------------
!     91-05-21 by A.Lasserre-Bigorry (scalar variables)
!     91-06-10 by A.Lasserre-Bigorry (middle atmosphere model)
!     91-09-25 by A.Lasserre-Bigorry and M. Deque (ozone chemistry)
!     91-10: J.F. Geleyn *CNRM*.
!     91-10: ADAPTED FROM THE METEO-FRANCE VERSION
!            TO THE ECMWF PHYSICS PACKAGE BY J.-J. MORCRETTE.
!     91-11-15, Michel Deque : standardization of *ADRME* and *AOZONE*.
!     92-03-31, Ryad El Khatib : subroutine *AMHMT*.
!     92-04-01, Jean-Marcel Piriou: diagnostic de l'humidite relative.
!     92-01-28, C. Castejon and E. Gerard (cloudiness statistic scheme).
!     91-02-01, H. Giordani, P. Le Moigne, W. Maurel.
!            ( Soil-Vegetation Parametrization )
!     92-05-01, Jean-Jacques Morcrette, ECMWF Physics LEZERO=.F. config.
!     92-05-25 C.Dreveton : ajout diagnostics flux de rayonnement
!     93-03-01, Jean-Jacques Morcrette, ECMWF Physics cloud/rad. I/O
!     94-03-01  M. Deque Shallow-convection clouds
!        Modified 93-11-17 by Ph. Dandin : FMR scheme with MF physics
!     94-01-18, Jean-Marcel Piriou: modification de la CVGQ
!               en fonction de la resolution locale du modele.
!     94-07-14, E.Bazile :
!               Reecriture pour enlever la physique du CEP et pour
!               introduire l'eau liquide et les flux de condensation.
!     94-09, Ph. Dandin - Passage de l'ozone.
!     94-09-05  M. Deque: Aerosols and thermal roughness
!     94-10-17  M. Deque: 4 layer soil temperature
!     94-11     Ph. Dandin - Passage des aerosols.
!     95-01-13, H. Douville : parametrisation de la neige.
!     95-03-07, E.Bazile : Nettoyage de tableaux residuels du CEP
!     95-04-26  M. Deque: fluxes over sea-ice (from coupler)
!     95-04, Ph. Dandin - Albedos diffus/direct.
!     95-12, Ph. Dandin - Modifications ozone/aerosols/FMR
!     97-02, J.M. Piriou:
!            - Schema de nebulosite ACNEBN.
!            - Abandon de VETAH et VETAF pour VAH, VBH, VP00.
!            - Soil inertia.
!     96-11, M. Janiskova - call for computation of the coef. for simpl.
!                           radiation scheme
!     96-06, M. Deque - Modification du test pour diagnostics ciel clair
!     96-09, M. Deque - Flux "descendants" en surface pour FMR
!     96-10, J-L. Ricard - Initialisation de ZXTROV et ZXUROV
!     97-02, P. Marquet - Abandon des VETAH et VETAF -> f(VAH,VBH,VP00)
!     97-03, P. Mercier - Diffusion turbulente + deposition de l'ozone
!     97-05, M. Deque   - Gel de FMR
!     97-08, J.M. Piriou - Replace AMx routines by ACx ones, introduce CDLOCK.
!     97-09, J.M. Piriou
!       - Move ZXTROV and ZXUROV initialization to a 0:KLEV loop.
!     97-10, M. Deque  - soulevement GWD
!     97-11, E. Bazile - Soil freezing (LFGEL)
!     98-01, M. Deque  - nettoyage ACRADIN
!     98-02, M. Deque  - new convective clouds (LNEBCO+LNEBR)
!     99-02, M. Janiskova - including PDHSF(mean weights for ACRADCOEF)
!     99-01, E. Bazile - Surface soil freezing (PFGELS)
!     98-08, V. Lorant - new mixing length     (LNEBCO+LNEBR)
!     98-12, L. Gerard / E. Bazile / J.M. Piriou
!       -call Stratiform Precipitation before the Convective
!       -move LCAPE key test outside loop
!       -introduce GCOMOD exponent in PCVGQ modulation
!     99-04, J.M. Piriou: Moon radiation.
!     99-02-17, K. YESSAD - options LRETCFOU, LWRTCFOU.
!     2000-03-31, E. Bazile - Output CAPE value from convection (ACCVIMP)
!     2000-06-13, R. El Khatib PBL height, gusts
!     2000-07-20, R. El Khatib PBL height in meters.
!     2000-08-21, R. El Khatib Turbulent gusts out of ACHMT
!     2001-02-02, E. Bazile Modified input of ACDROV (PFEVI).
!     2001-08-01, R. El Khatib LGWD => call ACCOEFK to compute B.-V. frequency
!     2001-08-07  R. El Khatib : Pruning options
!     2001-08, J.M. Piriou / J.F Geleyn
!      - New definition and use of the thermal mixing length.
!     2001-11-27, J.M. Piriou
!      - add grid-scale precipitation into energy input to deep convection
!        (LSRCONT).
!     2002-06-25 F. Bouyssel Pseudo-historical variables (PFPLCH,PFPLSH,PZAUXH)
!     2002-03-30  Y.Bouteloup add PVO3ABC and LO3ABC (clim. ozone profiles)
!     2002-10-29  J.M. Piriou: change definition of PQLI and PQICE:
!       they become grid-size values.
!     2002-09-03 E. Bazile and V.S. and A.B. new snow scheme LVGSN.
!     2002-10-23  K. YESSAD: option lwrtcfou=T: allow to store a temporal
!       average of transmission coefficients.
!     2002-12-10 D. Banciu - Change number of arguments in ACCOEFK call.
!       (phasage Y. Bouteloup)
!     2003-04, M. Bellus: splitting of pseudo-historical array PNEBH
!               into PPCCH, PTCCH, PSCCH, PBCCH, PPBLH + change of
!               arguments in ACHMT, ACNEBT, ACNEBR, ACRADIN, ACNEBC
!               and ACDRAC callings + general cleaning
!     2003-10-01  M.Hamrud:  CY28 Cleaning
!     2003-09   M. Tudor removal of PPCCH, init. of pseudo hist. vars
!       and cleaning
!     2003-10   M. Tudor reintroduce LSOLV and init. of METEO heights
!       (args in ACHMT)
!     2003-12-02  J.M. Piriou: Externalize mixing lengths, use of Troen
!       and Mahrt BLH to compute these lengths for ACCOEFK.
!     2004-01-29 Y. Bouteloup
!       - CALL ACRALU moon radiation in case of use of FMR or RRTM
!     2004-03-08 E. Bazile
!       - Mise en conformite du calcul de THETAV et possibilite d'activer la
!         CLP d'Ayotte ou de Troen & Marht pour calculer la longueur de melange
!     2004-03-05 Y.Bouteloup :
!       - Snow, Rain and TKE in argument for who wants to use them
!     2004-07-06 K. Yessad: use GFL ozone instead of obsolete pas. scalar one.
!     2004-03-26 Y.Bouteloup : Introduction of MTS radiance
!     2004-09-15 F.Bouyssel : Remove initialisation if done in INITAPLPAR
!     2004-11-05 R.Brozkova : New computation of critical humidity      
!     2004-07-27 F.Bouyssel : Use 6 aerosols and introduce NSW
!     2005-03-03 F.Bouyssel : Introduction of Lopez microphysics scheme
!     2005-05-02 F.Bouyssel : Introduction of STPRE, STPREH, VP00
!     2005-10    A. Alias   :  ACDNSHF added (JF Royer)
!     2005-12-19 A. Alias   : Aerosols Modifications (sulfate and volcano added)
!     2006-01-30 F. Vana    : pTKE scheme
!     2006-01-25 F.Bouyssel : New PFPEVPL, PFPEVPN
!     2006-01-25 F.Bouyssel : Change emissivity over sea if LRAYFM
!     2006-04-11 E. Bazile & P. Marquet : TKE scheme from GMGEC (LECT).
!     2006-03-03 R.Brozkova : bug correction when CGMIXLEN='AY'
!     2006-02-06 A. Alias   : GMEGC/EAC modif.
!                J.F. Gueremy : mass-flux deep convection scheme (ACCVIMPGY)
!                               a new cloud-diffusion for conservative
!                P. Marquet - Possible call to ACCVIMP_V3 (if LCVRAV3 for
!                             Bougeault-V3)
!                M. Deque   - Zenithal angle bugfix (ACOZONE)
!                P. Simon   : Introduction du rappel sur l'humidite (ACDRME)
!     2006-10-30 F.Bouyssel : New ACNEBSM arguments (PTS,PNEIJ,PLSM)
!     2006-10-30 F.Bouyssel : Correction of CY31 phasing bug in ACPLUIZ arguments
!     2006-08-29 R.Brozkova : pre-phasing of ALARO microphysics
!     2006-10-01 M. Bellus  : ALARO-0 phasing - 3MT; consistent correction
!                             of the negative values of water species (D. Banciu)
!     2006-08-22 A. Alias   : List of arguments for ACPLUIS has been modified
!     2006-09-19 A. Alias   : Change the test to call ACDNSHF
!     2006-10-25 A. Alias   : Introduction of aerosols logical keys replacing
!                             usage of the number of aerosols
!     2007-02-01 M.Janousek : Introduction of 3MT routines
!     2007-02-19 R.Brozkova : Cleaning obsolet features (LSRCON, LSRCONT, LNEBT,
!                             pre-ISBA, modularisation and racionalisation.
!     2007-04-17 S.Ivatek-S : Over dimensioning of PGPAR (KLON,NGPAR+1) is used
!                             boundary checking bf
!     2007-05-10 E. Bazile  : Introduction of the AROME shallow convection (LCVPPKF)
!     2007-03-21 A. Alias   : Modifications for SURFEX (IGFL_EXT)
!     2007-05-07 F. Bouyssel: Several modifications for SURFEX
!     2007-05-07 F. Bouyssel: New argument in ACCOEFK
!     2007-06-27 A. Alias   : Use NGFL_EXT instead of IGFL_EXT
!     2008-02-18 F. Bouyssel: New acdifv1 & acdifv2 & arp_ground_param
!     2008-02-21 E. Bazile  : Cleaning for the call of the AROME shallow convection (LCVPPKF)
!    4-Mar-2008 Y. Seity : Cleaning IR and WV similated sat radiances
!                            (replaced by Fullpos Calculations)
!     2008-03-14 Y. Bouteloup: Store diffusion coefficients from non-linear model
!     2007-10-11 A. Alias   : New Call to ACHMT/ACNEBR/ACPBLH (P. Marquet/JF. Gueremy)
!     2008-02-01 P. Marquet : modify ZALBD/ZALBP and PFRSODS if LRAYFM15 (idem V4)
!     2008-03-26 F. Bouyssel: Intrduction of LACDIFUS
!     2008-04-28 E. Bazile  : Introduction of ZPROTH_CVPP for the TKE scheme
!     2008-05-09, J.F. Gueremy : Flux MEMO sur mer (ACFLUSO/LFLUSO) +
!            and  P. Marquet   : ZCEROV as new argument in ACDIFUS
!     2008-06-01 F. Bouyssel: Interface of radozc (ECMWF ozone)
!     2008-09-02 F. Vana  : Better split of ACPTKE and ACDIFV1 code
!     2008-10-01 F. Bouyssel: Call of radozcmf instead of radozc (ECMWF ozone)
!     2008-10-05 E. Bazile : Computation of the PBL height from the TKE.
!     03-Oct-2008 J. Masek    parameters for NER statistical model via namelist
!     2009-Jan-21 F. Vana : new mixing lengths for pTKE + few fixes
!     2008-11    C. Payan: Neutral Wind (new arg in the call of ACHMT)
!     2008-11-15 F. Bouyssel: Correction of negative humidities
!     2009-05-25 F. Bouyssel: Cleaning
!     End Modifications

!-----------------------------------------------------------------------
!     ******************************************************************
!     ****** IDIOSYNCRASIES *** IDIOSYNCRASIES *** IDIOSYNCRASIES ******
!     ******************************************************************
!     ***  HEALTH WARNING:                                           ***
!     ***  ===============                                           ***
!     ***  NOTE THAT WITHIN THE E.C.M.W.F. PHYSICS HALF-LEVELS       ***
!     ***  ARE INDEXED FROM 1 TO NFLEVG+1 WHILE THEY ARE BETWEEN     ***
!     ***  0 AND NFLEVG IN THE REST OF THE MODEL. THE CHANGE IS TAKEN***
!     ***  CARE OF IN THE CALL TO THE VARIOUS SUBROUTINES OF THE     ***
!     ***  PHYSICS PACKAGE                                           ***
!     ***                                                            ***
!     ***    THIS IS SUPPOSED TO BE A "TEMPORARY" FEATURE TO BE      ***
!     ***    STRAIGHTENED OUT IN THE "NEAR" FUTURE                   ***
!     ******************************************************************

!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK    ,DR_HOOK
USE YOMGEM   , ONLY : VP00     ,TEQC     ,TEQK
USE YOMPHY   , ONLY : LMPHYS   ,LCAPE    ,LCONDWT   ,&
 &          LCVRA    ,LGWD     ,LGWDC    ,LHMTO    ,LNEBCO   ,&
 &          LNEBN    ,LNEBR    ,NDIFFNEB ,LOZONE   ,LRAY     ,&
 &          LRAYFM   ,LRAYFM15 ,LRRMES   ,LSFHYD   ,LSNV     ,&
 &          LSOLV    ,LSTRA    ,LSTRAS   ,&
 &          LTHERMO  ,LVDIF    ,LO3ABC   ,LRRGUST  ,LVGSN    ,&
 &          LFPCOR   ,LRAYLU   ,CGMIXLEN ,LHUCN    ,LPROCLD,&
 &          LECT     ,LCVPGY   ,LCVRAV3  ,&
 &          LPTKE    ,LRPROX   ,LCVGQD   ,LRCVOTT  ,LNEBCV   ,&
 &          LPHSPSH  ,LSTRAPRO ,LNEWSTAT ,&
 &          LAEROSEA ,LAEROLAN ,LAEROSOO ,LAERODES ,&
 &          LAEROSUL ,LAEROVOL ,&
 &          L3MT     ,LCVPRO   ,LCDDPRO  ,LENTCH   ,&
 &          LCVPPKF  ,LNEBECT  ,LCVGQKF  ,LACDIFUS ,LFLUSO   ,&
 &          LO3FL    ,LECSHAL  ,LECDEEP  
USE YOERAD   , ONLY : NAER     ,NMODE    ,NRADFR   ,NSW      ,&
 &          NOZOCL
USE YOMRAD15 , ONLY : NAER15   ,NFLUX15  ,NMODE15  ,NRAD15   ,&
 &          NRADFR15 ,LRADAER15
USE YOERDI   , ONLY : RCARDI   
USE YOMRDI15 , ONLY : RCARDI15
USE YOMCST   , ONLY : RG       ,RV       ,&
 &          RCPV     ,RETV     ,RCW      ,RCS      ,RLVTT    ,&
 &          RLSTT    ,RTT      ,RALPW    ,RBETW    ,RGAMW    ,&
 &          RALPS    ,RBETS    ,RGAMS    ,RALPD    ,RBETD    ,&
 &          RGAMD    ,RCPD     ,RATM     ,RKAPPA
USE YOMMCC   , ONLY : LMCC03
USE YOMPHY0  , ONLY : NPCLO1   ,NPCLO2   ,AERCS1   ,AERCS3   ,&
 &           AERCS5   ,GCOMOD   ,HUCOE    ,HUTIL    ,HUTIL1  ,HUTIL2   ,&
 &           RTCAPE   ,UHDIFV   ,XMINLM   ,XMAXLM   ,XKLM
USE YOMPHY1  , ONLY : ALCRIN   ,EMCRIN   ,HSOL     ,HSOLIWR  ,&
 &          HSOLIT0  ,WPMX     ,WSMX    ,ALB1     ,ALB2     ,ALBMED   ,&
 &          RLAIMX   ,RLAI     ,TMERGL   ,EMMGLA   ,EMMMER
USE YOMPHY2  , ONLY : TSPHY    ,HCLP     ,HTCLS    ,HVCLS    ,&
 &          LRAFTUR
USE YOMPHY3  , ONLY : QCO2     ,RII0     ,FSM_CC   ,FSM_DD   ,FSM_EE   ,&
 &                    FSM_FF   ,FSM_GG   ,FSM_HH   ,FSM_II
USE YOMTOPH  , ONLY : RMESOU   ,RMESOT   ,NTQSAT   ,NTDIFU   ,&
 &          NTCOEF   ,NTDRAG   ,NTCVIM  ,NTPLUI   ,NTRADI   ,&
 &          NTNEBU   ,NTOZON   ,NTDRME  ,RMESOQ   ,NTCOET
USE YOMCFU   , ONLY : NFRRC
USE YOMSTA   , ONLY : STPHI    ,STTEM    ,STPRE    ,STPREH
USE YOMCT0   , ONLY : LWRTCFOU ,NSTOP
USE YOMSIMPHL, ONLY : LRAYSP   ,LTRAJPST ,LVDIFSPNL
USE YOMRCOEF , ONLY : LRCOEF
USE YOMARPHY  ,ONLY : LMSE     ,LMPA     ,CCOUPLING
USE YOMARAR   ,ONLY : NGPAR    ,MRAIN    ,MSNOW    ,MGZ0     ,&
 &         MGZ0H     ,MVEMIS   ,MVQS     ,MVTS     ,&
 &         MALBDIR   ,MALBSCA  ,XSW_BANDS,NSWB_MNH ,&
 &         MSWDIR    ,MSWDIF
USE YOMRIP   , ONLY : NINDAT   ,NSSSSS   ,RSOVR    ,RCODEC   ,RSIDEC
USE YOM_YGFL  , ONLY : NGFL_EXT
USE YOMIOP   , ONLY : NG3DT95 ,NG3PR95 ,NG2DSF5

!     ------------------------------------------------------------------

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KLON 
INTEGER(KIND=JPIM),INTENT(IN)    :: KLEV 
INTEGER(KIND=JPIM),INTENT(IN)    :: KBL
INTEGER(KIND=JPIM),INTENT(IN)    :: KGPCOMP
INTEGER(KIND=JPIM),INTENT(IN)    :: KVCLIS 
INTEGER(KIND=JPIM),INTENT(IN)    :: KSGST 
INTEGER(KIND=JPIM),INTENT(IN)    :: KCSS 
INTEGER(KIND=JPIM),INTENT(IN)    :: KIDIA 
INTEGER(KIND=JPIM),INTENT(IN)    :: KFDIA 
INTEGER(KIND=JPIM),INTENT(IN)    :: KTDIA 
INTEGER(KIND=JPIM),INTENT(IN)    :: KGL1 
INTEGER(KIND=JPIM),INTENT(IN)    :: KGL2 
INTEGER(KIND=JPIM),INTENT(IN)    :: KSTGLO 
INTEGER(KIND=JPIM),INTENT(IN)    :: KVCLIV
INTEGER(KIND=JPIM),INTENT(IN)    :: KSTEP 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PAPHI(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PAPRS(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PAPHIF(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PAPRSF(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PALPH(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PARG(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PD2(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PDELP(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PIVEG(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PLAI(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PLNPR(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PRDELP(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PRSMIN(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSAB(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PGZ0HF(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PAESEA(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PAELAN(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PAESOO(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PAEDES(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PAESUL(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PAEVOL(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PRCORI(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PU(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PV(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PT(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQ(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PS(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PRR(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTKE(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSDSAT(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCVV(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PQI(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PQL(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PO3(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PVORT0(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCP(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCVGQ(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PR(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PEVEL0(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PKOZO(KLON,KLEV,KVCLIS) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPLCH(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPLSH(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTCCH(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSCCH(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PBCCH(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PPBLH(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFHPS(KLON)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSNS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PGPAR(KLON,NGPAR+1)
REAL(KIND=JPRB)   ,INTENT(IN)    :: PALBNS(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PRHONS(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PTP(KLON,KCSS) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PWL(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PWP(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PWPI(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PWS(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PWSI(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PHV(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PVERVEL(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PEMTD(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PEMTU(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTRSO(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PCLON(KLON) ! Argument NOT used
REAL(KIND=JPRB)   ,INTENT(IN)    :: PSLON(KLON) ! Argument NOT used
REAL(KIND=JPRB)   ,INTENT(IN)    :: PALV(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PALBF(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PALBSF(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PEMISF(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGETRL(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PLSM(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PVEG0(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PGZ0F(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGZ0RLF(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PVRLAN(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PVRLDI(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PVO3ABC(KLON,3) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PVRMOON(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PMU0(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PMU0LU(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PMU0M(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGAW(KLON) ! Argument NOT used
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGELAM(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGEMU(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PGM(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: POROG(KLON)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: POMPAC(KLON,0:KLEV,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PAC(KLEV+1,KLEV+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PCOR(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PMMU0(KLON) 
REAL(KIND=JPRB)   ,INTENT(IN)    :: PDHSF(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRAB3C(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRAB3N(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRAB4C(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRAB4N(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRAB6C(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRAB6N(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRAT1C(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRAT1N(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRAT2C(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRAT2N(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRAT3C(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRAT3N(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRAT4C(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRAT4N(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRAT5C(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRAT5N(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFCQ(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFCQI(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFCQL(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFCS(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFTQ(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFTQI(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFTQL(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDIFTS(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCCQL(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCCQN(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCSQL(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCSQN(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCQVNG(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCQING(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCQLNG(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCQRNG(KLON,0:KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCQSNG(KLON,0:KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPLCL(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPLCN(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPLSL(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPLSN(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFRSO(KLON,0:KLEV,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFRSOC(KLON,0:1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFRTH(KLON,0:KLEV,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFRTHC(KLON,0:1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSTRCU(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSTRCV(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSTRDU(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSTRDV(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSTRTU(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PSTRTV(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSTRMU(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PSTRMV(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFRMH(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFRMQ(KLON,0:KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCHOZ(KLON,0:KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPFPSL(KLON,0:KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPFPSN(KLON,0:KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPFPCL(KLON,0:KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPFPCN(KLON,0:KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPEVPSL(KLON,0:KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPEVPSN(KLON,0:KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPEVPCL(KLON,0:KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFPEVPCN(KLON,0:KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFTKE(KLON,0:KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCPS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PLHS(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRS(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PLH(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PLSCPE(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PNEB(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQICE(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQLI(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQSAT(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQW(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRH(KLON,KLEV) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTW(KLON,KLEV) 
! Prognostic convection variables (MUST BE 1:KLEV for GFL)
! Unless mf_phys has copied them into a 0:KLEV array
! Up to now, we leave 1:KLEV for pentch: see later.
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDDAL(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PDDOM(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PENTCH(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PUDAL(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PUDOM(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PUNEBH(KLON,KLEV)
!---------------------------------------------------
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PALB(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCD(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCDN(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCH(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PC1(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PC2(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PCT(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PEMIS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCHSP(KLON,KCSS) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCLL(KLON,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCLN(KLON,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFCS(KLON,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFEVI(KLON,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFEVL(KLON,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFEVN(KLON,KSGST+1) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFEVV(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFTR(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFLWSP(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFONTE(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PALBH(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFGEL(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PFGELS(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFRSODS(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFRSOPS(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFRSOPT(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFRSOLU(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PFRTHDS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PGZ0(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PGZ0H(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PNEIJ(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PVEG(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQSATS(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRUISL(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRUISP(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRUISS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PUCLS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PVCLS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PTCLS(KLON) 
REAL(KIND=JPRB)   ,INTENT(INOUT) :: PQCLS(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PRHCLS(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PCLCT(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PCLCH(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PCLCM(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PCLCL(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PCLCC(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PCAPE(KLON) 
INTEGER(KIND=JPIM),INTENT(OUT)   :: KCLPH(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PCLPH(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PUGST(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PVGST(KLON) 
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PTENDPTKE(KLON,KLEV)
REAL(KIND=JPRB)   ,INTENT(OUT)   :: PDERNSHF(KLON)

CHARACTER(LEN=6)  ,INTENT(IN)    :: CDLOCK 

!     ------------------------------------------------------------------

!        ATTENTION SI KVCLIG < 7 LES CHAMPS SUIVANTS NE SONT
!        PAS REELLEMENT ALLOUES EN MEMOIRE.
!*
!     ------------------------------------------------------------------

!     DECLARATION DES TABLEAUX LOCAUX-GLOBAUX DES PARAMETRISATIONS

INTEGER(KIND=JPIM) :: INLAB(KLON,KLEV), INLAB_CVPP(KLON,KLEV)
REAL(KIND=JPRB) :: ZVETAH(0:KLEV),ZNLAB(KLON,KLEV),ZNLABCVP(KLON,KLEV)
REAL(KIND=JPRB) :: ZVETAF(KLEV)

!     ------------------------------------------------------------------
!     WARNING: THE ARRAYS ZXTROV, ZXUROV, ZKTROV,ZKUROV, ZKNROV AND ZNBVNO
!     ARE DIMENSIONNED 0:KLEV ONLY IN ORDER TO KEEP IN MIND
!     THAT THEY ARE COMPUTED AT "HALF LEVELS".
!     THEY ARE USED HOWEVER FROM 1 TO KLEV.

REAL(KIND=JPRB) :: ZXTROV(KLON,0:KLEV),ZXUROV(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZXPTKEROV(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZKTROV(KLON,0:KLEV),ZKUROV(KLON,0:KLEV),ZNBVNO(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZKNROV(KLON,0:KLEV)

!     ------------------------------------------------------------------
REAL(KIND=JPRB) :: ZATSLC(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZNEBS(KLON,KLEV),ZQLIS(KLON,KLEV)
REAL(KIND=JPRB) :: ZNEBS0(KLON,KLEV),ZQLIS0(KLON,KLEV)
REAL(KIND=JPRB) :: ZNEBC0(KLON,KLEV)   !Nebulosite convective radiative
REAL(KIND=JPRB) :: ZNEBDIFF(KLON,KLEV) !Nebulosite: calcul de la diffusion
REAL(KIND=JPRB) :: ZNEBCH(KLON,KLEV)   !Nebulosite convective condensation
REAL(KIND=JPRB) :: ZUNEBH(KLON,KLEV)   !Nebulosite convective histo
REAL(KIND=JPRB) :: ZDETFI(KLON,KLEV)   !fraction of instantaneous detrained air
REAL(KIND=JPRB) :: ZFPCOR(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZFHP(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZERO(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZLMT(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZZLMT(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZLMU(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZOME(KLON,KLEV)   ! updraught envt vert vel*dt
REAL(KIND=JPRB) :: ZFALLR(KLON,KLEV) ! fall velocity of rain
REAL(KIND=JPRB) :: ZFALLS(KLON,KLEV) ! fall velocity of snow
REAL(KIND=JPRB) :: ZICEFR1(KLON,KLEV)! Resolved Condensate ice fraction
REAL(KIND=JPRB) :: ZRHCRI(KLON,KLEV) ! Smith scheme critical RH
REAL(KIND=JPRB) :: ZLHS(KLON,KLEV)   ! Sublimation latent heat
REAL(KIND=JPRB) :: ZLHV(KLON,KLEV)   ! Evaporation latent heat
REAL(KIND=JPRB) :: ZLH(KLON,KLEV)    ! Temporar storage for updated PLH
REAL(KIND=JPRB) :: ZLSCPE(KLON,KLEV) ! Temporar storage for updated PLSCPE
REAL(KIND=JPRB) :: ZQSAT(KLON,KLEV)  ! Temporar storage for updated PQSAT
REAL(KIND=JPRB) :: ZQSATS(KLON,KLEV) ! QSAT of resolved cond./evap. scheme
REAL(KIND=JPRB) :: ZQW(KLON,KLEV)    ! Temporar storage for updated PQW
REAL(KIND=JPRB) :: ZRH(KLON,KLEV)    ! Temporar storage for updated PRH
REAL(KIND=JPRB) :: ZTW(KLON,KLEV)    ! Temporar storage for updated PTW)
REAL(KIND=JPRB) :: ZDQ(KLON,KLEV)    ! Saturation departure for a given thermodynamic state
REAL(KIND=JPRB) :: ZDQM(KLON,KLEV)   ! maximum saturation departure 
REAL(KIND=JPRB) :: ZPOID(KLON,KLEV)  ! DP/(RG*DT) FOR A GIVEN LEVEL AND A GIVEN TIME STEP.
REAL(KIND=JPRB) :: ZIPOI(KLON,KLEV)  ! INVERSE OF ZPOID.

REAL(KIND=JPRB) :: ZQU(KLON,KLEV) ! Updraught Specific moisture
REAL(KIND=JPRB) :: ZTU(KLON,KLEV) ! Updraught Temperature
REAL(KIND=JPRB) :: ZUU(KLON,KLEV) ! Updraught zonal wind
REAL(KIND=JPRB) :: ZVU(KLON,KLEV) ! Updraught merid. wind

REAL(KIND=JPRB) :: ZT(KLON,KLEV)     ! updated temperature T for cascading parameterization
REAL(KIND=JPRB) :: ZTCORR(KLON,KLEV) ! temperature corr. for convective cloud
REAL(KIND=JPRB) :: ZMELNET(KLON,KLEV) ! net melting (-freezing) rate
REAL(KIND=JPRB) :: ZU(KLON,KLEV)     ! updated zonal velocity
REAL(KIND=JPRB) :: ZV(KLON,KLEV)     ! updated meridional velocity

REAL(KIND=JPRB) :: ZQV(KLON,KLEV)    ! corrected (for negative values) vapour
                                     ! updated value for cascading parameterization
REAL(KIND=JPRB) :: ZQI(KLON,KLEV)    ! corrected (for negative values) cloud ice
                                     ! updated value for cascading parameterization
REAL(KIND=JPRB) :: ZQL(KLON,KLEV)    ! corrected (for negative values) cloud liquid
                                     ! updated value for cascading parameterization
REAL(KIND=JPRB) :: ZQR(KLON,KLEV)    ! corrected (for negative values) rain
                                     ! updated value for cascading parameterization
REAL(KIND=JPRB) :: ZQS(KLON,KLEV)    ! corrected (for negative values) snow
                                     ! updated value for cascading parameterization
REAL(KIND=JPRB) :: ZFCQVNG(KLON,0:KLEV) ! correction flux increment for neg vapour
REAL(KIND=JPRB) :: ZFCQING(KLON,0:KLEV) ! correction flux increment for neg ice
REAL(KIND=JPRB) :: ZFCQLNG(KLON,0:KLEV) ! correction flux increment for neg liquid water
REAL(KIND=JPRB) :: ZFCQRNG(KLON,0:KLEV) ! correction flux increment for neg rain
REAL(KIND=JPRB) :: ZFCQSNG(KLON,0:KLEV) ! correction flux increment for neg snow
REAL(KIND=JPRB) :: ZFCQL(KLON,0:KLEV)   ! condensation flux(liquid)
REAL(KIND=JPRB) :: ZFCQLDM(KLON,0:KLEV) ! diff micro condensation flux(liquid)
REAL(KIND=JPRB) :: ZFCQI(KLON,0:KLEV)   ! condensation flux(ice)
REAL(KIND=JPRB) :: ZFCQIDM(KLON,0:KLEV) ! diff micro condensation flux(ice)
REAL(KIND=JPRB) :: ZDIFCQD(KLON,0:KLEV) ! downdraft flux of specific humidity
REAL(KIND=JPRB) :: ZDIFCQLD(KLON,0:KLEV) ! downdraft flux of liquid water
REAL(KIND=JPRB) :: ZDIFCQID(KLON,0:KLEV) ! downdraft flux of  solid water
REAL(KIND=JPRB) :: ZDIFCSD(KLON,0:KLEV) ! downdraft entalphy flux
REAL(KIND=JPRB) :: ZSTRCUD(KLON,0:KLEV) ! change in horizontal mom.
REAL(KIND=JPRB) :: ZSTRCVD(KLON,0:KLEV) ! change in horizontal mom.
REAL(KIND=JPRB) :: ZRCVOTT(KLON,0:KLEV) ! degree of inhomogeneity in precips.
REAL(KIND=JPRB) :: ZSIGPC(KLON)         ! Convective precipit mesh fraction
REAL(KIND=JPRB) :: ZSIGP(KLON)         ! Precipitation mesh fraction
REAL(KIND=JPRB) :: ZAUXPRC(KLON)        ! Precipitation auxilary
REAL(KIND=JPRB) :: ZDIFCVPPQ(KLON,0:KLEV) ! Flux de CVPP (KFB) sur Qv
REAL(KIND=JPRB) :: ZDIFCVPPS(KLON,0:KLEV) ! Flux de CVPP (KFB) sur CpT
REAL(KIND=JPRB) :: ZCONDCVPPL(KLON,0:KLEV) ! Flux de condensation liquide du a CVVPP (KFB) 
REAL(KIND=JPRB) :: ZCONDCVPPI(KLON,0:KLEV) ! Flux de condensation glace du a CVVPP (KFB)
REAL(KIND=JPRB) :: ZPRODTH_CVPP(KLON,0:KLEV) ! Flux de production thermique de TKE du a CVPP(KFB)

REAL(KIND=JPRB) :: ZDQV, ZDQI, ZDQL, ZDQR, ZDQS, ZDQC, ZGDT, ZGDTI, &
                 & ZQV0, ZQX0, ZQX1, ZDFCQL, ZDFCQI, &
                 & ZDQIT, ZDQLT, ZCONVC, ZTOTC
!-----------------------------------------------------------------

! - 2D (0:KLEV) .

! ZKTROV     : COEFFICIENT D'ECHANGE VERTICAL DE T ET Q EN KG/(M*M*S).
! ZKUROV     : COEFFICIENT D'ECHANGE VERTICAL DE U ET V EN KG/(M*M*S).
! ZKNROV     : COEFFICIENT D'ECHANGE VERTICAL NEUTRE EN KG/(M*M*S).
! ZNBVNO     : FREQUENCE DE BRUNT-VAISALA DIVISEE PAR G FOIS LA DENSITE.

! ZNEBS      : NEBULOSITE STRATIFORME (SCHEMA STATISTIQUE DE NUAGES).
!            : STRATIFORM CLOUDINESS (STATISTICAL CLOUD SCHEME)
! ZQLIS      : QUANTITE D'EAU LIQUIDE STRATIFORME (SCHEMA STATISTIQUE).
!            : STRATIFORM LIQUID WATER (STATISTICAL CLOUD SCHEME)

! ZCFRSO     : FLUX SOLAIRE RADIATIF EN CIEL CLAIR.
! ZCFRTH     : FLUX THERMIQUE RADIATIF EN CIEL CLAIR.

! - 2D (1:KLEV) .

! INLAB      : INDICE D'INSTABILITE CONVECTIVE.

INTEGER(KIND=JPIM) :: INND(KLON)
REAL(KIND=JPRB) :: ZXDROV(KLON),ZXHROV(KLON)
REAL(KIND=JPRB) :: ZUGST(KLON),ZVGST(KLON)
REAL(KIND=JPRB) :: ZCDROV(KLON),ZCHROV(KLON),ZDQSTS(KLON),ZGWDCS(KLON),&
 & ZHQ(KLON),ZHU(KLON),ZHTR(KLON),&
 & ZRTI(KLON),ZSTAB(KLON),ZTAUX(KLON)  
REAL(KIND=JPRB) :: ZWFC(KLON),ZWPMX(KLON),ZWLMX(KLON),ZWSEQ(KLON),&
 & ZWSMX(KLON),ZWWILT(KLON),&
 & ZC3(KLON),ZCG(KLON),ZCN(KLON),&
 & ZNEIJG(KLON),ZNEIJV(KLON)  
REAL(KIND=JPRB) :: ZPCLS(KLON)
REAL(KIND=JPRB) :: ZPREN(KLON)
REAL(KIND=JPRB) :: ZFRSOFS(KLON)

! - 1D (DIAGNOSTIQUE) .

! ZCDROV     : PCD RENORME EN DENSITE FOIS VITESSE.
! ZCG        : COEFFICIENT THERMIQUE DU SOL NU.
! ZCG        : THERMICAL COEFFICIENT OF BARE GROUND.
! ZCN        : COEFFICIENT THERMIQUE DE LA NEIGE.
! ZCN        : THERMICAL COEFFICIENT OF SNOW.
! ZCHROV     : PCH RENORME EN DENSITE FOIS VITESSE.
! ZC3        : COEFFICIENT UTILE POUR LE CALCUL DU DRAINAGE
! ZDQSTS     : DERIVEE DE PQSATS PAR RAPPORT A LA TEMPERATURE.
! ZGWDCS     : VARIABLE DE SURFACE POUR LE DRAG OROGRAPHIQUE (RHO*N0/G).
! ZHQ        : POIDS DE L'HUMIDITE DE L'AIR DANS L'HUMIDITE DE SURFACE.
! ZHTR       : RESISTANCE A LA TRANSPIRATION DU COUVERT VEGETAL.
! ZHTR       : FOLIAGE TRANSPIRATION RESISTANCE.
! ZHU        : POIDS DE L'HUMIDITE SATURANTE DANS L'HUMIDITE DE SURFACE.
! ZNEIJG     : FRACTION DE NEIGE RECOUVRANT LE SOL.
! ZNEIJV     : FRACTION DE NEIGE RECOUVRANT LA VEGETATION.
! ZRTI       : INVERSE DE R*T.
! ZSTAB      : INDICE DE STABILITE A LA SURFACE.
! INND       : INDICE DE PRECIPITATIONS CONVECTIVES.
! ZSFRTP     : FLUX RADIATIFS SPECTRAUX AU SOMMET.
! ZSFRBM     : FLUX RADIATIFS SPECTRAUX A LA SURFACE.
! ZWFC       : TENEUR EN EAU A LA CAPACITE AUX CHAMPS.
! ZWFC       : FIELD CAPACITY WATER CONTENT.
! ZWPMX      : TENEUR EN EAU MAXIMALE DU RESERVOIR PROFOND.
! ZWPMX      : MAXIMUM WATER CONTENT OF THE DEEP WATER-TANK.
! ZWLMX      : TENEUR EN EAU MAXIMALE DU RESERVOIR D'INTERCEPTION.
! ZWLMX      : MAXIMUM WATER CONTENT OF THE INTERCEPTION WATER-TANK.
! ZWSEQ      : TENEUR EN EAU A L'EQUILIBRE (EQUILIBRE ENTRE GRAVITE ET
!              CAPILLARITE) EN SURFACE.
! ZWSEQ      : SURFACE WATER CONTENT FOR THE BALANCE BETWEEN GRAVITY
!              AND CAPILLARITY
! ZWSMX      : TENEUR EN EAU MAXIMALE DU RESERVOIR SUPERFICIEL.
! ZWSMX      : MAXIMUM WATER CONTENT FOR THE SUPERFICIAL WATER-TANK.
! ZWWILT     : TENEUR EN EAU AU POINT DE FLETRISSEMENT.
! ZWWILT     : WATER CONTENT AT THE WILTING POINT.
REAL(KIND=JPRB) :: ZDAER(KLEV), ZHUC(KLEV), ZBLH(KLON)
REAL(KIND=JPRB) :: ZQO3(KLON,0:KLEV)
REAL(KIND=JPRB) :: ZAER(KLON,KLEV,6)
REAL(KIND=JPRB) :: ZQCO2(KLON,KLEV)
REAL(KIND=JPRB) :: ZROZ(KLON,KLEV)
REAL(KIND=JPRB) :: ZDPHIV(KLON),ZDPHIT(KLON)

REAL(KIND=JPRB) :: ZMAN(0:KLEV), ZMAK(0:KLEV)
! ZPUCLN/ZPVCLN : COMPOSANTES X/Y VENT NEUTRE
REAL(KIND=JPRB) :: ZPUCLN(KLON),ZPVCLN(KLON)

! - (PROFILS DIAGNOSTIQUES)
! ZDAER     : EPAISSEUR OPTIQUE DES AEROSOLS STANDARDS DANS LA COUCHE
! ZDAER     : OPTICAL DEPTH OF STANDARD AEROSOLS IN THE LAYER.
! ZHUC      : HUMIDITE CRITIQUE PAR NIVEAU POUR LE CALCUL DE PNEB
! ZHUC      : CRITICAL MOISTURE FOR EACH LEVEL FOR PNEB CALCULATION.
!   ZQO3    : RAPPORT DE MELANGE MASSIQUE D'OZONE
!        (0):     "         "    MOYEN AU-DESSUS DU MODELE
!   ZQO3    : OZONE MIXING RATIO (MASS).
!        (0):AVERAGED-ABOVE      "         " .
!   ZQCO2   : RAPPORT MASSIQUE LOCAL DU CO2.
!   ZQCO2   : CO2 MIXING RATIO (MASS).

! IJN        : DIMENSION TABLEAUX ETENDUS POUR CYCLE DIURNE RAYONNEMENT
!              IJN AU PLUSL A KLON

!* INPUT ARGUMENTS FOR ACRADIN ( RAYT ECMWF POUR CLIMAT )

!            1-D ARRAYS
!            ----------

REAL(KIND=JPRB) :: ZTRSOD(KLON)

!            2-D ARRAYS
!            ----------

!* OUTPUT ARGUMENTS FOR THE ECMWF PHYSICS

!            0.2  LOCAL ARRAYS FOR ECMWF PHYSICS PACKAGE
!                 --------------------------------------

REAL(KIND=JPRB) :: ZCEMTR(KLON,0:1) , ZCTRSO(KLON,0:1)
REAL(KIND=JPRB) :: ZALBD(KLON,NSW), ZALBP(KLON,NSW)
REAL(KIND=JPRB) :: ZSFSWDIR (KLON,NSW), ZSFSWDIF (KLON,NSW)
REAL(KIND=JPRB) :: ZFSDNN(KLON),ZFSDNV(KLON)

!            1-D ARRAYS
!            ----------

REAL(KIND=JPRB) :: ZSUDU(KLON) , ZDSRP(KLON) , ZSDUR(KLON)
REAL(KIND=JPRB) :: ZTHETAVS(KLON)
REAL(KIND=JPRB) :: ZAESEA(KLON), ZAELAN(KLON), ZAESOO(KLON), ZAEDES(KLON)
REAL(KIND=JPRB) :: ZAESUL(KLON), ZAEVOL(KLON)
REAL(KIND=JPRB) :: ZMERL(KLON)

!            2-D ARRAYS
!            ----------

REAL(KIND=JPRB) :: ZTENT(KLON,KLEV), ZGEOSLC(KLON,KLEV)
REAL(KIND=JPRB) :: ZTHETAV(KLON,KLEV)

!            LOCAL ARRAYS FOR TKE
! ZCOEFN : COEFFICIENT STATISTIQUE POUR LES FLUX D'EAUX CONDENSEES.

REAL(KIND=JPRB) :: ZCOEFN(KLON,KLEV)

!            LOCAL ARRAYS FOR ACVPPKF
REAL(KIND=JPRB) :: ZQC_CVPP(KLON,KLEV)
REAL(KIND=JPRB) :: ZNEB_CVPP(KLON,KLEV)

!           2-D ARRAY FOR SIMPL.RADIATION SCHEME

REAL(KIND=JPRB) :: ZZNEB(KLON,KLEV)

INTEGER(KIND=JPIM) :: IFLUX, IJN, IMODE, IRAD, IMLTYPE, &
 & JCHA, JLEV, JLON, JSG

LOGICAL :: LLCLS, LLHMT, LLZERO

REAL(KIND=JPRB) :: ZAEN, ZAEO, ZALBV, ZCARDI, ZEPS, ZEPS0, ZEPSO3
REAL(KIND=JPRB) :: ZVNEIJ, ZCOEF, ZCFN, ZCK
REAL(KIND=JPRB) :: ZALBPMER


!            2-D ARRAYS

! ZNEBC      : NEBULOSITE  CONVECTIVE A L'ECHELLE DE LA MAILLE.
! ZQLIC      : EAU LIQUIDE CONVECTIVE A L'ECHELLE DE LA MAILLE.
! ZQCL       : CONDENSAT STRATIFORME LIQUIDE
! ZQCI       : CONDENSAT STRATIFORME SOLIDE
! ZFHEVPPC   : FLUX DE CHALEUR DU A L'EVAPORATION DES PREC. CONVECTIVES.
! ZFHMLTSC   : FLUX DE CHALEUR DU A LA FONTE/GEL DES PREC. CONVECTIVES.
! ZFPEVPPC   : EVAPORATION DES PREC. CONVECTIVES.
! ICIS       : INDICE DE NIVEAU D'INSTABILITE SECHE.

REAL(KIND=JPRB) :: ZNEBC(KLON,KLEV),ZQLIC(KLON,KLEV)
REAL(KIND=JPRB) :: ZQCL(KLON,KLEV),ZQCI(KLON,KLEV)
REAL(KIND=JPRB) :: ZFHEVPPC(KLON,0:KLEV),ZFHMLTSC(KLON,0:KLEV)&
 & ,ZFPEVPPC(KLON,0:KLEV)
INTEGER(KIND=JPIM) :: ICIS(KLON,KLEV)


!           SURFEX local VARIABLES
!           ----------------------------

! Implicit coupling coefficients
INTEGER(KIND=JPIM) :: IRR
LOGICAL :: LLD_NBLOCKTOT
REAL(KIND=JPRB) :: ZCFAQ(KLON,KLEV),ZCFAS(KLON,KLEV),&
 & ZCFATH(KLON,KLEV),ZCFAU(KLON,KLEV),ZCFBQ(KLON,KLEV),&
 & ZCFBS(KLON,KLEV),ZCFBTH(KLON,KLEV),&
 & ZCFBU(KLON,KLEV),ZCFBV(KLON,KLEV)

REAL(KIND=JPRB) :: ZDSE(KLON,KLEV)
REAL(KIND=JPRB) :: ZFEV(KLON),ZFMDU(KLON),ZFMDV(KLON)
REAL(KIND=JPRB) :: ZSRAIN(KLON), ZSSNOW(KLON), ZSGROUPEL(KLON)
REAL(KIND=JPRB) :: ZSFCO2(KLON), ZRHODREFM(KLON)
REAL(KIND=JPRB) :: ZDEPTH_HEIGHT_LOW(KLON), ZZS(KLON)
REAL(KIND=JPRB) :: ZTSN(KLON)
REAL(KIND=JPRB), DIMENSION (:,:), ALLOCATABLE  :: ZSVM
REAL(KIND=JPRB), DIMENSION (:,:), ALLOCATABLE  :: ZSFSV

!            3-D ARRAYS
REAL(KIND=JPRB), DIMENSION(KLON,KLEV,NSW):: ZPIZA_DST !Single scattering
                                             ! albedo of dust (points,lev,wvl)
REAL(KIND=JPRB), DIMENSION(KLON,KLEV,NSW):: ZCGA_DST  !Assymetry factor
                                             ! for dust (points,lev,wvl)
REAL(KIND=JPRB), DIMENSION(KLON,KLEV,NSW):: ZTAUREL_DST !tau/tau_{550}
                                             !dust (points,lev,wvl)

!         ACFLUSO (ECUME) local variable
!-------------------------------------------
REAL(KIND=JPRB) :: ZCE(KLON), ZCEROV(KLON), ZCRTI(KLON)


!        New ACDIFV1 local variable
!--------------------------------------------
REAL(KIND=JPRB)   :: ZXURO(KLON,0:KLEV)
REAL(KIND=JPRB)   :: ZXQRO(KLON,0:KLEV)
REAL(KIND=JPRB)   :: ZXTRO(KLON,0:KLEV)


!        New ARP_GROUND_PARAM local variable
!------------------------------------------------

REAL(KIND=JPRB)   :: ZALPHA1(KLON,0:KLEV)
REAL(KIND=JPRB)   :: ZCOEFA (KLON,0:KLEV)
REAL(KIND=JPRB)   :: ZLVT   (KLON,0:KLEV)
REAL(KIND=JPRB)   :: ZQICE  (KLON,0:KLEV)
REAL(KIND=JPRB)   :: ZDIFWQ (KLON) 
REAL(KIND=JPRB)   :: ZDIFWS (KLON) 

!           TRAJECTORY (For diffusion !) local VARIABLES
!           ----------------------------
INTEGER(KIND=JPIM) :: IFIELDS,IPCT
REAL(KIND=JPRB) :: ZDUM1(KLON,0:KLEV),ZDUM2(KLON,KLEV),ZDUM3(KLON)


LOGICAL            :: LLAERO
CHARACTER(LEN=200) :: CLERR
REAL(KIND=JPRB) :: ZHOOK_HANDLE

!     ------------------------------------------------------------------

#include "abor1.intfb.h"
#include "acclph.intfb.h"
#include "accoefk.intfb.h"
#include "accvimp.intfb.h"
#include "accvimp_v3.intfb.h"
#include "accvimpgy.intfb.h"
#include "acdifoz.intfb.h"
#include "acdifus.intfb.h"
#include "acdnshf.intfb.h"
#include "acdrac.intfb.h"
#include "acdrag.intfb.h"
#include "acdrme.intfb.h"
#include "acdrov.intfb.h"
#include "acfluso.intfb.h"
#include "achmt.intfb.h"
#include "acmixlenz.intfb.h"
#include "acmixlentm.intfb.h"
#include "acmixelen.intfb.h"
#include "acnebc.intfb.h"
#include "acnebn.intfb.h"
#include "acnebr.intfb.h"
#include "acnebsm.intfb.h"
#include "acozone.intfb.h"
#include "acpblh.intfb.h"
#include "acpblhtm.intfb.h"
#include "acpluie.intfb.h"
#include "acpluis.intfb.h"
#include "acpluiz.intfb.h"
#include "acradcoef.intfb.h"
#include "acradin.intfb.h"
#include "acralu.intfb.h"
#include "acraneb.intfb.h"
#include "acsol.intfb.h"
#include "actqsat.intfb.h"
#include "actqsats.intfb.h"
#include "acupu.intfb.h"
#include "acupm.intfb.h"
#include "acupd.intfb.h"
#include "acveg.intfb.h"
#include "aplmphys.intfb.h"
#include "qngcor.intfb.h"
#include "radaer.intfb.h"
#include "radaer15.intfb.h"
#include "radheat.intfb.h"
#include "radheat15.intfb.h"
#include "radozcmf.intfb.h"
#include "suozon.intfb.h"
#include "actke.intfb.h"
#include "acdifv1.intfb.h"
#include "acdifv2.intfb.h"
#include "achmtls.intfb.h"
#include "aro_ground_param.h"
#include "aro_ground_diag.h"
#include "accvud.intfb.h"
#include "acmodo.intfb.h"
#include "acnebcond.intfb.h"
#include "accdev.intfb.h"
#include "acnpart.intfb.h"
#include "acvppkf.intfb.h"
#include "acptke.intfb.h"
#include "arp_ground_param.intfb.h"
#include "wrphtrajtm.intfb.h"

!     ------------------------------------------------------------------

#include "fcttrm.h"

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('APLPAR',0,ZHOOK_HANDLE)

!     ------------------------------------------------------------------

!     CHECK RELIABILITY OF INPUT ARGUMENTS.
IF(CDLOCK /= 'APLPAR') CALL ABOR1('APLPAR : BAD NUMBER OF ARGUMENTS!')

! SURFEX  and passive scalar
ALLOCATE(ZSVM  (KLON,NGFL_EXT))
ALLOCATE(ZSFSV (KLON,NGFL_EXT))

!     ------------------------------------------------------------------
!     1.- INITIALISATIONS COMPLEMENTAIRES
!     -----------------------------------
IJN = KLON

!     CALCUL FIN DE IJN
!      IJN = 1
!      ZMU0 = MAX(0.,-SIGN(1.,-PMU0(KIDIA)))
!      DO 1  JLON = KIDIA+1, KFDIA
!      ZMUN = MAX(0.,-SIGN(1.,-PMU0(JLON)))
!      IJN = IJN + IABS(NINT(ZMUN)-NINT(ZMU0))
!      ZMU0 = ZMUN
!   1  CONTINUE

!*        1.1 INITIALISATION DE L'OZONE

IF (LMPHYS) THEN
  IF (LOZONE) THEN

    ! L'ozone est initialise par PO3 (ozone GFL).
    ! Ozone is computed from PO3 (GFL ozone).

    ZEPSO3=1.E-11_JPRB
    DO JLON=KIDIA,KFDIA
      ZQO3(JLON,0)=1.E-9_JPRB
    ENDDO
    DO JLEV=KTDIA,KLEV
      DO JLON=KIDIA,KFDIA
        ZQO3(JLON,JLEV) = MAX(ZEPSO3,PO3(JLON,JLEV))
      ENDDO
    ENDDO

  ELSEIF(KVCLIS == 1) THEN
    ZEPSO3=1.E-11_JPRB
    DO JLON=KIDIA,KFDIA
      ZQO3(JLON,0)=1.E-9_JPRB
    ENDDO
    DO JLEV=KTDIA,KLEV
      DO JLON=KIDIA,KFDIA
        ZQO3(JLON,JLEV) = PKOZO(JLON,JLEV,1)
      ENDDO
    ENDDO

  ELSEIF ((LO3FL).AND.(NOZOCL == 1).AND.(LRAYFM)) THEN
    IF (MOD(KSTEP,NRADFR) == 0) THEN
      CALL RADOZCMF(KIDIA,KFDIA,KLON,KLEV,PAPRS,PGEMU,ZROZ)
      DO JLON=KIDIA,KFDIA
        ZQO3(JLON,0)=1.E-9_JPRB
      ENDDO
      DO JLEV=KTDIA,KLEV
        DO JLON=KIDIA,KFDIA
          ZQO3(JLON,JLEV)=ZROZ(JLON,JLEV)*PRDELP(JLON,JLEV)
        ENDDO
      ENDDO
    ENDIF

  ELSE
    CALL SUOZON(KIDIA,KFDIA,KLON,KLEV,ZQO3,.FALSE.,PAPRS,PRDELP,LO3ABC,PVO3ABC)
  ENDIF

!     GAZ CARBONIQUE.

  DO JLEV=KTDIA,KLEV
    DO JLON=KIDIA,KFDIA
      ZQCO2(JLON,JLEV)=QCO2
    ENDDO
  ENDDO


  ! INITIALISATION DE LA COORDONNEE ETA.
  ! INITIALISATION DE LA COORDONNEE ETA.

  ZVETAH(KTDIA-1)=STPREH(KTDIA-1)/VP00
  DO JLEV=KTDIA,KLEV
    ZVETAH(JLEV)=STPREH(JLEV)/VP00
    ZVETAF(JLEV)=STPRE (JLEV)/VP00
  ENDDO

!     EPAISSEUR STD AEROSOLS
  ZAEO = AERCS1*ZVETAH(KTDIA-1) + AERCS3*ZVETAH(KTDIA-1)**3 &
   & + AERCS5*ZVETAH(KTDIA-1)**5  
  DO JLEV = KTDIA, KLEV
    ZAEN = AERCS1*ZVETAH(JLEV) + AERCS3*ZVETAH(JLEV)**3 &
     & + AERCS5*ZVETAH(JLEV)**5  
    ZDAER(JLEV) = ZAEN - ZAEO
    ZAEO = ZAEN
  ENDDO

!     HUMIDITE CRITIQUE
  ZEPS=1.E-12_JPRB
  IF(LHUCN) THEN
    DO JLEV = KTDIA, KLEV
      ZHUC(JLEV)=1.0_JPRB-MAX( HUCOE*ZVETAF(JLEV)*(1.0_JPRB-ZVETAF(JLEV))/&
       &((1.0_JPRB+HUTIL1*(ZVETAF(JLEV)-0.5_JPRB))*&
       &(1.0_JPRB+HUTIL2*(ZVETAF(JLEV)-0.5_JPRB))),ZEPS)
    ENDDO
  ELSE
    DO JLEV = KTDIA, KLEV
      ZHUC(JLEV)=1.0_JPRB-MAX( HUCOE*ZVETAF(JLEV)**NPCLO1*&
       & (1.0_JPRB-ZVETAF(JLEV))**NPCLO2*&
       & (1.0_JPRB+SQRT(HUTIL)*(ZVETAF(JLEV)-0.5_JPRB)),ZEPS)  
    ENDDO
  ENDIF

  IF ( LNEWSTAT ) THEN

    DO JLEV = KTDIA, KLEV-1
      ZMAN(JLEV) = FSM_CC * TANH(FSM_DD*ZVETAH(JLEV))
      ZMAK(JLEV) = FSM_EE * ZVETAH(JLEV)**FSM_FF + &
       & FSM_GG * (1-ZVETAH(JLEV))**FSM_HH + FSM_II
    ENDDO

!     MATHEMATICAL FILTER FOR THE EDGES

    IF ( LRPROX ) THEN
      DO JLEV = KTDIA, KTDIA+3
        ZMAK(JLEV) = ZMAK(JLEV) / 2**(KTDIA+4-JLEV)
      ENDDO
      DO JLEV = KLEV-4, KLEV-1
        ZMAK(JLEV) = ZMAK(JLEV) / 2**(5-KLEV+JLEV)
      ENDDO
    ENDIF
 
  ELSE
    DO JLEV = KTDIA, KLEV-1
      ZMAN(JLEV) = 0.3_JPRB*ZVETAH(JLEV)
      ZMAK(JLEV) = 0.1_JPRB
    ENDDO
  ENDIF   !LNEWSTAT

!3MT  
!     INCREMENTAL CORRECTION FLUX FOR NEGAVTIVE HUMIDITY VALUES

  ZFCQVNG(:,:)=0.0_JPRB
  ZFCQING(:,:)=0.0_JPRB
  ZFCQLNG(:,:)=0.0_JPRB
  ZFCQRNG(:,:)=0.0_JPRB
  ZFCQSNG(:,:)=0.0_JPRB
  
  ZPRODTH_CVPP(:,:)=0.0_JPRB

  ZGDT=RG*TSPHY
  ZGDTI=1.0_JPRB/ZGDT

  DO JLEV=KTDIA,KLEV
    DO JLON=KIDIA,KFDIA

!     LAYER WEIGHTS

      ZPOID(JLON,JLEV)=PDELP(JLON,JLEV)*ZGDTI
      ZIPOI(JLON,JLEV)=PRDELP(JLON,JLEV)*ZGDT
      
!     CALCULATION OF LATENT HEATS

      ZLHV(JLON,JLEV)=FOLH(PT(JLON,JLEV),0.0_JPRB)
      ZLHS(JLON,JLEV)=FOLH(PT(JLON,JLEV),1.0_JPRB)

    ENDDO
  ENDDO

ENDIF  !LMPHYS
!**
!     ------------------------------------------------------------------
!     2.- MISES A ZERO DE SECURITE EN CAS DE NON-APPEL DES PARAMETRIS.
!     ------------------------------------------------------------------
ZEPS0=1.E-12_JPRB

DO JLEV = 0, KLEV
  DO JLON = KIDIA,KFDIA
    ZERO    (JLON,JLEV) = 0.0_JPRB
    ZFPCOR  (JLON,JLEV) = 0.0_JPRB
    ZFHP    (JLON,JLEV) = 0.0_JPRB
    ZXTROV  (JLON,JLEV) = 1.0_JPRB
    ZXUROV  (JLON,JLEV) = 1.0_JPRB
    ZLMT    (JLON,JLEV) = 0.0_JPRB
    ZZLMT   (JLON,JLEV) = 0.0_JPRB
    ZLMU    (JLON,JLEV) = 0.0_JPRB
    ZKTROV  (JLON,JLEV) = 0.0_JPRB
    ZKUROV  (JLON,JLEV) = 0.0_JPRB
    ZFHEVPPC(JLON,JLEV) = 0.0_JPRB
    ZFHMLTSC(JLON,JLEV) = 0.0_JPRB
    ZFPEVPPC(JLON,JLEV) = 0.0_JPRB
    ZFCQL   (JLON,JLEV) = 0.0_JPRB
    ZFCQLDM (JLON,JLEV) = 0.0_JPRB
    ZFCQI   (JLON,JLEV) = 0.0_JPRB
    ZFCQIDM (JLON,JLEV) = 0.0_JPRB
    ZDIFCVPPQ (JLON,JLEV) = 0.0_JPRB
    ZDIFCVPPS (JLON,JLEV) = 0.0_JPRB
    ZCONDCVPPL(JLON,JLEV) = 0.0_JPRB
    ZCONDCVPPI(JLON,JLEV) = 0.0_JPRB

    ZXURO   (JLON,JLEV) = 0.0_JPRB
    ZXQRO   (JLON,JLEV) = 0.0_JPRB
    ZXTRO   (JLON,JLEV) = 0.0_JPRB

    ZALPHA1 (JLON,JLEV) = 0.0_JPRB
    ZCOEFA  (JLON,JLEV) = 0.0_JPRB
    ZLVT    (JLON,JLEV) = 0.0_JPRB
    ZQICE   (JLON,JLEV) = 0.0_JPRB

  ENDDO
ENDDO

ZDIFWQ  (KIDIA:KFDIA) = 0.0_JPRB 
ZDIFWS  (KIDIA:KFDIA) = 0.0_JPRB     

DO JLEV = 1, KLEV
  DO JLON = KIDIA,KFDIA
    ZTENT   (JLON,JLEV) = 0.0_JPRB
    ZNEBS   (JLON,JLEV) = ZEPS0
    ZNEBC   (JLON,JLEV) = ZEPS0
    ZNEBS0  (JLON,JLEV) = ZEPS0
    ZNEBC0  (JLON,JLEV) = 0.0_JPRB
    ZNEBCH  (JLON,JLEV) = 0.0_JPRB
    ZUNEBH  (JLON,JLEV) = 0.0_JPRB
    ZDETFI (JLON,JLEV) = 0.0_JPRB
    ZNEBDIFF(JLON,JLEV) = 0.0_JPRB
    ZQLIS   (JLON,JLEV) = 0.0_JPRB
    ZQLIS0  (JLON,JLEV) = 0.0_JPRB
    ZCFATH  (JLON,JLEV) = 0.0_JPRB
    ZCFAU   (JLON,JLEV) = 0.0_JPRB
    ZCFBTH  (JLON,JLEV) = 0.0_JPRB
    ZCFBU   (JLON,JLEV) = 0.0_JPRB
    ZCFBV   (JLON,JLEV) = 0.0_JPRB
    ZQLIC   (JLON,JLEV) = 0.0_JPRB
    INLAB   (JLON,JLEV) = 0
    INLAB_CVPP(JLON,JLEV) = 0
    ICIS    (JLON,JLEV) = 1
    ZQC_CVPP(JLON,JLEV) = 0.0_JPRB
    ZNEB_CVPP(JLON,JLEV) = ZEPS0
  ENDDO
ENDDO

!  ---------------------------------------------------------------------
!  Correction of negative advected humidity and precipitation values
!  ---------------------------------------------------------------------


IF (LCONDWT) THEN
  IF (L3MT .OR. LSTRAPRO .OR. LPROCLD) THEN
!cdir unroll=8
    DO JLEV = 1, KLEV
      DO JLON = KIDIA,KFDIA
        ZQI(JLON,JLEV)=MAX(0.0_JPRB,PQI(JLON,JLEV))
        ZQL(JLON,JLEV)=MAX(0.0_JPRB,PQL(JLON,JLEV))
        ZQR(JLON,JLEV)=MAX(0.0_JPRB,PRR(JLON,JLEV))
        ZQS(JLON,JLEV)=MAX(0.0_JPRB,PS(JLON,JLEV))

  ! CORRECTION OF NEGATIVE ADVECTED VALUES:
  !                         VAPOUR PUT IN PFCQVNG
  !                         LIQUID,ICE PUT IN PFCQL/ING
  !                         FOR RAIN/SNOW PUT IN PFCQR/SNG

        ZDQI=ZQI(JLON,JLEV)-PQI(JLON,JLEV)
        ZDQL=ZQL(JLON,JLEV)-PQL(JLON,JLEV)
        ZDQR=ZQR(JLON,JLEV)-PRR(JLON,JLEV)
        ZDQS=ZQS(JLON,JLEV)-PS(JLON,JLEV)
        ZDQC=ZDQI+ZDQL+ZDQR+ZDQS 

        ZQV0=PQ(JLON,JLEV)-ZIPOI(JLON,JLEV)*(0.0_JPRB- PFCQVNG(JLON,JLEV-1) &
        & -PFCQING(JLON,JLEV-1)-PFCQLNG(JLON,JLEV-1)-PFCQRNG(JLON,JLEV-1) &
        & -PFCQSNG(JLON,JLEV-1))
        ZQV(JLON,JLEV)=MAX(0.0_JPRB,ZQV0-ZDQC)
        ZDQV=MAX(0.0_JPRB,ZQV0-ZDQC)-PQ(JLON,JLEV)

        PFCQVNG(JLON,JLEV)=PFCQVNG(JLON,JLEV-1)-ZDQV*ZPOID(JLON,JLEV)
        PFCQING(JLON,JLEV)=PFCQING(JLON,JLEV-1)-ZDQI*ZPOID(JLON,JLEV)
        PFCQLNG(JLON,JLEV)=PFCQLNG(JLON,JLEV-1)-ZDQL*ZPOID(JLON,JLEV)
        PFCQRNG(JLON,JLEV)=PFCQRNG(JLON,JLEV-1)-ZDQR*ZPOID(JLON,JLEV)
        PFCQSNG(JLON,JLEV)=PFCQSNG(JLON,JLEV-1)-ZDQS*ZPOID(JLON,JLEV)
      ENDDO
    ENDDO
  ELSE
    DO JLEV = 1, KLEV
      DO JLON = KIDIA,KFDIA
        ZQI(JLON,JLEV)=PQI(JLON,JLEV)
        ZQL(JLON,JLEV)=PQL(JLON,JLEV)
        ZQR(JLON,JLEV)=PRR(JLON,JLEV)
        ZQS(JLON,JLEV)=PS(JLON,JLEV)
        ZQV(JLON,JLEV)=PQ(JLON,JLEV)
      ENDDO
    ENDDO
  ENDIF
ELSE
  DO JLEV = 1, KLEV
    DO JLON = KIDIA,KFDIA
      ZQI(JLON,JLEV)=0.0_JPRB
      ZQL(JLON,JLEV)=0.0_JPRB
      ZQV(JLON,JLEV)=PQ(JLON,JLEV)
    ENDDO
  ENDDO
ENDIF ! LCONDWT  

DO JCHA = 1, 6
  DO JLEV = KTDIA, KLEV
    DO JLON = 1, KLON
      ZAER(JLON,JLEV,JCHA)=0.0_JPRB
    ENDDO
  ENDDO
ENDDO

DO JLON = KIDIA,KFDIA
  ZCEMTR  (JLON,0) = 0.0_JPRB
  ZCEMTR  (JLON,1) = 0.0_JPRB
  ZCTRSO  (JLON,0) = 0.0_JPRB
  ZCTRSO  (JLON,1) = 0.0_JPRB
  ZTRSOD  (JLON)   = 0.0_JPRB
  ZSUDU   (JLON)   = 0.0_JPRB
  ZFRSOFS (JLON)   = 0.0_JPRB
  ZXDROV  (JLON)   = 1.0_JPRB
  ZXHROV  (JLON)   = 1.0_JPRB
  ZTAUX   (JLON)   = ZEPS0
  KCLPH   (JLON)   = KLEV
ENDDO
DO JSG = 1, NSW
  DO JLON = KIDIA,KFDIA
    ZALBD   (JLON,JSG) = 0.0_JPRB
    ZALBP   (JLON,JSG) = 0.0_JPRB
    ZSFSWDIF(JLON,JSG) = 0.0_JPRB
    ZSFSWDIR(JLON,JSG) = 0.0_JPRB
  ENDDO
ENDDO

IF (LCVPRO) THEN
!  PUNEBH(:,:)=MIN(0.9999999999_JPRB,PUNEBH(:,:)+MAX(0._JPRB,PUDAL(:,:)))
   PUNEBH(KIDIA:KFDIA,:)=MAX(0.0_JPRB,PUNEBH(KIDIA:KFDIA,:))
ENDIF
!  -------------------------------------------------------
!  Security values for pseudo-historical arrays at KSTEP=0
!  -------------------------------------------------------

IF((LNEBR.OR.(TRIM(CGMIXLEN) == 'TM')&
        &.OR.(TRIM(CGMIXLEN) == 'TMC')).AND.KSTEP == 0) THEN
  DO JLON=KIDIA,KFDIA
    PPBLH(JLON)=(XMINLM+XMAXLM)*0.5_JPRB
  ENDDO
ENDIF
IF((LNEBCO.OR.LGWDC).AND.KSTEP == 0) THEN
  DO JLON=KIDIA,KFDIA
    PTCCH(JLON)=0.0_JPRB
    PSCCH(JLON)=0.0_JPRB
    PBCCH(JLON)=0.0_JPRB
  ENDDO
ENDIF

IF((LNEBN.OR.LNEBR.OR.LRRGUST).AND.KSTEP == 0) THEN
  DO JLEV=KTDIA-1,KLEV
    DO JLON=KIDIA,KFDIA
      PFPLCH(JLON,JLEV)=0.0_JPRB
    ENDDO
  ENDDO
  IF (LCVPRO) THEN
    PUNEBH(KIDIA:KFDIA,:)=0.0_JPRB
  ENDIF
  IF (LENTCH) THEN
    PENTCH(KIDIA:KFDIA,:)=0.0_JPRB
  ENDIF
ENDIF
IF(LRRGUST.AND.KSTEP == 0) THEN
  DO JLEV=KTDIA-1,KLEV
    DO JLON=KIDIA,KFDIA
      PFPLSH(JLON,JLEV)=0.0_JPRB
    ENDDO
  ENDDO
ENDIF
IF(LCVPGY.AND.KSTEP == 0) THEN
  DO JLEV=KTDIA,KLEV
    DO JLON=KIDIA,KFDIA
      PCVV(JLON,JLEV)=0.0_JPRB
    ENDDO
  ENDDO
ENDIF
IF(LPHSPSH.AND.KSTEP == 0) THEN
  PFHPS(KIDIA:KFDIA)=0._JPRB
ENDIF

IF (L3MT) THEN
  IF (LCVPRO) THEN
    ZUNEBH(:,:)=MIN(1.0_JPRB-ZEPS0,PUNEBH(:,:)+MAX(0._JPRB,PUDAL(:,:)))
  ELSE
    ZUNEBH(:,:)=PUNEBH(:,:)
  ENDIF
ENDIF

!     ------------------------------------------------------------------
!  The LMPHYS and LEPHYS keys should in the following be
! dispached to individual parametrizations.
IF(LMPHYS) THEN
!*
!     ------------------------------------------------------------------
!     4.- CALCULS THERMODYNAMIQUES
!     ----------------------------
  IF ( LTHERMO ) THEN
    CALL ACTQSAT ( KIDIA,KFDIA,KLON,NTQSAT,KLEV,&
     & PAPRSF, PCP, ZQV, PT,&
     & ZGEOSLC, PLH, PLSCPE, PQSAT, PQW, PRH, PTW, 'ACTQSAT' )  
  ENDIF

!*
!     ------------------------------------------------------------------
!     4.BIS. COEFFICIENTS THERMO-HYDRIQUES DU SOL
!     -------------------------------------------

  IF ( .NOT.LMSE ) THEN
    IF ( LSOLV ) THEN
      LLHMT=.FALSE.
      CALL ACSOL ( KIDIA,KFDIA,KLON,&
       & PARG,PD2,PGZ0F,PGZ0RLF,PLSM,PIVEG,&
       & PRHONS,PSAB,PSNS,PTS,PVEG0,PWP,PWPI,PWS,PWSI,&
       & LLHMT,&
       & PC1,PC2,ZC3,ZCG,ZCN,PCT,ZNEIJG,ZNEIJV,&
       & ZWFC,ZWPMX,ZWSEQ,ZWSMX,ZWWILT,'ACSOL  ')  
    ELSE

!            INITIALISATION DE L'INERTIE THERMIQUE DU SOL.

      DO JLON = KIDIA,KFDIA
        PCT(JLON)=HSOL &
         & /(1.0_JPRB+HSOLIWR*(PWS(JLON)+PWP(JLON))/(WSMX+WPMX)&
         & *EXP(-0.5_JPRB*(HSOLIT0*(PTS(JLON)-RTT))**2))  
      ENDDO
    ENDIF
  ENDIF

!*
!     ------------------------------------------------------------------
!     4.TER.- INITIALISATIONS LIEES AU SCHEMA DE SURFACE EXTERNALISE
!     ------------------------------------------------------------------

  IF ( LMSE ) THEN

!     INITIALISATION DU SCHEMA DE SURFACE EXTERNALISE ET DES
!     VARIABLES PSEUDO-HISTORIQUES ASSOCIEES

    IF ( (NSWB_MNH /= NSW) .AND. (LRAY.OR.LRAYFM15.OR.LRAYFM) ) &
      & CALL ABOR1('APLPAR: NSWB_MNH not = NSW')

    DO JLON=KIDIA,KFDIA
      PGZ0     (JLON) = PGPAR(JLON,MGZ0)
      PGZ0H    (JLON) = PGPAR(JLON,MGZ0H)
      PEMIS    (JLON) = PGPAR(JLON,MVEMIS)
      PQS      (JLON) = PGPAR(JLON,MVQS)
      PTS      (JLON) = PGPAR(JLON,MVTS)
      ZSRAIN   (JLON) = PGPAR(JLON,MRAIN)
      ZSSNOW   (JLON) = PGPAR(JLON,MSNOW)
      ZSGROUPEL(JLON) = 0._JPRB
      ZTSN     (JLON) = PTS(JLON)
    ENDDO

    DO JSG=1,NSW
      DO JLON=KIDIA,KFDIA
        ZALBP(JLON,JSG) = PGPAR(JLON,MALBDIR-1+JSG)
        ZALBD(JLON,JSG) = PGPAR(JLON,MALBSCA-1+JSG)
      ENDDO
    ENDDO
    DO JLON=KIDIA,KFDIA
      PALB(JLON)=0.0_JPRB
      DO JSG=1,NSW
        PALB(JLON)=PALB(JLON)+0.5*(ZALBP(JLON,JSG)+ZALBD(JLON,JSG))
      ENDDO
      PALB(JLON)=PALB(JLON)/REAL(NSW,JPRB)
    ENDDO
    DO JLON=KIDIA,KFDIA
      IF (PEMIS(JLON)==0._JPRB) THEN           
        PEMIS(JLON) = 0.99_JPRB           
        PTS  (JLON) = 288.0_JPRB         
        PALB (JLON) = 0.1_JPRB
      ENDIF
    ENDDO
  ENDIF

!*
!     ------------------------------------------------------------------
!     5.- STRUCTURE ET CHAMPS DANS LA COUCHE LIMITE DE SURFACE
!     ------------------------------------------------------------------

!        INITIALISATION DES HAUTEURS "METEO".

  IF ( LHMTO ) THEN
    DO JLON=KIDIA,KFDIA
      ZDPHIV(JLON)=RG*HVCLS
      ZDPHIT(JLON)=RG*HTCLS
    ENDDO
  ENDIF

  IF ( LVDIF.OR.LHMTO.OR.LGWD ) THEN
    LLCLS=LGWD.OR.LVDIF
    LLHMT=LHMTO
    IF (LMSE) THEN
      CALL ACHMTLS ( KIDIA,KFDIA,KLON,KLEV,&
       & PAPHI,PAPHIF,PAPRS,PAPRSF,PR,PT,PTS,PQS,ZDPHIT,LLCLS,&
       & ZNBVNO,PCPS,ZGWDCS,PLHS,ZPCLS,&
       & 'ACHMTLS ')  
    ELSE
      CALL ACHMT ( KIDIA,KFDIA,KLON,KTDIA,KLEV,KVCLIV,&
       & PAPHI, PAPHIF, PAPRS, PAPRSF, PCP, ZQV, PR, PT, PU, PV,&
       & PFPLSH,PFPLCH,&
       & ZDPHIT, ZDPHIV, PGZ0F, PGZ0HF, PGZ0RLF, PHV, PLSM,&
       & ZNEIJG, ZNEIJV, PSNS, PTS, PVEG0, ZWFC, PWS, PWSI,&
       & LLCLS, LLHMT,&
       & ZNBVNO,&
       & PCD, PCDN, ZCDROV, PCH, ZCHROV, PCPS, ZDQSTS, ZGWDCS,&
       & PGZ0, PGZ0H, ZHQ, ZHU, PNEIJ, PQCLS, PQS, PQSATS, PRHCLS,&
       & PRS, ZRTI, ZSTAB, PTCLS, PUCLS, PVCLS, ZPUCLN, ZPVCLN, ZPCLS, PVEG,&
       & ZXDROV, ZXHROV,PUGST,PVGST,'ACHMT  ')  
    ENDIF

    IF (LFLUSO.AND.(.NOT.LMSE)) THEN
      DO JLON=KIDIA,KFDIA
        ZCRTI(JLON) = 1.0_JPRB/(PTS(JLON)*PRS(JLON))
      ENDDO
      CALL ACFLUSO ( KIDIA,KFDIA,KLON,KLEV,&
       & PAPHI,PAPHIF,PAPRS,PAPRSF,PQ,PT,PU,PV,&
       & ZDPHIT,ZDPHIV,PGZ0,PLSM,PQSATS,ZCRTI,PTS,&
       & LLHMT,PCD,PCDN,ZCDROV,ZCE,ZCEROV,PCH,ZCHROV,&
       & PQCLS,PRHCLS,PTCLS,PUCLS,PVCLS,PUGST,PVGST,'ACFLUSO')
    ELSE
      DO JLON=KIDIA,KFDIA
        ZCE   (JLON) = PCH   (JLON)
        ZCEROV(JLON) = ZCHROV(JLON)
      ENDDO
    ENDIF

    IF((TRIM(CGMIXLEN) == 'Z')  .OR. (TRIM(CGMIXLEN) == 'EL1').OR. &
      &(TRIM(CGMIXLEN) == 'EL2').OR. (TRIM(CGMIXLEN) == 'EL3').OR. &
      &(TRIM(CGMIXLEN) == 'EL4').OR. (TRIM(CGMIXLEN) == 'AY') .OR. &
      &(TRIM(CGMIXLEN) == 'AYC').AND.(.NOT.LECT)) THEN
      DO JLEV=KTDIA,KLEV
        DO JLON=KIDIA,KFDIA
          ZTHETAV(JLON,JLEV)=PT(JLON,JLEV)*(1.0_JPRB+RETV*ZQV(JLON,JLEV)) &
           & *(RATM/PAPRSF(JLON,JLEV))**RKAPPA  
        ENDDO
      ENDDO
      DO JLON=KIDIA,KFDIA
        ZTHETAVS(JLON)=PTS(JLON)*(1.0_JPRB+RETV*PQS(JLON)) &
         & *(RATM/PAPRS(JLON,KLEV))**RKAPPA  
      ENDDO
      CALL ACCLPH ( KIDIA,KFDIA,KLON,KTDIA,KLEV,&
       & ZTHETAV,PAPHI,PAPHIF,PU,PV,ZTHETAVS, &
       & KCLPH,PCLPH,ZUGST,ZVGST,'ACCLPH ')  
      ZBLH(:)=PCLPH(:)
      IF (.NOT.LRAFTUR) THEN
        PUGST(KIDIA:KFDIA)=ZUGST(KIDIA:KFDIA)
        PVGST(KIDIA:KFDIA)=ZVGST(KIDIA:KFDIA)
      ENDIF
    ELSE
      ZBLH(:)=PPBLH(:)
    ENDIF
  ENDIF

!**
!     ------------------------------------------------------------------
!     6.- TURBULENCE: COEFFICIENTS D'ECHANGE
!     ------------------------------------------------------------------
  IF (LPTKE) THEN
    PTKE(KIDIA:KFDIA,1:KLEV) = MAX(PTKE(KIDIA:KFDIA,1:KLEV),1.E-08_JPRB)
  ENDIF

  IF ( (LVDIF.OR.LGWD).AND.(.NOT.(LNEBR.OR.LECT)) ) THEN
    IF(TRIM(CGMIXLEN) == 'Z') THEN

      !-------------------------------------------------
      ! "z dependent" mixing length.
      !-------------------------------------------------

      ZBLH(:)=1.0_JPRB/UHDIFV
      CALL ACMIXLENZ ( KIDIA,KFDIA,KLON, 1,KLEV,&
       & PAPHI,PAPHIF,ZBLH,PGZ0,PGZ0H,ZLMU,ZLMT,'ACMIXLENZ')
    ELSEIF((TRIM(CGMIXLEN) == 'TMC').OR.(TRIM(CGMIXLEN) == 'AYC')) THEN

      ZBLH(:)=MIN(XMAXLM,MAX(XMINLM,ZBLH(:)))

!     Cubique du climat
      CALL ACMIXLENTM ( KIDIA,KFDIA,KLON, 1,KLEV,&
       &PAPHI, PAPHIF,PGZ0,PGZ0H,ZBLH,ZLMU,ZLMT,'ACMIXLENTM')
    ELSEIF(TRIM(CGMIXLEN) == 'TM') THEN
      ZBLH(:)=MIN(XMAXLM,MAX(XMINLM,ZBLH(:)))*XKLM

!     Ancienne formulation pour Lm 
      CALL ACMIXLENZ ( KIDIA,KFDIA,KLON, 1,KLEV,&
        & PAPHI,PAPHIF,ZBLH,PGZ0,PGZ0H,ZLMU,ZLMT,'ACMIXLENZ')

!     Cubique du climat pour Lh
      ZBLH(:)=ZBLH(:)/XKLM
      CALL ACMIXLENTM ( KIDIA,KFDIA,KLON, 1,KLEV,&
       &PAPHI, PAPHIF,PGZ0,PGZ0H,ZBLH,ZZLMT,ZLMT,'ACMIXLENTM')
    ELSEIF(TRIM(CGMIXLEN) == 'AY') THEN
!     new Ayotte-Tudor ZBLH & mixing length
      CALL ACMIXLENZ ( KIDIA,KFDIA,KLON, 1,KLEV,&
        & PAPHI,PAPHIF,ZBLH,PGZ0,PGZ0H,ZLMU,ZLMT,'ACMIXLENZ')
    ELSEIF((CGMIXLEN(1:2) == 'EL').AND.LPTKE) THEN
!     e-type mixing length converted to Prandtl type
      CALL ACMIXLENZ ( KIDIA,KFDIA,KLON, 1,KLEV,&
        & PAPHI,PAPHIF,ZBLH,PGZ0,PGZ0H,ZLMU,ZLMT,'ACMIXLENZ')
      IF     (TRIM(CGMIXLEN) == 'EL1') THEN
        IMLTYPE=1
      ELSEIF (TRIM(CGMIXLEN) == 'EL2') THEN
        IMLTYPE=2
      ELSEIF (TRIM(CGMIXLEN) == 'EL3') THEN
        IMLTYPE=3
      ELSEIF (TRIM(CGMIXLEN) == 'EL4') THEN
        IMLTYPE=4
      ELSE
        CLERR='APLPAR: UNEXPECTED VALUE FOR CGMIXLEN: '//TRIM(CGMIXLEN)
        CALL ABOR1(CLERR)
      ENDIF
      CALL ACMIXELEN(KIDIA,KFDIA,KLON, 1,KLEV,IMLTYPE,&
        & PAPHI,PAPHIF,PAPRS,PAPRSF,PT,PQ,PQL,PQI,PRR,PS,PTKE,&
        & PGZ0,PTS,ZLMU,ZLMT)
    ELSE
      CLERR='APLPAR: UNEXPECTED VALUE FOR CGMIXLEN: '//TRIM(CGMIXLEN)
      CALL ABOR1(CLERR)
    ENDIF

     !-------------------------------------------------
     ! Compute diffusion coefficients.
     !-------------------------------------------------

    CALL ACCOEFK ( KIDIA,KFDIA,KLON,NTCOEF,KLEV,&
     & PAPHI, PAPHIF, PAPRS, PAPRSF, PCP, PDELP, PLSCPE, ZQV, ZQL, ZQI, PQSAT,&
     & PR, PT, PU, PV, PFPLSH, PFPLCH, ZLMU, ZLMT, PGZ0, PGZ0H, ZBLH,&
     & ZKTROV, ZKUROV, ZKNROV, ZNBVNO, ZXTROV, ZXUROV, ZXPTKEROV,&   
     & 'ACCOEFK')
  ENDIF

  IF (LCVPPKF) THEN
    CALL ACVPPKF( KIDIA, KFDIA, KLON, NTCVIM, KLEV, &
     & PAPRSF, PAPHIF, PDELP, PR, PT, ZQV, &
     & ZQL, ZQI, PU, PV, PVERVEL, PCP, &
     & ZDIFCVPPQ, ZDIFCVPPS, ZCONDCVPPL, ZCONDCVPPI, &
     & ZPRODTH_CVPP, INLAB_CVPP, ZQC_CVPP, ZNEB_CVPP, INND ,'ACVPPKF' )
  ENDIF

  IF ( LVDIF.AND.LECT ) THEN
    IF ( LCONDWT ) THEN
       PQICE(:,:)= ZQI(:,:)
       PQLI(:,:) = ZQL(:,:)
    ELSE
       PQICE(:,:)= 0.0_JPRB
       PQLI(:,:) = 0.0_JPRB
    ENDIF

! Computation of the 2 znlab used in acbl89
    IF (.NOT. LECSHAL) INLAB_CVPP(:,:) = 0
    IF (LECDEEP) THEN 
       ZNLABCVP(:,:) = 1.0_JPRB
    ELSE
       ZNLABCVP(:,:) = 0.0_JPRB
    ENDIF   
    DO JLEV=KTDIA,KLEV
       DO JLON=KIDIA,KFDIA
          ZNLABCVP(JLON,JLEV) = ZNLABCVP(JLON,JLEV) &
       &  *MAX(0.0_JPRB,SIGN(1.0_JPRB,PFPLCH(JLON,JLEV)-PFPLCH(JLON,JLEV-1)-ZEPS))
          ZNLAB(JLON,JLEV) = REAL(INLAB_CVPP(JLON,JLEV),JPRB)
       ENDDO
    ENDDO   

    CALL ACTKE ( KIDIA,KFDIA,KLON,NTCOEF,NTCOET,KLEV,&
     & PAPHI, PAPHIF, PAPRS, PAPRSF, &
     & PR, PT, PU, PV, ZQV, PLSCPE, &
     & PCD, PCH, PGZ0, PTS, PQS, &
     & PQICE, PQLI, PTKE, ZPRODTH_CVPP, ZNLAB, ZNLABCVP, &
     & ZKTROV, ZKUROV, ZXTROV, ZXUROV, &
     & ZNBVNO, ZNEBS, ZQLIS, ZNEBS0, ZQLIS0, ZCOEFN , PFTKE, &
     & PCLPH, KCLPH, 'ACTKE  ')
    PCLPH(:)=MIN(XMAXLM,MAX(XMINLM,PCLPH(:)))
  ENDIF


     !-------------------------------------------------
     ! Store diffusion coefficients in trajectory.
     !-------------------------------------------------

  IF (LTRAJPST .AND. LVDIFSPNL) THEN
  
  
     IFIELDS=NG3DT95*KLEV+NG3PR95*(KLEV+1)+NG2DSF5 
     IPCT = 0_JPIM ! <== IPCT is not used in WRPHTRAJTM
     
!  Shape of dummy arrays     
!     ZDUM1 ==> (KLON,0:KLEV)
!     ZDUM2 ==> (KLON,KLEV)
!     ZDUM3 ==> (KLON)

     ZDUM1(:,:) = 0.0_JPRB
     ZDUM2(:,:) = 0.0_JPRB
     ZDUM3(:)   = 0.0_JPRB
     CALL WRPHTRAJTM (KSTEP,KIDIA,KFDIA,KSTGLO,IFIELDS,&
                & ZDUM2,&
                & ZDUM1,ZDUM1,ZDUM1,ZDUM1,&
                & ZDUM1,ZDUM1,ZDUM1,ZDUM1,&
                & ZDUM1,ZDUM1,ZDUM1,ZDUM1,ZDUM1,ZDUM1,&
                & ZDUM1,ZDUM1,ZDUM1,ZDUM1,ZDUM1,ZDUM1,&
                & ZDUM1,ZDUM1,ZDUM1,&
                & ZKTROV,ZKUROV,ZDUM1,ZDUM1,&
                & ZCDROV,ZCHROV,ZDUM3,ZDUM3,&
                & ZDUM2,ZDUM2,ZDUM2,ZDUM2 )  
  ENDIF

!**
!     ------------------------------------------------------------------
!     7.- RAYONNEMENT
!     ----------------

!      7.1 Albedo et emissivite en presence de neige
!          Albedo and emissivity with snow

  IF (.NOT.LMSE) THEN
  DO JLON=KIDIA,KFDIA
    IF (LSNV) THEN
      IF ((PVEG0(JLON) < 0.01_JPRB).OR.(PALBF(JLON) >= 0.60_JPRB)) THEN
        ZALBV=0.0_JPRB
        PALBSF(JLON)=PALBF(JLON)
      ELSE
        ZALBV=(PALBF(JLON)-(1.0_JPRB-PVEG0(JLON))*PALBSF(JLON))/PVEG0(JLON)
      ENDIF
      PALB(JLON)= (1.0_JPRB-PVEG0(JLON))*(1.0_JPRB-ZNEIJG(JLON)) *&
       & PALBSF(JLON)&
       & + (1.0_JPRB-PVEG0(JLON))*ZNEIJG(JLON) *&
       & MAX(PALBSF(JLON),PALBNS(JLON))&
       & + PVEG0(JLON)*ZNEIJV(JLON) *&
       & MAX(ZALBV,PALBNS(JLON))&
       & + PVEG0(JLON)*(1.0_JPRB-ZNEIJV(JLON)) * ZALBV  
      PEMIS(JLON)= (1.0_JPRB-PVEG0(JLON))*(1.0_JPRB-ZNEIJG(JLON)) *&
       & PEMISF(JLON)&
       & + (1.0_JPRB-PVEG0(JLON))*ZNEIJG(JLON) * EMCRIN &
       & + PVEG0(JLON)*ZNEIJV(JLON) * EMCRIN &
       & + PVEG0(JLON)*(1.0_JPRB-ZNEIJV(JLON)) * PEMISF(JLON)  
    ELSE
      IF (LVGSN) THEN
        ZCFN = (1.0_JPRB-MAX(0.0_JPRB,MIN(1.0_JPRB,PLAI(JLON)/RLAIMX)))*&
         & MAX(0.0_JPRB,SIGN(1.0_JPRB,PLAI(JLON)-RLAI)) + &
         & (1.0_JPRB-MAX(0.0_JPRB,SIGN(1.0_JPRB,PLAI(JLON)-RLAI)))  

        ZCK = MAX(0.0_JPRB,(ALB1-MAX(ALB2,PALBNS(JLON))))/(ALB1-ALB2)
        ZCOEF= ZCFN * ZCK + (1.0_JPRB- ZCK)

        ZVNEIJ=PNEIJ(JLON)*ZCOEF
        PALB(JLON)=PALBF(JLON)-PNEIJ(JLON)*(PALBF(JLON)&
         & -PALBNS(JLON)) &
         & +(PNEIJ(JLON)-ZVNEIJ)*PVEG0(JLON)*(PALV(JLON)-PALBNS(JLON))  

        PALB(JLON)=MIN(ABS(PIVEG(JLON)-2._JPRB),1.0_JPRB) * PALB(JLON) +&
         & (1.0_JPRB-MIN(ABS(PIVEG(JLON)-2._JPRB),1.0_JPRB)) &
         & * MAX(ALCRIN,PALB(JLON))  
        PALBH(JLON)=PALB(JLON)

        PEMIS(JLON)=PEMISF(JLON)-PNEIJ(JLON)*(PEMISF(JLON)-EMCRIN)

      ELSE
        PALB(JLON)=PALBF(JLON)-PNEIJ(JLON)*(PALBF(JLON)&
         & -MAX(PALBF(JLON),ALCRIN))  
        PEMIS(JLON)=PEMISF(JLON)-PNEIJ(JLON)*(PEMISF(JLON)-EMCRIN)
      ENDIF
    ENDIF
  ENDDO

! Albedo dans les 2 intervalles, direct (parallel) et diffus (diffuse).

  IF ( LRAYFM15 ) THEN
    DO JSG=1,NSW
      DO JLON=KIDIA,KFDIA
        ! Partie Diffusive :
        ZALBD(JLON,JSG)=PALB(JLON)
        ! Partie Parallele :
        !  pour ocean, formule Geleyn ACRANEB :
        ZALBPMER=(1.0_JPRB+0.5_JPRB*(PMU0M(JLON)*(1.0_JPRB/PALB(JLON)-1.0_JPRB)))/&
                &(1.0_JPRB+         (PMU0M(JLON)*(1.0_JPRB/PALB(JLON)-1.0_JPRB)))**2
        ZALBP(JLON,JSG)=PALB(JLON)*            PLSM(JLON) &
                &       + ZALBPMER  *(1.0_JPRB-PLSM(JLON))
      ENDDO
    ENDDO
  ENDIF

  IF ( LRAYFM ) THEN
    DO JLON=KIDIA,KFDIA
      ZMERL(JLON)=(1.0_JPRB-PLSM(JLON))*(1.0_JPRB &
        & -MAX(0.0_JPRB,SIGN(1.0_JPRB,TMERGL-PTS(JLON))))
      PEMIS(JLON)=PEMIS(JLON)*PLSM(JLON)+ZMERL(JLON)*EMMMER &
        & + (1.0_JPRB-PLSM(JLON))*(1.0_JPRB-ZMERL(JLON))*EMMGLA
    ENDDO
    DO JSG=1,NSW
      DO JLON=KIDIA,KFDIA
        ZALBD(JLON,JSG)=(1.0_JPRB-ZMERL(JLON))*PALB(JLON)+ZMERL(JLON)*ALBMED
        ZALBP(JLON,JSG)=(1.0_JPRB-ZMERL(JLON))*PALB(JLON)+ZMERL(JLON) &
          & *MAX(0.037_JPRB/(1.1_JPRB*PMU0(JLON)**1.4_JPRB+0.15_JPRB),ZEPS0)
      ENDDO
    ENDDO
  ENDIF
  ENDIF


!      7.2 Flux radiatifs par ciel clair (Code Geleyn)
!          Clear sky radiative fluxes    (Geleyn's scheme)

  IF(LRAY.AND.NFRRC /= 0) THEN
    IF(MOD(KSTEP,NFRRC) == 0) THEN
      CALL ACRANEB ( KIDIA,KFDIA,KLON,NTRADI,KLEV,IJN,&
       & PAPHIF, PAPRS, PAPRSF,PCP, PR, PDELP, PNEB,&
       & ZQV, ZQCO2, PQICE, PQLI, ZQO3, PT,&
       & PALB, PEMIS, PMU0, PGEMU, PGELAM, PMU0LU, PTS,&
       & PFRSO, PFRTH,&
       & ZFRSOFS, PFRSOPS, PFRSOLU, PFRTHDS, ZDAER,&
       & ZMAK, ZMAN, 'ACRANEB')  
      DO JLON=KIDIA, KFDIA
        PFRSOC(JLON,0)=PFRSO(JLON,NTRADI-1,1)
        PFRSOC(JLON,1)=PFRSO(JLON,KLEV,1)
        PFRTHC(JLON,0)=PFRTH(JLON,NTRADI-1,1)
        PFRTHC(JLON,1)=PFRTH(JLON,KLEV,1)
      ENDDO
    ENDIF
  ENDIF

!      7.3 Nebulosite et Convection
!          Cloud cover and Convection
!      7.3.1 Shallow + Deep convection

  IF (LCVPGY) THEN
    ! Le schema de convection de J. F. Gueremy
    IF (LCONDWT) THEN
      DO JLEV=KTDIA,KLEV
        DO JLON=KIDIA,KFDIA
          ZQCL(JLON,JLEV)=ZQL(JLON,JLEV)
          ZQCI(JLON,JLEV)=ZQI(JLON,JLEV)
        ENDDO
      ENDDO
    ELSE
      DO JLEV=KTDIA,KLEV
        DO JLON=KIDIA,KFDIA
          ZQCL(JLON,JLEV)=0.0_JPRB
          ZQCI(JLON,JLEV)=0.0_JPRB
        ENDDO
      ENDDO
    ENDIF
    CALL ACCVIMPGY ( KIDIA,KFDIA,KLON,NTCVIM,KLEV,&
     & PALPH, PAPHIF, PAPRS, PAPRSF, PCP,&
     & PDELP,PLH,PLNPR,ZQV,ZQCI,ZQCL,ZQLIS,PQSAT,PQW,&
     & PR,PRDELP,PT,PTW, PU, PV,&
     & PCPS,PGM,ZSTAB,PTS,&
     & PDIFCQ,PDIFCQL,PDIFCQI,PDIFCS,PFCCQL,PFCCQN,&
     & PFPFPCL,PFPFPCN,PFPEVPCL,PFPEVPCN,&
     & ZFHMLTSC,ZFHEVPPC,ZFPEVPPC,&
     & PFPLCL,PFPLCN,ZNEBC,ZQLIC,PSTRCU,PSTRCV,&
     & ICIS,INLAB,&
     & INND,&
     & PCVV,&
     & 'ACCVIMPGY' )  

    DO JLEV = KTDIA, KLEV
      DO JLON = KIDIA, KFDIA
        PDIFCS(JLON,JLEV) = PDIFCS(JLON,JLEV) - ZFHEVPPC(JLON,JLEV) &
         &                                    - ZFHMLTSC(JLON,JLEV)
        PDIFCQ(JLON,JLEV) = PDIFCQ(JLON,JLEV) + ZFPEVPPC(JLON,JLEV)
      ENDDO
    ENDDO

    ! Annulation possible des flux convectifs pour les eaux condensees.
    IF (.FALSE.) THEN
      DO JLEV=0,KLEV
        DO JLON=KIDIA,KFDIA
          PDIFCQL(JLON,JLEV)=0.0_JPRB
          PDIFCQI(JLON,JLEV)=0.0_JPRB
        ENDDO
      ENDDO
    ENDIF
  ENDIF !  (LCVPGY)

  IF ( LCONDWT.AND.LPROCLD.AND.(.NOT.LNEBECT)) THEN

    CALL ACNEBSM ( KIDIA,KFDIA,KLON,NTPLUI,KLEV,&
     &PT,ZQV,ZQL,ZQI,&
     &PAPHI,PAPRSF,PCP,PR,&
     &PTS,PNEIJ,PLSM,PGM,ZVETAF,&
     &ZQLIS,ZNEBS,ZQLIS0,ZNEBS0 )
  ENDIF

  IF ( L3MT.OR.LSTRAPRO ) THEN
    IF(LCVPRO.AND.LNEBCV) THEN
       ZNEBCH(:,:)=ZUNEBH(:,:)
    ENDIF
    CALL ACNEBCOND ( KIDIA,KFDIA,KLON,NTPLUI,KLEV,&
     & ZHUC,ZVETAF,PAPHI,PAPHIF,PAPRSF,PCP,PDELP,ZQV,ZQI,ZQL,PQW,PT,ZNEBCH,&
     & PGM,PTS,&
     & ZNEBS,ZRHCRI,ZQSATS,ZICEFR1,'ACNEBCOND')
  ENDIF

  IF (LCVPPKF) THEN
    DO JLEV=KTDIA,KLEV
      DO JLON=KIDIA,KFDIA
        ZQLIS0(JLON,JLEV)=ZQLIS0(JLON,JLEV)+ZQC_CVPP(JLON,JLEV)
        ZQLIS (JLON,JLEV)=ZQLIS (JLON,JLEV)+ZQC_CVPP(JLON,JLEV)
        ZNEBS0(JLON,JLEV)=MAX(ZNEBS0(JLON,JLEV),ZNEB_CVPP(JLON,JLEV))
        ZNEBS (JLON,JLEV)=MAX(ZNEBS (JLON,JLEV),ZNEB_CVPP(JLON,JLEV))
      ENDDO
    ENDDO
  ENDIF

!         Appel du calcul de nebulosite.

  IF(LNEBN) THEN
    CALL ACNEBN ( KIDIA,KFDIA,KLON,NTNEBU,KLEV,&
     & PAPHIF,PCP,ZQV,ZQL,ZQI,PQSAT,PT,PFPLCH,PDELP,PRDELP,PAPRSF,&
     & ZUNEBH,&
     & ZNEBS0,ZQLIS0,&
     & PNEB,ZNEBC0,PQICE,PQLI,&
     & ZHUC,'ACNEBN ')  
  ENDIF

  IF ( LNEBR ) THEN
    CALL ACNEBR ( KIDIA,KFDIA,KLON,NTCOEF,NTNEBU,KLEV,&
     & PAPHI,PAPHIF,PAPRS,PAPRSF,PLSCPE,ZQV,&
     & PQSAT,PR,PT,PU,PV,PRDELP,PDELP,&
     & PGZ0,PFPLCH,PPBLH,PQS,PTS,&
     & ZKTROV,ZKUROV,ZNBVNO,PNEB,ZNEBS,PQICE,PQLI,&
     & ZQLIS,&
     & 'ACNEBR ')  
  ENDIF

!         Diagnostique de nebulosite partielle.
  CALL ACNPART ( KIDIA,KFDIA,KLON,NTNEBU,KLEV,&
   & PNEB,ZNEBC0,&
   & PCLCC,PCLCH,PCLCL,PCLCM,PCLCT,'ACNPART')

!     7.3.5 Computation of the equivalent coefficients for simplified
!           radiation scheme

  IF ( (LRAYSP .AND.(KSTEP == 1).AND.LRCOEF) .OR. &
     & (LRAYSP .AND.(KSTEP >= 1 .AND. KSTEP <= NSTOP-1).AND.LWRTCFOU) ) THEN  
    DO JLEV=KTDIA,KLEV
      DO JLON=KIDIA,KFDIA
        ZZNEB(JLON,JLEV)=0.0_JPRB
      ENDDO
    ENDDO

    CALL ACRADCOEF ( KIDIA,KFDIA,KLON,KTDIA,KLEV,&
     & PAPRS,PAPRSF,PDELP,ZZNEB,ZQV,ZQCO2,PQICE,PQLI,&
     & ZQO3,PT,&
     & PMMU0,PDHSF,PEMIS,&
     & ZDAER,&
     & POMPAC,PAC,PCOR,&
     & PRAB3C,PRAB3N,PRAB4C,PRAB4N,PRAB6C,PRAB6N,&
     & PRAT1C,PRAT1N,PRAT2C,PRAT2N,PRAT3C,PRAT3N,&
     & PRAT4C,PRAT4N,PRAT5C,PRAT5N,'ACRADCO')  
  ENDIF

!      7.4 Rayonnement Geleyn
!          Geleyn's radiation

  LLAERO=LAEROSEA.AND.LAEROLAN.AND.LAEROSOO.AND.LAERODES
  IF ( LRAY ) THEN
    CALL ACRANEB ( KIDIA,KFDIA,KLON,NTRADI,KLEV,IJN,&
     & PAPHIF, PAPRS, PAPRSF, PCP, PR, PDELP, PNEB,&
     & ZQV, ZQCO2, PQICE, PQLI, ZQO3, PT,&
     & PALB, PEMIS, PMU0, PGEMU, PGELAM, PMU0LU, PTS,&
     & PFRSO, PFRTH,&
     & ZFRSOFS, PFRSOPS, PFRSOLU, PFRTHDS, ZDAER,&  
     & ZMAK, ZMAN, 'ACRANEB' )

    DO JLON=KIDIA,KFDIA
      PFRSODS(JLON)=ZFRSOFS(JLON)+PFRSOPS(JLON)
    ENDDO

!      7.5 Rayonnement Morcrette
!          Morcrette's radiation

  ELSEIF ( LRAYFM.OR.LRAYFM15 ) THEN

    IF(LRAYFM)THEN
      NAER15=0
      NRADFR15=9999
    ELSE
      NAER=0
      NRADFR=9999
    ENDIF
    IF (MOD(KSTEP,NRADFR) == 0.OR.MOD(KSTEP,NRADFR15) == 0) THEN

! Appel de la routine d'aerosols

      IF((NAER /= 0.OR.NAER15 /= 0).AND.(.NOT.LLAERO).AND.LRADAER15) THEN
        CALL ABOR1('APLPAR: PB AEROSOLS!')
      ENDIF

      IF(LLAERO) THEN
        DO JLON = KIDIA,KFDIA
          ZAESEA(JLON) = PAESEA(JLON)
          ZAELAN(JLON) = PAELAN(JLON)
          ZAESOO(JLON) = PAESOO(JLON)
          ZAEDES(JLON) = PAEDES(JLON)
        ENDDO
      ELSE
        DO JLON = KIDIA,KFDIA
          ZAESEA(JLON) = 0.0_JPRB
          ZAELAN(JLON) = 0.0_JPRB
          ZAESOO(JLON) = 0.0_JPRB
          ZAEDES(JLON) = 0.0_JPRB
        ENDDO
      ENDIF
      IF(LAEROSUL) THEN
        DO JLON = KIDIA,KFDIA
          ZAESUL(JLON) = PAESUL(JLON)
        ENDDO
      ELSE
        DO JLON = KIDIA,KFDIA
          ZAESUL(JLON) = 0.0_JPRB
        ENDDO
      ENDIF 
      IF(LAEROVOL) THEN
         DO JLON = KIDIA,KFDIA
          ZAEVOL(JLON) = PAEVOL(JLON)
        ENDDO
      ELSE
        DO JLON = KIDIA,KFDIA
          ZAEVOL(JLON) = 0.0_JPRB
        ENDDO
      ENDIF 

      IF(LRAYFM.AND.NAER /= 0.AND.(LLAERO.OR.(.NOT.LRADAER15))) THEN
        CALL RADAER ( KIDIA , KFDIA , KLON  , KTDIA , KLEV,&
         & PAPRS , PAPRSF, PT    , PTS,&
         & ZAESEA, ZAELAN, ZAESOO, ZAEDES,&
         & ZAER                                 )  
      ENDIF
      IF(LRAYFM15.AND.NAER15 /= 0.AND.(LLAERO.OR.(.NOT.LRADAER15))) THEN
        CALL RADAER15 ( KIDIA , KFDIA , KLON  , KTDIA , KLEV,&
         & PAPRS , PAPRSF, PT    , PTS,&
         & ZAESEA, ZAELAN, ZAESOO, ZAEDES, ZAESUL, ZAEVOL,&
         & ZAER                                 )  
      ENDIF

! Appel de l'interface rayonnement

      IF (LRAYFM) THEN
        ZCARDI=RCARDI
        IMODE=NMODE
      ELSEIF (LRAYFM15) THEN
        ZCARDI=RCARDI15
        IFLUX=NFLUX15
        IMODE=NMODE15
        IRAD=NRAD15
      ENDIF

      CALL ACRADIN &
       & ( KIDIA , KFDIA,&
       & KLON  , KGL1 , KGL2     , KTDIA , KLEV,&
       & IMODE , IFLUX, IRAD,&
       & ZALBD , ZALBP, PAPRS    , PAPRSF,&
       & ZCARDI, PNEB , ZQO3(1,1), ZAER,&
       & PDELP , PEMIS, PMU0M , ZQV   , PQSAT,&
       & PQICE , PQLI , PLSM     , PT    , PTS,&
       & PEMTD , PEMTU, PTRSO,&
       & PFRTHC, PFRTH, PFRSOC   , PFRSO ,&
       & ZSFSWDIR     , ZSFSWDIF , ZFSDNN , ZFSDNV,&
       & ZCTRSO,ZCEMTR, ZTRSOD ,&
       & ZPIZA_DST,ZCGA_DST,ZTAUREL_DST,&
       & 'ACRADIN')

      IF(LMSE) THEN
        DO JSG=1,NSW
          DO JLON=KIDIA,KFDIA
            PGPAR(JLON,MSWDIR+JSG-1)= ZSFSWDIR(JLON,JSG)
            PGPAR(JLON,MSWDIF+JSG-1)= ZSFSWDIF(JLON,JSG)
          ENDDO
        ENDDO
      ENDIF
      IF (LRAYLU) THEN
        CALL ACRALU ( KIDIA,KFDIA,KLON,NTRADI,KLEV,IJN,&
         & PAPRS, PAPRSF, PDELP, PNEB,&
         & ZQV, ZQCO2, PQICE, PQLI, ZQO3, PT,&
         & PALB, PGEMU, PGELAM, PMU0LU,&
         & PFRSOLU, ZDAER, 'ACRALU' )  
        DO JLON=KIDIA,KFDIA
          PVRMOON(JLON)=PFRSOLU(JLON)
        ENDDO   
      ENDIF

    ELSE

      IF (LRAYLU) THEN
        DO JLON=KIDIA,KFDIA
          PFRSOLU(JLON)=PVRMOON(JLON)
        ENDDO   
      ENDIF  
       
    ENDIF   ! <== Fin du test sur les frequences d'appel

! Radiative fluxes at every time-step

! Logical for RADHEAT
    LLZERO=.TRUE.

    IF (LRAYFM) THEN
      CALL RADHEAT &
       & (  KIDIA  , KFDIA  , KLON    , KLEV,&
       & PAPRS  ,&
       & PEMIS  , PEMTD   , PMU0,&
       & ZQV,&
       & ZTENT  , PTRSO   , ZTRSOD , PTS , TSPHY,&
       & PFRSO  , PFRTH  , PFRSODS , PFRTHDS,&
       & ZCEMTR , ZCTRSO , PFRSOC  , PFRTHC,&
       & ZSUDU  , ZSDUR  , ZDSRP &
       & )  
    ELSEIF (LRAYFM15) THEN
      CALL RADHEAT15 &
       & (  KIDIA  , KFDIA  , KLON   , KLEV  ,LLZERO,&
       & PAPRS  ,&
       & PEMIS  , PEMTD  , PMU0,&
       & ZQV,&
       & ZTENT  , PTRSO  , ZTRSOD , PTS   , TSPHY,&
       & PFRSO  , PFRTH  , PFRSODS, PFRTHDS )  
    ENDIF

    IF (LRAYFM) THEN
      DO JLON=KIDIA,KFDIA
        PFRSODS(JLON)=PFRSO(JLON,KLEV,1)/(1.0_JPRB-ZALBD(JLON,1))
      ENDDO
    ELSEIF (LRAYFM15) THEN
      DO JLON=KIDIA,KFDIA
        PFRSODS(JLON)=PFRSO(JLON,KLEV,1)/(1.0_JPRB-PALB(JLON))
      ENDDO
    ENDIF

  ENDIF

!*
!     ------------------------------------------------------------------

!     7.BIS. BILAN HYDRIQUE DU SOL
!     ----------------------------
!     CALCUL DES RESISTANCES A L'EVAPOTRANSPIRATION HV ET
!     A LA TRANSPIRATION
!     ------------------------------------------------------------------
!     HTR DU COUVERT VEGETAL
!     ----------------------

  IF (LSOLV.AND.(.NOT.LMSE)) THEN
    CALL ACVEG ( KIDIA,KFDIA,KLON,KLEV,&
     & PFRSO,ZQV,PQSAT,PT,&
     & PD2,PLSM,PIVEG,PLAI,PNEIJ,PVEG,PRSMIN,&
     & ZCHROV,ZGWDCS,ZWFC,PWL,ZWWILT,PWP,PQSATS,&
     & ZHQ,ZHTR,ZHU,PHV,ZWLMX,'ACVEG  ' )  
  ENDIF

!     ------------------------------------------------------------------
!     8.- DIFFUSION VERTICALE TURBULENTE
!     ----------------------------------
  IF ( LVDIF ) THEN

!   Sauvegarde temporaire de l'ancien acdifus pour les besoins du Climat
    IF ( LACDIFUS ) THEN

      IF(NDIFFNEB == 1) THEN
        ZNEBDIFF(:,:)=ZNEBS(:,:)
      ELSEIF(NDIFFNEB == 2) THEN
        ZNEBDIFF(:,:)=PNEB(:,:)
      ELSEIF(NDIFFNEB == 3) THEN
        ZNEBDIFF(:,:)=ZNEBS(:,:)+(1.0_JPRB-ZNEBS(:,:))*ZNEBCH(:,:)
      ENDIF

      CALL ACDIFUS ( KIDIA,KFDIA,KLON,NTDIFU,KLEV,KCSS,&
       & PAPHI, PAPHIF, PCP, PDELP, PFRSO, ZKTROV, ZKUROV, ZKNROV,&
       & ZQV, PRDELP, PT, PU, PV, ZXTROV, ZXUROV, ZXPTKEROV, PALPH,&
       & PAPRSF, PAPRS, PR, ZQL, ZQI, ZNEBDIFF, PTKE, ZLMU, PLNPR,&
       & PCD, PCDN, ZCDROV, ZCHROV, ZCEROV, PCPS, PCT,ZDQSTS,&
       & PEMIS, PFHPS, ZHQ, ZHTR, ZHU, PHV,&
       & PLSM, PIVEG, PNEIJ, PQS, PQSATS, PTP, PTS, PVEG,&
       & ZXDROV, ZXHROV, PWS, PWSI,&
       & PDIFTQ, PDIFTS, PSTRTU, PSTRTV,&
       & PDIFTQL, PDIFTQI, PTENDPTKE, &
       & PFCHSP, PFCLL, PFCLN, PFCS, PFEVI, PFEVL, PFEVN, PFEVV,&
       & PFTR, PLHS, PFRTH, PGZ0F, PGZ0HF, 'ACDIFUS' )

    ELSE

      IF ( LPTKE ) THEN
        CALL ACPTKE ( KIDIA,KFDIA,KLON,KTDIA,KLEV,&
          & PAPHI,PAPHIF,PDELP,PRDELP,ZKNROV,&
          & PT,PU,PV,PALPH,&
          & PAPRS,PR,PTKE,ZLMU,PLNPR,&
          & PCD,PGZ0,&
          & ZKUROV,ZKTROV,ZXPTKEROV,&
          & PTENDPTKE,&
          & 'ACPTKE')
      ENDIF

      CALL ACDIFV1 ( KIDIA,KFDIA,KLON,KTDIA,KLEV,&
        & PAPHIF,PAPRSF,PCP,PDELP,ZKTROV,ZKUROV,&
        & ZQV,ZQL,ZQI,PRDELP,PT,PU,PV,ZXTROV,ZXUROV,&
        & ZXDROV,ZXHROV,&
        & ZXURO,ZXQRO,ZXTRO,&
        & ZCFAQ,ZCFAS,ZCFATH,ZCFAU,&
        & ZCFBQ,ZCFBS,ZCFBTH,ZCFBU,ZCFBV,&
        & ZDSE,&
        & 'ACDIFV1')  

      IF ( LMSE ) THEN

        IF (LRAYFM) THEN
          ZCARDI=RCARDI
          DO JSG=1,NSW
            DO JLON=KIDIA,KFDIA
              ZSFSWDIR(JLON,JSG)=PGPAR(JLON,MSWDIR+JSG-1)
              ZSFSWDIF(JLON,JSG)=PGPAR(JLON,MSWDIF+JSG-1)
            ENDDO
          ENDDO
        ELSEIF (LRAY) THEN
          ZCARDI=QCO2
          DO JLON=KIDIA,KFDIA
            ZSFSWDIF(JLON,1) = ZFRSOFS(JLON)
            ZSFSWDIR(JLON,1) = PFRSOPS(JLON)
          ENDDO
        ENDIF

        DO JLON=KIDIA,KFDIA
          ZRHODREFM(JLON)=PAPRSF(JLON,KLEV)/(PT(JLON,KLEV)*PR(JLON,KLEV))
          ZDEPTH_HEIGHT_LOW(JLON)=(PAPHIF(JLON,KLEV)-PAPHI(JLON,KLEV))/RG
          ZZS(JLON)=PAPHI(JLON,KLEV)/RG
        ENDDO

        IRR=2
        LLD_NBLOCKTOT=.FALSE.

        CALL ARO_GROUND_PARAM( KBL, KGPCOMP, LLD_NBLOCKTOT, &
          & KFDIA-KIDIA+1, KIDIA, KFDIA, &
          & IRR, NSW, NGFL_EXT, LMPA, CCOUPLING, &
          & NINDAT, REAL(NSSSSS,JPRB), RSOVR, RCODEC, RSIDEC, &
          & PU(KIDIA:KFDIA,KLEV:KLEV),PV(KIDIA:KFDIA,KLEV:KLEV), &
          & PT(KIDIA:KFDIA,KLEV:KLEV),PQ(KIDIA:KFDIA,KLEV:KLEV),&
          & ZSVM(KIDIA:KFDIA,1:NGFL_EXT), &
          & ZCARDI, &
          & ZRHODREFM(KIDIA:KFDIA), &
          & PAPRSF(KIDIA:KFDIA,KLEV:KLEV),PAPRS(KIDIA:KFDIA,KLEV:KLEV), &
          & TSPHY,ZDEPTH_HEIGHT_LOW(KIDIA:KFDIA),ZZS(KIDIA:KFDIA),&
          & PMU0(KIDIA:KFDIA),PGELAM(KIDIA:KFDIA),PGEMU(KIDIA:KFDIA),XSW_BANDS,&
          & ZSRAIN(KIDIA:KFDIA),ZSSNOW(KIDIA:KFDIA), &
          & ZSGROUPEL(KIDIA:KFDIA), &
          & PFRTHDS(KIDIA:KFDIA),ZSFSWDIF(KIDIA:KFDIA,1:NSW), &
          & ZSFSWDIR(KIDIA:KFDIA,1:NSW),&
          & ZCFAQ(KIDIA:KFDIA,KLEV:KLEV), ZCFATH(KIDIA:KFDIA,KLEV:KLEV), &
          & ZCFAU(KIDIA:KFDIA,KLEV:KLEV), &
          & ZCFBQ(KIDIA:KFDIA,KLEV:KLEV), ZCFBTH(KIDIA:KFDIA,KLEV:KLEV), &
          & ZCFBU(KIDIA:KFDIA,KLEV:KLEV), & 
          & ZCFBV(KIDIA:KFDIA,KLEV:KLEV), &
          & PFCS(KIDIA:KFDIA,1),ZFEV(KIDIA:KFDIA), &
          & ZSFSV(KIDIA:KFDIA,1:NGFL_EXT),ZSFCO2(KIDIA:KFDIA), &
          & ZFMDU(KIDIA:KFDIA),ZFMDV(KIDIA:KFDIA), &
          & ZALBP(KIDIA:KFDIA,1:NSW),ZALBD(KIDIA:KFDIA,1:NSW), &
          & PEMIS(KIDIA:KFDIA),ZTSN(KIDIA:KFDIA))
      
        CALL ARO_GROUND_DIAG( KBL, KGPCOMP, LLD_NBLOCKTOT, &
          & KFDIA-KIDIA+1, KIDIA, KFDIA, &
          & ZZS(KIDIA:KFDIA), PU(KIDIA:KFDIA,KLEV), PV(KIDIA:KFDIA,KLEV), &
          & PQS(KIDIA:KFDIA), PGZ0(KIDIA:KFDIA), &
          & PGZ0H(KIDIA:KFDIA), PTCLS (KIDIA:KFDIA), &
          & PQCLS(KIDIA:KFDIA), PRHCLS(KIDIA:KFDIA), &
          & PUCLS(KIDIA:KFDIA), PVCLS(KIDIA:KFDIA), &
          & PFCLL(KIDIA:KFDIA,1), PFCLN(KIDIA:KFDIA,1))

        DO JLON=KIDIA,KFDIA
          PGPAR(JLON,MGZ0)   = PGZ0 (JLON)
          PGPAR(JLON,MGZ0H)  = PGZ0H(JLON)
          PGPAR(JLON,MVEMIS) = PEMIS(JLON)
          PGPAR(JLON,MVQS)   = PQS  (JLON)
        ENDDO 

        DO JLON=KIDIA,KFDIA
          DO JSG=1,NSW
            PGPAR(JLON,MALBSCA-1+JSG) = ZALBD(JLON,JSG)
            PGPAR(JLON,MALBDIR-1+JSG) = ZALBP(JLON,JSG)
          ENDDO
        ENDDO 

      ELSE

        IF(NDIFFNEB == 1) THEN
          ZNEBDIFF(:,:)=ZNEBS(:,:)
        ELSEIF(NDIFFNEB == 2) THEN
          ZNEBDIFF(:,:)=PNEB(:,:)
        ENDIF

        CALL ARP_GROUND_PARAM ( KIDIA,KFDIA,KLON,KTDIA,KLEV,KCSS,&
          & PAPHI,PCP,PFRSO,&
          & ZQV,PRDELP,PT,PU,PV,ZXURO,ZXQRO,ZXTRO,&
          & PAPRS,ZQL,ZQI,ZNEBDIFF,&
          & PCD,PCDN,ZCDROV,ZCHROV,ZCEROV,PCPS,PCT,ZDQSTS,PEMIS,PFHPS,&
          & ZHQ,ZHTR,ZHU,PHV,PLSM,PIVEG,PNEIJ,PQS,PQSATS,&
          & PTP,PTS,PVEG,ZXDROV,ZXHROV,PWS,PWSI,&
          & ZDSE,&
          & ZCFAS,ZCFAU,&
          & ZCFBS,ZCFBU,ZCFBV,&
          & ZCFBQ,ZCOEFA,ZALPHA1,ZLVT,ZQICE,&
          & ZDIFWQ,ZDIFWS,ZFMDU,ZFMDV,&  
          & PFCHSP,PFCLL,PFCLN,PFCS,PFEVI,PFEVL,PFEVN,&
          & PFEVV,PFTR,PLHS,&
          & PFRTH,&
          & PGZ0F,PGZ0HF,&
          & 'ARP_GROUND_PARAM') 

        DO JLON=KIDIA,KFDIA
          PDIFTQ(JLON,KLEV)=ZDIFWQ(JLON)
          PDIFTS(JLON,KLEV)=ZDIFWS(JLON)
        ENDDO
            
      ENDIF  !LMSE  

      CALL ACDIFV2 ( KIDIA,KFDIA,KLON,KTDIA,KLEV,&
        & PAPRS,ZCFAQ,ZCFAS,ZCFAU,ZCFBQ,ZCFBS,ZCFBU,ZCFBV,&
        & ZKTROV,ZKUROV,&
        & ZCOEFA,ZALPHA1,ZLVT,ZQICE,&
        & PFCS,ZFEV,ZFMDU,ZFMDV,ZTSN,ZXHROV,&
        & PDIFTQ,PDIFTS,PSTRTU,PSTRTV,PDIFTQL,PDIFTQI,&
        & 'ACDIFV2')   

      IF ( LMSE ) THEN
        DO JLON=KIDIA,KFDIA
          PGPAR(JLON,MVTS) = ZTSN (JLON)
        ENDDO 
      ENDIF 

    ENDIF

!-----------------------------------------------------------------------------
!   THE DEEP CONVECTION WILL SEE THE SHALLOW PART FROM KFB AS IT IS WITH LOUIS 
!   SCHEME AND THE MODIFIED RI (LCVGQKF=TRUE)
!----------------------------------------------------------------------------
    IF (LCVPPKF.AND.LCVGQKF) THEN
      DO JLEV=KTDIA,KLEV
        DO JLON=KIDIA,KFDIA
          PDIFTQ   (JLON,JLEV) = PDIFTQ(JLON,JLEV) + ZDIFCVPPQ(JLON,JLEV)
          PDIFTS   (JLON,JLEV) = PDIFTS(JLON,JLEV) + ZDIFCVPPS(JLON,JLEV)
          ZDIFCVPPQ(JLON,JLEV) = 0.0_JPRB
          ZDIFCVPPS(JLON,JLEV) = 0.0_JPRB
        ENDDO
      ENDDO
    ENDIF

    IF (L3MT) THEN

    ! ------------------------------------------------------------------
    ! UPDATE TEMPERATURE, LIQUID WATER AND ICE BY THE TURBULENT FLUXES
    ! INCLUDING CORRECTION OF NEGATIVE VALUES OF WATER SPECIES
    ! SAVE THE INCREMENTAL PART DUE TO THE TURBULENT DIFFUSION PROCESSES
    ! ------------------------------------------------------------------

!cdir unroll=8
    DO JLEV = KTDIA,KLEV
      DO JLON = KIDIA,KFDIA

        ZT(JLON,JLEV)=PT(JLON,JLEV)-ZIPOI(JLON,JLEV)/PCP(JLON,JLEV) &
         & *(PDIFTS(JLON,JLEV)-PDIFTS(JLON,JLEV-1))
        ZQX0=ZQI(JLON,JLEV)
        ZQX1=ZQX0-ZIPOI(JLON,JLEV)*(PDIFTQI(JLON,JLEV) &
          & -PDIFTQI(JLON,JLEV-1))
        ZQI(JLON,JLEV)=MAX(0.0_JPRB,ZQX1)
        ZDQI=MAX(0.0_JPRB,ZQX1)-ZQX1
        ZFCQING(JLON,JLEV)=ZFCQING(JLON,JLEV-1)-ZDQI*ZPOID(JLON,JLEV)
        PFCQING(JLON,JLEV)=PFCQING(JLON,JLEV)+ZFCQING(JLON,JLEV)
        ZQX0=ZQL(JLON,JLEV)
        ZQX1=ZQX0-ZIPOI(JLON,JLEV)*(PDIFTQL(JLON,JLEV) &
          & -PDIFTQL(JLON,JLEV-1))
        ZQL(JLON,JLEV)=MAX(0.0_JPRB,ZQX1)  
        ZDQL= MAX(0.0_JPRB,ZQX1)-ZQX1
        ZFCQLNG(JLON,JLEV)=ZFCQLNG(JLON,JLEV-1)-ZDQL*ZPOID(JLON,JLEV)
        PFCQLNG(JLON,JLEV)=PFCQLNG(JLON,JLEV)+ZFCQLNG(JLON,JLEV)
        ZDQC=ZDQI+ZDQL

        ZQX0=ZQV(JLON,JLEV)
        ZQX1=ZQX0-ZIPOI(JLON,JLEV)*(PDIFTQ(JLON,JLEV) &
          & -PDIFTQ(JLON,JLEV-1))
        ZQV0=ZQX1-ZIPOI(JLON,JLEV)*(0.0_JPRB &
          & -ZFCQVNG(JLON,JLEV-1)-ZFCQING(JLON,JLEV-1) &
          & -ZFCQLNG(JLON,JLEV-1))
        IF(LCVGQD) THEN
          ZQV(JLON,JLEV)=MAX(0.0_JPRB,ZQV0-ZDQC)
        ENDIF
        ZDQV=MAX(0.0_JPRB,ZQV0-ZDQC)-ZQX1
        ZFCQVNG(JLON,JLEV)=ZFCQVNG(JLON,JLEV-1)-ZDQV*ZPOID(JLON,JLEV)
        PFCQVNG(JLON,JLEV)=PFCQVNG(JLON,JLEV)+ZFCQVNG(JLON,JLEV)
      ENDDO
    ENDDO   

    ELSEIF (LSTRAPRO) THEN

    ! ------------------------------------------------------------------
    ! UPDATE THE CORRECTION FLUXES FOR NEGATIVE VALUES OF WATER SPECIES
    ! SAVE THE INCREMENTAL PART DUE TO THE TURBULENT DIFFUSION PROCESSES
    ! ------------------------------------------------------------------
    DO JLEV = KTDIA, KLEV
      DO JLON = KIDIA,KFDIA

        ZQX0=ZQI(JLON,JLEV)
        ZQX1=ZQX0-ZIPOI(JLON,JLEV)*(PDIFTQI(JLON,JLEV) &
          & -PDIFTQI(JLON,JLEV-1))
        ZDQI= MAX(0.0_JPRB,ZQX1)-ZQX1
        ZFCQING(JLON,JLEV)=ZFCQING(JLON,JLEV-1)-ZDQI*ZPOID(JLON,JLEV)
        PFCQING(JLON,JLEV)=PFCQING(JLON,JLEV)+ZFCQING(JLON,JLEV)
        ZQX0=ZQL(JLON,JLEV)
        ZQX1=ZQX0-ZIPOI(JLON,JLEV)*(PDIFTQL(JLON,JLEV) &
          & -PDIFTQL(JLON,JLEV-1))
        ZDQL= MAX(0.0_JPRB,ZQX1)-ZQX1
        ZFCQLNG(JLON,JLEV)=ZFCQLNG(JLON,JLEV-1)-ZDQL*ZPOID(JLON,JLEV)
        PFCQLNG(JLON,JLEV)=PFCQLNG(JLON,JLEV)+ZFCQLNG(JLON,JLEV)
        ZDQC=ZDQI+ZDQL

        ZQX0=ZQV(JLON,JLEV)
        ZQX1=ZQX0-ZIPOI(JLON,JLEV)*(PDIFTQ(JLON,JLEV) &
          & -PDIFTQ(JLON,JLEV-1))
        ZQV0=ZQX1-ZIPOI(JLON,JLEV)*(0.0_JPRB &
          & -ZFCQVNG(JLON,JLEV-1)-ZFCQING(JLON,JLEV-1) &
          & -ZFCQLNG(JLON,JLEV-1))
        ZDQV=MAX(0.0_JPRB,ZQV0-ZDQC)-ZQX1
        ZFCQVNG(JLON,JLEV)=ZFCQVNG(JLON,JLEV-1)-ZDQV*ZPOID(JLON,JLEV)
        PFCQVNG(JLON,JLEV)=PFCQVNG(JLON,JLEV)+ZFCQVNG(JLON,JLEV)

      ENDDO
    ENDDO   
    
    ENDIF ! 3MT || LSTRAPRO

    ! ------------------------------------------------------
    ! DIAGNOSTIC DE LA HAUTEUR DE COUCHE LIMITE, SELON TROEN ET MAHRT,
    ! POUR USAGE AU PAS DE TEMPS SUIVANT.
    ! ------------------------------------------------------

    IF((TRIM(CGMIXLEN) == 'TM').OR.(TRIM(CGMIXLEN) == 'TMC')) THEN
      ZBLH(:)=MIN(XMAXLM,MAX(XMINLM,PPBLH(:)))
      CALL ACPBLHTM ( KIDIA,KFDIA,KLON,NTDIFU,KLEV,&
       & PAPHI, PAPHIF, PDELP, PCP,&
       & ZQV, PT, PU, PV,PAPRSF,PR,&
       & PSTRTU, PSTRTV,&
       & ZPCLS, PTCLS,PQCLS,&
       & PFCS,PFCLL,PFCLN,PLHS, PGZ0, &
       & KCLPH,ZBLH,ZUGST,ZVGST,'ACPBLHTM' )  
      PPBLH(:)=ZBLH(:)
      PCLPH(:)=ZBLH(:)
      IF (.NOT.LRAFTUR) THEN
        PUGST(KIDIA:KFDIA)=ZUGST(KIDIA:KFDIA)
        PVGST(KIDIA:KFDIA)=ZVGST(KIDIA:KFDIA)
      ENDIF
    ENDIF

    IF(LNEBCO.AND.LNEBR)THEN
      DO JLON = KIDIA,KFDIA
        ZPREN(JLON)=PAPRS(JLON,KLEV)
      ENDDO
      CALL ACPBLH ( KIDIA,KFDIA,KLON,NTDIFU,KLEV,&
       & PAPHI, PAPHIF, PCP,&
       & ZQV, PT, PU, PV,PAPRSF,PR,&
       & PSTRTU, PSTRTV,&
       & ZPREN, PTS, PQS,&
       & PFCS,PFCLL,PFCLN,PLHS,ZRTI,PPBLH,'ACPBLH' )  
    ENDIF

  ENDIF ! LVDIF

!     DIAGNOSTIC SUPPLEMENTAIRE FLUX DE RAYONNEMENT (PFRTHDS ET PFRSOPT)
!     ADDITIONAL DIAGNOSTICS OF RADIATIVE FLUXES (PFRTHDS AND PFRSOPT)

  DO JLON=KIDIA,KFDIA
    IF(PMU0(JLON) <= 0.0_JPRB) THEN

!     NUIT : FLUX SOLAIRE NUL
!     NIGHT: SOLAR FLUX IS EQUAL TO ZERO

      PFRSOPT(JLON)=0.0_JPRB
    ELSE
      PFRSOPT(JLON)=RII0*PMU0(JLON)
    ENDIF
  ENDDO

! ADDITIONAL DIAGNOSTIC OF THE DERIVATIVE OF THE NON SOLAR SURFACE
! HEAT FLUX WITH RESPECT TO SURFACE TEMPERATURE (PDERNSHF)

  IF(LMCC03)THEN
    CALL ACDNSHF(KIDIA, KFDIA, KLON, KTDIA, KLEV,&
     & PEMIS, PLSM, PNEIJ, ZQV, PQS, PTS, ZCHROV,  ZDQSTS,&
     & PDERNSHF, 'ACDNSHF')  
  ENDIF

!*
!     ------------------------------------------------------------------
!     9.- TRAINEE DES ONDES DE GRAVITE INDUITES PAR LE RELIEF
!     ------------------------------------------------------------------
  IF ( LGWD ) THEN
    CALL ACDRAG ( KIDIA,KFDIA,KLON,NTDRAG,KLEV,&
     & PAPRS, PAPRSF,&
     & PDELP, ZNBVNO, PRDELP, PU, PV,&
     & PRCORI,PGETRL, ZGWDCS,&
     & PVRLAN , PVRLDI,&
     & PSTRDU, PSTRDV, 'ACDRAG ' )  
  ENDIF

!     ------------------------------------------------------------------
!     10.- PRECIPITATIONS STRATIFORMES.
!     ---------------------------------

  IF ( LSTRA.AND.(.NOT.LSTRAPRO) ) THEN
    CALL ACPLUIE ( KIDIA,KFDIA,KLON,NTPLUI,KLEV,&
     & PAPRS, PDELP,&
     & ZQV, PQW, PT,&
     & PFPFPSL,PFPFPSN,PFCSQL,PFCSQN,PFPEVPSL,PFPEVPSN,PFPLSL,PFPLSN,&  
     & 'ACPLUIE' )  
  ENDIF
  
  IF ( LSTRAS ) THEN
    CALL ACPLUIS ( KIDIA,KFDIA,KLON,NTPLUI,KLEV,&
     & PAPRSF,PDELP,ZNEBS,ZQV,ZQLIS,PQW,PR,PT,&
     & PFCSQL,PFCSQN,PFPLSL,PFPLSN,PFPEVPSL,PFPEVPSN,PFPFPSL,PFPFPSN,&
     & 'ACPLUIS' )
  ENDIF
  
  IF ( LCONDWT.AND.LPROCLD ) THEN
    CALL ACPLUIZ ( KIDIA,KFDIA,KLON,NTPLUI,KLEV,&
     &PT, ZQV, ZQL, ZQI, ZQR, ZQS,&
     &PDELP, PAPRSF, PCP, PR, ZNEBS, ZQLIS,&
     &PAPHI, PDIFTQ, PDIFTS,&
     &PTS, PNEIJ, PLSM, PGM, ZVETAF, &
     &PFCSQL, PFCSQN, PFPLSL, PFPLSN,&
     &PFPEVPSL, PFPEVPSN, PFPFPSL, PFPFPSN )
  ENDIF

  IF (L3MT.OR.LSTRAPRO) THEN

    CALL ACCDEV ( KIDIA,KFDIA,KLON,NTPLUI,KLEV,&
     & PAPRS,PAPRSF,PCP,PDELP,ZQV,ZQI,ZQL,ZQS,ZQR,PQW,PR,PT,ZNEBS,&
     & ZRHCRI,ZICEFR1,ZQSATS,ZNEBCH,PLSM,PNEIJ,PTS,&
     & PFPFPSL,PFPFPSN,PFCSQL,PFCSQN,PFPEVPSL,PFPEVPSN,PFPLSL,PFPLSN,&
     & 'ACCDEV')
  ENDIF

  IF (L3MT) THEN

    !
    !  ----------------------------------------------------------------
    !   UPDATE HUMIDITY VARIABLES BY RESOLVED CONDENSATION FLUXES
    !  ----------------------------------------------------------------
!cdir unroll=8
    DO JLEV=KTDIA,KLEV
      DO JLON=KIDIA,KFDIA
        ZDQL=ZIPOI(JLON,JLEV)* &
          & (PFCSQL(JLON,JLEV)-PFCSQL(JLON,JLEV-1))
        ZQL(JLON,JLEV)=ZQL(JLON,JLEV)+ZDQL  
        ZDQI=ZIPOI(JLON,JLEV)* &
          & (PFCSQN(JLON,JLEV)-PFCSQN(JLON,JLEV-1))
        ZQI(JLON,JLEV)=ZQI(JLON,JLEV)+ZDQI
        ZQV(JLON,JLEV)=ZQV(JLON,JLEV)-ZDQI-ZDQL

        ZT(JLON,JLEV)=ZT(JLON,JLEV)+(ZLHV(JLON,JLEV)*ZDQL &
                   & +ZLHS(JLON,JLEV)*ZDQI)/PCP(JLON,JLEV)
      ENDDO
    ENDDO

  ENDIF ! L3MT

!     11.- PRECIPITATIONS SOUS-MAILLES.
!     ---------------------------------

  IF (LVDIF.AND.(LCVRA.OR.L3MT.OR.LCVRAV3)) THEN
!           LA TENDANCE DYNAMIQUE DE Q EST MULTIPLIEE PAR UN
!           FACTEUR CORRECTIF FONCTION DE LA RESOLUTION LOCALE
!           DU MODELE PUIS AUGMENTEE DE LA CONTRIBUTION
!           DE L EVAPORATION DU SOL.
    IF(.NOT.LCVGQD) THEN
!cdir unroll=8
      DO JLEV = KTDIA, KLEV
        DO JLON = KIDIA, KFDIA
          PCVGQ(JLON,JLEV) = PCVGQ(JLON,JLEV)&
           & /(1.0_JPRB+PGM(JLON)*TEQK)**GCOMOD &
           & -RG*PRDELP(JLON,JLEV)&
           & *(PDIFTQ(JLON,JLEV)-PDIFTQ(JLON,JLEV-1)&
           & +ZFCQVNG(JLON,JLEV)-ZFCQVNG(JLON,JLEV-1))
        ENDDO
      ENDDO
    ENDIF
    IF (LCAPE) THEN
      DO JLON = KIDIA, KFDIA
        ZTAUX(JLON)=RTCAPE*(PGM(JLON)*TEQC)**GCOMOD
      ENDDO
    ENDIF
  ENDIF


  IF (L3MT) THEN
    ! - TEMPORAIRES
    ! ZSIGPC: PROGNOSTIC CONVECTIVE PRECIPITATBLE AREA, USED FOR A POSTERIORI 
    ZSIGPC=0.0_JPRB
    ZSIGP=1.0_JPRB  ! used to limit dd area
  IF (LCVPRO) THEN
  !  -------------------------
  !  UPDRAUGHT CONTRIBUTION
  !  -------------------------

    CALL ACTQSATS ( KIDIA,KFDIA,KLON,NTQSAT,KLEV,&
     & PAPRSF, PCP, ZQV, ZT,&
     & ZGEOSLC, ZLH, ZLSCPE, ZQSAT, ZQW, ZRH, ZTW,&
     & 'ACTQSATS' )

    CALL ACCVUD ( KIDIA,KFDIA,KLON,KTDIA,KLEV,&
     & PALPH, PAPHI, PAPHIF, PAPRS, PAPRSF, PCP,PR,&
     & PCVGQ, PDELP, PLNPR,&
     & ZQV, ZQI, ZQL, ZQSAT, ZQW,&
     & PRDELP, ZT, ZTW, PU, PV, PVORT0,&
     & PDDAL, PDDOM,&
     & PQS, PTS, ZTAUX, PRCORI,&
     & PDIFCQ, PDIFCQL, PDIFCQI, PDIFCS,&
     & PFCCQL, PFCCQN, PSTRCU, PSTRCV, ZATSLC,&
     & INLAB, PUNEBH, ZDETFI, ZTU, ZQU, ZUU, ZVU,&
     & INND,PCAPE, &
     & ZGEOSLC, PENTCH, PUDAL, PUDOM, &
     & 'ACCVUD' )

    ! Initialize temperature correction
    ZTCORR(:,:)=ZTU(:,:)-ZT(:,:)
    ! Initialize Environment horizontal velocity
    ZU(KIDIA:KFDIA,:)=PU(KIDIA:KFDIA,:)
    ZV(KIDIA:KFDIA,:)=PV(KIDIA:KFDIA,:)
    !  ------------------------------------------- 
    !  UPDATE VARIABLES BY UPDRAUGHT CONTRIBUTION
    !  -------------------------------------------
!cdir unroll=8
    DO JLEV=KTDIA,KLEV
      DO JLON=KIDIA,KFDIA
        ZDQIT=ZIPOI(JLON,JLEV)*(0.0_JPRB & 
          & -(PFCCQN(JLON,JLEV)-PFCCQN(JLON,JLEV-1)) )
        ZQX0=ZQI(JLON,JLEV)
        ZQX1=ZQX0-ZDQIT-ZIPOI(JLON,JLEV)* &
          &  (PDIFCQI(JLON,JLEV)-PDIFCQI(JLON,JLEV-1)) 
        ZQI(JLON,JLEV)=MAX(0.0_JPRB,ZQX1)  
        ZDQI=MAX(0.0_JPRB,ZQX1)-ZQX1
        ZFCQING(JLON,JLEV)=ZFCQING(JLON,JLEV-1)-ZDQI*ZPOID(JLON,JLEV)
        PFCQING(JLON,JLEV)=PFCQING(JLON,JLEV)+ZFCQING(JLON,JLEV)

        ZDQLT=ZIPOI(JLON,JLEV)*(0.0_JPRB &
           & -(PFCCQL(JLON,JLEV)-PFCCQL(JLON,JLEV-1)) )
        ZQX0=ZQL(JLON,JLEV)
        ZQX1=ZQX0-ZDQLT-ZIPOI(JLON,JLEV)* &
          &  (PDIFCQL(JLON,JLEV)-PDIFCQL(JLON,JLEV-1)) 
        ZQL(JLON,JLEV)=MAX(0.0_JPRB,ZQX1)
        ZDQL=MAX(0.0_JPRB,ZQX1)-ZQX1
        ZFCQLNG(JLON,JLEV)=ZFCQLNG(JLON,JLEV-1)-ZDQL*ZPOID(JLON,JLEV)
        PFCQLNG(JLON,JLEV)=PFCQLNG(JLON,JLEV)+ZFCQLNG(JLON,JLEV)
        ZDQC=ZDQI+ZDQL

        ZQX0=ZQV(JLON,JLEV)
        ZQX1=ZQX0-ZIPOI(JLON,JLEV)*( &
          &  (PDIFCQ(JLON,JLEV)-PDIFCQ(JLON,JLEV-1)) &  
          & +(PFCCQN(JLON,JLEV)-PFCCQN(JLON,JLEV-1)) &
          & +(PFCCQL(JLON,JLEV)-PFCCQL(JLON,JLEV-1)) )
        ZQV0=ZQX1-ZIPOI(JLON,JLEV)*(0.0_JPRB &
          & -ZFCQVNG(JLON,JLEV-1)-ZFCQING(JLON,JLEV-1) &
          & -ZFCQLNG(JLON,JLEV-1))
        ZQV(JLON,JLEV)=MAX(0.0_JPRB,ZQV0-ZDQC)
        ZDQV=MAX(0.0_JPRB,ZQV0-ZDQC)-ZQX1
        ZFCQVNG(JLON,JLEV)=ZFCQVNG(JLON,JLEV-1)-ZDQV*ZPOID(JLON,JLEV)
        PFCQVNG(JLON,JLEV)=PFCQVNG(JLON,JLEV)+ZFCQVNG(JLON,JLEV)

        ZT(JLON,JLEV)=ZT(JLON,JLEV)-(ZIPOI(JLON,JLEV)* &
          &  (PDIFCS(JLON,JLEV)-PDIFCS(JLON,JLEV-1)) &
          &  +ZLHS(JLON,JLEV)*ZDQIT+ZLHV(JLON,JLEV)*ZDQLT)/PCP(JLON,JLEV)
       ENDDO
    ENDDO

    CALL ACUPU(KIDIA,KFDIA,KLON,KTDIA,KLEV,&
                & PUDAL,PUNEBH,ZDETFI,&
                & PFCCQL,PFCCQN,PFCSQL,PFCSQN,&
! output  1d .
               & ZSIGP, ZSIGPC,&
!input/output  2d .
               & ZNEBS, &
               & 'ACUPU')

  ENDIF !LCVPRO


  !  ---------------------------------------------------------
  !  MICROPHYSICS (AUTOCONVERSION, COLLECTION AND EVAPORATION)
  !        OF TOTAL CONDENSATE (RESOLVED + SUB-GRID)
  !  ---------------------------------------------------------
  !
    ZAUXPRC(:)=0._JPRB
    ZRCVOTT(:,:)=0._JPRB

    DO JLEV=KTDIA,KLEV
      DO JLON=KIDIA,KFDIA

    !    COMPUTE TOTAL CONDENSATION FLUX
    !    ------------------------------- 
        ZFCQL(JLON,JLEV)=PFCSQL(JLON,JLEV)+PFCCQL(JLON,JLEV)
        ZFCQI(JLON,JLEV)=PFCSQN(JLON,JLEV)+PFCCQN(JLON,JLEV)
        ZCONVC=MAX(0.0_JPRB, PFCCQL(JLON,JLEV)+PFCCQN(JLON,JLEV))
        ZAUXPRC(JLON)=ZAUXPRC(JLON)+&
       & MAX(0.0_JPRB,PFCSQL(JLON,JLEV)+PFCSQN(JLON,JLEV)&
       & -PFCSQL(JLON,JLEV-1)-PFCSQN(JLON,JLEV-1))
        ZTOTC=ZCONVC+ZAUXPRC(JLON)
        IF (LRCVOTT) THEN
          ZRCVOTT(JLON,JLEV)=MAX(0.0_JPRB,SIGN(1.0_JPRB,ZTOTC-ZEPS0))&
         & *ZCONVC/MAX(ZTOTC,ZEPS0)
        ENDIF
      ENDDO
    ENDDO

    CALL ACTQSATS ( KIDIA,KFDIA,KLON,NTQSAT,KLEV,&
     & PAPRSF, PCP, ZQV, ZT,&
     & ZGEOSLC, ZLH, ZLSCPE, ZQSAT, ZQW, ZRH, ZTW,&
     & 'ACTQSATS' )

    DO JLEV=KTDIA,KLEV
      DO JLON=KIDIA,KFDIA
        ZDQ(JLON,JLEV)=ZQW(JLON,JLEV) &
        &  -(ZQV(JLON,JLEV)+ZQI(JLON,JLEV)+ZQL(JLON,JLEV))
        ZDQM(JLON,JLEV)=ZQW(JLON,JLEV)
      ENDDO
    ENDDO

    CALL APLMPHYS( KIDIA,KFDIA,KLON,KTDIA,KLEV,&
     & PAPRS, PAPRSF, PCP, ZQV, ZQI, ZQL, ZQS, ZQR, PR, ZT,&
     & ZIPOI, ZDQ, ZDQM, ZLHS, ZLHV, ZNEBS, ZPOID, ZRCVOTT,&
     & ZTCORR,PLSM, PNEIJ, PTS,&
     & ZFCQL, ZFCQI,& 
     & ZFALLR, ZFALLS,& 
     & PFPFPSL,PFPFPSN, PFPEVPSL, PFPEVPSN, PFPLSL, PFPLSN,&
     & ZMELNET,&
     & 'APLMPHYS') 
     
  ! ---------------------------------------------- 
  !  UPDATE VARIABLES BY MICROPHYSICS CONTRIBUTION
  ! ----------------------------------------------

!cdir unroll=8
    DO JLEV=KTDIA,KLEV
      DO JLON=KIDIA,KFDIA
        ZQX1=ZQR(JLON,JLEV)-ZIPOI(JLON,JLEV)*(0.0_JPRB &
          & -(PFPFPSL(JLON,JLEV) - PFPFPSL(JLON,JLEV-1)) &
          & +(PFPLSL(JLON,JLEV) - PFPLSL(JLON,JLEV-1)) &
          & +(PFPEVPSL(JLON,JLEV)-PFPEVPSL(JLON,JLEV-1)) ) 
        ZQR(JLON,JLEV)=MAX(0.0_JPRB,ZQX1)  
        ZDQR=MAX(0.0_JPRB,ZQX1)-ZQX1
        ZFCQRNG(JLON,JLEV)=ZFCQRNG(JLON,JLEV-1)-ZDQR*ZPOID(JLON,JLEV)
        PFCQRNG(JLON,JLEV)=PFCQRNG(JLON,JLEV)+ZFCQRNG(JLON,JLEV)
        ZQX1=ZQS(JLON,JLEV)-ZIPOI(JLON,JLEV)*(0.0_JPRB  &
          & -(PFPFPSN(JLON,JLEV) - PFPFPSN(JLON,JLEV-1)) &
          & +(PFPLSN(JLON,JLEV) - PFPLSN(JLON,JLEV-1)) &
          & +(PFPEVPSN(JLON,JLEV)-PFPEVPSN(JLON,JLEV-1)) )
        ZQS(JLON,JLEV)=MAX(0.0_JPRB,ZQX1)
        ZDQS=MAX(0.0_JPRB,ZQX1)-ZQX1
        ZFCQSNG(JLON,JLEV)=ZFCQSNG(JLON,JLEV-1)-ZDQS*ZPOID(JLON,JLEV)
        PFCQSNG(JLON,JLEV)=PFCQSNG(JLON,JLEV)+ZFCQSNG(JLON,JLEV)
        ZDQC=ZDQR+ZDQS

        ZDFCQL=ZFCQL(JLON,JLEV)-ZFCQL(JLON,JLEV-1)  &
          & - PFCSQL(JLON,JLEV)+PFCSQL(JLON,JLEV-1) &
          & - PFCCQL(JLON,JLEV)+PFCCQL(JLON,JLEV-1) 
        ZFCQLDM(JLON,JLEV)=ZFCQLDM(JLON,JLEV-1)+ZDFCQL
        ZDFCQI=ZFCQI(JLON,JLEV)-ZFCQI(JLON,JLEV-1)  &
          & - PFCSQN(JLON,JLEV)+PFCSQN(JLON,JLEV-1) & 
          & - PFCCQN(JLON,JLEV)+PFCCQN(JLON,JLEV-1)
        ZFCQIDM(JLON,JLEV)=ZFCQIDM(JLON,JLEV-1)+ZDFCQI
        ZQX1=ZQV(JLON,JLEV)-ZIPOI(JLON,JLEV)*(0.0_JPRB  &
          & -(PFPEVPSL(JLON,JLEV)-PFPEVPSL(JLON,JLEV-1)) &
          & -(PFPEVPSN(JLON,JLEV)-PFPEVPSN(JLON,JLEV-1)) & 
          & +(ZDFCQL+ZDFCQI) ) 
        ZQV0=ZQX1-ZIPOI(JLON,JLEV)*(0.0_JPRB &
          & -ZFCQVNG(JLON,JLEV-1)-ZFCQRNG(JLON,JLEV-1) &
          & -ZFCQSNG(JLON,JLEV-1))
        ZQV(JLON,JLEV)=MAX(0.0_JPRB,ZQV0-ZDQC)  
        ZDQV=MAX(0.0_JPRB,ZQV0-ZDQC)-ZQX1
        ZFCQVNG(JLON,JLEV)=ZFCQVNG(JLON,JLEV-1)-ZDQV*ZPOID(JLON,JLEV)
        PFCQVNG(JLON,JLEV)= PFCQVNG(JLON,JLEV)+ZFCQVNG(JLON,JLEV)

        ZQL(JLON,JLEV)=ZQL(JLON,JLEV)-ZIPOI(JLON,JLEV)*( &
          & (PFPFPSL(JLON,JLEV)-PFPFPSL(JLON,JLEV-1)) &
          & -ZDFCQL )
        ZQI(JLON,JLEV)=ZQI(JLON,JLEV)-ZIPOI(JLON,JLEV)*( &
          & (PFPFPSN(JLON,JLEV)-PFPFPSN(JLON,JLEV-1)) &
          & -ZDFCQI )

        ZT(JLON,JLEV)=ZT(JLON,JLEV)-ZIPOI(JLON,JLEV)/PCP(JLON,JLEV) &
         & *(0.0_JPRB-ZLHV(JLON,JLEV)*ZDFCQL-ZLHS(JLON,JLEV)*ZDFCQI)

      ENDDO
    ENDDO

    !   STRATIFORM CORRECTION OF THE TOTAL CONDENSATION FLUX
    !   ------------------------------------

    DO JLEV=KTDIA,KLEV
      DO JLON=KIDIA,KFDIA
        PFCSQL(JLON,JLEV)=PFCSQL(JLON,JLEV)+ZFCQLDM(JLON,JLEV)
        PFCSQN(JLON,JLEV)=PFCSQN(JLON,JLEV)+ZFCQIDM(JLON,JLEV)
      ENDDO
    ENDDO

    !  ------------------------------------------------------------
    !   COMPUTE THE TEMPERATURE HEAT FLUX FOR DOWNDRAUGHT CLOSURE
    !   AND OTHER 3MT SPECIFIC STUFF
    !  ------------------------------------------------------------

   CALL ACUPM( KIDIA,KFDIA,KLON,KTDIA,KLEV,&
              & PCP, ZLHS, ZLHV,&
              & PEVEL0, ZIPOI, ZPOID, &
              & ZQU,ZTU, ZUU, ZVU, PUDAL, PUDOM,&
              & PFPEVPSL,PFPEVPSN,&
! output 2D
              & ZOME, ZFHP,&
! input/output  2d .
              & ZQV,ZQW,ZT,ZTW, ZU, ZV,&
              & 'ACUPM')


  IF (LCDDPRO) THEN
  !  -------------------------
  !  DOWNDRAUGHT CONTRIBUTION
  !  -------------------------

    ZDIFCQD(:,:)=0.0_JPRB
    ZDIFCQLD(:,:)=0.0_JPRB
    ZDIFCQID(:,:)=0.0_JPRB
    ZDIFCSD(:,:)=0.0_JPRB
    ZSTRCUD(:,:)=0.0_JPRB
    ZSTRCVD(:,:)=0.0_JPRB

    CALL ACTQSATS ( KIDIA,KFDIA,KLON,NTQSAT,KLEV,&
     & PAPRSF, PCP, ZQV, ZT,&
     & ZGEOSLC, ZLH, ZLSCPE, ZQSAT, ZQW, ZRH, ZTW,&
     & 'ACTQSATS' )
    
    CALL ACMODO(KIDIA,KFDIA,KLON,KTDIA,KLEV,&
     & PALPH,PAPHI,PAPHIF,PAPRS,PAPRSF,PCP,&
     & PDELP,PLNPR,ZQV,ZQI,ZQL,ZQW,&
     & PR,PRDELP,ZSIGP,ZT,PTS,ZTW,ZU,ZV,PEVEL0,ZOME,&
     & ZATSLC,ZGEOSLC,ZFHP,&
     & PFPLSL,PFPLSN,&
     & ZDIFCQD,ZDIFCQLD,ZDIFCQID,ZDIFCSD,&
     & PFPEVPCL,PFPEVPCN,&
     & ZSTRCUD,ZSTRCVD,&
     & PDDAL,PDDOM,&
     & 'ACMODO')

  !  ---------------------------------------------
  !  UPDATE VARIABLES  BY DOWNDRAUGHT CONTRIBUTION
  !  ---------------------------------------------
  !

    DO JLEV=KTDIA,KLEV
      DO JLON=KIDIA,KFDIA

    !   UPDATE CONVECTIVE DIFFUSION AND EVAPORATION FLUXES 
    !   --------------------------------------------------

        PDIFCS(JLON,JLEV) =PDIFCS(JLON,JLEV) +ZDIFCSD(JLON,JLEV)
        PDIFCQ(JLON,JLEV) =PDIFCQ(JLON,JLEV) +ZDIFCQD(JLON,JLEV)
        PDIFCQL(JLON,JLEV)=PDIFCQL(JLON,JLEV)+ZDIFCQLD(JLON,JLEV)
        PDIFCQI(JLON,JLEV)=PDIFCQI(JLON,JLEV)+ZDIFCQID(JLON,JLEV)
        PSTRCU(JLON,JLEV)=PSTRCU(JLON,JLEV)+ZSTRCUD(JLON,JLEV)
        PSTRCV(JLON,JLEV)=PSTRCV(JLON,JLEV)+ZSTRCVD(JLON,JLEV)
        PFPLSL(JLON,JLEV)=PFPLSL(JLON,JLEV)-PFPEVPCL(JLON,JLEV)
        PFPLSN(JLON,JLEV)=PFPLSN(JLON,JLEV)-PFPEVPCN(JLON,JLEV)
      ENDDO
    ENDDO  
    CALL ACUPD(KIDIA,KFDIA,KLON,KTDIA,KLEV,&
! input  2d .
     & PAPRSF,PCP,ZLHS,ZLHV,PR,&
     & ZIPOI,ZPOID,&
     & ZFALLR,ZFALLS,&
     & ZQU,ZTU,PUDAL,&   
! input/output  2d .
     & ZQV,ZT,&
     & PFPLSL,PFPLSN,PFPEVPCL,PFPEVPCN,&
! lock arguments .
     & 'ACUPD')

!cdir unroll=8
    DO JLEV=KTDIA,KLEV
      DO JLON=KIDIA,KFDIA


    !   UPDATE NEGATIVE VALUES CORRECTION FLUXES     
    !   ----------------------------------------
        ZQX1=ZQI(JLON,JLEV)-ZIPOI(JLON,JLEV)* &
          & (ZDIFCQID(JLON,JLEV)-ZDIFCQID(JLON,JLEV-1)) 
        ZDQI=MAX(0.0_JPRB,ZQX1)-ZQX1
        ZFCQING(JLON,JLEV)=ZFCQING(JLON,JLEV-1)-ZDQI*ZPOID(JLON,JLEV)
        PFCQING(JLON,JLEV)=PFCQING(JLON,JLEV)+ZFCQING(JLON,JLEV)
        ZQX1=ZQL(JLON,JLEV)-ZIPOI(JLON,JLEV)* &
          & (ZDIFCQLD(JLON,JLEV)-ZDIFCQLD(JLON,JLEV-1))
        ZDQL=MAX(0.0_JPRB,ZQX1)-ZQX1
        ZFCQLNG(JLON,JLEV)=ZFCQLNG(JLON,JLEV-1)-ZDQL*ZPOID(JLON,JLEV)
        PFCQLNG(JLON,JLEV)=PFCQLNG(JLON,JLEV)+ZFCQLNG(JLON,JLEV)
        ZDQC=ZDQI+ZDQL

        ZQX0=ZQV(JLON,JLEV)
        ZQX1=ZQV(JLON,JLEV)-ZIPOI(JLON,JLEV)* (&
          &  (ZDIFCQD(JLON,JLEV)-ZDIFCQD(JLON,JLEV-1)) &
          & -(PFPEVPCL(JLON,JLEV)-PFPEVPCL(JLON,JLEV-1)) &
          & -(PFPEVPCN(JLON,JLEV)-PFPEVPCN(JLON,JLEV-1)) )
        ZQV0=ZQX1-ZIPOI(JLON,JLEV)*(0.0_JPRB-ZFCQVNG(JLON,JLEV-1) &
          & -ZFCQLNG(JLON,JLEV-1)-ZFCQING(JLON,JLEV-1) )
        ZDQV=MAX(0.0_JPRB,ZQV0-ZDQC)-ZQX1
        ZFCQVNG(JLON,JLEV)=ZFCQVNG(JLON,JLEV-1)-ZDQV*ZPOID(JLON,JLEV)
        PFCQVNG(JLON,JLEV)=PFCQVNG(JLON,JLEV)+ZFCQVNG(JLON,JLEV)
      ENDDO
    ENDDO

  !  PARTITION CONVECTIVE/STRATIFORM PRECIPITATION
  ! ---------------------------------------------
    DO JLEV=KTDIA-1,KLEV
      DO JLON=KIDIA, KFDIA
         PFPLCL(JLON,JLEV)=ZSIGPC(JLON)*PFPLSL(JLON,JLEV)
         PFPLSL(JLON,JLEV)=PFPLSL(JLON,JLEV)-PFPLCL(JLON,JLEV)
         PFPLCN(JLON,JLEV)=ZSIGPC(JLON)*PFPLSN(JLON,JLEV)
         PFPLSN(JLON,JLEV)=PFPLSN(JLON,JLEV)-PFPLCN(JLON,JLEV)
      ENDDO
    ENDDO
     
  ENDIF ! LCDDPRO

  ENDIF ! L3MT

! -----------------------------------------------------

  IF ( LCVRA ) THEN

    IF (LSTRAPRO) THEN
      DO JLEV = KTDIA-1, KLEV
        DO JLON = KIDIA, KFDIA
          PDIFTQ(JLON,JLEV)=PDIFTQ(JLON,JLEV)+ZFCQVNG(JLON,JLEV)
        ENDDO
      ENDDO
    ENDIF

    CALL ACCVIMP ( KIDIA,KFDIA,KLON,NTCVIM,KLEV,&
     & PALPH, PAPHI, PAPHIF, PAPRS, PAPRSF, PCP, PCVGQ, PDELP,&
     & PLNPR, ZQV, PQSAT, PQW, PR, PRDELP, PT, PTW, PU, PV, PVORT0,&
     & PQS, PTS, ZTAUX, PRCORI,&
     & PDIFCQ, PDIFCS, PFCCQL, PFCCQN, PFPLCL, PFPLCN, PFPFPCL, PFPFPCN,&
     & PFPEVPCL, PFPEVPCN, PSTRCU, PSTRCV, ZFPCOR, INLAB, PCAPE, INND,&
     & PDIFTQ, PDIFTS, ZGEOSLC, 'ACCVIMP' )  

    IF (LSTRAPRO) THEN
      DO JLEV = KTDIA-1, KLEV
        DO JLON = KIDIA, KFDIA
          PDIFTQ(JLON,JLEV)=PDIFTQ(JLON,JLEV)-ZFCQVNG(JLON,JLEV)
        ENDDO
      ENDDO
    ENDIF

  ELSEIF (LCVRAV3) THEN

    CALL ACCVIMP_V3 (KIDIA,KFDIA,KLON,NTCVIM,KLEV,&
     & PALPH, PAPHI, PAPHIF, PAPRS, PAPRSF, PCP, PCVGQ, PDELP,&
     & PLNPR, ZQV, PQW, PR, PRDELP, PT, PTW, PU, PV,&
     & PQS, PTS, PPBLH,&
     & PDIFCQ, PDIFCS, PFCCQL, PFCCQN, PFPLCL, PFPLCN, PFPFPCL, PFPFPCN,&
     & PFPEVPCL, PFPEVPCN, PSTRCU, PSTRCV, INLAB, INND,&
     & PDIFTQ, PDIFTS,&
     & 'ACCVIMP' )  

  ENDIF

  IF (LCVPPKF.AND.(.NOT.LCVGQKF)) THEN
    DO JLEV=KTDIA-1,KLEV
      DO JLON=KIDIA,KFDIA
        PDIFTQ   (JLON,JLEV) = PDIFTQ(JLON,JLEV) + ZDIFCVPPQ(JLON,JLEV)
        PDIFTS   (JLON,JLEV) = PDIFTS(JLON,JLEV) + ZDIFCVPPS(JLON,JLEV)
        ZDIFCVPPQ(JLON,JLEV) = 0.0_JPRB
        ZDIFCVPPS(JLON,JLEV) = 0.0_JPRB
      ENDDO
    ENDDO
  ENDIF

  IF ( LNEBCO ) THEN
    CALL ACNEBC ( KIDIA,KFDIA,KLON,NTNEBU,KLEV,&
     & PFPLCL,PFPLCN,INLAB,&
     & INND,&
     & PTCCH,PSCCH,PBCCH,'ACNEBC ')
  ENDIF
  IF ( LGWDC ) THEN
    CALL ACDRAC ( KIDIA,KFDIA,KLON,NTDRAG,KLEV,&
     & PAPRS, ZNBVNO, PRDELP, PU, PV,&
     & PFPLCL, PFPLCN, PSCCH, PBCCH,&
     & PSTRCU, PSTRCV, 'ACDRAC ' )
  ENDIF

!*
!     ------------------------------------------------------------------
!         SAUVEGARDE DES FLUX DE PRECIPITATION CONVECTIVE ET STRATIFORME.

  IF(LNEBN.OR.LNEBR.OR.LRRGUST) THEN
    IF (LFPCOR) THEN
      IF (LCDDPRO) THEN
        DO JLEV=KTDIA-1,KLEV
          DO JLON=KIDIA,KFDIA
            PFPLCH(JLON,JLEV)=PFPLCL(JLON,JLEV)+PFPLCN(JLON,JLEV)
          ENDDO
        ENDDO
      ELSE
        DO JLEV=KTDIA-1,KLEV
          DO JLON=KIDIA,KFDIA
            PFPLCH(JLON,JLEV)=ZFPCOR(JLON,JLEV)
          ENDDO
        ENDDO
      ENDIF
    ELSE
      DO JLEV=KTDIA-1,KLEV
        DO JLON=KIDIA,KFDIA
          PFPLCH(JLON,JLEV)=PFPLCL(JLON,JLEV)+PFPLCN(JLON,JLEV)
        ENDDO
      ENDDO
    ENDIF
  ENDIF

  IF(LRRGUST) THEN
    DO JLEV=KTDIA-1,KLEV
      DO JLON=KIDIA,KFDIA
        PFPLSH(JLON,JLEV)=PFPLSL(JLON,JLEV)+PFPLSN(JLON,JLEV)
      ENDDO
    ENDDO
  ENDIF

  ! - - - - - - - - - - - - - - - - -
  ! CORRECT NEGATIVE WATER CONTENTS.
  ! - - - - - - - - - - - - - - - - -

  IF ( LCONDWT.AND.LPROCLD ) THEN
     CALL QNGCOR (KIDIA, KFDIA, KLON, NTPLUI, KLEV,&
                 &ZQV, ZQL, ZQI, PRDELP,&
                 &PDIFCQ, PDIFCQI, PDIFCQL, PDIFTQ, PDIFTQI, PDIFTQL,&
                 &PFPEVPSL, PFPEVPSN, PFPEVPCL, PFPEVPCN,&
                 &PFPFPSL, PFPFPSN, PFPFPCL, PFPFPCN,&
                 &PFCCQL, PFCCQN, PFCSQL, PFCSQN, PFCQVNG )
  ENDIF

!*
!     ------------------------------------------------------------------
!     12. - BILAN HYDRIQUE DU SOL
!     ---------------------------
  IF ( LMSE ) THEN
    DO JLON=KIDIA,KFDIA
      PGPAR(JLON,MRAIN) = PFPLSL(JLON,KLEV)+PFPLCL(JLON,KLEV)
      PGPAR(JLON,MSNOW) = PFPLSN(JLON,KLEV)+PFPLCN(JLON,KLEV)
    ENDDO

  ELSE

  IF ( LSFHYD ) THEN
    IF ( LSOLV ) THEN
      CALL ACDROV ( KIDIA,KFDIA,KLON,KTDIA,KLEV,KCSS,&
       & PFPLCL, PFPLCN, PFPLSL, PFPLSN, PFRSO, PFRTH,&
       & PC1, PC2, ZC3, ZCN, PCT, PD2, PFEVV, PFTR, PLAI, PNEIJ,&
       & PVEG, ZWFC, ZWPMX, PWL, ZWLMX, ZWSEQ, ZWSMX,&
       & PFCHSP, PFCLL, PFCLN, PFCS, PFEVI, PFEVL, PFEVN, PLSM, PSNS,&
       & PTP, PTS, PWP, PWPI, PWS, PWSI,&
       & PFGEL, PFGELS,&
       & PFLWSP, PFONTE, PRUISP, PRUISL, PRUISS,'ACDROV ' )  
    ENDIF
  ENDIF

  ENDIF

!*
!-  --------------------------------------------------------------------
!     13.- DRAG MESOSPHERIQUE POUR UN MODELE POSSEDANT DES NIVEAUX
!               AU-DESSUS DE 50 KM (I.E. DANS LA MESOSPHERE)
!     ------------------------------------------------------------------
  IF ( LRRMES ) THEN
    CALL ACDRME ( KIDIA,KFDIA,KLON,NTDRME,KLEV,&
     & PCP,PDELP,PT,ZQV,PU,PV,&
     & PFRMH,PFRMQ,PSTRMU,PSTRMV,&
     & RMESOT,RMESOQ,RMESOU,STTEM,'ACDRME ')
  ENDIF

!*
!     ------------------------------------------------------------------
!     14.- FLUX PHOTO-CHIMIQUE D'OZONE
!     ------------------------------------------------------------------
  IF ( LOZONE ) THEN
    CALL ACOZONE ( KIDIA,KFDIA,KLON,NTOZON,KLEV,KVCLIS,&
     & PAPRS,PAPRSF,PDELP,PKOZO,ZQO3(1,1),PT,PMU0,&
     & PFCHOZ,'ACOZONE')  

!           DIFFUSION TURBULENTE/DEPOT SEC DE L'OZONE

    CALL ACDIFOZ ( KIDIA,KFDIA,KLON,KTDIA,KLEV,&
     & PAPRSF,PDELP,PFPLCL,PFPLSL,PFRSO,&
     & ZKTROV,ZQO3(1,1),PRDELP,PT,ZXTROV,&
     & PNEIJ,PGEMU,PIVEG,&
     & PFCHOZ,'ACDIFOZ')  
  ENDIF
!*
!     ------------------------------------------------------------------
!     15.- CALCUL DES FLUX D'ENTHALPIE ET DE CHALEUR SENSIBLE LIES AUX
!          PRECIPITATIONS EN FONCTION DES FLUX DE PRECIPITATION
!          ET DE CONDENSATION.
!     ------------------------------------------------------------------

  ! STORE THE PSEUDO-HISTORIC SURFACE PRECIPITATION SENSIBLE HEAT FLUX
  ! -------------------------------------------------------------------

  IF (LPHSPSH) THEN
    DO JLON=KIDIA, KFDIA
       PFHPS(JLON)=(PT(JLON,KLEV)-PTS(JLON)) * &
         &  ((RCW-RCPD)*(PFPLSL(JLON,KLEV)+PFPLCL(JLON,KLEV)) &
         &  +(RCS-RCPD)*(PFPLSN(JLON,KLEV)+PFPLCN(JLON,KLEV)) )
    ENDDO
  ENDIF !LPHSPSH

ENDIF

!     ------------------------------------------------------------------

! Deallocate SURFEX Variables
DEALLOCATE(ZSVM )
DEALLOCATE(ZSFSV)

IF (LHOOK) CALL DR_HOOK('APLPAR',1,ZHOOK_HANDLE)
END SUBROUTINE APLPAR
