!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0 
SUBROUTINE SU_C11CLIM


!**   CFC11 FROM D.CARIOLLE 2D MODEL* 

!     PURPOSE.
!     --------

!**   INTERFACE.
!     ----------
!        CALL *SU_C11CLIM* FROM *SU_GHGCLIM*

!        EXPLICIT ARGUMENTS :
!        --------------------
!     ==== INPUTS ===
!     ==== OUTPUTS ===

!        IMPLICIT ARGUMENTS :   NONE
!        --------------------

!     METHOD.
!     -------

!     EXTERNALS.
!     ----------

!          NONE

!     REFERENCE.
!     ----------

!        SEE RADIATION'S PART OF THE MODEL'S DOCUMENTATION AND
!        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE "I.F.S"

!     AUTHOR.
!     -------
!     J.-J. MORCRETTE  E.C.M.W.F.    20080423

!     MODIFICATIONS.
!     --------------
!        Same history as suecaesu
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     R. Elkhatib 12-10-2005 Split for faster and more robust compilation.

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCLIM   ,ONLY : RGHG5

IMPLICIT NONE

!     -----------------------------------------------------------------

!*       0.1   ARGUMENTS.
!              ----------
! REAL(KIND=JPRB),INTENT(OUT) :: PCLC11(64,91,12)

!     ----------------------------------------------------------------- 

!*       0.2   LOCAL ARRAYS.
!              -------------

! REAL(KIND=JPRB),SAVE :: ZGHG5(64,91,12)

LOGICAL,SAVE :: LLFIRSTCALL = .TRUE.

REAL(KIND=JPRB) :: ZHOOK_HANDLE
!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM',0,ZHOOK_HANDLE)

IF(LLFIRSTCALL) THEN

  ALLOCATE(RGHG5(64,91,12))

  CALL PART1
  CALL PART2
  CALL PART3
  CALL PART4
  CALL PART5
  CALL PART6
  CALL PART7
  CALL PART8
  CALL PART9
  CALL PART10
  CALL PART11
  CALL PART12
  CALL PART13
  CALL PART14
  CALL PART15
  CALL PART16
  CALL PART17
  CALL PART18
  CALL PART19
  CALL PART20
  CALL PART21
  CALL PART22
  CALL PART23
  CALL PART24

ENDIF

! PCLC11(:,:,:)=ZGHG5(:,:,:)

!     ------------------------------------------------------------------

LLFIRSTCALL = .FALSE.

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM',1,ZHOOK_HANDLE)

!-----------------------------------------------------------------------------

CONTAINS

SUBROUTINE PART1
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART1',0,ZHOOK_HANDLE)



!-- Month=  1 ------------

RGHG5(:, 1, 1) = (/ &
  & 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.42038954E-44_JPRB, 0.98090893E-44_JPRB, 0.26624671E-43_JPRB, &
  & 0.63058431E-43_JPRB, 0.14153114E-42_JPRB, 0.44561291E-42_JPRB, 0.10705920E-41_JPRB, 0.31557241E-41_JPRB, 0.72853507E-41_JPRB, &
  & 0.13874256E-40_JPRB, 0.35150171E-40_JPRB, 0.79682035E-40_JPRB, 0.13209900E-39_JPRB, 0.18532032E-39_JPRB, 0.25922060E-39_JPRB, &
  & 0.46702055E-39_JPRB, 0.72871164E-39_JPRB, 0.12396405E-38_JPRB, 0.96618268E-39_JPRB, 0.13073330E-38_JPRB, 0.10775733E-38_JPRB, &
  & 0.84689154E-39_JPRB, 0.14490043E-38_JPRB, 0.95787438E-39_JPRB, 0.10368137E-38_JPRB, 0.53000051E-39_JPRB, 0.35033443E-39_JPRB, &
  & 0.24855111E-39_JPRB, 0.13747158E-39_JPRB, 0.81081932E-40_JPRB, 0.53644508E-40_JPRB, 0.32982362E-40_JPRB, 0.20629916E-40_JPRB, &
  & 0.12793855E-40_JPRB, 0.77940221E-41_JPRB, 0.46382979E-41_JPRB, 0.26876905E-41_JPRB, 0.15218101E-41_JPRB, 0.84918687E-42_JPRB, &
  & 0.47083628E-42_JPRB, 0.26064151E-42_JPRB, 0.14573504E-42_JPRB, 0.82676609E-43_JPRB, 0.47644148E-43_JPRB, 0.28025969E-43_JPRB, &
  & 0.16815582E-43_JPRB, 0.11210388E-43_JPRB, 0.70064923E-44_JPRB, 0.56051939E-44_JPRB, 0.56051939E-44_JPRB, 0.56051939E-44_JPRB, &
  & 0.56051939E-44_JPRB, 0.42038954E-44_JPRB, 0.42038954E-44_JPRB, 0.28025969E-44_JPRB /)

RGHG5(:, 2, 1) = (/ &
  & 0.14012985E-43_JPRB, 0.10649868E-42_JPRB, 0.14433374E-42_JPRB, 0.13592595E-42_JPRB, 0.10509738E-42_JPRB, 0.82676609E-43_JPRB, &
  & 0.74268819E-43_JPRB, 0.81275311E-43_JPRB, 0.11210388E-42_JPRB, 0.19618179E-42_JPRB, 0.41198175E-42_JPRB, 0.11140323E-41_JPRB, &
  & 0.26806840E-41_JPRB, 0.64123418E-41_JPRB, 0.18973581E-40_JPRB, 0.47373697E-40_JPRB, 0.13276883E-39_JPRB, 0.30397387E-39_JPRB, &
  & 0.60470653E-39_JPRB, 0.14632919E-38_JPRB, 0.31798083E-38_JPRB, 0.52516645E-38_JPRB, 0.74573419E-38_JPRB, 0.10620678E-37_JPRB, &
  & 0.19057058E-37_JPRB, 0.29866973E-37_JPRB, 0.47142242E-37_JPRB, 0.40706577E-37_JPRB, 0.50789250E-37_JPRB, 0.43546953E-37_JPRB, &
  & 0.36762827E-37_JPRB, 0.55043099E-37_JPRB, 0.39751598E-37_JPRB, 0.39806859E-37_JPRB, 0.21863455E-37_JPRB, 0.14122367E-37_JPRB, &
  & 0.97394727E-38_JPRB, 0.56079951E-38_JPRB, 0.33485372E-38_JPRB, 0.21755159E-38_JPRB, 0.13461392E-38_JPRB, 0.84264841E-39_JPRB, &
  & 0.52441073E-39_JPRB, 0.32224680E-39_JPRB, 0.19457590E-39_JPRB, 0.11529604E-39_JPRB, 0.67227294E-40_JPRB, 0.38821573E-40_JPRB, &
  & 0.22289053E-40_JPRB, 0.12781243E-40_JPRB, 0.73400014E-41_JPRB, 0.42431317E-41_JPRB, 0.24802983E-41_JPRB, 0.14811725E-41_JPRB, &
  & 0.91364660E-42_JPRB, 0.58994665E-42_JPRB, 0.40217266E-42_JPRB, 0.29006878E-42_JPRB, 0.22140516E-42_JPRB, 0.17656361E-42_JPRB, &
  & 0.14433374E-42_JPRB, 0.11911037E-42_JPRB, 0.95288296E-43_JPRB, 0.72867520E-43_JPRB /)

RGHG5(:, 3, 1) = (/ &
  & 0.10986180E-41_JPRB, 0.61208717E-41_JPRB, 0.72923572E-41_JPRB, 0.65875041E-41_JPRB, 0.50376680E-41_JPRB, 0.39740824E-41_JPRB, &
  & 0.36237578E-41_JPRB, 0.40497526E-41_JPRB, 0.56374237E-41_JPRB, 0.99604295E-41_JPRB, 0.21138587E-40_JPRB, 0.55504031E-40_JPRB, &
  & 0.13408605E-39_JPRB, 0.32227623E-39_JPRB, 0.93712816E-39_JPRB, 0.23218451E-38_JPRB, 0.63312094E-38_JPRB, 0.14173332E-37_JPRB, &
  & 0.27377734E-37_JPRB, 0.65835093E-37_JPRB, 0.14636043E-36_JPRB, 0.24461129E-36_JPRB, 0.34608184E-36_JPRB, 0.49033958E-36_JPRB, &
  & 0.91787049E-36_JPRB, 0.14543801E-35_JPRB, 0.22699394E-35_JPRB, 0.19750610E-35_JPRB, 0.24213099E-35_JPRB, 0.20987076E-35_JPRB, &
  & 0.18016663E-35_JPRB, 0.25991560E-35_JPRB, 0.19172776E-35_JPRB, 0.18761479E-35_JPRB, 0.10492854E-35_JPRB, 0.67395107E-36_JPRB, &
  & 0.46054748E-36_JPRB, 0.26802723E-36_JPRB, 0.16075743E-36_JPRB, 0.10405119E-36_JPRB, 0.64246844E-37_JPRB, 0.40061262E-37_JPRB, &
  & 0.24899199E-37_JPRB, 0.15322302E-37_JPRB, 0.93060960E-38_JPRB, 0.55719607E-38_JPRB, 0.32936511E-38_JPRB, 0.19293498E-38_JPRB, &
  & 0.11209070E-38_JPRB, 0.64700332E-39_JPRB, 0.37140155E-39_JPRB, 0.21280819E-39_JPRB, 0.12227450E-39_JPRB, 0.71075259E-40_JPRB, &
  & 0.42359851E-40_JPRB, 0.26312181E-40_JPRB, 0.17280813E-40_JPRB, 0.12096008E-40_JPRB, 0.90201582E-41_JPRB, 0.71017806E-41_JPRB, &
  & 0.57957704E-41_JPRB, 0.47363888E-41_JPRB, 0.36910202E-41_JPRB, 0.25517645E-41_JPRB /)

RGHG5(:, 4, 1) = (/ &
  & 0.43954109E-39_JPRB, 0.79745093E-39_JPRB, 0.75175038E-39_JPRB, 0.63724188E-39_JPRB, 0.47718837E-39_JPRB, 0.37374312E-39_JPRB, &
  & 0.33861396E-39_JPRB, 0.37500288E-39_JPRB, 0.52084302E-39_JPRB, 0.91692143E-39_JPRB, 0.19564257E-38_JPRB, 0.52503332E-38_JPRB, &
  & 0.12675002E-37_JPRB, 0.30615193E-37_JPRB, 0.87893924E-37_JPRB, 0.21585176E-36_JPRB, 0.57708394E-36_JPRB, 0.12675640E-35_JPRB, &
  & 0.23572280E-35_JPRB, 0.56395981E-35_JPRB, 0.12898999E-34_JPRB, 0.21769785E-34_JPRB, 0.30448128E-34_JPRB, 0.42162807E-34_JPRB, &
  & 0.82758832E-34_JPRB, 0.13136283E-33_JPRB, 0.20582362E-33_JPRB, 0.17658942E-33_JPRB, 0.21638867E-33_JPRB, 0.18694523E-33_JPRB, &
  & 0.15985760E-33_JPRB, 0.23100027E-33_JPRB, 0.16971618E-33_JPRB, 0.16568498E-33_JPRB, 0.92659737E-34_JPRB, 0.59355663E-34_JPRB, &
  & 0.40585897E-34_JPRB, 0.23595927E-34_JPRB, 0.14168660E-34_JPRB, 0.92186451E-35_JPRB, 0.56941548E-35_JPRB, 0.35652577E-35_JPRB, &
  & 0.22276097E-35_JPRB, 0.13828518E-35_JPRB, 0.85013446E-36_JPRB, 0.51690596E-36_JPRB, 0.31082033E-36_JPRB, 0.18500893E-36_JPRB, &
  & 0.10878157E-36_JPRB, 0.63130497E-37_JPRB, 0.36135491E-37_JPRB, 0.20457633E-37_JPRB, 0.11505204E-37_JPRB, 0.64875116E-38_JPRB, &
  & 0.37244103E-38_JPRB, 0.22240344E-38_JPRB, 0.14107839E-38_JPRB, 0.96743404E-39_JPRB, 0.71930892E-39_JPRB, 0.57445810E-39_JPRB, &
  & 0.48104194E-39_JPRB, 0.40348427E-39_JPRB, 0.31672708E-39_JPRB, 0.19848132E-39_JPRB /)

RGHG5(:, 5, 1) = (/ &
  & 0.32367483E-36_JPRB, 0.22835280E-36_JPRB, 0.17589089E-36_JPRB, 0.14114605E-36_JPRB, 0.10547722E-36_JPRB, 0.82863728E-37_JPRB, &
  & 0.74962428E-37_JPRB, 0.82494457E-37_JPRB, 0.11259101E-36_JPRB, 0.19780718E-36_JPRB, 0.42237481E-36_JPRB, 0.11465152E-35_JPRB, &
  & 0.27653401E-35_JPRB, 0.65967718E-35_JPRB, 0.18699885E-34_JPRB, 0.45030982E-34_JPRB, 0.11779596E-33_JPRB, 0.25279454E-33_JPRB, &
  & 0.45531580E-33_JPRB, 0.10669079E-32_JPRB, 0.24307370E-32_JPRB, 0.40676256E-32_JPRB, 0.55753866E-32_JPRB, 0.74995504E-32_JPRB, &
  & 0.14890808E-31_JPRB, 0.23406122E-31_JPRB, 0.36397002E-31_JPRB, 0.30688848E-31_JPRB, 0.37519734E-31_JPRB, 0.32111740E-31_JPRB, &
  & 0.27131988E-31_JPRB, 0.39635706E-31_JPRB, 0.28908060E-31_JPRB, 0.28330560E-31_JPRB, 0.15826881E-31_JPRB, 0.10179722E-31_JPRB, &
  & 0.70011577E-32_JPRB, 0.40839396E-32_JPRB, 0.24749157E-32_JPRB, 0.16359891E-32_JPRB, 0.10265237E-32_JPRB, 0.65454028E-33_JPRB, &
  & 0.41760493E-33_JPRB, 0.26515821E-33_JPRB, 0.16710245E-33_JPRB, 0.10435979E-33_JPRB, 0.64501791E-34_JPRB, 0.39405458E-34_JPRB, &
  & 0.23693153E-34_JPRB, 0.13980195E-34_JPRB, 0.80802222E-35_JPRB, 0.45870403E-35_JPRB, 0.25708657E-35_JPRB, 0.14375242E-35_JPRB, &
  & 0.81579776E-36_JPRB, 0.48111670E-36_JPRB, 0.30244942E-36_JPRB, 0.20702723E-36_JPRB, 0.15510132E-36_JPRB, 0.12605230E-36_JPRB, &
  & 0.10820181E-36_JPRB, 0.95108817E-37_JPRB, 0.80685196E-37_JPRB, 0.58530208E-37_JPRB /)

RGHG5(:, 6, 1) = (/ &
  & 0.89053460E-34_JPRB, 0.87487889E-34_JPRB, 0.74006243E-34_JPRB, 0.63825928E-34_JPRB, 0.49970012E-34_JPRB, 0.40603268E-34_JPRB, &
  & 0.37617105E-34_JPRB, 0.41543213E-34_JPRB, 0.56323754E-34_JPRB, 0.96595008E-34_JPRB, 0.20097262E-33_JPRB, 0.53540535E-33_JPRB, &
  & 0.12464877E-32_JPRB, 0.28579438E-32_JPRB, 0.77794018E-32_JPRB, 0.17936267E-31_JPRB, 0.44850769E-31_JPRB, 0.91926103E-31_JPRB, &
  & 0.15791525E-30_JPRB, 0.35272354E-30_JPRB, 0.77205688E-30_JPRB, 0.12442967E-29_JPRB, 0.16429567E-29_JPRB, 0.21211918E-29_JPRB, &
  & 0.41169427E-29_JPRB, 0.63112529E-29_JPRB, 0.96269767E-29_JPRB, 0.79349239E-29_JPRB, 0.95856836E-29_JPRB, 0.80963349E-29_JPRB, &
  & 0.67673191E-29_JPRB, 0.99491908E-29_JPRB, 0.72370948E-29_JPRB, 0.71474134E-29_JPRB, 0.40188877E-29_JPRB, 0.26128016E-29_JPRB, &
  & 0.18259926E-29_JPRB, 0.10823411E-29_JPRB, 0.67130903E-30_JPRB, 0.45796517E-30_JPRB, 0.29658597E-30_JPRB, 0.19620338E-30_JPRB, &
  & 0.13002553E-30_JPRB, 0.85877879E-31_JPRB, 0.56364190E-31_JPRB, 0.36692042E-31_JPRB, 0.23641989E-31_JPRB, 0.15039573E-31_JPRB, &
  & 0.93893265E-32_JPRB, 0.57283721E-32_JPRB, 0.34070051E-32_JPRB, 0.19821783E-32_JPRB, 0.11359195E-32_JPRB, 0.64949038E-33_JPRB, &
  & 0.37748290E-33_JPRB, 0.22865562E-33_JPRB, 0.14785739E-33_JPRB, 0.10405465E-33_JPRB, 0.79963428E-34_JPRB, 0.66316937E-34_JPRB, &
  & 0.58160424E-34_JPRB, 0.52530036E-34_JPRB, 0.47705521E-34_JPRB, 0.40442567E-34_JPRB /)

RGHG5(:, 7, 1) = (/ &
  & 0.81485280E-31_JPRB, 0.54764048E-31_JPRB, 0.45711275E-31_JPRB, 0.40642791E-31_JPRB, 0.33113173E-31_JPRB, 0.27919237E-31_JPRB, &
  & 0.26460801E-31_JPRB, 0.29461333E-31_JPRB, 0.38997392E-31_JPRB, 0.64553683E-31_JPRB, 0.12701068E-30_JPRB, 0.32085335E-30_JPRB, &
  & 0.70250585E-30_JPRB, 0.15061743E-29_JPRB, 0.38560608E-29_JPRB, 0.83298005E-29_JPRB, 0.19555527E-28_JPRB, 0.37631988E-28_JPRB, &
  & 0.60596166E-28_JPRB, 0.12710479E-27_JPRB, 0.26313685E-27_JPRB, 0.40341484E-27_JPRB, 0.50731898E-27_JPRB, 0.62246460E-27_JPRB, &
  & 0.11684244E-26_JPRB, 0.17356979E-26_JPRB, 0.25890923E-26_JPRB, 0.20767031E-26_JPRB, 0.24695988E-26_JPRB, 0.20592255E-26_JPRB, &
  & 0.17068968E-26_JPRB, 0.25149140E-26_JPRB, 0.18343734E-26_JPRB, 0.18261760E-26_JPRB, 0.10368284E-26_JPRB, 0.68479400E-27_JPRB, &
  & 0.48728286E-27_JPRB, 0.29611072E-27_JPRB, 0.18950066E-27_JPRB, 0.13388709E-27_JPRB, 0.90297785E-28_JPRB, 0.62369965E-28_JPRB, &
  & 0.43264554E-28_JPRB, 0.29946390E-28_JPRB, 0.20612715E-28_JPRB, 0.14080122E-28_JPRB, 0.95203261E-29_JPRB, 0.63521638E-29_JPRB, &
  & 0.41540552E-29_JPRB, 0.26494642E-29_JPRB, 0.16436573E-29_JPRB, 0.99637581E-30_JPRB, 0.59546585E-30_JPRB, 0.35596825E-30_JPRB, &
  & 0.21737192E-30_JPRB, 0.13882076E-30_JPRB, 0.94788279E-31_JPRB, 0.70203767E-31_JPRB, 0.56250343E-31_JPRB, 0.48163753E-31_JPRB, &
  & 0.43136264E-31_JPRB, 0.39654955E-31_JPRB, 0.36614648E-31_JPRB, 0.32321801E-31_JPRB /)

RGHG5(:, 8, 1) = (/ &
  & 0.68447526E-28_JPRB, 0.39111189E-28_JPRB, 0.30968048E-28_JPRB, 0.27767059E-28_JPRB, 0.22852074E-28_JPRB, 0.19428550E-28_JPRB, &
  & 0.18460096E-28_JPRB, 0.20219145E-28_JPRB, 0.25957708E-28_JPRB, 0.40719564E-28_JPRB, 0.75384834E-28_JPRB, 0.17896334E-27_JPRB, &
  & 0.36626570E-27_JPRB, 0.72882033E-27_JPRB, 0.17465184E-26_JPRB, 0.35106768E-26_JPRB, 0.77216594E-26_JPRB, 0.13898210E-25_JPRB, &
  & 0.20825319E-25_JPRB, 0.40967180E-25_JPRB, 0.80308869E-25_JPRB, 0.11688185E-24_JPRB, 0.13957987E-24_JPRB, 0.16197515E-24_JPRB, &
  & 0.29413685E-24_JPRB, 0.42256459E-24_JPRB, 0.61585173E-24_JPRB, 0.47976494E-24_JPRB, 0.56086709E-24_JPRB, 0.46157617E-24_JPRB, &
  & 0.37992946E-24_JPRB, 0.55970583E-24_JPRB, 0.40967891E-24_JPRB, 0.41089171E-24_JPRB, 0.23598232E-24_JPRB, 0.15821095E-24_JPRB, &
  & 0.11484304E-24_JPRB, 0.71800770E-25_JPRB, 0.47465459E-25_JPRB, 0.34853711E-25_JPRB, 0.24489247E-25_JPRB, 0.17714984E-25_JPRB, &
  & 0.12886213E-25_JPRB, 0.93585527E-26_JPRB, 0.67588701E-26_JPRB, 0.48419458E-26_JPRB, 0.34324883E-26_JPRB, 0.24011913E-26_JPRB, &
  & 0.16458601E-26_JPRB, 0.11000586E-26_JPRB, 0.71509707E-27_JPRB, 0.45468153E-27_JPRB, 0.28552073E-27_JPRB, 0.17991822E-27_JPRB, &
  & 0.11608097E-27_JPRB, 0.78533242E-28_JPRB, 0.56710927E-28_JPRB, 0.44159362E-28_JPRB, 0.36835324E-28_JPRB, 0.32492361E-28_JPRB, &
  & 0.29705077E-28_JPRB, 0.27650462E-28_JPRB, 0.25802863E-28_JPRB, 0.22875537E-28_JPRB /)

RGHG5(:, 9, 1) = (/ &
  & 0.50765621E-25_JPRB, 0.26966372E-25_JPRB, 0.20811673E-25_JPRB, 0.18436599E-25_JPRB, 0.15021408E-25_JPRB, 0.12594520E-25_JPRB, &
  & 0.11713463E-25_JPRB, 0.12448703E-25_JPRB, 0.15268993E-25_JPRB, 0.22709225E-25_JPRB, 0.39376057E-25_JPRB, 0.88148316E-25_JPRB, &
  & 0.16858589E-24_JPRB, 0.31088054E-24_JPRB, 0.69689279E-24_JPRB, 0.13011097E-23_JPRB, 0.26814897E-23_JPRB, 0.45152576E-23_JPRB, &
  & 0.62708415E-23_JPRB, 0.11576643E-22_JPRB, 0.21542837E-22_JPRB, 0.29733543E-22_JPRB, 0.33655921E-22_JPRB, 0.36906902E-22_JPRB, &
  & 0.64655109E-22_JPRB, 0.89688607E-22_JPRB, 0.12737936E-21_JPRB, 0.96423888E-22_JPRB, 0.11059523E-21_JPRB, 0.89753224E-22_JPRB, &
  & 0.73222940E-22_JPRB, 0.10758724E-21_JPRB, 0.78925559E-22_JPRB, 0.79772726E-22_JPRB, 0.46285265E-22_JPRB, 0.31626440E-22_JPRB, &
  & 0.23458117E-22_JPRB, 0.15127504E-22_JPRB, 0.10373339E-22_JPRB, 0.79237362E-23_JPRB, 0.58237790E-23_JPRB, 0.44203284E-23_JPRB, &
  & 0.33792813E-23_JPRB, 0.25792900E-23_JPRB, 0.19550312E-23_JPRB, 0.14681713E-23_JPRB, 0.10901623E-23_JPRB, 0.79888491E-24_JPRB, &
  & 0.57387787E-24_JPRB, 0.40238626E-24_JPRB, 0.27472399E-24_JPRB, 0.18377952E-24_JPRB, 0.12165137E-24_JPRB, 0.80851809E-25_JPRB, &
  & 0.55097213E-25_JPRB, 0.39290687E-25_JPRB, 0.29802592E-25_JPRB, 0.24195211E-25_JPRB, 0.20867134E-25_JPRB, 0.18825873E-25_JPRB, &
  & 0.17488929E-25_JPRB, 0.16467085E-25_JPRB, 0.15443918E-25_JPRB, 0.13822925E-25_JPRB /)

RGHG5(:,10, 1) = (/ &
  & 0.32445076E-22_JPRB, 0.16822025E-22_JPRB, 0.12720119E-22_JPRB, 0.11122231E-22_JPRB, 0.88844568E-23_JPRB, 0.72596755E-23_JPRB, &
  & 0.65410035E-23_JPRB, 0.66856727E-23_JPRB, 0.78199931E-23_JPRB, 0.10995422E-22_JPRB, 0.17894281E-22_JPRB, 0.37823735E-22_JPRB, &
  & 0.67670003E-22_JPRB, 0.11565798E-21_JPRB, 0.24248277E-21_JPRB, 0.42006952E-21_JPRB, 0.81112420E-21_JPRB, 0.12775956E-20_JPRB, &
  & 0.16419162E-20_JPRB, 0.28431175E-20_JPRB, 0.50181081E-20_JPRB, 0.65563571E-20_JPRB, 0.70253645E-20_JPRB, 0.72809762E-20_JPRB, &
  & 0.12264024E-19_JPRB, 0.16390487E-19_JPRB, 0.22621215E-19_JPRB, 0.16656505E-19_JPRB, 0.18699217E-19_JPRB, 0.14942985E-19_JPRB, &
  & 0.12059830E-19_JPRB, 0.17638253E-19_JPRB, 0.12959802E-19_JPRB, 0.13191082E-19_JPRB, 0.77526396E-20_JPRB, 0.54006360E-20_JPRB, &
  & 0.41085516E-20_JPRB, 0.27375399E-20_JPRB, 0.19513403E-20_JPRB, 0.15561379E-20_JPRB, 0.11984993E-20_JPRB, 0.95697375E-21_JPRB, &
  & 0.77080874E-21_JPRB, 0.61940687E-21_JPRB, 0.49358181E-21_JPRB, 0.38888909E-21_JPRB, 0.30262131E-21_JPRB, 0.23245820E-21_JPRB, &
  & 0.17514015E-21_JPRB, 0.12898276E-21_JPRB, 0.92609355E-22_JPRB, 0.65266306E-22_JPRB, 0.45523314E-22_JPRB, 0.31875793E-22_JPRB, &
  & 0.22829396E-22_JPRB, 0.17071089E-22_JPRB, 0.13495522E-22_JPRB, 0.11349485E-22_JPRB, 0.10025718E-22_JPRB, 0.92235526E-23_JPRB, &
  & 0.86717775E-23_JPRB, 0.82263977E-23_JPRB, 0.77901734E-23_JPRB, 0.69839331E-23_JPRB /)

RGHG5(:,11, 1) = (/ &
  & 0.17427797E-19_JPRB, 0.89229677E-20_JPRB, 0.66656031E-20_JPRB, 0.57398911E-20_JPRB, 0.44919631E-20_JPRB, 0.35724872E-20_JPRB, &
  & 0.31167790E-20_JPRB, 0.30654397E-20_JPRB, 0.34222825E-20_JPRB, 0.45627561E-20_JPRB, 0.69834788E-20_JPRB, 0.13958254E-19_JPRB, &
  & 0.23408279E-19_JPRB, 0.37165994E-19_JPRB, 0.72888151E-19_JPRB, 0.11728741E-18_JPRB, 0.21197467E-18_JPRB, 0.31229524E-18_JPRB, &
  & 0.37190733E-18_JPRB, 0.60311837E-18_JPRB, 0.10070135E-17_JPRB, 0.12440073E-17_JPRB, 0.12616544E-17_JPRB, 0.12376857E-17_JPRB, &
  & 0.19958952E-17_JPRB, 0.25678356E-17_JPRB, 0.34353336E-17_JPRB, 0.24609299E-17_JPRB, 0.26983142E-17_JPRB, 0.21203737E-17_JPRB, &
  & 0.16903757E-17_JPRB, 0.24577610E-17_JPRB, 0.18080133E-17_JPRB, 0.18540980E-17_JPRB, 0.11036810E-17_JPRB, 0.78575820E-18_JPRB, &
  & 0.61402382E-18_JPRB, 0.42315355E-18_JPRB, 0.31411550E-18_JPRB, 0.26170945E-18_JPRB, 0.21148832E-18_JPRB, 0.17772959E-18_JPRB, &
  & 0.15090008E-18_JPRB, 0.12792278E-18_JPRB, 0.10737482E-18_JPRB, 0.88971618E-19_JPRB, 0.72715574E-19_JPRB, 0.58670241E-19_JPRB, &
  & 0.46448498E-19_JPRB, 0.35981103E-19_JPRB, 0.27196122E-19_JPRB, 0.20186428E-19_JPRB, 0.14823637E-19_JPRB, 0.10899150E-19_JPRB, &
  & 0.81783008E-20_JPRB, 0.63751137E-20_JPRB, 0.52281741E-20_JPRB, 0.45168706E-20_JPRB, 0.40841663E-20_JPRB, 0.38062292E-20_JPRB, &
  & 0.36161190E-20_JPRB, 0.34599555E-20_JPRB, 0.32841017E-20_JPRB, 0.29903223E-20_JPRB /)

RGHG5(:,12, 1) = (/ &
  & 0.77827960E-17_JPRB, 0.39489834E-17_JPRB, 0.29174784E-17_JPRB, 0.24788940E-17_JPRB, 0.19047000E-17_JPRB, 0.14800073E-17_JPRB, &
  & 0.12536370E-17_JPRB, 0.11897556E-17_JPRB, 0.12716396E-17_JPRB, 0.16116501E-17_JPRB, 0.23256423E-17_JPRB, 0.43962689E-17_JPRB, &
  & 0.69224587E-17_JPRB, 0.10234778E-16_JPRB, 0.18776576E-16_JPRB, 0.28102432E-16_JPRB, 0.47483122E-16_JPRB, 0.65411927E-16_JPRB, &
  & 0.72373221E-16_JPRB, 0.10974034E-15_JPRB, 0.17286170E-15_JPRB, 0.20179713E-15_JPRB, 0.19379721E-15_JPRB, 0.18010522E-15_JPRB, &
  & 0.27727306E-15_JPRB, 0.34291986E-15_JPRB, 0.44382689E-15_JPRB, 0.30906546E-15_JPRB, 0.33024647E-15_JPRB, 0.25480993E-15_JPRB, &
  & 0.20043499E-15_JPRB, 0.28950744E-15_JPRB, 0.21328740E-15_JPRB, 0.22041568E-15_JPRB, 0.13307488E-15_JPRB, 0.96893627E-16_JPRB, &
  & 0.77882205E-16_JPRB, 0.55555912E-16_JPRB, 0.42991644E-16_JPRB, 0.37431974E-16_JPRB, 0.31740283E-16_JPRB, 0.28043947E-16_JPRB, &
  & 0.25094481E-16_JPRB, 0.22450102E-16_JPRB, 0.19895619E-16_JPRB, 0.17386079E-16_JPRB, 0.14969453E-16_JPRB, 0.12721872E-16_JPRB, &
  & 0.10606072E-16_JPRB, 0.86544020E-17_JPRB, 0.68877700E-17_JPRB, 0.53825288E-17_JPRB, 0.41529343E-17_JPRB, 0.31998173E-17_JPRB, &
  & 0.25053489E-17_JPRB, 0.20289661E-17_JPRB, 0.17158573E-17_JPRB, 0.15223800E-17_JPRB, 0.13982390E-17_JPRB, 0.13219434E-17_JPRB, &
  & 0.12667316E-17_JPRB, 0.12181823E-17_JPRB, 0.11662105E-17_JPRB, 0.10601598E-17_JPRB /)

RGHG5(:,13, 1) = (/ &
  & 0.56807601E-16_JPRB, 0.39912176E-16_JPRB, 0.35825517E-16_JPRB, 0.31733649E-16_JPRB, 0.24315202E-16_JPRB, 0.19695481E-16_JPRB, &
  & 0.17347041E-16_JPRB, 0.16235238E-16_JPRB, 0.16624199E-16_JPRB, 0.18537032E-16_JPRB, 0.27425714E-16_JPRB, 0.45742826E-16_JPRB, &
  & 0.68863547E-16_JPRB, 0.97618310E-16_JPRB, 0.15499176E-15_JPRB, 0.19416825E-15_JPRB, 0.27532502E-15_JPRB, 0.46838587E-15_JPRB, &
  & 0.57001225E-15_JPRB, 0.79619112E-15_JPRB, 0.11471207E-14_JPRB, 0.14430697E-14_JPRB, 0.20572901E-14_JPRB, 0.22334234E-14_JPRB, &
  & 0.30975809E-14_JPRB, 0.24597312E-14_JPRB, 0.34468888E-14_JPRB, 0.26315332E-14_JPRB, 0.30180574E-14_JPRB, 0.22742445E-14_JPRB, &
  & 0.25000516E-14_JPRB, 0.17108412E-14_JPRB, 0.14588028E-14_JPRB, 0.10254698E-14_JPRB, 0.80684981E-15_JPRB, 0.64726663E-15_JPRB, &
  & 0.57920918E-15_JPRB, 0.53956073E-15_JPRB, 0.51036049E-15_JPRB, 0.48827050E-15_JPRB, 0.46887943E-15_JPRB, 0.45171600E-15_JPRB, &
  & 0.43193302E-15_JPRB, 0.40618891E-15_JPRB, 0.37382137E-15_JPRB, 0.33567434E-15_JPRB, 0.29487591E-15_JPRB, 0.25492079E-15_JPRB, &
  & 0.21469172E-15_JPRB, 0.17713410E-15_JPRB, 0.14221637E-15_JPRB, 0.11193573E-15_JPRB, 0.86830115E-16_JPRB, 0.66913505E-16_JPRB, &
  & 0.52033869E-16_JPRB, 0.41376415E-16_JPRB, 0.34067056E-16_JPRB, 0.29174637E-16_JPRB, 0.26044536E-16_JPRB, 0.23929392E-16_JPRB, &
  & 0.22444176E-16_JPRB, 0.21210709E-16_JPRB, 0.19866971E-16_JPRB, 0.17749771E-16_JPRB /)

RGHG5(:,14, 1) = (/ &
  & 0.89758239E-15_JPRB, 0.46870203E-15_JPRB, 0.35395074E-15_JPRB, 0.29586829E-15_JPRB, 0.24213366E-15_JPRB, 0.20670676E-15_JPRB, &
  & 0.18991444E-15_JPRB, 0.19009594E-15_JPRB, 0.20158335E-15_JPRB, 0.23113840E-15_JPRB, 0.32624726E-15_JPRB, 0.49224272E-15_JPRB, &
  & 0.71480316E-15_JPRB, 0.10110950E-14_JPRB, 0.15680069E-14_JPRB, 0.22051541E-14_JPRB, 0.31028162E-14_JPRB, 0.46271707E-14_JPRB, &
  & 0.67675518E-14_JPRB, 0.89807490E-14_JPRB, 0.11990944E-13_JPRB, 0.16479095E-13_JPRB, 0.19455273E-13_JPRB, 0.22343945E-13_JPRB, &
  & 0.25326297E-13_JPRB, 0.25862018E-13_JPRB, 0.26449119E-13_JPRB, 0.23488507E-13_JPRB, 0.21873696E-13_JPRB, 0.17029901E-13_JPRB, &
  & 0.12598357E-13_JPRB, 0.10512448E-13_JPRB, 0.72713289E-14_JPRB, 0.58744272E-14_JPRB, 0.53947910E-14_JPRB, 0.50527201E-14_JPRB, &
  & 0.50781201E-14_JPRB, 0.52271470E-14_JPRB, 0.53909797E-14_JPRB, 0.55196072E-14_JPRB, 0.55905127E-14_JPRB, 0.55970658E-14_JPRB, &
  & 0.55022803E-14_JPRB, 0.52857240E-14_JPRB, 0.49518169E-14_JPRB, 0.45159494E-14_JPRB, 0.40220551E-14_JPRB, 0.35067052E-14_JPRB, &
  & 0.29759046E-14_JPRB, 0.24711352E-14_JPRB, 0.19916457E-14_JPRB, 0.15739759E-14_JPRB, 0.12235430E-14_JPRB, 0.94156998E-15_JPRB, &
  & 0.72734063E-15_JPRB, 0.56972331E-15_JPRB, 0.45791665E-15_JPRB, 0.38086561E-15_JPRB, 0.32854335E-15_JPRB, 0.29413058E-15_JPRB, &
  & 0.26909930E-15_JPRB, 0.24899198E-15_JPRB, 0.22891256E-15_JPRB, 0.19687270E-15_JPRB /)

RGHG5(:,15, 1) = (/ &
  & 0.19490923E-14_JPRB, 0.26597317E-14_JPRB, 0.23421598E-14_JPRB, 0.21092569E-14_JPRB, 0.19010740E-14_JPRB, 0.17647506E-14_JPRB, &
  & 0.17435330E-14_JPRB, 0.18389782E-14_JPRB, 0.20465980E-14_JPRB, 0.23931067E-14_JPRB, 0.31634254E-14_JPRB, 0.44947020E-14_JPRB, &
  & 0.64208384E-14_JPRB, 0.90555547E-14_JPRB, 0.13029511E-13_JPRB, 0.18900998E-13_JPRB, 0.27086674E-13_JPRB, 0.37856681E-13_JPRB, &
  & 0.52049029E-13_JPRB, 0.69463810E-13_JPRB, 0.87458361E-13_JPRB, 0.10813498E-12_JPRB, 0.12734799E-12_JPRB, 0.14487298E-12_JPRB, &
  & 0.15229518E-12_JPRB, 0.15445873E-12_JPRB, 0.14683758E-12_JPRB, 0.13027460E-12_JPRB, 0.10707403E-12_JPRB, 0.87561252E-13_JPRB, &
  & 0.66626494E-13_JPRB, 0.51835655E-13_JPRB, 0.40694122E-13_JPRB, 0.34401694E-13_JPRB, 0.32407020E-13_JPRB, 0.33836910E-13_JPRB, &
  & 0.37111979E-13_JPRB, 0.40980630E-13_JPRB, 0.44580354E-13_JPRB, 0.47455123E-13_JPRB, 0.49342820E-13_JPRB, 0.50176307E-13_JPRB, &
  & 0.49748878E-13_JPRB, 0.48092173E-13_JPRB, 0.45328209E-13_JPRB, 0.41672137E-13_JPRB, 0.37425704E-13_JPRB, 0.32869320E-13_JPRB, &
  & 0.28150298E-13_JPRB, 0.23507765E-13_JPRB, 0.19106031E-13_JPRB, 0.15207264E-13_JPRB, 0.11898116E-13_JPRB, 0.92056930E-14_JPRB, &
  & 0.71244026E-14_JPRB, 0.55624027E-14_JPRB, 0.44276322E-14_JPRB, 0.36121369E-14_JPRB, 0.30479153E-14_JPRB, 0.26579144E-14_JPRB, &
  & 0.23843541E-14_JPRB, 0.21571541E-14_JPRB, 0.19459887E-14_JPRB, 0.16141980E-14_JPRB /)

RGHG5(:,16, 1) = (/ &
  & 0.21009045E-13_JPRB, 0.16684299E-13_JPRB, 0.14214162E-13_JPRB, 0.12920628E-13_JPRB, 0.12406900E-13_JPRB, 0.12513839E-13_JPRB, &
  & 0.13442487E-13_JPRB, 0.15155495E-13_JPRB, 0.17758872E-13_JPRB, 0.21848161E-13_JPRB, 0.28144089E-13_JPRB, 0.37530766E-13_JPRB, &
  & 0.51101216E-13_JPRB, 0.70245405E-13_JPRB, 0.95705365E-13_JPRB, 0.13068402E-12_JPRB, 0.17673615E-12_JPRB, 0.23363928E-12_JPRB, &
  & 0.30144230E-12_JPRB, 0.37915482E-12_JPRB, 0.46705012E-12_JPRB, 0.54732694E-12_JPRB, 0.61318219E-12_JPRB, 0.65975318E-12_JPRB, &
  & 0.66926624E-12_JPRB, 0.64705923E-12_JPRB, 0.58894659E-12_JPRB, 0.51062865E-12_JPRB, 0.42146961E-12_JPRB, 0.32499161E-12_JPRB, &
  & 0.25465982E-12_JPRB, 0.19694237E-12_JPRB, 0.16787065E-12_JPRB, 0.15893301E-12_JPRB, 0.16609523E-12_JPRB, 0.18638529E-12_JPRB, &
  & 0.21518898E-12_JPRB, 0.24651854E-12_JPRB, 0.27511397E-12_JPRB, 0.29749461E-12_JPRB, 0.31130320E-12_JPRB, 0.31681103E-12_JPRB, &
  & 0.31328599E-12_JPRB, 0.30204349E-12_JPRB, 0.28466327E-12_JPRB, 0.26245420E-12_JPRB, 0.23685348E-12_JPRB, 0.20932442E-12_JPRB, &
  & 0.18070498E-12_JPRB, 0.15217691E-12_JPRB, 0.12507885E-12_JPRB, 0.10069309E-12_JPRB, 0.79765140E-13_JPRB, 0.62470991E-13_JPRB, &
  & 0.48874075E-13_JPRB, 0.38483136E-13_JPRB, 0.30718399E-13_JPRB, 0.24944214E-13_JPRB, 0.20813521E-13_JPRB, 0.17902131E-13_JPRB, &
  & 0.15718753E-13_JPRB, 0.14051851E-13_JPRB, 0.12345981E-13_JPRB, 0.10042973E-13_JPRB /)

RGHG5(:,17, 1) = (/ &
  & 0.83977943E-13_JPRB, 0.69591895E-13_JPRB, 0.65495291E-13_JPRB, 0.64319244E-13_JPRB, 0.66238864E-13_JPRB, 0.72199964E-13_JPRB, &
  & 0.83386070E-13_JPRB, 0.10041189E-12_JPRB, 0.12312251E-12_JPRB, 0.15257698E-12_JPRB, 0.19187527E-12_JPRB, 0.24466719E-12_JPRB, &
  & 0.31467727E-12_JPRB, 0.40674053E-12_JPRB, 0.52523670E-12_JPRB, 0.67616106E-12_JPRB, 0.86368884E-12_JPRB, 0.10876487E-11_JPRB, &
  & 0.13352865E-11_JPRB, 0.15922097E-11_JPRB, 0.18443001E-11_JPRB, 0.20602309E-11_JPRB, 0.22018843E-11_JPRB, 0.22482975E-11_JPRB, &
  & 0.21806346E-11_JPRB, 0.20224742E-11_JPRB, 0.17907679E-11_JPRB, 0.15143270E-11_JPRB, 0.12433620E-11_JPRB, 0.10179274E-11_JPRB, &
  & 0.84214536E-12_JPRB, 0.72456364E-12_JPRB, 0.66317188E-12_JPRB, 0.66700784E-12_JPRB, 0.72733583E-12_JPRB, 0.83586935E-12_JPRB, &
  & 0.97623092E-12_JPRB, 0.11256625E-11_JPRB, 0.12594976E-11_JPRB, 0.13573537E-11_JPRB, 0.14181564E-11_JPRB, 0.14388864E-11_JPRB, &
  & 0.14095509E-11_JPRB, 0.13458781E-11_JPRB, 0.12601504E-11_JPRB, 0.11593278E-11_JPRB, 0.10472662E-11_JPRB, 0.92893900E-12_JPRB, &
  & 0.80713723E-12_JPRB, 0.68625487E-12_JPRB, 0.57118329E-12_JPRB, 0.46695980E-12_JPRB, 0.37606959E-12_JPRB, 0.30008572E-12_JPRB, &
  & 0.23903237E-12_JPRB, 0.19146662E-12_JPRB, 0.15463420E-12_JPRB, 0.12662374E-12_JPRB, 0.10570468E-12_JPRB, 0.90150557E-13_JPRB, &
  & 0.78728365E-13_JPRB, 0.69021571E-13_JPRB, 0.60397257E-13_JPRB, 0.47126992E-13_JPRB /)

RGHG5(:,18, 1) = (/ &
  & 0.37038772E-12_JPRB, 0.36222956E-12_JPRB, 0.36038419E-12_JPRB, 0.36446673E-12_JPRB, 0.37757010E-12_JPRB, 0.40523680E-12_JPRB, &
  & 0.45363675E-12_JPRB, 0.52783206E-12_JPRB, 0.62934000E-12_JPRB, 0.76146072E-12_JPRB, 0.93020893E-12_JPRB, 0.11448780E-11_JPRB, &
  & 0.14149873E-11_JPRB, 0.17491629E-11_JPRB, 0.21560616E-11_JPRB, 0.26412635E-11_JPRB, 0.32001261E-11_JPRB, 0.38217502E-11_JPRB, &
  & 0.44622908E-11_JPRB, 0.50771908E-11_JPRB, 0.55907757E-11_JPRB, 0.59382998E-11_JPRB, 0.60567666E-11_JPRB, 0.59160194E-11_JPRB, &
  & 0.55253666E-11_JPRB, 0.49649664E-11_JPRB, 0.43171313E-11_JPRB, 0.36842326E-11_JPRB, 0.31064142E-11_JPRB, 0.26678013E-11_JPRB, &
  & 0.23652976E-11_JPRB, 0.22184646E-11_JPRB, 0.22115729E-11_JPRB, 0.23451456E-11_JPRB, 0.26125187E-11_JPRB, 0.29976770E-11_JPRB, &
  & 0.34601827E-11_JPRB, 0.39312004E-11_JPRB, 0.43344347E-11_JPRB, 0.46183573E-11_JPRB, 0.47336410E-11_JPRB, 0.47067038E-11_JPRB, &
  & 0.45706832E-11_JPRB, 0.43373838E-11_JPRB, 0.40410995E-11_JPRB, 0.37069826E-11_JPRB, 0.33513736E-11_JPRB, 0.29818635E-11_JPRB, &
  & 0.26089788E-11_JPRB, 0.22416058E-11_JPRB, 0.18932941E-11_JPRB, 0.15756061E-11_JPRB, 0.12959388E-11_JPRB, 0.10581131E-11_JPRB, &
  & 0.86337263E-12_JPRB, 0.70711839E-12_JPRB, 0.58285565E-12_JPRB, 0.48514816E-12_JPRB, 0.40912290E-12_JPRB, 0.35075965E-12_JPRB, &
  & 0.30436027E-12_JPRB, 0.26676846E-12_JPRB, 0.22968641E-12_JPRB, 0.17810010E-12_JPRB /)

RGHG5(:,19, 1) = (/ &
  & 0.10042746E-11_JPRB, 0.10624507E-11_JPRB, 0.11110199E-11_JPRB, 0.11746927E-11_JPRB, 0.12676922E-11_JPRB, 0.14056071E-11_JPRB, &
  & 0.16050580E-11_JPRB, 0.18750080E-11_JPRB, 0.22200837E-11_JPRB, 0.26502893E-11_JPRB, 0.31780227E-11_JPRB, 0.38138373E-11_JPRB, &
  & 0.45738521E-11_JPRB, 0.54638672E-11_JPRB, 0.64845585E-11_JPRB, 0.76359613E-11_JPRB, 0.88816792E-11_JPRB, 0.10153158E-10_JPRB, &
  & 0.11349983E-10_JPRB, 0.12388621E-10_JPRB, 0.13111935E-10_JPRB, 0.13413708E-10_JPRB, 0.13223728E-10_JPRB, 0.12534048E-10_JPRB, &
  & 0.11442640E-10_JPRB, 0.10154869E-10_JPRB, 0.88412975E-11_JPRB, 0.76722162E-11_JPRB, 0.68037481E-11_JPRB, 0.62308613E-11_JPRB, &
  & 0.59858381E-11_JPRB, 0.60260737E-11_JPRB, 0.63210223E-11_JPRB, 0.68743865E-11_JPRB, 0.76603906E-11_JPRB, 0.86311201E-11_JPRB, &
  & 0.96776883E-11_JPRB, 0.10653503E-10_JPRB, 0.11404863E-10_JPRB, 0.11848038E-10_JPRB, 0.11962719E-10_JPRB, 0.11760257E-10_JPRB, &
  & 0.11287617E-10_JPRB, 0.10630490E-10_JPRB, 0.98713381E-11_JPRB, 0.90439323E-11_JPRB, 0.81853656E-11_JPRB, 0.73165883E-11_JPRB, &
  & 0.64498693E-11_JPRB, 0.56081563E-11_JPRB, 0.48126034E-11_JPRB, 0.40854568E-11_JPRB, 0.34392769E-11_JPRB, 0.28824467E-11_JPRB, &
  & 0.24164264E-11_JPRB, 0.20298602E-11_JPRB, 0.17151361E-11_JPRB, 0.14600293E-11_JPRB, 0.12536400E-11_JPRB, 0.10860286E-11_JPRB, &
  & 0.94951835E-12_JPRB, 0.83243297E-12_JPRB, 0.71567763E-12_JPRB, 0.55306167E-12_JPRB /)

RGHG5(:,20, 1) = (/ &
  & 0.24281525E-11_JPRB, 0.26716246E-11_JPRB, 0.28484344E-11_JPRB, 0.30504804E-11_JPRB, 0.33177226E-11_JPRB, 0.36892967E-11_JPRB, &
  & 0.42037389E-11_JPRB, 0.48862130E-11_JPRB, 0.57371586E-11_JPRB, 0.67596840E-11_JPRB, 0.79737831E-11_JPRB, 0.93730570E-11_JPRB, &
  & 0.10974169E-10_JPRB, 0.12760650E-10_JPRB, 0.14700352E-10_JPRB, 0.16770703E-10_JPRB, 0.18891765E-10_JPRB, 0.20924623E-10_JPRB, &
  & 0.22674031E-10_JPRB, 0.24031895E-10_JPRB, 0.24773699E-10_JPRB, 0.24758157E-10_JPRB, 0.23941972E-10_JPRB, 0.22393084E-10_JPRB, &
  & 0.20317106E-10_JPRB, 0.18096710E-10_JPRB, 0.16055031E-10_JPRB, 0.14466537E-10_JPRB, 0.13437634E-10_JPRB, 0.13064631E-10_JPRB, &
  & 0.13287262E-10_JPRB, 0.14009459E-10_JPRB, 0.15106538E-10_JPRB, 0.16545333E-10_JPRB, 0.18247015E-10_JPRB, 0.20070706E-10_JPRB, &
  & 0.21827729E-10_JPRB, 0.23320205E-10_JPRB, 0.24337605E-10_JPRB, 0.24688876E-10_JPRB, 0.24415301E-10_JPRB, 0.23624384E-10_JPRB, &
  & 0.22478644E-10_JPRB, 0.21070305E-10_JPRB, 0.19516846E-10_JPRB, 0.17877432E-10_JPRB, 0.16215952E-10_JPRB, 0.14565555E-10_JPRB, &
  & 0.12949109E-10_JPRB, 0.11399838E-10_JPRB, 0.99444133E-11_JPRB, 0.86160558E-11_JPRB, 0.74292673E-11_JPRB, 0.63912755E-11_JPRB, &
  & 0.54999178E-11_JPRB, 0.47448287E-11_JPRB, 0.41145537E-11_JPRB, 0.35864460E-11_JPRB, 0.31428545E-11_JPRB, 0.27685063E-11_JPRB, &
  & 0.24498808E-11_JPRB, 0.21578345E-11_JPRB, 0.18806694E-11_JPRB, 0.14382528E-11_JPRB /)

RGHG5(:,21, 1) = (/ &
  & 0.46600939E-11_JPRB, 0.53477114E-11_JPRB, 0.58220108E-11_JPRB, 0.63260556E-11_JPRB, 0.69446436E-11_JPRB, 0.77406137E-11_JPRB, &
  & 0.87716570E-11_JPRB, 0.10072401E-10_JPRB, 0.11663520E-10_JPRB, 0.13537789E-10_JPRB, 0.15697220E-10_JPRB, 0.18112995E-10_JPRB, &
  & 0.20775107E-10_JPRB, 0.23643256E-10_JPRB, 0.26631671E-10_JPRB, 0.29667376E-10_JPRB, 0.32645869E-10_JPRB, 0.35371223E-10_JPRB, &
  & 0.37579315E-10_JPRB, 0.39108699E-10_JPRB, 0.39729900E-10_JPRB, 0.39305243E-10_JPRB, 0.37825579E-10_JPRB, 0.35418519E-10_JPRB, &
  & 0.32450403E-10_JPRB, 0.29440020E-10_JPRB, 0.26870992E-10_JPRB, 0.25071006E-10_JPRB, 0.24309414E-10_JPRB, 0.24584805E-10_JPRB, &
  & 0.25797012E-10_JPRB, 0.27732721E-10_JPRB, 0.30086773E-10_JPRB, 0.32777545E-10_JPRB, 0.35538093E-10_JPRB, 0.38162973E-10_JPRB, &
  & 0.40460465E-10_JPRB, 0.42104386E-10_JPRB, 0.42889376E-10_JPRB, 0.42721097E-10_JPRB, 0.41717147E-10_JPRB, 0.40045210E-10_JPRB, &
  & 0.37889223E-10_JPRB, 0.35406351E-10_JPRB, 0.32764853E-10_JPRB, 0.30044377E-10_JPRB, 0.27362178E-10_JPRB, 0.24737171E-10_JPRB, &
  & 0.22205408E-10_JPRB, 0.19803393E-10_JPRB, 0.17570393E-10_JPRB, 0.15533221E-10_JPRB, 0.13701117E-10_JPRB, 0.12080679E-10_JPRB, &
  & 0.10653874E-10_JPRB, 0.94233970E-11_JPRB, 0.83666242E-11_JPRB, 0.74564088E-11_JPRB, 0.66644238E-11_JPRB, 0.59689710E-11_JPRB, &
  & 0.53436656E-11_JPRB, 0.47822688E-11_JPRB, 0.41536982E-11_JPRB, 0.32892732E-11_JPRB /)

RGHG5(:,22, 1) = (/ &
  & 0.83846775E-11_JPRB, 0.94995635E-11_JPRB, 0.10293948E-10_JPRB, 0.11159214E-10_JPRB, 0.12223079E-10_JPRB, 0.13577301E-10_JPRB, &
  & 0.15283996E-10_JPRB, 0.17360322E-10_JPRB, 0.19814698E-10_JPRB, 0.22639163E-10_JPRB, 0.25830635E-10_JPRB, 0.29310342E-10_JPRB, &
  & 0.33037937E-10_JPRB, 0.36949804E-10_JPRB, 0.40931661E-10_JPRB, 0.44861708E-10_JPRB, 0.48563306E-10_JPRB, 0.51828861E-10_JPRB, &
  & 0.54409553E-10_JPRB, 0.56148083E-10_JPRB, 0.56793143E-10_JPRB, 0.56173430E-10_JPRB, 0.54339293E-10_JPRB, 0.51526949E-10_JPRB, &
  & 0.48078111E-10_JPRB, 0.44788562E-10_JPRB, 0.42093867E-10_JPRB, 0.40531602E-10_JPRB, 0.40340297E-10_JPRB, 0.41575972E-10_JPRB, &
  & 0.44009803E-10_JPRB, 0.47254155E-10_JPRB, 0.50916004E-10_JPRB, 0.54714185E-10_JPRB, 0.58314770E-10_JPRB, 0.61424782E-10_JPRB, &
  & 0.63789626E-10_JPRB, 0.65105824E-10_JPRB, 0.65265869E-10_JPRB, 0.64224390E-10_JPRB, 0.62173829E-10_JPRB, 0.59393983E-10_JPRB, &
  & 0.56101956E-10_JPRB, 0.52458579E-10_JPRB, 0.48646222E-10_JPRB, 0.44792416E-10_JPRB, 0.41005914E-10_JPRB, 0.37362169E-10_JPRB, &
  & 0.33889946E-10_JPRB, 0.30635241E-10_JPRB, 0.27632735E-10_JPRB, 0.24900094E-10_JPRB, 0.22430148E-10_JPRB, 0.20195510E-10_JPRB, &
  & 0.18206421E-10_JPRB, 0.16450331E-10_JPRB, 0.14905603E-10_JPRB, 0.13530663E-10_JPRB, 0.12295799E-10_JPRB, 0.11172480E-10_JPRB, &
  & 0.10143639E-10_JPRB, 0.91268789E-11_JPRB, 0.81201330E-11_JPRB, 0.64108697E-11_JPRB /)

RGHG5(:,23, 1) = (/ &
  & 0.13319297E-10_JPRB, 0.15113119E-10_JPRB, 0.16309355E-10_JPRB, 0.17567312E-10_JPRB, 0.19089263E-10_JPRB, 0.20995960E-10_JPRB, &
  & 0.23378827E-10_JPRB, 0.26245809E-10_JPRB, 0.29549578E-10_JPRB, 0.33276198E-10_JPRB, 0.37392318E-10_JPRB, 0.41813782E-10_JPRB, &
  & 0.46454597E-10_JPRB, 0.51206230E-10_JPRB, 0.55944610E-10_JPRB, 0.60574532E-10_JPRB, 0.64939221E-10_JPRB, 0.68805094E-10_JPRB, &
  & 0.71888759E-10_JPRB, 0.74027548E-10_JPRB, 0.75005641E-10_JPRB, 0.74738042E-10_JPRB, 0.73239623E-10_JPRB, 0.70668443E-10_JPRB, &
  & 0.67599926E-10_JPRB, 0.64621447E-10_JPRB, 0.62337024E-10_JPRB, 0.61263175E-10_JPRB, 0.61733077E-10_JPRB, 0.63774340E-10_JPRB, &
  & 0.67043600E-10_JPRB, 0.71124794E-10_JPRB, 0.75531074E-10_JPRB, 0.79862825E-10_JPRB, 0.83712093E-10_JPRB, 0.86748046E-10_JPRB, &
  & 0.88754781E-10_JPRB, 0.89407731E-10_JPRB, 0.88728760E-10_JPRB, 0.86736049E-10_JPRB, 0.83692782E-10_JPRB, 0.79905485E-10_JPRB, &
  & 0.75571070E-10_JPRB, 0.70884645E-10_JPRB, 0.66024936E-10_JPRB, 0.61121004E-10_JPRB, 0.56338309E-10_JPRB, 0.51766924E-10_JPRB, &
  & 0.47456108E-10_JPRB, 0.43459791E-10_JPRB, 0.39790379E-10_JPRB, 0.36461903E-10_JPRB, 0.33427712E-10_JPRB, 0.30665047E-10_JPRB, &
  & 0.28163027E-10_JPRB, 0.25906732E-10_JPRB, 0.23859165E-10_JPRB, 0.21985899E-10_JPRB, 0.20247085E-10_JPRB, 0.18612358E-10_JPRB, &
  & 0.17048418E-10_JPRB, 0.15551531E-10_JPRB, 0.13837266E-10_JPRB, 0.11280274E-10_JPRB /)

RGHG5(:,24, 1) = (/ &
  & 0.19624835E-10_JPRB, 0.22025624E-10_JPRB, 0.23634089E-10_JPRB, 0.25297757E-10_JPRB, 0.27262047E-10_JPRB, 0.29676064E-10_JPRB, &
  & 0.32625042E-10_JPRB, 0.36142121E-10_JPRB, 0.40177611E-10_JPRB, 0.44636312E-10_JPRB, 0.49499599E-10_JPRB, 0.54651460E-10_JPRB, &
  & 0.60011843E-10_JPRB, 0.65472822E-10_JPRB, 0.70892937E-10_JPRB, 0.76121512E-10_JPRB, 0.81000123E-10_JPRB, 0.85355563E-10_JPRB, &
  & 0.88999530E-10_JPRB, 0.91838342E-10_JPRB, 0.93677163E-10_JPRB, 0.94351714E-10_JPRB, 0.93831214E-10_JPRB, 0.92418385E-10_JPRB, &
  & 0.90426264E-10_JPRB, 0.88429923E-10_JPRB, 0.86958746E-10_JPRB, 0.86489212E-10_JPRB, 0.87424179E-10_JPRB, 0.89692441E-10_JPRB, &
  & 0.93081369E-10_JPRB, 0.97196591E-10_JPRB, 0.10145151E-09_JPRB, 0.10551469E-09_JPRB, 0.10894442E-09_JPRB, 0.11143857E-09_JPRB, &
  & 0.11274399E-09_JPRB, 0.11261370E-09_JPRB, 0.11111147E-09_JPRB, 0.10834481E-09_JPRB, 0.10452405E-09_JPRB, 0.99985305E-10_JPRB, &
  & 0.94886710E-10_JPRB, 0.89411090E-10_JPRB, 0.83740771E-10_JPRB, 0.78010931E-10_JPRB, 0.72457790E-10_JPRB, 0.67188012E-10_JPRB, &
  & 0.62257866E-10_JPRB, 0.57716151E-10_JPRB, 0.53554473E-10_JPRB, 0.49788319E-10_JPRB, 0.46329576E-10_JPRB, 0.43159028E-10_JPRB, &
  & 0.40248884E-10_JPRB, 0.37557422E-10_JPRB, 0.35054768E-10_JPRB, 0.32683009E-10_JPRB, 0.30412568E-10_JPRB, 0.28211827E-10_JPRB, &
  & 0.26065913E-10_JPRB, 0.23895419E-10_JPRB, 0.21580952E-10_JPRB, 0.17730229E-10_JPRB /)

RGHG5(:,25, 1) = (/ &
  & 0.27044051E-10_JPRB, 0.30006577E-10_JPRB, 0.31975179E-10_JPRB, 0.33992351E-10_JPRB, 0.36345645E-10_JPRB, 0.39183271E-10_JPRB, &
  & 0.42589293E-10_JPRB, 0.46575646E-10_JPRB, 0.51121333E-10_JPRB, 0.56114762E-10_JPRB, 0.61476969E-10_JPRB, 0.67110748E-10_JPRB, &
  & 0.72906126E-10_JPRB, 0.78756265E-10_JPRB, 0.84543442E-10_JPRB, 0.90196954E-10_JPRB, 0.95616418E-10_JPRB, 0.10066655E-09_JPRB, &
  & 0.10516765E-09_JPRB, 0.10899252E-09_JPRB, 0.11196115E-09_JPRB, 0.11397947E-09_JPRB, 0.11506542E-09_JPRB, 0.11533304E-09_JPRB, &
  & 0.11492537E-09_JPRB, 0.11434512E-09_JPRB, 0.11392149E-09_JPRB, 0.11403031E-09_JPRB, 0.11506951E-09_JPRB, 0.11702725E-09_JPRB, &
  & 0.11984977E-09_JPRB, 0.12314136E-09_JPRB, 0.12655788E-09_JPRB, 0.12973381E-09_JPRB, 0.13227723E-09_JPRB, 0.13391904E-09_JPRB, &
  & 0.13436385E-09_JPRB, 0.13347964E-09_JPRB, 0.13130243E-09_JPRB, 0.12799631E-09_JPRB, 0.12373919E-09_JPRB, 0.11876509E-09_JPRB, &
  & 0.11325290E-09_JPRB, 0.10731634E-09_JPRB, 0.10111804E-09_JPRB, 0.94865851E-10_JPRB, 0.88816940E-10_JPRB, 0.83077975E-10_JPRB, &
  & 0.77731599E-10_JPRB, 0.72830152E-10_JPRB, 0.68362122E-10_JPRB, 0.64293036E-10_JPRB, 0.60567315E-10_JPRB, 0.57133510E-10_JPRB, &
  & 0.53935204E-10_JPRB, 0.50930565E-10_JPRB, 0.48046137E-10_JPRB, 0.45243857E-10_JPRB, 0.42469070E-10_JPRB, 0.39694952E-10_JPRB, &
  & 0.36921424E-10_JPRB, 0.34106523E-10_JPRB, 0.30981256E-10_JPRB, 0.25833795E-10_JPRB /)

RGHG5(:,26, 1) = (/ &
  & 0.35408589E-10_JPRB, 0.38840490E-10_JPRB, 0.41099141E-10_JPRB, 0.43396085E-10_JPRB, 0.46047107E-10_JPRB, 0.49210108E-10_JPRB, &
  & 0.52950096E-10_JPRB, 0.57262080E-10_JPRB, 0.62113661E-10_JPRB, 0.67444848E-10_JPRB, 0.73130856E-10_JPRB, 0.79084579E-10_JPRB, &
  & 0.85205412E-10_JPRB, 0.91412031E-10_JPRB, 0.97584975E-10_JPRB, 0.10365712E-09_JPRB, 0.10953246E-09_JPRB, 0.11509023E-09_JPRB, &
  & 0.12022323E-09_JPRB, 0.12490804E-09_JPRB, 0.12905635E-09_JPRB, 0.13256236E-09_JPRB, 0.13535173E-09_JPRB, 0.13740523E-09_JPRB, &
  & 0.13874732E-09_JPRB, 0.13963643E-09_JPRB, 0.14030491E-09_JPRB, 0.14104279E-09_JPRB, 0.14200424E-09_JPRB, 0.14340264E-09_JPRB, &
  & 0.14522736E-09_JPRB, 0.14734598E-09_JPRB, 0.14955628E-09_JPRB, 0.15151679E-09_JPRB, 0.15297739E-09_JPRB, 0.15364049E-09_JPRB, &
  & 0.15324360E-09_JPRB, 0.15172928E-09_JPRB, 0.14911292E-09_JPRB, 0.14552883E-09_JPRB, 0.14112306E-09_JPRB, 0.13602255E-09_JPRB, &
  & 0.13037181E-09_JPRB, 0.12427333E-09_JPRB, 0.11785542E-09_JPRB, 0.11136449E-09_JPRB, 0.10503569E-09_JPRB, 0.98987624E-10_JPRB, &
  & 0.93396110E-10_JPRB, 0.88277899E-10_JPRB, 0.83638076E-10_JPRB, 0.79409403E-10_JPRB, 0.75543169E-10_JPRB, 0.71974038E-10_JPRB, &
  & 0.68620977E-10_JPRB, 0.65414008E-10_JPRB, 0.62289743E-10_JPRB, 0.59156235E-10_JPRB, 0.55975426E-10_JPRB, 0.52707873E-10_JPRB, &
  & 0.49342481E-10_JPRB, 0.45910071E-10_JPRB, 0.41952948E-10_JPRB, 0.35508287E-10_JPRB /)

RGHG5(:,27, 1) = (/ &
  & 0.44536364E-10_JPRB, 0.48395930E-10_JPRB, 0.50870457E-10_JPRB, 0.53373229E-10_JPRB, 0.56233233E-10_JPRB, 0.59607125E-10_JPRB, &
  & 0.63547251E-10_JPRB, 0.68037458E-10_JPRB, 0.73013505E-10_JPRB, 0.78454257E-10_JPRB, 0.84254916E-10_JPRB, 0.90306929E-10_JPRB, &
  & 0.96542135E-10_JPRB, 0.10286304E-09_JPRB, 0.10920014E-09_JPRB, 0.11548357E-09_JPRB, 0.12165578E-09_JPRB, 0.12766777E-09_JPRB, &
  & 0.13347383E-09_JPRB, 0.13905208E-09_JPRB, 0.14430791E-09_JPRB, 0.14911460E-09_JPRB, 0.15337463E-09_JPRB, 0.15697642E-09_JPRB, &
  & 0.15988051E-09_JPRB, 0.16211468E-09_JPRB, 0.16378314E-09_JPRB, 0.16499277E-09_JPRB, 0.16593767E-09_JPRB, 0.16683800E-09_JPRB, &
  & 0.16779247E-09_JPRB, 0.16876829E-09_JPRB, 0.16977109E-09_JPRB, 0.17051656E-09_JPRB, 0.17090757E-09_JPRB, 0.17065244E-09_JPRB, &
  & 0.16955740E-09_JPRB, 0.16759744E-09_JPRB, 0.16475442E-09_JPRB, 0.16109941E-09_JPRB, 0.15674427E-09_JPRB, 0.15177871E-09_JPRB, &
  & 0.14624242E-09_JPRB, 0.14022419E-09_JPRB, 0.13382867E-09_JPRB, 0.12726101E-09_JPRB, 0.12076126E-09_JPRB, 0.11458375E-09_JPRB, &
  & 0.10887499E-09_JPRB, 0.10367483E-09_JPRB, 0.98945560E-10_JPRB, 0.94660182E-10_JPRB, 0.90745036E-10_JPRB, 0.87128506E-10_JPRB, &
  & 0.83714410E-10_JPRB, 0.80434541E-10_JPRB, 0.77176272E-10_JPRB, 0.73872214E-10_JPRB, 0.70428920E-10_JPRB, 0.66810120E-10_JPRB, &
  & 0.63046353E-10_JPRB, 0.59032605E-10_JPRB, 0.54577561E-10_JPRB, 0.46665553E-10_JPRB /)

RGHG5(:,28, 1) = (/ &
  & 0.54405237E-10_JPRB, 0.58574465E-10_JPRB, 0.61232359E-10_JPRB, 0.63861083E-10_JPRB, 0.66844905E-10_JPRB, 0.70325912E-10_JPRB, &
  & 0.74350429E-10_JPRB, 0.78876704E-10_JPRB, 0.83845396E-10_JPRB, 0.89232080E-10_JPRB, 0.94972544E-10_JPRB, 0.10100226E-09_JPRB, &
  & 0.10720885E-09_JPRB, 0.11355107E-09_JPRB, 0.11994991E-09_JPRB, 0.12636578E-09_JPRB, 0.13277103E-09_JPRB, 0.13913391E-09_JPRB, &
  & 0.14541510E-09_JPRB, 0.15159554E-09_JPRB, 0.15759689E-09_JPRB, 0.16330853E-09_JPRB, 0.16862396E-09_JPRB, 0.17338891E-09_JPRB, &
  & 0.17748127E-09_JPRB, 0.18078654E-09_JPRB, 0.18330831E-09_JPRB, 0.18501198E-09_JPRB, 0.18607403E-09_JPRB, 0.18667140E-09_JPRB, &
  & 0.18698293E-09_JPRB, 0.18706914E-09_JPRB, 0.18706552E-09_JPRB, 0.18679669E-09_JPRB, 0.18626486E-09_JPRB, 0.18525388E-09_JPRB, &
  & 0.18362772E-09_JPRB, 0.18136700E-09_JPRB, 0.17845025E-09_JPRB, 0.17491242E-09_JPRB, 0.17079251E-09_JPRB, 0.16613236E-09_JPRB, &
  & 0.16089496E-09_JPRB, 0.15512064E-09_JPRB, 0.14887942E-09_JPRB, 0.14236487E-09_JPRB, 0.13587693E-09_JPRB, 0.12965801E-09_JPRB, &
  & 0.12391135E-09_JPRB, 0.11867286E-09_JPRB, 0.11393242E-09_JPRB, 0.10965917E-09_JPRB, 0.10574998E-09_JPRB, 0.10214818E-09_JPRB, &
  & 0.98743312E-10_JPRB, 0.95452708E-10_JPRB, 0.92180437E-10_JPRB, 0.88804838E-10_JPRB, 0.85259702E-10_JPRB, 0.81480385E-10_JPRB, &
  & 0.77471946E-10_JPRB, 0.73267357E-10_JPRB, 0.68252952E-10_JPRB, 0.59553328E-10_JPRB /)

RGHG5(:,29, 1) = (/ &
  & 0.64920652E-10_JPRB, 0.69348999E-10_JPRB, 0.72109430E-10_JPRB, 0.74819748E-10_JPRB, 0.77834725E-10_JPRB, 0.81336556E-10_JPRB, &
  & 0.85329979E-10_JPRB, 0.89781009E-10_JPRB, 0.94622851E-10_JPRB, 0.99833225E-10_JPRB, 0.10538712E-09_JPRB, 0.11126461E-09_JPRB, &
  & 0.11737815E-09_JPRB, 0.12365299E-09_JPRB, 0.13004747E-09_JPRB, 0.13653198E-09_JPRB, 0.14307230E-09_JPRB, 0.14962917E-09_JPRB, &
  & 0.15616644E-09_JPRB, 0.16267392E-09_JPRB, 0.16908830E-09_JPRB, 0.17532596E-09_JPRB, 0.18128185E-09_JPRB, 0.18679255E-09_JPRB, &
  & 0.19166481E-09_JPRB, 0.19573457E-09_JPRB, 0.19888437E-09_JPRB, 0.20104893E-09_JPRB, 0.20231711E-09_JPRB, 0.20284009E-09_JPRB, &
  & 0.20281324E-09_JPRB, 0.20234317E-09_JPRB, 0.20162763E-09_JPRB, 0.20062185E-09_JPRB, 0.19938250E-09_JPRB, 0.19781646E-09_JPRB, &
  & 0.19582244E-09_JPRB, 0.19340804E-09_JPRB, 0.19055606E-09_JPRB, 0.18726563E-09_JPRB, 0.18349504E-09_JPRB, 0.17921287E-09_JPRB, &
  & 0.17435628E-09_JPRB, 0.16890386E-09_JPRB, 0.16291957E-09_JPRB, 0.15658300E-09_JPRB, 0.15017421E-09_JPRB, 0.14401494E-09_JPRB, &
  & 0.13827299E-09_JPRB, 0.13306023E-09_JPRB, 0.12836190E-09_JPRB, 0.12412579E-09_JPRB, 0.12027057E-09_JPRB, 0.11669946E-09_JPRB, &
  & 0.11333268E-09_JPRB, 0.11007507E-09_JPRB, 0.10681384E-09_JPRB, 0.10345316E-09_JPRB, 0.99888563E-10_JPRB, 0.96092398E-10_JPRB, &
  & 0.92073439E-10_JPRB, 0.87793349E-10_JPRB, 0.82770089E-10_JPRB, 0.73682033E-10_JPRB /)

RGHG5(:,30, 1) = (/ &
  & 0.76102499E-10_JPRB, 0.80642146E-10_JPRB, 0.83468517E-10_JPRB, 0.86155458E-10_JPRB, 0.89147176E-10_JPRB, 0.92564165E-10_JPRB, &
  & 0.96448301E-10_JPRB, 0.10072209E-09_JPRB, 0.10534820E-09_JPRB, 0.11029098E-09_JPRB, 0.11558937E-09_JPRB, 0.12120661E-09_JPRB, &
  & 0.12711407E-09_JPRB, 0.13326835E-09_JPRB, 0.13960527E-09_JPRB, 0.14607868E-09_JPRB, 0.15264826E-09_JPRB, 0.15927594E-09_JPRB, &
  & 0.16591885E-09_JPRB, 0.17256602E-09_JPRB, 0.17916978E-09_JPRB, 0.18565721E-09_JPRB, 0.19191779E-09_JPRB, 0.19780970E-09_JPRB, &
  & 0.20311082E-09_JPRB, 0.20761648E-09_JPRB, 0.21119466E-09_JPRB, 0.21371452E-09_JPRB, 0.21521707E-09_JPRB, 0.21581439E-09_JPRB, &
  & 0.21568577E-09_JPRB, 0.21495056E-09_JPRB, 0.21381183E-09_JPRB, 0.21234857E-09_JPRB, 0.21064760E-09_JPRB, 0.20872692E-09_JPRB, &
  & 0.20654503E-09_JPRB, 0.20412189E-09_JPRB, 0.20143257E-09_JPRB, 0.19842603E-09_JPRB, 0.19501629E-09_JPRB, 0.19111755E-09_JPRB, &
  & 0.18664219E-09_JPRB, 0.18154224E-09_JPRB, 0.17585683E-09_JPRB, 0.16975876E-09_JPRB, 0.16352923E-09_JPRB, 0.15745630E-09_JPRB, &
  & 0.15181491E-09_JPRB, 0.14667301E-09_JPRB, 0.14205109E-09_JPRB, 0.13788130E-09_JPRB, 0.13406683E-09_JPRB, 0.13054338E-09_JPRB, &
  & 0.12720872E-09_JPRB, 0.12397861E-09_JPRB, 0.12074973E-09_JPRB, 0.11740967E-09_JPRB, 0.11389609E-09_JPRB, 0.11016042E-09_JPRB, &
  & 0.10626952E-09_JPRB, 0.10214174E-09_JPRB, 0.97355873E-10_JPRB, 0.88390809E-10_JPRB /)

RGHG5(:,31, 1) = (/ &
  & 0.87825150E-10_JPRB, 0.92373366E-10_JPRB, 0.95151421E-10_JPRB, 0.97785273E-10_JPRB, 0.10064995E-09_JPRB, 0.10393385E-09_JPRB, &
  & 0.10762421E-09_JPRB, 0.11167288E-09_JPRB, 0.11601666E-09_JPRB, 0.12064462E-09_JPRB, 0.12562590E-09_JPRB, 0.13094076E-09_JPRB, &
  & 0.13658236E-09_JPRB, 0.14252656E-09_JPRB, 0.14873716E-09_JPRB, 0.15515278E-09_JPRB, 0.16171903E-09_JPRB, 0.16836781E-09_JPRB, &
  & 0.17504551E-09_JPRB, 0.18172477E-09_JPRB, 0.18835178E-09_JPRB, 0.19487645E-09_JPRB, 0.20120103E-09_JPRB, 0.20717342E-09_JPRB, &
  & 0.21258725E-09_JPRB, 0.21726707E-09_JPRB, 0.22103983E-09_JPRB, 0.22377825E-09_JPRB, 0.22548313E-09_JPRB, 0.22621331E-09_JPRB, &
  & 0.22612980E-09_JPRB, 0.22534213E-09_JPRB, 0.22402118E-09_JPRB, 0.22234742E-09_JPRB, 0.22041352E-09_JPRB, 0.21833485E-09_JPRB, &
  & 0.21610874E-09_JPRB, 0.21377042E-09_JPRB, 0.21127478E-09_JPRB, 0.20854524E-09_JPRB, 0.20546365E-09_JPRB, 0.20191294E-09_JPRB, &
  & 0.19777788E-09_JPRB, 0.19300209E-09_JPRB, 0.18762862E-09_JPRB, 0.18180529E-09_JPRB, 0.17579728E-09_JPRB, 0.16993762E-09_JPRB, &
  & 0.16441704E-09_JPRB, 0.15940391E-09_JPRB, 0.15487370E-09_JPRB, 0.15076336E-09_JPRB, 0.14700777E-09_JPRB, 0.14350883E-09_JPRB, &
  & 0.14020303E-09_JPRB, 0.13698827E-09_JPRB, 0.13377967E-09_JPRB, 0.13048142E-09_JPRB, 0.12702263E-09_JPRB, 0.12341464E-09_JPRB, &
  & 0.11968151E-09_JPRB, 0.11584929E-09_JPRB, 0.11123981E-09_JPRB, 0.10301862E-09_JPRB /)

RGHG5(:,32, 1) = (/ &
  & 0.99877683E-10_JPRB, 0.10432982E-09_JPRB, 0.10700893E-09_JPRB, 0.10951125E-09_JPRB, 0.11222875E-09_JPRB, 0.11531139E-09_JPRB, &
  & 0.11878584E-09_JPRB, 0.12256632E-09_JPRB, 0.12660489E-09_JPRB, 0.13089116E-09_JPRB, 0.13551572E-09_JPRB, 0.14047985E-09_JPRB, &
  & 0.14582692E-09_JPRB, 0.15156103E-09_JPRB, 0.15763708E-09_JPRB, 0.16398660E-09_JPRB, 0.17052930E-09_JPRB, 0.17717391E-09_JPRB, &
  & 0.18383207E-09_JPRB, 0.19047210E-09_JPRB, 0.19703496E-09_JPRB, 0.20346383E-09_JPRB, 0.20965277E-09_JPRB, 0.21549296E-09_JPRB, &
  & 0.22077372E-09_JPRB, 0.22536750E-09_JPRB, 0.22912797E-09_JPRB, 0.23193154E-09_JPRB, 0.23376073E-09_JPRB, 0.23462343E-09_JPRB, &
  & 0.23466462E-09_JPRB, 0.23395458E-09_JPRB, 0.23264850E-09_JPRB, 0.23095967E-09_JPRB, 0.22899196E-09_JPRB, 0.22691356E-09_JPRB, &
  & 0.22476360E-09_JPRB, 0.22256066E-09_JPRB, 0.22026750E-09_JPRB, 0.21777932E-09_JPRB, 0.21496602E-09_JPRB, 0.21168582E-09_JPRB, &
  & 0.20782112E-09_JPRB, 0.20331493E-09_JPRB, 0.19820642E-09_JPRB, 0.19266819E-09_JPRB, 0.18694553E-09_JPRB, 0.18130605E-09_JPRB, &
  & 0.17600958E-09_JPRB, 0.17114364E-09_JPRB, 0.16672701E-09_JPRB, 0.16269902E-09_JPRB, 0.15898700E-09_JPRB, 0.15552684E-09_JPRB, &
  & 0.15222960E-09_JPRB, 0.14903241E-09_JPRB, 0.14584478E-09_JPRB, 0.14258178E-09_JPRB, 0.13920420E-09_JPRB, 0.13571265E-09_JPRB, &
  & 0.13219154E-09_JPRB, 0.12852083E-09_JPRB, 0.12439808E-09_JPRB, 0.11659937E-09_JPRB /)

RGHG5(:,33, 1) = (/ &
  & 0.11205182E-09_JPRB, 0.11628296E-09_JPRB, 0.11882334E-09_JPRB, 0.12117912E-09_JPRB, 0.12370666E-09_JPRB, 0.12659038E-09_JPRB, &
  & 0.12982539E-09_JPRB, 0.13333930E-09_JPRB, 0.13706047E-09_JPRB, 0.14100586E-09_JPRB, 0.14524519E-09_JPRB, 0.14983365E-09_JPRB, &
  & 0.15484161E-09_JPRB, 0.16031206E-09_JPRB, 0.16624108E-09_JPRB, 0.17254115E-09_JPRB, 0.17909076E-09_JPRB, 0.18575519E-09_JPRB, &
  & 0.19241927E-09_JPRB, 0.19900470E-09_JPRB, 0.20544451E-09_JPRB, 0.21167858E-09_JPRB, 0.21763383E-09_JPRB, 0.22314710E-09_JPRB, &
  & 0.22811388E-09_JPRB, 0.23241434E-09_JPRB, 0.23596641E-09_JPRB, 0.23869118E-09_JPRB, 0.24054173E-09_JPRB, 0.24149849E-09_JPRB, &
  & 0.24168939E-09_JPRB, 0.24113683E-09_JPRB, 0.23999414E-09_JPRB, 0.23844079E-09_JPRB, 0.23659799E-09_JPRB, 0.23464744E-09_JPRB, &
  & 0.23264453E-09_JPRB, 0.23061965E-09_JPRB, 0.22852795E-09_JPRB, 0.22625432E-09_JPRB, 0.22364285E-09_JPRB, 0.22054671E-09_JPRB, &
  & 0.21685877E-09_JPRB, 0.21253177E-09_JPRB, 0.20765130E-09_JPRB, 0.20236769E-09_JPRB, 0.19691467E-09_JPRB, 0.19157059E-09_JPRB, &
  & 0.18649915E-09_JPRB, 0.18183356E-09_JPRB, 0.17755622E-09_JPRB, 0.17362302E-09_JPRB, 0.16997978E-09_JPRB, 0.16654353E-09_JPRB, &
  & 0.16327295E-09_JPRB, 0.16008975E-09_JPRB, 0.15692882E-09_JPRB, 0.15370921E-09_JPRB, 0.15040710E-09_JPRB, 0.14704217E-09_JPRB, &
  & 0.14364407E-09_JPRB, 0.14023448E-09_JPRB, 0.13616640E-09_JPRB, 0.12905829E-09_JPRB /)

RGHG5(:,34, 1) = (/ &
  & 0.12405373E-09_JPRB, 0.12806212E-09_JPRB, 0.13042199E-09_JPRB, 0.13260552E-09_JPRB, 0.13496429E-09_JPRB, 0.13763903E-09_JPRB, &
  & 0.14064927E-09_JPRB, 0.14389971E-09_JPRB, 0.14731735E-09_JPRB, 0.15092211E-09_JPRB, 0.15477619E-09_JPRB, 0.15897583E-09_JPRB, &
  & 0.16363950E-09_JPRB, 0.16884752E-09_JPRB, 0.17460910E-09_JPRB, 0.18084913E-09_JPRB, 0.18740839E-09_JPRB, 0.19411382E-09_JPRB, &
  & 0.20080301E-09_JPRB, 0.20732566E-09_JPRB, 0.21362809E-09_JPRB, 0.21965788E-09_JPRB, 0.22526007E-09_JPRB, 0.23036045E-09_JPRB, &
  & 0.23483943E-09_JPRB, 0.23869109E-09_JPRB, 0.24188082E-09_JPRB, 0.24436750E-09_JPRB, 0.24611904E-09_JPRB, 0.24710936E-09_JPRB, &
  & 0.24742644E-09_JPRB, 0.24707469E-09_JPRB, 0.24619451E-09_JPRB, 0.24489016E-09_JPRB, 0.24330338E-09_JPRB, 0.24159136E-09_JPRB, &
  & 0.23981395E-09_JPRB, 0.23800989E-09_JPRB, 0.23612456E-09_JPRB, 0.23402830E-09_JPRB, 0.23156475E-09_JPRB, 0.22858045E-09_JPRB, &
  & 0.22497748E-09_JPRB, 0.22076470E-09_JPRB, 0.21602845E-09_JPRB, 0.21096691E-09_JPRB, 0.20580329E-09_JPRB, 0.20072040E-09_JPRB, &
  & 0.19592342E-09_JPRB, 0.19145148E-09_JPRB, 0.18732665E-09_JPRB, 0.18350671E-09_JPRB, 0.17992027E-09_JPRB, 0.17653830E-09_JPRB, &
  & 0.17329316E-09_JPRB, 0.17014336E-09_JPRB, 0.16700322E-09_JPRB, 0.16383830E-09_JPRB, 0.16061258E-09_JPRB, 0.15734287E-09_JPRB, &
  & 0.15408312E-09_JPRB, 0.15071056E-09_JPRB, 0.14696269E-09_JPRB, 0.14002768E-09_JPRB /)

RGHG5(:,35, 1) = (/ &
  & 0.13578161E-09_JPRB, 0.13948874E-09_JPRB, 0.14167836E-09_JPRB, 0.14370261E-09_JPRB, 0.14587881E-09_JPRB, 0.14837093E-09_JPRB, &
  & 0.15116094E-09_JPRB, 0.15416396E-09_JPRB, 0.15729067E-09_JPRB, 0.16056180E-09_JPRB, 0.16403232E-09_JPRB, 0.16783047E-09_JPRB, &
  & 0.17211989E-09_JPRB, 0.17703683E-09_JPRB, 0.18262512E-09_JPRB, 0.18880959E-09_JPRB, 0.19539143E-09_JPRB, 0.20215653E-09_JPRB, &
  & 0.20887676E-09_JPRB, 0.21536649E-09_JPRB, 0.22155436E-09_JPRB, 0.22730738E-09_JPRB, 0.23251677E-09_JPRB, 0.23708263E-09_JPRB, &
  & 0.24098565E-09_JPRB, 0.24425018E-09_JPRB, 0.24691771E-09_JPRB, 0.24903232E-09_JPRB, 0.25053604E-09_JPRB, 0.25146693E-09_JPRB, &
  & 0.25183672E-09_JPRB, 0.25168559E-09_JPRB, 0.25107985E-09_JPRB, 0.25009772E-09_JPRB, 0.24885757E-09_JPRB, 0.24746047E-09_JPRB, &
  & 0.24598371E-09_JPRB, 0.24445265E-09_JPRB, 0.24280056E-09_JPRB, 0.24089811E-09_JPRB, 0.23858787E-09_JPRB, 0.23571006E-09_JPRB, &
  & 0.23218839E-09_JPRB, 0.22803610E-09_JPRB, 0.22342947E-09_JPRB, 0.21857297E-09_JPRB, 0.21363855E-09_JPRB, 0.20885015E-09_JPRB, &
  & 0.20427472E-09_JPRB, 0.20001037E-09_JPRB, 0.19603437E-09_JPRB, 0.19230668E-09_JPRB, 0.18879838E-09_JPRB, 0.18546101E-09_JPRB, &
  & 0.18226515E-09_JPRB, 0.17914044E-09_JPRB, 0.17605289E-09_JPRB, 0.17293592E-09_JPRB, 0.16978918E-09_JPRB, 0.16661444E-09_JPRB, &
  & 0.16342502E-09_JPRB, 0.16021913E-09_JPRB, 0.15644623E-09_JPRB, 0.14989111E-09_JPRB /)

RGHG5(:,36, 1) = (/ &
  & 0.14711002E-09_JPRB, 0.15052382E-09_JPRB, 0.15252100E-09_JPRB, 0.15437292E-09_JPRB, 0.15639852E-09_JPRB, 0.15870352E-09_JPRB, &
  & 0.16129785E-09_JPRB, 0.16406425E-09_JPRB, 0.16692042E-09_JPRB, 0.16985877E-09_JPRB, 0.17295468E-09_JPRB, 0.17634265E-09_JPRB, &
  & 0.18022964E-09_JPRB, 0.18480965E-09_JPRB, 0.19018043E-09_JPRB, 0.19626414E-09_JPRB, 0.20286847E-09_JPRB, 0.20971208E-09_JPRB, &
  & 0.21650073E-09_JPRB, 0.22300763E-09_JPRB, 0.22905643E-09_JPRB, 0.23449584E-09_JPRB, 0.23920244E-09_JPRB, 0.24312499E-09_JPRB, &
  & 0.24630734E-09_JPRB, 0.24887384E-09_JPRB, 0.25092736E-09_JPRB, 0.25254140E-09_JPRB, 0.25372379E-09_JPRB, 0.25449542E-09_JPRB, &
  & 0.25484970E-09_JPRB, 0.25482799E-09_JPRB, 0.25443875E-09_JPRB, 0.25375591E-09_JPRB, 0.25283955E-09_JPRB, 0.25177052E-09_JPRB, &
  & 0.25061012E-09_JPRB, 0.24936675E-09_JPRB, 0.24798619E-09_JPRB, 0.24635383E-09_JPRB, 0.24429819E-09_JPRB, 0.24165275E-09_JPRB, &
  & 0.23831631E-09_JPRB, 0.23433269E-09_JPRB, 0.22988625E-09_JPRB, 0.22520778E-09_JPRB, 0.22053699E-09_JPRB, 0.21596824E-09_JPRB, &
  & 0.21163540E-09_JPRB, 0.20753860E-09_JPRB, 0.20368095E-09_JPRB, 0.20004959E-09_JPRB, 0.19660465E-09_JPRB, 0.19333249E-09_JPRB, &
  & 0.19018202E-09_JPRB, 0.18711978E-09_JPRB, 0.18407861E-09_JPRB, 0.18103763E-09_JPRB, 0.17796191E-09_JPRB, 0.17487016E-09_JPRB, &
  & 0.17178836E-09_JPRB, 0.16861844E-09_JPRB, 0.16506263E-09_JPRB, 0.15866029E-09_JPRB /)

RGHG5(:,37, 1) = (/ &
  & 0.15803947E-09_JPRB, 0.16109555E-09_JPRB, 0.16290383E-09_JPRB, 0.16460194E-09_JPRB, 0.16646622E-09_JPRB, 0.16861892E-09_JPRB, &
  & 0.17102411E-09_JPRB, 0.17357396E-09_JPRB, 0.17616761E-09_JPRB, 0.17878657E-09_JPRB, 0.18151208E-09_JPRB, 0.18447821E-09_JPRB, &
  & 0.18794793E-09_JPRB, 0.19213718E-09_JPRB, 0.19725155E-09_JPRB, 0.20322841E-09_JPRB, 0.20982131E-09_JPRB, 0.21672027E-09_JPRB, &
  & 0.22357331E-09_JPRB, 0.23005335E-09_JPRB, 0.23587765E-09_JPRB, 0.24086463E-09_JPRB, 0.24488206E-09_JPRB, 0.24802538E-09_JPRB, &
  & 0.25042596E-09_JPRB, 0.25228794E-09_JPRB, 0.25374547E-09_JPRB, 0.25491134E-09_JPRB, 0.25578373E-09_JPRB, 0.25638958E-09_JPRB, &
  & 0.25670549E-09_JPRB, 0.25673855E-09_JPRB, 0.25649380E-09_JPRB, 0.25600982E-09_JPRB, 0.25533103E-09_JPRB, 0.25451846E-09_JPRB, &
  & 0.25361099E-09_JPRB, 0.25261793E-09_JPRB, 0.25149821E-09_JPRB, 0.25015265E-09_JPRB, 0.24843080E-09_JPRB, 0.24615704E-09_JPRB, &
  & 0.24319527E-09_JPRB, 0.23953764E-09_JPRB, 0.23535485E-09_JPRB, 0.23093671E-09_JPRB, 0.22649237E-09_JPRB, 0.22218230E-09_JPRB, &
  & 0.21803583E-09_JPRB, 0.21409285E-09_JPRB, 0.21035210E-09_JPRB, 0.20679494E-09_JPRB, 0.20342124E-09_JPRB, 0.20020921E-09_JPRB, &
  & 0.19714086E-09_JPRB, 0.19416024E-09_JPRB, 0.19122046E-09_JPRB, 0.18825660E-09_JPRB, 0.18526600E-09_JPRB, 0.18225330E-09_JPRB, &
  & 0.17924474E-09_JPRB, 0.17621711E-09_JPRB, 0.17274841E-09_JPRB, 0.16667955E-09_JPRB /)

RGHG5(:,38, 1) = (/ &
  & 0.16846677E-09_JPRB, 0.17117274E-09_JPRB, 0.17277985E-09_JPRB, 0.17432582E-09_JPRB, 0.17605413E-09_JPRB, 0.17806412E-09_JPRB, &
  & 0.18030195E-09_JPRB, 0.18264495E-09_JPRB, 0.18498514E-09_JPRB, 0.18730209E-09_JPRB, 0.18965181E-09_JPRB, 0.19223100E-09_JPRB, &
  & 0.19523380E-09_JPRB, 0.19901639E-09_JPRB, 0.20377006E-09_JPRB, 0.20957493E-09_JPRB, 0.21613808E-09_JPRB, 0.22305484E-09_JPRB, &
  & 0.22988658E-09_JPRB, 0.23619667E-09_JPRB, 0.24159541E-09_JPRB, 0.24587862E-09_JPRB, 0.24911564E-09_JPRB, 0.25147717E-09_JPRB, &
  & 0.25320485E-09_JPRB, 0.25452648E-09_JPRB, 0.25555799E-09_JPRB, 0.25640046E-09_JPRB, 0.25706537E-09_JPRB, 0.25754571E-09_JPRB, &
  & 0.25782806E-09_JPRB, 0.25788530E-09_JPRB, 0.25772387E-09_JPRB, 0.25735952E-09_JPRB, 0.25683419E-09_JPRB, 0.25618990E-09_JPRB, &
  & 0.25546121E-09_JPRB, 0.25465333E-09_JPRB, 0.25373537E-09_JPRB, 0.25262961E-09_JPRB, 0.25120631E-09_JPRB, 0.24930416E-09_JPRB, &
  & 0.24677921E-09_JPRB, 0.24356325E-09_JPRB, 0.23979529E-09_JPRB, 0.23570521E-09_JPRB, 0.23156312E-09_JPRB, 0.22747990E-09_JPRB, &
  & 0.22353348E-09_JPRB, 0.21973941E-09_JPRB, 0.21609342E-09_JPRB, 0.21262012E-09_JPRB, 0.20932206E-09_JPRB, 0.20621557E-09_JPRB, &
  & 0.20327290E-09_JPRB, 0.20042971E-09_JPRB, 0.19762181E-09_JPRB, 0.19477969E-09_JPRB, 0.19187857E-09_JPRB, 0.18893608E-09_JPRB, &
  & 0.18601379E-09_JPRB, 0.18307503E-09_JPRB, 0.17979543E-09_JPRB, 0.17404771E-09_JPRB /)

RGHG5(:,39, 1) = (/ &
  & 0.17829926E-09_JPRB, 0.18063417E-09_JPRB, 0.18206694E-09_JPRB, 0.18346817E-09_JPRB, 0.18508610E-09_JPRB, 0.18696664E-09_JPRB, &
  & 0.18905266E-09_JPRB, 0.19119359E-09_JPRB, 0.19329290E-09_JPRB, 0.19530691E-09_JPRB, 0.19734550E-09_JPRB, 0.19951185E-09_JPRB, &
  & 0.20212380E-09_JPRB, 0.20542187E-09_JPRB, 0.20980113E-09_JPRB, 0.21532098E-09_JPRB, 0.22177016E-09_JPRB, 0.22862645E-09_JPRB, &
  & 0.23527558E-09_JPRB, 0.24116040E-09_JPRB, 0.24589078E-09_JPRB, 0.24942054E-09_JPRB, 0.25191857E-09_JPRB, 0.25369173E-09_JPRB, &
  & 0.25496538E-09_JPRB, 0.25593869E-09_JPRB, 0.25671193E-09_JPRB, 0.25735947E-09_JPRB, 0.25789226E-09_JPRB, 0.25829633E-09_JPRB, &
  & 0.25855071E-09_JPRB, 0.25862232E-09_JPRB, 0.25850772E-09_JPRB, 0.25821781E-09_JPRB, 0.25778787E-09_JPRB, 0.25725544E-09_JPRB, &
  & 0.25664881E-09_JPRB, 0.25597199E-09_JPRB, 0.25519911E-09_JPRB, 0.25426813E-09_JPRB, 0.25307384E-09_JPRB, 0.25148023E-09_JPRB, &
  & 0.24934244E-09_JPRB, 0.24659003E-09_JPRB, 0.24326119E-09_JPRB, 0.23958757E-09_JPRB, 0.23575258E-09_JPRB, 0.23193886E-09_JPRB, &
  & 0.22820032E-09_JPRB, 0.22454714E-09_JPRB, 0.22101743E-09_JPRB, 0.21763484E-09_JPRB, 0.21444609E-09_JPRB, 0.21147897E-09_JPRB, &
  & 0.20869627E-09_JPRB, 0.20605084E-09_JPRB, 0.20342787E-09_JPRB, 0.20075050E-09_JPRB, 0.19796158E-09_JPRB, 0.19510263E-09_JPRB, &
  & 0.19225550E-09_JPRB, 0.18944080E-09_JPRB, 0.18632630E-09_JPRB, 0.18094122E-09_JPRB /)

RGHG5(:,40, 1) = (/ &
  & 0.18737051E-09_JPRB, 0.18939389E-09_JPRB, 0.19065710E-09_JPRB, 0.19194855E-09_JPRB, 0.19345499E-09_JPRB, 0.19523992E-09_JPRB, &
  & 0.19717200E-09_JPRB, 0.19912061E-09_JPRB, 0.20097715E-09_JPRB, 0.20274678E-09_JPRB, 0.20446135E-09_JPRB, 0.20634106E-09_JPRB, &
  & 0.20852010E-09_JPRB, 0.21142656E-09_JPRB, 0.21534406E-09_JPRB, 0.22055718E-09_JPRB, 0.22677356E-09_JPRB, 0.23338320E-09_JPRB, &
  & 0.23965852E-09_JPRB, 0.24492794E-09_JPRB, 0.24893285E-09_JPRB, 0.25177530E-09_JPRB, 0.25373686E-09_JPRB, 0.25510946E-09_JPRB, &
  & 0.25610344E-09_JPRB, 0.25686767E-09_JPRB, 0.25748989E-09_JPRB, 0.25802072E-09_JPRB, 0.25847241E-09_JPRB, 0.25882771E-09_JPRB, &
  & 0.25906041E-09_JPRB, 0.25913932E-09_JPRB, 0.25905275E-09_JPRB, 0.25881031E-09_JPRB, 0.25844296E-09_JPRB, 0.25798608E-09_JPRB, &
  & 0.25746530E-09_JPRB, 0.25688171E-09_JPRB, 0.25621355E-09_JPRB, 0.25540850E-09_JPRB, 0.25438190E-09_JPRB, 0.25301750E-09_JPRB, &
  & 0.25119631E-09_JPRB, 0.24882379E-09_JPRB, 0.24593691E-09_JPRB, 0.24264474E-09_JPRB, 0.23917768E-09_JPRB, 0.23564903E-09_JPRB, &
  & 0.23212460E-09_JPRB, 0.22864916E-09_JPRB, 0.22524052E-09_JPRB, 0.22196385E-09_JPRB, 0.21890476E-09_JPRB, 0.21609103E-09_JPRB, &
  & 0.21353271E-09_JPRB, 0.21110898E-09_JPRB, 0.20872648E-09_JPRB, 0.20624885E-09_JPRB, 0.20362501E-09_JPRB, 0.20087777E-09_JPRB, &
  & 0.19813580E-09_JPRB, 0.19544458E-09_JPRB, 0.19251054E-09_JPRB, 0.18748132E-09_JPRB /)

RGHG5(:,41, 1) = (/ &
  & 0.19561040E-09_JPRB, 0.19736753E-09_JPRB, 0.19849485E-09_JPRB, 0.19968099E-09_JPRB, 0.20111809E-09_JPRB, 0.20279831E-09_JPRB, &
  & 0.20459530E-09_JPRB, 0.20635221E-09_JPRB, 0.20800059E-09_JPRB, 0.20952620E-09_JPRB, 0.21102702E-09_JPRB, 0.21259194E-09_JPRB, &
  & 0.21450078E-09_JPRB, 0.21696384E-09_JPRB, 0.22047250E-09_JPRB, 0.22526035E-09_JPRB, 0.23117640E-09_JPRB, 0.23744046E-09_JPRB, &
  & 0.24313279E-09_JPRB, 0.24773605E-09_JPRB, 0.25107910E-09_JPRB, 0.25338703E-09_JPRB, 0.25497190E-09_JPRB, 0.25607536E-09_JPRB, &
  & 0.25689725E-09_JPRB, 0.25753022E-09_JPRB, 0.25805999E-09_JPRB, 0.25852018E-09_JPRB, 0.25891764E-09_JPRB, 0.25923977E-09_JPRB, &
  & 0.25945429E-09_JPRB, 0.25953464E-09_JPRB, 0.25946512E-09_JPRB, 0.25925434E-09_JPRB, 0.25892949E-09_JPRB, 0.25852659E-09_JPRB, &
  & 0.25806801E-09_JPRB, 0.25755495E-09_JPRB, 0.25696603E-09_JPRB, 0.25625840E-09_JPRB, 0.25536009E-09_JPRB, 0.25417485E-09_JPRB, &
  & 0.25259464E-09_JPRB, 0.25054325E-09_JPRB, 0.24800786E-09_JPRB, 0.24511354E-09_JPRB, 0.24197797E-09_JPRB, 0.23874214E-09_JPRB, &
  & 0.23546989E-09_JPRB, 0.23217397E-09_JPRB, 0.22889693E-09_JPRB, 0.22574470E-09_JPRB, 0.22280541E-09_JPRB, 0.22019610E-09_JPRB, &
  & 0.21785138E-09_JPRB, 0.21569728E-09_JPRB, 0.21356472E-09_JPRB, 0.21134108E-09_JPRB, 0.20892543E-09_JPRB, 0.20635312E-09_JPRB, &
  & 0.20376519E-09_JPRB, 0.20122738E-09_JPRB, 0.19847930E-09_JPRB, 0.19379630E-09_JPRB /)

RGHG5(:,42, 1) = (/ &
  & 0.20302145E-09_JPRB, 0.20456054E-09_JPRB, 0.20558245E-09_JPRB, 0.20668482E-09_JPRB, 0.20804947E-09_JPRB, 0.20965135E-09_JPRB, &
  & 0.21131291E-09_JPRB, 0.21289767E-09_JPRB, 0.21435530E-09_JPRB, 0.21569972E-09_JPRB, 0.21699040E-09_JPRB, 0.21836477E-09_JPRB, &
  & 0.21997046E-09_JPRB, 0.22215196E-09_JPRB, 0.22522903E-09_JPRB, 0.22961638E-09_JPRB, 0.23511432E-09_JPRB, 0.24089705E-09_JPRB, &
  & 0.24600272E-09_JPRB, 0.24989405E-09_JPRB, 0.25266669E-09_JPRB, 0.25455649E-09_JPRB, 0.25586738E-09_JPRB, 0.25679001E-09_JPRB, &
  & 0.25749389E-09_JPRB, 0.25804295E-09_JPRB, 0.25851404E-09_JPRB, 0.25892646E-09_JPRB, 0.25928865E-09_JPRB, 0.25958366E-09_JPRB, &
  & 0.25978170E-09_JPRB, 0.25985872E-09_JPRB, 0.25979927E-09_JPRB, 0.25960933E-09_JPRB, 0.25931515E-09_JPRB, 0.25895136E-09_JPRB, &
  & 0.25854027E-09_JPRB, 0.25808189E-09_JPRB, 0.25755681E-09_JPRB, 0.25692706E-09_JPRB, 0.25613195E-09_JPRB, 0.25509034E-09_JPRB, &
  & 0.25371330E-09_JPRB, 0.25192115E-09_JPRB, 0.24970642E-09_JPRB, 0.24712454E-09_JPRB, 0.24431657E-09_JPRB, 0.24137692E-09_JPRB, &
  & 0.23835331E-09_JPRB, 0.23526109E-09_JPRB, 0.23214941E-09_JPRB, 0.22910301E-09_JPRB, 0.22633222E-09_JPRB, 0.22390055E-09_JPRB, &
  & 0.22180707E-09_JPRB, 0.21990432E-09_JPRB, 0.21804683E-09_JPRB, 0.21608582E-09_JPRB, 0.21393126E-09_JPRB, 0.21160054E-09_JPRB, &
  & 0.20921824E-09_JPRB, 0.20687731E-09_JPRB, 0.20432674E-09_JPRB, 0.19997788E-09_JPRB /)

RGHG5(:,43, 1) = (/ &
  & 0.20966201E-09_JPRB, 0.21104755E-09_JPRB, 0.21197118E-09_JPRB, 0.21300844E-09_JPRB, 0.21431470E-09_JPRB, 0.21583883E-09_JPRB, &
  & 0.21738186E-09_JPRB, 0.21881733E-09_JPRB, 0.22012170E-09_JPRB, 0.22130893E-09_JPRB, 0.22245200E-09_JPRB, 0.22364170E-09_JPRB, &
  & 0.22505886E-09_JPRB, 0.22691596E-09_JPRB, 0.22967375E-09_JPRB, 0.23361524E-09_JPRB, 0.23866317E-09_JPRB, 0.24386462E-09_JPRB, &
  & 0.24829019E-09_JPRB, 0.25159053E-09_JPRB, 0.25388439E-09_JPRB, 0.25545316E-09_JPRB, 0.25655700E-09_JPRB, 0.25735286E-09_JPRB, &
  & 0.25797225E-09_JPRB, 0.25846633E-09_JPRB, 0.25889654E-09_JPRB, 0.25927926E-09_JPRB, 0.25961328E-09_JPRB, 0.25988700E-09_JPRB, &
  & 0.26006794E-09_JPRB, 0.26013794E-09_JPRB, 0.26008309E-09_JPRB, 0.25990751E-09_JPRB, 0.25963509E-09_JPRB, 0.25930094E-09_JPRB, &
  & 0.25892666E-09_JPRB, 0.25851232E-09_JPRB, 0.25803995E-09_JPRB, 0.25747610E-09_JPRB, 0.25676913E-09_JPRB, 0.25585092E-09_JPRB, &
  & 0.25464206E-09_JPRB, 0.25307287E-09_JPRB, 0.25111785E-09_JPRB, 0.24883365E-09_JPRB, 0.24631641E-09_JPRB, 0.24365612E-09_JPRB, &
  & 0.24089222E-09_JPRB, 0.23802679E-09_JPRB, 0.23507610E-09_JPRB, 0.23220489E-09_JPRB, 0.22958628E-09_JPRB, 0.22737885E-09_JPRB, &
  & 0.22552178E-09_JPRB, 0.22387137E-09_JPRB, 0.22227116E-09_JPRB, 0.22057924E-09_JPRB, 0.21870961E-09_JPRB, 0.21666396E-09_JPRB, &
  & 0.21455451E-09_JPRB, 0.21244542E-09_JPRB, 0.21012185E-09_JPRB, 0.20612387E-09_JPRB /)

RGHG5(:,44, 1) = (/ &
  & 0.21565341E-09_JPRB, 0.21691915E-09_JPRB, 0.21777913E-09_JPRB, 0.21875415E-09_JPRB, 0.22000979E-09_JPRB, 0.22146474E-09_JPRB, &
  & 0.22290664E-09_JPRB, 0.22422691E-09_JPRB, 0.22540525E-09_JPRB, 0.22647553E-09_JPRB, 0.22748860E-09_JPRB, 0.22854077E-09_JPRB, &
  & 0.22976596E-09_JPRB, 0.23141203E-09_JPRB, 0.23379285E-09_JPRB, 0.23737873E-09_JPRB, 0.24192245E-09_JPRB, 0.24650640E-09_JPRB, &
  & 0.25024777E-09_JPRB, 0.25295815E-09_JPRB, 0.25485458E-09_JPRB, 0.25616625E-09_JPRB, 0.25711377E-09_JPRB, 0.25781399E-09_JPRB, &
  & 0.25837280E-09_JPRB, 0.25883010E-09_JPRB, 0.25923302E-09_JPRB, 0.25959357E-09_JPRB, 0.25990921E-09_JPRB, 0.26016142E-09_JPRB, &
  & 0.26032571E-09_JPRB, 0.26038591E-09_JPRB, 0.26033167E-09_JPRB, 0.26016489E-09_JPRB, 0.25990854E-09_JPRB, 0.25959673E-09_JPRB, &
  & 0.25925145E-09_JPRB, 0.25887315E-09_JPRB, 0.25844499E-09_JPRB, 0.25793795E-09_JPRB, 0.25730762E-09_JPRB, 0.25649693E-09_JPRB, &
  & 0.25543920E-09_JPRB, 0.25406999E-09_JPRB, 0.25235511E-09_JPRB, 0.25032801E-09_JPRB, 0.24807176E-09_JPRB, 0.24567806E-09_JPRB, &
  & 0.24316824E-09_JPRB, 0.24053318E-09_JPRB, 0.23780933E-09_JPRB, 0.23511607E-09_JPRB, 0.23272395E-09_JPRB, 0.23074621E-09_JPRB, &
  & 0.22912204E-09_JPRB, 0.22770708E-09_JPRB, 0.22633942E-09_JPRB, 0.22490371E-09_JPRB, 0.22331528E-09_JPRB, 0.22157738E-09_JPRB, &
  & 0.21977455E-09_JPRB, 0.21793825E-09_JPRB, 0.21587893E-09_JPRB, 0.21227443E-09_JPRB /)

RGHG5(:,45, 1) = (/ &
  & 0.22112320E-09_JPRB, 0.22230122E-09_JPRB, 0.22311210E-09_JPRB, 0.22403922E-09_JPRB, 0.22524603E-09_JPRB, 0.22664762E-09_JPRB, &
  & 0.22801555E-09_JPRB, 0.22924557E-09_JPRB, 0.23033950E-09_JPRB, 0.23131035E-09_JPRB, 0.23221708E-09_JPRB, 0.23314362E-09_JPRB, &
  & 0.23420482E-09_JPRB, 0.23561944E-09_JPRB, 0.23771329E-09_JPRB, 0.24082930E-09_JPRB, 0.24484376E-09_JPRB, 0.24875765E-09_JPRB, &
  & 0.25185573E-09_JPRB, 0.25407662E-09_JPRB, 0.25563560E-09_JPRB, 0.25675143E-09_JPRB, 0.25756863E-09_JPRB, 0.25820465E-09_JPRB, &
  & 0.25871652E-09_JPRB, 0.25914881E-09_JPRB, 0.25953495E-09_JPRB, 0.25988167E-09_JPRB, 0.26017913E-09_JPRB, 0.26041450E-09_JPRB, &
  & 0.26056018E-09_JPRB, 0.26060892E-09_JPRB, 0.26055189E-09_JPRB, 0.26039032E-09_JPRB, 0.26014485E-09_JPRB, 0.25985009E-09_JPRB, &
  & 0.25952770E-09_JPRB, 0.25917857E-09_JPRB, 0.25878780E-09_JPRB, 0.25832950E-09_JPRB, 0.25776650E-09_JPRB, 0.25705149E-09_JPRB, &
  & 0.25612978E-09_JPRB, 0.25494079E-09_JPRB, 0.25344996E-09_JPRB, 0.25166338E-09_JPRB, 0.24966187E-09_JPRB, 0.24751406E-09_JPRB, &
  & 0.24525496E-09_JPRB, 0.24286925E-09_JPRB, 0.24036659E-09_JPRB, 0.23794255E-09_JPRB, 0.23579017E-09_JPRB, 0.23407323E-09_JPRB, &
  & 0.23268097E-09_JPRB, 0.23147509E-09_JPRB, 0.23032530E-09_JPRB, 0.22911306E-09_JPRB, 0.22778843E-09_JPRB, 0.22634961E-09_JPRB, &
  & 0.22485180E-09_JPRB, 0.22331384E-09_JPRB, 0.22155165E-09_JPRB, 0.21841133E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART1',1,ZHOOK_HANDLE)
END SUBROUTINE PART1




SUBROUTINE PART2
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART2',0,ZHOOK_HANDLE)



RGHG5(:,46, 1) = (/ &
  & 0.22616213E-09_JPRB, 0.22730604E-09_JPRB, 0.22807098E-09_JPRB, 0.22896907E-09_JPRB, 0.23013448E-09_JPRB, 0.23148555E-09_JPRB, &
  & 0.23280559E-09_JPRB, 0.23398511E-09_JPRB, 0.23500818E-09_JPRB, 0.23589936E-09_JPRB, 0.23671021E-09_JPRB, 0.23750504E-09_JPRB, &
  & 0.23842583E-09_JPRB, 0.23960184E-09_JPRB, 0.24140623E-09_JPRB, 0.24407701E-09_JPRB, 0.24748234E-09_JPRB, 0.25070254E-09_JPRB, &
  & 0.25319541E-09_JPRB, 0.25498700E-09_JPRB, 0.25627733E-09_JPRB, 0.25722852E-09_JPRB, 0.25795668E-09_JPRB, 0.25853553E-09_JPRB, &
  & 0.25901700E-09_JPRB, 0.25943581E-09_JPRB, 0.25980884E-09_JPRB, 0.26014563E-09_JPRB, 0.26043157E-09_JPRB, 0.26064562E-09_JPRB, &
  & 0.26077451E-09_JPRB, 0.26081010E-09_JPRB, 0.26074812E-09_JPRB, 0.26058794E-09_JPRB, 0.26035032E-09_JPRB, 0.26006805E-09_JPRB, &
  & 0.25976363E-09_JPRB, 0.25943828E-09_JPRB, 0.25907829E-09_JPRB, 0.25866187E-09_JPRB, 0.25815741E-09_JPRB, 0.25752797E-09_JPRB, &
  & 0.25672944E-09_JPRB, 0.25571412E-09_JPRB, 0.25443905E-09_JPRB, 0.25289804E-09_JPRB, 0.25113983E-09_JPRB, 0.24924030E-09_JPRB, &
  & 0.24722949E-09_JPRB, 0.24508595E-09_JPRB, 0.24286936E-09_JPRB, 0.24068428E-09_JPRB, 0.23885949E-09_JPRB, 0.23737817E-09_JPRB, &
  & 0.23621910E-09_JPRB, 0.23521216E-09_JPRB, 0.23424446E-09_JPRB, 0.23324187E-09_JPRB, 0.23214411E-09_JPRB, 0.23096916E-09_JPRB, &
  & 0.22975997E-09_JPRB, 0.22850752E-09_JPRB, 0.22705192E-09_JPRB, 0.22442943E-09_JPRB /)

RGHG5(:,47, 1) = (/ &
  & 0.23089303E-09_JPRB, 0.23198349E-09_JPRB, 0.23274283E-09_JPRB, 0.23359936E-09_JPRB, 0.23473298E-09_JPRB, 0.23605684E-09_JPRB, &
  & 0.23734067E-09_JPRB, 0.23849006E-09_JPRB, 0.23945870E-09_JPRB, 0.24027452E-09_JPRB, 0.24097846E-09_JPRB, 0.24166866E-09_JPRB, &
  & 0.24240776E-09_JPRB, 0.24341890E-09_JPRB, 0.24483060E-09_JPRB, 0.24706084E-09_JPRB, 0.24977859E-09_JPRB, 0.25233615E-09_JPRB, &
  & 0.25429306E-09_JPRB, 0.25573263E-09_JPRB, 0.25680130E-09_JPRB, 0.25763092E-09_JPRB, 0.25828051E-09_JPRB, 0.25882615E-09_JPRB, &
  & 0.25928562E-09_JPRB, 0.25969343E-09_JPRB, 0.26006408E-09_JPRB, 0.26039210E-09_JPRB, 0.26066208E-09_JPRB, 0.26086011E-09_JPRB, &
  & 0.26096925E-09_JPRB, 0.26099145E-09_JPRB, 0.26092223E-09_JPRB, 0.26076183E-09_JPRB, 0.26052832E-09_JPRB, 0.26025576E-09_JPRB, &
  & 0.25996535E-09_JPRB, 0.25965854E-09_JPRB, 0.25932423E-09_JPRB, 0.25894248E-09_JPRB, 0.25848867E-09_JPRB, 0.25793387E-09_JPRB, &
  & 0.25724720E-09_JPRB, 0.25639271E-09_JPRB, 0.25533148E-09_JPRB, 0.25404587E-09_JPRB, 0.25254843E-09_JPRB, 0.25091479E-09_JPRB, &
  & 0.24915964E-09_JPRB, 0.24729435E-09_JPRB, 0.24531693E-09_JPRB, 0.24348124E-09_JPRB, 0.24188559E-09_JPRB, 0.24069693E-09_JPRB, &
  & 0.23973018E-09_JPRB, 0.23890412E-09_JPRB, 0.23811092E-09_JPRB, 0.23727503E-09_JPRB, 0.23637986E-09_JPRB, 0.23542931E-09_JPRB, &
  & 0.23446264E-09_JPRB, 0.23346547E-09_JPRB, 0.23230440E-09_JPRB, 0.23018192E-09_JPRB /)

RGHG5(:,48, 1) = (/ &
  & 0.23532362E-09_JPRB, 0.23641714E-09_JPRB, 0.23713922E-09_JPRB, 0.23799168E-09_JPRB, 0.23909155E-09_JPRB, 0.24038621E-09_JPRB, &
  & 0.24167035E-09_JPRB, 0.24278649E-09_JPRB, 0.24370805E-09_JPRB, 0.24443131E-09_JPRB, 0.24504038E-09_JPRB, 0.24559332E-09_JPRB, &
  & 0.24620900E-09_JPRB, 0.24696151E-09_JPRB, 0.24810751E-09_JPRB, 0.24971636E-09_JPRB, 0.25178906E-09_JPRB, 0.25369387E-09_JPRB, &
  & 0.25519367E-09_JPRB, 0.25634006E-09_JPRB, 0.25723684E-09_JPRB, 0.25796279E-09_JPRB, 0.25856545E-09_JPRB, 0.25907942E-09_JPRB, &
  & 0.25952901E-09_JPRB, 0.25993591E-09_JPRB, 0.26029973E-09_JPRB, 0.26062169E-09_JPRB, 0.26087796E-09_JPRB, 0.26105440E-09_JPRB, &
  & 0.26114610E-09_JPRB, 0.26115415E-09_JPRB, 0.26107685E-09_JPRB, 0.26091346E-09_JPRB, 0.26068334E-09_JPRB, 0.26041747E-09_JPRB, &
  & 0.26013774E-09_JPRB, 0.25984617E-09_JPRB, 0.25953184E-09_JPRB, 0.25917937E-09_JPRB, 0.25876787E-09_JPRB, 0.25827818E-09_JPRB, &
  & 0.25769145E-09_JPRB, 0.25698590E-09_JPRB, 0.25613980E-09_JPRB, 0.25511651E-09_JPRB, 0.25392649E-09_JPRB, 0.25257699E-09_JPRB, &
  & 0.25111871E-09_JPRB, 0.24952293E-09_JPRB, 0.24786656E-09_JPRB, 0.24626512E-09_JPRB, 0.24499833E-09_JPRB, 0.24400551E-09_JPRB, &
  & 0.24323918E-09_JPRB, 0.24256760E-09_JPRB, 0.24191552E-09_JPRB, 0.24123378E-09_JPRB, 0.24049659E-09_JPRB, 0.23972965E-09_JPRB, &
  & 0.23895796E-09_JPRB, 0.23817109E-09_JPRB, 0.23724847E-09_JPRB, 0.23557289E-09_JPRB /)

RGHG5(:,49, 1) = (/ &
  & 0.23951763E-09_JPRB, 0.24056901E-09_JPRB, 0.24130264E-09_JPRB, 0.24212440E-09_JPRB, 0.24322017E-09_JPRB, 0.24451294E-09_JPRB, &
  & 0.24579086E-09_JPRB, 0.24689209E-09_JPRB, 0.24772823E-09_JPRB, 0.24835589E-09_JPRB, 0.24884236E-09_JPRB, 0.24927499E-09_JPRB, &
  & 0.24971938E-09_JPRB, 0.25025931E-09_JPRB, 0.25100744E-09_JPRB, 0.25209013E-09_JPRB, 0.25346250E-09_JPRB, 0.25481711E-09_JPRB, &
  & 0.25593258E-09_JPRB, 0.25684177E-09_JPRB, 0.25759803E-09_JPRB, 0.25824765E-09_JPRB, 0.25881039E-09_JPRB, 0.25931077E-09_JPRB, &
  & 0.25975569E-09_JPRB, 0.26016111E-09_JPRB, 0.26052457E-09_JPRB, 0.26083605E-09_JPRB, 0.26107400E-09_JPRB, 0.26123201E-09_JPRB, &
  & 0.26130526E-09_JPRB, 0.26129968E-09_JPRB, 0.26121313E-09_JPRB, 0.26104682E-09_JPRB, 0.26081767E-09_JPRB, 0.26055744E-09_JPRB, &
  & 0.26028629E-09_JPRB, 0.26000621E-09_JPRB, 0.25970856E-09_JPRB, 0.25937918E-09_JPRB, 0.25900343E-09_JPRB, 0.25856900E-09_JPRB, &
  & 0.25806979E-09_JPRB, 0.25750263E-09_JPRB, 0.25685734E-09_JPRB, 0.25611729E-09_JPRB, 0.25524899E-09_JPRB, 0.25425492E-09_JPRB, &
  & 0.25311786E-09_JPRB, 0.25184441E-09_JPRB, 0.25047656E-09_JPRB, 0.24919924E-09_JPRB, 0.24816593E-09_JPRB, 0.24739172E-09_JPRB, &
  & 0.24678204E-09_JPRB, 0.24624414E-09_JPRB, 0.24571348E-09_JPRB, 0.24515046E-09_JPRB, 0.24454366E-09_JPRB, 0.24391342E-09_JPRB, &
  & 0.24329028E-09_JPRB, 0.24265559E-09_JPRB, 0.24191985E-09_JPRB, 0.24057767E-09_JPRB /)

RGHG5(:,50, 1) = (/ &
  & 0.24341257E-09_JPRB, 0.24447191E-09_JPRB, 0.24516236E-09_JPRB, 0.24600280E-09_JPRB, 0.24708496E-09_JPRB, 0.24840763E-09_JPRB, &
  & 0.24967947E-09_JPRB, 0.25070729E-09_JPRB, 0.25142027E-09_JPRB, 0.25189567E-09_JPRB, 0.25223815E-09_JPRB, 0.25252039E-09_JPRB, &
  & 0.25277702E-09_JPRB, 0.25308894E-09_JPRB, 0.25345948E-09_JPRB, 0.25405250E-09_JPRB, 0.25484326E-09_JPRB, 0.25573224E-09_JPRB, &
  & 0.25654212E-09_JPRB, 0.25725971E-09_JPRB, 0.25790620E-09_JPRB, 0.25849289E-09_JPRB, 0.25903157E-09_JPRB, 0.25952185E-09_JPRB, &
  & 0.25997046E-09_JPRB, 0.26037622E-09_JPRB, 0.26073510E-09_JPRB, 0.26103297E-09_JPRB, 0.26125366E-09_JPRB, 0.26139133E-09_JPRB, &
  & 0.26144825E-09_JPRB, 0.26142938E-09_JPRB, 0.26133376E-09_JPRB, 0.26116317E-09_JPRB, 0.26093533E-09_JPRB, 0.26067942E-09_JPRB, &
  & 0.26041508E-09_JPRB, 0.26014457E-09_JPRB, 0.25985972E-09_JPRB, 0.25954949E-09_JPRB, 0.25920260E-09_JPRB, 0.25881541E-09_JPRB, &
  & 0.25839342E-09_JPRB, 0.25794986E-09_JPRB, 0.25749364E-09_JPRB, 0.25701782E-09_JPRB, 0.25648708E-09_JPRB, 0.25586397E-09_JPRB, &
  & 0.25510219E-09_JPRB, 0.25419861E-09_JPRB, 0.25318356E-09_JPRB, 0.25223254E-09_JPRB, 0.25144981E-09_JPRB, 0.25087749E-09_JPRB, &
  & 0.25040342E-09_JPRB, 0.24998242E-09_JPRB, 0.24955929E-09_JPRB, 0.24909264E-09_JPRB, 0.24858940E-09_JPRB, 0.24806443E-09_JPRB, &
  & 0.24754246E-09_JPRB, 0.24701741E-09_JPRB, 0.24639818E-09_JPRB, 0.24527816E-09_JPRB /)

RGHG5(:,51, 1) = (/ &
  & 0.24702110E-09_JPRB, 0.24798386E-09_JPRB, 0.24871605E-09_JPRB, 0.24950722E-09_JPRB, 0.25063518E-09_JPRB, 0.25191663E-09_JPRB, &
  & 0.25312949E-09_JPRB, 0.25395075E-09_JPRB, 0.25443858E-09_JPRB, 0.25472138E-09_JPRB, 0.25489871E-09_JPRB, 0.25501967E-09_JPRB, &
  & 0.25512592E-09_JPRB, 0.25521513E-09_JPRB, 0.25535440E-09_JPRB, 0.25554939E-09_JPRB, 0.25594865E-09_JPRB, 0.25647720E-09_JPRB, &
  & 0.25705219E-09_JPRB, 0.25762009E-09_JPRB, 0.25817468E-09_JPRB, 0.25871494E-09_JPRB, 0.25923344E-09_JPRB, 0.25972274E-09_JPRB, &
  & 0.26017227E-09_JPRB, 0.26058072E-09_JPRB, 0.26092917E-09_JPRB, 0.26121358E-09_JPRB, 0.26141406E-09_JPRB, 0.26153485E-09_JPRB, &
  & 0.26157657E-09_JPRB, 0.26154501E-09_JPRB, 0.26144040E-09_JPRB, 0.26126568E-09_JPRB, 0.26103858E-09_JPRB, 0.26078661E-09_JPRB, &
  & 0.26052832E-09_JPRB, 0.26026542E-09_JPRB, 0.25999117E-09_JPRB, 0.25969601E-09_JPRB, 0.25937355E-09_JPRB, 0.25902658E-09_JPRB, &
  & 0.25867339E-09_JPRB, 0.25833935E-09_JPRB, 0.25805058E-09_JPRB, 0.25779839E-09_JPRB, 0.25755553E-09_JPRB, 0.25725938E-09_JPRB, &
  & 0.25687444E-09_JPRB, 0.25635899E-09_JPRB, 0.25576105E-09_JPRB, 0.25515245E-09_JPRB, 0.25466940E-09_JPRB, 0.25426727E-09_JPRB, &
  & 0.25394947E-09_JPRB, 0.25364519E-09_JPRB, 0.25332156E-09_JPRB, 0.25296731E-09_JPRB, 0.25255825E-09_JPRB, 0.25212782E-09_JPRB, &
  & 0.25169827E-09_JPRB, 0.25124841E-09_JPRB, 0.25071811E-09_JPRB, 0.24973262E-09_JPRB /)

RGHG5(:,52, 1) = (/ &
  & 0.25014749E-09_JPRB, 0.25115068E-09_JPRB, 0.25176169E-09_JPRB, 0.25260638E-09_JPRB, 0.25361155E-09_JPRB, 0.25481359E-09_JPRB, &
  & 0.25570007E-09_JPRB, 0.25621935E-09_JPRB, 0.25646524E-09_JPRB, 0.25658353E-09_JPRB, 0.25664038E-09_JPRB, 0.25666777E-09_JPRB, &
  & 0.25667438E-09_JPRB, 0.25666763E-09_JPRB, 0.25665636E-09_JPRB, 0.25667435E-09_JPRB, 0.25679442E-09_JPRB, 0.25708813E-09_JPRB, &
  & 0.25748526E-09_JPRB, 0.25793728E-09_JPRB, 0.25842203E-09_JPRB, 0.25892266E-09_JPRB, 0.25942590E-09_JPRB, 0.25991248E-09_JPRB, &
  & 0.26036584E-09_JPRB, 0.26076724E-09_JPRB, 0.26110869E-09_JPRB, 0.26137398E-09_JPRB, 0.26155877E-09_JPRB, 0.26166319E-09_JPRB, &
  & 0.26169181E-09_JPRB, 0.26164843E-09_JPRB, 0.26153490E-09_JPRB, 0.26135602E-09_JPRB, 0.26112953E-09_JPRB, 0.26088162E-09_JPRB, &
  & 0.26062852E-09_JPRB, 0.26037264E-09_JPRB, 0.26010719E-09_JPRB, 0.25982508E-09_JPRB, 0.25952313E-09_JPRB, 0.25921265E-09_JPRB, &
  & 0.25892000E-09_JPRB, 0.25868513E-09_JPRB, 0.25852986E-09_JPRB, 0.25844932E-09_JPRB, 0.25839703E-09_JPRB, 0.25832886E-09_JPRB, &
  & 0.25819899E-09_JPRB, 0.25799513E-09_JPRB, 0.25772032E-09_JPRB, 0.25743629E-09_JPRB, 0.25717153E-09_JPRB, 0.25696745E-09_JPRB, &
  & 0.25677660E-09_JPRB, 0.25659358E-09_JPRB, 0.25639535E-09_JPRB, 0.25615060E-09_JPRB, 0.25587454E-09_JPRB, 0.25556779E-09_JPRB, &
  & 0.25524968E-09_JPRB, 0.25491667E-09_JPRB, 0.25449653E-09_JPRB, 0.25368596E-09_JPRB /)

RGHG5(:,53, 1) = (/ &
  & 0.25288202E-09_JPRB, 0.25368116E-09_JPRB, 0.25437161E-09_JPRB, 0.25501951E-09_JPRB, 0.25594746E-09_JPRB, 0.25676117E-09_JPRB, &
  & 0.25731722E-09_JPRB, 0.25755709E-09_JPRB, 0.25765284E-09_JPRB, 0.25768584E-09_JPRB, 0.25769062E-09_JPRB, 0.25767949E-09_JPRB, &
  & 0.25765234E-09_JPRB, 0.25761590E-09_JPRB, 0.25754571E-09_JPRB, 0.25748539E-09_JPRB, 0.25746857E-09_JPRB, 0.25759267E-09_JPRB, &
  & 0.25786170E-09_JPRB, 0.25822688E-09_JPRB, 0.25865465E-09_JPRB, 0.25912508E-09_JPRB, 0.25961361E-09_JPRB, 0.26009520E-09_JPRB, &
  & 0.26054309E-09_JPRB, 0.26094094E-09_JPRB, 0.26126779E-09_JPRB, 0.26151972E-09_JPRB, 0.26168789E-09_JPRB, 0.26177885E-09_JPRB, &
  & 0.26179542E-09_JPRB, 0.26174135E-09_JPRB, 0.26161923E-09_JPRB, 0.26143632E-09_JPRB, 0.26121064E-09_JPRB, 0.26096633E-09_JPRB, &
  & 0.26071861E-09_JPRB, 0.26046906E-09_JPRB, 0.26021196E-09_JPRB, 0.25994135E-09_JPRB, 0.25965904E-09_JPRB, 0.25938110E-09_JPRB, &
  & 0.25914568E-09_JPRB, 0.25899216E-09_JPRB, 0.25894237E-09_JPRB, 0.25897112E-09_JPRB, 0.25902969E-09_JPRB, 0.25907312E-09_JPRB, &
  & 0.25907507E-09_JPRB, 0.25902330E-09_JPRB, 0.25892447E-09_JPRB, 0.25880059E-09_JPRB, 0.25868779E-09_JPRB, 0.25858124E-09_JPRB, &
  & 0.25848898E-09_JPRB, 0.25839203E-09_JPRB, 0.25827815E-09_JPRB, 0.25814573E-09_JPRB, 0.25797967E-09_JPRB, 0.25779934E-09_JPRB, &
  & 0.25761362E-09_JPRB, 0.25741376E-09_JPRB, 0.25716909E-09_JPRB, 0.25664096E-09_JPRB /)

RGHG5(:,54, 1) = (/ &
  & 0.25497043E-09_JPRB, 0.25581712E-09_JPRB, 0.25627167E-09_JPRB, 0.25689145E-09_JPRB, 0.25746574E-09_JPRB, 0.25799196E-09_JPRB, &
  & 0.25824470E-09_JPRB, 0.25834074E-09_JPRB, 0.25836494E-09_JPRB, 0.25836372E-09_JPRB, 0.25835084E-09_JPRB, 0.25832891E-09_JPRB, &
  & 0.25830046E-09_JPRB, 0.25824931E-09_JPRB, 0.25819188E-09_JPRB, 0.25808244E-09_JPRB, 0.25800581E-09_JPRB, 0.25802438E-09_JPRB, &
  & 0.25819757E-09_JPRB, 0.25849498E-09_JPRB, 0.25888117E-09_JPRB, 0.25932426E-09_JPRB, 0.25979707E-09_JPRB, 0.26026858E-09_JPRB, &
  & 0.26070979E-09_JPRB, 0.26109667E-09_JPRB, 0.26141397E-09_JPRB, 0.26165023E-09_JPRB, 0.26180569E-09_JPRB, 0.26188365E-09_JPRB, &
  & 0.26188915E-09_JPRB, 0.26182523E-09_JPRB, 0.26169564E-09_JPRB, 0.26150865E-09_JPRB, 0.26128397E-09_JPRB, 0.26104308E-09_JPRB, &
  & 0.26080080E-09_JPRB, 0.26055730E-09_JPRB, 0.26030852E-09_JPRB, 0.26004998E-09_JPRB, 0.25978633E-09_JPRB, 0.25954117E-09_JPRB, &
  & 0.25935476E-09_JPRB, 0.25927030E-09_JPRB, 0.25929431E-09_JPRB, 0.25938740E-09_JPRB, 0.25950009E-09_JPRB, 0.25959118E-09_JPRB, &
  & 0.25964361E-09_JPRB, 0.25965299E-09_JPRB, 0.25962460E-09_JPRB, 0.25957542E-09_JPRB, 0.25951991E-09_JPRB, 0.25947111E-09_JPRB, &
  & 0.25942132E-09_JPRB, 0.25936936E-09_JPRB, 0.25930974E-09_JPRB, 0.25923175E-09_JPRB, 0.25914210E-09_JPRB, 0.25904218E-09_JPRB, &
  & 0.25894431E-09_JPRB, 0.25885363E-09_JPRB, 0.25876282E-09_JPRB, 0.25864136E-09_JPRB /)

RGHG5(:,55, 1) = (/ &
  & 0.25666361E-09_JPRB, 0.25727345E-09_JPRB, 0.25774177E-09_JPRB, 0.25809282E-09_JPRB, 0.25847469E-09_JPRB, 0.25871849E-09_JPRB, &
  & 0.25882316E-09_JPRB, 0.25884414E-09_JPRB, 0.25883912E-09_JPRB, 0.25882574E-09_JPRB, 0.25880861E-09_JPRB, 0.25878791E-09_JPRB, &
  & 0.25875829E-09_JPRB, 0.25872288E-09_JPRB, 0.25865177E-09_JPRB, 0.25857166E-09_JPRB, 0.25844651E-09_JPRB, 0.25840058E-09_JPRB, &
  & 0.25850355E-09_JPRB, 0.25875060E-09_JPRB, 0.25910077E-09_JPRB, 0.25952035E-09_JPRB, 0.25997610E-09_JPRB, 0.26043390E-09_JPRB, &
  & 0.26086419E-09_JPRB, 0.26124194E-09_JPRB, 0.26154645E-09_JPRB, 0.26177116E-09_JPRB, 0.26191310E-09_JPRB, 0.26197985E-09_JPRB, &
  & 0.26197494E-09_JPRB, 0.26190203E-09_JPRB, 0.26176589E-09_JPRB, 0.26157604E-09_JPRB, 0.26135155E-09_JPRB, 0.26111494E-09_JPRB, &
  & 0.26087688E-09_JPRB, 0.26064068E-09_JPRB, 0.26040003E-09_JPRB, 0.26015431E-09_JPRB, 0.25991090E-09_JPRB, 0.25969582E-09_JPRB, &
  & 0.25955416E-09_JPRB, 0.25952190E-09_JPRB, 0.25959440E-09_JPRB, 0.25972730E-09_JPRB, 0.25986127E-09_JPRB, 0.25996885E-09_JPRB, &
  & 0.26003794E-09_JPRB, 0.26006822E-09_JPRB, 0.26006719E-09_JPRB, 0.26004704E-09_JPRB, 0.26002162E-09_JPRB, 0.25999417E-09_JPRB, &
  & 0.25996774E-09_JPRB, 0.25993824E-09_JPRB, 0.25990160E-09_JPRB, 0.25985736E-09_JPRB, 0.25980057E-09_JPRB, 0.25973917E-09_JPRB, &
  & 0.25967739E-09_JPRB, 0.25961602E-09_JPRB, 0.25954872E-09_JPRB, 0.25942887E-09_JPRB /)

RGHG5(:,56, 1) = (/ &
  & 0.25784158E-09_JPRB, 0.25840283E-09_JPRB, 0.25867153E-09_JPRB, 0.25891733E-09_JPRB, 0.25909844E-09_JPRB, 0.25920130E-09_JPRB, &
  & 0.25922051E-09_JPRB, 0.25920954E-09_JPRB, 0.25919333E-09_JPRB, 0.25917699E-09_JPRB, 0.25916047E-09_JPRB, 0.25914149E-09_JPRB, &
  & 0.25911970E-09_JPRB, 0.25908359E-09_JPRB, 0.25903932E-09_JPRB, 0.25894231E-09_JPRB, 0.25883337E-09_JPRB, 0.25873867E-09_JPRB, &
  & 0.25879079E-09_JPRB, 0.25899591E-09_JPRB, 0.25931648E-09_JPRB, 0.25971297E-09_JPRB, 0.26014940E-09_JPRB, 0.26059313E-09_JPRB, &
  & 0.26101088E-09_JPRB, 0.26137673E-09_JPRB, 0.26167110E-09_JPRB, 0.26188213E-09_JPRB, 0.26201311E-09_JPRB, 0.26206881E-09_JPRB, &
  & 0.26205460E-09_JPRB, 0.26197405E-09_JPRB, 0.26183208E-09_JPRB, 0.26164035E-09_JPRB, 0.26141711E-09_JPRB, 0.26118327E-09_JPRB, &
  & 0.26095154E-09_JPRB, 0.26072081E-09_JPRB, 0.26049032E-09_JPRB, 0.26025784E-09_JPRB, 0.26003480E-09_JPRB, 0.25984945E-09_JPRB, &
  & 0.25974420E-09_JPRB, 0.25975094E-09_JPRB, 0.25985855E-09_JPRB, 0.26000796E-09_JPRB, 0.26015382E-09_JPRB, 0.26026367E-09_JPRB, &
  & 0.26033439E-09_JPRB, 0.26036989E-09_JPRB, 0.26037855E-09_JPRB, 0.26037122E-09_JPRB, 0.26035710E-09_JPRB, 0.26034214E-09_JPRB, &
  & 0.26032557E-09_JPRB, 0.26030691E-09_JPRB, 0.26028454E-09_JPRB, 0.26025432E-09_JPRB, 0.26021832E-09_JPRB, 0.26017682E-09_JPRB, &
  & 0.26013541E-09_JPRB, 0.26009539E-09_JPRB, 0.26005292E-09_JPRB, 0.25998684E-09_JPRB /)

RGHG5(:,57, 1) = (/ &
  & 0.25871782E-09_JPRB, 0.25912472E-09_JPRB, 0.25932395E-09_JPRB, 0.25945052E-09_JPRB, 0.25952784E-09_JPRB, 0.25954608E-09_JPRB, &
  & 0.25952651E-09_JPRB, 0.25950317E-09_JPRB, 0.25948346E-09_JPRB, 0.25946734E-09_JPRB, 0.25945252E-09_JPRB, 0.25943722E-09_JPRB, &
  & 0.25941738E-09_JPRB, 0.25939295E-09_JPRB, 0.25934530E-09_JPRB, 0.25928149E-09_JPRB, 0.25915484E-09_JPRB, 0.25904798E-09_JPRB, &
  & 0.25906322E-09_JPRB, 0.25923594E-09_JPRB, 0.25952870E-09_JPRB, 0.25990204E-09_JPRB, 0.26032040E-09_JPRB, 0.26074704E-09_JPRB, &
  & 0.26115171E-09_JPRB, 0.26150554E-09_JPRB, 0.26178631E-09_JPRB, 0.26198682E-09_JPRB, 0.26210603E-09_JPRB, 0.26215213E-09_JPRB, &
  & 0.26212971E-09_JPRB, 0.26204280E-09_JPRB, 0.26189695E-09_JPRB, 0.26170360E-09_JPRB, 0.26148214E-09_JPRB, 0.26125280E-09_JPRB, &
  & 0.26102498E-09_JPRB, 0.26080255E-09_JPRB, 0.26058089E-09_JPRB, 0.26036301E-09_JPRB, 0.26016062E-09_JPRB, 0.26000188E-09_JPRB, &
  & 0.25992769E-09_JPRB, 0.25996355E-09_JPRB, 0.26008870E-09_JPRB, 0.26025387E-09_JPRB, 0.26039884E-09_JPRB, 0.26050709E-09_JPRB, &
  & 0.26057415E-09_JPRB, 0.26060809E-09_JPRB, 0.26061886E-09_JPRB, 0.26061614E-09_JPRB, 0.26060809E-09_JPRB, 0.26059782E-09_JPRB, &
  & 0.26058694E-09_JPRB, 0.26057423E-09_JPRB, 0.26055785E-09_JPRB, 0.26053754E-09_JPRB, 0.26051084E-09_JPRB, 0.26048114E-09_JPRB, &
  & 0.26045005E-09_JPRB, 0.26041880E-09_JPRB, 0.26038360E-09_JPRB, 0.26032132E-09_JPRB /)

RGHG5(:,58, 1) = (/ &
  & 0.25934829E-09_JPRB, 0.25964597E-09_JPRB, 0.25976732E-09_JPRB, 0.25982602E-09_JPRB, 0.25984406E-09_JPRB, 0.25982069E-09_JPRB, &
  & 0.25978597E-09_JPRB, 0.25975716E-09_JPRB, 0.25973770E-09_JPRB, 0.25972288E-09_JPRB, 0.25971017E-09_JPRB, 0.25969693E-09_JPRB, &
  & 0.25968194E-09_JPRB, 0.25965818E-09_JPRB, 0.25962577E-09_JPRB, 0.25955488E-09_JPRB, 0.25945385E-09_JPRB, 0.25933100E-09_JPRB, &
  & 0.25932445E-09_JPRB, 0.25947111E-09_JPRB, 0.25973906E-09_JPRB, 0.26009067E-09_JPRB, 0.26048885E-09_JPRB, 0.26089955E-09_JPRB, &
  & 0.26128860E-09_JPRB, 0.26162747E-09_JPRB, 0.26189648E-09_JPRB, 0.26208374E-09_JPRB, 0.26219343E-09_JPRB, 0.26223074E-09_JPRB, &
  & 0.26220157E-09_JPRB, 0.26211008E-09_JPRB, 0.26196145E-09_JPRB, 0.26176836E-09_JPRB, 0.26154934E-09_JPRB, 0.26132338E-09_JPRB, &
  & 0.26110214E-09_JPRB, 0.26088612E-09_JPRB, 0.26067506E-09_JPRB, 0.26047142E-09_JPRB, 0.26028857E-09_JPRB, 0.26015479E-09_JPRB, &
  & 0.26010530E-09_JPRB, 0.26016014E-09_JPRB, 0.26030117E-09_JPRB, 0.26046665E-09_JPRB, 0.26061481E-09_JPRB, 0.26071695E-09_JPRB, &
  & 0.26077832E-09_JPRB, 0.26080815E-09_JPRB, 0.26081792E-09_JPRB, 0.26081634E-09_JPRB, 0.26080998E-09_JPRB, 0.26080235E-09_JPRB, &
  & 0.26079366E-09_JPRB, 0.26078356E-09_JPRB, 0.26077135E-09_JPRB, 0.26075470E-09_JPRB, 0.26073460E-09_JPRB, 0.26071068E-09_JPRB, &
  & 0.26068608E-09_JPRB, 0.26066088E-09_JPRB, 0.26063252E-09_JPRB, 0.26058461E-09_JPRB /)

RGHG5(:,59, 1) = (/ &
  & 0.25982128E-09_JPRB, 0.26003771E-09_JPRB, 0.26009486E-09_JPRB, 0.26011410E-09_JPRB, 0.26009975E-09_JPRB, 0.26005864E-09_JPRB, &
  & 0.26001640E-09_JPRB, 0.25998803E-09_JPRB, 0.25996916E-09_JPRB, 0.25995600E-09_JPRB, 0.25994509E-09_JPRB, 0.25993444E-09_JPRB, &
  & 0.25992095E-09_JPRB, 0.25990321E-09_JPRB, 0.25986951E-09_JPRB, 0.25981636E-09_JPRB, 0.25970942E-09_JPRB, 0.25959490E-09_JPRB, &
  & 0.25957661E-09_JPRB, 0.25970315E-09_JPRB, 0.25994859E-09_JPRB, 0.26027877E-09_JPRB, 0.26065780E-09_JPRB, 0.26105004E-09_JPRB, &
  & 0.26142216E-09_JPRB, 0.26174587E-09_JPRB, 0.26199920E-09_JPRB, 0.26217578E-09_JPRB, 0.26227523E-09_JPRB, 0.26230529E-09_JPRB, &
  & 0.26227109E-09_JPRB, 0.26217667E-09_JPRB, 0.26202743E-09_JPRB, 0.26183514E-09_JPRB, 0.26161950E-09_JPRB, 0.26139849E-09_JPRB, &
  & 0.26118288E-09_JPRB, 0.26097458E-09_JPRB, 0.26077354E-09_JPRB, 0.26058355E-09_JPRB, 0.26041974E-09_JPRB, 0.26030708E-09_JPRB, &
  & 0.26027788E-09_JPRB, 0.26034760E-09_JPRB, 0.26049202E-09_JPRB, 0.26066352E-09_JPRB, 0.26080554E-09_JPRB, 0.26090410E-09_JPRB, &
  & 0.26095887E-09_JPRB, 0.26098401E-09_JPRB, 0.26099112E-09_JPRB, 0.26098868E-09_JPRB, 0.26098279E-09_JPRB, 0.26097546E-09_JPRB, &
  & 0.26096775E-09_JPRB, 0.26095895E-09_JPRB, 0.26094782E-09_JPRB, 0.26093425E-09_JPRB, 0.26091654E-09_JPRB, 0.26089675E-09_JPRB, &
  & 0.26087549E-09_JPRB, 0.26085362E-09_JPRB, 0.26082855E-09_JPRB, 0.26078348E-09_JPRB /)

RGHG5(:,60, 1) = (/ &
  & 0.26031360E-09_JPRB, 0.26034877E-09_JPRB, 0.26035940E-09_JPRB, 0.26035113E-09_JPRB, 0.26032038E-09_JPRB, 0.26027450E-09_JPRB, &
  & 0.26023189E-09_JPRB, 0.26020291E-09_JPRB, 0.26018554E-09_JPRB, 0.26017388E-09_JPRB, 0.26016492E-09_JPRB, 0.26015609E-09_JPRB, &
  & 0.26014571E-09_JPRB, 0.26012897E-09_JPRB, 0.26010238E-09_JPRB, 0.26004582E-09_JPRB, 0.25995131E-09_JPRB, 0.25984154E-09_JPRB, &
  & 0.25982091E-09_JPRB, 0.25993252E-09_JPRB, 0.26015803E-09_JPRB, 0.26046781E-09_JPRB, 0.26082692E-09_JPRB, 0.26119981E-09_JPRB, &
  & 0.26155353E-09_JPRB, 0.26185892E-09_JPRB, 0.26209787E-09_JPRB, 0.26226146E-09_JPRB, 0.26235245E-09_JPRB, 0.26237645E-09_JPRB, &
  & 0.26233887E-09_JPRB, 0.26224353E-09_JPRB, 0.26209518E-09_JPRB, 0.26190572E-09_JPRB, 0.26169422E-09_JPRB, 0.26147864E-09_JPRB, &
  & 0.26126890E-09_JPRB, 0.26106828E-09_JPRB, 0.26087646E-09_JPRB, 0.26070013E-09_JPRB, 0.26055275E-09_JPRB, 0.26045943E-09_JPRB, &
  & 0.26044666E-09_JPRB, 0.26052502E-09_JPRB, 0.26067379E-09_JPRB, 0.26083999E-09_JPRB, 0.26098187E-09_JPRB, 0.26107386E-09_JPRB, &
  & 0.26112379E-09_JPRB, 0.26114372E-09_JPRB, 0.26114752E-09_JPRB, 0.26114316E-09_JPRB, 0.26113600E-09_JPRB, 0.26112842E-09_JPRB, &
  & 0.26112040E-09_JPRB, 0.26111144E-09_JPRB, 0.26110114E-09_JPRB, 0.26108771E-09_JPRB, 0.26107194E-09_JPRB, 0.26105335E-09_JPRB, &
  & 0.26103419E-09_JPRB, 0.26101449E-09_JPRB, 0.26099206E-09_JPRB, 0.26095393E-09_JPRB /)

RGHG5(:,61, 1) = (/ &
  & 0.26054306E-09_JPRB, 0.26057151E-09_JPRB, 0.26057029E-09_JPRB, 0.26055361E-09_JPRB, 0.26052260E-09_JPRB, 0.26047620E-09_JPRB, &
  & 0.26043431E-09_JPRB, 0.26040659E-09_JPRB, 0.26039002E-09_JPRB, 0.26038025E-09_JPRB, 0.26037342E-09_JPRB, 0.26036728E-09_JPRB, &
  & 0.26035912E-09_JPRB, 0.26034613E-09_JPRB, 0.26031924E-09_JPRB, 0.26026806E-09_JPRB, 0.26017521E-09_JPRB, 0.26007774E-09_JPRB, &
  & 0.26005961E-09_JPRB, 0.26015984E-09_JPRB, 0.26036792E-09_JPRB, 0.26065816E-09_JPRB, 0.26099647E-09_JPRB, 0.26134922E-09_JPRB, &
  & 0.26168212E-09_JPRB, 0.26196911E-09_JPRB, 0.26219099E-09_JPRB, 0.26234287E-09_JPRB, 0.26242503E-09_JPRB, 0.26244440E-09_JPRB, &
  & 0.26240529E-09_JPRB, 0.26231087E-09_JPRB, 0.26216557E-09_JPRB, 0.26198033E-09_JPRB, 0.26177444E-09_JPRB, 0.26156399E-09_JPRB, &
  & 0.26136127E-09_JPRB, 0.26116689E-09_JPRB, 0.26098490E-09_JPRB, 0.26082009E-09_JPRB, 0.26068839E-09_JPRB, 0.26061142E-09_JPRB, &
  & 0.26061189E-09_JPRB, 0.26069696E-09_JPRB, 0.26084354E-09_JPRB, 0.26100769E-09_JPRB, 0.26114302E-09_JPRB, 0.26123204E-09_JPRB, &
  & 0.26127692E-09_JPRB, 0.26129260E-09_JPRB, 0.26129257E-09_JPRB, 0.26128544E-09_JPRB, 0.26127661E-09_JPRB, 0.26126759E-09_JPRB, &
  & 0.26125868E-09_JPRB, 0.26124919E-09_JPRB, 0.26123784E-09_JPRB, 0.26122465E-09_JPRB, 0.26120830E-09_JPRB, 0.26119046E-09_JPRB, &
  & 0.26117158E-09_JPRB, 0.26115243E-09_JPRB, 0.26113073E-09_JPRB, 0.26109256E-09_JPRB /)

RGHG5(:,62, 1) = (/ &
  & 0.26074337E-09_JPRB, 0.26076186E-09_JPRB, 0.26075697E-09_JPRB, 0.26073999E-09_JPRB, 0.26070862E-09_JPRB, 0.26066796E-09_JPRB, &
  & 0.26062769E-09_JPRB, 0.26059988E-09_JPRB, 0.26058439E-09_JPRB, 0.26057650E-09_JPRB, 0.26057279E-09_JPRB, 0.26057018E-09_JPRB, &
  & 0.26056601E-09_JPRB, 0.26055544E-09_JPRB, 0.26053149E-09_JPRB, 0.26047900E-09_JPRB, 0.26039221E-09_JPRB, 0.26030836E-09_JPRB, &
  & 0.26029420E-09_JPRB, 0.26038582E-09_JPRB, 0.26057842E-09_JPRB, 0.26084929E-09_JPRB, 0.26116706E-09_JPRB, 0.26149738E-09_JPRB, &
  & 0.26180896E-09_JPRB, 0.26207528E-09_JPRB, 0.26228070E-09_JPRB, 0.26241942E-09_JPRB, 0.26249386E-09_JPRB, 0.26250943E-09_JPRB, &
  & 0.26247024E-09_JPRB, 0.26237884E-09_JPRB, 0.26223854E-09_JPRB, 0.26205954E-09_JPRB, 0.26185948E-09_JPRB, 0.26165609E-09_JPRB, &
  & 0.26145847E-09_JPRB, 0.26127189E-09_JPRB, 0.26109753E-09_JPRB, 0.26094438E-09_JPRB, 0.26082589E-09_JPRB, 0.26076308E-09_JPRB, &
  & 0.26077449E-09_JPRB, 0.26086369E-09_JPRB, 0.26100747E-09_JPRB, 0.26116431E-09_JPRB, 0.26129596E-09_JPRB, 0.26138047E-09_JPRB, &
  & 0.26142216E-09_JPRB, 0.26143379E-09_JPRB, 0.26142977E-09_JPRB, 0.26141947E-09_JPRB, 0.26140795E-09_JPRB, 0.26139710E-09_JPRB, &
  & 0.26138652E-09_JPRB, 0.26137537E-09_JPRB, 0.26136315E-09_JPRB, 0.26134825E-09_JPRB, 0.26133140E-09_JPRB, 0.26131239E-09_JPRB, &
  & 0.26129321E-09_JPRB, 0.26127375E-09_JPRB, 0.26125191E-09_JPRB, 0.26121494E-09_JPRB /)

RGHG5(:,63, 1) = (/ &
  & 0.26091762E-09_JPRB, 0.26093483E-09_JPRB, 0.26092956E-09_JPRB, 0.26091335E-09_JPRB, 0.26088709E-09_JPRB, 0.26084987E-09_JPRB, &
  & 0.26081270E-09_JPRB, 0.26078512E-09_JPRB, 0.26077002E-09_JPRB, 0.26076449E-09_JPRB, 0.26076483E-09_JPRB, 0.26076749E-09_JPRB, &
  & 0.26076835E-09_JPRB, 0.26076166E-09_JPRB, 0.26073765E-09_JPRB, 0.26068583E-09_JPRB, 0.26060709E-09_JPRB, 0.26053559E-09_JPRB, &
  & 0.26052599E-09_JPRB, 0.26061087E-09_JPRB, 0.26078920E-09_JPRB, 0.26104169E-09_JPRB, 0.26133706E-09_JPRB, 0.26164501E-09_JPRB, &
  & 0.26193286E-09_JPRB, 0.26217839E-09_JPRB, 0.26236596E-09_JPRB, 0.26249197E-09_JPRB, 0.26255856E-09_JPRB, 0.26257133E-09_JPRB, &
  & 0.26253355E-09_JPRB, 0.26244673E-09_JPRB, 0.26231345E-09_JPRB, 0.26214222E-09_JPRB, 0.26195021E-09_JPRB, 0.26175281E-09_JPRB, &
  & 0.26156258E-09_JPRB, 0.26138150E-09_JPRB, 0.26121574E-09_JPRB, 0.26107225E-09_JPRB, 0.26096575E-09_JPRB, 0.26091490E-09_JPRB, &
  & 0.26093511E-09_JPRB, 0.26102637E-09_JPRB, 0.26116587E-09_JPRB, 0.26131547E-09_JPRB, 0.26144026E-09_JPRB, 0.26152211E-09_JPRB, &
  & 0.26156102E-09_JPRB, 0.26156954E-09_JPRB, 0.26156172E-09_JPRB, 0.26154767E-09_JPRB, 0.26153324E-09_JPRB, 0.26151969E-09_JPRB, &
  & 0.26150684E-09_JPRB, 0.26149380E-09_JPRB, 0.26147903E-09_JPRB, 0.26146263E-09_JPRB, 0.26144339E-09_JPRB, 0.26142305E-09_JPRB, &
  & 0.26140223E-09_JPRB, 0.26138164E-09_JPRB, 0.26135866E-09_JPRB, 0.26131947E-09_JPRB /)

RGHG5(:,64, 1) = (/ &
  & 0.26107905E-09_JPRB, 0.26109598E-09_JPRB, 0.26109223E-09_JPRB, 0.26107883E-09_JPRB, 0.26105559E-09_JPRB, 0.26102401E-09_JPRB, &
  & 0.26098923E-09_JPRB, 0.26096275E-09_JPRB, 0.26094818E-09_JPRB, 0.26094527E-09_JPRB, 0.26095057E-09_JPRB, 0.26095973E-09_JPRB, &
  & 0.26096600E-09_JPRB, 0.26096197E-09_JPRB, 0.26093863E-09_JPRB, 0.26088920E-09_JPRB, 0.26081887E-09_JPRB, 0.26075841E-09_JPRB, &
  & 0.26075334E-09_JPRB, 0.26083322E-09_JPRB, 0.26099867E-09_JPRB, 0.26123198E-09_JPRB, 0.26150573E-09_JPRB, 0.26178842E-09_JPRB, &
  & 0.26205291E-09_JPRB, 0.26227615E-09_JPRB, 0.26244609E-09_JPRB, 0.26255900E-09_JPRB, 0.26261826E-09_JPRB, 0.26262867E-09_JPRB, &
  & 0.26259322E-09_JPRB, 0.26251248E-09_JPRB, 0.26238769E-09_JPRB, 0.26222641E-09_JPRB, 0.26204322E-09_JPRB, 0.26185426E-09_JPRB, &
  & 0.26167016E-09_JPRB, 0.26149630E-09_JPRB, 0.26133773E-09_JPRB, 0.26120359E-09_JPRB, 0.26110739E-09_JPRB, 0.26106645E-09_JPRB, &
  & 0.26109304E-09_JPRB, 0.26118499E-09_JPRB, 0.26131877E-09_JPRB, 0.26145994E-09_JPRB, 0.26157815E-09_JPRB, 0.26165611E-09_JPRB, &
  & 0.26169367E-09_JPRB, 0.26170016E-09_JPRB, 0.26168911E-09_JPRB, 0.26167143E-09_JPRB, 0.26165331E-09_JPRB, 0.26163674E-09_JPRB, &
  & 0.26162100E-09_JPRB, 0.26160488E-09_JPRB, 0.26158783E-09_JPRB, 0.26156810E-09_JPRB, 0.26154662E-09_JPRB, 0.26152353E-09_JPRB, &
  & 0.26150077E-09_JPRB, 0.26147820E-09_JPRB, 0.26145303E-09_JPRB, 0.26141025E-09_JPRB /)

RGHG5(:,65, 1) = (/ &
  & 0.26123159E-09_JPRB, 0.26124952E-09_JPRB, 0.26124747E-09_JPRB, 0.26123650E-09_JPRB, 0.26121730E-09_JPRB, 0.26118951E-09_JPRB, &
  & 0.26115884E-09_JPRB, 0.26113356E-09_JPRB, 0.26112118E-09_JPRB, 0.26112160E-09_JPRB, 0.26113209E-09_JPRB, 0.26114691E-09_JPRB, &
  & 0.26115754E-09_JPRB, 0.26115571E-09_JPRB, 0.26113389E-09_JPRB, 0.26108848E-09_JPRB, 0.26102670E-09_JPRB, 0.26097613E-09_JPRB, &
  & 0.26097549E-09_JPRB, 0.26105107E-09_JPRB, 0.26120411E-09_JPRB, 0.26141886E-09_JPRB, 0.26166863E-09_JPRB, 0.26192673E-09_JPRB, &
  & 0.26216576E-09_JPRB, 0.26236729E-09_JPRB, 0.26251926E-09_JPRB, 0.26261965E-09_JPRB, 0.26267183E-09_JPRB, 0.26268038E-09_JPRB, &
  & 0.26264771E-09_JPRB, 0.26257360E-09_JPRB, 0.26245872E-09_JPRB, 0.26230867E-09_JPRB, 0.26213665E-09_JPRB, 0.26195648E-09_JPRB, &
  & 0.26178062E-09_JPRB, 0.26161362E-09_JPRB, 0.26146288E-09_JPRB, 0.26133740E-09_JPRB, 0.26125030E-09_JPRB, 0.26121724E-09_JPRB, &
  & 0.26124830E-09_JPRB, 0.26133884E-09_JPRB, 0.26146643E-09_JPRB, 0.26159880E-09_JPRB, 0.26170927E-09_JPRB, 0.26178346E-09_JPRB, &
  & 0.26181968E-09_JPRB, 0.26182528E-09_JPRB, 0.26181213E-09_JPRB, 0.26179117E-09_JPRB, 0.26176961E-09_JPRB, 0.26174923E-09_JPRB, &
  & 0.26172997E-09_JPRB, 0.26171082E-09_JPRB, 0.26168978E-09_JPRB, 0.26166735E-09_JPRB, 0.26164237E-09_JPRB, 0.26161667E-09_JPRB, &
  & 0.26159125E-09_JPRB, 0.26156594E-09_JPRB, 0.26153746E-09_JPRB, 0.26148789E-09_JPRB /)

RGHG5(:,66, 1) = (/ &
  & 0.26137031E-09_JPRB, 0.26139374E-09_JPRB, 0.26139507E-09_JPRB, 0.26138744E-09_JPRB, 0.26137173E-09_JPRB, 0.26134828E-09_JPRB, &
  & 0.26132119E-09_JPRB, 0.26129948E-09_JPRB, 0.26128996E-09_JPRB, 0.26129451E-09_JPRB, 0.26130983E-09_JPRB, 0.26132857E-09_JPRB, &
  & 0.26134206E-09_JPRB, 0.26134211E-09_JPRB, 0.26132294E-09_JPRB, 0.26128247E-09_JPRB, 0.26122862E-09_JPRB, 0.26118691E-09_JPRB, &
  & 0.26119043E-09_JPRB, 0.26126201E-09_JPRB, 0.26140279E-09_JPRB, 0.26159797E-09_JPRB, 0.26182434E-09_JPRB, 0.26205604E-09_JPRB, &
  & 0.26227079E-09_JPRB, 0.26245006E-09_JPRB, 0.26258495E-09_JPRB, 0.26267316E-09_JPRB, 0.26271879E-09_JPRB, 0.26272579E-09_JPRB, &
  & 0.26269598E-09_JPRB, 0.26262872E-09_JPRB, 0.26252411E-09_JPRB, 0.26238642E-09_JPRB, 0.26222666E-09_JPRB, 0.26205751E-09_JPRB, &
  & 0.26189062E-09_JPRB, 0.26173205E-09_JPRB, 0.26158972E-09_JPRB, 0.26147262E-09_JPRB, 0.26139391E-09_JPRB, 0.26136718E-09_JPRB, &
  & 0.26140046E-09_JPRB, 0.26148825E-09_JPRB, 0.26160826E-09_JPRB, 0.26173175E-09_JPRB, 0.26183467E-09_JPRB, 0.26190400E-09_JPRB, &
  & 0.26193869E-09_JPRB, 0.26194413E-09_JPRB, 0.26193026E-09_JPRB, 0.26190727E-09_JPRB, 0.26188224E-09_JPRB, 0.26185865E-09_JPRB, &
  & 0.26183578E-09_JPRB, 0.26181241E-09_JPRB, 0.26178842E-09_JPRB, 0.26176181E-09_JPRB, 0.26173408E-09_JPRB, 0.26170538E-09_JPRB, &
  & 0.26167693E-09_JPRB, 0.26164859E-09_JPRB, 0.26161479E-09_JPRB, 0.26155564E-09_JPRB /)

RGHG5(:,67, 1) = (/ &
  & 0.26150551E-09_JPRB, 0.26153291E-09_JPRB, 0.26153690E-09_JPRB, 0.26153213E-09_JPRB, 0.26151997E-09_JPRB, 0.26150063E-09_JPRB, &
  & 0.26147787E-09_JPRB, 0.26146030E-09_JPRB, 0.26145508E-09_JPRB, 0.26146402E-09_JPRB, 0.26148289E-09_JPRB, 0.26150426E-09_JPRB, &
  & 0.26151950E-09_JPRB, 0.26152150E-09_JPRB, 0.26150515E-09_JPRB, 0.26146985E-09_JPRB, 0.26142322E-09_JPRB, 0.26138966E-09_JPRB, &
  & 0.26139635E-09_JPRB, 0.26146321E-09_JPRB, 0.26159125E-09_JPRB, 0.26176708E-09_JPRB, 0.26196922E-09_JPRB, 0.26217600E-09_JPRB, &
  & 0.26236596E-09_JPRB, 0.26252486E-09_JPRB, 0.26264299E-09_JPRB, 0.26272032E-09_JPRB, 0.26275968E-09_JPRB, 0.26276514E-09_JPRB, &
  & 0.26273811E-09_JPRB, 0.26267757E-09_JPRB, 0.26258321E-09_JPRB, 0.26245806E-09_JPRB, 0.26231162E-09_JPRB, 0.26215469E-09_JPRB, &
  & 0.26199834E-09_JPRB, 0.26184963E-09_JPRB, 0.26171620E-09_JPRB, 0.26160815E-09_JPRB, 0.26153699E-09_JPRB, 0.26151548E-09_JPRB, &
  & 0.26154956E-09_JPRB, 0.26163280E-09_JPRB, 0.26174485E-09_JPRB, 0.26185892E-09_JPRB, 0.26195407E-09_JPRB, 0.26201863E-09_JPRB, &
  & 0.26205099E-09_JPRB, 0.26205615E-09_JPRB, 0.26204242E-09_JPRB, 0.26201860E-09_JPRB, 0.26199193E-09_JPRB, 0.26196503E-09_JPRB, &
  & 0.26193883E-09_JPRB, 0.26191252E-09_JPRB, 0.26188429E-09_JPRB, 0.26185534E-09_JPRB, 0.26182456E-09_JPRB, 0.26179336E-09_JPRB, &
  & 0.26176264E-09_JPRB, 0.26172942E-09_JPRB, 0.26168989E-09_JPRB, 0.26161423E-09_JPRB /)

RGHG5(:,68, 1) = (/ &
  & 0.26163080E-09_JPRB, 0.26166452E-09_JPRB, 0.26167246E-09_JPRB, 0.26167105E-09_JPRB, 0.26166241E-09_JPRB, 0.26164729E-09_JPRB, &
  & 0.26162961E-09_JPRB, 0.26161687E-09_JPRB, 0.26161637E-09_JPRB, 0.26162927E-09_JPRB, 0.26165062E-09_JPRB, 0.26167349E-09_JPRB, &
  & 0.26168975E-09_JPRB, 0.26169303E-09_JPRB, 0.26167948E-09_JPRB, 0.26164912E-09_JPRB, 0.26160879E-09_JPRB, 0.26158173E-09_JPRB, &
  & 0.26159006E-09_JPRB, 0.26165159E-09_JPRB, 0.26176689E-09_JPRB, 0.26192348E-09_JPRB, 0.26210289E-09_JPRB, 0.26228497E-09_JPRB, &
  & 0.26245273E-09_JPRB, 0.26259137E-09_JPRB, 0.26269470E-09_JPRB, 0.26276148E-09_JPRB, 0.26279534E-09_JPRB, 0.26279945E-09_JPRB, &
  & 0.26277497E-09_JPRB, 0.26272082E-09_JPRB, 0.26263630E-09_JPRB, 0.26252367E-09_JPRB, 0.26239075E-09_JPRB, 0.26224692E-09_JPRB, &
  & 0.26210234E-09_JPRB, 0.26196414E-09_JPRB, 0.26184097E-09_JPRB, 0.26174168E-09_JPRB, 0.26167837E-09_JPRB, 0.26166105E-09_JPRB, &
  & 0.26169483E-09_JPRB, 0.26177283E-09_JPRB, 0.26187585E-09_JPRB, 0.26198074E-09_JPRB, 0.26206798E-09_JPRB, 0.26212726E-09_JPRB, &
  & 0.26215724E-09_JPRB, 0.26216190E-09_JPRB, 0.26214855E-09_JPRB, 0.26212513E-09_JPRB, 0.26209740E-09_JPRB, 0.26206923E-09_JPRB, &
  & 0.26204067E-09_JPRB, 0.26201125E-09_JPRB, 0.26198127E-09_JPRB, 0.26194935E-09_JPRB, 0.26191710E-09_JPRB, 0.26188451E-09_JPRB, &
  & 0.26185079E-09_JPRB, 0.26181476E-09_JPRB, 0.26176544E-09_JPRB, 0.26167302E-09_JPRB /)

RGHG5(:,69, 1) = (/ &
  & 0.26175104E-09_JPRB, 0.26179214E-09_JPRB, 0.26180363E-09_JPRB, 0.26180558E-09_JPRB, 0.26180055E-09_JPRB, 0.26178987E-09_JPRB, &
  & 0.26177718E-09_JPRB, 0.26177002E-09_JPRB, 0.26177410E-09_JPRB, 0.26179020E-09_JPRB, 0.26181313E-09_JPRB, 0.26183630E-09_JPRB, &
  & 0.26185271E-09_JPRB, 0.26185690E-09_JPRB, 0.26184543E-09_JPRB, 0.26181962E-09_JPRB, 0.26178418E-09_JPRB, 0.26176253E-09_JPRB, &
  & 0.26177113E-09_JPRB, 0.26182650E-09_JPRB, 0.26192881E-09_JPRB, 0.26206720E-09_JPRB, 0.26222455E-09_JPRB, 0.26238448E-09_JPRB, &
  & 0.26253039E-09_JPRB, 0.26265143E-09_JPRB, 0.26274044E-09_JPRB, 0.26279803E-09_JPRB, 0.26282670E-09_JPRB, 0.26282956E-09_JPRB, &
  & 0.26280755E-09_JPRB, 0.26275931E-09_JPRB, 0.26268437E-09_JPRB, 0.26258401E-09_JPRB, 0.26246447E-09_JPRB, 0.26233427E-09_JPRB, &
  & 0.26220187E-09_JPRB, 0.26207531E-09_JPRB, 0.26196245E-09_JPRB, 0.26187294E-09_JPRB, 0.26181690E-09_JPRB, 0.26180347E-09_JPRB, &
  & 0.26183630E-09_JPRB, 0.26190852E-09_JPRB, 0.26200250E-09_JPRB, 0.26209765E-09_JPRB, 0.26217700E-09_JPRB, 0.26223090E-09_JPRB, &
  & 0.26225813E-09_JPRB, 0.26226221E-09_JPRB, 0.26224942E-09_JPRB, 0.26222680E-09_JPRB, 0.26219954E-09_JPRB, 0.26217090E-09_JPRB, &
  & 0.26214131E-09_JPRB, 0.26211100E-09_JPRB, 0.26207908E-09_JPRB, 0.26204669E-09_JPRB, 0.26201366E-09_JPRB, 0.26198013E-09_JPRB, &
  & 0.26194585E-09_JPRB, 0.26190511E-09_JPRB, 0.26184901E-09_JPRB, 0.26173283E-09_JPRB /)

RGHG5(:,70, 1) = (/ &
  & 0.26186545E-09_JPRB, 0.26191532E-09_JPRB, 0.26193167E-09_JPRB, 0.26193711E-09_JPRB, 0.26193572E-09_JPRB, 0.26192934E-09_JPRB, &
  & 0.26192210E-09_JPRB, 0.26192024E-09_JPRB, 0.26192851E-09_JPRB, 0.26194691E-09_JPRB, 0.26196975E-09_JPRB, 0.26199232E-09_JPRB, &
  & 0.26200792E-09_JPRB, 0.26201219E-09_JPRB, 0.26200250E-09_JPRB, 0.26198008E-09_JPRB, 0.26194902E-09_JPRB, 0.26193062E-09_JPRB, &
  & 0.26193850E-09_JPRB, 0.26198740E-09_JPRB, 0.26207742E-09_JPRB, 0.26219826E-09_JPRB, 0.26233574E-09_JPRB, 0.26247407E-09_JPRB, &
  & 0.26260075E-09_JPRB, 0.26270475E-09_JPRB, 0.26278130E-09_JPRB, 0.26283029E-09_JPRB, 0.26285435E-09_JPRB, 0.26285615E-09_JPRB, &
  & 0.26283642E-09_JPRB, 0.26279393E-09_JPRB, 0.26272803E-09_JPRB, 0.26263958E-09_JPRB, 0.26253341E-09_JPRB, 0.26241673E-09_JPRB, &
  & 0.26229718E-09_JPRB, 0.26218247E-09_JPRB, 0.26208066E-09_JPRB, 0.26200070E-09_JPRB, 0.26195193E-09_JPRB, 0.26194205E-09_JPRB, &
  & 0.26197389E-09_JPRB, 0.26203992E-09_JPRB, 0.26212477E-09_JPRB, 0.26221028E-09_JPRB, 0.26228131E-09_JPRB, 0.26232977E-09_JPRB, &
  & 0.26235425E-09_JPRB, 0.26235775E-09_JPRB, 0.26234565E-09_JPRB, 0.26232433E-09_JPRB, 0.26229832E-09_JPRB, 0.26227068E-09_JPRB, &
  & 0.26224170E-09_JPRB, 0.26221142E-09_JPRB, 0.26217992E-09_JPRB, 0.26214753E-09_JPRB, 0.26211491E-09_JPRB, 0.26208186E-09_JPRB, &
  & 0.26204700E-09_JPRB, 0.26200495E-09_JPRB, 0.26194086E-09_JPRB, 0.26180622E-09_JPRB /)

RGHG5(:,71, 1) = (/ &
  & 0.26197727E-09_JPRB, 0.26203742E-09_JPRB, 0.26205804E-09_JPRB, 0.26206698E-09_JPRB, 0.26206892E-09_JPRB, 0.26206676E-09_JPRB, &
  & 0.26206448E-09_JPRB, 0.26206765E-09_JPRB, 0.26207916E-09_JPRB, 0.26209807E-09_JPRB, 0.26212033E-09_JPRB, 0.26214028E-09_JPRB, &
  & 0.26215452E-09_JPRB, 0.26215835E-09_JPRB, 0.26214972E-09_JPRB, 0.26212987E-09_JPRB, 0.26210267E-09_JPRB, 0.26208657E-09_JPRB, &
  & 0.26209332E-09_JPRB, 0.26213573E-09_JPRB, 0.26221364E-09_JPRB, 0.26231825E-09_JPRB, 0.26243616E-09_JPRB, 0.26255551E-09_JPRB, &
  & 0.26266347E-09_JPRB, 0.26275251E-09_JPRB, 0.26281738E-09_JPRB, 0.26285887E-09_JPRB, 0.26287869E-09_JPRB, 0.26287972E-09_JPRB, &
  & 0.26286223E-09_JPRB, 0.26282523E-09_JPRB, 0.26276797E-09_JPRB, 0.26269101E-09_JPRB, 0.26259783E-09_JPRB, 0.26249461E-09_JPRB, &
  & 0.26238825E-09_JPRB, 0.26228575E-09_JPRB, 0.26219518E-09_JPRB, 0.26212485E-09_JPRB, 0.26208311E-09_JPRB, 0.26207661E-09_JPRB, &
  & 0.26210678E-09_JPRB, 0.26216693E-09_JPRB, 0.26224245E-09_JPRB, 0.26231811E-09_JPRB, 0.26238092E-09_JPRB, 0.26242367E-09_JPRB, &
  & 0.26244537E-09_JPRB, 0.26244840E-09_JPRB, 0.26243727E-09_JPRB, 0.26241787E-09_JPRB, 0.26239369E-09_JPRB, 0.26236854E-09_JPRB, &
  & 0.26234112E-09_JPRB, 0.26231298E-09_JPRB, 0.26228242E-09_JPRB, 0.26225178E-09_JPRB, 0.26222019E-09_JPRB, 0.26218866E-09_JPRB, &
  & 0.26215466E-09_JPRB, 0.26211247E-09_JPRB, 0.26204561E-09_JPRB, 0.26189870E-09_JPRB /)

RGHG5(:,72, 1) = (/ &
  & 0.26208891E-09_JPRB, 0.26215896E-09_JPRB, 0.26218402E-09_JPRB, 0.26219568E-09_JPRB, 0.26220054E-09_JPRB, 0.26220182E-09_JPRB, &
  & 0.26220409E-09_JPRB, 0.26221098E-09_JPRB, 0.26222458E-09_JPRB, 0.26224323E-09_JPRB, 0.26226199E-09_JPRB, 0.26228011E-09_JPRB, &
  & 0.26229149E-09_JPRB, 0.26229452E-09_JPRB, 0.26228666E-09_JPRB, 0.26226873E-09_JPRB, 0.26224506E-09_JPRB, 0.26223040E-09_JPRB, &
  & 0.26223579E-09_JPRB, 0.26227201E-09_JPRB, 0.26233857E-09_JPRB, 0.26242736E-09_JPRB, 0.26252781E-09_JPRB, 0.26262872E-09_JPRB, &
  & 0.26272010E-09_JPRB, 0.26279495E-09_JPRB, 0.26284944E-09_JPRB, 0.26288405E-09_JPRB, 0.26290023E-09_JPRB, 0.26290059E-09_JPRB, &
  & 0.26288524E-09_JPRB, 0.26285360E-09_JPRB, 0.26280447E-09_JPRB, 0.26273878E-09_JPRB, 0.26265784E-09_JPRB, 0.26256836E-09_JPRB, &
  & 0.26247507E-09_JPRB, 0.26238522E-09_JPRB, 0.26230593E-09_JPRB, 0.26224517E-09_JPRB, 0.26221014E-09_JPRB, 0.26220665E-09_JPRB, &
  & 0.26223507E-09_JPRB, 0.26228833E-09_JPRB, 0.26235486E-09_JPRB, 0.26242097E-09_JPRB, 0.26247515E-09_JPRB, 0.26251229E-09_JPRB, &
  & 0.26253136E-09_JPRB, 0.26253386E-09_JPRB, 0.26252395E-09_JPRB, 0.26250668E-09_JPRB, 0.26248570E-09_JPRB, 0.26246291E-09_JPRB, &
  & 0.26243929E-09_JPRB, 0.26241290E-09_JPRB, 0.26238592E-09_JPRB, 0.26235630E-09_JPRB, 0.26232799E-09_JPRB, 0.26229774E-09_JPRB, &
  & 0.26226649E-09_JPRB, 0.26222557E-09_JPRB, 0.26215860E-09_JPRB, 0.26200545E-09_JPRB /)

RGHG5(:,73, 1) = (/ &
  & 0.26221356E-09_JPRB, 0.26228400E-09_JPRB, 0.26230979E-09_JPRB, 0.26232255E-09_JPRB, 0.26232910E-09_JPRB, 0.26233304E-09_JPRB, &
  & 0.26233840E-09_JPRB, 0.26234798E-09_JPRB, 0.26236191E-09_JPRB, 0.26237806E-09_JPRB, 0.26239555E-09_JPRB, 0.26240882E-09_JPRB, &
  & 0.26241867E-09_JPRB, 0.26242042E-09_JPRB, 0.26241276E-09_JPRB, 0.26239644E-09_JPRB, 0.26237590E-09_JPRB, 0.26236280E-09_JPRB, &
  & 0.26236696E-09_JPRB, 0.26239710E-09_JPRB, 0.26245262E-09_JPRB, 0.26252689E-09_JPRB, 0.26261046E-09_JPRB, 0.26269489E-09_JPRB, &
  & 0.26277067E-09_JPRB, 0.26283289E-09_JPRB, 0.26287775E-09_JPRB, 0.26290631E-09_JPRB, 0.26291919E-09_JPRB, 0.26291916E-09_JPRB, &
  & 0.26290592E-09_JPRB, 0.26287925E-09_JPRB, 0.26283803E-09_JPRB, 0.26278285E-09_JPRB, 0.26271399E-09_JPRB, 0.26263763E-09_JPRB, &
  & 0.26255770E-09_JPRB, 0.26248040E-09_JPRB, 0.26241237E-09_JPRB, 0.26236105E-09_JPRB, 0.26233238E-09_JPRB, 0.26233138E-09_JPRB, &
  & 0.26235691E-09_JPRB, 0.26240371E-09_JPRB, 0.26246100E-09_JPRB, 0.26251709E-09_JPRB, 0.26256364E-09_JPRB, 0.26259520E-09_JPRB, &
  & 0.26261138E-09_JPRB, 0.26261365E-09_JPRB, 0.26260522E-09_JPRB, 0.26259059E-09_JPRB, 0.26257210E-09_JPRB, 0.26255373E-09_JPRB, &
  & 0.26253213E-09_JPRB, 0.26251062E-09_JPRB, 0.26248492E-09_JPRB, 0.26246025E-09_JPRB, 0.26243296E-09_JPRB, 0.26240726E-09_JPRB, &
  & 0.26237776E-09_JPRB, 0.26234065E-09_JPRB, 0.26227531E-09_JPRB, 0.26212135E-09_JPRB /)

RGHG5(:,74, 1) = (/ &
  & 0.26233640E-09_JPRB, 0.26240718E-09_JPRB, 0.26243208E-09_JPRB, 0.26244518E-09_JPRB, 0.26245237E-09_JPRB, 0.26245769E-09_JPRB, &
  & 0.26246488E-09_JPRB, 0.26247493E-09_JPRB, 0.26248798E-09_JPRB, 0.26250296E-09_JPRB, 0.26251570E-09_JPRB, 0.26252800E-09_JPRB, &
  & 0.26253472E-09_JPRB, 0.26253552E-09_JPRB, 0.26252811E-09_JPRB, 0.26251321E-09_JPRB, 0.26249539E-09_JPRB, 0.26248392E-09_JPRB, &
  & 0.26248687E-09_JPRB, 0.26251154E-09_JPRB, 0.26255673E-09_JPRB, 0.26261715E-09_JPRB, 0.26268548E-09_JPRB, 0.26275454E-09_JPRB, &
  & 0.26281605E-09_JPRB, 0.26286662E-09_JPRB, 0.26290276E-09_JPRB, 0.26292590E-09_JPRB, 0.26293584E-09_JPRB, 0.26293567E-09_JPRB, &
  & 0.26292446E-09_JPRB, 0.26290253E-09_JPRB, 0.26286864E-09_JPRB, 0.26282337E-09_JPRB, 0.26276636E-09_JPRB, 0.26270291E-09_JPRB, &
  & 0.26263586E-09_JPRB, 0.26257135E-09_JPRB, 0.26251426E-09_JPRB, 0.26247210E-09_JPRB, 0.26244920E-09_JPRB, 0.26244998E-09_JPRB, &
  & 0.26247238E-09_JPRB, 0.26251171E-09_JPRB, 0.26255953E-09_JPRB, 0.26260719E-09_JPRB, 0.26264538E-09_JPRB, 0.26267172E-09_JPRB, &
  & 0.26268557E-09_JPRB, 0.26268751E-09_JPRB, 0.26268043E-09_JPRB, 0.26266841E-09_JPRB, 0.26265340E-09_JPRB, 0.26263733E-09_JPRB, &
  & 0.26262037E-09_JPRB, 0.26260055E-09_JPRB, 0.26258046E-09_JPRB, 0.26255709E-09_JPRB, 0.26253560E-09_JPRB, 0.26251151E-09_JPRB, &
  & 0.26248720E-09_JPRB, 0.26245325E-09_JPRB, 0.26239264E-09_JPRB, 0.26224359E-09_JPRB /)

RGHG5(:,75, 1) = (/ &
  & 0.26245647E-09_JPRB, 0.26252459E-09_JPRB, 0.26254887E-09_JPRB, 0.26256103E-09_JPRB, 0.26256802E-09_JPRB, 0.26257369E-09_JPRB, &
  & 0.26258112E-09_JPRB, 0.26259084E-09_JPRB, 0.26260255E-09_JPRB, 0.26261421E-09_JPRB, 0.26262609E-09_JPRB, 0.26263425E-09_JPRB, &
  & 0.26264016E-09_JPRB, 0.26264002E-09_JPRB, 0.26263261E-09_JPRB, 0.26261943E-09_JPRB, 0.26260438E-09_JPRB, 0.26259472E-09_JPRB, &
  & 0.26259653E-09_JPRB, 0.26261607E-09_JPRB, 0.26265165E-09_JPRB, 0.26269942E-09_JPRB, 0.26275354E-09_JPRB, 0.26280833E-09_JPRB, &
  & 0.26285671E-09_JPRB, 0.26289654E-09_JPRB, 0.26292482E-09_JPRB, 0.26294319E-09_JPRB, 0.26295052E-09_JPRB, 0.26295030E-09_JPRB, &
  & 0.26294111E-09_JPRB, 0.26292368E-09_JPRB, 0.26289665E-09_JPRB, 0.26286068E-09_JPRB, 0.26281524E-09_JPRB, 0.26276406E-09_JPRB, &
  & 0.26270980E-09_JPRB, 0.26265773E-09_JPRB, 0.26261140E-09_JPRB, 0.26257793E-09_JPRB, 0.26256022E-09_JPRB, 0.26256225E-09_JPRB, &
  & 0.26258049E-09_JPRB, 0.26261224E-09_JPRB, 0.26265157E-09_JPRB, 0.26268948E-09_JPRB, 0.26272112E-09_JPRB, 0.26274224E-09_JPRB, &
  & 0.26275346E-09_JPRB, 0.26275518E-09_JPRB, 0.26274968E-09_JPRB, 0.26274022E-09_JPRB, 0.26272737E-09_JPRB, 0.26271527E-09_JPRB, &
  & 0.26270028E-09_JPRB, 0.26268532E-09_JPRB, 0.26266722E-09_JPRB, 0.26264982E-09_JPRB, 0.26263078E-09_JPRB, 0.26261210E-09_JPRB, &
  & 0.26259103E-09_JPRB, 0.26256253E-09_JPRB, 0.26250813E-09_JPRB, 0.26236899E-09_JPRB /)

RGHG5(:,76, 1) = (/ &
  & 0.26257063E-09_JPRB, 0.26263677E-09_JPRB, 0.26265820E-09_JPRB, 0.26266928E-09_JPRB, 0.26267519E-09_JPRB, 0.26268010E-09_JPRB, &
  & 0.26268709E-09_JPRB, 0.26269525E-09_JPRB, 0.26270464E-09_JPRB, 0.26271468E-09_JPRB, 0.26272251E-09_JPRB, 0.26272987E-09_JPRB, &
  & 0.26273372E-09_JPRB, 0.26273331E-09_JPRB, 0.26272684E-09_JPRB, 0.26271560E-09_JPRB, 0.26270369E-09_JPRB, 0.26269587E-09_JPRB, &
  & 0.26269653E-09_JPRB, 0.26271152E-09_JPRB, 0.26273825E-09_JPRB, 0.26277433E-09_JPRB, 0.26281513E-09_JPRB, 0.26285679E-09_JPRB, &
  & 0.26289296E-09_JPRB, 0.26292307E-09_JPRB, 0.26294419E-09_JPRB, 0.26295832E-09_JPRB, 0.26296343E-09_JPRB, 0.26296335E-09_JPRB, &
  & 0.26295599E-09_JPRB, 0.26294272E-09_JPRB, 0.26292210E-09_JPRB, 0.26289501E-09_JPRB, 0.26286037E-09_JPRB, 0.26282151E-09_JPRB, &
  & 0.26277919E-09_JPRB, 0.26273952E-09_JPRB, 0.26270325E-09_JPRB, 0.26267827E-09_JPRB, 0.26266508E-09_JPRB, 0.26266764E-09_JPRB, &
  & 0.26268149E-09_JPRB, 0.26270569E-09_JPRB, 0.26273589E-09_JPRB, 0.26276614E-09_JPRB, 0.26279001E-09_JPRB, 0.26280639E-09_JPRB, &
  & 0.26281533E-09_JPRB, 0.26281671E-09_JPRB, 0.26281241E-09_JPRB, 0.26280544E-09_JPRB, 0.26279529E-09_JPRB, 0.26278577E-09_JPRB, &
  & 0.26277430E-09_JPRB, 0.26276198E-09_JPRB, 0.26274877E-09_JPRB, 0.26273489E-09_JPRB, 0.26272123E-09_JPRB, 0.26270597E-09_JPRB, &
  & 0.26268987E-09_JPRB, 0.26266667E-09_JPRB, 0.26261990E-09_JPRB, 0.26249591E-09_JPRB /)

RGHG5(:,77, 1) = (/ &
  & 0.26268071E-09_JPRB, 0.26274052E-09_JPRB, 0.26275934E-09_JPRB, 0.26276845E-09_JPRB, 0.26277286E-09_JPRB, 0.26277641E-09_JPRB, &
  & 0.26278230E-09_JPRB, 0.26278843E-09_JPRB, 0.26279523E-09_JPRB, 0.26280189E-09_JPRB, 0.26280761E-09_JPRB, 0.26281194E-09_JPRB, &
  & 0.26281546E-09_JPRB, 0.26281541E-09_JPRB, 0.26281011E-09_JPRB, 0.26280167E-09_JPRB, 0.26279315E-09_JPRB, 0.26278749E-09_JPRB, &
  & 0.26278715E-09_JPRB, 0.26279795E-09_JPRB, 0.26281671E-09_JPRB, 0.26284191E-09_JPRB, 0.26287036E-09_JPRB, 0.26289995E-09_JPRB, &
  & 0.26292502E-09_JPRB, 0.26294647E-09_JPRB, 0.26296110E-09_JPRB, 0.26297153E-09_JPRB, 0.26297467E-09_JPRB, 0.26297486E-09_JPRB, &
  & 0.26296923E-09_JPRB, 0.26295977E-09_JPRB, 0.26294494E-09_JPRB, 0.26292601E-09_JPRB, 0.26290173E-09_JPRB, 0.26287425E-09_JPRB, &
  & 0.26284377E-09_JPRB, 0.26281560E-09_JPRB, 0.26278910E-09_JPRB, 0.26277192E-09_JPRB, 0.26276256E-09_JPRB, 0.26276531E-09_JPRB, &
  & 0.26277430E-09_JPRB, 0.26279109E-09_JPRB, 0.26281327E-09_JPRB, 0.26283495E-09_JPRB, 0.26285266E-09_JPRB, 0.26286401E-09_JPRB, &
  & 0.26287067E-09_JPRB, 0.26287178E-09_JPRB, 0.26286859E-09_JPRB, 0.26286401E-09_JPRB, 0.26285579E-09_JPRB, 0.26284969E-09_JPRB, &
  & 0.26284064E-09_JPRB, 0.26283220E-09_JPRB, 0.26282246E-09_JPRB, 0.26281355E-09_JPRB, 0.26280422E-09_JPRB, 0.26279323E-09_JPRB, &
  & 0.26278191E-09_JPRB, 0.26276392E-09_JPRB, 0.26272673E-09_JPRB, 0.26262129E-09_JPRB /)

RGHG5(:,78, 1) = (/ &
  & 0.26278438E-09_JPRB, 0.26283287E-09_JPRB, 0.26284544E-09_JPRB, 0.26285249E-09_JPRB, 0.26285515E-09_JPRB, 0.26285724E-09_JPRB, &
  & 0.26286207E-09_JPRB, 0.26286570E-09_JPRB, 0.26286953E-09_JPRB, 0.26287328E-09_JPRB, 0.26287564E-09_JPRB, 0.26287844E-09_JPRB, &
  & 0.26288138E-09_JPRB, 0.26288227E-09_JPRB, 0.26287883E-09_JPRB, 0.26287322E-09_JPRB, 0.26286831E-09_JPRB, 0.26286490E-09_JPRB, &
  & 0.26286393E-09_JPRB, 0.26287153E-09_JPRB, 0.26288319E-09_JPRB, 0.26289904E-09_JPRB, 0.26291666E-09_JPRB, 0.26293590E-09_JPRB, &
  & 0.26295155E-09_JPRB, 0.26296573E-09_JPRB, 0.26297509E-09_JPRB, 0.26298239E-09_JPRB, 0.26298391E-09_JPRB, 0.26298438E-09_JPRB, &
  & 0.26298025E-09_JPRB, 0.26297406E-09_JPRB, 0.26296415E-09_JPRB, 0.26295238E-09_JPRB, 0.26293712E-09_JPRB, 0.26291974E-09_JPRB, &
  & 0.26289967E-09_JPRB, 0.26288205E-09_JPRB, 0.26286376E-09_JPRB, 0.26285346E-09_JPRB, 0.26284697E-09_JPRB, 0.26284935E-09_JPRB, &
  & 0.26285374E-09_JPRB, 0.26286373E-09_JPRB, 0.26287850E-09_JPRB, 0.26289337E-09_JPRB, 0.26290489E-09_JPRB, 0.26291219E-09_JPRB, &
  & 0.26291691E-09_JPRB, 0.26291755E-09_JPRB, 0.26291516E-09_JPRB, 0.26291266E-09_JPRB, 0.26290625E-09_JPRB, 0.26290306E-09_JPRB, &
  & 0.26289654E-09_JPRB, 0.26289126E-09_JPRB, 0.26288496E-09_JPRB, 0.26288011E-09_JPRB, 0.26287489E-09_JPRB, 0.26286770E-09_JPRB, &
  & 0.26286062E-09_JPRB, 0.26284785E-09_JPRB, 0.26282240E-09_JPRB, 0.26274394E-09_JPRB /)

RGHG5(:,79, 1) = (/ &
  & 0.26285138E-09_JPRB, 0.26288421E-09_JPRB, 0.26289121E-09_JPRB, 0.26289598E-09_JPRB, 0.26289756E-09_JPRB, 0.26289879E-09_JPRB, &
  & 0.26290323E-09_JPRB, 0.26290575E-09_JPRB, 0.26290795E-09_JPRB, 0.26291047E-09_JPRB, 0.26291139E-09_JPRB, 0.26291319E-09_JPRB, &
  & 0.26291619E-09_JPRB, 0.26291763E-09_JPRB, 0.26291491E-09_JPRB, 0.26291075E-09_JPRB, 0.26290786E-09_JPRB, 0.26290584E-09_JPRB, &
  & 0.26290448E-09_JPRB, 0.26291053E-09_JPRB, 0.26291863E-09_JPRB, 0.26292943E-09_JPRB, 0.26294131E-09_JPRB, 0.26295513E-09_JPRB, &
  & 0.26296570E-09_JPRB, 0.26297611E-09_JPRB, 0.26298258E-09_JPRB, 0.26298841E-09_JPRB, 0.26298896E-09_JPRB, 0.26298966E-09_JPRB, &
  & 0.26298622E-09_JPRB, 0.26298180E-09_JPRB, 0.26297439E-09_JPRB, 0.26296654E-09_JPRB, 0.26295627E-09_JPRB, 0.26294450E-09_JPRB, &
  & 0.26292993E-09_JPRB, 0.26291797E-09_JPRB, 0.26290384E-09_JPRB, 0.26289709E-09_JPRB, 0.26289193E-09_JPRB, 0.26289418E-09_JPRB, &
  & 0.26289576E-09_JPRB, 0.26290201E-09_JPRB, 0.26291305E-09_JPRB, 0.26292429E-09_JPRB, 0.26293281E-09_JPRB, 0.26293770E-09_JPRB, &
  & 0.26294145E-09_JPRB, 0.26294186E-09_JPRB, 0.26293984E-09_JPRB, 0.26293842E-09_JPRB, 0.26293248E-09_JPRB, 0.26293101E-09_JPRB, &
  & 0.26292551E-09_JPRB, 0.26292185E-09_JPRB, 0.26291724E-09_JPRB, 0.26291461E-09_JPRB, 0.26291155E-09_JPRB, 0.26290625E-09_JPRB, &
  & 0.26290148E-09_JPRB, 0.26289240E-09_JPRB, 0.26287578E-09_JPRB, 0.26282213E-09_JPRB /)

RGHG5(:,80, 1) = (/ &
  & 0.26289565E-09_JPRB, 0.26290906E-09_JPRB, 0.26291117E-09_JPRB, 0.26291483E-09_JPRB, 0.26291574E-09_JPRB, 0.26291649E-09_JPRB, &
  & 0.26292102E-09_JPRB, 0.26292299E-09_JPRB, 0.26292490E-09_JPRB, 0.26292685E-09_JPRB, 0.26292724E-09_JPRB, 0.26292876E-09_JPRB, &
  & 0.26293190E-09_JPRB, 0.26293356E-09_JPRB, 0.26293095E-09_JPRB, 0.26292726E-09_JPRB, 0.26292532E-09_JPRB, 0.26292396E-09_JPRB, &
  & 0.26292235E-09_JPRB, 0.26292801E-09_JPRB, 0.26293445E-09_JPRB, 0.26294308E-09_JPRB, 0.26295233E-09_JPRB, 0.26296368E-09_JPRB, &
  & 0.26297203E-09_JPRB, 0.26298083E-09_JPRB, 0.26298602E-09_JPRB, 0.26299127E-09_JPRB, 0.26299132E-09_JPRB, 0.26299221E-09_JPRB, &
  & 0.26298896E-09_JPRB, 0.26298530E-09_JPRB, 0.26297900E-09_JPRB, 0.26297300E-09_JPRB, 0.26296501E-09_JPRB, 0.26295577E-09_JPRB, &
  & 0.26294367E-09_JPRB, 0.26293434E-09_JPRB, 0.26292188E-09_JPRB, 0.26291683E-09_JPRB, 0.26291216E-09_JPRB, 0.26291436E-09_JPRB, &
  & 0.26291455E-09_JPRB, 0.26291899E-09_JPRB, 0.26292840E-09_JPRB, 0.26293812E-09_JPRB, 0.26294519E-09_JPRB, 0.26294900E-09_JPRB, &
  & 0.26295238E-09_JPRB, 0.26295263E-09_JPRB, 0.26295066E-09_JPRB, 0.26294972E-09_JPRB, 0.26294383E-09_JPRB, 0.26294319E-09_JPRB, &
  & 0.26293800E-09_JPRB, 0.26293495E-09_JPRB, 0.26293104E-09_JPRB, 0.26292943E-09_JPRB, 0.26292732E-09_JPRB, 0.26292285E-09_JPRB, &
  & 0.26291927E-09_JPRB, 0.26291186E-09_JPRB, 0.26290137E-09_JPRB, 0.26287336E-09_JPRB /)

RGHG5(:,81, 1) = (/ &
  & 0.26292599E-09_JPRB, 0.26291958E-09_JPRB, 0.26291949E-09_JPRB, 0.26292271E-09_JPRB, 0.26292346E-09_JPRB, 0.26292402E-09_JPRB, &
  & 0.26292851E-09_JPRB, 0.26293048E-09_JPRB, 0.26293201E-09_JPRB, 0.26293417E-09_JPRB, 0.26293423E-09_JPRB, 0.26293570E-09_JPRB, &
  & 0.26293889E-09_JPRB, 0.26294067E-09_JPRB, 0.26293795E-09_JPRB, 0.26293442E-09_JPRB, 0.26293290E-09_JPRB, 0.26293187E-09_JPRB, &
  & 0.26293015E-09_JPRB, 0.26293556E-09_JPRB, 0.26294145E-09_JPRB, 0.26294894E-09_JPRB, 0.26295705E-09_JPRB, 0.26296743E-09_JPRB, &
  & 0.26297478E-09_JPRB, 0.26298289E-09_JPRB, 0.26298749E-09_JPRB, 0.26299257E-09_JPRB, 0.26299235E-09_JPRB, 0.26299329E-09_JPRB, &
  & 0.26299019E-09_JPRB, 0.26298685E-09_JPRB, 0.26298100E-09_JPRB, 0.26297581E-09_JPRB, 0.26296890E-09_JPRB, 0.26296076E-09_JPRB, &
  & 0.26294986E-09_JPRB, 0.26294159E-09_JPRB, 0.26292984E-09_JPRB, 0.26292557E-09_JPRB, 0.26292113E-09_JPRB, 0.26292329E-09_JPRB, &
  & 0.26292271E-09_JPRB, 0.26292632E-09_JPRB, 0.26293509E-09_JPRB, 0.26294417E-09_JPRB, 0.26295066E-09_JPRB, 0.26295396E-09_JPRB, &
  & 0.26295716E-09_JPRB, 0.26295735E-09_JPRB, 0.26295530E-09_JPRB, 0.26295457E-09_JPRB, 0.26294866E-09_JPRB, 0.26294839E-09_JPRB, &
  & 0.26294328E-09_JPRB, 0.26294056E-09_JPRB, 0.26293684E-09_JPRB, 0.26293567E-09_JPRB, 0.26293406E-09_JPRB, 0.26292996E-09_JPRB, &
  & 0.26292685E-09_JPRB, 0.26292010E-09_JPRB, 0.26291214E-09_JPRB, 0.26290814E-09_JPRB /)

RGHG5(:,82, 1) = (/ &
  & 0.26292846E-09_JPRB, 0.26292310E-09_JPRB, 0.26292318E-09_JPRB, 0.26292651E-09_JPRB, 0.26292718E-09_JPRB, 0.26292760E-09_JPRB, &
  & 0.26293229E-09_JPRB, 0.26293401E-09_JPRB, 0.26293581E-09_JPRB, 0.26293762E-09_JPRB, 0.26293773E-09_JPRB, 0.26293900E-09_JPRB, &
  & 0.26294236E-09_JPRB, 0.26294425E-09_JPRB, 0.26294145E-09_JPRB, 0.26293795E-09_JPRB, 0.26293664E-09_JPRB, 0.26293576E-09_JPRB, &
  & 0.26293384E-09_JPRB, 0.26293939E-09_JPRB, 0.26294472E-09_JPRB, 0.26295194E-09_JPRB, 0.26295935E-09_JPRB, 0.26296926E-09_JPRB, &
  & 0.26297609E-09_JPRB, 0.26298391E-09_JPRB, 0.26298821E-09_JPRB, 0.26299324E-09_JPRB, 0.26299291E-09_JPRB, 0.26299396E-09_JPRB, &
  & 0.26299077E-09_JPRB, 0.26298755E-09_JPRB, 0.26298189E-09_JPRB, 0.26297711E-09_JPRB, 0.26297070E-09_JPRB, 0.26296321E-09_JPRB, &
  & 0.26295291E-09_JPRB, 0.26294508E-09_JPRB, 0.26293390E-09_JPRB, 0.26292993E-09_JPRB, 0.26292560E-09_JPRB, 0.26292774E-09_JPRB, &
  & 0.26292674E-09_JPRB, 0.26292982E-09_JPRB, 0.26293834E-09_JPRB, 0.26294714E-09_JPRB, 0.26295330E-09_JPRB, 0.26295635E-09_JPRB, &
  & 0.26295946E-09_JPRB, 0.26295971E-09_JPRB, 0.26295757E-09_JPRB, 0.26295696E-09_JPRB, 0.26295097E-09_JPRB, 0.26295094E-09_JPRB, &
  & 0.26294572E-09_JPRB, 0.26294325E-09_JPRB, 0.26293961E-09_JPRB, 0.26293873E-09_JPRB, 0.26293739E-09_JPRB, 0.26293343E-09_JPRB, &
  & 0.26293057E-09_JPRB, 0.26292371E-09_JPRB, 0.26291574E-09_JPRB, 0.26291089E-09_JPRB /)

RGHG5(:,83, 1) = (/ &
  & 0.26293018E-09_JPRB, 0.26292518E-09_JPRB, 0.26292524E-09_JPRB, 0.26292865E-09_JPRB, 0.26292932E-09_JPRB, 0.26292968E-09_JPRB, &
  & 0.26293420E-09_JPRB, 0.26293623E-09_JPRB, 0.26293759E-09_JPRB, 0.26293981E-09_JPRB, 0.26293970E-09_JPRB, 0.26294111E-09_JPRB, &
  & 0.26294428E-09_JPRB, 0.26294622E-09_JPRB, 0.26294342E-09_JPRB, 0.26293989E-09_JPRB, 0.26293873E-09_JPRB, 0.26293798E-09_JPRB, &
  & 0.26293598E-09_JPRB, 0.26294134E-09_JPRB, 0.26294672E-09_JPRB, 0.26295333E-09_JPRB, 0.26296065E-09_JPRB, 0.26297023E-09_JPRB, &
  & 0.26297675E-09_JPRB, 0.26298450E-09_JPRB, 0.26298866E-09_JPRB, 0.26299365E-09_JPRB, 0.26299318E-09_JPRB, 0.26299427E-09_JPRB, &
  & 0.26299107E-09_JPRB, 0.26298794E-09_JPRB, 0.26298236E-09_JPRB, 0.26297775E-09_JPRB, 0.26297170E-09_JPRB, 0.26296443E-09_JPRB, &
  & 0.26295460E-09_JPRB, 0.26294711E-09_JPRB, 0.26293623E-09_JPRB, 0.26293245E-09_JPRB, 0.26292821E-09_JPRB, 0.26293023E-09_JPRB, &
  & 0.26292887E-09_JPRB, 0.26293168E-09_JPRB, 0.26294017E-09_JPRB, 0.26294883E-09_JPRB, 0.26295485E-09_JPRB, 0.26295768E-09_JPRB, &
  & 0.26296085E-09_JPRB, 0.26296099E-09_JPRB, 0.26295882E-09_JPRB, 0.26295829E-09_JPRB, 0.26295222E-09_JPRB, 0.26295233E-09_JPRB, &
  & 0.26294708E-09_JPRB, 0.26294475E-09_JPRB, 0.26294114E-09_JPRB, 0.26294042E-09_JPRB, 0.26293925E-09_JPRB, 0.26293537E-09_JPRB, &
  & 0.26293265E-09_JPRB, 0.26292576E-09_JPRB, 0.26291777E-09_JPRB, 0.26291272E-09_JPRB /)

RGHG5(:,84, 1) = (/ &
  & 0.26293143E-09_JPRB, 0.26292651E-09_JPRB, 0.26292654E-09_JPRB, 0.26292998E-09_JPRB, 0.26293059E-09_JPRB, 0.26293079E-09_JPRB, &
  & 0.26293562E-09_JPRB, 0.26293726E-09_JPRB, 0.26293911E-09_JPRB, 0.26294081E-09_JPRB, 0.26294097E-09_JPRB, 0.26294222E-09_JPRB, &
  & 0.26294555E-09_JPRB, 0.26294736E-09_JPRB, 0.26294467E-09_JPRB, 0.26294109E-09_JPRB, 0.26294003E-09_JPRB, 0.26293928E-09_JPRB, &
  & 0.26293723E-09_JPRB, 0.26294286E-09_JPRB, 0.26294764E-09_JPRB, 0.26295438E-09_JPRB, 0.26296126E-09_JPRB, 0.26297084E-09_JPRB, &
  & 0.26297717E-09_JPRB, 0.26298483E-09_JPRB, 0.26298891E-09_JPRB, 0.26299393E-09_JPRB, 0.26299335E-09_JPRB, 0.26299454E-09_JPRB, &
  & 0.26299127E-09_JPRB, 0.26298816E-09_JPRB, 0.26298252E-09_JPRB, 0.26297814E-09_JPRB, 0.26297220E-09_JPRB, 0.26296521E-09_JPRB, &
  & 0.26295577E-09_JPRB, 0.26294830E-09_JPRB, 0.26293784E-09_JPRB, 0.26293404E-09_JPRB, 0.26292990E-09_JPRB, 0.26293182E-09_JPRB, &
  & 0.26293021E-09_JPRB, 0.26293284E-09_JPRB, 0.26294120E-09_JPRB, 0.26294991E-09_JPRB, 0.26295582E-09_JPRB, 0.26295854E-09_JPRB, &
  & 0.26296165E-09_JPRB, 0.26296179E-09_JPRB, 0.26295960E-09_JPRB, 0.26295913E-09_JPRB, 0.26295296E-09_JPRB, 0.26295321E-09_JPRB, &
  & 0.26294789E-09_JPRB, 0.26294561E-09_JPRB, 0.26294206E-09_JPRB, 0.26294145E-09_JPRB, 0.26294045E-09_JPRB, 0.26293659E-09_JPRB, &
  & 0.26293404E-09_JPRB, 0.26292701E-09_JPRB, 0.26291902E-09_JPRB, 0.26291391E-09_JPRB /)

RGHG5(:,85, 1) = (/ &
  & 0.26293223E-09_JPRB, 0.26292735E-09_JPRB, 0.26292732E-09_JPRB, 0.26293084E-09_JPRB, 0.26293151E-09_JPRB, 0.26293179E-09_JPRB, &
  & 0.26293631E-09_JPRB, 0.26293834E-09_JPRB, 0.26293981E-09_JPRB, 0.26294167E-09_JPRB, 0.26294195E-09_JPRB, 0.26294336E-09_JPRB, &
  & 0.26294611E-09_JPRB, 0.26294791E-09_JPRB, 0.26294547E-09_JPRB, 0.26294192E-09_JPRB, 0.26294089E-09_JPRB, 0.26294011E-09_JPRB, &
  & 0.26293809E-09_JPRB, 0.26294344E-09_JPRB, 0.26294852E-09_JPRB, 0.26295474E-09_JPRB, 0.26296176E-09_JPRB, 0.26297120E-09_JPRB, &
  & 0.26297745E-09_JPRB, 0.26298516E-09_JPRB, 0.26298905E-09_JPRB, 0.26299418E-09_JPRB, 0.26299346E-09_JPRB, 0.26299468E-09_JPRB, &
  & 0.26299141E-09_JPRB, 0.26298827E-09_JPRB, 0.26298266E-09_JPRB, 0.26297831E-09_JPRB, 0.26297259E-09_JPRB, 0.26296579E-09_JPRB, &
  & 0.26295652E-09_JPRB, 0.26294927E-09_JPRB, 0.26293873E-09_JPRB, 0.26293515E-09_JPRB, 0.26293084E-09_JPRB, 0.26293287E-09_JPRB, &
  & 0.26293101E-09_JPRB, 0.26293337E-09_JPRB, 0.26294203E-09_JPRB, 0.26295055E-09_JPRB, 0.26295649E-09_JPRB, 0.26295907E-09_JPRB, &
  & 0.26296224E-09_JPRB, 0.26296232E-09_JPRB, 0.26296013E-09_JPRB, 0.26295968E-09_JPRB, 0.26295341E-09_JPRB, 0.26295385E-09_JPRB, &
  & 0.26294841E-09_JPRB, 0.26294614E-09_JPRB, 0.26294258E-09_JPRB, 0.26294208E-09_JPRB, 0.26294120E-09_JPRB, 0.26293742E-09_JPRB, &
  & 0.26293495E-09_JPRB, 0.26292787E-09_JPRB, 0.26291982E-09_JPRB, 0.26291469E-09_JPRB /)

RGHG5(:,86, 1) = (/ &
  & 0.26293279E-09_JPRB, 0.26292790E-09_JPRB, 0.26292787E-09_JPRB, 0.26293145E-09_JPRB, 0.26293209E-09_JPRB, 0.26293234E-09_JPRB, &
  & 0.26293723E-09_JPRB, 0.26293895E-09_JPRB, 0.26294061E-09_JPRB, 0.26294200E-09_JPRB, 0.26294261E-09_JPRB, 0.26294389E-09_JPRB, &
  & 0.26294628E-09_JPRB, 0.26294789E-09_JPRB, 0.26294586E-09_JPRB, 0.26294256E-09_JPRB, 0.26294147E-09_JPRB, 0.26294064E-09_JPRB, &
  & 0.26293856E-09_JPRB, 0.26294408E-09_JPRB, 0.26294877E-09_JPRB, 0.26295519E-09_JPRB, 0.26296182E-09_JPRB, 0.26297151E-09_JPRB, &
  & 0.26297761E-09_JPRB, 0.26298541E-09_JPRB, 0.26298921E-09_JPRB, 0.26299440E-09_JPRB, 0.26299357E-09_JPRB, 0.26299490E-09_JPRB, &
  & 0.26299149E-09_JPRB, 0.26298838E-09_JPRB, 0.26298275E-09_JPRB, 0.26297847E-09_JPRB, 0.26297289E-09_JPRB, 0.26296623E-09_JPRB, &
  & 0.26295710E-09_JPRB, 0.26294986E-09_JPRB, 0.26293925E-09_JPRB, 0.26293562E-09_JPRB, 0.26293132E-09_JPRB, 0.26293362E-09_JPRB, &
  & 0.26293148E-09_JPRB, 0.26293392E-09_JPRB, 0.26294236E-09_JPRB, 0.26295105E-09_JPRB, 0.26295696E-09_JPRB, 0.26295949E-09_JPRB, &
  & 0.26296265E-09_JPRB, 0.26296265E-09_JPRB, 0.26296040E-09_JPRB, 0.26296004E-09_JPRB, 0.26295369E-09_JPRB, 0.26295424E-09_JPRB, &
  & 0.26294869E-09_JPRB, 0.26294644E-09_JPRB, 0.26294292E-09_JPRB, 0.26294253E-09_JPRB, 0.26294172E-09_JPRB, 0.26293798E-09_JPRB, &
  & 0.26293559E-09_JPRB, 0.26292843E-09_JPRB, 0.26292038E-09_JPRB, 0.26291516E-09_JPRB /)

RGHG5(:,87, 1) = (/ &
  & 0.26293312E-09_JPRB, 0.26292826E-09_JPRB, 0.26292812E-09_JPRB, 0.26293182E-09_JPRB, 0.26293251E-09_JPRB, 0.26293320E-09_JPRB, &
  & 0.26293745E-09_JPRB, 0.26293953E-09_JPRB, 0.26294100E-09_JPRB, 0.26294236E-09_JPRB, 0.26294308E-09_JPRB, 0.26294428E-09_JPRB, &
  & 0.26294639E-09_JPRB, 0.26294772E-09_JPRB, 0.26294603E-09_JPRB, 0.26294303E-09_JPRB, 0.26294186E-09_JPRB, 0.26294097E-09_JPRB, &
  & 0.26293892E-09_JPRB, 0.26294428E-09_JPRB, 0.26294908E-09_JPRB, 0.26295524E-09_JPRB, 0.26296185E-09_JPRB, 0.26297164E-09_JPRB, &
  & 0.26297767E-09_JPRB, 0.26298563E-09_JPRB, 0.26298924E-09_JPRB, 0.26299463E-09_JPRB, 0.26299360E-09_JPRB, 0.26299493E-09_JPRB, &
  & 0.26299149E-09_JPRB, 0.26298846E-09_JPRB, 0.26298280E-09_JPRB, 0.26297858E-09_JPRB, 0.26297317E-09_JPRB, 0.26296668E-09_JPRB, &
  & 0.26295741E-09_JPRB, 0.26295049E-09_JPRB, 0.26293917E-09_JPRB, 0.26293606E-09_JPRB, 0.26293132E-09_JPRB, 0.26293412E-09_JPRB, &
  & 0.26293168E-09_JPRB, 0.26293398E-09_JPRB, 0.26294272E-09_JPRB, 0.26295127E-09_JPRB, 0.26295724E-09_JPRB, 0.26295974E-09_JPRB, &
  & 0.26296293E-09_JPRB, 0.26296290E-09_JPRB, 0.26296060E-09_JPRB, 0.26296021E-09_JPRB, 0.26295383E-09_JPRB, 0.26295441E-09_JPRB, &
  & 0.26294883E-09_JPRB, 0.26294655E-09_JPRB, 0.26294306E-09_JPRB, 0.26294272E-09_JPRB, 0.26294203E-09_JPRB, 0.26293834E-09_JPRB, &
  & 0.26293595E-09_JPRB, 0.26292876E-09_JPRB, 0.26292063E-09_JPRB, 0.26291547E-09_JPRB /)

RGHG5(:,88, 1) = (/ &
  & 0.26293323E-09_JPRB, 0.26292848E-09_JPRB, 0.26292832E-09_JPRB, 0.26293204E-09_JPRB, 0.26293276E-09_JPRB, 0.26293323E-09_JPRB, &
  & 0.26293798E-09_JPRB, 0.26293973E-09_JPRB, 0.26294125E-09_JPRB, 0.26294258E-09_JPRB, 0.26294333E-09_JPRB, 0.26294456E-09_JPRB, &
  & 0.26294644E-09_JPRB, 0.26294775E-09_JPRB, 0.26294619E-09_JPRB, 0.26294331E-09_JPRB, 0.26294214E-09_JPRB, 0.26294120E-09_JPRB, &
  & 0.26293906E-09_JPRB, 0.26294442E-09_JPRB, 0.26294916E-09_JPRB, 0.26295532E-09_JPRB, 0.26296185E-09_JPRB, 0.26297181E-09_JPRB, &
  & 0.26297764E-09_JPRB, 0.26298574E-09_JPRB, 0.26298930E-09_JPRB, 0.26299482E-09_JPRB, 0.26299360E-09_JPRB, 0.26299501E-09_JPRB, &
  & 0.26299155E-09_JPRB, 0.26298858E-09_JPRB, 0.26298283E-09_JPRB, 0.26297872E-09_JPRB, 0.26297337E-09_JPRB, 0.26296693E-09_JPRB, &
  & 0.26295760E-09_JPRB, 0.26295080E-09_JPRB, 0.26293909E-09_JPRB, 0.26293628E-09_JPRB, 0.26293120E-09_JPRB, 0.26293445E-09_JPRB, &
  & 0.26293173E-09_JPRB, 0.26293412E-09_JPRB, 0.26294289E-09_JPRB, 0.26295147E-09_JPRB, 0.26295741E-09_JPRB, 0.26295985E-09_JPRB, &
  & 0.26296310E-09_JPRB, 0.26296298E-09_JPRB, 0.26296071E-09_JPRB, 0.26296038E-09_JPRB, 0.26295391E-09_JPRB, 0.26295452E-09_JPRB, &
  & 0.26294891E-09_JPRB, 0.26294664E-09_JPRB, 0.26294317E-09_JPRB, 0.26294289E-09_JPRB, 0.26294225E-09_JPRB, 0.26293859E-09_JPRB, &
  & 0.26293620E-09_JPRB, 0.26292893E-09_JPRB, 0.26292088E-09_JPRB, 0.26291566E-09_JPRB /)

RGHG5(:,89, 1) = (/ &
  & 0.26293318E-09_JPRB, 0.26292871E-09_JPRB, 0.26292846E-09_JPRB, 0.26293220E-09_JPRB, 0.26293290E-09_JPRB, 0.26293334E-09_JPRB, &
  & 0.26293778E-09_JPRB, 0.26293978E-09_JPRB, 0.26294128E-09_JPRB, 0.26294261E-09_JPRB, 0.26294336E-09_JPRB, 0.26294458E-09_JPRB, &
  & 0.26294680E-09_JPRB, 0.26294814E-09_JPRB, 0.26294639E-09_JPRB, 0.26294328E-09_JPRB, 0.26294217E-09_JPRB, 0.26294125E-09_JPRB, &
  & 0.26293903E-09_JPRB, 0.26294464E-09_JPRB, 0.26294922E-09_JPRB, 0.26295535E-09_JPRB, 0.26296182E-09_JPRB, 0.26297187E-09_JPRB, &
  & 0.26297767E-09_JPRB, 0.26298591E-09_JPRB, 0.26298930E-09_JPRB, 0.26299493E-09_JPRB, 0.26299363E-09_JPRB, 0.26299513E-09_JPRB, &
  & 0.26299155E-09_JPRB, 0.26298871E-09_JPRB, 0.26298289E-09_JPRB, 0.26297883E-09_JPRB, 0.26297353E-09_JPRB, 0.26296720E-09_JPRB, &
  & 0.26295763E-09_JPRB, 0.26295108E-09_JPRB, 0.26293881E-09_JPRB, 0.26293645E-09_JPRB, 0.26293109E-09_JPRB, 0.26293470E-09_JPRB, &
  & 0.26293168E-09_JPRB, 0.26293406E-09_JPRB, 0.26294295E-09_JPRB, 0.26295155E-09_JPRB, 0.26295752E-09_JPRB, 0.26295996E-09_JPRB, &
  & 0.26296321E-09_JPRB, 0.26296312E-09_JPRB, 0.26296079E-09_JPRB, 0.26296049E-09_JPRB, 0.26295391E-09_JPRB, 0.26295466E-09_JPRB, &
  & 0.26294897E-09_JPRB, 0.26294675E-09_JPRB, 0.26294314E-09_JPRB, 0.26294303E-09_JPRB, 0.26294245E-09_JPRB, 0.26293870E-09_JPRB, &
  & 0.26293642E-09_JPRB, 0.26292904E-09_JPRB, 0.26292085E-09_JPRB, 0.26291566E-09_JPRB /)

RGHG5(:,90, 1) = (/ &
  & 0.26293298E-09_JPRB, 0.26292885E-09_JPRB, 0.26292840E-09_JPRB, 0.26293231E-09_JPRB, 0.26293279E-09_JPRB, 0.26293256E-09_JPRB, &
  & 0.26293795E-09_JPRB, 0.26293959E-09_JPRB, 0.26294111E-09_JPRB, 0.26294264E-09_JPRB, 0.26294319E-09_JPRB, 0.26294458E-09_JPRB, &
  & 0.26294722E-09_JPRB, 0.26294886E-09_JPRB, 0.26294655E-09_JPRB, 0.26294311E-09_JPRB, 0.26294217E-09_JPRB, 0.26294125E-09_JPRB, &
  & 0.26293867E-09_JPRB, 0.26294467E-09_JPRB, 0.26294922E-09_JPRB, 0.26295541E-09_JPRB, 0.26296179E-09_JPRB, 0.26297201E-09_JPRB, &
  & 0.26297764E-09_JPRB, 0.26298608E-09_JPRB, 0.26298921E-09_JPRB, 0.26299515E-09_JPRB, 0.26299360E-09_JPRB, 0.26299540E-09_JPRB, &
  & 0.26299160E-09_JPRB, 0.26298888E-09_JPRB, 0.26298291E-09_JPRB, 0.26297897E-09_JPRB, 0.26297373E-09_JPRB, 0.26296731E-09_JPRB, &
  & 0.26295752E-09_JPRB, 0.26295122E-09_JPRB, 0.26293848E-09_JPRB, 0.26293659E-09_JPRB, 0.26293087E-09_JPRB, 0.26293498E-09_JPRB, &
  & 0.26293159E-09_JPRB, 0.26293395E-09_JPRB, 0.26294297E-09_JPRB, 0.26295163E-09_JPRB, 0.26295768E-09_JPRB, 0.26296004E-09_JPRB, &
  & 0.26296340E-09_JPRB, 0.26296321E-09_JPRB, 0.26296082E-09_JPRB, 0.26296074E-09_JPRB, 0.26295383E-09_JPRB, 0.26295485E-09_JPRB, &
  & 0.26294888E-09_JPRB, 0.26294678E-09_JPRB, 0.26294311E-09_JPRB, 0.26294311E-09_JPRB, 0.26294258E-09_JPRB, 0.26293870E-09_JPRB, &
  & 0.26293656E-09_JPRB, 0.26292904E-09_JPRB, 0.26292077E-09_JPRB, 0.26291561E-09_JPRB /)

RGHG5(:,91, 1) = (/ &
  & 0.26293256E-09_JPRB, 0.26292910E-09_JPRB, 0.26292807E-09_JPRB, 0.26293256E-09_JPRB, 0.26293290E-09_JPRB, 0.26293159E-09_JPRB, &
  & 0.26293809E-09_JPRB, 0.26293923E-09_JPRB, 0.26294070E-09_JPRB, 0.26294336E-09_JPRB, 0.26294253E-09_JPRB, 0.26294383E-09_JPRB, &
  & 0.26294827E-09_JPRB, 0.26295038E-09_JPRB, 0.26294666E-09_JPRB, 0.26294258E-09_JPRB, 0.26294211E-09_JPRB, 0.26294142E-09_JPRB, &
  & 0.26293795E-09_JPRB, 0.26294480E-09_JPRB, 0.26294913E-09_JPRB, 0.26295535E-09_JPRB, 0.26296151E-09_JPRB, 0.26297234E-09_JPRB, &
  & 0.26297747E-09_JPRB, 0.26298638E-09_JPRB, 0.26298910E-09_JPRB, 0.26299571E-09_JPRB, 0.26299332E-09_JPRB, 0.26299585E-09_JPRB, &
  & 0.26299155E-09_JPRB, 0.26298932E-09_JPRB, 0.26298283E-09_JPRB, 0.26297908E-09_JPRB, 0.26297386E-09_JPRB, 0.26296781E-09_JPRB, &
  & 0.26295682E-09_JPRB, 0.26295160E-09_JPRB, 0.26293762E-09_JPRB, 0.26293676E-09_JPRB, 0.26293026E-09_JPRB, 0.26293551E-09_JPRB, &
  & 0.26293118E-09_JPRB, 0.26293348E-09_JPRB, 0.26294306E-09_JPRB, 0.26295183E-09_JPRB, 0.26295799E-09_JPRB, 0.26295999E-09_JPRB, &
  & 0.26296365E-09_JPRB, 0.26296340E-09_JPRB, 0.26296068E-09_JPRB, 0.26296115E-09_JPRB, 0.26295327E-09_JPRB, 0.26295530E-09_JPRB, &
  & 0.26294866E-09_JPRB, 0.26294689E-09_JPRB, 0.26294289E-09_JPRB, 0.26294317E-09_JPRB, 0.26294278E-09_JPRB, 0.26293856E-09_JPRB, &
  & 0.26293684E-09_JPRB, 0.26292876E-09_JPRB, 0.26292027E-09_JPRB, 0.26291544E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART2',1,ZHOOK_HANDLE)
END SUBROUTINE PART2






SUBROUTINE PART3
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART3',0,ZHOOK_HANDLE)



!-- Month=  2 ------------

RGHG5(:, 1, 2) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.70064923E-44_JPRB, 0.14012985E-43_JPRB, 0.37835059E-43_JPRB, &
  & 0.95288296E-43_JPRB, 0.22981295E-42_JPRB, 0.60676224E-42_JPRB, 0.15049946E-41_JPRB, 0.36013371E-41_JPRB, 0.92667867E-41_JPRB, &
  & 0.24791772E-40_JPRB, 0.48805824E-40_JPRB, 0.92230662E-40_JPRB, 0.14565096E-39_JPRB, 0.17454714E-39_JPRB, 0.22115292E-39_JPRB, &
  & 0.27920171E-39_JPRB, 0.40084843E-39_JPRB, 0.74958117E-39_JPRB, 0.76542565E-39_JPRB, 0.97039779E-39_JPRB, 0.94546728E-39_JPRB, &
  & 0.13359811E-38_JPRB, 0.94004846E-39_JPRB, 0.78335247E-39_JPRB, 0.54195919E-39_JPRB, 0.42600174E-39_JPRB, 0.24727873E-39_JPRB, &
  & 0.20101346E-39_JPRB, 0.12235858E-39_JPRB, 0.80633516E-40_JPRB, 0.53682343E-40_JPRB, 0.35842412E-40_JPRB, 0.23571241E-40_JPRB, &
  & 0.15066761E-40_JPRB, 0.92499712E-41_JPRB, 0.54384393E-41_JPRB, 0.30758501E-41_JPRB, 0.16857621E-41_JPRB, 0.91224530E-42_JPRB, &
  & 0.49325706E-42_JPRB, 0.26764801E-42_JPRB, 0.14853764E-42_JPRB, 0.82676609E-43_JPRB, 0.47644148E-43_JPRB, 0.28025969E-43_JPRB, &
  & 0.16815582E-43_JPRB, 0.98090893E-44_JPRB, 0.70064923E-44_JPRB, 0.56051939E-44_JPRB, 0.42038954E-44_JPRB, 0.42038954E-44_JPRB, &
  & 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB /)

RGHG5(:, 2, 2) = (/ &
  & 0.14012985E-44_JPRB, 0.42038954E-44_JPRB, 0.84077908E-44_JPRB, 0.98090893E-44_JPRB, 0.12611686E-43_JPRB, 0.16815582E-43_JPRB, &
  & 0.26624671E-43_JPRB, 0.51848043E-43_JPRB, 0.11350518E-42_JPRB, 0.26484541E-42_JPRB, 0.65020249E-42_JPRB, 0.16269075E-41_JPRB, &
  & 0.40721733E-41_JPRB, 0.99618308E-41_JPRB, 0.25859562E-40_JPRB, 0.64514380E-40_JPRB, 0.15769652E-39_JPRB, 0.40240808E-39_JPRB, &
  & 0.10164290E-38_JPRB, 0.19768622E-38_JPRB, 0.36473697E-38_JPRB, 0.57170805E-38_JPRB, 0.69522018E-38_JPRB, 0.89143153E-38_JPRB, &
  & 0.11535304E-37_JPRB, 0.16889612E-37_JPRB, 0.28795092E-37_JPRB, 0.31211541E-37_JPRB, 0.38266019E-37_JPRB, 0.39177788E-37_JPRB, &
  & 0.50941773E-37_JPRB, 0.38252612E-37_JPRB, 0.31198610E-37_JPRB, 0.21921374E-37_JPRB, 0.16775582E-37_JPRB, 0.10140464E-37_JPRB, &
  & 0.78491870E-38_JPRB, 0.49624687E-38_JPRB, 0.32689280E-38_JPRB, 0.21683973E-38_JPRB, 0.14424294E-38_JPRB, 0.94662896E-39_JPRB, &
  & 0.60584579E-39_JPRB, 0.37441714E-39_JPRB, 0.22328430E-39_JPRB, 0.12913806E-39_JPRB, 0.72943190E-40_JPRB, 0.40756766E-40_JPRB, &
  & 0.22698233E-40_JPRB, 0.12667738E-40_JPRB, 0.71143923E-41_JPRB, 0.40371409E-41_JPRB, 0.23275567E-41_JPRB, 0.13760751E-41_JPRB, &
  & 0.84498297E-42_JPRB, 0.54510510E-42_JPRB, 0.37134409E-42_JPRB, 0.27045060E-42_JPRB, 0.20739217E-42_JPRB, 0.16535322E-42_JPRB, &
  & 0.13592595E-42_JPRB, 0.11070258E-42_JPRB, 0.88281803E-43_JPRB, 0.68663625E-43_JPRB /)

RGHG5(:, 3, 2) = (/ &
  & 0.43440252E-43_JPRB, 0.25924022E-42_JPRB, 0.41198175E-42_JPRB, 0.47784278E-42_JPRB, 0.57453237E-42_JPRB, 0.80014142E-42_JPRB, &
  & 0.13270296E-41_JPRB, 0.25853957E-41_JPRB, 0.56136016E-41_JPRB, 0.13212843E-40_JPRB, 0.32486302E-40_JPRB, 0.81322955E-40_JPRB, &
  & 0.20293744E-39_JPRB, 0.49725076E-39_JPRB, 0.12767847E-38_JPRB, 0.31536362E-38_JPRB, 0.75907945E-38_JPRB, 0.18805353E-37_JPRB, &
  & 0.46716062E-37_JPRB, 0.90196448E-37_JPRB, 0.16934987E-36_JPRB, 0.27192484E-36_JPRB, 0.32840299E-36_JPRB, 0.42523745E-36_JPRB, &
  & 0.55523638E-36_JPRB, 0.82100467E-36_JPRB, 0.13778329E-35_JPRB, 0.15035676E-35_JPRB, 0.18271938E-35_JPRB, 0.18899144E-35_JPRB, &
  & 0.24022969E-35_JPRB, 0.18350042E-35_JPRB, 0.14869013E-35_JPRB, 0.10501394E-35_JPRB, 0.79529073E-36_JPRB, 0.48729457E-36_JPRB, &
  & 0.37241516E-36_JPRB, 0.23804776E-36_JPRB, 0.15689674E-36_JPRB, 0.10374383E-36_JPRB, 0.68568303E-37_JPRB, 0.44682397E-37_JPRB, &
  & 0.28389822E-37_JPRB, 0.17475767E-37_JPRB, 0.10442162E-37_JPRB, 0.60963041E-38_JPRB, 0.34977447E-38_JPRB, 0.19899671E-38_JPRB, &
  & 0.11264870E-38_JPRB, 0.63594428E-39_JPRB, 0.35887814E-39_JPRB, 0.20312242E-39_JPRB, 0.11589999E-39_JPRB, 0.67249715E-40_JPRB, &
  & 0.40217266E-40_JPRB, 0.25171524E-40_JPRB, 0.16707682E-40_JPRB, 0.11847979E-40_JPRB, 0.89542972E-41_JPRB, 0.71410170E-41_JPRB, &
  & 0.58854536E-41_JPRB, 0.48288745E-41_JPRB, 0.37568812E-41_JPRB, 0.25938035E-41_JPRB /)

RGHG5(:, 4, 2) = (/ &
  & 0.97698529E-41_JPRB, 0.32728727E-40_JPRB, 0.42005323E-40_JPRB, 0.45575831E-40_JPRB, 0.53687948E-40_JPRB, 0.75160044E-40_JPRB, &
  & 0.12533213E-39_JPRB, 0.24544443E-39_JPRB, 0.53255367E-39_JPRB, 0.12571119E-38_JPRB, 0.30957247E-38_JPRB, 0.77539729E-38_JPRB, &
  & 0.19341283E-37_JPRB, 0.47189679E-37_JPRB, 0.12011975E-36_JPRB, 0.29286456E-36_JPRB, 0.69047890E-36_JPRB, 0.16738684E-35_JPRB, &
  & 0.41122486E-35_JPRB, 0.78555466E-35_JPRB, 0.14986508E-34_JPRB, 0.24695472E-34_JPRB, 0.29283513E-34_JPRB, 0.38107969E-34_JPRB, &
  & 0.49632241E-34_JPRB, 0.73739599E-34_JPRB, 0.12355618E-33_JPRB, 0.13396958E-33_JPRB, 0.16239718E-33_JPRB, 0.16760515E-33_JPRB, &
  & 0.21307656E-33_JPRB, 0.16221310E-33_JPRB, 0.13138241E-33_JPRB, 0.92724544E-34_JPRB, 0.70303000E-34_JPRB, 0.43112125E-34_JPRB, &
  & 0.33042833E-34_JPRB, 0.21162701E-34_JPRB, 0.14000729E-34_JPRB, 0.92615294E-35_JPRB, 0.61209162E-35_JPRB, 0.39800880E-35_JPRB, &
  & 0.25271367E-35_JPRB, 0.15588573E-35_JPRB, 0.93896683E-36_JPRB, 0.55601913E-36_JPRB, 0.32499640E-36_JPRB, 0.18855323E-36_JPRB, &
  & 0.10856586E-36_JPRB, 0.61997558E-37_JPRB, 0.35129689E-37_JPRB, 0.19800329E-37_JPRB, 0.11158031E-37_JPRB, 0.63448650E-38_JPRB, &
  & 0.36959205E-38_JPRB, 0.22485165E-38_JPRB, 0.14553788E-38_JPRB, 0.10177617E-38_JPRB, 0.77002051E-39_JPRB, 0.62287296E-39_JPRB, &
  & 0.52581763E-39_JPRB, 0.44294064E-39_JPRB, 0.34969403E-39_JPRB, 0.22453566E-39_JPRB /)

RGHG5(:, 5, 2) = (/ &
  & 0.75846807E-38_JPRB, 0.98863232E-38_JPRB, 0.10236882E-37_JPRB, 0.10436078E-37_JPRB, 0.12207926E-37_JPRB, 0.17122449E-37_JPRB, &
  & 0.28561114E-37_JPRB, 0.55583513E-37_JPRB, 0.11977826E-36_JPRB, 0.28064437E-36_JPRB, 0.68663898E-36_JPRB, 0.17078830E-35_JPRB, &
  & 0.42171940E-35_JPRB, 0.10174734E-34_JPRB, 0.25479448E-34_JPRB, 0.60921734E-34_JPRB, 0.14070547E-33_JPRB, 0.33174352E-33_JPRB, &
  & 0.79944306E-33_JPRB, 0.14922139E-32_JPRB, 0.28207697E-32_JPRB, 0.46433717E-32_JPRB, 0.53774488E-32_JPRB, 0.69177034E-32_JPRB, &
  & 0.88784537E-32_JPRB, 0.13027396E-31_JPRB, 0.21691790E-31_JPRB, 0.23197585E-31_JPRB, 0.27983140E-31_JPRB, 0.28615870E-31_JPRB, &
  & 0.36542669E-31_JPRB, 0.27604334E-31_JPRB, 0.22362945E-31_JPRB, 0.15836138E-31_JPRB, 0.12049940E-31_JPRB, 0.74373763E-32_JPRB, &
  & 0.57451082E-32_JPRB, 0.37128764E-32_JPRB, 0.24841094E-32_JPRB, 0.16659532E-32_JPRB, 0.11161495E-32_JPRB, 0.73696608E-33_JPRB, &
  & 0.47521852E-33_JPRB, 0.29876289E-33_JPRB, 0.18400688E-33_JPRB, 0.11179594E-33_JPRB, 0.67181207E-34_JPRB, 0.40060787E-34_JPRB, &
  & 0.23648751E-34_JPRB, 0.13782648E-34_JPRB, 0.79228893E-35_JPRB, 0.45020246E-35_JPRB, 0.25435324E-35_JPRB, 0.14439456E-35_JPRB, &
  & 0.83739982E-36_JPRB, 0.50653715E-36_JPRB, 0.32644017E-36_JPRB, 0.22823430E-36_JPRB, 0.17371222E-36_JPRB, 0.14245067E-36_JPRB, &
  & 0.12271439E-36_JPRB, 0.10778301E-36_JPRB, 0.91652879E-37_JPRB, 0.67398342E-37_JPRB /)

RGHG5(:, 6, 2) = (/ &
  & 0.40443639E-35_JPRB, 0.53198904E-35_JPRB, 0.53362030E-35_JPRB, 0.55024565E-35_JPRB, 0.65180401E-35_JPRB, 0.91201343E-35_JPRB, &
  & 0.15055328E-34_JPRB, 0.28746967E-34_JPRB, 0.60483099E-34_JPRB, 0.13782056E-33_JPRB, 0.32743423E-33_JPRB, 0.78841664E-33_JPRB, &
  & 0.18803549E-32_JPRB, 0.43651075E-32_JPRB, 0.10503765E-31_JPRB, 0.24090954E-31_JPRB, 0.53154338E-31_JPRB, 0.11991087E-30_JPRB, &
  & 0.27539731E-30_JPRB, 0.49243988E-30_JPRB, 0.89273285E-30_JPRB, 0.14194813E-29_JPRB, 0.15845290E-29_JPRB, 0.19705273E-29_JPRB, &
  & 0.24465855E-29_JPRB, 0.34931032E-29_JPRB, 0.57081780E-29_JPRB, 0.59779726E-29_JPRB, 0.71195002E-29_JPRB, 0.71869123E-29_JPRB, &
  & 0.91787767E-29_JPRB, 0.68919636E-29_JPRB, 0.56017320E-29_JPRB, 0.39914326E-29_JPRB, 0.30690564E-29_JPRB, 0.19181820E-29_JPRB, &
  & 0.15083940E-29_JPRB, 0.99411877E-30_JPRB, 0.68272134E-30_JPRB, 0.47144974E-30_JPRB, 0.32672891E-30_JPRB, 0.22347177E-30_JPRB, &
  & 0.14978337E-30_JPRB, 0.97958141E-31_JPRB, 0.62882506E-31_JPRB, 0.39844645E-31_JPRB, 0.24977977E-31_JPRB, 0.15525129E-31_JPRB, &
  & 0.95335163E-32_JPRB, 0.57615416E-32_JPRB, 0.34214971E-32_JPRB, 0.20014253E-32_JPRB, 0.11613723E-32_JPRB, 0.67665046E-33_JPRB, &
  & 0.40290055E-33_JPRB, 0.25030019E-33_JPRB, 0.16551360E-33_JPRB, 0.11846939E-33_JPRB, 0.92068758E-34_JPRB, 0.76787160E-34_JPRB, &
  & 0.67361887E-34_JPRB, 0.60646394E-34_JPRB, 0.54760014E-34_JPRB, 0.46214879E-34_JPRB /)

RGHG5(:, 7, 2) = (/ &
  & 0.35249711E-32_JPRB, 0.39801148E-32_JPRB, 0.39780161E-32_JPRB, 0.41630235E-32_JPRB, 0.49342705E-32_JPRB, 0.68487475E-32_JPRB, &
  & 0.11026463E-31_JPRB, 0.20394164E-31_JPRB, 0.41159800E-31_JPRB, 0.89583096E-31_JPRB, 0.20204905E-30_JPRB, 0.46039384E-30_JPRB, &
  & 0.10355093E-29_JPRB, 0.22601181E-29_JPRB, 0.51164842E-29_JPRB, 0.11024249E-28_JPRB, 0.22847930E-28_JPRB, 0.48366836E-28_JPRB, &
  & 0.10470771E-27_JPRB, 0.17667858E-27_JPRB, 0.30324583E-27_JPRB, 0.45917420E-27_JPRB, 0.48975118E-27_JPRB, 0.58255832E-27_JPRB, &
  & 0.69345573E-27_JPRB, 0.95555428E-27_JPRB, 0.15320279E-26_JPRB, 0.15619989E-26_JPRB, 0.18327837E-26_JPRB, 0.18239539E-26_JPRB, &
  & 0.23247321E-26_JPRB, 0.17400804E-26_JPRB, 0.14203269E-26_JPRB, 0.10207893E-26_JPRB, 0.79376466E-27_JPRB, 0.50500589E-27_JPRB, &
  & 0.40497213E-27_JPRB, 0.27414508E-27_JPRB, 0.19424539E-27_JPRB, 0.13918922E-27_JPRB, 0.10054117E-27_JPRB, 0.72030833E-28_JPRB, &
  & 0.50668749E-28_JPRB, 0.34850322E-28_JPRB, 0.23529291E-28_JPRB, 0.15682780E-28_JPRB, 0.10338187E-28_JPRB, 0.67544432E-29_JPRB, &
  & 0.43562816E-29_JPRB, 0.27616775E-29_JPRB, 0.17179555E-29_JPRB, 0.10517046E-29_JPRB, 0.63866569E-30_JPRB, 0.38972156E-30_JPRB, &
  & 0.24336850E-30_JPRB, 0.15863013E-30_JPRB, 0.10990116E-30_JPRB, 0.82124044E-31_JPRB, 0.66156640E-31_JPRB, 0.56733519E-31_JPRB, &
  & 0.50741489E-31_JPRB, 0.46405478E-31_JPRB, 0.42539274E-31_JPRB, 0.37128136E-31_JPRB /)

RGHG5(:, 8, 2) = (/ &
  & 0.27316115E-29_JPRB, 0.29468007E-29_JPRB, 0.29105037E-29_JPRB, 0.30357631E-29_JPRB, 0.35770026E-29_JPRB, 0.48609313E-29_JPRB, &
  & 0.76185568E-29_JPRB, 0.13577451E-28_JPRB, 0.26258355E-28_JPRB, 0.54319819E-28_JPRB, 0.11588326E-27_JPRB, 0.24856981E-27_JPRB, &
  & 0.52443515E-27_JPRB, 0.10693855E-26_JPRB, 0.22651003E-26_JPRB, 0.45611371E-26_JPRB, 0.88243106E-26_JPRB, 0.17491900E-25_JPRB, &
  & 0.35664568E-25_JPRB, 0.56700425E-25_JPRB, 0.92075327E-25_JPRB, 0.13277632E-24_JPRB, 0.13483990E-24_JPRB, 0.15311513E-24_JPRB, &
  & 0.17447492E-24_JPRB, 0.23181780E-24_JPRB, 0.36429210E-24_JPRB, 0.36136540E-24_JPRB, 0.41718741E-24_JPRB, 0.40947285E-24_JPRB, &
  & 0.52006104E-24_JPRB, 0.38829279E-24_JPRB, 0.31843169E-24_JPRB, 0.23052535E-24_JPRB, 0.18155814E-24_JPRB, 0.11739070E-24_JPRB, &
  & 0.96206758E-25_JPRB, 0.66978913E-25_JPRB, 0.49063682E-25_JPRB, 0.36547183E-25_JPRB, 0.27579385E-25_JPRB, 0.20729089E-25_JPRB, &
  & 0.15342158E-25_JPRB, 0.11109905E-25_JPRB, 0.78955023E-26_JPRB, 0.55372897E-26_JPRB, 0.38391141E-26_JPRB, 0.26385812E-26_JPRB, &
  & 0.17902224E-26_JPRB, 0.11939371E-26_JPRB, 0.78140476E-27_JPRB, 0.50335498E-27_JPRB, 0.32170563E-27_JPRB, 0.20659593E-27_JPRB, &
  & 0.13572757E-27_JPRB, 0.92993461E-28_JPRB, 0.67578510E-28_JPRB, 0.52745564E-28_JPRB, 0.44063818E-28_JPRB, 0.38873343E-28_JPRB, &
  & 0.35454932E-28_JPRB, 0.32827410E-28_JPRB, 0.30365304E-28_JPRB, 0.26589723E-28_JPRB /)

RGHG5(:, 9, 2) = (/ &
  & 0.18318375E-26_JPRB, 0.19342180E-26_JPRB, 0.18911785E-26_JPRB, 0.19549133E-26_JPRB, 0.22673230E-26_JPRB, 0.30190194E-26_JPRB, &
  & 0.45920287E-26_JPRB, 0.79083514E-26_JPRB, 0.14658338E-25_JPRB, 0.28902970E-25_JPRB, 0.58410275E-25_JPRB, 0.11810389E-24_JPRB, &
  & 0.23386708E-24_JPRB, 0.44534980E-24_JPRB, 0.88159653E-24_JPRB, 0.16571311E-23_JPRB, 0.29869331E-23_JPRB, 0.55356961E-23_JPRB, &
  & 0.10662339E-22_JPRB, 0.15942641E-22_JPRB, 0.24528402E-22_JPRB, 0.33695512E-22_JPRB, 0.32486879E-22_JPRB, 0.35208471E-22_JPRB, &
  & 0.38385050E-22_JPRB, 0.49156179E-22_JPRB, 0.75516897E-22_JPRB, 0.72913662E-22_JPRB, 0.82718951E-22_JPRB, 0.80014073E-22_JPRB, &
  & 0.10101635E-21_JPRB, 0.75186345E-22_JPRB, 0.61854104E-22_JPRB, 0.45112412E-22_JPRB, 0.35969763E-22_JPRB, 0.23679536E-22_JPRB, &
  & 0.19859636E-22_JPRB, 0.14249150E-22_JPRB, 0.10818524E-22_JPRB, 0.83913320E-23_JPRB, 0.66283825E-23_JPRB, 0.52348459E-23_JPRB, &
  & 0.40813001E-23_JPRB, 0.31133743E-23_JPRB, 0.23297283E-23_JPRB, 0.17187607E-23_JPRB, 0.12531417E-23_JPRB, 0.90605053E-24_JPRB, &
  & 0.64706952E-24_JPRB, 0.45455432E-24_JPRB, 0.31354576E-24_JPRB, 0.21292968E-24_JPRB, 0.14337694E-24_JPRB, 0.96815105E-25_JPRB, &
  & 0.66768158E-25_JPRB, 0.47883765E-25_JPRB, 0.36316904E-25_JPRB, 0.29447327E-25_JPRB, 0.25416199E-25_JPRB, 0.22934226E-25_JPRB, &
  & 0.21268365E-25_JPRB, 0.19906469E-25_JPRB, 0.18519516E-25_JPRB, 0.16302117E-25_JPRB /)

RGHG5(:,10, 2) = (/ &
  & 0.10481056E-23_JPRB, 0.10945838E-23_JPRB, 0.10597674E-23_JPRB, 0.10836880E-23_JPRB, 0.12382371E-23_JPRB, 0.16114296E-23_JPRB, &
  & 0.23843849E-23_JPRB, 0.39693094E-23_JPRB, 0.70684067E-23_JPRB, 0.13309197E-22_JPRB, 0.25529254E-22_JPRB, 0.48750651E-22_JPRB, &
  & 0.90730086E-22_JPRB, 0.16149022E-21_JPRB, 0.29886004E-21_JPRB, 0.52410096E-21_JPRB, 0.87994326E-21_JPRB, 0.15227895E-20_JPRB, &
  & 0.27710175E-20_JPRB, 0.38923618E-20_JPRB, 0.56679934E-20_JPRB, 0.74087732E-20_JPRB, 0.67706058E-20_JPRB, 0.69970538E-20_JPRB, &
  & 0.73026283E-20_JPRB, 0.90072973E-20_JPRB, 0.13477285E-19_JPRB, 0.12683940E-19_JPRB, 0.14115731E-19_JPRB, 0.13450807E-19_JPRB, &
  & 0.16838265E-19_JPRB, 0.12485291E-19_JPRB, 0.10292810E-19_JPRB, 0.75569177E-20_JPRB, 0.61066015E-20_JPRB, 0.40929660E-20_JPRB, &
  & 0.35212174E-20_JPRB, 0.26088497E-20_JPRB, 0.20562634E-20_JPRB, 0.16648884E-20_JPRB, 0.13783731E-20_JPRB, 0.11456843E-20_JPRB, &
  & 0.94215498E-21_JPRB, 0.75842435E-21_JPRB, 0.59808400E-21_JPRB, 0.46469633E-21_JPRB, 0.35646317E-21_JPRB, 0.27132870E-21_JPRB, &
  & 0.20410430E-21_JPRB, 0.15114160E-21_JPRB, 0.10997134E-21_JPRB, 0.78758219E-22_JPRB, 0.55836307E-22_JPRB, 0.39587546E-22_JPRB, &
  & 0.28552095E-22_JPRB, 0.21354791E-22_JPRB, 0.16815820E-22_JPRB, 0.14110694E-22_JPRB, 0.12478218E-22_JPRB, 0.11492649E-22_JPRB, &
  & 0.10784784E-22_JPRB, 0.10182221E-22_JPRB, 0.95403718E-23_JPRB, 0.84332000E-23_JPRB /)

RGHG5(:,11, 2) = (/ &
  & 0.50178465E-21_JPRB, 0.51943464E-21_JPRB, 0.49916109E-21_JPRB, 0.50565666E-21_JPRB, 0.56945180E-21_JPRB, 0.72686002E-21_JPRB, &
  & 0.10476250E-20_JPRB, 0.16905129E-20_JPRB, 0.28984328E-20_JPRB, 0.52230817E-20_JPRB, 0.95358399E-20_JPRB, 0.17238320E-19_JPRB, &
  & 0.30225874E-19_JPRB, 0.50408422E-19_JPRB, 0.87314148E-19_JPRB, 0.14309501E-18_JPRB, 0.22392312E-18_JPRB, 0.36199210E-18_JPRB, &
  & 0.62117087E-18_JPRB, 0.81949543E-18_JPRB, 0.11279025E-17_JPRB, 0.14005805E-17_JPRB, 0.12140120E-17_JPRB, 0.11958671E-17_JPRB, &
  & 0.11948781E-17_JPRB, 0.14187789E-17_JPRB, 0.20616259E-17_JPRB, 0.18919784E-17_JPRB, 0.20623476E-17_JPRB, 0.19344820E-17_JPRB, &
  & 0.23974035E-17_JPRB, 0.17699876E-17_JPRB, 0.14611432E-17_JPRB, 0.10803390E-17_JPRB, 0.88464092E-18_JPRB, 0.60457276E-18_JPRB, &
  & 0.53390130E-18_JPRB, 0.40864172E-18_JPRB, 0.33473156E-18_JPRB, 0.28293677E-18_JPRB, 0.24557917E-18_JPRB, 0.21481712E-18_JPRB, &
  & 0.18643450E-18_JPRB, 0.15851199E-18_JPRB, 0.13197826E-18_JPRB, 0.10812044E-18_JPRB, 0.87387444E-19_JPRB, 0.70089896E-19_JPRB, &
  & 0.55580217E-19_JPRB, 0.43408112E-19_JPRB, 0.33318134E-19_JPRB, 0.25156695E-19_JPRB, 0.18764654E-19_JPRB, 0.13939628E-19_JPRB, &
  & 0.10501723E-19_JPRB, 0.81617184E-20_JPRB, 0.66570171E-20_JPRB, 0.57374600E-20_JPRB, 0.51991985E-20_JPRB, 0.48518998E-20_JPRB, &
  & 0.46064945E-20_JPRB, 0.43800635E-20_JPRB, 0.41255980E-20_JPRB, 0.36786648E-20_JPRB /)

RGHG5(:,12, 2) = (/ &
  & 0.19937630E-18_JPRB, 0.20518812E-18_JPRB, 0.19613140E-18_JPRB, 0.19728261E-18_JPRB, 0.21972957E-18_JPRB, 0.27563434E-18_JPRB, &
  & 0.38831050E-18_JPRB, 0.60830397E-18_JPRB, 0.10062050E-17_JPRB, 0.17388714E-17_JPRB, 0.30267225E-17_JPRB, 0.51901729E-17_JPRB, &
  & 0.85906942E-17_JPRB, 0.13452764E-16_JPRB, 0.21844933E-16_JPRB, 0.33486167E-16_JPRB, 0.48932408E-16_JPRB, 0.73879564E-16_JPRB, &
  & 0.11928639E-15_JPRB, 0.14785558E-15_JPRB, 0.19204014E-15_JPRB, 0.22619904E-15_JPRB, 0.18624346E-15_JPRB, 0.17474580E-15_JPRB, &
  & 0.16706474E-15_JPRB, 0.19067187E-15_JPRB, 0.26842045E-15_JPRB, 0.23996547E-15_JPRB, 0.25574138E-15_JPRB, 0.23584952E-15_JPRB, &
  & 0.28903268E-15_JPRB, 0.21241397E-15_JPRB, 0.17554757E-15_JPRB, 0.13077658E-15_JPRB, 0.10864299E-15_JPRB, 0.75728438E-16_JPRB, &
  & 0.68754194E-16_JPRB, 0.54375293E-16_JPRB, 0.46301673E-16_JPRB, 0.40867560E-16_JPRB, 0.37175161E-16_JPRB, 0.34196517E-16_JPRB, &
  & 0.31310487E-16_JPRB, 0.28136767E-16_JPRB, 0.24761887E-16_JPRB, 0.21432054E-16_JPRB, 0.18274205E-16_JPRB, 0.15465156E-16_JPRB, &
  & 0.12936661E-16_JPRB, 0.10657843E-16_JPRB, 0.86268569E-17_JPRB, 0.68609611E-17_JPRB, 0.53771157E-17_JPRB, 0.41827467E-17_JPRB, &
  & 0.32834531E-17_JPRB, 0.26487589E-17_JPRB, 0.22266110E-17_JPRB, 0.19730121E-17_JPRB, 0.18171961E-17_JPRB, 0.17225393E-17_JPRB, &
  & 0.16484620E-17_JPRB, 0.15783579E-17_JPRB, 0.14943212E-17_JPRB, 0.13369994E-17_JPRB /)

RGHG5(:,13, 2) = (/ &
  & 0.60922274E-17_JPRB, 0.58330428E-17_JPRB, 0.55129334E-17_JPRB, 0.52352840E-17_JPRB, 0.53424188E-17_JPRB, 0.60881804E-17_JPRB, &
  & 0.74924763E-17_JPRB, 0.10010384E-16_JPRB, 0.14282560E-16_JPRB, 0.21505106E-16_JPRB, 0.32995077E-16_JPRB, 0.50416897E-16_JPRB, &
  & 0.76980657E-16_JPRB, 0.11589497E-15_JPRB, 0.18643756E-15_JPRB, 0.28128270E-15_JPRB, 0.38245150E-15_JPRB, 0.60284732E-15_JPRB, &
  & 0.95317856E-15_JPRB, 0.95806806E-15_JPRB, 0.10770342E-14_JPRB, 0.12438467E-14_JPRB, 0.17153406E-14_JPRB, 0.19781197E-14_JPRB, &
  & 0.20092015E-14_JPRB, 0.22596904E-14_JPRB, 0.21033759E-14_JPRB, 0.24969295E-14_JPRB, 0.24119926E-14_JPRB, 0.19276727E-14_JPRB, &
  & 0.14740840E-14_JPRB, 0.13366094E-14_JPRB, 0.10858015E-14_JPRB, 0.81803403E-15_JPRB, 0.70196310E-15_JPRB, 0.61095719E-15_JPRB, &
  & 0.56444327E-15_JPRB, 0.54842646E-15_JPRB, 0.54564137E-15_JPRB, 0.54651603E-15_JPRB, 0.54782708E-15_JPRB, 0.54375269E-15_JPRB, &
  & 0.52955362E-15_JPRB, 0.49954038E-15_JPRB, 0.45665267E-15_JPRB, 0.40648923E-15_JPRB, 0.35377080E-15_JPRB, 0.30392781E-15_JPRB, &
  & 0.25746503E-15_JPRB, 0.21464666E-15_JPRB, 0.17575235E-15_JPRB, 0.14147507E-15_JPRB, 0.11210289E-15_JPRB, 0.87921583E-16_JPRB, &
  & 0.69199945E-16_JPRB, 0.55379696E-16_JPRB, 0.45759810E-16_JPRB, 0.39372805E-16_JPRB, 0.35415314E-16_JPRB, 0.32709352E-16_JPRB, &
  & 0.30782021E-16_JPRB, 0.29009873E-16_JPRB, 0.27086951E-16_JPRB, 0.23805049E-16_JPRB /)

RGHG5(:,14, 2) = (/ &
  & 0.10942283E-15_JPRB, 0.10189732E-15_JPRB, 0.94026613E-16_JPRB, 0.91620483E-16_JPRB, 0.94279128E-16_JPRB, 0.10375087E-15_JPRB, &
  & 0.12206036E-15_JPRB, 0.15319337E-15_JPRB, 0.20230448E-15_JPRB, 0.27950457E-15_JPRB, 0.38776554E-15_JPRB, 0.55116762E-15_JPRB, &
  & 0.79144080E-15_JPRB, 0.12194773E-14_JPRB, 0.18662304E-14_JPRB, 0.26889914E-14_JPRB, 0.32691866E-14_JPRB, 0.48156961E-14_JPRB, &
  & 0.63556698E-14_JPRB, 0.89619686E-14_JPRB, 0.11975990E-13_JPRB, 0.13952764E-13_JPRB, 0.16295206E-13_JPRB, 0.18242532E-13_JPRB, &
  & 0.19749044E-13_JPRB, 0.20776997E-13_JPRB, 0.19570776E-13_JPRB, 0.17959194E-13_JPRB, 0.15722143E-13_JPRB, 0.15056343E-13_JPRB, &
  & 0.11518105E-13_JPRB, 0.89562418E-14_JPRB, 0.69249890E-14_JPRB, 0.56846190E-14_JPRB, 0.50612866E-14_JPRB, 0.49070355E-14_JPRB, &
  & 0.50327674E-14_JPRB, 0.53312588E-14_JPRB, 0.56951039E-14_JPRB, 0.60565596E-14_JPRB, 0.63639830E-14_JPRB, 0.65552651E-14_JPRB, &
  & 0.65979284E-14_JPRB, 0.63862202E-14_JPRB, 0.59780379E-14_JPRB, 0.54450497E-14_JPRB, 0.48168540E-14_JPRB, 0.41846727E-14_JPRB, &
  & 0.35760198E-14_JPRB, 0.30039545E-14_JPRB, 0.24785639E-14_JPRB, 0.20111707E-14_JPRB, 0.16058781E-14_JPRB, 0.12676888E-14_JPRB, &
  & 0.99913592E-15_JPRB, 0.79430388E-15_JPRB, 0.64425813E-15_JPRB, 0.54057457E-15_JPRB, 0.47063856E-15_JPRB, 0.42508126E-15_JPRB, &
  & 0.39063458E-15_JPRB, 0.36201479E-15_JPRB, 0.33167266E-15_JPRB, 0.28356739E-15_JPRB /)

RGHG5(:,15, 2) = (/ &
  & 0.14612633E-14_JPRB, 0.11625547E-14_JPRB, 0.11125047E-14_JPRB, 0.11294285E-14_JPRB, 0.11997877E-14_JPRB, 0.13282804E-14_JPRB, &
  & 0.15452593E-14_JPRB, 0.18803738E-14_JPRB, 0.23841746E-14_JPRB, 0.31486709E-14_JPRB, 0.41886169E-14_JPRB, 0.55306322E-14_JPRB, &
  & 0.77395687E-14_JPRB, 0.11086453E-13_JPRB, 0.15985973E-13_JPRB, 0.21625297E-13_JPRB, 0.28434632E-13_JPRB, 0.41375323E-13_JPRB, &
  & 0.51052471E-13_JPRB, 0.67847807E-13_JPRB, 0.82222884E-13_JPRB, 0.98447170E-13_JPRB, 0.11244017E-12_JPRB, 0.12338032E-12_JPRB, &
  & 0.12989065E-12_JPRB, 0.13111654E-12_JPRB, 0.12588956E-12_JPRB, 0.11453108E-12_JPRB, 0.95718741E-13_JPRB, 0.76532029E-13_JPRB, &
  & 0.63024828E-13_JPRB, 0.48790494E-13_JPRB, 0.39809437E-13_JPRB, 0.34183770E-13_JPRB, 0.31732395E-13_JPRB, 0.32772457E-13_JPRB, &
  & 0.36093226E-13_JPRB, 0.40628505E-13_JPRB, 0.45562766E-13_JPRB, 0.50331978E-13_JPRB, 0.54429402E-13_JPRB, 0.57784371E-13_JPRB, &
  & 0.58757971E-13_JPRB, 0.57052921E-13_JPRB, 0.54189184E-13_JPRB, 0.50028493E-13_JPRB, 0.44825214E-13_JPRB, 0.39329369E-13_JPRB, &
  & 0.33910439E-13_JPRB, 0.28731303E-13_JPRB, 0.23927962E-13_JPRB, 0.19605220E-13_JPRB, 0.15814100E-13_JPRB, 0.12608265E-13_JPRB, &
  & 0.10006975E-13_JPRB, 0.79705190E-14_JPRB, 0.64224469E-14_JPRB, 0.53021014E-14_JPRB, 0.45275029E-14_JPRB, 0.39941250E-14_JPRB, &
  & 0.36085755E-14_JPRB, 0.32786644E-14_JPRB, 0.29581495E-14_JPRB, 0.24533752E-14_JPRB /)

RGHG5(:,16, 2) = (/ &
  & 0.92039989E-14_JPRB, 0.96178872E-14_JPRB, 0.10059216E-13_JPRB, 0.10708163E-13_JPRB, 0.11723980E-13_JPRB, 0.13190704E-13_JPRB, &
  & 0.15197694E-13_JPRB, 0.18056542E-13_JPRB, 0.22009587E-13_JPRB, 0.27645438E-13_JPRB, 0.35411059E-13_JPRB, 0.45636621E-13_JPRB, &
  & 0.59142788E-13_JPRB, 0.78584139E-13_JPRB, 0.10430489E-12_JPRB, 0.13583117E-12_JPRB, 0.17995032E-12_JPRB, 0.23429221E-12_JPRB, &
  & 0.29395006E-12_JPRB, 0.36401058E-12_JPRB, 0.43185792E-12_JPRB, 0.49621310E-12_JPRB, 0.54902843E-12_JPRB, 0.58386412E-12_JPRB, &
  & 0.59645420E-12_JPRB, 0.58290032E-12_JPRB, 0.54285737E-12_JPRB, 0.48541629E-12_JPRB, 0.41934628E-12_JPRB, 0.34197474E-12_JPRB, &
  & 0.27210485E-12_JPRB, 0.21949150E-12_JPRB, 0.18297164E-12_JPRB, 0.16503449E-12_JPRB, 0.16522948E-12_JPRB, 0.17965185E-12_JPRB, &
  & 0.20546204E-12_JPRB, 0.23795693E-12_JPRB, 0.27243298E-12_JPRB, 0.30512967E-12_JPRB, 0.33293152E-12_JPRB, 0.34609086E-12_JPRB, &
  & 0.35228900E-12_JPRB, 0.35156050E-12_JPRB, 0.33810154E-12_JPRB, 0.31286757E-12_JPRB, 0.28180602E-12_JPRB, 0.24931061E-12_JPRB, &
  & 0.21691285E-12_JPRB, 0.18565126E-12_JPRB, 0.15636188E-12_JPRB, 0.12967993E-12_JPRB, 0.10603112E-12_JPRB, 0.85692622E-13_JPRB, &
  & 0.68895261E-13_JPRB, 0.55429626E-13_JPRB, 0.44941007E-13_JPRB, 0.37011576E-13_JPRB, 0.31309899E-13_JPRB, 0.27305113E-13_JPRB, &
  & 0.24246428E-13_JPRB, 0.21815881E-13_JPRB, 0.19329468E-13_JPRB, 0.15752512E-13_JPRB /)

RGHG5(:,17, 2) = (/ &
  & 0.63744528E-13_JPRB, 0.73743583E-13_JPRB, 0.78354573E-13_JPRB, 0.83598127E-13_JPRB, 0.90737259E-13_JPRB, 0.10026977E-12_JPRB, &
  & 0.11251534E-12_JPRB, 0.12904334E-12_JPRB, 0.15140376E-12_JPRB, 0.18163512E-12_JPRB, 0.21992832E-12_JPRB, 0.26918946E-12_JPRB, &
  & 0.33547844E-12_JPRB, 0.42281226E-12_JPRB, 0.53101062E-12_JPRB, 0.66609999E-12_JPRB, 0.83703769E-12_JPRB, 0.10334416E-11_JPRB, &
  & 0.12473553E-11_JPRB, 0.14734623E-11_JPRB, 0.16844887E-11_JPRB, 0.18594583E-11_JPRB, 0.19801840E-11_JPRB, 0.20324259E-11_JPRB, &
  & 0.20068610E-11_JPRB, 0.19075713E-11_JPRB, 0.17460630E-11_JPRB, 0.15315276E-11_JPRB, 0.13073303E-11_JPRB, 0.11196834E-11_JPRB, &
  & 0.93875992E-12_JPRB, 0.81089551E-12_JPRB, 0.72790607E-12_JPRB, 0.69942305E-12_JPRB, 0.72562404E-12_JPRB, 0.80430752E-12_JPRB, &
  & 0.92535278E-12_JPRB, 0.10702859E-11_JPRB, 0.12177708E-11_JPRB, 0.13468593E-11_JPRB, 0.14542037E-11_JPRB, 0.15373711E-11_JPRB, &
  & 0.15682885E-11_JPRB, 0.15333334E-11_JPRB, 0.14493058E-11_JPRB, 0.13402692E-11_JPRB, 0.12150537E-11_JPRB, 0.10839144E-11_JPRB, &
  & 0.95218245E-12_JPRB, 0.82394963E-12_JPRB, 0.70271458E-12_JPRB, 0.59119756E-12_JPRB, 0.49114293E-12_JPRB, 0.40393974E-12_JPRB, &
  & 0.33055107E-12_JPRB, 0.27058854E-12_JPRB, 0.22267520E-12_JPRB, 0.18545311E-12_JPRB, 0.15752499E-12_JPRB, 0.13636604E-12_JPRB, &
  & 0.12065398E-12_JPRB, 0.10717023E-12_JPRB, 0.94477879E-13_JPRB, 0.75302327E-13_JPRB /)

RGHG5(:,18, 2) = (/ &
  & 0.21786647E-12_JPRB, 0.26002171E-12_JPRB, 0.29429860E-12_JPRB, 0.33451676E-12_JPRB, 0.38420273E-12_JPRB, 0.44638113E-12_JPRB, &
  & 0.52080638E-12_JPRB, 0.60881226E-12_JPRB, 0.71247804E-12_JPRB, 0.84275550E-12_JPRB, 0.10013890E-11_JPRB, 0.11910894E-11_JPRB, &
  & 0.14307379E-11_JPRB, 0.17280703E-11_JPRB, 0.20819340E-11_JPRB, 0.25010966E-11_JPRB, 0.29912869E-11_JPRB, 0.35320991E-11_JPRB, &
  & 0.40853683E-11_JPRB, 0.46188470E-11_JPRB, 0.50718275E-11_JPRB, 0.53867071E-11_JPRB, 0.55216842E-11_JPRB, 0.54649085E-11_JPRB, &
  & 0.52320908E-11_JPRB, 0.48577036E-11_JPRB, 0.43946994E-11_JPRB, 0.39308392E-11_JPRB, 0.34780408E-11_JPRB, 0.30469631E-11_JPRB, &
  & 0.27342048E-11_JPRB, 0.25288547E-11_JPRB, 0.24350077E-11_JPRB, 0.24685291E-11_JPRB, 0.26312271E-11_JPRB, 0.29222148E-11_JPRB, &
  & 0.33190523E-11_JPRB, 0.37700468E-11_JPRB, 0.42123267E-11_JPRB, 0.46008800E-11_JPRB, 0.48664055E-11_JPRB, 0.49764737E-11_JPRB, &
  & 0.49351907E-11_JPRB, 0.47664351E-11_JPRB, 0.45044081E-11_JPRB, 0.41686403E-11_JPRB, 0.37898257E-11_JPRB, 0.33985273E-11_JPRB, &
  & 0.30082224E-11_JPRB, 0.26277162E-11_JPRB, 0.22684990E-11_JPRB, 0.19361331E-11_JPRB, 0.16363718E-11_JPRB, 0.13722761E-11_JPRB, &
  & 0.11471532E-11_JPRB, 0.96001549E-12_JPRB, 0.80732355E-12_JPRB, 0.68470598E-12_JPRB, 0.58774518E-12_JPRB, 0.51249841E-12_JPRB, &
  & 0.45203704E-12_JPRB, 0.40193592E-12_JPRB, 0.35166276E-12_JPRB, 0.27875551E-12_JPRB /)

RGHG5(:,19, 2) = (/ &
  & 0.77912839E-12_JPRB, 0.95577463E-12_JPRB, 0.10630365E-11_JPRB, 0.11798209E-11_JPRB, 0.13282564E-11_JPRB, 0.15215131E-11_JPRB, &
  & 0.17685433E-11_JPRB, 0.20737162E-11_JPRB, 0.24316794E-11_JPRB, 0.28542461E-11_JPRB, 0.33511583E-11_JPRB, 0.39191107E-11_JPRB, &
  & 0.45882521E-11_JPRB, 0.53626470E-11_JPRB, 0.62431319E-11_JPRB, 0.72224466E-11_JPRB, 0.82935837E-11_JPRB, 0.94036350E-11_JPRB, &
  & 0.10458114E-10_JPRB, 0.11383296E-10_JPRB, 0.12055035E-10_JPRB, 0.12380859E-10_JPRB, 0.12322185E-10_JPRB, 0.11895116E-10_JPRB, &
  & 0.11165215E-10_JPRB, 0.10265331E-10_JPRB, 0.93209659E-11_JPRB, 0.84163544E-11_JPRB, 0.76718848E-11_JPRB, 0.71736423E-11_JPRB, &
  & 0.68965862E-11_JPRB, 0.68213612E-11_JPRB, 0.69405284E-11_JPRB, 0.72804566E-11_JPRB, 0.78413014E-11_JPRB, 0.86134598E-11_JPRB, &
  & 0.95235859E-11_JPRB, 0.10461054E-10_JPRB, 0.11291878E-10_JPRB, 0.11913612E-10_JPRB, 0.12261008E-10_JPRB, 0.12303496E-10_JPRB, &
  & 0.12047963E-10_JPRB, 0.11528646E-10_JPRB, 0.10809431E-10_JPRB, 0.99670021E-11_JPRB, 0.90683207E-11_JPRB, 0.81581963E-11_JPRB, &
  & 0.72626957E-11_JPRB, 0.63972881E-11_JPRB, 0.55843229E-11_JPRB, 0.48345633E-11_JPRB, 0.41566373E-11_JPRB, 0.35572001E-11_JPRB, &
  & 0.30414601E-11_JPRB, 0.26075546E-11_JPRB, 0.22469147E-11_JPRB, 0.19492524E-11_JPRB, 0.17020823E-11_JPRB, 0.14993460E-11_JPRB, &
  & 0.13335656E-11_JPRB, 0.11880140E-11_JPRB, 0.10401466E-11_JPRB, 0.82675251E-12_JPRB /)

RGHG5(:,20, 2) = (/ &
  & 0.19642293E-11_JPRB, 0.24454312E-11_JPRB, 0.27964423E-11_JPRB, 0.31661741E-11_JPRB, 0.35910196E-11_JPRB, 0.40957181E-11_JPRB, &
  & 0.46966818E-11_JPRB, 0.54266743E-11_JPRB, 0.62954086E-11_JPRB, 0.73019368E-11_JPRB, 0.84547074E-11_JPRB, 0.97342490E-11_JPRB, &
  & 0.11166521E-10_JPRB, 0.12734158E-10_JPRB, 0.14428310E-10_JPRB, 0.16216585E-10_JPRB, 0.18039795E-10_JPRB, 0.19801437E-10_JPRB, &
  & 0.21343949E-10_JPRB, 0.22564501E-10_JPRB, 0.23300152E-10_JPRB, 0.23427919E-10_JPRB, 0.22908300E-10_JPRB, 0.21827788E-10_JPRB, &
  & 0.20363005E-10_JPRB, 0.18719233E-10_JPRB, 0.17174427E-10_JPRB, 0.15954802E-10_JPRB, 0.15202400E-10_JPRB, 0.14906775E-10_JPRB, &
  & 0.15054642E-10_JPRB, 0.15589278E-10_JPRB, 0.16452261E-10_JPRB, 0.17593196E-10_JPRB, 0.18985796E-10_JPRB, 0.20532794E-10_JPRB, &
  & 0.22131481E-10_JPRB, 0.23596297E-10_JPRB, 0.24698880E-10_JPRB, 0.25281499E-10_JPRB, 0.25311107E-10_JPRB, 0.24810749E-10_JPRB, &
  & 0.23855987E-10_JPRB, 0.22541472E-10_JPRB, 0.21001159E-10_JPRB, 0.19329252E-10_JPRB, 0.17605519E-10_JPRB, 0.15890071E-10_JPRB, &
  & 0.14217951E-10_JPRB, 0.12624532E-10_JPRB, 0.11140684E-10_JPRB, 0.97787074E-11_JPRB, 0.85508076E-11_JPRB, 0.74646157E-11_JPRB, &
  & 0.65237065E-11_JPRB, 0.57226164E-11_JPRB, 0.50462568E-11_JPRB, 0.44692795E-11_JPRB, 0.39750503E-11_JPRB, 0.35556146E-11_JPRB, &
  & 0.31958297E-11_JPRB, 0.28636416E-11_JPRB, 0.25325428E-11_JPRB, 0.20103027E-11_JPRB /)

RGHG5(:,21, 2) = (/ &
  & 0.41876168E-11_JPRB, 0.51490305E-11_JPRB, 0.58098153E-11_JPRB, 0.65426336E-11_JPRB, 0.74340759E-11_JPRB, 0.85105976E-11_JPRB, &
  & 0.97703364E-11_JPRB, 0.11202211E-10_JPRB, 0.12848923E-10_JPRB, 0.14716537E-10_JPRB, 0.16798585E-10_JPRB, 0.19056028E-10_JPRB, &
  & 0.21485567E-10_JPRB, 0.24040010E-10_JPRB, 0.26675469E-10_JPRB, 0.29332026E-10_JPRB, 0.31908590E-10_JPRB, 0.34263689E-10_JPRB, &
  & 0.36205559E-10_JPRB, 0.37600856E-10_JPRB, 0.38257446E-10_JPRB, 0.38072000E-10_JPRB, 0.37059127E-10_JPRB, 0.35296738E-10_JPRB, &
  & 0.33105657E-10_JPRB, 0.30832947E-10_JPRB, 0.28851662E-10_JPRB, 0.27505649E-10_JPRB, 0.26959376E-10_JPRB, 0.27293390E-10_JPRB, &
  & 0.28399167E-10_JPRB, 0.30162227E-10_JPRB, 0.32345272E-10_JPRB, 0.34750994E-10_JPRB, 0.37346133E-10_JPRB, 0.39896898E-10_JPRB, &
  & 0.42141200E-10_JPRB, 0.43770248E-10_JPRB, 0.44604098E-10_JPRB, 0.44545936E-10_JPRB, 0.43678450E-10_JPRB, 0.42112164E-10_JPRB, &
  & 0.40020664E-10_JPRB, 0.37548312E-10_JPRB, 0.34843978E-10_JPRB, 0.32029948E-10_JPRB, 0.29196489E-10_JPRB, 0.26426640E-10_JPRB, &
  & 0.23782335E-10_JPRB, 0.21289916E-10_JPRB, 0.18992193E-10_JPRB, 0.16898701E-10_JPRB, 0.15019789E-10_JPRB, 0.13357487E-10_JPRB, &
  & 0.11909892E-10_JPRB, 0.10664985E-10_JPRB, 0.95898194E-11_JPRB, 0.86459295E-11_JPRB, 0.78170768E-11_JPRB, 0.70882128E-11_JPRB, &
  & 0.64321768E-11_JPRB, 0.58285291E-11_JPRB, 0.51587636E-11_JPRB, 0.41878688E-11_JPRB /)

RGHG5(:,22, 2) = (/ &
  & 0.77223740E-11_JPRB, 0.95203567E-11_JPRB, 0.10642577E-10_JPRB, 0.11819120E-10_JPRB, 0.13200822E-10_JPRB, 0.14889555E-10_JPRB, &
  & 0.16922625E-10_JPRB, 0.19254404E-10_JPRB, 0.21840734E-10_JPRB, 0.24702520E-10_JPRB, 0.27819236E-10_JPRB, 0.31131875E-10_JPRB, &
  & 0.34605117E-10_JPRB, 0.38166074E-10_JPRB, 0.41722386E-10_JPRB, 0.45184311E-10_JPRB, 0.48417177E-10_JPRB, 0.51255649E-10_JPRB, &
  & 0.53498712E-10_JPRB, 0.55042890E-10_JPRB, 0.55716761E-10_JPRB, 0.55402294E-10_JPRB, 0.54089025E-10_JPRB, 0.51997545E-10_JPRB, &
  & 0.49375129E-10_JPRB, 0.46767232E-10_JPRB, 0.44633807E-10_JPRB, 0.43405356E-10_JPRB, 0.43356169E-10_JPRB, 0.44592149E-10_JPRB, &
  & 0.46953965E-10_JPRB, 0.50219981E-10_JPRB, 0.53837563E-10_JPRB, 0.57750110E-10_JPRB, 0.61485178E-10_JPRB, 0.64711493E-10_JPRB, &
  & 0.67134874E-10_JPRB, 0.68445791E-10_JPRB, 0.68515305E-10_JPRB, 0.67374092E-10_JPRB, 0.65229044E-10_JPRB, 0.62305897E-10_JPRB, &
  & 0.58852874E-10_JPRB, 0.55036156E-10_JPRB, 0.51036786E-10_JPRB, 0.46965477E-10_JPRB, 0.42942080E-10_JPRB, 0.39069022E-10_JPRB, &
  & 0.35386302E-10_JPRB, 0.31960719E-10_JPRB, 0.28832051E-10_JPRB, 0.26001970E-10_JPRB, 0.23471631E-10_JPRB, 0.21229591E-10_JPRB, &
  & 0.19263514E-10_JPRB, 0.17544898E-10_JPRB, 0.16017862E-10_JPRB, 0.14650307E-10_JPRB, 0.13419802E-10_JPRB, 0.12302892E-10_JPRB, &
  & 0.11277239E-10_JPRB, 0.10262543E-10_JPRB, 0.92126922E-11_JPRB, 0.74903850E-11_JPRB /)

RGHG5(:,23, 2) = (/ &
  & 0.12776636E-10_JPRB, 0.15414210E-10_JPRB, 0.17140483E-10_JPRB, 0.18875681E-10_JPRB, 0.20860107E-10_JPRB, 0.23169277E-10_JPRB, &
  & 0.25883622E-10_JPRB, 0.29038645E-10_JPRB, 0.32537580E-10_JPRB, 0.36330362E-10_JPRB, 0.40390316E-10_JPRB, 0.44635916E-10_JPRB, &
  & 0.49014098E-10_JPRB, 0.53414145E-10_JPRB, 0.57738477E-10_JPRB, 0.61876448E-10_JPRB, 0.65690356E-10_JPRB, 0.69025660E-10_JPRB, &
  & 0.71697218E-10_JPRB, 0.73595977E-10_JPRB, 0.74545412E-10_JPRB, 0.74466940E-10_JPRB, 0.73394665E-10_JPRB, 0.71431881E-10_JPRB, &
  & 0.68969580E-10_JPRB, 0.66508722E-10_JPRB, 0.64552710E-10_JPRB, 0.63639233E-10_JPRB, 0.64141900E-10_JPRB, 0.66179937E-10_JPRB, &
  & 0.69610172E-10_JPRB, 0.73931181E-10_JPRB, 0.78715090E-10_JPRB, 0.83501400E-10_JPRB, 0.87804111E-10_JPRB, 0.91209595E-10_JPRB, &
  & 0.93344610E-10_JPRB, 0.93982391E-10_JPRB, 0.93041720E-10_JPRB, 0.90720972E-10_JPRB, 0.87293305E-10_JPRB, 0.83081084E-10_JPRB, &
  & 0.78364149E-10_JPRB, 0.73320912E-10_JPRB, 0.68119420E-10_JPRB, 0.62893142E-10_JPRB, 0.57776471E-10_JPRB, 0.52870909E-10_JPRB, &
  & 0.48278111E-10_JPRB, 0.44043536E-10_JPRB, 0.40195923E-10_JPRB, 0.36735236E-10_JPRB, 0.33638779E-10_JPRB, 0.30878296E-10_JPRB, &
  & 0.28422546E-10_JPRB, 0.26233092E-10_JPRB, 0.24246145E-10_JPRB, 0.22432351E-10_JPRB, 0.20755949E-10_JPRB, 0.19187962E-10_JPRB, &
  & 0.17689331E-10_JPRB, 0.16228883E-10_JPRB, 0.14572730E-10_JPRB, 0.12055299E-10_JPRB /)

RGHG5(:,24, 2) = (/ &
  & 0.19288404E-10_JPRB, 0.22868450E-10_JPRB, 0.25119653E-10_JPRB, 0.27332551E-10_JPRB, 0.29866533E-10_JPRB, 0.32814172E-10_JPRB, &
  & 0.36163062E-10_JPRB, 0.39945939E-10_JPRB, 0.44172166E-10_JPRB, 0.48714748E-10_JPRB, 0.53527842E-10_JPRB, 0.58521750E-10_JPRB, &
  & 0.63619984E-10_JPRB, 0.68714402E-10_JPRB, 0.73686481E-10_JPRB, 0.78415885E-10_JPRB, 0.82772803E-10_JPRB, 0.86610025E-10_JPRB, &
  & 0.89775798E-10_JPRB, 0.92206395E-10_JPRB, 0.93778547E-10_JPRB, 0.94414136E-10_JPRB, 0.94051364E-10_JPRB, 0.92835295E-10_JPRB, &
  & 0.91084799E-10_JPRB, 0.89235182E-10_JPRB, 0.87804111E-10_JPRB, 0.87326216E-10_JPRB, 0.88222860E-10_JPRB, 0.90696020E-10_JPRB, &
  & 0.94485836E-10_JPRB, 0.99190864E-10_JPRB, 0.10429187E-09_JPRB, 0.10921600E-09_JPRB, 0.11339897E-09_JPRB, 0.11641029E-09_JPRB, &
  & 0.11789215E-09_JPRB, 0.11765858E-09_JPRB, 0.11573556E-09_JPRB, 0.11240011E-09_JPRB, 0.10796666E-09_JPRB, 0.10280059E-09_JPRB, &
  & 0.97145569E-10_JPRB, 0.91162737E-10_JPRB, 0.85020511E-10_JPRB, 0.78879445E-10_JPRB, 0.72882360E-10_JPRB, 0.67206248E-10_JPRB, &
  & 0.61909304E-10_JPRB, 0.57053792E-10_JPRB, 0.52671850E-10_JPRB, 0.48738912E-10_JPRB, 0.45211918E-10_JPRB, 0.42037859E-10_JPRB, &
  & 0.39165275E-10_JPRB, 0.36528582E-10_JPRB, 0.34091403E-10_JPRB, 0.31806856E-10_JPRB, 0.29641324E-10_JPRB, 0.27560579E-10_JPRB, &
  & 0.25534595E-10_JPRB, 0.23472571E-10_JPRB, 0.21239822E-10_JPRB, 0.17621038E-10_JPRB /)

RGHG5(:,25, 2) = (/ &
  & 0.27116516E-10_JPRB, 0.31499057E-10_JPRB, 0.34257663E-10_JPRB, 0.36896645E-10_JPRB, 0.39834597E-10_JPRB, 0.43234222E-10_JPRB, &
  & 0.47116200E-10_JPRB, 0.51385320E-10_JPRB, 0.56072171E-10_JPRB, 0.61135201E-10_JPRB, 0.66457041E-10_JPRB, 0.71964143E-10_JPRB, &
  & 0.77567605E-10_JPRB, 0.83158799E-10_JPRB, 0.88622006E-10_JPRB, 0.93830110E-10_JPRB, 0.98676997E-10_JPRB, 0.10306451E-09_JPRB, &
  & 0.10689127E-09_JPRB, 0.11010729E-09_JPRB, 0.11258355E-09_JPRB, 0.11421559E-09_JPRB, 0.11495797E-09_JPRB, 0.11491751E-09_JPRB, &
  & 0.11429874E-09_JPRB, 0.11340620E-09_JPRB, 0.11276846E-09_JPRB, 0.11275487E-09_JPRB, 0.11389560E-09_JPRB, 0.11630154E-09_JPRB, &
  & 0.11988252E-09_JPRB, 0.12425844E-09_JPRB, 0.12885513E-09_JPRB, 0.13315574E-09_JPRB, 0.13664778E-09_JPRB, 0.13883114E-09_JPRB, &
  & 0.13945251E-09_JPRB, 0.13832366E-09_JPRB, 0.13559173E-09_JPRB, 0.13155443E-09_JPRB, 0.12652371E-09_JPRB, 0.12079314E-09_JPRB, &
  & 0.11457542E-09_JPRB, 0.10802281E-09_JPRB, 0.10127913E-09_JPRB, 0.94505022E-10_JPRB, 0.87914315E-10_JPRB, 0.81679788E-10_JPRB, &
  & 0.75897268E-10_JPRB, 0.70642506E-10_JPRB, 0.65917521E-10_JPRB, 0.61682770E-10_JPRB, 0.57864529E-10_JPRB, 0.54387533E-10_JPRB, &
  & 0.51163823E-10_JPRB, 0.48142303E-10_JPRB, 0.45272900E-10_JPRB, 0.42515880E-10_JPRB, 0.39829369E-10_JPRB, 0.37178163E-10_JPRB, &
  & 0.34535697E-10_JPRB, 0.31853672E-10_JPRB, 0.28847015E-10_JPRB, 0.24108973E-10_JPRB /)

RGHG5(:,26, 2) = (/ &
  & 0.35979997E-10_JPRB, 0.41021329E-10_JPRB, 0.44170338E-10_JPRB, 0.47174091E-10_JPRB, 0.50421549E-10_JPRB, 0.54114983E-10_JPRB, &
  & 0.58311050E-10_JPRB, 0.62929287E-10_JPRB, 0.67892664E-10_JPRB, 0.73251509E-10_JPRB, 0.78887119E-10_JPRB, 0.84719773E-10_JPRB, &
  & 0.90661534E-10_JPRB, 0.96608131E-10_JPRB, 0.10244607E-09_JPRB, 0.10807231E-09_JPRB, 0.11340406E-09_JPRB, 0.11835967E-09_JPRB, &
  & 0.12284909E-09_JPRB, 0.12683249E-09_JPRB, 0.13022503E-09_JPRB, 0.13295026E-09_JPRB, 0.13495727E-09_JPRB, 0.13627528E-09_JPRB, &
  & 0.13696035E-09_JPRB, 0.13721910E-09_JPRB, 0.13741842E-09_JPRB, 0.13795057E-09_JPRB, 0.13915964E-09_JPRB, 0.14123493E-09_JPRB, &
  & 0.14415219E-09_JPRB, 0.14766756E-09_JPRB, 0.15127959E-09_JPRB, 0.15452684E-09_JPRB, 0.15697865E-09_JPRB, 0.15814572E-09_JPRB, &
  & 0.15785320E-09_JPRB, 0.15596818E-09_JPRB, 0.15269658E-09_JPRB, 0.14829503E-09_JPRB, 0.14298437E-09_JPRB, 0.13702785E-09_JPRB, &
  & 0.13059211E-09_JPRB, 0.12377187E-09_JPRB, 0.11669864E-09_JPRB, 0.10958025E-09_JPRB, 0.10264668E-09_JPRB, 0.96083412E-10_JPRB, &
  & 0.90058704E-10_JPRB, 0.84592854E-10_JPRB, 0.79695826E-10_JPRB, 0.75303049E-10_JPRB, 0.71316647E-10_JPRB, 0.67638527E-10_JPRB, &
  & 0.64151254E-10_JPRB, 0.60801877E-10_JPRB, 0.57542856E-10_JPRB, 0.54316628E-10_JPRB, 0.51086354E-10_JPRB, 0.47825383E-10_JPRB, &
  & 0.44518146E-10_JPRB, 0.41116430E-10_JPRB, 0.37349401E-10_JPRB, 0.31327291E-10_JPRB /)

RGHG5(:,27, 2) = (/ &
  & 0.45667251E-10_JPRB, 0.51201939E-10_JPRB, 0.54628232E-10_JPRB, 0.57877980E-10_JPRB, 0.61358862E-10_JPRB, 0.65231535E-10_JPRB, &
  & 0.69570905E-10_JPRB, 0.74349374E-10_JPRB, 0.79457975E-10_JPRB, 0.84899816E-10_JPRB, 0.90695479E-10_JPRB, 0.96682079E-10_JPRB, &
  & 0.10282240E-09_JPRB, 0.10901250E-09_JPRB, 0.11515780E-09_JPRB, 0.12114926E-09_JPRB, 0.12689726E-09_JPRB, 0.13231792E-09_JPRB, &
  & 0.13735493E-09_JPRB, 0.14200409E-09_JPRB, 0.14622349E-09_JPRB, 0.14994014E-09_JPRB, 0.15309588E-09_JPRB, 0.15564136E-09_JPRB, &
  & 0.15757903E-09_JPRB, 0.15898624E-09_JPRB, 0.16005602E-09_JPRB, 0.16109450E-09_JPRB, 0.16235052E-09_JPRB, 0.16403962E-09_JPRB, &
  & 0.16619585E-09_JPRB, 0.16865563E-09_JPRB, 0.17107857E-09_JPRB, 0.17312016E-09_JPRB, 0.17442756E-09_JPRB, 0.17459438E-09_JPRB, &
  & 0.17350214E-09_JPRB, 0.17108009E-09_JPRB, 0.16749642E-09_JPRB, 0.16296342E-09_JPRB, 0.15768455E-09_JPRB, 0.15181031E-09_JPRB, &
  & 0.14543310E-09_JPRB, 0.13861823E-09_JPRB, 0.13149565E-09_JPRB, 0.12425370E-09_JPRB, 0.11714256E-09_JPRB, 0.11046229E-09_JPRB, &
  & 0.10431384E-09_JPRB, 0.98765052E-10_JPRB, 0.93811306E-10_JPRB, 0.89355343E-10_JPRB, 0.85295604E-10_JPRB, 0.81475875E-10_JPRB, &
  & 0.77800363E-10_JPRB, 0.74199251E-10_JPRB, 0.70592900E-10_JPRB, 0.66936956E-10_JPRB, 0.63178129E-10_JPRB, 0.59298413E-10_JPRB, &
  & 0.55317109E-10_JPRB, 0.51212496E-10_JPRB, 0.46644438E-10_JPRB, 0.39357125E-10_JPRB /)

RGHG5(:,28, 2) = (/ &
  & 0.55963408E-10_JPRB, 0.61849782E-10_JPRB, 0.65446343E-10_JPRB, 0.68811769E-10_JPRB, 0.72408295E-10_JPRB, 0.76364956E-10_JPRB, &
  & 0.80753466E-10_JPRB, 0.85542552E-10_JPRB, 0.90667203E-10_JPRB, 0.96088901E-10_JPRB, 0.10184215E-09_JPRB, 0.10789936E-09_JPRB, &
  & 0.11410037E-09_JPRB, 0.12039629E-09_JPRB, 0.12670026E-09_JPRB, 0.13291930E-09_JPRB, 0.13896909E-09_JPRB, 0.14478328E-09_JPRB, &
  & 0.15031017E-09_JPRB, 0.15553321E-09_JPRB, 0.16041488E-09_JPRB, 0.16490544E-09_JPRB, 0.16896066E-09_JPRB, 0.17250035E-09_JPRB, &
  & 0.17547984E-09_JPRB, 0.17786161E-09_JPRB, 0.17973679E-09_JPRB, 0.18124159E-09_JPRB, 0.18257933E-09_JPRB, 0.18393452E-09_JPRB, &
  & 0.18536984E-09_JPRB, 0.18683831E-09_JPRB, 0.18813814E-09_JPRB, 0.18903937E-09_JPRB, 0.18928994E-09_JPRB, 0.18859488E-09_JPRB, &
  & 0.18687958E-09_JPRB, 0.18411603E-09_JPRB, 0.18045158E-09_JPRB, 0.17606729E-09_JPRB, 0.17105085E-09_JPRB, 0.16545264E-09_JPRB, &
  & 0.15932518E-09_JPRB, 0.15271935E-09_JPRB, 0.14570752E-09_JPRB, 0.13851864E-09_JPRB, 0.13143682E-09_JPRB, 0.12471689E-09_JPRB, &
  & 0.11855994E-09_JPRB, 0.11301084E-09_JPRB, 0.10806397E-09_JPRB, 0.10360225E-09_JPRB, 0.99494815E-10_JPRB, 0.95597266E-10_JPRB, &
  & 0.91793559E-10_JPRB, 0.87987000E-10_JPRB, 0.84104716E-10_JPRB, 0.80067404E-10_JPRB, 0.75829357E-10_JPRB, 0.71384648E-10_JPRB, &
  & 0.66792585E-10_JPRB, 0.62047818E-10_JPRB, 0.56841479E-10_JPRB, 0.48313235E-10_JPRB /)

RGHG5(:,29, 2) = (/ &
  & 0.66739080E-10_JPRB, 0.72815767E-10_JPRB, 0.76492847E-10_JPRB, 0.79911251E-10_JPRB, 0.83503343E-10_JPRB, 0.87472571E-10_JPRB, &
  & 0.91809227E-10_JPRB, 0.96516045E-10_JPRB, 0.10152850E-09_JPRB, 0.10685779E-09_JPRB, 0.11244566E-09_JPRB, 0.11838105E-09_JPRB, &
  & 0.12461349E-09_JPRB, 0.13097848E-09_JPRB, 0.13740029E-09_JPRB, 0.14379749E-09_JPRB, 0.15009216E-09_JPRB, 0.15619891E-09_JPRB, &
  & 0.16205870E-09_JPRB, 0.16765771E-09_JPRB, 0.17297440E-09_JPRB, 0.17797497E-09_JPRB, 0.18263172E-09_JPRB, 0.18687171E-09_JPRB, &
  & 0.19060008E-09_JPRB, 0.19371280E-09_JPRB, 0.19619208E-09_JPRB, 0.19809060E-09_JPRB, 0.19952838E-09_JPRB, 0.20064735E-09_JPRB, &
  & 0.20154069E-09_JPRB, 0.20221684E-09_JPRB, 0.20259894E-09_JPRB, 0.20255640E-09_JPRB, 0.20194950E-09_JPRB, 0.20059579E-09_JPRB, &
  & 0.19846244E-09_JPRB, 0.19558204E-09_JPRB, 0.19206206E-09_JPRB, 0.18797293E-09_JPRB, 0.18332330E-09_JPRB, 0.17813144E-09_JPRB, &
  & 0.17239030E-09_JPRB, 0.16610668E-09_JPRB, 0.15937499E-09_JPRB, 0.15237961E-09_JPRB, 0.14540279E-09_JPRB, 0.13877136E-09_JPRB, &
  & 0.13265276E-09_JPRB, 0.12716410E-09_JPRB, 0.12225017E-09_JPRB, 0.11779851E-09_JPRB, 0.11367249E-09_JPRB, 0.10971841E-09_JPRB, &
  & 0.10580884E-09_JPRB, 0.10185690E-09_JPRB, 0.97732912E-10_JPRB, 0.93383509E-10_JPRB, 0.88734221E-10_JPRB, 0.83823191E-10_JPRB, &
  & 0.78737405E-10_JPRB, 0.73605400E-10_JPRB, 0.67837028E-10_JPRB, 0.58541866E-10_JPRB /)

RGHG5(:,30, 2) = (/ &
  & 0.77834073E-10_JPRB, 0.84008162E-10_JPRB, 0.87673840E-10_JPRB, 0.91030308E-10_JPRB, 0.94573051E-10_JPRB, 0.98442296E-10_JPRB, &
  & 0.10268074E-09_JPRB, 0.10724557E-09_JPRB, 0.11208653E-09_JPRB, 0.11722458E-09_JPRB, 0.12265847E-09_JPRB, 0.12837095E-09_JPRB, &
  & 0.13443742E-09_JPRB, 0.14080771E-09_JPRB, 0.14733557E-09_JPRB, 0.15389930E-09_JPRB, 0.16038956E-09_JPRB, 0.16671892E-09_JPRB, &
  & 0.17280094E-09_JPRB, 0.17862491E-09_JPRB, 0.18417930E-09_JPRB, 0.18946575E-09_JPRB, 0.19446456E-09_JPRB, 0.19910833E-09_JPRB, &
  & 0.20328444E-09_JPRB, 0.20683077E-09_JPRB, 0.20970781E-09_JPRB, 0.21186673E-09_JPRB, 0.21339179E-09_JPRB, 0.21436863E-09_JPRB, &
  & 0.21491235E-09_JPRB, 0.21502336E-09_JPRB, 0.21474922E-09_JPRB, 0.21401264E-09_JPRB, 0.21280344E-09_JPRB, 0.21103168E-09_JPRB, &
  & 0.20871717E-09_JPRB, 0.20588778E-09_JPRB, 0.20258262E-09_JPRB, 0.19883931E-09_JPRB, 0.19463939E-09_JPRB, 0.18991733E-09_JPRB, &
  & 0.18462572E-09_JPRB, 0.17874574E-09_JPRB, 0.17235245E-09_JPRB, 0.16564068E-09_JPRB, 0.15889609E-09_JPRB, 0.15239464E-09_JPRB, &
  & 0.14641273E-09_JPRB, 0.14099183E-09_JPRB, 0.13612321E-09_JPRB, 0.13170222E-09_JPRB, 0.12755350E-09_JPRB, 0.12356388E-09_JPRB, &
  & 0.11958010E-09_JPRB, 0.11549277E-09_JPRB, 0.11119248E-09_JPRB, 0.10657465E-09_JPRB, 0.10160667E-09_JPRB, 0.96337237E-10_JPRB, &
  & 0.91006459E-10_JPRB, 0.85602143E-10_JPRB, 0.79824418E-10_JPRB, 0.69902029E-10_JPRB /)

RGHG5(:,31, 2) = (/ &
  & 0.89170844E-10_JPRB, 0.95271915E-10_JPRB, 0.98869760E-10_JPRB, 0.10213481E-09_JPRB, 0.10553151E-09_JPRB, 0.10927414E-09_JPRB, &
  & 0.11336149E-09_JPRB, 0.11774347E-09_JPRB, 0.12238638E-09_JPRB, 0.12727054E-09_JPRB, 0.13247238E-09_JPRB, 0.13802898E-09_JPRB, &
  & 0.14392726E-09_JPRB, 0.15017054E-09_JPRB, 0.15669928E-09_JPRB, 0.16336288E-09_JPRB, 0.17000566E-09_JPRB, 0.17648999E-09_JPRB, &
  & 0.18272403E-09_JPRB, 0.18867341E-09_JPRB, 0.19434075E-09_JPRB, 0.19973900E-09_JPRB, 0.20486418E-09_JPRB, 0.20965270E-09_JPRB, &
  & 0.21399402E-09_JPRB, 0.21771310E-09_JPRB, 0.22076570E-09_JPRB, 0.22303960E-09_JPRB, 0.22460858E-09_JPRB, 0.22551500E-09_JPRB, &
  & 0.22584656E-09_JPRB, 0.22561768E-09_JPRB, 0.22493346E-09_JPRB, 0.22376126E-09_JPRB, 0.22219167E-09_JPRB, 0.22019833E-09_JPRB, &
  & 0.21783295E-09_JPRB, 0.21513107E-09_JPRB, 0.21211791E-09_JPRB, 0.20879086E-09_JPRB, 0.20505897E-09_JPRB, 0.20081699E-09_JPRB, &
  & 0.19597374E-09_JPRB, 0.19049524E-09_JPRB, 0.18448380E-09_JPRB, 0.17810634E-09_JPRB, 0.17163253E-09_JPRB, 0.16538892E-09_JPRB, &
  & 0.15954985E-09_JPRB, 0.15426531E-09_JPRB, 0.14947218E-09_JPRB, 0.14506585E-09_JPRB, 0.14092857E-09_JPRB, 0.13689933E-09_JPRB, &
  & 0.13286061E-09_JPRB, 0.12868490E-09_JPRB, 0.12423963E-09_JPRB, 0.11943392E-09_JPRB, 0.11422915E-09_JPRB, 0.10878023E-09_JPRB, &
  & 0.10332088E-09_JPRB, 0.98062711E-10_JPRB, 0.92207346E-10_JPRB, 0.82486143E-10_JPRB /)

RGHG5(:,32, 2) = (/ &
  & 0.10053929E-09_JPRB, 0.10654803E-09_JPRB, 0.10999507E-09_JPRB, 0.11310482E-09_JPRB, 0.11635644E-09_JPRB, 0.11991888E-09_JPRB, &
  & 0.12383242E-09_JPRB, 0.12800583E-09_JPRB, 0.13241630E-09_JPRB, 0.13703362E-09_JPRB, 0.14194085E-09_JPRB, 0.14722992E-09_JPRB, &
  & 0.15296424E-09_JPRB, 0.15911684E-09_JPRB, 0.16561424E-09_JPRB, 0.17232361E-09_JPRB, 0.17906472E-09_JPRB, 0.18566627E-09_JPRB, &
  & 0.19199914E-09_JPRB, 0.19801483E-09_JPRB, 0.20370478E-09_JPRB, 0.20909721E-09_JPRB, 0.21417318E-09_JPRB, 0.21891537E-09_JPRB, &
  & 0.22316499E-09_JPRB, 0.22685118E-09_JPRB, 0.22986632E-09_JPRB, 0.23213396E-09_JPRB, 0.23368468E-09_JPRB, 0.23455665E-09_JPRB, &
  & 0.23476962E-09_JPRB, 0.23440011E-09_JPRB, 0.23350832E-09_JPRB, 0.23214493E-09_JPRB, 0.23042876E-09_JPRB, 0.22838884E-09_JPRB, &
  & 0.22611396E-09_JPRB, 0.22363578E-09_JPRB, 0.22094869E-09_JPRB, 0.21799834E-09_JPRB, 0.21467333E-09_JPRB, 0.21083932E-09_JPRB, &
  & 0.20638040E-09_JPRB, 0.20127175E-09_JPRB, 0.19559307E-09_JPRB, 0.18956195E-09_JPRB, 0.18342966E-09_JPRB, 0.17744277E-09_JPRB, &
  & 0.17186139E-09_JPRB, 0.16672969E-09_JPRB, 0.16203713E-09_JPRB, 0.15769731E-09_JPRB, 0.15356658E-09_JPRB, 0.14953888E-09_JPRB, &
  & 0.14547510E-09_JPRB, 0.14125069E-09_JPRB, 0.13673564E-09_JPRB, 0.13181617E-09_JPRB, 0.12650692E-09_JPRB, 0.12099084E-09_JPRB, &
  & 0.11564964E-09_JPRB, 0.11047929E-09_JPRB, 0.10502949E-09_JPRB, 0.95453388E-10_JPRB /)

RGHG5(:,33, 2) = (/ &
  & 0.11184908E-09_JPRB, 0.11761976E-09_JPRB, 0.12094876E-09_JPRB, 0.12390006E-09_JPRB, 0.12696572E-09_JPRB, 0.13035346E-09_JPRB, &
  & 0.13406998E-09_JPRB, 0.13802648E-09_JPRB, 0.14218218E-09_JPRB, 0.14651649E-09_JPRB, 0.15113118E-09_JPRB, 0.15613080E-09_JPRB, &
  & 0.16160592E-09_JPRB, 0.16759473E-09_JPRB, 0.17404178E-09_JPRB, 0.18079041E-09_JPRB, 0.18762017E-09_JPRB, 0.19432560E-09_JPRB, &
  & 0.20073934E-09_JPRB, 0.20677608E-09_JPRB, 0.21243596E-09_JPRB, 0.21771743E-09_JPRB, 0.22263945E-09_JPRB, 0.22713979E-09_JPRB, &
  & 0.23115349E-09_JPRB, 0.23461363E-09_JPRB, 0.23742761E-09_JPRB, 0.23957861E-09_JPRB, 0.24104951E-09_JPRB, 0.24188576E-09_JPRB, &
  & 0.24206079E-09_JPRB, 0.24168756E-09_JPRB, 0.24076707E-09_JPRB, 0.23941818E-09_JPRB, 0.23773661E-09_JPRB, 0.23581331E-09_JPRB, &
  & 0.23373845E-09_JPRB, 0.23152379E-09_JPRB, 0.22915168E-09_JPRB, 0.22654059E-09_JPRB, 0.22354207E-09_JPRB, 0.22000431E-09_JPRB, &
  & 0.21583257E-09_JPRB, 0.21098978E-09_JPRB, 0.20561242E-09_JPRB, 0.19989450E-09_JPRB, 0.19407763E-09_JPRB, 0.18843670E-09_JPRB, &
  & 0.18310248E-09_JPRB, 0.17818666E-09_JPRB, 0.17364024E-09_JPRB, 0.16938084E-09_JPRB, 0.16531511E-09_JPRB, 0.16131088E-09_JPRB, &
  & 0.15727109E-09_JPRB, 0.15305759E-09_JPRB, 0.14854185E-09_JPRB, 0.14362062E-09_JPRB, 0.13832376E-09_JPRB, 0.13289991E-09_JPRB, &
  & 0.12768751E-09_JPRB, 0.12283181E-09_JPRB, 0.11751630E-09_JPRB, 0.10852239E-09_JPRB /)

RGHG5(:,34, 2) = (/ &
  & 0.12287327E-09_JPRB, 0.12849528E-09_JPRB, 0.13163227E-09_JPRB, 0.13443004E-09_JPRB, 0.13733709E-09_JPRB, 0.14053371E-09_JPRB, &
  & 0.14404934E-09_JPRB, 0.14778624E-09_JPRB, 0.15166911E-09_JPRB, 0.15570162E-09_JPRB, 0.15999641E-09_JPRB, 0.16468979E-09_JPRB, &
  & 0.16991480E-09_JPRB, 0.17572295E-09_JPRB, 0.18207802E-09_JPRB, 0.18881437E-09_JPRB, 0.19570563E-09_JPRB, 0.20249992E-09_JPRB, &
  & 0.20896176E-09_JPRB, 0.21500243E-09_JPRB, 0.22058251E-09_JPRB, 0.22570264E-09_JPRB, 0.23034583E-09_JPRB, 0.23452082E-09_JPRB, &
  & 0.23813967E-09_JPRB, 0.24123897E-09_JPRB, 0.24372673E-09_JPRB, 0.24564759E-09_JPRB, 0.24697824E-09_JPRB, 0.24774585E-09_JPRB, &
  & 0.24794056E-09_JPRB, 0.24764030E-09_JPRB, 0.24684327E-09_JPRB, 0.24565741E-09_JPRB, 0.24416119E-09_JPRB, 0.24247282E-09_JPRB, &
  & 0.24065669E-09_JPRB, 0.23873828E-09_JPRB, 0.23668656E-09_JPRB, 0.23438071E-09_JPRB, 0.23165020E-09_JPRB, 0.22833616E-09_JPRB, &
  & 0.22432969E-09_JPRB, 0.21968216E-09_JPRB, 0.21451184E-09_JPRB, 0.20905971E-09_JPRB, 0.20357022E-09_JPRB, 0.19821882E-09_JPRB, &
  & 0.19319175E-09_JPRB, 0.18849919E-09_JPRB, 0.18412531E-09_JPRB, 0.17999942E-09_JPRB, 0.17601048E-09_JPRB, 0.17208174E-09_JPRB, &
  & 0.16810182E-09_JPRB, 0.16395146E-09_JPRB, 0.15950782E-09_JPRB, 0.15468749E-09_JPRB, 0.14953158E-09_JPRB, 0.14428941E-09_JPRB, &
  & 0.13933039E-09_JPRB, 0.13462687E-09_JPRB, 0.12968511E-09_JPRB, 0.12095501E-09_JPRB /)

RGHG5(:,35, 2) = (/ &
  & 0.13361731E-09_JPRB, 0.13898085E-09_JPRB, 0.14200974E-09_JPRB, 0.14465831E-09_JPRB, 0.14739801E-09_JPRB, 0.15042891E-09_JPRB, &
  & 0.15373898E-09_JPRB, 0.15724425E-09_JPRB, 0.16084448E-09_JPRB, 0.16456812E-09_JPRB, 0.16852124E-09_JPRB, 0.17286456E-09_JPRB, &
  & 0.17776697E-09_JPRB, 0.18335039E-09_JPRB, 0.18959720E-09_JPRB, 0.19632444E-09_JPRB, 0.20327111E-09_JPRB, 0.21012944E-09_JPRB, &
  & 0.21663432E-09_JPRB, 0.22265215E-09_JPRB, 0.22811905E-09_JPRB, 0.23300922E-09_JPRB, 0.23731053E-09_JPRB, 0.24104010E-09_JPRB, &
  & 0.24416180E-09_JPRB, 0.24676944E-09_JPRB, 0.24880301E-09_JPRB, 0.25039654E-09_JPRB, 0.25149793E-09_JPRB, 0.25215355E-09_JPRB, &
  & 0.25236452E-09_JPRB, 0.25216673E-09_JPRB, 0.25156732E-09_JPRB, 0.25062749E-09_JPRB, 0.24942068E-09_JPRB, 0.24803562E-09_JPRB, &
  & 0.24653374E-09_JPRB, 0.24494529E-09_JPRB, 0.24320540E-09_JPRB, 0.24119207E-09_JPRB, 0.23873017E-09_JPRB, 0.23563235E-09_JPRB, &
  & 0.23182706E-09_JPRB, 0.22730787E-09_JPRB, 0.22232174E-09_JPRB, 0.21709529E-09_JPRB, 0.21185938E-09_JPRB, 0.20683065E-09_JPRB, &
  & 0.20205727E-09_JPRB, 0.19760794E-09_JPRB, 0.19342636E-09_JPRB, 0.18943336E-09_JPRB, 0.18556709E-09_JPRB, 0.18173253E-09_JPRB, &
  & 0.17784126E-09_JPRB, 0.17379137E-09_JPRB, 0.16948545E-09_JPRB, 0.16483645E-09_JPRB, 0.15992560E-09_JPRB, 0.15496784E-09_JPRB, &
  & 0.15025609E-09_JPRB, 0.14585656E-09_JPRB, 0.14104799E-09_JPRB, 0.13282038E-09_JPRB /)

RGHG5(:,36, 2) = (/ &
  & 0.14398463E-09_JPRB, 0.14916746E-09_JPRB, 0.15201757E-09_JPRB, 0.15453720E-09_JPRB, 0.15714721E-09_JPRB, 0.16000315E-09_JPRB, &
  & 0.16311803E-09_JPRB, 0.16638324E-09_JPRB, 0.16969844E-09_JPRB, 0.17309018E-09_JPRB, 0.17668561E-09_JPRB, 0.18066190E-09_JPRB, &
  & 0.18522130E-09_JPRB, 0.19052965E-09_JPRB, 0.19660835E-09_JPRB, 0.20328653E-09_JPRB, 0.21025874E-09_JPRB, 0.21716327E-09_JPRB, &
  & 0.22368998E-09_JPRB, 0.22966312E-09_JPRB, 0.23496083E-09_JPRB, 0.23954227E-09_JPRB, 0.24338834E-09_JPRB, 0.24654581E-09_JPRB, &
  & 0.24904839E-09_JPRB, 0.25104666E-09_JPRB, 0.25257738E-09_JPRB, 0.25375987E-09_JPRB, 0.25459976E-09_JPRB, 0.25511110E-09_JPRB, &
  & 0.25530686E-09_JPRB, 0.25519037E-09_JPRB, 0.25476549E-09_JPRB, 0.25406346E-09_JPRB, 0.25313576E-09_JPRB, 0.25204694E-09_JPRB, &
  & 0.25085306E-09_JPRB, 0.24956573E-09_JPRB, 0.24812785E-09_JPRB, 0.24642788E-09_JPRB, 0.24428448E-09_JPRB, 0.24152655E-09_JPRB, &
  & 0.23799543E-09_JPRB, 0.23376770E-09_JPRB, 0.22898329E-09_JPRB, 0.22399083E-09_JPRB, 0.21903532E-09_JPRB, 0.21425256E-09_JPRB, &
  & 0.20975330E-09_JPRB, 0.20551931E-09_JPRB, 0.20151289E-09_JPRB, 0.19768054E-09_JPRB, 0.19393526E-09_JPRB, 0.19021495E-09_JPRB, &
  & 0.18643900E-09_JPRB, 0.18253009E-09_JPRB, 0.17838840E-09_JPRB, 0.17399071E-09_JPRB, 0.16937367E-09_JPRB, 0.16476354E-09_JPRB, &
  & 0.16038931E-09_JPRB, 0.15621665E-09_JPRB, 0.15173750E-09_JPRB, 0.14384978E-09_JPRB /)

RGHG5(:,37, 2) = (/ &
  & 0.15407227E-09_JPRB, 0.15895349E-09_JPRB, 0.16168403E-09_JPRB, 0.16407239E-09_JPRB, 0.16655090E-09_JPRB, 0.16926889E-09_JPRB, &
  & 0.17219012E-09_JPRB, 0.17521144E-09_JPRB, 0.17823439E-09_JPRB, 0.18128825E-09_JPRB, 0.18450143E-09_JPRB, 0.18806327E-09_JPRB, &
  & 0.19223295E-09_JPRB, 0.19721355E-09_JPRB, 0.20309188E-09_JPRB, 0.20968612E-09_JPRB, 0.21664166E-09_JPRB, 0.22355931E-09_JPRB, &
  & 0.23008291E-09_JPRB, 0.23593016E-09_JPRB, 0.24093730E-09_JPRB, 0.24507085E-09_JPRB, 0.24828167E-09_JPRB, 0.25076133E-09_JPRB, &
  & 0.25260086E-09_JPRB, 0.25401581E-09_JPRB, 0.25507957E-09_JPRB, 0.25591909E-09_JPRB, 0.25652877E-09_JPRB, 0.25692062E-09_JPRB, &
  & 0.25708921E-09_JPRB, 0.25702057E-09_JPRB, 0.25671107E-09_JPRB, 0.25617586E-09_JPRB, 0.25545210E-09_JPRB, 0.25458818E-09_JPRB, &
  & 0.25362876E-09_JPRB, 0.25258107E-09_JPRB, 0.25139921E-09_JPRB, 0.24998575E-09_JPRB, 0.24818961E-09_JPRB, 0.24581942E-09_JPRB, &
  & 0.24275007E-09_JPRB, 0.23889887E-09_JPRB, 0.23449487E-09_JPRB, 0.22979282E-09_JPRB, 0.22510661E-09_JPRB, 0.22059952E-09_JPRB, &
  & 0.21632281E-09_JPRB, 0.21228862E-09_JPRB, 0.20845925E-09_JPRB, 0.20476928E-09_JPRB, 0.20116475E-09_JPRB, 0.19757933E-09_JPRB, &
  & 0.19395108E-09_JPRB, 0.19021404E-09_JPRB, 0.18630454E-09_JPRB, 0.18217698E-09_JPRB, 0.17791460E-09_JPRB, 0.17367122E-09_JPRB, &
  & 0.16963675E-09_JPRB, 0.16578565E-09_JPRB, 0.16158307E-09_JPRB, 0.15421860E-09_JPRB /)

RGHG5(:,38, 2) = (/ &
  & 0.16381538E-09_JPRB, 0.16841420E-09_JPRB, 0.17094809E-09_JPRB, 0.17323694E-09_JPRB, 0.17560969E-09_JPRB, 0.17819812E-09_JPRB, &
  & 0.18094252E-09_JPRB, 0.18371704E-09_JPRB, 0.18644636E-09_JPRB, 0.18915328E-09_JPRB, 0.19197252E-09_JPRB, 0.19511963E-09_JPRB, &
  & 0.19883913E-09_JPRB, 0.20343528E-09_JPRB, 0.20901539E-09_JPRB, 0.21546212E-09_JPRB, 0.22235905E-09_JPRB, 0.22922256E-09_JPRB, &
  & 0.23563451E-09_JPRB, 0.24123084E-09_JPRB, 0.24577448E-09_JPRB, 0.24924465E-09_JPRB, 0.25179084E-09_JPRB, 0.25360733E-09_JPRB, &
  & 0.25491595E-09_JPRB, 0.25589594E-09_JPRB, 0.25664562E-09_JPRB, 0.25724864E-09_JPRB, 0.25771030E-09_JPRB, 0.25802249E-09_JPRB, &
  & 0.25816987E-09_JPRB, 0.25812869E-09_JPRB, 0.25788910E-09_JPRB, 0.25745822E-09_JPRB, 0.25686686E-09_JPRB, 0.25615443E-09_JPRB, &
  & 0.25535979E-09_JPRB, 0.25448374E-09_JPRB, 0.25349217E-09_JPRB, 0.25230379E-09_JPRB, 0.25079022E-09_JPRB, 0.24879743E-09_JPRB, &
  & 0.24615801E-09_JPRB, 0.24281521E-09_JPRB, 0.23884045E-09_JPRB, 0.23453745E-09_JPRB, 0.23016838E-09_JPRB, 0.22592209E-09_JPRB, &
  & 0.22186965E-09_JPRB, 0.21802141E-09_JPRB, 0.21434074E-09_JPRB, 0.21079867E-09_JPRB, 0.20733819E-09_JPRB, 0.20391458E-09_JPRB, &
  & 0.20048055E-09_JPRB, 0.19697401E-09_JPRB, 0.19334104E-09_JPRB, 0.18954727E-09_JPRB, 0.18564560E-09_JPRB, 0.18177834E-09_JPRB, &
  & 0.17808591E-09_JPRB, 0.17455069E-09_JPRB, 0.17065618E-09_JPRB, 0.16386308E-09_JPRB /)

RGHG5(:,39, 2) = (/ &
  & 0.17320688E-09_JPRB, 0.17739560E-09_JPRB, 0.17980396E-09_JPRB, 0.18195997E-09_JPRB, 0.18426408E-09_JPRB, 0.18673718E-09_JPRB, &
  & 0.18931057E-09_JPRB, 0.19184217E-09_JPRB, 0.19427115E-09_JPRB, 0.19663578E-09_JPRB, 0.19908455E-09_JPRB, 0.20179058E-09_JPRB, &
  & 0.20507787E-09_JPRB, 0.20921884E-09_JPRB, 0.21446339E-09_JPRB, 0.22067284E-09_JPRB, 0.22742487E-09_JPRB, 0.23413860E-09_JPRB, &
  & 0.24024729E-09_JPRB, 0.24538011E-09_JPRB, 0.24929461E-09_JPRB, 0.25211122E-09_JPRB, 0.25405836E-09_JPRB, 0.25540503E-09_JPRB, &
  & 0.25636426E-09_JPRB, 0.25707958E-09_JPRB, 0.25764008E-09_JPRB, 0.25810523E-09_JPRB, 0.25847671E-09_JPRB, 0.25874136E-09_JPRB, &
  & 0.25887537E-09_JPRB, 0.25885111E-09_JPRB, 0.25865393E-09_JPRB, 0.25828994E-09_JPRB, 0.25778396E-09_JPRB, 0.25717548E-09_JPRB, &
  & 0.25649421E-09_JPRB, 0.25574293E-09_JPRB, 0.25488858E-09_JPRB, 0.25386487E-09_JPRB, 0.25256844E-09_JPRB, 0.25086250E-09_JPRB, &
  & 0.24861163E-09_JPRB, 0.24571661E-09_JPRB, 0.24222505E-09_JPRB, 0.23833618E-09_JPRB, 0.23431523E-09_JPRB, 0.23034834E-09_JPRB, &
  & 0.22652652E-09_JPRB, 0.22284050E-09_JPRB, 0.21930625E-09_JPRB, 0.21589505E-09_JPRB, 0.21258204E-09_JPRB, 0.20934530E-09_JPRB, &
  & 0.20613772E-09_JPRB, 0.20292386E-09_JPRB, 0.19962171E-09_JPRB, 0.19620179E-09_JPRB, 0.19268595E-09_JPRB, 0.18918843E-09_JPRB, &
  & 0.18584134E-09_JPRB, 0.18259418E-09_JPRB, 0.17906775E-09_JPRB, 0.17282213E-09_JPRB /)

RGHG5(:,40, 2) = (/ &
  & 0.18204319E-09_JPRB, 0.18588657E-09_JPRB, 0.18808954E-09_JPRB, 0.19018492E-09_JPRB, 0.19240205E-09_JPRB, 0.19479261E-09_JPRB, &
  & 0.19719384E-09_JPRB, 0.19947882E-09_JPRB, 0.20161962E-09_JPRB, 0.20366792E-09_JPRB, 0.20575132E-09_JPRB, 0.20808746E-09_JPRB, &
  & 0.21090642E-09_JPRB, 0.21459311E-09_JPRB, 0.21940152E-09_JPRB, 0.22531159E-09_JPRB, 0.23183079E-09_JPRB, 0.23825858E-09_JPRB, &
  & 0.24394115E-09_JPRB, 0.24843858E-09_JPRB, 0.25173266E-09_JPRB, 0.25398192E-09_JPRB, 0.25551339E-09_JPRB, 0.25655342E-09_JPRB, &
  & 0.25730340E-09_JPRB, 0.25786423E-09_JPRB, 0.25831740E-09_JPRB, 0.25870039E-09_JPRB, 0.25901889E-09_JPRB, 0.25925387E-09_JPRB, &
  & 0.25937855E-09_JPRB, 0.25936447E-09_JPRB, 0.25919511E-09_JPRB, 0.25887459E-09_JPRB, 0.25842795E-09_JPRB, 0.25789104E-09_JPRB, &
  & 0.25729360E-09_JPRB, 0.25663316E-09_JPRB, 0.25588201E-09_JPRB, 0.25498348E-09_JPRB, 0.25384894E-09_JPRB, 0.25236685E-09_JPRB, &
  & 0.25041458E-09_JPRB, 0.24789387E-09_JPRB, 0.24482349E-09_JPRB, 0.24134508E-09_JPRB, 0.23769631E-09_JPRB, 0.23403887E-09_JPRB, &
  & 0.23043403E-09_JPRB, 0.22692877E-09_JPRB, 0.22351504E-09_JPRB, 0.22021152E-09_JPRB, 0.21704155E-09_JPRB, 0.21398933E-09_JPRB, &
  & 0.21104965E-09_JPRB, 0.20814979E-09_JPRB, 0.20522775E-09_JPRB, 0.20220477E-09_JPRB, 0.19909933E-09_JPRB, 0.19598795E-09_JPRB, &
  & 0.19297368E-09_JPRB, 0.19005701E-09_JPRB, 0.18681087E-09_JPRB, 0.18117381E-09_JPRB /)

RGHG5(:,41, 2) = (/ &
  & 0.19025083E-09_JPRB, 0.19372172E-09_JPRB, 0.19579535E-09_JPRB, 0.19778580E-09_JPRB, 0.19996590E-09_JPRB, 0.20225713E-09_JPRB, &
  & 0.20448761E-09_JPRB, 0.20654234E-09_JPRB, 0.20840435E-09_JPRB, 0.21016702E-09_JPRB, 0.21194549E-09_JPRB, 0.21392117E-09_JPRB, &
  & 0.21636141E-09_JPRB, 0.21958345E-09_JPRB, 0.22394496E-09_JPRB, 0.22948050E-09_JPRB, 0.23566510E-09_JPRB, 0.24171429E-09_JPRB, &
  & 0.24682675E-09_JPRB, 0.25070823E-09_JPRB, 0.25342703E-09_JPRB, 0.25525521E-09_JPRB, 0.25649549E-09_JPRB, 0.25733979E-09_JPRB, &
  & 0.25796176E-09_JPRB, 0.25843022E-09_JPRB, 0.25881822E-09_JPRB, 0.25915334E-09_JPRB, 0.25943653E-09_JPRB, 0.25965224E-09_JPRB, &
  & 0.25976848E-09_JPRB, 0.25975963E-09_JPRB, 0.25960850E-09_JPRB, 0.25931871E-09_JPRB, 0.25891334E-09_JPRB, 0.25843061E-09_JPRB, &
  & 0.25789479E-09_JPRB, 0.25730568E-09_JPRB, 0.25663577E-09_JPRB, 0.25583519E-09_JPRB, 0.25483005E-09_JPRB, 0.25352337E-09_JPRB, &
  & 0.25180957E-09_JPRB, 0.24960256E-09_JPRB, 0.24688779E-09_JPRB, 0.24379740E-09_JPRB, 0.24049482E-09_JPRB, 0.23713881E-09_JPRB, &
  & 0.23379063E-09_JPRB, 0.23044910E-09_JPRB, 0.22714049E-09_JPRB, 0.22393858E-09_JPRB, 0.22087421E-09_JPRB, 0.21801987E-09_JPRB, &
  & 0.21533714E-09_JPRB, 0.21277571E-09_JPRB, 0.21022835E-09_JPRB, 0.20762284E-09_JPRB, 0.20493565E-09_JPRB, 0.20222367E-09_JPRB, &
  & 0.19957430E-09_JPRB, 0.19695091E-09_JPRB, 0.19405544E-09_JPRB, 0.18894331E-09_JPRB /)

RGHG5(:,42, 2) = (/ &
  & 0.19777410E-09_JPRB, 0.20092392E-09_JPRB, 0.20285199E-09_JPRB, 0.20476444E-09_JPRB, 0.20688237E-09_JPRB, 0.20907802E-09_JPRB, &
  & 0.21114076E-09_JPRB, 0.21296991E-09_JPRB, 0.21459637E-09_JPRB, 0.21610730E-09_JPRB, 0.21762571E-09_JPRB, 0.21931484E-09_JPRB, &
  & 0.22139829E-09_JPRB, 0.22422039E-09_JPRB, 0.22812974E-09_JPRB, 0.23324193E-09_JPRB, 0.23904592E-09_JPRB, 0.24456473E-09_JPRB, &
  & 0.24912153E-09_JPRB, 0.25240277E-09_JPRB, 0.25466432E-09_JPRB, 0.25617325E-09_JPRB, 0.25720689E-09_JPRB, 0.25792293E-09_JPRB, &
  & 0.25846025E-09_JPRB, 0.25887098E-09_JPRB, 0.25921978E-09_JPRB, 0.25952207E-09_JPRB, 0.25978406E-09_JPRB, 0.25998265E-09_JPRB, &
  & 0.26009100E-09_JPRB, 0.26008320E-09_JPRB, 0.25994409E-09_JPRB, 0.25967584E-09_JPRB, 0.25930214E-09_JPRB, 0.25885932E-09_JPRB, &
  & 0.25837274E-09_JPRB, 0.25784003E-09_JPRB, 0.25723659E-09_JPRB, 0.25651878E-09_JPRB, 0.25562050E-09_JPRB, 0.25446054E-09_JPRB, &
  & 0.25294583E-09_JPRB, 0.25098992E-09_JPRB, 0.24858493E-09_JPRB, 0.24581590E-09_JPRB, 0.24286012E-09_JPRB, 0.23981461E-09_JPRB, &
  & 0.23671645E-09_JPRB, 0.23355243E-09_JPRB, 0.23036836E-09_JPRB, 0.22722205E-09_JPRB, 0.22428708E-09_JPRB, 0.22160569E-09_JPRB, &
  & 0.21919097E-09_JPRB, 0.21694804E-09_JPRB, 0.21476779E-09_JPRB, 0.21255514E-09_JPRB, 0.21027947E-09_JPRB, 0.20797211E-09_JPRB, &
  & 0.20568279E-09_JPRB, 0.20339164E-09_JPRB, 0.20079158E-09_JPRB, 0.19621237E-09_JPRB /)

RGHG5(:,43, 2) = (/ &
  & 0.20464429E-09_JPRB, 0.20751342E-09_JPRB, 0.20930352E-09_JPRB, 0.21112398E-09_JPRB, 0.21315724E-09_JPRB, 0.21524217E-09_JPRB, &
  & 0.21714440E-09_JPRB, 0.21877988E-09_JPRB, 0.22020905E-09_JPRB, 0.22151243E-09_JPRB, 0.22282162E-09_JPRB, 0.22426896E-09_JPRB, &
  & 0.22607358E-09_JPRB, 0.22853106E-09_JPRB, 0.23204018E-09_JPRB, 0.23671581E-09_JPRB, 0.24204982E-09_JPRB, 0.24703092E-09_JPRB, &
  & 0.25094418E-09_JPRB, 0.25372396E-09_JPRB, 0.25560321E-09_JPRB, 0.25687324E-09_JPRB, 0.25775521E-09_JPRB, 0.25838287E-09_JPRB, &
  & 0.25886182E-09_JPRB, 0.25923630E-09_JPRB, 0.25955854E-09_JPRB, 0.25984204E-09_JPRB, 0.26008540E-09_JPRB, 0.26027178E-09_JPRB, &
  & 0.26036956E-09_JPRB, 0.26035957E-09_JPRB, 0.26022781E-09_JPRB, 0.25997560E-09_JPRB, 0.25962543E-09_JPRB, 0.25921454E-09_JPRB, &
  & 0.25876673E-09_JPRB, 0.25828070E-09_JPRB, 0.25773372E-09_JPRB, 0.25708594E-09_JPRB, 0.25628144E-09_JPRB, 0.25524835E-09_JPRB, &
  & 0.25390584E-09_JPRB, 0.25217539E-09_JPRB, 0.25003358E-09_JPRB, 0.24756805E-09_JPRB, 0.24490832E-09_JPRB, 0.24216099E-09_JPRB, &
  & 0.23931812E-09_JPRB, 0.23636143E-09_JPRB, 0.23328900E-09_JPRB, 0.23026805E-09_JPRB, 0.22743954E-09_JPRB, 0.22496316E-09_JPRB, &
  & 0.22280355E-09_JPRB, 0.22085703E-09_JPRB, 0.21900458E-09_JPRB, 0.21714795E-09_JPRB, 0.21524829E-09_JPRB, 0.21332004E-09_JPRB, &
  & 0.21138746E-09_JPRB, 0.20940479E-09_JPRB, 0.20712548E-09_JPRB, 0.20303915E-09_JPRB /)

RGHG5(:,44, 2) = (/ &
  & 0.21092150E-09_JPRB, 0.21357288E-09_JPRB, 0.21520598E-09_JPRB, 0.21692204E-09_JPRB, 0.21884695E-09_JPRB, 0.22081596E-09_JPRB, &
  & 0.22256870E-09_JPRB, 0.22406456E-09_JPRB, 0.22532669E-09_JPRB, 0.22647818E-09_JPRB, 0.22760868E-09_JPRB, 0.22886415E-09_JPRB, &
  & 0.23042608E-09_JPRB, 0.23258298E-09_JPRB, 0.23570360E-09_JPRB, 0.23996385E-09_JPRB, 0.24477087E-09_JPRB, 0.24912930E-09_JPRB, &
  & 0.25245719E-09_JPRB, 0.25476682E-09_JPRB, 0.25634436E-09_JPRB, 0.25742608E-09_JPRB, 0.25819760E-09_JPRB, 0.25875974E-09_JPRB, &
  & 0.25919861E-09_JPRB, 0.25955044E-09_JPRB, 0.25985580E-09_JPRB, 0.26012567E-09_JPRB, 0.26035801E-09_JPRB, 0.26052960E-09_JPRB, &
  & 0.26061697E-09_JPRB, 0.26060182E-09_JPRB, 0.26047370E-09_JPRB, 0.26023267E-09_JPRB, 0.25990102E-09_JPRB, 0.25951502E-09_JPRB, &
  & 0.25909902E-09_JPRB, 0.25865210E-09_JPRB, 0.25815261E-09_JPRB, 0.25756652E-09_JPRB, 0.25684377E-09_JPRB, 0.25592445E-09_JPRB, &
  & 0.25473681E-09_JPRB, 0.25320757E-09_JPRB, 0.25130614E-09_JPRB, 0.24910049E-09_JPRB, 0.24672536E-09_JPRB, 0.24425115E-09_JPRB, &
  & 0.24166938E-09_JPRB, 0.23892169E-09_JPRB, 0.23604219E-09_JPRB, 0.23314836E-09_JPRB, 0.23051354E-09_JPRB, 0.22824694E-09_JPRB, &
  & 0.22633739E-09_JPRB, 0.22466125E-09_JPRB, 0.22308802E-09_JPRB, 0.22153669E-09_JPRB, 0.21996184E-09_JPRB, 0.21836970E-09_JPRB, &
  & 0.21676073E-09_JPRB, 0.21508371E-09_JPRB, 0.21310004E-09_JPRB, 0.20950090E-09_JPRB /)

RGHG5(:,45, 2) = (/ &
  & 0.21674992E-09_JPRB, 0.21911130E-09_JPRB, 0.22067571E-09_JPRB, 0.22223497E-09_JPRB, 0.22406077E-09_JPRB, 0.22590514E-09_JPRB, &
  & 0.22756999E-09_JPRB, 0.22893509E-09_JPRB, 0.23010069E-09_JPRB, 0.23111651E-09_JPRB, 0.23211433E-09_JPRB, 0.23320246E-09_JPRB, &
  & 0.23454555E-09_JPRB, 0.23643559E-09_JPRB, 0.23918620E-09_JPRB, 0.24298019E-09_JPRB, 0.24722949E-09_JPRB, 0.25093153E-09_JPRB, &
  & 0.25368874E-09_JPRB, 0.25560956E-09_JPRB, 0.25693447E-09_JPRB, 0.25787653E-09_JPRB, 0.25855754E-09_JPRB, 0.25907787E-09_JPRB, &
  & 0.25948768E-09_JPRB, 0.25982438E-09_JPRB, 0.26012209E-09_JPRB, 0.26038310E-09_JPRB, 0.26060396E-09_JPRB, 0.26076408E-09_JPRB, &
  & 0.26083816E-09_JPRB, 0.26081598E-09_JPRB, 0.26068830E-09_JPRB, 0.26045532E-09_JPRB, 0.26013719E-09_JPRB, 0.25977137E-09_JPRB, &
  & 0.25938177E-09_JPRB, 0.25896679E-09_JPRB, 0.25850860E-09_JPRB, 0.25797481E-09_JPRB, 0.25732477E-09_JPRB, 0.25650726E-09_JPRB, &
  & 0.25546393E-09_JPRB, 0.25412486E-09_JPRB, 0.25245536E-09_JPRB, 0.25050126E-09_JPRB, 0.24838059E-09_JPRB, 0.24616789E-09_JPRB, &
  & 0.24383146E-09_JPRB, 0.24132449E-09_JPRB, 0.23864216E-09_JPRB, 0.23598876E-09_JPRB, 0.23356092E-09_JPRB, 0.23155734E-09_JPRB, &
  & 0.22988711E-09_JPRB, 0.22844886E-09_JPRB, 0.22711982E-09_JPRB, 0.22581630E-09_JPRB, 0.22451355E-09_JPRB, 0.22320466E-09_JPRB, &
  & 0.22187872E-09_JPRB, 0.22047381E-09_JPRB, 0.21878586E-09_JPRB, 0.21565646E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART3',1,ZHOOK_HANDLE)
END SUBROUTINE PART3




SUBROUTINE PART4
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART4',0,ZHOOK_HANDLE)



RGHG5(:,46, 2) = (/ &
  & 0.22208665E-09_JPRB, 0.22435000E-09_JPRB, 0.22571017E-09_JPRB, 0.22721586E-09_JPRB, 0.22889241E-09_JPRB, 0.23066277E-09_JPRB, &
  & 0.23223469E-09_JPRB, 0.23355104E-09_JPRB, 0.23461585E-09_JPRB, 0.23554197E-09_JPRB, 0.23641944E-09_JPRB, 0.23735214E-09_JPRB, &
  & 0.23852154E-09_JPRB, 0.24009902E-09_JPRB, 0.24252289E-09_JPRB, 0.24579050E-09_JPRB, 0.24939648E-09_JPRB, 0.25246130E-09_JPRB, &
  & 0.25470406E-09_JPRB, 0.25628658E-09_JPRB, 0.25741489E-09_JPRB, 0.25823915E-09_JPRB, 0.25886265E-09_JPRB, 0.25934613E-09_JPRB, &
  & 0.25973851E-09_JPRB, 0.26007102E-09_JPRB, 0.26036023E-09_JPRB, 0.26061830E-09_JPRB, 0.26083044E-09_JPRB, 0.26097538E-09_JPRB, &
  & 0.26103658E-09_JPRB, 0.26100544E-09_JPRB, 0.26087593E-09_JPRB, 0.26064700E-09_JPRB, 0.26033992E-09_JPRB, 0.25999014E-09_JPRB, &
  & 0.25962160E-09_JPRB, 0.25923438E-09_JPRB, 0.25880936E-09_JPRB, 0.25832148E-09_JPRB, 0.25773408E-09_JPRB, 0.25700914E-09_JPRB, &
  & 0.25609861E-09_JPRB, 0.25494587E-09_JPRB, 0.25350608E-09_JPRB, 0.25180649E-09_JPRB, 0.24994531E-09_JPRB, 0.24798141E-09_JPRB, &
  & 0.24590022E-09_JPRB, 0.24362595E-09_JPRB, 0.24121483E-09_JPRB, 0.23878385E-09_JPRB, 0.23667332E-09_JPRB, 0.23489810E-09_JPRB, &
  & 0.23348387E-09_JPRB, 0.23225720E-09_JPRB, 0.23113018E-09_JPRB, 0.23003943E-09_JPRB, 0.22895569E-09_JPRB, 0.22787883E-09_JPRB, &
  & 0.22679067E-09_JPRB, 0.22562924E-09_JPRB, 0.22420604E-09_JPRB, 0.22154022E-09_JPRB /)

RGHG5(:,47, 2) = (/ &
  & 0.22714465E-09_JPRB, 0.22916639E-09_JPRB, 0.23051000E-09_JPRB, 0.23185445E-09_JPRB, 0.23346713E-09_JPRB, 0.23515068E-09_JPRB, &
  & 0.23668453E-09_JPRB, 0.23794261E-09_JPRB, 0.23894431E-09_JPRB, 0.23978483E-09_JPRB, 0.24054581E-09_JPRB, 0.24135943E-09_JPRB, &
  & 0.24230870E-09_JPRB, 0.24368932E-09_JPRB, 0.24561686E-09_JPRB, 0.24838645E-09_JPRB, 0.25128899E-09_JPRB, 0.25373259E-09_JPRB, &
  & 0.25553040E-09_JPRB, 0.25683605E-09_JPRB, 0.25780089E-09_JPRB, 0.25854185E-09_JPRB, 0.25911345E-09_JPRB, 0.25957961E-09_JPRB, &
  & 0.25996200E-09_JPRB, 0.26028935E-09_JPRB, 0.26058272E-09_JPRB, 0.26083380E-09_JPRB, 0.26103616E-09_JPRB, 0.26116775E-09_JPRB, &
  & 0.26121363E-09_JPRB, 0.26117239E-09_JPRB, 0.26103841E-09_JPRB, 0.26081215E-09_JPRB, 0.26051236E-09_JPRB, 0.26017588E-09_JPRB, &
  & 0.25982555E-09_JPRB, 0.25945956E-09_JPRB, 0.25906374E-09_JPRB, 0.25861274E-09_JPRB, 0.25808072E-09_JPRB, 0.25743763E-09_JPRB, &
  & 0.25665259E-09_JPRB, 0.25568048E-09_JPRB, 0.25448205E-09_JPRB, 0.25306077E-09_JPRB, 0.25147381E-09_JPRB, 0.24978591E-09_JPRB, &
  & 0.24795571E-09_JPRB, 0.24595709E-09_JPRB, 0.24377703E-09_JPRB, 0.24167512E-09_JPRB, 0.23978525E-09_JPRB, 0.23831764E-09_JPRB, &
  & 0.23710089E-09_JPRB, 0.23607694E-09_JPRB, 0.23512872E-09_JPRB, 0.23420826E-09_JPRB, 0.23330710E-09_JPRB, 0.23241829E-09_JPRB, &
  & 0.23152455E-09_JPRB, 0.23056557E-09_JPRB, 0.22938385E-09_JPRB, 0.22714196E-09_JPRB /)

RGHG5(:,48, 2) = (/ &
  & 0.23185874E-09_JPRB, 0.23378344E-09_JPRB, 0.23498942E-09_JPRB, 0.23629254E-09_JPRB, 0.23780783E-09_JPRB, 0.23944174E-09_JPRB, &
  & 0.24094632E-09_JPRB, 0.24215410E-09_JPRB, 0.24309721E-09_JPRB, 0.24383762E-09_JPRB, 0.24450797E-09_JPRB, 0.24517002E-09_JPRB, &
  & 0.24598007E-09_JPRB, 0.24702124E-09_JPRB, 0.24861693E-09_JPRB, 0.25066160E-09_JPRB, 0.25291855E-09_JPRB, 0.25478536E-09_JPRB, &
  & 0.25620317E-09_JPRB, 0.25727898E-09_JPRB, 0.25811717E-09_JPRB, 0.25878633E-09_JPRB, 0.25933183E-09_JPRB, 0.25978136E-09_JPRB, &
  & 0.26016217E-09_JPRB, 0.26049538E-09_JPRB, 0.26078445E-09_JPRB, 0.26103517E-09_JPRB, 0.26122532E-09_JPRB, 0.26133987E-09_JPRB, &
  & 0.26137112E-09_JPRB, 0.26131880E-09_JPRB, 0.26117949E-09_JPRB, 0.26095276E-09_JPRB, 0.26065961E-09_JPRB, 0.26033398E-09_JPRB, &
  & 0.25999763E-09_JPRB, 0.25965044E-09_JPRB, 0.25927657E-09_JPRB, 0.25885796E-09_JPRB, 0.25837205E-09_JPRB, 0.25780261E-09_JPRB, &
  & 0.25713198E-09_JPRB, 0.25633617E-09_JPRB, 0.25538699E-09_JPRB, 0.25427277E-09_JPRB, 0.25301838E-09_JPRB, 0.25163022E-09_JPRB, &
  & 0.25010388E-09_JPRB, 0.24836883E-09_JPRB, 0.24649302E-09_JPRB, 0.24461863E-09_JPRB, 0.24305008E-09_JPRB, 0.24178037E-09_JPRB, &
  & 0.24078503E-09_JPRB, 0.23992086E-09_JPRB, 0.23912269E-09_JPRB, 0.23834826E-09_JPRB, 0.23758845E-09_JPRB, 0.23684826E-09_JPRB, &
  & 0.23610786E-09_JPRB, 0.23531266E-09_JPRB, 0.23432833E-09_JPRB, 0.23245127E-09_JPRB /)

RGHG5(:,49, 2) = (/ &
  & 0.23630897E-09_JPRB, 0.23810595E-09_JPRB, 0.23926386E-09_JPRB, 0.24049279E-09_JPRB, 0.24195851E-09_JPRB, 0.24356553E-09_JPRB, &
  & 0.24503538E-09_JPRB, 0.24619803E-09_JPRB, 0.24704416E-09_JPRB, 0.24769858E-09_JPRB, 0.24824456E-09_JPRB, 0.24878521E-09_JPRB, &
  & 0.24938629E-09_JPRB, 0.25017452E-09_JPRB, 0.25124328E-09_JPRB, 0.25269320E-09_JPRB, 0.25426075E-09_JPRB, 0.25564834E-09_JPRB, &
  & 0.25675181E-09_JPRB, 0.25763938E-09_JPRB, 0.25837388E-09_JPRB, 0.25899322E-09_JPRB, 0.25951602E-09_JPRB, 0.25996444E-09_JPRB, &
  & 0.26034869E-09_JPRB, 0.26068475E-09_JPRB, 0.26097843E-09_JPRB, 0.26122038E-09_JPRB, 0.26139665E-09_JPRB, 0.26149444E-09_JPRB, &
  & 0.26151054E-09_JPRB, 0.26144689E-09_JPRB, 0.26130087E-09_JPRB, 0.26107383E-09_JPRB, 0.26078528E-09_JPRB, 0.26046892E-09_JPRB, &
  & 0.26014479E-09_JPRB, 0.25981159E-09_JPRB, 0.25945682E-09_JPRB, 0.25906347E-09_JPRB, 0.25861802E-09_JPRB, 0.25811270E-09_JPRB, &
  & 0.25754746E-09_JPRB, 0.25691796E-09_JPRB, 0.25621813E-09_JPRB, 0.25543448E-09_JPRB, 0.25455241E-09_JPRB, 0.25354216E-09_JPRB, &
  & 0.25234750E-09_JPRB, 0.25093988E-09_JPRB, 0.24935481E-09_JPRB, 0.24778565E-09_JPRB, 0.24645755E-09_JPRB, 0.24541380E-09_JPRB, &
  & 0.24458496E-09_JPRB, 0.24386257E-09_JPRB, 0.24318361E-09_JPRB, 0.24251842E-09_JPRB, 0.24186628E-09_JPRB, 0.24123262E-09_JPRB, &
  & 0.24060248E-09_JPRB, 0.23992616E-09_JPRB, 0.23908825E-09_JPRB, 0.23749261E-09_JPRB /)

RGHG5(:,50, 2) = (/ &
  & 0.24047522E-09_JPRB, 0.24217836E-09_JPRB, 0.24326532E-09_JPRB, 0.24446317E-09_JPRB, 0.24590469E-09_JPRB, 0.24750804E-09_JPRB, &
  & 0.24893274E-09_JPRB, 0.25000185E-09_JPRB, 0.25072641E-09_JPRB, 0.25123945E-09_JPRB, 0.25164493E-09_JPRB, 0.25201607E-09_JPRB, &
  & 0.25239660E-09_JPRB, 0.25287442E-09_JPRB, 0.25347524E-09_JPRB, 0.25435362E-09_JPRB, 0.25536601E-09_JPRB, 0.25635050E-09_JPRB, &
  & 0.25720098E-09_JPRB, 0.25793806E-09_JPRB, 0.25858859E-09_JPRB, 0.25916752E-09_JPRB, 0.25968208E-09_JPRB, 0.26013097E-09_JPRB, &
  & 0.26052516E-09_JPRB, 0.26086688E-09_JPRB, 0.26115876E-09_JPRB, 0.26139088E-09_JPRB, 0.26155181E-09_JPRB, 0.26163161E-09_JPRB, &
  & 0.26163341E-09_JPRB, 0.26155889E-09_JPRB, 0.26140615E-09_JPRB, 0.26117764E-09_JPRB, 0.26089375E-09_JPRB, 0.26058544E-09_JPRB, &
  & 0.26027119E-09_JPRB, 0.25994998E-09_JPRB, 0.25960969E-09_JPRB, 0.25923802E-09_JPRB, 0.25882613E-09_JPRB, 0.25837787E-09_JPRB, &
  & 0.25790722E-09_JPRB, 0.25743191E-09_JPRB, 0.25696126E-09_JPRB, 0.25649557E-09_JPRB, 0.25598609E-09_JPRB, 0.25537333E-09_JPRB, &
  & 0.25457811E-09_JPRB, 0.25356134E-09_JPRB, 0.25234922E-09_JPRB, 0.25114380E-09_JPRB, 0.25007546E-09_JPRB, 0.24926664E-09_JPRB, &
  & 0.24857788E-09_JPRB, 0.24798100E-09_JPRB, 0.24739932E-09_JPRB, 0.24681246E-09_JPRB, 0.24623295E-09_JPRB, 0.24566801E-09_JPRB, &
  & 0.24510524E-09_JPRB, 0.24450200E-09_JPRB, 0.24375582E-09_JPRB, 0.24233615E-09_JPRB /)

RGHG5(:,51, 2) = (/ &
  & 0.24436203E-09_JPRB, 0.24590588E-09_JPRB, 0.24699384E-09_JPRB, 0.24812641E-09_JPRB, 0.24958541E-09_JPRB, 0.25112973E-09_JPRB, &
  & 0.25246424E-09_JPRB, 0.25331837E-09_JPRB, 0.25383923E-09_JPRB, 0.25416383E-09_JPRB, 0.25439301E-09_JPRB, 0.25457383E-09_JPRB, &
  & 0.25475341E-09_JPRB, 0.25493763E-09_JPRB, 0.25522862E-09_JPRB, 0.25562830E-09_JPRB, 0.25625368E-09_JPRB, 0.25692332E-09_JPRB, &
  & 0.25757929E-09_JPRB, 0.25819247E-09_JPRB, 0.25877508E-09_JPRB, 0.25932462E-09_JPRB, 0.25983179E-09_JPRB, 0.26029065E-09_JPRB, &
  & 0.26069172E-09_JPRB, 0.26104030E-09_JPRB, 0.26132535E-09_JPRB, 0.26154628E-09_JPRB, 0.26168884E-09_JPRB, 0.26175359E-09_JPRB, &
  & 0.26174191E-09_JPRB, 0.26165692E-09_JPRB, 0.26149735E-09_JPRB, 0.26126762E-09_JPRB, 0.26098787E-09_JPRB, 0.26068689E-09_JPRB, &
  & 0.26038138E-09_JPRB, 0.26006974E-09_JPRB, 0.25974189E-09_JPRB, 0.25938779E-09_JPRB, 0.25900557E-09_JPRB, 0.25860764E-09_JPRB, &
  & 0.25822344E-09_JPRB, 0.25788305E-09_JPRB, 0.25761313E-09_JPRB, 0.25739547E-09_JPRB, 0.25718749E-09_JPRB, 0.25690505E-09_JPRB, &
  & 0.25648961E-09_JPRB, 0.25589694E-09_JPRB, 0.25516278E-09_JPRB, 0.25436364E-09_JPRB, 0.25368435E-09_JPRB, 0.25308061E-09_JPRB, &
  & 0.25259753E-09_JPRB, 0.25212402E-09_JPRB, 0.25164529E-09_JPRB, 0.25114644E-09_JPRB, 0.25062930E-09_JPRB, 0.25011809E-09_JPRB, &
  & 0.24960375E-09_JPRB, 0.24904689E-09_JPRB, 0.24835134E-09_JPRB, 0.24704286E-09_JPRB /)

RGHG5(:,52, 2) = (/ &
  & 0.24778085E-09_JPRB, 0.24933011E-09_JPRB, 0.25025537E-09_JPRB, 0.25142680E-09_JPRB, 0.25274993E-09_JPRB, 0.25417929E-09_JPRB, &
  & 0.25516095E-09_JPRB, 0.25572341E-09_JPRB, 0.25600355E-09_JPRB, 0.25615648E-09_JPRB, 0.25624414E-09_JPRB, 0.25630276E-09_JPRB, &
  & 0.25634198E-09_JPRB, 0.25638724E-09_JPRB, 0.25644808E-09_JPRB, 0.25662736E-09_JPRB, 0.25693947E-09_JPRB, 0.25739963E-09_JPRB, &
  & 0.25790142E-09_JPRB, 0.25842281E-09_JPRB, 0.25894800E-09_JPRB, 0.25947269E-09_JPRB, 0.25997768E-09_JPRB, 0.26044061E-09_JPRB, &
  & 0.26085259E-09_JPRB, 0.26119829E-09_JPRB, 0.26147901E-09_JPRB, 0.26168270E-09_JPRB, 0.26181110E-09_JPRB, 0.26186142E-09_JPRB, &
  & 0.26183794E-09_JPRB, 0.26174285E-09_JPRB, 0.26157670E-09_JPRB, 0.26134572E-09_JPRB, 0.26106992E-09_JPRB, 0.26077604E-09_JPRB, &
  & 0.26047803E-09_JPRB, 0.26017527E-09_JPRB, 0.25985775E-09_JPRB, 0.25951982E-09_JPRB, 0.25916350E-09_JPRB, 0.25881292E-09_JPRB, &
  & 0.25850502E-09_JPRB, 0.25828428E-09_JPRB, 0.25816382E-09_JPRB, 0.25812155E-09_JPRB, 0.25809374E-09_JPRB, 0.25802180E-09_JPRB, &
  & 0.25786004E-09_JPRB, 0.25759406E-09_JPRB, 0.25723307E-09_JPRB, 0.25684480E-09_JPRB, 0.25646069E-09_JPRB, 0.25614863E-09_JPRB, &
  & 0.25583996E-09_JPRB, 0.25554461E-09_JPRB, 0.25521937E-09_JPRB, 0.25484814E-09_JPRB, 0.25445598E-09_JPRB, 0.25404870E-09_JPRB, &
  & 0.25362570E-09_JPRB, 0.25315730E-09_JPRB, 0.25255764E-09_JPRB, 0.25138269E-09_JPRB /)

RGHG5(:,53, 2) = (/ &
  & 0.25085739E-09_JPRB, 0.25212235E-09_JPRB, 0.25312871E-09_JPRB, 0.25406141E-09_JPRB, 0.25526783E-09_JPRB, 0.25626551E-09_JPRB, &
  & 0.25689109E-09_JPRB, 0.25716784E-09_JPRB, 0.25729296E-09_JPRB, 0.25734756E-09_JPRB, 0.25736985E-09_JPRB, 0.25737298E-09_JPRB, &
  & 0.25736185E-09_JPRB, 0.25734398E-09_JPRB, 0.25732377E-09_JPRB, 0.25734703E-09_JPRB, 0.25750668E-09_JPRB, 0.25779645E-09_JPRB, &
  & 0.25818964E-09_JPRB, 0.25863492E-09_JPRB, 0.25911914E-09_JPRB, 0.25962185E-09_JPRB, 0.26011995E-09_JPRB, 0.26058786E-09_JPRB, &
  & 0.26099847E-09_JPRB, 0.26134495E-09_JPRB, 0.26161326E-09_JPRB, 0.26180574E-09_JPRB, 0.26191882E-09_JPRB, 0.26195737E-09_JPRB, &
  & 0.26192348E-09_JPRB, 0.26181887E-09_JPRB, 0.26164615E-09_JPRB, 0.26141386E-09_JPRB, 0.26114216E-09_JPRB, 0.26085437E-09_JPRB, &
  & 0.26056404E-09_JPRB, 0.26026900E-09_JPRB, 0.25996244E-09_JPRB, 0.25963900E-09_JPRB, 0.25930944E-09_JPRB, 0.25900104E-09_JPRB, &
  & 0.25876515E-09_JPRB, 0.25863836E-09_JPRB, 0.25862709E-09_JPRB, 0.25868707E-09_JPRB, 0.25875388E-09_JPRB, 0.25878272E-09_JPRB, &
  & 0.25874952E-09_JPRB, 0.25865021E-09_JPRB, 0.25849625E-09_JPRB, 0.25831226E-09_JPRB, 0.25814156E-09_JPRB, 0.25797353E-09_JPRB, &
  & 0.25782457E-09_JPRB, 0.25766142E-09_JPRB, 0.25747454E-09_JPRB, 0.25726027E-09_JPRB, 0.25701410E-09_JPRB, 0.25675567E-09_JPRB, &
  & 0.25648125E-09_JPRB, 0.25616767E-09_JPRB, 0.25575386E-09_JPRB, 0.25488953E-09_JPRB /)

RGHG5(:,54, 2) = (/ &
  & 0.25327102E-09_JPRB, 0.25457286E-09_JPRB, 0.25527336E-09_JPRB, 0.25613772E-09_JPRB, 0.25693503E-09_JPRB, 0.25758537E-09_JPRB, &
  & 0.25789168E-09_JPRB, 0.25801955E-09_JPRB, 0.25806440E-09_JPRB, 0.25807784E-09_JPRB, 0.25807501E-09_JPRB, 0.25806093E-09_JPRB, &
  & 0.25803804E-09_JPRB, 0.25799768E-09_JPRB, 0.25795657E-09_JPRB, 0.25791574E-09_JPRB, 0.25795757E-09_JPRB, 0.25814462E-09_JPRB, &
  & 0.25844984E-09_JPRB, 0.25884161E-09_JPRB, 0.25928945E-09_JPRB, 0.25977442E-09_JPRB, 0.26026387E-09_JPRB, 0.26072558E-09_JPRB, &
  & 0.26113597E-09_JPRB, 0.26147451E-09_JPRB, 0.26173563E-09_JPRB, 0.26191443E-09_JPRB, 0.26201635E-09_JPRB, 0.26204353E-09_JPRB, &
  & 0.26199959E-09_JPRB, 0.26188673E-09_JPRB, 0.26170788E-09_JPRB, 0.26147459E-09_JPRB, 0.26120611E-09_JPRB, 0.26092484E-09_JPRB, &
  & 0.26064134E-09_JPRB, 0.26035490E-09_JPRB, 0.26005864E-09_JPRB, 0.25975244E-09_JPRB, 0.25944738E-09_JPRB, 0.25918312E-09_JPRB, &
  & 0.25900598E-09_JPRB, 0.25895516E-09_JPRB, 0.25901603E-09_JPRB, 0.25912864E-09_JPRB, 0.25924063E-09_JPRB, 0.25931057E-09_JPRB, &
  & 0.25933131E-09_JPRB, 0.25930355E-09_JPRB, 0.25923766E-09_JPRB, 0.25915398E-09_JPRB, 0.25906494E-09_JPRB, 0.25898683E-09_JPRB, &
  & 0.25890551E-09_JPRB, 0.25882096E-09_JPRB, 0.25872188E-09_JPRB, 0.25859892E-09_JPRB, 0.25846275E-09_JPRB, 0.25831651E-09_JPRB, &
  & 0.25816299E-09_JPRB, 0.25799693E-09_JPRB, 0.25779182E-09_JPRB, 0.25741229E-09_JPRB /)

RGHG5(:,55, 2) = (/ &
  & 0.25532307E-09_JPRB, 0.25629177E-09_JPRB, 0.25697625E-09_JPRB, 0.25750516E-09_JPRB, 0.25803110E-09_JPRB, 0.25836783E-09_JPRB, &
  & 0.25851749E-09_JPRB, 0.25856320E-09_JPRB, 0.25857461E-09_JPRB, 0.25857172E-09_JPRB, 0.25856123E-09_JPRB, 0.25854496E-09_JPRB, &
  & 0.25851857E-09_JPRB, 0.25848554E-09_JPRB, 0.25842589E-09_JPRB, 0.25837296E-09_JPRB, 0.25835123E-09_JPRB, 0.25845137E-09_JPRB, &
  & 0.25869404E-09_JPRB, 0.25904109E-09_JPRB, 0.25946320E-09_JPRB, 0.25992775E-09_JPRB, 0.26040553E-09_JPRB, 0.26085867E-09_JPRB, &
  & 0.26126157E-09_JPRB, 0.26159444E-09_JPRB, 0.26184527E-09_JPRB, 0.26201460E-09_JPRB, 0.26210484E-09_JPRB, 0.26212194E-09_JPRB, &
  & 0.26206864E-09_JPRB, 0.26194807E-09_JPRB, 0.26176447E-09_JPRB, 0.26152971E-09_JPRB, 0.26126512E-09_JPRB, 0.26098951E-09_JPRB, &
  & 0.26071306E-09_JPRB, 0.26043537E-09_JPRB, 0.26015137E-09_JPRB, 0.25986188E-09_JPRB, 0.25958583E-09_JPRB, 0.25935884E-09_JPRB, &
  & 0.25923513E-09_JPRB, 0.25923913E-09_JPRB, 0.25934180E-09_JPRB, 0.25948818E-09_JPRB, 0.25961361E-09_JPRB, 0.25969873E-09_JPRB, &
  & 0.25973940E-09_JPRB, 0.25974040E-09_JPRB, 0.25971320E-09_JPRB, 0.25967020E-09_JPRB, 0.25962638E-09_JPRB, 0.25958158E-09_JPRB, &
  & 0.25953945E-09_JPRB, 0.25949209E-09_JPRB, 0.25943464E-09_JPRB, 0.25936611E-09_JPRB, 0.25928451E-09_JPRB, 0.25919819E-09_JPRB, &
  & 0.25910785E-09_JPRB, 0.25900673E-09_JPRB, 0.25887881E-09_JPRB, 0.25860655E-09_JPRB /)

RGHG5(:,56, 2) = (/ &
  & 0.25680161E-09_JPRB, 0.25766572E-09_JPRB, 0.25807301E-09_JPRB, 0.25843117E-09_JPRB, 0.25871619E-09_JPRB, 0.25888558E-09_JPRB, &
  & 0.25894298E-09_JPRB, 0.25895514E-09_JPRB, 0.25895230E-09_JPRB, 0.25894392E-09_JPRB, 0.25893265E-09_JPRB, 0.25891661E-09_JPRB, &
  & 0.25889618E-09_JPRB, 0.25886110E-09_JPRB, 0.25881902E-09_JPRB, 0.25874353E-09_JPRB, 0.25869509E-09_JPRB, 0.25873817E-09_JPRB, &
  & 0.25892780E-09_JPRB, 0.25923960E-09_JPRB, 0.25963509E-09_JPRB, 0.26008309E-09_JPRB, 0.26054336E-09_JPRB, 0.26098701E-09_JPRB, &
  & 0.26138056E-09_JPRB, 0.26170499E-09_JPRB, 0.26194769E-09_JPRB, 0.26210617E-09_JPRB, 0.26218691E-09_JPRB, 0.26219443E-09_JPRB, &
  & 0.26213259E-09_JPRB, 0.26200492E-09_JPRB, 0.26181729E-09_JPRB, 0.26158270E-09_JPRB, 0.26132135E-09_JPRB, 0.26105118E-09_JPRB, &
  & 0.26078256E-09_JPRB, 0.26051378E-09_JPRB, 0.26024280E-09_JPRB, 0.25997313E-09_JPRB, 0.25972310E-09_JPRB, 0.25953459E-09_JPRB, &
  & 0.25945129E-09_JPRB, 0.25949326E-09_JPRB, 0.25962804E-09_JPRB, 0.25978372E-09_JPRB, 0.25991770E-09_JPRB, 0.26000460E-09_JPRB, &
  & 0.26004976E-09_JPRB, 0.26006131E-09_JPRB, 0.26005037E-09_JPRB, 0.26002800E-09_JPRB, 0.26000160E-09_JPRB, 0.25997693E-09_JPRB, &
  & 0.25995067E-09_JPRB, 0.25992197E-09_JPRB, 0.25988744E-09_JPRB, 0.25984292E-09_JPRB, 0.25979263E-09_JPRB, 0.25973843E-09_JPRB, &
  & 0.25968275E-09_JPRB, 0.25962626E-09_JPRB, 0.25956276E-09_JPRB, 0.25946451E-09_JPRB /)

RGHG5(:,57, 2) = (/ &
  & 0.25794861E-09_JPRB, 0.25854277E-09_JPRB, 0.25883376E-09_JPRB, 0.25903543E-09_JPRB, 0.25917901E-09_JPRB, 0.25925298E-09_JPRB, &
  & 0.25926997E-09_JPRB, 0.25926650E-09_JPRB, 0.25925834E-09_JPRB, 0.25924929E-09_JPRB, 0.25923852E-09_JPRB, 0.25922581E-09_JPRB, &
  & 0.25920693E-09_JPRB, 0.25918229E-09_JPRB, 0.25913510E-09_JPRB, 0.25907854E-09_JPRB, 0.25900221E-09_JPRB, 0.25900673E-09_JPRB, &
  & 0.25915664E-09_JPRB, 0.25943669E-09_JPRB, 0.25980912E-09_JPRB, 0.26023500E-09_JPRB, 0.26068264E-09_JPRB, 0.26111036E-09_JPRB, &
  & 0.26149527E-09_JPRB, 0.26180991E-09_JPRB, 0.26204242E-09_JPRB, 0.26219221E-09_JPRB, 0.26226313E-09_JPRB, 0.26226221E-09_JPRB, &
  & 0.26219293E-09_JPRB, 0.26205951E-09_JPRB, 0.26186911E-09_JPRB, 0.26163507E-09_JPRB, 0.26137723E-09_JPRB, 0.26111360E-09_JPRB, &
  & 0.26085178E-09_JPRB, 0.26059374E-09_JPRB, 0.26033631E-09_JPRB, 0.26008601E-09_JPRB, 0.25986421E-09_JPRB, 0.25970698E-09_JPRB, &
  & 0.25965724E-09_JPRB, 0.25972768E-09_JPRB, 0.25987490E-09_JPRB, 0.26004393E-09_JPRB, 0.26017410E-09_JPRB, 0.26025940E-09_JPRB, &
  & 0.26030314E-09_JPRB, 0.26031721E-09_JPRB, 0.26031283E-09_JPRB, 0.26029884E-09_JPRB, 0.26028268E-09_JPRB, 0.26026539E-09_JPRB, &
  & 0.26024835E-09_JPRB, 0.26022881E-09_JPRB, 0.26020430E-09_JPRB, 0.26017444E-09_JPRB, 0.26013816E-09_JPRB, 0.26009961E-09_JPRB, &
  & 0.26006003E-09_JPRB, 0.26001720E-09_JPRB, 0.25996816E-09_JPRB, 0.25987809E-09_JPRB /)

RGHG5(:,58, 2) = (/ &
  & 0.25875613E-09_JPRB, 0.25917363E-09_JPRB, 0.25934560E-09_JPRB, 0.25945004E-09_JPRB, 0.25952185E-09_JPRB, 0.25954527E-09_JPRB, &
  & 0.25954253E-09_JPRB, 0.25953273E-09_JPRB, 0.25952390E-09_JPRB, 0.25951519E-09_JPRB, 0.25950656E-09_JPRB, 0.25949554E-09_JPRB, &
  & 0.25948160E-09_JPRB, 0.25945762E-09_JPRB, 0.25942443E-09_JPRB, 0.25935870E-09_JPRB, 0.25928817E-09_JPRB, 0.25926566E-09_JPRB, &
  & 0.25938263E-09_JPRB, 0.25963498E-09_JPRB, 0.25998251E-09_JPRB, 0.26039060E-09_JPRB, 0.26081826E-09_JPRB, 0.26123526E-09_JPRB, &
  & 0.26160596E-09_JPRB, 0.26190972E-09_JPRB, 0.26213265E-09_JPRB, 0.26227204E-09_JPRB, 0.26233474E-09_JPRB, 0.26232630E-09_JPRB, &
  & 0.26225136E-09_JPRB, 0.26211394E-09_JPRB, 0.26192137E-09_JPRB, 0.26168903E-09_JPRB, 0.26143543E-09_JPRB, 0.26117747E-09_JPRB, &
  & 0.26092492E-09_JPRB, 0.26067654E-09_JPRB, 0.26043381E-09_JPRB, 0.26020347E-09_JPRB, 0.26000663E-09_JPRB, 0.25987879E-09_JPRB, &
  & 0.25985469E-09_JPRB, 0.25994162E-09_JPRB, 0.26010294E-09_JPRB, 0.26026978E-09_JPRB, 0.26040148E-09_JPRB, 0.26048125E-09_JPRB, &
  & 0.26052099E-09_JPRB, 0.26053393E-09_JPRB, 0.26053107E-09_JPRB, 0.26052091E-09_JPRB, 0.26050795E-09_JPRB, 0.26049535E-09_JPRB, &
  & 0.26048172E-09_JPRB, 0.26046637E-09_JPRB, 0.26044775E-09_JPRB, 0.26042346E-09_JPRB, 0.26039565E-09_JPRB, 0.26036540E-09_JPRB, &
  & 0.26033367E-09_JPRB, 0.26030114E-09_JPRB, 0.26026198E-09_JPRB, 0.26019625E-09_JPRB /)

RGHG5(:,59, 2) = (/ &
  & 0.25935620E-09_JPRB, 0.25962532E-09_JPRB, 0.25971650E-09_JPRB, 0.25977054E-09_JPRB, 0.25979499E-09_JPRB, 0.25979541E-09_JPRB, &
  & 0.25978400E-09_JPRB, 0.25977301E-09_JPRB, 0.25976410E-09_JPRB, 0.25975702E-09_JPRB, 0.25974972E-09_JPRB, 0.25974148E-09_JPRB, &
  & 0.25972910E-09_JPRB, 0.25971131E-09_JPRB, 0.25967653E-09_JPRB, 0.25962471E-09_JPRB, 0.25954494E-09_JPRB, 0.25951319E-09_JPRB, &
  & 0.25960767E-09_JPRB, 0.25983457E-09_JPRB, 0.26015973E-09_JPRB, 0.26054583E-09_JPRB, 0.26095814E-09_JPRB, 0.26135744E-09_JPRB, &
  & 0.26171518E-09_JPRB, 0.26200592E-09_JPRB, 0.26221686E-09_JPRB, 0.26234748E-09_JPRB, 0.26240199E-09_JPRB, 0.26238767E-09_JPRB, &
  & 0.26230862E-09_JPRB, 0.26216909E-09_JPRB, 0.26197661E-09_JPRB, 0.26174601E-09_JPRB, 0.26149699E-09_JPRB, 0.26124666E-09_JPRB, &
  & 0.26100183E-09_JPRB, 0.26076497E-09_JPRB, 0.26053629E-09_JPRB, 0.26032476E-09_JPRB, 0.26015193E-09_JPRB, 0.26004859E-09_JPRB, &
  & 0.26004471E-09_JPRB, 0.26014488E-09_JPRB, 0.26030744E-09_JPRB, 0.26047919E-09_JPRB, 0.26060476E-09_JPRB, 0.26068098E-09_JPRB, &
  & 0.26071573E-09_JPRB, 0.26072594E-09_JPRB, 0.26072225E-09_JPRB, 0.26071229E-09_JPRB, 0.26070091E-09_JPRB, 0.26068897E-09_JPRB, &
  & 0.26067709E-09_JPRB, 0.26066355E-09_JPRB, 0.26064670E-09_JPRB, 0.26062641E-09_JPRB, 0.26060218E-09_JPRB, 0.26057642E-09_JPRB, &
  & 0.26055014E-09_JPRB, 0.26052158E-09_JPRB, 0.26048935E-09_JPRB, 0.26042893E-09_JPRB /)

RGHG5(:,60, 2) = (/ &
  & 0.25991265E-09_JPRB, 0.25998176E-09_JPRB, 0.26001404E-09_JPRB, 0.26002930E-09_JPRB, 0.26003252E-09_JPRB, 0.26002195E-09_JPRB, &
  & 0.26000724E-09_JPRB, 0.25999572E-09_JPRB, 0.25998811E-09_JPRB, 0.25998220E-09_JPRB, 0.25997704E-09_JPRB, 0.25997057E-09_JPRB, &
  & 0.25996161E-09_JPRB, 0.25994501E-09_JPRB, 0.25991720E-09_JPRB, 0.25986180E-09_JPRB, 0.25978866E-09_JPRB, 0.25975194E-09_JPRB, &
  & 0.25983099E-09_JPRB, 0.26003691E-09_JPRB, 0.26033933E-09_JPRB, 0.26070568E-09_JPRB, 0.26109814E-09_JPRB, 0.26148109E-09_JPRB, &
  & 0.26182198E-09_JPRB, 0.26209773E-09_JPRB, 0.26229713E-09_JPRB, 0.26241764E-09_JPRB, 0.26246536E-09_JPRB, 0.26244662E-09_JPRB, &
  & 0.26236563E-09_JPRB, 0.26222607E-09_JPRB, 0.26203509E-09_JPRB, 0.26180794E-09_JPRB, 0.26156449E-09_JPRB, 0.26132088E-09_JPRB, &
  & 0.26108532E-09_JPRB, 0.26085892E-09_JPRB, 0.26064417E-09_JPRB, 0.26045055E-09_JPRB, 0.26029875E-09_JPRB, 0.26021704E-09_JPRB, &
  & 0.26022950E-09_JPRB, 0.26033667E-09_JPRB, 0.26050220E-09_JPRB, 0.26066818E-09_JPRB, 0.26079347E-09_JPRB, 0.26086414E-09_JPRB, &
  & 0.26089481E-09_JPRB, 0.26090149E-09_JPRB, 0.26089542E-09_JPRB, 0.26088456E-09_JPRB, 0.26087210E-09_JPRB, 0.26086033E-09_JPRB, &
  & 0.26084801E-09_JPRB, 0.26083441E-09_JPRB, 0.26081837E-09_JPRB, 0.26079849E-09_JPRB, 0.26077643E-09_JPRB, 0.26075306E-09_JPRB, &
  & 0.26072894E-09_JPRB, 0.26070479E-09_JPRB, 0.26067595E-09_JPRB, 0.26062849E-09_JPRB /)

RGHG5(:,61, 2) = (/ &
  & 0.26018276E-09_JPRB, 0.26023267E-09_JPRB, 0.26024766E-09_JPRB, 0.26025196E-09_JPRB, 0.26024705E-09_JPRB, 0.26023250E-09_JPRB, &
  & 0.26021738E-09_JPRB, 0.26020666E-09_JPRB, 0.26020003E-09_JPRB, 0.26019603E-09_JPRB, 0.26019276E-09_JPRB, 0.26018912E-09_JPRB, &
  & 0.26018243E-09_JPRB, 0.26016977E-09_JPRB, 0.26014152E-09_JPRB, 0.26009059E-09_JPRB, 0.26001845E-09_JPRB, 0.25998473E-09_JPRB, &
  & 0.26005401E-09_JPRB, 0.26024136E-09_JPRB, 0.26052277E-09_JPRB, 0.26086866E-09_JPRB, 0.26124072E-09_JPRB, 0.26160421E-09_JPRB, &
  & 0.26192667E-09_JPRB, 0.26218649E-09_JPRB, 0.26237240E-09_JPRB, 0.26248359E-09_JPRB, 0.26252511E-09_JPRB, 0.26250355E-09_JPRB, &
  & 0.26242258E-09_JPRB, 0.26228528E-09_JPRB, 0.26209815E-09_JPRB, 0.26187569E-09_JPRB, 0.26163841E-09_JPRB, 0.26140218E-09_JPRB, &
  & 0.26117519E-09_JPRB, 0.26095900E-09_JPRB, 0.26075733E-09_JPRB, 0.26057989E-09_JPRB, 0.26044722E-09_JPRB, 0.26038413E-09_JPRB, &
  & 0.26040986E-09_JPRB, 0.26052205E-09_JPRB, 0.26068472E-09_JPRB, 0.26084823E-09_JPRB, 0.26096797E-09_JPRB, 0.26103641E-09_JPRB, &
  & 0.26106292E-09_JPRB, 0.26106595E-09_JPRB, 0.26105687E-09_JPRB, 0.26104321E-09_JPRB, 0.26102942E-09_JPRB, 0.26101571E-09_JPRB, &
  & 0.26100233E-09_JPRB, 0.26098768E-09_JPRB, 0.26097041E-09_JPRB, 0.26095065E-09_JPRB, 0.26092856E-09_JPRB, 0.26090591E-09_JPRB, &
  & 0.26088337E-09_JPRB, 0.26085967E-09_JPRB, 0.26083383E-09_JPRB, 0.26078720E-09_JPRB /)

RGHG5(:,62, 2) = (/ &
  & 0.26041425E-09_JPRB, 0.26044650E-09_JPRB, 0.26045466E-09_JPRB, 0.26045405E-09_JPRB, 0.26044639E-09_JPRB, 0.26043279E-09_JPRB, &
  & 0.26041785E-09_JPRB, 0.26040764E-09_JPRB, 0.26040245E-09_JPRB, 0.26040037E-09_JPRB, 0.26040003E-09_JPRB, 0.26039979E-09_JPRB, &
  & 0.26039718E-09_JPRB, 0.26038682E-09_JPRB, 0.26036132E-09_JPRB, 0.26030916E-09_JPRB, 0.26024308E-09_JPRB, 0.26021399E-09_JPRB, &
  & 0.26027649E-09_JPRB, 0.26044800E-09_JPRB, 0.26070995E-09_JPRB, 0.26103458E-09_JPRB, 0.26138550E-09_JPRB, 0.26172692E-09_JPRB, &
  & 0.26202968E-09_JPRB, 0.26227154E-09_JPRB, 0.26244384E-09_JPRB, 0.26254526E-09_JPRB, 0.26258154E-09_JPRB, 0.26255861E-09_JPRB, &
  & 0.26247965E-09_JPRB, 0.26234701E-09_JPRB, 0.26216568E-09_JPRB, 0.26195021E-09_JPRB, 0.26171942E-09_JPRB, 0.26149125E-09_JPRB, &
  & 0.26127173E-09_JPRB, 0.26106553E-09_JPRB, 0.26087535E-09_JPRB, 0.26071306E-09_JPRB, 0.26059707E-09_JPRB, 0.26055014E-09_JPRB, &
  & 0.26058677E-09_JPRB, 0.26070207E-09_JPRB, 0.26086122E-09_JPRB, 0.26101760E-09_JPRB, 0.26113428E-09_JPRB, 0.26119912E-09_JPRB, &
  & 0.26122321E-09_JPRB, 0.26122271E-09_JPRB, 0.26121000E-09_JPRB, 0.26119357E-09_JPRB, 0.26117658E-09_JPRB, 0.26116093E-09_JPRB, &
  & 0.26114511E-09_JPRB, 0.26112829E-09_JPRB, 0.26110950E-09_JPRB, 0.26108793E-09_JPRB, 0.26106528E-09_JPRB, 0.26104230E-09_JPRB, &
  & 0.26101932E-09_JPRB, 0.26099684E-09_JPRB, 0.26097088E-09_JPRB, 0.26092839E-09_JPRB /)

RGHG5(:,63, 2) = (/ &
  & 0.26061164E-09_JPRB, 0.26063901E-09_JPRB, 0.26064476E-09_JPRB, 0.26064334E-09_JPRB, 0.26063657E-09_JPRB, 0.26062399E-09_JPRB, &
  & 0.26061056E-09_JPRB, 0.26060087E-09_JPRB, 0.26059685E-09_JPRB, 0.26059732E-09_JPRB, 0.26060104E-09_JPRB, 0.26060568E-09_JPRB, &
  & 0.26060809E-09_JPRB, 0.26060129E-09_JPRB, 0.26057512E-09_JPRB, 0.26052496E-09_JPRB, 0.26046557E-09_JPRB, 0.26044150E-09_JPRB, &
  & 0.26049937E-09_JPRB, 0.26065702E-09_JPRB, 0.26090025E-09_JPRB, 0.26120375E-09_JPRB, 0.26153082E-09_JPRB, 0.26184982E-09_JPRB, &
  & 0.26212993E-09_JPRB, 0.26235350E-09_JPRB, 0.26251123E-09_JPRB, 0.26260305E-09_JPRB, 0.26263464E-09_JPRB, 0.26261160E-09_JPRB, &
  & 0.26253649E-09_JPRB, 0.26241037E-09_JPRB, 0.26223756E-09_JPRB, 0.26203031E-09_JPRB, 0.26180857E-09_JPRB, 0.26158703E-09_JPRB, &
  & 0.26137623E-09_JPRB, 0.26117797E-09_JPRB, 0.26099928E-09_JPRB, 0.26085012E-09_JPRB, 0.26074903E-09_JPRB, 0.26071589E-09_JPRB, &
  & 0.26076133E-09_JPRB, 0.26087785E-09_JPRB, 0.26103197E-09_JPRB, 0.26118147E-09_JPRB, 0.26129227E-09_JPRB, 0.26135513E-09_JPRB, &
  & 0.26137711E-09_JPRB, 0.26137387E-09_JPRB, 0.26135799E-09_JPRB, 0.26133773E-09_JPRB, 0.26131788E-09_JPRB, 0.26129870E-09_JPRB, &
  & 0.26128011E-09_JPRB, 0.26126046E-09_JPRB, 0.26123853E-09_JPRB, 0.26121499E-09_JPRB, 0.26119054E-09_JPRB, 0.26116626E-09_JPRB, &
  & 0.26114272E-09_JPRB, 0.26111874E-09_JPRB, 0.26109273E-09_JPRB, 0.26104785E-09_JPRB /)

RGHG5(:,64, 2) = (/ &
  & 0.26079183E-09_JPRB, 0.26081759E-09_JPRB, 0.26082375E-09_JPRB, 0.26082328E-09_JPRB, 0.26081792E-09_JPRB, 0.26080799E-09_JPRB, &
  & 0.26079591E-09_JPRB, 0.26078734E-09_JPRB, 0.26078464E-09_JPRB, 0.26078811E-09_JPRB, 0.26079647E-09_JPRB, 0.26080776E-09_JPRB, &
  & 0.26081509E-09_JPRB, 0.26081015E-09_JPRB, 0.26078484E-09_JPRB, 0.26073765E-09_JPRB, 0.26068542E-09_JPRB, 0.26066627E-09_JPRB, &
  & 0.26072072E-09_JPRB, 0.26086644E-09_JPRB, 0.26109193E-09_JPRB, 0.26137273E-09_JPRB, 0.26167618E-09_JPRB, 0.26196922E-09_JPRB, &
  & 0.26222682E-09_JPRB, 0.26243058E-09_JPRB, 0.26257374E-09_JPRB, 0.26265609E-09_JPRB, 0.26268360E-09_JPRB, 0.26266134E-09_JPRB, &
  & 0.26259120E-09_JPRB, 0.26247343E-09_JPRB, 0.26231076E-09_JPRB, 0.26211494E-09_JPRB, 0.26190200E-09_JPRB, 0.26169020E-09_JPRB, &
  & 0.26148594E-09_JPRB, 0.26129696E-09_JPRB, 0.26112779E-09_JPRB, 0.26099103E-09_JPRB, 0.26090283E-09_JPRB, 0.26088123E-09_JPRB, &
  & 0.26093322E-09_JPRB, 0.26104935E-09_JPRB, 0.26119737E-09_JPRB, 0.26133842E-09_JPRB, 0.26144376E-09_JPRB, 0.26150351E-09_JPRB, &
  & 0.26152450E-09_JPRB, 0.26151947E-09_JPRB, 0.26150082E-09_JPRB, 0.26147748E-09_JPRB, 0.26145375E-09_JPRB, 0.26143132E-09_JPRB, &
  & 0.26140892E-09_JPRB, 0.26138544E-09_JPRB, 0.26136046E-09_JPRB, 0.26133379E-09_JPRB, 0.26130703E-09_JPRB, 0.26128083E-09_JPRB, &
  & 0.26125507E-09_JPRB, 0.26122970E-09_JPRB, 0.26120087E-09_JPRB, 0.26115274E-09_JPRB /)

RGHG5(:,65, 2) = (/ &
  & 0.26095698E-09_JPRB, 0.26098562E-09_JPRB, 0.26099362E-09_JPRB, 0.26099511E-09_JPRB, 0.26099206E-09_JPRB, 0.26098451E-09_JPRB, &
  & 0.26097502E-09_JPRB, 0.26096780E-09_JPRB, 0.26096728E-09_JPRB, 0.26097458E-09_JPRB, 0.26098843E-09_JPRB, 0.26100513E-09_JPRB, &
  & 0.26101624E-09_JPRB, 0.26101293E-09_JPRB, 0.26098934E-09_JPRB, 0.26094660E-09_JPRB, 0.26090122E-09_JPRB, 0.26088681E-09_JPRB, &
  & 0.26093938E-09_JPRB, 0.26107411E-09_JPRB, 0.26128189E-09_JPRB, 0.26154018E-09_JPRB, 0.26181718E-09_JPRB, 0.26208466E-09_JPRB, &
  & 0.26231775E-09_JPRB, 0.26250202E-09_JPRB, 0.26263036E-09_JPRB, 0.26270361E-09_JPRB, 0.26272748E-09_JPRB, 0.26270641E-09_JPRB, &
  & 0.26264191E-09_JPRB, 0.26253330E-09_JPRB, 0.26238275E-09_JPRB, 0.26219946E-09_JPRB, 0.26199851E-09_JPRB, 0.26179564E-09_JPRB, &
  & 0.26160099E-09_JPRB, 0.26142000E-09_JPRB, 0.26126107E-09_JPRB, 0.26113525E-09_JPRB, 0.26105848E-09_JPRB, 0.26104610E-09_JPRB, &
  & 0.26110233E-09_JPRB, 0.26121624E-09_JPRB, 0.26135699E-09_JPRB, 0.26148944E-09_JPRB, 0.26158803E-09_JPRB, 0.26164496E-09_JPRB, &
  & 0.26166480E-09_JPRB, 0.26165900E-09_JPRB, 0.26163860E-09_JPRB, 0.26161256E-09_JPRB, 0.26158584E-09_JPRB, 0.26155944E-09_JPRB, &
  & 0.26153330E-09_JPRB, 0.26150609E-09_JPRB, 0.26147698E-09_JPRB, 0.26144745E-09_JPRB, 0.26141797E-09_JPRB, 0.26138908E-09_JPRB, &
  & 0.26136091E-09_JPRB, 0.26133173E-09_JPRB, 0.26129898E-09_JPRB, 0.26124200E-09_JPRB /)

RGHG5(:,66, 2) = (/ &
  & 0.26111069E-09_JPRB, 0.26114438E-09_JPRB, 0.26115565E-09_JPRB, 0.26115990E-09_JPRB, 0.26115946E-09_JPRB, 0.26115482E-09_JPRB, &
  & 0.26114788E-09_JPRB, 0.26114358E-09_JPRB, 0.26114627E-09_JPRB, 0.26115735E-09_JPRB, 0.26117675E-09_JPRB, 0.26119715E-09_JPRB, &
  & 0.26121055E-09_JPRB, 0.26120892E-09_JPRB, 0.26118807E-09_JPRB, 0.26115024E-09_JPRB, 0.26111155E-09_JPRB, 0.26110195E-09_JPRB, &
  & 0.26115266E-09_JPRB, 0.26127733E-09_JPRB, 0.26146732E-09_JPRB, 0.26170172E-09_JPRB, 0.26195254E-09_JPRB, 0.26219291E-09_JPRB, &
  & 0.26240227E-09_JPRB, 0.26256672E-09_JPRB, 0.26268077E-09_JPRB, 0.26274535E-09_JPRB, 0.26276581E-09_JPRB, 0.26274613E-09_JPRB, &
  & 0.26268743E-09_JPRB, 0.26258851E-09_JPRB, 0.26245059E-09_JPRB, 0.26228142E-09_JPRB, 0.26209326E-09_JPRB, 0.26190256E-09_JPRB, &
  & 0.26171731E-09_JPRB, 0.26154645E-09_JPRB, 0.26139746E-09_JPRB, 0.26128233E-09_JPRB, 0.26121549E-09_JPRB, 0.26121041E-09_JPRB, &
  & 0.26126867E-09_JPRB, 0.26137836E-09_JPRB, 0.26151079E-09_JPRB, 0.26163424E-09_JPRB, 0.26172603E-09_JPRB, 0.26177918E-09_JPRB, &
  & 0.26179797E-09_JPRB, 0.26179178E-09_JPRB, 0.26177083E-09_JPRB, 0.26174304E-09_JPRB, 0.26171385E-09_JPRB, 0.26168462E-09_JPRB, &
  & 0.26165486E-09_JPRB, 0.26162367E-09_JPRB, 0.26159164E-09_JPRB, 0.26155855E-09_JPRB, 0.26152647E-09_JPRB, 0.26149496E-09_JPRB, &
  & 0.26146299E-09_JPRB, 0.26143010E-09_JPRB, 0.26139024E-09_JPRB, 0.26132094E-09_JPRB /)

RGHG5(:,67, 2) = (/ &
  & 0.26125746E-09_JPRB, 0.26129704E-09_JPRB, 0.26131142E-09_JPRB, 0.26131872E-09_JPRB, 0.26132121E-09_JPRB, 0.26131966E-09_JPRB, &
  & 0.26131597E-09_JPRB, 0.26131497E-09_JPRB, 0.26132121E-09_JPRB, 0.26133729E-09_JPRB, 0.26135982E-09_JPRB, 0.26138297E-09_JPRB, &
  & 0.26139776E-09_JPRB, 0.26139807E-09_JPRB, 0.26138022E-09_JPRB, 0.26134742E-09_JPRB, 0.26131508E-09_JPRB, 0.26130959E-09_JPRB, &
  & 0.26135835E-09_JPRB, 0.26147240E-09_JPRB, 0.26164440E-09_JPRB, 0.26185515E-09_JPRB, 0.26207925E-09_JPRB, 0.26229352E-09_JPRB, &
  & 0.26247932E-09_JPRB, 0.26262503E-09_JPRB, 0.26272523E-09_JPRB, 0.26278185E-09_JPRB, 0.26279912E-09_JPRB, 0.26278088E-09_JPRB, &
  & 0.26272773E-09_JPRB, 0.26263833E-09_JPRB, 0.26251337E-09_JPRB, 0.26235850E-09_JPRB, 0.26218508E-09_JPRB, 0.26200705E-09_JPRB, &
  & 0.26183380E-09_JPRB, 0.26167365E-09_JPRB, 0.26153560E-09_JPRB, 0.26143093E-09_JPRB, 0.26137323E-09_JPRB, 0.26137351E-09_JPRB, &
  & 0.26143188E-09_JPRB, 0.26153579E-09_JPRB, 0.26165911E-09_JPRB, 0.26177271E-09_JPRB, 0.26185781E-09_JPRB, 0.26190691E-09_JPRB, &
  & 0.26192415E-09_JPRB, 0.26191785E-09_JPRB, 0.26189664E-09_JPRB, 0.26186855E-09_JPRB, 0.26183805E-09_JPRB, 0.26180666E-09_JPRB, &
  & 0.26177441E-09_JPRB, 0.26174080E-09_JPRB, 0.26170532E-09_JPRB, 0.26167030E-09_JPRB, 0.26163560E-09_JPRB, 0.26160130E-09_JPRB, &
  & 0.26156646E-09_JPRB, 0.26152733E-09_JPRB, 0.26147953E-09_JPRB, 0.26139002E-09_JPRB /)

RGHG5(:,68, 2) = (/ &
  & 0.26139180E-09_JPRB, 0.26144059E-09_JPRB, 0.26146052E-09_JPRB, 0.26147179E-09_JPRB, 0.26147795E-09_JPRB, 0.26147987E-09_JPRB, &
  & 0.26147981E-09_JPRB, 0.26148256E-09_JPRB, 0.26149299E-09_JPRB, 0.26151240E-09_JPRB, 0.26153774E-09_JPRB, 0.26156208E-09_JPRB, &
  & 0.26157779E-09_JPRB, 0.26157962E-09_JPRB, 0.26156480E-09_JPRB, 0.26153676E-09_JPRB, 0.26151004E-09_JPRB, 0.26150762E-09_JPRB, &
  & 0.26155317E-09_JPRB, 0.26165636E-09_JPRB, 0.26181032E-09_JPRB, 0.26199778E-09_JPRB, 0.26219651E-09_JPRB, 0.26238567E-09_JPRB, &
  & 0.26254959E-09_JPRB, 0.26267721E-09_JPRB, 0.26276487E-09_JPRB, 0.26281374E-09_JPRB, 0.26282815E-09_JPRB, 0.26281130E-09_JPRB, &
  & 0.26276342E-09_JPRB, 0.26268321E-09_JPRB, 0.26257094E-09_JPRB, 0.26243074E-09_JPRB, 0.26227229E-09_JPRB, 0.26210858E-09_JPRB, &
  & 0.26194794E-09_JPRB, 0.26180003E-09_JPRB, 0.26167341E-09_JPRB, 0.26157931E-09_JPRB, 0.26152996E-09_JPRB, 0.26153446E-09_JPRB, &
  & 0.26159150E-09_JPRB, 0.26168856E-09_JPRB, 0.26180133E-09_JPRB, 0.26190597E-09_JPRB, 0.26198319E-09_JPRB, 0.26202840E-09_JPRB, &
  & 0.26204400E-09_JPRB, 0.26203748E-09_JPRB, 0.26201680E-09_JPRB, 0.26198879E-09_JPRB, 0.26195821E-09_JPRB, 0.26192609E-09_JPRB, &
  & 0.26189262E-09_JPRB, 0.26185709E-09_JPRB, 0.26182065E-09_JPRB, 0.26178337E-09_JPRB, 0.26174751E-09_JPRB, 0.26171151E-09_JPRB, &
  & 0.26167338E-09_JPRB, 0.26163022E-09_JPRB, 0.26157071E-09_JPRB, 0.26145883E-09_JPRB /)

RGHG5(:,69, 2) = (/ &
  & 0.26151972E-09_JPRB, 0.26158015E-09_JPRB, 0.26160529E-09_JPRB, 0.26162122E-09_JPRB, 0.26163122E-09_JPRB, 0.26163693E-09_JPRB, &
  & 0.26164060E-09_JPRB, 0.26164737E-09_JPRB, 0.26166155E-09_JPRB, 0.26168356E-09_JPRB, 0.26170999E-09_JPRB, 0.26173463E-09_JPRB, &
  & 0.26175059E-09_JPRB, 0.26175359E-09_JPRB, 0.26174121E-09_JPRB, 0.26171751E-09_JPRB, 0.26169503E-09_JPRB, 0.26169444E-09_JPRB, &
  & 0.26173574E-09_JPRB, 0.26182764E-09_JPRB, 0.26196406E-09_JPRB, 0.26212946E-09_JPRB, 0.26230393E-09_JPRB, 0.26247002E-09_JPRB, &
  & 0.26261307E-09_JPRB, 0.26272434E-09_JPRB, 0.26279995E-09_JPRB, 0.26284197E-09_JPRB, 0.26285377E-09_JPRB, 0.26283814E-09_JPRB, &
  & 0.26279554E-09_JPRB, 0.26272401E-09_JPRB, 0.26262426E-09_JPRB, 0.26249855E-09_JPRB, 0.26235539E-09_JPRB, 0.26220623E-09_JPRB, &
  & 0.26205943E-09_JPRB, 0.26192426E-09_JPRB, 0.26180969E-09_JPRB, 0.26172611E-09_JPRB, 0.26168467E-09_JPRB, 0.26169228E-09_JPRB, &
  & 0.26174710E-09_JPRB, 0.26183627E-09_JPRB, 0.26193911E-09_JPRB, 0.26203312E-09_JPRB, 0.26210373E-09_JPRB, 0.26214425E-09_JPRB, &
  & 0.26215830E-09_JPRB, 0.26215174E-09_JPRB, 0.26213176E-09_JPRB, 0.26210484E-09_JPRB, 0.26207500E-09_JPRB, 0.26204328E-09_JPRB, &
  & 0.26200986E-09_JPRB, 0.26197430E-09_JPRB, 0.26193722E-09_JPRB, 0.26189997E-09_JPRB, 0.26186323E-09_JPRB, 0.26182678E-09_JPRB, &
  & 0.26178754E-09_JPRB, 0.26174007E-09_JPRB, 0.26167138E-09_JPRB, 0.26153330E-09_JPRB /)

RGHG5(:,70, 2) = (/ &
  & 0.26164276E-09_JPRB, 0.26171565E-09_JPRB, 0.26174812E-09_JPRB, 0.26176866E-09_JPRB, 0.26178285E-09_JPRB, 0.26179200E-09_JPRB, &
  & 0.26179953E-09_JPRB, 0.26181007E-09_JPRB, 0.26182687E-09_JPRB, 0.26185051E-09_JPRB, 0.26187652E-09_JPRB, 0.26190045E-09_JPRB, &
  & 0.26191577E-09_JPRB, 0.26191924E-09_JPRB, 0.26190902E-09_JPRB, 0.26188843E-09_JPRB, 0.26186930E-09_JPRB, 0.26186928E-09_JPRB, &
  & 0.26190564E-09_JPRB, 0.26198643E-09_JPRB, 0.26210592E-09_JPRB, 0.26225019E-09_JPRB, 0.26240238E-09_JPRB, 0.26254640E-09_JPRB, &
  & 0.26267058E-09_JPRB, 0.26276648E-09_JPRB, 0.26283137E-09_JPRB, 0.26286698E-09_JPRB, 0.26287642E-09_JPRB, 0.26286223E-09_JPRB, &
  & 0.26282437E-09_JPRB, 0.26276148E-09_JPRB, 0.26267372E-09_JPRB, 0.26256244E-09_JPRB, 0.26243419E-09_JPRB, 0.26230051E-09_JPRB, &
  & 0.26216745E-09_JPRB, 0.26204594E-09_JPRB, 0.26194349E-09_JPRB, 0.26187030E-09_JPRB, 0.26183603E-09_JPRB, 0.26184618E-09_JPRB, &
  & 0.26189809E-09_JPRB, 0.26197927E-09_JPRB, 0.26207139E-09_JPRB, 0.26215594E-09_JPRB, 0.26221850E-09_JPRB, 0.26225500E-09_JPRB, &
  & 0.26226732E-09_JPRB, 0.26226105E-09_JPRB, 0.26224234E-09_JPRB, 0.26221697E-09_JPRB, 0.26218894E-09_JPRB, 0.26215863E-09_JPRB, &
  & 0.26212660E-09_JPRB, 0.26209215E-09_JPRB, 0.26205627E-09_JPRB, 0.26201960E-09_JPRB, 0.26198382E-09_JPRB, 0.26194780E-09_JPRB, &
  & 0.26190877E-09_JPRB, 0.26186006E-09_JPRB, 0.26178468E-09_JPRB, 0.26162689E-09_JPRB /)

RGHG5(:,71, 2) = (/ &
  & 0.26176394E-09_JPRB, 0.26185226E-09_JPRB, 0.26189070E-09_JPRB, 0.26191604E-09_JPRB, 0.26193353E-09_JPRB, 0.26194608E-09_JPRB, &
  & 0.26195676E-09_JPRB, 0.26197025E-09_JPRB, 0.26198899E-09_JPRB, 0.26201200E-09_JPRB, 0.26203692E-09_JPRB, 0.26205860E-09_JPRB, &
  & 0.26207281E-09_JPRB, 0.26207619E-09_JPRB, 0.26206728E-09_JPRB, 0.26204919E-09_JPRB, 0.26203220E-09_JPRB, 0.26203226E-09_JPRB, &
  & 0.26206348E-09_JPRB, 0.26213326E-09_JPRB, 0.26223654E-09_JPRB, 0.26236108E-09_JPRB, 0.26249181E-09_JPRB, 0.26261585E-09_JPRB, &
  & 0.26272223E-09_JPRB, 0.26280420E-09_JPRB, 0.26285915E-09_JPRB, 0.26288904E-09_JPRB, 0.26289651E-09_JPRB, 0.26288366E-09_JPRB, &
  & 0.26285066E-09_JPRB, 0.26279595E-09_JPRB, 0.26271993E-09_JPRB, 0.26262206E-09_JPRB, 0.26250949E-09_JPRB, 0.26239075E-09_JPRB, &
  & 0.26227237E-09_JPRB, 0.26216435E-09_JPRB, 0.26207406E-09_JPRB, 0.26201100E-09_JPRB, 0.26198335E-09_JPRB, 0.26199531E-09_JPRB, &
  & 0.26204372E-09_JPRB, 0.26211686E-09_JPRB, 0.26219843E-09_JPRB, 0.26227265E-09_JPRB, 0.26232816E-09_JPRB, 0.26235991E-09_JPRB, &
  & 0.26237085E-09_JPRB, 0.26236516E-09_JPRB, 0.26234800E-09_JPRB, 0.26232522E-09_JPRB, 0.26229943E-09_JPRB, 0.26227204E-09_JPRB, &
  & 0.26224226E-09_JPRB, 0.26221028E-09_JPRB, 0.26217667E-09_JPRB, 0.26214192E-09_JPRB, 0.26210778E-09_JPRB, 0.26207364E-09_JPRB, &
  & 0.26203584E-09_JPRB, 0.26198818E-09_JPRB, 0.26191027E-09_JPRB, 0.26174232E-09_JPRB /)

RGHG5(:,72, 2) = (/ &
  & 0.26188768E-09_JPRB, 0.26199024E-09_JPRB, 0.26203503E-09_JPRB, 0.26206362E-09_JPRB, 0.26208347E-09_JPRB, 0.26209818E-09_JPRB, &
  & 0.26211153E-09_JPRB, 0.26212699E-09_JPRB, 0.26214564E-09_JPRB, 0.26216790E-09_JPRB, 0.26218930E-09_JPRB, 0.26220889E-09_JPRB, &
  & 0.26222086E-09_JPRB, 0.26222358E-09_JPRB, 0.26221542E-09_JPRB, 0.26219912E-09_JPRB, 0.26218394E-09_JPRB, 0.26218341E-09_JPRB, &
  & 0.26220975E-09_JPRB, 0.26226904E-09_JPRB, 0.26235683E-09_JPRB, 0.26246236E-09_JPRB, 0.26257355E-09_JPRB, 0.26267855E-09_JPRB, &
  & 0.26276864E-09_JPRB, 0.26283786E-09_JPRB, 0.26288374E-09_JPRB, 0.26290847E-09_JPRB, 0.26291436E-09_JPRB, 0.26290300E-09_JPRB, &
  & 0.26287453E-09_JPRB, 0.26282793E-09_JPRB, 0.26276256E-09_JPRB, 0.26267863E-09_JPRB, 0.26258068E-09_JPRB, 0.26247779E-09_JPRB, &
  & 0.26237340E-09_JPRB, 0.26227931E-09_JPRB, 0.26220098E-09_JPRB, 0.26214761E-09_JPRB, 0.26212596E-09_JPRB, 0.26213895E-09_JPRB, &
  & 0.26218347E-09_JPRB, 0.26224767E-09_JPRB, 0.26231883E-09_JPRB, 0.26238356E-09_JPRB, 0.26243124E-09_JPRB, 0.26245880E-09_JPRB, &
  & 0.26246841E-09_JPRB, 0.26246344E-09_JPRB, 0.26244851E-09_JPRB, 0.26242813E-09_JPRB, 0.26240624E-09_JPRB, 0.26238142E-09_JPRB, &
  & 0.26235553E-09_JPRB, 0.26232660E-09_JPRB, 0.26229602E-09_JPRB, 0.26226421E-09_JPRB, 0.26223268E-09_JPRB, 0.26220096E-09_JPRB, &
  & 0.26216587E-09_JPRB, 0.26212052E-09_JPRB, 0.26204353E-09_JPRB, 0.26187003E-09_JPRB /)

RGHG5(:,73, 2) = (/ &
  & 0.26202787E-09_JPRB, 0.26213504E-09_JPRB, 0.26218111E-09_JPRB, 0.26221006E-09_JPRB, 0.26223049E-09_JPRB, 0.26224639E-09_JPRB, &
  & 0.26226091E-09_JPRB, 0.26227687E-09_JPRB, 0.26229510E-09_JPRB, 0.26231392E-09_JPRB, 0.26233343E-09_JPRB, 0.26234895E-09_JPRB, &
  & 0.26235908E-09_JPRB, 0.26236074E-09_JPRB, 0.26235281E-09_JPRB, 0.26233782E-09_JPRB, 0.26232411E-09_JPRB, 0.26232300E-09_JPRB, &
  & 0.26234487E-09_JPRB, 0.26239411E-09_JPRB, 0.26246708E-09_JPRB, 0.26255509E-09_JPRB, 0.26264768E-09_JPRB, 0.26273533E-09_JPRB, &
  & 0.26281038E-09_JPRB, 0.26286770E-09_JPRB, 0.26290542E-09_JPRB, 0.26292565E-09_JPRB, 0.26293023E-09_JPRB, 0.26292032E-09_JPRB, &
  & 0.26289637E-09_JPRB, 0.26285707E-09_JPRB, 0.26280245E-09_JPRB, 0.26273142E-09_JPRB, 0.26264826E-09_JPRB, 0.26256022E-09_JPRB, &
  & 0.26247077E-09_JPRB, 0.26239005E-09_JPRB, 0.26232361E-09_JPRB, 0.26227934E-09_JPRB, 0.26226299E-09_JPRB, 0.26227626E-09_JPRB, &
  & 0.26231564E-09_JPRB, 0.26237132E-09_JPRB, 0.26243208E-09_JPRB, 0.26248662E-09_JPRB, 0.26252775E-09_JPRB, 0.26255084E-09_JPRB, &
  & 0.26255917E-09_JPRB, 0.26255520E-09_JPRB, 0.26254238E-09_JPRB, 0.26252550E-09_JPRB, 0.26250629E-09_JPRB, 0.26248603E-09_JPRB, &
  & 0.26246311E-09_JPRB, 0.26243815E-09_JPRB, 0.26241145E-09_JPRB, 0.26238278E-09_JPRB, 0.26235469E-09_JPRB, 0.26232616E-09_JPRB, &
  & 0.26229435E-09_JPRB, 0.26225297E-09_JPRB, 0.26217917E-09_JPRB, 0.26200714E-09_JPRB /)

RGHG5(:,74, 2) = (/ &
  & 0.26216979E-09_JPRB, 0.26227970E-09_JPRB, 0.26232405E-09_JPRB, 0.26235236E-09_JPRB, 0.26237168E-09_JPRB, 0.26238722E-09_JPRB, &
  & 0.26240182E-09_JPRB, 0.26241703E-09_JPRB, 0.26243296E-09_JPRB, 0.26245020E-09_JPRB, 0.26246522E-09_JPRB, 0.26247882E-09_JPRB, &
  & 0.26248620E-09_JPRB, 0.26248681E-09_JPRB, 0.26247912E-09_JPRB, 0.26246538E-09_JPRB, 0.26245289E-09_JPRB, 0.26245120E-09_JPRB, &
  & 0.26246899E-09_JPRB, 0.26250885E-09_JPRB, 0.26256800E-09_JPRB, 0.26263955E-09_JPRB, 0.26271513E-09_JPRB, 0.26278682E-09_JPRB, &
  & 0.26284772E-09_JPRB, 0.26289437E-09_JPRB, 0.26292449E-09_JPRB, 0.26294072E-09_JPRB, 0.26294433E-09_JPRB, 0.26293590E-09_JPRB, &
  & 0.26291616E-09_JPRB, 0.26288391E-09_JPRB, 0.26283933E-09_JPRB, 0.26278085E-09_JPRB, 0.26271163E-09_JPRB, 0.26263844E-09_JPRB, &
  & 0.26256350E-09_JPRB, 0.26249630E-09_JPRB, 0.26244110E-09_JPRB, 0.26240549E-09_JPRB, 0.26239363E-09_JPRB, 0.26240612E-09_JPRB, &
  & 0.26244037E-09_JPRB, 0.26248653E-09_JPRB, 0.26253677E-09_JPRB, 0.26258290E-09_JPRB, 0.26261654E-09_JPRB, 0.26263583E-09_JPRB, &
  & 0.26264302E-09_JPRB, 0.26264005E-09_JPRB, 0.26262958E-09_JPRB, 0.26261524E-09_JPRB, 0.26260025E-09_JPRB, 0.26258251E-09_JPRB, &
  & 0.26256392E-09_JPRB, 0.26254263E-09_JPRB, 0.26251987E-09_JPRB, 0.26249536E-09_JPRB, 0.26247088E-09_JPRB, 0.26244618E-09_JPRB, &
  & 0.26241859E-09_JPRB, 0.26238201E-09_JPRB, 0.26231387E-09_JPRB, 0.26214911E-09_JPRB /)

RGHG5(:,75, 2) = (/ &
  & 0.26231206E-09_JPRB, 0.26241959E-09_JPRB, 0.26246175E-09_JPRB, 0.26248692E-09_JPRB, 0.26250432E-09_JPRB, 0.26251842E-09_JPRB, &
  & 0.26253189E-09_JPRB, 0.26254532E-09_JPRB, 0.26255942E-09_JPRB, 0.26257302E-09_JPRB, 0.26258615E-09_JPRB, 0.26259617E-09_JPRB, &
  & 0.26260186E-09_JPRB, 0.26260152E-09_JPRB, 0.26259414E-09_JPRB, 0.26258173E-09_JPRB, 0.26257083E-09_JPRB, 0.26256874E-09_JPRB, &
  & 0.26258273E-09_JPRB, 0.26261388E-09_JPRB, 0.26266037E-09_JPRB, 0.26271674E-09_JPRB, 0.26277669E-09_JPRB, 0.26283331E-09_JPRB, &
  & 0.26288133E-09_JPRB, 0.26291805E-09_JPRB, 0.26294134E-09_JPRB, 0.26295394E-09_JPRB, 0.26295685E-09_JPRB, 0.26294983E-09_JPRB, &
  & 0.26293417E-09_JPRB, 0.26290842E-09_JPRB, 0.26287356E-09_JPRB, 0.26282654E-09_JPRB, 0.26277144E-09_JPRB, 0.26271185E-09_JPRB, &
  & 0.26265173E-09_JPRB, 0.26259747E-09_JPRB, 0.26255328E-09_JPRB, 0.26252545E-09_JPRB, 0.26251720E-09_JPRB, 0.26252842E-09_JPRB, &
  & 0.26255656E-09_JPRB, 0.26259359E-09_JPRB, 0.26263422E-09_JPRB, 0.26267069E-09_JPRB, 0.26269881E-09_JPRB, 0.26271377E-09_JPRB, &
  & 0.26271979E-09_JPRB, 0.26271785E-09_JPRB, 0.26270935E-09_JPRB, 0.26269809E-09_JPRB, 0.26268593E-09_JPRB, 0.26267186E-09_JPRB, &
  & 0.26265640E-09_JPRB, 0.26263908E-09_JPRB, 0.26262090E-09_JPRB, 0.26260039E-09_JPRB, 0.26258037E-09_JPRB, 0.26255981E-09_JPRB, &
  & 0.26253685E-09_JPRB, 0.26250585E-09_JPRB, 0.26244537E-09_JPRB, 0.26229252E-09_JPRB /)

RGHG5(:,76, 2) = (/ &
  & 0.26245162E-09_JPRB, 0.26255434E-09_JPRB, 0.26259098E-09_JPRB, 0.26261304E-09_JPRB, 0.26262725E-09_JPRB, 0.26263905E-09_JPRB, &
  & 0.26265051E-09_JPRB, 0.26266167E-09_JPRB, 0.26267269E-09_JPRB, 0.26268387E-09_JPRB, 0.26269323E-09_JPRB, 0.26270136E-09_JPRB, &
  & 0.26270502E-09_JPRB, 0.26270439E-09_JPRB, 0.26269800E-09_JPRB, 0.26268754E-09_JPRB, 0.26267846E-09_JPRB, 0.26267630E-09_JPRB, &
  & 0.26268673E-09_JPRB, 0.26271008E-09_JPRB, 0.26274466E-09_JPRB, 0.26278738E-09_JPRB, 0.26283259E-09_JPRB, 0.26287547E-09_JPRB, &
  & 0.26291133E-09_JPRB, 0.26293906E-09_JPRB, 0.26295616E-09_JPRB, 0.26296548E-09_JPRB, 0.26296806E-09_JPRB, 0.26296232E-09_JPRB, &
  & 0.26295044E-09_JPRB, 0.26293070E-09_JPRB, 0.26290484E-09_JPRB, 0.26286881E-09_JPRB, 0.26282690E-09_JPRB, 0.26278091E-09_JPRB, &
  & 0.26273464E-09_JPRB, 0.26269339E-09_JPRB, 0.26265951E-09_JPRB, 0.26263897E-09_JPRB, 0.26263353E-09_JPRB, 0.26264269E-09_JPRB, &
  & 0.26266486E-09_JPRB, 0.26269262E-09_JPRB, 0.26272334E-09_JPRB, 0.26275201E-09_JPRB, 0.26277358E-09_JPRB, 0.26278479E-09_JPRB, &
  & 0.26278968E-09_JPRB, 0.26278865E-09_JPRB, 0.26278205E-09_JPRB, 0.26277325E-09_JPRB, 0.26276453E-09_JPRB, 0.26275321E-09_JPRB, &
  & 0.26274130E-09_JPRB, 0.26272781E-09_JPRB, 0.26271416E-09_JPRB, 0.26269836E-09_JPRB, 0.26268257E-09_JPRB, 0.26266656E-09_JPRB, &
  & 0.26264846E-09_JPRB, 0.26262376E-09_JPRB, 0.26257169E-09_JPRB, 0.26243602E-09_JPRB /)

RGHG5(:,77, 2) = (/ &
  & 0.26258895E-09_JPRB, 0.26268049E-09_JPRB, 0.26271121E-09_JPRB, 0.26272862E-09_JPRB, 0.26273947E-09_JPRB, 0.26274813E-09_JPRB, &
  & 0.26275709E-09_JPRB, 0.26276520E-09_JPRB, 0.26277297E-09_JPRB, 0.26278046E-09_JPRB, 0.26278690E-09_JPRB, 0.26279243E-09_JPRB, &
  & 0.26279481E-09_JPRB, 0.26279456E-09_JPRB, 0.26279012E-09_JPRB, 0.26278230E-09_JPRB, 0.26277563E-09_JPRB, 0.26277372E-09_JPRB, &
  & 0.26278110E-09_JPRB, 0.26279712E-09_JPRB, 0.26282129E-09_JPRB, 0.26285113E-09_JPRB, 0.26288288E-09_JPRB, 0.26291297E-09_JPRB, &
  & 0.26293781E-09_JPRB, 0.26295752E-09_JPRB, 0.26296904E-09_JPRB, 0.26297553E-09_JPRB, 0.26297800E-09_JPRB, 0.26297337E-09_JPRB, &
  & 0.26296496E-09_JPRB, 0.26295063E-09_JPRB, 0.26293323E-09_JPRB, 0.26290725E-09_JPRB, 0.26287772E-09_JPRB, 0.26284450E-09_JPRB, &
  & 0.26281180E-09_JPRB, 0.26278246E-09_JPRB, 0.26275856E-09_JPRB, 0.26274458E-09_JPRB, 0.26274105E-09_JPRB, 0.26274766E-09_JPRB, &
  & 0.26276353E-09_JPRB, 0.26278257E-09_JPRB, 0.26280439E-09_JPRB, 0.26282465E-09_JPRB, 0.26284108E-09_JPRB, 0.26284827E-09_JPRB, &
  & 0.26285224E-09_JPRB, 0.26285218E-09_JPRB, 0.26284713E-09_JPRB, 0.26284072E-09_JPRB, 0.26283523E-09_JPRB, 0.26282657E-09_JPRB, &
  & 0.26281805E-09_JPRB, 0.26280819E-09_JPRB, 0.26279953E-09_JPRB, 0.26278799E-09_JPRB, 0.26277683E-09_JPRB, 0.26276506E-09_JPRB, &
  & 0.26275232E-09_JPRB, 0.26273336E-09_JPRB, 0.26269173E-09_JPRB, 0.26257724E-09_JPRB /)

RGHG5(:,78, 2) = (/ &
  & 0.26272148E-09_JPRB, 0.26279362E-09_JPRB, 0.26281388E-09_JPRB, 0.26282701E-09_JPRB, 0.26283409E-09_JPRB, 0.26283981E-09_JPRB, &
  & 0.26284611E-09_JPRB, 0.26285080E-09_JPRB, 0.26285488E-09_JPRB, 0.26285882E-09_JPRB, 0.26286190E-09_JPRB, 0.26286565E-09_JPRB, &
  & 0.26286706E-09_JPRB, 0.26286792E-09_JPRB, 0.26286595E-09_JPRB, 0.26286126E-09_JPRB, 0.26285735E-09_JPRB, 0.26285601E-09_JPRB, &
  & 0.26286112E-09_JPRB, 0.26287128E-09_JPRB, 0.26288616E-09_JPRB, 0.26290517E-09_JPRB, 0.26292510E-09_JPRB, 0.26294428E-09_JPRB, &
  & 0.26295977E-09_JPRB, 0.26297270E-09_JPRB, 0.26297967E-09_JPRB, 0.26298372E-09_JPRB, 0.26298630E-09_JPRB, 0.26298261E-09_JPRB, &
  & 0.26297714E-09_JPRB, 0.26296743E-09_JPRB, 0.26295738E-09_JPRB, 0.26293998E-09_JPRB, 0.26292124E-09_JPRB, 0.26289929E-09_JPRB, &
  & 0.26287861E-09_JPRB, 0.26285996E-09_JPRB, 0.26284461E-09_JPRB, 0.26283609E-09_JPRB, 0.26283342E-09_JPRB, 0.26283686E-09_JPRB, &
  & 0.26284711E-09_JPRB, 0.26285818E-09_JPRB, 0.26287200E-09_JPRB, 0.26288563E-09_JPRB, 0.26289729E-09_JPRB, 0.26290120E-09_JPRB, &
  & 0.26290428E-09_JPRB, 0.26290525E-09_JPRB, 0.26290142E-09_JPRB, 0.26289701E-09_JPRB, 0.26289446E-09_JPRB, 0.26288807E-09_JPRB, &
  & 0.26288249E-09_JPRB, 0.26287597E-09_JPRB, 0.26287159E-09_JPRB, 0.26286398E-09_JPRB, 0.26285665E-09_JPRB, 0.26284894E-09_JPRB, &
  & 0.26284100E-09_JPRB, 0.26282776E-09_JPRB, 0.26279884E-09_JPRB, 0.26271518E-09_JPRB /)

RGHG5(:,79, 2) = (/ &
  & 0.26280716E-09_JPRB, 0.26285665E-09_JPRB, 0.26286850E-09_JPRB, 0.26287794E-09_JPRB, 0.26288305E-09_JPRB, 0.26288699E-09_JPRB, &
  & 0.26289201E-09_JPRB, 0.26289487E-09_JPRB, 0.26289670E-09_JPRB, 0.26289906E-09_JPRB, 0.26290045E-09_JPRB, 0.26290359E-09_JPRB, &
  & 0.26290470E-09_JPRB, 0.26290631E-09_JPRB, 0.26290572E-09_JPRB, 0.26290264E-09_JPRB, 0.26290023E-09_JPRB, 0.26289937E-09_JPRB, &
  & 0.26290364E-09_JPRB, 0.26291055E-09_JPRB, 0.26292077E-09_JPRB, 0.26293395E-09_JPRB, 0.26294758E-09_JPRB, 0.26296099E-09_JPRB, &
  & 0.26297137E-09_JPRB, 0.26298089E-09_JPRB, 0.26298530E-09_JPRB, 0.26298805E-09_JPRB, 0.26299088E-09_JPRB, 0.26298760E-09_JPRB, &
  & 0.26298366E-09_JPRB, 0.26297636E-09_JPRB, 0.26297053E-09_JPRB, 0.26295763E-09_JPRB, 0.26294483E-09_JPRB, 0.26292868E-09_JPRB, &
  & 0.26291458E-09_JPRB, 0.26290159E-09_JPRB, 0.26289068E-09_JPRB, 0.26288499E-09_JPRB, 0.26288249E-09_JPRB, 0.26288408E-09_JPRB, &
  & 0.26289115E-09_JPRB, 0.26289790E-09_JPRB, 0.26290750E-09_JPRB, 0.26291749E-09_JPRB, 0.26292704E-09_JPRB, 0.26292890E-09_JPRB, &
  & 0.26293173E-09_JPRB, 0.26293343E-09_JPRB, 0.26293007E-09_JPRB, 0.26292651E-09_JPRB, 0.26292563E-09_JPRB, 0.26292007E-09_JPRB, &
  & 0.26291597E-09_JPRB, 0.26291100E-09_JPRB, 0.26290908E-09_JPRB, 0.26290328E-09_JPRB, 0.26289793E-09_JPRB, 0.26289210E-09_JPRB, &
  & 0.26288691E-09_JPRB, 0.26287775E-09_JPRB, 0.26285837E-09_JPRB, 0.26280372E-09_JPRB /)

RGHG5(:,80, 2) = (/ &
  & 0.26286373E-09_JPRB, 0.26288710E-09_JPRB, 0.26289221E-09_JPRB, 0.26290009E-09_JPRB, 0.26290412E-09_JPRB, 0.26290725E-09_JPRB, &
  & 0.26291183E-09_JPRB, 0.26291366E-09_JPRB, 0.26291486E-09_JPRB, 0.26291644E-09_JPRB, 0.26291741E-09_JPRB, 0.26292041E-09_JPRB, &
  & 0.26292138E-09_JPRB, 0.26292338E-09_JPRB, 0.26292335E-09_JPRB, 0.26292094E-09_JPRB, 0.26291919E-09_JPRB, 0.26291858E-09_JPRB, &
  & 0.26292257E-09_JPRB, 0.26292826E-09_JPRB, 0.26293623E-09_JPRB, 0.26294689E-09_JPRB, 0.26295766E-09_JPRB, 0.26296842E-09_JPRB, &
  & 0.26297653E-09_JPRB, 0.26298452E-09_JPRB, 0.26298777E-09_JPRB, 0.26298999E-09_JPRB, 0.26299299E-09_JPRB, 0.26298977E-09_JPRB, &
  & 0.26298658E-09_JPRB, 0.26298025E-09_JPRB, 0.26297650E-09_JPRB, 0.26296568E-09_JPRB, 0.26295544E-09_JPRB, 0.26294192E-09_JPRB, &
  & 0.26293079E-09_JPRB, 0.26292038E-09_JPRB, 0.26291141E-09_JPRB, 0.26290703E-09_JPRB, 0.26290456E-09_JPRB, 0.26290520E-09_JPRB, &
  & 0.26291086E-09_JPRB, 0.26291558E-09_JPRB, 0.26292327E-09_JPRB, 0.26293162E-09_JPRB, 0.26294023E-09_JPRB, 0.26294100E-09_JPRB, &
  & 0.26294369E-09_JPRB, 0.26294586E-09_JPRB, 0.26294250E-09_JPRB, 0.26293925E-09_JPRB, 0.26293925E-09_JPRB, 0.26293395E-09_JPRB, &
  & 0.26293040E-09_JPRB, 0.26292601E-09_JPRB, 0.26292526E-09_JPRB, 0.26292021E-09_JPRB, 0.26291558E-09_JPRB, 0.26291058E-09_JPRB, &
  & 0.26290670E-09_JPRB, 0.26289954E-09_JPRB, 0.26288677E-09_JPRB, 0.26286243E-09_JPRB /)

RGHG5(:,81, 2) = (/ &
  & 0.26290253E-09_JPRB, 0.26290001E-09_JPRB, 0.26290223E-09_JPRB, 0.26290944E-09_JPRB, 0.26291308E-09_JPRB, 0.26291594E-09_JPRB, &
  & 0.26292027E-09_JPRB, 0.26292188E-09_JPRB, 0.26292252E-09_JPRB, 0.26292415E-09_JPRB, 0.26292474E-09_JPRB, 0.26292796E-09_JPRB, &
  & 0.26292876E-09_JPRB, 0.26293095E-09_JPRB, 0.26293112E-09_JPRB, 0.26292896E-09_JPRB, 0.26292749E-09_JPRB, 0.26292687E-09_JPRB, &
  & 0.26293090E-09_JPRB, 0.26293590E-09_JPRB, 0.26294306E-09_JPRB, 0.26295241E-09_JPRB, 0.26296201E-09_JPRB, 0.26297170E-09_JPRB, &
  & 0.26297881E-09_JPRB, 0.26298613E-09_JPRB, 0.26298880E-09_JPRB, 0.26299074E-09_JPRB, 0.26299396E-09_JPRB, 0.26299071E-09_JPRB, &
  & 0.26298788E-09_JPRB, 0.26298197E-09_JPRB, 0.26297911E-09_JPRB, 0.26296915E-09_JPRB, 0.26296010E-09_JPRB, 0.26294769E-09_JPRB, &
  & 0.26293795E-09_JPRB, 0.26292871E-09_JPRB, 0.26292060E-09_JPRB, 0.26291680E-09_JPRB, 0.26291430E-09_JPRB, 0.26291452E-09_JPRB, &
  & 0.26291960E-09_JPRB, 0.26292332E-09_JPRB, 0.26293021E-09_JPRB, 0.26293775E-09_JPRB, 0.26294605E-09_JPRB, 0.26294619E-09_JPRB, &
  & 0.26294891E-09_JPRB, 0.26295133E-09_JPRB, 0.26294791E-09_JPRB, 0.26294480E-09_JPRB, 0.26294514E-09_JPRB, 0.26293984E-09_JPRB, &
  & 0.26293659E-09_JPRB, 0.26293243E-09_JPRB, 0.26293223E-09_JPRB, 0.26292737E-09_JPRB, 0.26292313E-09_JPRB, 0.26291838E-09_JPRB, &
  & 0.26291505E-09_JPRB, 0.26290864E-09_JPRB, 0.26289859E-09_JPRB, 0.26290281E-09_JPRB /)

RGHG5(:,82, 2) = (/ &
  & 0.26290564E-09_JPRB, 0.26290431E-09_JPRB, 0.26290661E-09_JPRB, 0.26291397E-09_JPRB, 0.26291741E-09_JPRB, 0.26292005E-09_JPRB, &
  & 0.26292446E-09_JPRB, 0.26292574E-09_JPRB, 0.26292646E-09_JPRB, 0.26292774E-09_JPRB, 0.26292851E-09_JPRB, 0.26293145E-09_JPRB, &
  & 0.26293240E-09_JPRB, 0.26293462E-09_JPRB, 0.26293498E-09_JPRB, 0.26293290E-09_JPRB, 0.26293151E-09_JPRB, 0.26293101E-09_JPRB, &
  & 0.26293495E-09_JPRB, 0.26293975E-09_JPRB, 0.26294622E-09_JPRB, 0.26295524E-09_JPRB, 0.26296409E-09_JPRB, 0.26297320E-09_JPRB, &
  & 0.26297986E-09_JPRB, 0.26298685E-09_JPRB, 0.26298927E-09_JPRB, 0.26299105E-09_JPRB, 0.26299443E-09_JPRB, 0.26299113E-09_JPRB, &
  & 0.26298841E-09_JPRB, 0.26298266E-09_JPRB, 0.26298030E-09_JPRB, 0.26297078E-09_JPRB, 0.26296224E-09_JPRB, 0.26295055E-09_JPRB, &
  & 0.26294145E-09_JPRB, 0.26293281E-09_JPRB, 0.26292518E-09_JPRB, 0.26292166E-09_JPRB, 0.26291916E-09_JPRB, 0.26291910E-09_JPRB, &
  & 0.26292388E-09_JPRB, 0.26292701E-09_JPRB, 0.26293351E-09_JPRB, 0.26294081E-09_JPRB, 0.26294894E-09_JPRB, 0.26294877E-09_JPRB, &
  & 0.26295141E-09_JPRB, 0.26295399E-09_JPRB, 0.26295055E-09_JPRB, 0.26294744E-09_JPRB, 0.26294805E-09_JPRB, 0.26294264E-09_JPRB, &
  & 0.26293950E-09_JPRB, 0.26293548E-09_JPRB, 0.26293559E-09_JPRB, 0.26293084E-09_JPRB, 0.26292676E-09_JPRB, 0.26292218E-09_JPRB, &
  & 0.26291902E-09_JPRB, 0.26291261E-09_JPRB, 0.26290248E-09_JPRB, 0.26290603E-09_JPRB /)

RGHG5(:,83, 2) = (/ &
  & 0.26290786E-09_JPRB, 0.26290681E-09_JPRB, 0.26290906E-09_JPRB, 0.26291652E-09_JPRB, 0.26291985E-09_JPRB, 0.26292246E-09_JPRB, &
  & 0.26292660E-09_JPRB, 0.26292796E-09_JPRB, 0.26292826E-09_JPRB, 0.26292996E-09_JPRB, 0.26293029E-09_JPRB, 0.26293373E-09_JPRB, &
  & 0.26293445E-09_JPRB, 0.26293673E-09_JPRB, 0.26293709E-09_JPRB, 0.26293512E-09_JPRB, 0.26293379E-09_JPRB, 0.26293323E-09_JPRB, &
  & 0.26293737E-09_JPRB, 0.26294175E-09_JPRB, 0.26294822E-09_JPRB, 0.26295657E-09_JPRB, 0.26296529E-09_JPRB, 0.26297403E-09_JPRB, &
  & 0.26298036E-09_JPRB, 0.26298730E-09_JPRB, 0.26298949E-09_JPRB, 0.26299116E-09_JPRB, 0.26299468E-09_JPRB, 0.26299135E-09_JPRB, &
  & 0.26298866E-09_JPRB, 0.26298300E-09_JPRB, 0.26298086E-09_JPRB, 0.26297162E-09_JPRB, 0.26296343E-09_JPRB, 0.26295216E-09_JPRB, &
  & 0.26294350E-09_JPRB, 0.26293520E-09_JPRB, 0.26292785E-09_JPRB, 0.26292446E-09_JPRB, 0.26292196E-09_JPRB, 0.26292163E-09_JPRB, &
  & 0.26292626E-09_JPRB, 0.26292907E-09_JPRB, 0.26293537E-09_JPRB, 0.26294245E-09_JPRB, 0.26295063E-09_JPRB, 0.26295011E-09_JPRB, &
  & 0.26295274E-09_JPRB, 0.26295552E-09_JPRB, 0.26295202E-09_JPRB, 0.26294888E-09_JPRB, 0.26294966E-09_JPRB, 0.26294419E-09_JPRB, &
  & 0.26294111E-09_JPRB, 0.26293712E-09_JPRB, 0.26293748E-09_JPRB, 0.26293281E-09_JPRB, 0.26292885E-09_JPRB, 0.26292424E-09_JPRB, &
  & 0.26292118E-09_JPRB, 0.26291480E-09_JPRB, 0.26290467E-09_JPRB, 0.26290828E-09_JPRB /)

RGHG5(:,84, 2) = (/ &
  & 0.26290939E-09_JPRB, 0.26290845E-09_JPRB, 0.26291058E-09_JPRB, 0.26291810E-09_JPRB, 0.26292141E-09_JPRB, 0.26292379E-09_JPRB, &
  & 0.26292826E-09_JPRB, 0.26292923E-09_JPRB, 0.26292987E-09_JPRB, 0.26293098E-09_JPRB, 0.26293187E-09_JPRB, 0.26293456E-09_JPRB, &
  & 0.26293567E-09_JPRB, 0.26293789E-09_JPRB, 0.26293842E-09_JPRB, 0.26293653E-09_JPRB, 0.26293523E-09_JPRB, 0.26293470E-09_JPRB, &
  & 0.26293878E-09_JPRB, 0.26294322E-09_JPRB, 0.26294902E-09_JPRB, 0.26295757E-09_JPRB, 0.26296584E-09_JPRB, 0.26297456E-09_JPRB, &
  & 0.26298075E-09_JPRB, 0.26298755E-09_JPRB, 0.26298960E-09_JPRB, 0.26299121E-09_JPRB, 0.26299493E-09_JPRB, 0.26299146E-09_JPRB, &
  & 0.26298880E-09_JPRB, 0.26298314E-09_JPRB, 0.26298108E-09_JPRB, 0.26297206E-09_JPRB, 0.26296393E-09_JPRB, 0.26295321E-09_JPRB, &
  & 0.26294472E-09_JPRB, 0.26293667E-09_JPRB, 0.26292957E-09_JPRB, 0.26292624E-09_JPRB, 0.26292368E-09_JPRB, 0.26292318E-09_JPRB, &
  & 0.26292768E-09_JPRB, 0.26293026E-09_JPRB, 0.26293645E-09_JPRB, 0.26294350E-09_JPRB, 0.26295163E-09_JPRB, 0.26295091E-09_JPRB, &
  & 0.26295360E-09_JPRB, 0.26295649E-09_JPRB, 0.26295288E-09_JPRB, 0.26294975E-09_JPRB, 0.26295072E-09_JPRB, 0.26294519E-09_JPRB, &
  & 0.26294211E-09_JPRB, 0.26293812E-09_JPRB, 0.26293867E-09_JPRB, 0.26293401E-09_JPRB, 0.26293009E-09_JPRB, 0.26292549E-09_JPRB, &
  & 0.26292254E-09_JPRB, 0.26291616E-09_JPRB, 0.26290606E-09_JPRB, 0.26290983E-09_JPRB /)

RGHG5(:,85, 2) = (/ &
  & 0.26291039E-09_JPRB, 0.26290953E-09_JPRB, 0.26291153E-09_JPRB, 0.26291913E-09_JPRB, 0.26292238E-09_JPRB, 0.26292518E-09_JPRB, &
  & 0.26292887E-09_JPRB, 0.26293018E-09_JPRB, 0.26293059E-09_JPRB, 0.26293193E-09_JPRB, 0.26293262E-09_JPRB, 0.26293537E-09_JPRB, &
  & 0.26293639E-09_JPRB, 0.26293856E-09_JPRB, 0.26293923E-09_JPRB, 0.26293748E-09_JPRB, 0.26293615E-09_JPRB, 0.26293559E-09_JPRB, &
  & 0.26293986E-09_JPRB, 0.26294386E-09_JPRB, 0.26294988E-09_JPRB, 0.26295793E-09_JPRB, 0.26296626E-09_JPRB, 0.26297486E-09_JPRB, &
  & 0.26298091E-09_JPRB, 0.26298774E-09_JPRB, 0.26298963E-09_JPRB, 0.26299121E-09_JPRB, 0.26299507E-09_JPRB, 0.26299146E-09_JPRB, &
  & 0.26298883E-09_JPRB, 0.26298319E-09_JPRB, 0.26298125E-09_JPRB, 0.26297226E-09_JPRB, 0.26296448E-09_JPRB, 0.26295377E-09_JPRB, &
  & 0.26294564E-09_JPRB, 0.26293767E-09_JPRB, 0.26293062E-09_JPRB, 0.26292743E-09_JPRB, 0.26292477E-09_JPRB, 0.26292410E-09_JPRB, &
  & 0.26292868E-09_JPRB, 0.26293104E-09_JPRB, 0.26293720E-09_JPRB, 0.26294411E-09_JPRB, 0.26295235E-09_JPRB, 0.26295144E-09_JPRB, &
  & 0.26295410E-09_JPRB, 0.26295710E-09_JPRB, 0.26295346E-09_JPRB, 0.26295030E-09_JPRB, 0.26295138E-09_JPRB, 0.26294583E-09_JPRB, &
  & 0.26294275E-09_JPRB, 0.26293875E-09_JPRB, 0.26293948E-09_JPRB, 0.26293481E-09_JPRB, 0.26293093E-09_JPRB, 0.26292629E-09_JPRB, &
  & 0.26292343E-09_JPRB, 0.26291705E-09_JPRB, 0.26290692E-09_JPRB, 0.26291092E-09_JPRB /)

RGHG5(:,86, 2) = (/ &
  & 0.26291105E-09_JPRB, 0.26291025E-09_JPRB, 0.26291208E-09_JPRB, 0.26291985E-09_JPRB, 0.26292321E-09_JPRB, 0.26292560E-09_JPRB, &
  & 0.26292984E-09_JPRB, 0.26293073E-09_JPRB, 0.26293145E-09_JPRB, 0.26293245E-09_JPRB, 0.26293348E-09_JPRB, 0.26293548E-09_JPRB, &
  & 0.26293678E-09_JPRB, 0.26293870E-09_JPRB, 0.26293950E-09_JPRB, 0.26293812E-09_JPRB, 0.26293678E-09_JPRB, 0.26293626E-09_JPRB, &
  & 0.26294034E-09_JPRB, 0.26294447E-09_JPRB, 0.26295008E-09_JPRB, 0.26295832E-09_JPRB, 0.26296643E-09_JPRB, 0.26297511E-09_JPRB, &
  & 0.26298111E-09_JPRB, 0.26298796E-09_JPRB, 0.26298966E-09_JPRB, 0.26299124E-09_JPRB, 0.26299521E-09_JPRB, 0.26299149E-09_JPRB, &
  & 0.26298885E-09_JPRB, 0.26298319E-09_JPRB, 0.26298130E-09_JPRB, 0.26297259E-09_JPRB, 0.26296468E-09_JPRB, 0.26295444E-09_JPRB, &
  & 0.26294608E-09_JPRB, 0.26293834E-09_JPRB, 0.26293129E-09_JPRB, 0.26292807E-09_JPRB, 0.26292543E-09_JPRB, 0.26292463E-09_JPRB, &
  & 0.26292926E-09_JPRB, 0.26293148E-09_JPRB, 0.26293764E-09_JPRB, 0.26294453E-09_JPRB, 0.26295277E-09_JPRB, 0.26295177E-09_JPRB, &
  & 0.26295441E-09_JPRB, 0.26295749E-09_JPRB, 0.26295383E-09_JPRB, 0.26295061E-09_JPRB, 0.26295183E-09_JPRB, 0.26294622E-09_JPRB, &
  & 0.26294311E-09_JPRB, 0.26293914E-09_JPRB, 0.26294000E-09_JPRB, 0.26293537E-09_JPRB, 0.26293148E-09_JPRB, 0.26292682E-09_JPRB, &
  & 0.26292399E-09_JPRB, 0.26291760E-09_JPRB, 0.26290745E-09_JPRB, 0.26291158E-09_JPRB /)

RGHG5(:,87, 2) = (/ &
  & 0.26291141E-09_JPRB, 0.26291064E-09_JPRB, 0.26291236E-09_JPRB, 0.26292041E-09_JPRB, 0.26292354E-09_JPRB, 0.26292690E-09_JPRB, &
  & 0.26292987E-09_JPRB, 0.26293129E-09_JPRB, 0.26293190E-09_JPRB, 0.26293298E-09_JPRB, 0.26293390E-09_JPRB, 0.26293578E-09_JPRB, &
  & 0.26293701E-09_JPRB, 0.26293875E-09_JPRB, 0.26293959E-09_JPRB, 0.26293848E-09_JPRB, 0.26293720E-09_JPRB, 0.26293670E-09_JPRB, &
  & 0.26294072E-09_JPRB, 0.26294458E-09_JPRB, 0.26295033E-09_JPRB, 0.26295838E-09_JPRB, 0.26296657E-09_JPRB, 0.26297534E-09_JPRB, &
  & 0.26298116E-09_JPRB, 0.26298813E-09_JPRB, 0.26298971E-09_JPRB, 0.26299121E-09_JPRB, 0.26299535E-09_JPRB, 0.26299155E-09_JPRB, &
  & 0.26298891E-09_JPRB, 0.26298322E-09_JPRB, 0.26298150E-09_JPRB, 0.26297273E-09_JPRB, 0.26296526E-09_JPRB, 0.26295449E-09_JPRB, &
  & 0.26294655E-09_JPRB, 0.26293859E-09_JPRB, 0.26293143E-09_JPRB, 0.26292854E-09_JPRB, 0.26292571E-09_JPRB, 0.26292482E-09_JPRB, &
  & 0.26292973E-09_JPRB, 0.26293168E-09_JPRB, 0.26293789E-09_JPRB, 0.26294478E-09_JPRB, 0.26295308E-09_JPRB, 0.26295197E-09_JPRB, &
  & 0.26295463E-09_JPRB, 0.26295777E-09_JPRB, 0.26295405E-09_JPRB, 0.26295077E-09_JPRB, 0.26295210E-09_JPRB, 0.26294641E-09_JPRB, &
  & 0.26294336E-09_JPRB, 0.26293931E-09_JPRB, 0.26294028E-09_JPRB, 0.26293567E-09_JPRB, 0.26293179E-09_JPRB, 0.26292712E-09_JPRB, &
  & 0.26292429E-09_JPRB, 0.26291788E-09_JPRB, 0.26290772E-09_JPRB, 0.26291200E-09_JPRB /)

RGHG5(:,88, 2) = (/ &
  & 0.26291164E-09_JPRB, 0.26291094E-09_JPRB, 0.26291255E-09_JPRB, 0.26292052E-09_JPRB, 0.26292413E-09_JPRB, 0.26292654E-09_JPRB, &
  & 0.26293059E-09_JPRB, 0.26293145E-09_JPRB, 0.26293223E-09_JPRB, 0.26293315E-09_JPRB, 0.26293417E-09_JPRB, 0.26293590E-09_JPRB, &
  & 0.26293712E-09_JPRB, 0.26293878E-09_JPRB, 0.26293967E-09_JPRB, 0.26293873E-09_JPRB, 0.26293739E-09_JPRB, 0.26293689E-09_JPRB, &
  & 0.26294089E-09_JPRB, 0.26294478E-09_JPRB, 0.26295036E-09_JPRB, 0.26295846E-09_JPRB, 0.26296659E-09_JPRB, 0.26297542E-09_JPRB, &
  & 0.26298116E-09_JPRB, 0.26298830E-09_JPRB, 0.26298974E-09_JPRB, 0.26299118E-09_JPRB, 0.26299543E-09_JPRB, 0.26299152E-09_JPRB, &
  & 0.26298891E-09_JPRB, 0.26298322E-09_JPRB, 0.26298175E-09_JPRB, 0.26297312E-09_JPRB, 0.26296537E-09_JPRB, 0.26295485E-09_JPRB, &
  & 0.26294650E-09_JPRB, 0.26293878E-09_JPRB, 0.26293145E-09_JPRB, 0.26292868E-09_JPRB, 0.26292593E-09_JPRB, 0.26292488E-09_JPRB, &
  & 0.26292993E-09_JPRB, 0.26293179E-09_JPRB, 0.26293803E-09_JPRB, 0.26294486E-09_JPRB, 0.26295327E-09_JPRB, 0.26295205E-09_JPRB, &
  & 0.26295471E-09_JPRB, 0.26295793E-09_JPRB, 0.26295421E-09_JPRB, 0.26295088E-09_JPRB, 0.26295224E-09_JPRB, 0.26294653E-09_JPRB, &
  & 0.26294350E-09_JPRB, 0.26293945E-09_JPRB, 0.26294042E-09_JPRB, 0.26293587E-09_JPRB, 0.26293195E-09_JPRB, 0.26292724E-09_JPRB, &
  & 0.26292449E-09_JPRB, 0.26291808E-09_JPRB, 0.26290786E-09_JPRB, 0.26291225E-09_JPRB /)

RGHG5(:,89, 2) = (/ &
  & 0.26291178E-09_JPRB, 0.26291111E-09_JPRB, 0.26291258E-09_JPRB, 0.26292074E-09_JPRB, 0.26292390E-09_JPRB, 0.26292724E-09_JPRB, &
  & 0.26293026E-09_JPRB, 0.26293151E-09_JPRB, 0.26293212E-09_JPRB, 0.26293318E-09_JPRB, 0.26293412E-09_JPRB, 0.26293601E-09_JPRB, &
  & 0.26293728E-09_JPRB, 0.26293903E-09_JPRB, 0.26293989E-09_JPRB, 0.26293884E-09_JPRB, 0.26293751E-09_JPRB, 0.26293692E-09_JPRB, &
  & 0.26294106E-09_JPRB, 0.26294486E-09_JPRB, 0.26295038E-09_JPRB, 0.26295849E-09_JPRB, 0.26296662E-09_JPRB, 0.26297553E-09_JPRB, &
  & 0.26298116E-09_JPRB, 0.26298838E-09_JPRB, 0.26298974E-09_JPRB, 0.26299113E-09_JPRB, 0.26299554E-09_JPRB, 0.26299146E-09_JPRB, &
  & 0.26298899E-09_JPRB, 0.26298319E-09_JPRB, 0.26298205E-09_JPRB, 0.26297314E-09_JPRB, 0.26296579E-09_JPRB, 0.26295457E-09_JPRB, &
  & 0.26294658E-09_JPRB, 0.26293873E-09_JPRB, 0.26293129E-09_JPRB, 0.26292885E-09_JPRB, 0.26292596E-09_JPRB, 0.26292479E-09_JPRB, &
  & 0.26293007E-09_JPRB, 0.26293184E-09_JPRB, 0.26293817E-09_JPRB, 0.26294494E-09_JPRB, 0.26295346E-09_JPRB, 0.26295205E-09_JPRB, &
  & 0.26295474E-09_JPRB, 0.26295807E-09_JPRB, 0.26295432E-09_JPRB, 0.26295091E-09_JPRB, 0.26295238E-09_JPRB, 0.26294658E-09_JPRB, &
  & 0.26294361E-09_JPRB, 0.26293948E-09_JPRB, 0.26294050E-09_JPRB, 0.26293601E-09_JPRB, 0.26293209E-09_JPRB, 0.26292729E-09_JPRB, &
  & 0.26292465E-09_JPRB, 0.26291819E-09_JPRB, 0.26290781E-09_JPRB, 0.26291241E-09_JPRB /)

RGHG5(:,90, 2) = (/ &
  & 0.26291175E-09_JPRB, 0.26291114E-09_JPRB, 0.26291241E-09_JPRB, 0.26292066E-09_JPRB, 0.26292396E-09_JPRB, 0.26292621E-09_JPRB, &
  & 0.26293065E-09_JPRB, 0.26293134E-09_JPRB, 0.26293190E-09_JPRB, 0.26293295E-09_JPRB, 0.26293392E-09_JPRB, 0.26293620E-09_JPRB, &
  & 0.26293745E-09_JPRB, 0.26293948E-09_JPRB, 0.26294025E-09_JPRB, 0.26293889E-09_JPRB, 0.26293739E-09_JPRB, 0.26293676E-09_JPRB, &
  & 0.26294117E-09_JPRB, 0.26294486E-09_JPRB, 0.26295036E-09_JPRB, 0.26295852E-09_JPRB, 0.26296657E-09_JPRB, 0.26297561E-09_JPRB, &
  & 0.26298111E-09_JPRB, 0.26298858E-09_JPRB, 0.26298974E-09_JPRB, 0.26299105E-09_JPRB, 0.26299582E-09_JPRB, 0.26299152E-09_JPRB, &
  & 0.26298919E-09_JPRB, 0.26298308E-09_JPRB, 0.26298252E-09_JPRB, 0.26297323E-09_JPRB, 0.26296604E-09_JPRB, 0.26295444E-09_JPRB, &
  & 0.26294639E-09_JPRB, 0.26293870E-09_JPRB, 0.26293115E-09_JPRB, 0.26292893E-09_JPRB, 0.26292590E-09_JPRB, 0.26292457E-09_JPRB, &
  & 0.26293026E-09_JPRB, 0.26293179E-09_JPRB, 0.26293814E-09_JPRB, 0.26294492E-09_JPRB, 0.26295380E-09_JPRB, 0.26295202E-09_JPRB, &
  & 0.26295482E-09_JPRB, 0.26295832E-09_JPRB, 0.26295438E-09_JPRB, 0.26295086E-09_JPRB, 0.26295263E-09_JPRB, 0.26294655E-09_JPRB, &
  & 0.26294367E-09_JPRB, 0.26293939E-09_JPRB, 0.26294075E-09_JPRB, 0.26293609E-09_JPRB, 0.26293218E-09_JPRB, 0.26292718E-09_JPRB, &
  & 0.26292468E-09_JPRB, 0.26291816E-09_JPRB, 0.26290758E-09_JPRB, 0.26291255E-09_JPRB /)

RGHG5(:,91, 2) = (/ &
  & 0.26291164E-09_JPRB, 0.26291100E-09_JPRB, 0.26291164E-09_JPRB, 0.26292105E-09_JPRB, 0.26292377E-09_JPRB, 0.26292568E-09_JPRB, &
  & 0.26293109E-09_JPRB, 0.26293140E-09_JPRB, 0.26293104E-09_JPRB, 0.26293298E-09_JPRB, 0.26293279E-09_JPRB, 0.26293737E-09_JPRB, &
  & 0.26293737E-09_JPRB, 0.26294020E-09_JPRB, 0.26294089E-09_JPRB, 0.26293887E-09_JPRB, 0.26293726E-09_JPRB, 0.26293626E-09_JPRB, &
  & 0.26294131E-09_JPRB, 0.26294480E-09_JPRB, 0.26295022E-09_JPRB, 0.26295857E-09_JPRB, 0.26296651E-09_JPRB, 0.26297586E-09_JPRB, &
  & 0.26298100E-09_JPRB, 0.26298905E-09_JPRB, 0.26298974E-09_JPRB, 0.26299074E-09_JPRB, 0.26299651E-09_JPRB, 0.26299135E-09_JPRB, &
  & 0.26298949E-09_JPRB, 0.26298258E-09_JPRB, 0.26298372E-09_JPRB, 0.26297295E-09_JPRB, 0.26296673E-09_JPRB, 0.26295369E-09_JPRB, &
  & 0.26294622E-09_JPRB, 0.26293856E-09_JPRB, 0.26293070E-09_JPRB, 0.26292898E-09_JPRB, 0.26292582E-09_JPRB, 0.26292407E-09_JPRB, &
  & 0.26293051E-09_JPRB, 0.26293145E-09_JPRB, 0.26293812E-09_JPRB, 0.26294483E-09_JPRB, 0.26295455E-09_JPRB, 0.26295172E-09_JPRB, &
  & 0.26295480E-09_JPRB, 0.26295882E-09_JPRB, 0.26295432E-09_JPRB, 0.26295049E-09_JPRB, 0.26295313E-09_JPRB, 0.26294633E-09_JPRB, &
  & 0.26294378E-09_JPRB, 0.26293903E-09_JPRB, 0.26294114E-09_JPRB, 0.26293601E-09_JPRB, 0.26293220E-09_JPRB, 0.26292704E-09_JPRB, &
  & 0.26292488E-09_JPRB, 0.26291810E-09_JPRB, 0.26290689E-09_JPRB, 0.26291264E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART4',1,ZHOOK_HANDLE)
END SUBROUTINE PART4






SUBROUTINE PART5
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART5',0,ZHOOK_HANDLE)



!-- Month=  3 ------------

RGHG5(:, 1, 3) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, &
  & 0.42038954E-44_JPRB, 0.56051939E-44_JPRB, 0.70064923E-44_JPRB, 0.11210388E-43_JPRB, 0.21019477E-43_JPRB, 0.42038954E-43_JPRB, &
  & 0.93886997E-43_JPRB, 0.19618179E-42_JPRB, 0.43019863E-42_JPRB, 0.11406569E-41_JPRB, 0.27773736E-41_JPRB, 0.56822653E-41_JPRB, &
  & 0.13434248E-40_JPRB, 0.24566163E-40_JPRB, 0.38074681E-40_JPRB, 0.52990101E-40_JPRB, 0.69701987E-40_JPRB, 0.88972643E-40_JPRB, &
  & 0.12167755E-39_JPRB, 0.15728875E-39_JPRB, 0.20094340E-39_JPRB, 0.23299810E-39_JPRB, 0.26981582E-39_JPRB, 0.28705739E-39_JPRB, &
  & 0.31236905E-39_JPRB, 0.30307844E-39_JPRB, 0.32435295E-39_JPRB, 0.31253020E-39_JPRB, 0.27488151E-39_JPRB, 0.23863272E-39_JPRB, &
  & 0.17564716E-39_JPRB, 0.12663114E-39_JPRB, 0.94573633E-40_JPRB, 0.70579200E-40_JPRB, 0.53348834E-40_JPRB, 0.41705445E-40_JPRB, &
  & 0.30650601E-40_JPRB, 0.20167487E-40_JPRB, 0.11751289E-40_JPRB, 0.57915666E-41_JPRB, 0.25489619E-41_JPRB, 0.10888089E-41_JPRB, &
  & 0.48484927E-42_JPRB, 0.22841165E-42_JPRB, 0.11630777E-42_JPRB, 0.61657132E-43_JPRB, 0.33631163E-43_JPRB, 0.19618179E-43_JPRB, &
  & 0.11210388E-43_JPRB, 0.70064923E-44_JPRB, 0.56051939E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB /)

RGHG5(:, 2, 3) = (/ &
  & 0.42038954E-44_JPRB, 0.18216880E-43_JPRB, 0.37835059E-43_JPRB, 0.56051939E-43_JPRB, 0.70064923E-43_JPRB, 0.89683102E-43_JPRB, &
  & 0.12191297E-42_JPRB, 0.17796490E-42_JPRB, 0.28166099E-42_JPRB, 0.47504018E-42_JPRB, 0.90383751E-42_JPRB, 0.18160828E-41_JPRB, &
  & 0.40049110E-41_JPRB, 0.84456258E-41_JPRB, 0.19063264E-40_JPRB, 0.49227615E-40_JPRB, 0.11666650E-39_JPRB, 0.24031148E-39_JPRB, &
  & 0.54046260E-39_JPRB, 0.97306866E-39_JPRB, 0.15023657E-38_JPRB, 0.20971230E-38_JPRB, 0.27781779E-38_JPRB, 0.35958706E-38_JPRB, &
  & 0.49003772E-38_JPRB, 0.62965385E-38_JPRB, 0.79496643E-38_JPRB, 0.93090303E-38_JPRB, 0.10699602E-37_JPRB, 0.11500863E-37_JPRB, &
  & 0.12396528E-37_JPRB, 0.12212654E-37_JPRB, 0.12862440E-37_JPRB, 0.12368656E-37_JPRB, 0.10913535E-37_JPRB, 0.93731845E-38_JPRB, &
  & 0.69982499E-38_JPRB, 0.50889919E-38_JPRB, 0.37970004E-38_JPRB, 0.28356550E-38_JPRB, 0.21336759E-38_JPRB, 0.16544963E-38_JPRB, &
  & 0.12121890E-38_JPRB, 0.80096679E-39_JPRB, 0.47240013E-39_JPRB, 0.24044460E-39_JPRB, 0.11087634E-39_JPRB, 0.49464434E-40_JPRB, &
  & 0.22537083E-40_JPRB, 0.10710124E-40_JPRB, 0.53361446E-41_JPRB, 0.27899852E-41_JPRB, 0.15344218E-41_JPRB, 0.88982452E-42_JPRB, &
  & 0.54510510E-42_JPRB, 0.35452851E-42_JPRB, 0.24662853E-42_JPRB, 0.18497140E-42_JPRB, 0.14573504E-42_JPRB, 0.12051167E-42_JPRB, &
  & 0.10089349E-42_JPRB, 0.79874012E-43_JPRB, 0.57453237E-43_JPRB, 0.36433760E-43_JPRB /)

RGHG5(:, 3, 3) = (/ &
  & 0.15834673E-42_JPRB, 0.91925179E-42_JPRB, 0.19379958E-41_JPRB, 0.27059073E-41_JPRB, 0.33939449E-41_JPRB, 0.43216045E-41_JPRB, &
  & 0.58630328E-41_JPRB, 0.85899596E-41_JPRB, 0.13626226E-40_JPRB, 0.23145247E-40_JPRB, 0.44344090E-40_JPRB, 0.89722338E-40_JPRB, &
  & 0.19719212E-39_JPRB, 0.41624590E-39_JPRB, 0.93151175E-39_JPRB, 0.23456713E-38_JPRB, 0.54263279E-38_JPRB, 0.10920292E-37_JPRB, &
  & 0.24720984E-37_JPRB, 0.44990733E-37_JPRB, 0.70259003E-37_JPRB, 0.98906078E-37_JPRB, 0.13219582E-36_JPRB, 0.17207138E-36_JPRB, &
  & 0.23631470E-36_JPRB, 0.30182012E-36_JPRB, 0.37956126E-36_JPRB, 0.44422009E-36_JPRB, 0.51007179E-36_JPRB, 0.54965006E-36_JPRB, &
  & 0.59120006E-36_JPRB, 0.58459768E-36_JPRB, 0.61219205E-36_JPRB, 0.58765000E-36_JPRB, 0.51828317E-36_JPRB, 0.44420143E-36_JPRB, &
  & 0.33330994E-36_JPRB, 0.24396884E-36_JPRB, 0.18216871E-36_JPRB, 0.13594032E-36_JPRB, 0.10182777E-36_JPRB, 0.78794418E-37_JPRB, &
  & 0.57436550E-37_JPRB, 0.37558089E-37_JPRB, 0.21929602E-37_JPRB, 0.11076823E-37_JPRB, 0.51362942E-38_JPRB, 0.23344890E-38_JPRB, &
  & 0.10893358E-38_JPRB, 0.52860481E-39_JPRB, 0.26701182E-39_JPRB, 0.14045215E-39_JPRB, 0.77106448E-40_JPRB, 0.44367912E-40_JPRB, &
  & 0.26911937E-40_JPRB, 0.17336865E-40_JPRB, 0.11940464E-40_JPRB, 0.88379894E-41_JPRB, 0.69770651E-41_JPRB, 0.57929679E-41_JPRB, &
  & 0.48849264E-41_JPRB, 0.39166292E-41_JPRB, 0.26764801E-41_JPRB, 0.13438452E-41_JPRB /)

RGHG5(:, 4, 3) = (/ &
  & 0.20564055E-40_JPRB, 0.10973148E-39_JPRB, 0.19845890E-39_JPRB, 0.26172472E-39_JPRB, 0.32222017E-39_JPRB, 0.40837340E-39_JPRB, &
  & 0.55292995E-39_JPRB, 0.80949509E-39_JPRB, 0.12831017E-38_JPRB, 0.21795572E-38_JPRB, 0.41833510E-38_JPRB, 0.84737345E-38_JPRB, &
  & 0.18600471E-37_JPRB, 0.39034839E-37_JPRB, 0.86461595E-37_JPRB, 0.21353439E-36_JPRB, 0.48407158E-36_JPRB, 0.95038403E-36_JPRB, &
  & 0.21649915E-35_JPRB, 0.39779844E-35_JPRB, 0.62548188E-35_JPRB, 0.88387475E-35_JPRB, 0.11829971E-34_JPRB, 0.15407103E-34_JPRB, &
  & 0.21192446E-34_JPRB, 0.26978032E-34_JPRB, 0.33734777E-34_JPRB, 0.39435347E-34_JPRB, 0.45207653E-34_JPRB, 0.48679574E-34_JPRB, &
  & 0.52314435E-34_JPRB, 0.51684076E-34_JPRB, 0.54053208E-34_JPRB, 0.51837608E-34_JPRB, 0.45776950E-34_JPRB, 0.39244008E-34_JPRB, &
  & 0.29590091E-34_JPRB, 0.21732203E-34_JPRB, 0.16309645E-34_JPRB, 0.12206843E-34_JPRB, 0.91416741E-35_JPRB, 0.71075200E-35_JPRB, &
  & 0.51770342E-35_JPRB, 0.33613847E-35_JPRB, 0.19490787E-35_JPRB, 0.98164791E-36_JPRB, 0.45906793E-36_JPRB, 0.21279657E-36_JPRB, &
  & 0.10165813E-36_JPRB, 0.50343396E-37_JPRB, 0.25803549E-37_JPRB, 0.13682302E-37_JPRB, 0.75261849E-38_JPRB, 0.43191522E-38_JPRB, &
  & 0.26049284E-38_JPRB, 0.16670926E-38_JPRB, 0.11426412E-38_JPRB, 0.84344995E-39_JPRB, 0.66754636E-39_JPRB, 0.55892331E-39_JPRB, &
  & 0.48201444E-39_JPRB, 0.40272757E-39_JPRB, 0.28621241E-39_JPRB, 0.12697306E-39_JPRB /)

RGHG5(:, 5, 3) = (/ &
  & 0.11582875E-37_JPRB, 0.32950827E-37_JPRB, 0.48960303E-37_JPRB, 0.60604230E-37_JPRB, 0.73781425E-37_JPRB, 0.93091783E-37_JPRB, &
  & 0.12552152E-36_JPRB, 0.18266932E-36_JPRB, 0.28770940E-36_JPRB, 0.48451654E-36_JPRB, 0.92287517E-36_JPRB, 0.18532032E-35_JPRB, &
  & 0.40269535E-35_JPRB, 0.83483704E-35_JPRB, 0.18177330E-34_JPRB, 0.43946442E-34_JPRB, 0.97393518E-34_JPRB, 0.18590744E-33_JPRB, &
  & 0.41757407E-33_JPRB, 0.75701189E-33_JPRB, 0.11761708E-32_JPRB, 0.16391251E-32_JPRB, 0.21653860E-32_JPRB, 0.27750272E-32_JPRB, &
  & 0.37843417E-32_JPRB, 0.47484936E-32_JPRB, 0.58858699E-32_JPRB, 0.68162715E-32_JPRB, 0.77713886E-32_JPRB, 0.83181183E-32_JPRB, &
  & 0.89139103E-32_JPRB, 0.87853862E-32_JPRB, 0.91948711E-32_JPRB, 0.88412596E-32_JPRB, 0.78439394E-32_JPRB, 0.67732513E-32_JPRB, &
  & 0.51492280E-32_JPRB, 0.38250256E-32_JPRB, 0.29078373E-32_JPRB, 0.22076541E-32_JPRB, 0.16765290E-32_JPRB, 0.13261491E-32_JPRB, &
  & 0.97913996E-33_JPRB, 0.64315043E-33_JPRB, 0.37813536E-33_JPRB, 0.19387674E-33_JPRB, 0.92999207E-34_JPRB, 0.44376746E-34_JPRB, &
  & 0.21783657E-34_JPRB, 0.11046797E-34_JPRB, 0.57702545E-35_JPRB, 0.31044243E-35_JPRB, 0.17259495E-35_JPRB, 0.99816826E-36_JPRB, &
  & 0.60564981E-36_JPRB, 0.38965936E-36_JPRB, 0.26823236E-36_JPRB, 0.19897008E-36_JPRB, 0.15812706E-36_JPRB, 0.13342547E-36_JPRB, &
  & 0.11724577E-36_JPRB, 0.10369991E-36_JPRB, 0.85017153E-37_JPRB, 0.52314704E-37_JPRB /)

RGHG5(:, 6, 3) = (/ &
  & 0.10164632E-34_JPRB, 0.20505024E-34_JPRB, 0.26890779E-34_JPRB, 0.32493304E-34_JPRB, 0.39201058E-34_JPRB, 0.48948807E-34_JPRB, &
  & 0.65090589E-34_JPRB, 0.93071889E-34_JPRB, 0.14333814E-33_JPRB, 0.23492126E-33_JPRB, 0.43423000E-33_JPRB, 0.84336173E-33_JPRB, &
  & 0.17716173E-32_JPRB, 0.35341535E-32_JPRB, 0.73943906E-32_JPRB, 0.17161531E-31_JPRB, 0.36419739E-31_JPRB, 0.66564619E-31_JPRB, &
  & 0.14276978E-30_JPRB, 0.24836893E-30_JPRB, 0.37088723E-30_JPRB, 0.49772617E-30_JPRB, 0.63421155E-30_JPRB, 0.78506768E-30_JPRB, &
  & 0.10400669E-29_JPRB, 0.12710294E-29_JPRB, 0.15426925E-29_JPRB, 0.17540945E-29_JPRB, 0.19728933E-29_JPRB, 0.20881205E-29_JPRB, &
  & 0.22251627E-29_JPRB, 0.21873230E-29_JPRB, 0.22954734E-29_JPRB, 0.22205274E-29_JPRB, 0.19911095E-29_JPRB, 0.17443452E-29_JPRB, &
  & 0.13498509E-29_JPRB, 0.10249738E-29_JPRB, 0.80066371E-30_JPRB, 0.62679804E-30_JPRB, 0.49296556E-30_JPRB, 0.40477095E-30_JPRB, &
  & 0.31065466E-30_JPRB, 0.21212334E-30_JPRB, 0.12982430E-30_JPRB, 0.69447160E-31_JPRB, 0.34799153E-31_JPRB, 0.17342906E-31_JPRB, &
  & 0.88903453E-32_JPRB, 0.46987312E-32_JPRB, 0.25537674E-32_JPRB, 0.14266013E-32_JPRB, 0.82190152E-33_JPRB, 0.49160588E-33_JPRB, &
  & 0.30783134E-33_JPRB, 0.20381855E-33_JPRB, 0.14391073E-33_JPRB, 0.10891073E-33_JPRB, 0.87954557E-34_JPRB, 0.75141938E-34_JPRB, &
  & 0.66942790E-34_JPRB, 0.61154692E-34_JPRB, 0.55147962E-34_JPRB, 0.44881362E-34_JPRB /)

RGHG5(:, 7, 3) = (/ &
  & 0.84077682E-32_JPRB, 0.15805822E-31_JPRB, 0.20264792E-31_JPRB, 0.24210407E-31_JPRB, 0.28792600E-31_JPRB, 0.35284244E-31_JPRB, &
  & 0.45790101E-31_JPRB, 0.63500587E-31_JPRB, 0.94255057E-31_JPRB, 0.14776688E-30_JPRB, 0.26003722E-30_JPRB, 0.47839484E-30_JPRB, &
  & 0.95136773E-30_JPRB, 0.17871863E-29_JPRB, 0.35161304E-29_JPRB, 0.77136067E-29_JPRB, 0.15464107E-28_JPRB, 0.26624131E-28_JPRB, &
  & 0.53875459E-28_JPRB, 0.88710735E-28_JPRB, 0.12570730E-27_JPRB, 0.16057244E-27_JPRB, 0.19521053E-27_JPRB, 0.23138308E-27_JPRB, &
  & 0.29493677E-27_JPRB, 0.34880825E-27_JPRB, 0.41209354E-27_JPRB, 0.45788460E-27_JPRB, 0.50630994E-27_JPRB, 0.52903543E-27_JPRB, &
  & 0.56019129E-27_JPRB, 0.54963132E-27_JPRB, 0.57896343E-27_JPRB, 0.56450673E-27_JPRB, 0.51263402E-27_JPRB, 0.45711056E-27_JPRB, &
  & 0.36149065E-27_JPRB, 0.28207945E-27_JPRB, 0.22782201E-27_JPRB, 0.18549736E-27_JPRB, 0.15247622E-27_JPRB, 0.13159577E-27_JPRB, &
  & 0.10635881E-27_JPRB, 0.76653697E-28_JPRB, 0.49543049E-28_JPRB, 0.27924787E-28_JPRB, 0.14729341E-28_JPRB, 0.77412235E-29_JPRB, &
  & 0.41937170E-29_JPRB, 0.23487032E-29_JPRB, 0.13538089E-29_JPRB, 0.80204864E-30_JPRB, 0.48959208E-30_JPRB, 0.30970195E-30_JPRB, &
  & 0.20450708E-30_JPRB, 0.14217883E-30_JPRB, 0.10479553E-30_JPRB, 0.82233159E-31_JPRB, 0.68326979E-31_JPRB, 0.59664214E-31_JPRB, &
  & 0.54064006E-31_JPRB, 0.50028628E-31_JPRB, 0.46281954E-31_JPRB, 0.39748060E-31_JPRB /)

RGHG5(:, 8, 3) = (/ &
  & 0.59626328E-29_JPRB, 0.11055547E-28_JPRB, 0.14057698E-28_JPRB, 0.16616523E-28_JPRB, 0.19486079E-28_JPRB, 0.23427869E-28_JPRB, &
  & 0.29659586E-28_JPRB, 0.39872185E-28_JPRB, 0.56990759E-28_JPRB, 0.85343589E-28_JPRB, 0.14269876E-27_JPRB, 0.24787580E-27_JPRB, &
  & 0.46497524E-27_JPRB, 0.81828497E-27_JPRB, 0.15054303E-26_JPRB, 0.31130608E-26_JPRB, 0.58850622E-26_JPRB, 0.95011933E-26_JPRB, &
  & 0.18182771E-25_JPRB, 0.28338531E-25_JPRB, 0.38070920E-25_JPRB, 0.46207629E-25_JPRB, 0.53558429E-25_JPRB, 0.60639960E-25_JPRB, &
  & 0.74366589E-25_JPRB, 0.84914023E-25_JPRB, 0.97582704E-25_JPRB, 0.10584779E-24_JPRB, 0.11502335E-24_JPRB, 0.11863150E-24_JPRB, &
  & 0.12481701E-24_JPRB, 0.12221858E-24_JPRB, 0.12924051E-24_JPRB, 0.12701721E-24_JPRB, 0.11681476E-24_JPRB, 0.10608673E-24_JPRB, &
  & 0.85761155E-25_JPRB, 0.68871637E-25_JPRB, 0.57613889E-25_JPRB, 0.48846985E-25_JPRB, 0.42076306E-25_JPRB, 0.38231389E-25_JPRB, &
  & 0.32646750E-25_JPRB, 0.24907641E-25_JPRB, 0.17019669E-25_JPRB, 0.10101704E-25_JPRB, 0.56029420E-26_JPRB, 0.31048288E-26_JPRB, &
  & 0.17847242E-26_JPRB, 0.10644412E-26_JPRB, 0.65435237E-27_JPRB, 0.41321713E-27_JPRB, 0.26837807E-27_JPRB, 0.18010712E-27_JPRB, &
  & 0.12566760E-27_JPRB, 0.91863235E-28_JPRB, 0.70768765E-28_JPRB, 0.57650949E-28_JPRB, 0.49367034E-28_JPRB, 0.44122558E-28_JPRB, &
  & 0.40658783E-28_JPRB, 0.38142703E-28_JPRB, 0.35527612E-28_JPRB, 0.30993945E-28_JPRB /)

RGHG5(:, 9, 3) = (/ &
  & 0.35402321E-26_JPRB, 0.65141915E-26_JPRB, 0.82279194E-26_JPRB, 0.96545466E-26_JPRB, 0.11200284E-25_JPRB, 0.13262989E-25_JPRB, &
  & 0.16445597E-25_JPRB, 0.21518970E-25_JPRB, 0.29736864E-25_JPRB, 0.42700009E-25_JPRB, 0.68058340E-25_JPRB, 0.11190351E-24_JPRB, &
  & 0.19834850E-24_JPRB, 0.32728670E-24_JPRB, 0.56256210E-24_JPRB, 0.10966960E-23_JPRB, 0.19555828E-23_JPRB, 0.29534436E-23_JPRB, &
  & 0.53637710E-23_JPRB, 0.79196160E-23_JPRB, 0.10086744E-22_JPRB, 0.11626507E-22_JPRB, 0.12832822E-22_JPRB, 0.13892541E-22_JPRB, &
  & 0.16362416E-22_JPRB, 0.18060817E-22_JPRB, 0.20170872E-22_JPRB, 0.21371592E-22_JPRB, 0.22811888E-22_JPRB, 0.23216426E-22_JPRB, &
  & 0.24243433E-22_JPRB, 0.23669233E-22_JPRB, 0.25103725E-22_JPRB, 0.24864011E-22_JPRB, 0.23166393E-22_JPRB, 0.21437339E-22_JPRB, &
  & 0.17738164E-22_JPRB, 0.14678261E-22_JPRB, 0.12735725E-22_JPRB, 0.11260231E-22_JPRB, 0.10169307E-22_JPRB, 0.97341697E-23_JPRB, &
  & 0.87930594E-23_JPRB, 0.71012020E-23_JPRB, 0.51361215E-23_JPRB, 0.32040375E-23_JPRB, 0.18666461E-23_JPRB, 0.10921689E-23_JPRB, &
  & 0.66747799E-24_JPRB, 0.42488970E-24_JPRB, 0.27877556E-24_JPRB, 0.18748876E-24_JPRB, 0.12925629E-24_JPRB, 0.91679214E-25_JPRB, &
  & 0.67297773E-25_JPRB, 0.51472373E-25_JPRB, 0.41257968E-25_JPRB, 0.34753212E-25_JPRB, 0.30566037E-25_JPRB, 0.27878770E-25_JPRB, &
  & 0.26086040E-25_JPRB, 0.24706788E-25_JPRB, 0.23233824E-25_JPRB, 0.20307013E-25_JPRB /)

RGHG5(:,10, 3) = (/ &
  & 0.17480629E-23_JPRB, 0.31893333E-23_JPRB, 0.40146634E-23_JPRB, 0.46873543E-23_JPRB, 0.53990926E-23_JPRB, 0.63205307E-23_JPRB, &
  & 0.77068500E-23_JPRB, 0.98550886E-23_JPRB, 0.13218565E-22_JPRB, 0.18273892E-22_JPRB, 0.27858869E-22_JPRB, 0.43509838E-22_JPRB, &
  & 0.73043963E-22_JPRB, 0.11330888E-21_JPRB, 0.18227180E-21_JPRB, 0.33485800E-21_JPRB, 0.56324305E-21_JPRB, 0.79546421E-21_JPRB, &
  & 0.13698672E-20_JPRB, 0.19162190E-20_JPRB, 0.23116336E-20_JPRB, 0.25283022E-20_JPRB, 0.26565235E-20_JPRB, 0.27472465E-20_JPRB, &
  & 0.31101216E-20_JPRB, 0.33168048E-20_JPRB, 0.36008703E-20_JPRB, 0.37263768E-20_JPRB, 0.39058087E-20_JPRB, 0.39207170E-20_JPRB, &
  & 0.40597827E-20_JPRB, 0.39489853E-20_JPRB, 0.41972639E-20_JPRB, 0.41879302E-20_JPRB, 0.39531377E-20_JPRB, 0.37291107E-20_JPRB, &
  & 0.31612513E-20_JPRB, 0.27003531E-20_JPRB, 0.24325088E-20_JPRB, 0.22449474E-20_JPRB, 0.21271466E-20_JPRB, 0.21449476E-20_JPRB, &
  & 0.20498505E-20_JPRB, 0.17555576E-20_JPRB, 0.13438795E-20_JPRB, 0.88261009E-21_JPRB, 0.54065144E-21_JPRB, 0.33464891E-21_JPRB, &
  & 0.21792574E-21_JPRB, 0.14814728E-21_JPRB, 0.10363903E-21_JPRB, 0.74058483E-22_JPRB, 0.54006516E-22_JPRB, 0.40327456E-22_JPRB, &
  & 0.30990805E-22_JPRB, 0.24686605E-22_JPRB, 0.20488564E-22_JPRB, 0.17766730E-22_JPRB, 0.15980855E-22_JPRB, 0.14825852E-22_JPRB, &
  & 0.14027602E-22_JPRB, 0.13407221E-22_JPRB, 0.12650069E-22_JPRB, 0.11137291E-22_JPRB /)

RGHG5(:,11, 3) = (/ &
  & 0.71815579E-21_JPRB, 0.13019872E-20_JPRB, 0.16317321E-20_JPRB, 0.18991645E-20_JPRB, 0.21746187E-20_JPRB, 0.25216308E-20_JPRB, &
  & 0.30296413E-20_JPRB, 0.37943195E-20_JPRB, 0.49511849E-20_JPRB, 0.66066455E-20_JPRB, 0.96620350E-20_JPRB, 0.14373360E-19_JPRB, &
  & 0.22918614E-19_JPRB, 0.33541195E-19_JPRB, 0.50657436E-19_JPRB, 0.87752909E-19_JPRB, 0.13921235E-18_JPRB, 0.18422139E-18_JPRB, &
  & 0.30016146E-18_JPRB, 0.39729679E-18_JPRB, 0.45420229E-18_JPRB, 0.47161661E-18_JPRB, 0.47200415E-18_JPRB, 0.46661512E-18_JPRB, &
  & 0.50797213E-18_JPRB, 0.52369378E-18_JPRB, 0.55268435E-18_JPRB, 0.55870622E-18_JPRB, 0.57496606E-18_JPRB, 0.56913588E-18_JPRB, &
  & 0.58400109E-18_JPRB, 0.56564482E-18_JPRB, 0.60199160E-18_JPRB, 0.60482107E-18_JPRB, 0.57827705E-18_JPRB, 0.55591097E-18_JPRB, &
  & 0.48295064E-18_JPRB, 0.42581984E-18_JPRB, 0.39826482E-18_JPRB, 0.38357014E-18_JPRB, 0.38116904E-18_JPRB, 0.40449804E-18_JPRB, &
  & 0.40875295E-18_JPRB, 0.37094594E-18_JPRB, 0.30122501E-18_JPRB, 0.20836407E-18_JPRB, 0.13457095E-18_JPRB, 0.88251085E-19_JPRB, &
  & 0.61261526E-19_JPRB, 0.44426814E-19_JPRB, 0.33067918E-19_JPRB, 0.25040523E-19_JPRB, 0.19263217E-19_JPRB, 0.15092014E-19_JPRB, &
  & 0.12107202E-19_JPRB, 0.10007189E-19_JPRB, 0.85697947E-20_JPRB, 0.76213594E-20_JPRB, 0.69891406E-20_JPRB, 0.65704721E-20_JPRB, &
  & 0.62804758E-20_JPRB, 0.60314811E-20_JPRB, 0.57261049E-20_JPRB, 0.50357128E-20_JPRB /)

RGHG5(:,12, 3) = (/ &
  & 0.24658456E-18_JPRB, 0.44282814E-18_JPRB, 0.55385269E-18_JPRB, 0.64248359E-18_JPRB, 0.73225564E-18_JPRB, 0.84183365E-18_JPRB, &
  & 0.99793902E-18_JPRB, 0.12257729E-17_JPRB, 0.15585621E-17_JPRB, 0.20117334E-17_JPRB, 0.28277752E-17_JPRB, 0.40191242E-17_JPRB, &
  & 0.60993854E-17_JPRB, 0.84490428E-17_JPRB, 0.12021473E-16_JPRB, 0.19631312E-16_JPRB, 0.29370854E-16_JPRB, 0.36517724E-16_JPRB, &
  & 0.56070980E-16_JPRB, 0.70209390E-16_JPRB, 0.76062917E-16_JPRB, 0.75030986E-16_JPRB, 0.71556999E-16_JPRB, 0.67619163E-16_JPRB, &
  & 0.70784949E-16_JPRB, 0.70503125E-16_JPRB, 0.72283701E-16_JPRB, 0.71323284E-16_JPRB, 0.72009910E-16_JPRB, 0.70251066E-16_JPRB, &
  & 0.71402211E-16_JPRB, 0.68856083E-16_JPRB, 0.73373911E-16_JPRB, 0.74248056E-16_JPRB, 0.71934974E-16_JPRB, 0.70482763E-16_JPRB, &
  & 0.62766055E-16_JPRB, 0.57116576E-16_JPRB, 0.55452646E-16_JPRB, 0.55726933E-16_JPRB, 0.58068522E-16_JPRB, 0.64820626E-16_JPRB, &
  & 0.69193049E-16_JPRB, 0.66551346E-16_JPRB, 0.57301819E-16_JPRB, 0.41903160E-16_JPRB, 0.28566808E-16_JPRB, 0.19871471E-16_JPRB, &
  & 0.14687804E-16_JPRB, 0.11335782E-16_JPRB, 0.89520017E-17_JPRB, 0.71637563E-17_JPRB, 0.57970910E-17_JPRB, 0.47543901E-17_JPRB, &
  & 0.39691360E-17_JPRB, 0.33949238E-17_JPRB, 0.29899874E-17_JPRB, 0.27186918E-17_JPRB, 0.25336251E-17_JPRB, 0.24107778E-17_JPRB, &
  & 0.23194996E-17_JPRB, 0.22414967E-17_JPRB, 0.21282135E-17_JPRB, 0.18803832E-17_JPRB /)

RGHG5(:,13, 3) = (/ &
  & 0.56638037E-17_JPRB, 0.99031097E-17_JPRB, 0.12275680E-16_JPRB, 0.14302813E-16_JPRB, 0.16293663E-16_JPRB, 0.18508957E-16_JPRB, &
  & 0.21391920E-16_JPRB, 0.25309844E-16_JPRB, 0.30702370E-16_JPRB, 0.38107920E-16_JPRB, 0.49323681E-16_JPRB, 0.63357634E-16_JPRB, &
  & 0.89049335E-16_JPRB, 0.11672343E-15_JPRB, 0.14313618E-15_JPRB, 0.21225159E-15_JPRB, 0.30015899E-15_JPRB, 0.34543163E-15_JPRB, &
  & 0.46860843E-15_JPRB, 0.49821790E-15_JPRB, 0.68801845E-15_JPRB, 0.68038303E-15_JPRB, 0.87083902E-15_JPRB, 0.82274449E-15_JPRB, &
  & 0.93817136E-15_JPRB, 0.89867199E-15_JPRB, 0.94930932E-15_JPRB, 0.89474790E-15_JPRB, 0.89023989E-15_JPRB, 0.83298014E-15_JPRB, &
  & 0.77624418E-15_JPRB, 0.69962677E-15_JPRB, 0.65780621E-15_JPRB, 0.65087340E-15_JPRB, 0.65916083E-15_JPRB, 0.62108776E-15_JPRB, &
  & 0.61265290E-15_JPRB, 0.62599483E-15_JPRB, 0.62531646E-15_JPRB, 0.68596074E-15_JPRB, 0.75512707E-15_JPRB, 0.85431404E-15_JPRB, &
  & 0.89218023E-15_JPRB, 0.85836662E-15_JPRB, 0.76236655E-15_JPRB, 0.57555889E-15_JPRB, 0.41116996E-15_JPRB, 0.30920379E-15_JPRB, &
  & 0.24599814E-15_JPRB, 0.20244958E-15_JPRB, 0.16961006E-15_JPRB, 0.14303651E-15_JPRB, 0.12129005E-15_JPRB, 0.10353992E-15_JPRB, &
  & 0.89295921E-16_JPRB, 0.78135553E-16_JPRB, 0.69646252E-16_JPRB, 0.63417714E-16_JPRB, 0.58754652E-16_JPRB, 0.55243330E-16_JPRB, &
  & 0.52556270E-16_JPRB, 0.49965785E-16_JPRB, 0.46981738E-16_JPRB, 0.40501830E-16_JPRB /)

RGHG5(:,14, 3) = (/ &
  & 0.88006836E-16_JPRB, 0.15077456E-15_JPRB, 0.18861867E-15_JPRB, 0.22029948E-15_JPRB, 0.25244615E-15_JPRB, 0.28641559E-15_JPRB, &
  & 0.32698434E-15_JPRB, 0.37654839E-15_JPRB, 0.44236547E-15_JPRB, 0.53421802E-15_JPRB, 0.64647566E-15_JPRB, 0.80992560E-15_JPRB, &
  & 0.10581358E-14_JPRB, 0.14275394E-14_JPRB, 0.16536614E-14_JPRB, 0.24353070E-14_JPRB, 0.30828850E-14_JPRB, 0.38650541E-14_JPRB, &
  & 0.49252581E-14_JPRB, 0.54204273E-14_JPRB, 0.71779596E-14_JPRB, 0.73738563E-14_JPRB, 0.86598988E-14_JPRB, 0.86399343E-14_JPRB, &
  & 0.94086023E-14_JPRB, 0.88488414E-14_JPRB, 0.90996013E-14_JPRB, 0.87441574E-14_JPRB, 0.87377446E-14_JPRB, 0.79258110E-14_JPRB, &
  & 0.70948466E-14_JPRB, 0.63107262E-14_JPRB, 0.57115055E-14_JPRB, 0.53366798E-14_JPRB, 0.51997464E-14_JPRB, 0.52671393E-14_JPRB, &
  & 0.55208252E-14_JPRB, 0.58642895E-14_JPRB, 0.63737078E-14_JPRB, 0.71278720E-14_JPRB, 0.71933231E-14_JPRB, 0.74884311E-14_JPRB, &
  & 0.84453437E-14_JPRB, 0.79759960E-14_JPRB, 0.72365701E-14_JPRB, 0.56373359E-14_JPRB, 0.44125317E-14_JPRB, 0.36446104E-14_JPRB, &
  & 0.30999155E-14_JPRB, 0.26821474E-14_JPRB, 0.23403321E-14_JPRB, 0.20451918E-14_JPRB, 0.17872639E-14_JPRB, 0.15632377E-14_JPRB, &
  & 0.13720050E-14_JPRB, 0.12121554E-14_JPRB, 0.10816718E-14_JPRB, 0.97766438E-15_JPRB, 0.89377170E-15_JPRB, 0.82766247E-15_JPRB, &
  & 0.77237451E-15_JPRB, 0.72398881E-15_JPRB, 0.66662494E-15_JPRB, 0.57037123E-15_JPRB /)

RGHG5(:,15, 3) = (/ &
  & 0.96517297E-15_JPRB, 0.16044641E-14_JPRB, 0.20161281E-14_JPRB, 0.23630786E-14_JPRB, 0.27111229E-14_JPRB, 0.30680783E-14_JPRB, &
  & 0.34647294E-14_JPRB, 0.39219171E-14_JPRB, 0.44671357E-14_JPRB, 0.52062821E-14_JPRB, 0.61921192E-14_JPRB, 0.73684260E-14_JPRB, &
  & 0.91141084E-14_JPRB, 0.12236485E-13_JPRB, 0.14008677E-13_JPRB, 0.19589780E-13_JPRB, 0.23987370E-13_JPRB, 0.30479556E-13_JPRB, &
  & 0.37343755E-13_JPRB, 0.43665406E-13_JPRB, 0.51055070E-13_JPRB, 0.56550562E-13_JPRB, 0.62204419E-13_JPRB, 0.64889649E-13_JPRB, &
  & 0.67855816E-13_JPRB, 0.70266113E-13_JPRB, 0.65148855E-13_JPRB, 0.61452193E-13_JPRB, 0.57044498E-13_JPRB, 0.54344641E-13_JPRB, &
  & 0.49378839E-13_JPRB, 0.44324218E-13_JPRB, 0.40310969E-13_JPRB, 0.38114189E-13_JPRB, 0.37302802E-13_JPRB, 0.38175409E-13_JPRB, &
  & 0.40530838E-13_JPRB, 0.43742021E-13_JPRB, 0.48053819E-13_JPRB, 0.49799293E-13_JPRB, 0.55049166E-13_JPRB, 0.58885412E-13_JPRB, &
  & 0.60067003E-13_JPRB, 0.55897293E-13_JPRB, 0.46895539E-13_JPRB, 0.40956632E-13_JPRB, 0.36657116E-13_JPRB, 0.32535593E-13_JPRB, &
  & 0.28825270E-13_JPRB, 0.25578450E-13_JPRB, 0.22747402E-13_JPRB, 0.20232490E-13_JPRB, 0.17969465E-13_JPRB, 0.15925995E-13_JPRB, &
  & 0.14105512E-13_JPRB, 0.12512791E-13_JPRB, 0.11144344E-13_JPRB, 0.99983337E-14_JPRB, 0.90418090E-14_JPRB, 0.82556761E-14_JPRB, &
  & 0.76163551E-14_JPRB, 0.70333851E-14_JPRB, 0.64388527E-14_JPRB, 0.54800808E-14_JPRB /)

RGHG5(:,16, 3) = (/ &
  & 0.72766779E-14_JPRB, 0.11826441E-13_JPRB, 0.14809372E-13_JPRB, 0.17324387E-13_JPRB, 0.19844276E-13_JPRB, 0.22451398E-13_JPRB, &
  & 0.25176365E-13_JPRB, 0.28186687E-13_JPRB, 0.31642874E-13_JPRB, 0.36015509E-13_JPRB, 0.41744853E-13_JPRB, 0.49179902E-13_JPRB, &
  & 0.59794353E-13_JPRB, 0.73474226E-13_JPRB, 0.87921708E-13_JPRB, 0.11258075E-12_JPRB, 0.13879531E-12_JPRB, 0.17176458E-12_JPRB, &
  & 0.20921741E-12_JPRB, 0.24548403E-12_JPRB, 0.28046673E-12_JPRB, 0.30941853E-12_JPRB, 0.33159396E-12_JPRB, 0.34740816E-12_JPRB, &
  & 0.35674274E-12_JPRB, 0.35265139E-12_JPRB, 0.36109554E-12_JPRB, 0.35309714E-12_JPRB, 0.32476327E-12_JPRB, 0.28811927E-12_JPRB, &
  & 0.26960232E-12_JPRB, 0.24441248E-12_JPRB, 0.22396028E-12_JPRB, 0.21256650E-12_JPRB, 0.20940157E-12_JPRB, 0.21558841E-12_JPRB, &
  & 0.23080973E-12_JPRB, 0.25346953E-12_JPRB, 0.28193165E-12_JPRB, 0.31013015E-12_JPRB, 0.33135089E-12_JPRB, 0.32957851E-12_JPRB, &
  & 0.31776629E-12_JPRB, 0.30328854E-12_JPRB, 0.28912476E-12_JPRB, 0.26916295E-12_JPRB, 0.24179009E-12_JPRB, 0.21444718E-12_JPRB, &
  & 0.19025538E-12_JPRB, 0.16942989E-12_JPRB, 0.15154356E-12_JPRB, 0.13580496E-12_JPRB, 0.12156785E-12_JPRB, 0.10851986E-12_JPRB, &
  & 0.96600767E-13_JPRB, 0.85886288E-13_JPRB, 0.76438367E-13_JPRB, 0.68297839E-13_JPRB, 0.61389519E-13_JPRB, 0.55731210E-13_JPRB, &
  & 0.51005390E-13_JPRB, 0.46926086E-13_JPRB, 0.42711223E-13_JPRB, 0.36405507E-13_JPRB /)

RGHG5(:,17, 3) = (/ &
  & 0.38958989E-13_JPRB, 0.60874889E-13_JPRB, 0.74863354E-13_JPRB, 0.87556278E-13_JPRB, 0.10076051E-12_JPRB, 0.11537716E-12_JPRB, &
  & 0.13117758E-12_JPRB, 0.14874359E-12_JPRB, 0.16824607E-12_JPRB, 0.19082134E-12_JPRB, 0.21800666E-12_JPRB, 0.25455508E-12_JPRB, &
  & 0.30204946E-12_JPRB, 0.35601922E-12_JPRB, 0.42511976E-12_JPRB, 0.51280762E-12_JPRB, 0.61563981E-12_JPRB, 0.74211362E-12_JPRB, &
  & 0.87822983E-12_JPRB, 0.10111867E-11_JPRB, 0.11326684E-11_JPRB, 0.12331774E-11_JPRB, 0.13109206E-11_JPRB, 0.13582763E-11_JPRB, &
  & 0.13830494E-11_JPRB, 0.14035410E-11_JPRB, 0.13569809E-11_JPRB, 0.12898108E-11_JPRB, 0.12494061E-11_JPRB, 0.12048197E-11_JPRB, &
  & 0.11281609E-11_JPRB, 0.10445115E-11_JPRB, 0.97838697E-12_JPRB, 0.94378932E-12_JPRB, 0.93798688E-12_JPRB, 0.96594596E-12_JPRB, &
  & 0.10252838E-11_JPRB, 0.11047170E-11_JPRB, 0.11869649E-11_JPRB, 0.12590927E-11_JPRB, 0.13297800E-11_JPRB, 0.13841957E-11_JPRB, &
  & 0.14014724E-11_JPRB, 0.13728066E-11_JPRB, 0.12972662E-11_JPRB, 0.11851015E-11_JPRB, 0.10640512E-11_JPRB, 0.95135640E-12_JPRB, &
  & 0.85120322E-12_JPRB, 0.76425883E-12_JPRB, 0.68871937E-12_JPRB, 0.62157956E-12_JPRB, 0.56036734E-12_JPRB, 0.50367024E-12_JPRB, &
  & 0.45111774E-12_JPRB, 0.40295187E-12_JPRB, 0.35957286E-12_JPRB, 0.32164272E-12_JPRB, 0.28932092E-12_JPRB, 0.26253915E-12_JPRB, &
  & 0.24069879E-12_JPRB, 0.22169632E-12_JPRB, 0.20278107E-12_JPRB, 0.17402581E-12_JPRB /)

RGHG5(:,18, 3) = (/ &
  & 0.16204423E-12_JPRB, 0.24956133E-12_JPRB, 0.30463880E-12_JPRB, 0.35313592E-12_JPRB, 0.40125515E-12_JPRB, 0.45721608E-12_JPRB, &
  & 0.52298481E-12_JPRB, 0.59994490E-12_JPRB, 0.68839406E-12_JPRB, 0.78800356E-12_JPRB, 0.89927371E-12_JPRB, 0.10324444E-11_JPRB, &
  & 0.11934504E-11_JPRB, 0.13744869E-11_JPRB, 0.15951655E-11_JPRB, 0.18568977E-11_JPRB, 0.21581599E-11_JPRB, 0.25028248E-11_JPRB, &
  & 0.28662374E-11_JPRB, 0.32204911E-11_JPRB, 0.35346235E-11_JPRB, 0.37792694E-11_JPRB, 0.39512035E-11_JPRB, 0.40440836E-11_JPRB, &
  & 0.40812284E-11_JPRB, 0.40482782E-11_JPRB, 0.39926330E-11_JPRB, 0.40084624E-11_JPRB, 0.39310890E-11_JPRB, 0.38002149E-11_JPRB, &
  & 0.36435629E-11_JPRB, 0.34932261E-11_JPRB, 0.33833561E-11_JPRB, 0.33469289E-11_JPRB, 0.33777440E-11_JPRB, 0.34903861E-11_JPRB, &
  & 0.36817029E-11_JPRB, 0.39254711E-11_JPRB, 0.41785512E-11_JPRB, 0.44053051E-11_JPRB, 0.45517548E-11_JPRB, 0.45961720E-11_JPRB, &
  & 0.45287723E-11_JPRB, 0.43458921E-11_JPRB, 0.40627358E-11_JPRB, 0.37241941E-11_JPRB, 0.33763495E-11_JPRB, 0.30431985E-11_JPRB, &
  & 0.27435519E-11_JPRB, 0.24798375E-11_JPRB, 0.22481420E-11_JPRB, 0.20405778E-11_JPRB, 0.18513220E-11_JPRB, 0.16755654E-11_JPRB, &
  & 0.15116672E-11_JPRB, 0.13598367E-11_JPRB, 0.12217622E-11_JPRB, 0.10997372E-11_JPRB, 0.99527971E-12_JPRB, 0.90935072E-12_JPRB, &
  & 0.83890669E-12_JPRB, 0.77839330E-12_JPRB, 0.72019067E-12_JPRB, 0.62421227E-12_JPRB /)

RGHG5(:,19, 3) = (/ &
  & 0.53067419E-12_JPRB, 0.79881376E-12_JPRB, 0.97997760E-12_JPRB, 0.11498849E-11_JPRB, 0.13201517E-11_JPRB, 0.15036212E-11_JPRB, &
  & 0.17113520E-11_JPRB, 0.19524844E-11_JPRB, 0.22339142E-11_JPRB, 0.25508404E-11_JPRB, 0.29019311E-11_JPRB, 0.32953835E-11_JPRB, &
  & 0.37405469E-11_JPRB, 0.42281495E-11_JPRB, 0.47735869E-11_JPRB, 0.53813455E-11_JPRB, 0.60547071E-11_JPRB, 0.67771253E-11_JPRB, &
  & 0.75156669E-11_JPRB, 0.82190305E-11_JPRB, 0.88158951E-11_JPRB, 0.92613287E-11_JPRB, 0.95361618E-11_JPRB, 0.96704667E-11_JPRB, &
  & 0.96899502E-11_JPRB, 0.96682402E-11_JPRB, 0.97172825E-11_JPRB, 0.96212942E-11_JPRB, 0.95331625E-11_JPRB, 0.94408760E-11_JPRB, &
  & 0.93790644E-11_JPRB, 0.93422327E-11_JPRB, 0.93670740E-11_JPRB, 0.95097810E-11_JPRB, 0.97336366E-11_JPRB, 0.10065396E-10_JPRB, &
  & 0.10485743E-10_JPRB, 0.10954248E-10_JPRB, 0.11373500E-10_JPRB, 0.11657770E-10_JPRB, 0.11759629E-10_JPRB, 0.11640027E-10_JPRB, &
  & 0.11287232E-10_JPRB, 0.10714958E-10_JPRB, 0.99754198E-11_JPRB, 0.91447362E-11_JPRB, 0.82999423E-11_JPRB, 0.75052169E-11_JPRB, &
  & 0.67933467E-11_JPRB, 0.61661527E-11_JPRB, 0.56147357E-11_JPRB, 0.51214324E-11_JPRB, 0.46735411E-11_JPRB, 0.42596725E-11_JPRB, &
  & 0.38750314E-11_JPRB, 0.35184911E-11_JPRB, 0.31922893E-11_JPRB, 0.29019651E-11_JPRB, 0.26527404E-11_JPRB, 0.24463105E-11_JPRB, &
  & 0.22755894E-11_JPRB, 0.21318641E-11_JPRB, 0.19817815E-11_JPRB, 0.17546659E-11_JPRB /)

RGHG5(:,20, 3) = (/ &
  & 0.14464651E-11_JPRB, 0.21272057E-11_JPRB, 0.25650322E-11_JPRB, 0.29737168E-11_JPRB, 0.34042068E-11_JPRB, 0.38744116E-11_JPRB, &
  & 0.44080403E-11_JPRB, 0.50168801E-11_JPRB, 0.57184739E-11_JPRB, 0.65025364E-11_JPRB, 0.73620840E-11_JPRB, 0.82858147E-11_JPRB, &
  & 0.92764000E-11_JPRB, 0.10320073E-10_JPRB, 0.11409622E-10_JPRB, 0.12551517E-10_JPRB, 0.13746004E-10_JPRB, 0.14963048E-10_JPRB, &
  & 0.16149819E-10_JPRB, 0.17235787E-10_JPRB, 0.18131113E-10_JPRB, 0.18762309E-10_JPRB, 0.19118124E-10_JPRB, 0.19228572E-10_JPRB, &
  & 0.19168349E-10_JPRB, 0.19124455E-10_JPRB, 0.19001975E-10_JPRB, 0.19021314E-10_JPRB, 0.19196280E-10_JPRB, 0.19507220E-10_JPRB, &
  & 0.19958309E-10_JPRB, 0.20451344E-10_JPRB, 0.21054377E-10_JPRB, 0.21772131E-10_JPRB, 0.22490863E-10_JPRB, 0.23254494E-10_JPRB, &
  & 0.24013725E-10_JPRB, 0.24624979E-10_JPRB, 0.24977728E-10_JPRB, 0.24985371E-10_JPRB, 0.24618923E-10_JPRB, 0.23867923E-10_JPRB, &
  & 0.22765718E-10_JPRB, 0.21363040E-10_JPRB, 0.19761916E-10_JPRB, 0.18081064E-10_JPRB, 0.16449774E-10_JPRB, 0.14944334E-10_JPRB, &
  & 0.13596744E-10_JPRB, 0.12403111E-10_JPRB, 0.11348663E-10_JPRB, 0.10407045E-10_JPRB, 0.95569256E-11_JPRB, 0.87783522E-11_JPRB, &
  & 0.80603822E-11_JPRB, 0.73964767E-11_JPRB, 0.67873914E-11_JPRB, 0.62420303E-11_JPRB, 0.57693746E-11_JPRB, 0.53742471E-11_JPRB, &
  & 0.50517012E-11_JPRB, 0.47627314E-11_JPRB, 0.44728921E-11_JPRB, 0.39927658E-11_JPRB /)

RGHG5(:,21, 3) = (/ &
  & 0.32824151E-11_JPRB, 0.46669829E-11_JPRB, 0.55680447E-11_JPRB, 0.64042799E-11_JPRB, 0.72682203E-11_JPRB, 0.82107099E-11_JPRB, &
  & 0.92590354E-11_JPRB, 0.10464034E-10_JPRB, 0.11837785E-10_JPRB, 0.13365207E-10_JPRB, 0.15021023E-10_JPRB, 0.16764068E-10_JPRB, &
  & 0.18560551E-10_JPRB, 0.20388051E-10_JPRB, 0.22214341E-10_JPRB, 0.24018249E-10_JPRB, 0.25794727E-10_JPRB, 0.27519438E-10_JPRB, &
  & 0.29142137E-10_JPRB, 0.30590620E-10_JPRB, 0.31766170E-10_JPRB, 0.32601727E-10_JPRB, 0.33046951E-10_JPRB, 0.33149681E-10_JPRB, &
  & 0.33105726E-10_JPRB, 0.32859611E-10_JPRB, 0.32779029E-10_JPRB, 0.33028628E-10_JPRB, 0.33634262E-10_JPRB, 0.34639614E-10_JPRB, &
  & 0.35971726E-10_JPRB, 0.37490556E-10_JPRB, 0.39192618E-10_JPRB, 0.40868656E-10_JPRB, 0.42409704E-10_JPRB, 0.43711302E-10_JPRB, &
  & 0.44680468E-10_JPRB, 0.45129088E-10_JPRB, 0.44988860E-10_JPRB, 0.44209542E-10_JPRB, 0.42831707E-10_JPRB, 0.40932497E-10_JPRB, &
  & 0.38611420E-10_JPRB, 0.35985909E-10_JPRB, 0.33199755E-10_JPRB, 0.30414438E-10_JPRB, 0.27767920E-10_JPRB, 0.25341949E-10_JPRB, &
  & 0.23169116E-10_JPRB, 0.21243868E-10_JPRB, 0.19541493E-10_JPRB, 0.18026127E-10_JPRB, 0.16667145E-10_JPRB, 0.15433613E-10_JPRB, &
  & 0.14304250E-10_JPRB, 0.13262149E-10_JPRB, 0.12302388E-10_JPRB, 0.11432841E-10_JPRB, 0.10671049E-10_JPRB, 0.10027283E-10_JPRB, &
  & 0.94836534E-11_JPRB, 0.89950686E-11_JPRB, 0.84583816E-11_JPRB, 0.76827190E-11_JPRB /)

RGHG5(:,22, 3) = (/ &
  & 0.63936304E-11_JPRB, 0.87687062E-11_JPRB, 0.10272495E-10_JPRB, 0.11672217E-10_JPRB, 0.13130187E-10_JPRB, 0.14707643E-10_JPRB, &
  & 0.16448211E-10_JPRB, 0.18407329E-10_JPRB, 0.20611476E-10_JPRB, 0.23035251E-10_JPRB, 0.25636004E-10_JPRB, 0.28343890E-10_JPRB, &
  & 0.31070452E-10_JPRB, 0.33769404E-10_JPRB, 0.36400070E-10_JPRB, 0.38927604E-10_JPRB, 0.41330377E-10_JPRB, 0.43585312E-10_JPRB, &
  & 0.45656069E-10_JPRB, 0.47488062E-10_JPRB, 0.48991439E-10_JPRB, 0.50086647E-10_JPRB, 0.50738046E-10_JPRB, 0.50999094E-10_JPRB, &
  & 0.50900919E-10_JPRB, 0.50754137E-10_JPRB, 0.50815446E-10_JPRB, 0.51311448E-10_JPRB, 0.52379146E-10_JPRB, 0.54142312E-10_JPRB, &
  & 0.56416372E-10_JPRB, 0.59116823E-10_JPRB, 0.61947468E-10_JPRB, 0.64674627E-10_JPRB, 0.67002640E-10_JPRB, 0.68710350E-10_JPRB, &
  & 0.69629871E-10_JPRB, 0.69611886E-10_JPRB, 0.68615891E-10_JPRB, 0.66712628E-10_JPRB, 0.64034049E-10_JPRB, 0.60752327E-10_JPRB, &
  & 0.57045500E-10_JPRB, 0.53091496E-10_JPRB, 0.49058028E-10_JPRB, 0.45113129E-10_JPRB, 0.41397986E-10_JPRB, 0.37997556E-10_JPRB, &
  & 0.34948627E-10_JPRB, 0.32234625E-10_JPRB, 0.29828209E-10_JPRB, 0.27695492E-10_JPRB, 0.25792342E-10_JPRB, 0.24073923E-10_JPRB, &
  & 0.22504667E-10_JPRB, 0.21054254E-10_JPRB, 0.19709248E-10_JPRB, 0.18476054E-10_JPRB, 0.17371495E-10_JPRB, 0.16410687E-10_JPRB, &
  & 0.15585224E-10_JPRB, 0.14795123E-10_JPRB, 0.14014970E-10_JPRB, 0.12741884E-10_JPRB /)

RGHG5(:,23, 3) = (/ &
  & 0.10979526E-10_JPRB, 0.14546574E-10_JPRB, 0.16768070E-10_JPRB, 0.18786552E-10_JPRB, 0.20876922E-10_JPRB, 0.23144788E-10_JPRB, &
  & 0.25650374E-10_JPRB, 0.28398334E-10_JPRB, 0.31442047E-10_JPRB, 0.34757190E-10_JPRB, 0.38280101E-10_JPRB, 0.41935327E-10_JPRB, &
  & 0.45604496E-10_JPRB, 0.49188938E-10_JPRB, 0.52620939E-10_JPRB, 0.55861260E-10_JPRB, 0.58890198E-10_JPRB, 0.61693289E-10_JPRB, &
  & 0.64248454E-10_JPRB, 0.66538636E-10_JPRB, 0.68466899E-10_JPRB, 0.69955847E-10_JPRB, 0.70986966E-10_JPRB, 0.71535486E-10_JPRB, &
  & 0.71692131E-10_JPRB, 0.71725993E-10_JPRB, 0.71943951E-10_JPRB, 0.72666706E-10_JPRB, 0.74152233E-10_JPRB, 0.76428877E-10_JPRB, &
  & 0.79506159E-10_JPRB, 0.83070752E-10_JPRB, 0.86717314E-10_JPRB, 0.90144330E-10_JPRB, 0.92851109E-10_JPRB, 0.94575556E-10_JPRB, &
  & 0.95124311E-10_JPRB, 0.94378345E-10_JPRB, 0.92414465E-10_JPRB, 0.89359235E-10_JPRB, 0.85456024E-10_JPRB, 0.80936174E-10_JPRB, &
  & 0.76050707E-10_JPRB, 0.70979667E-10_JPRB, 0.65890154E-10_JPRB, 0.60943237E-10_JPRB, 0.56278822E-10_JPRB, 0.51996567E-10_JPRB, &
  & 0.48129487E-10_JPRB, 0.44676214E-10_JPRB, 0.41622594E-10_JPRB, 0.38915319E-10_JPRB, 0.36500577E-10_JPRB, 0.34318871E-10_JPRB, &
  & 0.32319043E-10_JPRB, 0.30459208E-10_JPRB, 0.28716828E-10_JPRB, 0.27092993E-10_JPRB, 0.25609995E-10_JPRB, 0.24290623E-10_JPRB, &
  & 0.23078931E-10_JPRB, 0.21972155E-10_JPRB, 0.20770810E-10_JPRB, 0.19023678E-10_JPRB /)

RGHG5(:,24, 3) = (/ &
  & 0.17089092E-10_JPRB, 0.21874291E-10_JPRB, 0.24794822E-10_JPRB, 0.27440054E-10_JPRB, 0.30137823E-10_JPRB, 0.33042395E-10_JPRB, &
  & 0.36230321E-10_JPRB, 0.39728783E-10_JPRB, 0.43498791E-10_JPRB, 0.47561639E-10_JPRB, 0.51865484E-10_JPRB, 0.56304780E-10_JPRB, &
  & 0.60763720E-10_JPRB, 0.65133982E-10_JPRB, 0.69319092E-10_JPRB, 0.73258434E-10_JPRB, 0.76934764E-10_JPRB, 0.80339485E-10_JPRB, &
  & 0.83459586E-10_JPRB, 0.86282835E-10_JPRB, 0.88731480E-10_JPRB, 0.90758248E-10_JPRB, 0.92290627E-10_JPRB, 0.93275575E-10_JPRB, &
  & 0.93852370E-10_JPRB, 0.94192973E-10_JPRB, 0.94650655E-10_JPRB, 0.95604531E-10_JPRB, 0.97290356E-10_JPRB, 0.99924326E-10_JPRB, &
  & 0.10336747E-09_JPRB, 0.10728440E-09_JPRB, 0.11122524E-09_JPRB, 0.11477677E-09_JPRB, 0.11735715E-09_JPRB, 0.11868841E-09_JPRB, &
  & 0.11861059E-09_JPRB, 0.11703941E-09_JPRB, 0.11415980E-09_JPRB, 0.11016010E-09_JPRB, 0.10536674E-09_JPRB, 0.10000538E-09_JPRB, &
  & 0.94334165E-10_JPRB, 0.88525229E-10_JPRB, 0.82708819E-10_JPRB, 0.77034698E-10_JPRB, 0.71638931E-10_JPRB, 0.66636544E-10_JPRB, &
  & 0.62095863E-10_JPRB, 0.58031389E-10_JPRB, 0.54419011E-10_JPRB, 0.51217881E-10_JPRB, 0.48354237E-10_JPRB, 0.45751829E-10_JPRB, &
  & 0.43344571E-10_JPRB, 0.41080399E-10_JPRB, 0.38932402E-10_JPRB, 0.36899480E-10_JPRB, 0.35007140E-10_JPRB, 0.33242700E-10_JPRB, &
  & 0.31626875E-10_JPRB, 0.30079821E-10_JPRB, 0.28512661E-10_JPRB, 0.26049980E-10_JPRB /)

RGHG5(:,25, 3) = (/ &
  & 0.24622434E-10_JPRB, 0.30515684E-10_JPRB, 0.34050068E-10_JPRB, 0.37198238E-10_JPRB, 0.40402764E-10_JPRB, 0.43845965E-10_JPRB, &
  & 0.47584704E-10_JPRB, 0.51641618E-10_JPRB, 0.56001131E-10_JPRB, 0.60652795E-10_JPRB, 0.65555700E-10_JPRB, 0.70637066E-10_JPRB, &
  & 0.75768850E-10_JPRB, 0.80806736E-10_JPRB, 0.85650133E-10_JPRB, 0.90230760E-10_JPRB, 0.94519677E-10_JPRB, 0.98506731E-10_JPRB, &
  & 0.10218806E-09_JPRB, 0.10555682E-09_JPRB, 0.10856756E-09_JPRB, 0.11116023E-09_JPRB, 0.11324727E-09_JPRB, 0.11478188E-09_JPRB, &
  & 0.11587565E-09_JPRB, 0.11663284E-09_JPRB, 0.11743632E-09_JPRB, 0.11859222E-09_JPRB, 0.12044520E-09_JPRB, 0.12314109E-09_JPRB, &
  & 0.12653462E-09_JPRB, 0.13034357E-09_JPRB, 0.13405721E-09_JPRB, 0.13721982E-09_JPRB, 0.13927519E-09_JPRB, 0.13994136E-09_JPRB, &
  & 0.13909950E-09_JPRB, 0.13675376E-09_JPRB, 0.13316652E-09_JPRB, 0.12856315E-09_JPRB, 0.12324285E-09_JPRB, 0.11745485E-09_JPRB, &
  & 0.11141103E-09_JPRB, 0.10523644E-09_JPRB, 0.99023297E-10_JPRB, 0.92887115E-10_JPRB, 0.86977842E-10_JPRB, 0.81451741E-10_JPRB, &
  & 0.76399560E-10_JPRB, 0.71857631E-10_JPRB, 0.67819167E-10_JPRB, 0.64221732E-10_JPRB, 0.60979916E-10_JPRB, 0.58002540E-10_JPRB, &
  & 0.55209434E-10_JPRB, 0.52542783E-10_JPRB, 0.49970042E-10_JPRB, 0.47499029E-10_JPRB, 0.45150224E-10_JPRB, 0.42933219E-10_JPRB, &
  & 0.40861911E-10_JPRB, 0.38905726E-10_JPRB, 0.36821338E-10_JPRB, 0.33685495E-10_JPRB /)

RGHG5(:,26, 3) = (/ &
  & 0.33354916E-10_JPRB, 0.40186462E-10_JPRB, 0.44178071E-10_JPRB, 0.47723388E-10_JPRB, 0.51290923E-10_JPRB, 0.55090824E-10_JPRB, &
  & 0.59247218E-10_JPRB, 0.63708552E-10_JPRB, 0.68479562E-10_JPRB, 0.73530591E-10_JPRB, 0.78853223E-10_JPRB, 0.84381752E-10_JPRB, &
  & 0.90025112E-10_JPRB, 0.95628797E-10_JPRB, 0.10104917E-09_JPRB, 0.10619726E-09_JPRB, 0.11103957E-09_JPRB, 0.11556399E-09_JPRB, &
  & 0.11977086E-09_JPRB, 0.12365256E-09_JPRB, 0.12717669E-09_JPRB, 0.13029164E-09_JPRB, 0.13291879E-09_JPRB, 0.13503229E-09_JPRB, &
  & 0.13667180E-09_JPRB, 0.13796234E-09_JPRB, 0.13915105E-09_JPRB, 0.14055306E-09_JPRB, 0.14250318E-09_JPRB, 0.14503648E-09_JPRB, &
  & 0.14815159E-09_JPRB, 0.15147453E-09_JPRB, 0.15458497E-09_JPRB, 0.15703769E-09_JPRB, 0.15833980E-09_JPRB, 0.15824687E-09_JPRB, &
  & 0.15669249E-09_JPRB, 0.15375817E-09_JPRB, 0.14969541E-09_JPRB, 0.14479540E-09_JPRB, 0.13932600E-09_JPRB, 0.13346774E-09_JPRB, &
  & 0.12737163E-09_JPRB, 0.12111540E-09_JPRB, 0.11474450E-09_JPRB, 0.10836694E-09_JPRB, 0.10215592E-09_JPRB, 0.96284480E-10_JPRB, &
  & 0.90883995E-10_JPRB, 0.86004349E-10_JPRB, 0.81629918E-10_JPRB, 0.77711768E-10_JPRB, 0.74148597E-10_JPRB, 0.70833069E-10_JPRB, &
  & 0.67676101E-10_JPRB, 0.64613287E-10_JPRB, 0.61614144E-10_JPRB, 0.58693717E-10_JPRB, 0.55855869E-10_JPRB, 0.53163488E-10_JPRB, &
  & 0.50637571E-10_JPRB, 0.48211577E-10_JPRB, 0.45668552E-10_JPRB, 0.41771475E-10_JPRB /)

RGHG5(:,27, 3) = (/ &
  & 0.43109093E-10_JPRB, 0.50499386E-10_JPRB, 0.54850364E-10_JPRB, 0.58649037E-10_JPRB, 0.62459427E-10_JPRB, 0.66503643E-10_JPRB, &
  & 0.70873744E-10_JPRB, 0.75607048E-10_JPRB, 0.80615098E-10_JPRB, 0.85921659E-10_JPRB, 0.91527910E-10_JPRB, 0.97368016E-10_JPRB, &
  & 0.10334996E-09_JPRB, 0.10934030E-09_JPRB, 0.11521026E-09_JPRB, 0.12085358E-09_JPRB, 0.12621200E-09_JPRB, 0.13124163E-09_JPRB, &
  & 0.13592269E-09_JPRB, 0.14023906E-09_JPRB, 0.14418541E-09_JPRB, 0.14772665E-09_JPRB, 0.15082079E-09_JPRB, 0.15344630E-09_JPRB, &
  & 0.15562621E-09_JPRB, 0.15746075E-09_JPRB, 0.15909778E-09_JPRB, 0.16079046E-09_JPRB, 0.16273019E-09_JPRB, 0.16503482E-09_JPRB, &
  & 0.16765006E-09_JPRB, 0.17029700E-09_JPRB, 0.17262014E-09_JPRB, 0.17423794E-09_JPRB, 0.17473972E-09_JPRB, 0.17392869E-09_JPRB, &
  & 0.17178091E-09_JPRB, 0.16844091E-09_JPRB, 0.16422287E-09_JPRB, 0.15936776E-09_JPRB, 0.15402497E-09_JPRB, 0.14835563E-09_JPRB, &
  & 0.14244955E-09_JPRB, 0.13631818E-09_JPRB, 0.13000455E-09_JPRB, 0.12357580E-09_JPRB, 0.11722073E-09_JPRB, 0.11114761E-09_JPRB, &
  & 0.10550627E-09_JPRB, 0.10036773E-09_JPRB, 0.95739500E-10_JPRB, 0.91550753E-10_JPRB, 0.87702845E-10_JPRB, 0.84072395E-10_JPRB, &
  & 0.80563951E-10_JPRB, 0.77109992E-10_JPRB, 0.73670632E-10_JPRB, 0.70280053E-10_JPRB, 0.66963574E-10_JPRB, 0.63797960E-10_JPRB, &
  & 0.60816657E-10_JPRB, 0.57955821E-10_JPRB, 0.54951536E-10_JPRB, 0.50295604E-10_JPRB /)

RGHG5(:,28, 3) = (/ &
  & 0.53446702E-10_JPRB, 0.61318985E-10_JPRB, 0.65785107E-10_JPRB, 0.69740963E-10_JPRB, 0.73701184E-10_JPRB, 0.77865915E-10_JPRB, &
  & 0.82357531E-10_JPRB, 0.87190172E-10_JPRB, 0.92335646E-10_JPRB, 0.97770597E-10_JPRB, 0.10353045E-09_JPRB, 0.10959469E-09_JPRB, &
  & 0.11587635E-09_JPRB, 0.12222921E-09_JPRB, 0.12848601E-09_JPRB, 0.13451266E-09_JPRB, 0.14024232E-09_JPRB, 0.14563251E-09_JPRB, &
  & 0.15065785E-09_JPRB, 0.15529580E-09_JPRB, 0.15954622E-09_JPRB, 0.16339907E-09_JPRB, 0.16684398E-09_JPRB, 0.16987223E-09_JPRB, &
  & 0.17250172E-09_JPRB, 0.17478410E-09_JPRB, 0.17681757E-09_JPRB, 0.17874562E-09_JPRB, 0.18067167E-09_JPRB, 0.18270642E-09_JPRB, &
  & 0.18478676E-09_JPRB, 0.18672146E-09_JPRB, 0.18823683E-09_JPRB, 0.18904543E-09_JPRB, 0.18882416E-09_JPRB, 0.18743598E-09_JPRB, &
  & 0.18492315E-09_JPRB, 0.18147500E-09_JPRB, 0.17731575E-09_JPRB, 0.17266370E-09_JPRB, 0.16766920E-09_JPRB, 0.16237342E-09_JPRB, &
  & 0.15680933E-09_JPRB, 0.15096609E-09_JPRB, 0.14482389E-09_JPRB, 0.13848815E-09_JPRB, 0.13212317E-09_JPRB, 0.12596375E-09_JPRB, &
  & 0.12017932E-09_JPRB, 0.11486718E-09_JPRB, 0.11002769E-09_JPRB, 0.10560222E-09_JPRB, 0.10148933E-09_JPRB, 0.97560349E-10_JPRB, &
  & 0.93720698E-10_JPRB, 0.89888062E-10_JPRB, 0.86041653E-10_JPRB, 0.82177272E-10_JPRB, 0.78381232E-10_JPRB, 0.74745224E-10_JPRB, &
  & 0.71313559E-10_JPRB, 0.68034745E-10_JPRB, 0.64567483E-10_JPRB, 0.59269402E-10_JPRB /)

RGHG5(:,29, 3) = (/ &
  & 0.64226867E-10_JPRB, 0.72179936E-10_JPRB, 0.76822736E-10_JPRB, 0.80815542E-10_JPRB, 0.84809437E-10_JPRB, 0.89047283E-10_JPRB, &
  & 0.93553366E-10_JPRB, 0.98394293E-10_JPRB, 0.10355838E-09_JPRB, 0.10903482E-09_JPRB, 0.11483717E-09_JPRB, 0.12098653E-09_JPRB, &
  & 0.12739768E-09_JPRB, 0.13396539E-09_JPRB, 0.14053113E-09_JPRB, 0.14691270E-09_JPRB, 0.15299367E-09_JPRB, 0.15870524E-09_JPRB, &
  & 0.16401326E-09_JPRB, 0.16889697E-09_JPRB, 0.17336504E-09_JPRB, 0.17742458E-09_JPRB, 0.18110499E-09_JPRB, 0.18441004E-09_JPRB, &
  & 0.18736604E-09_JPRB, 0.18997405E-09_JPRB, 0.19229308E-09_JPRB, 0.19436430E-09_JPRB, 0.19624639E-09_JPRB, 0.19800082E-09_JPRB, &
  & 0.19957756E-09_JPRB, 0.20085103E-09_JPRB, 0.20164957E-09_JPRB, 0.20176090E-09_JPRB, 0.20096555E-09_JPRB, 0.19918461E-09_JPRB, &
  & 0.19648870E-09_JPRB, 0.19305579E-09_JPRB, 0.18915121E-09_JPRB, 0.18492677E-09_JPRB, 0.18041174E-09_JPRB, 0.17560436E-09_JPRB, &
  & 0.17048996E-09_JPRB, 0.16500087E-09_JPRB, 0.15915626E-09_JPRB, 0.15300254E-09_JPRB, 0.14674167E-09_JPRB, 0.14059146E-09_JPRB, &
  & 0.13473994E-09_JPRB, 0.12930763E-09_JPRB, 0.12429530E-09_JPRB, 0.11965851E-09_JPRB, 0.11530715E-09_JPRB, 0.11110544E-09_JPRB, &
  & 0.10695925E-09_JPRB, 0.10278495E-09_JPRB, 0.98538136E-10_JPRB, 0.94243030E-10_JPRB, 0.89983861E-10_JPRB, 0.85881892E-10_JPRB, &
  & 0.82007984E-10_JPRB, 0.78319830E-10_JPRB, 0.74479631E-10_JPRB, 0.68508192E-10_JPRB /)

RGHG5(:,30, 3) = (/ &
  & 0.74999604E-10_JPRB, 0.83123924E-10_JPRB, 0.87685054E-10_JPRB, 0.91728083E-10_JPRB, 0.95729535E-10_JPRB, 0.99920378E-10_JPRB, &
  & 0.10441671E-09_JPRB, 0.10920663E-09_JPRB, 0.11429348E-09_JPRB, 0.11973759E-09_JPRB, 0.12555217E-09_JPRB, 0.13172713E-09_JPRB, &
  & 0.13819901E-09_JPRB, 0.14486408E-09_JPRB, 0.15161160E-09_JPRB, 0.15825445E-09_JPRB, 0.16461107E-09_JPRB, 0.17058462E-09_JPRB, &
  & 0.17611680E-09_JPRB, 0.18118497E-09_JPRB, 0.18579931E-09_JPRB, 0.18999315E-09_JPRB, 0.19380832E-09_JPRB, 0.19727042E-09_JPRB, &
  & 0.20041081E-09_JPRB, 0.20318928E-09_JPRB, 0.20566665E-09_JPRB, 0.20777406E-09_JPRB, 0.20956624E-09_JPRB, 0.21104769E-09_JPRB, &
  & 0.21218161E-09_JPRB, 0.21290643E-09_JPRB, 0.21312183E-09_JPRB, 0.21269911E-09_JPRB, 0.21150057E-09_JPRB, 0.20949706E-09_JPRB, &
  & 0.20680543E-09_JPRB, 0.20362882E-09_JPRB, 0.20011318E-09_JPRB, 0.19633391E-09_JPRB, 0.19231493E-09_JPRB, 0.18801272E-09_JPRB, &
  & 0.18337097E-09_JPRB, 0.17830638E-09_JPRB, 0.17278037E-09_JPRB, 0.16689382E-09_JPRB, 0.16080764E-09_JPRB, 0.15474108E-09_JPRB, &
  & 0.14890969E-09_JPRB, 0.14340222E-09_JPRB, 0.13826515E-09_JPRB, 0.13346470E-09_JPRB, 0.12890024E-09_JPRB, 0.12446943E-09_JPRB, &
  & 0.12006809E-09_JPRB, 0.11560179E-09_JPRB, 0.11101844E-09_JPRB, 0.10633308E-09_JPRB, 0.10163555E-09_JPRB, 0.97079317E-10_JPRB, &
  & 0.92783226E-10_JPRB, 0.88709567E-10_JPRB, 0.84466587E-10_JPRB, 0.77949876E-10_JPRB /)

RGHG5(:,31, 3) = (/ &
  & 0.85771147E-10_JPRB, 0.93781219E-10_JPRB, 0.98425060E-10_JPRB, 0.10239153E-09_JPRB, 0.10635752E-09_JPRB, 0.11051571E-09_JPRB, &
  & 0.11491657E-09_JPRB, 0.11962520E-09_JPRB, 0.12461188E-09_JPRB, 0.12993721E-09_JPRB, 0.13566341E-09_JPRB, 0.14182520E-09_JPRB, &
  & 0.14836764E-09_JPRB, 0.15510600E-09_JPRB, 0.16192422E-09_JPRB, 0.16870297E-09_JPRB, 0.17524972E-09_JPRB, 0.18141137E-09_JPRB, &
  & 0.18710372E-09_JPRB, 0.19230030E-09_JPRB, 0.19700593E-09_JPRB, 0.20126666E-09_JPRB, 0.20513670E-09_JPRB, 0.20864403E-09_JPRB, &
  & 0.21183734E-09_JPRB, 0.21463822E-09_JPRB, 0.21714101E-09_JPRB, 0.21918038E-09_JPRB, 0.22084408E-09_JPRB, 0.22206914E-09_JPRB, &
  & 0.22283915E-09_JPRB, 0.22314828E-09_JPRB, 0.22293055E-09_JPRB, 0.22215235E-09_JPRB, 0.22072558E-09_JPRB, 0.21869090E-09_JPRB, &
  & 0.21617177E-09_JPRB, 0.21328160E-09_JPRB, 0.21014937E-09_JPRB, 0.20684418E-09_JPRB, 0.20331406E-09_JPRB, 0.19948830E-09_JPRB, &
  & 0.19528534E-09_JPRB, 0.19060964E-09_JPRB, 0.18544881E-09_JPRB, 0.17985788E-09_JPRB, 0.17400048E-09_JPRB, 0.16810768E-09_JPRB, &
  & 0.16233898E-09_JPRB, 0.15684121E-09_JPRB, 0.15164044E-09_JPRB, 0.14671585E-09_JPRB, 0.14200491E-09_JPRB, 0.13740652E-09_JPRB, &
  & 0.13281307E-09_JPRB, 0.12813617E-09_JPRB, 0.12329135E-09_JPRB, 0.11829038E-09_JPRB, 0.11321376E-09_JPRB, 0.10825410E-09_JPRB, &
  & 0.10354997E-09_JPRB, 0.99133202E-10_JPRB, 0.94555835E-10_JPRB, 0.87478344E-10_JPRB /)

RGHG5(:,32, 3) = (/ &
  & 0.96296061E-10_JPRB, 0.10435602E-09_JPRB, 0.10884781E-09_JPRB, 0.11281213E-09_JPRB, 0.11670648E-09_JPRB, 0.12076989E-09_JPRB, &
  & 0.12509103E-09_JPRB, 0.12966188E-09_JPRB, 0.13451615E-09_JPRB, 0.13970736E-09_JPRB, 0.14529861E-09_JPRB, 0.15130461E-09_JPRB, &
  & 0.15776207E-09_JPRB, 0.16455867E-09_JPRB, 0.17146698E-09_JPRB, 0.17832547E-09_JPRB, 0.18498045E-09_JPRB, 0.19126292E-09_JPRB, &
  & 0.19706337E-09_JPRB, 0.20233598E-09_JPRB, 0.20708542E-09_JPRB, 0.21136963E-09_JPRB, 0.21521443E-09_JPRB, 0.21870053E-09_JPRB, &
  & 0.22181096E-09_JPRB, 0.22453889E-09_JPRB, 0.22693980E-09_JPRB, 0.22884664E-09_JPRB, 0.23033919E-09_JPRB, 0.23133713E-09_JPRB, &
  & 0.23183061E-09_JPRB, 0.23184490E-09_JPRB, 0.23135129E-09_JPRB, 0.23037415E-09_JPRB, 0.22886812E-09_JPRB, 0.22690777E-09_JPRB, &
  & 0.22458679E-09_JPRB, 0.22202225E-09_JPRB, 0.21931554E-09_JPRB, 0.21646261E-09_JPRB, 0.21338448E-09_JPRB, 0.20996406E-09_JPRB, &
  & 0.20610906E-09_JPRB, 0.20176337E-09_JPRB, 0.19691739E-09_JPRB, 0.19163277E-09_JPRB, 0.18605618E-09_JPRB, 0.18035673E-09_JPRB, &
  & 0.17475389E-09_JPRB, 0.16931942E-09_JPRB, 0.16411894E-09_JPRB, 0.15915912E-09_JPRB, 0.15436567E-09_JPRB, 0.14968028E-09_JPRB, &
  & 0.14499156E-09_JPRB, 0.14018967E-09_JPRB, 0.13519325E-09_JPRB, 0.12998067E-09_JPRB, 0.12462788E-09_JPRB, 0.11933476E-09_JPRB, &
  & 0.11433059E-09_JPRB, 0.10960243E-09_JPRB, 0.10471425E-09_JPRB, 0.97138880E-10_JPRB /)

RGHG5(:,33, 3) = (/ &
  & 0.10672456E-09_JPRB, 0.11458909E-09_JPRB, 0.11910278E-09_JPRB, 0.12293312E-09_JPRB, 0.12675394E-09_JPRB, 0.13073007E-09_JPRB, &
  & 0.13492470E-09_JPRB, 0.13934827E-09_JPRB, 0.14402865E-09_JPRB, 0.14902930E-09_JPRB, 0.15444655E-09_JPRB, 0.16032972E-09_JPRB, &
  & 0.16662861E-09_JPRB, 0.17330570E-09_JPRB, 0.18021025E-09_JPRB, 0.18711958E-09_JPRB, 0.19384316E-09_JPRB, 0.20019444E-09_JPRB, &
  & 0.20604836E-09_JPRB, 0.21135554E-09_JPRB, 0.21610151E-09_JPRB, 0.22036239E-09_JPRB, 0.22412704E-09_JPRB, 0.22752529E-09_JPRB, &
  & 0.23047919E-09_JPRB, 0.23305435E-09_JPRB, 0.23526783E-09_JPRB, 0.23699540E-09_JPRB, 0.23829527E-09_JPRB, 0.23909685E-09_JPRB, &
  & 0.23939647E-09_JPRB, 0.23922603E-09_JPRB, 0.23859995E-09_JPRB, 0.23755733E-09_JPRB, 0.23610039E-09_JPRB, 0.23430460E-09_JPRB, &
  & 0.23226737E-09_JPRB, 0.23008029E-09_JPRB, 0.22776236E-09_JPRB, 0.22526650E-09_JPRB, 0.22250765E-09_JPRB, 0.21938761E-09_JPRB, &
  & 0.21580478E-09_JPRB, 0.21170046E-09_JPRB, 0.20709692E-09_JPRB, 0.20207198E-09_JPRB, 0.19675350E-09_JPRB, 0.19132865E-09_JPRB, &
  & 0.18590084E-09_JPRB, 0.18061264E-09_JPRB, 0.17549945E-09_JPRB, 0.17056373E-09_JPRB, 0.16578583E-09_JPRB, 0.16109605E-09_JPRB, &
  & 0.15639751E-09_JPRB, 0.15158484E-09_JPRB, 0.14655989E-09_JPRB, 0.14127037E-09_JPRB, 0.13578066E-09_JPRB, 0.13031103E-09_JPRB, &
  & 0.12507885E-09_JPRB, 0.12014455E-09_JPRB, 0.11500782E-09_JPRB, 0.10695832E-09_JPRB /)

RGHG5(:,34, 3) = (/ &
  & 0.11689119E-09_JPRB, 0.12470937E-09_JPRB, 0.12902074E-09_JPRB, 0.13281151E-09_JPRB, 0.13652034E-09_JPRB, 0.14037037E-09_JPRB, &
  & 0.14444003E-09_JPRB, 0.14868787E-09_JPRB, 0.15316762E-09_JPRB, 0.15794197E-09_JPRB, 0.16310446E-09_JPRB, 0.16875001E-09_JPRB, &
  & 0.17490252E-09_JPRB, 0.18146652E-09_JPRB, 0.18828572E-09_JPRB, 0.19515969E-09_JPRB, 0.20187962E-09_JPRB, 0.20823897E-09_JPRB, &
  & 0.21409652E-09_JPRB, 0.21939316E-09_JPRB, 0.22409453E-09_JPRB, 0.22829047E-09_JPRB, 0.23193499E-09_JPRB, 0.23518976E-09_JPRB, &
  & 0.23794416E-09_JPRB, 0.24030450E-09_JPRB, 0.24228011E-09_JPRB, 0.24378985E-09_JPRB, 0.24488928E-09_JPRB, 0.24552332E-09_JPRB, &
  & 0.24569755E-09_JPRB, 0.24544433E-09_JPRB, 0.24479938E-09_JPRB, 0.24381155E-09_JPRB, 0.24250016E-09_JPRB, 0.24094901E-09_JPRB, &
  & 0.23923419E-09_JPRB, 0.23739474E-09_JPRB, 0.23540786E-09_JPRB, 0.23320440E-09_JPRB, 0.23067848E-09_JPRB, 0.22772863E-09_JPRB, &
  & 0.22428170E-09_JPRB, 0.22033082E-09_JPRB, 0.21590488E-09_JPRB, 0.21111035E-09_JPRB, 0.20606980E-09_JPRB, 0.20088273E-09_JPRB, &
  & 0.19570466E-09_JPRB, 0.19059718E-09_JPRB, 0.18562121E-09_JPRB, 0.18080436E-09_JPRB, 0.17610952E-09_JPRB, 0.17150195E-09_JPRB, &
  & 0.16688823E-09_JPRB, 0.16216459E-09_JPRB, 0.15723062E-09_JPRB, 0.15201065E-09_JPRB, 0.14655720E-09_JPRB, 0.14104745E-09_JPRB, &
  & 0.13575344E-09_JPRB, 0.13069229E-09_JPRB, 0.12536670E-09_JPRB, 0.11694279E-09_JPRB /)

RGHG5(:,35, 3) = (/ &
  & 0.12693616E-09_JPRB, 0.13446093E-09_JPRB, 0.13874779E-09_JPRB, 0.14237495E-09_JPRB, 0.14598667E-09_JPRB, 0.14972319E-09_JPRB, &
  & 0.15361795E-09_JPRB, 0.15767419E-09_JPRB, 0.16191763E-09_JPRB, 0.16642751E-09_JPRB, 0.17131838E-09_JPRB, 0.17667905E-09_JPRB, &
  & 0.18256069E-09_JPRB, 0.18892803E-09_JPRB, 0.19563140E-09_JPRB, 0.20244065E-09_JPRB, 0.20911131E-09_JPRB, 0.21543105E-09_JPRB, &
  & 0.22124197E-09_JPRB, 0.22648308E-09_JPRB, 0.23110464E-09_JPRB, 0.23519248E-09_JPRB, 0.23868829E-09_JPRB, 0.24173477E-09_JPRB, &
  & 0.24424349E-09_JPRB, 0.24632779E-09_JPRB, 0.24800642E-09_JPRB, 0.24925828E-09_JPRB, 0.25014096E-09_JPRB, 0.25062560E-09_JPRB, &
  & 0.25072130E-09_JPRB, 0.25046143E-09_JPRB, 0.24988261E-09_JPRB, 0.24902727E-09_JPRB, 0.24792951E-09_JPRB, 0.24665267E-09_JPRB, &
  & 0.24524902E-09_JPRB, 0.24372282E-09_JPRB, 0.24202310E-09_JPRB, 0.24006416E-09_JPRB, 0.23772695E-09_JPRB, 0.23490734E-09_JPRB, &
  & 0.23156875E-09_JPRB, 0.22770180E-09_JPRB, 0.22342385E-09_JPRB, 0.21882439E-09_JPRB, 0.21401239E-09_JPRB, 0.20909770E-09_JPRB, &
  & 0.20413697E-09_JPRB, 0.19924287E-09_JPRB, 0.19445470E-09_JPRB, 0.18979229E-09_JPRB, 0.18526020E-09_JPRB, 0.18080321E-09_JPRB, &
  & 0.17634857E-09_JPRB, 0.17180540E-09_JPRB, 0.16706619E-09_JPRB, 0.16204307E-09_JPRB, 0.15676099E-09_JPRB, 0.15138893E-09_JPRB, &
  & 0.14614659E-09_JPRB, 0.14107665E-09_JPRB, 0.13567542E-09_JPRB, 0.12696660E-09_JPRB /)

RGHG5(:,36, 3) = (/ &
  & 0.13666901E-09_JPRB, 0.14403063E-09_JPRB, 0.14809527E-09_JPRB, 0.15166621E-09_JPRB, 0.15515852E-09_JPRB, 0.15875191E-09_JPRB, &
  & 0.16247835E-09_JPRB, 0.16630958E-09_JPRB, 0.17028767E-09_JPRB, 0.17449239E-09_JPRB, 0.17905311E-09_JPRB, 0.18409872E-09_JPRB, &
  & 0.18970209E-09_JPRB, 0.19582644E-09_JPRB, 0.20233830E-09_JPRB, 0.20901086E-09_JPRB, 0.21556995E-09_JPRB, 0.22179769E-09_JPRB, &
  & 0.22751635E-09_JPRB, 0.23267564E-09_JPRB, 0.23719254E-09_JPRB, 0.24111435E-09_JPRB, 0.24440006E-09_JPRB, 0.24714353E-09_JPRB, &
  & 0.24931671E-09_JPRB, 0.25102700E-09_JPRB, 0.25235383E-09_JPRB, 0.25330477E-09_JPRB, 0.25396091E-09_JPRB, 0.25430635E-09_JPRB, &
  & 0.25435343E-09_JPRB, 0.25412528E-09_JPRB, 0.25364805E-09_JPRB, 0.25295749E-09_JPRB, 0.25207714E-09_JPRB, 0.25105809E-09_JPRB, &
  & 0.24992564E-09_JPRB, 0.24866739E-09_JPRB, 0.24722663E-09_JPRB, 0.24550226E-09_JPRB, 0.24336747E-09_JPRB, 0.24072816E-09_JPRB, &
  & 0.23751828E-09_JPRB, 0.23381339E-09_JPRB, 0.22968136E-09_JPRB, 0.22529104E-09_JPRB, 0.22071847E-09_JPRB, 0.21602846E-09_JPRB, &
  & 0.21131093E-09_JPRB, 0.20661872E-09_JPRB, 0.20202259E-09_JPRB, 0.19756430E-09_JPRB, 0.19322427E-09_JPRB, 0.18897491E-09_JPRB, &
  & 0.18474713E-09_JPRB, 0.18045004E-09_JPRB, 0.17597673E-09_JPRB, 0.17124274E-09_JPRB, 0.16624893E-09_JPRB, 0.16112210E-09_JPRB, &
  & 0.15606839E-09_JPRB, 0.15110321E-09_JPRB, 0.14571927E-09_JPRB, 0.13691245E-09_JPRB /)

RGHG5(:,37, 3) = (/ &
  & 0.14618101E-09_JPRB, 0.15320091E-09_JPRB, 0.15718822E-09_JPRB, 0.16062192E-09_JPRB, 0.16402399E-09_JPRB, 0.16749666E-09_JPRB, &
  & 0.17102258E-09_JPRB, 0.17461363E-09_JPRB, 0.17829922E-09_JPRB, 0.18217589E-09_JPRB, 0.18637680E-09_JPRB, 0.19104418E-09_JPRB, &
  & 0.19628843E-09_JPRB, 0.20211680E-09_JPRB, 0.20840715E-09_JPRB, 0.21490189E-09_JPRB, 0.22130831E-09_JPRB, 0.22740160E-09_JPRB, &
  & 0.23300514E-09_JPRB, 0.23802801E-09_JPRB, 0.24238317E-09_JPRB, 0.24604924E-09_JPRB, 0.24899041E-09_JPRB, 0.25130684E-09_JPRB, &
  & 0.25303237E-09_JPRB, 0.25433067E-09_JPRB, 0.25528551E-09_JPRB, 0.25596397E-09_JPRB, 0.25642377E-09_JPRB, 0.25666205E-09_JPRB, &
  & 0.25668170E-09_JPRB, 0.25649294E-09_JPRB, 0.25610983E-09_JPRB, 0.25555671E-09_JPRB, 0.25485408E-09_JPRB, 0.25403504E-09_JPRB, &
  & 0.25311389E-09_JPRB, 0.25207592E-09_JPRB, 0.25085983E-09_JPRB, 0.24937125E-09_JPRB, 0.24748645E-09_JPRB, 0.24508703E-09_JPRB, &
  & 0.24214464E-09_JPRB, 0.23865268E-09_JPRB, 0.23478325E-09_JPRB, 0.23062936E-09_JPRB, 0.22631017E-09_JPRB, 0.22186979E-09_JPRB, &
  & 0.21736091E-09_JPRB, 0.21286650E-09_JPRB, 0.20846759E-09_JPRB, 0.20420499E-09_JPRB, 0.20009151E-09_JPRB, 0.19608680E-09_JPRB, &
  & 0.19212598E-09_JPRB, 0.18812275E-09_JPRB, 0.18397117E-09_JPRB, 0.17958100E-09_JPRB, 0.17494343E-09_JPRB, 0.17015725E-09_JPRB, &
  & 0.16538773E-09_JPRB, 0.16063169E-09_JPRB, 0.15539867E-09_JPRB, 0.14666643E-09_JPRB /)

RGHG5(:,38, 3) = (/ &
  & 0.15537983E-09_JPRB, 0.16210279E-09_JPRB, 0.16590976E-09_JPRB, 0.16926760E-09_JPRB, 0.17258744E-09_JPRB, 0.17593145E-09_JPRB, &
  & 0.17926846E-09_JPRB, 0.18260002E-09_JPRB, 0.18597192E-09_JPRB, 0.18949002E-09_JPRB, 0.19330473E-09_JPRB, 0.19757530E-09_JPRB, &
  & 0.20243010E-09_JPRB, 0.20790535E-09_JPRB, 0.21389700E-09_JPRB, 0.22016103E-09_JPRB, 0.22636772E-09_JPRB, 0.23227684E-09_JPRB, &
  & 0.23769958E-09_JPRB, 0.24251409E-09_JPRB, 0.24658409E-09_JPRB, 0.24986038E-09_JPRB, 0.25233665E-09_JPRB, 0.25416777E-09_JPRB, &
  & 0.25546021E-09_JPRB, 0.25639851E-09_JPRB, 0.25707897E-09_JPRB, 0.25756208E-09_JPRB, 0.25789573E-09_JPRB, 0.25807004E-09_JPRB, &
  & 0.25808061E-09_JPRB, 0.25792510E-09_JPRB, 0.25760999E-09_JPRB, 0.25715396E-09_JPRB, 0.25657379E-09_JPRB, 0.25589564E-09_JPRB, &
  & 0.25512853E-09_JPRB, 0.25425340E-09_JPRB, 0.25321945E-09_JPRB, 0.25193925E-09_JPRB, 0.25029712E-09_JPRB, 0.24819105E-09_JPRB, &
  & 0.24554375E-09_JPRB, 0.24240193E-09_JPRB, 0.23882946E-09_JPRB, 0.23499042E-09_JPRB, 0.23094548E-09_JPRB, 0.22675764E-09_JPRB, &
  & 0.22246470E-09_JPRB, 0.21816042E-09_JPRB, 0.21393423E-09_JPRB, 0.20987373E-09_JPRB, 0.20598637E-09_JPRB, 0.20224401E-09_JPRB, &
  & 0.19857965E-09_JPRB, 0.19489929E-09_JPRB, 0.19110166E-09_JPRB, 0.18709333E-09_JPRB, 0.18285766E-09_JPRB, 0.17847589E-09_JPRB, &
  & 0.17406941E-09_JPRB, 0.16962719E-09_JPRB, 0.16464873E-09_JPRB, 0.15620996E-09_JPRB /)

RGHG5(:,39, 3) = (/ &
  & 0.16430818E-09_JPRB, 0.17066737E-09_JPRB, 0.17430921E-09_JPRB, 0.17757525E-09_JPRB, 0.18080781E-09_JPRB, 0.18403928E-09_JPRB, &
  & 0.18718603E-09_JPRB, 0.19025094E-09_JPRB, 0.19329663E-09_JPRB, 0.19644555E-09_JPRB, 0.19984729E-09_JPRB, 0.20368002E-09_JPRB, &
  & 0.20810430E-09_JPRB, 0.21319316E-09_JPRB, 0.21885295E-09_JPRB, 0.22483158E-09_JPRB, 0.23081304E-09_JPRB, 0.23649577E-09_JPRB, &
  & 0.24165769E-09_JPRB, 0.24612118E-09_JPRB, 0.24976032E-09_JPRB, 0.25255012E-09_JPRB, 0.25455696E-09_JPRB, 0.25597399E-09_JPRB, &
  & 0.25694591E-09_JPRB, 0.25764776E-09_JPRB, 0.25815450E-09_JPRB, 0.25852548E-09_JPRB, 0.25878821E-09_JPRB, 0.25893054E-09_JPRB, &
  & 0.25894176E-09_JPRB, 0.25881219E-09_JPRB, 0.25854321E-09_JPRB, 0.25815075E-09_JPRB, 0.25765309E-09_JPRB, 0.25707053E-09_JPRB, &
  & 0.25641214E-09_JPRB, 0.25565619E-09_JPRB, 0.25475924E-09_JPRB, 0.25364416E-09_JPRB, 0.25221183E-09_JPRB, 0.25035715E-09_JPRB, &
  & 0.24802843E-09_JPRB, 0.24520963E-09_JPRB, 0.24200197E-09_JPRB, 0.23848995E-09_JPRB, 0.23476635E-09_JPRB, 0.23085051E-09_JPRB, &
  & 0.22679762E-09_JPRB, 0.22266743E-09_JPRB, 0.21861633E-09_JPRB, 0.21473309E-09_JPRB, 0.21106414E-09_JPRB, 0.20758512E-09_JPRB, &
  & 0.20421963E-09_JPRB, 0.20088006E-09_JPRB, 0.19744797E-09_JPRB, 0.19384541E-09_JPRB, 0.19004440E-09_JPRB, 0.18611182E-09_JPRB, &
  & 0.18214245E-09_JPRB, 0.17808456E-09_JPRB, 0.17348989E-09_JPRB, 0.16552991E-09_JPRB /)

RGHG5(:,40, 3) = (/ &
  & 0.17295616E-09_JPRB, 0.17888889E-09_JPRB, 0.18235594E-09_JPRB, 0.18548721E-09_JPRB, 0.18865685E-09_JPRB, 0.19176563E-09_JPRB, &
  & 0.19472540E-09_JPRB, 0.19752050E-09_JPRB, 0.20024304E-09_JPRB, 0.20300453E-09_JPRB, 0.20599172E-09_JPRB, 0.20938061E-09_JPRB, &
  & 0.21335531E-09_JPRB, 0.21801867E-09_JPRB, 0.22331198E-09_JPRB, 0.22896331E-09_JPRB, 0.23463698E-09_JPRB, 0.24002339E-09_JPRB, &
  & 0.24485455E-09_JPRB, 0.24889871E-09_JPRB, 0.25204655E-09_JPRB, 0.25436878E-09_JPRB, 0.25598826E-09_JPRB, 0.25711241E-09_JPRB, &
  & 0.25787614E-09_JPRB, 0.25843275E-09_JPRB, 0.25883895E-09_JPRB, 0.25914565E-09_JPRB, 0.25937005E-09_JPRB, 0.25949720E-09_JPRB, &
  & 0.25951258E-09_JPRB, 0.25940211E-09_JPRB, 0.25916469E-09_JPRB, 0.25881525E-09_JPRB, 0.25837232E-09_JPRB, 0.25785843E-09_JPRB, &
  & 0.25727573E-09_JPRB, 0.25660940E-09_JPRB, 0.25581542E-09_JPRB, 0.25483021E-09_JPRB, 0.25356198E-09_JPRB, 0.25192490E-09_JPRB, &
  & 0.24985417E-09_JPRB, 0.24735430E-09_JPRB, 0.24447555E-09_JPRB, 0.24131080E-09_JPRB, 0.23791538E-09_JPRB, 0.23430899E-09_JPRB, &
  & 0.23049326E-09_JPRB, 0.22657656E-09_JPRB, 0.22267513E-09_JPRB, 0.21895633E-09_JPRB, 0.21548961E-09_JPRB, 0.21225269E-09_JPRB, &
  & 0.20918393E-09_JPRB, 0.20617055E-09_JPRB, 0.20311317E-09_JPRB, 0.19991682E-09_JPRB, 0.19657208E-09_JPRB, 0.19312249E-09_JPRB, &
  & 0.18962858E-09_JPRB, 0.18603856E-09_JPRB, 0.18189414E-09_JPRB, 0.17462892E-09_JPRB /)

RGHG5(:,41, 3) = (/ &
  & 0.18127719E-09_JPRB, 0.18677859E-09_JPRB, 0.18999696E-09_JPRB, 0.19301538E-09_JPRB, 0.19606831E-09_JPRB, 0.19906471E-09_JPRB, &
  & 0.20183735E-09_JPRB, 0.20437435E-09_JPRB, 0.20676372E-09_JPRB, 0.20915970E-09_JPRB, 0.21172183E-09_JPRB, 0.21466290E-09_JPRB, &
  & 0.21818623E-09_JPRB, 0.22242275E-09_JPRB, 0.22732716E-09_JPRB, 0.23265279E-09_JPRB, 0.23800303E-09_JPRB, 0.24303243E-09_JPRB, &
  & 0.24742763E-09_JPRB, 0.25100583E-09_JPRB, 0.25369706E-09_JPRB, 0.25562283E-09_JPRB, 0.25695568E-09_JPRB, 0.25787483E-09_JPRB, &
  & 0.25850555E-09_JPRB, 0.25897115E-09_JPRB, 0.25931571E-09_JPRB, 0.25958494E-09_JPRB, 0.25978678E-09_JPRB, 0.25990637E-09_JPRB, &
  & 0.25992603E-09_JPRB, 0.25982977E-09_JPRB, 0.25961466E-09_JPRB, 0.25929509E-09_JPRB, 0.25889266E-09_JPRB, 0.25842556E-09_JPRB, &
  & 0.25790198E-09_JPRB, 0.25730110E-09_JPRB, 0.25659019E-09_JPRB, 0.25570734E-09_JPRB, 0.25457772E-09_JPRB, 0.25311786E-09_JPRB, &
  & 0.25127853E-09_JPRB, 0.24904453E-09_JPRB, 0.24647120E-09_JPRB, 0.24363067E-09_JPRB, 0.24055688E-09_JPRB, 0.23725361E-09_JPRB, &
  & 0.23372324E-09_JPRB, 0.23000302E-09_JPRB, 0.22627272E-09_JPRB, 0.22271056E-09_JPRB, 0.21941642E-09_JPRB, 0.21641348E-09_JPRB, &
  & 0.21361179E-09_JPRB, 0.21091658E-09_JPRB, 0.20820967E-09_JPRB, 0.20542079E-09_JPRB, 0.20252709E-09_JPRB, 0.19956949E-09_JPRB, &
  & 0.19658020E-09_JPRB, 0.19347626E-09_JPRB, 0.18986626E-09_JPRB, 0.18341394E-09_JPRB /)

RGHG5(:,42, 3) = (/ &
  & 0.18924380E-09_JPRB, 0.19426236E-09_JPRB, 0.19726194E-09_JPRB, 0.20009142E-09_JPRB, 0.20304011E-09_JPRB, 0.20590704E-09_JPRB, &
  & 0.20848859E-09_JPRB, 0.21077395E-09_JPRB, 0.21285708E-09_JPRB, 0.21489407E-09_JPRB, 0.21706656E-09_JPRB, 0.21958006E-09_JPRB, &
  & 0.22265242E-09_JPRB, 0.22646540E-09_JPRB, 0.23097975E-09_JPRB, 0.23594027E-09_JPRB, 0.24096164E-09_JPRB, 0.24560129E-09_JPRB, &
  & 0.24955851E-09_JPRB, 0.25265165E-09_JPRB, 0.25492800E-09_JPRB, 0.25653746E-09_JPRB, 0.25765193E-09_JPRB, 0.25842795E-09_JPRB, &
  & 0.25896871E-09_JPRB, 0.25937369E-09_JPRB, 0.25967922E-09_JPRB, 0.25992411E-09_JPRB, 0.26011207E-09_JPRB, 0.26022690E-09_JPRB, &
  & 0.26024974E-09_JPRB, 0.26016378E-09_JPRB, 0.25996527E-09_JPRB, 0.25966879E-09_JPRB, 0.25929450E-09_JPRB, 0.25886515E-09_JPRB, &
  & 0.25838293E-09_JPRB, 0.25783642E-09_JPRB, 0.25719007E-09_JPRB, 0.25639563E-09_JPRB, 0.25538269E-09_JPRB, 0.25408409E-09_JPRB, &
  & 0.25244609E-09_JPRB, 0.25045771E-09_JPRB, 0.24815472E-09_JPRB, 0.24559815E-09_JPRB, 0.24283142E-09_JPRB, 0.23982993E-09_JPRB, &
  & 0.23656721E-09_JPRB, 0.23308891E-09_JPRB, 0.22953631E-09_JPRB, 0.22612247E-09_JPRB, 0.22301661E-09_JPRB, 0.22021859E-09_JPRB, &
  & 0.21767459E-09_JPRB, 0.21526669E-09_JPRB, 0.21289404E-09_JPRB, 0.21048165E-09_JPRB, 0.20802204E-09_JPRB, 0.20553617E-09_JPRB, &
  & 0.20303431E-09_JPRB, 0.20042805E-09_JPRB, 0.19735330E-09_JPRB, 0.19179740E-09_JPRB /)

RGHG5(:,43, 3) = (/ &
  & 0.19682331E-09_JPRB, 0.20135793E-09_JPRB, 0.20410015E-09_JPRB, 0.20674645E-09_JPRB, 0.20954638E-09_JPRB, 0.21226212E-09_JPRB, &
  & 0.21467765E-09_JPRB, 0.21671757E-09_JPRB, 0.21852468E-09_JPRB, 0.22024287E-09_JPRB, 0.22206031E-09_JPRB, 0.22417383E-09_JPRB, &
  & 0.22684285E-09_JPRB, 0.23022965E-09_JPRB, 0.23437946E-09_JPRB, 0.23898497E-09_JPRB, 0.24361663E-09_JPRB, 0.24784516E-09_JPRB, &
  & 0.25132077E-09_JPRB, 0.25397015E-09_JPRB, 0.25588440E-09_JPRB, 0.25723484E-09_JPRB, 0.25818514E-09_JPRB, 0.25885472E-09_JPRB, &
  & 0.25933261E-09_JPRB, 0.25969599E-09_JPRB, 0.25997510E-09_JPRB, 0.26020458E-09_JPRB, 0.26038238E-09_JPRB, 0.26049385E-09_JPRB, &
  & 0.26051822E-09_JPRB, 0.26043956E-09_JPRB, 0.26025401E-09_JPRB, 0.25997465E-09_JPRB, 0.25962363E-09_JPRB, 0.25922031E-09_JPRB, &
  & 0.25877286E-09_JPRB, 0.25826696E-09_JPRB, 0.25767644E-09_JPRB, 0.25695623E-09_JPRB, 0.25605035E-09_JPRB, 0.25489724E-09_JPRB, &
  & 0.25345293E-09_JPRB, 0.25169306E-09_JPRB, 0.24964200E-09_JPRB, 0.24735436E-09_JPRB, 0.24485694E-09_JPRB, 0.24213670E-09_JPRB, &
  & 0.23915245E-09_JPRB, 0.23591351E-09_JPRB, 0.23256304E-09_JPRB, 0.22934517E-09_JPRB, 0.22641476E-09_JPRB, 0.22383655E-09_JPRB, &
  & 0.22152598E-09_JPRB, 0.21938290E-09_JPRB, 0.21730671E-09_JPRB, 0.21523792E-09_JPRB, 0.21316737E-09_JPRB, 0.21111031E-09_JPRB, &
  & 0.20905522E-09_JPRB, 0.20690460E-09_JPRB, 0.20434723E-09_JPRB, 0.19967361E-09_JPRB /)

RGHG5(:,44, 3) = (/ &
  & 0.20390474E-09_JPRB, 0.20804422E-09_JPRB, 0.21050112E-09_JPRB, 0.21297188E-09_JPRB, 0.21558604E-09_JPRB, 0.21818519E-09_JPRB, &
  & 0.22039794E-09_JPRB, 0.22225717E-09_JPRB, 0.22380603E-09_JPRB, 0.22526001E-09_JPRB, 0.22676355E-09_JPRB, 0.22854388E-09_JPRB, &
  & 0.23080519E-09_JPRB, 0.23383359E-09_JPRB, 0.23759505E-09_JPRB, 0.24185479E-09_JPRB, 0.24609578E-09_JPRB, 0.24983599E-09_JPRB, &
  & 0.25283226E-09_JPRB, 0.25504562E-09_JPRB, 0.25664720E-09_JPRB, 0.25778776E-09_JPRB, 0.25860863E-09_JPRB, 0.25919783E-09_JPRB, &
  & 0.25963173E-09_JPRB, 0.25996491E-09_JPRB, 0.26022734E-09_JPRB, 0.26044608E-09_JPRB, 0.26061728E-09_JPRB, 0.26072478E-09_JPRB, &
  & 0.26074901E-09_JPRB, 0.26067520E-09_JPRB, 0.26049943E-09_JPRB, 0.26023439E-09_JPRB, 0.25989988E-09_JPRB, 0.25951821E-09_JPRB, &
  & 0.25909541E-09_JPRB, 0.25862407E-09_JPRB, 0.25807856E-09_JPRB, 0.25742489E-09_JPRB, 0.25661448E-09_JPRB, 0.25560101E-09_JPRB, &
  & 0.25434285E-09_JPRB, 0.25281255E-09_JPRB, 0.25101052E-09_JPRB, 0.24897265E-09_JPRB, 0.24673469E-09_JPRB, 0.24427591E-09_JPRB, &
  & 0.24155422E-09_JPRB, 0.23856825E-09_JPRB, 0.23545915E-09_JPRB, 0.23244640E-09_JPRB, 0.22974823E-09_JPRB, 0.22738030E-09_JPRB, &
  & 0.22529384E-09_JPRB, 0.22338820E-09_JPRB, 0.22157194E-09_JPRB, 0.21979853E-09_JPRB, 0.21806330E-09_JPRB, 0.21637196E-09_JPRB, &
  & 0.21469936E-09_JPRB, 0.21295087E-09_JPRB, 0.21085331E-09_JPRB, 0.20699018E-09_JPRB /)

RGHG5(:,45, 3) = (/ &
  & 0.21056873E-09_JPRB, 0.21420857E-09_JPRB, 0.21652853E-09_JPRB, 0.21874552E-09_JPRB, 0.22124744E-09_JPRB, 0.22366156E-09_JPRB, &
  & 0.22577271E-09_JPRB, 0.22741306E-09_JPRB, 0.22878516E-09_JPRB, 0.22999846E-09_JPRB, 0.23126065E-09_JPRB, 0.23273000E-09_JPRB, &
  & 0.23468208E-09_JPRB, 0.23731078E-09_JPRB, 0.24075525E-09_JPRB, 0.24461977E-09_JPRB, 0.24840024E-09_JPRB, 0.25162816E-09_JPRB, &
  & 0.25410793E-09_JPRB, 0.25593550E-09_JPRB, 0.25726282E-09_JPRB, 0.25823252E-09_JPRB, 0.25895097E-09_JPRB, 0.25948099E-09_JPRB, &
  & 0.25988212E-09_JPRB, 0.26019495E-09_JPRB, 0.26044747E-09_JPRB, 0.26065947E-09_JPRB, 0.26082506E-09_JPRB, 0.26092881E-09_JPRB, &
  & 0.26095087E-09_JPRB, 0.26087948E-09_JPRB, 0.26071154E-09_JPRB, 0.26045696E-09_JPRB, 0.26013611E-09_JPRB, 0.25976910E-09_JPRB, &
  & 0.25936706E-09_JPRB, 0.25892133E-09_JPRB, 0.25841557E-09_JPRB, 0.25781832E-09_JPRB, 0.25709657E-09_JPRB, 0.25621302E-09_JPRB, &
  & 0.25514021E-09_JPRB, 0.25384439E-09_JPRB, 0.25230781E-09_JPRB, 0.25053701E-09_JPRB, 0.24855196E-09_JPRB, 0.24634683E-09_JPRB, &
  & 0.24386937E-09_JPRB, 0.24113922E-09_JPRB, 0.23826918E-09_JPRB, 0.23553715E-09_JPRB, 0.23306418E-09_JPRB, 0.23093308E-09_JPRB, &
  & 0.22906073E-09_JPRB, 0.22736292E-09_JPRB, 0.22577189E-09_JPRB, 0.22424387E-09_JPRB, 0.22278367E-09_JPRB, 0.22139135E-09_JPRB, &
  & 0.22003294E-09_JPRB, 0.21861367E-09_JPRB, 0.21690778E-09_JPRB, 0.21374411E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART5',1,ZHOOK_HANDLE)
END SUBROUTINE PART5




SUBROUTINE PART6
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART6',0,ZHOOK_HANDLE)



RGHG5(:,46, 3) = (/ &
  & 0.21662581E-09_JPRB, 0.22004015E-09_JPRB, 0.22206670E-09_JPRB, 0.22420699E-09_JPRB, 0.22650193E-09_JPRB, 0.22883531E-09_JPRB, &
  & 0.23077391E-09_JPRB, 0.23229356E-09_JPRB, 0.23347688E-09_JPRB, 0.23452396E-09_JPRB, 0.23557659E-09_JPRB, 0.23681865E-09_JPRB, &
  & 0.23846425E-09_JPRB, 0.24079130E-09_JPRB, 0.24384786E-09_JPRB, 0.24730529E-09_JPRB, 0.25055200E-09_JPRB, 0.25319069E-09_JPRB, &
  & 0.25519514E-09_JPRB, 0.25666097E-09_JPRB, 0.25776264E-09_JPRB, 0.25859284E-09_JPRB, 0.25923139E-09_JPRB, 0.25971575E-09_JPRB, &
  & 0.26009522E-09_JPRB, 0.26039543E-09_JPRB, 0.26064198E-09_JPRB, 0.26085065E-09_JPRB, 0.26101216E-09_JPRB, 0.26111044E-09_JPRB, &
  & 0.26112901E-09_JPRB, 0.26105818E-09_JPRB, 0.26089517E-09_JPRB, 0.26064917E-09_JPRB, 0.26033750E-09_JPRB, 0.25998292E-09_JPRB, &
  & 0.25959460E-09_JPRB, 0.25917204E-09_JPRB, 0.25869695E-09_JPRB, 0.25815142E-09_JPRB, 0.25750724E-09_JPRB, 0.25674765E-09_JPRB, &
  & 0.25585267E-09_JPRB, 0.25480090E-09_JPRB, 0.25355426E-09_JPRB, 0.25208924E-09_JPRB, 0.25039210E-09_JPRB, 0.24843588E-09_JPRB, &
  & 0.24620631E-09_JPRB, 0.24369448E-09_JPRB, 0.24111099E-09_JPRB, 0.23861219E-09_JPRB, 0.23643529E-09_JPRB, 0.23452304E-09_JPRB, &
  & 0.23285696E-09_JPRB, 0.23135369E-09_JPRB, 0.22994742E-09_JPRB, 0.22862404E-09_JPRB, 0.22738250E-09_JPRB, 0.22622629E-09_JPRB, &
  & 0.22511311E-09_JPRB, 0.22396113E-09_JPRB, 0.22256771E-09_JPRB, 0.21998896E-09_JPRB /)

RGHG5(:,47, 3) = (/ &
  & 0.22226419E-09_JPRB, 0.22535512E-09_JPRB, 0.22732084E-09_JPRB, 0.22926350E-09_JPRB, 0.23148203E-09_JPRB, 0.23367555E-09_JPRB, &
  & 0.23551350E-09_JPRB, 0.23688634E-09_JPRB, 0.23794011E-09_JPRB, 0.23884128E-09_JPRB, 0.23973867E-09_JPRB, 0.24079455E-09_JPRB, &
  & 0.24220667E-09_JPRB, 0.24423516E-09_JPRB, 0.24690486E-09_JPRB, 0.24985097E-09_JPRB, 0.25247027E-09_JPRB, 0.25454136E-09_JPRB, &
  & 0.25608354E-09_JPRB, 0.25725697E-09_JPRB, 0.25816563E-09_JPRB, 0.25888558E-09_JPRB, 0.25946062E-09_JPRB, 0.25991431E-09_JPRB, &
  & 0.26027866E-09_JPRB, 0.26057126E-09_JPRB, 0.26081787E-09_JPRB, 0.26102354E-09_JPRB, 0.26118077E-09_JPRB, 0.26127339E-09_JPRB, &
  & 0.26128663E-09_JPRB, 0.26121422E-09_JPRB, 0.26105473E-09_JPRB, 0.26081418E-09_JPRB, 0.26051017E-09_JPRB, 0.26016345E-09_JPRB, &
  & 0.25978827E-09_JPRB, 0.25938163E-09_JPRB, 0.25893554E-09_JPRB, 0.25843200E-09_JPRB, 0.25785982E-09_JPRB, 0.25721003E-09_JPRB, &
  & 0.25648619E-09_JPRB, 0.25567257E-09_JPRB, 0.25474103E-09_JPRB, 0.25362809E-09_JPRB, 0.25227617E-09_JPRB, 0.25062702E-09_JPRB, &
  & 0.24862323E-09_JPRB, 0.24636532E-09_JPRB, 0.24397678E-09_JPRB, 0.24180380E-09_JPRB, 0.23984326E-09_JPRB, 0.23817925E-09_JPRB, &
  & 0.23670302E-09_JPRB, 0.23536562E-09_JPRB, 0.23412561E-09_JPRB, 0.23296232E-09_JPRB, 0.23189577E-09_JPRB, 0.23092049E-09_JPRB, &
  & 0.22999889E-09_JPRB, 0.22904736E-09_JPRB, 0.22790492E-09_JPRB, 0.22578102E-09_JPRB /)

RGHG5(:,48, 3) = (/ &
  & 0.22743257E-09_JPRB, 0.23034853E-09_JPRB, 0.23219106E-09_JPRB, 0.23406760E-09_JPRB, 0.23618246E-09_JPRB, 0.23828278E-09_JPRB, &
  & 0.24001182E-09_JPRB, 0.24126523E-09_JPRB, 0.24220392E-09_JPRB, 0.24298813E-09_JPRB, 0.24376492E-09_JPRB, 0.24466917E-09_JPRB, &
  & 0.24588798E-09_JPRB, 0.24758642E-09_JPRB, 0.24983809E-09_JPRB, 0.25213115E-09_JPRB, 0.25411825E-09_JPRB, 0.25563887E-09_JPRB, &
  & 0.25681199E-09_JPRB, 0.25773345E-09_JPRB, 0.25849134E-09_JPRB, 0.25912311E-09_JPRB, 0.25965088E-09_JPRB, 0.26008337E-09_JPRB, &
  & 0.26043928E-09_JPRB, 0.26073116E-09_JPRB, 0.26097655E-09_JPRB, 0.26118183E-09_JPRB, 0.26133415E-09_JPRB, 0.26141894E-09_JPRB, &
  & 0.26142613E-09_JPRB, 0.26135122E-09_JPRB, 0.26119290E-09_JPRB, 0.26095637E-09_JPRB, 0.26065769E-09_JPRB, 0.26031843E-09_JPRB, &
  & 0.25995214E-09_JPRB, 0.25956137E-09_JPRB, 0.25913705E-09_JPRB, 0.25867219E-09_JPRB, 0.25816019E-09_JPRB, 0.25761079E-09_JPRB, &
  & 0.25703684E-09_JPRB, 0.25644675E-09_JPRB, 0.25581162E-09_JPRB, 0.25507521E-09_JPRB, 0.25412070E-09_JPRB, 0.25283856E-09_JPRB, &
  & 0.25116739E-09_JPRB, 0.24912133E-09_JPRB, 0.24705021E-09_JPRB, 0.24507738E-09_JPRB, 0.24340696E-09_JPRB, 0.24193159E-09_JPRB, &
  & 0.24063165E-09_JPRB, 0.23944280E-09_JPRB, 0.23833052E-09_JPRB, 0.23729921E-09_JPRB, 0.23636304E-09_JPRB, 0.23552485E-09_JPRB, &
  & 0.23474211E-09_JPRB, 0.23394417E-09_JPRB, 0.23298219E-09_JPRB, 0.23120880E-09_JPRB /)

RGHG5(:,49, 3) = (/ &
  & 0.23218624E-09_JPRB, 0.23502073E-09_JPRB, 0.23678287E-09_JPRB, 0.23862623E-09_JPRB, 0.24067104E-09_JPRB, 0.24270924E-09_JPRB, &
  & 0.24432589E-09_JPRB, 0.24546978E-09_JPRB, 0.24629984E-09_JPRB, 0.24698249E-09_JPRB, 0.24765118E-09_JPRB, 0.24840513E-09_JPRB, &
  & 0.24940194E-09_JPRB, 0.25076508E-09_JPRB, 0.25239000E-09_JPRB, 0.25405850E-09_JPRB, 0.25542701E-09_JPRB, 0.25651797E-09_JPRB, &
  & 0.25738670E-09_JPRB, 0.25811786E-09_JPRB, 0.25875352E-09_JPRB, 0.25931768E-09_JPRB, 0.25981040E-09_JPRB, 0.26023167E-09_JPRB, &
  & 0.26058475E-09_JPRB, 0.26087682E-09_JPRB, 0.26112504E-09_JPRB, 0.26132665E-09_JPRB, 0.26147273E-09_JPRB, 0.26154953E-09_JPRB, &
  & 0.26154995E-09_JPRB, 0.26147168E-09_JPRB, 0.26131325E-09_JPRB, 0.26107963E-09_JPRB, 0.26078520E-09_JPRB, 0.26045222E-09_JPRB, &
  & 0.26009481E-09_JPRB, 0.25971592E-09_JPRB, 0.25931168E-09_JPRB, 0.25887772E-09_JPRB, 0.25841901E-09_JPRB, 0.25795388E-09_JPRB, &
  & 0.25751101E-09_JPRB, 0.25710489E-09_JPRB, 0.25672597E-09_JPRB, 0.25629932E-09_JPRB, 0.25573021E-09_JPRB, 0.25486774E-09_JPRB, &
  & 0.25358779E-09_JPRB, 0.25197516E-09_JPRB, 0.25018071E-09_JPRB, 0.24857147E-09_JPRB, 0.24712660E-09_JPRB, 0.24585484E-09_JPRB, &
  & 0.24470384E-09_JPRB, 0.24363533E-09_JPRB, 0.24262514E-09_JPRB, 0.24168623E-09_JPRB, 0.24084398E-09_JPRB, 0.24009880E-09_JPRB, &
  & 0.23941443E-09_JPRB, 0.23871866E-09_JPRB, 0.23788502E-09_JPRB, 0.23635491E-09_JPRB /)

RGHG5(:,50, 3) = (/ &
  & 0.23660351E-09_JPRB, 0.23936833E-09_JPRB, 0.24111660E-09_JPRB, 0.24293598E-09_JPRB, 0.24497707E-09_JPRB, 0.24695157E-09_JPRB, &
  & 0.24844665E-09_JPRB, 0.24946373E-09_JPRB, 0.25016494E-09_JPRB, 0.25072922E-09_JPRB, 0.25123953E-09_JPRB, 0.25182478E-09_JPRB, &
  & 0.25250999E-09_JPRB, 0.25340580E-09_JPRB, 0.25447477E-09_JPRB, 0.25551658E-09_JPRB, 0.25643410E-09_JPRB, 0.25719288E-09_JPRB, &
  & 0.25784269E-09_JPRB, 0.25842678E-09_JPRB, 0.25896843E-09_JPRB, 0.25947883E-09_JPRB, 0.25994903E-09_JPRB, 0.26036528E-09_JPRB, &
  & 0.26071953E-09_JPRB, 0.26101574E-09_JPRB, 0.26126276E-09_JPRB, 0.26146019E-09_JPRB, 0.26159830E-09_JPRB, 0.26166633E-09_JPRB, &
  & 0.26166003E-09_JPRB, 0.26157820E-09_JPRB, 0.26141903E-09_JPRB, 0.26118707E-09_JPRB, 0.26089716E-09_JPRB, 0.26056993E-09_JPRB, &
  & 0.26022032E-09_JPRB, 0.25985236E-09_JPRB, 0.25946395E-09_JPRB, 0.25905669E-09_JPRB, 0.25864250E-09_JPRB, 0.25824951E-09_JPRB, &
  & 0.25791450E-09_JPRB, 0.25765790E-09_JPRB, 0.25745692E-09_JPRB, 0.25726010E-09_JPRB, 0.25695862E-09_JPRB, 0.25645139E-09_JPRB, &
  & 0.25563240E-09_JPRB, 0.25447683E-09_JPRB, 0.25324676E-09_JPRB, 0.25202737E-09_JPRB, 0.25090702E-09_JPRB, 0.24988189E-09_JPRB, &
  & 0.24889538E-09_JPRB, 0.24794447E-09_JPRB, 0.24702967E-09_JPRB, 0.24615701E-09_JPRB, 0.24537677E-09_JPRB, 0.24469282E-09_JPRB, &
  & 0.24406721E-09_JPRB, 0.24343522E-09_JPRB, 0.24268360E-09_JPRB, 0.24130292E-09_JPRB /)

RGHG5(:,51, 3) = (/ &
  & 0.24074148E-09_JPRB, 0.24338098E-09_JPRB, 0.24518287E-09_JPRB, 0.24696573E-09_JPRB, 0.24901223E-09_JPRB, 0.25085370E-09_JPRB, &
  & 0.25217112E-09_JPRB, 0.25296970E-09_JPRB, 0.25349187E-09_JPRB, 0.25386437E-09_JPRB, 0.25419983E-09_JPRB, 0.25451441E-09_JPRB, &
  & 0.25491326E-09_JPRB, 0.25538210E-09_JPRB, 0.25596478E-09_JPRB, 0.25659286E-09_JPRB, 0.25717950E-09_JPRB, 0.25771385E-09_JPRB, &
  & 0.25820734E-09_JPRB, 0.25867980E-09_JPRB, 0.25915026E-09_JPRB, 0.25961988E-09_JPRB, 0.26007357E-09_JPRB, 0.26049024E-09_JPRB, &
  & 0.26084876E-09_JPRB, 0.26114744E-09_JPRB, 0.26139310E-09_JPRB, 0.26158326E-09_JPRB, 0.26171199E-09_JPRB, 0.26177163E-09_JPRB, &
  & 0.26175875E-09_JPRB, 0.26167299E-09_JPRB, 0.26151242E-09_JPRB, 0.26128197E-09_JPRB, 0.26099600E-09_JPRB, 0.26067484E-09_JPRB, &
  & 0.26033270E-09_JPRB, 0.25997418E-09_JPRB, 0.25959973E-09_JPRB, 0.25921484E-09_JPRB, 0.25883837E-09_JPRB, 0.25850863E-09_JPRB, &
  & 0.25826388E-09_JPRB, 0.25811614E-09_JPRB, 0.25804106E-09_JPRB, 0.25797386E-09_JPRB, 0.25784716E-09_JPRB, 0.25757180E-09_JPRB, &
  & 0.25708877E-09_JPRB, 0.25644192E-09_JPRB, 0.25569574E-09_JPRB, 0.25497343E-09_JPRB, 0.25428379E-09_JPRB, 0.25356411E-09_JPRB, &
  & 0.25284697E-09_JPRB, 0.25209884E-09_JPRB, 0.25131319E-09_JPRB, 0.25055064E-09_JPRB, 0.24984040E-09_JPRB, 0.24921176E-09_JPRB, &
  & 0.24863581E-09_JPRB, 0.24805286E-09_JPRB, 0.24734964E-09_JPRB, 0.24608146E-09_JPRB /)

RGHG5(:,52, 3) = (/ &
  & 0.24440808E-09_JPRB, 0.24718921E-09_JPRB, 0.24878963E-09_JPRB, 0.25064212E-09_JPRB, 0.25248525E-09_JPRB, 0.25407434E-09_JPRB, &
  & 0.25501604E-09_JPRB, 0.25554317E-09_JPRB, 0.25584110E-09_JPRB, 0.25604463E-09_JPRB, 0.25619343E-09_JPRB, 0.25634825E-09_JPRB, &
  & 0.25650079E-09_JPRB, 0.25672109E-09_JPRB, 0.25700575E-09_JPRB, 0.25735933E-09_JPRB, 0.25773980E-09_JPRB, 0.25812097E-09_JPRB, &
  & 0.25850252E-09_JPRB, 0.25889740E-09_JPRB, 0.25931124E-09_JPRB, 0.25974914E-09_JPRB, 0.26019337E-09_JPRB, 0.26061037E-09_JPRB, &
  & 0.26097313E-09_JPRB, 0.26127334E-09_JPRB, 0.26151464E-09_JPRB, 0.26169639E-09_JPRB, 0.26181554E-09_JPRB, 0.26186700E-09_JPRB, &
  & 0.26184790E-09_JPRB, 0.26175784E-09_JPRB, 0.26159577E-09_JPRB, 0.26136637E-09_JPRB, 0.26108424E-09_JPRB, 0.26076916E-09_JPRB, &
  & 0.26043409E-09_JPRB, 0.26008484E-09_JPRB, 0.25972258E-09_JPRB, 0.25935801E-09_JPRB, 0.25901670E-09_JPRB, 0.25874097E-09_JPRB, &
  & 0.25856997E-09_JPRB, 0.25850466E-09_JPRB, 0.25850516E-09_JPRB, 0.25851654E-09_JPRB, 0.25847974E-09_JPRB, 0.25834732E-09_JPRB, &
  & 0.25809468E-09_JPRB, 0.25774127E-09_JPRB, 0.25737718E-09_JPRB, 0.25702240E-09_JPRB, 0.25665228E-09_JPRB, 0.25628427E-09_JPRB, &
  & 0.25585611E-09_JPRB, 0.25537480E-09_JPRB, 0.25484609E-09_JPRB, 0.25426822E-09_JPRB, 0.25371680E-09_JPRB, 0.25321062E-09_JPRB, &
  & 0.25273109E-09_JPRB, 0.25223301E-09_JPRB, 0.25162500E-09_JPRB, 0.25047228E-09_JPRB /)

RGHG5(:,53, 3) = (/ &
  & 0.24790409E-09_JPRB, 0.25032298E-09_JPRB, 0.25209154E-09_JPRB, 0.25359084E-09_JPRB, 0.25517352E-09_JPRB, 0.25625332E-09_JPRB, &
  & 0.25683145E-09_JPRB, 0.25710956E-09_JPRB, 0.25725883E-09_JPRB, 0.25734728E-09_JPRB, 0.25741392E-09_JPRB, 0.25746358E-09_JPRB, &
  & 0.25752511E-09_JPRB, 0.25759955E-09_JPRB, 0.25773145E-09_JPRB, 0.25792513E-09_JPRB, 0.25816999E-09_JPRB, 0.25844774E-09_JPRB, &
  & 0.25875338E-09_JPRB, 0.25908758E-09_JPRB, 0.25946378E-09_JPRB, 0.25987740E-09_JPRB, 0.26031166E-09_JPRB, 0.26072877E-09_JPRB, &
  & 0.26109248E-09_JPRB, 0.26139152E-09_JPRB, 0.26162739E-09_JPRB, 0.26180058E-09_JPRB, 0.26191024E-09_JPRB, 0.26195393E-09_JPRB, &
  & 0.26192898E-09_JPRB, 0.26183447E-09_JPRB, 0.26167057E-09_JPRB, 0.26144181E-09_JPRB, 0.26116381E-09_JPRB, 0.26085403E-09_JPRB, &
  & 0.26052668E-09_JPRB, 0.26018593E-09_JPRB, 0.25983699E-09_JPRB, 0.25949223E-09_JPRB, 0.25918306E-09_JPRB, 0.25895627E-09_JPRB, &
  & 0.25884456E-09_JPRB, 0.25883626E-09_JPRB, 0.25888380E-09_JPRB, 0.25893973E-09_JPRB, 0.25895441E-09_JPRB, 0.25890090E-09_JPRB, &
  & 0.25877023E-09_JPRB, 0.25859873E-09_JPRB, 0.25842006E-09_JPRB, 0.25824742E-09_JPRB, 0.25808497E-09_JPRB, 0.25789287E-09_JPRB, &
  & 0.25768376E-09_JPRB, 0.25742961E-09_JPRB, 0.25711994E-09_JPRB, 0.25678376E-09_JPRB, 0.25643815E-09_JPRB, 0.25611052E-09_JPRB, &
  & 0.25579516E-09_JPRB, 0.25545033E-09_JPRB, 0.25500033E-09_JPRB, 0.25411320E-09_JPRB /)

RGHG5(:,54, 3) = (/ &
  & 0.25076446E-09_JPRB, 0.25328697E-09_JPRB, 0.25456989E-09_JPRB, 0.25588287E-09_JPRB, 0.25692257E-09_JPRB, 0.25758964E-09_JPRB, &
  & 0.25789448E-09_JPRB, 0.25803404E-09_JPRB, 0.25810193E-09_JPRB, 0.25814118E-09_JPRB, 0.25816360E-09_JPRB, 0.25818073E-09_JPRB, &
  & 0.25819272E-09_JPRB, 0.25821376E-09_JPRB, 0.25825950E-09_JPRB, 0.25835892E-09_JPRB, 0.25851571E-09_JPRB, 0.25872121E-09_JPRB, &
  & 0.25897040E-09_JPRB, 0.25926628E-09_JPRB, 0.25961108E-09_JPRB, 0.26000840E-09_JPRB, 0.26043312E-09_JPRB, 0.26084471E-09_JPRB, &
  & 0.26120589E-09_JPRB, 0.26150143E-09_JPRB, 0.26173166E-09_JPRB, 0.26189670E-09_JPRB, 0.26199778E-09_JPRB, 0.26203376E-09_JPRB, &
  & 0.26200303E-09_JPRB, 0.26190433E-09_JPRB, 0.26173808E-09_JPRB, 0.26151056E-09_JPRB, 0.26123562E-09_JPRB, 0.26093194E-09_JPRB, &
  & 0.26061139E-09_JPRB, 0.26028102E-09_JPRB, 0.25994523E-09_JPRB, 0.25962243E-09_JPRB, 0.25934466E-09_JPRB, 0.25915939E-09_JPRB, &
  & 0.25909266E-09_JPRB, 0.25912378E-09_JPRB, 0.25920413E-09_JPRB, 0.25928215E-09_JPRB, 0.25932623E-09_JPRB, 0.25931723E-09_JPRB, &
  & 0.25925534E-09_JPRB, 0.25916633E-09_JPRB, 0.25907904E-09_JPRB, 0.25899885E-09_JPRB, 0.25891228E-09_JPRB, 0.25882563E-09_JPRB, &
  & 0.25871558E-09_JPRB, 0.25858396E-09_JPRB, 0.25842617E-09_JPRB, 0.25823996E-09_JPRB, 0.25805336E-09_JPRB, 0.25787869E-09_JPRB, &
  & 0.25770452E-09_JPRB, 0.25751623E-09_JPRB, 0.25726465E-09_JPRB, 0.25674041E-09_JPRB /)

RGHG5(:,55, 3) = (/ &
  & 0.25342783E-09_JPRB, 0.25540139E-09_JPRB, 0.25654853E-09_JPRB, 0.25737079E-09_JPRB, 0.25802172E-09_JPRB, 0.25839286E-09_JPRB, &
  & 0.25855232E-09_JPRB, 0.25861951E-09_JPRB, 0.25865049E-09_JPRB, 0.25866542E-09_JPRB, 0.25867294E-09_JPRB, 0.25867430E-09_JPRB, &
  & 0.25867095E-09_JPRB, 0.25866637E-09_JPRB, 0.25867239E-09_JPRB, 0.25871236E-09_JPRB, 0.25880714E-09_JPRB, 0.25895985E-09_JPRB, &
  & 0.25916863E-09_JPRB, 0.25943361E-09_JPRB, 0.25976049E-09_JPRB, 0.26014227E-09_JPRB, 0.26055588E-09_JPRB, 0.26095789E-09_JPRB, &
  & 0.26131292E-09_JPRB, 0.26160393E-09_JPRB, 0.26182842E-09_JPRB, 0.26198665E-09_JPRB, 0.26207936E-09_JPRB, 0.26210784E-09_JPRB, &
  & 0.26207120E-09_JPRB, 0.26196864E-09_JPRB, 0.26180022E-09_JPRB, 0.26157354E-09_JPRB, 0.26130251E-09_JPRB, 0.26100419E-09_JPRB, &
  & 0.26069161E-09_JPRB, 0.26037131E-09_JPRB, 0.26005192E-09_JPRB, 0.25975105E-09_JPRB, 0.25950425E-09_JPRB, 0.25935284E-09_JPRB, &
  & 0.25931962E-09_JPRB, 0.25937966E-09_JPRB, 0.25947713E-09_JPRB, 0.25957475E-09_JPRB, 0.25963301E-09_JPRB, 0.25964808E-09_JPRB, &
  & 0.25961930E-09_JPRB, 0.25957536E-09_JPRB, 0.25952923E-09_JPRB, 0.25948504E-09_JPRB, 0.25944358E-09_JPRB, 0.25939320E-09_JPRB, &
  & 0.25933819E-09_JPRB, 0.25926841E-09_JPRB, 0.25918132E-09_JPRB, 0.25908364E-09_JPRB, 0.25898350E-09_JPRB, 0.25888905E-09_JPRB, &
  & 0.25880070E-09_JPRB, 0.25869959E-09_JPRB, 0.25855915E-09_JPRB, 0.25821148E-09_JPRB /)

RGHG5(:,56, 3) = (/ &
  & 0.25549671E-09_JPRB, 0.25710561E-09_JPRB, 0.25781932E-09_JPRB, 0.25833377E-09_JPRB, 0.25871366E-09_JPRB, 0.25891503E-09_JPRB, &
  & 0.25899990E-09_JPRB, 0.25903255E-09_JPRB, 0.25904617E-09_JPRB, 0.25905167E-09_JPRB, 0.25905245E-09_JPRB, 0.25904878E-09_JPRB, &
  & 0.25904140E-09_JPRB, 0.25902652E-09_JPRB, 0.25901331E-09_JPRB, 0.25901764E-09_JPRB, 0.25906724E-09_JPRB, 0.25917829E-09_JPRB, &
  & 0.25935518E-09_JPRB, 0.25959851E-09_JPRB, 0.25990876E-09_JPRB, 0.26027847E-09_JPRB, 0.26067726E-09_JPRB, 0.26106844E-09_JPRB, &
  & 0.26141467E-09_JPRB, 0.26170077E-09_JPRB, 0.26191993E-09_JPRB, 0.26207087E-09_JPRB, 0.26215641E-09_JPRB, 0.26217739E-09_JPRB, &
  & 0.26213473E-09_JPRB, 0.26202854E-09_JPRB, 0.26185865E-09_JPRB, 0.26163280E-09_JPRB, 0.26136621E-09_JPRB, 0.26107366E-09_JPRB, &
  & 0.26076916E-09_JPRB, 0.26046099E-09_JPRB, 0.26015795E-09_JPRB, 0.25988128E-09_JPRB, 0.25966201E-09_JPRB, 0.25953942E-09_JPRB, &
  & 0.25952984E-09_JPRB, 0.25960764E-09_JPRB, 0.25972297E-09_JPRB, 0.25982741E-09_JPRB, 0.25989802E-09_JPRB, 0.25992455E-09_JPRB, &
  & 0.25991359E-09_JPRB, 0.25988905E-09_JPRB, 0.25986246E-09_JPRB, 0.25983810E-09_JPRB, 0.25981134E-09_JPRB, 0.25978486E-09_JPRB, &
  & 0.25975144E-09_JPRB, 0.25971181E-09_JPRB, 0.25966351E-09_JPRB, 0.25960634E-09_JPRB, 0.25955005E-09_JPRB, 0.25950117E-09_JPRB, &
  & 0.25945582E-09_JPRB, 0.25941471E-09_JPRB, 0.25937266E-09_JPRB, 0.25932811E-09_JPRB /)

RGHG5(:,57, 3) = (/ &
  & 0.25713884E-09_JPRB, 0.25821956E-09_JPRB, 0.25866187E-09_JPRB, 0.25897262E-09_JPRB, 0.25917360E-09_JPRB, 0.25929167E-09_JPRB, &
  & 0.25933655E-09_JPRB, 0.25935326E-09_JPRB, 0.25935934E-09_JPRB, 0.25936081E-09_JPRB, 0.25935953E-09_JPRB, 0.25935537E-09_JPRB, &
  & 0.25934588E-09_JPRB, 0.25933142E-09_JPRB, 0.25930869E-09_JPRB, 0.25929248E-09_JPRB, 0.25930944E-09_JPRB, 0.25938737E-09_JPRB, &
  & 0.25953778E-09_JPRB, 0.25976207E-09_JPRB, 0.26005836E-09_JPRB, 0.26041280E-09_JPRB, 0.26079860E-09_JPRB, 0.26117494E-09_JPRB, &
  & 0.26151445E-09_JPRB, 0.26179367E-09_JPRB, 0.26200692E-09_JPRB, 0.26215144E-09_JPRB, 0.26222940E-09_JPRB, 0.26224353E-09_JPRB, &
  & 0.26219515E-09_JPRB, 0.26208558E-09_JPRB, 0.26191502E-09_JPRB, 0.26169039E-09_JPRB, 0.26142860E-09_JPRB, 0.26114250E-09_JPRB, &
  & 0.26084743E-09_JPRB, 0.26055150E-09_JPRB, 0.26026656E-09_JPRB, 0.26001243E-09_JPRB, 0.25981942E-09_JPRB, 0.25971919E-09_JPRB, &
  & 0.25972652E-09_JPRB, 0.25981897E-09_JPRB, 0.25994137E-09_JPRB, 0.26005775E-09_JPRB, 0.26013239E-09_JPRB, 0.26016519E-09_JPRB, &
  & 0.26016211E-09_JPRB, 0.26014749E-09_JPRB, 0.26012958E-09_JPRB, 0.26011235E-09_JPRB, 0.26009558E-09_JPRB, 0.26007643E-09_JPRB, &
  & 0.26005564E-09_JPRB, 0.26003003E-09_JPRB, 0.25999819E-09_JPRB, 0.25996214E-09_JPRB, 0.25992605E-09_JPRB, 0.25989297E-09_JPRB, &
  & 0.25986471E-09_JPRB, 0.25983524E-09_JPRB, 0.25980224E-09_JPRB, 0.25974753E-09_JPRB /)

RGHG5(:,58, 3) = (/ &
  & 0.25836855E-09_JPRB, 0.25897273E-09_JPRB, 0.25923963E-09_JPRB, 0.25939820E-09_JPRB, 0.25952346E-09_JPRB, 0.25958580E-09_JPRB, &
  & 0.25961280E-09_JPRB, 0.25962163E-09_JPRB, 0.25962466E-09_JPRB, 0.25962490E-09_JPRB, 0.25962346E-09_JPRB, 0.25961933E-09_JPRB, &
  & 0.25961222E-09_JPRB, 0.25959659E-09_JPRB, 0.25957383E-09_JPRB, 0.25954605E-09_JPRB, 0.25954061E-09_JPRB, 0.25959318E-09_JPRB, &
  & 0.25972058E-09_JPRB, 0.25992711E-09_JPRB, 0.26020763E-09_JPRB, 0.26054769E-09_JPRB, 0.26091695E-09_JPRB, 0.26128347E-09_JPRB, &
  & 0.26161165E-09_JPRB, 0.26188474E-09_JPRB, 0.26209077E-09_JPRB, 0.26222793E-09_JPRB, 0.26229924E-09_JPRB, 0.26230704E-09_JPRB, &
  & 0.26225361E-09_JPRB, 0.26214092E-09_JPRB, 0.26197056E-09_JPRB, 0.26174815E-09_JPRB, 0.26149147E-09_JPRB, 0.26121291E-09_JPRB, &
  & 0.26092770E-09_JPRB, 0.26064570E-09_JPRB, 0.26037780E-09_JPRB, 0.26014568E-09_JPRB, 0.25997487E-09_JPRB, 0.25989427E-09_JPRB, &
  & 0.25991442E-09_JPRB, 0.26001429E-09_JPRB, 0.26014649E-09_JPRB, 0.26026509E-09_JPRB, 0.26034669E-09_JPRB, 0.26038133E-09_JPRB, &
  & 0.26038169E-09_JPRB, 0.26036992E-09_JPRB, 0.26035557E-09_JPRB, 0.26034189E-09_JPRB, 0.26032740E-09_JPRB, 0.26031330E-09_JPRB, &
  & 0.26029667E-09_JPRB, 0.26027763E-09_JPRB, 0.26025468E-09_JPRB, 0.26022773E-09_JPRB, 0.26020064E-09_JPRB, 0.26017710E-09_JPRB, &
  & 0.26015445E-09_JPRB, 0.26013255E-09_JPRB, 0.26010563E-09_JPRB, 0.26005822E-09_JPRB /)

RGHG5(:,59, 3) = (/ &
  & 0.25910396E-09_JPRB, 0.25948965E-09_JPRB, 0.25962896E-09_JPRB, 0.25973185E-09_JPRB, 0.25979535E-09_JPRB, 0.25983626E-09_JPRB, &
  & 0.25985217E-09_JPRB, 0.25985816E-09_JPRB, 0.25986033E-09_JPRB, 0.25986074E-09_JPRB, 0.25985994E-09_JPRB, 0.25985739E-09_JPRB, &
  & 0.25985114E-09_JPRB, 0.25983932E-09_JPRB, 0.25981520E-09_JPRB, 0.25978303E-09_JPRB, 0.25976352E-09_JPRB, 0.25979702E-09_JPRB, &
  & 0.25990532E-09_JPRB, 0.26009453E-09_JPRB, 0.26035907E-09_JPRB, 0.26068278E-09_JPRB, 0.26103852E-09_JPRB, 0.26139063E-09_JPRB, &
  & 0.26171021E-09_JPRB, 0.26197355E-09_JPRB, 0.26217156E-09_JPRB, 0.26230143E-09_JPRB, 0.26236591E-09_JPRB, 0.26236829E-09_JPRB, &
  & 0.26231081E-09_JPRB, 0.26219618E-09_JPRB, 0.26202618E-09_JPRB, 0.26180791E-09_JPRB, 0.26155605E-09_JPRB, 0.26128641E-09_JPRB, &
  & 0.26101241E-09_JPRB, 0.26074343E-09_JPRB, 0.26049313E-09_JPRB, 0.26028013E-09_JPRB, 0.26012967E-09_JPRB, 0.26006516E-09_JPRB, &
  & 0.26009514E-09_JPRB, 0.26020125E-09_JPRB, 0.26033567E-09_JPRB, 0.26046063E-09_JPRB, 0.26054348E-09_JPRB, 0.26058003E-09_JPRB, &
  & 0.26058122E-09_JPRB, 0.26057007E-09_JPRB, 0.26055577E-09_JPRB, 0.26054189E-09_JPRB, 0.26052868E-09_JPRB, 0.26051478E-09_JPRB, &
  & 0.26050045E-09_JPRB, 0.26048397E-09_JPRB, 0.26046423E-09_JPRB, 0.26044222E-09_JPRB, 0.26042030E-09_JPRB, 0.26039990E-09_JPRB, &
  & 0.26038216E-09_JPRB, 0.26036276E-09_JPRB, 0.26033958E-09_JPRB, 0.26029504E-09_JPRB /)

RGHG5(:,60, 3) = (/ &
  & 0.25969851E-09_JPRB, 0.25985969E-09_JPRB, 0.25994051E-09_JPRB, 0.25999014E-09_JPRB, 0.26003280E-09_JPRB, 0.26005648E-09_JPRB, &
  & 0.26006869E-09_JPRB, 0.26007357E-09_JPRB, 0.26007610E-09_JPRB, 0.26007740E-09_JPRB, 0.26007790E-09_JPRB, 0.26007699E-09_JPRB, &
  & 0.26007355E-09_JPRB, 0.26006314E-09_JPRB, 0.26004190E-09_JPRB, 0.26000674E-09_JPRB, 0.25997926E-09_JPRB, 0.25999961E-09_JPRB, &
  & 0.26009192E-09_JPRB, 0.26026520E-09_JPRB, 0.26051319E-09_JPRB, 0.26082145E-09_JPRB, 0.26116168E-09_JPRB, 0.26150077E-09_JPRB, &
  & 0.26180763E-09_JPRB, 0.26206071E-09_JPRB, 0.26224933E-09_JPRB, 0.26237112E-09_JPRB, 0.26242944E-09_JPRB, 0.26242739E-09_JPRB, &
  & 0.26236749E-09_JPRB, 0.26225178E-09_JPRB, 0.26208369E-09_JPRB, 0.26186994E-09_JPRB, 0.26162447E-09_JPRB, 0.26136407E-09_JPRB, &
  & 0.26110114E-09_JPRB, 0.26084612E-09_JPRB, 0.26061137E-09_JPRB, 0.26041647E-09_JPRB, 0.26028321E-09_JPRB, 0.26023295E-09_JPRB, &
  & 0.26027133E-09_JPRB, 0.26038036E-09_JPRB, 0.26051769E-09_JPRB, 0.26064220E-09_JPRB, 0.26072899E-09_JPRB, 0.26076630E-09_JPRB, &
  & 0.26076752E-09_JPRB, 0.26075447E-09_JPRB, 0.26073863E-09_JPRB, 0.26072322E-09_JPRB, 0.26070807E-09_JPRB, 0.26069402E-09_JPRB, &
  & 0.26067901E-09_JPRB, 0.26066294E-09_JPRB, 0.26064459E-09_JPRB, 0.26062422E-09_JPRB, 0.26060409E-09_JPRB, 0.26058677E-09_JPRB, &
  & 0.26056993E-09_JPRB, 0.26055352E-09_JPRB, 0.26053282E-09_JPRB, 0.26049476E-09_JPRB /)

RGHG5(:,61, 3) = (/ &
  & 0.26000588E-09_JPRB, 0.26012820E-09_JPRB, 0.26017694E-09_JPRB, 0.26021377E-09_JPRB, 0.26023922E-09_JPRB, 0.26025854E-09_JPRB, &
  & 0.26026870E-09_JPRB, 0.26027450E-09_JPRB, 0.26027813E-09_JPRB, 0.26028099E-09_JPRB, 0.26028341E-09_JPRB, 0.26028490E-09_JPRB, &
  & 0.26028424E-09_JPRB, 0.26027769E-09_JPRB, 0.26025720E-09_JPRB, 0.26022121E-09_JPRB, 0.26018965E-09_JPRB, 0.26020106E-09_JPRB, &
  & 0.26028080E-09_JPRB, 0.26043886E-09_JPRB, 0.26067132E-09_JPRB, 0.26096411E-09_JPRB, 0.26128769E-09_JPRB, 0.26161229E-09_JPRB, &
  & 0.26190505E-09_JPRB, 0.26214569E-09_JPRB, 0.26232366E-09_JPRB, 0.26243746E-09_JPRB, 0.26248978E-09_JPRB, 0.26248445E-09_JPRB, &
  & 0.26242347E-09_JPRB, 0.26230884E-09_JPRB, 0.26214350E-09_JPRB, 0.26193592E-09_JPRB, 0.26169747E-09_JPRB, 0.26144686E-09_JPRB, &
  & 0.26119501E-09_JPRB, 0.26095304E-09_JPRB, 0.26073324E-09_JPRB, 0.26055402E-09_JPRB, 0.26043645E-09_JPRB, 0.26039837E-09_JPRB, &
  & 0.26044375E-09_JPRB, 0.26055483E-09_JPRB, 0.26069161E-09_JPRB, 0.26081681E-09_JPRB, 0.26090383E-09_JPRB, 0.26094341E-09_JPRB, &
  & 0.26094465E-09_JPRB, 0.26092958E-09_JPRB, 0.26091013E-09_JPRB, 0.26089120E-09_JPRB, 0.26087393E-09_JPRB, 0.26085709E-09_JPRB, &
  & 0.26084096E-09_JPRB, 0.26082386E-09_JPRB, 0.26080488E-09_JPRB, 0.26078495E-09_JPRB, 0.26076610E-09_JPRB, 0.26074889E-09_JPRB, &
  & 0.26073396E-09_JPRB, 0.26071778E-09_JPRB, 0.26069857E-09_JPRB, 0.26066171E-09_JPRB /)

RGHG5(:,62, 3) = (/ &
  & 0.26026736E-09_JPRB, 0.26034880E-09_JPRB, 0.26038591E-09_JPRB, 0.26040980E-09_JPRB, 0.26043084E-09_JPRB, 0.26044619E-09_JPRB, &
  & 0.26045732E-09_JPRB, 0.26046440E-09_JPRB, 0.26047009E-09_JPRB, 0.26047520E-09_JPRB, 0.26048025E-09_JPRB, 0.26048530E-09_JPRB, &
  & 0.26048852E-09_JPRB, 0.26048533E-09_JPRB, 0.26046654E-09_JPRB, 0.26042976E-09_JPRB, 0.26039665E-09_JPRB, 0.26040223E-09_JPRB, &
  & 0.26047139E-09_JPRB, 0.26061603E-09_JPRB, 0.26083397E-09_JPRB, 0.26111008E-09_JPRB, 0.26141764E-09_JPRB, 0.26172467E-09_JPRB, &
  & 0.26200214E-09_JPRB, 0.26222838E-09_JPRB, 0.26239516E-09_JPRB, 0.26250024E-09_JPRB, 0.26254726E-09_JPRB, 0.26253971E-09_JPRB, &
  & 0.26247921E-09_JPRB, 0.26236735E-09_JPRB, 0.26220684E-09_JPRB, 0.26200619E-09_JPRB, 0.26177632E-09_JPRB, 0.26153513E-09_JPRB, &
  & 0.26129454E-09_JPRB, 0.26106470E-09_JPRB, 0.26085856E-09_JPRB, 0.26069369E-09_JPRB, 0.26058974E-09_JPRB, 0.26056238E-09_JPRB, &
  & 0.26061361E-09_JPRB, 0.26072566E-09_JPRB, 0.26086114E-09_JPRB, 0.26098432E-09_JPRB, 0.26107172E-09_JPRB, 0.26111308E-09_JPRB, &
  & 0.26111538E-09_JPRB, 0.26109778E-09_JPRB, 0.26107427E-09_JPRB, 0.26105113E-09_JPRB, 0.26102936E-09_JPRB, 0.26100994E-09_JPRB, &
  & 0.26099101E-09_JPRB, 0.26097183E-09_JPRB, 0.26095170E-09_JPRB, 0.26093097E-09_JPRB, 0.26091171E-09_JPRB, 0.26089547E-09_JPRB, &
  & 0.26087990E-09_JPRB, 0.26086472E-09_JPRB, 0.26084582E-09_JPRB, 0.26081093E-09_JPRB /)

RGHG5(:,63, 3) = (/ &
  & 0.26047428E-09_JPRB, 0.26054309E-09_JPRB, 0.26057168E-09_JPRB, 0.26059241E-09_JPRB, 0.26060915E-09_JPRB, 0.26062441E-09_JPRB, &
  & 0.26063623E-09_JPRB, 0.26064600E-09_JPRB, 0.26065430E-09_JPRB, 0.26066271E-09_JPRB, 0.26067171E-09_JPRB, 0.26068120E-09_JPRB, &
  & 0.26068958E-09_JPRB, 0.26068983E-09_JPRB, 0.26067126E-09_JPRB, 0.26063468E-09_JPRB, 0.26060157E-09_JPRB, 0.26060290E-09_JPRB, &
  & 0.26066382E-09_JPRB, 0.26079686E-09_JPRB, 0.26100053E-09_JPRB, 0.26126060E-09_JPRB, 0.26154945E-09_JPRB, 0.26183888E-09_JPRB, &
  & 0.26209790E-09_JPRB, 0.26230917E-09_JPRB, 0.26246344E-09_JPRB, 0.26255997E-09_JPRB, 0.26260197E-09_JPRB, 0.26259309E-09_JPRB, &
  & 0.26253458E-09_JPRB, 0.26242716E-09_JPRB, 0.26227340E-09_JPRB, 0.26208100E-09_JPRB, 0.26186095E-09_JPRB, 0.26162972E-09_JPRB, &
  & 0.26139990E-09_JPRB, 0.26118172E-09_JPRB, 0.26098798E-09_JPRB, 0.26083602E-09_JPRB, 0.26074426E-09_JPRB, 0.26072611E-09_JPRB, &
  & 0.26078195E-09_JPRB, 0.26089386E-09_JPRB, 0.26102681E-09_JPRB, 0.26114735E-09_JPRB, 0.26123342E-09_JPRB, 0.26127614E-09_JPRB, &
  & 0.26128014E-09_JPRB, 0.26126140E-09_JPRB, 0.26123381E-09_JPRB, 0.26120550E-09_JPRB, 0.26117955E-09_JPRB, 0.26115565E-09_JPRB, &
  & 0.26113348E-09_JPRB, 0.26111163E-09_JPRB, 0.26108898E-09_JPRB, 0.26106711E-09_JPRB, 0.26104749E-09_JPRB, 0.26103014E-09_JPRB, &
  & 0.26101485E-09_JPRB, 0.26099856E-09_JPRB, 0.26097913E-09_JPRB, 0.26094257E-09_JPRB /)

RGHG5(:,64, 3) = (/ &
  & 0.26065844E-09_JPRB, 0.26071784E-09_JPRB, 0.26074415E-09_JPRB, 0.26076230E-09_JPRB, 0.26077868E-09_JPRB, 0.26079355E-09_JPRB, &
  & 0.26080765E-09_JPRB, 0.26081975E-09_JPRB, 0.26083199E-09_JPRB, 0.26084457E-09_JPRB, 0.26085886E-09_JPRB, 0.26087438E-09_JPRB, &
  & 0.26088767E-09_JPRB, 0.26088962E-09_JPRB, 0.26087091E-09_JPRB, 0.26083569E-09_JPRB, 0.26080360E-09_JPRB, 0.26080271E-09_JPRB, &
  & 0.26085695E-09_JPRB, 0.26097952E-09_JPRB, 0.26116950E-09_JPRB, 0.26141253E-09_JPRB, 0.26168295E-09_JPRB, 0.26195174E-09_JPRB, &
  & 0.26219193E-09_JPRB, 0.26238639E-09_JPRB, 0.26252783E-09_JPRB, 0.26261548E-09_JPRB, 0.26265301E-09_JPRB, 0.26264355E-09_JPRB, &
  & 0.26258803E-09_JPRB, 0.26248667E-09_JPRB, 0.26234129E-09_JPRB, 0.26215913E-09_JPRB, 0.26194963E-09_JPRB, 0.26172967E-09_JPRB, &
  & 0.26151045E-09_JPRB, 0.26130348E-09_JPRB, 0.26112137E-09_JPRB, 0.26098113E-09_JPRB, 0.26090005E-09_JPRB, 0.26088953E-09_JPRB, &
  & 0.26094854E-09_JPRB, 0.26105906E-09_JPRB, 0.26118835E-09_JPRB, 0.26130523E-09_JPRB, 0.26138919E-09_JPRB, 0.26143207E-09_JPRB, &
  & 0.26143773E-09_JPRB, 0.26141894E-09_JPRB, 0.26138874E-09_JPRB, 0.26135602E-09_JPRB, 0.26132502E-09_JPRB, 0.26129687E-09_JPRB, &
  & 0.26127078E-09_JPRB, 0.26124519E-09_JPRB, 0.26122027E-09_JPRB, 0.26119637E-09_JPRB, 0.26117541E-09_JPRB, 0.26115754E-09_JPRB, &
  & 0.26114044E-09_JPRB, 0.26112312E-09_JPRB, 0.26110133E-09_JPRB, 0.26106070E-09_JPRB /)

RGHG5(:,65, 3) = (/ &
  & 0.26081975E-09_JPRB, 0.26087907E-09_JPRB, 0.26090491E-09_JPRB, 0.26092378E-09_JPRB, 0.26094027E-09_JPRB, 0.26095659E-09_JPRB, &
  & 0.26097213E-09_JPRB, 0.26098823E-09_JPRB, 0.26100389E-09_JPRB, 0.26102259E-09_JPRB, 0.26104263E-09_JPRB, 0.26106436E-09_JPRB, &
  & 0.26108082E-09_JPRB, 0.26108293E-09_JPRB, 0.26106492E-09_JPRB, 0.26103195E-09_JPRB, 0.26100161E-09_JPRB, 0.26099950E-09_JPRB, &
  & 0.26104890E-09_JPRB, 0.26116226E-09_JPRB, 0.26133895E-09_JPRB, 0.26156471E-09_JPRB, 0.26181465E-09_JPRB, 0.26206209E-09_JPRB, &
  & 0.26228178E-09_JPRB, 0.26245900E-09_JPRB, 0.26258726E-09_JPRB, 0.26266619E-09_JPRB, 0.26269936E-09_JPRB, 0.26268976E-09_JPRB, &
  & 0.26263794E-09_JPRB, 0.26254363E-09_JPRB, 0.26240815E-09_JPRB, 0.26223720E-09_JPRB, 0.26204064E-09_JPRB, 0.26183233E-09_JPRB, &
  & 0.26162500E-09_JPRB, 0.26142902E-09_JPRB, 0.26125840E-09_JPRB, 0.26112917E-09_JPRB, 0.26105734E-09_JPRB, 0.26105301E-09_JPRB, &
  & 0.26111352E-09_JPRB, 0.26122118E-09_JPRB, 0.26134550E-09_JPRB, 0.26145788E-09_JPRB, 0.26153904E-09_JPRB, 0.26158112E-09_JPRB, &
  & 0.26158767E-09_JPRB, 0.26156954E-09_JPRB, 0.26153801E-09_JPRB, 0.26150251E-09_JPRB, 0.26146735E-09_JPRB, 0.26143507E-09_JPRB, &
  & 0.26140451E-09_JPRB, 0.26137581E-09_JPRB, 0.26134742E-09_JPRB, 0.26132180E-09_JPRB, 0.26129932E-09_JPRB, 0.26127939E-09_JPRB, &
  & 0.26126085E-09_JPRB, 0.26124036E-09_JPRB, 0.26121472E-09_JPRB, 0.26116589E-09_JPRB /)

RGHG5(:,66, 3) = (/ &
  & 0.26096741E-09_JPRB, 0.26102953E-09_JPRB, 0.26105801E-09_JPRB, 0.26107849E-09_JPRB, 0.26109698E-09_JPRB, 0.26111488E-09_JPRB, &
  & 0.26113339E-09_JPRB, 0.26115182E-09_JPRB, 0.26117353E-09_JPRB, 0.26119651E-09_JPRB, 0.26122388E-09_JPRB, 0.26124894E-09_JPRB, &
  & 0.26126673E-09_JPRB, 0.26126906E-09_JPRB, 0.26125271E-09_JPRB, 0.26122265E-09_JPRB, 0.26119487E-09_JPRB, 0.26119290E-09_JPRB, &
  & 0.26123850E-09_JPRB, 0.26134347E-09_JPRB, 0.26150657E-09_JPRB, 0.26171421E-09_JPRB, 0.26194277E-09_JPRB, 0.26216754E-09_JPRB, &
  & 0.26236635E-09_JPRB, 0.26252597E-09_JPRB, 0.26264102E-09_JPRB, 0.26271141E-09_JPRB, 0.26274052E-09_JPRB, 0.26273095E-09_JPRB, &
  & 0.26268318E-09_JPRB, 0.26259639E-09_JPRB, 0.26247160E-09_JPRB, 0.26231337E-09_JPRB, 0.26213060E-09_JPRB, 0.26193592E-09_JPRB, &
  & 0.26174096E-09_JPRB, 0.26155714E-09_JPRB, 0.26139813E-09_JPRB, 0.26127972E-09_JPRB, 0.26121608E-09_JPRB, 0.26121638E-09_JPRB, &
  & 0.26127708E-09_JPRB, 0.26137997E-09_JPRB, 0.26149827E-09_JPRB, 0.26160543E-09_JPRB, 0.26168276E-09_JPRB, 0.26172356E-09_JPRB, &
  & 0.26173030E-09_JPRB, 0.26171271E-09_JPRB, 0.26168123E-09_JPRB, 0.26164390E-09_JPRB, 0.26160654E-09_JPRB, 0.26157038E-09_JPRB, &
  & 0.26153685E-09_JPRB, 0.26150401E-09_JPRB, 0.26147370E-09_JPRB, 0.26144559E-09_JPRB, 0.26142133E-09_JPRB, 0.26139965E-09_JPRB, &
  & 0.26137795E-09_JPRB, 0.26135408E-09_JPRB, 0.26132232E-09_JPRB, 0.26126010E-09_JPRB /)

RGHG5(:,67, 3) = (/ &
  & 0.26110675E-09_JPRB, 0.26117436E-09_JPRB, 0.26120545E-09_JPRB, 0.26122898E-09_JPRB, 0.26124999E-09_JPRB, 0.26127078E-09_JPRB, &
  & 0.26129177E-09_JPRB, 0.26131464E-09_JPRB, 0.26133939E-09_JPRB, 0.26136915E-09_JPRB, 0.26139926E-09_JPRB, 0.26142691E-09_JPRB, &
  & 0.26144503E-09_JPRB, 0.26144809E-09_JPRB, 0.26143382E-09_JPRB, 0.26140709E-09_JPRB, 0.26138233E-09_JPRB, 0.26138114E-09_JPRB, &
  & 0.26142363E-09_JPRB, 0.26152022E-09_JPRB, 0.26166969E-09_JPRB, 0.26185837E-09_JPRB, 0.26206484E-09_JPRB, 0.26226665E-09_JPRB, &
  & 0.26244459E-09_JPRB, 0.26258701E-09_JPRB, 0.26268915E-09_JPRB, 0.26275140E-09_JPRB, 0.26277663E-09_JPRB, 0.26276725E-09_JPRB, &
  & 0.26272362E-09_JPRB, 0.26264457E-09_JPRB, 0.26253072E-09_JPRB, 0.26238592E-09_JPRB, 0.26221803E-09_JPRB, 0.26203795E-09_JPRB, &
  & 0.26185673E-09_JPRB, 0.26168603E-09_JPRB, 0.26153946E-09_JPRB, 0.26143182E-09_JPRB, 0.26137595E-09_JPRB, 0.26137961E-09_JPRB, &
  & 0.26143876E-09_JPRB, 0.26153604E-09_JPRB, 0.26164695E-09_JPRB, 0.26174762E-09_JPRB, 0.26182109E-09_JPRB, 0.26185953E-09_JPRB, &
  & 0.26186614E-09_JPRB, 0.26184918E-09_JPRB, 0.26181785E-09_JPRB, 0.26178054E-09_JPRB, 0.26174138E-09_JPRB, 0.26170380E-09_JPRB, &
  & 0.26166697E-09_JPRB, 0.26163247E-09_JPRB, 0.26159930E-09_JPRB, 0.26156982E-09_JPRB, 0.26154368E-09_JPRB, 0.26151975E-09_JPRB, &
  & 0.26149566E-09_JPRB, 0.26146693E-09_JPRB, 0.26142699E-09_JPRB, 0.26134664E-09_JPRB /)

RGHG5(:,68, 3) = (/ &
  & 0.26123798E-09_JPRB, 0.26131253E-09_JPRB, 0.26134883E-09_JPRB, 0.26137592E-09_JPRB, 0.26140065E-09_JPRB, 0.26142460E-09_JPRB, &
  & 0.26144897E-09_JPRB, 0.26147493E-09_JPRB, 0.26150443E-09_JPRB, 0.26153663E-09_JPRB, 0.26156960E-09_JPRB, 0.26159755E-09_JPRB, &
  & 0.26161590E-09_JPRB, 0.26161984E-09_JPRB, 0.26160782E-09_JPRB, 0.26158448E-09_JPRB, 0.26156313E-09_JPRB, 0.26156283E-09_JPRB, &
  & 0.26160218E-09_JPRB, 0.26169031E-09_JPRB, 0.26182539E-09_JPRB, 0.26199498E-09_JPRB, 0.26217925E-09_JPRB, 0.26235872E-09_JPRB, &
  & 0.26251645E-09_JPRB, 0.26264235E-09_JPRB, 0.26273231E-09_JPRB, 0.26278676E-09_JPRB, 0.26280850E-09_JPRB, 0.26279937E-09_JPRB, &
  & 0.26275973E-09_JPRB, 0.26268851E-09_JPRB, 0.26258570E-09_JPRB, 0.26245450E-09_JPRB, 0.26230199E-09_JPRB, 0.26213695E-09_JPRB, &
  & 0.26197064E-09_JPRB, 0.26181385E-09_JPRB, 0.26168037E-09_JPRB, 0.26158392E-09_JPRB, 0.26153540E-09_JPRB, 0.26154159E-09_JPRB, &
  & 0.26159835E-09_JPRB, 0.26168864E-09_JPRB, 0.26179148E-09_JPRB, 0.26188524E-09_JPRB, 0.26195324E-09_JPRB, 0.26198957E-09_JPRB, &
  & 0.26199556E-09_JPRB, 0.26197911E-09_JPRB, 0.26194880E-09_JPRB, 0.26191171E-09_JPRB, 0.26187277E-09_JPRB, 0.26183383E-09_JPRB, &
  & 0.26179625E-09_JPRB, 0.26175984E-09_JPRB, 0.26172578E-09_JPRB, 0.26169469E-09_JPRB, 0.26166752E-09_JPRB, 0.26164226E-09_JPRB, &
  & 0.26161578E-09_JPRB, 0.26158342E-09_JPRB, 0.26153565E-09_JPRB, 0.26143340E-09_JPRB /)

RGHG5(:,69, 3) = (/ &
  & 0.26136393E-09_JPRB, 0.26144936E-09_JPRB, 0.26149000E-09_JPRB, 0.26152203E-09_JPRB, 0.26155039E-09_JPRB, 0.26157804E-09_JPRB, &
  & 0.26160527E-09_JPRB, 0.26163433E-09_JPRB, 0.26166655E-09_JPRB, 0.26170072E-09_JPRB, 0.26173419E-09_JPRB, 0.26176186E-09_JPRB, &
  & 0.26178007E-09_JPRB, 0.26178476E-09_JPRB, 0.26177474E-09_JPRB, 0.26175481E-09_JPRB, 0.26173638E-09_JPRB, 0.26173680E-09_JPRB, &
  & 0.26177249E-09_JPRB, 0.26185157E-09_JPRB, 0.26197236E-09_JPRB, 0.26212268E-09_JPRB, 0.26228564E-09_JPRB, 0.26244348E-09_JPRB, &
  & 0.26258229E-09_JPRB, 0.26269253E-09_JPRB, 0.26277111E-09_JPRB, 0.26281829E-09_JPRB, 0.26283675E-09_JPRB, 0.26282801E-09_JPRB, &
  & 0.26279243E-09_JPRB, 0.26272878E-09_JPRB, 0.26263711E-09_JPRB, 0.26251953E-09_JPRB, 0.26238214E-09_JPRB, 0.26223279E-09_JPRB, &
  & 0.26208152E-09_JPRB, 0.26193958E-09_JPRB, 0.26181970E-09_JPRB, 0.26173441E-09_JPRB, 0.26169325E-09_JPRB, 0.26170144E-09_JPRB, &
  & 0.26175484E-09_JPRB, 0.26183813E-09_JPRB, 0.26193198E-09_JPRB, 0.26201769E-09_JPRB, 0.26208047E-09_JPRB, 0.26211358E-09_JPRB, &
  & 0.26211910E-09_JPRB, 0.26210348E-09_JPRB, 0.26207420E-09_JPRB, 0.26203842E-09_JPRB, 0.26200020E-09_JPRB, 0.26196179E-09_JPRB, &
  & 0.26192390E-09_JPRB, 0.26188751E-09_JPRB, 0.26185296E-09_JPRB, 0.26182176E-09_JPRB, 0.26179400E-09_JPRB, 0.26176825E-09_JPRB, &
  & 0.26174088E-09_JPRB, 0.26170591E-09_JPRB, 0.26164995E-09_JPRB, 0.26152902E-09_JPRB /)

RGHG5(:,70, 3) = (/ &
  & 0.26148766E-09_JPRB, 0.26158339E-09_JPRB, 0.26163219E-09_JPRB, 0.26166835E-09_JPRB, 0.26170138E-09_JPRB, 0.26173161E-09_JPRB, &
  & 0.26176156E-09_JPRB, 0.26179278E-09_JPRB, 0.26182626E-09_JPRB, 0.26186101E-09_JPRB, 0.26189345E-09_JPRB, 0.26192010E-09_JPRB, &
  & 0.26193750E-09_JPRB, 0.26194244E-09_JPRB, 0.26193425E-09_JPRB, 0.26191710E-09_JPRB, 0.26190133E-09_JPRB, 0.26190178E-09_JPRB, &
  & 0.26193347E-09_JPRB, 0.26200325E-09_JPRB, 0.26210947E-09_JPRB, 0.26224128E-09_JPRB, 0.26238359E-09_JPRB, 0.26252142E-09_JPRB, &
  & 0.26264219E-09_JPRB, 0.26273811E-09_JPRB, 0.26280594E-09_JPRB, 0.26284641E-09_JPRB, 0.26286193E-09_JPRB, 0.26285368E-09_JPRB, &
  & 0.26282210E-09_JPRB, 0.26276606E-09_JPRB, 0.26268512E-09_JPRB, 0.26258101E-09_JPRB, 0.26245889E-09_JPRB, 0.26232486E-09_JPRB, &
  & 0.26218933E-09_JPRB, 0.26206229E-09_JPRB, 0.26195612E-09_JPRB, 0.26188202E-09_JPRB, 0.26184768E-09_JPRB, 0.26185748E-09_JPRB, &
  & 0.26190744E-09_JPRB, 0.26198280E-09_JPRB, 0.26206798E-09_JPRB, 0.26214531E-09_JPRB, 0.26220165E-09_JPRB, 0.26223182E-09_JPRB, &
  & 0.26223665E-09_JPRB, 0.26222191E-09_JPRB, 0.26219452E-09_JPRB, 0.26216057E-09_JPRB, 0.26212421E-09_JPRB, 0.26208713E-09_JPRB, &
  & 0.26205055E-09_JPRB, 0.26201513E-09_JPRB, 0.26198146E-09_JPRB, 0.26195102E-09_JPRB, 0.26192393E-09_JPRB, 0.26189850E-09_JPRB, &
  & 0.26187136E-09_JPRB, 0.26183539E-09_JPRB, 0.26177616E-09_JPRB, 0.26163979E-09_JPRB /)

RGHG5(:,71, 3) = (/ &
  & 0.26160824E-09_JPRB, 0.26172164E-09_JPRB, 0.26177616E-09_JPRB, 0.26181818E-09_JPRB, 0.26185382E-09_JPRB, 0.26188676E-09_JPRB, &
  & 0.26191765E-09_JPRB, 0.26194996E-09_JPRB, 0.26198357E-09_JPRB, 0.26201688E-09_JPRB, 0.26204777E-09_JPRB, 0.26207231E-09_JPRB, &
  & 0.26208821E-09_JPRB, 0.26209285E-09_JPRB, 0.26208571E-09_JPRB, 0.26207081E-09_JPRB, 0.26205707E-09_JPRB, 0.26205715E-09_JPRB, &
  & 0.26208458E-09_JPRB, 0.26214494E-09_JPRB, 0.26223701E-09_JPRB, 0.26235092E-09_JPRB, 0.26247363E-09_JPRB, 0.26259256E-09_JPRB, &
  & 0.26269678E-09_JPRB, 0.26277905E-09_JPRB, 0.26283722E-09_JPRB, 0.26287145E-09_JPRB, 0.26288433E-09_JPRB, 0.26287675E-09_JPRB, &
  & 0.26284919E-09_JPRB, 0.26280045E-09_JPRB, 0.26273012E-09_JPRB, 0.26263908E-09_JPRB, 0.26253202E-09_JPRB, 0.26241348E-09_JPRB, &
  & 0.26229349E-09_JPRB, 0.26218139E-09_JPRB, 0.26208877E-09_JPRB, 0.26202540E-09_JPRB, 0.26199751E-09_JPRB, 0.26200847E-09_JPRB, &
  & 0.26205402E-09_JPRB, 0.26212230E-09_JPRB, 0.26219757E-09_JPRB, 0.26226638E-09_JPRB, 0.26231656E-09_JPRB, 0.26234320E-09_JPRB, &
  & 0.26234750E-09_JPRB, 0.26233429E-09_JPRB, 0.26230901E-09_JPRB, 0.26227789E-09_JPRB, 0.26224431E-09_JPRB, 0.26220962E-09_JPRB, &
  & 0.26217556E-09_JPRB, 0.26214220E-09_JPRB, 0.26211081E-09_JPRB, 0.26208197E-09_JPRB, 0.26205646E-09_JPRB, 0.26203234E-09_JPRB, &
  & 0.26200631E-09_JPRB, 0.26197133E-09_JPRB, 0.26191135E-09_JPRB, 0.26177144E-09_JPRB /)

RGHG5(:,72, 3) = (/ &
  & 0.26173261E-09_JPRB, 0.26186203E-09_JPRB, 0.26192568E-09_JPRB, 0.26197078E-09_JPRB, 0.26200880E-09_JPRB, 0.26204194E-09_JPRB, &
  & 0.26207339E-09_JPRB, 0.26210517E-09_JPRB, 0.26213681E-09_JPRB, 0.26216868E-09_JPRB, 0.26219607E-09_JPRB, 0.26221808E-09_JPRB, &
  & 0.26223179E-09_JPRB, 0.26223534E-09_JPRB, 0.26222868E-09_JPRB, 0.26221525E-09_JPRB, 0.26220329E-09_JPRB, 0.26220273E-09_JPRB, &
  & 0.26222588E-09_JPRB, 0.26227701E-09_JPRB, 0.26235547E-09_JPRB, 0.26245198E-09_JPRB, 0.26255634E-09_JPRB, 0.26265751E-09_JPRB, &
  & 0.26274605E-09_JPRB, 0.26281599E-09_JPRB, 0.26286526E-09_JPRB, 0.26289390E-09_JPRB, 0.26290442E-09_JPRB, 0.26289743E-09_JPRB, &
  & 0.26287383E-09_JPRB, 0.26283217E-09_JPRB, 0.26277189E-09_JPRB, 0.26269389E-09_JPRB, 0.26260141E-09_JPRB, 0.26249830E-09_JPRB, &
  & 0.26239383E-09_JPRB, 0.26229638E-09_JPRB, 0.26221703E-09_JPRB, 0.26216385E-09_JPRB, 0.26214159E-09_JPRB, 0.26215305E-09_JPRB, &
  & 0.26219449E-09_JPRB, 0.26225389E-09_JPRB, 0.26232028E-09_JPRB, 0.26238003E-09_JPRB, 0.26242372E-09_JPRB, 0.26244706E-09_JPRB, &
  & 0.26245101E-09_JPRB, 0.26243926E-09_JPRB, 0.26241709E-09_JPRB, 0.26238939E-09_JPRB, 0.26235936E-09_JPRB, 0.26232846E-09_JPRB, &
  & 0.26229741E-09_JPRB, 0.26226771E-09_JPRB, 0.26223879E-09_JPRB, 0.26221286E-09_JPRB, 0.26218924E-09_JPRB, 0.26216707E-09_JPRB, &
  & 0.26214286E-09_JPRB, 0.26210986E-09_JPRB, 0.26205210E-09_JPRB, 0.26191385E-09_JPRB /)

RGHG5(:,73, 3) = (/ &
  & 0.26187957E-09_JPRB, 0.26201588E-09_JPRB, 0.26208086E-09_JPRB, 0.26212615E-09_JPRB, 0.26216337E-09_JPRB, 0.26219571E-09_JPRB, &
  & 0.26222557E-09_JPRB, 0.26225538E-09_JPRB, 0.26228522E-09_JPRB, 0.26231287E-09_JPRB, 0.26233768E-09_JPRB, 0.26235605E-09_JPRB, &
  & 0.26236721E-09_JPRB, 0.26236921E-09_JPRB, 0.26236235E-09_JPRB, 0.26234992E-09_JPRB, 0.26233926E-09_JPRB, 0.26233798E-09_JPRB, &
  & 0.26235716E-09_JPRB, 0.26239949E-09_JPRB, 0.26246477E-09_JPRB, 0.26254504E-09_JPRB, 0.26263189E-09_JPRB, 0.26271668E-09_JPRB, &
  & 0.26279071E-09_JPRB, 0.26284902E-09_JPRB, 0.26289015E-09_JPRB, 0.26291377E-09_JPRB, 0.26292227E-09_JPRB, 0.26291605E-09_JPRB, &
  & 0.26289626E-09_JPRB, 0.26286123E-09_JPRB, 0.26281063E-09_JPRB, 0.26274524E-09_JPRB, 0.26266672E-09_JPRB, 0.26257913E-09_JPRB, &
  & 0.26248989E-09_JPRB, 0.26240668E-09_JPRB, 0.26234007E-09_JPRB, 0.26229627E-09_JPRB, 0.26227892E-09_JPRB, 0.26229058E-09_JPRB, &
  & 0.26232644E-09_JPRB, 0.26237812E-09_JPRB, 0.26243424E-09_JPRB, 0.26248526E-09_JPRB, 0.26252292E-09_JPRB, 0.26254263E-09_JPRB, &
  & 0.26254635E-09_JPRB, 0.26253671E-09_JPRB, 0.26251745E-09_JPRB, 0.26249394E-09_JPRB, 0.26246830E-09_JPRB, 0.26244104E-09_JPRB, &
  & 0.26241470E-09_JPRB, 0.26238808E-09_JPRB, 0.26236338E-09_JPRB, 0.26233976E-09_JPRB, 0.26231900E-09_JPRB, 0.26229893E-09_JPRB, &
  & 0.26227701E-09_JPRB, 0.26224681E-09_JPRB, 0.26219318E-09_JPRB, 0.26206087E-09_JPRB /)

RGHG5(:,74, 3) = (/ &
  & 0.26203245E-09_JPRB, 0.26217295E-09_JPRB, 0.26223632E-09_JPRB, 0.26227975E-09_JPRB, 0.26231389E-09_JPRB, 0.26234348E-09_JPRB, &
  & 0.26237121E-09_JPRB, 0.26239796E-09_JPRB, 0.26242403E-09_JPRB, 0.26244884E-09_JPRB, 0.26246910E-09_JPRB, 0.26248448E-09_JPRB, &
  & 0.26249300E-09_JPRB, 0.26249330E-09_JPRB, 0.26248601E-09_JPRB, 0.26247424E-09_JPRB, 0.26246497E-09_JPRB, 0.26246305E-09_JPRB, &
  & 0.26247829E-09_JPRB, 0.26251240E-09_JPRB, 0.26256525E-09_JPRB, 0.26263047E-09_JPRB, 0.26270111E-09_JPRB, 0.26277078E-09_JPRB, &
  & 0.26283109E-09_JPRB, 0.26287880E-09_JPRB, 0.26291239E-09_JPRB, 0.26293148E-09_JPRB, 0.26293823E-09_JPRB, 0.26293279E-09_JPRB, &
  & 0.26291658E-09_JPRB, 0.26288793E-09_JPRB, 0.26284655E-09_JPRB, 0.26279276E-09_JPRB, 0.26272826E-09_JPRB, 0.26265518E-09_JPRB, &
  & 0.26258129E-09_JPRB, 0.26251190E-09_JPRB, 0.26245711E-09_JPRB, 0.26242208E-09_JPRB, 0.26240879E-09_JPRB, 0.26241986E-09_JPRB, &
  & 0.26245070E-09_JPRB, 0.26249314E-09_JPRB, 0.26253988E-09_JPRB, 0.26258234E-09_JPRB, 0.26261354E-09_JPRB, 0.26263025E-09_JPRB, &
  & 0.26263358E-09_JPRB, 0.26262573E-09_JPRB, 0.26261013E-09_JPRB, 0.26259075E-09_JPRB, 0.26256930E-09_JPRB, 0.26254673E-09_JPRB, &
  & 0.26252397E-09_JPRB, 0.26250244E-09_JPRB, 0.26248070E-09_JPRB, 0.26246083E-09_JPRB, 0.26244240E-09_JPRB, 0.26242500E-09_JPRB, &
  & 0.26240596E-09_JPRB, 0.26237906E-09_JPRB, 0.26233038E-09_JPRB, 0.26220714E-09_JPRB /)

RGHG5(:,75, 3) = (/ &
  & 0.26218969E-09_JPRB, 0.26232785E-09_JPRB, 0.26238881E-09_JPRB, 0.26242619E-09_JPRB, 0.26245670E-09_JPRB, 0.26248256E-09_JPRB, &
  & 0.26250677E-09_JPRB, 0.26253003E-09_JPRB, 0.26255242E-09_JPRB, 0.26257274E-09_JPRB, 0.26258970E-09_JPRB, 0.26260172E-09_JPRB, &
  & 0.26260794E-09_JPRB, 0.26260677E-09_JPRB, 0.26259928E-09_JPRB, 0.26258840E-09_JPRB, 0.26258051E-09_JPRB, 0.26257796E-09_JPRB, &
  & 0.26258964E-09_JPRB, 0.26261593E-09_JPRB, 0.26265781E-09_JPRB, 0.26270888E-09_JPRB, 0.26276484E-09_JPRB, 0.26282032E-09_JPRB, &
  & 0.26286773E-09_JPRB, 0.26290553E-09_JPRB, 0.26293220E-09_JPRB, 0.26294719E-09_JPRB, 0.26295244E-09_JPRB, 0.26294766E-09_JPRB, &
  & 0.26293492E-09_JPRB, 0.26291230E-09_JPRB, 0.26287938E-09_JPRB, 0.26283678E-09_JPRB, 0.26278565E-09_JPRB, 0.26272667E-09_JPRB, &
  & 0.26266764E-09_JPRB, 0.26261157E-09_JPRB, 0.26256808E-09_JPRB, 0.26254074E-09_JPRB, 0.26253089E-09_JPRB, 0.26254099E-09_JPRB, &
  & 0.26256591E-09_JPRB, 0.26260014E-09_JPRB, 0.26263738E-09_JPRB, 0.26267122E-09_JPRB, 0.26269706E-09_JPRB, 0.26271010E-09_JPRB, &
  & 0.26271313E-09_JPRB, 0.26270713E-09_JPRB, 0.26269459E-09_JPRB, 0.26267946E-09_JPRB, 0.26266250E-09_JPRB, 0.26264343E-09_JPRB, &
  & 0.26262559E-09_JPRB, 0.26260774E-09_JPRB, 0.26259073E-09_JPRB, 0.26257366E-09_JPRB, 0.26255847E-09_JPRB, 0.26254401E-09_JPRB, &
  & 0.26252811E-09_JPRB, 0.26250521E-09_JPRB, 0.26246194E-09_JPRB, 0.26234856E-09_JPRB /)

RGHG5(:,76, 3) = (/ &
  & 0.26234775E-09_JPRB, 0.26248023E-09_JPRB, 0.26253302E-09_JPRB, 0.26256475E-09_JPRB, 0.26258951E-09_JPRB, 0.26261104E-09_JPRB, &
  & 0.26263144E-09_JPRB, 0.26265029E-09_JPRB, 0.26266855E-09_JPRB, 0.26268454E-09_JPRB, 0.26269731E-09_JPRB, 0.26270636E-09_JPRB, &
  & 0.26271080E-09_JPRB, 0.26270880E-09_JPRB, 0.26270178E-09_JPRB, 0.26269226E-09_JPRB, 0.26268621E-09_JPRB, 0.26268321E-09_JPRB, &
  & 0.26269159E-09_JPRB, 0.26271102E-09_JPRB, 0.26274261E-09_JPRB, 0.26278130E-09_JPRB, 0.26282324E-09_JPRB, 0.26286567E-09_JPRB, &
  & 0.26290076E-09_JPRB, 0.26292943E-09_JPRB, 0.26294980E-09_JPRB, 0.26296118E-09_JPRB, 0.26296512E-09_JPRB, 0.26296099E-09_JPRB, &
  & 0.26295163E-09_JPRB, 0.26293451E-09_JPRB, 0.26290933E-09_JPRB, 0.26287728E-09_JPRB, 0.26283892E-09_JPRB, 0.26279320E-09_JPRB, &
  & 0.26274843E-09_JPRB, 0.26270547E-09_JPRB, 0.26267244E-09_JPRB, 0.26265223E-09_JPRB, 0.26264504E-09_JPRB, 0.26265345E-09_JPRB, &
  & 0.26267272E-09_JPRB, 0.26269867E-09_JPRB, 0.26272709E-09_JPRB, 0.26275310E-09_JPRB, 0.26277297E-09_JPRB, 0.26278296E-09_JPRB, &
  & 0.26278535E-09_JPRB, 0.26278082E-09_JPRB, 0.26277144E-09_JPRB, 0.26276020E-09_JPRB, 0.26274727E-09_JPRB, 0.26273222E-09_JPRB, &
  & 0.26271818E-09_JPRB, 0.26270508E-09_JPRB, 0.26269195E-09_JPRB, 0.26267871E-09_JPRB, 0.26266650E-09_JPRB, 0.26265526E-09_JPRB, &
  & 0.26264305E-09_JPRB, 0.26262423E-09_JPRB, 0.26258737E-09_JPRB, 0.26248381E-09_JPRB /)

RGHG5(:,77, 3) = (/ &
  & 0.26250749E-09_JPRB, 0.26262409E-09_JPRB, 0.26266908E-09_JPRB, 0.26269198E-09_JPRB, 0.26271121E-09_JPRB, 0.26272762E-09_JPRB, &
  & 0.26274347E-09_JPRB, 0.26275787E-09_JPRB, 0.26277092E-09_JPRB, 0.26278241E-09_JPRB, 0.26279087E-09_JPRB, 0.26279703E-09_JPRB, &
  & 0.26280014E-09_JPRB, 0.26279806E-09_JPRB, 0.26279245E-09_JPRB, 0.26278493E-09_JPRB, 0.26278130E-09_JPRB, 0.26277816E-09_JPRB, &
  & 0.26278385E-09_JPRB, 0.26279690E-09_JPRB, 0.26281999E-09_JPRB, 0.26284691E-09_JPRB, 0.26287628E-09_JPRB, 0.26290661E-09_JPRB, &
  & 0.26293023E-09_JPRB, 0.26295061E-09_JPRB, 0.26296534E-09_JPRB, 0.26297350E-09_JPRB, 0.26297639E-09_JPRB, 0.26297281E-09_JPRB, &
  & 0.26296659E-09_JPRB, 0.26295432E-09_JPRB, 0.26293634E-09_JPRB, 0.26291405E-09_JPRB, 0.26288716E-09_JPRB, 0.26285446E-09_JPRB, &
  & 0.26282268E-09_JPRB, 0.26279243E-09_JPRB, 0.26276928E-09_JPRB, 0.26275529E-09_JPRB, 0.26275010E-09_JPRB, 0.26275634E-09_JPRB, &
  & 0.26276961E-09_JPRB, 0.26278812E-09_JPRB, 0.26280852E-09_JPRB, 0.26282657E-09_JPRB, 0.26284153E-09_JPRB, 0.26284808E-09_JPRB, &
  & 0.26284994E-09_JPRB, 0.26284680E-09_JPRB, 0.26284011E-09_JPRB, 0.26283276E-09_JPRB, 0.26282382E-09_JPRB, 0.26281188E-09_JPRB, &
  & 0.26280200E-09_JPRB, 0.26279309E-09_JPRB, 0.26278446E-09_JPRB, 0.26277458E-09_JPRB, 0.26276567E-09_JPRB, 0.26275773E-09_JPRB, &
  & 0.26274935E-09_JPRB, 0.26273497E-09_JPRB, 0.26270477E-09_JPRB, 0.26261451E-09_JPRB /)

RGHG5(:,78, 3) = (/ &
  & 0.26266439E-09_JPRB, 0.26275498E-09_JPRB, 0.26278613E-09_JPRB, 0.26280081E-09_JPRB, 0.26281397E-09_JPRB, 0.26282557E-09_JPRB, &
  & 0.26283686E-09_JPRB, 0.26284580E-09_JPRB, 0.26285446E-09_JPRB, 0.26286073E-09_JPRB, 0.26286548E-09_JPRB, 0.26286906E-09_JPRB, &
  & 0.26287150E-09_JPRB, 0.26286995E-09_JPRB, 0.26286628E-09_JPRB, 0.26286145E-09_JPRB, 0.26286051E-09_JPRB, 0.26285790E-09_JPRB, &
  & 0.26286162E-09_JPRB, 0.26286981E-09_JPRB, 0.26288560E-09_JPRB, 0.26290278E-09_JPRB, 0.26292107E-09_JPRB, 0.26294103E-09_JPRB, &
  & 0.26295488E-09_JPRB, 0.26296818E-09_JPRB, 0.26297819E-09_JPRB, 0.26298372E-09_JPRB, 0.26298574E-09_JPRB, 0.26298266E-09_JPRB, &
  & 0.26297914E-09_JPRB, 0.26297098E-09_JPRB, 0.26295921E-09_JPRB, 0.26294522E-09_JPRB, 0.26292854E-09_JPRB, 0.26290697E-09_JPRB, &
  & 0.26288677E-09_JPRB, 0.26286745E-09_JPRB, 0.26285296E-09_JPRB, 0.26284414E-09_JPRB, 0.26284011E-09_JPRB, 0.26284364E-09_JPRB, &
  & 0.26285121E-09_JPRB, 0.26286337E-09_JPRB, 0.26287653E-09_JPRB, 0.26288793E-09_JPRB, 0.26289837E-09_JPRB, 0.26290206E-09_JPRB, &
  & 0.26290356E-09_JPRB, 0.26290153E-09_JPRB, 0.26289732E-09_JPRB, 0.26289329E-09_JPRB, 0.26288779E-09_JPRB, 0.26287852E-09_JPRB, &
  & 0.26287220E-09_JPRB, 0.26286709E-09_JPRB, 0.26286226E-09_JPRB, 0.26285546E-09_JPRB, 0.26284935E-09_JPRB, 0.26284463E-09_JPRB, &
  & 0.26283986E-09_JPRB, 0.26282967E-09_JPRB, 0.26280975E-09_JPRB, 0.26273969E-09_JPRB /)

RGHG5(:,79, 3) = (/ &
  & 0.26276623E-09_JPRB, 0.26282768E-09_JPRB, 0.26284885E-09_JPRB, 0.26285679E-09_JPRB, 0.26286709E-09_JPRB, 0.26287603E-09_JPRB, &
  & 0.26288483E-09_JPRB, 0.26289132E-09_JPRB, 0.26289673E-09_JPRB, 0.26290128E-09_JPRB, 0.26290378E-09_JPRB, 0.26290645E-09_JPRB, &
  & 0.26290875E-09_JPRB, 0.26290728E-09_JPRB, 0.26290461E-09_JPRB, 0.26290115E-09_JPRB, 0.26290209E-09_JPRB, 0.26289965E-09_JPRB, &
  & 0.26290259E-09_JPRB, 0.26290808E-09_JPRB, 0.26292063E-09_JPRB, 0.26293259E-09_JPRB, 0.26294500E-09_JPRB, 0.26295965E-09_JPRB, &
  & 0.26296798E-09_JPRB, 0.26297758E-09_JPRB, 0.26298527E-09_JPRB, 0.26298946E-09_JPRB, 0.26299107E-09_JPRB, 0.26298805E-09_JPRB, &
  & 0.26298616E-09_JPRB, 0.26298008E-09_JPRB, 0.26297167E-09_JPRB, 0.26296226E-09_JPRB, 0.26295116E-09_JPRB, 0.26293553E-09_JPRB, &
  & 0.26292146E-09_JPRB, 0.26290797E-09_JPRB, 0.26289815E-09_JPRB, 0.26289179E-09_JPRB, 0.26288804E-09_JPRB, 0.26288990E-09_JPRB, &
  & 0.26289426E-09_JPRB, 0.26290306E-09_JPRB, 0.26291255E-09_JPRB, 0.26292013E-09_JPRB, 0.26292851E-09_JPRB, 0.26293034E-09_JPRB, &
  & 0.26293168E-09_JPRB, 0.26293032E-09_JPRB, 0.26292724E-09_JPRB, 0.26292513E-09_JPRB, 0.26292138E-09_JPRB, 0.26291302E-09_JPRB, &
  & 0.26290847E-09_JPRB, 0.26290525E-09_JPRB, 0.26290259E-09_JPRB, 0.26289715E-09_JPRB, 0.26289237E-09_JPRB, 0.26288921E-09_JPRB, &
  & 0.26288655E-09_JPRB, 0.26287988E-09_JPRB, 0.26286806E-09_JPRB, 0.26282029E-09_JPRB /)

RGHG5(:,80, 3) = (/ &
  & 0.26283378E-09_JPRB, 0.26286281E-09_JPRB, 0.26287614E-09_JPRB, 0.26288094E-09_JPRB, 0.26288971E-09_JPRB, 0.26289756E-09_JPRB, &
  & 0.26290567E-09_JPRB, 0.26291036E-09_JPRB, 0.26291569E-09_JPRB, 0.26291866E-09_JPRB, 0.26292096E-09_JPRB, 0.26292307E-09_JPRB, &
  & 0.26292551E-09_JPRB, 0.26292407E-09_JPRB, 0.26292168E-09_JPRB, 0.26291866E-09_JPRB, 0.26292066E-09_JPRB, 0.26291816E-09_JPRB, &
  & 0.26292077E-09_JPRB, 0.26292513E-09_JPRB, 0.26293634E-09_JPRB, 0.26294600E-09_JPRB, 0.26295577E-09_JPRB, 0.26296801E-09_JPRB, &
  & 0.26297384E-09_JPRB, 0.26298178E-09_JPRB, 0.26298852E-09_JPRB, 0.26299216E-09_JPRB, 0.26299363E-09_JPRB, 0.26299052E-09_JPRB, &
  & 0.26298941E-09_JPRB, 0.26298427E-09_JPRB, 0.26297742E-09_JPRB, 0.26297012E-09_JPRB, 0.26296162E-09_JPRB, 0.26294861E-09_JPRB, &
  & 0.26293728E-09_JPRB, 0.26292638E-09_JPRB, 0.26291866E-09_JPRB, 0.26291344E-09_JPRB, 0.26290972E-09_JPRB, 0.26291069E-09_JPRB, &
  & 0.26291350E-09_JPRB, 0.26292082E-09_JPRB, 0.26292865E-09_JPRB, 0.26293454E-09_JPRB, 0.26294200E-09_JPRB, 0.26294289E-09_JPRB, &
  & 0.26294411E-09_JPRB, 0.26294292E-09_JPRB, 0.26294031E-09_JPRB, 0.26293903E-09_JPRB, 0.26293601E-09_JPRB, 0.26292776E-09_JPRB, &
  & 0.26292390E-09_JPRB, 0.26292155E-09_JPRB, 0.26291982E-09_JPRB, 0.26291486E-09_JPRB, 0.26291058E-09_JPRB, 0.26290820E-09_JPRB, &
  & 0.26290675E-09_JPRB, 0.26290164E-09_JPRB, 0.26289626E-09_JPRB, 0.26287347E-09_JPRB /)

RGHG5(:,81, 3) = (/ &
  & 0.26288038E-09_JPRB, 0.26287755E-09_JPRB, 0.26288768E-09_JPRB, 0.26289093E-09_JPRB, 0.26289931E-09_JPRB, 0.26290684E-09_JPRB, &
  & 0.26291413E-09_JPRB, 0.26291933E-09_JPRB, 0.26292307E-09_JPRB, 0.26292679E-09_JPRB, 0.26292826E-09_JPRB, 0.26293068E-09_JPRB, &
  & 0.26293301E-09_JPRB, 0.26293154E-09_JPRB, 0.26292918E-09_JPRB, 0.26292629E-09_JPRB, 0.26292882E-09_JPRB, 0.26292624E-09_JPRB, &
  & 0.26292873E-09_JPRB, 0.26293254E-09_JPRB, 0.26294331E-09_JPRB, 0.26295188E-09_JPRB, 0.26296040E-09_JPRB, 0.26297176E-09_JPRB, &
  & 0.26297631E-09_JPRB, 0.26298366E-09_JPRB, 0.26299002E-09_JPRB, 0.26299346E-09_JPRB, 0.26299488E-09_JPRB, 0.26299168E-09_JPRB, &
  & 0.26299096E-09_JPRB, 0.26298613E-09_JPRB, 0.26297997E-09_JPRB, 0.26297353E-09_JPRB, 0.26296623E-09_JPRB, 0.26295444E-09_JPRB, &
  & 0.26294433E-09_JPRB, 0.26293462E-09_JPRB, 0.26292782E-09_JPRB, 0.26292313E-09_JPRB, 0.26291935E-09_JPRB, 0.26291988E-09_JPRB, &
  & 0.26292196E-09_JPRB, 0.26292873E-09_JPRB, 0.26293584E-09_JPRB, 0.26294081E-09_JPRB, 0.26294797E-09_JPRB, 0.26294836E-09_JPRB, &
  & 0.26294952E-09_JPRB, 0.26294833E-09_JPRB, 0.26294597E-09_JPRB, 0.26294505E-09_JPRB, 0.26294236E-09_JPRB, 0.26293398E-09_JPRB, &
  & 0.26293040E-09_JPRB, 0.26292840E-09_JPRB, 0.26292724E-09_JPRB, 0.26292235E-09_JPRB, 0.26291821E-09_JPRB, 0.26291619E-09_JPRB, &
  & 0.26291522E-09_JPRB, 0.26291080E-09_JPRB, 0.26290806E-09_JPRB, 0.26290986E-09_JPRB /)

RGHG5(:,82, 3) = (/ &
  & 0.26288410E-09_JPRB, 0.26288241E-09_JPRB, 0.26289276E-09_JPRB, 0.26289573E-09_JPRB, 0.26290400E-09_JPRB, 0.26291100E-09_JPRB, &
  & 0.26291894E-09_JPRB, 0.26292249E-09_JPRB, 0.26292793E-09_JPRB, 0.26293009E-09_JPRB, 0.26293234E-09_JPRB, 0.26293417E-09_JPRB, &
  & 0.26293681E-09_JPRB, 0.26293523E-09_JPRB, 0.26293284E-09_JPRB, 0.26292998E-09_JPRB, 0.26293295E-09_JPRB, 0.26293023E-09_JPRB, &
  & 0.26293259E-09_JPRB, 0.26293617E-09_JPRB, 0.26294675E-09_JPRB, 0.26295471E-09_JPRB, 0.26296268E-09_JPRB, 0.26297353E-09_JPRB, &
  & 0.26297753E-09_JPRB, 0.26298458E-09_JPRB, 0.26299077E-09_JPRB, 0.26299413E-09_JPRB, 0.26299546E-09_JPRB, 0.26299218E-09_JPRB, &
  & 0.26299174E-09_JPRB, 0.26298702E-09_JPRB, 0.26298119E-09_JPRB, 0.26297525E-09_JPRB, 0.26296842E-09_JPRB, 0.26295724E-09_JPRB, &
  & 0.26294783E-09_JPRB, 0.26293878E-09_JPRB, 0.26293243E-09_JPRB, 0.26292793E-09_JPRB, 0.26292413E-09_JPRB, 0.26292443E-09_JPRB, &
  & 0.26292610E-09_JPRB, 0.26293265E-09_JPRB, 0.26293936E-09_JPRB, 0.26294394E-09_JPRB, 0.26295097E-09_JPRB, 0.26295097E-09_JPRB, &
  & 0.26295216E-09_JPRB, 0.26295099E-09_JPRB, 0.26294872E-09_JPRB, 0.26294794E-09_JPRB, 0.26294544E-09_JPRB, 0.26293695E-09_JPRB, &
  & 0.26293351E-09_JPRB, 0.26293179E-09_JPRB, 0.26293079E-09_JPRB, 0.26292593E-09_JPRB, 0.26292182E-09_JPRB, 0.26291999E-09_JPRB, &
  & 0.26291924E-09_JPRB, 0.26291486E-09_JPRB, 0.26291205E-09_JPRB, 0.26291275E-09_JPRB /)

RGHG5(:,83, 3) = (/ &
  & 0.26288666E-09_JPRB, 0.26288521E-09_JPRB, 0.26289562E-09_JPRB, 0.26289829E-09_JPRB, 0.26290647E-09_JPRB, 0.26291402E-09_JPRB, &
  & 0.26292055E-09_JPRB, 0.26292596E-09_JPRB, 0.26292890E-09_JPRB, 0.26293290E-09_JPRB, 0.26293406E-09_JPRB, 0.26293662E-09_JPRB, &
  & 0.26293881E-09_JPRB, 0.26293726E-09_JPRB, 0.26293490E-09_JPRB, 0.26293207E-09_JPRB, 0.26293523E-09_JPRB, 0.26293240E-09_JPRB, &
  & 0.26293479E-09_JPRB, 0.26293806E-09_JPRB, 0.26294866E-09_JPRB, 0.26295638E-09_JPRB, 0.26296396E-09_JPRB, 0.26297467E-09_JPRB, &
  & 0.26297817E-09_JPRB, 0.26298508E-09_JPRB, 0.26299124E-09_JPRB, 0.26299457E-09_JPRB, 0.26299590E-09_JPRB, 0.26299246E-09_JPRB, &
  & 0.26299218E-09_JPRB, 0.26298752E-09_JPRB, 0.26298183E-09_JPRB, 0.26297606E-09_JPRB, 0.26296956E-09_JPRB, 0.26295882E-09_JPRB, &
  & 0.26294980E-09_JPRB, 0.26294122E-09_JPRB, 0.26293509E-09_JPRB, 0.26293084E-09_JPRB, 0.26292699E-09_JPRB, 0.26292701E-09_JPRB, &
  & 0.26292843E-09_JPRB, 0.26293484E-09_JPRB, 0.26294145E-09_JPRB, 0.26294567E-09_JPRB, 0.26295274E-09_JPRB, 0.26295249E-09_JPRB, &
  & 0.26295360E-09_JPRB, 0.26295244E-09_JPRB, 0.26295019E-09_JPRB, 0.26294961E-09_JPRB, 0.26294722E-09_JPRB, 0.26293848E-09_JPRB, &
  & 0.26293512E-09_JPRB, 0.26293359E-09_JPRB, 0.26293276E-09_JPRB, 0.26292787E-09_JPRB, 0.26292385E-09_JPRB, 0.26292213E-09_JPRB, &
  & 0.26292152E-09_JPRB, 0.26291713E-09_JPRB, 0.26291438E-09_JPRB, 0.26291480E-09_JPRB /)

RGHG5(:,84, 3) = (/ &
  & 0.26288841E-09_JPRB, 0.26288696E-09_JPRB, 0.26289737E-09_JPRB, 0.26289987E-09_JPRB, 0.26290817E-09_JPRB, 0.26291494E-09_JPRB, &
  & 0.26292318E-09_JPRB, 0.26292618E-09_JPRB, 0.26293168E-09_JPRB, 0.26293356E-09_JPRB, 0.26293584E-09_JPRB, 0.26293753E-09_JPRB, &
  & 0.26294006E-09_JPRB, 0.26293862E-09_JPRB, 0.26293623E-09_JPRB, 0.26293340E-09_JPRB, 0.26293664E-09_JPRB, 0.26293379E-09_JPRB, &
  & 0.26293612E-09_JPRB, 0.26293939E-09_JPRB, 0.26294991E-09_JPRB, 0.26295732E-09_JPRB, 0.26296479E-09_JPRB, 0.26297534E-09_JPRB, &
  & 0.26297856E-09_JPRB, 0.26298541E-09_JPRB, 0.26299157E-09_JPRB, 0.26299488E-09_JPRB, 0.26299618E-09_JPRB, 0.26299274E-09_JPRB, &
  & 0.26299249E-09_JPRB, 0.26298777E-09_JPRB, 0.26298214E-09_JPRB, 0.26297653E-09_JPRB, 0.26296998E-09_JPRB, 0.26295988E-09_JPRB, &
  & 0.26295108E-09_JPRB, 0.26294278E-09_JPRB, 0.26293692E-09_JPRB, 0.26293254E-09_JPRB, 0.26292885E-09_JPRB, 0.26292868E-09_JPRB, &
  & 0.26292987E-09_JPRB, 0.26293612E-09_JPRB, 0.26294270E-09_JPRB, 0.26294683E-09_JPRB, 0.26295391E-09_JPRB, 0.26295344E-09_JPRB, &
  & 0.26295449E-09_JPRB, 0.26295335E-09_JPRB, 0.26295111E-09_JPRB, 0.26295066E-09_JPRB, 0.26294830E-09_JPRB, 0.26293948E-09_JPRB, &
  & 0.26293612E-09_JPRB, 0.26293465E-09_JPRB, 0.26293398E-09_JPRB, 0.26292912E-09_JPRB, 0.26292510E-09_JPRB, 0.26292346E-09_JPRB, &
  & 0.26292291E-09_JPRB, 0.26291858E-09_JPRB, 0.26291588E-09_JPRB, 0.26291619E-09_JPRB /)

RGHG5(:,85, 3) = (/ &
  & 0.26288957E-09_JPRB, 0.26288816E-09_JPRB, 0.26289854E-09_JPRB, 0.26290090E-09_JPRB, 0.26290908E-09_JPRB, 0.26291724E-09_JPRB, &
  & 0.26292310E-09_JPRB, 0.26292873E-09_JPRB, 0.26293143E-09_JPRB, 0.26293495E-09_JPRB, 0.26293634E-09_JPRB, 0.26293850E-09_JPRB, &
  & 0.26294034E-09_JPRB, 0.26293925E-09_JPRB, 0.26293706E-09_JPRB, 0.26293445E-09_JPRB, 0.26293751E-09_JPRB, 0.26293467E-09_JPRB, &
  & 0.26293703E-09_JPRB, 0.26294003E-09_JPRB, 0.26295072E-09_JPRB, 0.26295804E-09_JPRB, 0.26296521E-09_JPRB, 0.26297586E-09_JPRB, &
  & 0.26297869E-09_JPRB, 0.26298558E-09_JPRB, 0.26299174E-09_JPRB, 0.26299510E-09_JPRB, 0.26299640E-09_JPRB, 0.26299282E-09_JPRB, &
  & 0.26299266E-09_JPRB, 0.26298796E-09_JPRB, 0.26298236E-09_JPRB, 0.26297675E-09_JPRB, 0.26297053E-09_JPRB, 0.26296035E-09_JPRB, &
  & 0.26295185E-09_JPRB, 0.26294383E-09_JPRB, 0.26293795E-09_JPRB, 0.26293395E-09_JPRB, 0.26293012E-09_JPRB, 0.26292982E-09_JPRB, &
  & 0.26293084E-09_JPRB, 0.26293706E-09_JPRB, 0.26294350E-09_JPRB, 0.26294750E-09_JPRB, 0.26295466E-09_JPRB, 0.26295399E-09_JPRB, &
  & 0.26295505E-09_JPRB, 0.26295391E-09_JPRB, 0.26295166E-09_JPRB, 0.26295133E-09_JPRB, 0.26294905E-09_JPRB, 0.26294003E-09_JPRB, &
  & 0.26293670E-09_JPRB, 0.26293534E-09_JPRB, 0.26293473E-09_JPRB, 0.26292990E-09_JPRB, 0.26292579E-09_JPRB, 0.26292424E-09_JPRB, &
  & 0.26292379E-09_JPRB, 0.26291944E-09_JPRB, 0.26291685E-09_JPRB, 0.26291713E-09_JPRB /)

RGHG5(:,86, 3) = (/ &
  & 0.26289032E-09_JPRB, 0.26288877E-09_JPRB, 0.26289929E-09_JPRB, 0.26290151E-09_JPRB, 0.26291047E-09_JPRB, 0.26291705E-09_JPRB, &
  & 0.26292568E-09_JPRB, 0.26292862E-09_JPRB, 0.26293301E-09_JPRB, 0.26293501E-09_JPRB, 0.26293695E-09_JPRB, 0.26293859E-09_JPRB, &
  & 0.26294023E-09_JPRB, 0.26293953E-09_JPRB, 0.26293767E-09_JPRB, 0.26293540E-09_JPRB, 0.26293795E-09_JPRB, 0.26293534E-09_JPRB, &
  & 0.26293759E-09_JPRB, 0.26294053E-09_JPRB, 0.26295116E-09_JPRB, 0.26295838E-09_JPRB, 0.26296551E-09_JPRB, 0.26297628E-09_JPRB, &
  & 0.26297881E-09_JPRB, 0.26298566E-09_JPRB, 0.26299191E-09_JPRB, 0.26299524E-09_JPRB, 0.26299657E-09_JPRB, 0.26299291E-09_JPRB, &
  & 0.26299279E-09_JPRB, 0.26298805E-09_JPRB, 0.26298250E-09_JPRB, 0.26297708E-09_JPRB, 0.26297067E-09_JPRB, 0.26296104E-09_JPRB, &
  & 0.26295235E-09_JPRB, 0.26294436E-09_JPRB, 0.26293881E-09_JPRB, 0.26293445E-09_JPRB, 0.26293095E-09_JPRB, 0.26293057E-09_JPRB, &
  & 0.26293151E-09_JPRB, 0.26293759E-09_JPRB, 0.26294411E-09_JPRB, 0.26294794E-09_JPRB, 0.26295519E-09_JPRB, 0.26295435E-09_JPRB, &
  & 0.26295535E-09_JPRB, 0.26295424E-09_JPRB, 0.26295202E-09_JPRB, 0.26295174E-09_JPRB, 0.26294950E-09_JPRB, 0.26294036E-09_JPRB, &
  & 0.26293706E-09_JPRB, 0.26293581E-09_JPRB, 0.26293528E-09_JPRB, 0.26293037E-09_JPRB, 0.26292629E-09_JPRB, 0.26292477E-09_JPRB, &
  & 0.26292443E-09_JPRB, 0.26292005E-09_JPRB, 0.26291744E-09_JPRB, 0.26291772E-09_JPRB /)

RGHG5(:,87, 3) = (/ &
  & 0.26289076E-09_JPRB, 0.26288921E-09_JPRB, 0.26289970E-09_JPRB, 0.26290228E-09_JPRB, 0.26291047E-09_JPRB, 0.26291985E-09_JPRB, &
  & 0.26292499E-09_JPRB, 0.26293012E-09_JPRB, 0.26293273E-09_JPRB, 0.26293545E-09_JPRB, 0.26293695E-09_JPRB, 0.26293862E-09_JPRB, &
  & 0.26293995E-09_JPRB, 0.26293950E-09_JPRB, 0.26293798E-09_JPRB, 0.26293606E-09_JPRB, 0.26293823E-09_JPRB, 0.26293584E-09_JPRB, &
  & 0.26293792E-09_JPRB, 0.26294070E-09_JPRB, 0.26295144E-09_JPRB, 0.26295860E-09_JPRB, 0.26296557E-09_JPRB, 0.26297656E-09_JPRB, &
  & 0.26297886E-09_JPRB, 0.26298577E-09_JPRB, 0.26299199E-09_JPRB, 0.26299538E-09_JPRB, 0.26299674E-09_JPRB, 0.26299296E-09_JPRB, &
  & 0.26299296E-09_JPRB, 0.26298819E-09_JPRB, 0.26298269E-09_JPRB, 0.26297725E-09_JPRB, 0.26297142E-09_JPRB, 0.26296113E-09_JPRB, &
  & 0.26295285E-09_JPRB, 0.26294467E-09_JPRB, 0.26293889E-09_JPRB, 0.26293506E-09_JPRB, 0.26293104E-09_JPRB, 0.26293082E-09_JPRB, &
  & 0.26293170E-09_JPRB, 0.26293814E-09_JPRB, 0.26294453E-09_JPRB, 0.26294830E-09_JPRB, 0.26295555E-09_JPRB, 0.26295457E-09_JPRB, &
  & 0.26295557E-09_JPRB, 0.26295444E-09_JPRB, 0.26295224E-09_JPRB, 0.26295202E-09_JPRB, 0.26294977E-09_JPRB, 0.26294053E-09_JPRB, &
  & 0.26293723E-09_JPRB, 0.26293606E-09_JPRB, 0.26293562E-09_JPRB, 0.26293059E-09_JPRB, 0.26292649E-09_JPRB, 0.26292507E-09_JPRB, &
  & 0.26292474E-09_JPRB, 0.26292041E-09_JPRB, 0.26291780E-09_JPRB, 0.26291808E-09_JPRB /)

RGHG5(:,88, 3) = (/ &
  & 0.26289104E-09_JPRB, 0.26288965E-09_JPRB, 0.26289990E-09_JPRB, 0.26290231E-09_JPRB, 0.26291197E-09_JPRB, 0.26291835E-09_JPRB, &
  & 0.26292676E-09_JPRB, 0.26292971E-09_JPRB, 0.26293348E-09_JPRB, 0.26293551E-09_JPRB, 0.26293720E-09_JPRB, 0.26293873E-09_JPRB, &
  & 0.26294000E-09_JPRB, 0.26293961E-09_JPRB, 0.26293817E-09_JPRB, 0.26293639E-09_JPRB, 0.26293842E-09_JPRB, 0.26293609E-09_JPRB, &
  & 0.26293812E-09_JPRB, 0.26294092E-09_JPRB, 0.26295155E-09_JPRB, 0.26295877E-09_JPRB, 0.26296568E-09_JPRB, 0.26297681E-09_JPRB, &
  & 0.26297881E-09_JPRB, 0.26298577E-09_JPRB, 0.26299204E-09_JPRB, 0.26299543E-09_JPRB, 0.26299690E-09_JPRB, 0.26299296E-09_JPRB, &
  & 0.26299310E-09_JPRB, 0.26298827E-09_JPRB, 0.26298286E-09_JPRB, 0.26297767E-09_JPRB, 0.26297173E-09_JPRB, 0.26296165E-09_JPRB, &
  & 0.26295288E-09_JPRB, 0.26294461E-09_JPRB, 0.26293920E-09_JPRB, 0.26293503E-09_JPRB, 0.26293101E-09_JPRB, 0.26293090E-09_JPRB, &
  & 0.26293179E-09_JPRB, 0.26293845E-09_JPRB, 0.26294497E-09_JPRB, 0.26294850E-09_JPRB, 0.26295582E-09_JPRB, 0.26295469E-09_JPRB, &
  & 0.26295563E-09_JPRB, 0.26295457E-09_JPRB, 0.26295233E-09_JPRB, 0.26295219E-09_JPRB, 0.26294994E-09_JPRB, 0.26294059E-09_JPRB, &
  & 0.26293731E-09_JPRB, 0.26293620E-09_JPRB, 0.26293584E-09_JPRB, 0.26293079E-09_JPRB, 0.26292665E-09_JPRB, 0.26292513E-09_JPRB, &
  & 0.26292496E-09_JPRB, 0.26292063E-09_JPRB, 0.26291808E-09_JPRB, 0.26291835E-09_JPRB /)

RGHG5(:,89, 3) = (/ &
  & 0.26289121E-09_JPRB, 0.26289018E-09_JPRB, 0.26289981E-09_JPRB, 0.26290251E-09_JPRB, 0.26291064E-09_JPRB, 0.26292002E-09_JPRB, &
  & 0.26292529E-09_JPRB, 0.26293034E-09_JPRB, 0.26293312E-09_JPRB, 0.26293576E-09_JPRB, 0.26293734E-09_JPRB, 0.26293900E-09_JPRB, &
  & 0.26294039E-09_JPRB, 0.26293986E-09_JPRB, 0.26293823E-09_JPRB, 0.26293628E-09_JPRB, 0.26293864E-09_JPRB, 0.26293615E-09_JPRB, &
  & 0.26293825E-09_JPRB, 0.26294089E-09_JPRB, 0.26295172E-09_JPRB, 0.26295885E-09_JPRB, 0.26296570E-09_JPRB, 0.26297697E-09_JPRB, &
  & 0.26297872E-09_JPRB, 0.26298577E-09_JPRB, 0.26299216E-09_JPRB, 0.26299554E-09_JPRB, 0.26299704E-09_JPRB, 0.26299299E-09_JPRB, &
  & 0.26299329E-09_JPRB, 0.26298838E-09_JPRB, 0.26298302E-09_JPRB, 0.26297781E-09_JPRB, 0.26297245E-09_JPRB, 0.26296146E-09_JPRB, &
  & 0.26295310E-09_JPRB, 0.26294456E-09_JPRB, 0.26293911E-09_JPRB, 0.26293531E-09_JPRB, 0.26293070E-09_JPRB, 0.26293090E-09_JPRB, &
  & 0.26293165E-09_JPRB, 0.26293881E-09_JPRB, 0.26294519E-09_JPRB, 0.26294861E-09_JPRB, 0.26295607E-09_JPRB, 0.26295480E-09_JPRB, &
  & 0.26295569E-09_JPRB, 0.26295463E-09_JPRB, 0.26295241E-09_JPRB, 0.26295224E-09_JPRB, 0.26295008E-09_JPRB, 0.26294061E-09_JPRB, &
  & 0.26293737E-09_JPRB, 0.26293634E-09_JPRB, 0.26293595E-09_JPRB, 0.26293087E-09_JPRB, 0.26292674E-09_JPRB, 0.26292521E-09_JPRB, &
  & 0.26292513E-09_JPRB, 0.26292074E-09_JPRB, 0.26291813E-09_JPRB, 0.26291846E-09_JPRB /)

RGHG5(:,90, 3) = (/ &
  & 0.26289129E-09_JPRB, 0.26289060E-09_JPRB, 0.26289954E-09_JPRB, 0.26290195E-09_JPRB, 0.26291092E-09_JPRB, 0.26291763E-09_JPRB, &
  & 0.26292604E-09_JPRB, 0.26292929E-09_JPRB, 0.26293345E-09_JPRB, 0.26293592E-09_JPRB, 0.26293770E-09_JPRB, 0.26293956E-09_JPRB, &
  & 0.26294125E-09_JPRB, 0.26294034E-09_JPRB, 0.26293823E-09_JPRB, 0.26293584E-09_JPRB, 0.26293909E-09_JPRB, 0.26293592E-09_JPRB, &
  & 0.26293828E-09_JPRB, 0.26294075E-09_JPRB, 0.26295185E-09_JPRB, 0.26295893E-09_JPRB, 0.26296557E-09_JPRB, 0.26297728E-09_JPRB, &
  & 0.26297858E-09_JPRB, 0.26298583E-09_JPRB, 0.26299218E-09_JPRB, 0.26299563E-09_JPRB, 0.26299726E-09_JPRB, 0.26299291E-09_JPRB, &
  & 0.26299349E-09_JPRB, 0.26298844E-09_JPRB, 0.26298302E-09_JPRB, 0.26297800E-09_JPRB, 0.26297281E-09_JPRB, 0.26296154E-09_JPRB, &
  & 0.26295299E-09_JPRB, 0.26294436E-09_JPRB, 0.26293911E-09_JPRB, 0.26293534E-09_JPRB, 0.26293048E-09_JPRB, 0.26293087E-09_JPRB, &
  & 0.26293145E-09_JPRB, 0.26293898E-09_JPRB, 0.26294542E-09_JPRB, 0.26294861E-09_JPRB, 0.26295641E-09_JPRB, 0.26295480E-09_JPRB, &
  & 0.26295580E-09_JPRB, 0.26295474E-09_JPRB, 0.26295241E-09_JPRB, 0.26295235E-09_JPRB, 0.26295030E-09_JPRB, 0.26294042E-09_JPRB, &
  & 0.26293728E-09_JPRB, 0.26293637E-09_JPRB, 0.26293617E-09_JPRB, 0.26293090E-09_JPRB, 0.26292668E-09_JPRB, 0.26292518E-09_JPRB, &
  & 0.26292526E-09_JPRB, 0.26292066E-09_JPRB, 0.26291816E-09_JPRB, 0.26291858E-09_JPRB /)

RGHG5(:,91, 3) = (/ &
  & 0.26289135E-09_JPRB, 0.26289079E-09_JPRB, 0.26289909E-09_JPRB, 0.26290131E-09_JPRB, 0.26291017E-09_JPRB, 0.26291708E-09_JPRB, &
  & 0.26292493E-09_JPRB, 0.26292826E-09_JPRB, 0.26293315E-09_JPRB, 0.26293673E-09_JPRB, 0.26293767E-09_JPRB, 0.26294003E-09_JPRB, &
  & 0.26294344E-09_JPRB, 0.26294081E-09_JPRB, 0.26293800E-09_JPRB, 0.26293451E-09_JPRB, 0.26294011E-09_JPRB, 0.26293531E-09_JPRB, &
  & 0.26293828E-09_JPRB, 0.26294014E-09_JPRB, 0.26295213E-09_JPRB, 0.26295902E-09_JPRB, 0.26296523E-09_JPRB, 0.26297797E-09_JPRB, &
  & 0.26297822E-09_JPRB, 0.26298586E-09_JPRB, 0.26299243E-09_JPRB, 0.26299579E-09_JPRB, 0.26299779E-09_JPRB, 0.26299252E-09_JPRB, &
  & 0.26299399E-09_JPRB, 0.26298860E-09_JPRB, 0.26298302E-09_JPRB, 0.26297792E-09_JPRB, 0.26297353E-09_JPRB, 0.26296110E-09_JPRB, &
  & 0.26295291E-09_JPRB, 0.26294406E-09_JPRB, 0.26293903E-09_JPRB, 0.26293542E-09_JPRB, 0.26293004E-09_JPRB, 0.26293079E-09_JPRB, &
  & 0.26293098E-09_JPRB, 0.26293909E-09_JPRB, 0.26294567E-09_JPRB, 0.26294836E-09_JPRB, 0.26295699E-09_JPRB, 0.26295463E-09_JPRB, &
  & 0.26295593E-09_JPRB, 0.26295482E-09_JPRB, 0.26295227E-09_JPRB, 0.26295252E-09_JPRB, 0.26295083E-09_JPRB, 0.26293989E-09_JPRB, &
  & 0.26293712E-09_JPRB, 0.26293634E-09_JPRB, 0.26293648E-09_JPRB, 0.26293084E-09_JPRB, 0.26292643E-09_JPRB, 0.26292507E-09_JPRB, &
  & 0.26292557E-09_JPRB, 0.26292038E-09_JPRB, 0.26291797E-09_JPRB, 0.26291855E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART6',1,ZHOOK_HANDLE)
END SUBROUTINE PART6






SUBROUTINE PART7
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART7',0,ZHOOK_HANDLE)



!-- Month=  4 ------------

RGHG5(:, 1, 4) = (/ &
  & 0.14012985E-44_JPRB, 0.42038954E-44_JPRB, 0.70064923E-44_JPRB, 0.98090893E-44_JPRB, 0.12611686E-43_JPRB, 0.16815582E-43_JPRB, &
  & 0.21019477E-43_JPRB, 0.28025969E-43_JPRB, 0.39236357E-43_JPRB, 0.58854536E-43_JPRB, 0.93886997E-43_JPRB, 0.16114932E-42_JPRB, &
  & 0.28166099E-42_JPRB, 0.48064537E-42_JPRB, 0.98931672E-42_JPRB, 0.17348075E-41_JPRB, 0.37218487E-41_JPRB, 0.65524716E-41_JPRB, &
  & 0.12421110E-40_JPRB, 0.18962371E-40_JPRB, 0.29326374E-40_JPRB, 0.40571794E-40_JPRB, 0.57037051E-40_JPRB, 0.75608460E-40_JPRB, &
  & 0.99506204E-40_JPRB, 0.11710651E-39_JPRB, 0.14135598E-39_JPRB, 0.15359352E-39_JPRB, 0.18247428E-39_JPRB, 0.18647219E-39_JPRB, &
  & 0.20674898E-39_JPRB, 0.27320836E-39_JPRB, 0.30032769E-39_JPRB, 0.43130425E-39_JPRB, 0.39360652E-39_JPRB, 0.49503811E-39_JPRB, &
  & 0.35168247E-39_JPRB, 0.37742152E-39_JPRB, 0.27186732E-39_JPRB, 0.18343557E-39_JPRB, 0.10808916E-39_JPRB, 0.59716334E-40_JPRB, &
  & 0.34850293E-40_JPRB, 0.23599267E-40_JPRB, 0.14605734E-40_JPRB, 0.79972103E-41_JPRB, 0.39572669E-41_JPRB, 0.17866555E-41_JPRB, &
  & 0.72307001E-42_JPRB, 0.26904931E-42_JPRB, 0.96689594E-43_JPRB, 0.36433760E-43_JPRB, 0.14012985E-43_JPRB, 0.70064923E-44_JPRB, &
  & 0.42038954E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG5(:, 2, 4) = (/ &
  & 0.33631163E-43_JPRB, 0.12611686E-42_JPRB, 0.25223372E-42_JPRB, 0.37694929E-42_JPRB, 0.50166485E-42_JPRB, 0.65440638E-42_JPRB, &
  & 0.86039726E-42_JPRB, 0.11644790E-41_JPRB, 0.16521309E-41_JPRB, 0.24634827E-41_JPRB, 0.39446552E-41_JPRB, 0.67780807E-41_JPRB, &
  & 0.11832564E-40_JPRB, 0.20725204E-40_JPRB, 0.41701241E-40_JPRB, 0.74927429E-40_JPRB, 0.15412882E-39_JPRB, 0.27102934E-39_JPRB, &
  & 0.49758567E-39_JPRB, 0.76044544E-39_JPRB, 0.11668696E-38_JPRB, 0.16226181E-38_JPRB, 0.22783249E-38_JPRB, 0.30323973E-38_JPRB, &
  & 0.39344467E-38_JPRB, 0.46620766E-38_JPRB, 0.55435690E-38_JPRB, 0.61578029E-38_JPRB, 0.71484859E-38_JPRB, 0.75119197E-38_JPRB, &
  & 0.84116177E-38_JPRB, 0.10847973E-37_JPRB, 0.12312267E-37_JPRB, 0.16780109E-37_JPRB, 0.16067968E-37_JPRB, 0.18871257E-37_JPRB, &
  & 0.14473792E-37_JPRB, 0.14479555E-37_JPRB, 0.10799098E-37_JPRB, 0.74118011E-38_JPRB, 0.44049201E-38_JPRB, 0.24452924E-38_JPRB, &
  & 0.14218163E-38_JPRB, 0.94734082E-39_JPRB, 0.58597958E-39_JPRB, 0.32511245E-39_JPRB, 0.16402199E-39_JPRB, 0.75792030E-40_JPRB, &
  & 0.31711384E-40_JPRB, 0.12210915E-40_JPRB, 0.44897603E-41_JPRB, 0.16899659E-41_JPRB, 0.69784664E-42_JPRB, 0.32369995E-42_JPRB, &
  & 0.16815582E-42_JPRB, 0.99492191E-43_JPRB, 0.63058431E-43_JPRB, 0.44841551E-43_JPRB, 0.35032462E-43_JPRB, 0.29427268E-43_JPRB, &
  & 0.23822074E-43_JPRB, 0.18216880E-43_JPRB, 0.98090893E-44_JPRB, 0.42038954E-44_JPRB /)

RGHG5(:, 3, 4) = (/ &
  & 0.13060102E-41_JPRB, 0.61657132E-41_JPRB, 0.12729395E-40_JPRB, 0.18495738E-40_JPRB, 0.24353166E-40_JPRB, 0.31604886E-40_JPRB, &
  & 0.41509263E-40_JPRB, 0.56112194E-40_JPRB, 0.79597957E-40_JPRB, 0.11860170E-39_JPRB, 0.18996563E-39_JPRB, 0.32692013E-39_JPRB, &
  & 0.57047141E-39_JPRB, 0.99542077E-39_JPRB, 0.19840032E-38_JPRB, 0.35134210E-38_JPRB, 0.71511091E-38_JPRB, 0.12431660E-37_JPRB, &
  & 0.23047641E-37_JPRB, 0.35211455E-37_JPRB, 0.54782424E-37_JPRB, 0.76515655E-37_JPRB, 0.10871835E-36_JPRB, 0.14489523E-36_JPRB, &
  & 0.18769063E-36_JPRB, 0.22161569E-36_JPRB, 0.26230458E-36_JPRB, 0.29264618E-36_JPRB, 0.33821054E-36_JPRB, 0.35849618E-36_JPRB, &
  & 0.40263336E-36_JPRB, 0.51685519E-36_JPRB, 0.59049260E-36_JPRB, 0.79370289E-36_JPRB, 0.76918066E-36_JPRB, 0.88494101E-36_JPRB, &
  & 0.69415380E-36_JPRB, 0.68238303E-36_JPRB, 0.51625669E-36_JPRB, 0.35757500E-36_JPRB, 0.21220645E-36_JPRB, 0.11533045E-36_JPRB, &
  & 0.65910477E-37_JPRB, 0.44095003E-37_JPRB, 0.27179083E-37_JPRB, 0.14972646E-37_JPRB, 0.75691193E-38_JPRB, 0.35395692E-38_JPRB, &
  & 0.15145934E-38_JPRB, 0.60094685E-39_JPRB, 0.22724857E-39_JPRB, 0.87218218E-40_JPRB, 0.36160507E-40_JPRB, 0.16660037E-40_JPRB, &
  & 0.86067752E-41_JPRB, 0.49732082E-41_JPRB, 0.31907566E-41_JPRB, 0.22364723E-41_JPRB, 0.16969724E-41_JPRB, 0.13802790E-41_JPRB, &
  & 0.11854985E-41_JPRB, 0.97250113E-42_JPRB, 0.58854536E-42_JPRB, 0.13592595E-42_JPRB /)

RGHG5(:, 4, 4) = (/ &
  & 0.13858562E-39_JPRB, 0.70257602E-39_JPRB, 0.13008576E-38_JPRB, 0.18127715E-38_JPRB, 0.23381562E-38_JPRB, 0.30199257E-38_JPRB, &
  & 0.39484541E-38_JPRB, 0.53094834E-38_JPRB, 0.75022773E-38_JPRB, 0.11116007E-37_JPRB, 0.17746538E-37_JPRB, 0.30510326E-37_JPRB, &
  & 0.53058765E-37_JPRB, 0.91724373E-37_JPRB, 0.18174612E-36_JPRB, 0.31578611E-36_JPRB, 0.63853794E-36_JPRB, 0.10929007E-35_JPRB, &
  & 0.20445916E-35_JPRB, 0.31016955E-35_JPRB, 0.48736951E-35_JPRB, 0.67934002E-35_JPRB, 0.96960484E-35_JPRB, 0.12932421E-34_JPRB, &
  & 0.16664669E-34_JPRB, 0.19592618E-34_JPRB, 0.23124217E-34_JPRB, 0.25761386E-34_JPRB, 0.29775998E-34_JPRB, 0.31529063E-34_JPRB, &
  & 0.35421496E-34_JPRB, 0.45434358E-34_JPRB, 0.52008783E-34_JPRB, 0.69782797E-34_JPRB, 0.67842147E-34_JPRB, 0.77949998E-34_JPRB, &
  & 0.61568405E-34_JPRB, 0.60511964E-34_JPRB, 0.46181230E-34_JPRB, 0.32302329E-34_JPRB, 0.19124056E-34_JPRB, 0.10237250E-34_JPRB, &
  & 0.57651935E-35_JPRB, 0.39288470E-35_JPRB, 0.24172141E-35_JPRB, 0.13262126E-35_JPRB, 0.67144985E-36_JPRB, 0.31764956E-36_JPRB, &
  & 0.13847237E-36_JPRB, 0.56235408E-37_JPRB, 0.21798491E-37_JPRB, 0.85368686E-38_JPRB, 0.35799168E-38_JPRB, 0.16573143E-38_JPRB, &
  & 0.85303203E-39_JPRB, 0.49277221E-39_JPRB, 0.31508056E-39_JPRB, 0.22058680E-39_JPRB, 0.16734306E-39_JPRB, 0.13645985E-39_JPRB, &
  & 0.11993714E-39_JPRB, 0.10425661E-39_JPRB, 0.74285634E-40_JPRB, 0.23524999E-40_JPRB /)

RGHG5(:, 5, 4) = (/ &
  & 0.73194572E-37_JPRB, 0.20748762E-36_JPRB, 0.32500087E-36_JPRB, 0.42482652E-36_JPRB, 0.54200180E-36_JPRB, 0.69512964E-36_JPRB, &
  & 0.90219263E-36_JPRB, 0.12039260E-35_JPRB, 0.16854079E-35_JPRB, 0.24722994E-35_JPRB, 0.39040970E-35_JPRB, 0.66456097E-35_JPRB, &
  & 0.11416827E-34_JPRB, 0.19419457E-34_JPRB, 0.37892006E-34_JPRB, 0.64429173E-34_JPRB, 0.12779115E-33_JPRB, 0.21372946E-33_JPRB, &
  & 0.39442409E-33_JPRB, 0.58633465E-33_JPRB, 0.91024047E-33_JPRB, 0.12459921E-32_JPRB, 0.17582743E-32_JPRB, 0.23087411E-32_JPRB, &
  & 0.29434456E-32_JPRB, 0.34134038E-32_JPRB, 0.39968806E-32_JPRB, 0.44122585E-32_JPRB, 0.50824746E-32_JPRB, 0.53392724E-32_JPRB, &
  & 0.59711902E-32_JPRB, 0.76746579E-32_JPRB, 0.87722706E-32_JPRB, 0.11846998E-31_JPRB, 0.11576204E-31_JPRB, 0.13439672E-31_JPRB, &
  & 0.10696617E-31_JPRB, 0.10646966E-31_JPRB, 0.82329126E-32_JPRB, 0.58495530E-32_JPRB, 0.35107994E-32_JPRB, 0.18895467E-32_JPRB, &
  & 0.10745082E-32_JPRB, 0.75252609E-33_JPRB, 0.47044459E-33_JPRB, 0.26109080E-33_JPRB, 0.13459214E-33_JPRB, 0.65074730E-34_JPRB, &
  & 0.29055879E-34_JPRB, 0.12113936E-34_JPRB, 0.48212448E-35_JPRB, 0.19341822E-35_JPRB, 0.82664368E-36_JPRB, 0.38757377E-36_JPRB, &
  & 0.20160219E-36_JPRB, 0.11709377E-36_JPRB, 0.75284743E-37_JPRB, 0.52988403E-37_JPRB, 0.40321416E-37_JPRB, 0.33117296E-37_JPRB, &
  & 0.29654233E-37_JPRB, 0.27599902E-37_JPRB, 0.23979073E-37_JPRB, 0.16099567E-37_JPRB /)

RGHG5(:, 6, 4) = (/ &
  & 0.62684843E-34_JPRB, 0.12842345E-33_JPRB, 0.17817391E-33_JPRB, 0.22792087E-33_JPRB, 0.28756121E-33_JPRB, 0.36406883E-33_JPRB, &
  & 0.46526039E-33_JPRB, 0.60916937E-33_JPRB, 0.83448941E-33_JPRB, 0.11921302E-32_JPRB, 0.18272301E-32_JPRB, 0.30110872E-32_JPRB, &
  & 0.49888921E-32_JPRB, 0.81409611E-32_JPRB, 0.15272316E-31_JPRB, 0.24819059E-31_JPRB, 0.47183453E-31_JPRB, 0.75433189E-31_JPRB, &
  & 0.13345719E-30_JPRB, 0.19009570E-30_JPRB, 0.28354529E-30_JPRB, 0.37311648E-30_JPRB, 0.50827802E-30_JPRB, 0.64617338E-30_JPRB, &
  & 0.80125193E-30_JPRB, 0.90451657E-30_JPRB, 0.10383239E-29_JPRB, 0.11233030E-29_JPRB, 0.12794688E-29_JPRB, 0.13256778E-29_JPRB, &
  & 0.14728384E-29_JPRB, 0.18907947E-29_JPRB, 0.21661863E-29_JPRB, 0.29512066E-29_JPRB, 0.29169290E-29_JPRB, 0.34563476E-29_JPRB, &
  & 0.27941883E-29_JPRB, 0.28590018E-29_JPRB, 0.22650704E-29_JPRB, 0.16573506E-29_JPRB, 0.10271075E-29_JPRB, 0.57170704E-30_JPRB, &
  & 0.33882487E-30_JPRB, 0.24935919E-30_JPRB, 0.16267917E-30_JPRB, 0.94413896E-31_JPRB, 0.50937456E-31_JPRB, 0.25779661E-31_JPRB, &
  & 0.12048466E-31_JPRB, 0.52472628E-32_JPRB, 0.21782531E-32_JPRB, 0.91023579E-33_JPRB, 0.40444302E-33_JPRB, 0.19659569E-33_JPRB, &
  & 0.10556326E-33_JPRB, 0.63048127E-34_JPRB, 0.41512233E-34_JPRB, 0.29748025E-34_JPRB, 0.23030124E-34_JPRB, 0.19160670E-34_JPRB, &
  & 0.17421894E-34_JPRB, 0.16767019E-34_JPRB, 0.16528250E-34_JPRB, 0.15996736E-34_JPRB /)

RGHG5(:, 7, 4) = (/ &
  & 0.49959315E-31_JPRB, 0.95920221E-31_JPRB, 0.13061072E-30_JPRB, 0.16529562E-30_JPRB, 0.20559634E-30_JPRB, 0.25529212E-30_JPRB, &
  & 0.31839226E-30_JPRB, 0.40494812E-30_JPRB, 0.53571834E-30_JPRB, 0.73489316E-30_JPRB, 0.10752269E-29_JPRB, 0.16849773E-29_JPRB, &
  & 0.26418549E-29_JPRB, 0.40520731E-29_JPRB, 0.71816686E-29_JPRB, 0.10945462E-28_JPRB, 0.19674656E-28_JPRB, 0.29617956E-28_JPRB, &
  & 0.49667347E-28_JPRB, 0.66915395E-28_JPRB, 0.94841764E-28_JPRB, 0.11865577E-27_JPRB, 0.15450966E-27_JPRB, 0.18850641E-27_JPRB, &
  & 0.22545974E-27_JPRB, 0.24587575E-27_JPRB, 0.27464789E-27_JPRB, 0.28968372E-27_JPRB, 0.32459255E-27_JPRB, 0.33138660E-27_JPRB, &
  & 0.36537960E-27_JPRB, 0.46882335E-27_JPRB, 0.53870861E-27_JPRB, 0.74223953E-27_JPRB, 0.74366275E-27_JPRB, 0.90339143E-27_JPRB, &
  & 0.74410605E-27_JPRB, 0.78914758E-27_JPRB, 0.64381864E-27_JPRB, 0.48900377E-27_JPRB, 0.31506613E-27_JPRB, 0.18414209E-27_JPRB, &
  & 0.11554464E-27_JPRB, 0.90581788E-28_JPRB, 0.62848848E-28_JPRB, 0.38827972E-28_JPRB, 0.22335310E-28_JPRB, 0.12053800E-28_JPRB, &
  & 0.59856338E-29_JPRB, 0.27630266E-29_JPRB, 0.12126721E-29_JPRB, 0.53569196E-30_JPRB, 0.25197636E-30_JPRB, 0.12965229E-30_JPRB, &
  & 0.73487622E-31_JPRB, 0.46093487E-31_JPRB, 0.31645824E-31_JPRB, 0.23519595E-31_JPRB, 0.18727425E-31_JPRB, 0.15973653E-31_JPRB, &
  & 0.14788855E-31_JPRB, 0.14458935E-31_JPRB, 0.14632912E-31_JPRB, 0.15232632E-31_JPRB /)

RGHG5(:, 8, 4) = (/ &
  & 0.33347224E-28_JPRB, 0.63430641E-28_JPRB, 0.85851698E-28_JPRB, 0.10766511E-27_JPRB, 0.13214756E-27_JPRB, 0.16109951E-27_JPRB, &
  & 0.19628670E-27_JPRB, 0.24258823E-27_JPRB, 0.31023794E-27_JPRB, 0.40863293E-27_JPRB, 0.57060436E-27_JPRB, 0.84970392E-27_JPRB, &
  & 0.12591483E-26_JPRB, 0.18097030E-26_JPRB, 0.30293160E-26_JPRB, 0.43077186E-26_JPRB, 0.73368078E-26_JPRB, 0.10359452E-25_JPRB, &
  & 0.16538500E-25_JPRB, 0.21022200E-25_JPRB, 0.28351889E-25_JPRB, 0.33656861E-25_JPRB, 0.41899355E-25_JPRB, 0.48917681E-25_JPRB, &
  & 0.56369782E-25_JPRB, 0.59273135E-25_JPRB, 0.64320101E-25_JPRB, 0.66098643E-25_JPRB, 0.72764000E-25_JPRB, 0.73248946E-25_JPRB, &
  & 0.80193245E-25_JPRB, 0.10273642E-24_JPRB, 0.11851598E-24_JPRB, 0.16510933E-24_JPRB, 0.16771294E-24_JPRB, 0.20901328E-24_JPRB, &
  & 0.17549775E-24_JPRB, 0.19325410E-24_JPRB, 0.16269507E-24_JPRB, 0.12836544E-24_JPRB, 0.86379906E-25_JPRB, 0.53021800E-25_JPRB, &
  & 0.35361812E-25_JPRB, 0.29590521E-25_JPRB, 0.21886200E-25_JPRB, 0.14444498E-25_JPRB, 0.88891867E-26_JPRB, 0.51242713E-26_JPRB, &
  & 0.27116710E-26_JPRB, 0.13286376E-26_JPRB, 0.61726748E-27_JPRB, 0.28886965E-27_JPRB, 0.14439027E-27_JPRB, 0.79012817E-28_JPRB, &
  & 0.47497582E-28_JPRB, 0.31430608E-28_JPRB, 0.22613093E-28_JPRB, 0.17464127E-28_JPRB, 0.14366143E-28_JPRB, 0.12565937E-28_JPRB, &
  & 0.11874873E-28_JPRB, 0.11782169E-28_JPRB, 0.12056001E-28_JPRB, 0.12721014E-28_JPRB /)

RGHG5(:, 9, 4) = (/ &
  & 0.18215632E-25_JPRB, 0.34541184E-25_JPRB, 0.46500056E-25_JPRB, 0.57965992E-25_JPRB, 0.70438315E-25_JPRB, 0.84643216E-25_JPRB, &
  & 0.10120648E-24_JPRB, 0.12218320E-24_JPRB, 0.15180964E-24_JPRB, 0.19304761E-24_JPRB, 0.25854837E-24_JPRB, 0.36748215E-24_JPRB, &
  & 0.51677499E-24_JPRB, 0.69851646E-24_JPRB, 0.11069411E-23_JPRB, 0.14708867E-23_JPRB, 0.23792569E-23_JPRB, 0.31517415E-23_JPRB, &
  & 0.48072375E-23_JPRB, 0.57634998E-23_JPRB, 0.74103535E-23_JPRB, 0.83445352E-23_JPRB, 0.99217087E-23_JPRB, 0.11091539E-22_JPRB, &
  & 0.12289360E-22_JPRB, 0.12476163E-22_JPRB, 0.13143275E-22_JPRB, 0.13176978E-22_JPRB, 0.14237270E-22_JPRB, 0.14141637E-22_JPRB, &
  & 0.15362195E-22_JPRB, 0.19646278E-22_JPRB, 0.22739495E-22_JPRB, 0.32024118E-22_JPRB, 0.32979719E-22_JPRB, 0.42110695E-22_JPRB, &
  & 0.36118148E-22_JPRB, 0.41241819E-22_JPRB, 0.35891855E-22_JPRB, 0.29499419E-22_JPRB, 0.20745152E-22_JPRB, 0.13421157E-22_JPRB, &
  & 0.95011378E-23_JPRB, 0.84762465E-23_JPRB, 0.66839632E-23_JPRB, 0.47106289E-23_JPRB, 0.30983380E-23_JPRB, 0.19085965E-23_JPRB, &
  & 0.10755564E-23_JPRB, 0.55932161E-24_JPRB, 0.27502514E-24_JPRB, 0.13632922E-24_JPRB, 0.72393297E-25_JPRB, 0.42095658E-25_JPRB, &
  & 0.26795140E-25_JPRB, 0.18669202E-25_JPRB, 0.14038484E-25_JPRB, 0.11249874E-25_JPRB, 0.95280985E-26_JPRB, 0.85332740E-26_JPRB, &
  & 0.82138663E-26_JPRB, 0.82628581E-26_JPRB, 0.85416457E-26_JPRB, 0.90956756E-26_JPRB /)

RGHG5(:,10, 4) = (/ &
  & 0.81123631E-23_JPRB, 0.15279666E-22_JPRB, 0.20544164E-22_JPRB, 0.25484448E-22_JPRB, 0.30771053E-22_JPRB, 0.36591130E-22_JPRB, &
  & 0.43134226E-22_JPRB, 0.51119566E-22_JPRB, 0.62035113E-22_JPRB, 0.76562611E-22_JPRB, 0.98858629E-22_JPRB, 0.13473379E-21_JPRB, &
  & 0.18061657E-21_JPRB, 0.23071670E-21_JPRB, 0.34710882E-21_JPRB, 0.43252983E-21_JPRB, 0.66520195E-21_JPRB, 0.82795832E-21_JPRB, &
  & 0.12063765E-20_JPRB, 0.13653537E-20_JPRB, 0.16725327E-20_JPRB, 0.17871302E-20_JPRB, 0.20291181E-20_JPRB, 0.21700156E-20_JPRB, &
  & 0.23127433E-20_JPRB, 0.22680598E-20_JPRB, 0.23199395E-20_JPRB, 0.22702160E-20_JPRB, 0.24067214E-20_JPRB, 0.23586813E-20_JPRB, &
  & 0.25416067E-20_JPRB, 0.32413086E-20_JPRB, 0.37646125E-20_JPRB, 0.53518481E-20_JPRB, 0.55903435E-20_JPRB, 0.72997526E-20_JPRB, &
  & 0.64123889E-20_JPRB, 0.75753572E-20_JPRB, 0.68309367E-20_JPRB, 0.58513448E-20_JPRB, 0.43139723E-20_JPRB, 0.29432748E-20_JPRB, &
  & 0.22121130E-20_JPRB, 0.21018126E-20_JPRB, 0.17664991E-20_JPRB, 0.13289833E-20_JPRB, 0.93442399E-21_JPRB, 0.61490483E-21_JPRB, &
  & 0.36929098E-21_JPRB, 0.20404627E-21_JPRB, 0.10629010E-21_JPRB, 0.55834180E-22_JPRB, 0.31479018E-22_JPRB, 0.19411453E-22_JPRB, &
  & 0.13043088E-22_JPRB, 0.95349192E-23_JPRB, 0.74682259E-23_JPRB, 0.61863462E-23_JPRB, 0.53798093E-23_JPRB, 0.49168233E-23_JPRB, &
  & 0.48091390E-23_JPRB, 0.48954286E-23_JPRB, 0.51064501E-23_JPRB, 0.54798250E-23_JPRB /)

RGHG5(:,11, 4) = (/ &
  & 0.29791312E-20_JPRB, 0.56194196E-20_JPRB, 0.75168156E-20_JPRB, 0.93046122E-20_JPRB, 0.11160436E-19_JPRB, 0.13148637E-19_JPRB, &
  & 0.15300292E-19_JPRB, 0.17830327E-19_JPRB, 0.21174481E-19_JPRB, 0.25423847E-19_JPRB, 0.31734174E-19_JPRB, 0.41573051E-19_JPRB, &
  & 0.53289269E-19_JPRB, 0.64613688E-19_JPRB, 0.92398259E-19_JPRB, 0.10856366E-18_JPRB, 0.15854833E-18_JPRB, 0.18612637E-18_JPRB, &
  & 0.25813743E-18_JPRB, 0.27655910E-18_JPRB, 0.32233155E-18_JPRB, 0.32755455E-18_JPRB, 0.35506154E-18_JPRB, 0.36389169E-18_JPRB, &
  & 0.37327171E-18_JPRB, 0.35407727E-18_JPRB, 0.35195393E-18_JPRB, 0.33645184E-18_JPRB, 0.35016378E-18_JPRB, 0.33861124E-18_JPRB, &
  & 0.36167412E-18_JPRB, 0.45966990E-18_JPRB, 0.53491030E-18_JPRB, 0.76681194E-18_JPRB, 0.81214112E-18_JPRB, 0.10827428E-17_JPRB, &
  & 0.97553277E-18_JPRB, 0.11903305E-17_JPRB, 0.11128383E-17_JPRB, 0.99392099E-18_JPRB, 0.76831875E-18_JPRB, 0.55311758E-18_JPRB, &
  & 0.44132609E-18_JPRB, 0.44624657E-18_JPRB, 0.39954925E-18_JPRB, 0.32078550E-18_JPRB, 0.24095342E-18_JPRB, 0.16941640E-18_JPRB, &
  & 0.10845062E-18_JPRB, 0.63705321E-19_JPRB, 0.35181164E-19_JPRB, 0.19581976E-19_JPRB, 0.11702987E-19_JPRB, 0.76307904E-20_JPRB, &
  & 0.53925920E-20_JPRB, 0.41196179E-20_JPRB, 0.33473449E-20_JPRB, 0.28558497E-20_JPRB, 0.25410150E-20_JPRB, 0.23625581E-20_JPRB, &
  & 0.23419056E-20_JPRB, 0.24076719E-20_JPRB, 0.25290623E-20_JPRB, 0.27325443E-20_JPRB /)

RGHG5(:,12, 4) = (/ &
  & 0.92195866E-18_JPRB, 0.17244592E-17_JPRB, 0.23073113E-17_JPRB, 0.28388781E-17_JPRB, 0.33850845E-17_JPRB, 0.39480942E-17_JPRB, &
  & 0.45352617E-17_JPRB, 0.51988455E-17_JPRB, 0.60465215E-17_JPRB, 0.70713454E-17_JPRB, 0.85452679E-17_JPRB, 0.10782763E-16_JPRB, &
  & 0.13245008E-16_JPRB, 0.15296856E-16_JPRB, 0.20817699E-16_JPRB, 0.23167832E-16_JPRB, 0.32082948E-16_JPRB, 0.35649857E-16_JPRB, &
  & 0.46864788E-16_JPRB, 0.47671067E-16_JPRB, 0.52765239E-16_JPRB, 0.51103840E-16_JPRB, 0.52887311E-16_JPRB, 0.51984007E-16_JPRB, &
  & 0.51355760E-16_JPRB, 0.47140878E-16_JPRB, 0.45548118E-16_JPRB, 0.42537978E-16_JPRB, 0.43474806E-16_JPRB, 0.41464777E-16_JPRB, &
  & 0.43882137E-16_JPRB, 0.55534981E-16_JPRB, 0.64733368E-16_JPRB, 0.93474149E-16_JPRB, 0.10040353E-15_JPRB, 0.13657013E-15_JPRB, &
  & 0.12630006E-15_JPRB, 0.15911392E-15_JPRB, 0.15426155E-15_JPRB, 0.14366143E-15_JPRB, 0.11642373E-15_JPRB, 0.88430425E-16_JPRB, &
  & 0.74914869E-16_JPRB, 0.80639700E-16_JPRB, 0.76889303E-16_JPRB, 0.65845443E-16_JPRB, 0.52838087E-16_JPRB, 0.39665871E-16_JPRB, &
  & 0.27063735E-16_JPRB, 0.16898034E-16_JPRB, 0.98922347E-17_JPRB, 0.58297390E-17_JPRB, 0.36855669E-17_JPRB, 0.25326215E-17_JPRB, &
  & 0.18748460E-17_JPRB, 0.14902339E-17_JPRB, 0.12507207E-17_JPRB, 0.10945052E-17_JPRB, 0.99260495E-18_JPRB, 0.93591909E-18_JPRB, &
  & 0.93757645E-18_JPRB, 0.97093923E-18_JPRB, 0.10259119E-17_JPRB, 0.11128028E-17_JPRB /)

RGHG5(:,13, 4) = (/ &
  & 0.14354282E-16_JPRB, 0.25407116E-16_JPRB, 0.32827940E-16_JPRB, 0.39940608E-16_JPRB, 0.47231894E-16_JPRB, 0.55167722E-16_JPRB, &
  & 0.63716935E-16_JPRB, 0.73916879E-16_JPRB, 0.87007013E-16_JPRB, 0.10256882E-15_JPRB, 0.12256878E-15_JPRB, 0.15346900E-15_JPRB, &
  & 0.19612698E-15_JPRB, 0.22319718E-15_JPRB, 0.30052112E-15_JPRB, 0.32559107E-15_JPRB, 0.44323974E-15_JPRB, 0.46761571E-15_JPRB, &
  & 0.60196636E-15_JPRB, 0.61075295E-15_JPRB, 0.73067481E-15_JPRB, 0.68788244E-15_JPRB, 0.75310181E-15_JPRB, 0.70852014E-15_JPRB, &
  & 0.74113673E-15_JPRB, 0.67753324E-15_JPRB, 0.67174806E-15_JPRB, 0.61199967E-15_JPRB, 0.61267667E-15_JPRB, 0.58295761E-15_JPRB, &
  & 0.58854840E-15_JPRB, 0.61855915E-15_JPRB, 0.66464505E-15_JPRB, 0.75580390E-15_JPRB, 0.80138587E-15_JPRB, 0.87463532E-15_JPRB, &
  & 0.96425807E-15_JPRB, 0.11823896E-14_JPRB, 0.10602942E-14_JPRB, 0.11948680E-14_JPRB, 0.10124645E-14_JPRB, 0.92970940E-15_JPRB, &
  & 0.71050511E-15_JPRB, 0.76323926E-15_JPRB, 0.69796748E-15_JPRB, 0.62522191E-15_JPRB, 0.48724242E-15_JPRB, 0.35266114E-15_JPRB, &
  & 0.24799603E-15_JPRB, 0.16892280E-15_JPRB, 0.11399033E-15_JPRB, 0.78956897E-16_JPRB, 0.58409546E-16_JPRB, 0.46661910E-16_JPRB, &
  & 0.39425354E-16_JPRB, 0.34957407E-16_JPRB, 0.32032245E-16_JPRB, 0.30044345E-16_JPRB, 0.28728208E-16_JPRB, 0.28153112E-16_JPRB, &
  & 0.28840545E-16_JPRB, 0.30317083E-16_JPRB, 0.32524047E-16_JPRB, 0.37099669E-16_JPRB /)

RGHG5(:,14, 4) = (/ &
  & 0.15442742E-15_JPRB, 0.25741943E-15_JPRB, 0.32822998E-15_JPRB, 0.39356409E-15_JPRB, 0.46276470E-15_JPRB, 0.53937968E-15_JPRB, &
  & 0.62584321E-15_JPRB, 0.73284899E-15_JPRB, 0.86778229E-15_JPRB, 0.10427672E-14_JPRB, 0.12265292E-14_JPRB, 0.15603674E-14_JPRB, &
  & 0.19386350E-14_JPRB, 0.22829670E-14_JPRB, 0.30271706E-14_JPRB, 0.34064273E-14_JPRB, 0.43390495E-14_JPRB, 0.48593586E-14_JPRB, &
  & 0.58206745E-14_JPRB, 0.62554209E-14_JPRB, 0.69116127E-14_JPRB, 0.70726917E-14_JPRB, 0.74853352E-14_JPRB, 0.72679840E-14_JPRB, &
  & 0.76345045E-14_JPRB, 0.71611384E-14_JPRB, 0.73629669E-14_JPRB, 0.67098443E-14_JPRB, 0.66474104E-14_JPRB, 0.63357611E-14_JPRB, &
  & 0.62934878E-14_JPRB, 0.62147150E-14_JPRB, 0.62145626E-14_JPRB, 0.61693136E-14_JPRB, 0.63765822E-14_JPRB, 0.62709572E-14_JPRB, &
  & 0.68357020E-14_JPRB, 0.74739062E-14_JPRB, 0.70596202E-14_JPRB, 0.83176747E-14_JPRB, 0.68807781E-14_JPRB, 0.57702121E-14_JPRB, &
  & 0.53126106E-14_JPRB, 0.57588089E-14_JPRB, 0.58603237E-14_JPRB, 0.49614243E-14_JPRB, 0.36977782E-14_JPRB, 0.27826191E-14_JPRB, &
  & 0.20944908E-14_JPRB, 0.16091398E-14_JPRB, 0.12586586E-14_JPRB, 0.10060705E-14_JPRB, 0.84549341E-15_JPRB, 0.74555522E-15_JPRB, &
  & 0.67796787E-15_JPRB, 0.63301530E-15_JPRB, 0.60054789E-15_JPRB, 0.57672748E-15_JPRB, 0.56137442E-15_JPRB, 0.55836550E-15_JPRB, &
  & 0.57829015E-15_JPRB, 0.61523899E-15_JPRB, 0.67188702E-15_JPRB, 0.76353795E-15_JPRB /)

RGHG5(:,15, 4) = (/ &
  & 0.12430674E-14_JPRB, 0.19925122E-14_JPRB, 0.24818029E-14_JPRB, 0.29437652E-14_JPRB, 0.34298511E-14_JPRB, 0.39791092E-14_JPRB, &
  & 0.46181193E-14_JPRB, 0.53942954E-14_JPRB, 0.63969550E-14_JPRB, 0.77720067E-14_JPRB, 0.90512560E-14_JPRB, 0.11397313E-13_JPRB, &
  & 0.13906262E-13_JPRB, 0.16758969E-13_JPRB, 0.20617410E-13_JPRB, 0.24861300E-13_JPRB, 0.30228742E-13_JPRB, 0.35545209E-13_JPRB, &
  & 0.40582013E-13_JPRB, 0.45026787E-13_JPRB, 0.48302491E-13_JPRB, 0.51917370E-13_JPRB, 0.53984625E-13_JPRB, 0.55696028E-13_JPRB, &
  & 0.56893306E-13_JPRB, 0.58268684E-13_JPRB, 0.59408546E-13_JPRB, 0.58861295E-13_JPRB, 0.56445334E-13_JPRB, 0.54801426E-13_JPRB, &
  & 0.51861042E-13_JPRB, 0.49563598E-13_JPRB, 0.47601517E-13_JPRB, 0.45440326E-13_JPRB, 0.44041414E-13_JPRB, 0.43108380E-13_JPRB, &
  & 0.45451537E-13_JPRB, 0.41008233E-13_JPRB, 0.42169213E-13_JPRB, 0.40420416E-13_JPRB, 0.42095579E-13_JPRB, 0.43616413E-13_JPRB, &
  & 0.44086676E-13_JPRB, 0.41608247E-13_JPRB, 0.35066815E-13_JPRB, 0.27225895E-13_JPRB, 0.22257121E-13_JPRB, 0.18665525E-13_JPRB, &
  & 0.15764582E-13_JPRB, 0.13645755E-13_JPRB, 0.11934302E-13_JPRB, 0.10613863E-13_JPRB, 0.96632839E-14_JPRB, 0.90117199E-14_JPRB, &
  & 0.85397819E-14_JPRB, 0.82032845E-14_JPRB, 0.78884797E-14_JPRB, 0.76044941E-14_JPRB, 0.74026461E-14_JPRB, 0.73515633E-14_JPRB, &
  & 0.75508439E-14_JPRB, 0.79492102E-14_JPRB, 0.85303460E-14_JPRB, 0.93764099E-14_JPRB /)

RGHG5(:,16, 4) = (/ &
  & 0.78552446E-14_JPRB, 0.11985067E-13_JPRB, 0.14687794E-13_JPRB, 0.17182844E-13_JPRB, 0.19833903E-13_JPRB, 0.22849227E-13_JPRB, &
  & 0.26416923E-13_JPRB, 0.30690165E-13_JPRB, 0.36218160E-13_JPRB, 0.43515166E-13_JPRB, 0.51485210E-13_JPRB, 0.62974230E-13_JPRB, &
  & 0.76072253E-13_JPRB, 0.91181640E-13_JPRB, 0.10909135E-12_JPRB, 0.12918464E-12_JPRB, 0.15324531E-12_JPRB, 0.18062494E-12_JPRB, &
  & 0.20937122E-12_JPRB, 0.23567574E-12_JPRB, 0.26086910E-12_JPRB, 0.27972386E-12_JPRB, 0.30005984E-12_JPRB, 0.31681092E-12_JPRB, &
  & 0.32995300E-12_JPRB, 0.34491366E-12_JPRB, 0.35950393E-12_JPRB, 0.35896728E-12_JPRB, 0.35522364E-12_JPRB, 0.33892580E-12_JPRB, &
  & 0.32359266E-12_JPRB, 0.30316239E-12_JPRB, 0.28164076E-12_JPRB, 0.26262269E-12_JPRB, 0.24933601E-12_JPRB, 0.24406228E-12_JPRB, &
  & 0.25030404E-12_JPRB, 0.26009744E-12_JPRB, 0.28351185E-12_JPRB, 0.28937643E-12_JPRB, 0.28015174E-12_JPRB, 0.26883370E-12_JPRB, &
  & 0.25262488E-12_JPRB, 0.22695897E-12_JPRB, 0.19777764E-12_JPRB, 0.17344088E-12_JPRB, 0.15192800E-12_JPRB, 0.13115575E-12_JPRB, &
  & 0.11474762E-12_JPRB, 0.10292357E-12_JPRB, 0.94033884E-13_JPRB, 0.87034506E-13_JPRB, 0.81450654E-13_JPRB, 0.76902521E-13_JPRB, &
  & 0.72731290E-13_JPRB, 0.68953340E-13_JPRB, 0.65520086E-13_JPRB, 0.62645052E-13_JPRB, 0.60633159E-13_JPRB, 0.59853449E-13_JPRB, &
  & 0.60819656E-13_JPRB, 0.63145601E-13_JPRB, 0.66760941E-13_JPRB, 0.72465085E-13_JPRB /)

RGHG5(:,17, 4) = (/ &
  & 0.39054768E-13_JPRB, 0.57217977E-13_JPRB, 0.68705844E-13_JPRB, 0.79397155E-13_JPRB, 0.90669375E-13_JPRB, 0.10353114E-12_JPRB, &
  & 0.11882821E-12_JPRB, 0.13739140E-12_JPRB, 0.16075135E-12_JPRB, 0.19041351E-12_JPRB, 0.22600585E-12_JPRB, 0.27142123E-12_JPRB, &
  & 0.32341664E-12_JPRB, 0.38266721E-12_JPRB, 0.45031177E-12_JPRB, 0.52481592E-12_JPRB, 0.60808097E-12_JPRB, 0.70361707E-12_JPRB, &
  & 0.81044036E-12_JPRB, 0.92355290E-12_JPRB, 0.10232276E-11_JPRB, 0.11286838E-11_JPRB, 0.12226405E-11_JPRB, 0.13088669E-11_JPRB, &
  & 0.14052640E-11_JPRB, 0.14742825E-11_JPRB, 0.15326278E-11_JPRB, 0.15680871E-11_JPRB, 0.15692551E-11_JPRB, 0.15319369E-11_JPRB, &
  & 0.14642301E-11_JPRB, 0.13712098E-11_JPRB, 0.12685867E-11_JPRB, 0.11712575E-11_JPRB, 0.10977943E-11_JPRB, 0.10588352E-11_JPRB, &
  & 0.10552687E-11_JPRB, 0.10807931E-11_JPRB, 0.11232628E-11_JPRB, 0.11636385E-11_JPRB, 0.11950939E-11_JPRB, 0.11924341E-11_JPRB, &
  & 0.11500652E-11_JPRB, 0.10686654E-11_JPRB, 0.96815644E-12_JPRB, 0.85948067E-12_JPRB, 0.74878726E-12_JPRB, 0.65559304E-12_JPRB, &
  & 0.58389334E-12_JPRB, 0.53138266E-12_JPRB, 0.49065521E-12_JPRB, 0.45804793E-12_JPRB, 0.42996574E-12_JPRB, 0.40522948E-12_JPRB, &
  & 0.38168665E-12_JPRB, 0.36075819E-12_JPRB, 0.34262290E-12_JPRB, 0.32807901E-12_JPRB, 0.31794771E-12_JPRB, 0.31353362E-12_JPRB, &
  & 0.31651591E-12_JPRB, 0.32544732E-12_JPRB, 0.34028737E-12_JPRB, 0.36881151E-12_JPRB /)

RGHG5(:,18, 4) = (/ &
  & 0.15662920E-12_JPRB, 0.21961847E-12_JPRB, 0.25939485E-12_JPRB, 0.29553270E-12_JPRB, 0.33398295E-12_JPRB, 0.37817495E-12_JPRB, &
  & 0.43123442E-12_JPRB, 0.49642631E-12_JPRB, 0.57594614E-12_JPRB, 0.67461612E-12_JPRB, 0.79565044E-12_JPRB, 0.94087498E-12_JPRB, &
  & 0.11047607E-11_JPRB, 0.12883986E-11_JPRB, 0.14905971E-11_JPRB, 0.17096626E-11_JPRB, 0.19484212E-11_JPRB, 0.22041997E-11_JPRB, &
  & 0.24942485E-11_JPRB, 0.28081482E-11_JPRB, 0.31339870E-11_JPRB, 0.34491377E-11_JPRB, 0.37520369E-11_JPRB, 0.40452568E-11_JPRB, &
  & 0.43070833E-11_JPRB, 0.45578433E-11_JPRB, 0.48213599E-11_JPRB, 0.50248516E-11_JPRB, 0.51347524E-11_JPRB, 0.51099147E-11_JPRB, &
  & 0.49409999E-11_JPRB, 0.46844711E-11_JPRB, 0.43843852E-11_JPRB, 0.40837624E-11_JPRB, 0.38449669E-11_JPRB, 0.37042218E-11_JPRB, &
  & 0.36741651E-11_JPRB, 0.37375012E-11_JPRB, 0.38478079E-11_JPRB, 0.39536759E-11_JPRB, 0.40013652E-11_JPRB, 0.39548148E-11_JPRB, &
  & 0.38060215E-11_JPRB, 0.35484009E-11_JPRB, 0.32224267E-11_JPRB, 0.28715849E-11_JPRB, 0.25476392E-11_JPRB, 0.22778778E-11_JPRB, &
  & 0.20631951E-11_JPRB, 0.18979486E-11_JPRB, 0.17604244E-11_JPRB, 0.16434005E-11_JPRB, 0.15411399E-11_JPRB, 0.14515758E-11_JPRB, &
  & 0.13694920E-11_JPRB, 0.12984908E-11_JPRB, 0.12384043E-11_JPRB, 0.11905073E-11_JPRB, 0.11568031E-11_JPRB, 0.11404870E-11_JPRB, &
  & 0.11456767E-11_JPRB, 0.11690131E-11_JPRB, 0.12116708E-11_JPRB, 0.13035294E-11_JPRB /)

RGHG5(:,19, 4) = (/ &
  & 0.51418212E-12_JPRB, 0.69971947E-12_JPRB, 0.81226117E-12_JPRB, 0.91673078E-12_JPRB, 0.10256984E-11_JPRB, 0.11510801E-11_JPRB, &
  & 0.13019114E-11_JPRB, 0.14871891E-11_JPRB, 0.17131014E-11_JPRB, 0.19826421E-11_JPRB, 0.23085557E-11_JPRB, 0.26882765E-11_JPRB, &
  & 0.31107909E-11_JPRB, 0.35693584E-11_JPRB, 0.40582498E-11_JPRB, 0.45798690E-11_JPRB, 0.51359568E-11_JPRB, 0.57225904E-11_JPRB, &
  & 0.63523089E-11_JPRB, 0.70473566E-11_JPRB, 0.77742604E-11_JPRB, 0.85056164E-11_JPRB, 0.92631467E-11_JPRB, 0.99540766E-11_JPRB, &
  & 0.10627353E-10_JPRB, 0.11280958E-10_JPRB, 0.11895334E-10_JPRB, 0.12389634E-10_JPRB, 0.12760126E-10_JPRB, 0.12858307E-10_JPRB, &
  & 0.12703571E-10_JPRB, 0.12331076E-10_JPRB, 0.11798241E-10_JPRB, 0.11240311E-10_JPRB, 0.10761105E-10_JPRB, 0.10435377E-10_JPRB, &
  & 0.10316335E-10_JPRB, 0.10353283E-10_JPRB, 0.10454372E-10_JPRB, 0.10530664E-10_JPRB, 0.10481829E-10_JPRB, 0.10231684E-10_JPRB, &
  & 0.97731450E-11_JPRB, 0.91007583E-11_JPRB, 0.83030345E-11_JPRB, 0.74849675E-11_JPRB, 0.67271145E-11_JPRB, 0.60689817E-11_JPRB, &
  & 0.55200380E-11_JPRB, 0.50740809E-11_JPRB, 0.46985345E-11_JPRB, 0.43816595E-11_JPRB, 0.41115089E-11_JPRB, 0.38818462E-11_JPRB, &
  & 0.36793147E-11_JPRB, 0.35070126E-11_JPRB, 0.33616629E-11_JPRB, 0.32444548E-11_JPRB, 0.31591010E-11_JPRB, 0.31124799E-11_JPRB, &
  & 0.31126052E-11_JPRB, 0.31538726E-11_JPRB, 0.32434192E-11_JPRB, 0.34532199E-11_JPRB /)

RGHG5(:,20, 4) = (/ &
  & 0.14119369E-11_JPRB, 0.18494360E-11_JPRB, 0.21260693E-11_JPRB, 0.23731468E-11_JPRB, 0.26369768E-11_JPRB, 0.29366537E-11_JPRB, &
  & 0.32947215E-11_JPRB, 0.37303880E-11_JPRB, 0.42577899E-11_JPRB, 0.48775064E-11_JPRB, 0.56053881E-11_JPRB, 0.64296181E-11_JPRB, &
  & 0.73324654E-11_JPRB, 0.82872997E-11_JPRB, 0.92765517E-11_JPRB, 0.10300438E-10_JPRB, 0.11366249E-10_JPRB, 0.12469879E-10_JPRB, &
  & 0.13620690E-10_JPRB, 0.14839801E-10_JPRB, 0.16127068E-10_JPRB, 0.17448053E-10_JPRB, 0.18751459E-10_JPRB, 0.20055861E-10_JPRB, &
  & 0.21294466E-10_JPRB, 0.22494241E-10_JPRB, 0.23590019E-10_JPRB, 0.24536036E-10_JPRB, 0.25323743E-10_JPRB, 0.25811358E-10_JPRB, &
  & 0.25993612E-10_JPRB, 0.25821996E-10_JPRB, 0.25418575E-10_JPRB, 0.24841842E-10_JPRB, 0.24241357E-10_JPRB, 0.23757305E-10_JPRB, &
  & 0.23451237E-10_JPRB, 0.23246847E-10_JPRB, 0.23092771E-10_JPRB, 0.22791581E-10_JPRB, 0.22235370E-10_JPRB, 0.21352626E-10_JPRB, &
  & 0.20169214E-10_JPRB, 0.18688003E-10_JPRB, 0.17068250E-10_JPRB, 0.15454733E-10_JPRB, 0.13975639E-10_JPRB, 0.12689926E-10_JPRB, &
  & 0.11613082E-10_JPRB, 0.10725092E-10_JPRB, 0.99713978E-11_JPRB, 0.93309848E-11_JPRB, 0.87883338E-11_JPRB, 0.83312203E-11_JPRB, &
  & 0.79359219E-11_JPRB, 0.76011922E-11_JPRB, 0.73167548E-11_JPRB, 0.70820745E-11_JPRB, 0.69028594E-11_JPRB, 0.67911436E-11_JPRB, &
  & 0.67615028E-11_JPRB, 0.68067505E-11_JPRB, 0.69372563E-11_JPRB, 0.72970466E-11_JPRB /)

RGHG5(:,21, 4) = (/ &
  & 0.32462078E-11_JPRB, 0.41661271E-11_JPRB, 0.47111733E-11_JPRB, 0.52219639E-11_JPRB, 0.57518434E-11_JPRB, 0.63569523E-11_JPRB, &
  & 0.70752926E-11_JPRB, 0.79370547E-11_JPRB, 0.89658498E-11_JPRB, 0.10169970E-10_JPRB, 0.11528056E-10_JPRB, 0.13041209E-10_JPRB, &
  & 0.14667293E-10_JPRB, 0.16352024E-10_JPRB, 0.18058680E-10_JPRB, 0.19772997E-10_JPRB, 0.21499290E-10_JPRB, 0.23255332E-10_JPRB, &
  & 0.25054497E-10_JPRB, 0.26903002E-10_JPRB, 0.28804044E-10_JPRB, 0.30695592E-10_JPRB, 0.32623942E-10_JPRB, 0.34412896E-10_JPRB, &
  & 0.36124562E-10_JPRB, 0.37769891E-10_JPRB, 0.39346582E-10_JPRB, 0.40872295E-10_JPRB, 0.42270284E-10_JPRB, 0.43456582E-10_JPRB, &
  & 0.44387462E-10_JPRB, 0.44959852E-10_JPRB, 0.45239139E-10_JPRB, 0.45110003E-10_JPRB, 0.44765358E-10_JPRB, 0.44261747E-10_JPRB, &
  & 0.43721707E-10_JPRB, 0.43057218E-10_JPRB, 0.42203692E-10_JPRB, 0.41000918E-10_JPRB, 0.39379347E-10_JPRB, 0.37315474E-10_JPRB, &
  & 0.34917094E-10_JPRB, 0.32237758E-10_JPRB, 0.29482503E-10_JPRB, 0.26844785E-10_JPRB, 0.24462224E-10_JPRB, 0.22397780E-10_JPRB, &
  & 0.20644873E-10_JPRB, 0.19168389E-10_JPRB, 0.17900407E-10_JPRB, 0.16819195E-10_JPRB, 0.15904517E-10_JPRB, 0.15136191E-10_JPRB, &
  & 0.14477279E-10_JPRB, 0.13916483E-10_JPRB, 0.13434556E-10_JPRB, 0.13025732E-10_JPRB, 0.12697547E-10_JPRB, 0.12467952E-10_JPRB, &
  & 0.12357407E-10_JPRB, 0.12361599E-10_JPRB, 0.12496067E-10_JPRB, 0.12948564E-10_JPRB /)

RGHG5(:,22, 4) = (/ &
  & 0.64510112E-11_JPRB, 0.80270738E-11_JPRB, 0.90162478E-11_JPRB, 0.98959400E-11_JPRB, 0.10832040E-10_JPRB, 0.11881747E-10_JPRB, &
  & 0.13113141E-10_JPRB, 0.14570904E-10_JPRB, 0.16283138E-10_JPRB, 0.18256919E-10_JPRB, 0.20469137E-10_JPRB, 0.22845550E-10_JPRB, &
  & 0.25367078E-10_JPRB, 0.27947908E-10_JPRB, 0.30520739E-10_JPRB, 0.33054275E-10_JPRB, 0.35549286E-10_JPRB, 0.38023893E-10_JPRB, &
  & 0.40489001E-10_JPRB, 0.42957818E-10_JPRB, 0.45419463E-10_JPRB, 0.47856979E-10_JPRB, 0.50186834E-10_JPRB, 0.52362427E-10_JPRB, &
  & 0.54365627E-10_JPRB, 0.56268313E-10_JPRB, 0.58142977E-10_JPRB, 0.60087130E-10_JPRB, 0.62111233E-10_JPRB, 0.64131374E-10_JPRB, &
  & 0.66037939E-10_JPRB, 0.67700734E-10_JPRB, 0.68985546E-10_JPRB, 0.69693119E-10_JPRB, 0.69880726E-10_JPRB, 0.69518856E-10_JPRB, &
  & 0.68703210E-10_JPRB, 0.67365821E-10_JPRB, 0.65493333E-10_JPRB, 0.63013615E-10_JPRB, 0.59962972E-10_JPRB, 0.56419751E-10_JPRB, &
  & 0.52592444E-10_JPRB, 0.48573610E-10_JPRB, 0.44618045E-10_JPRB, 0.40908582E-10_JPRB, 0.37588974E-10_JPRB, 0.34697422E-10_JPRB, &
  & 0.32208097E-10_JPRB, 0.30077642E-10_JPRB, 0.28228987E-10_JPRB, 0.26644166E-10_JPRB, 0.25302264E-10_JPRB, 0.24173141E-10_JPRB, &
  & 0.23203647E-10_JPRB, 0.22368753E-10_JPRB, 0.21639092E-10_JPRB, 0.21001936E-10_JPRB, 0.20464071E-10_JPRB, 0.20050213E-10_JPRB, &
  & 0.19792733E-10_JPRB, 0.19681657E-10_JPRB, 0.19724075E-10_JPRB, 0.20087813E-10_JPRB /)

RGHG5(:,23, 4) = (/ &
  & 0.11195139E-10_JPRB, 0.13681069E-10_JPRB, 0.15163360E-10_JPRB, 0.16536245E-10_JPRB, 0.17962134E-10_JPRB, 0.19559632E-10_JPRB, &
  & 0.21408401E-10_JPRB, 0.23560102E-10_JPRB, 0.26043102E-10_JPRB, 0.28866907E-10_JPRB, 0.31986074E-10_JPRB, 0.35319702E-10_JPRB, &
  & 0.38806014E-10_JPRB, 0.42346376E-10_JPRB, 0.45841966E-10_JPRB, 0.49237989E-10_JPRB, 0.52513854E-10_JPRB, 0.55695788E-10_JPRB, &
  & 0.58808777E-10_JPRB, 0.61844425E-10_JPRB, 0.64799777E-10_JPRB, 0.67634502E-10_JPRB, 0.70290392E-10_JPRB, 0.72692949E-10_JPRB, &
  & 0.74845637E-10_JPRB, 0.76850262E-10_JPRB, 0.78852896E-10_JPRB, 0.81004925E-10_JPRB, 0.83429784E-10_JPRB, 0.86133822E-10_JPRB, &
  & 0.88881548E-10_JPRB, 0.91532185E-10_JPRB, 0.93733257E-10_JPRB, 0.95245811E-10_JPRB, 0.95906692E-10_JPRB, 0.95647830E-10_JPRB, &
  & 0.94496806E-10_JPRB, 0.92412945E-10_JPRB, 0.89481880E-10_JPRB, 0.85727814E-10_JPRB, 0.81323767E-10_JPRB, 0.76403515E-10_JPRB, &
  & 0.71300688E-10_JPRB, 0.66130185E-10_JPRB, 0.61156087E-10_JPRB, 0.56538191E-10_JPRB, 0.52397850E-10_JPRB, 0.48755913E-10_JPRB, &
  & 0.45577278E-10_JPRB, 0.42809103E-10_JPRB, 0.40386142E-10_JPRB, 0.38298396E-10_JPRB, 0.36519406E-10_JPRB, 0.35011098E-10_JPRB, &
  & 0.33707575E-10_JPRB, 0.32568843E-10_JPRB, 0.31552164E-10_JPRB, 0.30638981E-10_JPRB, 0.29838475E-10_JPRB, 0.29182136E-10_JPRB, &
  & 0.28706393E-10_JPRB, 0.28416106E-10_JPRB, 0.28276605E-10_JPRB, 0.28383058E-10_JPRB /)

RGHG5(:,24, 4) = (/ &
  & 0.17552060E-10_JPRB, 0.20978273E-10_JPRB, 0.23053313E-10_JPRB, 0.24926887E-10_JPRB, 0.26885546E-10_JPRB, 0.29055019E-10_JPRB, &
  & 0.31534251E-10_JPRB, 0.34380096E-10_JPRB, 0.37618575E-10_JPRB, 0.41255416E-10_JPRB, 0.45247566E-10_JPRB, 0.49504335E-10_JPRB, &
  & 0.53886888E-10_JPRB, 0.58317122E-10_JPRB, 0.62677349E-10_JPRB, 0.66899132E-10_JPRB, 0.70940837E-10_JPRB, 0.74813121E-10_JPRB, &
  & 0.78509935E-10_JPRB, 0.82038133E-10_JPRB, 0.85399104E-10_JPRB, 0.88534402E-10_JPRB, 0.91418324E-10_JPRB, 0.93947808E-10_JPRB, &
  & 0.96175498E-10_JPRB, 0.98199629E-10_JPRB, 0.10020609E-09_JPRB, 0.10244380E-09_JPRB, 0.10505235E-09_JPRB, 0.10806706E-09_JPRB, &
  & 0.11130753E-09_JPRB, 0.11454163E-09_JPRB, 0.11732688E-09_JPRB, 0.11929385E-09_JPRB, 0.12017651E-09_JPRB, 0.11984841E-09_JPRB, &
  & 0.11828692E-09_JPRB, 0.11553847E-09_JPRB, 0.11172981E-09_JPRB, 0.10696896E-09_JPRB, 0.10152959E-09_JPRB, 0.95646685E-10_JPRB, &
  & 0.89673609E-10_JPRB, 0.83738745E-10_JPRB, 0.78086627E-10_JPRB, 0.72834197E-10_JPRB, 0.68080847E-10_JPRB, 0.63843333E-10_JPRB, &
  & 0.60078838E-10_JPRB, 0.56758064E-10_JPRB, 0.53823362E-10_JPRB, 0.51265207E-10_JPRB, 0.49063378E-10_JPRB, 0.47169407E-10_JPRB, &
  & 0.45509700E-10_JPRB, 0.44033915E-10_JPRB, 0.42693182E-10_JPRB, 0.41462209E-10_JPRB, 0.40350993E-10_JPRB, 0.39399546E-10_JPRB, &
  & 0.38657369E-10_JPRB, 0.38119972E-10_JPRB, 0.37743801E-10_JPRB, 0.37411123E-10_JPRB /)

RGHG5(:,25, 4) = (/ &
  & 0.25409270E-10_JPRB, 0.29717104E-10_JPRB, 0.32351906E-10_JPRB, 0.34700957E-10_JPRB, 0.37149429E-10_JPRB, 0.39846702E-10_JPRB, &
  & 0.42887766E-10_JPRB, 0.46343745E-10_JPRB, 0.50226236E-10_JPRB, 0.54544008E-10_JPRB, 0.59263046E-10_JPRB, 0.64294618E-10_JPRB, &
  & 0.69500926E-10_JPRB, 0.74734434E-10_JPRB, 0.79872609E-10_JPRB, 0.84819943E-10_JPRB, 0.89525165E-10_JPRB, 0.93981170E-10_JPRB, &
  & 0.98183121E-10_JPRB, 0.10214193E-09_JPRB, 0.10584073E-09_JPRB, 0.10922575E-09_JPRB, 0.11227162E-09_JPRB, 0.11489110E-09_JPRB, &
  & 0.11714818E-09_JPRB, 0.11914369E-09_JPRB, 0.12111624E-09_JPRB, 0.12330738E-09_JPRB, 0.12588849E-09_JPRB, 0.12895998E-09_JPRB, &
  & 0.13233747E-09_JPRB, 0.13572619E-09_JPRB, 0.13867756E-09_JPRB, 0.14071982E-09_JPRB, 0.14154915E-09_JPRB, 0.14099705E-09_JPRB, &
  & 0.13901699E-09_JPRB, 0.13567764E-09_JPRB, 0.13122549E-09_JPRB, 0.12586825E-09_JPRB, 0.11987451E-09_JPRB, 0.11349496E-09_JPRB, &
  & 0.10710899E-09_JPRB, 0.10081772E-09_JPRB, 0.94826418E-10_JPRB, 0.89219014E-10_JPRB, 0.84066358E-10_JPRB, 0.79390980E-10_JPRB, &
  & 0.75179904E-10_JPRB, 0.71407991E-10_JPRB, 0.68034113E-10_JPRB, 0.65062997E-10_JPRB, 0.62462480E-10_JPRB, 0.60182456E-10_JPRB, &
  & 0.58145693E-10_JPRB, 0.56298924E-10_JPRB, 0.54591401E-10_JPRB, 0.52998713E-10_JPRB, 0.51535436E-10_JPRB, 0.50250033E-10_JPRB, &
  & 0.49195599E-10_JPRB, 0.48375443E-10_JPRB, 0.47707057E-10_JPRB, 0.46910854E-10_JPRB /)

RGHG5(:,26, 4) = (/ &
  & 0.34479711E-10_JPRB, 0.39684353E-10_JPRB, 0.42670353E-10_JPRB, 0.45456288E-10_JPRB, 0.48286597E-10_JPRB, 0.51397771E-10_JPRB, &
  & 0.54901479E-10_JPRB, 0.58819408E-10_JPRB, 0.63199466E-10_JPRB, 0.68041794E-10_JPRB, 0.73312585E-10_JPRB, 0.78938994E-10_JPRB, &
  & 0.84771253E-10_JPRB, 0.90633598E-10_JPRB, 0.96400610E-10_JPRB, 0.10197043E-09_JPRB, 0.10727214E-09_JPRB, 0.11226548E-09_JPRB, &
  & 0.11693077E-09_JPRB, 0.12126734E-09_JPRB, 0.12525031E-09_JPRB, 0.12885137E-09_JPRB, 0.13203051E-09_JPRB, 0.13474397E-09_JPRB, &
  & 0.13702958E-09_JPRB, 0.13902079E-09_JPRB, 0.14094267E-09_JPRB, 0.14298658E-09_JPRB, 0.14546428E-09_JPRB, 0.14835666E-09_JPRB, &
  & 0.15155857E-09_JPRB, 0.15475064E-09_JPRB, 0.15751810E-09_JPRB, 0.15935255E-09_JPRB, 0.15992288E-09_JPRB, 0.15904608E-09_JPRB, &
  & 0.15668190E-09_JPRB, 0.15301861E-09_JPRB, 0.14824995E-09_JPRB, 0.14262630E-09_JPRB, 0.13644684E-09_JPRB, 0.13001489E-09_JPRB, &
  & 0.12358699E-09_JPRB, 0.11729126E-09_JPRB, 0.11123662E-09_JPRB, 0.10549602E-09_JPRB, 0.10012162E-09_JPRB, 0.95161774E-10_JPRB, &
  & 0.90613954E-10_JPRB, 0.86476604E-10_JPRB, 0.82733244E-10_JPRB, 0.79381481E-10_JPRB, 0.76397763E-10_JPRB, 0.73729259E-10_JPRB, &
  & 0.71298169E-10_JPRB, 0.69051181E-10_JPRB, 0.66940314E-10_JPRB, 0.64945431E-10_JPRB, 0.63088965E-10_JPRB, 0.61434073E-10_JPRB, &
  & 0.60039827E-10_JPRB, 0.58913263E-10_JPRB, 0.57884444E-10_JPRB, 0.56574034E-10_JPRB /)

RGHG5(:,27, 4) = (/ &
  & 0.44738879E-10_JPRB, 0.50286744E-10_JPRB, 0.53759729E-10_JPRB, 0.56738409E-10_JPRB, 0.59885749E-10_JPRB, 0.63302592E-10_JPRB, &
  & 0.67103829E-10_JPRB, 0.71370097E-10_JPRB, 0.76080767E-10_JPRB, 0.81269755E-10_JPRB, 0.86935022E-10_JPRB, 0.92986507E-10_JPRB, &
  & 0.99302386E-10_JPRB, 0.10567736E-09_JPRB, 0.11196299E-09_JPRB, 0.11803303E-09_JPRB, 0.12380812E-09_JPRB, 0.12923385E-09_JPRB, &
  & 0.13428218E-09_JPRB, 0.13893055E-09_JPRB, 0.14316190E-09_JPRB, 0.14694652E-09_JPRB, 0.15025768E-09_JPRB, 0.15307022E-09_JPRB, &
  & 0.15541443E-09_JPRB, 0.15743121E-09_JPRB, 0.15928871E-09_JPRB, 0.16123911E-09_JPRB, 0.16348363E-09_JPRB, 0.16602986E-09_JPRB, &
  & 0.16883862E-09_JPRB, 0.17161393E-09_JPRB, 0.17396677E-09_JPRB, 0.17541966E-09_JPRB, 0.17563666E-09_JPRB, 0.17446100E-09_JPRB, &
  & 0.17188369E-09_JPRB, 0.16799996E-09_JPRB, 0.16313167E-09_JPRB, 0.15760979E-09_JPRB, 0.15162721E-09_JPRB, 0.14544091E-09_JPRB, &
  & 0.13927309E-09_JPRB, 0.13319922E-09_JPRB, 0.12730023E-09_JPRB, 0.12158892E-09_JPRB, 0.11613401E-09_JPRB, 0.11098336E-09_JPRB, &
  & 0.10618147E-09_JPRB, 0.10174784E-09_JPRB, 0.97676395E-10_JPRB, 0.93981413E-10_JPRB, 0.90631141E-10_JPRB, 0.87573053E-10_JPRB, &
  & 0.84738154E-10_JPRB, 0.82070933E-10_JPRB, 0.79532783E-10_JPRB, 0.77108486E-10_JPRB, 0.74832730E-10_JPRB, 0.72784292E-10_JPRB, &
  & 0.71034519E-10_JPRB, 0.69568233E-10_JPRB, 0.68223760E-10_JPRB, 0.66410877E-10_JPRB /)

RGHG5(:,28, 4) = (/ &
  & 0.55421993E-10_JPRB, 0.61609204E-10_JPRB, 0.65041493E-10_JPRB, 0.68320294E-10_JPRB, 0.71609003E-10_JPRB, 0.75211733E-10_JPRB, &
  & 0.79237179E-10_JPRB, 0.83685746E-10_JPRB, 0.88606449E-10_JPRB, 0.94009391E-10_JPRB, 0.99894489E-10_JPRB, 0.10622109E-09_JPRB, &
  & 0.11284741E-09_JPRB, 0.11961244E-09_JPRB, 0.12631753E-09_JPRB, 0.13280674E-09_JPRB, 0.13896252E-09_JPRB, 0.14472160E-09_JPRB, &
  & 0.15006865E-09_JPRB, 0.15497109E-09_JPRB, 0.15940757E-09_JPRB, 0.16334956E-09_JPRB, 0.16678436E-09_JPRB, 0.16969193E-09_JPRB, &
  & 0.17211335E-09_JPRB, 0.17415348E-09_JPRB, 0.17595914E-09_JPRB, 0.17778458E-09_JPRB, 0.17974153E-09_JPRB, 0.18190284E-09_JPRB, &
  & 0.18421470E-09_JPRB, 0.18645743E-09_JPRB, 0.18827981E-09_JPRB, 0.18927260E-09_JPRB, 0.18911890E-09_JPRB, 0.18767474E-09_JPRB, &
  & 0.18491594E-09_JPRB, 0.18110252E-09_JPRB, 0.17650675E-09_JPRB, 0.17130265E-09_JPRB, 0.16573176E-09_JPRB, 0.16001020E-09_JPRB, &
  & 0.15429195E-09_JPRB, 0.14860932E-09_JPRB, 0.14295296E-09_JPRB, 0.13737662E-09_JPRB, 0.13190890E-09_JPRB, 0.12666163E-09_JPRB, &
  & 0.12168122E-09_JPRB, 0.11701023E-09_JPRB, 0.11266034E-09_JPRB, 0.10864451E-09_JPRB, 0.10493896E-09_JPRB, 0.10150032E-09_JPRB, &
  & 0.98263155E-10_JPRB, 0.95174854E-10_JPRB, 0.92203210E-10_JPRB, 0.89341722E-10_JPRB, 0.86643213E-10_JPRB, 0.84202992E-10_JPRB, &
  & 0.82112317E-10_JPRB, 0.80324095E-10_JPRB, 0.78659072E-10_JPRB, 0.76431438E-10_JPRB /)

RGHG5(:,29, 4) = (/ &
  & 0.66620882E-10_JPRB, 0.72698493E-10_JPRB, 0.76533821E-10_JPRB, 0.79762294E-10_JPRB, 0.83211896E-10_JPRB, 0.86944729E-10_JPRB, &
  & 0.91043124E-10_JPRB, 0.95609590E-10_JPRB, 0.10061312E-09_JPRB, 0.10610615E-09_JPRB, 0.11211578E-09_JPRB, 0.11857844E-09_JPRB, &
  & 0.12538073E-09_JPRB, 0.13232408E-09_JPRB, 0.13925368E-09_JPRB, 0.14604519E-09_JPRB, 0.15255054E-09_JPRB, 0.15862819E-09_JPRB, &
  & 0.16423742E-09_JPRB, 0.16935257E-09_JPRB, 0.17396308E-09_JPRB, 0.17803169E-09_JPRB, 0.18157613E-09_JPRB, 0.18456198E-09_JPRB, &
  & 0.18706456E-09_JPRB, 0.18912781E-09_JPRB, 0.19091381E-09_JPRB, 0.19259930E-09_JPRB, 0.19426388E-09_JPRB, 0.19600430E-09_JPRB, &
  & 0.19779013E-09_JPRB, 0.19945195E-09_JPRB, 0.20071977E-09_JPRB, 0.20123868E-09_JPRB, 0.20074795E-09_JPRB, 0.19913689E-09_JPRB, &
  & 0.19647281E-09_JPRB, 0.19290557E-09_JPRB, 0.18859976E-09_JPRB, 0.18385860E-09_JPRB, 0.17886126E-09_JPRB, 0.17372664E-09_JPRB, &
  & 0.16857024E-09_JPRB, 0.16334610E-09_JPRB, 0.15805886E-09_JPRB, 0.15267192E-09_JPRB, 0.14728334E-09_JPRB, 0.14197443E-09_JPRB, &
  & 0.13686416E-09_JPRB, 0.13200567E-09_JPRB, 0.12740808E-09_JPRB, 0.12310421E-09_JPRB, 0.11907447E-09_JPRB, 0.11527769E-09_JPRB, &
  & 0.11166050E-09_JPRB, 0.10816642E-09_JPRB, 0.10477688E-09_JPRB, 0.10148778E-09_JPRB, 0.98375273E-10_JPRB, 0.95552080E-10_JPRB, &
  & 0.93119054E-10_JPRB, 0.91045047E-10_JPRB, 0.89133534E-10_JPRB, 0.86484417E-10_JPRB /)

RGHG5(:,30, 4) = (/ &
  & 0.77458720E-10_JPRB, 0.83983313E-10_JPRB, 0.87591323E-10_JPRB, 0.91056961E-10_JPRB, 0.94497098E-10_JPRB, 0.98278594E-10_JPRB, &
  & 0.10245664E-09_JPRB, 0.10701422E-09_JPRB, 0.11202762E-09_JPRB, 0.11752289E-09_JPRB, 0.12353264E-09_JPRB, 0.13004912E-09_JPRB, &
  & 0.13695999E-09_JPRB, 0.14408763E-09_JPRB, 0.15120344E-09_JPRB, 0.15812962E-09_JPRB, 0.16480277E-09_JPRB, 0.17108835E-09_JPRB, &
  & 0.17689063E-09_JPRB, 0.18215988E-09_JPRB, 0.18689841E-09_JPRB, 0.19105395E-09_JPRB, 0.19468137E-09_JPRB, 0.19770970E-09_JPRB, &
  & 0.20028090E-09_JPRB, 0.20233891E-09_JPRB, 0.20410877E-09_JPRB, 0.20564694E-09_JPRB, 0.20704899E-09_JPRB, 0.20839075E-09_JPRB, &
  & 0.20967526E-09_JPRB, 0.21078213E-09_JPRB, 0.21152582E-09_JPRB, 0.21161785E-09_JPRB, 0.21086588E-09_JPRB, 0.20918502E-09_JPRB, &
  & 0.20659710E-09_JPRB, 0.20323682E-09_JPRB, 0.19943044E-09_JPRB, 0.19532480E-09_JPRB, 0.19099228E-09_JPRB, 0.18650115E-09_JPRB, &
  & 0.18190005E-09_JPRB, 0.17717289E-09_JPRB, 0.17222553E-09_JPRB, 0.16710770E-09_JPRB, 0.16184741E-09_JPRB, 0.15657450E-09_JPRB, &
  & 0.15140229E-09_JPRB, 0.14640336E-09_JPRB, 0.14162030E-09_JPRB, 0.13708017E-09_JPRB, 0.13276526E-09_JPRB, 0.12865756E-09_JPRB, &
  & 0.12469932E-09_JPRB, 0.12084513E-09_JPRB, 0.11707359E-09_JPRB, 0.11339350E-09_JPRB, 0.10990158E-09_JPRB, 0.10673136E-09_JPRB, &
  & 0.10399471E-09_JPRB, 0.10166889E-09_JPRB, 0.99508998E-10_JPRB, 0.96529069E-10_JPRB /)

RGHG5(:,31, 4) = (/ &
  & 0.88249165E-10_JPRB, 0.94575126E-10_JPRB, 0.98532148E-10_JPRB, 0.10186806E-09_JPRB, 0.10541348E-09_JPRB, 0.10921269E-09_JPRB, &
  & 0.11335562E-09_JPRB, 0.11790406E-09_JPRB, 0.12284747E-09_JPRB, 0.12827207E-09_JPRB, 0.13423031E-09_JPRB, 0.14068782E-09_JPRB, &
  & 0.14756131E-09_JPRB, 0.15469925E-09_JPRB, 0.16191835E-09_JPRB, 0.16900166E-09_JPRB, 0.17579758E-09_JPRB, 0.18221272E-09_JPRB, &
  & 0.18813216E-09_JPRB, 0.19349830E-09_JPRB, 0.19830527E-09_JPRB, 0.20250474E-09_JPRB, 0.20617284E-09_JPRB, 0.20921090E-09_JPRB, &
  & 0.21181044E-09_JPRB, 0.21384675E-09_JPRB, 0.21557822E-09_JPRB, 0.21697442E-09_JPRB, 0.21815398E-09_JPRB, 0.21914834E-09_JPRB, &
  & 0.21999451E-09_JPRB, 0.22062040E-09_JPRB, 0.22090481E-09_JPRB, 0.22064219E-09_JPRB, 0.21969113E-09_JPRB, 0.21798274E-09_JPRB, &
  & 0.21557410E-09_JPRB, 0.21267477E-09_JPRB, 0.20938676E-09_JPRB, 0.20581389E-09_JPRB, 0.20206661E-09_JPRB, 0.19817137E-09_JPRB, &
  & 0.19412572E-09_JPRB, 0.18982947E-09_JPRB, 0.18525614E-09_JPRB, 0.18037842E-09_JPRB, 0.17530323E-09_JPRB, 0.17013352E-09_JPRB, &
  & 0.16497052E-09_JPRB, 0.15991120E-09_JPRB, 0.15501032E-09_JPRB, 0.15028999E-09_JPRB, 0.14576568E-09_JPRB, 0.14141301E-09_JPRB, &
  & 0.13718232E-09_JPRB, 0.13303099E-09_JPRB, 0.12893818E-09_JPRB, 0.12492658E-09_JPRB, 0.12110363E-09_JPRB, 0.11763912E-09_JPRB, &
  & 0.11464129E-09_JPRB, 0.11211396E-09_JPRB, 0.10975942E-09_JPRB, 0.10646172E-09_JPRB /)

RGHG5(:,32, 4) = (/ &
  & 0.98457610E-10_JPRB, 0.10514763E-09_JPRB, 0.10887036E-09_JPRB, 0.11240212E-09_JPRB, 0.11589334E-09_JPRB, 0.11968834E-09_JPRB, &
  & 0.12380522E-09_JPRB, 0.12825874E-09_JPRB, 0.13309884E-09_JPRB, 0.13839337E-09_JPRB, 0.14421468E-09_JPRB, 0.15057658E-09_JPRB, &
  & 0.15737679E-09_JPRB, 0.16445909E-09_JPRB, 0.17165279E-09_JPRB, 0.17876159E-09_JPRB, 0.18561636E-09_JPRB, 0.19209312E-09_JPRB, &
  & 0.19806812E-09_JPRB, 0.20347490E-09_JPRB, 0.20828836E-09_JPRB, 0.21249352E-09_JPRB, 0.21615316E-09_JPRB, 0.21918034E-09_JPRB, &
  & 0.22175137E-09_JPRB, 0.22376798E-09_JPRB, 0.22542000E-09_JPRB, 0.22670647E-09_JPRB, 0.22768692E-09_JPRB, 0.22840639E-09_JPRB, &
  & 0.22889690E-09_JPRB, 0.22913549E-09_JPRB, 0.22905651E-09_JPRB, 0.22852345E-09_JPRB, 0.22744680E-09_JPRB, 0.22579756E-09_JPRB, &
  & 0.22367098E-09_JPRB, 0.22114764E-09_JPRB, 0.21831775E-09_JPRB, 0.21527258E-09_JPRB, 0.21203479E-09_JPRB, 0.20862657E-09_JPRB, &
  & 0.20500925E-09_JPRB, 0.20110501E-09_JPRB, 0.19685216E-09_JPRB, 0.19226484E-09_JPRB, 0.18740090E-09_JPRB, 0.18238069E-09_JPRB, &
  & 0.17731580E-09_JPRB, 0.17227349E-09_JPRB, 0.16732653E-09_JPRB, 0.16252315E-09_JPRB, 0.15787105E-09_JPRB, 0.15336211E-09_JPRB, &
  & 0.14894591E-09_JPRB, 0.14458476E-09_JPRB, 0.14024934E-09_JPRB, 0.13598395E-09_JPRB, 0.13191478E-09_JPRB, 0.12821302E-09_JPRB, &
  & 0.12503522E-09_JPRB, 0.12233636E-09_JPRB, 0.11981538E-09_JPRB, 0.11625156E-09_JPRB /)

RGHG5(:,33, 4) = (/ &
  & 0.10853728E-09_JPRB, 0.11506854E-09_JPRB, 0.11906680E-09_JPRB, 0.12245621E-09_JPRB, 0.12600200E-09_JPRB, 0.12975797E-09_JPRB, &
  & 0.13378443E-09_JPRB, 0.13813466E-09_JPRB, 0.14281985E-09_JPRB, 0.14793593E-09_JPRB, 0.15357288E-09_JPRB, 0.15974076E-09_JPRB, &
  & 0.16638770E-09_JPRB, 0.17336037E-09_JPRB, 0.18047323E-09_JPRB, 0.18754623E-09_JPRB, 0.19437310E-09_JPRB, 0.20083368E-09_JPRB, &
  & 0.20678666E-09_JPRB, 0.21218499E-09_JPRB, 0.21696017E-09_JPRB, 0.22112792E-09_JPRB, 0.22474211E-09_JPRB, 0.22773618E-09_JPRB, &
  & 0.23024402E-09_JPRB, 0.23222108E-09_JPRB, 0.23378272E-09_JPRB, 0.23496644E-09_JPRB, 0.23578750E-09_JPRB, 0.23629582E-09_JPRB, &
  & 0.23652108E-09_JPRB, 0.23647395E-09_JPRB, 0.23613350E-09_JPRB, 0.23542096E-09_JPRB, 0.23429639E-09_JPRB, 0.23276905E-09_JPRB, &
  & 0.23088056E-09_JPRB, 0.22869337E-09_JPRB, 0.22627600E-09_JPRB, 0.22366767E-09_JPRB, 0.22085553E-09_JPRB, 0.21782898E-09_JPRB, &
  & 0.21454655E-09_JPRB, 0.21093238E-09_JPRB, 0.20696164E-09_JPRB, 0.20262654E-09_JPRB, 0.19800131E-09_JPRB, 0.19318747E-09_JPRB, &
  & 0.18826236E-09_JPRB, 0.18332091E-09_JPRB, 0.17841920E-09_JPRB, 0.17361436E-09_JPRB, 0.16893675E-09_JPRB, 0.16437270E-09_JPRB, &
  & 0.15987350E-09_JPRB, 0.15539908E-09_JPRB, 0.15092319E-09_JPRB, 0.14649605E-09_JPRB, 0.14226051E-09_JPRB, 0.13842066E-09_JPRB, &
  & 0.13510901E-09_JPRB, 0.13230192E-09_JPRB, 0.12965147E-09_JPRB, 0.12585354E-09_JPRB /)

RGHG5(:,34, 4) = (/ &
  & 0.11819480E-09_JPRB, 0.12496273E-09_JPRB, 0.12874855E-09_JPRB, 0.13225802E-09_JPRB, 0.13572106E-09_JPRB, 0.13940663E-09_JPRB, &
  & 0.14335294E-09_JPRB, 0.14754217E-09_JPRB, 0.15203883E-09_JPRB, 0.15693535E-09_JPRB, 0.16232979E-09_JPRB, 0.16826990E-09_JPRB, &
  & 0.17469032E-09_JPRB, 0.18148183E-09_JPRB, 0.18846170E-09_JPRB, 0.19542330E-09_JPRB, 0.20216608E-09_JPRB, 0.20853971E-09_JPRB, &
  & 0.21440083E-09_JPRB, 0.21972521E-09_JPRB, 0.22443884E-09_JPRB, 0.22853687E-09_JPRB, 0.23207827E-09_JPRB, 0.23501695E-09_JPRB, &
  & 0.23743768E-09_JPRB, 0.23935076E-09_JPRB, 0.24081606E-09_JPRB, 0.24189700E-09_JPRB, 0.24259353E-09_JPRB, 0.24294902E-09_JPRB, &
  & 0.24299729E-09_JPRB, 0.24276536E-09_JPRB, 0.24226660E-09_JPRB, 0.24146735E-09_JPRB, 0.24036520E-09_JPRB, 0.23897806E-09_JPRB, &
  & 0.23732652E-09_JPRB, 0.23545582E-09_JPRB, 0.23338687E-09_JPRB, 0.23110325E-09_JPRB, 0.22858399E-09_JPRB, 0.22580321E-09_JPRB, &
  & 0.22274094E-09_JPRB, 0.21933920E-09_JPRB, 0.21557658E-09_JPRB, 0.21147645E-09_JPRB, 0.20709216E-09_JPRB, 0.20249211E-09_JPRB, &
  & 0.19776870E-09_JPRB, 0.19297909E-09_JPRB, 0.18819096E-09_JPRB, 0.18347984E-09_JPRB, 0.17886682E-09_JPRB, 0.17434698E-09_JPRB, &
  & 0.16987285E-09_JPRB, 0.16539434E-09_JPRB, 0.16088091E-09_JPRB, 0.15639974E-09_JPRB, 0.15210269E-09_JPRB, 0.14819604E-09_JPRB, &
  & 0.14483509E-09_JPRB, 0.14195521E-09_JPRB, 0.13920926E-09_JPRB, 0.13523342E-09_JPRB /)

RGHG5(:,35, 4) = (/ &
  & 0.12777211E-09_JPRB, 0.13435898E-09_JPRB, 0.13828579E-09_JPRB, 0.14164420E-09_JPRB, 0.14509299E-09_JPRB, 0.14868398E-09_JPRB, &
  & 0.15248208E-09_JPRB, 0.15650367E-09_JPRB, 0.16077840E-09_JPRB, 0.16541442E-09_JPRB, 0.17052790E-09_JPRB, 0.17617906E-09_JPRB, &
  & 0.18234558E-09_JPRB, 0.18888999E-09_JPRB, 0.19567079E-09_JPRB, 0.20247276E-09_JPRB, 0.20907448E-09_JPRB, 0.21531826E-09_JPRB, &
  & 0.22104737E-09_JPRB, 0.22624021E-09_JPRB, 0.23085753E-09_JPRB, 0.23486713E-09_JPRB, 0.23831112E-09_JPRB, 0.24116734E-09_JPRB, &
  & 0.24347702E-09_JPRB, 0.24528660E-09_JPRB, 0.24664143E-09_JPRB, 0.24760829E-09_JPRB, 0.24819991E-09_JPRB, 0.24845223E-09_JPRB, &
  & 0.24840061E-09_JPRB, 0.24807809E-09_JPRB, 0.24751756E-09_JPRB, 0.24671443E-09_JPRB, 0.24568669E-09_JPRB, 0.24445324E-09_JPRB, &
  & 0.24303493E-09_JPRB, 0.24144689E-09_JPRB, 0.23965807E-09_JPRB, 0.23762259E-09_JPRB, 0.23528249E-09_JPRB, 0.23263461E-09_JPRB, &
  & 0.22967823E-09_JPRB, 0.22639668E-09_JPRB, 0.22279897E-09_JPRB, 0.21890117E-09_JPRB, 0.21475038E-09_JPRB, 0.21039459E-09_JPRB, &
  & 0.20587144E-09_JPRB, 0.20126972E-09_JPRB, 0.19665139E-09_JPRB, 0.19208685E-09_JPRB, 0.18761644E-09_JPRB, 0.18323047E-09_JPRB, &
  & 0.17887317E-09_JPRB, 0.17448876E-09_JPRB, 0.17005451E-09_JPRB, 0.16562415E-09_JPRB, 0.16136420E-09_JPRB, 0.15748661E-09_JPRB, &
  & 0.15412727E-09_JPRB, 0.15122703E-09_JPRB, 0.14843574E-09_JPRB, 0.14431675E-09_JPRB /)

RGHG5(:,36, 4) = (/ &
  & 0.13705823E-09_JPRB, 0.14363886E-09_JPRB, 0.14737628E-09_JPRB, 0.15075445E-09_JPRB, 0.15409667E-09_JPRB, 0.15757259E-09_JPRB, &
  & 0.16122315E-09_JPRB, 0.16502787E-09_JPRB, 0.16905513E-09_JPRB, 0.17340870E-09_JPRB, 0.17820490E-09_JPRB, 0.18352511E-09_JPRB, &
  & 0.18937235E-09_JPRB, 0.19565480E-09_JPRB, 0.20218011E-09_JPRB, 0.20875550E-09_JPRB, 0.21515295E-09_JPRB, 0.22122168E-09_JPRB, &
  & 0.22680198E-09_JPRB, 0.23185535E-09_JPRB, 0.23635877E-09_JPRB, 0.24026703E-09_JPRB, 0.24358260E-09_JPRB, 0.24630376E-09_JPRB, &
  & 0.24845132E-09_JPRB, 0.25008931E-09_JPRB, 0.25128649E-09_JPRB, 0.25211064E-09_JPRB, 0.25259758E-09_JPRB, 0.25277924E-09_JPRB, &
  & 0.25269087E-09_JPRB, 0.25235788E-09_JPRB, 0.25181962E-09_JPRB, 0.25108554E-09_JPRB, 0.25018010E-09_JPRB, 0.24912389E-09_JPRB, &
  & 0.24792832E-09_JPRB, 0.24657576E-09_JPRB, 0.24501806E-09_JPRB, 0.24317470E-09_JPRB, 0.24097876E-09_JPRB, 0.23840768E-09_JPRB, &
  & 0.23550450E-09_JPRB, 0.23230136E-09_JPRB, 0.22882994E-09_JPRB, 0.22512331E-09_JPRB, 0.22118253E-09_JPRB, 0.21702937E-09_JPRB, &
  & 0.21271956E-09_JPRB, 0.20830136E-09_JPRB, 0.20386509E-09_JPRB, 0.19948723E-09_JPRB, 0.19520716E-09_JPRB, 0.19101545E-09_JPRB, &
  & 0.18685310E-09_JPRB, 0.18265453E-09_JPRB, 0.17838742E-09_JPRB, 0.17411467E-09_JPRB, 0.16998994E-09_JPRB, 0.16621664E-09_JPRB, &
  & 0.16293202E-09_JPRB, 0.16006281E-09_JPRB, 0.15725832E-09_JPRB, 0.15308092E-09_JPRB /)

RGHG5(:,37, 4) = (/ &
  & 0.14619234E-09_JPRB, 0.15253840E-09_JPRB, 0.15622284E-09_JPRB, 0.15948716E-09_JPRB, 0.16276247E-09_JPRB, 0.16612445E-09_JPRB, &
  & 0.16959370E-09_JPRB, 0.17317246E-09_JPRB, 0.17692404E-09_JPRB, 0.18096273E-09_JPRB, 0.18541715E-09_JPRB, 0.19038048E-09_JPRB, &
  & 0.19586940E-09_JPRB, 0.20181438E-09_JPRB, 0.20805425E-09_JPRB, 0.21436025E-09_JPRB, 0.22051257E-09_JPRB, 0.22635394E-09_JPRB, &
  & 0.23176562E-09_JPRB, 0.23667393E-09_JPRB, 0.24105257E-09_JPRB, 0.24482930E-09_JPRB, 0.24795713E-09_JPRB, 0.25043942E-09_JPRB, &
  & 0.25231997E-09_JPRB, 0.25369934E-09_JPRB, 0.25467042E-09_JPRB, 0.25532107E-09_JPRB, 0.25569730E-09_JPRB, 0.25582833E-09_JPRB, &
  & 0.25574279E-09_JPRB, 0.25545382E-09_JPRB, 0.25499375E-09_JPRB, 0.25437616E-09_JPRB, 0.25362645E-09_JPRB, 0.25275793E-09_JPRB, &
  & 0.25177005E-09_JPRB, 0.25062977E-09_JPRB, 0.24927307E-09_JPRB, 0.24761956E-09_JPRB, 0.24558311E-09_JPRB, 0.24313154E-09_JPRB, &
  & 0.24031466E-09_JPRB, 0.23719499E-09_JPRB, 0.23385224E-09_JPRB, 0.23029934E-09_JPRB, 0.22655300E-09_JPRB, 0.22261079E-09_JPRB, &
  & 0.21848469E-09_JPRB, 0.21424668E-09_JPRB, 0.20998714E-09_JPRB, 0.20579896E-09_JPRB, 0.20173473E-09_JPRB, 0.19777914E-09_JPRB, &
  & 0.19386329E-09_JPRB, 0.18991503E-09_JPRB, 0.18589973E-09_JPRB, 0.18186214E-09_JPRB, 0.17795662E-09_JPRB, 0.17437013E-09_JPRB, &
  & 0.17121995E-09_JPRB, 0.16843307E-09_JPRB, 0.16567855E-09_JPRB, 0.16149716E-09_JPRB /)

RGHG5(:,38, 4) = (/ &
  & 0.15511917E-09_JPRB, 0.16113509E-09_JPRB, 0.16470818E-09_JPRB, 0.16787972E-09_JPRB, 0.17109643E-09_JPRB, 0.17434953E-09_JPRB, &
  & 0.17763839E-09_JPRB, 0.18097585E-09_JPRB, 0.18443391E-09_JPRB, 0.18813430E-09_JPRB, 0.19221598E-09_JPRB, 0.19678296E-09_JPRB, &
  & 0.20188995E-09_JPRB, 0.20747358E-09_JPRB, 0.21336774E-09_JPRB, 0.21936186E-09_JPRB, 0.22522507E-09_JPRB, 0.23081767E-09_JPRB, &
  & 0.23602920E-09_JPRB, 0.24077187E-09_JPRB, 0.24496308E-09_JPRB, 0.24851896E-09_JPRB, 0.25135022E-09_JPRB, 0.25348151E-09_JPRB, &
  & 0.25501604E-09_JPRB, 0.25609043E-09_JPRB, 0.25683061E-09_JPRB, 0.25731750E-09_JPRB, 0.25760113E-09_JPRB, 0.25769878E-09_JPRB, &
  & 0.25763067E-09_JPRB, 0.25739741E-09_JPRB, 0.25702229E-09_JPRB, 0.25651908E-09_JPRB, 0.25590902E-09_JPRB, 0.25520505E-09_JPRB, &
  & 0.25439481E-09_JPRB, 0.25344415E-09_JPRB, 0.25228683E-09_JPRB, 0.25083868E-09_JPRB, 0.24900831E-09_JPRB, 0.24675467E-09_JPRB, &
  & 0.24410138E-09_JPRB, 0.24114161E-09_JPRB, 0.23795152E-09_JPRB, 0.23459712E-09_JPRB, 0.23105662E-09_JPRB, 0.22730855E-09_JPRB, &
  & 0.22336434E-09_JPRB, 0.21928365E-09_JPRB, 0.21518234E-09_JPRB, 0.21117900E-09_JPRB, 0.20733597E-09_JPRB, 0.20363472E-09_JPRB, &
  & 0.20000078E-09_JPRB, 0.19634791E-09_JPRB, 0.19263396E-09_JPRB, 0.18889608E-09_JPRB, 0.18527591E-09_JPRB, 0.18194074E-09_JPRB, &
  & 0.17898741E-09_JPRB, 0.17634151E-09_JPRB, 0.17367946E-09_JPRB, 0.16958218E-09_JPRB /)

RGHG5(:,39, 4) = (/ &
  & 0.16372037E-09_JPRB, 0.16947010E-09_JPRB, 0.17279495E-09_JPRB, 0.17595200E-09_JPRB, 0.17907363E-09_JPRB, 0.18225176E-09_JPRB, &
  & 0.18537287E-09_JPRB, 0.18845638E-09_JPRB, 0.19160031E-09_JPRB, 0.19494890E-09_JPRB, 0.19863421E-09_JPRB, 0.20278736E-09_JPRB, &
  & 0.20747025E-09_JPRB, 0.21265278E-09_JPRB, 0.21817706E-09_JPRB, 0.22382662E-09_JPRB, 0.22938459E-09_JPRB, 0.23469465E-09_JPRB, &
  & 0.23966390E-09_JPRB, 0.24418284E-09_JPRB, 0.24810187E-09_JPRB, 0.25130376E-09_JPRB, 0.25375091E-09_JPRB, 0.25550173E-09_JPRB, &
  & 0.25670915E-09_JPRB, 0.25753488E-09_JPRB, 0.25809793E-09_JPRB, 0.25847233E-09_JPRB, 0.25869579E-09_JPRB, 0.25877631E-09_JPRB, &
  & 0.25872565E-09_JPRB, 0.25853697E-09_JPRB, 0.25822525E-09_JPRB, 0.25780467E-09_JPRB, 0.25729602E-09_JPRB, 0.25670771E-09_JPRB, &
  & 0.25603253E-09_JPRB, 0.25523378E-09_JPRB, 0.25425390E-09_JPRB, 0.25300881E-09_JPRB, 0.25140967E-09_JPRB, 0.24939273E-09_JPRB, &
  & 0.24698182E-09_JPRB, 0.24423633E-09_JPRB, 0.24128077E-09_JPRB, 0.23814578E-09_JPRB, 0.23483468E-09_JPRB, 0.23130120E-09_JPRB, &
  & 0.22753169E-09_JPRB, 0.22359259E-09_JPRB, 0.21962909E-09_JPRB, 0.21579465E-09_JPRB, 0.21216665E-09_JPRB, 0.20872656E-09_JPRB, &
  & 0.20538515E-09_JPRB, 0.20205079E-09_JPRB, 0.19866425E-09_JPRB, 0.19526419E-09_JPRB, 0.19197285E-09_JPRB, 0.18894072E-09_JPRB, &
  & 0.18623565E-09_JPRB, 0.18377574E-09_JPRB, 0.18126060E-09_JPRB, 0.17731874E-09_JPRB /)

RGHG5(:,40, 4) = (/ &
  & 0.17205237E-09_JPRB, 0.17731426E-09_JPRB, 0.18059301E-09_JPRB, 0.18357799E-09_JPRB, 0.18672805E-09_JPRB, 0.18981777E-09_JPRB, &
  & 0.19277213E-09_JPRB, 0.19560709E-09_JPRB, 0.19843477E-09_JPRB, 0.20139834E-09_JPRB, 0.20467783E-09_JPRB, 0.20839777E-09_JPRB, &
  & 0.21265122E-09_JPRB, 0.21741445E-09_JPRB, 0.22254162E-09_JPRB, 0.22781609E-09_JPRB, 0.23303282E-09_JPRB, 0.23804347E-09_JPRB, &
  & 0.24271302E-09_JPRB, 0.24693197E-09_JPRB, 0.25050595E-09_JPRB, 0.25331032E-09_JPRB, 0.25536517E-09_JPRB, 0.25679348E-09_JPRB, &
  & 0.25775582E-09_JPRB, 0.25840835E-09_JPRB, 0.25885802E-09_JPRB, 0.25916200E-09_JPRB, 0.25935096E-09_JPRB, 0.25942426E-09_JPRB, &
  & 0.25938765E-09_JPRB, 0.25922969E-09_JPRB, 0.25896091E-09_JPRB, 0.25859515E-09_JPRB, 0.25815189E-09_JPRB, 0.25764352E-09_JPRB, &
  & 0.25705940E-09_JPRB, 0.25637467E-09_JPRB, 0.25553418E-09_JPRB, 0.25446656E-09_JPRB, 0.25308380E-09_JPRB, 0.25132346E-09_JPRB, &
  & 0.24917382E-09_JPRB, 0.24670699E-09_JPRB, 0.24400187E-09_JPRB, 0.24113414E-09_JPRB, 0.23806587E-09_JPRB, 0.23474331E-09_JPRB, &
  & 0.23114434E-09_JPRB, 0.22733895E-09_JPRB, 0.22349514E-09_JPRB, 0.21981524E-09_JPRB, 0.21639382E-09_JPRB, 0.21320984E-09_JPRB, &
  & 0.21016155E-09_JPRB, 0.20714130E-09_JPRB, 0.20409191E-09_JPRB, 0.20103670E-09_JPRB, 0.19809851E-09_JPRB, 0.19539574E-09_JPRB, &
  & 0.19297118E-09_JPRB, 0.19073476E-09_JPRB, 0.18840403E-09_JPRB, 0.18467913E-09_JPRB /)

RGHG5(:,41, 4) = (/ &
  & 0.17992058E-09_JPRB, 0.18489286E-09_JPRB, 0.18790301E-09_JPRB, 0.19091342E-09_JPRB, 0.19398687E-09_JPRB, 0.19703833E-09_JPRB, &
  & 0.19984055E-09_JPRB, 0.20241880E-09_JPRB, 0.20491271E-09_JPRB, 0.20750586E-09_JPRB, 0.21035464E-09_JPRB, 0.21363461E-09_JPRB, &
  & 0.21744244E-09_JPRB, 0.22177771E-09_JPRB, 0.22650391E-09_JPRB, 0.23140595E-09_JPRB, 0.23627361E-09_JPRB, 0.24095323E-09_JPRB, &
  & 0.24530544E-09_JPRB, 0.24914604E-09_JPRB, 0.25233426E-09_JPRB, 0.25475433E-09_JPRB, 0.25647762E-09_JPRB, 0.25765490E-09_JPRB, &
  & 0.25844379E-09_JPRB, 0.25898089E-09_JPRB, 0.25935593E-09_JPRB, 0.25961666E-09_JPRB, 0.25978475E-09_JPRB, 0.25985561E-09_JPRB, &
  & 0.25982980E-09_JPRB, 0.25969407E-09_JPRB, 0.25945424E-09_JPRB, 0.25912567E-09_JPRB, 0.25872771E-09_JPRB, 0.25827113E-09_JPRB, &
  & 0.25775390E-09_JPRB, 0.25714997E-09_JPRB, 0.25641797E-09_JPRB, 0.25549474E-09_JPRB, 0.25430585E-09_JPRB, 0.25278649E-09_JPRB, &
  & 0.25092051E-09_JPRB, 0.24872990E-09_JPRB, 0.24631266E-09_JPRB, 0.24369776E-09_JPRB, 0.24087402E-09_JPRB, 0.23777086E-09_JPRB, &
  & 0.23434493E-09_JPRB, 0.23066332E-09_JPRB, 0.22693897E-09_JPRB, 0.22340323E-09_JPRB, 0.22018673E-09_JPRB, 0.21725044E-09_JPRB, &
  & 0.21448344E-09_JPRB, 0.21176788E-09_JPRB, 0.20903837E-09_JPRB, 0.20632512E-09_JPRB, 0.20373345E-09_JPRB, 0.20136601E-09_JPRB, &
  & 0.19923201E-09_JPRB, 0.19723553E-09_JPRB, 0.19510973E-09_JPRB, 0.19164756E-09_JPRB /)

RGHG5(:,42, 4) = (/ &
  & 0.18742834E-09_JPRB, 0.19203750E-09_JPRB, 0.19496198E-09_JPRB, 0.19783916E-09_JPRB, 0.20094147E-09_JPRB, 0.20392704E-09_JPRB, &
  & 0.20656582E-09_JPRB, 0.20889296E-09_JPRB, 0.21106644E-09_JPRB, 0.21327090E-09_JPRB, 0.21570605E-09_JPRB, 0.21853802E-09_JPRB, &
  & 0.22190441E-09_JPRB, 0.22581234E-09_JPRB, 0.23013608E-09_JPRB, 0.23466351E-09_JPRB, 0.23918353E-09_JPRB, 0.24352387E-09_JPRB, &
  & 0.24751373E-09_JPRB, 0.25097927E-09_JPRB, 0.25375960E-09_JPRB, 0.25583435E-09_JPRB, 0.25728453E-09_JPRB, 0.25827179E-09_JPRB, &
  & 0.25893593E-09_JPRB, 0.25939206E-09_JPRB, 0.25971747E-09_JPRB, 0.25994876E-09_JPRB, 0.26010380E-09_JPRB, 0.26017427E-09_JPRB, &
  & 0.26015715E-09_JPRB, 0.26003771E-09_JPRB, 0.25981983E-09_JPRB, 0.25951805E-09_JPRB, 0.25915098E-09_JPRB, 0.25873359E-09_JPRB, &
  & 0.25826216E-09_JPRB, 0.25772046E-09_JPRB, 0.25707178E-09_JPRB, 0.25626684E-09_JPRB, 0.25524505E-09_JPRB, 0.25395391E-09_JPRB, &
  & 0.25236147E-09_JPRB, 0.25047836E-09_JPRB, 0.24833591E-09_JPRB, 0.24599492E-09_JPRB, 0.24341040E-09_JPRB, 0.24051180E-09_JPRB, &
  & 0.23725516E-09_JPRB, 0.23371116E-09_JPRB, 0.23010155E-09_JPRB, 0.22672859E-09_JPRB, 0.22371550E-09_JPRB, 0.22102624E-09_JPRB, &
  & 0.21852543E-09_JPRB, 0.21609362E-09_JPRB, 0.21366346E-09_JPRB, 0.21126491E-09_JPRB, 0.20900159E-09_JPRB, 0.20694879E-09_JPRB, &
  & 0.20509636E-09_JPRB, 0.20333754E-09_JPRB, 0.20142731E-09_JPRB, 0.19824474E-09_JPRB /)

RGHG5(:,43, 4) = (/ &
  & 0.19459952E-09_JPRB, 0.19891219E-09_JPRB, 0.20168871E-09_JPRB, 0.20451030E-09_JPRB, 0.20757485E-09_JPRB, 0.21048792E-09_JPRB, &
  & 0.21297442E-09_JPRB, 0.21504329E-09_JPRB, 0.21690823E-09_JPRB, 0.21875365E-09_JPRB, 0.22077817E-09_JPRB, 0.22317630E-09_JPRB, &
  & 0.22609950E-09_JPRB, 0.22959221E-09_JPRB, 0.23352917E-09_JPRB, 0.23769217E-09_JPRB, 0.24186222E-09_JPRB, 0.24585251E-09_JPRB, &
  & 0.24946484E-09_JPRB, 0.25251937E-09_JPRB, 0.25491609E-09_JPRB, 0.25667549E-09_JPRB, 0.25790331E-09_JPRB, 0.25874278E-09_JPRB, &
  & 0.25931327E-09_JPRB, 0.25971214E-09_JPRB, 0.26000119E-09_JPRB, 0.26021277E-09_JPRB, 0.26035868E-09_JPRB, 0.26042959E-09_JPRB, &
  & 0.26041941E-09_JPRB, 0.26031324E-09_JPRB, 0.26011246E-09_JPRB, 0.25983121E-09_JPRB, 0.25948824E-09_JPRB, 0.25909747E-09_JPRB, &
  & 0.25866168E-09_JPRB, 0.25816621E-09_JPRB, 0.25758409E-09_JPRB, 0.25687713E-09_JPRB, 0.25600064E-09_JPRB, 0.25491628E-09_JPRB, &
  & 0.25359873E-09_JPRB, 0.25201946E-09_JPRB, 0.25019636E-09_JPRB, 0.24811575E-09_JPRB, 0.24577387E-09_JPRB, 0.24308411E-09_JPRB, &
  & 0.24000102E-09_JPRB, 0.23659599E-09_JPRB, 0.23314028E-09_JPRB, 0.22994065E-09_JPRB, 0.22714927E-09_JPRB, 0.22469984E-09_JPRB, &
  & 0.22245331E-09_JPRB, 0.22027959E-09_JPRB, 0.21811863E-09_JPRB, 0.21600360E-09_JPRB, 0.21403183E-09_JPRB, 0.21226237E-09_JPRB, &
  & 0.21066526E-09_JPRB, 0.20913089E-09_JPRB, 0.20742970E-09_JPRB, 0.20453730E-09_JPRB /)

RGHG5(:,44, 4) = (/ &
  & 0.20144345E-09_JPRB, 0.20554397E-09_JPRB, 0.20816088E-09_JPRB, 0.21091956E-09_JPRB, 0.21391125E-09_JPRB, 0.21676154E-09_JPRB, &
  & 0.21905540E-09_JPRB, 0.22090399E-09_JPRB, 0.22247050E-09_JPRB, 0.22399271E-09_JPRB, 0.22564234E-09_JPRB, 0.22762812E-09_JPRB, &
  & 0.23013007E-09_JPRB, 0.23322008E-09_JPRB, 0.23678737E-09_JPRB, 0.24059857E-09_JPRB, 0.24442146E-09_JPRB, 0.24802424E-09_JPRB, &
  & 0.25122535E-09_JPRB, 0.25384977E-09_JPRB, 0.25587449E-09_JPRB, 0.25735347E-09_JPRB, 0.25839614E-09_JPRB, 0.25911778E-09_JPRB, &
  & 0.25961785E-09_JPRB, 0.25997349E-09_JPRB, 0.26023700E-09_JPRB, 0.26043429E-09_JPRB, 0.26057420E-09_JPRB, 0.26064567E-09_JPRB, &
  & 0.26064118E-09_JPRB, 0.26054581E-09_JPRB, 0.26035929E-09_JPRB, 0.26009517E-09_JPRB, 0.25976951E-09_JPRB, 0.25939947E-09_JPRB, &
  & 0.25898869E-09_JPRB, 0.25852909E-09_JPRB, 0.25800012E-09_JPRB, 0.25737459E-09_JPRB, 0.25662455E-09_JPRB, 0.25572960E-09_JPRB, &
  & 0.25466818E-09_JPRB, 0.25341643E-09_JPRB, 0.25191557E-09_JPRB, 0.25015801E-09_JPRB, 0.24806637E-09_JPRB, 0.24559102E-09_JPRB, &
  & 0.24268806E-09_JPRB, 0.23945113E-09_JPRB, 0.23616240E-09_JPRB, 0.23317379E-09_JPRB, 0.23061229E-09_JPRB, 0.22840239E-09_JPRB, &
  & 0.22638851E-09_JPRB, 0.22445057E-09_JPRB, 0.22252719E-09_JPRB, 0.22065856E-09_JPRB, 0.21893806E-09_JPRB, 0.21741146E-09_JPRB, &
  & 0.21603708E-09_JPRB, 0.21470602E-09_JPRB, 0.21320522E-09_JPRB, 0.21060539E-09_JPRB /)

RGHG5(:,45, 4) = (/ &
  & 0.20801331E-09_JPRB, 0.21185791E-09_JPRB, 0.21440293E-09_JPRB, 0.21703588E-09_JPRB, 0.21999270E-09_JPRB, 0.22271762E-09_JPRB, &
  & 0.22485988E-09_JPRB, 0.22646632E-09_JPRB, 0.22779498E-09_JPRB, 0.22902273E-09_JPRB, 0.23035904E-09_JPRB, 0.23197097E-09_JPRB, &
  & 0.23407742E-09_JPRB, 0.23678795E-09_JPRB, 0.24000407E-09_JPRB, 0.24347735E-09_JPRB, 0.24691274E-09_JPRB, 0.25010655E-09_JPRB, &
  & 0.25281879E-09_JPRB, 0.25500849E-09_JPRB, 0.25667296E-09_JPRB, 0.25790861E-09_JPRB, 0.25879524E-09_JPRB, 0.25942465E-09_JPRB, &
  & 0.25986924E-09_JPRB, 0.26019353E-09_JPRB, 0.26043867E-09_JPRB, 0.26062638E-09_JPRB, 0.26076219E-09_JPRB, 0.26083435E-09_JPRB, &
  & 0.26083424E-09_JPRB, 0.26074751E-09_JPRB, 0.26057376E-09_JPRB, 0.26032301E-09_JPRB, 0.26001157E-09_JPRB, 0.25965533E-09_JPRB, &
  & 0.25926317E-09_JPRB, 0.25883015E-09_JPRB, 0.25834360E-09_JPRB, 0.25778651E-09_JPRB, 0.25714569E-09_JPRB, 0.25641628E-09_JPRB, &
  & 0.25559801E-09_JPRB, 0.25464778E-09_JPRB, 0.25352195E-09_JPRB, 0.25209904E-09_JPRB, 0.25032787E-09_JPRB, 0.24810129E-09_JPRB, &
  & 0.24540167E-09_JPRB, 0.24234464E-09_JPRB, 0.23926058E-09_JPRB, 0.23649971E-09_JPRB, 0.23418090E-09_JPRB, 0.23219504E-09_JPRB, &
  & 0.23040533E-09_JPRB, 0.22867441E-09_JPRB, 0.22696181E-09_JPRB, 0.22530430E-09_JPRB, 0.22379612E-09_JPRB, 0.22247276E-09_JPRB, &
  & 0.22128913E-09_JPRB, 0.22013626E-09_JPRB, 0.21882557E-09_JPRB, 0.21651672E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART7',1,ZHOOK_HANDLE)
END SUBROUTINE PART7




SUBROUTINE PART8
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART8',0,ZHOOK_HANDLE)



RGHG5(:,46, 4) = (/ &
  & 0.21423430E-09_JPRB, 0.21789395E-09_JPRB, 0.22032999E-09_JPRB, 0.22290164E-09_JPRB, 0.22576335E-09_JPRB, 0.22838532E-09_JPRB, &
  & 0.23034256E-09_JPRB, 0.23175917E-09_JPRB, 0.23286167E-09_JPRB, 0.23387672E-09_JPRB, 0.23493879E-09_JPRB, 0.23626218E-09_JPRB, &
  & 0.23801627E-09_JPRB, 0.24037025E-09_JPRB, 0.24325927E-09_JPRB, 0.24635730E-09_JPRB, 0.24938931E-09_JPRB, 0.25204797E-09_JPRB, &
  & 0.25426586E-09_JPRB, 0.25599442E-09_JPRB, 0.25734181E-09_JPRB, 0.25836228E-09_JPRB, 0.25912281E-09_JPRB, 0.25967742E-09_JPRB, &
  & 0.26008046E-09_JPRB, 0.26038183E-09_JPRB, 0.26061381E-09_JPRB, 0.26079586E-09_JPRB, 0.26092928E-09_JPRB, 0.26100191E-09_JPRB, &
  & 0.26100519E-09_JPRB, 0.26092586E-09_JPRB, 0.26076202E-09_JPRB, 0.26052338E-09_JPRB, 0.26022176E-09_JPRB, 0.25987601E-09_JPRB, &
  & 0.25949609E-09_JPRB, 0.25908362E-09_JPRB, 0.25863092E-09_JPRB, 0.25813099E-09_JPRB, 0.25758251E-09_JPRB, 0.25699859E-09_JPRB, &
  & 0.25638211E-09_JPRB, 0.25572011E-09_JPRB, 0.25492497E-09_JPRB, 0.25390653E-09_JPRB, 0.25249938E-09_JPRB, 0.25060809E-09_JPRB, &
  & 0.24816976E-09_JPRB, 0.24533028E-09_JPRB, 0.24246344E-09_JPRB, 0.23994989E-09_JPRB, 0.23786187E-09_JPRB, 0.23610908E-09_JPRB, &
  & 0.23450888E-09_JPRB, 0.23297581E-09_JPRB, 0.23144389E-09_JPRB, 0.22997020E-09_JPRB, 0.22863941E-09_JPRB, 0.22748678E-09_JPRB, &
  & 0.22646135E-09_JPRB, 0.22546755E-09_JPRB, 0.22432629E-09_JPRB, 0.22231050E-09_JPRB /)

RGHG5(:,47, 4) = (/ &
  & 0.22003172E-09_JPRB, 0.22361805E-09_JPRB, 0.22592514E-09_JPRB, 0.22846397E-09_JPRB, 0.23122115E-09_JPRB, 0.23372407E-09_JPRB, &
  & 0.23551777E-09_JPRB, 0.23675084E-09_JPRB, 0.23769609E-09_JPRB, 0.23851990E-09_JPRB, 0.23940755E-09_JPRB, 0.24047370E-09_JPRB, &
  & 0.24196273E-09_JPRB, 0.24400792E-09_JPRB, 0.24653499E-09_JPRB, 0.24924762E-09_JPRB, 0.25172608E-09_JPRB, 0.25383612E-09_JPRB, &
  & 0.25549848E-09_JPRB, 0.25683061E-09_JPRB, 0.25788779E-09_JPRB, 0.25873426E-09_JPRB, 0.25939073E-09_JPRB, 0.25988794E-09_JPRB, &
  & 0.26025954E-09_JPRB, 0.26054398E-09_JPRB, 0.26076813E-09_JPRB, 0.26094685E-09_JPRB, 0.26107899E-09_JPRB, 0.26115246E-09_JPRB, &
  & 0.26115826E-09_JPRB, 0.26108429E-09_JPRB, 0.26092958E-09_JPRB, 0.26069968E-09_JPRB, 0.26040622E-09_JPRB, 0.26006752E-09_JPRB, &
  & 0.25969660E-09_JPRB, 0.25929936E-09_JPRB, 0.25887445E-09_JPRB, 0.25842189E-09_JPRB, 0.25795202E-09_JPRB, 0.25748395E-09_JPRB, &
  & 0.25703970E-09_JPRB, 0.25659447E-09_JPRB, 0.25609898E-09_JPRB, 0.25542377E-09_JPRB, 0.25443800E-09_JPRB, 0.25296584E-09_JPRB, &
  & 0.25090929E-09_JPRB, 0.24836427E-09_JPRB, 0.24576446E-09_JPRB, 0.24350361E-09_JPRB, 0.24166733E-09_JPRB, 0.24010693E-09_JPRB, &
  & 0.23870822E-09_JPRB, 0.23733382E-09_JPRB, 0.23596974E-09_JPRB, 0.23464933E-09_JPRB, 0.23347027E-09_JPRB, 0.23245793E-09_JPRB, &
  & 0.23156800E-09_JPRB, 0.23070443E-09_JPRB, 0.22971930E-09_JPRB, 0.22796418E-09_JPRB /)

RGHG5(:,48, 4) = (/ &
  & 0.22549333E-09_JPRB, 0.22887976E-09_JPRB, 0.23125213E-09_JPRB, 0.23365127E-09_JPRB, 0.23639654E-09_JPRB, 0.23874663E-09_JPRB, &
  & 0.24039787E-09_JPRB, 0.24149488E-09_JPRB, 0.24229882E-09_JPRB, 0.24300723E-09_JPRB, 0.24372934E-09_JPRB, 0.24464475E-09_JPRB, &
  & 0.24587962E-09_JPRB, 0.24762428E-09_JPRB, 0.24977900E-09_JPRB, 0.25193272E-09_JPRB, 0.25382318E-09_JPRB, 0.25532415E-09_JPRB, &
  & 0.25652652E-09_JPRB, 0.25750210E-09_JPRB, 0.25833366E-09_JPRB, 0.25903471E-09_JPRB, 0.25961092E-09_JPRB, 0.26006403E-09_JPRB, &
  & 0.26041305E-09_JPRB, 0.26068650E-09_JPRB, 0.26090499E-09_JPRB, 0.26108254E-09_JPRB, 0.26121416E-09_JPRB, 0.26128824E-09_JPRB, &
  & 0.26129601E-09_JPRB, 0.26122668E-09_JPRB, 0.26107858E-09_JPRB, 0.26085609E-09_JPRB, 0.26056923E-09_JPRB, 0.26023528E-09_JPRB, &
  & 0.25987162E-09_JPRB, 0.25948652E-09_JPRB, 0.25908403E-09_JPRB, 0.25867120E-09_JPRB, 0.25826408E-09_JPRB, 0.25789246E-09_JPRB, &
  & 0.25757246E-09_JPRB, 0.25729721E-09_JPRB, 0.25700375E-09_JPRB, 0.25660901E-09_JPRB, 0.25597574E-09_JPRB, 0.25495844E-09_JPRB, &
  & 0.25338837E-09_JPRB, 0.25130739E-09_JPRB, 0.24909361E-09_JPRB, 0.24714908E-09_JPRB, 0.24555788E-09_JPRB, 0.24421296E-09_JPRB, &
  & 0.24297092E-09_JPRB, 0.24175736E-09_JPRB, 0.24052454E-09_JPRB, 0.23933822E-09_JPRB, 0.23828081E-09_JPRB, 0.23738631E-09_JPRB, &
  & 0.23660168E-09_JPRB, 0.23584831E-09_JPRB, 0.23498434E-09_JPRB, 0.23345528E-09_JPRB /)

RGHG5(:,49, 4) = (/ &
  & 0.23048752E-09_JPRB, 0.23390129E-09_JPRB, 0.23615698E-09_JPRB, 0.23862162E-09_JPRB, 0.24123886E-09_JPRB, 0.24350846E-09_JPRB, &
  & 0.24502123E-09_JPRB, 0.24600169E-09_JPRB, 0.24670643E-09_JPRB, 0.24730107E-09_JPRB, 0.24791919E-09_JPRB, 0.24864705E-09_JPRB, &
  & 0.24967936E-09_JPRB, 0.25104571E-09_JPRB, 0.25266569E-09_JPRB, 0.25421273E-09_JPRB, 0.25548566E-09_JPRB, 0.25649827E-09_JPRB, &
  & 0.25732194E-09_JPRB, 0.25803876E-09_JPRB, 0.25868721E-09_JPRB, 0.25927832E-09_JPRB, 0.25979138E-09_JPRB, 0.26021321E-09_JPRB, &
  & 0.26054742E-09_JPRB, 0.26081332E-09_JPRB, 0.26102914E-09_JPRB, 0.26120567E-09_JPRB, 0.26133654E-09_JPRB, 0.26141161E-09_JPRB, &
  & 0.26142075E-09_JPRB, 0.26135494E-09_JPRB, 0.26121239E-09_JPRB, 0.26099592E-09_JPRB, 0.26071378E-09_JPRB, 0.26038552E-09_JPRB, &
  & 0.26002711E-09_JPRB, 0.25965224E-09_JPRB, 0.25926808E-09_JPRB, 0.25888675E-09_JPRB, 0.25853167E-09_JPRB, 0.25823282E-09_JPRB, &
  & 0.25801072E-09_JPRB, 0.25784544E-09_JPRB, 0.25769234E-09_JPRB, 0.25746999E-09_JPRB, 0.25709715E-09_JPRB, 0.25644309E-09_JPRB, &
  & 0.25538460E-09_JPRB, 0.25389790E-09_JPRB, 0.25223207E-09_JPRB, 0.25073701E-09_JPRB, 0.24945102E-09_JPRB, 0.24833455E-09_JPRB, &
  & 0.24726976E-09_JPRB, 0.24619462E-09_JPRB, 0.24508867E-09_JPRB, 0.24401098E-09_JPRB, 0.24305696E-09_JPRB, 0.24225202E-09_JPRB, &
  & 0.24155375E-09_JPRB, 0.24088243E-09_JPRB, 0.24011110E-09_JPRB, 0.23875379E-09_JPRB /)

RGHG5(:,50, 4) = (/ &
  & 0.23508617E-09_JPRB, 0.23855648E-09_JPRB, 0.24079477E-09_JPRB, 0.24324115E-09_JPRB, 0.24581220E-09_JPRB, 0.24794050E-09_JPRB, &
  & 0.24931004E-09_JPRB, 0.25015967E-09_JPRB, 0.25074898E-09_JPRB, 0.25122726E-09_JPRB, 0.25169275E-09_JPRB, 0.25225375E-09_JPRB, &
  & 0.25294075E-09_JPRB, 0.25389041E-09_JPRB, 0.25492139E-09_JPRB, 0.25589647E-09_JPRB, 0.25669999E-09_JPRB, 0.25736024E-09_JPRB, &
  & 0.25792810E-09_JPRB, 0.25845553E-09_JPRB, 0.25897165E-09_JPRB, 0.25947353E-09_JPRB, 0.25994112E-09_JPRB, 0.26034164E-09_JPRB, &
  & 0.26066743E-09_JPRB, 0.26092956E-09_JPRB, 0.26114397E-09_JPRB, 0.26131883E-09_JPRB, 0.26144881E-09_JPRB, 0.26152414E-09_JPRB, &
  & 0.26153435E-09_JPRB, 0.26147165E-09_JPRB, 0.26133357E-09_JPRB, 0.26112176E-09_JPRB, 0.26084512E-09_JPRB, 0.26052085E-09_JPRB, &
  & 0.26016847E-09_JPRB, 0.25980168E-09_JPRB, 0.25943198E-09_JPRB, 0.25907626E-09_JPRB, 0.25876237E-09_JPRB, 0.25852348E-09_JPRB, &
  & 0.25837157E-09_JPRB, 0.25828473E-09_JPRB, 0.25821167E-09_JPRB, 0.25809982E-09_JPRB, 0.25787919E-09_JPRB, 0.25748495E-09_JPRB, &
  & 0.25682176E-09_JPRB, 0.25587751E-09_JPRB, 0.25485317E-09_JPRB, 0.25386454E-09_JPRB, 0.25300459E-09_JPRB, 0.25217453E-09_JPRB, &
  & 0.25135549E-09_JPRB, 0.25046892E-09_JPRB, 0.24952143E-09_JPRB, 0.24856811E-09_JPRB, 0.24771463E-09_JPRB, 0.24699581E-09_JPRB, &
  & 0.24636804E-09_JPRB, 0.24575850E-09_JPRB, 0.24506419E-09_JPRB, 0.24381669E-09_JPRB /)

RGHG5(:,51, 4) = (/ &
  & 0.23949703E-09_JPRB, 0.24271796E-09_JPRB, 0.24517699E-09_JPRB, 0.24744262E-09_JPRB, 0.24994648E-09_JPRB, 0.25181338E-09_JPRB, &
  & 0.25294050E-09_JPRB, 0.25359342E-09_JPRB, 0.25401026E-09_JPRB, 0.25433397E-09_JPRB, 0.25463237E-09_JPRB, 0.25494531E-09_JPRB, &
  & 0.25537328E-09_JPRB, 0.25586805E-09_JPRB, 0.25647712E-09_JPRB, 0.25704555E-09_JPRB, 0.25754909E-09_JPRB, 0.25798436E-09_JPRB, &
  & 0.25838676E-09_JPRB, 0.25878477E-09_JPRB, 0.25919983E-09_JPRB, 0.25963762E-09_JPRB, 0.26006713E-09_JPRB, 0.26045543E-09_JPRB, &
  & 0.26077762E-09_JPRB, 0.26103925E-09_JPRB, 0.26125213E-09_JPRB, 0.26142497E-09_JPRB, 0.26155311E-09_JPRB, 0.26162786E-09_JPRB, &
  & 0.26163871E-09_JPRB, 0.26157845E-09_JPRB, 0.26144403E-09_JPRB, 0.26123648E-09_JPRB, 0.26096458E-09_JPRB, 0.26064542E-09_JPRB, &
  & 0.26029823E-09_JPRB, 0.25993829E-09_JPRB, 0.25958027E-09_JPRB, 0.25924538E-09_JPRB, 0.25896607E-09_JPRB, 0.25877633E-09_JPRB, &
  & 0.25867955E-09_JPRB, 0.25864283E-09_JPRB, 0.25862157E-09_JPRB, 0.25856867E-09_JPRB, 0.25844757E-09_JPRB, 0.25820654E-09_JPRB, &
  & 0.25780508E-09_JPRB, 0.25727642E-09_JPRB, 0.25669961E-09_JPRB, 0.25619201E-09_JPRB, 0.25570368E-09_JPRB, 0.25523572E-09_JPRB, &
  & 0.25471653E-09_JPRB, 0.25412319E-09_JPRB, 0.25342528E-09_JPRB, 0.25268299E-09_JPRB, 0.25198579E-09_JPRB, 0.25137850E-09_JPRB, &
  & 0.25083904E-09_JPRB, 0.25030977E-09_JPRB, 0.24967153E-09_JPRB, 0.24855715E-09_JPRB /)

RGHG5(:,52, 4) = (/ &
  & 0.24322624E-09_JPRB, 0.24687244E-09_JPRB, 0.24884625E-09_JPRB, 0.25124583E-09_JPRB, 0.25327834E-09_JPRB, 0.25476515E-09_JPRB, &
  & 0.25554150E-09_JPRB, 0.25595231E-09_JPRB, 0.25620317E-09_JPRB, 0.25637870E-09_JPRB, 0.25653130E-09_JPRB, 0.25670055E-09_JPRB, &
  & 0.25688560E-09_JPRB, 0.25716676E-09_JPRB, 0.25747976E-09_JPRB, 0.25782410E-09_JPRB, 0.25814356E-09_JPRB, 0.25844482E-09_JPRB, &
  & 0.25873914E-09_JPRB, 0.25904964E-09_JPRB, 0.25939428E-09_JPRB, 0.25977606E-09_JPRB, 0.26018093E-09_JPRB, 0.26055993E-09_JPRB, &
  & 0.26088165E-09_JPRB, 0.26114366E-09_JPRB, 0.26135538E-09_JPRB, 0.26152569E-09_JPRB, 0.26165092E-09_JPRB, 0.26172436E-09_JPRB, &
  & 0.26173511E-09_JPRB, 0.26167674E-09_JPRB, 0.26154537E-09_JPRB, 0.26134175E-09_JPRB, 0.26107475E-09_JPRB, 0.26076072E-09_JPRB, &
  & 0.26041835E-09_JPRB, 0.26006461E-09_JPRB, 0.25971683E-09_JPRB, 0.25940003E-09_JPRB, 0.25915198E-09_JPRB, 0.25900262E-09_JPRB, &
  & 0.25894725E-09_JPRB, 0.25894598E-09_JPRB, 0.25895569E-09_JPRB, 0.25894156E-09_JPRB, 0.25887445E-09_JPRB, 0.25873265E-09_JPRB, &
  & 0.25849500E-09_JPRB, 0.25819502E-09_JPRB, 0.25791752E-09_JPRB, 0.25766600E-09_JPRB, 0.25744618E-09_JPRB, 0.25722019E-09_JPRB, &
  & 0.25696700E-09_JPRB, 0.25665275E-09_JPRB, 0.25625319E-09_JPRB, 0.25578523E-09_JPRB, 0.25531696E-09_JPRB, 0.25489397E-09_JPRB, &
  & 0.25449906E-09_JPRB, 0.25408620E-09_JPRB, 0.25359187E-09_JPRB, 0.25261182E-09_JPRB /)

RGHG5(:,53, 4) = (/ &
  & 0.24696578E-09_JPRB, 0.24995514E-09_JPRB, 0.25230718E-09_JPRB, 0.25402275E-09_JPRB, 0.25571609E-09_JPRB, 0.25667951E-09_JPRB, &
  & 0.25715208E-09_JPRB, 0.25738417E-09_JPRB, 0.25751393E-09_JPRB, 0.25760491E-09_JPRB, 0.25768010E-09_JPRB, 0.25775188E-09_JPRB, &
  & 0.25785421E-09_JPRB, 0.25797567E-09_JPRB, 0.25816163E-09_JPRB, 0.25836494E-09_JPRB, 0.25857938E-09_JPRB, 0.25879449E-09_JPRB, &
  & 0.25902058E-09_JPRB, 0.25927105E-09_JPRB, 0.25956254E-09_JPRB, 0.25990810E-09_JPRB, 0.26028682E-09_JPRB, 0.26065999E-09_JPRB, &
  & 0.26098187E-09_JPRB, 0.26124375E-09_JPRB, 0.26145430E-09_JPRB, 0.26162134E-09_JPRB, 0.26174374E-09_JPRB, 0.26181463E-09_JPRB, &
  & 0.26182473E-09_JPRB, 0.26176750E-09_JPRB, 0.26163871E-09_JPRB, 0.26143876E-09_JPRB, 0.26117661E-09_JPRB, 0.26086749E-09_JPRB, &
  & 0.26053035E-09_JPRB, 0.26018249E-09_JPRB, 0.25984498E-09_JPRB, 0.25954661E-09_JPRB, 0.25932517E-09_JPRB, 0.25921007E-09_JPRB, &
  & 0.25918601E-09_JPRB, 0.25920999E-09_JPRB, 0.25924027E-09_JPRB, 0.25925007E-09_JPRB, 0.25922009E-09_JPRB, 0.25913385E-09_JPRB, &
  & 0.25899033E-09_JPRB, 0.25883315E-09_JPRB, 0.25868940E-09_JPRB, 0.25857810E-09_JPRB, 0.25847890E-09_JPRB, 0.25837971E-09_JPRB, &
  & 0.25826713E-09_JPRB, 0.25811839E-09_JPRB, 0.25792141E-09_JPRB, 0.25767549E-09_JPRB, 0.25741984E-09_JPRB, 0.25717667E-09_JPRB, &
  & 0.25694644E-09_JPRB, 0.25670061E-09_JPRB, 0.25636271E-09_JPRB, 0.25570016E-09_JPRB /)

RGHG5(:,54, 4) = (/ &
  & 0.24977351E-09_JPRB, 0.25307906E-09_JPRB, 0.25459296E-09_JPRB, 0.25618030E-09_JPRB, 0.25723532E-09_JPRB, 0.25785299E-09_JPRB, &
  & 0.25811936E-09_JPRB, 0.25824448E-09_JPRB, 0.25831409E-09_JPRB, 0.25835942E-09_JPRB, 0.25839531E-09_JPRB, 0.25843289E-09_JPRB, &
  & 0.25847263E-09_JPRB, 0.25854410E-09_JPRB, 0.25863794E-09_JPRB, 0.25876812E-09_JPRB, 0.25891361E-09_JPRB, 0.25907404E-09_JPRB, &
  & 0.25925309E-09_JPRB, 0.25946317E-09_JPRB, 0.25972002E-09_JPRB, 0.26003288E-09_JPRB, 0.26039620E-09_JPRB, 0.26075889E-09_JPRB, &
  & 0.26107830E-09_JPRB, 0.26133914E-09_JPRB, 0.26154806E-09_JPRB, 0.26171276E-09_JPRB, 0.26183120E-09_JPRB, 0.26189972E-09_JPRB, &
  & 0.26190847E-09_JPRB, 0.26185143E-09_JPRB, 0.26172481E-09_JPRB, 0.26152835E-09_JPRB, 0.26127123E-09_JPRB, 0.26096741E-09_JPRB, &
  & 0.26063504E-09_JPRB, 0.26029423E-09_JPRB, 0.25996824E-09_JPRB, 0.25968794E-09_JPRB, 0.25949223E-09_JPRB, 0.25940311E-09_JPRB, &
  & 0.25940247E-09_JPRB, 0.25944435E-09_JPRB, 0.25949187E-09_JPRB, 0.25951799E-09_JPRB, 0.25950975E-09_JPRB, 0.25945945E-09_JPRB, &
  & 0.25937352E-09_JPRB, 0.25928323E-09_JPRB, 0.25921343E-09_JPRB, 0.25915992E-09_JPRB, 0.25911409E-09_JPRB, 0.25907032E-09_JPRB, &
  & 0.25901717E-09_JPRB, 0.25894958E-09_JPRB, 0.25885263E-09_JPRB, 0.25873012E-09_JPRB, 0.25859825E-09_JPRB, 0.25847841E-09_JPRB, &
  & 0.25836289E-09_JPRB, 0.25823976E-09_JPRB, 0.25808861E-09_JPRB, 0.25777552E-09_JPRB /)

RGHG5(:,55, 4) = (/ &
  & 0.25252628E-09_JPRB, 0.25502928E-09_JPRB, 0.25654120E-09_JPRB, 0.25748798E-09_JPRB, 0.25822236E-09_JPRB, 0.25858027E-09_JPRB, &
  & 0.25873437E-09_JPRB, 0.25880462E-09_JPRB, 0.25884156E-09_JPRB, 0.25886576E-09_JPRB, 0.25888458E-09_JPRB, 0.25890093E-09_JPRB, &
  & 0.25892355E-09_JPRB, 0.25895225E-09_JPRB, 0.25900837E-09_JPRB, 0.25908564E-09_JPRB, 0.25918664E-09_JPRB, 0.25930791E-09_JPRB, &
  & 0.25945471E-09_JPRB, 0.25963645E-09_JPRB, 0.25986838E-09_JPRB, 0.26016311E-09_JPRB, 0.26050648E-09_JPRB, 0.26085928E-09_JPRB, &
  & 0.26117178E-09_JPRB, 0.26142993E-09_JPRB, 0.26163771E-09_JPRB, 0.26179905E-09_JPRB, 0.26191493E-09_JPRB, 0.26198008E-09_JPRB, &
  & 0.26198690E-09_JPRB, 0.26192951E-09_JPRB, 0.26180444E-09_JPRB, 0.26161198E-09_JPRB, 0.26135946E-09_JPRB, 0.26106128E-09_JPRB, &
  & 0.26073485E-09_JPRB, 0.26040170E-09_JPRB, 0.26008887E-09_JPRB, 0.25982808E-09_JPRB, 0.25965396E-09_JPRB, 0.25958569E-09_JPRB, &
  & 0.25960153E-09_JPRB, 0.25965885E-09_JPRB, 0.25971794E-09_JPRB, 0.25975808E-09_JPRB, 0.25976465E-09_JPRB, 0.25973493E-09_JPRB, &
  & 0.25967989E-09_JPRB, 0.25962965E-09_JPRB, 0.25959071E-09_JPRB, 0.25956332E-09_JPRB, 0.25954078E-09_JPRB, 0.25951818E-09_JPRB, &
  & 0.25949293E-09_JPRB, 0.25945784E-09_JPRB, 0.25940958E-09_JPRB, 0.25934560E-09_JPRB, 0.25927863E-09_JPRB, 0.25921487E-09_JPRB, &
  & 0.25915708E-09_JPRB, 0.25909430E-09_JPRB, 0.25900368E-09_JPRB, 0.25879582E-09_JPRB /)

RGHG5(:,56, 4) = (/ &
  & 0.25460944E-09_JPRB, 0.25681410E-09_JPRB, 0.25771843E-09_JPRB, 0.25841412E-09_JPRB, 0.25885208E-09_JPRB, 0.25907224E-09_JPRB, &
  & 0.25916447E-09_JPRB, 0.25920455E-09_JPRB, 0.25922633E-09_JPRB, 0.25923991E-09_JPRB, 0.25924987E-09_JPRB, 0.25925911E-09_JPRB, &
  & 0.25926775E-09_JPRB, 0.25928348E-09_JPRB, 0.25930877E-09_JPRB, 0.25935543E-09_JPRB, 0.25942268E-09_JPRB, 0.25951483E-09_JPRB, &
  & 0.25963651E-09_JPRB, 0.25979893E-09_JPRB, 0.26001418E-09_JPRB, 0.26029248E-09_JPRB, 0.26062227E-09_JPRB, 0.26095925E-09_JPRB, &
  & 0.26126321E-09_JPRB, 0.26151770E-09_JPRB, 0.26172314E-09_JPRB, 0.26188277E-09_JPRB, 0.26199476E-09_JPRB, 0.26205682E-09_JPRB, &
  & 0.26206123E-09_JPRB, 0.26200281E-09_JPRB, 0.26187896E-09_JPRB, 0.26169014E-09_JPRB, 0.26144320E-09_JPRB, 0.26115085E-09_JPRB, &
  & 0.26083100E-09_JPRB, 0.26050762E-09_JPRB, 0.26020905E-09_JPRB, 0.25996685E-09_JPRB, 0.25981303E-09_JPRB, 0.25976071E-09_JPRB, &
  & 0.25978864E-09_JPRB, 0.25985633E-09_JPRB, 0.25992766E-09_JPRB, 0.25997715E-09_JPRB, 0.25999430E-09_JPRB, 0.25997726E-09_JPRB, &
  & 0.25994143E-09_JPRB, 0.25990823E-09_JPRB, 0.25988534E-09_JPRB, 0.25986913E-09_JPRB, 0.25985550E-09_JPRB, 0.25984315E-09_JPRB, &
  & 0.25982808E-09_JPRB, 0.25980923E-09_JPRB, 0.25978164E-09_JPRB, 0.25974634E-09_JPRB, 0.25970825E-09_JPRB, 0.25967598E-09_JPRB, &
  & 0.25964672E-09_JPRB, 0.25961952E-09_JPRB, 0.25959271E-09_JPRB, 0.25956046E-09_JPRB /)

RGHG5(:,57, 4) = (/ &
  & 0.25632901E-09_JPRB, 0.25793145E-09_JPRB, 0.25859553E-09_JPRB, 0.25902291E-09_JPRB, 0.25929495E-09_JPRB, 0.25943436E-09_JPRB, &
  & 0.25949090E-09_JPRB, 0.25951713E-09_JPRB, 0.25953031E-09_JPRB, 0.25953886E-09_JPRB, 0.25954519E-09_JPRB, 0.25954999E-09_JPRB, &
  & 0.25955499E-09_JPRB, 0.25956029E-09_JPRB, 0.25957239E-09_JPRB, 0.25959584E-09_JPRB, 0.25963837E-09_JPRB, 0.25970640E-09_JPRB, &
  & 0.25980854E-09_JPRB, 0.25995461E-09_JPRB, 0.26015809E-09_JPRB, 0.26042410E-09_JPRB, 0.26073738E-09_JPRB, 0.26105990E-09_JPRB, &
  & 0.26135383E-09_JPRB, 0.26160368E-09_JPRB, 0.26180733E-09_JPRB, 0.26196367E-09_JPRB, 0.26207253E-09_JPRB, 0.26213060E-09_JPRB, &
  & 0.26213229E-09_JPRB, 0.26207261E-09_JPRB, 0.26194957E-09_JPRB, 0.26176447E-09_JPRB, 0.26152300E-09_JPRB, 0.26123745E-09_JPRB, &
  & 0.26092625E-09_JPRB, 0.26061336E-09_JPRB, 0.26033023E-09_JPRB, 0.26010624E-09_JPRB, 0.25996935E-09_JPRB, 0.25993036E-09_JPRB, &
  & 0.25996741E-09_JPRB, 0.26004313E-09_JPRB, 0.26012240E-09_JPRB, 0.26018113E-09_JPRB, 0.26020569E-09_JPRB, 0.26019664E-09_JPRB, &
  & 0.26016975E-09_JPRB, 0.26014668E-09_JPRB, 0.26012942E-09_JPRB, 0.26011737E-09_JPRB, 0.26010755E-09_JPRB, 0.26009800E-09_JPRB, &
  & 0.26008773E-09_JPRB, 0.26007441E-09_JPRB, 0.26005631E-09_JPRB, 0.26003316E-09_JPRB, 0.26000926E-09_JPRB, 0.25998745E-09_JPRB, &
  & 0.25996882E-09_JPRB, 0.25994978E-09_JPRB, 0.25992597E-09_JPRB, 0.25988511E-09_JPRB /)

RGHG5(:,58, 4) = (/ &
  & 0.25792091E-09_JPRB, 0.25880878E-09_JPRB, 0.25920416E-09_JPRB, 0.25945535E-09_JPRB, 0.25963337E-09_JPRB, 0.25972025E-09_JPRB, &
  & 0.25975999E-09_JPRB, 0.25977706E-09_JPRB, 0.25978680E-09_JPRB, 0.25979285E-09_JPRB, 0.25979738E-09_JPRB, 0.25980118E-09_JPRB, &
  & 0.25980390E-09_JPRB, 0.25980643E-09_JPRB, 0.25980981E-09_JPRB, 0.25981939E-09_JPRB, 0.25984270E-09_JPRB, 0.25989114E-09_JPRB, &
  & 0.25997540E-09_JPRB, 0.26010918E-09_JPRB, 0.26030056E-09_JPRB, 0.26055444E-09_JPRB, 0.26085303E-09_JPRB, 0.26116090E-09_JPRB, &
  & 0.26144528E-09_JPRB, 0.26169042E-09_JPRB, 0.26189043E-09_JPRB, 0.26204389E-09_JPRB, 0.26214850E-09_JPRB, 0.26220240E-09_JPRB, &
  & 0.26220098E-09_JPRB, 0.26214009E-09_JPRB, 0.26201757E-09_JPRB, 0.26183583E-09_JPRB, 0.26160057E-09_JPRB, 0.26132271E-09_JPRB, &
  & 0.26102101E-09_JPRB, 0.26072156E-09_JPRB, 0.26045333E-09_JPRB, 0.26024613E-09_JPRB, 0.26012448E-09_JPRB, 0.26009600E-09_JPRB, &
  & 0.26014008E-09_JPRB, 0.26022143E-09_JPRB, 0.26030689E-09_JPRB, 0.26037189E-09_JPRB, 0.26040309E-09_JPRB, 0.26039942E-09_JPRB, &
  & 0.26037839E-09_JPRB, 0.26035740E-09_JPRB, 0.26034241E-09_JPRB, 0.26033098E-09_JPRB, 0.26032138E-09_JPRB, 0.26031280E-09_JPRB, &
  & 0.26030322E-09_JPRB, 0.26029207E-09_JPRB, 0.26027724E-09_JPRB, 0.26025906E-09_JPRB, 0.26023994E-09_JPRB, 0.26022404E-09_JPRB, &
  & 0.26020885E-09_JPRB, 0.26019356E-09_JPRB, 0.26017460E-09_JPRB, 0.26013633E-09_JPRB /)

RGHG5(:,59, 4) = (/ &
  & 0.25880115E-09_JPRB, 0.25938673E-09_JPRB, 0.25962049E-09_JPRB, 0.25979199E-09_JPRB, 0.25989944E-09_JPRB, 0.25996316E-09_JPRB, &
  & 0.25999075E-09_JPRB, 0.26000471E-09_JPRB, 0.26001229E-09_JPRB, 0.26001767E-09_JPRB, 0.26002200E-09_JPRB, 0.26002550E-09_JPRB, &
  & 0.26002869E-09_JPRB, 0.26003030E-09_JPRB, 0.26003061E-09_JPRB, 0.26003130E-09_JPRB, 0.26004041E-09_JPRB, 0.26007235E-09_JPRB, &
  & 0.26014210E-09_JPRB, 0.26026267E-09_JPRB, 0.26044344E-09_JPRB, 0.26068442E-09_JPRB, 0.26096841E-09_JPRB, 0.26126326E-09_JPRB, &
  & 0.26153882E-09_JPRB, 0.26177779E-09_JPRB, 0.26197383E-09_JPRB, 0.26212288E-09_JPRB, 0.26222310E-09_JPRB, 0.26227256E-09_JPRB, &
  & 0.26226793E-09_JPRB, 0.26220578E-09_JPRB, 0.26208402E-09_JPRB, 0.26190572E-09_JPRB, 0.26167690E-09_JPRB, 0.26140770E-09_JPRB, &
  & 0.26111802E-09_JPRB, 0.26083163E-09_JPRB, 0.26057936E-09_JPRB, 0.26038741E-09_JPRB, 0.26027860E-09_JPRB, 0.26025859E-09_JPRB, &
  & 0.26030805E-09_JPRB, 0.26039335E-09_JPRB, 0.26048280E-09_JPRB, 0.26055294E-09_JPRB, 0.26058930E-09_JPRB, 0.26059063E-09_JPRB, &
  & 0.26057145E-09_JPRB, 0.26055169E-09_JPRB, 0.26053498E-09_JPRB, 0.26052208E-09_JPRB, 0.26051136E-09_JPRB, 0.26050118E-09_JPRB, &
  & 0.26049113E-09_JPRB, 0.26047936E-09_JPRB, 0.26046490E-09_JPRB, 0.26044805E-09_JPRB, 0.26043165E-09_JPRB, 0.26041683E-09_JPRB, &
  & 0.26040398E-09_JPRB, 0.26038990E-09_JPRB, 0.26037092E-09_JPRB, 0.26033348E-09_JPRB /)

RGHG5(:,60, 4) = (/ &
  & 0.25949015E-09_JPRB, 0.25979799E-09_JPRB, 0.25995028E-09_JPRB, 0.26005104E-09_JPRB, 0.26013081E-09_JPRB, 0.26017516E-09_JPRB, &
  & 0.26019870E-09_JPRB, 0.26021019E-09_JPRB, 0.26021763E-09_JPRB, 0.26022301E-09_JPRB, 0.26022773E-09_JPRB, 0.26023236E-09_JPRB, &
  & 0.26023642E-09_JPRB, 0.26023961E-09_JPRB, 0.26023939E-09_JPRB, 0.26023508E-09_JPRB, 0.26023370E-09_JPRB, 0.26025251E-09_JPRB, &
  & 0.26030861E-09_JPRB, 0.26041785E-09_JPRB, 0.26058661E-09_JPRB, 0.26081484E-09_JPRB, 0.26108560E-09_JPRB, 0.26136787E-09_JPRB, &
  & 0.26163391E-09_JPRB, 0.26186636E-09_JPRB, 0.26205640E-09_JPRB, 0.26220037E-09_JPRB, 0.26229580E-09_JPRB, 0.26234098E-09_JPRB, &
  & 0.26233329E-09_JPRB, 0.26227004E-09_JPRB, 0.26214980E-09_JPRB, 0.26197491E-09_JPRB, 0.26175337E-09_JPRB, 0.26149402E-09_JPRB, &
  & 0.26121677E-09_JPRB, 0.26094535E-09_JPRB, 0.26070762E-09_JPRB, 0.26052999E-09_JPRB, 0.26043206E-09_JPRB, 0.26041899E-09_JPRB, &
  & 0.26047248E-09_JPRB, 0.26056035E-09_JPRB, 0.26065256E-09_JPRB, 0.26072583E-09_JPRB, 0.26076694E-09_JPRB, 0.26077290E-09_JPRB, &
  & 0.26075631E-09_JPRB, 0.26073407E-09_JPRB, 0.26071501E-09_JPRB, 0.26069893E-09_JPRB, 0.26068495E-09_JPRB, 0.26067276E-09_JPRB, &
  & 0.26066022E-09_JPRB, 0.26064684E-09_JPRB, 0.26063124E-09_JPRB, 0.26061397E-09_JPRB, 0.26059729E-09_JPRB, 0.26058383E-09_JPRB, &
  & 0.26057073E-09_JPRB, 0.26055735E-09_JPRB, 0.26053965E-09_JPRB, 0.26050251E-09_JPRB /)

RGHG5(:,61, 4) = (/ &
  & 0.25987257E-09_JPRB, 0.26009639E-09_JPRB, 0.26019689E-09_JPRB, 0.26027441E-09_JPRB, 0.26033017E-09_JPRB, 0.26036839E-09_JPRB, &
  & 0.26038852E-09_JPRB, 0.26040042E-09_JPRB, 0.26040806E-09_JPRB, 0.26041444E-09_JPRB, 0.26042046E-09_JPRB, 0.26042651E-09_JPRB, &
  & 0.26043329E-09_JPRB, 0.26043862E-09_JPRB, 0.26043975E-09_JPRB, 0.26043273E-09_JPRB, 0.26042368E-09_JPRB, 0.26043173E-09_JPRB, &
  & 0.26047656E-09_JPRB, 0.26057426E-09_JPRB, 0.26073152E-09_JPRB, 0.26094754E-09_JPRB, 0.26120459E-09_JPRB, 0.26147484E-09_JPRB, &
  & 0.26173091E-09_JPRB, 0.26195485E-09_JPRB, 0.26213798E-09_JPRB, 0.26227584E-09_JPRB, 0.26236616E-09_JPRB, 0.26240732E-09_JPRB, &
  & 0.26239710E-09_JPRB, 0.26233352E-09_JPRB, 0.26221522E-09_JPRB, 0.26204522E-09_JPRB, 0.26183086E-09_JPRB, 0.26158306E-09_JPRB, &
  & 0.26131880E-09_JPRB, 0.26106195E-09_JPRB, 0.26083885E-09_JPRB, 0.26067384E-09_JPRB, 0.26058566E-09_JPRB, 0.26057806E-09_JPRB, &
  & 0.26063426E-09_JPRB, 0.26072366E-09_JPRB, 0.26081728E-09_JPRB, 0.26089289E-09_JPRB, 0.26093755E-09_JPRB, 0.26094832E-09_JPRB, &
  & 0.26093394E-09_JPRB, 0.26091096E-09_JPRB, 0.26088726E-09_JPRB, 0.26086650E-09_JPRB, 0.26084862E-09_JPRB, 0.26083202E-09_JPRB, &
  & 0.26081659E-09_JPRB, 0.26080027E-09_JPRB, 0.26078223E-09_JPRB, 0.26076355E-09_JPRB, 0.26074709E-09_JPRB, 0.26073255E-09_JPRB, &
  & 0.26071995E-09_JPRB, 0.26070582E-09_JPRB, 0.26068664E-09_JPRB, 0.26064781E-09_JPRB /)

RGHG5(:,62, 4) = (/ &
  & 0.26017830E-09_JPRB, 0.26033298E-09_JPRB, 0.26040980E-09_JPRB, 0.26046598E-09_JPRB, 0.26051344E-09_JPRB, 0.26054592E-09_JPRB, &
  & 0.26056657E-09_JPRB, 0.26057892E-09_JPRB, 0.26058825E-09_JPRB, 0.26059610E-09_JPRB, 0.26060407E-09_JPRB, 0.26061298E-09_JPRB, &
  & 0.26062263E-09_JPRB, 0.26063207E-09_JPRB, 0.26063507E-09_JPRB, 0.26062602E-09_JPRB, 0.26061109E-09_JPRB, 0.26061062E-09_JPRB, &
  & 0.26064570E-09_JPRB, 0.26073280E-09_JPRB, 0.26087896E-09_JPRB, 0.26108274E-09_JPRB, 0.26132682E-09_JPRB, 0.26158409E-09_JPRB, &
  & 0.26182895E-09_JPRB, 0.26204333E-09_JPRB, 0.26221836E-09_JPRB, 0.26234914E-09_JPRB, 0.26243419E-09_JPRB, 0.26247154E-09_JPRB, &
  & 0.26245950E-09_JPRB, 0.26239616E-09_JPRB, 0.26228131E-09_JPRB, 0.26211694E-09_JPRB, 0.26191146E-09_JPRB, 0.26167515E-09_JPRB, &
  & 0.26142463E-09_JPRB, 0.26118233E-09_JPRB, 0.26097266E-09_JPRB, 0.26081948E-09_JPRB, 0.26073976E-09_JPRB, 0.26073665E-09_JPRB, &
  & 0.26079455E-09_JPRB, 0.26088423E-09_JPRB, 0.26097832E-09_JPRB, 0.26105529E-09_JPRB, 0.26110261E-09_JPRB, 0.26111746E-09_JPRB, &
  & 0.26110672E-09_JPRB, 0.26108263E-09_JPRB, 0.26105568E-09_JPRB, 0.26102934E-09_JPRB, 0.26100549E-09_JPRB, 0.26098435E-09_JPRB, &
  & 0.26096442E-09_JPRB, 0.26094413E-09_JPRB, 0.26092342E-09_JPRB, 0.26090291E-09_JPRB, 0.26088492E-09_JPRB, 0.26087060E-09_JPRB, &
  & 0.26085656E-09_JPRB, 0.26084176E-09_JPRB, 0.26082120E-09_JPRB, 0.26077765E-09_JPRB /)

RGHG5(:,63, 4) = (/ &
  & 0.26041125E-09_JPRB, 0.26053326E-09_JPRB, 0.26059338E-09_JPRB, 0.26064123E-09_JPRB, 0.26068120E-09_JPRB, 0.26071306E-09_JPRB, &
  & 0.26073393E-09_JPRB, 0.26074884E-09_JPRB, 0.26076002E-09_JPRB, 0.26077071E-09_JPRB, 0.26078173E-09_JPRB, 0.26079430E-09_JPRB, &
  & 0.26080899E-09_JPRB, 0.26082250E-09_JPRB, 0.26082711E-09_JPRB, 0.26081579E-09_JPRB, 0.26079633E-09_JPRB, 0.26078928E-09_JPRB, &
  & 0.26081609E-09_JPRB, 0.26089345E-09_JPRB, 0.26102931E-09_JPRB, 0.26122110E-09_JPRB, 0.26145164E-09_JPRB, 0.26169569E-09_JPRB, &
  & 0.26192809E-09_JPRB, 0.26213176E-09_JPRB, 0.26229716E-09_JPRB, 0.26242059E-09_JPRB, 0.26249966E-09_JPRB, 0.26253349E-09_JPRB, &
  & 0.26252026E-09_JPRB, 0.26245853E-09_JPRB, 0.26234787E-09_JPRB, 0.26219121E-09_JPRB, 0.26199518E-09_JPRB, 0.26177166E-09_JPRB, &
  & 0.26153452E-09_JPRB, 0.26130673E-09_JPRB, 0.26110969E-09_JPRB, 0.26096750E-09_JPRB, 0.26089542E-09_JPRB, 0.26089592E-09_JPRB, &
  & 0.26095406E-09_JPRB, 0.26104283E-09_JPRB, 0.26113625E-09_JPRB, 0.26121372E-09_JPRB, 0.26126290E-09_JPRB, 0.26128094E-09_JPRB, &
  & 0.26127334E-09_JPRB, 0.26125055E-09_JPRB, 0.26122043E-09_JPRB, 0.26118951E-09_JPRB, 0.26115959E-09_JPRB, 0.26113275E-09_JPRB, &
  & 0.26110719E-09_JPRB, 0.26108313E-09_JPRB, 0.26105834E-09_JPRB, 0.26103580E-09_JPRB, 0.26101715E-09_JPRB, 0.26100097E-09_JPRB, &
  & 0.26098645E-09_JPRB, 0.26096944E-09_JPRB, 0.26094554E-09_JPRB, 0.26089572E-09_JPRB /)

RGHG5(:,64, 4) = (/ &
  & 0.26060332E-09_JPRB, 0.26070562E-09_JPRB, 0.26075855E-09_JPRB, 0.26080044E-09_JPRB, 0.26083835E-09_JPRB, 0.26086905E-09_JPRB, &
  & 0.26089286E-09_JPRB, 0.26090974E-09_JPRB, 0.26092481E-09_JPRB, 0.26093866E-09_JPRB, 0.26095437E-09_JPRB, 0.26097238E-09_JPRB, &
  & 0.26099267E-09_JPRB, 0.26101046E-09_JPRB, 0.26101488E-09_JPRB, 0.26100094E-09_JPRB, 0.26097813E-09_JPRB, 0.26096639E-09_JPRB, &
  & 0.26098640E-09_JPRB, 0.26105534E-09_JPRB, 0.26118113E-09_JPRB, 0.26136146E-09_JPRB, 0.26157820E-09_JPRB, 0.26180827E-09_JPRB, &
  & 0.26202704E-09_JPRB, 0.26221847E-09_JPRB, 0.26237379E-09_JPRB, 0.26248856E-09_JPRB, 0.26256175E-09_JPRB, 0.26259195E-09_JPRB, &
  & 0.26257826E-09_JPRB, 0.26251892E-09_JPRB, 0.26241406E-09_JPRB, 0.26226615E-09_JPRB, 0.26208161E-09_JPRB, 0.26187097E-09_JPRB, &
  & 0.26164798E-09_JPRB, 0.26143415E-09_JPRB, 0.26124958E-09_JPRB, 0.26111729E-09_JPRB, 0.26105212E-09_JPRB, 0.26105523E-09_JPRB, &
  & 0.26111255E-09_JPRB, 0.26119898E-09_JPRB, 0.26129066E-09_JPRB, 0.26136759E-09_JPRB, 0.26141783E-09_JPRB, 0.26143807E-09_JPRB, &
  & 0.26143299E-09_JPRB, 0.26141117E-09_JPRB, 0.26138067E-09_JPRB, 0.26134570E-09_JPRB, 0.26131142E-09_JPRB, 0.26127805E-09_JPRB, &
  & 0.26124827E-09_JPRB, 0.26121832E-09_JPRB, 0.26119082E-09_JPRB, 0.26116570E-09_JPRB, 0.26114494E-09_JPRB, 0.26112809E-09_JPRB, &
  & 0.26111102E-09_JPRB, 0.26109184E-09_JPRB, 0.26106356E-09_JPRB, 0.26100172E-09_JPRB /)

RGHG5(:,65, 4) = (/ &
  & 0.26076069E-09_JPRB, 0.26085836E-09_JPRB, 0.26090818E-09_JPRB, 0.26094918E-09_JPRB, 0.26098562E-09_JPRB, 0.26101796E-09_JPRB, &
  & 0.26104291E-09_JPRB, 0.26106448E-09_JPRB, 0.26108243E-09_JPRB, 0.26110222E-09_JPRB, 0.26112312E-09_JPRB, 0.26114821E-09_JPRB, &
  & 0.26117444E-09_JPRB, 0.26119382E-09_JPRB, 0.26119651E-09_JPRB, 0.26118055E-09_JPRB, 0.26115585E-09_JPRB, 0.26114086E-09_JPRB, &
  & 0.26115565E-09_JPRB, 0.26121716E-09_JPRB, 0.26133393E-09_JPRB, 0.26150199E-09_JPRB, 0.26170541E-09_JPRB, 0.26192007E-09_JPRB, &
  & 0.26212435E-09_JPRB, 0.26230249E-09_JPRB, 0.26244612E-09_JPRB, 0.26255206E-09_JPRB, 0.26261870E-09_JPRB, 0.26264566E-09_JPRB, &
  & 0.26263186E-09_JPRB, 0.26257591E-09_JPRB, 0.26247776E-09_JPRB, 0.26234015E-09_JPRB, 0.26216818E-09_JPRB, 0.26197153E-09_JPRB, &
  & 0.26176314E-09_JPRB, 0.26156349E-09_JPRB, 0.26139124E-09_JPRB, 0.26126862E-09_JPRB, 0.26120969E-09_JPRB, 0.26121447E-09_JPRB, &
  & 0.26126970E-09_JPRB, 0.26135252E-09_JPRB, 0.26144117E-09_JPRB, 0.26151672E-09_JPRB, 0.26156710E-09_JPRB, 0.26158867E-09_JPRB, &
  & 0.26158536E-09_JPRB, 0.26156474E-09_JPRB, 0.26153363E-09_JPRB, 0.26149743E-09_JPRB, 0.26145897E-09_JPRB, 0.26142249E-09_JPRB, &
  & 0.26138661E-09_JPRB, 0.26135369E-09_JPRB, 0.26132180E-09_JPRB, 0.26129449E-09_JPRB, 0.26127212E-09_JPRB, 0.26125258E-09_JPRB, &
  & 0.26123403E-09_JPRB, 0.26121089E-09_JPRB, 0.26117619E-09_JPRB, 0.26110025E-09_JPRB /)

RGHG5(:,66, 4) = (/ &
  & 0.26089594E-09_JPRB, 0.26099550E-09_JPRB, 0.26104824E-09_JPRB, 0.26108982E-09_JPRB, 0.26112773E-09_JPRB, 0.26116084E-09_JPRB, &
  & 0.26118946E-09_JPRB, 0.26121294E-09_JPRB, 0.26123739E-09_JPRB, 0.26126121E-09_JPRB, 0.26129043E-09_JPRB, 0.26132133E-09_JPRB, &
  & 0.26135119E-09_JPRB, 0.26136995E-09_JPRB, 0.26137095E-09_JPRB, 0.26135394E-09_JPRB, 0.26132865E-09_JPRB, 0.26131183E-09_JPRB, &
  & 0.26132285E-09_JPRB, 0.26137822E-09_JPRB, 0.26148575E-09_JPRB, 0.26164240E-09_JPRB, 0.26183067E-09_JPRB, 0.26202995E-09_JPRB, &
  & 0.26221814E-09_JPRB, 0.26238209E-09_JPRB, 0.26251365E-09_JPRB, 0.26260985E-09_JPRB, 0.26267000E-09_JPRB, 0.26269364E-09_JPRB, &
  & 0.26268010E-09_JPRB, 0.26262811E-09_JPRB, 0.26253774E-09_JPRB, 0.26241082E-09_JPRB, 0.26225278E-09_JPRB, 0.26207075E-09_JPRB, &
  & 0.26187813E-09_JPRB, 0.26169281E-09_JPRB, 0.26153354E-09_JPRB, 0.26142055E-09_JPRB, 0.26136734E-09_JPRB, 0.26137301E-09_JPRB, &
  & 0.26142533E-09_JPRB, 0.26150321E-09_JPRB, 0.26158778E-09_JPRB, 0.26166069E-09_JPRB, 0.26171054E-09_JPRB, 0.26173283E-09_JPRB, &
  & 0.26173083E-09_JPRB, 0.26171110E-09_JPRB, 0.26168018E-09_JPRB, 0.26164299E-09_JPRB, 0.26160321E-09_JPRB, 0.26156305E-09_JPRB, &
  & 0.26152480E-09_JPRB, 0.26148739E-09_JPRB, 0.26145336E-09_JPRB, 0.26142338E-09_JPRB, 0.26139868E-09_JPRB, 0.26137767E-09_JPRB, &
  & 0.26135591E-09_JPRB, 0.26132962E-09_JPRB, 0.26128816E-09_JPRB, 0.26119476E-09_JPRB /)

RGHG5(:,67, 4) = (/ &
  & 0.26101576E-09_JPRB, 0.26112629E-09_JPRB, 0.26118180E-09_JPRB, 0.26122718E-09_JPRB, 0.26126712E-09_JPRB, 0.26130248E-09_JPRB, &
  & 0.26133304E-09_JPRB, 0.26136138E-09_JPRB, 0.26138852E-09_JPRB, 0.26142052E-09_JPRB, 0.26145386E-09_JPRB, 0.26148994E-09_JPRB, &
  & 0.26152000E-09_JPRB, 0.26153751E-09_JPRB, 0.26153776E-09_JPRB, 0.26152105E-09_JPRB, 0.26149616E-09_JPRB, 0.26147881E-09_JPRB, &
  & 0.26148728E-09_JPRB, 0.26153715E-09_JPRB, 0.26163627E-09_JPRB, 0.26177999E-09_JPRB, 0.26195360E-09_JPRB, 0.26213548E-09_JPRB, &
  & 0.26230768E-09_JPRB, 0.26245636E-09_JPRB, 0.26257538E-09_JPRB, 0.26266195E-09_JPRB, 0.26271552E-09_JPRB, 0.26273603E-09_JPRB, &
  & 0.26272293E-09_JPRB, 0.26267530E-09_JPRB, 0.26259281E-09_JPRB, 0.26247762E-09_JPRB, 0.26233332E-09_JPRB, 0.26216732E-09_JPRB, &
  & 0.26199048E-09_JPRB, 0.26182051E-09_JPRB, 0.26167452E-09_JPRB, 0.26157168E-09_JPRB, 0.26152391E-09_JPRB, 0.26153013E-09_JPRB, &
  & 0.26157873E-09_JPRB, 0.26165103E-09_JPRB, 0.26173025E-09_JPRB, 0.26179989E-09_JPRB, 0.26184824E-09_JPRB, 0.26187072E-09_JPRB, &
  & 0.26186969E-09_JPRB, 0.26185085E-09_JPRB, 0.26182037E-09_JPRB, 0.26178312E-09_JPRB, 0.26174241E-09_JPRB, 0.26170102E-09_JPRB, &
  & 0.26166017E-09_JPRB, 0.26162100E-09_JPRB, 0.26158448E-09_JPRB, 0.26155275E-09_JPRB, 0.26152625E-09_JPRB, 0.26150274E-09_JPRB, &
  & 0.26147953E-09_JPRB, 0.26144922E-09_JPRB, 0.26140085E-09_JPRB, 0.26129141E-09_JPRB /)

RGHG5(:,68, 4) = (/ &
  & 0.26113151E-09_JPRB, 0.26125024E-09_JPRB, 0.26131472E-09_JPRB, 0.26136301E-09_JPRB, 0.26140626E-09_JPRB, 0.26144420E-09_JPRB, &
  & 0.26147701E-09_JPRB, 0.26150832E-09_JPRB, 0.26154107E-09_JPRB, 0.26157601E-09_JPRB, 0.26161445E-09_JPRB, 0.26165078E-09_JPRB, &
  & 0.26168034E-09_JPRB, 0.26169705E-09_JPRB, 0.26169725E-09_JPRB, 0.26168157E-09_JPRB, 0.26165808E-09_JPRB, 0.26164129E-09_JPRB, &
  & 0.26164801E-09_JPRB, 0.26169306E-09_JPRB, 0.26178312E-09_JPRB, 0.26191430E-09_JPRB, 0.26207125E-09_JPRB, 0.26223632E-09_JPRB, &
  & 0.26239128E-09_JPRB, 0.26252517E-09_JPRB, 0.26263161E-09_JPRB, 0.26270860E-09_JPRB, 0.26275587E-09_JPRB, 0.26277353E-09_JPRB, &
  & 0.26276106E-09_JPRB, 0.26271779E-09_JPRB, 0.26264368E-09_JPRB, 0.26253952E-09_JPRB, 0.26240993E-09_JPRB, 0.26225921E-09_JPRB, &
  & 0.26209943E-09_JPRB, 0.26194463E-09_JPRB, 0.26181274E-09_JPRB, 0.26172017E-09_JPRB, 0.26167804E-09_JPRB, 0.26168451E-09_JPRB, &
  & 0.26172928E-09_JPRB, 0.26179514E-09_JPRB, 0.26186886E-09_JPRB, 0.26193403E-09_JPRB, 0.26198027E-09_JPRB, 0.26200236E-09_JPRB, &
  & 0.26200192E-09_JPRB, 0.26198413E-09_JPRB, 0.26195451E-09_JPRB, 0.26191777E-09_JPRB, 0.26187710E-09_JPRB, 0.26183530E-09_JPRB, &
  & 0.26179356E-09_JPRB, 0.26175306E-09_JPRB, 0.26171568E-09_JPRB, 0.26168248E-09_JPRB, 0.26165453E-09_JPRB, 0.26163000E-09_JPRB, &
  & 0.26160463E-09_JPRB, 0.26157249E-09_JPRB, 0.26151864E-09_JPRB, 0.26139663E-09_JPRB /)

RGHG5(:,69, 4) = (/ &
  & 0.26123681E-09_JPRB, 0.26137775E-09_JPRB, 0.26144639E-09_JPRB, 0.26150154E-09_JPRB, 0.26154690E-09_JPRB, 0.26158675E-09_JPRB, &
  & 0.26162236E-09_JPRB, 0.26165603E-09_JPRB, 0.26169192E-09_JPRB, 0.26173011E-09_JPRB, 0.26176916E-09_JPRB, 0.26180530E-09_JPRB, &
  & 0.26183358E-09_JPRB, 0.26184974E-09_JPRB, 0.26185010E-09_JPRB, 0.26183594E-09_JPRB, 0.26181451E-09_JPRB, 0.26179880E-09_JPRB, &
  & 0.26180444E-09_JPRB, 0.26184452E-09_JPRB, 0.26192559E-09_JPRB, 0.26204292E-09_JPRB, 0.26218377E-09_JPRB, 0.26233077E-09_JPRB, &
  & 0.26246927E-09_JPRB, 0.26258826E-09_JPRB, 0.26268260E-09_JPRB, 0.26275046E-09_JPRB, 0.26279179E-09_JPRB, 0.26280672E-09_JPRB, &
  & 0.26279520E-09_JPRB, 0.26275648E-09_JPRB, 0.26269031E-09_JPRB, 0.26259772E-09_JPRB, 0.26248162E-09_JPRB, 0.26234742E-09_JPRB, &
  & 0.26220343E-09_JPRB, 0.26206465E-09_JPRB, 0.26194663E-09_JPRB, 0.26186472E-09_JPRB, 0.26182823E-09_JPRB, 0.26183511E-09_JPRB, &
  & 0.26187566E-09_JPRB, 0.26193572E-09_JPRB, 0.26200292E-09_JPRB, 0.26206337E-09_JPRB, 0.26210673E-09_JPRB, 0.26212787E-09_JPRB, &
  & 0.26212782E-09_JPRB, 0.26211119E-09_JPRB, 0.26208280E-09_JPRB, 0.26204716E-09_JPRB, 0.26200742E-09_JPRB, 0.26196620E-09_JPRB, &
  & 0.26192473E-09_JPRB, 0.26188418E-09_JPRB, 0.26184654E-09_JPRB, 0.26181327E-09_JPRB, 0.26178482E-09_JPRB, 0.26175948E-09_JPRB, &
  & 0.26173391E-09_JPRB, 0.26170008E-09_JPRB, 0.26164257E-09_JPRB, 0.26151004E-09_JPRB /)

RGHG5(:,70, 4) = (/ &
  & 0.26134547E-09_JPRB, 0.26150093E-09_JPRB, 0.26158484E-09_JPRB, 0.26164221E-09_JPRB, 0.26169100E-09_JPRB, 0.26173186E-09_JPRB, &
  & 0.26176841E-09_JPRB, 0.26180466E-09_JPRB, 0.26184177E-09_JPRB, 0.26188093E-09_JPRB, 0.26191915E-09_JPRB, 0.26195374E-09_JPRB, &
  & 0.26198044E-09_JPRB, 0.26199562E-09_JPRB, 0.26199640E-09_JPRB, 0.26198391E-09_JPRB, 0.26196481E-09_JPRB, 0.26195074E-09_JPRB, &
  & 0.26195532E-09_JPRB, 0.26199057E-09_JPRB, 0.26206190E-09_JPRB, 0.26216562E-09_JPRB, 0.26228944E-09_JPRB, 0.26241928E-09_JPRB, &
  & 0.26254132E-09_JPRB, 0.26264615E-09_JPRB, 0.26272889E-09_JPRB, 0.26278812E-09_JPRB, 0.26282387E-09_JPRB, 0.26283636E-09_JPRB, &
  & 0.26282584E-09_JPRB, 0.26279168E-09_JPRB, 0.26273350E-09_JPRB, 0.26265182E-09_JPRB, 0.26254987E-09_JPRB, 0.26243058E-09_JPRB, &
  & 0.26230307E-09_JPRB, 0.26217964E-09_JPRB, 0.26207547E-09_JPRB, 0.26200414E-09_JPRB, 0.26197330E-09_JPRB, 0.26198044E-09_JPRB, &
  & 0.26201724E-09_JPRB, 0.26207098E-09_JPRB, 0.26213218E-09_JPRB, 0.26218699E-09_JPRB, 0.26222699E-09_JPRB, 0.26224672E-09_JPRB, &
  & 0.26224689E-09_JPRB, 0.26223163E-09_JPRB, 0.26220504E-09_JPRB, 0.26217117E-09_JPRB, 0.26213315E-09_JPRB, 0.26209368E-09_JPRB, &
  & 0.26205352E-09_JPRB, 0.26201416E-09_JPRB, 0.26197763E-09_JPRB, 0.26194510E-09_JPRB, 0.26191732E-09_JPRB, 0.26189256E-09_JPRB, &
  & 0.26186717E-09_JPRB, 0.26183386E-09_JPRB, 0.26177482E-09_JPRB, 0.26163596E-09_JPRB /)

RGHG5(:,71, 4) = (/ &
  & 0.26145711E-09_JPRB, 0.26163838E-09_JPRB, 0.26172736E-09_JPRB, 0.26178992E-09_JPRB, 0.26183830E-09_JPRB, 0.26187966E-09_JPRB, &
  & 0.26191654E-09_JPRB, 0.26195299E-09_JPRB, 0.26199068E-09_JPRB, 0.26202859E-09_JPRB, 0.26206506E-09_JPRB, 0.26209715E-09_JPRB, &
  & 0.26212146E-09_JPRB, 0.26213520E-09_JPRB, 0.26213604E-09_JPRB, 0.26212515E-09_JPRB, 0.26210842E-09_JPRB, 0.26209585E-09_JPRB, &
  & 0.26209962E-09_JPRB, 0.26212987E-09_JPRB, 0.26219160E-09_JPRB, 0.26228128E-09_JPRB, 0.26238872E-09_JPRB, 0.26250130E-09_JPRB, &
  & 0.26260774E-09_JPRB, 0.26269895E-09_JPRB, 0.26277072E-09_JPRB, 0.26282185E-09_JPRB, 0.26285241E-09_JPRB, 0.26286284E-09_JPRB, &
  & 0.26285332E-09_JPRB, 0.26282371E-09_JPRB, 0.26277330E-09_JPRB, 0.26270258E-09_JPRB, 0.26261357E-09_JPRB, 0.26250971E-09_JPRB, &
  & 0.26239746E-09_JPRB, 0.26228952E-09_JPRB, 0.26219879E-09_JPRB, 0.26213764E-09_JPRB, 0.26211222E-09_JPRB, 0.26211963E-09_JPRB, &
  & 0.26215211E-09_JPRB, 0.26220062E-09_JPRB, 0.26225450E-09_JPRB, 0.26230407E-09_JPRB, 0.26234001E-09_JPRB, 0.26235811E-09_JPRB, &
  & 0.26235844E-09_JPRB, 0.26234492E-09_JPRB, 0.26232047E-09_JPRB, 0.26228925E-09_JPRB, 0.26225402E-09_JPRB, 0.26221716E-09_JPRB, &
  & 0.26217983E-09_JPRB, 0.26214259E-09_JPRB, 0.26210839E-09_JPRB, 0.26207775E-09_JPRB, 0.26205177E-09_JPRB, 0.26202834E-09_JPRB, &
  & 0.26200464E-09_JPRB, 0.26197317E-09_JPRB, 0.26191710E-09_JPRB, 0.26178329E-09_JPRB /)

RGHG5(:,72, 4) = (/ &
  & 0.26158964E-09_JPRB, 0.26178387E-09_JPRB, 0.26188018E-09_JPRB, 0.26194230E-09_JPRB, 0.26199004E-09_JPRB, 0.26202987E-09_JPRB, &
  & 0.26206601E-09_JPRB, 0.26210192E-09_JPRB, 0.26213759E-09_JPRB, 0.26217398E-09_JPRB, 0.26220684E-09_JPRB, 0.26223562E-09_JPRB, &
  & 0.26225697E-09_JPRB, 0.26226846E-09_JPRB, 0.26226890E-09_JPRB, 0.26225919E-09_JPRB, 0.26224459E-09_JPRB, 0.26223354E-09_JPRB, &
  & 0.26223634E-09_JPRB, 0.26226177E-09_JPRB, 0.26231389E-09_JPRB, 0.26239008E-09_JPRB, 0.26248126E-09_JPRB, 0.26257743E-09_JPRB, &
  & 0.26266872E-09_JPRB, 0.26274713E-09_JPRB, 0.26280852E-09_JPRB, 0.26285213E-09_JPRB, 0.26287800E-09_JPRB, 0.26288646E-09_JPRB, &
  & 0.26287802E-09_JPRB, 0.26285282E-09_JPRB, 0.26281000E-09_JPRB, 0.26274946E-09_JPRB, 0.26267349E-09_JPRB, 0.26258376E-09_JPRB, &
  & 0.26248712E-09_JPRB, 0.26239383E-09_JPRB, 0.26231609E-09_JPRB, 0.26226482E-09_JPRB, 0.26224425E-09_JPRB, 0.26225139E-09_JPRB, &
  & 0.26228031E-09_JPRB, 0.26232225E-09_JPRB, 0.26236988E-09_JPRB, 0.26241304E-09_JPRB, 0.26244490E-09_JPRB, 0.26246108E-09_JPRB, &
  & 0.26246172E-09_JPRB, 0.26245014E-09_JPRB, 0.26242858E-09_JPRB, 0.26240082E-09_JPRB, 0.26236907E-09_JPRB, 0.26233640E-09_JPRB, &
  & 0.26230218E-09_JPRB, 0.26226893E-09_JPRB, 0.26223740E-09_JPRB, 0.26220989E-09_JPRB, 0.26218619E-09_JPRB, 0.26216507E-09_JPRB, &
  & 0.26214339E-09_JPRB, 0.26211472E-09_JPRB, 0.26206307E-09_JPRB, 0.26193736E-09_JPRB /)

RGHG5(:,73, 4) = (/ &
  & 0.26174862E-09_JPRB, 0.26194427E-09_JPRB, 0.26203972E-09_JPRB, 0.26209829E-09_JPRB, 0.26214325E-09_JPRB, 0.26218083E-09_JPRB, &
  & 0.26221494E-09_JPRB, 0.26224833E-09_JPRB, 0.26228236E-09_JPRB, 0.26231409E-09_JPRB, 0.26234412E-09_JPRB, 0.26236854E-09_JPRB, &
  & 0.26238625E-09_JPRB, 0.26239516E-09_JPRB, 0.26239450E-09_JPRB, 0.26238539E-09_JPRB, 0.26237240E-09_JPRB, 0.26236274E-09_JPRB, &
  & 0.26236466E-09_JPRB, 0.26238528E-09_JPRB, 0.26242844E-09_JPRB, 0.26249153E-09_JPRB, 0.26256738E-09_JPRB, 0.26264782E-09_JPRB, &
  & 0.26272473E-09_JPRB, 0.26279104E-09_JPRB, 0.26284261E-09_JPRB, 0.26287919E-09_JPRB, 0.26290065E-09_JPRB, 0.26290750E-09_JPRB, &
  & 0.26290017E-09_JPRB, 0.26287927E-09_JPRB, 0.26284364E-09_JPRB, 0.26279298E-09_JPRB, 0.26272862E-09_JPRB, 0.26265351E-09_JPRB, &
  & 0.26257124E-09_JPRB, 0.26249244E-09_JPRB, 0.26242714E-09_JPRB, 0.26238478E-09_JPRB, 0.26236868E-09_JPRB, 0.26237545E-09_JPRB, &
  & 0.26239994E-09_JPRB, 0.26243654E-09_JPRB, 0.26247626E-09_JPRB, 0.26251376E-09_JPRB, 0.26254110E-09_JPRB, 0.26255542E-09_JPRB, &
  & 0.26255620E-09_JPRB, 0.26254696E-09_JPRB, 0.26252850E-09_JPRB, 0.26250466E-09_JPRB, 0.26247754E-09_JPRB, 0.26244870E-09_JPRB, &
  & 0.26241995E-09_JPRB, 0.26238997E-09_JPRB, 0.26236299E-09_JPRB, 0.26233823E-09_JPRB, 0.26231781E-09_JPRB, 0.26229893E-09_JPRB, &
  & 0.26227959E-09_JPRB, 0.26225389E-09_JPRB, 0.26220717E-09_JPRB, 0.26209124E-09_JPRB /)

RGHG5(:,74, 4) = (/ &
  & 0.26191696E-09_JPRB, 0.26211130E-09_JPRB, 0.26219979E-09_JPRB, 0.26225394E-09_JPRB, 0.26229427E-09_JPRB, 0.26232852E-09_JPRB, &
  & 0.26235955E-09_JPRB, 0.26239061E-09_JPRB, 0.26241909E-09_JPRB, 0.26244890E-09_JPRB, 0.26247290E-09_JPRB, 0.26249361E-09_JPRB, &
  & 0.26250768E-09_JPRB, 0.26251368E-09_JPRB, 0.26251168E-09_JPRB, 0.26250294E-09_JPRB, 0.26249142E-09_JPRB, 0.26248292E-09_JPRB, &
  & 0.26248395E-09_JPRB, 0.26250022E-09_JPRB, 0.26253466E-09_JPRB, 0.26258587E-09_JPRB, 0.26264704E-09_JPRB, 0.26271285E-09_JPRB, &
  & 0.26277630E-09_JPRB, 0.26283103E-09_JPRB, 0.26287331E-09_JPRB, 0.26290337E-09_JPRB, 0.26292085E-09_JPRB, 0.26292624E-09_JPRB, &
  & 0.26291996E-09_JPRB, 0.26290309E-09_JPRB, 0.26287436E-09_JPRB, 0.26283259E-09_JPRB, 0.26277999E-09_JPRB, 0.26271796E-09_JPRB, &
  & 0.26265023E-09_JPRB, 0.26258506E-09_JPRB, 0.26253130E-09_JPRB, 0.26249730E-09_JPRB, 0.26248478E-09_JPRB, 0.26249081E-09_JPRB, &
  & 0.26251176E-09_JPRB, 0.26254171E-09_JPRB, 0.26257480E-09_JPRB, 0.26260594E-09_JPRB, 0.26262897E-09_JPRB, 0.26264133E-09_JPRB, &
  & 0.26264221E-09_JPRB, 0.26263514E-09_JPRB, 0.26262004E-09_JPRB, 0.26260041E-09_JPRB, 0.26257777E-09_JPRB, 0.26255426E-09_JPRB, &
  & 0.26252961E-09_JPRB, 0.26250518E-09_JPRB, 0.26248137E-09_JPRB, 0.26246091E-09_JPRB, 0.26244321E-09_JPRB, 0.26242708E-09_JPRB, &
  & 0.26241012E-09_JPRB, 0.26238728E-09_JPRB, 0.26234617E-09_JPRB, 0.26223979E-09_JPRB /)

RGHG5(:,75, 4) = (/ &
  & 0.26209288E-09_JPRB, 0.26227556E-09_JPRB, 0.26235802E-09_JPRB, 0.26240388E-09_JPRB, 0.26243918E-09_JPRB, 0.26246927E-09_JPRB, &
  & 0.26249639E-09_JPRB, 0.26252295E-09_JPRB, 0.26254846E-09_JPRB, 0.26257141E-09_JPRB, 0.26259267E-09_JPRB, 0.26260819E-09_JPRB, &
  & 0.26261901E-09_JPRB, 0.26262265E-09_JPRB, 0.26261954E-09_JPRB, 0.26261138E-09_JPRB, 0.26260116E-09_JPRB, 0.26259397E-09_JPRB, &
  & 0.26259414E-09_JPRB, 0.26260624E-09_JPRB, 0.26263311E-09_JPRB, 0.26267308E-09_JPRB, 0.26272115E-09_JPRB, 0.26277311E-09_JPRB, &
  & 0.26282385E-09_JPRB, 0.26286759E-09_JPRB, 0.26290098E-09_JPRB, 0.26292502E-09_JPRB, 0.26293878E-09_JPRB, 0.26294283E-09_JPRB, &
  & 0.26293767E-09_JPRB, 0.26292454E-09_JPRB, 0.26290212E-09_JPRB, 0.26286887E-09_JPRB, 0.26282704E-09_JPRB, 0.26277786E-09_JPRB, &
  & 0.26272357E-09_JPRB, 0.26267155E-09_JPRB, 0.26262875E-09_JPRB, 0.26260222E-09_JPRB, 0.26259284E-09_JPRB, 0.26259808E-09_JPRB, &
  & 0.26261504E-09_JPRB, 0.26263924E-09_JPRB, 0.26266514E-09_JPRB, 0.26269051E-09_JPRB, 0.26270924E-09_JPRB, 0.26271951E-09_JPRB, &
  & 0.26272029E-09_JPRB, 0.26271540E-09_JPRB, 0.26270333E-09_JPRB, 0.26268815E-09_JPRB, 0.26266994E-09_JPRB, 0.26265101E-09_JPRB, &
  & 0.26263178E-09_JPRB, 0.26261146E-09_JPRB, 0.26259248E-09_JPRB, 0.26257535E-09_JPRB, 0.26256125E-09_JPRB, 0.26254771E-09_JPRB, &
  & 0.26253327E-09_JPRB, 0.26251382E-09_JPRB, 0.26247726E-09_JPRB, 0.26238123E-09_JPRB /)

RGHG5(:,76, 4) = (/ &
  & 0.26226804E-09_JPRB, 0.26243857E-09_JPRB, 0.26250840E-09_JPRB, 0.26254635E-09_JPRB, 0.26257527E-09_JPRB, 0.26260005E-09_JPRB, &
  & 0.26262309E-09_JPRB, 0.26264524E-09_JPRB, 0.26266414E-09_JPRB, 0.26268387E-09_JPRB, 0.26269850E-09_JPRB, 0.26271088E-09_JPRB, &
  & 0.26271851E-09_JPRB, 0.26272060E-09_JPRB, 0.26271718E-09_JPRB, 0.26271008E-09_JPRB, 0.26270158E-09_JPRB, 0.26269581E-09_JPRB, &
  & 0.26269523E-09_JPRB, 0.26270378E-09_JPRB, 0.26272354E-09_JPRB, 0.26275410E-09_JPRB, 0.26278979E-09_JPRB, 0.26282895E-09_JPRB, &
  & 0.26286764E-09_JPRB, 0.26290092E-09_JPRB, 0.26292590E-09_JPRB, 0.26294442E-09_JPRB, 0.26295477E-09_JPRB, 0.26295771E-09_JPRB, &
  & 0.26295344E-09_JPRB, 0.26294378E-09_JPRB, 0.26292732E-09_JPRB, 0.26290173E-09_JPRB, 0.26287025E-09_JPRB, 0.26283267E-09_JPRB, &
  & 0.26279168E-09_JPRB, 0.26275190E-09_JPRB, 0.26271935E-09_JPRB, 0.26269967E-09_JPRB, 0.26269284E-09_JPRB, 0.26269706E-09_JPRB, &
  & 0.26271044E-09_JPRB, 0.26272881E-09_JPRB, 0.26274821E-09_JPRB, 0.26276795E-09_JPRB, 0.26278218E-09_JPRB, 0.26279062E-09_JPRB, &
  & 0.26279107E-09_JPRB, 0.26278818E-09_JPRB, 0.26277905E-09_JPRB, 0.26276767E-09_JPRB, 0.26275410E-09_JPRB, 0.26273927E-09_JPRB, &
  & 0.26272512E-09_JPRB, 0.26270955E-09_JPRB, 0.26269456E-09_JPRB, 0.26268168E-09_JPRB, 0.26267100E-09_JPRB, 0.26266037E-09_JPRB, &
  & 0.26264865E-09_JPRB, 0.26263225E-09_JPRB, 0.26260136E-09_JPRB, 0.26251371E-09_JPRB /)

RGHG5(:,77, 4) = (/ &
  & 0.26244526E-09_JPRB, 0.26259239E-09_JPRB, 0.26265048E-09_JPRB, 0.26267827E-09_JPRB, 0.26270008E-09_JPRB, 0.26271998E-09_JPRB, &
  & 0.26273711E-09_JPRB, 0.26275440E-09_JPRB, 0.26276734E-09_JPRB, 0.26278096E-09_JPRB, 0.26279134E-09_JPRB, 0.26279934E-09_JPRB, &
  & 0.26280467E-09_JPRB, 0.26280594E-09_JPRB, 0.26280292E-09_JPRB, 0.26279767E-09_JPRB, 0.26279126E-09_JPRB, 0.26278729E-09_JPRB, &
  & 0.26278635E-09_JPRB, 0.26279187E-09_JPRB, 0.26280589E-09_JPRB, 0.26282782E-09_JPRB, 0.26285252E-09_JPRB, 0.26287969E-09_JPRB, &
  & 0.26290725E-09_JPRB, 0.26293084E-09_JPRB, 0.26294802E-09_JPRB, 0.26296157E-09_JPRB, 0.26296898E-09_JPRB, 0.26297081E-09_JPRB, &
  & 0.26296731E-09_JPRB, 0.26296079E-09_JPRB, 0.26294977E-09_JPRB, 0.26293140E-09_JPRB, 0.26290900E-09_JPRB, 0.26288260E-09_JPRB, &
  & 0.26285357E-09_JPRB, 0.26282543E-09_JPRB, 0.26280242E-09_JPRB, 0.26278901E-09_JPRB, 0.26278427E-09_JPRB, 0.26278735E-09_JPRB, &
  & 0.26279692E-09_JPRB, 0.26281000E-09_JPRB, 0.26282346E-09_JPRB, 0.26283770E-09_JPRB, 0.26284785E-09_JPRB, 0.26285427E-09_JPRB, &
  & 0.26285418E-09_JPRB, 0.26285324E-09_JPRB, 0.26284647E-09_JPRB, 0.26283922E-09_JPRB, 0.26282937E-09_JPRB, 0.26281899E-09_JPRB, &
  & 0.26280944E-09_JPRB, 0.26279837E-09_JPRB, 0.26278743E-09_JPRB, 0.26277852E-09_JPRB, 0.26277155E-09_JPRB, 0.26276376E-09_JPRB, &
  & 0.26275482E-09_JPRB, 0.26274175E-09_JPRB, 0.26271607E-09_JPRB, 0.26263974E-09_JPRB /)

RGHG5(:,78, 4) = (/ &
  & 0.26261909E-09_JPRB, 0.26273320E-09_JPRB, 0.26277314E-09_JPRB, 0.26279115E-09_JPRB, 0.26280630E-09_JPRB, 0.26282038E-09_JPRB, &
  & 0.26283259E-09_JPRB, 0.26284364E-09_JPRB, 0.26285060E-09_JPRB, 0.26285915E-09_JPRB, 0.26286490E-09_JPRB, 0.26286973E-09_JPRB, &
  & 0.26287314E-09_JPRB, 0.26287428E-09_JPRB, 0.26287222E-09_JPRB, 0.26286917E-09_JPRB, 0.26286515E-09_JPRB, 0.26286326E-09_JPRB, &
  & 0.26286234E-09_JPRB, 0.26286584E-09_JPRB, 0.26287514E-09_JPRB, 0.26289063E-09_JPRB, 0.26290578E-09_JPRB, 0.26292282E-09_JPRB, &
  & 0.26294075E-09_JPRB, 0.26295607E-09_JPRB, 0.26296643E-09_JPRB, 0.26297581E-09_JPRB, 0.26298075E-09_JPRB, 0.26298172E-09_JPRB, &
  & 0.26297886E-09_JPRB, 0.26297492E-09_JPRB, 0.26296873E-09_JPRB, 0.26295638E-09_JPRB, 0.26294178E-09_JPRB, 0.26292513E-09_JPRB, &
  & 0.26290647E-09_JPRB, 0.26288829E-09_JPRB, 0.26287356E-09_JPRB, 0.26286545E-09_JPRB, 0.26286237E-09_JPRB, 0.26286431E-09_JPRB, &
  & 0.26287023E-09_JPRB, 0.26287880E-09_JPRB, 0.26288674E-09_JPRB, 0.26289629E-09_JPRB, 0.26290239E-09_JPRB, 0.26290720E-09_JPRB, &
  & 0.26290636E-09_JPRB, 0.26290720E-09_JPRB, 0.26290245E-09_JPRB, 0.26289851E-09_JPRB, 0.26289240E-09_JPRB, 0.26288519E-09_JPRB, &
  & 0.26288013E-09_JPRB, 0.26287278E-09_JPRB, 0.26286545E-09_JPRB, 0.26286021E-09_JPRB, 0.26285654E-09_JPRB, 0.26285141E-09_JPRB, &
  & 0.26284491E-09_JPRB, 0.26283486E-09_JPRB, 0.26281774E-09_JPRB, 0.26275856E-09_JPRB /)

RGHG5(:,79, 4) = (/ &
  & 0.26273198E-09_JPRB, 0.26281163E-09_JPRB, 0.26283897E-09_JPRB, 0.26284958E-09_JPRB, 0.26286112E-09_JPRB, 0.26287267E-09_JPRB, &
  & 0.26288138E-09_JPRB, 0.26288996E-09_JPRB, 0.26289301E-09_JPRB, 0.26289956E-09_JPRB, 0.26290281E-09_JPRB, 0.26290614E-09_JPRB, &
  & 0.26290875E-09_JPRB, 0.26290986E-09_JPRB, 0.26290811E-09_JPRB, 0.26290639E-09_JPRB, 0.26290359E-09_JPRB, 0.26290303E-09_JPRB, &
  & 0.26290214E-09_JPRB, 0.26290459E-09_JPRB, 0.26291178E-09_JPRB, 0.26292399E-09_JPRB, 0.26293420E-09_JPRB, 0.26294580E-09_JPRB, &
  & 0.26295879E-09_JPRB, 0.26296976E-09_JPRB, 0.26297634E-09_JPRB, 0.26298366E-09_JPRB, 0.26298724E-09_JPRB, 0.26298780E-09_JPRB, &
  & 0.26298505E-09_JPRB, 0.26298261E-09_JPRB, 0.26297922E-09_JPRB, 0.26297009E-09_JPRB, 0.26295960E-09_JPRB, 0.26294827E-09_JPRB, &
  & 0.26293501E-09_JPRB, 0.26292221E-09_JPRB, 0.26291172E-09_JPRB, 0.26290639E-09_JPRB, 0.26290395E-09_JPRB, 0.26290511E-09_JPRB, &
  & 0.26290903E-09_JPRB, 0.26291511E-09_JPRB, 0.26292013E-09_JPRB, 0.26292707E-09_JPRB, 0.26293107E-09_JPRB, 0.26293501E-09_JPRB, &
  & 0.26293351E-09_JPRB, 0.26293551E-09_JPRB, 0.26293162E-09_JPRB, 0.26292962E-09_JPRB, 0.26292521E-09_JPRB, 0.26291958E-09_JPRB, &
  & 0.26291691E-09_JPRB, 0.26291128E-09_JPRB, 0.26290564E-09_JPRB, 0.26290220E-09_JPRB, 0.26290042E-09_JPRB, 0.26289654E-09_JPRB, &
  & 0.26289118E-09_JPRB, 0.26288377E-09_JPRB, 0.26287358E-09_JPRB, 0.26283428E-09_JPRB /)

RGHG5(:,80, 4) = (/ &
  & 0.26280655E-09_JPRB, 0.26284983E-09_JPRB, 0.26286778E-09_JPRB, 0.26287486E-09_JPRB, 0.26288455E-09_JPRB, 0.26289498E-09_JPRB, &
  & 0.26290278E-09_JPRB, 0.26290961E-09_JPRB, 0.26291180E-09_JPRB, 0.26291688E-09_JPRB, 0.26291977E-09_JPRB, 0.26292227E-09_JPRB, &
  & 0.26292463E-09_JPRB, 0.26292571E-09_JPRB, 0.26292410E-09_JPRB, 0.26292293E-09_JPRB, 0.26292069E-09_JPRB, 0.26292091E-09_JPRB, &
  & 0.26291996E-09_JPRB, 0.26292193E-09_JPRB, 0.26292815E-09_JPRB, 0.26293917E-09_JPRB, 0.26294703E-09_JPRB, 0.26295610E-09_JPRB, &
  & 0.26296693E-09_JPRB, 0.26297592E-09_JPRB, 0.26298083E-09_JPRB, 0.26298724E-09_JPRB, 0.26299032E-09_JPRB, 0.26299063E-09_JPRB, &
  & 0.26298788E-09_JPRB, 0.26298619E-09_JPRB, 0.26298416E-09_JPRB, 0.26297642E-09_JPRB, 0.26296773E-09_JPRB, 0.26295885E-09_JPRB, &
  & 0.26294808E-09_JPRB, 0.26293753E-09_JPRB, 0.26292896E-09_JPRB, 0.26292485E-09_JPRB, 0.26292268E-09_JPRB, 0.26292343E-09_JPRB, &
  & 0.26292640E-09_JPRB, 0.26293143E-09_JPRB, 0.26293495E-09_JPRB, 0.26294084E-09_JPRB, 0.26294378E-09_JPRB, 0.26294739E-09_JPRB, &
  & 0.26294542E-09_JPRB, 0.26294805E-09_JPRB, 0.26294442E-09_JPRB, 0.26294328E-09_JPRB, 0.26293953E-09_JPRB, 0.26293440E-09_JPRB, &
  & 0.26293287E-09_JPRB, 0.26292793E-09_JPRB, 0.26292279E-09_JPRB, 0.26292021E-09_JPRB, 0.26291933E-09_JPRB, 0.26291591E-09_JPRB, &
  & 0.26291111E-09_JPRB, 0.26290478E-09_JPRB, 0.26290023E-09_JPRB, 0.26288369E-09_JPRB /)

RGHG5(:,81, 4) = (/ &
  & 0.26285768E-09_JPRB, 0.26286587E-09_JPRB, 0.26288000E-09_JPRB, 0.26288544E-09_JPRB, 0.26289451E-09_JPRB, 0.26290470E-09_JPRB, &
  & 0.26291139E-09_JPRB, 0.26291852E-09_JPRB, 0.26291935E-09_JPRB, 0.26292529E-09_JPRB, 0.26292712E-09_JPRB, 0.26292971E-09_JPRB, &
  & 0.26293173E-09_JPRB, 0.26293279E-09_JPRB, 0.26293115E-09_JPRB, 0.26293021E-09_JPRB, 0.26292826E-09_JPRB, 0.26292885E-09_JPRB, &
  & 0.26292790E-09_JPRB, 0.26292957E-09_JPRB, 0.26293537E-09_JPRB, 0.26294594E-09_JPRB, 0.26295260E-09_JPRB, 0.26296063E-09_JPRB, &
  & 0.26297053E-09_JPRB, 0.26297872E-09_JPRB, 0.26298275E-09_JPRB, 0.26298885E-09_JPRB, 0.26299174E-09_JPRB, 0.26299188E-09_JPRB, &
  & 0.26298910E-09_JPRB, 0.26298777E-09_JPRB, 0.26298644E-09_JPRB, 0.26297922E-09_JPRB, 0.26297131E-09_JPRB, 0.26296354E-09_JPRB, &
  & 0.26295380E-09_JPRB, 0.26294436E-09_JPRB, 0.26293664E-09_JPRB, 0.26293304E-09_JPRB, 0.26293095E-09_JPRB, 0.26293151E-09_JPRB, &
  & 0.26293404E-09_JPRB, 0.26293856E-09_JPRB, 0.26294147E-09_JPRB, 0.26294689E-09_JPRB, 0.26294938E-09_JPRB, 0.26295277E-09_JPRB, &
  & 0.26295052E-09_JPRB, 0.26295358E-09_JPRB, 0.26294997E-09_JPRB, 0.26294922E-09_JPRB, 0.26294572E-09_JPRB, 0.26294078E-09_JPRB, &
  & 0.26293981E-09_JPRB, 0.26293503E-09_JPRB, 0.26293009E-09_JPRB, 0.26292793E-09_JPRB, 0.26292743E-09_JPRB, 0.26292415E-09_JPRB, &
  & 0.26291952E-09_JPRB, 0.26291350E-09_JPRB, 0.26291128E-09_JPRB, 0.26291722E-09_JPRB /)

RGHG5(:,82, 4) = (/ &
  & 0.26286173E-09_JPRB, 0.26287120E-09_JPRB, 0.26288532E-09_JPRB, 0.26289040E-09_JPRB, 0.26289934E-09_JPRB, 0.26290911E-09_JPRB, &
  & 0.26291672E-09_JPRB, 0.26292235E-09_JPRB, 0.26292407E-09_JPRB, 0.26292818E-09_JPRB, 0.26293107E-09_JPRB, 0.26293306E-09_JPRB, &
  & 0.26293531E-09_JPRB, 0.26293634E-09_JPRB, 0.26293465E-09_JPRB, 0.26293381E-09_JPRB, 0.26293201E-09_JPRB, 0.26293284E-09_JPRB, &
  & 0.26293182E-09_JPRB, 0.26293326E-09_JPRB, 0.26293889E-09_JPRB, 0.26294927E-09_JPRB, 0.26295541E-09_JPRB, 0.26296276E-09_JPRB, &
  & 0.26297237E-09_JPRB, 0.26298008E-09_JPRB, 0.26298372E-09_JPRB, 0.26298966E-09_JPRB, 0.26299243E-09_JPRB, 0.26299254E-09_JPRB, &
  & 0.26298971E-09_JPRB, 0.26298855E-09_JPRB, 0.26298755E-09_JPRB, 0.26298061E-09_JPRB, 0.26297306E-09_JPRB, 0.26296576E-09_JPRB, &
  & 0.26295660E-09_JPRB, 0.26294769E-09_JPRB, 0.26294047E-09_JPRB, 0.26293709E-09_JPRB, 0.26293509E-09_JPRB, 0.26293556E-09_JPRB, &
  & 0.26293784E-09_JPRB, 0.26294214E-09_JPRB, 0.26294467E-09_JPRB, 0.26294988E-09_JPRB, 0.26295202E-09_JPRB, 0.26295546E-09_JPRB, &
  & 0.26295299E-09_JPRB, 0.26295635E-09_JPRB, 0.26295266E-09_JPRB, 0.26295213E-09_JPRB, 0.26294872E-09_JPRB, 0.26294389E-09_JPRB, &
  & 0.26294319E-09_JPRB, 0.26293856E-09_JPRB, 0.26293365E-09_JPRB, 0.26293159E-09_JPRB, 0.26293134E-09_JPRB, 0.26292815E-09_JPRB, &
  & 0.26292343E-09_JPRB, 0.26291733E-09_JPRB, 0.26291488E-09_JPRB, 0.26291985E-09_JPRB /)

RGHG5(:,83, 4) = (/ &
  & 0.26286445E-09_JPRB, 0.26287439E-09_JPRB, 0.26288832E-09_JPRB, 0.26289329E-09_JPRB, 0.26290187E-09_JPRB, 0.26291225E-09_JPRB, &
  & 0.26291780E-09_JPRB, 0.26292529E-09_JPRB, 0.26292546E-09_JPRB, 0.26293165E-09_JPRB, 0.26293293E-09_JPRB, 0.26293545E-09_JPRB, &
  & 0.26293720E-09_JPRB, 0.26293825E-09_JPRB, 0.26293662E-09_JPRB, 0.26293587E-09_JPRB, 0.26293412E-09_JPRB, 0.26293506E-09_JPRB, &
  & 0.26293401E-09_JPRB, 0.26293537E-09_JPRB, 0.26294078E-09_JPRB, 0.26295133E-09_JPRB, 0.26295693E-09_JPRB, 0.26296409E-09_JPRB, &
  & 0.26297337E-09_JPRB, 0.26298094E-09_JPRB, 0.26298427E-09_JPRB, 0.26299019E-09_JPRB, 0.26299291E-09_JPRB, 0.26299296E-09_JPRB, &
  & 0.26299005E-09_JPRB, 0.26298894E-09_JPRB, 0.26298813E-09_JPRB, 0.26298125E-09_JPRB, 0.26297395E-09_JPRB, 0.26296695E-09_JPRB, &
  & 0.26295810E-09_JPRB, 0.26294966E-09_JPRB, 0.26294275E-09_JPRB, 0.26293959E-09_JPRB, 0.26293756E-09_JPRB, 0.26293789E-09_JPRB, &
  & 0.26294000E-09_JPRB, 0.26294408E-09_JPRB, 0.26294647E-09_JPRB, 0.26295152E-09_JPRB, 0.26295355E-09_JPRB, 0.26295699E-09_JPRB, &
  & 0.26295438E-09_JPRB, 0.26295796E-09_JPRB, 0.26295421E-09_JPRB, 0.26295380E-09_JPRB, 0.26295047E-09_JPRB, 0.26294558E-09_JPRB, &
  & 0.26294511E-09_JPRB, 0.26294047E-09_JPRB, 0.26293556E-09_JPRB, 0.26293365E-09_JPRB, 0.26293359E-09_JPRB, 0.26293048E-09_JPRB, &
  & 0.26292571E-09_JPRB, 0.26291944E-09_JPRB, 0.26291699E-09_JPRB, 0.26292168E-09_JPRB /)

RGHG5(:,84, 4) = (/ &
  & 0.26286631E-09_JPRB, 0.26287630E-09_JPRB, 0.26289027E-09_JPRB, 0.26289501E-09_JPRB, 0.26290384E-09_JPRB, 0.26291325E-09_JPRB, &
  & 0.26292141E-09_JPRB, 0.26292604E-09_JPRB, 0.26292818E-09_JPRB, 0.26293151E-09_JPRB, 0.26293451E-09_JPRB, 0.26293623E-09_JPRB, &
  & 0.26293837E-09_JPRB, 0.26293931E-09_JPRB, 0.26293787E-09_JPRB, 0.26293709E-09_JPRB, 0.26293542E-09_JPRB, 0.26293648E-09_JPRB, &
  & 0.26293534E-09_JPRB, 0.26293659E-09_JPRB, 0.26294200E-09_JPRB, 0.26295255E-09_JPRB, 0.26295793E-09_JPRB, 0.26296476E-09_JPRB, &
  & 0.26297414E-09_JPRB, 0.26298147E-09_JPRB, 0.26298452E-09_JPRB, 0.26299049E-09_JPRB, 0.26299313E-09_JPRB, 0.26299318E-09_JPRB, &
  & 0.26299019E-09_JPRB, 0.26298924E-09_JPRB, 0.26298846E-09_JPRB, 0.26298169E-09_JPRB, 0.26297442E-09_JPRB, 0.26296754E-09_JPRB, &
  & 0.26295896E-09_JPRB, 0.26295077E-09_JPRB, 0.26294436E-09_JPRB, 0.26294111E-09_JPRB, 0.26293925E-09_JPRB, 0.26293945E-09_JPRB, &
  & 0.26294136E-09_JPRB, 0.26294519E-09_JPRB, 0.26294750E-09_JPRB, 0.26295255E-09_JPRB, 0.26295441E-09_JPRB, 0.26295791E-09_JPRB, &
  & 0.26295524E-09_JPRB, 0.26295899E-09_JPRB, 0.26295516E-09_JPRB, 0.26295482E-09_JPRB, 0.26295149E-09_JPRB, 0.26294661E-09_JPRB, &
  & 0.26294633E-09_JPRB, 0.26294170E-09_JPRB, 0.26293676E-09_JPRB, 0.26293495E-09_JPRB, 0.26293498E-09_JPRB, 0.26293193E-09_JPRB, &
  & 0.26292707E-09_JPRB, 0.26292074E-09_JPRB, 0.26291830E-09_JPRB, 0.26292293E-09_JPRB /)

RGHG5(:,85, 4) = (/ &
  & 0.26286753E-09_JPRB, 0.26287766E-09_JPRB, 0.26289154E-09_JPRB, 0.26289615E-09_JPRB, 0.26290464E-09_JPRB, 0.26291558E-09_JPRB, &
  & 0.26292071E-09_JPRB, 0.26292785E-09_JPRB, 0.26292848E-09_JPRB, 0.26293356E-09_JPRB, 0.26293501E-09_JPRB, 0.26293728E-09_JPRB, &
  & 0.26293878E-09_JPRB, 0.26293973E-09_JPRB, 0.26293864E-09_JPRB, 0.26293784E-09_JPRB, 0.26293634E-09_JPRB, 0.26293739E-09_JPRB, &
  & 0.26293626E-09_JPRB, 0.26293737E-09_JPRB, 0.26294275E-09_JPRB, 0.26295349E-09_JPRB, 0.26295849E-09_JPRB, 0.26296526E-09_JPRB, &
  & 0.26297459E-09_JPRB, 0.26298189E-09_JPRB, 0.26298466E-09_JPRB, 0.26299074E-09_JPRB, 0.26299340E-09_JPRB, 0.26299338E-09_JPRB, &
  & 0.26299035E-09_JPRB, 0.26298946E-09_JPRB, 0.26298871E-09_JPRB, 0.26298191E-09_JPRB, 0.26297473E-09_JPRB, 0.26296790E-09_JPRB, &
  & 0.26295943E-09_JPRB, 0.26295158E-09_JPRB, 0.26294522E-09_JPRB, 0.26294225E-09_JPRB, 0.26294042E-09_JPRB, 0.26294059E-09_JPRB, &
  & 0.26294228E-09_JPRB, 0.26294594E-09_JPRB, 0.26294819E-09_JPRB, 0.26295319E-09_JPRB, 0.26295499E-09_JPRB, 0.26295852E-09_JPRB, &
  & 0.26295582E-09_JPRB, 0.26295977E-09_JPRB, 0.26295582E-09_JPRB, 0.26295549E-09_JPRB, 0.26295227E-09_JPRB, 0.26294736E-09_JPRB, &
  & 0.26294716E-09_JPRB, 0.26294253E-09_JPRB, 0.26293753E-09_JPRB, 0.26293578E-09_JPRB, 0.26293598E-09_JPRB, 0.26293284E-09_JPRB, &
  & 0.26292798E-09_JPRB, 0.26292155E-09_JPRB, 0.26291916E-09_JPRB, 0.26292368E-09_JPRB /)

RGHG5(:,86, 4) = (/ &
  & 0.26286828E-09_JPRB, 0.26287844E-09_JPRB, 0.26289226E-09_JPRB, 0.26289682E-09_JPRB, 0.26290622E-09_JPRB, 0.26291561E-09_JPRB, &
  & 0.26292368E-09_JPRB, 0.26292790E-09_JPRB, 0.26293026E-09_JPRB, 0.26293318E-09_JPRB, 0.26293573E-09_JPRB, 0.26293726E-09_JPRB, &
  & 0.26293898E-09_JPRB, 0.26293973E-09_JPRB, 0.26293903E-09_JPRB, 0.26293831E-09_JPRB, 0.26293703E-09_JPRB, 0.26293787E-09_JPRB, &
  & 0.26293684E-09_JPRB, 0.26293792E-09_JPRB, 0.26294319E-09_JPRB, 0.26295399E-09_JPRB, 0.26295885E-09_JPRB, 0.26296548E-09_JPRB, &
  & 0.26297495E-09_JPRB, 0.26298216E-09_JPRB, 0.26298475E-09_JPRB, 0.26299091E-09_JPRB, 0.26299357E-09_JPRB, 0.26299354E-09_JPRB, &
  & 0.26299046E-09_JPRB, 0.26298957E-09_JPRB, 0.26298885E-09_JPRB, 0.26298225E-09_JPRB, 0.26297500E-09_JPRB, 0.26296831E-09_JPRB, &
  & 0.26295982E-09_JPRB, 0.26295194E-09_JPRB, 0.26294578E-09_JPRB, 0.26294272E-09_JPRB, 0.26294106E-09_JPRB, 0.26294122E-09_JPRB, &
  & 0.26294295E-09_JPRB, 0.26294636E-09_JPRB, 0.26294866E-09_JPRB, 0.26295360E-09_JPRB, 0.26295538E-09_JPRB, 0.26295890E-09_JPRB, &
  & 0.26295618E-09_JPRB, 0.26296024E-09_JPRB, 0.26295627E-09_JPRB, 0.26295599E-09_JPRB, 0.26295274E-09_JPRB, 0.26294775E-09_JPRB, &
  & 0.26294766E-09_JPRB, 0.26294306E-09_JPRB, 0.26293798E-09_JPRB, 0.26293634E-09_JPRB, 0.26293662E-09_JPRB, 0.26293359E-09_JPRB, &
  & 0.26292860E-09_JPRB, 0.26292213E-09_JPRB, 0.26291963E-09_JPRB, 0.26292415E-09_JPRB /)

RGHG5(:,87, 4) = (/ &
  & 0.26286889E-09_JPRB, 0.26287911E-09_JPRB, 0.26289268E-09_JPRB, 0.26289743E-09_JPRB, 0.26290611E-09_JPRB, 0.26291780E-09_JPRB, &
  & 0.26292302E-09_JPRB, 0.26292907E-09_JPRB, 0.26293051E-09_JPRB, 0.26293429E-09_JPRB, 0.26293584E-09_JPRB, 0.26293775E-09_JPRB, &
  & 0.26293889E-09_JPRB, 0.26293967E-09_JPRB, 0.26293917E-09_JPRB, 0.26293856E-09_JPRB, 0.26293748E-09_JPRB, 0.26293817E-09_JPRB, &
  & 0.26293720E-09_JPRB, 0.26293823E-09_JPRB, 0.26294344E-09_JPRB, 0.26295435E-09_JPRB, 0.26295904E-09_JPRB, 0.26296559E-09_JPRB, &
  & 0.26297514E-09_JPRB, 0.26298236E-09_JPRB, 0.26298480E-09_JPRB, 0.26299107E-09_JPRB, 0.26299374E-09_JPRB, 0.26299368E-09_JPRB, &
  & 0.26299052E-09_JPRB, 0.26298963E-09_JPRB, 0.26298907E-09_JPRB, 0.26298247E-09_JPRB, 0.26297542E-09_JPRB, 0.26296881E-09_JPRB, &
  & 0.26296029E-09_JPRB, 0.26295222E-09_JPRB, 0.26294578E-09_JPRB, 0.26294289E-09_JPRB, 0.26294111E-09_JPRB, 0.26294139E-09_JPRB, &
  & 0.26294311E-09_JPRB, 0.26294691E-09_JPRB, 0.26294900E-09_JPRB, 0.26295402E-09_JPRB, 0.26295563E-09_JPRB, 0.26295915E-09_JPRB, &
  & 0.26295638E-09_JPRB, 0.26296057E-09_JPRB, 0.26295649E-09_JPRB, 0.26295632E-09_JPRB, 0.26295308E-09_JPRB, 0.26294811E-09_JPRB, &
  & 0.26294800E-09_JPRB, 0.26294333E-09_JPRB, 0.26293828E-09_JPRB, 0.26293664E-09_JPRB, 0.26293698E-09_JPRB, 0.26293395E-09_JPRB, &
  & 0.26292896E-09_JPRB, 0.26292238E-09_JPRB, 0.26291985E-09_JPRB, 0.26292438E-09_JPRB /)

RGHG5(:,88, 4) = (/ &
  & 0.26286970E-09_JPRB, 0.26287983E-09_JPRB, 0.26289271E-09_JPRB, 0.26289751E-09_JPRB, 0.26290753E-09_JPRB, 0.26291691E-09_JPRB, &
  & 0.26292465E-09_JPRB, 0.26292890E-09_JPRB, 0.26293120E-09_JPRB, 0.26293398E-09_JPRB, 0.26293617E-09_JPRB, 0.26293753E-09_JPRB, &
  & 0.26293900E-09_JPRB, 0.26293967E-09_JPRB, 0.26293934E-09_JPRB, 0.26293878E-09_JPRB, 0.26293775E-09_JPRB, 0.26293845E-09_JPRB, &
  & 0.26293751E-09_JPRB, 0.26293848E-09_JPRB, 0.26294356E-09_JPRB, 0.26295460E-09_JPRB, 0.26295918E-09_JPRB, 0.26296568E-09_JPRB, &
  & 0.26297531E-09_JPRB, 0.26298247E-09_JPRB, 0.26298475E-09_JPRB, 0.26299121E-09_JPRB, 0.26299382E-09_JPRB, 0.26299377E-09_JPRB, &
  & 0.26299055E-09_JPRB, 0.26298977E-09_JPRB, 0.26298935E-09_JPRB, 0.26298280E-09_JPRB, 0.26297572E-09_JPRB, 0.26296940E-09_JPRB, &
  & 0.26296068E-09_JPRB, 0.26295230E-09_JPRB, 0.26294558E-09_JPRB, 0.26294272E-09_JPRB, 0.26294089E-09_JPRB, 0.26294125E-09_JPRB, &
  & 0.26294328E-09_JPRB, 0.26294725E-09_JPRB, 0.26294927E-09_JPRB, 0.26295432E-09_JPRB, 0.26295577E-09_JPRB, 0.26295935E-09_JPRB, &
  & 0.26295655E-09_JPRB, 0.26296088E-09_JPRB, 0.26295668E-09_JPRB, 0.26295660E-09_JPRB, 0.26295327E-09_JPRB, 0.26294830E-09_JPRB, &
  & 0.26294822E-09_JPRB, 0.26294350E-09_JPRB, 0.26293842E-09_JPRB, 0.26293684E-09_JPRB, 0.26293726E-09_JPRB, 0.26293426E-09_JPRB, &
  & 0.26292915E-09_JPRB, 0.26292257E-09_JPRB, 0.26291999E-09_JPRB, 0.26292457E-09_JPRB /)

RGHG5(:,89, 4) = (/ &
  & 0.26287078E-09_JPRB, 0.26288077E-09_JPRB, 0.26289243E-09_JPRB, 0.26289754E-09_JPRB, 0.26290631E-09_JPRB, 0.26291791E-09_JPRB, &
  & 0.26292343E-09_JPRB, 0.26292940E-09_JPRB, 0.26293093E-09_JPRB, 0.26293459E-09_JPRB, 0.26293617E-09_JPRB, 0.26293792E-09_JPRB, &
  & 0.26293906E-09_JPRB, 0.26293984E-09_JPRB, 0.26293945E-09_JPRB, 0.26293884E-09_JPRB, 0.26293778E-09_JPRB, 0.26293862E-09_JPRB, &
  & 0.26293756E-09_JPRB, 0.26293850E-09_JPRB, 0.26294364E-09_JPRB, 0.26295477E-09_JPRB, 0.26295921E-09_JPRB, 0.26296565E-09_JPRB, &
  & 0.26297545E-09_JPRB, 0.26298264E-09_JPRB, 0.26298477E-09_JPRB, 0.26299130E-09_JPRB, 0.26299399E-09_JPRB, 0.26299393E-09_JPRB, &
  & 0.26299052E-09_JPRB, 0.26298980E-09_JPRB, 0.26298952E-09_JPRB, 0.26298302E-09_JPRB, 0.26297597E-09_JPRB, 0.26296984E-09_JPRB, &
  & 0.26296101E-09_JPRB, 0.26295244E-09_JPRB, 0.26294525E-09_JPRB, 0.26294261E-09_JPRB, 0.26294059E-09_JPRB, 0.26294114E-09_JPRB, &
  & 0.26294319E-09_JPRB, 0.26294775E-09_JPRB, 0.26294941E-09_JPRB, 0.26295460E-09_JPRB, 0.26295591E-09_JPRB, 0.26295949E-09_JPRB, &
  & 0.26295655E-09_JPRB, 0.26296107E-09_JPRB, 0.26295674E-09_JPRB, 0.26295674E-09_JPRB, 0.26295338E-09_JPRB, 0.26294836E-09_JPRB, &
  & 0.26294839E-09_JPRB, 0.26294361E-09_JPRB, 0.26293848E-09_JPRB, 0.26293695E-09_JPRB, 0.26293742E-09_JPRB, 0.26293442E-09_JPRB, &
  & 0.26292929E-09_JPRB, 0.26292266E-09_JPRB, 0.26291999E-09_JPRB, 0.26292463E-09_JPRB /)

RGHG5(:,90, 4) = (/ &
  & 0.26287184E-09_JPRB, 0.26288161E-09_JPRB, 0.26289182E-09_JPRB, 0.26289698E-09_JPRB, 0.26290636E-09_JPRB, 0.26291644E-09_JPRB, &
  & 0.26292363E-09_JPRB, 0.26292910E-09_JPRB, 0.26293068E-09_JPRB, 0.26293456E-09_JPRB, 0.26293676E-09_JPRB, 0.26293809E-09_JPRB, &
  & 0.26293967E-09_JPRB, 0.26294042E-09_JPRB, 0.26293964E-09_JPRB, 0.26293889E-09_JPRB, 0.26293762E-09_JPRB, 0.26293881E-09_JPRB, &
  & 0.26293751E-09_JPRB, 0.26293845E-09_JPRB, 0.26294350E-09_JPRB, 0.26295505E-09_JPRB, 0.26295918E-09_JPRB, 0.26296559E-09_JPRB, &
  & 0.26297553E-09_JPRB, 0.26298283E-09_JPRB, 0.26298472E-09_JPRB, 0.26299146E-09_JPRB, 0.26299413E-09_JPRB, 0.26299407E-09_JPRB, &
  & 0.26299046E-09_JPRB, 0.26298982E-09_JPRB, 0.26298988E-09_JPRB, 0.26298314E-09_JPRB, 0.26297603E-09_JPRB, 0.26297003E-09_JPRB, &
  & 0.26296118E-09_JPRB, 0.26295241E-09_JPRB, 0.26294494E-09_JPRB, 0.26294250E-09_JPRB, 0.26294031E-09_JPRB, 0.26294097E-09_JPRB, &
  & 0.26294319E-09_JPRB, 0.26294797E-09_JPRB, 0.26294941E-09_JPRB, 0.26295477E-09_JPRB, 0.26295585E-09_JPRB, 0.26295968E-09_JPRB, &
  & 0.26295638E-09_JPRB, 0.26296129E-09_JPRB, 0.26295666E-09_JPRB, 0.26295693E-09_JPRB, 0.26295344E-09_JPRB, 0.26294827E-09_JPRB, &
  & 0.26294852E-09_JPRB, 0.26294367E-09_JPRB, 0.26293842E-09_JPRB, 0.26293695E-09_JPRB, 0.26293751E-09_JPRB, 0.26293451E-09_JPRB, &
  & 0.26292937E-09_JPRB, 0.26292252E-09_JPRB, 0.26291994E-09_JPRB, 0.26292477E-09_JPRB /)

RGHG5(:,91, 4) = (/ &
  & 0.26287217E-09_JPRB, 0.26288208E-09_JPRB, 0.26289027E-09_JPRB, 0.26289659E-09_JPRB, 0.26290553E-09_JPRB, 0.26291630E-09_JPRB, &
  & 0.26292163E-09_JPRB, 0.26293065E-09_JPRB, 0.26292613E-09_JPRB, 0.26293628E-09_JPRB, 0.26293745E-09_JPRB, 0.26293809E-09_JPRB, &
  & 0.26294097E-09_JPRB, 0.26294192E-09_JPRB, 0.26293956E-09_JPRB, 0.26293889E-09_JPRB, 0.26293703E-09_JPRB, 0.26293923E-09_JPRB, &
  & 0.26293726E-09_JPRB, 0.26293817E-09_JPRB, 0.26294308E-09_JPRB, 0.26295552E-09_JPRB, 0.26295904E-09_JPRB, 0.26296537E-09_JPRB, &
  & 0.26297575E-09_JPRB, 0.26298316E-09_JPRB, 0.26298433E-09_JPRB, 0.26299174E-09_JPRB, 0.26299438E-09_JPRB, 0.26299438E-09_JPRB, &
  & 0.26299024E-09_JPRB, 0.26298977E-09_JPRB, 0.26299060E-09_JPRB, 0.26298311E-09_JPRB, 0.26297597E-09_JPRB, 0.26297034E-09_JPRB, &
  & 0.26296115E-09_JPRB, 0.26295233E-09_JPRB, 0.26294453E-09_JPRB, 0.26294253E-09_JPRB, 0.26294009E-09_JPRB, 0.26294078E-09_JPRB, &
  & 0.26294300E-09_JPRB, 0.26294833E-09_JPRB, 0.26294922E-09_JPRB, 0.26295510E-09_JPRB, 0.26295577E-09_JPRB, 0.26296018E-09_JPRB, &
  & 0.26295588E-09_JPRB, 0.26296199E-09_JPRB, 0.26295632E-09_JPRB, 0.26295710E-09_JPRB, 0.26295358E-09_JPRB, 0.26294794E-09_JPRB, &
  & 0.26294891E-09_JPRB, 0.26294367E-09_JPRB, 0.26293814E-09_JPRB, 0.26293678E-09_JPRB, 0.26293778E-09_JPRB, 0.26293465E-09_JPRB, &
  & 0.26292932E-09_JPRB, 0.26292207E-09_JPRB, 0.26291969E-09_JPRB, 0.26292488E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART8',1,ZHOOK_HANDLE)
END SUBROUTINE PART8






SUBROUTINE PART9
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART9',0,ZHOOK_HANDLE)



!-- Month=  5 ------------

RGHG5(:, 1, 5) = (/ &
  & 0.14012985E-44_JPRB, 0.16815582E-43_JPRB, 0.28025969E-43_JPRB, 0.36433760E-43_JPRB, 0.43440252E-43_JPRB, 0.54650640E-43_JPRB, &
  & 0.68663625E-43_JPRB, 0.92485699E-43_JPRB, 0.13172206E-42_JPRB, 0.19478049E-42_JPRB, 0.30408177E-42_JPRB, 0.48765187E-42_JPRB, &
  & 0.81975960E-42_JPRB, 0.13508517E-41_JPRB, 0.23205503E-41_JPRB, 0.37148422E-41_JPRB, 0.61643119E-41_JPRB, 0.93915023E-41_JPRB, &
  & 0.14436177E-40_JPRB, 0.20830302E-40_JPRB, 0.29622048E-40_JPRB, 0.40725937E-40_JPRB, 0.54513313E-40_JPRB, 0.71157936E-40_JPRB, &
  & 0.91716386E-40_JPRB, 0.11773429E-39_JPRB, 0.15006085E-39_JPRB, 0.18967415E-39_JPRB, 0.21879874E-39_JPRB, 0.30540179E-39_JPRB, &
  & 0.31714747E-39_JPRB, 0.49136391E-39_JPRB, 0.50624850E-39_JPRB, 0.89908431E-39_JPRB, 0.66918027E-39_JPRB, 0.11375531E-38_JPRB, &
  & 0.11841476E-38_JPRB, 0.95730125E-39_JPRB, 0.47135757E-39_JPRB, 0.32437397E-39_JPRB, 0.20027498E-39_JPRB, 0.10397494E-39_JPRB, &
  & 0.58773260E-40_JPRB, 0.28960635E-40_JPRB, 0.13245073E-40_JPRB, 0.46130745E-41_JPRB, 0.14839751E-41_JPRB, 0.50446745E-42_JPRB, &
  & 0.24102334E-42_JPRB, 0.15414283E-42_JPRB, 0.91084400E-43_JPRB, 0.50446745E-43_JPRB, 0.23822074E-43_JPRB, 0.11210388E-43_JPRB, &
  & 0.56051939E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG5(:, 2, 5) = (/ &
  & 0.14993894E-42_JPRB, 0.63618950E-42_JPRB, 0.11378544E-41_JPRB, 0.15063958E-41_JPRB, 0.18048724E-41_JPRB, 0.21888282E-41_JPRB, &
  & 0.27857813E-41_JPRB, 0.37736968E-41_JPRB, 0.54202225E-41_JPRB, 0.81471493E-41_JPRB, 0.12758823E-40_JPRB, 0.20498194E-40_JPRB, &
  & 0.34334615E-40_JPRB, 0.56703542E-40_JPRB, 0.96522840E-40_JPRB, 0.15467953E-39_JPRB, 0.25301705E-39_JPRB, 0.38437056E-39_JPRB, &
  & 0.58432324E-39_JPRB, 0.84046939E-39_JPRB, 0.11902531E-38_JPRB, 0.16341480E-38_JPRB, 0.21862274E-38_JPRB, 0.28596494E-38_JPRB, &
  & 0.36852356E-38_JPRB, 0.47076762E-38_JPRB, 0.59558786E-38_JPRB, 0.74609054E-38_JPRB, 0.88828408E-38_JPRB, 0.11837092E-37_JPRB, &
  & 0.13116098E-37_JPRB, 0.19230867E-37_JPRB, 0.21311028E-37_JPRB, 0.34184875E-37_JPRB, 0.28991360E-37_JPRB, 0.43835895E-37_JPRB, &
  & 0.45615600E-37_JPRB, 0.36727624E-37_JPRB, 0.20090608E-37_JPRB, 0.13313190E-37_JPRB, 0.81663765E-38_JPRB, 0.42827030E-38_JPRB, &
  & 0.23981191E-38_JPRB, 0.11900779E-38_JPRB, 0.55039080E-39_JPRB, 0.20227043E-39_JPRB, 0.68841590E-40_JPRB, 0.23972013E-40_JPRB, &
  & 0.10739551E-40_JPRB, 0.64025327E-41_JPRB, 0.37596838E-41_JPRB, 0.20515010E-41_JPRB, 0.10215466E-41_JPRB, 0.48765187E-42_JPRB, &
  & 0.22701035E-42_JPRB, 0.99492191E-43_JPRB, 0.42038954E-43_JPRB, 0.21019477E-43_JPRB, 0.14012985E-43_JPRB, 0.12611686E-43_JPRB, &
  & 0.16815582E-43_JPRB, 0.19618179E-43_JPRB, 0.11210388E-43_JPRB, 0.00000000E+00_JPRB /)

RGHG5(:, 3, 5) = (/ &
  & 0.65889054E-41_JPRB, 0.31426921E-40_JPRB, 0.57144951E-40_JPRB, 0.73687280E-40_JPRB, 0.87641410E-40_JPRB, 0.10542669E-39_JPRB, &
  & 0.13364744E-39_JPRB, 0.18054750E-39_JPRB, 0.25857180E-39_JPRB, 0.38829420E-39_JPRB, 0.60733256E-39_JPRB, 0.97470818E-39_JPRB, &
  & 0.16358814E-38_JPRB, 0.26956470E-38_JPRB, 0.45922022E-38_JPRB, 0.73175091E-38_JPRB, 0.11962102E-37_JPRB, 0.18095287E-37_JPRB, &
  & 0.27563771E-37_JPRB, 0.39701568E-37_JPRB, 0.56478808E-37_JPRB, 0.77828229E-37_JPRB, 0.10449328E-36_JPRB, 0.13656171E-36_JPRB, &
  & 0.17602362E-36_JPRB, 0.22348652E-36_JPRB, 0.28172774E-36_JPRB, 0.35179197E-36_JPRB, 0.42180783E-36_JPRB, 0.55691466E-36_JPRB, &
  & 0.62756360E-36_JPRB, 0.90998529E-36_JPRB, 0.10263427E-35_JPRB, 0.16061505E-35_JPRB, 0.14106332E-35_JPRB, 0.20597452E-35_JPRB, &
  & 0.21378209E-35_JPRB, 0.17338291E-35_JPRB, 0.97681947E-36_JPRB, 0.64781611E-36_JPRB, 0.39475528E-36_JPRB, 0.20099488E-36_JPRB, &
  & 0.11075426E-36_JPRB, 0.53076399E-37_JPRB, 0.23961027E-37_JPRB, 0.84425178E-38_JPRB, 0.28943946E-38_JPRB, 0.10658122E-38_JPRB, &
  & 0.51138986E-39_JPRB, 0.30935065E-39_JPRB, 0.18334449E-39_JPRB, 0.10062024E-39_JPRB, 0.50717195E-40_JPRB, 0.24343357E-40_JPRB, &
  & 0.11511667E-40_JPRB, 0.50797069E-41_JPRB, 0.21888282E-41_JPRB, 0.10705920E-41_JPRB, 0.68383365E-42_JPRB, 0.65020249E-42_JPRB, &
  & 0.84778557E-42_JPRB, 0.10075336E-41_JPRB, 0.70905702E-42_JPRB, 0.17656361E-42_JPRB /)

RGHG5(:, 4, 5) = (/ &
  & 0.83087750E-39_JPRB, 0.36675960E-38_JPRB, 0.58773807E-38_JPRB, 0.72521526E-38_JPRB, 0.84348975E-38_JPRB, 0.10084290E-37_JPRB, &
  & 0.12704347E-37_JPRB, 0.17046804E-37_JPRB, 0.24312604E-37_JPRB, 0.36271526E-37_JPRB, 0.56552225E-37_JPRB, 0.90312632E-37_JPRB, &
  & 0.15162455E-36_JPRB, 0.24842811E-36_JPRB, 0.42314819E-36_JPRB, 0.66795571E-36_JPRB, 0.10896910E-35_JPRB, 0.16348099E-35_JPRB, &
  & 0.24870087E-35_JPRB, 0.35686800E-35_JPRB, 0.50711432E-35_JPRB, 0.69732658E-35_JPRB, 0.93200946E-35_JPRB, 0.12133481E-34_JPRB, &
  & 0.15516267E-34_JPRB, 0.19617252E-34_JPRB, 0.24613133E-34_JPRB, 0.30700566E-34_JPRB, 0.36806599E-34_JPRB, 0.48674696E-34_JPRB, &
  & 0.54839262E-34_JPRB, 0.79648277E-34_JPRB, 0.89929479E-34_JPRB, 0.14090332E-33_JPRB, 0.12413468E-33_JPRB, 0.18137887E-33_JPRB, &
  & 0.18841334E-33_JPRB, 0.15315378E-33_JPRB, 0.87860058E-34_JPRB, 0.58515058E-34_JPRB, 0.35715060E-34_JPRB, 0.17741773E-34_JPRB, &
  & 0.96974854E-35_JPRB, 0.45054882E-35_JPRB, 0.19986112E-35_JPRB, 0.67199544E-36_JPRB, 0.23223621E-36_JPRB, 0.90669476E-37_JPRB, &
  & 0.46273218E-37_JPRB, 0.28979870E-37_JPRB, 0.17375054E-37_JPRB, 0.96313387E-38_JPRB, 0.48865323E-38_JPRB, 0.23716598E-38_JPRB, &
  & 0.11222523E-38_JPRB, 0.49948023E-39_JPRB, 0.21305482E-39_JPRB, 0.10353914E-39_JPRB, 0.65905869E-40_JPRB, 0.64023926E-40_JPRB, &
  & 0.87585358E-40_JPRB, 0.11221318E-39_JPRB, 0.94884722E-40_JPRB, 0.44295044E-40_JPRB /)

RGHG5(:, 5, 5) = (/ &
  & 0.52034970E-36_JPRB, 0.11049505E-35_JPRB, 0.14801483E-35_JPRB, 0.17089260E-35_JPRB, 0.19662491E-35_JPRB, 0.23350585E-35_JPRB, &
  & 0.29224763E-35_JPRB, 0.38899920E-35_JPRB, 0.54839086E-35_JPRB, 0.81017325E-35_JPRB, 0.12488666E-34_JPRB, 0.19700964E-34_JPRB, &
  & 0.32729362E-34_JPRB, 0.52828151E-34_JPRB, 0.88779607E-34_JPRB, 0.13753884E-33_JPRB, 0.22061205E-33_JPRB, 0.32440531E-33_JPRB, &
  & 0.48459360E-33_JPRB, 0.68207004E-33_JPRB, 0.95137891E-33_JPRB, 0.12838979E-32_JPRB, 0.16851062E-32_JPRB, 0.21529012E-32_JPRB, &
  & 0.27115845E-32_JPRB, 0.33784883E-32_JPRB, 0.41993537E-32_JPRB, 0.52068192E-32_JPRB, 0.61952027E-32_JPRB, 0.82167209E-32_JPRB, &
  & 0.91668767E-32_JPRB, 0.13397732E-31_JPRB, 0.15052010E-31_JPRB, 0.23858617E-31_JPRB, 0.20993988E-31_JPRB, 0.31176784E-31_JPRB, &
  & 0.32680988E-31_JPRB, 0.26855917E-31_JPRB, 0.15571283E-31_JPRB, 0.10569107E-31_JPRB, 0.65587780E-32_JPRB, 0.32634603E-32_JPRB, &
  & 0.18145392E-32_JPRB, 0.84335282E-33_JPRB, 0.37838378E-33_JPRB, 0.12638953E-33_JPRB, 0.44809543E-34_JPRB, 0.18223810E-34_JPRB, &
  & 0.97275515E-35_JPRB, 0.62602816E-35_JPRB, 0.38285967E-35_JPRB, 0.21535939E-35_JPRB, 0.11096122E-35_JPRB, 0.54524716E-36_JPRB, &
  & 0.26186742E-36_JPRB, 0.11676767E-36_JPRB, 0.49481934E-37_JPRB, 0.23751370E-37_JPRB, 0.15052339E-37_JPRB, 0.14964637E-37_JPRB, &
  & 0.21745037E-37_JPRB, 0.30485433E-37_JPRB, 0.31571725E-37_JPRB, 0.39102659E-37_JPRB /)

RGHG5(:, 6, 5) = (/ &
  & 0.45603533E-33_JPRB, 0.68502732E-33_JPRB, 0.80962054E-33_JPRB, 0.91532191E-33_JPRB, 0.10430319E-32_JPRB, 0.12270769E-32_JPRB, &
  & 0.15132054E-32_JPRB, 0.19762999E-32_JPRB, 0.27245061E-32_JPRB, 0.39176835E-32_JPRB, 0.58668130E-32_JPRB, 0.89537317E-32_JPRB, &
  & 0.14362566E-31_JPRB, 0.22282251E-31_JPRB, 0.35977092E-31_JPRB, 0.53323386E-31_JPRB, 0.81863331E-31_JPRB, 0.11498977E-30_JPRB, &
  & 0.16419618E-30_JPRB, 0.22105120E-30_JPRB, 0.29548695E-30_JPRB, 0.38307179E-30_JPRB, 0.48432718E-30_JPRB, 0.59787523E-30_JPRB, &
  & 0.72964665E-30_JPRB, 0.88549773E-30_JPRB, 0.10768373E-29_JPRB, 0.13141950E-29_JPRB, 0.15379786E-29_JPRB, 0.20333451E-29_JPRB, &
  & 0.22403049E-29_JPRB, 0.32841029E-29_JPRB, 0.36842310E-29_JPRB, 0.59120019E-29_JPRB, 0.52309401E-29_JPRB, 0.79783002E-29_JPRB, &
  & 0.85376046E-29_JPRB, 0.71620926E-29_JPRB, 0.42330913E-29_JPRB, 0.29716354E-29_JPRB, 0.19070210E-29_JPRB, 0.98156026E-30_JPRB, &
  & 0.57016982E-30_JPRB, 0.27594264E-30_JPRB, 0.12965113E-30_JPRB, 0.45015115E-31_JPRB, 0.16789304E-31_JPRB, 0.72189893E-32_JPRB, &
  & 0.40697234E-32_JPRB, 0.27528588E-32_JPRB, 0.17556813E-32_JPRB, 0.10266647E-32_JPRB, 0.54821030E-33_JPRB, 0.27868666E-33_JPRB, &
  & 0.13776960E-33_JPRB, 0.62920074E-34_JPRB, 0.26953595E-34_JPRB, 0.12989157E-34_JPRB, 0.82421526E-35_JPRB, 0.82450683E-35_JPRB, &
  & 0.12167690E-34_JPRB, 0.17216502E-34_JPRB, 0.18363522E-34_JPRB, 0.22969599E-34_JPRB /)

RGHG5(:, 7, 5) = (/ &
  & 0.35599202E-30_JPRB, 0.50089972E-30_JPRB, 0.58215276E-30_JPRB, 0.65238056E-30_JPRB, 0.73581122E-30_JPRB, 0.85138517E-30_JPRB, &
  & 0.10291409E-29_JPRB, 0.13068264E-29_JPRB, 0.17409007E-29_JPRB, 0.24069821E-29_JPRB, 0.34477046E-29_JPRB, 0.50056853E-29_JPRB, &
  & 0.76145319E-29_JPRB, 0.11148131E-28_JPRB, 0.16986260E-28_JPRB, 0.23666414E-28_JPRB, 0.34230991E-28_JPRB, 0.45193992E-28_JPRB, &
  & 0.60856702E-28_JPRB, 0.77331576E-28_JPRB, 0.97988017E-28_JPRB, 0.12089575E-27_JPRB, 0.14601649E-27_JPRB, 0.17283735E-27_JPRB, &
  & 0.20306360E-27_JPRB, 0.23827514E-27_JPRB, 0.28176514E-27_JPRB, 0.33637146E-27_JPRB, 0.38572467E-27_JPRB, 0.50554284E-27_JPRB, &
  & 0.55115194E-27_JPRB, 0.80805039E-27_JPRB, 0.90834300E-27_JPRB, 0.14749221E-26_JPRB, 0.13177503E-26_JPRB, 0.20699288E-26_JPRB, &
  & 0.22750413E-26_JPRB, 0.19623666E-26_JPRB, 0.11816372E-26_JPRB, 0.86638864E-27_JPRB, 0.58068396E-27_JPRB, 0.31173218E-27_JPRB, &
  & 0.19234466E-27_JPRB, 0.98701665E-28_JPRB, 0.49319867E-28_JPRB, 0.18198627E-28_JPRB, 0.72659965E-29_JPRB, 0.33652974E-29_JPRB, &
  & 0.20493856E-29_JPRB, 0.14877980E-29_JPRB, 0.10118531E-29_JPRB, 0.62794480E-30_JPRB, 0.35449341E-30_JPRB, 0.18981800E-30_JPRB, &
  & 0.98432318E-31_JPRB, 0.46862099E-31_JPRB, 0.20774304E-31_JPRB, 0.10301001E-31_JPRB, 0.66519087E-32_JPRB, 0.66684244E-32_JPRB, &
  & 0.98441877E-32_JPRB, 0.13904156E-31_JPRB, 0.15084040E-31_JPRB, 0.22787252E-31_JPRB /)

RGHG5(:, 8, 5) = (/ &
  & 0.22911811E-27_JPRB, 0.31988507E-27_JPRB, 0.36992882E-27_JPRB, 0.41179550E-27_JPRB, 0.45950233E-27_JPRB, 0.52472756E-27_JPRB, &
  & 0.62092935E-27_JPRB, 0.76873662E-27_JPRB, 0.99061035E-27_JPRB, 0.13177582E-26_JPRB, 0.18067625E-26_JPRB, 0.24956137E-26_JPRB, &
  & 0.36007136E-26_JPRB, 0.49681150E-26_JPRB, 0.71522136E-26_JPRB, 0.93473723E-26_JPRB, 0.12760617E-25_JPRB, 0.15815493E-25_JPRB, &
  & 0.20113852E-25_JPRB, 0.24115253E-25_JPRB, 0.28980851E-25_JPRB, 0.34011994E-25_JPRB, 0.39232241E-25_JPRB, 0.44457735E-25_JPRB, &
  & 0.50225812E-25_JPRB, 0.56898479E-25_JPRB, 0.65293746E-25_JPRB, 0.76092703E-25_JPRB, 0.85513311E-25_JPRB, 0.11073043E-24_JPRB, &
  & 0.11977810E-24_JPRB, 0.17538376E-24_JPRB, 0.19797418E-24_JPRB, 0.32500443E-24_JPRB, 0.29372003E-24_JPRB, 0.47478949E-24_JPRB, &
  & 0.53649681E-24_JPRB, 0.47686923E-24_JPRB, 0.29296847E-24_JPRB, 0.22517620E-24_JPRB, 0.15780555E-24_JPRB, 0.88573777E-25_JPRB, &
  & 0.58195914E-25_JPRB, 0.31655737E-25_JPRB, 0.16890684E-25_JPRB, 0.66030762E-26_JPRB, 0.28350825E-26_JPRB, 0.14234098E-26_JPRB, &
  & 0.94267896E-27_JPRB, 0.73949922E-27_JPRB, 0.53877500E-27_JPRB, 0.35650937E-27_JPRB, 0.21365468E-27_JPRB, 0.12097457E-27_JPRB, &
  & 0.66066722E-28_JPRB, 0.32947792E-28_JPRB, 0.15250535E-28_JPRB, 0.78658304E-29_JPRB, 0.52381969E-29_JPRB, 0.53435468E-29_JPRB, &
  & 0.78952618E-29_JPRB, 0.11176357E-28_JPRB, 0.12450196E-28_JPRB, 0.19951056E-28_JPRB /)

RGHG5(:, 9, 5) = (/ &
  & 0.11946373E-24_JPRB, 0.16625691E-24_JPRB, 0.19142267E-24_JPRB, 0.21197979E-24_JPRB, 0.23477625E-24_JPRB, 0.26471495E-24_JPRB, &
  & 0.30863335E-24_JPRB, 0.37353390E-24_JPRB, 0.46828608E-24_JPRB, 0.60261740E-24_JPRB, 0.79520517E-24_JPRB, 0.10508162E-23_JPRB, &
  & 0.14450623E-23_JPRB, 0.18890483E-23_JPRB, 0.25783183E-23_JPRB, 0.31749174E-23_JPRB, 0.41061275E-23_JPRB, 0.47934135E-23_JPRB, &
  & 0.57795007E-23_JPRB, 0.65541759E-23_JPRB, 0.74850996E-23_JPRB, 0.83663401E-23_JPRB, 0.92130111E-23_JPRB, 0.99979332E-23_JPRB, &
  & 0.10851982E-22_JPRB, 0.11865339E-22_JPRB, 0.13203443E-22_JPRB, 0.15003453E-22_JPRB, 0.16535739E-22_JPRB, 0.21104326E-22_JPRB, &
  & 0.22695986E-22_JPRB, 0.33132925E-22_JPRB, 0.37606309E-22_JPRB, 0.62379763E-22_JPRB, 0.57150739E-22_JPRB, 0.94780918E-22_JPRB, &
  & 0.11003838E-21_JPRB, 0.10086476E-21_JPRB, 0.63623172E-22_JPRB, 0.51262444E-22_JPRB, 0.37658929E-22_JPRB, 0.22136194E-22_JPRB, &
  & 0.15486367E-22_JPRB, 0.89285589E-23_JPRB, 0.50781773E-23_JPRB, 0.21005076E-23_JPRB, 0.96968153E-24_JPRB, 0.52774311E-24_JPRB, &
  & 0.38065053E-24_JPRB, 0.32276111E-24_JPRB, 0.25197097E-24_JPRB, 0.17775410E-24_JPRB, 0.11307443E-24_JPRB, 0.67690546E-25_JPRB, &
  & 0.38910792E-25_JPRB, 0.20321881E-25_JPRB, 0.98246848E-26_JPRB, 0.52909440E-26_JPRB, 0.36550830E-26_JPRB, 0.38165195E-26_JPRB, &
  & 0.56893319E-26_JPRB, 0.81143219E-26_JPRB, 0.92020347E-26_JPRB, 0.15071083E-25_JPRB /)

RGHG5(:,10, 5) = (/ &
  & 0.50189451E-22_JPRB, 0.69493950E-22_JPRB, 0.79834907E-22_JPRB, 0.88007910E-22_JPRB, 0.96890332E-22_JPRB, 0.10835026E-21_JPRB, &
  & 0.12459928E-21_JPRB, 0.14834611E-21_JPRB, 0.18171082E-21_JPRB, 0.22744940E-21_JPRB, 0.29048999E-21_JPRB, 0.36937790E-21_JPRB, &
  & 0.48670335E-21_JPRB, 0.60589950E-21_JPRB, 0.78765330E-21_JPRB, 0.91764228E-21_JPRB, 0.11287305E-20_JPRB, 0.12452299E-20_JPRB, &
  & 0.14279702E-20_JPRB, 0.15350197E-20_JPRB, 0.16687444E-20_JPRB, 0.17770592E-20_JPRB, 0.18693415E-20_JPRB, 0.19418255E-20_JPRB, &
  & 0.20258982E-20_JPRB, 0.21370617E-20_JPRB, 0.23054899E-20_JPRB, 0.25525980E-20_JPRB, 0.27595650E-20_JPRB, 0.34681470E-20_JPRB, &
  & 0.37063584E-20_JPRB, 0.53958627E-20_JPRB, 0.61563079E-20_JPRB, 0.10311657E-19_JPRB, 0.95925050E-20_JPRB, 0.16282054E-19_JPRB, &
  & 0.19402760E-19_JPRB, 0.18342094E-19_JPRB, 0.11953217E-19_JPRB, 0.10092360E-19_JPRB, 0.77777943E-20_JPRB, 0.48088953E-20_JPRB, &
  & 0.35768348E-20_JPRB, 0.21873606E-20_JPRB, 0.13262767E-20_JPRB, 0.58117844E-21_JPRB, 0.28838316E-21_JPRB, 0.17012211E-21_JPRB, &
  & 0.13331656E-21_JPRB, 0.12205335E-21_JPRB, 0.10204284E-21_JPRB, 0.76749066E-22_JPRB, 0.51814315E-22_JPRB, 0.32783431E-22_JPRB, &
  & 0.19822391E-22_JPRB, 0.10827121E-22_JPRB, 0.54602218E-23_JPRB, 0.30624474E-23_JPRB, 0.21954531E-23_JPRB, 0.23545540E-23_JPRB, &
  & 0.35472977E-23_JPRB, 0.51009616E-23_JPRB, 0.58685082E-23_JPRB, 0.96796002E-23_JPRB /)

RGHG5(:,11, 5) = (/ &
  & 0.17301748E-19_JPRB, 0.23934982E-19_JPRB, 0.27381106E-19_JPRB, 0.30114977E-19_JPRB, 0.32966640E-19_JPRB, 0.36576011E-19_JPRB, &
  & 0.41614914E-19_JPRB, 0.48736028E-19_JPRB, 0.58466761E-19_JPRB, 0.71307266E-19_JPRB, 0.88315670E-19_JPRB, 0.10833815E-18_JPRB, &
  & 0.13708337E-18_JPRB, 0.16310455E-18_JPRB, 0.20227884E-18_JPRB, 0.22394659E-18_JPRB, 0.26228297E-18_JPRB, 0.27453623E-18_JPRB, &
  & 0.29976082E-18_JPRB, 0.30631139E-18_JPRB, 0.31730599E-18_JPRB, 0.32240941E-18_JPRB, 0.32421716E-18_JPRB, 0.32289740E-18_JPRB, &
  & 0.32404351E-18_JPRB, 0.33013101E-18_JPRB, 0.34542626E-18_JPRB, 0.37280363E-18_JPRB, 0.39541782E-18_JPRB, 0.48938104E-18_JPRB, &
  & 0.51929841E-18_JPRB, 0.75343715E-18_JPRB, 0.86315775E-18_JPRB, 0.14592614E-17_JPRB, 0.13791911E-17_JPRB, 0.23934105E-17_JPRB, &
  & 0.29269693E-17_JPRB, 0.28539729E-17_JPRB, 0.19286816E-17_JPRB, 0.17052020E-17_JPRB, 0.13798224E-17_JPRB, 0.89896655E-18_JPRB, &
  & 0.71051713E-18_JPRB, 0.46118462E-18_JPRB, 0.29816503E-18_JPRB, 0.13869252E-18_JPRB, 0.74044627E-19_JPRB, 0.47229086E-19_JPRB, &
  & 0.40108767E-19_JPRB, 0.39536862E-19_JPRB, 0.35350791E-19_JPRB, 0.28309222E-19_JPRB, 0.20259702E-19_JPRB, 0.13525663E-19_JPRB, &
  & 0.85830708E-20_JPRB, 0.48896367E-20_JPRB, 0.25612452E-20_JPRB, 0.14894763E-20_JPRB, 0.11030188E-20_JPRB, 0.12125236E-20_JPRB, &
  & 0.18519035E-20_JPRB, 0.26861438E-20_JPRB, 0.31211015E-20_JPRB, 0.51698970E-20_JPRB /)

RGHG5(:,12, 5) = (/ &
  & 0.49886733E-17_JPRB, 0.68707830E-17_JPRB, 0.78553596E-17_JPRB, 0.85963537E-17_JPRB, 0.93677526E-17_JPRB, 0.10306099E-16_JPRB, &
  & 0.11588112E-16_JPRB, 0.13356379E-16_JPRB, 0.15678070E-16_JPRB, 0.18631294E-16_JPRB, 0.22388864E-16_JPRB, 0.26523654E-16_JPRB, &
  & 0.32281961E-16_JPRB, 0.36790962E-16_JPRB, 0.43613544E-16_JPRB, 0.46021676E-16_JPRB, 0.51384364E-16_JPRB, 0.51180540E-16_JPRB, &
  & 0.53246218E-16_JPRB, 0.51830247E-16_JPRB, 0.51203334E-16_JPRB, 0.49691386E-16_JPRB, 0.47819725E-16_JPRB, 0.45714944E-16_JPRB, &
  & 0.44170194E-16_JPRB, 0.43488640E-16_JPRB, 0.44158719E-16_JPRB, 0.46477065E-16_JPRB, 0.48357217E-16_JPRB, 0.58969481E-16_JPRB, &
  & 0.62027310E-16_JPRB, 0.89672096E-16_JPRB, 0.10302314E-15_JPRB, 0.17562719E-15_JPRB, 0.16876970E-15_JPRB, 0.29938189E-15_JPRB, &
  & 0.37594898E-15_JPRB, 0.37834725E-15_JPRB, 0.26559650E-15_JPRB, 0.24592167E-15_JPRB, 0.20895591E-15_JPRB, 0.14366306E-15_JPRB, &
  & 0.12054647E-15_JPRB, 0.83128045E-16_JPRB, 0.57269744E-16_JPRB, 0.28347473E-16_JPRB, 0.16269096E-16_JPRB, 0.11213878E-16_JPRB, &
  & 0.10293355E-16_JPRB, 0.10899809E-16_JPRB, 0.10404970E-16_JPRB, 0.88585146E-17_JPRB, 0.67084894E-17_JPRB, 0.47161574E-17_JPRB, &
  & 0.31326016E-17_JPRB, 0.18545569E-17_JPRB, 0.10037771E-17_JPRB, 0.60165799E-18_JPRB, 0.45767019E-18_JPRB, 0.51400331E-18_JPRB, &
  & 0.79657312E-18_JPRB, 0.11666700E-17_JPRB, 0.13635381E-17_JPRB, 0.22732232E-17_JPRB /)

RGHG5(:,13, 5) = (/ &
  & 0.74731520E-16_JPRB, 0.91372812E-16_JPRB, 0.98970526E-16_JPRB, 0.10516769E-15_JPRB, 0.11188019E-15_JPRB, 0.12126092E-15_JPRB, &
  & 0.13514162E-15_JPRB, 0.15541747E-15_JPRB, 0.18365853E-15_JPRB, 0.22048540E-15_JPRB, 0.27063738E-15_JPRB, 0.32527383E-15_JPRB, &
  & 0.40758400E-15_JPRB, 0.46947897E-15_JPRB, 0.57644330E-15_JPRB, 0.61432467E-15_JPRB, 0.71136484E-15_JPRB, 0.70772165E-15_JPRB, &
  & 0.77110396E-15_JPRB, 0.73135032E-15_JPRB, 0.76322084E-15_JPRB, 0.73098414E-15_JPRB, 0.72277099E-15_JPRB, 0.69082753E-15_JPRB, &
  & 0.67534662E-15_JPRB, 0.66365391E-15_JPRB, 0.66624059E-15_JPRB, 0.67861696E-15_JPRB, 0.69801778E-15_JPRB, 0.73359200E-15_JPRB, &
  & 0.83095319E-15_JPRB, 0.84733619E-15_JPRB, 0.11881643E-14_JPRB, 0.12443500E-14_JPRB, 0.17568788E-14_JPRB, 0.20540466E-14_JPRB, &
  & 0.24969487E-14_JPRB, 0.23215153E-14_JPRB, 0.18983730E-14_JPRB, 0.19089431E-14_JPRB, 0.14235104E-14_JPRB, 0.94344393E-15_JPRB, &
  & 0.85328934E-15_JPRB, 0.57633763E-15_JPRB, 0.42827172E-15_JPRB, 0.25210901E-15_JPRB, 0.17406653E-15_JPRB, 0.11558328E-15_JPRB, &
  & 0.90877834E-16_JPRB, 0.80005498E-16_JPRB, 0.87013921E-16_JPRB, 0.82325620E-16_JPRB, 0.70972573E-16_JPRB, 0.56735068E-16_JPRB, &
  & 0.41600802E-16_JPRB, 0.26804905E-16_JPRB, 0.16625837E-16_JPRB, 0.11822539E-16_JPRB, 0.10858926E-16_JPRB, 0.12995778E-16_JPRB, &
  & 0.17441758E-16_JPRB, 0.23849726E-16_JPRB, 0.23444350E-16_JPRB, 0.30725922E-16_JPRB /)

RGHG5(:,14, 5) = (/ &
  & 0.77653852E-15_JPRB, 0.84610471E-15_JPRB, 0.87362994E-15_JPRB, 0.89528206E-15_JPRB, 0.92670995E-15_JPRB, 0.98166396E-15_JPRB, &
  & 0.10757527E-14_JPRB, 0.12256512E-14_JPRB, 0.14444042E-14_JPRB, 0.17424507E-14_JPRB, 0.21623337E-14_JPRB, 0.26425120E-14_JPRB, &
  & 0.33110437E-14_JPRB, 0.39741532E-14_JPRB, 0.47834670E-14_JPRB, 0.54409809E-14_JPRB, 0.61701683E-14_JPRB, 0.66691143E-14_JPRB, &
  & 0.72346067E-14_JPRB, 0.74276793E-14_JPRB, 0.77362636E-14_JPRB, 0.77536600E-14_JPRB, 0.78410890E-14_JPRB, 0.77863394E-14_JPRB, &
  & 0.78197523E-14_JPRB, 0.78607698E-14_JPRB, 0.79682498E-14_JPRB, 0.80642365E-14_JPRB, 0.81702223E-14_JPRB, 0.82667875E-14_JPRB, &
  & 0.85066875E-14_JPRB, 0.84701965E-14_JPRB, 0.94497621E-14_JPRB, 0.92771749E-14_JPRB, 0.87910195E-14_JPRB, 0.10376029E-13_JPRB, &
  & 0.13555139E-13_JPRB, 0.13132929E-13_JPRB, 0.95086275E-14_JPRB, 0.63410504E-14_JPRB, 0.49920378E-14_JPRB, 0.51775321E-14_JPRB, &
  & 0.41004408E-14_JPRB, 0.29909398E-14_JPRB, 0.29879373E-14_JPRB, 0.23581061E-14_JPRB, 0.16551679E-14_JPRB, 0.11722920E-14_JPRB, &
  & 0.89937757E-15_JPRB, 0.75630127E-15_JPRB, 0.70657519E-15_JPRB, 0.74481264E-15_JPRB, 0.68891212E-15_JPRB, 0.58271759E-15_JPRB, &
  & 0.46767505E-15_JPRB, 0.34166784E-15_JPRB, 0.25018698E-15_JPRB, 0.20873467E-15_JPRB, 0.20781755E-15_JPRB, 0.24112664E-15_JPRB, &
  & 0.30630805E-15_JPRB, 0.37457915E-15_JPRB, 0.41487253E-15_JPRB, 0.53913298E-15_JPRB /)

RGHG5(:,15, 5) = (/ &
  & 0.60603971E-14_JPRB, 0.59750005E-14_JPRB, 0.58895073E-14_JPRB, 0.58366728E-14_JPRB, 0.58726260E-14_JPRB, 0.60673453E-14_JPRB, &
  & 0.65097125E-14_JPRB, 0.72865933E-14_JPRB, 0.84872185E-14_JPRB, 0.10192898E-13_JPRB, 0.12575930E-13_JPRB, 0.15570924E-13_JPRB, &
  & 0.19406822E-13_JPRB, 0.23888880E-13_JPRB, 0.28940460E-13_JPRB, 0.34499276E-13_JPRB, 0.39958562E-13_JPRB, 0.44956934E-13_JPRB, &
  & 0.49395028E-13_JPRB, 0.52929171E-13_JPRB, 0.55903775E-13_JPRB, 0.58950247E-13_JPRB, 0.61873358E-13_JPRB, 0.64963172E-13_JPRB, &
  & 0.67805855E-13_JPRB, 0.70775329E-13_JPRB, 0.73290380E-13_JPRB, 0.74908477E-13_JPRB, 0.75163515E-13_JPRB, 0.73958201E-13_JPRB, &
  & 0.71793137E-13_JPRB, 0.68913645E-13_JPRB, 0.66689221E-13_JPRB, 0.63648827E-13_JPRB, 0.63888707E-13_JPRB, 0.58467513E-13_JPRB, &
  & 0.45365167E-13_JPRB, 0.43354683E-13_JPRB, 0.50102473E-13_JPRB, 0.52281191E-13_JPRB, 0.49005667E-13_JPRB, 0.43374992E-13_JPRB, &
  & 0.36178051E-13_JPRB, 0.31877878E-13_JPRB, 0.28283358E-13_JPRB, 0.21873454E-13_JPRB, 0.15452068E-13_JPRB, 0.11472286E-13_JPRB, &
  & 0.91150647E-14_JPRB, 0.75950581E-14_JPRB, 0.67534687E-14_JPRB, 0.62164764E-14_JPRB, 0.56395945E-14_JPRB, 0.47979254E-14_JPRB, &
  & 0.38539216E-14_JPRB, 0.30680558E-14_JPRB, 0.26455177E-14_JPRB, 0.26137006E-14_JPRB, 0.28998389E-14_JPRB, 0.35110727E-14_JPRB, &
  & 0.44073517E-14_JPRB, 0.55062258E-14_JPRB, 0.69993881E-14_JPRB, 0.10929653E-13_JPRB /)

RGHG5(:,16, 5) = (/ &
  & 0.37327875E-13_JPRB, 0.33072906E-13_JPRB, 0.31142461E-13_JPRB, 0.29953619E-13_JPRB, 0.29392955E-13_JPRB, 0.29677527E-13_JPRB, &
  & 0.31125588E-13_JPRB, 0.34137339E-13_JPRB, 0.39031478E-13_JPRB, 0.46266952E-13_JPRB, 0.56089749E-13_JPRB, 0.68874092E-13_JPRB, &
  & 0.84943540E-13_JPRB, 0.10373081E-12_JPRB, 0.12455401E-12_JPRB, 0.14732333E-12_JPRB, 0.17307037E-12_JPRB, 0.20049437E-12_JPRB, &
  & 0.23043275E-12_JPRB, 0.26209116E-12_JPRB, 0.29164922E-12_JPRB, 0.31916673E-12_JPRB, 0.35027520E-12_JPRB, 0.38591195E-12_JPRB, &
  & 0.42599675E-12_JPRB, 0.46419872E-12_JPRB, 0.49573269E-12_JPRB, 0.51265085E-12_JPRB, 0.51326163E-12_JPRB, 0.49673687E-12_JPRB, &
  & 0.46567253E-12_JPRB, 0.42790993E-12_JPRB, 0.38716074E-12_JPRB, 0.34716107E-12_JPRB, 0.31740154E-12_JPRB, 0.30058982E-12_JPRB, &
  & 0.30061652E-12_JPRB, 0.29761477E-12_JPRB, 0.29177268E-12_JPRB, 0.28332648E-12_JPRB, 0.27126955E-12_JPRB, 0.25179831E-12_JPRB, &
  & 0.22559836E-12_JPRB, 0.19509093E-12_JPRB, 0.15916276E-12_JPRB, 0.12669904E-12_JPRB, 0.10334566E-12_JPRB, 0.87372499E-13_JPRB, &
  & 0.76361199E-13_JPRB, 0.66302541E-13_JPRB, 0.56605257E-13_JPRB, 0.47513060E-13_JPRB, 0.39775952E-13_JPRB, 0.33599730E-13_JPRB, &
  & 0.29397244E-13_JPRB, 0.27167337E-13_JPRB, 0.26608952E-13_JPRB, 0.28246524E-13_JPRB, 0.32289577E-13_JPRB, 0.38977851E-13_JPRB, &
  & 0.48484464E-13_JPRB, 0.61592523E-13_JPRB, 0.82600790E-13_JPRB, 0.13202913E-12_JPRB /)

RGHG5(:,17, 5) = (/ &
  & 0.16247003E-12_JPRB, 0.14255138E-12_JPRB, 0.13088926E-12_JPRB, 0.12362820E-12_JPRB, 0.11923386E-12_JPRB, 0.11828230E-12_JPRB, &
  & 0.12179374E-12_JPRB, 0.13097206E-12_JPRB, 0.14702492E-12_JPRB, 0.17137246E-12_JPRB, 0.20492367E-12_JPRB, 0.24878285E-12_JPRB, &
  & 0.30393640E-12_JPRB, 0.37061760E-12_JPRB, 0.44835248E-12_JPRB, 0.53446288E-12_JPRB, 0.62785205E-12_JPRB, 0.73218130E-12_JPRB, &
  & 0.84565276E-12_JPRB, 0.97252143E-12_JPRB, 0.11277327E-11_JPRB, 0.13117659E-11_JPRB, 0.15191067E-11_JPRB, 0.17450971E-11_JPRB, &
  & 0.19698099E-11_JPRB, 0.21787030E-11_JPRB, 0.23512251E-11_JPRB, 0.24590636E-11_JPRB, 0.24599960E-11_JPRB, 0.23696468E-11_JPRB, &
  & 0.21868625E-11_JPRB, 0.19544383E-11_JPRB, 0.17109625E-11_JPRB, 0.14804172E-11_JPRB, 0.12959672E-11_JPRB, 0.11704101E-11_JPRB, &
  & 0.11080789E-11_JPRB, 0.11023332E-11_JPRB, 0.11163304E-11_JPRB, 0.11407911E-11_JPRB, 0.11431208E-11_JPRB, 0.11080005E-11_JPRB, &
  & 0.10347145E-11_JPRB, 0.93422850E-12_JPRB, 0.82390789E-12_JPRB, 0.71514133E-12_JPRB, 0.61303041E-12_JPRB, 0.52172855E-12_JPRB, &
  & 0.43993466E-12_JPRB, 0.36994848E-12_JPRB, 0.31433303E-12_JPRB, 0.27243314E-12_JPRB, 0.24162540E-12_JPRB, 0.22050065E-12_JPRB, &
  & 0.20767310E-12_JPRB, 0.20185539E-12_JPRB, 0.20294976E-12_JPRB, 0.21477847E-12_JPRB, 0.23750779E-12_JPRB, 0.27209487E-12_JPRB, &
  & 0.32033022E-12_JPRB, 0.38615519E-12_JPRB, 0.49108065E-12_JPRB, 0.74404746E-12_JPRB /)

RGHG5(:,18, 5) = (/ &
  & 0.55526823E-12_JPRB, 0.48352777E-12_JPRB, 0.44329682E-12_JPRB, 0.41665103E-12_JPRB, 0.39939932E-12_JPRB, 0.39243253E-12_JPRB, &
  & 0.39887370E-12_JPRB, 0.42243878E-12_JPRB, 0.46627047E-12_JPRB, 0.53423569E-12_JPRB, 0.62855938E-12_JPRB, 0.74965105E-12_JPRB, &
  & 0.90177713E-12_JPRB, 0.10845524E-11_JPRB, 0.12991274E-11_JPRB, 0.15495088E-11_JPRB, 0.18393182E-11_JPRB, 0.21698641E-11_JPRB, &
  & 0.25549914E-11_JPRB, 0.30111415E-11_JPRB, 0.35333088E-11_JPRB, 0.41066005E-11_JPRB, 0.47409160E-11_JPRB, 0.54556724E-11_JPRB, &
  & 0.62175438E-11_JPRB, 0.69604669E-11_JPRB, 0.76086819E-11_JPRB, 0.80275959E-11_JPRB, 0.81017632E-11_JPRB, 0.78429676E-11_JPRB, &
  & 0.72457765E-11_JPRB, 0.64823793E-11_JPRB, 0.56612527E-11_JPRB, 0.48746701E-11_JPRB, 0.42402154E-11_JPRB, 0.37941733E-11_JPRB, &
  & 0.35468991E-11_JPRB, 0.34686607E-11_JPRB, 0.35282274E-11_JPRB, 0.36264667E-11_JPRB, 0.36755625E-11_JPRB, 0.36426552E-11_JPRB, &
  & 0.34976984E-11_JPRB, 0.32489376E-11_JPRB, 0.29349912E-11_JPRB, 0.25812453E-11_JPRB, 0.22302414E-11_JPRB, 0.19138577E-11_JPRB, &
  & 0.16543782E-11_JPRB, 0.14447584E-11_JPRB, 0.12796487E-11_JPRB, 0.11501899E-11_JPRB, 0.10519511E-11_JPRB, 0.98070412E-12_JPRB, &
  & 0.93476258E-12_JPRB, 0.91244763E-12_JPRB, 0.91455044E-12_JPRB, 0.95268021E-12_JPRB, 0.10267371E-11_JPRB, 0.11382861E-11_JPRB, &
  & 0.12907691E-11_JPRB, 0.14959982E-11_JPRB, 0.18020183E-11_JPRB, 0.24773759E-11_JPRB /)

RGHG5(:,19, 5) = (/ &
  & 0.15288037E-11_JPRB, 0.13405813E-11_JPRB, 0.12405849E-11_JPRB, 0.11723234E-11_JPRB, 0.11256636E-11_JPRB, 0.11042987E-11_JPRB, &
  & 0.11157961E-11_JPRB, 0.11689535E-11_JPRB, 0.12720297E-11_JPRB, 0.14325941E-11_JPRB, 0.16548098E-11_JPRB, 0.19398469E-11_JPRB, &
  & 0.22863744E-11_JPRB, 0.27004724E-11_JPRB, 0.31772616E-11_JPRB, 0.37194757E-11_JPRB, 0.43418689E-11_JPRB, 0.50597772E-11_JPRB, &
  & 0.58814559E-11_JPRB, 0.68192578E-11_JPRB, 0.79254615E-11_JPRB, 0.92480216E-11_JPRB, 0.10787966E-10_JPRB, 0.12462911E-10_JPRB, &
  & 0.14243710E-10_JPRB, 0.15992796E-10_JPRB, 0.17514474E-10_JPRB, 0.18574406E-10_JPRB, 0.18996759E-10_JPRB, 0.18673453E-10_JPRB, &
  & 0.17664786E-10_JPRB, 0.16170692E-10_JPRB, 0.14424355E-10_JPRB, 0.12673062E-10_JPRB, 0.11178662E-10_JPRB, 0.10075385E-10_JPRB, &
  & 0.94072614E-11_JPRB, 0.91408435E-11_JPRB, 0.91790117E-11_JPRB, 0.93431391E-11_JPRB, 0.94573004E-11_JPRB, 0.93761101E-11_JPRB, &
  & 0.90507489E-11_JPRB, 0.85034280E-11_JPRB, 0.78056043E-11_JPRB, 0.70095028E-11_JPRB, 0.62095472E-11_JPRB, 0.54763681E-11_JPRB, &
  & 0.48428293E-11_JPRB, 0.42984314E-11_JPRB, 0.38508454E-11_JPRB, 0.34923286E-11_JPRB, 0.32162632E-11_JPRB, 0.30145281E-11_JPRB, &
  & 0.28846571E-11_JPRB, 0.28213157E-11_JPRB, 0.28222095E-11_JPRB, 0.29069347E-11_JPRB, 0.30712026E-11_JPRB, 0.33128021E-11_JPRB, &
  & 0.36360723E-11_JPRB, 0.40620211E-11_JPRB, 0.46644143E-11_JPRB, 0.59644737E-11_JPRB /)

RGHG5(:,20, 5) = (/ &
  & 0.35020598E-11_JPRB, 0.31267692E-11_JPRB, 0.29354813E-11_JPRB, 0.28031245E-11_JPRB, 0.27130071E-11_JPRB, 0.26722481E-11_JPRB, &
  & 0.26985356E-11_JPRB, 0.28114338E-11_JPRB, 0.30282428E-11_JPRB, 0.33634998E-11_JPRB, 0.38233379E-11_JPRB, 0.44049894E-11_JPRB, &
  & 0.50990423E-11_JPRB, 0.59062035E-11_JPRB, 0.68264899E-11_JPRB, 0.78530871E-11_JPRB, 0.89966706E-11_JPRB, 0.10286091E-10_JPRB, &
  & 0.11749832E-10_JPRB, 0.13432915E-10_JPRB, 0.15360041E-10_JPRB, 0.17531315E-10_JPRB, 0.20034051E-10_JPRB, 0.22840705E-10_JPRB, &
  & 0.25814509E-10_JPRB, 0.28777297E-10_JPRB, 0.31500965E-10_JPRB, 0.33538866E-10_JPRB, 0.34671023E-10_JPRB, 0.34756583E-10_JPRB, &
  & 0.33816568E-10_JPRB, 0.31963682E-10_JPRB, 0.29574485E-10_JPRB, 0.26917895E-10_JPRB, 0.24437650E-10_JPRB, 0.22435359E-10_JPRB, &
  & 0.21083649E-10_JPRB, 0.20362205E-10_JPRB, 0.20145172E-10_JPRB, 0.20107643E-10_JPRB, 0.20034141E-10_JPRB, 0.19702399E-10_JPRB, &
  & 0.18983239E-10_JPRB, 0.17899284E-10_JPRB, 0.16567865E-10_JPRB, 0.15064609E-10_JPRB, 0.13540885E-10_JPRB, 0.12098856E-10_JPRB, &
  & 0.10819803E-10_JPRB, 0.97006413E-11_JPRB, 0.87694149E-11_JPRB, 0.80169881E-11_JPRB, 0.74406072E-11_JPRB, 0.70284204E-11_JPRB, &
  & 0.67698529E-11_JPRB, 0.66461571E-11_JPRB, 0.66425255E-11_JPRB, 0.67808580E-11_JPRB, 0.70465088E-11_JPRB, 0.74297461E-11_JPRB, &
  & 0.79302771E-11_JPRB, 0.85815712E-11_JPRB, 0.95044181E-11_JPRB, 0.11427023E-10_JPRB /)

RGHG5(:,21, 5) = (/ &
  & 0.68632895E-11_JPRB, 0.62791842E-11_JPRB, 0.59927514E-11_JPRB, 0.57963591E-11_JPRB, 0.56685663E-11_JPRB, 0.56270717E-11_JPRB, &
  & 0.57037656E-11_JPRB, 0.59349014E-11_JPRB, 0.63549712E-11_JPRB, 0.69877090E-11_JPRB, 0.78401782E-11_JPRB, 0.89079863E-11_JPRB, &
  & 0.10163141E-10_JPRB, 0.11570713E-10_JPRB, 0.13132601E-10_JPRB, 0.14848518E-10_JPRB, 0.16713596E-10_JPRB, 0.18747880E-10_JPRB, &
  & 0.20991415E-10_JPRB, 0.23480714E-10_JPRB, 0.26260367E-10_JPRB, 0.29349485E-10_JPRB, 0.32731904E-10_JPRB, 0.36456661E-10_JPRB, &
  & 0.40377493E-10_JPRB, 0.44275885E-10_JPRB, 0.47936568E-10_JPRB, 0.51056701E-10_JPRB, 0.53285903E-10_JPRB, 0.54392400E-10_JPRB, &
  & 0.54267209E-10_JPRB, 0.52958839E-10_JPRB, 0.50779606E-10_JPRB, 0.47902991E-10_JPRB, 0.44959227E-10_JPRB, 0.42325986E-10_JPRB, &
  & 0.40262123E-10_JPRB, 0.38778796E-10_JPRB, 0.37837067E-10_JPRB, 0.37082042E-10_JPRB, 0.36233107E-10_JPRB, 0.35064885E-10_JPRB, &
  & 0.33480278E-10_JPRB, 0.31480887E-10_JPRB, 0.29197145E-10_JPRB, 0.26717791E-10_JPRB, 0.24218997E-10_JPRB, 0.21870191E-10_JPRB, &
  & 0.19782205E-10_JPRB, 0.17954646E-10_JPRB, 0.16423734E-10_JPRB, 0.15180236E-10_JPRB, 0.14228759E-10_JPRB, 0.13544571E-10_JPRB, &
  & 0.13108115E-10_JPRB, 0.12883578E-10_JPRB, 0.12840316E-10_JPRB, 0.12994107E-10_JPRB, 0.13316787E-10_JPRB, 0.13784415E-10_JPRB, &
  & 0.14384887E-10_JPRB, 0.15145890E-10_JPRB, 0.16223514E-10_JPRB, 0.18342277E-10_JPRB /)

RGHG5(:,22, 5) = (/ &
  & 0.11830066E-10_JPRB, 0.11106813E-10_JPRB, 0.10764751E-10_JPRB, 0.10545222E-10_JPRB, 0.10429494E-10_JPRB, 0.10446347E-10_JPRB, &
  & 0.10649610E-10_JPRB, 0.11101956E-10_JPRB, 0.11854569E-10_JPRB, 0.12944616E-10_JPRB, 0.14385294E-10_JPRB, 0.16154789E-10_JPRB, &
  & 0.18212232E-10_JPRB, 0.20488179E-10_JPRB, 0.22923552E-10_JPRB, 0.25512602E-10_JPRB, 0.28254482E-10_JPRB, 0.31144937E-10_JPRB, &
  & 0.34219665E-10_JPRB, 0.37490622E-10_JPRB, 0.41009175E-10_JPRB, 0.44772321E-10_JPRB, 0.48751218E-10_JPRB, 0.52930309E-10_JPRB, &
  & 0.57286651E-10_JPRB, 0.61717166E-10_JPRB, 0.66034685E-10_JPRB, 0.69909134E-10_JPRB, 0.73115645E-10_JPRB, 0.75464704E-10_JPRB, &
  & 0.76698287E-10_JPRB, 0.76734036E-10_JPRB, 0.75681739E-10_JPRB, 0.73596913E-10_JPRB, 0.71007325E-10_JPRB, 0.68222601E-10_JPRB, &
  & 0.65672391E-10_JPRB, 0.63364466E-10_JPRB, 0.61366121E-10_JPRB, 0.59369024E-10_JPRB, 0.57154836E-10_JPRB, 0.54530686E-10_JPRB, &
  & 0.51503666E-10_JPRB, 0.48143940E-10_JPRB, 0.44608990E-10_JPRB, 0.40964690E-10_JPRB, 0.37437241E-10_JPRB, 0.34188815E-10_JPRB, &
  & 0.31321855E-10_JPRB, 0.28816470E-10_JPRB, 0.26705313E-10_JPRB, 0.24983848E-10_JPRB, 0.23647249E-10_JPRB, 0.22660179E-10_JPRB, &
  & 0.21992692E-10_JPRB, 0.21597764E-10_JPRB, 0.21435496E-10_JPRB, 0.21514162E-10_JPRB, 0.21794185E-10_JPRB, 0.22241400E-10_JPRB, &
  & 0.22831128E-10_JPRB, 0.23574802E-10_JPRB, 0.24602591E-10_JPRB, 0.26812637E-10_JPRB /)

RGHG5(:,23, 5) = (/ &
  & 0.18363458E-10_JPRB, 0.17661473E-10_JPRB, 0.17354871E-10_JPRB, 0.17193148E-10_JPRB, 0.17173589E-10_JPRB, 0.17344999E-10_JPRB, &
  & 0.17791501E-10_JPRB, 0.18596050E-10_JPRB, 0.19836346E-10_JPRB, 0.21560538E-10_JPRB, 0.23779780E-10_JPRB, 0.26468602E-10_JPRB, &
  & 0.29539898E-10_JPRB, 0.32895242E-10_JPRB, 0.36404491E-10_JPRB, 0.40020431E-10_JPRB, 0.43721506E-10_JPRB, 0.47491788E-10_JPRB, &
  & 0.51334693E-10_JPRB, 0.55258097E-10_JPRB, 0.59240973E-10_JPRB, 0.63285960E-10_JPRB, 0.67367618E-10_JPRB, 0.71505066E-10_JPRB, &
  & 0.75700557E-10_JPRB, 0.79978468E-10_JPRB, 0.84373633E-10_JPRB, 0.88753893E-10_JPRB, 0.92792281E-10_JPRB, 0.96298122E-10_JPRB, &
  & 0.98984321E-10_JPRB, 0.10064163E-09_JPRB, 0.10115729E-09_JPRB, 0.10047928E-09_JPRB, 0.98854105E-10_JPRB, 0.96542135E-10_JPRB, &
  & 0.93818668E-10_JPRB, 0.90827242E-10_JPRB, 0.87653343E-10_JPRB, 0.84158396E-10_JPRB, 0.80261214E-10_JPRB, 0.75938061E-10_JPRB, &
  & 0.71282730E-10_JPRB, 0.66420099E-10_JPRB, 0.61549384E-10_JPRB, 0.56791603E-10_JPRB, 0.52336545E-10_JPRB, 0.48303302E-10_JPRB, &
  & 0.44769893E-10_JPRB, 0.41690002E-10_JPRB, 0.39088635E-10_JPRB, 0.36947494E-10_JPRB, 0.35256242E-10_JPRB, 0.33968339E-10_JPRB, &
  & 0.33040910E-10_JPRB, 0.32416007E-10_JPRB, 0.32047580E-10_JPRB, 0.31939423E-10_JPRB, 0.32052590E-10_JPRB, 0.32352284E-10_JPRB, &
  & 0.32810209E-10_JPRB, 0.33422650E-10_JPRB, 0.34275714E-10_JPRB, 0.36116249E-10_JPRB /)

RGHG5(:,24, 5) = (/ &
  & 0.26294886E-10_JPRB, 0.25784697E-10_JPRB, 0.25612699E-10_JPRB, 0.25599226E-10_JPRB, 0.25770960E-10_JPRB, 0.26205496E-10_JPRB, &
  & 0.27006748E-10_JPRB, 0.28291860E-10_JPRB, 0.30145126E-10_JPRB, 0.32626360E-10_JPRB, 0.35745844E-10_JPRB, 0.39455255E-10_JPRB, &
  & 0.43643582E-10_JPRB, 0.48158363E-10_JPRB, 0.52823614E-10_JPRB, 0.57490176E-10_JPRB, 0.62136934E-10_JPRB, 0.66711844E-10_JPRB, &
  & 0.71199893E-10_JPRB, 0.75570585E-10_JPRB, 0.79799584E-10_JPRB, 0.83844431E-10_JPRB, 0.87705822E-10_JPRB, 0.91422772E-10_JPRB, &
  & 0.95093586E-10_JPRB, 0.98862050E-10_JPRB, 0.10287007E-09_JPRB, 0.10713497E-09_JPRB, 0.11159592E-09_JPRB, 0.11593181E-09_JPRB, &
  & 0.11978143E-09_JPRB, 0.12283174E-09_JPRB, 0.12479096E-09_JPRB, 0.12549252E-09_JPRB, 0.12493183E-09_JPRB, 0.12324942E-09_JPRB, &
  & 0.12058415E-09_JPRB, 0.11711773E-09_JPRB, 0.11294690E-09_JPRB, 0.10816734E-09_JPRB, 0.10280270E-09_JPRB, 0.96968586E-10_JPRB, &
  & 0.90891031E-10_JPRB, 0.84765014E-10_JPRB, 0.78833738E-10_JPRB, 0.73189822E-10_JPRB, 0.68000258E-10_JPRB, 0.63357611E-10_JPRB, &
  & 0.59313242E-10_JPRB, 0.55799310E-10_JPRB, 0.52822753E-10_JPRB, 0.50355844E-10_JPRB, 0.48376032E-10_JPRB, 0.46822116E-10_JPRB, &
  & 0.45637241E-10_JPRB, 0.44752493E-10_JPRB, 0.44116308E-10_JPRB, 0.43729194E-10_JPRB, 0.43561790E-10_JPRB, 0.43588879E-10_JPRB, &
  & 0.43790790E-10_JPRB, 0.44166910E-10_JPRB, 0.44761930E-10_JPRB, 0.45960621E-10_JPRB /)

RGHG5(:,25, 5) = (/ &
  & 0.35396259E-10_JPRB, 0.35209332E-10_JPRB, 0.35246306E-10_JPRB, 0.35449220E-10_JPRB, 0.35885711E-10_JPRB, 0.36652511E-10_JPRB, &
  & 0.37883668E-10_JPRB, 0.39712109E-10_JPRB, 0.42231114E-10_JPRB, 0.45495229E-10_JPRB, 0.49511829E-10_JPRB, 0.54204467E-10_JPRB, &
  & 0.59438746E-10_JPRB, 0.65017776E-10_JPRB, 0.70716037E-10_JPRB, 0.76343001E-10_JPRB, 0.81810045E-10_JPRB, 0.87057639E-10_JPRB, &
  & 0.92044615E-10_JPRB, 0.96715372E-10_JPRB, 0.10103091E-09_JPRB, 0.10493711E-09_JPRB, 0.10842307E-09_JPRB, 0.11159138E-09_JPRB, &
  & 0.11459099E-09_JPRB, 0.11767931E-09_JPRB, 0.12111859E-09_JPRB, 0.12503618E-09_JPRB, 0.12940964E-09_JPRB, 0.13406300E-09_JPRB, &
  & 0.13857507E-09_JPRB, 0.14252531E-09_JPRB, 0.14548604E-09_JPRB, 0.14717683E-09_JPRB, 0.14741094E-09_JPRB, 0.14620602E-09_JPRB, &
  & 0.14361842E-09_JPRB, 0.13985596E-09_JPRB, 0.13505076E-09_JPRB, 0.12934946E-09_JPRB, 0.12295433E-09_JPRB, 0.11608364E-09_JPRB, &
  & 0.10904339E-09_JPRB, 0.10208028E-09_JPRB, 0.95430046E-10_JPRB, 0.89209154E-10_JPRB, 0.83572302E-10_JPRB, 0.78572419E-10_JPRB, &
  & 0.74234535E-10_JPRB, 0.70471913E-10_JPRB, 0.67266699E-10_JPRB, 0.64580896E-10_JPRB, 0.62381399E-10_JPRB, 0.60596826E-10_JPRB, &
  & 0.59161877E-10_JPRB, 0.58004490E-10_JPRB, 0.57069127E-10_JPRB, 0.56352364E-10_JPRB, 0.55835239E-10_JPRB, 0.55506579E-10_JPRB, &
  & 0.55358398E-10_JPRB, 0.55393461E-10_JPRB, 0.55649471E-10_JPRB, 0.56456409E-10_JPRB /)

RGHG5(:,26, 5) = (/ &
  & 0.45445373E-10_JPRB, 0.45651247E-10_JPRB, 0.45923407E-10_JPRB, 0.46384147E-10_JPRB, 0.47101371E-10_JPRB, 0.48218089E-10_JPRB, &
  & 0.49890717E-10_JPRB, 0.52247307E-10_JPRB, 0.55389700E-10_JPRB, 0.59361523E-10_JPRB, 0.64138750E-10_JPRB, 0.69658571E-10_JPRB, &
  & 0.75737028E-10_JPRB, 0.82176786E-10_JPRB, 0.88706806E-10_JPRB, 0.95117178E-10_JPRB, 0.10123144E-09_JPRB, 0.10699689E-09_JPRB, &
  & 0.11234500E-09_JPRB, 0.11721679E-09_JPRB, 0.12155166E-09_JPRB, 0.12529500E-09_JPRB, 0.12845935E-09_JPRB, 0.13115070E-09_JPRB, &
  & 0.13355980E-09_JPRB, 0.13597820E-09_JPRB, 0.13875558E-09_JPRB, 0.14212509E-09_JPRB, 0.14618144E-09_JPRB, 0.15072318E-09_JPRB, &
  & 0.15537943E-09_JPRB, 0.15969948E-09_JPRB, 0.16315901E-09_JPRB, 0.16537474E-09_JPRB, 0.16604021E-09_JPRB, 0.16509082E-09_JPRB, &
  & 0.16256037E-09_JPRB, 0.15859719E-09_JPRB, 0.15343193E-09_JPRB, 0.14723223E-09_JPRB, 0.14029439E-09_JPRB, 0.13290986E-09_JPRB, &
  & 0.12539271E-09_JPRB, 0.11804087E-09_JPRB, 0.11109424E-09_JPRB, 0.10468268E-09_JPRB, 0.98890902E-10_JPRB, 0.93780275E-10_JPRB, &
  & 0.89334797E-10_JPRB, 0.85458383E-10_JPRB, 0.82119242E-10_JPRB, 0.79274060E-10_JPRB, 0.76879815E-10_JPRB, 0.74871276E-10_JPRB, &
  & 0.73182391E-10_JPRB, 0.71741807E-10_JPRB, 0.70493951E-10_JPRB, 0.69433265E-10_JPRB, 0.68549312E-10_JPRB, 0.67843724E-10_JPRB, &
  & 0.67318692E-10_JPRB, 0.66971984E-10_JPRB, 0.66790157E-10_JPRB, 0.66850414E-10_JPRB /)

RGHG5(:,27, 5) = (/ &
  & 0.56205297E-10_JPRB, 0.56753553E-10_JPRB, 0.57306278E-10_JPRB, 0.57986959E-10_JPRB, 0.58983513E-10_JPRB, 0.60428169E-10_JPRB, &
  & 0.62480736E-10_JPRB, 0.65311048E-10_JPRB, 0.68965514E-10_JPRB, 0.73482082E-10_JPRB, 0.78846908E-10_JPRB, 0.84940922E-10_JPRB, &
  & 0.91631182E-10_JPRB, 0.98666401E-10_JPRB, 0.10579313E-09_JPRB, 0.11275481E-09_JPRB, 0.11934945E-09_JPRB, 0.12548958E-09_JPRB, &
  & 0.13110397E-09_JPRB, 0.13612958E-09_JPRB, 0.14049768E-09_JPRB, 0.14416489E-09_JPRB, 0.14714609E-09_JPRB, 0.14954102E-09_JPRB, &
  & 0.15153555E-09_JPRB, 0.15343610E-09_JPRB, 0.15563043E-09_JPRB, 0.15836613E-09_JPRB, 0.16184051E-09_JPRB, 0.16599085E-09_JPRB, &
  & 0.17040001E-09_JPRB, 0.17465156E-09_JPRB, 0.17818486E-09_JPRB, 0.18052453E-09_JPRB, 0.18132661E-09_JPRB, 0.18046792E-09_JPRB, &
  & 0.17795801E-09_JPRB, 0.17389791E-09_JPRB, 0.16858870E-09_JPRB, 0.16228721E-09_JPRB, 0.15522245E-09_JPRB, 0.14776375E-09_JPRB, &
  & 0.14022988E-09_JPRB, 0.13293816E-09_JPRB, 0.12607348E-09_JPRB, 0.11973240E-09_JPRB, 0.11401384E-09_JPRB, 0.10894318E-09_JPRB, &
  & 0.10449379E-09_JPRB, 0.10057652E-09_JPRB, 0.97144723E-10_JPRB, 0.94152644E-10_JPRB, 0.91568003E-10_JPRB, 0.89325658E-10_JPRB, &
  & 0.87368675E-10_JPRB, 0.85633931E-10_JPRB, 0.84070542E-10_JPRB, 0.82666846E-10_JPRB, 0.81423361E-10_JPRB, 0.80355063E-10_JPRB, &
  & 0.79476641E-10_JPRB, 0.78785936E-10_JPRB, 0.78231963E-10_JPRB, 0.77676712E-10_JPRB /)

RGHG5(:,28, 5) = (/ &
  & 0.67198871E-10_JPRB, 0.68217924E-10_JPRB, 0.68946036E-10_JPRB, 0.69877992E-10_JPRB, 0.71096962E-10_JPRB, 0.72807843E-10_JPRB, &
  & 0.75209297E-10_JPRB, 0.78384410E-10_JPRB, 0.82431673E-10_JPRB, 0.87337054E-10_JPRB, 0.93059158E-10_JPRB, 0.99535838E-10_JPRB, &
  & 0.10657605E-09_JPRB, 0.11398051E-09_JPRB, 0.12146818E-09_JPRB, 0.12878461E-09_JPRB, 0.13572966E-09_JPRB, 0.14213754E-09_JPRB, &
  & 0.14795655E-09_JPRB, 0.15312043E-09_JPRB, 0.15756776E-09_JPRB, 0.16125042E-09_JPRB, 0.16418014E-09_JPRB, 0.16644536E-09_JPRB, &
  & 0.16821430E-09_JPRB, 0.16978337E-09_JPRB, 0.17149079E-09_JPRB, 0.17365560E-09_JPRB, 0.17649324E-09_JPRB, 0.18001139E-09_JPRB, &
  & 0.18391086E-09_JPRB, 0.18776503E-09_JPRB, 0.19105145E-09_JPRB, 0.19323068E-09_JPRB, 0.19396915E-09_JPRB, 0.19309317E-09_JPRB, &
  & 0.19059225E-09_JPRB, 0.18660862E-09_JPRB, 0.18139704E-09_JPRB, 0.17522576E-09_JPRB, 0.16837975E-09_JPRB, 0.16121333E-09_JPRB, &
  & 0.15403659E-09_JPRB, 0.14710266E-09_JPRB, 0.14056355E-09_JPRB, 0.13450643E-09_JPRB, 0.12898546E-09_JPRB, 0.12404079E-09_JPRB, &
  & 0.11963812E-09_JPRB, 0.11569114E-09_JPRB, 0.11215899E-09_JPRB, 0.10900839E-09_JPRB, 0.10620706E-09_JPRB, 0.10371289E-09_JPRB, &
  & 0.10147325E-09_JPRB, 0.99433545E-10_JPRB, 0.97547859E-10_JPRB, 0.95805551E-10_JPRB, 0.94215503E-10_JPRB, 0.92800552E-10_JPRB, &
  & 0.91590180E-10_JPRB, 0.90576782E-10_JPRB, 0.89674386E-10_JPRB, 0.88578894E-10_JPRB /)

RGHG5(:,29, 5) = (/ &
  & 0.78272222E-10_JPRB, 0.79522472E-10_JPRB, 0.80551454E-10_JPRB, 0.81623791E-10_JPRB, 0.83060649E-10_JPRB, 0.85014974E-10_JPRB, &
  & 0.87646126E-10_JPRB, 0.91124885E-10_JPRB, 0.95424516E-10_JPRB, 0.10055888E-09_JPRB, 0.10649894E-09_JPRB, 0.11313573E-09_JPRB, &
  & 0.12036598E-09_JPRB, 0.12794900E-09_JPRB, 0.13563350E-09_JPRB, 0.14314194E-09_JPRB, 0.15027483E-09_JPRB, 0.15687535E-09_JPRB, &
  & 0.16285313E-09_JPRB, 0.16813885E-09_JPRB, 0.17268831E-09_JPRB, 0.17643839E-09_JPRB, 0.17941618E-09_JPRB, 0.18168184E-09_JPRB, &
  & 0.18338163E-09_JPRB, 0.18477810E-09_JPRB, 0.18614953E-09_JPRB, 0.18782821E-09_JPRB, 0.19005979E-09_JPRB, 0.19287419E-09_JPRB, &
  & 0.19610334E-09_JPRB, 0.19935235E-09_JPRB, 0.20216508E-09_JPRB, 0.20400327E-09_JPRB, 0.20454095E-09_JPRB, 0.20359250E-09_JPRB, &
  & 0.20115851E-09_JPRB, 0.19735807E-09_JPRB, 0.19244074E-09_JPRB, 0.18665634E-09_JPRB, 0.18029589E-09_JPRB, 0.17368670E-09_JPRB, &
  & 0.16711352E-09_JPRB, 0.16074853E-09_JPRB, 0.15471742E-09_JPRB, 0.14903692E-09_JPRB, 0.14378024E-09_JPRB, 0.13897777E-09_JPRB, &
  & 0.13460702E-09_JPRB, 0.13060407E-09_JPRB, 0.12694235E-09_JPRB, 0.12359677E-09_JPRB, 0.12056120E-09_JPRB, 0.11780256E-09_JPRB, &
  & 0.11527616E-09_JPRB, 0.11293649E-09_JPRB, 0.11074019E-09_JPRB, 0.10867136E-09_JPRB, 0.10674753E-09_JPRB, 0.10499929E-09_JPRB, &
  & 0.10346623E-09_JPRB, 0.10213835E-09_JPRB, 0.10089556E-09_JPRB, 0.99189261E-10_JPRB /)

RGHG5(:,30, 5) = (/ &
  & 0.88845917E-10_JPRB, 0.90592964E-10_JPRB, 0.91718209E-10_JPRB, 0.93025178E-10_JPRB, 0.94617404E-10_JPRB, 0.96752356E-10_JPRB, &
  & 0.99620777E-10_JPRB, 0.10326276E-09_JPRB, 0.10773512E-09_JPRB, 0.11299096E-09_JPRB, 0.11899152E-09_JPRB, 0.12569196E-09_JPRB, &
  & 0.13293153E-09_JPRB, 0.14055035E-09_JPRB, 0.14830011E-09_JPRB, 0.15589308E-09_JPRB, 0.16312153E-09_JPRB, 0.16982749E-09_JPRB, &
  & 0.17591413E-09_JPRB, 0.18128415E-09_JPRB, 0.18593146E-09_JPRB, 0.18976232E-09_JPRB, 0.19283838E-09_JPRB, 0.19517420E-09_JPRB, &
  & 0.19690978E-09_JPRB, 0.19824525E-09_JPRB, 0.19941658E-09_JPRB, 0.20072734E-09_JPRB, 0.20242344E-09_JPRB, 0.20457111E-09_JPRB, &
  & 0.20708202E-09_JPRB, 0.20963761E-09_JPRB, 0.21186183E-09_JPRB, 0.21326292E-09_JPRB, 0.21353878E-09_JPRB, 0.21251684E-09_JPRB, &
  & 0.21018243E-09_JPRB, 0.20667527E-09_JPRB, 0.20220903E-09_JPRB, 0.19701803E-09_JPRB, 0.19133883E-09_JPRB, 0.18546749E-09_JPRB, &
  & 0.17961653E-09_JPRB, 0.17392307E-09_JPRB, 0.16842035E-09_JPRB, 0.16316277E-09_JPRB, 0.15814768E-09_JPRB, 0.15346872E-09_JPRB, &
  & 0.14911980E-09_JPRB, 0.14503747E-09_JPRB, 0.14122031E-09_JPRB, 0.13767038E-09_JPRB, 0.13438718E-09_JPRB, 0.13136399E-09_JPRB, &
  & 0.12856737E-09_JPRB, 0.12595446E-09_JPRB, 0.12347812E-09_JPRB, 0.12112333E-09_JPRB, 0.11890686E-09_JPRB, 0.11686221E-09_JPRB, &
  & 0.11504546E-09_JPRB, 0.11344063E-09_JPRB, 0.11191074E-09_JPRB, 0.10974243E-09_JPRB /)

RGHG5(:,31, 5) = (/ &
  & 0.99102344E-10_JPRB, 0.10103958E-09_JPRB, 0.10248385E-09_JPRB, 0.10390069E-09_JPRB, 0.10567788E-09_JPRB, 0.10798886E-09_JPRB, &
  & 0.11097911E-09_JPRB, 0.11476754E-09_JPRB, 0.11929839E-09_JPRB, 0.12456368E-09_JPRB, 0.13055225E-09_JPRB, 0.13717823E-09_JPRB, &
  & 0.14436172E-09_JPRB, 0.15188546E-09_JPRB, 0.15956028E-09_JPRB, 0.16714637E-09_JPRB, 0.17439455E-09_JPRB, 0.18113737E-09_JPRB, &
  & 0.18728727E-09_JPRB, 0.19270878E-09_JPRB, 0.19742293E-09_JPRB, 0.20133278E-09_JPRB, 0.20450379E-09_JPRB, 0.20694089E-09_JPRB, &
  & 0.20875897E-09_JPRB, 0.21011268E-09_JPRB, 0.21120347E-09_JPRB, 0.21225800E-09_JPRB, 0.21352918E-09_JPRB, 0.21507937E-09_JPRB, &
  & 0.21690628E-09_JPRB, 0.21877568E-09_JPRB, 0.22038399E-09_JPRB, 0.22132499E-09_JPRB, 0.22132048E-09_JPRB, 0.22022796E-09_JPRB, &
  & 0.21804497E-09_JPRB, 0.21490001E-09_JPRB, 0.21097814E-09_JPRB, 0.20645907E-09_JPRB, 0.20156331E-09_JPRB, 0.19648574E-09_JPRB, &
  & 0.19140360E-09_JPRB, 0.18638616E-09_JPRB, 0.18145463E-09_JPRB, 0.17656615E-09_JPRB, 0.17181441E-09_JPRB, 0.16723939E-09_JPRB, &
  & 0.16287514E-09_JPRB, 0.15870494E-09_JPRB, 0.15473046E-09_JPRB, 0.15097011E-09_JPRB, 0.14745927E-09_JPRB, 0.14420037E-09_JPRB, &
  & 0.14116794E-09_JPRB, 0.13832262E-09_JPRB, 0.13561649E-09_JPRB, 0.13302842E-09_JPRB, 0.13057266E-09_JPRB, 0.12829025E-09_JPRB, &
  & 0.12623604E-09_JPRB, 0.12440358E-09_JPRB, 0.12262572E-09_JPRB, 0.12008224E-09_JPRB /)

RGHG5(:,32, 5) = (/ &
  & 0.10868478E-09_JPRB, 0.11116620E-09_JPRB, 0.11268943E-09_JPRB, 0.11435119E-09_JPRB, 0.11626261E-09_JPRB, 0.11869492E-09_JPRB, &
  & 0.12181055E-09_JPRB, 0.12562081E-09_JPRB, 0.13014144E-09_JPRB, 0.13534406E-09_JPRB, 0.14120116E-09_JPRB, 0.14769579E-09_JPRB, &
  & 0.15469726E-09_JPRB, 0.16208178E-09_JPRB, 0.16961381E-09_JPRB, 0.17708114E-09_JPRB, 0.18428081E-09_JPRB, 0.19099228E-09_JPRB, &
  & 0.19714591E-09_JPRB, 0.20259308E-09_JPRB, 0.20732976E-09_JPRB, 0.21130461E-09_JPRB, 0.21454172E-09_JPRB, 0.21707960E-09_JPRB, &
  & 0.21898605E-09_JPRB, 0.22039394E-09_JPRB, 0.22146630E-09_JPRB, 0.22237481E-09_JPRB, 0.22332194E-09_JPRB, 0.22439567E-09_JPRB, &
  & 0.22562101E-09_JPRB, 0.22686553E-09_JPRB, 0.22789254E-09_JPRB, 0.22837741E-09_JPRB, 0.22809193E-09_JPRB, 0.22693916E-09_JPRB, &
  & 0.22494323E-09_JPRB, 0.22220156E-09_JPRB, 0.21885670E-09_JPRB, 0.21504279E-09_JPRB, 0.21090790E-09_JPRB, 0.20661285E-09_JPRB, &
  & 0.20223812E-09_JPRB, 0.19784907E-09_JPRB, 0.19340043E-09_JPRB, 0.18890010E-09_JPRB, 0.18438231E-09_JPRB, 0.17992430E-09_JPRB, &
  & 0.17557036E-09_JPRB, 0.17132606E-09_JPRB, 0.16722014E-09_JPRB, 0.16329074E-09_JPRB, 0.15959697E-09_JPRB, 0.15614735E-09_JPRB, &
  & 0.15293328E-09_JPRB, 0.14991097E-09_JPRB, 0.14702950E-09_JPRB, 0.14426853E-09_JPRB, 0.14163704E-09_JPRB, 0.13917500E-09_JPRB, &
  & 0.13694512E-09_JPRB, 0.13493309E-09_JPRB, 0.13295408E-09_JPRB, 0.13009463E-09_JPRB /)

RGHG5(:,33, 5) = (/ &
  & 0.11801184E-09_JPRB, 0.12072465E-09_JPRB, 0.12259832E-09_JPRB, 0.12435755E-09_JPRB, 0.12642982E-09_JPRB, 0.12897414E-09_JPRB, &
  & 0.13210857E-09_JPRB, 0.13590752E-09_JPRB, 0.14032989E-09_JPRB, 0.14537241E-09_JPRB, 0.15105205E-09_JPRB, 0.15730842E-09_JPRB, &
  & 0.16408323E-09_JPRB, 0.17120350E-09_JPRB, 0.17852644E-09_JPRB, 0.18583579E-09_JPRB, 0.19291736E-09_JPRB, 0.19956503E-09_JPRB, &
  & 0.20566590E-09_JPRB, 0.21110591E-09_JPRB, 0.21583804E-09_JPRB, 0.21984310E-09_JPRB, 0.22312299E-09_JPRB, 0.22573128E-09_JPRB, &
  & 0.22771174E-09_JPRB, 0.22917568E-09_JPRB, 0.23025137E-09_JPRB, 0.23108031E-09_JPRB, 0.23180707E-09_JPRB, 0.23252196E-09_JPRB, &
  & 0.23326999E-09_JPRB, 0.23398830E-09_JPRB, 0.23451574E-09_JPRB, 0.23461774E-09_JPRB, 0.23412972E-09_JPRB, 0.23297897E-09_JPRB, &
  & 0.23116484E-09_JPRB, 0.22878700E-09_JPRB, 0.22596428E-09_JPRB, 0.22278342E-09_JPRB, 0.21933096E-09_JPRB, 0.21569659E-09_JPRB, &
  & 0.21195729E-09_JPRB, 0.20807142E-09_JPRB, 0.20406468E-09_JPRB, 0.19987735E-09_JPRB, 0.19559590E-09_JPRB, 0.19128457E-09_JPRB, &
  & 0.18697251E-09_JPRB, 0.18270729E-09_JPRB, 0.17852048E-09_JPRB, 0.17448645E-09_JPRB, 0.17066834E-09_JPRB, 0.16709779E-09_JPRB, &
  & 0.16376477E-09_JPRB, 0.16062614E-09_JPRB, 0.15763248E-09_JPRB, 0.15476080E-09_JPRB, 0.15201461E-09_JPRB, 0.14944221E-09_JPRB, &
  & 0.14709016E-09_JPRB, 0.14495694E-09_JPRB, 0.14283157E-09_JPRB, 0.13973210E-09_JPRB /)

RGHG5(:,34, 5) = (/ &
  & 0.12684481E-09_JPRB, 0.13010329E-09_JPRB, 0.13205699E-09_JPRB, 0.13403866E-09_JPRB, 0.13620294E-09_JPRB, 0.13880178E-09_JPRB, &
  & 0.14194154E-09_JPRB, 0.14564019E-09_JPRB, 0.14990419E-09_JPRB, 0.15473878E-09_JPRB, 0.16014379E-09_JPRB, 0.16612625E-09_JPRB, &
  & 0.17259118E-09_JPRB, 0.17943733E-09_JPRB, 0.18647127E-09_JPRB, 0.19354218E-09_JPRB, 0.20045614E-09_JPRB, 0.20699864E-09_JPRB, &
  & 0.21302077E-09_JPRB, 0.21841449E-09_JPRB, 0.22312591E-09_JPRB, 0.22712823E-09_JPRB, 0.23042959E-09_JPRB, 0.23307212E-09_JPRB, &
  & 0.23510427E-09_JPRB, 0.23660851E-09_JPRB, 0.23769359E-09_JPRB, 0.23846733E-09_JPRB, 0.23904875E-09_JPRB, 0.23950911E-09_JPRB, &
  & 0.23990629E-09_JPRB, 0.24021660E-09_JPRB, 0.24034535E-09_JPRB, 0.24013866E-09_JPRB, 0.23948107E-09_JPRB, 0.23833724E-09_JPRB, &
  & 0.23674435E-09_JPRB, 0.23473193E-09_JPRB, 0.23236923E-09_JPRB, 0.22970761E-09_JPRB, 0.22679782E-09_JPRB, 0.22370153E-09_JPRB, &
  & 0.22042321E-09_JPRB, 0.21697348E-09_JPRB, 0.21330235E-09_JPRB, 0.20941889E-09_JPRB, 0.20535573E-09_JPRB, 0.20119087E-09_JPRB, &
  & 0.19698275E-09_JPRB, 0.19274203E-09_JPRB, 0.18854431E-09_JPRB, 0.18447441E-09_JPRB, 0.18060670E-09_JPRB, 0.17698705E-09_JPRB, &
  & 0.17360202E-09_JPRB, 0.17041075E-09_JPRB, 0.16736539E-09_JPRB, 0.16444483E-09_JPRB, 0.16165430E-09_JPRB, 0.15903470E-09_JPRB, &
  & 0.15663391E-09_JPRB, 0.15443220E-09_JPRB, 0.15222250E-09_JPRB, 0.14897016E-09_JPRB /)

RGHG5(:,35, 5) = (/ &
  & 0.13550584E-09_JPRB, 0.13899991E-09_JPRB, 0.14125029E-09_JPRB, 0.14330558E-09_JPRB, 0.14556964E-09_JPRB, 0.14819865E-09_JPRB, &
  & 0.15127469E-09_JPRB, 0.15484614E-09_JPRB, 0.15890304E-09_JPRB, 0.16346842E-09_JPRB, 0.16857855E-09_JPRB, 0.17421367E-09_JPRB, &
  & 0.18033529E-09_JPRB, 0.18682583E-09_JPRB, 0.19355761E-09_JPRB, 0.20035346E-09_JPRB, 0.20703150E-09_JPRB, 0.21342127E-09_JPRB, &
  & 0.21934794E-09_JPRB, 0.22467982E-09_JPRB, 0.22935552E-09_JPRB, 0.23334362E-09_JPRB, 0.23664215E-09_JPRB, 0.23929259E-09_JPRB, &
  & 0.24134261E-09_JPRB, 0.24286084E-09_JPRB, 0.24394670E-09_JPRB, 0.24467928E-09_JPRB, 0.24516256E-09_JPRB, 0.24544841E-09_JPRB, &
  & 0.24560387E-09_JPRB, 0.24562666E-09_JPRB, 0.24547112E-09_JPRB, 0.24505550E-09_JPRB, 0.24431673E-09_JPRB, 0.24322824E-09_JPRB, &
  & 0.24181004E-09_JPRB, 0.24010691E-09_JPRB, 0.23812802E-09_JPRB, 0.23586944E-09_JPRB, 0.23335789E-09_JPRB, 0.23062736E-09_JPRB, &
  & 0.22769926E-09_JPRB, 0.22453661E-09_JPRB, 0.22115683E-09_JPRB, 0.21751469E-09_JPRB, 0.21366718E-09_JPRB, 0.20967936E-09_JPRB, &
  & 0.20558215E-09_JPRB, 0.20142907E-09_JPRB, 0.19727922E-09_JPRB, 0.19323732E-09_JPRB, 0.18939532E-09_JPRB, 0.18579339E-09_JPRB, &
  & 0.18242147E-09_JPRB, 0.17923858E-09_JPRB, 0.17620147E-09_JPRB, 0.17329110E-09_JPRB, 0.17051753E-09_JPRB, 0.16792032E-09_JPRB, &
  & 0.16553381E-09_JPRB, 0.16333024E-09_JPRB, 0.16110144E-09_JPRB, 0.15777989E-09_JPRB /)

RGHG5(:,36, 5) = (/ &
  & 0.14376468E-09_JPRB, 0.14765261E-09_JPRB, 0.14998587E-09_JPRB, 0.15218679E-09_JPRB, 0.15451612E-09_JPRB, 0.15713647E-09_JPRB, &
  & 0.16014123E-09_JPRB, 0.16354479E-09_JPRB, 0.16736322E-09_JPRB, 0.17163404E-09_JPRB, 0.17639769E-09_JPRB, 0.18167054E-09_JPRB, &
  & 0.18740896E-09_JPRB, 0.19352731E-09_JPRB, 0.19989076E-09_JPRB, 0.20637754E-09_JPRB, 0.21279949E-09_JPRB, 0.21898658E-09_JPRB, &
  & 0.22478662E-09_JPRB, 0.23005185E-09_JPRB, 0.23469054E-09_JPRB, 0.23865812E-09_JPRB, 0.24194086E-09_JPRB, 0.24456670E-09_JPRB, &
  & 0.24659058E-09_JPRB, 0.24808042E-09_JPRB, 0.24913177E-09_JPRB, 0.24981783E-09_JPRB, 0.25022698E-09_JPRB, 0.25040553E-09_JPRB, &
  & 0.25040794E-09_JPRB, 0.25026028E-09_JPRB, 0.24993993E-09_JPRB, 0.24941998E-09_JPRB, 0.24867852E-09_JPRB, 0.24770566E-09_JPRB, &
  & 0.24647839E-09_JPRB, 0.24500885E-09_JPRB, 0.24331606E-09_JPRB, 0.24135452E-09_JPRB, 0.23910529E-09_JPRB, 0.23660687E-09_JPRB, &
  & 0.23387409E-09_JPRB, 0.23092769E-09_JPRB, 0.22774108E-09_JPRB, 0.22431897E-09_JPRB, 0.22067197E-09_JPRB, 0.21684818E-09_JPRB, &
  & 0.21289413E-09_JPRB, 0.20884719E-09_JPRB, 0.20478919E-09_JPRB, 0.20083252E-09_JPRB, 0.19707064E-09_JPRB, 0.19354950E-09_JPRB, &
  & 0.19025036E-09_JPRB, 0.18713174E-09_JPRB, 0.18415366E-09_JPRB, 0.18130678E-09_JPRB, 0.17860756E-09_JPRB, 0.17609096E-09_JPRB, &
  & 0.17378285E-09_JPRB, 0.17164027E-09_JPRB, 0.16945344E-09_JPRB, 0.16615870E-09_JPRB /)

RGHG5(:,37, 5) = (/ &
  & 0.15176736E-09_JPRB, 0.15586669E-09_JPRB, 0.15837025E-09_JPRB, 0.16065482E-09_JPRB, 0.16304552E-09_JPRB, 0.16566855E-09_JPRB, &
  & 0.16857860E-09_JPRB, 0.17179975E-09_JPRB, 0.17535855E-09_JPRB, 0.17931048E-09_JPRB, 0.18371218E-09_JPRB, 0.18858722E-09_JPRB, &
  & 0.19391515E-09_JPRB, 0.19962687E-09_JPRB, 0.20560587E-09_JPRB, 0.21173430E-09_JPRB, 0.21786817E-09_JPRB, 0.22383539E-09_JPRB, &
  & 0.22948604E-09_JPRB, 0.23466942E-09_JPRB, 0.23926233E-09_JPRB, 0.24320010E-09_JPRB, 0.24642691E-09_JPRB, 0.24896477E-09_JPRB, &
  & 0.25087477E-09_JPRB, 0.25225261E-09_JPRB, 0.25320041E-09_JPRB, 0.25380709E-09_JPRB, 0.25414118E-09_JPRB, 0.25426239E-09_JPRB, &
  & 0.25419200E-09_JPRB, 0.25397764E-09_JPRB, 0.25360836E-09_JPRB, 0.25307736E-09_JPRB, 0.25239016E-09_JPRB, 0.25153776E-09_JPRB, &
  & 0.25052810E-09_JPRB, 0.24931204E-09_JPRB, 0.24786043E-09_JPRB, 0.24613805E-09_JPRB, 0.24409563E-09_JPRB, 0.24173791E-09_JPRB, &
  & 0.23912891E-09_JPRB, 0.23630001E-09_JPRB, 0.23327049E-09_JPRB, 0.23001291E-09_JPRB, 0.22654657E-09_JPRB, 0.22289147E-09_JPRB, &
  & 0.21907676E-09_JPRB, 0.21515176E-09_JPRB, 0.21121253E-09_JPRB, 0.20737237E-09_JPRB, 0.20374047E-09_JPRB, 0.20034691E-09_JPRB, &
  & 0.19716970E-09_JPRB, 0.19416216E-09_JPRB, 0.19128871E-09_JPRB, 0.18854943E-09_JPRB, 0.18597125E-09_JPRB, 0.18358728E-09_JPRB, &
  & 0.18140875E-09_JPRB, 0.17938002E-09_JPRB, 0.17729360E-09_JPRB, 0.17410537E-09_JPRB /)

RGHG5(:,38, 5) = (/ &
  & 0.15948082E-09_JPRB, 0.16372556E-09_JPRB, 0.16635268E-09_JPRB, 0.16871808E-09_JPRB, 0.17120647E-09_JPRB, 0.17382247E-09_JPRB, &
  & 0.17664149E-09_JPRB, 0.17967232E-09_JPRB, 0.18295411E-09_JPRB, 0.18656805E-09_JPRB, 0.19059219E-09_JPRB, 0.19505804E-09_JPRB, &
  & 0.19995711E-09_JPRB, 0.20523414E-09_JPRB, 0.21079635E-09_JPRB, 0.21653986E-09_JPRB, 0.22233809E-09_JPRB, 0.22805345E-09_JPRB, &
  & 0.23352981E-09_JPRB, 0.23860772E-09_JPRB, 0.24312113E-09_JPRB, 0.24694349E-09_JPRB, 0.25002378E-09_JPRB, 0.25234945E-09_JPRB, &
  & 0.25402788E-09_JPRB, 0.25519231E-09_JPRB, 0.25596950E-09_JPRB, 0.25645824E-09_JPRB, 0.25671823E-09_JPRB, 0.25680294E-09_JPRB, &
  & 0.25672484E-09_JPRB, 0.25651251E-09_JPRB, 0.25617550E-09_JPRB, 0.25571037E-09_JPRB, 0.25512661E-09_JPRB, 0.25442976E-09_JPRB, &
  & 0.25360730E-09_JPRB, 0.25263658E-09_JPRB, 0.25144165E-09_JPRB, 0.24996472E-09_JPRB, 0.24815272E-09_JPRB, 0.24599012E-09_JPRB, &
  & 0.24352123E-09_JPRB, 0.24080843E-09_JPRB, 0.23790250E-09_JPRB, 0.23479957E-09_JPRB, 0.23149563E-09_JPRB, 0.22799510E-09_JPRB, &
  & 0.22431697E-09_JPRB, 0.22051747E-09_JPRB, 0.21670192E-09_JPRB, 0.21300509E-09_JPRB, 0.20952795E-09_JPRB, 0.20629783E-09_JPRB, &
  & 0.20328061E-09_JPRB, 0.20042035E-09_JPRB, 0.19768771E-09_JPRB, 0.19509150E-09_JPRB, 0.19267180E-09_JPRB, 0.19045790E-09_JPRB, &
  & 0.18844883E-09_JPRB, 0.18657374E-09_JPRB, 0.18462815E-09_JPRB, 0.18161851E-09_JPRB /)

RGHG5(:,39, 5) = (/ &
  & 0.16690800E-09_JPRB, 0.17129445E-09_JPRB, 0.17392214E-09_JPRB, 0.17644647E-09_JPRB, 0.17897556E-09_JPRB, 0.18163709E-09_JPRB, &
  & 0.18436325E-09_JPRB, 0.18719136E-09_JPRB, 0.19018777E-09_JPRB, 0.19345735E-09_JPRB, 0.19708571E-09_JPRB, 0.20113311E-09_JPRB, &
  & 0.20559233E-09_JPRB, 0.21042254E-09_JPRB, 0.21554483E-09_JPRB, 0.22087777E-09_JPRB, 0.22631841E-09_JPRB, 0.23174182E-09_JPRB, &
  & 0.23699467E-09_JPRB, 0.24191291E-09_JPRB, 0.24625821E-09_JPRB, 0.24985847E-09_JPRB, 0.25263946E-09_JPRB, 0.25466443E-09_JPRB, &
  & 0.25605426E-09_JPRB, 0.25698660E-09_JPRB, 0.25759592E-09_JPRB, 0.25797514E-09_JPRB, 0.25817937E-09_JPRB, 0.25823865E-09_JPRB, &
  & 0.25817437E-09_JPRB, 0.25798819E-09_JPRB, 0.25770000E-09_JPRB, 0.25730673E-09_JPRB, 0.25682753E-09_JPRB, 0.25626062E-09_JPRB, &
  & 0.25560251E-09_JPRB, 0.25482330E-09_JPRB, 0.25387498E-09_JPRB, 0.25267127E-09_JPRB, 0.25114358E-09_JPRB, 0.24925803E-09_JPRB, &
  & 0.24702967E-09_JPRB, 0.24452113E-09_JPRB, 0.24177335E-09_JPRB, 0.23883073E-09_JPRB, 0.23568508E-09_JPRB, 0.23233639E-09_JPRB, &
  & 0.22879482E-09_JPRB, 0.22511662E-09_JPRB, 0.22143001E-09_JPRB, 0.21788041E-09_JPRB, 0.21457276E-09_JPRB, 0.21152666E-09_JPRB, &
  & 0.20868976E-09_JPRB, 0.20600306E-09_JPRB, 0.20343471E-09_JPRB, 0.20100900E-09_JPRB, 0.19877187E-09_JPRB, 0.19675450E-09_JPRB, &
  & 0.19493704E-09_JPRB, 0.19324001E-09_JPRB, 0.19146101E-09_JPRB, 0.18868106E-09_JPRB /)

RGHG5(:,40, 5) = (/ &
  & 0.17419913E-09_JPRB, 0.17846506E-09_JPRB, 0.18121724E-09_JPRB, 0.18373966E-09_JPRB, 0.18643947E-09_JPRB, 0.18909847E-09_JPRB, &
  & 0.19174509E-09_JPRB, 0.19436894E-09_JPRB, 0.19707409E-09_JPRB, 0.19998145E-09_JPRB, 0.20321915E-09_JPRB, 0.20683977E-09_JPRB, &
  & 0.21085715E-09_JPRB, 0.21523670E-09_JPRB, 0.21991373E-09_JPRB, 0.22481693E-09_JPRB, 0.22987087E-09_JPRB, 0.23497063E-09_JPRB, &
  & 0.23996008E-09_JPRB, 0.24461666E-09_JPRB, 0.24871791E-09_JPRB, 0.25200073E-09_JPRB, 0.25444047E-09_JPRB, 0.25614730E-09_JPRB, &
  & 0.25728986E-09_JPRB, 0.25803829E-09_JPRB, 0.25852517E-09_JPRB, 0.25882801E-09_JPRB, 0.25899483E-09_JPRB, 0.25904351E-09_JPRB, &
  & 0.25898814E-09_JPRB, 0.25883071E-09_JPRB, 0.25857880E-09_JPRB, 0.25823912E-09_JPRB, 0.25782954E-09_JPRB, 0.25735444E-09_JPRB, &
  & 0.25680755E-09_JPRB, 0.25617261E-09_JPRB, 0.25541000E-09_JPRB, 0.25445207E-09_JPRB, 0.25322186E-09_JPRB, 0.25165814E-09_JPRB, &
  & 0.24974856E-09_JPRB, 0.24751351E-09_JPRB, 0.24500924E-09_JPRB, 0.24225572E-09_JPRB, 0.23928434E-09_JPRB, 0.23608623E-09_JPRB, &
  & 0.23267782E-09_JPRB, 0.22912014E-09_JPRB, 0.22555675E-09_JPRB, 0.22215518E-09_JPRB, 0.21902102E-09_JPRB, 0.21616281E-09_JPRB, &
  & 0.21351564E-09_JPRB, 0.21101081E-09_JPRB, 0.20862244E-09_JPRB, 0.20637869E-09_JPRB, 0.20434029E-09_JPRB, 0.20252873E-09_JPRB, &
  & 0.20091352E-09_JPRB, 0.19940152E-09_JPRB, 0.19780523E-09_JPRB, 0.19527518E-09_JPRB /)

RGHG5(:,41, 5) = (/ &
  & 0.18128471E-09_JPRB, 0.18549179E-09_JPRB, 0.18811329E-09_JPRB, 0.19078940E-09_JPRB, 0.19350965E-09_JPRB, 0.19624301E-09_JPRB, &
  & 0.19878552E-09_JPRB, 0.20120099E-09_JPRB, 0.20360509E-09_JPRB, 0.20615935E-09_JPRB, 0.20899028E-09_JPRB, 0.21219065E-09_JPRB, &
  & 0.21577380E-09_JPRB, 0.21971162E-09_JPRB, 0.22394794E-09_JPRB, 0.22842966E-09_JPRB, 0.23308441E-09_JPRB, 0.23782470E-09_JPRB, &
  & 0.24249835E-09_JPRB, 0.24686139E-09_JPRB, 0.25061628E-09_JPRB, 0.25357488E-09_JPRB, 0.25569011E-09_JPRB, 0.25713071E-09_JPRB, &
  & 0.25808042E-09_JPRB, 0.25869779E-09_JPRB, 0.25910032E-09_JPRB, 0.25935398E-09_JPRB, 0.25949592E-09_JPRB, 0.25954164E-09_JPRB, &
  & 0.25949384E-09_JPRB, 0.25935776E-09_JPRB, 0.25913471E-09_JPRB, 0.25882924E-09_JPRB, 0.25846786E-09_JPRB, 0.25805183E-09_JPRB, &
  & 0.25757987E-09_JPRB, 0.25704400E-09_JPRB, 0.25641420E-09_JPRB, 0.25564248E-09_JPRB, 0.25466476E-09_JPRB, 0.25341990E-09_JPRB, &
  & 0.25185867E-09_JPRB, 0.24995719E-09_JPRB, 0.24773639E-09_JPRB, 0.24522373E-09_JPRB, 0.24243804E-09_JPRB, 0.23940117E-09_JPRB, &
  & 0.23612962E-09_JPRB, 0.23268919E-09_JPRB, 0.22924448E-09_JPRB, 0.22598498E-09_JPRB, 0.22302045E-09_JPRB, 0.22034644E-09_JPRB, &
  & 0.21788768E-09_JPRB, 0.21556724E-09_JPRB, 0.21335843E-09_JPRB, 0.21130304E-09_JPRB, 0.20946303E-09_JPRB, 0.20785657E-09_JPRB, &
  & 0.20643730E-09_JPRB, 0.20510810E-09_JPRB, 0.20368841E-09_JPRB, 0.20141711E-09_JPRB /)

RGHG5(:,42, 5) = (/ &
  & 0.18829895E-09_JPRB, 0.19225932E-09_JPRB, 0.19485991E-09_JPRB, 0.19747881E-09_JPRB, 0.20032356E-09_JPRB, 0.20305105E-09_JPRB, &
  & 0.20549226E-09_JPRB, 0.20769056E-09_JPRB, 0.20980213E-09_JPRB, 0.21199731E-09_JPRB, 0.21443337E-09_JPRB, 0.21721387E-09_JPRB, &
  & 0.22037512E-09_JPRB, 0.22389093E-09_JPRB, 0.22770860E-09_JPRB, 0.23177438E-09_JPRB, 0.23603802E-09_JPRB, 0.24040400E-09_JPRB, &
  & 0.24472413E-09_JPRB, 0.24873947E-09_JPRB, 0.25215258E-09_JPRB, 0.25476543E-09_JPRB, 0.25660529E-09_JPRB, 0.25782981E-09_JPRB, &
  & 0.25863167E-09_JPRB, 0.25915439E-09_JPRB, 0.25949728E-09_JPRB, 0.25971797E-09_JPRB, 0.25984423E-09_JPRB, 0.25988850E-09_JPRB, &
  & 0.25985031E-09_JPRB, 0.25972835E-09_JPRB, 0.25953004E-09_JPRB, 0.25924873E-09_JPRB, 0.25892083E-09_JPRB, 0.25854599E-09_JPRB, &
  & 0.25812591E-09_JPRB, 0.25765740E-09_JPRB, 0.25712388E-09_JPRB, 0.25648730E-09_JPRB, 0.25570540E-09_JPRB, 0.25472688E-09_JPRB, &
  & 0.25349822E-09_JPRB, 0.25196437E-09_JPRB, 0.25007804E-09_JPRB, 0.24785127E-09_JPRB, 0.24529367E-09_JPRB, 0.24243074E-09_JPRB, &
  & 0.23930330E-09_JPRB, 0.23598545E-09_JPRB, 0.23265348E-09_JPRB, 0.22953366E-09_JPRB, 0.22673180E-09_JPRB, 0.22423750E-09_JPRB, &
  & 0.22195956E-09_JPRB, 0.21981714E-09_JPRB, 0.21778433E-09_JPRB, 0.21590986E-09_JPRB, 0.21425992E-09_JPRB, 0.21284427E-09_JPRB, &
  & 0.21160526E-09_JPRB, 0.21044308E-09_JPRB, 0.20919040E-09_JPRB, 0.20715957E-09_JPRB /)

RGHG5(:,43, 5) = (/ &
  & 0.19521343E-09_JPRB, 0.19894900E-09_JPRB, 0.20138148E-09_JPRB, 0.20398740E-09_JPRB, 0.20684275E-09_JPRB, 0.20955908E-09_JPRB, &
  & 0.21187935E-09_JPRB, 0.21385545E-09_JPRB, 0.21568010E-09_JPRB, 0.21753684E-09_JPRB, 0.21959008E-09_JPRB, 0.22196360E-09_JPRB, &
  & 0.22472041E-09_JPRB, 0.22784100E-09_JPRB, 0.23126503E-09_JPRB, 0.23494404E-09_JPRB, 0.23881297E-09_JPRB, 0.24279923E-09_JPRB, &
  & 0.24673502E-09_JPRB, 0.25038219E-09_JPRB, 0.25342356E-09_JPRB, 0.25572089E-09_JPRB, 0.25731009E-09_JPRB, 0.25836189E-09_JPRB, &
  & 0.25904728E-09_JPRB, 0.25949853E-09_JPRB, 0.25979832E-09_JPRB, 0.25999528E-09_JPRB, 0.26011210E-09_JPRB, 0.26015615E-09_JPRB, &
  & 0.26012753E-09_JPRB, 0.26001795E-09_JPRB, 0.25983873E-09_JPRB, 0.25957853E-09_JPRB, 0.25927394E-09_JPRB, 0.25893032E-09_JPRB, &
  & 0.25854557E-09_JPRB, 0.25812719E-09_JPRB, 0.25766081E-09_JPRB, 0.25712682E-09_JPRB, 0.25649413E-09_JPRB, 0.25573013E-09_JPRB, &
  & 0.25479069E-09_JPRB, 0.25360591E-09_JPRB, 0.25210539E-09_JPRB, 0.25022059E-09_JPRB, 0.24794430E-09_JPRB, 0.24529961E-09_JPRB, &
  & 0.24233479E-09_JPRB, 0.23914595E-09_JPRB, 0.23593788E-09_JPRB, 0.23295005E-09_JPRB, 0.23031101E-09_JPRB, 0.22798650E-09_JPRB, &
  & 0.22588391E-09_JPRB, 0.22391120E-09_JPRB, 0.22204523E-09_JPRB, 0.22034005E-09_JPRB, 0.21886287E-09_JPRB, 0.21761656E-09_JPRB, &
  & 0.21653453E-09_JPRB, 0.21551959E-09_JPRB, 0.21441210E-09_JPRB, 0.21259765E-09_JPRB /)

RGHG5(:,44, 5) = (/ &
  & 0.20206622E-09_JPRB, 0.20546773E-09_JPRB, 0.20780218E-09_JPRB, 0.21028006E-09_JPRB, 0.21311046E-09_JPRB, 0.21578636E-09_JPRB, &
  & 0.21795346E-09_JPRB, 0.21971744E-09_JPRB, 0.22127453E-09_JPRB, 0.22281899E-09_JPRB, 0.22451456E-09_JPRB, 0.22651059E-09_JPRB, &
  & 0.22888411E-09_JPRB, 0.23163793E-09_JPRB, 0.23470892E-09_JPRB, 0.23801511E-09_JPRB, 0.24151192E-09_JPRB, 0.24509356E-09_JPRB, &
  & 0.24863139E-09_JPRB, 0.25185021E-09_JPRB, 0.25452787E-09_JPRB, 0.25650854E-09_JPRB, 0.25788000E-09_JPRB, 0.25878502E-09_JPRB, &
  & 0.25937860E-09_JPRB, 0.25977390E-09_JPRB, 0.26004185E-09_JPRB, 0.26022176E-09_JPRB, 0.26033292E-09_JPRB, 0.26037841E-09_JPRB, &
  & 0.26035835E-09_JPRB, 0.26026076E-09_JPRB, 0.26009755E-09_JPRB, 0.25985525E-09_JPRB, 0.25956956E-09_JPRB, 0.25924812E-09_JPRB, &
  & 0.25889038E-09_JPRB, 0.25850591E-09_JPRB, 0.25809122E-09_JPRB, 0.25763203E-09_JPRB, 0.25711622E-09_JPRB, 0.25652339E-09_JPRB, &
  & 0.25582114E-09_JPRB, 0.25495450E-09_JPRB, 0.25382776E-09_JPRB, 0.25234456E-09_JPRB, 0.25043037E-09_JPRB, 0.24806723E-09_JPRB, &
  & 0.24530833E-09_JPRB, 0.24227156E-09_JPRB, 0.23919433E-09_JPRB, 0.23635716E-09_JPRB, 0.23387264E-09_JPRB, 0.23172259E-09_JPRB, &
  & 0.22978508E-09_JPRB, 0.22797532E-09_JPRB, 0.22626702E-09_JPRB, 0.22471609E-09_JPRB, 0.22339249E-09_JPRB, 0.22228894E-09_JPRB, &
  & 0.22134276E-09_JPRB, 0.22044888E-09_JPRB, 0.21947050E-09_JPRB, 0.21784016E-09_JPRB /)

RGHG5(:,45, 5) = (/ &
  & 0.20868958E-09_JPRB, 0.21192124E-09_JPRB, 0.21399393E-09_JPRB, 0.21640396E-09_JPRB, 0.21914263E-09_JPRB, 0.22172134E-09_JPRB, &
  & 0.22374318E-09_JPRB, 0.22529963E-09_JPRB, 0.22661947E-09_JPRB, 0.22789018E-09_JPRB, 0.22928082E-09_JPRB, 0.23092350E-09_JPRB, &
  & 0.23295246E-09_JPRB, 0.23537014E-09_JPRB, 0.23810817E-09_JPRB, 0.24108515E-09_JPRB, 0.24419478E-09_JPRB, 0.24737232E-09_JPRB, &
  & 0.25043703E-09_JPRB, 0.25322294E-09_JPRB, 0.25548105E-09_JPRB, 0.25717961E-09_JPRB, 0.25834795E-09_JPRB, 0.25913191E-09_JPRB, &
  & 0.25965080E-09_JPRB, 0.26000238E-09_JPRB, 0.26024627E-09_JPRB, 0.26041461E-09_JPRB, 0.26052263E-09_JPRB, 0.26057118E-09_JPRB, &
  & 0.26055882E-09_JPRB, 0.26047295E-09_JPRB, 0.26032310E-09_JPRB, 0.26009725E-09_JPRB, 0.25982633E-09_JPRB, 0.25952193E-09_JPRB, &
  & 0.25918223E-09_JPRB, 0.25882382E-09_JPRB, 0.25844488E-09_JPRB, 0.25804506E-09_JPRB, 0.25761759E-09_JPRB, 0.25715782E-09_JPRB, &
  & 0.25664737E-09_JPRB, 0.25603605E-09_JPRB, 0.25524996E-09_JPRB, 0.25416916E-09_JPRB, 0.25267582E-09_JPRB, 0.25069416E-09_JPRB, &
  & 0.24821106E-09_JPRB, 0.24538208E-09_JPRB, 0.24248206E-09_JPRB, 0.23979388E-09_JPRB, 0.23749527E-09_JPRB, 0.23550442E-09_JPRB, &
  & 0.23374050E-09_JPRB, 0.23208677E-09_JPRB, 0.23052775E-09_JPRB, 0.22911975E-09_JPRB, 0.22792730E-09_JPRB, 0.22695006E-09_JPRB, &
  & 0.22611109E-09_JPRB, 0.22532551E-09_JPRB, 0.22445079E-09_JPRB, 0.22298759E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART9',1,ZHOOK_HANDLE)
END SUBROUTINE PART9




SUBROUTINE PART10
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART10',0,ZHOOK_HANDLE)



RGHG5(:,46, 5) = (/ &
  & 0.21520832E-09_JPRB, 0.21802739E-09_JPRB, 0.22009203E-09_JPRB, 0.22225802E-09_JPRB, 0.22493292E-09_JPRB, 0.22740480E-09_JPRB, &
  & 0.22926211E-09_JPRB, 0.23063915E-09_JPRB, 0.23175567E-09_JPRB, 0.23280655E-09_JPRB, 0.23392921E-09_JPRB, 0.23529531E-09_JPRB, &
  & 0.23699617E-09_JPRB, 0.23911134E-09_JPRB, 0.24155603E-09_JPRB, 0.24419483E-09_JPRB, 0.24693594E-09_JPRB, 0.24964256E-09_JPRB, &
  & 0.25221328E-09_JPRB, 0.25446528E-09_JPRB, 0.25633898E-09_JPRB, 0.25774061E-09_JPRB, 0.25874089E-09_JPRB, 0.25941901E-09_JPRB, &
  & 0.25987840E-09_JPRB, 0.26019586E-09_JPRB, 0.26042182E-09_JPRB, 0.26058256E-09_JPRB, 0.26068972E-09_JPRB, 0.26074254E-09_JPRB, &
  & 0.26073746E-09_JPRB, 0.26066302E-09_JPRB, 0.26052488E-09_JPRB, 0.26031324E-09_JPRB, 0.26005506E-09_JPRB, 0.25976218E-09_JPRB, &
  & 0.25943622E-09_JPRB, 0.25909455E-09_JPRB, 0.25874480E-09_JPRB, 0.25838781E-09_JPRB, 0.25803068E-09_JPRB, 0.25767311E-09_JPRB, &
  & 0.25730401E-09_JPRB, 0.25689384E-09_JPRB, 0.25637167E-09_JPRB, 0.25564126E-09_JPRB, 0.25457722E-09_JPRB, 0.25303637E-09_JPRB, &
  & 0.25096525E-09_JPRB, 0.24843821E-09_JPRB, 0.24575580E-09_JPRB, 0.24329130E-09_JPRB, 0.24115179E-09_JPRB, 0.23936586E-09_JPRB, &
  & 0.23775551E-09_JPRB, 0.23626348E-09_JPRB, 0.23484703E-09_JPRB, 0.23356955E-09_JPRB, 0.23249852E-09_JPRB, 0.23162339E-09_JPRB, &
  & 0.23088256E-09_JPRB, 0.23018157E-09_JPRB, 0.22940393E-09_JPRB, 0.22808316E-09_JPRB /)

RGHG5(:,47, 5) = (/ &
  & 0.22130407E-09_JPRB, 0.22406131E-09_JPRB, 0.22581033E-09_JPRB, 0.22798534E-09_JPRB, 0.23046692E-09_JPRB, 0.23283839E-09_JPRB, &
  & 0.23456104E-09_JPRB, 0.23577942E-09_JPRB, 0.23673793E-09_JPRB, 0.23760524E-09_JPRB, 0.23853725E-09_JPRB, 0.23964283E-09_JPRB, &
  & 0.24109542E-09_JPRB, 0.24292302E-09_JPRB, 0.24507704E-09_JPRB, 0.24739460E-09_JPRB, 0.24970626E-09_JPRB, 0.25189695E-09_JPRB, &
  & 0.25387403E-09_JPRB, 0.25561792E-09_JPRB, 0.25706601E-09_JPRB, 0.25822289E-09_JPRB, 0.25906532E-09_JPRB, 0.25965910E-09_JPRB, &
  & 0.26007035E-09_JPRB, 0.26036157E-09_JPRB, 0.26057445E-09_JPRB, 0.26073080E-09_JPRB, 0.26083874E-09_JPRB, 0.26089686E-09_JPRB, &
  & 0.26089894E-09_JPRB, 0.26083524E-09_JPRB, 0.26070773E-09_JPRB, 0.26050856E-09_JPRB, 0.26026101E-09_JPRB, 0.25997665E-09_JPRB, &
  & 0.25965918E-09_JPRB, 0.25933122E-09_JPRB, 0.25900102E-09_JPRB, 0.25868002E-09_JPRB, 0.25837543E-09_JPRB, 0.25809396E-09_JPRB, &
  & 0.25783181E-09_JPRB, 0.25755970E-09_JPRB, 0.25723140E-09_JPRB, 0.25676600E-09_JPRB, 0.25605745E-09_JPRB, 0.25498120E-09_JPRB, &
  & 0.25339958E-09_JPRB, 0.25131572E-09_JPRB, 0.24898456E-09_JPRB, 0.24674673E-09_JPRB, 0.24486144E-09_JPRB, 0.24323771E-09_JPRB, &
  & 0.24181934E-09_JPRB, 0.24047089E-09_JPRB, 0.23919486E-09_JPRB, 0.23804006E-09_JPRB, 0.23707569E-09_JPRB, 0.23629548E-09_JPRB, &
  & 0.23563462E-09_JPRB, 0.23501143E-09_JPRB, 0.23431412E-09_JPRB, 0.23312247E-09_JPRB /)

RGHG5(:,48, 5) = (/ &
  & 0.22719490E-09_JPRB, 0.22964919E-09_JPRB, 0.23144298E-09_JPRB, 0.23338148E-09_JPRB, 0.23585342E-09_JPRB, 0.23810220E-09_JPRB, &
  & 0.23971561E-09_JPRB, 0.24081448E-09_JPRB, 0.24164282E-09_JPRB, 0.24237606E-09_JPRB, 0.24313668E-09_JPRB, 0.24406271E-09_JPRB, &
  & 0.24526178E-09_JPRB, 0.24683436E-09_JPRB, 0.24867247E-09_JPRB, 0.25058999E-09_JPRB, 0.25238461E-09_JPRB, 0.25398086E-09_JPRB, &
  & 0.25536759E-09_JPRB, 0.25659927E-09_JPRB, 0.25769617E-09_JPRB, 0.25861549E-09_JPRB, 0.25933530E-09_JPRB, 0.25985900E-09_JPRB, &
  & 0.26023311E-09_JPRB, 0.26050495E-09_JPRB, 0.26070873E-09_JPRB, 0.26086283E-09_JPRB, 0.26097319E-09_JPRB, 0.26103691E-09_JPRB, &
  & 0.26104627E-09_JPRB, 0.26099295E-09_JPRB, 0.26087449E-09_JPRB, 0.26068658E-09_JPRB, 0.26044814E-09_JPRB, 0.26016916E-09_JPRB, &
  & 0.25985900E-09_JPRB, 0.25953972E-09_JPRB, 0.25922653E-09_JPRB, 0.25893124E-09_JPRB, 0.25866798E-09_JPRB, 0.25844429E-09_JPRB, &
  & 0.25825536E-09_JPRB, 0.25808250E-09_JPRB, 0.25788083E-09_JPRB, 0.25759600E-09_JPRB, 0.25715402E-09_JPRB, 0.25645347E-09_JPRB, &
  & 0.25537336E-09_JPRB, 0.25384744E-09_JPRB, 0.25198904E-09_JPRB, 0.25014743E-09_JPRB, 0.24851743E-09_JPRB, 0.24713162E-09_JPRB, &
  & 0.24587093E-09_JPRB, 0.24468044E-09_JPRB, 0.24352803E-09_JPRB, 0.24248575E-09_JPRB, 0.24161867E-09_JPRB, 0.24092095E-09_JPRB, &
  & 0.24033092E-09_JPRB, 0.23977312E-09_JPRB, 0.23914473E-09_JPRB, 0.23806557E-09_JPRB /)

RGHG5(:,49, 5) = (/ &
  & 0.23270109E-09_JPRB, 0.23508648E-09_JPRB, 0.23674696E-09_JPRB, 0.23870253E-09_JPRB, 0.24106689E-09_JPRB, 0.24326496E-09_JPRB, &
  & 0.24478225E-09_JPRB, 0.24577929E-09_JPRB, 0.24649616E-09_JPRB, 0.24710983E-09_JPRB, 0.24772412E-09_JPRB, 0.24846439E-09_JPRB, &
  & 0.24943042E-09_JPRB, 0.25067112E-09_JPRB, 0.25210034E-09_JPRB, 0.25347507E-09_JPRB, 0.25469199E-09_JPRB, 0.25569871E-09_JPRB, &
  & 0.25658936E-09_JPRB, 0.25740568E-09_JPRB, 0.25820374E-09_JPRB, 0.25893873E-09_JPRB, 0.25955310E-09_JPRB, 0.26002489E-09_JPRB, &
  & 0.26037214E-09_JPRB, 0.26063032E-09_JPRB, 0.26082830E-09_JPRB, 0.26098185E-09_JPRB, 0.26109531E-09_JPRB, 0.26116490E-09_JPRB, &
  & 0.26118183E-09_JPRB, 0.26113783E-09_JPRB, 0.26102795E-09_JPRB, 0.26085015E-09_JPRB, 0.26061908E-09_JPRB, 0.26034466E-09_JPRB, &
  & 0.26003988E-09_JPRB, 0.25972829E-09_JPRB, 0.25942684E-09_JPRB, 0.25915239E-09_JPRB, 0.25891989E-09_JPRB, 0.25873828E-09_JPRB, &
  & 0.25860508E-09_JPRB, 0.25849584E-09_JPRB, 0.25837874E-09_JPRB, 0.25820796E-09_JPRB, 0.25793939E-09_JPRB, 0.25750549E-09_JPRB, &
  & 0.25682867E-09_JPRB, 0.25582997E-09_JPRB, 0.25457383E-09_JPRB, 0.25324556E-09_JPRB, 0.25199390E-09_JPRB, 0.25089048E-09_JPRB, &
  & 0.24983801E-09_JPRB, 0.24880439E-09_JPRB, 0.24778224E-09_JPRB, 0.24684602E-09_JPRB, 0.24606725E-09_JPRB, 0.24544455E-09_JPRB, &
  & 0.24491584E-09_JPRB, 0.24441574E-09_JPRB, 0.24384317E-09_JPRB, 0.24285540E-09_JPRB /)

RGHG5(:,50, 5) = (/ &
  & 0.23783830E-09_JPRB, 0.24026386E-09_JPRB, 0.24184671E-09_JPRB, 0.24380029E-09_JPRB, 0.24607874E-09_JPRB, 0.24815167E-09_JPRB, &
  & 0.24951891E-09_JPRB, 0.25036337E-09_JPRB, 0.25095209E-09_JPRB, 0.25141106E-09_JPRB, 0.25188110E-09_JPRB, 0.25239599E-09_JPRB, &
  & 0.25307711E-09_JPRB, 0.25391866E-09_JPRB, 0.25482294E-09_JPRB, 0.25567468E-09_JPRB, 0.25637448E-09_JPRB, 0.25697444E-09_JPRB, &
  & 0.25749841E-09_JPRB, 0.25804459E-09_JPRB, 0.25860802E-09_JPRB, 0.25919422E-09_JPRB, 0.25972891E-09_JPRB, 0.26016225E-09_JPRB, &
  & 0.26049199E-09_JPRB, 0.26074187E-09_JPRB, 0.26093683E-09_JPRB, 0.26109068E-09_JPRB, 0.26120756E-09_JPRB, 0.26128277E-09_JPRB, &
  & 0.26130725E-09_JPRB, 0.26127173E-09_JPRB, 0.26116997E-09_JPRB, 0.26100133E-09_JPRB, 0.26077618E-09_JPRB, 0.26050623E-09_JPRB, &
  & 0.26020641E-09_JPRB, 0.25990071E-09_JPRB, 0.25960867E-09_JPRB, 0.25934910E-09_JPRB, 0.25913999E-09_JPRB, 0.25899208E-09_JPRB, &
  & 0.25889757E-09_JPRB, 0.25883479E-09_JPRB, 0.25876853E-09_JPRB, 0.25867014E-09_JPRB, 0.25850522E-09_JPRB, 0.25824215E-09_JPRB, &
  & 0.25782734E-09_JPRB, 0.25723759E-09_JPRB, 0.25649383E-09_JPRB, 0.25567554E-09_JPRB, 0.25491953E-09_JPRB, 0.25414834E-09_JPRB, &
  & 0.25340588E-09_JPRB, 0.25260274E-09_JPRB, 0.25177196E-09_JPRB, 0.25097469E-09_JPRB, 0.25030969E-09_JPRB, 0.24976465E-09_JPRB, &
  & 0.24930663E-09_JPRB, 0.24885410E-09_JPRB, 0.24834146E-09_JPRB, 0.24741051E-09_JPRB /)

RGHG5(:,51, 5) = (/ &
  & 0.24273678E-09_JPRB, 0.24490146E-09_JPRB, 0.24665467E-09_JPRB, 0.24835797E-09_JPRB, 0.25051378E-09_JPRB, 0.25223812E-09_JPRB, &
  & 0.25329938E-09_JPRB, 0.25392022E-09_JPRB, 0.25431002E-09_JPRB, 0.25463065E-09_JPRB, 0.25490429E-09_JPRB, 0.25523983E-09_JPRB, &
  & 0.25562599E-09_JPRB, 0.25611116E-09_JPRB, 0.25663069E-09_JPRB, 0.25709757E-09_JPRB, 0.25750205E-09_JPRB, 0.25784033E-09_JPRB, &
  & 0.25817787E-09_JPRB, 0.25852176E-09_JPRB, 0.25893873E-09_JPRB, 0.25940083E-09_JPRB, 0.25986904E-09_JPRB, 0.26027730E-09_JPRB, &
  & 0.26059724E-09_JPRB, 0.26084340E-09_JPRB, 0.26103719E-09_JPRB, 0.26119207E-09_JPRB, 0.26131203E-09_JPRB, 0.26139241E-09_JPRB, &
  & 0.26142383E-09_JPRB, 0.26139613E-09_JPRB, 0.26130248E-09_JPRB, 0.26114150E-09_JPRB, 0.26092234E-09_JPRB, 0.26065633E-09_JPRB, &
  & 0.26036134E-09_JPRB, 0.26006072E-09_JPRB, 0.25977537E-09_JPRB, 0.25952712E-09_JPRB, 0.25933700E-09_JPRB, 0.25921468E-09_JPRB, &
  & 0.25915206E-09_JPRB, 0.25911948E-09_JPRB, 0.25908797E-09_JPRB, 0.25903069E-09_JPRB, 0.25893149E-09_JPRB, 0.25876445E-09_JPRB, &
  & 0.25851654E-09_JPRB, 0.25817123E-09_JPRB, 0.25775831E-09_JPRB, 0.25734745E-09_JPRB, 0.25692171E-09_JPRB, 0.25653552E-09_JPRB, &
  & 0.25610136E-09_JPRB, 0.25562705E-09_JPRB, 0.25507854E-09_JPRB, 0.25452696E-09_JPRB, 0.25402522E-09_JPRB, 0.25361790E-09_JPRB, &
  & 0.25324198E-09_JPRB, 0.25288174E-09_JPRB, 0.25241526E-09_JPRB, 0.25160160E-09_JPRB /)

RGHG5(:,52, 5) = (/ &
  & 0.24683677E-09_JPRB, 0.24922453E-09_JPRB, 0.25051475E-09_JPRB, 0.25221944E-09_JPRB, 0.25382280E-09_JPRB, 0.25510860E-09_JPRB, &
  & 0.25580632E-09_JPRB, 0.25618427E-09_JPRB, 0.25642993E-09_JPRB, 0.25660052E-09_JPRB, 0.25677629E-09_JPRB, 0.25694416E-09_JPRB, &
  & 0.25717145E-09_JPRB, 0.25743682E-09_JPRB, 0.25772584E-09_JPRB, 0.25799907E-09_JPRB, 0.25823232E-09_JPRB, 0.25845059E-09_JPRB, &
  & 0.25865785E-09_JPRB, 0.25890806E-09_JPRB, 0.25920183E-09_JPRB, 0.25957411E-09_JPRB, 0.25998903E-09_JPRB, 0.26037539E-09_JPRB, &
  & 0.26069188E-09_JPRB, 0.26093752E-09_JPRB, 0.26113164E-09_JPRB, 0.26128766E-09_JPRB, 0.26141020E-09_JPRB, 0.26149494E-09_JPRB, &
  & 0.26153266E-09_JPRB, 0.26151226E-09_JPRB, 0.26142608E-09_JPRB, 0.26127239E-09_JPRB, 0.26105854E-09_JPRB, 0.26079730E-09_JPRB, &
  & 0.26050664E-09_JPRB, 0.26021008E-09_JPRB, 0.25993005E-09_JPRB, 0.25969121E-09_JPRB, 0.25951635E-09_JPRB, 0.25941677E-09_JPRB, &
  & 0.25937730E-09_JPRB, 0.25936758E-09_JPRB, 0.25935742E-09_JPRB, 0.25932795E-09_JPRB, 0.25926433E-09_JPRB, 0.25915947E-09_JPRB, &
  & 0.25900063E-09_JPRB, 0.25879937E-09_JPRB, 0.25858093E-09_JPRB, 0.25836039E-09_JPRB, 0.25817659E-09_JPRB, 0.25798391E-09_JPRB, &
  & 0.25779537E-09_JPRB, 0.25756716E-09_JPRB, 0.25729721E-09_JPRB, 0.25699284E-09_JPRB, 0.25671693E-09_JPRB, 0.25646002E-09_JPRB, &
  & 0.25623512E-09_JPRB, 0.25597549E-09_JPRB, 0.25566377E-09_JPRB, 0.25497374E-09_JPRB /)

RGHG5(:,53, 5) = (/ &
  & 0.25054206E-09_JPRB, 0.25230812E-09_JPRB, 0.25371061E-09_JPRB, 0.25481550E-09_JPRB, 0.25607882E-09_JPRB, 0.25688709E-09_JPRB, &
  & 0.25731647E-09_JPRB, 0.25754060E-09_JPRB, 0.25767388E-09_JPRB, 0.25778218E-09_JPRB, 0.25786878E-09_JPRB, 0.25797667E-09_JPRB, &
  & 0.25809485E-09_JPRB, 0.25825156E-09_JPRB, 0.25842356E-09_JPRB, 0.25858776E-09_JPRB, 0.25874011E-09_JPRB, 0.25887864E-09_JPRB, &
  & 0.25903166E-09_JPRB, 0.25920135E-09_JPRB, 0.25943175E-09_JPRB, 0.25973132E-09_JPRB, 0.26009292E-09_JPRB, 0.26046609E-09_JPRB, &
  & 0.26077923E-09_JPRB, 0.26102601E-09_JPRB, 0.26122121E-09_JPRB, 0.26137836E-09_JPRB, 0.26150312E-09_JPRB, 0.26159144E-09_JPRB, &
  & 0.26163460E-09_JPRB, 0.26162064E-09_JPRB, 0.26154140E-09_JPRB, 0.26139446E-09_JPRB, 0.26118660E-09_JPRB, 0.26092986E-09_JPRB, &
  & 0.26064326E-09_JPRB, 0.26035027E-09_JPRB, 0.26007529E-09_JPRB, 0.25984501E-09_JPRB, 0.25968444E-09_JPRB, 0.25960256E-09_JPRB, &
  & 0.25958219E-09_JPRB, 0.25958891E-09_JPRB, 0.25959418E-09_JPRB, 0.25958122E-09_JPRB, 0.25954228E-09_JPRB, 0.25946920E-09_JPRB, &
  & 0.25936697E-09_JPRB, 0.25924252E-09_JPRB, 0.25911590E-09_JPRB, 0.25901142E-09_JPRB, 0.25891483E-09_JPRB, 0.25883554E-09_JPRB, &
  & 0.25875047E-09_JPRB, 0.25865277E-09_JPRB, 0.25853045E-09_JPRB, 0.25839322E-09_JPRB, 0.25825303E-09_JPRB, 0.25813535E-09_JPRB, &
  & 0.25801319E-09_JPRB, 0.25789126E-09_JPRB, 0.25770330E-09_JPRB, 0.25731395E-09_JPRB /)

RGHG5(:,54, 5) = (/ &
  & 0.25328573E-09_JPRB, 0.25492974E-09_JPRB, 0.25572150E-09_JPRB, 0.25667291E-09_JPRB, 0.25745669E-09_JPRB, 0.25798963E-09_JPRB, &
  & 0.25824171E-09_JPRB, 0.25837255E-09_JPRB, 0.25845434E-09_JPRB, 0.25851138E-09_JPRB, 0.25856947E-09_JPRB, 0.25862457E-09_JPRB, &
  & 0.25870089E-09_JPRB, 0.25879282E-09_JPRB, 0.25890021E-09_JPRB, 0.25900790E-09_JPRB, 0.25910787E-09_JPRB, 0.25920965E-09_JPRB, &
  & 0.25931529E-09_JPRB, 0.25945163E-09_JPRB, 0.25962787E-09_JPRB, 0.25987495E-09_JPRB, 0.26020300E-09_JPRB, 0.26055111E-09_JPRB, &
  & 0.26086291E-09_JPRB, 0.26110980E-09_JPRB, 0.26130595E-09_JPRB, 0.26146477E-09_JPRB, 0.26159130E-09_JPRB, 0.26168284E-09_JPRB, &
  & 0.26173028E-09_JPRB, 0.26172170E-09_JPRB, 0.26164873E-09_JPRB, 0.26150854E-09_JPRB, 0.26130681E-09_JPRB, 0.26105532E-09_JPRB, &
  & 0.26077235E-09_JPRB, 0.26048305E-09_JPRB, 0.26021305E-09_JPRB, 0.25999197E-09_JPRB, 0.25984437E-09_JPRB, 0.25977781E-09_JPRB, &
  & 0.25977132E-09_JPRB, 0.25979033E-09_JPRB, 0.25980734E-09_JPRB, 0.25980662E-09_JPRB, 0.25978109E-09_JPRB, 0.25973029E-09_JPRB, &
  & 0.25965613E-09_JPRB, 0.25957414E-09_JPRB, 0.25950042E-09_JPRB, 0.25943808E-09_JPRB, 0.25939359E-09_JPRB, 0.25935365E-09_JPRB, &
  & 0.25931574E-09_JPRB, 0.25927155E-09_JPRB, 0.25921532E-09_JPRB, 0.25914837E-09_JPRB, 0.25908697E-09_JPRB, 0.25902880E-09_JPRB, &
  & 0.25898067E-09_JPRB, 0.25892799E-09_JPRB, 0.25887695E-09_JPRB, 0.25880434E-09_JPRB /)

RGHG5(:,55, 5) = (/ &
  & 0.25530417E-09_JPRB, 0.25648997E-09_JPRB, 0.25724434E-09_JPRB, 0.25781544E-09_JPRB, 0.25836722E-09_JPRB, 0.25869137E-09_JPRB, &
  & 0.25884989E-09_JPRB, 0.25892888E-09_JPRB, 0.25897645E-09_JPRB, 0.25901425E-09_JPRB, 0.25904570E-09_JPRB, 0.25908392E-09_JPRB, &
  & 0.25912728E-09_JPRB, 0.25918692E-09_JPRB, 0.25925656E-09_JPRB, 0.25932795E-09_JPRB, 0.25939903E-09_JPRB, 0.25947036E-09_JPRB, &
  & 0.25955471E-09_JPRB, 0.25965805E-09_JPRB, 0.25980573E-09_JPRB, 0.26002134E-09_JPRB, 0.26030769E-09_JPRB, 0.26064320E-09_JPRB, &
  & 0.26094418E-09_JPRB, 0.26119004E-09_JPRB, 0.26138683E-09_JPRB, 0.26154717E-09_JPRB, 0.26167579E-09_JPRB, 0.26176974E-09_JPRB, &
  & 0.26182029E-09_JPRB, 0.26181601E-09_JPRB, 0.26174862E-09_JPRB, 0.26161520E-09_JPRB, 0.26142022E-09_JPRB, 0.26117400E-09_JPRB, &
  & 0.26089567E-09_JPRB, 0.26060995E-09_JPRB, 0.26034597E-09_JPRB, 0.26013441E-09_JPRB, 0.25999916E-09_JPRB, 0.25994462E-09_JPRB, &
  & 0.25994876E-09_JPRB, 0.25997746E-09_JPRB, 0.26000324E-09_JPRB, 0.26001146E-09_JPRB, 0.25999608E-09_JPRB, 0.25995606E-09_JPRB, &
  & 0.25990024E-09_JPRB, 0.25984070E-09_JPRB, 0.25978941E-09_JPRB, 0.25975391E-09_JPRB, 0.25972649E-09_JPRB, 0.25970603E-09_JPRB, &
  & 0.25968608E-09_JPRB, 0.25966282E-09_JPRB, 0.25963331E-09_JPRB, 0.25959973E-09_JPRB, 0.25956498E-09_JPRB, 0.25953684E-09_JPRB, &
  & 0.25950847E-09_JPRB, 0.25948116E-09_JPRB, 0.25944200E-09_JPRB, 0.25937108E-09_JPRB /)

RGHG5(:,56, 5) = (/ &
  & 0.25705282E-09_JPRB, 0.25781721E-09_JPRB, 0.25821820E-09_JPRB, 0.25862365E-09_JPRB, 0.25897395E-09_JPRB, 0.25918329E-09_JPRB, &
  & 0.25928101E-09_JPRB, 0.25933111E-09_JPRB, 0.25936212E-09_JPRB, 0.25938465E-09_JPRB, 0.25940686E-09_JPRB, 0.25942903E-09_JPRB, &
  & 0.25945890E-09_JPRB, 0.25949659E-09_JPRB, 0.25954272E-09_JPRB, 0.25959171E-09_JPRB, 0.25964070E-09_JPRB, 0.25969432E-09_JPRB, &
  & 0.25975716E-09_JPRB, 0.25984415E-09_JPRB, 0.25997032E-09_JPRB, 0.26015720E-09_JPRB, 0.26042793E-09_JPRB, 0.26073521E-09_JPRB, &
  & 0.26102676E-09_JPRB, 0.26126809E-09_JPRB, 0.26146518E-09_JPRB, 0.26162703E-09_JPRB, 0.26175748E-09_JPRB, 0.26185326E-09_JPRB, &
  & 0.26190566E-09_JPRB, 0.26190455E-09_JPRB, 0.26184205E-09_JPRB, 0.26171507E-09_JPRB, 0.26152711E-09_JPRB, 0.26128710E-09_JPRB, &
  & 0.26101341E-09_JPRB, 0.26073291E-09_JPRB, 0.26047567E-09_JPRB, 0.26027425E-09_JPRB, 0.26015054E-09_JPRB, 0.26010588E-09_JPRB, &
  & 0.26011773E-09_JPRB, 0.26015329E-09_JPRB, 0.26018646E-09_JPRB, 0.26020158E-09_JPRB, 0.26019292E-09_JPRB, 0.26016106E-09_JPRB, &
  & 0.26011399E-09_JPRB, 0.26006580E-09_JPRB, 0.26002828E-09_JPRB, 0.26000113E-09_JPRB, 0.25998365E-09_JPRB, 0.25996968E-09_JPRB, &
  & 0.25995681E-09_JPRB, 0.25994240E-09_JPRB, 0.25992428E-09_JPRB, 0.25990268E-09_JPRB, 0.25988289E-09_JPRB, 0.25986485E-09_JPRB, &
  & 0.25984948E-09_JPRB, 0.25983285E-09_JPRB, 0.25981545E-09_JPRB, 0.25978536E-09_JPRB /)

RGHG5(:,57, 5) = (/ &
  & 0.25809796E-09_JPRB, 0.25862995E-09_JPRB, 0.25892469E-09_JPRB, 0.25918967E-09_JPRB, 0.25940763E-09_JPRB, 0.25954638E-09_JPRB, &
  & 0.25961167E-09_JPRB, 0.25964494E-09_JPRB, 0.25966518E-09_JPRB, 0.25968128E-09_JPRB, 0.25969540E-09_JPRB, 0.25971170E-09_JPRB, &
  & 0.25973096E-09_JPRB, 0.25975666E-09_JPRB, 0.25978783E-09_JPRB, 0.25982097E-09_JPRB, 0.25985505E-09_JPRB, 0.25989250E-09_JPRB, &
  & 0.25994171E-09_JPRB, 0.26001262E-09_JPRB, 0.26012337E-09_JPRB, 0.26029934E-09_JPRB, 0.26054353E-09_JPRB, 0.26083530E-09_JPRB, &
  & 0.26111077E-09_JPRB, 0.26134681E-09_JPRB, 0.26154279E-09_JPRB, 0.26170602E-09_JPRB, 0.26183763E-09_JPRB, 0.26193439E-09_JPRB, &
  & 0.26198785E-09_JPRB, 0.26198865E-09_JPRB, 0.26193009E-09_JPRB, 0.26180919E-09_JPRB, 0.26162814E-09_JPRB, 0.26139504E-09_JPRB, &
  & 0.26112745E-09_JPRB, 0.26085289E-09_JPRB, 0.26060415E-09_JPRB, 0.26041314E-09_JPRB, 0.26029964E-09_JPRB, 0.26026309E-09_JPRB, &
  & 0.26028057E-09_JPRB, 0.26032107E-09_JPRB, 0.26035943E-09_JPRB, 0.26038005E-09_JPRB, 0.26037700E-09_JPRB, 0.26035038E-09_JPRB, &
  & 0.26030914E-09_JPRB, 0.26026678E-09_JPRB, 0.26023306E-09_JPRB, 0.26021146E-09_JPRB, 0.26019609E-09_JPRB, 0.26018471E-09_JPRB, &
  & 0.26017410E-09_JPRB, 0.26016217E-09_JPRB, 0.26014757E-09_JPRB, 0.26013139E-09_JPRB, 0.26011543E-09_JPRB, 0.26010233E-09_JPRB, &
  & 0.26008956E-09_JPRB, 0.26007685E-09_JPRB, 0.26005892E-09_JPRB, 0.26002706E-09_JPRB /)

RGHG5(:,58, 5) = (/ &
  & 0.25895450E-09_JPRB, 0.25925984E-09_JPRB, 0.25943747E-09_JPRB, 0.25959512E-09_JPRB, 0.25974725E-09_JPRB, 0.25983565E-09_JPRB, &
  & 0.25988101E-09_JPRB, 0.25990410E-09_JPRB, 0.25991903E-09_JPRB, 0.25993027E-09_JPRB, 0.25994126E-09_JPRB, 0.25995281E-09_JPRB, &
  & 0.25996733E-09_JPRB, 0.25998573E-09_JPRB, 0.26000757E-09_JPRB, 0.26003044E-09_JPRB, 0.26005270E-09_JPRB, 0.26007788E-09_JPRB, &
  & 0.26011329E-09_JPRB, 0.26017238E-09_JPRB, 0.26027266E-09_JPRB, 0.26043340E-09_JPRB, 0.26066618E-09_JPRB, 0.26093616E-09_JPRB, &
  & 0.26119834E-09_JPRB, 0.26142757E-09_JPRB, 0.26162228E-09_JPRB, 0.26178534E-09_JPRB, 0.26191752E-09_JPRB, 0.26201419E-09_JPRB, &
  & 0.26206781E-09_JPRB, 0.26206973E-09_JPRB, 0.26201419E-09_JPRB, 0.26189836E-09_JPRB, 0.26172431E-09_JPRB, 0.26149874E-09_JPRB, &
  & 0.26123873E-09_JPRB, 0.26097233E-09_JPRB, 0.26073271E-09_JPRB, 0.26055183E-09_JPRB, 0.26044752E-09_JPRB, 0.26041738E-09_JPRB, &
  & 0.26043898E-09_JPRB, 0.26048272E-09_JPRB, 0.26052452E-09_JPRB, 0.26054936E-09_JPRB, 0.26055091E-09_JPRB, 0.26052951E-09_JPRB, &
  & 0.26049213E-09_JPRB, 0.26045185E-09_JPRB, 0.26042013E-09_JPRB, 0.26039770E-09_JPRB, 0.26038280E-09_JPRB, 0.26037100E-09_JPRB, &
  & 0.26035990E-09_JPRB, 0.26034785E-09_JPRB, 0.26033359E-09_JPRB, 0.26031766E-09_JPRB, 0.26030322E-09_JPRB, 0.26029051E-09_JPRB, &
  & 0.26027908E-09_JPRB, 0.26026648E-09_JPRB, 0.26025135E-09_JPRB, 0.26022054E-09_JPRB /)

RGHG5(:,59, 5) = (/ &
  & 0.25948754E-09_JPRB, 0.25969560E-09_JPRB, 0.25981078E-09_JPRB, 0.25992142E-09_JPRB, 0.26001262E-09_JPRB, 0.26007835E-09_JPRB, &
  & 0.26011049E-09_JPRB, 0.26012845E-09_JPRB, 0.26013969E-09_JPRB, 0.26014904E-09_JPRB, 0.26015773E-09_JPRB, 0.26016767E-09_JPRB, &
  & 0.26017960E-09_JPRB, 0.26019434E-09_JPRB, 0.26021146E-09_JPRB, 0.26022756E-09_JPRB, 0.26024125E-09_JPRB, 0.26025521E-09_JPRB, &
  & 0.26027897E-09_JPRB, 0.26032654E-09_JPRB, 0.26041677E-09_JPRB, 0.26056912E-09_JPRB, 0.26078573E-09_JPRB, 0.26103975E-09_JPRB, &
  & 0.26128896E-09_JPRB, 0.26151192E-09_JPRB, 0.26170394E-09_JPRB, 0.26186631E-09_JPRB, 0.26199751E-09_JPRB, 0.26209326E-09_JPRB, &
  & 0.26214630E-09_JPRB, 0.26214855E-09_JPRB, 0.26209515E-09_JPRB, 0.26198385E-09_JPRB, 0.26181618E-09_JPRB, 0.26159902E-09_JPRB, &
  & 0.26134819E-09_JPRB, 0.26109120E-09_JPRB, 0.26086253E-09_JPRB, 0.26069111E-09_JPRB, 0.26059457E-09_JPRB, 0.26056951E-09_JPRB, &
  & 0.26059394E-09_JPRB, 0.26063968E-09_JPRB, 0.26068372E-09_JPRB, 0.26071145E-09_JPRB, 0.26071695E-09_JPRB, 0.26070024E-09_JPRB, &
  & 0.26066721E-09_JPRB, 0.26062827E-09_JPRB, 0.26059488E-09_JPRB, 0.26057123E-09_JPRB, 0.26055400E-09_JPRB, 0.26054015E-09_JPRB, &
  & 0.26052738E-09_JPRB, 0.26051322E-09_JPRB, 0.26049704E-09_JPRB, 0.26047986E-09_JPRB, 0.26046387E-09_JPRB, 0.26045049E-09_JPRB, &
  & 0.26043795E-09_JPRB, 0.26042515E-09_JPRB, 0.26040758E-09_JPRB, 0.26037597E-09_JPRB /)

RGHG5(:,60, 5) = (/ &
  & 0.25990610E-09_JPRB, 0.26003305E-09_JPRB, 0.26010794E-09_JPRB, 0.26017560E-09_JPRB, 0.26024341E-09_JPRB, 0.26028818E-09_JPRB, &
  & 0.26031427E-09_JPRB, 0.26032843E-09_JPRB, 0.26033853E-09_JPRB, 0.26034663E-09_JPRB, 0.26035496E-09_JPRB, 0.26036420E-09_JPRB, &
  & 0.26037555E-09_JPRB, 0.26038960E-09_JPRB, 0.26040459E-09_JPRB, 0.26041724E-09_JPRB, 0.26042427E-09_JPRB, 0.26042854E-09_JPRB, &
  & 0.26044100E-09_JPRB, 0.26047847E-09_JPRB, 0.26055968E-09_JPRB, 0.26070171E-09_JPRB, 0.26090538E-09_JPRB, 0.26114447E-09_JPRB, &
  & 0.26138264E-09_JPRB, 0.26159913E-09_JPRB, 0.26178820E-09_JPRB, 0.26194838E-09_JPRB, 0.26207767E-09_JPRB, 0.26217145E-09_JPRB, &
  & 0.26222313E-09_JPRB, 0.26222519E-09_JPRB, 0.26217351E-09_JPRB, 0.26206629E-09_JPRB, 0.26190491E-09_JPRB, 0.26169680E-09_JPRB, &
  & 0.26145602E-09_JPRB, 0.26121116E-09_JPRB, 0.26099289E-09_JPRB, 0.26083138E-09_JPRB, 0.26074157E-09_JPRB, 0.26072028E-09_JPRB, &
  & 0.26074629E-09_JPRB, 0.26079303E-09_JPRB, 0.26083830E-09_JPRB, 0.26086819E-09_JPRB, 0.26087688E-09_JPRB, 0.26086461E-09_JPRB, &
  & 0.26083571E-09_JPRB, 0.26079910E-09_JPRB, 0.26076410E-09_JPRB, 0.26073693E-09_JPRB, 0.26071617E-09_JPRB, 0.26069935E-09_JPRB, &
  & 0.26068295E-09_JPRB, 0.26066577E-09_JPRB, 0.26064620E-09_JPRB, 0.26062580E-09_JPRB, 0.26060759E-09_JPRB, 0.26059213E-09_JPRB, &
  & 0.26057800E-09_JPRB, 0.26056282E-09_JPRB, 0.26054450E-09_JPRB, 0.26050795E-09_JPRB /)

RGHG5(:,61, 5) = (/ &
  & 0.26019609E-09_JPRB, 0.26029004E-09_JPRB, 0.26034369E-09_JPRB, 0.26039410E-09_JPRB, 0.26044061E-09_JPRB, 0.26047758E-09_JPRB, &
  & 0.26049862E-09_JPRB, 0.26051192E-09_JPRB, 0.26052113E-09_JPRB, 0.26052954E-09_JPRB, 0.26053798E-09_JPRB, 0.26054800E-09_JPRB, &
  & 0.26056049E-09_JPRB, 0.26057545E-09_JPRB, 0.26059105E-09_JPRB, 0.26060193E-09_JPRB, 0.26060379E-09_JPRB, 0.26059929E-09_JPRB, &
  & 0.26060168E-09_JPRB, 0.26062943E-09_JPRB, 0.26070174E-09_JPRB, 0.26083366E-09_JPRB, 0.26102456E-09_JPRB, 0.26125063E-09_JPRB, &
  & 0.26147887E-09_JPRB, 0.26168911E-09_JPRB, 0.26187424E-09_JPRB, 0.26203137E-09_JPRB, 0.26215768E-09_JPRB, 0.26224872E-09_JPRB, &
  & 0.26229829E-09_JPRB, 0.26229977E-09_JPRB, 0.26224958E-09_JPRB, 0.26214650E-09_JPRB, 0.26199165E-09_JPRB, 0.26179314E-09_JPRB, &
  & 0.26156408E-09_JPRB, 0.26133132E-09_JPRB, 0.26112495E-09_JPRB, 0.26097272E-09_JPRB, 0.26088912E-09_JPRB, 0.26087049E-09_JPRB, &
  & 0.26089703E-09_JPRB, 0.26094366E-09_JPRB, 0.26098945E-09_JPRB, 0.26102082E-09_JPRB, 0.26103222E-09_JPRB, 0.26102370E-09_JPRB, &
  & 0.26099944E-09_JPRB, 0.26096547E-09_JPRB, 0.26093033E-09_JPRB, 0.26089936E-09_JPRB, 0.26087454E-09_JPRB, 0.26085284E-09_JPRB, &
  & 0.26083252E-09_JPRB, 0.26081054E-09_JPRB, 0.26078653E-09_JPRB, 0.26076230E-09_JPRB, 0.26074073E-09_JPRB, 0.26072228E-09_JPRB, &
  & 0.26070529E-09_JPRB, 0.26068767E-09_JPRB, 0.26066407E-09_JPRB, 0.26062202E-09_JPRB /)

RGHG5(:,62, 5) = (/ &
  & 0.26043495E-09_JPRB, 0.26050567E-09_JPRB, 0.26054564E-09_JPRB, 0.26058269E-09_JPRB, 0.26062047E-09_JPRB, 0.26065031E-09_JPRB, &
  & 0.26067024E-09_JPRB, 0.26068275E-09_JPRB, 0.26069272E-09_JPRB, 0.26070160E-09_JPRB, 0.26071151E-09_JPRB, 0.26072328E-09_JPRB, &
  & 0.26073815E-09_JPRB, 0.26075606E-09_JPRB, 0.26077346E-09_JPRB, 0.26078353E-09_JPRB, 0.26078062E-09_JPRB, 0.26076830E-09_JPRB, &
  & 0.26076175E-09_JPRB, 0.26078067E-09_JPRB, 0.26084396E-09_JPRB, 0.26096589E-09_JPRB, 0.26114463E-09_JPRB, 0.26135871E-09_JPRB, &
  & 0.26157729E-09_JPRB, 0.26178129E-09_JPRB, 0.26196167E-09_JPRB, 0.26211491E-09_JPRB, 0.26223743E-09_JPRB, 0.26232513E-09_JPRB, &
  & 0.26237204E-09_JPRB, 0.26237257E-09_JPRB, 0.26232394E-09_JPRB, 0.26222519E-09_JPRB, 0.26207767E-09_JPRB, 0.26188907E-09_JPRB, &
  & 0.26167246E-09_JPRB, 0.26145297E-09_JPRB, 0.26125824E-09_JPRB, 0.26111549E-09_JPRB, 0.26103755E-09_JPRB, 0.26102076E-09_JPRB, &
  & 0.26104685E-09_JPRB, 0.26109262E-09_JPRB, 0.26113811E-09_JPRB, 0.26117045E-09_JPRB, 0.26118399E-09_JPRB, 0.26117877E-09_JPRB, &
  & 0.26115823E-09_JPRB, 0.26112812E-09_JPRB, 0.26109365E-09_JPRB, 0.26106056E-09_JPRB, 0.26103097E-09_JPRB, 0.26100444E-09_JPRB, &
  & 0.26097860E-09_JPRB, 0.26095109E-09_JPRB, 0.26092228E-09_JPRB, 0.26089314E-09_JPRB, 0.26086769E-09_JPRB, 0.26084590E-09_JPRB, &
  & 0.26082539E-09_JPRB, 0.26080302E-09_JPRB, 0.26077540E-09_JPRB, 0.26072000E-09_JPRB /)

RGHG5(:,63, 5) = (/ &
  & 0.26063504E-09_JPRB, 0.26069080E-09_JPRB, 0.26072308E-09_JPRB, 0.26075342E-09_JPRB, 0.26078437E-09_JPRB, 0.26081182E-09_JPRB, &
  & 0.26083058E-09_JPRB, 0.26084429E-09_JPRB, 0.26085498E-09_JPRB, 0.26086583E-09_JPRB, 0.26087765E-09_JPRB, 0.26089267E-09_JPRB, &
  & 0.26091168E-09_JPRB, 0.26093380E-09_JPRB, 0.26095387E-09_JPRB, 0.26096286E-09_JPRB, 0.26095509E-09_JPRB, 0.26093594E-09_JPRB, &
  & 0.26092173E-09_JPRB, 0.26093247E-09_JPRB, 0.26098723E-09_JPRB, 0.26109914E-09_JPRB, 0.26126676E-09_JPRB, 0.26146893E-09_JPRB, &
  & 0.26167843E-09_JPRB, 0.26187524E-09_JPRB, 0.26205027E-09_JPRB, 0.26219851E-09_JPRB, 0.26231645E-09_JPRB, 0.26239996E-09_JPRB, &
  & 0.26244396E-09_JPRB, 0.26244351E-09_JPRB, 0.26239655E-09_JPRB, 0.26230279E-09_JPRB, 0.26216351E-09_JPRB, 0.26198557E-09_JPRB, &
  & 0.26178226E-09_JPRB, 0.26157612E-09_JPRB, 0.26139371E-09_JPRB, 0.26126007E-09_JPRB, 0.26118743E-09_JPRB, 0.26117189E-09_JPRB, &
  & 0.26119665E-09_JPRB, 0.26124045E-09_JPRB, 0.26128494E-09_JPRB, 0.26131758E-09_JPRB, 0.26133279E-09_JPRB, 0.26133035E-09_JPRB, &
  & 0.26131330E-09_JPRB, 0.26128627E-09_JPRB, 0.26125396E-09_JPRB, 0.26122010E-09_JPRB, 0.26118666E-09_JPRB, 0.26115549E-09_JPRB, &
  & 0.26112329E-09_JPRB, 0.26109115E-09_JPRB, 0.26105598E-09_JPRB, 0.26102309E-09_JPRB, 0.26099342E-09_JPRB, 0.26096741E-09_JPRB, &
  & 0.26094271E-09_JPRB, 0.26091601E-09_JPRB, 0.26087899E-09_JPRB, 0.26081162E-09_JPRB /)

RGHG5(:,64, 5) = (/ &
  & 0.26080466E-09_JPRB, 0.26085373E-09_JPRB, 0.26088176E-09_JPRB, 0.26090824E-09_JPRB, 0.26093641E-09_JPRB, 0.26096197E-09_JPRB, &
  & 0.26098199E-09_JPRB, 0.26099639E-09_JPRB, 0.26100963E-09_JPRB, 0.26102240E-09_JPRB, 0.26103802E-09_JPRB, 0.26105734E-09_JPRB, &
  & 0.26108210E-09_JPRB, 0.26110966E-09_JPRB, 0.26113151E-09_JPRB, 0.26113825E-09_JPRB, 0.26112582E-09_JPRB, 0.26110109E-09_JPRB, &
  & 0.26108063E-09_JPRB, 0.26108415E-09_JPRB, 0.26113092E-09_JPRB, 0.26123390E-09_JPRB, 0.26138999E-09_JPRB, 0.26158148E-09_JPRB, &
  & 0.26178079E-09_JPRB, 0.26197020E-09_JPRB, 0.26213853E-09_JPRB, 0.26228075E-09_JPRB, 0.26239294E-09_JPRB, 0.26247163E-09_JPRB, &
  & 0.26251232E-09_JPRB, 0.26251112E-09_JPRB, 0.26246641E-09_JPRB, 0.26237817E-09_JPRB, 0.26224811E-09_JPRB, 0.26208175E-09_JPRB, &
  & 0.26189229E-09_JPRB, 0.26169994E-09_JPRB, 0.26152985E-09_JPRB, 0.26140545E-09_JPRB, 0.26133770E-09_JPRB, 0.26132285E-09_JPRB, &
  & 0.26134547E-09_JPRB, 0.26138652E-09_JPRB, 0.26142916E-09_JPRB, 0.26146138E-09_JPRB, 0.26147781E-09_JPRB, 0.26147762E-09_JPRB, &
  & 0.26146349E-09_JPRB, 0.26143943E-09_JPRB, 0.26140917E-09_JPRB, 0.26137548E-09_JPRB, 0.26134073E-09_JPRB, 0.26130437E-09_JPRB, &
  & 0.26126867E-09_JPRB, 0.26122940E-09_JPRB, 0.26119129E-09_JPRB, 0.26115304E-09_JPRB, 0.26111951E-09_JPRB, 0.26108959E-09_JPRB, &
  & 0.26106053E-09_JPRB, 0.26102720E-09_JPRB, 0.26098410E-09_JPRB, 0.26089514E-09_JPRB /)

RGHG5(:,65, 5) = (/ &
  & 0.26095084E-09_JPRB, 0.26099883E-09_JPRB, 0.26102592E-09_JPRB, 0.26105135E-09_JPRB, 0.26107821E-09_JPRB, 0.26110425E-09_JPRB, &
  & 0.26112473E-09_JPRB, 0.26114211E-09_JPRB, 0.26115696E-09_JPRB, 0.26117397E-09_JPRB, 0.26119334E-09_JPRB, 0.26121930E-09_JPRB, &
  & 0.26125088E-09_JPRB, 0.26128236E-09_JPRB, 0.26130464E-09_JPRB, 0.26130820E-09_JPRB, 0.26129182E-09_JPRB, 0.26126304E-09_JPRB, &
  & 0.26123764E-09_JPRB, 0.26123523E-09_JPRB, 0.26127492E-09_JPRB, 0.26136865E-09_JPRB, 0.26151498E-09_JPRB, 0.26169450E-09_JPRB, &
  & 0.26188424E-09_JPRB, 0.26206434E-09_JPRB, 0.26222505E-09_JPRB, 0.26235969E-09_JPRB, 0.26246524E-09_JPRB, 0.26253832E-09_JPRB, &
  & 0.26257541E-09_JPRB, 0.26257363E-09_JPRB, 0.26253172E-09_JPRB, 0.26244987E-09_JPRB, 0.26232952E-09_JPRB, 0.26217609E-09_JPRB, &
  & 0.26200084E-09_JPRB, 0.26182287E-09_JPRB, 0.26166555E-09_JPRB, 0.26155025E-09_JPRB, 0.26148717E-09_JPRB, 0.26147251E-09_JPRB, &
  & 0.26149252E-09_JPRB, 0.26153021E-09_JPRB, 0.26157027E-09_JPRB, 0.26160141E-09_JPRB, 0.26161842E-09_JPRB, 0.26162014E-09_JPRB, &
  & 0.26160860E-09_JPRB, 0.26158714E-09_JPRB, 0.26155891E-09_JPRB, 0.26152613E-09_JPRB, 0.26149002E-09_JPRB, 0.26145208E-09_JPRB, &
  & 0.26141095E-09_JPRB, 0.26136948E-09_JPRB, 0.26132588E-09_JPRB, 0.26128505E-09_JPRB, 0.26124747E-09_JPRB, 0.26121366E-09_JPRB, &
  & 0.26118011E-09_JPRB, 0.26114272E-09_JPRB, 0.26108740E-09_JPRB, 0.26098468E-09_JPRB /)

RGHG5(:,66, 5) = (/ &
  & 0.26108180E-09_JPRB, 0.26113167E-09_JPRB, 0.26116009E-09_JPRB, 0.26118580E-09_JPRB, 0.26121311E-09_JPRB, 0.26123981E-09_JPRB, &
  & 0.26126271E-09_JPRB, 0.26128150E-09_JPRB, 0.26130070E-09_JPRB, 0.26132049E-09_JPRB, 0.26134681E-09_JPRB, 0.26137875E-09_JPRB, &
  & 0.26141611E-09_JPRB, 0.26144995E-09_JPRB, 0.26147015E-09_JPRB, 0.26147132E-09_JPRB, 0.26145250E-09_JPRB, 0.26142111E-09_JPRB, &
  & 0.26139241E-09_JPRB, 0.26138519E-09_JPRB, 0.26141853E-09_JPRB, 0.26150443E-09_JPRB, 0.26163957E-09_JPRB, 0.26180874E-09_JPRB, &
  & 0.26198663E-09_JPRB, 0.26215688E-09_JPRB, 0.26230784E-09_JPRB, 0.26243405E-09_JPRB, 0.26253180E-09_JPRB, 0.26259875E-09_JPRB, &
  & 0.26263217E-09_JPRB, 0.26262995E-09_JPRB, 0.26259128E-09_JPRB, 0.26251629E-09_JPRB, 0.26240654E-09_JPRB, 0.26226618E-09_JPRB, &
  & 0.26210631E-09_JPRB, 0.26194297E-09_JPRB, 0.26179880E-09_JPRB, 0.26169278E-09_JPRB, 0.26163421E-09_JPRB, 0.26161964E-09_JPRB, &
  & 0.26163688E-09_JPRB, 0.26167063E-09_JPRB, 0.26170768E-09_JPRB, 0.26173722E-09_JPRB, 0.26175434E-09_JPRB, 0.26175756E-09_JPRB, &
  & 0.26174840E-09_JPRB, 0.26172939E-09_JPRB, 0.26170316E-09_JPRB, 0.26167146E-09_JPRB, 0.26163538E-09_JPRB, 0.26159552E-09_JPRB, &
  & 0.26155292E-09_JPRB, 0.26150740E-09_JPRB, 0.26146216E-09_JPRB, 0.26141764E-09_JPRB, 0.26137731E-09_JPRB, 0.26134023E-09_JPRB, &
  & 0.26130367E-09_JPRB, 0.26126046E-09_JPRB, 0.26120064E-09_JPRB, 0.26107830E-09_JPRB /)

RGHG5(:,67, 5) = (/ &
  & 0.26120145E-09_JPRB, 0.26125718E-09_JPRB, 0.26128730E-09_JPRB, 0.26131519E-09_JPRB, 0.26134400E-09_JPRB, 0.26137184E-09_JPRB, &
  & 0.26139699E-09_JPRB, 0.26141900E-09_JPRB, 0.26144081E-09_JPRB, 0.26146679E-09_JPRB, 0.26149755E-09_JPRB, 0.26153596E-09_JPRB, &
  & 0.26157582E-09_JPRB, 0.26160801E-09_JPRB, 0.26162714E-09_JPRB, 0.26162711E-09_JPRB, 0.26160732E-09_JPRB, 0.26157485E-09_JPRB, &
  & 0.26154423E-09_JPRB, 0.26153382E-09_JPRB, 0.26156183E-09_JPRB, 0.26163949E-09_JPRB, 0.26176505E-09_JPRB, 0.26192132E-09_JPRB, &
  & 0.26208777E-09_JPRB, 0.26224595E-09_JPRB, 0.26238628E-09_JPRB, 0.26250263E-09_JPRB, 0.26259225E-09_JPRB, 0.26265279E-09_JPRB, &
  & 0.26268251E-09_JPRB, 0.26268013E-09_JPRB, 0.26264491E-09_JPRB, 0.26257724E-09_JPRB, 0.26247790E-09_JPRB, 0.26235158E-09_JPRB, &
  & 0.26220648E-09_JPRB, 0.26205862E-09_JPRB, 0.26192742E-09_JPRB, 0.26183114E-09_JPRB, 0.26177732E-09_JPRB, 0.26176283E-09_JPRB, &
  & 0.26177732E-09_JPRB, 0.26180699E-09_JPRB, 0.26184074E-09_JPRB, 0.26186836E-09_JPRB, 0.26188535E-09_JPRB, 0.26188982E-09_JPRB, &
  & 0.26188274E-09_JPRB, 0.26186611E-09_JPRB, 0.26184199E-09_JPRB, 0.26181160E-09_JPRB, 0.26177599E-09_JPRB, 0.26173577E-09_JPRB, &
  & 0.26169156E-09_JPRB, 0.26164498E-09_JPRB, 0.26159716E-09_JPRB, 0.26155139E-09_JPRB, 0.26150859E-09_JPRB, 0.26146948E-09_JPRB, &
  & 0.26143013E-09_JPRB, 0.26138533E-09_JPRB, 0.26131616E-09_JPRB, 0.26118332E-09_JPRB /)

RGHG5(:,68, 5) = (/ &
  & 0.26131208E-09_JPRB, 0.26137509E-09_JPRB, 0.26141081E-09_JPRB, 0.26144145E-09_JPRB, 0.26147245E-09_JPRB, 0.26150387E-09_JPRB, &
  & 0.26152966E-09_JPRB, 0.26155561E-09_JPRB, 0.26158081E-09_JPRB, 0.26161090E-09_JPRB, 0.26164720E-09_JPRB, 0.26168814E-09_JPRB, &
  & 0.26172758E-09_JPRB, 0.26175925E-09_JPRB, 0.26177716E-09_JPRB, 0.26177599E-09_JPRB, 0.26175606E-09_JPRB, 0.26172395E-09_JPRB, &
  & 0.26169303E-09_JPRB, 0.26168068E-09_JPRB, 0.26170396E-09_JPRB, 0.26177421E-09_JPRB, 0.26188832E-09_JPRB, 0.26203262E-09_JPRB, &
  & 0.26218527E-09_JPRB, 0.26233093E-09_JPRB, 0.26245936E-09_JPRB, 0.26256558E-09_JPRB, 0.26264671E-09_JPRB, 0.26270097E-09_JPRB, &
  & 0.26272723E-09_JPRB, 0.26272473E-09_JPRB, 0.26269320E-09_JPRB, 0.26263261E-09_JPRB, 0.26254424E-09_JPRB, 0.26243091E-09_JPRB, &
  & 0.26230132E-09_JPRB, 0.26216823E-09_JPRB, 0.26205035E-09_JPRB, 0.26196365E-09_JPRB, 0.26191468E-09_JPRB, 0.26190075E-09_JPRB, &
  & 0.26191277E-09_JPRB, 0.26193850E-09_JPRB, 0.26196900E-09_JPRB, 0.26199456E-09_JPRB, 0.26201116E-09_JPRB, 0.26201658E-09_JPRB, &
  & 0.26201141E-09_JPRB, 0.26199715E-09_JPRB, 0.26197514E-09_JPRB, 0.26194635E-09_JPRB, 0.26191171E-09_JPRB, 0.26187183E-09_JPRB, &
  & 0.26182756E-09_JPRB, 0.26178013E-09_JPRB, 0.26173194E-09_JPRB, 0.26168495E-09_JPRB, 0.26164135E-09_JPRB, 0.26160096E-09_JPRB, &
  & 0.26156091E-09_JPRB, 0.26151395E-09_JPRB, 0.26144342E-09_JPRB, 0.26129868E-09_JPRB /)

RGHG5(:,69, 5) = (/ &
  & 0.26141381E-09_JPRB, 0.26149216E-09_JPRB, 0.26153277E-09_JPRB, 0.26156838E-09_JPRB, 0.26160327E-09_JPRB, 0.26163452E-09_JPRB, &
  & 0.26166547E-09_JPRB, 0.26169086E-09_JPRB, 0.26172170E-09_JPRB, 0.26175390E-09_JPRB, 0.26179342E-09_JPRB, 0.26183369E-09_JPRB, &
  & 0.26187061E-09_JPRB, 0.26189925E-09_JPRB, 0.26191715E-09_JPRB, 0.26191777E-09_JPRB, 0.26189939E-09_JPRB, 0.26186855E-09_JPRB, &
  & 0.26183872E-09_JPRB, 0.26182553E-09_JPRB, 0.26184493E-09_JPRB, 0.26190702E-09_JPRB, 0.26200997E-09_JPRB, 0.26214014E-09_JPRB, &
  & 0.26227917E-09_JPRB, 0.26241109E-09_JPRB, 0.26252750E-09_JPRB, 0.26262315E-09_JPRB, 0.26269578E-09_JPRB, 0.26274394E-09_JPRB, &
  & 0.26276692E-09_JPRB, 0.26276453E-09_JPRB, 0.26273655E-09_JPRB, 0.26268321E-09_JPRB, 0.26260510E-09_JPRB, 0.26250521E-09_JPRB, &
  & 0.26239000E-09_JPRB, 0.26227165E-09_JPRB, 0.26216668E-09_JPRB, 0.26208954E-09_JPRB, 0.26204564E-09_JPRB, 0.26203267E-09_JPRB, &
  & 0.26204267E-09_JPRB, 0.26206493E-09_JPRB, 0.26209224E-09_JPRB, 0.26211583E-09_JPRB, 0.26213193E-09_JPRB, 0.26213801E-09_JPRB, &
  & 0.26213462E-09_JPRB, 0.26212252E-09_JPRB, 0.26210270E-09_JPRB, 0.26207586E-09_JPRB, 0.26204264E-09_JPRB, 0.26200386E-09_JPRB, &
  & 0.26196034E-09_JPRB, 0.26191355E-09_JPRB, 0.26186553E-09_JPRB, 0.26181904E-09_JPRB, 0.26177549E-09_JPRB, 0.26173522E-09_JPRB, &
  & 0.26169542E-09_JPRB, 0.26164909E-09_JPRB, 0.26157568E-09_JPRB, 0.26142299E-09_JPRB /)

RGHG5(:,70, 5) = (/ &
  & 0.26151337E-09_JPRB, 0.26160690E-09_JPRB, 0.26165814E-09_JPRB, 0.26169841E-09_JPRB, 0.26173555E-09_JPRB, 0.26177069E-09_JPRB, &
  & 0.26179939E-09_JPRB, 0.26183042E-09_JPRB, 0.26186014E-09_JPRB, 0.26189650E-09_JPRB, 0.26193492E-09_JPRB, 0.26197425E-09_JPRB, &
  & 0.26201019E-09_JPRB, 0.26203875E-09_JPRB, 0.26205504E-09_JPRB, 0.26205399E-09_JPRB, 0.26203703E-09_JPRB, 0.26200880E-09_JPRB, &
  & 0.26198083E-09_JPRB, 0.26196775E-09_JPRB, 0.26198341E-09_JPRB, 0.26203739E-09_JPRB, 0.26212804E-09_JPRB, 0.26224425E-09_JPRB, &
  & 0.26236832E-09_JPRB, 0.26248653E-09_JPRB, 0.26259056E-09_JPRB, 0.26267569E-09_JPRB, 0.26274011E-09_JPRB, 0.26278241E-09_JPRB, &
  & 0.26280236E-09_JPRB, 0.26280012E-09_JPRB, 0.26277575E-09_JPRB, 0.26272926E-09_JPRB, 0.26266139E-09_JPRB, 0.26257388E-09_JPRB, &
  & 0.26247293E-09_JPRB, 0.26236868E-09_JPRB, 0.26227615E-09_JPRB, 0.26220850E-09_JPRB, 0.26216976E-09_JPRB, 0.26215818E-09_JPRB, &
  & 0.26216651E-09_JPRB, 0.26218591E-09_JPRB, 0.26221009E-09_JPRB, 0.26223174E-09_JPRB, 0.26224703E-09_JPRB, 0.26225375E-09_JPRB, &
  & 0.26225186E-09_JPRB, 0.26224187E-09_JPRB, 0.26222427E-09_JPRB, 0.26219965E-09_JPRB, 0.26216845E-09_JPRB, 0.26213159E-09_JPRB, &
  & 0.26208985E-09_JPRB, 0.26204475E-09_JPRB, 0.26199834E-09_JPRB, 0.26195340E-09_JPRB, 0.26191127E-09_JPRB, 0.26187244E-09_JPRB, &
  & 0.26183425E-09_JPRB, 0.26179003E-09_JPRB, 0.26171770E-09_JPRB, 0.26155852E-09_JPRB /)

RGHG5(:,71, 5) = (/ &
  & 0.26161245E-09_JPRB, 0.26173153E-09_JPRB, 0.26178865E-09_JPRB, 0.26183444E-09_JPRB, 0.26187366E-09_JPRB, 0.26190775E-09_JPRB, &
  & 0.26193908E-09_JPRB, 0.26196836E-09_JPRB, 0.26200148E-09_JPRB, 0.26203562E-09_JPRB, 0.26207356E-09_JPRB, 0.26210956E-09_JPRB, &
  & 0.26214034E-09_JPRB, 0.26216537E-09_JPRB, 0.26218244E-09_JPRB, 0.26218394E-09_JPRB, 0.26216912E-09_JPRB, 0.26214372E-09_JPRB, &
  & 0.26211855E-09_JPRB, 0.26210581E-09_JPRB, 0.26211827E-09_JPRB, 0.26216398E-09_JPRB, 0.26224231E-09_JPRB, 0.26234354E-09_JPRB, &
  & 0.26245286E-09_JPRB, 0.26255700E-09_JPRB, 0.26264882E-09_JPRB, 0.26272370E-09_JPRB, 0.26278005E-09_JPRB, 0.26281682E-09_JPRB, &
  & 0.26283389E-09_JPRB, 0.26283195E-09_JPRB, 0.26281105E-09_JPRB, 0.26277119E-09_JPRB, 0.26271282E-09_JPRB, 0.26263758E-09_JPRB, &
  & 0.26254993E-09_JPRB, 0.26245939E-09_JPRB, 0.26237904E-09_JPRB, 0.26232036E-09_JPRB, 0.26228680E-09_JPRB, 0.26227684E-09_JPRB, &
  & 0.26228400E-09_JPRB, 0.26230085E-09_JPRB, 0.26232200E-09_JPRB, 0.26234173E-09_JPRB, 0.26235605E-09_JPRB, 0.26236299E-09_JPRB, &
  & 0.26236238E-09_JPRB, 0.26235422E-09_JPRB, 0.26233898E-09_JPRB, 0.26231697E-09_JPRB, 0.26228839E-09_JPRB, 0.26225430E-09_JPRB, &
  & 0.26221558E-09_JPRB, 0.26217317E-09_JPRB, 0.26212993E-09_JPRB, 0.26208738E-09_JPRB, 0.26204852E-09_JPRB, 0.26201213E-09_JPRB, &
  & 0.26197708E-09_JPRB, 0.26193706E-09_JPRB, 0.26187022E-09_JPRB, 0.26172048E-09_JPRB /)

RGHG5(:,72, 5) = (/ &
  & 0.26172853E-09_JPRB, 0.26186076E-09_JPRB, 0.26193026E-09_JPRB, 0.26197666E-09_JPRB, 0.26201669E-09_JPRB, 0.26204977E-09_JPRB, &
  & 0.26208027E-09_JPRB, 0.26211033E-09_JPRB, 0.26214128E-09_JPRB, 0.26217523E-09_JPRB, 0.26220909E-09_JPRB, 0.26224220E-09_JPRB, &
  & 0.26227087E-09_JPRB, 0.26229341E-09_JPRB, 0.26230756E-09_JPRB, 0.26230787E-09_JPRB, 0.26229521E-09_JPRB, 0.26227287E-09_JPRB, &
  & 0.26225039E-09_JPRB, 0.26223868E-09_JPRB, 0.26224803E-09_JPRB, 0.26228592E-09_JPRB, 0.26235172E-09_JPRB, 0.26243829E-09_JPRB, &
  & 0.26253252E-09_JPRB, 0.26262295E-09_JPRB, 0.26270275E-09_JPRB, 0.26276742E-09_JPRB, 0.26281630E-09_JPRB, 0.26284769E-09_JPRB, &
  & 0.26286212E-09_JPRB, 0.26286051E-09_JPRB, 0.26284300E-09_JPRB, 0.26280916E-09_JPRB, 0.26275998E-09_JPRB, 0.26269609E-09_JPRB, &
  & 0.26262148E-09_JPRB, 0.26254365E-09_JPRB, 0.26247507E-09_JPRB, 0.26242503E-09_JPRB, 0.26239649E-09_JPRB, 0.26238822E-09_JPRB, &
  & 0.26239452E-09_JPRB, 0.26240882E-09_JPRB, 0.26242722E-09_JPRB, 0.26244482E-09_JPRB, 0.26245783E-09_JPRB, 0.26246477E-09_JPRB, &
  & 0.26246499E-09_JPRB, 0.26245855E-09_JPRB, 0.26244579E-09_JPRB, 0.26242664E-09_JPRB, 0.26240143E-09_JPRB, 0.26237101E-09_JPRB, &
  & 0.26233610E-09_JPRB, 0.26229824E-09_JPRB, 0.26225844E-09_JPRB, 0.26222097E-09_JPRB, 0.26218491E-09_JPRB, 0.26215294E-09_JPRB, &
  & 0.26212130E-09_JPRB, 0.26208599E-09_JPRB, 0.26202673E-09_JPRB, 0.26188607E-09_JPRB /)

RGHG5(:,73, 5) = (/ &
  & 0.26185851E-09_JPRB, 0.26201075E-09_JPRB, 0.26207708E-09_JPRB, 0.26212593E-09_JPRB, 0.26216265E-09_JPRB, 0.26219499E-09_JPRB, &
  & 0.26222355E-09_JPRB, 0.26225200E-09_JPRB, 0.26228245E-09_JPRB, 0.26231101E-09_JPRB, 0.26234301E-09_JPRB, 0.26236968E-09_JPRB, &
  & 0.26239119E-09_JPRB, 0.26240998E-09_JPRB, 0.26242444E-09_JPRB, 0.26242575E-09_JPRB, 0.26241434E-09_JPRB, 0.26239488E-09_JPRB, &
  & 0.26237529E-09_JPRB, 0.26236455E-09_JPRB, 0.26237135E-09_JPRB, 0.26240177E-09_JPRB, 0.26245578E-09_JPRB, 0.26252792E-09_JPRB, &
  & 0.26260774E-09_JPRB, 0.26268429E-09_JPRB, 0.26275254E-09_JPRB, 0.26280741E-09_JPRB, 0.26284874E-09_JPRB, 0.26287517E-09_JPRB, &
  & 0.26288716E-09_JPRB, 0.26288591E-09_JPRB, 0.26287159E-09_JPRB, 0.26284355E-09_JPRB, 0.26280275E-09_JPRB, 0.26274977E-09_JPRB, &
  & 0.26268715E-09_JPRB, 0.26262184E-09_JPRB, 0.26256414E-09_JPRB, 0.26252228E-09_JPRB, 0.26249858E-09_JPRB, 0.26249178E-09_JPRB, &
  & 0.26249719E-09_JPRB, 0.26250921E-09_JPRB, 0.26252484E-09_JPRB, 0.26254032E-09_JPRB, 0.26255187E-09_JPRB, 0.26255834E-09_JPRB, &
  & 0.26255920E-09_JPRB, 0.26255420E-09_JPRB, 0.26254374E-09_JPRB, 0.26252794E-09_JPRB, 0.26250627E-09_JPRB, 0.26248023E-09_JPRB, &
  & 0.26245039E-09_JPRB, 0.26241684E-09_JPRB, 0.26238328E-09_JPRB, 0.26234914E-09_JPRB, 0.26231925E-09_JPRB, 0.26229030E-09_JPRB, &
  & 0.26226318E-09_JPRB, 0.26223260E-09_JPRB, 0.26217920E-09_JPRB, 0.26205121E-09_JPRB /)

RGHG5(:,74, 5) = (/ &
  & 0.26200861E-09_JPRB, 0.26215868E-09_JPRB, 0.26223121E-09_JPRB, 0.26227415E-09_JPRB, 0.26230976E-09_JPRB, 0.26233793E-09_JPRB, &
  & 0.26236530E-09_JPRB, 0.26239183E-09_JPRB, 0.26241709E-09_JPRB, 0.26244548E-09_JPRB, 0.26246916E-09_JPRB, 0.26249411E-09_JPRB, &
  & 0.26251257E-09_JPRB, 0.26252855E-09_JPRB, 0.26253680E-09_JPRB, 0.26253608E-09_JPRB, 0.26252595E-09_JPRB, 0.26250910E-09_JPRB, &
  & 0.26249206E-09_JPRB, 0.26248259E-09_JPRB, 0.26248723E-09_JPRB, 0.26251082E-09_JPRB, 0.26255376E-09_JPRB, 0.26261246E-09_JPRB, &
  & 0.26267832E-09_JPRB, 0.26274152E-09_JPRB, 0.26279862E-09_JPRB, 0.26284377E-09_JPRB, 0.26287811E-09_JPRB, 0.26289984E-09_JPRB, &
  & 0.26290961E-09_JPRB, 0.26290869E-09_JPRB, 0.26289729E-09_JPRB, 0.26287436E-09_JPRB, 0.26284155E-09_JPRB, 0.26279848E-09_JPRB, &
  & 0.26274735E-09_JPRB, 0.26269353E-09_JPRB, 0.26264643E-09_JPRB, 0.26261202E-09_JPRB, 0.26259275E-09_JPRB, 0.26258737E-09_JPRB, &
  & 0.26259200E-09_JPRB, 0.26260166E-09_JPRB, 0.26261474E-09_JPRB, 0.26262800E-09_JPRB, 0.26263799E-09_JPRB, 0.26264371E-09_JPRB, &
  & 0.26264491E-09_JPRB, 0.26264105E-09_JPRB, 0.26263297E-09_JPRB, 0.26262029E-09_JPRB, 0.26260255E-09_JPRB, 0.26258110E-09_JPRB, &
  & 0.26255617E-09_JPRB, 0.26252889E-09_JPRB, 0.26249955E-09_JPRB, 0.26247249E-09_JPRB, 0.26244534E-09_JPRB, 0.26242225E-09_JPRB, &
  & 0.26239849E-09_JPRB, 0.26237243E-09_JPRB, 0.26232660E-09_JPRB, 0.26220770E-09_JPRB /)

RGHG5(:,75, 5) = (/ &
  & 0.26215824E-09_JPRB, 0.26231523E-09_JPRB, 0.26237967E-09_JPRB, 0.26242034E-09_JPRB, 0.26245028E-09_JPRB, 0.26247621E-09_JPRB, &
  & 0.26249997E-09_JPRB, 0.26252278E-09_JPRB, 0.26254693E-09_JPRB, 0.26256664E-09_JPRB, 0.26258939E-09_JPRB, 0.26260444E-09_JPRB, &
  & 0.26261415E-09_JPRB, 0.26262342E-09_JPRB, 0.26263738E-09_JPRB, 0.26263769E-09_JPRB, 0.26262914E-09_JPRB, 0.26261490E-09_JPRB, &
  & 0.26260055E-09_JPRB, 0.26259234E-09_JPRB, 0.26259511E-09_JPRB, 0.26261260E-09_JPRB, 0.26264557E-09_JPRB, 0.26269192E-09_JPRB, &
  & 0.26274469E-09_JPRB, 0.26279495E-09_JPRB, 0.26284130E-09_JPRB, 0.26287700E-09_JPRB, 0.26290436E-09_JPRB, 0.26292163E-09_JPRB, &
  & 0.26292918E-09_JPRB, 0.26292860E-09_JPRB, 0.26292013E-09_JPRB, 0.26290206E-09_JPRB, 0.26287644E-09_JPRB, 0.26284278E-09_JPRB, &
  & 0.26280214E-09_JPRB, 0.26275940E-09_JPRB, 0.26272201E-09_JPRB, 0.26269475E-09_JPRB, 0.26267943E-09_JPRB, 0.26267510E-09_JPRB, &
  & 0.26267893E-09_JPRB, 0.26268654E-09_JPRB, 0.26269711E-09_JPRB, 0.26270824E-09_JPRB, 0.26271668E-09_JPRB, 0.26272132E-09_JPRB, &
  & 0.26272268E-09_JPRB, 0.26271985E-09_JPRB, 0.26271385E-09_JPRB, 0.26270447E-09_JPRB, 0.26269015E-09_JPRB, 0.26267338E-09_JPRB, &
  & 0.26265373E-09_JPRB, 0.26263150E-09_JPRB, 0.26260888E-09_JPRB, 0.26258551E-09_JPRB, 0.26256503E-09_JPRB, 0.26254479E-09_JPRB, &
  & 0.26252617E-09_JPRB, 0.26250457E-09_JPRB, 0.26246411E-09_JPRB, 0.26235736E-09_JPRB /)

RGHG5(:,76, 5) = (/ &
  & 0.26231944E-09_JPRB, 0.26246455E-09_JPRB, 0.26252506E-09_JPRB, 0.26255778E-09_JPRB, 0.26258357E-09_JPRB, 0.26260405E-09_JPRB, &
  & 0.26262481E-09_JPRB, 0.26264435E-09_JPRB, 0.26266184E-09_JPRB, 0.26268074E-09_JPRB, 0.26269478E-09_JPRB, 0.26270947E-09_JPRB, &
  & 0.26271660E-09_JPRB, 0.26272720E-09_JPRB, 0.26273120E-09_JPRB, 0.26273042E-09_JPRB, 0.26272368E-09_JPRB, 0.26271216E-09_JPRB, &
  & 0.26270025E-09_JPRB, 0.26269351E-09_JPRB, 0.26269478E-09_JPRB, 0.26270708E-09_JPRB, 0.26273128E-09_JPRB, 0.26276639E-09_JPRB, &
  & 0.26280694E-09_JPRB, 0.26284469E-09_JPRB, 0.26288066E-09_JPRB, 0.26290720E-09_JPRB, 0.26292810E-09_JPRB, 0.26294128E-09_JPRB, &
  & 0.26294703E-09_JPRB, 0.26294675E-09_JPRB, 0.26294078E-09_JPRB, 0.26292679E-09_JPRB, 0.26290781E-09_JPRB, 0.26288272E-09_JPRB, &
  & 0.26285199E-09_JPRB, 0.26281941E-09_JPRB, 0.26279132E-09_JPRB, 0.26277053E-09_JPRB, 0.26275890E-09_JPRB, 0.26275543E-09_JPRB, &
  & 0.26275865E-09_JPRB, 0.26276423E-09_JPRB, 0.26277236E-09_JPRB, 0.26278163E-09_JPRB, 0.26278837E-09_JPRB, 0.26279176E-09_JPRB, &
  & 0.26279312E-09_JPRB, 0.26279104E-09_JPRB, 0.26278710E-09_JPRB, 0.26278063E-09_JPRB, 0.26276964E-09_JPRB, 0.26275723E-09_JPRB, &
  & 0.26274261E-09_JPRB, 0.26272617E-09_JPRB, 0.26270836E-09_JPRB, 0.26269145E-09_JPRB, 0.26267416E-09_JPRB, 0.26265967E-09_JPRB, &
  & 0.26264463E-09_JPRB, 0.26262814E-09_JPRB, 0.26259400E-09_JPRB, 0.26249716E-09_JPRB /)

RGHG5(:,77, 5) = (/ &
  & 0.26248068E-09_JPRB, 0.26261046E-09_JPRB, 0.26266095E-09_JPRB, 0.26268615E-09_JPRB, 0.26270525E-09_JPRB, 0.26272101E-09_JPRB, &
  & 0.26273692E-09_JPRB, 0.26275127E-09_JPRB, 0.26276561E-09_JPRB, 0.26277663E-09_JPRB, 0.26278774E-09_JPRB, 0.26279351E-09_JPRB, &
  & 0.26279245E-09_JPRB, 0.26279734E-09_JPRB, 0.26281050E-09_JPRB, 0.26281183E-09_JPRB, 0.26280772E-09_JPRB, 0.26279909E-09_JPRB, &
  & 0.26278971E-09_JPRB, 0.26278466E-09_JPRB, 0.26278513E-09_JPRB, 0.26279307E-09_JPRB, 0.26280980E-09_JPRB, 0.26283489E-09_JPRB, &
  & 0.26286415E-09_JPRB, 0.26289046E-09_JPRB, 0.26291638E-09_JPRB, 0.26293445E-09_JPRB, 0.26294908E-09_JPRB, 0.26295818E-09_JPRB, &
  & 0.26296215E-09_JPRB, 0.26296207E-09_JPRB, 0.26295865E-09_JPRB, 0.26294861E-09_JPRB, 0.26293570E-09_JPRB, 0.26291852E-09_JPRB, &
  & 0.26289679E-09_JPRB, 0.26287356E-09_JPRB, 0.26285396E-09_JPRB, 0.26283917E-09_JPRB, 0.26283084E-09_JPRB, 0.26282809E-09_JPRB, &
  & 0.26283076E-09_JPRB, 0.26283445E-09_JPRB, 0.26284031E-09_JPRB, 0.26284783E-09_JPRB, 0.26285293E-09_JPRB, 0.26285490E-09_JPRB, &
  & 0.26285618E-09_JPRB, 0.26285460E-09_JPRB, 0.26285241E-09_JPRB, 0.26284880E-09_JPRB, 0.26284053E-09_JPRB, 0.26283242E-09_JPRB, &
  & 0.26282243E-09_JPRB, 0.26281127E-09_JPRB, 0.26279912E-09_JPRB, 0.26278665E-09_JPRB, 0.26277486E-09_JPRB, 0.26276387E-09_JPRB, &
  & 0.26275387E-09_JPRB, 0.26274186E-09_JPRB, 0.26271402E-09_JPRB, 0.26263039E-09_JPRB /)

RGHG5(:,78, 5) = (/ &
  & 0.26264313E-09_JPRB, 0.26274274E-09_JPRB, 0.26277938E-09_JPRB, 0.26279595E-09_JPRB, 0.26280916E-09_JPRB, 0.26281882E-09_JPRB, &
  & 0.26283026E-09_JPRB, 0.26283958E-09_JPRB, 0.26284808E-09_JPRB, 0.26285574E-09_JPRB, 0.26286154E-09_JPRB, 0.26286576E-09_JPRB, &
  & 0.26286354E-09_JPRB, 0.26286823E-09_JPRB, 0.26287636E-09_JPRB, 0.26287814E-09_JPRB, 0.26287642E-09_JPRB, 0.26287056E-09_JPRB, &
  & 0.26286362E-09_JPRB, 0.26286059E-09_JPRB, 0.26286073E-09_JPRB, 0.26286565E-09_JPRB, 0.26287639E-09_JPRB, 0.26289335E-09_JPRB, &
  & 0.26291294E-09_JPRB, 0.26292973E-09_JPRB, 0.26294666E-09_JPRB, 0.26295752E-09_JPRB, 0.26296690E-09_JPRB, 0.26297256E-09_JPRB, &
  & 0.26297542E-09_JPRB, 0.26297547E-09_JPRB, 0.26297395E-09_JPRB, 0.26296681E-09_JPRB, 0.26295902E-09_JPRB, 0.26294855E-09_JPRB, &
  & 0.26293456E-09_JPRB, 0.26291924E-09_JPRB, 0.26290700E-09_JPRB, 0.26289740E-09_JPRB, 0.26289193E-09_JPRB, 0.26288977E-09_JPRB, &
  & 0.26289190E-09_JPRB, 0.26289382E-09_JPRB, 0.26289765E-09_JPRB, 0.26290373E-09_JPRB, 0.26290717E-09_JPRB, 0.26290767E-09_JPRB, &
  & 0.26290864E-09_JPRB, 0.26290725E-09_JPRB, 0.26290642E-09_JPRB, 0.26290517E-09_JPRB, 0.26289915E-09_JPRB, 0.26289459E-09_JPRB, &
  & 0.26288879E-09_JPRB, 0.26288241E-09_JPRB, 0.26287486E-09_JPRB, 0.26286731E-09_JPRB, 0.26285904E-09_JPRB, 0.26285227E-09_JPRB, &
  & 0.26284616E-09_JPRB, 0.26283886E-09_JPRB, 0.26281941E-09_JPRB, 0.26275607E-09_JPRB /)

RGHG5(:,79, 5) = (/ &
  & 0.26274835E-09_JPRB, 0.26281682E-09_JPRB, 0.26284291E-09_JPRB, 0.26285316E-09_JPRB, 0.26286306E-09_JPRB, 0.26286950E-09_JPRB, &
  & 0.26287841E-09_JPRB, 0.26288483E-09_JPRB, 0.26289115E-09_JPRB, 0.26289615E-09_JPRB, 0.26290040E-09_JPRB, 0.26290342E-09_JPRB, &
  & 0.26290037E-09_JPRB, 0.26290514E-09_JPRB, 0.26291042E-09_JPRB, 0.26291264E-09_JPRB, 0.26291250E-09_JPRB, 0.26290800E-09_JPRB, &
  & 0.26290228E-09_JPRB, 0.26290040E-09_JPRB, 0.26290051E-09_JPRB, 0.26290373E-09_JPRB, 0.26291153E-09_JPRB, 0.26292429E-09_JPRB, &
  & 0.26293914E-09_JPRB, 0.26295083E-09_JPRB, 0.26296301E-09_JPRB, 0.26296984E-09_JPRB, 0.26297634E-09_JPRB, 0.26298017E-09_JPRB, &
  & 0.26298258E-09_JPRB, 0.26298277E-09_JPRB, 0.26298236E-09_JPRB, 0.26297664E-09_JPRB, 0.26297167E-09_JPRB, 0.26296501E-09_JPRB, &
  & 0.26295513E-09_JPRB, 0.26294394E-09_JPRB, 0.26293551E-09_JPRB, 0.26292854E-09_JPRB, 0.26292443E-09_JPRB, 0.26292235E-09_JPRB, &
  & 0.26292427E-09_JPRB, 0.26292513E-09_JPRB, 0.26292782E-09_JPRB, 0.26293326E-09_JPRB, 0.26293573E-09_JPRB, 0.26293517E-09_JPRB, &
  & 0.26293598E-09_JPRB, 0.26293445E-09_JPRB, 0.26293442E-09_JPRB, 0.26293451E-09_JPRB, 0.26292921E-09_JPRB, 0.26292654E-09_JPRB, &
  & 0.26292282E-09_JPRB, 0.26291896E-09_JPRB, 0.26291383E-09_JPRB, 0.26290845E-09_JPRB, 0.26290217E-09_JPRB, 0.26289723E-09_JPRB, &
  & 0.26289348E-09_JPRB, 0.26288988E-09_JPRB, 0.26287725E-09_JPRB, 0.26283506E-09_JPRB /)

RGHG5(:,80, 5) = (/ &
  & 0.26281810E-09_JPRB, 0.26285255E-09_JPRB, 0.26287075E-09_JPRB, 0.26287800E-09_JPRB, 0.26288632E-09_JPRB, 0.26289115E-09_JPRB, &
  & 0.26289931E-09_JPRB, 0.26290436E-09_JPRB, 0.26290997E-09_JPRB, 0.26291405E-09_JPRB, 0.26291769E-09_JPRB, 0.26292041E-09_JPRB, &
  & 0.26291680E-09_JPRB, 0.26292180E-09_JPRB, 0.26292560E-09_JPRB, 0.26292812E-09_JPRB, 0.26292885E-09_JPRB, 0.26292499E-09_JPRB, &
  & 0.26291966E-09_JPRB, 0.26291841E-09_JPRB, 0.26291844E-09_JPRB, 0.26292077E-09_JPRB, 0.26292721E-09_JPRB, 0.26293825E-09_JPRB, &
  & 0.26295102E-09_JPRB, 0.26296049E-09_JPRB, 0.26297051E-09_JPRB, 0.26297539E-09_JPRB, 0.26298055E-09_JPRB, 0.26298358E-09_JPRB, &
  & 0.26298580E-09_JPRB, 0.26298608E-09_JPRB, 0.26298627E-09_JPRB, 0.26298119E-09_JPRB, 0.26297753E-09_JPRB, 0.26297264E-09_JPRB, &
  & 0.26296457E-09_JPRB, 0.26295516E-09_JPRB, 0.26294844E-09_JPRB, 0.26294253E-09_JPRB, 0.26293898E-09_JPRB, 0.26293689E-09_JPRB, &
  & 0.26293862E-09_JPRB, 0.26293895E-09_JPRB, 0.26294114E-09_JPRB, 0.26294644E-09_JPRB, 0.26294847E-09_JPRB, 0.26294719E-09_JPRB, &
  & 0.26294794E-09_JPRB, 0.26294625E-09_JPRB, 0.26294650E-09_JPRB, 0.26294728E-09_JPRB, 0.26294214E-09_JPRB, 0.26294025E-09_JPRB, &
  & 0.26293742E-09_JPRB, 0.26293473E-09_JPRB, 0.26293051E-09_JPRB, 0.26292610E-09_JPRB, 0.26292052E-09_JPRB, 0.26291636E-09_JPRB, &
  & 0.26291377E-09_JPRB, 0.26291203E-09_JPRB, 0.26290473E-09_JPRB, 0.26288621E-09_JPRB /)

RGHG5(:,81, 5) = (/ &
  & 0.26286584E-09_JPRB, 0.26286751E-09_JPRB, 0.26288263E-09_JPRB, 0.26288849E-09_JPRB, 0.26289623E-09_JPRB, 0.26290051E-09_JPRB, &
  & 0.26290808E-09_JPRB, 0.26291319E-09_JPRB, 0.26291788E-09_JPRB, 0.26292230E-09_JPRB, 0.26292526E-09_JPRB, 0.26292801E-09_JPRB, &
  & 0.26292415E-09_JPRB, 0.26292915E-09_JPRB, 0.26293223E-09_JPRB, 0.26293492E-09_JPRB, 0.26293623E-09_JPRB, 0.26293265E-09_JPRB, &
  & 0.26292735E-09_JPRB, 0.26292649E-09_JPRB, 0.26292640E-09_JPRB, 0.26292826E-09_JPRB, 0.26293404E-09_JPRB, 0.26294433E-09_JPRB, &
  & 0.26295632E-09_JPRB, 0.26296473E-09_JPRB, 0.26297384E-09_JPRB, 0.26297786E-09_JPRB, 0.26298239E-09_JPRB, 0.26298502E-09_JPRB, &
  & 0.26298722E-09_JPRB, 0.26298755E-09_JPRB, 0.26298805E-09_JPRB, 0.26298314E-09_JPRB, 0.26298008E-09_JPRB, 0.26297603E-09_JPRB, &
  & 0.26296876E-09_JPRB, 0.26296021E-09_JPRB, 0.26295419E-09_JPRB, 0.26294872E-09_JPRB, 0.26294536E-09_JPRB, 0.26294322E-09_JPRB, &
  & 0.26294480E-09_JPRB, 0.26294492E-09_JPRB, 0.26294686E-09_JPRB, 0.26295219E-09_JPRB, 0.26295405E-09_JPRB, 0.26295235E-09_JPRB, &
  & 0.26295302E-09_JPRB, 0.26295122E-09_JPRB, 0.26295169E-09_JPRB, 0.26295288E-09_JPRB, 0.26294766E-09_JPRB, 0.26294614E-09_JPRB, &
  & 0.26294372E-09_JPRB, 0.26294145E-09_JPRB, 0.26293764E-09_JPRB, 0.26293362E-09_JPRB, 0.26292832E-09_JPRB, 0.26292440E-09_JPRB, &
  & 0.26292227E-09_JPRB, 0.26292141E-09_JPRB, 0.26291616E-09_JPRB, 0.26292071E-09_JPRB /)

RGHG5(:,82, 5) = (/ &
  & 0.26286959E-09_JPRB, 0.26287242E-09_JPRB, 0.26288785E-09_JPRB, 0.26289343E-09_JPRB, 0.26290103E-09_JPRB, 0.26290481E-09_JPRB, &
  & 0.26291283E-09_JPRB, 0.26291672E-09_JPRB, 0.26292263E-09_JPRB, 0.26292579E-09_JPRB, 0.26292934E-09_JPRB, 0.26293168E-09_JPRB, &
  & 0.26292785E-09_JPRB, 0.26293290E-09_JPRB, 0.26293551E-09_JPRB, 0.26293837E-09_JPRB, 0.26293998E-09_JPRB, 0.26293645E-09_JPRB, &
  & 0.26293120E-09_JPRB, 0.26293048E-09_JPRB, 0.26293034E-09_JPRB, 0.26293190E-09_JPRB, 0.26293728E-09_JPRB, 0.26294733E-09_JPRB, &
  & 0.26295904E-09_JPRB, 0.26296687E-09_JPRB, 0.26297559E-09_JPRB, 0.26297903E-09_JPRB, 0.26298325E-09_JPRB, 0.26298566E-09_JPRB, &
  & 0.26298785E-09_JPRB, 0.26298824E-09_JPRB, 0.26298888E-09_JPRB, 0.26298405E-09_JPRB, 0.26298136E-09_JPRB, 0.26297761E-09_JPRB, &
  & 0.26297076E-09_JPRB, 0.26296262E-09_JPRB, 0.26295691E-09_JPRB, 0.26295174E-09_JPRB, 0.26294855E-09_JPRB, 0.26294639E-09_JPRB, &
  & 0.26294780E-09_JPRB, 0.26294780E-09_JPRB, 0.26294963E-09_JPRB, 0.26295499E-09_JPRB, 0.26295677E-09_JPRB, 0.26295485E-09_JPRB, &
  & 0.26295549E-09_JPRB, 0.26295358E-09_JPRB, 0.26295416E-09_JPRB, 0.26295557E-09_JPRB, 0.26295027E-09_JPRB, 0.26294894E-09_JPRB, &
  & 0.26294672E-09_JPRB, 0.26294472E-09_JPRB, 0.26294111E-09_JPRB, 0.26293726E-09_JPRB, 0.26293201E-09_JPRB, 0.26292823E-09_JPRB, &
  & 0.26292626E-09_JPRB, 0.26292549E-09_JPRB, 0.26291999E-09_JPRB, 0.26292346E-09_JPRB /)

RGHG5(:,83, 5) = (/ &
  & 0.26287220E-09_JPRB, 0.26287533E-09_JPRB, 0.26289082E-09_JPRB, 0.26289620E-09_JPRB, 0.26290373E-09_JPRB, 0.26290770E-09_JPRB, &
  & 0.26291469E-09_JPRB, 0.26292019E-09_JPRB, 0.26292402E-09_JPRB, 0.26292871E-09_JPRB, 0.26293104E-09_JPRB, 0.26293354E-09_JPRB, &
  & 0.26293037E-09_JPRB, 0.26293484E-09_JPRB, 0.26293737E-09_JPRB, 0.26294023E-09_JPRB, 0.26294211E-09_JPRB, 0.26293875E-09_JPRB, &
  & 0.26293334E-09_JPRB, 0.26293279E-09_JPRB, 0.26293259E-09_JPRB, 0.26293387E-09_JPRB, 0.26293900E-09_JPRB, 0.26294900E-09_JPRB, &
  & 0.26296068E-09_JPRB, 0.26296809E-09_JPRB, 0.26297661E-09_JPRB, 0.26297969E-09_JPRB, 0.26298375E-09_JPRB, 0.26298605E-09_JPRB, &
  & 0.26298819E-09_JPRB, 0.26298863E-09_JPRB, 0.26298938E-09_JPRB, 0.26298455E-09_JPRB, 0.26298200E-09_JPRB, 0.26297844E-09_JPRB, &
  & 0.26297176E-09_JPRB, 0.26296398E-09_JPRB, 0.26295849E-09_JPRB, 0.26295352E-09_JPRB, 0.26295033E-09_JPRB, 0.26294822E-09_JPRB, &
  & 0.26294944E-09_JPRB, 0.26294944E-09_JPRB, 0.26295108E-09_JPRB, 0.26295655E-09_JPRB, 0.26295832E-09_JPRB, 0.26295624E-09_JPRB, &
  & 0.26295688E-09_JPRB, 0.26295491E-09_JPRB, 0.26295560E-09_JPRB, 0.26295716E-09_JPRB, 0.26295174E-09_JPRB, 0.26295049E-09_JPRB, &
  & 0.26294841E-09_JPRB, 0.26294658E-09_JPRB, 0.26294303E-09_JPRB, 0.26293925E-09_JPRB, 0.26293415E-09_JPRB, 0.26293037E-09_JPRB, &
  & 0.26292851E-09_JPRB, 0.26292787E-09_JPRB, 0.26292224E-09_JPRB, 0.26292529E-09_JPRB /)

RGHG5(:,84, 5) = (/ &
  & 0.26287392E-09_JPRB, 0.26287714E-09_JPRB, 0.26289271E-09_JPRB, 0.26289793E-09_JPRB, 0.26290545E-09_JPRB, 0.26290892E-09_JPRB, &
  & 0.26291724E-09_JPRB, 0.26292066E-09_JPRB, 0.26292674E-09_JPRB, 0.26292932E-09_JPRB, 0.26293273E-09_JPRB, 0.26293445E-09_JPRB, &
  & 0.26293195E-09_JPRB, 0.26293603E-09_JPRB, 0.26293837E-09_JPRB, 0.26294136E-09_JPRB, 0.26294333E-09_JPRB, 0.26294014E-09_JPRB, &
  & 0.26293479E-09_JPRB, 0.26293426E-09_JPRB, 0.26293398E-09_JPRB, 0.26293509E-09_JPRB, 0.26294009E-09_JPRB, 0.26295005E-09_JPRB, &
  & 0.26296171E-09_JPRB, 0.26296890E-09_JPRB, 0.26297725E-09_JPRB, 0.26298014E-09_JPRB, 0.26298405E-09_JPRB, 0.26298624E-09_JPRB, &
  & 0.26298844E-09_JPRB, 0.26298885E-09_JPRB, 0.26298969E-09_JPRB, 0.26298486E-09_JPRB, 0.26298244E-09_JPRB, 0.26297883E-09_JPRB, &
  & 0.26297226E-09_JPRB, 0.26296482E-09_JPRB, 0.26295943E-09_JPRB, 0.26295474E-09_JPRB, 0.26295166E-09_JPRB, 0.26294955E-09_JPRB, &
  & 0.26295044E-09_JPRB, 0.26295044E-09_JPRB, 0.26295197E-09_JPRB, 0.26295746E-09_JPRB, 0.26295929E-09_JPRB, 0.26295716E-09_JPRB, &
  & 0.26295777E-09_JPRB, 0.26295571E-09_JPRB, 0.26295641E-09_JPRB, 0.26295816E-09_JPRB, 0.26295260E-09_JPRB, 0.26295144E-09_JPRB, &
  & 0.26294941E-09_JPRB, 0.26294772E-09_JPRB, 0.26294419E-09_JPRB, 0.26294056E-09_JPRB, 0.26293540E-09_JPRB, 0.26293170E-09_JPRB, &
  & 0.26292987E-09_JPRB, 0.26292932E-09_JPRB, 0.26292363E-09_JPRB, 0.26292660E-09_JPRB /)

RGHG5(:,85, 5) = (/ &
  & 0.26287506E-09_JPRB, 0.26287833E-09_JPRB, 0.26289393E-09_JPRB, 0.26289912E-09_JPRB, 0.26290661E-09_JPRB, 0.26291103E-09_JPRB, &
  & 0.26291747E-09_JPRB, 0.26292318E-09_JPRB, 0.26292657E-09_JPRB, 0.26293090E-09_JPRB, 0.26293273E-09_JPRB, 0.26293492E-09_JPRB, &
  & 0.26293362E-09_JPRB, 0.26293689E-09_JPRB, 0.26293917E-09_JPRB, 0.26294189E-09_JPRB, 0.26294392E-09_JPRB, 0.26294106E-09_JPRB, &
  & 0.26293570E-09_JPRB, 0.26293517E-09_JPRB, 0.26293484E-09_JPRB, 0.26293578E-09_JPRB, 0.26294070E-09_JPRB, 0.26295069E-09_JPRB, &
  & 0.26296240E-09_JPRB, 0.26296929E-09_JPRB, 0.26297775E-09_JPRB, 0.26298039E-09_JPRB, 0.26298427E-09_JPRB, 0.26298641E-09_JPRB, &
  & 0.26298863E-09_JPRB, 0.26298896E-09_JPRB, 0.26298985E-09_JPRB, 0.26298499E-09_JPRB, 0.26298266E-09_JPRB, 0.26297906E-09_JPRB, &
  & 0.26297262E-09_JPRB, 0.26296521E-09_JPRB, 0.26296004E-09_JPRB, 0.26295549E-09_JPRB, 0.26295249E-09_JPRB, 0.26295044E-09_JPRB, &
  & 0.26295111E-09_JPRB, 0.26295108E-09_JPRB, 0.26295260E-09_JPRB, 0.26295793E-09_JPRB, 0.26295985E-09_JPRB, 0.26295774E-09_JPRB, &
  & 0.26295832E-09_JPRB, 0.26295621E-09_JPRB, 0.26295702E-09_JPRB, 0.26295885E-09_JPRB, 0.26295321E-09_JPRB, 0.26295208E-09_JPRB, &
  & 0.26295011E-09_JPRB, 0.26294850E-09_JPRB, 0.26294503E-09_JPRB, 0.26294134E-09_JPRB, 0.26293628E-09_JPRB, 0.26293248E-09_JPRB, &
  & 0.26293076E-09_JPRB, 0.26293034E-09_JPRB, 0.26292457E-09_JPRB, 0.26292743E-09_JPRB /)

RGHG5(:,86, 5) = (/ &
  & 0.26287575E-09_JPRB, 0.26287911E-09_JPRB, 0.26289468E-09_JPRB, 0.26289979E-09_JPRB, 0.26290764E-09_JPRB, 0.26291133E-09_JPRB, &
  & 0.26291977E-09_JPRB, 0.26292318E-09_JPRB, 0.26292837E-09_JPRB, 0.26293068E-09_JPRB, 0.26293384E-09_JPRB, 0.26293506E-09_JPRB, &
  & 0.26293467E-09_JPRB, 0.26293712E-09_JPRB, 0.26293928E-09_JPRB, 0.26294192E-09_JPRB, 0.26294383E-09_JPRB, 0.26294161E-09_JPRB, &
  & 0.26293648E-09_JPRB, 0.26293587E-09_JPRB, 0.26293545E-09_JPRB, 0.26293626E-09_JPRB, 0.26294111E-09_JPRB, 0.26295108E-09_JPRB, &
  & 0.26296287E-09_JPRB, 0.26296967E-09_JPRB, 0.26297797E-09_JPRB, 0.26298055E-09_JPRB, 0.26298438E-09_JPRB, 0.26298647E-09_JPRB, &
  & 0.26298869E-09_JPRB, 0.26298910E-09_JPRB, 0.26298996E-09_JPRB, 0.26298511E-09_JPRB, 0.26298289E-09_JPRB, 0.26297939E-09_JPRB, &
  & 0.26297278E-09_JPRB, 0.26296559E-09_JPRB, 0.26296032E-09_JPRB, 0.26295588E-09_JPRB, 0.26295288E-09_JPRB, 0.26295088E-09_JPRB, &
  & 0.26295152E-09_JPRB, 0.26295152E-09_JPRB, 0.26295294E-09_JPRB, 0.26295835E-09_JPRB, 0.26296015E-09_JPRB, 0.26295804E-09_JPRB, &
  & 0.26295865E-09_JPRB, 0.26295655E-09_JPRB, 0.26295732E-09_JPRB, 0.26295924E-09_JPRB, 0.26295349E-09_JPRB, 0.26295238E-09_JPRB, &
  & 0.26295047E-09_JPRB, 0.26294894E-09_JPRB, 0.26294553E-09_JPRB, 0.26294192E-09_JPRB, 0.26293673E-09_JPRB, 0.26293306E-09_JPRB, &
  & 0.26293132E-09_JPRB, 0.26293101E-09_JPRB, 0.26292510E-09_JPRB, 0.26292796E-09_JPRB /)

RGHG5(:,87, 5) = (/ &
  & 0.26287630E-09_JPRB, 0.26287986E-09_JPRB, 0.26289504E-09_JPRB, 0.26290048E-09_JPRB, 0.26290803E-09_JPRB, 0.26291347E-09_JPRB, &
  & 0.26291952E-09_JPRB, 0.26292499E-09_JPRB, 0.26292807E-09_JPRB, 0.26293179E-09_JPRB, 0.26293334E-09_JPRB, 0.26293528E-09_JPRB, &
  & 0.26293528E-09_JPRB, 0.26293773E-09_JPRB, 0.26293950E-09_JPRB, 0.26294186E-09_JPRB, 0.26294367E-09_JPRB, 0.26294178E-09_JPRB, &
  & 0.26293714E-09_JPRB, 0.26293631E-09_JPRB, 0.26293584E-09_JPRB, 0.26293653E-09_JPRB, 0.26294131E-09_JPRB, 0.26295133E-09_JPRB, &
  & 0.26296312E-09_JPRB, 0.26296976E-09_JPRB, 0.26297822E-09_JPRB, 0.26298067E-09_JPRB, 0.26298447E-09_JPRB, 0.26298655E-09_JPRB, &
  & 0.26298883E-09_JPRB, 0.26298913E-09_JPRB, 0.26299007E-09_JPRB, 0.26298513E-09_JPRB, 0.26298319E-09_JPRB, 0.26297983E-09_JPRB, &
  & 0.26297348E-09_JPRB, 0.26296570E-09_JPRB, 0.26296060E-09_JPRB, 0.26295593E-09_JPRB, 0.26295288E-09_JPRB, 0.26295080E-09_JPRB, &
  & 0.26295166E-09_JPRB, 0.26295160E-09_JPRB, 0.26295316E-09_JPRB, 0.26295860E-09_JPRB, 0.26296040E-09_JPRB, 0.26295827E-09_JPRB, &
  & 0.26295882E-09_JPRB, 0.26295677E-09_JPRB, 0.26295749E-09_JPRB, 0.26295946E-09_JPRB, 0.26295377E-09_JPRB, 0.26295263E-09_JPRB, &
  & 0.26295072E-09_JPRB, 0.26294925E-09_JPRB, 0.26294586E-09_JPRB, 0.26294220E-09_JPRB, 0.26293706E-09_JPRB, 0.26293334E-09_JPRB, &
  & 0.26293168E-09_JPRB, 0.26293140E-09_JPRB, 0.26292546E-09_JPRB, 0.26292829E-09_JPRB /)

RGHG5(:,88, 5) = (/ &
  & 0.26287680E-09_JPRB, 0.26288091E-09_JPRB, 0.26289504E-09_JPRB, 0.26290051E-09_JPRB, 0.26290872E-09_JPRB, 0.26291291E-09_JPRB, &
  & 0.26292113E-09_JPRB, 0.26292479E-09_JPRB, 0.26292943E-09_JPRB, 0.26293159E-09_JPRB, 0.26293426E-09_JPRB, 0.26293534E-09_JPRB, &
  & 0.26293573E-09_JPRB, 0.26293751E-09_JPRB, 0.26293950E-09_JPRB, 0.26294175E-09_JPRB, 0.26294358E-09_JPRB, 0.26294203E-09_JPRB, &
  & 0.26293739E-09_JPRB, 0.26293656E-09_JPRB, 0.26293603E-09_JPRB, 0.26293667E-09_JPRB, 0.26294142E-09_JPRB, 0.26295141E-09_JPRB, &
  & 0.26296332E-09_JPRB, 0.26296992E-09_JPRB, 0.26297839E-09_JPRB, 0.26298072E-09_JPRB, 0.26298452E-09_JPRB, 0.26298655E-09_JPRB, &
  & 0.26298883E-09_JPRB, 0.26298916E-09_JPRB, 0.26299024E-09_JPRB, 0.26298519E-09_JPRB, 0.26298341E-09_JPRB, 0.26298039E-09_JPRB, &
  & 0.26297392E-09_JPRB, 0.26296609E-09_JPRB, 0.26296071E-09_JPRB, 0.26295574E-09_JPRB, 0.26295263E-09_JPRB, 0.26295033E-09_JPRB, &
  & 0.26295169E-09_JPRB, 0.26295152E-09_JPRB, 0.26295302E-09_JPRB, 0.26295899E-09_JPRB, 0.26296054E-09_JPRB, 0.26295838E-09_JPRB, &
  & 0.26295890E-09_JPRB, 0.26295688E-09_JPRB, 0.26295757E-09_JPRB, 0.26295949E-09_JPRB, 0.26295388E-09_JPRB, 0.26295274E-09_JPRB, &
  & 0.26295086E-09_JPRB, 0.26294941E-09_JPRB, 0.26294605E-09_JPRB, 0.26294242E-09_JPRB, 0.26293714E-09_JPRB, 0.26293356E-09_JPRB, &
  & 0.26293190E-09_JPRB, 0.26293168E-09_JPRB, 0.26292563E-09_JPRB, 0.26292851E-09_JPRB /)

RGHG5(:,89, 5) = (/ &
  & 0.26287758E-09_JPRB, 0.26288205E-09_JPRB, 0.26289482E-09_JPRB, 0.26290053E-09_JPRB, 0.26290831E-09_JPRB, 0.26291369E-09_JPRB, &
  & 0.26292016E-09_JPRB, 0.26292554E-09_JPRB, 0.26292896E-09_JPRB, 0.26293234E-09_JPRB, 0.26293387E-09_JPRB, 0.26293545E-09_JPRB, &
  & 0.26293553E-09_JPRB, 0.26293778E-09_JPRB, 0.26293956E-09_JPRB, 0.26294200E-09_JPRB, 0.26294397E-09_JPRB, 0.26294217E-09_JPRB, &
  & 0.26293734E-09_JPRB, 0.26293664E-09_JPRB, 0.26293615E-09_JPRB, 0.26293667E-09_JPRB, 0.26294142E-09_JPRB, 0.26295147E-09_JPRB, &
  & 0.26296340E-09_JPRB, 0.26296995E-09_JPRB, 0.26297847E-09_JPRB, 0.26298075E-09_JPRB, 0.26298461E-09_JPRB, 0.26298658E-09_JPRB, &
  & 0.26298891E-09_JPRB, 0.26298921E-09_JPRB, 0.26299035E-09_JPRB, 0.26298516E-09_JPRB, 0.26298352E-09_JPRB, 0.26298075E-09_JPRB, &
  & 0.26297448E-09_JPRB, 0.26296615E-09_JPRB, 0.26296096E-09_JPRB, 0.26295563E-09_JPRB, 0.26295238E-09_JPRB, 0.26294975E-09_JPRB, &
  & 0.26295185E-09_JPRB, 0.26295147E-09_JPRB, 0.26295305E-09_JPRB, 0.26295924E-09_JPRB, 0.26296068E-09_JPRB, 0.26295843E-09_JPRB, &
  & 0.26295893E-09_JPRB, 0.26295696E-09_JPRB, 0.26295757E-09_JPRB, 0.26295954E-09_JPRB, 0.26295391E-09_JPRB, 0.26295277E-09_JPRB, &
  & 0.26295091E-09_JPRB, 0.26294950E-09_JPRB, 0.26294616E-09_JPRB, 0.26294256E-09_JPRB, 0.26293720E-09_JPRB, 0.26293365E-09_JPRB, &
  & 0.26293201E-09_JPRB, 0.26293184E-09_JPRB, 0.26292565E-09_JPRB, 0.26292860E-09_JPRB /)

RGHG5(:,90, 5) = (/ &
  & 0.26287836E-09_JPRB, 0.26288324E-09_JPRB, 0.26289404E-09_JPRB, 0.26290009E-09_JPRB, 0.26290825E-09_JPRB, 0.26291194E-09_JPRB, &
  & 0.26292024E-09_JPRB, 0.26292443E-09_JPRB, 0.26292957E-09_JPRB, 0.26293223E-09_JPRB, 0.26293462E-09_JPRB, 0.26293556E-09_JPRB, &
  & 0.26293534E-09_JPRB, 0.26293756E-09_JPRB, 0.26293967E-09_JPRB, 0.26294253E-09_JPRB, 0.26294486E-09_JPRB, 0.26294264E-09_JPRB, &
  & 0.26293692E-09_JPRB, 0.26293667E-09_JPRB, 0.26293617E-09_JPRB, 0.26293662E-09_JPRB, 0.26294128E-09_JPRB, 0.26295147E-09_JPRB, &
  & 0.26296360E-09_JPRB, 0.26296998E-09_JPRB, 0.26297875E-09_JPRB, 0.26298075E-09_JPRB, 0.26298469E-09_JPRB, 0.26298660E-09_JPRB, &
  & 0.26298899E-09_JPRB, 0.26298921E-09_JPRB, 0.26299060E-09_JPRB, 0.26298502E-09_JPRB, 0.26298363E-09_JPRB, 0.26298105E-09_JPRB, &
  & 0.26297475E-09_JPRB, 0.26296623E-09_JPRB, 0.26296113E-09_JPRB, 0.26295541E-09_JPRB, 0.26295227E-09_JPRB, 0.26294911E-09_JPRB, &
  & 0.26295208E-09_JPRB, 0.26295133E-09_JPRB, 0.26295288E-09_JPRB, 0.26295954E-09_JPRB, 0.26296090E-09_JPRB, 0.26295846E-09_JPRB, &
  & 0.26295904E-09_JPRB, 0.26295693E-09_JPRB, 0.26295760E-09_JPRB, 0.26295979E-09_JPRB, 0.26295385E-09_JPRB, 0.26295277E-09_JPRB, &
  & 0.26295091E-09_JPRB, 0.26294958E-09_JPRB, 0.26294622E-09_JPRB, 0.26294264E-09_JPRB, 0.26293717E-09_JPRB, 0.26293365E-09_JPRB, &
  & 0.26293204E-09_JPRB, 0.26293204E-09_JPRB, 0.26292551E-09_JPRB, 0.26292868E-09_JPRB /)

RGHG5(:,91, 5) = (/ &
  & 0.26287866E-09_JPRB, 0.26288369E-09_JPRB, 0.26289229E-09_JPRB, 0.26290004E-09_JPRB, 0.26290850E-09_JPRB, 0.26291064E-09_JPRB, &
  & 0.26291902E-09_JPRB, 0.26292230E-09_JPRB, 0.26292837E-09_JPRB, 0.26293234E-09_JPRB, 0.26293703E-09_JPRB, 0.26293759E-09_JPRB, &
  & 0.26293109E-09_JPRB, 0.26293895E-09_JPRB, 0.26293989E-09_JPRB, 0.26294342E-09_JPRB, 0.26294655E-09_JPRB, 0.26294303E-09_JPRB, &
  & 0.26293603E-09_JPRB, 0.26293667E-09_JPRB, 0.26293609E-09_JPRB, 0.26293631E-09_JPRB, 0.26294092E-09_JPRB, 0.26295130E-09_JPRB, &
  & 0.26296404E-09_JPRB, 0.26296981E-09_JPRB, 0.26297919E-09_JPRB, 0.26298058E-09_JPRB, 0.26298483E-09_JPRB, 0.26298658E-09_JPRB, &
  & 0.26298916E-09_JPRB, 0.26298913E-09_JPRB, 0.26299121E-09_JPRB, 0.26298461E-09_JPRB, 0.26298372E-09_JPRB, 0.26298136E-09_JPRB, &
  & 0.26297498E-09_JPRB, 0.26296595E-09_JPRB, 0.26296126E-09_JPRB, 0.26295521E-09_JPRB, 0.26295227E-09_JPRB, 0.26294850E-09_JPRB, &
  & 0.26295244E-09_JPRB, 0.26295105E-09_JPRB, 0.26295247E-09_JPRB, 0.26296001E-09_JPRB, 0.26296151E-09_JPRB, 0.26295813E-09_JPRB, &
  & 0.26295929E-09_JPRB, 0.26295657E-09_JPRB, 0.26295741E-09_JPRB, 0.26296049E-09_JPRB, 0.26295341E-09_JPRB, 0.26295285E-09_JPRB, &
  & 0.26295091E-09_JPRB, 0.26294977E-09_JPRB, 0.26294625E-09_JPRB, 0.26294270E-09_JPRB, 0.26293695E-09_JPRB, 0.26293345E-09_JPRB, &
  & 0.26293195E-09_JPRB, 0.26293229E-09_JPRB, 0.26292507E-09_JPRB, 0.26292871E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART10',1,ZHOOK_HANDLE)
END SUBROUTINE PART10






SUBROUTINE PART11
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART11',0,ZHOOK_HANDLE)



!-- Month=  6 ------------

RGHG5(:, 1, 6) = (/ &
  & 0.56051939E-44_JPRB, 0.37835059E-43_JPRB, 0.63058431E-43_JPRB, 0.72867520E-43_JPRB, 0.78472714E-43_JPRB, 0.84077908E-43_JPRB, &
  & 0.93886997E-43_JPRB, 0.11210388E-42_JPRB, 0.14713634E-42_JPRB, 0.21019477E-42_JPRB, 0.31949605E-42_JPRB, 0.51007264E-42_JPRB, &
  & 0.84498297E-42_JPRB, 0.14083050E-41_JPRB, 0.23667931E-41_JPRB, 0.38129331E-41_JPRB, 0.60101691E-41_JPRB, 0.89935335E-41_JPRB, &
  & 0.12984432E-40_JPRB, 0.18113184E-40_JPRB, 0.24933304E-40_JPRB, 0.34229518E-40_JPRB, 0.47167706E-40_JPRB, 0.65576564E-40_JPRB, &
  & 0.92313339E-40_JPRB, 0.13291316E-39_JPRB, 0.19285370E-39_JPRB, 0.26756533E-39_JPRB, 0.39619612E-39_JPRB, 0.54731775E-39_JPRB, &
  & 0.81368077E-39_JPRB, 0.11082505E-38_JPRB, 0.18726014E-38_JPRB, 0.22703445E-38_JPRB, 0.23898739E-38_JPRB, 0.24390959E-38_JPRB, &
  & 0.11663428E-38_JPRB, 0.12139014E-38_JPRB, 0.49170022E-39_JPRB, 0.49765293E-39_JPRB, 0.29497193E-39_JPRB, 0.19588191E-39_JPRB, &
  & 0.11119303E-39_JPRB, 0.59500534E-40_JPRB, 0.29530964E-40_JPRB, 0.13348769E-40_JPRB, 0.54986952E-41_JPRB, 0.21790191E-41_JPRB, &
  & 0.80434532E-42_JPRB, 0.30408177E-42_JPRB, 0.11210388E-42_JPRB, 0.35032462E-43_JPRB, 0.16815582E-43_JPRB, 0.84077908E-44_JPRB, &
  & 0.42038954E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB /)

RGHG5(:, 2, 6) = (/ &
  & 0.42179084E-42_JPRB, 0.14797712E-41_JPRB, 0.24270489E-41_JPRB, 0.28950826E-41_JPRB, 0.31557241E-41_JPRB, 0.34205696E-41_JPRB, &
  & 0.38521695E-41_JPRB, 0.46607187E-41_JPRB, 0.61418912E-41_JPRB, 0.87735297E-41_JPRB, 0.13396413E-40_JPRB, 0.21453879E-40_JPRB, &
  & 0.35501897E-40_JPRB, 0.58993264E-40_JPRB, 0.98263252E-40_JPRB, 0.15748072E-39_JPRB, 0.24624037E-39_JPRB, 0.36655586E-39_JPRB, &
  & 0.52677612E-39_JPRB, 0.73328407E-39_JPRB, 0.10079274E-38_JPRB, 0.13824552E-38_JPRB, 0.19051003E-38_JPRB, 0.26535997E-38_JPRB, &
  & 0.37431639E-38_JPRB, 0.53694604E-38_JPRB, 0.76982980E-38_JPRB, 0.10799817E-37_JPRB, 0.15770709E-37_JPRB, 0.22084785E-37_JPRB, &
  & 0.32514177E-37_JPRB, 0.45579122E-37_JPRB, 0.73591487E-37_JPRB, 0.89667945E-37_JPRB, 0.94692441E-37_JPRB, 0.92920992E-37_JPRB, &
  & 0.50575810E-37_JPRB, 0.45752300E-37_JPRB, 0.22259615E-37_JPRB, 0.19718558E-37_JPRB, 0.11968464E-37_JPRB, 0.78727246E-38_JPRB, &
  & 0.44883380E-38_JPRB, 0.24148198E-38_JPRB, 0.12100282E-38_JPRB, 0.55693346E-39_JPRB, 0.23739678E-39_JPRB, 0.96472393E-40_JPRB, &
  & 0.36827525E-40_JPRB, 0.13906486E-40_JPRB, 0.51245485E-41_JPRB, 0.17292023E-41_JPRB, 0.75389857E-42_JPRB, 0.36854150E-42_JPRB, &
  & 0.19758308E-42_JPRB, 0.11210388E-42_JPRB, 0.64459729E-43_JPRB, 0.37835059E-43_JPRB, 0.28025969E-43_JPRB, 0.36433760E-43_JPRB, &
  & 0.49045446E-43_JPRB, 0.98090893E-43_JPRB, 0.93886997E-43_JPRB, 0.12611686E-43_JPRB /)

RGHG5(:, 3, 6) = (/ &
  & 0.17577888E-40_JPRB, 0.74336081E-40_JPRB, 0.12214558E-39_JPRB, 0.14411654E-39_JPRB, 0.15513635E-39_JPRB, 0.16634113E-39_JPRB, &
  & 0.18605600E-39_JPRB, 0.22390367E-39_JPRB, 0.29359305E-39_JPRB, 0.41824555E-39_JPRB, 0.63693499E-39_JPRB, 0.10187608E-38_JPRB, &
  & 0.16864473E-38_JPRB, 0.28019748E-38_JPRB, 0.46773437E-38_JPRB, 0.74983018E-38_JPRB, 0.11749186E-37_JPRB, 0.17503925E-37_JPRB, &
  & 0.25176163E-37_JPRB, 0.35050639E-37_JPRB, 0.48190150E-37_JPRB, 0.66117488E-37_JPRB, 0.91166057E-37_JPRB, 0.12689453E-36_JPRB, &
  & 0.17898422E-36_JPRB, 0.25542824E-36_JPRB, 0.36456463E-36_JPRB, 0.51191496E-36_JPRB, 0.74500923E-36_JPRB, 0.10486015E-35_JPRB, &
  & 0.15418757E-35_JPRB, 0.21811872E-35_JPRB, 0.34763721E-35_JPRB, 0.42423788E-35_JPRB, 0.44809222E-35_JPRB, 0.43465288E-35_JPRB, &
  & 0.24660023E-35_JPRB, 0.21608991E-35_JPRB, 0.10972881E-35_JPRB, 0.95604733E-36_JPRB, 0.57339788E-36_JPRB, 0.37426485E-36_JPRB, &
  & 0.20765822E-36_JPRB, 0.10882460E-36_JPRB, 0.53561327E-37_JPRB, 0.24554112E-37_JPRB, 0.10740647E-37_JPRB, 0.45185556E-38_JPRB, &
  & 0.18063564E-38_JPRB, 0.69773033E-39_JPRB, 0.26273505E-39_JPRB, 0.90710253E-40_JPRB, 0.38779534E-40_JPRB, 0.18595231E-40_JPRB, &
  & 0.98777529E-41_JPRB, 0.55435367E-41_JPRB, 0.31865527E-41_JPRB, 0.18469114E-41_JPRB, 0.13494504E-41_JPRB, 0.17628335E-41_JPRB, &
  & 0.25321463E-41_JPRB, 0.49914251E-41_JPRB, 0.55463393E-41_JPRB, 0.11392557E-41_JPRB /)

RGHG5(:, 4, 6) = (/ &
  & 0.21217466E-38_JPRB, 0.85863540E-38_JPRB, 0.12781295E-37_JPRB, 0.14413033E-37_JPRB, 0.15135943E-37_JPRB, 0.16050037E-37_JPRB, &
  & 0.17816640E-37_JPRB, 0.21280512E-37_JPRB, 0.27722319E-37_JPRB, 0.39189573E-37_JPRB, 0.59391603E-37_JPRB, 0.94586727E-37_JPRB, &
  & 0.15627469E-36_JPRB, 0.25885059E-36_JPRB, 0.43208341E-36_JPRB, 0.69051459E-36_JPRB, 0.10810579E-35_JPRB, 0.16058993E-35_JPRB, &
  & 0.23026470E-35_JPRB, 0.31911698E-35_JPRB, 0.43653325E-35_JPRB, 0.59538610E-35_JPRB, 0.81509563E-35_JPRB, 0.11264795E-34_JPRB, &
  & 0.15746246E-34_JPRB, 0.22324865E-34_JPRB, 0.31684271E-34_JPRB, 0.44420221E-34_JPRB, 0.64687179E-34_JPRB, 0.91158680E-34_JPRB, &
  & 0.13442253E-33_JPRB, 0.19030124E-33_JPRB, 0.30407725E-33_JPRB, 0.37170869E-33_JPRB, 0.39295197E-33_JPRB, 0.38032656E-33_JPRB, &
  & 0.21927899E-33_JPRB, 0.19092595E-33_JPRB, 0.99331385E-34_JPRB, 0.86750306E-34_JPRB, 0.51622713E-34_JPRB, 0.33758872E-34_JPRB, &
  & 0.18226944E-34_JPRB, 0.93676905E-35_JPRB, 0.45565240E-35_JPRB, 0.20963145E-35_JPRB, 0.93392233E-36_JPRB, 0.40572097E-36_JPRB, &
  & 0.16537529E-36_JPRB, 0.65111154E-37_JPRB, 0.24639261E-37_JPRB, 0.85567348E-38_JPRB, 0.36751743E-38_JPRB, 0.17740579E-38_JPRB, &
  & 0.94536639E-39_JPRB, 0.53337764E-39_JPRB, 0.30682551E-39_JPRB, 0.17711432E-39_JPRB, 0.12874710E-39_JPRB, 0.17252226E-39_JPRB, &
  & 0.25675151E-39_JPRB, 0.55594835E-39_JPRB, 0.78143969E-39_JPRB, 0.43256122E-39_JPRB /)

RGHG5(:, 5, 6) = (/ &
  & 0.12824117E-35_JPRB, 0.26054815E-35_JPRB, 0.32402544E-35_JPRB, 0.34288390E-35_JPRB, 0.35449284E-35_JPRB, 0.37336650E-35_JPRB, &
  & 0.41186286E-35_JPRB, 0.48815316E-35_JPRB, 0.62891911E-35_JPRB, 0.88019344E-35_JPRB, 0.13182528E-34_JPRB, 0.20755046E-34_JPRB, &
  & 0.33894054E-34_JPRB, 0.55384208E-34_JPRB, 0.91205574E-34_JPRB, 0.14342156E-33_JPRB, 0.22091993E-33_JPRB, 0.32234975E-33_JPRB, &
  & 0.45363062E-33_JPRB, 0.61628345E-33_JPRB, 0.82576201E-33_JPRB, 0.11024557E-32_JPRB, 0.14769606E-32_JPRB, 0.19972277E-32_JPRB, &
  & 0.27384555E-32_JPRB, 0.38169587E-32_JPRB, 0.53555787E-32_JPRB, 0.74497836E-32_JPRB, 0.10826199E-31_JPRB, 0.15231067E-31_JPRB, &
  & 0.22463800E-31_JPRB, 0.31796282E-31_JPRB, 0.51104564E-31_JPRB, 0.62676994E-31_JPRB, 0.66651893E-31_JPRB, 0.65012002E-31_JPRB, &
  & 0.37787256E-31_JPRB, 0.33340867E-31_JPRB, 0.17698850E-31_JPRB, 0.15726278E-31_JPRB, 0.94806037E-32_JPRB, 0.62927181E-32_JPRB, &
  & 0.34171187E-32_JPRB, 0.17678004E-32_JPRB, 0.87216905E-33_JPRB, 0.40939961E-33_JPRB, 0.18744560E-33_JPRB, 0.83363993E-34_JPRB, &
  & 0.34757270E-34_JPRB, 0.13831145E-34_JPRB, 0.52868181E-35_JPRB, 0.18398402E-35_JPRB, 0.80725841E-36_JPRB, 0.39727399E-36_JPRB, &
  & 0.21539262E-36_JPRB, 0.12283121E-36_JPRB, 0.71132264E-37_JPRB, 0.40734373E-37_JPRB, 0.29149107E-37_JPRB, 0.39787168E-37_JPRB, &
  & 0.59990641E-37_JPRB, 0.14451564E-36_JPRB, 0.25738369E-36_JPRB, 0.43164988E-36_JPRB /)

RGHG5(:, 6, 6) = (/ &
  & 0.11246294E-32_JPRB, 0.16142785E-32_JPRB, 0.17754134E-32_JPRB, 0.18369182E-32_JPRB, 0.18822388E-32_JPRB, 0.19638011E-32_JPRB, &
  & 0.21391018E-32_JPRB, 0.24920524E-32_JPRB, 0.31447402E-32_JPRB, 0.42869706E-32_JPRB, 0.62388812E-32_JPRB, 0.95105038E-32_JPRB, &
  & 0.14998744E-31_JPRB, 0.23584926E-31_JPRB, 0.37311642E-31_JPRB, 0.56194184E-31_JPRB, 0.82798989E-31_JPRB, 0.11540623E-30_JPRB, &
  & 0.15506332E-30_JPRB, 0.20117864E-30_JPRB, 0.25772253E-30_JPRB, 0.32964628E-30_JPRB, 0.42424071E-30_JPRB, 0.55290731E-30_JPRB, &
  & 0.73320294E-30_JPRB, 0.99381577E-30_JPRB, 0.13633699E-29_JPRB, 0.18633173E-29_JPRB, 0.26803600E-29_JPRB, 0.37386957E-29_JPRB, &
  & 0.54992304E-29_JPRB, 0.77615947E-29_JPRB, 0.12540211E-28_JPRB, 0.15491652E-28_JPRB, 0.16665397E-28_JPRB, 0.16538168E-28_JPRB, &
  & 0.97349770E-29_JPRB, 0.88524550E-29_JPRB, 0.47938134E-29_JPRB, 0.44405768E-29_JPRB, 0.27529088E-29_JPRB, 0.19052461E-29_JPRB, &
  & 0.10710812E-29_JPRB, 0.57935603E-30_JPRB, 0.29961442E-30_JPRB, 0.14764423E-30_JPRB, 0.71032250E-31_JPRB, 0.33163740E-31_JPRB, &
  & 0.14422168E-31_JPRB, 0.59721108E-32_JPRB, 0.23620734E-32_JPRB, 0.84713295E-33_JPRB, 0.38855171E-33_JPRB, 0.19904536E-33_JPRB, &
  & 0.11158044E-33_JPRB, 0.65317279E-34_JPRB, 0.38416418E-34_JPRB, 0.22003583E-34_JPRB, 0.15287218E-34_JPRB, 0.20477229E-34_JPRB, &
  & 0.29064933E-34_JPRB, 0.68082211E-34_JPRB, 0.11477433E-33_JPRB, 0.14514405E-33_JPRB /)

RGHG5(:, 7, 6) = (/ &
  & 0.87291891E-30_JPRB, 0.11747133E-29_JPRB, 0.12708885E-29_JPRB, 0.13050666E-29_JPRB, 0.13244208E-29_JPRB, 0.13632853E-29_JPRB, &
  & 0.14581345E-29_JPRB, 0.16573092E-29_JPRB, 0.20259963E-29_JPRB, 0.26588857E-29_JPRB, 0.37021696E-29_JPRB, 0.53740540E-29_JPRB, &
  & 0.80370862E-29_JPRB, 0.11942355E-28_JPRB, 0.17813829E-28_JPRB, 0.25240923E-28_JPRB, 0.34959288E-28_JPRB, 0.45776412E-28_JPRB, &
  & 0.57821996E-28_JPRB, 0.70629208E-28_JPRB, 0.85445501E-28_JPRB, 0.10365815E-27_JPRB, 0.12716493E-27_JPRB, 0.15879846E-27_JPRB, &
  & 0.20280208E-27_JPRB, 0.26611402E-27_JPRB, 0.35531421E-27_JPRB, 0.47491439E-27_JPRB, 0.67239838E-27_JPRB, 0.92726584E-27_JPRB, &
  & 0.13556480E-26_JPRB, 0.19081544E-26_JPRB, 0.30974496E-26_JPRB, 0.38576230E-26_JPRB, 0.42136065E-26_JPRB, 0.42806235E-26_JPRB, &
  & 0.25407550E-26_JPRB, 0.24150145E-26_JPRB, 0.13208884E-26_JPRB, 0.13008455E-26_JPRB, 0.83415252E-27_JPRB, 0.60761544E-27_JPRB, &
  & 0.35980512E-27_JPRB, 0.20640379E-27_JPRB, 0.11375836E-27_JPRB, 0.59941717E-28_JPRB, 0.30838023E-28_JPRB, 0.15394304E-28_JPRB, &
  & 0.71486495E-29_JPRB, 0.31523358E-29_JPRB, 0.13251881E-29_JPRB, 0.50295900E-30_JPRB, 0.24642532E-30_JPRB, 0.13395621E-30_JPRB, &
  & 0.79062110E-31_JPRB, 0.48331341E-31_JPRB, 0.29353878E-31_JPRB, 0.16969904E-31_JPRB, 0.11649427E-31_JPRB, 0.15077064E-31_JPRB, &
  & 0.20376908E-31_JPRB, 0.47057240E-31_JPRB, 0.80593450E-31_JPRB, 0.14279502E-30_JPRB /)

RGHG5(:, 8, 6) = (/ &
  & 0.55665996E-27_JPRB, 0.74336274E-27_JPRB, 0.80079849E-27_JPRB, 0.81758798E-27_JPRB, 0.82285598E-27_JPRB, 0.83720762E-27_JPRB, &
  & 0.88003308E-27_JPRB, 0.97800119E-27_JPRB, 0.11603479E-26_JPRB, 0.14675004E-26_JPRB, 0.19570988E-26_JPRB, 0.27055181E-26_JPRB, &
  & 0.38378037E-26_JPRB, 0.53829442E-26_JPRB, 0.75740084E-26_JPRB, 0.10087095E-25_JPRB, 0.13138267E-25_JPRB, 0.16161409E-25_JPRB, &
  & 0.19195024E-25_JPRB, 0.22069133E-25_JPRB, 0.25200456E-25_JPRB, 0.28974177E-25_JPRB, 0.33858853E-25_JPRB, 0.40489321E-25_JPRB, &
  & 0.49775940E-25_JPRB, 0.63204355E-25_JPRB, 0.82039131E-25_JPRB, 0.10712144E-24_JPRB, 0.14898331E-24_JPRB, 0.20303280E-24_JPRB, &
  & 0.29462572E-24_JPRB, 0.41446328E-24_JPRB, 0.67449959E-24_JPRB, 0.84869462E-24_JPRB, 0.94146812E-24_JPRB, 0.98016303E-24_JPRB, &
  & 0.58697730E-24_JPRB, 0.58524915E-24_JPRB, 0.32207919E-24_JPRB, 0.33977701E-24_JPRB, 0.22484488E-24_JPRB, 0.17345544E-24_JPRB, &
  & 0.10804601E-24_JPRB, 0.65931657E-25_JPRB, 0.38815263E-25_JPRB, 0.21883854E-25_JPRB, 0.12081765E-25_JPRB, 0.64762799E-26_JPRB, &
  & 0.32254373E-26_JPRB, 0.15254137E-26_JPRB, 0.68631520E-27_JPRB, 0.27776741E-27_JPRB, 0.14635762E-27_JPRB, 0.84839014E-28_JPRB, &
  & 0.53026629E-28_JPRB, 0.34033662E-28_JPRB, 0.21520490E-28_JPRB, 0.12796902E-28_JPRB, 0.88371581E-29_JPRB, 0.11379004E-28_JPRB, &
  & 0.15115050E-28_JPRB, 0.34706515E-28_JPRB, 0.62282348E-28_JPRB, 0.12583730E-27_JPRB /)

RGHG5(:, 9, 6) = (/ &
  & 0.28645679E-24_JPRB, 0.38123986E-24_JPRB, 0.40925246E-24_JPRB, 0.41598184E-24_JPRB, 0.41606274E-24_JPRB, 0.41926764E-24_JPRB, &
  & 0.43518878E-24_JPRB, 0.47425622E-24_JPRB, 0.54927221E-24_JPRB, 0.67321971E-24_JPRB, 0.86483008E-24_JPRB, 0.11452043E-23_JPRB, &
  & 0.15483782E-23_JPRB, 0.20611851E-23_JPRB, 0.27462800E-23_JPRB, 0.34543982E-23_JPRB, 0.42493365E-23_JPRB, 0.49322731E-23_JPRB, &
  & 0.55311669E-23_JPRB, 0.60066622E-23_JPRB, 0.64906063E-23_JPRB, 0.70833430E-23_JPRB, 0.78872467E-23_JPRB, 0.90287205E-23_JPRB, &
  & 0.10674766E-22_JPRB, 0.13097962E-22_JPRB, 0.16507972E-22_JPRB, 0.21028025E-22_JPRB, 0.28693834E-22_JPRB, 0.38596692E-22_JPRB, &
  & 0.55630774E-22_JPRB, 0.78115859E-22_JPRB, 0.12776921E-21_JPRB, 0.16235294E-21_JPRB, 0.18301688E-21_JPRB, 0.19500908E-21_JPRB, &
  & 0.11849552E-21_JPRB, 0.12343247E-21_JPRB, 0.68982743E-22_JPRB, 0.77525842E-22_JPRB, 0.53249506E-22_JPRB, 0.43461765E-22_JPRB, &
  & 0.28550880E-22_JPRB, 0.18517601E-22_JPRB, 0.11632246E-22_JPRB, 0.70171134E-23_JPRB, 0.41547387E-23_JPRB, 0.23909449E-23_JPRB, &
  & 0.12779988E-23_JPRB, 0.64838987E-24_JPRB, 0.31264111E-24_JPRB, 0.13501273E-24_JPRB, 0.76640881E-25_JPRB, 0.47415948E-25_JPRB, &
  & 0.31369303E-25_JPRB, 0.21172044E-25_JPRB, 0.13974116E-25_JPRB, 0.86051289E-26_JPRB, 0.61118717E-26_JPRB, 0.79653319E-26_JPRB, &
  & 0.10674213E-25_JPRB, 0.24721858E-25_JPRB, 0.45249071E-25_JPRB, 0.96529495E-25_JPRB /)

RGHG5(:,10, 6) = (/ &
  & 0.11825165E-21_JPRB, 0.15681989E-21_JPRB, 0.16786536E-21_JPRB, 0.17005015E-21_JPRB, 0.16927381E-21_JPRB, 0.16942091E-21_JPRB, &
  & 0.17387711E-21_JPRB, 0.18696544E-21_JPRB, 0.21211303E-21_JPRB, 0.25342201E-21_JPRB, 0.31542637E-21_JPRB, 0.40240022E-21_JPRB, &
  & 0.52162704E-21_JPRB, 0.66229722E-21_JPRB, 0.83996597E-21_JPRB, 0.10022673E-20_JPRB, 0.11698446E-20_JPRB, 0.12866619E-20_JPRB, &
  & 0.13679035E-20_JPRB, 0.14080149E-20_JPRB, 0.14439136E-20_JPRB, 0.14983991E-20_JPRB, 0.15911558E-20_JPRB, 0.17428722E-20_JPRB, &
  & 0.19795044E-20_JPRB, 0.23438647E-20_JPRB, 0.28630710E-20_JPRB, 0.35542158E-20_JPRB, 0.47527524E-20_JPRB, 0.63089158E-20_JPRB, &
  & 0.90214386E-20_JPRB, 0.12668058E-19_JPRB, 0.20798920E-19_JPRB, 0.26718055E-19_JPRB, 0.30601217E-19_JPRB, 0.33313811E-19_JPRB, &
  & 0.20682391E-19_JPRB, 0.22368238E-19_JPRB, 0.12858176E-19_JPRB, 0.15252154E-19_JPRB, 0.10934952E-19_JPRB, 0.94448589E-20_JPRB, &
  & 0.65531332E-20_JPRB, 0.45220316E-20_JPRB, 0.30319926E-20_JPRB, 0.19570005E-20_JPRB, 0.12426293E-20_JPRB, 0.76821380E-21_JPRB, &
  & 0.44047246E-21_JPRB, 0.23989366E-21_JPRB, 0.12393536E-21_JPRB, 0.57142168E-22_JPRB, 0.34925059E-22_JPRB, 0.23035745E-22_JPRB, &
  & 0.16124162E-22_JPRB, 0.11425652E-22_JPRB, 0.78717180E-23_JPRB, 0.50310701E-23_JPRB, 0.36950635E-23_JPRB, 0.49335420E-23_JPRB, &
  & 0.67294245E-23_JPRB, 0.15723415E-22_JPRB, 0.29180618E-22_JPRB, 0.63262240E-22_JPRB /)

RGHG5(:,11, 6) = (/ &
  & 0.39954614E-19_JPRB, 0.52836872E-19_JPRB, 0.56415295E-19_JPRB, 0.56977926E-19_JPRB, 0.56475091E-19_JPRB, 0.56174701E-19_JPRB, &
  & 0.57177076E-19_JPRB, 0.60605346E-19_JPRB, 0.67597406E-19_JPRB, 0.78844439E-19_JPRB, 0.95319460E-19_JPRB, 0.11748953E-18_JPRB, &
  & 0.14640763E-18_JPRB, 0.17792424E-18_JPRB, 0.21536361E-18_JPRB, 0.24466413E-18_JPRB, 0.27174320E-18_JPRB, 0.28416133E-18_JPRB, &
  & 0.28728934E-18_JPRB, 0.28116676E-18_JPRB, 0.27440044E-18_JPRB, 0.27140861E-18_JPRB, 0.27527726E-18_JPRB, 0.28879517E-18_JPRB, &
  & 0.31510685E-18_JPRB, 0.35969936E-18_JPRB, 0.42565233E-18_JPRB, 0.51444141E-18_JPRB, 0.67399772E-18_JPRB, 0.88194162E-18_JPRB, &
  & 0.12522304E-17_JPRB, 0.17549532E-17_JPRB, 0.28965272E-17_JPRB, 0.37584320E-17_JPRB, 0.43748317E-17_JPRB, 0.48632769E-17_JPRB, &
  & 0.30988254E-17_JPRB, 0.34692854E-17_JPRB, 0.20682015E-17_JPRB, 0.25750654E-17_JPRB, 0.19356101E-17_JPRB, 0.17675694E-17_JPRB, &
  & 0.12981484E-17_JPRB, 0.95347279E-18_JPRB, 0.68272717E-18_JPRB, 0.47166092E-18_JPRB, 0.32140602E-18_JPRB, 0.21329927E-18_JPRB, &
  & 0.13127539E-18_JPRB, 0.76674473E-19_JPRB, 0.42420135E-19_JPRB, 0.20868841E-19_JPRB, 0.13692232E-19_JPRB, 0.96006936E-20_JPRB, &
  & 0.70884823E-20_JPRB, 0.52598218E-20_JPRB, 0.37697783E-20_JPRB, 0.24943066E-20_JPRB, 0.18916086E-20_JPRB, 0.25872008E-20_JPRB, &
  & 0.35980870E-20_JPRB, 0.84893490E-20_JPRB, 0.15885711E-19_JPRB, 0.34671369E-19_JPRB /)

RGHG5(:,12, 6) = (/ &
  & 0.11213499E-16_JPRB, 0.14807140E-16_JPRB, 0.15776138E-16_JPRB, 0.15881739E-16_JPRB, 0.15671627E-16_JPRB, 0.15481512E-16_JPRB, &
  & 0.15600926E-16_JPRB, 0.16332592E-16_JPRB, 0.17869070E-16_JPRB, 0.20355755E-16_JPRB, 0.23909619E-16_JPRB, 0.28499314E-16_JPRB, &
  & 0.34202046E-16_JPRB, 0.39862304E-16_JPRB, 0.46162353E-16_JPRB, 0.50059303E-16_JPRB, 0.53039327E-16_JPRB, 0.52868782E-16_JPRB, &
  & 0.50955901E-16_JPRB, 0.47541709E-16_JPRB, 0.44259182E-16_JPRB, 0.41813785E-16_JPRB, 0.40578414E-16_JPRB, 0.40820228E-16_JPRB, &
  & 0.42816533E-16_JPRB, 0.47130270E-16_JPRB, 0.53995773E-16_JPRB, 0.63534115E-16_JPRB, 0.81480626E-16_JPRB, 0.10510011E-15_JPRB, &
  & 0.14793175E-15_JPRB, 0.20702580E-15_JPRB, 0.34284019E-15_JPRB, 0.44946999E-15_JPRB, 0.53185241E-15_JPRB, 0.60405223E-15_JPRB, &
  & 0.39593856E-15_JPRB, 0.45897348E-15_JPRB, 0.28480429E-15_JPRB, 0.37175956E-15_JPRB, 0.29354350E-15_JPRB, 0.28338406E-15_JPRB, &
  & 0.22048633E-15_JPRB, 0.17244897E-15_JPRB, 0.13188000E-15_JPRB, 0.97570420E-16_JPRB, 0.71326659E-16_JPRB, 0.50832833E-16_JPRB, &
  & 0.33555366E-16_JPRB, 0.21012677E-16_JPRB, 0.12434541E-16_JPRB, 0.65252804E-17_JPRB, 0.45808100E-17_JPRB, 0.34048545E-17_JPRB, &
  & 0.26440650E-17_JPRB, 0.20476045E-17_JPRB, 0.15211152E-17_JPRB, 0.10373813E-17_JPRB, 0.80817221E-18_JPRB, 0.11287575E-17_JPRB, &
  & 0.15937008E-17_JPRB, 0.37993655E-17_JPRB, 0.71615478E-17_JPRB, 0.15721588E-16_JPRB /)

RGHG5(:,13, 6) = (/ &
  & 0.19017982E-15_JPRB, 0.21635695E-15_JPRB, 0.21692947E-15_JPRB, 0.20984766E-15_JPRB, 0.20059609E-15_JPRB, 0.19313879E-15_JPRB, &
  & 0.19019488E-15_JPRB, 0.19535224E-15_JPRB, 0.21225269E-15_JPRB, 0.24256625E-15_JPRB, 0.28910500E-15_JPRB, 0.35096614E-15_JPRB, &
  & 0.43363767E-15_JPRB, 0.51372961E-15_JPRB, 0.61980900E-15_JPRB, 0.68260686E-15_JPRB, 0.75265452E-15_JPRB, 0.75572830E-15_JPRB, &
  & 0.75410406E-15_JPRB, 0.71702271E-15_JPRB, 0.68157877E-15_JPRB, 0.65139179E-15_JPRB, 0.63237818E-15_JPRB, 0.62927179E-15_JPRB, &
  & 0.64455607E-15_JPRB, 0.68055370E-15_JPRB, 0.74632819E-15_JPRB, 0.85626974E-15_JPRB, 0.96628460E-15_JPRB, 0.12427530E-14_JPRB, &
  & 0.14346808E-14_JPRB, 0.19992932E-14_JPRB, 0.28634775E-14_JPRB, 0.37386001E-14_JPRB, 0.39753255E-14_JPRB, 0.44413821E-14_JPRB, &
  & 0.28782226E-14_JPRB, 0.29946873E-14_JPRB, 0.22306721E-14_JPRB, 0.23210602E-14_JPRB, 0.16654648E-14_JPRB, 0.10288813E-14_JPRB, &
  & 0.11066029E-14_JPRB, 0.99462378E-15_JPRB, 0.77907830E-15_JPRB, 0.56522117E-15_JPRB, 0.44368443E-15_JPRB, 0.31782511E-15_JPRB, &
  & 0.21862681E-15_JPRB, 0.14212886E-15_JPRB, 0.86942903E-16_JPRB, 0.50992634E-16_JPRB, 0.41813765E-16_JPRB, 0.35535735E-16_JPRB, &
  & 0.30281646E-16_JPRB, 0.24727698E-16_JPRB, 0.19273292E-16_JPRB, 0.12824931E-16_JPRB, 0.13132943E-16_JPRB, 0.18669175E-16_JPRB, &
  & 0.25822896E-16_JPRB, 0.49738039E-16_JPRB, 0.90630540E-16_JPRB, 0.17228003E-15_JPRB /)

RGHG5(:,14, 6) = (/ &
  & 0.21727964E-14_JPRB, 0.21587073E-14_JPRB, 0.20383526E-14_JPRB, 0.18872309E-14_JPRB, 0.17391347E-14_JPRB, 0.16142196E-14_JPRB, &
  & 0.15388580E-14_JPRB, 0.15365513E-14_JPRB, 0.16354885E-14_JPRB, 0.18577535E-14_JPRB, 0.22239703E-14_JPRB, 0.27408186E-14_JPRB, &
  & 0.34395939E-14_JPRB, 0.42163055E-14_JPRB, 0.51155475E-14_JPRB, 0.59150860E-14_JPRB, 0.66191961E-14_JPRB, 0.70621990E-14_JPRB, &
  & 0.72894199E-14_JPRB, 0.73172610E-14_JPRB, 0.72754641E-14_JPRB, 0.72450794E-14_JPRB, 0.72559045E-14_JPRB, 0.73645839E-14_JPRB, &
  & 0.76234676E-14_JPRB, 0.80226632E-14_JPRB, 0.87097637E-14_JPRB, 0.95895302E-14_JPRB, 0.10677569E-13_JPRB, 0.12390819E-13_JPRB, &
  & 0.13680522E-13_JPRB, 0.15564993E-13_JPRB, 0.17290584E-13_JPRB, 0.20331976E-13_JPRB, 0.28850291E-13_JPRB, 0.26101908E-13_JPRB, &
  & 0.19558602E-13_JPRB, 0.15378479E-13_JPRB, 0.13661417E-13_JPRB, 0.10507660E-13_JPRB, 0.91900534E-14_JPRB, 0.83567949E-14_JPRB, &
  & 0.72790412E-14_JPRB, 0.57477818E-14_JPRB, 0.34799641E-14_JPRB, 0.31080195E-14_JPRB, 0.26267684E-14_JPRB, 0.19898123E-14_JPRB, &
  & 0.14607188E-14_JPRB, 0.95181855E-15_JPRB, 0.56415401E-15_JPRB, 0.38407600E-15_JPRB, 0.36552905E-15_JPRB, 0.34223522E-15_JPRB, &
  & 0.31010996E-15_JPRB, 0.26551937E-15_JPRB, 0.19677223E-15_JPRB, 0.16426240E-15_JPRB, 0.16765590E-15_JPRB, 0.23641306E-15_JPRB, &
  & 0.31079862E-15_JPRB, 0.50185511E-15_JPRB, 0.87200538E-15_JPRB, 0.14748262E-14_JPRB /)

RGHG5(:,15, 6) = (/ &
  & 0.17487373E-13_JPRB, 0.15590570E-13_JPRB, 0.14030765E-13_JPRB, 0.12560580E-13_JPRB, 0.11207164E-13_JPRB, 0.10096734E-13_JPRB, &
  & 0.93233492E-14_JPRB, 0.90286555E-14_JPRB, 0.93611727E-14_JPRB, 0.10454204E-13_JPRB, 0.12403377E-13_JPRB, 0.15348884E-13_JPRB, &
  & 0.19397217E-13_JPRB, 0.24341833E-13_JPRB, 0.30052597E-13_JPRB, 0.36004453E-13_JPRB, 0.41629877E-13_JPRB, 0.46515038E-13_JPRB, &
  & 0.50466443E-13_JPRB, 0.53633970E-13_JPRB, 0.56406194E-13_JPRB, 0.59177970E-13_JPRB, 0.62081471E-13_JPRB, 0.65465157E-13_JPRB, &
  & 0.69666075E-13_JPRB, 0.74797373E-13_JPRB, 0.81420683E-13_JPRB, 0.88750181E-13_JPRB, 0.97392912E-13_JPRB, 0.10590704E-12_JPRB, &
  & 0.11561588E-12_JPRB, 0.12131702E-12_JPRB, 0.12585291E-12_JPRB, 0.11652163E-12_JPRB, 0.10670492E-12_JPRB, 0.11192215E-12_JPRB, &
  & 0.12677645E-12_JPRB, 0.11718092E-12_JPRB, 0.10123980E-12_JPRB, 0.85301198E-13_JPRB, 0.67222818E-13_JPRB, 0.51175247E-13_JPRB, &
  & 0.37502611E-13_JPRB, 0.27510742E-13_JPRB, 0.22300855E-13_JPRB, 0.19296983E-13_JPRB, 0.16562442E-13_JPRB, 0.11943524E-13_JPRB, &
  & 0.74760043E-14_JPRB, 0.48270654E-14_JPRB, 0.36384715E-14_JPRB, 0.31649255E-14_JPRB, 0.31742174E-14_JPRB, 0.30330844E-14_JPRB, &
  & 0.27754011E-14_JPRB, 0.23909724E-14_JPRB, 0.19354912E-14_JPRB, 0.19017851E-14_JPRB, 0.22318547E-14_JPRB, 0.30402799E-14_JPRB, &
  & 0.39233118E-14_JPRB, 0.51254065E-14_JPRB, 0.60039622E-14_JPRB, 0.71282396E-14_JPRB /)

RGHG5(:,16, 6) = (/ &
  & 0.10059749E-12_JPRB, 0.83134685E-13_JPRB, 0.71870793E-13_JPRB, 0.62678154E-13_JPRB, 0.54879519E-13_JPRB, 0.48396362E-13_JPRB, &
  & 0.43694059E-13_JPRB, 0.41258463E-13_JPRB, 0.41646313E-13_JPRB, 0.45438473E-13_JPRB, 0.53074231E-13_JPRB, 0.65211373E-13_JPRB, &
  & 0.82454361E-13_JPRB, 0.10477612E-12_JPRB, 0.13161973E-12_JPRB, 0.16162393E-12_JPRB, 0.19387156E-12_JPRB, 0.22656658E-12_JPRB, &
  & 0.25809351E-12_JPRB, 0.28882148E-12_JPRB, 0.32000804E-12_JPRB, 0.35335125E-12_JPRB, 0.38929092E-12_JPRB, 0.42952545E-12_JPRB, &
  & 0.47427134E-12_JPRB, 0.52423219E-12_JPRB, 0.57723688E-12_JPRB, 0.62898645E-12_JPRB, 0.67285744E-12_JPRB, 0.70572460E-12_JPRB, &
  & 0.72221742E-12_JPRB, 0.72592475E-12_JPRB, 0.72288172E-12_JPRB, 0.69731260E-12_JPRB, 0.65046975E-12_JPRB, 0.57657579E-12_JPRB, &
  & 0.48503134E-12_JPRB, 0.44663099E-12_JPRB, 0.40986431E-12_JPRB, 0.36798250E-12_JPRB, 0.32489788E-12_JPRB, 0.27911766E-12_JPRB, &
  & 0.23334747E-12_JPRB, 0.19361936E-12_JPRB, 0.15428243E-12_JPRB, 0.11511278E-12_JPRB, 0.81273008E-13_JPRB, 0.59403701E-13_JPRB, &
  & 0.46065809E-13_JPRB, 0.37485863E-13_JPRB, 0.31670460E-13_JPRB, 0.27572938E-13_JPRB, 0.24564843E-13_JPRB, 0.22376947E-13_JPRB, &
  & 0.20541432E-13_JPRB, 0.19254982E-13_JPRB, 0.19174551E-13_JPRB, 0.21031906E-13_JPRB, 0.25913875E-13_JPRB, 0.34273948E-13_JPRB, &
  & 0.47472656E-13_JPRB, 0.61761800E-13_JPRB, 0.95767131E-13_JPRB, 0.15113225E-12_JPRB /)

RGHG5(:,17, 6) = (/ &
  & 0.40991768E-12_JPRB, 0.32716934E-12_JPRB, 0.27849560E-12_JPRB, 0.24048515E-12_JPRB, 0.20861080E-12_JPRB, 0.18259861E-12_JPRB, &
  & 0.16300141E-12_JPRB, 0.15140473E-12_JPRB, 0.14963630E-12_JPRB, 0.15952195E-12_JPRB, 0.18285850E-12_JPRB, 0.22100194E-12_JPRB, &
  & 0.27711730E-12_JPRB, 0.35271476E-12_JPRB, 0.44857764E-12_JPRB, 0.56273595E-12_JPRB, 0.69159462E-12_JPRB, 0.83339943E-12_JPRB, &
  & 0.98582926E-12_JPRB, 0.11493045E-11_JPRB, 0.13274321E-11_JPRB, 0.15282726E-11_JPRB, 0.17567950E-11_JPRB, 0.20244546E-11_JPRB, &
  & 0.23225874E-11_JPRB, 0.26432743E-11_JPRB, 0.29417636E-11_JPRB, 0.31909377E-11_JPRB, 0.33317633E-11_JPRB, 0.33884310E-11_JPRB, &
  & 0.32974836E-11_JPRB, 0.31169700E-11_JPRB, 0.28641523E-11_JPRB, 0.25824458E-11_JPRB, 0.23006152E-11_JPRB, 0.20442664E-11_JPRB, &
  & 0.18306474E-11_JPRB, 0.16123604E-11_JPRB, 0.14618225E-11_JPRB, 0.13334109E-11_JPRB, 0.12135497E-11_JPRB, 0.10963758E-11_JPRB, &
  & 0.97033232E-12_JPRB, 0.83744134E-12_JPRB, 0.69829076E-12_JPRB, 0.57119511E-12_JPRB, 0.46704990E-12_JPRB, 0.38515100E-12_JPRB, &
  & 0.31553525E-12_JPRB, 0.25911220E-12_JPRB, 0.21396288E-12_JPRB, 0.17837541E-12_JPRB, 0.15163428E-12_JPRB, 0.13365176E-12_JPRB, &
  & 0.12453345E-12_JPRB, 0.12397016E-12_JPRB, 0.13181601E-12_JPRB, 0.15017524E-12_JPRB, 0.18053148E-12_JPRB, 0.22663033E-12_JPRB, &
  & 0.29167603E-12_JPRB, 0.37718101E-12_JPRB, 0.54069211E-12_JPRB, 0.82808023E-12_JPRB /)

RGHG5(:,18, 6) = (/ &
  & 0.12192339E-11_JPRB, 0.97707541E-12_JPRB, 0.83718904E-12_JPRB, 0.72717505E-12_JPRB, 0.63580277E-12_JPRB, 0.55861077E-12_JPRB, &
  & 0.49876000E-12_JPRB, 0.46013529E-12_JPRB, 0.44817985E-12_JPRB, 0.46825098E-12_JPRB, 0.52513609E-12_JPRB, 0.62334816E-12_JPRB, &
  & 0.77070441E-12_JPRB, 0.97462067E-12_JPRB, 0.12402539E-11_JPRB, 0.15691420E-11_JPRB, 0.19590623E-11_JPRB, 0.24040555E-11_JPRB, &
  & 0.29006459E-11_JPRB, 0.34563563E-11_JPRB, 0.40828864E-11_JPRB, 0.48051936E-11_JPRB, 0.56476876E-11_JPRB, 0.66454186E-11_JPRB, &
  & 0.77643612E-11_JPRB, 0.89210566E-11_JPRB, 0.10010013E-10_JPRB, 0.10859420E-10_JPRB, 0.11289931E-10_JPRB, 0.11227920E-10_JPRB, &
  & 0.10657643E-10_JPRB, 0.97326921E-11_JPRB, 0.85998778E-11_JPRB, 0.73868394E-11_JPRB, 0.62350632E-11_JPRB, 0.52888709E-11_JPRB, &
  & 0.46092219E-11_JPRB, 0.42170070E-11_JPRB, 0.39567290E-11_JPRB, 0.37983236E-11_JPRB, 0.36456281E-11_JPRB, 0.34443962E-11_JPRB, &
  & 0.31945559E-11_JPRB, 0.29011223E-11_JPRB, 0.25672325E-11_JPRB, 0.22328038E-11_JPRB, 0.19192534E-11_JPRB, 0.16375372E-11_JPRB, &
  & 0.13810267E-11_JPRB, 0.11596436E-11_JPRB, 0.97556663E-12_JPRB, 0.82751102E-12_JPRB, 0.71863858E-12_JPRB, 0.64749979E-12_JPRB, &
  & 0.61122787E-12_JPRB, 0.60905794E-12_JPRB, 0.64141308E-12_JPRB, 0.71207656E-12_JPRB, 0.81885600E-12_JPRB, 0.96526357E-12_JPRB, &
  & 0.11599455E-11_JPRB, 0.14150082E-11_JPRB, 0.17713962E-11_JPRB, 0.25828890E-11_JPRB /)

RGHG5(:,19, 6) = (/ &
  & 0.28894578E-11_JPRB, 0.23575209E-11_JPRB, 0.20526653E-11_JPRB, 0.18151947E-11_JPRB, 0.16095493E-11_JPRB, 0.14330725E-11_JPRB, &
  & 0.12890631E-11_JPRB, 0.11903645E-11_JPRB, 0.11499122E-11_JPRB, 0.11814607E-11_JPRB, 0.12956408E-11_JPRB, 0.15025836E-11_JPRB, &
  & 0.18123684E-11_JPRB, 0.22463891E-11_JPRB, 0.28208074E-11_JPRB, 0.35435483E-11_JPRB, 0.44137216E-11_JPRB, 0.54238931E-11_JPRB, &
  & 0.65652653E-11_JPRB, 0.78511754E-11_JPRB, 0.93162734E-11_JPRB, 0.11013094E-10_JPRB, 0.12999843E-10_JPRB, 0.15324953E-10_JPRB, &
  & 0.17923760E-10_JPRB, 0.20638852E-10_JPRB, 0.23172145E-10_JPRB, 0.25035612E-10_JPRB, 0.25948903E-10_JPRB, 0.25702307E-10_JPRB, &
  & 0.24405377E-10_JPRB, 0.22250944E-10_JPRB, 0.19597886E-10_JPRB, 0.16794673E-10_JPRB, 0.14216589E-10_JPRB, 0.12114268E-10_JPRB, &
  & 0.10617613E-10_JPRB, 0.96941873E-11_JPRB, 0.92755525E-11_JPRB, 0.90752154E-11_JPRB, 0.89583297E-11_JPRB, 0.87909714E-11_JPRB, &
  & 0.84643447E-11_JPRB, 0.79716216E-11_JPRB, 0.73290376E-11_JPRB, 0.66099261E-11_JPRB, 0.58632448E-11_JPRB, 0.51378207E-11_JPRB, &
  & 0.44492006E-11_JPRB, 0.38344519E-11_JPRB, 0.33171842E-11_JPRB, 0.28967751E-11_JPRB, 0.25799311E-11_JPRB, 0.23542355E-11_JPRB, &
  & 0.22146202E-11_JPRB, 0.21654956E-11_JPRB, 0.22127565E-11_JPRB, 0.23639417E-11_JPRB, 0.26018120E-11_JPRB, 0.29157492E-11_JPRB, &
  & 0.33064061E-11_JPRB, 0.38026513E-11_JPRB, 0.44734312E-11_JPRB, 0.58783833E-11_JPRB /)

RGHG5(:,20, 6) = (/ &
  & 0.57454488E-11_JPRB, 0.48161093E-11_JPRB, 0.42888163E-11_JPRB, 0.38675495E-11_JPRB, 0.34966834E-11_JPRB, 0.31653070E-11_JPRB, &
  & 0.28861622E-11_JPRB, 0.26817329E-11_JPRB, 0.25867429E-11_JPRB, 0.26270175E-11_JPRB, 0.28232195E-11_JPRB, 0.31924866E-11_JPRB, &
  & 0.37515464E-11_JPRB, 0.45227719E-11_JPRB, 0.55393320E-11_JPRB, 0.68125523E-11_JPRB, 0.83383777E-11_JPRB, 0.10097569E-10_JPRB, &
  & 0.12075499E-10_JPRB, 0.14290390E-10_JPRB, 0.16813851E-10_JPRB, 0.19719467E-10_JPRB, 0.23062007E-10_JPRB, 0.26953656E-10_JPRB, &
  & 0.31323080E-10_JPRB, 0.35838024E-10_JPRB, 0.40051188E-10_JPRB, 0.43249369E-10_JPRB, 0.44963144E-10_JPRB, 0.44923152E-10_JPRB, &
  & 0.43228549E-10_JPRB, 0.40088800E-10_JPRB, 0.36025585E-10_JPRB, 0.31552944E-10_JPRB, 0.27290984E-10_JPRB, 0.23746474E-10_JPRB, &
  & 0.21168796E-10_JPRB, 0.19595704E-10_JPRB, 0.18870227E-10_JPRB, 0.18630630E-10_JPRB, 0.18548326E-10_JPRB, 0.18358403E-10_JPRB, &
  & 0.17946032E-10_JPRB, 0.17260533E-10_JPRB, 0.16238403E-10_JPRB, 0.14965635E-10_JPRB, 0.13554850E-10_JPRB, 0.12136390E-10_JPRB, &
  & 0.10763581E-10_JPRB, 0.95180773E-11_JPRB, 0.84498658E-11_JPRB, 0.75547684E-11_JPRB, 0.68398117E-11_JPRB, 0.62967071E-11_JPRB, &
  & 0.59246640E-11_JPRB, 0.57323733E-11_JPRB, 0.57282239E-11_JPRB, 0.59261966E-11_JPRB, 0.62911759E-11_JPRB, 0.67871733E-11_JPRB, &
  & 0.73890997E-11_JPRB, 0.81084610E-11_JPRB, 0.90880003E-11_JPRB, 0.10927463E-10_JPRB /)

RGHG5(:,21, 6) = (/ &
  & 0.10128751E-10_JPRB, 0.87055458E-11_JPRB, 0.79174150E-11_JPRB, 0.72754107E-11_JPRB, 0.67006084E-11_JPRB, 0.61745370E-11_JPRB, &
  & 0.57134124E-11_JPRB, 0.53710309E-11_JPRB, 0.52003571E-11_JPRB, 0.52506528E-11_JPRB, 0.55551605E-11_JPRB, 0.61391222E-11_JPRB, &
  & 0.70205725E-11_JPRB, 0.82194772E-11_JPRB, 0.97715360E-11_JPRB, 0.11691956E-10_JPRB, 0.13967926E-10_JPRB, 0.16564101E-10_JPRB, &
  & 0.19454452E-10_JPRB, 0.22650680E-10_JPRB, 0.26200783E-10_JPRB, 0.30271629E-10_JPRB, 0.34960170E-10_JPRB, 0.40322638E-10_JPRB, &
  & 0.46207326E-10_JPRB, 0.52394276E-10_JPRB, 0.58086744E-10_JPRB, 0.62521779E-10_JPRB, 0.65239973E-10_JPRB, 0.65960952E-10_JPRB, &
  & 0.64609693E-10_JPRB, 0.61374669E-10_JPRB, 0.56779088E-10_JPRB, 0.51313218E-10_JPRB, 0.45881111E-10_JPRB, 0.41101227E-10_JPRB, &
  & 0.37495042E-10_JPRB, 0.35194288E-10_JPRB, 0.33979076E-10_JPRB, 0.33472433E-10_JPRB, 0.33181256E-10_JPRB, 0.32799791E-10_JPRB, &
  & 0.32032769E-10_JPRB, 0.30851172E-10_JPRB, 0.29211886E-10_JPRB, 0.27243277E-10_JPRB, 0.25096404E-10_JPRB, 0.22923337E-10_JPRB, &
  & 0.20782046E-10_JPRB, 0.18781423E-10_JPRB, 0.16998217E-10_JPRB, 0.15431356E-10_JPRB, 0.14142299E-10_JPRB, 0.13144827E-10_JPRB, &
  & 0.12436569E-10_JPRB, 0.12013615E-10_JPRB, 0.11871531E-10_JPRB, 0.12021734E-10_JPRB, 0.12415814E-10_JPRB, 0.13003433E-10_JPRB, &
  & 0.13735045E-10_JPRB, 0.14591980E-10_JPRB, 0.15657408E-10_JPRB, 0.17756194E-10_JPRB /)

RGHG5(:,22, 6) = (/ &
  & 0.16104718E-10_JPRB, 0.14245532E-10_JPRB, 0.13197663E-10_JPRB, 0.12339987E-10_JPRB, 0.11560222E-10_JPRB, 0.10834439E-10_JPRB, &
  & 0.10198975E-10_JPRB, 0.97207251E-11_JPRB, 0.94947990E-11_JPRB, 0.95941137E-11_JPRB, 0.10069910E-10_JPRB, 0.10952497E-10_JPRB, &
  & 0.12261235E-10_JPRB, 0.14004261E-10_JPRB, 0.16182515E-10_JPRB, 0.18812309E-10_JPRB, 0.21866117E-10_JPRB, 0.25301594E-10_JPRB, &
  & 0.29081531E-10_JPRB, 0.33205987E-10_JPRB, 0.37756593E-10_JPRB, 0.42851962E-10_JPRB, 0.48536519E-10_JPRB, 0.54890207E-10_JPRB, &
  & 0.61817378E-10_JPRB, 0.68854075E-10_JPRB, 0.75536931E-10_JPRB, 0.81142093E-10_JPRB, 0.84956445E-10_JPRB, 0.86737902E-10_JPRB, &
  & 0.86409414E-10_JPRB, 0.84064353E-10_JPRB, 0.80067696E-10_JPRB, 0.74893723E-10_JPRB, 0.69343323E-10_JPRB, 0.64254956E-10_JPRB, &
  & 0.60009907E-10_JPRB, 0.57003527E-10_JPRB, 0.55113566E-10_JPRB, 0.53863546E-10_JPRB, 0.52826320E-10_JPRB, 0.51703551E-10_JPRB, &
  & 0.50235996E-10_JPRB, 0.48289556E-10_JPRB, 0.45817818E-10_JPRB, 0.42998119E-10_JPRB, 0.40006193E-10_JPRB, 0.36985512E-10_JPRB, &
  & 0.33988250E-10_JPRB, 0.31141870E-10_JPRB, 0.28554076E-10_JPRB, 0.26270375E-10_JPRB, 0.24388498E-10_JPRB, 0.22915218E-10_JPRB, &
  & 0.21837841E-10_JPRB, 0.21135926E-10_JPRB, 0.20784735E-10_JPRB, 0.20781335E-10_JPRB, 0.21064624E-10_JPRB, 0.21577462E-10_JPRB, &
  & 0.22271367E-10_JPRB, 0.23128048E-10_JPRB, 0.24218298E-10_JPRB, 0.26156398E-10_JPRB /)

RGHG5(:,23, 6) = (/ &
  & 0.23699844E-10_JPRB, 0.21458845E-10_JPRB, 0.20214575E-10_JPRB, 0.19184885E-10_JPRB, 0.18252261E-10_JPRB, 0.17389430E-10_JPRB, &
  & 0.16636716E-10_JPRB, 0.16104861E-10_JPRB, 0.15914964E-10_JPRB, 0.16175384E-10_JPRB, 0.16952391E-10_JPRB, 0.18283600E-10_JPRB, &
  & 0.20175273E-10_JPRB, 0.22615632E-10_JPRB, 0.25576430E-10_JPRB, 0.29015582E-10_JPRB, 0.32905206E-10_JPRB, 0.37177466E-10_JPRB, &
  & 0.41790443E-10_JPRB, 0.46766997E-10_JPRB, 0.52080045E-10_JPRB, 0.57819947E-10_JPRB, 0.64120251E-10_JPRB, 0.70972665E-10_JPRB, &
  & 0.78229506E-10_JPRB, 0.85662928E-10_JPRB, 0.92627551E-10_JPRB, 0.98517375E-10_JPRB, 0.10315924E-09_JPRB, 0.10612725E-09_JPRB, &
  & 0.10720336E-09_JPRB, 0.10640608E-09_JPRB, 0.10394251E-09_JPRB, 0.10016282E-09_JPRB, 0.95588613E-10_JPRB, 0.91118356E-10_JPRB, &
  & 0.86989679E-10_JPRB, 0.83538690E-10_JPRB, 0.80777815E-10_JPRB, 0.78354212E-10_JPRB, 0.76042853E-10_JPRB, 0.73570719E-10_JPRB, &
  & 0.70819024E-10_JPRB, 0.67779601E-10_JPRB, 0.64348880E-10_JPRB, 0.60593704E-10_JPRB, 0.56646673E-10_JPRB, 0.52705444E-10_JPRB, &
  & 0.48872111E-10_JPRB, 0.45292339E-10_JPRB, 0.42086373E-10_JPRB, 0.39287136E-10_JPRB, 0.36958752E-10_JPRB, 0.35094982E-10_JPRB, &
  & 0.33673241E-10_JPRB, 0.32671178E-10_JPRB, 0.32059463E-10_JPRB, 0.31825532E-10_JPRB, 0.31895361E-10_JPRB, 0.32199011E-10_JPRB, &
  & 0.32678204E-10_JPRB, 0.33309782E-10_JPRB, 0.34161809E-10_JPRB, 0.35775757E-10_JPRB /)

RGHG5(:,24, 6) = (/ &
  & 0.32591402E-10_JPRB, 0.30185895E-10_JPRB, 0.28826953E-10_JPRB, 0.27725437E-10_JPRB, 0.26740138E-10_JPRB, 0.25847024E-10_JPRB, &
  & 0.25111583E-10_JPRB, 0.24666949E-10_JPRB, 0.24680612E-10_JPRB, 0.25285836E-10_JPRB, 0.26562605E-10_JPRB, 0.28545636E-10_JPRB, &
  & 0.31226466E-10_JPRB, 0.34554949E-10_JPRB, 0.38457161E-10_JPRB, 0.42826707E-10_JPRB, 0.47607685E-10_JPRB, 0.52720821E-10_JPRB, &
  & 0.58081019E-10_JPRB, 0.63664532E-10_JPRB, 0.69497227E-10_JPRB, 0.75600928E-10_JPRB, 0.81948621E-10_JPRB, 0.88566245E-10_JPRB, &
  & 0.95380676E-10_JPRB, 0.10221537E-09_JPRB, 0.10890569E-09_JPRB, 0.11499841E-09_JPRB, 0.11996670E-09_JPRB, 0.12378609E-09_JPRB, &
  & 0.12621483E-09_JPRB, 0.12713317E-09_JPRB, 0.12658449E-09_JPRB, 0.12469344E-09_JPRB, 0.12176909E-09_JPRB, 0.11835696E-09_JPRB, &
  & 0.11473882E-09_JPRB, 0.11117358E-09_JPRB, 0.10764634E-09_JPRB, 0.10408596E-09_JPRB, 0.10030513E-09_JPRB, 0.96268042E-10_JPRB, &
  & 0.91935987E-10_JPRB, 0.87397908E-10_JPRB, 0.82643815E-10_JPRB, 0.77787499E-10_JPRB, 0.72985756E-10_JPRB, 0.68407280E-10_JPRB, &
  & 0.64102557E-10_JPRB, 0.60164311E-10_JPRB, 0.56674800E-10_JPRB, 0.53618880E-10_JPRB, 0.51037303E-10_JPRB, 0.48903805E-10_JPRB, &
  & 0.47191851E-10_JPRB, 0.45886482E-10_JPRB, 0.44968820E-10_JPRB, 0.44434085E-10_JPRB, 0.44214105E-10_JPRB, 0.44236666E-10_JPRB, &
  & 0.44436392E-10_JPRB, 0.44769355E-10_JPRB, 0.45245186E-10_JPRB, 0.46199961E-10_JPRB /)

RGHG5(:,25, 6) = (/ &
  & 0.42536672E-10_JPRB, 0.40111976E-10_JPRB, 0.38763777E-10_JPRB, 0.37711480E-10_JPRB, 0.36792108E-10_JPRB, 0.36004522E-10_JPRB, &
  & 0.35434794E-10_JPRB, 0.35254293E-10_JPRB, 0.35659767E-10_JPRB, 0.36805670E-10_JPRB, 0.38777637E-10_JPRB, 0.41598811E-10_JPRB, &
  & 0.45235177E-10_JPRB, 0.49586512E-10_JPRB, 0.54533024E-10_JPRB, 0.59912159E-10_JPRB, 0.65570313E-10_JPRB, 0.71426018E-10_JPRB, &
  & 0.77382940E-10_JPRB, 0.83399412E-10_JPRB, 0.89420353E-10_JPRB, 0.95413379E-10_JPRB, 0.10134442E-09_JPRB, 0.10727706E-09_JPRB, &
  & 0.11315309E-09_JPRB, 0.11897069E-09_JPRB, 0.12466110E-09_JPRB, 0.13013042E-09_JPRB, 0.13524848E-09_JPRB, 0.13964506E-09_JPRB, &
  & 0.14315148E-09_JPRB, 0.14556849E-09_JPRB, 0.14679125E-09_JPRB, 0.14671943E-09_JPRB, 0.14549852E-09_JPRB, 0.14332585E-09_JPRB, &
  & 0.14040748E-09_JPRB, 0.13688294E-09_JPRB, 0.13284190E-09_JPRB, 0.12825144E-09_JPRB, 0.12319466E-09_JPRB, 0.11773708E-09_JPRB, &
  & 0.11200944E-09_JPRB, 0.10615893E-09_JPRB, 0.10027277E-09_JPRB, 0.94506236E-10_JPRB, 0.89057310E-10_JPRB, 0.84025689E-10_JPRB, &
  & 0.79432259E-10_JPRB, 0.75318606E-10_JPRB, 0.71703081E-10_JPRB, 0.68537460E-10_JPRB, 0.65821008E-10_JPRB, 0.63511300E-10_JPRB, &
  & 0.61574974E-10_JPRB, 0.59993600E-10_JPRB, 0.58754925E-10_JPRB, 0.57866850E-10_JPRB, 0.57281568E-10_JPRB, 0.56942714E-10_JPRB, &
  & 0.56792921E-10_JPRB, 0.56782874E-10_JPRB, 0.56885312E-10_JPRB, 0.57192202E-10_JPRB /)

RGHG5(:,26, 6) = (/ &
  & 0.53061319E-10_JPRB, 0.50879505E-10_JPRB, 0.49718986E-10_JPRB, 0.48807076E-10_JPRB, 0.48065836E-10_JPRB, 0.47499324E-10_JPRB, &
  & 0.47224891E-10_JPRB, 0.47446363E-10_JPRB, 0.48384095E-10_JPRB, 0.50201468E-10_JPRB, 0.52972585E-10_JPRB, 0.56710501E-10_JPRB, &
  & 0.61332377E-10_JPRB, 0.66707140E-10_JPRB, 0.72645452E-10_JPRB, 0.78937232E-10_JPRB, 0.85375033E-10_JPRB, 0.91829662E-10_JPRB, &
  & 0.98196180E-10_JPRB, 0.10439522E-09_JPRB, 0.11033943E-09_JPRB, 0.11594276E-09_JPRB, 0.12121967E-09_JPRB, 0.12621530E-09_JPRB, &
  & 0.13093049E-09_JPRB, 0.13547279E-09_JPRB, 0.13998824E-09_JPRB, 0.14458064E-09_JPRB, 0.14924245E-09_JPRB, 0.15386864E-09_JPRB, &
  & 0.15807944E-09_JPRB, 0.16158549E-09_JPRB, 0.16413509E-09_JPRB, 0.16546919E-09_JPRB, 0.16555325E-09_JPRB, 0.16440255E-09_JPRB, &
  & 0.16208740E-09_JPRB, 0.15867690E-09_JPRB, 0.15436998E-09_JPRB, 0.14909461E-09_JPRB, 0.14315657E-09_JPRB, 0.13670100E-09_JPRB, &
  & 0.13000570E-09_JPRB, 0.12327935E-09_JPRB, 0.11667707E-09_JPRB, 0.11036567E-09_JPRB, 0.10449973E-09_JPRB, 0.99212312E-10_JPRB, &
  & 0.94491491E-10_JPRB, 0.90334622E-10_JPRB, 0.86708127E-10_JPRB, 0.83529288E-10_JPRB, 0.80764749E-10_JPRB, 0.78358306E-10_JPRB, &
  & 0.76262580E-10_JPRB, 0.74459161E-10_JPRB, 0.72936879E-10_JPRB, 0.71709590E-10_JPRB, 0.70752480E-10_JPRB, 0.70031460E-10_JPRB, &
  & 0.69506435E-10_JPRB, 0.69127079E-10_JPRB, 0.68826687E-10_JPRB, 0.68495140E-10_JPRB /)

RGHG5(:,27, 6) = (/ &
  & 0.64005662E-10_JPRB, 0.62299471E-10_JPRB, 0.61332620E-10_JPRB, 0.60658159E-10_JPRB, 0.60152390E-10_JPRB, 0.59874772E-10_JPRB, &
  & 0.59967406E-10_JPRB, 0.60661524E-10_JPRB, 0.62178186E-10_JPRB, 0.64681732E-10_JPRB, 0.68235313E-10_JPRB, 0.72808579E-10_JPRB, &
  & 0.78304571E-10_JPRB, 0.84532270E-10_JPRB, 0.91281913E-10_JPRB, 0.98287829E-10_JPRB, 0.10532479E-09_JPRB, 0.11218579E-09_JPRB, &
  & 0.11877350E-09_JPRB, 0.12498585E-09_JPRB, 0.13069984E-09_JPRB, 0.13583971E-09_JPRB, 0.14039662E-09_JPRB, 0.14441467E-09_JPRB, &
  & 0.14799950E-09_JPRB, 0.15131738E-09_JPRB, 0.15470675E-09_JPRB, 0.15838485E-09_JPRB, 0.16246508E-09_JPRB, 0.16687030E-09_JPRB, &
  & 0.17131509E-09_JPRB, 0.17541837E-09_JPRB, 0.17877745E-09_JPRB, 0.18100403E-09_JPRB, 0.18191920E-09_JPRB, 0.18143125E-09_JPRB, &
  & 0.17952627E-09_JPRB, 0.17624929E-09_JPRB, 0.17179788E-09_JPRB, 0.16625054E-09_JPRB, 0.15979218E-09_JPRB, 0.15282814E-09_JPRB, &
  & 0.14559347E-09_JPRB, 0.13842405E-09_JPRB, 0.13146909E-09_JPRB, 0.12493354E-09_JPRB, 0.11898106E-09_JPRB, 0.11370193E-09_JPRB, &
  & 0.10905562E-09_JPRB, 0.10499429E-09_JPRB, 0.10144766E-09_JPRB, 0.98318312E-10_JPRB, 0.95554759E-10_JPRB, 0.93090369E-10_JPRB, &
  & 0.90881976E-10_JPRB, 0.88908110E-10_JPRB, 0.87162028E-10_JPRB, 0.85661228E-10_JPRB, 0.84400473E-10_JPRB, 0.83362608E-10_JPRB, &
  & 0.82519463E-10_JPRB, 0.81819891E-10_JPRB, 0.81170924E-10_JPRB, 0.80273545E-10_JPRB /)

RGHG5(:,28, 6) = (/ &
  & 0.75333705E-10_JPRB, 0.73940451E-10_JPRB, 0.73282568E-10_JPRB, 0.72836751E-10_JPRB, 0.72598233E-10_JPRB, 0.72630180E-10_JPRB, &
  & 0.73107957E-10_JPRB, 0.74260452E-10_JPRB, 0.76335126E-10_JPRB, 0.79457996E-10_JPRB, 0.83660252E-10_JPRB, 0.88914952E-10_JPRB, &
  & 0.95063318E-10_JPRB, 0.10192397E-09_JPRB, 0.10922932E-09_JPRB, 0.11671657E-09_JPRB, 0.12411530E-09_JPRB, 0.13121598E-09_JPRB, &
  & 0.13788373E-09_JPRB, 0.14400041E-09_JPRB, 0.14944593E-09_JPRB, 0.15412951E-09_JPRB, 0.15803844E-09_JPRB, 0.16123963E-09_JPRB, &
  & 0.16387479E-09_JPRB, 0.16618264E-09_JPRB, 0.16856043E-09_JPRB, 0.17134001E-09_JPRB, 0.17473867E-09_JPRB, 0.17878651E-09_JPRB, &
  & 0.18315316E-09_JPRB, 0.18743010E-09_JPRB, 0.19114257E-09_JPRB, 0.19381363E-09_JPRB, 0.19516636E-09_JPRB, 0.19503878E-09_JPRB, &
  & 0.19338267E-09_JPRB, 0.19024300E-09_JPRB, 0.18577505E-09_JPRB, 0.18016261E-09_JPRB, 0.17360943E-09_JPRB, 0.16646344E-09_JPRB, &
  & 0.15912466E-09_JPRB, 0.15186212E-09_JPRB, 0.14489973E-09_JPRB, 0.13845894E-09_JPRB, 0.13265491E-09_JPRB, 0.12758040E-09_JPRB, &
  & 0.12314080E-09_JPRB, 0.11925701E-09_JPRB, 0.11583345E-09_JPRB, 0.11277296E-09_JPRB, 0.11001639E-09_JPRB, 0.10750546E-09_JPRB, &
  & 0.10519639E-09_JPRB, 0.10307576E-09_JPRB, 0.10113800E-09_JPRB, 0.99395561E-10_JPRB, 0.97846418E-10_JPRB, 0.96486451E-10_JPRB, &
  & 0.95303251E-10_JPRB, 0.94240317E-10_JPRB, 0.93150633E-10_JPRB, 0.91427012E-10_JPRB /)

RGHG5(:,29, 6) = (/ &
  & 0.86525162E-10_JPRB, 0.85571966E-10_JPRB, 0.85146931E-10_JPRB, 0.84947424E-10_JPRB, 0.84961718E-10_JPRB, 0.85290795E-10_JPRB, &
  & 0.86115039E-10_JPRB, 0.87708799E-10_JPRB, 0.90253333E-10_JPRB, 0.93876455E-10_JPRB, 0.98590795E-10_JPRB, 0.10431076E-09_JPRB, &
  & 0.11090745E-09_JPRB, 0.11814637E-09_JPRB, 0.12577855E-09_JPRB, 0.13351004E-09_JPRB, 0.14108442E-09_JPRB, 0.14827517E-09_JPRB, &
  & 0.15491144E-09_JPRB, 0.16088327E-09_JPRB, 0.16606337E-09_JPRB, 0.17037632E-09_JPRB, 0.17378937E-09_JPRB, 0.17638437E-09_JPRB, &
  & 0.17832598E-09_JPRB, 0.17989062E-09_JPRB, 0.18150659E-09_JPRB, 0.18353145E-09_JPRB, 0.18626579E-09_JPRB, 0.18977264E-09_JPRB, &
  & 0.19384946E-09_JPRB, 0.19799690E-09_JPRB, 0.20171519E-09_JPRB, 0.20448686E-09_JPRB, 0.20597467E-09_JPRB, 0.20599612E-09_JPRB, &
  & 0.20449806E-09_JPRB, 0.20151307E-09_JPRB, 0.19718539E-09_JPRB, 0.19167740E-09_JPRB, 0.18528985E-09_JPRB, 0.17833805E-09_JPRB, &
  & 0.17117395E-09_JPRB, 0.16413990E-09_JPRB, 0.15749106E-09_JPRB, 0.15134784E-09_JPRB, 0.14585885E-09_JPRB, 0.14106008E-09_JPRB, &
  & 0.13685700E-09_JPRB, 0.13314422E-09_JPRB, 0.12982050E-09_JPRB, 0.12679528E-09_JPRB, 0.12401999E-09_JPRB, 0.12144161E-09_JPRB, &
  & 0.11902705E-09_JPRB, 0.11676637E-09_JPRB, 0.11465009E-09_JPRB, 0.11269263E-09_JPRB, 0.11090022E-09_JPRB, 0.10927832E-09_JPRB, &
  & 0.10783196E-09_JPRB, 0.10651696E-09_JPRB, 0.10520090E-09_JPRB, 0.10334143E-09_JPRB /)

RGHG5(:,30, 6) = (/ &
  & 0.97376482E-10_JPRB, 0.96811371E-10_JPRB, 0.96645393E-10_JPRB, 0.96664940E-10_JPRB, 0.96910716E-10_JPRB, 0.97501868E-10_JPRB, &
  & 0.98657048E-10_JPRB, 0.10059408E-09_JPRB, 0.10353809E-09_JPRB, 0.10754641E-09_JPRB, 0.11259887E-09_JPRB, 0.11863084E-09_JPRB, &
  & 0.12546035E-09_JPRB, 0.13288452E-09_JPRB, 0.14063418E-09_JPRB, 0.14843599E-09_JPRB, 0.15602986E-09_JPRB, 0.16318984E-09_JPRB, &
  & 0.16974093E-09_JPRB, 0.17554988E-09_JPRB, 0.18050042E-09_JPRB, 0.18451782E-09_JPRB, 0.18757713E-09_JPRB, 0.18976437E-09_JPRB, &
  & 0.19125809E-09_JPRB, 0.19234811E-09_JPRB, 0.19344311E-09_JPRB, 0.19491622E-09_JPRB, 0.19708229E-09_JPRB, 0.20003191E-09_JPRB, &
  & 0.20362997E-09_JPRB, 0.20743189E-09_JPRB, 0.21091384E-09_JPRB, 0.21355187E-09_JPRB, 0.21498484E-09_JPRB, 0.21501521E-09_JPRB, &
  & 0.21360703E-09_JPRB, 0.21081667E-09_JPRB, 0.20675064E-09_JPRB, 0.20157113E-09_JPRB, 0.19552382E-09_JPRB, 0.18898168E-09_JPRB, &
  & 0.18230527E-09_JPRB, 0.17575588E-09_JPRB, 0.16954717E-09_JPRB, 0.16382060E-09_JPRB, 0.15869647E-09_JPRB, 0.15419663E-09_JPRB, &
  & 0.15019050E-09_JPRB, 0.14659712E-09_JPRB, 0.14331636E-09_JPRB, 0.14027306E-09_JPRB, 0.13743476E-09_JPRB, 0.13476378E-09_JPRB, &
  & 0.13223576E-09_JPRB, 0.12984358E-09_JPRB, 0.12758156E-09_JPRB, 0.12546097E-09_JPRB, 0.12349144E-09_JPRB, 0.12168563E-09_JPRB, &
  & 0.12005694E-09_JPRB, 0.11856599E-09_JPRB, 0.11706076E-09_JPRB, 0.11475462E-09_JPRB /)

RGHG5(:,31, 6) = (/ &
  & 0.10773557E-09_JPRB, 0.10757621E-09_JPRB, 0.10762428E-09_JPRB, 0.10783920E-09_JPRB, 0.10829302E-09_JPRB, 0.10912420E-09_JPRB, &
  & 0.11053156E-09_JPRB, 0.11278319E-09_JPRB, 0.11600816E-09_JPRB, 0.12026979E-09_JPRB, 0.12554280E-09_JPRB, 0.13170935E-09_JPRB, &
  & 0.13863528E-09_JPRB, 0.14606678E-09_JPRB, 0.15378383E-09_JPRB, 0.16150890E-09_JPRB, 0.16900994E-09_JPRB, 0.17605593E-09_JPRB, &
  & 0.18248142E-09_JPRB, 0.18812571E-09_JPRB, 0.19288494E-09_JPRB, 0.19668155E-09_JPRB, 0.19950969E-09_JPRB, 0.20146007E-09_JPRB, &
  & 0.20270996E-09_JPRB, 0.20354650E-09_JPRB, 0.20433213E-09_JPRB, 0.20541706E-09_JPRB, 0.20712833E-09_JPRB, 0.20956260E-09_JPRB, &
  & 0.21263082E-09_JPRB, 0.21595860E-09_JPRB, 0.21904360E-09_JPRB, 0.22137897E-09_JPRB, 0.22263116E-09_JPRB, 0.22261891E-09_JPRB, &
  & 0.22129712E-09_JPRB, 0.21872967E-09_JPRB, 0.21503550E-09_JPRB, 0.21031252E-09_JPRB, 0.20483029E-09_JPRB, 0.19886165E-09_JPRB, &
  & 0.19278619E-09_JPRB, 0.18683972E-09_JPRB, 0.18117827E-09_JPRB, 0.17592854E-09_JPRB, 0.17113892E-09_JPRB, 0.16688315E-09_JPRB, &
  & 0.16302289E-09_JPRB, 0.15948055E-09_JPRB, 0.15618269E-09_JPRB, 0.15307425E-09_JPRB, 0.15013972E-09_JPRB, 0.14736085E-09_JPRB, &
  & 0.14472200E-09_JPRB, 0.14221820E-09_JPRB, 0.13984487E-09_JPRB, 0.13761040E-09_JPRB, 0.13552243E-09_JPRB, 0.13359455E-09_JPRB, &
  & 0.13183932E-09_JPRB, 0.13021154E-09_JPRB, 0.12854513E-09_JPRB, 0.12592398E-09_JPRB /)

RGHG5(:,32, 6) = (/ &
  & 0.11763060E-09_JPRB, 0.11780139E-09_JPRB, 0.11803564E-09_JPRB, 0.11844027E-09_JPRB, 0.11908111E-09_JPRB, 0.12011597E-09_JPRB, &
  & 0.12176471E-09_JPRB, 0.12421827E-09_JPRB, 0.12763930E-09_JPRB, 0.13204506E-09_JPRB, 0.13738566E-09_JPRB, 0.14357891E-09_JPRB, &
  & 0.15044174E-09_JPRB, 0.15777707E-09_JPRB, 0.16533090E-09_JPRB, 0.17288061E-09_JPRB, 0.18021173E-09_JPRB, 0.18708474E-09_JPRB, &
  & 0.19334925E-09_JPRB, 0.19883643E-09_JPRB, 0.20343942E-09_JPRB, 0.20709005E-09_JPRB, 0.20978881E-09_JPRB, 0.21163234E-09_JPRB, &
  & 0.21279550E-09_JPRB, 0.21353058E-09_JPRB, 0.21418292E-09_JPRB, 0.21503309E-09_JPRB, 0.21639308E-09_JPRB, 0.21837258E-09_JPRB, &
  & 0.22091753E-09_JPRB, 0.22371767E-09_JPRB, 0.22632675E-09_JPRB, 0.22829305E-09_JPRB, 0.22929264E-09_JPRB, 0.22918521E-09_JPRB, &
  & 0.22795651E-09_JPRB, 0.22565839E-09_JPRB, 0.22237626E-09_JPRB, 0.21822850E-09_JPRB, 0.21337659E-09_JPRB, 0.20813598E-09_JPRB, &
  & 0.20274681E-09_JPRB, 0.19744703E-09_JPRB, 0.19231798E-09_JPRB, 0.18749219E-09_JPRB, 0.18302419E-09_JPRB, 0.17891072E-09_JPRB, &
  & 0.17513635E-09_JPRB, 0.17159953E-09_JPRB, 0.16824714E-09_JPRB, 0.16504978E-09_JPRB, 0.16201182E-09_JPRB, 0.15912552E-09_JPRB, &
  & 0.15639033E-09_JPRB, 0.15379892E-09_JPRB, 0.15134766E-09_JPRB, 0.14904078E-09_JPRB, 0.14688306E-09_JPRB, 0.14488363E-09_JPRB, &
  & 0.14305052E-09_JPRB, 0.14133784E-09_JPRB, 0.13956669E-09_JPRB, 0.13685152E-09_JPRB /)

RGHG5(:,33, 6) = (/ &
  & 0.12700366E-09_JPRB, 0.12746249E-09_JPRB, 0.12791138E-09_JPRB, 0.12848195E-09_JPRB, 0.12930952E-09_JPRB, 0.13053469E-09_JPRB, &
  & 0.13235035E-09_JPRB, 0.13496816E-09_JPRB, 0.13847601E-09_JPRB, 0.14290244E-09_JPRB, 0.14821586E-09_JPRB, 0.15429638E-09_JPRB, &
  & 0.16100928E-09_JPRB, 0.16812673E-09_JPRB, 0.17545444E-09_JPRB, 0.18274633E-09_JPRB, 0.18984048E-09_JPRB, 0.19651505E-09_JPRB, &
  & 0.20259724E-09_JPRB, 0.20793745E-09_JPRB, 0.21242330E-09_JPRB, 0.21598957E-09_JPRB, 0.21864204E-09_JPRB, 0.22047798E-09_JPRB, &
  & 0.22165755E-09_JPRB, 0.22241005E-09_JPRB, 0.22303903E-09_JPRB, 0.22377165E-09_JPRB, 0.22487240E-09_JPRB, 0.22646332E-09_JPRB, &
  & 0.22851757E-09_JPRB, 0.23078092E-09_JPRB, 0.23288638E-09_JPRB, 0.23444555E-09_JPRB, 0.23520028E-09_JPRB, 0.23500343E-09_JPRB, &
  & 0.23386448E-09_JPRB, 0.23184468E-09_JPRB, 0.22901227E-09_JPRB, 0.22542597E-09_JPRB, 0.22127336E-09_JPRB, 0.21672733E-09_JPRB, &
  & 0.21205680E-09_JPRB, 0.20737015E-09_JPRB, 0.20276962E-09_JPRB, 0.19831620E-09_JPRB, 0.19409582E-09_JPRB, 0.19011204E-09_JPRB, &
  & 0.18635102E-09_JPRB, 0.18279081E-09_JPRB, 0.17936400E-09_JPRB, 0.17608040E-09_JPRB, 0.17294496E-09_JPRB, 0.16997204E-09_JPRB, &
  & 0.16716402E-09_JPRB, 0.16451235E-09_JPRB, 0.16201623E-09_JPRB, 0.15967513E-09_JPRB, 0.15749022E-09_JPRB, 0.15546955E-09_JPRB, &
  & 0.15360918E-09_JPRB, 0.15186299E-09_JPRB, 0.15004904E-09_JPRB, 0.14722501E-09_JPRB /)

RGHG5(:,34, 6) = (/ &
  & 0.13576082E-09_JPRB, 0.13661551E-09_JPRB, 0.13724709E-09_JPRB, 0.13800923E-09_JPRB, 0.13899934E-09_JPRB, 0.14038415E-09_JPRB, &
  & 0.14234972E-09_JPRB, 0.14503893E-09_JPRB, 0.14855864E-09_JPRB, 0.15292234E-09_JPRB, 0.15809093E-09_JPRB, 0.16398644E-09_JPRB, &
  & 0.17044267E-09_JPRB, 0.17728541E-09_JPRB, 0.18430910E-09_JPRB, 0.19131367E-09_JPRB, 0.19812652E-09_JPRB, 0.20457239E-09_JPRB, &
  & 0.21047300E-09_JPRB, 0.21567978E-09_JPRB, 0.22008276E-09_JPRB, 0.22361853E-09_JPRB, 0.22629193E-09_JPRB, 0.22818764E-09_JPRB, &
  & 0.22945604E-09_JPRB, 0.23029363E-09_JPRB, 0.23095600E-09_JPRB, 0.23165025E-09_JPRB, 0.23256491E-09_JPRB, 0.23383995E-09_JPRB, &
  & 0.23544999E-09_JPRB, 0.23721200E-09_JPRB, 0.23883287E-09_JPRB, 0.24000135E-09_JPRB, 0.24049701E-09_JPRB, 0.24023167E-09_JPRB, &
  & 0.23919688E-09_JPRB, 0.23744948E-09_JPRB, 0.23503721E-09_JPRB, 0.23201434E-09_JPRB, 0.22847720E-09_JPRB, 0.22461250E-09_JPRB, &
  & 0.22055843E-09_JPRB, 0.21644464E-09_JPRB, 0.21228906E-09_JPRB, 0.20816678E-09_JPRB, 0.20415436E-09_JPRB, 0.20026486E-09_JPRB, &
  & 0.19652059E-09_JPRB, 0.19291486E-09_JPRB, 0.18943358E-09_JPRB, 0.18607527E-09_JPRB, 0.18287102E-09_JPRB, 0.17984367E-09_JPRB, &
  & 0.17699026E-09_JPRB, 0.17431022E-09_JPRB, 0.17179837E-09_JPRB, 0.16945687E-09_JPRB, 0.16728585E-09_JPRB, 0.16528622E-09_JPRB, &
  & 0.16344977E-09_JPRB, 0.16172658E-09_JPRB, 0.15992339E-09_JPRB, 0.15713658E-09_JPRB /)

RGHG5(:,35, 6) = (/ &
  & 0.14408441E-09_JPRB, 0.14524537E-09_JPRB, 0.14609977E-09_JPRB, 0.14701367E-09_JPRB, 0.14815979E-09_JPRB, 0.14968195E-09_JPRB, &
  & 0.15173197E-09_JPRB, 0.15445817E-09_JPRB, 0.15791855E-09_JPRB, 0.16214059E-09_JPRB, 0.16710623E-09_JPRB, 0.17272840E-09_JPRB, &
  & 0.17887909E-09_JPRB, 0.18538154E-09_JPRB, 0.19206768E-09_JPRB, 0.19874932E-09_JPRB, 0.20526632E-09_JPRB, 0.21146700E-09_JPRB, &
  & 0.21719106E-09_JPRB, 0.22229055E-09_JPRB, 0.22664588E-09_JPRB, 0.23019683E-09_JPRB, 0.23294219E-09_JPRB, 0.23494540E-09_JPRB, &
  & 0.23633978E-09_JPRB, 0.23729996E-09_JPRB, 0.23803282E-09_JPRB, 0.23872054E-09_JPRB, 0.23951241E-09_JPRB, 0.24051569E-09_JPRB, &
  & 0.24173299E-09_JPRB, 0.24303576E-09_JPRB, 0.24421565E-09_JPRB, 0.24502750E-09_JPRB, 0.24530375E-09_JPRB, 0.24497465E-09_JPRB, &
  & 0.24404800E-09_JPRB, 0.24255020E-09_JPRB, 0.24052188E-09_JPRB, 0.23798158E-09_JPRB, 0.23500657E-09_JPRB, 0.23169049E-09_JPRB, &
  & 0.22818498E-09_JPRB, 0.22452783E-09_JPRB, 0.22075941E-09_JPRB, 0.21691507E-09_JPRB, 0.21307614E-09_JPRB, 0.20928027E-09_JPRB, &
  & 0.20554460E-09_JPRB, 0.20192095E-09_JPRB, 0.19839733E-09_JPRB, 0.19499945E-09_JPRB, 0.19176441E-09_JPRB, 0.18871543E-09_JPRB, &
  & 0.18585253E-09_JPRB, 0.18317245E-09_JPRB, 0.18067454E-09_JPRB, 0.17836076E-09_JPRB, 0.17623437E-09_JPRB, 0.17429336E-09_JPRB, &
  & 0.17252035E-09_JPRB, 0.17085920E-09_JPRB, 0.16912652E-09_JPRB, 0.16643237E-09_JPRB /)

RGHG5(:,36, 6) = (/ &
  & 0.15191423E-09_JPRB, 0.15343551E-09_JPRB, 0.15445001E-09_JPRB, 0.15552779E-09_JPRB, 0.15680356E-09_JPRB, 0.15842638E-09_JPRB, &
  & 0.16053887E-09_JPRB, 0.16323731E-09_JPRB, 0.16659195E-09_JPRB, 0.17062825E-09_JPRB, 0.17533049E-09_JPRB, 0.18063795E-09_JPRB, &
  & 0.18642926E-09_JPRB, 0.19256081E-09_JPRB, 0.19887303E-09_JPRB, 0.20521340E-09_JPRB, 0.21142957E-09_JPRB, 0.21738195E-09_JPRB, &
  & 0.22293493E-09_JPRB, 0.22795049E-09_JPRB, 0.23230429E-09_JPRB, 0.23591257E-09_JPRB, 0.23875601E-09_JPRB, 0.24088342E-09_JPRB, &
  & 0.24241162E-09_JPRB, 0.24348901E-09_JPRB, 0.24429325E-09_JPRB, 0.24497768E-09_JPRB, 0.24566393E-09_JPRB, 0.24644004E-09_JPRB, &
  & 0.24731511E-09_JPRB, 0.24821664E-09_JPRB, 0.24900176E-09_JPRB, 0.24950544E-09_JPRB, 0.24960461E-09_JPRB, 0.24924970E-09_JPRB, &
  & 0.24843252E-09_JPRB, 0.24717695E-09_JPRB, 0.24548713E-09_JPRB, 0.24336760E-09_JPRB, 0.24083829E-09_JPRB, 0.23798730E-09_JPRB, &
  & 0.23488589E-09_JPRB, 0.23160618E-09_JPRB, 0.22814188E-09_JPRB, 0.22453900E-09_JPRB, 0.22085678E-09_JPRB, 0.21713929E-09_JPRB, &
  & 0.21344140E-09_JPRB, 0.20981564E-09_JPRB, 0.20628201E-09_JPRB, 0.20288107E-09_JPRB, 0.19965023E-09_JPRB, 0.19661869E-09_JPRB, &
  & 0.19377919E-09_JPRB, 0.19112897E-09_JPRB, 0.18866790E-09_JPRB, 0.18640822E-09_JPRB, 0.18435406E-09_JPRB, 0.18250154E-09_JPRB, &
  & 0.18082708E-09_JPRB, 0.17926806E-09_JPRB, 0.17764293E-09_JPRB, 0.17512609E-09_JPRB /)

RGHG5(:,37, 6) = (/ &
  & 0.15939736E-09_JPRB, 0.16118731E-09_JPRB, 0.16238408E-09_JPRB, 0.16359490E-09_JPRB, 0.16498565E-09_JPRB, 0.16669392E-09_JPRB, &
  & 0.16881926E-09_JPRB, 0.17145775E-09_JPRB, 0.17466248E-09_JPRB, 0.17846805E-09_JPRB, 0.18287491E-09_JPRB, 0.18782867E-09_JPRB, &
  & 0.19322646E-09_JPRB, 0.19895428E-09_JPRB, 0.20487567E-09_JPRB, 0.21085156E-09_JPRB, 0.21676008E-09_JPRB, 0.22246835E-09_JPRB, &
  & 0.22785977E-09_JPRB, 0.23280117E-09_JPRB, 0.23716187E-09_JPRB, 0.24083757E-09_JPRB, 0.24376431E-09_JPRB, 0.24597657E-09_JPRB, &
  & 0.24756200E-09_JPRB, 0.24868549E-09_JPRB, 0.24949467E-09_JPRB, 0.25013813E-09_JPRB, 0.25071450E-09_JPRB, 0.25129537E-09_JPRB, &
  & 0.25189376E-09_JPRB, 0.25247174E-09_JPRB, 0.25294694E-09_JPRB, 0.25321156E-09_JPRB, 0.25319391E-09_JPRB, 0.25284635E-09_JPRB, &
  & 0.25217325E-09_JPRB, 0.25115543E-09_JPRB, 0.24979266E-09_JPRB, 0.24805383E-09_JPRB, 0.24593497E-09_JPRB, 0.24346436E-09_JPRB, &
  & 0.24071123E-09_JPRB, 0.23771390E-09_JPRB, 0.23450261E-09_JPRB, 0.23110502E-09_JPRB, 0.22756648E-09_JPRB, 0.22393726E-09_JPRB, &
  & 0.22029069E-09_JPRB, 0.21669128E-09_JPRB, 0.21318033E-09_JPRB, 0.20980469E-09_JPRB, 0.20661846E-09_JPRB, 0.20363500E-09_JPRB, &
  & 0.20084928E-09_JPRB, 0.19825326E-09_JPRB, 0.19585496E-09_JPRB, 0.19367127E-09_JPRB, 0.19171414E-09_JPRB, 0.18997658E-09_JPRB, &
  & 0.18842808E-09_JPRB, 0.18699650E-09_JPRB, 0.18551335E-09_JPRB, 0.18320857E-09_JPRB /)

RGHG5(:,38, 6) = (/ &
  & 0.16655610E-09_JPRB, 0.16858130E-09_JPRB, 0.16994162E-09_JPRB, 0.17127050E-09_JPRB, 0.17278540E-09_JPRB, 0.17454724E-09_JPRB, &
  & 0.17666363E-09_JPRB, 0.17920156E-09_JPRB, 0.18221728E-09_JPRB, 0.18575858E-09_JPRB, 0.18983820E-09_JPRB, 0.19440960E-09_JPRB, &
  & 0.19939195E-09_JPRB, 0.20469088E-09_JPRB, 0.21019925E-09_JPRB, 0.21580238E-09_JPRB, 0.22138537E-09_JPRB, 0.22684550E-09_JPRB, &
  & 0.23206798E-09_JPRB, 0.23692270E-09_JPRB, 0.24125546E-09_JPRB, 0.24490759E-09_JPRB, 0.24780025E-09_JPRB, 0.24993752E-09_JPRB, &
  & 0.25143712E-09_JPRB, 0.25246227E-09_JPRB, 0.25318828E-09_JPRB, 0.25373806E-09_JPRB, 0.25420402E-09_JPRB, 0.25463442E-09_JPRB, &
  & 0.25504293E-09_JPRB, 0.25540917E-09_JPRB, 0.25568242E-09_JPRB, 0.25580479E-09_JPRB, 0.25572638E-09_JPRB, 0.25542765E-09_JPRB, &
  & 0.25489830E-09_JPRB, 0.25411606E-09_JPRB, 0.25306493E-09_JPRB, 0.25171090E-09_JPRB, 0.25000840E-09_JPRB, 0.24794494E-09_JPRB, &
  & 0.24554941E-09_JPRB, 0.24285624E-09_JPRB, 0.23989233E-09_JPRB, 0.23668609E-09_JPRB, 0.23329264E-09_JPRB, 0.22976936E-09_JPRB, &
  & 0.22619576E-09_JPRB, 0.22265687E-09_JPRB, 0.21919636E-09_JPRB, 0.21588221E-09_JPRB, 0.21276572E-09_JPRB, 0.20985880E-09_JPRB, &
  & 0.20715132E-09_JPRB, 0.20463203E-09_JPRB, 0.20231609E-09_JPRB, 0.20022937E-09_JPRB, 0.19839023E-09_JPRB, 0.19678774E-09_JPRB, &
  & 0.19538304E-09_JPRB, 0.19409539E-09_JPRB, 0.19276691E-09_JPRB, 0.19069980E-09_JPRB /)

RGHG5(:,39, 6) = (/ &
  & 0.17341453E-09_JPRB, 0.17567085E-09_JPRB, 0.17713755E-09_JPRB, 0.17863085E-09_JPRB, 0.18022459E-09_JPRB, 0.18205468E-09_JPRB, &
  & 0.18413264E-09_JPRB, 0.18653687E-09_JPRB, 0.18933347E-09_JPRB, 0.19258231E-09_JPRB, 0.19630385E-09_JPRB, 0.20047672E-09_JPRB, &
  & 0.20502536E-09_JPRB, 0.20988182E-09_JPRB, 0.21496159E-09_JPRB, 0.22017221E-09_JPRB, 0.22541818E-09_JPRB, 0.23060610E-09_JPRB, &
  & 0.23562660E-09_JPRB, 0.24035121E-09_JPRB, 0.24455979E-09_JPRB, 0.24806768E-09_JPRB, 0.25075053E-09_JPRB, 0.25266844E-09_JPRB, &
  & 0.25396313E-09_JPRB, 0.25483105E-09_JPRB, 0.25543431E-09_JPRB, 0.25588967E-09_JPRB, 0.25626617E-09_JPRB, 0.25659999E-09_JPRB, &
  & 0.25689828E-09_JPRB, 0.25714708E-09_JPRB, 0.25731203E-09_JPRB, 0.25736019E-09_JPRB, 0.25726213E-09_JPRB, 0.25700445E-09_JPRB, &
  & 0.25659494E-09_JPRB, 0.25598865E-09_JPRB, 0.25520064E-09_JPRB, 0.25418173E-09_JPRB, 0.25286942E-09_JPRB, 0.25123459E-09_JPRB, &
  & 0.24926425E-09_JPRB, 0.24695357E-09_JPRB, 0.24429914E-09_JPRB, 0.24134164E-09_JPRB, 0.23812924E-09_JPRB, 0.23474078E-09_JPRB, &
  & 0.23127479E-09_JPRB, 0.22782193E-09_JPRB, 0.22444614E-09_JPRB, 0.22121996E-09_JPRB, 0.21819838E-09_JPRB, 0.21538857E-09_JPRB, &
  & 0.21277458E-09_JPRB, 0.21034904E-09_JPRB, 0.20813058E-09_JPRB, 0.20615859E-09_JPRB, 0.20445336E-09_JPRB, 0.20300032E-09_JPRB, &
  & 0.20174648E-09_JPRB, 0.20061020E-09_JPRB, 0.19943577E-09_JPRB, 0.19761277E-09_JPRB /)

RGHG5(:,40, 6) = (/ &
  & 0.18003982E-09_JPRB, 0.18240159E-09_JPRB, 0.18405445E-09_JPRB, 0.18561905E-09_JPRB, 0.18737545E-09_JPRB, 0.18922487E-09_JPRB, &
  & 0.19125852E-09_JPRB, 0.19351447E-09_JPRB, 0.19606897E-09_JPRB, 0.19899642E-09_JPRB, 0.20234804E-09_JPRB, 0.20610406E-09_JPRB, &
  & 0.21021677E-09_JPRB, 0.21462560E-09_JPRB, 0.21926852E-09_JPRB, 0.22407115E-09_JPRB, 0.22895480E-09_JPRB, 0.23383387E-09_JPRB, &
  & 0.23860641E-09_JPRB, 0.24309499E-09_JPRB, 0.24709804E-09_JPRB, 0.25035077E-09_JPRB, 0.25277164E-09_JPRB, 0.25443439E-09_JPRB, &
  & 0.25552988E-09_JPRB, 0.25625310E-09_JPRB, 0.25675814E-09_JPRB, 0.25714134E-09_JPRB, 0.25745805E-09_JPRB, 0.25773331E-09_JPRB, &
  & 0.25796998E-09_JPRB, 0.25815661E-09_JPRB, 0.25826571E-09_JPRB, 0.25827646E-09_JPRB, 0.25817187E-09_JPRB, 0.25794583E-09_JPRB, &
  & 0.25760993E-09_JPRB, 0.25712435E-09_JPRB, 0.25651756E-09_JPRB, 0.25573646E-09_JPRB, 0.25473634E-09_JPRB, 0.25347965E-09_JPRB, &
  & 0.25193014E-09_JPRB, 0.25004129E-09_JPRB, 0.24777860E-09_JPRB, 0.24513405E-09_JPRB, 0.24216576E-09_JPRB, 0.23896332E-09_JPRB, &
  & 0.23563335E-09_JPRB, 0.23230107E-09_JPRB, 0.22903854E-09_JPRB, 0.22592343E-09_JPRB, 0.22301587E-09_JPRB, 0.22031649E-09_JPRB, &
  & 0.21780781E-09_JPRB, 0.21548327E-09_JPRB, 0.21337507E-09_JPRB, 0.21152659E-09_JPRB, 0.20996603E-09_JPRB, 0.20866599E-09_JPRB, &
  & 0.20756541E-09_JPRB, 0.20657261E-09_JPRB, 0.20555298E-09_JPRB, 0.20395576E-09_JPRB /)

RGHG5(:,41, 6) = (/ &
  & 0.18636874E-09_JPRB, 0.18891247E-09_JPRB, 0.19059125E-09_JPRB, 0.19236199E-09_JPRB, 0.19417010E-09_JPRB, 0.19609450E-09_JPRB, &
  & 0.19806230E-09_JPRB, 0.20015717E-09_JPRB, 0.20245966E-09_JPRB, 0.20506449E-09_JPRB, 0.20802726E-09_JPRB, 0.21136662E-09_JPRB, &
  & 0.21504359E-09_JPRB, 0.21901074E-09_JPRB, 0.22321553E-09_JPRB, 0.22760367E-09_JPRB, 0.23210167E-09_JPRB, 0.23663640E-09_JPRB, &
  & 0.24110150E-09_JPRB, 0.24532365E-09_JPRB, 0.24902508E-09_JPRB, 0.25199851E-09_JPRB, 0.25415242E-09_JPRB, 0.25560312E-09_JPRB, &
  & 0.25654248E-09_JPRB, 0.25716054E-09_JPRB, 0.25759500E-09_JPRB, 0.25792846E-09_JPRB, 0.25820490E-09_JPRB, 0.25844343E-09_JPRB, &
  & 0.25864461E-09_JPRB, 0.25879554E-09_JPRB, 0.25887545E-09_JPRB, 0.25886582E-09_JPRB, 0.25876162E-09_JPRB, 0.25855559E-09_JPRB, &
  & 0.25826807E-09_JPRB, 0.25786290E-09_JPRB, 0.25737004E-09_JPRB, 0.25675545E-09_JPRB, 0.25597460E-09_JPRB, 0.25500890E-09_JPRB, &
  & 0.25381292E-09_JPRB, 0.25232072E-09_JPRB, 0.25046218E-09_JPRB, 0.24818961E-09_JPRB, 0.24552213E-09_JPRB, 0.24254659E-09_JPRB, &
  & 0.23939642E-09_JPRB, 0.23620825E-09_JPRB, 0.23308580E-09_JPRB, 0.23010122E-09_JPRB, 0.22732038E-09_JPRB, 0.22474067E-09_JPRB, &
  & 0.22234170E-09_JPRB, 0.22012724E-09_JPRB, 0.21812965E-09_JPRB, 0.21641273E-09_JPRB, 0.21499660E-09_JPRB, 0.21384731E-09_JPRB, &
  & 0.21289007E-09_JPRB, 0.21203488E-09_JPRB, 0.21115028E-09_JPRB, 0.20976552E-09_JPRB /)

RGHG5(:,42, 6) = (/ &
  & 0.19253965E-09_JPRB, 0.19509756E-09_JPRB, 0.19692872E-09_JPRB, 0.19873045E-09_JPRB, 0.20071519E-09_JPRB, 0.20264689E-09_JPRB, &
  & 0.20456122E-09_JPRB, 0.20649654E-09_JPRB, 0.20855212E-09_JPRB, 0.21082802E-09_JPRB, 0.21341268E-09_JPRB, 0.21633900E-09_JPRB, &
  & 0.21958968E-09_JPRB, 0.22312610E-09_JPRB, 0.22690259E-09_JPRB, 0.23086592E-09_JPRB, 0.23496649E-09_JPRB, 0.23912294E-09_JPRB, &
  & 0.24324351E-09_JPRB, 0.24714614E-09_JPRB, 0.25057281E-09_JPRB, 0.25326327E-09_JPRB, 0.25517649E-09_JPRB, 0.25644123E-09_JPRB, &
  & 0.25725605E-09_JPRB, 0.25779526E-09_JPRB, 0.25817845E-09_JPRB, 0.25847588E-09_JPRB, 0.25872446E-09_JPRB, 0.25893848E-09_JPRB, &
  & 0.25911712E-09_JPRB, 0.25924765E-09_JPRB, 0.25931052E-09_JPRB, 0.25929026E-09_JPRB, 0.25918823E-09_JPRB, 0.25899774E-09_JPRB, &
  & 0.25874311E-09_JPRB, 0.25839061E-09_JPRB, 0.25797864E-09_JPRB, 0.25747138E-09_JPRB, 0.25684968E-09_JPRB, 0.25609442E-09_JPRB, &
  & 0.25516703E-09_JPRB, 0.25400662E-09_JPRB, 0.25252389E-09_JPRB, 0.25063801E-09_JPRB, 0.24831595E-09_JPRB, 0.24561977E-09_JPRB, &
  & 0.24267932E-09_JPRB, 0.23966421E-09_JPRB, 0.23669947E-09_JPRB, 0.23386326E-09_JPRB, 0.23121946E-09_JPRB, 0.22876834E-09_JPRB, &
  & 0.22648652E-09_JPRB, 0.22437995E-09_JPRB, 0.22250102E-09_JPRB, 0.22091193E-09_JPRB, 0.21963681E-09_JPRB, 0.21862723E-09_JPRB, &
  & 0.21780081E-09_JPRB, 0.21706474E-09_JPRB, 0.21630292E-09_JPRB, 0.21509575E-09_JPRB /)

RGHG5(:,43, 6) = (/ &
  & 0.19852364E-09_JPRB, 0.20117311E-09_JPRB, 0.20295246E-09_JPRB, 0.20491801E-09_JPRB, 0.20693668E-09_JPRB, 0.20893648E-09_JPRB, &
  & 0.21078167E-09_JPRB, 0.21256497E-09_JPRB, 0.21438301E-09_JPRB, 0.21635266E-09_JPRB, 0.21856902E-09_JPRB, 0.22109641E-09_JPRB, &
  & 0.22393824E-09_JPRB, 0.22706206E-09_JPRB, 0.23041846E-09_JPRB, 0.23396754E-09_JPRB, 0.23764732E-09_JPRB, 0.24140998E-09_JPRB, &
  & 0.24515262E-09_JPRB, 0.24872232E-09_JPRB, 0.25183816E-09_JPRB, 0.25427835E-09_JPRB, 0.25597924E-09_JPRB, 0.25708902E-09_JPRB, &
  & 0.25780084E-09_JPRB, 0.25827662E-09_JPRB, 0.25862051E-09_JPRB, 0.25889110E-09_JPRB, 0.25911900E-09_JPRB, 0.25931612E-09_JPRB, &
  & 0.25948055E-09_JPRB, 0.25959801E-09_JPRB, 0.25965133E-09_JPRB, 0.25962640E-09_JPRB, 0.25952659E-09_JPRB, 0.25935012E-09_JPRB, &
  & 0.25911615E-09_JPRB, 0.25880598E-09_JPRB, 0.25844332E-09_JPRB, 0.25801863E-09_JPRB, 0.25750591E-09_JPRB, 0.25690386E-09_JPRB, &
  & 0.25618185E-09_JPRB, 0.25528368E-09_JPRB, 0.25412911E-09_JPRB, 0.25262009E-09_JPRB, 0.25067373E-09_JPRB, 0.24829822E-09_JPRB, &
  & 0.24560737E-09_JPRB, 0.24278782E-09_JPRB, 0.23999092E-09_JPRB, 0.23731558E-09_JPRB, 0.23481928E-09_JPRB, 0.23250415E-09_JPRB, &
  & 0.23034481E-09_JPRB, 0.22835693E-09_JPRB, 0.22659424E-09_JPRB, 0.22513419E-09_JPRB, 0.22399023E-09_JPRB, 0.22310681E-09_JPRB, &
  & 0.22239237E-09_JPRB, 0.22175943E-09_JPRB, 0.22109581E-09_JPRB, 0.22003634E-09_JPRB /)

RGHG5(:,44, 6) = (/ &
  & 0.20451403E-09_JPRB, 0.20703822E-09_JPRB, 0.20889900E-09_JPRB, 0.21080304E-09_JPRB, 0.21296676E-09_JPRB, 0.21495813E-09_JPRB, &
  & 0.21676072E-09_JPRB, 0.21839772E-09_JPRB, 0.22000116E-09_JPRB, 0.22168214E-09_JPRB, 0.22356271E-09_JPRB, 0.22571349E-09_JPRB, &
  & 0.22816900E-09_JPRB, 0.23089811E-09_JPRB, 0.23385935E-09_JPRB, 0.23698679E-09_JPRB, 0.24025104E-09_JPRB, 0.24358537E-09_JPRB, &
  & 0.24694105E-09_JPRB, 0.25013958E-09_JPRB, 0.25295629E-09_JPRB, 0.25512659E-09_JPRB, 0.25663571E-09_JPRB, 0.25761046E-09_JPRB, &
  & 0.25823849E-09_JPRB, 0.25866301E-09_JPRB, 0.25897540E-09_JPRB, 0.25922509E-09_JPRB, 0.25943794E-09_JPRB, 0.25962332E-09_JPRB, &
  & 0.25977809E-09_JPRB, 0.25988833E-09_JPRB, 0.25993602E-09_JPRB, 0.25990979E-09_JPRB, 0.25981328E-09_JPRB, 0.25964830E-09_JPRB, &
  & 0.25943037E-09_JPRB, 0.25914823E-09_JPRB, 0.25882554E-09_JPRB, 0.25845479E-09_JPRB, 0.25802535E-09_JPRB, 0.25753580E-09_JPRB, &
  & 0.25696650E-09_JPRB, 0.25627728E-09_JPRB, 0.25539948E-09_JPRB, 0.25423091E-09_JPRB, 0.25267535E-09_JPRB, 0.25066049E-09_JPRB, &
  & 0.24826960E-09_JPRB, 0.24566563E-09_JPRB, 0.24305402E-09_JPRB, 0.24055191E-09_JPRB, 0.23821417E-09_JPRB, 0.23604674E-09_JPRB, &
  & 0.23402313E-09_JPRB, 0.23215863E-09_JPRB, 0.23052228E-09_JPRB, 0.22918550E-09_JPRB, 0.22816468E-09_JPRB, 0.22738905E-09_JPRB, &
  & 0.22677143E-09_JPRB, 0.22621907E-09_JPRB, 0.22563851E-09_JPRB, 0.22468905E-09_JPRB /)

RGHG5(:,45, 6) = (/ &
  & 0.21049673E-09_JPRB, 0.21296823E-09_JPRB, 0.21461309E-09_JPRB, 0.21661928E-09_JPRB, 0.21872550E-09_JPRB, 0.22079964E-09_JPRB, &
  & 0.22252428E-09_JPRB, 0.22404319E-09_JPRB, 0.22544409E-09_JPRB, 0.22687946E-09_JPRB, 0.22844554E-09_JPRB, 0.23025951E-09_JPRB, &
  & 0.23235039E-09_JPRB, 0.23471611E-09_JPRB, 0.23728605E-09_JPRB, 0.24002103E-09_JPRB, 0.24284622E-09_JPRB, 0.24575450E-09_JPRB, &
  & 0.24866334E-09_JPRB, 0.25148889E-09_JPRB, 0.25394664E-09_JPRB, 0.25587005E-09_JPRB, 0.25718655E-09_JPRB, 0.25804470E-09_JPRB, &
  & 0.25860017E-09_JPRB, 0.25898308E-09_JPRB, 0.25927011E-09_JPRB, 0.25950372E-09_JPRB, 0.25970526E-09_JPRB, 0.25988273E-09_JPRB, &
  & 0.26003166E-09_JPRB, 0.26013758E-09_JPRB, 0.26018301E-09_JPRB, 0.26015773E-09_JPRB, 0.26006508E-09_JPRB, 0.25990990E-09_JPRB, &
  & 0.25970315E-09_JPRB, 0.25944358E-09_JPRB, 0.25914648E-09_JPRB, 0.25881874E-09_JPRB, 0.25844876E-09_JPRB, 0.25804281E-09_JPRB, &
  & 0.25759067E-09_JPRB, 0.25706154E-09_JPRB, 0.25640290E-09_JPRB, 0.25553609E-09_JPRB, 0.25434102E-09_JPRB, 0.25273605E-09_JPRB, &
  & 0.25068361E-09_JPRB, 0.24835708E-09_JPRB, 0.24594918E-09_JPRB, 0.24363617E-09_JPRB, 0.24147764E-09_JPRB, 0.23946942E-09_JPRB, &
  & 0.23759839E-09_JPRB, 0.23587710E-09_JPRB, 0.23436952E-09_JPRB, 0.23315846E-09_JPRB, 0.23224542E-09_JPRB, 0.23156611E-09_JPRB, &
  & 0.23102255E-09_JPRB, 0.23053974E-09_JPRB, 0.23001760E-09_JPRB, 0.22915904E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART11',1,ZHOOK_HANDLE)
END SUBROUTINE PART11




SUBROUTINE PART12
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART12',0,ZHOOK_HANDLE)



RGHG5(:,46, 6) = (/ &
  & 0.21618575E-09_JPRB, 0.21857052E-09_JPRB, 0.22035926E-09_JPRB, 0.22217783E-09_JPRB, 0.22444376E-09_JPRB, 0.22645394E-09_JPRB, &
  & 0.22817345E-09_JPRB, 0.22955443E-09_JPRB, 0.23079494E-09_JPRB, 0.23199183E-09_JPRB, 0.23330093E-09_JPRB, 0.23479363E-09_JPRB, &
  & 0.23655944E-09_JPRB, 0.23857036E-09_JPRB, 0.24078572E-09_JPRB, 0.24310906E-09_JPRB, 0.24552069E-09_JPRB, 0.24795777E-09_JPRB, &
  & 0.25042346E-09_JPRB, 0.25277053E-09_JPRB, 0.25487784E-09_JPRB, 0.25650818E-09_JPRB, 0.25765864E-09_JPRB, 0.25840799E-09_JPRB, &
  & 0.25890473E-09_JPRB, 0.25925276E-09_JPRB, 0.25951974E-09_JPRB, 0.25974062E-09_JPRB, 0.25993432E-09_JPRB, 0.26010649E-09_JPRB, &
  & 0.26025215E-09_JPRB, 0.26035638E-09_JPRB, 0.26040176E-09_JPRB, 0.26037913E-09_JPRB, 0.26029104E-09_JPRB, 0.26014368E-09_JPRB, &
  & 0.25994626E-09_JPRB, 0.25970101E-09_JPRB, 0.25942615E-09_JPRB, 0.25912725E-09_JPRB, 0.25880306E-09_JPRB, 0.25846081E-09_JPRB, &
  & 0.25809432E-09_JPRB, 0.25768662E-09_JPRB, 0.25720009E-09_JPRB, 0.25656702E-09_JPRB, 0.25570523E-09_JPRB, 0.25448563E-09_JPRB, &
  & 0.25286095E-09_JPRB, 0.25086128E-09_JPRB, 0.24872876E-09_JPRB, 0.24662733E-09_JPRB, 0.24465735E-09_JPRB, 0.24283300E-09_JPRB, &
  & 0.24113178E-09_JPRB, 0.23956206E-09_JPRB, 0.23819577E-09_JPRB, 0.23710070E-09_JPRB, 0.23628910E-09_JPRB, 0.23568525E-09_JPRB, &
  & 0.23520702E-09_JPRB, 0.23477309E-09_JPRB, 0.23430408E-09_JPRB, 0.23350799E-09_JPRB /)

RGHG5(:,47, 6) = (/ &
  & 0.22238050E-09_JPRB, 0.22454374E-09_JPRB, 0.22601851E-09_JPRB, 0.22792523E-09_JPRB, 0.23002650E-09_JPRB, 0.23215679E-09_JPRB, &
  & 0.23377122E-09_JPRB, 0.23506513E-09_JPRB, 0.23612379E-09_JPRB, 0.23713503E-09_JPRB, 0.23818275E-09_JPRB, 0.23940733E-09_JPRB, &
  & 0.24085167E-09_JPRB, 0.24254135E-09_JPRB, 0.24438945E-09_JPRB, 0.24633692E-09_JPRB, 0.24829483E-09_JPRB, 0.25026078E-09_JPRB, &
  & 0.25218500E-09_JPRB, 0.25405308E-09_JPRB, 0.25571736E-09_JPRB, 0.25708310E-09_JPRB, 0.25805613E-09_JPRB, 0.25871660E-09_JPRB, &
  & 0.25916169E-09_JPRB, 0.25948235E-09_JPRB, 0.25973296E-09_JPRB, 0.25994470E-09_JPRB, 0.26013258E-09_JPRB, 0.26030181E-09_JPRB, &
  & 0.26044616E-09_JPRB, 0.26055050E-09_JPRB, 0.26059765E-09_JPRB, 0.26057878E-09_JPRB, 0.26049574E-09_JPRB, 0.26035493E-09_JPRB, &
  & 0.26016397E-09_JPRB, 0.25993085E-09_JPRB, 0.25967109E-09_JPRB, 0.25939506E-09_JPRB, 0.25910568E-09_JPRB, 0.25880886E-09_JPRB, &
  & 0.25850813E-09_JPRB, 0.25818978E-09_JPRB, 0.25782745E-09_JPRB, 0.25738150E-09_JPRB, 0.25677488E-09_JPRB, 0.25592600E-09_JPRB, &
  & 0.25471977E-09_JPRB, 0.25317445E-09_JPRB, 0.25137145E-09_JPRB, 0.24955354E-09_JPRB, 0.24780905E-09_JPRB, 0.24618249E-09_JPRB, &
  & 0.24466074E-09_JPRB, 0.24325666E-09_JPRB, 0.24201996E-09_JPRB, 0.24103725E-09_JPRB, 0.24030919E-09_JPRB, 0.23977167E-09_JPRB, &
  & 0.23934144E-09_JPRB, 0.23894994E-09_JPRB, 0.23851693E-09_JPRB, 0.23777472E-09_JPRB /)

RGHG5(:,48, 6) = (/ &
  & 0.22782173E-09_JPRB, 0.23009875E-09_JPRB, 0.23177539E-09_JPRB, 0.23357671E-09_JPRB, 0.23584884E-09_JPRB, 0.23790328E-09_JPRB, &
  & 0.23952332E-09_JPRB, 0.24066985E-09_JPRB, 0.24158361E-09_JPRB, 0.24238306E-09_JPRB, 0.24321692E-09_JPRB, 0.24415897E-09_JPRB, &
  & 0.24531280E-09_JPRB, 0.24666777E-09_JPRB, 0.24816366E-09_JPRB, 0.24968488E-09_JPRB, 0.25117339E-09_JPRB, 0.25258781E-09_JPRB, &
  & 0.25393943E-09_JPRB, 0.25525435E-09_JPRB, 0.25649952E-09_JPRB, 0.25757349E-09_JPRB, 0.25839872E-09_JPRB, 0.25897617E-09_JPRB, &
  & 0.25938071E-09_JPRB, 0.25967872E-09_JPRB, 0.25991700E-09_JPRB, 0.26012142E-09_JPRB, 0.26030578E-09_JPRB, 0.26047339E-09_JPRB, &
  & 0.26061792E-09_JPRB, 0.26072380E-09_JPRB, 0.26077415E-09_JPRB, 0.26075989E-09_JPRB, 0.26068223E-09_JPRB, 0.26054639E-09_JPRB, &
  & 0.26036148E-09_JPRB, 0.26013683E-09_JPRB, 0.25988992E-09_JPRB, 0.25963129E-09_JPRB, 0.25936617E-09_JPRB, 0.25910560E-09_JPRB, &
  & 0.25885083E-09_JPRB, 0.25859787E-09_JPRB, 0.25832961E-09_JPRB, 0.25801358E-09_JPRB, 0.25760916E-09_JPRB, 0.25704455E-09_JPRB, &
  & 0.25625327E-09_JPRB, 0.25516414E-09_JPRB, 0.25385838E-09_JPRB, 0.25239966E-09_JPRB, 0.25096683E-09_JPRB, 0.24957486E-09_JPRB, &
  & 0.24824950E-09_JPRB, 0.24699526E-09_JPRB, 0.24587915E-09_JPRB, 0.24498151E-09_JPRB, 0.24432112E-09_JPRB, 0.24383173E-09_JPRB, &
  & 0.24343844E-09_JPRB, 0.24307600E-09_JPRB, 0.24267013E-09_JPRB, 0.24196439E-09_JPRB /)

RGHG5(:,49, 6) = (/ &
  & 0.23343377E-09_JPRB, 0.23586005E-09_JPRB, 0.23753494E-09_JPRB, 0.23944230E-09_JPRB, 0.24167174E-09_JPRB, 0.24380029E-09_JPRB, &
  & 0.24530067E-09_JPRB, 0.24632091E-09_JPRB, 0.24705060E-09_JPRB, 0.24766622E-09_JPRB, 0.24826227E-09_JPRB, 0.24895597E-09_JPRB, &
  & 0.24979477E-09_JPRB, 0.25080302E-09_JPRB, 0.25189023E-09_JPRB, 0.25294267E-09_JPRB, 0.25389155E-09_JPRB, 0.25473249E-09_JPRB, &
  & 0.25553593E-09_JPRB, 0.25632671E-09_JPRB, 0.25718516E-09_JPRB, 0.25799987E-09_JPRB, 0.25868457E-09_JPRB, 0.25919666E-09_JPRB, &
  & 0.25956762E-09_JPRB, 0.25984842E-09_JPRB, 0.26007690E-09_JPRB, 0.26027630E-09_JPRB, 0.26045810E-09_JPRB, 0.26062547E-09_JPRB, &
  & 0.26077121E-09_JPRB, 0.26087965E-09_JPRB, 0.26093408E-09_JPRB, 0.26092492E-09_JPRB, 0.26085253E-09_JPRB, 0.26072117E-09_JPRB, &
  & 0.26054114E-09_JPRB, 0.26032460E-09_JPRB, 0.26008734E-09_JPRB, 0.25984184E-09_JPRB, 0.25959632E-09_JPRB, 0.25935978E-09_JPRB, &
  & 0.25914101E-09_JPRB, 0.25893571E-09_JPRB, 0.25873326E-09_JPRB, 0.25851254E-09_JPRB, 0.25824576E-09_JPRB, 0.25789351E-09_JPRB, &
  & 0.25740826E-09_JPRB, 0.25676114E-09_JPRB, 0.25592939E-09_JPRB, 0.25499711E-09_JPRB, 0.25396091E-09_JPRB, 0.25291597E-09_JPRB, &
  & 0.25184496E-09_JPRB, 0.25076571E-09_JPRB, 0.24975963E-09_JPRB, 0.24893640E-09_JPRB, 0.24832009E-09_JPRB, 0.24786706E-09_JPRB, &
  & 0.24749647E-09_JPRB, 0.24715291E-09_JPRB, 0.24675995E-09_JPRB, 0.24606972E-09_JPRB /)

RGHG5(:,50, 6) = (/ &
  & 0.23912367E-09_JPRB, 0.24151778E-09_JPRB, 0.24311470E-09_JPRB, 0.24497770E-09_JPRB, 0.24712876E-09_JPRB, 0.24909544E-09_JPRB, &
  & 0.25041169E-09_JPRB, 0.25122471E-09_JPRB, 0.25176641E-09_JPRB, 0.25218649E-09_JPRB, 0.25259389E-09_JPRB, 0.25303323E-09_JPRB, &
  & 0.25358843E-09_JPRB, 0.25423766E-09_JPRB, 0.25490648E-09_JPRB, 0.25550542E-09_JPRB, 0.25599861E-09_JPRB, 0.25641539E-09_JPRB, &
  & 0.25679175E-09_JPRB, 0.25724498E-09_JPRB, 0.25775357E-09_JPRB, 0.25836278E-09_JPRB, 0.25892549E-09_JPRB, 0.25938290E-09_JPRB, &
  & 0.25972910E-09_JPRB, 0.25999691E-09_JPRB, 0.26021826E-09_JPRB, 0.26041369E-09_JPRB, 0.26059394E-09_JPRB, 0.26076147E-09_JPRB, &
  & 0.26090896E-09_JPRB, 0.26102071E-09_JPRB, 0.26107977E-09_JPRB, 0.26107594E-09_JPRB, 0.26100846E-09_JPRB, 0.26088090E-09_JPRB, &
  & 0.26070676E-09_JPRB, 0.26049585E-09_JPRB, 0.26026814E-09_JPRB, 0.26003294E-09_JPRB, 0.25980051E-09_JPRB, 0.25958372E-09_JPRB, &
  & 0.25938970E-09_JPRB, 0.25922184E-09_JPRB, 0.25906624E-09_JPRB, 0.25891170E-09_JPRB, 0.25873509E-09_JPRB, 0.25852070E-09_JPRB, &
  & 0.25824040E-09_JPRB, 0.25788152E-09_JPRB, 0.25744576E-09_JPRB, 0.25692082E-09_JPRB, 0.25635621E-09_JPRB, 0.25571562E-09_JPRB, &
  & 0.25500632E-09_JPRB, 0.25423622E-09_JPRB, 0.25343683E-09_JPRB, 0.25273622E-09_JPRB, 0.25220925E-09_JPRB, 0.25179620E-09_JPRB, &
  & 0.25146238E-09_JPRB, 0.25113137E-09_JPRB, 0.25075109E-09_JPRB, 0.25004110E-09_JPRB /)

RGHG5(:,51, 6) = (/ &
  & 0.24415900E-09_JPRB, 0.24636115E-09_JPRB, 0.24794078E-09_JPRB, 0.24950370E-09_JPRB, 0.25139849E-09_JPRB, 0.25298663E-09_JPRB, &
  & 0.25399166E-09_JPRB, 0.25455374E-09_JPRB, 0.25491345E-09_JPRB, 0.25518859E-09_JPRB, 0.25543104E-09_JPRB, 0.25571309E-09_JPRB, &
  & 0.25603786E-09_JPRB, 0.25642605E-09_JPRB, 0.25680402E-09_JPRB, 0.25711772E-09_JPRB, 0.25735561E-09_JPRB, 0.25753913E-09_JPRB, &
  & 0.25772690E-09_JPRB, 0.25793059E-09_JPRB, 0.25826047E-09_JPRB, 0.25866112E-09_JPRB, 0.25912930E-09_JPRB, 0.25954250E-09_JPRB, &
  & 0.25987032E-09_JPRB, 0.26012925E-09_JPRB, 0.26034555E-09_JPRB, 0.26053795E-09_JPRB, 0.26071695E-09_JPRB, 0.26088473E-09_JPRB, &
  & 0.26103411E-09_JPRB, 0.26114930E-09_JPRB, 0.26121322E-09_JPRB, 0.26121463E-09_JPRB, 0.26115160E-09_JPRB, 0.26102925E-09_JPRB, &
  & 0.26085825E-09_JPRB, 0.26065577E-09_JPRB, 0.26043423E-09_JPRB, 0.26020802E-09_JPRB, 0.25998617E-09_JPRB, 0.25978242E-09_JPRB, &
  & 0.25961117E-09_JPRB, 0.25946853E-09_JPRB, 0.25935037E-09_JPRB, 0.25923710E-09_JPRB, 0.25912228E-09_JPRB, 0.25898692E-09_JPRB, &
  & 0.25882771E-09_JPRB, 0.25863361E-09_JPRB, 0.25840610E-09_JPRB, 0.25815683E-09_JPRB, 0.25787120E-09_JPRB, 0.25756428E-09_JPRB, &
  & 0.25721611E-09_JPRB, 0.25679106E-09_JPRB, 0.25633351E-09_JPRB, 0.25590255E-09_JPRB, 0.25553290E-09_JPRB, 0.25525196E-09_JPRB, &
  & 0.25498431E-09_JPRB, 0.25472122E-09_JPRB, 0.25436486E-09_JPRB, 0.25370711E-09_JPRB /)

RGHG5(:,52, 6) = (/ &
  & 0.24868274E-09_JPRB, 0.25049016E-09_JPRB, 0.25158656E-09_JPRB, 0.25288427E-09_JPRB, 0.25427141E-09_JPRB, 0.25546387E-09_JPRB, &
  & 0.25613467E-09_JPRB, 0.25650987E-09_JPRB, 0.25673824E-09_JPRB, 0.25690527E-09_JPRB, 0.25706637E-09_JPRB, 0.25722788E-09_JPRB, &
  & 0.25743879E-09_JPRB, 0.25767005E-09_JPRB, 0.25789382E-09_JPRB, 0.25806601E-09_JPRB, 0.25818692E-09_JPRB, 0.25828029E-09_JPRB, &
  & 0.25836072E-09_JPRB, 0.25848421E-09_JPRB, 0.25864685E-09_JPRB, 0.25894351E-09_JPRB, 0.25930433E-09_JPRB, 0.25968078E-09_JPRB, &
  & 0.25999647E-09_JPRB, 0.26024960E-09_JPRB, 0.26046237E-09_JPRB, 0.26065244E-09_JPRB, 0.26083014E-09_JPRB, 0.26099800E-09_JPRB, &
  & 0.26114891E-09_JPRB, 0.26126754E-09_JPRB, 0.26133606E-09_JPRB, 0.26134267E-09_JPRB, 0.26128483E-09_JPRB, 0.26116562E-09_JPRB, &
  & 0.26100189E-09_JPRB, 0.26080288E-09_JPRB, 0.26058972E-09_JPRB, 0.26036953E-09_JPRB, 0.26015554E-09_JPRB, 0.25996538E-09_JPRB, &
  & 0.25980876E-09_JPRB, 0.25969052E-09_JPRB, 0.25959515E-09_JPRB, 0.25951472E-09_JPRB, 0.25943325E-09_JPRB, 0.25934921E-09_JPRB, &
  & 0.25925118E-09_JPRB, 0.25914326E-09_JPRB, 0.25902497E-09_JPRB, 0.25889582E-09_JPRB, 0.25876778E-09_JPRB, 0.25863026E-09_JPRB, &
  & 0.25847322E-09_JPRB, 0.25829958E-09_JPRB, 0.25809491E-09_JPRB, 0.25789171E-09_JPRB, 0.25772978E-09_JPRB, 0.25757532E-09_JPRB, &
  & 0.25744029E-09_JPRB, 0.25727206E-09_JPRB, 0.25705271E-09_JPRB, 0.25651709E-09_JPRB /)

RGHG5(:,53, 6) = (/ &
  & 0.25197777E-09_JPRB, 0.25334515E-09_JPRB, 0.25427255E-09_JPRB, 0.25515137E-09_JPRB, 0.25617861E-09_JPRB, 0.25697722E-09_JPRB, &
  & 0.25743691E-09_JPRB, 0.25767277E-09_JPRB, 0.25781818E-09_JPRB, 0.25792909E-09_JPRB, 0.25802360E-09_JPRB, 0.25813740E-09_JPRB, &
  & 0.25826286E-09_JPRB, 0.25841781E-09_JPRB, 0.25855751E-09_JPRB, 0.25866198E-09_JPRB, 0.25873187E-09_JPRB, 0.25877858E-09_JPRB, &
  & 0.25882796E-09_JPRB, 0.25888308E-09_JPRB, 0.25899999E-09_JPRB, 0.25917460E-09_JPRB, 0.25947142E-09_JPRB, 0.25980751E-09_JPRB, &
  & 0.26011138E-09_JPRB, 0.26036096E-09_JPRB, 0.26057123E-09_JPRB, 0.26075947E-09_JPRB, 0.26093572E-09_JPRB, 0.26110328E-09_JPRB, &
  & 0.26125541E-09_JPRB, 0.26137681E-09_JPRB, 0.26144978E-09_JPRB, 0.26146169E-09_JPRB, 0.26140826E-09_JPRB, 0.26129554E-09_JPRB, &
  & 0.26113445E-09_JPRB, 0.26094332E-09_JPRB, 0.26073380E-09_JPRB, 0.26051938E-09_JPRB, 0.26031380E-09_JPRB, 0.26013286E-09_JPRB, &
  & 0.25999314E-09_JPRB, 0.25989036E-09_JPRB, 0.25981567E-09_JPRB, 0.25975322E-09_JPRB, 0.25969729E-09_JPRB, 0.25963776E-09_JPRB, &
  & 0.25957642E-09_JPRB, 0.25950947E-09_JPRB, 0.25944058E-09_JPRB, 0.25937502E-09_JPRB, 0.25930941E-09_JPRB, 0.25924543E-09_JPRB, &
  & 0.25918012E-09_JPRB, 0.25910102E-09_JPRB, 0.25901689E-09_JPRB, 0.25893671E-09_JPRB, 0.25886182E-09_JPRB, 0.25880398E-09_JPRB, &
  & 0.25873984E-09_JPRB, 0.25867242E-09_JPRB, 0.25856223E-09_JPRB, 0.25829611E-09_JPRB /)

RGHG5(:,54, 6) = (/ &
  & 0.25467514E-09_JPRB, 0.25557370E-09_JPRB, 0.25612218E-09_JPRB, 0.25674854E-09_JPRB, 0.25742306E-09_JPRB, 0.25796767E-09_JPRB, &
  & 0.25826072E-09_JPRB, 0.25841931E-09_JPRB, 0.25851460E-09_JPRB, 0.25858379E-09_JPRB, 0.25865177E-09_JPRB, 0.25871905E-09_JPRB, &
  & 0.25881097E-09_JPRB, 0.25891075E-09_JPRB, 0.25900709E-09_JPRB, 0.25907551E-09_JPRB, 0.25911817E-09_JPRB, 0.25914831E-09_JPRB, &
  & 0.25917210E-09_JPRB, 0.25921237E-09_JPRB, 0.25927083E-09_JPRB, 0.25940830E-09_JPRB, 0.25962632E-09_JPRB, 0.25992758E-09_JPRB, &
  & 0.26022060E-09_JPRB, 0.26046573E-09_JPRB, 0.26067404E-09_JPRB, 0.26086022E-09_JPRB, 0.26103567E-09_JPRB, 0.26120234E-09_JPRB, &
  & 0.26135513E-09_JPRB, 0.26147870E-09_JPRB, 0.26155558E-09_JPRB, 0.26157260E-09_JPRB, 0.26152502E-09_JPRB, 0.26141661E-09_JPRB, &
  & 0.26126215E-09_JPRB, 0.26107419E-09_JPRB, 0.26086935E-09_JPRB, 0.26066027E-09_JPRB, 0.26046063E-09_JPRB, 0.26029229E-09_JPRB, &
  & 0.26016447E-09_JPRB, 0.26007663E-09_JPRB, 0.26001504E-09_JPRB, 0.25996791E-09_JPRB, 0.25992447E-09_JPRB, 0.25988228E-09_JPRB, &
  & 0.25983649E-09_JPRB, 0.25979072E-09_JPRB, 0.25974661E-09_JPRB, 0.25970470E-09_JPRB, 0.25966904E-09_JPRB, 0.25963598E-09_JPRB, &
  & 0.25960142E-09_JPRB, 0.25956676E-09_JPRB, 0.25952746E-09_JPRB, 0.25948979E-09_JPRB, 0.25946162E-09_JPRB, 0.25943503E-09_JPRB, &
  & 0.25941410E-09_JPRB, 0.25939231E-09_JPRB, 0.25937671E-09_JPRB, 0.25938587E-09_JPRB /)

RGHG5(:,55, 6) = (/ &
  & 0.25634886E-09_JPRB, 0.25701610E-09_JPRB, 0.25742725E-09_JPRB, 0.25783775E-09_JPRB, 0.25828009E-09_JPRB, 0.25863406E-09_JPRB, &
  & 0.25883551E-09_JPRB, 0.25893884E-09_JPRB, 0.25900262E-09_JPRB, 0.25905145E-09_JPRB, 0.25909355E-09_JPRB, 0.25914482E-09_JPRB, &
  & 0.25920208E-09_JPRB, 0.25927580E-09_JPRB, 0.25934230E-09_JPRB, 0.25939045E-09_JPRB, 0.25941982E-09_JPRB, 0.25943703E-09_JPRB, &
  & 0.25945340E-09_JPRB, 0.25947297E-09_JPRB, 0.25951985E-09_JPRB, 0.25960495E-09_JPRB, 0.25978672E-09_JPRB, 0.26005015E-09_JPRB, &
  & 0.26032637E-09_JPRB, 0.26056635E-09_JPRB, 0.26077174E-09_JPRB, 0.26095714E-09_JPRB, 0.26113062E-09_JPRB, 0.26129721E-09_JPRB, &
  & 0.26144970E-09_JPRB, 0.26157485E-09_JPRB, 0.26165492E-09_JPRB, 0.26167665E-09_JPRB, 0.26163455E-09_JPRB, 0.26153263E-09_JPRB, &
  & 0.26138253E-09_JPRB, 0.26119895E-09_JPRB, 0.26099775E-09_JPRB, 0.26079222E-09_JPRB, 0.26060187E-09_JPRB, 0.26044278E-09_JPRB, &
  & 0.26032776E-09_JPRB, 0.26025129E-09_JPRB, 0.26020033E-09_JPRB, 0.26016247E-09_JPRB, 0.26012914E-09_JPRB, 0.26009428E-09_JPRB, &
  & 0.26005820E-09_JPRB, 0.26002114E-09_JPRB, 0.25998600E-09_JPRB, 0.25995683E-09_JPRB, 0.25993163E-09_JPRB, 0.25990968E-09_JPRB, &
  & 0.25988989E-09_JPRB, 0.25986763E-09_JPRB, 0.25984565E-09_JPRB, 0.25982630E-09_JPRB, 0.25980904E-09_JPRB, 0.25979630E-09_JPRB, &
  & 0.25978281E-09_JPRB, 0.25976962E-09_JPRB, 0.25975236E-09_JPRB, 0.25972846E-09_JPRB /)

RGHG5(:,56, 6) = (/ &
  & 0.25776659E-09_JPRB, 0.25811470E-09_JPRB, 0.25835292E-09_JPRB, 0.25860639E-09_JPRB, 0.25889663E-09_JPRB, 0.25912433E-09_JPRB, &
  & 0.25925651E-09_JPRB, 0.25932914E-09_JPRB, 0.25937336E-09_JPRB, 0.25940602E-09_JPRB, 0.25943797E-09_JPRB, 0.25947050E-09_JPRB, &
  & 0.25951494E-09_JPRB, 0.25956481E-09_JPRB, 0.25961458E-09_JPRB, 0.25964997E-09_JPRB, 0.25967009E-09_JPRB, 0.25968150E-09_JPRB, &
  & 0.25968891E-09_JPRB, 0.25970240E-09_JPRB, 0.25972824E-09_JPRB, 0.25979915E-09_JPRB, 0.25994246E-09_JPRB, 0.26017505E-09_JPRB, &
  & 0.26043376E-09_JPRB, 0.26066527E-09_JPRB, 0.26086769E-09_JPRB, 0.26105057E-09_JPRB, 0.26122404E-09_JPRB, 0.26138888E-09_JPRB, &
  & 0.26154140E-09_JPRB, 0.26166699E-09_JPRB, 0.26174909E-09_JPRB, 0.26177494E-09_JPRB, 0.26173855E-09_JPRB, 0.26164276E-09_JPRB, &
  & 0.26149785E-09_JPRB, 0.26131847E-09_JPRB, 0.26111971E-09_JPRB, 0.26092029E-09_JPRB, 0.26073627E-09_JPRB, 0.26058894E-09_JPRB, &
  & 0.26048436E-09_JPRB, 0.26041716E-09_JPRB, 0.26037450E-09_JPRB, 0.26034380E-09_JPRB, 0.26031616E-09_JPRB, 0.26028699E-09_JPRB, &
  & 0.26025429E-09_JPRB, 0.26022057E-09_JPRB, 0.26018962E-09_JPRB, 0.26016256E-09_JPRB, 0.26014138E-09_JPRB, 0.26012376E-09_JPRB, &
  & 0.26010652E-09_JPRB, 0.26009039E-09_JPRB, 0.26007388E-09_JPRB, 0.26005909E-09_JPRB, 0.26004837E-09_JPRB, 0.26003841E-09_JPRB, &
  & 0.26002989E-09_JPRB, 0.26001973E-09_JPRB, 0.26000871E-09_JPRB, 0.25998978E-09_JPRB /)

RGHG5(:,57, 6) = (/ &
  & 0.25858141E-09_JPRB, 0.25883753E-09_JPRB, 0.25899705E-09_JPRB, 0.25917224E-09_JPRB, 0.25934541E-09_JPRB, 0.25949831E-09_JPRB, &
  & 0.25958938E-09_JPRB, 0.25963962E-09_JPRB, 0.25967106E-09_JPRB, 0.25969554E-09_JPRB, 0.25971725E-09_JPRB, 0.25974323E-09_JPRB, &
  & 0.25977320E-09_JPRB, 0.25981201E-09_JPRB, 0.25984892E-09_JPRB, 0.25987631E-09_JPRB, 0.25989114E-09_JPRB, 0.25989691E-09_JPRB, &
  & 0.25989921E-09_JPRB, 0.25990379E-09_JPRB, 0.25992292E-09_JPRB, 0.25997388E-09_JPRB, 0.26009805E-09_JPRB, 0.26030622E-09_JPRB, &
  & 0.26054406E-09_JPRB, 0.26076530E-09_JPRB, 0.26096286E-09_JPRB, 0.26114477E-09_JPRB, 0.26131589E-09_JPRB, 0.26148037E-09_JPRB, &
  & 0.26163136E-09_JPRB, 0.26175659E-09_JPRB, 0.26183977E-09_JPRB, 0.26186875E-09_JPRB, 0.26183750E-09_JPRB, 0.26174790E-09_JPRB, &
  & 0.26160871E-09_JPRB, 0.26143279E-09_JPRB, 0.26123900E-09_JPRB, 0.26104341E-09_JPRB, 0.26086919E-09_JPRB, 0.26073080E-09_JPRB, &
  & 0.26063593E-09_JPRB, 0.26057667E-09_JPRB, 0.26053990E-09_JPRB, 0.26051439E-09_JPRB, 0.26049118E-09_JPRB, 0.26046529E-09_JPRB, &
  & 0.26043520E-09_JPRB, 0.26040253E-09_JPRB, 0.26037048E-09_JPRB, 0.26034375E-09_JPRB, 0.26032176E-09_JPRB, 0.26030306E-09_JPRB, &
  & 0.26028682E-09_JPRB, 0.26027006E-09_JPRB, 0.26025443E-09_JPRB, 0.26024174E-09_JPRB, 0.26023098E-09_JPRB, 0.26022276E-09_JPRB, &
  & 0.26021396E-09_JPRB, 0.26020461E-09_JPRB, 0.26019117E-09_JPRB, 0.26016714E-09_JPRB /)

RGHG5(:,58, 6) = (/ &
  & 0.25920910E-09_JPRB, 0.25936936E-09_JPRB, 0.25947805E-09_JPRB, 0.25958241E-09_JPRB, 0.25970309E-09_JPRB, 0.25979890E-09_JPRB, &
  & 0.25986269E-09_JPRB, 0.25989894E-09_JPRB, 0.25992267E-09_JPRB, 0.25994051E-09_JPRB, 0.25995828E-09_JPRB, 0.25997693E-09_JPRB, &
  & 0.26000171E-09_JPRB, 0.26003064E-09_JPRB, 0.26006072E-09_JPRB, 0.26008307E-09_JPRB, 0.26009400E-09_JPRB, 0.26009556E-09_JPRB, &
  & 0.26009234E-09_JPRB, 0.26009023E-09_JPRB, 0.26009953E-09_JPRB, 0.26014246E-09_JPRB, 0.26025235E-09_JPRB, 0.26043884E-09_JPRB, &
  & 0.26065827E-09_JPRB, 0.26086835E-09_JPRB, 0.26106109E-09_JPRB, 0.26123956E-09_JPRB, 0.26140989E-09_JPRB, 0.26157188E-09_JPRB, &
  & 0.26172145E-09_JPRB, 0.26184538E-09_JPRB, 0.26192831E-09_JPRB, 0.26195948E-09_JPRB, 0.26193253E-09_JPRB, 0.26184868E-09_JPRB, &
  & 0.26171484E-09_JPRB, 0.26154473E-09_JPRB, 0.26135441E-09_JPRB, 0.26116662E-09_JPRB, 0.26099925E-09_JPRB, 0.26087102E-09_JPRB, &
  & 0.26078420E-09_JPRB, 0.26073077E-09_JPRB, 0.26069899E-09_JPRB, 0.26067698E-09_JPRB, 0.26065688E-09_JPRB, 0.26063363E-09_JPRB, &
  & 0.26060548E-09_JPRB, 0.26057340E-09_JPRB, 0.26054045E-09_JPRB, 0.26051056E-09_JPRB, 0.26048563E-09_JPRB, 0.26046482E-09_JPRB, &
  & 0.26044497E-09_JPRB, 0.26042657E-09_JPRB, 0.26040953E-09_JPRB, 0.26039487E-09_JPRB, 0.26038430E-09_JPRB, 0.26037461E-09_JPRB, &
  & 0.26036570E-09_JPRB, 0.26035496E-09_JPRB, 0.26034139E-09_JPRB, 0.26031402E-09_JPRB /)

RGHG5(:,59, 6) = (/ &
  & 0.25963251E-09_JPRB, 0.25975916E-09_JPRB, 0.25983357E-09_JPRB, 0.25991032E-09_JPRB, 0.25998348E-09_JPRB, 0.26005217E-09_JPRB, &
  & 0.26009633E-09_JPRB, 0.26012431E-09_JPRB, 0.26014221E-09_JPRB, 0.26015728E-09_JPRB, 0.26017097E-09_JPRB, 0.26018759E-09_JPRB, &
  & 0.26020713E-09_JPRB, 0.26023234E-09_JPRB, 0.26025787E-09_JPRB, 0.26027758E-09_JPRB, 0.26028618E-09_JPRB, 0.26028377E-09_JPRB, &
  & 0.26027425E-09_JPRB, 0.26026509E-09_JPRB, 0.26026731E-09_JPRB, 0.26030281E-09_JPRB, 0.26040264E-09_JPRB, 0.26057387E-09_JPRB, &
  & 0.26077585E-09_JPRB, 0.26097555E-09_JPRB, 0.26116231E-09_JPRB, 0.26133840E-09_JPRB, 0.26150557E-09_JPRB, 0.26166563E-09_JPRB, &
  & 0.26181229E-09_JPRB, 0.26193392E-09_JPRB, 0.26201596E-09_JPRB, 0.26204794E-09_JPRB, 0.26202421E-09_JPRB, 0.26194544E-09_JPRB, &
  & 0.26181785E-09_JPRB, 0.26165273E-09_JPRB, 0.26146990E-09_JPRB, 0.26128755E-09_JPRB, 0.26113015E-09_JPRB, 0.26100971E-09_JPRB, &
  & 0.26092956E-09_JPRB, 0.26088151E-09_JPRB, 0.26085273E-09_JPRB, 0.26083347E-09_JPRB, 0.26081542E-09_JPRB, 0.26079416E-09_JPRB, &
  & 0.26076794E-09_JPRB, 0.26073704E-09_JPRB, 0.26070335E-09_JPRB, 0.26067071E-09_JPRB, 0.26064201E-09_JPRB, 0.26061620E-09_JPRB, &
  & 0.26059277E-09_JPRB, 0.26057001E-09_JPRB, 0.26054908E-09_JPRB, 0.26053287E-09_JPRB, 0.26051933E-09_JPRB, 0.26050859E-09_JPRB, &
  & 0.26049751E-09_JPRB, 0.26048536E-09_JPRB, 0.26046848E-09_JPRB, 0.26043753E-09_JPRB /)

RGHG5(:,60, 6) = (/ &
  & 0.25997790E-09_JPRB, 0.26006602E-09_JPRB, 0.26012029E-09_JPRB, 0.26016991E-09_JPRB, 0.26022404E-09_JPRB, 0.26026964E-09_JPRB, &
  & 0.26030406E-09_JPRB, 0.26032515E-09_JPRB, 0.26034086E-09_JPRB, 0.26035318E-09_JPRB, 0.26036626E-09_JPRB, 0.26038033E-09_JPRB, &
  & 0.26039923E-09_JPRB, 0.26042168E-09_JPRB, 0.26044600E-09_JPRB, 0.26046473E-09_JPRB, 0.26047178E-09_JPRB, 0.26046532E-09_JPRB, &
  & 0.26044944E-09_JPRB, 0.26043190E-09_JPRB, 0.26042729E-09_JPRB, 0.26045782E-09_JPRB, 0.26055094E-09_JPRB, 0.26070748E-09_JPRB, &
  & 0.26089597E-09_JPRB, 0.26108596E-09_JPRB, 0.26126779E-09_JPRB, 0.26144001E-09_JPRB, 0.26160452E-09_JPRB, 0.26176120E-09_JPRB, &
  & 0.26190450E-09_JPRB, 0.26202290E-09_JPRB, 0.26210256E-09_JPRB, 0.26213440E-09_JPRB, 0.26211294E-09_JPRB, 0.26203895E-09_JPRB, &
  & 0.26191704E-09_JPRB, 0.26175967E-09_JPRB, 0.26158276E-09_JPRB, 0.26141020E-09_JPRB, 0.26126007E-09_JPRB, 0.26114783E-09_JPRB, &
  & 0.26107372E-09_JPRB, 0.26102875E-09_JPRB, 0.26100291E-09_JPRB, 0.26098521E-09_JPRB, 0.26096869E-09_JPRB, 0.26094876E-09_JPRB, &
  & 0.26092414E-09_JPRB, 0.26089472E-09_JPRB, 0.26086147E-09_JPRB, 0.26082722E-09_JPRB, 0.26079455E-09_JPRB, 0.26076433E-09_JPRB, &
  & 0.26073543E-09_JPRB, 0.26070723E-09_JPRB, 0.26068225E-09_JPRB, 0.26066105E-09_JPRB, 0.26064526E-09_JPRB, 0.26063107E-09_JPRB, &
  & 0.26061764E-09_JPRB, 0.26060204E-09_JPRB, 0.26058197E-09_JPRB, 0.26054320E-09_JPRB /)

RGHG5(:,61, 6) = (/ &
  & 0.26024125E-09_JPRB, 0.26031233E-09_JPRB, 0.26035316E-09_JPRB, 0.26039151E-09_JPRB, 0.26042896E-09_JPRB, 0.26046479E-09_JPRB, &
  & 0.26049074E-09_JPRB, 0.26050967E-09_JPRB, 0.26052299E-09_JPRB, 0.26053543E-09_JPRB, 0.26054736E-09_JPRB, 0.26056252E-09_JPRB, &
  & 0.26058061E-09_JPRB, 0.26060418E-09_JPRB, 0.26062849E-09_JPRB, 0.26064739E-09_JPRB, 0.26065308E-09_JPRB, 0.26064223E-09_JPRB, &
  & 0.26061894E-09_JPRB, 0.26059405E-09_JPRB, 0.26058317E-09_JPRB, 0.26060962E-09_JPRB, 0.26069519E-09_JPRB, 0.26084068E-09_JPRB, &
  & 0.26101704E-09_JPRB, 0.26119956E-09_JPRB, 0.26137623E-09_JPRB, 0.26154515E-09_JPRB, 0.26170630E-09_JPRB, 0.26185934E-09_JPRB, &
  & 0.26199812E-09_JPRB, 0.26211208E-09_JPRB, 0.26218841E-09_JPRB, 0.26221897E-09_JPRB, 0.26219907E-09_JPRB, 0.26212921E-09_JPRB, &
  & 0.26201405E-09_JPRB, 0.26186361E-09_JPRB, 0.26169650E-09_JPRB, 0.26153157E-09_JPRB, 0.26139119E-09_JPRB, 0.26128585E-09_JPRB, &
  & 0.26121608E-09_JPRB, 0.26117453E-09_JPRB, 0.26114988E-09_JPRB, 0.26113342E-09_JPRB, 0.26111782E-09_JPRB, 0.26109903E-09_JPRB, &
  & 0.26107566E-09_JPRB, 0.26104752E-09_JPRB, 0.26101538E-09_JPRB, 0.26098085E-09_JPRB, 0.26094582E-09_JPRB, 0.26091154E-09_JPRB, &
  & 0.26087724E-09_JPRB, 0.26084418E-09_JPRB, 0.26081259E-09_JPRB, 0.26078736E-09_JPRB, 0.26076624E-09_JPRB, 0.26074859E-09_JPRB, &
  & 0.26073085E-09_JPRB, 0.26071090E-09_JPRB, 0.26068414E-09_JPRB, 0.26063485E-09_JPRB /)

RGHG5(:,62, 6) = (/ &
  & 0.26046629E-09_JPRB, 0.26052210E-09_JPRB, 0.26055408E-09_JPRB, 0.26058319E-09_JPRB, 0.26061348E-09_JPRB, 0.26064112E-09_JPRB, &
  & 0.26066407E-09_JPRB, 0.26068042E-09_JPRB, 0.26069419E-09_JPRB, 0.26070612E-09_JPRB, 0.26071981E-09_JPRB, 0.26073529E-09_JPRB, &
  & 0.26075647E-09_JPRB, 0.26078154E-09_JPRB, 0.26080810E-09_JPRB, 0.26082742E-09_JPRB, 0.26083105E-09_JPRB, 0.26081504E-09_JPRB, &
  & 0.26078506E-09_JPRB, 0.26075314E-09_JPRB, 0.26073702E-09_JPRB, 0.26075864E-09_JPRB, 0.26083768E-09_JPRB, 0.26097274E-09_JPRB, &
  & 0.26113989E-09_JPRB, 0.26131536E-09_JPRB, 0.26148775E-09_JPRB, 0.26165334E-09_JPRB, 0.26181107E-09_JPRB, 0.26195981E-09_JPRB, &
  & 0.26209315E-09_JPRB, 0.26220176E-09_JPRB, 0.26227354E-09_JPRB, 0.26230207E-09_JPRB, 0.26228297E-09_JPRB, 0.26221722E-09_JPRB, &
  & 0.26210847E-09_JPRB, 0.26196689E-09_JPRB, 0.26180838E-09_JPRB, 0.26165431E-09_JPRB, 0.26152208E-09_JPRB, 0.26142358E-09_JPRB, &
  & 0.26135835E-09_JPRB, 0.26131819E-09_JPRB, 0.26129485E-09_JPRB, 0.26127875E-09_JPRB, 0.26126376E-09_JPRB, 0.26124589E-09_JPRB, &
  & 0.26122376E-09_JPRB, 0.26119690E-09_JPRB, 0.26116578E-09_JPRB, 0.26113153E-09_JPRB, 0.26109559E-09_JPRB, 0.26105793E-09_JPRB, &
  & 0.26102048E-09_JPRB, 0.26098171E-09_JPRB, 0.26094588E-09_JPRB, 0.26091385E-09_JPRB, 0.26088814E-09_JPRB, 0.26086491E-09_JPRB, &
  & 0.26084207E-09_JPRB, 0.26081581E-09_JPRB, 0.26078109E-09_JPRB, 0.26071423E-09_JPRB /)

RGHG5(:,63, 6) = (/ &
  & 0.26065280E-09_JPRB, 0.26070215E-09_JPRB, 0.26073016E-09_JPRB, 0.26075531E-09_JPRB, 0.26078043E-09_JPRB, 0.26080499E-09_JPRB, &
  & 0.26082525E-09_JPRB, 0.26084196E-09_JPRB, 0.26085567E-09_JPRB, 0.26086974E-09_JPRB, 0.26088448E-09_JPRB, 0.26090391E-09_JPRB, &
  & 0.26092761E-09_JPRB, 0.26095714E-09_JPRB, 0.26098571E-09_JPRB, 0.26100466E-09_JPRB, 0.26100519E-09_JPRB, 0.26098435E-09_JPRB, &
  & 0.26094849E-09_JPRB, 0.26091088E-09_JPRB, 0.26088970E-09_JPRB, 0.26090652E-09_JPRB, 0.26097885E-09_JPRB, 0.26110544E-09_JPRB, &
  & 0.26126412E-09_JPRB, 0.26143371E-09_JPRB, 0.26160213E-09_JPRB, 0.26176405E-09_JPRB, 0.26191815E-09_JPRB, 0.26206168E-09_JPRB, &
  & 0.26218916E-09_JPRB, 0.26229108E-09_JPRB, 0.26235752E-09_JPRB, 0.26238312E-09_JPRB, 0.26236463E-09_JPRB, 0.26230285E-09_JPRB, &
  & 0.26220126E-09_JPRB, 0.26206826E-09_JPRB, 0.26192068E-09_JPRB, 0.26177632E-09_JPRB, 0.26165339E-09_JPRB, 0.26156127E-09_JPRB, &
  & 0.26149918E-09_JPRB, 0.26146102E-09_JPRB, 0.26143773E-09_JPRB, 0.26142188E-09_JPRB, 0.26140720E-09_JPRB, 0.26139010E-09_JPRB, &
  & 0.26136912E-09_JPRB, 0.26134359E-09_JPRB, 0.26131364E-09_JPRB, 0.26128008E-09_JPRB, 0.26124347E-09_JPRB, 0.26120464E-09_JPRB, &
  & 0.26116359E-09_JPRB, 0.26112237E-09_JPRB, 0.26108110E-09_JPRB, 0.26104480E-09_JPRB, 0.26101249E-09_JPRB, 0.26098412E-09_JPRB, &
  & 0.26095531E-09_JPRB, 0.26092256E-09_JPRB, 0.26087710E-09_JPRB, 0.26079228E-09_JPRB /)

RGHG5(:,64, 6) = (/ &
  & 0.26081595E-09_JPRB, 0.26086266E-09_JPRB, 0.26088856E-09_JPRB, 0.26091151E-09_JPRB, 0.26093469E-09_JPRB, 0.26095709E-09_JPRB, &
  & 0.26097724E-09_JPRB, 0.26099400E-09_JPRB, 0.26100988E-09_JPRB, 0.26102537E-09_JPRB, 0.26104430E-09_JPRB, 0.26106697E-09_JPRB, &
  & 0.26109720E-09_JPRB, 0.26113095E-09_JPRB, 0.26116162E-09_JPRB, 0.26117933E-09_JPRB, 0.26117586E-09_JPRB, 0.26114977E-09_JPRB, &
  & 0.26110900E-09_JPRB, 0.26106659E-09_JPRB, 0.26104091E-09_JPRB, 0.26105296E-09_JPRB, 0.26111915E-09_JPRB, 0.26123831E-09_JPRB, &
  & 0.26138949E-09_JPRB, 0.26155358E-09_JPRB, 0.26171765E-09_JPRB, 0.26187585E-09_JPRB, 0.26202490E-09_JPRB, 0.26216271E-09_JPRB, &
  & 0.26228289E-09_JPRB, 0.26237776E-09_JPRB, 0.26243835E-09_JPRB, 0.26246053E-09_JPRB, 0.26244240E-09_JPRB, 0.26238486E-09_JPRB, &
  & 0.26229049E-09_JPRB, 0.26216726E-09_JPRB, 0.26203037E-09_JPRB, 0.26189712E-09_JPRB, 0.26178301E-09_JPRB, 0.26169689E-09_JPRB, &
  & 0.26163832E-09_JPRB, 0.26160102E-09_JPRB, 0.26157795E-09_JPRB, 0.26156177E-09_JPRB, 0.26154720E-09_JPRB, 0.26153077E-09_JPRB, &
  & 0.26151104E-09_JPRB, 0.26148697E-09_JPRB, 0.26145844E-09_JPRB, 0.26142580E-09_JPRB, 0.26138938E-09_JPRB, 0.26134950E-09_JPRB, &
  & 0.26130711E-09_JPRB, 0.26126279E-09_JPRB, 0.26121899E-09_JPRB, 0.26117750E-09_JPRB, 0.26114080E-09_JPRB, 0.26110661E-09_JPRB, &
  & 0.26107283E-09_JPRB, 0.26103328E-09_JPRB, 0.26098007E-09_JPRB, 0.26087454E-09_JPRB /)

RGHG5(:,65, 6) = (/ &
  & 0.26095995E-09_JPRB, 0.26100735E-09_JPRB, 0.26103344E-09_JPRB, 0.26105618E-09_JPRB, 0.26107866E-09_JPRB, 0.26110075E-09_JPRB, &
  & 0.26112079E-09_JPRB, 0.26113930E-09_JPRB, 0.26115657E-09_JPRB, 0.26117611E-09_JPRB, 0.26119820E-09_JPRB, 0.26122790E-09_JPRB, &
  & 0.26126332E-09_JPRB, 0.26130098E-09_JPRB, 0.26133182E-09_JPRB, 0.26134617E-09_JPRB, 0.26133912E-09_JPRB, 0.26131028E-09_JPRB, &
  & 0.26126618E-09_JPRB, 0.26121993E-09_JPRB, 0.26119051E-09_JPRB, 0.26119829E-09_JPRB, 0.26125913E-09_JPRB, 0.26137098E-09_JPRB, &
  & 0.26151561E-09_JPRB, 0.26167357E-09_JPRB, 0.26183289E-09_JPRB, 0.26198574E-09_JPRB, 0.26212910E-09_JPRB, 0.26225927E-09_JPRB, &
  & 0.26237149E-09_JPRB, 0.26245847E-09_JPRB, 0.26251315E-09_JPRB, 0.26253225E-09_JPRB, 0.26251462E-09_JPRB, 0.26246139E-09_JPRB, &
  & 0.26237484E-09_JPRB, 0.26226171E-09_JPRB, 0.26213637E-09_JPRB, 0.26201399E-09_JPRB, 0.26190911E-09_JPRB, 0.26182909E-09_JPRB, &
  & 0.26177352E-09_JPRB, 0.26173744E-09_JPRB, 0.26171426E-09_JPRB, 0.26169780E-09_JPRB, 0.26168320E-09_JPRB, 0.26166755E-09_JPRB, &
  & 0.26164901E-09_JPRB, 0.26162661E-09_JPRB, 0.26159985E-09_JPRB, 0.26156849E-09_JPRB, 0.26153277E-09_JPRB, 0.26149288E-09_JPRB, &
  & 0.26144925E-09_JPRB, 0.26140351E-09_JPRB, 0.26135688E-09_JPRB, 0.26131247E-09_JPRB, 0.26127120E-09_JPRB, 0.26123317E-09_JPRB, &
  & 0.26119459E-09_JPRB, 0.26115174E-09_JPRB, 0.26108882E-09_JPRB, 0.26097122E-09_JPRB /)

RGHG5(:,66, 6) = (/ &
  & 0.26108971E-09_JPRB, 0.26114055E-09_JPRB, 0.26116831E-09_JPRB, 0.26119215E-09_JPRB, 0.26121533E-09_JPRB, 0.26123803E-09_JPRB, &
  & 0.26125913E-09_JPRB, 0.26127886E-09_JPRB, 0.26129937E-09_JPRB, 0.26132158E-09_JPRB, 0.26135014E-09_JPRB, 0.26138483E-09_JPRB, &
  & 0.26142633E-09_JPRB, 0.26146649E-09_JPRB, 0.26149566E-09_JPRB, 0.26150818E-09_JPRB, 0.26149838E-09_JPRB, 0.26146632E-09_JPRB, &
  & 0.26141955E-09_JPRB, 0.26137087E-09_JPRB, 0.26133873E-09_JPRB, 0.26134311E-09_JPRB, 0.26139838E-09_JPRB, 0.26150404E-09_JPRB, &
  & 0.26164118E-09_JPRB, 0.26179264E-09_JPRB, 0.26194533E-09_JPRB, 0.26209193E-09_JPRB, 0.26222741E-09_JPRB, 0.26234923E-09_JPRB, &
  & 0.26245242E-09_JPRB, 0.26253122E-09_JPRB, 0.26258021E-09_JPRB, 0.26259653E-09_JPRB, 0.26257990E-09_JPRB, 0.26253116E-09_JPRB, &
  & 0.26245273E-09_JPRB, 0.26235014E-09_JPRB, 0.26223640E-09_JPRB, 0.26212546E-09_JPRB, 0.26202945E-09_JPRB, 0.26195582E-09_JPRB, &
  & 0.26190350E-09_JPRB, 0.26186878E-09_JPRB, 0.26184582E-09_JPRB, 0.26182920E-09_JPRB, 0.26181490E-09_JPRB, 0.26179994E-09_JPRB, &
  & 0.26178279E-09_JPRB, 0.26176222E-09_JPRB, 0.26173735E-09_JPRB, 0.26170771E-09_JPRB, 0.26167318E-09_JPRB, 0.26163388E-09_JPRB, &
  & 0.26159008E-09_JPRB, 0.26154334E-09_JPRB, 0.26149510E-09_JPRB, 0.26144817E-09_JPRB, 0.26140412E-09_JPRB, 0.26136260E-09_JPRB, &
  & 0.26132166E-09_JPRB, 0.26127420E-09_JPRB, 0.26120872E-09_JPRB, 0.26107577E-09_JPRB /)

RGHG5(:,67, 6) = (/ &
  & 0.26120844E-09_JPRB, 0.26126504E-09_JPRB, 0.26129598E-09_JPRB, 0.26132205E-09_JPRB, 0.26134744E-09_JPRB, 0.26137120E-09_JPRB, &
  & 0.26139421E-09_JPRB, 0.26141578E-09_JPRB, 0.26143893E-09_JPRB, 0.26146596E-09_JPRB, 0.26149857E-09_JPRB, 0.26153932E-09_JPRB, &
  & 0.26158339E-09_JPRB, 0.26162236E-09_JPRB, 0.26165003E-09_JPRB, 0.26166025E-09_JPRB, 0.26164879E-09_JPRB, 0.26161634E-09_JPRB, &
  & 0.26156893E-09_JPRB, 0.26151942E-09_JPRB, 0.26148569E-09_JPRB, 0.26148722E-09_JPRB, 0.26153793E-09_JPRB, 0.26163596E-09_JPRB, &
  & 0.26176591E-09_JPRB, 0.26190913E-09_JPRB, 0.26205385E-09_JPRB, 0.26219216E-09_JPRB, 0.26231872E-09_JPRB, 0.26243116E-09_JPRB, &
  & 0.26252495E-09_JPRB, 0.26259578E-09_JPRB, 0.26263922E-09_JPRB, 0.26265329E-09_JPRB, 0.26263794E-09_JPRB, 0.26259406E-09_JPRB, &
  & 0.26252350E-09_JPRB, 0.26243163E-09_JPRB, 0.26232949E-09_JPRB, 0.26222952E-09_JPRB, 0.26214289E-09_JPRB, 0.26207536E-09_JPRB, &
  & 0.26202696E-09_JPRB, 0.26199393E-09_JPRB, 0.26197172E-09_JPRB, 0.26195537E-09_JPRB, 0.26194158E-09_JPRB, 0.26192773E-09_JPRB, &
  & 0.26191210E-09_JPRB, 0.26189359E-09_JPRB, 0.26187086E-09_JPRB, 0.26184321E-09_JPRB, 0.26181030E-09_JPRB, 0.26177216E-09_JPRB, &
  & 0.26172886E-09_JPRB, 0.26168193E-09_JPRB, 0.26163283E-09_JPRB, 0.26158445E-09_JPRB, 0.26153865E-09_JPRB, 0.26149533E-09_JPRB, &
  & 0.26145200E-09_JPRB, 0.26140398E-09_JPRB, 0.26133129E-09_JPRB, 0.26119013E-09_JPRB /)

RGHG5(:,68, 6) = (/ &
  & 0.26131297E-09_JPRB, 0.26138153E-09_JPRB, 0.26141758E-09_JPRB, 0.26144825E-09_JPRB, 0.26147601E-09_JPRB, 0.26150326E-09_JPRB, &
  & 0.26152680E-09_JPRB, 0.26155189E-09_JPRB, 0.26157707E-09_JPRB, 0.26160837E-09_JPRB, 0.26164518E-09_JPRB, 0.26168850E-09_JPRB, &
  & 0.26173222E-09_JPRB, 0.26177033E-09_JPRB, 0.26179639E-09_JPRB, 0.26180563E-09_JPRB, 0.26179370E-09_JPRB, 0.26176120E-09_JPRB, &
  & 0.26171434E-09_JPRB, 0.26166541E-09_JPRB, 0.26163147E-09_JPRB, 0.26163099E-09_JPRB, 0.26167635E-09_JPRB, 0.26176702E-09_JPRB, &
  & 0.26188782E-09_JPRB, 0.26202179E-09_JPRB, 0.26215705E-09_JPRB, 0.26228558E-09_JPRB, 0.26240243E-09_JPRB, 0.26250502E-09_JPRB, &
  & 0.26258962E-09_JPRB, 0.26265271E-09_JPRB, 0.26269109E-09_JPRB, 0.26270322E-09_JPRB, 0.26268951E-09_JPRB, 0.26265035E-09_JPRB, &
  & 0.26258773E-09_JPRB, 0.26250602E-09_JPRB, 0.26241509E-09_JPRB, 0.26232594E-09_JPRB, 0.26224806E-09_JPRB, 0.26218730E-09_JPRB, &
  & 0.26214289E-09_JPRB, 0.26211222E-09_JPRB, 0.26209127E-09_JPRB, 0.26207569E-09_JPRB, 0.26206293E-09_JPRB, 0.26205038E-09_JPRB, &
  & 0.26203664E-09_JPRB, 0.26202024E-09_JPRB, 0.26199989E-09_JPRB, 0.26197453E-09_JPRB, 0.26194366E-09_JPRB, 0.26190713E-09_JPRB, &
  & 0.26186506E-09_JPRB, 0.26181862E-09_JPRB, 0.26176961E-09_JPRB, 0.26172092E-09_JPRB, 0.26167446E-09_JPRB, 0.26163038E-09_JPRB, &
  & 0.26158675E-09_JPRB, 0.26153760E-09_JPRB, 0.26146532E-09_JPRB, 0.26131583E-09_JPRB /)

RGHG5(:,69, 6) = (/ &
  & 0.26141114E-09_JPRB, 0.26149399E-09_JPRB, 0.26153804E-09_JPRB, 0.26157282E-09_JPRB, 0.26160563E-09_JPRB, 0.26163360E-09_JPRB, &
  & 0.26166147E-09_JPRB, 0.26168587E-09_JPRB, 0.26171634E-09_JPRB, 0.26174851E-09_JPRB, 0.26178854E-09_JPRB, 0.26183122E-09_JPRB, &
  & 0.26187399E-09_JPRB, 0.26191010E-09_JPRB, 0.26193450E-09_JPRB, 0.26194291E-09_JPRB, 0.26193137E-09_JPRB, 0.26190056E-09_JPRB, &
  & 0.26185581E-09_JPRB, 0.26180894E-09_JPRB, 0.26177610E-09_JPRB, 0.26177382E-09_JPRB, 0.26181404E-09_JPRB, 0.26189576E-09_JPRB, &
  & 0.26200669E-09_JPRB, 0.26213007E-09_JPRB, 0.26225455E-09_JPRB, 0.26237262E-09_JPRB, 0.26247893E-09_JPRB, 0.26257194E-09_JPRB, &
  & 0.26264724E-09_JPRB, 0.26270319E-09_JPRB, 0.26273683E-09_JPRB, 0.26274743E-09_JPRB, 0.26273536E-09_JPRB, 0.26270111E-09_JPRB, &
  & 0.26264593E-09_JPRB, 0.26257407E-09_JPRB, 0.26249380E-09_JPRB, 0.26241484E-09_JPRB, 0.26234576E-09_JPRB, 0.26229158E-09_JPRB, &
  & 0.26225161E-09_JPRB, 0.26222383E-09_JPRB, 0.26220451E-09_JPRB, 0.26219038E-09_JPRB, 0.26217883E-09_JPRB, 0.26216801E-09_JPRB, &
  & 0.26215619E-09_JPRB, 0.26214211E-09_JPRB, 0.26212421E-09_JPRB, 0.26210140E-09_JPRB, 0.26207289E-09_JPRB, 0.26203853E-09_JPRB, &
  & 0.26199831E-09_JPRB, 0.26195326E-09_JPRB, 0.26190536E-09_JPRB, 0.26185748E-09_JPRB, 0.26181174E-09_JPRB, 0.26176827E-09_JPRB, &
  & 0.26172506E-09_JPRB, 0.26167740E-09_JPRB, 0.26160377E-09_JPRB, 0.26145014E-09_JPRB /)

RGHG5(:,70, 6) = (/ &
  & 0.26150679E-09_JPRB, 0.26160762E-09_JPRB, 0.26165942E-09_JPRB, 0.26170047E-09_JPRB, 0.26173563E-09_JPRB, 0.26176755E-09_JPRB, &
  & 0.26179447E-09_JPRB, 0.26182373E-09_JPRB, 0.26185260E-09_JPRB, 0.26188882E-09_JPRB, 0.26192679E-09_JPRB, 0.26196895E-09_JPRB, &
  & 0.26200939E-09_JPRB, 0.26204358E-09_JPRB, 0.26206670E-09_JPRB, 0.26207458E-09_JPRB, 0.26206362E-09_JPRB, 0.26203520E-09_JPRB, &
  & 0.26199373E-09_JPRB, 0.26195032E-09_JPRB, 0.26191896E-09_JPRB, 0.26191543E-09_JPRB, 0.26194985E-09_JPRB, 0.26202218E-09_JPRB, &
  & 0.26212185E-09_JPRB, 0.26223365E-09_JPRB, 0.26234664E-09_JPRB, 0.26245339E-09_JPRB, 0.26254932E-09_JPRB, 0.26263242E-09_JPRB, &
  & 0.26269892E-09_JPRB, 0.26274802E-09_JPRB, 0.26277736E-09_JPRB, 0.26278654E-09_JPRB, 0.26277619E-09_JPRB, 0.26274669E-09_JPRB, &
  & 0.26269881E-09_JPRB, 0.26263614E-09_JPRB, 0.26256591E-09_JPRB, 0.26249675E-09_JPRB, 0.26243621E-09_JPRB, 0.26238864E-09_JPRB, &
  & 0.26235339E-09_JPRB, 0.26232869E-09_JPRB, 0.26231153E-09_JPRB, 0.26229907E-09_JPRB, 0.26228913E-09_JPRB, 0.26227998E-09_JPRB, &
  & 0.26227021E-09_JPRB, 0.26225844E-09_JPRB, 0.26224314E-09_JPRB, 0.26222305E-09_JPRB, 0.26219737E-09_JPRB, 0.26216573E-09_JPRB, &
  & 0.26212812E-09_JPRB, 0.26208544E-09_JPRB, 0.26203961E-09_JPRB, 0.26199395E-09_JPRB, 0.26195007E-09_JPRB, 0.26190891E-09_JPRB, &
  & 0.26186747E-09_JPRB, 0.26182226E-09_JPRB, 0.26175162E-09_JPRB, 0.26159663E-09_JPRB /)

RGHG5(:,71, 6) = (/ &
  & 0.26160363E-09_JPRB, 0.26172711E-09_JPRB, 0.26178620E-09_JPRB, 0.26183244E-09_JPRB, 0.26187011E-09_JPRB, 0.26190314E-09_JPRB, &
  & 0.26193206E-09_JPRB, 0.26196020E-09_JPRB, 0.26199259E-09_JPRB, 0.26202496E-09_JPRB, 0.26206345E-09_JPRB, 0.26210181E-09_JPRB, &
  & 0.26214000E-09_JPRB, 0.26217117E-09_JPRB, 0.26219221E-09_JPRB, 0.26219965E-09_JPRB, 0.26219021E-09_JPRB, 0.26216473E-09_JPRB, &
  & 0.26212715E-09_JPRB, 0.26208785E-09_JPRB, 0.26205901E-09_JPRB, 0.26205438E-09_JPRB, 0.26208297E-09_JPRB, 0.26214531E-09_JPRB, &
  & 0.26223304E-09_JPRB, 0.26233263E-09_JPRB, 0.26243341E-09_JPRB, 0.26252872E-09_JPRB, 0.26261376E-09_JPRB, 0.26268746E-09_JPRB, &
  & 0.26274541E-09_JPRB, 0.26278801E-09_JPRB, 0.26281333E-09_JPRB, 0.26282126E-09_JPRB, 0.26281261E-09_JPRB, 0.26278754E-09_JPRB, &
  & 0.26274646E-09_JPRB, 0.26269262E-09_JPRB, 0.26263189E-09_JPRB, 0.26257216E-09_JPRB, 0.26251967E-09_JPRB, 0.26247879E-09_JPRB, &
  & 0.26244806E-09_JPRB, 0.26242691E-09_JPRB, 0.26241198E-09_JPRB, 0.26240138E-09_JPRB, 0.26239300E-09_JPRB, 0.26238564E-09_JPRB, &
  & 0.26237773E-09_JPRB, 0.26236829E-09_JPRB, 0.26235555E-09_JPRB, 0.26233835E-09_JPRB, 0.26231578E-09_JPRB, 0.26228758E-09_JPRB, &
  & 0.26225327E-09_JPRB, 0.26221397E-09_JPRB, 0.26217151E-09_JPRB, 0.26212907E-09_JPRB, 0.26208910E-09_JPRB, 0.26205085E-09_JPRB, &
  & 0.26201297E-09_JPRB, 0.26197183E-09_JPRB, 0.26190783E-09_JPRB, 0.26176639E-09_JPRB /)

RGHG5(:,72, 6) = (/ &
  & 0.26171074E-09_JPRB, 0.26185126E-09_JPRB, 0.26192326E-09_JPRB, 0.26197050E-09_JPRB, 0.26201133E-09_JPRB, 0.26204294E-09_JPRB, &
  & 0.26207275E-09_JPRB, 0.26210173E-09_JPRB, 0.26213018E-09_JPRB, 0.26216468E-09_JPRB, 0.26219582E-09_JPRB, 0.26223343E-09_JPRB, &
  & 0.26226696E-09_JPRB, 0.26229538E-09_JPRB, 0.26231400E-09_JPRB, 0.26232005E-09_JPRB, 0.26231134E-09_JPRB, 0.26228927E-09_JPRB, &
  & 0.26225594E-09_JPRB, 0.26222113E-09_JPRB, 0.26219490E-09_JPRB, 0.26218952E-09_JPRB, 0.26221242E-09_JPRB, 0.26226485E-09_JPRB, &
  & 0.26234023E-09_JPRB, 0.26242694E-09_JPRB, 0.26251545E-09_JPRB, 0.26259875E-09_JPRB, 0.26267324E-09_JPRB, 0.26273761E-09_JPRB, &
  & 0.26278726E-09_JPRB, 0.26282379E-09_JPRB, 0.26284522E-09_JPRB, 0.26285202E-09_JPRB, 0.26284494E-09_JPRB, 0.26282421E-09_JPRB, &
  & 0.26278946E-09_JPRB, 0.26274385E-09_JPRB, 0.26269215E-09_JPRB, 0.26264119E-09_JPRB, 0.26259678E-09_JPRB, 0.26256189E-09_JPRB, &
  & 0.26253605E-09_JPRB, 0.26251795E-09_JPRB, 0.26250549E-09_JPRB, 0.26249664E-09_JPRB, 0.26248981E-09_JPRB, 0.26248403E-09_JPRB, &
  & 0.26247787E-09_JPRB, 0.26247043E-09_JPRB, 0.26246011E-09_JPRB, 0.26244579E-09_JPRB, 0.26242677E-09_JPRB, 0.26240218E-09_JPRB, &
  & 0.26237232E-09_JPRB, 0.26233704E-09_JPRB, 0.26229896E-09_JPRB, 0.26226177E-09_JPRB, 0.26222563E-09_JPRB, 0.26219246E-09_JPRB, &
  & 0.26215830E-09_JPRB, 0.26212177E-09_JPRB, 0.26206581E-09_JPRB, 0.26193681E-09_JPRB /)

RGHG5(:,73, 6) = (/ &
  & 0.26183999E-09_JPRB, 0.26199987E-09_JPRB, 0.26206690E-09_JPRB, 0.26211899E-09_JPRB, 0.26215524E-09_JPRB, 0.26218863E-09_JPRB, &
  & 0.26221622E-09_JPRB, 0.26224292E-09_JPRB, 0.26227318E-09_JPRB, 0.26229796E-09_JPRB, 0.26233182E-09_JPRB, 0.26235986E-09_JPRB, &
  & 0.26239144E-09_JPRB, 0.26241426E-09_JPRB, 0.26243008E-09_JPRB, 0.26243469E-09_JPRB, 0.26242677E-09_JPRB, 0.26240726E-09_JPRB, &
  & 0.26237804E-09_JPRB, 0.26234812E-09_JPRB, 0.26232500E-09_JPRB, 0.26231922E-09_JPRB, 0.26233707E-09_JPRB, 0.26237973E-09_JPRB, &
  & 0.26244296E-09_JPRB, 0.26251670E-09_JPRB, 0.26259261E-09_JPRB, 0.26266411E-09_JPRB, 0.26272789E-09_JPRB, 0.26278335E-09_JPRB, &
  & 0.26282482E-09_JPRB, 0.26285574E-09_JPRB, 0.26287356E-09_JPRB, 0.26287933E-09_JPRB, 0.26287372E-09_JPRB, 0.26285682E-09_JPRB, &
  & 0.26282798E-09_JPRB, 0.26279010E-09_JPRB, 0.26274677E-09_JPRB, 0.26270441E-09_JPRB, 0.26266708E-09_JPRB, 0.26263838E-09_JPRB, &
  & 0.26261665E-09_JPRB, 0.26260183E-09_JPRB, 0.26259153E-09_JPRB, 0.26258445E-09_JPRB, 0.26257893E-09_JPRB, 0.26257457E-09_JPRB, &
  & 0.26256980E-09_JPRB, 0.26256414E-09_JPRB, 0.26255600E-09_JPRB, 0.26254465E-09_JPRB, 0.26252889E-09_JPRB, 0.26250874E-09_JPRB, &
  & 0.26248301E-09_JPRB, 0.26245295E-09_JPRB, 0.26242028E-09_JPRB, 0.26238772E-09_JPRB, 0.26235769E-09_JPRB, 0.26232838E-09_JPRB, &
  & 0.26229929E-09_JPRB, 0.26226732E-09_JPRB, 0.26221766E-09_JPRB, 0.26210353E-09_JPRB /)

RGHG5(:,74, 6) = (/ &
  & 0.26199104E-09_JPRB, 0.26214708E-09_JPRB, 0.26222155E-09_JPRB, 0.26226646E-09_JPRB, 0.26230340E-09_JPRB, 0.26233210E-09_JPRB, &
  & 0.26235880E-09_JPRB, 0.26238481E-09_JPRB, 0.26240743E-09_JPRB, 0.26243560E-09_JPRB, 0.26245661E-09_JPRB, 0.26248620E-09_JPRB, &
  & 0.26250929E-09_JPRB, 0.26252872E-09_JPRB, 0.26254021E-09_JPRB, 0.26254290E-09_JPRB, 0.26253522E-09_JPRB, 0.26251840E-09_JPRB, &
  & 0.26249350E-09_JPRB, 0.26246810E-09_JPRB, 0.26244806E-09_JPRB, 0.26244240E-09_JPRB, 0.26245567E-09_JPRB, 0.26248942E-09_JPRB, &
  & 0.26254099E-09_JPRB, 0.26260183E-09_JPRB, 0.26266531E-09_JPRB, 0.26272501E-09_JPRB, 0.26277835E-09_JPRB, 0.26282496E-09_JPRB, &
  & 0.26285865E-09_JPRB, 0.26288427E-09_JPRB, 0.26289881E-09_JPRB, 0.26290353E-09_JPRB, 0.26289920E-09_JPRB, 0.26288580E-09_JPRB, &
  & 0.26286232E-09_JPRB, 0.26283153E-09_JPRB, 0.26279626E-09_JPRB, 0.26276167E-09_JPRB, 0.26273128E-09_JPRB, 0.26270802E-09_JPRB, &
  & 0.26269040E-09_JPRB, 0.26267827E-09_JPRB, 0.26267016E-09_JPRB, 0.26266472E-09_JPRB, 0.26266045E-09_JPRB, 0.26265720E-09_JPRB, &
  & 0.26265357E-09_JPRB, 0.26264932E-09_JPRB, 0.26264335E-09_JPRB, 0.26263447E-09_JPRB, 0.26262229E-09_JPRB, 0.26260583E-09_JPRB, &
  & 0.26258526E-09_JPRB, 0.26256028E-09_JPRB, 0.26253266E-09_JPRB, 0.26250654E-09_JPRB, 0.26248054E-09_JPRB, 0.26245670E-09_JPRB, &
  & 0.26243174E-09_JPRB, 0.26240438E-09_JPRB, 0.26236222E-09_JPRB, 0.26225869E-09_JPRB /)

RGHG5(:,75, 6) = (/ &
  & 0.26214064E-09_JPRB, 0.26230551E-09_JPRB, 0.26237021E-09_JPRB, 0.26241398E-09_JPRB, 0.26244418E-09_JPRB, 0.26247157E-09_JPRB, &
  & 0.26249478E-09_JPRB, 0.26251640E-09_JPRB, 0.26253996E-09_JPRB, 0.26255714E-09_JPRB, 0.26258093E-09_JPRB, 0.26259886E-09_JPRB, &
  & 0.26262037E-09_JPRB, 0.26263325E-09_JPRB, 0.26264155E-09_JPRB, 0.26264282E-09_JPRB, 0.26263580E-09_JPRB, 0.26262165E-09_JPRB, &
  & 0.26260080E-09_JPRB, 0.26258012E-09_JPRB, 0.26256339E-09_JPRB, 0.26255823E-09_JPRB, 0.26256772E-09_JPRB, 0.26259331E-09_JPRB, &
  & 0.26263405E-09_JPRB, 0.26268254E-09_JPRB, 0.26273339E-09_JPRB, 0.26278218E-09_JPRB, 0.26282485E-09_JPRB, 0.26286281E-09_JPRB, &
  & 0.26288935E-09_JPRB, 0.26290983E-09_JPRB, 0.26292121E-09_JPRB, 0.26292496E-09_JPRB, 0.26292177E-09_JPRB, 0.26291158E-09_JPRB, &
  & 0.26289290E-09_JPRB, 0.26286878E-09_JPRB, 0.26284083E-09_JPRB, 0.26281358E-09_JPRB, 0.26278951E-09_JPRB, 0.26277153E-09_JPRB, &
  & 0.26275754E-09_JPRB, 0.26274799E-09_JPRB, 0.26274177E-09_JPRB, 0.26273783E-09_JPRB, 0.26273458E-09_JPRB, 0.26273239E-09_JPRB, &
  & 0.26272964E-09_JPRB, 0.26272673E-09_JPRB, 0.26272262E-09_JPRB, 0.26271618E-09_JPRB, 0.26270702E-09_JPRB, 0.26269456E-09_JPRB, &
  & 0.26267832E-09_JPRB, 0.26265842E-09_JPRB, 0.26263652E-09_JPRB, 0.26261474E-09_JPRB, 0.26259445E-09_JPRB, 0.26257457E-09_JPRB, &
  & 0.26255459E-09_JPRB, 0.26253211E-09_JPRB, 0.26249533E-09_JPRB, 0.26240418E-09_JPRB /)

RGHG5(:,76, 6) = (/ &
  & 0.26230379E-09_JPRB, 0.26245656E-09_JPRB, 0.26251662E-09_JPRB, 0.26255220E-09_JPRB, 0.26257799E-09_JPRB, 0.26259991E-09_JPRB, &
  & 0.26261995E-09_JPRB, 0.26263924E-09_JPRB, 0.26265556E-09_JPRB, 0.26267338E-09_JPRB, 0.26268629E-09_JPRB, 0.26270433E-09_JPRB, &
  & 0.26271824E-09_JPRB, 0.26272856E-09_JPRB, 0.26273311E-09_JPRB, 0.26273345E-09_JPRB, 0.26272759E-09_JPRB, 0.26271665E-09_JPRB, &
  & 0.26269997E-09_JPRB, 0.26268390E-09_JPRB, 0.26267047E-09_JPRB, 0.26266614E-09_JPRB, 0.26267263E-09_JPRB, 0.26269115E-09_JPRB, &
  & 0.26272198E-09_JPRB, 0.26275859E-09_JPRB, 0.26279737E-09_JPRB, 0.26283550E-09_JPRB, 0.26286773E-09_JPRB, 0.26289718E-09_JPRB, &
  & 0.26291708E-09_JPRB, 0.26293270E-09_JPRB, 0.26294114E-09_JPRB, 0.26294394E-09_JPRB, 0.26294167E-09_JPRB, 0.26293442E-09_JPRB, &
  & 0.26292002E-09_JPRB, 0.26290195E-09_JPRB, 0.26288099E-09_JPRB, 0.26286046E-09_JPRB, 0.26284239E-09_JPRB, 0.26282923E-09_JPRB, &
  & 0.26281854E-09_JPRB, 0.26281127E-09_JPRB, 0.26280689E-09_JPRB, 0.26280428E-09_JPRB, 0.26280189E-09_JPRB, 0.26280064E-09_JPRB, &
  & 0.26279878E-09_JPRB, 0.26279681E-09_JPRB, 0.26279448E-09_JPRB, 0.26279001E-09_JPRB, 0.26278366E-09_JPRB, 0.26277427E-09_JPRB, &
  & 0.26276251E-09_JPRB, 0.26274768E-09_JPRB, 0.26273023E-09_JPRB, 0.26271446E-09_JPRB, 0.26269792E-09_JPRB, 0.26268307E-09_JPRB, &
  & 0.26266744E-09_JPRB, 0.26265012E-09_JPRB, 0.26261987E-09_JPRB, 0.26253749E-09_JPRB /)

RGHG5(:,77, 6) = (/ &
  & 0.26246802E-09_JPRB, 0.26260455E-09_JPRB, 0.26265376E-09_JPRB, 0.26268168E-09_JPRB, 0.26269975E-09_JPRB, 0.26271732E-09_JPRB, &
  & 0.26273217E-09_JPRB, 0.26274635E-09_JPRB, 0.26276059E-09_JPRB, 0.26276992E-09_JPRB, 0.26278185E-09_JPRB, 0.26279218E-09_JPRB, &
  & 0.26280353E-09_JPRB, 0.26281088E-09_JPRB, 0.26281302E-09_JPRB, 0.26281322E-09_JPRB, 0.26280902E-09_JPRB, 0.26280139E-09_JPRB, &
  & 0.26278890E-09_JPRB, 0.26277747E-09_JPRB, 0.26276742E-09_JPRB, 0.26276448E-09_JPRB, 0.26276895E-09_JPRB, 0.26278138E-09_JPRB, &
  & 0.26280358E-09_JPRB, 0.26282906E-09_JPRB, 0.26285671E-09_JPRB, 0.26288435E-09_JPRB, 0.26290689E-09_JPRB, 0.26292807E-09_JPRB, &
  & 0.26294192E-09_JPRB, 0.26295308E-09_JPRB, 0.26295877E-09_JPRB, 0.26296076E-09_JPRB, 0.26295924E-09_JPRB, 0.26295457E-09_JPRB, &
  & 0.26294394E-09_JPRB, 0.26293140E-09_JPRB, 0.26291669E-09_JPRB, 0.26290237E-09_JPRB, 0.26288971E-09_JPRB, 0.26288108E-09_JPRB, &
  & 0.26287336E-09_JPRB, 0.26286820E-09_JPRB, 0.26286537E-09_JPRB, 0.26286404E-09_JPRB, 0.26286243E-09_JPRB, 0.26286204E-09_JPRB, &
  & 0.26286071E-09_JPRB, 0.26285946E-09_JPRB, 0.26285868E-09_JPRB, 0.26285593E-09_JPRB, 0.26285174E-09_JPRB, 0.26284494E-09_JPRB, &
  & 0.26283703E-09_JPRB, 0.26282682E-09_JPRB, 0.26281449E-09_JPRB, 0.26280345E-09_JPRB, 0.26279187E-09_JPRB, 0.26278116E-09_JPRB, &
  & 0.26277036E-09_JPRB, 0.26275851E-09_JPRB, 0.26273400E-09_JPRB, 0.26266303E-09_JPRB /)

RGHG5(:,78, 6) = (/ &
  & 0.26263428E-09_JPRB, 0.26273936E-09_JPRB, 0.26277347E-09_JPRB, 0.26279295E-09_JPRB, 0.26280383E-09_JPRB, 0.26281557E-09_JPRB, &
  & 0.26282546E-09_JPRB, 0.26283511E-09_JPRB, 0.26284364E-09_JPRB, 0.26284935E-09_JPRB, 0.26285493E-09_JPRB, 0.26286381E-09_JPRB, &
  & 0.26287039E-09_JPRB, 0.26287711E-09_JPRB, 0.26287733E-09_JPRB, 0.26287772E-09_JPRB, 0.26287525E-09_JPRB, 0.26287092E-09_JPRB, &
  & 0.26286212E-09_JPRB, 0.26285515E-09_JPRB, 0.26284844E-09_JPRB, 0.26284727E-09_JPRB, 0.26285057E-09_JPRB, 0.26285843E-09_JPRB, &
  & 0.26287358E-09_JPRB, 0.26288999E-09_JPRB, 0.26290800E-09_JPRB, 0.26292624E-09_JPRB, 0.26294042E-09_JPRB, 0.26295432E-09_JPRB, &
  & 0.26296276E-09_JPRB, 0.26297020E-09_JPRB, 0.26297339E-09_JPRB, 0.26297456E-09_JPRB, 0.26297370E-09_JPRB, 0.26297126E-09_JPRB, &
  & 0.26296376E-09_JPRB, 0.26295593E-09_JPRB, 0.26294661E-09_JPRB, 0.26293745E-09_JPRB, 0.26292957E-09_JPRB, 0.26292488E-09_JPRB, &
  & 0.26291966E-09_JPRB, 0.26291616E-09_JPRB, 0.26291469E-09_JPRB, 0.26291433E-09_JPRB, 0.26291322E-09_JPRB, 0.26291339E-09_JPRB, &
  & 0.26291239E-09_JPRB, 0.26291158E-09_JPRB, 0.26291205E-09_JPRB, 0.26291042E-09_JPRB, 0.26290792E-09_JPRB, 0.26290281E-09_JPRB, &
  & 0.26289809E-09_JPRB, 0.26289199E-09_JPRB, 0.26288363E-09_JPRB, 0.26287791E-09_JPRB, 0.26287006E-09_JPRB, 0.26286379E-09_JPRB, &
  & 0.26285735E-09_JPRB, 0.26285074E-09_JPRB, 0.26283442E-09_JPRB, 0.26278041E-09_JPRB /)

RGHG5(:,79, 6) = (/ &
  & 0.26274227E-09_JPRB, 0.26281513E-09_JPRB, 0.26283775E-09_JPRB, 0.26285119E-09_JPRB, 0.26285768E-09_JPRB, 0.26286701E-09_JPRB, &
  & 0.26287364E-09_JPRB, 0.26288094E-09_JPRB, 0.26288732E-09_JPRB, 0.26288982E-09_JPRB, 0.26289354E-09_JPRB, 0.26290056E-09_JPRB, &
  & 0.26290525E-09_JPRB, 0.26291164E-09_JPRB, 0.26291058E-09_JPRB, 0.26291108E-09_JPRB, 0.26290958E-09_JPRB, 0.26290714E-09_JPRB, &
  & 0.26290037E-09_JPRB, 0.26289587E-09_JPRB, 0.26289088E-09_JPRB, 0.26289099E-09_JPRB, 0.26289390E-09_JPRB, 0.26289926E-09_JPRB, &
  & 0.26291105E-09_JPRB, 0.26292260E-09_JPRB, 0.26293570E-09_JPRB, 0.26294897E-09_JPRB, 0.26295857E-09_JPRB, 0.26296862E-09_JPRB, &
  & 0.26297403E-09_JPRB, 0.26297958E-09_JPRB, 0.26298130E-09_JPRB, 0.26298203E-09_JPRB, 0.26298153E-09_JPRB, 0.26298042E-09_JPRB, &
  & 0.26297448E-09_JPRB, 0.26296909E-09_JPRB, 0.26296260E-09_JPRB, 0.26295618E-09_JPRB, 0.26295077E-09_JPRB, 0.26294830E-09_JPRB, &
  & 0.26294433E-09_JPRB, 0.26294161E-09_JPRB, 0.26294081E-09_JPRB, 0.26294089E-09_JPRB, 0.26293986E-09_JPRB, 0.26294031E-09_JPRB, &
  & 0.26293934E-09_JPRB, 0.26293859E-09_JPRB, 0.26293984E-09_JPRB, 0.26293875E-09_JPRB, 0.26293706E-09_JPRB, 0.26293270E-09_JPRB, &
  & 0.26292971E-09_JPRB, 0.26292557E-09_JPRB, 0.26291913E-09_JPRB, 0.26291599E-09_JPRB, 0.26290994E-09_JPRB, 0.26290575E-09_JPRB, &
  & 0.26290159E-09_JPRB, 0.26289931E-09_JPRB, 0.26288960E-09_JPRB, 0.26285449E-09_JPRB /)

RGHG5(:,80, 6) = (/ &
  & 0.26281405E-09_JPRB, 0.26285185E-09_JPRB, 0.26286595E-09_JPRB, 0.26287661E-09_JPRB, 0.26288086E-09_JPRB, 0.26288902E-09_JPRB, &
  & 0.26289484E-09_JPRB, 0.26290045E-09_JPRB, 0.26290697E-09_JPRB, 0.26290775E-09_JPRB, 0.26291089E-09_JPRB, 0.26291688E-09_JPRB, &
  & 0.26292074E-09_JPRB, 0.26292715E-09_JPRB, 0.26292529E-09_JPRB, 0.26292582E-09_JPRB, 0.26292490E-09_JPRB, 0.26292352E-09_JPRB, &
  & 0.26291752E-09_JPRB, 0.26291433E-09_JPRB, 0.26291014E-09_JPRB, 0.26291086E-09_JPRB, 0.26291355E-09_JPRB, 0.26291769E-09_JPRB, &
  & 0.26292804E-09_JPRB, 0.26293739E-09_JPRB, 0.26294827E-09_JPRB, 0.26295940E-09_JPRB, 0.26296695E-09_JPRB, 0.26297520E-09_JPRB, &
  & 0.26297919E-09_JPRB, 0.26298394E-09_JPRB, 0.26298494E-09_JPRB, 0.26298541E-09_JPRB, 0.26298508E-09_JPRB, 0.26298461E-09_JPRB, &
  & 0.26297928E-09_JPRB, 0.26297498E-09_JPRB, 0.26296981E-09_JPRB, 0.26296454E-09_JPRB, 0.26296026E-09_JPRB, 0.26295877E-09_JPRB, &
  & 0.26295532E-09_JPRB, 0.26295291E-09_JPRB, 0.26295235E-09_JPRB, 0.26295269E-09_JPRB, 0.26295160E-09_JPRB, 0.26295222E-09_JPRB, &
  & 0.26295116E-09_JPRB, 0.26295038E-09_JPRB, 0.26295199E-09_JPRB, 0.26295113E-09_JPRB, 0.26294983E-09_JPRB, 0.26294572E-09_JPRB, &
  & 0.26294353E-09_JPRB, 0.26294028E-09_JPRB, 0.26293440E-09_JPRB, 0.26293234E-09_JPRB, 0.26292682E-09_JPRB, 0.26292352E-09_JPRB, &
  & 0.26292060E-09_JPRB, 0.26292038E-09_JPRB, 0.26291594E-09_JPRB, 0.26290300E-09_JPRB /)

RGHG5(:,81, 6) = (/ &
  & 0.26286331E-09_JPRB, 0.26286737E-09_JPRB, 0.26287783E-09_JPRB, 0.26288738E-09_JPRB, 0.26289071E-09_JPRB, 0.26289870E-09_JPRB, &
  & 0.26290337E-09_JPRB, 0.26291036E-09_JPRB, 0.26291469E-09_JPRB, 0.26291591E-09_JPRB, 0.26291783E-09_JPRB, 0.26292465E-09_JPRB, &
  & 0.26292757E-09_JPRB, 0.26293406E-09_JPRB, 0.26293173E-09_JPRB, 0.26293231E-09_JPRB, 0.26293159E-09_JPRB, 0.26293084E-09_JPRB, &
  & 0.26292513E-09_JPRB, 0.26292266E-09_JPRB, 0.26291869E-09_JPRB, 0.26291974E-09_JPRB, 0.26292235E-09_JPRB, 0.26292579E-09_JPRB, &
  & 0.26293573E-09_JPRB, 0.26294400E-09_JPRB, 0.26295394E-09_JPRB, 0.26296409E-09_JPRB, 0.26297067E-09_JPRB, 0.26297814E-09_JPRB, &
  & 0.26298153E-09_JPRB, 0.26298586E-09_JPRB, 0.26298652E-09_JPRB, 0.26298688E-09_JPRB, 0.26298663E-09_JPRB, 0.26298649E-09_JPRB, &
  & 0.26298133E-09_JPRB, 0.26297756E-09_JPRB, 0.26297287E-09_JPRB, 0.26296823E-09_JPRB, 0.26296446E-09_JPRB, 0.26296335E-09_JPRB, &
  & 0.26296018E-09_JPRB, 0.26295782E-09_JPRB, 0.26295741E-09_JPRB, 0.26295782E-09_JPRB, 0.26295671E-09_JPRB, 0.26295738E-09_JPRB, &
  & 0.26295627E-09_JPRB, 0.26295544E-09_JPRB, 0.26295735E-09_JPRB, 0.26295660E-09_JPRB, 0.26295549E-09_JPRB, 0.26295144E-09_JPRB, &
  & 0.26294963E-09_JPRB, 0.26294669E-09_JPRB, 0.26294100E-09_JPRB, 0.26293936E-09_JPRB, 0.26293395E-09_JPRB, 0.26293101E-09_JPRB, &
  & 0.26292854E-09_JPRB, 0.26292929E-09_JPRB, 0.26292704E-09_JPRB, 0.26293642E-09_JPRB /)

RGHG5(:,82, 6) = (/ &
  & 0.26286717E-09_JPRB, 0.26287250E-09_JPRB, 0.26288313E-09_JPRB, 0.26289254E-09_JPRB, 0.26289557E-09_JPRB, 0.26290306E-09_JPRB, &
  & 0.26290864E-09_JPRB, 0.26291289E-09_JPRB, 0.26291958E-09_JPRB, 0.26291969E-09_JPRB, 0.26292268E-09_JPRB, 0.26292743E-09_JPRB, &
  & 0.26293095E-09_JPRB, 0.26293734E-09_JPRB, 0.26293490E-09_JPRB, 0.26293548E-09_JPRB, 0.26293487E-09_JPRB, 0.26293445E-09_JPRB, &
  & 0.26292896E-09_JPRB, 0.26292679E-09_JPRB, 0.26292285E-09_JPRB, 0.26292415E-09_JPRB, 0.26292674E-09_JPRB, 0.26292971E-09_JPRB, &
  & 0.26293945E-09_JPRB, 0.26294736E-09_JPRB, 0.26295671E-09_JPRB, 0.26296657E-09_JPRB, 0.26297253E-09_JPRB, 0.26297961E-09_JPRB, &
  & 0.26298264E-09_JPRB, 0.26298683E-09_JPRB, 0.26298727E-09_JPRB, 0.26298763E-09_JPRB, 0.26298741E-09_JPRB, 0.26298735E-09_JPRB, &
  & 0.26298233E-09_JPRB, 0.26297872E-09_JPRB, 0.26297434E-09_JPRB, 0.26296998E-09_JPRB, 0.26296651E-09_JPRB, 0.26296554E-09_JPRB, &
  & 0.26296257E-09_JPRB, 0.26296024E-09_JPRB, 0.26295979E-09_JPRB, 0.26296029E-09_JPRB, 0.26295918E-09_JPRB, 0.26295996E-09_JPRB, &
  & 0.26295877E-09_JPRB, 0.26295788E-09_JPRB, 0.26295999E-09_JPRB, 0.26295932E-09_JPRB, 0.26295829E-09_JPRB, 0.26295421E-09_JPRB, &
  & 0.26295260E-09_JPRB, 0.26294983E-09_JPRB, 0.26294414E-09_JPRB, 0.26294272E-09_JPRB, 0.26293737E-09_JPRB, 0.26293454E-09_JPRB, &
  & 0.26293226E-09_JPRB, 0.26293326E-09_JPRB, 0.26293079E-09_JPRB, 0.26293911E-09_JPRB /)

RGHG5(:,83, 6) = (/ &
  & 0.26286992E-09_JPRB, 0.26287553E-09_JPRB, 0.26288613E-09_JPRB, 0.26289546E-09_JPRB, 0.26289812E-09_JPRB, 0.26290614E-09_JPRB, &
  & 0.26291011E-09_JPRB, 0.26291758E-09_JPRB, 0.26292085E-09_JPRB, 0.26292227E-09_JPRB, 0.26292379E-09_JPRB, 0.26293001E-09_JPRB, &
  & 0.26293284E-09_JPRB, 0.26293900E-09_JPRB, 0.26293656E-09_JPRB, 0.26293723E-09_JPRB, 0.26293667E-09_JPRB, 0.26293656E-09_JPRB, &
  & 0.26293104E-09_JPRB, 0.26292921E-09_JPRB, 0.26292521E-09_JPRB, 0.26292665E-09_JPRB, 0.26292918E-09_JPRB, 0.26293179E-09_JPRB, &
  & 0.26294175E-09_JPRB, 0.26294911E-09_JPRB, 0.26295854E-09_JPRB, 0.26296790E-09_JPRB, 0.26297364E-09_JPRB, 0.26298047E-09_JPRB, &
  & 0.26298330E-09_JPRB, 0.26298738E-09_JPRB, 0.26298774E-09_JPRB, 0.26298802E-09_JPRB, 0.26298777E-09_JPRB, 0.26298780E-09_JPRB, &
  & 0.26298277E-09_JPRB, 0.26297930E-09_JPRB, 0.26297514E-09_JPRB, 0.26297098E-09_JPRB, 0.26296768E-09_JPRB, 0.26296673E-09_JPRB, &
  & 0.26296385E-09_JPRB, 0.26296160E-09_JPRB, 0.26296115E-09_JPRB, 0.26296171E-09_JPRB, 0.26296057E-09_JPRB, 0.26296140E-09_JPRB, &
  & 0.26296021E-09_JPRB, 0.26295929E-09_JPRB, 0.26296154E-09_JPRB, 0.26296082E-09_JPRB, 0.26295990E-09_JPRB, 0.26295577E-09_JPRB, &
  & 0.26295430E-09_JPRB, 0.26295163E-09_JPRB, 0.26294592E-09_JPRB, 0.26294461E-09_JPRB, 0.26293923E-09_JPRB, 0.26293653E-09_JPRB, &
  & 0.26293429E-09_JPRB, 0.26293553E-09_JPRB, 0.26293301E-09_JPRB, 0.26294103E-09_JPRB /)

RGHG5(:,84, 6) = (/ &
  & 0.26287172E-09_JPRB, 0.26287747E-09_JPRB, 0.26288796E-09_JPRB, 0.26289726E-09_JPRB, 0.26289998E-09_JPRB, 0.26290731E-09_JPRB, &
  & 0.26291316E-09_JPRB, 0.26291674E-09_JPRB, 0.26292327E-09_JPRB, 0.26292360E-09_JPRB, 0.26292657E-09_JPRB, 0.26293040E-09_JPRB, &
  & 0.26293395E-09_JPRB, 0.26293956E-09_JPRB, 0.26293775E-09_JPRB, 0.26293828E-09_JPRB, 0.26293778E-09_JPRB, 0.26293773E-09_JPRB, &
  & 0.26293240E-09_JPRB, 0.26293068E-09_JPRB, 0.26292668E-09_JPRB, 0.26292829E-09_JPRB, 0.26293076E-09_JPRB, 0.26293312E-09_JPRB, &
  & 0.26294297E-09_JPRB, 0.26295047E-09_JPRB, 0.26295938E-09_JPRB, 0.26296892E-09_JPRB, 0.26297431E-09_JPRB, 0.26298103E-09_JPRB, &
  & 0.26298366E-09_JPRB, 0.26298766E-09_JPRB, 0.26298796E-09_JPRB, 0.26298819E-09_JPRB, 0.26298802E-09_JPRB, 0.26298808E-09_JPRB, &
  & 0.26298305E-09_JPRB, 0.26297958E-09_JPRB, 0.26297556E-09_JPRB, 0.26297159E-09_JPRB, 0.26296848E-09_JPRB, 0.26296751E-09_JPRB, &
  & 0.26296476E-09_JPRB, 0.26296251E-09_JPRB, 0.26296207E-09_JPRB, 0.26296254E-09_JPRB, 0.26296143E-09_JPRB, 0.26296226E-09_JPRB, &
  & 0.26296113E-09_JPRB, 0.26296013E-09_JPRB, 0.26296251E-09_JPRB, 0.26296185E-09_JPRB, 0.26296093E-09_JPRB, 0.26295677E-09_JPRB, &
  & 0.26295541E-09_JPRB, 0.26295272E-09_JPRB, 0.26294697E-09_JPRB, 0.26294572E-09_JPRB, 0.26294034E-09_JPRB, 0.26293770E-09_JPRB, &
  & 0.26293556E-09_JPRB, 0.26293692E-09_JPRB, 0.26293442E-09_JPRB, 0.26294236E-09_JPRB /)

RGHG5(:,85, 6) = (/ &
  & 0.26287295E-09_JPRB, 0.26287869E-09_JPRB, 0.26288918E-09_JPRB, 0.26289845E-09_JPRB, 0.26290090E-09_JPRB, 0.26290931E-09_JPRB, &
  & 0.26291286E-09_JPRB, 0.26292049E-09_JPRB, 0.26292299E-09_JPRB, 0.26292513E-09_JPRB, 0.26292662E-09_JPRB, 0.26293195E-09_JPRB, &
  & 0.26293467E-09_JPRB, 0.26293925E-09_JPRB, 0.26293834E-09_JPRB, 0.26293881E-09_JPRB, 0.26293848E-09_JPRB, 0.26293842E-09_JPRB, &
  & 0.26293337E-09_JPRB, 0.26293173E-09_JPRB, 0.26292762E-09_JPRB, 0.26292932E-09_JPRB, 0.26293179E-09_JPRB, 0.26293381E-09_JPRB, &
  & 0.26294406E-09_JPRB, 0.26295099E-09_JPRB, 0.26296032E-09_JPRB, 0.26296942E-09_JPRB, 0.26297478E-09_JPRB, 0.26298139E-09_JPRB, &
  & 0.26298397E-09_JPRB, 0.26298785E-09_JPRB, 0.26298808E-09_JPRB, 0.26298833E-09_JPRB, 0.26298813E-09_JPRB, 0.26298827E-09_JPRB, &
  & 0.26298316E-09_JPRB, 0.26297969E-09_JPRB, 0.26297581E-09_JPRB, 0.26297192E-09_JPRB, 0.26296898E-09_JPRB, 0.26296793E-09_JPRB, &
  & 0.26296521E-09_JPRB, 0.26296310E-09_JPRB, 0.26296265E-09_JPRB, 0.26296304E-09_JPRB, 0.26296201E-09_JPRB, 0.26296282E-09_JPRB, &
  & 0.26296168E-09_JPRB, 0.26296068E-09_JPRB, 0.26296315E-09_JPRB, 0.26296254E-09_JPRB, 0.26296160E-09_JPRB, 0.26295743E-09_JPRB, &
  & 0.26295613E-09_JPRB, 0.26295349E-09_JPRB, 0.26294766E-09_JPRB, 0.26294650E-09_JPRB, 0.26294106E-09_JPRB, 0.26293845E-09_JPRB, &
  & 0.26293637E-09_JPRB, 0.26293784E-09_JPRB, 0.26293537E-09_JPRB, 0.26294331E-09_JPRB /)

RGHG5(:,86, 6) = (/ &
  & 0.26287375E-09_JPRB, 0.26287950E-09_JPRB, 0.26288993E-09_JPRB, 0.26289937E-09_JPRB, 0.26290239E-09_JPRB, 0.26290897E-09_JPRB, &
  & 0.26291605E-09_JPRB, 0.26291888E-09_JPRB, 0.26292490E-09_JPRB, 0.26292571E-09_JPRB, 0.26292896E-09_JPRB, 0.26293168E-09_JPRB, &
  & 0.26293506E-09_JPRB, 0.26293850E-09_JPRB, 0.26293848E-09_JPRB, 0.26293900E-09_JPRB, 0.26293884E-09_JPRB, 0.26293867E-09_JPRB, &
  & 0.26293417E-09_JPRB, 0.26293243E-09_JPRB, 0.26292832E-09_JPRB, 0.26293004E-09_JPRB, 0.26293248E-09_JPRB, 0.26293440E-09_JPRB, &
  & 0.26294447E-09_JPRB, 0.26295163E-09_JPRB, 0.26296054E-09_JPRB, 0.26296998E-09_JPRB, 0.26297506E-09_JPRB, 0.26298172E-09_JPRB, &
  & 0.26298419E-09_JPRB, 0.26298808E-09_JPRB, 0.26298819E-09_JPRB, 0.26298838E-09_JPRB, 0.26298827E-09_JPRB, 0.26298849E-09_JPRB, &
  & 0.26298325E-09_JPRB, 0.26297986E-09_JPRB, 0.26297592E-09_JPRB, 0.26297214E-09_JPRB, 0.26296923E-09_JPRB, 0.26296826E-09_JPRB, &
  & 0.26296565E-09_JPRB, 0.26296343E-09_JPRB, 0.26296304E-09_JPRB, 0.26296337E-09_JPRB, 0.26296240E-09_JPRB, 0.26296312E-09_JPRB, &
  & 0.26296204E-09_JPRB, 0.26296113E-09_JPRB, 0.26296348E-09_JPRB, 0.26296290E-09_JPRB, 0.26296199E-09_JPRB, 0.26295788E-09_JPRB, &
  & 0.26295655E-09_JPRB, 0.26295394E-09_JPRB, 0.26294814E-09_JPRB, 0.26294705E-09_JPRB, 0.26294150E-09_JPRB, 0.26293892E-09_JPRB, &
  & 0.26293687E-09_JPRB, 0.26293845E-09_JPRB, 0.26293598E-09_JPRB, 0.26294389E-09_JPRB /)

RGHG5(:,87, 6) = (/ &
  & 0.26287431E-09_JPRB, 0.26288008E-09_JPRB, 0.26289032E-09_JPRB, 0.26289981E-09_JPRB, 0.26290220E-09_JPRB, 0.26291175E-09_JPRB, &
  & 0.26291477E-09_JPRB, 0.26292224E-09_JPRB, 0.26292435E-09_JPRB, 0.26292701E-09_JPRB, 0.26292851E-09_JPRB, 0.26293270E-09_JPRB, &
  & 0.26293490E-09_JPRB, 0.26293800E-09_JPRB, 0.26293834E-09_JPRB, 0.26293892E-09_JPRB, 0.26293887E-09_JPRB, 0.26293864E-09_JPRB, &
  & 0.26293479E-09_JPRB, 0.26293284E-09_JPRB, 0.26292876E-09_JPRB, 0.26293043E-09_JPRB, 0.26293290E-09_JPRB, 0.26293462E-09_JPRB, &
  & 0.26294489E-09_JPRB, 0.26295174E-09_JPRB, 0.26296099E-09_JPRB, 0.26297023E-09_JPRB, 0.26297525E-09_JPRB, 0.26298197E-09_JPRB, &
  & 0.26298425E-09_JPRB, 0.26298819E-09_JPRB, 0.26298827E-09_JPRB, 0.26298841E-09_JPRB, 0.26298835E-09_JPRB, 0.26298874E-09_JPRB, &
  & 0.26298336E-09_JPRB, 0.26298003E-09_JPRB, 0.26297611E-09_JPRB, 0.26297223E-09_JPRB, 0.26296926E-09_JPRB, 0.26296848E-09_JPRB, &
  & 0.26296565E-09_JPRB, 0.26296351E-09_JPRB, 0.26296318E-09_JPRB, 0.26296354E-09_JPRB, 0.26296265E-09_JPRB, 0.26296326E-09_JPRB, &
  & 0.26296226E-09_JPRB, 0.26296143E-09_JPRB, 0.26296371E-09_JPRB, 0.26296315E-09_JPRB, 0.26296221E-09_JPRB, 0.26295818E-09_JPRB, &
  & 0.26295688E-09_JPRB, 0.26295421E-09_JPRB, 0.26294836E-09_JPRB, 0.26294733E-09_JPRB, 0.26294178E-09_JPRB, 0.26293923E-09_JPRB, &
  & 0.26293720E-09_JPRB, 0.26293884E-09_JPRB, 0.26293634E-09_JPRB, 0.26294431E-09_JPRB /)

RGHG5(:,88, 6) = (/ &
  & 0.26287486E-09_JPRB, 0.26288088E-09_JPRB, 0.26289054E-09_JPRB, 0.26289998E-09_JPRB, 0.26290398E-09_JPRB, 0.26291008E-09_JPRB, &
  & 0.26291774E-09_JPRB, 0.26292046E-09_JPRB, 0.26292574E-09_JPRB, 0.26292685E-09_JPRB, 0.26292984E-09_JPRB, 0.26293215E-09_JPRB, &
  & 0.26293512E-09_JPRB, 0.26293773E-09_JPRB, 0.26293825E-09_JPRB, 0.26293892E-09_JPRB, 0.26293895E-09_JPRB, 0.26293875E-09_JPRB, &
  & 0.26293498E-09_JPRB, 0.26293312E-09_JPRB, 0.26292898E-09_JPRB, 0.26293068E-09_JPRB, 0.26293318E-09_JPRB, 0.26293479E-09_JPRB, &
  & 0.26294508E-09_JPRB, 0.26295197E-09_JPRB, 0.26296107E-09_JPRB, 0.26297045E-09_JPRB, 0.26297539E-09_JPRB, 0.26298222E-09_JPRB, &
  & 0.26298433E-09_JPRB, 0.26298830E-09_JPRB, 0.26298827E-09_JPRB, 0.26298846E-09_JPRB, 0.26298844E-09_JPRB, 0.26298905E-09_JPRB, &
  & 0.26298344E-09_JPRB, 0.26298028E-09_JPRB, 0.26297631E-09_JPRB, 0.26297214E-09_JPRB, 0.26296915E-09_JPRB, 0.26296865E-09_JPRB, &
  & 0.26296568E-09_JPRB, 0.26296337E-09_JPRB, 0.26296326E-09_JPRB, 0.26296365E-09_JPRB, 0.26296282E-09_JPRB, 0.26296335E-09_JPRB, &
  & 0.26296246E-09_JPRB, 0.26296174E-09_JPRB, 0.26296373E-09_JPRB, 0.26296332E-09_JPRB, 0.26296237E-09_JPRB, 0.26295846E-09_JPRB, &
  & 0.26295710E-09_JPRB, 0.26295438E-09_JPRB, 0.26294850E-09_JPRB, 0.26294755E-09_JPRB, 0.26294192E-09_JPRB, 0.26293936E-09_JPRB, &
  & 0.26293737E-09_JPRB, 0.26293911E-09_JPRB, 0.26293656E-09_JPRB, 0.26294453E-09_JPRB /)

RGHG5(:,89, 6) = (/ &
  & 0.26287569E-09_JPRB, 0.26288172E-09_JPRB, 0.26289060E-09_JPRB, 0.26289973E-09_JPRB, 0.26290264E-09_JPRB, 0.26291225E-09_JPRB, &
  & 0.26291574E-09_JPRB, 0.26292257E-09_JPRB, 0.26292499E-09_JPRB, 0.26292740E-09_JPRB, 0.26292904E-09_JPRB, 0.26293265E-09_JPRB, &
  & 0.26293490E-09_JPRB, 0.26293809E-09_JPRB, 0.26293850E-09_JPRB, 0.26293917E-09_JPRB, 0.26293917E-09_JPRB, 0.26293900E-09_JPRB, &
  & 0.26293515E-09_JPRB, 0.26293320E-09_JPRB, 0.26292910E-09_JPRB, 0.26293079E-09_JPRB, 0.26293334E-09_JPRB, 0.26293484E-09_JPRB, &
  & 0.26294530E-09_JPRB, 0.26295205E-09_JPRB, 0.26296121E-09_JPRB, 0.26297065E-09_JPRB, 0.26297542E-09_JPRB, 0.26298239E-09_JPRB, &
  & 0.26298433E-09_JPRB, 0.26298838E-09_JPRB, 0.26298830E-09_JPRB, 0.26298846E-09_JPRB, 0.26298841E-09_JPRB, 0.26298921E-09_JPRB, &
  & 0.26298341E-09_JPRB, 0.26298047E-09_JPRB, 0.26297639E-09_JPRB, 0.26297212E-09_JPRB, 0.26296887E-09_JPRB, 0.26296892E-09_JPRB, &
  & 0.26296554E-09_JPRB, 0.26296329E-09_JPRB, 0.26296332E-09_JPRB, 0.26296373E-09_JPRB, 0.26296285E-09_JPRB, 0.26296332E-09_JPRB, &
  & 0.26296249E-09_JPRB, 0.26296185E-09_JPRB, 0.26296379E-09_JPRB, 0.26296340E-09_JPRB, 0.26296246E-09_JPRB, 0.26295863E-09_JPRB, &
  & 0.26295724E-09_JPRB, 0.26295449E-09_JPRB, 0.26294855E-09_JPRB, 0.26294772E-09_JPRB, 0.26294200E-09_JPRB, 0.26293945E-09_JPRB, &
  & 0.26293734E-09_JPRB, 0.26293925E-09_JPRB, 0.26293662E-09_JPRB, 0.26294469E-09_JPRB /)

RGHG5(:,90, 6) = (/ &
  & 0.26287644E-09_JPRB, 0.26288263E-09_JPRB, 0.26289004E-09_JPRB, 0.26289954E-09_JPRB, 0.26290287E-09_JPRB, 0.26291022E-09_JPRB, &
  & 0.26291680E-09_JPRB, 0.26292063E-09_JPRB, 0.26292563E-09_JPRB, 0.26292674E-09_JPRB, 0.26292946E-09_JPRB, 0.26293212E-09_JPRB, &
  & 0.26293534E-09_JPRB, 0.26293892E-09_JPRB, 0.26293887E-09_JPRB, 0.26293953E-09_JPRB, 0.26293942E-09_JPRB, 0.26293956E-09_JPRB, &
  & 0.26293476E-09_JPRB, 0.26293323E-09_JPRB, 0.26292882E-09_JPRB, 0.26293079E-09_JPRB, 0.26293343E-09_JPRB, 0.26293467E-09_JPRB, &
  & 0.26294539E-09_JPRB, 0.26295199E-09_JPRB, 0.26296129E-09_JPRB, 0.26297081E-09_JPRB, 0.26297542E-09_JPRB, 0.26298261E-09_JPRB, &
  & 0.26298436E-09_JPRB, 0.26298858E-09_JPRB, 0.26298833E-09_JPRB, 0.26298846E-09_JPRB, 0.26298841E-09_JPRB, 0.26298952E-09_JPRB, &
  & 0.26298339E-09_JPRB, 0.26298050E-09_JPRB, 0.26297650E-09_JPRB, 0.26297201E-09_JPRB, 0.26296859E-09_JPRB, 0.26296917E-09_JPRB, &
  & 0.26296551E-09_JPRB, 0.26296310E-09_JPRB, 0.26296329E-09_JPRB, 0.26296382E-09_JPRB, 0.26296285E-09_JPRB, 0.26296340E-09_JPRB, &
  & 0.26296254E-09_JPRB, 0.26296185E-09_JPRB, 0.26296385E-09_JPRB, 0.26296351E-09_JPRB, 0.26296262E-09_JPRB, 0.26295865E-09_JPRB, &
  & 0.26295732E-09_JPRB, 0.26295463E-09_JPRB, 0.26294844E-09_JPRB, 0.26294783E-09_JPRB, 0.26294195E-09_JPRB, 0.26293948E-09_JPRB, &
  & 0.26293726E-09_JPRB, 0.26293939E-09_JPRB, 0.26293656E-09_JPRB, 0.26294483E-09_JPRB /)

RGHG5(:,91, 6) = (/ &
  & 0.26287617E-09_JPRB, 0.26288269E-09_JPRB, 0.26288768E-09_JPRB, 0.26290067E-09_JPRB, 0.26290137E-09_JPRB, 0.26290992E-09_JPRB, &
  & 0.26291339E-09_JPRB, 0.26291913E-09_JPRB, 0.26292607E-09_JPRB, 0.26292546E-09_JPRB, 0.26292901E-09_JPRB, 0.26293107E-09_JPRB, &
  & 0.26293509E-09_JPRB, 0.26294428E-09_JPRB, 0.26293850E-09_JPRB, 0.26294009E-09_JPRB, 0.26293936E-09_JPRB, 0.26294067E-09_JPRB, &
  & 0.26293404E-09_JPRB, 0.26293340E-09_JPRB, 0.26292829E-09_JPRB, 0.26293082E-09_JPRB, 0.26293351E-09_JPRB, 0.26293406E-09_JPRB, &
  & 0.26294569E-09_JPRB, 0.26295185E-09_JPRB, 0.26296126E-09_JPRB, 0.26297117E-09_JPRB, 0.26297517E-09_JPRB, 0.26298305E-09_JPRB, &
  & 0.26298419E-09_JPRB, 0.26298894E-09_JPRB, 0.26298827E-09_JPRB, 0.26298849E-09_JPRB, 0.26298835E-09_JPRB, 0.26299005E-09_JPRB, &
  & 0.26298319E-09_JPRB, 0.26298064E-09_JPRB, 0.26297664E-09_JPRB, 0.26297192E-09_JPRB, 0.26296823E-09_JPRB, 0.26296967E-09_JPRB, &
  & 0.26296543E-09_JPRB, 0.26296271E-09_JPRB, 0.26296329E-09_JPRB, 0.26296409E-09_JPRB, 0.26296254E-09_JPRB, 0.26296368E-09_JPRB, &
  & 0.26296257E-09_JPRB, 0.26296146E-09_JPRB, 0.26296415E-09_JPRB, 0.26296360E-09_JPRB, 0.26296285E-09_JPRB, 0.26295838E-09_JPRB, &
  & 0.26295746E-09_JPRB, 0.26295480E-09_JPRB, 0.26294805E-09_JPRB, 0.26294819E-09_JPRB, 0.26294170E-09_JPRB, 0.26293942E-09_JPRB, &
  & 0.26293701E-09_JPRB, 0.26293967E-09_JPRB, 0.26293637E-09_JPRB, 0.26294508E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART12',1,ZHOOK_HANDLE)
END SUBROUTINE PART12






SUBROUTINE PART13
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART13',0,ZHOOK_HANDLE)



!-- Month=  7 ------------

RGHG5(:, 1, 7) = (/ &
  & 0.11210388E-43_JPRB, 0.22420775E-43_JPRB, 0.32229865E-43_JPRB, 0.39236357E-43_JPRB, 0.43440252E-43_JPRB, 0.46242849E-43_JPRB, &
  & 0.50446745E-43_JPRB, 0.57453237E-43_JPRB, 0.70064923E-43_JPRB, 0.96689594E-43_JPRB, 0.14293244E-42_JPRB, 0.22701035E-42_JPRB, &
  & 0.38115318E-42_JPRB, 0.65300508E-42_JPRB, 0.11266440E-41_JPRB, 0.19043646E-41_JPRB, 0.31164878E-41_JPRB, 0.49031433E-41_JPRB, &
  & 0.74493026E-41_JPRB, 0.10960957E-40_JPRB, 0.15892126E-40_JPRB, 0.23075182E-40_JPRB, 0.34086585E-40_JPRB, 0.51831228E-40_JPRB, &
  & 0.81786785E-40_JPRB, 0.13343024E-39_JPRB, 0.21485549E-39_JPRB, 0.37873314E-39_JPRB, 0.63168433E-39_JPRB, 0.10230460E-38_JPRB, &
  & 0.17892928E-38_JPRB, 0.26548342E-38_JPRB, 0.52203791E-38_JPRB, 0.55880826E-38_JPRB, 0.56639419E-38_JPRB, 0.31127505E-38_JPRB, &
  & 0.31153303E-38_JPRB, 0.29223967E-38_JPRB, 0.18277682E-38_JPRB, 0.11023300E-38_JPRB, 0.63039373E-39_JPRB, 0.37666482E-39_JPRB, &
  & 0.21991418E-39_JPRB, 0.10327289E-39_JPRB, 0.48547985E-40_JPRB, 0.19550916E-40_JPRB, 0.59092756E-41_JPRB, 0.26974995E-41_JPRB, &
  & 0.12009128E-41_JPRB, 0.51287524E-42_JPRB, 0.21019477E-42_JPRB, 0.77071416E-43_JPRB, 0.23822074E-43_JPRB, 0.84077908E-44_JPRB, &
  & 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.28025969E-44_JPRB, 0.42038954E-44_JPRB, 0.42038954E-44_JPRB, 0.00000000E+00_JPRB /)

RGHG5(:, 2, 7) = (/ &
  & 0.41198175E-42_JPRB, 0.87721284E-42_JPRB, 0.13046089E-41_JPRB, 0.15778621E-41_JPRB, 0.17376101E-41_JPRB, 0.18651283E-41_JPRB, &
  & 0.20388893E-41_JPRB, 0.23499775E-41_JPRB, 0.29455294E-41_JPRB, 0.40511539E-41_JPRB, 0.60648198E-41_JPRB, 0.96997880E-41_JPRB, &
  & 0.16250858E-40_JPRB, 0.27737302E-40_JPRB, 0.47522235E-40_JPRB, 0.79637193E-40_JPRB, 0.12933985E-39_JPRB, 0.20235591E-39_JPRB, &
  & 0.30599314E-39_JPRB, 0.44896201E-39_JPRB, 0.64924400E-39_JPRB, 0.94007789E-39_JPRB, 0.13855773E-38_JPRB, 0.21062259E-38_JPRB, &
  & 0.33259427E-38_JPRB, 0.54274616E-38_JPRB, 0.88220272E-38_JPRB, 0.15318161E-37_JPRB, 0.25544598E-37_JPRB, 0.41819547E-37_JPRB, &
  & 0.71936055E-37_JPRB, 0.11053846E-36_JPRB, 0.20192762E-36_JPRB, 0.22103656E-36_JPRB, 0.21804478E-36_JPRB, 0.13266456E-36_JPRB, &
  & 0.12415887E-36_JPRB, 0.11258285E-36_JPRB, 0.74127528E-37_JPRB, 0.45618705E-37_JPRB, 0.26059236E-37_JPRB, 0.15369189E-37_JPRB, &
  & 0.88904484E-38_JPRB, 0.42352705E-38_JPRB, 0.20038302E-38_JPRB, 0.82686418E-39_JPRB, 0.27721747E-39_JPRB, 0.11956299E-39_JPRB, &
  & 0.52222190E-40_JPRB, 0.22424979E-40_JPRB, 0.93634763E-41_JPRB, 0.35368773E-41_JPRB, 0.11868998E-41_JPRB, 0.40357396E-42_JPRB, &
  & 0.15274153E-42_JPRB, 0.88281803E-43_JPRB, 0.61657132E-43_JPRB, 0.51848043E-43_JPRB, 0.42038954E-43_JPRB, 0.64459729E-43_JPRB, &
  & 0.11490647E-42_JPRB, 0.14573504E-42_JPRB, 0.16395192E-42_JPRB, 0.14012985E-43_JPRB /)

RGHG5(:, 3, 7) = (/ &
  & 0.15264344E-40_JPRB, 0.42181886E-40_JPRB, 0.65932494E-40_JPRB, 0.79078075E-40_JPRB, 0.85819722E-40_JPRB, 0.91050769E-40_JPRB, &
  & 0.98687846E-40_JPRB, 0.11277650E-39_JPRB, 0.14034144E-39_JPRB, 0.19213343E-39_JPRB, 0.28684019E-39_JPRB, 0.45847263E-39_JPRB, &
  & 0.76938152E-39_JPRB, 0.13158080E-38_JPRB, 0.22618793E-38_JPRB, 0.38032936E-38_JPRB, 0.61995994E-38_JPRB, 0.97302452E-38_JPRB, &
  & 0.14744891E-37_JPRB, 0.21639413E-37_JPRB, 0.31246282E-37_JPRB, 0.45118414E-37_JPRB, 0.66326164E-37_JPRB, 0.10063466E-36_JPRB, &
  & 0.15894732E-36_JPRB, 0.25924712E-36_JPRB, 0.42248261E-36_JPRB, 0.72909680E-36_JPRB, 0.12161323E-35_JPRB, 0.19982541E-35_JPRB, &
  & 0.34226146E-35_JPRB, 0.53139806E-35_JPRB, 0.94973666E-35_JPRB, 0.10461888E-34_JPRB, 0.10245237E-34_JPRB, 0.64517966E-35_JPRB, &
  & 0.59228611E-35_JPRB, 0.53219118E-35_JPRB, 0.35786707E-35_JPRB, 0.22285519E-35_JPRB, 0.12554575E-35_JPRB, 0.72644339E-36_JPRB, &
  & 0.41281760E-36_JPRB, 0.18815087E-36_JPRB, 0.88035063E-37_JPRB, 0.36308647E-37_JPRB, 0.12596853E-37_JPRB, 0.57122433E-38_JPRB, &
  & 0.25502511E-38_JPRB, 0.11162057E-38_JPRB, 0.47067934E-39_JPRB, 0.18127057E-39_JPRB, 0.62175613E-40_JPRB, 0.21239481E-40_JPRB, &
  & 0.78879091E-41_JPRB, 0.43762551E-41_JPRB, 0.30268047E-41_JPRB, 0.25447580E-41_JPRB, 0.20094620E-41_JPRB, 0.30996722E-41_JPRB, &
  & 0.56023913E-41_JPRB, 0.74815325E-41_JPRB, 0.98104905E-41_JPRB, 0.12681751E-41_JPRB /)

RGHG5(:, 4, 7) = (/ &
  & 0.13056697E-38_JPRB, 0.46021248E-38_JPRB, 0.69117071E-38_JPRB, 0.79789472E-38_JPRB, 0.84288131E-38_JPRB, 0.88198944E-38_JPRB, &
  & 0.94723670E-38_JPRB, 0.10711303E-37_JPRB, 0.13207503E-37_JPRB, 0.17914033E-37_JPRB, 0.26571965E-37_JPRB, 0.42285414E-37_JPRB, &
  & 0.70855850E-37_JPRB, 0.12108870E-36_JPRB, 0.20839232E-36_JPRB, 0.35072936E-36_JPRB, 0.57223716E-36_JPRB, 0.89815420E-36_JPRB, &
  & 0.13591585E-35_JPRB, 0.19874367E-35_JPRB, 0.28536132E-35_JPRB, 0.40910984E-35_JPRB, 0.59640977E-35_JPRB, 0.89745851E-35_JPRB, &
  & 0.14056497E-34_JPRB, 0.22774899E-34_JPRB, 0.36921592E-34_JPRB, 0.63499820E-34_JPRB, 0.10581613E-33_JPRB, 0.17402266E-33_JPRB, &
  & 0.29887972E-33_JPRB, 0.46447226E-33_JPRB, 0.83220078E-33_JPRB, 0.91827295E-33_JPRB, 0.89916281E-33_JPRB, 0.57068313E-33_JPRB, &
  & 0.52387095E-33_JPRB, 0.47087296E-33_JPRB, 0.32224359E-33_JPRB, 0.20239359E-33_JPRB, 0.11356346E-33_JPRB, 0.64888700E-34_JPRB, &
  & 0.36446185E-34_JPRB, 0.15898172E-34_JPRB, 0.74235051E-35_JPRB, 0.30788481E-35_JPRB, 0.10842039E-35_JPRB, 0.51553116E-36_JPRB, &
  & 0.23606191E-36_JPRB, 0.10399527E-36_JPRB, 0.44083376E-37_JPRB, 0.16969133E-37_JPRB, 0.58302144E-38_JPRB, 0.19986202E-38_JPRB, &
  & 0.74732789E-39_JPRB, 0.41674897E-39_JPRB, 0.28798225E-39_JPRB, 0.24246807E-39_JPRB, 0.19124361E-39_JPRB, 0.29760216E-39_JPRB, &
  & 0.55044545E-39_JPRB, 0.79663397E-39_JPRB, 0.13438775E-38_JPRB, 0.52251757E-39_JPRB /)

RGHG5(:, 5, 7) = (/ &
  & 0.59895568E-36_JPRB, 0.13561712E-35_JPRB, 0.17587283E-35_JPRB, 0.19054269E-35_JPRB, 0.19773097E-35_JPRB, 0.20538193E-35_JPRB, &
  & 0.21914321E-35_JPRB, 0.24582005E-35_JPRB, 0.29961560E-35_JPRB, 0.40191629E-35_JPRB, 0.58881136E-35_JPRB, 0.92584795E-35_JPRB, &
  & 0.15334812E-34_JPRB, 0.25876571E-34_JPRB, 0.43969137E-34_JPRB, 0.72974012E-34_JPRB, 0.11730295E-33_JPRB, 0.18117728E-33_JPRB, &
  & 0.26945742E-33_JPRB, 0.38669948E-33_JPRB, 0.54432910E-33_JPRB, 0.76442306E-33_JPRB, 0.10912412E-32_JPRB, 0.16073701E-32_JPRB, &
  & 0.24663910E-32_JPRB, 0.39215854E-32_JPRB, 0.62716958E-32_JPRB, 0.10678118E-31_JPRB, 0.17718025E-31_JPRB, 0.29111485E-31_JPRB, &
  & 0.50005747E-31_JPRB, 0.77820083E-31_JPRB, 0.14042387E-30_JPRB, 0.15531783E-30_JPRB, 0.15283747E-30_JPRB, 0.97715254E-31_JPRB, &
  & 0.90679944E-31_JPRB, 0.82457302E-31_JPRB, 0.57408846E-31_JPRB, 0.36782335E-31_JPRB, 0.20882548E-31_JPRB, 0.12043123E-31_JPRB, &
  & 0.68535148E-32_JPRB, 0.29594229E-32_JPRB, 0.14145698E-32_JPRB, 0.59793596E-33_JPRB, 0.21558006E-33_JPRB, 0.10638077E-33_JPRB, &
  & 0.49663666E-34_JPRB, 0.22154699E-34_JPRB, 0.94460377E-35_JPRB, 0.36437089E-35_JPRB, 0.12515404E-35_JPRB, 0.43374609E-36_JPRB, &
  & 0.16533962E-36_JPRB, 0.94457785E-37_JPRB, 0.66048398E-37_JPRB, 0.55768495E-37_JPRB, 0.43839051E-37_JPRB, 0.68258005E-37_JPRB, &
  & 0.12743766E-36_JPRB, 0.20010284E-36_JPRB, 0.42002413E-36_JPRB, 0.49883638E-36_JPRB /)

RGHG5(:, 6, 7) = (/ &
  & 0.51245107E-33_JPRB, 0.84184075E-33_JPRB, 0.96897992E-33_JPRB, 0.10252246E-32_JPRB, 0.10545793E-32_JPRB, 0.10855632E-32_JPRB, &
  & 0.11460874E-32_JPRB, 0.12649475E-32_JPRB, 0.15102657E-32_JPRB, 0.19716490E-32_JPRB, 0.28030864E-32_JPRB, 0.42604654E-32_JPRB, &
  & 0.68029958E-32_JPRB, 0.11035031E-31_JPRB, 0.17991499E-31_JPRB, 0.28595978E-31_JPRB, 0.43962731E-31_JPRB, 0.64882339E-31_JPRB, &
  & 0.92200546E-31_JPRB, 0.12650622E-30_JPRB, 0.17050849E-30_JPRB, 0.22979878E-30_JPRB, 0.31564703E-30_JPRB, 0.44861388E-30_JPRB, &
  & 0.66603745E-30_JPRB, 0.10285117E-29_JPRB, 0.16055838E-29_JPRB, 0.26836064E-29_JPRB, 0.43998257E-29_JPRB, 0.71713438E-29_JPRB, &
  & 0.12296896E-28_JPRB, 0.19089646E-28_JPRB, 0.34660317E-28_JPRB, 0.38579431E-28_JPRB, 0.38442814E-28_JPRB, 0.24759533E-28_JPRB, &
  & 0.23573509E-28_JPRB, 0.21975333E-28_JPRB, 0.15673376E-28_JPRB, 0.10325612E-28_JPRB, 0.60471992E-29_JPRB, 0.36239306E-29_JPRB, &
  & 0.21449702E-29_JPRB, 0.96330276E-30_JPRB, 0.48251255E-30_JPRB, 0.21418720E-30_JPRB, 0.81021377E-31_JPRB, 0.42146318E-31_JPRB, &
  & 0.20567055E-31_JPRB, 0.95310919E-32_JPRB, 0.42039443E-32_JPRB, 0.16692938E-32_JPRB, 0.58807434E-33_JPRB, 0.21035003E-33_JPRB, &
  & 0.83175214E-34_JPRB, 0.49367772E-34_JPRB, 0.35227953E-34_JPRB, 0.29941913E-34_JPRB, 0.23232568E-34_JPRB, 0.35366326E-34_JPRB, &
  & 0.63978335E-34_JPRB, 0.95209991E-34_JPRB, 0.19233614E-33_JPRB, 0.17854669E-33_JPRB /)

RGHG5(:, 7, 7) = (/ &
  & 0.40567909E-30_JPRB, 0.62446351E-30_JPRB, 0.70638427E-30_JPRB, 0.74209993E-30_JPRB, 0.75648088E-30_JPRB, 0.76941743E-30_JPRB, &
  & 0.79854801E-30_JPRB, 0.86144825E-30_JPRB, 0.99465273E-30_JPRB, 0.12473316E-29_JPRB, 0.16910506E-29_JPRB, 0.24383751E-29_JPRB, &
  & 0.36785604E-29_JPRB, 0.56177229E-29_JPRB, 0.86096652E-29_JPRB, 0.12844702E-28_JPRB, 0.18525872E-28_JPRB, 0.25657431E-28_JPRB, &
  & 0.34264481E-28_JPRB, 0.44285916E-28_JPRB, 0.56426600E-28_JPRB, 0.72216565E-28_JPRB, 0.94704138E-28_JPRB, 0.12920782E-27_JPRB, &
  & 0.18508367E-27_JPRB, 0.27697692E-27_JPRB, 0.42104011E-27_JPRB, 0.68831027E-27_JPRB, 0.11104602E-26_JPRB, 0.17918681E-26_JPRB, &
  & 0.30518883E-26_JPRB, 0.47320777E-26_JPRB, 0.86230124E-26_JPRB, 0.96770037E-26_JPRB, 0.97934023E-26_JPRB, 0.63661006E-26_JPRB, &
  & 0.62494951E-26_JPRB, 0.60192156E-26_JPRB, 0.43940130E-26_JPRB, 0.29896436E-26_JPRB, 0.18166215E-26_JPRB, 0.11451651E-26_JPRB, &
  & 0.71774710E-27_JPRB, 0.33974495E-27_JPRB, 0.18174794E-27_JPRB, 0.85873617E-28_JPRB, 0.34682805E-28_JPRB, 0.19386110E-28_JPRB, &
  & 0.10106919E-28_JPRB, 0.49865783E-29_JPRB, 0.23360817E-29_JPRB, 0.97994532E-30_JPRB, 0.36313148E-30_JPRB, 0.13698779E-30_JPRB, &
  & 0.57152559E-31_JPRB, 0.35775221E-31_JPRB, 0.26418501E-31_JPRB, 0.22807664E-31_JPRB, 0.17613895E-31_JPRB, 0.26166519E-31_JPRB, &
  & 0.45873761E-31_JPRB, 0.66739379E-31_JPRB, 0.13523331E-30_JPRB, 0.16823183E-30_JPRB /)

RGHG5(:, 8, 7) = (/ &
  & 0.26621783E-27_JPRB, 0.40591776E-27_JPRB, 0.45725626E-27_JPRB, 0.47804287E-27_JPRB, 0.48387907E-27_JPRB, 0.48709951E-27_JPRB, &
  & 0.49809671E-27_JPRB, 0.52582645E-27_JPRB, 0.58877445E-27_JPRB, 0.70955385E-27_JPRB, 0.91818729E-27_JPRB, 0.12556145E-26_JPRB, &
  & 0.17878625E-26_JPRB, 0.25666058E-26_JPRB, 0.36908853E-26_JPRB, 0.51595382E-26_JPRB, 0.69715790E-26_JPRB, 0.90491606E-26_JPRB, &
  & 0.11344715E-25_JPRB, 0.13792715E-25_JPRB, 0.16582930E-25_JPRB, 0.20112494E-25_JPRB, 0.25135623E-25_JPRB, 0.32884788E-25_JPRB, &
  & 0.45452073E-25_JPRB, 0.65974730E-25_JPRB, 0.97643650E-25_JPRB, 0.15612102E-24_JPRB, 0.24772126E-24_JPRB, 0.39510759E-24_JPRB, &
  & 0.66849725E-24_JPRB, 0.10355366E-23_JPRB, 0.18926325E-23_JPRB, 0.21446921E-23_JPRB, 0.22070352E-23_JPRB, 0.14471669E-23_JPRB, &
  & 0.14673453E-23_JPRB, 0.14633410E-23_JPRB, 0.10938405E-23_JPRB, 0.76976194E-24_JPRB, 0.48615777E-24_JPRB, 0.32351528E-24_JPRB, &
  & 0.21472434E-24_JPRB, 0.10748078E-24_JPRB, 0.61388330E-25_JPRB, 0.30928657E-25_JPRB, 0.13327534E-25_JPRB, 0.80660072E-26_JPRB, &
  & 0.45167895E-26_JPRB, 0.23887675E-26_JPRB, 0.11966613E-26_JPRB, 0.53435475E-27_JPRB, 0.20980339E-27_JPRB, 0.83906635E-28_JPRB, &
  & 0.37122339E-28_JPRB, 0.24603538E-28_JPRB, 0.18955072E-28_JPRB, 0.16822082E-28_JPRB, 0.13116177E-28_JPRB, 0.19499380E-28_JPRB, &
  & 0.33976197E-28_JPRB, 0.49096230E-28_JPRB, 0.10340259E-27_JPRB, 0.14312297E-27_JPRB /)

RGHG5(:, 9, 7) = (/ &
  & 0.14152087E-24_JPRB, 0.21447964E-24_JPRB, 0.24101786E-24_JPRB, 0.25102533E-24_JPRB, 0.25296903E-24_JPRB, 0.25281296E-24_JPRB, &
  & 0.25574619E-24_JPRB, 0.26555844E-24_JPRB, 0.29008250E-24_JPRB, 0.33831012E-24_JPRB, 0.42054135E-24_JPRB, 0.54867396E-24_JPRB, &
  & 0.74119655E-24_JPRB, 0.10045888E-23_JPRB, 0.13605834E-23_JPRB, 0.17883869E-23_JPRB, 0.22715368E-23_JPRB, 0.27729841E-23_JPRB, &
  & 0.32741427E-23_JPRB, 0.37538203E-23_JPRB, 0.42649390E-23_JPRB, 0.49024368E-23_JPRB, 0.58323137E-23_JPRB, 0.73056511E-23_JPRB, &
  & 0.97275046E-23_JPRB, 0.13673143E-22_JPRB, 0.19674776E-22_JPRB, 0.30746939E-22_JPRB, 0.47918384E-22_JPRB, 0.75522583E-22_JPRB, &
  & 0.12686077E-21_JPRB, 0.19645354E-21_JPRB, 0.36050254E-21_JPRB, 0.41270348E-21_JPRB, 0.43176612E-21_JPRB, 0.28691989E-21_JPRB, &
  & 0.30008572E-21_JPRB, 0.30965229E-21_JPRB, 0.23795912E-21_JPRB, 0.17380255E-21_JPRB, 0.11450219E-21_JPRB, 0.80419762E-22_JPRB, &
  & 0.56578909E-22_JPRB, 0.29866706E-22_JPRB, 0.18240174E-22_JPRB, 0.97804703E-23_JPRB, 0.44867419E-23_JPRB, 0.29488889E-23_JPRB, &
  & 0.17743884E-23_JPRB, 0.10064154E-23_JPRB, 0.53970688E-24_JPRB, 0.25675921E-24_JPRB, 0.10688773E-24_JPRB, 0.45356741E-25_JPRB, &
  & 0.21275878E-25_JPRB, 0.14945052E-25_JPRB, 0.12028281E-25_JPRB, 0.11035689E-25_JPRB, 0.88146016E-26_JPRB, 0.13309959E-25_JPRB, &
  & 0.23404212E-25_JPRB, 0.34225337E-25_JPRB, 0.73316597E-25_JPRB, 0.10632176E-24_JPRB /)

RGHG5(:,10, 7) = (/ &
  & 0.60424467E-22_JPRB, 0.91202797E-22_JPRB, 0.10214122E-21_JPRB, 0.10627532E-21_JPRB, 0.10677673E-21_JPRB, 0.10621916E-21_JPRB, &
  & 0.10661879E-21_JPRB, 0.10943041E-21_JPRB, 0.11725180E-21_JPRB, 0.13321158E-21_JPRB, 0.16011775E-21_JPRB, 0.20057386E-21_JPRB, &
  & 0.25853105E-21_JPRB, 0.33254996E-21_JPRB, 0.42610540E-21_JPRB, 0.52881292E-21_JPRB, 0.63391065E-21_JPRB, 0.73050746E-21_JPRB, &
  & 0.81513101E-21_JPRB, 0.88388126E-21_JPRB, 0.95091692E-21_JPRB, 0.10369367E-20_JPRB, 0.11741370E-20_JPRB, 0.14057525E-20_JPRB, &
  & 0.17987111E-20_JPRB, 0.24432104E-20_JPRB, 0.34074550E-20_JPRB, 0.51992114E-20_JPRB, 0.79515079E-20_JPRB, 0.12368546E-19_JPRB, &
  & 0.20647989E-19_JPRB, 0.31951166E-19_JPRB, 0.58945983E-19_JPRB, 0.68177351E-19_JPRB, 0.72469035E-19_JPRB, 0.49052217E-19_JPRB, &
  & 0.52835389E-19_JPRB, 0.56320091E-19_JPRB, 0.44706385E-19_JPRB, 0.33992961E-19_JPRB, 0.23439256E-19_JPRB, 0.17381493E-19_JPRB, &
  & 0.12949200E-19_JPRB, 0.72294261E-20_JPRB, 0.47164211E-20_JPRB, 0.26937841E-20_JPRB, 0.13160791E-20_JPRB, 0.93919401E-21_JPRB, &
  & 0.60694680E-21_JPRB, 0.36914331E-21_JPRB, 0.21188814E-21_JPRB, 0.10739776E-21_JPRB, 0.47415513E-22_JPRB, 0.21345779E-22_JPRB, &
  & 0.10609782E-22_JPRB, 0.78822248E-23_JPRB, 0.66251686E-23_JPRB, 0.62906498E-23_JPRB, 0.51718242E-23_JPRB, 0.79983751E-23_JPRB, &
  & 0.14276865E-22_JPRB, 0.21130428E-22_JPRB, 0.45889424E-22_JPRB, 0.67574967E-22_JPRB /)

RGHG5(:,11, 7) = (/ &
  & 0.21076194E-19_JPRB, 0.31650657E-19_JPRB, 0.35460738E-19_JPRB, 0.36801246E-19_JPRB, 0.36907203E-19_JPRB, 0.36585097E-19_JPRB, &
  & 0.36485282E-19_JPRB, 0.37047355E-19_JPRB, 0.39074073E-19_JPRB, 0.43383875E-19_JPRB, 0.50621502E-19_JPRB, 0.61130476E-19_JPRB, &
  & 0.75478441E-19_JPRB, 0.92513689E-19_JPRB, 0.11256130E-18_JPRB, 0.13236209E-18_JPRB, 0.15022865E-18_JPRB, 0.16389689E-18_JPRB, &
  & 0.17329959E-18_JPRB, 0.17813119E-18_JPRB, 0.18185444E-18_JPRB, 0.18845918E-18_JPRB, 0.20331597E-18_JPRB, 0.23273344E-18_JPRB, &
  & 0.28582184E-18_JPRB, 0.37420968E-18_JPRB, 0.50528007E-18_JPRB, 0.75135710E-18_JPRB, 0.11268009E-17_JPRB, 0.17293110E-17_JPRB, &
  & 0.28687606E-17_JPRB, 0.44354702E-17_JPRB, 0.82269903E-17_JPRB, 0.96128735E-17_JPRB, 0.10380462E-16_JPRB, 0.71785215E-17_JPRB, &
  & 0.79636863E-17_JPRB, 0.87677935E-17_JPRB, 0.72134509E-17_JPRB, 0.57217506E-17_JPRB, 0.41393168E-17_JPRB, 0.32416180E-17_JPRB, &
  & 0.25582413E-17_JPRB, 0.15129626E-17_JPRB, 0.10551314E-17_JPRB, 0.64256129E-18_JPRB, 0.33519052E-18_JPRB, 0.25906829E-18_JPRB, &
  & 0.17966981E-18_JPRB, 0.11708773E-18_JPRB, 0.71874040E-19_JPRB, 0.38779629E-19_JPRB, 0.18145283E-19_JPRB, 0.86524102E-20_JPRB, &
  & 0.45453603E-20_JPRB, 0.35570180E-20_JPRB, 0.31121546E-20_JPRB, 0.30510652E-20_JPRB, 0.25807522E-20_JPRB, 0.40834942E-20_JPRB, &
  & 0.74009845E-20_JPRB, 0.11091776E-19_JPRB, 0.24254921E-19_JPRB, 0.36009576E-19_JPRB /)

RGHG5(:,12, 7) = (/ &
  & 0.60409439E-17_JPRB, 0.90788829E-17_JPRB, 0.10143665E-16_JPRB, 0.10525969E-16_JPRB, 0.10530329E-16_JPRB, 0.10390887E-16_JPRB, &
  & 0.10294097E-16_JPRB, 0.10344775E-16_JPRB, 0.10740352E-16_JPRB, 0.11677146E-16_JPRB, 0.13255081E-16_JPRB, 0.15471207E-16_JPRB, &
  & 0.18357401E-16_JPRB, 0.21512678E-16_JPRB, 0.24939264E-16_JPRB, 0.27878237E-16_JPRB, 0.30041813E-16_JPRB, 0.31106957E-16_JPRB, &
  & 0.31227941E-16_JPRB, 0.30485100E-16_JPRB, 0.29587427E-16_JPRB, 0.29197785E-16_JPRB, 0.30069239E-16_JPRB, 0.32937465E-16_JPRB, &
  & 0.38821161E-16_JPRB, 0.48963970E-16_JPRB, 0.63928204E-16_JPRB, 0.92556375E-16_JPRB, 0.13596414E-15_JPRB, 0.20576545E-15_JPRB, &
  & 0.33890185E-15_JPRB, 0.52331887E-15_JPRB, 0.97500088E-15_JPRB, 0.11509458E-14_JPRB, 0.12629110E-14_JPRB, 0.89388742E-15_JPRB, &
  & 0.10224977E-14_JPRB, 0.11639278E-14_JPRB, 0.99460303E-15_JPRB, 0.82427624E-15_JPRB, 0.62655652E-15_JPRB, 0.51846220E-15_JPRB, &
  & 0.43330794E-15_JPRB, 0.27204451E-15_JPRB, 0.20271072E-15_JPRB, 0.13176529E-15_JPRB, 0.73573752E-16_JPRB, 0.61421019E-16_JPRB, &
  & 0.45680050E-16_JPRB, 0.31881493E-16_JPRB, 0.20907392E-16_JPRB, 0.11999339E-16_JPRB, 0.59463045E-17_JPRB, 0.29981716E-17_JPRB, &
  & 0.16605932E-17_JPRB, 0.13634126E-17_JPRB, 0.12375952E-17_JPRB, 0.12484651E-17_JPRB, 0.10832328E-17_JPRB, 0.17469471E-17_JPRB, &
  & 0.32054723E-17_JPRB, 0.48543421E-17_JPRB, 0.10668487E-16_JPRB, 0.15936439E-16_JPRB /)

RGHG5(:,13, 7) = (/ &
  & 0.11601588E-15_JPRB, 0.15219017E-15_JPRB, 0.16132680E-15_JPRB, 0.16086867E-15_JPRB, 0.15572862E-15_JPRB, 0.14975226E-15_JPRB, &
  & 0.14497898E-15_JPRB, 0.14406137E-15_JPRB, 0.14979653E-15_JPRB, 0.16502988E-15_JPRB, 0.19138848E-15_JPRB, 0.22875231E-15_JPRB, &
  & 0.27919675E-15_JPRB, 0.33293271E-15_JPRB, 0.39575198E-15_JPRB, 0.44823088E-15_JPRB, 0.49328684E-15_JPRB, 0.51608780E-15_JPRB, &
  & 0.52281457E-15_JPRB, 0.51257659E-15_JPRB, 0.49539558E-15_JPRB, 0.48166804E-15_JPRB, 0.48025371E-15_JPRB, 0.49879780E-15_JPRB, &
  & 0.54534019E-15_JPRB, 0.62669617E-15_JPRB, 0.76607052E-15_JPRB, 0.98118454E-15_JPRB, 0.13207801E-14_JPRB, 0.18629418E-14_JPRB, &
  & 0.25742072E-14_JPRB, 0.40715379E-14_JPRB, 0.59919098E-14_JPRB, 0.93904537E-14_JPRB, 0.77294196E-14_JPRB, 0.59449346E-14_JPRB, &
  & 0.49145961E-14_JPRB, 0.35035172E-14_JPRB, 0.27993611E-14_JPRB, 0.23907204E-14_JPRB, 0.29745406E-14_JPRB, 0.28468193E-14_JPRB, &
  & 0.24714202E-14_JPRB, 0.14132158E-14_JPRB, 0.11580914E-14_JPRB, 0.84016806E-15_JPRB, 0.49723613E-15_JPRB, 0.36633450E-15_JPRB, &
  & 0.26536153E-15_JPRB, 0.18491612E-15_JPRB, 0.12438450E-15_JPRB, 0.77758697E-16_JPRB, 0.43220515E-16_JPRB, 0.24404104E-16_JPRB, &
  & 0.15803315E-16_JPRB, 0.15904665E-16_JPRB, 0.15561951E-16_JPRB, 0.16436004E-16_JPRB, 0.14318543E-16_JPRB, 0.21895461E-16_JPRB, &
  & 0.32713832E-16_JPRB, 0.53598604E-16_JPRB, 0.10053656E-15_JPRB, 0.65051078E-16_JPRB /)

RGHG5(:,14, 7) = (/ &
  & 0.14912999E-14_JPRB, 0.17251117E-14_JPRB, 0.17282776E-14_JPRB, 0.16502021E-14_JPRB, 0.15394305E-14_JPRB, 0.14230015E-14_JPRB, &
  & 0.13339186E-14_JPRB, 0.12934318E-14_JPRB, 0.13222992E-14_JPRB, 0.14561686E-14_JPRB, 0.17115357E-14_JPRB, 0.20906370E-14_JPRB, &
  & 0.26096117E-14_JPRB, 0.32178204E-14_JPRB, 0.39010052E-14_JPRB, 0.45627391E-14_JPRB, 0.51286435E-14_JPRB, 0.55291719E-14_JPRB, &
  & 0.57620238E-14_JPRB, 0.58246420E-14_JPRB, 0.57987228E-14_JPRB, 0.57677226E-14_JPRB, 0.58043424E-14_JPRB, 0.59892056E-14_JPRB, &
  & 0.63931904E-14_JPRB, 0.70362858E-14_JPRB, 0.81185364E-14_JPRB, 0.97504250E-14_JPRB, 0.11925423E-13_JPRB, 0.15930316E-13_JPRB, &
  & 0.18542840E-13_JPRB, 0.25028367E-13_JPRB, 0.27807219E-13_JPRB, 0.28769657E-13_JPRB, 0.36704167E-13_JPRB, 0.52399376E-13_JPRB, &
  & 0.51162003E-13_JPRB, 0.45015790E-13_JPRB, 0.35096515E-13_JPRB, 0.26321015E-13_JPRB, 0.17977392E-13_JPRB, 0.11253834E-13_JPRB, &
  & 0.74924240E-14_JPRB, 0.56120761E-14_JPRB, 0.55588883E-14_JPRB, 0.46347576E-14_JPRB, 0.29842034E-14_JPRB, 0.21489419E-14_JPRB, &
  & 0.15421514E-14_JPRB, 0.11060841E-14_JPRB, 0.80674520E-15_JPRB, 0.51937636E-15_JPRB, 0.30406723E-15_JPRB, 0.19149784E-15_JPRB, &
  & 0.15949994E-15_JPRB, 0.17162587E-15_JPRB, 0.18006961E-15_JPRB, 0.19020746E-15_JPRB, 0.17401094E-15_JPRB, 0.22584434E-15_JPRB, &
  & 0.32800075E-15_JPRB, 0.51237870E-15_JPRB, 0.87229581E-15_JPRB, 0.11851993E-14_JPRB /)

RGHG5(:,15, 7) = (/ &
  & 0.13809268E-13_JPRB, 0.14154506E-13_JPRB, 0.13446270E-13_JPRB, 0.12341242E-13_JPRB, 0.11094834E-13_JPRB, 0.99022226E-14_JPRB, &
  & 0.89487405E-14_JPRB, 0.83920941E-14_JPRB, 0.83619287E-14_JPRB, 0.90581119E-14_JPRB, 0.10613084E-13_JPRB, 0.13095666E-13_JPRB, &
  & 0.16586730E-13_JPRB, 0.20962815E-13_JPRB, 0.26049255E-13_JPRB, 0.31379223E-13_JPRB, 0.36466520E-13_JPRB, 0.40848486E-13_JPRB, &
  & 0.44417317E-13_JPRB, 0.47050447E-13_JPRB, 0.49111167E-13_JPRB, 0.50997706E-13_JPRB, 0.53206622E-13_JPRB, 0.56145870E-13_JPRB, &
  & 0.60535825E-13_JPRB, 0.66436094E-13_JPRB, 0.74990022E-13_JPRB, 0.86668459E-13_JPRB, 0.10253175E-12_JPRB, 0.12464164E-12_JPRB, &
  & 0.15221323E-12_JPRB, 0.18333643E-12_JPRB, 0.21041547E-12_JPRB, 0.23031045E-12_JPRB, 0.25029786E-12_JPRB, 0.22319639E-12_JPRB, &
  & 0.21164327E-12_JPRB, 0.19100040E-12_JPRB, 0.16617061E-12_JPRB, 0.13724921E-12_JPRB, 0.10734409E-12_JPRB, 0.81644184E-13_JPRB, &
  & 0.62005651E-13_JPRB, 0.45947326E-13_JPRB, 0.30760483E-13_JPRB, 0.20444729E-13_JPRB, 0.15433503E-13_JPRB, 0.11986760E-13_JPRB, &
  & 0.91037458E-14_JPRB, 0.65687117E-14_JPRB, 0.45508404E-14_JPRB, 0.31365357E-14_JPRB, 0.22578222E-14_JPRB, 0.17736184E-14_JPRB, &
  & 0.16141427E-14_JPRB, 0.16676266E-14_JPRB, 0.18213898E-14_JPRB, 0.18923192E-14_JPRB, 0.21063926E-14_JPRB, 0.26707199E-14_JPRB, &
  & 0.34354655E-14_JPRB, 0.42104326E-14_JPRB, 0.64878247E-14_JPRB, 0.96488073E-14_JPRB /)

RGHG5(:,16, 7) = (/ &
  & 0.89298916E-13_JPRB, 0.82667122E-13_JPRB, 0.75124924E-13_JPRB, 0.67136462E-13_JPRB, 0.58758499E-13_JPRB, 0.51180367E-13_JPRB, &
  & 0.44976701E-13_JPRB, 0.40987931E-13_JPRB, 0.39751487E-13_JPRB, 0.42024300E-13_JPRB, 0.48550519E-13_JPRB, 0.59897278E-13_JPRB, &
  & 0.76605036E-13_JPRB, 0.98771136E-13_JPRB, 0.12604594E-12_JPRB, 0.15691031E-12_JPRB, 0.18927138E-12_JPRB, 0.22121519E-12_JPRB, &
  & 0.25154510E-12_JPRB, 0.27941728E-12_JPRB, 0.30598224E-12_JPRB, 0.33275715E-12_JPRB, 0.36204376E-12_JPRB, 0.39598107E-12_JPRB, &
  & 0.43787708E-12_JPRB, 0.48751742E-12_JPRB, 0.54752481E-12_JPRB, 0.61683791E-12_JPRB, 0.69647212E-12_JPRB, 0.78270073E-12_JPRB, &
  & 0.86828591E-12_JPRB, 0.94941123E-12_JPRB, 0.10230068E-11_JPRB, 0.10567500E-11_JPRB, 0.10488965E-11_JPRB, 0.10057482E-11_JPRB, &
  & 0.89131702E-12_JPRB, 0.75380809E-12_JPRB, 0.62933437E-12_JPRB, 0.52278955E-12_JPRB, 0.43853793E-12_JPRB, 0.36178775E-12_JPRB, &
  & 0.28961442E-12_JPRB, 0.22400841E-12_JPRB, 0.17054226E-12_JPRB, 0.13046273E-12_JPRB, 0.98928610E-13_JPRB, 0.74872454E-13_JPRB, &
  & 0.56835528E-13_JPRB, 0.43076579E-13_JPRB, 0.32152951E-13_JPRB, 0.24495956E-13_JPRB, 0.19673809E-13_JPRB, 0.16508879E-13_JPRB, &
  & 0.14703955E-13_JPRB, 0.14414822E-13_JPRB, 0.16123652E-13_JPRB, 0.18570142E-13_JPRB, 0.21364055E-13_JPRB, 0.25707230E-13_JPRB, &
  & 0.35430792E-13_JPRB, 0.45035807E-13_JPRB, 0.63165639E-13_JPRB, 0.90180189E-13_JPRB /)

RGHG5(:,17, 7) = (/ &
  & 0.39317277E-12_JPRB, 0.34141079E-12_JPRB, 0.30251550E-12_JPRB, 0.26685463E-12_JPRB, 0.23215203E-12_JPRB, 0.19975617E-12_JPRB, &
  & 0.17344333E-12_JPRB, 0.15518237E-12_JPRB, 0.14751298E-12_JPRB, 0.15235453E-12_JPRB, 0.17287468E-12_JPRB, 0.21172632E-12_JPRB, &
  & 0.27179287E-12_JPRB, 0.35543427E-12_JPRB, 0.46403685E-12_JPRB, 0.59534642E-12_JPRB, 0.74404621E-12_JPRB, 0.90331876E-12_JPRB, &
  & 0.10680113E-11_JPRB, 0.12336878E-11_JPRB, 0.14034861E-11_JPRB, 0.15849871E-11_JPRB, 0.17884875E-11_JPRB, 0.20270376E-11_JPRB, &
  & 0.23094016E-11_JPRB, 0.26283626E-11_JPRB, 0.29675130E-11_JPRB, 0.32923746E-11_JPRB, 0.35537669E-11_JPRB, 0.37339116E-11_JPRB, &
  & 0.38312968E-11_JPRB, 0.38114993E-11_JPRB, 0.36913393E-11_JPRB, 0.34341488E-11_JPRB, 0.30555857E-11_JPRB, 0.26545773E-11_JPRB, &
  & 0.23069029E-11_JPRB, 0.20554702E-11_JPRB, 0.18313302E-11_JPRB, 0.16325466E-11_JPRB, 0.14430887E-11_JPRB, 0.12650706E-11_JPRB, &
  & 0.10942699E-11_JPRB, 0.93126852E-12_JPRB, 0.77939380E-12_JPRB, 0.64546751E-12_JPRB, 0.53110137E-12_JPRB, 0.43486403E-12_JPRB, &
  & 0.35373920E-12_JPRB, 0.28860697E-12_JPRB, 0.23689766E-12_JPRB, 0.19765302E-12_JPRB, 0.17040937E-12_JPRB, 0.14973134E-12_JPRB, &
  & 0.13374531E-12_JPRB, 0.12279289E-12_JPRB, 0.11894519E-12_JPRB, 0.12447026E-12_JPRB, 0.13937701E-12_JPRB, 0.16171660E-12_JPRB, &
  & 0.19236884E-12_JPRB, 0.24015867E-12_JPRB, 0.30495495E-12_JPRB, 0.48404309E-12_JPRB /)

RGHG5(:,18, 7) = (/ &
  & 0.12251159E-11_JPRB, 0.10406039E-11_JPRB, 0.91097052E-12_JPRB, 0.80618612E-12_JPRB, 0.70407764E-12_JPRB, 0.60965496E-12_JPRB, &
  & 0.52929362E-12_JPRB, 0.47085111E-12_JPRB, 0.44188272E-12_JPRB, 0.44877529E-12_JPRB, 0.49949590E-12_JPRB, 0.60357128E-12_JPRB, &
  & 0.77124467E-12_JPRB, 0.10133203E-11_JPRB, 0.13396560E-11_JPRB, 0.17517052E-11_JPRB, 0.22397644E-11_JPRB, 0.27878127E-11_JPRB, &
  & 0.33814869E-11_JPRB, 0.40100740E-11_JPRB, 0.46811717E-11_JPRB, 0.54207463E-11_JPRB, 0.62782318E-11_JPRB, 0.73034157E-11_JPRB, &
  & 0.84947925E-11_JPRB, 0.97368467E-11_JPRB, 0.10916655E-10_JPRB, 0.11904398E-10_JPRB, 0.12526629E-10_JPRB, 0.12682556E-10_JPRB, &
  & 0.12305270E-10_JPRB, 0.11509891E-10_JPRB, 0.10412950E-10_JPRB, 0.91477208E-11_JPRB, 0.78809372E-11_JPRB, 0.67610002E-11_JPRB, &
  & 0.58198164E-11_JPRB, 0.50694700E-11_JPRB, 0.45989232E-11_JPRB, 0.43052619E-11_JPRB, 0.41052647E-11_JPRB, 0.38821082E-11_JPRB, &
  & 0.36140431E-11_JPRB, 0.33042648E-11_JPRB, 0.29666306E-11_JPRB, 0.26166194E-11_JPRB, 0.22748158E-11_JPRB, 0.19513289E-11_JPRB, &
  & 0.16572217E-11_JPRB, 0.14037954E-11_JPRB, 0.11917990E-11_JPRB, 0.10209160E-11_JPRB, 0.88641220E-12_JPRB, 0.77848166E-12_JPRB, &
  & 0.69741413E-12_JPRB, 0.64132841E-12_JPRB, 0.61103162E-12_JPRB, 0.61221292E-12_JPRB, 0.65268716E-12_JPRB, 0.73047932E-12_JPRB, &
  & 0.83498627E-12_JPRB, 0.96686461E-12_JPRB, 0.11716755E-11_JPRB, 0.15809485E-11_JPRB /)

RGHG5(:,19, 7) = (/ &
  & 0.28860861E-11_JPRB, 0.24805457E-11_JPRB, 0.21903165E-11_JPRB, 0.19557188E-11_JPRB, 0.17310140E-11_JPRB, 0.15184945E-11_JPRB, &
  & 0.13307642E-11_JPRB, 0.11873371E-11_JPRB, 0.11074855E-11_JPRB, 0.11100475E-11_JPRB, 0.12107377E-11_JPRB, 0.14328229E-11_JPRB, &
  & 0.18015101E-11_JPRB, 0.23457482E-11_JPRB, 0.30928103E-11_JPRB, 0.40560723E-11_JPRB, 0.52215853E-11_JPRB, 0.65525753E-11_JPRB, &
  & 0.80157461E-11_JPRB, 0.95981669E-11_JPRB, 0.11321092E-10_JPRB, 0.13226135E-10_JPRB, 0.15400431E-10_JPRB, 0.17935788E-10_JPRB, &
  & 0.20784539E-10_JPRB, 0.23750665E-10_JPRB, 0.26533015E-10_JPRB, 0.28593251E-10_JPRB, 0.29570742E-10_JPRB, 0.29235087E-10_JPRB, &
  & 0.27718156E-10_JPRB, 0.25248845E-10_JPRB, 0.22226622E-10_JPRB, 0.18980808E-10_JPRB, 0.15846307E-10_JPRB, 0.13268412E-10_JPRB, &
  & 0.11406908E-10_JPRB, 0.10281951E-10_JPRB, 0.97627679E-11_JPRB, 0.96477193E-11_JPRB, 0.96962846E-11_JPRB, 0.97224078E-11_JPRB, &
  & 0.95930434E-11_JPRB, 0.92402613E-11_JPRB, 0.86933759E-11_JPRB, 0.80023661E-11_JPRB, 0.72301700E-11_JPRB, 0.64171828E-11_JPRB, &
  & 0.56174809E-11_JPRB, 0.48721270E-11_JPRB, 0.42074855E-11_JPRB, 0.36313155E-11_JPRB, 0.31512351E-11_JPRB, 0.27654506E-11_JPRB, &
  & 0.24822514E-11_JPRB, 0.22931878E-11_JPRB, 0.21866916E-11_JPRB, 0.21578384E-11_JPRB, 0.22158345E-11_JPRB, 0.23618731E-11_JPRB, &
  & 0.25814106E-11_JPRB, 0.28598170E-11_JPRB, 0.32165245E-11_JPRB, 0.39992497E-11_JPRB /)

RGHG5(:,20, 7) = (/ &
  & 0.57199722E-11_JPRB, 0.49567165E-11_JPRB, 0.44487599E-11_JPRB, 0.40228567E-11_JPRB, 0.36169769E-11_JPRB, 0.32226405E-11_JPRB, &
  & 0.28630321E-11_JPRB, 0.25712078E-11_JPRB, 0.23932711E-11_JPRB, 0.23694837E-11_JPRB, 0.25334413E-11_JPRB, 0.29158381E-11_JPRB, &
  & 0.35694950E-11_JPRB, 0.45403785E-11_JPRB, 0.58774361E-11_JPRB, 0.75985320E-11_JPRB, 0.96794161E-11_JPRB, 0.12052461E-10_JPRB, &
  & 0.14643758E-10_JPRB, 0.17414663E-10_JPRB, 0.20429977E-10_JPRB, 0.23765588E-10_JPRB, 0.27512556E-10_JPRB, 0.31774347E-10_JPRB, &
  & 0.36536670E-10_JPRB, 0.41457213E-10_JPRB, 0.45898872E-10_JPRB, 0.49123632E-10_JPRB, 0.50548746E-10_JPRB, 0.49936211E-10_JPRB, &
  & 0.47416997E-10_JPRB, 0.43350833E-10_JPRB, 0.38338999E-10_JPRB, 0.33007971E-10_JPRB, 0.27935028E-10_JPRB, 0.23819238E-10_JPRB, &
  & 0.20888534E-10_JPRB, 0.19232758E-10_JPRB, 0.18617578E-10_JPRB, 0.18760798E-10_JPRB, 0.19306676E-10_JPRB, 0.19793620E-10_JPRB, &
  & 0.19996272E-10_JPRB, 0.19817715E-10_JPRB, 0.19218528E-10_JPRB, 0.18216395E-10_JPRB, 0.16914043E-10_JPRB, 0.15401035E-10_JPRB, &
  & 0.13806796E-10_JPRB, 0.12239187E-10_JPRB, 0.10781306E-10_JPRB, 0.94567583E-11_JPRB, 0.83177519E-11_JPRB, 0.73752792E-11_JPRB, &
  & 0.66572793E-11_JPRB, 0.61530724E-11_JPRB, 0.58421891E-11_JPRB, 0.57056612E-11_JPRB, 0.57367271E-11_JPRB, 0.59168803E-11_JPRB, &
  & 0.62185686E-11_JPRB, 0.66363564E-11_JPRB, 0.72087783E-11_JPRB, 0.82872485E-11_JPRB /)

RGHG5(:,21, 7) = (/ &
  & 0.99567334E-11_JPRB, 0.87388412E-11_JPRB, 0.79773185E-11_JPRB, 0.73162986E-11_JPRB, 0.66745442E-11_JPRB, 0.60407087E-11_JPRB, &
  & 0.54350214E-11_JPRB, 0.49242390E-11_JPRB, 0.45832253E-11_JPRB, 0.44884005E-11_JPRB, 0.46946678E-11_JPRB, 0.52485776E-11_JPRB, &
  & 0.62099024E-11_JPRB, 0.76437971E-11_JPRB, 0.96010300E-11_JPRB, 0.12100494E-10_JPRB, 0.15089542E-10_JPRB, 0.18465911E-10_JPRB, &
  & 0.22133189E-10_JPRB, 0.26030469E-10_JPRB, 0.30190531E-10_JPRB, 0.34773927E-10_JPRB, 0.39928838E-10_JPRB, 0.45779085E-10_JPRB, &
  & 0.52246516E-10_JPRB, 0.58876126E-10_JPRB, 0.64898649E-10_JPRB, 0.69328286E-10_JPRB, 0.71466451E-10_JPRB, 0.71105601E-10_JPRB, &
  & 0.68335171E-10_JPRB, 0.63535843E-10_JPRB, 0.57362084E-10_JPRB, 0.50509465E-10_JPRB, 0.43940043E-10_JPRB, 0.38502077E-10_JPRB, &
  & 0.34616685E-10_JPRB, 0.32452249E-10_JPRB, 0.31893283E-10_JPRB, 0.32344509E-10_JPRB, 0.33298600E-10_JPRB, 0.34238574E-10_JPRB, &
  & 0.34790837E-10_JPRB, 0.34716022E-10_JPRB, 0.33973033E-10_JPRB, 0.32647156E-10_JPRB, 0.30847158E-10_JPRB, 0.28652759E-10_JPRB, &
  & 0.26236312E-10_JPRB, 0.23768799E-10_JPRB, 0.21374675E-10_JPRB, 0.19119739E-10_JPRB, 0.17119252E-10_JPRB, 0.15425067E-10_JPRB, &
  & 0.14083529E-10_JPRB, 0.13081344E-10_JPRB, 0.12396567E-10_JPRB, 0.12009393E-10_JPRB, 0.11908462E-10_JPRB, 0.12048303E-10_JPRB, &
  & 0.12361384E-10_JPRB, 0.12814022E-10_JPRB, 0.13463623E-10_JPRB, 0.14781372E-10_JPRB /)

RGHG5(:,22, 7) = (/ &
  & 0.15854115E-10_JPRB, 0.14115408E-10_JPRB, 0.13040212E-10_JPRB, 0.12109924E-10_JPRB, 0.11195352E-10_JPRB, 0.10265107E-10_JPRB, &
  & 0.93578513E-11_JPRB, 0.85524305E-11_JPRB, 0.79837924E-11_JPRB, 0.77589107E-11_JPRB, 0.79634216E-11_JPRB, 0.86588471E-11_JPRB, &
  & 0.98967431E-11_JPRB, 0.11747534E-10_JPRB, 0.14255282E-10_JPRB, 0.17414707E-10_JPRB, 0.21160724E-10_JPRB, 0.25367290E-10_JPRB, &
  & 0.29912319E-10_JPRB, 0.34760875E-10_JPRB, 0.39947913E-10_JPRB, 0.45606654E-10_JPRB, 0.51896584E-10_JPRB, 0.58963660E-10_JPRB, &
  & 0.66692651E-10_JPRB, 0.74672435E-10_JPRB, 0.81860962E-10_JPRB, 0.87376328E-10_JPRB, 0.90555868E-10_JPRB, 0.91055830E-10_JPRB, &
  & 0.88886100E-10_JPRB, 0.84446644E-10_JPRB, 0.78287501E-10_JPRB, 0.71215804E-10_JPRB, 0.64202477E-10_JPRB, 0.58195837E-10_JPRB, &
  & 0.53810408E-10_JPRB, 0.51301276E-10_JPRB, 0.50381428E-10_JPRB, 0.50766023E-10_JPRB, 0.51725235E-10_JPRB, 0.52673907E-10_JPRB, &
  & 0.53138785E-10_JPRB, 0.52956858E-10_JPRB, 0.51997365E-10_JPRB, 0.50253121E-10_JPRB, 0.47861215E-10_JPRB, 0.44941731E-10_JPRB, &
  & 0.41730914E-10_JPRB, 0.38403475E-10_JPRB, 0.35109481E-10_JPRB, 0.31967318E-10_JPRB, 0.29152958E-10_JPRB, 0.26726201E-10_JPRB, &
  & 0.24739285E-10_JPRB, 0.23177019E-10_JPRB, 0.22016866E-10_JPRB, 0.21245110E-10_JPRB, 0.20861700E-10_JPRB, 0.20820646E-10_JPRB, &
  & 0.21037833E-10_JPRB, 0.21450883E-10_JPRB, 0.22066795E-10_JPRB, 0.23312949E-10_JPRB /)

RGHG5(:,23, 7) = (/ &
  & 0.23421012E-10_JPRB, 0.21122236E-10_JPRB, 0.19774033E-10_JPRB, 0.18568251E-10_JPRB, 0.17369746E-10_JPRB, 0.16136540E-10_JPRB, &
  & 0.14892369E-10_JPRB, 0.13771411E-10_JPRB, 0.12933843E-10_JPRB, 0.12542368E-10_JPRB, 0.12711726E-10_JPRB, 0.13520999E-10_JPRB, &
  & 0.15016700E-10_JPRB, 0.17239004E-10_JPRB, 0.20222733E-10_JPRB, 0.23939141E-10_JPRB, 0.28297576E-10_JPRB, 0.33177277E-10_JPRB, &
  & 0.38443373E-10_JPRB, 0.44055318E-10_JPRB, 0.50064532E-10_JPRB, 0.56593442E-10_JPRB, 0.63777851E-10_JPRB, 0.71710193E-10_JPRB, &
  & 0.80328764E-10_JPRB, 0.89090915E-10_JPRB, 0.97195647E-10_JPRB, 0.10363860E-09_JPRB, 0.10773038E-09_JPRB, 0.10931412E-09_JPRB, &
  & 0.10841045E-09_JPRB, 0.10527974E-09_JPRB, 0.10036476E-09_JPRB, 0.94404748E-10_JPRB, 0.88151458E-10_JPRB, 0.82598255E-10_JPRB, &
  & 0.78288820E-10_JPRB, 0.75513075E-10_JPRB, 0.74194713E-10_JPRB, 0.73863339E-10_JPRB, 0.74015197E-10_JPRB, 0.74108268E-10_JPRB, &
  & 0.73796386E-10_JPRB, 0.72791599E-10_JPRB, 0.71065244E-10_JPRB, 0.68681949E-10_JPRB, 0.65694394E-10_JPRB, 0.62174120E-10_JPRB, &
  & 0.58322291E-10_JPRB, 0.54332476E-10_JPRB, 0.50404712E-10_JPRB, 0.46673877E-10_JPRB, 0.43299444E-10_JPRB, 0.40330184E-10_JPRB, &
  & 0.37824507E-10_JPRB, 0.35774685E-10_JPRB, 0.34163648E-10_JPRB, 0.32980386E-10_JPRB, 0.32231946E-10_JPRB, 0.31877088E-10_JPRB, &
  & 0.31837311E-10_JPRB, 0.32050008E-10_JPRB, 0.32521721E-10_JPRB, 0.33627025E-10_JPRB /)

RGHG5(:,24, 7) = (/ &
  & 0.32405491E-10_JPRB, 0.29784245E-10_JPRB, 0.28151641E-10_JPRB, 0.26722298E-10_JPRB, 0.25285331E-10_JPRB, 0.23786100E-10_JPRB, &
  & 0.22265969E-10_JPRB, 0.20862203E-10_JPRB, 0.19795226E-10_JPRB, 0.19269784E-10_JPRB, 0.19438683E-10_JPRB, 0.20397269E-10_JPRB, &
  & 0.22193844E-10_JPRB, 0.24833214E-10_JPRB, 0.28317723E-10_JPRB, 0.32597012E-10_JPRB, 0.37550300E-10_JPRB, 0.43048721E-10_JPRB, &
  & 0.48967275E-10_JPRB, 0.55245787E-10_JPRB, 0.61908312E-10_JPRB, 0.69039212E-10_JPRB, 0.76773782E-10_JPRB, 0.85171196E-10_JPRB, &
  & 0.94062633E-10_JPRB, 0.10300254E-09_JPRB, 0.11124010E-09_JPRB, 0.11807777E-09_JPRB, 0.12308662E-09_JPRB, 0.12591708E-09_JPRB, &
  & 0.12660373E-09_JPRB, 0.12536490E-09_JPRB, 0.12255598E-09_JPRB, 0.11862314E-09_JPRB, 0.11420415E-09_JPRB, 0.10998453E-09_JPRB, &
  & 0.10637177E-09_JPRB, 0.10360006E-09_JPRB, 0.10152341E-09_JPRB, 0.10004201E-09_JPRB, 0.98747871E-10_JPRB, 0.97319527E-10_JPRB, &
  & 0.95509267E-10_JPRB, 0.93220223E-10_JPRB, 0.90328710E-10_JPRB, 0.86884319E-10_JPRB, 0.83054591E-10_JPRB, 0.78903113E-10_JPRB, &
  & 0.74590764E-10_JPRB, 0.70271053E-10_JPRB, 0.66077310E-10_JPRB, 0.62087897E-10_JPRB, 0.58426639E-10_JPRB, 0.55140097E-10_JPRB, &
  & 0.52287195E-10_JPRB, 0.49873577E-10_JPRB, 0.47896829E-10_JPRB, 0.46357640E-10_JPRB, 0.45266631E-10_JPRB, 0.44589818E-10_JPRB, &
  & 0.44250222E-10_JPRB, 0.44176093E-10_JPRB, 0.44330508E-10_JPRB, 0.44936214E-10_JPRB /)

RGHG5(:,25, 7) = (/ &
  & 0.42680488E-10_JPRB, 0.39730413E-10_JPRB, 0.37987599E-10_JPRB, 0.36416734E-10_JPRB, 0.34855441E-10_JPRB, 0.33219767E-10_JPRB, &
  & 0.31550516E-10_JPRB, 0.30007920E-10_JPRB, 0.28849730E-10_JPRB, 0.28328387E-10_JPRB, 0.28633028E-10_JPRB, 0.29879897E-10_JPRB, &
  & 0.32118610E-10_JPRB, 0.35334201E-10_JPRB, 0.39464158E-10_JPRB, 0.44424391E-10_JPRB, 0.50060803E-10_JPRB, 0.56211175E-10_JPRB, &
  & 0.62741992E-10_JPRB, 0.69583735E-10_JPRB, 0.76721816E-10_JPRB, 0.84192334E-10_JPRB, 0.92016665E-10_JPRB, 0.10024843E-09_JPRB, &
  & 0.10874027E-09_JPRB, 0.11713341E-09_JPRB, 0.12499771E-09_JPRB, 0.13177423E-09_JPRB, 0.13708708E-09_JPRB, 0.14092727E-09_JPRB, &
  & 0.14320535E-09_JPRB, 0.14400534E-09_JPRB, 0.14354981E-09_JPRB, 0.14200906E-09_JPRB, 0.13978112E-09_JPRB, 0.13714886E-09_JPRB, &
  & 0.13444598E-09_JPRB, 0.13177935E-09_JPRB, 0.12902777E-09_JPRB, 0.12631761E-09_JPRB, 0.12342102E-09_JPRB, 0.12021910E-09_JPRB, &
  & 0.11670791E-09_JPRB, 0.11289887E-09_JPRB, 0.10884257E-09_JPRB, 0.10452946E-09_JPRB, 0.99986838E-10_JPRB, 0.95260508E-10_JPRB, &
  & 0.90553183E-10_JPRB, 0.85964909E-10_JPRB, 0.81589360E-10_JPRB, 0.77464715E-10_JPRB, 0.73673470E-10_JPRB, 0.70235484E-10_JPRB, &
  & 0.67190226E-10_JPRB, 0.64542108E-10_JPRB, 0.62294392E-10_JPRB, 0.60460470E-10_JPRB, 0.59061929E-10_JPRB, 0.58077706E-10_JPRB, &
  & 0.57444379E-10_JPRB, 0.57085718E-10_JPRB, 0.56934919E-10_JPRB, 0.57048966E-10_JPRB /)

RGHG5(:,26, 7) = (/ &
  & 0.53692065E-10_JPRB, 0.50741144E-10_JPRB, 0.48980466E-10_JPRB, 0.47425841E-10_JPRB, 0.45878124E-10_JPRB, 0.44276267E-10_JPRB, &
  & 0.42646588E-10_JPRB, 0.41181086E-10_JPRB, 0.40151077E-10_JPRB, 0.39851518E-10_JPRB, 0.40503042E-10_JPRB, 0.42242817E-10_JPRB, &
  & 0.45116168E-10_JPRB, 0.49091436E-10_JPRB, 0.54049792E-10_JPRB, 0.59839245E-10_JPRB, 0.66246300E-10_JPRB, 0.73079397E-10_JPRB, &
  & 0.80160135E-10_JPRB, 0.87358461E-10_JPRB, 0.94606711E-10_JPRB, 0.10193812E-09_JPRB, 0.10935301E-09_JPRB, 0.11678088E-09_JPRB, &
  & 0.12423640E-09_JPRB, 0.13147193E-09_JPRB, 0.13829426E-09_JPRB, 0.14454542E-09_JPRB, 0.15004084E-09_JPRB, 0.15454936E-09_JPRB, &
  & 0.15810464E-09_JPRB, 0.16069554E-09_JPRB, 0.16231981E-09_JPRB, 0.16293124E-09_JPRB, 0.16265098E-09_JPRB, 0.16153545E-09_JPRB, &
  & 0.15968679E-09_JPRB, 0.15714025E-09_JPRB, 0.15392729E-09_JPRB, 0.15007839E-09_JPRB, 0.14580122E-09_JPRB, 0.14100178E-09_JPRB, &
  & 0.13596174E-09_JPRB, 0.13070280E-09_JPRB, 0.12539865E-09_JPRB, 0.12010284E-09_JPRB, 0.11493938E-09_JPRB, 0.10992843E-09_JPRB, &
  & 0.10510882E-09_JPRB, 0.10052598E-09_JPRB, 0.96210928E-10_JPRB, 0.92175045E-10_JPRB, 0.88457297E-10_JPRB, 0.85055157E-10_JPRB, &
  & 0.81984218E-10_JPRB, 0.79247060E-10_JPRB, 0.76856618E-10_JPRB, 0.74839579E-10_JPRB, 0.73222380E-10_JPRB, 0.71994029E-10_JPRB, &
  & 0.71106086E-10_JPRB, 0.70489441E-10_JPRB, 0.70054913E-10_JPRB, 0.69719071E-10_JPRB /)

RGHG5(:,27, 7) = (/ &
  & 0.65186842E-10_JPRB, 0.62470411E-10_JPRB, 0.60845440E-10_JPRB, 0.59425631E-10_JPRB, 0.58041624E-10_JPRB, 0.56623723E-10_JPRB, &
  & 0.55238238E-10_JPRB, 0.54055063E-10_JPRB, 0.53383863E-10_JPRB, 0.53528085E-10_JPRB, 0.54729950E-10_JPRB, 0.57131119E-10_JPRB, &
  & 0.60781290E-10_JPRB, 0.65610399E-10_JPRB, 0.71470087E-10_JPRB, 0.78103538E-10_JPRB, 0.85265794E-10_JPRB, 0.92684395E-10_JPRB, &
  & 0.10012587E-09_JPRB, 0.10738146E-09_JPRB, 0.11442708E-09_JPRB, 0.12128179E-09_JPRB, 0.12775268E-09_JPRB, 0.13398962E-09_JPRB, &
  & 0.14001032E-09_JPRB, 0.14572621E-09_JPRB, 0.15125387E-09_JPRB, 0.15660502E-09_JPRB, 0.16178522E-09_JPRB, 0.16672337E-09_JPRB, &
  & 0.17125611E-09_JPRB, 0.17520177E-09_JPRB, 0.17838041E-09_JPRB, 0.18056073E-09_JPRB, 0.18165888E-09_JPRB, 0.18159131E-09_JPRB, &
  & 0.18033976E-09_JPRB, 0.17789856E-09_JPRB, 0.17440330E-09_JPRB, 0.16984582E-09_JPRB, 0.16461014E-09_JPRB, 0.15875215E-09_JPRB, &
  & 0.15261850E-09_JPRB, 0.14638389E-09_JPRB, 0.14022486E-09_JPRB, 0.13428170E-09_JPRB, 0.12867293E-09_JPRB, 0.12344285E-09_JPRB, &
  & 0.11861234E-09_JPRB, 0.11415405E-09_JPRB, 0.11003227E-09_JPRB, 0.10620577E-09_JPRB, 0.10267277E-09_JPRB, 0.99405692E-10_JPRB, &
  & 0.96406300E-10_JPRB, 0.93677427E-10_JPRB, 0.91238531E-10_JPRB, 0.89110504E-10_JPRB, 0.87324606E-10_JPRB, 0.85881940E-10_JPRB, &
  & 0.84752032E-10_JPRB, 0.83872811E-10_JPRB, 0.83117992E-10_JPRB, 0.82111151E-10_JPRB /)

RGHG5(:,28, 7) = (/ &
  & 0.77139309E-10_JPRB, 0.74689525E-10_JPRB, 0.73273859E-10_JPRB, 0.72069427E-10_JPRB, 0.70925349E-10_JPRB, 0.69812246E-10_JPRB, &
  & 0.68781286E-10_JPRB, 0.68043585E-10_JPRB, 0.67886745E-10_JPRB, 0.68622698E-10_JPRB, 0.70484840E-10_JPRB, 0.73619319E-10_JPRB, &
  & 0.78045223E-10_JPRB, 0.83678779E-10_JPRB, 0.90313056E-10_JPRB, 0.97659644E-10_JPRB, 0.10537928E-09_JPRB, 0.11318143E-09_JPRB, &
  & 0.12072926E-09_JPRB, 0.12782772E-09_JPRB, 0.13445652E-09_JPRB, 0.14051646E-09_JPRB, 0.14588894E-09_JPRB, 0.15078983E-09_JPRB, &
  & 0.15528817E-09_JPRB, 0.15952967E-09_JPRB, 0.16376109E-09_JPRB, 0.16816300E-09_JPRB, 0.17290393E-09_JPRB, 0.17791128E-09_JPRB, &
  & 0.18291783E-09_JPRB, 0.18767463E-09_JPRB, 0.19181395E-09_JPRB, 0.19495083E-09_JPRB, 0.19685831E-09_JPRB, 0.19738280E-09_JPRB, &
  & 0.19646483E-09_JPRB, 0.19409975E-09_JPRB, 0.19044524E-09_JPRB, 0.18561082E-09_JPRB, 0.17981272E-09_JPRB, 0.17341964E-09_JPRB, &
  & 0.16666303E-09_JPRB, 0.15990864E-09_JPRB, 0.15331017E-09_JPRB, 0.14710937E-09_JPRB, 0.14141070E-09_JPRB, 0.13621509E-09_JPRB, &
  & 0.13150978E-09_JPRB, 0.12723561E-09_JPRB, 0.12331808E-09_JPRB, 0.11969922E-09_JPRB, 0.11634782E-09_JPRB, 0.11322467E-09_JPRB, &
  & 0.11031566E-09_JPRB, 0.10762066E-09_JPRB, 0.10514526E-09_JPRB, 0.10291683E-09_JPRB, 0.10097229E-09_JPRB, 0.99329947E-10_JPRB, &
  & 0.97980617E-10_JPRB, 0.96868555E-10_JPRB, 0.95860542E-10_JPRB, 0.94473207E-10_JPRB /)

RGHG5(:,29, 7) = (/ &
  & 0.89066143E-10_JPRB, 0.87027843E-10_JPRB, 0.85843707E-10_JPRB, 0.84896395E-10_JPRB, 0.84041898E-10_JPRB, 0.83263535E-10_JPRB, &
  & 0.82656201E-10_JPRB, 0.82416407E-10_JPRB, 0.82836515E-10_JPRB, 0.84205504E-10_JPRB, 0.86740240E-10_JPRB, 0.90548971E-10_JPRB, &
  & 0.95646421E-10_JPRB, 0.10189739E-09_JPRB, 0.10908505E-09_JPRB, 0.11687117E-09_JPRB, 0.12489682E-09_JPRB, 0.13281148E-09_JPRB, &
  & 0.14028149E-09_JPRB, 0.14706969E-09_JPRB, 0.15311034E-09_JPRB, 0.15833160E-09_JPRB, 0.16269047E-09_JPRB, 0.16635632E-09_JPRB, &
  & 0.16951876E-09_JPRB, 0.17246177E-09_JPRB, 0.17551446E-09_JPRB, 0.17904352E-09_JPRB, 0.18319947E-09_JPRB, 0.18803245E-09_JPRB, &
  & 0.19324582E-09_JPRB, 0.19838725E-09_JPRB, 0.20300768E-09_JPRB, 0.20661113E-09_JPRB, 0.20889655E-09_JPRB, 0.20968503E-09_JPRB, &
  & 0.20892342E-09_JPRB, 0.20662901E-09_JPRB, 0.20292956E-09_JPRB, 0.19804013E-09_JPRB, 0.19212884E-09_JPRB, 0.18549454E-09_JPRB, &
  & 0.17856504E-09_JPRB, 0.17158729E-09_JPRB, 0.16490642E-09_JPRB, 0.15871970E-09_JPRB, 0.15314360E-09_JPRB, 0.14817678E-09_JPRB, &
  & 0.14374719E-09_JPRB, 0.13972748E-09_JPRB, 0.13603986E-09_JPRB, 0.13262047E-09_JPRB, 0.12943339E-09_JPRB, 0.12643728E-09_JPRB, &
  & 0.12361411E-09_JPRB, 0.12095508E-09_JPRB, 0.11847283E-09_JPRB, 0.11620080E-09_JPRB, 0.11418255E-09_JPRB, 0.11244656E-09_JPRB, &
  & 0.11100113E-09_JPRB, 0.10978773E-09_JPRB, 0.10865838E-09_JPRB, 0.10696867E-09_JPRB /)

RGHG5(:,30, 7) = (/ &
  & 0.10063757E-09_JPRB, 0.99066942E-10_JPRB, 0.98183094E-10_JPRB, 0.97495262E-10_JPRB, 0.96920742E-10_JPRB, 0.96481011E-10_JPRB, &
  & 0.96279346E-10_JPRB, 0.96530159E-10_JPRB, 0.97509154E-10_JPRB, 0.99472458E-10_JPRB, 0.10259190E-09_JPRB, 0.10696467E-09_JPRB, &
  & 0.11254459E-09_JPRB, 0.11919704E-09_JPRB, 0.12666429E-09_JPRB, 0.13462396E-09_JPRB, 0.14269079E-09_JPRB, 0.15051954E-09_JPRB, &
  & 0.15776214E-09_JPRB, 0.16417620E-09_JPRB, 0.16963725E-09_JPRB, 0.17412512E-09_JPRB, 0.17762206E-09_JPRB, 0.18030352E-09_JPRB, &
  & 0.18242673E-09_JPRB, 0.18436136E-09_JPRB, 0.18654001E-09_JPRB, 0.18932356E-09_JPRB, 0.19297282E-09_JPRB, 0.19743671E-09_JPRB, &
  & 0.20252547E-09_JPRB, 0.20771924E-09_JPRB, 0.21244753E-09_JPRB, 0.21616993E-09_JPRB, 0.21854227E-09_JPRB, 0.21939181E-09_JPRB, &
  & 0.21869292E-09_JPRB, 0.21649629E-09_JPRB, 0.21289399E-09_JPRB, 0.20809784E-09_JPRB, 0.20230473E-09_JPRB, 0.19579809E-09_JPRB, &
  & 0.18892754E-09_JPRB, 0.18209391E-09_JPRB, 0.17557711E-09_JPRB, 0.16958816E-09_JPRB, 0.16429350E-09_JPRB, 0.15960772E-09_JPRB, &
  & 0.15545296E-09_JPRB, 0.15168046E-09_JPRB, 0.14819398E-09_JPRB, 0.14494578E-09_JPRB, 0.14188992E-09_JPRB, 0.13899319E-09_JPRB, &
  & 0.13624035E-09_JPRB, 0.13362914E-09_JPRB, 0.13117588E-09_JPRB, 0.12891838E-09_JPRB, 0.12689522E-09_JPRB, 0.12513240E-09_JPRB, &
  & 0.12362636E-09_JPRB, 0.12231609E-09_JPRB, 0.12098024E-09_JPRB, 0.11886470E-09_JPRB /)

RGHG5(:,31, 7) = (/ &
  & 0.11189102E-09_JPRB, 0.11066914E-09_JPRB, 0.11002301E-09_JPRB, 0.10956488E-09_JPRB, 0.10924606E-09_JPRB, 0.10910776E-09_JPRB, &
  & 0.10927752E-09_JPRB, 0.10997474E-09_JPRB, 0.11144152E-09_JPRB, 0.11390135E-09_JPRB, 0.11749468E-09_JPRB, 0.12225820E-09_JPRB, &
  & 0.12814404E-09_JPRB, 0.13496902E-09_JPRB, 0.14249400E-09_JPRB, 0.15039248E-09_JPRB, 0.15831710E-09_JPRB, 0.16589870E-09_JPRB, &
  & 0.17283715E-09_JPRB, 0.17887425E-09_JPRB, 0.18385933E-09_JPRB, 0.18775277E-09_JPRB, 0.19059779E-09_JPRB, 0.19257765E-09_JPRB, &
  & 0.19399399E-09_JPRB, 0.19525723E-09_JPRB, 0.19681184E-09_JPRB, 0.19901852E-09_JPRB, 0.20215121E-09_JPRB, 0.20623547E-09_JPRB, &
  & 0.21102649E-09_JPRB, 0.21601426E-09_JPRB, 0.22059346E-09_JPRB, 0.22418654E-09_JPRB, 0.22645445E-09_JPRB, 0.22725052E-09_JPRB, &
  & 0.22658062E-09_JPRB, 0.22451209E-09_JPRB, 0.22115094E-09_JPRB, 0.21660303E-09_JPRB, 0.21111281E-09_JPRB, 0.20492139E-09_JPRB, &
  & 0.19840538E-09_JPRB, 0.19187364E-09_JPRB, 0.18569521E-09_JPRB, 0.18006588E-09_JPRB, 0.17508053E-09_JPRB, 0.17068426E-09_JPRB, &
  & 0.16675591E-09_JPRB, 0.16317643E-09_JPRB, 0.15982818E-09_JPRB, 0.15668097E-09_JPRB, 0.15370612E-09_JPRB, 0.15087384E-09_JPRB, &
  & 0.14817610E-09_JPRB, 0.14561230E-09_JPRB, 0.14320228E-09_JPRB, 0.14097361E-09_JPRB, 0.13895796E-09_JPRB, 0.13717626E-09_JPRB, &
  & 0.13562111E-09_JPRB, 0.13422909E-09_JPRB, 0.13281551E-09_JPRB, 0.13070581E-09_JPRB /)

RGHG5(:,32, 7) = (/ &
  & 0.12254374E-09_JPRB, 0.12159836E-09_JPRB, 0.12117175E-09_JPRB, 0.12092193E-09_JPRB, 0.12083425E-09_JPRB, 0.12097132E-09_JPRB, &
  & 0.12147783E-09_JPRB, 0.12255236E-09_JPRB, 0.12442730E-09_JPRB, 0.12727103E-09_JPRB, 0.13118293E-09_JPRB, 0.13618552E-09_JPRB, &
  & 0.14218199E-09_JPRB, 0.14900438E-09_JPRB, 0.15640217E-09_JPRB, 0.16408609E-09_JPRB, 0.17173409E-09_JPRB, 0.17900699E-09_JPRB, &
  & 0.18561075E-09_JPRB, 0.19130075E-09_JPRB, 0.19591453E-09_JPRB, 0.19940019E-09_JPRB, 0.20181717E-09_JPRB, 0.20336612E-09_JPRB, &
  & 0.20437015E-09_JPRB, 0.20524296E-09_JPRB, 0.20640063E-09_JPRB, 0.20820971E-09_JPRB, 0.21091681E-09_JPRB, 0.21457773E-09_JPRB, &
  & 0.21895012E-09_JPRB, 0.22356900E-09_JPRB, 0.22779682E-09_JPRB, 0.23109056E-09_JPRB, 0.23312696E-09_JPRB, 0.23380242E-09_JPRB, &
  & 0.23315391E-09_JPRB, 0.23126465E-09_JPRB, 0.22820384E-09_JPRB, 0.22408636E-09_JPRB, 0.21902094E-09_JPRB, 0.21330870E-09_JPRB, &
  & 0.20728318E-09_JPRB, 0.20127242E-09_JPRB, 0.19552499E-09_JPRB, 0.19026407E-09_JPRB, 0.18559378E-09_JPRB, 0.18143061E-09_JPRB, &
  & 0.17766243E-09_JPRB, 0.17417998E-09_JPRB, 0.17090894E-09_JPRB, 0.16780480E-09_JPRB, 0.16485918E-09_JPRB, 0.16205889E-09_JPRB, &
  & 0.15939494E-09_JPRB, 0.15687041E-09_JPRB, 0.15449982E-09_JPRB, 0.15230359E-09_JPRB, 0.15030570E-09_JPRB, 0.14852579E-09_JPRB, &
  & 0.14696375E-09_JPRB, 0.14554336E-09_JPRB, 0.14409832E-09_JPRB, 0.14180633E-09_JPRB /)

RGHG5(:,33, 7) = (/ &
  & 0.13233414E-09_JPRB, 0.13177445E-09_JPRB, 0.13156001E-09_JPRB, 0.13151083E-09_JPRB, 0.13164253E-09_JPRB, 0.13203691E-09_JPRB, &
  & 0.13283438E-09_JPRB, 0.13423872E-09_JPRB, 0.13641992E-09_JPRB, 0.13952151E-09_JPRB, 0.14361795E-09_JPRB, 0.14868640E-09_JPRB, &
  & 0.15464754E-09_JPRB, 0.16130972E-09_JPRB, 0.16846542E-09_JPRB, 0.17582857E-09_JPRB, 0.18313767E-09_JPRB, 0.19007132E-09_JPRB, &
  & 0.19635817E-09_JPRB, 0.20176599E-09_JPRB, 0.20612212E-09_JPRB, 0.20936776E-09_JPRB, 0.21155881E-09_JPRB, 0.21291660E-09_JPRB, &
  & 0.21375703E-09_JPRB, 0.21445737E-09_JPRB, 0.21542471E-09_JPRB, 0.21696361E-09_JPRB, 0.21931651E-09_JPRB, 0.22254537E-09_JPRB, &
  & 0.22645209E-09_JPRB, 0.23056174E-09_JPRB, 0.23430705E-09_JPRB, 0.23717298E-09_JPRB, 0.23889807E-09_JPRB, 0.23941504E-09_JPRB, &
  & 0.23878891E-09_JPRB, 0.23710006E-09_JPRB, 0.23441338E-09_JPRB, 0.23076092E-09_JPRB, 0.22628562E-09_JPRB, 0.22117508E-09_JPRB, &
  & 0.21573666E-09_JPRB, 0.21031878E-09_JPRB, 0.20507648E-09_JPRB, 0.20020698E-09_JPRB, 0.19575092E-09_JPRB, 0.19175662E-09_JPRB, &
  & 0.18808910E-09_JPRB, 0.18463202E-09_JPRB, 0.18136001E-09_JPRB, 0.17825258E-09_JPRB, 0.17529805E-09_JPRB, 0.17250208E-09_JPRB, &
  & 0.16985667E-09_JPRB, 0.16736229E-09_JPRB, 0.16503010E-09_JPRB, 0.16286990E-09_JPRB, 0.16090501E-09_JPRB, 0.15915139E-09_JPRB, &
  & 0.15760176E-09_JPRB, 0.15618537E-09_JPRB, 0.15473470E-09_JPRB, 0.15246544E-09_JPRB /)

RGHG5(:,34, 7) = (/ &
  & 0.14143732E-09_JPRB, 0.14122618E-09_JPRB, 0.14121246E-09_JPRB, 0.14135501E-09_JPRB, 0.14169596E-09_JPRB, 0.14232324E-09_JPRB, &
  & 0.14338483E-09_JPRB, 0.14503694E-09_JPRB, 0.14743703E-09_JPRB, 0.15068169E-09_JPRB, 0.15481780E-09_JPRB, 0.15983156E-09_JPRB, &
  & 0.16561828E-09_JPRB, 0.17202637E-09_JPRB, 0.17885375E-09_JPRB, 0.18586338E-09_JPRB, 0.19279692E-09_JPRB, 0.19939971E-09_JPRB, &
  & 0.20539875E-09_JPRB, 0.21059351E-09_JPRB, 0.21480559E-09_JPRB, 0.21794846E-09_JPRB, 0.22010491E-09_JPRB, 0.22146701E-09_JPRB, &
  & 0.22234298E-09_JPRB, 0.22304680E-09_JPRB, 0.22396676E-09_JPRB, 0.22535609E-09_JPRB, 0.22742359E-09_JPRB, 0.23023178E-09_JPRB, &
  & 0.23359409E-09_JPRB, 0.23711150E-09_JPRB, 0.24025884E-09_JPRB, 0.24261648E-09_JPRB, 0.24397934E-09_JPRB, 0.24431765E-09_JPRB, &
  & 0.24371544E-09_JPRB, 0.24223684E-09_JPRB, 0.23992075E-09_JPRB, 0.23680360E-09_JPRB, 0.23293389E-09_JPRB, 0.22850451E-09_JPRB, &
  & 0.22377719E-09_JPRB, 0.21893082E-09_JPRB, 0.21422122E-09_JPRB, 0.20969568E-09_JPRB, 0.20545013E-09_JPRB, 0.20150454E-09_JPRB, &
  & 0.19787745E-09_JPRB, 0.19439772E-09_JPRB, 0.19108543E-09_JPRB, 0.18793984E-09_JPRB, 0.18495926E-09_JPRB, 0.18215422E-09_JPRB, &
  & 0.17951897E-09_JPRB, 0.17705171E-09_JPRB, 0.17475490E-09_JPRB, 0.17263758E-09_JPRB, 0.17071469E-09_JPRB, 0.16899952E-09_JPRB, &
  & 0.16747402E-09_JPRB, 0.16607896E-09_JPRB, 0.16463411E-09_JPRB, 0.16237321E-09_JPRB /)

RGHG5(:,35, 7) = (/ &
  & 0.14991132E-09_JPRB, 0.15000090E-09_JPRB, 0.15018120E-09_JPRB, 0.15050911E-09_JPRB, 0.15104448E-09_JPRB, 0.15188105E-09_JPRB, &
  & 0.15314597E-09_JPRB, 0.15498572E-09_JPRB, 0.15750655E-09_JPRB, 0.16078504E-09_JPRB, 0.16486391E-09_JPRB, 0.16970744E-09_JPRB, &
  & 0.17524715E-09_JPRB, 0.18132733E-09_JPRB, 0.18779493E-09_JPRB, 0.19442252E-09_JPRB, 0.20099861E-09_JPRB, 0.20727785E-09_JPRB, &
  & 0.21303392E-09_JPRB, 0.21806425E-09_JPRB, 0.22221508E-09_JPRB, 0.22540507E-09_JPRB, 0.22768917E-09_JPRB, 0.22921676E-09_JPRB, &
  & 0.23026547E-09_JPRB, 0.23112401E-09_JPRB, 0.23209350E-09_JPRB, 0.23340502E-09_JPRB, 0.23522073E-09_JPRB, 0.23759084E-09_JPRB, &
  & 0.24036556E-09_JPRB, 0.24319585E-09_JPRB, 0.24567678E-09_JPRB, 0.24747698E-09_JPRB, 0.24846142E-09_JPRB, 0.24862196E-09_JPRB, &
  & 0.24804706E-09_JPRB, 0.24676491E-09_JPRB, 0.24483154E-09_JPRB, 0.24222191E-09_JPRB, 0.23898161E-09_JPRB, 0.23524246E-09_JPRB, &
  & 0.23117816E-09_JPRB, 0.22697251E-09_JPRB, 0.22271980E-09_JPRB, 0.21854304E-09_JPRB, 0.21445262E-09_JPRB, 0.21055824E-09_JPRB, &
  & 0.20689880E-09_JPRB, 0.20337670E-09_JPRB, 0.19999741E-09_JPRB, 0.19680382E-09_JPRB, 0.19379374E-09_JPRB, 0.19097930E-09_JPRB, &
  & 0.18835447E-09_JPRB, 0.18591503E-09_JPRB, 0.18365687E-09_JPRB, 0.18158308E-09_JPRB, 0.17970918E-09_JPRB, 0.17804194E-09_JPRB, &
  & 0.17656136E-09_JPRB, 0.17520647E-09_JPRB, 0.17381518E-09_JPRB, 0.17161501E-09_JPRB /)

RGHG5(:,36, 7) = (/ &
  & 0.15782001E-09_JPRB, 0.15819718E-09_JPRB, 0.15856044E-09_JPRB, 0.15905850E-09_JPRB, 0.15976459E-09_JPRB, 0.16076894E-09_JPRB, &
  & 0.16218570E-09_JPRB, 0.16412671E-09_JPRB, 0.16668303E-09_JPRB, 0.16991805E-09_JPRB, 0.17384960E-09_JPRB, 0.17846730E-09_JPRB, &
  & 0.18369514E-09_JPRB, 0.18942398E-09_JPRB, 0.19550209E-09_JPRB, 0.20175750E-09_JPRB, 0.20797664E-09_JPRB, 0.21396739E-09_JPRB, &
  & 0.21952606E-09_JPRB, 0.22446028E-09_JPRB, 0.22863615E-09_JPRB, 0.23196726E-09_JPRB, 0.23445113E-09_JPRB, 0.23623631E-09_JPRB, &
  & 0.23752744E-09_JPRB, 0.23858468E-09_JPRB, 0.23964711E-09_JPRB, 0.24089333E-09_JPRB, 0.24245642E-09_JPRB, 0.24436450E-09_JPRB, &
  & 0.24650065E-09_JPRB, 0.24861568E-09_JPRB, 0.25040769E-09_JPRB, 0.25166694E-09_JPRB, 0.25229965E-09_JPRB, 0.25232219E-09_JPRB, &
  & 0.25179187E-09_JPRB, 0.25071903E-09_JPRB, 0.24915450E-09_JPRB, 0.24703273E-09_JPRB, 0.24437791E-09_JPRB, 0.24129426E-09_JPRB, &
  & 0.23786872E-09_JPRB, 0.23420271E-09_JPRB, 0.23041476E-09_JPRB, 0.22651372E-09_JPRB, 0.22258960E-09_JPRB, 0.21875260E-09_JPRB, &
  & 0.21506763E-09_JPRB, 0.21148658E-09_JPRB, 0.20805459E-09_JPRB, 0.20482142E-09_JPRB, 0.20179036E-09_JPRB, 0.19897736E-09_JPRB, &
  & 0.19637236E-09_JPRB, 0.19396630E-09_JPRB, 0.19174784E-09_JPRB, 0.18972481E-09_JPRB, 0.18790629E-09_JPRB, 0.18629839E-09_JPRB, &
  & 0.18487753E-09_JPRB, 0.18358473E-09_JPRB, 0.18224772E-09_JPRB, 0.18015045E-09_JPRB /)

RGHG5(:,37, 7) = (/ &
  & 0.16530068E-09_JPRB, 0.16595368E-09_JPRB, 0.16647615E-09_JPRB, 0.16712151E-09_JPRB, 0.16796295E-09_JPRB, 0.16908816E-09_JPRB, &
  & 0.17058782E-09_JPRB, 0.17255904E-09_JPRB, 0.17507848E-09_JPRB, 0.17819626E-09_JPRB, 0.18193663E-09_JPRB, 0.18627724E-09_JPRB, &
  & 0.19116975E-09_JPRB, 0.19651884E-09_JPRB, 0.20220749E-09_JPRB, 0.20807170E-09_JPRB, 0.21395118E-09_JPRB, 0.21965968E-09_JPRB, &
  & 0.22503863E-09_JPRB, 0.22992783E-09_JPRB, 0.23416485E-09_JPRB, 0.23764582E-09_JPRB, 0.24033725E-09_JPRB, 0.24231836E-09_JPRB, &
  & 0.24378372E-09_JPRB, 0.24494826E-09_JPRB, 0.24601385E-09_JPRB, 0.24714353E-09_JPRB, 0.24842356E-09_JPRB, 0.24987884E-09_JPRB, &
  & 0.25141997E-09_JPRB, 0.25288655E-09_JPRB, 0.25409302E-09_JPRB, 0.25490438E-09_JPRB, 0.25527969E-09_JPRB, 0.25522354E-09_JPRB, &
  & 0.25478342E-09_JPRB, 0.25394023E-09_JPRB, 0.25274152E-09_JPRB, 0.25107691E-09_JPRB, 0.24901231E-09_JPRB, 0.24651806E-09_JPRB, &
  & 0.24366054E-09_JPRB, 0.24052216E-09_JPRB, 0.23712349E-09_JPRB, 0.23351890E-09_JPRB, 0.22978693E-09_JPRB, 0.22603851E-09_JPRB, &
  & 0.22234166E-09_JPRB, 0.21872548E-09_JPRB, 0.21527154E-09_JPRB, 0.21201979E-09_JPRB, 0.20899121E-09_JPRB, 0.20619785E-09_JPRB, &
  & 0.20362607E-09_JPRB, 0.20125912E-09_JPRB, 0.19908943E-09_JPRB, 0.19711996E-09_JPRB, 0.19536529E-09_JPRB, 0.19382690E-09_JPRB, &
  & 0.19248110E-09_JPRB, 0.19125986E-09_JPRB, 0.19000564E-09_JPRB, 0.18803144E-09_JPRB /)

RGHG5(:,38, 7) = (/ &
  & 0.17251649E-09_JPRB, 0.17338091E-09_JPRB, 0.17403715E-09_JPRB, 0.17478495E-09_JPRB, 0.17573232E-09_JPRB, 0.17692584E-09_JPRB, &
  & 0.17845153E-09_JPRB, 0.18039160E-09_JPRB, 0.18281035E-09_JPRB, 0.18576346E-09_JPRB, 0.18926986E-09_JPRB, 0.19331337E-09_JPRB, &
  & 0.19784765E-09_JPRB, 0.20280597E-09_JPRB, 0.20808766E-09_JPRB, 0.21356189E-09_JPRB, 0.21908114E-09_JPRB, 0.22450884E-09_JPRB, &
  & 0.22970384E-09_JPRB, 0.23450805E-09_JPRB, 0.23876998E-09_JPRB, 0.24229621E-09_JPRB, 0.24501989E-09_JPRB, 0.24701391E-09_JPRB, &
  & 0.24844901E-09_JPRB, 0.24955293E-09_JPRB, 0.25051919E-09_JPRB, 0.25147548E-09_JPRB, 0.25249525E-09_JPRB, 0.25358474E-09_JPRB, &
  & 0.25468497E-09_JPRB, 0.25569696E-09_JPRB, 0.25650271E-09_JPRB, 0.25702473E-09_JPRB, 0.25724400E-09_JPRB, 0.25716881E-09_JPRB, &
  & 0.25682598E-09_JPRB, 0.25620325E-09_JPRB, 0.25531721E-09_JPRB, 0.25409153E-09_JPRB, 0.25254460E-09_JPRB, 0.25061328E-09_JPRB, &
  & 0.24833058E-09_JPRB, 0.24570335E-09_JPRB, 0.24274269E-09_JPRB, 0.23947391E-09_JPRB, 0.23597768E-09_JPRB, 0.23235648E-09_JPRB, &
  & 0.22870258E-09_JPRB, 0.22511418E-09_JPRB, 0.22167682E-09_JPRB, 0.21844711E-09_JPRB, 0.21545102E-09_JPRB, 0.21270115E-09_JPRB, &
  & 0.21017807E-09_JPRB, 0.20786163E-09_JPRB, 0.20574382E-09_JPRB, 0.20383377E-09_JPRB, 0.20214920E-09_JPRB, 0.20069034E-09_JPRB, &
  & 0.19942806E-09_JPRB, 0.19829104E-09_JPRB, 0.19712695E-09_JPRB, 0.19529740E-09_JPRB /)

RGHG5(:,39, 7) = (/ &
  & 0.17953200E-09_JPRB, 0.18054433E-09_JPRB, 0.18127944E-09_JPRB, 0.18211659E-09_JPRB, 0.18311400E-09_JPRB, 0.18434826E-09_JPRB, &
  & 0.18585777E-09_JPRB, 0.18771501E-09_JPRB, 0.18999267E-09_JPRB, 0.19274364E-09_JPRB, 0.19598595E-09_JPRB, 0.19971488E-09_JPRB, &
  & 0.20388458E-09_JPRB, 0.20844043E-09_JPRB, 0.21330497E-09_JPRB, 0.21836713E-09_JPRB, 0.22351036E-09_JPRB, 0.22862470E-09_JPRB, &
  & 0.23358682E-09_JPRB, 0.23825547E-09_JPRB, 0.24238245E-09_JPRB, 0.24578994E-09_JPRB, 0.24836339E-09_JPRB, 0.25019195E-09_JPRB, &
  & 0.25148539E-09_JPRB, 0.25246433E-09_JPRB, 0.25330396E-09_JPRB, 0.25411370E-09_JPRB, 0.25494049E-09_JPRB, 0.25578806E-09_JPRB, &
  & 0.25661401E-09_JPRB, 0.25735031E-09_JPRB, 0.25792246E-09_JPRB, 0.25827634E-09_JPRB, 0.25841032E-09_JPRB, 0.25833027E-09_JPRB, &
  & 0.25806252E-09_JPRB, 0.25759087E-09_JPRB, 0.25693303E-09_JPRB, 0.25603333E-09_JPRB, 0.25489372E-09_JPRB, 0.25345492E-09_JPRB, &
  & 0.25171620E-09_JPRB, 0.24962912E-09_JPRB, 0.24716595E-09_JPRB, 0.24431651E-09_JPRB, 0.24113378E-09_JPRB, 0.23771438E-09_JPRB, &
  & 0.23419300E-09_JPRB, 0.23068887E-09_JPRB, 0.22732001E-09_JPRB, 0.22415293E-09_JPRB, 0.22122465E-09_JPRB, 0.21854439E-09_JPRB, &
  & 0.21608645E-09_JPRB, 0.21382905E-09_JPRB, 0.21176877E-09_JPRB, 0.20992261E-09_JPRB, 0.20831326E-09_JPRB, 0.20694016E-09_JPRB, &
  & 0.20576668E-09_JPRB, 0.20471867E-09_JPRB, 0.20364672E-09_JPRB, 0.20197739E-09_JPRB /)

RGHG5(:,40, 7) = (/ &
  & 0.18633019E-09_JPRB, 0.18743551E-09_JPRB, 0.18823298E-09_JPRB, 0.18909635E-09_JPRB, 0.19015323E-09_JPRB, 0.19138792E-09_JPRB, &
  & 0.19285477E-09_JPRB, 0.19461231E-09_JPRB, 0.19671816E-09_JPRB, 0.19923535E-09_JPRB, 0.20220020E-09_JPRB, 0.20559923E-09_JPRB, &
  & 0.20939825E-09_JPRB, 0.21355018E-09_JPRB, 0.21798714E-09_JPRB, 0.22262003E-09_JPRB, 0.22735833E-09_JPRB, 0.23211194E-09_JPRB, &
  & 0.23678487E-09_JPRB, 0.24118840E-09_JPRB, 0.24511121E-09_JPRB, 0.24827668E-09_JPRB, 0.25062083E-09_JPRB, 0.25225697E-09_JPRB, &
  & 0.25340172E-09_JPRB, 0.25426958E-09_JPRB, 0.25501240E-09_JPRB, 0.25571389E-09_JPRB, 0.25641123E-09_JPRB, 0.25710317E-09_JPRB, &
  & 0.25776045E-09_JPRB, 0.25833694E-09_JPRB, 0.25877117E-09_JPRB, 0.25903013E-09_JPRB, 0.25911365E-09_JPRB, 0.25903521E-09_JPRB, &
  & 0.25881017E-09_JPRB, 0.25843527E-09_JPRB, 0.25791852E-09_JPRB, 0.25722979E-09_JPRB, 0.25636715E-09_JPRB, 0.25529390E-09_JPRB, &
  & 0.25399033E-09_JPRB, 0.25239277E-09_JPRB, 0.25044214E-09_JPRB, 0.24806954E-09_JPRB, 0.24527819E-09_JPRB, 0.24215760E-09_JPRB, &
  & 0.23883548E-09_JPRB, 0.23548719E-09_JPRB, 0.23224167E-09_JPRB, 0.22918462E-09_JPRB, 0.22635988E-09_JPRB, 0.22377157E-09_JPRB, &
  & 0.22139619E-09_JPRB, 0.21920644E-09_JPRB, 0.21721075E-09_JPRB, 0.21543059E-09_JPRB, 0.21390077E-09_JPRB, 0.21261573E-09_JPRB, &
  & 0.21153326E-09_JPRB, 0.21057034E-09_JPRB, 0.20959454E-09_JPRB, 0.20806949E-09_JPRB /)

RGHG5(:,41, 7) = (/ &
  & 0.19293617E-09_JPRB, 0.19408269E-09_JPRB, 0.19487251E-09_JPRB, 0.19577616E-09_JPRB, 0.19683496E-09_JPRB, 0.19807984E-09_JPRB, &
  & 0.19949876E-09_JPRB, 0.20113486E-09_JPRB, 0.20305897E-09_JPRB, 0.20533536E-09_JPRB, 0.20800141E-09_JPRB, 0.21106583E-09_JPRB, &
  & 0.21449346E-09_JPRB, 0.21823793E-09_JPRB, 0.22224293E-09_JPRB, 0.22643619E-09_JPRB, 0.23073990E-09_JPRB, 0.23510233E-09_JPRB, &
  & 0.23942462E-09_JPRB, 0.24354657E-09_JPRB, 0.24716870E-09_JPRB, 0.25007671E-09_JPRB, 0.25219329E-09_JPRB, 0.25365737E-09_JPRB, &
  & 0.25468375E-09_JPRB, 0.25546654E-09_JPRB, 0.25613528E-09_JPRB, 0.25675900E-09_JPRB, 0.25736363E-09_JPRB, 0.25795094E-09_JPRB, &
  & 0.25850239E-09_JPRB, 0.25897612E-09_JPRB, 0.25932886E-09_JPRB, 0.25952868E-09_JPRB, 0.25958255E-09_JPRB, 0.25950528E-09_JPRB, &
  & 0.25930899E-09_JPRB, 0.25899566E-09_JPRB, 0.25856686E-09_JPRB, 0.25801433E-09_JPRB, 0.25733107E-09_JPRB, 0.25650188E-09_JPRB, &
  & 0.25551591E-09_JPRB, 0.25429628E-09_JPRB, 0.25279112E-09_JPRB, 0.25088084E-09_JPRB, 0.24853228E-09_JPRB, 0.24575547E-09_JPRB, &
  & 0.24271307E-09_JPRB, 0.23956875E-09_JPRB, 0.23649219E-09_JPRB, 0.23358618E-09_JPRB, 0.23089447E-09_JPRB, 0.22842778E-09_JPRB, &
  & 0.22614881E-09_JPRB, 0.22404312E-09_JPRB, 0.22211369E-09_JPRB, 0.22040726E-09_JPRB, 0.21895744E-09_JPRB, 0.21776145E-09_JPRB, &
  & 0.21676466E-09_JPRB, 0.21588530E-09_JPRB, 0.21499019E-09_JPRB, 0.21360450E-09_JPRB /)

RGHG5(:,42, 7) = (/ &
  & 0.19959548E-09_JPRB, 0.20050582E-09_JPRB, 0.20124313E-09_JPRB, 0.20211666E-09_JPRB, 0.20321743E-09_JPRB, 0.20445398E-09_JPRB, &
  & 0.20582071E-09_JPRB, 0.20734721E-09_JPRB, 0.20908658E-09_JPRB, 0.21111309E-09_JPRB, 0.21348301E-09_JPRB, 0.21620843E-09_JPRB, &
  & 0.21926246E-09_JPRB, 0.22260416E-09_JPRB, 0.22617813E-09_JPRB, 0.22991950E-09_JPRB, 0.23378377E-09_JPRB, 0.23771402E-09_JPRB, &
  & 0.24165664E-09_JPRB, 0.24543240E-09_JPRB, 0.24878724E-09_JPRB, 0.25144758E-09_JPRB, 0.25336672E-09_JPRB, 0.25468655E-09_JPRB, &
  & 0.25561650E-09_JPRB, 0.25633154E-09_JPRB, 0.25694175E-09_JPRB, 0.25750221E-09_JPRB, 0.25803745E-09_JPRB, 0.25855043E-09_JPRB, &
  & 0.25902674E-09_JPRB, 0.25943575E-09_JPRB, 0.25973218E-09_JPRB, 0.25989527E-09_JPRB, 0.25993033E-09_JPRB, 0.25985500E-09_JPRB, &
  & 0.25968017E-09_JPRB, 0.25940761E-09_JPRB, 0.25904187E-09_JPRB, 0.25857549E-09_JPRB, 0.25801419E-09_JPRB, 0.25734934E-09_JPRB, &
  & 0.25657826E-09_JPRB, 0.25563934E-09_JPRB, 0.25448132E-09_JPRB, 0.25297850E-09_JPRB, 0.25104652E-09_JPRB, 0.24866309E-09_JPRB, &
  & 0.24592459E-09_JPRB, 0.24302402E-09_JPRB, 0.24014687E-09_JPRB, 0.23741983E-09_JPRB, 0.23489352E-09_JPRB, 0.23256350E-09_JPRB, &
  & 0.23040739E-09_JPRB, 0.22839272E-09_JPRB, 0.22654578E-09_JPRB, 0.22491350E-09_JPRB, 0.22354818E-09_JPRB, 0.22243807E-09_JPRB, &
  & 0.22152349E-09_JPRB, 0.22071640E-09_JPRB, 0.21989555E-09_JPRB, 0.21861910E-09_JPRB /)

RGHG5(:,43, 7) = (/ &
  & 0.20525484E-09_JPRB, 0.20640613E-09_JPRB, 0.20721042E-09_JPRB, 0.20816503E-09_JPRB, 0.20929009E-09_JPRB, 0.21055874E-09_JPRB, &
  & 0.21188334E-09_JPRB, 0.21330161E-09_JPRB, 0.21486533E-09_JPRB, 0.21665353E-09_JPRB, 0.21872792E-09_JPRB, 0.22111601E-09_JPRB, &
  & 0.22380188E-09_JPRB, 0.22674324E-09_JPRB, 0.22988647E-09_JPRB, 0.23318558E-09_JPRB, 0.23658844E-09_JPRB, 0.24009217E-09_JPRB, &
  & 0.24363278E-09_JPRB, 0.24708052E-09_JPRB, 0.25013686E-09_JPRB, 0.25256397E-09_JPRB, 0.25430053E-09_JPRB, 0.25549524E-09_JPRB, &
  & 0.25634322E-09_JPRB, 0.25700020E-09_JPRB, 0.25755972E-09_JPRB, 0.25806876E-09_JPRB, 0.25854863E-09_JPRB, 0.25900546E-09_JPRB, &
  & 0.25942978E-09_JPRB, 0.25979008E-09_JPRB, 0.26005040E-09_JPRB, 0.26018721E-09_JPRB, 0.26021088E-09_JPRB, 0.26013849E-09_JPRB, &
  & 0.25998037E-09_JPRB, 0.25973934E-09_JPRB, 0.25941657E-09_JPRB, 0.25901409E-09_JPRB, 0.25853544E-09_JPRB, 0.25798258E-09_JPRB, &
  & 0.25736432E-09_JPRB, 0.25662683E-09_JPRB, 0.25573199E-09_JPRB, 0.25456168E-09_JPRB, 0.25301702E-09_JPRB, 0.25101485E-09_JPRB, &
  & 0.24860236E-09_JPRB, 0.24596034E-09_JPRB, 0.24329816E-09_JPRB, 0.24076971E-09_JPRB, 0.23842206E-09_JPRB, 0.23625432E-09_JPRB, &
  & 0.23423316E-09_JPRB, 0.23233505E-09_JPRB, 0.23057684E-09_JPRB, 0.22903164E-09_JPRB, 0.22775162E-09_JPRB, 0.22672647E-09_JPRB, &
  & 0.22588729E-09_JPRB, 0.22514499E-09_JPRB, 0.22438307E-09_JPRB, 0.22319062E-09_JPRB /)

RGHG5(:,44, 7) = (/ &
  & 0.21086256E-09_JPRB, 0.21218098E-09_JPRB, 0.21304881E-09_JPRB, 0.21399890E-09_JPRB, 0.21519619E-09_JPRB, 0.21645420E-09_JPRB, &
  & 0.21775728E-09_JPRB, 0.21906832E-09_JPRB, 0.22047035E-09_JPRB, 0.22202769E-09_JPRB, 0.22381819E-09_JPRB, 0.22587911E-09_JPRB, &
  & 0.22820050E-09_JPRB, 0.23074424E-09_JPRB, 0.23346994E-09_JPRB, 0.23631508E-09_JPRB, 0.23927660E-09_JPRB, 0.24232052E-09_JPRB, &
  & 0.24545657E-09_JPRB, 0.24853350E-09_JPRB, 0.25131414E-09_JPRB, 0.25350863E-09_JPRB, 0.25507896E-09_JPRB, 0.25615979E-09_JPRB, &
  & 0.25693489E-09_JPRB, 0.25753960E-09_JPRB, 0.25805433E-09_JPRB, 0.25851915E-09_JPRB, 0.25895533E-09_JPRB, 0.25936972E-09_JPRB, &
  & 0.25975377E-09_JPRB, 0.26008090E-09_JPRB, 0.26031322E-09_JPRB, 0.26043309E-09_JPRB, 0.26044991E-09_JPRB, 0.26038136E-09_JPRB, &
  & 0.26023741E-09_JPRB, 0.26002006E-09_JPRB, 0.25973193E-09_JPRB, 0.25937416E-09_JPRB, 0.25895597E-09_JPRB, 0.25848490E-09_JPRB, &
  & 0.25797081E-09_JPRB, 0.25738658E-09_JPRB, 0.25668617E-09_JPRB, 0.25578789E-09_JPRB, 0.25457825E-09_JPRB, 0.25293956E-09_JPRB, &
  & 0.25087168E-09_JPRB, 0.24849062E-09_JPRB, 0.24605637E-09_JPRB, 0.24372826E-09_JPRB, 0.24157182E-09_JPRB, 0.23958108E-09_JPRB, &
  & 0.23771929E-09_JPRB, 0.23595365E-09_JPRB, 0.23430824E-09_JPRB, 0.23285734E-09_JPRB, 0.23166864E-09_JPRB, 0.23072588E-09_JPRB, &
  & 0.22995521E-09_JPRB, 0.22926921E-09_JPRB, 0.22855412E-09_JPRB, 0.22742287E-09_JPRB /)

RGHG5(:,45, 7) = (/ &
  & 0.21726133E-09_JPRB, 0.21818847E-09_JPRB, 0.21888664E-09_JPRB, 0.21981958E-09_JPRB, 0.22096519E-09_JPRB, 0.22227613E-09_JPRB, &
  & 0.22350635E-09_JPRB, 0.22473678E-09_JPRB, 0.22597041E-09_JPRB, 0.22731649E-09_JPRB, 0.22883284E-09_JPRB, 0.23057478E-09_JPRB, &
  & 0.23254074E-09_JPRB, 0.23470004E-09_JPRB, 0.23699662E-09_JPRB, 0.23941665E-09_JPRB, 0.24190758E-09_JPRB, 0.24452060E-09_JPRB, &
  & 0.24721217E-09_JPRB, 0.24992811E-09_JPRB, 0.25237526E-09_JPRB, 0.25433838E-09_JPRB, 0.25573979E-09_JPRB, 0.25671684E-09_JPRB, &
  & 0.25742486E-09_JPRB, 0.25798275E-09_JPRB, 0.25845731E-09_JPRB, 0.25888588E-09_JPRB, 0.25928673E-09_JPRB, 0.25966826E-09_JPRB, &
  & 0.26002306E-09_JPRB, 0.26032393E-09_JPRB, 0.26053748E-09_JPRB, 0.26064567E-09_JPRB, 0.26065938E-09_JPRB, 0.26059555E-09_JPRB, &
  & 0.26046343E-09_JPRB, 0.26026545E-09_JPRB, 0.26000380E-09_JPRB, 0.25968031E-09_JPRB, 0.25930827E-09_JPRB, 0.25889402E-09_JPRB, &
  & 0.25846039E-09_JPRB, 0.25798380E-09_JPRB, 0.25743405E-09_JPRB, 0.25674834E-09_JPRB, 0.25581715E-09_JPRB, 0.25453595E-09_JPRB, &
  & 0.25280436E-09_JPRB, 0.25073069E-09_JPRB, 0.24852562E-09_JPRB, 0.24640293E-09_JPRB, 0.24444707E-09_JPRB, 0.24264651E-09_JPRB, &
  & 0.24096192E-09_JPRB, 0.23935642E-09_JPRB, 0.23783911E-09_JPRB, 0.23650013E-09_JPRB, 0.23540445E-09_JPRB, 0.23453986E-09_JPRB, &
  & 0.23383179E-09_JPRB, 0.23319308E-09_JPRB, 0.23251635E-09_JPRB, 0.23142477E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART13',1,ZHOOK_HANDLE)
END SUBROUTINE PART13




SUBROUTINE PART14
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART14',0,ZHOOK_HANDLE)



RGHG5(:,46, 7) = (/ &
  & 0.22219923E-09_JPRB, 0.22366319E-09_JPRB, 0.22458491E-09_JPRB, 0.22554622E-09_JPRB, 0.22680621E-09_JPRB, 0.22806031E-09_JPRB, &
  & 0.22929814E-09_JPRB, 0.23039444E-09_JPRB, 0.23148485E-09_JPRB, 0.23260546E-09_JPRB, 0.23386293E-09_JPRB, 0.23529259E-09_JPRB, &
  & 0.23690974E-09_JPRB, 0.23867805E-09_JPRB, 0.24057123E-09_JPRB, 0.24253041E-09_JPRB, 0.24459029E-09_JPRB, 0.24672248E-09_JPRB, &
  & 0.24898658E-09_JPRB, 0.25125435E-09_JPRB, 0.25337007E-09_JPRB, 0.25506583E-09_JPRB, 0.25630886E-09_JPRB, 0.25718561E-09_JPRB, &
  & 0.25783392E-09_JPRB, 0.25834848E-09_JPRB, 0.25878924E-09_JPRB, 0.25918664E-09_JPRB, 0.25956035E-09_JPRB, 0.25991681E-09_JPRB, &
  & 0.26024877E-09_JPRB, 0.26053121E-09_JPRB, 0.26073074E-09_JPRB, 0.26083222E-09_JPRB, 0.26084568E-09_JPRB, 0.26078700E-09_JPRB, &
  & 0.26066505E-09_JPRB, 0.26048325E-09_JPRB, 0.26024155E-09_JPRB, 0.25994765E-09_JPRB, 0.25960675E-09_JPRB, 0.25924080E-09_JPRB, &
  & 0.25885949E-09_JPRB, 0.25846653E-09_JPRB, 0.25802793E-09_JPRB, 0.25750188E-09_JPRB, 0.25680597E-09_JPRB, 0.25582803E-09_JPRB, &
  & 0.25447061E-09_JPRB, 0.25272698E-09_JPRB, 0.25080099E-09_JPRB, 0.24890406E-09_JPRB, 0.24715477E-09_JPRB, 0.24556054E-09_JPRB, &
  & 0.24407079E-09_JPRB, 0.24263594E-09_JPRB, 0.24127267E-09_JPRB, 0.24004931E-09_JPRB, 0.23904967E-09_JPRB, 0.23825708E-09_JPRB, &
  & 0.23760341E-09_JPRB, 0.23700544E-09_JPRB, 0.23635982E-09_JPRB, 0.23529842E-09_JPRB /)

RGHG5(:,47, 7) = (/ &
  & 0.22868014E-09_JPRB, 0.22977191E-09_JPRB, 0.23055764E-09_JPRB, 0.23156081E-09_JPRB, 0.23276603E-09_JPRB, 0.23410732E-09_JPRB, &
  & 0.23522090E-09_JPRB, 0.23622643E-09_JPRB, 0.23711721E-09_JPRB, 0.23802507E-09_JPRB, 0.23900137E-09_JPRB, 0.24011917E-09_JPRB, &
  & 0.24138277E-09_JPRB, 0.24276953E-09_JPRB, 0.24422911E-09_JPRB, 0.24576444E-09_JPRB, 0.24734206E-09_JPRB, 0.24902314E-09_JPRB, &
  & 0.25077554E-09_JPRB, 0.25259553E-09_JPRB, 0.25429145E-09_JPRB, 0.25572250E-09_JPRB, 0.25679461E-09_JPRB, 0.25758090E-09_JPRB, &
  & 0.25817323E-09_JPRB, 0.25865127E-09_JPRB, 0.25906161E-09_JPRB, 0.25943508E-09_JPRB, 0.25978669E-09_JPRB, 0.26012420E-09_JPRB, &
  & 0.26043986E-09_JPRB, 0.26070787E-09_JPRB, 0.26089850E-09_JPRB, 0.26099675E-09_JPRB, 0.26101213E-09_JPRB, 0.26095898E-09_JPRB, &
  & 0.26084621E-09_JPRB, 0.26067665E-09_JPRB, 0.26045427E-09_JPRB, 0.26017957E-09_JPRB, 0.25987021E-09_JPRB, 0.25953223E-09_JPRB, &
  & 0.25919700E-09_JPRB, 0.25885807E-09_JPRB, 0.25850463E-09_JPRB, 0.25809893E-09_JPRB, 0.25758431E-09_JPRB, 0.25687732E-09_JPRB, &
  & 0.25586791E-09_JPRB, 0.25453348E-09_JPRB, 0.25294422E-09_JPRB, 0.25133451E-09_JPRB, 0.24982008E-09_JPRB, 0.24844160E-09_JPRB, &
  & 0.24715016E-09_JPRB, 0.24590366E-09_JPRB, 0.24468744E-09_JPRB, 0.24358790E-09_JPRB, 0.24267388E-09_JPRB, 0.24194610E-09_JPRB, &
  & 0.24133756E-09_JPRB, 0.24077346E-09_JPRB, 0.24015256E-09_JPRB, 0.23911512E-09_JPRB /)

RGHG5(:,48, 7) = (/ &
  & 0.23375510E-09_JPRB, 0.23530977E-09_JPRB, 0.23639918E-09_JPRB, 0.23754543E-09_JPRB, 0.23896268E-09_JPRB, 0.24027971E-09_JPRB, &
  & 0.24139848E-09_JPRB, 0.24223637E-09_JPRB, 0.24295202E-09_JPRB, 0.24361646E-09_JPRB, 0.24431793E-09_JPRB, 0.24511118E-09_JPRB, &
  & 0.24601585E-09_JPRB, 0.24700714E-09_JPRB, 0.24805114E-09_JPRB, 0.24911767E-09_JPRB, 0.25022812E-09_JPRB, 0.25137728E-09_JPRB, &
  & 0.25260907E-09_JPRB, 0.25388872E-09_JPRB, 0.25516600E-09_JPRB, 0.25630090E-09_JPRB, 0.25721461E-09_JPRB, 0.25791208E-09_JPRB, &
  & 0.25845612E-09_JPRB, 0.25890048E-09_JPRB, 0.25928709E-09_JPRB, 0.25963956E-09_JPRB, 0.25997493E-09_JPRB, 0.26029823E-09_JPRB, &
  & 0.26060115E-09_JPRB, 0.26085978E-09_JPRB, 0.26104455E-09_JPRB, 0.26114239E-09_JPRB, 0.26116118E-09_JPRB, 0.26111383E-09_JPRB, &
  & 0.26100877E-09_JPRB, 0.26085092E-09_JPRB, 0.26064167E-09_JPRB, 0.26038938E-09_JPRB, 0.26009755E-09_JPRB, 0.25978950E-09_JPRB, &
  & 0.25947963E-09_JPRB, 0.25918478E-09_JPRB, 0.25889096E-09_JPRB, 0.25857547E-09_JPRB, 0.25819977E-09_JPRB, 0.25770386E-09_JPRB, &
  & 0.25702396E-09_JPRB, 0.25609326E-09_JPRB, 0.25497413E-09_JPRB, 0.25373006E-09_JPRB, 0.25253394E-09_JPRB, 0.25140651E-09_JPRB, &
  & 0.25032898E-09_JPRB, 0.24925806E-09_JPRB, 0.24818902E-09_JPRB, 0.24718699E-09_JPRB, 0.24634567E-09_JPRB, 0.24566274E-09_JPRB, &
  & 0.24508739E-09_JPRB, 0.24454502E-09_JPRB, 0.24394098E-09_JPRB, 0.24291449E-09_JPRB /)

RGHG5(:,49, 7) = (/ &
  & 0.23883140E-09_JPRB, 0.24069291E-09_JPRB, 0.24192798E-09_JPRB, 0.24326618E-09_JPRB, 0.24477159E-09_JPRB, 0.24621813E-09_JPRB, &
  & 0.24725660E-09_JPRB, 0.24799507E-09_JPRB, 0.24854796E-09_JPRB, 0.24901209E-09_JPRB, 0.24947741E-09_JPRB, 0.24998448E-09_JPRB, &
  & 0.25056346E-09_JPRB, 0.25118535E-09_JPRB, 0.25181973E-09_JPRB, 0.25244412E-09_JPRB, 0.25305627E-09_JPRB, 0.25368452E-09_JPRB, &
  & 0.25435506E-09_JPRB, 0.25511093E-09_JPRB, 0.25596600E-09_JPRB, 0.25681748E-09_JPRB, 0.25757307E-09_JPRB, 0.25819180E-09_JPRB, &
  & 0.25869137E-09_JPRB, 0.25910846E-09_JPRB, 0.25947366E-09_JPRB, 0.25981051E-09_JPRB, 0.26013233E-09_JPRB, 0.26044472E-09_JPRB, &
  & 0.26073887E-09_JPRB, 0.26099037E-09_JPRB, 0.26117231E-09_JPRB, 0.26127164E-09_JPRB, 0.26129504E-09_JPRB, 0.26125346E-09_JPRB, &
  & 0.26115521E-09_JPRB, 0.26100705E-09_JPRB, 0.26081182E-09_JPRB, 0.26057456E-09_JPRB, 0.26030383E-09_JPRB, 0.26001173E-09_JPRB, &
  & 0.25972707E-09_JPRB, 0.25945981E-09_JPRB, 0.25921054E-09_JPRB, 0.25896080E-09_JPRB, 0.25868527E-09_JPRB, 0.25835067E-09_JPRB, &
  & 0.25791785E-09_JPRB, 0.25736935E-09_JPRB, 0.25668478E-09_JPRB, 0.25594096E-09_JPRB, 0.25514518E-09_JPRB, 0.25435401E-09_JPRB, &
  & 0.25355371E-09_JPRB, 0.25268523E-09_JPRB, 0.25176902E-09_JPRB, 0.25086877E-09_JPRB, 0.25007896E-09_JPRB, 0.24943295E-09_JPRB, &
  & 0.24887462E-09_JPRB, 0.24834479E-09_JPRB, 0.24774333E-09_JPRB, 0.24670732E-09_JPRB /)

RGHG5(:,50, 7) = (/ &
  & 0.24397886E-09_JPRB, 0.24563335E-09_JPRB, 0.24676947E-09_JPRB, 0.24803887E-09_JPRB, 0.24951316E-09_JPRB, 0.25087052E-09_JPRB, &
  & 0.25180755E-09_JPRB, 0.25242453E-09_JPRB, 0.25283498E-09_JPRB, 0.25317673E-09_JPRB, 0.25348035E-09_JPRB, 0.25380648E-09_JPRB, &
  & 0.25415597E-09_JPRB, 0.25451363E-09_JPRB, 0.25483970E-09_JPRB, 0.25512159E-09_JPRB, 0.25536367E-09_JPRB, 0.25558786E-09_JPRB, &
  & 0.25584132E-09_JPRB, 0.25619740E-09_JPRB, 0.25667057E-09_JPRB, 0.25727628E-09_JPRB, 0.25788260E-09_JPRB, 0.25842806E-09_JPRB, &
  & 0.25888991E-09_JPRB, 0.25928309E-09_JPRB, 0.25963171E-09_JPRB, 0.25995470E-09_JPRB, 0.26026609E-09_JPRB, 0.26056984E-09_JPRB, &
  & 0.26085697E-09_JPRB, 0.26110397E-09_JPRB, 0.26128477E-09_JPRB, 0.26138705E-09_JPRB, 0.26141561E-09_JPRB, 0.26137920E-09_JPRB, &
  & 0.26128819E-09_JPRB, 0.26114805E-09_JPRB, 0.26096544E-09_JPRB, 0.26074287E-09_JPRB, 0.26048780E-09_JPRB, 0.26021299E-09_JPRB, &
  & 0.25994296E-09_JPRB, 0.25969873E-09_JPRB, 0.25948063E-09_JPRB, 0.25927785E-09_JPRB, 0.25907188E-09_JPRB, 0.25884761E-09_JPRB, &
  & 0.25858782E-09_JPRB, 0.25828500E-09_JPRB, 0.25794786E-09_JPRB, 0.25756650E-09_JPRB, 0.25717253E-09_JPRB, 0.25675070E-09_JPRB, &
  & 0.25626662E-09_JPRB, 0.25572333E-09_JPRB, 0.25506230E-09_JPRB, 0.25435712E-09_JPRB, 0.25370656E-09_JPRB, 0.25313002E-09_JPRB, &
  & 0.25262406E-09_JPRB, 0.25211661E-09_JPRB, 0.25152172E-09_JPRB, 0.25045122E-09_JPRB /)

RGHG5(:,51, 7) = (/ &
  & 0.24788069E-09_JPRB, 0.24944027E-09_JPRB, 0.25046915E-09_JPRB, 0.25153438E-09_JPRB, 0.25280628E-09_JPRB, 0.25392435E-09_JPRB, &
  & 0.25469013E-09_JPRB, 0.25513117E-09_JPRB, 0.25544714E-09_JPRB, 0.25567165E-09_JPRB, 0.25588678E-09_JPRB, 0.25609875E-09_JPRB, &
  & 0.25632127E-09_JPRB, 0.25652649E-09_JPRB, 0.25668795E-09_JPRB, 0.25679647E-09_JPRB, 0.25685978E-09_JPRB, 0.25690142E-09_JPRB, &
  & 0.25695657E-09_JPRB, 0.25706445E-09_JPRB, 0.25730934E-09_JPRB, 0.25767427E-09_JPRB, 0.25815436E-09_JPRB, 0.25863126E-09_JPRB, &
  & 0.25905997E-09_JPRB, 0.25943384E-09_JPRB, 0.25976821E-09_JPRB, 0.26008035E-09_JPRB, 0.26038222E-09_JPRB, 0.26067845E-09_JPRB, &
  & 0.26095998E-09_JPRB, 0.26120356E-09_JPRB, 0.26138475E-09_JPRB, 0.26149075E-09_JPRB, 0.26152464E-09_JPRB, 0.26149413E-09_JPRB, &
  & 0.26140839E-09_JPRB, 0.26127839E-09_JPRB, 0.26110475E-09_JPRB, 0.26089722E-09_JPRB, 0.26065508E-09_JPRB, 0.26039432E-09_JPRB, &
  & 0.26013827E-09_JPRB, 0.25991037E-09_JPRB, 0.25971528E-09_JPRB, 0.25954444E-09_JPRB, 0.25938807E-09_JPRB, 0.25923316E-09_JPRB, &
  & 0.25907887E-09_JPRB, 0.25892083E-09_JPRB, 0.25875713E-09_JPRB, 0.25859237E-09_JPRB, 0.25841657E-09_JPRB, 0.25822755E-09_JPRB, &
  & 0.25802205E-09_JPRB, 0.25774938E-09_JPRB, 0.25742661E-09_JPRB, 0.25704155E-09_JPRB, 0.25664074E-09_JPRB, 0.25627395E-09_JPRB, &
  & 0.25590011E-09_JPRB, 0.25550262E-09_JPRB, 0.25497976E-09_JPRB, 0.25396632E-09_JPRB /)

RGHG5(:,52, 7) = (/ &
  & 0.25152394E-09_JPRB, 0.25252675E-09_JPRB, 0.25321989E-09_JPRB, 0.25402655E-09_JPRB, 0.25497443E-09_JPRB, 0.25584951E-09_JPRB, &
  & 0.25638278E-09_JPRB, 0.25672170E-09_JPRB, 0.25692026E-09_JPRB, 0.25708607E-09_JPRB, 0.25722505E-09_JPRB, 0.25736999E-09_JPRB, &
  & 0.25751695E-09_JPRB, 0.25764357E-09_JPRB, 0.25772762E-09_JPRB, 0.25776409E-09_JPRB, 0.25776484E-09_JPRB, 0.25774646E-09_JPRB, &
  & 0.25773128E-09_JPRB, 0.25774599E-09_JPRB, 0.25782682E-09_JPRB, 0.25805461E-09_JPRB, 0.25839395E-09_JPRB, 0.25881014E-09_JPRB, &
  & 0.25920946E-09_JPRB, 0.25956720E-09_JPRB, 0.25989030E-09_JPRB, 0.26019223E-09_JPRB, 0.26048597E-09_JPRB, 0.26077487E-09_JPRB, &
  & 0.26105076E-09_JPRB, 0.26129196E-09_JPRB, 0.26147434E-09_JPRB, 0.26158486E-09_JPRB, 0.26162411E-09_JPRB, 0.26159894E-09_JPRB, &
  & 0.26152119E-09_JPRB, 0.26139693E-09_JPRB, 0.26123559E-09_JPRB, 0.26103752E-09_JPRB, 0.26080915E-09_JPRB, 0.26056010E-09_JPRB, &
  & 0.26031663E-09_JPRB, 0.26010133E-09_JPRB, 0.25992419E-09_JPRB, 0.25977692E-09_JPRB, 0.25965091E-09_JPRB, 0.25954325E-09_JPRB, &
  & 0.25944702E-09_JPRB, 0.25936292E-09_JPRB, 0.25928601E-09_JPRB, 0.25921015E-09_JPRB, 0.25913763E-09_JPRB, 0.25906366E-09_JPRB, &
  & 0.25897440E-09_JPRB, 0.25887589E-09_JPRB, 0.25873939E-09_JPRB, 0.25858060E-09_JPRB, 0.25841562E-09_JPRB, 0.25823627E-09_JPRB, &
  & 0.25805413E-09_JPRB, 0.25782670E-09_JPRB, 0.25750083E-09_JPRB, 0.25674260E-09_JPRB /)

RGHG5(:,53, 7) = (/ &
  & 0.25380370E-09_JPRB, 0.25462921E-09_JPRB, 0.25517594E-09_JPRB, 0.25575658E-09_JPRB, 0.25645325E-09_JPRB, 0.25706126E-09_JPRB, &
  & 0.25746719E-09_JPRB, 0.25768160E-09_JPRB, 0.25783248E-09_JPRB, 0.25793578E-09_JPRB, 0.25803426E-09_JPRB, 0.25813232E-09_JPRB, &
  & 0.25823099E-09_JPRB, 0.25831448E-09_JPRB, 0.25836083E-09_JPRB, 0.25836908E-09_JPRB, 0.25834956E-09_JPRB, 0.25831676E-09_JPRB, &
  & 0.25827876E-09_JPRB, 0.25825780E-09_JPRB, 0.25827770E-09_JPRB, 0.25837740E-09_JPRB, 0.25862840E-09_JPRB, 0.25897359E-09_JPRB, &
  & 0.25934535E-09_JPRB, 0.25968891E-09_JPRB, 0.26000155E-09_JPRB, 0.26029531E-09_JPRB, 0.26058022E-09_JPRB, 0.26086205E-09_JPRB, &
  & 0.26113262E-09_JPRB, 0.26137137E-09_JPRB, 0.26155589E-09_JPRB, 0.26167063E-09_JPRB, 0.26171609E-09_JPRB, 0.26169741E-09_JPRB, &
  & 0.26162483E-09_JPRB, 0.26150998E-09_JPRB, 0.26135566E-09_JPRB, 0.26116878E-09_JPRB, 0.26095026E-09_JPRB, 0.26071265E-09_JPRB, &
  & 0.26048055E-09_JPRB, 0.26027885E-09_JPRB, 0.26011382E-09_JPRB, 0.25998320E-09_JPRB, 0.25988017E-09_JPRB, 0.25979818E-09_JPRB, &
  & 0.25973626E-09_JPRB, 0.25968744E-09_JPRB, 0.25964716E-09_JPRB, 0.25961316E-09_JPRB, 0.25958136E-09_JPRB, 0.25954935E-09_JPRB, &
  & 0.25951769E-09_JPRB, 0.25947453E-09_JPRB, 0.25942501E-09_JPRB, 0.25936270E-09_JPRB, 0.25929192E-09_JPRB, 0.25922303E-09_JPRB, &
  & 0.25914138E-09_JPRB, 0.25904534E-09_JPRB, 0.25890062E-09_JPRB, 0.25851932E-09_JPRB /)

RGHG5(:,54, 7) = (/ &
  & 0.25575883E-09_JPRB, 0.25625360E-09_JPRB, 0.25660535E-09_JPRB, 0.25700153E-09_JPRB, 0.25747526E-09_JPRB, 0.25790761E-09_JPRB, &
  & 0.25817301E-09_JPRB, 0.25833838E-09_JPRB, 0.25843247E-09_JPRB, 0.25850910E-09_JPRB, 0.25857433E-09_JPRB, 0.25864147E-09_JPRB, &
  & 0.25871175E-09_JPRB, 0.25876751E-09_JPRB, 0.25879537E-09_JPRB, 0.25879252E-09_JPRB, 0.25876837E-09_JPRB, 0.25873115E-09_JPRB, &
  & 0.25869420E-09_JPRB, 0.25865504E-09_JPRB, 0.25864155E-09_JPRB, 0.25868932E-09_JPRB, 0.25884195E-09_JPRB, 0.25913310E-09_JPRB, &
  & 0.25947405E-09_JPRB, 0.25980315E-09_JPRB, 0.26010633E-09_JPRB, 0.26039060E-09_JPRB, 0.26066846E-09_JPRB, 0.26094249E-09_JPRB, &
  & 0.26120756E-09_JPRB, 0.26144467E-09_JPRB, 0.26163055E-09_JPRB, 0.26175070E-09_JPRB, 0.26180186E-09_JPRB, 0.26178926E-09_JPRB, &
  & 0.26172406E-09_JPRB, 0.26161517E-09_JPRB, 0.26146946E-09_JPRB, 0.26129024E-09_JPRB, 0.26108049E-09_JPRB, 0.26085462E-09_JPRB, &
  & 0.26063410E-09_JPRB, 0.26044339E-09_JPRB, 0.26029112E-09_JPRB, 0.26017272E-09_JPRB, 0.26008282E-09_JPRB, 0.26001834E-09_JPRB, &
  & 0.25997215E-09_JPRB, 0.25993988E-09_JPRB, 0.25991637E-09_JPRB, 0.25989721E-09_JPRB, 0.25988164E-09_JPRB, 0.25986790E-09_JPRB, &
  & 0.25985197E-09_JPRB, 0.25983554E-09_JPRB, 0.25981262E-09_JPRB, 0.25978614E-09_JPRB, 0.25975866E-09_JPRB, 0.25972827E-09_JPRB, &
  & 0.25969879E-09_JPRB, 0.25966740E-09_JPRB, 0.25964017E-09_JPRB, 0.25963701E-09_JPRB /)

RGHG5(:,55, 7) = (/ &
  & 0.25698899E-09_JPRB, 0.25737631E-09_JPRB, 0.25762936E-09_JPRB, 0.25790803E-09_JPRB, 0.25821900E-09_JPRB, 0.25850577E-09_JPRB, &
  & 0.25870200E-09_JPRB, 0.25880709E-09_JPRB, 0.25887897E-09_JPRB, 0.25892866E-09_JPRB, 0.25897490E-09_JPRB, 0.25902244E-09_JPRB, &
  & 0.25907018E-09_JPRB, 0.25911062E-09_JPRB, 0.25912811E-09_JPRB, 0.25912167E-09_JPRB, 0.25909694E-09_JPRB, 0.25906366E-09_JPRB, &
  & 0.25902092E-09_JPRB, 0.25898486E-09_JPRB, 0.25895072E-09_JPRB, 0.25895674E-09_JPRB, 0.25906033E-09_JPRB, 0.25929034E-09_JPRB, &
  & 0.25960117E-09_JPRB, 0.25991376E-09_JPRB, 0.26020597E-09_JPRB, 0.26048269E-09_JPRB, 0.26075139E-09_JPRB, 0.26101921E-09_JPRB, &
  & 0.26127894E-09_JPRB, 0.26151367E-09_JPRB, 0.26170144E-09_JPRB, 0.26182581E-09_JPRB, 0.26188285E-09_JPRB, 0.26187674E-09_JPRB, &
  & 0.26181790E-09_JPRB, 0.26171568E-09_JPRB, 0.26157626E-09_JPRB, 0.26140384E-09_JPRB, 0.26120309E-09_JPRB, 0.26098615E-09_JPRB, &
  & 0.26077909E-09_JPRB, 0.26060029E-09_JPRB, 0.26045788E-09_JPRB, 0.26034913E-09_JPRB, 0.26026936E-09_JPRB, 0.26021268E-09_JPRB, &
  & 0.26017472E-09_JPRB, 0.26014893E-09_JPRB, 0.26013042E-09_JPRB, 0.26011737E-09_JPRB, 0.26010713E-09_JPRB, 0.26009792E-09_JPRB, &
  & 0.26008973E-09_JPRB, 0.26007896E-09_JPRB, 0.26006708E-09_JPRB, 0.26005259E-09_JPRB, 0.26003649E-09_JPRB, 0.26002112E-09_JPRB, &
  & 0.26000369E-09_JPRB, 0.25998539E-09_JPRB, 0.25996483E-09_JPRB, 0.25993829E-09_JPRB /)

RGHG5(:,56, 7) = (/ &
  & 0.25798652E-09_JPRB, 0.25822111E-09_JPRB, 0.25839000E-09_JPRB, 0.25856636E-09_JPRB, 0.25877767E-09_JPRB, 0.25896810E-09_JPRB, &
  & 0.25909699E-09_JPRB, 0.25917785E-09_JPRB, 0.25922489E-09_JPRB, 0.25926208E-09_JPRB, 0.25929453E-09_JPRB, 0.25932761E-09_JPRB, &
  & 0.25936336E-09_JPRB, 0.25939223E-09_JPRB, 0.25940505E-09_JPRB, 0.25939842E-09_JPRB, 0.25937599E-09_JPRB, 0.25934216E-09_JPRB, &
  & 0.25930513E-09_JPRB, 0.25925839E-09_JPRB, 0.25922198E-09_JPRB, 0.25920441E-09_JPRB, 0.25926350E-09_JPRB, 0.25945202E-09_JPRB, &
  & 0.25973015E-09_JPRB, 0.26002439E-09_JPRB, 0.26030489E-09_JPRB, 0.26057162E-09_JPRB, 0.26083402E-09_JPRB, 0.26109406E-09_JPRB, &
  & 0.26134914E-09_JPRB, 0.26158145E-09_JPRB, 0.26176994E-09_JPRB, 0.26189789E-09_JPRB, 0.26196034E-09_JPRB, 0.26196062E-09_JPRB, &
  & 0.26190797E-09_JPRB, 0.26181199E-09_JPRB, 0.26167807E-09_JPRB, 0.26151165E-09_JPRB, 0.26131786E-09_JPRB, 0.26111296E-09_JPRB, &
  & 0.26091698E-09_JPRB, 0.26075000E-09_JPRB, 0.26061747E-09_JPRB, 0.26051669E-09_JPRB, 0.26044289E-09_JPRB, 0.26039149E-09_JPRB, &
  & 0.26035596E-09_JPRB, 0.26033126E-09_JPRB, 0.26031396E-09_JPRB, 0.26030089E-09_JPRB, 0.26029104E-09_JPRB, 0.26028318E-09_JPRB, &
  & 0.26027464E-09_JPRB, 0.26026642E-09_JPRB, 0.26025604E-09_JPRB, 0.26024494E-09_JPRB, 0.26023411E-09_JPRB, 0.26022245E-09_JPRB, &
  & 0.26021102E-09_JPRB, 0.26019806E-09_JPRB, 0.26018379E-09_JPRB, 0.26016372E-09_JPRB /)

RGHG5(:,57, 7) = (/ &
  & 0.25863789E-09_JPRB, 0.25882518E-09_JPRB, 0.25894353E-09_JPRB, 0.25907093E-09_JPRB, 0.25920210E-09_JPRB, 0.25933114E-09_JPRB, &
  & 0.25942384E-09_JPRB, 0.25947794E-09_JPRB, 0.25951424E-09_JPRB, 0.25954039E-09_JPRB, 0.25956426E-09_JPRB, 0.25958946E-09_JPRB, &
  & 0.25961538E-09_JPRB, 0.25963862E-09_JPRB, 0.25964933E-09_JPRB, 0.25964408E-09_JPRB, 0.25962396E-09_JPRB, 0.25959329E-09_JPRB, &
  & 0.25955163E-09_JPRB, 0.25950844E-09_JPRB, 0.25945784E-09_JPRB, 0.25942801E-09_JPRB, 0.25946215E-09_JPRB, 0.25961586E-09_JPRB, &
  & 0.25986391E-09_JPRB, 0.26013752E-09_JPRB, 0.26040489E-09_JPRB, 0.26066299E-09_JPRB, 0.26091651E-09_JPRB, 0.26117106E-09_JPRB, &
  & 0.26142019E-09_JPRB, 0.26164981E-09_JPRB, 0.26183805E-09_JPRB, 0.26196856E-09_JPRB, 0.26203523E-09_JPRB, 0.26204136E-09_JPRB, &
  & 0.26199534E-09_JPRB, 0.26190444E-09_JPRB, 0.26177593E-09_JPRB, 0.26161484E-09_JPRB, 0.26142913E-09_JPRB, 0.26123387E-09_JPRB, &
  & 0.26105079E-09_JPRB, 0.26089492E-09_JPRB, 0.26077066E-09_JPRB, 0.26067681E-09_JPRB, 0.26060801E-09_JPRB, 0.26055888E-09_JPRB, &
  & 0.26052427E-09_JPRB, 0.26049896E-09_JPRB, 0.26047922E-09_JPRB, 0.26046440E-09_JPRB, 0.26045285E-09_JPRB, 0.26044231E-09_JPRB, &
  & 0.26043323E-09_JPRB, 0.26042249E-09_JPRB, 0.26041164E-09_JPRB, 0.26040034E-09_JPRB, 0.26038896E-09_JPRB, 0.26037866E-09_JPRB, &
  & 0.26036739E-09_JPRB, 0.26035538E-09_JPRB, 0.26034097E-09_JPRB, 0.26031657E-09_JPRB /)

RGHG5(:,58, 7) = (/ &
  & 0.25916699E-09_JPRB, 0.25928915E-09_JPRB, 0.25937186E-09_JPRB, 0.25945268E-09_JPRB, 0.25954527E-09_JPRB, 0.25962971E-09_JPRB, &
  & 0.25969435E-09_JPRB, 0.25973590E-09_JPRB, 0.25976227E-09_JPRB, 0.25978270E-09_JPRB, 0.25980146E-09_JPRB, 0.25982078E-09_JPRB, &
  & 0.25984268E-09_JPRB, 0.25986230E-09_JPRB, 0.25987351E-09_JPRB, 0.25987090E-09_JPRB, 0.25985386E-09_JPRB, 0.25982289E-09_JPRB, &
  & 0.25978292E-09_JPRB, 0.25972952E-09_JPRB, 0.25967745E-09_JPRB, 0.25963362E-09_JPRB, 0.25965183E-09_JPRB, 0.25978128E-09_JPRB, &
  & 0.26000266E-09_JPRB, 0.26025609E-09_JPRB, 0.26050964E-09_JPRB, 0.26075747E-09_JPRB, 0.26100358E-09_JPRB, 0.26125055E-09_JPRB, &
  & 0.26149446E-09_JPRB, 0.26172037E-09_JPRB, 0.26190730E-09_JPRB, 0.26203861E-09_JPRB, 0.26210883E-09_JPRB, 0.26212005E-09_JPRB, &
  & 0.26207947E-09_JPRB, 0.26199454E-09_JPRB, 0.26187064E-09_JPRB, 0.26171515E-09_JPRB, 0.26153704E-09_JPRB, 0.26135291E-09_JPRB, &
  & 0.26118174E-09_JPRB, 0.26103519E-09_JPRB, 0.26091979E-09_JPRB, 0.26083102E-09_JPRB, 0.26076608E-09_JPRB, 0.26071892E-09_JPRB, &
  & 0.26068434E-09_JPRB, 0.26065761E-09_JPRB, 0.26063587E-09_JPRB, 0.26061769E-09_JPRB, 0.26060210E-09_JPRB, 0.26058930E-09_JPRB, &
  & 0.26057551E-09_JPRB, 0.26056252E-09_JPRB, 0.26054836E-09_JPRB, 0.26053462E-09_JPRB, 0.26052249E-09_JPRB, 0.26051025E-09_JPRB, &
  & 0.26049851E-09_JPRB, 0.26048555E-09_JPRB, 0.26047015E-09_JPRB, 0.26044472E-09_JPRB /)

RGHG5(:,59, 7) = (/ &
  & 0.25953795E-09_JPRB, 0.25964059E-09_JPRB, 0.25970287E-09_JPRB, 0.25976327E-09_JPRB, 0.25982350E-09_JPRB, 0.25988439E-09_JPRB, &
  & 0.25993119E-09_JPRB, 0.25996263E-09_JPRB, 0.25998384E-09_JPRB, 0.26000060E-09_JPRB, 0.26001593E-09_JPRB, 0.26003308E-09_JPRB, &
  & 0.26005192E-09_JPRB, 0.26007121E-09_JPRB, 0.26008409E-09_JPRB, 0.26008501E-09_JPRB, 0.26007113E-09_JPRB, 0.26004141E-09_JPRB, &
  & 0.25999627E-09_JPRB, 0.25994099E-09_JPRB, 0.25987656E-09_JPRB, 0.25982694E-09_JPRB, 0.25983535E-09_JPRB, 0.25994779E-09_JPRB, &
  & 0.26014613E-09_JPRB, 0.26038019E-09_JPRB, 0.26062044E-09_JPRB, 0.26085814E-09_JPRB, 0.26109601E-09_JPRB, 0.26133556E-09_JPRB, &
  & 0.26157310E-09_JPRB, 0.26179409E-09_JPRB, 0.26197841E-09_JPRB, 0.26210947E-09_JPRB, 0.26218136E-09_JPRB, 0.26219657E-09_JPRB, &
  & 0.26216140E-09_JPRB, 0.26208136E-09_JPRB, 0.26196309E-09_JPRB, 0.26181327E-09_JPRB, 0.26164376E-09_JPRB, 0.26147048E-09_JPRB, &
  & 0.26130945E-09_JPRB, 0.26117411E-09_JPRB, 0.26106395E-09_JPRB, 0.26098107E-09_JPRB, 0.26091884E-09_JPRB, 0.26087302E-09_JPRB, &
  & 0.26083843E-09_JPRB, 0.26081085E-09_JPRB, 0.26078720E-09_JPRB, 0.26076583E-09_JPRB, 0.26074734E-09_JPRB, 0.26072874E-09_JPRB, &
  & 0.26071187E-09_JPRB, 0.26069313E-09_JPRB, 0.26067501E-09_JPRB, 0.26065808E-09_JPRB, 0.26064217E-09_JPRB, 0.26062813E-09_JPRB, &
  & 0.26061361E-09_JPRB, 0.26059821E-09_JPRB, 0.26058034E-09_JPRB, 0.26054925E-09_JPRB /)

RGHG5(:,60, 7) = (/ &
  & 0.25985092E-09_JPRB, 0.25992972E-09_JPRB, 0.25997590E-09_JPRB, 0.26001853E-09_JPRB, 0.26006355E-09_JPRB, 0.26010619E-09_JPRB, &
  & 0.26014263E-09_JPRB, 0.26016783E-09_JPRB, 0.26018612E-09_JPRB, 0.26020058E-09_JPRB, 0.26021507E-09_JPRB, 0.26023059E-09_JPRB, &
  & 0.26024968E-09_JPRB, 0.26026953E-09_JPRB, 0.26028549E-09_JPRB, 0.26029048E-09_JPRB, 0.26027988E-09_JPRB, 0.26025007E-09_JPRB, &
  & 0.26020225E-09_JPRB, 0.26013683E-09_JPRB, 0.26006733E-09_JPRB, 0.26001129E-09_JPRB, 0.26001493E-09_JPRB, 0.26011365E-09_JPRB, &
  & 0.26029279E-09_JPRB, 0.26050995E-09_JPRB, 0.26073715E-09_JPRB, 0.26096564E-09_JPRB, 0.26119468E-09_JPRB, 0.26142677E-09_JPRB, &
  & 0.26165667E-09_JPRB, 0.26187211E-09_JPRB, 0.26205216E-09_JPRB, 0.26218092E-09_JPRB, 0.26225339E-09_JPRB, 0.26227118E-09_JPRB, &
  & 0.26224015E-09_JPRB, 0.26216579E-09_JPRB, 0.26205277E-09_JPRB, 0.26191022E-09_JPRB, 0.26174940E-09_JPRB, 0.26158625E-09_JPRB, &
  & 0.26143765E-09_JPRB, 0.26130850E-09_JPRB, 0.26120678E-09_JPRB, 0.26112701E-09_JPRB, 0.26106764E-09_JPRB, 0.26102270E-09_JPRB, &
  & 0.26098793E-09_JPRB, 0.26095964E-09_JPRB, 0.26093483E-09_JPRB, 0.26091201E-09_JPRB, 0.26088942E-09_JPRB, 0.26086816E-09_JPRB, &
  & 0.26084479E-09_JPRB, 0.26082156E-09_JPRB, 0.26079772E-09_JPRB, 0.26077557E-09_JPRB, 0.26075636E-09_JPRB, 0.26073788E-09_JPRB, &
  & 0.26071989E-09_JPRB, 0.26070096E-09_JPRB, 0.26067806E-09_JPRB, 0.26064012E-09_JPRB /)

RGHG5(:,61, 7) = (/ &
  & 0.26010386E-09_JPRB, 0.26016886E-09_JPRB, 0.26020658E-09_JPRB, 0.26024005E-09_JPRB, 0.26027333E-09_JPRB, 0.26030722E-09_JPRB, &
  & 0.26033586E-09_JPRB, 0.26035812E-09_JPRB, 0.26037436E-09_JPRB, 0.26038868E-09_JPRB, 0.26040245E-09_JPRB, 0.26041896E-09_JPRB, &
  & 0.26043845E-09_JPRB, 0.26046099E-09_JPRB, 0.26048036E-09_JPRB, 0.26048952E-09_JPRB, 0.26048175E-09_JPRB, 0.26045133E-09_JPRB, &
  & 0.26039818E-09_JPRB, 0.26032729E-09_JPRB, 0.26025010E-09_JPRB, 0.26019192E-09_JPRB, 0.26019165E-09_JPRB, 0.26027946E-09_JPRB, &
  & 0.26044183E-09_JPRB, 0.26064415E-09_JPRB, 0.26086028E-09_JPRB, 0.26107921E-09_JPRB, 0.26130093E-09_JPRB, 0.26152414E-09_JPRB, &
  & 0.26174679E-09_JPRB, 0.26195446E-09_JPRB, 0.26212882E-09_JPRB, 0.26225377E-09_JPRB, 0.26232472E-09_JPRB, 0.26234398E-09_JPRB, &
  & 0.26231667E-09_JPRB, 0.26224700E-09_JPRB, 0.26214075E-09_JPRB, 0.26200536E-09_JPRB, 0.26185418E-09_JPRB, 0.26170249E-09_JPRB, &
  & 0.26156177E-09_JPRB, 0.26144359E-09_JPRB, 0.26134545E-09_JPRB, 0.26127084E-09_JPRB, 0.26121316E-09_JPRB, 0.26116906E-09_JPRB, &
  & 0.26113411E-09_JPRB, 0.26110511E-09_JPRB, 0.26107963E-09_JPRB, 0.26105546E-09_JPRB, 0.26103164E-09_JPRB, 0.26100622E-09_JPRB, &
  & 0.26097946E-09_JPRB, 0.26095004E-09_JPRB, 0.26092062E-09_JPRB, 0.26089311E-09_JPRB, 0.26086819E-09_JPRB, 0.26084535E-09_JPRB, &
  & 0.26082245E-09_JPRB, 0.26079744E-09_JPRB, 0.26076838E-09_JPRB, 0.26071667E-09_JPRB /)

RGHG5(:,62, 7) = (/ &
  & 0.26032454E-09_JPRB, 0.26037866E-09_JPRB, 0.26040886E-09_JPRB, 0.26043595E-09_JPRB, 0.26046348E-09_JPRB, 0.26049071E-09_JPRB, &
  & 0.26051616E-09_JPRB, 0.26053623E-09_JPRB, 0.26055283E-09_JPRB, 0.26056721E-09_JPRB, 0.26058253E-09_JPRB, 0.26059993E-09_JPRB, &
  & 0.26062233E-09_JPRB, 0.26064773E-09_JPRB, 0.26067129E-09_JPRB, 0.26068403E-09_JPRB, 0.26067792E-09_JPRB, 0.26064623E-09_JPRB, &
  & 0.26058825E-09_JPRB, 0.26051139E-09_JPRB, 0.26043054E-09_JPRB, 0.26037070E-09_JPRB, 0.26036706E-09_JPRB, 0.26044458E-09_JPRB, &
  & 0.26059349E-09_JPRB, 0.26078273E-09_JPRB, 0.26098868E-09_JPRB, 0.26119987E-09_JPRB, 0.26141336E-09_JPRB, 0.26162927E-09_JPRB, &
  & 0.26184260E-09_JPRB, 0.26204217E-09_JPRB, 0.26220859E-09_JPRB, 0.26232777E-09_JPRB, 0.26239583E-09_JPRB, 0.26241517E-09_JPRB, &
  & 0.26239064E-09_JPRB, 0.26232622E-09_JPRB, 0.26222630E-09_JPRB, 0.26209973E-09_JPRB, 0.26195823E-09_JPRB, 0.26181621E-09_JPRB, &
  & 0.26168723E-09_JPRB, 0.26157421E-09_JPRB, 0.26148372E-09_JPRB, 0.26141159E-09_JPRB, 0.26135621E-09_JPRB, 0.26131278E-09_JPRB, &
  & 0.26127786E-09_JPRB, 0.26124836E-09_JPRB, 0.26122232E-09_JPRB, 0.26119748E-09_JPRB, 0.26117225E-09_JPRB, 0.26114508E-09_JPRB, &
  & 0.26111444E-09_JPRB, 0.26108102E-09_JPRB, 0.26104599E-09_JPRB, 0.26101274E-09_JPRB, 0.26098260E-09_JPRB, 0.26095423E-09_JPRB, &
  & 0.26092528E-09_JPRB, 0.26089447E-09_JPRB, 0.26085489E-09_JPRB, 0.26078636E-09_JPRB /)

RGHG5(:,63, 7) = (/ &
  & 0.26051122E-09_JPRB, 0.26056127E-09_JPRB, 0.26058933E-09_JPRB, 0.26061353E-09_JPRB, 0.26063737E-09_JPRB, 0.26066191E-09_JPRB, &
  & 0.26068478E-09_JPRB, 0.26070524E-09_JPRB, 0.26072233E-09_JPRB, 0.26073882E-09_JPRB, 0.26075592E-09_JPRB, 0.26077698E-09_JPRB, &
  & 0.26080263E-09_JPRB, 0.26083263E-09_JPRB, 0.26085969E-09_JPRB, 0.26087488E-09_JPRB, 0.26086894E-09_JPRB, 0.26083463E-09_JPRB, &
  & 0.26077335E-09_JPRB, 0.26069286E-09_JPRB, 0.26060940E-09_JPRB, 0.26054819E-09_JPRB, 0.26054134E-09_JPRB, 0.26061081E-09_JPRB, &
  & 0.26074765E-09_JPRB, 0.26092592E-09_JPRB, 0.26112298E-09_JPRB, 0.26132632E-09_JPRB, 0.26153310E-09_JPRB, 0.26174038E-09_JPRB, &
  & 0.26194491E-09_JPRB, 0.26213368E-09_JPRB, 0.26229102E-09_JPRB, 0.26240268E-09_JPRB, 0.26246633E-09_JPRB, 0.26248478E-09_JPRB, &
  & 0.26246244E-09_JPRB, 0.26240274E-09_JPRB, 0.26231017E-09_JPRB, 0.26219221E-09_JPRB, 0.26206098E-09_JPRB, 0.26193006E-09_JPRB, &
  & 0.26180877E-09_JPRB, 0.26170521E-09_JPRB, 0.26161856E-09_JPRB, 0.26155073E-09_JPRB, 0.26149696E-09_JPRB, 0.26145439E-09_JPRB, &
  & 0.26141964E-09_JPRB, 0.26139005E-09_JPRB, 0.26136365E-09_JPRB, 0.26133845E-09_JPRB, 0.26131244E-09_JPRB, 0.26128363E-09_JPRB, &
  & 0.26125066E-09_JPRB, 0.26121386E-09_JPRB, 0.26117472E-09_JPRB, 0.26113636E-09_JPRB, 0.26110089E-09_JPRB, 0.26106722E-09_JPRB, &
  & 0.26103342E-09_JPRB, 0.26099531E-09_JPRB, 0.26094676E-09_JPRB, 0.26085739E-09_JPRB /)

RGHG5(:,64, 7) = (/ &
  & 0.26067820E-09_JPRB, 0.26072702E-09_JPRB, 0.26075367E-09_JPRB, 0.26077657E-09_JPRB, 0.26079913E-09_JPRB, 0.26082170E-09_JPRB, &
  & 0.26084440E-09_JPRB, 0.26086500E-09_JPRB, 0.26088462E-09_JPRB, 0.26090341E-09_JPRB, 0.26092467E-09_JPRB, 0.26094954E-09_JPRB, &
  & 0.26098085E-09_JPRB, 0.26101493E-09_JPRB, 0.26104496E-09_JPRB, 0.26106078E-09_JPRB, 0.26105357E-09_JPRB, 0.26101737E-09_JPRB, &
  & 0.26095312E-09_JPRB, 0.26087052E-09_JPRB, 0.26078584E-09_JPRB, 0.26072383E-09_JPRB, 0.26071451E-09_JPRB, 0.26077718E-09_JPRB, &
  & 0.26090433E-09_JPRB, 0.26107275E-09_JPRB, 0.26126137E-09_JPRB, 0.26145766E-09_JPRB, 0.26165664E-09_JPRB, 0.26185568E-09_JPRB, &
  & 0.26204938E-09_JPRB, 0.26222693E-09_JPRB, 0.26237279E-09_JPRB, 0.26247599E-09_JPRB, 0.26253424E-09_JPRB, 0.26255101E-09_JPRB, &
  & 0.26253053E-09_JPRB, 0.26247571E-09_JPRB, 0.26239039E-09_JPRB, 0.26228197E-09_JPRB, 0.26216124E-09_JPRB, 0.26204020E-09_JPRB, &
  & 0.26192903E-09_JPRB, 0.26183145E-09_JPRB, 0.26175112E-09_JPRB, 0.26168623E-09_JPRB, 0.26163458E-09_JPRB, 0.26159297E-09_JPRB, &
  & 0.26155864E-09_JPRB, 0.26152927E-09_JPRB, 0.26150304E-09_JPRB, 0.26147778E-09_JPRB, 0.26145139E-09_JPRB, 0.26142169E-09_JPRB, &
  & 0.26138700E-09_JPRB, 0.26134769E-09_JPRB, 0.26130534E-09_JPRB, 0.26126301E-09_JPRB, 0.26122288E-09_JPRB, 0.26118485E-09_JPRB, &
  & 0.26114622E-09_JPRB, 0.26110369E-09_JPRB, 0.26104560E-09_JPRB, 0.26093774E-09_JPRB /)

RGHG5(:,65, 7) = (/ &
  & 0.26082880E-09_JPRB, 0.26087849E-09_JPRB, 0.26090577E-09_JPRB, 0.26092872E-09_JPRB, 0.26095082E-09_JPRB, 0.26097324E-09_JPRB, &
  & 0.26099525E-09_JPRB, 0.26101793E-09_JPRB, 0.26103936E-09_JPRB, 0.26106278E-09_JPRB, 0.26108823E-09_JPRB, 0.26111963E-09_JPRB, &
  & 0.26115585E-09_JPRB, 0.26119393E-09_JPRB, 0.26122493E-09_JPRB, 0.26124006E-09_JPRB, 0.26123131E-09_JPRB, 0.26119323E-09_JPRB, &
  & 0.26112806E-09_JPRB, 0.26104471E-09_JPRB, 0.26095942E-09_JPRB, 0.26089730E-09_JPRB, 0.26088637E-09_JPRB, 0.26094377E-09_JPRB, &
  & 0.26106253E-09_JPRB, 0.26122182E-09_JPRB, 0.26140223E-09_JPRB, 0.26159047E-09_JPRB, 0.26178124E-09_JPRB, 0.26197039E-09_JPRB, &
  & 0.26215252E-09_JPRB, 0.26231692E-09_JPRB, 0.26245081E-09_JPRB, 0.26254446E-09_JPRB, 0.26259706E-09_JPRB, 0.26261202E-09_JPRB, &
  & 0.26259311E-09_JPRB, 0.26254315E-09_JPRB, 0.26246560E-09_JPRB, 0.26236677E-09_JPRB, 0.26225683E-09_JPRB, 0.26214642E-09_JPRB, &
  & 0.26204383E-09_JPRB, 0.26195424E-09_JPRB, 0.26187866E-09_JPRB, 0.26181768E-09_JPRB, 0.26176800E-09_JPRB, 0.26172778E-09_JPRB, &
  & 0.26169417E-09_JPRB, 0.26166549E-09_JPRB, 0.26163977E-09_JPRB, 0.26161495E-09_JPRB, 0.26158870E-09_JPRB, 0.26155861E-09_JPRB, &
  & 0.26152294E-09_JPRB, 0.26148203E-09_JPRB, 0.26143721E-09_JPRB, 0.26139174E-09_JPRB, 0.26134814E-09_JPRB, 0.26130642E-09_JPRB, &
  & 0.26126462E-09_JPRB, 0.26121855E-09_JPRB, 0.26115402E-09_JPRB, 0.26103086E-09_JPRB /)

RGHG5(:,66, 7) = (/ &
  & 0.26096486E-09_JPRB, 0.26101915E-09_JPRB, 0.26104827E-09_JPRB, 0.26107289E-09_JPRB, 0.26109609E-09_JPRB, 0.26111877E-09_JPRB, &
  & 0.26114214E-09_JPRB, 0.26116515E-09_JPRB, 0.26119087E-09_JPRB, 0.26121730E-09_JPRB, 0.26124947E-09_JPRB, 0.26128572E-09_JPRB, &
  & 0.26132715E-09_JPRB, 0.26136654E-09_JPRB, 0.26139726E-09_JPRB, 0.26141125E-09_JPRB, 0.26140132E-09_JPRB, 0.26136276E-09_JPRB, &
  & 0.26129732E-09_JPRB, 0.26121416E-09_JPRB, 0.26113017E-09_JPRB, 0.26106908E-09_JPRB, 0.26105718E-09_JPRB, 0.26111038E-09_JPRB, &
  & 0.26122121E-09_JPRB, 0.26137162E-09_JPRB, 0.26154282E-09_JPRB, 0.26172198E-09_JPRB, 0.26190278E-09_JPRB, 0.26208083E-09_JPRB, &
  & 0.26225006E-09_JPRB, 0.26240066E-09_JPRB, 0.26252189E-09_JPRB, 0.26260613E-09_JPRB, 0.26265312E-09_JPRB, 0.26266628E-09_JPRB, &
  & 0.26264901E-09_JPRB, 0.26260394E-09_JPRB, 0.26253408E-09_JPRB, 0.26244543E-09_JPRB, 0.26234609E-09_JPRB, 0.26224645E-09_JPRB, &
  & 0.26215316E-09_JPRB, 0.26207084E-09_JPRB, 0.26200100E-09_JPRB, 0.26194369E-09_JPRB, 0.26189667E-09_JPRB, 0.26185817E-09_JPRB, &
  & 0.26182584E-09_JPRB, 0.26179814E-09_JPRB, 0.26177333E-09_JPRB, 0.26174934E-09_JPRB, 0.26172375E-09_JPRB, 0.26169392E-09_JPRB, &
  & 0.26165803E-09_JPRB, 0.26161617E-09_JPRB, 0.26156982E-09_JPRB, 0.26152219E-09_JPRB, 0.26147609E-09_JPRB, 0.26143196E-09_JPRB, &
  & 0.26138797E-09_JPRB, 0.26134020E-09_JPRB, 0.26127156E-09_JPRB, 0.26113828E-09_JPRB /)

RGHG5(:,67, 7) = (/ &
  & 0.26108959E-09_JPRB, 0.26115082E-09_JPRB, 0.26118444E-09_JPRB, 0.26121172E-09_JPRB, 0.26123742E-09_JPRB, 0.26126196E-09_JPRB, &
  & 0.26128591E-09_JPRB, 0.26131186E-09_JPRB, 0.26133873E-09_JPRB, 0.26137156E-09_JPRB, 0.26140687E-09_JPRB, 0.26144872E-09_JPRB, &
  & 0.26149127E-09_JPRB, 0.26153071E-09_JPRB, 0.26156055E-09_JPRB, 0.26157360E-09_JPRB, 0.26156327E-09_JPRB, 0.26152516E-09_JPRB, &
  & 0.26146116E-09_JPRB, 0.26138036E-09_JPRB, 0.26129868E-09_JPRB, 0.26123931E-09_JPRB, 0.26122698E-09_JPRB, 0.26127567E-09_JPRB, &
  & 0.26137914E-09_JPRB, 0.26151986E-09_JPRB, 0.26168079E-09_JPRB, 0.26184949E-09_JPRB, 0.26201871E-09_JPRB, 0.26218427E-09_JPRB, &
  & 0.26233982E-09_JPRB, 0.26247651E-09_JPRB, 0.26258540E-09_JPRB, 0.26266062E-09_JPRB, 0.26270225E-09_JPRB, 0.26271391E-09_JPRB, &
  & 0.26269836E-09_JPRB, 0.26265806E-09_JPRB, 0.26259592E-09_JPRB, 0.26251676E-09_JPRB, 0.26242852E-09_JPRB, 0.26233898E-09_JPRB, &
  & 0.26225525E-09_JPRB, 0.26218058E-09_JPRB, 0.26211672E-09_JPRB, 0.26206373E-09_JPRB, 0.26201979E-09_JPRB, 0.26198368E-09_JPRB, &
  & 0.26195315E-09_JPRB, 0.26192704E-09_JPRB, 0.26190350E-09_JPRB, 0.26188074E-09_JPRB, 0.26185615E-09_JPRB, 0.26182717E-09_JPRB, &
  & 0.26179164E-09_JPRB, 0.26174965E-09_JPRB, 0.26170272E-09_JPRB, 0.26165400E-09_JPRB, 0.26160668E-09_JPRB, 0.26156130E-09_JPRB, &
  & 0.26151620E-09_JPRB, 0.26146788E-09_JPRB, 0.26139685E-09_JPRB, 0.26125407E-09_JPRB /)

RGHG5(:,68, 7) = (/ &
  & 0.26119779E-09_JPRB, 0.26127472E-09_JPRB, 0.26131461E-09_JPRB, 0.26134753E-09_JPRB, 0.26137659E-09_JPRB, 0.26140379E-09_JPRB, &
  & 0.26143010E-09_JPRB, 0.26145713E-09_JPRB, 0.26148841E-09_JPRB, 0.26152236E-09_JPRB, 0.26156274E-09_JPRB, 0.26160468E-09_JPRB, &
  & 0.26164759E-09_JPRB, 0.26168595E-09_JPRB, 0.26171487E-09_JPRB, 0.26172731E-09_JPRB, 0.26171731E-09_JPRB, 0.26168068E-09_JPRB, &
  & 0.26161928E-09_JPRB, 0.26154190E-09_JPRB, 0.26146427E-09_JPRB, 0.26140787E-09_JPRB, 0.26139513E-09_JPRB, 0.26143948E-09_JPRB, &
  & 0.26153466E-09_JPRB, 0.26166497E-09_JPRB, 0.26181460E-09_JPRB, 0.26197122E-09_JPRB, 0.26212801E-09_JPRB, 0.26227998E-09_JPRB, &
  & 0.26242147E-09_JPRB, 0.26254457E-09_JPRB, 0.26264174E-09_JPRB, 0.26270855E-09_JPRB, 0.26274541E-09_JPRB, 0.26275560E-09_JPRB, &
  & 0.26274180E-09_JPRB, 0.26270616E-09_JPRB, 0.26265121E-09_JPRB, 0.26258151E-09_JPRB, 0.26250319E-09_JPRB, 0.26242419E-09_JPRB, &
  & 0.26234950E-09_JPRB, 0.26228289E-09_JPRB, 0.26222524E-09_JPRB, 0.26217695E-09_JPRB, 0.26213690E-09_JPRB, 0.26210362E-09_JPRB, &
  & 0.26207558E-09_JPRB, 0.26205146E-09_JPRB, 0.26202968E-09_JPRB, 0.26200850E-09_JPRB, 0.26198538E-09_JPRB, 0.26195768E-09_JPRB, &
  & 0.26192326E-09_JPRB, 0.26188193E-09_JPRB, 0.26183547E-09_JPRB, 0.26178687E-09_JPRB, 0.26173944E-09_JPRB, 0.26169417E-09_JPRB, &
  & 0.26164931E-09_JPRB, 0.26160227E-09_JPRB, 0.26153224E-09_JPRB, 0.26138949E-09_JPRB /)

RGHG5(:,69, 7) = (/ &
  & 0.26129723E-09_JPRB, 0.26139335E-09_JPRB, 0.26144395E-09_JPRB, 0.26148220E-09_JPRB, 0.26151600E-09_JPRB, 0.26154590E-09_JPRB, &
  & 0.26157426E-09_JPRB, 0.26160368E-09_JPRB, 0.26163632E-09_JPRB, 0.26167313E-09_JPRB, 0.26171304E-09_JPRB, 0.26175512E-09_JPRB, &
  & 0.26179647E-09_JPRB, 0.26183344E-09_JPRB, 0.26186128E-09_JPRB, 0.26187325E-09_JPRB, 0.26186397E-09_JPRB, 0.26182972E-09_JPRB, &
  & 0.26177249E-09_JPRB, 0.26170047E-09_JPRB, 0.26162783E-09_JPRB, 0.26157471E-09_JPRB, 0.26156169E-09_JPRB, 0.26160077E-09_JPRB, &
  & 0.26168714E-09_JPRB, 0.26180630E-09_JPRB, 0.26194341E-09_JPRB, 0.26208727E-09_JPRB, 0.26223043E-09_JPRB, 0.26236854E-09_JPRB, &
  & 0.26249597E-09_JPRB, 0.26260591E-09_JPRB, 0.26269192E-09_JPRB, 0.26275099E-09_JPRB, 0.26278335E-09_JPRB, 0.26279234E-09_JPRB, &
  & 0.26278033E-09_JPRB, 0.26274902E-09_JPRB, 0.26270100E-09_JPRB, 0.26263977E-09_JPRB, 0.26257135E-09_JPRB, 0.26250191E-09_JPRB, &
  & 0.26243652E-09_JPRB, 0.26237784E-09_JPRB, 0.26232663E-09_JPRB, 0.26228364E-09_JPRB, 0.26224753E-09_JPRB, 0.26221780E-09_JPRB, &
  & 0.26219260E-09_JPRB, 0.26217103E-09_JPRB, 0.26215141E-09_JPRB, 0.26213223E-09_JPRB, 0.26211094E-09_JPRB, 0.26208516E-09_JPRB, &
  & 0.26205260E-09_JPRB, 0.26201280E-09_JPRB, 0.26196775E-09_JPRB, 0.26192054E-09_JPRB, 0.26187452E-09_JPRB, 0.26183081E-09_JPRB, &
  & 0.26178754E-09_JPRB, 0.26174257E-09_JPRB, 0.26167546E-09_JPRB, 0.26153238E-09_JPRB /)

RGHG5(:,70, 7) = (/ &
  & 0.26138941E-09_JPRB, 0.26151400E-09_JPRB, 0.26157404E-09_JPRB, 0.26161973E-09_JPRB, 0.26165708E-09_JPRB, 0.26168936E-09_JPRB, &
  & 0.26171953E-09_JPRB, 0.26175076E-09_JPRB, 0.26178407E-09_JPRB, 0.26182112E-09_JPRB, 0.26185951E-09_JPRB, 0.26189992E-09_JPRB, &
  & 0.26193914E-09_JPRB, 0.26197414E-09_JPRB, 0.26200062E-09_JPRB, 0.26201208E-09_JPRB, 0.26200409E-09_JPRB, 0.26197280E-09_JPRB, &
  & 0.26192057E-09_JPRB, 0.26185470E-09_JPRB, 0.26178831E-09_JPRB, 0.26173924E-09_JPRB, 0.26172589E-09_JPRB, 0.26175931E-09_JPRB, &
  & 0.26183608E-09_JPRB, 0.26194319E-09_JPRB, 0.26206742E-09_JPRB, 0.26219735E-09_JPRB, 0.26232666E-09_JPRB, 0.26245056E-09_JPRB, &
  & 0.26256422E-09_JPRB, 0.26266148E-09_JPRB, 0.26273700E-09_JPRB, 0.26278871E-09_JPRB, 0.26281699E-09_JPRB, 0.26282485E-09_JPRB, &
  & 0.26281449E-09_JPRB, 0.26278740E-09_JPRB, 0.26274583E-09_JPRB, 0.26269265E-09_JPRB, 0.26263328E-09_JPRB, 0.26257285E-09_JPRB, &
  & 0.26251665E-09_JPRB, 0.26246555E-09_JPRB, 0.26242125E-09_JPRB, 0.26238337E-09_JPRB, 0.26235170E-09_JPRB, 0.26232552E-09_JPRB, &
  & 0.26230373E-09_JPRB, 0.26228486E-09_JPRB, 0.26226774E-09_JPRB, 0.26225094E-09_JPRB, 0.26223199E-09_JPRB, 0.26220856E-09_JPRB, &
  & 0.26217856E-09_JPRB, 0.26214131E-09_JPRB, 0.26209884E-09_JPRB, 0.26205446E-09_JPRB, 0.26201125E-09_JPRB, 0.26197058E-09_JPRB, &
  & 0.26193003E-09_JPRB, 0.26188859E-09_JPRB, 0.26182626E-09_JPRB, 0.26169233E-09_JPRB /)

RGHG5(:,71, 7) = (/ &
  & 0.26148611E-09_JPRB, 0.26163810E-09_JPRB, 0.26171110E-09_JPRB, 0.26176175E-09_JPRB, 0.26180150E-09_JPRB, 0.26183616E-09_JPRB, &
  & 0.26186714E-09_JPRB, 0.26189859E-09_JPRB, 0.26193292E-09_JPRB, 0.26196598E-09_JPRB, 0.26200392E-09_JPRB, 0.26204033E-09_JPRB, &
  & 0.26207719E-09_JPRB, 0.26210953E-09_JPRB, 0.26213406E-09_JPRB, 0.26214467E-09_JPRB, 0.26213809E-09_JPRB, 0.26211008E-09_JPRB, &
  & 0.26206362E-09_JPRB, 0.26200497E-09_JPRB, 0.26194519E-09_JPRB, 0.26190045E-09_JPRB, 0.26188676E-09_JPRB, 0.26191443E-09_JPRB, &
  & 0.26198094E-09_JPRB, 0.26207583E-09_JPRB, 0.26218605E-09_JPRB, 0.26230207E-09_JPRB, 0.26241703E-09_JPRB, 0.26252667E-09_JPRB, &
  & 0.26262703E-09_JPRB, 0.26271196E-09_JPRB, 0.26277752E-09_JPRB, 0.26282229E-09_JPRB, 0.26284672E-09_JPRB, 0.26285368E-09_JPRB, &
  & 0.26284483E-09_JPRB, 0.26282165E-09_JPRB, 0.26278607E-09_JPRB, 0.26274058E-09_JPRB, 0.26268940E-09_JPRB, 0.26263813E-09_JPRB, &
  & 0.26258970E-09_JPRB, 0.26254671E-09_JPRB, 0.26250849E-09_JPRB, 0.26247610E-09_JPRB, 0.26244867E-09_JPRB, 0.26242639E-09_JPRB, &
  & 0.26240785E-09_JPRB, 0.26239189E-09_JPRB, 0.26237740E-09_JPRB, 0.26236308E-09_JPRB, 0.26234684E-09_JPRB, 0.26232633E-09_JPRB, &
  & 0.26229957E-09_JPRB, 0.26226585E-09_JPRB, 0.26222696E-09_JPRB, 0.26218652E-09_JPRB, 0.26214769E-09_JPRB, 0.26211075E-09_JPRB, &
  & 0.26207453E-09_JPRB, 0.26203656E-09_JPRB, 0.26198199E-09_JPRB, 0.26186150E-09_JPRB /)

RGHG5(:,72, 7) = (/ &
  & 0.26158925E-09_JPRB, 0.26177452E-09_JPRB, 0.26185626E-09_JPRB, 0.26190994E-09_JPRB, 0.26195274E-09_JPRB, 0.26198649E-09_JPRB, &
  & 0.26201830E-09_JPRB, 0.26205030E-09_JPRB, 0.26207961E-09_JPRB, 0.26211427E-09_JPRB, 0.26214406E-09_JPRB, 0.26217981E-09_JPRB, &
  & 0.26221145E-09_JPRB, 0.26224078E-09_JPRB, 0.26226285E-09_JPRB, 0.26227218E-09_JPRB, 0.26226660E-09_JPRB, 0.26224178E-09_JPRB, &
  & 0.26220104E-09_JPRB, 0.26214939E-09_JPRB, 0.26209693E-09_JPRB, 0.26205682E-09_JPRB, 0.26204350E-09_JPRB, 0.26206545E-09_JPRB, &
  & 0.26212171E-09_JPRB, 0.26220345E-09_JPRB, 0.26230004E-09_JPRB, 0.26240146E-09_JPRB, 0.26250219E-09_JPRB, 0.26259753E-09_JPRB, &
  & 0.26268482E-09_JPRB, 0.26275801E-09_JPRB, 0.26281405E-09_JPRB, 0.26285235E-09_JPRB, 0.26287311E-09_JPRB, 0.26287916E-09_JPRB, &
  & 0.26287181E-09_JPRB, 0.26285235E-09_JPRB, 0.26282237E-09_JPRB, 0.26278374E-09_JPRB, 0.26274072E-09_JPRB, 0.26269700E-09_JPRB, &
  & 0.26265709E-09_JPRB, 0.26262048E-09_JPRB, 0.26258876E-09_JPRB, 0.26256131E-09_JPRB, 0.26253824E-09_JPRB, 0.26251970E-09_JPRB, &
  & 0.26250443E-09_JPRB, 0.26249114E-09_JPRB, 0.26247915E-09_JPRB, 0.26246735E-09_JPRB, 0.26245381E-09_JPRB, 0.26243663E-09_JPRB, &
  & 0.26241365E-09_JPRB, 0.26238392E-09_JPRB, 0.26234973E-09_JPRB, 0.26231423E-09_JPRB, 0.26228028E-09_JPRB, 0.26224839E-09_JPRB, &
  & 0.26221611E-09_JPRB, 0.26218264E-09_JPRB, 0.26213420E-09_JPRB, 0.26202746E-09_JPRB /)

RGHG5(:,73, 7) = (/ &
  & 0.26173255E-09_JPRB, 0.26192834E-09_JPRB, 0.26201127E-09_JPRB, 0.26206673E-09_JPRB, 0.26210667E-09_JPRB, 0.26214148E-09_JPRB, &
  & 0.26217206E-09_JPRB, 0.26220009E-09_JPRB, 0.26223146E-09_JPRB, 0.26225555E-09_JPRB, 0.26228839E-09_JPRB, 0.26231403E-09_JPRB, &
  & 0.26234390E-09_JPRB, 0.26236804E-09_JPRB, 0.26238700E-09_JPRB, 0.26239411E-09_JPRB, 0.26238955E-09_JPRB, 0.26236688E-09_JPRB, &
  & 0.26233191E-09_JPRB, 0.26228769E-09_JPRB, 0.26224209E-09_JPRB, 0.26220731E-09_JPRB, 0.26219435E-09_JPRB, 0.26221122E-09_JPRB, &
  & 0.26225724E-09_JPRB, 0.26232647E-09_JPRB, 0.26240862E-09_JPRB, 0.26249583E-09_JPRB, 0.26258212E-09_JPRB, 0.26266353E-09_JPRB, &
  & 0.26273808E-09_JPRB, 0.26280000E-09_JPRB, 0.26284705E-09_JPRB, 0.26287919E-09_JPRB, 0.26289657E-09_JPRB, 0.26290164E-09_JPRB, &
  & 0.26289568E-09_JPRB, 0.26287961E-09_JPRB, 0.26285488E-09_JPRB, 0.26282293E-09_JPRB, 0.26278704E-09_JPRB, 0.26275096E-09_JPRB, &
  & 0.26271774E-09_JPRB, 0.26268793E-09_JPRB, 0.26266159E-09_JPRB, 0.26263902E-09_JPRB, 0.26261998E-09_JPRB, 0.26260508E-09_JPRB, &
  & 0.26259281E-09_JPRB, 0.26258207E-09_JPRB, 0.26257246E-09_JPRB, 0.26256303E-09_JPRB, 0.26255215E-09_JPRB, 0.26253827E-09_JPRB, &
  & 0.26251901E-09_JPRB, 0.26249397E-09_JPRB, 0.26246447E-09_JPRB, 0.26243449E-09_JPRB, 0.26240593E-09_JPRB, 0.26237862E-09_JPRB, &
  & 0.26235125E-09_JPRB, 0.26232150E-09_JPRB, 0.26227928E-09_JPRB, 0.26218544E-09_JPRB /)

RGHG5(:,74, 7) = (/ &
  & 0.26189123E-09_JPRB, 0.26209074E-09_JPRB, 0.26217303E-09_JPRB, 0.26222333E-09_JPRB, 0.26226304E-09_JPRB, 0.26229446E-09_JPRB, &
  & 0.26232244E-09_JPRB, 0.26235075E-09_JPRB, 0.26237315E-09_JPRB, 0.26240116E-09_JPRB, 0.26242103E-09_JPRB, 0.26244842E-09_JPRB, &
  & 0.26246927E-09_JPRB, 0.26248972E-09_JPRB, 0.26250491E-09_JPRB, 0.26250935E-09_JPRB, 0.26250505E-09_JPRB, 0.26248517E-09_JPRB, &
  & 0.26245534E-09_JPRB, 0.26241792E-09_JPRB, 0.26237970E-09_JPRB, 0.26235000E-09_JPRB, 0.26233804E-09_JPRB, 0.26235036E-09_JPRB, &
  & 0.26238711E-09_JPRB, 0.26244384E-09_JPRB, 0.26251210E-09_JPRB, 0.26258498E-09_JPRB, 0.26265712E-09_JPRB, 0.26272509E-09_JPRB, &
  & 0.26278696E-09_JPRB, 0.26283822E-09_JPRB, 0.26287697E-09_JPRB, 0.26290325E-09_JPRB, 0.26291733E-09_JPRB, 0.26292155E-09_JPRB, &
  & 0.26291677E-09_JPRB, 0.26290392E-09_JPRB, 0.26288410E-09_JPRB, 0.26285812E-09_JPRB, 0.26282893E-09_JPRB, 0.26279942E-09_JPRB, &
  & 0.26277291E-09_JPRB, 0.26274871E-09_JPRB, 0.26272762E-09_JPRB, 0.26270947E-09_JPRB, 0.26269420E-09_JPRB, 0.26268265E-09_JPRB, &
  & 0.26267319E-09_JPRB, 0.26266461E-09_JPRB, 0.26265726E-09_JPRB, 0.26264993E-09_JPRB, 0.26264155E-09_JPRB, 0.26263083E-09_JPRB, &
  & 0.26261546E-09_JPRB, 0.26259461E-09_JPRB, 0.26257030E-09_JPRB, 0.26254543E-09_JPRB, 0.26252209E-09_JPRB, 0.26249936E-09_JPRB, &
  & 0.26247637E-09_JPRB, 0.26245081E-09_JPRB, 0.26241476E-09_JPRB, 0.26233071E-09_JPRB /)

RGHG5(:,75, 7) = (/ &
  & 0.26206018E-09_JPRB, 0.26225677E-09_JPRB, 0.26233130E-09_JPRB, 0.26237809E-09_JPRB, 0.26241218E-09_JPRB, 0.26244096E-09_JPRB, &
  & 0.26246644E-09_JPRB, 0.26248878E-09_JPRB, 0.26251301E-09_JPRB, 0.26252958E-09_JPRB, 0.26255315E-09_JPRB, 0.26256902E-09_JPRB, &
  & 0.26258815E-09_JPRB, 0.26260219E-09_JPRB, 0.26261407E-09_JPRB, 0.26261654E-09_JPRB, 0.26261218E-09_JPRB, 0.26259525E-09_JPRB, &
  & 0.26257060E-09_JPRB, 0.26254035E-09_JPRB, 0.26250888E-09_JPRB, 0.26248451E-09_JPRB, 0.26247371E-09_JPRB, 0.26248234E-09_JPRB, &
  & 0.26251054E-09_JPRB, 0.26255570E-09_JPRB, 0.26261027E-09_JPRB, 0.26266911E-09_JPRB, 0.26272748E-09_JPRB, 0.26278235E-09_JPRB, &
  & 0.26283198E-09_JPRB, 0.26287311E-09_JPRB, 0.26290392E-09_JPRB, 0.26292488E-09_JPRB, 0.26293581E-09_JPRB, 0.26293917E-09_JPRB, &
  & 0.26293537E-09_JPRB, 0.26292540E-09_JPRB, 0.26291008E-09_JPRB, 0.26288971E-09_JPRB, 0.26286681E-09_JPRB, 0.26284333E-09_JPRB, &
  & 0.26282287E-09_JPRB, 0.26280383E-09_JPRB, 0.26278738E-09_JPRB, 0.26277330E-09_JPRB, 0.26276142E-09_JPRB, 0.26275301E-09_JPRB, &
  & 0.26274594E-09_JPRB, 0.26273941E-09_JPRB, 0.26273411E-09_JPRB, 0.26272867E-09_JPRB, 0.26272240E-09_JPRB, 0.26271463E-09_JPRB, &
  & 0.26270278E-09_JPRB, 0.26268629E-09_JPRB, 0.26266656E-09_JPRB, 0.26264677E-09_JPRB, 0.26262795E-09_JPRB, 0.26260982E-09_JPRB, &
  & 0.26259078E-09_JPRB, 0.26256997E-09_JPRB, 0.26253819E-09_JPRB, 0.26246499E-09_JPRB /)

RGHG5(:,76, 7) = (/ &
  & 0.26223687E-09_JPRB, 0.26241970E-09_JPRB, 0.26248528E-09_JPRB, 0.26252359E-09_JPRB, 0.26255298E-09_JPRB, 0.26257657E-09_JPRB, &
  & 0.26259755E-09_JPRB, 0.26261859E-09_JPRB, 0.26263447E-09_JPRB, 0.26265271E-09_JPRB, 0.26266544E-09_JPRB, 0.26268185E-09_JPRB, &
  & 0.26269359E-09_JPRB, 0.26270414E-09_JPRB, 0.26271246E-09_JPRB, 0.26271402E-09_JPRB, 0.26271019E-09_JPRB, 0.26269642E-09_JPRB, &
  & 0.26267721E-09_JPRB, 0.26265370E-09_JPRB, 0.26262906E-09_JPRB, 0.26260988E-09_JPRB, 0.26260064E-09_JPRB, 0.26260649E-09_JPRB, &
  & 0.26262723E-09_JPRB, 0.26266173E-09_JPRB, 0.26270305E-09_JPRB, 0.26274841E-09_JPRB, 0.26279320E-09_JPRB, 0.26283514E-09_JPRB, &
  & 0.26287350E-09_JPRB, 0.26290486E-09_JPRB, 0.26292843E-09_JPRB, 0.26294428E-09_JPRB, 0.26295224E-09_JPRB, 0.26295480E-09_JPRB, &
  & 0.26295183E-09_JPRB, 0.26294456E-09_JPRB, 0.26293340E-09_JPRB, 0.26291808E-09_JPRB, 0.26290084E-09_JPRB, 0.26288294E-09_JPRB, &
  & 0.26286801E-09_JPRB, 0.26285368E-09_JPRB, 0.26284147E-09_JPRB, 0.26283101E-09_JPRB, 0.26282226E-09_JPRB, 0.26281660E-09_JPRB, &
  & 0.26281172E-09_JPRB, 0.26280705E-09_JPRB, 0.26280361E-09_JPRB, 0.26279962E-09_JPRB, 0.26279509E-09_JPRB, 0.26278979E-09_JPRB, &
  & 0.26278127E-09_JPRB, 0.26276900E-09_JPRB, 0.26275376E-09_JPRB, 0.26273853E-09_JPRB, 0.26272459E-09_JPRB, 0.26271005E-09_JPRB, &
  & 0.26269584E-09_JPRB, 0.26267868E-09_JPRB, 0.26265326E-09_JPRB, 0.26258568E-09_JPRB /)

RGHG5(:,77, 7) = (/ &
  & 0.26241748E-09_JPRB, 0.26257754E-09_JPRB, 0.26263020E-09_JPRB, 0.26265973E-09_JPRB, 0.26268177E-09_JPRB, 0.26270022E-09_JPRB, &
  & 0.26271602E-09_JPRB, 0.26273134E-09_JPRB, 0.26274527E-09_JPRB, 0.26275476E-09_JPRB, 0.26276784E-09_JPRB, 0.26277683E-09_JPRB, &
  & 0.26278624E-09_JPRB, 0.26279304E-09_JPRB, 0.26279878E-09_JPRB, 0.26280003E-09_JPRB, 0.26279723E-09_JPRB, 0.26278651E-09_JPRB, &
  & 0.26277278E-09_JPRB, 0.26275615E-09_JPRB, 0.26273805E-09_JPRB, 0.26272423E-09_JPRB, 0.26271707E-09_JPRB, 0.26272112E-09_JPRB, &
  & 0.26273553E-09_JPRB, 0.26276034E-09_JPRB, 0.26278946E-09_JPRB, 0.26282182E-09_JPRB, 0.26285360E-09_JPRB, 0.26288344E-09_JPRB, &
  & 0.26291097E-09_JPRB, 0.26293362E-09_JPRB, 0.26295036E-09_JPRB, 0.26296165E-09_JPRB, 0.26296676E-09_JPRB, 0.26296842E-09_JPRB, &
  & 0.26296612E-09_JPRB, 0.26296126E-09_JPRB, 0.26295396E-09_JPRB, 0.26294339E-09_JPRB, 0.26293134E-09_JPRB, 0.26291830E-09_JPRB, &
  & 0.26290850E-09_JPRB, 0.26289823E-09_JPRB, 0.26288971E-09_JPRB, 0.26288255E-09_JPRB, 0.26287650E-09_JPRB, 0.26287339E-09_JPRB, &
  & 0.26287023E-09_JPRB, 0.26286728E-09_JPRB, 0.26286537E-09_JPRB, 0.26286245E-09_JPRB, 0.26285890E-09_JPRB, 0.26285571E-09_JPRB, &
  & 0.26285027E-09_JPRB, 0.26284197E-09_JPRB, 0.26283115E-09_JPRB, 0.26282068E-09_JPRB, 0.26281111E-09_JPRB, 0.26280109E-09_JPRB, &
  & 0.26279054E-09_JPRB, 0.26277849E-09_JPRB, 0.26275715E-09_JPRB, 0.26269897E-09_JPRB /)

RGHG5(:,78, 7) = (/ &
  & 0.26259950E-09_JPRB, 0.26272212E-09_JPRB, 0.26275676E-09_JPRB, 0.26277669E-09_JPRB, 0.26279212E-09_JPRB, 0.26280417E-09_JPRB, &
  & 0.26281460E-09_JPRB, 0.26282537E-09_JPRB, 0.26283306E-09_JPRB, 0.26283944E-09_JPRB, 0.26284702E-09_JPRB, 0.26285427E-09_JPRB, &
  & 0.26286009E-09_JPRB, 0.26286470E-09_JPRB, 0.26286856E-09_JPRB, 0.26286984E-09_JPRB, 0.26286820E-09_JPRB, 0.26286034E-09_JPRB, &
  & 0.26285141E-09_JPRB, 0.26284114E-09_JPRB, 0.26282904E-09_JPRB, 0.26282043E-09_JPRB, 0.26281580E-09_JPRB, 0.26281916E-09_JPRB, &
  & 0.26282868E-09_JPRB, 0.26284586E-09_JPRB, 0.26286442E-09_JPRB, 0.26288532E-09_JPRB, 0.26290564E-09_JPRB, 0.26292463E-09_JPRB, &
  & 0.26294295E-09_JPRB, 0.26295799E-09_JPRB, 0.26296895E-09_JPRB, 0.26297625E-09_JPRB, 0.26297886E-09_JPRB, 0.26297983E-09_JPRB, &
  & 0.26297806E-09_JPRB, 0.26297525E-09_JPRB, 0.26297117E-09_JPRB, 0.26296448E-09_JPRB, 0.26295682E-09_JPRB, 0.26294802E-09_JPRB, &
  & 0.26294250E-09_JPRB, 0.26293573E-09_JPRB, 0.26293021E-09_JPRB, 0.26292568E-09_JPRB, 0.26292171E-09_JPRB, 0.26292055E-09_JPRB, &
  & 0.26291866E-09_JPRB, 0.26291685E-09_JPRB, 0.26291630E-09_JPRB, 0.26291391E-09_JPRB, 0.26291097E-09_JPRB, 0.26290925E-09_JPRB, &
  & 0.26290614E-09_JPRB, 0.26290151E-09_JPRB, 0.26289457E-09_JPRB, 0.26288849E-09_JPRB, 0.26288377E-09_JPRB, 0.26287703E-09_JPRB, &
  & 0.26287084E-09_JPRB, 0.26286268E-09_JPRB, 0.26284913E-09_JPRB, 0.26280284E-09_JPRB /)

RGHG5(:,79, 7) = (/ &
  & 0.26271837E-09_JPRB, 0.26280375E-09_JPRB, 0.26282462E-09_JPRB, 0.26283764E-09_JPRB, 0.26284944E-09_JPRB, 0.26285871E-09_JPRB, &
  & 0.26286551E-09_JPRB, 0.26287442E-09_JPRB, 0.26287925E-09_JPRB, 0.26288274E-09_JPRB, 0.26288913E-09_JPRB, 0.26289446E-09_JPRB, &
  & 0.26289876E-09_JPRB, 0.26290201E-09_JPRB, 0.26290478E-09_JPRB, 0.26290614E-09_JPRB, 0.26290525E-09_JPRB, 0.26289873E-09_JPRB, &
  & 0.26289257E-09_JPRB, 0.26288571E-09_JPRB, 0.26287689E-09_JPRB, 0.26287122E-09_JPRB, 0.26286792E-09_JPRB, 0.26287128E-09_JPRB, &
  & 0.26287844E-09_JPRB, 0.26289176E-09_JPRB, 0.26290475E-09_JPRB, 0.26291955E-09_JPRB, 0.26293373E-09_JPRB, 0.26294686E-09_JPRB, &
  & 0.26296035E-09_JPRB, 0.26297139E-09_JPRB, 0.26297919E-09_JPRB, 0.26298433E-09_JPRB, 0.26298541E-09_JPRB, 0.26298602E-09_JPRB, &
  & 0.26298447E-09_JPRB, 0.26298286E-09_JPRB, 0.26298050E-09_JPRB, 0.26297592E-09_JPRB, 0.26297056E-09_JPRB, 0.26296385E-09_JPRB, &
  & 0.26296076E-09_JPRB, 0.26295555E-09_JPRB, 0.26295160E-09_JPRB, 0.26294833E-09_JPRB, 0.26294530E-09_JPRB, 0.26294522E-09_JPRB, &
  & 0.26294394E-09_JPRB, 0.26294264E-09_JPRB, 0.26294270E-09_JPRB, 0.26294050E-09_JPRB, 0.26293762E-09_JPRB, 0.26293678E-09_JPRB, &
  & 0.26293501E-09_JPRB, 0.26293218E-09_JPRB, 0.26292707E-09_JPRB, 0.26292321E-09_JPRB, 0.26292091E-09_JPRB, 0.26291594E-09_JPRB, &
  & 0.26291169E-09_JPRB, 0.26290697E-09_JPRB, 0.26289923E-09_JPRB, 0.26286862E-09_JPRB /)

RGHG5(:,80, 7) = (/ &
  & 0.26279784E-09_JPRB, 0.26284358E-09_JPRB, 0.26285418E-09_JPRB, 0.26286401E-09_JPRB, 0.26287417E-09_JPRB, 0.26288205E-09_JPRB, &
  & 0.26288821E-09_JPRB, 0.26289512E-09_JPRB, 0.26289987E-09_JPRB, 0.26290159E-09_JPRB, 0.26290836E-09_JPRB, 0.26291228E-09_JPRB, &
  & 0.26291608E-09_JPRB, 0.26291858E-09_JPRB, 0.26292077E-09_JPRB, 0.26292232E-09_JPRB, 0.26292191E-09_JPRB, 0.26291594E-09_JPRB, &
  & 0.26291105E-09_JPRB, 0.26290603E-09_JPRB, 0.26289851E-09_JPRB, 0.26289421E-09_JPRB, 0.26289143E-09_JPRB, 0.26289482E-09_JPRB, &
  & 0.26290092E-09_JPRB, 0.26291266E-09_JPRB, 0.26292313E-09_JPRB, 0.26293517E-09_JPRB, 0.26294653E-09_JPRB, 0.26295693E-09_JPRB, &
  & 0.26296831E-09_JPRB, 0.26297764E-09_JPRB, 0.26298402E-09_JPRB, 0.26298813E-09_JPRB, 0.26298841E-09_JPRB, 0.26298883E-09_JPRB, &
  & 0.26298735E-09_JPRB, 0.26298624E-09_JPRB, 0.26298480E-09_JPRB, 0.26298116E-09_JPRB, 0.26297681E-09_JPRB, 0.26297098E-09_JPRB, &
  & 0.26296895E-09_JPRB, 0.26296443E-09_JPRB, 0.26296101E-09_JPRB, 0.26295829E-09_JPRB, 0.26295569E-09_JPRB, 0.26295618E-09_JPRB, &
  & 0.26295513E-09_JPRB, 0.26295402E-09_JPRB, 0.26295444E-09_JPRB, 0.26295219E-09_JPRB, 0.26294927E-09_JPRB, 0.26294894E-09_JPRB, &
  & 0.26294775E-09_JPRB, 0.26294578E-09_JPRB, 0.26294111E-09_JPRB, 0.26293806E-09_JPRB, 0.26293695E-09_JPRB, 0.26293243E-09_JPRB, &
  & 0.26292934E-09_JPRB, 0.26292613E-09_JPRB, 0.26292341E-09_JPRB, 0.26291130E-09_JPRB /)

RGHG5(:,81, 7) = (/ &
  & 0.26285274E-09_JPRB, 0.26286051E-09_JPRB, 0.26286665E-09_JPRB, 0.26287506E-09_JPRB, 0.26288463E-09_JPRB, 0.26289232E-09_JPRB, &
  & 0.26289709E-09_JPRB, 0.26290556E-09_JPRB, 0.26290814E-09_JPRB, 0.26291114E-09_JPRB, 0.26291549E-09_JPRB, 0.26292049E-09_JPRB, &
  & 0.26292352E-09_JPRB, 0.26292582E-09_JPRB, 0.26292779E-09_JPRB, 0.26292943E-09_JPRB, 0.26292929E-09_JPRB, 0.26292357E-09_JPRB, &
  & 0.26291938E-09_JPRB, 0.26291522E-09_JPRB, 0.26290822E-09_JPRB, 0.26290453E-09_JPRB, 0.26290178E-09_JPRB, 0.26290525E-09_JPRB, &
  & 0.26291089E-09_JPRB, 0.26292205E-09_JPRB, 0.26293137E-09_JPRB, 0.26294208E-09_JPRB, 0.26295222E-09_JPRB, 0.26296143E-09_JPRB, &
  & 0.26297187E-09_JPRB, 0.26298047E-09_JPRB, 0.26298622E-09_JPRB, 0.26298994E-09_JPRB, 0.26298974E-09_JPRB, 0.26299005E-09_JPRB, &
  & 0.26298852E-09_JPRB, 0.26298774E-09_JPRB, 0.26298669E-09_JPRB, 0.26298347E-09_JPRB, 0.26297947E-09_JPRB, 0.26297409E-09_JPRB, &
  & 0.26297253E-09_JPRB, 0.26296826E-09_JPRB, 0.26296507E-09_JPRB, 0.26296260E-09_JPRB, 0.26296015E-09_JPRB, 0.26296101E-09_JPRB, &
  & 0.26296004E-09_JPRB, 0.26295896E-09_JPRB, 0.26295960E-09_JPRB, 0.26295732E-09_JPRB, 0.26295432E-09_JPRB, 0.26295430E-09_JPRB, &
  & 0.26295341E-09_JPRB, 0.26295177E-09_JPRB, 0.26294725E-09_JPRB, 0.26294442E-09_JPRB, 0.26294378E-09_JPRB, 0.26293945E-09_JPRB, &
  & 0.26293673E-09_JPRB, 0.26293415E-09_JPRB, 0.26293351E-09_JPRB, 0.26294039E-09_JPRB /)

RGHG5(:,82, 7) = (/ &
  & 0.26285712E-09_JPRB, 0.26286617E-09_JPRB, 0.26287206E-09_JPRB, 0.26288030E-09_JPRB, 0.26288982E-09_JPRB, 0.26289698E-09_JPRB, &
  & 0.26290309E-09_JPRB, 0.26290847E-09_JPRB, 0.26291319E-09_JPRB, 0.26291413E-09_JPRB, 0.26292102E-09_JPRB, 0.26292385E-09_JPRB, &
  & 0.26292732E-09_JPRB, 0.26292934E-09_JPRB, 0.26293118E-09_JPRB, 0.26293293E-09_JPRB, 0.26293301E-09_JPRB, 0.26292729E-09_JPRB, &
  & 0.26292354E-09_JPRB, 0.26291991E-09_JPRB, 0.26291305E-09_JPRB, 0.26290964E-09_JPRB, 0.26290675E-09_JPRB, 0.26291042E-09_JPRB, &
  & 0.26291569E-09_JPRB, 0.26292685E-09_JPRB, 0.26293534E-09_JPRB, 0.26294564E-09_JPRB, 0.26295499E-09_JPRB, 0.26296360E-09_JPRB, &
  & 0.26297359E-09_JPRB, 0.26298183E-09_JPRB, 0.26298733E-09_JPRB, 0.26299082E-09_JPRB, 0.26299046E-09_JPRB, 0.26299066E-09_JPRB, &
  & 0.26298913E-09_JPRB, 0.26298852E-09_JPRB, 0.26298760E-09_JPRB, 0.26298458E-09_JPRB, 0.26298091E-09_JPRB, 0.26297567E-09_JPRB, &
  & 0.26297431E-09_JPRB, 0.26297023E-09_JPRB, 0.26296715E-09_JPRB, 0.26296471E-09_JPRB, 0.26296229E-09_JPRB, 0.26296340E-09_JPRB, &
  & 0.26296243E-09_JPRB, 0.26296140E-09_JPRB, 0.26296215E-09_JPRB, 0.26295985E-09_JPRB, 0.26295677E-09_JPRB, 0.26295696E-09_JPRB, &
  & 0.26295618E-09_JPRB, 0.26295471E-09_JPRB, 0.26295022E-09_JPRB, 0.26294750E-09_JPRB, 0.26294716E-09_JPRB, 0.26294283E-09_JPRB, &
  & 0.26294023E-09_JPRB, 0.26293773E-09_JPRB, 0.26293698E-09_JPRB, 0.26294275E-09_JPRB /)

RGHG5(:,83, 7) = (/ &
  & 0.26286026E-09_JPRB, 0.26286953E-09_JPRB, 0.26287508E-09_JPRB, 0.26288319E-09_JPRB, 0.26289257E-09_JPRB, 0.26290012E-09_JPRB, &
  & 0.26290428E-09_JPRB, 0.26291286E-09_JPRB, 0.26291480E-09_JPRB, 0.26291824E-09_JPRB, 0.26292143E-09_JPRB, 0.26292657E-09_JPRB, &
  & 0.26292918E-09_JPRB, 0.26293126E-09_JPRB, 0.26293309E-09_JPRB, 0.26293484E-09_JPRB, 0.26293503E-09_JPRB, 0.26292937E-09_JPRB, &
  & 0.26292588E-09_JPRB, 0.26292266E-09_JPRB, 0.26291586E-09_JPRB, 0.26291258E-09_JPRB, 0.26290958E-09_JPRB, 0.26291325E-09_JPRB, &
  & 0.26291846E-09_JPRB, 0.26292934E-09_JPRB, 0.26293789E-09_JPRB, 0.26294755E-09_JPRB, 0.26295668E-09_JPRB, 0.26296482E-09_JPRB, &
  & 0.26297461E-09_JPRB, 0.26298266E-09_JPRB, 0.26298802E-09_JPRB, 0.26299138E-09_JPRB, 0.26299085E-09_JPRB, 0.26299099E-09_JPRB, &
  & 0.26298946E-09_JPRB, 0.26298894E-09_JPRB, 0.26298816E-09_JPRB, 0.26298524E-09_JPRB, 0.26298161E-09_JPRB, 0.26297658E-09_JPRB, &
  & 0.26297520E-09_JPRB, 0.26297128E-09_JPRB, 0.26296823E-09_JPRB, 0.26296593E-09_JPRB, 0.26296351E-09_JPRB, 0.26296473E-09_JPRB, &
  & 0.26296379E-09_JPRB, 0.26296279E-09_JPRB, 0.26296362E-09_JPRB, 0.26296135E-09_JPRB, 0.26295816E-09_JPRB, 0.26295849E-09_JPRB, &
  & 0.26295779E-09_JPRB, 0.26295641E-09_JPRB, 0.26295185E-09_JPRB, 0.26294922E-09_JPRB, 0.26294911E-09_JPRB, 0.26294472E-09_JPRB, &
  & 0.26294222E-09_JPRB, 0.26293970E-09_JPRB, 0.26293900E-09_JPRB, 0.26294442E-09_JPRB /)

RGHG5(:,84, 7) = (/ &
  & 0.26286229E-09_JPRB, 0.26287170E-09_JPRB, 0.26287694E-09_JPRB, 0.26288496E-09_JPRB, 0.26289448E-09_JPRB, 0.26290151E-09_JPRB, &
  & 0.26290800E-09_JPRB, 0.26291241E-09_JPRB, 0.26291738E-09_JPRB, 0.26291841E-09_JPRB, 0.26292460E-09_JPRB, 0.26292718E-09_JPRB, &
  & 0.26293043E-09_JPRB, 0.26293240E-09_JPRB, 0.26293415E-09_JPRB, 0.26293595E-09_JPRB, 0.26293620E-09_JPRB, 0.26293073E-09_JPRB, &
  & 0.26292737E-09_JPRB, 0.26292429E-09_JPRB, 0.26291752E-09_JPRB, 0.26291447E-09_JPRB, 0.26291125E-09_JPRB, 0.26291513E-09_JPRB, &
  & 0.26291985E-09_JPRB, 0.26293134E-09_JPRB, 0.26293906E-09_JPRB, 0.26294900E-09_JPRB, 0.26295754E-09_JPRB, 0.26296565E-09_JPRB, &
  & 0.26297520E-09_JPRB, 0.26298316E-09_JPRB, 0.26298841E-09_JPRB, 0.26299174E-09_JPRB, 0.26299110E-09_JPRB, 0.26299116E-09_JPRB, &
  & 0.26298966E-09_JPRB, 0.26298916E-09_JPRB, 0.26298844E-09_JPRB, 0.26298561E-09_JPRB, 0.26298205E-09_JPRB, 0.26297711E-09_JPRB, &
  & 0.26297586E-09_JPRB, 0.26297192E-09_JPRB, 0.26296901E-09_JPRB, 0.26296662E-09_JPRB, 0.26296434E-09_JPRB, 0.26296554E-09_JPRB, &
  & 0.26296459E-09_JPRB, 0.26296362E-09_JPRB, 0.26296454E-09_JPRB, 0.26296226E-09_JPRB, 0.26295899E-09_JPRB, 0.26295932E-09_JPRB, &
  & 0.26295877E-09_JPRB, 0.26295749E-09_JPRB, 0.26295291E-09_JPRB, 0.26295030E-09_JPRB, 0.26295024E-09_JPRB, 0.26294592E-09_JPRB, &
  & 0.26294344E-09_JPRB, 0.26294097E-09_JPRB, 0.26294034E-09_JPRB, 0.26294555E-09_JPRB /)

RGHG5(:,85, 7) = (/ &
  & 0.26286373E-09_JPRB, 0.26287311E-09_JPRB, 0.26287814E-09_JPRB, 0.26288610E-09_JPRB, 0.26289559E-09_JPRB, 0.26290350E-09_JPRB, &
  & 0.26290728E-09_JPRB, 0.26291591E-09_JPRB, 0.26291763E-09_JPRB, 0.26292141E-09_JPRB, 0.26292407E-09_JPRB, 0.26292835E-09_JPRB, &
  & 0.26293084E-09_JPRB, 0.26293290E-09_JPRB, 0.26293467E-09_JPRB, 0.26293634E-09_JPRB, 0.26293662E-09_JPRB, 0.26293168E-09_JPRB, &
  & 0.26292848E-09_JPRB, 0.26292546E-09_JPRB, 0.26291863E-09_JPRB, 0.26291572E-09_JPRB, 0.26291233E-09_JPRB, 0.26291630E-09_JPRB, &
  & 0.26292110E-09_JPRB, 0.26293218E-09_JPRB, 0.26294028E-09_JPRB, 0.26294955E-09_JPRB, 0.26295832E-09_JPRB, 0.26296609E-09_JPRB, &
  & 0.26297567E-09_JPRB, 0.26298350E-09_JPRB, 0.26298874E-09_JPRB, 0.26299199E-09_JPRB, 0.26299127E-09_JPRB, 0.26299132E-09_JPRB, &
  & 0.26298977E-09_JPRB, 0.26298938E-09_JPRB, 0.26298866E-09_JPRB, 0.26298588E-09_JPRB, 0.26298236E-09_JPRB, 0.26297747E-09_JPRB, &
  & 0.26297617E-09_JPRB, 0.26297242E-09_JPRB, 0.26296931E-09_JPRB, 0.26296706E-09_JPRB, 0.26296487E-09_JPRB, 0.26296604E-09_JPRB, &
  & 0.26296512E-09_JPRB, 0.26296421E-09_JPRB, 0.26296515E-09_JPRB, 0.26296290E-09_JPRB, 0.26295957E-09_JPRB, 0.26295999E-09_JPRB, &
  & 0.26295946E-09_JPRB, 0.26295827E-09_JPRB, 0.26295360E-09_JPRB, 0.26295099E-09_JPRB, 0.26295105E-09_JPRB, 0.26294672E-09_JPRB, &
  & 0.26294428E-09_JPRB, 0.26294183E-09_JPRB, 0.26294120E-09_JPRB, 0.26294639E-09_JPRB /)

RGHG5(:,86, 7) = (/ &
  & 0.26286462E-09_JPRB, 0.26287397E-09_JPRB, 0.26287880E-09_JPRB, 0.26288688E-09_JPRB, 0.26289712E-09_JPRB, 0.26290342E-09_JPRB, &
  & 0.26291122E-09_JPRB, 0.26291458E-09_JPRB, 0.26291980E-09_JPRB, 0.26292121E-09_JPRB, 0.26292599E-09_JPRB, 0.26292840E-09_JPRB, &
  & 0.26293112E-09_JPRB, 0.26293306E-09_JPRB, 0.26293479E-09_JPRB, 0.26293623E-09_JPRB, 0.26293642E-09_JPRB, 0.26293248E-09_JPRB, &
  & 0.26292929E-09_JPRB, 0.26292629E-09_JPRB, 0.26291944E-09_JPRB, 0.26291652E-09_JPRB, 0.26291302E-09_JPRB, 0.26291708E-09_JPRB, &
  & 0.26292146E-09_JPRB, 0.26293320E-09_JPRB, 0.26294050E-09_JPRB, 0.26295030E-09_JPRB, 0.26295857E-09_JPRB, 0.26296648E-09_JPRB, &
  & 0.26297603E-09_JPRB, 0.26298380E-09_JPRB, 0.26298902E-09_JPRB, 0.26299218E-09_JPRB, 0.26299135E-09_JPRB, 0.26299141E-09_JPRB, &
  & 0.26298985E-09_JPRB, 0.26298949E-09_JPRB, 0.26298888E-09_JPRB, 0.26298611E-09_JPRB, 0.26298255E-09_JPRB, 0.26297758E-09_JPRB, &
  & 0.26297653E-09_JPRB, 0.26297259E-09_JPRB, 0.26296970E-09_JPRB, 0.26296734E-09_JPRB, 0.26296532E-09_JPRB, 0.26296637E-09_JPRB, &
  & 0.26296548E-09_JPRB, 0.26296459E-09_JPRB, 0.26296543E-09_JPRB, 0.26296332E-09_JPRB, 0.26295999E-09_JPRB, 0.26296038E-09_JPRB, &
  & 0.26295999E-09_JPRB, 0.26295874E-09_JPRB, 0.26295408E-09_JPRB, 0.26295149E-09_JPRB, 0.26295158E-09_JPRB, 0.26294728E-09_JPRB, &
  & 0.26294478E-09_JPRB, 0.26294231E-09_JPRB, 0.26294175E-09_JPRB, 0.26294686E-09_JPRB /)

RGHG5(:,87, 7) = (/ &
  & 0.26286534E-09_JPRB, 0.26287458E-09_JPRB, 0.26287933E-09_JPRB, 0.26288768E-09_JPRB, 0.26289665E-09_JPRB, 0.26290622E-09_JPRB, &
  & 0.26290947E-09_JPRB, 0.26291791E-09_JPRB, 0.26291969E-09_JPRB, 0.26292329E-09_JPRB, 0.26292563E-09_JPRB, 0.26292885E-09_JPRB, &
  & 0.26293104E-09_JPRB, 0.26293293E-09_JPRB, 0.26293451E-09_JPRB, 0.26293590E-09_JPRB, 0.26293612E-09_JPRB, 0.26293279E-09_JPRB, &
  & 0.26292987E-09_JPRB, 0.26292674E-09_JPRB, 0.26292010E-09_JPRB, 0.26291708E-09_JPRB, 0.26291355E-09_JPRB, 0.26291758E-09_JPRB, &
  & 0.26292196E-09_JPRB, 0.26293337E-09_JPRB, 0.26294092E-09_JPRB, 0.26295038E-09_JPRB, 0.26295885E-09_JPRB, 0.26296662E-09_JPRB, &
  & 0.26297622E-09_JPRB, 0.26298408E-09_JPRB, 0.26298919E-09_JPRB, 0.26299232E-09_JPRB, 0.26299143E-09_JPRB, 0.26299141E-09_JPRB, &
  & 0.26298985E-09_JPRB, 0.26298957E-09_JPRB, 0.26298913E-09_JPRB, 0.26298633E-09_JPRB, 0.26298280E-09_JPRB, 0.26297753E-09_JPRB, &
  & 0.26297667E-09_JPRB, 0.26297273E-09_JPRB, 0.26296973E-09_JPRB, 0.26296754E-09_JPRB, 0.26296559E-09_JPRB, 0.26296648E-09_JPRB, &
  & 0.26296568E-09_JPRB, 0.26296493E-09_JPRB, 0.26296562E-09_JPRB, 0.26296354E-09_JPRB, 0.26296029E-09_JPRB, 0.26296063E-09_JPRB, &
  & 0.26296032E-09_JPRB, 0.26295915E-09_JPRB, 0.26295435E-09_JPRB, 0.26295174E-09_JPRB, 0.26295188E-09_JPRB, 0.26294752E-09_JPRB, &
  & 0.26294508E-09_JPRB, 0.26294267E-09_JPRB, 0.26294208E-09_JPRB, 0.26294722E-09_JPRB /)

RGHG5(:,88, 7) = (/ &
  & 0.26286612E-09_JPRB, 0.26287514E-09_JPRB, 0.26287975E-09_JPRB, 0.26288752E-09_JPRB, 0.26289862E-09_JPRB, 0.26290448E-09_JPRB, &
  & 0.26291314E-09_JPRB, 0.26291627E-09_JPRB, 0.26292099E-09_JPRB, 0.26292260E-09_JPRB, 0.26292649E-09_JPRB, 0.26292876E-09_JPRB, &
  & 0.26293115E-09_JPRB, 0.26293293E-09_JPRB, 0.26293445E-09_JPRB, 0.26293573E-09_JPRB, 0.26293595E-09_JPRB, 0.26293301E-09_JPRB, &
  & 0.26293012E-09_JPRB, 0.26292715E-09_JPRB, 0.26292030E-09_JPRB, 0.26291747E-09_JPRB, 0.26291383E-09_JPRB, 0.26291780E-09_JPRB, &
  & 0.26292202E-09_JPRB, 0.26293373E-09_JPRB, 0.26294095E-09_JPRB, 0.26295061E-09_JPRB, 0.26295890E-09_JPRB, 0.26296670E-09_JPRB, &
  & 0.26297639E-09_JPRB, 0.26298419E-09_JPRB, 0.26298935E-09_JPRB, 0.26299254E-09_JPRB, 0.26299155E-09_JPRB, 0.26299149E-09_JPRB, &
  & 0.26298988E-09_JPRB, 0.26298971E-09_JPRB, 0.26298941E-09_JPRB, 0.26298658E-09_JPRB, 0.26298297E-09_JPRB, 0.26297736E-09_JPRB, &
  & 0.26297686E-09_JPRB, 0.26297262E-09_JPRB, 0.26296976E-09_JPRB, 0.26296759E-09_JPRB, 0.26296576E-09_JPRB, 0.26296651E-09_JPRB, &
  & 0.26296576E-09_JPRB, 0.26296509E-09_JPRB, 0.26296568E-09_JPRB, 0.26296371E-09_JPRB, 0.26296054E-09_JPRB, 0.26296082E-09_JPRB, &
  & 0.26296049E-09_JPRB, 0.26295932E-09_JPRB, 0.26295452E-09_JPRB, 0.26295191E-09_JPRB, 0.26295213E-09_JPRB, 0.26294775E-09_JPRB, &
  & 0.26294525E-09_JPRB, 0.26294281E-09_JPRB, 0.26294231E-09_JPRB, 0.26294747E-09_JPRB /)

RGHG5(:,89, 7) = (/ &
  & 0.26286717E-09_JPRB, 0.26287561E-09_JPRB, 0.26288000E-09_JPRB, 0.26288777E-09_JPRB, 0.26289701E-09_JPRB, 0.26290664E-09_JPRB, &
  & 0.26291042E-09_JPRB, 0.26291816E-09_JPRB, 0.26292021E-09_JPRB, 0.26292332E-09_JPRB, 0.26292590E-09_JPRB, 0.26292901E-09_JPRB, &
  & 0.26293129E-09_JPRB, 0.26293315E-09_JPRB, 0.26293470E-09_JPRB, 0.26293612E-09_JPRB, 0.26293637E-09_JPRB, 0.26293298E-09_JPRB, &
  & 0.26293021E-09_JPRB, 0.26292718E-09_JPRB, 0.26292041E-09_JPRB, 0.26291755E-09_JPRB, 0.26291391E-09_JPRB, 0.26291797E-09_JPRB, &
  & 0.26292213E-09_JPRB, 0.26293387E-09_JPRB, 0.26294103E-09_JPRB, 0.26295066E-09_JPRB, 0.26295899E-09_JPRB, 0.26296673E-09_JPRB, &
  & 0.26297650E-09_JPRB, 0.26298436E-09_JPRB, 0.26298949E-09_JPRB, 0.26299274E-09_JPRB, 0.26299157E-09_JPRB, 0.26299146E-09_JPRB, &
  & 0.26298985E-09_JPRB, 0.26298974E-09_JPRB, 0.26298957E-09_JPRB, 0.26298669E-09_JPRB, 0.26298314E-09_JPRB, 0.26297714E-09_JPRB, &
  & 0.26297703E-09_JPRB, 0.26297264E-09_JPRB, 0.26296973E-09_JPRB, 0.26296762E-09_JPRB, 0.26296579E-09_JPRB, 0.26296654E-09_JPRB, &
  & 0.26296582E-09_JPRB, 0.26296518E-09_JPRB, 0.26296570E-09_JPRB, 0.26296376E-09_JPRB, 0.26296071E-09_JPRB, 0.26296090E-09_JPRB, &
  & 0.26296063E-09_JPRB, 0.26295949E-09_JPRB, 0.26295463E-09_JPRB, 0.26295205E-09_JPRB, 0.26295233E-09_JPRB, 0.26294786E-09_JPRB, &
  & 0.26294536E-09_JPRB, 0.26294292E-09_JPRB, 0.26294233E-09_JPRB, 0.26294761E-09_JPRB /)

RGHG5(:,90, 7) = (/ &
  & 0.26286792E-09_JPRB, 0.26287594E-09_JPRB, 0.26287966E-09_JPRB, 0.26288710E-09_JPRB, 0.26289748E-09_JPRB, 0.26290439E-09_JPRB, &
  & 0.26291164E-09_JPRB, 0.26291611E-09_JPRB, 0.26292019E-09_JPRB, 0.26292185E-09_JPRB, 0.26292618E-09_JPRB, 0.26292912E-09_JPRB, &
  & 0.26293182E-09_JPRB, 0.26293370E-09_JPRB, 0.26293531E-09_JPRB, 0.26293689E-09_JPRB, 0.26293723E-09_JPRB, 0.26293301E-09_JPRB, &
  & 0.26293004E-09_JPRB, 0.26292737E-09_JPRB, 0.26292016E-09_JPRB, 0.26291758E-09_JPRB, 0.26291377E-09_JPRB, 0.26291802E-09_JPRB, &
  & 0.26292196E-09_JPRB, 0.26293401E-09_JPRB, 0.26294103E-09_JPRB, 0.26295077E-09_JPRB, 0.26295893E-09_JPRB, 0.26296662E-09_JPRB, &
  & 0.26297658E-09_JPRB, 0.26298455E-09_JPRB, 0.26298971E-09_JPRB, 0.26299299E-09_JPRB, 0.26299157E-09_JPRB, 0.26299155E-09_JPRB, &
  & 0.26298982E-09_JPRB, 0.26298974E-09_JPRB, 0.26298974E-09_JPRB, 0.26298674E-09_JPRB, 0.26298325E-09_JPRB, 0.26297686E-09_JPRB, &
  & 0.26297736E-09_JPRB, 0.26297262E-09_JPRB, 0.26296967E-09_JPRB, 0.26296754E-09_JPRB, 0.26296565E-09_JPRB, 0.26296659E-09_JPRB, &
  & 0.26296584E-09_JPRB, 0.26296521E-09_JPRB, 0.26296584E-09_JPRB, 0.26296390E-09_JPRB, 0.26296068E-09_JPRB, 0.26296099E-09_JPRB, &
  & 0.26296076E-09_JPRB, 0.26295965E-09_JPRB, 0.26295457E-09_JPRB, 0.26295194E-09_JPRB, 0.26295244E-09_JPRB, 0.26294783E-09_JPRB, &
  & 0.26294539E-09_JPRB, 0.26294289E-09_JPRB, 0.26294239E-09_JPRB, 0.26294775E-09_JPRB /)

RGHG5(:,91, 7) = (/ &
  & 0.26286720E-09_JPRB, 0.26287592E-09_JPRB, 0.26287783E-09_JPRB, 0.26288696E-09_JPRB, 0.26289687E-09_JPRB, 0.26290389E-09_JPRB, &
  & 0.26290756E-09_JPRB, 0.26291658E-09_JPRB, 0.26291924E-09_JPRB, 0.26291919E-09_JPRB, 0.26292707E-09_JPRB, 0.26293054E-09_JPRB, &
  & 0.26293304E-09_JPRB, 0.26293429E-09_JPRB, 0.26293570E-09_JPRB, 0.26293809E-09_JPRB, 0.26293925E-09_JPRB, 0.26293204E-09_JPRB, &
  & 0.26292976E-09_JPRB, 0.26292768E-09_JPRB, 0.26291977E-09_JPRB, 0.26291769E-09_JPRB, 0.26291325E-09_JPRB, 0.26291802E-09_JPRB, &
  & 0.26292149E-09_JPRB, 0.26293437E-09_JPRB, 0.26294084E-09_JPRB, 0.26295083E-09_JPRB, 0.26295888E-09_JPRB, 0.26296620E-09_JPRB, &
  & 0.26297686E-09_JPRB, 0.26298469E-09_JPRB, 0.26298996E-09_JPRB, 0.26299349E-09_JPRB, 0.26299146E-09_JPRB, 0.26299166E-09_JPRB, &
  & 0.26298974E-09_JPRB, 0.26298977E-09_JPRB, 0.26298996E-09_JPRB, 0.26298683E-09_JPRB, 0.26298352E-09_JPRB, 0.26297631E-09_JPRB, &
  & 0.26297817E-09_JPRB, 0.26297245E-09_JPRB, 0.26296951E-09_JPRB, 0.26296762E-09_JPRB, 0.26296498E-09_JPRB, 0.26296693E-09_JPRB, &
  & 0.26296593E-09_JPRB, 0.26296504E-09_JPRB, 0.26296623E-09_JPRB, 0.26296407E-09_JPRB, 0.26296013E-09_JPRB, 0.26296101E-09_JPRB, &
  & 0.26296085E-09_JPRB, 0.26295993E-09_JPRB, 0.26295444E-09_JPRB, 0.26295180E-09_JPRB, 0.26295277E-09_JPRB, 0.26294769E-09_JPRB, &
  & 0.26294533E-09_JPRB, 0.26294275E-09_JPRB, 0.26294228E-09_JPRB, 0.26294791E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART14',1,ZHOOK_HANDLE)
END SUBROUTINE PART14






SUBROUTINE PART15
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART15',0,ZHOOK_HANDLE)



!-- Month=  8 ------------

RGHG5(:, 1, 8) = (/ &
  & 0.42038954E-44_JPRB, 0.56051939E-44_JPRB, 0.70064923E-44_JPRB, 0.84077908E-44_JPRB, 0.84077908E-44_JPRB, 0.98090893E-44_JPRB, &
  & 0.11210388E-43_JPRB, 0.14012985E-43_JPRB, 0.19618179E-43_JPRB, 0.29427268E-43_JPRB, 0.47644148E-43_JPRB, 0.84077908E-43_JPRB, &
  & 0.15414283E-42_JPRB, 0.28726619E-42_JPRB, 0.53809861E-42_JPRB, 0.98651412E-42_JPRB, 0.17600309E-41_JPRB, 0.30296073E-41_JPRB, &
  & 0.50124446E-41_JPRB, 0.80294402E-41_JPRB, 0.12566845E-40_JPRB, 0.19370149E-40_JPRB, 0.29687909E-40_JPRB, 0.45819657E-40_JPRB, &
  & 0.72168272E-40_JPRB, 0.11624612E-39_JPRB, 0.18574351E-39_JPRB, 0.34906625E-39_JPRB, 0.54130198E-39_JPRB, 0.89071015E-39_JPRB, &
  & 0.14342444E-38_JPRB, 0.25085583E-38_JPRB, 0.37643081E-38_JPRB, 0.55917036E-38_JPRB, 0.43984236E-38_JPRB, 0.33989587E-38_JPRB, &
  & 0.25819317E-38_JPRB, 0.20419679E-38_JPRB, 0.10236836E-38_JPRB, 0.69440505E-39_JPRB, 0.54005202E-39_JPRB, 0.32773148E-39_JPRB, &
  & 0.17001674E-39_JPRB, 0.75755596E-40_JPRB, 0.38891638E-40_JPRB, 0.18781603E-40_JPRB, 0.67836859E-41_JPRB, 0.27521502E-41_JPRB, &
  & 0.95988945E-42_JPRB, 0.44561291E-42_JPRB, 0.20599087E-42_JPRB, 0.10369609E-42_JPRB, 0.51848043E-43_JPRB, 0.29427268E-43_JPRB, &
  & 0.15414283E-43_JPRB, 0.98090893E-44_JPRB, 0.56051939E-44_JPRB, 0.42038954E-44_JPRB, 0.42038954E-44_JPRB, 0.42038954E-44_JPRB, &
  & 0.42038954E-44_JPRB, 0.42038954E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB /)

RGHG5(:, 2, 8) = (/ &
  & 0.10089349E-42_JPRB, 0.16395192E-42_JPRB, 0.23541814E-42_JPRB, 0.28866748E-42_JPRB, 0.32510124E-42_JPRB, 0.36573890E-42_JPRB, &
  & 0.43300123E-42_JPRB, 0.56051939E-42_JPRB, 0.79874012E-42_JPRB, 0.12513595E-41_JPRB, 0.21131581E-41_JPRB, 0.37610851E-41_JPRB, &
  & 0.69112040E-41_JPRB, 0.12845703E-40_JPRB, 0.23742200E-40_JPRB, 0.42997442E-40_JPRB, 0.75546803E-40_JPRB, 0.12831550E-39_JPRB, &
  & 0.20991451E-39_JPRB, 0.33290648E-39_JPRB, 0.51599453E-39_JPRB, 0.78877269E-39_JPRB, 0.12020394E-38_JPRB, 0.18519448E-38_JPRB, &
  & 0.29166346E-38_JPRB, 0.47138125E-38_JPRB, 0.76652399E-38_JPRB, 0.13979777E-37_JPRB, 0.21931138E-37_JPRB, 0.36069736E-37_JPRB, &
  & 0.58731042E-37_JPRB, 0.10090555E-36_JPRB, 0.15159980E-36_JPRB, 0.21360560E-36_JPRB, 0.17517350E-36_JPRB, 0.13640299E-36_JPRB, &
  & 0.10411822E-36_JPRB, 0.79759784E-37_JPRB, 0.43675704E-37_JPRB, 0.28954660E-37_JPRB, 0.21753153E-37_JPRB, 0.13240054E-37_JPRB, &
  & 0.68991613E-38_JPRB, 0.31247975E-38_JPRB, 0.15988479E-38_JPRB, 0.77510022E-39_JPRB, 0.29638023E-39_JPRB, 0.12125716E-39_JPRB, &
  & 0.43780768E-40_JPRB, 0.19246834E-40_JPRB, 0.88379894E-41_JPRB, 0.44000772E-41_JPRB, 0.21720126E-41_JPRB, 0.12317414E-41_JPRB, &
  & 0.65440638E-42_JPRB, 0.41338305E-42_JPRB, 0.24242463E-42_JPRB, 0.17936620E-42_JPRB, 0.14573504E-42_JPRB, 0.14433374E-42_JPRB, &
  & 0.15554413E-42_JPRB, 0.16114932E-42_JPRB, 0.10509738E-42_JPRB, 0.14012985E-43_JPRB /)

RGHG5(:, 3, 8) = (/ &
  & 0.35943306E-41_JPRB, 0.77477792E-41_JPRB, 0.11796130E-40_JPRB, 0.14315665E-40_JPRB, 0.15742187E-40_JPRB, 0.17292023E-40_JPRB, &
  & 0.20125449E-40_JPRB, 0.25677393E-40_JPRB, 0.36372103E-40_JPRB, 0.56917941E-40_JPRB, 0.96748449E-40_JPRB, 0.17395999E-39_JPRB, &
  & 0.32359485E-39_JPRB, 0.60836112E-39_JPRB, 0.11350083E-38_JPRB, 0.20694852E-38_JPRB, 0.36522855E-38_JPRB, 0.62167065E-38_JPRB, &
  & 0.10167428E-37_JPRB, 0.16082264E-37_JPRB, 0.24813706E-37_JPRB, 0.37723246E-37_JPRB, 0.57251529E-37_JPRB, 0.87928424E-37_JPRB, &
  & 0.13873714E-36_JPRB, 0.22468756E-36_JPRB, 0.36788448E-36_JPRB, 0.66581981E-36_JPRB, 0.10483692E-35_JPRB, 0.17238240E-35_JPRB, &
  & 0.28152021E-35_JPRB, 0.48142585E-35_JPRB, 0.72241281E-35_JPRB, 0.10034728E-34_JPRB, 0.83279700E-35_JPRB, 0.65156165E-35_JPRB, &
  & 0.49795739E-35_JPRB, 0.37977070E-35_JPRB, 0.21398280E-35_JPRB, 0.14166249E-35_JPRB, 0.10587948E-35_JPRB, 0.63633156E-36_JPRB, &
  & 0.32012910E-36_JPRB, 0.13726251E-36_JPRB, 0.70269759E-37_JPRB, 0.34341103E-37_JPRB, 0.13179732E-37_JPRB, 0.56483721E-38_JPRB, &
  & 0.21155081E-38_JPRB, 0.94677189E-39_JPRB, 0.43687301E-39_JPRB, 0.21727693E-39_JPRB, 0.10761131E-39_JPRB, 0.60418385E-40_JPRB, &
  & 0.32221457E-40_JPRB, 0.20090416E-40_JPRB, 0.11890017E-40_JPRB, 0.86992609E-41_JPRB, 0.70078936E-41_JPRB, 0.69336248E-41_JPRB, &
  & 0.75600052E-41_JPRB, 0.81079129E-41_JPRB, 0.63086457E-41_JPRB, 0.91224530E-42_JPRB /)

RGHG5(:, 4, 8) = (/ &
  & 0.26841031E-39_JPRB, 0.80621325E-39_JPRB, 0.12341824E-38_JPRB, 0.14365818E-38_JPRB, 0.15248636E-38_JPRB, 0.16353433E-38_JPRB, &
  & 0.18652334E-38_JPRB, 0.23363093E-38_JPRB, 0.32594693E-38_JPRB, 0.50552935E-38_JPRB, 0.85839046E-38_JPRB, 0.15519380E-37_JPRB, &
  & 0.29143225E-37_JPRB, 0.55373329E-37_JPRB, 0.10428715E-36_JPRB, 0.19146344E-36_JPRB, 0.33917059E-36_JPRB, 0.57759702E-36_JPRB, &
  & 0.94192458E-36_JPRB, 0.14813286E-35_JPRB, 0.22676467E-35_JPRB, 0.34173337E-35_JPRB, 0.51381415E-35_JPRB, 0.78383146E-35_JPRB, &
  & 0.12278684E-34_JPRB, 0.19846150E-34_JPRB, 0.32390391E-34_JPRB, 0.58477899E-34_JPRB, 0.91916920E-34_JPRB, 0.15116206E-33_JPRB, &
  & 0.24700835E-33_JPRB, 0.42248814E-33_JPRB, 0.63499695E-33_JPRB, 0.88450532E-33_JPRB, 0.73534936E-33_JPRB, 0.57579033E-33_JPRB, &
  & 0.44161656E-33_JPRB, 0.33744517E-33_JPRB, 0.19250282E-33_JPRB, 0.12807920E-33_JPRB, 0.96748902E-34_JPRB, 0.57645061E-34_JPRB, &
  & 0.28100775E-34_JPRB, 0.11371926E-34_JPRB, 0.59485729E-35_JPRB, 0.29534457E-35_JPRB, 0.11333439E-35_JPRB, 0.50285486E-36_JPRB, &
  & 0.19398872E-36_JPRB, 0.88262891E-37_JPRB, 0.41177262E-37_JPRB, 0.20551725E-37_JPRB, 0.10207593E-37_JPRB, 0.57356744E-38_JPRB, &
  & 0.30644534E-38_JPRB, 0.19106578E-38_JPRB, 0.11330241E-38_JPRB, 0.82778624E-39_JPRB, 0.66675603E-39_JPRB, 0.65963182E-39_JPRB, &
  & 0.73069728E-39_JPRB, 0.83712309E-39_JPRB, 0.83400660E-39_JPRB, 0.33630322E-39_JPRB /)

RGHG5(:, 5, 8) = (/ &
  & 0.97097742E-37_JPRB, 0.23200628E-36_JPRB, 0.31311487E-36_JPRB, 0.34260801E-36_JPRB, 0.35676875E-36_JPRB, 0.37856331E-36_JPRB, &
  & 0.42689982E-36_JPRB, 0.52732718E-36_JPRB, 0.72388765E-36_JPRB, 0.11065450E-35_JPRB, 0.18572642E-35_JPRB, 0.33286651E-35_JPRB, &
  & 0.62106595E-35_JPRB, 0.11728307E-34_JPRB, 0.21931100E-34_JPRB, 0.39882704E-34_JPRB, 0.69778010E-34_JPRB, 0.11701146E-33_JPRB, &
  & 0.18742155E-33_JPRB, 0.28899405E-33_JPRB, 0.43335885E-33_JPRB, 0.63957656E-33_JPRB, 0.94272296E-33_JPRB, 0.14096064E-32_JPRB, &
  & 0.21718772E-32_JPRB, 0.34523090E-32_JPRB, 0.55732707E-32_JPRB, 0.99498279E-32_JPRB, 0.15561889E-31_JPRB, 0.25490216E-31_JPRB, &
  & 0.41623585E-31_JPRB, 0.71248164E-31_JPRB, 0.10740795E-30_JPRB, 0.15083228E-30_JPRB, 0.12569871E-30_JPRB, 0.99086768E-31_JPRB, &
  & 0.76598903E-31_JPRB, 0.59328863E-31_JPRB, 0.34141475E-31_JPRB, 0.23182413E-31_JPRB, 0.17879080E-31_JPRB, 0.10790292E-31_JPRB, &
  & 0.52513528E-32_JPRB, 0.20989908E-32_JPRB, 0.11378052E-32_JPRB, 0.57931199E-33_JPRB, 0.22581974E-33_JPRB, 0.10359730E-33_JPRB, &
  & 0.40799644E-34_JPRB, 0.18961599E-34_JPRB, 0.89652947E-35_JPRB, 0.45268389E-35_JPRB, 0.22682548E-35_JPRB, 0.12875451E-35_JPRB, &
  & 0.69257735E-36_JPRB, 0.43513600E-36_JPRB, 0.25930490E-36_JPRB, 0.19027631E-36_JPRB, 0.15356633E-36_JPRB, 0.15205452E-36_JPRB, &
  & 0.17009323E-36_JPRB, 0.20936343E-36_JPRB, 0.26386968E-36_JPRB, 0.30362396E-36_JPRB /)

RGHG5(:, 6, 8) = (/ &
  & 0.83196497E-34_JPRB, 0.14468618E-33_JPRB, 0.17397535E-33_JPRB, 0.18657933E-33_JPRB, 0.19340953E-33_JPRB, 0.20389730E-33_JPRB, &
  & 0.22659077E-33_JPRB, 0.27359080E-33_JPRB, 0.36517005E-33_JPRB, 0.54013263E-33_JPRB, 0.87553620E-33_JPRB, 0.15121383E-32_JPRB, &
  & 0.27154287E-32_JPRB, 0.49314817E-32_JPRB, 0.88594144E-32_JPRB, 0.15463517E-31_JPRB, 0.25937494E-31_JPRB, 0.41664845E-31_JPRB, &
  & 0.63915366E-31_JPRB, 0.94453498E-31_JPRB, 0.13594975E-30_JPRB, 0.19299412E-30_JPRB, 0.27421420E-30_JPRB, 0.39653435E-30_JPRB, &
  & 0.59189140E-30_JPRB, 0.91595329E-30_JPRB, 0.14441416E-29_JPRB, 0.25298497E-29_JPRB, 0.39039691E-29_JPRB, 0.63434798E-29_JPRB, &
  & 0.10300696E-28_JPRB, 0.17624665E-28_JPRB, 0.26620769E-28_JPRB, 0.37752326E-28_JPRB, 0.31743665E-28_JPRB, 0.25362517E-28_JPRB, &
  & 0.19980174E-28_JPRB, 0.15843693E-28_JPRB, 0.92867447E-29_JPRB, 0.65235701E-29_JPRB, 0.52405366E-29_JPRB, 0.32648485E-29_JPRB, &
  & 0.16454534E-29_JPRB, 0.68247411E-30_JPRB, 0.38942586E-30_JPRB, 0.20794015E-30_JPRB, 0.85047892E-31_JPRB, 0.40930584E-31_JPRB, &
  & 0.16876743E-31_JPRB, 0.81852405E-32_JPRB, 0.40226904E-32_JPRB, 0.21068776E-32_JPRB, 0.10901177E-32_JPRB, 0.63847306E-33_JPRB, &
  & 0.35211474E-33_JPRB, 0.22653103E-33_JPRB, 0.13741354E-33_JPRB, 0.10238123E-33_JPRB, 0.83397392E-34_JPRB, 0.82848388E-34_JPRB, &
  & 0.92388874E-34_JPRB, 0.11380337E-33_JPRB, 0.15349293E-33_JPRB, 0.19400910E-33_JPRB /)

RGHG5(:, 7, 8) = (/ &
  & 0.70338332E-31_JPRB, 0.11299919E-30_JPRB, 0.13346369E-30_JPRB, 0.14284935E-30_JPRB, 0.14755690E-30_JPRB, 0.15339798E-30_JPRB, &
  & 0.16621274E-30_JPRB, 0.19353910E-30_JPRB, 0.24678514E-30_JPRB, 0.34658036E-30_JPRB, 0.53074285E-30_JPRB, 0.86245870E-30_JPRB, &
  & 0.14536853E-29_JPRB, 0.24743761E-29_JPRB, 0.41681886E-29_JPRB, 0.68274412E-29_JPRB, 0.10762841E-28_JPRB, 0.16281881E-28_JPRB, &
  & 0.23574093E-28_JPRB, 0.32974912E-28_JPRB, 0.45075379E-28_JPRB, 0.60998914E-28_JPRB, 0.82953895E-28_JPRB, 0.11526137E-27_JPRB, &
  & 0.16610958E-27_JPRB, 0.24910893E-27_JPRB, 0.38255161E-27_JPRB, 0.65496944E-27_JPRB, 0.99503633E-27_JPRB, 0.15973268E-26_JPRB, &
  & 0.25781020E-26_JPRB, 0.43982181E-26_JPRB, 0.66644017E-26_JPRB, 0.95339495E-26_JPRB, 0.81135877E-26_JPRB, 0.65975688E-26_JPRB, &
  & 0.53147316E-26_JPRB, 0.43426897E-26_JPRB, 0.25930836E-26_JPRB, 0.19016351E-26_JPRB, 0.16033611E-26_JPRB, 0.10430614E-26_JPRB, &
  & 0.55005922E-27_JPRB, 0.24092033E-27_JPRB, 0.14676683E-27_JPRB, 0.83292245E-28_JPRB, 0.36250157E-28_JPRB, 0.18636412E-28_JPRB, &
  & 0.81890188E-29_JPRB, 0.42425570E-29_JPRB, 0.22204631E-29_JPRB, 0.12346302E-29_JPRB, 0.67512933E-30_JPRB, 0.41669154E-30_JPRB, &
  & 0.24037790E-30_JPRB, 0.16114903E-30_JPRB, 0.10108414E-30_JPRB, 0.77527232E-31_JPRB, 0.64506281E-31_JPRB, 0.64813350E-31_JPRB, &
  & 0.72272931E-31_JPRB, 0.88779511E-31_JPRB, 0.12074664E-30_JPRB, 0.17343676E-30_JPRB /)

RGHG5(:, 8, 8) = (/ &
  & 0.50290752E-28_JPRB, 0.79643697E-28_JPRB, 0.93716919E-28_JPRB, 0.10042809E-27_JPRB, 0.10325869E-27_JPRB, 0.10590963E-27_JPRB, &
  & 0.11190739E-27_JPRB, 0.12565122E-27_JPRB, 0.15309850E-27_JPRB, 0.20401999E-27_JPRB, 0.29483585E-27_JPRB, 0.44991129E-27_JPRB, &
  & 0.70924190E-27_JPRB, 0.11269610E-26_JPRB, 0.17710436E-26_JPRB, 0.27100396E-26_JPRB, 0.40003345E-26_JPRB, 0.56843040E-26_JPRB, &
  & 0.77534457E-26_JPRB, 0.10249705E-25_JPRB, 0.13285960E-25_JPRB, 0.17110033E-25_JPRB, 0.22231647E-25_JPRB, 0.29648554E-25_JPRB, &
  & 0.41213003E-25_JPRB, 0.59923341E-25_JPRB, 0.89540175E-25_JPRB, 0.14991382E-24_JPRB, 0.22393560E-24_JPRB, 0.35516944E-24_JPRB, &
  & 0.56930297E-24_JPRB, 0.96930515E-24_JPRB, 0.14734500E-23_JPRB, 0.21272230E-23_JPRB, 0.18342406E-23_JPRB, 0.15191528E-23_JPRB, &
  & 0.12527351E-23_JPRB, 0.10559940E-23_JPRB, 0.64369162E-24_JPRB, 0.49316034E-24_JPRB, 0.43769666E-24_JPRB, 0.29709042E-24_JPRB, &
  & 0.16446605E-24_JPRB, 0.75911536E-25_JPRB, 0.49537525E-25_JPRB, 0.29945055E-25_JPRB, 0.13826370E-25_JPRB, 0.76308996E-26_JPRB, &
  & 0.35828556E-26_JPRB, 0.19973856E-26_JPRB, 0.11199928E-26_JPRB, 0.66540957E-27_JPRB, 0.38662940E-27_JPRB, 0.25282881E-27_JPRB, &
  & 0.15321379E-27_JPRB, 0.10752144E-27_JPRB, 0.69985177E-28_JPRB, 0.55480721E-28_JPRB, 0.47308585E-28_JPRB, 0.48373387E-28_JPRB, &
  & 0.54423265E-28_JPRB, 0.66979324E-28_JPRB, 0.92232081E-28_JPRB, 0.13679542E-27_JPRB /)

RGHG5(:, 9, 8) = (/ &
  & 0.29420808E-25_JPRB, 0.46243948E-25_JPRB, 0.54257693E-25_JPRB, 0.58228825E-25_JPRB, 0.59757255E-25_JPRB, 0.60725779E-25_JPRB, &
  & 0.62968363E-25_JPRB, 0.68687290E-25_JPRB, 0.80586443E-25_JPRB, 0.10262338E-24_JPRB, 0.14087064E-24_JPRB, 0.20289678E-24_JPRB, &
  & 0.30043494E-24_JPRB, 0.44668840E-24_JPRB, 0.65610055E-24_JPRB, 0.93882948E-24_JPRB, 0.12988761E-23_JPRB, 0.17358809E-23_JPRB, &
  & 0.22335589E-23_JPRB, 0.27931131E-23_JPRB, 0.34339573E-23_JPRB, 0.42056526E-23_JPRB, 0.52124970E-23_JPRB, 0.66592104E-23_JPRB, &
  & 0.89136131E-23_JPRB, 0.12542419E-22_JPRB, 0.18210963E-22_JPRB, 0.29807709E-22_JPRB, 0.43728535E-22_JPRB, 0.68489282E-22_JPRB, &
  & 0.10903483E-21_JPRB, 0.18538241E-21_JPRB, 0.28298975E-21_JPRB, 0.41238313E-21_JPRB, 0.36056505E-21_JPRB, 0.30446005E-21_JPRB, &
  & 0.25729884E-21_JPRB, 0.22375536E-21_JPRB, 0.13998758E-21_JPRB, 0.11214468E-21_JPRB, 0.10460351E-21_JPRB, 0.74362062E-22_JPRB, &
  & 0.43200447E-22_JPRB, 0.20979412E-22_JPRB, 0.14698822E-22_JPRB, 0.94595435E-23_JPRB, 0.46177413E-23_JPRB, 0.27425059E-23_JPRB, &
  & 0.13738322E-23_JPRB, 0.82559919E-24_JPRB, 0.49611640E-24_JPRB, 0.31491002E-24_JPRB, 0.19432908E-24_JPRB, 0.13453063E-24_JPRB, &
  & 0.85564482E-25_JPRB, 0.62778654E-25_JPRB, 0.42349868E-25_JPRB, 0.34654829E-25_JPRB, 0.30272602E-25_JPRB, 0.31501462E-25_JPRB, &
  & 0.35830546E-25_JPRB, 0.44459344E-25_JPRB, 0.61686698E-25_JPRB, 0.92995971E-25_JPRB /)

RGHG5(:,10, 8) = (/ &
  & 0.14050637E-22_JPRB, 0.21622952E-22_JPRB, 0.25497551E-22_JPRB, 0.27356630E-22_JPRB, 0.28079419E-22_JPRB, 0.28390255E-22_JPRB, &
  & 0.29075182E-22_JPRB, 0.31058666E-22_JPRB, 0.35372211E-22_JPRB, 0.43389533E-22_JPRB, 0.56949712E-22_JPRB, 0.77885474E-22_JPRB, &
  & 0.10885263E-21_JPRB, 0.15211048E-21_JPRB, 0.20948193E-21_JPRB, 0.28103123E-21_JPRB, 0.36514985E-21_JPRB, 0.45976525E-21_JPRB, &
  & 0.55878019E-21_JPRB, 0.66163246E-21_JPRB, 0.77171635E-21_JPRB, 0.89821515E-21_JPRB, 0.10606328E-20_JPRB, 0.12950815E-20_JPRB, &
  & 0.16651153E-20_JPRB, 0.22629810E-20_JPRB, 0.31835189E-20_JPRB, 0.50921081E-20_JPRB, 0.73265818E-20_JPRB, 0.11324435E-19_JPRB, &
  & 0.17910974E-19_JPRB, 0.30421131E-19_JPRB, 0.46669285E-19_JPRB, 0.68659913E-19_JPRB, 0.60905645E-19_JPRB, 0.52478513E-19_JPRB, &
  & 0.45490950E-19_JPRB, 0.40797159E-19_JPRB, 0.26348981E-19_JPRB, 0.22069684E-19_JPRB, 0.21613691E-19_JPRB, 0.16117081E-19_JPRB, &
  & 0.98554507E-20_JPRB, 0.50449087E-20_JPRB, 0.37931716E-20_JPRB, 0.26005710E-20_JPRB, 0.13431676E-20_JPRB, 0.85848049E-21_JPRB, &
  & 0.45889995E-21_JPRB, 0.29695653E-21_JPRB, 0.19098160E-21_JPRB, 0.12932640E-21_JPRB, 0.84626795E-22_JPRB, 0.61929601E-22_JPRB, &
  & 0.41272814E-22_JPRB, 0.31609590E-22_JPRB, 0.22063313E-22_JPRB, 0.18600578E-22_JPRB, 0.16615283E-22_JPRB, 0.17579390E-22_JPRB, &
  & 0.20209420E-22_JPRB, 0.25248451E-22_JPRB, 0.35299172E-22_JPRB, 0.53687879E-22_JPRB /)

RGHG5(:,11, 8) = (/ &
  & 0.53361466E-20_JPRB, 0.83325877E-20_JPRB, 0.97275980E-20_JPRB, 0.10488438E-19_JPRB, 0.10761743E-19_JPRB, 0.10850379E-19_JPRB, &
  & 0.11022054E-19_JPRB, 0.11596622E-19_JPRB, 0.12904077E-19_JPRB, 0.15336362E-19_JPRB, 0.19345163E-19_JPRB, 0.25237701E-19_JPRB, &
  & 0.33432446E-19_JPRB, 0.44074238E-19_JPRB, 0.57111968E-19_JPRB, 0.72031663E-19_JPRB, 0.88070986E-19_JPRB, 0.10458916E-18_JPRB, &
  & 0.12015765E-18_JPRB, 0.13473964E-18_JPRB, 0.14909405E-18_JPRB, 0.16491076E-18_JPRB, 0.18540191E-18_JPRB, 0.21630111E-18_JPRB, &
  & 0.26682660E-18_JPRB, 0.34952031E-18_JPRB, 0.47616704E-18_JPRB, 0.74330662E-18_JPRB, 0.10484894E-17_JPRB, 0.15998253E-17_JPRB, &
  & 0.25124953E-17_JPRB, 0.42671018E-17_JPRB, 0.65757517E-17_JPRB, 0.97682023E-17_JPRB, 0.87936926E-17_JPRB, 0.77371075E-17_JPRB, &
  & 0.68859982E-17_JPRB, 0.63694396E-17_JPRB, 0.42617239E-17_JPRB, 0.37336017E-17_JPRB, 0.38354897E-17_JPRB, 0.30049222E-17_JPRB, &
  & 0.19367609E-17_JPRB, 0.10484427E-17_JPRB, 0.84482779E-18_JPRB, 0.61704856E-18_JPRB, 0.33828094E-18_JPRB, 0.23238696E-18_JPRB, &
  & 0.13257557E-18_JPRB, 0.92161498E-19_JPRB, 0.63296629E-19_JPRB, 0.45617395E-19_JPRB, 0.31588280E-19_JPRB, 0.24370751E-19_JPRB, &
  & 0.16982861E-19_JPRB, 0.13539786E-19_JPRB, 0.97566074E-20_JPRB, 0.84495029E-20_JPRB, 0.76983761E-20_JPRB, 0.82600584E-20_JPRB, &
  & 0.95783153E-20_JPRB, 0.12031254E-19_JPRB, 0.16899592E-19_JPRB, 0.25842681E-19_JPRB /)

RGHG5(:,12, 8) = (/ &
  & 0.16923729E-17_JPRB, 0.25816288E-17_JPRB, 0.30536894E-17_JPRB, 0.32820819E-17_JPRB, 0.33705116E-17_JPRB, 0.33903672E-17_JPRB, &
  & 0.34240232E-17_JPRB, 0.35620676E-17_JPRB, 0.38910733E-17_JPRB, 0.45022920E-17_JPRB, 0.54833373E-17_JPRB, 0.68525660E-17_JPRB, &
  & 0.86402688E-17_JPRB, 0.10789384E-16_JPRB, 0.13201943E-16_JPRB, 0.15701542E-16_JPRB, 0.18098990E-16_JPRB, 0.20294873E-16_JPRB, &
  & 0.22040758E-16_JPRB, 0.23404276E-16_JPRB, 0.24563307E-16_JPRB, 0.25815731E-16_JPRB, 0.27650947E-16_JPRB, 0.30819618E-16_JPRB, &
  & 0.36466939E-16_JPRB, 0.46023423E-16_JPRB, 0.60651960E-16_JPRB, 0.92330780E-16_JPRB, 0.12765798E-15_JPRB, 0.19219283E-15_JPRB, &
  & 0.29974307E-15_JPRB, 0.50858251E-15_JPRB, 0.78728822E-15_JPRB, 0.11805143E-14_JPRB, 0.10790858E-14_JPRB, 0.97029022E-15_JPRB, &
  & 0.88761154E-15_JPRB, 0.84756541E-15_JPRB, 0.58863708E-15_JPRB, 0.53979578E-15_JPRB, 0.58151782E-15_JPRB, 0.47879961E-15_JPRB, &
  & 0.32555875E-15_JPRB, 0.18694622E-15_JPRB, 0.16109413E-15_JPRB, 0.12534799E-15_JPRB, 0.73195267E-16_JPRB, 0.53941212E-16_JPRB, &
  & 0.32873918E-16_JPRB, 0.24495443E-16_JPRB, 0.17938110E-16_JPRB, 0.13733518E-16_JPRB, 0.10047851E-16_JPRB, 0.81540495E-17_JPRB, &
  & 0.59317912E-17_JPRB, 0.49104072E-17_JPRB, 0.36458411E-17_JPRB, 0.32347806E-17_JPRB, 0.29987729E-17_JPRB, 0.32542278E-17_JPRB, &
  & 0.37981226E-17_JPRB, 0.47839879E-17_JPRB, 0.67342118E-17_JPRB, 0.10323198E-16_JPRB /)

RGHG5(:,13, 8) = (/ &
  & 0.33154286E-16_JPRB, 0.49412411E-16_JPRB, 0.55510781E-16_JPRB, 0.58594523E-16_JPRB, 0.59268417E-16_JPRB, 0.59249809E-16_JPRB, &
  & 0.59886096E-16_JPRB, 0.62745812E-16_JPRB, 0.69319588E-16_JPRB, 0.81187744E-16_JPRB, 0.99932345E-16_JPRB, 0.12564561E-15_JPRB, &
  & 0.15951573E-15_JPRB, 0.19909356E-15_JPRB, 0.24377502E-15_JPRB, 0.28850477E-15_JPRB, 0.33145641E-15_JPRB, 0.36850131E-15_JPRB, &
  & 0.39558231E-15_JPRB, 0.41360267E-15_JPRB, 0.42519847E-15_JPRB, 0.43420561E-15_JPRB, 0.44610208E-15_JPRB, 0.46844654E-15_JPRB, &
  & 0.50992845E-15_JPRB, 0.58281902E-15_JPRB, 0.69974953E-15_JPRB, 0.89308179E-15_JPRB, 0.12324377E-14_JPRB, 0.15674673E-14_JPRB, &
  & 0.23219881E-14_JPRB, 0.28304267E-14_JPRB, 0.41733644E-14_JPRB, 0.44780010E-14_JPRB, 0.56782374E-14_JPRB, 0.67432136E-14_JPRB, &
  & 0.76370202E-14_JPRB, 0.65238101E-14_JPRB, 0.49891867E-14_JPRB, 0.40871182E-14_JPRB, 0.39629118E-14_JPRB, 0.28204738E-14_JPRB, &
  & 0.16546899E-14_JPRB, 0.10621873E-14_JPRB, 0.97415893E-15_JPRB, 0.76269303E-15_JPRB, 0.48855235E-15_JPRB, 0.32240684E-15_JPRB, &
  & 0.21008154E-15_JPRB, 0.16255428E-15_JPRB, 0.12978572E-15_JPRB, 0.10816295E-15_JPRB, 0.92539501E-16_JPRB, 0.80430788E-16_JPRB, &
  & 0.65141658E-16_JPRB, 0.58393068E-16_JPRB, 0.46614129E-16_JPRB, 0.43757411E-16_JPRB, 0.47082293E-16_JPRB, 0.53682252E-16_JPRB, &
  & 0.63087676E-16_JPRB, 0.81499783E-16_JPRB, 0.11263558E-15_JPRB, 0.17720085E-15_JPRB /)

RGHG5(:,14, 8) = (/ &
  & 0.46732613E-15_JPRB, 0.63258385E-15_JPRB, 0.68856266E-15_JPRB, 0.70153106E-15_JPRB, 0.68997663E-15_JPRB, 0.67377511E-15_JPRB, &
  & 0.67080822E-15_JPRB, 0.69900759E-15_JPRB, 0.77525336E-15_JPRB, 0.91705568E-15_JPRB, 0.11426567E-14_JPRB, 0.14581422E-14_JPRB, &
  & 0.18716197E-14_JPRB, 0.23674512E-14_JPRB, 0.29187491E-14_JPRB, 0.34816718E-14_JPRB, 0.40140104E-14_JPRB, 0.44832802E-14_JPRB, &
  & 0.48397891E-14_JPRB, 0.50950163E-14_JPRB, 0.52686894E-14_JPRB, 0.53952492E-14_JPRB, 0.55214859E-14_JPRB, 0.57132131E-14_JPRB, &
  & 0.60246019E-14_JPRB, 0.65535617E-14_JPRB, 0.74536070E-14_JPRB, 0.87131086E-14_JPRB, 0.10898956E-13_JPRB, 0.14186785E-13_JPRB, &
  & 0.17860381E-13_JPRB, 0.25541016E-13_JPRB, 0.30755753E-13_JPRB, 0.43504344E-13_JPRB, 0.54275706E-13_JPRB, 0.49862129E-13_JPRB, &
  & 0.40180821E-13_JPRB, 0.36328328E-13_JPRB, 0.33530365E-13_JPRB, 0.26976337E-13_JPRB, 0.18982266E-13_JPRB, 0.13857152E-13_JPRB, &
  & 0.10990470E-13_JPRB, 0.89640734E-14_JPRB, 0.66802511E-14_JPRB, 0.49196173E-14_JPRB, 0.35134257E-14_JPRB, 0.23157790E-14_JPRB, &
  & 0.16372056E-14_JPRB, 0.12451196E-14_JPRB, 0.10629254E-14_JPRB, 0.93777940E-15_JPRB, 0.84331130E-15_JPRB, 0.74970701E-15_JPRB, &
  & 0.66932586E-15_JPRB, 0.58496169E-15_JPRB, 0.49643436E-15_JPRB, 0.47849648E-15_JPRB, 0.52935218E-15_JPRB, 0.58091621E-15_JPRB, &
  & 0.69652075E-15_JPRB, 0.86206699E-15_JPRB, 0.10386527E-14_JPRB, 0.10850125E-14_JPRB /)

RGHG5(:,15, 8) = (/ &
  & 0.50754206E-14_JPRB, 0.62435002E-14_JPRB, 0.64220539E-14_JPRB, 0.62445975E-14_JPRB, 0.58909384E-14_JPRB, 0.55192485E-14_JPRB, &
  & 0.53081425E-14_JPRB, 0.53959810E-14_JPRB, 0.59076965E-14_JPRB, 0.69711642E-14_JPRB, 0.87273150E-14_JPRB, 0.11257825E-13_JPRB, &
  & 0.14626211E-13_JPRB, 0.18762485E-13_JPRB, 0.23448166E-13_JPRB, 0.28342901E-13_JPRB, 0.33116891E-13_JPRB, 0.37515367E-13_JPRB, &
  & 0.41270942E-13_JPRB, 0.44386895E-13_JPRB, 0.46973855E-13_JPRB, 0.49268522E-13_JPRB, 0.51423333E-13_JPRB, 0.53913088E-13_JPRB, &
  & 0.56983139E-13_JPRB, 0.61113597E-13_JPRB, 0.67103061E-13_JPRB, 0.74771772E-13_JPRB, 0.86095688E-13_JPRB, 0.10081214E-12_JPRB, &
  & 0.12005632E-12_JPRB, 0.14653425E-12_JPRB, 0.16366362E-12_JPRB, 0.18182271E-12_JPRB, 0.17184454E-12_JPRB, 0.18540703E-12_JPRB, &
  & 0.20310854E-12_JPRB, 0.19426443E-12_JPRB, 0.17037046E-12_JPRB, 0.14678372E-12_JPRB, 0.12331888E-12_JPRB, 0.10008762E-12_JPRB, &
  & 0.78873560E-13_JPRB, 0.60262227E-13_JPRB, 0.44606771E-13_JPRB, 0.32537636E-13_JPRB, 0.23749875E-13_JPRB, 0.17567038E-13_JPRB, &
  & 0.13186974E-13_JPRB, 0.10420757E-13_JPRB, 0.87786054E-14_JPRB, 0.78354596E-14_JPRB, 0.71573030E-14_JPRB, 0.64763360E-14_JPRB, &
  & 0.56420543E-14_JPRB, 0.48605618E-14_JPRB, 0.43052279E-14_JPRB, 0.42227841E-14_JPRB, 0.47945707E-14_JPRB, 0.52220979E-14_JPRB, &
  & 0.62709724E-14_JPRB, 0.81265874E-14_JPRB, 0.10180645E-13_JPRB, 0.14571484E-13_JPRB /)

RGHG5(:,16, 8) = (/ &
  & 0.42733937E-13_JPRB, 0.46627361E-13_JPRB, 0.44990799E-13_JPRB, 0.41479014E-13_JPRB, 0.37352828E-13_JPRB, 0.33407003E-13_JPRB, &
  & 0.30755031E-13_JPRB, 0.30127912E-13_JPRB, 0.32135820E-13_JPRB, 0.37422231E-13_JPRB, 0.46717052E-13_JPRB, 0.60638181E-13_JPRB, &
  & 0.79643872E-13_JPRB, 0.10362743E-12_JPRB, 0.13171636E-12_JPRB, 0.16229607E-12_JPRB, 0.19358790E-12_JPRB, 0.22424554E-12_JPRB, &
  & 0.25276284E-12_JPRB, 0.27926907E-12_JPRB, 0.30426700E-12_JPRB, 0.32883147E-12_JPRB, 0.35385367E-12_JPRB, 0.38079804E-12_JPRB, &
  & 0.41059254E-12_JPRB, 0.44412832E-12_JPRB, 0.48247788E-12_JPRB, 0.52366732E-12_JPRB, 0.57033859E-12_JPRB, 0.61788682E-12_JPRB, &
  & 0.67241042E-12_JPRB, 0.72931358E-12_JPRB, 0.77653763E-12_JPRB, 0.82025315E-12_JPRB, 0.86697376E-12_JPRB, 0.85400269E-12_JPRB, &
  & 0.77466701E-12_JPRB, 0.70119680E-12_JPRB, 0.63741341E-12_JPRB, 0.56859351E-12_JPRB, 0.50068462E-12_JPRB, 0.43376926E-12_JPRB, &
  & 0.36532962E-12_JPRB, 0.29991377E-12_JPRB, 0.24050401E-12_JPRB, 0.19086126E-12_JPRB, 0.15044837E-12_JPRB, 0.11961616E-12_JPRB, &
  & 0.95800917E-13_JPRB, 0.78142164E-13_JPRB, 0.64972082E-13_JPRB, 0.55083596E-13_JPRB, 0.47584417E-13_JPRB, 0.42039746E-13_JPRB, &
  & 0.38596574E-13_JPRB, 0.36223791E-13_JPRB, 0.34504582E-13_JPRB, 0.34429311E-13_JPRB, 0.37021120E-13_JPRB, 0.41999292E-13_JPRB, &
  & 0.48518420E-13_JPRB, 0.54345813E-13_JPRB, 0.71012810E-13_JPRB, 0.91822376E-13_JPRB /)

RGHG5(:,17, 8) = (/ &
  & 0.26749604E-12_JPRB, 0.25624752E-12_JPRB, 0.23011627E-12_JPRB, 0.20182423E-12_JPRB, 0.17448086E-12_JPRB, 0.15066853E-12_JPRB, &
  & 0.13373853E-12_JPRB, 0.12640826E-12_JPRB, 0.13095499E-12_JPRB, 0.14964562E-12_JPRB, 0.18540283E-12_JPRB, 0.24102839E-12_JPRB, &
  & 0.31914822E-12_JPRB, 0.42050597E-12_JPRB, 0.54292432E-12_JPRB, 0.68131557E-12_JPRB, 0.82924921E-12_JPRB, 0.98103448E-12_JPRB, &
  & 0.11312563E-11_JPRB, 0.12795862E-11_JPRB, 0.14297699E-11_JPRB, 0.15869797E-11_JPRB, 0.17580408E-11_JPRB, 0.19459922E-11_JPRB, &
  & 0.21522157E-11_JPRB, 0.23671187E-11_JPRB, 0.25813223E-11_JPRB, 0.27629372E-11_JPRB, 0.28996525E-11_JPRB, 0.29619367E-11_JPRB, &
  & 0.29688372E-11_JPRB, 0.29189407E-11_JPRB, 0.28353841E-11_JPRB, 0.26930175E-11_JPRB, 0.24819168E-11_JPRB, 0.22558648E-11_JPRB, &
  & 0.21233280E-11_JPRB, 0.20055151E-11_JPRB, 0.18901935E-11_JPRB, 0.17903732E-11_JPRB, 0.16819165E-11_JPRB, 0.15560000E-11_JPRB, &
  & 0.14126503E-11_JPRB, 0.12556579E-11_JPRB, 0.10915470E-11_JPRB, 0.93261889E-12_JPRB, 0.78750331E-12_JPRB, 0.66557925E-12_JPRB, &
  & 0.56207323E-12_JPRB, 0.47683802E-12_JPRB, 0.40719012E-12_JPRB, 0.35057038E-12_JPRB, 0.30439380E-12_JPRB, 0.26888124E-12_JPRB, &
  & 0.24537460E-12_JPRB, 0.23258167E-12_JPRB, 0.22850957E-12_JPRB, 0.23053627E-12_JPRB, 0.23805445E-12_JPRB, 0.25442587E-12_JPRB, &
  & 0.28196559E-12_JPRB, 0.31965649E-12_JPRB, 0.36633213E-12_JPRB, 0.49296228E-12_JPRB /)

RGHG5(:,18, 8) = (/ &
  & 0.10637776E-11_JPRB, 0.94577308E-12_JPRB, 0.80746119E-12_JPRB, 0.69830903E-12_JPRB, 0.59388405E-12_JPRB, 0.50827360E-12_JPRB, &
  & 0.44382621E-12_JPRB, 0.41086503E-12_JPRB, 0.41609077E-12_JPRB, 0.46624185E-12_JPRB, 0.57004797E-12_JPRB, 0.73696355E-12_JPRB, &
  & 0.97590967E-12_JPRB, 0.12919532E-11_JPRB, 0.16820800E-11_JPRB, 0.21339462E-11_JPRB, 0.26296020E-11_JPRB, 0.31538079E-11_JPRB, &
  & 0.36917782E-11_JPRB, 0.42433392E-11_JPRB, 0.48202904E-11_JPRB, 0.54519670E-11_JPRB, 0.61654011E-11_JPRB, 0.69570022E-11_JPRB, &
  & 0.77828135E-11_JPRB, 0.86201532E-11_JPRB, 0.93756183E-11_JPRB, 0.99329650E-11_JPRB, 0.10177383E-10_JPRB, 0.10087482E-10_JPRB, &
  & 0.96687562E-11_JPRB, 0.90104764E-11_JPRB, 0.82117247E-11_JPRB, 0.73394416E-11_JPRB, 0.65106059E-11_JPRB, 0.58277194E-11_JPRB, &
  & 0.52826480E-11_JPRB, 0.49345051E-11_JPRB, 0.47812834E-11_JPRB, 0.47396631E-11_JPRB, 0.47309838E-11_JPRB, 0.46925267E-11_JPRB, &
  & 0.45630418E-11_JPRB, 0.43266142E-11_JPRB, 0.40035184E-11_JPRB, 0.36267259E-11_JPRB, 0.32319926E-11_JPRB, 0.28548236E-11_JPRB, &
  & 0.24972940E-11_JPRB, 0.21768175E-11_JPRB, 0.18959073E-11_JPRB, 0.16555006E-11_JPRB, 0.14525038E-11_JPRB, 0.12877763E-11_JPRB, &
  & 0.11633786E-11_JPRB, 0.10760508E-11_JPRB, 0.10266301E-11_JPRB, 0.10129896E-11_JPRB, 0.10274356E-11_JPRB, 0.10666809E-11_JPRB, &
  & 0.11320979E-11_JPRB, 0.12326105E-11_JPRB, 0.13876528E-11_JPRB, 0.17221016E-11_JPRB /)

RGHG5(:,19, 8) = (/ &
  & 0.27654953E-11_JPRB, 0.24220493E-11_JPRB, 0.20531248E-11_JPRB, 0.17957424E-11_JPRB, 0.15405522E-11_JPRB, 0.13302317E-11_JPRB, &
  & 0.11676418E-11_JPRB, 0.10752790E-11_JPRB, 0.10733157E-11_JPRB, 0.11789820E-11_JPRB, 0.14131017E-11_JPRB, 0.17979347E-11_JPRB, &
  & 0.23550723E-11_JPRB, 0.30966063E-11_JPRB, 0.40191604E-11_JPRB, 0.50984208E-11_JPRB, 0.62950027E-11_JPRB, 0.75720610E-11_JPRB, &
  & 0.89050703E-11_JPRB, 0.10297952E-10_JPRB, 0.11764352E-10_JPRB, 0.13345123E-10_JPRB, 0.15111560E-10_JPRB, 0.17068999E-10_JPRB, &
  & 0.19200379E-10_JPRB, 0.21351429E-10_JPRB, 0.23230095E-10_JPRB, 0.24479391E-10_JPRB, 0.24823794E-10_JPRB, 0.24192587E-10_JPRB, &
  & 0.22714771E-10_JPRB, 0.20626632E-10_JPRB, 0.18282282E-10_JPRB, 0.15848794E-10_JPRB, 0.13666131E-10_JPRB, 0.11964858E-10_JPRB, &
  & 0.10785674E-10_JPRB, 0.10190121E-10_JPRB, 0.10124087E-10_JPRB, 0.10416881E-10_JPRB, 0.10865892E-10_JPRB, 0.11262550E-10_JPRB, &
  & 0.11457340E-10_JPRB, 0.11390159E-10_JPRB, 0.11045002E-10_JPRB, 0.10451374E-10_JPRB, 0.96829931E-11_JPRB, 0.88274466E-11_JPRB, &
  & 0.79280220E-11_JPRB, 0.70463800E-11_JPRB, 0.62197925E-11_JPRB, 0.54780694E-11_JPRB, 0.48365079E-11_JPRB, 0.43079130E-11_JPRB, &
  & 0.38931081E-11_JPRB, 0.35799191E-11_JPRB, 0.33657101E-11_JPRB, 0.32488044E-11_JPRB, 0.32200388E-11_JPRB, 0.32708359E-11_JPRB, &
  & 0.33894773E-11_JPRB, 0.35779459E-11_JPRB, 0.38961113E-11_JPRB, 0.45958393E-11_JPRB /)

RGHG5(:,20, 8) = (/ &
  & 0.56477730E-11_JPRB, 0.48800118E-11_JPRB, 0.42300352E-11_JPRB, 0.37328595E-11_JPRB, 0.32724405E-11_JPRB, 0.28678975E-11_JPRB, &
  & 0.25523869E-11_JPRB, 0.23567975E-11_JPRB, 0.23279581E-11_JPRB, 0.25039066E-11_JPRB, 0.29233250E-11_JPRB, 0.36247793E-11_JPRB, &
  & 0.46422432E-11_JPRB, 0.59934540E-11_JPRB, 0.76650535E-11_JPRB, 0.96088016E-11_JPRB, 0.11754191E-10_JPRB, 0.14028055E-10_JPRB, &
  & 0.16376242E-10_JPRB, 0.18811862E-10_JPRB, 0.21392535E-10_JPRB, 0.24153190E-10_JPRB, 0.27183374E-10_JPRB, 0.30551065E-10_JPRB, &
  & 0.34208358E-10_JPRB, 0.37903503E-10_JPRB, 0.41124510E-10_JPRB, 0.43290121E-10_JPRB, 0.43905258E-10_JPRB, 0.42896079E-10_JPRB, &
  & 0.40419543E-10_JPRB, 0.36854683E-10_JPRB, 0.32747981E-10_JPRB, 0.28496042E-10_JPRB, 0.24645437E-10_JPRB, 0.21628659E-10_JPRB, &
  & 0.19730981E-10_JPRB, 0.18887357E-10_JPRB, 0.18930380E-10_JPRB, 0.19669032E-10_JPRB, 0.20763037E-10_JPRB, 0.21854019E-10_JPRB, &
  & 0.22689239E-10_JPRB, 0.23080423E-10_JPRB, 0.22937390E-10_JPRB, 0.22283838E-10_JPRB, 0.21196768E-10_JPRB, 0.19798958E-10_JPRB, &
  & 0.18164295E-10_JPRB, 0.16439657E-10_JPRB, 0.14745184E-10_JPRB, 0.13164269E-10_JPRB, 0.11756663E-10_JPRB, 0.10564020E-10_JPRB, &
  & 0.96023215E-11_JPRB, 0.88560600E-11_JPRB, 0.83138314E-11_JPRB, 0.79617190E-11_JPRB, 0.77805488E-11_JPRB, 0.77635858E-11_JPRB, &
  & 0.79009924E-11_JPRB, 0.81928119E-11_JPRB, 0.86918554E-11_JPRB, 0.98079505E-11_JPRB /)

RGHG5(:,21, 8) = (/ &
  & 0.98955020E-11_JPRB, 0.85160542E-11_JPRB, 0.75462111E-11_JPRB, 0.67535352E-11_JPRB, 0.60076818E-11_JPRB, 0.53550359E-11_JPRB, &
  & 0.48203750E-11_JPRB, 0.44756672E-11_JPRB, 0.43805150E-11_JPRB, 0.46118079E-11_JPRB, 0.52247781E-11_JPRB, 0.62719959E-11_JPRB, &
  & 0.77929338E-11_JPRB, 0.97974840E-11_JPRB, 0.12255143E-10_JPRB, 0.15084855E-10_JPRB, 0.18178452E-10_JPRB, 0.21441977E-10_JPRB, &
  & 0.24809861E-10_JPRB, 0.28265416E-10_JPRB, 0.31893797E-10_JPRB, 0.35786728E-10_JPRB, 0.40025365E-10_JPRB, 0.44720446E-10_JPRB, &
  & 0.49817470E-10_JPRB, 0.54980045E-10_JPRB, 0.59554910E-10_JPRB, 0.62765626E-10_JPRB, 0.64030531E-10_JPRB, 0.63199231E-10_JPRB, &
  & 0.60373193E-10_JPRB, 0.56001242E-10_JPRB, 0.50712844E-10_JPRB, 0.45080523E-10_JPRB, 0.39853985E-10_JPRB, 0.35702795E-10_JPRB, &
  & 0.32941771E-10_JPRB, 0.31730934E-10_JPRB, 0.31882032E-10_JPRB, 0.32990426E-10_JPRB, 0.34612459E-10_JPRB, 0.36341465E-10_JPRB, &
  & 0.37769999E-10_JPRB, 0.38604668E-10_JPRB, 0.38740389E-10_JPRB, 0.38132452E-10_JPRB, 0.36796850E-10_JPRB, 0.34890597E-10_JPRB, &
  & 0.32541893E-10_JPRB, 0.29967431E-10_JPRB, 0.27328310E-10_JPRB, 0.24775798E-10_JPRB, 0.22447299E-10_JPRB, 0.20427222E-10_JPRB, &
  & 0.18755920E-10_JPRB, 0.17424546E-10_JPRB, 0.16421973E-10_JPRB, 0.15724817E-10_JPRB, 0.15297343E-10_JPRB, 0.15119787E-10_JPRB, &
  & 0.15183393E-10_JPRB, 0.15497272E-10_JPRB, 0.16162943E-10_JPRB, 0.17534097E-10_JPRB /)

RGHG5(:,22, 8) = (/ &
  & 0.15624930E-10_JPRB, 0.13548200E-10_JPRB, 0.12200297E-10_JPRB, 0.11033503E-10_JPRB, 0.99715262E-11_JPRB, 0.89805698E-11_JPRB, &
  & 0.81589683E-11_JPRB, 0.75917059E-11_JPRB, 0.73770356E-11_JPRB, 0.76101148E-11_JPRB, 0.83687059E-11_JPRB, 0.97091068E-11_JPRB, &
  & 0.11668104E-10_JPRB, 0.14242912E-10_JPRB, 0.17378710E-10_JPRB, 0.20971072E-10_JPRB, 0.24890246E-10_JPRB, 0.29009326E-10_JPRB, &
  & 0.33250826E-10_JPRB, 0.37629143E-10_JPRB, 0.42176432E-10_JPRB, 0.47049489E-10_JPRB, 0.52353559E-10_JPRB, 0.58192756E-10_JPRB, &
  & 0.64534572E-10_JPRB, 0.70998263E-10_JPRB, 0.76833165E-10_JPRB, 0.81198513E-10_JPRB, 0.83427501E-10_JPRB, 0.83320163E-10_JPRB, &
  & 0.80983269E-10_JPRB, 0.76811273E-10_JPRB, 0.71372755E-10_JPRB, 0.65371902E-10_JPRB, 0.59645851E-10_JPRB, 0.54934533E-10_JPRB, &
  & 0.51687172E-10_JPRB, 0.50060966E-10_JPRB, 0.49931809E-10_JPRB, 0.50957724E-10_JPRB, 0.52585887E-10_JPRB, 0.54406455E-10_JPRB, &
  & 0.55866842E-10_JPRB, 0.56772094E-10_JPRB, 0.56898299E-10_JPRB, 0.56131672E-10_JPRB, 0.54522269E-10_JPRB, 0.52205833E-10_JPRB, &
  & 0.49279164E-10_JPRB, 0.45964552E-10_JPRB, 0.42505617E-10_JPRB, 0.39128856E-10_JPRB, 0.36004932E-10_JPRB, 0.33240004E-10_JPRB, &
  & 0.30894166E-10_JPRB, 0.28968354E-10_JPRB, 0.27458213E-10_JPRB, 0.26348050E-10_JPRB, 0.25606479E-10_JPRB, 0.25215450E-10_JPRB, &
  & 0.25159874E-10_JPRB, 0.25418575E-10_JPRB, 0.26094567E-10_JPRB, 0.27582058E-10_JPRB /)

RGHG5(:,23, 8) = (/ &
  & 0.22922286E-10_JPRB, 0.20067193E-10_JPRB, 0.18303433E-10_JPRB, 0.16762879E-10_JPRB, 0.15280834E-10_JPRB, 0.13916254E-10_JPRB, &
  & 0.12722386E-10_JPRB, 0.11859582E-10_JPRB, 0.11458803E-10_JPRB, 0.11620398E-10_JPRB, 0.12448227E-10_JPRB, 0.13996557E-10_JPRB, &
  & 0.16290131E-10_JPRB, 0.19311211E-10_JPRB, 0.22992538E-10_JPRB, 0.27205550E-10_JPRB, 0.31804073E-10_JPRB, 0.36669084E-10_JPRB, &
  & 0.41680548E-10_JPRB, 0.46866039E-10_JPRB, 0.52262090E-10_JPRB, 0.57987257E-10_JPRB, 0.64213100E-10_JPRB, 0.71011114E-10_JPRB, &
  & 0.78357043E-10_JPRB, 0.85788432E-10_JPRB, 0.92600198E-10_JPRB, 0.97959897E-10_JPRB, 0.10134073E-09_JPRB, 0.10247667E-09_JPRB, &
  & 0.10138236E-09_JPRB, 0.98370347E-10_JPRB, 0.93939106E-10_JPRB, 0.88728871E-10_JPRB, 0.83472396E-10_JPRB, 0.78982633E-10_JPRB, &
  & 0.75696623E-10_JPRB, 0.73815058E-10_JPRB, 0.73265824E-10_JPRB, 0.73610944E-10_JPRB, 0.74488131E-10_JPRB, 0.75513353E-10_JPRB, &
  & 0.76363020E-10_JPRB, 0.76617490E-10_JPRB, 0.76153660E-10_JPRB, 0.74909960E-10_JPRB, 0.72797712E-10_JPRB, 0.69928140E-10_JPRB, &
  & 0.66451240E-10_JPRB, 0.62625106E-10_JPRB, 0.58669083E-10_JPRB, 0.54781277E-10_JPRB, 0.51132272E-10_JPRB, 0.47848392E-10_JPRB, &
  & 0.45003612E-10_JPRB, 0.42607144E-10_JPRB, 0.40657464E-10_JPRB, 0.39142932E-10_JPRB, 0.38049227E-10_JPRB, 0.37372747E-10_JPRB, &
  & 0.37121750E-10_JPRB, 0.37283947E-10_JPRB, 0.37715723E-10_JPRB, 0.38801105E-10_JPRB /)

RGHG5(:,24, 8) = (/ &
  & 0.31590418E-10_JPRB, 0.28094492E-10_JPRB, 0.25889443E-10_JPRB, 0.23947500E-10_JPRB, 0.22085476E-10_JPRB, 0.20284557E-10_JPRB, &
  & 0.18690854E-10_JPRB, 0.17482030E-10_JPRB, 0.16836109E-10_JPRB, 0.16883848E-10_JPRB, 0.17732971E-10_JPRB, 0.19432412E-10_JPRB, &
  & 0.22000924E-10_JPRB, 0.25404505E-10_JPRB, 0.29561912E-10_JPRB, 0.34345450E-10_JPRB, 0.39581945E-10_JPRB, 0.45137481E-10_JPRB, &
  & 0.50894424E-10_JPRB, 0.56842465E-10_JPRB, 0.63026147E-10_JPRB, 0.69530881E-10_JPRB, 0.76481266E-10_JPRB, 0.83959242E-10_JPRB, &
  & 0.91891751E-10_JPRB, 0.99910948E-10_JPRB, 0.10735038E-09_JPRB, 0.11356441E-09_JPRB, 0.11794241E-09_JPRB, 0.12036327E-09_JPRB, &
  & 0.12090492E-09_JPRB, 0.11973941E-09_JPRB, 0.11726081E-09_JPRB, 0.11385152E-09_JPRB, 0.11016476E-09_JPRB, 0.10672432E-09_JPRB, &
  & 0.10387750E-09_JPRB, 0.10185770E-09_JPRB, 0.10049435E-09_JPRB, 0.99725186E-10_JPRB, 0.99184751E-10_JPRB, 0.98736519E-10_JPRB, &
  & 0.98088031E-10_JPRB, 0.97141364E-10_JPRB, 0.95591188E-10_JPRB, 0.93393834E-10_JPRB, 0.90567776E-10_JPRB, 0.87193856E-10_JPRB, &
  & 0.83327525E-10_JPRB, 0.79138467E-10_JPRB, 0.74840634E-10_JPRB, 0.70631528E-10_JPRB, 0.66683083E-10_JPRB, 0.63111849E-10_JPRB, &
  & 0.59975289E-10_JPRB, 0.57277627E-10_JPRB, 0.55019586E-10_JPRB, 0.53198466E-10_JPRB, 0.51808918E-10_JPRB, 0.50858769E-10_JPRB, &
  & 0.50346938E-10_JPRB, 0.50226927E-10_JPRB, 0.50356087E-10_JPRB, 0.50935305E-10_JPRB /)

RGHG5(:,25, 8) = (/ &
  & 0.41211288E-10_JPRB, 0.37254658E-10_JPRB, 0.34803507E-10_JPRB, 0.32558099E-10_JPRB, 0.30380937E-10_JPRB, 0.28229852E-10_JPRB, &
  & 0.26282830E-10_JPRB, 0.24754490E-10_JPRB, 0.23880427E-10_JPRB, 0.23831546E-10_JPRB, 0.24705541E-10_JPRB, 0.26574401E-10_JPRB, &
  & 0.29441973E-10_JPRB, 0.33266445E-10_JPRB, 0.37954376E-10_JPRB, 0.43359871E-10_JPRB, 0.49295710E-10_JPRB, 0.55580478E-10_JPRB, &
  & 0.62078787E-10_JPRB, 0.68735170E-10_JPRB, 0.75567719E-10_JPRB, 0.82642657E-10_JPRB, 0.90026084E-10_JPRB, 0.97771416E-10_JPRB, &
  & 0.10576941E-09_JPRB, 0.11373516E-09_JPRB, 0.12117059E-09_JPRB, 0.12757981E-09_JPRB, 0.13283322E-09_JPRB, 0.13664343E-09_JPRB, &
  & 0.13894373E-09_JPRB, 0.13986524E-09_JPRB, 0.13966543E-09_JPRB, 0.13851709E-09_JPRB, 0.13678636E-09_JPRB, 0.13476356E-09_JPRB, &
  & 0.13268553E-09_JPRB, 0.13068849E-09_JPRB, 0.12856390E-09_JPRB, 0.12658878E-09_JPRB, 0.12444390E-09_JPRB, 0.12223850E-09_JPRB, &
  & 0.11978811E-09_JPRB, 0.11717631E-09_JPRB, 0.11427077E-09_JPRB, 0.11098379E-09_JPRB, 0.10723936E-09_JPRB, 0.10315825E-09_JPRB, &
  & 0.98856701E-10_JPRB, 0.94451218E-10_JPRB, 0.90054318E-10_JPRB, 0.85799791E-10_JPRB, 0.81813216E-10_JPRB, 0.78178082E-10_JPRB, &
  & 0.74929611E-10_JPRB, 0.72074020E-10_JPRB, 0.69618117E-10_JPRB, 0.67570498E-10_JPRB, 0.65939504E-10_JPRB, 0.64734426E-10_JPRB, &
  & 0.63969531E-10_JPRB, 0.63488409E-10_JPRB, 0.63267121E-10_JPRB, 0.63369081E-10_JPRB /)

RGHG5(:,26, 8) = (/ &
  & 0.51477263E-10_JPRB, 0.47441412E-10_JPRB, 0.44834077E-10_JPRB, 0.42527665E-10_JPRB, 0.40153401E-10_JPRB, 0.37850931E-10_JPRB, &
  & 0.35684698E-10_JPRB, 0.33967443E-10_JPRB, 0.32966758E-10_JPRB, 0.32902531E-10_JPRB, 0.33901233E-10_JPRB, 0.36035216E-10_JPRB, &
  & 0.39308286E-10_JPRB, 0.43673735E-10_JPRB, 0.49016312E-10_JPRB, 0.55163936E-10_JPRB, 0.61874825E-10_JPRB, 0.68920064E-10_JPRB, &
  & 0.76106066E-10_JPRB, 0.83346968E-10_JPRB, 0.90591736E-10_JPRB, 0.97881300E-10_JPRB, 0.10524923E-09_JPRB, 0.11273874E-09_JPRB, &
  & 0.12026787E-09_JPRB, 0.12768411E-09_JPRB, 0.13481016E-09_JPRB, 0.14132089E-09_JPRB, 0.14687913E-09_JPRB, 0.15149440E-09_JPRB, &
  & 0.15519161E-09_JPRB, 0.15795537E-09_JPRB, 0.15982382E-09_JPRB, 0.16076247E-09_JPRB, 0.16088313E-09_JPRB, 0.16025359E-09_JPRB, &
  & 0.15892432E-09_JPRB, 0.15697610E-09_JPRB, 0.15433384E-09_JPRB, 0.15121626E-09_JPRB, 0.14764540E-09_JPRB, 0.14379800E-09_JPRB, &
  & 0.13976949E-09_JPRB, 0.13561718E-09_JPRB, 0.13136836E-09_JPRB, 0.12702349E-09_JPRB, 0.12260520E-09_JPRB, 0.11810786E-09_JPRB, &
  & 0.11353073E-09_JPRB, 0.10896801E-09_JPRB, 0.10452333E-09_JPRB, 0.10029352E-09_JPRB, 0.96351864E-10_JPRB, 0.92743875E-10_JPRB, &
  & 0.89484434E-10_JPRB, 0.86577835E-10_JPRB, 0.84032559E-10_JPRB, 0.81859235E-10_JPRB, 0.80062325E-10_JPRB, 0.78650086E-10_JPRB, &
  & 0.77587915E-10_JPRB, 0.76780922E-10_JPRB, 0.76163728E-10_JPRB, 0.75574012E-10_JPRB /)

RGHG5(:,27, 8) = (/ &
  & 0.62271285E-10_JPRB, 0.58410284E-10_JPRB, 0.55949280E-10_JPRB, 0.53618041E-10_JPRB, 0.51391891E-10_JPRB, 0.49066640E-10_JPRB, &
  & 0.46936132E-10_JPRB, 0.45223575E-10_JPRB, 0.44277124E-10_JPRB, 0.44354645E-10_JPRB, 0.45621840E-10_JPRB, 0.48144336E-10_JPRB, &
  & 0.51946662E-10_JPRB, 0.56960343E-10_JPRB, 0.63047977E-10_JPRB, 0.69983769E-10_JPRB, 0.77469059E-10_JPRB, 0.85189522E-10_JPRB, &
  & 0.92919762E-10_JPRB, 0.10045730E-09_JPRB, 0.10778275E-09_JPRB, 0.11486388E-09_JPRB, 0.12173906E-09_JPRB, 0.12849621E-09_JPRB, &
  & 0.13508172E-09_JPRB, 0.14149659E-09_JPRB, 0.14764630E-09_JPRB, 0.15355757E-09_JPRB, 0.15927989E-09_JPRB, 0.16461824E-09_JPRB, &
  & 0.16942439E-09_JPRB, 0.17360136E-09_JPRB, 0.17703142E-09_JPRB, 0.17951345E-09_JPRB, 0.18097984E-09_JPRB, 0.18134924E-09_JPRB, &
  & 0.18057819E-09_JPRB, 0.17869414E-09_JPRB, 0.17574452E-09_JPRB, 0.17185253E-09_JPRB, 0.16731158E-09_JPRB, 0.16227836E-09_JPRB, &
  & 0.15706850E-09_JPRB, 0.15175639E-09_JPRB, 0.14647616E-09_JPRB, 0.14123837E-09_JPRB, 0.13615248E-09_JPRB, 0.13127902E-09_JPRB, &
  & 0.12662328E-09_JPRB, 0.12214625E-09_JPRB, 0.11785331E-09_JPRB, 0.11379597E-09_JPRB, 0.11001618E-09_JPRB, 0.10653604E-09_JPRB, &
  & 0.10335721E-09_JPRB, 0.10047770E-09_JPRB, 0.97901069E-10_JPRB, 0.95638449E-10_JPRB, 0.93708236E-10_JPRB, 0.92118403E-10_JPRB, &
  & 0.90807674E-10_JPRB, 0.89739764E-10_JPRB, 0.88810653E-10_JPRB, 0.87638660E-10_JPRB /)

RGHG5(:,28, 8) = (/ &
  & 0.73660335E-10_JPRB, 0.70160912E-10_JPRB, 0.67863118E-10_JPRB, 0.65855349E-10_JPRB, 0.63737592E-10_JPRB, 0.61703018E-10_JPRB, &
  & 0.59755277E-10_JPRB, 0.58271651E-10_JPRB, 0.57577249E-10_JPRB, 0.57968276E-10_JPRB, 0.59631938E-10_JPRB, 0.62659732E-10_JPRB, &
  & 0.67048728E-10_JPRB, 0.72727463E-10_JPRB, 0.79513243E-10_JPRB, 0.87140260E-10_JPRB, 0.95221976E-10_JPRB, 0.10341603E-09_JPRB, &
  & 0.11139921E-09_JPRB, 0.11895807E-09_JPRB, 0.12603349E-09_JPRB, 0.13254257E-09_JPRB, 0.13866239E-09_JPRB, 0.14438424E-09_JPRB, &
  & 0.14980829E-09_JPRB, 0.15504499E-09_JPRB, 0.16024038E-09_JPRB, 0.16552780E-09_JPRB, 0.17097308E-09_JPRB, 0.17647506E-09_JPRB, &
  & 0.18187579E-09_JPRB, 0.18691558E-09_JPRB, 0.19131013E-09_JPRB, 0.19473131E-09_JPRB, 0.19698781E-09_JPRB, 0.19792562E-09_JPRB, &
  & 0.19747487E-09_JPRB, 0.19564143E-09_JPRB, 0.19254524E-09_JPRB, 0.18828092E-09_JPRB, 0.18317592E-09_JPRB, 0.17749179E-09_JPRB, &
  & 0.17153882E-09_JPRB, 0.16553273E-09_JPRB, 0.15961478E-09_JPRB, 0.15392768E-09_JPRB, 0.14855381E-09_JPRB, 0.14356633E-09_JPRB, &
  & 0.13889934E-09_JPRB, 0.13452378E-09_JPRB, 0.13040249E-09_JPRB, 0.12653754E-09_JPRB, 0.12293715E-09_JPRB, 0.11960086E-09_JPRB, &
  & 0.11651177E-09_JPRB, 0.11366129E-09_JPRB, 0.11104979E-09_JPRB, 0.10869555E-09_JPRB, 0.10663689E-09_JPRB, 0.10485986E-09_JPRB, &
  & 0.10335524E-09_JPRB, 0.10208151E-09_JPRB, 0.10091698E-09_JPRB, 0.99391599E-10_JPRB /)

RGHG5(:,29, 8) = (/ &
  & 0.85543399E-10_JPRB, 0.82442636E-10_JPRB, 0.80502452E-10_JPRB, 0.78681894E-10_JPRB, 0.76979395E-10_JPRB, 0.75203968E-10_JPRB, &
  & 0.73637874E-10_JPRB, 0.72521246E-10_JPRB, 0.72232116E-10_JPRB, 0.73065214E-10_JPRB, 0.75221870E-10_JPRB, 0.78780149E-10_JPRB, &
  & 0.83729967E-10_JPRB, 0.89959810E-10_JPRB, 0.97271705E-10_JPRB, 0.10533880E-09_JPRB, 0.11375212E-09_JPRB, 0.12211486E-09_JPRB, &
  & 0.13008185E-09_JPRB, 0.13740226E-09_JPRB, 0.14400311E-09_JPRB, 0.14984472E-09_JPRB, 0.15504695E-09_JPRB, 0.15968227E-09_JPRB, &
  & 0.16391649E-09_JPRB, 0.16802945E-09_JPRB, 0.17223932E-09_JPRB, 0.17679423E-09_JPRB, 0.18178539E-09_JPRB, 0.18722815E-09_JPRB, &
  & 0.19281435E-09_JPRB, 0.19823375E-09_JPRB, 0.20308896E-09_JPRB, 0.20694749E-09_JPRB, 0.20955214E-09_JPRB, 0.21072802E-09_JPRB, &
  & 0.21041204E-09_JPRB, 0.20861447E-09_JPRB, 0.20547830E-09_JPRB, 0.20112881E-09_JPRB, 0.19580829E-09_JPRB, 0.18986263E-09_JPRB, &
  & 0.18357522E-09_JPRB, 0.17723743E-09_JPRB, 0.17103868E-09_JPRB, 0.16517551E-09_JPRB, 0.15976617E-09_JPRB, 0.15484242E-09_JPRB, &
  & 0.15033863E-09_JPRB, 0.14615993E-09_JPRB, 0.14224849E-09_JPRB, 0.13858309E-09_JPRB, 0.13515825E-09_JPRB, 0.13195543E-09_JPRB, &
  & 0.12895315E-09_JPRB, 0.12614650E-09_JPRB, 0.12355024E-09_JPRB, 0.12120598E-09_JPRB, 0.11913900E-09_JPRB, 0.11733206E-09_JPRB, &
  & 0.11578120E-09_JPRB, 0.11442952E-09_JPRB, 0.11312109E-09_JPRB, 0.11107711E-09_JPRB /)

RGHG5(:,30, 8) = (/ &
  & 0.97588257E-10_JPRB, 0.94961990E-10_JPRB, 0.93292971E-10_JPRB, 0.91865127E-10_JPRB, 0.90409187E-10_JPRB, 0.89063409E-10_JPRB, &
  & 0.87889147E-10_JPRB, 0.87234164E-10_JPRB, 0.87430174E-10_JPRB, 0.88767077E-10_JPRB, 0.91422141E-10_JPRB, 0.95474406E-10_JPRB, &
  & 0.10086805E-09_JPRB, 0.10747669E-09_JPRB, 0.11506369E-09_JPRB, 0.12329308E-09_JPRB, 0.13172824E-09_JPRB, 0.13999998E-09_JPRB, &
  & 0.14772195E-09_JPRB, 0.15464861E-09_JPRB, 0.16069840E-09_JPRB, 0.16583898E-09_JPRB, 0.17015336E-09_JPRB, 0.17382368E-09_JPRB, &
  & 0.17707621E-09_JPRB, 0.18022711E-09_JPRB, 0.18360316E-09_JPRB, 0.18746757E-09_JPRB, 0.19196883E-09_JPRB, 0.19706500E-09_JPRB, &
  & 0.20255152E-09_JPRB, 0.20799631E-09_JPRB, 0.21292054E-09_JPRB, 0.21685517E-09_JPRB, 0.21950214E-09_JPRB, 0.22069863E-09_JPRB, &
  & 0.22040605E-09_JPRB, 0.21865366E-09_JPRB, 0.21555589E-09_JPRB, 0.21130367E-09_JPRB, 0.20603617E-09_JPRB, 0.20010212E-09_JPRB, &
  & 0.19381068E-09_JPRB, 0.18745538E-09_JPRB, 0.18130353E-09_JPRB, 0.17552725E-09_JPRB, 0.17024940E-09_JPRB, 0.16549569E-09_JPRB, &
  & 0.16117729E-09_JPRB, 0.15719027E-09_JPRB, 0.15347416E-09_JPRB, 0.14998773E-09_JPRB, 0.14671016E-09_JPRB, 0.14362689E-09_JPRB, &
  & 0.14071194E-09_JPRB, 0.13797435E-09_JPRB, 0.13544178E-09_JPRB, 0.13314111E-09_JPRB, 0.13106297E-09_JPRB, 0.12920753E-09_JPRB, &
  & 0.12756826E-09_JPRB, 0.12608344E-09_JPRB, 0.12457622E-09_JPRB, 0.12236161E-09_JPRB /)

RGHG5(:,31, 8) = (/ &
  & 0.10948007E-09_JPRB, 0.10729657E-09_JPRB, 0.10594396E-09_JPRB, 0.10474381E-09_JPRB, 0.10367195E-09_JPRB, 0.10266232E-09_JPRB, &
  & 0.10193611E-09_JPRB, 0.10176004E-09_JPRB, 0.10245962E-09_JPRB, 0.10429037E-09_JPRB, 0.10740858E-09_JPRB, 0.11184079E-09_JPRB, &
  & 0.11753518E-09_JPRB, 0.12430722E-09_JPRB, 0.13192775E-09_JPRB, 0.14004996E-09_JPRB, 0.14828549E-09_JPRB, 0.15623779E-09_JPRB, &
  & 0.16358832E-09_JPRB, 0.17007194E-09_JPRB, 0.17557747E-09_JPRB, 0.18009444E-09_JPRB, 0.18371396E-09_JPRB, 0.18664077E-09_JPRB, &
  & 0.18915611E-09_JPRB, 0.19159685E-09_JPRB, 0.19429873E-09_JPRB, 0.19755525E-09_JPRB, 0.20154602E-09_JPRB, 0.20623864E-09_JPRB, &
  & 0.21141061E-09_JPRB, 0.21660558E-09_JPRB, 0.22133043E-09_JPRB, 0.22507829E-09_JPRB, 0.22756680E-09_JPRB, 0.22865290E-09_JPRB, &
  & 0.22832965E-09_JPRB, 0.22664035E-09_JPRB, 0.22369306E-09_JPRB, 0.21961533E-09_JPRB, 0.21462392E-09_JPRB, 0.20891261E-09_JPRB, &
  & 0.20283931E-09_JPRB, 0.19671396E-09_JPRB, 0.19077455E-09_JPRB, 0.18522971E-09_JPRB, 0.18019382E-09_JPRB, 0.17567786E-09_JPRB, &
  & 0.17157092E-09_JPRB, 0.16777507E-09_JPRB, 0.16422047E-09_JPRB, 0.16086807E-09_JPRB, 0.15769534E-09_JPRB, 0.15469548E-09_JPRB, &
  & 0.15185278E-09_JPRB, 0.14917750E-09_JPRB, 0.14668609E-09_JPRB, 0.14438417E-09_JPRB, 0.14226943E-09_JPRB, 0.14037038E-09_JPRB, &
  & 0.13869469E-09_JPRB, 0.13719029E-09_JPRB, 0.13569837E-09_JPRB, 0.13334016E-09_JPRB /)

RGHG5(:,32, 8) = (/ &
  & 0.12076577E-09_JPRB, 0.11901519E-09_JPRB, 0.11795369E-09_JPRB, 0.11707994E-09_JPRB, 0.11628676E-09_JPRB, 0.11566587E-09_JPRB, &
  & 0.11535968E-09_JPRB, 0.11565444E-09_JPRB, 0.11683512E-09_JPRB, 0.11911162E-09_JPRB, 0.12258551E-09_JPRB, 0.12727810E-09_JPRB, &
  & 0.13308291E-09_JPRB, 0.13983392E-09_JPRB, 0.14727904E-09_JPRB, 0.15511385E-09_JPRB, 0.16297388E-09_JPRB, 0.17051988E-09_JPRB, &
  & 0.17742838E-09_JPRB, 0.18348038E-09_JPRB, 0.18854231E-09_JPRB, 0.19258814E-09_JPRB, 0.19573383E-09_JPRB, 0.19817160E-09_JPRB, &
  & 0.20021154E-09_JPRB, 0.20218366E-09_JPRB, 0.20442840E-09_JPRB, 0.20721763E-09_JPRB, 0.21071843E-09_JPRB, 0.21493525E-09_JPRB, &
  & 0.21963815E-09_JPRB, 0.22440520E-09_JPRB, 0.22871664E-09_JPRB, 0.23209736E-09_JPRB, 0.23429253E-09_JPRB, 0.23518892E-09_JPRB, &
  & 0.23481589E-09_JPRB, 0.23322411E-09_JPRB, 0.23048830E-09_JPRB, 0.22673138E-09_JPRB, 0.22207679E-09_JPRB, 0.21679093E-09_JPRB, &
  & 0.21112477E-09_JPRB, 0.20535687E-09_JPRB, 0.19979496E-09_JPRB, 0.19456800E-09_JPRB, 0.18981344E-09_JPRB, 0.18550635E-09_JPRB, &
  & 0.18158725E-09_JPRB, 0.17793372E-09_JPRB, 0.17449198E-09_JPRB, 0.17123022E-09_JPRB, 0.16812621E-09_JPRB, 0.16517915E-09_JPRB, &
  & 0.16238284E-09_JPRB, 0.15974475E-09_JPRB, 0.15727164E-09_JPRB, 0.15497674E-09_JPRB, 0.15287625E-09_JPRB, 0.15100142E-09_JPRB, &
  & 0.14935352E-09_JPRB, 0.14786714E-09_JPRB, 0.14633485E-09_JPRB, 0.14387713E-09_JPRB /)

RGHG5(:,33, 8) = (/ &
  & 0.13133060E-09_JPRB, 0.13001880E-09_JPRB, 0.12924073E-09_JPRB, 0.12861977E-09_JPRB, 0.12814229E-09_JPRB, 0.12785915E-09_JPRB, &
  & 0.12795580E-09_JPRB, 0.12868906E-09_JPRB, 0.13028793E-09_JPRB, 0.13291490E-09_JPRB, 0.13664217E-09_JPRB, 0.14143223E-09_JPRB, &
  & 0.14720389E-09_JPRB, 0.15376336E-09_JPRB, 0.16089650E-09_JPRB, 0.16830903E-09_JPRB, 0.17572849E-09_JPRB, 0.18281553E-09_JPRB, &
  & 0.18931123E-09_JPRB, 0.19498772E-09_JPRB, 0.19972306E-09_JPRB, 0.20349944E-09_JPRB, 0.20636838E-09_JPRB, 0.20855778E-09_JPRB, &
  & 0.21035398E-09_JPRB, 0.21206976E-09_JPRB, 0.21401705E-09_JPRB, 0.21644599E-09_JPRB, 0.21951967E-09_JPRB, 0.22323837E-09_JPRB, &
  & 0.22740039E-09_JPRB, 0.23159008E-09_JPRB, 0.23534655E-09_JPRB, 0.23823252E-09_JPRB, 0.24004879E-09_JPRB, 0.24071481E-09_JPRB, &
  & 0.24028946E-09_JPRB, 0.23881119E-09_JPRB, 0.23635383E-09_JPRB, 0.23297114E-09_JPRB, 0.22879283E-09_JPRB, 0.22398804E-09_JPRB, &
  & 0.21885128E-09_JPRB, 0.21361890E-09_JPRB, 0.20843602E-09_JPRB, 0.20359965E-09_JPRB, 0.19909446E-09_JPRB, 0.19498954E-09_JPRB, &
  & 0.19119530E-09_JPRB, 0.18764990E-09_JPRB, 0.18426798E-09_JPRB, 0.18104011E-09_JPRB, 0.17796813E-09_JPRB, 0.17504391E-09_JPRB, &
  & 0.17227092E-09_JPRB, 0.16966101E-09_JPRB, 0.16721957E-09_JPRB, 0.16495109E-09_JPRB, 0.16288489E-09_JPRB, 0.16103739E-09_JPRB, &
  & 0.15940581E-09_JPRB, 0.15792054E-09_JPRB, 0.15639326E-09_JPRB, 0.15395969E-09_JPRB /)

RGHG5(:,34, 8) = (/ &
  & 0.14120885E-09_JPRB, 0.14023789E-09_JPRB, 0.13971857E-09_JPRB, 0.13935647E-09_JPRB, 0.13914775E-09_JPRB, 0.13918405E-09_JPRB, &
  & 0.13964270E-09_JPRB, 0.14074324E-09_JPRB, 0.14268045E-09_JPRB, 0.14556108E-09_JPRB, 0.14940146E-09_JPRB, 0.15418015E-09_JPRB, &
  & 0.15977382E-09_JPRB, 0.16604053E-09_JPRB, 0.17276534E-09_JPRB, 0.17972566E-09_JPRB, 0.18665063E-09_JPRB, 0.19331441E-09_JPRB, &
  & 0.19944348E-09_JPRB, 0.20485544E-09_JPRB, 0.20940857E-09_JPRB, 0.21301891E-09_JPRB, 0.21581573E-09_JPRB, 0.21796127E-09_JPRB, &
  & 0.21971561E-09_JPRB, 0.22134783E-09_JPRB, 0.22314059E-09_JPRB, 0.22531191E-09_JPRB, 0.22799262E-09_JPRB, 0.23119967E-09_JPRB, &
  & 0.23473773E-09_JPRB, 0.23826383E-09_JPRB, 0.24135982E-09_JPRB, 0.24367489E-09_JPRB, 0.24506722E-09_JPRB, 0.24548896E-09_JPRB, &
  & 0.24501456E-09_JPRB, 0.24366437E-09_JPRB, 0.24149971E-09_JPRB, 0.23855404E-09_JPRB, 0.23488225E-09_JPRB, 0.23064971E-09_JPRB, &
  & 0.22609314E-09_JPRB, 0.22143168E-09_JPRB, 0.21674815E-09_JPRB, 0.21221028E-09_JPRB, 0.20798760E-09_JPRB, 0.20403036E-09_JPRB, &
  & 0.20031460E-09_JPRB, 0.19681540E-09_JPRB, 0.19346687E-09_JPRB, 0.19023497E-09_JPRB, 0.18716612E-09_JPRB, 0.18425124E-09_JPRB, &
  & 0.18149855E-09_JPRB, 0.17891974E-09_JPRB, 0.17651705E-09_JPRB, 0.17429189E-09_JPRB, 0.17226223E-09_JPRB, 0.17044800E-09_JPRB, &
  & 0.16884964E-09_JPRB, 0.16740798E-09_JPRB, 0.16592756E-09_JPRB, 0.16349760E-09_JPRB /)

RGHG5(:,35, 8) = (/ &
  & 0.15017371E-09_JPRB, 0.14967766E-09_JPRB, 0.14940758E-09_JPRB, 0.14927848E-09_JPRB, 0.14932090E-09_JPRB, 0.14963680E-09_JPRB, &
  & 0.15039262E-09_JPRB, 0.15178928E-09_JPRB, 0.15396671E-09_JPRB, 0.15698179E-09_JPRB, 0.16085211E-09_JPRB, 0.16549610E-09_JPRB, &
  & 0.17084799E-09_JPRB, 0.17674004E-09_JPRB, 0.18303209E-09_JPRB, 0.18950216E-09_JPRB, 0.19597352E-09_JPRB, 0.20221738E-09_JPRB, &
  & 0.20803231E-09_JPRB, 0.21324614E-09_JPRB, 0.21769278E-09_JPRB, 0.22133805E-09_JPRB, 0.22424172E-09_JPRB, 0.22650948E-09_JPRB, &
  & 0.22836741E-09_JPRB, 0.23004487E-09_JPRB, 0.23176946E-09_JPRB, 0.23373342E-09_JPRB, 0.23604713E-09_JPRB, 0.23871446E-09_JPRB, &
  & 0.24158886E-09_JPRB, 0.24437607E-09_JPRB, 0.24676355E-09_JPRB, 0.24848482E-09_JPRB, 0.24944988E-09_JPRB, 0.24964433E-09_JPRB, &
  & 0.24913124E-09_JPRB, 0.24792121E-09_JPRB, 0.24606850E-09_JPRB, 0.24354352E-09_JPRB, 0.24040844E-09_JPRB, 0.23676452E-09_JPRB, &
  & 0.23280776E-09_JPRB, 0.22873337E-09_JPRB, 0.22451474E-09_JPRB, 0.22030600E-09_JPRB, 0.21630629E-09_JPRB, 0.21248873E-09_JPRB, &
  & 0.20882078E-09_JPRB, 0.20533696E-09_JPRB, 0.20199489E-09_JPRB, 0.19874372E-09_JPRB, 0.19566350E-09_JPRB, 0.19276056E-09_JPRB, &
  & 0.19003407E-09_JPRB, 0.18750190E-09_JPRB, 0.18515128E-09_JPRB, 0.18297808E-09_JPRB, 0.18099880E-09_JPRB, 0.17923257E-09_JPRB, &
  & 0.17768129E-09_JPRB, 0.17627873E-09_JPRB, 0.17482372E-09_JPRB, 0.17245783E-09_JPRB /)

RGHG5(:,36, 8) = (/ &
  & 0.15856336E-09_JPRB, 0.15840726E-09_JPRB, 0.15837116E-09_JPRB, 0.15845544E-09_JPRB, 0.15871922E-09_JPRB, 0.15926777E-09_JPRB, &
  & 0.16026215E-09_JPRB, 0.16186529E-09_JPRB, 0.16418278E-09_JPRB, 0.16725551E-09_JPRB, 0.17104315E-09_JPRB, 0.17550618E-09_JPRB, &
  & 0.18054001E-09_JPRB, 0.18604343E-09_JPRB, 0.19186913E-09_JPRB, 0.19787938E-09_JPRB, 0.20388920E-09_JPRB, 0.20976629E-09_JPRB, &
  & 0.21532888E-09_JPRB, 0.22039698E-09_JPRB, 0.22486793E-09_JPRB, 0.22864638E-09_JPRB, 0.23173202E-09_JPRB, 0.23421218E-09_JPRB, &
  & 0.23622304E-09_JPRB, 0.23797825E-09_JPRB, 0.23965829E-09_JPRB, 0.24141841E-09_JPRB, 0.24335248E-09_JPRB, 0.24546848E-09_JPRB, &
  & 0.24765154E-09_JPRB, 0.24970515E-09_JPRB, 0.25140190E-09_JPRB, 0.25257205E-09_JPRB, 0.25316582E-09_JPRB, 0.25318808E-09_JPRB, &
  & 0.25267521E-09_JPRB, 0.25163932E-09_JPRB, 0.25008970E-09_JPRB, 0.24799671E-09_JPRB, 0.24537194E-09_JPRB, 0.24230559E-09_JPRB, &
  & 0.23894381E-09_JPRB, 0.23535304E-09_JPRB, 0.23157724E-09_JPRB, 0.22771629E-09_JPRB, 0.22392757E-09_JPRB, 0.22021926E-09_JPRB, &
  & 0.21659630E-09_JPRB, 0.21312196E-09_JPRB, 0.20976465E-09_JPRB, 0.20650757E-09_JPRB, 0.20342919E-09_JPRB, 0.20054958E-09_JPRB, &
  & 0.19787363E-09_JPRB, 0.19540422E-09_JPRB, 0.19312067E-09_JPRB, 0.19101608E-09_JPRB, 0.18910058E-09_JPRB, 0.18739565E-09_JPRB, &
  & 0.18589903E-09_JPRB, 0.18454790E-09_JPRB, 0.18314421E-09_JPRB, 0.18084058E-09_JPRB /)

RGHG5(:,37, 8) = (/ &
  & 0.16634001E-09_JPRB, 0.16653109E-09_JPRB, 0.16671101E-09_JPRB, 0.16699073E-09_JPRB, 0.16744707E-09_JPRB, 0.16819254E-09_JPRB, &
  & 0.16936516E-09_JPRB, 0.17109790E-09_JPRB, 0.17347558E-09_JPRB, 0.17650283E-09_JPRB, 0.18015947E-09_JPRB, 0.18436234E-09_JPRB, &
  & 0.18905670E-09_JPRB, 0.19413478E-09_JPRB, 0.19950669E-09_JPRB, 0.20504180E-09_JPRB, 0.21064145E-09_JPRB, 0.21615144E-09_JPRB, &
  & 0.22148915E-09_JPRB, 0.22649863E-09_JPRB, 0.23101261E-09_JPRB, 0.23493404E-09_JPRB, 0.23818358E-09_JPRB, 0.24078167E-09_JPRB, &
  & 0.24287014E-09_JPRB, 0.24459465E-09_JPRB, 0.24614713E-09_JPRB, 0.24765995E-09_JPRB, 0.24920940E-09_JPRB, 0.25080568E-09_JPRB, &
  & 0.25237995E-09_JPRB, 0.25380173E-09_JPRB, 0.25493543E-09_JPRB, 0.25567984E-09_JPRB, 0.25601460E-09_JPRB, 0.25594912E-09_JPRB, &
  & 0.25550323E-09_JPRB, 0.25467822E-09_JPRB, 0.25345934E-09_JPRB, 0.25179922E-09_JPRB, 0.24969085E-09_JPRB, 0.24718333E-09_JPRB, &
  & 0.24433705E-09_JPRB, 0.24120278E-09_JPRB, 0.23785016E-09_JPRB, 0.23433652E-09_JPRB, 0.23075278E-09_JPRB, 0.22715137E-09_JPRB, &
  & 0.22359742E-09_JPRB, 0.22013313E-09_JPRB, 0.21676622E-09_JPRB, 0.21352140E-09_JPRB, 0.21047263E-09_JPRB, 0.20764579E-09_JPRB, &
  & 0.20504221E-09_JPRB, 0.20265781E-09_JPRB, 0.20046154E-09_JPRB, 0.19844082E-09_JPRB, 0.19660444E-09_JPRB, 0.19497265E-09_JPRB, &
  & 0.19354325E-09_JPRB, 0.19224963E-09_JPRB, 0.19090457E-09_JPRB, 0.18868589E-09_JPRB /)

RGHG5(:,38, 8) = (/ &
  & 0.17364854E-09_JPRB, 0.17415741E-09_JPRB, 0.17453203E-09_JPRB, 0.17498498E-09_JPRB, 0.17561935E-09_JPRB, 0.17652815E-09_JPRB, &
  & 0.17783017E-09_JPRB, 0.17963089E-09_JPRB, 0.18198183E-09_JPRB, 0.18490068E-09_JPRB, 0.18834649E-09_JPRB, 0.19225835E-09_JPRB, &
  & 0.19656866E-09_JPRB, 0.20121382E-09_JPRB, 0.20611765E-09_JPRB, 0.21120319E-09_JPRB, 0.21638302E-09_JPRB, 0.22157999E-09_JPRB, &
  & 0.22668120E-09_JPRB, 0.23156889E-09_JPRB, 0.23608848E-09_JPRB, 0.24001928E-09_JPRB, 0.24325245E-09_JPRB, 0.24579444E-09_JPRB, &
  & 0.24774102E-09_JPRB, 0.24930596E-09_JPRB, 0.25064828E-09_JPRB, 0.25189573E-09_JPRB, 0.25311409E-09_JPRB, 0.25431213E-09_JPRB, &
  & 0.25544689E-09_JPRB, 0.25643926E-09_JPRB, 0.25720190E-09_JPRB, 0.25768077E-09_JPRB, 0.25786975E-09_JPRB, 0.25778463E-09_JPRB, &
  & 0.25743455E-09_JPRB, 0.25682143E-09_JPRB, 0.25591734E-09_JPRB, 0.25468128E-09_JPRB, 0.25307673E-09_JPRB, 0.25111843E-09_JPRB, &
  & 0.24878111E-09_JPRB, 0.24614183E-09_JPRB, 0.24321664E-09_JPRB, 0.24004476E-09_JPRB, 0.23669031E-09_JPRB, 0.23324337E-09_JPRB, &
  & 0.22977412E-09_JPRB, 0.22634972E-09_JPRB, 0.22300486E-09_JPRB, 0.21980774E-09_JPRB, 0.21682285E-09_JPRB, 0.21407898E-09_JPRB, &
  & 0.21157774E-09_JPRB, 0.20930040E-09_JPRB, 0.20720989E-09_JPRB, 0.20528820E-09_JPRB, 0.20354536E-09_JPRB, 0.20200194E-09_JPRB, &
  & 0.20065169E-09_JPRB, 0.19942825E-09_JPRB, 0.19814755E-09_JPRB, 0.19603413E-09_JPRB /)

RGHG5(:,39, 8) = (/ &
  & 0.18059007E-09_JPRB, 0.18137467E-09_JPRB, 0.18191407E-09_JPRB, 0.18252971E-09_JPRB, 0.18331095E-09_JPRB, 0.18436201E-09_JPRB, &
  & 0.18575813E-09_JPRB, 0.18756216E-09_JPRB, 0.18982885E-09_JPRB, 0.19257021E-09_JPRB, 0.19575608E-09_JPRB, 0.19933419E-09_JPRB, &
  & 0.20324620E-09_JPRB, 0.20744181E-09_JPRB, 0.21187935E-09_JPRB, 0.21650640E-09_JPRB, 0.22127454E-09_JPRB, 0.22612787E-09_JPRB, &
  & 0.23097643E-09_JPRB, 0.23569791E-09_JPRB, 0.24005206E-09_JPRB, 0.24384089E-09_JPRB, 0.24687719E-09_JPRB, 0.24918376E-09_JPRB, &
  & 0.25092312E-09_JPRB, 0.25227712E-09_JPRB, 0.25342040E-09_JPRB, 0.25445596E-09_JPRB, 0.25543681E-09_JPRB, 0.25637154E-09_JPRB, &
  & 0.25723501E-09_JPRB, 0.25796831E-09_JPRB, 0.25851751E-09_JPRB, 0.25884603E-09_JPRB, 0.25895988E-09_JPRB, 0.25887323E-09_JPRB, &
  & 0.25859911E-09_JPRB, 0.25813710E-09_JPRB, 0.25747285E-09_JPRB, 0.25656496E-09_JPRB, 0.25539168E-09_JPRB, 0.25391958E-09_JPRB, &
  & 0.25211222E-09_JPRB, 0.25000355E-09_JPRB, 0.24755115E-09_JPRB, 0.24477720E-09_JPRB, 0.24172780E-09_JPRB, 0.23847985E-09_JPRB, &
  & 0.23514371E-09_JPRB, 0.23179092E-09_JPRB, 0.22851296E-09_JPRB, 0.22539749E-09_JPRB, 0.22251108E-09_JPRB, 0.21988399E-09_JPRB, &
  & 0.21751070E-09_JPRB, 0.21536031E-09_JPRB, 0.21338974E-09_JPRB, 0.21158097E-09_JPRB, 0.20994415E-09_JPRB, 0.20850063E-09_JPRB, &
  & 0.20724047E-09_JPRB, 0.20609628E-09_JPRB, 0.20489539E-09_JPRB, 0.20290941E-09_JPRB /)

RGHG5(:,40, 8) = (/ &
  & 0.18728594E-09_JPRB, 0.18826896E-09_JPRB, 0.18893756E-09_JPRB, 0.18965926E-09_JPRB, 0.19058170E-09_JPRB, 0.19174654E-09_JPRB, &
  & 0.19319020E-09_JPRB, 0.19496811E-09_JPRB, 0.19709541E-09_JPRB, 0.19961002E-09_JPRB, 0.20250267E-09_JPRB, 0.20572272E-09_JPRB, &
  & 0.20922554E-09_JPRB, 0.21297417E-09_JPRB, 0.21694443E-09_JPRB, 0.22111388E-09_JPRB, 0.22546032E-09_JPRB, 0.22994116E-09_JPRB, &
  & 0.23449570E-09_JPRB, 0.23893987E-09_JPRB, 0.24307270E-09_JPRB, 0.24658076E-09_JPRB, 0.24935173E-09_JPRB, 0.25141966E-09_JPRB, &
  & 0.25294861E-09_JPRB, 0.25413555E-09_JPRB, 0.25512478E-09_JPRB, 0.25600763E-09_JPRB, 0.25682770E-09_JPRB, 0.25759528E-09_JPRB, &
  & 0.25828967E-09_JPRB, 0.25887245E-09_JPRB, 0.25929692E-09_JPRB, 0.25954142E-09_JPRB, 0.25961308E-09_JPRB, 0.25952884E-09_JPRB, &
  & 0.25930100E-09_JPRB, 0.25893360E-09_JPRB, 0.25841912E-09_JPRB, 0.25773197E-09_JPRB, 0.25685734E-09_JPRB, 0.25576261E-09_JPRB, &
  & 0.25440605E-09_JPRB, 0.25279401E-09_JPRB, 0.25084207E-09_JPRB, 0.24852426E-09_JPRB, 0.24584518E-09_JPRB, 0.24287228E-09_JPRB, &
  & 0.23971330E-09_JPRB, 0.23648933E-09_JPRB, 0.23332275E-09_JPRB, 0.23032580E-09_JPRB, 0.22757159E-09_JPRB, 0.22508743E-09_JPRB, &
  & 0.22286299E-09_JPRB, 0.22085382E-09_JPRB, 0.21901832E-09_JPRB, 0.21733160E-09_JPRB, 0.21581271E-09_JPRB, 0.21447810E-09_JPRB, &
  & 0.21331674E-09_JPRB, 0.21225856E-09_JPRB, 0.21114500E-09_JPRB, 0.20929865E-09_JPRB /)

RGHG5(:,41, 8) = (/ &
  & 0.19385242E-09_JPRB, 0.19494970E-09_JPRB, 0.19564711E-09_JPRB, 0.19645108E-09_JPRB, 0.19745841E-09_JPRB, 0.19870475E-09_JPRB, &
  & 0.20018981E-09_JPRB, 0.20188227E-09_JPRB, 0.20384677E-09_JPRB, 0.20611254E-09_JPRB, 0.20868604E-09_JPRB, 0.21154349E-09_JPRB, &
  & 0.21464132E-09_JPRB, 0.21795116E-09_JPRB, 0.22146351E-09_JPRB, 0.22517720E-09_JPRB, 0.22908722E-09_JPRB, 0.23318572E-09_JPRB, &
  & 0.23738211E-09_JPRB, 0.24154428E-09_JPRB, 0.24536070E-09_JPRB, 0.24860053E-09_JPRB, 0.25110614E-09_JPRB, 0.25295643E-09_JPRB, &
  & 0.25432126E-09_JPRB, 0.25537500E-09_JPRB, 0.25625005E-09_JPRB, 0.25702201E-09_JPRB, 0.25772950E-09_JPRB, 0.25838204E-09_JPRB, &
  & 0.25896987E-09_JPRB, 0.25945535E-09_JPRB, 0.25980587E-09_JPRB, 0.25999877E-09_JPRB, 0.26004623E-09_JPRB, 0.25996422E-09_JPRB, &
  & 0.25976621E-09_JPRB, 0.25945734E-09_JPRB, 0.25903737E-09_JPRB, 0.25849037E-09_JPRB, 0.25781124E-09_JPRB, 0.25697705E-09_JPRB, &
  & 0.25595545E-09_JPRB, 0.25474295E-09_JPRB, 0.25323546E-09_JPRB, 0.25137847E-09_JPRB, 0.24911948E-09_JPRB, 0.24646754E-09_JPRB, &
  & 0.24356089E-09_JPRB, 0.24050875E-09_JPRB, 0.23749555E-09_JPRB, 0.23464511E-09_JPRB, 0.23204258E-09_JPRB, 0.22972155E-09_JPRB, &
  & 0.22765748E-09_JPRB, 0.22580664E-09_JPRB, 0.22411435E-09_JPRB, 0.22256377E-09_JPRB, 0.22116869E-09_JPRB, 0.21994963E-09_JPRB, &
  & 0.21888930E-09_JPRB, 0.21792004E-09_JPRB, 0.21689310E-09_JPRB, 0.21519318E-09_JPRB /)

RGHG5(:,42, 8) = (/ &
  & 0.20065502E-09_JPRB, 0.20149529E-09_JPRB, 0.20212718E-09_JPRB, 0.20291566E-09_JPRB, 0.20398527E-09_JPRB, 0.20530609E-09_JPRB, &
  & 0.20676272E-09_JPRB, 0.20837845E-09_JPRB, 0.21015276E-09_JPRB, 0.21215874E-09_JPRB, 0.21441796E-09_JPRB, 0.21691744E-09_JPRB, &
  & 0.21962383E-09_JPRB, 0.22251463E-09_JPRB, 0.22558662E-09_JPRB, 0.22884925E-09_JPRB, 0.23232528E-09_JPRB, 0.23600547E-09_JPRB, &
  & 0.23985350E-09_JPRB, 0.24367069E-09_JPRB, 0.24721045E-09_JPRB, 0.25016303E-09_JPRB, 0.25243577E-09_JPRB, 0.25410157E-09_JPRB, &
  & 0.25532709E-09_JPRB, 0.25627525E-09_JPRB, 0.25705868E-09_JPRB, 0.25774449E-09_JPRB, 0.25836669E-09_JPRB, 0.25893851E-09_JPRB, &
  & 0.25944896E-09_JPRB, 0.25987257E-09_JPRB, 0.26017249E-09_JPRB, 0.26033350E-09_JPRB, 0.26036578E-09_JPRB, 0.26028688E-09_JPRB, &
  & 0.26010941E-09_JPRB, 0.25984045E-09_JPRB, 0.25948246E-09_JPRB, 0.25902758E-09_JPRB, 0.25847705E-09_JPRB, 0.25782063E-09_JPRB, &
  & 0.25703284E-09_JPRB, 0.25611224E-09_JPRB, 0.25496738E-09_JPRB, 0.25351654E-09_JPRB, 0.25166763E-09_JPRB, 0.24939223E-09_JPRB, &
  & 0.24676350E-09_JPRB, 0.24393029E-09_JPRB, 0.24109728E-09_JPRB, 0.23841329E-09_JPRB, 0.23598046E-09_JPRB, 0.23383068E-09_JPRB, &
  & 0.23194366E-09_JPRB, 0.23025916E-09_JPRB, 0.22872586E-09_JPRB, 0.22731739E-09_JPRB, 0.22605279E-09_JPRB, 0.22494848E-09_JPRB, &
  & 0.22398744E-09_JPRB, 0.22310320E-09_JPRB, 0.22216028E-09_JPRB, 0.22059543E-09_JPRB /)

RGHG5(:,43, 8) = (/ &
  & 0.20651521E-09_JPRB, 0.20755381E-09_JPRB, 0.20824233E-09_JPRB, 0.20907973E-09_JPRB, 0.21021389E-09_JPRB, 0.21155858E-09_JPRB, &
  & 0.21301547E-09_JPRB, 0.21450687E-09_JPRB, 0.21610065E-09_JPRB, 0.21785433E-09_JPRB, 0.21981066E-09_JPRB, 0.22196825E-09_JPRB, &
  & 0.22430467E-09_JPRB, 0.22679937E-09_JPRB, 0.22945021E-09_JPRB, 0.23228108E-09_JPRB, 0.23531332E-09_JPRB, 0.23858354E-09_JPRB, &
  & 0.24203214E-09_JPRB, 0.24553054E-09_JPRB, 0.24875690E-09_JPRB, 0.25145344E-09_JPRB, 0.25350541E-09_JPRB, 0.25500635E-09_JPRB, &
  & 0.25611410E-09_JPRB, 0.25697131E-09_JPRB, 0.25767879E-09_JPRB, 0.25829430E-09_JPRB, 0.25885033E-09_JPRB, 0.25935931E-09_JPRB, &
  & 0.25981609E-09_JPRB, 0.26019309E-09_JPRB, 0.26045996E-09_JPRB, 0.26059893E-09_JPRB, 0.26062225E-09_JPRB, 0.26054706E-09_JPRB, &
  & 0.26038569E-09_JPRB, 0.26014502E-09_JPRB, 0.25983082E-09_JPRB, 0.25943933E-09_JPRB, 0.25897690E-09_JPRB, 0.25844268E-09_JPRB, &
  & 0.25782143E-09_JPRB, 0.25711161E-09_JPRB, 0.25624355E-09_JPRB, 0.25512670E-09_JPRB, 0.25366309E-09_JPRB, 0.25175090E-09_JPRB, &
  & 0.24943747E-09_JPRB, 0.24684912E-09_JPRB, 0.24421690E-09_JPRB, 0.24170776E-09_JPRB, 0.23944866E-09_JPRB, 0.23748431E-09_JPRB, &
  & 0.23578028E-09_JPRB, 0.23427815E-09_JPRB, 0.23291136E-09_JPRB, 0.23165375E-09_JPRB, 0.23051912E-09_JPRB, 0.22952640E-09_JPRB, &
  & 0.22865818E-09_JPRB, 0.22785211E-09_JPRB, 0.22698525E-09_JPRB, 0.22554113E-09_JPRB /)

RGHG5(:,44, 8) = (/ &
  & 0.21207310E-09_JPRB, 0.21346429E-09_JPRB, 0.21423022E-09_JPRB, 0.21510133E-09_JPRB, 0.21624728E-09_JPRB, 0.21762145E-09_JPRB, &
  & 0.21900783E-09_JPRB, 0.22038438E-09_JPRB, 0.22179458E-09_JPRB, 0.22330970E-09_JPRB, 0.22497978E-09_JPRB, 0.22681818E-09_JPRB, &
  & 0.22880509E-09_JPRB, 0.23092368E-09_JPRB, 0.23318186E-09_JPRB, 0.23558794E-09_JPRB, 0.23819796E-09_JPRB, 0.24102267E-09_JPRB, &
  & 0.24408686E-09_JPRB, 0.24720681E-09_JPRB, 0.25013389E-09_JPRB, 0.25255728E-09_JPRB, 0.25440139E-09_JPRB, 0.25575245E-09_JPRB, &
  & 0.25675312E-09_JPRB, 0.25753127E-09_JPRB, 0.25817304E-09_JPRB, 0.25873009E-09_JPRB, 0.25923294E-09_JPRB, 0.25969446E-09_JPRB, &
  & 0.26010927E-09_JPRB, 0.26045388E-09_JPRB, 0.26069616E-09_JPRB, 0.26082092E-09_JPRB, 0.26083932E-09_JPRB, 0.26076860E-09_JPRB, &
  & 0.26062030E-09_JPRB, 0.26040167E-09_JPRB, 0.26011865E-09_JPRB, 0.25977381E-09_JPRB, 0.25937302E-09_JPRB, 0.25892780E-09_JPRB, &
  & 0.25842523E-09_JPRB, 0.25787111E-09_JPRB, 0.25721181E-09_JPRB, 0.25636626E-09_JPRB, 0.25523206E-09_JPRB, 0.25368113E-09_JPRB, &
  & 0.25169611E-09_JPRB, 0.24937086E-09_JPRB, 0.24694408E-09_JPRB, 0.24461594E-09_JPRB, 0.24254185E-09_JPRB, 0.24076607E-09_JPRB, &
  & 0.23926028E-09_JPRB, 0.23794677E-09_JPRB, 0.23675603E-09_JPRB, 0.23565083E-09_JPRB, 0.23464342E-09_JPRB, 0.23375435E-09_JPRB, &
  & 0.23297039E-09_JPRB, 0.23223583E-09_JPRB, 0.23143627E-09_JPRB, 0.23010052E-09_JPRB /)

RGHG5(:,45, 8) = (/ &
  & 0.21914764E-09_JPRB, 0.21987104E-09_JPRB, 0.22042893E-09_JPRB, 0.22117196E-09_JPRB, 0.22228484E-09_JPRB, 0.22359158E-09_JPRB, &
  & 0.22488908E-09_JPRB, 0.22613052E-09_JPRB, 0.22735008E-09_JPRB, 0.22863868E-09_JPRB, 0.23003938E-09_JPRB, 0.23157107E-09_JPRB, &
  & 0.23322433E-09_JPRB, 0.23499019E-09_JPRB, 0.23686064E-09_JPRB, 0.23887570E-09_JPRB, 0.24104643E-09_JPRB, 0.24346014E-09_JPRB, &
  & 0.24606786E-09_JPRB, 0.24881847E-09_JPRB, 0.25137847E-09_JPRB, 0.25352723E-09_JPRB, 0.25516461E-09_JPRB, 0.25637378E-09_JPRB, &
  & 0.25727978E-09_JPRB, 0.25798758E-09_JPRB, 0.25857272E-09_JPRB, 0.25908187E-09_JPRB, 0.25954203E-09_JPRB, 0.25996663E-09_JPRB, &
  & 0.26035057E-09_JPRB, 0.26067035E-09_JPRB, 0.26089586E-09_JPRB, 0.26101138E-09_JPRB, 0.26102800E-09_JPRB, 0.26096253E-09_JPRB, &
  & 0.26082528E-09_JPRB, 0.26062369E-09_JPRB, 0.26036501E-09_JPRB, 0.26005303E-09_JPRB, 0.25970015E-09_JPRB, 0.25931696E-09_JPRB, &
  & 0.25890595E-09_JPRB, 0.25846314E-09_JPRB, 0.25796215E-09_JPRB, 0.25732655E-09_JPRB, 0.25647068E-09_JPRB, 0.25525806E-09_JPRB, &
  & 0.25360566E-09_JPRB, 0.25157512E-09_JPRB, 0.24936836E-09_JPRB, 0.24723518E-09_JPRB, 0.24535235E-09_JPRB, 0.24378080E-09_JPRB, &
  & 0.24248129E-09_JPRB, 0.24136249E-09_JPRB, 0.24034785E-09_JPRB, 0.23939276E-09_JPRB, 0.23850438E-09_JPRB, 0.23770924E-09_JPRB, &
  & 0.23699986E-09_JPRB, 0.23632865E-09_JPRB, 0.23559321E-09_JPRB, 0.23435678E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART15',1,ZHOOK_HANDLE)
END SUBROUTINE PART15




SUBROUTINE PART16
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART16',0,ZHOOK_HANDLE)



RGHG5(:,46, 8) = (/ &
  & 0.22391353E-09_JPRB, 0.22542128E-09_JPRB, 0.22628366E-09_JPRB, 0.22720753E-09_JPRB, 0.22834319E-09_JPRB, 0.22961352E-09_JPRB, &
  & 0.23080936E-09_JPRB, 0.23187635E-09_JPRB, 0.23291041E-09_JPRB, 0.23396049E-09_JPRB, 0.23509278E-09_JPRB, 0.23632407E-09_JPRB, &
  & 0.23765206E-09_JPRB, 0.23906213E-09_JPRB, 0.24057292E-09_JPRB, 0.24218064E-09_JPRB, 0.24395858E-09_JPRB, 0.24590435E-09_JPRB, &
  & 0.24809838E-09_JPRB, 0.25036381E-09_JPRB, 0.25255070E-09_JPRB, 0.25438515E-09_JPRB, 0.25581659E-09_JPRB, 0.25689501E-09_JPRB, &
  & 0.25771338E-09_JPRB, 0.25835978E-09_JPRB, 0.25889740E-09_JPRB, 0.25936658E-09_JPRB, 0.25979399E-09_JPRB, 0.26019031E-09_JPRB, &
  & 0.26055069E-09_JPRB, 0.26085289E-09_JPRB, 0.26106634E-09_JPRB, 0.26117672E-09_JPRB, 0.26119409E-09_JPRB, 0.26113406E-09_JPRB, &
  & 0.26100683E-09_JPRB, 0.26081914E-09_JPRB, 0.26057778E-09_JPRB, 0.26029359E-09_JPRB, 0.25997346E-09_JPRB, 0.25964059E-09_JPRB, &
  & 0.25929248E-09_JPRB, 0.25893601E-09_JPRB, 0.25854685E-09_JPRB, 0.25807237E-09_JPRB, 0.25743807E-09_JPRB, 0.25652105E-09_JPRB, &
  & 0.25522118E-09_JPRB, 0.25351166E-09_JPRB, 0.25157124E-09_JPRB, 0.24965555E-09_JPRB, 0.24798225E-09_JPRB, 0.24662877E-09_JPRB, &
  & 0.24553221E-09_JPRB, 0.24460628E-09_JPRB, 0.24375757E-09_JPRB, 0.24294255E-09_JPRB, 0.24216482E-09_JPRB, 0.24145125E-09_JPRB, &
  & 0.24080851E-09_JPRB, 0.24019567E-09_JPRB, 0.23951988E-09_JPRB, 0.23838304E-09_JPRB /)

RGHG5(:,47, 8) = (/ &
  & 0.23027223E-09_JPRB, 0.23153046E-09_JPRB, 0.23240375E-09_JPRB, 0.23337487E-09_JPRB, 0.23457927E-09_JPRB, 0.23582336E-09_JPRB, &
  & 0.23687188E-09_JPRB, 0.23777655E-09_JPRB, 0.23857985E-09_JPRB, 0.23938312E-09_JPRB, 0.24022909E-09_JPRB, 0.24114849E-09_JPRB, &
  & 0.24213953E-09_JPRB, 0.24320435E-09_JPRB, 0.24433575E-09_JPRB, 0.24557459E-09_JPRB, 0.24692029E-09_JPRB, 0.24845076E-09_JPRB, &
  & 0.25011512E-09_JPRB, 0.25191407E-09_JPRB, 0.25363056E-09_JPRB, 0.25515010E-09_JPRB, 0.25637431E-09_JPRB, 0.25732716E-09_JPRB, &
  & 0.25806901E-09_JPRB, 0.25866220E-09_JPRB, 0.25915944E-09_JPRB, 0.25959784E-09_JPRB, 0.25999913E-09_JPRB, 0.26037453E-09_JPRB, &
  & 0.26071820E-09_JPRB, 0.26100699E-09_JPRB, 0.26121286E-09_JPRB, 0.26132108E-09_JPRB, 0.26134100E-09_JPRB, 0.26128694E-09_JPRB, &
  & 0.26116836E-09_JPRB, 0.26099162E-09_JPRB, 0.26076608E-09_JPRB, 0.26049993E-09_JPRB, 0.26020991E-09_JPRB, 0.25990915E-09_JPRB, &
  & 0.25961233E-09_JPRB, 0.25931396E-09_JPRB, 0.25900754E-09_JPRB, 0.25864957E-09_JPRB, 0.25818259E-09_JPRB, 0.25752023E-09_JPRB, &
  & 0.25654456E-09_JPRB, 0.25521993E-09_JPRB, 0.25360031E-09_JPRB, 0.25196356E-09_JPRB, 0.25052821E-09_JPRB, 0.24938529E-09_JPRB, &
  & 0.24849231E-09_JPRB, 0.24773456E-09_JPRB, 0.24703786E-09_JPRB, 0.24634772E-09_JPRB, 0.24566443E-09_JPRB, 0.24502453E-09_JPRB, &
  & 0.24443847E-09_JPRB, 0.24387820E-09_JPRB, 0.24325919E-09_JPRB, 0.24221772E-09_JPRB /)

RGHG5(:,48, 8) = (/ &
  & 0.23537944E-09_JPRB, 0.23704261E-09_JPRB, 0.23816285E-09_JPRB, 0.23935287E-09_JPRB, 0.24072008E-09_JPRB, 0.24199659E-09_JPRB, &
  & 0.24300048E-09_JPRB, 0.24373251E-09_JPRB, 0.24433572E-09_JPRB, 0.24488817E-09_JPRB, 0.24544658E-09_JPRB, 0.24604724E-09_JPRB, &
  & 0.24670083E-09_JPRB, 0.24740851E-09_JPRB, 0.24818214E-09_JPRB, 0.24902094E-09_JPRB, 0.24995961E-09_JPRB, 0.25099062E-09_JPRB, &
  & 0.25214572E-09_JPRB, 0.25337121E-09_JPRB, 0.25463887E-09_JPRB, 0.25582184E-09_JPRB, 0.25684760E-09_JPRB, 0.25768662E-09_JPRB, &
  & 0.25835900E-09_JPRB, 0.25890676E-09_JPRB, 0.25937175E-09_JPRB, 0.25978478E-09_JPRB, 0.26016722E-09_JPRB, 0.26052738E-09_JPRB, &
  & 0.26085833E-09_JPRB, 0.26113839E-09_JPRB, 0.26133906E-09_JPRB, 0.26144750E-09_JPRB, 0.26147118E-09_JPRB, 0.26142338E-09_JPRB, &
  & 0.26131264E-09_JPRB, 0.26114608E-09_JPRB, 0.26093150E-09_JPRB, 0.26068372E-09_JPRB, 0.26041236E-09_JPRB, 0.26014063E-09_JPRB, &
  & 0.25987484E-09_JPRB, 0.25962360E-09_JPRB, 0.25937252E-09_JPRB, 0.25909863E-09_JPRB, 0.25875679E-09_JPRB, 0.25828661E-09_JPRB, &
  & 0.25761299E-09_JPRB, 0.25666241E-09_JPRB, 0.25547806E-09_JPRB, 0.25419020E-09_JPRB, 0.25304236E-09_JPRB, 0.25213381E-09_JPRB, &
  & 0.25141600E-09_JPRB, 0.25080898E-09_JPRB, 0.25023505E-09_JPRB, 0.24964833E-09_JPRB, 0.24904437E-09_JPRB, 0.24846009E-09_JPRB, &
  & 0.24792107E-09_JPRB, 0.24740290E-09_JPRB, 0.24683183E-09_JPRB, 0.24587016E-09_JPRB /)

RGHG5(:,49, 8) = (/ &
  & 0.24022240E-09_JPRB, 0.24207422E-09_JPRB, 0.24331034E-09_JPRB, 0.24461971E-09_JPRB, 0.24610719E-09_JPRB, 0.24748750E-09_JPRB, &
  & 0.24846170E-09_JPRB, 0.24912572E-09_JPRB, 0.24960700E-09_JPRB, 0.24998578E-09_JPRB, 0.25033603E-09_JPRB, 0.25068231E-09_JPRB, &
  & 0.25104963E-09_JPRB, 0.25144309E-09_JPRB, 0.25186969E-09_JPRB, 0.25233587E-09_JPRB, 0.25283578E-09_JPRB, 0.25338281E-09_JPRB, &
  & 0.25399408E-09_JPRB, 0.25470823E-09_JPRB, 0.25552999E-09_JPRB, 0.25640912E-09_JPRB, 0.25724822E-09_JPRB, 0.25798300E-09_JPRB, &
  & 0.25859603E-09_JPRB, 0.25910596E-09_JPRB, 0.25954411E-09_JPRB, 0.25993818E-09_JPRB, 0.26030600E-09_JPRB, 0.26065497E-09_JPRB, &
  & 0.26097752E-09_JPRB, 0.26125072E-09_JPRB, 0.26144870E-09_JPRB, 0.26155850E-09_JPRB, 0.26158700E-09_JPRB, 0.26154559E-09_JPRB, &
  & 0.26144234E-09_JPRB, 0.26128438E-09_JPRB, 0.26108155E-09_JPRB, 0.26084637E-09_JPRB, 0.26059319E-09_JPRB, 0.26033881E-09_JPRB, &
  & 0.26010011E-09_JPRB, 0.25987704E-09_JPRB, 0.25966895E-09_JPRB, 0.25945143E-09_JPRB, 0.25919836E-09_JPRB, 0.25887117E-09_JPRB, &
  & 0.25842381E-09_JPRB, 0.25782407E-09_JPRB, 0.25706032E-09_JPRB, 0.25622937E-09_JPRB, 0.25544139E-09_JPRB, 0.25479224E-09_JPRB, &
  & 0.25425789E-09_JPRB, 0.25379110E-09_JPRB, 0.25332547E-09_JPRB, 0.25282651E-09_JPRB, 0.25229022E-09_JPRB, 0.25175201E-09_JPRB, &
  & 0.25124652E-09_JPRB, 0.25076205E-09_JPRB, 0.25022540E-09_JPRB, 0.24932442E-09_JPRB /)

RGHG5(:,50, 8) = (/ &
  & 0.24493307E-09_JPRB, 0.24650934E-09_JPRB, 0.24758759E-09_JPRB, 0.24880120E-09_JPRB, 0.25021521E-09_JPRB, 0.25153044E-09_JPRB, &
  & 0.25243840E-09_JPRB, 0.25303840E-09_JPRB, 0.25342897E-09_JPRB, 0.25373575E-09_JPRB, 0.25397898E-09_JPRB, 0.25420088E-09_JPRB, &
  & 0.25440339E-09_JPRB, 0.25459515E-09_JPRB, 0.25477676E-09_JPRB, 0.25494790E-09_JPRB, 0.25511529E-09_JPRB, 0.25529079E-09_JPRB, &
  & 0.25550934E-09_JPRB, 0.25583127E-09_JPRB, 0.25630126E-09_JPRB, 0.25691366E-09_JPRB, 0.25758662E-09_JPRB, 0.25822919E-09_JPRB, &
  & 0.25879116E-09_JPRB, 0.25927011E-09_JPRB, 0.25968738E-09_JPRB, 0.26006602E-09_JPRB, 0.26042291E-09_JPRB, 0.26076361E-09_JPRB, &
  & 0.26107938E-09_JPRB, 0.26134805E-09_JPRB, 0.26154429E-09_JPRB, 0.26165675E-09_JPRB, 0.26169061E-09_JPRB, 0.26165542E-09_JPRB, &
  & 0.26155950E-09_JPRB, 0.26141031E-09_JPRB, 0.26121785E-09_JPRB, 0.26099453E-09_JPRB, 0.26075525E-09_JPRB, 0.26051603E-09_JPRB, &
  & 0.26029146E-09_JPRB, 0.26009389E-09_JPRB, 0.25991170E-09_JPRB, 0.25973509E-09_JPRB, 0.25954147E-09_JPRB, 0.25931129E-09_JPRB, &
  & 0.25902330E-09_JPRB, 0.25866603E-09_JPRB, 0.25824901E-09_JPRB, 0.25779559E-09_JPRB, 0.25736996E-09_JPRB, 0.25699604E-09_JPRB, &
  & 0.25667463E-09_JPRB, 0.25636318E-09_JPRB, 0.25604099E-09_JPRB, 0.25566640E-09_JPRB, 0.25522917E-09_JPRB, 0.25476754E-09_JPRB, &
  & 0.25431882E-09_JPRB, 0.25387387E-09_JPRB, 0.25337804E-09_JPRB, 0.25251926E-09_JPRB /)

RGHG5(:,51, 8) = (/ &
  & 0.24848162E-09_JPRB, 0.24987887E-09_JPRB, 0.25082811E-09_JPRB, 0.25183097E-09_JPRB, 0.25305982E-09_JPRB, 0.25416269E-09_JPRB, &
  & 0.25493513E-09_JPRB, 0.25539132E-09_JPRB, 0.25571642E-09_JPRB, 0.25593713E-09_JPRB, 0.25612709E-09_JPRB, 0.25628183E-09_JPRB, &
  & 0.25641045E-09_JPRB, 0.25650446E-09_JPRB, 0.25656405E-09_JPRB, 0.25659375E-09_JPRB, 0.25659916E-09_JPRB, 0.25659905E-09_JPRB, &
  & 0.25662250E-09_JPRB, 0.25671823E-09_JPRB, 0.25695168E-09_JPRB, 0.25734923E-09_JPRB, 0.25787522E-09_JPRB, 0.25843577E-09_JPRB, &
  & 0.25895500E-09_JPRB, 0.25940888E-09_JPRB, 0.25980937E-09_JPRB, 0.26017591E-09_JPRB, 0.26052344E-09_JPRB, 0.26085720E-09_JPRB, &
  & 0.26116759E-09_JPRB, 0.26143263E-09_JPRB, 0.26162836E-09_JPRB, 0.26174432E-09_JPRB, 0.26178365E-09_JPRB, 0.26175487E-09_JPRB, &
  & 0.26166608E-09_JPRB, 0.26152602E-09_JPRB, 0.26134311E-09_JPRB, 0.26113256E-09_JPRB, 0.26090319E-09_JPRB, 0.26067454E-09_JPRB, &
  & 0.26046473E-09_JPRB, 0.26027835E-09_JPRB, 0.26011865E-09_JPRB, 0.25996749E-09_JPRB, 0.25981445E-09_JPRB, 0.25964675E-09_JPRB, &
  & 0.25945976E-09_JPRB, 0.25925312E-09_JPRB, 0.25903460E-09_JPRB, 0.25881761E-09_JPRB, 0.25862021E-09_JPRB, 0.25844921E-09_JPRB, &
  & 0.25829466E-09_JPRB, 0.25814639E-09_JPRB, 0.25797606E-09_JPRB, 0.25776586E-09_JPRB, 0.25750113E-09_JPRB, 0.25718727E-09_JPRB, &
  & 0.25685451E-09_JPRB, 0.25650945E-09_JPRB, 0.25608735E-09_JPRB, 0.25532321E-09_JPRB /)

RGHG5(:,52, 8) = (/ &
  & 0.25168848E-09_JPRB, 0.25262456E-09_JPRB, 0.25326430E-09_JPRB, 0.25404981E-09_JPRB, 0.25498215E-09_JPRB, 0.25587873E-09_JPRB, &
  & 0.25644237E-09_JPRB, 0.25680816E-09_JPRB, 0.25702390E-09_JPRB, 0.25719782E-09_JPRB, 0.25732796E-09_JPRB, 0.25744190E-09_JPRB, &
  & 0.25752683E-09_JPRB, 0.25757657E-09_JPRB, 0.25758767E-09_JPRB, 0.25756400E-09_JPRB, 0.25751590E-09_JPRB, 0.25745578E-09_JPRB, &
  & 0.25740612E-09_JPRB, 0.25739919E-09_JPRB, 0.25748814E-09_JPRB, 0.25773086E-09_JPRB, 0.25812891E-09_JPRB, 0.25861449E-09_JPRB, &
  & 0.25909613E-09_JPRB, 0.25952995E-09_JPRB, 0.25991692E-09_JPRB, 0.26027264E-09_JPRB, 0.26061220E-09_JPRB, 0.26093896E-09_JPRB, &
  & 0.26124453E-09_JPRB, 0.26150657E-09_JPRB, 0.26170305E-09_JPRB, 0.26182301E-09_JPRB, 0.26186772E-09_JPRB, 0.26184541E-09_JPRB, &
  & 0.26176433E-09_JPRB, 0.26163241E-09_JPRB, 0.26146088E-09_JPRB, 0.26125918E-09_JPRB, 0.26104158E-09_JPRB, 0.26082209E-09_JPRB, &
  & 0.26061797E-09_JPRB, 0.26044600E-09_JPRB, 0.26029684E-09_JPRB, 0.26016492E-09_JPRB, 0.26003777E-09_JPRB, 0.25991156E-09_JPRB, &
  & 0.25978458E-09_JPRB, 0.25966221E-09_JPRB, 0.25954666E-09_JPRB, 0.25944441E-09_JPRB, 0.25935742E-09_JPRB, 0.25928729E-09_JPRB, &
  & 0.25922622E-09_JPRB, 0.25916530E-09_JPRB, 0.25909705E-09_JPRB, 0.25900776E-09_JPRB, 0.25888358E-09_JPRB, 0.25872612E-09_JPRB, &
  & 0.25854374E-09_JPRB, 0.25833094E-09_JPRB, 0.25805463E-09_JPRB, 0.25747152E-09_JPRB /)

RGHG5(:,53, 8) = (/ &
  & 0.25376695E-09_JPRB, 0.25452754E-09_JPRB, 0.25505792E-09_JPRB, 0.25562319E-09_JPRB, 0.25634739E-09_JPRB, 0.25699287E-09_JPRB, &
  & 0.25743740E-09_JPRB, 0.25767971E-09_JPRB, 0.25785102E-09_JPRB, 0.25796298E-09_JPRB, 0.25806224E-09_JPRB, 0.25814112E-09_JPRB, &
  & 0.25820052E-09_JPRB, 0.25822838E-09_JPRB, 0.25822094E-09_JPRB, 0.25818186E-09_JPRB, 0.25811944E-09_JPRB, 0.25804528E-09_JPRB, &
  & 0.25797101E-09_JPRB, 0.25792152E-09_JPRB, 0.25793434E-09_JPRB, 0.25806704E-09_JPRB, 0.25835992E-09_JPRB, 0.25877647E-09_JPRB, &
  & 0.25922345E-09_JPRB, 0.25963914E-09_JPRB, 0.26001373E-09_JPRB, 0.26036040E-09_JPRB, 0.26069108E-09_JPRB, 0.26101149E-09_JPRB, &
  & 0.26131214E-09_JPRB, 0.26157193E-09_JPRB, 0.26176999E-09_JPRB, 0.26189390E-09_JPRB, 0.26194458E-09_JPRB, 0.26192898E-09_JPRB, &
  & 0.26185487E-09_JPRB, 0.26173216E-09_JPRB, 0.26156943E-09_JPRB, 0.26137936E-09_JPRB, 0.26116981E-09_JPRB, 0.26095776E-09_JPRB, &
  & 0.26076410E-09_JPRB, 0.26059585E-09_JPRB, 0.26045804E-09_JPRB, 0.26033739E-09_JPRB, 0.26022870E-09_JPRB, 0.26012786E-09_JPRB, &
  & 0.26003816E-09_JPRB, 0.25996008E-09_JPRB, 0.25989580E-09_JPRB, 0.25984406E-09_JPRB, 0.25980634E-09_JPRB, 0.25977689E-09_JPRB, &
  & 0.25975333E-09_JPRB, 0.25973051E-09_JPRB, 0.25970406E-09_JPRB, 0.25966790E-09_JPRB, 0.25961647E-09_JPRB, 0.25954508E-09_JPRB, &
  & 0.25945759E-09_JPRB, 0.25935559E-09_JPRB, 0.25921487E-09_JPRB, 0.25887897E-09_JPRB /)

RGHG5(:,54, 8) = (/ &
  & 0.25556121E-09_JPRB, 0.25606339E-09_JPRB, 0.25640401E-09_JPRB, 0.25681834E-09_JPRB, 0.25731900E-09_JPRB, 0.25780106E-09_JPRB, &
  & 0.25810298E-09_JPRB, 0.25829416E-09_JPRB, 0.25840297E-09_JPRB, 0.25849078E-09_JPRB, 0.25855662E-09_JPRB, 0.25861530E-09_JPRB, &
  & 0.25865732E-09_JPRB, 0.25867414E-09_JPRB, 0.25866084E-09_JPRB, 0.25861965E-09_JPRB, 0.25855754E-09_JPRB, 0.25848154E-09_JPRB, &
  & 0.25840335E-09_JPRB, 0.25833408E-09_JPRB, 0.25830546E-09_JPRB, 0.25836819E-09_JPRB, 0.25857835E-09_JPRB, 0.25893046E-09_JPRB, &
  & 0.25934380E-09_JPRB, 0.25974073E-09_JPRB, 0.26010402E-09_JPRB, 0.26044017E-09_JPRB, 0.26076327E-09_JPRB, 0.26107652E-09_JPRB, &
  & 0.26137231E-09_JPRB, 0.26163099E-09_JPRB, 0.26183047E-09_JPRB, 0.26195890E-09_JPRB, 0.26201560E-09_JPRB, 0.26200653E-09_JPRB, &
  & 0.26193975E-09_JPRB, 0.26182498E-09_JPRB, 0.26167221E-09_JPRB, 0.26149022E-09_JPRB, 0.26129018E-09_JPRB, 0.26108707E-09_JPRB, &
  & 0.26089753E-09_JPRB, 0.26073882E-09_JPRB, 0.26060587E-09_JPRB, 0.26049435E-09_JPRB, 0.26039693E-09_JPRB, 0.26031383E-09_JPRB, &
  & 0.26024444E-09_JPRB, 0.26019081E-09_JPRB, 0.26015012E-09_JPRB, 0.26012206E-09_JPRB, 0.26010241E-09_JPRB, 0.26008981E-09_JPRB, &
  & 0.26007962E-09_JPRB, 0.26007030E-09_JPRB, 0.26005914E-09_JPRB, 0.26004371E-09_JPRB, 0.26002034E-09_JPRB, 0.25998814E-09_JPRB, &
  & 0.25994989E-09_JPRB, 0.25990918E-09_JPRB, 0.25986829E-09_JPRB, 0.25982344E-09_JPRB /)

RGHG5(:,55, 8) = (/ &
  & 0.25675875E-09_JPRB, 0.25714866E-09_JPRB, 0.25741309E-09_JPRB, 0.25770336E-09_JPRB, 0.25805091E-09_JPRB, 0.25838123E-09_JPRB, &
  & 0.25861197E-09_JPRB, 0.25873703E-09_JPRB, 0.25882341E-09_JPRB, 0.25887989E-09_JPRB, 0.25893043E-09_JPRB, 0.25897157E-09_JPRB, &
  & 0.25900268E-09_JPRB, 0.25901423E-09_JPRB, 0.25900079E-09_JPRB, 0.25896268E-09_JPRB, 0.25890445E-09_JPRB, 0.25883271E-09_JPRB, &
  & 0.25875160E-09_JPRB, 0.25867530E-09_JPRB, 0.25862182E-09_JPRB, 0.25863872E-09_JPRB, 0.25878621E-09_JPRB, 0.25908531E-09_JPRB, &
  & 0.25946173E-09_JPRB, 0.25983973E-09_JPRB, 0.26018873E-09_JPRB, 0.26051594E-09_JPRB, 0.26082980E-09_JPRB, 0.26113672E-09_JPRB, &
  & 0.26142821E-09_JPRB, 0.26168526E-09_JPRB, 0.26188646E-09_JPRB, 0.26201952E-09_JPRB, 0.26208216E-09_JPRB, 0.26207950E-09_JPRB, &
  & 0.26201974E-09_JPRB, 0.26191288E-09_JPRB, 0.26176816E-09_JPRB, 0.26159519E-09_JPRB, 0.26140282E-09_JPRB, 0.26120711E-09_JPRB, &
  & 0.26102720E-09_JPRB, 0.26087241E-09_JPRB, 0.26074634E-09_JPRB, 0.26064051E-09_JPRB, 0.26055214E-09_JPRB, 0.26047856E-09_JPRB, &
  & 0.26042182E-09_JPRB, 0.26037961E-09_JPRB, 0.26035052E-09_JPRB, 0.26033101E-09_JPRB, 0.26031963E-09_JPRB, 0.26031180E-09_JPRB, &
  & 0.26030642E-09_JPRB, 0.26030111E-09_JPRB, 0.26029495E-09_JPRB, 0.26028610E-09_JPRB, 0.26027275E-09_JPRB, 0.26025421E-09_JPRB, &
  & 0.26023148E-09_JPRB, 0.26020658E-09_JPRB, 0.26017849E-09_JPRB, 0.26013053E-09_JPRB /)

RGHG5(:,56, 8) = (/ &
  & 0.25776312E-09_JPRB, 0.25800889E-09_JPRB, 0.25818336E-09_JPRB, 0.25837471E-09_JPRB, 0.25861277E-09_JPRB, 0.25883923E-09_JPRB, &
  & 0.25899571E-09_JPRB, 0.25909477E-09_JPRB, 0.25915131E-09_JPRB, 0.25919628E-09_JPRB, 0.25923089E-09_JPRB, 0.25926261E-09_JPRB, &
  & 0.25928637E-09_JPRB, 0.25929583E-09_JPRB, 0.25928487E-09_JPRB, 0.25925234E-09_JPRB, 0.25919977E-09_JPRB, 0.25913083E-09_JPRB, &
  & 0.25905103E-09_JPRB, 0.25896674E-09_JPRB, 0.25889793E-09_JPRB, 0.25888397E-09_JPRB, 0.25898900E-09_JPRB, 0.25924013E-09_JPRB, &
  & 0.25958358E-09_JPRB, 0.25993757E-09_JPRB, 0.26027311E-09_JPRB, 0.26058861E-09_JPRB, 0.26089489E-09_JPRB, 0.26119479E-09_JPRB, &
  & 0.26148195E-09_JPRB, 0.26173733E-09_JPRB, 0.26194008E-09_JPRB, 0.26207711E-09_JPRB, 0.26214533E-09_JPRB, 0.26214891E-09_JPRB, &
  & 0.26209598E-09_JPRB, 0.26199667E-09_JPRB, 0.26185981E-09_JPRB, 0.26169372E-09_JPRB, 0.26150959E-09_JPRB, 0.26132241E-09_JPRB, &
  & 0.26114910E-09_JPRB, 0.26100203E-09_JPRB, 0.26088043E-09_JPRB, 0.26078056E-09_JPRB, 0.26069760E-09_JPRB, 0.26063146E-09_JPRB, &
  & 0.26058056E-09_JPRB, 0.26054386E-09_JPRB, 0.26051858E-09_JPRB, 0.26050284E-09_JPRB, 0.26049257E-09_JPRB, 0.26048647E-09_JPRB, &
  & 0.26048147E-09_JPRB, 0.26047697E-09_JPRB, 0.26047164E-09_JPRB, 0.26046443E-09_JPRB, 0.26045444E-09_JPRB, 0.26044081E-09_JPRB, &
  & 0.26042507E-09_JPRB, 0.26040847E-09_JPRB, 0.26038993E-09_JPRB, 0.26036184E-09_JPRB /)

RGHG5(:,57, 8) = (/ &
  & 0.25843080E-09_JPRB, 0.25862915E-09_JPRB, 0.25875574E-09_JPRB, 0.25889504E-09_JPRB, 0.25904517E-09_JPRB, 0.25920205E-09_JPRB, &
  & 0.25931840E-09_JPRB, 0.25938574E-09_JPRB, 0.25943137E-09_JPRB, 0.25946237E-09_JPRB, 0.25949012E-09_JPRB, 0.25951416E-09_JPRB, &
  & 0.25953395E-09_JPRB, 0.25954333E-09_JPRB, 0.25953634E-09_JPRB, 0.25950972E-09_JPRB, 0.25946301E-09_JPRB, 0.25939773E-09_JPRB, &
  & 0.25931596E-09_JPRB, 0.25922647E-09_JPRB, 0.25914468E-09_JPRB, 0.25910973E-09_JPRB, 0.25918334E-09_JPRB, 0.25939959E-09_JPRB, &
  & 0.25970850E-09_JPRB, 0.26003935E-09_JPRB, 0.26035823E-09_JPRB, 0.26066330E-09_JPRB, 0.26096050E-09_JPRB, 0.26125388E-09_JPRB, &
  & 0.26153596E-09_JPRB, 0.26178928E-09_JPRB, 0.26199262E-09_JPRB, 0.26213323E-09_JPRB, 0.26220603E-09_JPRB, 0.26221564E-09_JPRB, &
  & 0.26216965E-09_JPRB, 0.26207728E-09_JPRB, 0.26194730E-09_JPRB, 0.26178895E-09_JPRB, 0.26161170E-09_JPRB, 0.26143276E-09_JPRB, &
  & 0.26126790E-09_JPRB, 0.26112654E-09_JPRB, 0.26101060E-09_JPRB, 0.26091526E-09_JPRB, 0.26083782E-09_JPRB, 0.26077560E-09_JPRB, &
  & 0.26072813E-09_JPRB, 0.26069349E-09_JPRB, 0.26066907E-09_JPRB, 0.26065236E-09_JPRB, 0.26064209E-09_JPRB, 0.26063440E-09_JPRB, &
  & 0.26062866E-09_JPRB, 0.26062311E-09_JPRB, 0.26061692E-09_JPRB, 0.26060931E-09_JPRB, 0.26059904E-09_JPRB, 0.26058655E-09_JPRB, &
  & 0.26057245E-09_JPRB, 0.26055769E-09_JPRB, 0.26054142E-09_JPRB, 0.26051242E-09_JPRB /)

RGHG5(:,58, 8) = (/ &
  & 0.25898189E-09_JPRB, 0.25911601E-09_JPRB, 0.25920643E-09_JPRB, 0.25929431E-09_JPRB, 0.25940017E-09_JPRB, 0.25950397E-09_JPRB, &
  & 0.25958655E-09_JPRB, 0.25964031E-09_JPRB, 0.25967320E-09_JPRB, 0.25969901E-09_JPRB, 0.25972038E-09_JPRB, 0.25974084E-09_JPRB, &
  & 0.25975877E-09_JPRB, 0.25976940E-09_JPRB, 0.25976704E-09_JPRB, 0.25974686E-09_JPRB, 0.25970573E-09_JPRB, 0.25964270E-09_JPRB, &
  & 0.25955960E-09_JPRB, 0.25946242E-09_JPRB, 0.25936997E-09_JPRB, 0.25932045E-09_JPRB, 0.25937349E-09_JPRB, 0.25956032E-09_JPRB, &
  & 0.25983857E-09_JPRB, 0.26014568E-09_JPRB, 0.26044833E-09_JPRB, 0.26074176E-09_JPRB, 0.26103020E-09_JPRB, 0.26131614E-09_JPRB, &
  & 0.26159269E-09_JPRB, 0.26184263E-09_JPRB, 0.26204619E-09_JPRB, 0.26218824E-09_JPRB, 0.26226538E-09_JPRB, 0.26228042E-09_JPRB, &
  & 0.26224078E-09_JPRB, 0.26215549E-09_JPRB, 0.26203248E-09_JPRB, 0.26188041E-09_JPRB, 0.26171151E-09_JPRB, 0.26154040E-09_JPRB, &
  & 0.26138330E-09_JPRB, 0.26124836E-09_JPRB, 0.26113731E-09_JPRB, 0.26104657E-09_JPRB, 0.26097302E-09_JPRB, 0.26091451E-09_JPRB, &
  & 0.26086933E-09_JPRB, 0.26083480E-09_JPRB, 0.26080932E-09_JPRB, 0.26079100E-09_JPRB, 0.26077737E-09_JPRB, 0.26076785E-09_JPRB, &
  & 0.26075977E-09_JPRB, 0.26075225E-09_JPRB, 0.26074443E-09_JPRB, 0.26073482E-09_JPRB, 0.26072344E-09_JPRB, 0.26070968E-09_JPRB, &
  & 0.26069530E-09_JPRB, 0.26068120E-09_JPRB, 0.26066557E-09_JPRB, 0.26064087E-09_JPRB /)

RGHG5(:,59, 8) = (/ &
  & 0.25938213E-09_JPRB, 0.25949037E-09_JPRB, 0.25955557E-09_JPRB, 0.25962060E-09_JPRB, 0.25968855E-09_JPRB, 0.25976341E-09_JPRB, &
  & 0.25982477E-09_JPRB, 0.25986538E-09_JPRB, 0.25989311E-09_JPRB, 0.25991373E-09_JPRB, 0.25993260E-09_JPRB, 0.25995101E-09_JPRB, &
  & 0.25996855E-09_JPRB, 0.25998170E-09_JPRB, 0.25998434E-09_JPRB, 0.25997016E-09_JPRB, 0.25993466E-09_JPRB, 0.25987296E-09_JPRB, &
  & 0.25978644E-09_JPRB, 0.25968222E-09_JPRB, 0.25958025E-09_JPRB, 0.25952110E-09_JPRB, 0.25955965E-09_JPRB, 0.25972210E-09_JPRB, &
  & 0.25997357E-09_JPRB, 0.26025754E-09_JPRB, 0.26054472E-09_JPRB, 0.26082633E-09_JPRB, 0.26110586E-09_JPRB, 0.26138358E-09_JPRB, &
  & 0.26165362E-09_JPRB, 0.26189956E-09_JPRB, 0.26210090E-09_JPRB, 0.26224420E-09_JPRB, 0.26232352E-09_JPRB, 0.26234334E-09_JPRB, &
  & 0.26231012E-09_JPRB, 0.26223126E-09_JPRB, 0.26211497E-09_JPRB, 0.26197061E-09_JPRB, 0.26180877E-09_JPRB, 0.26164654E-09_JPRB, &
  & 0.26149666E-09_JPRB, 0.26136820E-09_JPRB, 0.26126154E-09_JPRB, 0.26117492E-09_JPRB, 0.26110500E-09_JPRB, 0.26104935E-09_JPRB, &
  & 0.26100555E-09_JPRB, 0.26097197E-09_JPRB, 0.26094493E-09_JPRB, 0.26092351E-09_JPRB, 0.26090688E-09_JPRB, 0.26089356E-09_JPRB, &
  & 0.26088234E-09_JPRB, 0.26087218E-09_JPRB, 0.26086128E-09_JPRB, 0.26084931E-09_JPRB, 0.26083474E-09_JPRB, 0.26081876E-09_JPRB, &
  & 0.26080249E-09_JPRB, 0.26078650E-09_JPRB, 0.26076968E-09_JPRB, 0.26074123E-09_JPRB /)

RGHG5(:,60, 8) = (/ &
  & 0.25971758E-09_JPRB, 0.25979635E-09_JPRB, 0.25984401E-09_JPRB, 0.25988822E-09_JPRB, 0.25993824E-09_JPRB, 0.25999058E-09_JPRB, &
  & 0.26003827E-09_JPRB, 0.26007196E-09_JPRB, 0.26009522E-09_JPRB, 0.26011404E-09_JPRB, 0.26013142E-09_JPRB, 0.26014943E-09_JPRB, &
  & 0.26016833E-09_JPRB, 0.26018449E-09_JPRB, 0.26019242E-09_JPRB, 0.26018440E-09_JPRB, 0.26015282E-09_JPRB, 0.26009239E-09_JPRB, &
  & 0.26000122E-09_JPRB, 0.25989008E-09_JPRB, 0.25978150E-09_JPRB, 0.25971608E-09_JPRB, 0.25974320E-09_JPRB, 0.25988531E-09_JPRB, &
  & 0.26011182E-09_JPRB, 0.26037594E-09_JPRB, 0.26064750E-09_JPRB, 0.26091870E-09_JPRB, 0.26118821E-09_JPRB, 0.26145802E-09_JPRB, &
  & 0.26172028E-09_JPRB, 0.26196040E-09_JPRB, 0.26215907E-09_JPRB, 0.26230057E-09_JPRB, 0.26238148E-09_JPRB, 0.26240468E-09_JPRB, &
  & 0.26237681E-09_JPRB, 0.26230462E-09_JPRB, 0.26219532E-09_JPRB, 0.26205801E-09_JPRB, 0.26190519E-09_JPRB, 0.26175076E-09_JPRB, &
  & 0.26160929E-09_JPRB, 0.26148600E-09_JPRB, 0.26138441E-09_JPRB, 0.26130118E-09_JPRB, 0.26123437E-09_JPRB, 0.26118085E-09_JPRB, &
  & 0.26113883E-09_JPRB, 0.26110536E-09_JPRB, 0.26107841E-09_JPRB, 0.26105457E-09_JPRB, 0.26103431E-09_JPRB, 0.26101643E-09_JPRB, &
  & 0.26100161E-09_JPRB, 0.26098712E-09_JPRB, 0.26097291E-09_JPRB, 0.26095659E-09_JPRB, 0.26093838E-09_JPRB, 0.26091862E-09_JPRB, &
  & 0.26089914E-09_JPRB, 0.26088084E-09_JPRB, 0.26086100E-09_JPRB, 0.26082922E-09_JPRB /)

RGHG5(:,61, 8) = (/ &
  & 0.25998576E-09_JPRB, 0.26004862E-09_JPRB, 0.26008534E-09_JPRB, 0.26011931E-09_JPRB, 0.26015537E-09_JPRB, 0.26019639E-09_JPRB, &
  & 0.26023450E-09_JPRB, 0.26026364E-09_JPRB, 0.26028527E-09_JPRB, 0.26030308E-09_JPRB, 0.26032068E-09_JPRB, 0.26033978E-09_JPRB, &
  & 0.26036082E-09_JPRB, 0.26038136E-09_JPRB, 0.26039443E-09_JPRB, 0.26039168E-09_JPRB, 0.26036401E-09_JPRB, 0.26030161E-09_JPRB, &
  & 0.26020747E-09_JPRB, 0.26009078E-09_JPRB, 0.25997787E-09_JPRB, 0.25990851E-09_JPRB, 0.25992569E-09_JPRB, 0.26004948E-09_JPRB, &
  & 0.26025440E-09_JPRB, 0.26049965E-09_JPRB, 0.26075803E-09_JPRB, 0.26101799E-09_JPRB, 0.26127919E-09_JPRB, 0.26153937E-09_JPRB, &
  & 0.26179386E-09_JPRB, 0.26202684E-09_JPRB, 0.26222002E-09_JPRB, 0.26235902E-09_JPRB, 0.26243890E-09_JPRB, 0.26246438E-09_JPRB, &
  & 0.26244118E-09_JPRB, 0.26237515E-09_JPRB, 0.26227306E-09_JPRB, 0.26214406E-09_JPRB, 0.26199942E-09_JPRB, 0.26185457E-09_JPRB, &
  & 0.26171965E-09_JPRB, 0.26160346E-09_JPRB, 0.26150548E-09_JPRB, 0.26142613E-09_JPRB, 0.26136168E-09_JPRB, 0.26131014E-09_JPRB, &
  & 0.26126917E-09_JPRB, 0.26123667E-09_JPRB, 0.26120950E-09_JPRB, 0.26118568E-09_JPRB, 0.26116184E-09_JPRB, 0.26114091E-09_JPRB, &
  & 0.26112013E-09_JPRB, 0.26110170E-09_JPRB, 0.26108188E-09_JPRB, 0.26106081E-09_JPRB, 0.26103725E-09_JPRB, 0.26101274E-09_JPRB, &
  & 0.26098923E-09_JPRB, 0.26096675E-09_JPRB, 0.26094238E-09_JPRB, 0.26090263E-09_JPRB /)

RGHG5(:,62, 8) = (/ &
  & 0.26021729E-09_JPRB, 0.26026725E-09_JPRB, 0.26029595E-09_JPRB, 0.26032235E-09_JPRB, 0.26035152E-09_JPRB, 0.26038421E-09_JPRB, &
  & 0.26041749E-09_JPRB, 0.26044461E-09_JPRB, 0.26046565E-09_JPRB, 0.26048436E-09_JPRB, 0.26050301E-09_JPRB, 0.26052444E-09_JPRB, &
  & 0.26054942E-09_JPRB, 0.26057442E-09_JPRB, 0.26059310E-09_JPRB, 0.26059452E-09_JPRB, 0.26056740E-09_JPRB, 0.26050517E-09_JPRB, &
  & 0.26040639E-09_JPRB, 0.26028765E-09_JPRB, 0.26017238E-09_JPRB, 0.26010000E-09_JPRB, 0.26010835E-09_JPRB, 0.26021543E-09_JPRB, &
  & 0.26040159E-09_JPRB, 0.26063005E-09_JPRB, 0.26087540E-09_JPRB, 0.26112601E-09_JPRB, 0.26137756E-09_JPRB, 0.26162961E-09_JPRB, &
  & 0.26187444E-09_JPRB, 0.26209918E-09_JPRB, 0.26228530E-09_JPRB, 0.26241892E-09_JPRB, 0.26249664E-09_JPRB, 0.26252275E-09_JPRB, &
  & 0.26250324E-09_JPRB, 0.26244321E-09_JPRB, 0.26234862E-09_JPRB, 0.26222793E-09_JPRB, 0.26209290E-09_JPRB, 0.26195612E-09_JPRB, &
  & 0.26182997E-09_JPRB, 0.26171879E-09_JPRB, 0.26162603E-09_JPRB, 0.26154956E-09_JPRB, 0.26148766E-09_JPRB, 0.26143776E-09_JPRB, &
  & 0.26139785E-09_JPRB, 0.26136573E-09_JPRB, 0.26133923E-09_JPRB, 0.26131500E-09_JPRB, 0.26129168E-09_JPRB, 0.26126587E-09_JPRB, &
  & 0.26124236E-09_JPRB, 0.26121694E-09_JPRB, 0.26119198E-09_JPRB, 0.26116426E-09_JPRB, 0.26113486E-09_JPRB, 0.26110472E-09_JPRB, &
  & 0.26107647E-09_JPRB, 0.26104857E-09_JPRB, 0.26101815E-09_JPRB, 0.26096597E-09_JPRB /)

RGHG5(:,63, 8) = (/ &
  & 0.26041422E-09_JPRB, 0.26045829E-09_JPRB, 0.26048347E-09_JPRB, 0.26050623E-09_JPRB, 0.26053079E-09_JPRB, 0.26055966E-09_JPRB, &
  & 0.26058969E-09_JPRB, 0.26061645E-09_JPRB, 0.26063876E-09_JPRB, 0.26065894E-09_JPRB, 0.26068075E-09_JPRB, 0.26070585E-09_JPRB, &
  & 0.26073560E-09_JPRB, 0.26076671E-09_JPRB, 0.26078925E-09_JPRB, 0.26079303E-09_JPRB, 0.26076663E-09_JPRB, 0.26070135E-09_JPRB, &
  & 0.26060246E-09_JPRB, 0.26048222E-09_JPRB, 0.26036637E-09_JPRB, 0.26029123E-09_JPRB, 0.26029182E-09_JPRB, 0.26038516E-09_JPRB, &
  & 0.26055383E-09_JPRB, 0.26076746E-09_JPRB, 0.26100083E-09_JPRB, 0.26124167E-09_JPRB, 0.26148483E-09_JPRB, 0.26172703E-09_JPRB, &
  & 0.26196251E-09_JPRB, 0.26217675E-09_JPRB, 0.26235386E-09_JPRB, 0.26248023E-09_JPRB, 0.26255403E-09_JPRB, 0.26257974E-09_JPRB, &
  & 0.26256305E-09_JPRB, 0.26250865E-09_JPRB, 0.26242170E-09_JPRB, 0.26231003E-09_JPRB, 0.26218433E-09_JPRB, 0.26205715E-09_JPRB, &
  & 0.26193805E-09_JPRB, 0.26183383E-09_JPRB, 0.26174488E-09_JPRB, 0.26167207E-09_JPRB, 0.26161240E-09_JPRB, 0.26156408E-09_JPRB, &
  & 0.26152505E-09_JPRB, 0.26149358E-09_JPRB, 0.26146743E-09_JPRB, 0.26144387E-09_JPRB, 0.26141975E-09_JPRB, 0.26139441E-09_JPRB, &
  & 0.26136515E-09_JPRB, 0.26133629E-09_JPRB, 0.26130403E-09_JPRB, 0.26127031E-09_JPRB, 0.26123412E-09_JPRB, 0.26119928E-09_JPRB, &
  & 0.26116470E-09_JPRB, 0.26113173E-09_JPRB, 0.26109143E-09_JPRB, 0.26102531E-09_JPRB /)

RGHG5(:,64, 8) = (/ &
  & 0.26058955E-09_JPRB, 0.26063118E-09_JPRB, 0.26065433E-09_JPRB, 0.26067515E-09_JPRB, 0.26069780E-09_JPRB, 0.26072383E-09_JPRB, &
  & 0.26075325E-09_JPRB, 0.26078023E-09_JPRB, 0.26080479E-09_JPRB, 0.26082836E-09_JPRB, 0.26085362E-09_JPRB, 0.26088440E-09_JPRB, &
  & 0.26092042E-09_JPRB, 0.26095612E-09_JPRB, 0.26098207E-09_JPRB, 0.26098615E-09_JPRB, 0.26095806E-09_JPRB, 0.26089314E-09_JPRB, &
  & 0.26079350E-09_JPRB, 0.26067423E-09_JPRB, 0.26055863E-09_JPRB, 0.26048216E-09_JPRB, 0.26047664E-09_JPRB, 0.26055766E-09_JPRB, &
  & 0.26071201E-09_JPRB, 0.26091126E-09_JPRB, 0.26113309E-09_JPRB, 0.26136440E-09_JPRB, 0.26159797E-09_JPRB, 0.26183045E-09_JPRB, &
  & 0.26205468E-09_JPRB, 0.26225741E-09_JPRB, 0.26242306E-09_JPRB, 0.26254079E-09_JPRB, 0.26260938E-09_JPRB, 0.26263386E-09_JPRB, &
  & 0.26261943E-09_JPRB, 0.26257049E-09_JPRB, 0.26249128E-09_JPRB, 0.26238892E-09_JPRB, 0.26227320E-09_JPRB, 0.26215508E-09_JPRB, &
  & 0.26204439E-09_JPRB, 0.26194591E-09_JPRB, 0.26186187E-09_JPRB, 0.26179225E-09_JPRB, 0.26173505E-09_JPRB, 0.26168828E-09_JPRB, &
  & 0.26165028E-09_JPRB, 0.26161956E-09_JPRB, 0.26159386E-09_JPRB, 0.26157068E-09_JPRB, 0.26154712E-09_JPRB, 0.26152031E-09_JPRB, &
  & 0.26149038E-09_JPRB, 0.26145605E-09_JPRB, 0.26141939E-09_JPRB, 0.26137906E-09_JPRB, 0.26133837E-09_JPRB, 0.26129718E-09_JPRB, &
  & 0.26125885E-09_JPRB, 0.26121766E-09_JPRB, 0.26116956E-09_JPRB, 0.26108180E-09_JPRB /)

RGHG5(:,65, 8) = (/ &
  & 0.26074770E-09_JPRB, 0.26078958E-09_JPRB, 0.26081290E-09_JPRB, 0.26083344E-09_JPRB, 0.26085525E-09_JPRB, 0.26088096E-09_JPRB, &
  & 0.26090893E-09_JPRB, 0.26093869E-09_JPRB, 0.26096519E-09_JPRB, 0.26099306E-09_JPRB, 0.26102376E-09_JPRB, 0.26106028E-09_JPRB, &
  & 0.26110225E-09_JPRB, 0.26114205E-09_JPRB, 0.26116823E-09_JPRB, 0.26117170E-09_JPRB, 0.26114336E-09_JPRB, 0.26107813E-09_JPRB, &
  & 0.26098032E-09_JPRB, 0.26086272E-09_JPRB, 0.26074914E-09_JPRB, 0.26067221E-09_JPRB, 0.26066227E-09_JPRB, 0.26073382E-09_JPRB, &
  & 0.26087466E-09_JPRB, 0.26106081E-09_JPRB, 0.26127089E-09_JPRB, 0.26149138E-09_JPRB, 0.26171473E-09_JPRB, 0.26193592E-09_JPRB, &
  & 0.26214761E-09_JPRB, 0.26233693E-09_JPRB, 0.26248989E-09_JPRB, 0.26259789E-09_JPRB, 0.26266078E-09_JPRB, 0.26268349E-09_JPRB, &
  & 0.26267108E-09_JPRB, 0.26262734E-09_JPRB, 0.26255603E-09_JPRB, 0.26246330E-09_JPRB, 0.26235772E-09_JPRB, 0.26224942E-09_JPRB, &
  & 0.26214678E-09_JPRB, 0.26205488E-09_JPRB, 0.26197555E-09_JPRB, 0.26190958E-09_JPRB, 0.26185465E-09_JPRB, 0.26180969E-09_JPRB, &
  & 0.26177294E-09_JPRB, 0.26174310E-09_JPRB, 0.26171809E-09_JPRB, 0.26169550E-09_JPRB, 0.26167224E-09_JPRB, 0.26164554E-09_JPRB, &
  & 0.26161376E-09_JPRB, 0.26157726E-09_JPRB, 0.26153599E-09_JPRB, 0.26149180E-09_JPRB, 0.26144592E-09_JPRB, 0.26140173E-09_JPRB, &
  & 0.26135713E-09_JPRB, 0.26131164E-09_JPRB, 0.26125149E-09_JPRB, 0.26114594E-09_JPRB /)

RGHG5(:,66, 8) = (/ &
  & 0.26089236E-09_JPRB, 0.26093788E-09_JPRB, 0.26096272E-09_JPRB, 0.26098440E-09_JPRB, 0.26100705E-09_JPRB, 0.26103247E-09_JPRB, &
  & 0.26106242E-09_JPRB, 0.26109148E-09_JPRB, 0.26112373E-09_JPRB, 0.26115449E-09_JPRB, 0.26119124E-09_JPRB, 0.26123376E-09_JPRB, &
  & 0.26127955E-09_JPRB, 0.26132030E-09_JPRB, 0.26134636E-09_JPRB, 0.26134916E-09_JPRB, 0.26132072E-09_JPRB, 0.26125715E-09_JPRB, &
  & 0.26116187E-09_JPRB, 0.26104774E-09_JPRB, 0.26093716E-09_JPRB, 0.26086194E-09_JPRB, 0.26084906E-09_JPRB, 0.26091232E-09_JPRB, &
  & 0.26104122E-09_JPRB, 0.26121438E-09_JPRB, 0.26141156E-09_JPRB, 0.26162014E-09_JPRB, 0.26183142E-09_JPRB, 0.26203967E-09_JPRB, &
  & 0.26223743E-09_JPRB, 0.26241201E-09_JPRB, 0.26255179E-09_JPRB, 0.26264974E-09_JPRB, 0.26270677E-09_JPRB, 0.26272759E-09_JPRB, &
  & 0.26271699E-09_JPRB, 0.26267835E-09_JPRB, 0.26261485E-09_JPRB, 0.26253183E-09_JPRB, 0.26243677E-09_JPRB, 0.26233846E-09_JPRB, &
  & 0.26224434E-09_JPRB, 0.26215938E-09_JPRB, 0.26208510E-09_JPRB, 0.26202279E-09_JPRB, 0.26197064E-09_JPRB, 0.26192762E-09_JPRB, &
  & 0.26189242E-09_JPRB, 0.26186381E-09_JPRB, 0.26183988E-09_JPRB, 0.26181821E-09_JPRB, 0.26179547E-09_JPRB, 0.26176880E-09_JPRB, &
  & 0.26173644E-09_JPRB, 0.26169805E-09_JPRB, 0.26165436E-09_JPRB, 0.26160676E-09_JPRB, 0.26155814E-09_JPRB, 0.26151017E-09_JPRB, &
  & 0.26146230E-09_JPRB, 0.26141186E-09_JPRB, 0.26134336E-09_JPRB, 0.26121946E-09_JPRB /)

RGHG5(:,67, 8) = (/ &
  & 0.26102620E-09_JPRB, 0.26107819E-09_JPRB, 0.26110647E-09_JPRB, 0.26113067E-09_JPRB, 0.26115532E-09_JPRB, 0.26118274E-09_JPRB, &
  & 0.26121227E-09_JPRB, 0.26124636E-09_JPRB, 0.26127817E-09_JPRB, 0.26131639E-09_JPRB, 0.26135619E-09_JPRB, 0.26140268E-09_JPRB, &
  & 0.26144983E-09_JPRB, 0.26149000E-09_JPRB, 0.26151542E-09_JPRB, 0.26151797E-09_JPRB, 0.26149044E-09_JPRB, 0.26142932E-09_JPRB, &
  & 0.26133806E-09_JPRB, 0.26122879E-09_JPRB, 0.26112357E-09_JPRB, 0.26105060E-09_JPRB, 0.26103628E-09_JPRB, 0.26109215E-09_JPRB, &
  & 0.26120961E-09_JPRB, 0.26136929E-09_JPRB, 0.26155295E-09_JPRB, 0.26174779E-09_JPRB, 0.26194535E-09_JPRB, 0.26213937E-09_JPRB, &
  & 0.26232164E-09_JPRB, 0.26248145E-09_JPRB, 0.26260782E-09_JPRB, 0.26269609E-09_JPRB, 0.26274741E-09_JPRB, 0.26276628E-09_JPRB, &
  & 0.26275734E-09_JPRB, 0.26272345E-09_JPRB, 0.26266744E-09_JPRB, 0.26259389E-09_JPRB, 0.26250935E-09_JPRB, 0.26242114E-09_JPRB, &
  & 0.26233610E-09_JPRB, 0.26225797E-09_JPRB, 0.26218944E-09_JPRB, 0.26213115E-09_JPRB, 0.26208205E-09_JPRB, 0.26204158E-09_JPRB, &
  & 0.26200830E-09_JPRB, 0.26198133E-09_JPRB, 0.26195882E-09_JPRB, 0.26193828E-09_JPRB, 0.26191649E-09_JPRB, 0.26189037E-09_JPRB, &
  & 0.26185798E-09_JPRB, 0.26181887E-09_JPRB, 0.26177363E-09_JPRB, 0.26172436E-09_JPRB, 0.26167343E-09_JPRB, 0.26162353E-09_JPRB, &
  & 0.26157296E-09_JPRB, 0.26151950E-09_JPRB, 0.26144426E-09_JPRB, 0.26130215E-09_JPRB /)

RGHG5(:,68, 8) = (/ &
  & 0.26114796E-09_JPRB, 0.26121164E-09_JPRB, 0.26124600E-09_JPRB, 0.26127450E-09_JPRB, 0.26130259E-09_JPRB, 0.26133207E-09_JPRB, &
  & 0.26136457E-09_JPRB, 0.26139779E-09_JPRB, 0.26143632E-09_JPRB, 0.26147418E-09_JPRB, 0.26151900E-09_JPRB, 0.26156560E-09_JPRB, &
  & 0.26161182E-09_JPRB, 0.26165087E-09_JPRB, 0.26167565E-09_JPRB, 0.26167832E-09_JPRB, 0.26165239E-09_JPRB, 0.26159472E-09_JPRB, &
  & 0.26150876E-09_JPRB, 0.26140617E-09_JPRB, 0.26130695E-09_JPRB, 0.26123814E-09_JPRB, 0.26122263E-09_JPRB, 0.26127178E-09_JPRB, &
  & 0.26137770E-09_JPRB, 0.26152375E-09_JPRB, 0.26169267E-09_JPRB, 0.26187272E-09_JPRB, 0.26205518E-09_JPRB, 0.26223362E-09_JPRB, &
  & 0.26240027E-09_JPRB, 0.26254487E-09_JPRB, 0.26265845E-09_JPRB, 0.26273719E-09_JPRB, 0.26278313E-09_JPRB, 0.26280023E-09_JPRB, &
  & 0.26279287E-09_JPRB, 0.26276326E-09_JPRB, 0.26271418E-09_JPRB, 0.26264971E-09_JPRB, 0.26257510E-09_JPRB, 0.26249714E-09_JPRB, &
  & 0.26242089E-09_JPRB, 0.26235045E-09_JPRB, 0.26228772E-09_JPRB, 0.26223385E-09_JPRB, 0.26218852E-09_JPRB, 0.26215086E-09_JPRB, &
  & 0.26212019E-09_JPRB, 0.26209529E-09_JPRB, 0.26207450E-09_JPRB, 0.26205543E-09_JPRB, 0.26203495E-09_JPRB, 0.26200983E-09_JPRB, &
  & 0.26197819E-09_JPRB, 0.26193925E-09_JPRB, 0.26189381E-09_JPRB, 0.26184402E-09_JPRB, 0.26179228E-09_JPRB, 0.26174179E-09_JPRB, &
  & 0.26168970E-09_JPRB, 0.26163588E-09_JPRB, 0.26155572E-09_JPRB, 0.26140365E-09_JPRB /)

RGHG5(:,69, 8) = (/ &
  & 0.26125790E-09_JPRB, 0.26134106E-09_JPRB, 0.26138358E-09_JPRB, 0.26141841E-09_JPRB, 0.26145061E-09_JPRB, 0.26148320E-09_JPRB, &
  & 0.26151670E-09_JPRB, 0.26155306E-09_JPRB, 0.26159086E-09_JPRB, 0.26163263E-09_JPRB, 0.26167632E-09_JPRB, 0.26172234E-09_JPRB, &
  & 0.26176666E-09_JPRB, 0.26180394E-09_JPRB, 0.26182775E-09_JPRB, 0.26183072E-09_JPRB, 0.26180688E-09_JPRB, 0.26175370E-09_JPRB, &
  & 0.26167440E-09_JPRB, 0.26157956E-09_JPRB, 0.26148814E-09_JPRB, 0.26142349E-09_JPRB, 0.26140751E-09_JPRB, 0.26144978E-09_JPRB, &
  & 0.26154431E-09_JPRB, 0.26167596E-09_JPRB, 0.26182964E-09_JPRB, 0.26199395E-09_JPRB, 0.26216035E-09_JPRB, 0.26232272E-09_JPRB, &
  & 0.26247332E-09_JPRB, 0.26260313E-09_JPRB, 0.26270419E-09_JPRB, 0.26277416E-09_JPRB, 0.26281488E-09_JPRB, 0.26283020E-09_JPRB, &
  & 0.26282410E-09_JPRB, 0.26279851E-09_JPRB, 0.26275596E-09_JPRB, 0.26269978E-09_JPRB, 0.26263472E-09_JPRB, 0.26256619E-09_JPRB, &
  & 0.26249886E-09_JPRB, 0.26243616E-09_JPRB, 0.26237981E-09_JPRB, 0.26233102E-09_JPRB, 0.26228963E-09_JPRB, 0.26225555E-09_JPRB, &
  & 0.26222777E-09_JPRB, 0.26220537E-09_JPRB, 0.26218669E-09_JPRB, 0.26216945E-09_JPRB, 0.26215063E-09_JPRB, 0.26212699E-09_JPRB, &
  & 0.26209682E-09_JPRB, 0.26205918E-09_JPRB, 0.26201480E-09_JPRB, 0.26196592E-09_JPRB, 0.26191471E-09_JPRB, 0.26186531E-09_JPRB, &
  & 0.26181352E-09_JPRB, 0.26176011E-09_JPRB, 0.26167959E-09_JPRB, 0.26151650E-09_JPRB /)

RGHG5(:,70, 8) = (/ &
  & 0.26135935E-09_JPRB, 0.26146751E-09_JPRB, 0.26152325E-09_JPRB, 0.26156466E-09_JPRB, 0.26160185E-09_JPRB, 0.26163660E-09_JPRB, &
  & 0.26167157E-09_JPRB, 0.26170816E-09_JPRB, 0.26174679E-09_JPRB, 0.26178751E-09_JPRB, 0.26182964E-09_JPRB, 0.26187336E-09_JPRB, &
  & 0.26191499E-09_JPRB, 0.26194999E-09_JPRB, 0.26197255E-09_JPRB, 0.26197569E-09_JPRB, 0.26195440E-09_JPRB, 0.26190633E-09_JPRB, &
  & 0.26183458E-09_JPRB, 0.26174887E-09_JPRB, 0.26166558E-09_JPRB, 0.26160618E-09_JPRB, 0.26158964E-09_JPRB, 0.26162519E-09_JPRB, &
  & 0.26170793E-09_JPRB, 0.26182523E-09_JPRB, 0.26196323E-09_JPRB, 0.26211128E-09_JPRB, 0.26226113E-09_JPRB, 0.26240696E-09_JPRB, &
  & 0.26254154E-09_JPRB, 0.26265681E-09_JPRB, 0.26274585E-09_JPRB, 0.26280733E-09_JPRB, 0.26284311E-09_JPRB, 0.26285674E-09_JPRB, &
  & 0.26285174E-09_JPRB, 0.26282981E-09_JPRB, 0.26279323E-09_JPRB, 0.26274466E-09_JPRB, 0.26268848E-09_JPRB, 0.26262884E-09_JPRB, &
  & 0.26257044E-09_JPRB, 0.26251534E-09_JPRB, 0.26246588E-09_JPRB, 0.26242233E-09_JPRB, 0.26238550E-09_JPRB, 0.26235517E-09_JPRB, &
  & 0.26233082E-09_JPRB, 0.26231120E-09_JPRB, 0.26229488E-09_JPRB, 0.26227978E-09_JPRB, 0.26226271E-09_JPRB, 0.26224134E-09_JPRB, &
  & 0.26221322E-09_JPRB, 0.26217803E-09_JPRB, 0.26213584E-09_JPRB, 0.26208954E-09_JPRB, 0.26204053E-09_JPRB, 0.26199382E-09_JPRB, &
  & 0.26194405E-09_JPRB, 0.26189367E-09_JPRB, 0.26181601E-09_JPRB, 0.26165597E-09_JPRB /)

RGHG5(:,71, 8) = (/ &
  & 0.26145783E-09_JPRB, 0.26160046E-09_JPRB, 0.26166772E-09_JPRB, 0.26171687E-09_JPRB, 0.26175700E-09_JPRB, 0.26179375E-09_JPRB, &
  & 0.26182906E-09_JPRB, 0.26186464E-09_JPRB, 0.26190305E-09_JPRB, 0.26193947E-09_JPRB, 0.26198022E-09_JPRB, 0.26201952E-09_JPRB, &
  & 0.26205813E-09_JPRB, 0.26209021E-09_JPRB, 0.26211089E-09_JPRB, 0.26211400E-09_JPRB, 0.26209537E-09_JPRB, 0.26205266E-09_JPRB, &
  & 0.26198915E-09_JPRB, 0.26191288E-09_JPRB, 0.26183863E-09_JPRB, 0.26178448E-09_JPRB, 0.26176797E-09_JPRB, 0.26179683E-09_JPRB, &
  & 0.26186797E-09_JPRB, 0.26197072E-09_JPRB, 0.26209282E-09_JPRB, 0.26222455E-09_JPRB, 0.26235747E-09_JPRB, 0.26248667E-09_JPRB, &
  & 0.26260535E-09_JPRB, 0.26270636E-09_JPRB, 0.26278382E-09_JPRB, 0.26283714E-09_JPRB, 0.26286834E-09_JPRB, 0.26288030E-09_JPRB, &
  & 0.26287622E-09_JPRB, 0.26285765E-09_JPRB, 0.26282648E-09_JPRB, 0.26278502E-09_JPRB, 0.26273678E-09_JPRB, 0.26268601E-09_JPRB, &
  & 0.26263536E-09_JPRB, 0.26258845E-09_JPRB, 0.26254554E-09_JPRB, 0.26250777E-09_JPRB, 0.26247560E-09_JPRB, 0.26244940E-09_JPRB, &
  & 0.26242852E-09_JPRB, 0.26241187E-09_JPRB, 0.26239810E-09_JPRB, 0.26238517E-09_JPRB, 0.26237032E-09_JPRB, 0.26235128E-09_JPRB, &
  & 0.26232633E-09_JPRB, 0.26229424E-09_JPRB, 0.26225563E-09_JPRB, 0.26221314E-09_JPRB, 0.26216784E-09_JPRB, 0.26212493E-09_JPRB, &
  & 0.26207952E-09_JPRB, 0.26203248E-09_JPRB, 0.26196340E-09_JPRB, 0.26181196E-09_JPRB /)

RGHG5(:,72, 8) = (/ &
  & 0.26156743E-09_JPRB, 0.26174185E-09_JPRB, 0.26182195E-09_JPRB, 0.26187499E-09_JPRB, 0.26191774E-09_JPRB, 0.26195451E-09_JPRB, &
  & 0.26198901E-09_JPRB, 0.26202435E-09_JPRB, 0.26205660E-09_JPRB, 0.26209368E-09_JPRB, 0.26212585E-09_JPRB, 0.26216357E-09_JPRB, &
  & 0.26219688E-09_JPRB, 0.26222557E-09_JPRB, 0.26224395E-09_JPRB, 0.26224653E-09_JPRB, 0.26222990E-09_JPRB, 0.26219302E-09_JPRB, &
  & 0.26213726E-09_JPRB, 0.26207084E-09_JPRB, 0.26200564E-09_JPRB, 0.26195740E-09_JPRB, 0.26194130E-09_JPRB, 0.26196401E-09_JPRB, &
  & 0.26202371E-09_JPRB, 0.26211178E-09_JPRB, 0.26221819E-09_JPRB, 0.26233338E-09_JPRB, 0.26244945E-09_JPRB, 0.26256203E-09_JPRB, &
  & 0.26266514E-09_JPRB, 0.26275201E-09_JPRB, 0.26281846E-09_JPRB, 0.26286401E-09_JPRB, 0.26289079E-09_JPRB, 0.26290115E-09_JPRB, &
  & 0.26289793E-09_JPRB, 0.26288235E-09_JPRB, 0.26285624E-09_JPRB, 0.26282110E-09_JPRB, 0.26278071E-09_JPRB, 0.26273750E-09_JPRB, &
  & 0.26269503E-09_JPRB, 0.26265498E-09_JPRB, 0.26261909E-09_JPRB, 0.26258676E-09_JPRB, 0.26255959E-09_JPRB, 0.26253752E-09_JPRB, &
  & 0.26252012E-09_JPRB, 0.26250643E-09_JPRB, 0.26249494E-09_JPRB, 0.26248420E-09_JPRB, 0.26247143E-09_JPRB, 0.26245550E-09_JPRB, &
  & 0.26243357E-09_JPRB, 0.26240590E-09_JPRB, 0.26237165E-09_JPRB, 0.26233382E-09_JPRB, 0.26229355E-09_JPRB, 0.26225555E-09_JPRB, &
  & 0.26221486E-09_JPRB, 0.26217339E-09_JPRB, 0.26211117E-09_JPRB, 0.26197464E-09_JPRB /)

RGHG5(:,73, 8) = (/ &
  & 0.26171354E-09_JPRB, 0.26190275E-09_JPRB, 0.26198474E-09_JPRB, 0.26203922E-09_JPRB, 0.26208066E-09_JPRB, 0.26211680E-09_JPRB, &
  & 0.26215036E-09_JPRB, 0.26218042E-09_JPRB, 0.26221383E-09_JPRB, 0.26223984E-09_JPRB, 0.26227387E-09_JPRB, 0.26230185E-09_JPRB, &
  & 0.26233232E-09_JPRB, 0.26235622E-09_JPRB, 0.26237160E-09_JPRB, 0.26237307E-09_JPRB, 0.26235844E-09_JPRB, 0.26232588E-09_JPRB, &
  & 0.26227848E-09_JPRB, 0.26222116E-09_JPRB, 0.26216534E-09_JPRB, 0.26212335E-09_JPRB, 0.26210825E-09_JPRB, 0.26212532E-09_JPRB, &
  & 0.26217398E-09_JPRB, 0.26224781E-09_JPRB, 0.26233848E-09_JPRB, 0.26243752E-09_JPRB, 0.26253674E-09_JPRB, 0.26263319E-09_JPRB, &
  & 0.26272073E-09_JPRB, 0.26279426E-09_JPRB, 0.26284996E-09_JPRB, 0.26288824E-09_JPRB, 0.26291083E-09_JPRB, 0.26291963E-09_JPRB, &
  & 0.26291708E-09_JPRB, 0.26290425E-09_JPRB, 0.26288277E-09_JPRB, 0.26285363E-09_JPRB, 0.26282024E-09_JPRB, 0.26278446E-09_JPRB, &
  & 0.26274882E-09_JPRB, 0.26271582E-09_JPRB, 0.26268607E-09_JPRB, 0.26265931E-09_JPRB, 0.26263686E-09_JPRB, 0.26261901E-09_JPRB, &
  & 0.26260480E-09_JPRB, 0.26259389E-09_JPRB, 0.26258459E-09_JPRB, 0.26257579E-09_JPRB, 0.26256539E-09_JPRB, 0.26255190E-09_JPRB, &
  & 0.26253397E-09_JPRB, 0.26251024E-09_JPRB, 0.26248112E-09_JPRB, 0.26244862E-09_JPRB, 0.26241403E-09_JPRB, 0.26238101E-09_JPRB, &
  & 0.26234631E-09_JPRB, 0.26230931E-09_JPRB, 0.26225566E-09_JPRB, 0.26213268E-09_JPRB /)

RGHG5(:,74, 8) = (/ &
  & 0.26187749E-09_JPRB, 0.26207009E-09_JPRB, 0.26215224E-09_JPRB, 0.26220254E-09_JPRB, 0.26224259E-09_JPRB, 0.26227595E-09_JPRB, &
  & 0.26230576E-09_JPRB, 0.26233546E-09_JPRB, 0.26235941E-09_JPRB, 0.26238844E-09_JPRB, 0.26240954E-09_JPRB, 0.26243835E-09_JPRB, &
  & 0.26246044E-09_JPRB, 0.26248043E-09_JPRB, 0.26249250E-09_JPRB, 0.26249247E-09_JPRB, 0.26247909E-09_JPRB, 0.26245170E-09_JPRB, &
  & 0.26241101E-09_JPRB, 0.26236308E-09_JPRB, 0.26231636E-09_JPRB, 0.26228070E-09_JPRB, 0.26226712E-09_JPRB, 0.26227936E-09_JPRB, &
  & 0.26231808E-09_JPRB, 0.26237812E-09_JPRB, 0.26245361E-09_JPRB, 0.26253652E-09_JPRB, 0.26261920E-09_JPRB, 0.26270008E-09_JPRB, &
  & 0.26277250E-09_JPRB, 0.26283301E-09_JPRB, 0.26287880E-09_JPRB, 0.26291005E-09_JPRB, 0.26292873E-09_JPRB, 0.26293595E-09_JPRB, &
  & 0.26293404E-09_JPRB, 0.26292368E-09_JPRB, 0.26290639E-09_JPRB, 0.26288266E-09_JPRB, 0.26285588E-09_JPRB, 0.26282679E-09_JPRB, &
  & 0.26279762E-09_JPRB, 0.26277086E-09_JPRB, 0.26274719E-09_JPRB, 0.26272540E-09_JPRB, 0.26270763E-09_JPRB, 0.26269342E-09_JPRB, &
  & 0.26268238E-09_JPRB, 0.26267394E-09_JPRB, 0.26266656E-09_JPRB, 0.26265962E-09_JPRB, 0.26265104E-09_JPRB, 0.26264066E-09_JPRB, &
  & 0.26262559E-09_JPRB, 0.26260658E-09_JPRB, 0.26258226E-09_JPRB, 0.26255514E-09_JPRB, 0.26252678E-09_JPRB, 0.26249899E-09_JPRB, &
  & 0.26246974E-09_JPRB, 0.26243821E-09_JPRB, 0.26239177E-09_JPRB, 0.26228200E-09_JPRB /)

RGHG5(:,75, 8) = (/ &
  & 0.26204927E-09_JPRB, 0.26224084E-09_JPRB, 0.26231525E-09_JPRB, 0.26236191E-09_JPRB, 0.26239672E-09_JPRB, 0.26242664E-09_JPRB, &
  & 0.26245373E-09_JPRB, 0.26247690E-09_JPRB, 0.26250205E-09_JPRB, 0.26251953E-09_JPRB, 0.26254329E-09_JPRB, 0.26256097E-09_JPRB, &
  & 0.26258060E-09_JPRB, 0.26259514E-09_JPRB, 0.26260430E-09_JPRB, 0.26260316E-09_JPRB, 0.26259150E-09_JPRB, 0.26256866E-09_JPRB, &
  & 0.26253547E-09_JPRB, 0.26249614E-09_JPRB, 0.26245828E-09_JPRB, 0.26242877E-09_JPRB, 0.26241698E-09_JPRB, 0.26242533E-09_JPRB, &
  & 0.26245509E-09_JPRB, 0.26250246E-09_JPRB, 0.26256319E-09_JPRB, 0.26263017E-09_JPRB, 0.26269700E-09_JPRB, 0.26276262E-09_JPRB, &
  & 0.26282032E-09_JPRB, 0.26286867E-09_JPRB, 0.26290486E-09_JPRB, 0.26292976E-09_JPRB, 0.26294467E-09_JPRB, 0.26295027E-09_JPRB, &
  & 0.26294902E-09_JPRB, 0.26294089E-09_JPRB, 0.26292751E-09_JPRB, 0.26290875E-09_JPRB, 0.26288816E-09_JPRB, 0.26286506E-09_JPRB, &
  & 0.26284191E-09_JPRB, 0.26282077E-09_JPRB, 0.26280259E-09_JPRB, 0.26278557E-09_JPRB, 0.26277189E-09_JPRB, 0.26276134E-09_JPRB, &
  & 0.26275293E-09_JPRB, 0.26274688E-09_JPRB, 0.26274111E-09_JPRB, 0.26273589E-09_JPRB, 0.26272923E-09_JPRB, 0.26272115E-09_JPRB, &
  & 0.26270947E-09_JPRB, 0.26269417E-09_JPRB, 0.26267477E-09_JPRB, 0.26265309E-09_JPRB, 0.26263042E-09_JPRB, 0.26260816E-09_JPRB, &
  & 0.26258418E-09_JPRB, 0.26255831E-09_JPRB, 0.26251756E-09_JPRB, 0.26242200E-09_JPRB /)

RGHG5(:,76, 8) = (/ &
  & 0.26222929E-09_JPRB, 0.26240621E-09_JPRB, 0.26247385E-09_JPRB, 0.26251171E-09_JPRB, 0.26254166E-09_JPRB, 0.26256611E-09_JPRB, &
  & 0.26258831E-09_JPRB, 0.26260943E-09_JPRB, 0.26262625E-09_JPRB, 0.26264482E-09_JPRB, 0.26265751E-09_JPRB, 0.26267538E-09_JPRB, &
  & 0.26268759E-09_JPRB, 0.26269870E-09_JPRB, 0.26270558E-09_JPRB, 0.26270372E-09_JPRB, 0.26269417E-09_JPRB, 0.26267646E-09_JPRB, &
  & 0.26265043E-09_JPRB, 0.26261970E-09_JPRB, 0.26259037E-09_JPRB, 0.26256677E-09_JPRB, 0.26255728E-09_JPRB, 0.26256264E-09_JPRB, &
  & 0.26258484E-09_JPRB, 0.26262026E-09_JPRB, 0.26266678E-09_JPRB, 0.26271862E-09_JPRB, 0.26276997E-09_JPRB, 0.26282052E-09_JPRB, &
  & 0.26286462E-09_JPRB, 0.26290115E-09_JPRB, 0.26292868E-09_JPRB, 0.26294747E-09_JPRB, 0.26295893E-09_JPRB, 0.26296298E-09_JPRB, &
  & 0.26296226E-09_JPRB, 0.26295610E-09_JPRB, 0.26294630E-09_JPRB, 0.26293204E-09_JPRB, 0.26291716E-09_JPRB, 0.26289981E-09_JPRB, &
  & 0.26288183E-09_JPRB, 0.26286601E-09_JPRB, 0.26285288E-09_JPRB, 0.26283997E-09_JPRB, 0.26283034E-09_JPRB, 0.26282271E-09_JPRB, &
  & 0.26281671E-09_JPRB, 0.26281277E-09_JPRB, 0.26280841E-09_JPRB, 0.26280472E-09_JPRB, 0.26279975E-09_JPRB, 0.26279423E-09_JPRB, &
  & 0.26278524E-09_JPRB, 0.26277391E-09_JPRB, 0.26275884E-09_JPRB, 0.26274238E-09_JPRB, 0.26272567E-09_JPRB, 0.26270830E-09_JPRB, &
  & 0.26269009E-09_JPRB, 0.26266905E-09_JPRB, 0.26263605E-09_JPRB, 0.26254959E-09_JPRB /)

RGHG5(:,77, 8) = (/ &
  & 0.26241062E-09_JPRB, 0.26256747E-09_JPRB, 0.26262231E-09_JPRB, 0.26265184E-09_JPRB, 0.26267427E-09_JPRB, 0.26269315E-09_JPRB, &
  & 0.26271008E-09_JPRB, 0.26272498E-09_JPRB, 0.26274016E-09_JPRB, 0.26274988E-09_JPRB, 0.26276184E-09_JPRB, 0.26277239E-09_JPRB, &
  & 0.26278174E-09_JPRB, 0.26278918E-09_JPRB, 0.26279456E-09_JPRB, 0.26279251E-09_JPRB, 0.26278540E-09_JPRB, 0.26277280E-09_JPRB, &
  & 0.26275412E-09_JPRB, 0.26273167E-09_JPRB, 0.26271058E-09_JPRB, 0.26269292E-09_JPRB, 0.26268615E-09_JPRB, 0.26268954E-09_JPRB, &
  & 0.26270539E-09_JPRB, 0.26273000E-09_JPRB, 0.26276326E-09_JPRB, 0.26280067E-09_JPRB, 0.26283714E-09_JPRB, 0.26287356E-09_JPRB, &
  & 0.26290473E-09_JPRB, 0.26293062E-09_JPRB, 0.26294997E-09_JPRB, 0.26296329E-09_JPRB, 0.26297156E-09_JPRB, 0.26297409E-09_JPRB, &
  & 0.26297386E-09_JPRB, 0.26296942E-09_JPRB, 0.26296296E-09_JPRB, 0.26295266E-09_JPRB, 0.26294322E-09_JPRB, 0.26293093E-09_JPRB, &
  & 0.26291785E-09_JPRB, 0.26290645E-09_JPRB, 0.26289787E-09_JPRB, 0.26288874E-09_JPRB, 0.26288238E-09_JPRB, 0.26287739E-09_JPRB, &
  & 0.26287308E-09_JPRB, 0.26287106E-09_JPRB, 0.26286781E-09_JPRB, 0.26286565E-09_JPRB, 0.26286207E-09_JPRB, 0.26285898E-09_JPRB, &
  & 0.26285263E-09_JPRB, 0.26284497E-09_JPRB, 0.26283417E-09_JPRB, 0.26282285E-09_JPRB, 0.26281152E-09_JPRB, 0.26279945E-09_JPRB, &
  & 0.26278604E-09_JPRB, 0.26277125E-09_JPRB, 0.26274302E-09_JPRB, 0.26267119E-09_JPRB /)

RGHG5(:,78, 8) = (/ &
  & 0.26259450E-09_JPRB, 0.26271396E-09_JPRB, 0.26275251E-09_JPRB, 0.26277183E-09_JPRB, 0.26278771E-09_JPRB, 0.26279995E-09_JPRB, &
  & 0.26281152E-09_JPRB, 0.26282149E-09_JPRB, 0.26283076E-09_JPRB, 0.26283736E-09_JPRB, 0.26284291E-09_JPRB, 0.26285199E-09_JPRB, &
  & 0.26285732E-09_JPRB, 0.26286237E-09_JPRB, 0.26286676E-09_JPRB, 0.26286459E-09_JPRB, 0.26285985E-09_JPRB, 0.26285188E-09_JPRB, &
  & 0.26283969E-09_JPRB, 0.26282490E-09_JPRB, 0.26281161E-09_JPRB, 0.26279948E-09_JPRB, 0.26279612E-09_JPRB, 0.26279851E-09_JPRB, &
  & 0.26280969E-09_JPRB, 0.26282501E-09_JPRB, 0.26284688E-09_JPRB, 0.26287195E-09_JPRB, 0.26289484E-09_JPRB, 0.26291916E-09_JPRB, &
  & 0.26293892E-09_JPRB, 0.26295566E-09_JPRB, 0.26296793E-09_JPRB, 0.26297650E-09_JPRB, 0.26298211E-09_JPRB, 0.26298339E-09_JPRB, &
  & 0.26298363E-09_JPRB, 0.26298044E-09_JPRB, 0.26297675E-09_JPRB, 0.26296984E-09_JPRB, 0.26296504E-09_JPRB, 0.26295716E-09_JPRB, &
  & 0.26294794E-09_JPRB, 0.26294042E-09_JPRB, 0.26293551E-09_JPRB, 0.26292929E-09_JPRB, 0.26292560E-09_JPRB, 0.26292241E-09_JPRB, &
  & 0.26291933E-09_JPRB, 0.26291869E-09_JPRB, 0.26291613E-09_JPRB, 0.26291513E-09_JPRB, 0.26291269E-09_JPRB, 0.26291183E-09_JPRB, &
  & 0.26290775E-09_JPRB, 0.26290350E-09_JPRB, 0.26289645E-09_JPRB, 0.26288965E-09_JPRB, 0.26288366E-09_JPRB, 0.26287583E-09_JPRB, &
  & 0.26286731E-09_JPRB, 0.26285735E-09_JPRB, 0.26283822E-09_JPRB, 0.26278307E-09_JPRB /)

RGHG5(:,79, 8) = (/ &
  & 0.26271424E-09_JPRB, 0.26279673E-09_JPRB, 0.26282229E-09_JPRB, 0.26283450E-09_JPRB, 0.26284669E-09_JPRB, 0.26285582E-09_JPRB, &
  & 0.26286423E-09_JPRB, 0.26287128E-09_JPRB, 0.26287883E-09_JPRB, 0.26288202E-09_JPRB, 0.26288585E-09_JPRB, 0.26289310E-09_JPRB, &
  & 0.26289673E-09_JPRB, 0.26290053E-09_JPRB, 0.26290456E-09_JPRB, 0.26290223E-09_JPRB, 0.26289868E-09_JPRB, 0.26289315E-09_JPRB, &
  & 0.26288471E-09_JPRB, 0.26287386E-09_JPRB, 0.26286487E-09_JPRB, 0.26285568E-09_JPRB, 0.26285435E-09_JPRB, 0.26285646E-09_JPRB, &
  & 0.26286542E-09_JPRB, 0.26287583E-09_JPRB, 0.26289190E-09_JPRB, 0.26291044E-09_JPRB, 0.26292604E-09_JPRB, 0.26294394E-09_JPRB, &
  & 0.26295754E-09_JPRB, 0.26296931E-09_JPRB, 0.26297764E-09_JPRB, 0.26298375E-09_JPRB, 0.26298794E-09_JPRB, 0.26298838E-09_JPRB, &
  & 0.26298896E-09_JPRB, 0.26298641E-09_JPRB, 0.26298430E-09_JPRB, 0.26297908E-09_JPRB, 0.26297686E-09_JPRB, 0.26297131E-09_JPRB, &
  & 0.26296393E-09_JPRB, 0.26295821E-09_JPRB, 0.26295532E-09_JPRB, 0.26295047E-09_JPRB, 0.26294811E-09_JPRB, 0.26294580E-09_JPRB, &
  & 0.26294317E-09_JPRB, 0.26294342E-09_JPRB, 0.26294089E-09_JPRB, 0.26294045E-09_JPRB, 0.26293842E-09_JPRB, 0.26293889E-09_JPRB, &
  & 0.26293578E-09_JPRB, 0.26293337E-09_JPRB, 0.26292804E-09_JPRB, 0.26292366E-09_JPRB, 0.26292044E-09_JPRB, 0.26291488E-09_JPRB, &
  & 0.26290872E-09_JPRB, 0.26290278E-09_JPRB, 0.26288957E-09_JPRB, 0.26285427E-09_JPRB /)

RGHG5(:,80, 8) = (/ &
  & 0.26279445E-09_JPRB, 0.26283689E-09_JPRB, 0.26285299E-09_JPRB, 0.26286168E-09_JPRB, 0.26287220E-09_JPRB, 0.26287983E-09_JPRB, &
  & 0.26288721E-09_JPRB, 0.26289274E-09_JPRB, 0.26289998E-09_JPRB, 0.26290176E-09_JPRB, 0.26290467E-09_JPRB, 0.26291133E-09_JPRB, &
  & 0.26291419E-09_JPRB, 0.26291747E-09_JPRB, 0.26292146E-09_JPRB, 0.26291896E-09_JPRB, 0.26291605E-09_JPRB, 0.26291180E-09_JPRB, &
  & 0.26290498E-09_JPRB, 0.26289598E-09_JPRB, 0.26288902E-09_JPRB, 0.26288094E-09_JPRB, 0.26288066E-09_JPRB, 0.26288255E-09_JPRB, &
  & 0.26289057E-09_JPRB, 0.26289876E-09_JPRB, 0.26291228E-09_JPRB, 0.26292796E-09_JPRB, 0.26294017E-09_JPRB, 0.26295530E-09_JPRB, &
  & 0.26296609E-09_JPRB, 0.26297556E-09_JPRB, 0.26298214E-09_JPRB, 0.26298705E-09_JPRB, 0.26299060E-09_JPRB, 0.26299071E-09_JPRB, &
  & 0.26299143E-09_JPRB, 0.26298913E-09_JPRB, 0.26298774E-09_JPRB, 0.26298330E-09_JPRB, 0.26298236E-09_JPRB, 0.26297775E-09_JPRB, &
  & 0.26297109E-09_JPRB, 0.26296609E-09_JPRB, 0.26296407E-09_JPRB, 0.26295977E-09_JPRB, 0.26295810E-09_JPRB, 0.26295621E-09_JPRB, &
  & 0.26295371E-09_JPRB, 0.26295441E-09_JPRB, 0.26295174E-09_JPRB, 0.26295152E-09_JPRB, 0.26294955E-09_JPRB, 0.26295072E-09_JPRB, &
  & 0.26294789E-09_JPRB, 0.26294628E-09_JPRB, 0.26294147E-09_JPRB, 0.26293809E-09_JPRB, 0.26293626E-09_JPRB, 0.26293151E-09_JPRB, &
  & 0.26292657E-09_JPRB, 0.26292243E-09_JPRB, 0.26291411E-09_JPRB, 0.26290042E-09_JPRB /)

RGHG5(:,81, 8) = (/ &
  & 0.26284988E-09_JPRB, 0.26285385E-09_JPRB, 0.26286590E-09_JPRB, 0.26287311E-09_JPRB, 0.26288313E-09_JPRB, 0.26289035E-09_JPRB, &
  & 0.26289693E-09_JPRB, 0.26290287E-09_JPRB, 0.26290858E-09_JPRB, 0.26291058E-09_JPRB, 0.26291250E-09_JPRB, 0.26291958E-09_JPRB, &
  & 0.26292185E-09_JPRB, 0.26292490E-09_JPRB, 0.26292893E-09_JPRB, 0.26292640E-09_JPRB, 0.26292382E-09_JPRB, 0.26292010E-09_JPRB, &
  & 0.26291419E-09_JPRB, 0.26290589E-09_JPRB, 0.26289987E-09_JPRB, 0.26289204E-09_JPRB, 0.26289232E-09_JPRB, 0.26289407E-09_JPRB, &
  & 0.26290170E-09_JPRB, 0.26290881E-09_JPRB, 0.26292132E-09_JPRB, 0.26293576E-09_JPRB, 0.26294655E-09_JPRB, 0.26296029E-09_JPRB, &
  & 0.26296984E-09_JPRB, 0.26297839E-09_JPRB, 0.26298416E-09_JPRB, 0.26298852E-09_JPRB, 0.26299188E-09_JPRB, 0.26299171E-09_JPRB, &
  & 0.26299254E-09_JPRB, 0.26299032E-09_JPRB, 0.26298924E-09_JPRB, 0.26298513E-09_JPRB, 0.26298480E-09_JPRB, 0.26298067E-09_JPRB, &
  & 0.26297428E-09_JPRB, 0.26296956E-09_JPRB, 0.26296787E-09_JPRB, 0.26296379E-09_JPRB, 0.26296249E-09_JPRB, 0.26296076E-09_JPRB, &
  & 0.26295832E-09_JPRB, 0.26295929E-09_JPRB, 0.26295652E-09_JPRB, 0.26295635E-09_JPRB, 0.26295432E-09_JPRB, 0.26295591E-09_JPRB, &
  & 0.26295308E-09_JPRB, 0.26295183E-09_JPRB, 0.26294716E-09_JPRB, 0.26294417E-09_JPRB, 0.26294297E-09_JPRB, 0.26293862E-09_JPRB, &
  & 0.26293409E-09_JPRB, 0.26293079E-09_JPRB, 0.26292424E-09_JPRB, 0.26293187E-09_JPRB /)

RGHG5(:,82, 8) = (/ &
  & 0.26285421E-09_JPRB, 0.26285948E-09_JPRB, 0.26287156E-09_JPRB, 0.26287850E-09_JPRB, 0.26288843E-09_JPRB, 0.26289526E-09_JPRB, &
  & 0.26290220E-09_JPRB, 0.26290650E-09_JPRB, 0.26291366E-09_JPRB, 0.26291452E-09_JPRB, 0.26291733E-09_JPRB, 0.26292293E-09_JPRB, &
  & 0.26292560E-09_JPRB, 0.26292860E-09_JPRB, 0.26293262E-09_JPRB, 0.26293007E-09_JPRB, 0.26292760E-09_JPRB, 0.26292432E-09_JPRB, &
  & 0.26291874E-09_JPRB, 0.26291083E-09_JPRB, 0.26290525E-09_JPRB, 0.26289745E-09_JPRB, 0.26289809E-09_JPRB, 0.26289967E-09_JPRB, &
  & 0.26290717E-09_JPRB, 0.26291375E-09_JPRB, 0.26292568E-09_JPRB, 0.26293981E-09_JPRB, 0.26294969E-09_JPRB, 0.26296282E-09_JPRB, &
  & 0.26297170E-09_JPRB, 0.26297967E-09_JPRB, 0.26298511E-09_JPRB, 0.26298924E-09_JPRB, 0.26299252E-09_JPRB, 0.26299227E-09_JPRB, &
  & 0.26299313E-09_JPRB, 0.26299091E-09_JPRB, 0.26298999E-09_JPRB, 0.26298608E-09_JPRB, 0.26298597E-09_JPRB, 0.26298208E-09_JPRB, &
  & 0.26297584E-09_JPRB, 0.26297120E-09_JPRB, 0.26296973E-09_JPRB, 0.26296576E-09_JPRB, 0.26296465E-09_JPRB, 0.26296304E-09_JPRB, &
  & 0.26296060E-09_JPRB, 0.26296171E-09_JPRB, 0.26295879E-09_JPRB, 0.26295877E-09_JPRB, 0.26295671E-09_JPRB, 0.26295860E-09_JPRB, &
  & 0.26295569E-09_JPRB, 0.26295460E-09_JPRB, 0.26294988E-09_JPRB, 0.26294705E-09_JPRB, 0.26294628E-09_JPRB, 0.26294206E-09_JPRB, &
  & 0.26293764E-09_JPRB, 0.26293440E-09_JPRB, 0.26292760E-09_JPRB, 0.26293437E-09_JPRB /)

RGHG5(:,83, 8) = (/ &
  & 0.26285724E-09_JPRB, 0.26286279E-09_JPRB, 0.26287478E-09_JPRB, 0.26288152E-09_JPRB, 0.26289138E-09_JPRB, 0.26289843E-09_JPRB, &
  & 0.26290445E-09_JPRB, 0.26291064E-09_JPRB, 0.26291505E-09_JPRB, 0.26291724E-09_JPRB, 0.26291874E-09_JPRB, 0.26292557E-09_JPRB, &
  & 0.26292757E-09_JPRB, 0.26293065E-09_JPRB, 0.26293465E-09_JPRB, 0.26293212E-09_JPRB, 0.26292973E-09_JPRB, 0.26292668E-09_JPRB, &
  & 0.26292135E-09_JPRB, 0.26291364E-09_JPRB, 0.26290836E-09_JPRB, 0.26290042E-09_JPRB, 0.26290134E-09_JPRB, 0.26290267E-09_JPRB, &
  & 0.26291022E-09_JPRB, 0.26291630E-09_JPRB, 0.26292840E-09_JPRB, 0.26294192E-09_JPRB, 0.26295158E-09_JPRB, 0.26296415E-09_JPRB, &
  & 0.26297273E-09_JPRB, 0.26298042E-09_JPRB, 0.26298563E-09_JPRB, 0.26298963E-09_JPRB, 0.26299282E-09_JPRB, 0.26299252E-09_JPRB, &
  & 0.26299343E-09_JPRB, 0.26299121E-09_JPRB, 0.26299035E-09_JPRB, 0.26298666E-09_JPRB, 0.26298666E-09_JPRB, 0.26298294E-09_JPRB, &
  & 0.26297672E-09_JPRB, 0.26297220E-09_JPRB, 0.26297076E-09_JPRB, 0.26296690E-09_JPRB, 0.26296587E-09_JPRB, 0.26296432E-09_JPRB, &
  & 0.26296190E-09_JPRB, 0.26296310E-09_JPRB, 0.26296013E-09_JPRB, 0.26296013E-09_JPRB, 0.26295796E-09_JPRB, 0.26296001E-09_JPRB, &
  & 0.26295710E-09_JPRB, 0.26295613E-09_JPRB, 0.26295136E-09_JPRB, 0.26294864E-09_JPRB, 0.26294811E-09_JPRB, 0.26294406E-09_JPRB, &
  & 0.26293967E-09_JPRB, 0.26293656E-09_JPRB, 0.26292951E-09_JPRB, 0.26293609E-09_JPRB /)

RGHG5(:,84, 8) = (/ &
  & 0.26285932E-09_JPRB, 0.26286495E-09_JPRB, 0.26287683E-09_JPRB, 0.26288335E-09_JPRB, 0.26289332E-09_JPRB, 0.26290004E-09_JPRB, &
  & 0.26290711E-09_JPRB, 0.26291092E-09_JPRB, 0.26291752E-09_JPRB, 0.26291846E-09_JPRB, 0.26292149E-09_JPRB, 0.26292590E-09_JPRB, &
  & 0.26292890E-09_JPRB, 0.26293182E-09_JPRB, 0.26293556E-09_JPRB, 0.26293337E-09_JPRB, 0.26293109E-09_JPRB, 0.26292815E-09_JPRB, &
  & 0.26292304E-09_JPRB, 0.26291536E-09_JPRB, 0.26291028E-09_JPRB, 0.26290220E-09_JPRB, 0.26290334E-09_JPRB, 0.26290450E-09_JPRB, &
  & 0.26291208E-09_JPRB, 0.26291802E-09_JPRB, 0.26292957E-09_JPRB, 0.26294364E-09_JPRB, 0.26295258E-09_JPRB, 0.26296515E-09_JPRB, &
  & 0.26297337E-09_JPRB, 0.26298091E-09_JPRB, 0.26298597E-09_JPRB, 0.26298988E-09_JPRB, 0.26299302E-09_JPRB, 0.26299268E-09_JPRB, &
  & 0.26299360E-09_JPRB, 0.26299135E-09_JPRB, 0.26299057E-09_JPRB, 0.26298697E-09_JPRB, 0.26298705E-09_JPRB, 0.26298341E-09_JPRB, &
  & 0.26297742E-09_JPRB, 0.26297273E-09_JPRB, 0.26297137E-09_JPRB, 0.26296751E-09_JPRB, 0.26296657E-09_JPRB, 0.26296512E-09_JPRB, &
  & 0.26296271E-09_JPRB, 0.26296396E-09_JPRB, 0.26296090E-09_JPRB, 0.26296099E-09_JPRB, 0.26295874E-09_JPRB, 0.26296099E-09_JPRB, &
  & 0.26295802E-09_JPRB, 0.26295710E-09_JPRB, 0.26295224E-09_JPRB, 0.26294955E-09_JPRB, 0.26294927E-09_JPRB, 0.26294522E-09_JPRB, &
  & 0.26294092E-09_JPRB, 0.26293789E-09_JPRB, 0.26293079E-09_JPRB, 0.26293731E-09_JPRB /)

RGHG5(:,85, 8) = (/ &
  & 0.26286071E-09_JPRB, 0.26286634E-09_JPRB, 0.26287811E-09_JPRB, 0.26288460E-09_JPRB, 0.26289459E-09_JPRB, 0.26290212E-09_JPRB, &
  & 0.26290764E-09_JPRB, 0.26291397E-09_JPRB, 0.26291747E-09_JPRB, 0.26292007E-09_JPRB, 0.26292196E-09_JPRB, 0.26292704E-09_JPRB, &
  & 0.26292954E-09_JPRB, 0.26293251E-09_JPRB, 0.26293551E-09_JPRB, 0.26293398E-09_JPRB, 0.26293198E-09_JPRB, 0.26292915E-09_JPRB, &
  & 0.26292418E-09_JPRB, 0.26291649E-09_JPRB, 0.26291164E-09_JPRB, 0.26290337E-09_JPRB, 0.26290464E-09_JPRB, 0.26290564E-09_JPRB, &
  & 0.26291330E-09_JPRB, 0.26291871E-09_JPRB, 0.26293098E-09_JPRB, 0.26294422E-09_JPRB, 0.26295363E-09_JPRB, 0.26296565E-09_JPRB, &
  & 0.26297389E-09_JPRB, 0.26298119E-09_JPRB, 0.26298613E-09_JPRB, 0.26299005E-09_JPRB, 0.26299318E-09_JPRB, 0.26299279E-09_JPRB, &
  & 0.26299368E-09_JPRB, 0.26299146E-09_JPRB, 0.26299071E-09_JPRB, 0.26298716E-09_JPRB, 0.26298733E-09_JPRB, 0.26298388E-09_JPRB, &
  & 0.26297764E-09_JPRB, 0.26297320E-09_JPRB, 0.26297170E-09_JPRB, 0.26296798E-09_JPRB, 0.26296709E-09_JPRB, 0.26296565E-09_JPRB, &
  & 0.26296323E-09_JPRB, 0.26296454E-09_JPRB, 0.26296146E-09_JPRB, 0.26296160E-09_JPRB, 0.26295927E-09_JPRB, 0.26296160E-09_JPRB, &
  & 0.26295860E-09_JPRB, 0.26295774E-09_JPRB, 0.26295283E-09_JPRB, 0.26295016E-09_JPRB, 0.26295005E-09_JPRB, 0.26294600E-09_JPRB, &
  & 0.26294170E-09_JPRB, 0.26293873E-09_JPRB, 0.26293157E-09_JPRB, 0.26293809E-09_JPRB /)

RGHG5(:,86, 8) = (/ &
  & 0.26286165E-09_JPRB, 0.26286726E-09_JPRB, 0.26287894E-09_JPRB, 0.26288538E-09_JPRB, 0.26289609E-09_JPRB, 0.26290239E-09_JPRB, &
  & 0.26291036E-09_JPRB, 0.26291380E-09_JPRB, 0.26291919E-09_JPRB, 0.26292080E-09_JPRB, 0.26292363E-09_JPRB, 0.26292701E-09_JPRB, &
  & 0.26292984E-09_JPRB, 0.26293237E-09_JPRB, 0.26293490E-09_JPRB, 0.26293417E-09_JPRB, 0.26293240E-09_JPRB, 0.26292979E-09_JPRB, &
  & 0.26292499E-09_JPRB, 0.26291749E-09_JPRB, 0.26291247E-09_JPRB, 0.26290414E-09_JPRB, 0.26290548E-09_JPRB, 0.26290634E-09_JPRB, &
  & 0.26291408E-09_JPRB, 0.26291933E-09_JPRB, 0.26293098E-09_JPRB, 0.26294525E-09_JPRB, 0.26295374E-09_JPRB, 0.26296632E-09_JPRB, &
  & 0.26297420E-09_JPRB, 0.26298147E-09_JPRB, 0.26298630E-09_JPRB, 0.26299019E-09_JPRB, 0.26299329E-09_JPRB, 0.26299285E-09_JPRB, &
  & 0.26299385E-09_JPRB, 0.26299149E-09_JPRB, 0.26299085E-09_JPRB, 0.26298724E-09_JPRB, 0.26298760E-09_JPRB, 0.26298405E-09_JPRB, &
  & 0.26297806E-09_JPRB, 0.26297320E-09_JPRB, 0.26297203E-09_JPRB, 0.26296820E-09_JPRB, 0.26296731E-09_JPRB, 0.26296598E-09_JPRB, &
  & 0.26296365E-09_JPRB, 0.26296484E-09_JPRB, 0.26296182E-09_JPRB, 0.26296196E-09_JPRB, 0.26295957E-09_JPRB, 0.26296193E-09_JPRB, &
  & 0.26295899E-09_JPRB, 0.26295813E-09_JPRB, 0.26295316E-09_JPRB, 0.26295055E-09_JPRB, 0.26295058E-09_JPRB, 0.26294653E-09_JPRB, &
  & 0.26294228E-09_JPRB, 0.26293939E-09_JPRB, 0.26293209E-09_JPRB, 0.26293864E-09_JPRB /)

RGHG5(:,87, 8) = (/ &
  & 0.26286226E-09_JPRB, 0.26286795E-09_JPRB, 0.26287952E-09_JPRB, 0.26288627E-09_JPRB, 0.26289598E-09_JPRB, 0.26290503E-09_JPRB, &
  & 0.26290986E-09_JPRB, 0.26291602E-09_JPRB, 0.26291913E-09_JPRB, 0.26292182E-09_JPRB, 0.26292396E-09_JPRB, 0.26292743E-09_JPRB, &
  & 0.26292979E-09_JPRB, 0.26293223E-09_JPRB, 0.26293429E-09_JPRB, 0.26293390E-09_JPRB, 0.26293256E-09_JPRB, 0.26293009E-09_JPRB, &
  & 0.26292560E-09_JPRB, 0.26291816E-09_JPRB, 0.26291316E-09_JPRB, 0.26290461E-09_JPRB, 0.26290595E-09_JPRB, 0.26290672E-09_JPRB, &
  & 0.26291455E-09_JPRB, 0.26291935E-09_JPRB, 0.26293148E-09_JPRB, 0.26294530E-09_JPRB, 0.26295421E-09_JPRB, 0.26296662E-09_JPRB, &
  & 0.26297450E-09_JPRB, 0.26298172E-09_JPRB, 0.26298647E-09_JPRB, 0.26299030E-09_JPRB, 0.26299346E-09_JPRB, 0.26299293E-09_JPRB, &
  & 0.26299402E-09_JPRB, 0.26299155E-09_JPRB, 0.26299107E-09_JPRB, 0.26298727E-09_JPRB, 0.26298796E-09_JPRB, 0.26298447E-09_JPRB, &
  & 0.26297781E-09_JPRB, 0.26297325E-09_JPRB, 0.26297206E-09_JPRB, 0.26296842E-09_JPRB, 0.26296748E-09_JPRB, 0.26296620E-09_JPRB, &
  & 0.26296387E-09_JPRB, 0.26296498E-09_JPRB, 0.26296207E-09_JPRB, 0.26296221E-09_JPRB, 0.26295977E-09_JPRB, 0.26296212E-09_JPRB, &
  & 0.26295927E-09_JPRB, 0.26295841E-09_JPRB, 0.26295335E-09_JPRB, 0.26295072E-09_JPRB, 0.26295086E-09_JPRB, 0.26294689E-09_JPRB, &
  & 0.26294261E-09_JPRB, 0.26293973E-09_JPRB, 0.26293231E-09_JPRB, 0.26293898E-09_JPRB /)

RGHG5(:,88, 8) = (/ &
  & 0.26286287E-09_JPRB, 0.26286889E-09_JPRB, 0.26287969E-09_JPRB, 0.26288619E-09_JPRB, 0.26289754E-09_JPRB, 0.26290364E-09_JPRB, &
  & 0.26291191E-09_JPRB, 0.26291530E-09_JPRB, 0.26292005E-09_JPRB, 0.26292193E-09_JPRB, 0.26292452E-09_JPRB, 0.26292746E-09_JPRB, &
  & 0.26292990E-09_JPRB, 0.26293207E-09_JPRB, 0.26293412E-09_JPRB, 0.26293387E-09_JPRB, 0.26293256E-09_JPRB, 0.26293032E-09_JPRB, &
  & 0.26292585E-09_JPRB, 0.26291863E-09_JPRB, 0.26291344E-09_JPRB, 0.26290495E-09_JPRB, 0.26290628E-09_JPRB, 0.26290686E-09_JPRB, &
  & 0.26291480E-09_JPRB, 0.26291941E-09_JPRB, 0.26293132E-09_JPRB, 0.26294580E-09_JPRB, 0.26295408E-09_JPRB, 0.26296706E-09_JPRB, &
  & 0.26297467E-09_JPRB, 0.26298191E-09_JPRB, 0.26298663E-09_JPRB, 0.26299043E-09_JPRB, 0.26299357E-09_JPRB, 0.26299299E-09_JPRB, &
  & 0.26299415E-09_JPRB, 0.26299155E-09_JPRB, 0.26299124E-09_JPRB, 0.26298716E-09_JPRB, 0.26298833E-09_JPRB, 0.26298469E-09_JPRB, &
  & 0.26297792E-09_JPRB, 0.26297295E-09_JPRB, 0.26297217E-09_JPRB, 0.26296842E-09_JPRB, 0.26296754E-09_JPRB, 0.26296632E-09_JPRB, &
  & 0.26296409E-09_JPRB, 0.26296507E-09_JPRB, 0.26296226E-09_JPRB, 0.26296235E-09_JPRB, 0.26295990E-09_JPRB, 0.26296226E-09_JPRB, &
  & 0.26295938E-09_JPRB, 0.26295857E-09_JPRB, 0.26295349E-09_JPRB, 0.26295083E-09_JPRB, 0.26295111E-09_JPRB, 0.26294708E-09_JPRB, &
  & 0.26294283E-09_JPRB, 0.26294000E-09_JPRB, 0.26293251E-09_JPRB, 0.26293920E-09_JPRB /)

RGHG5(:,89, 8) = (/ &
  & 0.26286373E-09_JPRB, 0.26286973E-09_JPRB, 0.26287969E-09_JPRB, 0.26288635E-09_JPRB, 0.26289615E-09_JPRB, 0.26290509E-09_JPRB, &
  & 0.26291008E-09_JPRB, 0.26291622E-09_JPRB, 0.26291960E-09_JPRB, 0.26292210E-09_JPRB, 0.26292435E-09_JPRB, 0.26292782E-09_JPRB, &
  & 0.26293023E-09_JPRB, 0.26293262E-09_JPRB, 0.26293465E-09_JPRB, 0.26293423E-09_JPRB, 0.26293287E-09_JPRB, 0.26293046E-09_JPRB, &
  & 0.26292599E-09_JPRB, 0.26291855E-09_JPRB, 0.26291372E-09_JPRB, 0.26290498E-09_JPRB, 0.26290642E-09_JPRB, 0.26290695E-09_JPRB, &
  & 0.26291500E-09_JPRB, 0.26291935E-09_JPRB, 0.26293143E-09_JPRB, 0.26294589E-09_JPRB, 0.26295421E-09_JPRB, 0.26296731E-09_JPRB, &
  & 0.26297478E-09_JPRB, 0.26298211E-09_JPRB, 0.26298677E-09_JPRB, 0.26299055E-09_JPRB, 0.26299374E-09_JPRB, 0.26299299E-09_JPRB, &
  & 0.26299429E-09_JPRB, 0.26299149E-09_JPRB, 0.26299141E-09_JPRB, 0.26298697E-09_JPRB, 0.26298863E-09_JPRB, 0.26298502E-09_JPRB, &
  & 0.26297775E-09_JPRB, 0.26297284E-09_JPRB, 0.26297223E-09_JPRB, 0.26296845E-09_JPRB, 0.26296762E-09_JPRB, 0.26296634E-09_JPRB, &
  & 0.26296412E-09_JPRB, 0.26296509E-09_JPRB, 0.26296235E-09_JPRB, 0.26296237E-09_JPRB, 0.26295996E-09_JPRB, 0.26296235E-09_JPRB, &
  & 0.26295943E-09_JPRB, 0.26295871E-09_JPRB, 0.26295349E-09_JPRB, 0.26295086E-09_JPRB, 0.26295127E-09_JPRB, 0.26294719E-09_JPRB, &
  & 0.26294295E-09_JPRB, 0.26294014E-09_JPRB, 0.26293254E-09_JPRB, 0.26293936E-09_JPRB /)

RGHG5(:,90, 8) = (/ &
  & 0.26286440E-09_JPRB, 0.26287073E-09_JPRB, 0.26287902E-09_JPRB, 0.26288569E-09_JPRB, 0.26289643E-09_JPRB, 0.26290273E-09_JPRB, &
  & 0.26291047E-09_JPRB, 0.26291441E-09_JPRB, 0.26291985E-09_JPRB, 0.26292149E-09_JPRB, 0.26292404E-09_JPRB, 0.26292796E-09_JPRB, &
  & 0.26293062E-09_JPRB, 0.26293320E-09_JPRB, 0.26293584E-09_JPRB, 0.26293495E-09_JPRB, 0.26293312E-09_JPRB, 0.26293068E-09_JPRB, &
  & 0.26292596E-09_JPRB, 0.26291830E-09_JPRB, 0.26291375E-09_JPRB, 0.26290473E-09_JPRB, 0.26290647E-09_JPRB, 0.26290681E-09_JPRB, &
  & 0.26291519E-09_JPRB, 0.26291916E-09_JPRB, 0.26293132E-09_JPRB, 0.26294614E-09_JPRB, 0.26295396E-09_JPRB, 0.26296756E-09_JPRB, &
  & 0.26297486E-09_JPRB, 0.26298227E-09_JPRB, 0.26298683E-09_JPRB, 0.26299063E-09_JPRB, 0.26299399E-09_JPRB, 0.26299296E-09_JPRB, &
  & 0.26299438E-09_JPRB, 0.26299143E-09_JPRB, 0.26299166E-09_JPRB, 0.26298677E-09_JPRB, 0.26298896E-09_JPRB, 0.26298530E-09_JPRB, &
  & 0.26297767E-09_JPRB, 0.26297253E-09_JPRB, 0.26297234E-09_JPRB, 0.26296837E-09_JPRB, 0.26296768E-09_JPRB, 0.26296640E-09_JPRB, &
  & 0.26296404E-09_JPRB, 0.26296521E-09_JPRB, 0.26296232E-09_JPRB, 0.26296249E-09_JPRB, 0.26295988E-09_JPRB, 0.26296251E-09_JPRB, &
  & 0.26295946E-09_JPRB, 0.26295890E-09_JPRB, 0.26295341E-09_JPRB, 0.26295080E-09_JPRB, 0.26295147E-09_JPRB, 0.26294728E-09_JPRB, &
  & 0.26294295E-09_JPRB, 0.26294020E-09_JPRB, 0.26293231E-09_JPRB, 0.26293942E-09_JPRB /)

RGHG5(:,91, 8) = (/ &
  & 0.26286412E-09_JPRB, 0.26287122E-09_JPRB, 0.26287725E-09_JPRB, 0.26288535E-09_JPRB, 0.26289615E-09_JPRB, 0.26290223E-09_JPRB, &
  & 0.26290864E-09_JPRB, 0.26291300E-09_JPRB, 0.26292118E-09_JPRB, 0.26292024E-09_JPRB, 0.26292141E-09_JPRB, 0.26292968E-09_JPRB, &
  & 0.26293087E-09_JPRB, 0.26293373E-09_JPRB, 0.26293914E-09_JPRB, 0.26293531E-09_JPRB, 0.26293312E-09_JPRB, 0.26293093E-09_JPRB, &
  & 0.26292607E-09_JPRB, 0.26291777E-09_JPRB, 0.26291402E-09_JPRB, 0.26290395E-09_JPRB, 0.26290656E-09_JPRB, 0.26290631E-09_JPRB, &
  & 0.26291544E-09_JPRB, 0.26291863E-09_JPRB, 0.26293115E-09_JPRB, 0.26294653E-09_JPRB, 0.26295344E-09_JPRB, 0.26296790E-09_JPRB, &
  & 0.26297495E-09_JPRB, 0.26298250E-09_JPRB, 0.26298697E-09_JPRB, 0.26299080E-09_JPRB, 0.26299438E-09_JPRB, 0.26299279E-09_JPRB, &
  & 0.26299471E-09_JPRB, 0.26299118E-09_JPRB, 0.26299202E-09_JPRB, 0.26298627E-09_JPRB, 0.26298946E-09_JPRB, 0.26298572E-09_JPRB, &
  & 0.26297750E-09_JPRB, 0.26297209E-09_JPRB, 0.26297267E-09_JPRB, 0.26296815E-09_JPRB, 0.26296779E-09_JPRB, 0.26296648E-09_JPRB, &
  & 0.26296368E-09_JPRB, 0.26296559E-09_JPRB, 0.26296207E-09_JPRB, 0.26296273E-09_JPRB, 0.26295943E-09_JPRB, 0.26296296E-09_JPRB, &
  & 0.26295935E-09_JPRB, 0.26295921E-09_JPRB, 0.26295321E-09_JPRB, 0.26295061E-09_JPRB, 0.26295180E-09_JPRB, 0.26294725E-09_JPRB, &
  & 0.26294283E-09_JPRB, 0.26294031E-09_JPRB, 0.26293176E-09_JPRB, 0.26293959E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART16',1,ZHOOK_HANDLE)
END SUBROUTINE PART16






SUBROUTINE PART17
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART17',0,ZHOOK_HANDLE)



!-- Month=  9 ------------

RGHG5(:, 1, 9) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.14012985E-44_JPRB, 0.42038954E-44_JPRB, 0.70064923E-44_JPRB, 0.12611686E-43_JPRB, 0.26624671E-43_JPRB, 0.50446745E-43_JPRB, &
  & 0.99492191E-43_JPRB, 0.19618179E-42_JPRB, 0.37975188E-42_JPRB, 0.72307001E-42_JPRB, 0.13466478E-41_JPRB, 0.24536736E-41_JPRB, &
  & 0.43720512E-41_JPRB, 0.76356753E-41_JPRB, 0.13043286E-40_JPRB, 0.21624838E-40_JPRB, 0.34867108E-40_JPRB, 0.54876249E-40_JPRB, &
  & 0.84114342E-40_JPRB, 0.12529850E-39_JPRB, 0.18490273E-39_JPRB, 0.27013952E-39_JPRB, 0.40138093E-39_JPRB, 0.59734691E-39_JPRB, &
  & 0.80205560E-39_JPRB, 0.12452302E-38_JPRB, 0.14413139E-38_JPRB, 0.20143988E-38_JPRB, 0.19511554E-38_JPRB, 0.18914923E-38_JPRB, &
  & 0.16372113E-38_JPRB, 0.10231973E-38_JPRB, 0.86951410E-39_JPRB, 0.56660382E-39_JPRB, 0.29369254E-39_JPRB, 0.15486590E-39_JPRB, &
  & 0.92617421E-40_JPRB, 0.48602636E-40_JPRB, 0.28003549E-40_JPRB, 0.13305329E-40_JPRB, 0.58420133E-41_JPRB, 0.25265411E-41_JPRB, &
  & 0.10089349E-41_JPRB, 0.42459343E-42_JPRB, 0.17936620E-42_JPRB, 0.82676609E-43_JPRB, 0.39236357E-43_JPRB, 0.22420775E-43_JPRB, &
  & 0.14012985E-43_JPRB, 0.11210388E-43_JPRB, 0.84077908E-44_JPRB, 0.84077908E-44_JPRB, 0.70064923E-44_JPRB, 0.84077908E-44_JPRB, &
  & 0.84077908E-44_JPRB, 0.70064923E-44_JPRB, 0.42038954E-44_JPRB, 0.28025969E-44_JPRB /)

RGHG5(:, 2, 9) = (/ &
  & 0.84077908E-44_JPRB, 0.12611686E-43_JPRB, 0.19618179E-43_JPRB, 0.29427268E-43_JPRB, 0.43440252E-43_JPRB, 0.68663625E-43_JPRB, &
  & 0.11350518E-42_JPRB, 0.19898438E-42_JPRB, 0.35873241E-42_JPRB, 0.66841937E-42_JPRB, 0.12737803E-41_JPRB, 0.24550749E-41_JPRB, &
  & 0.47447966E-41_JPRB, 0.91238543E-41_JPRB, 0.17314444E-40_JPRB, 0.32211648E-40_JPRB, 0.58638736E-40_JPRB, 0.10472324E-39_JPRB, &
  & 0.18343978E-39_JPRB, 0.31550936E-39_JPRB, 0.53180398E-39_JPRB, 0.87338029E-39_JPRB, 0.13994922E-38_JPRB, 0.21970356E-38_JPRB, &
  & 0.33649758E-38_JPRB, 0.50257710E-38_JPRB, 0.74372991E-38_JPRB, 0.10874276E-37_JPRB, 0.16104259E-37_JPRB, 0.23818795E-37_JPRB, &
  & 0.32571140E-37_JPRB, 0.49207846E-37_JPRB, 0.58643265E-37_JPRB, 0.78659457E-37_JPRB, 0.77585339E-37_JPRB, 0.74158452E-37_JPRB, &
  & 0.63320434E-37_JPRB, 0.42789644E-37_JPRB, 0.34056505E-37_JPRB, 0.22720771E-37_JPRB, 0.12667804E-37_JPRB, 0.66518237E-38_JPRB, &
  & 0.38455596E-38_JPRB, 0.20182467E-38_JPRB, 0.11485995E-38_JPRB, 0.55846648E-39_JPRB, 0.25336317E-39_JPRB, 0.11214451E-39_JPRB, &
  & 0.46349348E-40_JPRB, 0.19524292E-40_JPRB, 0.82326285E-41_JPRB, 0.36545864E-41_JPRB, 0.17362088E-41_JPRB, 0.94727776E-42_JPRB, &
  & 0.57733497E-42_JPRB, 0.41758694E-42_JPRB, 0.34191683E-42_JPRB, 0.31248956E-42_JPRB, 0.30688436E-42_JPRB, 0.31108826E-42_JPRB, &
  & 0.30688436E-42_JPRB, 0.25924022E-42_JPRB, 0.15414283E-42_JPRB, 0.71466222E-43_JPRB /)

RGHG5(:, 3, 9) = (/ &
  & 0.22981295E-42_JPRB, 0.46943499E-42_JPRB, 0.77772065E-42_JPRB, 0.11714855E-41_JPRB, 0.17558270E-41_JPRB, 0.27815775E-41_JPRB, &
  & 0.47181719E-41_JPRB, 0.84806583E-41_JPRB, 0.15876712E-40_JPRB, 0.30530090E-40_JPRB, 0.59775189E-40_JPRB, 0.11777213E-39_JPRB, &
  & 0.23103208E-39_JPRB, 0.44752989E-39_JPRB, 0.84993937E-39_JPRB, 0.15746615E-38_JPRB, 0.28469634E-38_JPRB, 0.50445526E-38_JPRB, &
  & 0.87710508E-38_JPRB, 0.14991628E-37_JPRB, 0.25153324E-37_JPRB, 0.41205955E-37_JPRB, 0.66095695E-37_JPRB, 0.10392112E-36_JPRB, &
  & 0.15997092E-36_JPRB, 0.23966112E-36_JPRB, 0.35521600E-36_JPRB, 0.52009347E-36_JPRB, 0.76772547E-36_JPRB, 0.11341499E-35_JPRB, &
  & 0.15582634E-35_JPRB, 0.23400400E-35_JPRB, 0.28109570E-35_JPRB, 0.37327513E-35_JPRB, 0.36975981E-35_JPRB, 0.35207462E-35_JPRB, &
  & 0.29998892E-35_JPRB, 0.20609702E-35_JPRB, 0.16280439E-35_JPRB, 0.10938638E-35_JPRB, 0.62284295E-36_JPRB, 0.32081150E-36_JPRB, &
  & 0.18233162E-36_JPRB, 0.92430263E-37_JPRB, 0.52345751E-37_JPRB, 0.24973398E-37_JPRB, 0.11289550E-37_JPRB, 0.50768707E-38_JPRB, &
  & 0.21536752E-38_JPRB, 0.93329841E-39_JPRB, 0.40158692E-39_JPRB, 0.18002481E-39_JPRB, 0.85550673E-40_JPRB, 0.46317118E-40_JPRB, &
  & 0.28010555E-40_JPRB, 0.20185704E-40_JPRB, 0.16396593E-40_JPRB, 0.15026123E-40_JPRB, 0.14790705E-40_JPRB, 0.15097590E-40_JPRB, &
  & 0.15162049E-40_JPRB, 0.13333355E-40_JPRB, 0.83671531E-41_JPRB, 0.27465450E-41_JPRB /)

RGHG5(:, 4, 9) = (/ &
  & 0.12365058E-40_JPRB, 0.37458109E-40_JPRB, 0.66965251E-40_JPRB, 0.98068472E-40_JPRB, 0.14355322E-39_JPRB, 0.22448101E-39_JPRB, &
  & 0.38374979E-39_JPRB, 0.70231257E-39_JPRB, 0.13483826E-38_JPRB, 0.26641879E-38_JPRB, 0.53552344E-38_JPRB, 0.10792415E-37_JPRB, &
  & 0.21519481E-37_JPRB, 0.42064466E-37_JPRB, 0.80042919E-37_JPRB, 0.14774444E-36_JPRB, 0.26517428E-36_JPRB, 0.46565726E-36_JPRB, &
  & 0.80211508E-36_JPRB, 0.13587548E-35_JPRB, 0.22624726E-35_JPRB, 0.36847655E-35_JPRB, 0.58823670E-35_JPRB, 0.92466270E-35_JPRB, &
  & 0.14201496E-34_JPRB, 0.21278098E-34_JPRB, 0.31500703E-34_JPRB, 0.45962659E-34_JPRB, 0.67752487E-34_JPRB, 0.99868864E-34_JPRB, &
  & 0.13752274E-33_JPRB, 0.20626030E-33_JPRB, 0.24852017E-33_JPRB, 0.33074935E-33_JPRB, 0.32837710E-33_JPRB, 0.31359170E-33_JPRB, &
  & 0.26761633E-33_JPRB, 0.18312225E-33_JPRB, 0.14533817E-33_JPRB, 0.98386501E-34_JPRB, 0.55929447E-34_JPRB, 0.28533670E-34_JPRB, &
  & 0.16136378E-34_JPRB, 0.79688372E-35_JPRB, 0.45598566E-35_JPRB, 0.21415214E-35_JPRB, 0.96797348E-36_JPRB, 0.44330389E-36_JPRB, &
  & 0.19216914E-36_JPRB, 0.85318881E-37_JPRB, 0.37389821E-37_JPRB, 0.16927065E-37_JPRB, 0.80731999E-38_JPRB, 0.43715734E-38_JPRB, &
  & 0.26398711E-38_JPRB, 0.19054478E-38_JPRB, 0.15489281E-38_JPRB, 0.14228098E-38_JPRB, 0.14045873E-38_JPRB, 0.14448746E-38_JPRB, &
  & 0.14915267E-38_JPRB, 0.14066220E-38_JPRB, 0.10004907E-38_JPRB, 0.31799666E-39_JPRB /)

RGHG5(:, 5, 9) = (/ &
  & 0.33440559E-38_JPRB, 0.96506893E-38_JPRB, 0.15729679E-37_JPRB, 0.21994820E-37_JPRB, 0.31564282E-37_JPRB, 0.48882627E-37_JPRB, &
  & 0.82982900E-37_JPRB, 0.15171621E-36_JPRB, 0.29152089E-36_JPRB, 0.57747393E-36_JPRB, 0.11649725E-35_JPRB, 0.23525700E-35_JPRB, &
  & 0.46838998E-35_JPRB, 0.90970104E-35_JPRB, 0.17108907E-34_JPRB, 0.31074595E-34_JPRB, 0.54720192E-34_JPRB, 0.94109699E-34_JPRB, &
  & 0.15865487E-33_JPRB, 0.26305265E-33_JPRB, 0.42889725E-33_JPRB, 0.68501401E-33_JPRB, 0.10751026E-32_JPRB, 0.16618276E-32_JPRB, &
  & 0.25219513E-32_JPRB, 0.37304163E-32_JPRB, 0.54645327E-32_JPRB, 0.79059606E-32_JPRB, 0.11567612E-31_JPRB, 0.16978220E-31_JPRB, &
  & 0.23345597E-31_JPRB, 0.35026158E-31_JPRB, 0.42246415E-31_JPRB, 0.56664294E-31_JPRB, 0.56557136E-31_JPRB, 0.54568364E-31_JPRB, &
  & 0.47027191E-31_JPRB, 0.32002881E-31_JPRB, 0.25920229E-31_JPRB, 0.17700975E-31_JPRB, 0.10176465E-31_JPRB, 0.52138523E-32_JPRB, &
  & 0.30139407E-32_JPRB, 0.14917720E-32_JPRB, 0.87710007E-33_JPRB, 0.41585422E-33_JPRB, 0.19155509E-33_JPRB, 0.90035825E-34_JPRB, &
  & 0.40052703E-34_JPRB, 0.18221836E-34_JPRB, 0.81394963E-35_JPRB, 0.37357704E-35_JPRB, 0.17970185E-35_JPRB, 0.97942019E-36_JPRB, &
  & 0.59492900E-36_JPRB, 0.43203489E-36_JPRB, 0.35298249E-36_JPRB, 0.32557414E-36_JPRB, 0.32241456E-36_JPRB, 0.33310295E-36_JPRB, &
  & 0.34936839E-36_JPRB, 0.35395970E-36_JPRB, 0.30720009E-36_JPRB, 0.17284105E-36_JPRB /)

RGHG5(:, 6, 9) = (/ &
  & 0.29111305E-35_JPRB, 0.60624091E-35_JPRB, 0.88286556E-35_JPRB, 0.12064197E-34_JPRB, 0.17164767E-34_JPRB, 0.26197212E-34_JPRB, &
  & 0.43513182E-34_JPRB, 0.77267304E-34_JPRB, 0.14392978E-33_JPRB, 0.27642147E-33_JPRB, 0.54071620E-33_JPRB, 0.10589427E-32_JPRB, &
  & 0.20419911E-32_JPRB, 0.38321773E-32_JPRB, 0.69436877E-32_JPRB, 0.12117628E-31_JPRB, 0.20462533E-31_JPRB, 0.33718268E-31_JPRB, &
  & 0.54445742E-31_JPRB, 0.86502372E-31_JPRB, 0.13531775E-30_JPRB, 0.20779644E-30_JPRB, 0.31431748E-30_JPRB, 0.47008795E-30_JPRB, &
  & 0.69159796E-30_JPRB, 0.99646177E-30_JPRB, 0.14265000E-29_JPRB, 0.20246961E-29_JPRB, 0.29200628E-29_JPRB, 0.42453394E-29_JPRB, &
  & 0.58079096E-29_JPRB, 0.87066756E-29_JPRB, 0.10530779E-28_JPRB, 0.14245084E-28_JPRB, 0.14372806E-28_JPRB, 0.14105132E-28_JPRB, &
  & 0.12400564E-28_JPRB, 0.85219541E-29_JPRB, 0.71347301E-29_JPRB, 0.49982573E-29_JPRB, 0.29520872E-29_JPRB, 0.15603922E-29_JPRB, &
  & 0.94307777E-30_JPRB, 0.48367206E-30_JPRB, 0.29851399E-30_JPRB, 0.14717612E-30_JPRB, 0.70859070E-31_JPRB, 0.34892931E-31_JPRB, &
  & 0.16246876E-31_JPRB, 0.77251880E-32_JPRB, 0.35956738E-32_JPRB, 0.17133335E-32_JPRB, 0.85261820E-33_JPRB, 0.47943391E-33_JPRB, &
  & 0.29898400E-33_JPRB, 0.22216990E-33_JPRB, 0.18465155E-33_JPRB, 0.17257979E-33_JPRB, 0.17255641E-33_JPRB, 0.17959503E-33_JPRB, &
  & 0.18993640E-33_JPRB, 0.19787363E-33_JPRB, 0.19450242E-33_JPRB, 0.15461811E-33_JPRB /)

RGHG5(:, 7, 9) = (/ &
  & 0.28199783E-32_JPRB, 0.52322539E-32_JPRB, 0.73736395E-32_JPRB, 0.98718096E-32_JPRB, 0.13777317E-31_JPRB, 0.20323980E-31_JPRB, &
  & 0.32238808E-31_JPRB, 0.54236005E-31_JPRB, 0.95424233E-31_JPRB, 0.17276725E-30_JPRB, 0.31889786E-30_JPRB, 0.58974791E-30_JPRB, &
  & 0.10746332E-29_JPRB, 0.19063821E-29_JPRB, 0.32643369E-29_JPRB, 0.53809279E-29_JPRB, 0.85828195E-29_JPRB, 0.13363217E-28_JPRB, &
  & 0.20410902E-28_JPRB, 0.30713768E-28_JPRB, 0.45615988E-28_JPRB, 0.66691662E-28_JPRB, 0.96389122E-28_JPRB, 0.13826524E-27_JPRB, &
  & 0.19591005E-27_JPRB, 0.27305977E-27_JPRB, 0.37975407E-27_JPRB, 0.52662614E-27_JPRB, 0.74590333E-27_JPRB, 0.10707251E-26_JPRB, &
  & 0.14561160E-26_JPRB, 0.21785440E-26_JPRB, 0.26454589E-26_JPRB, 0.36085252E-26_JPRB, 0.36886300E-26_JPRB, 0.36891928E-26_JPRB, &
  & 0.33203749E-26_JPRB, 0.23324260E-26_JPRB, 0.20265563E-26_JPRB, 0.14696147E-26_JPRB, 0.90037841E-27_JPRB, 0.49715811E-27_JPRB, &
  & 0.31680857E-27_JPRB, 0.17082789E-27_JPRB, 0.11196431E-27_JPRB, 0.58101852E-28_JPRB, 0.29590454E-28_JPRB, 0.15474053E-28_JPRB, &
  & 0.76403153E-29_JPRB, 0.38635757E-29_JPRB, 0.19095612E-29_JPRB, 0.96622570E-30_JPRB, 0.50977983E-30_JPRB, 0.30294309E-30_JPRB, &
  & 0.19835113E-30_JPRB, 0.15342428E-30_JPRB, 0.13168497E-30_JPRB, 0.12617318E-30_JPRB, 0.12858922E-30_JPRB, 0.13579255E-30_JPRB, &
  & 0.14514257E-30_JPRB, 0.15265319E-30_JPRB, 0.15331210E-30_JPRB, 0.13035846E-30_JPRB /)

RGHG5(:, 8, 9) = (/ &
  & 0.23981140E-29_JPRB, 0.43046208E-29_JPRB, 0.58976049E-29_JPRB, 0.77559952E-29_JPRB, 0.10495769E-28_JPRB, 0.14895536E-28_JPRB, &
  & 0.22480845E-28_JPRB, 0.35776002E-28_JPRB, 0.59231987E-28_JPRB, 0.10075284E-27_JPRB, 0.17440198E-27_JPRB, 0.30247933E-27_JPRB, &
  & 0.51707849E-27_JPRB, 0.86140500E-27_JPRB, 0.13865544E-26_JPRB, 0.21501991E-26_JPRB, 0.32291965E-26_JPRB, 0.47405252E-26_JPRB, &
  & 0.68363325E-26_JPRB, 0.97336322E-26_JPRB, 0.13707589E-25_JPRB, 0.19060503E-25_JPRB, 0.26285499E-25_JPRB, 0.36104657E-25_JPRB, &
  & 0.49206438E-25_JPRB, 0.66207099E-25_JPRB, 0.89396627E-25_JPRB, 0.12092862E-24_JPRB, 0.16810954E-24_JPRB, 0.23835452E-24_JPRB, &
  & 0.32185828E-24_JPRB, 0.48131959E-24_JPRB, 0.58675701E-24_JPRB, 0.80737547E-24_JPRB, 0.83650475E-24_JPRB, 0.85256764E-24_JPRB, &
  & 0.78566301E-24_JPRB, 0.56684793E-24_JPRB, 0.51072024E-24_JPRB, 0.38430276E-24_JPRB, 0.24541845E-24_JPRB, 0.14158362E-24_JPRB, &
  & 0.95495575E-25_JPRB, 0.54079534E-25_JPRB, 0.37778900E-25_JPRB, 0.20607242E-25_JPRB, 0.11093959E-25_JPRB, 0.61678804E-26_JPRB, &
  & 0.32303176E-26_JPRB, 0.17415341E-26_JPRB, 0.91683664E-27_JPRB, 0.49487675E-27_JPRB, 0.27804670E-27_JPRB, 0.17560647E-27_JPRB, &
  & 0.12102320E-27_JPRB, 0.97827407E-28_JPRB, 0.86847945E-28_JPRB, 0.85464959E-28_JPRB, 0.88887421E-28_JPRB, 0.95294526E-28_JPRB, &
  & 0.10299925E-27_JPRB, 0.10914505E-27_JPRB, 0.11026829E-27_JPRB, 0.94702170E-28_JPRB /)

RGHG5(:, 9, 9) = (/ &
  & 0.17151743E-26_JPRB, 0.29721278E-26_JPRB, 0.39982937E-26_JPRB, 0.51548979E-26_JPRB, 0.67951392E-26_JPRB, 0.93211974E-26_JPRB, &
  & 0.13495213E-25_JPRB, 0.20448994E-25_JPRB, 0.32102131E-25_JPRB, 0.51500673E-25_JPRB, 0.83843730E-25_JPRB, 0.13645008E-24_JPRB, &
  & 0.21862733E-24_JPRB, 0.34152739E-24_JPRB, 0.51607803E-24_JPRB, 0.75220589E-24_JPRB, 0.10632049E-23_JPRB, 0.14713914E-23_JPRB, &
  & 0.20041915E-23_JPRB, 0.27005182E-23_JPRB, 0.36079121E-23_JPRB, 0.47690791E-23_JPRB, 0.62687605E-23_JPRB, 0.82365906E-23_JPRB, &
  & 0.10774770E-22_JPRB, 0.13985671E-22_JPRB, 0.18303252E-22_JPRB, 0.24146018E-22_JPRB, 0.32936252E-22_JPRB, 0.46112407E-22_JPRB, &
  & 0.61871478E-22_JPRB, 0.92469234E-22_JPRB, 0.11323909E-21_JPRB, 0.15721875E-21_JPRB, 0.16518592E-21_JPRB, 0.17159598E-21_JPRB, &
  & 0.16189954E-21_JPRB, 0.12021726E-21_JPRB, 0.11223313E-21_JPRB, 0.87776730E-22_JPRB, 0.58491051E-22_JPRB, 0.35423704E-22_JPRB, &
  & 0.25249964E-22_JPRB, 0.15051277E-22_JPRB, 0.11221453E-22_JPRB, 0.64242162E-23_JPRB, 0.36560800E-23_JPRB, 0.21612458E-23_JPRB, &
  & 0.11983287E-23_JPRB, 0.68864870E-24_JPRB, 0.38548438E-24_JPRB, 0.22151860E-24_JPRB, 0.13222232E-24_JPRB, 0.88416424E-25_JPRB, &
  & 0.63957859E-25_JPRB, 0.53817909E-25_JPRB, 0.49276656E-25_JPRB, 0.49647078E-25_JPRB, 0.52525669E-25_JPRB, 0.56990658E-25_JPRB, &
  & 0.62095661E-25_JPRB, 0.66121249E-25_JPRB, 0.67051501E-25_JPRB, 0.57888530E-25_JPRB /)

RGHG5(:,10, 9) = (/ &
  & 0.10004795E-23_JPRB, 0.16767528E-23_JPRB, 0.22358213E-23_JPRB, 0.28252061E-23_JPRB, 0.36628946E-23_JPRB, 0.48855647E-23_JPRB, &
  & 0.68414751E-23_JPRB, 0.99583600E-23_JPRB, 0.14915940E-22_JPRB, 0.22711053E-22_JPRB, 0.34915470E-22_JPRB, 0.53452420E-22_JPRB, &
  & 0.80369105E-22_JPRB, 0.11774313E-21_JPRB, 0.16698646E-21_JPRB, 0.22867694E-21_JPRB, 0.30407581E-21_JPRB, 0.39660067E-21_JPRB, &
  & 0.51007837E-21_JPRB, 0.65033996E-21_JPRB, 0.82380868E-21_JPRB, 0.10343272E-20_JPRB, 0.12942248E-20_JPRB, 0.16235072E-20_JPRB, &
  & 0.20361461E-20_JPRB, 0.25450655E-20_JPRB, 0.32264959E-20_JPRB, 0.41473043E-20_JPRB, 0.55480324E-20_JPRB, 0.76719548E-20_JPRB, &
  & 0.10220964E-19_JPRB, 0.15278065E-19_JPRB, 0.18789437E-19_JPRB, 0.26337461E-19_JPRB, 0.28070316E-19_JPRB, 0.29732177E-19_JPRB, &
  & 0.28729046E-19_JPRB, 0.21975796E-19_JPRB, 0.21256889E-19_JPRB, 0.17288075E-19_JPRB, 0.12045736E-19_JPRB, 0.76654036E-20_JPRB, &
  & 0.57795085E-20_JPRB, 0.36368425E-20_JPRB, 0.28912244E-20_JPRB, 0.17438468E-20_JPRB, 0.10501006E-20_JPRB, 0.66057935E-21_JPRB, &
  & 0.38782714E-21_JPRB, 0.23730754E-21_JPRB, 0.14098080E-21_JPRB, 0.85997810E-22_JPRB, 0.54284491E-22_JPRB, 0.38271473E-22_JPRB, &
  & 0.28908792E-22_JPRB, 0.25228570E-22_JPRB, 0.23732581E-22_JPRB, 0.24392881E-22_JPRB, 0.26159333E-22_JPRB, 0.28628677E-22_JPRB, &
  & 0.31322256E-22_JPRB, 0.33465859E-22_JPRB, 0.33997485E-22_JPRB, 0.29380433E-22_JPRB /)

RGHG5(:,11, 9) = (/ &
  & 0.46315076E-21_JPRB, 0.77802087E-21_JPRB, 0.10142202E-20_JPRB, 0.12813348E-20_JPRB, 0.16269193E-20_JPRB, 0.21342970E-20_JPRB, &
  & 0.29062658E-20_JPRB, 0.40889375E-20_JPRB, 0.58790755E-20_JPRB, 0.85339246E-20_JPRB, 0.12434177E-19_JPRB, 0.17958304E-19_JPRB, &
  & 0.25380485E-19_JPRB, 0.34905755E-19_JPRB, 0.46474994E-19_JPRB, 0.59788175E-19_JPRB, 0.74758645E-19_JPRB, 0.91833126E-19_JPRB, &
  & 0.11143652E-18_JPRB, 0.13432742E-18_JPRB, 0.16121459E-18_JPRB, 0.19211661E-18_JPRB, 0.22867359E-18_JPRB, 0.27377383E-18_JPRB, &
  & 0.32905599E-18_JPRB, 0.39617345E-18_JPRB, 0.48655580E-18_JPRB, 0.60952360E-18_JPRB, 0.80010694E-18_JPRB, 0.10928036E-17_JPRB, &
  & 0.14464854E-17_JPRB, 0.21617530E-17_JPRB, 0.26707476E-17_JPRB, 0.37789734E-17_JPRB, 0.40865894E-17_JPRB, 0.44142605E-17_JPRB, &
  & 0.43692139E-17_JPRB, 0.34441094E-17_JPRB, 0.34518673E-17_JPRB, 0.29191650E-17_JPRB, 0.21255969E-17_JPRB, 0.14228656E-17_JPRB, &
  & 0.11333363E-17_JPRB, 0.75448963E-18_JPRB, 0.63869769E-18_JPRB, 0.40696340E-18_JPRB, 0.26015722E-18_JPRB, 0.17418575E-18_JPRB, &
  & 0.10833453E-18_JPRB, 0.70499725E-19_JPRB, 0.44351525E-19_JPRB, 0.28616885E-19_JPRB, 0.19033016E-19_JPRB, 0.14075365E-19_JPRB, &
  & 0.11064187E-19_JPRB, 0.99765365E-20_JPRB, 0.96167275E-20_JPRB, 0.10057516E-19_JPRB, 0.10907494E-19_JPRB, 0.12009735E-19_JPRB, &
  & 0.13190837E-19_JPRB, 0.14086823E-19_JPRB, 0.14329415E-19_JPRB, 0.12475669E-19_JPRB /)

RGHG5(:,12, 9) = (/ &
  & 0.17529842E-18_JPRB, 0.28711586E-18_JPRB, 0.37926272E-18_JPRB, 0.47089603E-18_JPRB, 0.59727863E-18_JPRB, 0.76902940E-18_JPRB, &
  & 0.10267098E-17_JPRB, 0.14036456E-17_JPRB, 0.19469648E-17_JPRB, 0.27064361E-17_JPRB, 0.37523787E-17_JPRB, 0.51282563E-17_JPRB, &
  & 0.68311032E-17_JPRB, 0.88343055E-17_JPRB, 0.11053001E-16_JPRB, 0.13360975E-16_JPRB, 0.15704745E-16_JPRB, 0.18156002E-16_JPRB, &
  & 0.20765132E-16_JPRB, 0.23636764E-16_JPRB, 0.26847328E-16_JPRB, 0.30343069E-16_JPRB, 0.34346557E-16_JPRB, 0.39241111E-16_JPRB, &
  & 0.45209103E-16_JPRB, 0.52439452E-16_JPRB, 0.62400441E-16_JPRB, 0.76210241E-16_JPRB, 0.98161775E-16_JPRB, 0.13248396E-15_JPRB, &
  & 0.17419763E-15_JPRB, 0.26023923E-15_JPRB, 0.32293698E-15_JPRB, 0.46124036E-15_JPRB, 0.50614554E-15_JPRB, 0.55778718E-15_JPRB, &
  & 0.56587921E-15_JPRB, 0.45969955E-15_JPRB, 0.47770223E-15_JPRB, 0.41996336E-15_JPRB, 0.31945046E-15_JPRB, 0.22476181E-15_JPRB, &
  & 0.18897255E-15_JPRB, 0.13330909E-15_JPRB, 0.11985303E-15_JPRB, 0.81001046E-16_JPRB, 0.55059798E-16_JPRB, 0.39254203E-16_JPRB, &
  & 0.25908112E-16_JPRB, 0.17907047E-16_JPRB, 0.11916687E-16_JPRB, 0.81136558E-17_JPRB, 0.56684777E-17_JPRB, 0.43818578E-17_JPRB, &
  & 0.35742441E-17_JPRB, 0.33207470E-17_JPRB, 0.32732182E-17_JPRB, 0.34765822E-17_JPRB, 0.38066025E-17_JPRB, 0.42133565E-17_JPRB, &
  & 0.46310385E-17_JPRB, 0.49560936E-17_JPRB, 0.50434236E-17_JPRB, 0.43869623E-17_JPRB /)

RGHG5(:,13, 9) = (/ &
  & 0.36275915E-17_JPRB, 0.62271736E-17_JPRB, 0.80518563E-17_JPRB, 0.10147126E-16_JPRB, 0.12680098E-16_JPRB, 0.16274345E-16_JPRB, &
  & 0.21422042E-16_JPRB, 0.28854859E-16_JPRB, 0.39446328E-16_JPRB, 0.53960260E-16_JPRB, 0.73766829E-16_JPRB, 0.99197577E-16_JPRB, &
  & 0.13052230E-15_JPRB, 0.16637106E-15_JPRB, 0.20529358E-15_JPRB, 0.24477593E-15_JPRB, 0.28345269E-15_JPRB, 0.32293351E-15_JPRB, &
  & 0.36536766E-15_JPRB, 0.41267199E-15_JPRB, 0.46221688E-15_JPRB, 0.50394733E-15_JPRB, 0.53997450E-15_JPRB, 0.58392604E-15_JPRB, &
  & 0.63698397E-15_JPRB, 0.69601724E-15_JPRB, 0.76663734E-15_JPRB, 0.86955174E-15_JPRB, 0.99213446E-15_JPRB, 0.11617630E-14_JPRB, &
  & 0.14131595E-14_JPRB, 0.18042321E-14_JPRB, 0.24589377E-14_JPRB, 0.29430471E-14_JPRB, 0.36498146E-14_JPRB, 0.39890297E-14_JPRB, &
  & 0.35058243E-14_JPRB, 0.28636824E-14_JPRB, 0.23243200E-14_JPRB, 0.18021115E-14_JPRB, 0.15253136E-14_JPRB, 0.14259450E-14_JPRB, &
  & 0.12873880E-14_JPRB, 0.10257297E-14_JPRB, 0.75913284E-15_JPRB, 0.61654851E-15_JPRB, 0.46133660E-15_JPRB, 0.33950211E-15_JPRB, &
  & 0.24717806E-15_JPRB, 0.18226949E-15_JPRB, 0.13619583E-15_JPRB, 0.10530163E-15_JPRB, 0.85300314E-16_JPRB, 0.74524592E-16_JPRB, &
  & 0.67944126E-16_JPRB, 0.66994972E-16_JPRB, 0.68590955E-16_JPRB, 0.72687279E-16_JPRB, 0.78280674E-16_JPRB, 0.84841904E-16_JPRB, &
  & 0.90903410E-16_JPRB, 0.95349023E-16_JPRB, 0.97087611E-16_JPRB, 0.89304345E-16_JPRB /)

RGHG5(:,14, 9) = (/ &
  & 0.47429511E-16_JPRB, 0.82421110E-16_JPRB, 0.10963243E-15_JPRB, 0.13816891E-15_JPRB, 0.17467914E-15_JPRB, 0.22412841E-15_JPRB, &
  & 0.29501403E-15_JPRB, 0.39641155E-15_JPRB, 0.53974835E-15_JPRB, 0.73626063E-15_JPRB, 0.10015479E-14_JPRB, 0.13427180E-14_JPRB, &
  & 0.17600580E-14_JPRB, 0.22404060E-14_JPRB, 0.27604484E-14_JPRB, 0.32924899E-14_JPRB, 0.38044150E-14_JPRB, 0.43034737E-14_JPRB, &
  & 0.48364794E-14_JPRB, 0.54320545E-14_JPRB, 0.59800509E-14_JPRB, 0.63586272E-14_JPRB, 0.65525770E-14_JPRB, 0.67590548E-14_JPRB, &
  & 0.71124128E-14_JPRB, 0.75008732E-14_JPRB, 0.78701456E-14_JPRB, 0.83212593E-14_JPRB, 0.89769119E-14_JPRB, 0.97925903E-14_JPRB, &
  & 0.10867365E-13_JPRB, 0.13046821E-13_JPRB, 0.14783303E-13_JPRB, 0.18825732E-13_JPRB, 0.21941109E-13_JPRB, 0.19462576E-13_JPRB, &
  & 0.17312557E-13_JPRB, 0.16745804E-13_JPRB, 0.15780446E-13_JPRB, 0.15320104E-13_JPRB, 0.14774257E-13_JPRB, 0.13701786E-13_JPRB, &
  & 0.12112909E-13_JPRB, 0.10082813E-13_JPRB, 0.79705817E-14_JPRB, 0.60698673E-14_JPRB, 0.47288964E-14_JPRB, 0.35542629E-14_JPRB, &
  & 0.27205737E-14_JPRB, 0.21180781E-14_JPRB, 0.16894054E-14_JPRB, 0.13992102E-14_JPRB, 0.12101114E-14_JPRB, 0.10956410E-14_JPRB, &
  & 0.10360528E-14_JPRB, 0.10190928E-14_JPRB, 0.10355163E-14_JPRB, 0.10727909E-14_JPRB, 0.11098786E-14_JPRB, 0.11781127E-14_JPRB, &
  & 0.12228625E-14_JPRB, 0.12673610E-14_JPRB, 0.12699062E-14_JPRB, 0.11658137E-14_JPRB /)

RGHG5(:,15, 9) = (/ &
  & 0.43277915E-15_JPRB, 0.76652188E-15_JPRB, 0.10240802E-14_JPRB, 0.12951297E-14_JPRB, 0.16367331E-14_JPRB, 0.20979611E-14_JPRB, &
  & 0.27548762E-14_JPRB, 0.36910240E-14_JPRB, 0.50094460E-14_JPRB, 0.68152288E-14_JPRB, 0.92360108E-14_JPRB, 0.12336708E-13_JPRB, &
  & 0.16110692E-13_JPRB, 0.20436923E-13_JPRB, 0.25109617E-13_JPRB, 0.29902977E-13_JPRB, 0.34570860E-13_JPRB, 0.38914530E-13_JPRB, &
  & 0.43166656E-13_JPRB, 0.47729270E-13_JPRB, 0.52477222E-13_JPRB, 0.56059771E-13_JPRB, 0.57730513E-13_JPRB, 0.58610221E-13_JPRB, &
  & 0.60269206E-13_JPRB, 0.62580332E-13_JPRB, 0.64244176E-13_JPRB, 0.65658125E-13_JPRB, 0.67493049E-13_JPRB, 0.69721687E-13_JPRB, &
  & 0.72658690E-13_JPRB, 0.75881386E-13_JPRB, 0.82106813E-13_JPRB, 0.85714103E-13_JPRB, 0.84515287E-13_JPRB, 0.94990761E-13_JPRB, &
  & 0.10412092E-12_JPRB, 0.10756995E-12_JPRB, 0.10890160E-12_JPRB, 0.10512594E-12_JPRB, 0.96922070E-13_JPRB, 0.87158457E-13_JPRB, &
  & 0.76120818E-13_JPRB, 0.64525547E-13_JPRB, 0.53438004E-13_JPRB, 0.43603281E-13_JPRB, 0.35296134E-13_JPRB, 0.28631638E-13_JPRB, &
  & 0.23505344E-13_JPRB, 0.19633837E-13_JPRB, 0.16761469E-13_JPRB, 0.14668563E-13_JPRB, 0.13178328E-13_JPRB, 0.12153512E-13_JPRB, &
  & 0.11518578E-13_JPRB, 0.11193868E-13_JPRB, 0.11151083E-13_JPRB, 0.11241628E-13_JPRB, 0.11232517E-13_JPRB, 0.11674332E-13_JPRB, &
  & 0.11791079E-13_JPRB, 0.11898200E-13_JPRB, 0.11323478E-13_JPRB, 0.10247815E-13_JPRB /)

RGHG5(:,16, 9) = (/ &
  & 0.30727196E-14_JPRB, 0.53819707E-14_JPRB, 0.70065600E-14_JPRB, 0.87460235E-14_JPRB, 0.10855120E-13_JPRB, 0.13742957E-13_JPRB, &
  & 0.17830836E-13_JPRB, 0.23678455E-13_JPRB, 0.31913559E-13_JPRB, 0.43203458E-13_JPRB, 0.58281328E-13_JPRB, 0.77526181E-13_JPRB, &
  & 0.10085439E-12_JPRB, 0.12753278E-12_JPRB, 0.15636692E-12_JPRB, 0.18607232E-12_JPRB, 0.21560547E-12_JPRB, 0.24390112E-12_JPRB, &
  & 0.27157394E-12_JPRB, 0.30102708E-12_JPRB, 0.32834678E-12_JPRB, 0.34925887E-12_JPRB, 0.36424704E-12_JPRB, 0.37384912E-12_JPRB, &
  & 0.38255033E-12_JPRB, 0.39387108E-12_JPRB, 0.40281995E-12_JPRB, 0.40515340E-12_JPRB, 0.40415750E-12_JPRB, 0.40346277E-12_JPRB, &
  & 0.40610408E-12_JPRB, 0.41500874E-12_JPRB, 0.42838744E-12_JPRB, 0.43707280E-12_JPRB, 0.45689169E-12_JPRB, 0.46426204E-12_JPRB, &
  & 0.46501973E-12_JPRB, 0.46949131E-12_JPRB, 0.46993952E-12_JPRB, 0.46691405E-12_JPRB, 0.45718822E-12_JPRB, 0.43467744E-12_JPRB, &
  & 0.39842416E-12_JPRB, 0.35430277E-12_JPRB, 0.30779814E-12_JPRB, 0.26306404E-12_JPRB, 0.22300483E-12_JPRB, 0.18982090E-12_JPRB, &
  & 0.16374140E-12_JPRB, 0.14365489E-12_JPRB, 0.12802651E-12_JPRB, 0.11562450E-12_JPRB, 0.10553697E-12_JPRB, 0.97375782E-13_JPRB, &
  & 0.90955455E-13_JPRB, 0.86457473E-13_JPRB, 0.83974860E-13_JPRB, 0.82819582E-13_JPRB, 0.81958461E-13_JPRB, 0.81102253E-13_JPRB, &
  & 0.79928367E-13_JPRB, 0.82142551E-13_JPRB, 0.76288863E-13_JPRB, 0.69623621E-13_JPRB /)

RGHG5(:,17, 9) = (/ &
  & 0.18451068E-13_JPRB, 0.30129341E-13_JPRB, 0.37634972E-13_JPRB, 0.44951357E-13_JPRB, 0.53897235E-13_JPRB, 0.66061753E-13_JPRB, &
  & 0.83580136E-13_JPRB, 0.10883555E-12_JPRB, 0.14461991E-12_JPRB, 0.19381292E-12_JPRB, 0.25946910E-12_JPRB, 0.34298099E-12_JPRB, &
  & 0.44388424E-12_JPRB, 0.55896699E-12_JPRB, 0.68338927E-12_JPRB, 0.81145794E-12_JPRB, 0.93836679E-12_JPRB, 0.10601568E-11_JPRB, &
  & 0.11714350E-11_JPRB, 0.12833218E-11_JPRB, 0.14146837E-11_JPRB, 0.15526922E-11_JPRB, 0.16733758E-11_JPRB, 0.17649467E-11_JPRB, &
  & 0.18276743E-11_JPRB, 0.18685112E-11_JPRB, 0.19010498E-11_JPRB, 0.19036149E-11_JPRB, 0.18655849E-11_JPRB, 0.18144518E-11_JPRB, &
  & 0.17581267E-11_JPRB, 0.16958535E-11_JPRB, 0.16380972E-11_JPRB, 0.15840785E-11_JPRB, 0.15438468E-11_JPRB, 0.15254303E-11_JPRB, &
  & 0.15433627E-11_JPRB, 0.15844661E-11_JPRB, 0.16413197E-11_JPRB, 0.16928128E-11_JPRB, 0.17164643E-11_JPRB, 0.16952263E-11_JPRB, &
  & 0.16259447E-11_JPRB, 0.15136039E-11_JPRB, 0.13707699E-11_JPRB, 0.12195577E-11_JPRB, 0.10787851E-11_JPRB, 0.95847245E-12_JPRB, &
  & 0.85953494E-12_JPRB, 0.77843840E-12_JPRB, 0.71025624E-12_JPRB, 0.65069413E-12_JPRB, 0.59745362E-12_JPRB, 0.54981280E-12_JPRB, &
  & 0.50801995E-12_JPRB, 0.47255396E-12_JPRB, 0.44463755E-12_JPRB, 0.42480017E-12_JPRB, 0.41231943E-12_JPRB, 0.40368365E-12_JPRB, &
  & 0.39423467E-12_JPRB, 0.37818782E-12_JPRB, 0.36411605E-12_JPRB, 0.31329895E-12_JPRB /)

RGHG5(:,18, 9) = (/ &
  & 0.95453369E-13_JPRB, 0.14083054E-12_JPRB, 0.16433850E-12_JPRB, 0.18488371E-12_JPRB, 0.20993363E-12_JPRB, 0.24524569E-12_JPRB, &
  & 0.29790818E-12_JPRB, 0.37585375E-12_JPRB, 0.48785943E-12_JPRB, 0.64307652E-12_JPRB, 0.85059889E-12_JPRB, 0.11150173E-11_JPRB, &
  & 0.14345708E-11_JPRB, 0.18010842E-11_JPRB, 0.22015196E-11_JPRB, 0.26227495E-11_JPRB, 0.30538959E-11_JPRB, 0.34880783E-11_JPRB, &
  & 0.39228351E-11_JPRB, 0.43501695E-11_JPRB, 0.47947067E-11_JPRB, 0.52588342E-11_JPRB, 0.57132333E-11_JPRB, 0.61288778E-11_JPRB, &
  & 0.64627041E-11_JPRB, 0.66744713E-11_JPRB, 0.67358393E-11_JPRB, 0.66723315E-11_JPRB, 0.65082844E-11_JPRB, 0.62310383E-11_JPRB, &
  & 0.58653412E-11_JPRB, 0.54278908E-11_JPRB, 0.50160158E-11_JPRB, 0.46661104E-11_JPRB, 0.43869591E-11_JPRB, 0.42281439E-11_JPRB, &
  & 0.42071377E-11_JPRB, 0.43137581E-11_JPRB, 0.45137136E-11_JPRB, 0.47524094E-11_JPRB, 0.49607159E-11_JPRB, 0.50773235E-11_JPRB, &
  & 0.50568872E-11_JPRB, 0.48884295E-11_JPRB, 0.46063930E-11_JPRB, 0.42658368E-11_JPRB, 0.39185252E-11_JPRB, 0.35965911E-11_JPRB, &
  & 0.33098897E-11_JPRB, 0.30550805E-11_JPRB, 0.28216563E-11_JPRB, 0.26006690E-11_JPRB, 0.23894270E-11_JPRB, 0.21909057E-11_JPRB, &
  & 0.20125282E-11_JPRB, 0.18590201E-11_JPRB, 0.17328435E-11_JPRB, 0.16325393E-11_JPRB, 0.15574992E-11_JPRB, 0.15054514E-11_JPRB, &
  & 0.14662890E-11_JPRB, 0.14157967E-11_JPRB, 0.13377857E-11_JPRB, 0.11568536E-11_JPRB /)

RGHG5(:,19, 9) = (/ &
  & 0.40679528E-12_JPRB, 0.53993859E-12_JPRB, 0.58640153E-12_JPRB, 0.61972183E-12_JPRB, 0.66231200E-12_JPRB, 0.73080143E-12_JPRB, &
  & 0.84361912E-12_JPRB, 0.10199258E-11_JPRB, 0.12798393E-11_JPRB, 0.16437737E-11_JPRB, 0.21300088E-11_JPRB, 0.27453604E-11_JPRB, &
  & 0.34834364E-11_JPRB, 0.43206020E-11_JPRB, 0.52286040E-11_JPRB, 0.61780229E-11_JPRB, 0.71503103E-11_JPRB, 0.81396435E-11_JPRB, &
  & 0.91481944E-11_JPRB, 0.10184499E-10_JPRB, 0.11237719E-10_JPRB, 0.12337269E-10_JPRB, 0.13472464E-10_JPRB, 0.14596784E-10_JPRB, &
  & 0.15613054E-10_JPRB, 0.16396757E-10_JPRB, 0.16817008E-10_JPRB, 0.16819275E-10_JPRB, 0.16403563E-10_JPRB, 0.15648810E-10_JPRB, &
  & 0.14642712E-10_JPRB, 0.13425025E-10_JPRB, 0.12226249E-10_JPRB, 0.11138323E-10_JPRB, 0.10340506E-10_JPRB, 0.98525138E-11_JPRB, &
  & 0.96410701E-11_JPRB, 0.97657091E-11_JPRB, 0.10203534E-10_JPRB, 0.10811466E-10_JPRB, 0.11433685E-10_JPRB, 0.11925122E-10_JPRB, &
  & 0.12157881E-10_JPRB, 0.12094542E-10_JPRB, 0.11765159E-10_JPRB, 0.11242942E-10_JPRB, 0.10618516E-10_JPRB, 0.99674609E-11_JPRB, &
  & 0.93301825E-11_JPRB, 0.87115003E-11_JPRB, 0.81008377E-11_JPRB, 0.74923661E-11_JPRB, 0.68938826E-11_JPRB, 0.63263158E-11_JPRB, &
  & 0.58127348E-11_JPRB, 0.53686504E-11_JPRB, 0.50042314E-11_JPRB, 0.47146401E-11_JPRB, 0.44903456E-11_JPRB, 0.43186435E-11_JPRB, &
  & 0.41593703E-11_JPRB, 0.40032652E-11_JPRB, 0.37943476E-11_JPRB, 0.33762995E-11_JPRB /)

RGHG5(:,20, 9) = (/ &
  & 0.13790510E-11_JPRB, 0.16123773E-11_JPRB, 0.16613313E-11_JPRB, 0.16691516E-11_JPRB, 0.16990897E-11_JPRB, 0.17830683E-11_JPRB, &
  & 0.19600883E-11_JPRB, 0.22659726E-11_JPRB, 0.27368743E-11_JPRB, 0.34046750E-11_JPRB, 0.42979344E-11_JPRB, 0.54216423E-11_JPRB, &
  & 0.67532421E-11_JPRB, 0.82476049E-11_JPRB, 0.98450085E-11_JPRB, 0.11499250E-10_JPRB, 0.13176638E-10_JPRB, 0.14877247E-10_JPRB, &
  & 0.16621475E-10_JPRB, 0.18444371E-10_JPRB, 0.20367780E-10_JPRB, 0.22418352E-10_JPRB, 0.24594122E-10_JPRB, 0.26840224E-10_JPRB, &
  & 0.28983954E-10_JPRB, 0.30776302E-10_JPRB, 0.31946362E-10_JPRB, 0.32327561E-10_JPRB, 0.31866641E-10_JPRB, 0.30666220E-10_JPRB, &
  & 0.28864916E-10_JPRB, 0.26626019E-10_JPRB, 0.24307613E-10_JPRB, 0.22098748E-10_JPRB, 0.20292120E-10_JPRB, 0.19067255E-10_JPRB, &
  & 0.18657914E-10_JPRB, 0.18930283E-10_JPRB, 0.19689854E-10_JPRB, 0.20788355E-10_JPRB, 0.21958624E-10_JPRB, 0.22961374E-10_JPRB, &
  & 0.23596501E-10_JPRB, 0.23806282E-10_JPRB, 0.23569809E-10_JPRB, 0.22948997E-10_JPRB, 0.22060121E-10_JPRB, 0.21016324E-10_JPRB, &
  & 0.19888357E-10_JPRB, 0.18705504E-10_JPRB, 0.17486176E-10_JPRB, 0.16252295E-10_JPRB, 0.15040634E-10_JPRB, 0.13896813E-10_JPRB, &
  & 0.12860975E-10_JPRB, 0.11961521E-10_JPRB, 0.11218325E-10_JPRB, 0.10630287E-10_JPRB, 0.10172840E-10_JPRB, 0.98011798E-11_JPRB, &
  & 0.94510242E-11_JPRB, 0.90835854E-11_JPRB, 0.86716277E-11_JPRB, 0.78465593E-11_JPRB /)

RGHG5(:,21, 9) = (/ &
  & 0.34746110E-11_JPRB, 0.37457064E-11_JPRB, 0.37173832E-11_JPRB, 0.36354856E-11_JPRB, 0.35909452E-11_JPRB, 0.36416490E-11_JPRB, &
  & 0.38531348E-11_JPRB, 0.42816467E-11_JPRB, 0.49794105E-11_JPRB, 0.59936635E-11_JPRB, 0.73534165E-11_JPRB, 0.90582429E-11_JPRB, &
  & 0.11067784E-10_JPRB, 0.13299712E-10_JPRB, 0.15671561E-10_JPRB, 0.18107189E-10_JPRB, 0.20575305E-10_JPRB, 0.23072211E-10_JPRB, &
  & 0.25636240E-10_JPRB, 0.28334460E-10_JPRB, 0.31232548E-10_JPRB, 0.34374805E-10_JPRB, 0.37756933E-10_JPRB, 0.41313081E-10_JPRB, &
  & 0.44774108E-10_JPRB, 0.47788693E-10_JPRB, 0.49958617E-10_JPRB, 0.51046965E-10_JPRB, 0.50957630E-10_JPRB, 0.49732288E-10_JPRB, &
  & 0.47499102E-10_JPRB, 0.44502638E-10_JPRB, 0.41240122E-10_JPRB, 0.38039866E-10_JPRB, 0.35382190E-10_JPRB, 0.33578137E-10_JPRB, &
  & 0.32680896E-10_JPRB, 0.32793053E-10_JPRB, 0.33750724E-10_JPRB, 0.35180685E-10_JPRB, 0.36759887E-10_JPRB, 0.38085465E-10_JPRB, &
  & 0.39070077E-10_JPRB, 0.39498228E-10_JPRB, 0.39322302E-10_JPRB, 0.38609359E-10_JPRB, 0.37438896E-10_JPRB, 0.35936910E-10_JPRB, &
  & 0.34222573E-10_JPRB, 0.32375831E-10_JPRB, 0.30451416E-10_JPRB, 0.28506256E-10_JPRB, 0.26610632E-10_JPRB, 0.24833547E-10_JPRB, &
  & 0.23233122E-10_JPRB, 0.21843506E-10_JPRB, 0.20679219E-10_JPRB, 0.19736591E-10_JPRB, 0.18988436E-10_JPRB, 0.18341155E-10_JPRB, &
  & 0.17759899E-10_JPRB, 0.17196983E-10_JPRB, 0.16473557E-10_JPRB, 0.15202926E-10_JPRB /)

RGHG5(:,22, 9) = (/ &
  & 0.70136735E-11_JPRB, 0.71459986E-11_JPRB, 0.69581992E-11_JPRB, 0.67224785E-11_JPRB, 0.65157992E-11_JPRB, 0.64598127E-11_JPRB, &
  & 0.66423590E-11_JPRB, 0.71439252E-11_JPRB, 0.80352756E-11_JPRB, 0.93669170E-11_JPRB, 0.11176786E-10_JPRB, 0.13448493E-10_JPRB, &
  & 0.16119992E-10_JPRB, 0.19087393E-10_JPRB, 0.22229437E-10_JPRB, 0.25457110E-10_JPRB, 0.28719879E-10_JPRB, 0.32030642E-10_JPRB, &
  & 0.35438201E-10_JPRB, 0.39025342E-10_JPRB, 0.42892370E-10_JPRB, 0.47110246E-10_JPRB, 0.51683768E-10_JPRB, 0.56505085E-10_JPRB, &
  & 0.61295934E-10_JPRB, 0.65589131E-10_JPRB, 0.68937245E-10_JPRB, 0.70961723E-10_JPRB, 0.71548351E-10_JPRB, 0.70761910E-10_JPRB, &
  & 0.68720349E-10_JPRB, 0.65646731E-10_JPRB, 0.62069197E-10_JPRB, 0.58377747E-10_JPRB, 0.55164241E-10_JPRB, 0.52884773E-10_JPRB, &
  & 0.51719046E-10_JPRB, 0.51693060E-10_JPRB, 0.52534234E-10_JPRB, 0.53894902E-10_JPRB, 0.55394796E-10_JPRB, 0.56808887E-10_JPRB, &
  & 0.57688927E-10_JPRB, 0.58008438E-10_JPRB, 0.57710340E-10_JPRB, 0.56726585E-10_JPRB, 0.55159950E-10_JPRB, 0.53166464E-10_JPRB, &
  & 0.50868761E-10_JPRB, 0.48366221E-10_JPRB, 0.45754647E-10_JPRB, 0.43136571E-10_JPRB, 0.40619265E-10_JPRB, 0.38293549E-10_JPRB, &
  & 0.36222705E-10_JPRB, 0.34435736E-10_JPRB, 0.32939970E-10_JPRB, 0.31701142E-10_JPRB, 0.30602396E-10_JPRB, 0.29629538E-10_JPRB, &
  & 0.28760785E-10_JPRB, 0.27915907E-10_JPRB, 0.27005833E-10_JPRB, 0.25131119E-10_JPRB /)

RGHG5(:,23, 9) = (/ &
  & 0.12115098E-10_JPRB, 0.11953950E-10_JPRB, 0.11523205E-10_JPRB, 0.11023791E-10_JPRB, 0.10585044E-10_JPRB, 0.10339473E-10_JPRB, &
  & 0.10411661E-10_JPRB, 0.10909228E-10_JPRB, 0.11919703E-10_JPRB, 0.13508181E-10_JPRB, 0.15700555E-10_JPRB, 0.18479003E-10_JPRB, &
  & 0.21762163E-10_JPRB, 0.25417769E-10_JPRB, 0.29308996E-10_JPRB, 0.33316811E-10_JPRB, 0.37384883E-10_JPRB, 0.41508852E-10_JPRB, &
  & 0.45760416E-10_JPRB, 0.50219155E-10_JPRB, 0.55011381E-10_JPRB, 0.60193940E-10_JPRB, 0.65824061E-10_JPRB, 0.71713122E-10_JPRB, &
  & 0.77594930E-10_JPRB, 0.82882957E-10_JPRB, 0.87165788E-10_JPRB, 0.90179725E-10_JPRB, 0.91829613E-10_JPRB, 0.92012106E-10_JPRB, &
  & 0.90808180E-10_JPRB, 0.88418363E-10_JPRB, 0.85335107E-10_JPRB, 0.81997305E-10_JPRB, 0.78933610E-10_JPRB, 0.76575822E-10_JPRB, &
  & 0.75213058E-10_JPRB, 0.74901779E-10_JPRB, 0.75381000E-10_JPRB, 0.76259707E-10_JPRB, 0.77211279E-10_JPRB, 0.77999933E-10_JPRB, &
  & 0.78435307E-10_JPRB, 0.78228687E-10_JPRB, 0.77351896E-10_JPRB, 0.75881926E-10_JPRB, 0.73786900E-10_JPRB, 0.71197735E-10_JPRB, &
  & 0.68281901E-10_JPRB, 0.65176323E-10_JPRB, 0.61990288E-10_JPRB, 0.58845089E-10_JPRB, 0.55868282E-10_JPRB, 0.53154932E-10_JPRB, &
  & 0.50755823E-10_JPRB, 0.48683356E-10_JPRB, 0.46924062E-10_JPRB, 0.45422319E-10_JPRB, 0.44068818E-10_JPRB, 0.42841095E-10_JPRB, &
  & 0.41701066E-10_JPRB, 0.40604454E-10_JPRB, 0.39325015E-10_JPRB, 0.37220511E-10_JPRB /)

RGHG5(:,24, 9) = (/ &
  & 0.18702625E-10_JPRB, 0.18175806E-10_JPRB, 0.17415373E-10_JPRB, 0.16626546E-10_JPRB, 0.15902850E-10_JPRB, 0.15394068E-10_JPRB, &
  & 0.15281701E-10_JPRB, 0.15698831E-10_JPRB, 0.16755972E-10_JPRB, 0.18525481E-10_JPRB, 0.21039167E-10_JPRB, 0.24264193E-10_JPRB, &
  & 0.28111222E-10_JPRB, 0.32437063E-10_JPRB, 0.37074042E-10_JPRB, 0.41889749E-10_JPRB, 0.46782921E-10_JPRB, 0.51752644E-10_JPRB, &
  & 0.56843454E-10_JPRB, 0.62133985E-10_JPRB, 0.67746350E-10_JPRB, 0.73743830E-10_JPRB, 0.80181188E-10_JPRB, 0.86840680E-10_JPRB, &
  & 0.93414443E-10_JPRB, 0.99555919E-10_JPRB, 0.10479408E-09_JPRB, 0.10871198E-09_JPRB, 0.11121126E-09_JPRB, 0.11241348E-09_JPRB, &
  & 0.11238917E-09_JPRB, 0.11124078E-09_JPRB, 0.10934406E-09_JPRB, 0.10705428E-09_JPRB, 0.10475246E-09_JPRB, 0.10276561E-09_JPRB, &
  & 0.10146625E-09_JPRB, 0.10078807E-09_JPRB, 0.10059355E-09_JPRB, 0.10061164E-09_JPRB, 0.10056089E-09_JPRB, 0.10030103E-09_JPRB, &
  & 0.99699075E-10_JPRB, 0.98717416E-10_JPRB, 0.97107100E-10_JPRB, 0.94881922E-10_JPRB, 0.92138644E-10_JPRB, 0.89009793E-10_JPRB, &
  & 0.85567983E-10_JPRB, 0.81940843E-10_JPRB, 0.78286939E-10_JPRB, 0.74749318E-10_JPRB, 0.71457236E-10_JPRB, 0.68488201E-10_JPRB, &
  & 0.65866569E-10_JPRB, 0.63584735E-10_JPRB, 0.61619994E-10_JPRB, 0.59846586E-10_JPRB, 0.58246241E-10_JPRB, 0.56791814E-10_JPRB, &
  & 0.55454214E-10_JPRB, 0.54147752E-10_JPRB, 0.52707196E-10_JPRB, 0.50084679E-10_JPRB /)

RGHG5(:,25, 9) = (/ &
  & 0.26565136E-10_JPRB, 0.25647248E-10_JPRB, 0.24617119E-10_JPRB, 0.23537982E-10_JPRB, 0.22552467E-10_JPRB, 0.21782774E-10_JPRB, &
  & 0.21459756E-10_JPRB, 0.21756721E-10_JPRB, 0.22813959E-10_JPRB, 0.24716963E-10_JPRB, 0.27504889E-10_JPRB, 0.31143026E-10_JPRB, &
  & 0.35537025E-10_JPRB, 0.40533299E-10_JPRB, 0.45942087E-10_JPRB, 0.51601182E-10_JPRB, 0.57369276E-10_JPRB, 0.63195199E-10_JPRB, &
  & 0.69108858E-10_JPRB, 0.75165492E-10_JPRB, 0.81446391E-10_JPRB, 0.88018690E-10_JPRB, 0.94911204E-10_JPRB, 0.10199164E-09_JPRB, &
  & 0.10893055E-09_JPRB, 0.11531570E-09_JPRB, 0.12081416E-09_JPRB, 0.12531808E-09_JPRB, 0.12879380E-09_JPRB, 0.13115231E-09_JPRB, &
  & 0.13244955E-09_JPRB, 0.13276409E-09_JPRB, 0.13235894E-09_JPRB, 0.13143631E-09_JPRB, 0.13029069E-09_JPRB, 0.12910682E-09_JPRB, &
  & 0.12796733E-09_JPRB, 0.12691589E-09_JPRB, 0.12589442E-09_JPRB, 0.12486842E-09_JPRB, 0.12364251E-09_JPRB, 0.12221157E-09_JPRB, &
  & 0.12041557E-09_JPRB, 0.11834406E-09_JPRB, 0.11586115E-09_JPRB, 0.11291532E-09_JPRB, 0.10949008E-09_JPRB, 0.10575035E-09_JPRB, &
  & 0.10184535E-09_JPRB, 0.97868172E-10_JPRB, 0.93925617E-10_JPRB, 0.90159470E-10_JPRB, 0.86687720E-10_JPRB, 0.83571372E-10_JPRB, &
  & 0.80823494E-10_JPRB, 0.78429548E-10_JPRB, 0.76294873E-10_JPRB, 0.74357909E-10_JPRB, 0.72583065E-10_JPRB, 0.70942648E-10_JPRB, &
  & 0.69410151E-10_JPRB, 0.67920281E-10_JPRB, 0.66264799E-10_JPRB, 0.63378552E-10_JPRB /)

RGHG5(:,26, 9) = (/ &
  & 0.35437729E-10_JPRB, 0.34288707E-10_JPRB, 0.33071011E-10_JPRB, 0.31853822E-10_JPRB, 0.30673165E-10_JPRB, 0.29750841E-10_JPRB, &
  & 0.29251102E-10_JPRB, 0.29440374E-10_JPRB, 0.30486742E-10_JPRB, 0.32508610E-10_JPRB, 0.35545802E-10_JPRB, 0.39580891E-10_JPRB, &
  & 0.44509681E-10_JPRB, 0.50175981E-10_JPRB, 0.56370696E-10_JPRB, 0.62882671E-10_JPRB, 0.69524560E-10_JPRB, 0.76197632E-10_JPRB, &
  & 0.82861454E-10_JPRB, 0.89526164E-10_JPRB, 0.96292065E-10_JPRB, 0.10319701E-09_JPRB, 0.11023223E-09_JPRB, 0.11730102E-09_JPRB, &
  & 0.12416017E-09_JPRB, 0.13045860E-09_JPRB, 0.13605886E-09_JPRB, 0.14088659E-09_JPRB, 0.14486436E-09_JPRB, 0.14810753E-09_JPRB, &
  & 0.15055021E-09_JPRB, 0.15220460E-09_JPRB, 0.15321303E-09_JPRB, 0.15361444E-09_JPRB, 0.15348879E-09_JPRB, 0.15292910E-09_JPRB, &
  & 0.15199129E-09_JPRB, 0.15065835E-09_JPRB, 0.14897938E-09_JPRB, 0.14702300E-09_JPRB, 0.14473511E-09_JPRB, 0.14221926E-09_JPRB, &
  & 0.13942392E-09_JPRB, 0.13638826E-09_JPRB, 0.13305526E-09_JPRB, 0.12942594E-09_JPRB, 0.12551672E-09_JPRB, 0.12138321E-09_JPRB, &
  & 0.11711608E-09_JPRB, 0.11284092E-09_JPRB, 0.10869160E-09_JPRB, 0.10477767E-09_JPRB, 0.10119589E-09_JPRB, 0.97997915E-10_JPRB, &
  & 0.95180343E-10_JPRB, 0.92696871E-10_JPRB, 0.90447282E-10_JPRB, 0.88388664E-10_JPRB, 0.86486221E-10_JPRB, 0.84715700E-10_JPRB, &
  & 0.83055458E-10_JPRB, 0.81452407E-10_JPRB, 0.79647622E-10_JPRB, 0.76619981E-10_JPRB /)

RGHG5(:,27, 9) = (/ &
  & 0.45227030E-10_JPRB, 0.44067278E-10_JPRB, 0.42870894E-10_JPRB, 0.41600987E-10_JPRB, 0.40424261E-10_JPRB, 0.39416827E-10_JPRB, &
  & 0.38862892E-10_JPRB, 0.39015787E-10_JPRB, 0.40099323E-10_JPRB, 0.42248711E-10_JPRB, 0.45540672E-10_JPRB, 0.49949007E-10_JPRB, &
  & 0.55383982E-10_JPRB, 0.61675429E-10_JPRB, 0.68598141E-10_JPRB, 0.75890905E-10_JPRB, 0.83332286E-10_JPRB, 0.90728994E-10_JPRB, &
  & 0.97951314E-10_JPRB, 0.10507138E-09_JPRB, 0.11207552E-09_JPRB, 0.11902196E-09_JPRB, 0.12587831E-09_JPRB, 0.13260840E-09_JPRB, &
  & 0.13904847E-09_JPRB, 0.14504130E-09_JPRB, 0.15053805E-09_JPRB, 0.15542113E-09_JPRB, 0.15969970E-09_JPRB, 0.16338070E-09_JPRB, &
  & 0.16658282E-09_JPRB, 0.16924760E-09_JPRB, 0.17136578E-09_JPRB, 0.17282857E-09_JPRB, 0.17356587E-09_JPRB, 0.17355002E-09_JPRB, &
  & 0.17277110E-09_JPRB, 0.17123805E-09_JPRB, 0.16903025E-09_JPRB, 0.16631692E-09_JPRB, 0.16318333E-09_JPRB, 0.15977980E-09_JPRB, &
  & 0.15618568E-09_JPRB, 0.15239250E-09_JPRB, 0.14839763E-09_JPRB, 0.14417295E-09_JPRB, 0.13981384E-09_JPRB, 0.13539618E-09_JPRB, &
  & 0.13099741E-09_JPRB, 0.12664773E-09_JPRB, 0.12243617E-09_JPRB, 0.11847986E-09_JPRB, 0.11486935E-09_JPRB, 0.11163121E-09_JPRB, &
  & 0.10874362E-09_JPRB, 0.10610846E-09_JPRB, 0.10367331E-09_JPRB, 0.10139251E-09_JPRB, 0.99241476E-10_JPRB, 0.97218830E-10_JPRB, &
  & 0.95327635E-10_JPRB, 0.93494053E-10_JPRB, 0.91609623E-10_JPRB, 0.88680188E-10_JPRB /)

RGHG5(:,28, 9) = (/ &
  & 0.56269087E-10_JPRB, 0.55164588E-10_JPRB, 0.54047152E-10_JPRB, 0.52901857E-10_JPRB, 0.51743321E-10_JPRB, 0.50820976E-10_JPRB, &
  & 0.50305895E-10_JPRB, 0.50515203E-10_JPRB, 0.51695023E-10_JPRB, 0.54017919E-10_JPRB, 0.57554767E-10_JPRB, 0.62311788E-10_JPRB, &
  & 0.68183126E-10_JPRB, 0.74997043E-10_JPRB, 0.82499486E-10_JPRB, 0.90417139E-10_JPRB, 0.98463300E-10_JPRB, 0.10633083E-09_JPRB, &
  & 0.11394352E-09_JPRB, 0.12126532E-09_JPRB, 0.12827087E-09_JPRB, 0.13500184E-09_JPRB, 0.14144862E-09_JPRB, 0.14761221E-09_JPRB, &
  & 0.15343214E-09_JPRB, 0.15883514E-09_JPRB, 0.16378267E-09_JPRB, 0.16837551E-09_JPRB, 0.17271315E-09_JPRB, 0.17681270E-09_JPRB, &
  & 0.18057511E-09_JPRB, 0.18393334E-09_JPRB, 0.18679774E-09_JPRB, 0.18897010E-09_JPRB, 0.19028477E-09_JPRB, 0.19063406E-09_JPRB, &
  & 0.18996926E-09_JPRB, 0.18832030E-09_JPRB, 0.18578429E-09_JPRB, 0.18257448E-09_JPRB, 0.17889069E-09_JPRB, 0.17489145E-09_JPRB, &
  & 0.17074109E-09_JPRB, 0.16645169E-09_JPRB, 0.16203378E-09_JPRB, 0.15748899E-09_JPRB, 0.15289155E-09_JPRB, 0.14833014E-09_JPRB, &
  & 0.14385887E-09_JPRB, 0.13950026E-09_JPRB, 0.13530238E-09_JPRB, 0.13135602E-09_JPRB, 0.12772484E-09_JPRB, 0.12443357E-09_JPRB, &
  & 0.12144950E-09_JPRB, 0.11870542E-09_JPRB, 0.11616577E-09_JPRB, 0.11380755E-09_JPRB, 0.11162639E-09_JPRB, 0.10961586E-09_JPRB, &
  & 0.10776319E-09_JPRB, 0.10604997E-09_JPRB, 0.10417637E-09_JPRB, 0.10092153E-09_JPRB /)

RGHG5(:,29, 9) = (/ &
  & 0.68382550E-10_JPRB, 0.67495912E-10_JPRB, 0.66536943E-10_JPRB, 0.65466854E-10_JPRB, 0.64488366E-10_JPRB, 0.63664116E-10_JPRB, &
  & 0.63283850E-10_JPRB, 0.63618513E-10_JPRB, 0.64957338E-10_JPRB, 0.67471632E-10_JPRB, 0.71265827E-10_JPRB, 0.76316634E-10_JPRB, &
  & 0.82530906E-10_JPRB, 0.89714673E-10_JPRB, 0.97604355E-10_JPRB, 0.10590047E-09_JPRB, 0.11428334E-09_JPRB, 0.12235257E-09_JPRB, &
  & 0.13013206E-09_JPRB, 0.13743097E-09_JPRB, 0.14424120E-09_JPRB, 0.15058652E-09_JPRB, 0.15649301E-09_JPRB, 0.16200576E-09_JPRB, &
  & 0.16712390E-09_JPRB, 0.17184056E-09_JPRB, 0.17627216E-09_JPRB, 0.18054666E-09_JPRB, 0.18470404E-09_JPRB, 0.18883982E-09_JPRB, &
  & 0.19285271E-09_JPRB, 0.19656304E-09_JPRB, 0.19981936E-09_JPRB, 0.20236354E-09_JPRB, 0.20397972E-09_JPRB, 0.20452003E-09_JPRB, &
  & 0.20391923E-09_JPRB, 0.20222021E-09_JPRB, 0.19954552E-09_JPRB, 0.19608168E-09_JPRB, 0.19211846E-09_JPRB, 0.18780030E-09_JPRB, &
  & 0.18334614E-09_JPRB, 0.17878656E-09_JPRB, 0.17415097E-09_JPRB, 0.16945401E-09_JPRB, 0.16475402E-09_JPRB, 0.16013572E-09_JPRB, &
  & 0.15561645E-09_JPRB, 0.15124169E-09_JPRB, 0.14707630E-09_JPRB, 0.14318610E-09_JPRB, 0.13960634E-09_JPRB, 0.13633340E-09_JPRB, &
  & 0.13333169E-09_JPRB, 0.13057294E-09_JPRB, 0.12803400E-09_JPRB, 0.12569265E-09_JPRB, 0.12351443E-09_JPRB, 0.12147738E-09_JPRB, &
  & 0.11957312E-09_JPRB, 0.11769774E-09_JPRB, 0.11568190E-09_JPRB, 0.11220501E-09_JPRB /)

RGHG5(:,30, 9) = (/ &
  & 0.81348678E-10_JPRB, 0.80621218E-10_JPRB, 0.79784714E-10_JPRB, 0.78942533E-10_JPRB, 0.78101955E-10_JPRB, 0.77470003E-10_JPRB, &
  & 0.77258540E-10_JPRB, 0.77772538E-10_JPRB, 0.79301746E-10_JPRB, 0.82035649E-10_JPRB, 0.86045379E-10_JPRB, 0.91331200E-10_JPRB, &
  & 0.97766684E-10_JPRB, 0.10515225E-09_JPRB, 0.11319548E-09_JPRB, 0.12163721E-09_JPRB, 0.13004478E-09_JPRB, 0.13812990E-09_JPRB, &
  & 0.14580390E-09_JPRB, 0.15291574E-09_JPRB, 0.15940112E-09_JPRB, 0.16529179E-09_JPRB, 0.17064465E-09_JPRB, 0.17551269E-09_JPRB, &
  & 0.17996073E-09_JPRB, 0.18406389E-09_JPRB, 0.18797360E-09_JPRB, 0.19183839E-09_JPRB, 0.19574893E-09_JPRB, 0.19973405E-09_JPRB, &
  & 0.20371854E-09_JPRB, 0.20749163E-09_JPRB, 0.21084397E-09_JPRB, 0.21348832E-09_JPRB, 0.21519091E-09_JPRB, 0.21578810E-09_JPRB, &
  & 0.21521480E-09_JPRB, 0.21352195E-09_JPRB, 0.21084159E-09_JPRB, 0.20734311E-09_JPRB, 0.20328782E-09_JPRB, 0.19890574E-09_JPRB, &
  & 0.19432633E-09_JPRB, 0.18970292E-09_JPRB, 0.18501002E-09_JPRB, 0.18029907E-09_JPRB, 0.17562725E-09_JPRB, 0.17105564E-09_JPRB, &
  & 0.16662276E-09_JPRB, 0.16234109E-09_JPRB, 0.15825292E-09_JPRB, 0.15441912E-09_JPRB, 0.15086936E-09_JPRB, 0.14759736E-09_JPRB, &
  & 0.14457278E-09_JPRB, 0.14177833E-09_JPRB, 0.13917469E-09_JPRB, 0.13671866E-09_JPRB, 0.13438872E-09_JPRB, 0.13220641E-09_JPRB, &
  & 0.13018736E-09_JPRB, 0.12832832E-09_JPRB, 0.12635742E-09_JPRB, 0.12331251E-09_JPRB /)

RGHG5(:,31, 9) = (/ &
  & 0.94545233E-10_JPRB, 0.93991648E-10_JPRB, 0.93347524E-10_JPRB, 0.92680218E-10_JPRB, 0.92071156E-10_JPRB, 0.91636337E-10_JPRB, &
  & 0.91628316E-10_JPRB, 0.92362555E-10_JPRB, 0.94099020E-10_JPRB, 0.97024791E-10_JPRB, 0.10122325E-09_JPRB, 0.10664358E-09_JPRB, &
  & 0.11316840E-09_JPRB, 0.12056893E-09_JPRB, 0.12857287E-09_JPRB, 0.13688327E-09_JPRB, 0.14513656E-09_JPRB, 0.15303182E-09_JPRB, &
  & 0.16044994E-09_JPRB, 0.16724817E-09_JPRB, 0.17336795E-09_JPRB, 0.17882784E-09_JPRB, 0.18365873E-09_JPRB, 0.18797516E-09_JPRB, &
  & 0.19185069E-09_JPRB, 0.19543590E-09_JPRB, 0.19889573E-09_JPRB, 0.20235527E-09_JPRB, 0.20593295E-09_JPRB, 0.20964626E-09_JPRB, &
  & 0.21341966E-09_JPRB, 0.21703553E-09_JPRB, 0.22026764E-09_JPRB, 0.22281418E-09_JPRB, 0.22444976E-09_JPRB, 0.22501379E-09_JPRB, &
  & 0.22444951E-09_JPRB, 0.22280705E-09_JPRB, 0.22021594E-09_JPRB, 0.21683388E-09_JPRB, 0.21287573E-09_JPRB, 0.20855186E-09_JPRB, &
  & 0.20407198E-09_JPRB, 0.19947971E-09_JPRB, 0.19487005E-09_JPRB, 0.19023998E-09_JPRB, 0.18566149E-09_JPRB, 0.18120917E-09_JPRB, &
  & 0.17690466E-09_JPRB, 0.17276176E-09_JPRB, 0.16880135E-09_JPRB, 0.16505225E-09_JPRB, 0.16153937E-09_JPRB, 0.15825631E-09_JPRB, &
  & 0.15519158E-09_JPRB, 0.15232839E-09_JPRB, 0.14963117E-09_JPRB, 0.14709131E-09_JPRB, 0.14473481E-09_JPRB, 0.14258612E-09_JPRB, &
  & 0.14064609E-09_JPRB, 0.13881812E-09_JPRB, 0.13689674E-09_JPRB, 0.13346960E-09_JPRB /)

RGHG5(:,32, 9) = (/ &
  & 0.10757611E-09_JPRB, 0.10724293E-09_JPRB, 0.10675567E-09_JPRB, 0.10628990E-09_JPRB, 0.10587018E-09_JPRB, 0.10565008E-09_JPRB, &
  & 0.10587479E-09_JPRB, 0.10683047E-09_JPRB, 0.10877927E-09_JPRB, 0.11188641E-09_JPRB, 0.11618429E-09_JPRB, 0.12163903E-09_JPRB, &
  & 0.12810210E-09_JPRB, 0.13535625E-09_JPRB, 0.14312433E-09_JPRB, 0.15113343E-09_JPRB, 0.15905226E-09_JPRB, 0.16664421E-09_JPRB, &
  & 0.17373476E-09_JPRB, 0.18021251E-09_JPRB, 0.18597890E-09_JPRB, 0.19104576E-09_JPRB, 0.19547559E-09_JPRB, 0.19934454E-09_JPRB, &
  & 0.20278708E-09_JPRB, 0.20595639E-09_JPRB, 0.20901564E-09_JPRB, 0.21210550E-09_JPRB, 0.21532630E-09_JPRB, 0.21870138E-09_JPRB, &
  & 0.22214695E-09_JPRB, 0.22546104E-09_JPRB, 0.22841784E-09_JPRB, 0.23073217E-09_JPRB, 0.23219869E-09_JPRB, 0.23267335E-09_JPRB, &
  & 0.23211186E-09_JPRB, 0.23056074E-09_JPRB, 0.22811490E-09_JPRB, 0.22496245E-09_JPRB, 0.22122185E-09_JPRB, 0.21708282E-09_JPRB, &
  & 0.21277227E-09_JPRB, 0.20836587E-09_JPRB, 0.20389174E-09_JPRB, 0.19941694E-09_JPRB, 0.19500418E-09_JPRB, 0.19069282E-09_JPRB, &
  & 0.18652857E-09_JPRB, 0.18250958E-09_JPRB, 0.17865534E-09_JPRB, 0.17498329E-09_JPRB, 0.17151552E-09_JPRB, 0.16824026E-09_JPRB, &
  & 0.16514837E-09_JPRB, 0.16224162E-09_JPRB, 0.15950886E-09_JPRB, 0.15696289E-09_JPRB, 0.15460754E-09_JPRB, 0.15243729E-09_JPRB, &
  & 0.15043934E-09_JPRB, 0.14857085E-09_JPRB, 0.14655273E-09_JPRB, 0.14337849E-09_JPRB /)

RGHG5(:,33, 9) = (/ &
  & 0.12018786E-09_JPRB, 0.12003552E-09_JPRB, 0.11970164E-09_JPRB, 0.11937792E-09_JPRB, 0.11914991E-09_JPRB, 0.11915019E-09_JPRB, &
  & 0.11959535E-09_JPRB, 0.12078669E-09_JPRB, 0.12293719E-09_JPRB, 0.12615448E-09_JPRB, 0.13048565E-09_JPRB, 0.13584565E-09_JPRB, &
  & 0.14211476E-09_JPRB, 0.14907751E-09_JPRB, 0.15649386E-09_JPRB, 0.16406956E-09_JPRB, 0.17157660E-09_JPRB, 0.17876764E-09_JPRB, &
  & 0.18550700E-09_JPRB, 0.19164821E-09_JPRB, 0.19714751E-09_JPRB, 0.20196067E-09_JPRB, 0.20610212E-09_JPRB, 0.20966906E-09_JPRB, &
  & 0.21280613E-09_JPRB, 0.21566049E-09_JPRB, 0.21839316E-09_JPRB, 0.22113883E-09_JPRB, 0.22399976E-09_JPRB, 0.22698954E-09_JPRB, &
  & 0.23003649E-09_JPRB, 0.23295207E-09_JPRB, 0.23553418E-09_JPRB, 0.23753127E-09_JPRB, 0.23876559E-09_JPRB, 0.23912039E-09_JPRB, &
  & 0.23856175E-09_JPRB, 0.23712357E-09_JPRB, 0.23488306E-09_JPRB, 0.23200170E-09_JPRB, 0.22856966E-09_JPRB, 0.22469666E-09_JPRB, &
  & 0.22062942E-09_JPRB, 0.21644739E-09_JPRB, 0.21220234E-09_JPRB, 0.20790177E-09_JPRB, 0.20365945E-09_JPRB, 0.19952519E-09_JPRB, &
  & 0.19550525E-09_JPRB, 0.19162275E-09_JPRB, 0.18787388E-09_JPRB, 0.18427765E-09_JPRB, 0.18084767E-09_JPRB, 0.17758986E-09_JPRB, &
  & 0.17450644E-09_JPRB, 0.17159767E-09_JPRB, 0.16886370E-09_JPRB, 0.16629384E-09_JPRB, 0.16389096E-09_JPRB, 0.16168050E-09_JPRB, &
  & 0.15968898E-09_JPRB, 0.15784857E-09_JPRB, 0.15595533E-09_JPRB, 0.15265084E-09_JPRB /)

RGHG5(:,34, 9) = (/ &
  & 0.13182315E-09_JPRB, 0.13196511E-09_JPRB, 0.13183779E-09_JPRB, 0.13169479E-09_JPRB, 0.13165696E-09_JPRB, 0.13186099E-09_JPRB, &
  & 0.13254009E-09_JPRB, 0.13393331E-09_JPRB, 0.13623433E-09_JPRB, 0.13952378E-09_JPRB, 0.14378110E-09_JPRB, 0.14896234E-09_JPRB, &
  & 0.15492883E-09_JPRB, 0.16151154E-09_JPRB, 0.16848103E-09_JPRB, 0.17560253E-09_JPRB, 0.18263677E-09_JPRB, 0.18943283E-09_JPRB, &
  & 0.19583081E-09_JPRB, 0.20172104E-09_JPRB, 0.20702436E-09_JPRB, 0.21164280E-09_JPRB, 0.21560990E-09_JPRB, 0.21901028E-09_JPRB, &
  & 0.22195827E-09_JPRB, 0.22458538E-09_JPRB, 0.22704892E-09_JPRB, 0.22948474E-09_JPRB, 0.23198124E-09_JPRB, 0.23456545E-09_JPRB, &
  & 0.23716601E-09_JPRB, 0.23962882E-09_JPRB, 0.24177838E-09_JPRB, 0.24341151E-09_JPRB, 0.24438201E-09_JPRB, 0.24460398E-09_JPRB, &
  & 0.24404989E-09_JPRB, 0.24274027E-09_JPRB, 0.24073604E-09_JPRB, 0.23816238E-09_JPRB, 0.23504135E-09_JPRB, 0.23151327E-09_JPRB, &
  & 0.22772612E-09_JPRB, 0.22379384E-09_JPRB, 0.21980615E-09_JPRB, 0.21572627E-09_JPRB, 0.21163921E-09_JPRB, 0.20769261E-09_JPRB, &
  & 0.20382418E-09_JPRB, 0.20006156E-09_JPRB, 0.19641394E-09_JPRB, 0.19290540E-09_JPRB, 0.18953271E-09_JPRB, 0.18631938E-09_JPRB, &
  & 0.18327685E-09_JPRB, 0.18039362E-09_JPRB, 0.17766164E-09_JPRB, 0.17508310E-09_JPRB, 0.17268315E-09_JPRB, 0.17049571E-09_JPRB, &
  & 0.16852461E-09_JPRB, 0.16670033E-09_JPRB, 0.16472537E-09_JPRB, 0.16149912E-09_JPRB /)

RGHG5(:,35, 9) = (/ &
  & 0.14277290E-09_JPRB, 0.14300514E-09_JPRB, 0.14307174E-09_JPRB, 0.14310711E-09_JPRB, 0.14325011E-09_JPRB, 0.14365797E-09_JPRB, &
  & 0.14452445E-09_JPRB, 0.14609189E-09_JPRB, 0.14849805E-09_JPRB, 0.15177029E-09_JPRB, 0.15590984E-09_JPRB, 0.16082427E-09_JPRB, &
  & 0.16643825E-09_JPRB, 0.17257903E-09_JPRB, 0.17908175E-09_JPRB, 0.18570662E-09_JPRB, 0.19229031E-09_JPRB, 0.19868933E-09_JPRB, &
  & 0.20477026E-09_JPRB, 0.21044345E-09_JPRB, 0.21559760E-09_JPRB, 0.22014073E-09_JPRB, 0.22406813E-09_JPRB, 0.22741520E-09_JPRB, &
  & 0.23026407E-09_JPRB, 0.23273869E-09_JPRB, 0.23497915E-09_JPRB, 0.23712105E-09_JPRB, 0.23925845E-09_JPRB, 0.24141592E-09_JPRB, &
  & 0.24354671E-09_JPRB, 0.24552843E-09_JPRB, 0.24722213E-09_JPRB, 0.24847657E-09_JPRB, 0.24917979E-09_JPRB, 0.24927269E-09_JPRB, &
  & 0.24873159E-09_JPRB, 0.24756325E-09_JPRB, 0.24581204E-09_JPRB, 0.24354455E-09_JPRB, 0.24076327E-09_JPRB, 0.23756777E-09_JPRB, &
  & 0.23408309E-09_JPRB, 0.23044579E-09_JPRB, 0.22670214E-09_JPRB, 0.22283955E-09_JPRB, 0.21893024E-09_JPRB, 0.21515462E-09_JPRB, &
  & 0.21144181E-09_JPRB, 0.20779153E-09_JPRB, 0.20424350E-09_JPRB, 0.20082722E-09_JPRB, 0.19753366E-09_JPRB, 0.19438695E-09_JPRB, &
  & 0.19141808E-09_JPRB, 0.18859211E-09_JPRB, 0.18590644E-09_JPRB, 0.18336836E-09_JPRB, 0.18099938E-09_JPRB, 0.17882543E-09_JPRB, &
  & 0.17686064E-09_JPRB, 0.17503421E-09_JPRB, 0.17313131E-09_JPRB, 0.16987159E-09_JPRB /)

RGHG5(:,36, 9) = (/ &
  & 0.15258547E-09_JPRB, 0.15317955E-09_JPRB, 0.15340716E-09_JPRB, 0.15360306E-09_JPRB, 0.15391587E-09_JPRB, 0.15448712E-09_JPRB, &
  & 0.15552416E-09_JPRB, 0.15720857E-09_JPRB, 0.15965099E-09_JPRB, 0.16287451E-09_JPRB, 0.16681441E-09_JPRB, 0.17144015E-09_JPRB, &
  & 0.17665371E-09_JPRB, 0.18234700E-09_JPRB, 0.18834906E-09_JPRB, 0.19450523E-09_JPRB, 0.20062077E-09_JPRB, 0.20664134E-09_JPRB, &
  & 0.21244487E-09_JPRB, 0.21792415E-09_JPRB, 0.22299945E-09_JPRB, 0.22755738E-09_JPRB, 0.23151518E-09_JPRB, 0.23487379E-09_JPRB, &
  & 0.23766572E-09_JPRB, 0.24000607E-09_JPRB, 0.24204033E-09_JPRB, 0.24389787E-09_JPRB, 0.24567165E-09_JPRB, 0.24740260E-09_JPRB, &
  & 0.24906299E-09_JPRB, 0.25056615E-09_JPRB, 0.25181926E-09_JPRB, 0.25271357E-09_JPRB, 0.25317673E-09_JPRB, 0.25316865E-09_JPRB, &
  & 0.25266575E-09_JPRB, 0.25166288E-09_JPRB, 0.25017838E-09_JPRB, 0.24822805E-09_JPRB, 0.24577729E-09_JPRB, 0.24290805E-09_JPRB, &
  & 0.23975483E-09_JPRB, 0.23641872E-09_JPRB, 0.23288527E-09_JPRB, 0.22923048E-09_JPRB, 0.22553699E-09_JPRB, 0.22190748E-09_JPRB, &
  & 0.21833338E-09_JPRB, 0.21478416E-09_JPRB, 0.21133303E-09_JPRB, 0.20801255E-09_JPRB, 0.20482203E-09_JPRB, 0.20178112E-09_JPRB, &
  & 0.19892088E-09_JPRB, 0.19620100E-09_JPRB, 0.19360662E-09_JPRB, 0.19114188E-09_JPRB, 0.18882382E-09_JPRB, 0.18669066E-09_JPRB, &
  & 0.18476207E-09_JPRB, 0.18297842E-09_JPRB, 0.18105963E-09_JPRB, 0.17783153E-09_JPRB /)

RGHG5(:,37, 9) = (/ &
  & 0.16162624E-09_JPRB, 0.16254531E-09_JPRB, 0.16292021E-09_JPRB, 0.16326311E-09_JPRB, 0.16371922E-09_JPRB, 0.16444524E-09_JPRB, &
  & 0.16560534E-09_JPRB, 0.16736573E-09_JPRB, 0.16980395E-09_JPRB, 0.17289901E-09_JPRB, 0.17662311E-09_JPRB, 0.18090675E-09_JPRB, &
  & 0.18571197E-09_JPRB, 0.19092869E-09_JPRB, 0.19644626E-09_JPRB, 0.20210705E-09_JPRB, 0.20781168E-09_JPRB, 0.21342403E-09_JPRB, &
  & 0.21897095E-09_JPRB, 0.22432284E-09_JPRB, 0.22934551E-09_JPRB, 0.23391375E-09_JPRB, 0.23788985E-09_JPRB, 0.24119218E-09_JPRB, &
  & 0.24386776E-09_JPRB, 0.24601857E-09_JPRB, 0.24780697E-09_JPRB, 0.24936722E-09_JPRB, 0.25079247E-09_JPRB, 0.25212649E-09_JPRB, &
  & 0.25336047E-09_JPRB, 0.25444541E-09_JPRB, 0.25531996E-09_JPRB, 0.25591976E-09_JPRB, 0.25620175E-09_JPRB, 0.25614214E-09_JPRB, &
  & 0.25572205E-09_JPRB, 0.25492186E-09_JPRB, 0.25373859E-09_JPRB, 0.25213537E-09_JPRB, 0.25004732E-09_JPRB, 0.24755692E-09_JPRB, &
  & 0.24475344E-09_JPRB, 0.24166599E-09_JPRB, 0.23836505E-09_JPRB, 0.23493874E-09_JPRB, 0.23145096E-09_JPRB, 0.22796148E-09_JPRB, &
  & 0.22449761E-09_JPRB, 0.22106249E-09_JPRB, 0.21771410E-09_JPRB, 0.21449420E-09_JPRB, 0.21142320E-09_JPRB, 0.20852534E-09_JPRB, &
  & 0.20581206E-09_JPRB, 0.20323887E-09_JPRB, 0.20077640E-09_JPRB, 0.19842175E-09_JPRB, 0.19619437E-09_JPRB, 0.19413431E-09_JPRB, &
  & 0.19225969E-09_JPRB, 0.19050179E-09_JPRB, 0.18862158E-09_JPRB, 0.18541325E-09_JPRB /)

RGHG5(:,38, 9) = (/ &
  & 0.17030800E-09_JPRB, 0.17122388E-09_JPRB, 0.17171822E-09_JPRB, 0.17218690E-09_JPRB, 0.17278484E-09_JPRB, 0.17364067E-09_JPRB, &
  & 0.17490884E-09_JPRB, 0.17670698E-09_JPRB, 0.17907931E-09_JPRB, 0.18201426E-09_JPRB, 0.18546401E-09_JPRB, 0.18938828E-09_JPRB, &
  & 0.19374868E-09_JPRB, 0.19848453E-09_JPRB, 0.20349838E-09_JPRB, 0.20868364E-09_JPRB, 0.21396150E-09_JPRB, 0.21926021E-09_JPRB, &
  & 0.22450848E-09_JPRB, 0.22967528E-09_JPRB, 0.23461502E-09_JPRB, 0.23909583E-09_JPRB, 0.24292915E-09_JPRB, 0.24603689E-09_JPRB, &
  & 0.24844288E-09_JPRB, 0.25031588E-09_JPRB, 0.25182134E-09_JPRB, 0.25309593E-09_JPRB, 0.25422306E-09_JPRB, 0.25524563E-09_JPRB, &
  & 0.25616390E-09_JPRB, 0.25694696E-09_JPRB, 0.25756045E-09_JPRB, 0.25796409E-09_JPRB, 0.25813571E-09_JPRB, 0.25806721E-09_JPRB, &
  & 0.25774322E-09_JPRB, 0.25714969E-09_JPRB, 0.25626867E-09_JPRB, 0.25503546E-09_JPRB, 0.25337968E-09_JPRB, 0.25133962E-09_JPRB, &
  & 0.24891589E-09_JPRB, 0.24615820E-09_JPRB, 0.24314378E-09_JPRB, 0.23996233E-09_JPRB, 0.23666061E-09_JPRB, 0.23332414E-09_JPRB, &
  & 0.22997618E-09_JPRB, 0.22665071E-09_JPRB, 0.22340493E-09_JPRB, 0.22030133E-09_JPRB, 0.21737709E-09_JPRB, 0.21465564E-09_JPRB, &
  & 0.21212403E-09_JPRB, 0.20973166E-09_JPRB, 0.20743920E-09_JPRB, 0.20523096E-09_JPRB, 0.20312653E-09_JPRB, 0.20116343E-09_JPRB, &
  & 0.19936018E-09_JPRB, 0.19765935E-09_JPRB, 0.19581860E-09_JPRB, 0.19265388E-09_JPRB /)

RGHG5(:,39, 9) = (/ &
  & 0.17807486E-09_JPRB, 0.17923826E-09_JPRB, 0.17986355E-09_JPRB, 0.18047117E-09_JPRB, 0.18120069E-09_JPRB, 0.18218907E-09_JPRB, &
  & 0.18354679E-09_JPRB, 0.18534478E-09_JPRB, 0.18761637E-09_JPRB, 0.19034033E-09_JPRB, 0.19348306E-09_JPRB, 0.19701620E-09_JPRB, &
  & 0.20091870E-09_JPRB, 0.20515306E-09_JPRB, 0.20966162E-09_JPRB, 0.21436325E-09_JPRB, 0.21919200E-09_JPRB, 0.22412473E-09_JPRB, &
  & 0.22910328E-09_JPRB, 0.23404997E-09_JPRB, 0.23876751E-09_JPRB, 0.24302821E-09_JPRB, 0.24658020E-09_JPRB, 0.24935060E-09_JPRB, &
  & 0.25144517E-09_JPRB, 0.25303065E-09_JPRB, 0.25428620E-09_JPRB, 0.25533339E-09_JPRB, 0.25624591E-09_JPRB, 0.25705865E-09_JPRB, &
  & 0.25777591E-09_JPRB, 0.25837640E-09_JPRB, 0.25883531E-09_JPRB, 0.25912625E-09_JPRB, 0.25923888E-09_JPRB, 0.25917185E-09_JPRB, &
  & 0.25892066E-09_JPRB, 0.25847630E-09_JPRB, 0.25782695E-09_JPRB, 0.25691199E-09_JPRB, 0.25566199E-09_JPRB, 0.25408206E-09_JPRB, &
  & 0.25211663E-09_JPRB, 0.24978494E-09_JPRB, 0.24714714E-09_JPRB, 0.24425270E-09_JPRB, 0.24118357E-09_JPRB, 0.23802146E-09_JPRB, &
  & 0.23480515E-09_JPRB, 0.23159066E-09_JPRB, 0.22845786E-09_JPRB, 0.22548437E-09_JPRB, 0.22272703E-09_JPRB, 0.22020377E-09_JPRB, &
  & 0.21787799E-09_JPRB, 0.21569511E-09_JPRB, 0.21359632E-09_JPRB, 0.21156556E-09_JPRB, 0.20961002E-09_JPRB, 0.20777245E-09_JPRB, &
  & 0.20606732E-09_JPRB, 0.20444066E-09_JPRB, 0.20265194E-09_JPRB, 0.19957334E-09_JPRB /)

RGHG5(:,40, 9) = (/ &
  & 0.18536972E-09_JPRB, 0.18668567E-09_JPRB, 0.18744721E-09_JPRB, 0.18816795E-09_JPRB, 0.18904403E-09_JPRB, 0.19016025E-09_JPRB, &
  & 0.19158204E-09_JPRB, 0.19336441E-09_JPRB, 0.19549547E-09_JPRB, 0.19797596E-09_JPRB, 0.20079127E-09_JPRB, 0.20391726E-09_JPRB, &
  & 0.20735565E-09_JPRB, 0.21109048E-09_JPRB, 0.21508985E-09_JPRB, 0.21930896E-09_JPRB, 0.22370633E-09_JPRB, 0.22824186E-09_JPRB, &
  & 0.23289393E-09_JPRB, 0.23753080E-09_JPRB, 0.24197960E-09_JPRB, 0.24590460E-09_JPRB, 0.24910868E-09_JPRB, 0.25155408E-09_JPRB, &
  & 0.25336028E-09_JPRB, 0.25471750E-09_JPRB, 0.25578395E-09_JPRB, 0.25666952E-09_JPRB, 0.25743557E-09_JPRB, 0.25811500E-09_JPRB, &
  & 0.25870889E-09_JPRB, 0.25920230E-09_JPRB, 0.25957292E-09_JPRB, 0.25980085E-09_JPRB, 0.25988045E-09_JPRB, 0.25981595E-09_JPRB, &
  & 0.25960850E-09_JPRB, 0.25925609E-09_JPRB, 0.25875632E-09_JPRB, 0.25805930E-09_JPRB, 0.25711744E-09_JPRB, 0.25591762E-09_JPRB, &
  & 0.25438870E-09_JPRB, 0.25252517E-09_JPRB, 0.25032607E-09_JPRB, 0.24779423E-09_JPRB, 0.24501895E-09_JPRB, 0.24207072E-09_JPRB, &
  & 0.23900415E-09_JPRB, 0.23592409E-09_JPRB, 0.23291788E-09_JPRB, 0.23009075E-09_JPRB, 0.22751792E-09_JPRB, 0.22520127E-09_JPRB, &
  & 0.22309790E-09_JPRB, 0.22113242E-09_JPRB, 0.21924906E-09_JPRB, 0.21740802E-09_JPRB, 0.21562656E-09_JPRB, 0.21393431E-09_JPRB, &
  & 0.21235133E-09_JPRB, 0.21081667E-09_JPRB, 0.20912301E-09_JPRB, 0.20615044E-09_JPRB /)

RGHG5(:,41, 9) = (/ &
  & 0.19224365E-09_JPRB, 0.19369149E-09_JPRB, 0.19451633E-09_JPRB, 0.19537172E-09_JPRB, 0.19636662E-09_JPRB, 0.19759916E-09_JPRB, &
  & 0.19908955E-09_JPRB, 0.20080983E-09_JPRB, 0.20278737E-09_JPRB, 0.20501427E-09_JPRB, 0.20748847E-09_JPRB, 0.21021425E-09_JPRB, &
  & 0.21319832E-09_JPRB, 0.21644657E-09_JPRB, 0.21994837E-09_JPRB, 0.22368177E-09_JPRB, 0.22762628E-09_JPRB, 0.23176977E-09_JPRB, &
  & 0.23605037E-09_JPRB, 0.24038072E-09_JPRB, 0.24447128E-09_JPRB, 0.24806493E-09_JPRB, 0.25092856E-09_JPRB, 0.25307820E-09_JPRB, &
  & 0.25465596E-09_JPRB, 0.25583538E-09_JPRB, 0.25676283E-09_JPRB, 0.25753108E-09_JPRB, 0.25819710E-09_JPRB, 0.25878513E-09_JPRB, &
  & 0.25930119E-09_JPRB, 0.25972757E-09_JPRB, 0.26004551E-09_JPRB, 0.26023536E-09_JPRB, 0.26029576E-09_JPRB, 0.26023281E-09_JPRB, &
  & 0.26005215E-09_JPRB, 0.25975716E-09_JPRB, 0.25934996E-09_JPRB, 0.25879948E-09_JPRB, 0.25806424E-09_JPRB, 0.25714370E-09_JPRB, &
  & 0.25596766E-09_JPRB, 0.25452060E-09_JPRB, 0.25275532E-09_JPRB, 0.25064673E-09_JPRB, 0.24820776E-09_JPRB, 0.24551405E-09_JPRB, &
  & 0.24264168E-09_JPRB, 0.23971009E-09_JPRB, 0.23684316E-09_JPRB, 0.23417790E-09_JPRB, 0.23179275E-09_JPRB, 0.22969139E-09_JPRB, &
  & 0.22780902E-09_JPRB, 0.22607090E-09_JPRB, 0.22440005E-09_JPRB, 0.22276445E-09_JPRB, 0.22116456E-09_JPRB, 0.21963800E-09_JPRB, &
  & 0.21819349E-09_JPRB, 0.21678276E-09_JPRB, 0.21519043E-09_JPRB, 0.21239596E-09_JPRB /)

RGHG5(:,42, 9) = (/ &
  & 0.19883094E-09_JPRB, 0.20031260E-09_JPRB, 0.20123171E-09_JPRB, 0.20213763E-09_JPRB, 0.20325926E-09_JPRB, 0.20460011E-09_JPRB, &
  & 0.20610086E-09_JPRB, 0.20776876E-09_JPRB, 0.20957090E-09_JPRB, 0.21154235E-09_JPRB, 0.21369120E-09_JPRB, 0.21603158E-09_JPRB, &
  & 0.21858811E-09_JPRB, 0.22137613E-09_JPRB, 0.22440277E-09_JPRB, 0.22766228E-09_JPRB, 0.23115698E-09_JPRB, 0.23487648E-09_JPRB, &
  & 0.23879920E-09_JPRB, 0.24275806E-09_JPRB, 0.24653221E-09_JPRB, 0.24976729E-09_JPRB, 0.25231953E-09_JPRB, 0.25421501E-09_JPRB, &
  & 0.25560135E-09_JPRB, 0.25664154E-09_JPRB, 0.25746041E-09_JPRB, 0.25814156E-09_JPRB, 0.25873156E-09_JPRB, 0.25925667E-09_JPRB, &
  & 0.25971714E-09_JPRB, 0.26010008E-09_JPRB, 0.26038285E-09_JPRB, 0.26054886E-09_JPRB, 0.26059682E-09_JPRB, 0.26053534E-09_JPRB, &
  & 0.26037314E-09_JPRB, 0.26011532E-09_JPRB, 0.25977109E-09_JPRB, 0.25931646E-09_JPRB, 0.25872532E-09_JPRB, 0.25799987E-09_JPRB, &
  & 0.25708857E-09_JPRB, 0.25597083E-09_JPRB, 0.25460042E-09_JPRB, 0.25288491E-09_JPRB, 0.25082120E-09_JPRB, 0.24841704E-09_JPRB, &
  & 0.24576241E-09_JPRB, 0.24300867E-09_JPRB, 0.24030461E-09_JPRB, 0.23780827E-09_JPRB, 0.23562197E-09_JPRB, 0.23372901E-09_JPRB, &
  & 0.23206803E-09_JPRB, 0.23054757E-09_JPRB, 0.22909430E-09_JPRB, 0.22765984E-09_JPRB, 0.22625196E-09_JPRB, 0.22489575E-09_JPRB, &
  & 0.22360806E-09_JPRB, 0.22233190E-09_JPRB, 0.22088789E-09_JPRB, 0.21830940E-09_JPRB /)

RGHG5(:,43, 9) = (/ &
  & 0.20530279E-09_JPRB, 0.20680330E-09_JPRB, 0.20768604E-09_JPRB, 0.20864703E-09_JPRB, 0.20982592E-09_JPRB, 0.21121727E-09_JPRB, &
  & 0.21274021E-09_JPRB, 0.21430567E-09_JPRB, 0.21594308E-09_JPRB, 0.21766886E-09_JPRB, 0.21951066E-09_JPRB, 0.22149760E-09_JPRB, &
  & 0.22365820E-09_JPRB, 0.22602382E-09_JPRB, 0.22860272E-09_JPRB, 0.23140946E-09_JPRB, 0.23445201E-09_JPRB, 0.23775876E-09_JPRB, &
  & 0.24127647E-09_JPRB, 0.24489824E-09_JPRB, 0.24829225E-09_JPRB, 0.25119298E-09_JPRB, 0.25344324E-09_JPRB, 0.25511232E-09_JPRB, &
  & 0.25633795E-09_JPRB, 0.25726210E-09_JPRB, 0.25799451E-09_JPRB, 0.25860525E-09_JPRB, 0.25913832E-09_JPRB, 0.25961397E-09_JPRB, &
  & 0.26003569E-09_JPRB, 0.26038677E-09_JPRB, 0.26064600E-09_JPRB, 0.26079530E-09_JPRB, 0.26083527E-09_JPRB, 0.26077576E-09_JPRB, &
  & 0.26062683E-09_JPRB, 0.26039643E-09_JPRB, 0.26009475E-09_JPRB, 0.25970950E-09_JPRB, 0.25921773E-09_JPRB, 0.25863353E-09_JPRB, &
  & 0.25791710E-09_JPRB, 0.25705754E-09_JPRB, 0.25600119E-09_JPRB, 0.25465782E-09_JPRB, 0.25295577E-09_JPRB, 0.25086527E-09_JPRB, &
  & 0.24846311E-09_JPRB, 0.24590491E-09_JPRB, 0.24337710E-09_JPRB, 0.24106586E-09_JPRB, 0.23906901E-09_JPRB, 0.23738320E-09_JPRB, &
  & 0.23593327E-09_JPRB, 0.23462732E-09_JPRB, 0.23338137E-09_JPRB, 0.23214977E-09_JPRB, 0.23092872E-09_JPRB, 0.22974778E-09_JPRB, &
  & 0.22861860E-09_JPRB, 0.22749812E-09_JPRB, 0.22621546E-09_JPRB, 0.22392320E-09_JPRB /)

RGHG5(:,44, 9) = (/ &
  & 0.21162011E-09_JPRB, 0.21317972E-09_JPRB, 0.21406350E-09_JPRB, 0.21499233E-09_JPRB, 0.21617454E-09_JPRB, 0.21759786E-09_JPRB, &
  & 0.21906327E-09_JPRB, 0.22053598E-09_JPRB, 0.22199927E-09_JPRB, 0.22349429E-09_JPRB, 0.22505495E-09_JPRB, 0.22671577E-09_JPRB, &
  & 0.22852528E-09_JPRB, 0.23050106E-09_JPRB, 0.23267417E-09_JPRB, 0.23504781E-09_JPRB, 0.23766494E-09_JPRB, 0.24053132E-09_JPRB, &
  & 0.24366489E-09_JPRB, 0.24686361E-09_JPRB, 0.24988825E-09_JPRB, 0.25241900E-09_JPRB, 0.25438535E-09_JPRB, 0.25584859E-09_JPRB, &
  & 0.25693381E-09_JPRB, 0.25776073E-09_JPRB, 0.25842067E-09_JPRB, 0.25897512E-09_JPRB, 0.25946201E-09_JPRB, 0.25990071E-09_JPRB, &
  & 0.26029215E-09_JPRB, 0.26062066E-09_JPRB, 0.26086233E-09_JPRB, 0.26100036E-09_JPRB, 0.26103503E-09_JPRB, 0.26097793E-09_JPRB, &
  & 0.26084013E-09_JPRB, 0.26062968E-09_JPRB, 0.26036004E-09_JPRB, 0.26002392E-09_JPRB, 0.25960584E-09_JPRB, 0.25912533E-09_JPRB, &
  & 0.25855615E-09_JPRB, 0.25789235E-09_JPRB, 0.25709565E-09_JPRB, 0.25606614E-09_JPRB, 0.25471156E-09_JPRB, 0.25295366E-09_JPRB, &
  & 0.25081306E-09_JPRB, 0.24847235E-09_JPRB, 0.24613769E-09_JPRB, 0.24400926E-09_JPRB, 0.24221170E-09_JPRB, 0.24072544E-09_JPRB, &
  & 0.23948110E-09_JPRB, 0.23837862E-09_JPRB, 0.23733385E-09_JPRB, 0.23629401E-09_JPRB, 0.23525457E-09_JPRB, 0.23424040E-09_JPRB, &
  & 0.23327099E-09_JPRB, 0.23230620E-09_JPRB, 0.23120787E-09_JPRB, 0.22924311E-09_JPRB /)

RGHG5(:,45, 9) = (/ &
  & 0.21871679E-09_JPRB, 0.21977210E-09_JPRB, 0.22046617E-09_JPRB, 0.22128904E-09_JPRB, 0.22243471E-09_JPRB, 0.22379010E-09_JPRB, &
  & 0.22519706E-09_JPRB, 0.22653973E-09_JPRB, 0.22782813E-09_JPRB, 0.22910170E-09_JPRB, 0.23039826E-09_JPRB, 0.23177214E-09_JPRB, &
  & 0.23325114E-09_JPRB, 0.23488822E-09_JPRB, 0.23668140E-09_JPRB, 0.23867036E-09_JPRB, 0.24086386E-09_JPRB, 0.24333163E-09_JPRB, &
  & 0.24599595E-09_JPRB, 0.24877828E-09_JPRB, 0.25133495E-09_JPRB, 0.25349900E-09_JPRB, 0.25518423E-09_JPRB, 0.25646096E-09_JPRB, &
  & 0.25742425E-09_JPRB, 0.25816788E-09_JPRB, 0.25876778E-09_JPRB, 0.25927624E-09_JPRB, 0.25972660E-09_JPRB, 0.26013630E-09_JPRB, &
  & 0.26050517E-09_JPRB, 0.26081670E-09_JPRB, 0.26104580E-09_JPRB, 0.26117566E-09_JPRB, 0.26120731E-09_JPRB, 0.26115338E-09_JPRB, &
  & 0.26102465E-09_JPRB, 0.26083030E-09_JPRB, 0.26058355E-09_JPRB, 0.26028429E-09_JPRB, 0.25992161E-09_JPRB, 0.25951866E-09_JPRB, &
  & 0.25906163E-09_JPRB, 0.25854885E-09_JPRB, 0.25795191E-09_JPRB, 0.25718550E-09_JPRB, 0.25615227E-09_JPRB, 0.25472119E-09_JPRB, &
  & 0.25288105E-09_JPRB, 0.25078026E-09_JPRB, 0.24864805E-09_JPRB, 0.24672431E-09_JPRB, 0.24511748E-09_JPRB, 0.24383132E-09_JPRB, &
  & 0.24278524E-09_JPRB, 0.24187330E-09_JPRB, 0.24101562E-09_JPRB, 0.24015537E-09_JPRB, 0.23928187E-09_JPRB, 0.23842350E-09_JPRB, &
  & 0.23760005E-09_JPRB, 0.23679000E-09_JPRB, 0.23587332E-09_JPRB, 0.23425228E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART17',1,ZHOOK_HANDLE)
END SUBROUTINE PART17




SUBROUTINE PART18
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART18',0,ZHOOK_HANDLE)



RGHG5(:,46, 9) = (/ &
  & 0.22419760E-09_JPRB, 0.22570405E-09_JPRB, 0.22656728E-09_JPRB, 0.22747278E-09_JPRB, 0.22859488E-09_JPRB, 0.22992321E-09_JPRB, &
  & 0.23121868E-09_JPRB, 0.23241230E-09_JPRB, 0.23351379E-09_JPRB, 0.23456176E-09_JPRB, 0.23561164E-09_JPRB, 0.23670294E-09_JPRB, &
  & 0.23789973E-09_JPRB, 0.23920763E-09_JPRB, 0.24067506E-09_JPRB, 0.24229435E-09_JPRB, 0.24412469E-09_JPRB, 0.24614005E-09_JPRB, &
  & 0.24836924E-09_JPRB, 0.25058891E-09_JPRB, 0.25268104E-09_JPRB, 0.25444313E-09_JPRB, 0.25586580E-09_JPRB, 0.25697316E-09_JPRB, &
  & 0.25782926E-09_JPRB, 0.25850241E-09_JPRB, 0.25905272E-09_JPRB, 0.25952374E-09_JPRB, 0.25994568E-09_JPRB, 0.26033292E-09_JPRB, &
  & 0.26068495E-09_JPRB, 0.26098362E-09_JPRB, 0.26120361E-09_JPRB, 0.26132788E-09_JPRB, 0.26135832E-09_JPRB, 0.26130775E-09_JPRB, &
  & 0.26118718E-09_JPRB, 0.26100486E-09_JPRB, 0.26077576E-09_JPRB, 0.26050406E-09_JPRB, 0.26018321E-09_JPRB, 0.25984004E-09_JPRB, &
  & 0.25946756E-09_JPRB, 0.25906724E-09_JPRB, 0.25862237E-09_JPRB, 0.25806343E-09_JPRB, 0.25729838E-09_JPRB, 0.25619906E-09_JPRB, &
  & 0.25468810E-09_JPRB, 0.25286512E-09_JPRB, 0.25097746E-09_JPRB, 0.24924968E-09_JPRB, 0.24784991E-09_JPRB, 0.24675986E-09_JPRB, &
  & 0.24589383E-09_JPRB, 0.24515939E-09_JPRB, 0.24446600E-09_JPRB, 0.24376445E-09_JPRB, 0.24304084E-09_JPRB, 0.24231792E-09_JPRB, &
  & 0.24162794E-09_JPRB, 0.24095481E-09_JPRB, 0.24020735E-09_JPRB, 0.23890634E-09_JPRB /)

RGHG5(:,47, 9) = (/ &
  & 0.23044019E-09_JPRB, 0.23182771E-09_JPRB, 0.23270243E-09_JPRB, 0.23362848E-09_JPRB, 0.23478366E-09_JPRB, 0.23604435E-09_JPRB, &
  & 0.23721355E-09_JPRB, 0.23823341E-09_JPRB, 0.23911942E-09_JPRB, 0.23993474E-09_JPRB, 0.24072760E-09_JPRB, 0.24156238E-09_JPRB, &
  & 0.24246533E-09_JPRB, 0.24349289E-09_JPRB, 0.24463920E-09_JPRB, 0.24594415E-09_JPRB, 0.24737976E-09_JPRB, 0.24898383E-09_JPRB, &
  & 0.25063854E-09_JPRB, 0.25232302E-09_JPRB, 0.25387659E-09_JPRB, 0.25527144E-09_JPRB, 0.25644314E-09_JPRB, 0.25739991E-09_JPRB, &
  & 0.25816377E-09_JPRB, 0.25877767E-09_JPRB, 0.25928698E-09_JPRB, 0.25972877E-09_JPRB, 0.26012825E-09_JPRB, 0.26049887E-09_JPRB, &
  & 0.26083802E-09_JPRB, 0.26112740E-09_JPRB, 0.26134045E-09_JPRB, 0.26146096E-09_JPRB, 0.26149155E-09_JPRB, 0.26144464E-09_JPRB, &
  & 0.26133085E-09_JPRB, 0.26115862E-09_JPRB, 0.26094252E-09_JPRB, 0.26069097E-09_JPRB, 0.26040373E-09_JPRB, 0.26010435E-09_JPRB, &
  & 0.25979566E-09_JPRB, 0.25947819E-09_JPRB, 0.25914249E-09_JPRB, 0.25873559E-09_JPRB, 0.25818833E-09_JPRB, 0.25738225E-09_JPRB, &
  & 0.25622363E-09_JPRB, 0.25474919E-09_JPRB, 0.25313091E-09_JPRB, 0.25164915E-09_JPRB, 0.25044627E-09_JPRB, 0.24953545E-09_JPRB, &
  & 0.24883917E-09_JPRB, 0.24824925E-09_JPRB, 0.24769953E-09_JPRB, 0.24713182E-09_JPRB, 0.24653307E-09_JPRB, 0.24592833E-09_JPRB, &
  & 0.24534988E-09_JPRB, 0.24479407E-09_JPRB, 0.24418773E-09_JPRB, 0.24315083E-09_JPRB /)

RGHG5(:,48, 9) = (/ &
  & 0.23600730E-09_JPRB, 0.23758173E-09_JPRB, 0.23857766E-09_JPRB, 0.23961136E-09_JPRB, 0.24082017E-09_JPRB, 0.24206687E-09_JPRB, &
  & 0.24313682E-09_JPRB, 0.24397234E-09_JPRB, 0.24464397E-09_JPRB, 0.24521754E-09_JPRB, 0.24576435E-09_JPRB, 0.24632782E-09_JPRB, &
  & 0.24696697E-09_JPRB, 0.24770036E-09_JPRB, 0.24855709E-09_JPRB, 0.24950680E-09_JPRB, 0.25056185E-09_JPRB, 0.25163799E-09_JPRB, &
  & 0.25274893E-09_JPRB, 0.25383945E-09_JPRB, 0.25493291E-09_JPRB, 0.25597516E-09_JPRB, 0.25693067E-09_JPRB, 0.25775471E-09_JPRB, &
  & 0.25843994E-09_JPRB, 0.25900448E-09_JPRB, 0.25948138E-09_JPRB, 0.25989988E-09_JPRB, 0.26028268E-09_JPRB, 0.26064065E-09_JPRB, &
  & 0.26097044E-09_JPRB, 0.26125213E-09_JPRB, 0.26146021E-09_JPRB, 0.26157809E-09_JPRB, 0.26160987E-09_JPRB, 0.26156663E-09_JPRB, &
  & 0.26145902E-09_JPRB, 0.26129485E-09_JPRB, 0.26108851E-09_JPRB, 0.26085314E-09_JPRB, 0.26059049E-09_JPRB, 0.26032482E-09_JPRB, &
  & 0.26006236E-09_JPRB, 0.25980493E-09_JPRB, 0.25954519E-09_JPRB, 0.25924740E-09_JPRB, 0.25885699E-09_JPRB, 0.25829433E-09_JPRB, &
  & 0.25747093E-09_JPRB, 0.25638064E-09_JPRB, 0.25512931E-09_JPRB, 0.25391758E-09_JPRB, 0.25293156E-09_JPRB, 0.25219477E-09_JPRB, &
  & 0.25163382E-09_JPRB, 0.25116823E-09_JPRB, 0.25072852E-09_JPRB, 0.25026903E-09_JPRB, 0.24977151E-09_JPRB, 0.24925917E-09_JPRB, &
  & 0.24876937E-09_JPRB, 0.24830477E-09_JPRB, 0.24780547E-09_JPRB, 0.24696553E-09_JPRB /)

RGHG5(:,49, 9) = (/ &
  & 0.24097785E-09_JPRB, 0.24270658E-09_JPRB, 0.24380317E-09_JPRB, 0.24492058E-09_JPRB, 0.24621569E-09_JPRB, 0.24751279E-09_JPRB, &
  & 0.24852267E-09_JPRB, 0.24923680E-09_JPRB, 0.24973770E-09_JPRB, 0.25012203E-09_JPRB, 0.25045072E-09_JPRB, 0.25078881E-09_JPRB, &
  & 0.25117003E-09_JPRB, 0.25162655E-09_JPRB, 0.25215413E-09_JPRB, 0.25274019E-09_JPRB, 0.25332095E-09_JPRB, 0.25390914E-09_JPRB, &
  & 0.25448965E-09_JPRB, 0.25511401E-09_JPRB, 0.25580923E-09_JPRB, 0.25657021E-09_JPRB, 0.25733671E-09_JPRB, 0.25804930E-09_JPRB, &
  & 0.25866873E-09_JPRB, 0.25919381E-09_JPRB, 0.25964481E-09_JPRB, 0.26004576E-09_JPRB, 0.26041580E-09_JPRB, 0.26076430E-09_JPRB, &
  & 0.26108637E-09_JPRB, 0.26136227E-09_JPRB, 0.26156560E-09_JPRB, 0.26168220E-09_JPRB, 0.26171562E-09_JPRB, 0.26167604E-09_JPRB, &
  & 0.26157401E-09_JPRB, 0.26141686E-09_JPRB, 0.26121930E-09_JPRB, 0.26099525E-09_JPRB, 0.26075239E-09_JPRB, 0.26051050E-09_JPRB, &
  & 0.26028257E-09_JPRB, 0.26006625E-09_JPRB, 0.25986091E-09_JPRB, 0.25963545E-09_JPRB, 0.25935659E-09_JPRB, 0.25897007E-09_JPRB, &
  & 0.25842395E-09_JPRB, 0.25770169E-09_JPRB, 0.25685359E-09_JPRB, 0.25599511E-09_JPRB, 0.25526239E-09_JPRB, 0.25470084E-09_JPRB, &
  & 0.25426489E-09_JPRB, 0.25390284E-09_JPRB, 0.25355062E-09_JPRB, 0.25317504E-09_JPRB, 0.25275718E-09_JPRB, 0.25231570E-09_JPRB, &
  & 0.25189206E-09_JPRB, 0.25149438E-09_JPRB, 0.25106858E-09_JPRB, 0.25036670E-09_JPRB /)

RGHG5(:,50, 9) = (/ &
  & 0.24577906E-09_JPRB, 0.24724614E-09_JPRB, 0.24818045E-09_JPRB, 0.24921057E-09_JPRB, 0.25044097E-09_JPRB, 0.25168112E-09_JPRB, &
  & 0.25261443E-09_JPRB, 0.25321906E-09_JPRB, 0.25360442E-09_JPRB, 0.25386490E-09_JPRB, 0.25407354E-09_JPRB, 0.25425978E-09_JPRB, &
  & 0.25445887E-09_JPRB, 0.25468308E-09_JPRB, 0.25492430E-09_JPRB, 0.25515517E-09_JPRB, 0.25537789E-09_JPRB, 0.25558389E-09_JPRB, &
  & 0.25581373E-09_JPRB, 0.25611377E-09_JPRB, 0.25652619E-09_JPRB, 0.25706245E-09_JPRB, 0.25767630E-09_JPRB, 0.25829458E-09_JPRB, &
  & 0.25886046E-09_JPRB, 0.25935426E-09_JPRB, 0.25978544E-09_JPRB, 0.26017294E-09_JPRB, 0.26053326E-09_JPRB, 0.26087421E-09_JPRB, &
  & 0.26118993E-09_JPRB, 0.26146013E-09_JPRB, 0.26165953E-09_JPRB, 0.26177535E-09_JPRB, 0.26181063E-09_JPRB, 0.26177488E-09_JPRB, &
  & 0.26167826E-09_JPRB, 0.26152797E-09_JPRB, 0.26133770E-09_JPRB, 0.26112362E-09_JPRB, 0.26089472E-09_JPRB, 0.26067121E-09_JPRB, &
  & 0.26046496E-09_JPRB, 0.26028196E-09_JPRB, 0.26010991E-09_JPRB, 0.25993588E-09_JPRB, 0.25972977E-09_JPRB, 0.25946445E-09_JPRB, &
  & 0.25911298E-09_JPRB, 0.25867913E-09_JPRB, 0.25818053E-09_JPRB, 0.25767655E-09_JPRB, 0.25722641E-09_JPRB, 0.25686106E-09_JPRB, &
  & 0.25657224E-09_JPRB, 0.25630920E-09_JPRB, 0.25605418E-09_JPRB, 0.25576496E-09_JPRB, 0.25542579E-09_JPRB, 0.25505709E-09_JPRB, &
  & 0.25469521E-09_JPRB, 0.25434835E-09_JPRB, 0.25398378E-09_JPRB, 0.25336139E-09_JPRB /)

RGHG5(:,51, 9) = (/ &
  & 0.24938068E-09_JPRB, 0.25062660E-09_JPRB, 0.25144728E-09_JPRB, 0.25229027E-09_JPRB, 0.25336513E-09_JPRB, 0.25443309E-09_JPRB, &
  & 0.25520616E-09_JPRB, 0.25567076E-09_JPRB, 0.25595054E-09_JPRB, 0.25613850E-09_JPRB, 0.25627162E-09_JPRB, 0.25638616E-09_JPRB, &
  & 0.25648736E-09_JPRB, 0.25657648E-09_JPRB, 0.25664418E-09_JPRB, 0.25668798E-09_JPRB, 0.25670754E-09_JPRB, 0.25672631E-09_JPRB, &
  & 0.25676986E-09_JPRB, 0.25687977E-09_JPRB, 0.25710711E-09_JPRB, 0.25747462E-09_JPRB, 0.25796199E-09_JPRB, 0.25850228E-09_JPRB, &
  & 0.25902441E-09_JPRB, 0.25949337E-09_JPRB, 0.25990965E-09_JPRB, 0.26028654E-09_JPRB, 0.26063907E-09_JPRB, 0.26097355E-09_JPRB, &
  & 0.26128327E-09_JPRB, 0.26154809E-09_JPRB, 0.26174393E-09_JPRB, 0.26185948E-09_JPRB, 0.26189675E-09_JPRB, 0.26186506E-09_JPRB, &
  & 0.26177366E-09_JPRB, 0.26163019E-09_JPRB, 0.26144750E-09_JPRB, 0.26124150E-09_JPRB, 0.26102337E-09_JPRB, 0.26081148E-09_JPRB, &
  & 0.26062458E-09_JPRB, 0.26045846E-09_JPRB, 0.26031532E-09_JPRB, 0.26017227E-09_JPRB, 0.26001570E-09_JPRB, 0.25982913E-09_JPRB, &
  & 0.25960550E-09_JPRB, 0.25935282E-09_JPRB, 0.25909061E-09_JPRB, 0.25883273E-09_JPRB, 0.25861013E-09_JPRB, 0.25842684E-09_JPRB, &
  & 0.25826996E-09_JPRB, 0.25813163E-09_JPRB, 0.25797942E-09_JPRB, 0.25780103E-09_JPRB, 0.25757743E-09_JPRB, 0.25731089E-09_JPRB, &
  & 0.25703345E-09_JPRB, 0.25676242E-09_JPRB, 0.25644870E-09_JPRB, 0.25592684E-09_JPRB /)

RGHG5(:,52, 9) = (/ &
  & 0.25255067E-09_JPRB, 0.25330527E-09_JPRB, 0.25381797E-09_JPRB, 0.25448019E-09_JPRB, 0.25530569E-09_JPRB, 0.25617014E-09_JPRB, &
  & 0.25675326E-09_JPRB, 0.25709132E-09_JPRB, 0.25728919E-09_JPRB, 0.25741320E-09_JPRB, 0.25750685E-09_JPRB, 0.25757671E-09_JPRB, &
  & 0.25763033E-09_JPRB, 0.25765934E-09_JPRB, 0.25765531E-09_JPRB, 0.25761843E-09_JPRB, 0.25756203E-09_JPRB, 0.25750066E-09_JPRB, &
  & 0.25745994E-09_JPRB, 0.25747190E-09_JPRB, 0.25757960E-09_JPRB, 0.25782543E-09_JPRB, 0.25821106E-09_JPRB, 0.25868335E-09_JPRB, &
  & 0.25916860E-09_JPRB, 0.25961794E-09_JPRB, 0.26002139E-09_JPRB, 0.26038974E-09_JPRB, 0.26073552E-09_JPRB, 0.26106381E-09_JPRB, &
  & 0.26136798E-09_JPRB, 0.26162744E-09_JPRB, 0.26182057E-09_JPRB, 0.26193583E-09_JPRB, 0.26197533E-09_JPRB, 0.26194763E-09_JPRB, &
  & 0.26186173E-09_JPRB, 0.26172492E-09_JPRB, 0.26155020E-09_JPRB, 0.26135166E-09_JPRB, 0.26114186E-09_JPRB, 0.26094094E-09_JPRB, &
  & 0.26076125E-09_JPRB, 0.26061539E-09_JPRB, 0.26048502E-09_JPRB, 0.26036664E-09_JPRB, 0.26024230E-09_JPRB, 0.26010646E-09_JPRB, &
  & 0.25996075E-09_JPRB, 0.25981531E-09_JPRB, 0.25967747E-09_JPRB, 0.25955846E-09_JPRB, 0.25945801E-09_JPRB, 0.25938046E-09_JPRB, &
  & 0.25931643E-09_JPRB, 0.25925456E-09_JPRB, 0.25918859E-09_JPRB, 0.25910363E-09_JPRB, 0.25898686E-09_JPRB, 0.25883939E-09_JPRB, &
  & 0.25867314E-09_JPRB, 0.25849203E-09_JPRB, 0.25828431E-09_JPRB, 0.25786864E-09_JPRB /)

RGHG5(:,53, 9) = (/ &
  & 0.25440761E-09_JPRB, 0.25503685E-09_JPRB, 0.25549934E-09_JPRB, 0.25597044E-09_JPRB, 0.25664199E-09_JPRB, 0.25728514E-09_JPRB, &
  & 0.25772107E-09_JPRB, 0.25795630E-09_JPRB, 0.25809077E-09_JPRB, 0.25817914E-09_JPRB, 0.25823971E-09_JPRB, 0.25828700E-09_JPRB, &
  & 0.25831670E-09_JPRB, 0.25832070E-09_JPRB, 0.25828978E-09_JPRB, 0.25822697E-09_JPRB, 0.25814362E-09_JPRB, 0.25805452E-09_JPRB, &
  & 0.25797620E-09_JPRB, 0.25793695E-09_JPRB, 0.25797359E-09_JPRB, 0.25813143E-09_JPRB, 0.25843350E-09_JPRB, 0.25884980E-09_JPRB, &
  & 0.25930103E-09_JPRB, 0.25973143E-09_JPRB, 0.26012409E-09_JPRB, 0.26048416E-09_JPRB, 0.26082331E-09_JPRB, 0.26114633E-09_JPRB, &
  & 0.26144448E-09_JPRB, 0.26169961E-09_JPRB, 0.26189023E-09_JPRB, 0.26200547E-09_JPRB, 0.26204758E-09_JPRB, 0.26202410E-09_JPRB, &
  & 0.26194322E-09_JPRB, 0.26181349E-09_JPRB, 0.26164640E-09_JPRB, 0.26145569E-09_JPRB, 0.26125355E-09_JPRB, 0.26105793E-09_JPRB, &
  & 0.26089156E-09_JPRB, 0.26074945E-09_JPRB, 0.26063621E-09_JPRB, 0.26053076E-09_JPRB, 0.26042921E-09_JPRB, 0.26032676E-09_JPRB, &
  & 0.26022856E-09_JPRB, 0.26014041E-09_JPRB, 0.26006808E-09_JPRB, 0.26000938E-09_JPRB, 0.25996794E-09_JPRB, 0.25993596E-09_JPRB, &
  & 0.25991093E-09_JPRB, 0.25988733E-09_JPRB, 0.25985974E-09_JPRB, 0.25982275E-09_JPRB, 0.25976998E-09_JPRB, 0.25969718E-09_JPRB, &
  & 0.25961158E-09_JPRB, 0.25952038E-09_JPRB, 0.25940161E-09_JPRB, 0.25916119E-09_JPRB /)

RGHG5(:,54, 9) = (/ &
  & 0.25600169E-09_JPRB, 0.25643951E-09_JPRB, 0.25671867E-09_JPRB, 0.25710356E-09_JPRB, 0.25756630E-09_JPRB, 0.25806401E-09_JPRB, &
  & 0.25836702E-09_JPRB, 0.25853394E-09_JPRB, 0.25862693E-09_JPRB, 0.25868568E-09_JPRB, 0.25872909E-09_JPRB, 0.25875979E-09_JPRB, &
  & 0.25877750E-09_JPRB, 0.25877195E-09_JPRB, 0.25873403E-09_JPRB, 0.25866559E-09_JPRB, 0.25857594E-09_JPRB, 0.25847702E-09_JPRB, &
  & 0.25838387E-09_JPRB, 0.25831509E-09_JPRB, 0.25830643E-09_JPRB, 0.25840324E-09_JPRB, 0.25864377E-09_JPRB, 0.25900648E-09_JPRB, &
  & 0.25942748E-09_JPRB, 0.25983848E-09_JPRB, 0.26021885E-09_JPRB, 0.26057120E-09_JPRB, 0.26090391E-09_JPRB, 0.26122163E-09_JPRB, &
  & 0.26151434E-09_JPRB, 0.26176564E-09_JPRB, 0.26195393E-09_JPRB, 0.26206942E-09_JPRB, 0.26211427E-09_JPRB, 0.26209507E-09_JPRB, &
  & 0.26201966E-09_JPRB, 0.26189639E-09_JPRB, 0.26173666E-09_JPRB, 0.26155358E-09_JPRB, 0.26135863E-09_JPRB, 0.26117200E-09_JPRB, &
  & 0.26100755E-09_JPRB, 0.26087871E-09_JPRB, 0.26076932E-09_JPRB, 0.26067698E-09_JPRB, 0.26059011E-09_JPRB, 0.26050984E-09_JPRB, &
  & 0.26043934E-09_JPRB, 0.26038338E-09_JPRB, 0.26034080E-09_JPRB, 0.26031227E-09_JPRB, 0.26029212E-09_JPRB, 0.26027966E-09_JPRB, &
  & 0.26026942E-09_JPRB, 0.26025965E-09_JPRB, 0.26024777E-09_JPRB, 0.26023078E-09_JPRB, 0.26020533E-09_JPRB, 0.26017044E-09_JPRB, &
  & 0.26013081E-09_JPRB, 0.26009078E-09_JPRB, 0.26005414E-09_JPRB, 0.26000987E-09_JPRB /)

RGHG5(:,55, 9) = (/ &
  & 0.25706851E-09_JPRB, 0.25739963E-09_JPRB, 0.25765703E-09_JPRB, 0.25791075E-09_JPRB, 0.25827782E-09_JPRB, 0.25861285E-09_JPRB, &
  & 0.25883840E-09_JPRB, 0.25895197E-09_JPRB, 0.25901731E-09_JPRB, 0.25905925E-09_JPRB, 0.25908878E-09_JPRB, 0.25911079E-09_JPRB, &
  & 0.25912189E-09_JPRB, 0.25911392E-09_JPRB, 0.25907751E-09_JPRB, 0.25901145E-09_JPRB, 0.25892377E-09_JPRB, 0.25882294E-09_JPRB, &
  & 0.25871946E-09_JPRB, 0.25863447E-09_JPRB, 0.25859534E-09_JPRB, 0.25865032E-09_JPRB, 0.25884014E-09_JPRB, 0.25916436E-09_JPRB, &
  & 0.25955052E-09_JPRB, 0.25994151E-09_JPRB, 0.26030858E-09_JPRB, 0.26065228E-09_JPRB, 0.26097893E-09_JPRB, 0.26129118E-09_JPRB, &
  & 0.26157909E-09_JPRB, 0.26182692E-09_JPRB, 0.26201274E-09_JPRB, 0.26212882E-09_JPRB, 0.26217659E-09_JPRB, 0.26216171E-09_JPRB, &
  & 0.26209143E-09_JPRB, 0.26197464E-09_JPRB, 0.26182226E-09_JPRB, 0.26164571E-09_JPRB, 0.26145891E-09_JPRB, 0.26127794E-09_JPRB, &
  & 0.26112365E-09_JPRB, 0.26099617E-09_JPRB, 0.26089664E-09_JPRB, 0.26081043E-09_JPRB, 0.26073491E-09_JPRB, 0.26066838E-09_JPRB, &
  & 0.26061506E-09_JPRB, 0.26057514E-09_JPRB, 0.26054853E-09_JPRB, 0.26053087E-09_JPRB, 0.26052122E-09_JPRB, 0.26051450E-09_JPRB, &
  & 0.26050978E-09_JPRB, 0.26050476E-09_JPRB, 0.26049823E-09_JPRB, 0.26048863E-09_JPRB, 0.26047370E-09_JPRB, 0.26045305E-09_JPRB, &
  & 0.26042865E-09_JPRB, 0.26040359E-09_JPRB, 0.26037467E-09_JPRB, 0.26032806E-09_JPRB /)

RGHG5(:,56, 9) = (/ &
  & 0.25795505E-09_JPRB, 0.25819774E-09_JPRB, 0.25835489E-09_JPRB, 0.25856126E-09_JPRB, 0.25879862E-09_JPRB, 0.25904665E-09_JPRB, &
  & 0.25919639E-09_JPRB, 0.25928004E-09_JPRB, 0.25932573E-09_JPRB, 0.25935576E-09_JPRB, 0.25937782E-09_JPRB, 0.25939376E-09_JPRB, &
  & 0.25940208E-09_JPRB, 0.25939531E-09_JPRB, 0.25936381E-09_JPRB, 0.25930488E-09_JPRB, 0.25922109E-09_JPRB, 0.25912034E-09_JPRB, &
  & 0.25901212E-09_JPRB, 0.25891164E-09_JPRB, 0.25885158E-09_JPRB, 0.25887631E-09_JPRB, 0.25903368E-09_JPRB, 0.25931743E-09_JPRB, &
  & 0.25967581E-09_JPRB, 0.26004285E-09_JPRB, 0.26039582E-09_JPRB, 0.26073041E-09_JPRB, 0.26105038E-09_JPRB, 0.26135744E-09_JPRB, &
  & 0.26164063E-09_JPRB, 0.26188440E-09_JPRB, 0.26206792E-09_JPRB, 0.26218466E-09_JPRB, 0.26223534E-09_JPRB, 0.26222469E-09_JPRB, &
  & 0.26215985E-09_JPRB, 0.26204930E-09_JPRB, 0.26190297E-09_JPRB, 0.26173405E-09_JPRB, 0.26155392E-09_JPRB, 0.26138175E-09_JPRB, &
  & 0.26123192E-09_JPRB, 0.26111280E-09_JPRB, 0.26101640E-09_JPRB, 0.26093749E-09_JPRB, 0.26086905E-09_JPRB, 0.26081221E-09_JPRB, &
  & 0.26076785E-09_JPRB, 0.26073693E-09_JPRB, 0.26071650E-09_JPRB, 0.26070485E-09_JPRB, 0.26069746E-09_JPRB, 0.26069336E-09_JPRB, &
  & 0.26068972E-09_JPRB, 0.26068597E-09_JPRB, 0.26068112E-09_JPRB, 0.26067376E-09_JPRB, 0.26066321E-09_JPRB, 0.26064861E-09_JPRB, &
  & 0.26063213E-09_JPRB, 0.26061486E-09_JPRB, 0.26059685E-09_JPRB, 0.26056685E-09_JPRB /)

RGHG5(:,57, 9) = (/ &
  & 0.25857691E-09_JPRB, 0.25876540E-09_JPRB, 0.25890556E-09_JPRB, 0.25904429E-09_JPRB, 0.25921978E-09_JPRB, 0.25938146E-09_JPRB, &
  & 0.25949259E-09_JPRB, 0.25955052E-09_JPRB, 0.25958488E-09_JPRB, 0.25960745E-09_JPRB, 0.25962424E-09_JPRB, 0.25963742E-09_JPRB, &
  & 0.25964478E-09_JPRB, 0.25964075E-09_JPRB, 0.25961616E-09_JPRB, 0.25956481E-09_JPRB, 0.25948743E-09_JPRB, 0.25938734E-09_JPRB, &
  & 0.25927246E-09_JPRB, 0.25916205E-09_JPRB, 0.25908459E-09_JPRB, 0.25908917E-09_JPRB, 0.25921798E-09_JPRB, 0.25947425E-09_JPRB, &
  & 0.25980043E-09_JPRB, 0.26014607E-09_JPRB, 0.26048344E-09_JPRB, 0.26080796E-09_JPRB, 0.26112143E-09_JPRB, 0.26142211E-09_JPRB, &
  & 0.26170061E-09_JPRB, 0.26193944E-09_JPRB, 0.26212069E-09_JPRB, 0.26223840E-09_JPRB, 0.26229174E-09_JPRB, 0.26228519E-09_JPRB, &
  & 0.26222555E-09_JPRB, 0.26212110E-09_JPRB, 0.26198177E-09_JPRB, 0.26181834E-09_JPRB, 0.26164632E-09_JPRB, 0.26148111E-09_JPRB, &
  & 0.26133909E-09_JPRB, 0.26122421E-09_JPRB, 0.26113373E-09_JPRB, 0.26105945E-09_JPRB, 0.26099720E-09_JPRB, 0.26094588E-09_JPRB, &
  & 0.26090707E-09_JPRB, 0.26087987E-09_JPRB, 0.26086247E-09_JPRB, 0.26085131E-09_JPRB, 0.26084510E-09_JPRB, 0.26084035E-09_JPRB, &
  & 0.26083663E-09_JPRB, 0.26083263E-09_JPRB, 0.26082753E-09_JPRB, 0.26082081E-09_JPRB, 0.26081096E-09_JPRB, 0.26079883E-09_JPRB, &
  & 0.26078514E-09_JPRB, 0.26077149E-09_JPRB, 0.26075567E-09_JPRB, 0.26072880E-09_JPRB /)

RGHG5(:,58, 9) = (/ &
  & 0.25908284E-09_JPRB, 0.25923369E-09_JPRB, 0.25932939E-09_JPRB, 0.25943475E-09_JPRB, 0.25955088E-09_JPRB, 0.25966534E-09_JPRB, &
  & 0.25974195E-09_JPRB, 0.25978641E-09_JPRB, 0.25981239E-09_JPRB, 0.25983038E-09_JPRB, 0.25984465E-09_JPRB, 0.25985616E-09_JPRB, &
  & 0.25986427E-09_JPRB, 0.25986380E-09_JPRB, 0.25984609E-09_JPRB, 0.25980337E-09_JPRB, 0.25973135E-09_JPRB, 0.25963243E-09_JPRB, &
  & 0.25951327E-09_JPRB, 0.25939148E-09_JPRB, 0.25930200E-09_JPRB, 0.25929145E-09_JPRB, 0.25940106E-09_JPRB, 0.25962815E-09_JPRB, &
  & 0.25992844E-09_JPRB, 0.26025188E-09_JPRB, 0.26057392E-09_JPRB, 0.26088798E-09_JPRB, 0.26119337E-09_JPRB, 0.26148789E-09_JPRB, &
  & 0.26176006E-09_JPRB, 0.26199359E-09_JPRB, 0.26217289E-09_JPRB, 0.26229077E-09_JPRB, 0.26234639E-09_JPRB, 0.26234365E-09_JPRB, &
  & 0.26228930E-09_JPRB, 0.26219113E-09_JPRB, 0.26205774E-09_JPRB, 0.26190189E-09_JPRB, 0.26173633E-09_JPRB, 0.26157901E-09_JPRB, &
  & 0.26144326E-09_JPRB, 0.26133407E-09_JPRB, 0.26124783E-09_JPRB, 0.26117833E-09_JPRB, 0.26112060E-09_JPRB, 0.26107361E-09_JPRB, &
  & 0.26103786E-09_JPRB, 0.26101202E-09_JPRB, 0.26099442E-09_JPRB, 0.26098307E-09_JPRB, 0.26097488E-09_JPRB, 0.26096930E-09_JPRB, &
  & 0.26096431E-09_JPRB, 0.26095912E-09_JPRB, 0.26095331E-09_JPRB, 0.26094543E-09_JPRB, 0.26093569E-09_JPRB, 0.26092364E-09_JPRB, &
  & 0.26091151E-09_JPRB, 0.26089947E-09_JPRB, 0.26088692E-09_JPRB, 0.26086538E-09_JPRB /)

RGHG5(:,59, 9) = (/ &
  & 0.25947178E-09_JPRB, 0.25959163E-09_JPRB, 0.25967006E-09_JPRB, 0.25974456E-09_JPRB, 0.25982677E-09_JPRB, 0.25990610E-09_JPRB, &
  & 0.25996350E-09_JPRB, 0.25999772E-09_JPRB, 0.26001915E-09_JPRB, 0.26003466E-09_JPRB, 0.26004743E-09_JPRB, 0.26005909E-09_JPRB, &
  & 0.26006841E-09_JPRB, 0.26007194E-09_JPRB, 0.26006119E-09_JPRB, 0.26002603E-09_JPRB, 0.25996022E-09_JPRB, 0.25986119E-09_JPRB, &
  & 0.25973729E-09_JPRB, 0.25960842E-09_JPRB, 0.25950994E-09_JPRB, 0.25948860E-09_JPRB, 0.25957983E-09_JPRB, 0.25978347E-09_JPRB, &
  & 0.26005853E-09_JPRB, 0.26036148E-09_JPRB, 0.26066893E-09_JPRB, 0.26097199E-09_JPRB, 0.26126867E-09_JPRB, 0.26155572E-09_JPRB, &
  & 0.26182073E-09_JPRB, 0.26204891E-09_JPRB, 0.26222513E-09_JPRB, 0.26234284E-09_JPRB, 0.26239991E-09_JPRB, 0.26240060E-09_JPRB, &
  & 0.26235139E-09_JPRB, 0.26225919E-09_JPRB, 0.26213295E-09_JPRB, 0.26198349E-09_JPRB, 0.26182584E-09_JPRB, 0.26167554E-09_JPRB, &
  & 0.26154615E-09_JPRB, 0.26144201E-09_JPRB, 0.26136007E-09_JPRB, 0.26129460E-09_JPRB, 0.26124083E-09_JPRB, 0.26119726E-09_JPRB, &
  & 0.26116298E-09_JPRB, 0.26113772E-09_JPRB, 0.26111890E-09_JPRB, 0.26110497E-09_JPRB, 0.26109512E-09_JPRB, 0.26108710E-09_JPRB, &
  & 0.26108021E-09_JPRB, 0.26107350E-09_JPRB, 0.26106559E-09_JPRB, 0.26105651E-09_JPRB, 0.26104491E-09_JPRB, 0.26103239E-09_JPRB, &
  & 0.26101993E-09_JPRB, 0.26100849E-09_JPRB, 0.26099586E-09_JPRB, 0.26097544E-09_JPRB /)

RGHG5(:,60, 9) = (/ &
  & 0.25979638E-09_JPRB, 0.25989128E-09_JPRB, 0.25994812E-09_JPRB, 0.26000305E-09_JPRB, 0.26006158E-09_JPRB, 0.26011909E-09_JPRB, &
  & 0.26016375E-09_JPRB, 0.26019217E-09_JPRB, 0.26021107E-09_JPRB, 0.26022540E-09_JPRB, 0.26023828E-09_JPRB, 0.26025057E-09_JPRB, &
  & 0.26026259E-09_JPRB, 0.26027036E-09_JPRB, 0.26026609E-09_JPRB, 0.26023816E-09_JPRB, 0.26017602E-09_JPRB, 0.26007829E-09_JPRB, &
  & 0.25995009E-09_JPRB, 0.25981670E-09_JPRB, 0.25971236E-09_JPRB, 0.25968236E-09_JPRB, 0.25975794E-09_JPRB, 0.25993910E-09_JPRB, &
  & 0.26019142E-09_JPRB, 0.26047595E-09_JPRB, 0.26076882E-09_JPRB, 0.26106076E-09_JPRB, 0.26134839E-09_JPRB, 0.26162686E-09_JPRB, &
  & 0.26188426E-09_JPRB, 0.26210600E-09_JPRB, 0.26227898E-09_JPRB, 0.26239469E-09_JPRB, 0.26245253E-09_JPRB, 0.26245603E-09_JPRB, &
  & 0.26241165E-09_JPRB, 0.26232572E-09_JPRB, 0.26220617E-09_JPRB, 0.26206462E-09_JPRB, 0.26191427E-09_JPRB, 0.26177144E-09_JPRB, &
  & 0.26164823E-09_JPRB, 0.26154884E-09_JPRB, 0.26147084E-09_JPRB, 0.26140895E-09_JPRB, 0.26135860E-09_JPRB, 0.26131733E-09_JPRB, &
  & 0.26128499E-09_JPRB, 0.26125924E-09_JPRB, 0.26123914E-09_JPRB, 0.26122293E-09_JPRB, 0.26120972E-09_JPRB, 0.26119903E-09_JPRB, &
  & 0.26118971E-09_JPRB, 0.26118019E-09_JPRB, 0.26117034E-09_JPRB, 0.26115812E-09_JPRB, 0.26114455E-09_JPRB, 0.26113006E-09_JPRB, &
  & 0.26111707E-09_JPRB, 0.26110514E-09_JPRB, 0.26109320E-09_JPRB, 0.26107308E-09_JPRB /)

RGHG5(:,61, 9) = (/ &
  & 0.26006081E-09_JPRB, 0.26013669E-09_JPRB, 0.26018224E-09_JPRB, 0.26022370E-09_JPRB, 0.26026731E-09_JPRB, 0.26031199E-09_JPRB, &
  & 0.26034855E-09_JPRB, 0.26037400E-09_JPRB, 0.26039201E-09_JPRB, 0.26040653E-09_JPRB, 0.26042027E-09_JPRB, 0.26043478E-09_JPRB, &
  & 0.26044983E-09_JPRB, 0.26046287E-09_JPRB, 0.26046479E-09_JPRB, 0.26044214E-09_JPRB, 0.26038388E-09_JPRB, 0.26028435E-09_JPRB, &
  & 0.26015601E-09_JPRB, 0.26001964E-09_JPRB, 0.25991242E-09_JPRB, 0.25987490E-09_JPRB, 0.25993568E-09_JPRB, 0.26009672E-09_JPRB, &
  & 0.26032829E-09_JPRB, 0.26059499E-09_JPRB, 0.26087421E-09_JPRB, 0.26115526E-09_JPRB, 0.26143337E-09_JPRB, 0.26170241E-09_JPRB, &
  & 0.26195168E-09_JPRB, 0.26216659E-09_JPRB, 0.26233410E-09_JPRB, 0.26244718E-09_JPRB, 0.26250424E-09_JPRB, 0.26250985E-09_JPRB, &
  & 0.26246999E-09_JPRB, 0.26239017E-09_JPRB, 0.26227806E-09_JPRB, 0.26214433E-09_JPRB, 0.26200220E-09_JPRB, 0.26186683E-09_JPRB, &
  & 0.26174973E-09_JPRB, 0.26165500E-09_JPRB, 0.26158067E-09_JPRB, 0.26152192E-09_JPRB, 0.26147423E-09_JPRB, 0.26143529E-09_JPRB, &
  & 0.26140376E-09_JPRB, 0.26137870E-09_JPRB, 0.26135744E-09_JPRB, 0.26133889E-09_JPRB, 0.26132274E-09_JPRB, 0.26130881E-09_JPRB, &
  & 0.26129571E-09_JPRB, 0.26128344E-09_JPRB, 0.26126934E-09_JPRB, 0.26125399E-09_JPRB, 0.26123648E-09_JPRB, 0.26121977E-09_JPRB, &
  & 0.26120500E-09_JPRB, 0.26119240E-09_JPRB, 0.26117902E-09_JPRB, 0.26115834E-09_JPRB /)

RGHG5(:,62, 9) = (/ &
  & 0.26028876E-09_JPRB, 0.26035046E-09_JPRB, 0.26038591E-09_JPRB, 0.26041852E-09_JPRB, 0.26045308E-09_JPRB, 0.26048910E-09_JPRB, &
  & 0.26052149E-09_JPRB, 0.26054597E-09_JPRB, 0.26056435E-09_JPRB, 0.26058045E-09_JPRB, 0.26059616E-09_JPRB, 0.26061378E-09_JPRB, &
  & 0.26063363E-09_JPRB, 0.26065214E-09_JPRB, 0.26065980E-09_JPRB, 0.26064134E-09_JPRB, 0.26058319E-09_JPRB, 0.26048558E-09_JPRB, &
  & 0.26035590E-09_JPRB, 0.26022057E-09_JPRB, 0.26011115E-09_JPRB, 0.26006730E-09_JPRB, 0.26011510E-09_JPRB, 0.26025745E-09_JPRB, &
  & 0.26046981E-09_JPRB, 0.26071995E-09_JPRB, 0.26098596E-09_JPRB, 0.26125582E-09_JPRB, 0.26152425E-09_JPRB, 0.26178362E-09_JPRB, &
  & 0.26202376E-09_JPRB, 0.26223049E-09_JPRB, 0.26239166E-09_JPRB, 0.26249988E-09_JPRB, 0.26255537E-09_JPRB, 0.26256231E-09_JPRB, &
  & 0.26252653E-09_JPRB, 0.26245275E-09_JPRB, 0.26234834E-09_JPRB, 0.26222288E-09_JPRB, 0.26208927E-09_JPRB, 0.26196162E-09_JPRB, &
  & 0.26185065E-09_JPRB, 0.26176061E-09_JPRB, 0.26168973E-09_JPRB, 0.26163374E-09_JPRB, 0.26158842E-09_JPRB, 0.26155109E-09_JPRB, &
  & 0.26152075E-09_JPRB, 0.26149574E-09_JPRB, 0.26147437E-09_JPRB, 0.26145464E-09_JPRB, 0.26143607E-09_JPRB, 0.26141839E-09_JPRB, &
  & 0.26140223E-09_JPRB, 0.26138477E-09_JPRB, 0.26136682E-09_JPRB, 0.26134575E-09_JPRB, 0.26132405E-09_JPRB, 0.26130365E-09_JPRB, &
  & 0.26128710E-09_JPRB, 0.26127234E-09_JPRB, 0.26125796E-09_JPRB, 0.26123384E-09_JPRB /)

RGHG5(:,63, 9) = (/ &
  & 0.26048302E-09_JPRB, 0.26053676E-09_JPRB, 0.26056754E-09_JPRB, 0.26059502E-09_JPRB, 0.26062386E-09_JPRB, 0.26065533E-09_JPRB, &
  & 0.26068531E-09_JPRB, 0.26070998E-09_JPRB, 0.26073038E-09_JPRB, 0.26074851E-09_JPRB, 0.26076802E-09_JPRB, 0.26078989E-09_JPRB, &
  & 0.26081570E-09_JPRB, 0.26084079E-09_JPRB, 0.26085262E-09_JPRB, 0.26083544E-09_JPRB, 0.26077859E-09_JPRB, 0.26068073E-09_JPRB, &
  & 0.26055405E-09_JPRB, 0.26041963E-09_JPRB, 0.26030994E-09_JPRB, 0.26026092E-09_JPRB, 0.26029734E-09_JPRB, 0.26042335E-09_JPRB, &
  & 0.26061747E-09_JPRB, 0.26085198E-09_JPRB, 0.26110461E-09_JPRB, 0.26136329E-09_JPRB, 0.26162159E-09_JPRB, 0.26187050E-09_JPRB, &
  & 0.26210070E-09_JPRB, 0.26229768E-09_JPRB, 0.26245053E-09_JPRB, 0.26255306E-09_JPRB, 0.26260569E-09_JPRB, 0.26261329E-09_JPRB, &
  & 0.26258107E-09_JPRB, 0.26251354E-09_JPRB, 0.26241670E-09_JPRB, 0.26230015E-09_JPRB, 0.26217536E-09_JPRB, 0.26205574E-09_JPRB, &
  & 0.26195099E-09_JPRB, 0.26186561E-09_JPRB, 0.26179803E-09_JPRB, 0.26174460E-09_JPRB, 0.26170127E-09_JPRB, 0.26166541E-09_JPRB, &
  & 0.26163580E-09_JPRB, 0.26161129E-09_JPRB, 0.26159000E-09_JPRB, 0.26156999E-09_JPRB, 0.26155023E-09_JPRB, 0.26153035E-09_JPRB, &
  & 0.26150931E-09_JPRB, 0.26148833E-09_JPRB, 0.26146368E-09_JPRB, 0.26143721E-09_JPRB, 0.26140920E-09_JPRB, 0.26138505E-09_JPRB, &
  & 0.26136471E-09_JPRB, 0.26134786E-09_JPRB, 0.26132968E-09_JPRB, 0.26130170E-09_JPRB /)

RGHG5(:,64, 9) = (/ &
  & 0.26065577E-09_JPRB, 0.26070557E-09_JPRB, 0.26073321E-09_JPRB, 0.26075775E-09_JPRB, 0.26078362E-09_JPRB, 0.26081190E-09_JPRB, &
  & 0.26084124E-09_JPRB, 0.26086719E-09_JPRB, 0.26088998E-09_JPRB, 0.26091224E-09_JPRB, 0.26093569E-09_JPRB, 0.26096422E-09_JPRB, &
  & 0.26099672E-09_JPRB, 0.26102687E-09_JPRB, 0.26104102E-09_JPRB, 0.26102420E-09_JPRB, 0.26096736E-09_JPRB, 0.26087235E-09_JPRB, &
  & 0.26074848E-09_JPRB, 0.26061686E-09_JPRB, 0.26050798E-09_JPRB, 0.26045560E-09_JPRB, 0.26048275E-09_JPRB, 0.26059394E-09_JPRB, &
  & 0.26077188E-09_JPRB, 0.26099073E-09_JPRB, 0.26123012E-09_JPRB, 0.26147703E-09_JPRB, 0.26172395E-09_JPRB, 0.26196190E-09_JPRB, &
  & 0.26218036E-09_JPRB, 0.26236635E-09_JPRB, 0.26250946E-09_JPRB, 0.26260483E-09_JPRB, 0.26265398E-09_JPRB, 0.26266175E-09_JPRB, &
  & 0.26263294E-09_JPRB, 0.26257141E-09_JPRB, 0.26248273E-09_JPRB, 0.26237512E-09_JPRB, 0.26225971E-09_JPRB, 0.26214811E-09_JPRB, &
  & 0.26204977E-09_JPRB, 0.26196906E-09_JPRB, 0.26190469E-09_JPRB, 0.26185357E-09_JPRB, 0.26181202E-09_JPRB, 0.26177752E-09_JPRB, &
  & 0.26174868E-09_JPRB, 0.26172467E-09_JPRB, 0.26170363E-09_JPRB, 0.26168398E-09_JPRB, 0.26166369E-09_JPRB, 0.26164204E-09_JPRB, &
  & 0.26161889E-09_JPRB, 0.26159225E-09_JPRB, 0.26156308E-09_JPRB, 0.26152946E-09_JPRB, 0.26149624E-09_JPRB, 0.26146629E-09_JPRB, &
  & 0.26144234E-09_JPRB, 0.26142041E-09_JPRB, 0.26139821E-09_JPRB, 0.26136035E-09_JPRB /)

RGHG5(:,65, 9) = (/ &
  & 0.26081204E-09_JPRB, 0.26086056E-09_JPRB, 0.26088751E-09_JPRB, 0.26091102E-09_JPRB, 0.26093533E-09_JPRB, 0.26096261E-09_JPRB, &
  & 0.26099106E-09_JPRB, 0.26101954E-09_JPRB, 0.26104541E-09_JPRB, 0.26107200E-09_JPRB, 0.26110178E-09_JPRB, 0.26113631E-09_JPRB, &
  & 0.26117528E-09_JPRB, 0.26120847E-09_JPRB, 0.26122246E-09_JPRB, 0.26120550E-09_JPRB, 0.26115077E-09_JPRB, 0.26105890E-09_JPRB, &
  & 0.26093927E-09_JPRB, 0.26081176E-09_JPRB, 0.26070521E-09_JPRB, 0.26065111E-09_JPRB, 0.26067096E-09_JPRB, 0.26076974E-09_JPRB, &
  & 0.26093208E-09_JPRB, 0.26113578E-09_JPRB, 0.26136121E-09_JPRB, 0.26159508E-09_JPRB, 0.26182956E-09_JPRB, 0.26205474E-09_JPRB, &
  & 0.26226016E-09_JPRB, 0.26243374E-09_JPRB, 0.26256589E-09_JPRB, 0.26265368E-09_JPRB, 0.26269886E-09_JPRB, 0.26270652E-09_JPRB, &
  & 0.26268085E-09_JPRB, 0.26262545E-09_JPRB, 0.26254490E-09_JPRB, 0.26244698E-09_JPRB, 0.26234093E-09_JPRB, 0.26223784E-09_JPRB, &
  & 0.26214611E-09_JPRB, 0.26207003E-09_JPRB, 0.26200886E-09_JPRB, 0.26196004E-09_JPRB, 0.26192021E-09_JPRB, 0.26188696E-09_JPRB, &
  & 0.26185901E-09_JPRB, 0.26183555E-09_JPRB, 0.26181504E-09_JPRB, 0.26179553E-09_JPRB, 0.26177549E-09_JPRB, 0.26175298E-09_JPRB, &
  & 0.26172739E-09_JPRB, 0.26169805E-09_JPRB, 0.26166355E-09_JPRB, 0.26162553E-09_JPRB, 0.26158617E-09_JPRB, 0.26155161E-09_JPRB, &
  & 0.26152111E-09_JPRB, 0.26149410E-09_JPRB, 0.26146313E-09_JPRB, 0.26141356E-09_JPRB /)

RGHG5(:,66, 9) = (/ &
  & 0.26095179E-09_JPRB, 0.26100466E-09_JPRB, 0.26103311E-09_JPRB, 0.26105751E-09_JPRB, 0.26108213E-09_JPRB, 0.26110891E-09_JPRB, &
  & 0.26113881E-09_JPRB, 0.26116798E-09_JPRB, 0.26119901E-09_JPRB, 0.26122982E-09_JPRB, 0.26126568E-09_JPRB, 0.26130662E-09_JPRB, &
  & 0.26134869E-09_JPRB, 0.26138208E-09_JPRB, 0.26139574E-09_JPRB, 0.26137970E-09_JPRB, 0.26132757E-09_JPRB, 0.26124009E-09_JPRB, &
  & 0.26112609E-09_JPRB, 0.26100391E-09_JPRB, 0.26090130E-09_JPRB, 0.26084740E-09_JPRB, 0.26086178E-09_JPRB, 0.26094943E-09_JPRB, &
  & 0.26109734E-09_JPRB, 0.26128560E-09_JPRB, 0.26149571E-09_JPRB, 0.26171534E-09_JPRB, 0.26193545E-09_JPRB, 0.26214639E-09_JPRB, &
  & 0.26233746E-09_JPRB, 0.26249741E-09_JPRB, 0.26261837E-09_JPRB, 0.26269814E-09_JPRB, 0.26273939E-09_JPRB, 0.26274671E-09_JPRB, &
  & 0.26272412E-09_JPRB, 0.26267472E-09_JPRB, 0.26260258E-09_JPRB, 0.26251420E-09_JPRB, 0.26241814E-09_JPRB, 0.26232380E-09_JPRB, &
  & 0.26223893E-09_JPRB, 0.26216773E-09_JPRB, 0.26210989E-09_JPRB, 0.26206334E-09_JPRB, 0.26202518E-09_JPRB, 0.26199326E-09_JPRB, &
  & 0.26196639E-09_JPRB, 0.26194374E-09_JPRB, 0.26192393E-09_JPRB, 0.26190497E-09_JPRB, 0.26188501E-09_JPRB, 0.26186223E-09_JPRB, &
  & 0.26183530E-09_JPRB, 0.26180330E-09_JPRB, 0.26176603E-09_JPRB, 0.26172425E-09_JPRB, 0.26168137E-09_JPRB, 0.26164088E-09_JPRB, &
  & 0.26160524E-09_JPRB, 0.26156985E-09_JPRB, 0.26152971E-09_JPRB, 0.26146060E-09_JPRB /)

RGHG5(:,67, 9) = (/ &
  & 0.26107988E-09_JPRB, 0.26114069E-09_JPRB, 0.26117322E-09_JPRB, 0.26119995E-09_JPRB, 0.26122626E-09_JPRB, 0.26125432E-09_JPRB, &
  & 0.26128430E-09_JPRB, 0.26131772E-09_JPRB, 0.26135008E-09_JPRB, 0.26138780E-09_JPRB, 0.26142769E-09_JPRB, 0.26147209E-09_JPRB, &
  & 0.26151495E-09_JPRB, 0.26154728E-09_JPRB, 0.26156088E-09_JPRB, 0.26154628E-09_JPRB, 0.26149757E-09_JPRB, 0.26141550E-09_JPRB, &
  & 0.26130817E-09_JPRB, 0.26119329E-09_JPRB, 0.26109606E-09_JPRB, 0.26104346E-09_JPRB, 0.26105387E-09_JPRB, 0.26113151E-09_JPRB, &
  & 0.26126523E-09_JPRB, 0.26143734E-09_JPRB, 0.26163163E-09_JPRB, 0.26183503E-09_JPRB, 0.26203939E-09_JPRB, 0.26223479E-09_JPRB, &
  & 0.26241037E-09_JPRB, 0.26255659E-09_JPRB, 0.26266606E-09_JPRB, 0.26273805E-09_JPRB, 0.26277533E-09_JPRB, 0.26278232E-09_JPRB, &
  & 0.26276259E-09_JPRB, 0.26271896E-09_JPRB, 0.26265498E-09_JPRB, 0.26257641E-09_JPRB, 0.26249025E-09_JPRB, 0.26240490E-09_JPRB, &
  & 0.26232741E-09_JPRB, 0.26226127E-09_JPRB, 0.26220703E-09_JPRB, 0.26216304E-09_JPRB, 0.26212668E-09_JPRB, 0.26209626E-09_JPRB, &
  & 0.26207056E-09_JPRB, 0.26204905E-09_JPRB, 0.26203015E-09_JPRB, 0.26201197E-09_JPRB, 0.26199246E-09_JPRB, 0.26196950E-09_JPRB, &
  & 0.26194186E-09_JPRB, 0.26190844E-09_JPRB, 0.26186925E-09_JPRB, 0.26182570E-09_JPRB, 0.26177974E-09_JPRB, 0.26173619E-09_JPRB, &
  & 0.26169414E-09_JPRB, 0.26165198E-09_JPRB, 0.26159871E-09_JPRB, 0.26150740E-09_JPRB /)

RGHG5(:,68, 9) = (/ &
  & 0.26119784E-09_JPRB, 0.26127189E-09_JPRB, 0.26131031E-09_JPRB, 0.26134112E-09_JPRB, 0.26137009E-09_JPRB, 0.26139976E-09_JPRB, &
  & 0.26143210E-09_JPRB, 0.26146571E-09_JPRB, 0.26150396E-09_JPRB, 0.26154279E-09_JPRB, 0.26158695E-09_JPRB, 0.26163174E-09_JPRB, &
  & 0.26167318E-09_JPRB, 0.26170435E-09_JPRB, 0.26171809E-09_JPRB, 0.26170527E-09_JPRB, 0.26166053E-09_JPRB, 0.26158456E-09_JPRB, &
  & 0.26148536E-09_JPRB, 0.26137875E-09_JPRB, 0.26128816E-09_JPRB, 0.26123831E-09_JPRB, 0.26124503E-09_JPRB, 0.26131333E-09_JPRB, &
  & 0.26143279E-09_JPRB, 0.26158897E-09_JPRB, 0.26176597E-09_JPRB, 0.26195268E-09_JPRB, 0.26214006E-09_JPRB, 0.26231883E-09_JPRB, &
  & 0.26247893E-09_JPRB, 0.26261091E-09_JPRB, 0.26270938E-09_JPRB, 0.26277369E-09_JPRB, 0.26280716E-09_JPRB, 0.26281377E-09_JPRB, &
  & 0.26279667E-09_JPRB, 0.26275848E-09_JPRB, 0.26270228E-09_JPRB, 0.26263294E-09_JPRB, 0.26255664E-09_JPRB, 0.26248043E-09_JPRB, &
  & 0.26241048E-09_JPRB, 0.26235009E-09_JPRB, 0.26229979E-09_JPRB, 0.26225849E-09_JPRB, 0.26222435E-09_JPRB, 0.26219554E-09_JPRB, &
  & 0.26217151E-09_JPRB, 0.26215127E-09_JPRB, 0.26213359E-09_JPRB, 0.26211644E-09_JPRB, 0.26209765E-09_JPRB, 0.26207508E-09_JPRB, &
  & 0.26204733E-09_JPRB, 0.26201341E-09_JPRB, 0.26197344E-09_JPRB, 0.26192878E-09_JPRB, 0.26188179E-09_JPRB, 0.26183544E-09_JPRB, &
  & 0.26178984E-09_JPRB, 0.26174118E-09_JPRB, 0.26167610E-09_JPRB, 0.26156199E-09_JPRB /)

RGHG5(:,69, 9) = (/ &
  & 0.26130678E-09_JPRB, 0.26140051E-09_JPRB, 0.26144709E-09_JPRB, 0.26148342E-09_JPRB, 0.26151564E-09_JPRB, 0.26154776E-09_JPRB, &
  & 0.26158090E-09_JPRB, 0.26161739E-09_JPRB, 0.26165575E-09_JPRB, 0.26169794E-09_JPRB, 0.26174155E-09_JPRB, 0.26178532E-09_JPRB, &
  & 0.26182465E-09_JPRB, 0.26185415E-09_JPRB, 0.26186786E-09_JPRB, 0.26185693E-09_JPRB, 0.26181657E-09_JPRB, 0.26174748E-09_JPRB, &
  & 0.26165706E-09_JPRB, 0.26155977E-09_JPRB, 0.26147684E-09_JPRB, 0.26142966E-09_JPRB, 0.26143351E-09_JPRB, 0.26149261E-09_JPRB, &
  & 0.26159849E-09_JPRB, 0.26173805E-09_JPRB, 0.26189809E-09_JPRB, 0.26206703E-09_JPRB, 0.26223704E-09_JPRB, 0.26239877E-09_JPRB, &
  & 0.26254288E-09_JPRB, 0.26266106E-09_JPRB, 0.26274866E-09_JPRB, 0.26280572E-09_JPRB, 0.26283553E-09_JPRB, 0.26284158E-09_JPRB, &
  & 0.26282690E-09_JPRB, 0.26279376E-09_JPRB, 0.26274477E-09_JPRB, 0.26268424E-09_JPRB, 0.26261723E-09_JPRB, 0.26255001E-09_JPRB, &
  & 0.26248789E-09_JPRB, 0.26243363E-09_JPRB, 0.26238775E-09_JPRB, 0.26234981E-09_JPRB, 0.26231803E-09_JPRB, 0.26229147E-09_JPRB, &
  & 0.26226923E-09_JPRB, 0.26225072E-09_JPRB, 0.26223451E-09_JPRB, 0.26221858E-09_JPRB, 0.26220093E-09_JPRB, 0.26217928E-09_JPRB, &
  & 0.26215199E-09_JPRB, 0.26211852E-09_JPRB, 0.26207878E-09_JPRB, 0.26203434E-09_JPRB, 0.26198696E-09_JPRB, 0.26193983E-09_JPRB, &
  & 0.26189156E-09_JPRB, 0.26183911E-09_JPRB, 0.26176414E-09_JPRB, 0.26162722E-09_JPRB /)

RGHG5(:,70, 9) = (/ &
  & 0.26141103E-09_JPRB, 0.26152847E-09_JPRB, 0.26158686E-09_JPRB, 0.26162864E-09_JPRB, 0.26166511E-09_JPRB, 0.26169866E-09_JPRB, &
  & 0.26173322E-09_JPRB, 0.26176997E-09_JPRB, 0.26180891E-09_JPRB, 0.26185026E-09_JPRB, 0.26189201E-09_JPRB, 0.26193325E-09_JPRB, &
  & 0.26196986E-09_JPRB, 0.26199737E-09_JPRB, 0.26201086E-09_JPRB, 0.26200150E-09_JPRB, 0.26196553E-09_JPRB, 0.26190380E-09_JPRB, &
  & 0.26182267E-09_JPRB, 0.26173541E-09_JPRB, 0.26166005E-09_JPRB, 0.26161642E-09_JPRB, 0.26161742E-09_JPRB, 0.26166797E-09_JPRB, &
  & 0.26176025E-09_JPRB, 0.26188388E-09_JPRB, 0.26202657E-09_JPRB, 0.26217789E-09_JPRB, 0.26233007E-09_JPRB, 0.26247457E-09_JPRB, &
  & 0.26260277E-09_JPRB, 0.26270736E-09_JPRB, 0.26278443E-09_JPRB, 0.26283450E-09_JPRB, 0.26286079E-09_JPRB, 0.26286626E-09_JPRB, &
  & 0.26285379E-09_JPRB, 0.26282523E-09_JPRB, 0.26278296E-09_JPRB, 0.26273053E-09_JPRB, 0.26267236E-09_JPRB, 0.26261374E-09_JPRB, &
  & 0.26255947E-09_JPRB, 0.26251151E-09_JPRB, 0.26247068E-09_JPRB, 0.26243646E-09_JPRB, 0.26240768E-09_JPRB, 0.26238364E-09_JPRB, &
  & 0.26236366E-09_JPRB, 0.26234714E-09_JPRB, 0.26233263E-09_JPRB, 0.26231822E-09_JPRB, 0.26230190E-09_JPRB, 0.26228175E-09_JPRB, &
  & 0.26225580E-09_JPRB, 0.26222402E-09_JPRB, 0.26218558E-09_JPRB, 0.26214264E-09_JPRB, 0.26209596E-09_JPRB, 0.26204922E-09_JPRB, &
  & 0.26200025E-09_JPRB, 0.26194671E-09_JPRB, 0.26186539E-09_JPRB, 0.26171307E-09_JPRB /)

RGHG5(:,71, 9) = (/ &
  & 0.26151689E-09_JPRB, 0.26166397E-09_JPRB, 0.26173122E-09_JPRB, 0.26177957E-09_JPRB, 0.26181812E-09_JPRB, 0.26185359E-09_JPRB, &
  & 0.26188818E-09_JPRB, 0.26192384E-09_JPRB, 0.26196248E-09_JPRB, 0.26199906E-09_JPRB, 0.26203928E-09_JPRB, 0.26207578E-09_JPRB, &
  & 0.26210858E-09_JPRB, 0.26213295E-09_JPRB, 0.26214611E-09_JPRB, 0.26213887E-09_JPRB, 0.26210747E-09_JPRB, 0.26205291E-09_JPRB, &
  & 0.26198149E-09_JPRB, 0.26190394E-09_JPRB, 0.26183697E-09_JPRB, 0.26179670E-09_JPRB, 0.26179567E-09_JPRB, 0.26183797E-09_JPRB, &
  & 0.26191746E-09_JPRB, 0.26202523E-09_JPRB, 0.26215100E-09_JPRB, 0.26228469E-09_JPRB, 0.26241925E-09_JPRB, 0.26254640E-09_JPRB, &
  & 0.26265898E-09_JPRB, 0.26275010E-09_JPRB, 0.26281716E-09_JPRB, 0.26286037E-09_JPRB, 0.26288330E-09_JPRB, 0.26288818E-09_JPRB, &
  & 0.26287766E-09_JPRB, 0.26285335E-09_JPRB, 0.26281724E-09_JPRB, 0.26277233E-09_JPRB, 0.26272232E-09_JPRB, 0.26267202E-09_JPRB, &
  & 0.26262512E-09_JPRB, 0.26258370E-09_JPRB, 0.26254815E-09_JPRB, 0.26251812E-09_JPRB, 0.26249281E-09_JPRB, 0.26247166E-09_JPRB, &
  & 0.26245428E-09_JPRB, 0.26243999E-09_JPRB, 0.26242736E-09_JPRB, 0.26241459E-09_JPRB, 0.26240007E-09_JPRB, 0.26238181E-09_JPRB, &
  & 0.26235819E-09_JPRB, 0.26232877E-09_JPRB, 0.26229313E-09_JPRB, 0.26225264E-09_JPRB, 0.26220828E-09_JPRB, 0.26216346E-09_JPRB, &
  & 0.26211577E-09_JPRB, 0.26206323E-09_JPRB, 0.26198108E-09_JPRB, 0.26181982E-09_JPRB /)

RGHG5(:,72, 9) = (/ &
  & 0.26163699E-09_JPRB, 0.26180713E-09_JPRB, 0.26188368E-09_JPRB, 0.26193464E-09_JPRB, 0.26197564E-09_JPRB, 0.26201061E-09_JPRB, &
  & 0.26204444E-09_JPRB, 0.26207958E-09_JPRB, 0.26211142E-09_JPRB, 0.26214869E-09_JPRB, 0.26218008E-09_JPRB, 0.26221483E-09_JPRB, &
  & 0.26224345E-09_JPRB, 0.26226488E-09_JPRB, 0.26227637E-09_JPRB, 0.26226959E-09_JPRB, 0.26224201E-09_JPRB, 0.26219471E-09_JPRB, &
  & 0.26213240E-09_JPRB, 0.26206523E-09_JPRB, 0.26200603E-09_JPRB, 0.26197011E-09_JPRB, 0.26196739E-09_JPRB, 0.26200225E-09_JPRB, &
  & 0.26206920E-09_JPRB, 0.26216160E-09_JPRB, 0.26227082E-09_JPRB, 0.26238714E-09_JPRB, 0.26250413E-09_JPRB, 0.26261418E-09_JPRB, &
  & 0.26271144E-09_JPRB, 0.26278968E-09_JPRB, 0.26284708E-09_JPRB, 0.26288371E-09_JPRB, 0.26290337E-09_JPRB, 0.26290772E-09_JPRB, &
  & 0.26289892E-09_JPRB, 0.26287847E-09_JPRB, 0.26284813E-09_JPRB, 0.26281002E-09_JPRB, 0.26276772E-09_JPRB, 0.26272506E-09_JPRB, &
  & 0.26268540E-09_JPRB, 0.26265012E-09_JPRB, 0.26261987E-09_JPRB, 0.26259428E-09_JPRB, 0.26257252E-09_JPRB, 0.26255464E-09_JPRB, &
  & 0.26254002E-09_JPRB, 0.26252814E-09_JPRB, 0.26251748E-09_JPRB, 0.26250654E-09_JPRB, 0.26249397E-09_JPRB, 0.26247812E-09_JPRB, &
  & 0.26245703E-09_JPRB, 0.26243174E-09_JPRB, 0.26239902E-09_JPRB, 0.26236302E-09_JPRB, 0.26232153E-09_JPRB, 0.26228070E-09_JPRB, &
  & 0.26223546E-09_JPRB, 0.26218674E-09_JPRB, 0.26210670E-09_JPRB, 0.26194508E-09_JPRB /)

RGHG5(:,73, 9) = (/ &
  & 0.26178773E-09_JPRB, 0.26196459E-09_JPRB, 0.26204178E-09_JPRB, 0.26209349E-09_JPRB, 0.26213309E-09_JPRB, 0.26216762E-09_JPRB, &
  & 0.26219962E-09_JPRB, 0.26222924E-09_JPRB, 0.26226207E-09_JPRB, 0.26228750E-09_JPRB, 0.26232083E-09_JPRB, 0.26234584E-09_JPRB, &
  & 0.26236963E-09_JPRB, 0.26238661E-09_JPRB, 0.26239833E-09_JPRB, 0.26239308E-09_JPRB, 0.26236921E-09_JPRB, 0.26232785E-09_JPRB, &
  & 0.26227523E-09_JPRB, 0.26221725E-09_JPRB, 0.26216684E-09_JPRB, 0.26213506E-09_JPRB, 0.26213140E-09_JPRB, 0.26215949E-09_JPRB, &
  & 0.26221481E-09_JPRB, 0.26229227E-09_JPRB, 0.26238522E-09_JPRB, 0.26248465E-09_JPRB, 0.26258418E-09_JPRB, 0.26267802E-09_JPRB, &
  & 0.26275998E-09_JPRB, 0.26282604E-09_JPRB, 0.26287428E-09_JPRB, 0.26290473E-09_JPRB, 0.26292127E-09_JPRB, 0.26292496E-09_JPRB, &
  & 0.26291772E-09_JPRB, 0.26290081E-09_JPRB, 0.26287575E-09_JPRB, 0.26284405E-09_JPRB, 0.26280880E-09_JPRB, 0.26277316E-09_JPRB, &
  & 0.26274025E-09_JPRB, 0.26271096E-09_JPRB, 0.26268587E-09_JPRB, 0.26266458E-09_JPRB, 0.26264646E-09_JPRB, 0.26263181E-09_JPRB, &
  & 0.26261993E-09_JPRB, 0.26261035E-09_JPRB, 0.26260172E-09_JPRB, 0.26259248E-09_JPRB, 0.26258215E-09_JPRB, 0.26256838E-09_JPRB, &
  & 0.26255109E-09_JPRB, 0.26252892E-09_JPRB, 0.26250155E-09_JPRB, 0.26246932E-09_JPRB, 0.26243330E-09_JPRB, 0.26239635E-09_JPRB, &
  & 0.26235630E-09_JPRB, 0.26231156E-09_JPRB, 0.26223845E-09_JPRB, 0.26208158E-09_JPRB /)

RGHG5(:,74, 9) = (/ &
  & 0.26195063E-09_JPRB, 0.26212671E-09_JPRB, 0.26220137E-09_JPRB, 0.26224972E-09_JPRB, 0.26228794E-09_JPRB, 0.26231894E-09_JPRB, &
  & 0.26234742E-09_JPRB, 0.26237584E-09_JPRB, 0.26239882E-09_JPRB, 0.26242719E-09_JPRB, 0.26244790E-09_JPRB, 0.26247365E-09_JPRB, &
  & 0.26249247E-09_JPRB, 0.26250616E-09_JPRB, 0.26251445E-09_JPRB, 0.26250888E-09_JPRB, 0.26248786E-09_JPRB, 0.26245292E-09_JPRB, &
  & 0.26240843E-09_JPRB, 0.26236049E-09_JPRB, 0.26231795E-09_JPRB, 0.26229111E-09_JPRB, 0.26228675E-09_JPRB, 0.26230879E-09_JPRB, &
  & 0.26235336E-09_JPRB, 0.26241662E-09_JPRB, 0.26249408E-09_JPRB, 0.26257674E-09_JPRB, 0.26265948E-09_JPRB, 0.26273747E-09_JPRB, &
  & 0.26280508E-09_JPRB, 0.26285926E-09_JPRB, 0.26289898E-09_JPRB, 0.26292346E-09_JPRB, 0.26293723E-09_JPRB, 0.26294028E-09_JPRB, &
  & 0.26293451E-09_JPRB, 0.26292077E-09_JPRB, 0.26290065E-09_JPRB, 0.26287478E-09_JPRB, 0.26284597E-09_JPRB, 0.26281682E-09_JPRB, &
  & 0.26279015E-09_JPRB, 0.26276650E-09_JPRB, 0.26274627E-09_JPRB, 0.26272909E-09_JPRB, 0.26271454E-09_JPRB, 0.26270280E-09_JPRB, &
  & 0.26269359E-09_JPRB, 0.26268612E-09_JPRB, 0.26267924E-09_JPRB, 0.26267172E-09_JPRB, 0.26266328E-09_JPRB, 0.26265215E-09_JPRB, &
  & 0.26263750E-09_JPRB, 0.26262004E-09_JPRB, 0.26259656E-09_JPRB, 0.26257047E-09_JPRB, 0.26253896E-09_JPRB, 0.26250815E-09_JPRB, &
  & 0.26247304E-09_JPRB, 0.26243474E-09_JPRB, 0.26236843E-09_JPRB, 0.26222199E-09_JPRB /)

RGHG5(:,75, 9) = (/ &
  & 0.26211894E-09_JPRB, 0.26228786E-09_JPRB, 0.26235614E-09_JPRB, 0.26240071E-09_JPRB, 0.26243396E-09_JPRB, 0.26246164E-09_JPRB, &
  & 0.26248659E-09_JPRB, 0.26250874E-09_JPRB, 0.26253208E-09_JPRB, 0.26254926E-09_JPRB, 0.26257185E-09_JPRB, 0.26258717E-09_JPRB, &
  & 0.26260033E-09_JPRB, 0.26260877E-09_JPRB, 0.26261965E-09_JPRB, 0.26261565E-09_JPRB, 0.26259808E-09_JPRB, 0.26256863E-09_JPRB, &
  & 0.26253305E-09_JPRB, 0.26249383E-09_JPRB, 0.26245950E-09_JPRB, 0.26243724E-09_JPRB, 0.26243277E-09_JPRB, 0.26244959E-09_JPRB, &
  & 0.26248445E-09_JPRB, 0.26253463E-09_JPRB, 0.26259694E-09_JPRB, 0.26266336E-09_JPRB, 0.26272989E-09_JPRB, 0.26279262E-09_JPRB, &
  & 0.26284647E-09_JPRB, 0.26288954E-09_JPRB, 0.26292130E-09_JPRB, 0.26294028E-09_JPRB, 0.26295141E-09_JPRB, 0.26295383E-09_JPRB, &
  & 0.26294927E-09_JPRB, 0.26293845E-09_JPRB, 0.26292293E-09_JPRB, 0.26290242E-09_JPRB, 0.26287972E-09_JPRB, 0.26285643E-09_JPRB, &
  & 0.26283575E-09_JPRB, 0.26281705E-09_JPRB, 0.26280145E-09_JPRB, 0.26278815E-09_JPRB, 0.26277674E-09_JPRB, 0.26276792E-09_JPRB, &
  & 0.26276095E-09_JPRB, 0.26275546E-09_JPRB, 0.26275021E-09_JPRB, 0.26274413E-09_JPRB, 0.26273761E-09_JPRB, 0.26272856E-09_JPRB, &
  & 0.26271715E-09_JPRB, 0.26270297E-09_JPRB, 0.26268482E-09_JPRB, 0.26266322E-09_JPRB, 0.26263822E-09_JPRB, 0.26261257E-09_JPRB, &
  & 0.26258429E-09_JPRB, 0.26255198E-09_JPRB, 0.26249466E-09_JPRB, 0.26236122E-09_JPRB /)

RGHG5(:,76, 9) = (/ &
  & 0.26228850E-09_JPRB, 0.26244401E-09_JPRB, 0.26250493E-09_JPRB, 0.26254215E-09_JPRB, 0.26257110E-09_JPRB, 0.26259303E-09_JPRB, &
  & 0.26261351E-09_JPRB, 0.26263308E-09_JPRB, 0.26264874E-09_JPRB, 0.26266611E-09_JPRB, 0.26267924E-09_JPRB, 0.26269367E-09_JPRB, &
  & 0.26270347E-09_JPRB, 0.26270994E-09_JPRB, 0.26271660E-09_JPRB, 0.26271316E-09_JPRB, 0.26269911E-09_JPRB, 0.26267544E-09_JPRB, &
  & 0.26264826E-09_JPRB, 0.26261787E-09_JPRB, 0.26259106E-09_JPRB, 0.26257338E-09_JPRB, 0.26256902E-09_JPRB, 0.26258154E-09_JPRB, &
  & 0.26260802E-09_JPRB, 0.26264579E-09_JPRB, 0.26269370E-09_JPRB, 0.26274438E-09_JPRB, 0.26279556E-09_JPRB, 0.26284316E-09_JPRB, &
  & 0.26288444E-09_JPRB, 0.26291705E-09_JPRB, 0.26294147E-09_JPRB, 0.26295519E-09_JPRB, 0.26296407E-09_JPRB, 0.26296595E-09_JPRB, &
  & 0.26296251E-09_JPRB, 0.26295421E-09_JPRB, 0.26294297E-09_JPRB, 0.26292740E-09_JPRB, 0.26291033E-09_JPRB, 0.26289254E-09_JPRB, &
  & 0.26287711E-09_JPRB, 0.26286323E-09_JPRB, 0.26285185E-09_JPRB, 0.26284208E-09_JPRB, 0.26283362E-09_JPRB, 0.26282704E-09_JPRB, &
  & 0.26282215E-09_JPRB, 0.26281841E-09_JPRB, 0.26281463E-09_JPRB, 0.26280983E-09_JPRB, 0.26280519E-09_JPRB, 0.26279814E-09_JPRB, &
  & 0.26278937E-09_JPRB, 0.26277880E-09_JPRB, 0.26276492E-09_JPRB, 0.26274866E-09_JPRB, 0.26272937E-09_JPRB, 0.26270980E-09_JPRB, &
  & 0.26268807E-09_JPRB, 0.26266259E-09_JPRB, 0.26261518E-09_JPRB, 0.26249689E-09_JPRB /)

RGHG5(:,77, 9) = (/ &
  & 0.26245717E-09_JPRB, 0.26259428E-09_JPRB, 0.26264405E-09_JPRB, 0.26267410E-09_JPRB, 0.26269642E-09_JPRB, 0.26271280E-09_JPRB, &
  & 0.26272817E-09_JPRB, 0.26274266E-09_JPRB, 0.26275573E-09_JPRB, 0.26276548E-09_JPRB, 0.26277711E-09_JPRB, 0.26278429E-09_JPRB, &
  & 0.26278729E-09_JPRB, 0.26278801E-09_JPRB, 0.26280061E-09_JPRB, 0.26279948E-09_JPRB, 0.26278935E-09_JPRB, 0.26277133E-09_JPRB, &
  & 0.26275268E-09_JPRB, 0.26273078E-09_JPRB, 0.26271119E-09_JPRB, 0.26269820E-09_JPRB, 0.26269431E-09_JPRB, 0.26270353E-09_JPRB, &
  & 0.26272259E-09_JPRB, 0.26274896E-09_JPRB, 0.26278313E-09_JPRB, 0.26281924E-09_JPRB, 0.26285554E-09_JPRB, 0.26288918E-09_JPRB, &
  & 0.26291860E-09_JPRB, 0.26294189E-09_JPRB, 0.26295954E-09_JPRB, 0.26296834E-09_JPRB, 0.26297509E-09_JPRB, 0.26297642E-09_JPRB, &
  & 0.26297398E-09_JPRB, 0.26296798E-09_JPRB, 0.26296068E-09_JPRB, 0.26294963E-09_JPRB, 0.26293784E-09_JPRB, 0.26292474E-09_JPRB, &
  & 0.26291441E-09_JPRB, 0.26290478E-09_JPRB, 0.26289715E-09_JPRB, 0.26289060E-09_JPRB, 0.26288441E-09_JPRB, 0.26287988E-09_JPRB, &
  & 0.26287664E-09_JPRB, 0.26287439E-09_JPRB, 0.26287186E-09_JPRB, 0.26286823E-09_JPRB, 0.26286540E-09_JPRB, 0.26286037E-09_JPRB, &
  & 0.26285399E-09_JPRB, 0.26284694E-09_JPRB, 0.26283720E-09_JPRB, 0.26282568E-09_JPRB, 0.26281219E-09_JPRB, 0.26279837E-09_JPRB, &
  & 0.26278343E-09_JPRB, 0.26276514E-09_JPRB, 0.26272703E-09_JPRB, 0.26262884E-09_JPRB /)

RGHG5(:,78, 9) = (/ &
  & 0.26262595E-09_JPRB, 0.26273067E-09_JPRB, 0.26276570E-09_JPRB, 0.26278676E-09_JPRB, 0.26280356E-09_JPRB, 0.26281324E-09_JPRB, &
  & 0.26282385E-09_JPRB, 0.26283425E-09_JPRB, 0.26284186E-09_JPRB, 0.26284833E-09_JPRB, 0.26285485E-09_JPRB, 0.26285943E-09_JPRB, &
  & 0.26286129E-09_JPRB, 0.26286134E-09_JPRB, 0.26287048E-09_JPRB, 0.26287028E-09_JPRB, 0.26286365E-09_JPRB, 0.26285063E-09_JPRB, &
  & 0.26283994E-09_JPRB, 0.26282565E-09_JPRB, 0.26281299E-09_JPRB, 0.26280461E-09_JPRB, 0.26280181E-09_JPRB, 0.26280858E-09_JPRB, &
  & 0.26282185E-09_JPRB, 0.26283820E-09_JPRB, 0.26286040E-09_JPRB, 0.26288402E-09_JPRB, 0.26290686E-09_JPRB, 0.26292860E-09_JPRB, &
  & 0.26294750E-09_JPRB, 0.26296276E-09_JPRB, 0.26297478E-09_JPRB, 0.26297922E-09_JPRB, 0.26298444E-09_JPRB, 0.26298541E-09_JPRB, &
  & 0.26298377E-09_JPRB, 0.26297947E-09_JPRB, 0.26297550E-09_JPRB, 0.26296831E-09_JPRB, 0.26296096E-09_JPRB, 0.26295191E-09_JPRB, &
  & 0.26294572E-09_JPRB, 0.26293961E-09_JPRB, 0.26293501E-09_JPRB, 0.26293095E-09_JPRB, 0.26292651E-09_JPRB, 0.26292329E-09_JPRB, &
  & 0.26292141E-09_JPRB, 0.26292024E-09_JPRB, 0.26291874E-09_JPRB, 0.26291605E-09_JPRB, 0.26291502E-09_JPRB, 0.26291158E-09_JPRB, &
  & 0.26290758E-09_JPRB, 0.26290350E-09_JPRB, 0.26289756E-09_JPRB, 0.26289010E-09_JPRB, 0.26288194E-09_JPRB, 0.26287300E-09_JPRB, &
  & 0.26286434E-09_JPRB, 0.26285241E-09_JPRB, 0.26282704E-09_JPRB, 0.26275421E-09_JPRB /)

RGHG5(:,79, 9) = (/ &
  & 0.26273622E-09_JPRB, 0.26280744E-09_JPRB, 0.26283042E-09_JPRB, 0.26284555E-09_JPRB, 0.26285940E-09_JPRB, 0.26286542E-09_JPRB, &
  & 0.26287328E-09_JPRB, 0.26288158E-09_JPRB, 0.26288685E-09_JPRB, 0.26289027E-09_JPRB, 0.26289554E-09_JPRB, 0.26289806E-09_JPRB, &
  & 0.26289965E-09_JPRB, 0.26289940E-09_JPRB, 0.26290700E-09_JPRB, 0.26290733E-09_JPRB, 0.26290259E-09_JPRB, 0.26289193E-09_JPRB, &
  & 0.26288588E-09_JPRB, 0.26287575E-09_JPRB, 0.26286678E-09_JPRB, 0.26286118E-09_JPRB, 0.26285893E-09_JPRB, 0.26286484E-09_JPRB, &
  & 0.26287522E-09_JPRB, 0.26288621E-09_JPRB, 0.26290220E-09_JPRB, 0.26291899E-09_JPRB, 0.26293462E-09_JPRB, 0.26294986E-09_JPRB, &
  & 0.26296315E-09_JPRB, 0.26297414E-09_JPRB, 0.26298319E-09_JPRB, 0.26298511E-09_JPRB, 0.26298960E-09_JPRB, 0.26299038E-09_JPRB, &
  & 0.26298919E-09_JPRB, 0.26298566E-09_JPRB, 0.26298350E-09_JPRB, 0.26297831E-09_JPRB, 0.26297331E-09_JPRB, 0.26296626E-09_JPRB, &
  & 0.26296224E-09_JPRB, 0.26295793E-09_JPRB, 0.26295488E-09_JPRB, 0.26295213E-09_JPRB, 0.26294839E-09_JPRB, 0.26294572E-09_JPRB, &
  & 0.26294450E-09_JPRB, 0.26294389E-09_JPRB, 0.26294286E-09_JPRB, 0.26294050E-09_JPRB, 0.26294050E-09_JPRB, 0.26293787E-09_JPRB, &
  & 0.26293484E-09_JPRB, 0.26293254E-09_JPRB, 0.26292843E-09_JPRB, 0.26292302E-09_JPRB, 0.26291749E-09_JPRB, 0.26291103E-09_JPRB, &
  & 0.26290575E-09_JPRB, 0.26289859E-09_JPRB, 0.26288172E-09_JPRB, 0.26283375E-09_JPRB /)

RGHG5(:,80, 9) = (/ &
  & 0.26281055E-09_JPRB, 0.26284450E-09_JPRB, 0.26285860E-09_JPRB, 0.26287095E-09_JPRB, 0.26288363E-09_JPRB, 0.26288788E-09_JPRB, &
  & 0.26289459E-09_JPRB, 0.26290206E-09_JPRB, 0.26290631E-09_JPRB, 0.26290856E-09_JPRB, 0.26291322E-09_JPRB, 0.26291497E-09_JPRB, &
  & 0.26291658E-09_JPRB, 0.26291622E-09_JPRB, 0.26292321E-09_JPRB, 0.26292393E-09_JPRB, 0.26291996E-09_JPRB, 0.26291030E-09_JPRB, &
  & 0.26290653E-09_JPRB, 0.26289823E-09_JPRB, 0.26289110E-09_JPRB, 0.26288663E-09_JPRB, 0.26288463E-09_JPRB, 0.26289018E-09_JPRB, &
  & 0.26289940E-09_JPRB, 0.26290795E-09_JPRB, 0.26292113E-09_JPRB, 0.26293498E-09_JPRB, 0.26294725E-09_JPRB, 0.26295960E-09_JPRB, &
  & 0.26297020E-09_JPRB, 0.26297930E-09_JPRB, 0.26298713E-09_JPRB, 0.26298769E-09_JPRB, 0.26299196E-09_JPRB, 0.26299271E-09_JPRB, &
  & 0.26299168E-09_JPRB, 0.26298846E-09_JPRB, 0.26298722E-09_JPRB, 0.26298291E-09_JPRB, 0.26297892E-09_JPRB, 0.26297270E-09_JPRB, &
  & 0.26296962E-09_JPRB, 0.26296609E-09_JPRB, 0.26296382E-09_JPRB, 0.26296162E-09_JPRB, 0.26295810E-09_JPRB, 0.26295566E-09_JPRB, &
  & 0.26295471E-09_JPRB, 0.26295435E-09_JPRB, 0.26295355E-09_JPRB, 0.26295105E-09_JPRB, 0.26295158E-09_JPRB, 0.26294913E-09_JPRB, &
  & 0.26294647E-09_JPRB, 0.26294486E-09_JPRB, 0.26294156E-09_JPRB, 0.26293689E-09_JPRB, 0.26293259E-09_JPRB, 0.26292712E-09_JPRB, &
  & 0.26292360E-09_JPRB, 0.26291860E-09_JPRB, 0.26290795E-09_JPRB, 0.26288552E-09_JPRB /)

RGHG5(:,81, 9) = (/ &
  & 0.26286245E-09_JPRB, 0.26286004E-09_JPRB, 0.26287042E-09_JPRB, 0.26288155E-09_JPRB, 0.26289410E-09_JPRB, 0.26289745E-09_JPRB, &
  & 0.26290367E-09_JPRB, 0.26291108E-09_JPRB, 0.26291452E-09_JPRB, 0.26291669E-09_JPRB, 0.26292069E-09_JPRB, 0.26292232E-09_JPRB, &
  & 0.26292399E-09_JPRB, 0.26292352E-09_JPRB, 0.26293032E-09_JPRB, 0.26293126E-09_JPRB, 0.26292779E-09_JPRB, 0.26291830E-09_JPRB, &
  & 0.26291574E-09_JPRB, 0.26290825E-09_JPRB, 0.26290178E-09_JPRB, 0.26289787E-09_JPRB, 0.26289584E-09_JPRB, 0.26290134E-09_JPRB, &
  & 0.26291005E-09_JPRB, 0.26291758E-09_JPRB, 0.26292951E-09_JPRB, 0.26294203E-09_JPRB, 0.26295291E-09_JPRB, 0.26296382E-09_JPRB, &
  & 0.26297337E-09_JPRB, 0.26298158E-09_JPRB, 0.26298888E-09_JPRB, 0.26298877E-09_JPRB, 0.26299304E-09_JPRB, 0.26299377E-09_JPRB, &
  & 0.26299288E-09_JPRB, 0.26298971E-09_JPRB, 0.26298880E-09_JPRB, 0.26298491E-09_JPRB, 0.26298133E-09_JPRB, 0.26297553E-09_JPRB, &
  & 0.26297284E-09_JPRB, 0.26296970E-09_JPRB, 0.26296770E-09_JPRB, 0.26296584E-09_JPRB, 0.26296240E-09_JPRB, 0.26296001E-09_JPRB, &
  & 0.26295924E-09_JPRB, 0.26295899E-09_JPRB, 0.26295827E-09_JPRB, 0.26295566E-09_JPRB, 0.26295641E-09_JPRB, 0.26295391E-09_JPRB, &
  & 0.26295141E-09_JPRB, 0.26295011E-09_JPRB, 0.26294711E-09_JPRB, 0.26294281E-09_JPRB, 0.26293895E-09_JPRB, 0.26293392E-09_JPRB, &
  & 0.26293104E-09_JPRB, 0.26292707E-09_JPRB, 0.26291888E-09_JPRB, 0.26292088E-09_JPRB /)

RGHG5(:,82, 9) = (/ &
  & 0.26286665E-09_JPRB, 0.26286512E-09_JPRB, 0.26287550E-09_JPRB, 0.26288663E-09_JPRB, 0.26289909E-09_JPRB, 0.26290212E-09_JPRB, &
  & 0.26290842E-09_JPRB, 0.26291494E-09_JPRB, 0.26291880E-09_JPRB, 0.26292021E-09_JPRB, 0.26292457E-09_JPRB, 0.26292576E-09_JPRB, &
  & 0.26292754E-09_JPRB, 0.26292710E-09_JPRB, 0.26293379E-09_JPRB, 0.26293495E-09_JPRB, 0.26293157E-09_JPRB, 0.26292221E-09_JPRB, &
  & 0.26292035E-09_JPRB, 0.26291325E-09_JPRB, 0.26290711E-09_JPRB, 0.26290342E-09_JPRB, 0.26290134E-09_JPRB, 0.26290675E-09_JPRB, &
  & 0.26291533E-09_JPRB, 0.26292224E-09_JPRB, 0.26293370E-09_JPRB, 0.26294555E-09_JPRB, 0.26295560E-09_JPRB, 0.26296595E-09_JPRB, &
  & 0.26297484E-09_JPRB, 0.26298266E-09_JPRB, 0.26298974E-09_JPRB, 0.26298935E-09_JPRB, 0.26299365E-09_JPRB, 0.26299432E-09_JPRB, &
  & 0.26299340E-09_JPRB, 0.26299035E-09_JPRB, 0.26298963E-09_JPRB, 0.26298594E-09_JPRB, 0.26298258E-09_JPRB, 0.26297695E-09_JPRB, &
  & 0.26297445E-09_JPRB, 0.26297148E-09_JPRB, 0.26296970E-09_JPRB, 0.26296790E-09_JPRB, 0.26296451E-09_JPRB, 0.26296218E-09_JPRB, &
  & 0.26296149E-09_JPRB, 0.26296126E-09_JPRB, 0.26296060E-09_JPRB, 0.26295785E-09_JPRB, 0.26295877E-09_JPRB, 0.26295630E-09_JPRB, &
  & 0.26295380E-09_JPRB, 0.26295266E-09_JPRB, 0.26294977E-09_JPRB, 0.26294558E-09_JPRB, 0.26294200E-09_JPRB, 0.26293712E-09_JPRB, &
  & 0.26293465E-09_JPRB, 0.26293084E-09_JPRB, 0.26292249E-09_JPRB, 0.26292368E-09_JPRB /)

RGHG5(:,83, 9) = (/ &
  & 0.26286953E-09_JPRB, 0.26286801E-09_JPRB, 0.26287839E-09_JPRB, 0.26288938E-09_JPRB, 0.26290198E-09_JPRB, 0.26290489E-09_JPRB, &
  & 0.26291058E-09_JPRB, 0.26291799E-09_JPRB, 0.26292066E-09_JPRB, 0.26292291E-09_JPRB, 0.26292613E-09_JPRB, 0.26292776E-09_JPRB, &
  & 0.26292943E-09_JPRB, 0.26292918E-09_JPRB, 0.26293570E-09_JPRB, 0.26293703E-09_JPRB, 0.26293379E-09_JPRB, 0.26292440E-09_JPRB, &
  & 0.26292302E-09_JPRB, 0.26291608E-09_JPRB, 0.26291003E-09_JPRB, 0.26290653E-09_JPRB, 0.26290431E-09_JPRB, 0.26290989E-09_JPRB, &
  & 0.26291824E-09_JPRB, 0.26292493E-09_JPRB, 0.26293606E-09_JPRB, 0.26294750E-09_JPRB, 0.26295727E-09_JPRB, 0.26296704E-09_JPRB, &
  & 0.26297567E-09_JPRB, 0.26298327E-09_JPRB, 0.26299021E-09_JPRB, 0.26298969E-09_JPRB, 0.26299390E-09_JPRB, 0.26299468E-09_JPRB, &
  & 0.26299371E-09_JPRB, 0.26299068E-09_JPRB, 0.26299005E-09_JPRB, 0.26298652E-09_JPRB, 0.26298325E-09_JPRB, 0.26297775E-09_JPRB, &
  & 0.26297534E-09_JPRB, 0.26297250E-09_JPRB, 0.26297087E-09_JPRB, 0.26296912E-09_JPRB, 0.26296568E-09_JPRB, 0.26296335E-09_JPRB, &
  & 0.26296273E-09_JPRB, 0.26296254E-09_JPRB, 0.26296185E-09_JPRB, 0.26295907E-09_JPRB, 0.26296010E-09_JPRB, 0.26295754E-09_JPRB, &
  & 0.26295505E-09_JPRB, 0.26295402E-09_JPRB, 0.26295124E-09_JPRB, 0.26294716E-09_JPRB, 0.26294369E-09_JPRB, 0.26293892E-09_JPRB, &
  & 0.26293662E-09_JPRB, 0.26293293E-09_JPRB, 0.26292463E-09_JPRB, 0.26292568E-09_JPRB /)

RGHG5(:,84, 9) = (/ &
  & 0.26287159E-09_JPRB, 0.26286992E-09_JPRB, 0.26288000E-09_JPRB, 0.26289115E-09_JPRB, 0.26290384E-09_JPRB, 0.26290650E-09_JPRB, &
  & 0.26291297E-09_JPRB, 0.26291869E-09_JPRB, 0.26292241E-09_JPRB, 0.26292382E-09_JPRB, 0.26292762E-09_JPRB, 0.26292879E-09_JPRB, &
  & 0.26293051E-09_JPRB, 0.26293068E-09_JPRB, 0.26293659E-09_JPRB, 0.26293820E-09_JPRB, 0.26293512E-09_JPRB, 0.26292585E-09_JPRB, &
  & 0.26292465E-09_JPRB, 0.26291785E-09_JPRB, 0.26291186E-09_JPRB, 0.26290842E-09_JPRB, 0.26290609E-09_JPRB, 0.26291161E-09_JPRB, &
  & 0.26292021E-09_JPRB, 0.26292654E-09_JPRB, 0.26293756E-09_JPRB, 0.26294888E-09_JPRB, 0.26295810E-09_JPRB, 0.26296784E-09_JPRB, &
  & 0.26297614E-09_JPRB, 0.26298363E-09_JPRB, 0.26299043E-09_JPRB, 0.26298985E-09_JPRB, 0.26299413E-09_JPRB, 0.26299485E-09_JPRB, &
  & 0.26299390E-09_JPRB, 0.26299088E-09_JPRB, 0.26299030E-09_JPRB, 0.26298685E-09_JPRB, 0.26298363E-09_JPRB, 0.26297819E-09_JPRB, &
  & 0.26297595E-09_JPRB, 0.26297303E-09_JPRB, 0.26297156E-09_JPRB, 0.26296990E-09_JPRB, 0.26296640E-09_JPRB, 0.26296412E-09_JPRB, &
  & 0.26296348E-09_JPRB, 0.26296335E-09_JPRB, 0.26296265E-09_JPRB, 0.26295985E-09_JPRB, 0.26296093E-09_JPRB, 0.26295827E-09_JPRB, &
  & 0.26295582E-09_JPRB, 0.26295488E-09_JPRB, 0.26295213E-09_JPRB, 0.26294805E-09_JPRB, 0.26294475E-09_JPRB, 0.26293992E-09_JPRB, &
  & 0.26293789E-09_JPRB, 0.26293431E-09_JPRB, 0.26292601E-09_JPRB, 0.26292704E-09_JPRB /)

RGHG5(:,85, 9) = (/ &
  & 0.26287297E-09_JPRB, 0.26287109E-09_JPRB, 0.26288119E-09_JPRB, 0.26289226E-09_JPRB, 0.26290503E-09_JPRB, 0.26290825E-09_JPRB, &
  & 0.26291350E-09_JPRB, 0.26292057E-09_JPRB, 0.26292299E-09_JPRB, 0.26292535E-09_JPRB, 0.26292787E-09_JPRB, 0.26292954E-09_JPRB, &
  & 0.26293112E-09_JPRB, 0.26293198E-09_JPRB, 0.26293678E-09_JPRB, 0.26293842E-09_JPRB, 0.26293570E-09_JPRB, 0.26292710E-09_JPRB, &
  & 0.26292574E-09_JPRB, 0.26291902E-09_JPRB, 0.26291314E-09_JPRB, 0.26290964E-09_JPRB, 0.26290714E-09_JPRB, 0.26291289E-09_JPRB, &
  & 0.26292130E-09_JPRB, 0.26292754E-09_JPRB, 0.26293859E-09_JPRB, 0.26294955E-09_JPRB, 0.26295899E-09_JPRB, 0.26296818E-09_JPRB, &
  & 0.26297650E-09_JPRB, 0.26298386E-09_JPRB, 0.26299068E-09_JPRB, 0.26298996E-09_JPRB, 0.26299427E-09_JPRB, 0.26299501E-09_JPRB, &
  & 0.26299402E-09_JPRB, 0.26299096E-09_JPRB, 0.26299049E-09_JPRB, 0.26298713E-09_JPRB, 0.26298397E-09_JPRB, 0.26297858E-09_JPRB, &
  & 0.26297628E-09_JPRB, 0.26297350E-09_JPRB, 0.26297198E-09_JPRB, 0.26297042E-09_JPRB, 0.26296684E-09_JPRB, 0.26296459E-09_JPRB, &
  & 0.26296398E-09_JPRB, 0.26296387E-09_JPRB, 0.26296321E-09_JPRB, 0.26296035E-09_JPRB, 0.26296151E-09_JPRB, 0.26295882E-09_JPRB, &
  & 0.26295632E-09_JPRB, 0.26295546E-09_JPRB, 0.26295272E-09_JPRB, 0.26294869E-09_JPRB, 0.26294536E-09_JPRB, 0.26294072E-09_JPRB, &
  & 0.26293867E-09_JPRB, 0.26293526E-09_JPRB, 0.26292687E-09_JPRB, 0.26292798E-09_JPRB /)

RGHG5(:,86, 9) = (/ &
  & 0.26287394E-09_JPRB, 0.26287186E-09_JPRB, 0.26288177E-09_JPRB, 0.26289299E-09_JPRB, 0.26290622E-09_JPRB, 0.26290903E-09_JPRB, &
  & 0.26291619E-09_JPRB, 0.26292046E-09_JPRB, 0.26292402E-09_JPRB, 0.26292574E-09_JPRB, 0.26292840E-09_JPRB, 0.26292993E-09_JPRB, &
  & 0.26293157E-09_JPRB, 0.26293284E-09_JPRB, 0.26293639E-09_JPRB, 0.26293795E-09_JPRB, 0.26293573E-09_JPRB, 0.26292829E-09_JPRB, &
  & 0.26292640E-09_JPRB, 0.26291996E-09_JPRB, 0.26291394E-09_JPRB, 0.26291050E-09_JPRB, 0.26290781E-09_JPRB, 0.26291339E-09_JPRB, &
  & 0.26292213E-09_JPRB, 0.26292807E-09_JPRB, 0.26293898E-09_JPRB, 0.26295036E-09_JPRB, 0.26295921E-09_JPRB, 0.26296873E-09_JPRB, &
  & 0.26297672E-09_JPRB, 0.26298416E-09_JPRB, 0.26299088E-09_JPRB, 0.26299002E-09_JPRB, 0.26299443E-09_JPRB, 0.26299515E-09_JPRB, &
  & 0.26299415E-09_JPRB, 0.26299105E-09_JPRB, 0.26299068E-09_JPRB, 0.26298735E-09_JPRB, 0.26298413E-09_JPRB, 0.26297864E-09_JPRB, &
  & 0.26297650E-09_JPRB, 0.26297367E-09_JPRB, 0.26297231E-09_JPRB, 0.26297076E-09_JPRB, 0.26296715E-09_JPRB, 0.26296490E-09_JPRB, &
  & 0.26296429E-09_JPRB, 0.26296423E-09_JPRB, 0.26296354E-09_JPRB, 0.26296060E-09_JPRB, 0.26296182E-09_JPRB, 0.26295915E-09_JPRB, &
  & 0.26295660E-09_JPRB, 0.26295580E-09_JPRB, 0.26295305E-09_JPRB, 0.26294900E-09_JPRB, 0.26294583E-09_JPRB, 0.26294095E-09_JPRB, &
  & 0.26293923E-09_JPRB, 0.26293584E-09_JPRB, 0.26292749E-09_JPRB, 0.26292862E-09_JPRB /)

RGHG5(:,87, 9) = (/ &
  & 0.26287453E-09_JPRB, 0.26287222E-09_JPRB, 0.26288233E-09_JPRB, 0.26289401E-09_JPRB, 0.26290647E-09_JPRB, 0.26291119E-09_JPRB, &
  & 0.26291569E-09_JPRB, 0.26292196E-09_JPRB, 0.26292424E-09_JPRB, 0.26292649E-09_JPRB, 0.26292854E-09_JPRB, 0.26293015E-09_JPRB, &
  & 0.26293173E-09_JPRB, 0.26293306E-09_JPRB, 0.26293606E-09_JPRB, 0.26293734E-09_JPRB, 0.26293551E-09_JPRB, 0.26292910E-09_JPRB, &
  & 0.26292696E-09_JPRB, 0.26292049E-09_JPRB, 0.26291455E-09_JPRB, 0.26291092E-09_JPRB, 0.26290811E-09_JPRB, 0.26291383E-09_JPRB, &
  & 0.26292246E-09_JPRB, 0.26292812E-09_JPRB, 0.26293942E-09_JPRB, 0.26295041E-09_JPRB, 0.26295971E-09_JPRB, 0.26296884E-09_JPRB, &
  & 0.26297706E-09_JPRB, 0.26298441E-09_JPRB, 0.26299107E-09_JPRB, 0.26299005E-09_JPRB, 0.26299454E-09_JPRB, 0.26299526E-09_JPRB, &
  & 0.26299432E-09_JPRB, 0.26299102E-09_JPRB, 0.26299088E-09_JPRB, 0.26298749E-09_JPRB, 0.26298433E-09_JPRB, 0.26297858E-09_JPRB, &
  & 0.26297653E-09_JPRB, 0.26297381E-09_JPRB, 0.26297248E-09_JPRB, 0.26297103E-09_JPRB, 0.26296731E-09_JPRB, 0.26296509E-09_JPRB, &
  & 0.26296451E-09_JPRB, 0.26296443E-09_JPRB, 0.26296379E-09_JPRB, 0.26296076E-09_JPRB, 0.26296207E-09_JPRB, 0.26295932E-09_JPRB, &
  & 0.26295677E-09_JPRB, 0.26295602E-09_JPRB, 0.26295327E-09_JPRB, 0.26294930E-09_JPRB, 0.26294608E-09_JPRB, 0.26294128E-09_JPRB, &
  & 0.26293953E-09_JPRB, 0.26293623E-09_JPRB, 0.26292776E-09_JPRB, 0.26292898E-09_JPRB /)

RGHG5(:,88, 9) = (/ &
  & 0.26287492E-09_JPRB, 0.26287275E-09_JPRB, 0.26288249E-09_JPRB, 0.26289376E-09_JPRB, 0.26290758E-09_JPRB, 0.26291050E-09_JPRB, &
  & 0.26291780E-09_JPRB, 0.26292157E-09_JPRB, 0.26292485E-09_JPRB, 0.26292662E-09_JPRB, 0.26292887E-09_JPRB, 0.26293040E-09_JPRB, &
  & 0.26293195E-09_JPRB, 0.26293334E-09_JPRB, 0.26293601E-09_JPRB, 0.26293728E-09_JPRB, 0.26293556E-09_JPRB, 0.26292948E-09_JPRB, &
  & 0.26292718E-09_JPRB, 0.26292094E-09_JPRB, 0.26291480E-09_JPRB, 0.26291128E-09_JPRB, 0.26290825E-09_JPRB, 0.26291397E-09_JPRB, &
  & 0.26292274E-09_JPRB, 0.26292815E-09_JPRB, 0.26293945E-09_JPRB, 0.26295083E-09_JPRB, 0.26295971E-09_JPRB, 0.26296923E-09_JPRB, &
  & 0.26297722E-09_JPRB, 0.26298461E-09_JPRB, 0.26299130E-09_JPRB, 0.26299005E-09_JPRB, 0.26299471E-09_JPRB, 0.26299540E-09_JPRB, &
  & 0.26299443E-09_JPRB, 0.26299102E-09_JPRB, 0.26299116E-09_JPRB, 0.26298771E-09_JPRB, 0.26298455E-09_JPRB, 0.26297844E-09_JPRB, &
  & 0.26297664E-09_JPRB, 0.26297375E-09_JPRB, 0.26297253E-09_JPRB, 0.26297114E-09_JPRB, 0.26296745E-09_JPRB, 0.26296523E-09_JPRB, &
  & 0.26296465E-09_JPRB, 0.26296457E-09_JPRB, 0.26296396E-09_JPRB, 0.26296085E-09_JPRB, 0.26296221E-09_JPRB, 0.26295946E-09_JPRB, &
  & 0.26295691E-09_JPRB, 0.26295610E-09_JPRB, 0.26295341E-09_JPRB, 0.26294941E-09_JPRB, 0.26294622E-09_JPRB, 0.26294131E-09_JPRB, &
  & 0.26293970E-09_JPRB, 0.26293642E-09_JPRB, 0.26292793E-09_JPRB, 0.26292918E-09_JPRB /)

RGHG5(:,89, 9) = (/ &
  & 0.26287511E-09_JPRB, 0.26287331E-09_JPRB, 0.26288272E-09_JPRB, 0.26289410E-09_JPRB, 0.26290689E-09_JPRB, 0.26291141E-09_JPRB, &
  & 0.26291597E-09_JPRB, 0.26292227E-09_JPRB, 0.26292454E-09_JPRB, 0.26292674E-09_JPRB, 0.26292890E-09_JPRB, 0.26293046E-09_JPRB, &
  & 0.26293204E-09_JPRB, 0.26293334E-09_JPRB, 0.26293637E-09_JPRB, 0.26293773E-09_JPRB, 0.26293590E-09_JPRB, 0.26292937E-09_JPRB, &
  & 0.26292740E-09_JPRB, 0.26292088E-09_JPRB, 0.26291497E-09_JPRB, 0.26291136E-09_JPRB, 0.26290825E-09_JPRB, 0.26291405E-09_JPRB, &
  & 0.26292288E-09_JPRB, 0.26292804E-09_JPRB, 0.26293956E-09_JPRB, 0.26295086E-09_JPRB, 0.26295988E-09_JPRB, 0.26296920E-09_JPRB, &
  & 0.26297739E-09_JPRB, 0.26298472E-09_JPRB, 0.26299157E-09_JPRB, 0.26298999E-09_JPRB, 0.26299476E-09_JPRB, 0.26299551E-09_JPRB, &
  & 0.26299454E-09_JPRB, 0.26299096E-09_JPRB, 0.26299141E-09_JPRB, 0.26298774E-09_JPRB, 0.26298469E-09_JPRB, 0.26297825E-09_JPRB, &
  & 0.26297661E-09_JPRB, 0.26297384E-09_JPRB, 0.26297267E-09_JPRB, 0.26297128E-09_JPRB, 0.26296748E-09_JPRB, 0.26296526E-09_JPRB, &
  & 0.26296468E-09_JPRB, 0.26296471E-09_JPRB, 0.26296409E-09_JPRB, 0.26296088E-09_JPRB, 0.26296235E-09_JPRB, 0.26295957E-09_JPRB, &
  & 0.26295699E-09_JPRB, 0.26295621E-09_JPRB, 0.26295344E-09_JPRB, 0.26294944E-09_JPRB, 0.26294630E-09_JPRB, 0.26294134E-09_JPRB, &
  & 0.26293978E-09_JPRB, 0.26293662E-09_JPRB, 0.26292798E-09_JPRB, 0.26292929E-09_JPRB /)

RGHG5(:,90, 9) = (/ &
  & 0.26287528E-09_JPRB, 0.26287394E-09_JPRB, 0.26288205E-09_JPRB, 0.26289337E-09_JPRB, 0.26290725E-09_JPRB, 0.26290939E-09_JPRB, &
  & 0.26291652E-09_JPRB, 0.26292132E-09_JPRB, 0.26292463E-09_JPRB, 0.26292643E-09_JPRB, 0.26292912E-09_JPRB, 0.26293057E-09_JPRB, &
  & 0.26293218E-09_JPRB, 0.26293340E-09_JPRB, 0.26293728E-09_JPRB, 0.26293898E-09_JPRB, 0.26293670E-09_JPRB, 0.26292868E-09_JPRB, &
  & 0.26292746E-09_JPRB, 0.26292082E-09_JPRB, 0.26291483E-09_JPRB, 0.26291141E-09_JPRB, 0.26290806E-09_JPRB, 0.26291402E-09_JPRB, &
  & 0.26292304E-09_JPRB, 0.26292790E-09_JPRB, 0.26293956E-09_JPRB, 0.26295094E-09_JPRB, 0.26295979E-09_JPRB, 0.26296931E-09_JPRB, &
  & 0.26297747E-09_JPRB, 0.26298486E-09_JPRB, 0.26299196E-09_JPRB, 0.26298980E-09_JPRB, 0.26299499E-09_JPRB, 0.26299568E-09_JPRB, &
  & 0.26299476E-09_JPRB, 0.26299085E-09_JPRB, 0.26299163E-09_JPRB, 0.26298777E-09_JPRB, 0.26298483E-09_JPRB, 0.26297806E-09_JPRB, &
  & 0.26297664E-09_JPRB, 0.26297378E-09_JPRB, 0.26297270E-09_JPRB, 0.26297137E-09_JPRB, 0.26296748E-09_JPRB, 0.26296529E-09_JPRB, &
  & 0.26296473E-09_JPRB, 0.26296476E-09_JPRB, 0.26296421E-09_JPRB, 0.26296082E-09_JPRB, 0.26296251E-09_JPRB, 0.26295954E-09_JPRB, &
  & 0.26295693E-09_JPRB, 0.26295630E-09_JPRB, 0.26295352E-09_JPRB, 0.26294950E-09_JPRB, 0.26294633E-09_JPRB, 0.26294125E-09_JPRB, &
  & 0.26293989E-09_JPRB, 0.26293667E-09_JPRB, 0.26292774E-09_JPRB, 0.26292943E-09_JPRB /)

RGHG5(:,91, 9) = (/ &
  & 0.26287542E-09_JPRB, 0.26287406E-09_JPRB, 0.26288013E-09_JPRB, 0.26289310E-09_JPRB, 0.26290797E-09_JPRB, 0.26290825E-09_JPRB, &
  & 0.26291397E-09_JPRB, 0.26292202E-09_JPRB, 0.26292440E-09_JPRB, 0.26292518E-09_JPRB, 0.26293026E-09_JPRB, 0.26293037E-09_JPRB, &
  & 0.26293273E-09_JPRB, 0.26293107E-09_JPRB, 0.26293964E-09_JPRB, 0.26294136E-09_JPRB, 0.26293825E-09_JPRB, 0.26292654E-09_JPRB, &
  & 0.26292804E-09_JPRB, 0.26292055E-09_JPRB, 0.26291455E-09_JPRB, 0.26291139E-09_JPRB, 0.26290747E-09_JPRB, 0.26291380E-09_JPRB, &
  & 0.26292332E-09_JPRB, 0.26292746E-09_JPRB, 0.26293953E-09_JPRB, 0.26295105E-09_JPRB, 0.26295965E-09_JPRB, 0.26296929E-09_JPRB, &
  & 0.26297761E-09_JPRB, 0.26298480E-09_JPRB, 0.26299293E-09_JPRB, 0.26298910E-09_JPRB, 0.26299538E-09_JPRB, 0.26299590E-09_JPRB, &
  & 0.26299499E-09_JPRB, 0.26299049E-09_JPRB, 0.26299193E-09_JPRB, 0.26298771E-09_JPRB, 0.26298516E-09_JPRB, 0.26297767E-09_JPRB, &
  & 0.26297672E-09_JPRB, 0.26297367E-09_JPRB, 0.26297275E-09_JPRB, 0.26297156E-09_JPRB, 0.26296731E-09_JPRB, 0.26296515E-09_JPRB, &
  & 0.26296465E-09_JPRB, 0.26296482E-09_JPRB, 0.26296437E-09_JPRB, 0.26296043E-09_JPRB, 0.26296279E-09_JPRB, 0.26295949E-09_JPRB, &
  & 0.26295680E-09_JPRB, 0.26295646E-09_JPRB, 0.26295363E-09_JPRB, 0.26294941E-09_JPRB, 0.26294639E-09_JPRB, 0.26294097E-09_JPRB, &
  & 0.26293998E-09_JPRB, 0.26293681E-09_JPRB, 0.26292721E-09_JPRB, 0.26292943E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART18',1,ZHOOK_HANDLE)
END SUBROUTINE PART18






SUBROUTINE PART19
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART19',0,ZHOOK_HANDLE)



!-- Month= 10 ------------

RGHG5(:, 1,10) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.14012985E-44_JPRB, 0.56051939E-44_JPRB, 0.98090893E-44_JPRB, 0.23822074E-43_JPRB, 0.54650640E-43_JPRB, 0.12611686E-42_JPRB, &
  & 0.29707527E-42_JPRB, 0.72026741E-42_JPRB, 0.17600309E-41_JPRB, 0.40343383E-41_JPRB, 0.94727776E-41_JPRB, 0.19741493E-40_JPRB, &
  & 0.37409064E-40_JPRB, 0.60760301E-40_JPRB, 0.79547510E-40_JPRB, 0.10752443E-39_JPRB, 0.15861157E-39_JPRB, 0.26293824E-39_JPRB, &
  & 0.37883263E-39_JPRB, 0.40530456E-39_JPRB, 0.40081900E-39_JPRB, 0.35068195E-39_JPRB, 0.35857967E-39_JPRB, 0.40588049E-39_JPRB, &
  & 0.31658135E-39_JPRB, 0.32524277E-39_JPRB, 0.28576680E-39_JPRB, 0.22961256E-39_JPRB, 0.24534914E-39_JPRB, 0.20665649E-39_JPRB, &
  & 0.19341562E-39_JPRB, 0.16452926E-39_JPRB, 0.12426294E-39_JPRB, 0.92728123E-40_JPRB, 0.64924960E-40_JPRB, 0.43368786E-40_JPRB, &
  & 0.27898451E-40_JPRB, 0.17223359E-40_JPRB, 0.10736749E-40_JPRB, 0.62666067E-41_JPRB, 0.34345825E-41_JPRB, 0.19001607E-41_JPRB, &
  & 0.99912581E-42_JPRB, 0.54510510E-42_JPRB, 0.29567398E-42_JPRB, 0.16955711E-42_JPRB, 0.10649868E-42_JPRB, 0.72867520E-43_JPRB, &
  & 0.54650640E-43_JPRB, 0.46242849E-43_JPRB, 0.42038954E-43_JPRB, 0.39236357E-43_JPRB, 0.37835059E-43_JPRB, 0.35032462E-43_JPRB, &
  & 0.30828566E-43_JPRB, 0.25223372E-43_JPRB, 0.18216880E-43_JPRB, 0.14012985E-43_JPRB /)

RGHG5(:, 2,10) = (/ &
  & 0.42038954E-44_JPRB, 0.84077908E-44_JPRB, 0.14012985E-43_JPRB, 0.23822074E-43_JPRB, 0.39236357E-43_JPRB, 0.71466222E-43_JPRB, &
  & 0.13732725E-42_JPRB, 0.28025969E-42_JPRB, 0.59134795E-42_JPRB, 0.12807868E-41_JPRB, 0.28446359E-41_JPRB, 0.64697950E-41_JPRB, &
  & 0.14943447E-40_JPRB, 0.35000232E-40_JPRB, 0.81671878E-40_JPRB, 0.18147376E-39_JPRB, 0.40334134E-39_JPRB, 0.81232571E-39_JPRB, &
  & 0.14948491E-38_JPRB, 0.23931725E-38_JPRB, 0.31763274E-38_JPRB, 0.43243608E-38_JPRB, 0.63838814E-38_JPRB, 0.10419401E-37_JPRB, &
  & 0.14823267E-37_JPRB, 0.15934011E-37_JPRB, 0.15743101E-37_JPRB, 0.14152141E-37_JPRB, 0.14399388E-37_JPRB, 0.15790202E-37_JPRB, &
  & 0.12919787E-37_JPRB, 0.12874871E-37_JPRB, 0.11368231E-37_JPRB, 0.93800047E-38_JPRB, 0.95594703E-38_JPRB, 0.82529809E-38_JPRB, &
  & 0.75394958E-38_JPRB, 0.63959704E-38_JPRB, 0.49374247E-38_JPRB, 0.37010464E-38_JPRB, 0.26409866E-38_JPRB, 0.17823437E-38_JPRB, &
  & 0.11530024E-38_JPRB, 0.72018473E-39_JPRB, 0.45080332E-39_JPRB, 0.26819031E-39_JPRB, 0.15195540E-39_JPRB, 0.85770676E-40_JPRB, &
  & 0.46460051E-40_JPRB, 0.25461593E-40_JPRB, 0.13829415E-40_JPRB, 0.78290545E-41_JPRB, 0.47433953E-41_JPRB, 0.31501189E-41_JPRB, &
  & 0.23219516E-41_JPRB, 0.18931542E-41_JPRB, 0.16619400E-41_JPRB, 0.15288166E-41_JPRB, 0.14349296E-41_JPRB, 0.13438452E-41_JPRB, &
  & 0.12247349E-41_JPRB, 0.10383622E-41_JPRB, 0.78752974E-42_JPRB, 0.55491419E-42_JPRB /)

RGHG5(:, 3,10) = (/ &
  & 0.10369609E-42_JPRB, 0.29427268E-42_JPRB, 0.57032847E-42_JPRB, 0.97250113E-42_JPRB, 0.16871634E-41_JPRB, 0.31599280E-41_JPRB, &
  & 0.62918301E-41_JPRB, 0.13225455E-40_JPRB, 0.28488398E-40_JPRB, 0.63166331E-40_JPRB, 0.14293665E-39_JPRB, 0.32903609E-39_JPRB, &
  & 0.76429200E-39_JPRB, 0.17828776E-38_JPRB, 0.40977316E-38_JPRB, 0.89556312E-38_JPRB, 0.19473562E-37_JPRB, 0.38635155E-37_JPRB, &
  & 0.70602411E-37_JPRB, 0.11309596E-36_JPRB, 0.14935679E-36_JPRB, 0.20218183E-36_JPRB, 0.29909734E-36_JPRB, 0.49734607E-36_JPRB, &
  & 0.71260291E-36_JPRB, 0.76017020E-36_JPRB, 0.74825038E-36_JPRB, 0.67629807E-36_JPRB, 0.68777016E-36_JPRB, 0.74725315E-36_JPRB, &
  & 0.62039263E-36_JPRB, 0.61289589E-36_JPRB, 0.54180584E-36_JPRB, 0.44944278E-36_JPRB, 0.45214494E-36_JPRB, 0.39158185E-36_JPRB, &
  & 0.35540528E-36_JPRB, 0.30123592E-36_JPRB, 0.23413807E-36_JPRB, 0.17643212E-36_JPRB, 0.12713991E-36_JPRB, 0.85964543E-37_JPRB, &
  & 0.55581741E-37_JPRB, 0.34536430E-37_JPRB, 0.21534938E-37_JPRB, 0.12804045E-37_JPRB, 0.72901586E-38_JPRB, 0.41519913E-38_JPRB, &
  & 0.22788182E-38_JPRB, 0.12610425E-38_JPRB, 0.68788200E-39_JPRB, 0.38718577E-39_JPRB, 0.23153094E-39_JPRB, 0.15155043E-39_JPRB, &
  & 0.11074322E-39_JPRB, 0.90043235E-40_JPRB, 0.79272855E-40_JPRB, 0.73285107E-40_JPRB, 0.69299814E-40_JPRB, 0.65535927E-40_JPRB, &
  & 0.60373543E-40_JPRB, 0.51387016E-40_JPRB, 0.37465116E-40_JPRB, 0.21242283E-40_JPRB /)

RGHG5(:, 4,10) = (/ &
  & 0.68677638E-41_JPRB, 0.25954850E-40_JPRB, 0.50194511E-40_JPRB, 0.83686946E-40_JPRB, 0.14450890E-39_JPRB, 0.27291128E-39_JPRB, &
  & 0.55479228E-39_JPRB, 0.11757034E-38_JPRB, 0.25918052E-38_JPRB, 0.58547049E-38_JPRB, 0.13512414E-37_JPRB, 0.31671049E-37_JPRB, &
  & 0.74199617E-37_JPRB, 0.17270646E-36_JPRB, 0.39295404E-36_JPRB, 0.84545812E-36_JPRB, 0.18041092E-35_JPRB, 0.35299599E-35_JPRB, &
  & 0.64008896E-35_JPRB, 0.10243803E-34_JPRB, 0.13389105E-34_JPRB, 0.17914412E-34_JPRB, 0.26369716E-34_JPRB, 0.44736264E-34_JPRB, &
  & 0.64498990E-34_JPRB, 0.67983453E-34_JPRB, 0.66493215E-34_JPRB, 0.60046903E-34_JPRB, 0.60958853E-34_JPRB, 0.66061084E-34_JPRB, &
  & 0.54881317E-34_JPRB, 0.54179792E-34_JPRB, 0.47886825E-34_JPRB, 0.39679354E-34_JPRB, 0.40011698E-34_JPRB, 0.34586789E-34_JPRB, &
  & 0.31450495E-34_JPRB, 0.26667085E-34_JPRB, 0.20731215E-34_JPRB, 0.15690297E-34_JPRB, 0.11353550E-34_JPRB, 0.77193022E-35_JPRB, &
  & 0.49891786E-35_JPRB, 0.30991890E-35_JPRB, 0.19366501E-35_JPRB, 0.11549293E-35_JPRB, 0.66174851E-36_JPRB, 0.38083086E-36_JPRB, &
  & 0.21154979E-36_JPRB, 0.11833422E-36_JPRB, 0.64948738E-37_JPRB, 0.36535643E-37_JPRB, 0.21716561E-37_JPRB, 0.14122736E-37_JPRB, &
  & 0.10292917E-37_JPRB, 0.84062802E-38_JPRB, 0.74519245E-38_JPRB, 0.69491624E-38_JPRB, 0.66343327E-38_JPRB, 0.63600425E-38_JPRB, &
  & 0.60120384E-38_JPRB, 0.53079322E-38_JPRB, 0.39139387E-38_JPRB, 0.18019073E-38_JPRB /)

RGHG5(:, 5,10) = (/ &
  & 0.27276597E-38_JPRB, 0.70990173E-38_JPRB, 0.12075328E-37_JPRB, 0.19398504E-37_JPRB, 0.33380734E-37_JPRB, 0.63199839E-37_JPRB, &
  & 0.12737413E-36_JPRB, 0.26884194E-36_JPRB, 0.58803416E-36_JPRB, 0.13265397E-35_JPRB, 0.30675215E-35_JPRB, 0.71690698E-35_JPRB, &
  & 0.16677890E-34_JPRB, 0.38282140E-34_JPRB, 0.85227875E-34_JPRB, 0.17897423E-33_JPRB, 0.37139340E-33_JPRB, 0.70849542E-33_JPRB, &
  & 0.12575214E-32_JPRB, 0.19791093E-32_JPRB, 0.25387824E-32_JPRB, 0.33245934E-32_JPRB, 0.48079409E-32_JPRB, 0.81156424E-32_JPRB, &
  & 0.11596629E-31_JPRB, 0.12024443E-31_JPRB, 0.11618739E-31_JPRB, 0.10388697E-31_JPRB, 0.10464545E-31_JPRB, 0.11288121E-31_JPRB, &
  & 0.93324355E-32_JPRB, 0.92117703E-32_JPRB, 0.81514230E-32_JPRB, 0.67505841E-32_JPRB, 0.68815629E-32_JPRB, 0.59586606E-32_JPRB, &
  & 0.54782717E-32_JPRB, 0.46854375E-32_JPRB, 0.36619918E-32_JPRB, 0.28026210E-32_JPRB, 0.20583635E-32_JPRB, 0.14173447E-32_JPRB, &
  & 0.92873246E-33_JPRB, 0.58522005E-33_JPRB, 0.37213378E-33_JPRB, 0.22600546E-33_JPRB, 0.13212664E-33_JPRB, 0.77738489E-34_JPRB, &
  & 0.44151401E-34_JPRB, 0.25204180E-34_JPRB, 0.14067835E-34_JPRB, 0.80101711E-35_JPRB, 0.47999246E-35_JPRB, 0.31401713E-35_JPRB, &
  & 0.23054939E-35_JPRB, 0.18975405E-35_JPRB, 0.16961745E-35_JPRB, 0.15925593E-35_JPRB, 0.15300362E-35_JPRB, 0.14786290E-35_JPRB, &
  & 0.14268262E-35_JPRB, 0.13418859E-35_JPRB, 0.11359823E-35_JPRB, 0.70366335E-36_JPRB /)

RGHG5(:, 6,10) = (/ &
  & 0.22400243E-35_JPRB, 0.44982221E-35_JPRB, 0.70145947E-35_JPRB, 0.11193326E-34_JPRB, 0.19210115E-34_JPRB, 0.35839824E-34_JPRB, &
  & 0.70197148E-34_JPRB, 0.14339425E-33_JPRB, 0.30219189E-33_JPRB, 0.65925424E-33_JPRB, 0.14703761E-32_JPRB, 0.33248167E-32_JPRB, &
  & 0.74709675E-32_JPRB, 0.16526803E-31_JPRB, 0.35366193E-31_JPRB, 0.71169847E-31_JPRB, 0.14105714E-30_JPRB, 0.25724434E-30_JPRB, &
  & 0.43656976E-30_JPRB, 0.65867199E-30_JPRB, 0.81187417E-30_JPRB, 0.10197264E-29_JPRB, 0.14156858E-29_JPRB, 0.23138073E-29_JPRB, &
  & 0.32129774E-29_JPRB, 0.32424114E-29_JPRB, 0.30585327E-29_JPRB, 0.26792322E-29_JPRB, 0.26531965E-29_JPRB, 0.28305343E-29_JPRB, &
  & 0.23195159E-29_JPRB, 0.22851776E-29_JPRB, 0.20259882E-29_JPRB, 0.16865574E-29_JPRB, 0.17443926E-29_JPRB, 0.15274588E-29_JPRB, &
  & 0.14347430E-29_JPRB, 0.12533836E-29_JPRB, 0.10004547E-29_JPRB, 0.78740146E-30_JPRB, 0.59701219E-30_JPRB, 0.42383822E-30_JPRB, &
  & 0.28728311E-30_JPRB, 0.18708155E-30_JPRB, 0.12381165E-30_JPRB, 0.78127998E-31_JPRB, 0.47541018E-31_JPRB, 0.29208302E-31_JPRB, &
  & 0.17312983E-31_JPRB, 0.10324227E-31_JPRB, 0.60092032E-32_JPRB, 0.35669884E-32_JPRB, 0.22251625E-32_JPRB, 0.15118566E-32_JPRB, &
  & 0.11456131E-32_JPRB, 0.96735076E-33_JPRB, 0.88069157E-33_JPRB, 0.83845679E-33_JPRB, 0.81382890E-33_JPRB, 0.79270233E-33_JPRB, &
  & 0.77211795E-33_JPRB, 0.74758268E-33_JPRB, 0.70386618E-33_JPRB, 0.58725884E-33_JPRB /)

RGHG5(:, 7,10) = (/ &
  & 0.22004801E-32_JPRB, 0.39687595E-32_JPRB, 0.60597968E-32_JPRB, 0.95144087E-32_JPRB, 0.15979260E-31_JPRB, 0.28617416E-31_JPRB, &
  & 0.53663692E-31_JPRB, 0.10351384E-30_JPRB, 0.20652420E-30_JPRB, 0.42309596E-30_JPRB, 0.88880491E-30_JPRB, 0.18932916E-29_JPRB, &
  & 0.40228813E-29_JPRB, 0.84411636E-29_JPRB, 0.17139758E-28_JPRB, 0.32649201E-28_JPRB, 0.61195299E-28_JPRB, 0.10537514E-27_JPRB, &
  & 0.16879601E-27_JPRB, 0.24057032E-27_JPRB, 0.28104812E-27_JPRB, 0.33400154E-27_JPRB, 0.44004028E-27_JPRB, 0.68718086E-27_JPRB, &
  & 0.91986728E-27_JPRB, 0.89765226E-27_JPRB, 0.82164341E-27_JPRB, 0.70029639E-27_JPRB, 0.67910726E-27_JPRB, 0.71439107E-27_JPRB, &
  & 0.57925237E-27_JPRB, 0.56892495E-27_JPRB, 0.50574073E-27_JPRB, 0.42446384E-27_JPRB, 0.44546293E-27_JPRB, 0.39693825E-27_JPRB, &
  & 0.38204287E-27_JPRB, 0.34334579E-27_JPRB, 0.28251358E-27_JPRB, 0.23099953E-27_JPRB, 0.18236452E-27_JPRB, 0.13532186E-27_JPRB, &
  & 0.95520853E-28_JPRB, 0.65148420E-28_JPRB, 0.45316650E-28_JPRB, 0.30016334E-28_JPRB, 0.19187209E-28_JPRB, 0.12459718E-28_JPRB, &
  & 0.78038576E-29_JPRB, 0.49427691E-29_JPRB, 0.30552879E-29_JPRB, 0.19334475E-29_JPRB, 0.12881913E-29_JPRB, 0.93088959E-30_JPRB, &
  & 0.74441810E-30_JPRB, 0.65514344E-30_JPRB, 0.61558241E-30_JPRB, 0.59999658E-30_JPRB, 0.59274124E-30_JPRB, 0.58482960E-30_JPRB, &
  & 0.57490137E-30_JPRB, 0.56083842E-30_JPRB, 0.53861104E-30_JPRB, 0.47643839E-30_JPRB /)

RGHG5(:, 8,10) = (/ &
  & 0.19331512E-29_JPRB, 0.33918211E-29_JPRB, 0.50392943E-29_JPRB, 0.77335973E-29_JPRB, 0.12481511E-28_JPRB, 0.21455750E-28_JPRB, &
  & 0.38154589E-28_JPRB, 0.69972772E-28_JPRB, 0.13118982E-27_JPRB, 0.25242124E-27_JPRB, 0.49542564E-27_JPRB, 0.98778549E-27_JPRB, &
  & 0.19710651E-26_JPRB, 0.39038172E-26_JPRB, 0.75051826E-26_JPRB, 0.13512522E-25_JPRB, 0.23957273E-25_JPRB, 0.38938698E-25_JPRB, &
  & 0.58799479E-25_JPRB, 0.79045823E-25_JPRB, 0.87175188E-25_JPRB, 0.97754405E-25_JPRB, 0.12183385E-24_JPRB, 0.18147012E-24_JPRB, &
  & 0.23381832E-24_JPRB, 0.22018833E-24_JPRB, 0.19515876E-24_JPRB, 0.16163250E-24_JPRB, 0.15334477E-24_JPRB, 0.15901957E-24_JPRB, &
  & 0.12751414E-24_JPRB, 0.12485472E-24_JPRB, 0.11127360E-24_JPRB, 0.94276169E-25_JPRB, 0.10028909E-24_JPRB, 0.91109083E-25_JPRB, &
  & 0.89835252E-25_JPRB, 0.83110613E-25_JPRB, 0.70791472E-25_JPRB, 0.60213291E-25_JPRB, 0.49804530E-25_JPRB, 0.38624309E-25_JPRB, &
  & 0.28673565E-25_JPRB, 0.20451083E-25_JPRB, 0.15018718E-25_JPRB, 0.10434239E-25_JPRB, 0.69963889E-26_JPRB, 0.48057133E-26_JPRB, &
  & 0.31789238E-26_JPRB, 0.21432619E-26_JPRB, 0.14093784E-26_JPRB, 0.95355430E-27_JPRB, 0.67940982E-27_JPRB, 0.52294482E-27_JPRB, &
  & 0.44078388E-27_JPRB, 0.40456638E-27_JPRB, 0.39227594E-27_JPRB, 0.39151972E-27_JPRB, 0.39363013E-27_JPRB, 0.39325260E-27_JPRB, &
  & 0.38981819E-27_JPRB, 0.38239840E-27_JPRB, 0.36897823E-27_JPRB, 0.32946792E-27_JPRB /)

RGHG5(:, 9,10) = (/ &
  & 0.14709918E-26_JPRB, 0.24944560E-26_JPRB, 0.36451987E-26_JPRB, 0.53993739E-26_JPRB, 0.84198560E-26_JPRB, 0.13848832E-25_JPRB, &
  & 0.23605247E-25_JPRB, 0.41117544E-25_JPRB, 0.73074589E-25_JPRB, 0.13219751E-24_JPRB, 0.24304735E-24_JPRB, 0.45318452E-24_JPRB, &
  & 0.84719332E-24_JPRB, 0.15799507E-23_JPRB, 0.28724625E-23_JPRB, 0.48859244E-23_JPRB, 0.82062045E-23_JPRB, 0.12602436E-22_JPRB, &
  & 0.17961326E-22_JPRB, 0.22780590E-22_JPRB, 0.23681305E-22_JPRB, 0.25017054E-22_JPRB, 0.29468619E-22_JPRB, 0.41862472E-22_JPRB, &
  & 0.51804540E-22_JPRB, 0.47019234E-22_JPRB, 0.40346278E-22_JPRB, 0.32459137E-22_JPRB, 0.30128333E-22_JPRB, 0.30804450E-22_JPRB, &
  & 0.24435705E-22_JPRB, 0.23856776E-22_JPRB, 0.21318223E-22_JPRB, 0.18231511E-22_JPRB, 0.19649452E-22_JPRB, 0.18211720E-22_JPRB, &
  & 0.18383783E-22_JPRB, 0.17511740E-22_JPRB, 0.15454983E-22_JPRB, 0.13702132E-22_JPRB, 0.11861221E-22_JPRB, 0.96903003E-23_JPRB, &
  & 0.75556056E-23_JPRB, 0.56723461E-23_JPRB, 0.44004594E-23_JPRB, 0.32069892E-23_JPRB, 0.22518875E-23_JPRB, 0.16358814E-23_JPRB, &
  & 0.11402913E-23_JPRB, 0.81764013E-24_JPRB, 0.57016884E-24_JPRB, 0.41070966E-24_JPRB, 0.31118640E-24_JPRB, 0.25294859E-24_JPRB, &
  & 0.22326578E-24_JPRB, 0.21233246E-24_JPRB, 0.21147174E-24_JPRB, 0.21524745E-24_JPRB, 0.21944266E-24_JPRB, 0.22128367E-24_JPRB, &
  & 0.22060451E-24_JPRB, 0.21733766E-24_JPRB, 0.20971953E-24_JPRB, 0.18962297E-24_JPRB /)

RGHG5(:,10,10) = (/ &
  & 0.93390994E-24_JPRB, 0.15655743E-23_JPRB, 0.22189111E-23_JPRB, 0.32105783E-23_JPRB, 0.48255939E-23_JPRB, 0.76529637E-23_JPRB, &
  & 0.12504947E-22_JPRB, 0.20835307E-22_JPRB, 0.35167337E-22_JPRB, 0.60109718E-22_JPRB, 0.10381984E-21_JPRB, 0.18129648E-21_JPRB, &
  & 0.31726956E-21_JPRB, 0.55592808E-21_JPRB, 0.95394776E-21_JPRB, 0.15304139E-20_JPRB, 0.24344483E-20_JPRB, 0.35321343E-20_JPRB, &
  & 0.47508892E-20_JPRB, 0.56839958E-20_JPRB, 0.55622040E-20_JPRB, 0.55307582E-20_JPRB, 0.61522709E-20_JPRB, 0.83234387E-20_JPRB, &
  & 0.98812944E-20_JPRB, 0.86393498E-20_JPRB, 0.71723587E-20_JPRB, 0.56082648E-20_JPRB, 0.50923205E-20_JPRB, 0.51334481E-20_JPRB, &
  & 0.40314961E-20_JPRB, 0.39253969E-20_JPRB, 0.35176764E-20_JPRB, 0.30364995E-20_JPRB, 0.33167784E-20_JPRB, 0.31366035E-20_JPRB, &
  & 0.32425050E-20_JPRB, 0.31800423E-20_JPRB, 0.29106369E-20_JPRB, 0.26882916E-20_JPRB, 0.24391175E-20_JPRB, 0.20961635E-20_JPRB, &
  & 0.17267367E-20_JPRB, 0.13656331E-20_JPRB, 0.11226489E-20_JPRB, 0.85995512E-21_JPRB, 0.63282987E-21_JPRB, 0.48684390E-21_JPRB, &
  & 0.35716333E-21_JPRB, 0.27190362E-21_JPRB, 0.20033774E-21_JPRB, 0.15279352E-21_JPRB, 0.12214257E-21_JPRB, 0.10408390E-21_JPRB, &
  & 0.95455956E-22_JPRB, 0.93521991E-22_JPRB, 0.95193436E-22_JPRB, 0.98392885E-22_JPRB, 0.10134361E-21_JPRB, 0.10284492E-21_JPRB, &
  & 0.10289344E-21_JPRB, 0.10142669E-21_JPRB, 0.98549793E-22_JPRB, 0.88437846E-22_JPRB /)

RGHG5(:,11,10) = (/ &
  & 0.49734643E-21_JPRB, 0.80894063E-21_JPRB, 0.11339257E-20_JPRB, 0.15929538E-20_JPRB, 0.23282396E-20_JPRB, 0.35656218E-20_JPRB, &
  & 0.56111918E-20_JPRB, 0.89570501E-20_JPRB, 0.14413002E-19_JPRB, 0.23353890E-19_JPRB, 0.38030592E-19_JPRB, 0.62373179E-19_JPRB, &
  & 0.10230110E-18_JPRB, 0.16832608E-18_JPRB, 0.27222162E-18_JPRB, 0.41118621E-18_JPRB, 0.61874676E-18_JPRB, 0.84732494E-18_JPRB, &
  & 0.10746927E-17_JPRB, 0.12119022E-17_JPRB, 0.11166190E-17_JPRB, 0.10455199E-17_JPRB, 0.10981839E-17_JPRB, 0.14140157E-17_JPRB, &
  & 0.16098098E-17_JPRB, 0.13563508E-17_JPRB, 0.10897279E-17_JPRB, 0.82857591E-18_JPRB, 0.73621018E-18_JPRB, 0.73206642E-18_JPRB, &
  & 0.56963421E-18_JPRB, 0.55356896E-18_JPRB, 0.49773774E-18_JPRB, 0.43372404E-18_JPRB, 0.48058754E-18_JPRB, 0.46368617E-18_JPRB, &
  & 0.49110370E-18_JPRB, 0.49582659E-18_JPRB, 0.47023331E-18_JPRB, 0.45206785E-18_JPRB, 0.42890150E-18_JPRB, 0.38758212E-18_JPRB, &
  & 0.33677382E-18_JPRB, 0.28129735E-18_JPRB, 0.24521529E-18_JPRB, 0.19800876E-18_JPRB, 0.15320590E-18_JPRB, 0.12499632E-18_JPRB, &
  & 0.96513747E-19_JPRB, 0.77889814E-19_JPRB, 0.60433085E-19_JPRB, 0.48581264E-19_JPRB, 0.40751318E-19_JPRB, 0.36195802E-19_JPRB, &
  & 0.34347021E-19_JPRB, 0.34546416E-19_JPRB, 0.35850828E-19_JPRB, 0.37565432E-19_JPRB, 0.39042957E-19_JPRB, 0.39828746E-19_JPRB, &
  & 0.39954778E-19_JPRB, 0.39497399E-19_JPRB, 0.38140784E-19_JPRB, 0.34878953E-19_JPRB /)

RGHG5(:,12,10) = (/ &
  & 0.21366835E-18_JPRB, 0.34651162E-18_JPRB, 0.47470711E-18_JPRB, 0.65668137E-18_JPRB, 0.93414220E-18_JPRB, 0.13894930E-17_JPRB, &
  & 0.21127291E-17_JPRB, 0.32425083E-17_JPRB, 0.49894236E-17_JPRB, 0.76907994E-17_JPRB, 0.11851324E-16_JPRB, 0.18317675E-16_JPRB, &
  & 0.28222357E-16_JPRB, 0.43638118E-16_JPRB, 0.66468687E-16_JPRB, 0.94380408E-16_JPRB, 0.13410208E-15_JPRB, 0.17306622E-15_JPRB, &
  & 0.20670080E-15_JPRB, 0.21948850E-15_JPRB, 0.19059787E-15_JPRB, 0.16821197E-15_JPRB, 0.16687155E-15_JPRB, 0.20417266E-15_JPRB, &
  & 0.22295749E-15_JPRB, 0.18112214E-15_JPRB, 0.14081964E-15_JPRB, 0.10408993E-15_JPRB, 0.90522213E-16_JPRB, 0.88777550E-16_JPRB, &
  & 0.68512478E-16_JPRB, 0.66454393E-16_JPRB, 0.59981288E-16_JPRB, 0.52750314E-16_JPRB, 0.59342705E-16_JPRB, 0.58404722E-16_JPRB, &
  & 0.63422254E-16_JPRB, 0.65930245E-16_JPRB, 0.64729179E-16_JPRB, 0.64704284E-16_JPRB, 0.64094215E-16_JPRB, 0.60759288E-16_JPRB, &
  & 0.55610003E-16_JPRB, 0.49093788E-16_JPRB, 0.45345700E-16_JPRB, 0.38728940E-16_JPRB, 0.31637263E-16_JPRB, 0.27384436E-16_JPRB, &
  & 0.22287703E-16_JPRB, 0.19020077E-16_JPRB, 0.15515739E-16_JPRB, 0.13094602E-16_JPRB, 0.11479256E-16_JPRB, 0.10590880E-16_JPRB, &
  & 0.10368409E-16_JPRB, 0.10686528E-16_JPRB, 0.11295950E-16_JPRB, 0.11995755E-16_JPRB, 0.12583199E-16_JPRB, 0.12913600E-16_JPRB, &
  & 0.12993175E-16_JPRB, 0.12841944E-16_JPRB, 0.12499469E-16_JPRB, 0.11242052E-16_JPRB /)

RGHG5(:,13,10) = (/ &
  & 0.41904887E-17_JPRB, 0.65293498E-17_JPRB, 0.87515576E-17_JPRB, 0.11559501E-16_JPRB, 0.15660309E-16_JPRB, 0.21958466E-16_JPRB, &
  & 0.31404914E-16_JPRB, 0.45225789E-16_JPRB, 0.65151028E-16_JPRB, 0.93642589E-16_JPRB, 0.13398140E-15_JPRB, 0.19159132E-15_JPRB, &
  & 0.27345786E-15_JPRB, 0.39260184E-15_JPRB, 0.57752242E-15_JPRB, 0.88039249E-15_JPRB, 0.12195306E-14_JPRB, 0.15764698E-14_JPRB, &
  & 0.18719038E-14_JPRB, 0.19690329E-14_JPRB, 0.16035114E-14_JPRB, 0.14858616E-14_JPRB, 0.15334077E-14_JPRB, 0.16035582E-14_JPRB, &
  & 0.19381530E-14_JPRB, 0.16167368E-14_JPRB, 0.13929599E-14_JPRB, 0.10646773E-14_JPRB, 0.95098168E-15_JPRB, 0.80294102E-15_JPRB, &
  & 0.67304936E-15_JPRB, 0.61311829E-15_JPRB, 0.54659915E-15_JPRB, 0.60174285E-15_JPRB, 0.63460148E-15_JPRB, 0.69649762E-15_JPRB, &
  & 0.77828638E-15_JPRB, 0.83793693E-15_JPRB, 0.88101697E-15_JPRB, 0.90671235E-15_JPRB, 0.92211670E-15_JPRB, 0.90406833E-15_JPRB, &
  & 0.84908250E-15_JPRB, 0.76810493E-15_JPRB, 0.70007093E-15_JPRB, 0.62772929E-15_JPRB, 0.52093289E-15_JPRB, 0.45042142E-15_JPRB, &
  & 0.38612706E-15_JPRB, 0.32948028E-15_JPRB, 0.27982490E-15_JPRB, 0.24365112E-15_JPRB, 0.21790940E-15_JPRB, 0.20159247E-15_JPRB, &
  & 0.19465180E-15_JPRB, 0.19302180E-15_JPRB, 0.19534838E-15_JPRB, 0.19798704E-15_JPRB, 0.19987099E-15_JPRB, 0.19878143E-15_JPRB, &
  & 0.19497523E-15_JPRB, 0.18914506E-15_JPRB, 0.17852763E-15_JPRB, 0.16096786E-15_JPRB /)

RGHG5(:,14,10) = (/ &
  & 0.57298861E-16_JPRB, 0.91363779E-16_JPRB, 0.12122103E-15_JPRB, 0.15868360E-15_JPRB, 0.21032365E-15_JPRB, 0.28656723E-15_JPRB, &
  & 0.39616647E-15_JPRB, 0.54927583E-15_JPRB, 0.75767542E-15_JPRB, 0.10358466E-14_JPRB, 0.13970252E-14_JPRB, 0.18642475E-14_JPRB, &
  & 0.24587518E-14_JPRB, 0.32194877E-14_JPRB, 0.42162064E-14_JPRB, 0.56199459E-14_JPRB, 0.79320451E-14_JPRB, 0.11320809E-13_JPRB, &
  & 0.13615787E-13_JPRB, 0.14346373E-13_JPRB, 0.12649188E-13_JPRB, 0.12399676E-13_JPRB, 0.12099914E-13_JPRB, 0.13282474E-13_JPRB, &
  & 0.15043759E-13_JPRB, 0.13741091E-13_JPRB, 0.10515867E-13_JPRB, 0.93318577E-14_JPRB, 0.79005855E-14_JPRB, 0.68124522E-14_JPRB, &
  & 0.59418828E-14_JPRB, 0.51539168E-14_JPRB, 0.53755044E-14_JPRB, 0.54211218E-14_JPRB, 0.59559706E-14_JPRB, 0.68319556E-14_JPRB, &
  & 0.79542416E-14_JPRB, 0.87868860E-14_JPRB, 0.93129511E-14_JPRB, 0.96313279E-14_JPRB, 0.96478408E-14_JPRB, 0.94614427E-14_JPRB, &
  & 0.90921228E-14_JPRB, 0.83275096E-14_JPRB, 0.76322166E-14_JPRB, 0.67150286E-14_JPRB, 0.60103031E-14_JPRB, 0.51125680E-14_JPRB, &
  & 0.45768333E-14_JPRB, 0.39704708E-14_JPRB, 0.34959197E-14_JPRB, 0.31237038E-14_JPRB, 0.28308955E-14_JPRB, 0.26204254E-14_JPRB, &
  & 0.24780055E-14_JPRB, 0.23791347E-14_JPRB, 0.23186989E-14_JPRB, 0.22583499E-14_JPRB, 0.21987241E-14_JPRB, 0.21210097E-14_JPRB, &
  & 0.20248560E-14_JPRB, 0.19128714E-14_JPRB, 0.17847124E-14_JPRB, 0.15168315E-14_JPRB /)

RGHG5(:,15,10) = (/ &
  & 0.56505563E-15_JPRB, 0.90955658E-15_JPRB, 0.12165264E-14_JPRB, 0.15872007E-14_JPRB, 0.20901156E-14_JPRB, 0.28088438E-14_JPRB, &
  & 0.38177164E-14_JPRB, 0.51939781E-14_JPRB, 0.70145289E-14_JPRB, 0.93574660E-14_JPRB, 0.12259714E-13_JPRB, 0.15794344E-13_JPRB, &
  & 0.19968966E-13_JPRB, 0.24876030E-13_JPRB, 0.30441361E-13_JPRB, 0.36584508E-13_JPRB, 0.43293585E-13_JPRB, 0.54329713E-13_JPRB, &
  & 0.74053394E-13_JPRB, 0.84063256E-13_JPRB, 0.86015478E-13_JPRB, 0.91228450E-13_JPRB, 0.97330482E-13_JPRB, 0.10022946E-12_JPRB, &
  & 0.89933093E-13_JPRB, 0.78048137E-13_JPRB, 0.71264406E-13_JPRB, 0.63646598E-13_JPRB, 0.53608817E-13_JPRB, 0.45405493E-13_JPRB, &
  & 0.39847127E-13_JPRB, 0.36070115E-13_JPRB, 0.36244259E-13_JPRB, 0.40098414E-13_JPRB, 0.44784373E-13_JPRB, 0.49504326E-13_JPRB, &
  & 0.55352180E-13_JPRB, 0.61773361E-13_JPRB, 0.67671590E-13_JPRB, 0.71764433E-13_JPRB, 0.73650179E-13_JPRB, 0.72898834E-13_JPRB, &
  & 0.70694007E-13_JPRB, 0.66501790E-13_JPRB, 0.60982679E-13_JPRB, 0.54798617E-13_JPRB, 0.49161823E-13_JPRB, 0.43746480E-13_JPRB, &
  & 0.38937745E-13_JPRB, 0.34792810E-13_JPRB, 0.31346020E-13_JPRB, 0.28463973E-13_JPRB, 0.25987571E-13_JPRB, 0.23927883E-13_JPRB, &
  & 0.22193209E-13_JPRB, 0.20742905E-13_JPRB, 0.19482191E-13_JPRB, 0.18378755E-13_JPRB, 0.17261239E-13_JPRB, 0.16199525E-13_JPRB, &
  & 0.15089917E-13_JPRB, 0.14034558E-13_JPRB, 0.12805215E-13_JPRB, 0.10660680E-13_JPRB /)

RGHG5(:,16,10) = (/ &
  & 0.40214880E-14_JPRB, 0.65039120E-14_JPRB, 0.86740062E-14_JPRB, 0.11283208E-13_JPRB, 0.14751607E-13_JPRB, 0.19606156E-13_JPRB, &
  & 0.26301444E-13_JPRB, 0.35322568E-13_JPRB, 0.47128608E-13_JPRB, 0.62162928E-13_JPRB, 0.80578027E-13_JPRB, 0.10266281E-12_JPRB, &
  & 0.12829668E-12_JPRB, 0.15781980E-12_JPRB, 0.19096549E-12_JPRB, 0.22733441E-12_JPRB, 0.26422275E-12_JPRB, 0.29787292E-12_JPRB, &
  & 0.34576549E-12_JPRB, 0.41775237E-12_JPRB, 0.47708929E-12_JPRB, 0.51269666E-12_JPRB, 0.52759555E-12_JPRB, 0.52214065E-12_JPRB, &
  & 0.49722027E-12_JPRB, 0.46094086E-12_JPRB, 0.40581343E-12_JPRB, 0.33913871E-12_JPRB, 0.28281140E-12_JPRB, 0.24011126E-12_JPRB, &
  & 0.21085881E-12_JPRB, 0.19356183E-12_JPRB, 0.18785483E-12_JPRB, 0.19189302E-12_JPRB, 0.20892180E-12_JPRB, 0.24321924E-12_JPRB, &
  & 0.28526996E-12_JPRB, 0.32656465E-12_JPRB, 0.36269731E-12_JPRB, 0.39054084E-12_JPRB, 0.40607296E-12_JPRB, 0.40727412E-12_JPRB, &
  & 0.39643416E-12_JPRB, 0.37449322E-12_JPRB, 0.34678215E-12_JPRB, 0.31687055E-12_JPRB, 0.28829234E-12_JPRB, 0.26239173E-12_JPRB, &
  & 0.23924176E-12_JPRB, 0.21896567E-12_JPRB, 0.20100794E-12_JPRB, 0.18460679E-12_JPRB, 0.16926623E-12_JPRB, 0.15519935E-12_JPRB, &
  & 0.14213286E-12_JPRB, 0.13012020E-12_JPRB, 0.11918294E-12_JPRB, 0.10926461E-12_JPRB, 0.10004858E-12_JPRB, 0.91944932E-13_JPRB, &
  & 0.84350360E-13_JPRB, 0.77874481E-13_JPRB, 0.69608720E-13_JPRB, 0.57447170E-13_JPRB /)

RGHG5(:,17,10) = (/ &
  & 0.21480447E-13_JPRB, 0.34074394E-13_JPRB, 0.44815090E-13_JPRB, 0.57562055E-13_JPRB, 0.74161516E-13_JPRB, 0.96799942E-13_JPRB, &
  & 0.12731884E-12_JPRB, 0.16758194E-12_JPRB, 0.21933563E-12_JPRB, 0.28420509E-12_JPRB, 0.36272707E-12_JPRB, 0.45582928E-12_JPRB, &
  & 0.56310468E-12_JPRB, 0.68608313E-12_JPRB, 0.82546226E-12_JPRB, 0.98042744E-12_JPRB, 0.11526777E-11_JPRB, 0.13358671E-11_JPRB, &
  & 0.15024698E-11_JPRB, 0.16741022E-11_JPRB, 0.18495383E-11_JPRB, 0.19842353E-11_JPRB, 0.20498369E-11_JPRB, 0.20393895E-11_JPRB, &
  & 0.19508718E-11_JPRB, 0.17888938E-11_JPRB, 0.15727996E-11_JPRB, 0.13610020E-11_JPRB, 0.11557036E-11_JPRB, 0.10118735E-11_JPRB, &
  & 0.90547264E-12_JPRB, 0.84242455E-12_JPRB, 0.82238470E-12_JPRB, 0.85377782E-12_JPRB, 0.93135341E-12_JPRB, 0.10343416E-11_JPRB, &
  & 0.11609312E-11_JPRB, 0.13048179E-11_JPRB, 0.14439550E-11_JPRB, 0.15591015E-11_JPRB, 0.16315423E-11_JPRB, 0.16488865E-11_JPRB, &
  & 0.16177314E-11_JPRB, 0.15478003E-11_JPRB, 0.14551522E-11_JPRB, 0.13541644E-11_JPRB, 0.12565282E-11_JPRB, 0.11670792E-11_JPRB, &
  & 0.10860923E-11_JPRB, 0.10128589E-11_JPRB, 0.94363601E-12_JPRB, 0.87553272E-12_JPRB, 0.80724327E-12_JPRB, 0.73928450E-12_JPRB, &
  & 0.67247569E-12_JPRB, 0.60886463E-12_JPRB, 0.55049379E-12_JPRB, 0.49617894E-12_JPRB, 0.44775492E-12_JPRB, 0.40551763E-12_JPRB, &
  & 0.36924663E-12_JPRB, 0.33597368E-12_JPRB, 0.30032408E-12_JPRB, 0.24282280E-12_JPRB /)

RGHG5(:,18,10) = (/ &
  & 0.88483149E-13_JPRB, 0.13482946E-12_JPRB, 0.17409197E-12_JPRB, 0.21911685E-12_JPRB, 0.27729940E-12_JPRB, 0.35439371E-12_JPRB, &
  & 0.45577257E-12_JPRB, 0.58613617E-12_JPRB, 0.74932871E-12_JPRB, 0.94854777E-12_JPRB, 0.11838434E-11_JPRB, 0.14560844E-11_JPRB, &
  & 0.17625240E-11_JPRB, 0.21053335E-11_JPRB, 0.24830376E-11_JPRB, 0.28967098E-11_JPRB, 0.33386464E-11_JPRB, 0.38245618E-11_JPRB, &
  & 0.43287062E-11_JPRB, 0.48110691E-11_JPRB, 0.52643870E-11_JPRB, 0.56363568E-11_JPRB, 0.58494923E-11_JPRB, 0.58857372E-11_JPRB, &
  & 0.57226173E-11_JPRB, 0.53655938E-11_JPRB, 0.48873800E-11_JPRB, 0.43606759E-11_JPRB, 0.38519886E-11_JPRB, 0.34266266E-11_JPRB, &
  & 0.31217461E-11_JPRB, 0.29301245E-11_JPRB, 0.28415352E-11_JPRB, 0.28646315E-11_JPRB, 0.29854368E-11_JPRB, 0.32218180E-11_JPRB, &
  & 0.35619875E-11_JPRB, 0.39548100E-11_JPRB, 0.43515482E-11_JPRB, 0.46939340E-11_JPRB, 0.49295797E-11_JPRB, 0.50187684E-11_JPRB, &
  & 0.49751219E-11_JPRB, 0.48247842E-11_JPRB, 0.46058899E-11_JPRB, 0.43597096E-11_JPRB, 0.41142107E-11_JPRB, 0.38832032E-11_JPRB, &
  & 0.36668498E-11_JPRB, 0.34600478E-11_JPRB, 0.32520828E-11_JPRB, 0.30346205E-11_JPRB, 0.28052452E-11_JPRB, 0.25677039E-11_JPRB, &
  & 0.23305108E-11_JPRB, 0.21031306E-11_JPRB, 0.18951533E-11_JPRB, 0.17058373E-11_JPRB, 0.15381578E-11_JPRB, 0.13908418E-11_JPRB, &
  & 0.12615269E-11_JPRB, 0.11434743E-11_JPRB, 0.10207503E-11_JPRB, 0.82773832E-12_JPRB /)

RGHG5(:,19,10) = (/ &
  & 0.28184228E-12_JPRB, 0.41392719E-12_JPRB, 0.51854072E-12_JPRB, 0.64082409E-12_JPRB, 0.79300948E-12_JPRB, 0.99252822E-12_JPRB, &
  & 0.12488905E-11_JPRB, 0.15712802E-11_JPRB, 0.19656655E-11_JPRB, 0.24360243E-11_JPRB, 0.29790172E-11_JPRB, 0.35936805E-11_JPRB, &
  & 0.42718351E-11_JPRB, 0.50156138E-11_JPRB, 0.58187331E-11_JPRB, 0.66764814E-11_JPRB, 0.75843351E-11_JPRB, 0.85475802E-11_JPRB, &
  & 0.95648793E-11_JPRB, 0.10590334E-10_JPRB, 0.11562562E-10_JPRB, 0.12412896E-10_JPRB, 0.13019107E-10_JPRB, 0.13304066E-10_JPRB, &
  & 0.13188357E-10_JPRB, 0.12704800E-10_JPRB, 0.11966313E-10_JPRB, 0.11095907E-10_JPRB, 0.10192851E-10_JPRB, 0.93639783E-11_JPRB, &
  & 0.86833119E-11_JPRB, 0.81681207E-11_JPRB, 0.78480980E-11_JPRB, 0.77364105E-11_JPRB, 0.78695592E-11_JPRB, 0.82534674E-11_JPRB, &
  & 0.88298310E-11_JPRB, 0.95595303E-11_JPRB, 0.10368735E-10_JPRB, 0.11104621E-10_JPRB, 0.11668868E-10_JPRB, 0.11936094E-10_JPRB, &
  & 0.11960213E-10_JPRB, 0.11741625E-10_JPRB, 0.11362387E-10_JPRB, 0.10904431E-10_JPRB, 0.10425344E-10_JPRB, 0.99519542E-11_JPRB, &
  & 0.94830723E-11_JPRB, 0.90128833E-11_JPRB, 0.85233825E-11_JPRB, 0.79999375E-11_JPRB, 0.74375896E-11_JPRB, 0.68453602E-11_JPRB, &
  & 0.62435881E-11_JPRB, 0.56659994E-11_JPRB, 0.51170999E-11_JPRB, 0.46188201E-11_JPRB, 0.41793622E-11_JPRB, 0.37970855E-11_JPRB, &
  & 0.34576855E-11_JPRB, 0.31535291E-11_JPRB, 0.28158079E-11_JPRB, 0.23078562E-11_JPRB /)

RGHG5(:,20,10) = (/ &
  & 0.72379559E-12_JPRB, 0.10103444E-11_JPRB, 0.12415801E-11_JPRB, 0.14947405E-11_JPRB, 0.18140259E-11_JPRB, 0.22191528E-11_JPRB, &
  & 0.27318115E-11_JPRB, 0.33647933E-11_JPRB, 0.41251859E-11_JPRB, 0.50139819E-11_JPRB, 0.60226867E-11_JPRB, 0.71433341E-11_JPRB, &
  & 0.83595552E-11_JPRB, 0.96716003E-11_JPRB, 0.11070860E-10_JPRB, 0.12548454E-10_JPRB, 0.14090073E-10_JPRB, 0.15718128E-10_JPRB, &
  & 0.17416062E-10_JPRB, 0.19174093E-10_JPRB, 0.20912518E-10_JPRB, 0.22516145E-10_JPRB, 0.23797391E-10_JPRB, 0.24679175E-10_JPRB, &
  & 0.25029987E-10_JPRB, 0.24802100E-10_JPRB, 0.24080475E-10_JPRB, 0.23048395E-10_JPRB, 0.21891530E-10_JPRB, 0.20661785E-10_JPRB, &
  & 0.19480152E-10_JPRB, 0.18425619E-10_JPRB, 0.17591739E-10_JPRB, 0.17062565E-10_JPRB, 0.16950202E-10_JPRB, 0.17234126E-10_JPRB, &
  & 0.17991178E-10_JPRB, 0.19152735E-10_JPRB, 0.20457924E-10_JPRB, 0.21721795E-10_JPRB, 0.22709274E-10_JPRB, 0.23341990E-10_JPRB, &
  & 0.23498790E-10_JPRB, 0.23253960E-10_JPRB, 0.22712519E-10_JPRB, 0.21989249E-10_JPRB, 0.21181019E-10_JPRB, 0.20334448E-10_JPRB, &
  & 0.19468659E-10_JPRB, 0.18584707E-10_JPRB, 0.17659235E-10_JPRB, 0.16666168E-10_JPRB, 0.15602290E-10_JPRB, 0.14490320E-10_JPRB, &
  & 0.13369957E-10_JPRB, 0.12265333E-10_JPRB, 0.11205509E-10_JPRB, 0.10218209E-10_JPRB, 0.93210639E-11_JPRB, 0.85169285E-11_JPRB, &
  & 0.78100989E-11_JPRB, 0.71293067E-11_JPRB, 0.64732004E-11_JPRB, 0.52822096E-11_JPRB /)

RGHG5(:,21,10) = (/ &
  & 0.15388279E-11_JPRB, 0.20835482E-11_JPRB, 0.24910731E-11_JPRB, 0.29465601E-11_JPRB, 0.34929980E-11_JPRB, 0.41832800E-11_JPRB, &
  & 0.50391540E-11_JPRB, 0.60804604E-11_JPRB, 0.73135456E-11_JPRB, 0.87380519E-11_JPRB, 0.10332719E-10_JPRB, 0.12083298E-10_JPRB, &
  & 0.13960901E-10_JPRB, 0.15959850E-10_JPRB, 0.18066510E-10_JPRB, 0.20274785E-10_JPRB, 0.22572756E-10_JPRB, 0.24979522E-10_JPRB, &
  & 0.27499759E-10_JPRB, 0.30113113E-10_JPRB, 0.32778197E-10_JPRB, 0.35362175E-10_JPRB, 0.37683155E-10_JPRB, 0.39538005E-10_JPRB, &
  & 0.40703226E-10_JPRB, 0.41130120E-10_JPRB, 0.40915455E-10_JPRB, 0.40200010E-10_JPRB, 0.39115725E-10_JPRB, 0.37785004E-10_JPRB, &
  & 0.36236798E-10_JPRB, 0.34587957E-10_JPRB, 0.33043946E-10_JPRB, 0.31842851E-10_JPRB, 0.31244889E-10_JPRB, 0.31317927E-10_JPRB, &
  & 0.32065014E-10_JPRB, 0.33372041E-10_JPRB, 0.35065610E-10_JPRB, 0.36797922E-10_JPRB, 0.38252960E-10_JPRB, 0.39137939E-10_JPRB, &
  & 0.39462697E-10_JPRB, 0.39191844E-10_JPRB, 0.38447009E-10_JPRB, 0.37372352E-10_JPRB, 0.36111520E-10_JPRB, 0.34759629E-10_JPRB, &
  & 0.33360415E-10_JPRB, 0.31922579E-10_JPRB, 0.30418626E-10_JPRB, 0.28837934E-10_JPRB, 0.27193666E-10_JPRB, 0.25513234E-10_JPRB, &
  & 0.23823254E-10_JPRB, 0.22134582E-10_JPRB, 0.20497767E-10_JPRB, 0.18946848E-10_JPRB, 0.17501027E-10_JPRB, 0.16168379E-10_JPRB, &
  & 0.14926633E-10_JPRB, 0.13805539E-10_JPRB, 0.12480158E-10_JPRB, 0.10548547E-10_JPRB /)

RGHG5(:,22,10) = (/ &
  & 0.28697084E-11_JPRB, 0.37387502E-11_JPRB, 0.44123446E-11_JPRB, 0.50985154E-11_JPRB, 0.59332994E-11_JPRB, 0.69537713E-11_JPRB, &
  & 0.82022635E-11_JPRB, 0.97037352E-11_JPRB, 0.11467266E-10_JPRB, 0.13483993E-10_JPRB, 0.15731494E-10_JPRB, 0.18177373E-10_JPRB, &
  & 0.20784752E-10_JPRB, 0.23533987E-10_JPRB, 0.26407288E-10_JPRB, 0.29389338E-10_JPRB, 0.32481223E-10_JPRB, 0.35714126E-10_JPRB, &
  & 0.39100327E-10_JPRB, 0.42642292E-10_JPRB, 0.46326734E-10_JPRB, 0.50016241E-10_JPRB, 0.53481719E-10_JPRB, 0.56523685E-10_JPRB, &
  & 0.58905263E-10_JPRB, 0.60439570E-10_JPRB, 0.61157898E-10_JPRB, 0.61140815E-10_JPRB, 0.60496656E-10_JPRB, 0.59323955E-10_JPRB, &
  & 0.57688750E-10_JPRB, 0.55694029E-10_JPRB, 0.53524931E-10_JPRB, 0.51603315E-10_JPRB, 0.50332658E-10_JPRB, 0.49851932E-10_JPRB, &
  & 0.50349471E-10_JPRB, 0.51726179E-10_JPRB, 0.53583853E-10_JPRB, 0.55543670E-10_JPRB, 0.57237760E-10_JPRB, 0.58314409E-10_JPRB, &
  & 0.58634410E-10_JPRB, 0.58253971E-10_JPRB, 0.57263572E-10_JPRB, 0.55763637E-10_JPRB, 0.53939186E-10_JPRB, 0.51980829E-10_JPRB, &
  & 0.49923260E-10_JPRB, 0.47816411E-10_JPRB, 0.45669486E-10_JPRB, 0.43487870E-10_JPRB, 0.41283962E-10_JPRB, 0.39090398E-10_JPRB, &
  & 0.36876127E-10_JPRB, 0.34684155E-10_JPRB, 0.32550022E-10_JPRB, 0.30491439E-10_JPRB, 0.28525016E-10_JPRB, 0.26659643E-10_JPRB, &
  & 0.24918831E-10_JPRB, 0.23153156E-10_JPRB, 0.21370445E-10_JPRB, 0.18065022E-10_JPRB /)

RGHG5(:,23,10) = (/ &
  & 0.48492798E-11_JPRB, 0.61190519E-11_JPRB, 0.70821977E-11_JPRB, 0.80513773E-11_JPRB, 0.91842905E-11_JPRB, 0.10555047E-10_JPRB, &
  & 0.12208690E-10_JPRB, 0.14176597E-10_JPRB, 0.16472740E-10_JPRB, 0.19094039E-10_JPRB, 0.22003625E-10_JPRB, 0.25167953E-10_JPRB, &
  & 0.28531970E-10_JPRB, 0.32064199E-10_JPRB, 0.35732389E-10_JPRB, 0.39510086E-10_JPRB, 0.43403621E-10_JPRB, 0.47446932E-10_JPRB, &
  & 0.51703725E-10_JPRB, 0.56148461E-10_JPRB, 0.60785592E-10_JPRB, 0.65557650E-10_JPRB, 0.70178523E-10_JPRB, 0.74462603E-10_JPRB, &
  & 0.78071730E-10_JPRB, 0.80819518E-10_JPRB, 0.82647451E-10_JPRB, 0.83581794E-10_JPRB, 0.83679876E-10_JPRB, 0.82999073E-10_JPRB, &
  & 0.81585391E-10_JPRB, 0.79540298E-10_JPRB, 0.77135714E-10_JPRB, 0.74767324E-10_JPRB, 0.72998371E-10_JPRB, 0.72071973E-10_JPRB, &
  & 0.72166537E-10_JPRB, 0.73221901E-10_JPRB, 0.74879394E-10_JPRB, 0.76738990E-10_JPRB, 0.78333111E-10_JPRB, 0.79381009E-10_JPRB, &
  & 0.79613330E-10_JPRB, 0.78954655E-10_JPRB, 0.77531127E-10_JPRB, 0.75543960E-10_JPRB, 0.73126977E-10_JPRB, 0.70498996E-10_JPRB, &
  & 0.67770775E-10_JPRB, 0.65003294E-10_JPRB, 0.62217224E-10_JPRB, 0.59461061E-10_JPRB, 0.56762220E-10_JPRB, 0.54134964E-10_JPRB, &
  & 0.51552949E-10_JPRB, 0.49021440E-10_JPRB, 0.46536663E-10_JPRB, 0.44093264E-10_JPRB, 0.41704543E-10_JPRB, 0.39383281E-10_JPRB, &
  & 0.37119776E-10_JPRB, 0.34929983E-10_JPRB, 0.32304062E-10_JPRB, 0.28062620E-10_JPRB /)

RGHG5(:,24,10) = (/ &
  & 0.76143614E-11_JPRB, 0.93642689E-11_JPRB, 0.10642237E-10_JPRB, 0.11889931E-10_JPRB, 0.13327447E-10_JPRB, 0.15035445E-10_JPRB, &
  & 0.17073242E-10_JPRB, 0.19485221E-10_JPRB, 0.22287359E-10_JPRB, 0.25480409E-10_JPRB, 0.29034377E-10_JPRB, 0.32901418E-10_JPRB, &
  & 0.37019530E-10_JPRB, 0.41340924E-10_JPRB, 0.45815976E-10_JPRB, 0.50393221E-10_JPRB, 0.55075187E-10_JPRB, 0.59897039E-10_JPRB, &
  & 0.64928445E-10_JPRB, 0.70206486E-10_JPRB, 0.75711944E-10_JPRB, 0.81373817E-10_JPRB, 0.86981568E-10_JPRB, 0.92281294E-10_JPRB, &
  & 0.96916836E-10_JPRB, 0.10067651E-09_JPRB, 0.10350006E-09_JPRB, 0.10541390E-09_JPRB, 0.10640174E-09_JPRB, 0.10646504E-09_JPRB, &
  & 0.10560999E-09_JPRB, 0.10392378E-09_JPRB, 0.10166828E-09_JPRB, 0.99337073E-10_JPRB, 0.97326543E-10_JPRB, 0.96040023E-10_JPRB, &
  & 0.95767394E-10_JPRB, 0.96356374E-10_JPRB, 0.97557303E-10_JPRB, 0.98972316E-10_JPRB, 0.10016742E-09_JPRB, 0.10082171E-09_JPRB, &
  & 0.10073570E-09_JPRB, 0.99755371E-10_JPRB, 0.97869469E-10_JPRB, 0.95310849E-10_JPRB, 0.92286623E-10_JPRB, 0.89014088E-10_JPRB, &
  & 0.85609381E-10_JPRB, 0.82204007E-10_JPRB, 0.78857365E-10_JPRB, 0.75638364E-10_JPRB, 0.72589199E-10_JPRB, 0.69666814E-10_JPRB, &
  & 0.66862973E-10_JPRB, 0.64147285E-10_JPRB, 0.61475325E-10_JPRB, 0.58812781E-10_JPRB, 0.56148249E-10_JPRB, 0.53492790E-10_JPRB, &
  & 0.50867963E-10_JPRB, 0.48152315E-10_JPRB, 0.45122434E-10_JPRB, 0.39687850E-10_JPRB /)

RGHG5(:,25,10) = (/ &
  & 0.11342038E-10_JPRB, 0.13680994E-10_JPRB, 0.15254428E-10_JPRB, 0.16782593E-10_JPRB, 0.18491949E-10_JPRB, 0.20509421E-10_JPRB, &
  & 0.22897094E-10_JPRB, 0.25704171E-10_JPRB, 0.28964811E-10_JPRB, 0.32679283E-10_JPRB, 0.36826150E-10_JPRB, 0.41357265E-10_JPRB, &
  & 0.46195273E-10_JPRB, 0.51282478E-10_JPRB, 0.56546091E-10_JPRB, 0.61914883E-10_JPRB, 0.67357515E-10_JPRB, 0.72905210E-10_JPRB, &
  & 0.78627910E-10_JPRB, 0.84556834E-10_JPRB, 0.90731922E-10_JPRB, 0.97054219E-10_JPRB, 0.10336364E-09_JPRB, 0.10938388E-09_JPRB, &
  & 0.11482110E-09_JPRB, 0.11945415E-09_JPRB, 0.12316480E-09_JPRB, 0.12585706E-09_JPRB, 0.12757227E-09_JPRB, 0.12833497E-09_JPRB, &
  & 0.12815868E-09_JPRB, 0.12710286E-09_JPRB, 0.12537094E-09_JPRB, 0.12341669E-09_JPRB, 0.12155851E-09_JPRB, 0.12017476E-09_JPRB, &
  & 0.11952303E-09_JPRB, 0.11955280E-09_JPRB, 0.12015568E-09_JPRB, 0.12091478E-09_JPRB, 0.12148653E-09_JPRB, 0.12152067E-09_JPRB, &
  & 0.12088300E-09_JPRB, 0.11944495E-09_JPRB, 0.11712552E-09_JPRB, 0.11408132E-09_JPRB, 0.11052783E-09_JPRB, 0.10672388E-09_JPRB, &
  & 0.10281657E-09_JPRB, 0.98914890E-10_JPRB, 0.95102440E-10_JPRB, 0.91505248E-10_JPRB, 0.88128803E-10_JPRB, 0.84982466E-10_JPRB, &
  & 0.82027017E-10_JPRB, 0.79194103E-10_JPRB, 0.76414625E-10_JPRB, 0.73635383E-10_JPRB, 0.70835615E-10_JPRB, 0.68010757E-10_JPRB, &
  & 0.65160349E-10_JPRB, 0.62199898E-10_JPRB, 0.58765021E-10_JPRB, 0.52546342E-10_JPRB /)

RGHG5(:,26,10) = (/ &
  & 0.16253797E-10_JPRB, 0.19303980E-10_JPRB, 0.21173559E-10_JPRB, 0.22944868E-10_JPRB, 0.24905347E-10_JPRB, 0.27180291E-10_JPRB, &
  & 0.29869173E-10_JPRB, 0.33022154E-10_JPRB, 0.36669459E-10_JPRB, 0.40843183E-10_JPRB, 0.45511404E-10_JPRB, 0.50637345E-10_JPRB, &
  & 0.56134947E-10_JPRB, 0.61932535E-10_JPRB, 0.67930959E-10_JPRB, 0.74030532E-10_JPRB, 0.80204482E-10_JPRB, 0.86398118E-10_JPRB, &
  & 0.92684103E-10_JPRB, 0.99117201E-10_JPRB, 0.10572639E-09_JPRB, 0.11246742E-09_JPRB, 0.11915749E-09_JPRB, 0.12559409E-09_JPRB, &
  & 0.13152628E-09_JPRB, 0.13664854E-09_JPRB, 0.14087528E-09_JPRB, 0.14417401E-09_JPRB, 0.14652130E-09_JPRB, 0.14792903E-09_JPRB, &
  & 0.14843826E-09_JPRB, 0.14812244E-09_JPRB, 0.14711127E-09_JPRB, 0.14575260E-09_JPRB, 0.14434881E-09_JPRB, 0.14308642E-09_JPRB, &
  & 0.14216420E-09_JPRB, 0.14171220E-09_JPRB, 0.14159170E-09_JPRB, 0.14156971E-09_JPRB, 0.14140651E-09_JPRB, 0.14078794E-09_JPRB, &
  & 0.13955746E-09_JPRB, 0.13759086E-09_JPRB, 0.13481243E-09_JPRB, 0.13132490E-09_JPRB, 0.12730952E-09_JPRB, 0.12299486E-09_JPRB, &
  & 0.11858681E-09_JPRB, 0.11426391E-09_JPRB, 0.11015411E-09_JPRB, 0.10633433E-09_JPRB, 0.10280138E-09_JPRB, 0.99546427E-10_JPRB, &
  & 0.96508579E-10_JPRB, 0.93607053E-10_JPRB, 0.90767768E-10_JPRB, 0.87934840E-10_JPRB, 0.85082559E-10_JPRB, 0.82202890E-10_JPRB, &
  & 0.79273844E-10_JPRB, 0.76247536E-10_JPRB, 0.72570165E-10_JPRB, 0.66217497E-10_JPRB /)

RGHG5(:,27,10) = (/ &
  & 0.22588237E-10_JPRB, 0.26407045E-10_JPRB, 0.28609577E-10_JPRB, 0.30618365E-10_JPRB, 0.32774092E-10_JPRB, 0.35280265E-10_JPRB, &
  & 0.38205723E-10_JPRB, 0.41631993E-10_JPRB, 0.45607865E-10_JPRB, 0.50142997E-10_JPRB, 0.55248573E-10_JPRB, 0.60871252E-10_JPRB, &
  & 0.66931682E-10_JPRB, 0.73339786E-10_JPRB, 0.79975145E-10_JPRB, 0.86760446E-10_JPRB, 0.93492658E-10_JPRB, 0.10026826E-09_JPRB, &
  & 0.10699126E-09_JPRB, 0.11380219E-09_JPRB, 0.12061858E-09_JPRB, 0.12752455E-09_JPRB, 0.13431638E-09_JPRB, 0.14085878E-09_JPRB, &
  & 0.14690758E-09_JPRB, 0.15222477E-09_JPRB, 0.15672164E-09_JPRB, 0.16034252E-09_JPRB, 0.16311982E-09_JPRB, 0.16506886E-09_JPRB, &
  & 0.16621304E-09_JPRB, 0.16661506E-09_JPRB, 0.16636309E-09_JPRB, 0.16568075E-09_JPRB, 0.16476992E-09_JPRB, 0.16377898E-09_JPRB, &
  & 0.16276722E-09_JPRB, 0.16189286E-09_JPRB, 0.16112939E-09_JPRB, 0.16035630E-09_JPRB, 0.15944883E-09_JPRB, 0.15818281E-09_JPRB, &
  & 0.15639749E-09_JPRB, 0.15395378E-09_JPRB, 0.15077689E-09_JPRB, 0.14692295E-09_JPRB, 0.14259320E-09_JPRB, 0.13802581E-09_JPRB, &
  & 0.13341706E-09_JPRB, 0.12885440E-09_JPRB, 0.12447114E-09_JPRB, 0.12039150E-09_JPRB, 0.11668329E-09_JPRB, 0.11330019E-09_JPRB, &
  & 0.11017619E-09_JPRB, 0.10723401E-09_JPRB, 0.10439093E-09_JPRB, 0.10157787E-09_JPRB, 0.98743368E-10_JPRB, 0.95864955E-10_JPRB, &
  & 0.92947185E-10_JPRB, 0.89840746E-10_JPRB, 0.86382589E-10_JPRB, 0.79785331E-10_JPRB /)

RGHG5(:,28,10) = (/ &
  & 0.30525530E-10_JPRB, 0.35150466E-10_JPRB, 0.37687426E-10_JPRB, 0.39900305E-10_JPRB, 0.42246179E-10_JPRB, 0.44900972E-10_JPRB, &
  & 0.48017788E-10_JPRB, 0.51652443E-10_JPRB, 0.55853676E-10_JPRB, 0.60680384E-10_JPRB, 0.66106856E-10_JPRB, 0.72112344E-10_JPRB, &
  & 0.78612200E-10_JPRB, 0.85499031E-10_JPRB, 0.92671107E-10_JPRB, 0.99935449E-10_JPRB, 0.10714302E-09_JPRB, 0.11434310E-09_JPRB, &
  & 0.12137674E-09_JPRB, 0.12837438E-09_JPRB, 0.13525869E-09_JPRB, 0.14211614E-09_JPRB, 0.14880314E-09_JPRB, 0.15519280E-09_JPRB, &
  & 0.16110033E-09_JPRB, 0.16634510E-09_JPRB, 0.17081893E-09_JPRB, 0.17459532E-09_JPRB, 0.17763650E-09_JPRB, 0.17996815E-09_JPRB, &
  & 0.18161522E-09_JPRB, 0.18262167E-09_JPRB, 0.18303356E-09_JPRB, 0.18297265E-09_JPRB, 0.18253532E-09_JPRB, 0.18180193E-09_JPRB, &
  & 0.18079629E-09_JPRB, 0.17964255E-09_JPRB, 0.17838379E-09_JPRB, 0.17700443E-09_JPRB, 0.17545498E-09_JPRB, 0.17360961E-09_JPRB, &
  & 0.17132246E-09_JPRB, 0.16847045E-09_JPRB, 0.16496235E-09_JPRB, 0.16082707E-09_JPRB, 0.15624724E-09_JPRB, 0.15142035E-09_JPRB, &
  & 0.14652470E-09_JPRB, 0.14171939E-09_JPRB, 0.13724157E-09_JPRB, 0.13314520E-09_JPRB, 0.12940468E-09_JPRB, 0.12599374E-09_JPRB, &
  & 0.12285567E-09_JPRB, 0.11991053E-09_JPRB, 0.11707052E-09_JPRB, 0.11425839E-09_JPRB, 0.11143252E-09_JPRB, 0.10858094E-09_JPRB, &
  & 0.10570184E-09_JPRB, 0.10281093E-09_JPRB, 0.99259545E-10_JPRB, 0.93188915E-10_JPRB /)

RGHG5(:,29,10) = (/ &
  & 0.40135312E-10_JPRB, 0.45496870E-10_JPRB, 0.48355431E-10_JPRB, 0.50757044E-10_JPRB, 0.53214374E-10_JPRB, 0.56003698E-10_JPRB, &
  & 0.59223050E-10_JPRB, 0.62986810E-10_JPRB, 0.67357356E-10_JPRB, 0.72353956E-10_JPRB, 0.78009529E-10_JPRB, 0.84273512E-10_JPRB, &
  & 0.91070325E-10_JPRB, 0.98290716E-10_JPRB, 0.10584294E-09_JPRB, 0.11337822E-09_JPRB, 0.12096511E-09_JPRB, 0.12839006E-09_JPRB, &
  & 0.13559345E-09_JPRB, 0.14262459E-09_JPRB, 0.14945573E-09_JPRB, 0.15611451E-09_JPRB, 0.16253668E-09_JPRB, 0.16862363E-09_JPRB, &
  & 0.17421628E-09_JPRB, 0.17920380E-09_JPRB, 0.18355299E-09_JPRB, 0.18727499E-09_JPRB, 0.19039249E-09_JPRB, 0.19293166E-09_JPRB, &
  & 0.19491499E-09_JPRB, 0.19636177E-09_JPRB, 0.19728182E-09_JPRB, 0.19771818E-09_JPRB, 0.19768191E-09_JPRB, 0.19719078E-09_JPRB, &
  & 0.19623149E-09_JPRB, 0.19490795E-09_JPRB, 0.19331250E-09_JPRB, 0.19149997E-09_JPRB, 0.18946346E-09_JPRB, 0.18716112E-09_JPRB, &
  & 0.18448944E-09_JPRB, 0.18131319E-09_JPRB, 0.17757736E-09_JPRB, 0.17325617E-09_JPRB, 0.16850725E-09_JPRB, 0.16352925E-09_JPRB, &
  & 0.15850671E-09_JPRB, 0.15369374E-09_JPRB, 0.14920501E-09_JPRB, 0.14506692E-09_JPRB, 0.14129295E-09_JPRB, 0.13785889E-09_JPRB, &
  & 0.13469456E-09_JPRB, 0.13171982E-09_JPRB, 0.12885097E-09_JPRB, 0.12602894E-09_JPRB, 0.12322611E-09_JPRB, 0.12045791E-09_JPRB, &
  & 0.11773070E-09_JPRB, 0.11484574E-09_JPRB, 0.11159270E-09_JPRB, 0.10558029E-09_JPRB /)

RGHG5(:,30,10) = (/ &
  & 0.51265894E-10_JPRB, 0.57320860E-10_JPRB, 0.60406215E-10_JPRB, 0.62937842E-10_JPRB, 0.65491390E-10_JPRB, 0.68309074E-10_JPRB, &
  & 0.71592593E-10_JPRB, 0.75416763E-10_JPRB, 0.79844326E-10_JPRB, 0.84946702E-10_JPRB, 0.90706095E-10_JPRB, 0.97107655E-10_JPRB, &
  & 0.10405993E-09_JPRB, 0.11147155E-09_JPRB, 0.11918064E-09_JPRB, 0.12688800E-09_JPRB, 0.13461673E-09_JPRB, 0.14214206E-09_JPRB, &
  & 0.14937249E-09_JPRB, 0.15632018E-09_JPRB, 0.16298377E-09_JPRB, 0.16936687E-09_JPRB, 0.17542774E-09_JPRB, 0.18111061E-09_JPRB, &
  & 0.18629320E-09_JPRB, 0.19092027E-09_JPRB, 0.19499873E-09_JPRB, 0.19855932E-09_JPRB, 0.20163370E-09_JPRB, 0.20423990E-09_JPRB, &
  & 0.20640584E-09_JPRB, 0.20812785E-09_JPRB, 0.20938717E-09_JPRB, 0.21017003E-09_JPRB, 0.21042833E-09_JPRB, 0.21013472E-09_JPRB, &
  & 0.20925264E-09_JPRB, 0.20786671E-09_JPRB, 0.20606629E-09_JPRB, 0.20398069E-09_JPRB, 0.20161525E-09_JPRB, 0.19899586E-09_JPRB, &
  & 0.19605326E-09_JPRB, 0.19267286E-09_JPRB, 0.18878554E-09_JPRB, 0.18438367E-09_JPRB, 0.17957991E-09_JPRB, 0.17458113E-09_JPRB, &
  & 0.16961320E-09_JPRB, 0.16486187E-09_JPRB, 0.16036748E-09_JPRB, 0.15619057E-09_JPRB, 0.15237391E-09_JPRB, 0.14889810E-09_JPRB, &
  & 0.14569550E-09_JPRB, 0.14269275E-09_JPRB, 0.13982571E-09_JPRB, 0.13704005E-09_JPRB, 0.13430944E-09_JPRB, 0.13159918E-09_JPRB, &
  & 0.12885609E-09_JPRB, 0.12606170E-09_JPRB, 0.12277043E-09_JPRB, 0.11716629E-09_JPRB /)

RGHG5(:,31,10) = (/ &
  & 0.63709898E-10_JPRB, 0.70206355E-10_JPRB, 0.73486814E-10_JPRB, 0.76109771E-10_JPRB, 0.78656831E-10_JPRB, 0.81501951E-10_JPRB, &
  & 0.84764251E-10_JPRB, 0.88576896E-10_JPRB, 0.93011349E-10_JPRB, 0.98095823E-10_JPRB, 0.10386720E-09_JPRB, 0.11027833E-09_JPRB, &
  & 0.11724276E-09_JPRB, 0.12468082E-09_JPRB, 0.13237772E-09_JPRB, 0.14011509E-09_JPRB, 0.14781282E-09_JPRB, 0.15528720E-09_JPRB, &
  & 0.16243072E-09_JPRB, 0.16922075E-09_JPRB, 0.17565180E-09_JPRB, 0.18171351E-09_JPRB, 0.18737777E-09_JPRB, 0.19261757E-09_JPRB, &
  & 0.19736582E-09_JPRB, 0.20158920E-09_JPRB, 0.20534222E-09_JPRB, 0.20865634E-09_JPRB, 0.21158338E-09_JPRB, 0.21414724E-09_JPRB, &
  & 0.21636336E-09_JPRB, 0.21821592E-09_JPRB, 0.21965772E-09_JPRB, 0.22064335E-09_JPRB, 0.22108698E-09_JPRB, 0.22092987E-09_JPRB, &
  & 0.22013164E-09_JPRB, 0.21875073E-09_JPRB, 0.21686525E-09_JPRB, 0.21463809E-09_JPRB, 0.21209032E-09_JPRB, 0.20927399E-09_JPRB, &
  & 0.20617261E-09_JPRB, 0.20267089E-09_JPRB, 0.19871262E-09_JPRB, 0.19428593E-09_JPRB, 0.18948280E-09_JPRB, 0.18450437E-09_JPRB, &
  & 0.17957082E-09_JPRB, 0.17482354E-09_JPRB, 0.17034757E-09_JPRB, 0.16624403E-09_JPRB, 0.16251799E-09_JPRB, 0.15910287E-09_JPRB, &
  & 0.15593102E-09_JPRB, 0.15294153E-09_JPRB, 0.15007645E-09_JPRB, 0.14728258E-09_JPRB, 0.14451593E-09_JPRB, 0.14177065E-09_JPRB, &
  & 0.13907181E-09_JPRB, 0.13632402E-09_JPRB, 0.13329357E-09_JPRB, 0.12773820E-09_JPRB /)

RGHG5(:,32,10) = (/ &
  & 0.76978389E-10_JPRB, 0.83775195E-10_JPRB, 0.87121393E-10_JPRB, 0.89756341E-10_JPRB, 0.92336125E-10_JPRB, 0.95123687E-10_JPRB, &
  & 0.98354005E-10_JPRB, 0.10210847E-09_JPRB, 0.10645358E-09_JPRB, 0.11146022E-09_JPRB, 0.11712036E-09_JPRB, 0.12341322E-09_JPRB, &
  & 0.13025581E-09_JPRB, 0.13755516E-09_JPRB, 0.14509763E-09_JPRB, 0.15272228E-09_JPRB, 0.16026802E-09_JPRB, 0.16758553E-09_JPRB, &
  & 0.17455841E-09_JPRB, 0.18115437E-09_JPRB, 0.18731589E-09_JPRB, 0.19304332E-09_JPRB, 0.19832630E-09_JPRB, 0.20313957E-09_JPRB, &
  & 0.20745466E-09_JPRB, 0.21127604E-09_JPRB, 0.21466728E-09_JPRB, 0.21770334E-09_JPRB, 0.22042801E-09_JPRB, 0.22286925E-09_JPRB, &
  & 0.22503553E-09_JPRB, 0.22689590E-09_JPRB, 0.22839064E-09_JPRB, 0.22945319E-09_JPRB, 0.22998677E-09_JPRB, 0.22991004E-09_JPRB, &
  & 0.22918709E-09_JPRB, 0.22785010E-09_JPRB, 0.22596991E-09_JPRB, 0.22370064E-09_JPRB, 0.22108397E-09_JPRB, 0.21818089E-09_JPRB, &
  & 0.21498760E-09_JPRB, 0.21145123E-09_JPRB, 0.20747640E-09_JPRB, 0.20308746E-09_JPRB, 0.19839161E-09_JPRB, 0.19355537E-09_JPRB, &
  & 0.18876936E-09_JPRB, 0.18414630E-09_JPRB, 0.17980646E-09_JPRB, 0.17580817E-09_JPRB, 0.17213328E-09_JPRB, 0.16874036E-09_JPRB, &
  & 0.16556753E-09_JPRB, 0.16255464E-09_JPRB, 0.15965401E-09_JPRB, 0.15681755E-09_JPRB, 0.15404085E-09_JPRB, 0.15134166E-09_JPRB, &
  & 0.14870295E-09_JPRB, 0.14605947E-09_JPRB, 0.14291351E-09_JPRB, 0.13760851E-09_JPRB /)

RGHG5(:,33,10) = (/ &
  & 0.90617958E-10_JPRB, 0.97461310E-10_JPRB, 0.10081485E-09_JPRB, 0.10348519E-09_JPRB, 0.10600924E-09_JPRB, 0.10879263E-09_JPRB, &
  & 0.11194583E-09_JPRB, 0.11560480E-09_JPRB, 0.11983398E-09_JPRB, 0.12465987E-09_JPRB, 0.13012284E-09_JPRB, 0.13618130E-09_JPRB, &
  & 0.14276910E-09_JPRB, 0.14978542E-09_JPRB, 0.15706876E-09_JPRB, 0.16443530E-09_JPRB, 0.17174769E-09_JPRB, 0.17882566E-09_JPRB, &
  & 0.18558999E-09_JPRB, 0.19194502E-09_JPRB, 0.19786099E-09_JPRB, 0.20330546E-09_JPRB, 0.20824560E-09_JPRB, 0.21268820E-09_JPRB, &
  & 0.21661373E-09_JPRB, 0.22006283E-09_JPRB, 0.22311368E-09_JPRB, 0.22584570E-09_JPRB, 0.22832826E-09_JPRB, 0.23058574E-09_JPRB, &
  & 0.23261842E-09_JPRB, 0.23438970E-09_JPRB, 0.23583066E-09_JPRB, 0.23687291E-09_JPRB, 0.23741681E-09_JPRB, 0.23737545E-09_JPRB, &
  & 0.23671634E-09_JPRB, 0.23544849E-09_JPRB, 0.23363084E-09_JPRB, 0.23139600E-09_JPRB, 0.22879722E-09_JPRB, 0.22587712E-09_JPRB, &
  & 0.22267166E-09_JPRB, 0.21914216E-09_JPRB, 0.21520996E-09_JPRB, 0.21091873E-09_JPRB, 0.20637256E-09_JPRB, 0.20171301E-09_JPRB, &
  & 0.19710297E-09_JPRB, 0.19266488E-09_JPRB, 0.18849891E-09_JPRB, 0.18463314E-09_JPRB, 0.18105609E-09_JPRB, 0.17771232E-09_JPRB, &
  & 0.17455878E-09_JPRB, 0.17154418E-09_JPRB, 0.16862828E-09_JPRB, 0.16579496E-09_JPRB, 0.16303567E-09_JPRB, 0.16034397E-09_JPRB, &
  & 0.15771129E-09_JPRB, 0.15502642E-09_JPRB, 0.15207847E-09_JPRB, 0.14682554E-09_JPRB /)

RGHG5(:,34,10) = (/ &
  & 0.10411337E-09_JPRB, 0.11085585E-09_JPRB, 0.11419524E-09_JPRB, 0.11680257E-09_JPRB, 0.11936732E-09_JPRB, 0.12207076E-09_JPRB, &
  & 0.12516965E-09_JPRB, 0.12871892E-09_JPRB, 0.13276938E-09_JPRB, 0.13738521E-09_JPRB, 0.14256178E-09_JPRB, 0.14829457E-09_JPRB, &
  & 0.15452586E-09_JPRB, 0.16116472E-09_JPRB, 0.16807966E-09_JPRB, 0.17511678E-09_JPRB, 0.18211624E-09_JPRB, 0.18892840E-09_JPRB, &
  & 0.19545099E-09_JPRB, 0.20158908E-09_JPRB, 0.20728505E-09_JPRB, 0.21249352E-09_JPRB, 0.21716337E-09_JPRB, 0.22129643E-09_JPRB, &
  & 0.22490210E-09_JPRB, 0.22801991E-09_JPRB, 0.23075394E-09_JPRB, 0.23319302E-09_JPRB, 0.23540792E-09_JPRB, 0.23743460E-09_JPRB, &
  & 0.23926872E-09_JPRB, 0.24087263E-09_JPRB, 0.24217911E-09_JPRB, 0.24312607E-09_JPRB, 0.24361996E-09_JPRB, 0.24358118E-09_JPRB, &
  & 0.24297928E-09_JPRB, 0.24179658E-09_JPRB, 0.24008276E-09_JPRB, 0.23794025E-09_JPRB, 0.23540919E-09_JPRB, 0.23253520E-09_JPRB, &
  & 0.22937420E-09_JPRB, 0.22588127E-09_JPRB, 0.22202949E-09_JPRB, 0.21788056E-09_JPRB, 0.21351981E-09_JPRB, 0.20908013E-09_JPRB, &
  & 0.20470403E-09_JPRB, 0.20047469E-09_JPRB, 0.19647758E-09_JPRB, 0.19276090E-09_JPRB, 0.18929371E-09_JPRB, 0.18604643E-09_JPRB, &
  & 0.18295873E-09_JPRB, 0.17998597E-09_JPRB, 0.17709605E-09_JPRB, 0.17426187E-09_JPRB, 0.17147779E-09_JPRB, 0.16877051E-09_JPRB, &
  & 0.16615281E-09_JPRB, 0.16358477E-09_JPRB, 0.16065266E-09_JPRB, 0.15556789E-09_JPRB /)

RGHG5(:,35,10) = (/ &
  & 0.11707674E-09_JPRB, 0.12363044E-09_JPRB, 0.12687328E-09_JPRB, 0.12950777E-09_JPRB, 0.13199426E-09_JPRB, 0.13470511E-09_JPRB, &
  & 0.13771286E-09_JPRB, 0.14113101E-09_JPRB, 0.14500384E-09_JPRB, 0.14934795E-09_JPRB, 0.15420638E-09_JPRB, 0.15955093E-09_JPRB, &
  & 0.16536027E-09_JPRB, 0.17155315E-09_JPRB, 0.17804484E-09_JPRB, 0.18468639E-09_JPRB, 0.19134139E-09_JPRB, 0.19786608E-09_JPRB, &
  & 0.20415689E-09_JPRB, 0.21010156E-09_JPRB, 0.21562427E-09_JPRB, 0.22064921E-09_JPRB, 0.22512794E-09_JPRB, 0.22903962E-09_JPRB, &
  & 0.23238525E-09_JPRB, 0.23523047E-09_JPRB, 0.23766980E-09_JPRB, 0.23981458E-09_JPRB, 0.24174274E-09_JPRB, 0.24349767E-09_JPRB, &
  & 0.24507912E-09_JPRB, 0.24645747E-09_JPRB, 0.24757110E-09_JPRB, 0.24837019E-09_JPRB, 0.24877372E-09_JPRB, 0.24871968E-09_JPRB, &
  & 0.24817334E-09_JPRB, 0.24709684E-09_JPRB, 0.24552418E-09_JPRB, 0.24351468E-09_JPRB, 0.24109137E-09_JPRB, 0.23831723E-09_JPRB, &
  & 0.23522181E-09_JPRB, 0.23179289E-09_JPRB, 0.22804869E-09_JPRB, 0.22406015E-09_JPRB, 0.21990713E-09_JPRB, 0.21570962E-09_JPRB, &
  & 0.21157395E-09_JPRB, 0.20758283E-09_JPRB, 0.20378496E-09_JPRB, 0.20023655E-09_JPRB, 0.19691763E-09_JPRB, 0.19378191E-09_JPRB, &
  & 0.19078150E-09_JPRB, 0.18787662E-09_JPRB, 0.18501990E-09_JPRB, 0.18219548E-09_JPRB, 0.17942986E-09_JPRB, 0.17675909E-09_JPRB, &
  & 0.17419520E-09_JPRB, 0.17163056E-09_JPRB, 0.16876731E-09_JPRB, 0.16381561E-09_JPRB /)

RGHG5(:,36,10) = (/ &
  & 0.12936419E-09_JPRB, 0.13560379E-09_JPRB, 0.13878185E-09_JPRB, 0.14131643E-09_JPRB, 0.14383038E-09_JPRB, 0.14646329E-09_JPRB, &
  & 0.14940521E-09_JPRB, 0.15268663E-09_JPRB, 0.15634373E-09_JPRB, 0.16042458E-09_JPRB, 0.16492487E-09_JPRB, 0.16985728E-09_JPRB, &
  & 0.17520015E-09_JPRB, 0.18092020E-09_JPRB, 0.18693819E-09_JPRB, 0.19316945E-09_JPRB, 0.19943946E-09_JPRB, 0.20568167E-09_JPRB, &
  & 0.21173163E-09_JPRB, 0.21752400E-09_JPRB, 0.22293604E-09_JPRB, 0.22787051E-09_JPRB, 0.23222622E-09_JPRB, 0.23597613E-09_JPRB, &
  & 0.23910748E-09_JPRB, 0.24168567E-09_JPRB, 0.24383998E-09_JPRB, 0.24568331E-09_JPRB, 0.24730784E-09_JPRB, 0.24876159E-09_JPRB, &
  & 0.25005831E-09_JPRB, 0.25116814E-09_JPRB, 0.25205360E-09_JPRB, 0.25267416E-09_JPRB, 0.25296765E-09_JPRB, 0.25289498E-09_JPRB, &
  & 0.25241342E-09_JPRB, 0.25147467E-09_JPRB, 0.25008762E-09_JPRB, 0.24825653E-09_JPRB, 0.24599867E-09_JPRB, 0.24335187E-09_JPRB, &
  & 0.24034708E-09_JPRB, 0.23699956E-09_JPRB, 0.23337424E-09_JPRB, 0.22956000E-09_JPRB, 0.22562666E-09_JPRB, 0.22166743E-09_JPRB, &
  & 0.21777141E-09_JPRB, 0.21400434E-09_JPRB, 0.21039857E-09_JPRB, 0.20702262E-09_JPRB, 0.20385865E-09_JPRB, 0.20086971E-09_JPRB, &
  & 0.19799004E-09_JPRB, 0.19518345E-09_JPRB, 0.19241084E-09_JPRB, 0.18965146E-09_JPRB, 0.18693372E-09_JPRB, 0.18429043E-09_JPRB, &
  & 0.18174236E-09_JPRB, 0.17924229E-09_JPRB, 0.17646566E-09_JPRB, 0.17162725E-09_JPRB /)

RGHG5(:,37,10) = (/ &
  & 0.14098793E-09_JPRB, 0.14681080E-09_JPRB, 0.14982637E-09_JPRB, 0.15233137E-09_JPRB, 0.15476609E-09_JPRB, 0.15738504E-09_JPRB, &
  & 0.16022297E-09_JPRB, 0.16335497E-09_JPRB, 0.16680560E-09_JPRB, 0.17059097E-09_JPRB, 0.17473346E-09_JPRB, 0.17922569E-09_JPRB, &
  & 0.18408694E-09_JPRB, 0.18930454E-09_JPRB, 0.19484295E-09_JPRB, 0.20063066E-09_JPRB, 0.20654445E-09_JPRB, 0.21245311E-09_JPRB, &
  & 0.21829891E-09_JPRB, 0.22394749E-09_JPRB, 0.22928623E-09_JPRB, 0.23415631E-09_JPRB, 0.23841487E-09_JPRB, 0.24197261E-09_JPRB, &
  & 0.24484484E-09_JPRB, 0.24712810E-09_JPRB, 0.24896732E-09_JPRB, 0.25049676E-09_JPRB, 0.25181085E-09_JPRB, 0.25296151E-09_JPRB, &
  & 0.25396152E-09_JPRB, 0.25480498E-09_JPRB, 0.25546010E-09_JPRB, 0.25590480E-09_JPRB, 0.25609637E-09_JPRB, 0.25601660E-09_JPRB, &
  & 0.25561858E-09_JPRB, 0.25486188E-09_JPRB, 0.25371794E-09_JPRB, 0.25215280E-09_JPRB, 0.25014549E-09_JPRB, 0.24770203E-09_JPRB, &
  & 0.24483801E-09_JPRB, 0.24160721E-09_JPRB, 0.23812508E-09_JPRB, 0.23447613E-09_JPRB, 0.23074845E-09_JPRB, 0.22701986E-09_JPRB, &
  & 0.22334125E-09_JPRB, 0.21977350E-09_JPRB, 0.21635754E-09_JPRB, 0.21314416E-09_JPRB, 0.21014845E-09_JPRB, 0.20731683E-09_JPRB, &
  & 0.20459534E-09_JPRB, 0.20193831E-09_JPRB, 0.19930077E-09_JPRB, 0.19664306E-09_JPRB, 0.19399414E-09_JPRB, 0.19140625E-09_JPRB, &
  & 0.18891898E-09_JPRB, 0.18646915E-09_JPRB, 0.18372801E-09_JPRB, 0.17901913E-09_JPRB /)

RGHG5(:,38,10) = (/ &
  & 0.15205075E-09_JPRB, 0.15734959E-09_JPRB, 0.16016219E-09_JPRB, 0.16254464E-09_JPRB, 0.16494722E-09_JPRB, 0.16748901E-09_JPRB, &
  & 0.17024211E-09_JPRB, 0.17321629E-09_JPRB, 0.17643795E-09_JPRB, 0.17992560E-09_JPRB, 0.18368701E-09_JPRB, 0.18773028E-09_JPRB, &
  & 0.19208933E-09_JPRB, 0.19679823E-09_JPRB, 0.20185381E-09_JPRB, 0.20718932E-09_JPRB, 0.21274721E-09_JPRB, 0.21836979E-09_JPRB, &
  & 0.22397176E-09_JPRB, 0.22944678E-09_JPRB, 0.23465951E-09_JPRB, 0.23938296E-09_JPRB, 0.24341262E-09_JPRB, 0.24667041E-09_JPRB, &
  & 0.24918725E-09_JPRB, 0.25111491E-09_JPRB, 0.25262267E-09_JPRB, 0.25384783E-09_JPRB, 0.25487915E-09_JPRB, 0.25576544E-09_JPRB, &
  & 0.25652663E-09_JPRB, 0.25715421E-09_JPRB, 0.25763475E-09_JPRB, 0.25794714E-09_JPRB, 0.25807007E-09_JPRB, 0.25799676E-09_JPRB, &
  & 0.25768815E-09_JPRB, 0.25711719E-09_JPRB, 0.25624342E-09_JPRB, 0.25500640E-09_JPRB, 0.25335462E-09_JPRB, 0.25123245E-09_JPRB, &
  & 0.24863001E-09_JPRB, 0.24562063E-09_JPRB, 0.24231747E-09_JPRB, 0.23886074E-09_JPRB, 0.23533908E-09_JPRB, 0.23182184E-09_JPRB, &
  & 0.22834067E-09_JPRB, 0.22494874E-09_JPRB, 0.22169598E-09_JPRB, 0.21864011E-09_JPRB, 0.21580839E-09_JPRB, 0.21315813E-09_JPRB, &
  & 0.21063049E-09_JPRB, 0.20816093E-09_JPRB, 0.20569897E-09_JPRB, 0.20318791E-09_JPRB, 0.20065828E-09_JPRB, 0.19815830E-09_JPRB, &
  & 0.19573093E-09_JPRB, 0.19332536E-09_JPRB, 0.19066312E-09_JPRB, 0.18602120E-09_JPRB /)

RGHG5(:,39,10) = (/ &
  & 0.16257330E-09_JPRB, 0.16725557E-09_JPRB, 0.16982060E-09_JPRB, 0.17209077E-09_JPRB, 0.17440749E-09_JPRB, 0.17689385E-09_JPRB, &
  & 0.17953990E-09_JPRB, 0.18234828E-09_JPRB, 0.18532886E-09_JPRB, 0.18850119E-09_JPRB, 0.19186867E-09_JPRB, 0.19545209E-09_JPRB, &
  & 0.19931121E-09_JPRB, 0.20350599E-09_JPRB, 0.20808047E-09_JPRB, 0.21298698E-09_JPRB, 0.21813526E-09_JPRB, 0.22345849E-09_JPRB, &
  & 0.22881330E-09_JPRB, 0.23408606E-09_JPRB, 0.23905197E-09_JPRB, 0.24347710E-09_JPRB, 0.24712701E-09_JPRB, 0.24995789E-09_JPRB, &
  & 0.25207722E-09_JPRB, 0.25365857E-09_JPRB, 0.25487867E-09_JPRB, 0.25586047E-09_JPRB, 0.25668290E-09_JPRB, 0.25738717E-09_JPRB, &
  & 0.25798788E-09_JPRB, 0.25848146E-09_JPRB, 0.25885363E-09_JPRB, 0.25908717E-09_JPRB, 0.25917254E-09_JPRB, 0.25910790E-09_JPRB, &
  & 0.25886573E-09_JPRB, 0.25843583E-09_JPRB, 0.25777663E-09_JPRB, 0.25683733E-09_JPRB, 0.25554459E-09_JPRB, 0.25381700E-09_JPRB, &
  & 0.25161012E-09_JPRB, 0.24894861E-09_JPRB, 0.24593805E-09_JPRB, 0.24271712E-09_JPRB, 0.23941671E-09_JPRB, 0.23610397E-09_JPRB, &
  & 0.23281188E-09_JPRB, 0.22957668E-09_JPRB, 0.22646951E-09_JPRB, 0.22356672E-09_JPRB, 0.22089619E-09_JPRB, 0.21843777E-09_JPRB, &
  & 0.21611818E-09_JPRB, 0.21387124E-09_JPRB, 0.21161503E-09_JPRB, 0.20929916E-09_JPRB, 0.20691965E-09_JPRB, 0.20453370E-09_JPRB, &
  & 0.20218606E-09_JPRB, 0.19985910E-09_JPRB, 0.19723603E-09_JPRB, 0.19270252E-09_JPRB /)

RGHG5(:,40,10) = (/ &
  & 0.17250698E-09_JPRB, 0.17654837E-09_JPRB, 0.17887758E-09_JPRB, 0.18099461E-09_JPRB, 0.18323423E-09_JPRB, 0.18564883E-09_JPRB, &
  & 0.18818722E-09_JPRB, 0.19081749E-09_JPRB, 0.19354765E-09_JPRB, 0.19638752E-09_JPRB, 0.19935895E-09_JPRB, 0.20248932E-09_JPRB, &
  & 0.20585710E-09_JPRB, 0.20955855E-09_JPRB, 0.21365389E-09_JPRB, 0.21813829E-09_JPRB, 0.22292392E-09_JPRB, 0.22789218E-09_JPRB, &
  & 0.23295071E-09_JPRB, 0.23791599E-09_JPRB, 0.24255586E-09_JPRB, 0.24654997E-09_JPRB, 0.24973998E-09_JPRB, 0.25214725E-09_JPRB, &
  & 0.25391259E-09_JPRB, 0.25522268E-09_JPRB, 0.25623137E-09_JPRB, 0.25704633E-09_JPRB, 0.25773050E-09_JPRB, 0.25831939E-09_JPRB, &
  & 0.25882324E-09_JPRB, 0.25923683E-09_JPRB, 0.25954752E-09_JPRB, 0.25973523E-09_JPRB, 0.25980057E-09_JPRB, 0.25974090E-09_JPRB, &
  & 0.25954106E-09_JPRB, 0.25919986E-09_JPRB, 0.25868596E-09_JPRB, 0.25795835E-09_JPRB, 0.25695354E-09_JPRB, 0.25558608E-09_JPRB, &
  & 0.25380115E-09_JPRB, 0.25157207E-09_JPRB, 0.24894328E-09_JPRB, 0.24603480E-09_JPRB, 0.24299643E-09_JPRB, 0.23990226E-09_JPRB, &
  & 0.23679050E-09_JPRB, 0.23371402E-09_JPRB, 0.23073991E-09_JPRB, 0.22797197E-09_JPRB, 0.22546998E-09_JPRB, 0.22320248E-09_JPRB, &
  & 0.22110784E-09_JPRB, 0.21908600E-09_JPRB, 0.21706023E-09_JPRB, 0.21495145E-09_JPRB, 0.21275740E-09_JPRB, 0.21051652E-09_JPRB, &
  & 0.20829313E-09_JPRB, 0.20604606E-09_JPRB, 0.20352839E-09_JPRB, 0.19907902E-09_JPRB /)

RGHG5(:,41,10) = (/ &
  & 0.18175296E-09_JPRB, 0.18526163E-09_JPRB, 0.18733581E-09_JPRB, 0.18931620E-09_JPRB, 0.19147178E-09_JPRB, 0.19381358E-09_JPRB, &
  & 0.19624491E-09_JPRB, 0.19869126E-09_JPRB, 0.20116030E-09_JPRB, 0.20367445E-09_JPRB, 0.20625310E-09_JPRB, 0.20894796E-09_JPRB, &
  & 0.21185387E-09_JPRB, 0.21508302E-09_JPRB, 0.21872291E-09_JPRB, 0.22277642E-09_JPRB, 0.22716851E-09_JPRB, 0.23179454E-09_JPRB, &
  & 0.23650815E-09_JPRB, 0.24112537E-09_JPRB, 0.24532962E-09_JPRB, 0.24886374E-09_JPRB, 0.25160363E-09_JPRB, 0.25363917E-09_JPRB, &
  & 0.25513042E-09_JPRB, 0.25624017E-09_JPRB, 0.25710170E-09_JPRB, 0.25780195E-09_JPRB, 0.25839497E-09_JPRB, 0.25890839E-09_JPRB, &
  & 0.25935093E-09_JPRB, 0.25971506E-09_JPRB, 0.25998775E-09_JPRB, 0.26014726E-09_JPRB, 0.26020033E-09_JPRB, 0.26014235E-09_JPRB, &
  & 0.25996921E-09_JPRB, 0.25968458E-09_JPRB, 0.25926480E-09_JPRB, 0.25868405E-09_JPRB, 0.25788588E-09_JPRB, 0.25680658E-09_JPRB, &
  & 0.25538813E-09_JPRB, 0.25357835E-09_JPRB, 0.25136615E-09_JPRB, 0.24884475E-09_JPRB, 0.24609131E-09_JPRB, 0.24323787E-09_JPRB, &
  & 0.24032895E-09_JPRB, 0.23740446E-09_JPRB, 0.23456437E-09_JPRB, 0.23194439E-09_JPRB, 0.22959951E-09_JPRB, 0.22753127E-09_JPRB, &
  & 0.22564750E-09_JPRB, 0.22385627E-09_JPRB, 0.22205116E-09_JPRB, 0.22016354E-09_JPRB, 0.21816736E-09_JPRB, 0.21610587E-09_JPRB, &
  & 0.21402312E-09_JPRB, 0.21192421E-09_JPRB, 0.20951529E-09_JPRB, 0.20525515E-09_JPRB /)

RGHG5(:,42,10) = (/ &
  & 0.19032480E-09_JPRB, 0.19337060E-09_JPRB, 0.19524415E-09_JPRB, 0.19709441E-09_JPRB, 0.19917532E-09_JPRB, 0.20146541E-09_JPRB, &
  & 0.20378127E-09_JPRB, 0.20604916E-09_JPRB, 0.20826357E-09_JPRB, 0.21045657E-09_JPRB, 0.21266766E-09_JPRB, 0.21495594E-09_JPRB, &
  & 0.21742985E-09_JPRB, 0.22021841E-09_JPRB, 0.22342427E-09_JPRB, 0.22706498E-09_JPRB, 0.23106971E-09_JPRB, 0.23531674E-09_JPRB, &
  & 0.23966337E-09_JPRB, 0.24386476E-09_JPRB, 0.24761854E-09_JPRB, 0.25067062E-09_JPRB, 0.25300279E-09_JPRB, 0.25472821E-09_JPRB, &
  & 0.25600036E-09_JPRB, 0.25696112E-09_JPRB, 0.25771504E-09_JPRB, 0.25833422E-09_JPRB, 0.25886279E-09_JPRB, 0.25932453E-09_JPRB, &
  & 0.25972494E-09_JPRB, 0.26005584E-09_JPRB, 0.26030297E-09_JPRB, 0.26044297E-09_JPRB, 0.26048722E-09_JPRB, 0.26042915E-09_JPRB, &
  & 0.26027400E-09_JPRB, 0.26002642E-09_JPRB, 0.25967270E-09_JPRB, 0.25919378E-09_JPRB, 0.25854832E-09_JPRB, 0.25768726E-09_JPRB, &
  & 0.25656360E-09_JPRB, 0.25511668E-09_JPRB, 0.25332869E-09_JPRB, 0.25117591E-09_JPRB, 0.24876587E-09_JPRB, 0.24616287E-09_JPRB, &
  & 0.24345828E-09_JPRB, 0.24071120E-09_JPRB, 0.23802380E-09_JPRB, 0.23554686E-09_JPRB, 0.23338137E-09_JPRB, 0.23150215E-09_JPRB, &
  & 0.22982817E-09_JPRB, 0.22824728E-09_JPRB, 0.22665839E-09_JPRB, 0.22498195E-09_JPRB, 0.22319209E-09_JPRB, 0.22132234E-09_JPRB, &
  & 0.21943627E-09_JPRB, 0.21750576E-09_JPRB, 0.21530196E-09_JPRB, 0.21130726E-09_JPRB /)

RGHG5(:,43,10) = (/ &
  & 0.19825244E-09_JPRB, 0.20094586E-09_JPRB, 0.20264690E-09_JPRB, 0.20439429E-09_JPRB, 0.20642738E-09_JPRB, 0.20866166E-09_JPRB, &
  & 0.21088489E-09_JPRB, 0.21297403E-09_JPRB, 0.21494563E-09_JPRB, 0.21684421E-09_JPRB, 0.21871253E-09_JPRB, 0.22063140E-09_JPRB, &
  & 0.22271311E-09_JPRB, 0.22509040E-09_JPRB, 0.22788342E-09_JPRB, 0.23112313E-09_JPRB, 0.23473376E-09_JPRB, 0.23860014E-09_JPRB, &
  & 0.24254299E-09_JPRB, 0.24629937E-09_JPRB, 0.24954877E-09_JPRB, 0.25214572E-09_JPRB, 0.25410574E-09_JPRB, 0.25556954E-09_JPRB, &
  & 0.25666644E-09_JPRB, 0.25750929E-09_JPRB, 0.25818178E-09_JPRB, 0.25874072E-09_JPRB, 0.25922217E-09_JPRB, 0.25964600E-09_JPRB, &
  & 0.26001623E-09_JPRB, 0.26032287E-09_JPRB, 0.26055119E-09_JPRB, 0.26067648E-09_JPRB, 0.26071331E-09_JPRB, 0.26065458E-09_JPRB, &
  & 0.26051172E-09_JPRB, 0.26029087E-09_JPRB, 0.25998453E-09_JPRB, 0.25958113E-09_JPRB, 0.25904931E-09_JPRB, 0.25835659E-09_JPRB, &
  & 0.25746333E-09_JPRB, 0.25632829E-09_JPRB, 0.25489361E-09_JPRB, 0.25314026E-09_JPRB, 0.25104335E-09_JPRB, 0.24872512E-09_JPRB, &
  & 0.24624799E-09_JPRB, 0.24369046E-09_JPRB, 0.24117869E-09_JPRB, 0.23888086E-09_JPRB, 0.23689242E-09_JPRB, 0.23520497E-09_JPRB, &
  & 0.23372926E-09_JPRB, 0.23234498E-09_JPRB, 0.23095521E-09_JPRB, 0.22948096E-09_JPRB, 0.22789684E-09_JPRB, 0.22623997E-09_JPRB, &
  & 0.22456371E-09_JPRB, 0.22286789E-09_JPRB, 0.22091334E-09_JPRB, 0.21734058E-09_JPRB /)

RGHG5(:,44,10) = (/ &
  & 0.20565329E-09_JPRB, 0.20807270E-09_JPRB, 0.20964204E-09_JPRB, 0.21130664E-09_JPRB, 0.21328811E-09_JPRB, 0.21549812E-09_JPRB, &
  & 0.21761615E-09_JPRB, 0.21954268E-09_JPRB, 0.22129026E-09_JPRB, 0.22291174E-09_JPRB, 0.22447959E-09_JPRB, 0.22606784E-09_JPRB, &
  & 0.22778959E-09_JPRB, 0.22979856E-09_JPRB, 0.23220328E-09_JPRB, 0.23505392E-09_JPRB, 0.23828625E-09_JPRB, 0.24174462E-09_JPRB, &
  & 0.24524369E-09_JPRB, 0.24848143E-09_JPRB, 0.25122396E-09_JPRB, 0.25336888E-09_JPRB, 0.25500579E-09_JPRB, 0.25624547E-09_JPRB, &
  & 0.25719826E-09_JPRB, 0.25794678E-09_JPRB, 0.25855579E-09_JPRB, 0.25906843E-09_JPRB, 0.25951485E-09_JPRB, 0.25991054E-09_JPRB, &
  & 0.26025804E-09_JPRB, 0.26054625E-09_JPRB, 0.26075936E-09_JPRB, 0.26087313E-09_JPRB, 0.26090297E-09_JPRB, 0.26084346E-09_JPRB, &
  & 0.26070951E-09_JPRB, 0.26050825E-09_JPRB, 0.26023775E-09_JPRB, 0.25989105E-09_JPRB, 0.25944705E-09_JPRB, 0.25888383E-09_JPRB, &
  & 0.25817484E-09_JPRB, 0.25728675E-09_JPRB, 0.25617897E-09_JPRB, 0.25476254E-09_JPRB, 0.25302921E-09_JPRB, 0.25098493E-09_JPRB, &
  & 0.24874419E-09_JPRB, 0.24640381E-09_JPRB, 0.24409663E-09_JPRB, 0.24199198E-09_JPRB, 0.24020164E-09_JPRB, 0.23871050E-09_JPRB, &
  & 0.23741659E-09_JPRB, 0.23621899E-09_JPRB, 0.23501356E-09_JPRB, 0.23373117E-09_JPRB, 0.23235171E-09_JPRB, 0.23090832E-09_JPRB, &
  & 0.22947085E-09_JPRB, 0.22802632E-09_JPRB, 0.22637388E-09_JPRB, 0.22335020E-09_JPRB /)

RGHG5(:,45,10) = (/ &
  & 0.21264041E-09_JPRB, 0.21485559E-09_JPRB, 0.21631863E-09_JPRB, 0.21789474E-09_JPRB, 0.21985817E-09_JPRB, 0.22200834E-09_JPRB, &
  & 0.22404451E-09_JPRB, 0.22580382E-09_JPRB, 0.22733390E-09_JPRB, 0.22871621E-09_JPRB, 0.23000751E-09_JPRB, 0.23130274E-09_JPRB, &
  & 0.23272440E-09_JPRB, 0.23437885E-09_JPRB, 0.23643210E-09_JPRB, 0.23891977E-09_JPRB, 0.24175623E-09_JPRB, 0.24479596E-09_JPRB, &
  & 0.24776980E-09_JPRB, 0.25045491E-09_JPRB, 0.25265678E-09_JPRB, 0.25440169E-09_JPRB, 0.25574737E-09_JPRB, 0.25680116E-09_JPRB, &
  & 0.25763341E-09_JPRB, 0.25830560E-09_JPRB, 0.25886368E-09_JPRB, 0.25934155E-09_JPRB, 0.25976146E-09_JPRB, 0.26013627E-09_JPRB, &
  & 0.26046654E-09_JPRB, 0.26074015E-09_JPRB, 0.26094055E-09_JPRB, 0.26104466E-09_JPRB, 0.26106786E-09_JPRB, 0.26100772E-09_JPRB, &
  & 0.26088004E-09_JPRB, 0.26069372E-09_JPRB, 0.26045033E-09_JPRB, 0.26014707E-09_JPRB, 0.25977109E-09_JPRB, 0.25930827E-09_JPRB, &
  & 0.25874386E-09_JPRB, 0.25806035E-09_JPRB, 0.25720986E-09_JPRB, 0.25613187E-09_JPRB, 0.25472688E-09_JPRB, 0.25299740E-09_JPRB, &
  & 0.25101202E-09_JPRB, 0.24889474E-09_JPRB, 0.24680502E-09_JPRB, 0.24492777E-09_JPRB, 0.24334426E-09_JPRB, 0.24204538E-09_JPRB, &
  & 0.24093830E-09_JPRB, 0.23991081E-09_JPRB, 0.23888144E-09_JPRB, 0.23778432E-09_JPRB, 0.23659999E-09_JPRB, 0.23537536E-09_JPRB, &
  & 0.23416927E-09_JPRB, 0.23298061E-09_JPRB, 0.23164325E-09_JPRB, 0.22919833E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART19',1,ZHOOK_HANDLE)
END SUBROUTINE PART19




SUBROUTINE PART20
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART20',0,ZHOOK_HANDLE)



RGHG5(:,46,10) = (/ &
  & 0.21932035E-09_JPRB, 0.22139346E-09_JPRB, 0.22275566E-09_JPRB, 0.22428974E-09_JPRB, 0.22616339E-09_JPRB, 0.22829993E-09_JPRB, &
  & 0.23019922E-09_JPRB, 0.23179336E-09_JPRB, 0.23312147E-09_JPRB, 0.23426283E-09_JPRB, 0.23531696E-09_JPRB, 0.23636476E-09_JPRB, &
  & 0.23749547E-09_JPRB, 0.23887178E-09_JPRB, 0.24058272E-09_JPRB, 0.24271035E-09_JPRB, 0.24516683E-09_JPRB, 0.24769781E-09_JPRB, &
  & 0.25010821E-09_JPRB, 0.25217678E-09_JPRB, 0.25389260E-09_JPRB, 0.25526109E-09_JPRB, 0.25636790E-09_JPRB, 0.25726221E-09_JPRB, &
  & 0.25799535E-09_JPRB, 0.25860455E-09_JPRB, 0.25912289E-09_JPRB, 0.25957358E-09_JPRB, 0.25997424E-09_JPRB, 0.26033375E-09_JPRB, &
  & 0.26065058E-09_JPRB, 0.26091221E-09_JPRB, 0.26110153E-09_JPRB, 0.26119731E-09_JPRB, 0.26121419E-09_JPRB, 0.26115354E-09_JPRB, &
  & 0.26103023E-09_JPRB, 0.26085528E-09_JPRB, 0.26063232E-09_JPRB, 0.26036268E-09_JPRB, 0.26003902E-09_JPRB, 0.25965494E-09_JPRB, &
  & 0.25920377E-09_JPRB, 0.25867561E-09_JPRB, 0.25804484E-09_JPRB, 0.25724048E-09_JPRB, 0.25617403E-09_JPRB, 0.25477756E-09_JPRB, &
  & 0.25306787E-09_JPRB, 0.25119792E-09_JPRB, 0.24934910E-09_JPRB, 0.24768768E-09_JPRB, 0.24633276E-09_JPRB, 0.24522698E-09_JPRB, &
  & 0.24429231E-09_JPRB, 0.24343119E-09_JPRB, 0.24256502E-09_JPRB, 0.24164093E-09_JPRB, 0.24064661E-09_JPRB, 0.23962335E-09_JPRB, &
  & 0.23863356E-09_JPRB, 0.23767710E-09_JPRB, 0.23661340E-09_JPRB, 0.23471017E-09_JPRB /)

RGHG5(:,47,10) = (/ &
  & 0.22580771E-09_JPRB, 0.22776417E-09_JPRB, 0.22908464E-09_JPRB, 0.23051014E-09_JPRB, 0.23237653E-09_JPRB, 0.23436392E-09_JPRB, &
  & 0.23615276E-09_JPRB, 0.23754815E-09_JPRB, 0.23865393E-09_JPRB, 0.23958346E-09_JPRB, 0.24041041E-09_JPRB, 0.24122493E-09_JPRB, &
  & 0.24213281E-09_JPRB, 0.24321573E-09_JPRB, 0.24463512E-09_JPRB, 0.24640806E-09_JPRB, 0.24839794E-09_JPRB, 0.25039026E-09_JPRB, &
  & 0.25215147E-09_JPRB, 0.25366370E-09_JPRB, 0.25491789E-09_JPRB, 0.25598476E-09_JPRB, 0.25688299E-09_JPRB, 0.25764860E-09_JPRB, &
  & 0.25829952E-09_JPRB, 0.25885782E-09_JPRB, 0.25934416E-09_JPRB, 0.25977481E-09_JPRB, 0.26016117E-09_JPRB, 0.26050925E-09_JPRB, &
  & 0.26081545E-09_JPRB, 0.26106706E-09_JPRB, 0.26124608E-09_JPRB, 0.26133470E-09_JPRB, 0.26134564E-09_JPRB, 0.26128438E-09_JPRB, &
  & 0.26116420E-09_JPRB, 0.26099756E-09_JPRB, 0.26079017E-09_JPRB, 0.26054614E-09_JPRB, 0.26026303E-09_JPRB, 0.25993918E-09_JPRB, &
  & 0.25957453E-09_JPRB, 0.25916752E-09_JPRB, 0.25869956E-09_JPRB, 0.25812383E-09_JPRB, 0.25735811E-09_JPRB, 0.25629540E-09_JPRB, &
  & 0.25493091E-09_JPRB, 0.25333347E-09_JPRB, 0.25172681E-09_JPRB, 0.25031333E-09_JPRB, 0.24915284E-09_JPRB, 0.24823688E-09_JPRB, &
  & 0.24746216E-09_JPRB, 0.24674915E-09_JPRB, 0.24603342E-09_JPRB, 0.24526484E-09_JPRB, 0.24444002E-09_JPRB, 0.24359650E-09_JPRB, &
  & 0.24279354E-09_JPRB, 0.24202673E-09_JPRB, 0.24119262E-09_JPRB, 0.23971597E-09_JPRB /)

RGHG5(:,48,10) = (/ &
  & 0.23213789E-09_JPRB, 0.23405869E-09_JPRB, 0.23530489E-09_JPRB, 0.23671137E-09_JPRB, 0.23841965E-09_JPRB, 0.24033961E-09_JPRB, &
  & 0.24190777E-09_JPRB, 0.24309288E-09_JPRB, 0.24397831E-09_JPRB, 0.24467839E-09_JPRB, 0.24529589E-09_JPRB, 0.24590213E-09_JPRB, &
  & 0.24656968E-09_JPRB, 0.24741592E-09_JPRB, 0.24850069E-09_JPRB, 0.24986851E-09_JPRB, 0.25133956E-09_JPRB, 0.25269414E-09_JPRB, &
  & 0.25387192E-09_JPRB, 0.25487473E-09_JPRB, 0.25577207E-09_JPRB, 0.25657962E-09_JPRB, 0.25731497E-09_JPRB, 0.25797334E-09_JPRB, &
  & 0.25855812E-09_JPRB, 0.25907587E-09_JPRB, 0.25953764E-09_JPRB, 0.25995278E-09_JPRB, 0.26032859E-09_JPRB, 0.26066788E-09_JPRB, &
  & 0.26096522E-09_JPRB, 0.26120714E-09_JPRB, 0.26137717E-09_JPRB, 0.26145910E-09_JPRB, 0.26146471E-09_JPRB, 0.26140268E-09_JPRB, &
  & 0.26128452E-09_JPRB, 0.26112418E-09_JPRB, 0.26092850E-09_JPRB, 0.26070404E-09_JPRB, 0.26045191E-09_JPRB, 0.26017410E-09_JPRB, &
  & 0.25987484E-09_JPRB, 0.25955652E-09_JPRB, 0.25921021E-09_JPRB, 0.25880612E-09_JPRB, 0.25827576E-09_JPRB, 0.25754315E-09_JPRB, &
  & 0.25652508E-09_JPRB, 0.25528762E-09_JPRB, 0.25396704E-09_JPRB, 0.25278091E-09_JPRB, 0.25182956E-09_JPRB, 0.25106894E-09_JPRB, &
  & 0.25043398E-09_JPRB, 0.24984884E-09_JPRB, 0.24925811E-09_JPRB, 0.24862404E-09_JPRB, 0.24794025E-09_JPRB, 0.24724822E-09_JPRB, &
  & 0.24659313E-09_JPRB, 0.24597782E-09_JPRB, 0.24531238E-09_JPRB, 0.24415278E-09_JPRB /)

RGHG5(:,49,10) = (/ &
  & 0.23828797E-09_JPRB, 0.24014946E-09_JPRB, 0.24137434E-09_JPRB, 0.24267560E-09_JPRB, 0.24431171E-09_JPRB, 0.24600533E-09_JPRB, &
  & 0.24737373E-09_JPRB, 0.24830665E-09_JPRB, 0.24895497E-09_JPRB, 0.24944338E-09_JPRB, 0.24985117E-09_JPRB, 0.25024971E-09_JPRB, &
  & 0.25070035E-09_JPRB, 0.25125335E-09_JPRB, 0.25199670E-09_JPRB, 0.25286084E-09_JPRB, 0.25374852E-09_JPRB, 0.25453542E-09_JPRB, &
  & 0.25521635E-09_JPRB, 0.25584640E-09_JPRB, 0.25645958E-09_JPRB, 0.25707386E-09_JPRB, 0.25767474E-09_JPRB, 0.25824881E-09_JPRB, &
  & 0.25878116E-09_JPRB, 0.25926766E-09_JPRB, 0.25971061E-09_JPRB, 0.26011435E-09_JPRB, 0.26048147E-09_JPRB, 0.26081315E-09_JPRB, &
  & 0.26110203E-09_JPRB, 0.26133551E-09_JPRB, 0.26149646E-09_JPRB, 0.26157257E-09_JPRB, 0.26157340E-09_JPRB, 0.26151017E-09_JPRB, &
  & 0.26139380E-09_JPRB, 0.26123789E-09_JPRB, 0.26105154E-09_JPRB, 0.26084199E-09_JPRB, 0.26061345E-09_JPRB, 0.26037014E-09_JPRB, &
  & 0.26011948E-09_JPRB, 0.25986541E-09_JPRB, 0.25960686E-09_JPRB, 0.25932070E-09_JPRB, 0.25896937E-09_JPRB, 0.25848512E-09_JPRB, &
  & 0.25781904E-09_JPRB, 0.25695085E-09_JPRB, 0.25599875E-09_JPRB, 0.25508906E-09_JPRB, 0.25433317E-09_JPRB, 0.25372310E-09_JPRB, &
  & 0.25320626E-09_JPRB, 0.25272678E-09_JPRB, 0.25223931E-09_JPRB, 0.25171273E-09_JPRB, 0.25114505E-09_JPRB, 0.25057043E-09_JPRB, &
  & 0.25003197E-09_JPRB, 0.24952826E-09_JPRB, 0.24898289E-09_JPRB, 0.24804797E-09_JPRB /)

RGHG5(:,50,10) = (/ &
  & 0.24395230E-09_JPRB, 0.24570992E-09_JPRB, 0.24681918E-09_JPRB, 0.24799868E-09_JPRB, 0.24942987E-09_JPRB, 0.25088984E-09_JPRB, &
  & 0.25195879E-09_JPRB, 0.25263747E-09_JPRB, 0.25306568E-09_JPRB, 0.25336022E-09_JPRB, 0.25359706E-09_JPRB, 0.25381594E-09_JPRB, &
  & 0.25405386E-09_JPRB, 0.25435110E-09_JPRB, 0.25470370E-09_JPRB, 0.25512359E-09_JPRB, 0.25552302E-09_JPRB, 0.25588859E-09_JPRB, &
  & 0.25623573E-09_JPRB, 0.25660313E-09_JPRB, 0.25701719E-09_JPRB, 0.25748112E-09_JPRB, 0.25797864E-09_JPRB, 0.25848473E-09_JPRB, &
  & 0.25897676E-09_JPRB, 0.25943972E-09_JPRB, 0.25986918E-09_JPRB, 0.26026342E-09_JPRB, 0.26062347E-09_JPRB, 0.26094729E-09_JPRB, &
  & 0.26122857E-09_JPRB, 0.26145305E-09_JPRB, 0.26160590E-09_JPRB, 0.26167646E-09_JPRB, 0.26167341E-09_JPRB, 0.26160879E-09_JPRB, &
  & 0.26149399E-09_JPRB, 0.26134173E-09_JPRB, 0.26116276E-09_JPRB, 0.26096492E-09_JPRB, 0.26075372E-09_JPRB, 0.26053612E-09_JPRB, &
  & 0.26032027E-09_JPRB, 0.26011443E-09_JPRB, 0.25991487E-09_JPRB, 0.25971270E-09_JPRB, 0.25947769E-09_JPRB, 0.25917468E-09_JPRB, &
  & 0.25876642E-09_JPRB, 0.25825236E-09_JPRB, 0.25765784E-09_JPRB, 0.25707653E-09_JPRB, 0.25655497E-09_JPRB, 0.25611432E-09_JPRB, &
  & 0.25572175E-09_JPRB, 0.25534841E-09_JPRB, 0.25496161E-09_JPRB, 0.25453153E-09_JPRB, 0.25406588E-09_JPRB, 0.25359020E-09_JPRB, &
  & 0.25314589E-09_JPRB, 0.25272170E-09_JPRB, 0.25226843E-09_JPRB, 0.25146724E-09_JPRB /)

RGHG5(:,51,10) = (/ &
  & 0.24875410E-09_JPRB, 0.25020203E-09_JPRB, 0.25110058E-09_JPRB, 0.25205471E-09_JPRB, 0.25319480E-09_JPRB, 0.25432312E-09_JPRB, &
  & 0.25509259E-09_JPRB, 0.25553182E-09_JPRB, 0.25578739E-09_JPRB, 0.25595479E-09_JPRB, 0.25607499E-09_JPRB, 0.25617874E-09_JPRB, &
  & 0.25627916E-09_JPRB, 0.25638378E-09_JPRB, 0.25650485E-09_JPRB, 0.25662278E-09_JPRB, 0.25673991E-09_JPRB, 0.25685706E-09_JPRB, &
  & 0.25700070E-09_JPRB, 0.25719837E-09_JPRB, 0.25747196E-09_JPRB, 0.25782360E-09_JPRB, 0.25823912E-09_JPRB, 0.25869157E-09_JPRB, &
  & 0.25915189E-09_JPRB, 0.25959718E-09_JPRB, 0.26001626E-09_JPRB, 0.26040289E-09_JPRB, 0.26075575E-09_JPRB, 0.26107255E-09_JPRB, &
  & 0.26134545E-09_JPRB, 0.26156177E-09_JPRB, 0.26170668E-09_JPRB, 0.26177230E-09_JPRB, 0.26176597E-09_JPRB, 0.26170019E-09_JPRB, &
  & 0.26158664E-09_JPRB, 0.26143818E-09_JPRB, 0.26126537E-09_JPRB, 0.26107644E-09_JPRB, 0.26087849E-09_JPRB, 0.26067873E-09_JPRB, &
  & 0.26048996E-09_JPRB, 0.26031605E-09_JPRB, 0.26016211E-09_JPRB, 0.26001401E-09_JPRB, 0.25985825E-09_JPRB, 0.25967195E-09_JPRB, &
  & 0.25944027E-09_JPRB, 0.25916216E-09_JPRB, 0.25885949E-09_JPRB, 0.25855373E-09_JPRB, 0.25827485E-09_JPRB, 0.25801888E-09_JPRB, &
  & 0.25778360E-09_JPRB, 0.25754246E-09_JPRB, 0.25727498E-09_JPRB, 0.25696961E-09_JPRB, 0.25661642E-09_JPRB, 0.25625274E-09_JPRB, &
  & 0.25589680E-09_JPRB, 0.25555769E-09_JPRB, 0.25516389E-09_JPRB, 0.25448660E-09_JPRB /)

RGHG5(:,52,10) = (/ &
  & 0.25261951E-09_JPRB, 0.25349109E-09_JPRB, 0.25408356E-09_JPRB, 0.25476568E-09_JPRB, 0.25561975E-09_JPRB, 0.25642558E-09_JPRB, &
  & 0.25693339E-09_JPRB, 0.25720570E-09_JPRB, 0.25735586E-09_JPRB, 0.25744504E-09_JPRB, 0.25750713E-09_JPRB, 0.25755093E-09_JPRB, &
  & 0.25758312E-09_JPRB, 0.25760355E-09_JPRB, 0.25760702E-09_JPRB, 0.25759220E-09_JPRB, 0.25756983E-09_JPRB, 0.25755897E-09_JPRB, &
  & 0.25758606E-09_JPRB, 0.25767649E-09_JPRB, 0.25785077E-09_JPRB, 0.25811855E-09_JPRB, 0.25846897E-09_JPRB, 0.25887847E-09_JPRB, &
  & 0.25931249E-09_JPRB, 0.25974414E-09_JPRB, 0.26015320E-09_JPRB, 0.26053332E-09_JPRB, 0.26087935E-09_JPRB, 0.26118877E-09_JPRB, &
  & 0.26145416E-09_JPRB, 0.26166233E-09_JPRB, 0.26180005E-09_JPRB, 0.26186109E-09_JPRB, 0.26185221E-09_JPRB, 0.26178545E-09_JPRB, &
  & 0.26167354E-09_JPRB, 0.26152852E-09_JPRB, 0.26136129E-09_JPRB, 0.26117999E-09_JPRB, 0.26099117E-09_JPRB, 0.26080571E-09_JPRB, &
  & 0.26063379E-09_JPRB, 0.26048808E-09_JPRB, 0.26036256E-09_JPRB, 0.26025568E-09_JPRB, 0.26015148E-09_JPRB, 0.26003974E-09_JPRB, &
  & 0.25991437E-09_JPRB, 0.25977859E-09_JPRB, 0.25963912E-09_JPRB, 0.25950680E-09_JPRB, 0.25938438E-09_JPRB, 0.25927449E-09_JPRB, &
  & 0.25916289E-09_JPRB, 0.25904454E-09_JPRB, 0.25890312E-09_JPRB, 0.25872268E-09_JPRB, 0.25850944E-09_JPRB, 0.25827113E-09_JPRB, &
  & 0.25803693E-09_JPRB, 0.25779284E-09_JPRB, 0.25751273E-09_JPRB, 0.25695329E-09_JPRB /)

RGHG5(:,53,10) = (/ &
  & 0.25480990E-09_JPRB, 0.25551208E-09_JPRB, 0.25598959E-09_JPRB, 0.25649852E-09_JPRB, 0.25712202E-09_JPRB, 0.25768032E-09_JPRB, &
  & 0.25801378E-09_JPRB, 0.25817815E-09_JPRB, 0.25826385E-09_JPRB, 0.25831465E-09_JPRB, 0.25834460E-09_JPRB, 0.25836219E-09_JPRB, &
  & 0.25836622E-09_JPRB, 0.25835251E-09_JPRB, 0.25831196E-09_JPRB, 0.25824606E-09_JPRB, 0.25816171E-09_JPRB, 0.25808861E-09_JPRB, &
  & 0.25804978E-09_JPRB, 0.25807098E-09_JPRB, 0.25817604E-09_JPRB, 0.25837957E-09_JPRB, 0.25867944E-09_JPRB, 0.25905211E-09_JPRB, &
  & 0.25946492E-09_JPRB, 0.25988034E-09_JPRB, 0.26028235E-09_JPRB, 0.26065367E-09_JPRB, 0.26099423E-09_JPRB, 0.26129682E-09_JPRB, &
  & 0.26155483E-09_JPRB, 0.26175551E-09_JPRB, 0.26188643E-09_JPRB, 0.26194355E-09_JPRB, 0.26193275E-09_JPRB, 0.26186578E-09_JPRB, &
  & 0.26175517E-09_JPRB, 0.26161392E-09_JPRB, 0.26145200E-09_JPRB, 0.26127669E-09_JPRB, 0.26109603E-09_JPRB, 0.26091940E-09_JPRB, &
  & 0.26076463E-09_JPRB, 0.26063424E-09_JPRB, 0.26053573E-09_JPRB, 0.26045494E-09_JPRB, 0.26038699E-09_JPRB, 0.26032199E-09_JPRB, &
  & 0.26025754E-09_JPRB, 0.26019456E-09_JPRB, 0.26013608E-09_JPRB, 0.26008323E-09_JPRB, 0.26003708E-09_JPRB, 0.25999242E-09_JPRB, &
  & 0.25994873E-09_JPRB, 0.25989566E-09_JPRB, 0.25982788E-09_JPRB, 0.25973854E-09_JPRB, 0.25962235E-09_JPRB, 0.25949509E-09_JPRB, &
  & 0.25936381E-09_JPRB, 0.25923341E-09_JPRB, 0.25906785E-09_JPRB, 0.25873068E-09_JPRB /)

RGHG5(:,54,10) = (/ &
  & 0.25641170E-09_JPRB, 0.25693520E-09_JPRB, 0.25726093E-09_JPRB, 0.25764674E-09_JPRB, 0.25808683E-09_JPRB, 0.25847674E-09_JPRB, &
  & 0.25868555E-09_JPRB, 0.25878755E-09_JPRB, 0.25883859E-09_JPRB, 0.25886596E-09_JPRB, 0.25888131E-09_JPRB, 0.25888630E-09_JPRB, &
  & 0.25887972E-09_JPRB, 0.25885516E-09_JPRB, 0.25880476E-09_JPRB, 0.25871774E-09_JPRB, 0.25861255E-09_JPRB, 0.25850766E-09_JPRB, &
  & 0.25843072E-09_JPRB, 0.25840657E-09_JPRB, 0.25846197E-09_JPRB, 0.25861796E-09_JPRB, 0.25887714E-09_JPRB, 0.25922015E-09_JPRB, &
  & 0.25960889E-09_JPRB, 0.26001207E-09_JPRB, 0.26040026E-09_JPRB, 0.26076680E-09_JPRB, 0.26110022E-09_JPRB, 0.26139707E-09_JPRB, &
  & 0.26164831E-09_JPRB, 0.26184149E-09_JPRB, 0.26196667E-09_JPRB, 0.26202038E-09_JPRB, 0.26200833E-09_JPRB, 0.26194177E-09_JPRB, &
  & 0.26183314E-09_JPRB, 0.26169508E-09_JPRB, 0.26153768E-09_JPRB, 0.26136843E-09_JPRB, 0.26119379E-09_JPRB, 0.26102745E-09_JPRB, &
  & 0.26088107E-09_JPRB, 0.26076985E-09_JPRB, 0.26068578E-09_JPRB, 0.26062746E-09_JPRB, 0.26058300E-09_JPRB, 0.26054695E-09_JPRB, &
  & 0.26051580E-09_JPRB, 0.26048921E-09_JPRB, 0.26046648E-09_JPRB, 0.26044750E-09_JPRB, 0.26043045E-09_JPRB, 0.26041463E-09_JPRB, &
  & 0.26039557E-09_JPRB, 0.26037250E-09_JPRB, 0.26033950E-09_JPRB, 0.26029243E-09_JPRB, 0.26023281E-09_JPRB, 0.26016578E-09_JPRB, &
  & 0.26010269E-09_JPRB, 0.26004421E-09_JPRB, 0.25999042E-09_JPRB, 0.25992272E-09_JPRB /)

RGHG5(:,55,10) = (/ &
  & 0.25749541E-09_JPRB, 0.25788260E-09_JPRB, 0.25815675E-09_JPRB, 0.25842425E-09_JPRB, 0.25875255E-09_JPRB, 0.25900648E-09_JPRB, &
  & 0.25914570E-09_JPRB, 0.25920754E-09_JPRB, 0.25923816E-09_JPRB, 0.25925426E-09_JPRB, 0.25926158E-09_JPRB, 0.25926170E-09_JPRB, &
  & 0.25925234E-09_JPRB, 0.25922736E-09_JPRB, 0.25917507E-09_JPRB, 0.25909097E-09_JPRB, 0.25897529E-09_JPRB, 0.25885558E-09_JPRB, &
  & 0.25875518E-09_JPRB, 0.25870003E-09_JPRB, 0.25871999E-09_JPRB, 0.25884028E-09_JPRB, 0.25906777E-09_JPRB, 0.25938313E-09_JPRB, &
  & 0.25975100E-09_JPRB, 0.26013458E-09_JPRB, 0.26051414E-09_JPRB, 0.26087094E-09_JPRB, 0.26119959E-09_JPRB, 0.26149050E-09_JPRB, &
  & 0.26173488E-09_JPRB, 0.26192140E-09_JPRB, 0.26204108E-09_JPRB, 0.26209218E-09_JPRB, 0.26207966E-09_JPRB, 0.26201416E-09_JPRB, &
  & 0.26190788E-09_JPRB, 0.26177305E-09_JPRB, 0.26161998E-09_JPRB, 0.26145536E-09_JPRB, 0.26128799E-09_JPRB, 0.26112826E-09_JPRB, &
  & 0.26099517E-09_JPRB, 0.26089245E-09_JPRB, 0.26082489E-09_JPRB, 0.26078009E-09_JPRB, 0.26075231E-09_JPRB, 0.26073377E-09_JPRB, &
  & 0.26072078E-09_JPRB, 0.26071137E-09_JPRB, 0.26070449E-09_JPRB, 0.26069888E-09_JPRB, 0.26069374E-09_JPRB, 0.26068742E-09_JPRB, &
  & 0.26067970E-09_JPRB, 0.26066774E-09_JPRB, 0.26065006E-09_JPRB, 0.26062397E-09_JPRB, 0.26058861E-09_JPRB, 0.26055008E-09_JPRB, &
  & 0.26051242E-09_JPRB, 0.26047675E-09_JPRB, 0.26043695E-09_JPRB, 0.26037159E-09_JPRB /)

RGHG5(:,56,10) = (/ &
  & 0.25829441E-09_JPRB, 0.25860505E-09_JPRB, 0.25878535E-09_JPRB, 0.25899882E-09_JPRB, 0.25921970E-09_JPRB, 0.25939983E-09_JPRB, &
  & 0.25948621E-09_JPRB, 0.25952634E-09_JPRB, 0.25954505E-09_JPRB, 0.25955443E-09_JPRB, 0.25955821E-09_JPRB, 0.25955660E-09_JPRB, &
  & 0.25954727E-09_JPRB, 0.25952512E-09_JPRB, 0.25948016E-09_JPRB, 0.25939814E-09_JPRB, 0.25928504E-09_JPRB, 0.25915675E-09_JPRB, &
  & 0.25904034E-09_JPRB, 0.25896357E-09_JPRB, 0.25895802E-09_JPRB, 0.25905203E-09_JPRB, 0.25925367E-09_JPRB, 0.25954378E-09_JPRB, &
  & 0.25988892E-09_JPRB, 0.26025604E-09_JPRB, 0.26062130E-09_JPRB, 0.26097108E-09_JPRB, 0.26129315E-09_JPRB, 0.26157804E-09_JPRB, &
  & 0.26181576E-09_JPRB, 0.26199565E-09_JPRB, 0.26211094E-09_JPRB, 0.26215999E-09_JPRB, 0.26214758E-09_JPRB, 0.26208394E-09_JPRB, &
  & 0.26198055E-09_JPRB, 0.26184896E-09_JPRB, 0.26169922E-09_JPRB, 0.26154004E-09_JPRB, 0.26137795E-09_JPRB, 0.26122807E-09_JPRB, &
  & 0.26110220E-09_JPRB, 0.26101230E-09_JPRB, 0.26095337E-09_JPRB, 0.26092026E-09_JPRB, 0.26090313E-09_JPRB, 0.26089519E-09_JPRB, &
  & 0.26089181E-09_JPRB, 0.26089059E-09_JPRB, 0.26089017E-09_JPRB, 0.26088964E-09_JPRB, 0.26088837E-09_JPRB, 0.26088606E-09_JPRB, &
  & 0.26088173E-09_JPRB, 0.26087510E-09_JPRB, 0.26086408E-09_JPRB, 0.26084701E-09_JPRB, 0.26082481E-09_JPRB, 0.26080013E-09_JPRB, &
  & 0.26077643E-09_JPRB, 0.26075381E-09_JPRB, 0.26073038E-09_JPRB, 0.26069286E-09_JPRB /)

RGHG5(:,57,10) = (/ &
  & 0.25888472E-09_JPRB, 0.25911517E-09_JPRB, 0.25927110E-09_JPRB, 0.25941657E-09_JPRB, 0.25958186E-09_JPRB, 0.25969937E-09_JPRB, &
  & 0.25975924E-09_JPRB, 0.25978505E-09_JPRB, 0.25979768E-09_JPRB, 0.25980396E-09_JPRB, 0.25980618E-09_JPRB, 0.25980448E-09_JPRB, &
  & 0.25979707E-09_JPRB, 0.25977873E-09_JPRB, 0.25974017E-09_JPRB, 0.25966876E-09_JPRB, 0.25955721E-09_JPRB, 0.25942490E-09_JPRB, &
  & 0.25929786E-09_JPRB, 0.25920605E-09_JPRB, 0.25918256E-09_JPRB, 0.25925639E-09_JPRB, 0.25943545E-09_JPRB, 0.25970331E-09_JPRB, &
  & 0.26002589E-09_JPRB, 0.26037517E-09_JPRB, 0.26072797E-09_JPRB, 0.26106783E-09_JPRB, 0.26138280E-09_JPRB, 0.26166083E-09_JPRB, &
  & 0.26189154E-09_JPRB, 0.26206548E-09_JPRB, 0.26217700E-09_JPRB, 0.26222471E-09_JPRB, 0.26221320E-09_JPRB, 0.26215197E-09_JPRB, &
  & 0.26205180E-09_JPRB, 0.26192359E-09_JPRB, 0.26177799E-09_JPRB, 0.26162225E-09_JPRB, 0.26146751E-09_JPRB, 0.26132427E-09_JPRB, &
  & 0.26120886E-09_JPRB, 0.26112632E-09_JPRB, 0.26107658E-09_JPRB, 0.26105085E-09_JPRB, 0.26104105E-09_JPRB, 0.26103947E-09_JPRB, &
  & 0.26104113E-09_JPRB, 0.26104341E-09_JPRB, 0.26104502E-09_JPRB, 0.26104563E-09_JPRB, 0.26104519E-09_JPRB, 0.26104346E-09_JPRB, &
  & 0.26104055E-09_JPRB, 0.26103536E-09_JPRB, 0.26102717E-09_JPRB, 0.26101485E-09_JPRB, 0.26099845E-09_JPRB, 0.26098090E-09_JPRB, &
  & 0.26096403E-09_JPRB, 0.26094768E-09_JPRB, 0.26092906E-09_JPRB, 0.26089686E-09_JPRB /)

RGHG5(:,58,10) = (/ &
  & 0.25936467E-09_JPRB, 0.25953478E-09_JPRB, 0.25963690E-09_JPRB, 0.25975103E-09_JPRB, 0.25986546E-09_JPRB, 0.25994951E-09_JPRB, &
  & 0.25998997E-09_JPRB, 0.26000876E-09_JPRB, 0.26001790E-09_JPRB, 0.26002281E-09_JPRB, 0.26002489E-09_JPRB, 0.26002409E-09_JPRB, &
  & 0.26001856E-09_JPRB, 0.26000491E-09_JPRB, 0.25997299E-09_JPRB, 0.25990943E-09_JPRB, 0.25980429E-09_JPRB, 0.25966959E-09_JPRB, &
  & 0.25953578E-09_JPRB, 0.25943386E-09_JPRB, 0.25939817E-09_JPRB, 0.25945601E-09_JPRB, 0.25961550E-09_JPRB, 0.25986077E-09_JPRB, &
  & 0.26016381E-09_JPRB, 0.26049521E-09_JPRB, 0.26083471E-09_JPRB, 0.26116367E-09_JPRB, 0.26147004E-09_JPRB, 0.26173996E-09_JPRB, &
  & 0.26196323E-09_JPRB, 0.26213193E-09_JPRB, 0.26224023E-09_JPRB, 0.26228719E-09_JPRB, 0.26227723E-09_JPRB, 0.26221900E-09_JPRB, &
  & 0.26212255E-09_JPRB, 0.26199815E-09_JPRB, 0.26185579E-09_JPRB, 0.26170560E-09_JPRB, 0.26155542E-09_JPRB, 0.26142058E-09_JPRB, &
  & 0.26131255E-09_JPRB, 0.26123823E-09_JPRB, 0.26119487E-09_JPRB, 0.26117497E-09_JPRB, 0.26116992E-09_JPRB, 0.26117217E-09_JPRB, &
  & 0.26117622E-09_JPRB, 0.26117936E-09_JPRB, 0.26118080E-09_JPRB, 0.26118058E-09_JPRB, 0.26117927E-09_JPRB, 0.26117714E-09_JPRB, &
  & 0.26117375E-09_JPRB, 0.26116898E-09_JPRB, 0.26116165E-09_JPRB, 0.26115082E-09_JPRB, 0.26113750E-09_JPRB, 0.26112351E-09_JPRB, &
  & 0.26111024E-09_JPRB, 0.26109759E-09_JPRB, 0.26108377E-09_JPRB, 0.26106017E-09_JPRB /)

RGHG5(:,59,10) = (/ &
  & 0.25970609E-09_JPRB, 0.25984456E-09_JPRB, 0.25993369E-09_JPRB, 0.26001709E-09_JPRB, 0.26010205E-09_JPRB, 0.26016311E-09_JPRB, &
  & 0.26019403E-09_JPRB, 0.26020883E-09_JPRB, 0.26021685E-09_JPRB, 0.26022168E-09_JPRB, 0.26022443E-09_JPRB, 0.26022509E-09_JPRB, &
  & 0.26022226E-09_JPRB, 0.26021185E-09_JPRB, 0.26018696E-09_JPRB, 0.26013056E-09_JPRB, 0.26003080E-09_JPRB, 0.25989677E-09_JPRB, &
  & 0.25975905E-09_JPRB, 0.25965236E-09_JPRB, 0.25960806E-09_JPRB, 0.25965258E-09_JPRB, 0.25979366E-09_JPRB, 0.26001942E-09_JPRB, &
  & 0.26030270E-09_JPRB, 0.26061742E-09_JPRB, 0.26094291E-09_JPRB, 0.26125985E-09_JPRB, 0.26155597E-09_JPRB, 0.26181618E-09_JPRB, &
  & 0.26203253E-09_JPRB, 0.26219577E-09_JPRB, 0.26230132E-09_JPRB, 0.26234792E-09_JPRB, 0.26233987E-09_JPRB, 0.26228508E-09_JPRB, &
  & 0.26219277E-09_JPRB, 0.26207245E-09_JPRB, 0.26193478E-09_JPRB, 0.26178817E-09_JPRB, 0.26164457E-09_JPRB, 0.26151581E-09_JPRB, &
  & 0.26141544E-09_JPRB, 0.26134764E-09_JPRB, 0.26130978E-09_JPRB, 0.26129415E-09_JPRB, 0.26129224E-09_JPRB, 0.26129665E-09_JPRB, &
  & 0.26130159E-09_JPRB, 0.26130423E-09_JPRB, 0.26130414E-09_JPRB, 0.26130215E-09_JPRB, 0.26129937E-09_JPRB, 0.26129582E-09_JPRB, &
  & 0.26129168E-09_JPRB, 0.26128597E-09_JPRB, 0.26127819E-09_JPRB, 0.26126784E-09_JPRB, 0.26125535E-09_JPRB, 0.26124286E-09_JPRB, &
  & 0.26123137E-09_JPRB, 0.26122035E-09_JPRB, 0.26120789E-09_JPRB, 0.26118649E-09_JPRB /)

RGHG5(:,60,10) = (/ &
  & 0.25999736E-09_JPRB, 0.26011174E-09_JPRB, 0.26017746E-09_JPRB, 0.26024305E-09_JPRB, 0.26030750E-09_JPRB, 0.26035415E-09_JPRB, &
  & 0.26037969E-09_JPRB, 0.26039298E-09_JPRB, 0.26040098E-09_JPRB, 0.26040653E-09_JPRB, 0.26041075E-09_JPRB, 0.26041336E-09_JPRB, &
  & 0.26041336E-09_JPRB, 0.26040753E-09_JPRB, 0.26038671E-09_JPRB, 0.26033772E-09_JPRB, 0.26024213E-09_JPRB, 0.26011007E-09_JPRB, &
  & 0.25997318E-09_JPRB, 0.25986419E-09_JPRB, 0.25981431E-09_JPRB, 0.25984731E-09_JPRB, 0.25997218E-09_JPRB, 0.26017902E-09_JPRB, &
  & 0.26044400E-09_JPRB, 0.26074246E-09_JPRB, 0.26105307E-09_JPRB, 0.26135710E-09_JPRB, 0.26164093E-09_JPRB, 0.26189173E-09_JPRB, &
  & 0.26209993E-09_JPRB, 0.26225810E-09_JPRB, 0.26236077E-09_JPRB, 0.26240715E-09_JPRB, 0.26240127E-09_JPRB, 0.26235022E-09_JPRB, &
  & 0.26226216E-09_JPRB, 0.26214675E-09_JPRB, 0.26201333E-09_JPRB, 0.26187216E-09_JPRB, 0.26173341E-09_JPRB, 0.26161140E-09_JPRB, &
  & 0.26151725E-09_JPRB, 0.26145525E-09_JPRB, 0.26142200E-09_JPRB, 0.26140953E-09_JPRB, 0.26140973E-09_JPRB, 0.26141522E-09_JPRB, &
  & 0.26142027E-09_JPRB, 0.26142163E-09_JPRB, 0.26141930E-09_JPRB, 0.26141495E-09_JPRB, 0.26140995E-09_JPRB, 0.26140495E-09_JPRB, &
  & 0.26139912E-09_JPRB, 0.26139230E-09_JPRB, 0.26138341E-09_JPRB, 0.26137204E-09_JPRB, 0.26135943E-09_JPRB, 0.26134730E-09_JPRB, &
  & 0.26133629E-09_JPRB, 0.26132602E-09_JPRB, 0.26131491E-09_JPRB, 0.26129585E-09_JPRB /)

RGHG5(:,61,10) = (/ &
  & 0.26023611E-09_JPRB, 0.26033148E-09_JPRB, 0.26038824E-09_JPRB, 0.26043964E-09_JPRB, 0.26048974E-09_JPRB, 0.26052907E-09_JPRB, &
  & 0.26055191E-09_JPRB, 0.26056529E-09_JPRB, 0.26057423E-09_JPRB, 0.26058131E-09_JPRB, 0.26058747E-09_JPRB, 0.26059302E-09_JPRB, &
  & 0.26059654E-09_JPRB, 0.26059477E-09_JPRB, 0.26057972E-09_JPRB, 0.26053354E-09_JPRB, 0.26044228E-09_JPRB, 0.26031446E-09_JPRB, &
  & 0.26018021E-09_JPRB, 0.26007216E-09_JPRB, 0.26001823E-09_JPRB, 0.26004179E-09_JPRB, 0.26015176E-09_JPRB, 0.26034111E-09_JPRB, &
  & 0.26058858E-09_JPRB, 0.26087024E-09_JPRB, 0.26116578E-09_JPRB, 0.26145583E-09_JPRB, 0.26172686E-09_JPRB, 0.26196673E-09_JPRB, &
  & 0.26216726E-09_JPRB, 0.26231933E-09_JPRB, 0.26241892E-09_JPRB, 0.26246505E-09_JPRB, 0.26246125E-09_JPRB, 0.26241379E-09_JPRB, &
  & 0.26233052E-09_JPRB, 0.26222008E-09_JPRB, 0.26209201E-09_JPRB, 0.26195562E-09_JPRB, 0.26182292E-09_JPRB, 0.26170677E-09_JPRB, &
  & 0.26161859E-09_JPRB, 0.26156152E-09_JPRB, 0.26153199E-09_JPRB, 0.26152205E-09_JPRB, 0.26152361E-09_JPRB, 0.26152949E-09_JPRB, &
  & 0.26153424E-09_JPRB, 0.26153435E-09_JPRB, 0.26152958E-09_JPRB, 0.26152247E-09_JPRB, 0.26151514E-09_JPRB, 0.26150770E-09_JPRB, &
  & 0.26150021E-09_JPRB, 0.26149133E-09_JPRB, 0.26148053E-09_JPRB, 0.26146774E-09_JPRB, 0.26145397E-09_JPRB, 0.26144109E-09_JPRB, &
  & 0.26142979E-09_JPRB, 0.26141933E-09_JPRB, 0.26140787E-09_JPRB, 0.26138891E-09_JPRB /)

RGHG5(:,62,10) = (/ &
  & 0.26044744E-09_JPRB, 0.26052899E-09_JPRB, 0.26057453E-09_JPRB, 0.26061675E-09_JPRB, 0.26065836E-09_JPRB, 0.26069188E-09_JPRB, &
  & 0.26071428E-09_JPRB, 0.26072849E-09_JPRB, 0.26073912E-09_JPRB, 0.26074834E-09_JPRB, 0.26075744E-09_JPRB, 0.26076655E-09_JPRB, &
  & 0.26077501E-09_JPRB, 0.26077834E-09_JPRB, 0.26076694E-09_JPRB, 0.26072358E-09_JPRB, 0.26063524E-09_JPRB, 0.26051233E-09_JPRB, &
  & 0.26038358E-09_JPRB, 0.26027730E-09_JPRB, 0.26022104E-09_JPRB, 0.26023686E-09_JPRB, 0.26033387E-09_JPRB, 0.26050678E-09_JPRB, &
  & 0.26073671E-09_JPRB, 0.26100203E-09_JPRB, 0.26128166E-09_JPRB, 0.26155716E-09_JPRB, 0.26181429E-09_JPRB, 0.26204355E-09_JPRB, &
  & 0.26223468E-09_JPRB, 0.26238048E-09_JPRB, 0.26247637E-09_JPRB, 0.26252162E-09_JPRB, 0.26251962E-09_JPRB, 0.26247587E-09_JPRB, &
  & 0.26239744E-09_JPRB, 0.26229252E-09_JPRB, 0.26216998E-09_JPRB, 0.26203939E-09_JPRB, 0.26191249E-09_JPRB, 0.26180233E-09_JPRB, &
  & 0.26171942E-09_JPRB, 0.26166672E-09_JPRB, 0.26164021E-09_JPRB, 0.26163219E-09_JPRB, 0.26163460E-09_JPRB, 0.26164049E-09_JPRB, &
  & 0.26164473E-09_JPRB, 0.26164379E-09_JPRB, 0.26163716E-09_JPRB, 0.26162728E-09_JPRB, 0.26161712E-09_JPRB, 0.26160735E-09_JPRB, &
  & 0.26159708E-09_JPRB, 0.26158575E-09_JPRB, 0.26157249E-09_JPRB, 0.26155711E-09_JPRB, 0.26154146E-09_JPRB, 0.26152730E-09_JPRB, &
  & 0.26151492E-09_JPRB, 0.26150360E-09_JPRB, 0.26149158E-09_JPRB, 0.26147121E-09_JPRB /)

RGHG5(:,63,10) = (/ &
  & 0.26062977E-09_JPRB, 0.26070318E-09_JPRB, 0.26074407E-09_JPRB, 0.26078029E-09_JPRB, 0.26081559E-09_JPRB, 0.26084662E-09_JPRB, &
  & 0.26086860E-09_JPRB, 0.26088459E-09_JPRB, 0.26089733E-09_JPRB, 0.26090943E-09_JPRB, 0.26092223E-09_JPRB, 0.26093638E-09_JPRB, &
  & 0.26095048E-09_JPRB, 0.26095925E-09_JPRB, 0.26095071E-09_JPRB, 0.26090841E-09_JPRB, 0.26082303E-09_JPRB, 0.26070734E-09_JPRB, &
  & 0.26058422E-09_JPRB, 0.26048100E-09_JPRB, 0.26042379E-09_JPRB, 0.26043362E-09_JPRB, 0.26051936E-09_JPRB, 0.26067695E-09_JPRB, &
  & 0.26088998E-09_JPRB, 0.26113836E-09_JPRB, 0.26140179E-09_JPRB, 0.26166186E-09_JPRB, 0.26190500E-09_JPRB, 0.26212207E-09_JPRB, &
  & 0.26230340E-09_JPRB, 0.26244151E-09_JPRB, 0.26253291E-09_JPRB, 0.26257679E-09_JPRB, 0.26257624E-09_JPRB, 0.26253610E-09_JPRB, &
  & 0.26246280E-09_JPRB, 0.26236377E-09_JPRB, 0.26224725E-09_JPRB, 0.26212285E-09_JPRB, 0.26200217E-09_JPRB, 0.26189800E-09_JPRB, &
  & 0.26182007E-09_JPRB, 0.26177110E-09_JPRB, 0.26174704E-09_JPRB, 0.26174038E-09_JPRB, 0.26174318E-09_JPRB, 0.26174882E-09_JPRB, &
  & 0.26175251E-09_JPRB, 0.26175090E-09_JPRB, 0.26174291E-09_JPRB, 0.26173105E-09_JPRB, 0.26171815E-09_JPRB, 0.26170530E-09_JPRB, &
  & 0.26169228E-09_JPRB, 0.26167779E-09_JPRB, 0.26166108E-09_JPRB, 0.26164274E-09_JPRB, 0.26162433E-09_JPRB, 0.26160785E-09_JPRB, &
  & 0.26159369E-09_JPRB, 0.26158062E-09_JPRB, 0.26156635E-09_JPRB, 0.26154312E-09_JPRB /)

RGHG5(:,64,10) = (/ &
  & 0.26079489E-09_JPRB, 0.26086372E-09_JPRB, 0.26090122E-09_JPRB, 0.26093355E-09_JPRB, 0.26096555E-09_JPRB, 0.26099395E-09_JPRB, &
  & 0.26101699E-09_JPRB, 0.26103425E-09_JPRB, 0.26105001E-09_JPRB, 0.26106550E-09_JPRB, 0.26108316E-09_JPRB, 0.26110339E-09_JPRB, &
  & 0.26112412E-09_JPRB, 0.26113775E-09_JPRB, 0.26113070E-09_JPRB, 0.26108843E-09_JPRB, 0.26100794E-09_JPRB, 0.26089853E-09_JPRB, &
  & 0.26078176E-09_JPRB, 0.26068245E-09_JPRB, 0.26062594E-09_JPRB, 0.26063152E-09_JPRB, 0.26070762E-09_JPRB, 0.26085109E-09_JPRB, &
  & 0.26104760E-09_JPRB, 0.26127908E-09_JPRB, 0.26152561E-09_JPRB, 0.26176958E-09_JPRB, 0.26199784E-09_JPRB, 0.26220195E-09_JPRB, &
  & 0.26237193E-09_JPRB, 0.26250171E-09_JPRB, 0.26258762E-09_JPRB, 0.26262939E-09_JPRB, 0.26262986E-09_JPRB, 0.26259331E-09_JPRB, &
  & 0.26252547E-09_JPRB, 0.26243269E-09_JPRB, 0.26232297E-09_JPRB, 0.26220523E-09_JPRB, 0.26209127E-09_JPRB, 0.26199298E-09_JPRB, &
  & 0.26191971E-09_JPRB, 0.26187397E-09_JPRB, 0.26185179E-09_JPRB, 0.26184599E-09_JPRB, 0.26184888E-09_JPRB, 0.26185401E-09_JPRB, &
  & 0.26185706E-09_JPRB, 0.26185495E-09_JPRB, 0.26184677E-09_JPRB, 0.26183350E-09_JPRB, 0.26181823E-09_JPRB, 0.26180269E-09_JPRB, &
  & 0.26178623E-09_JPRB, 0.26176816E-09_JPRB, 0.26174790E-09_JPRB, 0.26172567E-09_JPRB, 0.26170408E-09_JPRB, 0.26168490E-09_JPRB, &
  & 0.26166802E-09_JPRB, 0.26165212E-09_JPRB, 0.26163488E-09_JPRB, 0.26160527E-09_JPRB /)

RGHG5(:,65,10) = (/ &
  & 0.26094649E-09_JPRB, 0.26101382E-09_JPRB, 0.26104929E-09_JPRB, 0.26108016E-09_JPRB, 0.26110950E-09_JPRB, 0.26113722E-09_JPRB, &
  & 0.26115979E-09_JPRB, 0.26118019E-09_JPRB, 0.26119809E-09_JPRB, 0.26121857E-09_JPRB, 0.26124131E-09_JPRB, 0.26126809E-09_JPRB, &
  & 0.26129438E-09_JPRB, 0.26130983E-09_JPRB, 0.26130259E-09_JPRB, 0.26126273E-09_JPRB, 0.26118746E-09_JPRB, 0.26108565E-09_JPRB, &
  & 0.26097569E-09_JPRB, 0.26088171E-09_JPRB, 0.26082697E-09_JPRB, 0.26082986E-09_JPRB, 0.26089791E-09_JPRB, 0.26102809E-09_JPRB, &
  & 0.26120883E-09_JPRB, 0.26142272E-09_JPRB, 0.26165164E-09_JPRB, 0.26187849E-09_JPRB, 0.26209118E-09_JPRB, 0.26228097E-09_JPRB, &
  & 0.26243885E-09_JPRB, 0.26255925E-09_JPRB, 0.26263894E-09_JPRB, 0.26267807E-09_JPRB, 0.26267927E-09_JPRB, 0.26264640E-09_JPRB, &
  & 0.26258420E-09_JPRB, 0.26249836E-09_JPRB, 0.26239597E-09_JPRB, 0.26228589E-09_JPRB, 0.26217895E-09_JPRB, 0.26208674E-09_JPRB, &
  & 0.26201788E-09_JPRB, 0.26197486E-09_JPRB, 0.26195413E-09_JPRB, 0.26194874E-09_JPRB, 0.26195138E-09_JPRB, 0.26195593E-09_JPRB, &
  & 0.26195829E-09_JPRB, 0.26195573E-09_JPRB, 0.26194749E-09_JPRB, 0.26193392E-09_JPRB, 0.26191738E-09_JPRB, 0.26189900E-09_JPRB, &
  & 0.26187966E-09_JPRB, 0.26185804E-09_JPRB, 0.26183369E-09_JPRB, 0.26180796E-09_JPRB, 0.26178298E-09_JPRB, 0.26176039E-09_JPRB, &
  & 0.26174013E-09_JPRB, 0.26172048E-09_JPRB, 0.26169769E-09_JPRB, 0.26165947E-09_JPRB /)

RGHG5(:,66,10) = (/ &
  & 0.26108227E-09_JPRB, 0.26115332E-09_JPRB, 0.26119090E-09_JPRB, 0.26122143E-09_JPRB, 0.26125055E-09_JPRB, 0.26127697E-09_JPRB, &
  & 0.26130140E-09_JPRB, 0.26132202E-09_JPRB, 0.26134522E-09_JPRB, 0.26136848E-09_JPRB, 0.26139829E-09_JPRB, 0.26142996E-09_JPRB, &
  & 0.26145947E-09_JPRB, 0.26147626E-09_JPRB, 0.26147001E-09_JPRB, 0.26143263E-09_JPRB, 0.26136265E-09_JPRB, 0.26126809E-09_JPRB, &
  & 0.26116595E-09_JPRB, 0.26107808E-09_JPRB, 0.26102667E-09_JPRB, 0.26102789E-09_JPRB, 0.26108854E-09_JPRB, 0.26120670E-09_JPRB, &
  & 0.26137131E-09_JPRB, 0.26156743E-09_JPRB, 0.26177757E-09_JPRB, 0.26198632E-09_JPRB, 0.26218250E-09_JPRB, 0.26235714E-09_JPRB, &
  & 0.26250235E-09_JPRB, 0.26261271E-09_JPRB, 0.26268571E-09_JPRB, 0.26272184E-09_JPRB, 0.26272354E-09_JPRB, 0.26269437E-09_JPRB, &
  & 0.26263799E-09_JPRB, 0.26255956E-09_JPRB, 0.26246547E-09_JPRB, 0.26236355E-09_JPRB, 0.26226427E-09_JPRB, 0.26217833E-09_JPRB, &
  & 0.26211394E-09_JPRB, 0.26207342E-09_JPRB, 0.26205366E-09_JPRB, 0.26204836E-09_JPRB, 0.26205055E-09_JPRB, 0.26205435E-09_JPRB, &
  & 0.26205604E-09_JPRB, 0.26205313E-09_JPRB, 0.26204491E-09_JPRB, 0.26203156E-09_JPRB, 0.26201413E-09_JPRB, 0.26199437E-09_JPRB, &
  & 0.26197211E-09_JPRB, 0.26194741E-09_JPRB, 0.26192012E-09_JPRB, 0.26189106E-09_JPRB, 0.26186303E-09_JPRB, 0.26183722E-09_JPRB, &
  & 0.26181290E-09_JPRB, 0.26178798E-09_JPRB, 0.26175856E-09_JPRB, 0.26170580E-09_JPRB /)

RGHG5(:,67,10) = (/ &
  & 0.26120744E-09_JPRB, 0.26128771E-09_JPRB, 0.26132793E-09_JPRB, 0.26136046E-09_JPRB, 0.26138969E-09_JPRB, 0.26141678E-09_JPRB, &
  & 0.26144065E-09_JPRB, 0.26146529E-09_JPRB, 0.26148900E-09_JPRB, 0.26151956E-09_JPRB, 0.26155184E-09_JPRB, 0.26158764E-09_JPRB, &
  & 0.26161753E-09_JPRB, 0.26163394E-09_JPRB, 0.26162844E-09_JPRB, 0.26159463E-09_JPRB, 0.26153144E-09_JPRB, 0.26144525E-09_JPRB, &
  & 0.26135163E-09_JPRB, 0.26127100E-09_JPRB, 0.26122343E-09_JPRB, 0.26122357E-09_JPRB, 0.26127775E-09_JPRB, 0.26138372E-09_JPRB, &
  & 0.26153274E-09_JPRB, 0.26171010E-09_JPRB, 0.26190114E-09_JPRB, 0.26209107E-09_JPRB, 0.26227009E-09_JPRB, 0.26242919E-09_JPRB, &
  & 0.26256131E-09_JPRB, 0.26266161E-09_JPRB, 0.26272767E-09_JPRB, 0.26276062E-09_JPRB, 0.26276270E-09_JPRB, 0.26273700E-09_JPRB, &
  & 0.26268662E-09_JPRB, 0.26261571E-09_JPRB, 0.26253044E-09_JPRB, 0.26243743E-09_JPRB, 0.26234634E-09_JPRB, 0.26226710E-09_JPRB, &
  & 0.26220726E-09_JPRB, 0.26216929E-09_JPRB, 0.26215030E-09_JPRB, 0.26214478E-09_JPRB, 0.26214628E-09_JPRB, 0.26214930E-09_JPRB, &
  & 0.26215036E-09_JPRB, 0.26214722E-09_JPRB, 0.26213903E-09_JPRB, 0.26212596E-09_JPRB, 0.26210853E-09_JPRB, 0.26208755E-09_JPRB, &
  & 0.26206370E-09_JPRB, 0.26203684E-09_JPRB, 0.26200705E-09_JPRB, 0.26197583E-09_JPRB, 0.26194544E-09_JPRB, 0.26191638E-09_JPRB, &
  & 0.26188837E-09_JPRB, 0.26185779E-09_JPRB, 0.26181882E-09_JPRB, 0.26174840E-09_JPRB /)

RGHG5(:,68,10) = (/ &
  & 0.26132585E-09_JPRB, 0.26141783E-09_JPRB, 0.26146352E-09_JPRB, 0.26149832E-09_JPRB, 0.26152894E-09_JPRB, 0.26155619E-09_JPRB, &
  & 0.26158176E-09_JPRB, 0.26160654E-09_JPRB, 0.26163566E-09_JPRB, 0.26166685E-09_JPRB, 0.26170380E-09_JPRB, 0.26173946E-09_JPRB, &
  & 0.26176955E-09_JPRB, 0.26178665E-09_JPRB, 0.26178251E-09_JPRB, 0.26175193E-09_JPRB, 0.26169436E-09_JPRB, 0.26161642E-09_JPRB, &
  & 0.26153174E-09_JPRB, 0.26145869E-09_JPRB, 0.26141525E-09_JPRB, 0.26141456E-09_JPRB, 0.26146207E-09_JPRB, 0.26155675E-09_JPRB, &
  & 0.26168970E-09_JPRB, 0.26184888E-09_JPRB, 0.26202032E-09_JPRB, 0.26219155E-09_JPRB, 0.26235319E-09_JPRB, 0.26249661E-09_JPRB, &
  & 0.26261585E-09_JPRB, 0.26270594E-09_JPRB, 0.26276528E-09_JPRB, 0.26279495E-09_JPRB, 0.26279726E-09_JPRB, 0.26277483E-09_JPRB, &
  & 0.26273020E-09_JPRB, 0.26266700E-09_JPRB, 0.26259042E-09_JPRB, 0.26250666E-09_JPRB, 0.26242408E-09_JPRB, 0.26235189E-09_JPRB, &
  & 0.26229713E-09_JPRB, 0.26226182E-09_JPRB, 0.26224378E-09_JPRB, 0.26223806E-09_JPRB, 0.26223873E-09_JPRB, 0.26224106E-09_JPRB, &
  & 0.26224148E-09_JPRB, 0.26223809E-09_JPRB, 0.26223018E-09_JPRB, 0.26221741E-09_JPRB, 0.26220009E-09_JPRB, 0.26217883E-09_JPRB, &
  & 0.26215405E-09_JPRB, 0.26212582E-09_JPRB, 0.26209493E-09_JPRB, 0.26206237E-09_JPRB, 0.26203018E-09_JPRB, 0.26199948E-09_JPRB, &
  & 0.26196764E-09_JPRB, 0.26193220E-09_JPRB, 0.26188376E-09_JPRB, 0.26179375E-09_JPRB /)

RGHG5(:,69,10) = (/ &
  & 0.26143998E-09_JPRB, 0.26154798E-09_JPRB, 0.26159913E-09_JPRB, 0.26163738E-09_JPRB, 0.26166924E-09_JPRB, 0.26169736E-09_JPRB, &
  & 0.26172359E-09_JPRB, 0.26175062E-09_JPRB, 0.26178038E-09_JPRB, 0.26181488E-09_JPRB, 0.26185121E-09_JPRB, 0.26188654E-09_JPRB, &
  & 0.26191513E-09_JPRB, 0.26193098E-09_JPRB, 0.26192770E-09_JPRB, 0.26190100E-09_JPRB, 0.26185029E-09_JPRB, 0.26178087E-09_JPRB, &
  & 0.26170513E-09_JPRB, 0.26163946E-09_JPRB, 0.26160010E-09_JPRB, 0.26159847E-09_JPRB, 0.26163990E-09_JPRB, 0.26172320E-09_JPRB, &
  & 0.26184102E-09_JPRB, 0.26198210E-09_JPRB, 0.26213465E-09_JPRB, 0.26228736E-09_JPRB, 0.26243166E-09_JPRB, 0.26255995E-09_JPRB, &
  & 0.26266614E-09_JPRB, 0.26274624E-09_JPRB, 0.26279889E-09_JPRB, 0.26282537E-09_JPRB, 0.26282776E-09_JPRB, 0.26280841E-09_JPRB, &
  & 0.26276925E-09_JPRB, 0.26271341E-09_JPRB, 0.26264543E-09_JPRB, 0.26257080E-09_JPRB, 0.26249691E-09_JPRB, 0.26243221E-09_JPRB, &
  & 0.26238275E-09_JPRB, 0.26235059E-09_JPRB, 0.26233382E-09_JPRB, 0.26232799E-09_JPRB, 0.26232813E-09_JPRB, 0.26232977E-09_JPRB, &
  & 0.26232982E-09_JPRB, 0.26232647E-09_JPRB, 0.26231869E-09_JPRB, 0.26230640E-09_JPRB, 0.26228947E-09_JPRB, 0.26226854E-09_JPRB, &
  & 0.26224359E-09_JPRB, 0.26221519E-09_JPRB, 0.26218397E-09_JPRB, 0.26215080E-09_JPRB, 0.26211833E-09_JPRB, 0.26208566E-09_JPRB, &
  & 0.26205244E-09_JPRB, 0.26201222E-09_JPRB, 0.26195593E-09_JPRB, 0.26184580E-09_JPRB /)

RGHG5(:,70,10) = (/ &
  & 0.26155450E-09_JPRB, 0.26167896E-09_JPRB, 0.26173747E-09_JPRB, 0.26177832E-09_JPRB, 0.26181185E-09_JPRB, 0.26184074E-09_JPRB, &
  & 0.26186756E-09_JPRB, 0.26189559E-09_JPRB, 0.26192618E-09_JPRB, 0.26196031E-09_JPRB, 0.26199537E-09_JPRB, 0.26202865E-09_JPRB, &
  & 0.26205535E-09_JPRB, 0.26207114E-09_JPRB, 0.26206834E-09_JPRB, 0.26204447E-09_JPRB, 0.26199931E-09_JPRB, 0.26193803E-09_JPRB, &
  & 0.26187066E-09_JPRB, 0.26181224E-09_JPRB, 0.26177663E-09_JPRB, 0.26177416E-09_JPRB, 0.26180963E-09_JPRB, 0.26188229E-09_JPRB, &
  & 0.26198538E-09_JPRB, 0.26210925E-09_JPRB, 0.26224353E-09_JPRB, 0.26237829E-09_JPRB, 0.26250588E-09_JPRB, 0.26261901E-09_JPRB, &
  & 0.26271260E-09_JPRB, 0.26278291E-09_JPRB, 0.26282906E-09_JPRB, 0.26285246E-09_JPRB, 0.26285471E-09_JPRB, 0.26283820E-09_JPRB, &
  & 0.26280417E-09_JPRB, 0.26275540E-09_JPRB, 0.26269564E-09_JPRB, 0.26262989E-09_JPRB, 0.26256475E-09_JPRB, 0.26250760E-09_JPRB, &
  & 0.26246383E-09_JPRB, 0.26243518E-09_JPRB, 0.26242000E-09_JPRB, 0.26241451E-09_JPRB, 0.26241428E-09_JPRB, 0.26241556E-09_JPRB, &
  & 0.26241528E-09_JPRB, 0.26241198E-09_JPRB, 0.26240454E-09_JPRB, 0.26239300E-09_JPRB, 0.26237690E-09_JPRB, 0.26235678E-09_JPRB, &
  & 0.26233260E-09_JPRB, 0.26230512E-09_JPRB, 0.26227445E-09_JPRB, 0.26224198E-09_JPRB, 0.26220939E-09_JPRB, 0.26217697E-09_JPRB, &
  & 0.26214200E-09_JPRB, 0.26210037E-09_JPRB, 0.26203698E-09_JPRB, 0.26191160E-09_JPRB /)

RGHG5(:,71,10) = (/ &
  & 0.26167415E-09_JPRB, 0.26181579E-09_JPRB, 0.26187855E-09_JPRB, 0.26192223E-09_JPRB, 0.26195632E-09_JPRB, 0.26198571E-09_JPRB, &
  & 0.26201308E-09_JPRB, 0.26204050E-09_JPRB, 0.26207123E-09_JPRB, 0.26210251E-09_JPRB, 0.26213554E-09_JPRB, 0.26216507E-09_JPRB, &
  & 0.26218883E-09_JPRB, 0.26220212E-09_JPRB, 0.26219987E-09_JPRB, 0.26217958E-09_JPRB, 0.26214036E-09_JPRB, 0.26208663E-09_JPRB, &
  & 0.26202743E-09_JPRB, 0.26197569E-09_JPRB, 0.26194397E-09_JPRB, 0.26194069E-09_JPRB, 0.26197064E-09_JPRB, 0.26203337E-09_JPRB, &
  & 0.26212249E-09_JPRB, 0.26223013E-09_JPRB, 0.26234662E-09_JPRB, 0.26246433E-09_JPRB, 0.26257557E-09_JPRB, 0.26267413E-09_JPRB, &
  & 0.26275546E-09_JPRB, 0.26281632E-09_JPRB, 0.26285629E-09_JPRB, 0.26287661E-09_JPRB, 0.26287866E-09_JPRB, 0.26286470E-09_JPRB, &
  & 0.26283542E-09_JPRB, 0.26279337E-09_JPRB, 0.26274150E-09_JPRB, 0.26268432E-09_JPRB, 0.26262756E-09_JPRB, 0.26257788E-09_JPRB, &
  & 0.26253985E-09_JPRB, 0.26251487E-09_JPRB, 0.26250171E-09_JPRB, 0.26249686E-09_JPRB, 0.26249666E-09_JPRB, 0.26249775E-09_JPRB, &
  & 0.26249741E-09_JPRB, 0.26249430E-09_JPRB, 0.26248742E-09_JPRB, 0.26247682E-09_JPRB, 0.26246200E-09_JPRB, 0.26244332E-09_JPRB, &
  & 0.26242108E-09_JPRB, 0.26239516E-09_JPRB, 0.26236652E-09_JPRB, 0.26233540E-09_JPRB, 0.26230393E-09_JPRB, 0.26227226E-09_JPRB, &
  & 0.26223793E-09_JPRB, 0.26219535E-09_JPRB, 0.26212957E-09_JPRB, 0.26199315E-09_JPRB /)

RGHG5(:,72,10) = (/ &
  & 0.26180527E-09_JPRB, 0.26195726E-09_JPRB, 0.26202351E-09_JPRB, 0.26206740E-09_JPRB, 0.26210156E-09_JPRB, 0.26213060E-09_JPRB, &
  & 0.26215710E-09_JPRB, 0.26218430E-09_JPRB, 0.26221111E-09_JPRB, 0.26224162E-09_JPRB, 0.26226868E-09_JPRB, 0.26229563E-09_JPRB, &
  & 0.26231586E-09_JPRB, 0.26232838E-09_JPRB, 0.26232541E-09_JPRB, 0.26230715E-09_JPRB, 0.26227301E-09_JPRB, 0.26222649E-09_JPRB, &
  & 0.26217487E-09_JPRB, 0.26212982E-09_JPRB, 0.26210170E-09_JPRB, 0.26209807E-09_JPRB, 0.26212305E-09_JPRB, 0.26217620E-09_JPRB, &
  & 0.26225230E-09_JPRB, 0.26234412E-09_JPRB, 0.26244412E-09_JPRB, 0.26254510E-09_JPRB, 0.26264091E-09_JPRB, 0.26272526E-09_JPRB, &
  & 0.26279479E-09_JPRB, 0.26284663E-09_JPRB, 0.26288061E-09_JPRB, 0.26289809E-09_JPRB, 0.26289998E-09_JPRB, 0.26288818E-09_JPRB, &
  & 0.26286340E-09_JPRB, 0.26282768E-09_JPRB, 0.26278338E-09_JPRB, 0.26273420E-09_JPRB, 0.26268568E-09_JPRB, 0.26264313E-09_JPRB, &
  & 0.26261077E-09_JPRB, 0.26258959E-09_JPRB, 0.26257846E-09_JPRB, 0.26257443E-09_JPRB, 0.26257438E-09_JPRB, 0.26257560E-09_JPRB, &
  & 0.26257524E-09_JPRB, 0.26257257E-09_JPRB, 0.26256641E-09_JPRB, 0.26255706E-09_JPRB, 0.26254379E-09_JPRB, 0.26252767E-09_JPRB, &
  & 0.26250727E-09_JPRB, 0.26248501E-09_JPRB, 0.26245833E-09_JPRB, 0.26242963E-09_JPRB, 0.26240093E-09_JPRB, 0.26237043E-09_JPRB, &
  & 0.26233818E-09_JPRB, 0.26229749E-09_JPRB, 0.26223054E-09_JPRB, 0.26209143E-09_JPRB /)

RGHG5(:,73,10) = (/ &
  & 0.26195351E-09_JPRB, 0.26210462E-09_JPRB, 0.26216940E-09_JPRB, 0.26221164E-09_JPRB, 0.26224409E-09_JPRB, 0.26227182E-09_JPRB, &
  & 0.26229702E-09_JPRB, 0.26232072E-09_JPRB, 0.26234701E-09_JPRB, 0.26237024E-09_JPRB, 0.26239660E-09_JPRB, 0.26241725E-09_JPRB, &
  & 0.26243474E-09_JPRB, 0.26244415E-09_JPRB, 0.26244162E-09_JPRB, 0.26242597E-09_JPRB, 0.26239652E-09_JPRB, 0.26235672E-09_JPRB, &
  & 0.26231253E-09_JPRB, 0.26227373E-09_JPRB, 0.26224969E-09_JPRB, 0.26224595E-09_JPRB, 0.26226621E-09_JPRB, 0.26231059E-09_JPRB, &
  & 0.26237412E-09_JPRB, 0.26245137E-09_JPRB, 0.26253524E-09_JPRB, 0.26262081E-09_JPRB, 0.26270142E-09_JPRB, 0.26277244E-09_JPRB, &
  & 0.26283073E-09_JPRB, 0.26287403E-09_JPRB, 0.26290234E-09_JPRB, 0.26291719E-09_JPRB, 0.26291888E-09_JPRB, 0.26290900E-09_JPRB, &
  & 0.26288838E-09_JPRB, 0.26285873E-09_JPRB, 0.26282140E-09_JPRB, 0.26277991E-09_JPRB, 0.26273914E-09_JPRB, 0.26270347E-09_JPRB, &
  & 0.26267660E-09_JPRB, 0.26265895E-09_JPRB, 0.26264982E-09_JPRB, 0.26264663E-09_JPRB, 0.26264674E-09_JPRB, 0.26264815E-09_JPRB, &
  & 0.26264793E-09_JPRB, 0.26264579E-09_JPRB, 0.26264063E-09_JPRB, 0.26263267E-09_JPRB, 0.26262159E-09_JPRB, 0.26260738E-09_JPRB, &
  & 0.26259084E-09_JPRB, 0.26257058E-09_JPRB, 0.26254809E-09_JPRB, 0.26252270E-09_JPRB, 0.26249597E-09_JPRB, 0.26246985E-09_JPRB, &
  & 0.26243929E-09_JPRB, 0.26240221E-09_JPRB, 0.26233937E-09_JPRB, 0.26220051E-09_JPRB /)

RGHG5(:,74,10) = (/ &
  & 0.26210581E-09_JPRB, 0.26225225E-09_JPRB, 0.26231228E-09_JPRB, 0.26235106E-09_JPRB, 0.26238070E-09_JPRB, 0.26240593E-09_JPRB, &
  & 0.26242836E-09_JPRB, 0.26245042E-09_JPRB, 0.26247041E-09_JPRB, 0.26249369E-09_JPRB, 0.26251212E-09_JPRB, 0.26253161E-09_JPRB, &
  & 0.26254474E-09_JPRB, 0.26255334E-09_JPRB, 0.26254968E-09_JPRB, 0.26253585E-09_JPRB, 0.26251085E-09_JPRB, 0.26247757E-09_JPRB, &
  & 0.26244035E-09_JPRB, 0.26240787E-09_JPRB, 0.26238767E-09_JPRB, 0.26238411E-09_JPRB, 0.26240010E-09_JPRB, 0.26243613E-09_JPRB, &
  & 0.26248823E-09_JPRB, 0.26255145E-09_JPRB, 0.26262048E-09_JPRB, 0.26269098E-09_JPRB, 0.26275748E-09_JPRB, 0.26281571E-09_JPRB, &
  & 0.26286351E-09_JPRB, 0.26289868E-09_JPRB, 0.26292174E-09_JPRB, 0.26293409E-09_JPRB, 0.26293559E-09_JPRB, 0.26292746E-09_JPRB, &
  & 0.26291055E-09_JPRB, 0.26288657E-09_JPRB, 0.26285596E-09_JPRB, 0.26282165E-09_JPRB, 0.26278837E-09_JPRB, 0.26275926E-09_JPRB, &
  & 0.26273744E-09_JPRB, 0.26272312E-09_JPRB, 0.26271582E-09_JPRB, 0.26271332E-09_JPRB, 0.26271352E-09_JPRB, 0.26271513E-09_JPRB, &
  & 0.26271502E-09_JPRB, 0.26271352E-09_JPRB, 0.26270933E-09_JPRB, 0.26270297E-09_JPRB, 0.26269389E-09_JPRB, 0.26268271E-09_JPRB, &
  & 0.26266786E-09_JPRB, 0.26265234E-09_JPRB, 0.26263267E-09_JPRB, 0.26261052E-09_JPRB, 0.26258926E-09_JPRB, 0.26256447E-09_JPRB, &
  & 0.26253935E-09_JPRB, 0.26250627E-09_JPRB, 0.26244734E-09_JPRB, 0.26231745E-09_JPRB /)

RGHG5(:,75,10) = (/ &
  & 0.26225913E-09_JPRB, 0.26239483E-09_JPRB, 0.26244956E-09_JPRB, 0.26248331E-09_JPRB, 0.26250885E-09_JPRB, 0.26253089E-09_JPRB, &
  & 0.26255073E-09_JPRB, 0.26256813E-09_JPRB, 0.26258709E-09_JPRB, 0.26260308E-09_JPRB, 0.26262123E-09_JPRB, 0.26263453E-09_JPRB, &
  & 0.26264552E-09_JPRB, 0.26265154E-09_JPRB, 0.26264818E-09_JPRB, 0.26263655E-09_JPRB, 0.26261593E-09_JPRB, 0.26258898E-09_JPRB, &
  & 0.26255867E-09_JPRB, 0.26253205E-09_JPRB, 0.26251573E-09_JPRB, 0.26251251E-09_JPRB, 0.26252475E-09_JPRB, 0.26255306E-09_JPRB, &
  & 0.26259434E-09_JPRB, 0.26264477E-09_JPRB, 0.26269961E-09_JPRB, 0.26275604E-09_JPRB, 0.26280891E-09_JPRB, 0.26285510E-09_JPRB, &
  & 0.26289307E-09_JPRB, 0.26292077E-09_JPRB, 0.26293887E-09_JPRB, 0.26294905E-09_JPRB, 0.26295049E-09_JPRB, 0.26294383E-09_JPRB, &
  & 0.26293040E-09_JPRB, 0.26291172E-09_JPRB, 0.26288741E-09_JPRB, 0.26285987E-09_JPRB, 0.26283370E-09_JPRB, 0.26281055E-09_JPRB, &
  & 0.26279362E-09_JPRB, 0.26278235E-09_JPRB, 0.26277674E-09_JPRB, 0.26277472E-09_JPRB, 0.26277491E-09_JPRB, 0.26277669E-09_JPRB, &
  & 0.26277652E-09_JPRB, 0.26277563E-09_JPRB, 0.26277236E-09_JPRB, 0.26276761E-09_JPRB, 0.26276073E-09_JPRB, 0.26275121E-09_JPRB, &
  & 0.26273989E-09_JPRB, 0.26272673E-09_JPRB, 0.26271132E-09_JPRB, 0.26269409E-09_JPRB, 0.26267472E-09_JPRB, 0.26265651E-09_JPRB, &
  & 0.26263330E-09_JPRB, 0.26260658E-09_JPRB, 0.26255481E-09_JPRB, 0.26243349E-09_JPRB /)

RGHG5(:,76,10) = (/ &
  & 0.26240804E-09_JPRB, 0.26253241E-09_JPRB, 0.26257935E-09_JPRB, 0.26260702E-09_JPRB, 0.26262770E-09_JPRB, 0.26264618E-09_JPRB, &
  & 0.26266228E-09_JPRB, 0.26267732E-09_JPRB, 0.26269073E-09_JPRB, 0.26270580E-09_JPRB, 0.26271740E-09_JPRB, 0.26272889E-09_JPRB, &
  & 0.26273592E-09_JPRB, 0.26274063E-09_JPRB, 0.26273714E-09_JPRB, 0.26272803E-09_JPRB, 0.26271199E-09_JPRB, 0.26269162E-09_JPRB, &
  & 0.26266772E-09_JPRB, 0.26264674E-09_JPRB, 0.26263414E-09_JPRB, 0.26263144E-09_JPRB, 0.26264024E-09_JPRB, 0.26266173E-09_JPRB, &
  & 0.26269303E-09_JPRB, 0.26273139E-09_JPRB, 0.26277297E-09_JPRB, 0.26281591E-09_JPRB, 0.26285613E-09_JPRB, 0.26289088E-09_JPRB, &
  & 0.26291980E-09_JPRB, 0.26294056E-09_JPRB, 0.26295416E-09_JPRB, 0.26296235E-09_JPRB, 0.26296360E-09_JPRB, 0.26295832E-09_JPRB, &
  & 0.26294805E-09_JPRB, 0.26293434E-09_JPRB, 0.26291583E-09_JPRB, 0.26289482E-09_JPRB, 0.26287517E-09_JPRB, 0.26285799E-09_JPRB, &
  & 0.26284541E-09_JPRB, 0.26283700E-09_JPRB, 0.26283278E-09_JPRB, 0.26283109E-09_JPRB, 0.26283109E-09_JPRB, 0.26283295E-09_JPRB, &
  & 0.26283264E-09_JPRB, 0.26283228E-09_JPRB, 0.26282979E-09_JPRB, 0.26282665E-09_JPRB, 0.26282163E-09_JPRB, 0.26281438E-09_JPRB, &
  & 0.26280472E-09_JPRB, 0.26279534E-09_JPRB, 0.26278391E-09_JPRB, 0.26276967E-09_JPRB, 0.26275679E-09_JPRB, 0.26274016E-09_JPRB, &
  & 0.26272348E-09_JPRB, 0.26270114E-09_JPRB, 0.26265765E-09_JPRB, 0.26255029E-09_JPRB /)

RGHG5(:,77,10) = (/ &
  & 0.26255326E-09_JPRB, 0.26266192E-09_JPRB, 0.26270042E-09_JPRB, 0.26272109E-09_JPRB, 0.26273628E-09_JPRB, 0.26275085E-09_JPRB, &
  & 0.26276398E-09_JPRB, 0.26277455E-09_JPRB, 0.26278549E-09_JPRB, 0.26279529E-09_JPRB, 0.26280450E-09_JPRB, 0.26281133E-09_JPRB, &
  & 0.26281588E-09_JPRB, 0.26281896E-09_JPRB, 0.26281566E-09_JPRB, 0.26280925E-09_JPRB, 0.26279806E-09_JPRB, 0.26278416E-09_JPRB, &
  & 0.26276675E-09_JPRB, 0.26275127E-09_JPRB, 0.26274227E-09_JPRB, 0.26274027E-09_JPRB, 0.26274616E-09_JPRB, 0.26276126E-09_JPRB, &
  & 0.26278354E-09_JPRB, 0.26281088E-09_JPRB, 0.26283989E-09_JPRB, 0.26287036E-09_JPRB, 0.26289870E-09_JPRB, 0.26292302E-09_JPRB, &
  & 0.26294358E-09_JPRB, 0.26295807E-09_JPRB, 0.26296748E-09_JPRB, 0.26297386E-09_JPRB, 0.26297514E-09_JPRB, 0.26297106E-09_JPRB, &
  & 0.26296348E-09_JPRB, 0.26295446E-09_JPRB, 0.26294142E-09_JPRB, 0.26292621E-09_JPRB, 0.26291291E-09_JPRB, 0.26290095E-09_JPRB, &
  & 0.26289254E-09_JPRB, 0.26288660E-09_JPRB, 0.26288358E-09_JPRB, 0.26288194E-09_JPRB, 0.26288166E-09_JPRB, 0.26288374E-09_JPRB, &
  & 0.26288305E-09_JPRB, 0.26288322E-09_JPRB, 0.26288133E-09_JPRB, 0.26287975E-09_JPRB, 0.26287661E-09_JPRB, 0.26287078E-09_JPRB, &
  & 0.26286351E-09_JPRB, 0.26285693E-09_JPRB, 0.26284927E-09_JPRB, 0.26283986E-09_JPRB, 0.26282992E-09_JPRB, 0.26281902E-09_JPRB, &
  & 0.26280544E-09_JPRB, 0.26278998E-09_JPRB, 0.26275479E-09_JPRB, 0.26266447E-09_JPRB /)

RGHG5(:,78,10) = (/ &
  & 0.26269359E-09_JPRB, 0.26277833E-09_JPRB, 0.26280506E-09_JPRB, 0.26281832E-09_JPRB, 0.26282812E-09_JPRB, 0.26283911E-09_JPRB, &
  & 0.26284888E-09_JPRB, 0.26285624E-09_JPRB, 0.26286287E-09_JPRB, 0.26286992E-09_JPRB, 0.26287469E-09_JPRB, 0.26287869E-09_JPRB, &
  & 0.26288061E-09_JPRB, 0.26288241E-09_JPRB, 0.26287988E-09_JPRB, 0.26287600E-09_JPRB, 0.26286928E-09_JPRB, 0.26286162E-09_JPRB, &
  & 0.26285024E-09_JPRB, 0.26283986E-09_JPRB, 0.26283453E-09_JPRB, 0.26283345E-09_JPRB, 0.26283706E-09_JPRB, 0.26284677E-09_JPRB, &
  & 0.26286123E-09_JPRB, 0.26287914E-09_JPRB, 0.26289701E-09_JPRB, 0.26291694E-09_JPRB, 0.26293473E-09_JPRB, 0.26295024E-09_JPRB, &
  & 0.26296348E-09_JPRB, 0.26297275E-09_JPRB, 0.26297861E-09_JPRB, 0.26298344E-09_JPRB, 0.26298475E-09_JPRB, 0.26298153E-09_JPRB, &
  & 0.26297625E-09_JPRB, 0.26297126E-09_JPRB, 0.26296290E-09_JPRB, 0.26295277E-09_JPRB, 0.26294489E-09_JPRB, 0.26293753E-09_JPRB, &
  & 0.26293240E-09_JPRB, 0.26292848E-09_JPRB, 0.26292618E-09_JPRB, 0.26292452E-09_JPRB, 0.26292374E-09_JPRB, 0.26292601E-09_JPRB, &
  & 0.26292496E-09_JPRB, 0.26292563E-09_JPRB, 0.26292407E-09_JPRB, 0.26292385E-09_JPRB, 0.26292246E-09_JPRB, 0.26291791E-09_JPRB, &
  & 0.26291228E-09_JPRB, 0.26290833E-09_JPRB, 0.26290453E-09_JPRB, 0.26289795E-09_JPRB, 0.26289307E-09_JPRB, 0.26288444E-09_JPRB, &
  & 0.26287630E-09_JPRB, 0.26286570E-09_JPRB, 0.26284241E-09_JPRB, 0.26277558E-09_JPRB /)

RGHG5(:,79,10) = (/ &
  & 0.26278438E-09_JPRB, 0.26284397E-09_JPRB, 0.26286104E-09_JPRB, 0.26286878E-09_JPRB, 0.26287544E-09_JPRB, 0.26288469E-09_JPRB, &
  & 0.26289321E-09_JPRB, 0.26289823E-09_JPRB, 0.26290287E-09_JPRB, 0.26290814E-09_JPRB, 0.26291117E-09_JPRB, 0.26291358E-09_JPRB, &
  & 0.26291416E-09_JPRB, 0.26291530E-09_JPRB, 0.26291314E-09_JPRB, 0.26291078E-09_JPRB, 0.26290656E-09_JPRB, 0.26290259E-09_JPRB, &
  & 0.26289440E-09_JPRB, 0.26288682E-09_JPRB, 0.26288366E-09_JPRB, 0.26288333E-09_JPRB, 0.26288582E-09_JPRB, 0.26289279E-09_JPRB, &
  & 0.26290317E-09_JPRB, 0.26291611E-09_JPRB, 0.26292793E-09_JPRB, 0.26294217E-09_JPRB, 0.26295419E-09_JPRB, 0.26296490E-09_JPRB, &
  & 0.26297431E-09_JPRB, 0.26298058E-09_JPRB, 0.26298450E-09_JPRB, 0.26298869E-09_JPRB, 0.26299010E-09_JPRB, 0.26298724E-09_JPRB, &
  & 0.26298308E-09_JPRB, 0.26298033E-09_JPRB, 0.26297450E-09_JPRB, 0.26296693E-09_JPRB, 0.26296196E-09_JPRB, 0.26295696E-09_JPRB, &
  & 0.26295366E-09_JPRB, 0.26295072E-09_JPRB, 0.26294886E-09_JPRB, 0.26294683E-09_JPRB, 0.26294567E-09_JPRB, 0.26294819E-09_JPRB, &
  & 0.26294669E-09_JPRB, 0.26294789E-09_JPRB, 0.26294633E-09_JPRB, 0.26294694E-09_JPRB, 0.26294658E-09_JPRB, 0.26294231E-09_JPRB, &
  & 0.26293728E-09_JPRB, 0.26293473E-09_JPRB, 0.26293295E-09_JPRB, 0.26292807E-09_JPRB, 0.26292524E-09_JPRB, 0.26291833E-09_JPRB, &
  & 0.26291230E-09_JPRB, 0.26290592E-09_JPRB, 0.26289071E-09_JPRB, 0.26284655E-09_JPRB /)

RGHG5(:,80,10) = (/ &
  & 0.26284530E-09_JPRB, 0.26287572E-09_JPRB, 0.26288560E-09_JPRB, 0.26289051E-09_JPRB, 0.26289557E-09_JPRB, 0.26290431E-09_JPRB, &
  & 0.26291236E-09_JPRB, 0.26291633E-09_JPRB, 0.26292021E-09_JPRB, 0.26292477E-09_JPRB, 0.26292712E-09_JPRB, 0.26292879E-09_JPRB, &
  & 0.26292882E-09_JPRB, 0.26292976E-09_JPRB, 0.26292779E-09_JPRB, 0.26292613E-09_JPRB, 0.26292310E-09_JPRB, 0.26292096E-09_JPRB, &
  & 0.26291425E-09_JPRB, 0.26290778E-09_JPRB, 0.26290578E-09_JPRB, 0.26290581E-09_JPRB, 0.26290786E-09_JPRB, 0.26291361E-09_JPRB, &
  & 0.26292221E-09_JPRB, 0.26293293E-09_JPRB, 0.26294203E-09_JPRB, 0.26295371E-09_JPRB, 0.26296310E-09_JPRB, 0.26297162E-09_JPRB, &
  & 0.26297919E-09_JPRB, 0.26298408E-09_JPRB, 0.26298708E-09_JPRB, 0.26299110E-09_JPRB, 0.26299263E-09_JPRB, 0.26298985E-09_JPRB, &
  & 0.26298613E-09_JPRB, 0.26298450E-09_JPRB, 0.26297978E-09_JPRB, 0.26297328E-09_JPRB, 0.26296967E-09_JPRB, 0.26296579E-09_JPRB, &
  & 0.26296332E-09_JPRB, 0.26296074E-09_JPRB, 0.26295896E-09_JPRB, 0.26295680E-09_JPRB, 0.26295535E-09_JPRB, 0.26295807E-09_JPRB, &
  & 0.26295624E-09_JPRB, 0.26295760E-09_JPRB, 0.26295599E-09_JPRB, 0.26295702E-09_JPRB, 0.26295718E-09_JPRB, 0.26295285E-09_JPRB, &
  & 0.26294791E-09_JPRB, 0.26294592E-09_JPRB, 0.26294519E-09_JPRB, 0.26294081E-09_JPRB, 0.26293923E-09_JPRB, 0.26293256E-09_JPRB, &
  & 0.26292782E-09_JPRB, 0.26292327E-09_JPRB, 0.26291397E-09_JPRB, 0.26289323E-09_JPRB /)

RGHG5(:,81,10) = (/ &
  & 0.26288746E-09_JPRB, 0.26288932E-09_JPRB, 0.26289601E-09_JPRB, 0.26289967E-09_JPRB, 0.26290406E-09_JPRB, 0.26291264E-09_JPRB, &
  & 0.26292057E-09_JPRB, 0.26292424E-09_JPRB, 0.26292743E-09_JPRB, 0.26293215E-09_JPRB, 0.26293390E-09_JPRB, 0.26293545E-09_JPRB, &
  & 0.26293523E-09_JPRB, 0.26293612E-09_JPRB, 0.26293420E-09_JPRB, 0.26293284E-09_JPRB, 0.26293034E-09_JPRB, 0.26292918E-09_JPRB, &
  & 0.26292302E-09_JPRB, 0.26291705E-09_JPRB, 0.26291555E-09_JPRB, 0.26291574E-09_JPRB, 0.26291760E-09_JPRB, 0.26292285E-09_JPRB, &
  & 0.26293068E-09_JPRB, 0.26294036E-09_JPRB, 0.26294822E-09_JPRB, 0.26295879E-09_JPRB, 0.26296698E-09_JPRB, 0.26297453E-09_JPRB, &
  & 0.26298136E-09_JPRB, 0.26298558E-09_JPRB, 0.26298816E-09_JPRB, 0.26299218E-09_JPRB, 0.26299374E-09_JPRB, 0.26299096E-09_JPRB, &
  & 0.26298749E-09_JPRB, 0.26298627E-09_JPRB, 0.26298211E-09_JPRB, 0.26297614E-09_JPRB, 0.26297314E-09_JPRB, 0.26296973E-09_JPRB, &
  & 0.26296768E-09_JPRB, 0.26296529E-09_JPRB, 0.26296354E-09_JPRB, 0.26296118E-09_JPRB, 0.26295952E-09_JPRB, 0.26296243E-09_JPRB, &
  & 0.26296038E-09_JPRB, 0.26296187E-09_JPRB, 0.26296015E-09_JPRB, 0.26296137E-09_JPRB, 0.26296179E-09_JPRB, 0.26295732E-09_JPRB, &
  & 0.26295238E-09_JPRB, 0.26295063E-09_JPRB, 0.26295038E-09_JPRB, 0.26294619E-09_JPRB, 0.26294511E-09_JPRB, 0.26293867E-09_JPRB, &
  & 0.26293429E-09_JPRB, 0.26293054E-09_JPRB, 0.26292366E-09_JPRB, 0.26292513E-09_JPRB /)

RGHG5(:,82,10) = (/ &
  & 0.26289088E-09_JPRB, 0.26289382E-09_JPRB, 0.26290053E-09_JPRB, 0.26290395E-09_JPRB, 0.26290808E-09_JPRB, 0.26291677E-09_JPRB, &
  & 0.26292468E-09_JPRB, 0.26292798E-09_JPRB, 0.26293134E-09_JPRB, 0.26293545E-09_JPRB, 0.26293731E-09_JPRB, 0.26293864E-09_JPRB, &
  & 0.26293831E-09_JPRB, 0.26293911E-09_JPRB, 0.26293728E-09_JPRB, 0.26293612E-09_JPRB, 0.26293390E-09_JPRB, 0.26293323E-09_JPRB, &
  & 0.26292740E-09_JPRB, 0.26292152E-09_JPRB, 0.26292035E-09_JPRB, 0.26292063E-09_JPRB, 0.26292238E-09_JPRB, 0.26292732E-09_JPRB, &
  & 0.26293484E-09_JPRB, 0.26294408E-09_JPRB, 0.26295138E-09_JPRB, 0.26296129E-09_JPRB, 0.26296892E-09_JPRB, 0.26297600E-09_JPRB, &
  & 0.26298233E-09_JPRB, 0.26298627E-09_JPRB, 0.26298869E-09_JPRB, 0.26299266E-09_JPRB, 0.26299427E-09_JPRB, 0.26299149E-09_JPRB, &
  & 0.26298810E-09_JPRB, 0.26298713E-09_JPRB, 0.26298325E-09_JPRB, 0.26297750E-09_JPRB, 0.26297481E-09_JPRB, 0.26297173E-09_JPRB, &
  & 0.26296990E-09_JPRB, 0.26296759E-09_JPRB, 0.26296584E-09_JPRB, 0.26296332E-09_JPRB, 0.26296151E-09_JPRB, 0.26296459E-09_JPRB, &
  & 0.26296232E-09_JPRB, 0.26296396E-09_JPRB, 0.26296215E-09_JPRB, 0.26296351E-09_JPRB, 0.26296407E-09_JPRB, 0.26295946E-09_JPRB, &
  & 0.26295441E-09_JPRB, 0.26295285E-09_JPRB, 0.26295291E-09_JPRB, 0.26294880E-09_JPRB, 0.26294805E-09_JPRB, 0.26294150E-09_JPRB, &
  & 0.26293739E-09_JPRB, 0.26293367E-09_JPRB, 0.26292685E-09_JPRB, 0.26292768E-09_JPRB /)

RGHG5(:,83,10) = (/ &
  & 0.26289323E-09_JPRB, 0.26289640E-09_JPRB, 0.26290312E-09_JPRB, 0.26290628E-09_JPRB, 0.26291033E-09_JPRB, 0.26291902E-09_JPRB, &
  & 0.26292687E-09_JPRB, 0.26293029E-09_JPRB, 0.26293315E-09_JPRB, 0.26293762E-09_JPRB, 0.26293911E-09_JPRB, 0.26294042E-09_JPRB, &
  & 0.26294011E-09_JPRB, 0.26294078E-09_JPRB, 0.26293900E-09_JPRB, 0.26293800E-09_JPRB, 0.26293595E-09_JPRB, 0.26293562E-09_JPRB, &
  & 0.26292984E-09_JPRB, 0.26292413E-09_JPRB, 0.26292310E-09_JPRB, 0.26292341E-09_JPRB, 0.26292502E-09_JPRB, 0.26292990E-09_JPRB, &
  & 0.26293712E-09_JPRB, 0.26294619E-09_JPRB, 0.26295310E-09_JPRB, 0.26296276E-09_JPRB, 0.26296998E-09_JPRB, 0.26297672E-09_JPRB, &
  & 0.26298286E-09_JPRB, 0.26298658E-09_JPRB, 0.26298891E-09_JPRB, 0.26299299E-09_JPRB, 0.26299463E-09_JPRB, 0.26299182E-09_JPRB, &
  & 0.26298849E-09_JPRB, 0.26298760E-09_JPRB, 0.26298383E-09_JPRB, 0.26297842E-09_JPRB, 0.26297584E-09_JPRB, 0.26297289E-09_JPRB, &
  & 0.26297114E-09_JPRB, 0.26296892E-09_JPRB, 0.26296712E-09_JPRB, 0.26296454E-09_JPRB, 0.26296260E-09_JPRB, 0.26296587E-09_JPRB, &
  & 0.26296346E-09_JPRB, 0.26296515E-09_JPRB, 0.26296323E-09_JPRB, 0.26296468E-09_JPRB, 0.26296537E-09_JPRB, 0.26296071E-09_JPRB, &
  & 0.26295555E-09_JPRB, 0.26295408E-09_JPRB, 0.26295432E-09_JPRB, 0.26295019E-09_JPRB, 0.26294963E-09_JPRB, 0.26294314E-09_JPRB, &
  & 0.26293900E-09_JPRB, 0.26293545E-09_JPRB, 0.26292865E-09_JPRB, 0.26292946E-09_JPRB /)

RGHG5(:,84,10) = (/ &
  & 0.26289487E-09_JPRB, 0.26289818E-09_JPRB, 0.26290467E-09_JPRB, 0.26290772E-09_JPRB, 0.26291166E-09_JPRB, 0.26292044E-09_JPRB, &
  & 0.26292851E-09_JPRB, 0.26293162E-09_JPRB, 0.26293487E-09_JPRB, 0.26293850E-09_JPRB, 0.26294028E-09_JPRB, 0.26294139E-09_JPRB, &
  & 0.26294114E-09_JPRB, 0.26294172E-09_JPRB, 0.26294009E-09_JPRB, 0.26293909E-09_JPRB, 0.26293720E-09_JPRB, 0.26293706E-09_JPRB, &
  & 0.26293143E-09_JPRB, 0.26292568E-09_JPRB, 0.26292477E-09_JPRB, 0.26292510E-09_JPRB, 0.26292674E-09_JPRB, 0.26293140E-09_JPRB, &
  & 0.26293859E-09_JPRB, 0.26294747E-09_JPRB, 0.26295421E-09_JPRB, 0.26296373E-09_JPRB, 0.26297059E-09_JPRB, 0.26297725E-09_JPRB, &
  & 0.26298314E-09_JPRB, 0.26298683E-09_JPRB, 0.26298902E-09_JPRB, 0.26299318E-09_JPRB, 0.26299482E-09_JPRB, 0.26299202E-09_JPRB, &
  & 0.26298871E-09_JPRB, 0.26298785E-09_JPRB, 0.26298427E-09_JPRB, 0.26297892E-09_JPRB, 0.26297645E-09_JPRB, 0.26297362E-09_JPRB, &
  & 0.26297201E-09_JPRB, 0.26296976E-09_JPRB, 0.26296795E-09_JPRB, 0.26296532E-09_JPRB, 0.26296326E-09_JPRB, 0.26296662E-09_JPRB, &
  & 0.26296412E-09_JPRB, 0.26296587E-09_JPRB, 0.26296387E-09_JPRB, 0.26296540E-09_JPRB, 0.26296618E-09_JPRB, 0.26296146E-09_JPRB, &
  & 0.26295621E-09_JPRB, 0.26295471E-09_JPRB, 0.26295510E-09_JPRB, 0.26295099E-09_JPRB, 0.26295069E-09_JPRB, 0.26294397E-09_JPRB, &
  & 0.26294003E-09_JPRB, 0.26293645E-09_JPRB, 0.26292984E-09_JPRB, 0.26293068E-09_JPRB /)

RGHG5(:,85,10) = (/ &
  & 0.26289598E-09_JPRB, 0.26289920E-09_JPRB, 0.26290581E-09_JPRB, 0.26290867E-09_JPRB, 0.26291261E-09_JPRB, 0.26292202E-09_JPRB, &
  & 0.26292926E-09_JPRB, 0.26293312E-09_JPRB, 0.26293565E-09_JPRB, 0.26293923E-09_JPRB, 0.26294075E-09_JPRB, 0.26294183E-09_JPRB, &
  & 0.26294178E-09_JPRB, 0.26294206E-09_JPRB, 0.26294075E-09_JPRB, 0.26293981E-09_JPRB, 0.26293803E-09_JPRB, 0.26293792E-09_JPRB, &
  & 0.26293256E-09_JPRB, 0.26292679E-09_JPRB, 0.26292588E-09_JPRB, 0.26292621E-09_JPRB, 0.26292771E-09_JPRB, 0.26293245E-09_JPRB, &
  & 0.26293948E-09_JPRB, 0.26294844E-09_JPRB, 0.26295499E-09_JPRB, 0.26296437E-09_JPRB, 0.26297114E-09_JPRB, 0.26297745E-09_JPRB, &
  & 0.26298336E-09_JPRB, 0.26298688E-09_JPRB, 0.26298910E-09_JPRB, 0.26299329E-09_JPRB, 0.26299496E-09_JPRB, 0.26299213E-09_JPRB, &
  & 0.26298888E-09_JPRB, 0.26298808E-09_JPRB, 0.26298455E-09_JPRB, 0.26297936E-09_JPRB, 0.26297683E-09_JPRB, 0.26297406E-09_JPRB, &
  & 0.26297259E-09_JPRB, 0.26297034E-09_JPRB, 0.26296851E-09_JPRB, 0.26296582E-09_JPRB, 0.26296371E-09_JPRB, 0.26296715E-09_JPRB, &
  & 0.26296459E-09_JPRB, 0.26296637E-09_JPRB, 0.26296429E-09_JPRB, 0.26296587E-09_JPRB, 0.26296673E-09_JPRB, 0.26296193E-09_JPRB, &
  & 0.26295660E-09_JPRB, 0.26295516E-09_JPRB, 0.26295566E-09_JPRB, 0.26295158E-09_JPRB, 0.26295127E-09_JPRB, 0.26294478E-09_JPRB, &
  & 0.26294064E-09_JPRB, 0.26293723E-09_JPRB, 0.26293057E-09_JPRB, 0.26293151E-09_JPRB /)

RGHG5(:,86,10) = (/ &
  & 0.26289662E-09_JPRB, 0.26289995E-09_JPRB, 0.26290639E-09_JPRB, 0.26290931E-09_JPRB, 0.26291380E-09_JPRB, 0.26292227E-09_JPRB, &
  & 0.26293095E-09_JPRB, 0.26293367E-09_JPRB, 0.26293678E-09_JPRB, 0.26293931E-09_JPRB, 0.26294089E-09_JPRB, 0.26294178E-09_JPRB, &
  & 0.26294189E-09_JPRB, 0.26294211E-09_JPRB, 0.26294114E-09_JPRB, 0.26294020E-09_JPRB, 0.26293870E-09_JPRB, 0.26293839E-09_JPRB, &
  & 0.26293326E-09_JPRB, 0.26292760E-09_JPRB, 0.26292660E-09_JPRB, 0.26292693E-09_JPRB, 0.26292829E-09_JPRB, 0.26293287E-09_JPRB, &
  & 0.26293998E-09_JPRB, 0.26294905E-09_JPRB, 0.26295535E-09_JPRB, 0.26296496E-09_JPRB, 0.26297139E-09_JPRB, 0.26297778E-09_JPRB, &
  & 0.26298350E-09_JPRB, 0.26298694E-09_JPRB, 0.26298910E-09_JPRB, 0.26299343E-09_JPRB, 0.26299510E-09_JPRB, 0.26299227E-09_JPRB, &
  & 0.26298894E-09_JPRB, 0.26298830E-09_JPRB, 0.26298477E-09_JPRB, 0.26297944E-09_JPRB, 0.26297706E-09_JPRB, 0.26297428E-09_JPRB, &
  & 0.26297300E-09_JPRB, 0.26297070E-09_JPRB, 0.26296887E-09_JPRB, 0.26296612E-09_JPRB, 0.26296396E-09_JPRB, 0.26296748E-09_JPRB, &
  & 0.26296493E-09_JPRB, 0.26296665E-09_JPRB, 0.26296454E-09_JPRB, 0.26296620E-09_JPRB, 0.26296718E-09_JPRB, 0.26296224E-09_JPRB, &
  & 0.26295680E-09_JPRB, 0.26295538E-09_JPRB, 0.26295602E-09_JPRB, 0.26295185E-09_JPRB, 0.26295177E-09_JPRB, 0.26294503E-09_JPRB, &
  & 0.26294109E-09_JPRB, 0.26293756E-09_JPRB, 0.26293104E-09_JPRB, 0.26293207E-09_JPRB /)

RGHG5(:,87,10) = (/ &
  & 0.26289704E-09_JPRB, 0.26290026E-09_JPRB, 0.26290681E-09_JPRB, 0.26290972E-09_JPRB, 0.26291386E-09_JPRB, 0.26292490E-09_JPRB, &
  & 0.26293054E-09_JPRB, 0.26293479E-09_JPRB, 0.26293695E-09_JPRB, 0.26293950E-09_JPRB, 0.26294081E-09_JPRB, 0.26294167E-09_JPRB, &
  & 0.26294183E-09_JPRB, 0.26294200E-09_JPRB, 0.26294120E-09_JPRB, 0.26294045E-09_JPRB, 0.26293911E-09_JPRB, 0.26293856E-09_JPRB, &
  & 0.26293387E-09_JPRB, 0.26292815E-09_JPRB, 0.26292707E-09_JPRB, 0.26292735E-09_JPRB, 0.26292857E-09_JPRB, 0.26293315E-09_JPRB, &
  & 0.26294017E-09_JPRB, 0.26294947E-09_JPRB, 0.26295566E-09_JPRB, 0.26296523E-09_JPRB, 0.26297170E-09_JPRB, 0.26297786E-09_JPRB, &
  & 0.26298369E-09_JPRB, 0.26298702E-09_JPRB, 0.26298910E-09_JPRB, 0.26299349E-09_JPRB, 0.26299524E-09_JPRB, 0.26299229E-09_JPRB, &
  & 0.26298902E-09_JPRB, 0.26298846E-09_JPRB, 0.26298497E-09_JPRB, 0.26297947E-09_JPRB, 0.26297720E-09_JPRB, 0.26297445E-09_JPRB, &
  & 0.26297325E-09_JPRB, 0.26297092E-09_JPRB, 0.26296904E-09_JPRB, 0.26296626E-09_JPRB, 0.26296412E-09_JPRB, 0.26296768E-09_JPRB, &
  & 0.26296515E-09_JPRB, 0.26296681E-09_JPRB, 0.26296468E-09_JPRB, 0.26296637E-09_JPRB, 0.26296740E-09_JPRB, 0.26296237E-09_JPRB, &
  & 0.26295691E-09_JPRB, 0.26295549E-09_JPRB, 0.26295616E-09_JPRB, 0.26295199E-09_JPRB, 0.26295197E-09_JPRB, 0.26294533E-09_JPRB, &
  & 0.26294128E-09_JPRB, 0.26293787E-09_JPRB, 0.26293120E-09_JPRB, 0.26293240E-09_JPRB /)

RGHG5(:,88,10) = (/ &
  & 0.26289720E-09_JPRB, 0.26290059E-09_JPRB, 0.26290703E-09_JPRB, 0.26290983E-09_JPRB, 0.26291536E-09_JPRB, 0.26292329E-09_JPRB, &
  & 0.26293212E-09_JPRB, 0.26293467E-09_JPRB, 0.26293756E-09_JPRB, 0.26293956E-09_JPRB, 0.26294092E-09_JPRB, 0.26294170E-09_JPRB, &
  & 0.26294189E-09_JPRB, 0.26294203E-09_JPRB, 0.26294134E-09_JPRB, 0.26294056E-09_JPRB, 0.26293934E-09_JPRB, 0.26293881E-09_JPRB, &
  & 0.26293412E-09_JPRB, 0.26292860E-09_JPRB, 0.26292740E-09_JPRB, 0.26292762E-09_JPRB, 0.26292873E-09_JPRB, 0.26293326E-09_JPRB, &
  & 0.26294028E-09_JPRB, 0.26294983E-09_JPRB, 0.26295566E-09_JPRB, 0.26296568E-09_JPRB, 0.26297178E-09_JPRB, 0.26297803E-09_JPRB, &
  & 0.26298383E-09_JPRB, 0.26298708E-09_JPRB, 0.26298910E-09_JPRB, 0.26299357E-09_JPRB, 0.26299526E-09_JPRB, 0.26299241E-09_JPRB, &
  & 0.26298902E-09_JPRB, 0.26298869E-09_JPRB, 0.26298511E-09_JPRB, 0.26297944E-09_JPRB, 0.26297728E-09_JPRB, 0.26297448E-09_JPRB, &
  & 0.26297339E-09_JPRB, 0.26297103E-09_JPRB, 0.26296917E-09_JPRB, 0.26296637E-09_JPRB, 0.26296421E-09_JPRB, 0.26296779E-09_JPRB, &
  & 0.26296523E-09_JPRB, 0.26296690E-09_JPRB, 0.26296473E-09_JPRB, 0.26296648E-09_JPRB, 0.26296756E-09_JPRB, 0.26296243E-09_JPRB, &
  & 0.26295696E-09_JPRB, 0.26295560E-09_JPRB, 0.26295635E-09_JPRB, 0.26295208E-09_JPRB, 0.26295216E-09_JPRB, 0.26294544E-09_JPRB, &
  & 0.26294136E-09_JPRB, 0.26293792E-09_JPRB, 0.26293137E-09_JPRB, 0.26293256E-09_JPRB /)

RGHG5(:,89,10) = (/ &
  & 0.26289743E-09_JPRB, 0.26290081E-09_JPRB, 0.26290711E-09_JPRB, 0.26290983E-09_JPRB, 0.26291383E-09_JPRB, 0.26292524E-09_JPRB, &
  & 0.26293084E-09_JPRB, 0.26293509E-09_JPRB, 0.26293723E-09_JPRB, 0.26293984E-09_JPRB, 0.26294117E-09_JPRB, 0.26294200E-09_JPRB, &
  & 0.26294208E-09_JPRB, 0.26294222E-09_JPRB, 0.26294145E-09_JPRB, 0.26294072E-09_JPRB, 0.26293945E-09_JPRB, 0.26293903E-09_JPRB, &
  & 0.26293431E-09_JPRB, 0.26292851E-09_JPRB, 0.26292746E-09_JPRB, 0.26292774E-09_JPRB, 0.26292882E-09_JPRB, 0.26293329E-09_JPRB, &
  & 0.26294036E-09_JPRB, 0.26295000E-09_JPRB, 0.26295574E-09_JPRB, 0.26296582E-09_JPRB, 0.26297192E-09_JPRB, 0.26297811E-09_JPRB, &
  & 0.26298394E-09_JPRB, 0.26298713E-09_JPRB, 0.26298905E-09_JPRB, 0.26299365E-09_JPRB, 0.26299546E-09_JPRB, 0.26299246E-09_JPRB, &
  & 0.26298896E-09_JPRB, 0.26298880E-09_JPRB, 0.26298519E-09_JPRB, 0.26297930E-09_JPRB, 0.26297733E-09_JPRB, 0.26297453E-09_JPRB, &
  & 0.26297359E-09_JPRB, 0.26297109E-09_JPRB, 0.26296929E-09_JPRB, 0.26296643E-09_JPRB, 0.26296426E-09_JPRB, 0.26296790E-09_JPRB, &
  & 0.26296521E-09_JPRB, 0.26296698E-09_JPRB, 0.26296473E-09_JPRB, 0.26296654E-09_JPRB, 0.26296768E-09_JPRB, 0.26296243E-09_JPRB, &
  & 0.26295693E-09_JPRB, 0.26295563E-09_JPRB, 0.26295641E-09_JPRB, 0.26295210E-09_JPRB, 0.26295230E-09_JPRB, 0.26294553E-09_JPRB, &
  & 0.26294145E-09_JPRB, 0.26293803E-09_JPRB, 0.26293134E-09_JPRB, 0.26293268E-09_JPRB /)

RGHG5(:,90,10) = (/ &
  & 0.26289751E-09_JPRB, 0.26290098E-09_JPRB, 0.26290697E-09_JPRB, 0.26290958E-09_JPRB, 0.26291386E-09_JPRB, 0.26292271E-09_JPRB, &
  & 0.26293176E-09_JPRB, 0.26293434E-09_JPRB, 0.26293739E-09_JPRB, 0.26294006E-09_JPRB, 0.26294161E-09_JPRB, 0.26294247E-09_JPRB, &
  & 0.26294239E-09_JPRB, 0.26294264E-09_JPRB, 0.26294156E-09_JPRB, 0.26294075E-09_JPRB, 0.26293939E-09_JPRB, 0.26293950E-09_JPRB, &
  & 0.26293420E-09_JPRB, 0.26292835E-09_JPRB, 0.26292746E-09_JPRB, 0.26292774E-09_JPRB, 0.26292876E-09_JPRB, 0.26293326E-09_JPRB, &
  & 0.26294028E-09_JPRB, 0.26295016E-09_JPRB, 0.26295563E-09_JPRB, 0.26296607E-09_JPRB, 0.26297198E-09_JPRB, 0.26297814E-09_JPRB, &
  & 0.26298400E-09_JPRB, 0.26298716E-09_JPRB, 0.26298894E-09_JPRB, 0.26299379E-09_JPRB, 0.26299574E-09_JPRB, 0.26299252E-09_JPRB, &
  & 0.26298885E-09_JPRB, 0.26298899E-09_JPRB, 0.26298533E-09_JPRB, 0.26297911E-09_JPRB, 0.26297739E-09_JPRB, 0.26297453E-09_JPRB, &
  & 0.26297367E-09_JPRB, 0.26297114E-09_JPRB, 0.26296931E-09_JPRB, 0.26296637E-09_JPRB, 0.26296409E-09_JPRB, 0.26296809E-09_JPRB, &
  & 0.26296515E-09_JPRB, 0.26296706E-09_JPRB, 0.26296465E-09_JPRB, 0.26296659E-09_JPRB, 0.26296793E-09_JPRB, 0.26296246E-09_JPRB, &
  & 0.26295680E-09_JPRB, 0.26295555E-09_JPRB, 0.26295657E-09_JPRB, 0.26295205E-09_JPRB, 0.26295244E-09_JPRB, 0.26294542E-09_JPRB, &
  & 0.26294139E-09_JPRB, 0.26293800E-09_JPRB, 0.26293120E-09_JPRB, 0.26293273E-09_JPRB /)

RGHG5(:,91,10) = (/ &
  & 0.26289743E-09_JPRB, 0.26290115E-09_JPRB, 0.26290670E-09_JPRB, 0.26290933E-09_JPRB, 0.26291228E-09_JPRB, 0.26292235E-09_JPRB, &
  & 0.26293137E-09_JPRB, 0.26293379E-09_JPRB, 0.26293601E-09_JPRB, 0.26294134E-09_JPRB, 0.26294242E-09_JPRB, 0.26294378E-09_JPRB, &
  & 0.26294211E-09_JPRB, 0.26294369E-09_JPRB, 0.26294125E-09_JPRB, 0.26294089E-09_JPRB, 0.26293889E-09_JPRB, 0.26294042E-09_JPRB, &
  & 0.26293409E-09_JPRB, 0.26292776E-09_JPRB, 0.26292737E-09_JPRB, 0.26292771E-09_JPRB, 0.26292857E-09_JPRB, 0.26293306E-09_JPRB, &
  & 0.26294009E-09_JPRB, 0.26295047E-09_JPRB, 0.26295530E-09_JPRB, 0.26296634E-09_JPRB, 0.26297189E-09_JPRB, 0.26297808E-09_JPRB, &
  & 0.26298425E-09_JPRB, 0.26298733E-09_JPRB, 0.26298866E-09_JPRB, 0.26299413E-09_JPRB, 0.26299624E-09_JPRB, 0.26299257E-09_JPRB, &
  & 0.26298852E-09_JPRB, 0.26298932E-09_JPRB, 0.26298544E-09_JPRB, 0.26297881E-09_JPRB, 0.26297747E-09_JPRB, 0.26297439E-09_JPRB, &
  & 0.26297375E-09_JPRB, 0.26297106E-09_JPRB, 0.26296942E-09_JPRB, 0.26296637E-09_JPRB, 0.26296365E-09_JPRB, 0.26296854E-09_JPRB, &
  & 0.26296482E-09_JPRB, 0.26296734E-09_JPRB, 0.26296437E-09_JPRB, 0.26296665E-09_JPRB, 0.26296837E-09_JPRB, 0.26296243E-09_JPRB, &
  & 0.26295655E-09_JPRB, 0.26295541E-09_JPRB, 0.26295688E-09_JPRB, 0.26295172E-09_JPRB, 0.26295291E-09_JPRB, 0.26294514E-09_JPRB, &
  & 0.26294125E-09_JPRB, 0.26293798E-09_JPRB, 0.26293076E-09_JPRB, 0.26293276E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART20',1,ZHOOK_HANDLE)
END SUBROUTINE PART20






SUBROUTINE PART21
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART21',0,ZHOOK_HANDLE)



!-- Month= 11 ------------

RGHG5(:, 1,11) = (/ &
  & 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.42038954E-44_JPRB, &
  & 0.56051939E-44_JPRB, 0.84077908E-44_JPRB, 0.16815582E-43_JPRB, 0.36433760E-43_JPRB, 0.82676609E-43_JPRB, 0.18777399E-42_JPRB, &
  & 0.45261940E-42_JPRB, 0.10131388E-41_JPRB, 0.21748152E-41_JPRB, 0.47377901E-41_JPRB, 0.91098413E-41_JPRB, 0.19594356E-40_JPRB, &
  & 0.36196941E-40_JPRB, 0.49698451E-40_JPRB, 0.11765582E-39_JPRB, 0.22227957E-39_JPRB, 0.36909641E-39_JPRB, 0.41797510E-39_JPRB, &
  & 0.57955322E-39_JPRB, 0.88035315E-39_JPRB, 0.97182571E-39_JPRB, 0.13384558E-38_JPRB, 0.12084462E-38_JPRB, 0.12066189E-38_JPRB, &
  & 0.61761249E-39_JPRB, 0.55622300E-39_JPRB, 0.30146975E-39_JPRB, 0.20173933E-39_JPRB, 0.16751542E-39_JPRB, 0.13976691E-39_JPRB, &
  & 0.11703365E-39_JPRB, 0.90637386E-40_JPRB, 0.72920769E-40_JPRB, 0.55696009E-40_JPRB, 0.41434994E-40_JPRB, 0.30168555E-40_JPRB, &
  & 0.21425854E-40_JPRB, 0.14793508E-40_JPRB, 0.99197918E-41_JPRB, 0.62315743E-41_JPRB, 0.38437617E-41_JPRB, 0.22406762E-41_JPRB, &
  & 0.12597673E-41_JPRB, 0.71045832E-42_JPRB, 0.40077136E-42_JPRB, 0.23541814E-42_JPRB, 0.14433374E-42_JPRB, 0.93886997E-43_JPRB, &
  & 0.65861028E-43_JPRB, 0.50446745E-43_JPRB, 0.40637655E-43_JPRB, 0.35032462E-43_JPRB, 0.30828566E-43_JPRB, 0.28025969E-43_JPRB, &
  & 0.25223372E-43_JPRB, 0.21019477E-43_JPRB, 0.18216880E-43_JPRB, 0.15414283E-43_JPRB /)

RGHG5(:, 2,11) = (/ &
  & 0.70064923E-44_JPRB, 0.56051939E-43_JPRB, 0.99492191E-43_JPRB, 0.12051167E-42_JPRB, 0.14153114E-42_JPRB, 0.17516231E-42_JPRB, &
  & 0.24522723E-42_JPRB, 0.42179084E-42_JPRB, 0.83237129E-42_JPRB, 0.17628335E-41_JPRB, 0.37386643E-41_JPRB, 0.82984895E-41_JPRB, &
  & 0.19193585E-40_JPRB, 0.42382272E-40_JPRB, 0.91171281E-40_JPRB, 0.19475386E-39_JPRB, 0.38075241E-39_JPRB, 0.80023251E-39_JPRB, &
  & 0.14605454E-38_JPRB, 0.21269244E-38_JPRB, 0.47813228E-38_JPRB, 0.88784407E-38_JPRB, 0.14541692E-37_JPRB, 0.16820687E-37_JPRB, &
  & 0.23355771E-37_JPRB, 0.34837931E-37_JPRB, 0.39608430E-37_JPRB, 0.51440949E-37_JPRB, 0.48283000E-37_JPRB, 0.46216410E-37_JPRB, &
  & 0.26430826E-37_JPRB, 0.21755226E-37_JPRB, 0.12599044E-37_JPRB, 0.83520317E-38_JPRB, 0.66863811E-38_JPRB, 0.55231773E-38_JPRB, &
  & 0.45775909E-38_JPRB, 0.36016804E-38_JPRB, 0.28802457E-38_JPRB, 0.22283308E-38_JPRB, 0.16722535E-38_JPRB, 0.12268634E-38_JPRB, &
  & 0.87794292E-39_JPRB, 0.61214883E-39_JPRB, 0.41516830E-39_JPRB, 0.26771807E-39_JPRB, 0.16880041E-39_JPRB, 0.10175249E-39_JPRB, &
  & 0.59265116E-40_JPRB, 0.34127223E-40_JPRB, 0.19506075E-40_JPRB, 0.11384149E-40_JPRB, 0.68649612E-41_JPRB, 0.43678473E-41_JPRB, &
  & 0.29665488E-41_JPRB, 0.21720126E-41_JPRB, 0.17095841E-41_JPRB, 0.14349296E-41_JPRB, 0.12639712E-41_JPRB, 0.11448608E-41_JPRB, &
  & 0.10397635E-41_JPRB, 0.91224530E-42_JPRB, 0.74689208E-42_JPRB, 0.56892718E-42_JPRB /)

RGHG5(:, 3,11) = (/ &
  & 0.58013756E-42_JPRB, 0.33939449E-41_JPRB, 0.52184355E-41_JPRB, 0.61685158E-41_JPRB, 0.72264962E-41_JPRB, 0.91743010E-41_JPRB, &
  & 0.13106345E-40_JPRB, 0.22608549E-40_JPRB, 0.44358103E-40_JPRB, 0.90364133E-40_JPRB, 0.19249777E-39_JPRB, 0.41594322E-39_JPRB, &
  & 0.95227619E-39_JPRB, 0.20865250E-38_JPRB, 0.44413875E-38_JPRB, 0.93434490E-38_JPRB, 0.18116406E-37_JPRB, 0.37663229E-37_JPRB, &
  & 0.68205025E-37_JPRB, 0.95399772E-37_JPRB, 0.21963419E-36_JPRB, 0.41590942E-36_JPRB, 0.70000002E-36_JPRB, 0.79302785E-36_JPRB, &
  & 0.11134528E-35_JPRB, 0.16835785E-35_JPRB, 0.19039206E-35_JPRB, 0.24398621E-35_JPRB, 0.23020357E-35_JPRB, 0.21809314E-35_JPRB, &
  & 0.12839514E-35_JPRB, 0.10351017E-35_JPRB, 0.60839846E-36_JPRB, 0.40214212E-36_JPRB, 0.31794561E-36_JPRB, 0.26096186E-36_JPRB, &
  & 0.21552466E-36_JPRB, 0.17029753E-36_JPRB, 0.13651887E-36_JPRB, 0.10622090E-36_JPRB, 0.80296291E-37_JPRB, 0.59128265E-37_JPRB, &
  & 0.42478625E-37_JPRB, 0.29717516E-37_JPRB, 0.20240562E-37_JPRB, 0.13169179E-37_JPRB, 0.83881978E-38_JPRB, 0.51276047E-38_JPRB, &
  & 0.30286698E-38_JPRB, 0.17574763E-38_JPRB, 0.10030466E-38_JPRB, 0.57755497E-39_JPRB, 0.34033196E-39_JPRB, 0.21059134E-39_JPRB, &
  & 0.13945162E-39_JPRB, 0.10019564E-39_JPRB, 0.78258315E-40_JPRB, 0.65739115E-40_JPRB, 0.58442554E-40_JPRB, 0.53665527E-40_JPRB, &
  & 0.49292075E-40_JPRB, 0.43224452E-40_JPRB, 0.33880594E-40_JPRB, 0.21924716E-40_JPRB /)

RGHG5(:, 4,11) = (/ &
  & 0.18566224E-39_JPRB, 0.44840009E-39_JPRB, 0.55472922E-39_JPRB, 0.61661476E-39_JPRB, 0.70742731E-39_JPRB, 0.88564725E-39_JPRB, &
  & 0.12449850E-38_JPRB, 0.21212618E-38_JPRB, 0.41251592E-38_JPRB, 0.85957259E-38_JPRB, 0.18099184E-37_JPRB, 0.39830446E-37_JPRB, &
  & 0.90958446E-37_JPRB, 0.19771969E-36_JPRB, 0.41667271E-36_JPRB, 0.86501298E-36_JPRB, 0.16525329E-35_JPRB, 0.34138920E-35_JPRB, &
  & 0.61396198E-35_JPRB, 0.80838655E-35_JPRB, 0.19160099E-34_JPRB, 0.36934337E-34_JPRB, 0.64090845E-34_JPRB, 0.70176221E-34_JPRB, &
  & 0.99455799E-34_JPRB, 0.15200921E-33_JPRB, 0.17022990E-33_JPRB, 0.21686805E-33_JPRB, 0.20416890E-33_JPRB, 0.19331349E-33_JPRB, &
  & 0.11332010E-33_JPRB, 0.91395920E-34_JPRB, 0.53449705E-34_JPRB, 0.35262337E-34_JPRB, 0.27880654E-34_JPRB, 0.22892519E-34_JPRB, &
  & 0.18919871E-34_JPRB, 0.14978443E-34_JPRB, 0.12058148E-34_JPRB, 0.94453604E-35_JPRB, 0.71815501E-35_JPRB, 0.53266780E-35_JPRB, &
  & 0.38505440E-35_JPRB, 0.27126441E-35_JPRB, 0.18627157E-35_JPRB, 0.12246405E-35_JPRB, 0.78904646E-36_JPRB, 0.48843776E-36_JPRB, &
  & 0.29172310E-36_JPRB, 0.17028422E-36_JPRB, 0.96982196E-37_JPRB, 0.55189036E-37_JPRB, 0.31864322E-37_JPRB, 0.19269876E-37_JPRB, &
  & 0.12516255E-37_JPRB, 0.89276389E-38_JPRB, 0.69902499E-38_JPRB, 0.59468108E-38_JPRB, 0.53857870E-38_JPRB, 0.50667407E-38_JPRB, &
  & 0.47967021E-38_JPRB, 0.43270976E-38_JPRB, 0.33888161E-38_JPRB, 0.18023094E-38_JPRB /)

RGHG5(:, 5,11) = (/ &
  & 0.14591987E-36_JPRB, 0.13689859E-36_JPRB, 0.13768848E-36_JPRB, 0.14424911E-36_JPRB, 0.16369729E-36_JPRB, 0.20284472E-36_JPRB, &
  & 0.27930015E-36_JPRB, 0.46794741E-36_JPRB, 0.91234539E-36_JPRB, 0.18906626E-35_JPRB, 0.40518043E-35_JPRB, 0.88486887E-35_JPRB, &
  & 0.20071100E-34_JPRB, 0.43000639E-34_JPRB, 0.88791127E-34_JPRB, 0.18032479E-33_JPRB, 0.33770169E-33_JPRB, 0.68409877E-33_JPRB, &
  & 0.12094150E-32_JPRB, 0.15213092E-32_JPRB, 0.35918042E-32_JPRB, 0.68586246E-32_JPRB, 0.11939318E-31_JPRB, 0.12659069E-31_JPRB, &
  & 0.17774491E-31_JPRB, 0.27010063E-31_JPRB, 0.29774035E-31_JPRB, 0.37615129E-31_JPRB, 0.35121735E-31_JPRB, 0.33169638E-31_JPRB, &
  & 0.19133883E-31_JPRB, 0.15512426E-31_JPRB, 0.89925472E-32_JPRB, 0.59329955E-32_JPRB, 0.47313398E-32_JPRB, 0.39101115E-32_JPRB, &
  & 0.32605594E-32_JPRB, 0.25993389E-32_JPRB, 0.21219647E-32_JPRB, 0.16860393E-32_JPRB, 0.13025627E-32_JPRB, 0.98228955E-33_JPRB, &
  & 0.72254543E-33_JPRB, 0.51863913E-33_JPRB, 0.36313284E-33_JPRB, 0.24384101E-33_JPRB, 0.16053142E-33_JPRB, 0.10151898E-33_JPRB, &
  & 0.61824666E-34_JPRB, 0.36647428E-34_JPRB, 0.21079603E-34_JPRB, 0.12044423E-34_JPRB, 0.69523840E-35_JPRB, 0.42008871E-35_JPRB, &
  & 0.27372581E-35_JPRB, 0.19662905E-35_JPRB, 0.15576696E-35_JPRB, 0.13389296E-35_JPRB, 0.12260546E-35_JPRB, 0.11694275E-35_JPRB, &
  & 0.11355888E-35_JPRB, 0.10890259E-35_JPRB, 0.95679744E-36_JPRB, 0.66171941E-36_JPRB /)

RGHG5(:, 6,11) = (/ &
  & 0.58346776E-34_JPRB, 0.65289212E-34_JPRB, 0.67352044E-34_JPRB, 0.73029056E-34_JPRB, 0.84791587E-34_JPRB, 0.10668434E-33_JPRB, &
  & 0.14727378E-33_JPRB, 0.24475147E-33_JPRB, 0.46933412E-33_JPRB, 0.95992907E-33_JPRB, 0.19954737E-32_JPRB, 0.42289835E-32_JPRB, &
  & 0.92228714E-32_JPRB, 0.18906957E-31_JPRB, 0.37327758E-31_JPRB, 0.72441720E-31_JPRB, 0.12950660E-30_JPRB, 0.25051473E-30_JPRB, &
  & 0.42325249E-30_JPRB, 0.50709844E-30_JPRB, 0.11431130E-29_JPRB, 0.21011072E-29_JPRB, 0.35359111E-29_JPRB, 0.36090693E-29_JPRB, &
  & 0.49041421E-29_JPRB, 0.72729923E-29_JPRB, 0.78213633E-29_JPRB, 0.97037296E-29_JPRB, 0.89060365E-29_JPRB, 0.83341722E-29_JPRB, &
  & 0.47257713E-29_JPRB, 0.38413436E-29_JPRB, 0.22163248E-29_JPRB, 0.14707327E-29_JPRB, 0.11881455E-29_JPRB, 0.99681883E-30_JPRB, &
  & 0.84694048E-30_JPRB, 0.68832637E-30_JPRB, 0.57780964E-30_JPRB, 0.47273093E-30_JPRB, 0.37715482E-30_JPRB, 0.29394955E-30_JPRB, &
  & 0.22412375E-30_JPRB, 0.16676175E-30_JPRB, 0.12125880E-30_JPRB, 0.84577024E-31_JPRB, 0.57917312E-31_JPRB, 0.38077794E-31_JPRB, &
  & 0.24080823E-31_JPRB, 0.14805857E-31_JPRB, 0.88131095E-32_JPRB, 0.52137234E-32_JPRB, 0.31196033E-32_JPRB, 0.19611861E-32_JPRB, &
  & 0.13292236E-32_JPRB, 0.98948256E-33_JPRB, 0.80441980E-33_JPRB, 0.70390985E-33_JPRB, 0.65154943E-33_JPRB, 0.62601484E-33_JPRB, &
  & 0.61384770E-33_JPRB, 0.60638023E-33_JPRB, 0.59022866E-33_JPRB, 0.53873788E-33_JPRB /)

RGHG5(:, 7,11) = (/ &
  & 0.55219165E-31_JPRB, 0.47119732E-31_JPRB, 0.47726475E-31_JPRB, 0.52348637E-31_JPRB, 0.62196335E-31_JPRB, 0.79451710E-31_JPRB, &
  & 0.11061595E-30_JPRB, 0.18161917E-30_JPRB, 0.33893428E-30_JPRB, 0.66301610E-30_JPRB, 0.13092094E-29_JPRB, 0.26100161E-29_JPRB, &
  & 0.53322414E-29_JPRB, 0.10246721E-28_JPRB, 0.18947139E-28_JPRB, 0.34411264E-28_JPRB, 0.57577650E-28_JPRB, 0.10424139E-27_JPRB, &
  & 0.16533739E-27_JPRB, 0.18594237E-27_JPRB, 0.39318050E-27_JPRB, 0.68434589E-27_JPRB, 0.11002794E-26_JPRB, 0.10707685E-26_JPRB, &
  & 0.13934525E-26_JPRB, 0.20063758E-26_JPRB, 0.20878702E-26_JPRB, 0.25368613E-26_JPRB, 0.22763419E-26_JPRB, 0.21015534E-26_JPRB, &
  & 0.11748570E-26_JPRB, 0.95419159E-27_JPRB, 0.55093475E-27_JPRB, 0.36860896E-27_JPRB, 0.30216695E-27_JPRB, 0.25817276E-27_JPRB, &
  & 0.22451408E-27_JPRB, 0.18731846E-27_JPRB, 0.16266853E-27_JPRB, 0.13824235E-27_JPRB, 0.11470953E-27_JPRB, 0.93488889E-28_JPRB, &
  & 0.74461387E-28_JPRB, 0.58067257E-28_JPRB, 0.44242938E-28_JPRB, 0.32334889E-28_JPRB, 0.23260031E-28_JPRB, 0.16062328E-28_JPRB, &
  & 0.10678354E-28_JPRB, 0.69179351E-29_JPRB, 0.43456318E-29_JPRB, 0.27257888E-29_JPRB, 0.17389720E-29_JPRB, 0.11690592E-29_JPRB, &
  & 0.84493829E-30_JPRB, 0.66335384E-30_JPRB, 0.56140510E-30_JPRB, 0.50499350E-30_JPRB, 0.47603308E-30_JPRB, 0.46283543E-30_JPRB, &
  & 0.45748651E-30_JPRB, 0.45520351E-30_JPRB, 0.45123843E-30_JPRB, 0.43574311E-30_JPRB /)

RGHG5(:, 8,11) = (/ &
  & 0.47654085E-28_JPRB, 0.36455245E-28_JPRB, 0.35473866E-28_JPRB, 0.38761468E-28_JPRB, 0.45918696E-28_JPRB, 0.58552856E-28_JPRB, &
  & 0.80498840E-28_JPRB, 0.12936969E-27_JPRB, 0.23193767E-27_JPRB, 0.43167707E-27_JPRB, 0.80197384E-27_JPRB, 0.14971496E-26_JPRB, &
  & 0.28533230E-26_JPRB, 0.51174343E-26_JPRB, 0.88217668E-26_JPRB, 0.14932628E-25_JPRB, 0.23258183E-25_JPRB, 0.39290166E-25_JPRB, &
  & 0.58347363E-25_JPRB, 0.61048448E-25_JPRB, 0.12102799E-24_JPRB, 0.19934246E-24_JPRB, 0.30572743E-24_JPRB, 0.28244918E-24_JPRB, &
  & 0.35121123E-24_JPRB, 0.49056282E-24_JPRB, 0.49255218E-24_JPRB, 0.58553102E-24_JPRB, 0.51282990E-24_JPRB, 0.46670125E-24_JPRB, &
  & 0.25765435E-24_JPRB, 0.20874108E-24_JPRB, 0.12081042E-24_JPRB, 0.81567096E-25_JPRB, 0.67800259E-25_JPRB, 0.59014820E-25_JPRB, &
  & 0.52576199E-25_JPRB, 0.45129013E-25_JPRB, 0.40624793E-25_JPRB, 0.35900413E-25_JPRB, 0.31172067E-25_JPRB, 0.26587734E-25_JPRB, &
  & 0.22258697E-25_JPRB, 0.18202990E-25_JPRB, 0.14566968E-25_JPRB, 0.11146194E-25_JPRB, 0.84262139E-26_JPRB, 0.61112091E-26_JPRB, &
  & 0.42742468E-26_JPRB, 0.29280549E-26_JPRB, 0.19491297E-26_JPRB, 0.13046334E-26_JPRB, 0.89005186E-27_JPRB, 0.64048977E-27_JPRB, &
  & 0.49177061E-27_JPRB, 0.40582551E-27_JPRB, 0.35655331E-27_JPRB, 0.32949431E-27_JPRB, 0.31646202E-27_JPRB, 0.31156554E-27_JPRB, &
  & 0.31051638E-27_JPRB, 0.31063769E-27_JPRB, 0.30922835E-27_JPRB, 0.30081528E-27_JPRB /)

RGHG5(:, 9,11) = (/ &
  & 0.36168151E-25_JPRB, 0.26356487E-25_JPRB, 0.25062757E-25_JPRB, 0.26854690E-25_JPRB, 0.31297724E-25_JPRB, 0.39011662E-25_JPRB, &
  & 0.52188104E-25_JPRB, 0.80844838E-25_JPRB, 0.13905352E-24_JPRB, 0.24553074E-24_JPRB, 0.43035094E-24_JPRB, 0.75287218E-24_JPRB, &
  & 0.13410941E-23_JPRB, 0.22454381E-23_JPRB, 0.36081019E-23_JPRB, 0.56906505E-23_JPRB, 0.82432225E-23_JPRB, 0.13004420E-22_JPRB, &
  & 0.18101682E-22_JPRB, 0.17510437E-22_JPRB, 0.32667746E-22_JPRB, 0.50889837E-22_JPRB, 0.74478138E-22_JPRB, 0.65151227E-22_JPRB, &
  & 0.77303623E-22_JPRB, 0.10448321E-21_JPRB, 0.10116552E-21_JPRB, 0.11743179E-21_JPRB, 0.10046124E-21_JPRB, 0.90052959E-22_JPRB, &
  & 0.49179671E-22_JPRB, 0.39671064E-22_JPRB, 0.23011693E-22_JPRB, 0.15669146E-22_JPRB, 0.13201325E-22_JPRB, 0.11716438E-22_JPRB, &
  & 0.10693006E-22_JPRB, 0.94718071E-23_JPRB, 0.88351159E-23_JPRB, 0.81447459E-23_JPRB, 0.74002079E-23_JPRB, 0.66429496E-23_JPRB, &
  & 0.58450771E-23_JPRB, 0.50323532E-23_JPRB, 0.42305411E-23_JPRB, 0.33873660E-23_JPRB, 0.26901109E-23_JPRB, 0.20463884E-23_JPRB, &
  & 0.15043031E-23_JPRB, 0.10894512E-23_JPRB, 0.76821671E-24_JPRB, 0.54723675E-24_JPRB, 0.39734544E-24_JPRB, 0.30306530E-24_JPRB, &
  & 0.24477501E-24_JPRB, 0.21033245E-24_JPRB, 0.19058993E-24_JPRB, 0.18012192E-24_JPRB, 0.17573167E-24_JPRB, 0.17485171E-24_JPRB, &
  & 0.17546316E-24_JPRB, 0.17625427E-24_JPRB, 0.17594105E-24_JPRB, 0.17216929E-24_JPRB /)

RGHG5(:,10,11) = (/ &
  & 0.23583861E-22_JPRB, 0.16886445E-22_JPRB, 0.15764906E-22_JPRB, 0.16572873E-22_JPRB, 0.18837071E-22_JPRB, 0.22774746E-22_JPRB, &
  & 0.29299017E-22_JPRB, 0.43582801E-22_JPRB, 0.71625680E-22_JPRB, 0.12032665E-21_JPRB, 0.19916107E-21_JPRB, 0.32750390E-21_JPRB, &
  & 0.54609763E-21_JPRB, 0.85441557E-21_JPRB, 0.12801346E-20_JPRB, 0.18814005E-20_JPRB, 0.25342615E-20_JPRB, 0.37334950E-20_JPRB, &
  & 0.48735066E-20_JPRB, 0.43490685E-20_JPRB, 0.76408466E-20_JPRB, 0.11244774E-19_JPRB, 0.15681436E-19_JPRB, 0.12981555E-19_JPRB, &
  & 0.14682477E-19_JPRB, 0.19132486E-19_JPRB, 0.17880410E-19_JPRB, 0.20219118E-19_JPRB, 0.16915407E-19_JPRB, 0.14931153E-19_JPRB, &
  & 0.80728603E-20_JPRB, 0.64798942E-20_JPRB, 0.37640725E-20_JPRB, 0.25843170E-20_JPRB, 0.22082085E-20_JPRB, 0.19992796E-20_JPRB, &
  & 0.18718245E-20_JPRB, 0.17128637E-20_JPRB, 0.16572420E-20_JPRB, 0.15929812E-20_JPRB, 0.15177100E-20_JPRB, 0.14326221E-20_JPRB, &
  & 0.13299292E-20_JPRB, 0.12064522E-20_JPRB, 0.10688744E-20_JPRB, 0.89592627E-21_JPRB, 0.74865490E-21_JPRB, 0.59729125E-21_JPRB, &
  & 0.46126477E-21_JPRB, 0.35277049E-21_JPRB, 0.26279489E-21_JPRB, 0.19822772E-21_JPRB, 0.15195629E-21_JPRB, 0.12176963E-21_JPRB, &
  & 0.10250458E-21_JPRB, 0.91058328E-22_JPRB, 0.84619734E-22_JPRB, 0.81456262E-22_JPRB, 0.80488753E-22_JPRB, 0.80760197E-22_JPRB, &
  & 0.81443123E-22_JPRB, 0.82119360E-22_JPRB, 0.82191607E-22_JPRB, 0.80486418E-22_JPRB /)

RGHG5(:,11,11) = (/ &
  & 0.12884803E-19_JPRB, 0.91486071E-20_JPRB, 0.84282709E-20_JPRB, 0.86934986E-20_JPRB, 0.96372414E-20_JPRB, 0.11283771E-19_JPRB, &
  & 0.13950265E-19_JPRB, 0.19875156E-19_JPRB, 0.31265120E-19_JPRB, 0.50042198E-19_JPRB, 0.78491491E-19_JPRB, 0.12161779E-18_JPRB, &
  & 0.19039870E-18_JPRB, 0.27886339E-18_JPRB, 0.39005854E-18_JPRB, 0.53459173E-18_JPRB, 0.67017077E-18_JPRB, 0.92145129E-18_JPRB, &
  & 0.11275402E-17_JPRB, 0.93099695E-18_JPRB, 0.15364551E-17_JPRB, 0.21344207E-17_JPRB, 0.28305943E-17_JPRB, 0.22204931E-17_JPRB, &
  & 0.23921025E-17_JPRB, 0.29987487E-17_JPRB, 0.27069107E-17_JPRB, 0.29768636E-17_JPRB, 0.24365587E-17_JPRB, 0.21166812E-17_JPRB, &
  & 0.11334972E-17_JPRB, 0.90530730E-18_JPRB, 0.52668042E-18_JPRB, 0.36464448E-18_JPRB, 0.31626020E-18_JPRB, 0.29241675E-18_JPRB, &
  & 0.28094450E-18_JPRB, 0.26577476E-18_JPRB, 0.26653949E-18_JPRB, 0.26695011E-18_JPRB, 0.26615350E-18_JPRB, 0.26404616E-18_JPRB, &
  & 0.25833176E-18_JPRB, 0.24742502E-18_JPRB, 0.23145896E-18_JPRB, 0.20365918E-18_JPRB, 0.17948010E-18_JPRB, 0.15039011E-18_JPRB, &
  & 0.12204305E-18_JPRB, 0.98481500E-19_JPRB, 0.77234616E-19_JPRB, 0.61413785E-19_JPRB, 0.49404690E-19_JPRB, 0.41342755E-19_JPRB, &
  & 0.36093231E-19_JPRB, 0.33014132E-19_JPRB, 0.31371242E-19_JPRB, 0.30691764E-19_JPRB, 0.30667650E-19_JPRB, 0.30991549E-19_JPRB, &
  & 0.31412458E-19_JPRB, 0.31718428E-19_JPRB, 0.31810439E-19_JPRB, 0.31333421E-19_JPRB /)

RGHG5(:,12,11) = (/ &
  & 0.58418415E-17_JPRB, 0.41174569E-17_JPRB, 0.37494013E-17_JPRB, 0.38027188E-17_JPRB, 0.41211983E-17_JPRB, 0.46856539E-17_JPRB, &
  & 0.55757052E-17_JPRB, 0.76204312E-17_JPRB, 0.11491883E-16_JPRB, 0.17573747E-16_JPRB, 0.26183754E-16_JPRB, 0.38330653E-16_JPRB, &
  & 0.56489309E-16_JPRB, 0.77587080E-16_JPRB, 0.10143871E-15_JPRB, 0.12972140E-15_JPRB, 0.15149456E-15_JPRB, 0.19421605E-15_JPRB, &
  & 0.22259534E-15_JPRB, 0.17092404E-15_JPRB, 0.26400529E-15_JPRB, 0.34579424E-15_JPRB, 0.43553725E-15_JPRB, 0.32445081E-15_JPRB, &
  & 0.33268598E-15_JPRB, 0.40067377E-15_JPRB, 0.34937166E-15_JPRB, 0.37318554E-15_JPRB, 0.29866361E-15_JPRB, 0.25511515E-15_JPRB, &
  & 0.13528434E-15_JPRB, 0.10751540E-15_JPRB, 0.62678632E-16_JPRB, 0.43780873E-16_JPRB, 0.38587585E-16_JPRB, 0.36458624E-16_JPRB, &
  & 0.35971524E-16_JPRB, 0.35158981E-16_JPRB, 0.36536730E-16_JPRB, 0.38079504E-16_JPRB, 0.39664793E-16_JPRB, 0.41270340E-16_JPRB, &
  & 0.42502075E-16_JPRB, 0.42963814E-16_JPRB, 0.42492027E-16_JPRB, 0.39370637E-16_JPRB, 0.36668443E-16_JPRB, 0.32322761E-16_JPRB, &
  & 0.27590995E-16_JPRB, 0.23446082E-16_JPRB, 0.19325869E-16_JPRB, 0.16124761E-16_JPRB, 0.13565753E-16_JPRB, 0.11809974E-16_JPRB, &
  & 0.10663694E-16_JPRB, 0.10023788E-16_JPRB, 0.97279691E-17_JPRB, 0.96657146E-17_JPRB, 0.97626776E-17_JPRB, 0.99386007E-17_JPRB, &
  & 0.10109232E-16_JPRB, 0.10252498E-16_JPRB, 0.10294490E-16_JPRB, 0.10125437E-16_JPRB /)

RGHG5(:,13,11) = (/ &
  & 0.48835225E-16_JPRB, 0.38927566E-16_JPRB, 0.36234908E-16_JPRB, 0.36106708E-16_JPRB, 0.37477548E-16_JPRB, 0.39950289E-16_JPRB, &
  & 0.45248275E-16_JPRB, 0.57285672E-16_JPRB, 0.81087523E-16_JPRB, 0.11943699E-15_JPRB, 0.18153711E-15_JPRB, 0.27572611E-15_JPRB, &
  & 0.40445140E-15_JPRB, 0.55878213E-15_JPRB, 0.73052468E-15_JPRB, 0.88293153E-15_JPRB, 0.10453399E-14_JPRB, 0.12974046E-14_JPRB, &
  & 0.16247920E-14_JPRB, 0.14385517E-14_JPRB, 0.19097671E-14_JPRB, 0.22193991E-14_JPRB, 0.29166631E-14_JPRB, 0.24522362E-14_JPRB, &
  & 0.27922583E-14_JPRB, 0.27372410E-14_JPRB, 0.29511655E-14_JPRB, 0.22588817E-14_JPRB, 0.19554406E-14_JPRB, 0.15519560E-14_JPRB, &
  & 0.94130877E-15_JPRB, 0.71061485E-15_JPRB, 0.52391910E-15_JPRB, 0.44441611E-15_JPRB, 0.42264525E-15_JPRB, 0.44370937E-15_JPRB, &
  & 0.46157261E-15_JPRB, 0.48615382E-15_JPRB, 0.51332939E-15_JPRB, 0.55549559E-15_JPRB, 0.60129519E-15_JPRB, 0.63785408E-15_JPRB, &
  & 0.65928021E-15_JPRB, 0.68669273E-15_JPRB, 0.69502325E-15_JPRB, 0.66209998E-15_JPRB, 0.62382881E-15_JPRB, 0.57103864E-15_JPRB, &
  & 0.49118620E-15_JPRB, 0.42900713E-15_JPRB, 0.36029648E-15_JPRB, 0.30346565E-15_JPRB, 0.25658886E-15_JPRB, 0.22009792E-15_JPRB, &
  & 0.19261460E-15_JPRB, 0.17337252E-15_JPRB, 0.15931463E-15_JPRB, 0.14964559E-15_JPRB, 0.14325160E-15_JPRB, 0.13905214E-15_JPRB, &
  & 0.13600797E-15_JPRB, 0.13351324E-15_JPRB, 0.12972797E-15_JPRB, 0.12323820E-15_JPRB /)

RGHG5(:,14,11) = (/ &
  & 0.35897921E-15_JPRB, 0.33034041E-15_JPRB, 0.32323773E-15_JPRB, 0.32611192E-15_JPRB, 0.33747158E-15_JPRB, 0.36011201E-15_JPRB, &
  & 0.39930557E-15_JPRB, 0.46465930E-15_JPRB, 0.57628723E-15_JPRB, 0.73206723E-15_JPRB, 0.94968847E-15_JPRB, 0.12624775E-14_JPRB, &
  & 0.17372614E-14_JPRB, 0.24956970E-14_JPRB, 0.36614075E-14_JPRB, 0.55121969E-14_JPRB, 0.64484843E-14_JPRB, 0.83297830E-14_JPRB, &
  & 0.10388847E-13_JPRB, 0.10932727E-13_JPRB, 0.10534218E-13_JPRB, 0.12535889E-13_JPRB, 0.15656740E-13_JPRB, 0.16800651E-13_JPRB, &
  & 0.14805304E-13_JPRB, 0.13756206E-13_JPRB, 0.13095278E-13_JPRB, 0.11941354E-13_JPRB, 0.11749202E-13_JPRB, 0.79125735E-14_JPRB, &
  & 0.59817395E-14_JPRB, 0.48968288E-14_JPRB, 0.40153627E-14_JPRB, 0.37107785E-14_JPRB, 0.38557418E-14_JPRB, 0.41620023E-14_JPRB, &
  & 0.45747140E-14_JPRB, 0.50326018E-14_JPRB, 0.55573129E-14_JPRB, 0.60419224E-14_JPRB, 0.65566203E-14_JPRB, 0.70201252E-14_JPRB, &
  & 0.72917458E-14_JPRB, 0.75852343E-14_JPRB, 0.76506210E-14_JPRB, 0.73139440E-14_JPRB, 0.70791643E-14_JPRB, 0.65021955E-14_JPRB, &
  & 0.58806088E-14_JPRB, 0.50874531E-14_JPRB, 0.44330697E-14_JPRB, 0.37183133E-14_JPRB, 0.31651828E-14_JPRB, 0.26775808E-14_JPRB, &
  & 0.22921008E-14_JPRB, 0.19938851E-14_JPRB, 0.17596862E-14_JPRB, 0.15818484E-14_JPRB, 0.14493435E-14_JPRB, 0.13516209E-14_JPRB, &
  & 0.12794194E-14_JPRB, 0.12184334E-14_JPRB, 0.11607144E-14_JPRB, 0.10456674E-14_JPRB /)

RGHG5(:,15,11) = (/ &
  & 0.30701486E-14_JPRB, 0.29454027E-14_JPRB, 0.30489302E-14_JPRB, 0.32489215E-14_JPRB, 0.35355854E-14_JPRB, 0.39267041E-14_JPRB, &
  & 0.44602349E-14_JPRB, 0.51967479E-14_JPRB, 0.62403149E-14_JPRB, 0.75352305E-14_JPRB, 0.91741054E-14_JPRB, 0.11251915E-13_JPRB, &
  & 0.13780022E-13_JPRB, 0.17001933E-13_JPRB, 0.21056136E-13_JPRB, 0.26646332E-13_JPRB, 0.35313935E-13_JPRB, 0.43058313E-13_JPRB, &
  & 0.58433002E-13_JPRB, 0.76984778E-13_JPRB, 0.90555947E-13_JPRB, 0.98921901E-13_JPRB, 0.10742869E-12_JPRB, 0.11615736E-12_JPRB, &
  & 0.11632774E-12_JPRB, 0.10414729E-12_JPRB, 0.89770354E-13_JPRB, 0.71499074E-13_JPRB, 0.54606994E-13_JPRB, 0.45154886E-13_JPRB, &
  & 0.36377456E-13_JPRB, 0.30585333E-13_JPRB, 0.27102362E-13_JPRB, 0.26471846E-13_JPRB, 0.28604936E-13_JPRB, 0.31999553E-13_JPRB, &
  & 0.35932229E-13_JPRB, 0.40431149E-13_JPRB, 0.44485581E-13_JPRB, 0.48651845E-13_JPRB, 0.52874124E-13_JPRB, 0.56427749E-13_JPRB, &
  & 0.59161138E-13_JPRB, 0.60197873E-13_JPRB, 0.60122236E-13_JPRB, 0.58618935E-13_JPRB, 0.56210739E-13_JPRB, 0.52458475E-13_JPRB, &
  & 0.47796880E-13_JPRB, 0.42204057E-13_JPRB, 0.36847282E-13_JPRB, 0.31490899E-13_JPRB, 0.26789618E-13_JPRB, 0.22611919E-13_JPRB, &
  & 0.19158406E-13_JPRB, 0.16328913E-13_JPRB, 0.14042116E-13_JPRB, 0.12252485E-13_JPRB, 0.10880948E-13_JPRB, 0.98434478E-14_JPRB, &
  & 0.90821024E-14_JPRB, 0.84629112E-14_JPRB, 0.78922397E-14_JPRB, 0.69336516E-14_JPRB /)

RGHG5(:,16,11) = (/ &
  & 0.18427215E-13_JPRB, 0.19591459E-13_JPRB, 0.21080405E-13_JPRB, 0.23030524E-13_JPRB, 0.25604325E-13_JPRB, 0.29031099E-13_JPRB, &
  & 0.33635739E-13_JPRB, 0.39875557E-13_JPRB, 0.48436519E-13_JPRB, 0.58968557E-13_JPRB, 0.71952677E-13_JPRB, 0.87918171E-13_JPRB, &
  & 0.10706570E-12_JPRB, 0.13002605E-12_JPRB, 0.15824438E-12_JPRB, 0.19383629E-12_JPRB, 0.23807719E-12_JPRB, 0.29243619E-12_JPRB, &
  & 0.35393894E-12_JPRB, 0.42220811E-12_JPRB, 0.48486112E-12_JPRB, 0.52884368E-12_JPRB, 0.54880048E-12_JPRB, 0.54459508E-12_JPRB, &
  & 0.51701254E-12_JPRB, 0.46953256E-12_JPRB, 0.41088124E-12_JPRB, 0.34515213E-12_JPRB, 0.27867097E-12_JPRB, 0.22519299E-12_JPRB, &
  & 0.18539623E-12_JPRB, 0.16202565E-12_JPRB, 0.15273793E-12_JPRB, 0.15668588E-12_JPRB, 0.17258287E-12_JPRB, 0.19508215E-12_JPRB, &
  & 0.22477330E-12_JPRB, 0.25347034E-12_JPRB, 0.27999738E-12_JPRB, 0.30293538E-12_JPRB, 0.32067477E-12_JPRB, 0.33275932E-12_JPRB, &
  & 0.33854731E-12_JPRB, 0.33898272E-12_JPRB, 0.33339591E-12_JPRB, 0.32343372E-12_JPRB, 0.30914859E-12_JPRB, 0.28998361E-12_JPRB, &
  & 0.26683430E-12_JPRB, 0.24045804E-12_JPRB, 0.21261721E-12_JPRB, 0.18477044E-12_JPRB, 0.15852788E-12_JPRB, 0.13474412E-12_JPRB, &
  & 0.11421913E-12_JPRB, 0.96605016E-13_JPRB, 0.82112241E-13_JPRB, 0.70541947E-13_JPRB, 0.61557028E-13_JPRB, 0.54765525E-13_JPRB, &
  & 0.49603029E-13_JPRB, 0.45820373E-13_JPRB, 0.41970923E-13_JPRB, 0.36604769E-13_JPRB /)

RGHG5(:,17,11) = (/ &
  & 0.91315010E-13_JPRB, 0.10018519E-12_JPRB, 0.10865899E-12_JPRB, 0.11897236E-12_JPRB, 0.13226636E-12_JPRB, 0.14973076E-12_JPRB, &
  & 0.17289864E-12_JPRB, 0.20362228E-12_JPRB, 0.24446458E-12_JPRB, 0.29388661E-12_JPRB, 0.35313237E-12_JPRB, 0.42377091E-12_JPRB, &
  & 0.50722805E-12_JPRB, 0.60627555E-12_JPRB, 0.72086786E-12_JPRB, 0.85995864E-12_JPRB, 0.10258957E-11_JPRB, 0.12215767E-11_JPRB, &
  & 0.14350225E-11_JPRB, 0.16468616E-11_JPRB, 0.18243601E-11_JPRB, 0.19433535E-11_JPRB, 0.19885569E-11_JPRB, 0.19430508E-11_JPRB, &
  & 0.18158484E-11_JPRB, 0.16119744E-11_JPRB, 0.13856278E-11_JPRB, 0.11736317E-11_JPRB, 0.99052288E-12_JPRB, 0.84642411E-12_JPRB, &
  & 0.74784786E-12_JPRB, 0.69355112E-12_JPRB, 0.68353190E-12_JPRB, 0.71835458E-12_JPRB, 0.79012166E-12_JPRB, 0.89725764E-12_JPRB, &
  & 0.10113452E-11_JPRB, 0.11306323E-11_JPRB, 0.12331248E-11_JPRB, 0.13153904E-11_JPRB, 0.13710219E-11_JPRB, 0.13991129E-11_JPRB, &
  & 0.14017538E-11_JPRB, 0.13820261E-11_JPRB, 0.13440030E-11_JPRB, 0.12951066E-11_JPRB, 0.12356867E-11_JPRB, 0.11653516E-11_JPRB, &
  & 0.10829103E-11_JPRB, 0.99013853E-12_JPRB, 0.88953655E-12_JPRB, 0.78572251E-12_JPRB, 0.68374993E-12_JPRB, 0.58806307E-12_JPRB, &
  & 0.50159779E-12_JPRB, 0.42554214E-12_JPRB, 0.36154304E-12_JPRB, 0.30959585E-12_JPRB, 0.26862572E-12_JPRB, 0.23729033E-12_JPRB, &
  & 0.21418368E-12_JPRB, 0.19583697E-12_JPRB, 0.18026180E-12_JPRB, 0.15428666E-12_JPRB /)

RGHG5(:,18,11) = (/ &
  & 0.34413385E-12_JPRB, 0.38258822E-12_JPRB, 0.41507832E-12_JPRB, 0.45327243E-12_JPRB, 0.50176530E-12_JPRB, 0.56493715E-12_JPRB, &
  & 0.64742309E-12_JPRB, 0.75496797E-12_JPRB, 0.89397240E-12_JPRB, 0.10602516E-11_JPRB, 0.12553362E-11_JPRB, 0.14804955E-11_JPRB, &
  & 0.17371728E-11_JPRB, 0.20369702E-11_JPRB, 0.23797013E-11_JPRB, 0.27733460E-11_JPRB, 0.32239892E-11_JPRB, 0.37309587E-11_JPRB, &
  & 0.42617047E-11_JPRB, 0.47616516E-11_JPRB, 0.51622799E-11_JPRB, 0.54098709E-11_JPRB, 0.54518811E-11_JPRB, 0.52632928E-11_JPRB, &
  & 0.49043096E-11_JPRB, 0.44213496E-11_JPRB, 0.39057789E-11_JPRB, 0.34136368E-11_JPRB, 0.29953928E-11_JPRB, 0.27075085E-11_JPRB, &
  & 0.25084854E-11_JPRB, 0.24260622E-11_JPRB, 0.24434124E-11_JPRB, 0.25666103E-11_JPRB, 0.27810245E-11_JPRB, 0.30757014E-11_JPRB, &
  & 0.34178786E-11_JPRB, 0.37478007E-11_JPRB, 0.40344243E-11_JPRB, 0.42404565E-11_JPRB, 0.43648037E-11_JPRB, 0.43978285E-11_JPRB, &
  & 0.43592191E-11_JPRB, 0.42576090E-11_JPRB, 0.41180544E-11_JPRB, 0.39530185E-11_JPRB, 0.37717668E-11_JPRB, 0.35709140E-11_JPRB, &
  & 0.33466927E-11_JPRB, 0.30987561E-11_JPRB, 0.28271920E-11_JPRB, 0.25395558E-11_JPRB, 0.22474585E-11_JPRB, 0.19629717E-11_JPRB, &
  & 0.16924959E-11_JPRB, 0.14495264E-11_JPRB, 0.12412736E-11_JPRB, 0.10687920E-11_JPRB, 0.93076003E-12_JPRB, 0.82359607E-12_JPRB, &
  & 0.74322953E-12_JPRB, 0.68132251E-12_JPRB, 0.62538668E-12_JPRB, 0.54042719E-12_JPRB /)

RGHG5(:,19,11) = (/ &
  & 0.96658911E-12_JPRB, 0.10906814E-11_JPRB, 0.11894006E-11_JPRB, 0.12992169E-11_JPRB, 0.14347696E-11_JPRB, 0.16067259E-11_JPRB, &
  & 0.18273007E-11_JPRB, 0.21074934E-11_JPRB, 0.24605222E-11_JPRB, 0.28775988E-11_JPRB, 0.33604460E-11_JPRB, 0.39071450E-11_JPRB, &
  & 0.45141807E-11_JPRB, 0.51994750E-11_JPRB, 0.59682285E-11_JPRB, 0.68315687E-11_JPRB, 0.77747322E-11_JPRB, 0.88062778E-11_JPRB, &
  & 0.98442469E-11_JPRB, 0.10784429E-10_JPRB, 0.11500498E-10_JPRB, 0.11931792E-10_JPRB, 0.11972961E-10_JPRB, 0.11620593E-10_JPRB, &
  & 0.10934158E-10_JPRB, 0.10027527E-10_JPRB, 0.91253108E-11_JPRB, 0.83007342E-11_JPRB, 0.76713393E-11_JPRB, 0.72268415E-11_JPRB, &
  & 0.69869826E-11_JPRB, 0.69313691E-11_JPRB, 0.70414130E-11_JPRB, 0.73291755E-11_JPRB, 0.77749803E-11_JPRB, 0.83487349E-11_JPRB, &
  & 0.89913875E-11_JPRB, 0.96535774E-11_JPRB, 0.10220517E-10_JPRB, 0.10619515E-10_JPRB, 0.10828978E-10_JPRB, 0.10835109E-10_JPRB, &
  & 0.10671740E-10_JPRB, 0.10391218E-10_JPRB, 0.10024911E-10_JPRB, 0.96256354E-11_JPRB, 0.92017054E-11_JPRB, 0.87511266E-11_JPRB, &
  & 0.82619779E-11_JPRB, 0.77253794E-11_JPRB, 0.71375432E-11_JPRB, 0.65076482E-11_JPRB, 0.58499746E-11_JPRB, 0.51863886E-11_JPRB, &
  & 0.45424606E-11_JPRB, 0.39515752E-11_JPRB, 0.34328484E-11_JPRB, 0.29941358E-11_JPRB, 0.26345783E-11_JPRB, 0.23505661E-11_JPRB, &
  & 0.21295951E-11_JPRB, 0.19640704E-11_JPRB, 0.18006581E-11_JPRB, 0.15763527E-11_JPRB /)

RGHG5(:,20,11) = (/ &
  & 0.21712823E-11_JPRB, 0.24681997E-11_JPRB, 0.26914640E-11_JPRB, 0.29388378E-11_JPRB, 0.32375433E-11_JPRB, 0.36121540E-11_JPRB, &
  & 0.40805801E-11_JPRB, 0.46625650E-11_JPRB, 0.53720448E-11_JPRB, 0.61962822E-11_JPRB, 0.71385046E-11_JPRB, 0.81925673E-11_JPRB, &
  & 0.93444228E-11_JPRB, 0.10617317E-10_JPRB, 0.12014723E-10_JPRB, 0.13553725E-10_JPRB, 0.15192474E-10_JPRB, 0.16910992E-10_JPRB, &
  & 0.18622787E-10_JPRB, 0.20160812E-10_JPRB, 0.21329433E-10_JPRB, 0.22055132E-10_JPRB, 0.22195778E-10_JPRB, 0.21746702E-10_JPRB, &
  & 0.20826979E-10_JPRB, 0.19638719E-10_JPRB, 0.18454018E-10_JPRB, 0.17434401E-10_JPRB, 0.16735269E-10_JPRB, 0.16320993E-10_JPRB, &
  & 0.16173826E-10_JPRB, 0.16244343E-10_JPRB, 0.16471310E-10_JPRB, 0.16869053E-10_JPRB, 0.17461239E-10_JPRB, 0.18204407E-10_JPRB, &
  & 0.19119291E-10_JPRB, 0.20061477E-10_JPRB, 0.20862435E-10_JPRB, 0.21526258E-10_JPRB, 0.21795597E-10_JPRB, 0.21769579E-10_JPRB, &
  & 0.21417873E-10_JPRB, 0.20871312E-10_JPRB, 0.20168849E-10_JPRB, 0.19393801E-10_JPRB, 0.18585779E-10_JPRB, 0.17735917E-10_JPRB, &
  & 0.16827506E-10_JPRB, 0.15849964E-10_JPRB, 0.14794884E-10_JPRB, 0.13662923E-10_JPRB, 0.12470169E-10_JPRB, 0.11233329E-10_JPRB, &
  & 0.10017246E-10_JPRB, 0.88741289E-11_JPRB, 0.78482229E-11_JPRB, 0.69561110E-11_JPRB, 0.62068926E-11_JPRB, 0.55958593E-11_JPRB, &
  & 0.51241481E-11_JPRB, 0.47218739E-11_JPRB, 0.43915375E-11_JPRB, 0.37970282E-11_JPRB /)

RGHG5(:,21,11) = (/ &
  & 0.41256673E-11_JPRB, 0.46843228E-11_JPRB, 0.51078091E-11_JPRB, 0.55615798E-11_JPRB, 0.61074301E-11_JPRB, 0.67777867E-11_JPRB, &
  & 0.76049549E-11_JPRB, 0.86065937E-11_JPRB, 0.98008641E-11_JPRB, 0.11164983E-10_JPRB, 0.12702242E-10_JPRB, 0.14406434E-10_JPRB, &
  & 0.16252721E-10_JPRB, 0.18252636E-10_JPRB, 0.20417862E-10_JPRB, 0.22762799E-10_JPRB, 0.25237815E-10_JPRB, 0.27784271E-10_JPRB, &
  & 0.30265280E-10_JPRB, 0.32524376E-10_JPRB, 0.34337207E-10_JPRB, 0.35574710E-10_JPRB, 0.36099367E-10_JPRB, 0.35902312E-10_JPRB, &
  & 0.35117985E-10_JPRB, 0.34005649E-10_JPRB, 0.32938745E-10_JPRB, 0.32112771E-10_JPRB, 0.31590151E-10_JPRB, 0.31409833E-10_JPRB, &
  & 0.31484784E-10_JPRB, 0.31673584E-10_JPRB, 0.31884176E-10_JPRB, 0.32170547E-10_JPRB, 0.32621017E-10_JPRB, 0.33264939E-10_JPRB, &
  & 0.34179541E-10_JPRB, 0.35211164E-10_JPRB, 0.36226466E-10_JPRB, 0.36989814E-10_JPRB, 0.37418499E-10_JPRB, 0.37269521E-10_JPRB, &
  & 0.36719919E-10_JPRB, 0.35842010E-10_JPRB, 0.34667397E-10_JPRB, 0.33403700E-10_JPRB, 0.32071814E-10_JPRB, 0.30662129E-10_JPRB, &
  & 0.29197401E-10_JPRB, 0.27656240E-10_JPRB, 0.26023317E-10_JPRB, 0.24294913E-10_JPRB, 0.22453719E-10_JPRB, 0.20555198E-10_JPRB, &
  & 0.18662190E-10_JPRB, 0.16849761E-10_JPRB, 0.15176249E-10_JPRB, 0.13685057E-10_JPRB, 0.12395697E-10_JPRB, 0.11316096E-10_JPRB, &
  & 0.10416053E-10_JPRB, 0.97170163E-11_JPRB, 0.89421248E-11_JPRB, 0.79408485E-11_JPRB /)

RGHG5(:,22,11) = (/ &
  & 0.68648585E-11_JPRB, 0.78005762E-11_JPRB, 0.84774097E-11_JPRB, 0.92086625E-11_JPRB, 0.10065998E-10_JPRB, 0.11106819E-10_JPRB, &
  & 0.12361267E-10_JPRB, 0.13857607E-10_JPRB, 0.15606346E-10_JPRB, 0.17581495E-10_JPRB, 0.19783510E-10_JPRB, 0.22205586E-10_JPRB, &
  & 0.24822186E-10_JPRB, 0.27625513E-10_JPRB, 0.30609081E-10_JPRB, 0.33791744E-10_JPRB, 0.37119849E-10_JPRB, 0.40545869E-10_JPRB, &
  & 0.43906316E-10_JPRB, 0.47021338E-10_JPRB, 0.49687039E-10_JPRB, 0.51785021E-10_JPRB, 0.53121001E-10_JPRB, 0.53637809E-10_JPRB, &
  & 0.53498893E-10_JPRB, 0.52996572E-10_JPRB, 0.52502371E-10_JPRB, 0.52215579E-10_JPRB, 0.52162115E-10_JPRB, 0.52326934E-10_JPRB, &
  & 0.52554811E-10_JPRB, 0.52662378E-10_JPRB, 0.52573345E-10_JPRB, 0.52464044E-10_JPRB, 0.52473331E-10_JPRB, 0.52722039E-10_JPRB, &
  & 0.53382517E-10_JPRB, 0.54312478E-10_JPRB, 0.55292729E-10_JPRB, 0.56141702E-10_JPRB, 0.56564736E-10_JPRB, 0.56401644E-10_JPRB, &
  & 0.55598706E-10_JPRB, 0.54371757E-10_JPRB, 0.52718531E-10_JPRB, 0.50817597E-10_JPRB, 0.48846701E-10_JPRB, 0.46787095E-10_JPRB, &
  & 0.44657902E-10_JPRB, 0.42472595E-10_JPRB, 0.40214575E-10_JPRB, 0.37867688E-10_JPRB, 0.35411500E-10_JPRB, 0.32881926E-10_JPRB, &
  & 0.30344564E-10_JPRB, 0.27870511E-10_JPRB, 0.25537239E-10_JPRB, 0.23395792E-10_JPRB, 0.21483787E-10_JPRB, 0.19820288E-10_JPRB, &
  & 0.18432511E-10_JPRB, 0.17157577E-10_JPRB, 0.16053461E-10_JPRB, 0.14007562E-10_JPRB /)

RGHG5(:,23,11) = (/ &
  & 0.10370312E-10_JPRB, 0.11731372E-10_JPRB, 0.12734252E-10_JPRB, 0.13780505E-10_JPRB, 0.14997918E-10_JPRB, 0.16442342E-10_JPRB, &
  & 0.18158450E-10_JPRB, 0.20164904E-10_JPRB, 0.22478195E-10_JPRB, 0.25072954E-10_JPRB, 0.27946465E-10_JPRB, 0.31087372E-10_JPRB, &
  & 0.34478431E-10_JPRB, 0.38100328E-10_JPRB, 0.41923305E-10_JPRB, 0.45933007E-10_JPRB, 0.50091407E-10_JPRB, 0.54366005E-10_JPRB, &
  & 0.58620914E-10_JPRB, 0.62698083E-10_JPRB, 0.66402703E-10_JPRB, 0.69596322E-10_JPRB, 0.72087551E-10_JPRB, 0.73803415E-10_JPRB, &
  & 0.74800582E-10_JPRB, 0.75289955E-10_JPRB, 0.75634922E-10_JPRB, 0.76007249E-10_JPRB, 0.76414444E-10_JPRB, 0.76771145E-10_JPRB, &
  & 0.76964234E-10_JPRB, 0.76837377E-10_JPRB, 0.76351037E-10_JPRB, 0.75706032E-10_JPRB, 0.75174478E-10_JPRB, 0.74901356E-10_JPRB, &
  & 0.75151080E-10_JPRB, 0.75790950E-10_JPRB, 0.76629536E-10_JPRB, 0.77399122E-10_JPRB, 0.77711906E-10_JPRB, 0.77463147E-10_JPRB, &
  & 0.76474875E-10_JPRB, 0.74862692E-10_JPRB, 0.72756669E-10_JPRB, 0.70285423E-10_JPRB, 0.67612568E-10_JPRB, 0.64853449E-10_JPRB, &
  & 0.62043135E-10_JPRB, 0.59241646E-10_JPRB, 0.56388144E-10_JPRB, 0.53451008E-10_JPRB, 0.50445564E-10_JPRB, 0.47397163E-10_JPRB, &
  & 0.44341267E-10_JPRB, 0.41329721E-10_JPRB, 0.38427483E-10_JPRB, 0.35686870E-10_JPRB, 0.33162317E-10_JPRB, 0.30887723E-10_JPRB, &
  & 0.28852639E-10_JPRB, 0.27100685E-10_JPRB, 0.25114152E-10_JPRB, 0.22302143E-10_JPRB /)

RGHG5(:,24,11) = (/ &
  & 0.14539028E-10_JPRB, 0.16402402E-10_JPRB, 0.17743633E-10_JPRB, 0.19142778E-10_JPRB, 0.20735001E-10_JPRB, 0.22598205E-10_JPRB, &
  & 0.24768720E-10_JPRB, 0.27274006E-10_JPRB, 0.30124774E-10_JPRB, 0.33303395E-10_JPRB, 0.36810211E-10_JPRB, 0.40622155E-10_JPRB, &
  & 0.44724897E-10_JPRB, 0.49105785E-10_JPRB, 0.53722735E-10_JPRB, 0.58546099E-10_JPRB, 0.63493849E-10_JPRB, 0.68538598E-10_JPRB, &
  & 0.73629540E-10_JPRB, 0.78652120E-10_JPRB, 0.83442447E-10_JPRB, 0.87872244E-10_JPRB, 0.91720555E-10_JPRB, 0.94814531E-10_JPRB, &
  & 0.97117404E-10_JPRB, 0.98769729E-10_JPRB, 0.10002145E-09_JPRB, 0.10100056E-09_JPRB, 0.10173265E-09_JPRB, 0.10216940E-09_JPRB, &
  & 0.10222146E-09_JPRB, 0.10178822E-09_JPRB, 0.10091645E-09_JPRB, 0.99799169E-10_JPRB, 0.98751507E-10_JPRB, 0.98052517E-10_JPRB, &
  & 0.97853288E-10_JPRB, 0.98127714E-10_JPRB, 0.98685893E-10_JPRB, 0.99220035E-10_JPRB, 0.99382780E-10_JPRB, 0.98931724E-10_JPRB, &
  & 0.97747810E-10_JPRB, 0.95794581E-10_JPRB, 0.93212361E-10_JPRB, 0.90213406E-10_JPRB, 0.86938977E-10_JPRB, 0.83578866E-10_JPRB, &
  & 0.80148693E-10_JPRB, 0.76741662E-10_JPRB, 0.73315652E-10_JPRB, 0.69902889E-10_JPRB, 0.66486851E-10_JPRB, 0.63071881E-10_JPRB, &
  & 0.59665127E-10_JPRB, 0.56287950E-10_JPRB, 0.52971995E-10_JPRB, 0.49761972E-10_JPRB, 0.46708429E-10_JPRB, 0.43861241E-10_JPRB, &
  & 0.41264700E-10_JPRB, 0.38767354E-10_JPRB, 0.36280222E-10_JPRB, 0.31964289E-10_JPRB /)

RGHG5(:,25,11) = (/ &
  & 0.19336558E-10_JPRB, 0.21712927E-10_JPRB, 0.23427156E-10_JPRB, 0.25179319E-10_JPRB, 0.27153533E-10_JPRB, 0.29425039E-10_JPRB, &
  & 0.32035895E-10_JPRB, 0.35005884E-10_JPRB, 0.38350430E-10_JPRB, 0.42058565E-10_JPRB, 0.46131474E-10_JPRB, 0.50543902E-10_JPRB, &
  & 0.55269393E-10_JPRB, 0.60287601E-10_JPRB, 0.65563860E-10_JPRB, 0.71062677E-10_JPRB, 0.76725425E-10_JPRB, 0.82521594E-10_JPRB, &
  & 0.88371220E-10_JPRB, 0.94232511E-10_JPRB, 0.10001212E-09_JPRB, 0.10557769E-09_JPRB, 0.11067113E-09_JPRB, 0.11506633E-09_JPRB, &
  & 0.11862952E-09_JPRB, 0.12137211E-09_JPRB, 0.12346273E-09_JPRB, 0.12497108E-09_JPRB, 0.12593213E-09_JPRB, 0.12635644E-09_JPRB, &
  & 0.12621620E-09_JPRB, 0.12552138E-09_JPRB, 0.12438495E-09_JPRB, 0.12303888E-09_JPRB, 0.12169978E-09_JPRB, 0.12069995E-09_JPRB, &
  & 0.12017902E-09_JPRB, 0.12009760E-09_JPRB, 0.12031676E-09_JPRB, 0.12051164E-09_JPRB, 0.12039345E-09_JPRB, 0.11966103E-09_JPRB, &
  & 0.11821050E-09_JPRB, 0.11595933E-09_JPRB, 0.11298650E-09_JPRB, 0.10950321E-09_JPRB, 0.10569146E-09_JPRB, 0.10176606E-09_JPRB, &
  & 0.97825782E-10_JPRB, 0.93951416E-10_JPRB, 0.90097499E-10_JPRB, 0.86306122E-10_JPRB, 0.82585487E-10_JPRB, 0.78933200E-10_JPRB, &
  & 0.75327564E-10_JPRB, 0.71744687E-10_JPRB, 0.68190939E-10_JPRB, 0.64685084E-10_JPRB, 0.61278968E-10_JPRB, 0.58021275E-10_JPRB, &
  & 0.54929495E-10_JPRB, 0.51954680E-10_JPRB, 0.48668479E-10_JPRB, 0.43193421E-10_JPRB /)

RGHG5(:,26,11) = (/ &
  & 0.24767220E-10_JPRB, 0.27703452E-10_JPRB, 0.29791156E-10_JPRB, 0.31905888E-10_JPRB, 0.34250582E-10_JPRB, 0.36915759E-10_JPRB, &
  & 0.39937290E-10_JPRB, 0.43334648E-10_JPRB, 0.47119839E-10_JPRB, 0.51295829E-10_JPRB, 0.55857499E-10_JPRB, 0.60787320E-10_JPRB, &
  & 0.66049388E-10_JPRB, 0.71605277E-10_JPRB, 0.77418662E-10_JPRB, 0.83454604E-10_JPRB, 0.89647151E-10_JPRB, 0.96003427E-10_JPRB, &
  & 0.10248975E-09_JPRB, 0.10905028E-09_JPRB, 0.11561327E-09_JPRB, 0.12206311E-09_JPRB, 0.12812108E-09_JPRB, 0.13353123E-09_JPRB, &
  & 0.13807629E-09_JPRB, 0.14169871E-09_JPRB, 0.14447823E-09_JPRB, 0.14643525E-09_JPRB, 0.14760808E-09_JPRB, 0.14805512E-09_JPRB, &
  & 0.14782436E-09_JPRB, 0.14702774E-09_JPRB, 0.14581938E-09_JPRB, 0.14446530E-09_JPRB, 0.14308792E-09_JPRB, 0.14194215E-09_JPRB, &
  & 0.14121376E-09_JPRB, 0.14085152E-09_JPRB, 0.14068467E-09_JPRB, 0.14051869E-09_JPRB, 0.14004259E-09_JPRB, 0.13898539E-09_JPRB, &
  & 0.13722977E-09_JPRB, 0.13468694E-09_JPRB, 0.13139577E-09_JPRB, 0.12753068E-09_JPRB, 0.12329802E-09_JPRB, 0.11891664E-09_JPRB, &
  & 0.11453795E-09_JPRB, 0.11021251E-09_JPRB, 0.10601022E-09_JPRB, 0.10197192E-09_JPRB, 0.98081487E-10_JPRB, 0.94311635E-10_JPRB, &
  & 0.90615140E-10_JPRB, 0.86953486E-10_JPRB, 0.83310241E-10_JPRB, 0.79696791E-10_JPRB, 0.76146964E-10_JPRB, 0.72692158E-10_JPRB, &
  & 0.69355056E-10_JPRB, 0.66058423E-10_JPRB, 0.62284775E-10_JPRB, 0.55978916E-10_JPRB /)

RGHG5(:,27,11) = (/ &
  & 0.30936989E-10_JPRB, 0.34497502E-10_JPRB, 0.36975686E-10_JPRB, 0.39437686E-10_JPRB, 0.42137915E-10_JPRB, 0.45162693E-10_JPRB, &
  & 0.48552481E-10_JPRB, 0.52321557E-10_JPRB, 0.56484338E-10_JPRB, 0.61038112E-10_JPRB, 0.65997166E-10_JPRB, 0.71338539E-10_JPRB, &
  & 0.77000108E-10_JPRB, 0.83011098E-10_JPRB, 0.89255200E-10_JPRB, 0.95750227E-10_JPRB, 0.10236986E-09_JPRB, 0.10915236E-09_JPRB, &
  & 0.11606480E-09_JPRB, 0.12306994E-09_JPRB, 0.13010718E-09_JPRB, 0.13710445E-09_JPRB, 0.14375372E-09_JPRB, 0.14981756E-09_JPRB, &
  & 0.15502942E-09_JPRB, 0.15926525E-09_JPRB, 0.16256355E-09_JPRB, 0.16489921E-09_JPRB, 0.16630854E-09_JPRB, 0.16686777E-09_JPRB, &
  & 0.16668804E-09_JPRB, 0.16595246E-09_JPRB, 0.16484200E-09_JPRB, 0.16361855E-09_JPRB, 0.16239077E-09_JPRB, 0.16126696E-09_JPRB, &
  & 0.16042614E-09_JPRB, 0.15983936E-09_JPRB, 0.15932175E-09_JPRB, 0.15876704E-09_JPRB, 0.15791060E-09_JPRB, 0.15652550E-09_JPRB, &
  & 0.15447592E-09_JPRB, 0.15166726E-09_JPRB, 0.14811455E-09_JPRB, 0.14396682E-09_JPRB, 0.13944237E-09_JPRB, 0.13476693E-09_JPRB, &
  & 0.13007016E-09_JPRB, 0.12543250E-09_JPRB, 0.12095518E-09_JPRB, 0.11670122E-09_JPRB, 0.11267987E-09_JPRB, 0.10884160E-09_JPRB, &
  & 0.10512528E-09_JPRB, 0.10147603E-09_JPRB, 0.97866007E-10_JPRB, 0.94288848E-10_JPRB, 0.90763085E-10_JPRB, 0.87328013E-10_JPRB, &
  & 0.83984993E-10_JPRB, 0.80587439E-10_JPRB, 0.76842310E-10_JPRB, 0.69945043E-10_JPRB /)

RGHG5(:,28,11) = (/ &
  & 0.38007767E-10_JPRB, 0.42257663E-10_JPRB, 0.45117743E-10_JPRB, 0.47927384E-10_JPRB, 0.50936477E-10_JPRB, 0.54276000E-10_JPRB, &
  & 0.57974431E-10_JPRB, 0.62046437E-10_JPRB, 0.66494130E-10_JPRB, 0.71339025E-10_JPRB, 0.76574080E-10_JPRB, 0.82191871E-10_JPRB, &
  & 0.88153568E-10_JPRB, 0.94462639E-10_JPRB, 0.10099618E-09_JPRB, 0.10779942E-09_JPRB, 0.11472433E-09_JPRB, 0.12180745E-09_JPRB, &
  & 0.12899026E-09_JPRB, 0.13623419E-09_JPRB, 0.14350604E-09_JPRB, 0.15073255E-09_JPRB, 0.15765816E-09_JPRB, 0.16403108E-09_JPRB, &
  & 0.16960129E-09_JPRB, 0.17420292E-09_JPRB, 0.17785533E-09_JPRB, 0.18050059E-09_JPRB, 0.18216482E-09_JPRB, 0.18291380E-09_JPRB, &
  & 0.18290169E-09_JPRB, 0.18234750E-09_JPRB, 0.18144847E-09_JPRB, 0.18044695E-09_JPRB, 0.17943608E-09_JPRB, 0.17843901E-09_JPRB, &
  & 0.17756044E-09_JPRB, 0.17680800E-09_JPRB, 0.17600725E-09_JPRB, 0.17509519E-09_JPRB, 0.17387441E-09_JPRB, 0.17216453E-09_JPRB, &
  & 0.16983934E-09_JPRB, 0.16680154E-09_JPRB, 0.16303478E-09_JPRB, 0.15866537E-09_JPRB, 0.15388781E-09_JPRB, 0.14889455E-09_JPRB, &
  & 0.14388042E-09_JPRB, 0.13905048E-09_JPRB, 0.13451151E-09_JPRB, 0.13024559E-09_JPRB, 0.12621738E-09_JPRB, 0.12239490E-09_JPRB, &
  & 0.11871917E-09_JPRB, 0.11513465E-09_JPRB, 0.11161286E-09_JPRB, 0.10814155E-09_JPRB, 0.10474206E-09_JPRB, 0.10142932E-09_JPRB, &
  & 0.98215366E-10_JPRB, 0.95011318E-10_JPRB, 0.91229725E-10_JPRB, 0.84743546E-10_JPRB /)

RGHG5(:,29,11) = (/ &
  & 0.46106292E-10_JPRB, 0.51051673E-10_JPRB, 0.54335772E-10_JPRB, 0.57427826E-10_JPRB, 0.60718652E-10_JPRB, 0.64301162E-10_JPRB, &
  & 0.68237173E-10_JPRB, 0.72523591E-10_JPRB, 0.77175544E-10_JPRB, 0.82189699E-10_JPRB, 0.87599428E-10_JPRB, 0.93366745E-10_JPRB, &
  & 0.99520940E-10_JPRB, 0.10596286E-09_JPRB, 0.11269287E-09_JPRB, 0.11967882E-09_JPRB, 0.12679396E-09_JPRB, 0.13401781E-09_JPRB, &
  & 0.14130970E-09_JPRB, 0.14862514E-09_JPRB, 0.15593020E-09_JPRB, 0.16315597E-09_JPRB, 0.17009898E-09_JPRB, 0.17651322E-09_JPRB, &
  & 0.18219237E-09_JPRB, 0.18694390E-09_JPRB, 0.19078263E-09_JPRB, 0.19365060E-09_JPRB, 0.19554770E-09_JPRB, 0.19652713E-09_JPRB, &
  & 0.19674698E-09_JPRB, 0.19643753E-09_JPRB, 0.19579874E-09_JPRB, 0.19505196E-09_JPRB, 0.19426397E-09_JPRB, 0.19342336E-09_JPRB, &
  & 0.19255991E-09_JPRB, 0.19169341E-09_JPRB, 0.19067871E-09_JPRB, 0.18947116E-09_JPRB, 0.18793386E-09_JPRB, 0.18593506E-09_JPRB, &
  & 0.18336624E-09_JPRB, 0.18014021E-09_JPRB, 0.17622916E-09_JPRB, 0.17172644E-09_JPRB, 0.16679619E-09_JPRB, 0.16168523E-09_JPRB, &
  & 0.15664033E-09_JPRB, 0.15178174E-09_JPRB, 0.14713183E-09_JPRB, 0.14275631E-09_JPRB, 0.13870785E-09_JPRB, 0.13491643E-09_JPRB, &
  & 0.13130101E-09_JPRB, 0.12780327E-09_JPRB, 0.12438653E-09_JPRB, 0.12104266E-09_JPRB, 0.11778421E-09_JPRB, 0.11465352E-09_JPRB, &
  & 0.11162549E-09_JPRB, 0.10857751E-09_JPRB, 0.10516409E-09_JPRB, 0.98964642E-10_JPRB /)

RGHG5(:,30,11) = (/ &
  & 0.55218243E-10_JPRB, 0.60959973E-10_JPRB, 0.64551302E-10_JPRB, 0.67938988E-10_JPRB, 0.71418108E-10_JPRB, 0.75188689E-10_JPRB, &
  & 0.79275558E-10_JPRB, 0.83696106E-10_JPRB, 0.88438881E-10_JPRB, 0.93537733E-10_JPRB, 0.98996179E-10_JPRB, 0.10481802E-09_JPRB, &
  & 0.11102923E-09_JPRB, 0.11751236E-09_JPRB, 0.12432376E-09_JPRB, 0.13140562E-09_JPRB, 0.13860822E-09_JPRB, 0.14587867E-09_JPRB, &
  & 0.15315402E-09_JPRB, 0.16039933E-09_JPRB, 0.16756430E-09_JPRB, 0.17460380E-09_JPRB, 0.18136459E-09_JPRB, 0.18763896E-09_JPRB, &
  & 0.19320838E-09_JPRB, 0.19793797E-09_JPRB, 0.20181645E-09_JPRB, 0.20481157E-09_JPRB, 0.20689386E-09_JPRB, 0.20809851E-09_JPRB, &
  & 0.20856586E-09_JPRB, 0.20851210E-09_JPRB, 0.20813451E-09_JPRB, 0.20762957E-09_JPRB, 0.20703732E-09_JPRB, 0.20633618E-09_JPRB, &
  & 0.20551055E-09_JPRB, 0.20456882E-09_JPRB, 0.20339751E-09_JPRB, 0.20196632E-09_JPRB, 0.20018108E-09_JPRB, 0.19795098E-09_JPRB, &
  & 0.19518440E-09_JPRB, 0.19181820E-09_JPRB, 0.18781068E-09_JPRB, 0.18322897E-09_JPRB, 0.17824281E-09_JPRB, 0.17307533E-09_JPRB, &
  & 0.16796241E-09_JPRB, 0.16301153E-09_JPRB, 0.15838227E-09_JPRB, 0.15414310E-09_JPRB, 0.15021251E-09_JPRB, 0.14650978E-09_JPRB, &
  & 0.14296841E-09_JPRB, 0.13954189E-09_JPRB, 0.13620216E-09_JPRB, 0.13294461E-09_JPRB, 0.12980932E-09_JPRB, 0.12680823E-09_JPRB, &
  & 0.12395206E-09_JPRB, 0.12111157E-09_JPRB, 0.11786587E-09_JPRB, 0.11221071E-09_JPRB /)

RGHG5(:,31,11) = (/ &
  & 0.65425665E-10_JPRB, 0.71756462E-10_JPRB, 0.75726397E-10_JPRB, 0.79270465E-10_JPRB, 0.82917388E-10_JPRB, 0.86786148E-10_JPRB, &
  & 0.90955965E-10_JPRB, 0.95413191E-10_JPRB, 0.10017107E-09_JPRB, 0.10523694E-09_JPRB, 0.11065117E-09_JPRB, 0.11642319E-09_JPRB, &
  & 0.12256576E-09_JPRB, 0.12900704E-09_JPRB, 0.13580044E-09_JPRB, 0.14286804E-09_JPRB, 0.15007404E-09_JPRB, 0.15731860E-09_JPRB, &
  & 0.16450991E-09_JPRB, 0.17157184E-09_JPRB, 0.17848904E-09_JPRB, 0.18523455E-09_JPRB, 0.19169406E-09_JPRB, 0.19768338E-09_JPRB, &
  & 0.20301820E-09_JPRB, 0.20757558E-09_JPRB, 0.21138552E-09_JPRB, 0.21440093E-09_JPRB, 0.21659737E-09_JPRB, 0.21798613E-09_JPRB, &
  & 0.21867697E-09_JPRB, 0.21885761E-09_JPRB, 0.21871108E-09_JPRB, 0.21840618E-09_JPRB, 0.21796709E-09_JPRB, 0.21736508E-09_JPRB, &
  & 0.21657864E-09_JPRB, 0.21558517E-09_JPRB, 0.21430943E-09_JPRB, 0.21272115E-09_JPRB, 0.21075844E-09_JPRB, 0.20835929E-09_JPRB, &
  & 0.20544849E-09_JPRB, 0.20198369E-09_JPRB, 0.19792311E-09_JPRB, 0.19332734E-09_JPRB, 0.18835676E-09_JPRB, 0.18325268E-09_JPRB, &
  & 0.17819274E-09_JPRB, 0.17337898E-09_JPRB, 0.16889452E-09_JPRB, 0.16472988E-09_JPRB, 0.16085322E-09_JPRB, 0.15720479E-09_JPRB, &
  & 0.15372276E-09_JPRB, 0.15035070E-09_JPRB, 0.14705845E-09_JPRB, 0.14386789E-09_JPRB, 0.14080551E-09_JPRB, 0.13791608E-09_JPRB, &
  & 0.13517096E-09_JPRB, 0.13248662E-09_JPRB, 0.12946312E-09_JPRB, 0.12418074E-09_JPRB /)

RGHG5(:,32,11) = (/ &
  & 0.76445794E-10_JPRB, 0.83406802E-10_JPRB, 0.87531295E-10_JPRB, 0.91258681E-10_JPRB, 0.94973383E-10_JPRB, 0.98895836E-10_JPRB, &
  & 0.10306894E-09_JPRB, 0.10749976E-09_JPRB, 0.11217439E-09_JPRB, 0.11713032E-09_JPRB, 0.12239273E-09_JPRB, 0.12801146E-09_JPRB, &
  & 0.13397859E-09_JPRB, 0.14030088E-09_JPRB, 0.14697979E-09_JPRB, 0.15395119E-09_JPRB, 0.16107149E-09_JPRB, 0.16821144E-09_JPRB, &
  & 0.17524886E-09_JPRB, 0.18210425E-09_JPRB, 0.18873980E-09_JPRB, 0.19513925E-09_JPRB, 0.20122981E-09_JPRB, 0.20685607E-09_JPRB, &
  & 0.21186580E-09_JPRB, 0.21618168E-09_JPRB, 0.21981469E-09_JPRB, 0.22276238E-09_JPRB, 0.22499065E-09_JPRB, 0.22650121E-09_JPRB, &
  & 0.22736821E-09_JPRB, 0.22773819E-09_JPRB, 0.22777527E-09_JPRB, 0.22761863E-09_JPRB, 0.22728246E-09_JPRB, 0.22674726E-09_JPRB, &
  & 0.22598859E-09_JPRB, 0.22496206E-09_JPRB, 0.22362412E-09_JPRB, 0.22193442E-09_JPRB, 0.21985777E-09_JPRB, 0.21734216E-09_JPRB, &
  & 0.21433740E-09_JPRB, 0.21081376E-09_JPRB, 0.20674205E-09_JPRB, 0.20219233E-09_JPRB, 0.19734321E-09_JPRB, 0.19236353E-09_JPRB, &
  & 0.18745935E-09_JPRB, 0.18278005E-09_JPRB, 0.17840973E-09_JPRB, 0.17436542E-09_JPRB, 0.17060034E-09_JPRB, 0.16705792E-09_JPRB, &
  & 0.16365255E-09_JPRB, 0.16032900E-09_JPRB, 0.15708367E-09_JPRB, 0.15392321E-09_JPRB, 0.15091242E-09_JPRB, 0.14808739E-09_JPRB, &
  & 0.14546998E-09_JPRB, 0.14289320E-09_JPRB, 0.14003440E-09_JPRB, 0.13506532E-09_JPRB /)

RGHG5(:,33,11) = (/ &
  & 0.88238361E-10_JPRB, 0.95486292E-10_JPRB, 0.99812124E-10_JPRB, 0.10358132E-09_JPRB, 0.10733067E-09_JPRB, 0.11124737E-09_JPRB, &
  & 0.11537724E-09_JPRB, 0.11971046E-09_JPRB, 0.12424713E-09_JPRB, 0.12900155E-09_JPRB, 0.13402943E-09_JPRB, 0.13938738E-09_JPRB, &
  & 0.14509664E-09_JPRB, 0.15120120E-09_JPRB, 0.15769787E-09_JPRB, 0.16450215E-09_JPRB, 0.17149633E-09_JPRB, 0.17850998E-09_JPRB, &
  & 0.18536885E-09_JPRB, 0.19198346E-09_JPRB, 0.19831299E-09_JPRB, 0.20436144E-09_JPRB, 0.21004792E-09_JPRB, 0.21527183E-09_JPRB, &
  & 0.21990856E-09_JPRB, 0.22390648E-09_JPRB, 0.22731121E-09_JPRB, 0.23011851E-09_JPRB, 0.23231225E-09_JPRB, 0.23387914E-09_JPRB, &
  & 0.23486149E-09_JPRB, 0.23536958E-09_JPRB, 0.23553748E-09_JPRB, 0.23547786E-09_JPRB, 0.23520538E-09_JPRB, 0.23471675E-09_JPRB, &
  & 0.23397279E-09_JPRB, 0.23293623E-09_JPRB, 0.23156720E-09_JPRB, 0.22982413E-09_JPRB, 0.22768437E-09_JPRB, 0.22509844E-09_JPRB, &
  & 0.22204108E-09_JPRB, 0.21849123E-09_JPRB, 0.21445340E-09_JPRB, 0.21001727E-09_JPRB, 0.20529954E-09_JPRB, 0.20049380E-09_JPRB, &
  & 0.19576797E-09_JPRB, 0.19128635E-09_JPRB, 0.18710754E-09_JPRB, 0.18323364E-09_JPRB, 0.17962830E-09_JPRB, 0.17619625E-09_JPRB, &
  & 0.17286499E-09_JPRB, 0.16959419E-09_JPRB, 0.16636847E-09_JPRB, 0.16323572E-09_JPRB, 0.16026074E-09_JPRB, 0.15751575E-09_JPRB, &
  & 0.15495150E-09_JPRB, 0.15249561E-09_JPRB, 0.14975018E-09_JPRB, 0.14507426E-09_JPRB /)

RGHG5(:,34,11) = (/ &
  & 0.10047610E-09_JPRB, 0.10787204E-09_JPRB, 0.11219166E-09_JPRB, 0.11595318E-09_JPRB, 0.11968782E-09_JPRB, 0.12354402E-09_JPRB, &
  & 0.12758720E-09_JPRB, 0.13178819E-09_JPRB, 0.13612518E-09_JPRB, 0.14062651E-09_JPRB, 0.14534088E-09_JPRB, 0.15035093E-09_JPRB, &
  & 0.15572484E-09_JPRB, 0.16152675E-09_JPRB, 0.16776605E-09_JPRB, 0.17435486E-09_JPRB, 0.18116712E-09_JPRB, 0.18801011E-09_JPRB, &
  & 0.19469867E-09_JPRB, 0.20111068E-09_JPRB, 0.20718970E-09_JPRB, 0.21291489E-09_JPRB, 0.21822812E-09_JPRB, 0.22304733E-09_JPRB, &
  & 0.22729679E-09_JPRB, 0.23095127E-09_JPRB, 0.23407001E-09_JPRB, 0.23667646E-09_JPRB, 0.23876220E-09_JPRB, 0.24031047E-09_JPRB, &
  & 0.24134300E-09_JPRB, 0.24193128E-09_JPRB, 0.24217767E-09_JPRB, 0.24217212E-09_JPRB, 0.24194402E-09_JPRB, 0.24148575E-09_JPRB, &
  & 0.24075966E-09_JPRB, 0.23973984E-09_JPRB, 0.23836705E-09_JPRB, 0.23661520E-09_JPRB, 0.23444974E-09_JPRB, 0.23183148E-09_JPRB, &
  & 0.22874908E-09_JPRB, 0.22520122E-09_JPRB, 0.22122269E-09_JPRB, 0.21690066E-09_JPRB, 0.21237187E-09_JPRB, 0.20778786E-09_JPRB, &
  & 0.20333718E-09_JPRB, 0.19909999E-09_JPRB, 0.19513900E-09_JPRB, 0.19144586E-09_JPRB, 0.18795762E-09_JPRB, 0.18461499E-09_JPRB, &
  & 0.18135085E-09_JPRB, 0.17812761E-09_JPRB, 0.17495545E-09_JPRB, 0.17186674E-09_JPRB, 0.16895028E-09_JPRB, 0.16624388E-09_JPRB, &
  & 0.16377921E-09_JPRB, 0.16140021E-09_JPRB, 0.15881607E-09_JPRB, 0.15435837E-09_JPRB /)

RGHG5(:,35,11) = (/ &
  & 0.11300388E-09_JPRB, 0.12024801E-09_JPRB, 0.12443689E-09_JPRB, 0.12811679E-09_JPRB, 0.13173362E-09_JPRB, 0.13551051E-09_JPRB, &
  & 0.13942714E-09_JPRB, 0.14345755E-09_JPRB, 0.14757136E-09_JPRB, 0.15176925E-09_JPRB, 0.15612329E-09_JPRB, 0.16072424E-09_JPRB, &
  & 0.16569641E-09_JPRB, 0.17112668E-09_JPRB, 0.17705182E-09_JPRB, 0.18338722E-09_JPRB, 0.19000140E-09_JPRB, 0.19667427E-09_JPRB, &
  & 0.20321797E-09_JPRB, 0.20946715E-09_JPRB, 0.21534774E-09_JPRB, 0.22080800E-09_JPRB, 0.22579208E-09_JPRB, 0.23023861E-09_JPRB, &
  & 0.23410218E-09_JPRB, 0.23739377E-09_JPRB, 0.24018759E-09_JPRB, 0.24253227E-09_JPRB, 0.24443619E-09_JPRB, 0.24589239E-09_JPRB, &
  & 0.24690269E-09_JPRB, 0.24751357E-09_JPRB, 0.24779395E-09_JPRB, 0.24782085E-09_JPRB, 0.24762939E-09_JPRB, 0.24719904E-09_JPRB, &
  & 0.24651789E-09_JPRB, 0.24554314E-09_JPRB, 0.24421148E-09_JPRB, 0.24249594E-09_JPRB, 0.24034555E-09_JPRB, 0.23772634E-09_JPRB, &
  & 0.23464389E-09_JPRB, 0.23111159E-09_JPRB, 0.22720363E-09_JPRB, 0.22302485E-09_JPRB, 0.21868836E-09_JPRB, 0.21436171E-09_JPRB, &
  & 0.21014246E-09_JPRB, 0.20614052E-09_JPRB, 0.20238811E-09_JPRB, 0.19885998E-09_JPRB, 0.19552185E-09_JPRB, 0.19230084E-09_JPRB, &
  & 0.18914098E-09_JPRB, 0.18600731E-09_JPRB, 0.18290096E-09_JPRB, 0.17986970E-09_JPRB, 0.17699407E-09_JPRB, 0.17436619E-09_JPRB, &
  & 0.17196390E-09_JPRB, 0.16970397E-09_JPRB, 0.16720168E-09_JPRB, 0.16301288E-09_JPRB /)

RGHG5(:,36,11) = (/ &
  & 0.12569243E-09_JPRB, 0.13243406E-09_JPRB, 0.13638578E-09_JPRB, 0.13983495E-09_JPRB, 0.14332038E-09_JPRB, 0.14693333E-09_JPRB, &
  & 0.15069876E-09_JPRB, 0.15453872E-09_JPRB, 0.15839570E-09_JPRB, 0.16227358E-09_JPRB, 0.16623034E-09_JPRB, 0.17038998E-09_JPRB, &
  & 0.17491107E-09_JPRB, 0.17992663E-09_JPRB, 0.18549286E-09_JPRB, 0.19156071E-09_JPRB, 0.19797003E-09_JPRB, 0.20451035E-09_JPRB, &
  & 0.21092918E-09_JPRB, 0.21706183E-09_JPRB, 0.22278365E-09_JPRB, 0.22803227E-09_JPRB, 0.23272398E-09_JPRB, 0.23682128E-09_JPRB, &
  & 0.24030167E-09_JPRB, 0.24320626E-09_JPRB, 0.24563487E-09_JPRB, 0.24765368E-09_JPRB, 0.24930102E-09_JPRB, 0.25057725E-09_JPRB, &
  & 0.25149252E-09_JPRB, 0.25206875E-09_JPRB, 0.25234825E-09_JPRB, 0.25240232E-09_JPRB, 0.25224328E-09_JPRB, 0.25186339E-09_JPRB, &
  & 0.25126246E-09_JPRB, 0.25037353E-09_JPRB, 0.24915259E-09_JPRB, 0.24754312E-09_JPRB, 0.24547317E-09_JPRB, 0.24291652E-09_JPRB, &
  & 0.23986046E-09_JPRB, 0.23637398E-09_JPRB, 0.23254643E-09_JPRB, 0.22850273E-09_JPRB, 0.22437568E-09_JPRB, 0.22027366E-09_JPRB, &
  & 0.21630819E-09_JPRB, 0.21253410E-09_JPRB, 0.20897890E-09_JPRB, 0.20562348E-09_JPRB, 0.20241334E-09_JPRB, 0.19931981E-09_JPRB, &
  & 0.19626578E-09_JPRB, 0.19322925E-09_JPRB, 0.19020779E-09_JPRB, 0.18725349E-09_JPRB, 0.18445789E-09_JPRB, 0.18189700E-09_JPRB, &
  & 0.17958508E-09_JPRB, 0.17738322E-09_JPRB, 0.17503533E-09_JPRB, 0.17103403E-09_JPRB /)

RGHG5(:,37,11) = (/ &
  & 0.13838514E-09_JPRB, 0.14442031E-09_JPRB, 0.14793144E-09_JPRB, 0.15110554E-09_JPRB, 0.15433382E-09_JPRB, 0.15776336E-09_JPRB, &
  & 0.16133224E-09_JPRB, 0.16494861E-09_JPRB, 0.16853537E-09_JPRB, 0.17206897E-09_JPRB, 0.17561878E-09_JPRB, 0.17932193E-09_JPRB, &
  & 0.18336668E-09_JPRB, 0.18793936E-09_JPRB, 0.19311798E-09_JPRB, 0.19890567E-09_JPRB, 0.20510123E-09_JPRB, 0.21150907E-09_JPRB, &
  & 0.21785806E-09_JPRB, 0.22392217E-09_JPRB, 0.22953089E-09_JPRB, 0.23457877E-09_JPRB, 0.23897656E-09_JPRB, 0.24267693E-09_JPRB, &
  & 0.24570629E-09_JPRB, 0.24814989E-09_JPRB, 0.25013622E-09_JPRB, 0.25176097E-09_JPRB, 0.25307842E-09_JPRB, 0.25411367E-09_JPRB, &
  & 0.25487343E-09_JPRB, 0.25537036E-09_JPRB, 0.25563007E-09_JPRB, 0.25570313E-09_JPRB, 0.25558222E-09_JPRB, 0.25528310E-09_JPRB, &
  & 0.25478475E-09_JPRB, 0.25404437E-09_JPRB, 0.25301106E-09_JPRB, 0.25160532E-09_JPRB, 0.24975169E-09_JPRB, 0.24736324E-09_JPRB, &
  & 0.24445129E-09_JPRB, 0.24106120E-09_JPRB, 0.23734109E-09_JPRB, 0.23343563E-09_JPRB, 0.22948837E-09_JPRB, 0.22560470E-09_JPRB, &
  & 0.22184883E-09_JPRB, 0.21827552E-09_JPRB, 0.21489853E-09_JPRB, 0.21169917E-09_JPRB, 0.20863357E-09_JPRB, 0.20566740E-09_JPRB, &
  & 0.20274858E-09_JPRB, 0.19984507E-09_JPRB, 0.19695259E-09_JPRB, 0.19411449E-09_JPRB, 0.19141011E-09_JPRB, 0.18892085E-09_JPRB, &
  & 0.18666461E-09_JPRB, 0.18456597E-09_JPRB, 0.18227429E-09_JPRB, 0.17847498E-09_JPRB /)

RGHG5(:,38,11) = (/ &
  & 0.15091886E-09_JPRB, 0.15600238E-09_JPRB, 0.15905395E-09_JPRB, 0.16185447E-09_JPRB, 0.16480037E-09_JPRB, 0.16798309E-09_JPRB, &
  & 0.17131815E-09_JPRB, 0.17468121E-09_JPRB, 0.17796750E-09_JPRB, 0.18114894E-09_JPRB, 0.18429178E-09_JPRB, 0.18754588E-09_JPRB, &
  & 0.19111530E-09_JPRB, 0.19522728E-09_JPRB, 0.20001700E-09_JPRB, 0.20548699E-09_JPRB, 0.21151200E-09_JPRB, 0.21777859E-09_JPRB, &
  & 0.22402991E-09_JPRB, 0.23000393E-09_JPRB, 0.23545713E-09_JPRB, 0.24021130E-09_JPRB, 0.24416963E-09_JPRB, 0.24734773E-09_JPRB, &
  & 0.24983268E-09_JPRB, 0.25176924E-09_JPRB, 0.25330765E-09_JPRB, 0.25455160E-09_JPRB, 0.25556487E-09_JPRB, 0.25637126E-09_JPRB, &
  & 0.25698302E-09_JPRB, 0.25739630E-09_JPRB, 0.25763117E-09_JPRB, 0.25771027E-09_JPRB, 0.25762714E-09_JPRB, 0.25740243E-09_JPRB, &
  & 0.25701100E-09_JPRB, 0.25643021E-09_JPRB, 0.25560995E-09_JPRB, 0.25447797E-09_JPRB, 0.25293106E-09_JPRB, 0.25087907E-09_JPRB, &
  & 0.24825811E-09_JPRB, 0.24511926E-09_JPRB, 0.24157321E-09_JPRB, 0.23783919E-09_JPRB, 0.23407712E-09_JPRB, 0.23038331E-09_JPRB, &
  & 0.22681901E-09_JPRB, 0.22341762E-09_JPRB, 0.22018787E-09_JPRB, 0.21712765E-09_JPRB, 0.21420000E-09_JPRB, 0.21138542E-09_JPRB, &
  & 0.20864169E-09_JPRB, 0.20592095E-09_JPRB, 0.20320745E-09_JPRB, 0.20051732E-09_JPRB, 0.19792158E-09_JPRB, 0.19550847E-09_JPRB, &
  & 0.19332119E-09_JPRB, 0.19125293E-09_JPRB, 0.18905781E-09_JPRB, 0.18536872E-09_JPRB /)

RGHG5(:,39,11) = (/ &
  & 0.16290116E-09_JPRB, 0.16708462E-09_JPRB, 0.16962554E-09_JPRB, 0.17204986E-09_JPRB, 0.17469326E-09_JPRB, 0.17759791E-09_JPRB, &
  & 0.18066987E-09_JPRB, 0.18374144E-09_JPRB, 0.18670543E-09_JPRB, 0.18953063E-09_JPRB, 0.19228645E-09_JPRB, 0.19511202E-09_JPRB, &
  & 0.19824234E-09_JPRB, 0.20188697E-09_JPRB, 0.20628324E-09_JPRB, 0.21143307E-09_JPRB, 0.21720760E-09_JPRB, 0.22332873E-09_JPRB, &
  & 0.22943171E-09_JPRB, 0.23518537E-09_JPRB, 0.24030189E-09_JPRB, 0.24457347E-09_JPRB, 0.24796384E-09_JPRB, 0.25057015E-09_JPRB, &
  & 0.25255098E-09_JPRB, 0.25406435E-09_JPRB, 0.25525909E-09_JPRB, 0.25622870E-09_JPRB, 0.25702721E-09_JPRB, 0.25767896E-09_JPRB, &
  & 0.25818589E-09_JPRB, 0.25853947E-09_JPRB, 0.25875513E-09_JPRB, 0.25883062E-09_JPRB, 0.25877656E-09_JPRB, 0.25860042E-09_JPRB, &
  & 0.25829031E-09_JPRB, 0.25783417E-09_JPRB, 0.25718733E-09_JPRB, 0.25629243E-09_JPRB, 0.25505803E-09_JPRB, 0.25337951E-09_JPRB, &
  & 0.25118088E-09_JPRB, 0.24840588E-09_JPRB, 0.24517555E-09_JPRB, 0.24169147E-09_JPRB, 0.23813290E-09_JPRB, 0.23463187E-09_JPRB, &
  & 0.23124197E-09_JPRB, 0.22798972E-09_JPRB, 0.22489420E-09_JPRB, 0.22196554E-09_JPRB, 0.21918681E-09_JPRB, 0.21654711E-09_JPRB, &
  & 0.21399957E-09_JPRB, 0.21150323E-09_JPRB, 0.20900058E-09_JPRB, 0.20649769E-09_JPRB, 0.20404364E-09_JPRB, 0.20172211E-09_JPRB, &
  & 0.19957856E-09_JPRB, 0.19756738E-09_JPRB, 0.19538908E-09_JPRB, 0.19179912E-09_JPRB /)

RGHG5(:,40,11) = (/ &
  & 0.17401884E-09_JPRB, 0.17738640E-09_JPRB, 0.17950902E-09_JPRB, 0.18160518E-09_JPRB, 0.18394744E-09_JPRB, 0.18659986E-09_JPRB, &
  & 0.18938355E-09_JPRB, 0.19214522E-09_JPRB, 0.19477883E-09_JPRB, 0.19725876E-09_JPRB, 0.19964733E-09_JPRB, 0.20210600E-09_JPRB, &
  & 0.20480964E-09_JPRB, 0.20804983E-09_JPRB, 0.21201220E-09_JPRB, 0.21684730E-09_JPRB, 0.22236570E-09_JPRB, 0.22825186E-09_JPRB, &
  & 0.23408761E-09_JPRB, 0.23948055E-09_JPRB, 0.24407862E-09_JPRB, 0.24775912E-09_JPRB, 0.25056579E-09_JPRB, 0.25267660E-09_JPRB, &
  & 0.25426078E-09_JPRB, 0.25547611E-09_JPRB, 0.25644159E-09_JPRB, 0.25723479E-09_JPRB, 0.25790159E-09_JPRB, 0.25845523E-09_JPRB, &
  & 0.25889646E-09_JPRB, 0.25921168E-09_JPRB, 0.25941280E-09_JPRB, 0.25948324E-09_JPRB, 0.25944663E-09_JPRB, 0.25929903E-09_JPRB, &
  & 0.25904476E-09_JPRB, 0.25867022E-09_JPRB, 0.25814670E-09_JPRB, 0.25742675E-09_JPRB, 0.25643759E-09_JPRB, 0.25509156E-09_JPRB, &
  & 0.25327959E-09_JPRB, 0.25093638E-09_JPRB, 0.24811481E-09_JPRB, 0.24494942E-09_JPRB, 0.24166197E-09_JPRB, 0.23837132E-09_JPRB, &
  & 0.23515631E-09_JPRB, 0.23205211E-09_JPRB, 0.22908198E-09_JPRB, 0.22627523E-09_JPRB, 0.22365666E-09_JPRB, 0.22119370E-09_JPRB, &
  & 0.21887749E-09_JPRB, 0.21661208E-09_JPRB, 0.21435734E-09_JPRB, 0.21206517E-09_JPRB, 0.20977910E-09_JPRB, 0.20756336E-09_JPRB, &
  & 0.20549680E-09_JPRB, 0.20351296E-09_JPRB, 0.20139042E-09_JPRB, 0.19783890E-09_JPRB /)

RGHG5(:,41,11) = (/ &
  & 0.18405043E-09_JPRB, 0.18682335E-09_JPRB, 0.18861000E-09_JPRB, 0.19042920E-09_JPRB, 0.19255852E-09_JPRB, 0.19496146E-09_JPRB, &
  & 0.19748767E-09_JPRB, 0.19994333E-09_JPRB, 0.20225288E-09_JPRB, 0.20440599E-09_JPRB, 0.20647878E-09_JPRB, 0.20858111E-09_JPRB, &
  & 0.21094625E-09_JPRB, 0.21376612E-09_JPRB, 0.21735366E-09_JPRB, 0.22179635E-09_JPRB, 0.22701377E-09_JPRB, 0.23260344E-09_JPRB, &
  & 0.23809757E-09_JPRB, 0.24298716E-09_JPRB, 0.24700622E-09_JPRB, 0.25008448E-09_JPRB, 0.25238259E-09_JPRB, 0.25409483E-09_JPRB, &
  & 0.25539296E-09_JPRB, 0.25639948E-09_JPRB, 0.25721344E-09_JPRB, 0.25789437E-09_JPRB, 0.25847424E-09_JPRB, 0.25896693E-09_JPRB, &
  & 0.25936264E-09_JPRB, 0.25965441E-09_JPRB, 0.25984109E-09_JPRB, 0.25990890E-09_JPRB, 0.25988009E-09_JPRB, 0.25975100E-09_JPRB, &
  & 0.25953276E-09_JPRB, 0.25921415E-09_JPRB, 0.25877592E-09_JPRB, 0.25818245E-09_JPRB, 0.25737706E-09_JPRB, 0.25628238E-09_JPRB, &
  & 0.25480093E-09_JPRB, 0.25286614E-09_JPRB, 0.25045566E-09_JPRB, 0.24768304E-09_JPRB, 0.24468122E-09_JPRB, 0.24163907E-09_JPRB, &
  & 0.23862018E-09_JPRB, 0.23566624E-09_JPRB, 0.23282215E-09_JPRB, 0.23015539E-09_JPRB, 0.22767582E-09_JPRB, 0.22542535E-09_JPRB, &
  & 0.22331580E-09_JPRB, 0.22130670E-09_JPRB, 0.21928903E-09_JPRB, 0.21722570E-09_JPRB, 0.21512693E-09_JPRB, 0.21306377E-09_JPRB, &
  & 0.21108867E-09_JPRB, 0.20918565E-09_JPRB, 0.20709738E-09_JPRB, 0.20362619E-09_JPRB /)

RGHG5(:,42,11) = (/ &
  & 0.19302795E-09_JPRB, 0.19537015E-09_JPRB, 0.19691637E-09_JPRB, 0.19855856E-09_JPRB, 0.20050062E-09_JPRB, 0.20274633E-09_JPRB, &
  & 0.20503246E-09_JPRB, 0.20721412E-09_JPRB, 0.20922841E-09_JPRB, 0.21109231E-09_JPRB, 0.21286468E-09_JPRB, 0.21468380E-09_JPRB, &
  & 0.21669613E-09_JPRB, 0.21917834E-09_JPRB, 0.22235014E-09_JPRB, 0.22643359E-09_JPRB, 0.23128559E-09_JPRB, 0.23651300E-09_JPRB, &
  & 0.24153129E-09_JPRB, 0.24588379E-09_JPRB, 0.24928740E-09_JPRB, 0.25183142E-09_JPRB, 0.25370597E-09_JPRB, 0.25511548E-09_JPRB, &
  & 0.25619842E-09_JPRB, 0.25705846E-09_JPRB, 0.25776742E-09_JPRB, 0.25836974E-09_JPRB, 0.25889363E-09_JPRB, 0.25934224E-09_JPRB, &
  & 0.25970537E-09_JPRB, 0.25998126E-09_JPRB, 0.26015343E-09_JPRB, 0.26022001E-09_JPRB, 0.26019287E-09_JPRB, 0.26007690E-09_JPRB, &
  & 0.25988250E-09_JPRB, 0.25960356E-09_JPRB, 0.25922814E-09_JPRB, 0.25872801E-09_JPRB, 0.25806146E-09_JPRB, 0.25716079E-09_JPRB, &
  & 0.25595384E-09_JPRB, 0.25436275E-09_JPRB, 0.25235147E-09_JPRB, 0.24993452E-09_JPRB, 0.24728108E-09_JPRB, 0.24449576E-09_JPRB, &
  & 0.24169061E-09_JPRB, 0.23891342E-09_JPRB, 0.23621857E-09_JPRB, 0.23367339E-09_JPRB, 0.23137456E-09_JPRB, 0.22930099E-09_JPRB, &
  & 0.22742690E-09_JPRB, 0.22563942E-09_JPRB, 0.22386130E-09_JPRB, 0.22202332E-09_JPRB, 0.22013354E-09_JPRB, 0.21824781E-09_JPRB, &
  & 0.21642742E-09_JPRB, 0.21463191E-09_JPRB, 0.21265789E-09_JPRB, 0.20931146E-09_JPRB /)

RGHG5(:,43,11) = (/ &
  & 0.20108526E-09_JPRB, 0.20313451E-09_JPRB, 0.20452198E-09_JPRB, 0.20602081E-09_JPRB, 0.20787813E-09_JPRB, 0.20998198E-09_JPRB, &
  & 0.21209706E-09_JPRB, 0.21404162E-09_JPRB, 0.21580553E-09_JPRB, 0.21741024E-09_JPRB, 0.21893183E-09_JPRB, 0.22046898E-09_JPRB, &
  & 0.22219977E-09_JPRB, 0.22431518E-09_JPRB, 0.22711887E-09_JPRB, 0.23078602E-09_JPRB, 0.23525626E-09_JPRB, 0.24004601E-09_JPRB, &
  & 0.24456071E-09_JPRB, 0.24828686E-09_JPRB, 0.25112137E-09_JPRB, 0.25319352E-09_JPRB, 0.25472455E-09_JPRB, 0.25589339E-09_JPRB, &
  & 0.25681438E-09_JPRB, 0.25756342E-09_JPRB, 0.25819566E-09_JPRB, 0.25874433E-09_JPRB, 0.25922564E-09_JPRB, 0.25964439E-09_JPRB, &
  & 0.25998109E-09_JPRB, 0.26024427E-09_JPRB, 0.26040306E-09_JPRB, 0.26046768E-09_JPRB, 0.26043986E-09_JPRB, 0.26033264E-09_JPRB, &
  & 0.26015470E-09_JPRB, 0.25990576E-09_JPRB, 0.25957730E-09_JPRB, 0.25915037E-09_JPRB, 0.25859043E-09_JPRB, 0.25784719E-09_JPRB, &
  & 0.25686073E-09_JPRB, 0.25556335E-09_JPRB, 0.25388830E-09_JPRB, 0.25185296E-09_JPRB, 0.24950203E-09_JPRB, 0.24700245E-09_JPRB, &
  & 0.24443639E-09_JPRB, 0.24185848E-09_JPRB, 0.23932850E-09_JPRB, 0.23695687E-09_JPRB, 0.23481964E-09_JPRB, 0.23295005E-09_JPRB, &
  & 0.23127875E-09_JPRB, 0.22970865E-09_JPRB, 0.22814639E-09_JPRB, 0.22652784E-09_JPRB, 0.22485459E-09_JPRB, 0.22318329E-09_JPRB, &
  & 0.22155741E-09_JPRB, 0.21994592E-09_JPRB, 0.21813842E-09_JPRB, 0.21504377E-09_JPRB /)

RGHG5(:,44,11) = (/ &
  & 0.20840341E-09_JPRB, 0.21025595E-09_JPRB, 0.21151898E-09_JPRB, 0.21294483E-09_JPRB, 0.21471720E-09_JPRB, 0.21676202E-09_JPRB, &
  & 0.21872788E-09_JPRB, 0.22049471E-09_JPRB, 0.22204627E-09_JPRB, 0.22343441E-09_JPRB, 0.22472636E-09_JPRB, 0.22602768E-09_JPRB, &
  & 0.22746974E-09_JPRB, 0.22927411E-09_JPRB, 0.23168789E-09_JPRB, 0.23495908E-09_JPRB, 0.23900137E-09_JPRB, 0.24330740E-09_JPRB, &
  & 0.24721028E-09_JPRB, 0.25032409E-09_JPRB, 0.25261679E-09_JPRB, 0.25428559E-09_JPRB, 0.25553790E-09_JPRB, 0.25651462E-09_JPRB, &
  & 0.25730745E-09_JPRB, 0.25797087E-09_JPRB, 0.25854630E-09_JPRB, 0.25905431E-09_JPRB, 0.25950664E-09_JPRB, 0.25990121E-09_JPRB, &
  & 0.26021740E-09_JPRB, 0.26046815E-09_JPRB, 0.26061575E-09_JPRB, 0.26067640E-09_JPRB, 0.26064723E-09_JPRB, 0.26054534E-09_JPRB, &
  & 0.26037936E-09_JPRB, 0.26015295E-09_JPRB, 0.25986149E-09_JPRB, 0.25949187E-09_JPRB, 0.25901789E-09_JPRB, 0.25840161E-09_JPRB, &
  & 0.25759625E-09_JPRB, 0.25654184E-09_JPRB, 0.25518418E-09_JPRB, 0.25346591E-09_JPRB, 0.25145092E-09_JPRB, 0.24922159E-09_JPRB, &
  & 0.24690389E-09_JPRB, 0.24455379E-09_JPRB, 0.24222990E-09_JPRB, 0.24004232E-09_JPRB, 0.23809862E-09_JPRB, 0.23643112E-09_JPRB, &
  & 0.23495200E-09_JPRB, 0.23358232E-09_JPRB, 0.23221773E-09_JPRB, 0.23080704E-09_JPRB, 0.22935648E-09_JPRB, 0.22791721E-09_JPRB, &
  & 0.22652541E-09_JPRB, 0.22514075E-09_JPRB, 0.22357406E-09_JPRB, 0.22085986E-09_JPRB /)

RGHG5(:,45,11) = (/ &
  & 0.21514511E-09_JPRB, 0.21684293E-09_JPRB, 0.21803101E-09_JPRB, 0.21937087E-09_JPRB, 0.22112417E-09_JPRB, 0.22309582E-09_JPRB, &
  & 0.22497584E-09_JPRB, 0.22659104E-09_JPRB, 0.22797204E-09_JPRB, 0.22917487E-09_JPRB, 0.23026761E-09_JPRB, 0.23134696E-09_JPRB, &
  & 0.23254799E-09_JPRB, 0.23404159E-09_JPRB, 0.23609256E-09_JPRB, 0.23896007E-09_JPRB, 0.24253599E-09_JPRB, 0.24628727E-09_JPRB, &
  & 0.24953711E-09_JPRB, 0.25203095E-09_JPRB, 0.25384167E-09_JPRB, 0.25517785E-09_JPRB, 0.25619940E-09_JPRB, 0.25702473E-09_JPRB, &
  & 0.25771421E-09_JPRB, 0.25831096E-09_JPRB, 0.25884178E-09_JPRB, 0.25932170E-09_JPRB, 0.25975166E-09_JPRB, 0.26012756E-09_JPRB, &
  & 0.26042721E-09_JPRB, 0.26066507E-09_JPRB, 0.26080305E-09_JPRB, 0.26085847E-09_JPRB, 0.26082755E-09_JPRB, 0.26072847E-09_JPRB, &
  & 0.26057115E-09_JPRB, 0.26036204E-09_JPRB, 0.26009955E-09_JPRB, 0.25977562E-09_JPRB, 0.25937102E-09_JPRB, 0.25885710E-09_JPRB, &
  & 0.25820038E-09_JPRB, 0.25735558E-09_JPRB, 0.25626143E-09_JPRB, 0.25487185E-09_JPRB, 0.25315514E-09_JPRB, 0.25121563E-09_JPRB, &
  & 0.24915173E-09_JPRB, 0.24703359E-09_JPRB, 0.24493407E-09_JPRB, 0.24297173E-09_JPRB, 0.24124513E-09_JPRB, 0.23977220E-09_JPRB, &
  & 0.23849306E-09_JPRB, 0.23730085E-09_JPRB, 0.23612501E-09_JPRB, 0.23491406E-09_JPRB, 0.23368216E-09_JPRB, 0.23248081E-09_JPRB, &
  & 0.23133588E-09_JPRB, 0.23019769E-09_JPRB, 0.22890845E-09_JPRB, 0.22664731E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART21',1,ZHOOK_HANDLE)
END SUBROUTINE PART21




SUBROUTINE PART22
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART22',0,ZHOOK_HANDLE)



RGHG5(:,46,11) = (/ &
  & 0.22141974E-09_JPRB, 0.22301619E-09_JPRB, 0.22411219E-09_JPRB, 0.22541999E-09_JPRB, 0.22709028E-09_JPRB, 0.22905497E-09_JPRB, &
  & 0.23083460E-09_JPRB, 0.23233272E-09_JPRB, 0.23356855E-09_JPRB, 0.23459976E-09_JPRB, 0.23551913E-09_JPRB, 0.23640986E-09_JPRB, &
  & 0.23738533E-09_JPRB, 0.23861196E-09_JPRB, 0.24034183E-09_JPRB, 0.24276797E-09_JPRB, 0.24586841E-09_JPRB, 0.24895319E-09_JPRB, &
  & 0.25153352E-09_JPRB, 0.25344510E-09_JPRB, 0.25484898E-09_JPRB, 0.25590535E-09_JPRB, 0.25674848E-09_JPRB, 0.25744940E-09_JPRB, &
  & 0.25805799E-09_JPRB, 0.25860122E-09_JPRB, 0.25909866E-09_JPRB, 0.25955674E-09_JPRB, 0.25997118E-09_JPRB, 0.26033148E-09_JPRB, &
  & 0.26061703E-09_JPRB, 0.26084171E-09_JPRB, 0.26097138E-09_JPRB, 0.26102046E-09_JPRB, 0.26098751E-09_JPRB, 0.26088950E-09_JPRB, &
  & 0.26073846E-09_JPRB, 0.26054217E-09_JPRB, 0.26030278E-09_JPRB, 0.26001520E-09_JPRB, 0.25966582E-09_JPRB, 0.25923549E-09_JPRB, &
  & 0.25869915E-09_JPRB, 0.25802616E-09_JPRB, 0.25717212E-09_JPRB, 0.25606739E-09_JPRB, 0.25467681E-09_JPRB, 0.25302677E-09_JPRB, &
  & 0.25121188E-09_JPRB, 0.24933441E-09_JPRB, 0.24747998E-09_JPRB, 0.24574476E-09_JPRB, 0.24425728E-09_JPRB, 0.24299071E-09_JPRB, &
  & 0.24189672E-09_JPRB, 0.24088126E-09_JPRB, 0.23988028E-09_JPRB, 0.23885915E-09_JPRB, 0.23783747E-09_JPRB, 0.23686286E-09_JPRB, &
  & 0.23594582E-09_JPRB, 0.23504623E-09_JPRB, 0.23401761E-09_JPRB, 0.23222031E-09_JPRB /)

RGHG5(:,47,11) = (/ &
  & 0.22732614E-09_JPRB, 0.22880625E-09_JPRB, 0.22986202E-09_JPRB, 0.23106540E-09_JPRB, 0.23273541E-09_JPRB, 0.23459754E-09_JPRB, &
  & 0.23632230E-09_JPRB, 0.23770438E-09_JPRB, 0.23879052E-09_JPRB, 0.23967955E-09_JPRB, 0.24043606E-09_JPRB, 0.24115987E-09_JPRB, &
  & 0.24194813E-09_JPRB, 0.24294672E-09_JPRB, 0.24434427E-09_JPRB, 0.24638985E-09_JPRB, 0.24886676E-09_JPRB, 0.25128549E-09_JPRB, &
  & 0.25318692E-09_JPRB, 0.25460736E-09_JPRB, 0.25566732E-09_JPRB, 0.25650765E-09_JPRB, 0.25720348E-09_JPRB, 0.25780972E-09_JPRB, &
  & 0.25835323E-09_JPRB, 0.25885480E-09_JPRB, 0.25932645E-09_JPRB, 0.25976868E-09_JPRB, 0.26017077E-09_JPRB, 0.26051744E-09_JPRB, &
  & 0.26079064E-09_JPRB, 0.26100216E-09_JPRB, 0.26112393E-09_JPRB, 0.26116642E-09_JPRB, 0.26113092E-09_JPRB, 0.26103297E-09_JPRB, &
  & 0.26088601E-09_JPRB, 0.26069991E-09_JPRB, 0.26047814E-09_JPRB, 0.26021940E-09_JPRB, 0.25991440E-09_JPRB, 0.25954958E-09_JPRB, &
  & 0.25911101E-09_JPRB, 0.25857846E-09_JPRB, 0.25792052E-09_JPRB, 0.25708358E-09_JPRB, 0.25600705E-09_JPRB, 0.25466526E-09_JPRB, &
  & 0.25313432E-09_JPRB, 0.25150040E-09_JPRB, 0.24987312E-09_JPRB, 0.24840352E-09_JPRB, 0.24712177E-09_JPRB, 0.24607269E-09_JPRB, &
  & 0.24514768E-09_JPRB, 0.24429883E-09_JPRB, 0.24346014E-09_JPRB, 0.24261190E-09_JPRB, 0.24178068E-09_JPRB, 0.24100091E-09_JPRB, &
  & 0.24028537E-09_JPRB, 0.23958091E-09_JPRB, 0.23878555E-09_JPRB, 0.23737656E-09_JPRB /)

RGHG5(:,48,11) = (/ &
  & 0.23288221E-09_JPRB, 0.23429014E-09_JPRB, 0.23525687E-09_JPRB, 0.23643015E-09_JPRB, 0.23796717E-09_JPRB, 0.23981730E-09_JPRB, &
  & 0.24143226E-09_JPRB, 0.24269697E-09_JPRB, 0.24365693E-09_JPRB, 0.24439123E-09_JPRB, 0.24501010E-09_JPRB, 0.24558425E-09_JPRB, &
  & 0.24620644E-09_JPRB, 0.24698957E-09_JPRB, 0.24809579E-09_JPRB, 0.24965122E-09_JPRB, 0.25150565E-09_JPRB, 0.25320226E-09_JPRB, &
  & 0.25453514E-09_JPRB, 0.25553931E-09_JPRB, 0.25633684E-09_JPRB, 0.25700206E-09_JPRB, 0.25758684E-09_JPRB, 0.25811739E-09_JPRB, &
  & 0.25861172E-09_JPRB, 0.25908198E-09_JPRB, 0.25953401E-09_JPRB, 0.25996291E-09_JPRB, 0.26035490E-09_JPRB, 0.26068872E-09_JPRB, &
  & 0.26095007E-09_JPRB, 0.26114877E-09_JPRB, 0.26126309E-09_JPRB, 0.26129895E-09_JPRB, 0.26126040E-09_JPRB, 0.26116170E-09_JPRB, &
  & 0.26101774E-09_JPRB, 0.26083885E-09_JPRB, 0.26063146E-09_JPRB, 0.26039526E-09_JPRB, 0.26012498E-09_JPRB, 0.25981256E-09_JPRB, &
  & 0.25944988E-09_JPRB, 0.25902844E-09_JPRB, 0.25852984E-09_JPRB, 0.25791930E-09_JPRB, 0.25713309E-09_JPRB, 0.25613259E-09_JPRB, &
  & 0.25490901E-09_JPRB, 0.25355057E-09_JPRB, 0.25218910E-09_JPRB, 0.25092872E-09_JPRB, 0.24988953E-09_JPRB, 0.24900376E-09_JPRB, &
  & 0.24824812E-09_JPRB, 0.24753818E-09_JPRB, 0.24684182E-09_JPRB, 0.24614322E-09_JPRB, 0.24546737E-09_JPRB, 0.24485128E-09_JPRB, &
  & 0.24428851E-09_JPRB, 0.24374475E-09_JPRB, 0.24312186E-09_JPRB, 0.24202701E-09_JPRB /)

RGHG5(:,49,11) = (/ &
  & 0.23811481E-09_JPRB, 0.23942728E-09_JPRB, 0.24034588E-09_JPRB, 0.24141991E-09_JPRB, 0.24291433E-09_JPRB, 0.24463914E-09_JPRB, &
  & 0.24618374E-09_JPRB, 0.24732233E-09_JPRB, 0.24813027E-09_JPRB, 0.24873026E-09_JPRB, 0.24920524E-09_JPRB, 0.24963859E-09_JPRB, &
  & 0.25009866E-09_JPRB, 0.25065344E-09_JPRB, 0.25143485E-09_JPRB, 0.25245186E-09_JPRB, 0.25365277E-09_JPRB, 0.25472846E-09_JPRB, &
  & 0.25559238E-09_JPRB, 0.25628955E-09_JPRB, 0.25688074E-09_JPRB, 0.25741426E-09_JPRB, 0.25791105E-09_JPRB, 0.25838476E-09_JPRB, &
  & 0.25884289E-09_JPRB, 0.25928970E-09_JPRB, 0.25972749E-09_JPRB, 0.26014518E-09_JPRB, 0.26052555E-09_JPRB, 0.26084737E-09_JPRB, &
  & 0.26109714E-09_JPRB, 0.26128366E-09_JPRB, 0.26139041E-09_JPRB, 0.26142016E-09_JPRB, 0.26137806E-09_JPRB, 0.26127839E-09_JPRB, &
  & 0.26113606E-09_JPRB, 0.26096328E-09_JPRB, 0.26076666E-09_JPRB, 0.26054850E-09_JPRB, 0.26030542E-09_JPRB, 0.26003311E-09_JPRB, &
  & 0.25972963E-09_JPRB, 0.25939287E-09_JPRB, 0.25901831E-09_JPRB, 0.25858393E-09_JPRB, 0.25805269E-09_JPRB, 0.25736571E-09_JPRB, &
  & 0.25649693E-09_JPRB, 0.25547378E-09_JPRB, 0.25439004E-09_JPRB, 0.25339963E-09_JPRB, 0.25253946E-09_JPRB, 0.25183239E-09_JPRB, &
  & 0.25120492E-09_JPRB, 0.25061714E-09_JPRB, 0.25003596E-09_JPRB, 0.24945504E-09_JPRB, 0.24890445E-09_JPRB, 0.24840810E-09_JPRB, &
  & 0.24796468E-09_JPRB, 0.24753474E-09_JPRB, 0.24704311E-09_JPRB, 0.24617086E-09_JPRB /)

RGHG5(:,50,11) = (/ &
  & 0.24296321E-09_JPRB, 0.24418920E-09_JPRB, 0.24503430E-09_JPRB, 0.24603847E-09_JPRB, 0.24742372E-09_JPRB, 0.24906963E-09_JPRB, &
  & 0.25045174E-09_JPRB, 0.25142680E-09_JPRB, 0.25206734E-09_JPRB, 0.25250149E-09_JPRB, 0.25282951E-09_JPRB, 0.25311042E-09_JPRB, &
  & 0.25338609E-09_JPRB, 0.25371930E-09_JPRB, 0.25411234E-09_JPRB, 0.25467400E-09_JPRB, 0.25528618E-09_JPRB, 0.25589400E-09_JPRB, &
  & 0.25641964E-09_JPRB, 0.25688765E-09_JPRB, 0.25732955E-09_JPRB, 0.25776040E-09_JPRB, 0.25818975E-09_JPRB, 0.25862135E-09_JPRB, &
  & 0.25905320E-09_JPRB, 0.25948496E-09_JPRB, 0.25991076E-09_JPRB, 0.26031727E-09_JPRB, 0.26068558E-09_JPRB, 0.26099398E-09_JPRB, &
  & 0.26123334E-09_JPRB, 0.26140839E-09_JPRB, 0.26150751E-09_JPRB, 0.26153144E-09_JPRB, 0.26148589E-09_JPRB, 0.26138469E-09_JPRB, &
  & 0.26124383E-09_JPRB, 0.26107555E-09_JPRB, 0.26088798E-09_JPRB, 0.26068378E-09_JPRB, 0.26046149E-09_JPRB, 0.26022007E-09_JPRB, &
  & 0.25996086E-09_JPRB, 0.25968880E-09_JPRB, 0.25940611E-09_JPRB, 0.25910729E-09_JPRB, 0.25876581E-09_JPRB, 0.25834462E-09_JPRB, &
  & 0.25780655E-09_JPRB, 0.25714514E-09_JPRB, 0.25641891E-09_JPRB, 0.25570304E-09_JPRB, 0.25507996E-09_JPRB, 0.25452901E-09_JPRB, &
  & 0.25403041E-09_JPRB, 0.25355273E-09_JPRB, 0.25306851E-09_JPRB, 0.25258493E-09_JPRB, 0.25213059E-09_JPRB, 0.25172670E-09_JPRB, &
  & 0.25136931E-09_JPRB, 0.25102012E-09_JPRB, 0.25062036E-09_JPRB, 0.24989139E-09_JPRB /)

RGHG5(:,51,11) = (/ &
  & 0.24733721E-09_JPRB, 0.24844088E-09_JPRB, 0.24921437E-09_JPRB, 0.25013006E-09_JPRB, 0.25138019E-09_JPRB, 0.25281074E-09_JPRB, &
  & 0.25396635E-09_JPRB, 0.25467342E-09_JPRB, 0.25509250E-09_JPRB, 0.25535324E-09_JPRB, 0.25552976E-09_JPRB, 0.25566582E-09_JPRB, &
  & 0.25578983E-09_JPRB, 0.25590741E-09_JPRB, 0.25606270E-09_JPRB, 0.25624025E-09_JPRB, 0.25649463E-09_JPRB, 0.25677319E-09_JPRB, &
  & 0.25706776E-09_JPRB, 0.25737690E-09_JPRB, 0.25770455E-09_JPRB, 0.25805735E-09_JPRB, 0.25843605E-09_JPRB, 0.25883426E-09_JPRB, &
  & 0.25924943E-09_JPRB, 0.25966931E-09_JPRB, 0.26008642E-09_JPRB, 0.26048011E-09_JPRB, 0.26083466E-09_JPRB, 0.26113048E-09_JPRB, &
  & 0.26135932E-09_JPRB, 0.26152430E-09_JPRB, 0.26161587E-09_JPRB, 0.26163416E-09_JPRB, 0.26158534E-09_JPRB, 0.26148286E-09_JPRB, &
  & 0.26134284E-09_JPRB, 0.26117869E-09_JPRB, 0.26099825E-09_JPRB, 0.26080504E-09_JPRB, 0.26059882E-09_JPRB, 0.26038002E-09_JPRB, &
  & 0.26015473E-09_JPRB, 0.25993080E-09_JPRB, 0.25971883E-09_JPRB, 0.25951696E-09_JPRB, 0.25931365E-09_JPRB, 0.25908195E-09_JPRB, &
  & 0.25879610E-09_JPRB, 0.25844768E-09_JPRB, 0.25805377E-09_JPRB, 0.25765745E-09_JPRB, 0.25727481E-09_JPRB, 0.25692198E-09_JPRB, &
  & 0.25657937E-09_JPRB, 0.25622288E-09_JPRB, 0.25585309E-09_JPRB, 0.25547287E-09_JPRB, 0.25511027E-09_JPRB, 0.25479058E-09_JPRB, &
  & 0.25450328E-09_JPRB, 0.25422298E-09_JPRB, 0.25388269E-09_JPRB, 0.25326719E-09_JPRB /)

RGHG5(:,52,11) = (/ &
  & 0.25104596E-09_JPRB, 0.25203190E-09_JPRB, 0.25268856E-09_JPRB, 0.25346392E-09_JPRB, 0.25450275E-09_JPRB, 0.25562244E-09_JPRB, &
  & 0.25638522E-09_JPRB, 0.25681138E-09_JPRB, 0.25703190E-09_JPRB, 0.25715313E-09_JPRB, 0.25722613E-09_JPRB, 0.25727229E-09_JPRB, &
  & 0.25730099E-09_JPRB, 0.25731872E-09_JPRB, 0.25732372E-09_JPRB, 0.25733077E-09_JPRB, 0.25736241E-09_JPRB, 0.25744787E-09_JPRB, &
  & 0.25758889E-09_JPRB, 0.25778246E-09_JPRB, 0.25802774E-09_JPRB, 0.25832078E-09_JPRB, 0.25865657E-09_JPRB, 0.25903388E-09_JPRB, &
  & 0.25943320E-09_JPRB, 0.25984678E-09_JPRB, 0.26025129E-09_JPRB, 0.26063429E-09_JPRB, 0.26097341E-09_JPRB, 0.26125713E-09_JPRB, &
  & 0.26147651E-09_JPRB, 0.26163213E-09_JPRB, 0.26171659E-09_JPRB, 0.26172958E-09_JPRB, 0.26167757E-09_JPRB, 0.26157407E-09_JPRB, &
  & 0.26143498E-09_JPRB, 0.26127425E-09_JPRB, 0.26110009E-09_JPRB, 0.26091562E-09_JPRB, 0.26072111E-09_JPRB, 0.26052016E-09_JPRB, &
  & 0.26031943E-09_JPRB, 0.26013444E-09_JPRB, 0.25997449E-09_JPRB, 0.25984589E-09_JPRB, 0.25973546E-09_JPRB, 0.25962624E-09_JPRB, &
  & 0.25950025E-09_JPRB, 0.25935121E-09_JPRB, 0.25918365E-09_JPRB, 0.25900748E-09_JPRB, 0.25883440E-09_JPRB, 0.25865615E-09_JPRB, &
  & 0.25846553E-09_JPRB, 0.25825803E-09_JPRB, 0.25801900E-09_JPRB, 0.25776362E-09_JPRB, 0.25751651E-09_JPRB, 0.25729388E-09_JPRB, &
  & 0.25709343E-09_JPRB, 0.25688682E-09_JPRB, 0.25663560E-09_JPRB, 0.25612681E-09_JPRB /)

RGHG5(:,53,11) = (/ &
  & 0.25399355E-09_JPRB, 0.25476729E-09_JPRB, 0.25531141E-09_JPRB, 0.25590585E-09_JPRB, 0.25666230E-09_JPRB, 0.25738608E-09_JPRB, &
  & 0.25784139E-09_JPRB, 0.25805241E-09_JPRB, 0.25815233E-09_JPRB, 0.25820068E-09_JPRB, 0.25822286E-09_JPRB, 0.25822916E-09_JPRB, &
  & 0.25822164E-09_JPRB, 0.25819930E-09_JPRB, 0.25815028E-09_JPRB, 0.25808444E-09_JPRB, 0.25800889E-09_JPRB, 0.25797864E-09_JPRB, &
  & 0.25801791E-09_JPRB, 0.25813163E-09_JPRB, 0.25831298E-09_JPRB, 0.25855848E-09_JPRB, 0.25886615E-09_JPRB, 0.25921945E-09_JPRB, &
  & 0.25961175E-09_JPRB, 0.26001198E-09_JPRB, 0.26040956E-09_JPRB, 0.26077604E-09_JPRB, 0.26110372E-09_JPRB, 0.26137506E-09_JPRB, &
  & 0.26158550E-09_JPRB, 0.26173252E-09_JPRB, 0.26181024E-09_JPRB, 0.26181859E-09_JPRB, 0.26176381E-09_JPRB, 0.26165947E-09_JPRB, &
  & 0.26152144E-09_JPRB, 0.26136404E-09_JPRB, 0.26119495E-09_JPRB, 0.26101754E-09_JPRB, 0.26083302E-09_JPRB, 0.26064420E-09_JPRB, &
  & 0.26046532E-09_JPRB, 0.26030850E-09_JPRB, 0.26019259E-09_JPRB, 0.26011471E-09_JPRB, 0.26006675E-09_JPRB, 0.26003005E-09_JPRB, &
  & 0.25999097E-09_JPRB, 0.25994229E-09_JPRB, 0.25988439E-09_JPRB, 0.25981986E-09_JPRB, 0.25974856E-09_JPRB, 0.25967062E-09_JPRB, &
  & 0.25958147E-09_JPRB, 0.25947047E-09_JPRB, 0.25934113E-09_JPRB, 0.25919505E-09_JPRB, 0.25905170E-09_JPRB, 0.25892369E-09_JPRB, &
  & 0.25880836E-09_JPRB, 0.25869190E-09_JPRB, 0.25854202E-09_JPRB, 0.25822550E-09_JPRB /)

RGHG5(:,54,11) = (/ &
  & 0.25609498E-09_JPRB, 0.25671648E-09_JPRB, 0.25709251E-09_JPRB, 0.25751096E-09_JPRB, 0.25800526E-09_JPRB, 0.25844810E-09_JPRB, &
  & 0.25867866E-09_JPRB, 0.25878044E-09_JPRB, 0.25882113E-09_JPRB, 0.25883654E-09_JPRB, 0.25883867E-09_JPRB, 0.25883129E-09_JPRB, &
  & 0.25881403E-09_JPRB, 0.25877966E-09_JPRB, 0.25872601E-09_JPRB, 0.25862615E-09_JPRB, 0.25851085E-09_JPRB, 0.25841176E-09_JPRB, &
  & 0.25838345E-09_JPRB, 0.25843772E-09_JPRB, 0.25857286E-09_JPRB, 0.25878349E-09_JPRB, 0.25906177E-09_JPRB, 0.25940328E-09_JPRB, &
  & 0.25977789E-09_JPRB, 0.26017252E-09_JPRB, 0.26055347E-09_JPRB, 0.26091124E-09_JPRB, 0.26122443E-09_JPRB, 0.26148597E-09_JPRB, &
  & 0.26168712E-09_JPRB, 0.26182592E-09_JPRB, 0.26189750E-09_JPRB, 0.26190183E-09_JPRB, 0.26184482E-09_JPRB, 0.26174024E-09_JPRB, &
  & 0.26160354E-09_JPRB, 0.26144889E-09_JPRB, 0.26128458E-09_JPRB, 0.26111324E-09_JPRB, 0.26093583E-09_JPRB, 0.26075986E-09_JPRB, &
  & 0.26059541E-09_JPRB, 0.26046656E-09_JPRB, 0.26038111E-09_JPRB, 0.26034208E-09_JPRB, 0.26033295E-09_JPRB, 0.26033686E-09_JPRB, &
  & 0.26034042E-09_JPRB, 0.26033686E-09_JPRB, 0.26032432E-09_JPRB, 0.26030367E-09_JPRB, 0.26027658E-09_JPRB, 0.26024211E-09_JPRB, &
  & 0.26019767E-09_JPRB, 0.26014266E-09_JPRB, 0.26007091E-09_JPRB, 0.25999061E-09_JPRB, 0.25991209E-09_JPRB, 0.25984553E-09_JPRB, &
  & 0.25978852E-09_JPRB, 0.25973765E-09_JPRB, 0.25968730E-09_JPRB, 0.25961969E-09_JPRB /)

RGHG5(:,55,11) = (/ &
  & 0.25755253E-09_JPRB, 0.25798094E-09_JPRB, 0.25825941E-09_JPRB, 0.25853003E-09_JPRB, 0.25884059E-09_JPRB, 0.25908703E-09_JPRB, &
  & 0.25920721E-09_JPRB, 0.25924984E-09_JPRB, 0.25926358E-09_JPRB, 0.25926505E-09_JPRB, 0.25925989E-09_JPRB, 0.25924904E-09_JPRB, &
  & 0.25923025E-09_JPRB, 0.25920027E-09_JPRB, 0.25914243E-09_JPRB, 0.25905489E-09_JPRB, 0.25891320E-09_JPRB, 0.25877769E-09_JPRB, &
  & 0.25870311E-09_JPRB, 0.25871524E-09_JPRB, 0.25881458E-09_JPRB, 0.25899685E-09_JPRB, 0.25925656E-09_JPRB, 0.25957653E-09_JPRB, &
  & 0.25994198E-09_JPRB, 0.26031918E-09_JPRB, 0.26069297E-09_JPRB, 0.26103586E-09_JPRB, 0.26133959E-09_JPRB, 0.26158992E-09_JPRB, &
  & 0.26178232E-09_JPRB, 0.26191307E-09_JPRB, 0.26197894E-09_JPRB, 0.26198005E-09_JPRB, 0.26192193E-09_JPRB, 0.26181732E-09_JPRB, &
  & 0.26168234E-09_JPRB, 0.26153063E-09_JPRB, 0.26136987E-09_JPRB, 0.26120364E-09_JPRB, 0.26103444E-09_JPRB, 0.26086680E-09_JPRB, &
  & 0.26072047E-09_JPRB, 0.26060959E-09_JPRB, 0.26055158E-09_JPRB, 0.26053801E-09_JPRB, 0.26055333E-09_JPRB, 0.26057945E-09_JPRB, &
  & 0.26060287E-09_JPRB, 0.26061803E-09_JPRB, 0.26062316E-09_JPRB, 0.26061975E-09_JPRB, 0.26060948E-09_JPRB, 0.26059344E-09_JPRB, &
  & 0.26057129E-09_JPRB, 0.26053953E-09_JPRB, 0.26049940E-09_JPRB, 0.26045155E-09_JPRB, 0.26040556E-09_JPRB, 0.26036490E-09_JPRB, &
  & 0.26033087E-09_JPRB, 0.26029762E-09_JPRB, 0.26025934E-09_JPRB, 0.26018937E-09_JPRB /)

RGHG5(:,56,11) = (/ &
  & 0.25853047E-09_JPRB, 0.25884461E-09_JPRB, 0.25902025E-09_JPRB, 0.25919300E-09_JPRB, 0.25938079E-09_JPRB, 0.25951771E-09_JPRB, &
  & 0.25957203E-09_JPRB, 0.25958802E-09_JPRB, 0.25958963E-09_JPRB, 0.25958580E-09_JPRB, 0.25957869E-09_JPRB, 0.25956801E-09_JPRB, &
  & 0.25955191E-09_JPRB, 0.25952457E-09_JPRB, 0.25948033E-09_JPRB, 0.25939106E-09_JPRB, 0.25925828E-09_JPRB, 0.25909777E-09_JPRB, &
  & 0.25899005E-09_JPRB, 0.25897165E-09_JPRB, 0.25904526E-09_JPRB, 0.25920566E-09_JPRB, 0.25944469E-09_JPRB, 0.25974964E-09_JPRB, &
  & 0.26009664E-09_JPRB, 0.26046384E-09_JPRB, 0.26082242E-09_JPRB, 0.26115649E-09_JPRB, 0.26144817E-09_JPRB, 0.26168862E-09_JPRB, &
  & 0.26187150E-09_JPRB, 0.26199506E-09_JPRB, 0.26205582E-09_JPRB, 0.26205449E-09_JPRB, 0.26199590E-09_JPRB, 0.26189259E-09_JPRB, &
  & 0.26175931E-09_JPRB, 0.26161004E-09_JPRB, 0.26145297E-09_JPRB, 0.26129168E-09_JPRB, 0.26112826E-09_JPRB, 0.26097283E-09_JPRB, &
  & 0.26083780E-09_JPRB, 0.26074679E-09_JPRB, 0.26070637E-09_JPRB, 0.26071115E-09_JPRB, 0.26074221E-09_JPRB, 0.26077990E-09_JPRB, &
  & 0.26081270E-09_JPRB, 0.26083447E-09_JPRB, 0.26084573E-09_JPRB, 0.26084826E-09_JPRB, 0.26084479E-09_JPRB, 0.26083660E-09_JPRB, &
  & 0.26082347E-09_JPRB, 0.26080521E-09_JPRB, 0.26077940E-09_JPRB, 0.26074956E-09_JPRB, 0.26071967E-09_JPRB, 0.26069488E-09_JPRB, &
  & 0.26067259E-09_JPRB, 0.26065228E-09_JPRB, 0.26062985E-09_JPRB, 0.26059352E-09_JPRB /)

RGHG5(:,57,11) = (/ &
  & 0.25918745E-09_JPRB, 0.25942032E-09_JPRB, 0.25954225E-09_JPRB, 0.25965247E-09_JPRB, 0.25976002E-09_JPRB, 0.25983096E-09_JPRB, &
  & 0.25985400E-09_JPRB, 0.25985658E-09_JPRB, 0.25985319E-09_JPRB, 0.25984781E-09_JPRB, 0.25984079E-09_JPRB, 0.25983146E-09_JPRB, &
  & 0.25981783E-09_JPRB, 0.25979641E-09_JPRB, 0.25975599E-09_JPRB, 0.25968566E-09_JPRB, 0.25955119E-09_JPRB, 0.25938351E-09_JPRB, &
  & 0.25925509E-09_JPRB, 0.25921451E-09_JPRB, 0.25926805E-09_JPRB, 0.25941038E-09_JPRB, 0.25963184E-09_JPRB, 0.25991861E-09_JPRB, &
  & 0.26025038E-09_JPRB, 0.26060212E-09_JPRB, 0.26095001E-09_JPRB, 0.26127145E-09_JPRB, 0.26155228E-09_JPRB, 0.26178190E-09_JPRB, &
  & 0.26195618E-09_JPRB, 0.26207264E-09_JPRB, 0.26212921E-09_JPRB, 0.26212618E-09_JPRB, 0.26206814E-09_JPRB, 0.26196648E-09_JPRB, &
  & 0.26183569E-09_JPRB, 0.26168934E-09_JPRB, 0.26153532E-09_JPRB, 0.26137809E-09_JPRB, 0.26122235E-09_JPRB, 0.26107472E-09_JPRB, &
  & 0.26095451E-09_JPRB, 0.26087621E-09_JPRB, 0.26085059E-09_JPRB, 0.26086786E-09_JPRB, 0.26090813E-09_JPRB, 0.26095298E-09_JPRB, &
  & 0.26098881E-09_JPRB, 0.26101291E-09_JPRB, 0.26102495E-09_JPRB, 0.26102878E-09_JPRB, 0.26102737E-09_JPRB, 0.26102226E-09_JPRB, &
  & 0.26101385E-09_JPRB, 0.26100086E-09_JPRB, 0.26098362E-09_JPRB, 0.26096250E-09_JPRB, 0.26094216E-09_JPRB, 0.26092359E-09_JPRB, &
  & 0.26090807E-09_JPRB, 0.26089214E-09_JPRB, 0.26087366E-09_JPRB, 0.26083952E-09_JPRB /)

RGHG5(:,58,11) = (/ &
  & 0.25975053E-09_JPRB, 0.25986072E-09_JPRB, 0.25992747E-09_JPRB, 0.25998653E-09_JPRB, 0.26004840E-09_JPRB, 0.26008171E-09_JPRB, &
  & 0.26008812E-09_JPRB, 0.26008529E-09_JPRB, 0.26008068E-09_JPRB, 0.26007541E-09_JPRB, 0.26006947E-09_JPRB, 0.26006192E-09_JPRB, &
  & 0.26005090E-09_JPRB, 0.26003283E-09_JPRB, 0.26000069E-09_JPRB, 0.25993421E-09_JPRB, 0.25981511E-09_JPRB, 0.25964270E-09_JPRB, &
  & 0.25950228E-09_JPRB, 0.25944785E-09_JPRB, 0.25948649E-09_JPRB, 0.25961258E-09_JPRB, 0.25981764E-09_JPRB, 0.26008695E-09_JPRB, &
  & 0.26040251E-09_JPRB, 0.26073987E-09_JPRB, 0.26107405E-09_JPRB, 0.26138319E-09_JPRB, 0.26165198E-09_JPRB, 0.26187127E-09_JPRB, &
  & 0.26203642E-09_JPRB, 0.26214711E-09_JPRB, 0.26219996E-09_JPRB, 0.26219604E-09_JPRB, 0.26213923E-09_JPRB, 0.26204017E-09_JPRB, &
  & 0.26191257E-09_JPRB, 0.26176905E-09_JPRB, 0.26161839E-09_JPRB, 0.26146563E-09_JPRB, 0.26131514E-09_JPRB, 0.26117780E-09_JPRB, &
  & 0.26106742E-09_JPRB, 0.26100200E-09_JPRB, 0.26098645E-09_JPRB, 0.26101160E-09_JPRB, 0.26105848E-09_JPRB, 0.26110639E-09_JPRB, &
  & 0.26114422E-09_JPRB, 0.26116670E-09_JPRB, 0.26117764E-09_JPRB, 0.26118063E-09_JPRB, 0.26117922E-09_JPRB, 0.26117497E-09_JPRB, &
  & 0.26116803E-09_JPRB, 0.26115821E-09_JPRB, 0.26114441E-09_JPRB, 0.26112823E-09_JPRB, 0.26111177E-09_JPRB, 0.26109795E-09_JPRB, &
  & 0.26108485E-09_JPRB, 0.26107250E-09_JPRB, 0.26105754E-09_JPRB, 0.26103095E-09_JPRB /)

RGHG5(:,59,11) = (/ &
  & 0.26008104E-09_JPRB, 0.26017083E-09_JPRB, 0.26021335E-09_JPRB, 0.26025129E-09_JPRB, 0.26028130E-09_JPRB, 0.26029515E-09_JPRB, &
  & 0.26029415E-09_JPRB, 0.26028990E-09_JPRB, 0.26028538E-09_JPRB, 0.26028130E-09_JPRB, 0.26027672E-09_JPRB, 0.26027089E-09_JPRB, &
  & 0.26026228E-09_JPRB, 0.26024738E-09_JPRB, 0.26021924E-09_JPRB, 0.26016209E-09_JPRB, 0.26004687E-09_JPRB, 0.25988070E-09_JPRB, &
  & 0.25973718E-09_JPRB, 0.25967453E-09_JPRB, 0.25970148E-09_JPRB, 0.25981384E-09_JPRB, 0.26000282E-09_JPRB, 0.26025626E-09_JPRB, &
  & 0.26055491E-09_JPRB, 0.26087710E-09_JPRB, 0.26119651E-09_JPRB, 0.26149238E-09_JPRB, 0.26174843E-09_JPRB, 0.26195643E-09_JPRB, &
  & 0.26211402E-09_JPRB, 0.26221858E-09_JPRB, 0.26226871E-09_JPRB, 0.26226443E-09_JPRB, 0.26220950E-09_JPRB, 0.26211386E-09_JPRB, &
  & 0.26198987E-09_JPRB, 0.26184996E-09_JPRB, 0.26170252E-09_JPRB, 0.26155353E-09_JPRB, 0.26140945E-09_JPRB, 0.26127919E-09_JPRB, &
  & 0.26117966E-09_JPRB, 0.26112362E-09_JPRB, 0.26111596E-09_JPRB, 0.26114660E-09_JPRB, 0.26119662E-09_JPRB, 0.26124702E-09_JPRB, &
  & 0.26128372E-09_JPRB, 0.26130489E-09_JPRB, 0.26131319E-09_JPRB, 0.26131433E-09_JPRB, 0.26131186E-09_JPRB, 0.26130723E-09_JPRB, &
  & 0.26130065E-09_JPRB, 0.26129138E-09_JPRB, 0.26127939E-09_JPRB, 0.26126515E-09_JPRB, 0.26125144E-09_JPRB, 0.26123873E-09_JPRB, &
  & 0.26122793E-09_JPRB, 0.26121633E-09_JPRB, 0.26120259E-09_JPRB, 0.26117664E-09_JPRB /)

RGHG5(:,60,11) = (/ &
  & 0.26036917E-09_JPRB, 0.26042171E-09_JPRB, 0.26044869E-09_JPRB, 0.26046754E-09_JPRB, 0.26048277E-09_JPRB, 0.26048588E-09_JPRB, &
  & 0.26048208E-09_JPRB, 0.26047772E-09_JPRB, 0.26047459E-09_JPRB, 0.26047198E-09_JPRB, 0.26046934E-09_JPRB, 0.26046565E-09_JPRB, &
  & 0.26045938E-09_JPRB, 0.26044777E-09_JPRB, 0.26042288E-09_JPRB, 0.26036961E-09_JPRB, 0.26026070E-09_JPRB, 0.26010119E-09_JPRB, &
  & 0.25996208E-09_JPRB, 0.25989610E-09_JPRB, 0.25991409E-09_JPRB, 0.26001426E-09_JPRB, 0.26018923E-09_JPRB, 0.26042626E-09_JPRB, &
  & 0.26070884E-09_JPRB, 0.26101454E-09_JPRB, 0.26131877E-09_JPRB, 0.26159958E-09_JPRB, 0.26184208E-09_JPRB, 0.26203964E-09_JPRB, &
  & 0.26218835E-09_JPRB, 0.26228802E-09_JPRB, 0.26233543E-09_JPRB, 0.26233146E-09_JPRB, 0.26227898E-09_JPRB, 0.26218716E-09_JPRB, &
  & 0.26206753E-09_JPRB, 0.26193137E-09_JPRB, 0.26178743E-09_JPRB, 0.26164274E-09_JPRB, 0.26150343E-09_JPRB, 0.26138133E-09_JPRB, &
  & 0.26129002E-09_JPRB, 0.26124258E-09_JPRB, 0.26124086E-09_JPRB, 0.26127450E-09_JPRB, 0.26132635E-09_JPRB, 0.26137695E-09_JPRB, &
  & 0.26141356E-09_JPRB, 0.26143177E-09_JPRB, 0.26143734E-09_JPRB, 0.26143626E-09_JPRB, 0.26143226E-09_JPRB, 0.26142649E-09_JPRB, &
  & 0.26141905E-09_JPRB, 0.26140962E-09_JPRB, 0.26139760E-09_JPRB, 0.26138408E-09_JPRB, 0.26137068E-09_JPRB, 0.26135932E-09_JPRB, &
  & 0.26134836E-09_JPRB, 0.26133787E-09_JPRB, 0.26132482E-09_JPRB, 0.26130126E-09_JPRB /)

RGHG5(:,61,11) = (/ &
  & 0.26058111E-09_JPRB, 0.26062841E-09_JPRB, 0.26064639E-09_JPRB, 0.26065805E-09_JPRB, 0.26066330E-09_JPRB, 0.26066133E-09_JPRB, &
  & 0.26065655E-09_JPRB, 0.26065330E-09_JPRB, 0.26065169E-09_JPRB, 0.26065120E-09_JPRB, 0.26065097E-09_JPRB, 0.26064997E-09_JPRB, &
  & 0.26064675E-09_JPRB, 0.26063773E-09_JPRB, 0.26061645E-09_JPRB, 0.26056429E-09_JPRB, 0.26045943E-09_JPRB, 0.26031055E-09_JPRB, &
  & 0.26017954E-09_JPRB, 0.26011346E-09_JPRB, 0.26012517E-09_JPRB, 0.26021521E-09_JPRB, 0.26037680E-09_JPRB, 0.26059854E-09_JPRB, &
  & 0.26086430E-09_JPRB, 0.26115343E-09_JPRB, 0.26144076E-09_JPRB, 0.26170602E-09_JPRB, 0.26193459E-09_JPRB, 0.26212044E-09_JPRB, &
  & 0.26226149E-09_JPRB, 0.26235533E-09_JPRB, 0.26240060E-09_JPRB, 0.26239710E-09_JPRB, 0.26234748E-09_JPRB, 0.26225988E-09_JPRB, &
  & 0.26214475E-09_JPRB, 0.26201277E-09_JPRB, 0.26187275E-09_JPRB, 0.26173186E-09_JPRB, 0.26159838E-09_JPRB, 0.26148272E-09_JPRB, &
  & 0.26139962E-09_JPRB, 0.26135918E-09_JPRB, 0.26136204E-09_JPRB, 0.26139757E-09_JPRB, 0.26144933E-09_JPRB, 0.26150002E-09_JPRB, &
  & 0.26153499E-09_JPRB, 0.26155125E-09_JPRB, 0.26155395E-09_JPRB, 0.26155031E-09_JPRB, 0.26154406E-09_JPRB, 0.26153668E-09_JPRB, &
  & 0.26152783E-09_JPRB, 0.26151700E-09_JPRB, 0.26150418E-09_JPRB, 0.26149016E-09_JPRB, 0.26147703E-09_JPRB, 0.26146488E-09_JPRB, &
  & 0.26145450E-09_JPRB, 0.26144337E-09_JPRB, 0.26143024E-09_JPRB, 0.26140573E-09_JPRB /)

RGHG5(:,62,11) = (/ &
  & 0.26077920E-09_JPRB, 0.26081259E-09_JPRB, 0.26082492E-09_JPRB, 0.26083039E-09_JPRB, 0.26083091E-09_JPRB, 0.26082630E-09_JPRB, &
  & 0.26082120E-09_JPRB, 0.26081881E-09_JPRB, 0.26081903E-09_JPRB, 0.26082106E-09_JPRB, 0.26082400E-09_JPRB, 0.26082686E-09_JPRB, &
  & 0.26082767E-09_JPRB, 0.26082275E-09_JPRB, 0.26080316E-09_JPRB, 0.26075214E-09_JPRB, 0.26065042E-09_JPRB, 0.26051261E-09_JPRB, &
  & 0.26039215E-09_JPRB, 0.26032806E-09_JPRB, 0.26033559E-09_JPRB, 0.26041702E-09_JPRB, 0.26056637E-09_JPRB, 0.26077299E-09_JPRB, &
  & 0.26102207E-09_JPRB, 0.26129354E-09_JPRB, 0.26156380E-09_JPRB, 0.26181232E-09_JPRB, 0.26202637E-09_JPRB, 0.26220079E-09_JPRB, &
  & 0.26233279E-09_JPRB, 0.26242139E-09_JPRB, 0.26246436E-09_JPRB, 0.26246139E-09_JPRB, 0.26241476E-09_JPRB, 0.26233163E-09_JPRB, &
  & 0.26222144E-09_JPRB, 0.26209410E-09_JPRB, 0.26195798E-09_JPRB, 0.26182159E-09_JPRB, 0.26169317E-09_JPRB, 0.26158453E-09_JPRB, &
  & 0.26150837E-09_JPRB, 0.26147395E-09_JPRB, 0.26148037E-09_JPRB, 0.26151678E-09_JPRB, 0.26156782E-09_JPRB, 0.26161695E-09_JPRB, &
  & 0.26165134E-09_JPRB, 0.26166566E-09_JPRB, 0.26166574E-09_JPRB, 0.26165914E-09_JPRB, 0.26165056E-09_JPRB, 0.26164060E-09_JPRB, &
  & 0.26162961E-09_JPRB, 0.26161695E-09_JPRB, 0.26160252E-09_JPRB, 0.26158736E-09_JPRB, 0.26157299E-09_JPRB, 0.26156080E-09_JPRB, &
  & 0.26154917E-09_JPRB, 0.26153785E-09_JPRB, 0.26152380E-09_JPRB, 0.26149857E-09_JPRB /)

RGHG5(:,63,11) = (/ &
  & 0.26094948E-09_JPRB, 0.26098010E-09_JPRB, 0.26098926E-09_JPRB, 0.26099203E-09_JPRB, 0.26098990E-09_JPRB, 0.26098351E-09_JPRB, &
  & 0.26097804E-09_JPRB, 0.26097624E-09_JPRB, 0.26097813E-09_JPRB, 0.26098290E-09_JPRB, 0.26099012E-09_JPRB, 0.26099803E-09_JPRB, &
  & 0.26100425E-09_JPRB, 0.26100358E-09_JPRB, 0.26098568E-09_JPRB, 0.26093422E-09_JPRB, 0.26083644E-09_JPRB, 0.26071198E-09_JPRB, &
  & 0.26060146E-09_JPRB, 0.26054081E-09_JPRB, 0.26054603E-09_JPRB, 0.26062022E-09_JPRB, 0.26075819E-09_JPRB, 0.26095009E-09_JPRB, &
  & 0.26118233E-09_JPRB, 0.26143587E-09_JPRB, 0.26168770E-09_JPRB, 0.26191935E-09_JPRB, 0.26211841E-09_JPRB, 0.26228048E-09_JPRB, &
  & 0.26240349E-09_JPRB, 0.26248603E-09_JPRB, 0.26252645E-09_JPRB, 0.26252392E-09_JPRB, 0.26248043E-09_JPRB, 0.26240216E-09_JPRB, &
  & 0.26229727E-09_JPRB, 0.26217484E-09_JPRB, 0.26204330E-09_JPRB, 0.26191144E-09_JPRB, 0.26178870E-09_JPRB, 0.26168631E-09_JPRB, &
  & 0.26161665E-09_JPRB, 0.26158720E-09_JPRB, 0.26159630E-09_JPRB, 0.26163299E-09_JPRB, 0.26168245E-09_JPRB, 0.26173003E-09_JPRB, &
  & 0.26176308E-09_JPRB, 0.26177663E-09_JPRB, 0.26177466E-09_JPRB, 0.26176550E-09_JPRB, 0.26175351E-09_JPRB, 0.26174085E-09_JPRB, &
  & 0.26172695E-09_JPRB, 0.26171154E-09_JPRB, 0.26169478E-09_JPRB, 0.26167782E-09_JPRB, 0.26166247E-09_JPRB, 0.26164854E-09_JPRB, &
  & 0.26163632E-09_JPRB, 0.26162325E-09_JPRB, 0.26160779E-09_JPRB, 0.26157954E-09_JPRB /)

RGHG5(:,64,11) = (/ &
  & 0.26110741E-09_JPRB, 0.26113567E-09_JPRB, 0.26114383E-09_JPRB, 0.26114533E-09_JPRB, 0.26114202E-09_JPRB, 0.26113506E-09_JPRB, &
  & 0.26112884E-09_JPRB, 0.26112720E-09_JPRB, 0.26113045E-09_JPRB, 0.26113828E-09_JPRB, 0.26115002E-09_JPRB, 0.26116448E-09_JPRB, &
  & 0.26117675E-09_JPRB, 0.26118008E-09_JPRB, 0.26116309E-09_JPRB, 0.26111152E-09_JPRB, 0.26102123E-09_JPRB, 0.26090768E-09_JPRB, &
  & 0.26080707E-09_JPRB, 0.26075098E-09_JPRB, 0.26075531E-09_JPRB, 0.26082353E-09_JPRB, 0.26095087E-09_JPRB, 0.26112851E-09_JPRB, &
  & 0.26134367E-09_JPRB, 0.26157845E-09_JPRB, 0.26181179E-09_JPRB, 0.26202551E-09_JPRB, 0.26220923E-09_JPRB, 0.26235861E-09_JPRB, &
  & 0.26247204E-09_JPRB, 0.26254826E-09_JPRB, 0.26258565E-09_JPRB, 0.26258351E-09_JPRB, 0.26254335E-09_JPRB, 0.26247030E-09_JPRB, &
  & 0.26237118E-09_JPRB, 0.26225433E-09_JPRB, 0.26212774E-09_JPRB, 0.26200112E-09_JPRB, 0.26188393E-09_JPRB, 0.26178773E-09_JPRB, &
  & 0.26172378E-09_JPRB, 0.26169844E-09_JPRB, 0.26170943E-09_JPRB, 0.26174576E-09_JPRB, 0.26179353E-09_JPRB, 0.26183861E-09_JPRB, &
  & 0.26187055E-09_JPRB, 0.26188368E-09_JPRB, 0.26188079E-09_JPRB, 0.26186897E-09_JPRB, 0.26185426E-09_JPRB, 0.26183788E-09_JPRB, &
  & 0.26182068E-09_JPRB, 0.26180205E-09_JPRB, 0.26178268E-09_JPRB, 0.26176353E-09_JPRB, 0.26174596E-09_JPRB, 0.26173091E-09_JPRB, &
  & 0.26171648E-09_JPRB, 0.26170194E-09_JPRB, 0.26168365E-09_JPRB, 0.26165051E-09_JPRB /)

RGHG5(:,65,11) = (/ &
  & 0.26125405E-09_JPRB, 0.26128288E-09_JPRB, 0.26129071E-09_JPRB, 0.26129221E-09_JPRB, 0.26128885E-09_JPRB, 0.26128161E-09_JPRB, &
  & 0.26127539E-09_JPRB, 0.26127386E-09_JPRB, 0.26127839E-09_JPRB, 0.26128955E-09_JPRB, 0.26130631E-09_JPRB, 0.26132657E-09_JPRB, &
  & 0.26134447E-09_JPRB, 0.26135039E-09_JPRB, 0.26133368E-09_JPRB, 0.26128502E-09_JPRB, 0.26120181E-09_JPRB, 0.26109970E-09_JPRB, &
  & 0.26100883E-09_JPRB, 0.26095801E-09_JPRB, 0.26096250E-09_JPRB, 0.26102551E-09_JPRB, 0.26114286E-09_JPRB, 0.26130628E-09_JPRB, &
  & 0.26150415E-09_JPRB, 0.26171978E-09_JPRB, 0.26193353E-09_JPRB, 0.26212923E-09_JPRB, 0.26229696E-09_JPRB, 0.26243333E-09_JPRB, &
  & 0.26253674E-09_JPRB, 0.26260619E-09_JPRB, 0.26264033E-09_JPRB, 0.26263858E-09_JPRB, 0.26260188E-09_JPRB, 0.26253441E-09_JPRB, &
  & 0.26244168E-09_JPRB, 0.26233121E-09_JPRB, 0.26221075E-09_JPRB, 0.26208993E-09_JPRB, 0.26197877E-09_JPRB, 0.26188854E-09_JPRB, &
  & 0.26182975E-09_JPRB, 0.26180766E-09_JPRB, 0.26181959E-09_JPRB, 0.26185512E-09_JPRB, 0.26190070E-09_JPRB, 0.26194333E-09_JPRB, &
  & 0.26197347E-09_JPRB, 0.26198640E-09_JPRB, 0.26198330E-09_JPRB, 0.26197028E-09_JPRB, 0.26195240E-09_JPRB, 0.26193300E-09_JPRB, &
  & 0.26191199E-09_JPRB, 0.26189018E-09_JPRB, 0.26186769E-09_JPRB, 0.26184616E-09_JPRB, 0.26182678E-09_JPRB, 0.26180902E-09_JPRB, &
  & 0.26179275E-09_JPRB, 0.26177485E-09_JPRB, 0.26175262E-09_JPRB, 0.26171132E-09_JPRB /)

RGHG5(:,66,11) = (/ &
  & 0.26138613E-09_JPRB, 0.26142027E-09_JPRB, 0.26143077E-09_JPRB, 0.26143354E-09_JPRB, 0.26143104E-09_JPRB, 0.26142472E-09_JPRB, &
  & 0.26141861E-09_JPRB, 0.26141767E-09_JPRB, 0.26142433E-09_JPRB, 0.26143820E-09_JPRB, 0.26146016E-09_JPRB, 0.26148500E-09_JPRB, &
  & 0.26150598E-09_JPRB, 0.26151373E-09_JPRB, 0.26149860E-09_JPRB, 0.26145389E-09_JPRB, 0.26137864E-09_JPRB, 0.26128696E-09_JPRB, &
  & 0.26120575E-09_JPRB, 0.26116084E-09_JPRB, 0.26116614E-09_JPRB, 0.26122449E-09_JPRB, 0.26133187E-09_JPRB, 0.26148100E-09_JPRB, &
  & 0.26166108E-09_JPRB, 0.26185684E-09_JPRB, 0.26205088E-09_JPRB, 0.26222782E-09_JPRB, 0.26237959E-09_JPRB, 0.26250274E-09_JPRB, &
  & 0.26259622E-09_JPRB, 0.26265878E-09_JPRB, 0.26268954E-09_JPRB, 0.26268807E-09_JPRB, 0.26265493E-09_JPRB, 0.26259322E-09_JPRB, &
  & 0.26250760E-09_JPRB, 0.26240451E-09_JPRB, 0.26229133E-09_JPRB, 0.26217728E-09_JPRB, 0.26207275E-09_JPRB, 0.26198846E-09_JPRB, &
  & 0.26193431E-09_JPRB, 0.26191477E-09_JPRB, 0.26192692E-09_JPRB, 0.26196093E-09_JPRB, 0.26200397E-09_JPRB, 0.26204380E-09_JPRB, &
  & 0.26207214E-09_JPRB, 0.26208433E-09_JPRB, 0.26208147E-09_JPRB, 0.26206776E-09_JPRB, 0.26204849E-09_JPRB, 0.26202587E-09_JPRB, &
  & 0.26200209E-09_JPRB, 0.26197677E-09_JPRB, 0.26195196E-09_JPRB, 0.26192787E-09_JPRB, 0.26190577E-09_JPRB, 0.26188610E-09_JPRB, &
  & 0.26186625E-09_JPRB, 0.26184493E-09_JPRB, 0.26181660E-09_JPRB, 0.26176325E-09_JPRB /)

RGHG5(:,67,11) = (/ &
  & 0.26151456E-09_JPRB, 0.26155417E-09_JPRB, 0.26156641E-09_JPRB, 0.26157088E-09_JPRB, 0.26156971E-09_JPRB, 0.26156460E-09_JPRB, &
  & 0.26155975E-09_JPRB, 0.26156016E-09_JPRB, 0.26156838E-09_JPRB, 0.26158661E-09_JPRB, 0.26161109E-09_JPRB, 0.26163899E-09_JPRB, &
  & 0.26166155E-09_JPRB, 0.26167069E-09_JPRB, 0.26165756E-09_JPRB, 0.26161720E-09_JPRB, 0.26154992E-09_JPRB, 0.26146871E-09_JPRB, &
  & 0.26139713E-09_JPRB, 0.26135796E-09_JPRB, 0.26136401E-09_JPRB, 0.26141761E-09_JPRB, 0.26151498E-09_JPRB, 0.26164954E-09_JPRB, &
  & 0.26181182E-09_JPRB, 0.26198752E-09_JPRB, 0.26216157E-09_JPRB, 0.26232033E-09_JPRB, 0.26245611E-09_JPRB, 0.26256622E-09_JPRB, &
  & 0.26264990E-09_JPRB, 0.26270572E-09_JPRB, 0.26273317E-09_JPRB, 0.26273181E-09_JPRB, 0.26270211E-09_JPRB, 0.26264649E-09_JPRB, &
  & 0.26256836E-09_JPRB, 0.26247332E-09_JPRB, 0.26236846E-09_JPRB, 0.26226227E-09_JPRB, 0.26216487E-09_JPRB, 0.26208685E-09_JPRB, &
  & 0.26203714E-09_JPRB, 0.26201960E-09_JPRB, 0.26203131E-09_JPRB, 0.26206320E-09_JPRB, 0.26210334E-09_JPRB, 0.26214034E-09_JPRB, &
  & 0.26216662E-09_JPRB, 0.26217789E-09_JPRB, 0.26217495E-09_JPRB, 0.26216149E-09_JPRB, 0.26214092E-09_JPRB, 0.26211722E-09_JPRB, &
  & 0.26209068E-09_JPRB, 0.26206359E-09_JPRB, 0.26203603E-09_JPRB, 0.26200991E-09_JPRB, 0.26198596E-09_JPRB, 0.26196303E-09_JPRB, &
  & 0.26194091E-09_JPRB, 0.26191443E-09_JPRB, 0.26187869E-09_JPRB, 0.26180860E-09_JPRB /)

RGHG5(:,68,11) = (/ &
  & 0.26163297E-09_JPRB, 0.26168109E-09_JPRB, 0.26169786E-09_JPRB, 0.26170469E-09_JPRB, 0.26170549E-09_JPRB, 0.26170233E-09_JPRB, &
  & 0.26169927E-09_JPRB, 0.26170155E-09_JPRB, 0.26171254E-09_JPRB, 0.26173244E-09_JPRB, 0.26175970E-09_JPRB, 0.26178826E-09_JPRB, &
  & 0.26181129E-09_JPRB, 0.26182120E-09_JPRB, 0.26180993E-09_JPRB, 0.26177435E-09_JPRB, 0.26171479E-09_JPRB, 0.26164348E-09_JPRB, &
  & 0.26158076E-09_JPRB, 0.26154698E-09_JPRB, 0.26155339E-09_JPRB, 0.26160196E-09_JPRB, 0.26168925E-09_JPRB, 0.26180952E-09_JPRB, &
  & 0.26195393E-09_JPRB, 0.26211022E-09_JPRB, 0.26226490E-09_JPRB, 0.26240587E-09_JPRB, 0.26252633E-09_JPRB, 0.26262398E-09_JPRB, &
  & 0.26269814E-09_JPRB, 0.26274746E-09_JPRB, 0.26277167E-09_JPRB, 0.26277044E-09_JPRB, 0.26274410E-09_JPRB, 0.26269426E-09_JPRB, &
  & 0.26262381E-09_JPRB, 0.26253733E-09_JPRB, 0.26244140E-09_JPRB, 0.26234367E-09_JPRB, 0.26225433E-09_JPRB, 0.26218283E-09_JPRB, &
  & 0.26213764E-09_JPRB, 0.26212182E-09_JPRB, 0.26213270E-09_JPRB, 0.26216218E-09_JPRB, 0.26219910E-09_JPRB, 0.26223307E-09_JPRB, &
  & 0.26225713E-09_JPRB, 0.26226735E-09_JPRB, 0.26226424E-09_JPRB, 0.26225078E-09_JPRB, 0.26223054E-09_JPRB, 0.26220570E-09_JPRB, &
  & 0.26217867E-09_JPRB, 0.26214977E-09_JPRB, 0.26212116E-09_JPRB, 0.26209349E-09_JPRB, 0.26206731E-09_JPRB, 0.26204339E-09_JPRB, &
  & 0.26201741E-09_JPRB, 0.26198776E-09_JPRB, 0.26194336E-09_JPRB, 0.26185573E-09_JPRB /)

RGHG5(:,69,11) = (/ &
  & 0.26174715E-09_JPRB, 0.26180624E-09_JPRB, 0.26182684E-09_JPRB, 0.26183655E-09_JPRB, 0.26183958E-09_JPRB, 0.26183877E-09_JPRB, &
  & 0.26183819E-09_JPRB, 0.26184280E-09_JPRB, 0.26185573E-09_JPRB, 0.26187758E-09_JPRB, 0.26190503E-09_JPRB, 0.26193328E-09_JPRB, &
  & 0.26195560E-09_JPRB, 0.26196570E-09_JPRB, 0.26195593E-09_JPRB, 0.26192462E-09_JPRB, 0.26187233E-09_JPRB, 0.26181010E-09_JPRB, &
  & 0.26175551E-09_JPRB, 0.26172625E-09_JPRB, 0.26173244E-09_JPRB, 0.26177574E-09_JPRB, 0.26185315E-09_JPRB, 0.26195945E-09_JPRB, &
  & 0.26208691E-09_JPRB, 0.26222449E-09_JPRB, 0.26236066E-09_JPRB, 0.26248492E-09_JPRB, 0.26259073E-09_JPRB, 0.26267649E-09_JPRB, &
  & 0.26274155E-09_JPRB, 0.26278471E-09_JPRB, 0.26280583E-09_JPRB, 0.26280456E-09_JPRB, 0.26278135E-09_JPRB, 0.26273725E-09_JPRB, &
  & 0.26267438E-09_JPRB, 0.26259650E-09_JPRB, 0.26250976E-09_JPRB, 0.26242122E-09_JPRB, 0.26234029E-09_JPRB, 0.26227573E-09_JPRB, &
  & 0.26223515E-09_JPRB, 0.26222119E-09_JPRB, 0.26223126E-09_JPRB, 0.26225802E-09_JPRB, 0.26229158E-09_JPRB, 0.26232247E-09_JPRB, &
  & 0.26234415E-09_JPRB, 0.26235319E-09_JPRB, 0.26234986E-09_JPRB, 0.26233685E-09_JPRB, 0.26231667E-09_JPRB, 0.26229247E-09_JPRB, &
  & 0.26226518E-09_JPRB, 0.26223632E-09_JPRB, 0.26220703E-09_JPRB, 0.26217861E-09_JPRB, 0.26215227E-09_JPRB, 0.26212615E-09_JPRB, &
  & 0.26209990E-09_JPRB, 0.26206601E-09_JPRB, 0.26201527E-09_JPRB, 0.26190961E-09_JPRB /)

RGHG5(:,70,11) = (/ &
  & 0.26185915E-09_JPRB, 0.26192887E-09_JPRB, 0.26195476E-09_JPRB, 0.26196739E-09_JPRB, 0.26197289E-09_JPRB, 0.26197475E-09_JPRB, &
  & 0.26197677E-09_JPRB, 0.26198385E-09_JPRB, 0.26199826E-09_JPRB, 0.26202060E-09_JPRB, 0.26204688E-09_JPRB, 0.26207342E-09_JPRB, &
  & 0.26209399E-09_JPRB, 0.26210351E-09_JPRB, 0.26209487E-09_JPRB, 0.26206753E-09_JPRB, 0.26202165E-09_JPRB, 0.26196739E-09_JPRB, &
  & 0.26191985E-09_JPRB, 0.26189442E-09_JPRB, 0.26190017E-09_JPRB, 0.26193811E-09_JPRB, 0.26200617E-09_JPRB, 0.26209915E-09_JPRB, &
  & 0.26221042E-09_JPRB, 0.26233044E-09_JPRB, 0.26244940E-09_JPRB, 0.26255756E-09_JPRB, 0.26264979E-09_JPRB, 0.26272415E-09_JPRB, &
  & 0.26278071E-09_JPRB, 0.26281799E-09_JPRB, 0.26283614E-09_JPRB, 0.26283484E-09_JPRB, 0.26281463E-09_JPRB, 0.26277597E-09_JPRB, &
  & 0.26272051E-09_JPRB, 0.26265121E-09_JPRB, 0.26257385E-09_JPRB, 0.26249453E-09_JPRB, 0.26242220E-09_JPRB, 0.26236471E-09_JPRB, &
  & 0.26232899E-09_JPRB, 0.26231714E-09_JPRB, 0.26232655E-09_JPRB, 0.26235084E-09_JPRB, 0.26238087E-09_JPRB, 0.26240854E-09_JPRB, &
  & 0.26242786E-09_JPRB, 0.26243563E-09_JPRB, 0.26243197E-09_JPRB, 0.26241956E-09_JPRB, 0.26240043E-09_JPRB, 0.26237715E-09_JPRB, &
  & 0.26235103E-09_JPRB, 0.26232300E-09_JPRB, 0.26229424E-09_JPRB, 0.26226640E-09_JPRB, 0.26223990E-09_JPRB, 0.26221461E-09_JPRB, &
  & 0.26218699E-09_JPRB, 0.26215280E-09_JPRB, 0.26209682E-09_JPRB, 0.26197866E-09_JPRB /)

RGHG5(:,71,11) = (/ &
  & 0.26197228E-09_JPRB, 0.26205257E-09_JPRB, 0.26208202E-09_JPRB, 0.26209737E-09_JPRB, 0.26210517E-09_JPRB, 0.26210945E-09_JPRB, &
  & 0.26211414E-09_JPRB, 0.26212302E-09_JPRB, 0.26213870E-09_JPRB, 0.26215941E-09_JPRB, 0.26218419E-09_JPRB, 0.26220739E-09_JPRB, &
  & 0.26222566E-09_JPRB, 0.26223421E-09_JPRB, 0.26222588E-09_JPRB, 0.26220223E-09_JPRB, 0.26216213E-09_JPRB, 0.26211497E-09_JPRB, &
  & 0.26207359E-09_JPRB, 0.26205135E-09_JPRB, 0.26205638E-09_JPRB, 0.26208941E-09_JPRB, 0.26214822E-09_JPRB, 0.26222896E-09_JPRB, &
  & 0.26232472E-09_JPRB, 0.26242836E-09_JPRB, 0.26253094E-09_JPRB, 0.26262426E-09_JPRB, 0.26270361E-09_JPRB, 0.26276742E-09_JPRB, &
  & 0.26281591E-09_JPRB, 0.26284774E-09_JPRB, 0.26286312E-09_JPRB, 0.26286184E-09_JPRB, 0.26284441E-09_JPRB, 0.26281088E-09_JPRB, &
  & 0.26276259E-09_JPRB, 0.26270167E-09_JPRB, 0.26263355E-09_JPRB, 0.26256355E-09_JPRB, 0.26249986E-09_JPRB, 0.26244948E-09_JPRB, &
  & 0.26241870E-09_JPRB, 0.26240898E-09_JPRB, 0.26241795E-09_JPRB, 0.26243988E-09_JPRB, 0.26246649E-09_JPRB, 0.26249092E-09_JPRB, &
  & 0.26250774E-09_JPRB, 0.26251440E-09_JPRB, 0.26251065E-09_JPRB, 0.26249924E-09_JPRB, 0.26248143E-09_JPRB, 0.26246003E-09_JPRB, &
  & 0.26243610E-09_JPRB, 0.26240973E-09_JPRB, 0.26238275E-09_JPRB, 0.26235630E-09_JPRB, 0.26233102E-09_JPRB, 0.26230659E-09_JPRB, &
  & 0.26228023E-09_JPRB, 0.26224575E-09_JPRB, 0.26218924E-09_JPRB, 0.26206332E-09_JPRB /)

RGHG5(:,72,11) = (/ &
  & 0.26208929E-09_JPRB, 0.26217603E-09_JPRB, 0.26220856E-09_JPRB, 0.26222546E-09_JPRB, 0.26223484E-09_JPRB, 0.26224128E-09_JPRB, &
  & 0.26224789E-09_JPRB, 0.26225841E-09_JPRB, 0.26227306E-09_JPRB, 0.26229330E-09_JPRB, 0.26231348E-09_JPRB, 0.26233429E-09_JPRB, &
  & 0.26234925E-09_JPRB, 0.26235666E-09_JPRB, 0.26234898E-09_JPRB, 0.26232813E-09_JPRB, 0.26229335E-09_JPRB, 0.26225244E-09_JPRB, &
  & 0.26221661E-09_JPRB, 0.26219724E-09_JPRB, 0.26220170E-09_JPRB, 0.26222982E-09_JPRB, 0.26228023E-09_JPRB, 0.26234875E-09_JPRB, &
  & 0.26243041E-09_JPRB, 0.26251828E-09_JPRB, 0.26260602E-09_JPRB, 0.26268523E-09_JPRB, 0.26275265E-09_JPRB, 0.26280647E-09_JPRB, &
  & 0.26284744E-09_JPRB, 0.26287414E-09_JPRB, 0.26288721E-09_JPRB, 0.26288591E-09_JPRB, 0.26287106E-09_JPRB, 0.26284241E-09_JPRB, &
  & 0.26280098E-09_JPRB, 0.26274813E-09_JPRB, 0.26268923E-09_JPRB, 0.26262836E-09_JPRB, 0.26257310E-09_JPRB, 0.26252986E-09_JPRB, &
  & 0.26250382E-09_JPRB, 0.26249630E-09_JPRB, 0.26250480E-09_JPRB, 0.26252453E-09_JPRB, 0.26254779E-09_JPRB, 0.26256899E-09_JPRB, &
  & 0.26258345E-09_JPRB, 0.26258906E-09_JPRB, 0.26258534E-09_JPRB, 0.26257524E-09_JPRB, 0.26255953E-09_JPRB, 0.26254068E-09_JPRB, &
  & 0.26251920E-09_JPRB, 0.26249622E-09_JPRB, 0.26247132E-09_JPRB, 0.26244684E-09_JPRB, 0.26242419E-09_JPRB, 0.26240088E-09_JPRB, &
  & 0.26237632E-09_JPRB, 0.26234412E-09_JPRB, 0.26228739E-09_JPRB, 0.26216035E-09_JPRB /)

RGHG5(:,73,11) = (/ &
  & 0.26221247E-09_JPRB, 0.26230010E-09_JPRB, 0.26233252E-09_JPRB, 0.26234964E-09_JPRB, 0.26235972E-09_JPRB, 0.26236732E-09_JPRB, &
  & 0.26237529E-09_JPRB, 0.26238559E-09_JPRB, 0.26240049E-09_JPRB, 0.26241637E-09_JPRB, 0.26243546E-09_JPRB, 0.26245134E-09_JPRB, &
  & 0.26246408E-09_JPRB, 0.26247016E-09_JPRB, 0.26246319E-09_JPRB, 0.26244473E-09_JPRB, 0.26241467E-09_JPRB, 0.26237965E-09_JPRB, &
  & 0.26234895E-09_JPRB, 0.26233243E-09_JPRB, 0.26233624E-09_JPRB, 0.26235988E-09_JPRB, 0.26240182E-09_JPRB, 0.26245947E-09_JPRB, &
  & 0.26252731E-09_JPRB, 0.26260116E-09_JPRB, 0.26267444E-09_JPRB, 0.26274077E-09_JPRB, 0.26279684E-09_JPRB, 0.26284153E-09_JPRB, &
  & 0.26287572E-09_JPRB, 0.26289773E-09_JPRB, 0.26290853E-09_JPRB, 0.26290720E-09_JPRB, 0.26289484E-09_JPRB, 0.26287086E-09_JPRB, &
  & 0.26283589E-09_JPRB, 0.26279087E-09_JPRB, 0.26274105E-09_JPRB, 0.26268898E-09_JPRB, 0.26264205E-09_JPRB, 0.26260560E-09_JPRB, &
  & 0.26258420E-09_JPRB, 0.26257851E-09_JPRB, 0.26258645E-09_JPRB, 0.26260374E-09_JPRB, 0.26262373E-09_JPRB, 0.26264188E-09_JPRB, &
  & 0.26265426E-09_JPRB, 0.26265903E-09_JPRB, 0.26265579E-09_JPRB, 0.26264735E-09_JPRB, 0.26263386E-09_JPRB, 0.26261762E-09_JPRB, &
  & 0.26259989E-09_JPRB, 0.26257926E-09_JPRB, 0.26255778E-09_JPRB, 0.26253655E-09_JPRB, 0.26251512E-09_JPRB, 0.26249530E-09_JPRB, &
  & 0.26247235E-09_JPRB, 0.26244246E-09_JPRB, 0.26239039E-09_JPRB, 0.26226313E-09_JPRB /)

RGHG5(:,74,11) = (/ &
  & 0.26233424E-09_JPRB, 0.26242028E-09_JPRB, 0.26245150E-09_JPRB, 0.26246783E-09_JPRB, 0.26247757E-09_JPRB, 0.26248553E-09_JPRB, &
  & 0.26249347E-09_JPRB, 0.26250391E-09_JPRB, 0.26251587E-09_JPRB, 0.26253150E-09_JPRB, 0.26254515E-09_JPRB, 0.26255970E-09_JPRB, &
  & 0.26256924E-09_JPRB, 0.26257402E-09_JPRB, 0.26256802E-09_JPRB, 0.26255192E-09_JPRB, 0.26252639E-09_JPRB, 0.26249664E-09_JPRB, &
  & 0.26247088E-09_JPRB, 0.26245692E-09_JPRB, 0.26246044E-09_JPRB, 0.26247970E-09_JPRB, 0.26251387E-09_JPRB, 0.26256097E-09_JPRB, &
  & 0.26261646E-09_JPRB, 0.26267682E-09_JPRB, 0.26273678E-09_JPRB, 0.26279112E-09_JPRB, 0.26283670E-09_JPRB, 0.26287292E-09_JPRB, &
  & 0.26290090E-09_JPRB, 0.26291860E-09_JPRB, 0.26292740E-09_JPRB, 0.26292621E-09_JPRB, 0.26291611E-09_JPRB, 0.26289640E-09_JPRB, &
  & 0.26286759E-09_JPRB, 0.26283015E-09_JPRB, 0.26278904E-09_JPRB, 0.26274563E-09_JPRB, 0.26270661E-09_JPRB, 0.26267677E-09_JPRB, &
  & 0.26265959E-09_JPRB, 0.26265543E-09_JPRB, 0.26266248E-09_JPRB, 0.26267738E-09_JPRB, 0.26269395E-09_JPRB, 0.26270930E-09_JPRB, &
  & 0.26271985E-09_JPRB, 0.26272401E-09_JPRB, 0.26272132E-09_JPRB, 0.26271479E-09_JPRB, 0.26270364E-09_JPRB, 0.26269023E-09_JPRB, &
  & 0.26267485E-09_JPRB, 0.26265845E-09_JPRB, 0.26263980E-09_JPRB, 0.26262084E-09_JPRB, 0.26260391E-09_JPRB, 0.26258484E-09_JPRB, &
  & 0.26256580E-09_JPRB, 0.26253955E-09_JPRB, 0.26249025E-09_JPRB, 0.26237201E-09_JPRB /)

RGHG5(:,75,11) = (/ &
  & 0.26245278E-09_JPRB, 0.26253491E-09_JPRB, 0.26256405E-09_JPRB, 0.26257863E-09_JPRB, 0.26258734E-09_JPRB, 0.26259472E-09_JPRB, &
  & 0.26260238E-09_JPRB, 0.26261104E-09_JPRB, 0.26262259E-09_JPRB, 0.26263375E-09_JPRB, 0.26264674E-09_JPRB, 0.26265706E-09_JPRB, &
  & 0.26266506E-09_JPRB, 0.26266855E-09_JPRB, 0.26266375E-09_JPRB, 0.26264968E-09_JPRB, 0.26262856E-09_JPRB, 0.26260391E-09_JPRB, &
  & 0.26258282E-09_JPRB, 0.26257152E-09_JPRB, 0.26257480E-09_JPRB, 0.26258998E-09_JPRB, 0.26261687E-09_JPRB, 0.26265420E-09_JPRB, &
  & 0.26269806E-09_JPRB, 0.26274627E-09_JPRB, 0.26279340E-09_JPRB, 0.26283659E-09_JPRB, 0.26287239E-09_JPRB, 0.26290095E-09_JPRB, &
  & 0.26292327E-09_JPRB, 0.26293709E-09_JPRB, 0.26294419E-09_JPRB, 0.26294303E-09_JPRB, 0.26293503E-09_JPRB, 0.26291941E-09_JPRB, &
  & 0.26289629E-09_JPRB, 0.26286623E-09_JPRB, 0.26283356E-09_JPRB, 0.26279834E-09_JPRB, 0.26276717E-09_JPRB, 0.26274333E-09_JPRB, &
  & 0.26272995E-09_JPRB, 0.26272695E-09_JPRB, 0.26273297E-09_JPRB, 0.26274519E-09_JPRB, 0.26275865E-09_JPRB, 0.26277130E-09_JPRB, &
  & 0.26278002E-09_JPRB, 0.26278374E-09_JPRB, 0.26278169E-09_JPRB, 0.26277719E-09_JPRB, 0.26276811E-09_JPRB, 0.26275684E-09_JPRB, &
  & 0.26274510E-09_JPRB, 0.26273106E-09_JPRB, 0.26271602E-09_JPRB, 0.26270125E-09_JPRB, 0.26268554E-09_JPRB, 0.26267122E-09_JPRB, &
  & 0.26265398E-09_JPRB, 0.26263192E-09_JPRB, 0.26258948E-09_JPRB, 0.26247809E-09_JPRB /)

RGHG5(:,76,11) = (/ &
  & 0.26256705E-09_JPRB, 0.26264346E-09_JPRB, 0.26266950E-09_JPRB, 0.26268185E-09_JPRB, 0.26268879E-09_JPRB, 0.26269525E-09_JPRB, &
  & 0.26270164E-09_JPRB, 0.26270933E-09_JPRB, 0.26271779E-09_JPRB, 0.26272801E-09_JPRB, 0.26273644E-09_JPRB, 0.26274535E-09_JPRB, &
  & 0.26275088E-09_JPRB, 0.26275332E-09_JPRB, 0.26274988E-09_JPRB, 0.26273841E-09_JPRB, 0.26272173E-09_JPRB, 0.26270203E-09_JPRB, &
  & 0.26268532E-09_JPRB, 0.26267646E-09_JPRB, 0.26267982E-09_JPRB, 0.26269145E-09_JPRB, 0.26271124E-09_JPRB, 0.26273969E-09_JPRB, &
  & 0.26277266E-09_JPRB, 0.26280961E-09_JPRB, 0.26284486E-09_JPRB, 0.26287761E-09_JPRB, 0.26290414E-09_JPRB, 0.26292590E-09_JPRB, &
  & 0.26294314E-09_JPRB, 0.26295341E-09_JPRB, 0.26295899E-09_JPRB, 0.26295788E-09_JPRB, 0.26295188E-09_JPRB, 0.26294006E-09_JPRB, &
  & 0.26292224E-09_JPRB, 0.26289942E-09_JPRB, 0.26287458E-09_JPRB, 0.26284747E-09_JPRB, 0.26282362E-09_JPRB, 0.26280547E-09_JPRB, &
  & 0.26279542E-09_JPRB, 0.26279334E-09_JPRB, 0.26279801E-09_JPRB, 0.26280794E-09_JPRB, 0.26281796E-09_JPRB, 0.26282806E-09_JPRB, &
  & 0.26283498E-09_JPRB, 0.26283820E-09_JPRB, 0.26283667E-09_JPRB, 0.26283414E-09_JPRB, 0.26282693E-09_JPRB, 0.26281802E-09_JPRB, &
  & 0.26280841E-09_JPRB, 0.26279848E-09_JPRB, 0.26278657E-09_JPRB, 0.26277458E-09_JPRB, 0.26276373E-09_JPRB, 0.26275060E-09_JPRB, &
  & 0.26273789E-09_JPRB, 0.26271979E-09_JPRB, 0.26268340E-09_JPRB, 0.26258462E-09_JPRB /)

RGHG5(:,77,11) = (/ &
  & 0.26267624E-09_JPRB, 0.26274438E-09_JPRB, 0.26276675E-09_JPRB, 0.26277650E-09_JPRB, 0.26278132E-09_JPRB, 0.26278640E-09_JPRB, &
  & 0.26279176E-09_JPRB, 0.26279715E-09_JPRB, 0.26280403E-09_JPRB, 0.26281044E-09_JPRB, 0.26281671E-09_JPRB, 0.26282235E-09_JPRB, &
  & 0.26282629E-09_JPRB, 0.26282793E-09_JPRB, 0.26282626E-09_JPRB, 0.26281721E-09_JPRB, 0.26280539E-09_JPRB, 0.26279051E-09_JPRB, &
  & 0.26277830E-09_JPRB, 0.26277178E-09_JPRB, 0.26277555E-09_JPRB, 0.26278368E-09_JPRB, 0.26279701E-09_JPRB, 0.26281696E-09_JPRB, &
  & 0.26284031E-09_JPRB, 0.26286665E-09_JPRB, 0.26289115E-09_JPRB, 0.26291416E-09_JPRB, 0.26293229E-09_JPRB, 0.26294786E-09_JPRB, &
  & 0.26296063E-09_JPRB, 0.26296768E-09_JPRB, 0.26297198E-09_JPRB, 0.26297101E-09_JPRB, 0.26296690E-09_JPRB, 0.26295843E-09_JPRB, &
  & 0.26294555E-09_JPRB, 0.26292946E-09_JPRB, 0.26291214E-09_JPRB, 0.26289257E-09_JPRB, 0.26287567E-09_JPRB, 0.26286254E-09_JPRB, &
  & 0.26285557E-09_JPRB, 0.26285410E-09_JPRB, 0.26285746E-09_JPRB, 0.26286492E-09_JPRB, 0.26287167E-09_JPRB, 0.26287925E-09_JPRB, &
  & 0.26288438E-09_JPRB, 0.26288707E-09_JPRB, 0.26288580E-09_JPRB, 0.26288538E-09_JPRB, 0.26287980E-09_JPRB, 0.26287256E-09_JPRB, &
  & 0.26286612E-09_JPRB, 0.26285904E-09_JPRB, 0.26285071E-09_JPRB, 0.26284291E-09_JPRB, 0.26283423E-09_JPRB, 0.26282523E-09_JPRB, &
  & 0.26281496E-09_JPRB, 0.26280197E-09_JPRB, 0.26277269E-09_JPRB, 0.26268854E-09_JPRB /)

RGHG5(:,78,11) = (/ &
  & 0.26277930E-09_JPRB, 0.26283348E-09_JPRB, 0.26284983E-09_JPRB, 0.26285668E-09_JPRB, 0.26285929E-09_JPRB, 0.26286320E-09_JPRB, &
  & 0.26286717E-09_JPRB, 0.26287081E-09_JPRB, 0.26287500E-09_JPRB, 0.26287883E-09_JPRB, 0.26288147E-09_JPRB, 0.26288505E-09_JPRB, &
  & 0.26288727E-09_JPRB, 0.26288843E-09_JPRB, 0.26288877E-09_JPRB, 0.26288227E-09_JPRB, 0.26287500E-09_JPRB, 0.26286481E-09_JPRB, &
  & 0.26285688E-09_JPRB, 0.26285277E-09_JPRB, 0.26285718E-09_JPRB, 0.26286245E-09_JPRB, 0.26286989E-09_JPRB, 0.26288269E-09_JPRB, &
  & 0.26289776E-09_JPRB, 0.26291483E-09_JPRB, 0.26293032E-09_JPRB, 0.26294497E-09_JPRB, 0.26295566E-09_JPRB, 0.26296607E-09_JPRB, &
  & 0.26297517E-09_JPRB, 0.26297947E-09_JPRB, 0.26298266E-09_JPRB, 0.26298183E-09_JPRB, 0.26297928E-09_JPRB, 0.26297381E-09_JPRB, &
  & 0.26296518E-09_JPRB, 0.26295502E-09_JPRB, 0.26294425E-09_JPRB, 0.26293134E-09_JPRB, 0.26292035E-09_JPRB, 0.26291161E-09_JPRB, &
  & 0.26290697E-09_JPRB, 0.26290597E-09_JPRB, 0.26290792E-09_JPRB, 0.26291325E-09_JPRB, 0.26291688E-09_JPRB, 0.26292227E-09_JPRB, &
  & 0.26292571E-09_JPRB, 0.26292779E-09_JPRB, 0.26292662E-09_JPRB, 0.26292810E-09_JPRB, 0.26292388E-09_JPRB, 0.26291816E-09_JPRB, &
  & 0.26291386E-09_JPRB, 0.26291008E-09_JPRB, 0.26290478E-09_JPRB, 0.26290015E-09_JPRB, 0.26289504E-09_JPRB, 0.26288799E-09_JPRB, &
  & 0.26288133E-09_JPRB, 0.26287242E-09_JPRB, 0.26285293E-09_JPRB, 0.26279029E-09_JPRB /)

RGHG5(:,79,11) = (/ &
  & 0.26284511E-09_JPRB, 0.26288333E-09_JPRB, 0.26289426E-09_JPRB, 0.26289843E-09_JPRB, 0.26289965E-09_JPRB, 0.26290289E-09_JPRB, &
  & 0.26290636E-09_JPRB, 0.26290881E-09_JPRB, 0.26291172E-09_JPRB, 0.26291405E-09_JPRB, 0.26291497E-09_JPRB, 0.26291741E-09_JPRB, &
  & 0.26291894E-09_JPRB, 0.26291991E-09_JPRB, 0.26292171E-09_JPRB, 0.26291630E-09_JPRB, 0.26291164E-09_JPRB, 0.26290375E-09_JPRB, &
  & 0.26289820E-09_JPRB, 0.26289559E-09_JPRB, 0.26290101E-09_JPRB, 0.26290481E-09_JPRB, 0.26290903E-09_JPRB, 0.26291797E-09_JPRB, &
  & 0.26292868E-09_JPRB, 0.26294089E-09_JPRB, 0.26295160E-09_JPRB, 0.26296174E-09_JPRB, 0.26296818E-09_JPRB, 0.26297581E-09_JPRB, &
  & 0.26298316E-09_JPRB, 0.26298594E-09_JPRB, 0.26298863E-09_JPRB, 0.26298788E-09_JPRB, 0.26298616E-09_JPRB, 0.26298219E-09_JPRB, &
  & 0.26297575E-09_JPRB, 0.26296884E-09_JPRB, 0.26296160E-09_JPRB, 0.26295210E-09_JPRB, 0.26294425E-09_JPRB, 0.26293764E-09_JPRB, &
  & 0.26293429E-09_JPRB, 0.26293340E-09_JPRB, 0.26293459E-09_JPRB, 0.26293889E-09_JPRB, 0.26294067E-09_JPRB, 0.26294500E-09_JPRB, &
  & 0.26294750E-09_JPRB, 0.26294936E-09_JPRB, 0.26294808E-09_JPRB, 0.26295074E-09_JPRB, 0.26294708E-09_JPRB, 0.26294175E-09_JPRB, &
  & 0.26293881E-09_JPRB, 0.26293659E-09_JPRB, 0.26293287E-09_JPRB, 0.26293012E-09_JPRB, 0.26292629E-09_JPRB, 0.26292069E-09_JPRB, &
  & 0.26291533E-09_JPRB, 0.26290992E-09_JPRB, 0.26289759E-09_JPRB, 0.26285590E-09_JPRB /)

RGHG5(:,80,11) = (/ &
  & 0.26288843E-09_JPRB, 0.26290725E-09_JPRB, 0.26291375E-09_JPRB, 0.26291658E-09_JPRB, 0.26291697E-09_JPRB, 0.26291999E-09_JPRB, &
  & 0.26292329E-09_JPRB, 0.26292513E-09_JPRB, 0.26292768E-09_JPRB, 0.26292932E-09_JPRB, 0.26292948E-09_JPRB, 0.26293151E-09_JPRB, &
  & 0.26293284E-09_JPRB, 0.26293379E-09_JPRB, 0.26293645E-09_JPRB, 0.26293143E-09_JPRB, 0.26292790E-09_JPRB, 0.26292096E-09_JPRB, &
  & 0.26291644E-09_JPRB, 0.26291461E-09_JPRB, 0.26292080E-09_JPRB, 0.26292396E-09_JPRB, 0.26292665E-09_JPRB, 0.26293390E-09_JPRB, &
  & 0.26294272E-09_JPRB, 0.26295283E-09_JPRB, 0.26296129E-09_JPRB, 0.26296931E-09_JPRB, 0.26297373E-09_JPRB, 0.26298022E-09_JPRB, &
  & 0.26298688E-09_JPRB, 0.26298896E-09_JPRB, 0.26299149E-09_JPRB, 0.26299071E-09_JPRB, 0.26298941E-09_JPRB, 0.26298613E-09_JPRB, &
  & 0.26298055E-09_JPRB, 0.26297514E-09_JPRB, 0.26296954E-09_JPRB, 0.26296149E-09_JPRB, 0.26295494E-09_JPRB, 0.26294927E-09_JPRB, &
  & 0.26294647E-09_JPRB, 0.26294564E-09_JPRB, 0.26294644E-09_JPRB, 0.26295033E-09_JPRB, 0.26295113E-09_JPRB, 0.26295496E-09_JPRB, &
  & 0.26295710E-09_JPRB, 0.26295890E-09_JPRB, 0.26295743E-09_JPRB, 0.26296088E-09_JPRB, 0.26295729E-09_JPRB, 0.26295194E-09_JPRB, &
  & 0.26294950E-09_JPRB, 0.26294805E-09_JPRB, 0.26294494E-09_JPRB, 0.26294306E-09_JPRB, 0.26293989E-09_JPRB, 0.26293448E-09_JPRB, &
  & 0.26293001E-09_JPRB, 0.26292618E-09_JPRB, 0.26291910E-09_JPRB, 0.26289937E-09_JPRB /)

RGHG5(:,81,11) = (/ &
  & 0.26291763E-09_JPRB, 0.26291744E-09_JPRB, 0.26292202E-09_JPRB, 0.26292432E-09_JPRB, 0.26292435E-09_JPRB, 0.26292732E-09_JPRB, &
  & 0.26293048E-09_JPRB, 0.26293220E-09_JPRB, 0.26293431E-09_JPRB, 0.26293603E-09_JPRB, 0.26293570E-09_JPRB, 0.26293767E-09_JPRB, &
  & 0.26293895E-09_JPRB, 0.26293989E-09_JPRB, 0.26294295E-09_JPRB, 0.26293803E-09_JPRB, 0.26293509E-09_JPRB, 0.26292840E-09_JPRB, &
  & 0.26292429E-09_JPRB, 0.26292277E-09_JPRB, 0.26292959E-09_JPRB, 0.26293237E-09_JPRB, 0.26293448E-09_JPRB, 0.26294095E-09_JPRB, &
  & 0.26294891E-09_JPRB, 0.26295804E-09_JPRB, 0.26296554E-09_JPRB, 0.26297270E-09_JPRB, 0.26297617E-09_JPRB, 0.26298214E-09_JPRB, &
  & 0.26298858E-09_JPRB, 0.26299030E-09_JPRB, 0.26299282E-09_JPRB, 0.26299204E-09_JPRB, 0.26299088E-09_JPRB, 0.26298785E-09_JPRB, &
  & 0.26298269E-09_JPRB, 0.26297789E-09_JPRB, 0.26297306E-09_JPRB, 0.26296570E-09_JPRB, 0.26295971E-09_JPRB, 0.26295441E-09_JPRB, &
  & 0.26295177E-09_JPRB, 0.26295094E-09_JPRB, 0.26295155E-09_JPRB, 0.26295535E-09_JPRB, 0.26295566E-09_JPRB, 0.26295929E-09_JPRB, &
  & 0.26296126E-09_JPRB, 0.26296304E-09_JPRB, 0.26296143E-09_JPRB, 0.26296537E-09_JPRB, 0.26296179E-09_JPRB, 0.26295624E-09_JPRB, &
  & 0.26295408E-09_JPRB, 0.26295299E-09_JPRB, 0.26295019E-09_JPRB, 0.26294866E-09_JPRB, 0.26294575E-09_JPRB, 0.26294045E-09_JPRB, &
  & 0.26293617E-09_JPRB, 0.26293301E-09_JPRB, 0.26292818E-09_JPRB, 0.26292937E-09_JPRB /)

RGHG5(:,82,11) = (/ &
  & 0.26292002E-09_JPRB, 0.26292082E-09_JPRB, 0.26292568E-09_JPRB, 0.26292798E-09_JPRB, 0.26292790E-09_JPRB, 0.26293082E-09_JPRB, &
  & 0.26293406E-09_JPRB, 0.26293551E-09_JPRB, 0.26293778E-09_JPRB, 0.26293923E-09_JPRB, 0.26293887E-09_JPRB, 0.26294070E-09_JPRB, &
  & 0.26294189E-09_JPRB, 0.26294286E-09_JPRB, 0.26294622E-09_JPRB, 0.26294131E-09_JPRB, 0.26293864E-09_JPRB, 0.26293201E-09_JPRB, &
  & 0.26292812E-09_JPRB, 0.26292676E-09_JPRB, 0.26293373E-09_JPRB, 0.26293656E-09_JPRB, 0.26293823E-09_JPRB, 0.26294439E-09_JPRB, &
  & 0.26295199E-09_JPRB, 0.26296068E-09_JPRB, 0.26296770E-09_JPRB, 0.26297436E-09_JPRB, 0.26297728E-09_JPRB, 0.26298300E-09_JPRB, &
  & 0.26298935E-09_JPRB, 0.26299099E-09_JPRB, 0.26299357E-09_JPRB, 0.26299268E-09_JPRB, 0.26299157E-09_JPRB, 0.26298869E-09_JPRB, &
  & 0.26298375E-09_JPRB, 0.26297928E-09_JPRB, 0.26297484E-09_JPRB, 0.26296784E-09_JPRB, 0.26296207E-09_JPRB, 0.26295685E-09_JPRB, &
  & 0.26295438E-09_JPRB, 0.26295355E-09_JPRB, 0.26295410E-09_JPRB, 0.26295782E-09_JPRB, 0.26295782E-09_JPRB, 0.26296137E-09_JPRB, &
  & 0.26296321E-09_JPRB, 0.26296504E-09_JPRB, 0.26296335E-09_JPRB, 0.26296765E-09_JPRB, 0.26296401E-09_JPRB, 0.26295832E-09_JPRB, &
  & 0.26295624E-09_JPRB, 0.26295538E-09_JPRB, 0.26295272E-09_JPRB, 0.26295141E-09_JPRB, 0.26294861E-09_JPRB, 0.26294333E-09_JPRB, &
  & 0.26293909E-09_JPRB, 0.26293601E-09_JPRB, 0.26293118E-09_JPRB, 0.26293173E-09_JPRB /)

RGHG5(:,83,11) = (/ &
  & 0.26292157E-09_JPRB, 0.26292277E-09_JPRB, 0.26292776E-09_JPRB, 0.26293009E-09_JPRB, 0.26292990E-09_JPRB, 0.26293279E-09_JPRB, &
  & 0.26293598E-09_JPRB, 0.26293751E-09_JPRB, 0.26293953E-09_JPRB, 0.26294100E-09_JPRB, 0.26294056E-09_JPRB, 0.26294239E-09_JPRB, &
  & 0.26294356E-09_JPRB, 0.26294453E-09_JPRB, 0.26294808E-09_JPRB, 0.26294317E-09_JPRB, 0.26294059E-09_JPRB, 0.26293401E-09_JPRB, &
  & 0.26293018E-09_JPRB, 0.26292887E-09_JPRB, 0.26293634E-09_JPRB, 0.26293895E-09_JPRB, 0.26294034E-09_JPRB, 0.26294628E-09_JPRB, &
  & 0.26295371E-09_JPRB, 0.26296215E-09_JPRB, 0.26296890E-09_JPRB, 0.26297531E-09_JPRB, 0.26297792E-09_JPRB, 0.26298347E-09_JPRB, &
  & 0.26298988E-09_JPRB, 0.26299138E-09_JPRB, 0.26299399E-09_JPRB, 0.26299307E-09_JPRB, 0.26299196E-09_JPRB, 0.26298907E-09_JPRB, &
  & 0.26298430E-09_JPRB, 0.26298000E-09_JPRB, 0.26297575E-09_JPRB, 0.26296915E-09_JPRB, 0.26296337E-09_JPRB, 0.26295838E-09_JPRB, &
  & 0.26295585E-09_JPRB, 0.26295494E-09_JPRB, 0.26295541E-09_JPRB, 0.26295924E-09_JPRB, 0.26295896E-09_JPRB, 0.26296254E-09_JPRB, &
  & 0.26296429E-09_JPRB, 0.26296620E-09_JPRB, 0.26296443E-09_JPRB, 0.26296895E-09_JPRB, 0.26296526E-09_JPRB, 0.26295952E-09_JPRB, &
  & 0.26295746E-09_JPRB, 0.26295666E-09_JPRB, 0.26295416E-09_JPRB, 0.26295299E-09_JPRB, 0.26295024E-09_JPRB, 0.26294494E-09_JPRB, &
  & 0.26294072E-09_JPRB, 0.26293764E-09_JPRB, 0.26293287E-09_JPRB, 0.26293343E-09_JPRB /)

RGHG5(:,84,11) = (/ &
  & 0.26292263E-09_JPRB, 0.26292402E-09_JPRB, 0.26292910E-09_JPRB, 0.26293137E-09_JPRB, 0.26293115E-09_JPRB, 0.26293409E-09_JPRB, &
  & 0.26293726E-09_JPRB, 0.26293873E-09_JPRB, 0.26294075E-09_JPRB, 0.26294197E-09_JPRB, 0.26294170E-09_JPRB, 0.26294328E-09_JPRB, &
  & 0.26294456E-09_JPRB, 0.26294553E-09_JPRB, 0.26294911E-09_JPRB, 0.26294439E-09_JPRB, 0.26294192E-09_JPRB, 0.26293526E-09_JPRB, &
  & 0.26293148E-09_JPRB, 0.26293026E-09_JPRB, 0.26293775E-09_JPRB, 0.26294039E-09_JPRB, 0.26294161E-09_JPRB, 0.26294747E-09_JPRB, &
  & 0.26295477E-09_JPRB, 0.26296315E-09_JPRB, 0.26296967E-09_JPRB, 0.26297589E-09_JPRB, 0.26297825E-09_JPRB, 0.26298372E-09_JPRB, &
  & 0.26299016E-09_JPRB, 0.26299160E-09_JPRB, 0.26299427E-09_JPRB, 0.26299335E-09_JPRB, 0.26299218E-09_JPRB, 0.26298932E-09_JPRB, &
  & 0.26298466E-09_JPRB, 0.26298053E-09_JPRB, 0.26297639E-09_JPRB, 0.26296990E-09_JPRB, 0.26296440E-09_JPRB, 0.26295921E-09_JPRB, &
  & 0.26295680E-09_JPRB, 0.26295582E-09_JPRB, 0.26295621E-09_JPRB, 0.26296010E-09_JPRB, 0.26295971E-09_JPRB, 0.26296321E-09_JPRB, &
  & 0.26296496E-09_JPRB, 0.26296693E-09_JPRB, 0.26296512E-09_JPRB, 0.26296981E-09_JPRB, 0.26296607E-09_JPRB, 0.26296021E-09_JPRB, &
  & 0.26295821E-09_JPRB, 0.26295743E-09_JPRB, 0.26295502E-09_JPRB, 0.26295396E-09_JPRB, 0.26295127E-09_JPRB, 0.26294592E-09_JPRB, &
  & 0.26294170E-09_JPRB, 0.26293873E-09_JPRB, 0.26293401E-09_JPRB, 0.26293459E-09_JPRB /)

RGHG5(:,85,11) = (/ &
  & 0.26292329E-09_JPRB, 0.26292479E-09_JPRB, 0.26292990E-09_JPRB, 0.26293229E-09_JPRB, 0.26293195E-09_JPRB, 0.26293503E-09_JPRB, &
  & 0.26293809E-09_JPRB, 0.26293973E-09_JPRB, 0.26294142E-09_JPRB, 0.26294258E-09_JPRB, 0.26294261E-09_JPRB, 0.26294397E-09_JPRB, &
  & 0.26294511E-09_JPRB, 0.26294628E-09_JPRB, 0.26294930E-09_JPRB, 0.26294522E-09_JPRB, 0.26294267E-09_JPRB, 0.26293615E-09_JPRB, &
  & 0.26293234E-09_JPRB, 0.26293104E-09_JPRB, 0.26293889E-09_JPRB, 0.26294136E-09_JPRB, 0.26294228E-09_JPRB, 0.26294811E-09_JPRB, &
  & 0.26295546E-09_JPRB, 0.26296382E-09_JPRB, 0.26297020E-09_JPRB, 0.26297631E-09_JPRB, 0.26297844E-09_JPRB, 0.26298388E-09_JPRB, &
  & 0.26299038E-09_JPRB, 0.26299182E-09_JPRB, 0.26299446E-09_JPRB, 0.26299352E-09_JPRB, 0.26299232E-09_JPRB, 0.26298949E-09_JPRB, &
  & 0.26298491E-09_JPRB, 0.26298086E-09_JPRB, 0.26297681E-09_JPRB, 0.26297062E-09_JPRB, 0.26296479E-09_JPRB, 0.26295982E-09_JPRB, &
  & 0.26295727E-09_JPRB, 0.26295632E-09_JPRB, 0.26295677E-09_JPRB, 0.26296074E-09_JPRB, 0.26296013E-09_JPRB, 0.26296365E-09_JPRB, &
  & 0.26296532E-09_JPRB, 0.26296734E-09_JPRB, 0.26296554E-09_JPRB, 0.26297048E-09_JPRB, 0.26296662E-09_JPRB, 0.26296068E-09_JPRB, &
  & 0.26295871E-09_JPRB, 0.26295793E-09_JPRB, 0.26295560E-09_JPRB, 0.26295463E-09_JPRB, 0.26295199E-09_JPRB, 0.26294655E-09_JPRB, &
  & 0.26294236E-09_JPRB, 0.26293942E-09_JPRB, 0.26293470E-09_JPRB, 0.26293542E-09_JPRB /)

RGHG5(:,86,11) = (/ &
  & 0.26292366E-09_JPRB, 0.26292526E-09_JPRB, 0.26293054E-09_JPRB, 0.26293290E-09_JPRB, 0.26293256E-09_JPRB, 0.26293556E-09_JPRB, &
  & 0.26293892E-09_JPRB, 0.26294034E-09_JPRB, 0.26294203E-09_JPRB, 0.26294292E-09_JPRB, 0.26294322E-09_JPRB, 0.26294431E-09_JPRB, &
  & 0.26294544E-09_JPRB, 0.26294658E-09_JPRB, 0.26294891E-09_JPRB, 0.26294572E-09_JPRB, 0.26294314E-09_JPRB, 0.26293692E-09_JPRB, &
  & 0.26293306E-09_JPRB, 0.26293162E-09_JPRB, 0.26293953E-09_JPRB, 0.26294203E-09_JPRB, 0.26294261E-09_JPRB, 0.26294847E-09_JPRB, &
  & 0.26295585E-09_JPRB, 0.26296434E-09_JPRB, 0.26297059E-09_JPRB, 0.26297670E-09_JPRB, 0.26297856E-09_JPRB, 0.26298402E-09_JPRB, &
  & 0.26299052E-09_JPRB, 0.26299193E-09_JPRB, 0.26299463E-09_JPRB, 0.26299360E-09_JPRB, 0.26299241E-09_JPRB, 0.26298963E-09_JPRB, &
  & 0.26298508E-09_JPRB, 0.26298108E-09_JPRB, 0.26297722E-09_JPRB, 0.26297081E-09_JPRB, 0.26296523E-09_JPRB, 0.26295990E-09_JPRB, &
  & 0.26295760E-09_JPRB, 0.26295666E-09_JPRB, 0.26295705E-09_JPRB, 0.26296115E-09_JPRB, 0.26296043E-09_JPRB, 0.26296393E-09_JPRB, &
  & 0.26296554E-09_JPRB, 0.26296768E-09_JPRB, 0.26296579E-09_JPRB, 0.26297090E-09_JPRB, 0.26296698E-09_JPRB, 0.26296099E-09_JPRB, &
  & 0.26295902E-09_JPRB, 0.26295827E-09_JPRB, 0.26295596E-09_JPRB, 0.26295502E-09_JPRB, 0.26295241E-09_JPRB, 0.26294697E-09_JPRB, &
  & 0.26294281E-09_JPRB, 0.26293986E-09_JPRB, 0.26293509E-09_JPRB, 0.26293598E-09_JPRB /)

RGHG5(:,87,11) = (/ &
  & 0.26292388E-09_JPRB, 0.26292554E-09_JPRB, 0.26293082E-09_JPRB, 0.26293320E-09_JPRB, 0.26293287E-09_JPRB, 0.26293656E-09_JPRB, &
  & 0.26293917E-09_JPRB, 0.26294100E-09_JPRB, 0.26294228E-09_JPRB, 0.26294319E-09_JPRB, 0.26294367E-09_JPRB, 0.26294467E-09_JPRB, &
  & 0.26294567E-09_JPRB, 0.26294678E-09_JPRB, 0.26294852E-09_JPRB, 0.26294589E-09_JPRB, 0.26294336E-09_JPRB, 0.26293737E-09_JPRB, &
  & 0.26293359E-09_JPRB, 0.26293207E-09_JPRB, 0.26293986E-09_JPRB, 0.26294242E-09_JPRB, 0.26294275E-09_JPRB, 0.26294861E-09_JPRB, &
  & 0.26295610E-09_JPRB, 0.26296471E-09_JPRB, 0.26297084E-09_JPRB, 0.26297697E-09_JPRB, 0.26297861E-09_JPRB, 0.26298405E-09_JPRB, &
  & 0.26299074E-09_JPRB, 0.26299204E-09_JPRB, 0.26299479E-09_JPRB, 0.26299374E-09_JPRB, 0.26299252E-09_JPRB, 0.26298974E-09_JPRB, &
  & 0.26298524E-09_JPRB, 0.26298130E-09_JPRB, 0.26297758E-09_JPRB, 0.26297120E-09_JPRB, 0.26296526E-09_JPRB, 0.26296001E-09_JPRB, &
  & 0.26295771E-09_JPRB, 0.26295680E-09_JPRB, 0.26295721E-09_JPRB, 0.26296137E-09_JPRB, 0.26296054E-09_JPRB, 0.26296412E-09_JPRB, &
  & 0.26296568E-09_JPRB, 0.26296787E-09_JPRB, 0.26296595E-09_JPRB, 0.26297120E-09_JPRB, 0.26296720E-09_JPRB, 0.26296107E-09_JPRB, &
  & 0.26295921E-09_JPRB, 0.26295841E-09_JPRB, 0.26295618E-09_JPRB, 0.26295527E-09_JPRB, 0.26295263E-09_JPRB, 0.26294728E-09_JPRB, &
  & 0.26294306E-09_JPRB, 0.26294014E-09_JPRB, 0.26293537E-09_JPRB, 0.26293637E-09_JPRB /)

RGHG5(:,88,11) = (/ &
  & 0.26292407E-09_JPRB, 0.26292576E-09_JPRB, 0.26293107E-09_JPRB, 0.26293348E-09_JPRB, 0.26293331E-09_JPRB, 0.26293634E-09_JPRB, &
  & 0.26293973E-09_JPRB, 0.26294111E-09_JPRB, 0.26294258E-09_JPRB, 0.26294336E-09_JPRB, 0.26294381E-09_JPRB, 0.26294472E-09_JPRB, &
  & 0.26294575E-09_JPRB, 0.26294675E-09_JPRB, 0.26294841E-09_JPRB, 0.26294605E-09_JPRB, 0.26294350E-09_JPRB, 0.26293778E-09_JPRB, &
  & 0.26293379E-09_JPRB, 0.26293220E-09_JPRB, 0.26294020E-09_JPRB, 0.26294278E-09_JPRB, 0.26294278E-09_JPRB, 0.26294861E-09_JPRB, &
  & 0.26295616E-09_JPRB, 0.26296504E-09_JPRB, 0.26297098E-09_JPRB, 0.26297725E-09_JPRB, 0.26297858E-09_JPRB, 0.26298405E-09_JPRB, &
  & 0.26299085E-09_JPRB, 0.26299210E-09_JPRB, 0.26299485E-09_JPRB, 0.26299379E-09_JPRB, 0.26299260E-09_JPRB, 0.26298988E-09_JPRB, &
  & 0.26298533E-09_JPRB, 0.26298144E-09_JPRB, 0.26297778E-09_JPRB, 0.26297120E-09_JPRB, 0.26296534E-09_JPRB, 0.26295990E-09_JPRB, &
  & 0.26295777E-09_JPRB, 0.26295682E-09_JPRB, 0.26295727E-09_JPRB, 0.26296154E-09_JPRB, 0.26296057E-09_JPRB, 0.26296418E-09_JPRB, &
  & 0.26296573E-09_JPRB, 0.26296795E-09_JPRB, 0.26296604E-09_JPRB, 0.26297142E-09_JPRB, 0.26296731E-09_JPRB, 0.26296115E-09_JPRB, &
  & 0.26295929E-09_JPRB, 0.26295854E-09_JPRB, 0.26295635E-09_JPRB, 0.26295544E-09_JPRB, 0.26295280E-09_JPRB, 0.26294739E-09_JPRB, &
  & 0.26294322E-09_JPRB, 0.26294031E-09_JPRB, 0.26293551E-09_JPRB, 0.26293662E-09_JPRB /)

RGHG5(:,89,11) = (/ &
  & 0.26292418E-09_JPRB, 0.26292593E-09_JPRB, 0.26293118E-09_JPRB, 0.26293354E-09_JPRB, 0.26293304E-09_JPRB, 0.26293684E-09_JPRB, &
  & 0.26293942E-09_JPRB, 0.26294128E-09_JPRB, 0.26294256E-09_JPRB, 0.26294342E-09_JPRB, 0.26294381E-09_JPRB, 0.26294480E-09_JPRB, &
  & 0.26294583E-09_JPRB, 0.26294694E-09_JPRB, 0.26294880E-09_JPRB, 0.26294616E-09_JPRB, 0.26294369E-09_JPRB, 0.26293764E-09_JPRB, &
  & 0.26293381E-09_JPRB, 0.26293218E-09_JPRB, 0.26294028E-09_JPRB, 0.26294297E-09_JPRB, 0.26294272E-09_JPRB, 0.26294861E-09_JPRB, &
  & 0.26295621E-09_JPRB, 0.26296523E-09_JPRB, 0.26297109E-09_JPRB, 0.26297731E-09_JPRB, 0.26297850E-09_JPRB, 0.26298405E-09_JPRB, &
  & 0.26299096E-09_JPRB, 0.26299216E-09_JPRB, 0.26299504E-09_JPRB, 0.26299382E-09_JPRB, 0.26299268E-09_JPRB, 0.26298994E-09_JPRB, &
  & 0.26298536E-09_JPRB, 0.26298139E-09_JPRB, 0.26297792E-09_JPRB, 0.26297126E-09_JPRB, 0.26296532E-09_JPRB, 0.26295988E-09_JPRB, &
  & 0.26295782E-09_JPRB, 0.26295685E-09_JPRB, 0.26295727E-09_JPRB, 0.26296168E-09_JPRB, 0.26296060E-09_JPRB, 0.26296423E-09_JPRB, &
  & 0.26296570E-09_JPRB, 0.26296804E-09_JPRB, 0.26296601E-09_JPRB, 0.26297167E-09_JPRB, 0.26296743E-09_JPRB, 0.26296118E-09_JPRB, &
  & 0.26295935E-09_JPRB, 0.26295857E-09_JPRB, 0.26295643E-09_JPRB, 0.26295555E-09_JPRB, 0.26295291E-09_JPRB, 0.26294750E-09_JPRB, &
  & 0.26294333E-09_JPRB, 0.26294042E-09_JPRB, 0.26293551E-09_JPRB, 0.26293676E-09_JPRB /)

RGHG5(:,90,11) = (/ &
  & 0.26292429E-09_JPRB, 0.26292596E-09_JPRB, 0.26293120E-09_JPRB, 0.26293362E-09_JPRB, 0.26293293E-09_JPRB, 0.26293612E-09_JPRB, &
  & 0.26293961E-09_JPRB, 0.26294100E-09_JPRB, 0.26294267E-09_JPRB, 0.26294347E-09_JPRB, 0.26294372E-09_JPRB, 0.26294480E-09_JPRB, &
  & 0.26294603E-09_JPRB, 0.26294719E-09_JPRB, 0.26294983E-09_JPRB, 0.26294639E-09_JPRB, 0.26294394E-09_JPRB, 0.26293739E-09_JPRB, &
  & 0.26293348E-09_JPRB, 0.26293173E-09_JPRB, 0.26294056E-09_JPRB, 0.26294317E-09_JPRB, 0.26294261E-09_JPRB, 0.26294858E-09_JPRB, &
  & 0.26295621E-09_JPRB, 0.26296543E-09_JPRB, 0.26297112E-09_JPRB, 0.26297753E-09_JPRB, 0.26297836E-09_JPRB, 0.26298400E-09_JPRB, &
  & 0.26299118E-09_JPRB, 0.26299213E-09_JPRB, 0.26299524E-09_JPRB, 0.26299388E-09_JPRB, 0.26299277E-09_JPRB, 0.26299010E-09_JPRB, &
  & 0.26298544E-09_JPRB, 0.26298139E-09_JPRB, 0.26297808E-09_JPRB, 0.26297126E-09_JPRB, 0.26296529E-09_JPRB, 0.26295977E-09_JPRB, &
  & 0.26295782E-09_JPRB, 0.26295685E-09_JPRB, 0.26295718E-09_JPRB, 0.26296187E-09_JPRB, 0.26296051E-09_JPRB, 0.26296432E-09_JPRB, &
  & 0.26296573E-09_JPRB, 0.26296818E-09_JPRB, 0.26296584E-09_JPRB, 0.26297201E-09_JPRB, 0.26296751E-09_JPRB, 0.26296110E-09_JPRB, &
  & 0.26295935E-09_JPRB, 0.26295860E-09_JPRB, 0.26295643E-09_JPRB, 0.26295563E-09_JPRB, 0.26295305E-09_JPRB, 0.26294744E-09_JPRB, &
  & 0.26294328E-09_JPRB, 0.26294047E-09_JPRB, 0.26293545E-09_JPRB, 0.26293689E-09_JPRB /)

RGHG5(:,91,11) = (/ &
  & 0.26292435E-09_JPRB, 0.26292563E-09_JPRB, 0.26293118E-09_JPRB, 0.26293387E-09_JPRB, 0.26293234E-09_JPRB, 0.26293590E-09_JPRB, &
  & 0.26293939E-09_JPRB, 0.26294056E-09_JPRB, 0.26294286E-09_JPRB, 0.26294400E-09_JPRB, 0.26294272E-09_JPRB, 0.26294483E-09_JPRB, &
  & 0.26294622E-09_JPRB, 0.26294666E-09_JPRB, 0.26295241E-09_JPRB, 0.26294592E-09_JPRB, 0.26294461E-09_JPRB, 0.26293678E-09_JPRB, &
  & 0.26293315E-09_JPRB, 0.26293090E-09_JPRB, 0.26294106E-09_JPRB, 0.26294342E-09_JPRB, 0.26294220E-09_JPRB, 0.26294847E-09_JPRB, &
  & 0.26295613E-09_JPRB, 0.26296568E-09_JPRB, 0.26297114E-09_JPRB, 0.26297789E-09_JPRB, 0.26297803E-09_JPRB, 0.26298386E-09_JPRB, &
  & 0.26299166E-09_JPRB, 0.26299199E-09_JPRB, 0.26299565E-09_JPRB, 0.26299388E-09_JPRB, 0.26299293E-09_JPRB, 0.26299038E-09_JPRB, &
  & 0.26298530E-09_JPRB, 0.26298125E-09_JPRB, 0.26297831E-09_JPRB, 0.26297117E-09_JPRB, 0.26296521E-09_JPRB, 0.26295952E-09_JPRB, &
  & 0.26295774E-09_JPRB, 0.26295668E-09_JPRB, 0.26295691E-09_JPRB, 0.26296229E-09_JPRB, 0.26296021E-09_JPRB, 0.26296448E-09_JPRB, &
  & 0.26296568E-09_JPRB, 0.26296851E-09_JPRB, 0.26296529E-09_JPRB, 0.26297273E-09_JPRB, 0.26296765E-09_JPRB, 0.26296076E-09_JPRB, &
  & 0.26295929E-09_JPRB, 0.26295874E-09_JPRB, 0.26295632E-09_JPRB, 0.26295571E-09_JPRB, 0.26295319E-09_JPRB, 0.26294725E-09_JPRB, &
  & 0.26294314E-09_JPRB, 0.26294039E-09_JPRB, 0.26293512E-09_JPRB, 0.26293692E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART22',1,ZHOOK_HANDLE)
END SUBROUTINE PART22






SUBROUTINE PART23
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART23',0,ZHOOK_HANDLE)



!-- Month= 12 ------------

RGHG5(:, 1,12) = (/ &
  & 0.00000000E+00_JPRB, 0.12611686E-43_JPRB, 0.12611686E-43_JPRB, 0.84077908E-44_JPRB, 0.56051939E-44_JPRB, 0.42038954E-44_JPRB, &
  & 0.42038954E-44_JPRB, 0.42038954E-44_JPRB, 0.70064923E-44_JPRB, 0.14012985E-43_JPRB, 0.25223372E-43_JPRB, 0.54650640E-43_JPRB, &
  & 0.11070258E-42_JPRB, 0.21439867E-42_JPRB, 0.40077136E-42_JPRB, 0.13340361E-41_JPRB, 0.31669345E-41_JPRB, 0.86249920E-41_JPRB, &
  & 0.19287472E-40_JPRB, 0.33786707E-40_JPRB, 0.75338009E-40_JPRB, 0.18019297E-39_JPRB, 0.33227169E-39_JPRB, 0.56770945E-39_JPRB, &
  & 0.71063348E-39_JPRB, 0.73164736E-39_JPRB, 0.11170899E-38_JPRB, 0.82543346E-39_JPRB, 0.19817583E-38_JPRB, 0.20454193E-38_JPRB, &
  & 0.19207024E-38_JPRB, 0.16691384E-38_JPRB, 0.88637032E-39_JPRB, 0.56887112E-39_JPRB, 0.32812945E-39_JPRB, 0.20619126E-39_JPRB, &
  & 0.12687777E-39_JPRB, 0.85034995E-40_JPRB, 0.58116051E-40_JPRB, 0.40531157E-40_JPRB, 0.28512220E-40_JPRB, 0.20021752E-40_JPRB, &
  & 0.13882664E-40_JPRB, 0.93172335E-41_JPRB, 0.60367938E-41_JPRB, 0.37863085E-41_JPRB, 0.22827152E-41_JPRB, 0.13228258E-41_JPRB, &
  & 0.75810247E-42_JPRB, 0.42739603E-42_JPRB, 0.24382593E-42_JPRB, 0.14012985E-42_JPRB, 0.82676609E-43_JPRB, 0.50446745E-43_JPRB, &
  & 0.33631163E-43_JPRB, 0.25223372E-43_JPRB, 0.19618179E-43_JPRB, 0.15414283E-43_JPRB, 0.14012985E-43_JPRB, 0.12611686E-43_JPRB, &
  & 0.98090893E-44_JPRB, 0.84077908E-44_JPRB, 0.70064923E-44_JPRB, 0.56051939E-44_JPRB /)

RGHG5(:, 2,12) = (/ &
  & 0.58854536E-43_JPRB, 0.47644148E-42_JPRB, 0.48765187E-42_JPRB, 0.35592981E-42_JPRB, 0.24522723E-42_JPRB, 0.18917529E-42_JPRB, &
  & 0.18076750E-42_JPRB, 0.22280646E-42_JPRB, 0.34471942E-42_JPRB, 0.61236743E-42_JPRB, 0.11532686E-41_JPRB, 0.23275567E-41_JPRB, &
  & 0.46116732E-41_JPRB, 0.90369738E-41_JPRB, 0.18612046E-40_JPRB, 0.56962783E-40_JPRB, 0.13807134E-39_JPRB, 0.36318713E-39_JPRB, &
  & 0.79985416E-39_JPRB, 0.14514229E-38_JPRB, 0.31716751E-38_JPRB, 0.72799627E-38_JPRB, 0.13290959E-37_JPRB, 0.22433328E-37_JPRB, &
  & 0.28223087E-37_JPRB, 0.29865818E-37_JPRB, 0.43076094E-37_JPRB, 0.38027709E-37_JPRB, 0.75805852E-37_JPRB, 0.80958091E-37_JPRB, &
  & 0.76362207E-37_JPRB, 0.65124735E-37_JPRB, 0.37056637E-37_JPRB, 0.23158523E-37_JPRB, 0.13510726E-37_JPRB, 0.83654968E-38_JPRB, &
  & 0.51863359E-38_JPRB, 0.34392264E-38_JPRB, 0.23594419E-38_JPRB, 0.16504115E-38_JPRB, 0.11606885E-38_JPRB, 0.81667815E-39_JPRB, &
  & 0.56769824E-39_JPRB, 0.38438598E-39_JPRB, 0.25252379E-39_JPRB, 0.16131748E-39_JPRB, 0.99786464E-40_JPRB, 0.59790603E-40_JPRB, &
  & 0.35312721E-40_JPRB, 0.20544437E-40_JPRB, 0.11965688E-40_JPRB, 0.70205053E-41_JPRB, 0.41996915E-41_JPRB, 0.25966061E-41_JPRB, &
  & 0.16857621E-41_JPRB, 0.11658803E-41_JPRB, 0.86460115E-42_JPRB, 0.68803755E-42_JPRB, 0.58013756E-42_JPRB, 0.51007264E-42_JPRB, &
  & 0.45402070E-42_JPRB, 0.39516617E-42_JPRB, 0.32229865E-42_JPRB, 0.24802983E-42_JPRB /)

RGHG5(:, 3,12) = (/ &
  & 0.50376680E-41_JPRB, 0.28100238E-40_JPRB, 0.24843620E-40_JPRB, 0.17572283E-40_JPRB, 0.12132442E-40_JPRB, 0.95218231E-41_JPRB, &
  & 0.92583790E-41_JPRB, 0.11546699E-40_JPRB, 0.17795089E-40_JPRB, 0.30755699E-40_JPRB, 0.58100637E-40_JPRB, 0.11412735E-39_JPRB, &
  & 0.22667264E-39_JPRB, 0.44427327E-39_JPRB, 0.92847794E-39_JPRB, 0.27275322E-38_JPRB, 0.64950856E-38_JPRB, 0.16752391E-37_JPRB, &
  & 0.36331689E-37_JPRB, 0.63152464E-37_JPRB, 0.13745332E-36_JPRB, 0.33117003E-36_JPRB, 0.62051971E-36_JPRB, 0.10872799E-35_JPRB, &
  & 0.13679558E-35_JPRB, 0.14284142E-35_JPRB, 0.20745766E-35_JPRB, 0.18730350E-35_JPRB, 0.35971386E-35_JPRB, 0.38592705E-35_JPRB, &
  & 0.36425143E-35_JPRB, 0.30907573E-35_JPRB, 0.17902774E-35_JPRB, 0.11118100E-35_JPRB, 0.64919248E-36_JPRB, 0.39975803E-36_JPRB, &
  & 0.24801236E-36_JPRB, 0.16416225E-36_JPRB, 0.11294908E-36_JPRB, 0.79152607E-37_JPRB, 0.55866793E-37_JPRB, 0.39303331E-37_JPRB, &
  & 0.27394757E-37_JPRB, 0.18604261E-37_JPRB, 0.12296959E-37_JPRB, 0.79232988E-38_JPRB, 0.49565790E-38_JPRB, 0.30077120E-38_JPRB, &
  & 0.17941623E-38_JPRB, 0.10492432E-38_JPRB, 0.60943731E-39_JPRB, 0.35343550E-39_JPRB, 0.20709790E-39_JPRB, 0.12450257E-39_JPRB, &
  & 0.78317170E-40_JPRB, 0.52606146E-40_JPRB, 0.38276468E-40_JPRB, 0.30240021E-40_JPRB, 0.25661979E-40_JPRB, 0.22818744E-40_JPRB, &
  & 0.20555647E-40_JPRB, 0.17863753E-40_JPRB, 0.14003176E-40_JPRB, 0.91364660E-41_JPRB /)

RGHG5(:, 4,12) = (/ &
  & 0.19179110E-38_JPRB, 0.37562828E-38_JPRB, 0.26413145E-38_JPRB, 0.17435992E-38_JPRB, 0.11697283E-38_JPRB, 0.89841869E-39_JPRB, &
  & 0.85220807E-39_JPRB, 0.10444172E-38_JPRB, 0.16072711E-38_JPRB, 0.28385556E-38_JPRB, 0.53579474E-38_JPRB, 0.10797560E-37_JPRB, &
  & 0.21389955E-37_JPRB, 0.41884934E-37_JPRB, 0.86462795E-37_JPRB, 0.25043795E-36_JPRB, 0.58216413E-36_JPRB, 0.14865161E-35_JPRB, &
  & 0.31905359E-35_JPRB, 0.52371932E-35_JPRB, 0.11205716E-34_JPRB, 0.28499648E-34_JPRB, 0.54536544E-34_JPRB, 0.99568297E-34_JPRB, &
  & 0.12453057E-33_JPRB, 0.12692726E-33_JPRB, 0.18686203E-33_JPRB, 0.16675206E-33_JPRB, 0.31963776E-33_JPRB, 0.34260816E-33_JPRB, &
  & 0.32284987E-33_JPRB, 0.27354266E-33_JPRB, 0.15753996E-33_JPRB, 0.97745363E-34_JPRB, 0.56893995E-34_JPRB, 0.34986601E-34_JPRB, &
  & 0.21671305E-34_JPRB, 0.14380291E-34_JPRB, 0.99376625E-35_JPRB, 0.70168252E-35_JPRB, 0.49796173E-35_JPRB, 0.35332527E-35_JPRB, &
  & 0.24791340E-35_JPRB, 0.16997149E-35_JPRB, 0.11360128E-35_JPRB, 0.74146204E-36_JPRB, 0.47031603E-36_JPRB, 0.28910538E-36_JPRB, &
  & 0.17394181E-36_JPRB, 0.10195196E-36_JPRB, 0.58864602E-37_JPRB, 0.33633848E-37_JPRB, 0.19254610E-37_JPRB, 0.11241278E-37_JPRB, &
  & 0.68593574E-38_JPRB, 0.45063404E-38_JPRB, 0.32510461E-38_JPRB, 0.25946975E-38_JPRB, 0.22531100E-38_JPRB, 0.20669811E-38_JPRB, &
  & 0.19279863E-38_JPRB, 0.17258756E-38_JPRB, 0.13469897E-38_JPRB, 0.72006562E-39_JPRB /)

RGHG5(:, 5,12) = (/ &
  & 0.12634817E-35_JPRB, 0.10531609E-35_JPRB, 0.61972629E-36_JPRB, 0.38567343E-36_JPRB, 0.25626780E-36_JPRB, 0.19521928E-36_JPRB, &
  & 0.18183998E-36_JPRB, 0.21966804E-36_JPRB, 0.33965044E-36_JPRB, 0.60596410E-36_JPRB, 0.11731081E-35_JPRB, 0.23697983E-35_JPRB, &
  & 0.46886318E-35_JPRB, 0.90484539E-35_JPRB, 0.18366548E-34_JPRB, 0.51981623E-34_JPRB, 0.11806393E-33_JPRB, 0.29564854E-33_JPRB, &
  & 0.62276231E-33_JPRB, 0.98006336E-33_JPRB, 0.20302159E-32_JPRB, 0.52263368E-32_JPRB, 0.99224624E-32_JPRB, 0.18281218E-31_JPRB, &
  & 0.22502575E-31_JPRB, 0.22397496E-31_JPRB, 0.32831434E-31_JPRB, 0.28690291E-31_JPRB, 0.55127288E-31_JPRB, 0.58695137E-31_JPRB, &
  & 0.55066233E-31_JPRB, 0.46593425E-31_JPRB, 0.26585641E-31_JPRB, 0.16508406E-31_JPRB, 0.96163843E-32_JPRB, 0.59281690E-32_JPRB, &
  & 0.36862599E-32_JPRB, 0.24675388E-32_JPRB, 0.17295664E-32_JPRB, 0.12406885E-32_JPRB, 0.89779253E-33_JPRB, 0.64911891E-33_JPRB, &
  & 0.46525359E-33_JPRB, 0.32599530E-33_JPRB, 0.22305405E-33_JPRB, 0.14919569E-33_JPRB, 0.96989235E-34_JPRB, 0.61004730E-34_JPRB, &
  & 0.37392470E-34_JPRB, 0.22197703E-34_JPRB, 0.12893930E-34_JPRB, 0.73653948E-35_JPRB, 0.41965105E-35_JPRB, 0.24331295E-35_JPRB, &
  & 0.14768627E-35_JPRB, 0.96948976E-36_JPRB, 0.70452274E-36_JPRB, 0.56934236E-36_JPRB, 0.50262060E-36_JPRB, 0.47014120E-36_JPRB, &
  & 0.45122098E-36_JPRB, 0.42854922E-36_JPRB, 0.37258340E-36_JPRB, 0.25150346E-36_JPRB /)

RGHG5(:, 6,12) = (/ &
  & 0.29932024E-33_JPRB, 0.36413339E-33_JPRB, 0.23823790E-33_JPRB, 0.16121219E-33_JPRB, 0.11331057E-33_JPRB, 0.90525669E-34_JPRB, &
  & 0.87319394E-34_JPRB, 0.10670477E-33_JPRB, 0.16729597E-33_JPRB, 0.29751335E-33_JPRB, 0.56712216E-33_JPRB, 0.11218800E-32_JPRB, &
  & 0.21428351E-32_JPRB, 0.39659813E-32_JPRB, 0.76821671E-32_JPRB, 0.20794933E-31_JPRB, 0.45076694E-31_JPRB, 0.10770389E-30_JPRB, &
  & 0.21692446E-30_JPRB, 0.32464977E-30_JPRB, 0.63973149E-30_JPRB, 0.15868154E-29_JPRB, 0.29098704E-29_JPRB, 0.52221071E-29_JPRB, &
  & 0.62414778E-29_JPRB, 0.60145709E-29_JPRB, 0.86399489E-29_JPRB, 0.73420467E-29_JPRB, 0.13994472E-28_JPRB, 0.14733484E-28_JPRB, &
  & 0.13723619E-28_JPRB, 0.11598226E-28_JPRB, 0.65797599E-29_JPRB, 0.41162190E-29_JPRB, 0.24107796E-29_JPRB, 0.15049696E-29_JPRB, &
  & 0.94732112E-30_JPRB, 0.64783027E-30_JPRB, 0.46583858E-30_JPRB, 0.34472404E-30_JPRB, 0.25795965E-30_JPRB, 0.19356222E-30_JPRB, &
  & 0.14409191E-30_JPRB, 0.10499748E-30_JPRB, 0.74788177E-31_JPRB, 0.52110887E-31_JPRB, 0.35286277E-31_JPRB, 0.23088178E-31_JPRB, &
  & 0.14682027E-31_JPRB, 0.90060470E-32_JPRB, 0.53852272E-32_JPRB, 0.31603915E-32_JPRB, 0.18510945E-32_JPRB, 0.11076477E-32_JPRB, &
  & 0.69682442E-33_JPRB, 0.47520686E-33_JPRB, 0.35705280E-33_JPRB, 0.29601028E-33_JPRB, 0.26567472E-33_JPRB, 0.25119256E-33_JPRB, &
  & 0.24400048E-33_JPRB, 0.23884264E-33_JPRB, 0.22952354E-33_JPRB, 0.20267504E-33_JPRB /)

RGHG5(:, 7,12) = (/ &
  & 0.27698949E-30_JPRB, 0.21255056E-30_JPRB, 0.13525682E-30_JPRB, 0.93361981E-31_JPRB, 0.69080088E-31_JPRB, 0.58425349E-31_JPRB, &
  & 0.59050165E-31_JPRB, 0.74613663E-31_JPRB, 0.11599279E-30_JPRB, 0.20197154E-30_JPRB, 0.36733432E-30_JPRB, 0.68844040E-30_JPRB, &
  & 0.12364954E-29_JPRB, 0.21412617E-29_JPRB, 0.38599514E-29_JPRB, 0.97900398E-29_JPRB, 0.19837561E-28_JPRB, 0.44435703E-28_JPRB, &
  & 0.84028979E-28_JPRB, 0.11793599E-27_JPRB, 0.21749077E-27_JPRB, 0.51201059E-27_JPRB, 0.89423730E-27_JPRB, 0.15472265E-26_JPRB, &
  & 0.17820923E-26_JPRB, 0.16479052E-26_JPRB, 0.23139355E-26_JPRB, 0.18981238E-26_JPRB, 0.35831133E-26_JPRB, 0.37202253E-26_JPRB, &
  & 0.34389524E-26_JPRB, 0.29014110E-26_JPRB, 0.16482141E-26_JPRB, 0.10386798E-26_JPRB, 0.61527631E-27_JPRB, 0.38989291E-27_JPRB, &
  & 0.25033851E-27_JPRB, 0.17551039E-27_JPRB, 0.13025488E-27_JPRB, 0.99955704E-28_JPRB, 0.77966194E-28_JPRB, 0.61157881E-28_JPRB, &
  & 0.47704629E-28_JPRB, 0.36440186E-28_JPRB, 0.27227639E-28_JPRB, 0.19917074E-28_JPRB, 0.14160493E-28_JPRB, 0.97249456E-29_JPRB, &
  & 0.64923151E-29_JPRB, 0.41747605E-29_JPRB, 0.26187770E-29_JPRB, 0.16142592E-29_JPRB, 0.99842089E-30_JPRB, 0.63466473E-30_JPRB, &
  & 0.42636732E-30_JPRB, 0.30978047E-30_JPRB, 0.24568093E-30_JPRB, 0.21190616E-30_JPRB, 0.19521703E-30_JPRB, 0.18765868E-30_JPRB, &
  & 0.18421830E-30_JPRB, 0.18195578E-30_JPRB, 0.17834751E-30_JPRB, 0.16676650E-30_JPRB /)

RGHG5(:, 8,12) = (/ &
  & 0.24044927E-27_JPRB, 0.14957404E-27_JPRB, 0.87938449E-28_JPRB, 0.60699245E-28_JPRB, 0.45595359E-28_JPRB, 0.39560662E-28_JPRB, &
  & 0.40848824E-28_JPRB, 0.51386465E-28_JPRB, 0.78477041E-28_JPRB, 0.13027900E-27_JPRB, 0.22438947E-27_JPRB, 0.39488112E-27_JPRB, &
  & 0.66315108E-27_JPRB, 0.10675668E-26_JPRB, 0.17748692E-26_JPRB, 0.42035401E-26_JPRB, 0.79163887E-26_JPRB, 0.16573626E-25_JPRB, &
  & 0.29375723E-25_JPRB, 0.38388246E-25_JPRB, 0.66038911E-25_JPRB, 0.14747243E-24_JPRB, 0.24501596E-24_JPRB, 0.40789914E-24_JPRB, &
  & 0.45161108E-24_JPRB, 0.39903185E-24_JPRB, 0.54799643E-24_JPRB, 0.43281248E-24_JPRB, 0.80869967E-24_JPRB, 0.82738552E-24_JPRB, &
  & 0.75871814E-24_JPRB, 0.63879530E-24_JPRB, 0.36374901E-24_JPRB, 0.23098890E-24_JPRB, 0.13851281E-24_JPRB, 0.89262416E-25_JPRB, &
  & 0.58590388E-25_JPRB, 0.42208718E-25_JPRB, 0.32365737E-25_JPRB, 0.25811426E-25_JPRB, 0.21025647E-25_JPRB, 0.17294293E-25_JPRB, &
  & 0.14168594E-25_JPRB, 0.11360471E-25_JPRB, 0.89069738E-26_JPRB, 0.68373117E-26_JPRB, 0.51004676E-26_JPRB, 0.36752745E-26_JPRB, &
  & 0.25797086E-26_JPRB, 0.17452912E-26_JPRB, 0.11551280E-26_JPRB, 0.75407360E-27_JPRB, 0.49593890E-27_JPRB, 0.33680981E-27_JPRB, &
  & 0.24172007E-27_JPRB, 0.18673675E-27_JPRB, 0.15568752E-27_JPRB, 0.13939235E-27_JPRB, 0.13178046E-27_JPRB, 0.12886079E-27_JPRB, &
  & 0.12792051E-27_JPRB, 0.12727958E-27_JPRB, 0.12540813E-27_JPRB, 0.11821291E-27_JPRB /)

RGHG5(:, 9,12) = (/ &
  & 0.18500495E-24_JPRB, 0.10510643E-24_JPRB, 0.59510773E-25_JPRB, 0.40283000E-25_JPRB, 0.30067914E-25_JPRB, 0.25899629E-25_JPRB, &
  & 0.26295686E-25_JPRB, 0.32208642E-25_JPRB, 0.47131804E-25_JPRB, 0.74490434E-25_JPRB, 0.12098225E-24_JPRB, 0.19999258E-24_JPRB, &
  & 0.31408144E-24_JPRB, 0.46949510E-24_JPRB, 0.71761686E-24_JPRB, 0.15884255E-23_JPRB, 0.27742449E-23_JPRB, 0.54375129E-23_JPRB, &
  & 0.90444859E-23_JPRB, 0.10967278E-22_JPRB, 0.17566235E-22_JPRB, 0.37346531E-22_JPRB, 0.58838440E-22_JPRB, 0.94123355E-22_JPRB, &
  & 0.99879371E-22_JPRB, 0.84296004E-22_JPRB, 0.11281165E-21_JPRB, 0.85981244E-22_JPRB, 0.15833329E-21_JPRB, 0.15956027E-21_JPRB, &
  & 0.14497580E-21_JPRB, 0.12158751E-21_JPRB, 0.69353009E-22_JPRB, 0.44342995E-22_JPRB, 0.26934589E-22_JPRB, 0.17691957E-22_JPRB, &
  & 0.11907670E-22_JPRB, 0.88432562E-23_JPRB, 0.70233099E-23_JPRB, 0.58350515E-23_JPRB, 0.49738532E-23_JPRB, 0.42991886E-23_JPRB, &
  & 0.37063738E-23_JPRB, 0.31234076E-23_JPRB, 0.25694344E-23_JPRB, 0.20686706E-23_JPRB, 0.16172530E-23_JPRB, 0.12211023E-23_JPRB, &
  & 0.90114322E-24_JPRB, 0.64164250E-24_JPRB, 0.44891594E-24_JPRB, 0.31043385E-24_JPRB, 0.21695955E-24_JPRB, 0.15653523E-24_JPRB, &
  & 0.11906412E-24_JPRB, 0.96742795E-25_JPRB, 0.84010907E-25_JPRB, 0.77525521E-25_JPRB, 0.74861587E-25_JPRB, 0.74261030E-25_JPRB, &
  & 0.74418093E-25_JPRB, 0.74496758E-25_JPRB, 0.73660725E-25_JPRB, 0.69948469E-25_JPRB /)

RGHG5(:,10,12) = (/ &
  & 0.12251399E-21_JPRB, 0.67819060E-22_JPRB, 0.37503246E-22_JPRB, 0.24998952E-22_JPRB, 0.18299752E-22_JPRB, 0.15359485E-22_JPRB, &
  & 0.15075544E-22_JPRB, 0.17692296E-22_JPRB, 0.24710023E-22_JPRB, 0.37044419E-22_JPRB, 0.56748533E-22_JPRB, 0.88222272E-22_JPRB, &
  & 0.12955552E-21_JPRB, 0.17990661E-21_JPRB, 0.25264933E-21_JPRB, 0.52272917E-21_JPRB, 0.84600331E-21_JPRB, 0.15523100E-20_JPRB, &
  & 0.24240205E-20_JPRB, 0.27244597E-20_JPRB, 0.40626273E-20_JPRB, 0.82071657E-20_JPRB, 0.12253837E-19_JPRB, 0.18741585E-19_JPRB, &
  & 0.19031137E-19_JPRB, 0.15366499E-19_JPRB, 0.19937428E-19_JPRB, 0.14712076E-19_JPRB, 0.26568944E-19_JPRB, 0.26364114E-19_JPRB, &
  & 0.23708027E-19_JPRB, 0.19784262E-19_JPRB, 0.11292807E-19_JPRB, 0.72684272E-20_JPRB, 0.44763190E-20_JPRB, 0.30005549E-20_JPRB, &
  & 0.20774247E-20_JPRB, 0.15943020E-20_JPRB, 0.13157289E-20_JPRB, 0.11402802E-20_JPRB, 0.10188819E-20_JPRB, 0.92624175E-21_JPRB, &
  & 0.84203119E-21_JPRB, 0.74687482E-21_JPRB, 0.64564436E-21_JPRB, 0.54568086E-21_JPRB, 0.44727863E-21_JPRB, 0.35391100E-21_JPRB, &
  & 0.27470371E-21_JPRB, 0.20583635E-21_JPRB, 0.15208206E-21_JPRB, 0.11118105E-21_JPRB, 0.82137592E-22_JPRB, 0.62534443E-22_JPRB, &
  & 0.49947041E-22_JPRB, 0.42324085E-22_JPRB, 0.37988837E-22_JPRB, 0.35925051E-22_JPRB, 0.35289535E-22_JPRB, 0.35411057E-22_JPRB, &
  & 0.35742855E-22_JPRB, 0.35956425E-22_JPRB, 0.35730495E-22_JPRB, 0.33953182E-22_JPRB /)

RGHG5(:,11,12) = (/ &
  & 0.68294765E-19_JPRB, 0.37379869E-19_JPRB, 0.20429217E-19_JPRB, 0.13404400E-19_JPRB, 0.95980618E-20_JPRB, 0.78259889E-20_JPRB, &
  & 0.74055776E-20_JPRB, 0.83214038E-20_JPRB, 0.11087880E-19_JPRB, 0.15787198E-19_JPRB, 0.22859055E-19_JPRB, 0.33446211E-19_JPRB, &
  & 0.46006105E-19_JPRB, 0.59462137E-19_JPRB, 0.76893366E-19_JPRB, 0.14866020E-18_JPRB, 0.22306835E-18_JPRB, 0.38276242E-18_JPRB, &
  & 0.56059462E-18_JPRB, 0.58502437E-18_JPRB, 0.81200650E-18_JPRB, 0.15550655E-17_JPRB, 0.21961192E-17_JPRB, 0.32037532E-17_JPRB, &
  & 0.31109802E-17_JPRB, 0.24062399E-17_JPRB, 0.30149437E-17_JPRB, 0.21565537E-17_JPRB, 0.38051412E-17_JPRB, 0.37146427E-17_JPRB, &
  & 0.33027560E-17_JPRB, 0.27407345E-17_JPRB, 0.15657048E-17_JPRB, 0.10146265E-17_JPRB, 0.63402536E-18_JPRB, 0.43421037E-18_JPRB, &
  & 0.30951121E-18_JPRB, 0.24603042E-18_JPRB, 0.21113520E-18_JPRB, 0.19111251E-18_JPRB, 0.17885926E-18_JPRB, 0.17096147E-18_JPRB, &
  & 0.16384249E-18_JPRB, 0.15325346E-18_JPRB, 0.13949511E-18_JPRB, 0.12407051E-18_JPRB, 0.10686125E-18_JPRB, 0.88745649E-19_JPRB, &
  & 0.72535274E-19_JPRB, 0.57192786E-19_JPRB, 0.44560394E-19_JPRB, 0.34327407E-19_JPRB, 0.26686399E-19_JPRB, 0.21312632E-19_JPRB, &
  & 0.17768035E-19_JPRB, 0.15610317E-19_JPRB, 0.14414816E-19_JPRB, 0.13921143E-19_JPRB, 0.13877687E-19_JPRB, 0.14060868E-19_JPRB, &
  & 0.14286771E-19_JPRB, 0.14416785E-19_JPRB, 0.14349462E-19_JPRB, 0.13796096E-19_JPRB /)

RGHG5(:,12,12) = (/ &
  & 0.31718717E-16_JPRB, 0.17195447E-16_JPRB, 0.93011298E-17_JPRB, 0.60124251E-17_JPRB, 0.42211039E-17_JPRB, 0.33536113E-17_JPRB, &
  & 0.30705670E-17_JPRB, 0.33155132E-17_JPRB, 0.42246538E-17_JPRB, 0.57251292E-17_JPRB, 0.78449148E-17_JPRB, 0.10816302E-16_JPRB, &
  & 0.13953086E-16_JPRB, 0.16818359E-16_JPRB, 0.20089325E-16_JPRB, 0.36247412E-16_JPRB, 0.50496035E-16_JPRB, 0.80900368E-16_JPRB, &
  & 0.11098662E-15_JPRB, 0.10783601E-15_JPRB, 0.13941097E-15_JPRB, 0.25212071E-15_JPRB, 0.33686937E-15_JPRB, 0.46771592E-15_JPRB, &
  & 0.43437369E-15_JPRB, 0.32200114E-15_JPRB, 0.38862835E-15_JPRB, 0.26927844E-15_JPRB, 0.46299583E-15_JPRB, 0.44407703E-15_JPRB, &
  & 0.38999615E-15_JPRB, 0.32177601E-15_JPRB, 0.18398097E-15_JPRB, 0.12023197E-15_JPRB, 0.76231920E-16_JPRB, 0.53396312E-16_JPRB, &
  & 0.39209787E-16_JPRB, 0.32296493E-16_JPRB, 0.28855944E-16_JPRB, 0.27266733E-16_JPRB, 0.26718227E-16_JPRB, 0.26804498E-16_JPRB, &
  & 0.27047535E-16_JPRB, 0.26685613E-16_JPRB, 0.25631318E-16_JPRB, 0.24054252E-16_JPRB, 0.21827778E-16_JPRB, 0.19071427E-16_JPRB, &
  & 0.16431865E-16_JPRB, 0.13629448E-16_JPRB, 0.11182826E-16_JPRB, 0.90520459E-17_JPRB, 0.73797001E-17_JPRB, 0.61560452E-17_JPRB, &
  & 0.53349303E-17_JPRB, 0.48412644E-17_JPRB, 0.45865205E-17_JPRB, 0.45149127E-17_JPRB, 0.45623622E-17_JPRB, 0.46658673E-17_JPRB, &
  & 0.47642394E-17_JPRB, 0.48303911E-17_JPRB, 0.48249846E-17_JPRB, 0.46250989E-17_JPRB /)

RGHG5(:,13,12) = (/ &
  & 0.20731022E-15_JPRB, 0.11794955E-15_JPRB, 0.73637418E-16_JPRB, 0.52173673E-16_JPRB, 0.39284611E-16_JPRB, 0.32772370E-16_JPRB, &
  & 0.31168132E-16_JPRB, 0.33417008E-16_JPRB, 0.39914724E-16_JPRB, 0.51547775E-16_JPRB, 0.67934167E-16_JPRB, 0.93158788E-16_JPRB, &
  & 0.12496863E-15_JPRB, 0.14978363E-15_JPRB, 0.18437926E-15_JPRB, 0.28799427E-15_JPRB, 0.39606948E-15_JPRB, 0.60394005E-15_JPRB, &
  & 0.77609426E-15_JPRB, 0.79154880E-15_JPRB, 0.11112204E-14_JPRB, 0.13405764E-14_JPRB, 0.12355576E-14_JPRB, 0.18168954E-14_JPRB, &
  & 0.18845666E-14_JPRB, 0.25812958E-14_JPRB, 0.40057802E-14_JPRB, 0.32899774E-14_JPRB, 0.28616364E-14_JPRB, 0.31806180E-14_JPRB, &
  & 0.22853442E-14_JPRB, 0.18050598E-14_JPRB, 0.10375412E-14_JPRB, 0.73057576E-15_JPRB, 0.56754966E-15_JPRB, 0.45817944E-15_JPRB, &
  & 0.42046716E-15_JPRB, 0.40596473E-15_JPRB, 0.40224282E-15_JPRB, 0.40961545E-15_JPRB, 0.42381630E-15_JPRB, 0.44149745E-15_JPRB, &
  & 0.45770246E-15_JPRB, 0.46100086E-15_JPRB, 0.44915103E-15_JPRB, 0.43176906E-15_JPRB, 0.39746359E-15_JPRB, 0.35282885E-15_JPRB, &
  & 0.31006552E-15_JPRB, 0.26054193E-15_JPRB, 0.21684708E-15_JPRB, 0.17756390E-15_JPRB, 0.14483190E-15_JPRB, 0.11980881E-15_JPRB, &
  & 0.10125022E-15_JPRB, 0.88408376E-16_JPRB, 0.79645211E-16_JPRB, 0.74041056E-16_JPRB, 0.70601281E-16_JPRB, 0.68465600E-16_JPRB, &
  & 0.66864920E-16_JPRB, 0.65358664E-16_JPRB, 0.62970633E-16_JPRB, 0.58506074E-16_JPRB /)

RGHG5(:,14,12) = (/ &
  & 0.80314642E-15_JPRB, 0.61291442E-15_JPRB, 0.47594681E-15_JPRB, 0.36404809E-15_JPRB, 0.30289943E-15_JPRB, 0.27797419E-15_JPRB, &
  & 0.27986707E-15_JPRB, 0.30207863E-15_JPRB, 0.34783313E-15_JPRB, 0.42717889E-15_JPRB, 0.54305829E-15_JPRB, 0.78975044E-15_JPRB, &
  & 0.10756873E-14_JPRB, 0.13132498E-14_JPRB, 0.14175006E-14_JPRB, 0.20198712E-14_JPRB, 0.30906720E-14_JPRB, 0.44771180E-14_JPRB, &
  & 0.58834510E-14_JPRB, 0.77768390E-14_JPRB, 0.11666867E-13_JPRB, 0.14066684E-13_JPRB, 0.16413118E-13_JPRB, 0.21279436E-13_JPRB, &
  & 0.22052608E-13_JPRB, 0.22156259E-13_JPRB, 0.21387160E-13_JPRB, 0.19507240E-13_JPRB, 0.19830066E-13_JPRB, 0.17785856E-13_JPRB, &
  & 0.12859182E-13_JPRB, 0.84710486E-14_JPRB, 0.60244515E-14_JPRB, 0.49009885E-14_JPRB, 0.42316576E-14_JPRB, 0.40524292E-14_JPRB, &
  & 0.41341510E-14_JPRB, 0.43210632E-14_JPRB, 0.45407124E-14_JPRB, 0.47948401E-14_JPRB, 0.50514267E-14_JPRB, 0.52849998E-14_JPRB, &
  & 0.54601633E-14_JPRB, 0.54856056E-14_JPRB, 0.53953525E-14_JPRB, 0.52047951E-14_JPRB, 0.47950705E-14_JPRB, 0.43326070E-14_JPRB, &
  & 0.38314752E-14_JPRB, 0.32465646E-14_JPRB, 0.27359613E-14_JPRB, 0.22495507E-14_JPRB, 0.18400531E-14_JPRB, 0.15091012E-14_JPRB, &
  & 0.12539645E-14_JPRB, 0.10612751E-14_JPRB, 0.91964135E-15_JPRB, 0.81659042E-15_JPRB, 0.74289443E-15_JPRB, 0.68941340E-15_JPRB, &
  & 0.64891035E-15_JPRB, 0.61409031E-15_JPRB, 0.57772041E-15_JPRB, 0.50909804E-15_JPRB /)

RGHG5(:,15,12) = (/ &
  & 0.28421591E-14_JPRB, 0.30737542E-14_JPRB, 0.17485818E-14_JPRB, 0.13044467E-14_JPRB, 0.12000452E-14_JPRB, 0.12729050E-14_JPRB, &
  & 0.15491656E-14_JPRB, 0.20240246E-14_JPRB, 0.26009036E-14_JPRB, 0.31736169E-14_JPRB, 0.38426217E-14_JPRB, 0.50551934E-14_JPRB, &
  & 0.74973495E-14_JPRB, 0.10530107E-13_JPRB, 0.14066162E-13_JPRB, 0.20173409E-13_JPRB, 0.28079920E-13_JPRB, 0.37497034E-13_JPRB, &
  & 0.49355837E-13_JPRB, 0.65363656E-13_JPRB, 0.82459789E-13_JPRB, 0.95473854E-13_JPRB, 0.11274143E-12_JPRB, 0.12641124E-12_JPRB, &
  & 0.13056182E-12_JPRB, 0.12971311E-12_JPRB, 0.12370221E-12_JPRB, 0.10353784E-12_JPRB, 0.81481405E-13_JPRB, 0.58648290E-13_JPRB, &
  & 0.48924691E-13_JPRB, 0.38087707E-13_JPRB, 0.32535732E-13_JPRB, 0.29348001E-13_JPRB, 0.29009045E-13_JPRB, 0.30699920E-13_JPRB, &
  & 0.33434152E-13_JPRB, 0.36474923E-13_JPRB, 0.39331433E-13_JPRB, 0.41961050E-13_JPRB, 0.44159724E-13_JPRB, 0.45692674E-13_JPRB, &
  & 0.46388688E-13_JPRB, 0.46025077E-13_JPRB, 0.44813112E-13_JPRB, 0.42685490E-13_JPRB, 0.39746801E-13_JPRB, 0.36038670E-13_JPRB, &
  & 0.31976781E-13_JPRB, 0.27580357E-13_JPRB, 0.23412567E-13_JPRB, 0.19475334E-13_JPRB, 0.16050946E-13_JPRB, 0.13172677E-13_JPRB, &
  & 0.10889706E-13_JPRB, 0.90611604E-14_JPRB, 0.76703628E-14_JPRB, 0.66163895E-14_JPRB, 0.58317325E-14_JPRB, 0.52427282E-14_JPRB, &
  & 0.48073143E-14_JPRB, 0.44355643E-14_JPRB, 0.40924202E-14_JPRB, 0.34800353E-14_JPRB /)

RGHG5(:,16,12) = (/ &
  & 0.38472629E-13_JPRB, 0.17474571E-13_JPRB, 0.14560617E-13_JPRB, 0.13512622E-13_JPRB, 0.13191005E-13_JPRB, 0.13507657E-13_JPRB, &
  & 0.14612745E-13_JPRB, 0.17006683E-13_JPRB, 0.21483300E-13_JPRB, 0.27775476E-13_JPRB, 0.35526927E-13_JPRB, 0.44982030E-13_JPRB, &
  & 0.58390582E-13_JPRB, 0.78796575E-13_JPRB, 0.10520273E-12_JPRB, 0.14017321E-12_JPRB, 0.18423995E-12_JPRB, 0.23362036E-12_JPRB, &
  & 0.29199532E-12_JPRB, 0.36362674E-12_JPRB, 0.43523193E-12_JPRB, 0.48843503E-12_JPRB, 0.54024358E-12_JPRB, 0.57334758E-12_JPRB, &
  & 0.57660848E-12_JPRB, 0.55095121E-12_JPRB, 0.49762982E-12_JPRB, 0.43100175E-12_JPRB, 0.35613808E-12_JPRB, 0.29201977E-12_JPRB, &
  & 0.22809003E-12_JPRB, 0.18969235E-12_JPRB, 0.16676141E-12_JPRB, 0.16140207E-12_JPRB, 0.16965803E-12_JPRB, 0.18762353E-12_JPRB, &
  & 0.21041949E-12_JPRB, 0.23330510E-12_JPRB, 0.25266773E-12_JPRB, 0.26812976E-12_JPRB, 0.27849842E-12_JPRB, 0.28291307E-12_JPRB, &
  & 0.28128503E-12_JPRB, 0.27399071E-12_JPRB, 0.26273807E-12_JPRB, 0.24807654E-12_JPRB, 0.23022109E-12_JPRB, 0.20939245E-12_JPRB, &
  & 0.18668765E-12_JPRB, 0.16313153E-12_JPRB, 0.13989050E-12_JPRB, 0.11792553E-12_JPRB, 0.98309056E-13_JPRB, 0.81367117E-13_JPRB, &
  & 0.67334139E-13_JPRB, 0.55833183E-13_JPRB, 0.46825394E-13_JPRB, 0.39841774E-13_JPRB, 0.34532751E-13_JPRB, 0.30537381E-13_JPRB, &
  & 0.27436261E-13_JPRB, 0.25128279E-13_JPRB, 0.22631413E-13_JPRB, 0.19230348E-13_JPRB /)

RGHG5(:,17,12) = (/ &
  & 0.12893508E-12_JPRB, 0.12560485E-12_JPRB, 0.11928742E-12_JPRB, 0.11469425E-12_JPRB, 0.11262465E-12_JPRB, 0.11369135E-12_JPRB, &
  & 0.11899860E-12_JPRB, 0.13054583E-12_JPRB, 0.15174303E-12_JPRB, 0.18428890E-12_JPRB, 0.22868434E-12_JPRB, 0.28499143E-12_JPRB, &
  & 0.35612155E-12_JPRB, 0.44863681E-12_JPRB, 0.56590198E-12_JPRB, 0.71483021E-12_JPRB, 0.89383969E-12_JPRB, 0.10858888E-11_JPRB, &
  & 0.12989380E-11_JPRB, 0.15241405E-11_JPRB, 0.17223065E-11_JPRB, 0.18664428E-11_JPRB, 0.19539225E-11_JPRB, 0.19646082E-11_JPRB, &
  & 0.18876051E-11_JPRB, 0.17430561E-11_JPRB, 0.15387931E-11_JPRB, 0.13187936E-11_JPRB, 0.11135948E-11_JPRB, 0.93194343E-12_JPRB, &
  & 0.80172208E-12_JPRB, 0.72367448E-12_JPRB, 0.69708540E-12_JPRB, 0.72170205E-12_JPRB, 0.79008664E-12_JPRB, 0.89036547E-12_JPRB, &
  & 0.10050813E-11_JPRB, 0.11116399E-11_JPRB, 0.11941333E-11_JPRB, 0.12491737E-11_JPRB, 0.12723987E-11_JPRB, 0.12680031E-11_JPRB, &
  & 0.12374160E-11_JPRB, 0.11858004E-11_JPRB, 0.11220957E-11_JPRB, 0.10496738E-11_JPRB, 0.96914360E-12_JPRB, 0.88177604E-12_JPRB, &
  & 0.79022200E-12_JPRB, 0.69674545E-12_JPRB, 0.60442000E-12_JPRB, 0.51703027E-12_JPRB, 0.43735263E-12_JPRB, 0.36706827E-12_JPRB, &
  & 0.30608865E-12_JPRB, 0.25515768E-12_JPRB, 0.21429455E-12_JPRB, 0.18205383E-12_JPRB, 0.15707660E-12_JPRB, 0.13794971E-12_JPRB, &
  & 0.12370163E-12_JPRB, 0.11191982E-12_JPRB, 0.10181659E-12_JPRB, 0.84272392E-13_JPRB /)

RGHG5(:,18,12) = (/ &
  & 0.48949798E-12_JPRB, 0.45664427E-12_JPRB, 0.45481419E-12_JPRB, 0.46518757E-12_JPRB, 0.48489343E-12_JPRB, 0.51441631E-12_JPRB, &
  & 0.55633796E-12_JPRB, 0.61713926E-12_JPRB, 0.70726985E-12_JPRB, 0.83413349E-12_JPRB, 0.10040550E-11_JPRB, 0.12188253E-11_JPRB, &
  & 0.14831443E-11_JPRB, 0.18089089E-11_JPRB, 0.21933397E-11_JPRB, 0.26524930E-11_JPRB, 0.31755321E-11_JPRB, 0.37170609E-11_JPRB, &
  & 0.42611344E-11_JPRB, 0.47762792E-11_JPRB, 0.51729510E-11_JPRB, 0.53869014E-11_JPRB, 0.54149350E-11_JPRB, 0.52466677E-11_JPRB, &
  & 0.48955028E-11_JPRB, 0.44159919E-11_JPRB, 0.38764508E-11_JPRB, 0.33638769E-11_JPRB, 0.29374398E-11_JPRB, 0.26248478E-11_JPRB, &
  & 0.24406224E-11_JPRB, 0.23823749E-11_JPRB, 0.24409294E-11_JPRB, 0.26203889E-11_JPRB, 0.29015965E-11_JPRB, 0.32529465E-11_JPRB, &
  & 0.36193485E-11_JPRB, 0.39476239E-11_JPRB, 0.41742621E-11_JPRB, 0.42829598E-11_JPRB, 0.42831207E-11_JPRB, 0.41904293E-11_JPRB, &
  & 0.40284707E-11_JPRB, 0.38108089E-11_JPRB, 0.35729423E-11_JPRB, 0.33210912E-11_JPRB, 0.30594069E-11_JPRB, 0.27875230E-11_JPRB, &
  & 0.25114147E-11_JPRB, 0.22345630E-11_JPRB, 0.19645514E-11_JPRB, 0.17075863E-11_JPRB, 0.14689053E-11_JPRB, 0.12520555E-11_JPRB, &
  & 0.10589538E-11_JPRB, 0.89436444E-12_JPRB, 0.75900787E-12_JPRB, 0.65002365E-12_JPRB, 0.56406984E-12_JPRB, 0.49738528E-12_JPRB, &
  & 0.44666801E-12_JPRB, 0.40687402E-12_JPRB, 0.36942742E-12_JPRB, 0.31173374E-12_JPRB /)

RGHG5(:,19,12) = (/ &
  & 0.11691103E-11_JPRB, 0.12145757E-11_JPRB, 0.12703789E-11_JPRB, 0.13449029E-11_JPRB, 0.14443179E-11_JPRB, 0.15746527E-11_JPRB, &
  & 0.17456089E-11_JPRB, 0.19704084E-11_JPRB, 0.22693837E-11_JPRB, 0.26530098E-11_JPRB, 0.31378123E-11_JPRB, 0.37321353E-11_JPRB, &
  & 0.44354243E-11_JPRB, 0.52633748E-11_JPRB, 0.61993379E-11_JPRB, 0.72451836E-11_JPRB, 0.83727547E-11_JPRB, 0.95104792E-11_JPRB, &
  & 0.10569380E-10_JPRB, 0.11453799E-10_JPRB, 0.12039901E-10_JPRB, 0.12205071E-10_JPRB, 0.11959665E-10_JPRB, 0.11329154E-10_JPRB, &
  & 0.10417792E-10_JPRB, 0.93623980E-11_JPRB, 0.83109049E-11_JPRB, 0.74576465E-11_JPRB, 0.68355352E-11_JPRB, 0.65100009E-11_JPRB, &
  & 0.64459150E-11_JPRB, 0.66284838E-11_JPRB, 0.70226177E-11_JPRB, 0.76227202E-11_JPRB, 0.83723081E-11_JPRB, 0.91997642E-11_JPRB, &
  & 0.99967803E-11_JPRB, 0.10635958E-10_JPRB, 0.11021318E-10_JPRB, 0.11155587E-10_JPRB, 0.11009306E-10_JPRB, 0.10646095E-10_JPRB, &
  & 0.10128188E-10_JPRB, 0.95233647E-11_JPRB, 0.88834079E-11_JPRB, 0.82356847E-11_JPRB, 0.75825882E-11_JPRB, 0.69290910E-11_JPRB, &
  & 0.62834720E-11_JPRB, 0.56513943E-11_JPRB, 0.50397512E-11_JPRB, 0.44553207E-11_JPRB, 0.39046067E-11_JPRB, 0.33850769E-11_JPRB, &
  & 0.29146236E-11_JPRB, 0.25052284E-11_JPRB, 0.21610487E-11_JPRB, 0.18784670E-11_JPRB, 0.16509990E-11_JPRB, 0.14726117E-11_JPRB, &
  & 0.13333114E-11_JPRB, 0.12275517E-11_JPRB, 0.11205520E-11_JPRB, 0.96820588E-12_JPRB /)

RGHG5(:,20,12) = (/ &
  & 0.26526953E-11_JPRB, 0.28462779E-11_JPRB, 0.30142579E-11_JPRB, 0.32137437E-11_JPRB, 0.34680956E-11_JPRB, 0.37972230E-11_JPRB, &
  & 0.42198428E-11_JPRB, 0.47681989E-11_JPRB, 0.54728357E-11_JPRB, 0.63415501E-11_JPRB, 0.73930089E-11_JPRB, 0.86364796E-11_JPRB, &
  & 0.10066597E-10_JPRB, 0.11678246E-10_JPRB, 0.13440682E-10_JPRB, 0.15325597E-10_JPRB, 0.17236920E-10_JPRB, 0.19073472E-10_JPRB, &
  & 0.20739644E-10_JPRB, 0.22020465E-10_JPRB, 0.22733482E-10_JPRB, 0.22735782E-10_JPRB, 0.22068840E-10_JPRB, 0.20814576E-10_JPRB, &
  & 0.19175045E-10_JPRB, 0.17454795E-10_JPRB, 0.15900932E-10_JPRB, 0.14762337E-10_JPRB, 0.14195495E-10_JPRB, 0.14140631E-10_JPRB, &
  & 0.14572687E-10_JPRB, 0.15391107E-10_JPRB, 0.16481672E-10_JPRB, 0.17795045E-10_JPRB, 0.19202381E-10_JPRB, 0.20578634E-10_JPRB, &
  & 0.21832801E-10_JPRB, 0.22753318E-10_JPRB, 0.23190004E-10_JPRB, 0.23093704E-10_JPRB, 0.22598062E-10_JPRB, 0.21717265E-10_JPRB, &
  & 0.20596280E-10_JPRB, 0.19345069E-10_JPRB, 0.18025101E-10_JPRB, 0.16724856E-10_JPRB, 0.15439457E-10_JPRB, 0.14192457E-10_JPRB, &
  & 0.12978870E-10_JPRB, 0.11810551E-10_JPRB, 0.10684648E-10_JPRB, 0.96037137E-11_JPRB, 0.85540429E-11_JPRB, 0.75533980E-11_JPRB, &
  & 0.66319289E-11_JPRB, 0.58141252E-11_JPRB, 0.51123064E-11_JPRB, 0.45234406E-11_JPRB, 0.40412990E-11_JPRB, 0.36545792E-11_JPRB, &
  & 0.33592502E-11_JPRB, 0.31067295E-11_JPRB, 0.28973308E-11_JPRB, 0.25016809E-11_JPRB /)

RGHG5(:,21,12) = (/ &
  & 0.50929196E-11_JPRB, 0.55971703E-11_JPRB, 0.59824957E-11_JPRB, 0.64074119E-11_JPRB, 0.69218815E-11_JPRB, 0.75613578E-11_JPRB, &
  & 0.83675072E-11_JPRB, 0.93819908E-11_JPRB, 0.10659556E-10_JPRB, 0.12208018E-10_JPRB, 0.14026161E-10_JPRB, 0.16115751E-10_JPRB, &
  & 0.18459272E-10_JPRB, 0.21013092E-10_JPRB, 0.23714201E-10_JPRB, 0.26534989E-10_JPRB, 0.29327832E-10_JPRB, 0.31895268E-10_JPRB, &
  & 0.34138262E-10_JPRB, 0.35823761E-10_JPRB, 0.36712910E-10_JPRB, 0.36633245E-10_JPRB, 0.35657928E-10_JPRB, 0.33937998E-10_JPRB, &
  & 0.31779950E-10_JPRB, 0.29589203E-10_JPRB, 0.27767597E-10_JPRB, 0.26679497E-10_JPRB, 0.26415989E-10_JPRB, 0.27020955E-10_JPRB, &
  & 0.28293449E-10_JPRB, 0.30033784E-10_JPRB, 0.32001114E-10_JPRB, 0.34050592E-10_JPRB, 0.35983900E-10_JPRB, 0.37714800E-10_JPRB, &
  & 0.39117432E-10_JPRB, 0.39988651E-10_JPRB, 0.40262578E-10_JPRB, 0.39843465E-10_JPRB, 0.38817706E-10_JPRB, 0.37274146E-10_JPRB, &
  & 0.35406948E-10_JPRB, 0.33328625E-10_JPRB, 0.31209792E-10_JPRB, 0.29043497E-10_JPRB, 0.26963837E-10_JPRB, 0.24966232E-10_JPRB, &
  & 0.23041662E-10_JPRB, 0.21204635E-10_JPRB, 0.19431862E-10_JPRB, 0.17710840E-10_JPRB, 0.16025398E-10_JPRB, 0.14406013E-10_JPRB, &
  & 0.12893246E-10_JPRB, 0.11525464E-10_JPRB, 0.10324320E-10_JPRB, 0.92968966E-11_JPRB, 0.84393430E-11_JPRB, 0.77438550E-11_JPRB, &
  & 0.71784423E-11_JPRB, 0.67490466E-11_JPRB, 0.62648962E-11_JPRB, 0.56215106E-11_JPRB /)

RGHG5(:,22,12) = (/ &
  & 0.86120928E-11_JPRB, 0.95576073E-11_JPRB, 0.10243998E-10_JPRB, 0.10978113E-10_JPRB, 0.11847016E-10_JPRB, 0.12907039E-10_JPRB, &
  & 0.14197036E-10_JPRB, 0.15774600E-10_JPRB, 0.17704230E-10_JPRB, 0.20003254E-10_JPRB, 0.22668785E-10_JPRB, 0.25650015E-10_JPRB, &
  & 0.28934698E-10_JPRB, 0.32442986E-10_JPRB, 0.36059360E-10_JPRB, 0.39730417E-10_JPRB, 0.43325073E-10_JPRB, 0.46659884E-10_JPRB, &
  & 0.49576145E-10_JPRB, 0.51802524E-10_JPRB, 0.53096715E-10_JPRB, 0.53281400E-10_JPRB, 0.52455013E-10_JPRB, 0.50749595E-10_JPRB, &
  & 0.48592966E-10_JPRB, 0.46439054E-10_JPRB, 0.44765251E-10_JPRB, 0.44008436E-10_JPRB, 0.44382720E-10_JPRB, 0.45728560E-10_JPRB, &
  & 0.47809732E-10_JPRB, 0.50339378E-10_JPRB, 0.52934504E-10_JPRB, 0.55341433E-10_JPRB, 0.57463853E-10_JPRB, 0.59186128E-10_JPRB, &
  & 0.60456001E-10_JPRB, 0.61050165E-10_JPRB, 0.60914940E-10_JPRB, 0.59957615E-10_JPRB, 0.58369677E-10_JPRB, 0.56213010E-10_JPRB, &
  & 0.53586677E-10_JPRB, 0.50706717E-10_JPRB, 0.47696191E-10_JPRB, 0.44698578E-10_JPRB, 0.41760363E-10_JPRB, 0.38971250E-10_JPRB, &
  & 0.36285884E-10_JPRB, 0.33728687E-10_JPRB, 0.31271385E-10_JPRB, 0.28849988E-10_JPRB, 0.26485479E-10_JPRB, 0.24200336E-10_JPRB, &
  & 0.22039469E-10_JPRB, 0.20042266E-10_JPRB, 0.18250948E-10_JPRB, 0.16683314E-10_JPRB, 0.15348334E-10_JPRB, 0.14240172E-10_JPRB, &
  & 0.13359468E-10_JPRB, 0.12574485E-10_JPRB, 0.11909958E-10_JPRB, 0.10603199E-10_JPRB /)

RGHG5(:,23,12) = (/ &
  & 0.13294069E-10_JPRB, 0.14725523E-10_JPRB, 0.15749168E-10_JPRB, 0.16826211E-10_JPRB, 0.18083373E-10_JPRB, 0.19590397E-10_JPRB, &
  & 0.21404444E-10_JPRB, 0.23568366E-10_JPRB, 0.26144909E-10_JPRB, 0.29165625E-10_JPRB, 0.32621520E-10_JPRB, 0.36435344E-10_JPRB, &
  & 0.40551337E-10_JPRB, 0.44912907E-10_JPRB, 0.49380222E-10_JPRB, 0.53872663E-10_JPRB, 0.58220151E-10_JPRB, 0.62253376E-10_JPRB, &
  & 0.65875000E-10_JPRB, 0.68859266E-10_JPRB, 0.70962534E-10_JPRB, 0.71987943E-10_JPRB, 0.71964823E-10_JPRB, 0.71065015E-10_JPRB, &
  & 0.69648579E-10_JPRB, 0.68156744E-10_JPRB, 0.67053654E-10_JPRB, 0.66859573E-10_JPRB, 0.67673769E-10_JPRB, 0.69412677E-10_JPRB, &
  & 0.71856084E-10_JPRB, 0.74585976E-10_JPRB, 0.77115758E-10_JPRB, 0.79380023E-10_JPRB, 0.81249819E-10_JPRB, 0.82596929E-10_JPRB, &
  & 0.83399850E-10_JPRB, 0.83560041E-10_JPRB, 0.83019883E-10_JPRB, 0.81671642E-10_JPRB, 0.79595587E-10_JPRB, 0.76897398E-10_JPRB, &
  & 0.73657483E-10_JPRB, 0.70103715E-10_JPRB, 0.66311248E-10_JPRB, 0.62545538E-10_JPRB, 0.58851167E-10_JPRB, 0.55339920E-10_JPRB, &
  & 0.51971486E-10_JPRB, 0.48748269E-10_JPRB, 0.45628955E-10_JPRB, 0.42569899E-10_JPRB, 0.39578764E-10_JPRB, 0.36679916E-10_JPRB, &
  & 0.33895331E-10_JPRB, 0.31277064E-10_JPRB, 0.28869634E-10_JPRB, 0.26713404E-10_JPRB, 0.24836768E-10_JPRB, 0.23249343E-10_JPRB, &
  & 0.21915011E-10_JPRB, 0.20835488E-10_JPRB, 0.19617174E-10_JPRB, 0.17874683E-10_JPRB /)

RGHG5(:,24,12) = (/ &
  & 0.19045533E-10_JPRB, 0.20974833E-10_JPRB, 0.22333267E-10_JPRB, 0.23745769E-10_JPRB, 0.25372617E-10_JPRB, 0.27304898E-10_JPRB, &
  & 0.29595496E-10_JPRB, 0.32300464E-10_JPRB, 0.35467927E-10_JPRB, 0.39104379E-10_JPRB, 0.43227085E-10_JPRB, 0.47731402E-10_JPRB, &
  & 0.52522573E-10_JPRB, 0.57517706E-10_JPRB, 0.62610389E-10_JPRB, 0.67743693E-10_JPRB, 0.72788553E-10_JPRB, 0.77607309E-10_JPRB, &
  & 0.82121157E-10_JPRB, 0.86126078E-10_JPRB, 0.89381606E-10_JPRB, 0.91698663E-10_JPRB, 0.93106155E-10_JPRB, 0.93679509E-10_JPRB, &
  & 0.93625038E-10_JPRB, 0.93318617E-10_JPRB, 0.93064723E-10_JPRB, 0.93335999E-10_JPRB, 0.94315736E-10_JPRB, 0.95922249E-10_JPRB, &
  & 0.97986716E-10_JPRB, 0.10011733E-09_JPRB, 0.10208304E-09_JPRB, 0.10374248E-09_JPRB, 0.10504345E-09_JPRB, 0.10584671E-09_JPRB, &
  & 0.10612697E-09_JPRB, 0.10585931E-09_JPRB, 0.10488254E-09_JPRB, 0.10321397E-09_JPRB, 0.10087758E-09_JPRB, 0.97829189E-10_JPRB, &
  & 0.94257678E-10_JPRB, 0.90230719E-10_JPRB, 0.85954237E-10_JPRB, 0.81573338E-10_JPRB, 0.77253023E-10_JPRB, 0.73083352E-10_JPRB, &
  & 0.69120022E-10_JPRB, 0.65316558E-10_JPRB, 0.61624206E-10_JPRB, 0.58036628E-10_JPRB, 0.54531414E-10_JPRB, 0.51120639E-10_JPRB, &
  & 0.47818874E-10_JPRB, 0.44658863E-10_JPRB, 0.41698187E-10_JPRB, 0.38975871E-10_JPRB, 0.36546939E-10_JPRB, 0.34439711E-10_JPRB, &
  & 0.32664177E-10_JPRB, 0.31065425E-10_JPRB, 0.29555771E-10_JPRB, 0.26823018E-10_JPRB /)

RGHG5(:,25,12) = (/ &
  & 0.25740651E-10_JPRB, 0.28128791E-10_JPRB, 0.29789948E-10_JPRB, 0.31494481E-10_JPRB, 0.33441628E-10_JPRB, 0.35728101E-10_JPRB, &
  & 0.38424777E-10_JPRB, 0.41575611E-10_JPRB, 0.45223509E-10_JPRB, 0.49372176E-10_JPRB, 0.54008072E-10_JPRB, 0.59056884E-10_JPRB, &
  & 0.64404086E-10_JPRB, 0.69961516E-10_JPRB, 0.75614230E-10_JPRB, 0.81297705E-10_JPRB, 0.86945361E-10_JPRB, 0.92461316E-10_JPRB, &
  & 0.97775857E-10_JPRB, 0.10276813E-09_JPRB, 0.10728156E-09_JPRB, 0.11113500E-09_JPRB, 0.11424818E-09_JPRB, 0.11654426E-09_JPRB, &
  & 0.11809299E-09_JPRB, 0.11909246E-09_JPRB, 0.11980833E-09_JPRB, 0.12054042E-09_JPRB, 0.12139287E-09_JPRB, 0.12245642E-09_JPRB, &
  & 0.12366354E-09_JPRB, 0.12489672E-09_JPRB, 0.12594557E-09_JPRB, 0.12678872E-09_JPRB, 0.12738927E-09_JPRB, 0.12764180E-09_JPRB, &
  & 0.12743155E-09_JPRB, 0.12675044E-09_JPRB, 0.12551502E-09_JPRB, 0.12363810E-09_JPRB, 0.12112894E-09_JPRB, 0.11796919E-09_JPRB, &
  & 0.11425630E-09_JPRB, 0.11001568E-09_JPRB, 0.10543851E-09_JPRB, 0.10065242E-09_JPRB, 0.95878749E-10_JPRB, 0.91225687E-10_JPRB, &
  & 0.86753292E-10_JPRB, 0.82454252E-10_JPRB, 0.78303995E-10_JPRB, 0.74304493E-10_JPRB, 0.70408276E-10_JPRB, 0.66625705E-10_JPRB, &
  & 0.62945781E-10_JPRB, 0.59398549E-10_JPRB, 0.56005062E-10_JPRB, 0.52830351E-10_JPRB, 0.49925238E-10_JPRB, 0.47343768E-10_JPRB, &
  & 0.45090556E-10_JPRB, 0.43090895E-10_JPRB, 0.40971122E-10_JPRB, 0.37447621E-10_JPRB /)

RGHG5(:,26,12) = (/ &
  & 0.33302850E-10_JPRB, 0.36075812E-10_JPRB, 0.37986253E-10_JPRB, 0.39930018E-10_JPRB, 0.42124144E-10_JPRB, 0.44697947E-10_JPRB, &
  & 0.47710631E-10_JPRB, 0.51207722E-10_JPRB, 0.55216352E-10_JPRB, 0.59733038E-10_JPRB, 0.64727335E-10_JPRB, 0.70122956E-10_JPRB, &
  & 0.75827525E-10_JPRB, 0.81749787E-10_JPRB, 0.87795007E-10_JPRB, 0.93924431E-10_JPRB, 0.10002959E-09_JPRB, 0.10607847E-09_JPRB, &
  & 0.11211737E-09_JPRB, 0.11807802E-09_JPRB, 0.12380241E-09_JPRB, 0.12907557E-09_JPRB, 0.13374818E-09_JPRB, 0.13764304E-09_JPRB, &
  & 0.14071205E-09_JPRB, 0.14297168E-09_JPRB, 0.14454099E-09_JPRB, 0.14562496E-09_JPRB, 0.14634707E-09_JPRB, 0.14687136E-09_JPRB, &
  & 0.14727053E-09_JPRB, 0.14754849E-09_JPRB, 0.14764703E-09_JPRB, 0.14767644E-09_JPRB, 0.14758897E-09_JPRB, 0.14731609E-09_JPRB, &
  & 0.14672470E-09_JPRB, 0.14575088E-09_JPRB, 0.14433917E-09_JPRB, 0.14240682E-09_JPRB, 0.13986778E-09_JPRB, 0.13672552E-09_JPRB, &
  & 0.13299573E-09_JPRB, 0.12869023E-09_JPRB, 0.12394276E-09_JPRB, 0.11890663E-09_JPRB, 0.11380818E-09_JPRB, 0.10880742E-09_JPRB, &
  & 0.10397629E-09_JPRB, 0.99322738E-10_JPRB, 0.94834265E-10_JPRB, 0.90533352E-10_JPRB, 0.86382748E-10_JPRB, 0.82369750E-10_JPRB, &
  & 0.78473776E-10_JPRB, 0.74695923E-10_JPRB, 0.71069386E-10_JPRB, 0.67607961E-10_JPRB, 0.64392471E-10_JPRB, 0.61463418E-10_JPRB, &
  & 0.58838878E-10_JPRB, 0.56451455E-10_JPRB, 0.53854053E-10_JPRB, 0.49571985E-10_JPRB /)

RGHG5(:,27,12) = (/ &
  & 0.41685082E-10_JPRB, 0.44769997E-10_JPRB, 0.46876347E-10_JPRB, 0.48994770E-10_JPRB, 0.51386610E-10_JPRB, 0.54165554E-10_JPRB, &
  & 0.57417029E-10_JPRB, 0.61164587E-10_JPRB, 0.65416700E-10_JPRB, 0.70168683E-10_JPRB, 0.75374915E-10_JPRB, 0.80980146E-10_JPRB, &
  & 0.86866889E-10_JPRB, 0.92987909E-10_JPRB, 0.99229160E-10_JPRB, 0.10559235E-09_JPRB, 0.11205295E-09_JPRB, 0.11860145E-09_JPRB, &
  & 0.12525075E-09_JPRB, 0.13193653E-09_JPRB, 0.13852659E-09_JPRB, 0.14482569E-09_JPRB, 0.15065561E-09_JPRB, 0.15577278E-09_JPRB, &
  & 0.16004445E-09_JPRB, 0.16334641E-09_JPRB, 0.16571812E-09_JPRB, 0.16720896E-09_JPRB, 0.16796564E-09_JPRB, 0.16813212E-09_JPRB, &
  & 0.16792709E-09_JPRB, 0.16744105E-09_JPRB, 0.16677311E-09_JPRB, 0.16612825E-09_JPRB, 0.16546892E-09_JPRB, 0.16476083E-09_JPRB, &
  & 0.16388371E-09_JPRB, 0.16270674E-09_JPRB, 0.16120109E-09_JPRB, 0.15928975E-09_JPRB, 0.15682880E-09_JPRB, 0.15379448E-09_JPRB, &
  & 0.15015239E-09_JPRB, 0.14589503E-09_JPRB, 0.14111579E-09_JPRB, 0.13597179E-09_JPRB, 0.13067193E-09_JPRB, 0.12541680E-09_JPRB, &
  & 0.12027111E-09_JPRB, 0.11534661E-09_JPRB, 0.11064653E-09_JPRB, 0.10616617E-09_JPRB, 0.10187394E-09_JPRB, 0.97754554E-10_JPRB, &
  & 0.93785299E-10_JPRB, 0.89953940E-10_JPRB, 0.86252366E-10_JPRB, 0.82714641E-10_JPRB, 0.79367422E-10_JPRB, 0.76280773E-10_JPRB, &
  & 0.73477495E-10_JPRB, 0.70803682E-10_JPRB, 0.68035848E-10_JPRB, 0.62922757E-10_JPRB /)

RGHG5(:,28,12) = (/ &
  & 0.50859799E-10_JPRB, 0.54197497E-10_JPRB, 0.56451944E-10_JPRB, 0.58711751E-10_JPRB, 0.61227544E-10_JPRB, 0.64165971E-10_JPRB, &
  & 0.67574182E-10_JPRB, 0.71471114E-10_JPRB, 0.75849084E-10_JPRB, 0.80705095E-10_JPRB, 0.86003628E-10_JPRB, 0.91706517E-10_JPRB, &
  & 0.97674868E-10_JPRB, 0.10390129E-09_JPRB, 0.11030245E-09_JPRB, 0.11684283E-09_JPRB, 0.12350847E-09_JPRB, 0.13030071E-09_JPRB, &
  & 0.13725253E-09_JPRB, 0.14432057E-09_JPRB, 0.15139276E-09_JPRB, 0.15829332E-09_JPRB, 0.16482797E-09_JPRB, 0.17075032E-09_JPRB, &
  & 0.17584077E-09_JPRB, 0.17992600E-09_JPRB, 0.18296129E-09_JPRB, 0.18490401E-09_JPRB, 0.18586474E-09_JPRB, 0.18595053E-09_JPRB, &
  & 0.18544664E-09_JPRB, 0.18450846E-09_JPRB, 0.18333160E-09_JPRB, 0.18220493E-09_JPRB, 0.18112820E-09_JPRB, 0.18009717E-09_JPRB, &
  & 0.17901716E-09_JPRB, 0.17773973E-09_JPRB, 0.17620425E-09_JPRB, 0.17434841E-09_JPRB, 0.17201097E-09_JPRB, 0.16912893E-09_JPRB, &
  & 0.16563693E-09_JPRB, 0.16150253E-09_JPRB, 0.15678184E-09_JPRB, 0.15161246E-09_JPRB, 0.14619488E-09_JPRB, 0.14074215E-09_JPRB, &
  & 0.13541970E-09_JPRB, 0.13031361E-09_JPRB, 0.12546966E-09_JPRB, 0.12089368E-09_JPRB, 0.11656197E-09_JPRB, 0.11244695E-09_JPRB, &
  & 0.10850617E-09_JPRB, 0.10472503E-09_JPRB, 0.10108873E-09_JPRB, 0.97586501E-10_JPRB, 0.94273658E-10_JPRB, 0.91180126E-10_JPRB, &
  & 0.88332938E-10_JPRB, 0.85664087E-10_JPRB, 0.82609038E-10_JPRB, 0.77501949E-10_JPRB /)

RGHG5(:,29,12) = (/ &
  & 0.60795292E-10_JPRB, 0.64332824E-10_JPRB, 0.66709992E-10_JPRB, 0.69060146E-10_JPRB, 0.71687573E-10_JPRB, 0.74708982E-10_JPRB, &
  & 0.78205005E-10_JPRB, 0.82158225E-10_JPRB, 0.86549073E-10_JPRB, 0.91373152E-10_JPRB, 0.96647752E-10_JPRB, 0.10229091E-09_JPRB, &
  & 0.10824840E-09_JPRB, 0.11447124E-09_JPRB, 0.12088440E-09_JPRB, 0.12746686E-09_JPRB, 0.13419726E-09_JPRB, 0.14108623E-09_JPRB, &
  & 0.14816080E-09_JPRB, 0.15537949E-09_JPRB, 0.16265762E-09_JPRB, 0.16982071E-09_JPRB, 0.17669630E-09_JPRB, 0.18304031E-09_JPRB, &
  & 0.18861894E-09_JPRB, 0.19323873E-09_JPRB, 0.19676971E-09_JPRB, 0.19915489E-09_JPRB, 0.20041578E-09_JPRB, 0.20063651E-09_JPRB, &
  & 0.20009097E-09_JPRB, 0.19898562E-09_JPRB, 0.19754685E-09_JPRB, 0.19612385E-09_JPRB, 0.19477610E-09_JPRB, 0.19352873E-09_JPRB, &
  & 0.19230718E-09_JPRB, 0.19098786E-09_JPRB, 0.18947277E-09_JPRB, 0.18769267E-09_JPRB, 0.18548817E-09_JPRB, 0.18276493E-09_JPRB, &
  & 0.17943588E-09_JPRB, 0.17544716E-09_JPRB, 0.17082120E-09_JPRB, 0.16567174E-09_JPRB, 0.16019719E-09_JPRB, 0.15465887E-09_JPRB, &
  & 0.14923625E-09_JPRB, 0.14406877E-09_JPRB, 0.13919647E-09_JPRB, 0.13462353E-09_JPRB, 0.13032765E-09_JPRB, 0.12626490E-09_JPRB, &
  & 0.12241480E-09_JPRB, 0.11873015E-09_JPRB, 0.11518982E-09_JPRB, 0.11179359E-09_JPRB, 0.10856470E-09_JPRB, 0.10557155E-09_JPRB, &
  & 0.10281144E-09_JPRB, 0.10016435E-09_JPRB, 0.97322421E-10_JPRB, 0.92116828E-10_JPRB /)

RGHG5(:,30,12) = (/ &
  & 0.71387549E-10_JPRB, 0.75118439E-10_JPRB, 0.77590982E-10_JPRB, 0.80027415E-10_JPRB, 0.82699486E-10_JPRB, 0.85777857E-10_JPRB, &
  & 0.89285343E-10_JPRB, 0.93203348E-10_JPRB, 0.97506142E-10_JPRB, 0.10220051E-09_JPRB, 0.10731697E-09_JPRB, 0.11278958E-09_JPRB, &
  & 0.11861009E-09_JPRB, 0.12473295E-09_JPRB, 0.13109082E-09_JPRB, 0.13765904E-09_JPRB, 0.14440824E-09_JPRB, 0.15131266E-09_JPRB, &
  & 0.15837939E-09_JPRB, 0.16556306E-09_JPRB, 0.17280681E-09_JPRB, 0.17997825E-09_JPRB, 0.18690909E-09_JPRB, 0.19338373E-09_JPRB, &
  & 0.19916795E-09_JPRB, 0.20406789E-09_JPRB, 0.20792823E-09_JPRB, 0.21066889E-09_JPRB, 0.21224944E-09_JPRB, 0.21271679E-09_JPRB, &
  & 0.21230026E-09_JPRB, 0.21122941E-09_JPRB, 0.20972890E-09_JPRB, 0.20816567E-09_JPRB, 0.20667325E-09_JPRB, 0.20528859E-09_JPRB, &
  & 0.20397307E-09_JPRB, 0.20263276E-09_JPRB, 0.20116162E-09_JPRB, 0.19946497E-09_JPRB, 0.19738289E-09_JPRB, 0.19480063E-09_JPRB, &
  & 0.19162037E-09_JPRB, 0.18777101E-09_JPRB, 0.18325960E-09_JPRB, 0.17818229E-09_JPRB, 0.17276161E-09_JPRB, 0.16722648E-09_JPRB, &
  & 0.16181974E-09_JPRB, 0.15666286E-09_JPRB, 0.15183772E-09_JPRB, 0.14733001E-09_JPRB, 0.14310580E-09_JPRB, 0.13913069E-09_JPRB, &
  & 0.13536254E-09_JPRB, 0.13177442E-09_JPRB, 0.12833028E-09_JPRB, 0.12502534E-09_JPRB, 0.12191348E-09_JPRB, 0.11903159E-09_JPRB, &
  & 0.11641103E-09_JPRB, 0.11391920E-09_JPRB, 0.11113651E-09_JPRB, 0.10627415E-09_JPRB /)

RGHG5(:,31,12) = (/ &
  & 0.82590018E-10_JPRB, 0.86466667E-10_JPRB, 0.89012964E-10_JPRB, 0.91481767E-10_JPRB, 0.94189913E-10_JPRB, 0.97255551E-10_JPRB, &
  & 0.10072108E-09_JPRB, 0.10454195E-09_JPRB, 0.10868143E-09_JPRB, 0.11316009E-09_JPRB, 0.11802648E-09_JPRB, 0.12323803E-09_JPRB, &
  & 0.12883745E-09_JPRB, 0.13477522E-09_JPRB, 0.14099624E-09_JPRB, 0.14748298E-09_JPRB, 0.15418848E-09_JPRB, 0.16105609E-09_JPRB, &
  & 0.16806433E-09_JPRB, 0.17514705E-09_JPRB, 0.18224129E-09_JPRB, 0.18925558E-09_JPRB, 0.19605306E-09_JPRB, 0.20244623E-09_JPRB, &
  & 0.20820513E-09_JPRB, 0.21315054E-09_JPRB, 0.21715549E-09_JPRB, 0.22012787E-09_JPRB, 0.22198020E-09_JPRB, 0.22271754E-09_JPRB, &
  & 0.22251635E-09_JPRB, 0.22160215E-09_JPRB, 0.22018397E-09_JPRB, 0.21860978E-09_JPRB, 0.21707254E-09_JPRB, 0.21562055E-09_JPRB, &
  & 0.21425027E-09_JPRB, 0.21290467E-09_JPRB, 0.21147466E-09_JPRB, 0.20984277E-09_JPRB, 0.20785298E-09_JPRB, 0.20538073E-09_JPRB, &
  & 0.20231482E-09_JPRB, 0.19859107E-09_JPRB, 0.19420551E-09_JPRB, 0.18925891E-09_JPRB, 0.18394761E-09_JPRB, 0.17853054E-09_JPRB, &
  & 0.17321265E-09_JPRB, 0.16816835E-09_JPRB, 0.16343482E-09_JPRB, 0.15901030E-09_JPRB, 0.15487182E-09_JPRB, 0.15098159E-09_JPRB, &
  & 0.14731148E-09_JPRB, 0.14379850E-09_JPRB, 0.14042620E-09_JPRB, 0.13720701E-09_JPRB, 0.13418718E-09_JPRB, 0.13144050E-09_JPRB, &
  & 0.12894037E-09_JPRB, 0.12659122E-09_JPRB, 0.12399667E-09_JPRB, 0.11941448E-09_JPRB /)

RGHG5(:,32,12) = (/ &
  & 0.94308575E-10_JPRB, 0.98263363E-10_JPRB, 0.10081791E-09_JPRB, 0.10328876E-09_JPRB, 0.10597005E-09_JPRB, 0.10899513E-09_JPRB, &
  & 0.11237204E-09_JPRB, 0.11604367E-09_JPRB, 0.11997645E-09_JPRB, 0.12418755E-09_JPRB, 0.12872617E-09_JPRB, 0.13362042E-09_JPRB, &
  & 0.13892837E-09_JPRB, 0.14464213E-09_JPRB, 0.15071713E-09_JPRB, 0.15710436E-09_JPRB, 0.16374101E-09_JPRB, 0.17053674E-09_JPRB, &
  & 0.17743597E-09_JPRB, 0.18435609E-09_JPRB, 0.19124564E-09_JPRB, 0.19801424E-09_JPRB, 0.20455462E-09_JPRB, 0.21068092E-09_JPRB, &
  & 0.21622588E-09_JPRB, 0.22104245E-09_JPRB, 0.22502041E-09_JPRB, 0.22807854E-09_JPRB, 0.23010768E-09_JPRB, 0.23108600E-09_JPRB, &
  & 0.23112615E-09_JPRB, 0.23043212E-09_JPRB, 0.22919182E-09_JPRB, 0.22771156E-09_JPRB, 0.22620837E-09_JPRB, 0.22474853E-09_JPRB, &
  & 0.22336871E-09_JPRB, 0.22203217E-09_JPRB, 0.22062863E-09_JPRB, 0.21902959E-09_JPRB, 0.21709316E-09_JPRB, 0.21468091E-09_JPRB, &
  & 0.21169577E-09_JPRB, 0.20806916E-09_JPRB, 0.20380732E-09_JPRB, 0.19902215E-09_JPRB, 0.19389182E-09_JPRB, 0.18861779E-09_JPRB, &
  & 0.18347249E-09_JPRB, 0.17856429E-09_JPRB, 0.17397767E-09_JPRB, 0.16969426E-09_JPRB, 0.16567236E-09_JPRB, 0.16188950E-09_JPRB, &
  & 0.15828211E-09_JPRB, 0.15483301E-09_JPRB, 0.15152303E-09_JPRB, 0.14837251E-09_JPRB, 0.14545054E-09_JPRB, 0.14279937E-09_JPRB, &
  & 0.14043752E-09_JPRB, 0.13819061E-09_JPRB, 0.13574947E-09_JPRB, 0.13140621E-09_JPRB /)

RGHG5(:,33,12) = (/ &
  & 0.10637981E-09_JPRB, 0.11029695E-09_JPRB, 0.11280810E-09_JPRB, 0.11523359E-09_JPRB, 0.11785346E-09_JPRB, 0.12079679E-09_JPRB, &
  & 0.12405403E-09_JPRB, 0.12755927E-09_JPRB, 0.13125252E-09_JPRB, 0.13515891E-09_JPRB, 0.13932804E-09_JPRB, 0.14384822E-09_JPRB, &
  & 0.14880482E-09_JPRB, 0.15424075E-09_JPRB, 0.16013985E-09_JPRB, 0.16643666E-09_JPRB, 0.17302530E-09_JPRB, 0.17976648E-09_JPRB, &
  & 0.18655148E-09_JPRB, 0.19330616E-09_JPRB, 0.19996257E-09_JPRB, 0.20643352E-09_JPRB, 0.21262504E-09_JPRB, 0.21839958E-09_JPRB, &
  & 0.22359578E-09_JPRB, 0.22811653E-09_JPRB, 0.23190835E-09_JPRB, 0.23490443E-09_JPRB, 0.23700428E-09_JPRB, 0.23815425E-09_JPRB, &
  & 0.23842259E-09_JPRB, 0.23797339E-09_JPRB, 0.23697178E-09_JPRB, 0.23566152E-09_JPRB, 0.23426361E-09_JPRB, 0.23285729E-09_JPRB, &
  & 0.23151460E-09_JPRB, 0.23020094E-09_JPRB, 0.22880826E-09_JPRB, 0.22722096E-09_JPRB, 0.22529328E-09_JPRB, 0.22289817E-09_JPRB, &
  & 0.21994821E-09_JPRB, 0.21638208E-09_JPRB, 0.21223523E-09_JPRB, 0.20761776E-09_JPRB, 0.20266167E-09_JPRB, 0.19762671E-09_JPRB, &
  & 0.19268717E-09_JPRB, 0.18801280E-09_JPRB, 0.18359775E-09_JPRB, 0.17944315E-09_JPRB, 0.17553725E-09_JPRB, 0.17183888E-09_JPRB, &
  & 0.16832231E-09_JPRB, 0.16494359E-09_JPRB, 0.16170056E-09_JPRB, 0.15862171E-09_JPRB, 0.15577166E-09_JPRB, 0.15322427E-09_JPRB, &
  & 0.15092887E-09_JPRB, 0.14880495E-09_JPRB, 0.14643423E-09_JPRB, 0.14235066E-09_JPRB /)

RGHG5(:,34,12) = (/ &
  & 0.11859415E-09_JPRB, 0.12234810E-09_JPRB, 0.12477362E-09_JPRB, 0.12709249E-09_JPRB, 0.12962624E-09_JPRB, 0.13245939E-09_JPRB, &
  & 0.13558694E-09_JPRB, 0.13890446E-09_JPRB, 0.14235053E-09_JPRB, 0.14592888E-09_JPRB, 0.14970566E-09_JPRB, 0.15381209E-09_JPRB, &
  & 0.15837559E-09_JPRB, 0.16348997E-09_JPRB, 0.16918093E-09_JPRB, 0.17536764E-09_JPRB, 0.18188659E-09_JPRB, 0.18858770E-09_JPRB, &
  & 0.19531700E-09_JPRB, 0.20195054E-09_JPRB, 0.20838113E-09_JPRB, 0.21453782E-09_JPRB, 0.22035636E-09_JPRB, 0.22570759E-09_JPRB, &
  & 0.23046680E-09_JPRB, 0.23458607E-09_JPRB, 0.23805727E-09_JPRB, 0.24085567E-09_JPRB, 0.24290492E-09_JPRB, 0.24414196E-09_JPRB, &
  & 0.24459260E-09_JPRB, 0.24438679E-09_JPRB, 0.24365548E-09_JPRB, 0.24257604E-09_JPRB, 0.24135124E-09_JPRB, 0.24007332E-09_JPRB, &
  & 0.23881133E-09_JPRB, 0.23753968E-09_JPRB, 0.23616437E-09_JPRB, 0.23457214E-09_JPRB, 0.23262414E-09_JPRB, 0.23020910E-09_JPRB, &
  & 0.22724278E-09_JPRB, 0.22370736E-09_JPRB, 0.21964411E-09_JPRB, 0.21516224E-09_JPRB, 0.21043337E-09_JPRB, 0.20562679E-09_JPRB, &
  & 0.20095843E-09_JPRB, 0.19647517E-09_JPRB, 0.19223821E-09_JPRB, 0.18825153E-09_JPRB, 0.18448619E-09_JPRB, 0.18091467E-09_JPRB, &
  & 0.17747967E-09_JPRB, 0.17417749E-09_JPRB, 0.17099738E-09_JPRB, 0.16798722E-09_JPRB, 0.16522235E-09_JPRB, 0.16273488E-09_JPRB, &
  & 0.16054168E-09_JPRB, 0.15845625E-09_JPRB, 0.15622119E-09_JPRB, 0.15225730E-09_JPRB /)

RGHG5(:,35,12) = (/ &
  & 0.13072268E-09_JPRB, 0.13424754E-09_JPRB, 0.13649604E-09_JPRB, 0.13870013E-09_JPRB, 0.14109543E-09_JPRB, 0.14381422E-09_JPRB, &
  & 0.14679144E-09_JPRB, 0.14992155E-09_JPRB, 0.15310615E-09_JPRB, 0.15634728E-09_JPRB, 0.15972626E-09_JPRB, 0.16339263E-09_JPRB, &
  & 0.16753668E-09_JPRB, 0.17229995E-09_JPRB, 0.17775852E-09_JPRB, 0.18383144E-09_JPRB, 0.19032856E-09_JPRB, 0.19700459E-09_JPRB, &
  & 0.20369342E-09_JPRB, 0.21021646E-09_JPRB, 0.21645494E-09_JPRB, 0.22232682E-09_JPRB, 0.22775645E-09_JPRB, 0.23262857E-09_JPRB, &
  & 0.23688274E-09_JPRB, 0.24050678E-09_JPRB, 0.24354438E-09_JPRB, 0.24601779E-09_JPRB, 0.24787980E-09_JPRB, 0.24908864E-09_JPRB, &
  & 0.24964203E-09_JPRB, 0.24964600E-09_JPRB, 0.24918273E-09_JPRB, 0.24837440E-09_JPRB, 0.24739513E-09_JPRB, 0.24630989E-09_JPRB, &
  & 0.24518698E-09_JPRB, 0.24400629E-09_JPRB, 0.24268154E-09_JPRB, 0.24110566E-09_JPRB, 0.23915120E-09_JPRB, 0.23670144E-09_JPRB, &
  & 0.23371080E-09_JPRB, 0.23017632E-09_JPRB, 0.22617536E-09_JPRB, 0.22184068E-09_JPRB, 0.21730177E-09_JPRB, 0.21276478E-09_JPRB, &
  & 0.20831040E-09_JPRB, 0.20406336E-09_JPRB, 0.20003060E-09_JPRB, 0.19620333E-09_JPRB, 0.19256932E-09_JPRB, 0.18908426E-09_JPRB, &
  & 0.18575007E-09_JPRB, 0.18252572E-09_JPRB, 0.17943258E-09_JPRB, 0.17650009E-09_JPRB, 0.17380264E-09_JPRB, 0.17140206E-09_JPRB, &
  & 0.16925286E-09_JPRB, 0.16727161E-09_JPRB, 0.16507429E-09_JPRB, 0.16130916E-09_JPRB /)

RGHG5(:,36,12) = (/ &
  & 0.14260675E-09_JPRB, 0.14578969E-09_JPRB, 0.14786983E-09_JPRB, 0.14988868E-09_JPRB, 0.15215409E-09_JPRB, 0.15472193E-09_JPRB, &
  & 0.15754892E-09_JPRB, 0.16047505E-09_JPRB, 0.16339570E-09_JPRB, 0.16629786E-09_JPRB, 0.16927582E-09_JPRB, 0.17250112E-09_JPRB, &
  & 0.17620239E-09_JPRB, 0.18058581E-09_JPRB, 0.18578307E-09_JPRB, 0.19171537E-09_JPRB, 0.19818612E-09_JPRB, 0.20488330E-09_JPRB, &
  & 0.21155433E-09_JPRB, 0.21801831E-09_JPRB, 0.22410801E-09_JPRB, 0.22971663E-09_JPRB, 0.23473115E-09_JPRB, 0.23908153E-09_JPRB, &
  & 0.24273439E-09_JPRB, 0.24576480E-09_JPRB, 0.24825497E-09_JPRB, 0.25026581E-09_JPRB, 0.25181368E-09_JPRB, 0.25285996E-09_JPRB, &
  & 0.25341590E-09_JPRB, 0.25355637E-09_JPRB, 0.25330890E-09_JPRB, 0.25277702E-09_JPRB, 0.25206293E-09_JPRB, 0.25121272E-09_JPRB, &
  & 0.25028959E-09_JPRB, 0.24926053E-09_JPRB, 0.24806385E-09_JPRB, 0.24659721E-09_JPRB, 0.24472097E-09_JPRB, 0.24233335E-09_JPRB, &
  & 0.23937580E-09_JPRB, 0.23587446E-09_JPRB, 0.23194810E-09_JPRB, 0.22772184E-09_JPRB, 0.22339093E-09_JPRB, 0.21905644E-09_JPRB, &
  & 0.21486032E-09_JPRB, 0.21082583E-09_JPRB, 0.20696519E-09_JPRB, 0.20328049E-09_JPRB, 0.19975374E-09_JPRB, 0.19639221E-09_JPRB, &
  & 0.19315648E-09_JPRB, 0.19004189E-09_JPRB, 0.18703561E-09_JPRB, 0.18419105E-09_JPRB, 0.18157501E-09_JPRB, 0.17923595E-09_JPRB, &
  & 0.17717544E-09_JPRB, 0.17524346E-09_JPRB, 0.17316827E-09_JPRB, 0.16954310E-09_JPRB /)

RGHG5(:,37,12) = (/ &
  & 0.15408408E-09_JPRB, 0.15691379E-09_JPRB, 0.15875565E-09_JPRB, 0.16060830E-09_JPRB, 0.16270064E-09_JPRB, 0.16512336E-09_JPRB, &
  & 0.16777643E-09_JPRB, 0.17049345E-09_JPRB, 0.17314356E-09_JPRB, 0.17571136E-09_JPRB, 0.17830418E-09_JPRB, 0.18109579E-09_JPRB, &
  & 0.18434818E-09_JPRB, 0.18832413E-09_JPRB, 0.19321250E-09_JPRB, 0.19899131E-09_JPRB, 0.20539141E-09_JPRB, 0.21212190E-09_JPRB, &
  & 0.21882920E-09_JPRB, 0.22524869E-09_JPRB, 0.23118378E-09_JPRB, 0.23645383E-09_JPRB, 0.24095936E-09_JPRB, 0.24466096E-09_JPRB, &
  & 0.24763222E-09_JPRB, 0.24998778E-09_JPRB, 0.25187141E-09_JPRB, 0.25338293E-09_JPRB, 0.25455654E-09_JPRB, 0.25539090E-09_JPRB, &
  & 0.25588190E-09_JPRB, 0.25607835E-09_JPRB, 0.25597210E-09_JPRB, 0.25565283E-09_JPRB, 0.25515487E-09_JPRB, 0.25453273E-09_JPRB, &
  & 0.25381172E-09_JPRB, 0.25297697E-09_JPRB, 0.25197960E-09_JPRB, 0.25072042E-09_JPRB, 0.24907745E-09_JPRB, 0.24691216E-09_JPRB, &
  & 0.24415209E-09_JPRB, 0.24080582E-09_JPRB, 0.23698413E-09_JPRB, 0.23290797E-09_JPRB, 0.22873639E-09_JPRB, 0.22463133E-09_JPRB, &
  & 0.22063947E-09_JPRB, 0.21679261E-09_JPRB, 0.21309131E-09_JPRB, 0.20953231E-09_JPRB, 0.20613604E-09_JPRB, 0.20288253E-09_JPRB, &
  & 0.19977521E-09_JPRB, 0.19678317E-09_JPRB, 0.19390548E-09_JPRB, 0.19116642E-09_JPRB, 0.18863908E-09_JPRB, 0.18638040E-09_JPRB, &
  & 0.18438358E-09_JPRB, 0.18254498E-09_JPRB, 0.18054623E-09_JPRB, 0.17709677E-09_JPRB /)

RGHG5(:,38,12) = (/ &
  & 0.16500010E-09_JPRB, 0.16745096E-09_JPRB, 0.16908230E-09_JPRB, 0.17074865E-09_JPRB, 0.17267669E-09_JPRB, 0.17493687E-09_JPRB, &
  & 0.17740907E-09_JPRB, 0.17990442E-09_JPRB, 0.18228286E-09_JPRB, 0.18453952E-09_JPRB, 0.18676513E-09_JPRB, 0.18917010E-09_JPRB, &
  & 0.19197501E-09_JPRB, 0.19553943E-09_JPRB, 0.20007587E-09_JPRB, 0.20567470E-09_JPRB, 0.21203846E-09_JPRB, 0.21874513E-09_JPRB, &
  & 0.22541530E-09_JPRB, 0.23172615E-09_JPRB, 0.23735411E-09_JPRB, 0.24211189E-09_JPRB, 0.24592786E-09_JPRB, 0.24889465E-09_JPRB, &
  & 0.25115782E-09_JPRB, 0.25290475E-09_JPRB, 0.25427938E-09_JPRB, 0.25538524E-09_JPRB, 0.25626956E-09_JPRB, 0.25692284E-09_JPRB, &
  & 0.25735430E-09_JPRB, 0.25755742E-09_JPRB, 0.25753827E-09_JPRB, 0.25734218E-09_JPRB, 0.25699329E-09_JPRB, 0.25653277E-09_JPRB, &
  & 0.25597269E-09_JPRB, 0.25530891E-09_JPRB, 0.25450214E-09_JPRB, 0.25347907E-09_JPRB, 0.25212227E-09_JPRB, 0.25029701E-09_JPRB, &
  & 0.24787955E-09_JPRB, 0.24482866E-09_JPRB, 0.24125815E-09_JPRB, 0.23736635E-09_JPRB, 0.23340541E-09_JPRB, 0.22949379E-09_JPRB, &
  & 0.22570282E-09_JPRB, 0.22203911E-09_JPRB, 0.21848191E-09_JPRB, 0.21505370E-09_JPRB, 0.21176527E-09_JPRB, 0.20864308E-09_JPRB, &
  & 0.20568371E-09_JPRB, 0.20286414E-09_JPRB, 0.20015209E-09_JPRB, 0.19755619E-09_JPRB, 0.19513453E-09_JPRB, 0.19295766E-09_JPRB, &
  & 0.19103885E-09_JPRB, 0.18926967E-09_JPRB, 0.18736969E-09_JPRB, 0.18407878E-09_JPRB /)

RGHG5(:,39,12) = (/ &
  & 0.17518204E-09_JPRB, 0.17728659E-09_JPRB, 0.17871873E-09_JPRB, 0.18020992E-09_JPRB, 0.18199318E-09_JPRB, 0.18408496E-09_JPRB, &
  & 0.18637224E-09_JPRB, 0.18863741E-09_JPRB, 0.19076021E-09_JPRB, 0.19271901E-09_JPRB, 0.19464810E-09_JPRB, 0.19668113E-09_JPRB, &
  & 0.19912597E-09_JPRB, 0.20223763E-09_JPRB, 0.20643226E-09_JPRB, 0.21173850E-09_JPRB, 0.21797988E-09_JPRB, 0.22463917E-09_JPRB, &
  & 0.23118629E-09_JPRB, 0.23716429E-09_JPRB, 0.24227709E-09_JPRB, 0.24633154E-09_JPRB, 0.24941471E-09_JPRB, 0.25170574E-09_JPRB, &
  & 0.25342239E-09_JPRB, 0.25473168E-09_JPRB, 0.25576824E-09_JPRB, 0.25661617E-09_JPRB, 0.25731225E-09_JPRB, 0.25785282E-09_JPRB, &
  & 0.25823782E-09_JPRB, 0.25843780E-09_JPRB, 0.25846886E-09_JPRB, 0.25833924E-09_JPRB, 0.25808466E-09_JPRB, 0.25772523E-09_JPRB, &
  & 0.25727701E-09_JPRB, 0.25673699E-09_JPRB, 0.25607508E-09_JPRB, 0.25523758E-09_JPRB, 0.25412719E-09_JPRB, 0.25261371E-09_JPRB, &
  & 0.25057337E-09_JPRB, 0.24792277E-09_JPRB, 0.24470159E-09_JPRB, 0.24112273E-09_JPRB, 0.23738850E-09_JPRB, 0.23369978E-09_JPRB, &
  & 0.23010657E-09_JPRB, 0.22659842E-09_JPRB, 0.22318267E-09_JPRB, 0.21986814E-09_JPRB, 0.21670438E-09_JPRB, 0.21374723E-09_JPRB, &
  & 0.21097182E-09_JPRB, 0.20837304E-09_JPRB, 0.20586344E-09_JPRB, 0.20344953E-09_JPRB, 0.20116285E-09_JPRB, 0.19909038E-09_JPRB, &
  & 0.19725149E-09_JPRB, 0.19556648E-09_JPRB, 0.19374950E-09_JPRB, 0.19061382E-09_JPRB /)

RGHG5(:,40,12) = (/ &
  & 0.18445817E-09_JPRB, 0.18628651E-09_JPRB, 0.18754547E-09_JPRB, 0.18891277E-09_JPRB, 0.19054683E-09_JPRB, 0.19250881E-09_JPRB, &
  & 0.19460411E-09_JPRB, 0.19665082E-09_JPRB, 0.19852452E-09_JPRB, 0.20024980E-09_JPRB, 0.20189229E-09_JPRB, 0.20367291E-09_JPRB, &
  & 0.20574557E-09_JPRB, 0.20852345E-09_JPRB, 0.21228591E-09_JPRB, 0.21734473E-09_JPRB, 0.22335828E-09_JPRB, 0.22980184E-09_JPRB, &
  & 0.23603769E-09_JPRB, 0.24152269E-09_JPRB, 0.24592686E-09_JPRB, 0.24927049E-09_JPRB, 0.25171742E-09_JPRB, 0.25351510E-09_JPRB, &
  & 0.25485336E-09_JPRB, 0.25588731E-09_JPRB, 0.25671523E-09_JPRB, 0.25740673E-09_JPRB, 0.25798830E-09_JPRB, 0.25845998E-09_JPRB, &
  & 0.25880828E-09_JPRB, 0.25900873E-09_JPRB, 0.25906180E-09_JPRB, 0.25897501E-09_JPRB, 0.25877542E-09_JPRB, 0.25848110E-09_JPRB, &
  & 0.25810853E-09_JPRB, 0.25765323E-09_JPRB, 0.25709651E-09_JPRB, 0.25639313E-09_JPRB, 0.25546384E-09_JPRB, 0.25420260E-09_JPRB, &
  & 0.25249045E-09_JPRB, 0.25023025E-09_JPRB, 0.24742314E-09_JPRB, 0.24417771E-09_JPRB, 0.24075938E-09_JPRB, 0.23731045E-09_JPRB, &
  & 0.23391455E-09_JPRB, 0.23058219E-09_JPRB, 0.22729582E-09_JPRB, 0.22409448E-09_JPRB, 0.22107752E-09_JPRB, 0.21827257E-09_JPRB, &
  & 0.21573036E-09_JPRB, 0.21334913E-09_JPRB, 0.21109296E-09_JPRB, 0.20888993E-09_JPRB, 0.20678526E-09_JPRB, 0.20484346E-09_JPRB, &
  & 0.20311583E-09_JPRB, 0.20151890E-09_JPRB, 0.19980582E-09_JPRB, 0.19681644E-09_JPRB /)

RGHG5(:,41,12) = (/ &
  & 0.19279862E-09_JPRB, 0.19440836E-09_JPRB, 0.19555126E-09_JPRB, 0.19679772E-09_JPRB, 0.19835950E-09_JPRB, 0.20018455E-09_JPRB, &
  & 0.20211886E-09_JPRB, 0.20395413E-09_JPRB, 0.20562230E-09_JPRB, 0.20712132E-09_JPRB, 0.20857985E-09_JPRB, 0.21009079E-09_JPRB, &
  & 0.21194332E-09_JPRB, 0.21433617E-09_JPRB, 0.21777030E-09_JPRB, 0.22241892E-09_JPRB, 0.22816338E-09_JPRB, 0.23426378E-09_JPRB, &
  & 0.24002902E-09_JPRB, 0.24487690E-09_JPRB, 0.24861424E-09_JPRB, 0.25133054E-09_JPRB, 0.25329516E-09_JPRB, 0.25473387E-09_JPRB, &
  & 0.25582242E-09_JPRB, 0.25667490E-09_JPRB, 0.25737179E-09_JPRB, 0.25796490E-09_JPRB, 0.25847199E-09_JPRB, 0.25890001E-09_JPRB, &
  & 0.25921776E-09_JPRB, 0.25941832E-09_JPRB, 0.25948074E-09_JPRB, 0.25942121E-09_JPRB, 0.25925551E-09_JPRB, 0.25900515E-09_JPRB, &
  & 0.25868402E-09_JPRB, 0.25829069E-09_JPRB, 0.25780986E-09_JPRB, 0.25720578E-09_JPRB, 0.25641483E-09_JPRB, 0.25534924E-09_JPRB, &
  & 0.25390487E-09_JPRB, 0.25198255E-09_JPRB, 0.24954208E-09_JPRB, 0.24669275E-09_JPRB, 0.24358388E-09_JPRB, 0.24041077E-09_JPRB, &
  & 0.23723912E-09_JPRB, 0.23407215E-09_JPRB, 0.23091262E-09_JPRB, 0.22784374E-09_JPRB, 0.22493211E-09_JPRB, 0.22234040E-09_JPRB, &
  & 0.21999395E-09_JPRB, 0.21788368E-09_JPRB, 0.21587135E-09_JPRB, 0.21392095E-09_JPRB, 0.21202703E-09_JPRB, 0.21026977E-09_JPRB, &
  & 0.20868787E-09_JPRB, 0.20721957E-09_JPRB, 0.20562214E-09_JPRB, 0.20282696E-09_JPRB /)

RGHG5(:,42,12) = (/ &
  & 0.20026064E-09_JPRB, 0.20172780E-09_JPRB, 0.20277924E-09_JPRB, 0.20397631E-09_JPRB, 0.20545550E-09_JPRB, 0.20720936E-09_JPRB, &
  & 0.20898883E-09_JPRB, 0.21064674E-09_JPRB, 0.21212480E-09_JPRB, 0.21346451E-09_JPRB, 0.21473170E-09_JPRB, 0.21609137E-09_JPRB, &
  & 0.21767381E-09_JPRB, 0.21983854E-09_JPRB, 0.22286738E-09_JPRB, 0.22718595E-09_JPRB, 0.23253764E-09_JPRB, 0.23820049E-09_JPRB, &
  & 0.24335767E-09_JPRB, 0.24753716E-09_JPRB, 0.25063135E-09_JPRB, 0.25284733E-09_JPRB, 0.25443825E-09_JPRB, 0.25562127E-09_JPRB, &
  & 0.25653135E-09_JPRB, 0.25726166E-09_JPRB, 0.25786964E-09_JPRB, 0.25839672E-09_JPRB, 0.25885499E-09_JPRB, 0.25924823E-09_JPRB, &
  & 0.25954466E-09_JPRB, 0.25973856E-09_JPRB, 0.25980679E-09_JPRB, 0.25976296E-09_JPRB, 0.25961966E-09_JPRB, 0.25939956E-09_JPRB, &
  & 0.25911540E-09_JPRB, 0.25876851E-09_JPRB, 0.25834612E-09_JPRB, 0.25781913E-09_JPRB, 0.25713609E-09_JPRB, 0.25622399E-09_JPRB, &
  & 0.25499361E-09_JPRB, 0.25335473E-09_JPRB, 0.25126473E-09_JPRB, 0.24875890E-09_JPRB, 0.24599439E-09_JPRB, 0.24310082E-09_JPRB, &
  & 0.24016281E-09_JPRB, 0.23718011E-09_JPRB, 0.23417224E-09_JPRB, 0.23119139E-09_JPRB, 0.22845434E-09_JPRB, 0.22601163E-09_JPRB, &
  & 0.22392001E-09_JPRB, 0.22204028E-09_JPRB, 0.22029635E-09_JPRB, 0.21859742E-09_JPRB, 0.21695551E-09_JPRB, 0.21541965E-09_JPRB, &
  & 0.21403002E-09_JPRB, 0.21272736E-09_JPRB, 0.21129605E-09_JPRB, 0.20874774E-09_JPRB /)

RGHG5(:,43,12) = (/ &
  & 0.20699199E-09_JPRB, 0.20837482E-09_JPRB, 0.20937696E-09_JPRB, 0.21052543E-09_JPRB, 0.21199345E-09_JPRB, 0.21366935E-09_JPRB, &
  & 0.21533610E-09_JPRB, 0.21684007E-09_JPRB, 0.21817323E-09_JPRB, 0.21936414E-09_JPRB, 0.22050639E-09_JPRB, 0.22169108E-09_JPRB, &
  & 0.22311747E-09_JPRB, 0.22497518E-09_JPRB, 0.22771501E-09_JPRB, 0.23157390E-09_JPRB, 0.23651789E-09_JPRB, 0.24168539E-09_JPRB, &
  & 0.24620558E-09_JPRB, 0.24969848E-09_JPRB, 0.25222127E-09_JPRB, 0.25401506E-09_JPRB, 0.25531904E-09_JPRB, 0.25630764E-09_JPRB, &
  & 0.25708735E-09_JPRB, 0.25773000E-09_JPRB, 0.25827529E-09_JPRB, 0.25875591E-09_JPRB, 0.25918140E-09_JPRB, 0.25954400E-09_JPRB, &
  & 0.25982472E-09_JPRB, 0.26000727E-09_JPRB, 0.26007832E-09_JPRB, 0.26004301E-09_JPRB, 0.25991512E-09_JPRB, 0.25971592E-09_JPRB, &
  & 0.25945943E-09_JPRB, 0.25914831E-09_JPRB, 0.25877261E-09_JPRB, 0.25830824E-09_JPRB, 0.25771363E-09_JPRB, 0.25692884E-09_JPRB, &
  & 0.25588057E-09_JPRB, 0.25448757E-09_JPRB, 0.25269267E-09_JPRB, 0.25051747E-09_JPRB, 0.24806068E-09_JPRB, 0.24545982E-09_JPRB, &
  & 0.24276969E-09_JPRB, 0.23999366E-09_JPRB, 0.23712921E-09_JPRB, 0.23431590E-09_JPRB, 0.23170751E-09_JPRB, 0.22948199E-09_JPRB, &
  & 0.22760169E-09_JPRB, 0.22596938E-09_JPRB, 0.22446671E-09_JPRB, 0.22302607E-09_JPRB, 0.22164012E-09_JPRB, 0.22035232E-09_JPRB, &
  & 0.21918910E-09_JPRB, 0.21808833E-09_JPRB, 0.21686113E-09_JPRB, 0.21464741E-09_JPRB /)

RGHG5(:,44,12) = (/ &
  & 0.21316945E-09_JPRB, 0.21449578E-09_JPRB, 0.21547547E-09_JPRB, 0.21661080E-09_JPRB, 0.21805557E-09_JPRB, 0.21969658E-09_JPRB, &
  & 0.22126542E-09_JPRB, 0.22265845E-09_JPRB, 0.22387070E-09_JPRB, 0.22495264E-09_JPRB, 0.22597056E-09_JPRB, 0.22703342E-09_JPRB, &
  & 0.22826407E-09_JPRB, 0.22991664E-09_JPRB, 0.23227395E-09_JPRB, 0.23577029E-09_JPRB, 0.24019192E-09_JPRB, 0.24475386E-09_JPRB, &
  & 0.24861077E-09_JPRB, 0.25147054E-09_JPRB, 0.25349861E-09_JPRB, 0.25494779E-09_JPRB, 0.25602517E-09_JPRB, 0.25686284E-09_JPRB, &
  & 0.25754432E-09_JPRB, 0.25812094E-09_JPRB, 0.25862348E-09_JPRB, 0.25906896E-09_JPRB, 0.25947197E-09_JPRB, 0.25980909E-09_JPRB, &
  & 0.26007349E-09_JPRB, 0.26024444E-09_JPRB, 0.26031427E-09_JPRB, 0.26028343E-09_JPRB, 0.26016556E-09_JPRB, 0.25998115E-09_JPRB, &
  & 0.25974534E-09_JPRB, 0.25946240E-09_JPRB, 0.25912461E-09_JPRB, 0.25871277E-09_JPRB, 0.25819263E-09_JPRB, 0.25751695E-09_JPRB, &
  & 0.25662386E-09_JPRB, 0.25544272E-09_JPRB, 0.25391478E-09_JPRB, 0.25203345E-09_JPRB, 0.24987962E-09_JPRB, 0.24755439E-09_JPRB, &
  & 0.24511562E-09_JPRB, 0.24255659E-09_JPRB, 0.23990060E-09_JPRB, 0.23724972E-09_JPRB, 0.23484464E-09_JPRB, 0.23283370E-09_JPRB, &
  & 0.23117352E-09_JPRB, 0.22976944E-09_JPRB, 0.22849361E-09_JPRB, 0.22729008E-09_JPRB, 0.22615208E-09_JPRB, 0.22511140E-09_JPRB, &
  & 0.22417845E-09_JPRB, 0.22329315E-09_JPRB, 0.22229682E-09_JPRB, 0.22047511E-09_JPRB /)

RGHG5(:,45,12) = (/ &
  & 0.21890935E-09_JPRB, 0.22023633E-09_JPRB, 0.22118969E-09_JPRB, 0.22232254E-09_JPRB, 0.22375465E-09_JPRB, 0.22536119E-09_JPRB, &
  & 0.22686492E-09_JPRB, 0.22817589E-09_JPRB, 0.22930166E-09_JPRB, 0.23028945E-09_JPRB, 0.23120428E-09_JPRB, 0.23213750E-09_JPRB, &
  & 0.23320776E-09_JPRB, 0.23461122E-09_JPRB, 0.23665478E-09_JPRB, 0.23967600E-09_JPRB, 0.24357963E-09_JPRB, 0.24749724E-09_JPRB, &
  & 0.25064167E-09_JPRB, 0.25292593E-09_JPRB, 0.25453584E-09_JPRB, 0.25570887E-09_JPRB, 0.25660296E-09_JPRB, 0.25732610E-09_JPRB, &
  & 0.25792982E-09_JPRB, 0.25845878E-09_JPRB, 0.25892874E-09_JPRB, 0.25935248E-09_JPRB, 0.25973512E-09_JPRB, 0.26005248E-09_JPRB, &
  & 0.26029964E-09_JPRB, 0.26045852E-09_JPRB, 0.26052413E-09_JPRB, 0.26049496E-09_JPRB, 0.26038316E-09_JPRB, 0.26020883E-09_JPRB, &
  & 0.25998848E-09_JPRB, 0.25972768E-09_JPRB, 0.25942098E-09_JPRB, 0.25905295E-09_JPRB, 0.25859695E-09_JPRB, 0.25801400E-09_JPRB, &
  & 0.25725730E-09_JPRB, 0.25626595E-09_JPRB, 0.25498234E-09_JPRB, 0.25338176E-09_JPRB, 0.25150404E-09_JPRB, 0.24944419E-09_JPRB, &
  & 0.24725449E-09_JPRB, 0.24493477E-09_JPRB, 0.24248920E-09_JPRB, 0.24008237E-09_JPRB, 0.23791191E-09_JPRB, 0.23613222E-09_JPRB, &
  & 0.23470598E-09_JPRB, 0.23350336E-09_JPRB, 0.23243868E-09_JPRB, 0.23144492E-09_JPRB, 0.23052849E-09_JPRB, 0.22970928E-09_JPRB, &
  & 0.22898486E-09_JPRB, 0.22830084E-09_JPRB, 0.22752551E-09_JPRB, 0.22609904E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART23',1,ZHOOK_HANDLE)
END SUBROUTINE PART23




SUBROUTINE PART24
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART24',0,ZHOOK_HANDLE)



RGHG5(:,46,12) = (/ &
  & 0.22433919E-09_JPRB, 0.22564581E-09_JPRB, 0.22661084E-09_JPRB, 0.22772020E-09_JPRB, 0.22914824E-09_JPRB, 0.23071371E-09_JPRB, &
  & 0.23217914E-09_JPRB, 0.23342883E-09_JPRB, 0.23449012E-09_JPRB, 0.23538976E-09_JPRB, 0.23620880E-09_JPRB, 0.23700947E-09_JPRB, &
  & 0.23792765E-09_JPRB, 0.23908450E-09_JPRB, 0.24082264E-09_JPRB, 0.24335767E-09_JPRB, 0.24666968E-09_JPRB, 0.24985336E-09_JPRB, &
  & 0.25234909E-09_JPRB, 0.25411492E-09_JPRB, 0.25538405E-09_JPRB, 0.25633379E-09_JPRB, 0.25708857E-09_JPRB, 0.25771646E-09_JPRB, &
  & 0.25826552E-09_JPRB, 0.25875480E-09_JPRB, 0.25920627E-09_JPRB, 0.25960986E-09_JPRB, 0.25997987E-09_JPRB, 0.26027741E-09_JPRB, &
  & 0.26050767E-09_JPRB, 0.26065416E-09_JPRB, 0.26071345E-09_JPRB, 0.26068367E-09_JPRB, 0.26057492E-09_JPRB, 0.26040733E-09_JPRB, &
  & 0.26019822E-09_JPRB, 0.25995445E-09_JPRB, 0.25967306E-09_JPRB, 0.25934199E-09_JPRB, 0.25893962E-09_JPRB, 0.25843816E-09_JPRB, &
  & 0.25779945E-09_JPRB, 0.25697855E-09_JPRB, 0.25592317E-09_JPRB, 0.25458868E-09_JPRB, 0.25299154E-09_JPRB, 0.25119312E-09_JPRB, &
  & 0.24924837E-09_JPRB, 0.24716165E-09_JPRB, 0.24498761E-09_JPRB, 0.24281210E-09_JPRB, 0.24093766E-09_JPRB, 0.23940164E-09_JPRB, &
  & 0.23819319E-09_JPRB, 0.23719191E-09_JPRB, 0.23630486E-09_JPRB, 0.23549887E-09_JPRB, 0.23476671E-09_JPRB, 0.23413035E-09_JPRB, &
  & 0.23357710E-09_JPRB, 0.23305849E-09_JPRB, 0.23246798E-09_JPRB, 0.23138592E-09_JPRB /)

RGHG5(:,47,12) = (/ &
  & 0.22946800E-09_JPRB, 0.23079647E-09_JPRB, 0.23174128E-09_JPRB, 0.23285268E-09_JPRB, 0.23424002E-09_JPRB, 0.23578731E-09_JPRB, &
  & 0.23720195E-09_JPRB, 0.23842206E-09_JPRB, 0.23940594E-09_JPRB, 0.24022884E-09_JPRB, 0.24093183E-09_JPRB, 0.24162239E-09_JPRB, &
  & 0.24235508E-09_JPRB, 0.24333507E-09_JPRB, 0.24468416E-09_JPRB, 0.24678945E-09_JPRB, 0.24938132E-09_JPRB, 0.25186817E-09_JPRB, &
  & 0.25373870E-09_JPRB, 0.25508617E-09_JPRB, 0.25607716E-09_JPRB, 0.25685437E-09_JPRB, 0.25749641E-09_JPRB, 0.25805535E-09_JPRB, &
  & 0.25855926E-09_JPRB, 0.25902355E-09_JPRB, 0.25945784E-09_JPRB, 0.25985283E-09_JPRB, 0.26020433E-09_JPRB, 0.26048799E-09_JPRB, &
  & 0.26069957E-09_JPRB, 0.26083372E-09_JPRB, 0.26088556E-09_JPRB, 0.26085320E-09_JPRB, 0.26074520E-09_JPRB, 0.26058183E-09_JPRB, &
  & 0.26038058E-09_JPRB, 0.26015021E-09_JPRB, 0.25988905E-09_JPRB, 0.25958816E-09_JPRB, 0.25923180E-09_JPRB, 0.25879765E-09_JPRB, &
  & 0.25826208E-09_JPRB, 0.25759234E-09_JPRB, 0.25674604E-09_JPRB, 0.25568184E-09_JPRB, 0.25436858E-09_JPRB, 0.25284425E-09_JPRB, &
  & 0.25115504E-09_JPRB, 0.24932886E-09_JPRB, 0.24737876E-09_JPRB, 0.24553642E-09_JPRB, 0.24389124E-09_JPRB, 0.24263183E-09_JPRB, &
  & 0.24162164E-09_JPRB, 0.24079466E-09_JPRB, 0.24007260E-09_JPRB, 0.23941493E-09_JPRB, 0.23883565E-09_JPRB, 0.23833963E-09_JPRB, &
  & 0.23791805E-09_JPRB, 0.23752345E-09_JPRB, 0.23707894E-09_JPRB, 0.23625410E-09_JPRB /)

RGHG5(:,48,12) = (/ &
  & 0.23432023E-09_JPRB, 0.23565083E-09_JPRB, 0.23659952E-09_JPRB, 0.23768726E-09_JPRB, 0.23905666E-09_JPRB, 0.24055585E-09_JPRB, &
  & 0.24196184E-09_JPRB, 0.24311533E-09_JPRB, 0.24404137E-09_JPRB, 0.24475449E-09_JPRB, 0.24535898E-09_JPRB, 0.24590630E-09_JPRB, &
  & 0.24651081E-09_JPRB, 0.24723734E-09_JPRB, 0.24831154E-09_JPRB, 0.24982239E-09_JPRB, 0.25174621E-09_JPRB, 0.25351485E-09_JPRB, &
  & 0.25487279E-09_JPRB, 0.25587110E-09_JPRB, 0.25664834E-09_JPRB, 0.25728811E-09_JPRB, 0.25784683E-09_JPRB, 0.25835073E-09_JPRB, &
  & 0.25882402E-09_JPRB, 0.25926947E-09_JPRB, 0.25969460E-09_JPRB, 0.26007693E-09_JPRB, 0.26041691E-09_JPRB, 0.26068195E-09_JPRB, &
  & 0.26087768E-09_JPRB, 0.26099881E-09_JPRB, 0.26104241E-09_JPRB, 0.26100588E-09_JPRB, 0.26089744E-09_JPRB, 0.26073604E-09_JPRB, &
  & 0.26054067E-09_JPRB, 0.26032029E-09_JPRB, 0.26007527E-09_JPRB, 0.25979932E-09_JPRB, 0.25947983E-09_JPRB, 0.25910324E-09_JPRB, &
  & 0.25865393E-09_JPRB, 0.25811400E-09_JPRB, 0.25746080E-09_JPRB, 0.25664837E-09_JPRB, 0.25564306E-09_JPRB, 0.25442415E-09_JPRB, &
  & 0.25301736E-09_JPRB, 0.25144833E-09_JPRB, 0.24980581E-09_JPRB, 0.24818578E-09_JPRB, 0.24686375E-09_JPRB, 0.24579988E-09_JPRB, &
  & 0.24498600E-09_JPRB, 0.24430885E-09_JPRB, 0.24371574E-09_JPRB, 0.24318453E-09_JPRB, 0.24271701E-09_JPRB, 0.24232769E-09_JPRB, &
  & 0.24199845E-09_JPRB, 0.24169550E-09_JPRB, 0.24134994E-09_JPRB, 0.24071825E-09_JPRB /)

RGHG5(:,49,12) = (/ &
  & 0.23886973E-09_JPRB, 0.24018876E-09_JPRB, 0.24113861E-09_JPRB, 0.24220922E-09_JPRB, 0.24355248E-09_JPRB, 0.24503519E-09_JPRB, &
  & 0.24639774E-09_JPRB, 0.24751046E-09_JPRB, 0.24832397E-09_JPRB, 0.24893346E-09_JPRB, 0.24940813E-09_JPRB, 0.24983299E-09_JPRB, &
  & 0.25026620E-09_JPRB, 0.25078223E-09_JPRB, 0.25148506E-09_JPRB, 0.25245883E-09_JPRB, 0.25367997E-09_JPRB, 0.25484767E-09_JPRB, &
  & 0.25577854E-09_JPRB, 0.25651259E-09_JPRB, 0.25712010E-09_JPRB, 0.25765590E-09_JPRB, 0.25814897E-09_JPRB, 0.25861513E-09_JPRB, &
  & 0.25906599E-09_JPRB, 0.25950020E-09_JPRB, 0.25991675E-09_JPRB, 0.26029023E-09_JPRB, 0.26061234E-09_JPRB, 0.26086305E-09_JPRB, &
  & 0.26104219E-09_JPRB, 0.26115082E-09_JPRB, 0.26118580E-09_JPRB, 0.26114425E-09_JPRB, 0.26103381E-09_JPRB, 0.26087366E-09_JPRB, &
  & 0.26068217E-09_JPRB, 0.26046959E-09_JPRB, 0.26023741E-09_JPRB, 0.25998104E-09_JPRB, 0.25969210E-09_JPRB, 0.25936148E-09_JPRB, &
  & 0.25898370E-09_JPRB, 0.25855443E-09_JPRB, 0.25806299E-09_JPRB, 0.25748856E-09_JPRB, 0.25678146E-09_JPRB, 0.25590202E-09_JPRB, &
  & 0.25482599E-09_JPRB, 0.25357025E-09_JPRB, 0.25220545E-09_JPRB, 0.25091335E-09_JPRB, 0.24981855E-09_JPRB, 0.24898011E-09_JPRB, &
  & 0.24831581E-09_JPRB, 0.24776547E-09_JPRB, 0.24727712E-09_JPRB, 0.24683702E-09_JPRB, 0.24645427E-09_JPRB, 0.24613606E-09_JPRB, &
  & 0.24587210E-09_JPRB, 0.24562777E-09_JPRB, 0.24535160E-09_JPRB, 0.24484220E-09_JPRB /)

RGHG5(:,50,12) = (/ &
  & 0.24302943E-09_JPRB, 0.24437843E-09_JPRB, 0.24528438E-09_JPRB, 0.24636160E-09_JPRB, 0.24767163E-09_JPRB, 0.24914390E-09_JPRB, &
  & 0.25045777E-09_JPRB, 0.25145200E-09_JPRB, 0.25212638E-09_JPRB, 0.25257718E-09_JPRB, 0.25290769E-09_JPRB, 0.25318211E-09_JPRB, &
  & 0.25343341E-09_JPRB, 0.25372829E-09_JPRB, 0.25406641E-09_JPRB, 0.25457242E-09_JPRB, 0.25520985E-09_JPRB, 0.25589958E-09_JPRB, &
  & 0.25650904E-09_JPRB, 0.25703678E-09_JPRB, 0.25751823E-09_JPRB, 0.25797223E-09_JPRB, 0.25841554E-09_JPRB, 0.25885555E-09_JPRB, &
  & 0.25929153E-09_JPRB, 0.25971966E-09_JPRB, 0.26012689E-09_JPRB, 0.26048930E-09_JPRB, 0.26079514E-09_JPRB, 0.26102973E-09_JPRB, &
  & 0.26119459E-09_JPRB, 0.26129113E-09_JPRB, 0.26131708E-09_JPRB, 0.26126978E-09_JPRB, 0.26115721E-09_JPRB, 0.26099722E-09_JPRB, &
  & 0.26080871E-09_JPRB, 0.26060218E-09_JPRB, 0.26037997E-09_JPRB, 0.26013930E-09_JPRB, 0.25987407E-09_JPRB, 0.25958086E-09_JPRB, &
  & 0.25926145E-09_JPRB, 0.25892155E-09_JPRB, 0.25856750E-09_JPRB, 0.25818786E-09_JPRB, 0.25775021E-09_JPRB, 0.25719926E-09_JPRB, &
  & 0.25648739E-09_JPRB, 0.25560354E-09_JPRB, 0.25460370E-09_JPRB, 0.25364194E-09_JPRB, 0.25282179E-09_JPRB, 0.25218075E-09_JPRB, &
  & 0.25166130E-09_JPRB, 0.25121527E-09_JPRB, 0.25081720E-09_JPRB, 0.25044611E-09_JPRB, 0.25012359E-09_JPRB, 0.24985511E-09_JPRB, &
  & 0.24963107E-09_JPRB, 0.24942270E-09_JPRB, 0.24918431E-09_JPRB, 0.24874208E-09_JPRB /)

RGHG5(:,51,12) = (/ &
  & 0.24682351E-09_JPRB, 0.24805119E-09_JPRB, 0.24900867E-09_JPRB, 0.25000596E-09_JPRB, 0.25132862E-09_JPRB, 0.25270330E-09_JPRB, &
  & 0.25389071E-09_JPRB, 0.25465385E-09_JPRB, 0.25510094E-09_JPRB, 0.25536595E-09_JPRB, 0.25553801E-09_JPRB, 0.25565902E-09_JPRB, &
  & 0.25576513E-09_JPRB, 0.25585306E-09_JPRB, 0.25597047E-09_JPRB, 0.25611535E-09_JPRB, 0.25637928E-09_JPRB, 0.25672506E-09_JPRB, &
  & 0.25709992E-09_JPRB, 0.25747837E-09_JPRB, 0.25785901E-09_JPRB, 0.25825100E-09_JPRB, 0.25865859E-09_JPRB, 0.25907754E-09_JPRB, &
  & 0.25950647E-09_JPRB, 0.25992694E-09_JPRB, 0.26032665E-09_JPRB, 0.26067426E-09_JPRB, 0.26096417E-09_JPRB, 0.26118405E-09_JPRB, &
  & 0.26133548E-09_JPRB, 0.26142080E-09_JPRB, 0.26143770E-09_JPRB, 0.26138439E-09_JPRB, 0.26126923E-09_JPRB, 0.26110919E-09_JPRB, &
  & 0.26092303E-09_JPRB, 0.26072136E-09_JPRB, 0.26050714E-09_JPRB, 0.26027858E-09_JPRB, 0.26003241E-09_JPRB, 0.25976893E-09_JPRB, &
  & 0.25949681E-09_JPRB, 0.25923075E-09_JPRB, 0.25898556E-09_JPRB, 0.25875949E-09_JPRB, 0.25852795E-09_JPRB, 0.25824493E-09_JPRB, &
  & 0.25786392E-09_JPRB, 0.25736330E-09_JPRB, 0.25678232E-09_JPRB, 0.25618790E-09_JPRB, 0.25567809E-09_JPRB, 0.25524297E-09_JPRB, &
  & 0.25487812E-09_JPRB, 0.25455310E-09_JPRB, 0.25423844E-09_JPRB, 0.25394806E-09_JPRB, 0.25368033E-09_JPRB, 0.25345490E-09_JPRB, &
  & 0.25326352E-09_JPRB, 0.25308106E-09_JPRB, 0.25286412E-09_JPRB, 0.25246175E-09_JPRB /)

RGHG5(:,52,12) = (/ &
  & 0.25000652E-09_JPRB, 0.25130420E-09_JPRB, 0.25209032E-09_JPRB, 0.25312760E-09_JPRB, 0.25426622E-09_JPRB, 0.25549665E-09_JPRB, &
  & 0.25633190E-09_JPRB, 0.25680216E-09_JPRB, 0.25702762E-09_JPRB, 0.25714172E-09_JPRB, 0.25720154E-09_JPRB, 0.25723454E-09_JPRB, &
  & 0.25724700E-09_JPRB, 0.25724523E-09_JPRB, 0.25722993E-09_JPRB, 0.25721417E-09_JPRB, 0.25724708E-09_JPRB, 0.25737767E-09_JPRB, &
  & 0.25758889E-09_JPRB, 0.25785363E-09_JPRB, 0.25816133E-09_JPRB, 0.25850513E-09_JPRB, 0.25888208E-09_JPRB, 0.25929034E-09_JPRB, &
  & 0.25970920E-09_JPRB, 0.26012542E-09_JPRB, 0.26051117E-09_JPRB, 0.26084690E-09_JPRB, 0.26111999E-09_JPRB, 0.26132696E-09_JPRB, &
  & 0.26146602E-09_JPRB, 0.26154073E-09_JPRB, 0.26154892E-09_JPRB, 0.26148955E-09_JPRB, 0.26137148E-09_JPRB, 0.26121141E-09_JPRB, &
  & 0.26102728E-09_JPRB, 0.26082975E-09_JPRB, 0.26062208E-09_JPRB, 0.26040350E-09_JPRB, 0.26017227E-09_JPRB, 0.25993335E-09_JPRB, &
  & 0.25970004E-09_JPRB, 0.25949495E-09_JPRB, 0.25933489E-09_JPRB, 0.25922184E-09_JPRB, 0.25913011E-09_JPRB, 0.25902486E-09_JPRB, &
  & 0.25887265E-09_JPRB, 0.25865959E-09_JPRB, 0.25839597E-09_JPRB, 0.25812513E-09_JPRB, 0.25786467E-09_JPRB, 0.25763791E-09_JPRB, &
  & 0.25742888E-09_JPRB, 0.25722588E-09_JPRB, 0.25703051E-09_JPRB, 0.25682625E-09_JPRB, 0.25664010E-09_JPRB, 0.25647715E-09_JPRB, &
  & 0.25633554E-09_JPRB, 0.25619670E-09_JPRB, 0.25602748E-09_JPRB, 0.25568855E-09_JPRB /)

RGHG5(:,53,12) = (/ &
  & 0.25277674E-09_JPRB, 0.25379840E-09_JPRB, 0.25467897E-09_JPRB, 0.25545840E-09_JPRB, 0.25648528E-09_JPRB, 0.25730390E-09_JPRB, &
  & 0.25782304E-09_JPRB, 0.25804386E-09_JPRB, 0.25813710E-09_JPRB, 0.25817365E-09_JPRB, 0.25818450E-09_JPRB, 0.25817998E-09_JPRB, &
  & 0.25816052E-09_JPRB, 0.25812880E-09_JPRB, 0.25806376E-09_JPRB, 0.25798719E-09_JPRB, 0.25790733E-09_JPRB, 0.25790353E-09_JPRB, &
  & 0.25800059E-09_JPRB, 0.25818411E-09_JPRB, 0.25843414E-09_JPRB, 0.25874097E-09_JPRB, 0.25909866E-09_JPRB, 0.25949085E-09_JPRB, &
  & 0.25990532E-09_JPRB, 0.26030911E-09_JPRB, 0.26068497E-09_JPRB, 0.26100522E-09_JPRB, 0.26126495E-09_JPRB, 0.26145927E-09_JPRB, &
  & 0.26158706E-09_JPRB, 0.26165170E-09_JPRB, 0.26165164E-09_JPRB, 0.26158647E-09_JPRB, 0.26146565E-09_JPRB, 0.26130537E-09_JPRB, &
  & 0.26112312E-09_JPRB, 0.26092950E-09_JPRB, 0.26072766E-09_JPRB, 0.26051733E-09_JPRB, 0.26029945E-09_JPRB, 0.26008026E-09_JPRB, &
  & 0.25988095E-09_JPRB, 0.25972469E-09_JPRB, 0.25963201E-09_JPRB, 0.25959557E-09_JPRB, 0.25959090E-09_JPRB, 0.25958585E-09_JPRB, &
  & 0.25955615E-09_JPRB, 0.25949159E-09_JPRB, 0.25939784E-09_JPRB, 0.25928687E-09_JPRB, 0.25917754E-09_JPRB, 0.25906993E-09_JPRB, &
  & 0.25896602E-09_JPRB, 0.25886265E-09_JPRB, 0.25874922E-09_JPRB, 0.25863706E-09_JPRB, 0.25852626E-09_JPRB, 0.25843067E-09_JPRB, &
  & 0.25834995E-09_JPRB, 0.25827243E-09_JPRB, 0.25817865E-09_JPRB, 0.25797600E-09_JPRB /)

RGHG5(:,54,12) = (/ &
  & 0.25484700E-09_JPRB, 0.25592195E-09_JPRB, 0.25649383E-09_JPRB, 0.25723870E-09_JPRB, 0.25788410E-09_JPRB, 0.25842334E-09_JPRB, &
  & 0.25867009E-09_JPRB, 0.25876604E-09_JPRB, 0.25879546E-09_JPRB, 0.25880037E-09_JPRB, 0.25879363E-09_JPRB, 0.25877817E-09_JPRB, &
  & 0.25875491E-09_JPRB, 0.25871177E-09_JPRB, 0.25865488E-09_JPRB, 0.25854499E-09_JPRB, 0.25842647E-09_JPRB, 0.25834082E-09_JPRB, &
  & 0.25835814E-09_JPRB, 0.25847968E-09_JPRB, 0.25868771E-09_JPRB, 0.25896663E-09_JPRB, 0.25930413E-09_JPRB, 0.25968747E-09_JPRB, &
  & 0.26008792E-09_JPRB, 0.26048386E-09_JPRB, 0.26084468E-09_JPRB, 0.26115360E-09_JPRB, 0.26139968E-09_JPRB, 0.26158228E-09_JPRB, &
  & 0.26169955E-09_JPRB, 0.26175478E-09_JPRB, 0.26174687E-09_JPRB, 0.26167660E-09_JPRB, 0.26155317E-09_JPRB, 0.26139257E-09_JPRB, &
  & 0.26121250E-09_JPRB, 0.26102234E-09_JPRB, 0.26082611E-09_JPRB, 0.26062380E-09_JPRB, 0.26041697E-09_JPRB, 0.26021721E-09_JPRB, &
  & 0.26004496E-09_JPRB, 0.25993108E-09_JPRB, 0.25988703E-09_JPRB, 0.25990229E-09_JPRB, 0.25994756E-09_JPRB, 0.25999292E-09_JPRB, &
  & 0.26001937E-09_JPRB, 0.26001898E-09_JPRB, 0.25999378E-09_JPRB, 0.25995364E-09_JPRB, 0.25990554E-09_JPRB, 0.25985603E-09_JPRB, &
  & 0.25980468E-09_JPRB, 0.25974872E-09_JPRB, 0.25969032E-09_JPRB, 0.25962529E-09_JPRB, 0.25956493E-09_JPRB, 0.25951519E-09_JPRB, &
  & 0.25947638E-09_JPRB, 0.25944721E-09_JPRB, 0.25942531E-09_JPRB, 0.25941477E-09_JPRB /)

RGHG5(:,55,12) = (/ &
  & 0.25656177E-09_JPRB, 0.25733152E-09_JPRB, 0.25791955E-09_JPRB, 0.25835492E-09_JPRB, 0.25881056E-09_JPRB, 0.25908115E-09_JPRB, &
  & 0.25919822E-09_JPRB, 0.25922814E-09_JPRB, 0.25923064E-09_JPRB, 0.25922359E-09_JPRB, 0.25921182E-09_JPRB, 0.25919597E-09_JPRB, &
  & 0.25917202E-09_JPRB, 0.25914015E-09_JPRB, 0.25907720E-09_JPRB, 0.25899100E-09_JPRB, 0.25884536E-09_JPRB, 0.25871535E-09_JPRB, &
  & 0.25867639E-09_JPRB, 0.25875266E-09_JPRB, 0.25892732E-09_JPRB, 0.25918362E-09_JPRB, 0.25950547E-09_JPRB, 0.25987329E-09_JPRB, &
  & 0.26026412E-09_JPRB, 0.26064553E-09_JPRB, 0.26099622E-09_JPRB, 0.26129238E-09_JPRB, 0.26152630E-09_JPRB, 0.26169736E-09_JPRB, &
  & 0.26180466E-09_JPRB, 0.26185101E-09_JPRB, 0.26183597E-09_JPRB, 0.26176106E-09_JPRB, 0.26163571E-09_JPRB, 0.26147520E-09_JPRB, &
  & 0.26129668E-09_JPRB, 0.26111063E-09_JPRB, 0.26091931E-09_JPRB, 0.26072486E-09_JPRB, 0.26052996E-09_JPRB, 0.26034613E-09_JPRB, &
  & 0.26020044E-09_JPRB, 0.26011776E-09_JPRB, 0.26011032E-09_JPRB, 0.26015967E-09_JPRB, 0.26023184E-09_JPRB, 0.26030172E-09_JPRB, &
  & 0.26035155E-09_JPRB, 0.26037647E-09_JPRB, 0.26037872E-09_JPRB, 0.26036576E-09_JPRB, 0.26034530E-09_JPRB, 0.26032076E-09_JPRB, &
  & 0.26029334E-09_JPRB, 0.26026314E-09_JPRB, 0.26022734E-09_JPRB, 0.26018954E-09_JPRB, 0.26015151E-09_JPRB, 0.26011845E-09_JPRB, &
  & 0.26009211E-09_JPRB, 0.26006852E-09_JPRB, 0.26004379E-09_JPRB, 0.26000282E-09_JPRB /)

RGHG5(:,56,12) = (/ &
  & 0.25777197E-09_JPRB, 0.25846741E-09_JPRB, 0.25881144E-09_JPRB, 0.25914021E-09_JPRB, 0.25938210E-09_JPRB, 0.25952371E-09_JPRB, &
  & 0.25956201E-09_JPRB, 0.25956301E-09_JPRB, 0.25955421E-09_JPRB, 0.25954328E-09_JPRB, 0.25953104E-09_JPRB, 0.25951624E-09_JPRB, &
  & 0.25949778E-09_JPRB, 0.25946725E-09_JPRB, 0.25942448E-09_JPRB, 0.25933464E-09_JPRB, 0.25920532E-09_JPRB, 0.25904692E-09_JPRB, &
  & 0.25896749E-09_JPRB, 0.25900934E-09_JPRB, 0.25915875E-09_JPRB, 0.25939451E-09_JPRB, 0.25970051E-09_JPRB, 0.26005420E-09_JPRB, &
  & 0.26043021E-09_JPRB, 0.26080121E-09_JPRB, 0.26113905E-09_JPRB, 0.26142377E-09_JPRB, 0.26164609E-09_JPRB, 0.26180563E-09_JPRB, &
  & 0.26190325E-09_JPRB, 0.26194158E-09_JPRB, 0.26192040E-09_JPRB, 0.26184171E-09_JPRB, 0.26171504E-09_JPRB, 0.26155494E-09_JPRB, &
  & 0.26137884E-09_JPRB, 0.26119565E-09_JPRB, 0.26101052E-09_JPRB, 0.26082336E-09_JPRB, 0.26063979E-09_JPRB, 0.26047325E-09_JPRB, &
  & 0.26034763E-09_JPRB, 0.26029143E-09_JPRB, 0.26030991E-09_JPRB, 0.26037911E-09_JPRB, 0.26046887E-09_JPRB, 0.26054897E-09_JPRB, &
  & 0.26060781E-09_JPRB, 0.26064081E-09_JPRB, 0.26065305E-09_JPRB, 0.26065131E-09_JPRB, 0.26064212E-09_JPRB, 0.26062916E-09_JPRB, &
  & 0.26061359E-09_JPRB, 0.26059474E-09_JPRB, 0.26057320E-09_JPRB, 0.26054781E-09_JPRB, 0.26052241E-09_JPRB, 0.26050048E-09_JPRB, &
  & 0.26048180E-09_JPRB, 0.26046582E-09_JPRB, 0.26044961E-09_JPRB, 0.26042538E-09_JPRB /)

RGHG5(:,57,12) = (/ &
  & 0.25869623E-09_JPRB, 0.25919966E-09_JPRB, 0.25946348E-09_JPRB, 0.25964969E-09_JPRB, 0.25978375E-09_JPRB, 0.25983990E-09_JPRB, &
  & 0.25984248E-09_JPRB, 0.25983052E-09_JPRB, 0.25981770E-09_JPRB, 0.25980609E-09_JPRB, 0.25979491E-09_JPRB, 0.25978264E-09_JPRB, &
  & 0.25976638E-09_JPRB, 0.25974456E-09_JPRB, 0.25970304E-09_JPRB, 0.25963828E-09_JPRB, 0.25950742E-09_JPRB, 0.25934399E-09_JPRB, &
  & 0.25923919E-09_JPRB, 0.25925601E-09_JPRB, 0.25938371E-09_JPRB, 0.25960237E-09_JPRB, 0.25989097E-09_JPRB, 0.26022995E-09_JPRB, &
  & 0.26059235E-09_JPRB, 0.26094987E-09_JPRB, 0.26127575E-09_JPRB, 0.26154909E-09_JPRB, 0.26175945E-09_JPRB, 0.26190813E-09_JPRB, &
  & 0.26199679E-09_JPRB, 0.26202773E-09_JPRB, 0.26200148E-09_JPRB, 0.26192007E-09_JPRB, 0.26179256E-09_JPRB, 0.26163405E-09_JPRB, &
  & 0.26145994E-09_JPRB, 0.26128114E-09_JPRB, 0.26110047E-09_JPRB, 0.26092184E-09_JPRB, 0.26074948E-09_JPRB, 0.26059740E-09_JPRB, &
  & 0.26049152E-09_JPRB, 0.26045410E-09_JPRB, 0.26048941E-09_JPRB, 0.26057481E-09_JPRB, 0.26067151E-09_JPRB, 0.26075775E-09_JPRB, &
  & 0.26081770E-09_JPRB, 0.26085248E-09_JPRB, 0.26086663E-09_JPRB, 0.26086874E-09_JPRB, 0.26086441E-09_JPRB, 0.26085675E-09_JPRB, &
  & 0.26084668E-09_JPRB, 0.26083452E-09_JPRB, 0.26081914E-09_JPRB, 0.26080182E-09_JPRB, 0.26078353E-09_JPRB, 0.26076652E-09_JPRB, &
  & 0.26075236E-09_JPRB, 0.26073893E-09_JPRB, 0.26072408E-09_JPRB, 0.26069819E-09_JPRB /)

RGHG5(:,58,12) = (/ &
  & 0.25937399E-09_JPRB, 0.25974070E-09_JPRB, 0.25990982E-09_JPRB, 0.26001629E-09_JPRB, 0.26008207E-09_JPRB, 0.26009417E-09_JPRB, &
  & 0.26007918E-09_JPRB, 0.26006131E-09_JPRB, 0.26004765E-09_JPRB, 0.26003677E-09_JPRB, 0.26002692E-09_JPRB, 0.26001648E-09_JPRB, &
  & 0.26000385E-09_JPRB, 0.25998395E-09_JPRB, 0.25995378E-09_JPRB, 0.25988928E-09_JPRB, 0.25977973E-09_JPRB, 0.25961241E-09_JPRB, &
  & 0.25949531E-09_JPRB, 0.25949501E-09_JPRB, 0.25960528E-09_JPRB, 0.25980640E-09_JPRB, 0.26008043E-09_JPRB, 0.26040275E-09_JPRB, &
  & 0.26075112E-09_JPRB, 0.26109448E-09_JPRB, 0.26140801E-09_JPRB, 0.26166805E-09_JPRB, 0.26186758E-09_JPRB, 0.26200581E-09_JPRB, &
  & 0.26208580E-09_JPRB, 0.26211047E-09_JPRB, 0.26208019E-09_JPRB, 0.26199706E-09_JPRB, 0.26186978E-09_JPRB, 0.26171335E-09_JPRB, &
  & 0.26154248E-09_JPRB, 0.26136721E-09_JPRB, 0.26119240E-09_JPRB, 0.26102084E-09_JPRB, 0.26085914E-09_JPRB, 0.26072183E-09_JPRB, &
  & 0.26063079E-09_JPRB, 0.26060853E-09_JPRB, 0.26065697E-09_JPRB, 0.26074831E-09_JPRB, 0.26085314E-09_JPRB, 0.26093938E-09_JPRB, &
  & 0.26099906E-09_JPRB, 0.26103084E-09_JPRB, 0.26104438E-09_JPRB, 0.26104696E-09_JPRB, 0.26104416E-09_JPRB, 0.26103858E-09_JPRB, &
  & 0.26103122E-09_JPRB, 0.26102179E-09_JPRB, 0.26101052E-09_JPRB, 0.26099670E-09_JPRB, 0.26098215E-09_JPRB, 0.26096880E-09_JPRB, &
  & 0.26095667E-09_JPRB, 0.26094560E-09_JPRB, 0.26093339E-09_JPRB, 0.26091232E-09_JPRB /)

RGHG5(:,59,12) = (/ &
  & 0.25988167E-09_JPRB, 0.26014990E-09_JPRB, 0.26024241E-09_JPRB, 0.26030131E-09_JPRB, 0.26032290E-09_JPRB, 0.26031244E-09_JPRB, &
  & 0.26028882E-09_JPRB, 0.26026997E-09_JPRB, 0.26025651E-09_JPRB, 0.26024685E-09_JPRB, 0.26023866E-09_JPRB, 0.26023028E-09_JPRB, &
  & 0.26021954E-09_JPRB, 0.26020419E-09_JPRB, 0.26017516E-09_JPRB, 0.26012370E-09_JPRB, 0.26001465E-09_JPRB, 0.25985858E-09_JPRB, &
  & 0.25973884E-09_JPRB, 0.25972785E-09_JPRB, 0.25982366E-09_JPRB, 0.26001040E-09_JPRB, 0.26026761E-09_JPRB, 0.26057573E-09_JPRB, &
  & 0.26090760E-09_JPRB, 0.26123684E-09_JPRB, 0.26153496E-09_JPRB, 0.26178290E-09_JPRB, 0.26197025E-09_JPRB, 0.26209879E-09_JPRB, &
  & 0.26217128E-09_JPRB, 0.26219052E-09_JPRB, 0.26215702E-09_JPRB, 0.26207336E-09_JPRB, 0.26194749E-09_JPRB, 0.26179386E-09_JPRB, &
  & 0.26162678E-09_JPRB, 0.26145575E-09_JPRB, 0.26128585E-09_JPRB, 0.26112165E-09_JPRB, 0.26097013E-09_JPRB, 0.26084465E-09_JPRB, &
  & 0.26076796E-09_JPRB, 0.26075714E-09_JPRB, 0.26081207E-09_JPRB, 0.26091054E-09_JPRB, 0.26101543E-09_JPRB, 0.26110353E-09_JPRB, &
  & 0.26115915E-09_JPRB, 0.26118835E-09_JPRB, 0.26119917E-09_JPRB, 0.26120073E-09_JPRB, 0.26119790E-09_JPRB, 0.26119290E-09_JPRB, &
  & 0.26118638E-09_JPRB, 0.26117850E-09_JPRB, 0.26116850E-09_JPRB, 0.26115710E-09_JPRB, 0.26114458E-09_JPRB, 0.26113250E-09_JPRB, &
  & 0.26112199E-09_JPRB, 0.26111174E-09_JPRB, 0.26109997E-09_JPRB, 0.26107913E-09_JPRB /)

RGHG5(:,60,12) = (/ &
  & 0.26039260E-09_JPRB, 0.26047137E-09_JPRB, 0.26051253E-09_JPRB, 0.26053129E-09_JPRB, 0.26053054E-09_JPRB, 0.26050911E-09_JPRB, &
  & 0.26048275E-09_JPRB, 0.26046304E-09_JPRB, 0.26045094E-09_JPRB, 0.26044275E-09_JPRB, 0.26043642E-09_JPRB, 0.26043007E-09_JPRB, &
  & 0.26042191E-09_JPRB, 0.26040847E-09_JPRB, 0.26038469E-09_JPRB, 0.26033295E-09_JPRB, 0.26023395E-09_JPRB, 0.26008518E-09_JPRB, &
  & 0.25997185E-09_JPRB, 0.25995578E-09_JPRB, 0.26004054E-09_JPRB, 0.26021316E-09_JPRB, 0.26045630E-09_JPRB, 0.26074745E-09_JPRB, &
  & 0.26106417E-09_JPRB, 0.26137606E-09_JPRB, 0.26165950E-09_JPRB, 0.26189223E-09_JPRB, 0.26206862E-09_JPRB, 0.26218755E-09_JPRB, &
  & 0.26225314E-09_JPRB, 0.26226796E-09_JPRB, 0.26223240E-09_JPRB, 0.26214897E-09_JPRB, 0.26202568E-09_JPRB, 0.26187602E-09_JPRB, &
  & 0.26171282E-09_JPRB, 0.26154634E-09_JPRB, 0.26138147E-09_JPRB, 0.26122418E-09_JPRB, 0.26108146E-09_JPRB, 0.26096800E-09_JPRB, &
  & 0.26090241E-09_JPRB, 0.26090063E-09_JPRB, 0.26096125E-09_JPRB, 0.26105956E-09_JPRB, 0.26116698E-09_JPRB, 0.26125208E-09_JPRB, &
  & 0.26130600E-09_JPRB, 0.26133073E-09_JPRB, 0.26133887E-09_JPRB, 0.26133862E-09_JPRB, 0.26133476E-09_JPRB, 0.26132921E-09_JPRB, &
  & 0.26132263E-09_JPRB, 0.26131466E-09_JPRB, 0.26130548E-09_JPRB, 0.26129438E-09_JPRB, 0.26128266E-09_JPRB, 0.26127156E-09_JPRB, &
  & 0.26126129E-09_JPRB, 0.26125163E-09_JPRB, 0.26124072E-09_JPRB, 0.26122152E-09_JPRB /)

RGHG5(:,61,12) = (/ &
  & 0.26064478E-09_JPRB, 0.26070557E-09_JPRB, 0.26072403E-09_JPRB, 0.26072894E-09_JPRB, 0.26071806E-09_JPRB, 0.26069114E-09_JPRB, &
  & 0.26066377E-09_JPRB, 0.26064506E-09_JPRB, 0.26063371E-09_JPRB, 0.26062752E-09_JPRB, 0.26062350E-09_JPRB, 0.26061983E-09_JPRB, &
  & 0.26061447E-09_JPRB, 0.26060434E-09_JPRB, 0.26058194E-09_JPRB, 0.26053390E-09_JPRB, 0.26043642E-09_JPRB, 0.26030106E-09_JPRB, &
  & 0.26019747E-09_JPRB, 0.26017979E-09_JPRB, 0.26025596E-09_JPRB, 0.26041652E-09_JPRB, 0.26064448E-09_JPRB, 0.26092056E-09_JPRB, &
  & 0.26121924E-09_JPRB, 0.26151456E-09_JPRB, 0.26178015E-09_JPRB, 0.26199876E-09_JPRB, 0.26216238E-09_JPRB, 0.26227251E-09_JPRB, &
  & 0.26233185E-09_JPRB, 0.26234309E-09_JPRB, 0.26230651E-09_JPRB, 0.26222455E-09_JPRB, 0.26210464E-09_JPRB, 0.26195918E-09_JPRB, &
  & 0.26180091E-09_JPRB, 0.26163854E-09_JPRB, 0.26147895E-09_JPRB, 0.26132788E-09_JPRB, 0.26119409E-09_JPRB, 0.26109043E-09_JPRB, &
  & 0.26103519E-09_JPRB, 0.26104080E-09_JPRB, 0.26110361E-09_JPRB, 0.26120237E-09_JPRB, 0.26130648E-09_JPRB, 0.26139146E-09_JPRB, &
  & 0.26144142E-09_JPRB, 0.26146352E-09_JPRB, 0.26146846E-09_JPRB, 0.26146579E-09_JPRB, 0.26146019E-09_JPRB, 0.26145347E-09_JPRB, &
  & 0.26144581E-09_JPRB, 0.26143746E-09_JPRB, 0.26142749E-09_JPRB, 0.26141656E-09_JPRB, 0.26140473E-09_JPRB, 0.26139330E-09_JPRB, &
  & 0.26138311E-09_JPRB, 0.26137315E-09_JPRB, 0.26136177E-09_JPRB, 0.26134184E-09_JPRB /)

RGHG5(:,62,12) = (/ &
  & 0.26086294E-09_JPRB, 0.26090083E-09_JPRB, 0.26091007E-09_JPRB, 0.26090680E-09_JPRB, 0.26089000E-09_JPRB, 0.26086350E-09_JPRB, &
  & 0.26083577E-09_JPRB, 0.26081642E-09_JPRB, 0.26080654E-09_JPRB, 0.26080238E-09_JPRB, 0.26080174E-09_JPRB, 0.26080202E-09_JPRB, &
  & 0.26080071E-09_JPRB, 0.26079394E-09_JPRB, 0.26077412E-09_JPRB, 0.26072547E-09_JPRB, 0.26063196E-09_JPRB, 0.26050986E-09_JPRB, &
  & 0.26041755E-09_JPRB, 0.26040090E-09_JPRB, 0.26047067E-09_JPRB, 0.26062014E-09_JPRB, 0.26083413E-09_JPRB, 0.26109348E-09_JPRB, &
  & 0.26137473E-09_JPRB, 0.26165106E-09_JPRB, 0.26189920E-09_JPRB, 0.26210134E-09_JPRB, 0.26225308E-09_JPRB, 0.26235400E-09_JPRB, &
  & 0.26240768E-09_JPRB, 0.26241603E-09_JPRB, 0.26237937E-09_JPRB, 0.26229974E-09_JPRB, 0.26218402E-09_JPRB, 0.26204389E-09_JPRB, &
  & 0.26189004E-09_JPRB, 0.26173277E-09_JPRB, 0.26157779E-09_JPRB, 0.26143324E-09_JPRB, 0.26130706E-09_JPRB, 0.26121294E-09_JPRB, &
  & 0.26116626E-09_JPRB, 0.26117764E-09_JPRB, 0.26124206E-09_JPRB, 0.26133809E-09_JPRB, 0.26143990E-09_JPRB, 0.26152130E-09_JPRB, &
  & 0.26157038E-09_JPRB, 0.26158917E-09_JPRB, 0.26159108E-09_JPRB, 0.26158559E-09_JPRB, 0.26157776E-09_JPRB, 0.26156904E-09_JPRB, &
  & 0.26156005E-09_JPRB, 0.26155009E-09_JPRB, 0.26153943E-09_JPRB, 0.26152716E-09_JPRB, 0.26151456E-09_JPRB, 0.26150260E-09_JPRB, &
  & 0.26149155E-09_JPRB, 0.26148106E-09_JPRB, 0.26146915E-09_JPRB, 0.26144820E-09_JPRB /)

RGHG5(:,63,12) = (/ &
  & 0.26104571E-09_JPRB, 0.26107486E-09_JPRB, 0.26107808E-09_JPRB, 0.26107111E-09_JPRB, 0.26105459E-09_JPRB, 0.26102753E-09_JPRB, &
  & 0.26100005E-09_JPRB, 0.26098068E-09_JPRB, 0.26097061E-09_JPRB, 0.26096891E-09_JPRB, 0.26097258E-09_JPRB, 0.26097827E-09_JPRB, &
  & 0.26098262E-09_JPRB, 0.26098002E-09_JPRB, 0.26096128E-09_JPRB, 0.26091249E-09_JPRB, 0.26082414E-09_JPRB, 0.26071578E-09_JPRB, &
  & 0.26063449E-09_JPRB, 0.26061994E-09_JPRB, 0.26068492E-09_JPRB, 0.26082425E-09_JPRB, 0.26102437E-09_JPRB, 0.26126690E-09_JPRB, &
  & 0.26152919E-09_JPRB, 0.26178640E-09_JPRB, 0.26201524E-09_JPRB, 0.26220154E-09_JPRB, 0.26234004E-09_JPRB, 0.26243230E-09_JPRB, &
  & 0.26248051E-09_JPRB, 0.26248664E-09_JPRB, 0.26245067E-09_JPRB, 0.26237440E-09_JPRB, 0.26226382E-09_JPRB, 0.26212921E-09_JPRB, &
  & 0.26198091E-09_JPRB, 0.26182814E-09_JPRB, 0.26167868E-09_JPRB, 0.26153985E-09_JPRB, 0.26142122E-09_JPRB, 0.26133531E-09_JPRB, &
  & 0.26129612E-09_JPRB, 0.26131203E-09_JPRB, 0.26137681E-09_JPRB, 0.26146985E-09_JPRB, 0.26156671E-09_JPRB, 0.26164595E-09_JPRB, &
  & 0.26169286E-09_JPRB, 0.26171029E-09_JPRB, 0.26170927E-09_JPRB, 0.26170069E-09_JPRB, 0.26168984E-09_JPRB, 0.26167887E-09_JPRB, &
  & 0.26166752E-09_JPRB, 0.26165597E-09_JPRB, 0.26164315E-09_JPRB, 0.26162966E-09_JPRB, 0.26161551E-09_JPRB, 0.26160207E-09_JPRB, &
  & 0.26159008E-09_JPRB, 0.26157837E-09_JPRB, 0.26156499E-09_JPRB, 0.26154190E-09_JPRB /)

RGHG5(:,64,12) = (/ &
  & 0.26121033E-09_JPRB, 0.26123287E-09_JPRB, 0.26123409E-09_JPRB, 0.26122654E-09_JPRB, 0.26120989E-09_JPRB, 0.26118518E-09_JPRB, &
  & 0.26115826E-09_JPRB, 0.26113789E-09_JPRB, 0.26112851E-09_JPRB, 0.26112904E-09_JPRB, 0.26113717E-09_JPRB, 0.26114982E-09_JPRB, &
  & 0.26115993E-09_JPRB, 0.26116104E-09_JPRB, 0.26114308E-09_JPRB, 0.26109531E-09_JPRB, 0.26101390E-09_JPRB, 0.26091782E-09_JPRB, &
  & 0.26084668E-09_JPRB, 0.26083552E-09_JPRB, 0.26089700E-09_JPRB, 0.26102714E-09_JPRB, 0.26121327E-09_JPRB, 0.26143848E-09_JPRB, &
  & 0.26168123E-09_JPRB, 0.26191793E-09_JPRB, 0.26212746E-09_JPRB, 0.26229685E-09_JPRB, 0.26242264E-09_JPRB, 0.26250577E-09_JPRB, &
  & 0.26254884E-09_JPRB, 0.26255317E-09_JPRB, 0.26251867E-09_JPRB, 0.26244665E-09_JPRB, 0.26234204E-09_JPRB, 0.26221395E-09_JPRB, &
  & 0.26207164E-09_JPRB, 0.26192445E-09_JPRB, 0.26178029E-09_JPRB, 0.26164751E-09_JPRB, 0.26153571E-09_JPRB, 0.26145705E-09_JPRB, &
  & 0.26142433E-09_JPRB, 0.26144351E-09_JPRB, 0.26150757E-09_JPRB, 0.26159705E-09_JPRB, 0.26168906E-09_JPRB, 0.26176417E-09_JPRB, &
  & 0.26181041E-09_JPRB, 0.26182678E-09_JPRB, 0.26182359E-09_JPRB, 0.26181179E-09_JPRB, 0.26179792E-09_JPRB, 0.26178376E-09_JPRB, &
  & 0.26176999E-09_JPRB, 0.26175551E-09_JPRB, 0.26174077E-09_JPRB, 0.26172470E-09_JPRB, 0.26170868E-09_JPRB, 0.26169367E-09_JPRB, &
  & 0.26167976E-09_JPRB, 0.26166633E-09_JPRB, 0.26165084E-09_JPRB, 0.26162361E-09_JPRB /)

RGHG5(:,65,12) = (/ &
  & 0.26136282E-09_JPRB, 0.26138103E-09_JPRB, 0.26138114E-09_JPRB, 0.26137376E-09_JPRB, 0.26135902E-09_JPRB, 0.26133642E-09_JPRB, &
  & 0.26131078E-09_JPRB, 0.26129099E-09_JPRB, 0.26128213E-09_JPRB, 0.26128524E-09_JPRB, 0.26129862E-09_JPRB, 0.26131650E-09_JPRB, &
  & 0.26133176E-09_JPRB, 0.26133551E-09_JPRB, 0.26131872E-09_JPRB, 0.26127392E-09_JPRB, 0.26120031E-09_JPRB, 0.26111568E-09_JPRB, &
  & 0.26105437E-09_JPRB, 0.26104688E-09_JPRB, 0.26110533E-09_JPRB, 0.26122640E-09_JPRB, 0.26139849E-09_JPRB, 0.26160571E-09_JPRB, &
  & 0.26182798E-09_JPRB, 0.26204369E-09_JPRB, 0.26223324E-09_JPRB, 0.26238600E-09_JPRB, 0.26249869E-09_JPRB, 0.26257305E-09_JPRB, &
  & 0.26261102E-09_JPRB, 0.26261396E-09_JPRB, 0.26258148E-09_JPRB, 0.26251443E-09_JPRB, 0.26241664E-09_JPRB, 0.26229621E-09_JPRB, &
  & 0.26216093E-09_JPRB, 0.26202021E-09_JPRB, 0.26188218E-09_JPRB, 0.26175556E-09_JPRB, 0.26165023E-09_JPRB, 0.26157818E-09_JPRB, &
  & 0.26155050E-09_JPRB, 0.26157171E-09_JPRB, 0.26163449E-09_JPRB, 0.26171967E-09_JPRB, 0.26180660E-09_JPRB, 0.26187758E-09_JPRB, &
  & 0.26192198E-09_JPRB, 0.26193830E-09_JPRB, 0.26193389E-09_JPRB, 0.26191960E-09_JPRB, 0.26190222E-09_JPRB, 0.26188504E-09_JPRB, &
  & 0.26186778E-09_JPRB, 0.26185087E-09_JPRB, 0.26183283E-09_JPRB, 0.26181468E-09_JPRB, 0.26179620E-09_JPRB, 0.26177868E-09_JPRB, &
  & 0.26176267E-09_JPRB, 0.26174654E-09_JPRB, 0.26172758E-09_JPRB, 0.26169392E-09_JPRB /)

RGHG5(:,66,12) = (/ &
  & 0.26149544E-09_JPRB, 0.26151734E-09_JPRB, 0.26151958E-09_JPRB, 0.26151414E-09_JPRB, 0.26150165E-09_JPRB, 0.26148173E-09_JPRB, &
  & 0.26145860E-09_JPRB, 0.26144015E-09_JPRB, 0.26143332E-09_JPRB, 0.26143970E-09_JPRB, 0.26145691E-09_JPRB, 0.26147909E-09_JPRB, &
  & 0.26149724E-09_JPRB, 0.26150312E-09_JPRB, 0.26148816E-09_JPRB, 0.26144784E-09_JPRB, 0.26138208E-09_JPRB, 0.26130792E-09_JPRB, &
  & 0.26125571E-09_JPRB, 0.26125213E-09_JPRB, 0.26130770E-09_JPRB, 0.26141980E-09_JPRB, 0.26157743E-09_JPRB, 0.26176575E-09_JPRB, &
  & 0.26196736E-09_JPRB, 0.26216115E-09_JPRB, 0.26233124E-09_JPRB, 0.26246719E-09_JPRB, 0.26256733E-09_JPRB, 0.26263300E-09_JPRB, &
  & 0.26266622E-09_JPRB, 0.26266794E-09_JPRB, 0.26263774E-09_JPRB, 0.26257602E-09_JPRB, 0.26248606E-09_JPRB, 0.26237398E-09_JPRB, &
  & 0.26224728E-09_JPRB, 0.26211394E-09_JPRB, 0.26198321E-09_JPRB, 0.26186325E-09_JPRB, 0.26176464E-09_JPRB, 0.26169830E-09_JPRB, &
  & 0.26167471E-09_JPRB, 0.26169700E-09_JPRB, 0.26175728E-09_JPRB, 0.26183805E-09_JPRB, 0.26191954E-09_JPRB, 0.26198602E-09_JPRB, &
  & 0.26202809E-09_JPRB, 0.26204411E-09_JPRB, 0.26203958E-09_JPRB, 0.26202368E-09_JPRB, 0.26200395E-09_JPRB, 0.26198321E-09_JPRB, &
  & 0.26196317E-09_JPRB, 0.26194258E-09_JPRB, 0.26192232E-09_JPRB, 0.26190095E-09_JPRB, 0.26188002E-09_JPRB, 0.26186014E-09_JPRB, &
  & 0.26184102E-09_JPRB, 0.26182156E-09_JPRB, 0.26179758E-09_JPRB, 0.26175362E-09_JPRB /)

RGHG5(:,67,12) = (/ &
  & 0.26162672E-09_JPRB, 0.26164937E-09_JPRB, 0.26165284E-09_JPRB, 0.26164909E-09_JPRB, 0.26163893E-09_JPRB, 0.26162220E-09_JPRB, &
  & 0.26160174E-09_JPRB, 0.26158625E-09_JPRB, 0.26158228E-09_JPRB, 0.26159200E-09_JPRB, 0.26161237E-09_JPRB, 0.26163688E-09_JPRB, &
  & 0.26165675E-09_JPRB, 0.26166413E-09_JPRB, 0.26165151E-09_JPRB, 0.26161603E-09_JPRB, 0.26155789E-09_JPRB, 0.26149377E-09_JPRB, &
  & 0.26144983E-09_JPRB, 0.26144931E-09_JPRB, 0.26150165E-09_JPRB, 0.26160421E-09_JPRB, 0.26174687E-09_JPRB, 0.26191641E-09_JPRB, &
  & 0.26209662E-09_JPRB, 0.26226957E-09_JPRB, 0.26242003E-09_JPRB, 0.26254021E-09_JPRB, 0.26262828E-09_JPRB, 0.26268576E-09_JPRB, &
  & 0.26271449E-09_JPRB, 0.26271521E-09_JPRB, 0.26268737E-09_JPRB, 0.26263131E-09_JPRB, 0.26254920E-09_JPRB, 0.26244654E-09_JPRB, &
  & 0.26232891E-09_JPRB, 0.26220456E-09_JPRB, 0.26208175E-09_JPRB, 0.26196967E-09_JPRB, 0.26187782E-09_JPRB, 0.26181723E-09_JPRB, &
  & 0.26179686E-09_JPRB, 0.26181923E-09_JPRB, 0.26187644E-09_JPRB, 0.26195202E-09_JPRB, 0.26202790E-09_JPRB, 0.26208968E-09_JPRB, &
  & 0.26212896E-09_JPRB, 0.26214420E-09_JPRB, 0.26213989E-09_JPRB, 0.26212377E-09_JPRB, 0.26210201E-09_JPRB, 0.26207930E-09_JPRB, &
  & 0.26205588E-09_JPRB, 0.26203312E-09_JPRB, 0.26200947E-09_JPRB, 0.26198621E-09_JPRB, 0.26196284E-09_JPRB, 0.26194005E-09_JPRB, &
  & 0.26191832E-09_JPRB, 0.26189437E-09_JPRB, 0.26186367E-09_JPRB, 0.26180449E-09_JPRB /)

RGHG5(:,68,12) = (/ &
  & 0.26174790E-09_JPRB, 0.26177455E-09_JPRB, 0.26178060E-09_JPRB, 0.26177910E-09_JPRB, 0.26177147E-09_JPRB, 0.26175781E-09_JPRB, &
  & 0.26174149E-09_JPRB, 0.26172947E-09_JPRB, 0.26172900E-09_JPRB, 0.26174182E-09_JPRB, 0.26176422E-09_JPRB, 0.26178976E-09_JPRB, &
  & 0.26181018E-09_JPRB, 0.26181854E-09_JPRB, 0.26180788E-09_JPRB, 0.26177732E-09_JPRB, 0.26172628E-09_JPRB, 0.26167096E-09_JPRB, &
  & 0.26163410E-09_JPRB, 0.26163580E-09_JPRB, 0.26168429E-09_JPRB, 0.26177710E-09_JPRB, 0.26190483E-09_JPRB, 0.26205554E-09_JPRB, &
  & 0.26221558E-09_JPRB, 0.26236782E-09_JPRB, 0.26250041E-09_JPRB, 0.26260547E-09_JPRB, 0.26268226E-09_JPRB, 0.26273214E-09_JPRB, &
  & 0.26275673E-09_JPRB, 0.26275654E-09_JPRB, 0.26273114E-09_JPRB, 0.26268063E-09_JPRB, 0.26260660E-09_JPRB, 0.26251326E-09_JPRB, &
  & 0.26240576E-09_JPRB, 0.26229063E-09_JPRB, 0.26217722E-09_JPRB, 0.26207339E-09_JPRB, 0.26198910E-09_JPRB, 0.26193400E-09_JPRB, &
  & 0.26191671E-09_JPRB, 0.26193855E-09_JPRB, 0.26199198E-09_JPRB, 0.26206198E-09_JPRB, 0.26213198E-09_JPRB, 0.26218877E-09_JPRB, &
  & 0.26222494E-09_JPRB, 0.26223898E-09_JPRB, 0.26223473E-09_JPRB, 0.26221866E-09_JPRB, 0.26219676E-09_JPRB, 0.26217228E-09_JPRB, &
  & 0.26214755E-09_JPRB, 0.26212202E-09_JPRB, 0.26209707E-09_JPRB, 0.26207150E-09_JPRB, 0.26204638E-09_JPRB, 0.26202224E-09_JPRB, &
  & 0.26199726E-09_JPRB, 0.26196983E-09_JPRB, 0.26193125E-09_JPRB, 0.26185479E-09_JPRB /)

RGHG5(:,69,12) = (/ &
  & 0.26186464E-09_JPRB, 0.26189600E-09_JPRB, 0.26190455E-09_JPRB, 0.26190539E-09_JPRB, 0.26190039E-09_JPRB, 0.26189029E-09_JPRB, &
  & 0.26187794E-09_JPRB, 0.26187044E-09_JPRB, 0.26187380E-09_JPRB, 0.26188893E-09_JPRB, 0.26191238E-09_JPRB, 0.26193761E-09_JPRB, &
  & 0.26195768E-09_JPRB, 0.26196631E-09_JPRB, 0.26195696E-09_JPRB, 0.26193098E-09_JPRB, 0.26188629E-09_JPRB, 0.26183872E-09_JPRB, &
  & 0.26180758E-09_JPRB, 0.26181024E-09_JPRB, 0.26185418E-09_JPRB, 0.26193703E-09_JPRB, 0.26205027E-09_JPRB, 0.26218339E-09_JPRB, &
  & 0.26232388E-09_JPRB, 0.26245717E-09_JPRB, 0.26257249E-09_JPRB, 0.26266389E-09_JPRB, 0.26273025E-09_JPRB, 0.26277314E-09_JPRB, &
  & 0.26279387E-09_JPRB, 0.26279293E-09_JPRB, 0.26276994E-09_JPRB, 0.26272487E-09_JPRB, 0.26265867E-09_JPRB, 0.26257499E-09_JPRB, &
  & 0.26247726E-09_JPRB, 0.26237254E-09_JPRB, 0.26226862E-09_JPRB, 0.26217406E-09_JPRB, 0.26209757E-09_JPRB, 0.26204830E-09_JPRB, &
  & 0.26203364E-09_JPRB, 0.26205491E-09_JPRB, 0.26210417E-09_JPRB, 0.26216831E-09_JPRB, 0.26223212E-09_JPRB, 0.26228392E-09_JPRB, &
  & 0.26231667E-09_JPRB, 0.26232924E-09_JPRB, 0.26232494E-09_JPRB, 0.26230948E-09_JPRB, 0.26228769E-09_JPRB, 0.26226321E-09_JPRB, &
  & 0.26223748E-09_JPRB, 0.26221136E-09_JPRB, 0.26218480E-09_JPRB, 0.26215863E-09_JPRB, 0.26213298E-09_JPRB, 0.26210717E-09_JPRB, &
  & 0.26208138E-09_JPRB, 0.26205002E-09_JPRB, 0.26200453E-09_JPRB, 0.26190841E-09_JPRB /)

RGHG5(:,70,12) = (/ &
  & 0.26197566E-09_JPRB, 0.26201336E-09_JPRB, 0.26202529E-09_JPRB, 0.26202879E-09_JPRB, 0.26202668E-09_JPRB, 0.26202002E-09_JPRB, &
  & 0.26201227E-09_JPRB, 0.26200930E-09_JPRB, 0.26201605E-09_JPRB, 0.26203317E-09_JPRB, 0.26205602E-09_JPRB, 0.26208002E-09_JPRB, &
  & 0.26209865E-09_JPRB, 0.26210684E-09_JPRB, 0.26209826E-09_JPRB, 0.26207603E-09_JPRB, 0.26203695E-09_JPRB, 0.26199559E-09_JPRB, &
  & 0.26196900E-09_JPRB, 0.26197194E-09_JPRB, 0.26201105E-09_JPRB, 0.26208416E-09_JPRB, 0.26218375E-09_JPRB, 0.26229993E-09_JPRB, &
  & 0.26242239E-09_JPRB, 0.26253777E-09_JPRB, 0.26263747E-09_JPRB, 0.26271596E-09_JPRB, 0.26277286E-09_JPRB, 0.26280930E-09_JPRB, &
  & 0.26282659E-09_JPRB, 0.26282512E-09_JPRB, 0.26280450E-09_JPRB, 0.26276478E-09_JPRB, 0.26270630E-09_JPRB, 0.26263183E-09_JPRB, &
  & 0.26254432E-09_JPRB, 0.26244978E-09_JPRB, 0.26235616E-09_JPRB, 0.26227101E-09_JPRB, 0.26220257E-09_JPRB, 0.26215924E-09_JPRB, &
  & 0.26214755E-09_JPRB, 0.26216790E-09_JPRB, 0.26221322E-09_JPRB, 0.26227109E-09_JPRB, 0.26232860E-09_JPRB, 0.26237507E-09_JPRB, &
  & 0.26240432E-09_JPRB, 0.26241534E-09_JPRB, 0.26241095E-09_JPRB, 0.26239622E-09_JPRB, 0.26237548E-09_JPRB, 0.26235170E-09_JPRB, &
  & 0.26232666E-09_JPRB, 0.26230068E-09_JPRB, 0.26227442E-09_JPRB, 0.26224822E-09_JPRB, 0.26222266E-09_JPRB, 0.26219735E-09_JPRB, &
  & 0.26217040E-09_JPRB, 0.26213787E-09_JPRB, 0.26208646E-09_JPRB, 0.26197411E-09_JPRB /)

RGHG5(:,71,12) = (/ &
  & 0.26208266E-09_JPRB, 0.26212832E-09_JPRB, 0.26214375E-09_JPRB, 0.26215005E-09_JPRB, 0.26215080E-09_JPRB, 0.26214758E-09_JPRB, &
  & 0.26214414E-09_JPRB, 0.26214553E-09_JPRB, 0.26215530E-09_JPRB, 0.26217251E-09_JPRB, 0.26219452E-09_JPRB, 0.26221542E-09_JPRB, &
  & 0.26223196E-09_JPRB, 0.26223926E-09_JPRB, 0.26223107E-09_JPRB, 0.26221156E-09_JPRB, 0.26217759E-09_JPRB, 0.26214159E-09_JPRB, &
  & 0.26211863E-09_JPRB, 0.26212127E-09_JPRB, 0.26215541E-09_JPRB, 0.26221930E-09_JPRB, 0.26230562E-09_JPRB, 0.26240632E-09_JPRB, &
  & 0.26251148E-09_JPRB, 0.26261054E-09_JPRB, 0.26269567E-09_JPRB, 0.26276259E-09_JPRB, 0.26281069E-09_JPRB, 0.26284128E-09_JPRB, &
  & 0.26285554E-09_JPRB, 0.26285368E-09_JPRB, 0.26283550E-09_JPRB, 0.26280084E-09_JPRB, 0.26274966E-09_JPRB, 0.26268454E-09_JPRB, &
  & 0.26260702E-09_JPRB, 0.26252298E-09_JPRB, 0.26243971E-09_JPRB, 0.26236405E-09_JPRB, 0.26230390E-09_JPRB, 0.26226640E-09_JPRB, &
  & 0.26225758E-09_JPRB, 0.26227731E-09_JPRB, 0.26231828E-09_JPRB, 0.26237018E-09_JPRB, 0.26242103E-09_JPRB, 0.26246211E-09_JPRB, &
  & 0.26248773E-09_JPRB, 0.26249733E-09_JPRB, 0.26249289E-09_JPRB, 0.26247921E-09_JPRB, 0.26245991E-09_JPRB, 0.26243821E-09_JPRB, &
  & 0.26241470E-09_JPRB, 0.26239047E-09_JPRB, 0.26236519E-09_JPRB, 0.26234021E-09_JPRB, 0.26231578E-09_JPRB, 0.26229124E-09_JPRB, &
  & 0.26226504E-09_JPRB, 0.26223218E-09_JPRB, 0.26217836E-09_JPRB, 0.26205627E-09_JPRB /)

RGHG5(:,72,12) = (/ &
  & 0.26218699E-09_JPRB, 0.26224128E-09_JPRB, 0.26226066E-09_JPRB, 0.26226932E-09_JPRB, 0.26227256E-09_JPRB, 0.26227229E-09_JPRB, &
  & 0.26227279E-09_JPRB, 0.26227762E-09_JPRB, 0.26228889E-09_JPRB, 0.26230620E-09_JPRB, 0.26232441E-09_JPRB, 0.26234323E-09_JPRB, &
  & 0.26235650E-09_JPRB, 0.26236233E-09_JPRB, 0.26235492E-09_JPRB, 0.26233729E-09_JPRB, 0.26230801E-09_JPRB, 0.26227659E-09_JPRB, &
  & 0.26225683E-09_JPRB, 0.26225896E-09_JPRB, 0.26228836E-09_JPRB, 0.26234293E-09_JPRB, 0.26241720E-09_JPRB, 0.26250274E-09_JPRB, &
  & 0.26259225E-09_JPRB, 0.26267588E-09_JPRB, 0.26274791E-09_JPRB, 0.26280400E-09_JPRB, 0.26284430E-09_JPRB, 0.26286956E-09_JPRB, &
  & 0.26288116E-09_JPRB, 0.26287900E-09_JPRB, 0.26286318E-09_JPRB, 0.26283350E-09_JPRB, 0.26278937E-09_JPRB, 0.26273328E-09_JPRB, &
  & 0.26266561E-09_JPRB, 0.26259217E-09_JPRB, 0.26251917E-09_JPRB, 0.26245339E-09_JPRB, 0.26240113E-09_JPRB, 0.26236971E-09_JPRB, &
  & 0.26236346E-09_JPRB, 0.26238214E-09_JPRB, 0.26241909E-09_JPRB, 0.26246458E-09_JPRB, 0.26250882E-09_JPRB, 0.26254440E-09_JPRB, &
  & 0.26256652E-09_JPRB, 0.26257468E-09_JPRB, 0.26257047E-09_JPRB, 0.26255831E-09_JPRB, 0.26254152E-09_JPRB, 0.26252178E-09_JPRB, &
  & 0.26250147E-09_JPRB, 0.26247904E-09_JPRB, 0.26245656E-09_JPRB, 0.26243274E-09_JPRB, 0.26241070E-09_JPRB, 0.26238745E-09_JPRB, &
  & 0.26236269E-09_JPRB, 0.26233143E-09_JPRB, 0.26227723E-09_JPRB, 0.26215075E-09_JPRB /)

RGHG5(:,73,12) = (/ &
  & 0.26229935E-09_JPRB, 0.26235594E-09_JPRB, 0.26237607E-09_JPRB, 0.26238584E-09_JPRB, 0.26239061E-09_JPRB, 0.26239258E-09_JPRB, &
  & 0.26239574E-09_JPRB, 0.26240271E-09_JPRB, 0.26241478E-09_JPRB, 0.26242933E-09_JPRB, 0.26244656E-09_JPRB, 0.26246039E-09_JPRB, &
  & 0.26247166E-09_JPRB, 0.26247579E-09_JPRB, 0.26246899E-09_JPRB, 0.26245303E-09_JPRB, 0.26242783E-09_JPRB, 0.26240085E-09_JPRB, &
  & 0.26238409E-09_JPRB, 0.26238567E-09_JPRB, 0.26241015E-09_JPRB, 0.26245628E-09_JPRB, 0.26251848E-09_JPRB, 0.26259056E-09_JPRB, &
  & 0.26266495E-09_JPRB, 0.26273467E-09_JPRB, 0.26279440E-09_JPRB, 0.26284080E-09_JPRB, 0.26287389E-09_JPRB, 0.26289432E-09_JPRB, &
  & 0.26290362E-09_JPRB, 0.26290142E-09_JPRB, 0.26288793E-09_JPRB, 0.26286295E-09_JPRB, 0.26282557E-09_JPRB, 0.26277835E-09_JPRB, &
  & 0.26272023E-09_JPRB, 0.26265731E-09_JPRB, 0.26259470E-09_JPRB, 0.26253852E-09_JPRB, 0.26249442E-09_JPRB, 0.26246832E-09_JPRB, &
  & 0.26246441E-09_JPRB, 0.26248190E-09_JPRB, 0.26251418E-09_JPRB, 0.26255320E-09_JPRB, 0.26259109E-09_JPRB, 0.26262145E-09_JPRB, &
  & 0.26263991E-09_JPRB, 0.26264715E-09_JPRB, 0.26264352E-09_JPRB, 0.26263319E-09_JPRB, 0.26261854E-09_JPRB, 0.26260241E-09_JPRB, &
  & 0.26258415E-09_JPRB, 0.26256558E-09_JPRB, 0.26254462E-09_JPRB, 0.26252420E-09_JPRB, 0.26250369E-09_JPRB, 0.26248315E-09_JPRB, &
  & 0.26246036E-09_JPRB, 0.26243147E-09_JPRB, 0.26237945E-09_JPRB, 0.26225311E-09_JPRB /)

RGHG5(:,74,12) = (/ &
  & 0.26240940E-09_JPRB, 0.26246735E-09_JPRB, 0.26248750E-09_JPRB, 0.26249741E-09_JPRB, 0.26250302E-09_JPRB, 0.26250604E-09_JPRB, &
  & 0.26251074E-09_JPRB, 0.26251840E-09_JPRB, 0.26252936E-09_JPRB, 0.26254351E-09_JPRB, 0.26255575E-09_JPRB, 0.26256858E-09_JPRB, &
  & 0.26257641E-09_JPRB, 0.26257929E-09_JPRB, 0.26257302E-09_JPRB, 0.26255878E-09_JPRB, 0.26253746E-09_JPRB, 0.26251448E-09_JPRB, &
  & 0.26250074E-09_JPRB, 0.26250183E-09_JPRB, 0.26252173E-09_JPRB, 0.26255953E-09_JPRB, 0.26261082E-09_JPRB, 0.26266980E-09_JPRB, &
  & 0.26273064E-09_JPRB, 0.26278715E-09_JPRB, 0.26283584E-09_JPRB, 0.26287331E-09_JPRB, 0.26290001E-09_JPRB, 0.26291611E-09_JPRB, &
  & 0.26292343E-09_JPRB, 0.26292130E-09_JPRB, 0.26291003E-09_JPRB, 0.26288943E-09_JPRB, 0.26285873E-09_JPRB, 0.26281979E-09_JPRB, &
  & 0.26277105E-09_JPRB, 0.26271879E-09_JPRB, 0.26266614E-09_JPRB, 0.26261962E-09_JPRB, 0.26258293E-09_JPRB, 0.26256217E-09_JPRB, &
  & 0.26255983E-09_JPRB, 0.26257549E-09_JPRB, 0.26260297E-09_JPRB, 0.26263589E-09_JPRB, 0.26266725E-09_JPRB, 0.26269251E-09_JPRB, &
  & 0.26270813E-09_JPRB, 0.26271427E-09_JPRB, 0.26271141E-09_JPRB, 0.26270303E-09_JPRB, 0.26269131E-09_JPRB, 0.26267716E-09_JPRB, &
  & 0.26266272E-09_JPRB, 0.26264596E-09_JPRB, 0.26262906E-09_JPRB, 0.26261016E-09_JPRB, 0.26259353E-09_JPRB, 0.26257482E-09_JPRB, &
  & 0.26255487E-09_JPRB, 0.26252991E-09_JPRB, 0.26248098E-09_JPRB, 0.26235966E-09_JPRB /)

RGHG5(:,75,12) = (/ &
  & 0.26251590E-09_JPRB, 0.26257357E-09_JPRB, 0.26259314E-09_JPRB, 0.26260238E-09_JPRB, 0.26260827E-09_JPRB, 0.26261143E-09_JPRB, &
  & 0.26261637E-09_JPRB, 0.26262348E-09_JPRB, 0.26263400E-09_JPRB, 0.26264460E-09_JPRB, 0.26265629E-09_JPRB, 0.26266486E-09_JPRB, &
  & 0.26267166E-09_JPRB, 0.26267333E-09_JPRB, 0.26266733E-09_JPRB, 0.26265498E-09_JPRB, 0.26263733E-09_JPRB, 0.26261845E-09_JPRB, &
  & 0.26260755E-09_JPRB, 0.26260816E-09_JPRB, 0.26262376E-09_JPRB, 0.26265382E-09_JPRB, 0.26269470E-09_JPRB, 0.26274177E-09_JPRB, &
  & 0.26278973E-09_JPRB, 0.26283431E-09_JPRB, 0.26287267E-09_JPRB, 0.26290209E-09_JPRB, 0.26292299E-09_JPRB, 0.26293523E-09_JPRB, &
  & 0.26294089E-09_JPRB, 0.26293887E-09_JPRB, 0.26292979E-09_JPRB, 0.26291311E-09_JPRB, 0.26288910E-09_JPRB, 0.26285774E-09_JPRB, &
  & 0.26281866E-09_JPRB, 0.26277630E-09_JPRB, 0.26273361E-09_JPRB, 0.26269642E-09_JPRB, 0.26266705E-09_JPRB, 0.26265076E-09_JPRB, &
  & 0.26264954E-09_JPRB, 0.26266306E-09_JPRB, 0.26268587E-09_JPRB, 0.26271196E-09_JPRB, 0.26273761E-09_JPRB, 0.26275798E-09_JPRB, &
  & 0.26277033E-09_JPRB, 0.26277588E-09_JPRB, 0.26277400E-09_JPRB, 0.26276767E-09_JPRB, 0.26275804E-09_JPRB, 0.26274699E-09_JPRB, &
  & 0.26273450E-09_JPRB, 0.26272146E-09_JPRB, 0.26270655E-09_JPRB, 0.26269142E-09_JPRB, 0.26267732E-09_JPRB, 0.26266186E-09_JPRB, &
  & 0.26264502E-09_JPRB, 0.26262401E-09_JPRB, 0.26258090E-09_JPRB, 0.26246724E-09_JPRB /)

RGHG5(:,76,12) = (/ &
  & 0.26261757E-09_JPRB, 0.26267438E-09_JPRB, 0.26269187E-09_JPRB, 0.26270003E-09_JPRB, 0.26270566E-09_JPRB, 0.26270822E-09_JPRB, &
  & 0.26271274E-09_JPRB, 0.26271879E-09_JPRB, 0.26272701E-09_JPRB, 0.26273672E-09_JPRB, 0.26274397E-09_JPRB, 0.26275179E-09_JPRB, &
  & 0.26275621E-09_JPRB, 0.26275745E-09_JPRB, 0.26275221E-09_JPRB, 0.26274213E-09_JPRB, 0.26272837E-09_JPRB, 0.26271324E-09_JPRB, &
  & 0.26270516E-09_JPRB, 0.26270536E-09_JPRB, 0.26271690E-09_JPRB, 0.26273991E-09_JPRB, 0.26277111E-09_JPRB, 0.26280694E-09_JPRB, &
  & 0.26284303E-09_JPRB, 0.26287636E-09_JPRB, 0.26290542E-09_JPRB, 0.26292751E-09_JPRB, 0.26294319E-09_JPRB, 0.26295191E-09_JPRB, &
  & 0.26295632E-09_JPRB, 0.26295444E-09_JPRB, 0.26294741E-09_JPRB, 0.26293445E-09_JPRB, 0.26291685E-09_JPRB, 0.26289243E-09_JPRB, &
  & 0.26286312E-09_JPRB, 0.26283015E-09_JPRB, 0.26279690E-09_JPRB, 0.26276903E-09_JPRB, 0.26274630E-09_JPRB, 0.26273414E-09_JPRB, &
  & 0.26273350E-09_JPRB, 0.26274477E-09_JPRB, 0.26276245E-09_JPRB, 0.26278268E-09_JPRB, 0.26280197E-09_JPRB, 0.26281777E-09_JPRB, &
  & 0.26282712E-09_JPRB, 0.26283181E-09_JPRB, 0.26283076E-09_JPRB, 0.26282640E-09_JPRB, 0.26281943E-09_JPRB, 0.26281022E-09_JPRB, &
  & 0.26280075E-09_JPRB, 0.26279012E-09_JPRB, 0.26277869E-09_JPRB, 0.26276609E-09_JPRB, 0.26275615E-09_JPRB, 0.26274344E-09_JPRB, &
  & 0.26272967E-09_JPRB, 0.26271427E-09_JPRB, 0.26267682E-09_JPRB, 0.26257474E-09_JPRB /)

RGHG5(:,77,12) = (/ &
  & 0.26271491E-09_JPRB, 0.26276775E-09_JPRB, 0.26278282E-09_JPRB, 0.26278932E-09_JPRB, 0.26279454E-09_JPRB, 0.26279587E-09_JPRB, &
  & 0.26279959E-09_JPRB, 0.26280378E-09_JPRB, 0.26281036E-09_JPRB, 0.26281649E-09_JPRB, 0.26282179E-09_JPRB, 0.26282648E-09_JPRB, &
  & 0.26283015E-09_JPRB, 0.26283128E-09_JPRB, 0.26282712E-09_JPRB, 0.26281977E-09_JPRB, 0.26281019E-09_JPRB, 0.26279892E-09_JPRB, &
  & 0.26279368E-09_JPRB, 0.26279351E-09_JPRB, 0.26280136E-09_JPRB, 0.26281766E-09_JPRB, 0.26284006E-09_JPRB, 0.26286529E-09_JPRB, &
  & 0.26289046E-09_JPRB, 0.26291364E-09_JPRB, 0.26293429E-09_JPRB, 0.26294980E-09_JPRB, 0.26296085E-09_JPRB, 0.26296648E-09_JPRB, &
  & 0.26296987E-09_JPRB, 0.26296809E-09_JPRB, 0.26296315E-09_JPRB, 0.26295341E-09_JPRB, 0.26294175E-09_JPRB, 0.26292379E-09_JPRB, &
  & 0.26290400E-09_JPRB, 0.26287988E-09_JPRB, 0.26285574E-09_JPRB, 0.26283650E-09_JPRB, 0.26282010E-09_JPRB, 0.26281141E-09_JPRB, &
  & 0.26281102E-09_JPRB, 0.26281996E-09_JPRB, 0.26283301E-09_JPRB, 0.26284683E-09_JPRB, 0.26286054E-09_JPRB, 0.26287167E-09_JPRB, &
  & 0.26287789E-09_JPRB, 0.26288177E-09_JPRB, 0.26288141E-09_JPRB, 0.26287900E-09_JPRB, 0.26287414E-09_JPRB, 0.26286728E-09_JPRB, &
  & 0.26286026E-09_JPRB, 0.26285260E-09_JPRB, 0.26284416E-09_JPRB, 0.26283470E-09_JPRB, 0.26282862E-09_JPRB, 0.26281871E-09_JPRB, &
  & 0.26280850E-09_JPRB, 0.26279814E-09_JPRB, 0.26276861E-09_JPRB, 0.26268079E-09_JPRB /)

RGHG5(:,78,12) = (/ &
  & 0.26280644E-09_JPRB, 0.26285024E-09_JPRB, 0.26286015E-09_JPRB, 0.26286467E-09_JPRB, 0.26286959E-09_JPRB, 0.26286950E-09_JPRB, &
  & 0.26287236E-09_JPRB, 0.26287461E-09_JPRB, 0.26287880E-09_JPRB, 0.26288249E-09_JPRB, 0.26288410E-09_JPRB, 0.26288738E-09_JPRB, &
  & 0.26288963E-09_JPRB, 0.26289132E-09_JPRB, 0.26288854E-09_JPRB, 0.26288413E-09_JPRB, 0.26287875E-09_JPRB, 0.26287106E-09_JPRB, &
  & 0.26286862E-09_JPRB, 0.26286837E-09_JPRB, 0.26287308E-09_JPRB, 0.26288366E-09_JPRB, 0.26289845E-09_JPRB, 0.26291427E-09_JPRB, &
  & 0.26293015E-09_JPRB, 0.26294467E-09_JPRB, 0.26295832E-09_JPRB, 0.26296837E-09_JPRB, 0.26297550E-09_JPRB, 0.26297839E-09_JPRB, &
  & 0.26298105E-09_JPRB, 0.26297944E-09_JPRB, 0.26297620E-09_JPRB, 0.26296923E-09_JPRB, 0.26296279E-09_JPRB, 0.26295055E-09_JPRB, &
  & 0.26293917E-09_JPRB, 0.26292302E-09_JPRB, 0.26290681E-09_JPRB, 0.26289537E-09_JPRB, 0.26288410E-09_JPRB, 0.26287833E-09_JPRB, &
  & 0.26287786E-09_JPRB, 0.26288460E-09_JPRB, 0.26289326E-09_JPRB, 0.26290162E-09_JPRB, 0.26290992E-09_JPRB, 0.26291699E-09_JPRB, &
  & 0.26292027E-09_JPRB, 0.26292335E-09_JPRB, 0.26292341E-09_JPRB, 0.26292254E-09_JPRB, 0.26291982E-09_JPRB, 0.26291466E-09_JPRB, &
  & 0.26291019E-09_JPRB, 0.26290509E-09_JPRB, 0.26289940E-09_JPRB, 0.26289265E-09_JPRB, 0.26289027E-09_JPRB, 0.26288297E-09_JPRB, &
  & 0.26287572E-09_JPRB, 0.26287067E-09_JPRB, 0.26285082E-09_JPRB, 0.26278435E-09_JPRB /)

RGHG5(:,79,12) = (/ &
  & 0.26286515E-09_JPRB, 0.26289634E-09_JPRB, 0.26290115E-09_JPRB, 0.26290356E-09_JPRB, 0.26290856E-09_JPRB, 0.26290750E-09_JPRB, &
  & 0.26291000E-09_JPRB, 0.26291114E-09_JPRB, 0.26291430E-09_JPRB, 0.26291666E-09_JPRB, 0.26291663E-09_JPRB, 0.26291885E-09_JPRB, &
  & 0.26292074E-09_JPRB, 0.26292277E-09_JPRB, 0.26292063E-09_JPRB, 0.26291780E-09_JPRB, 0.26291475E-09_JPRB, 0.26290892E-09_JPRB, &
  & 0.26290842E-09_JPRB, 0.26290820E-09_JPRB, 0.26291122E-09_JPRB, 0.26291891E-09_JPRB, 0.26292982E-09_JPRB, 0.26294075E-09_JPRB, &
  & 0.26295155E-09_JPRB, 0.26296143E-09_JPRB, 0.26297142E-09_JPRB, 0.26297853E-09_JPRB, 0.26298358E-09_JPRB, 0.26298483E-09_JPRB, &
  & 0.26298719E-09_JPRB, 0.26298549E-09_JPRB, 0.26298325E-09_JPRB, 0.26297761E-09_JPRB, 0.26297417E-09_JPRB, 0.26296493E-09_JPRB, &
  & 0.26295829E-09_JPRB, 0.26294625E-09_JPRB, 0.26293415E-09_JPRB, 0.26292701E-09_JPRB, 0.26291838E-09_JPRB, 0.26291397E-09_JPRB, &
  & 0.26291336E-09_JPRB, 0.26291919E-09_JPRB, 0.26292560E-09_JPRB, 0.26293079E-09_JPRB, 0.26293615E-09_JPRB, 0.26294100E-09_JPRB, &
  & 0.26294250E-09_JPRB, 0.26294519E-09_JPRB, 0.26294550E-09_JPRB, 0.26294555E-09_JPRB, 0.26294386E-09_JPRB, 0.26293945E-09_JPRB, &
  & 0.26293626E-09_JPRB, 0.26293231E-09_JPRB, 0.26292801E-09_JPRB, 0.26292246E-09_JPRB, 0.26292224E-09_JPRB, 0.26291591E-09_JPRB, &
  & 0.26291028E-09_JPRB, 0.26290936E-09_JPRB, 0.26289695E-09_JPRB, 0.26285066E-09_JPRB /)

RGHG5(:,80,12) = (/ &
  & 0.26290359E-09_JPRB, 0.26291860E-09_JPRB, 0.26291896E-09_JPRB, 0.26292032E-09_JPRB, 0.26292535E-09_JPRB, 0.26292371E-09_JPRB, &
  & 0.26292618E-09_JPRB, 0.26292674E-09_JPRB, 0.26292984E-09_JPRB, 0.26293176E-09_JPRB, 0.26293095E-09_JPRB, 0.26293290E-09_JPRB, &
  & 0.26293451E-09_JPRB, 0.26293676E-09_JPRB, 0.26293479E-09_JPRB, 0.26293259E-09_JPRB, 0.26293073E-09_JPRB, 0.26292565E-09_JPRB, &
  & 0.26292621E-09_JPRB, 0.26292601E-09_JPRB, 0.26292829E-09_JPRB, 0.26293473E-09_JPRB, 0.26294403E-09_JPRB, 0.26295272E-09_JPRB, &
  & 0.26296124E-09_JPRB, 0.26296901E-09_JPRB, 0.26297745E-09_JPRB, 0.26298327E-09_JPRB, 0.26298741E-09_JPRB, 0.26298788E-09_JPRB, &
  & 0.26299013E-09_JPRB, 0.26298833E-09_JPRB, 0.26298635E-09_JPRB, 0.26298133E-09_JPRB, 0.26297936E-09_JPRB, 0.26297137E-09_JPRB, &
  & 0.26296706E-09_JPRB, 0.26295677E-09_JPRB, 0.26294639E-09_JPRB, 0.26294128E-09_JPRB, 0.26293367E-09_JPRB, 0.26292984E-09_JPRB, &
  & 0.26292921E-09_JPRB, 0.26293476E-09_JPRB, 0.26294025E-09_JPRB, 0.26294389E-09_JPRB, 0.26294786E-09_JPRB, 0.26295160E-09_JPRB, &
  & 0.26295216E-09_JPRB, 0.26295480E-09_JPRB, 0.26295516E-09_JPRB, 0.26295566E-09_JPRB, 0.26295449E-09_JPRB, 0.26295024E-09_JPRB, &
  & 0.26294755E-09_JPRB, 0.26294408E-09_JPRB, 0.26294028E-09_JPRB, 0.26293509E-09_JPRB, 0.26293595E-09_JPRB, 0.26293001E-09_JPRB, &
  & 0.26292504E-09_JPRB, 0.26292632E-09_JPRB, 0.26291927E-09_JPRB, 0.26289423E-09_JPRB /)

RGHG5(:,81,12) = (/ &
  & 0.26292959E-09_JPRB, 0.26292807E-09_JPRB, 0.26292654E-09_JPRB, 0.26292740E-09_JPRB, 0.26293248E-09_JPRB, 0.26293065E-09_JPRB, &
  & 0.26293304E-09_JPRB, 0.26293354E-09_JPRB, 0.26293637E-09_JPRB, 0.26293831E-09_JPRB, 0.26293717E-09_JPRB, 0.26293906E-09_JPRB, &
  & 0.26294056E-09_JPRB, 0.26294292E-09_JPRB, 0.26294097E-09_JPRB, 0.26293903E-09_JPRB, 0.26293767E-09_JPRB, 0.26293290E-09_JPRB, &
  & 0.26293398E-09_JPRB, 0.26293381E-09_JPRB, 0.26293578E-09_JPRB, 0.26294161E-09_JPRB, 0.26295033E-09_JPRB, 0.26295799E-09_JPRB, &
  & 0.26296554E-09_JPRB, 0.26297237E-09_JPRB, 0.26298011E-09_JPRB, 0.26298541E-09_JPRB, 0.26298919E-09_JPRB, 0.26298916E-09_JPRB, &
  & 0.26299143E-09_JPRB, 0.26298952E-09_JPRB, 0.26298774E-09_JPRB, 0.26298283E-09_JPRB, 0.26298158E-09_JPRB, 0.26297417E-09_JPRB, &
  & 0.26297095E-09_JPRB, 0.26296143E-09_JPRB, 0.26295185E-09_JPRB, 0.26294761E-09_JPRB, 0.26294045E-09_JPRB, 0.26293681E-09_JPRB, &
  & 0.26293606E-09_JPRB, 0.26294164E-09_JPRB, 0.26294675E-09_JPRB, 0.26294969E-09_JPRB, 0.26295285E-09_JPRB, 0.26295616E-09_JPRB, &
  & 0.26295632E-09_JPRB, 0.26295893E-09_JPRB, 0.26295932E-09_JPRB, 0.26296013E-09_JPRB, 0.26295915E-09_JPRB, 0.26295491E-09_JPRB, &
  & 0.26295247E-09_JPRB, 0.26294913E-09_JPRB, 0.26294550E-09_JPRB, 0.26294039E-09_JPRB, 0.26294183E-09_JPRB, 0.26293587E-09_JPRB, &
  & 0.26293115E-09_JPRB, 0.26293359E-09_JPRB, 0.26292879E-09_JPRB, 0.26292393E-09_JPRB /)

RGHG5(:,82,12) = (/ &
  & 0.26293168E-09_JPRB, 0.26293123E-09_JPRB, 0.26292979E-09_JPRB, 0.26293073E-09_JPRB, 0.26293598E-09_JPRB, 0.26293395E-09_JPRB, &
  & 0.26293634E-09_JPRB, 0.26293664E-09_JPRB, 0.26293978E-09_JPRB, 0.26294156E-09_JPRB, 0.26294020E-09_JPRB, 0.26294203E-09_JPRB, &
  & 0.26294350E-09_JPRB, 0.26294597E-09_JPRB, 0.26294400E-09_JPRB, 0.26294217E-09_JPRB, 0.26294106E-09_JPRB, 0.26293639E-09_JPRB, &
  & 0.26293787E-09_JPRB, 0.26293764E-09_JPRB, 0.26293934E-09_JPRB, 0.26294511E-09_JPRB, 0.26295338E-09_JPRB, 0.26296054E-09_JPRB, &
  & 0.26296762E-09_JPRB, 0.26297400E-09_JPRB, 0.26298144E-09_JPRB, 0.26298652E-09_JPRB, 0.26299010E-09_JPRB, 0.26298985E-09_JPRB, &
  & 0.26299213E-09_JPRB, 0.26299010E-09_JPRB, 0.26298835E-09_JPRB, 0.26298352E-09_JPRB, 0.26298261E-09_JPRB, 0.26297556E-09_JPRB, &
  & 0.26297275E-09_JPRB, 0.26296371E-09_JPRB, 0.26295460E-09_JPRB, 0.26295069E-09_JPRB, 0.26294383E-09_JPRB, 0.26294020E-09_JPRB, &
  & 0.26293942E-09_JPRB, 0.26294505E-09_JPRB, 0.26295005E-09_JPRB, 0.26295252E-09_JPRB, 0.26295532E-09_JPRB, 0.26295832E-09_JPRB, &
  & 0.26295824E-09_JPRB, 0.26296090E-09_JPRB, 0.26296135E-09_JPRB, 0.26296235E-09_JPRB, 0.26296143E-09_JPRB, 0.26295710E-09_JPRB, &
  & 0.26295477E-09_JPRB, 0.26295155E-09_JPRB, 0.26294800E-09_JPRB, 0.26294289E-09_JPRB, 0.26294464E-09_JPRB, 0.26293870E-09_JPRB, &
  & 0.26293404E-09_JPRB, 0.26293681E-09_JPRB, 0.26293198E-09_JPRB, 0.26292626E-09_JPRB /)

RGHG5(:,83,12) = (/ &
  & 0.26293309E-09_JPRB, 0.26293318E-09_JPRB, 0.26293162E-09_JPRB, 0.26293256E-09_JPRB, 0.26293789E-09_JPRB, 0.26293581E-09_JPRB, &
  & 0.26293817E-09_JPRB, 0.26293853E-09_JPRB, 0.26294136E-09_JPRB, 0.26294336E-09_JPRB, 0.26294195E-09_JPRB, 0.26294381E-09_JPRB, &
  & 0.26294517E-09_JPRB, 0.26294766E-09_JPRB, 0.26294567E-09_JPRB, 0.26294389E-09_JPRB, 0.26294295E-09_JPRB, 0.26293837E-09_JPRB, &
  & 0.26294006E-09_JPRB, 0.26293981E-09_JPRB, 0.26294145E-09_JPRB, 0.26294686E-09_JPRB, 0.26295519E-09_JPRB, 0.26296204E-09_JPRB, &
  & 0.26296887E-09_JPRB, 0.26297492E-09_JPRB, 0.26298227E-09_JPRB, 0.26298713E-09_JPRB, 0.26299063E-09_JPRB, 0.26299013E-09_JPRB, &
  & 0.26299254E-09_JPRB, 0.26299041E-09_JPRB, 0.26298869E-09_JPRB, 0.26298391E-09_JPRB, 0.26298311E-09_JPRB, 0.26297634E-09_JPRB, &
  & 0.26297367E-09_JPRB, 0.26296504E-09_JPRB, 0.26295621E-09_JPRB, 0.26295247E-09_JPRB, 0.26294572E-09_JPRB, 0.26294217E-09_JPRB, &
  & 0.26294136E-09_JPRB, 0.26294689E-09_JPRB, 0.26295194E-09_JPRB, 0.26295419E-09_JPRB, 0.26295671E-09_JPRB, 0.26295957E-09_JPRB, &
  & 0.26295927E-09_JPRB, 0.26296201E-09_JPRB, 0.26296246E-09_JPRB, 0.26296360E-09_JPRB, 0.26296271E-09_JPRB, 0.26295841E-09_JPRB, &
  & 0.26295605E-09_JPRB, 0.26295288E-09_JPRB, 0.26294938E-09_JPRB, 0.26294422E-09_JPRB, 0.26294622E-09_JPRB, 0.26294023E-09_JPRB, &
  & 0.26293553E-09_JPRB, 0.26293864E-09_JPRB, 0.26293390E-09_JPRB, 0.26292790E-09_JPRB /)

RGHG5(:,84,12) = (/ &
  & 0.26293404E-09_JPRB, 0.26293437E-09_JPRB, 0.26293279E-09_JPRB, 0.26293367E-09_JPRB, 0.26293911E-09_JPRB, 0.26293695E-09_JPRB, &
  & 0.26293928E-09_JPRB, 0.26293959E-09_JPRB, 0.26294272E-09_JPRB, 0.26294433E-09_JPRB, 0.26294317E-09_JPRB, 0.26294472E-09_JPRB, &
  & 0.26294625E-09_JPRB, 0.26294858E-09_JPRB, 0.26294672E-09_JPRB, 0.26294497E-09_JPRB, 0.26294411E-09_JPRB, 0.26293956E-09_JPRB, &
  & 0.26294139E-09_JPRB, 0.26294114E-09_JPRB, 0.26294261E-09_JPRB, 0.26294819E-09_JPRB, 0.26295618E-09_JPRB, 0.26296296E-09_JPRB, &
  & 0.26296959E-09_JPRB, 0.26297553E-09_JPRB, 0.26298280E-09_JPRB, 0.26298758E-09_JPRB, 0.26299099E-09_JPRB, 0.26299035E-09_JPRB, &
  & 0.26299282E-09_JPRB, 0.26299057E-09_JPRB, 0.26298888E-09_JPRB, 0.26298405E-09_JPRB, 0.26298330E-09_JPRB, 0.26297681E-09_JPRB, &
  & 0.26297420E-09_JPRB, 0.26296576E-09_JPRB, 0.26295732E-09_JPRB, 0.26295346E-09_JPRB, 0.26294708E-09_JPRB, 0.26294339E-09_JPRB, &
  & 0.26294247E-09_JPRB, 0.26294816E-09_JPRB, 0.26295308E-09_JPRB, 0.26295519E-09_JPRB, 0.26295749E-09_JPRB, 0.26296024E-09_JPRB, &
  & 0.26295982E-09_JPRB, 0.26296260E-09_JPRB, 0.26296312E-09_JPRB, 0.26296432E-09_JPRB, 0.26296351E-09_JPRB, 0.26295921E-09_JPRB, &
  & 0.26295685E-09_JPRB, 0.26295369E-09_JPRB, 0.26295019E-09_JPRB, 0.26294505E-09_JPRB, 0.26294725E-09_JPRB, 0.26294120E-09_JPRB, &
  & 0.26293645E-09_JPRB, 0.26293981E-09_JPRB, 0.26293515E-09_JPRB, 0.26292898E-09_JPRB /)

RGHG5(:,85,12) = (/ &
  & 0.26293465E-09_JPRB, 0.26293517E-09_JPRB, 0.26293345E-09_JPRB, 0.26293434E-09_JPRB, 0.26293992E-09_JPRB, 0.26293767E-09_JPRB, &
  & 0.26294000E-09_JPRB, 0.26294064E-09_JPRB, 0.26294325E-09_JPRB, 0.26294480E-09_JPRB, 0.26294417E-09_JPRB, 0.26294553E-09_JPRB, &
  & 0.26294689E-09_JPRB, 0.26294891E-09_JPRB, 0.26294733E-09_JPRB, 0.26294567E-09_JPRB, 0.26294486E-09_JPRB, 0.26294045E-09_JPRB, &
  & 0.26294228E-09_JPRB, 0.26294197E-09_JPRB, 0.26294339E-09_JPRB, 0.26294872E-09_JPRB, 0.26295699E-09_JPRB, 0.26296351E-09_JPRB, &
  & 0.26297009E-09_JPRB, 0.26297589E-09_JPRB, 0.26298322E-09_JPRB, 0.26298794E-09_JPRB, 0.26299130E-09_JPRB, 0.26299052E-09_JPRB, &
  & 0.26299304E-09_JPRB, 0.26299071E-09_JPRB, 0.26298891E-09_JPRB, 0.26298411E-09_JPRB, 0.26298344E-09_JPRB, 0.26297714E-09_JPRB, &
  & 0.26297459E-09_JPRB, 0.26296643E-09_JPRB, 0.26295791E-09_JPRB, 0.26295430E-09_JPRB, 0.26294772E-09_JPRB, 0.26294419E-09_JPRB, &
  & 0.26294331E-09_JPRB, 0.26294886E-09_JPRB, 0.26295399E-09_JPRB, 0.26295588E-09_JPRB, 0.26295799E-09_JPRB, 0.26296068E-09_JPRB, &
  & 0.26296021E-09_JPRB, 0.26296304E-09_JPRB, 0.26296360E-09_JPRB, 0.26296487E-09_JPRB, 0.26296407E-09_JPRB, 0.26295977E-09_JPRB, &
  & 0.26295735E-09_JPRB, 0.26295419E-09_JPRB, 0.26295072E-09_JPRB, 0.26294553E-09_JPRB, 0.26294791E-09_JPRB, 0.26294183E-09_JPRB, &
  & 0.26293703E-09_JPRB, 0.26294053E-09_JPRB, 0.26293601E-09_JPRB, 0.26292976E-09_JPRB /)

RGHG5(:,86,12) = (/ &
  & 0.26293498E-09_JPRB, 0.26293567E-09_JPRB, 0.26293390E-09_JPRB, 0.26293467E-09_JPRB, 0.26294053E-09_JPRB, 0.26293828E-09_JPRB, &
  & 0.26294061E-09_JPRB, 0.26294145E-09_JPRB, 0.26294372E-09_JPRB, 0.26294500E-09_JPRB, 0.26294483E-09_JPRB, 0.26294594E-09_JPRB, &
  & 0.26294716E-09_JPRB, 0.26294888E-09_JPRB, 0.26294772E-09_JPRB, 0.26294622E-09_JPRB, 0.26294525E-09_JPRB, 0.26294111E-09_JPRB, &
  & 0.26294286E-09_JPRB, 0.26294253E-09_JPRB, 0.26294372E-09_JPRB, 0.26294916E-09_JPRB, 0.26295732E-09_JPRB, 0.26296390E-09_JPRB, &
  & 0.26297037E-09_JPRB, 0.26297611E-09_JPRB, 0.26298358E-09_JPRB, 0.26298824E-09_JPRB, 0.26299152E-09_JPRB, 0.26299055E-09_JPRB, &
  & 0.26299313E-09_JPRB, 0.26299077E-09_JPRB, 0.26298899E-09_JPRB, 0.26298419E-09_JPRB, 0.26298358E-09_JPRB, 0.26297736E-09_JPRB, &
  & 0.26297503E-09_JPRB, 0.26296676E-09_JPRB, 0.26295829E-09_JPRB, 0.26295471E-09_JPRB, 0.26294819E-09_JPRB, 0.26294447E-09_JPRB, &
  & 0.26294356E-09_JPRB, 0.26294958E-09_JPRB, 0.26295457E-09_JPRB, 0.26295635E-09_JPRB, 0.26295829E-09_JPRB, 0.26296101E-09_JPRB, &
  & 0.26296040E-09_JPRB, 0.26296323E-09_JPRB, 0.26296390E-09_JPRB, 0.26296523E-09_JPRB, 0.26296448E-09_JPRB, 0.26296010E-09_JPRB, &
  & 0.26295771E-09_JPRB, 0.26295449E-09_JPRB, 0.26295102E-09_JPRB, 0.26294586E-09_JPRB, 0.26294833E-09_JPRB, 0.26294220E-09_JPRB, &
  & 0.26293731E-09_JPRB, 0.26294109E-09_JPRB, 0.26293656E-09_JPRB, 0.26293029E-09_JPRB /)

RGHG5(:,87,12) = (/ &
  & 0.26293520E-09_JPRB, 0.26293606E-09_JPRB, 0.26293415E-09_JPRB, 0.26293490E-09_JPRB, 0.26294089E-09_JPRB, 0.26293867E-09_JPRB, &
  & 0.26294100E-09_JPRB, 0.26294200E-09_JPRB, 0.26294406E-09_JPRB, 0.26294522E-09_JPRB, 0.26294528E-09_JPRB, 0.26294622E-09_JPRB, &
  & 0.26294736E-09_JPRB, 0.26294866E-09_JPRB, 0.26294780E-09_JPRB, 0.26294647E-09_JPRB, 0.26294550E-09_JPRB, 0.26294156E-09_JPRB, &
  & 0.26294317E-09_JPRB, 0.26294286E-09_JPRB, 0.26294392E-09_JPRB, 0.26294922E-09_JPRB, 0.26295760E-09_JPRB, 0.26296409E-09_JPRB, &
  & 0.26297059E-09_JPRB, 0.26297625E-09_JPRB, 0.26298388E-09_JPRB, 0.26298852E-09_JPRB, 0.26299177E-09_JPRB, 0.26299063E-09_JPRB, &
  & 0.26299324E-09_JPRB, 0.26299082E-09_JPRB, 0.26298899E-09_JPRB, 0.26298413E-09_JPRB, 0.26298372E-09_JPRB, 0.26297747E-09_JPRB, &
  & 0.26297547E-09_JPRB, 0.26296718E-09_JPRB, 0.26295832E-09_JPRB, 0.26295516E-09_JPRB, 0.26294822E-09_JPRB, 0.26294461E-09_JPRB, &
  & 0.26294367E-09_JPRB, 0.26294994E-09_JPRB, 0.26295507E-09_JPRB, 0.26295671E-09_JPRB, 0.26295849E-09_JPRB, 0.26296115E-09_JPRB, &
  & 0.26296049E-09_JPRB, 0.26296332E-09_JPRB, 0.26296407E-09_JPRB, 0.26296551E-09_JPRB, 0.26296473E-09_JPRB, 0.26296029E-09_JPRB, &
  & 0.26295788E-09_JPRB, 0.26295460E-09_JPRB, 0.26295119E-09_JPRB, 0.26294597E-09_JPRB, 0.26294855E-09_JPRB, 0.26294245E-09_JPRB, &
  & 0.26293748E-09_JPRB, 0.26294136E-09_JPRB, 0.26293692E-09_JPRB, 0.26293065E-09_JPRB /)

RGHG5(:,88,12) = (/ &
  & 0.26293528E-09_JPRB, 0.26293620E-09_JPRB, 0.26293434E-09_JPRB, 0.26293492E-09_JPRB, 0.26294114E-09_JPRB, 0.26293889E-09_JPRB, &
  & 0.26294125E-09_JPRB, 0.26294233E-09_JPRB, 0.26294422E-09_JPRB, 0.26294542E-09_JPRB, 0.26294550E-09_JPRB, 0.26294647E-09_JPRB, &
  & 0.26294747E-09_JPRB, 0.26294875E-09_JPRB, 0.26294794E-09_JPRB, 0.26294666E-09_JPRB, 0.26294564E-09_JPRB, 0.26294178E-09_JPRB, &
  & 0.26294342E-09_JPRB, 0.26294297E-09_JPRB, 0.26294394E-09_JPRB, 0.26294927E-09_JPRB, 0.26295777E-09_JPRB, 0.26296423E-09_JPRB, &
  & 0.26297070E-09_JPRB, 0.26297628E-09_JPRB, 0.26298413E-09_JPRB, 0.26298871E-09_JPRB, 0.26299191E-09_JPRB, 0.26299066E-09_JPRB, &
  & 0.26299332E-09_JPRB, 0.26299082E-09_JPRB, 0.26298905E-09_JPRB, 0.26298413E-09_JPRB, 0.26298386E-09_JPRB, 0.26297756E-09_JPRB, &
  & 0.26297584E-09_JPRB, 0.26296737E-09_JPRB, 0.26295827E-09_JPRB, 0.26295546E-09_JPRB, 0.26294830E-09_JPRB, 0.26294456E-09_JPRB, &
  & 0.26294361E-09_JPRB, 0.26295027E-09_JPRB, 0.26295538E-09_JPRB, 0.26295691E-09_JPRB, 0.26295857E-09_JPRB, 0.26296124E-09_JPRB, &
  & 0.26296051E-09_JPRB, 0.26296335E-09_JPRB, 0.26296418E-09_JPRB, 0.26296570E-09_JPRB, 0.26296493E-09_JPRB, 0.26296043E-09_JPRB, &
  & 0.26295799E-09_JPRB, 0.26295471E-09_JPRB, 0.26295127E-09_JPRB, 0.26294605E-09_JPRB, 0.26294877E-09_JPRB, 0.26294256E-09_JPRB, &
  & 0.26293756E-09_JPRB, 0.26294156E-09_JPRB, 0.26293723E-09_JPRB, 0.26293082E-09_JPRB /)

RGHG5(:,89,12) = (/ &
  & 0.26293537E-09_JPRB, 0.26293626E-09_JPRB, 0.26293440E-09_JPRB, 0.26293498E-09_JPRB, 0.26294136E-09_JPRB, 0.26293878E-09_JPRB, &
  & 0.26294128E-09_JPRB, 0.26294217E-09_JPRB, 0.26294433E-09_JPRB, 0.26294550E-09_JPRB, 0.26294550E-09_JPRB, 0.26294644E-09_JPRB, &
  & 0.26294761E-09_JPRB, 0.26294891E-09_JPRB, 0.26294800E-09_JPRB, 0.26294672E-09_JPRB, 0.26294580E-09_JPRB, 0.26294175E-09_JPRB, &
  & 0.26294350E-09_JPRB, 0.26294311E-09_JPRB, 0.26294389E-09_JPRB, 0.26294936E-09_JPRB, 0.26295791E-09_JPRB, 0.26296429E-09_JPRB, &
  & 0.26297076E-09_JPRB, 0.26297625E-09_JPRB, 0.26298427E-09_JPRB, 0.26298885E-09_JPRB, 0.26299207E-09_JPRB, 0.26299063E-09_JPRB, &
  & 0.26299335E-09_JPRB, 0.26299082E-09_JPRB, 0.26298907E-09_JPRB, 0.26298408E-09_JPRB, 0.26298411E-09_JPRB, 0.26297753E-09_JPRB, &
  & 0.26297617E-09_JPRB, 0.26296748E-09_JPRB, 0.26295810E-09_JPRB, 0.26295571E-09_JPRB, 0.26294825E-09_JPRB, 0.26294450E-09_JPRB, &
  & 0.26294356E-09_JPRB, 0.26295047E-09_JPRB, 0.26295560E-09_JPRB, 0.26295699E-09_JPRB, 0.26295863E-09_JPRB, 0.26296132E-09_JPRB, &
  & 0.26296043E-09_JPRB, 0.26296337E-09_JPRB, 0.26296423E-09_JPRB, 0.26296576E-09_JPRB, 0.26296501E-09_JPRB, 0.26296049E-09_JPRB, &
  & 0.26295807E-09_JPRB, 0.26295480E-09_JPRB, 0.26295133E-09_JPRB, 0.26294608E-09_JPRB, 0.26294900E-09_JPRB, 0.26294264E-09_JPRB, &
  & 0.26293756E-09_JPRB, 0.26294175E-09_JPRB, 0.26293737E-09_JPRB, 0.26293087E-09_JPRB /)

RGHG5(:,90,12) = (/ &
  & 0.26293545E-09_JPRB, 0.26293634E-09_JPRB, 0.26293445E-09_JPRB, 0.26293473E-09_JPRB, 0.26294167E-09_JPRB, 0.26293848E-09_JPRB, &
  & 0.26294122E-09_JPRB, 0.26294181E-09_JPRB, 0.26294422E-09_JPRB, 0.26294575E-09_JPRB, 0.26294533E-09_JPRB, 0.26294650E-09_JPRB, &
  & 0.26294775E-09_JPRB, 0.26294958E-09_JPRB, 0.26294816E-09_JPRB, 0.26294666E-09_JPRB, 0.26294600E-09_JPRB, 0.26294142E-09_JPRB, &
  & 0.26294367E-09_JPRB, 0.26294311E-09_JPRB, 0.26294381E-09_JPRB, 0.26294925E-09_JPRB, 0.26295802E-09_JPRB, 0.26296434E-09_JPRB, &
  & 0.26297087E-09_JPRB, 0.26297620E-09_JPRB, 0.26298444E-09_JPRB, 0.26298896E-09_JPRB, 0.26299232E-09_JPRB, 0.26299049E-09_JPRB, &
  & 0.26299357E-09_JPRB, 0.26299085E-09_JPRB, 0.26298927E-09_JPRB, 0.26298383E-09_JPRB, 0.26298438E-09_JPRB, 0.26297736E-09_JPRB, &
  & 0.26297656E-09_JPRB, 0.26296754E-09_JPRB, 0.26295785E-09_JPRB, 0.26295582E-09_JPRB, 0.26294816E-09_JPRB, 0.26294442E-09_JPRB, &
  & 0.26294333E-09_JPRB, 0.26295055E-09_JPRB, 0.26295577E-09_JPRB, 0.26295710E-09_JPRB, 0.26295871E-09_JPRB, 0.26296146E-09_JPRB, &
  & 0.26296040E-09_JPRB, 0.26296346E-09_JPRB, 0.26296423E-09_JPRB, 0.26296593E-09_JPRB, 0.26296521E-09_JPRB, 0.26296049E-09_JPRB, &
  & 0.26295807E-09_JPRB, 0.26295480E-09_JPRB, 0.26295141E-09_JPRB, 0.26294592E-09_JPRB, 0.26294930E-09_JPRB, 0.26294264E-09_JPRB, &
  & 0.26293734E-09_JPRB, 0.26294200E-09_JPRB, 0.26293742E-09_JPRB, 0.26293082E-09_JPRB /)

RGHG5(:,91,12) = (/ &
  & 0.26293556E-09_JPRB, 0.26293645E-09_JPRB, 0.26293429E-09_JPRB, 0.26293423E-09_JPRB, 0.26294247E-09_JPRB, 0.26293778E-09_JPRB, &
  & 0.26294142E-09_JPRB, 0.26294061E-09_JPRB, 0.26294439E-09_JPRB, 0.26294722E-09_JPRB, 0.26294392E-09_JPRB, 0.26294641E-09_JPRB, &
  & 0.26294786E-09_JPRB, 0.26295105E-09_JPRB, 0.26294811E-09_JPRB, 0.26294644E-09_JPRB, 0.26294653E-09_JPRB, 0.26294053E-09_JPRB, &
  & 0.26294394E-09_JPRB, 0.26294303E-09_JPRB, 0.26294342E-09_JPRB, 0.26294905E-09_JPRB, 0.26295821E-09_JPRB, 0.26296434E-09_JPRB, &
  & 0.26297092E-09_JPRB, 0.26297597E-09_JPRB, 0.26298472E-09_JPRB, 0.26298907E-09_JPRB, 0.26299263E-09_JPRB, 0.26299013E-09_JPRB, &
  & 0.26299404E-09_JPRB, 0.26299080E-09_JPRB, 0.26298969E-09_JPRB, 0.26298327E-09_JPRB, 0.26298502E-09_JPRB, 0.26297689E-09_JPRB, &
  & 0.26297733E-09_JPRB, 0.26296740E-09_JPRB, 0.26295718E-09_JPRB, 0.26295624E-09_JPRB, 0.26294794E-09_JPRB, 0.26294419E-09_JPRB, &
  & 0.26294278E-09_JPRB, 0.26295066E-09_JPRB, 0.26295607E-09_JPRB, 0.26295707E-09_JPRB, 0.26295863E-09_JPRB, 0.26296171E-09_JPRB, &
  & 0.26296010E-09_JPRB, 0.26296365E-09_JPRB, 0.26296418E-09_JPRB, 0.26296607E-09_JPRB, 0.26296545E-09_JPRB, 0.26296032E-09_JPRB, &
  & 0.26295818E-09_JPRB, 0.26295477E-09_JPRB, 0.26295152E-09_JPRB, 0.26294530E-09_JPRB, 0.26294994E-09_JPRB, 0.26294247E-09_JPRB, &
  & 0.26293670E-09_JPRB, 0.26294247E-09_JPRB, 0.26293723E-09_JPRB, 0.26293062E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C11CLIM:PART24',1,ZHOOK_HANDLE)
END SUBROUTINE PART24

END SUBROUTINE SU_C11CLIM
