!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0 
SUBROUTINE SU_C12CLIM


!**   CFC12 FROM D.CARIOLLE 2D MODEL* 

!     PURPOSE.
!     --------

!**   INTERFACE.
!     ----------
!        CALL *SU_C12CLIM* FROM *SU_GHGCLIM*

!        EXPLICIT ARGUMENTS :
!        --------------------
!     ==== INPUTS ===
!     ==== OUTPUTS ===

!        IMPLICIT ARGUMENTS :   NONE
!        --------------------

!     METHOD.
!     -------

!     EXTERNALS.
!     ----------

!          NONE

!     REFERENCE.
!     ----------

!        SEE RADIATION'S PART OF THE MODEL'S DOCUMENTATION AND
!        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE "I.F.S"

!     AUTHOR.
!     -------
!     J.-J. MORCRETTE  E.C.M.W.F.    20080423

!     MODIFICATIONS.
!     --------------
!        Same history as suecaesu
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     R. Elkhatib 12-10-2005 Split for faster and more robust compilation.

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCLIM   ,ONLY : RGHG6

IMPLICIT NONE

!     -----------------------------------------------------------------

!*       0.1   ARGUMENTS.
!              ----------
! REAL(KIND=JPRB),INTENT(OUT) :: PCLC12(64,91,12)

!     ----------------------------------------------------------------- 

!*       0.2   LOCAL ARRAYS.
!              -------------

! REAL(KIND=JPRB),SAVE :: ZGHG6(64,91,12)

LOGICAL,SAVE :: LLFIRSTCALL = .TRUE.

REAL(KIND=JPRB) :: ZHOOK_HANDLE
!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM',0,ZHOOK_HANDLE)

IF(LLFIRSTCALL) THEN

  ALLOCATE(RGHG6(64,91,12))

  CALL PART1
  CALL PART2
  CALL PART3
  CALL PART4
  CALL PART5
  CALL PART6
  CALL PART7
  CALL PART8
  CALL PART9
  CALL PART10
  CALL PART11
  CALL PART12
  CALL PART13
  CALL PART14
  CALL PART15
  CALL PART16
  CALL PART17
  CALL PART18
  CALL PART19
  CALL PART20
  CALL PART21
  CALL PART22
  CALL PART23
  CALL PART24

ENDIF

! PCLC12(:,:,:)=ZGHG6(:,:,:)

!     ------------------------------------------------------------------

LLFIRSTCALL = .FALSE.

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM',1,ZHOOK_HANDLE)

!-----------------------------------------------------------------------------

CONTAINS

SUBROUTINE PART1
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART1',0,ZHOOK_HANDLE)



!-- Month=  1 ------------

RGHG6(:, 1, 1) = (/ &
  & 0.37963512E-36_JPRB, 0.43985475E-35_JPRB, 0.84266192E-35_JPRB, 0.10527320E-34_JPRB, 0.11384811E-34_JPRB, 0.13422550E-34_JPRB, &
  & 0.16790730E-34_JPRB, 0.23260489E-34_JPRB, 0.34560622E-34_JPRB, 0.54533226E-34_JPRB, 0.88644310E-34_JPRB, 0.14313635E-33_JPRB, &
  & 0.23062740E-33_JPRB, 0.40896032E-33_JPRB, 0.76412744E-33_JPRB, 0.13503748E-32_JPRB, 0.23533830E-32_JPRB, 0.40401418E-32_JPRB, &
  & 0.67642316E-32_JPRB, 0.11086922E-31_JPRB, 0.17377712E-31_JPRB, 0.25843287E-31_JPRB, 0.36384383E-31_JPRB, 0.48806396E-31_JPRB, &
  & 0.63073853E-31_JPRB, 0.79458681E-31_JPRB, 0.99049246E-31_JPRB, 0.12081809E-30_JPRB, 0.13977803E-30_JPRB, 0.15600084E-30_JPRB, &
  & 0.16636727E-30_JPRB, 0.16838991E-30_JPRB, 0.16056599E-30_JPRB, 0.14387360E-30_JPRB, 0.11937356E-30_JPRB, 0.92112637E-31_JPRB, &
  & 0.67015744E-31_JPRB, 0.45611373E-31_JPRB, 0.28729247E-31_JPRB, 0.16970104E-31_JPRB, 0.93537274E-32_JPRB, 0.48713419E-32_JPRB, &
  & 0.24631092E-32_JPRB, 0.12405110E-32_JPRB, 0.63182684E-33_JPRB, 0.32727225E-33_JPRB, 0.17248165E-33_JPRB, 0.92434849E-34_JPRB, &
  & 0.50236628E-34_JPRB, 0.27606752E-34_JPRB, 0.15298898E-34_JPRB, 0.85448696E-35_JPRB, 0.48196280E-35_JPRB, 0.27647399E-35_JPRB, &
  & 0.16313223E-35_JPRB, 0.10035402E-35_JPRB, 0.65128138E-36_JPRB, 0.45003783E-36_JPRB, 0.32769165E-36_JPRB, 0.25018637E-36_JPRB, &
  & 0.19604977E-36_JPRB, 0.15513825E-36_JPRB, 0.12232336E-36_JPRB, 0.10005165E-36_JPRB /)

RGHG6(:, 2, 1) = (/ &
  & 0.24717194E-34_JPRB, 0.18324809E-33_JPRB, 0.33345698E-33_JPRB, 0.41585064E-33_JPRB, 0.46155225E-33_JPRB, 0.55302996E-33_JPRB, &
  & 0.70904598E-33_JPRB, 0.97904445E-33_JPRB, 0.14516317E-32_JPRB, 0.22536857E-32_JPRB, 0.36024457E-32_JPRB, 0.57913223E-32_JPRB, &
  & 0.94067628E-32_JPRB, 0.16676415E-31_JPRB, 0.30861981E-31_JPRB, 0.54741902E-31_JPRB, 0.95308118E-31_JPRB, 0.16359247E-30_JPRB, &
  & 0.27342553E-30_JPRB, 0.44497107E-30_JPRB, 0.69252943E-30_JPRB, 0.10261680E-29_JPRB, 0.14465086E-29_JPRB, 0.19485940E-29_JPRB, &
  & 0.25339917E-29_JPRB, 0.32107979E-29_JPRB, 0.39931915E-29_JPRB, 0.48318746E-29_JPRB, 0.56152598E-29_JPRB, 0.62650117E-29_JPRB, &
  & 0.66706720E-29_JPRB, 0.67380653E-29_JPRB, 0.64072439E-29_JPRB, 0.57117368E-29_JPRB, 0.47176433E-29_JPRB, 0.36292980E-29_JPRB, &
  & 0.26366934E-29_JPRB, 0.18048948E-29_JPRB, 0.11570759E-29_JPRB, 0.69253620E-30_JPRB, 0.38643095E-30_JPRB, 0.20444675E-30_JPRB, &
  & 0.10530904E-30_JPRB, 0.54208804E-31_JPRB, 0.28275365E-31_JPRB, 0.15020119E-31_JPRB, 0.81255320E-32_JPRB, 0.44690010E-32_JPRB, &
  & 0.24913020E-32_JPRB, 0.14031277E-32_JPRB, 0.79631082E-33_JPRB, 0.45504130E-33_JPRB, 0.26221571E-33_JPRB, 0.15325180E-33_JPRB, &
  & 0.91685081E-34_JPRB, 0.56812526E-34_JPRB, 0.36803365E-34_JPRB, 0.25078968E-34_JPRB, 0.17937899E-34_JPRB, 0.13423592E-34_JPRB, &
  & 0.10403894E-34_JPRB, 0.82482051E-35_JPRB, 0.65486127E-35_JPRB, 0.50874443E-35_JPRB /)

RGHG6(:, 3, 1) = (/ &
  & 0.15889923E-32_JPRB, 0.10483678E-31_JPRB, 0.16771654E-31_JPRB, 0.20188451E-31_JPRB, 0.22352376E-31_JPRB, 0.26949754E-31_JPRB, &
  & 0.34710126E-31_JPRB, 0.48182626E-31_JPRB, 0.70823535E-31_JPRB, 0.10979881E-30_JPRB, 0.17488102E-30_JPRB, 0.28001742E-30_JPRB, &
  & 0.45744287E-30_JPRB, 0.80749860E-30_JPRB, 0.14893806E-29_JPRB, 0.26256752E-29_JPRB, 0.45404152E-29_JPRB, 0.77139596E-29_JPRB, &
  & 0.12766543E-28_JPRB, 0.20639123E-28_JPRB, 0.32116170E-28_JPRB, 0.47936032E-28_JPRB, 0.68331417E-28_JPRB, 0.93115752E-28_JPRB, &
  & 0.12212601E-27_JPRB, 0.15566543E-27_JPRB, 0.19308738E-27_JPRB, 0.23289257E-27_JPRB, 0.27017239E-27_JPRB, 0.30113605E-27_JPRB, &
  & 0.32023886E-27_JPRB, 0.32281540E-27_JPRB, 0.30611282E-27_JPRB, 0.27175760E-27_JPRB, 0.22355643E-27_JPRB, 0.17156652E-27_JPRB, &
  & 0.12450041E-27_JPRB, 0.85511061E-28_JPRB, 0.55197453E-28_JPRB, 0.33124418E-28_JPRB, 0.18458504E-28_JPRB, 0.97051056E-29_JPRB, &
  & 0.49831809E-29_JPRB, 0.25707520E-29_JPRB, 0.13534214E-29_JPRB, 0.72946350E-30_JPRB, 0.40126304E-30_JPRB, 0.22415878E-30_JPRB, &
  & 0.12642756E-30_JPRB, 0.71614096E-31_JPRB, 0.40581821E-31_JPRB, 0.22968206E-31_JPRB, 0.12992741E-31_JPRB, 0.73835004E-32_JPRB, &
  & 0.42547587E-32_JPRB, 0.25193226E-32_JPRB, 0.15538325E-32_JPRB, 0.10092013E-32_JPRB, 0.69469788E-33_JPRB, 0.50666663E-33_JPRB, &
  & 0.38768685E-33_JPRB, 0.30318966E-33_JPRB, 0.23198170E-33_JPRB, 0.16039705E-33_JPRB /)

RGHG6(:, 4, 1) = (/ &
  & 0.36509286E-30_JPRB, 0.13080590E-29_JPRB, 0.16956164E-29_JPRB, 0.19274466E-29_JPRB, 0.20972651E-29_JPRB, 0.25205524E-29_JPRB, &
  & 0.32515716E-29_JPRB, 0.44901970E-29_JPRB, 0.66498923E-29_JPRB, 0.10310814E-28_JPRB, 0.16465416E-28_JPRB, 0.26468067E-28_JPRB, &
  & 0.43077660E-28_JPRB, 0.76028660E-28_JPRB, 0.13913423E-27_JPRB, 0.24375568E-27_JPRB, 0.41700953E-27_JPRB, 0.70058282E-27_JPRB, &
  & 0.11457430E-26_JPRB, 0.18357935E-26_JPRB, 0.28465940E-26_JPRB, 0.42585473E-26_JPRB, 0.61127387E-26_JPRB, 0.83814823E-26_JPRB, &
  & 0.11038427E-25_JPRB, 0.14055027E-25_JPRB, 0.17380980E-25_JPRB, 0.20845220E-25_JPRB, 0.24112477E-25_JPRB, 0.26833698E-25_JPRB, &
  & 0.28485290E-25_JPRB, 0.28656266E-25_JPRB, 0.27100503E-25_JPRB, 0.24011300E-25_JPRB, 0.19716318E-25_JPRB, 0.15106258E-25_JPRB, &
  & 0.10966171E-25_JPRB, 0.75407306E-26_JPRB, 0.48795504E-26_JPRB, 0.29330600E-26_JPRB, 0.16301741E-26_JPRB, 0.85641415E-27_JPRB, &
  & 0.44097127E-27_JPRB, 0.22996068E-27_JPRB, 0.12312037E-27_JPRB, 0.67716112E-28_JPRB, 0.38021811E-28_JPRB, 0.21618842E-28_JPRB, &
  & 0.12342640E-28_JPRB, 0.70250085E-29_JPRB, 0.39658494E-29_JPRB, 0.22153818E-29_JPRB, 0.12247901E-29_JPRB, 0.67325282E-30_JPRB, &
  & 0.37143877E-30_JPRB, 0.20896904E-30_JPRB, 0.12214563E-30_JPRB, 0.75850871E-31_JPRB, 0.50871175E-31_JPRB, 0.37046815E-31_JPRB, &
  & 0.28904651E-31_JPRB, 0.23154329E-31_JPRB, 0.17788386E-31_JPRB, 0.11136079E-31_JPRB /)

RGHG6(:, 5, 1) = (/ &
  & 0.21357506E-27_JPRB, 0.35724106E-27_JPRB, 0.38885715E-27_JPRB, 0.42241258E-27_JPRB, 0.45941624E-27_JPRB, 0.55578491E-27_JPRB, &
  & 0.71841954E-27_JPRB, 0.99820573E-27_JPRB, 0.14739178E-26_JPRB, 0.22970821E-26_JPRB, 0.36646942E-26_JPRB, 0.58400147E-26_JPRB, &
  & 0.94185763E-26_JPRB, 0.16396050E-25_JPRB, 0.29575437E-25_JPRB, 0.50881787E-25_JPRB, 0.85419301E-25_JPRB, 0.14059685E-24_JPRB, &
  & 0.22516361E-24_JPRB, 0.35361333E-24_JPRB, 0.53827352E-24_JPRB, 0.79388639E-24_JPRB, 0.11260996E-23_JPRB, 0.15283140E-23_JPRB, &
  & 0.19903146E-23_JPRB, 0.25052017E-23_JPRB, 0.30588032E-23_JPRB, 0.36286750E-23_JPRB, 0.41655236E-23_JPRB, 0.46099438E-23_JPRB, &
  & 0.48766135E-23_JPRB, 0.48938126E-23_JPRB, 0.46254883E-23_JPRB, 0.40995437E-23_JPRB, 0.33749935E-23_JPRB, 0.25955283E-23_JPRB, &
  & 0.18921316E-23_JPRB, 0.13106885E-23_JPRB, 0.85610114E-24_JPRB, 0.51975294E-24_JPRB, 0.29261787E-24_JPRB, 0.15601137E-24_JPRB, &
  & 0.82051752E-25_JPRB, 0.43913058E-25_JPRB, 0.24212326E-25_JPRB, 0.13733333E-25_JPRB, 0.79463677E-26_JPRB, 0.46424106E-26_JPRB, &
  & 0.27100671E-26_JPRB, 0.15670819E-26_JPRB, 0.89235508E-27_JPRB, 0.49929170E-27_JPRB, 0.27473853E-27_JPRB, 0.14947341E-27_JPRB, &
  & 0.81240028E-28_JPRB, 0.44856600E-28_JPRB, 0.25734550E-28_JPRB, 0.15772011E-28_JPRB, 0.10568835E-28_JPRB, 0.78158375E-29_JPRB, &
  & 0.62585881E-29_JPRB, 0.52667812E-29_JPRB, 0.43739622E-29_JPRB, 0.31877214E-29_JPRB /)

RGHG6(:, 6, 1) = (/ &
  & 0.62218409E-25_JPRB, 0.13940441E-24_JPRB, 0.16532432E-24_JPRB, 0.19205100E-24_JPRB, 0.21849332E-24_JPRB, 0.27315169E-24_JPRB, &
  & 0.36149112E-24_JPRB, 0.50490288E-24_JPRB, 0.74711379E-24_JPRB, 0.11439357E-23_JPRB, 0.17840225E-23_JPRB, 0.27548620E-23_JPRB, &
  & 0.42765471E-23_JPRB, 0.71526318E-23_JPRB, 0.12361301E-22_JPRB, 0.20347422E-22_JPRB, 0.32635270E-22_JPRB, 0.51275735E-22_JPRB, &
  & 0.78411651E-22_JPRB, 0.11767467E-21_JPRB, 0.17157431E-21_JPRB, 0.24296093E-21_JPRB, 0.33242359E-21_JPRB, 0.43659743E-21_JPRB, &
  & 0.55216305E-21_JPRB, 0.67674471E-21_JPRB, 0.80685067E-21_JPRB, 0.93885323E-21_JPRB, 0.10610716E-20_JPRB, 0.11627191E-20_JPRB, &
  & 0.12226436E-20_JPRB, 0.12248105E-20_JPRB, 0.11597033E-20_JPRB, 0.10339477E-20_JPRB, 0.85825199E-21_JPRB, 0.66721865E-21_JPRB, &
  & 0.49373100E-21_JPRB, 0.34832256E-21_JPRB, 0.23273315E-21_JPRB, 0.14526746E-21_JPRB, 0.84162371E-22_JPRB, 0.46376072E-22_JPRB, &
  & 0.25268838E-22_JPRB, 0.14059645E-22_JPRB, 0.80809365E-23_JPRB, 0.47846000E-23_JPRB, 0.28899205E-23_JPRB, 0.17597290E-23_JPRB, &
  & 0.10672613E-23_JPRB, 0.63830552E-24_JPRB, 0.37407885E-24_JPRB, 0.21446162E-24_JPRB, 0.12056065E-24_JPRB, 0.66944807E-25_JPRB, &
  & 0.37137815E-25_JPRB, 0.20964224E-25_JPRB, 0.12314231E-25_JPRB, 0.77406437E-26_JPRB, 0.53298490E-26_JPRB, 0.40377187E-26_JPRB, &
  & 0.33206006E-26_JPRB, 0.28780063E-26_JPRB, 0.25631293E-26_JPRB, 0.21954843E-26_JPRB /)

RGHG6(:, 7, 1) = (/ &
  & 0.52600980E-22_JPRB, 0.85737303E-22_JPRB, 0.10181193E-21_JPRB, 0.12256629E-21_JPRB, 0.14550658E-21_JPRB, 0.18896397E-21_JPRB, &
  & 0.25513718E-21_JPRB, 0.35909345E-21_JPRB, 0.51989311E-21_JPRB, 0.77184867E-21_JPRB, 0.11456219E-20_JPRB, 0.16729001E-20_JPRB, &
  & 0.24403064E-20_JPRB, 0.38251206E-20_JPRB, 0.61932067E-20_JPRB, 0.95442587E-20_JPRB, 0.14323094E-19_JPRB, 0.21078942E-19_JPRB, &
  & 0.30244793E-19_JPRB, 0.42697170E-19_JPRB, 0.58752797E-19_JPRB, 0.78868065E-19_JPRB, 0.10278611E-18_JPRB, 0.12932710E-18_JPRB, &
  & 0.15746385E-18_JPRB, 0.18670107E-18_JPRB, 0.21638300E-18_JPRB, 0.24581838E-18_JPRB, 0.27300303E-18_JPRB, 0.29555125E-18_JPRB, &
  & 0.30894777E-18_JPRB, 0.30932809E-18_JPRB, 0.29410962E-18_JPRB, 0.26427288E-18_JPRB, 0.22174934E-18_JPRB, 0.17495131E-18_JPRB, &
  & 0.13187623E-18_JPRB, 0.95328359E-19_JPRB, 0.65687278E-19_JPRB, 0.42406555E-19_JPRB, 0.25535465E-19_JPRB, 0.14602623E-19_JPRB, &
  & 0.82732416E-20_JPRB, 0.48001024E-20_JPRB, 0.28859764E-20_JPRB, 0.17921381E-20_JPRB, 0.11368134E-20_JPRB, 0.72707742E-21_JPRB, &
  & 0.46273253E-21_JPRB, 0.28985892E-21_JPRB, 0.17749541E-21_JPRB, 0.10612741E-21_JPRB, 0.62185123E-22_JPRB, 0.36002397E-22_JPRB, &
  & 0.20871354E-22_JPRB, 0.12330095E-22_JPRB, 0.75983138E-23_JPRB, 0.50175612E-23_JPRB, 0.36165794E-23_JPRB, 0.28508421E-23_JPRB, &
  & 0.24110902E-23_JPRB, 0.21407713E-23_JPRB, 0.19465589E-23_JPRB, 0.17453049E-23_JPRB /)

RGHG6(:, 8, 1) = (/ &
  & 0.42806422E-19_JPRB, 0.60306469E-19_JPRB, 0.68590133E-19_JPRB, 0.83386598E-19_JPRB, 0.10030881E-18_JPRB, 0.13170218E-18_JPRB, &
  & 0.17828265E-18_JPRB, 0.24661237E-18_JPRB, 0.34728857E-18_JPRB, 0.49128836E-18_JPRB, 0.69082780E-18_JPRB, 0.94727845E-18_JPRB, &
  & 0.12909797E-17_JPRB, 0.18855276E-17_JPRB, 0.28450399E-17_JPRB, 0.40827972E-17_JPRB, 0.57070987E-17_JPRB, 0.78324351E-17_JPRB, &
  & 0.10506124E-16_JPRB, 0.13910036E-16_JPRB, 0.18016879E-16_JPRB, 0.22864989E-16_JPRB, 0.28319035E-16_JPRB, 0.34039974E-16_JPRB, &
  & 0.39819082E-16_JPRB, 0.45587899E-16_JPRB, 0.51274938E-16_JPRB, 0.56844937E-16_JPRB, 0.61945260E-16_JPRB, 0.66237229E-16_JPRB, &
  & 0.68793382E-16_JPRB, 0.68827515E-16_JPRB, 0.65711148E-16_JPRB, 0.59505818E-16_JPRB, 0.50509739E-16_JPRB, 0.40438048E-16_JPRB, &
  & 0.31117946E-16_JPRB, 0.23094911E-16_JPRB, 0.16430998E-16_JPRB, 0.11031897E-16_JPRB, 0.69077679E-17_JPRB, 0.41103639E-17_JPRB, &
  & 0.24200157E-17_JPRB, 0.14622471E-17_JPRB, 0.91888206E-18_JPRB, 0.59804445E-18_JPRB, 0.39833854E-18_JPRB, 0.26781508E-18_JPRB, &
  & 0.17923693E-18_JPRB, 0.11805740E-18_JPRB, 0.75986356E-19_JPRB, 0.47741908E-19_JPRB, 0.29386444E-19_JPRB, 0.17880611E-19_JPRB, &
  & 0.10885585E-19_JPRB, 0.67599058E-20_JPRB, 0.43777023E-20_JPRB, 0.30350749E-20_JPRB, 0.22876952E-20_JPRB, 0.18717569E-20_JPRB, &
  & 0.16276486E-20_JPRB, 0.14709712E-20_JPRB, 0.13582818E-20_JPRB, 0.12301245E-20_JPRB /)

RGHG6(:, 9, 1) = (/ &
  & 0.31245302E-16_JPRB, 0.41323419E-16_JPRB, 0.45828598E-16_JPRB, 0.55045700E-16_JPRB, 0.65544905E-16_JPRB, 0.85144612E-16_JPRB, &
  & 0.11291148E-15_JPRB, 0.15190545E-15_JPRB, 0.20520645E-15_JPRB, 0.27679967E-15_JPRB, 0.36764332E-15_JPRB, 0.47370926E-15_JPRB, &
  & 0.60294939E-15_JPRB, 0.82025252E-15_JPRB, 0.11527655E-14_JPRB, 0.15395676E-14_JPRB, 0.20027308E-14_JPRB, 0.25618403E-14_JPRB, &
  & 0.32104054E-14_JPRB, 0.39835904E-14_JPRB, 0.48529109E-14_JPRB, 0.58157634E-14_JPRB, 0.68340359E-14_JPRB, 0.78355232E-14_JPRB, &
  & 0.87883556E-14_JPRB, 0.97017714E-14_JPRB, 0.10576949E-13_JPRB, 0.11427640E-13_JPRB, 0.12207543E-13_JPRB, 0.12870432E-13_JPRB, &
  & 0.13257328E-13_JPRB, 0.13229547E-13_JPRB, 0.12664009E-13_JPRB, 0.11558232E-13_JPRB, 0.99267222E-14_JPRB, 0.80882355E-14_JPRB, &
  & 0.63658321E-14_JPRB, 0.48635116E-14_JPRB, 0.35858009E-14_JPRB, 0.25059410E-14_JPRB, 0.16403253E-14_JPRB, 0.10178522E-14_JPRB, &
  & 0.62389895E-15_JPRB, 0.39308353E-15_JPRB, 0.25823133E-15_JPRB, 0.17618418E-15_JPRB, 0.12322979E-15_JPRB, 0.87113712E-16_JPRB, &
  & 0.61364969E-16_JPRB, 0.42577858E-16_JPRB, 0.28883582E-16_JPRB, 0.19127093E-16_JPRB, 0.12404484E-16_JPRB, 0.79361271E-17_JPRB, &
  & 0.50757151E-17_JPRB, 0.33010915E-17_JPRB, 0.22358950E-17_JPRB, 0.16162997E-17_JPRB, 0.12662241E-17_JPRB, 0.10655513E-17_JPRB, &
  & 0.94667605E-18_JPRB, 0.86916065E-18_JPRB, 0.80879999E-18_JPRB, 0.74110363E-18_JPRB /)

RGHG6(:,10, 1) = (/ &
  & 0.19860592E-13_JPRB, 0.25688348E-13_JPRB, 0.27913718E-13_JPRB, 0.33017548E-13_JPRB, 0.38517963E-13_JPRB, 0.48812354E-13_JPRB, &
  & 0.62857895E-13_JPRB, 0.81547101E-13_JPRB, 0.10559988E-12_JPRB, 0.13547215E-12_JPRB, 0.17020016E-12_JPRB, 0.20614710E-12_JPRB, &
  & 0.24519953E-12_JPRB, 0.31079693E-12_JPRB, 0.40684814E-12_JPRB, 0.50557827E-12_JPRB, 0.61192723E-12_JPRB, 0.72924414E-12_JPRB, &
  & 0.85317625E-12_JPRB, 0.99129580E-12_JPRB, 0.11343969E-11_JPRB, 0.12819383E-11_JPRB, 0.14270560E-11_JPRB, 0.15576552E-11_JPRB, &
  & 0.16726374E-11_JPRB, 0.17775002E-11_JPRB, 0.18759180E-11_JPRB, 0.19728264E-11_JPRB, 0.20629214E-11_JPRB, 0.21410970E-11_JPRB, &
  & 0.21832863E-11_JPRB, 0.21692296E-11_JPRB, 0.20798296E-11_JPRB, 0.19123618E-11_JPRB, 0.16650278E-11_JPRB, 0.13828478E-11_JPRB, &
  & 0.11167998E-11_JPRB, 0.88051560E-12_JPRB, 0.67382683E-12_JPRB, 0.49175730E-12_JPRB, 0.33716329E-12_JPRB, 0.21915002E-12_JPRB, &
  & 0.14042680E-12_JPRB, 0.92450014E-13_JPRB, 0.63631521E-13_JPRB, 0.45570576E-13_JPRB, 0.33506143E-13_JPRB, 0.24929355E-13_JPRB, &
  & 0.18499959E-13_JPRB, 0.13534544E-13_JPRB, 0.96841607E-14_JPRB, 0.67631884E-14_JPRB, 0.46170559E-14_JPRB, 0.31030819E-14_JPRB, &
  & 0.20764223E-14_JPRB, 0.14099700E-14_JPRB, 0.99303411E-15_JPRB, 0.74525559E-15_JPRB, 0.59984338E-15_JPRB, 0.51771072E-15_JPRB, &
  & 0.46711188E-15_JPRB, 0.43294358E-15_JPRB, 0.40742841E-15_JPRB, 0.37430254E-15_JPRB /)

RGHG6(:,11, 1) = (/ &
  & 0.18674640E-12_JPRB, 0.21249720E-12_JPRB, 0.18703051E-12_JPRB, 0.20092131E-12_JPRB, 0.20028055E-12_JPRB, 0.21473392E-12_JPRB, &
  & 0.23647385E-12_JPRB, 0.27081728E-12_JPRB, 0.32222177E-12_JPRB, 0.39754292E-12_JPRB, 0.50645680E-12_JPRB, 0.65463455E-12_JPRB, &
  & 0.83537886E-12_JPRB, 0.10323812E-11_JPRB, 0.12687747E-11_JPRB, 0.15651095E-11_JPRB, 0.19035483E-11_JPRB, 0.22771806E-11_JPRB, &
  & 0.26727067E-11_JPRB, 0.30977848E-11_JPRB, 0.35350616E-11_JPRB, 0.39669223E-11_JPRB, 0.43795614E-11_JPRB, 0.47392936E-11_JPRB, &
  & 0.50261917E-11_JPRB, 0.52646650E-11_JPRB, 0.54391504E-11_JPRB, 0.55623830E-11_JPRB, 0.56092778E-11_JPRB, 0.55751341E-11_JPRB, &
  & 0.54221606E-11_JPRB, 0.51163301E-11_JPRB, 0.46171678E-11_JPRB, 0.39999618E-11_JPRB, 0.33356705E-11_JPRB, 0.26769869E-11_JPRB, &
  & 0.20972898E-11_JPRB, 0.16227464E-11_JPRB, 0.12402151E-11_JPRB, 0.93207386E-12_JPRB, 0.68468451E-12_JPRB, 0.49148289E-12_JPRB, &
  & 0.34657458E-12_JPRB, 0.24601583E-12_JPRB, 0.17999465E-12_JPRB, 0.13635794E-12_JPRB, 0.10591498E-12_JPRB, 0.83281560E-13_JPRB, &
  & 0.65402802E-13_JPRB, 0.50711917E-13_JPRB, 0.38519935E-13_JPRB, 0.28558519E-13_JPRB, 0.20670054E-13_JPRB, 0.14675168E-13_JPRB, &
  & 0.10344912E-13_JPRB, 0.73660738E-14_JPRB, 0.54310431E-14_JPRB, 0.42211396E-14_JPRB, 0.35174293E-14_JPRB, 0.30843654E-14_JPRB, &
  & 0.28154257E-14_JPRB, 0.26282534E-14_JPRB, 0.24606777E-14_JPRB, 0.22616121E-14_JPRB /)

RGHG6(:,12, 1) = (/ &
  & 0.14652572E-11_JPRB, 0.12434253E-11_JPRB, 0.10460816E-11_JPRB, 0.99129819E-12_JPRB, 0.92632889E-12_JPRB, 0.89573168E-12_JPRB, &
  & 0.90467672E-12_JPRB, 0.95957953E-12_JPRB, 0.10667560E-11_JPRB, 0.12337826E-11_JPRB, 0.14733488E-11_JPRB, 0.17994416E-11_JPRB, &
  & 0.22343963E-11_JPRB, 0.27850276E-11_JPRB, 0.34193236E-11_JPRB, 0.41545196E-11_JPRB, 0.50044361E-11_JPRB, 0.59411820E-11_JPRB, &
  & 0.69314207E-11_JPRB, 0.79817247E-11_JPRB, 0.90495250E-11_JPRB, 0.10080157E-10_JPRB, 0.11033333E-10_JPRB, 0.11844784E-10_JPRB, &
  & 0.12440857E-10_JPRB, 0.12863429E-10_JPRB, 0.13043337E-10_JPRB, 0.12989026E-10_JPRB, 0.12651364E-10_JPRB, 0.12042505E-10_JPRB, &
  & 0.11139781E-10_JPRB, 0.99882056E-11_JPRB, 0.86121154E-11_JPRB, 0.71128737E-11_JPRB, 0.56449294E-11_JPRB, 0.43631392E-11_JPRB, &
  & 0.33417876E-11_JPRB, 0.25692068E-11_JPRB, 0.19874042E-11_JPRB, 0.15343200E-11_JPRB, 0.11722166E-11_JPRB, 0.88586105E-12_JPRB, &
  & 0.66678753E-12_JPRB, 0.50723591E-12_JPRB, 0.39504841E-12_JPRB, 0.31501993E-12_JPRB, 0.25527646E-12_JPRB, 0.20830984E-12_JPRB, &
  & 0.16923401E-12_JPRB, 0.13572395E-12_JPRB, 0.10677795E-12_JPRB, 0.82227878E-13_JPRB, 0.61949272E-13_JPRB, 0.45945269E-13_JPRB, &
  & 0.33902463E-13_JPRB, 0.25352079E-13_JPRB, 0.19579465E-13_JPRB, 0.15959656E-13_JPRB, 0.13694053E-13_JPRB, 0.12351959E-13_JPRB, &
  & 0.11459715E-13_JPRB, 0.10791811E-13_JPRB, 0.10223873E-13_JPRB, 0.93361954E-14_JPRB /)

RGHG6(:,13, 1) = (/ &
  & 0.50786749E-11_JPRB, 0.42007300E-11_JPRB, 0.36961541E-11_JPRB, 0.33387921E-11_JPRB, 0.31075533E-11_JPRB, 0.29876607E-11_JPRB, &
  & 0.29842997E-11_JPRB, 0.30949548E-11_JPRB, 0.33194857E-11_JPRB, 0.36656381E-11_JPRB, 0.41542065E-11_JPRB, 0.48040968E-11_JPRB, &
  & 0.56464724E-11_JPRB, 0.67215287E-11_JPRB, 0.80366651E-11_JPRB, 0.95776859E-11_JPRB, 0.11336129E-10_JPRB, 0.13269632E-10_JPRB, &
  & 0.15299218E-10_JPRB, 0.17421805E-10_JPRB, 0.19544772E-10_JPRB, 0.21565340E-10_JPRB, 0.23378797E-10_JPRB, 0.24865748E-10_JPRB, &
  & 0.25862807E-10_JPRB, 0.26391844E-10_JPRB, 0.26309446E-10_JPRB, 0.25596993E-10_JPRB, 0.24214504E-10_JPRB, 0.22264574E-10_JPRB, &
  & 0.19832434E-10_JPRB, 0.17052148E-10_JPRB, 0.14119207E-10_JPRB, 0.11312028E-10_JPRB, 0.88324487E-11_JPRB, 0.68282211E-11_JPRB, &
  & 0.53325773E-11_JPRB, 0.42479965E-11_JPRB, 0.34587233E-11_JPRB, 0.28640799E-11_JPRB, 0.23964955E-11_JPRB, 0.20214162E-11_JPRB, &
  & 0.17152211E-11_JPRB, 0.14621802E-11_JPRB, 0.12491802E-11_JPRB, 0.10677136E-11_JPRB, 0.90843988E-12_JPRB, 0.76500389E-12_JPRB, &
  & 0.63565239E-12_JPRB, 0.51745582E-12_JPRB, 0.41169721E-12_JPRB, 0.32037746E-12_JPRB, 0.24430111E-12_JPRB, 0.18403671E-12_JPRB, &
  & 0.13861774E-12_JPRB, 0.10605003E-12_JPRB, 0.83896174E-13_JPRB, 0.69383362E-13_JPRB, 0.60507155E-13_JPRB, 0.54770099E-13_JPRB, &
  & 0.50970235E-13_JPRB, 0.48048107E-13_JPRB, 0.45144152E-13_JPRB, 0.40979291E-13_JPRB /)

RGHG6(:,14, 1) = (/ &
  & 0.11919936E-10_JPRB, 0.99651450E-11_JPRB, 0.90850036E-11_JPRB, 0.85459105E-11_JPRB, 0.81952041E-11_JPRB, 0.80026454E-11_JPRB, &
  & 0.79816804E-11_JPRB, 0.81374985E-11_JPRB, 0.84850989E-11_JPRB, 0.90572159E-11_JPRB, 0.99112749E-11_JPRB, 0.11084847E-10_JPRB, &
  & 0.12620008E-10_JPRB, 0.14544182E-10_JPRB, 0.16861592E-10_JPRB, 0.19585340E-10_JPRB, 0.22679086E-10_JPRB, 0.26043988E-10_JPRB, &
  & 0.29538681E-10_JPRB, 0.33133007E-10_JPRB, 0.36654846E-10_JPRB, 0.39920796E-10_JPRB, 0.42744704E-10_JPRB, 0.44903171E-10_JPRB, &
  & 0.46143464E-10_JPRB, 0.46422449E-10_JPRB, 0.45536210E-10_JPRB, 0.43459604E-10_JPRB, 0.40224608E-10_JPRB, 0.36067510E-10_JPRB, &
  & 0.31319222E-10_JPRB, 0.26384684E-10_JPRB, 0.21571231E-10_JPRB, 0.17325431E-10_JPRB, 0.13851825E-10_JPRB, 0.11217322E-10_JPRB, &
  & 0.93773244E-11_JPRB, 0.81384934E-11_JPRB, 0.72886801E-11_JPRB, 0.66785249E-11_JPRB, 0.62063987E-11_JPRB, 0.58066724E-11_JPRB, &
  & 0.54301025E-11_JPRB, 0.50415141E-11_JPRB, 0.46207487E-11_JPRB, 0.41707302E-11_JPRB, 0.37042253E-11_JPRB, 0.32200301E-11_JPRB, &
  & 0.27462208E-11_JPRB, 0.22830295E-11_JPRB, 0.18497330E-11_JPRB, 0.14652012E-11_JPRB, 0.11367864E-11_JPRB, 0.87195670E-12_JPRB, &
  & 0.66822622E-12_JPRB, 0.51858984E-12_JPRB, 0.41310995E-12_JPRB, 0.34209696E-12_JPRB, 0.29542208E-12_JPRB, 0.26555543E-12_JPRB, &
  & 0.24440042E-12_JPRB, 0.22788656E-12_JPRB, 0.21183728E-12_JPRB, 0.18676778E-12_JPRB /)

RGHG6(:,15, 1) = (/ &
  & 0.21966099E-10_JPRB, 0.19728046E-10_JPRB, 0.18751996E-10_JPRB, 0.18076259E-10_JPRB, 0.17604073E-10_JPRB, 0.17348617E-10_JPRB, &
  & 0.17365137E-10_JPRB, 0.17682937E-10_JPRB, 0.18330412E-10_JPRB, 0.19347383E-10_JPRB, 0.20808189E-10_JPRB, 0.22757523E-10_JPRB, &
  & 0.25254618E-10_JPRB, 0.28336541E-10_JPRB, 0.31976789E-10_JPRB, 0.36182130E-10_JPRB, 0.40900113E-10_JPRB, 0.45968649E-10_JPRB, &
  & 0.51156513E-10_JPRB, 0.56376733E-10_JPRB, 0.61342320E-10_JPRB, 0.65763846E-10_JPRB, 0.69360358E-10_JPRB, 0.71795597E-10_JPRB, &
  & 0.72727768E-10_JPRB, 0.72076810E-10_JPRB, 0.69626520E-10_JPRB, 0.65396563E-10_JPRB, 0.59600290E-10_JPRB, 0.52761347E-10_JPRB, &
  & 0.45368823E-10_JPRB, 0.38132438E-10_JPRB, 0.31581689E-10_JPRB, 0.26183954E-10_JPRB, 0.22158303E-10_JPRB, 0.19533639E-10_JPRB, &
  & 0.18036532E-10_JPRB, 0.17298791E-10_JPRB, 0.16971027E-10_JPRB, 0.16812648E-10_JPRB, 0.16670648E-10_JPRB, 0.16426412E-10_JPRB, &
  & 0.16004880E-10_JPRB, 0.15374025E-10_JPRB, 0.14524416E-10_JPRB, 0.13488357E-10_JPRB, 0.12302370E-10_JPRB, 0.10994353E-10_JPRB, &
  & 0.96222327E-11_JPRB, 0.82161595E-11_JPRB, 0.68436047E-11_JPRB, 0.55802455E-11_JPRB, 0.44606489E-11_JPRB, 0.35271504E-11_JPRB, &
  & 0.27809248E-11_JPRB, 0.22099403E-11_JPRB, 0.17879550E-11_JPRB, 0.14879668E-11_JPRB, 0.12813997E-11_JPRB, 0.11391495E-11_JPRB, &
  & 0.10395762E-11_JPRB, 0.95686805E-12_JPRB, 0.87968424E-12_JPRB, 0.75651968E-12_JPRB /)

RGHG6(:,16, 1) = (/ &
  & 0.35318151E-10_JPRB, 0.33192980E-10_JPRB, 0.32238202E-10_JPRB, 0.31723513E-10_JPRB, 0.31542498E-10_JPRB, 0.31701430E-10_JPRB, &
  & 0.32254966E-10_JPRB, 0.33226994E-10_JPRB, 0.34632037E-10_JPRB, 0.36511703E-10_JPRB, 0.38953521E-10_JPRB, 0.42007141E-10_JPRB, &
  & 0.45748228E-10_JPRB, 0.50223489E-10_JPRB, 0.55393287E-10_JPRB, 0.61237036E-10_JPRB, 0.67655111E-10_JPRB, 0.74416237E-10_JPRB, &
  & 0.81180791E-10_JPRB, 0.87784842E-10_JPRB, 0.93809384E-10_JPRB, 0.98853745E-10_JPRB, 0.10252613E-09_JPRB, 0.10442867E-09_JPRB, &
  & 0.10418080E-09_JPRB, 0.10173389E-09_JPRB, 0.96949324E-10_JPRB, 0.90038227E-10_JPRB, 0.81408304E-10_JPRB, 0.71779999E-10_JPRB, &
  & 0.62150826E-10_JPRB, 0.53206925E-10_JPRB, 0.45631179E-10_JPRB, 0.40013961E-10_JPRB, 0.36545593E-10_JPRB, 0.35038646E-10_JPRB, &
  & 0.35031943E-10_JPRB, 0.35856665E-10_JPRB, 0.36935788E-10_JPRB, 0.37863788E-10_JPRB, 0.38347190E-10_JPRB, 0.38328184E-10_JPRB, &
  & 0.37762772E-10_JPRB, 0.36664827E-10_JPRB, 0.35080546E-10_JPRB, 0.33068864E-10_JPRB, 0.30695092E-10_JPRB, 0.28018411E-10_JPRB, &
  & 0.25100587E-10_JPRB, 0.22022079E-10_JPRB, 0.18919628E-10_JPRB, 0.15943720E-10_JPRB, 0.13215065E-10_JPRB, 0.10832646E-10_JPRB, &
  & 0.88473447E-11_JPRB, 0.72558123E-11_JPRB, 0.60230306E-11_JPRB, 0.50903361E-11_JPRB, 0.44095864E-11_JPRB, 0.39209352E-11_JPRB, &
  & 0.35472888E-11_JPRB, 0.32560961E-11_JPRB, 0.29497771E-11_JPRB, 0.25193172E-11_JPRB /)

RGHG6(:,17, 1) = (/ &
  & 0.51157082E-10_JPRB, 0.50162336E-10_JPRB, 0.49987361E-10_JPRB, 0.50192319E-10_JPRB, 0.50775044E-10_JPRB, 0.51790509E-10_JPRB, &
  & 0.53325420E-10_JPRB, 0.55398151E-10_JPRB, 0.58025983E-10_JPRB, 0.61234830E-10_JPRB, 0.65107877E-10_JPRB, 0.69666994E-10_JPRB, &
  & 0.74970363E-10_JPRB, 0.81052477E-10_JPRB, 0.87840180E-10_JPRB, 0.95285668E-10_JPRB, 0.10323675E-09_JPRB, 0.11136539E-09_JPRB, &
  & 0.11925239E-09_JPRB, 0.12661491E-09_JPRB, 0.13291063E-09_JPRB, 0.13769041E-09_JPRB, 0.14046717E-09_JPRB, 0.14084710E-09_JPRB, &
  & 0.13851278E-09_JPRB, 0.13354587E-09_JPRB, 0.12605082E-09_JPRB, 0.11643397E-09_JPRB, 0.10546972E-09_JPRB, 0.94094357E-10_JPRB, &
  & 0.83281396E-10_JPRB, 0.73832856E-10_JPRB, 0.66590261E-10_JPRB, 0.62056603E-10_JPRB, 0.60303672E-10_JPRB, 0.61059241E-10_JPRB, &
  & 0.63581890E-10_JPRB, 0.66853689E-10_JPRB, 0.69960565E-10_JPRB, 0.72233969E-10_JPRB, 0.73469848E-10_JPRB, 0.73570691E-10_JPRB, &
  & 0.72508839E-10_JPRB, 0.70466077E-10_JPRB, 0.67668648E-10_JPRB, 0.64245442E-10_JPRB, 0.60271420E-10_JPRB, 0.55807484E-10_JPRB, &
  & 0.50900693E-10_JPRB, 0.45666450E-10_JPRB, 0.40286864E-10_JPRB, 0.34997255E-10_JPRB, 0.29991967E-10_JPRB, 0.25466873E-10_JPRB, &
  & 0.21540492E-10_JPRB, 0.18263967E-10_JPRB, 0.15605343E-10_JPRB, 0.13496051E-10_JPRB, 0.11854436E-10_JPRB, 0.10587821E-10_JPRB, &
  & 0.96229162E-11_JPRB, 0.87713612E-11_JPRB, 0.79804930E-11_JPRB, 0.66870086E-11_JPRB /)

RGHG6(:,18, 1) = (/ &
  & 0.69689421E-10_JPRB, 0.70265224E-10_JPRB, 0.71078150E-10_JPRB, 0.72254036E-10_JPRB, 0.73907033E-10_JPRB, 0.76152501E-10_JPRB, &
  & 0.79073574E-10_JPRB, 0.82702525E-10_JPRB, 0.87010343E-10_JPRB, 0.91998333E-10_JPRB, 0.97710798E-10_JPRB, 0.10411584E-09_JPRB, &
  & 0.11122056E-09_JPRB, 0.11902518E-09_JPRB, 0.12739712E-09_JPRB, 0.13624069E-09_JPRB, 0.14535963E-09_JPRB, 0.15431978E-09_JPRB, &
  & 0.16265642E-09_JPRB, 0.17000890E-09_JPRB, 0.17572235E-09_JPRB, 0.17932912E-09_JPRB, 0.18035799E-09_JPRB, 0.17847872E-09_JPRB, &
  & 0.17354167E-09_JPRB, 0.16589657E-09_JPRB, 0.15593303E-09_JPRB, 0.14445786E-09_JPRB, 0.13227942E-09_JPRB, 0.12071057E-09_JPRB, &
  & 0.11042182E-09_JPRB, 0.10245187E-09_JPRB, 0.97197979E-10_JPRB, 0.95093280E-10_JPRB, 0.96045977E-10_JPRB, 0.99634162E-10_JPRB, &
  & 0.10490278E-09_JPRB, 0.11055197E-09_JPRB, 0.11536602E-09_JPRB, 0.11867102E-09_JPRB, 0.12003520E-09_JPRB, 0.11951351E-09_JPRB, &
  & 0.11744060E-09_JPRB, 0.11407374E-09_JPRB, 0.10971837E-09_JPRB, 0.10458982E-09_JPRB, 0.98802744E-10_JPRB, 0.92385821E-10_JPRB, &
  & 0.85388419E-10_JPRB, 0.77920018E-10_JPRB, 0.70203759E-10_JPRB, 0.62504481E-10_JPRB, 0.55089159E-10_JPRB, 0.48201519E-10_JPRB, &
  & 0.42059953E-10_JPRB, 0.36773348E-10_JPRB, 0.32326766E-10_JPRB, 0.28632596E-10_JPRB, 0.25601084E-10_JPRB, 0.23155941E-10_JPRB, &
  & 0.21115960E-10_JPRB, 0.19378046E-10_JPRB, 0.17564136E-10_JPRB, 0.14821935E-10_JPRB /)

RGHG6(:,19, 1) = (/ &
  & 0.89058483E-10_JPRB, 0.91312582E-10_JPRB, 0.93286726E-10_JPRB, 0.95648517E-10_JPRB, 0.98644024E-10_JPRB, 0.10242107E-09_JPRB, &
  & 0.10707154E-09_JPRB, 0.11256189E-09_JPRB, 0.11883178E-09_JPRB, 0.12582328E-09_JPRB, 0.13352358E-09_JPRB, 0.14185650E-09_JPRB, &
  & 0.15075464E-09_JPRB, 0.16015569E-09_JPRB, 0.16988741E-09_JPRB, 0.17977204E-09_JPRB, 0.18959630E-09_JPRB, 0.19886452E-09_JPRB, &
  & 0.20702921E-09_JPRB, 0.21373465E-09_JPRB, 0.21831567E-09_JPRB, 0.22028046E-09_JPRB, 0.21925012E-09_JPRB, 0.21501502E-09_JPRB, &
  & 0.20768666E-09_JPRB, 0.19789771E-09_JPRB, 0.18642622E-09_JPRB, 0.17432461E-09_JPRB, 0.16294352E-09_JPRB, 0.15293550E-09_JPRB, &
  & 0.14547363E-09_JPRB, 0.14071730E-09_JPRB, 0.13891653E-09_JPRB, 0.14012495E-09_JPRB, 0.14407102E-09_JPRB, 0.15011276E-09_JPRB, &
  & 0.15714356E-09_JPRB, 0.16382554E-09_JPRB, 0.16892025E-09_JPRB, 0.17182895E-09_JPRB, 0.17244350E-09_JPRB, 0.17086692E-09_JPRB, &
  & 0.16735427E-09_JPRB, 0.16237274E-09_JPRB, 0.15635562E-09_JPRB, 0.14949753E-09_JPRB, 0.14193813E-09_JPRB, 0.13370188E-09_JPRB, &
  & 0.12482883E-09_JPRB, 0.11544644E-09_JPRB, 0.10577391E-09_JPRB, 0.96089192E-10_JPRB, 0.86659131E-10_JPRB, 0.77775911E-10_JPRB, &
  & 0.69702882E-10_JPRB, 0.62587796E-10_JPRB, 0.56429198E-10_JPRB, 0.51134992E-10_JPRB, 0.46600585E-10_JPRB, 0.42711886E-10_JPRB, &
  & 0.39367311E-10_JPRB, 0.36334095E-10_JPRB, 0.33102594E-10_JPRB, 0.28193689E-10_JPRB /)

RGHG6(:,20, 1) = (/ &
  & 0.10970078E-09_JPRB, 0.11385168E-09_JPRB, 0.11695690E-09_JPRB, 0.12037311E-09_JPRB, 0.12449625E-09_JPRB, 0.12954700E-09_JPRB, &
  & 0.13562711E-09_JPRB, 0.14273756E-09_JPRB, 0.15074843E-09_JPRB, 0.15951787E-09_JPRB, 0.16898395E-09_JPRB, 0.17896054E-09_JPRB, &
  & 0.18935677E-09_JPRB, 0.20001419E-09_JPRB, 0.21073751E-09_JPRB, 0.22128448E-09_JPRB, 0.23138114E-09_JPRB, 0.24059205E-09_JPRB, &
  & 0.24830407E-09_JPRB, 0.25414584E-09_JPRB, 0.25751853E-09_JPRB, 0.25796437E-09_JPRB, 0.25520913E-09_JPRB, 0.24921953E-09_JPRB, &
  & 0.24034688E-09_JPRB, 0.22956553E-09_JPRB, 0.21802220E-09_JPRB, 0.20705249E-09_JPRB, 0.19766996E-09_JPRB, 0.19119038E-09_JPRB, &
  & 0.18770585E-09_JPRB, 0.18728401E-09_JPRB, 0.18956720E-09_JPRB, 0.19415777E-09_JPRB, 0.20055282E-09_JPRB, 0.20794727E-09_JPRB, &
  & 0.21528203E-09_JPRB, 0.22155427E-09_JPRB, 0.22579399E-09_JPRB, 0.22733140E-09_JPRB, 0.22616074E-09_JPRB, 0.22270900E-09_JPRB, &
  & 0.21750408E-09_JPRB, 0.21091767E-09_JPRB, 0.20328964E-09_JPRB, 0.19483710E-09_JPRB, 0.18571958E-09_JPRB, 0.17597032E-09_JPRB, &
  & 0.16565872E-09_JPRB, 0.15491379E-09_JPRB, 0.14392877E-09_JPRB, 0.13295932E-09_JPRB, 0.12225682E-09_JPRB, 0.11210317E-09_JPRB, &
  & 0.10276433E-09_JPRB, 0.94384028E-10_JPRB, 0.86970306E-10_JPRB, 0.80395524E-10_JPRB, 0.74555188E-10_JPRB, 0.69347229E-10_JPRB, &
  & 0.64660638E-10_JPRB, 0.60101861E-10_JPRB, 0.55473324E-10_JPRB, 0.47353375E-10_JPRB /)

RGHG6(:,21, 1) = (/ &
  & 0.12847570E-09_JPRB, 0.13476124E-09_JPRB, 0.13918110E-09_JPRB, 0.14378553E-09_JPRB, 0.14912563E-09_JPRB, 0.15543994E-09_JPRB, &
  & 0.16282545E-09_JPRB, 0.17124013E-09_JPRB, 0.18060267E-09_JPRB, 0.19075828E-09_JPRB, 0.20153487E-09_JPRB, 0.21273724E-09_JPRB, &
  & 0.22418607E-09_JPRB, 0.23570640E-09_JPRB, 0.24704849E-09_JPRB, 0.25795677E-09_JPRB, 0.26812036E-09_JPRB, 0.27712066E-09_JPRB, &
  & 0.28441435E-09_JPRB, 0.28958522E-09_JPRB, 0.29211625E-09_JPRB, 0.29163030E-09_JPRB, 0.28796471E-09_JPRB, 0.28125327E-09_JPRB, &
  & 0.27210989E-09_JPRB, 0.26169378E-09_JPRB, 0.25136229E-09_JPRB, 0.24244540E-09_JPRB, 0.23644844E-09_JPRB, 0.23370947E-09_JPRB, &
  & 0.23444832E-09_JPRB, 0.23806268E-09_JPRB, 0.24367436E-09_JPRB, 0.25070182E-09_JPRB, 0.25829830E-09_JPRB, 0.26570557E-09_JPRB, &
  & 0.27221242E-09_JPRB, 0.27694264E-09_JPRB, 0.27919639E-09_JPRB, 0.27878638E-09_JPRB, 0.27590352E-09_JPRB, 0.27092115E-09_JPRB, &
  & 0.26424310E-09_JPRB, 0.25623664E-09_JPRB, 0.24729035E-09_JPRB, 0.23755828E-09_JPRB, 0.22730964E-09_JPRB, 0.21655118E-09_JPRB, &
  & 0.20539558E-09_JPRB, 0.19394336E-09_JPRB, 0.18238111E-09_JPRB, 0.17092125E-09_JPRB, 0.15977447E-09_JPRB, 0.14919378E-09_JPRB, &
  & 0.13935694E-09_JPRB, 0.13039786E-09_JPRB, 0.12228391E-09_JPRB, 0.11491789E-09_JPRB, 0.10816455E-09_JPRB, 0.10191098E-09_JPRB, &
  & 0.95969843E-10_JPRB, 0.90304597E-10_JPRB, 0.83507916E-10_JPRB, 0.73157001E-10_JPRB /)

RGHG6(:,22, 1) = (/ &
  & 0.14935890E-09_JPRB, 0.15588054E-09_JPRB, 0.16069031E-09_JPRB, 0.16586627E-09_JPRB, 0.17193783E-09_JPRB, 0.17915154E-09_JPRB, &
  & 0.18752913E-09_JPRB, 0.19696431E-09_JPRB, 0.20730948E-09_JPRB, 0.21838702E-09_JPRB, 0.23006833E-09_JPRB, 0.24204691E-09_JPRB, &
  & 0.25415159E-09_JPRB, 0.26617256E-09_JPRB, 0.27787933E-09_JPRB, 0.28900829E-09_JPRB, 0.29919953E-09_JPRB, 0.30805924E-09_JPRB, &
  & 0.31513911E-09_JPRB, 0.32007993E-09_JPRB, 0.32242120E-09_JPRB, 0.32182856E-09_JPRB, 0.31827896E-09_JPRB, 0.31206243E-09_JPRB, &
  & 0.30384620E-09_JPRB, 0.29502775E-09_JPRB, 0.28680505E-09_JPRB, 0.28072589E-09_JPRB, 0.27765001E-09_JPRB, 0.27824545E-09_JPRB, &
  & 0.28204872E-09_JPRB, 0.28813305E-09_JPRB, 0.29557462E-09_JPRB, 0.30350486E-09_JPRB, 0.31110278E-09_JPRB, 0.31771374E-09_JPRB, &
  & 0.32274949E-09_JPRB, 0.32560563E-09_JPRB, 0.32600178E-09_JPRB, 0.32382297E-09_JPRB, 0.31936667E-09_JPRB, 0.31306099E-09_JPRB, &
  & 0.30532715E-09_JPRB, 0.29642117E-09_JPRB, 0.28664163E-09_JPRB, 0.27618513E-09_JPRB, 0.26529304E-09_JPRB, 0.25409627E-09_JPRB, &
  & 0.24267169E-09_JPRB, 0.23115268E-09_JPRB, 0.21969235E-09_JPRB, 0.20846483E-09_JPRB, 0.19762933E-09_JPRB, 0.18730521E-09_JPRB, &
  & 0.17763008E-09_JPRB, 0.16865914E-09_JPRB, 0.16037728E-09_JPRB, 0.15264322E-09_JPRB, 0.14535020E-09_JPRB, 0.13837320E-09_JPRB, &
  & 0.13162943E-09_JPRB, 0.12456675E-09_JPRB, 0.11704133E-09_JPRB, 0.10311837E-09_JPRB /)

RGHG6(:,23, 1) = (/ &
  & 0.16797849E-09_JPRB, 0.17579427E-09_JPRB, 0.18111286E-09_JPRB, 0.18666600E-09_JPRB, 0.19313939E-09_JPRB, 0.20079198E-09_JPRB, &
  & 0.20971291E-09_JPRB, 0.21976146E-09_JPRB, 0.23070301E-09_JPRB, 0.24235414E-09_JPRB, 0.25450983E-09_JPRB, 0.26692767E-09_JPRB, &
  & 0.27937694E-09_JPRB, 0.29163116E-09_JPRB, 0.30345607E-09_JPRB, 0.31465930E-09_JPRB, 0.32495828E-09_JPRB, 0.33396827E-09_JPRB, &
  & 0.34125033E-09_JPRB, 0.34647119E-09_JPRB, 0.34927430E-09_JPRB, 0.34947756E-09_JPRB, 0.34708483E-09_JPRB, 0.34240644E-09_JPRB, &
  & 0.33630698E-09_JPRB, 0.32981765E-09_JPRB, 0.32414918E-09_JPRB, 0.32050756E-09_JPRB, 0.31982189E-09_JPRB, 0.32226097E-09_JPRB, &
  & 0.32731387E-09_JPRB, 0.33407060E-09_JPRB, 0.34163444E-09_JPRB, 0.34909883E-09_JPRB, 0.35571956E-09_JPRB, 0.36094397E-09_JPRB, &
  & 0.36438205E-09_JPRB, 0.36553985E-09_JPRB, 0.36439246E-09_JPRB, 0.36093378E-09_JPRB, 0.35553199E-09_JPRB, 0.34855144E-09_JPRB, &
  & 0.34028216E-09_JPRB, 0.33098427E-09_JPRB, 0.32087843E-09_JPRB, 0.31017919E-09_JPRB, 0.29918748E-09_JPRB, 0.28805486E-09_JPRB, &
  & 0.27687413E-09_JPRB, 0.26580441E-09_JPRB, 0.25497063E-09_JPRB, 0.24449656E-09_JPRB, 0.23443303E-09_JPRB, 0.22484220E-09_JPRB, &
  & 0.21575648E-09_JPRB, 0.20720121E-09_JPRB, 0.19909212E-09_JPRB, 0.19134194E-09_JPRB, 0.18381781E-09_JPRB, 0.17639992E-09_JPRB, &
  & 0.16893353E-09_JPRB, 0.16134798E-09_JPRB, 0.15209987E-09_JPRB, 0.13673616E-09_JPRB /)

RGHG6(:,24, 1) = (/ &
  & 0.18647527E-09_JPRB, 0.19455679E-09_JPRB, 0.20018780E-09_JPRB, 0.20603039E-09_JPRB, 0.21275189E-09_JPRB, 0.22064842E-09_JPRB, &
  & 0.22976261E-09_JPRB, 0.24003111E-09_JPRB, 0.25124153E-09_JPRB, 0.26310237E-09_JPRB, 0.27545499E-09_JPRB, 0.28800223E-09_JPRB, &
  & 0.30055677E-09_JPRB, 0.31292308E-09_JPRB, 0.32488576E-09_JPRB, 0.33618155E-09_JPRB, 0.34655881E-09_JPRB, 0.35573899E-09_JPRB, &
  & 0.36341433E-09_JPRB, 0.36934752E-09_JPRB, 0.37325235E-09_JPRB, 0.37493172E-09_JPRB, 0.37441150E-09_JPRB, 0.37214409E-09_JPRB, &
  & 0.36865699E-09_JPRB, 0.36485373E-09_JPRB, 0.36166314E-09_JPRB, 0.35999065E-09_JPRB, 0.36055547E-09_JPRB, 0.36340425E-09_JPRB, &
  & 0.36816949E-09_JPRB, 0.37420134E-09_JPRB, 0.38056028E-09_JPRB, 0.38661116E-09_JPRB, 0.39167491E-09_JPRB, 0.39534473E-09_JPRB, &
  & 0.39724551E-09_JPRB, 0.39706094E-09_JPRB, 0.39484274E-09_JPRB, 0.39068873E-09_JPRB, 0.38484471E-09_JPRB, 0.37767481E-09_JPRB, &
  & 0.36936831E-09_JPRB, 0.36012202E-09_JPRB, 0.35013528E-09_JPRB, 0.33963760E-09_JPRB, 0.32896572E-09_JPRB, 0.31830200E-09_JPRB, &
  & 0.30775826E-09_JPRB, 0.29749198E-09_JPRB, 0.28757846E-09_JPRB, 0.27809927E-09_JPRB, 0.26904748E-09_JPRB, 0.26041114E-09_JPRB, &
  & 0.25216632E-09_JPRB, 0.24423907E-09_JPRB, 0.23657354E-09_JPRB, 0.22901424E-09_JPRB, 0.22146825E-09_JPRB, 0.21381932E-09_JPRB, &
  & 0.20597582E-09_JPRB, 0.19760560E-09_JPRB, 0.18796743E-09_JPRB, 0.17063427E-09_JPRB /)

RGHG6(:,25, 1) = (/ &
  & 0.20407592E-09_JPRB, 0.21243879E-09_JPRB, 0.21820976E-09_JPRB, 0.22417018E-09_JPRB, 0.23100802E-09_JPRB, 0.23897712E-09_JPRB, &
  & 0.24812616E-09_JPRB, 0.25835223E-09_JPRB, 0.26949945E-09_JPRB, 0.28131691E-09_JPRB, 0.29356026E-09_JPRB, 0.30599739E-09_JPRB, &
  & 0.31839781E-09_JPRB, 0.33056757E-09_JPRB, 0.34235820E-09_JPRB, 0.35363534E-09_JPRB, 0.36419776E-09_JPRB, 0.37381062E-09_JPRB, &
  & 0.38220216E-09_JPRB, 0.38912995E-09_JPRB, 0.39435755E-09_JPRB, 0.39779491E-09_JPRB, 0.39953751E-09_JPRB, 0.39983866E-09_JPRB, &
  & 0.39902592E-09_JPRB, 0.39780271E-09_JPRB, 0.39671325E-09_JPRB, 0.39637385E-09_JPRB, 0.39738871E-09_JPRB, 0.39977119E-09_JPRB, &
  & 0.40343906E-09_JPRB, 0.40783743E-09_JPRB, 0.41244910E-09_JPRB, 0.41670417E-09_JPRB, 0.42007980E-09_JPRB, 0.42224393E-09_JPRB, &
  & 0.42282311E-09_JPRB, 0.42165815E-09_JPRB, 0.41877624E-09_JPRB, 0.41432729E-09_JPRB, 0.40849549E-09_JPRB, 0.40150999E-09_JPRB, &
  & 0.39354348E-09_JPRB, 0.38469794E-09_JPRB, 0.37515438E-09_JPRB, 0.36518122E-09_JPRB, 0.35510125E-09_JPRB, 0.34510741E-09_JPRB, &
  & 0.33536646E-09_JPRB, 0.32600933E-09_JPRB, 0.31710146E-09_JPRB, 0.30866543E-09_JPRB, 0.30067374E-09_JPRB, 0.29305164E-09_JPRB, &
  & 0.28570005E-09_JPRB, 0.27854660E-09_JPRB, 0.27143640E-09_JPRB, 0.26427327E-09_JPRB, 0.25690208E-09_JPRB, 0.24921704E-09_JPRB, &
  & 0.24117214E-09_JPRB, 0.23252279E-09_JPRB, 0.22238267E-09_JPRB, 0.20385842E-09_JPRB /)

RGHG6(:,26, 1) = (/ &
  & 0.22133030E-09_JPRB, 0.22978293E-09_JPRB, 0.23558727E-09_JPRB, 0.24154898E-09_JPRB, 0.24835117E-09_JPRB, 0.25625610E-09_JPRB, &
  & 0.26527922E-09_JPRB, 0.27530034E-09_JPRB, 0.28616490E-09_JPRB, 0.29768812E-09_JPRB, 0.30963665E-09_JPRB, 0.32178726E-09_JPRB, &
  & 0.33395306E-09_JPRB, 0.34599348E-09_JPRB, 0.35770659E-09_JPRB, 0.36895473E-09_JPRB, 0.37958944E-09_JPRB, 0.38941939E-09_JPRB, &
  & 0.39824954E-09_JPRB, 0.40595069E-09_JPRB, 0.41239731E-09_JPRB, 0.41750584E-09_JPRB, 0.42128970E-09_JPRB, 0.42386011E-09_JPRB, &
  & 0.42539616E-09_JPRB, 0.42626408E-09_JPRB, 0.42683773E-09_JPRB, 0.42753071E-09_JPRB, 0.42859177E-09_JPRB, 0.43028087E-09_JPRB, &
  & 0.43257742E-09_JPRB, 0.43527651E-09_JPRB, 0.43810927E-09_JPRB, 0.44060103E-09_JPRB, 0.44243720E-09_JPRB, 0.44328025E-09_JPRB, &
  & 0.44282522E-09_JPRB, 0.44099538E-09_JPRB, 0.43779697E-09_JPRB, 0.43335760E-09_JPRB, 0.42780807E-09_JPRB, 0.42126042E-09_JPRB, &
  & 0.41383538E-09_JPRB, 0.40560949E-09_JPRB, 0.39672249E-09_JPRB, 0.38743347E-09_JPRB, 0.37805201E-09_JPRB, 0.36877557E-09_JPRB, &
  & 0.35987374E-09_JPRB, 0.35140263E-09_JPRB, 0.34345377E-09_JPRB, 0.33599323E-09_JPRB, 0.32896239E-09_JPRB, 0.32227274E-09_JPRB, &
  & 0.31579767E-09_JPRB, 0.30941252E-09_JPRB, 0.30299865E-09_JPRB, 0.29635308E-09_JPRB, 0.28936584E-09_JPRB, 0.28190647E-09_JPRB, &
  & 0.27387131E-09_JPRB, 0.26528130E-09_JPRB, 0.25462657E-09_JPRB, 0.23593694E-09_JPRB /)

RGHG6(:,27, 1) = (/ &
  & 0.23843710E-09_JPRB, 0.24696589E-09_JPRB, 0.25272051E-09_JPRB, 0.25860417E-09_JPRB, 0.26526731E-09_JPRB, 0.27296834E-09_JPRB, &
  & 0.28170646E-09_JPRB, 0.29136113E-09_JPRB, 0.30174641E-09_JPRB, 0.31274577E-09_JPRB, 0.32415537E-09_JPRB, 0.33578329E-09_JPRB, &
  & 0.34746006E-09_JPRB, 0.35902853E-09_JPRB, 0.37040868E-09_JPRB, 0.38146936E-09_JPRB, 0.39206838E-09_JPRB, 0.40206985E-09_JPRB, &
  & 0.41134435E-09_JPRB, 0.41977880E-09_JPRB, 0.42725182E-09_JPRB, 0.43366999E-09_JPRB, 0.43902174E-09_JPRB, 0.44331971E-09_JPRB, &
  & 0.44664794E-09_JPRB, 0.44912091E-09_JPRB, 0.45093518E-09_JPRB, 0.45228304E-09_JPRB, 0.45340615E-09_JPRB, 0.45455023E-09_JPRB, &
  & 0.45581344E-09_JPRB, 0.45713969E-09_JPRB, 0.45849771E-09_JPRB, 0.45953447E-09_JPRB, 0.46010534E-09_JPRB, 0.45990381E-09_JPRB, &
  & 0.45871143E-09_JPRB, 0.45649115E-09_JPRB, 0.45322635E-09_JPRB, 0.44898837E-09_JPRB, 0.44386445E-09_JPRB, 0.43791160E-09_JPRB, &
  & 0.43115897E-09_JPRB, 0.42365955E-09_JPRB, 0.41551654E-09_JPRB, 0.40693468E-09_JPRB, 0.39821230E-09_JPRB, 0.38967757E-09_JPRB, &
  & 0.38153125E-09_JPRB, 0.37388298E-09_JPRB, 0.36675588E-09_JPRB, 0.36012618E-09_JPRB, 0.35391534E-09_JPRB, 0.34802711E-09_JPRB, &
  & 0.34232708E-09_JPRB, 0.33670411E-09_JPRB, 0.33096592E-09_JPRB, 0.32497477E-09_JPRB, 0.31852979E-09_JPRB, 0.31151348E-09_JPRB, &
  & 0.30392405E-09_JPRB, 0.29540720E-09_JPRB, 0.28549640E-09_JPRB, 0.26633845E-09_JPRB /)

RGHG6(:,28, 1) = (/ &
  & 0.25576602E-09_JPRB, 0.26426689E-09_JPRB, 0.26996205E-09_JPRB, 0.27566568E-09_JPRB, 0.28210109E-09_JPRB, 0.28948002E-09_JPRB, &
  & 0.29780872E-09_JPRB, 0.30693265E-09_JPRB, 0.31670000E-09_JPRB, 0.32701963E-09_JPRB, 0.33773156E-09_JPRB, 0.34873082E-09_JPRB, &
  & 0.35983413E-09_JPRB, 0.37093881E-09_JPRB, 0.38191275E-09_JPRB, 0.39265385E-09_JPRB, 0.40306994E-09_JPRB, 0.41305886E-09_JPRB, &
  & 0.42250442E-09_JPRB, 0.43130405E-09_JPRB, 0.43935661E-09_JPRB, 0.44658302E-09_JPRB, 0.45295312E-09_JPRB, 0.45842335E-09_JPRB, &
  & 0.46297735E-09_JPRB, 0.46658311E-09_JPRB, 0.46931337E-09_JPRB, 0.47122140E-09_JPRB, 0.47250115E-09_JPRB, 0.47335136E-09_JPRB, &
  & 0.47394572E-09_JPRB, 0.47433590E-09_JPRB, 0.47462090E-09_JPRB, 0.47459492E-09_JPRB, 0.47421256E-09_JPRB, 0.47325932E-09_JPRB, &
  & 0.47158594E-09_JPRB, 0.46916915E-09_JPRB, 0.46599274E-09_JPRB, 0.46208956E-09_JPRB, 0.45748014E-09_JPRB, 0.45217805E-09_JPRB, &
  & 0.44614407E-09_JPRB, 0.43939113E-09_JPRB, 0.43197115E-09_JPRB, 0.42407622E-09_JPRB, 0.41604092E-09_JPRB, 0.40814976E-09_JPRB, &
  & 0.40067105E-09_JPRB, 0.39369619E-09_JPRB, 0.38725442E-09_JPRB, 0.38131998E-09_JPRB, 0.37577780E-09_JPRB, 0.37055831E-09_JPRB, &
  & 0.36551800E-09_JPRB, 0.36053568E-09_JPRB, 0.35546263E-09_JPRB, 0.35009590E-09_JPRB, 0.34429862E-09_JPRB, 0.33792402E-09_JPRB, &
  & 0.33091113E-09_JPRB, 0.32326894E-09_JPRB, 0.31362216E-09_JPRB, 0.29575931E-09_JPRB /)

RGHG6(:,29, 1) = (/ &
  & 0.27348820E-09_JPRB, 0.28194802E-09_JPRB, 0.28744335E-09_JPRB, 0.29293640E-09_JPRB, 0.29902128E-09_JPRB, 0.30598507E-09_JPRB, &
  & 0.31376923E-09_JPRB, 0.32225175E-09_JPRB, 0.33127490E-09_JPRB, 0.34077594E-09_JPRB, 0.35068012E-09_JPRB, 0.36091632E-09_JPRB, &
  & 0.37134687E-09_JPRB, 0.38185016E-09_JPRB, 0.39233738E-09_JPRB, 0.40271586E-09_JPRB, 0.41288500E-09_JPRB, 0.42272738E-09_JPRB, &
  & 0.43213233E-09_JPRB, 0.44101447E-09_JPRB, 0.44929613E-09_JPRB, 0.45691986E-09_JPRB, 0.46385037E-09_JPRB, 0.47001392E-09_JPRB, &
  & 0.47531745E-09_JPRB, 0.47966531E-09_JPRB, 0.48301435E-09_JPRB, 0.48538440E-09_JPRB, 0.48687648E-09_JPRB, 0.48766557E-09_JPRB, &
  & 0.48793825E-09_JPRB, 0.48779775E-09_JPRB, 0.48739585E-09_JPRB, 0.48667292E-09_JPRB, 0.48563631E-09_JPRB, 0.48419657E-09_JPRB, &
  & 0.48224780E-09_JPRB, 0.47979098E-09_JPRB, 0.47680926E-09_JPRB, 0.47330595E-09_JPRB, 0.46923920E-09_JPRB, 0.46456522E-09_JPRB, &
  & 0.45921883E-09_JPRB, 0.45316068E-09_JPRB, 0.44643395E-09_JPRB, 0.43920895E-09_JPRB, 0.43177173E-09_JPRB, 0.42448622E-09_JPRB, &
  & 0.41755710E-09_JPRB, 0.41116027E-09_JPRB, 0.40529133E-09_JPRB, 0.39990333E-09_JPRB, 0.39491330E-09_JPRB, 0.39020887E-09_JPRB, &
  & 0.38569328E-09_JPRB, 0.38123968E-09_JPRB, 0.37669162E-09_JPRB, 0.37190079E-09_JPRB, 0.36669318E-09_JPRB, 0.36099204E-09_JPRB, &
  & 0.35476663E-09_JPRB, 0.34787492E-09_JPRB, 0.33946396E-09_JPRB, 0.32332673E-09_JPRB /)

RGHG6(:,30, 1) = (/ &
  & 0.29171834E-09_JPRB, 0.29994240E-09_JPRB, 0.30523473E-09_JPRB, 0.31035927E-09_JPRB, 0.31604863E-09_JPRB, 0.32247099E-09_JPRB, &
  & 0.32964664E-09_JPRB, 0.33738878E-09_JPRB, 0.34560288E-09_JPRB, 0.35421141E-09_JPRB, 0.36324929E-09_JPRB, 0.37264553E-09_JPRB, &
  & 0.38231968E-09_JPRB, 0.39219378E-09_JPRB, 0.40215886E-09_JPRB, 0.41210388E-09_JPRB, 0.42191728E-09_JPRB, 0.43148760E-09_JPRB, &
  & 0.44069992E-09_JPRB, 0.44947879E-09_JPRB, 0.45776499E-09_JPRB, 0.46551241E-09_JPRB, 0.47266346E-09_JPRB, 0.47915022E-09_JPRB, &
  & 0.48483939E-09_JPRB, 0.48957921E-09_JPRB, 0.49332649E-09_JPRB, 0.49601795E-09_JPRB, 0.49772364E-09_JPRB, 0.49857918E-09_JPRB, &
  & 0.49875892E-09_JPRB, 0.49838289E-09_JPRB, 0.49760218E-09_JPRB, 0.49648108E-09_JPRB, 0.49505677E-09_JPRB, 0.49334148E-09_JPRB, &
  & 0.49128940E-09_JPRB, 0.48891119E-09_JPRB, 0.48619087E-09_JPRB, 0.48308907E-09_JPRB, 0.47952647E-09_JPRB, 0.47541648E-09_JPRB, &
  & 0.47067328E-09_JPRB, 0.46523829E-09_JPRB, 0.45913229E-09_JPRB, 0.45251264E-09_JPRB, 0.44565815E-09_JPRB, 0.43887355E-09_JPRB, &
  & 0.43247150E-09_JPRB, 0.42655304E-09_JPRB, 0.42115467E-09_JPRB, 0.41621379E-09_JPRB, 0.41162879E-09_JPRB, 0.40733120E-09_JPRB, &
  & 0.40320236E-09_JPRB, 0.39914061E-09_JPRB, 0.39501141E-09_JPRB, 0.39066014E-09_JPRB, 0.38598541E-09_JPRB, 0.38089662E-09_JPRB, &
  & 0.37545028E-09_JPRB, 0.36950448E-09_JPRB, 0.36234932E-09_JPRB, 0.34828493E-09_JPRB /)

RGHG6(:,31, 1) = (/ &
  & 0.31030817E-09_JPRB, 0.31816516E-09_JPRB, 0.32309153E-09_JPRB, 0.32784436E-09_JPRB, 0.33300779E-09_JPRB, 0.33886816E-09_JPRB, &
  & 0.34535688E-09_JPRB, 0.35235440E-09_JPRB, 0.35972789E-09_JPRB, 0.36744555E-09_JPRB, 0.37559000E-09_JPRB, 0.38412412E-09_JPRB, &
  & 0.39301218E-09_JPRB, 0.40219134E-09_JPRB, 0.41158782E-09_JPRB, 0.42107268E-09_JPRB, 0.43051768E-09_JPRB, 0.43977974E-09_JPRB, &
  & 0.44874413E-09_JPRB, 0.45733012E-09_JPRB, 0.46546936E-09_JPRB, 0.47313581E-09_JPRB, 0.48027321E-09_JPRB, 0.48678900E-09_JPRB, &
  & 0.49254678E-09_JPRB, 0.49742299E-09_JPRB, 0.50132687E-09_JPRB, 0.50419063E-09_JPRB, 0.50605892E-09_JPRB, 0.50701560E-09_JPRB, &
  & 0.50722604E-09_JPRB, 0.50680082E-09_JPRB, 0.50586613E-09_JPRB, 0.50457749E-09_JPRB, 0.50298066E-09_JPRB, 0.50117188E-09_JPRB, &
  & 0.49914273E-09_JPRB, 0.49691967E-09_JPRB, 0.49446913E-09_JPRB, 0.49173132E-09_JPRB, 0.48860116E-09_JPRB, 0.48496851E-09_JPRB, &
  & 0.48072524E-09_JPRB, 0.47580906E-09_JPRB, 0.47024845E-09_JPRB, 0.46417237E-09_JPRB, 0.45783619E-09_JPRB, 0.45157780E-09_JPRB, &
  & 0.44561127E-09_JPRB, 0.44012816E-09_JPRB, 0.43511295E-09_JPRB, 0.43050849E-09_JPRB, 0.42625162E-09_JPRB, 0.42223924E-09_JPRB, &
  & 0.41840220E-09_JPRB, 0.41462372E-09_JPRB, 0.41079934E-09_JPRB, 0.40680609E-09_JPRB, 0.40254383E-09_JPRB, 0.39800860E-09_JPRB, &
  & 0.39321280E-09_JPRB, 0.38815998E-09_JPRB, 0.38190576E-09_JPRB, 0.37031886E-09_JPRB /)

RGHG6(:,32, 1) = (/ &
  & 0.32891040E-09_JPRB, 0.33627140E-09_JPRB, 0.34079550E-09_JPRB, 0.34507661E-09_JPRB, 0.34973982E-09_JPRB, 0.35498138E-09_JPRB, &
  & 0.36081318E-09_JPRB, 0.36706213E-09_JPRB, 0.37363190E-09_JPRB, 0.38048842E-09_JPRB, 0.38775472E-09_JPRB, 0.39542136E-09_JPRB, &
  & 0.40353032E-09_JPRB, 0.41206069E-09_JPRB, 0.42091633E-09_JPRB, 0.42996029E-09_JPRB, 0.43903761E-09_JPRB, 0.44798856E-09_JPRB, &
  & 0.45666435E-09_JPRB, 0.46499429E-09_JPRB, 0.47290960E-09_JPRB, 0.48036741E-09_JPRB, 0.48729226E-09_JPRB, 0.49362325E-09_JPRB, &
  & 0.49920629E-09_JPRB, 0.50396182E-09_JPRB, 0.50781301E-09_JPRB, 0.51069360E-09_JPRB, 0.51263671E-09_JPRB, 0.51367771E-09_JPRB, &
  & 0.51397425E-09_JPRB, 0.51360050E-09_JPRB, 0.51267846E-09_JPRB, 0.51138893E-09_JPRB, 0.50979027E-09_JPRB, 0.50802396E-09_JPRB, &
  & 0.50611865E-09_JPRB, 0.50408433E-09_JPRB, 0.50189541E-09_JPRB, 0.49946547E-09_JPRB, 0.49668153E-09_JPRB, 0.49341675E-09_JPRB, &
  & 0.48956333E-09_JPRB, 0.48506060E-09_JPRB, 0.47993409E-09_JPRB, 0.47433762E-09_JPRB, 0.46850157E-09_JPRB, 0.46268772E-09_JPRB, &
  & 0.45717713E-09_JPRB, 0.45206286E-09_JPRB, 0.44737380E-09_JPRB, 0.44305654E-09_JPRB, 0.43903944E-09_JPRB, 0.43526016E-09_JPRB, &
  & 0.43162440E-09_JPRB, 0.42806336E-09_JPRB, 0.42447162E-09_JPRB, 0.42074791E-09_JPRB, 0.41683684E-09_JPRB, 0.41272863E-09_JPRB, &
  & 0.40850862E-09_JPRB, 0.40402481E-09_JPRB, 0.39887424E-09_JPRB, 0.38881504E-09_JPRB /)

RGHG6(:,33, 1) = (/ &
  & 0.34719250E-09_JPRB, 0.35391043E-09_JPRB, 0.35800443E-09_JPRB, 0.36184450E-09_JPRB, 0.36598055E-09_JPRB, 0.37066605E-09_JPRB, &
  & 0.37586076E-09_JPRB, 0.38142614E-09_JPRB, 0.38723505E-09_JPRB, 0.39329753E-09_JPRB, 0.39970724E-09_JPRB, 0.40653036E-09_JPRB, &
  & 0.41384679E-09_JPRB, 0.42168988E-09_JPRB, 0.43002363E-09_JPRB, 0.43868820E-09_JPRB, 0.44747570E-09_JPRB, 0.45617898E-09_JPRB, &
  & 0.46462886E-09_JPRB, 0.47270693E-09_JPRB, 0.48034537E-09_JPRB, 0.48749188E-09_JPRB, 0.49410182E-09_JPRB, 0.50004484E-09_JPRB, &
  & 0.50526883E-09_JPRB, 0.50969357E-09_JPRB, 0.51329707E-09_JPRB, 0.51605425E-09_JPRB, 0.51796600E-09_JPRB, 0.51904481E-09_JPRB, &
  & 0.51943655E-09_JPRB, 0.51916893E-09_JPRB, 0.51837801E-09_JPRB, 0.51720594E-09_JPRB, 0.51573290E-09_JPRB, 0.51411092E-09_JPRB, &
  & 0.51237858E-09_JPRB, 0.51055682E-09_JPRB, 0.50861293E-09_JPRB, 0.50645160E-09_JPRB, 0.50393784E-09_JPRB, 0.50094012E-09_JPRB, &
  & 0.49736149E-09_JPRB, 0.49315113E-09_JPRB, 0.48837911E-09_JPRB, 0.48317761E-09_JPRB, 0.47776183E-09_JPRB, 0.47240656E-09_JPRB, &
  & 0.46728266E-09_JPRB, 0.46252635E-09_JPRB, 0.45812892E-09_JPRB, 0.45405421E-09_JPRB, 0.45025170E-09_JPRB, 0.44663975E-09_JPRB, &
  & 0.44317638E-09_JPRB, 0.43977777E-09_JPRB, 0.43637177E-09_JPRB, 0.43286655E-09_JPRB, 0.42922965E-09_JPRB, 0.42547493E-09_JPRB, &
  & 0.42163117E-09_JPRB, 0.41771209E-09_JPRB, 0.41294876E-09_JPRB, 0.40441900E-09_JPRB /)

RGHG6(:,34, 1) = (/ &
  & 0.36472636E-09_JPRB, 0.37084946E-09_JPRB, 0.37449688E-09_JPRB, 0.37790016E-09_JPRB, 0.38158818E-09_JPRB, 0.38574563E-09_JPRB, &
  & 0.39037681E-09_JPRB, 0.39531717E-09_JPRB, 0.40044315E-09_JPRB, 0.40577175E-09_JPRB, 0.41138559E-09_JPRB, 0.41740755E-09_JPRB, &
  & 0.42398485E-09_JPRB, 0.43119858E-09_JPRB, 0.43902693E-09_JPRB, 0.44732942E-09_JPRB, 0.45585616E-09_JPRB, 0.46435983E-09_JPRB, &
  & 0.47262450E-09_JPRB, 0.48045895E-09_JPRB, 0.48780957E-09_JPRB, 0.49463589E-09_JPRB, 0.50079818E-09_JPRB, 0.50625892E-09_JPRB, &
  & 0.51094057E-09_JPRB, 0.51487664E-09_JPRB, 0.51808308E-09_JPRB, 0.52056509E-09_JPRB, 0.52233268E-09_JPRB, 0.52339083E-09_JPRB, &
  & 0.52384763E-09_JPRB, 0.52371585E-09_JPRB, 0.52312882E-09_JPRB, 0.52215771E-09_JPRB, 0.52091148E-09_JPRB, 0.51951610E-09_JPRB, &
  & 0.51801141E-09_JPRB, 0.51642829E-09_JPRB, 0.51472249E-09_JPRB, 0.51278432E-09_JPRB, 0.51047938E-09_JPRB, 0.50767013E-09_JPRB, &
  & 0.50426524E-09_JPRB, 0.50026433E-09_JPRB, 0.49573745E-09_JPRB, 0.49086080E-09_JPRB, 0.48584103E-09_JPRB, 0.48085869E-09_JPRB, &
  & 0.47611848E-09_JPRB, 0.47166521E-09_JPRB, 0.46752913E-09_JPRB, 0.46367477E-09_JPRB, 0.46003537E-09_JPRB, 0.45658413E-09_JPRB, &
  & 0.45325341E-09_JPRB, 0.44999948E-09_JPRB, 0.44673218E-09_JPRB, 0.44341153E-09_JPRB, 0.43999537E-09_JPRB, 0.43649762E-09_JPRB, &
  & 0.43297052E-09_JPRB, 0.42927892E-09_JPRB, 0.42511972E-09_JPRB, 0.41726961E-09_JPRB /)

RGHG6(:,35, 1) = (/ &
  & 0.38141035E-09_JPRB, 0.38687209E-09_JPRB, 0.39012193E-09_JPRB, 0.39314682E-09_JPRB, 0.39640372E-09_JPRB, 0.40011922E-09_JPRB, &
  & 0.40424031E-09_JPRB, 0.40862766E-09_JPRB, 0.41314024E-09_JPRB, 0.41780138E-09_JPRB, 0.42267889E-09_JPRB, 0.42794063E-09_JPRB, &
  & 0.43379061E-09_JPRB, 0.44038515E-09_JPRB, 0.44774501E-09_JPRB, 0.45572779E-09_JPRB, 0.46404292E-09_JPRB, 0.47239823E-09_JPRB, &
  & 0.48050697E-09_JPRB, 0.48814330E-09_JPRB, 0.49523885E-09_JPRB, 0.50166510E-09_JPRB, 0.50733567E-09_JPRB, 0.51218296E-09_JPRB, &
  & 0.51623278E-09_JPRB, 0.51954663E-09_JPRB, 0.52220867E-09_JPRB, 0.52429860E-09_JPRB, 0.52579263E-09_JPRB, 0.52675420E-09_JPRB, &
  & 0.52721250E-09_JPRB, 0.52721760E-09_JPRB, 0.52683441E-09_JPRB, 0.52611815E-09_JPRB, 0.52516269E-09_JPRB, 0.52404348E-09_JPRB, &
  & 0.52281773E-09_JPRB, 0.52150451E-09_JPRB, 0.52004651E-09_JPRB, 0.51833315E-09_JPRB, 0.51622800E-09_JPRB, 0.51358706E-09_JPRB, &
  & 0.51033622E-09_JPRB, 0.50647642E-09_JPRB, 0.50215831E-09_JPRB, 0.49756216E-09_JPRB, 0.49284732E-09_JPRB, 0.48823373E-09_JPRB, &
  & 0.48378979E-09_JPRB, 0.47961907E-09_JPRB, 0.47570720E-09_JPRB, 0.47202059E-09_JPRB, 0.46853554E-09_JPRB, 0.46520615E-09_JPRB, &
  & 0.46200366E-09_JPRB, 0.45885654E-09_JPRB, 0.45572901E-09_JPRB, 0.45255061E-09_JPRB, 0.44931830E-09_JPRB, 0.44603060E-09_JPRB, &
  & 0.44270071E-09_JPRB, 0.43932125E-09_JPRB, 0.43530202E-09_JPRB, 0.42820725E-09_JPRB /)

RGHG6(:,36, 1) = (/ &
  & 0.39711459E-09_JPRB, 0.40197373E-09_JPRB, 0.40483117E-09_JPRB, 0.40749026E-09_JPRB, 0.41040055E-09_JPRB, 0.41370185E-09_JPRB, &
  & 0.41738651E-09_JPRB, 0.42127862E-09_JPRB, 0.42525292E-09_JPRB, 0.42929596E-09_JPRB, 0.43350232E-09_JPRB, 0.43804702E-09_JPRB, &
  & 0.44318613E-09_JPRB, 0.44914894E-09_JPRB, 0.45602655E-09_JPRB, 0.46367496E-09_JPRB, 0.47181170E-09_JPRB, 0.48006799E-09_JPRB, &
  & 0.48808374E-09_JPRB, 0.49559351E-09_JPRB, 0.50241522E-09_JPRB, 0.50841020E-09_JPRB, 0.51347804E-09_JPRB, 0.51761001E-09_JPRB, &
  & 0.52089433E-09_JPRB, 0.52349058E-09_JPRB, 0.52553534E-09_JPRB, 0.52712834E-09_JPRB, 0.52829885E-09_JPRB, 0.52908755E-09_JPRB, &
  & 0.52950028E-09_JPRB, 0.52958815E-09_JPRB, 0.52936122E-09_JPRB, 0.52887938E-09_JPRB, 0.52818611E-09_JPRB, 0.52734372E-09_JPRB, &
  & 0.52639731E-09_JPRB, 0.52535065E-09_JPRB, 0.52415577E-09_JPRB, 0.52271476E-09_JPRB, 0.52087717E-09_JPRB, 0.51849303E-09_JPRB, &
  & 0.51546512E-09_JPRB, 0.51182159E-09_JPRB, 0.50771676E-09_JPRB, 0.50335225E-09_JPRB, 0.49895127E-09_JPRB, 0.49460647E-09_JPRB, &
  & 0.49045351E-09_JPRB, 0.48650040E-09_JPRB, 0.48275772E-09_JPRB, 0.47921983E-09_JPRB, 0.47585225E-09_JPRB, 0.47264315E-09_JPRB, &
  & 0.46954246E-09_JPRB, 0.46651683E-09_JPRB, 0.46349810E-09_JPRB, 0.46046392E-09_JPRB, 0.45737691E-09_JPRB, 0.45425444E-09_JPRB, &
  & 0.45112081E-09_JPRB, 0.44787657E-09_JPRB, 0.44420767E-09_JPRB, 0.43752635E-09_JPRB /)

RGHG6(:,37, 1) = (/ &
  & 0.41189585E-09_JPRB, 0.41610854E-09_JPRB, 0.41860312E-09_JPRB, 0.42095261E-09_JPRB, 0.42353065E-09_JPRB, 0.42649784E-09_JPRB, &
  & 0.42979015E-09_JPRB, 0.43325127E-09_JPRB, 0.43673792E-09_JPRB, 0.44022438E-09_JPRB, 0.44381221E-09_JPRB, 0.44767318E-09_JPRB, &
  & 0.45213205E-09_JPRB, 0.45744269E-09_JPRB, 0.46382687E-09_JPRB, 0.47116488E-09_JPRB, 0.47911308E-09_JPRB, 0.48727100E-09_JPRB, &
  & 0.49521298E-09_JPRB, 0.50256782E-09_JPRB, 0.50904458E-09_JPRB, 0.51447829E-09_JPRB, 0.51877402E-09_JPRB, 0.52207194E-09_JPRB, &
  & 0.52454857E-09_JPRB, 0.52643717E-09_JPRB, 0.52789589E-09_JPRB, 0.52905380E-09_JPRB, 0.52992405E-09_JPRB, 0.53054572E-09_JPRB, &
  & 0.53090649E-09_JPRB, 0.53102112E-09_JPRB, 0.53089894E-09_JPRB, 0.53056909E-09_JPRB, 0.53006532E-09_JPRB, 0.52943505E-09_JPRB, &
  & 0.52870563E-09_JPRB, 0.52788202E-09_JPRB, 0.52692711E-09_JPRB, 0.52575450E-09_JPRB, 0.52423210E-09_JPRB, 0.52220239E-09_JPRB, &
  & 0.51953986E-09_JPRB, 0.51622673E-09_JPRB, 0.51240395E-09_JPRB, 0.50832560E-09_JPRB, 0.50418020E-09_JPRB, 0.50012156E-09_JPRB, &
  & 0.49618532E-09_JPRB, 0.49241733E-09_JPRB, 0.48882531E-09_JPRB, 0.48539778E-09_JPRB, 0.48213816E-09_JPRB, 0.47902698E-09_JPRB, &
  & 0.47604742E-09_JPRB, 0.47314430E-09_JPRB, 0.47027049E-09_JPRB, 0.46736121E-09_JPRB, 0.46441215E-09_JPRB, 0.46142679E-09_JPRB, &
  & 0.45843213E-09_JPRB, 0.45540205E-09_JPRB, 0.45191340E-09_JPRB, 0.44575371E-09_JPRB /)

RGHG6(:,38, 1) = (/ &
  & 0.42566506E-09_JPRB, 0.42927895E-09_JPRB, 0.43142653E-09_JPRB, 0.43349133E-09_JPRB, 0.43579657E-09_JPRB, 0.43846915E-09_JPRB, &
  & 0.44142751E-09_JPRB, 0.44450268E-09_JPRB, 0.44754844E-09_JPRB, 0.45053869E-09_JPRB, 0.45354204E-09_JPRB, 0.45680748E-09_JPRB, &
  & 0.46056703E-09_JPRB, 0.46524828E-09_JPRB, 0.47105375E-09_JPRB, 0.47803711E-09_JPRB, 0.48580495E-09_JPRB, 0.49384896E-09_JPRB, &
  & 0.50165100E-09_JPRB, 0.50872390E-09_JPRB, 0.51466975E-09_JPRB, 0.51931143E-09_JPRB, 0.52276261E-09_JPRB, 0.52524374E-09_JPRB, &
  & 0.52703347E-09_JPRB, 0.52838278E-09_JPRB, 0.52942378E-09_JPRB, 0.53026916E-09_JPRB, 0.53093924E-09_JPRB, 0.53143656E-09_JPRB, &
  & 0.53175631E-09_JPRB, 0.53187882E-09_JPRB, 0.53181554E-09_JPRB, 0.53157578E-09_JPRB, 0.53119337E-09_JPRB, 0.53070015E-09_JPRB, &
  & 0.53012172E-09_JPRB, 0.52946014E-09_JPRB, 0.52868621E-09_JPRB, 0.52773164E-09_JPRB, 0.52648169E-09_JPRB, 0.52479221E-09_JPRB, &
  & 0.52253124E-09_JPRB, 0.51963106E-09_JPRB, 0.51620530E-09_JPRB, 0.51245241E-09_JPRB, 0.50861337E-09_JPRB, 0.50479343E-09_JPRB, &
  & 0.50107068E-09_JPRB, 0.49746890E-09_JPRB, 0.49399251E-09_JPRB, 0.49067078E-09_JPRB, 0.48751059E-09_JPRB, 0.48452892E-09_JPRB, &
  & 0.48169924E-09_JPRB, 0.47895887E-09_JPRB, 0.47624515E-09_JPRB, 0.47348964E-09_JPRB, 0.47066695E-09_JPRB, 0.46779386E-09_JPRB, &
  & 0.46493046E-09_JPRB, 0.46204232E-09_JPRB, 0.45880741E-09_JPRB, 0.45310694E-09_JPRB /)

RGHG6(:,39, 1) = (/ &
  & 0.43835355E-09_JPRB, 0.44138329E-09_JPRB, 0.44323634E-09_JPRB, 0.44504905E-09_JPRB, 0.44713733E-09_JPRB, 0.44955595E-09_JPRB, &
  & 0.45222634E-09_JPRB, 0.45495013E-09_JPRB, 0.45760207E-09_JPRB, 0.46012821E-09_JPRB, 0.46266463E-09_JPRB, 0.46533846E-09_JPRB, &
  & 0.46853321E-09_JPRB, 0.47252691E-09_JPRB, 0.47777304E-09_JPRB, 0.48430154E-09_JPRB, 0.49181981E-09_JPRB, 0.49968940E-09_JPRB, &
  & 0.50720317E-09_JPRB, 0.51374993E-09_JPRB, 0.51893645E-09_JPRB, 0.52275340E-09_JPRB, 0.52542037E-09_JPRB, 0.52728805E-09_JPRB, &
  & 0.52861387E-09_JPRB, 0.52961369E-09_JPRB, 0.53040006E-09_JPRB, 0.53105520E-09_JPRB, 0.53159666E-09_JPRB, 0.53201754E-09_JPRB, &
  & 0.53230431E-09_JPRB, 0.53243077E-09_JPRB, 0.53239874E-09_JPRB, 0.53221438E-09_JPRB, 0.53190652E-09_JPRB, 0.53150345E-09_JPRB, &
  & 0.53102700E-09_JPRB, 0.53047838E-09_JPRB, 0.52983334E-09_JPRB, 0.52903626E-09_JPRB, 0.52799365E-09_JPRB, 0.52658283E-09_JPRB, &
  & 0.52467253E-09_JPRB, 0.52219334E-09_JPRB, 0.51917265E-09_JPRB, 0.51580873E-09_JPRB, 0.51226623E-09_JPRB, 0.50870985E-09_JPRB, &
  & 0.50519533E-09_JPRB, 0.50174082E-09_JPRB, 0.49838950E-09_JPRB, 0.49517074E-09_JPRB, 0.49213250E-09_JPRB, 0.48930221E-09_JPRB, &
  & 0.48664472E-09_JPRB, 0.48411469E-09_JPRB, 0.48160115E-09_JPRB, 0.47902926E-09_JPRB, 0.47634319E-09_JPRB, 0.47358245E-09_JPRB, &
  & 0.47082793E-09_JPRB, 0.46809945E-09_JPRB, 0.46507653E-09_JPRB, 0.45983070E-09_JPRB /)

RGHG6(:,40, 1) = (/ &
  & 0.44980647E-09_JPRB, 0.45236037E-09_JPRB, 0.45395096E-09_JPRB, 0.45557205E-09_JPRB, 0.45745857E-09_JPRB, 0.45968723E-09_JPRB, &
  & 0.46208920E-09_JPRB, 0.46449983E-09_JPRB, 0.46678295E-09_JPRB, 0.46894610E-09_JPRB, 0.47102855E-09_JPRB, 0.47329585E-09_JPRB, &
  & 0.47590626E-09_JPRB, 0.47935966E-09_JPRB, 0.48397231E-09_JPRB, 0.49004667E-09_JPRB, 0.49720617E-09_JPRB, 0.50471977E-09_JPRB, &
  & 0.51175869E-09_JPRB, 0.51759558E-09_JPRB, 0.52197846E-09_JPRB, 0.52505295E-09_JPRB, 0.52714921E-09_JPRB, 0.52859872E-09_JPRB, &
  & 0.52963650E-09_JPRB, 0.53042448E-09_JPRB, 0.53106008E-09_JPRB, 0.53159971E-09_JPRB, 0.53206095E-09_JPRB, 0.53243193E-09_JPRB, &
  & 0.53269300E-09_JPRB, 0.53281946E-09_JPRB, 0.53280474E-09_JPRB, 0.53265503E-09_JPRB, 0.53239535E-09_JPRB, 0.53205285E-09_JPRB, &
  & 0.53164734E-09_JPRB, 0.53117849E-09_JPRB, 0.53062588E-09_JPRB, 0.52994215E-09_JPRB, 0.52905114E-09_JPRB, 0.52784749E-09_JPRB, &
  & 0.52622223E-09_JPRB, 0.52408605E-09_JPRB, 0.52146498E-09_JPRB, 0.51845195E-09_JPRB, 0.51524918E-09_JPRB, 0.51196081E-09_JPRB, &
  & 0.50865112E-09_JPRB, 0.50536936E-09_JPRB, 0.50214000E-09_JPRB, 0.49903082E-09_JPRB, 0.49612608E-09_JPRB, 0.49345350E-09_JPRB, &
  & 0.49102250E-09_JPRB, 0.48871707E-09_JPRB, 0.48644788E-09_JPRB, 0.48408416E-09_JPRB, 0.48157617E-09_JPRB, 0.47894644E-09_JPRB, &
  & 0.47631804E-09_JPRB, 0.47373844E-09_JPRB, 0.47092469E-09_JPRB, 0.46609711E-09_JPRB /)

RGHG6(:,41, 1) = (/ &
  & 0.46000090E-09_JPRB, 0.46216592E-09_JPRB, 0.46354717E-09_JPRB, 0.46499854E-09_JPRB, 0.46675191E-09_JPRB, 0.46879528E-09_JPRB, &
  & 0.47097320E-09_JPRB, 0.47309340E-09_JPRB, 0.47507287E-09_JPRB, 0.47689613E-09_JPRB, 0.47868048E-09_JPRB, 0.48053095E-09_JPRB, &
  & 0.48277521E-09_JPRB, 0.48565352E-09_JPRB, 0.48972565E-09_JPRB, 0.49523541E-09_JPRB, 0.50197790E-09_JPRB, 0.50904359E-09_JPRB, &
  & 0.51539728E-09_JPRB, 0.52047960E-09_JPRB, 0.52413379E-09_JPRB, 0.52662974E-09_JPRB, 0.52832450E-09_JPRB, 0.52949095E-09_JPRB, &
  & 0.53034976E-09_JPRB, 0.53100324E-09_JPRB, 0.53154525E-09_JPRB, 0.53201388E-09_JPRB, 0.53242033E-09_JPRB, 0.53275678E-09_JPRB, &
  & 0.53299654E-09_JPRB, 0.53311888E-09_JPRB, 0.53311333E-09_JPRB, 0.53298599E-09_JPRB, 0.53275850E-09_JPRB, 0.53245874E-09_JPRB, &
  & 0.53210436E-09_JPRB, 0.53169535E-09_JPRB, 0.53121213E-09_JPRB, 0.53061566E-09_JPRB, 0.52984067E-09_JPRB, 0.52879900E-09_JPRB, &
  & 0.52739141E-09_JPRB, 0.52554439E-09_JPRB, 0.52324128E-09_JPRB, 0.52058735E-09_JPRB, 0.51768712E-09_JPRB, 0.51466759E-09_JPRB, &
  & 0.51159194E-09_JPRB, 0.50847876E-09_JPRB, 0.50537585E-09_JPRB, 0.50238863E-09_JPRB, 0.49960325E-09_JPRB, 0.49713128E-09_JPRB, &
  & 0.49491000E-09_JPRB, 0.49286891E-09_JPRB, 0.49084681E-09_JPRB, 0.48873600E-09_JPRB, 0.48644022E-09_JPRB, 0.48399385E-09_JPRB, &
  & 0.48153109E-09_JPRB, 0.47911869E-09_JPRB, 0.47650894E-09_JPRB, 0.47206411E-09_JPRB /)

RGHG6(:,42, 1) = (/ &
  & 0.46899967E-09_JPRB, 0.47085430E-09_JPRB, 0.47208115E-09_JPRB, 0.47339899E-09_JPRB, 0.47502591E-09_JPRB, 0.47693094E-09_JPRB, &
  & 0.47890031E-09_JPRB, 0.48077248E-09_JPRB, 0.48248744E-09_JPRB, 0.48406301E-09_JPRB, 0.48556936E-09_JPRB, 0.48716675E-09_JPRB, &
  & 0.48902499E-09_JPRB, 0.49153703E-09_JPRB, 0.49506133E-09_JPRB, 0.50005555E-09_JPRB, 0.50626620E-09_JPRB, 0.51274374E-09_JPRB, &
  & 0.51841603E-09_JPRB, 0.52270399E-09_JPRB, 0.52573118E-09_JPRB, 0.52777449E-09_JPRB, 0.52917548E-09_JPRB, 0.53015037E-09_JPRB, &
  & 0.53088528E-09_JPRB, 0.53145183E-09_JPRB, 0.53193355E-09_JPRB, 0.53235344E-09_JPRB, 0.53272364E-09_JPRB, 0.53303140E-09_JPRB, &
  & 0.53325205E-09_JPRB, 0.53336685E-09_JPRB, 0.53336519E-09_JPRB, 0.53325183E-09_JPRB, 0.53304694E-09_JPRB, 0.53277788E-09_JPRB, &
  & 0.53246207E-09_JPRB, 0.53209909E-09_JPRB, 0.53167143E-09_JPRB, 0.53114441E-09_JPRB, 0.53046267E-09_JPRB, 0.52955113E-09_JPRB, &
  & 0.52832683E-09_JPRB, 0.52671367E-09_JPRB, 0.52469873E-09_JPRB, 0.52232724E-09_JPRB, 0.51972315E-09_JPRB, 0.51697330E-09_JPRB, &
  & 0.51412524E-09_JPRB, 0.51120025E-09_JPRB, 0.50825177E-09_JPRB, 0.50536497E-09_JPRB, 0.50274129E-09_JPRB, 0.50044102E-09_JPRB, &
  & 0.49846216E-09_JPRB, 0.49666388E-09_JPRB, 0.49490789E-09_JPRB, 0.49305321E-09_JPRB, 0.49101395E-09_JPRB, 0.48880866E-09_JPRB, &
  & 0.48655374E-09_JPRB, 0.48434301E-09_JPRB, 0.48193810E-09_JPRB, 0.47784560E-09_JPRB /)

RGHG6(:,43, 1) = (/ &
  & 0.47692589E-09_JPRB, 0.47856474E-09_JPRB, 0.47965043E-09_JPRB, 0.48086718E-09_JPRB, 0.48239496E-09_JPRB, 0.48417287E-09_JPRB, &
  & 0.48596793E-09_JPRB, 0.48763305E-09_JPRB, 0.48914117E-09_JPRB, 0.49050969E-09_JPRB, 0.49182292E-09_JPRB, 0.49318527E-09_JPRB, &
  & 0.49480270E-09_JPRB, 0.49691484E-09_JPRB, 0.50003862E-09_JPRB, 0.50448123E-09_JPRB, 0.51013921E-09_JPRB, 0.51593185E-09_JPRB, &
  & 0.52082838E-09_JPRB, 0.52445520E-09_JPRB, 0.52695637E-09_JPRB, 0.52865101E-09_JPRB, 0.52982940E-09_JPRB, 0.53066901E-09_JPRB, &
  & 0.53131444E-09_JPRB, 0.53182325E-09_JPRB, 0.53226235E-09_JPRB, 0.53265148E-09_JPRB, 0.53299237E-09_JPRB, 0.53327748E-09_JPRB, &
  & 0.53347876E-09_JPRB, 0.53358318E-09_JPRB, 0.53358135E-09_JPRB, 0.53347649E-09_JPRB, 0.53328730E-09_JPRB, 0.53304111E-09_JPRB, &
  & 0.53275490E-09_JPRB, 0.53242866E-09_JPRB, 0.53204641E-09_JPRB, 0.53157762E-09_JPRB, 0.53097515E-09_JPRB, 0.53017507E-09_JPRB, &
  & 0.52910265E-09_JPRB, 0.52769045E-09_JPRB, 0.52590976E-09_JPRB, 0.52380628E-09_JPRB, 0.52146454E-09_JPRB, 0.51896770E-09_JPRB, &
  & 0.51635674E-09_JPRB, 0.51364030E-09_JPRB, 0.51084037E-09_JPRB, 0.50811794E-09_JPRB, 0.50563875E-09_JPRB, 0.50355203E-09_JPRB, &
  & 0.50179844E-09_JPRB, 0.50024102E-09_JPRB, 0.49873156E-09_JPRB, 0.49713550E-09_JPRB, 0.49537152E-09_JPRB, 0.49344295E-09_JPRB, &
  & 0.49145488E-09_JPRB, 0.48947191E-09_JPRB, 0.48729304E-09_JPRB, 0.48355331E-09_JPRB /)

RGHG6(:,44, 1) = (/ &
  & 0.48396381E-09_JPRB, 0.48543514E-09_JPRB, 0.48643101E-09_JPRB, 0.48755555E-09_JPRB, 0.48899984E-09_JPRB, 0.49066962E-09_JPRB, &
  & 0.49232052E-09_JPRB, 0.49382876E-09_JPRB, 0.49517118E-09_JPRB, 0.49638760E-09_JPRB, 0.49753601E-09_JPRB, 0.49872584E-09_JPRB, &
  & 0.50010779E-09_JPRB, 0.50195914E-09_JPRB, 0.50462923E-09_JPRB, 0.50863597E-09_JPRB, 0.51369037E-09_JPRB, 0.51876747E-09_JPRB, &
  & 0.52289295E-09_JPRB, 0.52586618E-09_JPRB, 0.52793125E-09_JPRB, 0.52934623E-09_JPRB, 0.53035604E-09_JPRB, 0.53109306E-09_JPRB, &
  & 0.53167371E-09_JPRB, 0.53214344E-09_JPRB, 0.53255361E-09_JPRB, 0.53291938E-09_JPRB, 0.53324101E-09_JPRB, 0.53350341E-09_JPRB, &
  & 0.53368637E-09_JPRB, 0.53377813E-09_JPRB, 0.53377280E-09_JPRB, 0.53367222E-09_JPRB, 0.53349403E-09_JPRB, 0.53326465E-09_JPRB, &
  & 0.53300159E-09_JPRB, 0.53270510E-09_JPRB, 0.53236049E-09_JPRB, 0.53194149E-09_JPRB, 0.53140742E-09_JPRB, 0.53070404E-09_JPRB, &
  & 0.52976767E-09_JPRB, 0.52853538E-09_JPRB, 0.52697074E-09_JPRB, 0.52509908E-09_JPRB, 0.52299315E-09_JPRB, 0.52073840E-09_JPRB, &
  & 0.51835969E-09_JPRB, 0.51585514E-09_JPRB, 0.51326576E-09_JPRB, 0.51070936E-09_JPRB, 0.50844351E-09_JPRB, 0.50657395E-09_JPRB, &
  & 0.50504101E-09_JPRB, 0.50370713E-09_JPRB, 0.50241855E-09_JPRB, 0.50106669E-09_JPRB, 0.49957138E-09_JPRB, 0.49793702E-09_JPRB, &
  & 0.49624355E-09_JPRB, 0.49452253E-09_JPRB, 0.49259841E-09_JPRB, 0.48924054E-09_JPRB /)

RGHG6(:,45, 1) = (/ &
  & 0.49029369E-09_JPRB, 0.49164345E-09_JPRB, 0.49256743E-09_JPRB, 0.49362170E-09_JPRB, 0.49499099E-09_JPRB, 0.49657772E-09_JPRB, &
  & 0.49812304E-09_JPRB, 0.49950988E-09_JPRB, 0.50074073E-09_JPRB, 0.50183102E-09_JPRB, 0.50284726E-09_JPRB, 0.50388371E-09_JPRB, &
  & 0.50506854E-09_JPRB, 0.50664484E-09_JPRB, 0.50897253E-09_JPRB, 0.51242749E-09_JPRB, 0.51686549E-09_JPRB, 0.52117977E-09_JPRB, &
  & 0.52458576E-09_JPRB, 0.52701787E-09_JPRB, 0.52871363E-09_JPRB, 0.52991544E-09_JPRB, 0.53078469E-09_JPRB, 0.53145227E-09_JPRB, &
  & 0.53198257E-09_JPRB, 0.53242522E-09_JPRB, 0.53281729E-09_JPRB, 0.53316812E-09_JPRB, 0.53347049E-09_JPRB, 0.53371518E-09_JPRB, &
  & 0.53387805E-09_JPRB, 0.53395610E-09_JPRB, 0.53394478E-09_JPRB, 0.53384547E-09_JPRB, 0.53367410E-09_JPRB, 0.53345717E-09_JPRB, &
  & 0.53321209E-09_JPRB, 0.53293936E-09_JPRB, 0.53262633E-09_JPRB, 0.53224963E-09_JPRB, 0.53177501E-09_JPRB, 0.53115701E-09_JPRB, &
  & 0.53034249E-09_JPRB, 0.52927207E-09_JPRB, 0.52790899E-09_JPRB, 0.52625443E-09_JPRB, 0.52437926E-09_JPRB, 0.52234844E-09_JPRB, &
  & 0.52019983E-09_JPRB, 0.51792598E-09_JPRB, 0.51554228E-09_JPRB, 0.51323856E-09_JPRB, 0.51119836E-09_JPRB, 0.50957483E-09_JPRB, &
  & 0.50826077E-09_JPRB, 0.50712418E-09_JPRB, 0.50604160E-09_JPRB, 0.50490145E-09_JPRB, 0.50365634E-09_JPRB, 0.50230542E-09_JPRB, &
  & 0.50090199E-09_JPRB, 0.49946342E-09_JPRB, 0.49782078E-09_JPRB, 0.49490217E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART1',1,ZHOOK_HANDLE)
END SUBROUTINE PART1




SUBROUTINE PART2
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART2',0,ZHOOK_HANDLE)



RGHG6(:,46, 1) = (/ &
  & 0.49604382E-09_JPRB, 0.49733645E-09_JPRB, 0.49819826E-09_JPRB, 0.49920701E-09_JPRB, 0.50051346E-09_JPRB, 0.50202498E-09_JPRB, &
  & 0.50349946E-09_JPRB, 0.50481486E-09_JPRB, 0.50595372E-09_JPRB, 0.50694438E-09_JPRB, 0.50784443E-09_JPRB, 0.50872540E-09_JPRB, &
  & 0.50974430E-09_JPRB, 0.51104360E-09_JPRB, 0.51303389E-09_JPRB, 0.51597432E-09_JPRB, 0.51971832E-09_JPRB, 0.52325583E-09_JPRB, &
  & 0.52599175E-09_JPRB, 0.52795213E-09_JPRB, 0.52935450E-09_JPRB, 0.53037741E-09_JPRB, 0.53115035E-09_JPRB, 0.53175614E-09_JPRB, &
  & 0.53225335E-09_JPRB, 0.53268084E-09_JPRB, 0.53305843E-09_JPRB, 0.53339833E-09_JPRB, 0.53368837E-09_JPRB, 0.53391086E-09_JPRB, &
  & 0.53405602E-09_JPRB, 0.53411914E-09_JPRB, 0.53410010E-09_JPRB, 0.53399912E-09_JPRB, 0.53383203E-09_JPRB, 0.53362392E-09_JPRB, &
  & 0.53339261E-09_JPRB, 0.53313914E-09_JPRB, 0.53285182E-09_JPRB, 0.53251109E-09_JPRB, 0.53208765E-09_JPRB, 0.53154542E-09_JPRB, &
  & 0.53084059E-09_JPRB, 0.52992533E-09_JPRB, 0.52875598E-09_JPRB, 0.52732324E-09_JPRB, 0.52566945E-09_JPRB, 0.52386667E-09_JPRB, &
  & 0.52194743E-09_JPRB, 0.51989862E-09_JPRB, 0.51778309E-09_JPRB, 0.51570381E-09_JPRB, 0.51397259E-09_JPRB, 0.51257110E-09_JPRB, &
  & 0.51147681E-09_JPRB, 0.51052773E-09_JPRB, 0.50961685E-09_JPRB, 0.50867432E-09_JPRB, 0.50764337E-09_JPRB, 0.50654136E-09_JPRB, &
  & 0.50540977E-09_JPRB, 0.50423998E-09_JPRB, 0.50288468E-09_JPRB, 0.50045018E-09_JPRB /)

RGHG6(:,47, 1) = (/ &
  & 0.50137361E-09_JPRB, 0.50259197E-09_JPRB, 0.50343718E-09_JPRB, 0.50438898E-09_JPRB, 0.50564680E-09_JPRB, 0.50711324E-09_JPRB, &
  & 0.50853338E-09_JPRB, 0.50980298E-09_JPRB, 0.51087162E-09_JPRB, 0.51177074E-09_JPRB, 0.51254567E-09_JPRB, 0.51330457E-09_JPRB, &
  & 0.51411625E-09_JPRB, 0.51522525E-09_JPRB, 0.51677179E-09_JPRB, 0.51921323E-09_JPRB, 0.52218840E-09_JPRB, 0.52499222E-09_JPRB, &
  & 0.52713905E-09_JPRB, 0.52871413E-09_JPRB, 0.52987531E-09_JPRB, 0.53076638E-09_JPRB, 0.53145438E-09_JPRB, 0.53202392E-09_JPRB, &
  & 0.53249699E-09_JPRB, 0.53291199E-09_JPRB, 0.53328603E-09_JPRB, 0.53361615E-09_JPRB, 0.53388949E-09_JPRB, 0.53409543E-09_JPRB, &
  & 0.53421995E-09_JPRB, 0.53426830E-09_JPRB, 0.53424004E-09_JPRB, 0.53413596E-09_JPRB, 0.53397026E-09_JPRB, 0.53376864E-09_JPRB, &
  & 0.53354787E-09_JPRB, 0.53330917E-09_JPRB, 0.53304317E-09_JPRB, 0.53273186E-09_JPRB, 0.53235222E-09_JPRB, 0.53187543E-09_JPRB, &
  & 0.53126947E-09_JPRB, 0.53049720E-09_JPRB, 0.52951926E-09_JPRB, 0.52831717E-09_JPRB, 0.52690202E-09_JPRB, 0.52534455E-09_JPRB, &
  & 0.52366361E-09_JPRB, 0.52187560E-09_JPRB, 0.51998461E-09_JPRB, 0.51823551E-09_JPRB, 0.51672056E-09_JPRB, 0.51559534E-09_JPRB, &
  & 0.51468230E-09_JPRB, 0.51390364E-09_JPRB, 0.51315691E-09_JPRB, 0.51237131E-09_JPRB, 0.51153098E-09_JPRB, 0.51064009E-09_JPRB, &
  & 0.50973592E-09_JPRB, 0.50880533E-09_JPRB, 0.50772464E-09_JPRB, 0.50575510E-09_JPRB /)

RGHG6(:,48, 1) = (/ &
  & 0.50630750E-09_JPRB, 0.50751597E-09_JPRB, 0.50831239E-09_JPRB, 0.50925081E-09_JPRB, 0.51046012E-09_JPRB, 0.51188159E-09_JPRB, &
  & 0.51329024E-09_JPRB, 0.51451321E-09_JPRB, 0.51552185E-09_JPRB, 0.51631288E-09_JPRB, 0.51697846E-09_JPRB, 0.51758209E-09_JPRB, &
  & 0.51825366E-09_JPRB, 0.51907367E-09_JPRB, 0.52032195E-09_JPRB, 0.52207555E-09_JPRB, 0.52434007E-09_JPRB, 0.52642835E-09_JPRB, &
  & 0.52807619E-09_JPRB, 0.52933208E-09_JPRB, 0.53030680E-09_JPRB, 0.53108573E-09_JPRB, 0.53172278E-09_JPRB, 0.53225779E-09_JPRB, &
  & 0.53271920E-09_JPRB, 0.53313198E-09_JPRB, 0.53349813E-09_JPRB, 0.53382126E-09_JPRB, 0.53408034E-09_JPRB, 0.53426424E-09_JPRB, &
  & 0.53437094E-09_JPRB, 0.53440419E-09_JPRB, 0.53436611E-09_JPRB, 0.53425708E-09_JPRB, 0.53409194E-09_JPRB, 0.53389437E-09_JPRB, &
  & 0.53368149E-09_JPRB, 0.53345478E-09_JPRB, 0.53320515E-09_JPRB, 0.53291849E-09_JPRB, 0.53257510E-09_JPRB, 0.53215482E-09_JPRB, &
  & 0.53163651E-09_JPRB, 0.53099575E-09_JPRB, 0.53020949E-09_JPRB, 0.52924420E-09_JPRB, 0.52810994E-09_JPRB, 0.52681670E-09_JPRB, &
  & 0.52541388E-09_JPRB, 0.52388033E-09_JPRB, 0.52229382E-09_JPRB, 0.52076632E-09_JPRB, 0.51956267E-09_JPRB, 0.51862237E-09_JPRB, &
  & 0.51789839E-09_JPRB, 0.51726523E-09_JPRB, 0.51665150E-09_JPRB, 0.51601090E-09_JPRB, 0.51531912E-09_JPRB, 0.51460058E-09_JPRB, &
  & 0.51387905E-09_JPRB, 0.51314492E-09_JPRB, 0.51228605E-09_JPRB, 0.51073112E-09_JPRB /)

RGHG6(:,49, 1) = (/ &
  & 0.51093013E-09_JPRB, 0.51208204E-09_JPRB, 0.51288407E-09_JPRB, 0.51378096E-09_JPRB, 0.51497601E-09_JPRB, 0.51638438E-09_JPRB, &
  & 0.51777543E-09_JPRB, 0.51897314E-09_JPRB, 0.51988203E-09_JPRB, 0.52056376E-09_JPRB, 0.52109195E-09_JPRB, 0.52156146E-09_JPRB, &
  & 0.52204352E-09_JPRB, 0.52262911E-09_JPRB, 0.52344112E-09_JPRB, 0.52461946E-09_JPRB, 0.52612070E-09_JPRB, 0.52761084E-09_JPRB, &
  & 0.52884108E-09_JPRB, 0.52983995E-09_JPRB, 0.53066274E-09_JPRB, 0.53135951E-09_JPRB, 0.53195337E-09_JPRB, 0.53247295E-09_JPRB, &
  & 0.53292826E-09_JPRB, 0.53333821E-09_JPRB, 0.53370280E-09_JPRB, 0.53401467E-09_JPRB, 0.53425486E-09_JPRB, 0.53442034E-09_JPRB, &
  & 0.53450822E-09_JPRB, 0.53452737E-09_JPRB, 0.53447891E-09_JPRB, 0.53436489E-09_JPRB, 0.53419857E-09_JPRB, 0.53400417E-09_JPRB, &
  & 0.53379740E-09_JPRB, 0.53357962E-09_JPRB, 0.53334354E-09_JPRB, 0.53307614E-09_JPRB, 0.53276317E-09_JPRB, 0.53239047E-09_JPRB, &
  & 0.53194815E-09_JPRB, 0.53142868E-09_JPRB, 0.53082055E-09_JPRB, 0.53010990E-09_JPRB, 0.52927002E-09_JPRB, 0.52830640E-09_JPRB, &
  & 0.52720650E-09_JPRB, 0.52597887E-09_JPRB, 0.52466670E-09_JPRB, 0.52344756E-09_JPRB, 0.52246552E-09_JPRB, 0.52173216E-09_JPRB, &
  & 0.52115623E-09_JPRB, 0.52064919E-09_JPRB, 0.52014992E-09_JPRB, 0.51962096E-09_JPRB, 0.51905180E-09_JPRB, 0.51846155E-09_JPRB, &
  & 0.51787896E-09_JPRB, 0.51728677E-09_JPRB, 0.51660187E-09_JPRB, 0.51535587E-09_JPRB /)

RGHG6(:,50, 1) = (/ &
  & 0.51518578E-09_JPRB, 0.51633686E-09_JPRB, 0.51708604E-09_JPRB, 0.51799692E-09_JPRB, 0.51916849E-09_JPRB, 0.52059912E-09_JPRB, &
  & 0.52197374E-09_JPRB, 0.52308402E-09_JPRB, 0.52385385E-09_JPRB, 0.52436722E-09_JPRB, 0.52473720E-09_JPRB, 0.52504223E-09_JPRB, &
  & 0.52532001E-09_JPRB, 0.52565818E-09_JPRB, 0.52606142E-09_JPRB, 0.52671045E-09_JPRB, 0.52758259E-09_JPRB, 0.52856930E-09_JPRB, &
  & 0.52946891E-09_JPRB, 0.53026095E-09_JPRB, 0.53096549E-09_JPRB, 0.53159488E-09_JPRB, 0.53216254E-09_JPRB, 0.53267041E-09_JPRB, &
  & 0.53312804E-09_JPRB, 0.53353694E-09_JPRB, 0.53389582E-09_JPRB, 0.53419347E-09_JPRB, 0.53441629E-09_JPRB, 0.53456140E-09_JPRB, &
  & 0.53463289E-09_JPRB, 0.53463850E-09_JPRB, 0.53457999E-09_JPRB, 0.53446031E-09_JPRB, 0.53429305E-09_JPRB, 0.53410087E-09_JPRB, &
  & 0.53389870E-09_JPRB, 0.53368820E-09_JPRB, 0.53346244E-09_JPRB, 0.53321098E-09_JPRB, 0.53292226E-09_JPRB, 0.53258969E-09_JPRB, &
  & 0.53221377E-09_JPRB, 0.53180171E-09_JPRB, 0.53136051E-09_JPRB, 0.53088745E-09_JPRB, 0.53035565E-09_JPRB, 0.52973664E-09_JPRB, &
  & 0.52898952E-09_JPRB, 0.52811283E-09_JPRB, 0.52713667E-09_JPRB, 0.52622773E-09_JPRB, 0.52548343E-09_JPRB, 0.52494137E-09_JPRB, &
  & 0.52449362E-09_JPRB, 0.52409688E-09_JPRB, 0.52369897E-09_JPRB, 0.52326088E-09_JPRB, 0.52278915E-09_JPRB, 0.52229782E-09_JPRB, &
  & 0.52181026E-09_JPRB, 0.52132060E-09_JPRB, 0.52074428E-09_JPRB, 0.51970411E-09_JPRB /)

RGHG6(:,51, 1) = (/ &
  & 0.51909876E-09_JPRB, 0.52013815E-09_JPRB, 0.52092747E-09_JPRB, 0.52177918E-09_JPRB, 0.52299237E-09_JPRB, 0.52436966E-09_JPRB, &
  & 0.52567251E-09_JPRB, 0.52655436E-09_JPRB, 0.52707838E-09_JPRB, 0.52738258E-09_JPRB, 0.52757398E-09_JPRB, 0.52770521E-09_JPRB, &
  & 0.52782134E-09_JPRB, 0.52791993E-09_JPRB, 0.52807575E-09_JPRB, 0.52829585E-09_JPRB, 0.52874743E-09_JPRB, 0.52934518E-09_JPRB, &
  & 0.52999172E-09_JPRB, 0.53062266E-09_JPRB, 0.53122873E-09_JPRB, 0.53180838E-09_JPRB, 0.53235405E-09_JPRB, 0.53285959E-09_JPRB, &
  & 0.53331667E-09_JPRB, 0.53372706E-09_JPRB, 0.53407456E-09_JPRB, 0.53435822E-09_JPRB, 0.53456084E-09_JPRB, 0.53468924E-09_JPRB, &
  & 0.53474575E-09_JPRB, 0.53473864E-09_JPRB, 0.53467059E-09_JPRB, 0.53454530E-09_JPRB, 0.53437693E-09_JPRB, 0.53418658E-09_JPRB, &
  & 0.53398841E-09_JPRB, 0.53378363E-09_JPRB, 0.53356625E-09_JPRB, 0.53332722E-09_JPRB, 0.53305893E-09_JPRB, 0.53276028E-09_JPRB, &
  & 0.53244281E-09_JPRB, 0.53212518E-09_JPRB, 0.53183158E-09_JPRB, 0.53155935E-09_JPRB, 0.53129195E-09_JPRB, 0.53097693E-09_JPRB, &
  & 0.53058347E-09_JPRB, 0.53007337E-09_JPRB, 0.52949189E-09_JPRB, 0.52890714E-09_JPRB, 0.52844634E-09_JPRB, 0.52806476E-09_JPRB, &
  & 0.52776439E-09_JPRB, 0.52747762E-09_JPRB, 0.52717331E-09_JPRB, 0.52684096E-09_JPRB, 0.52645793E-09_JPRB, 0.52605553E-09_JPRB, &
  & 0.52565463E-09_JPRB, 0.52523552E-09_JPRB, 0.52474231E-09_JPRB, 0.52382737E-09_JPRB /)

RGHG6(:,52, 1) = (/ &
  & 0.52246846E-09_JPRB, 0.52354487E-09_JPRB, 0.52419968E-09_JPRB, 0.52510407E-09_JPRB, 0.52617921E-09_JPRB, 0.52746429E-09_JPRB, &
  & 0.52841187E-09_JPRB, 0.52896720E-09_JPRB, 0.52923083E-09_JPRB, 0.52935845E-09_JPRB, 0.52942056E-09_JPRB, 0.52945170E-09_JPRB, &
  & 0.52946098E-09_JPRB, 0.52945770E-09_JPRB, 0.52945098E-09_JPRB, 0.52948351E-09_JPRB, 0.52963289E-09_JPRB, 0.52997862E-09_JPRB, &
  & 0.53043364E-09_JPRB, 0.53094029E-09_JPRB, 0.53147170E-09_JPRB, 0.53200888E-09_JPRB, 0.53253757E-09_JPRB, 0.53303900E-09_JPRB, &
  & 0.53349863E-09_JPRB, 0.53390070E-09_JPRB, 0.53424060E-09_JPRB, 0.53450483E-09_JPRB, 0.53469179E-09_JPRB, 0.53480409E-09_JPRB, &
  & 0.53484778E-09_JPRB, 0.53482901E-09_JPRB, 0.53475174E-09_JPRB, 0.53462118E-09_JPRB, 0.53445165E-09_JPRB, 0.53426324E-09_JPRB, &
  & 0.53406840E-09_JPRB, 0.53386878E-09_JPRB, 0.53365834E-09_JPRB, 0.53342991E-09_JPRB, 0.53317856E-09_JPRB, 0.53291038E-09_JPRB, &
  & 0.53264382E-09_JPRB, 0.53241167E-09_JPRB, 0.53223531E-09_JPRB, 0.53211924E-09_JPRB, 0.53202798E-09_JPRB, 0.53192645E-09_JPRB, &
  & 0.53177340E-09_JPRB, 0.53155702E-09_JPRB, 0.53128058E-09_JPRB, 0.53100224E-09_JPRB, 0.53074667E-09_JPRB, 0.53055155E-09_JPRB, &
  & 0.53037025E-09_JPRB, 0.53019711E-09_JPRB, 0.53001037E-09_JPRB, 0.52978044E-09_JPRB, 0.52952187E-09_JPRB, 0.52923516E-09_JPRB, &
  & 0.52893845E-09_JPRB, 0.52862847E-09_JPRB, 0.52823806E-09_JPRB, 0.52748633E-09_JPRB /)

RGHG6(:,53, 1) = (/ &
  & 0.52539978E-09_JPRB, 0.52625315E-09_JPRB, 0.52698929E-09_JPRB, 0.52767957E-09_JPRB, 0.52866733E-09_JPRB, 0.52953364E-09_JPRB, &
  & 0.53012622E-09_JPRB, 0.53038263E-09_JPRB, 0.53048577E-09_JPRB, 0.53052229E-09_JPRB, 0.53052884E-09_JPRB, 0.53051868E-09_JPRB, &
  & 0.53049221E-09_JPRB, 0.53045623E-09_JPRB, 0.53038801E-09_JPRB, 0.53033306E-09_JPRB, 0.53033705E-09_JPRB, 0.53049903E-09_JPRB, &
  & 0.53081683E-09_JPRB, 0.53123039E-09_JPRB, 0.53170063E-09_JPRB, 0.53220522E-09_JPRB, 0.53271737E-09_JPRB, 0.53321236E-09_JPRB, &
  & 0.53366522E-09_JPRB, 0.53406279E-09_JPRB, 0.53438759E-09_JPRB, 0.53463844E-09_JPRB, 0.53480892E-09_JPRB, 0.53490801E-09_JPRB, &
  & 0.53494004E-09_JPRB, 0.53491078E-09_JPRB, 0.53482485E-09_JPRB, 0.53468929E-09_JPRB, 0.53451893E-09_JPRB, 0.53433219E-09_JPRB, &
  & 0.53414090E-09_JPRB, 0.53394583E-09_JPRB, 0.53374194E-09_JPRB, 0.53352278E-09_JPRB, 0.53328758E-09_JPRB, 0.53304622E-09_JPRB, &
  & 0.53282778E-09_JPRB, 0.53266525E-09_JPRB, 0.53258309E-09_JPRB, 0.53256644E-09_JPRB, 0.53257998E-09_JPRB, 0.53258487E-09_JPRB, &
  & 0.53255744E-09_JPRB, 0.53248622E-09_JPRB, 0.53237703E-09_JPRB, 0.53224980E-09_JPRB, 0.53213789E-09_JPRB, 0.53203419E-09_JPRB, &
  & 0.53194549E-09_JPRB, 0.53185295E-09_JPRB, 0.53174504E-09_JPRB, 0.53162008E-09_JPRB, 0.53146398E-09_JPRB, 0.53129506E-09_JPRB, &
  & 0.53112165E-09_JPRB, 0.53093557E-09_JPRB, 0.53070826E-09_JPRB, 0.53021898E-09_JPRB /)

RGHG6(:,54, 1) = (/ &
  & 0.52762844E-09_JPRB, 0.52852778E-09_JPRB, 0.52901017E-09_JPRB, 0.52966759E-09_JPRB, 0.53027654E-09_JPRB, 0.53083543E-09_JPRB, &
  & 0.53110477E-09_JPRB, 0.53120808E-09_JPRB, 0.53123506E-09_JPRB, 0.53123494E-09_JPRB, 0.53122251E-09_JPRB, 0.53120064E-09_JPRB, &
  & 0.53117216E-09_JPRB, 0.53112093E-09_JPRB, 0.53106397E-09_JPRB, 0.53095844E-09_JPRB, 0.53089366E-09_JPRB, 0.53094301E-09_JPRB, &
  & 0.53115795E-09_JPRB, 0.53149879E-09_JPRB, 0.53192439E-09_JPRB, 0.53239907E-09_JPRB, 0.53289351E-09_JPRB, 0.53337695E-09_JPRB, &
  & 0.53382193E-09_JPRB, 0.53420790E-09_JPRB, 0.53452281E-09_JPRB, 0.53475802E-09_JPRB, 0.53491617E-09_JPRB, 0.53500265E-09_JPRB, &
  & 0.53502391E-09_JPRB, 0.53498506E-09_JPRB, 0.53489152E-09_JPRB, 0.53475130E-09_JPRB, 0.53458021E-09_JPRB, 0.53439519E-09_JPRB, &
  & 0.53420740E-09_JPRB, 0.53401661E-09_JPRB, 0.53381910E-09_JPRB, 0.53360960E-09_JPRB, 0.53338967E-09_JPRB, 0.53317550E-09_JPRB, &
  & 0.53299820E-09_JPRB, 0.53289578E-09_JPRB, 0.53287907E-09_JPRB, 0.53292337E-09_JPRB, 0.53298871E-09_JPRB, 0.53304106E-09_JPRB, &
  & 0.53306398E-09_JPRB, 0.53305255E-09_JPRB, 0.53301141E-09_JPRB, 0.53295601E-09_JPRB, 0.53289817E-09_JPRB, 0.53284926E-09_JPRB, &
  & 0.53280041E-09_JPRB, 0.53275012E-09_JPRB, 0.53269300E-09_JPRB, 0.53261884E-09_JPRB, 0.53253407E-09_JPRB, 0.53243998E-09_JPRB, &
  & 0.53234811E-09_JPRB, 0.53226329E-09_JPRB, 0.53217852E-09_JPRB, 0.53206550E-09_JPRB /)

RGHG6(:,55, 1) = (/ &
  & 0.52942639E-09_JPRB, 0.53007165E-09_JPRB, 0.53056626E-09_JPRB, 0.53093702E-09_JPRB, 0.53134086E-09_JPRB, 0.53159999E-09_JPRB, &
  & 0.53171234E-09_JPRB, 0.53173604E-09_JPRB, 0.53173199E-09_JPRB, 0.53171889E-09_JPRB, 0.53170174E-09_JPRB, 0.53168087E-09_JPRB, &
  & 0.53165111E-09_JPRB, 0.53161558E-09_JPRB, 0.53154470E-09_JPRB, 0.53146626E-09_JPRB, 0.53135091E-09_JPRB, 0.53132859E-09_JPRB, &
  & 0.53146837E-09_JPRB, 0.53175520E-09_JPRB, 0.53214155E-09_JPRB, 0.53259031E-09_JPRB, 0.53306570E-09_JPRB, 0.53353399E-09_JPRB, &
  & 0.53396715E-09_JPRB, 0.53434346E-09_JPRB, 0.53464538E-09_JPRB, 0.53486915E-09_JPRB, 0.53501398E-09_JPRB, 0.53508953E-09_JPRB, &
  & 0.53510085E-09_JPRB, 0.53505333E-09_JPRB, 0.53495319E-09_JPRB, 0.53480936E-09_JPRB, 0.53463717E-09_JPRB, 0.53445448E-09_JPRB, &
  & 0.53426924E-09_JPRB, 0.53408383E-09_JPRB, 0.53389249E-09_JPRB, 0.53369309E-09_JPRB, 0.53348964E-09_JPRB, 0.53330035E-09_JPRB, &
  & 0.53316135E-09_JPRB, 0.53310417E-09_JPRB, 0.53313232E-09_JPRB, 0.53321358E-09_JPRB, 0.53330174E-09_JPRB, 0.53337207E-09_JPRB, &
  & 0.53341315E-09_JPRB, 0.53342392E-09_JPRB, 0.53341054E-09_JPRB, 0.53338367E-09_JPRB, 0.53335514E-09_JPRB, 0.53332638E-09_JPRB, &
  & 0.53329974E-09_JPRB, 0.53327071E-09_JPRB, 0.53323507E-09_JPRB, 0.53319249E-09_JPRB, 0.53313831E-09_JPRB, 0.53308025E-09_JPRB, &
  & 0.53302207E-09_JPRB, 0.53296451E-09_JPRB, 0.53290167E-09_JPRB, 0.53279053E-09_JPRB /)

RGHG6(:,56, 1) = (/ &
  & 0.53067228E-09_JPRB, 0.53126259E-09_JPRB, 0.53154520E-09_JPRB, 0.53180393E-09_JPRB, 0.53199550E-09_JPRB, 0.53210575E-09_JPRB, &
  & 0.53212773E-09_JPRB, 0.53211763E-09_JPRB, 0.53210159E-09_JPRB, 0.53208521E-09_JPRB, 0.53206861E-09_JPRB, 0.53204957E-09_JPRB, &
  & 0.53202776E-09_JPRB, 0.53199156E-09_JPRB, 0.53194749E-09_JPRB, 0.53185223E-09_JPRB, 0.53174937E-09_JPRB, 0.53167509E-09_JPRB, &
  & 0.53175997E-09_JPRB, 0.53200122E-09_JPRB, 0.53235516E-09_JPRB, 0.53277832E-09_JPRB, 0.53323251E-09_JPRB, 0.53368543E-09_JPRB, &
  & 0.53410532E-09_JPRB, 0.53446925E-09_JPRB, 0.53476101E-09_JPRB, 0.53497118E-09_JPRB, 0.53510529E-09_JPRB, 0.53517002E-09_JPRB, &
  & 0.53517235E-09_JPRB, 0.53511745E-09_JPRB, 0.53501137E-09_JPRB, 0.53486482E-09_JPRB, 0.53469246E-09_JPRB, 0.53451110E-09_JPRB, &
  & 0.53433025E-09_JPRB, 0.53414861E-09_JPRB, 0.53396504E-09_JPRB, 0.53377602E-09_JPRB, 0.53358912E-09_JPRB, 0.53342480E-09_JPRB, &
  & 0.53331700E-09_JPRB, 0.53329491E-09_JPRB, 0.53335469E-09_JPRB, 0.53345373E-09_JPRB, 0.53355426E-09_JPRB, 0.53362920E-09_JPRB, &
  & 0.53367444E-09_JPRB, 0.53369231E-09_JPRB, 0.53368976E-09_JPRB, 0.53367621E-09_JPRB, 0.53365884E-09_JPRB, 0.53364246E-09_JPRB, &
  & 0.53362526E-09_JPRB, 0.53360644E-09_JPRB, 0.53358440E-09_JPRB, 0.53355509E-09_JPRB, 0.53352051E-09_JPRB, 0.53348104E-09_JPRB, &
  & 0.53344185E-09_JPRB, 0.53340415E-09_JPRB, 0.53336435E-09_JPRB, 0.53330279E-09_JPRB /)

RGHG6(:,57, 1) = (/ &
  & 0.53159432E-09_JPRB, 0.53202054E-09_JPRB, 0.53222898E-09_JPRB, 0.53236188E-09_JPRB, 0.53244409E-09_JPRB, 0.53246513E-09_JPRB, &
  & 0.53244631E-09_JPRB, 0.53242305E-09_JPRB, 0.53240323E-09_JPRB, 0.53238702E-09_JPRB, 0.53237215E-09_JPRB, 0.53235683E-09_JPRB, &
  & 0.53233701E-09_JPRB, 0.53231264E-09_JPRB, 0.53226529E-09_JPRB, 0.53220262E-09_JPRB, 0.53208193E-09_JPRB, 0.53199173E-09_JPRB, &
  & 0.53203636E-09_JPRB, 0.53224214E-09_JPRB, 0.53256533E-09_JPRB, 0.53296284E-09_JPRB, 0.53339727E-09_JPRB, 0.53383203E-09_JPRB, &
  & 0.53423815E-09_JPRB, 0.53458982E-09_JPRB, 0.53486787E-09_JPRB, 0.53506755E-09_JPRB, 0.53519011E-09_JPRB, 0.53524546E-09_JPRB, &
  & 0.53523969E-09_JPRB, 0.53517862E-09_JPRB, 0.53506827E-09_JPRB, 0.53491944E-09_JPRB, 0.53474758E-09_JPRB, 0.53456883E-09_JPRB, &
  & 0.53439031E-09_JPRB, 0.53421478E-09_JPRB, 0.53403781E-09_JPRB, 0.53386040E-09_JPRB, 0.53369031E-09_JPRB, 0.53354837E-09_JPRB, &
  & 0.53346788E-09_JPRB, 0.53347193E-09_JPRB, 0.53354948E-09_JPRB, 0.53366322E-09_JPRB, 0.53376564E-09_JPRB, 0.53384086E-09_JPRB, &
  & 0.53388477E-09_JPRB, 0.53390325E-09_JPRB, 0.53390437E-09_JPRB, 0.53389615E-09_JPRB, 0.53388527E-09_JPRB, 0.53387350E-09_JPRB, &
  & 0.53386190E-09_JPRB, 0.53384891E-09_JPRB, 0.53383259E-09_JPRB, 0.53381272E-09_JPRB, 0.53378690E-09_JPRB, 0.53375848E-09_JPRB, &
  & 0.53372895E-09_JPRB, 0.53369953E-09_JPRB, 0.53366661E-09_JPRB, 0.53360893E-09_JPRB /)

RGHG6(:,58, 1) = (/ &
  & 0.53225496E-09_JPRB, 0.53256488E-09_JPRB, 0.53269128E-09_JPRB, 0.53275301E-09_JPRB, 0.53277305E-09_JPRB, 0.53275034E-09_JPRB, &
  & 0.53271543E-09_JPRB, 0.53268639E-09_JPRB, 0.53266680E-09_JPRB, 0.53265192E-09_JPRB, 0.53263921E-09_JPRB, 0.53262600E-09_JPRB, &
  & 0.53261107E-09_JPRB, 0.53258747E-09_JPRB, 0.53255539E-09_JPRB, 0.53248594E-09_JPRB, 0.53238947E-09_JPRB, 0.53228200E-09_JPRB, &
  & 0.53230159E-09_JPRB, 0.53247812E-09_JPRB, 0.53277366E-09_JPRB, 0.53314719E-09_JPRB, 0.53355981E-09_JPRB, 0.53397758E-09_JPRB, &
  & 0.53436749E-09_JPRB, 0.53470395E-09_JPRB, 0.53497012E-09_JPRB, 0.53515664E-09_JPRB, 0.53526983E-09_JPRB, 0.53531646E-09_JPRB, &
  & 0.53530408E-09_JPRB, 0.53523819E-09_JPRB, 0.53512472E-09_JPRB, 0.53497506E-09_JPRB, 0.53480426E-09_JPRB, 0.53462740E-09_JPRB, &
  & 0.53445348E-09_JPRB, 0.53428256E-09_JPRB, 0.53411370E-09_JPRB, 0.53394755E-09_JPRB, 0.53379351E-09_JPRB, 0.53367266E-09_JPRB, &
  & 0.53361399E-09_JPRB, 0.53363630E-09_JPRB, 0.53372873E-09_JPRB, 0.53384536E-09_JPRB, 0.53395138E-09_JPRB, 0.53402305E-09_JPRB, &
  & 0.53406346E-09_JPRB, 0.53407978E-09_JPRB, 0.53408122E-09_JPRB, 0.53407501E-09_JPRB, 0.53406612E-09_JPRB, 0.53405724E-09_JPRB, &
  & 0.53404792E-09_JPRB, 0.53403759E-09_JPRB, 0.53402538E-09_JPRB, 0.53400906E-09_JPRB, 0.53398963E-09_JPRB, 0.53396676E-09_JPRB, &
  & 0.53394345E-09_JPRB, 0.53391969E-09_JPRB, 0.53389321E-09_JPRB, 0.53384885E-09_JPRB /)

RGHG6(:,59, 1) = (/ &
  & 0.53274796E-09_JPRB, 0.53297211E-09_JPRB, 0.53303140E-09_JPRB, 0.53305188E-09_JPRB, 0.53303789E-09_JPRB, 0.53299654E-09_JPRB, &
  & 0.53295368E-09_JPRB, 0.53292498E-09_JPRB, 0.53290594E-09_JPRB, 0.53289273E-09_JPRB, 0.53288185E-09_JPRB, 0.53287130E-09_JPRB, &
  & 0.53285798E-09_JPRB, 0.53284044E-09_JPRB, 0.53280724E-09_JPRB, 0.53275545E-09_JPRB, 0.53265348E-09_JPRB, 0.53255239E-09_JPRB, &
  & 0.53255761E-09_JPRB, 0.53271093E-09_JPRB, 0.53298133E-09_JPRB, 0.53333127E-09_JPRB, 0.53372307E-09_JPRB, 0.53412141E-09_JPRB, &
  & 0.53449389E-09_JPRB, 0.53481491E-09_JPRB, 0.53506533E-09_JPRB, 0.53524130E-09_JPRB, 0.53534427E-09_JPRB, 0.53538363E-09_JPRB, &
  & 0.53536603E-09_JPRB, 0.53529681E-09_JPRB, 0.53518190E-09_JPRB, 0.53503213E-09_JPRB, 0.53486326E-09_JPRB, 0.53468957E-09_JPRB, &
  & 0.53451954E-09_JPRB, 0.53435434E-09_JPRB, 0.53419325E-09_JPRB, 0.53403781E-09_JPRB, 0.53389942E-09_JPRB, 0.53379662E-09_JPRB, &
  & 0.53375637E-09_JPRB, 0.53379279E-09_JPRB, 0.53389065E-09_JPRB, 0.53401328E-09_JPRB, 0.53411586E-09_JPRB, 0.53418525E-09_JPRB, &
  & 0.53422117E-09_JPRB, 0.53423455E-09_JPRB, 0.53423466E-09_JPRB, 0.53422844E-09_JPRB, 0.53422056E-09_JPRB, 0.53421217E-09_JPRB, &
  & 0.53420396E-09_JPRB, 0.53419502E-09_JPRB, 0.53418392E-09_JPRB, 0.53417065E-09_JPRB, 0.53415361E-09_JPRB, 0.53413474E-09_JPRB, &
  & 0.53411464E-09_JPRB, 0.53409416E-09_JPRB, 0.53407090E-09_JPRB, 0.53402943E-09_JPRB /)

RGHG6(:,60, 1) = (/ &
  & 0.53325799E-09_JPRB, 0.53329402E-09_JPRB, 0.53330507E-09_JPRB, 0.53329680E-09_JPRB, 0.53326565E-09_JPRB, 0.53321914E-09_JPRB, &
  & 0.53317584E-09_JPRB, 0.53314642E-09_JPRB, 0.53312887E-09_JPRB, 0.53311722E-09_JPRB, 0.53310834E-09_JPRB, 0.53309968E-09_JPRB, &
  & 0.53308952E-09_JPRB, 0.53307314E-09_JPRB, 0.53304711E-09_JPRB, 0.53299226E-09_JPRB, 0.53290239E-09_JPRB, 0.53280541E-09_JPRB, &
  & 0.53280569E-09_JPRB, 0.53294108E-09_JPRB, 0.53318905E-09_JPRB, 0.53351645E-09_JPRB, 0.53388688E-09_JPRB, 0.53426474E-09_JPRB, &
  & 0.53461852E-09_JPRB, 0.53492105E-09_JPRB, 0.53515703E-09_JPRB, 0.53532001E-09_JPRB, 0.53541444E-09_JPRB, 0.53544763E-09_JPRB, &
  & 0.53542609E-09_JPRB, 0.53535532E-09_JPRB, 0.53524052E-09_JPRB, 0.53509219E-09_JPRB, 0.53492594E-09_JPRB, 0.53475591E-09_JPRB, &
  & 0.53459004E-09_JPRB, 0.53443044E-09_JPRB, 0.53427640E-09_JPRB, 0.53413191E-09_JPRB, 0.53400706E-09_JPRB, 0.53392085E-09_JPRB, &
  & 0.53389543E-09_JPRB, 0.53394122E-09_JPRB, 0.53404448E-09_JPRB, 0.53416449E-09_JPRB, 0.53426769E-09_JPRB, 0.53433269E-09_JPRB, &
  & 0.53436522E-09_JPRB, 0.53437488E-09_JPRB, 0.53437277E-09_JPRB, 0.53436533E-09_JPRB, 0.53435661E-09_JPRB, 0.53434834E-09_JPRB, &
  & 0.53434002E-09_JPRB, 0.53433108E-09_JPRB, 0.53432103E-09_JPRB, 0.53430815E-09_JPRB, 0.53429317E-09_JPRB, 0.53427562E-09_JPRB, &
  & 0.53425764E-09_JPRB, 0.53423921E-09_JPRB, 0.53421845E-09_JPRB, 0.53418348E-09_JPRB /)

RGHG6(:,61, 1) = (/ &
  & 0.53349469E-09_JPRB, 0.53352378E-09_JPRB, 0.53352256E-09_JPRB, 0.53350557E-09_JPRB, 0.53347388E-09_JPRB, 0.53342658E-09_JPRB, &
  & 0.53338389E-09_JPRB, 0.53335575E-09_JPRB, 0.53333898E-09_JPRB, 0.53332927E-09_JPRB, 0.53332261E-09_JPRB, 0.53331667E-09_JPRB, &
  & 0.53330879E-09_JPRB, 0.53329624E-09_JPRB, 0.53327021E-09_JPRB, 0.53322091E-09_JPRB, 0.53313309E-09_JPRB, 0.53304750E-09_JPRB, &
  & 0.53304783E-09_JPRB, 0.53316918E-09_JPRB, 0.53339722E-09_JPRB, 0.53370297E-09_JPRB, 0.53405114E-09_JPRB, 0.53440807E-09_JPRB, &
  & 0.53474047E-09_JPRB, 0.53502458E-09_JPRB, 0.53524357E-09_JPRB, 0.53539490E-09_JPRB, 0.53548022E-09_JPRB, 0.53550847E-09_JPRB, &
  & 0.53548466E-09_JPRB, 0.53541382E-09_JPRB, 0.53530080E-09_JPRB, 0.53515525E-09_JPRB, 0.53499283E-09_JPRB, 0.53482641E-09_JPRB, &
  & 0.53466565E-09_JPRB, 0.53451060E-09_JPRB, 0.53436411E-09_JPRB, 0.53422872E-09_JPRB, 0.53411692E-09_JPRB, 0.53404486E-09_JPRB, &
  & 0.53403171E-09_JPRB, 0.53408483E-09_JPRB, 0.53418825E-09_JPRB, 0.53430793E-09_JPRB, 0.53440691E-09_JPRB, 0.53446991E-09_JPRB, &
  & 0.53449883E-09_JPRB, 0.53450538E-09_JPRB, 0.53450050E-09_JPRB, 0.53449101E-09_JPRB, 0.53448118E-09_JPRB, 0.53447186E-09_JPRB, &
  & 0.53446292E-09_JPRB, 0.53445365E-09_JPRB, 0.53444271E-09_JPRB, 0.53443017E-09_JPRB, 0.53441479E-09_JPRB, 0.53439808E-09_JPRB, &
  & 0.53438054E-09_JPRB, 0.53436283E-09_JPRB, 0.53434290E-09_JPRB, 0.53430810E-09_JPRB /)

RGHG6(:,62, 1) = (/ &
  & 0.53370064E-09_JPRB, 0.53371940E-09_JPRB, 0.53371441E-09_JPRB, 0.53369709E-09_JPRB, 0.53366506E-09_JPRB, 0.53362348E-09_JPRB, &
  & 0.53358240E-09_JPRB, 0.53355409E-09_JPRB, 0.53353844E-09_JPRB, 0.53353066E-09_JPRB, 0.53352711E-09_JPRB, 0.53352478E-09_JPRB, &
  & 0.53352106E-09_JPRB, 0.53351112E-09_JPRB, 0.53348814E-09_JPRB, 0.53343796E-09_JPRB, 0.53335619E-09_JPRB, 0.53328331E-09_JPRB, &
  & 0.53328553E-09_JPRB, 0.53339583E-09_JPRB, 0.53360605E-09_JPRB, 0.53389049E-09_JPRB, 0.53421673E-09_JPRB, 0.53455035E-09_JPRB, &
  & 0.53486104E-09_JPRB, 0.53512450E-09_JPRB, 0.53532712E-09_JPRB, 0.53546534E-09_JPRB, 0.53554261E-09_JPRB, 0.53556637E-09_JPRB, &
  & 0.53554172E-09_JPRB, 0.53547256E-09_JPRB, 0.53536298E-09_JPRB, 0.53522187E-09_JPRB, 0.53506355E-09_JPRB, 0.53490218E-09_JPRB, &
  & 0.53474503E-09_JPRB, 0.53459598E-09_JPRB, 0.53445526E-09_JPRB, 0.53432941E-09_JPRB, 0.53422855E-09_JPRB, 0.53416882E-09_JPRB, &
  & 0.53416582E-09_JPRB, 0.53422400E-09_JPRB, 0.53432681E-09_JPRB, 0.53444205E-09_JPRB, 0.53453897E-09_JPRB, 0.53459903E-09_JPRB, &
  & 0.53462562E-09_JPRB, 0.53462912E-09_JPRB, 0.53462113E-09_JPRB, 0.53460919E-09_JPRB, 0.53459720E-09_JPRB, 0.53458638E-09_JPRB, &
  & 0.53457616E-09_JPRB, 0.53456545E-09_JPRB, 0.53455396E-09_JPRB, 0.53454008E-09_JPRB, 0.53452442E-09_JPRB, 0.53450683E-09_JPRB, &
  & 0.53448912E-09_JPRB, 0.53447125E-09_JPRB, 0.53445126E-09_JPRB, 0.53441773E-09_JPRB /)

RGHG6(:,63, 1) = (/ &
  & 0.53387950E-09_JPRB, 0.53389698E-09_JPRB, 0.53389154E-09_JPRB, 0.53387494E-09_JPRB, 0.53384802E-09_JPRB, 0.53381005E-09_JPRB, &
  & 0.53377214E-09_JPRB, 0.53374399E-09_JPRB, 0.53372873E-09_JPRB, 0.53372329E-09_JPRB, 0.53372384E-09_JPRB, 0.53372695E-09_JPRB, &
  & 0.53372839E-09_JPRB, 0.53372240E-09_JPRB, 0.53369970E-09_JPRB, 0.53365051E-09_JPRB, 0.53357674E-09_JPRB, 0.53351523E-09_JPRB, &
  & 0.53352006E-09_JPRB, 0.53362126E-09_JPRB, 0.53381499E-09_JPRB, 0.53407928E-09_JPRB, 0.53438182E-09_JPRB, 0.53469235E-09_JPRB, &
  & 0.53497895E-09_JPRB, 0.53522148E-09_JPRB, 0.53540650E-09_JPRB, 0.53553190E-09_JPRB, 0.53560117E-09_JPRB, 0.53562144E-09_JPRB, &
  & 0.53559707E-09_JPRB, 0.53553095E-09_JPRB, 0.53542648E-09_JPRB, 0.53529098E-09_JPRB, 0.53513860E-09_JPRB, 0.53498161E-09_JPRB, &
  & 0.53482996E-09_JPRB, 0.53468502E-09_JPRB, 0.53455113E-09_JPRB, 0.53443305E-09_JPRB, 0.53434207E-09_JPRB, 0.53429289E-09_JPRB, &
  & 0.53429827E-09_JPRB, 0.53435956E-09_JPRB, 0.53446048E-09_JPRB, 0.53457117E-09_JPRB, 0.53466365E-09_JPRB, 0.53472221E-09_JPRB, &
  & 0.53474708E-09_JPRB, 0.53474813E-09_JPRB, 0.53473703E-09_JPRB, 0.53472204E-09_JPRB, 0.53470772E-09_JPRB, 0.53469468E-09_JPRB, &
  & 0.53468252E-09_JPRB, 0.53467031E-09_JPRB, 0.53465649E-09_JPRB, 0.53464133E-09_JPRB, 0.53462357E-09_JPRB, 0.53460492E-09_JPRB, &
  & 0.53458588E-09_JPRB, 0.53456711E-09_JPRB, 0.53454624E-09_JPRB, 0.53451088E-09_JPRB /)

RGHG6(:,64, 1) = (/ &
  & 0.53404481E-09_JPRB, 0.53406196E-09_JPRB, 0.53405802E-09_JPRB, 0.53404425E-09_JPRB, 0.53402055E-09_JPRB, 0.53398830E-09_JPRB, &
  & 0.53395288E-09_JPRB, 0.53392585E-09_JPRB, 0.53391103E-09_JPRB, 0.53390825E-09_JPRB, 0.53391391E-09_JPRB, 0.53392363E-09_JPRB, &
  & 0.53393051E-09_JPRB, 0.53392751E-09_JPRB, 0.53390559E-09_JPRB, 0.53385890E-09_JPRB, 0.53379334E-09_JPRB, 0.53374194E-09_JPRB, &
  & 0.53374960E-09_JPRB, 0.53384380E-09_JPRB, 0.53402260E-09_JPRB, 0.53426608E-09_JPRB, 0.53454574E-09_JPRB, 0.53483024E-09_JPRB, &
  & 0.53509336E-09_JPRB, 0.53531368E-09_JPRB, 0.53548127E-09_JPRB, 0.53559351E-09_JPRB, 0.53565513E-09_JPRB, 0.53567217E-09_JPRB, &
  & 0.53564897E-09_JPRB, 0.53558730E-09_JPRB, 0.53548921E-09_JPRB, 0.53536131E-09_JPRB, 0.53521554E-09_JPRB, 0.53506483E-09_JPRB, &
  & 0.53491783E-09_JPRB, 0.53477839E-09_JPRB, 0.53465010E-09_JPRB, 0.53453952E-09_JPRB, 0.53445720E-09_JPRB, 0.53441679E-09_JPRB, &
  & 0.53442850E-09_JPRB, 0.53449178E-09_JPRB, 0.53458948E-09_JPRB, 0.53469451E-09_JPRB, 0.53478255E-09_JPRB, 0.53483878E-09_JPRB, &
  & 0.53486304E-09_JPRB, 0.53486271E-09_JPRB, 0.53484894E-09_JPRB, 0.53483096E-09_JPRB, 0.53481342E-09_JPRB, 0.53479782E-09_JPRB, &
  & 0.53478316E-09_JPRB, 0.53476823E-09_JPRB, 0.53475263E-09_JPRB, 0.53473459E-09_JPRB, 0.53471499E-09_JPRB, 0.53469396E-09_JPRB, &
  & 0.53467325E-09_JPRB, 0.53465277E-09_JPRB, 0.53463006E-09_JPRB, 0.53459159E-09_JPRB /)

RGHG6(:,65, 1) = (/ &
  & 0.53420079E-09_JPRB, 0.53421895E-09_JPRB, 0.53421678E-09_JPRB, 0.53420551E-09_JPRB, 0.53418586E-09_JPRB, 0.53415750E-09_JPRB, &
  & 0.53412630E-09_JPRB, 0.53410054E-09_JPRB, 0.53408800E-09_JPRB, 0.53408855E-09_JPRB, 0.53409943E-09_JPRB, 0.53411486E-09_JPRB, &
  & 0.53412630E-09_JPRB, 0.53412552E-09_JPRB, 0.53410526E-09_JPRB, 0.53406263E-09_JPRB, 0.53400528E-09_JPRB, 0.53396315E-09_JPRB, &
  & 0.53397364E-09_JPRB, 0.53406157E-09_JPRB, 0.53422616E-09_JPRB, 0.53444932E-09_JPRB, 0.53470411E-09_JPRB, 0.53496341E-09_JPRB, &
  & 0.53520094E-09_JPRB, 0.53539978E-09_JPRB, 0.53554955E-09_JPRB, 0.53564919E-09_JPRB, 0.53570354E-09_JPRB, 0.53571808E-09_JPRB, &
  & 0.53569643E-09_JPRB, 0.53563948E-09_JPRB, 0.53554894E-09_JPRB, 0.53542970E-09_JPRB, 0.53529259E-09_JPRB, 0.53514865E-09_JPRB, &
  & 0.53500793E-09_JPRB, 0.53487376E-09_JPRB, 0.53475158E-09_JPRB, 0.53464805E-09_JPRB, 0.53457350E-09_JPRB, 0.53454013E-09_JPRB, &
  & 0.53455657E-09_JPRB, 0.53461996E-09_JPRB, 0.53471383E-09_JPRB, 0.53481281E-09_JPRB, 0.53489546E-09_JPRB, 0.53494947E-09_JPRB, &
  & 0.53497323E-09_JPRB, 0.53497251E-09_JPRB, 0.53495708E-09_JPRB, 0.53493621E-09_JPRB, 0.53491578E-09_JPRB, 0.53489685E-09_JPRB, &
  & 0.53487914E-09_JPRB, 0.53486160E-09_JPRB, 0.53484250E-09_JPRB, 0.53482219E-09_JPRB, 0.53479959E-09_JPRB, 0.53477628E-09_JPRB, &
  & 0.53475330E-09_JPRB, 0.53473043E-09_JPRB, 0.53470489E-09_JPRB, 0.53466048E-09_JPRB /)

RGHG6(:,66, 1) = (/ &
  & 0.53434251E-09_JPRB, 0.53436622E-09_JPRB, 0.53436749E-09_JPRB, 0.53435967E-09_JPRB, 0.53434357E-09_JPRB, 0.53431964E-09_JPRB, &
  & 0.53429206E-09_JPRB, 0.53426996E-09_JPRB, 0.53426041E-09_JPRB, 0.53426519E-09_JPRB, 0.53428101E-09_JPRB, 0.53430044E-09_JPRB, &
  & 0.53431470E-09_JPRB, 0.53431587E-09_JPRB, 0.53429838E-09_JPRB, 0.53426075E-09_JPRB, 0.53421084E-09_JPRB, 0.53417665E-09_JPRB, &
  & 0.53418991E-09_JPRB, 0.53427224E-09_JPRB, 0.53442289E-09_JPRB, 0.53462512E-09_JPRB, 0.53485544E-09_JPRB, 0.53508803E-09_JPRB, &
  & 0.53530130E-09_JPRB, 0.53547800E-09_JPRB, 0.53561089E-09_JPRB, 0.53569837E-09_JPRB, 0.53574589E-09_JPRB, 0.53575822E-09_JPRB, &
  & 0.53573829E-09_JPRB, 0.53568650E-09_JPRB, 0.53560395E-09_JPRB, 0.53549432E-09_JPRB, 0.53536670E-09_JPRB, 0.53523130E-09_JPRB, &
  & 0.53509758E-09_JPRB, 0.53497007E-09_JPRB, 0.53485461E-09_JPRB, 0.53475796E-09_JPRB, 0.53469040E-09_JPRB, 0.53466281E-09_JPRB, &
  & 0.53468197E-09_JPRB, 0.53474425E-09_JPRB, 0.53483318E-09_JPRB, 0.53492605E-09_JPRB, 0.53500337E-09_JPRB, 0.53505406E-09_JPRB, &
  & 0.53507726E-09_JPRB, 0.53507682E-09_JPRB, 0.53506094E-09_JPRB, 0.53503846E-09_JPRB, 0.53501492E-09_JPRB, 0.53499333E-09_JPRB, &
  & 0.53497240E-09_JPRB, 0.53495108E-09_JPRB, 0.53492932E-09_JPRB, 0.53490534E-09_JPRB, 0.53488036E-09_JPRB, 0.53485455E-09_JPRB, &
  & 0.53482890E-09_JPRB, 0.53480342E-09_JPRB, 0.53477317E-09_JPRB, 0.53472043E-09_JPRB /)

RGHG6(:,67, 1) = (/ &
  & 0.53448046E-09_JPRB, 0.53450822E-09_JPRB, 0.53451216E-09_JPRB, 0.53450727E-09_JPRB, 0.53449478E-09_JPRB, 0.53447513E-09_JPRB, &
  & 0.53445198E-09_JPRB, 0.53443416E-09_JPRB, 0.53442889E-09_JPRB, 0.53443816E-09_JPRB, 0.53445759E-09_JPRB, 0.53447974E-09_JPRB, &
  & 0.53449578E-09_JPRB, 0.53449878E-09_JPRB, 0.53448412E-09_JPRB, 0.53445176E-09_JPRB, 0.53440830E-09_JPRB, 0.53438193E-09_JPRB, &
  & 0.53439719E-09_JPRB, 0.53447308E-09_JPRB, 0.53460936E-09_JPRB, 0.53479104E-09_JPRB, 0.53499638E-09_JPRB, 0.53520371E-09_JPRB, &
  & 0.53539229E-09_JPRB, 0.53554883E-09_JPRB, 0.53566512E-09_JPRB, 0.53574190E-09_JPRB, 0.53578292E-09_JPRB, 0.53579308E-09_JPRB, &
  & 0.53577481E-09_JPRB, 0.53572807E-09_JPRB, 0.53565352E-09_JPRB, 0.53555377E-09_JPRB, 0.53543664E-09_JPRB, 0.53531080E-09_JPRB, &
  & 0.53518534E-09_JPRB, 0.53506555E-09_JPRB, 0.53495730E-09_JPRB, 0.53486809E-09_JPRB, 0.53480709E-09_JPRB, 0.53478427E-09_JPRB, &
  & 0.53480487E-09_JPRB, 0.53486454E-09_JPRB, 0.53494803E-09_JPRB, 0.53503413E-09_JPRB, 0.53510590E-09_JPRB, 0.53515337E-09_JPRB, &
  & 0.53517529E-09_JPRB, 0.53517507E-09_JPRB, 0.53515953E-09_JPRB, 0.53513644E-09_JPRB, 0.53511157E-09_JPRB, 0.53508703E-09_JPRB, &
  & 0.53506322E-09_JPRB, 0.53503940E-09_JPRB, 0.53501387E-09_JPRB, 0.53498783E-09_JPRB, 0.53496030E-09_JPRB, 0.53493221E-09_JPRB, &
  & 0.53490462E-09_JPRB, 0.53487492E-09_JPRB, 0.53483962E-09_JPRB, 0.53477228E-09_JPRB /)

RGHG6(:,68, 1) = (/ &
  & 0.53460819E-09_JPRB, 0.53464239E-09_JPRB, 0.53465032E-09_JPRB, 0.53464888E-09_JPRB, 0.53464005E-09_JPRB, 0.53462462E-09_JPRB, &
  & 0.53460669E-09_JPRB, 0.53459381E-09_JPRB, 0.53459331E-09_JPRB, 0.53460669E-09_JPRB, 0.53462862E-09_JPRB, 0.53465227E-09_JPRB, &
  & 0.53466942E-09_JPRB, 0.53467358E-09_JPRB, 0.53466159E-09_JPRB, 0.53463423E-09_JPRB, 0.53459615E-09_JPRB, 0.53457588E-09_JPRB, &
  & 0.53459132E-09_JPRB, 0.53466059E-09_JPRB, 0.53478300E-09_JPRB, 0.53494453E-09_JPRB, 0.53512644E-09_JPRB, 0.53530880E-09_JPRB, &
  & 0.53547516E-09_JPRB, 0.53561178E-09_JPRB, 0.53571358E-09_JPRB, 0.53577981E-09_JPRB, 0.53581517E-09_JPRB, 0.53582333E-09_JPRB, &
  & 0.53580662E-09_JPRB, 0.53576482E-09_JPRB, 0.53569804E-09_JPRB, 0.53560811E-09_JPRB, 0.53550164E-09_JPRB, 0.53538635E-09_JPRB, &
  & 0.53527011E-09_JPRB, 0.53515875E-09_JPRB, 0.53505866E-09_JPRB, 0.53497662E-09_JPRB, 0.53492222E-09_JPRB, 0.53490345E-09_JPRB, &
  & 0.53492449E-09_JPRB, 0.53498084E-09_JPRB, 0.53505811E-09_JPRB, 0.53513755E-09_JPRB, 0.53520366E-09_JPRB, 0.53524740E-09_JPRB, &
  & 0.53526794E-09_JPRB, 0.53526783E-09_JPRB, 0.53525284E-09_JPRB, 0.53523014E-09_JPRB, 0.53520444E-09_JPRB, 0.53517896E-09_JPRB, &
  & 0.53515309E-09_JPRB, 0.53512650E-09_JPRB, 0.53509952E-09_JPRB, 0.53507082E-09_JPRB, 0.53504201E-09_JPRB, 0.53501281E-09_JPRB, &
  & 0.53498261E-09_JPRB, 0.53495042E-09_JPRB, 0.53490640E-09_JPRB, 0.53482424E-09_JPRB /)

RGHG6(:,69, 1) = (/ &
  & 0.53473070E-09_JPRB, 0.53477234E-09_JPRB, 0.53478394E-09_JPRB, 0.53478594E-09_JPRB, 0.53478078E-09_JPRB, 0.53476984E-09_JPRB, &
  & 0.53475702E-09_JPRB, 0.53474986E-09_JPRB, 0.53475407E-09_JPRB, 0.53477067E-09_JPRB, 0.53479410E-09_JPRB, 0.53481797E-09_JPRB, &
  & 0.53483534E-09_JPRB, 0.53484039E-09_JPRB, 0.53483035E-09_JPRB, 0.53480770E-09_JPRB, 0.53477339E-09_JPRB, 0.53475846E-09_JPRB, &
  & 0.53477311E-09_JPRB, 0.53483495E-09_JPRB, 0.53494303E-09_JPRB, 0.53508553E-09_JPRB, 0.53524479E-09_JPRB, 0.53540494E-09_JPRB, &
  & 0.53554955E-09_JPRB, 0.53566873E-09_JPRB, 0.53575633E-09_JPRB, 0.53581356E-09_JPRB, 0.53584365E-09_JPRB, 0.53585009E-09_JPRB, &
  & 0.53583482E-09_JPRB, 0.53579746E-09_JPRB, 0.53573823E-09_JPRB, 0.53565802E-09_JPRB, 0.53556226E-09_JPRB, 0.53545773E-09_JPRB, &
  & 0.53535115E-09_JPRB, 0.53524912E-09_JPRB, 0.53515731E-09_JPRB, 0.53508342E-09_JPRB, 0.53503529E-09_JPRB, 0.53502008E-09_JPRB, &
  & 0.53504118E-09_JPRB, 0.53509364E-09_JPRB, 0.53516441E-09_JPRB, 0.53523669E-09_JPRB, 0.53529703E-09_JPRB, 0.53533705E-09_JPRB, &
  & 0.53535576E-09_JPRB, 0.53535565E-09_JPRB, 0.53534144E-09_JPRB, 0.53531979E-09_JPRB, 0.53529448E-09_JPRB, 0.53526861E-09_JPRB, &
  & 0.53524180E-09_JPRB, 0.53521459E-09_JPRB, 0.53518590E-09_JPRB, 0.53515692E-09_JPRB, 0.53512744E-09_JPRB, 0.53509741E-09_JPRB, &
  & 0.53506666E-09_JPRB, 0.53503041E-09_JPRB, 0.53498034E-09_JPRB, 0.53487725E-09_JPRB /)

RGHG6(:,70, 1) = (/ &
  & 0.53484722E-09_JPRB, 0.53489768E-09_JPRB, 0.53491422E-09_JPRB, 0.53491978E-09_JPRB, 0.53491828E-09_JPRB, 0.53491178E-09_JPRB, &
  & 0.53490462E-09_JPRB, 0.53490279E-09_JPRB, 0.53491128E-09_JPRB, 0.53493027E-09_JPRB, 0.53495358E-09_JPRB, 0.53497684E-09_JPRB, &
  & 0.53499327E-09_JPRB, 0.53499827E-09_JPRB, 0.53498983E-09_JPRB, 0.53497062E-09_JPRB, 0.53493998E-09_JPRB, 0.53492771E-09_JPRB, &
  & 0.53494037E-09_JPRB, 0.53499483E-09_JPRB, 0.53508986E-09_JPRB, 0.53521398E-09_JPRB, 0.53535315E-09_JPRB, 0.53549148E-09_JPRB, &
  & 0.53561694E-09_JPRB, 0.53571925E-09_JPRB, 0.53579458E-09_JPRB, 0.53584337E-09_JPRB, 0.53586852E-09_JPRB, 0.53587357E-09_JPRB, &
  & 0.53585980E-09_JPRB, 0.53582683E-09_JPRB, 0.53577470E-09_JPRB, 0.53570393E-09_JPRB, 0.53561888E-09_JPRB, 0.53552507E-09_JPRB, &
  & 0.53542887E-09_JPRB, 0.53533639E-09_JPRB, 0.53525340E-09_JPRB, 0.53518751E-09_JPRB, 0.53514537E-09_JPRB, 0.53513360E-09_JPRB, &
  & 0.53515459E-09_JPRB, 0.53520283E-09_JPRB, 0.53526700E-09_JPRB, 0.53533228E-09_JPRB, 0.53538640E-09_JPRB, 0.53542254E-09_JPRB, &
  & 0.53543958E-09_JPRB, 0.53543930E-09_JPRB, 0.53542604E-09_JPRB, 0.53540583E-09_JPRB, 0.53538157E-09_JPRB, 0.53535665E-09_JPRB, &
  & 0.53533039E-09_JPRB, 0.53530319E-09_JPRB, 0.53527499E-09_JPRB, 0.53524607E-09_JPRB, 0.53521704E-09_JPRB, 0.53518745E-09_JPRB, &
  & 0.53515631E-09_JPRB, 0.53511878E-09_JPRB, 0.53506161E-09_JPRB, 0.53494231E-09_JPRB /)

RGHG6(:,71, 1) = (/ &
  & 0.53496108E-09_JPRB, 0.53502197E-09_JPRB, 0.53504279E-09_JPRB, 0.53505195E-09_JPRB, 0.53505389E-09_JPRB, 0.53505161E-09_JPRB, &
  & 0.53504950E-09_JPRB, 0.53505284E-09_JPRB, 0.53506466E-09_JPRB, 0.53508414E-09_JPRB, 0.53510685E-09_JPRB, 0.53512744E-09_JPRB, &
  & 0.53514254E-09_JPRB, 0.53514698E-09_JPRB, 0.53513938E-09_JPRB, 0.53512228E-09_JPRB, 0.53509541E-09_JPRB, 0.53508464E-09_JPRB, &
  & 0.53509547E-09_JPRB, 0.53514243E-09_JPRB, 0.53522436E-09_JPRB, 0.53533172E-09_JPRB, 0.53545085E-09_JPRB, 0.53557014E-09_JPRB, &
  & 0.53567689E-09_JPRB, 0.53576465E-09_JPRB, 0.53582844E-09_JPRB, 0.53586990E-09_JPRB, 0.53589067E-09_JPRB, 0.53589455E-09_JPRB, &
  & 0.53588206E-09_JPRB, 0.53585325E-09_JPRB, 0.53580801E-09_JPRB, 0.53574634E-09_JPRB, 0.53567178E-09_JPRB, 0.53558880E-09_JPRB, &
  & 0.53550298E-09_JPRB, 0.53542037E-09_JPRB, 0.53534649E-09_JPRB, 0.53528848E-09_JPRB, 0.53525240E-09_JPRB, 0.53524396E-09_JPRB, &
  & 0.53526406E-09_JPRB, 0.53530830E-09_JPRB, 0.53536570E-09_JPRB, 0.53542371E-09_JPRB, 0.53547172E-09_JPRB, 0.53550364E-09_JPRB, &
  & 0.53551885E-09_JPRB, 0.53551868E-09_JPRB, 0.53550653E-09_JPRB, 0.53548826E-09_JPRB, 0.53546567E-09_JPRB, 0.53544313E-09_JPRB, &
  & 0.53541815E-09_JPRB, 0.53539295E-09_JPRB, 0.53536564E-09_JPRB, 0.53533850E-09_JPRB, 0.53531035E-09_JPRB, 0.53528204E-09_JPRB, &
  & 0.53525162E-09_JPRB, 0.53521410E-09_JPRB, 0.53515437E-09_JPRB, 0.53502419E-09_JPRB /)

RGHG6(:,72, 1) = (/ &
  & 0.53507465E-09_JPRB, 0.53514554E-09_JPRB, 0.53517091E-09_JPRB, 0.53518290E-09_JPRB, 0.53518778E-09_JPRB, 0.53518900E-09_JPRB, &
  & 0.53519150E-09_JPRB, 0.53519866E-09_JPRB, 0.53521265E-09_JPRB, 0.53523186E-09_JPRB, 0.53525107E-09_JPRB, 0.53526977E-09_JPRB, &
  & 0.53528187E-09_JPRB, 0.53528548E-09_JPRB, 0.53527838E-09_JPRB, 0.53526245E-09_JPRB, 0.53523952E-09_JPRB, 0.53522886E-09_JPRB, &
  & 0.53523758E-09_JPRB, 0.53527766E-09_JPRB, 0.53534766E-09_JPRB, 0.53543869E-09_JPRB, 0.53554000E-09_JPRB, 0.53564092E-09_JPRB, &
  & 0.53573113E-09_JPRB, 0.53580490E-09_JPRB, 0.53585847E-09_JPRB, 0.53589333E-09_JPRB, 0.53591032E-09_JPRB, 0.53591315E-09_JPRB, &
  & 0.53590193E-09_JPRB, 0.53587729E-09_JPRB, 0.53583837E-09_JPRB, 0.53578569E-09_JPRB, 0.53572097E-09_JPRB, 0.53564897E-09_JPRB, &
  & 0.53557364E-09_JPRB, 0.53550131E-09_JPRB, 0.53543653E-09_JPRB, 0.53538646E-09_JPRB, 0.53535615E-09_JPRB, 0.53535076E-09_JPRB, &
  & 0.53536986E-09_JPRB, 0.53540916E-09_JPRB, 0.53545995E-09_JPRB, 0.53551097E-09_JPRB, 0.53555244E-09_JPRB, 0.53558030E-09_JPRB, &
  & 0.53559379E-09_JPRB, 0.53559357E-09_JPRB, 0.53558280E-09_JPRB, 0.53556654E-09_JPRB, 0.53554683E-09_JPRB, 0.53552640E-09_JPRB, &
  & 0.53550481E-09_JPRB, 0.53548121E-09_JPRB, 0.53545707E-09_JPRB, 0.53543087E-09_JPRB, 0.53540583E-09_JPRB, 0.53537869E-09_JPRB, &
  & 0.53535087E-09_JPRB, 0.53531435E-09_JPRB, 0.53525445E-09_JPRB, 0.53511873E-09_JPRB /)

RGHG6(:,73, 1) = (/ &
  & 0.53520138E-09_JPRB, 0.53527277E-09_JPRB, 0.53529881E-09_JPRB, 0.53531191E-09_JPRB, 0.53531857E-09_JPRB, 0.53532245E-09_JPRB, &
  & 0.53532823E-09_JPRB, 0.53533805E-09_JPRB, 0.53535243E-09_JPRB, 0.53536908E-09_JPRB, 0.53538690E-09_JPRB, 0.53540061E-09_JPRB, &
  & 0.53541122E-09_JPRB, 0.53541349E-09_JPRB, 0.53540639E-09_JPRB, 0.53539140E-09_JPRB, 0.53537175E-09_JPRB, 0.53536192E-09_JPRB, &
  & 0.53536875E-09_JPRB, 0.53540200E-09_JPRB, 0.53546029E-09_JPRB, 0.53553623E-09_JPRB, 0.53562038E-09_JPRB, 0.53570481E-09_JPRB, &
  & 0.53577953E-09_JPRB, 0.53584093E-09_JPRB, 0.53588511E-09_JPRB, 0.53591409E-09_JPRB, 0.53592752E-09_JPRB, 0.53592969E-09_JPRB, &
  & 0.53591970E-09_JPRB, 0.53589888E-09_JPRB, 0.53586618E-09_JPRB, 0.53582211E-09_JPRB, 0.53576710E-09_JPRB, 0.53570554E-09_JPRB, &
  & 0.53564092E-09_JPRB, 0.53557880E-09_JPRB, 0.53552296E-09_JPRB, 0.53548077E-09_JPRB, 0.53545585E-09_JPRB, 0.53545302E-09_JPRB, &
  & 0.53547028E-09_JPRB, 0.53550492E-09_JPRB, 0.53554888E-09_JPRB, 0.53559235E-09_JPRB, 0.53562821E-09_JPRB, 0.53565186E-09_JPRB, &
  & 0.53566351E-09_JPRB, 0.53566340E-09_JPRB, 0.53565424E-09_JPRB, 0.53564048E-09_JPRB, 0.53562293E-09_JPRB, 0.53560656E-09_JPRB, &
  & 0.53558674E-09_JPRB, 0.53556748E-09_JPRB, 0.53554455E-09_JPRB, 0.53552285E-09_JPRB, 0.53549887E-09_JPRB, 0.53547583E-09_JPRB, &
  & 0.53544957E-09_JPRB, 0.53541638E-09_JPRB, 0.53535787E-09_JPRB, 0.53522131E-09_JPRB /)

RGHG6(:,74, 1) = (/ &
  & 0.53532628E-09_JPRB, 0.53539789E-09_JPRB, 0.53542298E-09_JPRB, 0.53543658E-09_JPRB, 0.53544380E-09_JPRB, 0.53544907E-09_JPRB, &
  & 0.53545668E-09_JPRB, 0.53546700E-09_JPRB, 0.53548055E-09_JPRB, 0.53549609E-09_JPRB, 0.53550914E-09_JPRB, 0.53552190E-09_JPRB, &
  & 0.53552929E-09_JPRB, 0.53553056E-09_JPRB, 0.53552346E-09_JPRB, 0.53550930E-09_JPRB, 0.53549243E-09_JPRB, 0.53548338E-09_JPRB, &
  & 0.53548826E-09_JPRB, 0.53551558E-09_JPRB, 0.53556298E-09_JPRB, 0.53562460E-09_JPRB, 0.53569332E-09_JPRB, 0.53576249E-09_JPRB, &
  & 0.53582294E-09_JPRB, 0.53587307E-09_JPRB, 0.53590860E-09_JPRB, 0.53593241E-09_JPRB, 0.53594262E-09_JPRB, 0.53594440E-09_JPRB, &
  & 0.53593574E-09_JPRB, 0.53591853E-09_JPRB, 0.53589150E-09_JPRB, 0.53585542E-09_JPRB, 0.53581001E-09_JPRB, 0.53575894E-09_JPRB, &
  & 0.53570459E-09_JPRB, 0.53565291E-09_JPRB, 0.53560567E-09_JPRB, 0.53557137E-09_JPRB, 0.53555121E-09_JPRB, 0.53555049E-09_JPRB, &
  & 0.53556543E-09_JPRB, 0.53559451E-09_JPRB, 0.53563143E-09_JPRB, 0.53566868E-09_JPRB, 0.53569815E-09_JPRB, 0.53571803E-09_JPRB, &
  & 0.53572807E-09_JPRB, 0.53572813E-09_JPRB, 0.53572041E-09_JPRB, 0.53570903E-09_JPRB, 0.53569449E-09_JPRB, 0.53568028E-09_JPRB, &
  & 0.53566457E-09_JPRB, 0.53564686E-09_JPRB, 0.53562899E-09_JPRB, 0.53560856E-09_JPRB, 0.53558985E-09_JPRB, 0.53556826E-09_JPRB, &
  & 0.53554677E-09_JPRB, 0.53551630E-09_JPRB, 0.53546173E-09_JPRB, 0.53532939E-09_JPRB /)

RGHG6(:,75, 1) = (/ &
  & 0.53544846E-09_JPRB, 0.53551724E-09_JPRB, 0.53554156E-09_JPRB, 0.53555438E-09_JPRB, 0.53556137E-09_JPRB, 0.53556681E-09_JPRB, &
  & 0.53557486E-09_JPRB, 0.53558491E-09_JPRB, 0.53559712E-09_JPRB, 0.53560928E-09_JPRB, 0.53562144E-09_JPRB, 0.53562987E-09_JPRB, &
  & 0.53563659E-09_JPRB, 0.53563681E-09_JPRB, 0.53562932E-09_JPRB, 0.53561661E-09_JPRB, 0.53560240E-09_JPRB, 0.53559457E-09_JPRB, &
  & 0.53559768E-09_JPRB, 0.53561938E-09_JPRB, 0.53565663E-09_JPRB, 0.53570520E-09_JPRB, 0.53575944E-09_JPRB, 0.53581456E-09_JPRB, &
  & 0.53586191E-09_JPRB, 0.53590149E-09_JPRB, 0.53592936E-09_JPRB, 0.53594867E-09_JPRB, 0.53595595E-09_JPRB, 0.53595739E-09_JPRB, &
  & 0.53595001E-09_JPRB, 0.53593635E-09_JPRB, 0.53591470E-09_JPRB, 0.53588617E-09_JPRB, 0.53585009E-09_JPRB, 0.53580895E-09_JPRB, &
  & 0.53576482E-09_JPRB, 0.53572341E-09_JPRB, 0.53568461E-09_JPRB, 0.53565763E-09_JPRB, 0.53564192E-09_JPRB, 0.53564281E-09_JPRB, &
  & 0.53565441E-09_JPRB, 0.53567767E-09_JPRB, 0.53570842E-09_JPRB, 0.53573845E-09_JPRB, 0.53576299E-09_JPRB, 0.53577898E-09_JPRB, &
  & 0.53578725E-09_JPRB, 0.53578736E-09_JPRB, 0.53578120E-09_JPRB, 0.53577232E-09_JPRB, 0.53575949E-09_JPRB, 0.53574900E-09_JPRB, &
  & 0.53573485E-09_JPRB, 0.53572158E-09_JPRB, 0.53570548E-09_JPRB, 0.53569066E-09_JPRB, 0.53567439E-09_JPRB, 0.53565768E-09_JPRB, &
  & 0.53563903E-09_JPRB, 0.53561311E-09_JPRB, 0.53556409E-09_JPRB, 0.53544030E-09_JPRB /)

RGHG6(:,76, 1) = (/ &
  & 0.53556454E-09_JPRB, 0.53563148E-09_JPRB, 0.53565263E-09_JPRB, 0.53566451E-09_JPRB, 0.53567023E-09_JPRB, 0.53567478E-09_JPRB, &
  & 0.53568266E-09_JPRB, 0.53569110E-09_JPRB, 0.53570087E-09_JPRB, 0.53571148E-09_JPRB, 0.53571936E-09_JPRB, 0.53572707E-09_JPRB, &
  & 0.53573174E-09_JPRB, 0.53573179E-09_JPRB, 0.53572502E-09_JPRB, 0.53571364E-09_JPRB, 0.53570248E-09_JPRB, 0.53569604E-09_JPRB, &
  & 0.53569726E-09_JPRB, 0.53571420E-09_JPRB, 0.53574212E-09_JPRB, 0.53577864E-09_JPRB, 0.53581928E-09_JPRB, 0.53586147E-09_JPRB, &
  & 0.53589655E-09_JPRB, 0.53592686E-09_JPRB, 0.53594756E-09_JPRB, 0.53596289E-09_JPRB, 0.53596766E-09_JPRB, 0.53596916E-09_JPRB, &
  & 0.53596277E-09_JPRB, 0.53595228E-09_JPRB, 0.53593552E-09_JPRB, 0.53591431E-09_JPRB, 0.53588700E-09_JPRB, 0.53585608E-09_JPRB, &
  & 0.53582144E-09_JPRB, 0.53579019E-09_JPRB, 0.53575905E-09_JPRB, 0.53573934E-09_JPRB, 0.53572741E-09_JPRB, 0.53572946E-09_JPRB, &
  & 0.53573757E-09_JPRB, 0.53575494E-09_JPRB, 0.53577898E-09_JPRB, 0.53580329E-09_JPRB, 0.53582189E-09_JPRB, 0.53583421E-09_JPRB, &
  & 0.53584104E-09_JPRB, 0.53584120E-09_JPRB, 0.53583626E-09_JPRB, 0.53582988E-09_JPRB, 0.53581917E-09_JPRB, 0.53581117E-09_JPRB, &
  & 0.53579996E-09_JPRB, 0.53578908E-09_JPRB, 0.53577737E-09_JPRB, 0.53576610E-09_JPRB, 0.53575477E-09_JPRB, 0.53574106E-09_JPRB, &
  & 0.53572707E-09_JPRB, 0.53570548E-09_JPRB, 0.53566312E-09_JPRB, 0.53555255E-09_JPRB /)

RGHG6(:,77, 1) = (/ &
  & 0.53567650E-09_JPRB, 0.53573707E-09_JPRB, 0.53575527E-09_JPRB, 0.53576538E-09_JPRB, 0.53576943E-09_JPRB, 0.53577237E-09_JPRB, &
  & 0.53577942E-09_JPRB, 0.53578586E-09_JPRB, 0.53579297E-09_JPRB, 0.53580024E-09_JPRB, 0.53580590E-09_JPRB, 0.53581051E-09_JPRB, &
  & 0.53581511E-09_JPRB, 0.53581556E-09_JPRB, 0.53580940E-09_JPRB, 0.53580046E-09_JPRB, 0.53579263E-09_JPRB, 0.53578803E-09_JPRB, &
  & 0.53578747E-09_JPRB, 0.53580002E-09_JPRB, 0.53581944E-09_JPRB, 0.53584481E-09_JPRB, 0.53587290E-09_JPRB, 0.53590316E-09_JPRB, &
  & 0.53592725E-09_JPRB, 0.53594928E-09_JPRB, 0.53596350E-09_JPRB, 0.53597543E-09_JPRB, 0.53597793E-09_JPRB, 0.53597948E-09_JPRB, &
  & 0.53597399E-09_JPRB, 0.53596655E-09_JPRB, 0.53595417E-09_JPRB, 0.53593974E-09_JPRB, 0.53592097E-09_JPRB, 0.53589932E-09_JPRB, &
  & 0.53587412E-09_JPRB, 0.53585231E-09_JPRB, 0.53582866E-09_JPRB, 0.53581578E-09_JPRB, 0.53580707E-09_JPRB, 0.53580995E-09_JPRB, &
  & 0.53581389E-09_JPRB, 0.53582538E-09_JPRB, 0.53584359E-09_JPRB, 0.53586163E-09_JPRB, 0.53587557E-09_JPRB, 0.53588378E-09_JPRB, &
  & 0.53588928E-09_JPRB, 0.53588955E-09_JPRB, 0.53588550E-09_JPRB, 0.53588167E-09_JPRB, 0.53587212E-09_JPRB, 0.53586768E-09_JPRB, &
  & 0.53585825E-09_JPRB, 0.53585092E-09_JPRB, 0.53584220E-09_JPRB, 0.53583571E-09_JPRB, 0.53582871E-09_JPRB, 0.53581872E-09_JPRB, &
  & 0.53580906E-09_JPRB, 0.53579180E-09_JPRB, 0.53575777E-09_JPRB, 0.53566335E-09_JPRB /)

RGHG6(:,78, 1) = (/ &
  & 0.53578203E-09_JPRB, 0.53583116E-09_JPRB, 0.53584276E-09_JPRB, 0.53585103E-09_JPRB, 0.53585314E-09_JPRB, 0.53585425E-09_JPRB, &
  & 0.53586069E-09_JPRB, 0.53586441E-09_JPRB, 0.53586852E-09_JPRB, 0.53587301E-09_JPRB, 0.53587501E-09_JPRB, 0.53587801E-09_JPRB, &
  & 0.53588223E-09_JPRB, 0.53588389E-09_JPRB, 0.53587923E-09_JPRB, 0.53587268E-09_JPRB, 0.53586846E-09_JPRB, 0.53586580E-09_JPRB, &
  & 0.53586380E-09_JPRB, 0.53587318E-09_JPRB, 0.53588511E-09_JPRB, 0.53590077E-09_JPRB, 0.53591770E-09_JPRB, 0.53593791E-09_JPRB, &
  & 0.53595267E-09_JPRB, 0.53596771E-09_JPRB, 0.53597682E-09_JPRB, 0.53598570E-09_JPRB, 0.53598631E-09_JPRB, 0.53598809E-09_JPRB, &
  & 0.53598342E-09_JPRB, 0.53597848E-09_JPRB, 0.53596988E-09_JPRB, 0.53596133E-09_JPRB, 0.53595001E-09_JPRB, 0.53593674E-09_JPRB, &
  & 0.53591964E-09_JPRB, 0.53590665E-09_JPRB, 0.53588906E-09_JPRB, 0.53588239E-09_JPRB, 0.53587601E-09_JPRB, 0.53587934E-09_JPRB, &
  & 0.53587929E-09_JPRB, 0.53588528E-09_JPRB, 0.53589799E-09_JPRB, 0.53591104E-09_JPRB, 0.53592031E-09_JPRB, 0.53592530E-09_JPRB, &
  & 0.53592963E-09_JPRB, 0.53592969E-09_JPRB, 0.53592630E-09_JPRB, 0.53592469E-09_JPRB, 0.53591614E-09_JPRB, 0.53591476E-09_JPRB, &
  & 0.53590726E-09_JPRB, 0.53590293E-09_JPRB, 0.53589716E-09_JPRB, 0.53589472E-09_JPRB, 0.53589166E-09_JPRB, 0.53588511E-09_JPRB, &
  & 0.53587951E-09_JPRB, 0.53586635E-09_JPRB, 0.53584265E-09_JPRB, 0.53577176E-09_JPRB /)

RGHG6(:,79, 1) = (/ &
  & 0.53585042E-09_JPRB, 0.53588356E-09_JPRB, 0.53588911E-09_JPRB, 0.53589533E-09_JPRB, 0.53589622E-09_JPRB, 0.53589622E-09_JPRB, &
  & 0.53590266E-09_JPRB, 0.53590515E-09_JPRB, 0.53590765E-09_JPRB, 0.53591115E-09_JPRB, 0.53591143E-09_JPRB, 0.53591337E-09_JPRB, &
  & 0.53591798E-09_JPRB, 0.53592031E-09_JPRB, 0.53591598E-09_JPRB, 0.53591054E-09_JPRB, 0.53590843E-09_JPRB, 0.53590704E-09_JPRB, &
  & 0.53590410E-09_JPRB, 0.53591209E-09_JPRB, 0.53592009E-09_JPRB, 0.53593052E-09_JPRB, 0.53594151E-09_JPRB, 0.53595650E-09_JPRB, &
  & 0.53596622E-09_JPRB, 0.53597776E-09_JPRB, 0.53598398E-09_JPRB, 0.53599164E-09_JPRB, 0.53599097E-09_JPRB, 0.53599297E-09_JPRB, &
  & 0.53598859E-09_JPRB, 0.53598509E-09_JPRB, 0.53597804E-09_JPRB, 0.53597293E-09_JPRB, 0.53596572E-09_JPRB, 0.53595733E-09_JPRB, &
  & 0.53594440E-09_JPRB, 0.53593630E-09_JPRB, 0.53592153E-09_JPRB, 0.53591825E-09_JPRB, 0.53591276E-09_JPRB, 0.53591659E-09_JPRB, &
  & 0.53591387E-09_JPRB, 0.53591653E-09_JPRB, 0.53592680E-09_JPRB, 0.53593735E-09_JPRB, 0.53594440E-09_JPRB, 0.53594729E-09_JPRB, &
  & 0.53595117E-09_JPRB, 0.53595112E-09_JPRB, 0.53594801E-09_JPRB, 0.53594768E-09_JPRB, 0.53593896E-09_JPRB, 0.53593951E-09_JPRB, &
  & 0.53593252E-09_JPRB, 0.53592969E-09_JPRB, 0.53592530E-09_JPRB, 0.53592530E-09_JPRB, 0.53592447E-09_JPRB, 0.53591959E-09_JPRB, &
  & 0.53591626E-09_JPRB, 0.53590604E-09_JPRB, 0.53588994E-09_JPRB, 0.53584076E-09_JPRB /)

RGHG6(:,80, 1) = (/ &
  & 0.53589572E-09_JPRB, 0.53590898E-09_JPRB, 0.53590937E-09_JPRB, 0.53591459E-09_JPRB, 0.53591476E-09_JPRB, 0.53591404E-09_JPRB, &
  & 0.53592086E-09_JPRB, 0.53592281E-09_JPRB, 0.53592503E-09_JPRB, 0.53592797E-09_JPRB, 0.53592769E-09_JPRB, 0.53592930E-09_JPRB, &
  & 0.53593424E-09_JPRB, 0.53593696E-09_JPRB, 0.53593252E-09_JPRB, 0.53592725E-09_JPRB, 0.53592614E-09_JPRB, 0.53592542E-09_JPRB, &
  & 0.53592175E-09_JPRB, 0.53592958E-09_JPRB, 0.53593580E-09_JPRB, 0.53594379E-09_JPRB, 0.53595195E-09_JPRB, 0.53596461E-09_JPRB, &
  & 0.53597216E-09_JPRB, 0.53598237E-09_JPRB, 0.53598725E-09_JPRB, 0.53599458E-09_JPRB, 0.53599319E-09_JPRB, 0.53599541E-09_JPRB, &
  & 0.53599092E-09_JPRB, 0.53598803E-09_JPRB, 0.53598170E-09_JPRB, 0.53597826E-09_JPRB, 0.53597304E-09_JPRB, 0.53596688E-09_JPRB, &
  & 0.53595572E-09_JPRB, 0.53595001E-09_JPRB, 0.53593607E-09_JPRB, 0.53593452E-09_JPRB, 0.53592936E-09_JPRB, 0.53593352E-09_JPRB, &
  & 0.53592930E-09_JPRB, 0.53593041E-09_JPRB, 0.53593957E-09_JPRB, 0.53594923E-09_JPRB, 0.53595506E-09_JPRB, 0.53595706E-09_JPRB, &
  & 0.53596083E-09_JPRB, 0.53596072E-09_JPRB, 0.53595761E-09_JPRB, 0.53595783E-09_JPRB, 0.53594873E-09_JPRB, 0.53595040E-09_JPRB, &
  & 0.53594329E-09_JPRB, 0.53594118E-09_JPRB, 0.53593729E-09_JPRB, 0.53593857E-09_JPRB, 0.53593885E-09_JPRB, 0.53593469E-09_JPRB, &
  & 0.53593252E-09_JPRB, 0.53592347E-09_JPRB, 0.53591254E-09_JPRB, 0.53588561E-09_JPRB /)

RGHG6(:,81, 1) = (/ &
  & 0.53592702E-09_JPRB, 0.53591986E-09_JPRB, 0.53591792E-09_JPRB, 0.53592275E-09_JPRB, 0.53592270E-09_JPRB, 0.53592170E-09_JPRB, &
  & 0.53592858E-09_JPRB, 0.53593047E-09_JPRB, 0.53593219E-09_JPRB, 0.53593563E-09_JPRB, 0.53593491E-09_JPRB, 0.53593646E-09_JPRB, &
  & 0.53594157E-09_JPRB, 0.53594451E-09_JPRB, 0.53593974E-09_JPRB, 0.53593452E-09_JPRB, 0.53593374E-09_JPRB, 0.53593335E-09_JPRB, &
  & 0.53592947E-09_JPRB, 0.53593718E-09_JPRB, 0.53594262E-09_JPRB, 0.53594951E-09_JPRB, 0.53595645E-09_JPRB, 0.53596827E-09_JPRB, &
  & 0.53597471E-09_JPRB, 0.53598442E-09_JPRB, 0.53598875E-09_JPRB, 0.53599597E-09_JPRB, 0.53599419E-09_JPRB, 0.53599652E-09_JPRB, &
  & 0.53599208E-09_JPRB, 0.53598936E-09_JPRB, 0.53598331E-09_JPRB, 0.53598048E-09_JPRB, 0.53597643E-09_JPRB, 0.53597116E-09_JPRB, &
  & 0.53596094E-09_JPRB, 0.53595611E-09_JPRB, 0.53594262E-09_JPRB, 0.53594190E-09_JPRB, 0.53593691E-09_JPRB, 0.53594118E-09_JPRB, &
  & 0.53593596E-09_JPRB, 0.53593618E-09_JPRB, 0.53594518E-09_JPRB, 0.53595445E-09_JPRB, 0.53595989E-09_JPRB, 0.53596139E-09_JPRB, &
  & 0.53596511E-09_JPRB, 0.53596505E-09_JPRB, 0.53596172E-09_JPRB, 0.53596222E-09_JPRB, 0.53595267E-09_JPRB, 0.53595500E-09_JPRB, &
  & 0.53594784E-09_JPRB, 0.53594607E-09_JPRB, 0.53594235E-09_JPRB, 0.53594407E-09_JPRB, 0.53594507E-09_JPRB, 0.53594118E-09_JPRB, &
  & 0.53593968E-09_JPRB, 0.53593086E-09_JPRB, 0.53592214E-09_JPRB, 0.53591576E-09_JPRB /)

RGHG6(:,82, 1) = (/ &
  & 0.53592958E-09_JPRB, 0.53592353E-09_JPRB, 0.53592158E-09_JPRB, 0.53592669E-09_JPRB, 0.53592653E-09_JPRB, 0.53592519E-09_JPRB, &
  & 0.53593252E-09_JPRB, 0.53593413E-09_JPRB, 0.53593624E-09_JPRB, 0.53593918E-09_JPRB, 0.53593846E-09_JPRB, 0.53593985E-09_JPRB, &
  & 0.53594529E-09_JPRB, 0.53594834E-09_JPRB, 0.53594335E-09_JPRB, 0.53593802E-09_JPRB, 0.53593763E-09_JPRB, 0.53593735E-09_JPRB, &
  & 0.53593308E-09_JPRB, 0.53594101E-09_JPRB, 0.53594584E-09_JPRB, 0.53595234E-09_JPRB, 0.53595861E-09_JPRB, 0.53596994E-09_JPRB, &
  & 0.53597576E-09_JPRB, 0.53598542E-09_JPRB, 0.53598948E-09_JPRB, 0.53599675E-09_JPRB, 0.53599475E-09_JPRB, 0.53599719E-09_JPRB, &
  & 0.53599258E-09_JPRB, 0.53599003E-09_JPRB, 0.53598398E-09_JPRB, 0.53598159E-09_JPRB, 0.53597793E-09_JPRB, 0.53597327E-09_JPRB, &
  & 0.53596366E-09_JPRB, 0.53595911E-09_JPRB, 0.53594607E-09_JPRB, 0.53594557E-09_JPRB, 0.53594063E-09_JPRB, 0.53594507E-09_JPRB, &
  & 0.53593929E-09_JPRB, 0.53593890E-09_JPRB, 0.53594779E-09_JPRB, 0.53595695E-09_JPRB, 0.53596222E-09_JPRB, 0.53596355E-09_JPRB, &
  & 0.53596722E-09_JPRB, 0.53596716E-09_JPRB, 0.53596372E-09_JPRB, 0.53596450E-09_JPRB, 0.53595467E-09_JPRB, 0.53595728E-09_JPRB, &
  & 0.53594995E-09_JPRB, 0.53594840E-09_JPRB, 0.53594462E-09_JPRB, 0.53594684E-09_JPRB, 0.53594812E-09_JPRB, 0.53594446E-09_JPRB, &
  & 0.53594312E-09_JPRB, 0.53593413E-09_JPRB, 0.53592530E-09_JPRB, 0.53591809E-09_JPRB /)

RGHG6(:,83, 1) = (/ &
  & 0.53593141E-09_JPRB, 0.53592564E-09_JPRB, 0.53592364E-09_JPRB, 0.53592886E-09_JPRB, 0.53592869E-09_JPRB, 0.53592730E-09_JPRB, &
  & 0.53593452E-09_JPRB, 0.53593641E-09_JPRB, 0.53593796E-09_JPRB, 0.53594151E-09_JPRB, 0.53594063E-09_JPRB, 0.53594212E-09_JPRB, &
  & 0.53594729E-09_JPRB, 0.53595051E-09_JPRB, 0.53594540E-09_JPRB, 0.53593996E-09_JPRB, 0.53593979E-09_JPRB, 0.53593968E-09_JPRB, &
  & 0.53593519E-09_JPRB, 0.53594296E-09_JPRB, 0.53594784E-09_JPRB, 0.53595367E-09_JPRB, 0.53595978E-09_JPRB, 0.53597082E-09_JPRB, &
  & 0.53597637E-09_JPRB, 0.53598603E-09_JPRB, 0.53598992E-09_JPRB, 0.53599725E-09_JPRB, 0.53599497E-09_JPRB, 0.53599747E-09_JPRB, &
  & 0.53599281E-09_JPRB, 0.53599025E-09_JPRB, 0.53598426E-09_JPRB, 0.53598220E-09_JPRB, 0.53597893E-09_JPRB, 0.53597426E-09_JPRB, &
  & 0.53596511E-09_JPRB, 0.53596072E-09_JPRB, 0.53594806E-09_JPRB, 0.53594762E-09_JPRB, 0.53594285E-09_JPRB, 0.53594718E-09_JPRB, &
  & 0.53594101E-09_JPRB, 0.53594024E-09_JPRB, 0.53594923E-09_JPRB, 0.53595844E-09_JPRB, 0.53596361E-09_JPRB, 0.53596472E-09_JPRB, &
  & 0.53596855E-09_JPRB, 0.53596838E-09_JPRB, 0.53596483E-09_JPRB, 0.53596566E-09_JPRB, 0.53595567E-09_JPRB, 0.53595856E-09_JPRB, &
  & 0.53595101E-09_JPRB, 0.53594967E-09_JPRB, 0.53594590E-09_JPRB, 0.53594829E-09_JPRB, 0.53594984E-09_JPRB, 0.53594629E-09_JPRB, &
  & 0.53594512E-09_JPRB, 0.53593591E-09_JPRB, 0.53592702E-09_JPRB, 0.53591959E-09_JPRB /)

RGHG6(:,84, 1) = (/ &
  & 0.53593269E-09_JPRB, 0.53592697E-09_JPRB, 0.53592497E-09_JPRB, 0.53593030E-09_JPRB, 0.53593008E-09_JPRB, 0.53592841E-09_JPRB, &
  & 0.53593602E-09_JPRB, 0.53593752E-09_JPRB, 0.53593974E-09_JPRB, 0.53594246E-09_JPRB, 0.53594190E-09_JPRB, 0.53594323E-09_JPRB, &
  & 0.53594879E-09_JPRB, 0.53595173E-09_JPRB, 0.53594684E-09_JPRB, 0.53594124E-09_JPRB, 0.53594124E-09_JPRB, 0.53594096E-09_JPRB, &
  & 0.53593646E-09_JPRB, 0.53594462E-09_JPRB, 0.53594867E-09_JPRB, 0.53595461E-09_JPRB, 0.53596033E-09_JPRB, 0.53597138E-09_JPRB, &
  & 0.53597671E-09_JPRB, 0.53598631E-09_JPRB, 0.53599020E-09_JPRB, 0.53599758E-09_JPRB, 0.53599525E-09_JPRB, 0.53599791E-09_JPRB, &
  & 0.53599303E-09_JPRB, 0.53599047E-09_JPRB, 0.53598442E-09_JPRB, 0.53598254E-09_JPRB, 0.53597932E-09_JPRB, 0.53597493E-09_JPRB, &
  & 0.53596622E-09_JPRB, 0.53596166E-09_JPRB, 0.53594956E-09_JPRB, 0.53594906E-09_JPRB, 0.53594434E-09_JPRB, 0.53594856E-09_JPRB, &
  & 0.53594218E-09_JPRB, 0.53594096E-09_JPRB, 0.53594995E-09_JPRB, 0.53595939E-09_JPRB, 0.53596450E-09_JPRB, 0.53596549E-09_JPRB, &
  & 0.53596927E-09_JPRB, 0.53596910E-09_JPRB, 0.53596549E-09_JPRB, 0.53596644E-09_JPRB, 0.53595622E-09_JPRB, 0.53595933E-09_JPRB, &
  & 0.53595162E-09_JPRB, 0.53595034E-09_JPRB, 0.53594656E-09_JPRB, 0.53594917E-09_JPRB, 0.53595101E-09_JPRB, 0.53594756E-09_JPRB, &
  & 0.53594656E-09_JPRB, 0.53593707E-09_JPRB, 0.53592814E-09_JPRB, 0.53592059E-09_JPRB /)

RGHG6(:,85, 1) = (/ &
  & 0.53593363E-09_JPRB, 0.53592791E-09_JPRB, 0.53592580E-09_JPRB, 0.53593124E-09_JPRB, 0.53593102E-09_JPRB, 0.53592947E-09_JPRB, &
  & 0.53593668E-09_JPRB, 0.53593868E-09_JPRB, 0.53594046E-09_JPRB, 0.53594335E-09_JPRB, 0.53594312E-09_JPRB, 0.53594473E-09_JPRB, &
  & 0.53594928E-09_JPRB, 0.53595223E-09_JPRB, 0.53594773E-09_JPRB, 0.53594212E-09_JPRB, 0.53594207E-09_JPRB, 0.53594185E-09_JPRB, &
  & 0.53593729E-09_JPRB, 0.53594512E-09_JPRB, 0.53594951E-09_JPRB, 0.53595495E-09_JPRB, 0.53596072E-09_JPRB, 0.53597166E-09_JPRB, &
  & 0.53597693E-09_JPRB, 0.53598670E-09_JPRB, 0.53599031E-09_JPRB, 0.53599797E-09_JPRB, 0.53599536E-09_JPRB, 0.53599808E-09_JPRB, &
  & 0.53599314E-09_JPRB, 0.53599053E-09_JPRB, 0.53598442E-09_JPRB, 0.53598281E-09_JPRB, 0.53597965E-09_JPRB, 0.53597543E-09_JPRB, &
  & 0.53596699E-09_JPRB, 0.53596261E-09_JPRB, 0.53595040E-09_JPRB, 0.53595001E-09_JPRB, 0.53594523E-09_JPRB, 0.53594962E-09_JPRB, &
  & 0.53594257E-09_JPRB, 0.53594129E-09_JPRB, 0.53595067E-09_JPRB, 0.53595989E-09_JPRB, 0.53596511E-09_JPRB, 0.53596594E-09_JPRB, &
  & 0.53596994E-09_JPRB, 0.53596966E-09_JPRB, 0.53596599E-09_JPRB, 0.53596694E-09_JPRB, 0.53595650E-09_JPRB, 0.53595994E-09_JPRB, &
  & 0.53595195E-09_JPRB, 0.53595078E-09_JPRB, 0.53594695E-09_JPRB, 0.53594978E-09_JPRB, 0.53595184E-09_JPRB, 0.53594840E-09_JPRB, &
  & 0.53594756E-09_JPRB, 0.53593796E-09_JPRB, 0.53592886E-09_JPRB, 0.53592114E-09_JPRB /)

RGHG6(:,86, 1) = (/ &
  & 0.53593430E-09_JPRB, 0.53592852E-09_JPRB, 0.53592630E-09_JPRB, 0.53593197E-09_JPRB, 0.53593163E-09_JPRB, 0.53593002E-09_JPRB, &
  & 0.53593763E-09_JPRB, 0.53593940E-09_JPRB, 0.53594140E-09_JPRB, 0.53594351E-09_JPRB, 0.53594396E-09_JPRB, 0.53594551E-09_JPRB, &
  & 0.53594934E-09_JPRB, 0.53595189E-09_JPRB, 0.53594812E-09_JPRB, 0.53594290E-09_JPRB, 0.53594262E-09_JPRB, 0.53594235E-09_JPRB, &
  & 0.53593774E-09_JPRB, 0.53594579E-09_JPRB, 0.53594978E-09_JPRB, 0.53595534E-09_JPRB, 0.53596066E-09_JPRB, 0.53597204E-09_JPRB, &
  & 0.53597699E-09_JPRB, 0.53598698E-09_JPRB, 0.53599042E-09_JPRB, 0.53599819E-09_JPRB, 0.53599536E-09_JPRB, 0.53599836E-09_JPRB, &
  & 0.53599319E-09_JPRB, 0.53599064E-09_JPRB, 0.53598448E-09_JPRB, 0.53598287E-09_JPRB, 0.53597998E-09_JPRB, 0.53597587E-09_JPRB, &
  & 0.53596744E-09_JPRB, 0.53596316E-09_JPRB, 0.53595067E-09_JPRB, 0.53595051E-09_JPRB, 0.53594551E-09_JPRB, 0.53595045E-09_JPRB, &
  & 0.53594301E-09_JPRB, 0.53594151E-09_JPRB, 0.53595089E-09_JPRB, 0.53596033E-09_JPRB, 0.53596561E-09_JPRB, 0.53596638E-09_JPRB, &
  & 0.53597043E-09_JPRB, 0.53596994E-09_JPRB, 0.53596627E-09_JPRB, 0.53596722E-09_JPRB, 0.53595667E-09_JPRB, 0.53596028E-09_JPRB, &
  & 0.53595212E-09_JPRB, 0.53595106E-09_JPRB, 0.53594712E-09_JPRB, 0.53595017E-09_JPRB, 0.53595245E-09_JPRB, 0.53594906E-09_JPRB, &
  & 0.53594829E-09_JPRB, 0.53593846E-09_JPRB, 0.53592925E-09_JPRB, 0.53592147E-09_JPRB /)

RGHG6(:,87, 1) = (/ &
  & 0.53593469E-09_JPRB, 0.53592891E-09_JPRB, 0.53592658E-09_JPRB, 0.53593241E-09_JPRB, 0.53593213E-09_JPRB, 0.53593113E-09_JPRB, &
  & 0.53593774E-09_JPRB, 0.53594007E-09_JPRB, 0.53594190E-09_JPRB, 0.53594390E-09_JPRB, 0.53594462E-09_JPRB, 0.53594612E-09_JPRB, &
  & 0.53594945E-09_JPRB, 0.53595145E-09_JPRB, 0.53594829E-09_JPRB, 0.53594346E-09_JPRB, 0.53594301E-09_JPRB, 0.53594262E-09_JPRB, &
  & 0.53593807E-09_JPRB, 0.53594601E-09_JPRB, 0.53595006E-09_JPRB, 0.53595534E-09_JPRB, 0.53596055E-09_JPRB, 0.53597227E-09_JPRB, &
  & 0.53597704E-09_JPRB, 0.53598725E-09_JPRB, 0.53599036E-09_JPRB, 0.53599858E-09_JPRB, 0.53599541E-09_JPRB, 0.53599847E-09_JPRB, &
  & 0.53599319E-09_JPRB, 0.53599070E-09_JPRB, 0.53598453E-09_JPRB, 0.53598292E-09_JPRB, 0.53598026E-09_JPRB, 0.53597632E-09_JPRB, &
  & 0.53596771E-09_JPRB, 0.53596400E-09_JPRB, 0.53595034E-09_JPRB, 0.53595112E-09_JPRB, 0.53594540E-09_JPRB, 0.53595134E-09_JPRB, &
  & 0.53594290E-09_JPRB, 0.53594140E-09_JPRB, 0.53595117E-09_JPRB, 0.53596055E-09_JPRB, 0.53596594E-09_JPRB, 0.53596660E-09_JPRB, &
  & 0.53597071E-09_JPRB, 0.53597010E-09_JPRB, 0.53596644E-09_JPRB, 0.53596744E-09_JPRB, 0.53595672E-09_JPRB, 0.53596044E-09_JPRB, &
  & 0.53595223E-09_JPRB, 0.53595101E-09_JPRB, 0.53594729E-09_JPRB, 0.53595028E-09_JPRB, 0.53595273E-09_JPRB, 0.53594951E-09_JPRB, &
  & 0.53594879E-09_JPRB, 0.53593874E-09_JPRB, 0.53592936E-09_JPRB, 0.53592164E-09_JPRB /)

RGHG6(:,88, 1) = (/ &
  & 0.53593480E-09_JPRB, 0.53592913E-09_JPRB, 0.53592675E-09_JPRB, 0.53593263E-09_JPRB, 0.53593230E-09_JPRB, 0.53593102E-09_JPRB, &
  & 0.53593829E-09_JPRB, 0.53594029E-09_JPRB, 0.53594212E-09_JPRB, 0.53594396E-09_JPRB, 0.53594473E-09_JPRB, 0.53594640E-09_JPRB, &
  & 0.53594945E-09_JPRB, 0.53595145E-09_JPRB, 0.53594851E-09_JPRB, 0.53594384E-09_JPRB, 0.53594335E-09_JPRB, 0.53594285E-09_JPRB, &
  & 0.53593818E-09_JPRB, 0.53594612E-09_JPRB, 0.53595023E-09_JPRB, 0.53595545E-09_JPRB, 0.53596050E-09_JPRB, 0.53597249E-09_JPRB, &
  & 0.53597687E-09_JPRB, 0.53598731E-09_JPRB, 0.53599031E-09_JPRB, 0.53599886E-09_JPRB, 0.53599536E-09_JPRB, 0.53599852E-09_JPRB, &
  & 0.53599319E-09_JPRB, 0.53599081E-09_JPRB, 0.53598442E-09_JPRB, 0.53598304E-09_JPRB, 0.53598037E-09_JPRB, 0.53597665E-09_JPRB, &
  & 0.53596783E-09_JPRB, 0.53596450E-09_JPRB, 0.53594990E-09_JPRB, 0.53595156E-09_JPRB, 0.53594501E-09_JPRB, 0.53595195E-09_JPRB, &
  & 0.53594290E-09_JPRB, 0.53594129E-09_JPRB, 0.53595128E-09_JPRB, 0.53596072E-09_JPRB, 0.53596616E-09_JPRB, 0.53596672E-09_JPRB, &
  & 0.53597093E-09_JPRB, 0.53597027E-09_JPRB, 0.53596655E-09_JPRB, 0.53596760E-09_JPRB, 0.53595672E-09_JPRB, 0.53596055E-09_JPRB, &
  & 0.53595223E-09_JPRB, 0.53595095E-09_JPRB, 0.53594729E-09_JPRB, 0.53595051E-09_JPRB, 0.53595300E-09_JPRB, 0.53594973E-09_JPRB, &
  & 0.53594901E-09_JPRB, 0.53593885E-09_JPRB, 0.53592958E-09_JPRB, 0.53592175E-09_JPRB /)

RGHG6(:,89, 1) = (/ &
  & 0.53593474E-09_JPRB, 0.53592941E-09_JPRB, 0.53592691E-09_JPRB, 0.53593285E-09_JPRB, 0.53593269E-09_JPRB, 0.53593113E-09_JPRB, &
  & 0.53593807E-09_JPRB, 0.53594029E-09_JPRB, 0.53594218E-09_JPRB, 0.53594412E-09_JPRB, 0.53594484E-09_JPRB, 0.53594645E-09_JPRB, &
  & 0.53594995E-09_JPRB, 0.53595200E-09_JPRB, 0.53594873E-09_JPRB, 0.53594373E-09_JPRB, 0.53594340E-09_JPRB, 0.53594296E-09_JPRB, &
  & 0.53593807E-09_JPRB, 0.53594645E-09_JPRB, 0.53595028E-09_JPRB, 0.53595545E-09_JPRB, 0.53596039E-09_JPRB, 0.53597249E-09_JPRB, &
  & 0.53597687E-09_JPRB, 0.53598759E-09_JPRB, 0.53599020E-09_JPRB, 0.53599908E-09_JPRB, 0.53599536E-09_JPRB, 0.53599875E-09_JPRB, &
  & 0.53599314E-09_JPRB, 0.53599097E-09_JPRB, 0.53598437E-09_JPRB, 0.53598304E-09_JPRB, 0.53598059E-09_JPRB, 0.53597710E-09_JPRB, &
  & 0.53596783E-09_JPRB, 0.53596505E-09_JPRB, 0.53594945E-09_JPRB, 0.53595189E-09_JPRB, 0.53594479E-09_JPRB, 0.53595239E-09_JPRB, &
  & 0.53594268E-09_JPRB, 0.53594112E-09_JPRB, 0.53595123E-09_JPRB, 0.53596072E-09_JPRB, 0.53596627E-09_JPRB, 0.53596683E-09_JPRB, &
  & 0.53597105E-09_JPRB, 0.53597038E-09_JPRB, 0.53596672E-09_JPRB, 0.53596777E-09_JPRB, 0.53595672E-09_JPRB, 0.53596078E-09_JPRB, &
  & 0.53595223E-09_JPRB, 0.53595106E-09_JPRB, 0.53594712E-09_JPRB, 0.53595062E-09_JPRB, 0.53595328E-09_JPRB, 0.53594990E-09_JPRB, &
  & 0.53594940E-09_JPRB, 0.53593896E-09_JPRB, 0.53592947E-09_JPRB, 0.53592170E-09_JPRB /)

RGHG6(:,90, 1) = (/ &
  & 0.53593452E-09_JPRB, 0.53592952E-09_JPRB, 0.53592686E-09_JPRB, 0.53593308E-09_JPRB, 0.53593252E-09_JPRB, 0.53592986E-09_JPRB, &
  & 0.53593857E-09_JPRB, 0.53594007E-09_JPRB, 0.53594185E-09_JPRB, 0.53594412E-09_JPRB, 0.53594451E-09_JPRB, 0.53594629E-09_JPRB, &
  & 0.53595056E-09_JPRB, 0.53595323E-09_JPRB, 0.53594884E-09_JPRB, 0.53594323E-09_JPRB, 0.53594340E-09_JPRB, 0.53594307E-09_JPRB, &
  & 0.53593752E-09_JPRB, 0.53594662E-09_JPRB, 0.53595034E-09_JPRB, 0.53595550E-09_JPRB, 0.53596017E-09_JPRB, 0.53597266E-09_JPRB, &
  & 0.53597671E-09_JPRB, 0.53598787E-09_JPRB, 0.53598997E-09_JPRB, 0.53599941E-09_JPRB, 0.53599519E-09_JPRB, 0.53599913E-09_JPRB, &
  & 0.53599314E-09_JPRB, 0.53599114E-09_JPRB, 0.53598431E-09_JPRB, 0.53598315E-09_JPRB, 0.53598087E-09_JPRB, 0.53597732E-09_JPRB, &
  & 0.53596771E-09_JPRB, 0.53596561E-09_JPRB, 0.53594884E-09_JPRB, 0.53595228E-09_JPRB, 0.53594434E-09_JPRB, 0.53595295E-09_JPRB, &
  & 0.53594251E-09_JPRB, 0.53594090E-09_JPRB, 0.53595123E-09_JPRB, 0.53596078E-09_JPRB, 0.53596649E-09_JPRB, 0.53596683E-09_JPRB, &
  & 0.53597127E-09_JPRB, 0.53597060E-09_JPRB, 0.53596666E-09_JPRB, 0.53596821E-09_JPRB, 0.53595639E-09_JPRB, 0.53596105E-09_JPRB, &
  & 0.53595200E-09_JPRB, 0.53595106E-09_JPRB, 0.53594701E-09_JPRB, 0.53595078E-09_JPRB, 0.53595350E-09_JPRB, 0.53594995E-09_JPRB, &
  & 0.53594967E-09_JPRB, 0.53593896E-09_JPRB, 0.53592936E-09_JPRB, 0.53592164E-09_JPRB /)

RGHG6(:,91, 1) = (/ &
  & 0.53593407E-09_JPRB, 0.53592997E-09_JPRB, 0.53592608E-09_JPRB, 0.53593358E-09_JPRB, 0.53593280E-09_JPRB, 0.53592802E-09_JPRB, &
  & 0.53593924E-09_JPRB, 0.53593951E-09_JPRB, 0.53594101E-09_JPRB, 0.53594568E-09_JPRB, 0.53594329E-09_JPRB, 0.53594462E-09_JPRB, &
  & 0.53595223E-09_JPRB, 0.53595589E-09_JPRB, 0.53594884E-09_JPRB, 0.53594207E-09_JPRB, 0.53594346E-09_JPRB, 0.53594357E-09_JPRB, &
  & 0.53593624E-09_JPRB, 0.53594706E-09_JPRB, 0.53595028E-09_JPRB, 0.53595550E-09_JPRB, 0.53595967E-09_JPRB, 0.53597327E-09_JPRB, &
  & 0.53597626E-09_JPRB, 0.53598831E-09_JPRB, 0.53598970E-09_JPRB, 0.53600052E-09_JPRB, 0.53599453E-09_JPRB, 0.53599986E-09_JPRB, &
  & 0.53599286E-09_JPRB, 0.53599170E-09_JPRB, 0.53598365E-09_JPRB, 0.53598315E-09_JPRB, 0.53598104E-09_JPRB, 0.53597815E-09_JPRB, &
  & 0.53596666E-09_JPRB, 0.53596660E-09_JPRB, 0.53594734E-09_JPRB, 0.53595289E-09_JPRB, 0.53594340E-09_JPRB, 0.53595428E-09_JPRB, &
  & 0.53594190E-09_JPRB, 0.53594001E-09_JPRB, 0.53595134E-09_JPRB, 0.53596105E-09_JPRB, 0.53596699E-09_JPRB, 0.53596644E-09_JPRB, &
  & 0.53597160E-09_JPRB, 0.53597077E-09_JPRB, 0.53596627E-09_JPRB, 0.53596899E-09_JPRB, 0.53595528E-09_JPRB, 0.53596194E-09_JPRB, &
  & 0.53595151E-09_JPRB, 0.53595123E-09_JPRB, 0.53594645E-09_JPRB, 0.53595089E-09_JPRB, 0.53595395E-09_JPRB, 0.53594973E-09_JPRB, &
  & 0.53595028E-09_JPRB, 0.53593852E-09_JPRB, 0.53592880E-09_JPRB, 0.53592136E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART2',1,ZHOOK_HANDLE)
END SUBROUTINE PART2






SUBROUTINE PART3
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART3',0,ZHOOK_HANDLE)



!-- Month=  2 ------------

RGHG6(:, 1, 2) = (/ &
  & 0.27346467E-36_JPRB, 0.16445201E-35_JPRB, 0.38616514E-35_JPRB, 0.56667444E-35_JPRB, 0.78732372E-35_JPRB, 0.10958829E-34_JPRB, &
  & 0.16095700E-34_JPRB, 0.25596952E-34_JPRB, 0.41070343E-34_JPRB, 0.67039711E-34_JPRB, 0.11081603E-33_JPRB, 0.18558412E-33_JPRB, &
  & 0.32413701E-33_JPRB, 0.57718421E-33_JPRB, 0.96728886E-33_JPRB, 0.15970790E-32_JPRB, 0.26351083E-32_JPRB, 0.42851787E-32_JPRB, &
  & 0.67641574E-32_JPRB, 0.10410404E-31_JPRB, 0.15388824E-31_JPRB, 0.21708379E-31_JPRB, 0.29328752E-31_JPRB, 0.38409730E-31_JPRB, &
  & 0.49216870E-31_JPRB, 0.62482303E-31_JPRB, 0.78722204E-31_JPRB, 0.96372217E-31_JPRB, 0.11449520E-30_JPRB, 0.13225865E-30_JPRB, &
  & 0.14707966E-30_JPRB, 0.15515705E-30_JPRB, 0.15290946E-30_JPRB, 0.14196600E-30_JPRB, 0.12425529E-30_JPRB, 0.10138265E-30_JPRB, &
  & 0.77507772E-31_JPRB, 0.54988139E-31_JPRB, 0.36915048E-31_JPRB, 0.23789721E-31_JPRB, 0.14527851E-31_JPRB, 0.83628812E-32_JPRB, &
  & 0.45927879E-32_JPRB, 0.24624107E-32_JPRB, 0.13102997E-32_JPRB, 0.69987597E-33_JPRB, 0.37748850E-33_JPRB, 0.20685482E-33_JPRB, &
  & 0.11515317E-33_JPRB, 0.64979789E-34_JPRB, 0.37062097E-34_JPRB, 0.21354186E-34_JPRB, 0.12468700E-34_JPRB, 0.74369404E-35_JPRB, &
  & 0.45837040E-35_JPRB, 0.29569236E-35_JPRB, 0.20174902E-35_JPRB, 0.14665720E-35_JPRB, 0.11173029E-35_JPRB, 0.88189430E-36_JPRB, &
  & 0.71135309E-36_JPRB, 0.56781421E-36_JPRB, 0.44302865E-36_JPRB, 0.36238233E-36_JPRB /)

RGHG6(:, 2, 2) = (/ &
  & 0.12338644E-34_JPRB, 0.68956335E-34_JPRB, 0.15455373E-33_JPRB, 0.22626195E-33_JPRB, 0.31552112E-33_JPRB, 0.44352917E-33_JPRB, &
  & 0.65973596E-33_JPRB, 0.10353424E-32_JPRB, 0.16629307E-32_JPRB, 0.27186462E-32_JPRB, 0.44954441E-32_JPRB, 0.75478639E-32_JPRB, &
  & 0.13155172E-31_JPRB, 0.23184563E-31_JPRB, 0.38885988E-31_JPRB, 0.64416209E-31_JPRB, 0.10635076E-30_JPRB, 0.17234147E-30_JPRB, &
  & 0.27108778E-30_JPRB, 0.41445091E-30_JPRB, 0.60943119E-30_JPRB, 0.85910948E-30_JPRB, 0.11652076E-29_JPRB, 0.15361454E-29_JPRB, &
  & 0.19828205E-29_JPRB, 0.25213904E-29_JPRB, 0.31589246E-29_JPRB, 0.38639522E-29_JPRB, 0.45949472E-29_JPRB, 0.52951950E-29_JPRB, &
  & 0.58680821E-29_JPRB, 0.61725009E-29_JPRB, 0.60755879E-29_JPRB, 0.56249688E-29_JPRB, 0.49073823E-29_JPRB, 0.39964201E-29_JPRB, &
  & 0.30540818E-29_JPRB, 0.21889520E-29_JPRB, 0.14846025E-29_JPRB, 0.95930881E-30_JPRB, 0.58720889E-30_JPRB, 0.33949076E-30_JPRB, &
  & 0.18810218E-30_JPRB, 0.10223310E-30_JPRB, 0.55414003E-31_JPRB, 0.30251147E-31_JPRB, 0.16697740E-31_JPRB, 0.93454710E-32_JPRB, &
  & 0.52986429E-32_JPRB, 0.30375902E-32_JPRB, 0.17575845E-32_JPRB, 0.10263663E-32_JPRB, 0.60652028E-33_JPRB, 0.36512186E-33_JPRB, &
  & 0.22610581E-33_JPRB, 0.14570044E-33_JPRB, 0.98524989E-34_JPRB, 0.70222001E-34_JPRB, 0.52481191E-34_JPRB, 0.40875242E-34_JPRB, &
  & 0.32807875E-34_JPRB, 0.26524803E-34_JPRB, 0.21022218E-34_JPRB, 0.16208601E-34_JPRB /)

RGHG6(:, 3, 2) = (/ &
  & 0.58082191E-33_JPRB, 0.36528840E-32_JPRB, 0.76192612E-32_JPRB, 0.10814530E-31_JPRB, 0.15046649E-31_JPRB, 0.21267701E-31_JPRB, &
  & 0.31919609E-31_JPRB, 0.50042205E-31_JPRB, 0.80497359E-31_JPRB, 0.13160233E-30_JPRB, 0.21789546E-30_JPRB, 0.36627727E-30_JPRB, &
  & 0.63700429E-30_JPRB, 0.11180038E-29_JPRB, 0.18699241E-29_JPRB, 0.30875597E-29_JPRB, 0.50646304E-29_JPRB, 0.81218467E-29_JPRB, &
  & 0.12662181E-28_JPRB, 0.19248246E-28_JPRB, 0.28340167E-28_JPRB, 0.40240200E-28_JPRB, 0.55160891E-28_JPRB, 0.73473644E-28_JPRB, &
  & 0.95622963E-28_JPRB, 0.12178483E-27_JPRB, 0.15214779E-27_JPRB, 0.18557318E-27_JPRB, 0.22032472E-27_JPRB, 0.25350681E-27_JPRB, &
  & 0.28044087E-27_JPRB, 0.29437943E-27_JPRB, 0.28921579E-27_JPRB, 0.26730454E-27_JPRB, 0.23255864E-27_JPRB, 0.18945106E-27_JPRB, &
  & 0.14490187E-27_JPRB, 0.10451509E-27_JPRB, 0.71170761E-28_JPRB, 0.45938000E-28_JPRB, 0.27882377E-28_JPRB, 0.15915625E-28_JPRB, &
  & 0.87039387E-29_JPRB, 0.47065094E-29_JPRB, 0.25643473E-29_JPRB, 0.14197374E-29_JPRB, 0.79864722E-30_JPRB, 0.45563985E-30_JPRB, &
  & 0.26245554E-30_JPRB, 0.15202960E-30_JPRB, 0.88326070E-31_JPRB, 0.51446392E-31_JPRB, 0.30111175E-31_JPRB, 0.17821859E-31_JPRB, &
  & 0.10776139E-31_JPRB, 0.67441042E-32_JPRB, 0.44238679E-32_JPRB, 0.30686302E-32_JPRB, 0.22554052E-32_JPRB, 0.17496648E-32_JPRB, &
  & 0.14098955E-32_JPRB, 0.11410516E-32_JPRB, 0.88339209E-33_JPRB, 0.60981488E-33_JPRB /)

RGHG6(:, 4, 2) = (/ &
  & 0.94437006E-31_JPRB, 0.43168351E-30_JPRB, 0.76091386E-30_JPRB, 0.10245703E-29_JPRB, 0.14126285E-29_JPRB, 0.20047573E-29_JPRB, &
  & 0.30194609E-29_JPRB, 0.47405505E-29_JPRB, 0.76109531E-29_JPRB, 0.12441510E-28_JPRB, 0.20582504E-28_JPRB, 0.34566840E-28_JPRB, &
  & 0.60004273E-28_JPRB, 0.10474798E-27_JPRB, 0.17441439E-27_JPRB, 0.28608885E-27_JPRB, 0.46460537E-27_JPRB, 0.73761952E-27_JPRB, &
  & 0.11364036E-26_JPRB, 0.17142246E-26_JPRB, 0.25166017E-26_JPRB, 0.35832678E-26_JPRB, 0.49366542E-26_JPRB, 0.66129840E-26_JPRB, &
  & 0.86190819E-26_JPRB, 0.10955177E-25_JPRB, 0.13610454E-25_JPRB, 0.16531032E-25_JPRB, 0.19575093E-25_JPRB, 0.22496008E-25_JPRB, &
  & 0.24853448E-25_JPRB, 0.26049358E-25_JPRB, 0.25559087E-25_JPRB, 0.23594304E-25_JPRB, 0.20541693E-25_JPRB, 0.16739135E-25_JPRB, &
  & 0.12848349E-25_JPRB, 0.92995307E-26_JPRB, 0.63614633E-26_JPRB, 0.41066103E-26_JPRB, 0.24827538E-26_JPRB, 0.14043600E-26_JPRB, &
  & 0.76372482E-27_JPRB, 0.41401764E-27_JPRB, 0.22835910E-27_JPRB, 0.12882811E-27_JPRB, 0.74039813E-28_JPRB, 0.43113519E-28_JPRB, &
  & 0.25249402E-28_JPRB, 0.14783851E-28_JPRB, 0.86216300E-29_JPRB, 0.50037450E-29_JPRB, 0.28967211E-29_JPRB, 0.16837636E-29_JPRB, &
  & 0.99349604E-30_JPRB, 0.60447916E-30_JPRB, 0.38559106E-30_JPRB, 0.26226793E-30_JPRB, 0.19178362E-30_JPRB, 0.15023340E-30_JPRB, &
  & 0.12374832E-30_JPRB, 0.10272958E-30_JPRB, 0.80619587E-31_JPRB, 0.51786821E-31_JPRB /)

RGHG6(:, 5, 2) = (/ &
  & 0.60245797E-28_JPRB, 0.12545925E-27_JPRB, 0.18298565E-27_JPRB, 0.23385311E-27_JPRB, 0.32156730E-27_JPRB, 0.45727552E-27_JPRB, &
  & 0.68851490E-27_JPRB, 0.10752714E-26_JPRB, 0.17159134E-26_JPRB, 0.27843936E-26_JPRB, 0.45697961E-26_JPRB, 0.76053464E-26_JPRB, &
  & 0.13051909E-25_JPRB, 0.22494021E-25_JPRB, 0.36895302E-25_JPRB, 0.59490343E-25_JPRB, 0.94899690E-25_JPRB, 0.14749130E-24_JPRB, &
  & 0.22280045E-24_JPRB, 0.32930705E-24_JPRB, 0.47523703E-24_JPRB, 0.66695054E-24_JPRB, 0.90827591E-24_JPRB, 0.12026910E-23_JPRB, &
  & 0.15494311E-23_JPRB, 0.19422651E-23_JPRB, 0.23835168E-23_JPRB, 0.28633978E-23_JPRB, 0.33680385E-23_JPRB, 0.38521107E-23_JPRB, &
  & 0.42445915E-23_JPRB, 0.44422801E-23_JPRB, 0.43575824E-23_JPRB, 0.40316870E-23_JPRB, 0.35225038E-23_JPRB, 0.28890019E-23_JPRB, &
  & 0.22332364E-23_JPRB, 0.16338504E-23_JPRB, 0.11301702E-23_JPRB, 0.73894371E-24_JPRB, 0.45163302E-24_JPRB, 0.25868763E-24_JPRB, &
  & 0.14274946E-24_JPRB, 0.79055924E-25_JPRB, 0.44726392E-25_JPRB, 0.25946911E-25_JPRB, 0.15340576E-25_JPRB, 0.91753737E-26_JPRB, &
  & 0.55017736E-26_JPRB, 0.32828774E-26_JPRB, 0.19402693E-26_JPRB, 0.11348749E-26_JPRB, 0.65891832E-27_JPRB, 0.38269745E-27_JPRB, &
  & 0.22502048E-27_JPRB, 0.13617743E-27_JPRB, 0.86427683E-28_JPRB, 0.58669736E-28_JPRB, 0.43083110E-28_JPRB, 0.34190535E-28_JPRB, &
  & 0.28729437E-28_JPRB, 0.24862197E-28_JPRB, 0.21005233E-28_JPRB, 0.15493944E-28_JPRB /)

RGHG6(:, 6, 2) = (/ &
  & 0.32007846E-25_JPRB, 0.67111682E-25_JPRB, 0.95343085E-25_JPRB, 0.12337877E-24_JPRB, 0.17185299E-24_JPRB, 0.24373066E-24_JPRB, &
  & 0.36352611E-24_JPRB, 0.55808211E-24_JPRB, 0.87162819E-24_JPRB, 0.13783592E-23_JPRB, 0.21973519E-23_JPRB, 0.35377374E-23_JPRB, &
  & 0.58570445E-23_JPRB, 0.97093418E-23_JPRB, 0.15281793E-22_JPRB, 0.23600102E-22_JPRB, 0.35966131E-22_JPRB, 0.53454149E-22_JPRB, &
  & 0.77106786E-22_JPRB, 0.10907524E-21_JPRB, 0.15086329E-21_JPRB, 0.20362850E-21_JPRB, 0.26747115E-21_JPRB, 0.34277319E-21_JPRB, &
  & 0.42840797E-21_JPRB, 0.52273059E-21_JPRB, 0.62610262E-21_JPRB, 0.73833493E-21_JPRB, 0.85563070E-21_JPRB, 0.96980969E-21_JPRB, &
  & 0.10630414E-20_JPRB, 0.11111320E-20_JPRB, 0.10928610E-20_JPRB, 0.10172771E-20_JPRB, 0.89763102E-21_JPRB, 0.74557882E-21_JPRB, &
  & 0.58648928E-21_JPRB, 0.43788510E-21_JPRB, 0.31072797E-21_JPRB, 0.20898276E-21_JPRB, 0.13193017E-21_JPRB, 0.78141860E-22_JPRB, &
  & 0.44812913E-22_JPRB, 0.25833016E-22_JPRB, 0.15251048E-22_JPRB, 0.92370058E-23_JPRB, 0.57014804E-23_JPRB, 0.35565265E-23_JPRB, &
  & 0.22195960E-23_JPRB, 0.13743312E-23_JPRB, 0.83989626E-24_JPRB, 0.50624508E-24_JPRB, 0.30215135E-24_JPRB, 0.18016846E-24_JPRB, &
  & 0.10871055E-24_JPRB, 0.67473899E-25_JPRB, 0.43859008E-25_JPRB, 0.30430898E-25_JPRB, 0.22802165E-25_JPRB, 0.18403784E-25_JPRB, &
  & 0.15755315E-25_JPRB, 0.13974452E-25_JPRB, 0.12535425E-25_JPRB, 0.10632233E-25_JPRB /)

RGHG6(:, 7, 2) = (/ &
  & 0.27329326E-22_JPRB, 0.49971161E-22_JPRB, 0.70990962E-22_JPRB, 0.93380103E-22_JPRB, 0.13027034E-21_JPRB, 0.18350514E-21_JPRB, &
  & 0.26744551E-21_JPRB, 0.39848015E-21_JPRB, 0.59887695E-21_JPRB, 0.90651947E-21_JPRB, 0.13744712E-20_JPRB, 0.20943407E-20_JPRB, &
  & 0.32692458E-20_JPRB, 0.51000596E-20_JPRB, 0.75353940E-20_JPRB, 0.10907784E-19_JPRB, 0.15587274E-19_JPRB, 0.21726322E-19_JPRB, &
  & 0.29478791E-19_JPRB, 0.39297115E-19_JPRB, 0.51424746E-19_JPRB, 0.65908498E-19_JPRB, 0.82561563E-19_JPRB, 0.10137285E-18_JPRB, &
  & 0.12193278E-18_JPRB, 0.14387426E-18_JPRB, 0.16757065E-18_JPRB, 0.19303918E-18_JPRB, 0.22003046E-18_JPRB, 0.24652469E-18_JPRB, &
  & 0.26876117E-18_JPRB, 0.28083182E-18_JPRB, 0.27740644E-18_JPRB, 0.26042119E-18_JPRB, 0.23250325E-18_JPRB, 0.19630221E-18_JPRB, &
  & 0.15757355E-18_JPRB, 0.12076656E-18_JPRB, 0.88389845E-19_JPRB, 0.61651606E-19_JPRB, 0.40512696E-19_JPRB, 0.25085389E-19_JPRB, &
  & 0.15058180E-19_JPRB, 0.91152646E-20_JPRB, 0.56584405E-20_JPRB, 0.36089652E-20_JPRB, 0.23474071E-20_JPRB, 0.15433654E-20_JPRB, &
  & 0.10147943E-20_JPRB, 0.66134241E-21_JPRB, 0.42478006E-21_JPRB, 0.26871023E-21_JPRB, 0.16813577E-21_JPRB, 0.10502360E-21_JPRB, &
  & 0.66334935E-22_JPRB, 0.43036079E-22_JPRB, 0.29171767E-22_JPRB, 0.21044647E-22_JPRB, 0.16309379E-22_JPRB, 0.13530681E-22_JPRB, &
  & 0.11814806E-22_JPRB, 0.10654799E-22_JPRB, 0.97105212E-23_JPRB, 0.85312712E-23_JPRB /)

RGHG6(:, 8, 2) = (/ &
  & 0.21004195E-19_JPRB, 0.36775448E-19_JPRB, 0.51852253E-19_JPRB, 0.68006092E-19_JPRB, 0.94594255E-19_JPRB, 0.13071756E-18_JPRB, &
  & 0.18588329E-18_JPRB, 0.26749405E-18_JPRB, 0.38598437E-18_JPRB, 0.55675449E-18_JPRB, 0.79975347E-18_JPRB, 0.11478153E-17_JPRB, &
  & 0.16812168E-17_JPRB, 0.24559720E-17_JPRB, 0.33898056E-17_JPRB, 0.45783268E-17_JPRB, 0.61069719E-17_JPRB, 0.79600988E-17_JPRB, &
  & 0.10122322E-16_JPRB, 0.12692104E-16_JPRB, 0.15676504E-16_JPRB, 0.19043369E-16_JPRB, 0.22707893E-16_JPRB, 0.26652676E-16_JPRB, &
  & 0.30811187E-16_JPRB, 0.35113433E-16_JPRB, 0.39712925E-16_JPRB, 0.44695282E-16_JPRB, 0.50034871E-16_JPRB, 0.55411962E-16_JPRB, &
  & 0.60045160E-16_JPRB, 0.62714372E-16_JPRB, 0.62226779E-16_JPRB, 0.58910050E-16_JPRB, 0.53249745E-16_JPRB, 0.45683935E-16_JPRB, &
  & 0.37474650E-16_JPRB, 0.29504967E-16_JPRB, 0.22317201E-16_JPRB, 0.16177285E-16_JPRB, 0.11095730E-16_JPRB, 0.71878587E-17_JPRB, &
  & 0.45210640E-17_JPRB, 0.28723783E-17_JPRB, 0.18755998E-17_JPRB, 0.12608720E-17_JPRB, 0.86549205E-18_JPRB, 0.60110217E-18_JPRB, &
  & 0.41765642E-18_JPRB, 0.28761923E-18_JPRB, 0.19512896E-18_JPRB, 0.13025928E-18_JPRB, 0.85891255E-19_JPRB, 0.56427101E-19_JPRB, &
  & 0.37385552E-19_JPRB, 0.25370466E-19_JPRB, 0.17936032E-19_JPRB, 0.13450668E-19_JPRB, 0.10784571E-19_JPRB, 0.92044959E-20_JPRB, &
  & 0.82038998E-20_JPRB, 0.74989076E-20_JPRB, 0.69056366E-20_JPRB, 0.61000047E-20_JPRB /)

RGHG6(:, 9, 2) = (/ &
  & 0.14008754E-16_JPRB, 0.24060778E-16_JPRB, 0.33601632E-16_JPRB, 0.43740788E-16_JPRB, 0.60024864E-16_JPRB, 0.81489678E-16_JPRB, &
  & 0.11280480E-15_JPRB, 0.15715669E-15_JPRB, 0.21788071E-15_JPRB, 0.30006306E-15_JPRB, 0.40882964E-15_JPRB, 0.55323544E-15_JPRB, &
  & 0.76080743E-15_JPRB, 0.10410106E-14_JPRB, 0.13419261E-14_JPRB, 0.16905755E-14_JPRB, 0.21041099E-14_JPRB, 0.25632149E-14_JPRB, &
  & 0.30536762E-14_JPRB, 0.35981485E-14_JPRB, 0.41921931E-14_JPRB, 0.48222852E-14_JPRB, 0.54668942E-14_JPRB, 0.61301223E-14_JPRB, &
  & 0.68017419E-14_JPRB, 0.74824324E-14_JPRB, 0.82141672E-14_JPRB, 0.90223519E-14_JPRB, 0.99144258E-14_JPRB, 0.10835488E-13_JPRB, &
  & 0.11652846E-13_JPRB, 0.12146263E-13_JPRB, 0.12092539E-13_JPRB, 0.11543739E-13_JPRB, 0.10567318E-13_JPRB, 0.92286137E-14_JPRB, &
  & 0.77455420E-14_JPRB, 0.62772786E-14_JPRB, 0.49186174E-14_JPRB, 0.37120562E-14_JPRB, 0.26639165E-14_JPRB, 0.18083285E-14_JPRB, &
  & 0.11923109E-14_JPRB, 0.79497293E-15_JPRB, 0.54627495E-15_JPRB, 0.38720682E-15_JPRB, 0.28067951E-15_JPRB, 0.20604961E-15_JPRB, &
  & 0.15140866E-15_JPRB, 0.11029272E-15_JPRB, 0.79121262E-16_JPRB, 0.55787238E-16_JPRB, 0.38764440E-16_JPRB, 0.26739852E-16_JPRB, &
  & 0.18535347E-16_JPRB, 0.13102994E-16_JPRB, 0.96188565E-17_JPRB, 0.74651793E-17_JPRB, 0.61784122E-17_JPRB, 0.53960097E-17_JPRB, &
  & 0.48972124E-17_JPRB, 0.45311076E-17_JPRB, 0.42012106E-17_JPRB, 0.37356209E-17_JPRB /)

RGHG6(:,10, 2) = (/ &
  & 0.79988125E-14_JPRB, 0.13580172E-13_JPRB, 0.18802880E-13_JPRB, 0.24204258E-13_JPRB, 0.32810590E-13_JPRB, 0.43642895E-13_JPRB, &
  & 0.58942773E-13_JPRB, 0.79567300E-13_JPRB, 0.10620206E-12_JPRB, 0.13985990E-12_JPRB, 0.18101498E-12_JPRB, 0.23128415E-12_JPRB, &
  & 0.29895254E-12_JPRB, 0.38342205E-12_JPRB, 0.46189035E-12_JPRB, 0.54284826E-12_JPRB, 0.63049804E-12_JPRB, 0.71760008E-12_JPRB, &
  & 0.80043838E-12_JPRB, 0.88562155E-12_JPRB, 0.97214934E-12_JPRB, 0.10575918E-11_JPRB, 0.11387310E-11_JPRB, 0.12182434E-11_JPRB, &
  & 0.12966733E-11_JPRB, 0.13758158E-11_JPRB, 0.14650824E-11_JPRB, 0.15696281E-11_JPRB, 0.16912448E-11_JPRB, 0.18219629E-11_JPRB, &
  & 0.19416688E-11_JPRB, 0.20167971E-11_JPRB, 0.20124325E-11_JPRB, 0.19361951E-11_JPRB, 0.17962765E-11_JPRB, 0.15983615E-11_JPRB, &
  & 0.13752547E-11_JPRB, 0.11495759E-11_JPRB, 0.93443862E-12_JPRB, 0.73600620E-12_JPRB, 0.55350933E-12_JPRB, 0.39467087E-12_JPRB, &
  & 0.27319436E-12_JPRB, 0.19151651E-12_JPRB, 0.13861140E-12_JPRB, 0.10373970E-12_JPRB, 0.79460066E-13_JPRB, 0.61689870E-13_JPRB, &
  & 0.47947523E-13_JPRB, 0.36942681E-13_JPRB, 0.28015979E-13_JPRB, 0.20848371E-13_JPRB, 0.15243715E-13_JPRB, 0.11021165E-13_JPRB, &
  & 0.79647414E-14_JPRB, 0.58486033E-14_JPRB, 0.44405499E-14_JPRB, 0.35597508E-14_JPRB, 0.30166541E-14_JPRB, 0.26940366E-14_JPRB, &
  & 0.24767616E-14_JPRB, 0.23139547E-14_JPRB, 0.21622159E-14_JPRB, 0.19314964E-14_JPRB /)

RGHG6(:,11, 2) = (/ &
  & 0.59371941E-13_JPRB, 0.82785361E-13_JPRB, 0.10402969E-12_JPRB, 0.12029337E-12_JPRB, 0.14631593E-12_JPRB, 0.18347253E-12_JPRB, &
  & 0.23344895E-12_JPRB, 0.29926818E-12_JPRB, 0.38395204E-12_JPRB, 0.49220431E-12_JPRB, 0.62588812E-12_JPRB, 0.78294543E-12_JPRB, &
  & 0.96406617E-12_JPRB, 0.11795081E-11_JPRB, 0.14417882E-11_JPRB, 0.17288857E-11_JPRB, 0.20318315E-11_JPRB, 0.23447329E-11_JPRB, &
  & 0.26519375E-11_JPRB, 0.29549995E-11_JPRB, 0.32402926E-11_JPRB, 0.35013078E-11_JPRB, 0.37326492E-11_JPRB, 0.39265067E-11_JPRB, &
  & 0.40905074E-11_JPRB, 0.42219934E-11_JPRB, 0.43376951E-11_JPRB, 0.44483211E-11_JPRB, 0.45523884E-11_JPRB, 0.46334546E-11_JPRB, &
  & 0.46560655E-11_JPRB, 0.45718611E-11_JPRB, 0.43324164E-11_JPRB, 0.39422536E-11_JPRB, 0.34387757E-11_JPRB, 0.29012394E-11_JPRB, &
  & 0.23958543E-11_JPRB, 0.19607916E-11_JPRB, 0.15870611E-11_JPRB, 0.12626908E-11_JPRB, 0.98203769E-12_JPRB, 0.74680583E-12_JPRB, &
  & 0.56026738E-12_JPRB, 0.42194368E-12_JPRB, 0.32604315E-12_JPRB, 0.25987611E-12_JPRB, 0.21221051E-12_JPRB, 0.17571272E-12_JPRB, &
  & 0.14584648E-12_JPRB, 0.12016327E-12_JPRB, 0.97546801E-13_JPRB, 0.77684800E-13_JPRB, 0.60632746E-13_JPRB, 0.46528638E-13_JPRB, &
  & 0.35498599E-13_JPRB, 0.27316231E-13_JPRB, 0.21668057E-13_JPRB, 0.17965547E-13_JPRB, 0.15744494E-13_JPRB, 0.14309673E-13_JPRB, &
  & 0.13374943E-13_JPRB, 0.12635508E-13_JPRB, 0.11933267E-13_JPRB, 0.10896756E-13_JPRB /)

RGHG6(:,12, 2) = (/ &
  & 0.36391625E-12_JPRB, 0.47922788E-12_JPRB, 0.52961292E-12_JPRB, 0.58355669E-12_JPRB, 0.63980646E-12_JPRB, 0.72431433E-12_JPRB, &
  & 0.83254053E-12_JPRB, 0.97346610E-12_JPRB, 0.11558587E-11_JPRB, 0.13957469E-11_JPRB, 0.17065193E-11_JPRB, 0.20978085E-11_JPRB, &
  & 0.25820693E-11_JPRB, 0.31513028E-11_JPRB, 0.38077419E-11_JPRB, 0.45562399E-11_JPRB, 0.53749123E-11_JPRB, 0.62282757E-11_JPRB, &
  & 0.70707394E-11_JPRB, 0.78978291E-11_JPRB, 0.86741387E-11_JPRB, 0.93714593E-11_JPRB, 0.99609643E-11_JPRB, 0.10415522E-10_JPRB, &
  & 0.10736557E-10_JPRB, 0.10918502E-10_JPRB, 0.10961226E-10_JPRB, 0.10879091E-10_JPRB, 0.10670095E-10_JPRB, 0.10319426E-10_JPRB, &
  & 0.98010168E-11_JPRB, 0.90741520E-11_JPRB, 0.81228106E-11_JPRB, 0.70400547E-11_JPRB, 0.59006446E-11_JPRB, 0.48131768E-11_JPRB, &
  & 0.38720047E-11_JPRB, 0.31034847E-11_JPRB, 0.24987555E-11_JPRB, 0.20090537E-11_JPRB, 0.15959861E-11_JPRB, 0.12435834E-11_JPRB, &
  & 0.95629863E-12_JPRB, 0.73967373E-12_JPRB, 0.58649082E-12_JPRB, 0.47908633E-12_JPRB, 0.40027243E-12_JPRB, 0.33931820E-12_JPRB, &
  & 0.28887477E-12_JPRB, 0.24493043E-12_JPRB, 0.20548514E-12_JPRB, 0.16981609E-12_JPRB, 0.13793880E-12_JPRB, 0.11033011E-12_JPRB, &
  & 0.87557362E-13_JPRB, 0.69997082E-13_JPRB, 0.57311401E-13_JPRB, 0.49036641E-13_JPRB, 0.43665690E-13_JPRB, 0.40415574E-13_JPRB, &
  & 0.38106488E-13_JPRB, 0.36338916E-13_JPRB, 0.34636062E-13_JPRB, 0.32060780E-13_JPRB /)

RGHG6(:,13, 2) = (/ &
  & 0.20320653E-11_JPRB, 0.22683689E-11_JPRB, 0.22992316E-11_JPRB, 0.23682948E-11_JPRB, 0.24516732E-11_JPRB, 0.25668118E-11_JPRB, &
  & 0.27351765E-11_JPRB, 0.29788524E-11_JPRB, 0.33148907E-11_JPRB, 0.37741399E-11_JPRB, 0.43784564E-11_JPRB, 0.51444435E-11_JPRB, &
  & 0.61074657E-11_JPRB, 0.72859895E-11_JPRB, 0.86754996E-11_JPRB, 0.10261752E-10_JPRB, 0.12013481E-10_JPRB, 0.13872126E-10_JPRB, &
  & 0.15733309E-10_JPRB, 0.17573849E-10_JPRB, 0.19280961E-10_JPRB, 0.20785302E-10_JPRB, 0.22024540E-10_JPRB, 0.22957223E-10_JPRB, &
  & 0.23530101E-10_JPRB, 0.23700068E-10_JPRB, 0.23439724E-10_JPRB, 0.22738278E-10_JPRB, 0.21624010E-10_JPRB, 0.20117207E-10_JPRB, &
  & 0.18282688E-10_JPRB, 0.16178255E-10_JPRB, 0.13871235E-10_JPRB, 0.11553278E-10_JPRB, 0.93795804E-11_JPRB, 0.75115938E-11_JPRB, &
  & 0.60558000E-11_JPRB, 0.49697269E-11_JPRB, 0.41521162E-11_JPRB, 0.35141068E-11_JPRB, 0.29910401E-11_JPRB, 0.25463319E-11_JPRB, &
  & 0.21595644E-11_JPRB, 0.18259938E-11_JPRB, 0.15470238E-11_JPRB, 0.13164498E-11_JPRB, 0.11237193E-11_JPRB, 0.95967375E-12_JPRB, &
  & 0.81561814E-12_JPRB, 0.68624755E-12_JPRB, 0.56962524E-12_JPRB, 0.46534586E-12_JPRB, 0.37408477E-12_JPRB, 0.29668019E-12_JPRB, &
  & 0.23413151E-12_JPRB, 0.18614327E-12_JPRB, 0.15177158E-12_JPRB, 0.12847071E-12_JPRB, 0.11409930E-12_JPRB, 0.10461387E-12_JPRB, &
  & 0.98356199E-13_JPRB, 0.93306981E-13_JPRB, 0.88513154E-13_JPRB, 0.81313977E-13_JPRB /)

RGHG6(:,14, 2) = (/ &
  & 0.68108188E-11_JPRB, 0.69507820E-11_JPRB, 0.69683573E-11_JPRB, 0.69542393E-11_JPRB, 0.69798846E-11_JPRB, 0.70887723E-11_JPRB, &
  & 0.73145674E-11_JPRB, 0.76926200E-11_JPRB, 0.82470038E-11_JPRB, 0.90259415E-11_JPRB, 0.10063911E-10_JPRB, 0.11393017E-10_JPRB, &
  & 0.13074829E-10_JPRB, 0.15132118E-10_JPRB, 0.17580430E-10_JPRB, 0.20395836E-10_JPRB, 0.23526694E-10_JPRB, 0.26851724E-10_JPRB, &
  & 0.30194462E-10_JPRB, 0.33480680E-10_JPRB, 0.36516373E-10_JPRB, 0.39156848E-10_JPRB, 0.41262861E-10_JPRB, 0.42747954E-10_JPRB, &
  & 0.43504072E-10_JPRB, 0.43419289E-10_JPRB, 0.42422382E-10_JPRB, 0.40495766E-10_JPRB, 0.37725892E-10_JPRB, 0.34254457E-10_JPRB, &
  & 0.30294676E-10_JPRB, 0.26112845E-10_JPRB, 0.21949826E-10_JPRB, 0.18146854E-10_JPRB, 0.14889815E-10_JPRB, 0.12305291E-10_JPRB, &
  & 0.10414172E-10_JPRB, 0.91162225E-11_JPRB, 0.82327955E-11_JPRB, 0.75986760E-11_JPRB, 0.71027203E-11_JPRB, 0.66510868E-11_JPRB, &
  & 0.62089604E-11_JPRB, 0.57154433E-11_JPRB, 0.51823745E-11_JPRB, 0.46306362E-11_JPRB, 0.40824540E-11_JPRB, 0.35543879E-11_JPRB, &
  & 0.30549504E-11_JPRB, 0.25837297E-11_JPRB, 0.21488211E-11_JPRB, 0.17529285E-11_JPRB, 0.14044276E-11_JPRB, 0.11078206E-11_JPRB, &
  & 0.86701647E-12_JPRB, 0.68080643E-12_JPRB, 0.54411521E-12_JPRB, 0.45026466E-12_JPRB, 0.38828110E-12_JPRB, 0.34919986E-12_JPRB, &
  & 0.32140203E-12_JPRB, 0.30007046E-12_JPRB, 0.27911267E-12_JPRB, 0.24815127E-12_JPRB /)

RGHG6(:,15, 2) = (/ &
  & 0.15654870E-10_JPRB, 0.15777714E-10_JPRB, 0.15689346E-10_JPRB, 0.15640062E-10_JPRB, 0.15699175E-10_JPRB, 0.15908492E-10_JPRB, &
  & 0.16307639E-10_JPRB, 0.16938576E-10_JPRB, 0.17832942E-10_JPRB, 0.19064363E-10_JPRB, 0.20689206E-10_JPRB, 0.22756803E-10_JPRB, &
  & 0.25361008E-10_JPRB, 0.28542883E-10_JPRB, 0.32313714E-10_JPRB, 0.36640795E-10_JPRB, 0.41440469E-10_JPRB, 0.46527792E-10_JPRB, &
  & 0.51616229E-10_JPRB, 0.56534357E-10_JPRB, 0.60997422E-10_JPRB, 0.64745910E-10_JPRB, 0.67594652E-10_JPRB, 0.69378843E-10_JPRB, &
  & 0.69926537E-10_JPRB, 0.69076946E-10_JPRB, 0.66742091E-10_JPRB, 0.62929918E-10_JPRB, 0.57853604E-10_JPRB, 0.51850937E-10_JPRB, &
  & 0.45371099E-10_JPRB, 0.38864148E-10_JPRB, 0.32805123E-10_JPRB, 0.27607821E-10_JPRB, 0.23499336E-10_JPRB, 0.20657774E-10_JPRB, &
  & 0.18959188E-10_JPRB, 0.18114954E-10_JPRB, 0.17808012E-10_JPRB, 0.17750156E-10_JPRB, 0.17742093E-10_JPRB, 0.17657736E-10_JPRB, &
  & 0.17347630E-10_JPRB, 0.16683006E-10_JPRB, 0.15679945E-10_JPRB, 0.14433400E-10_JPRB, 0.13048772E-10_JPRB, 0.11612757E-10_JPRB, &
  & 0.10172179E-10_JPRB, 0.87582320E-11_JPRB, 0.74135437E-11_JPRB, 0.61575129E-11_JPRB, 0.50257502E-11_JPRB, 0.40404065E-11_JPRB, &
  & 0.32181848E-11_JPRB, 0.25629303E-11_JPRB, 0.20610946E-11_JPRB, 0.16985329E-11_JPRB, 0.14504424E-11_JPRB, 0.12821766E-11_JPRB, &
  & 0.11663755E-11_JPRB, 0.10714192E-11_JPRB, 0.98272822E-12_JPRB, 0.84725922E-12_JPRB /)

RGHG6(:,16, 2) = (/ &
  & 0.28309473E-10_JPRB, 0.28828009E-10_JPRB, 0.29076661E-10_JPRB, 0.29347625E-10_JPRB, 0.29752339E-10_JPRB, 0.30358389E-10_JPRB, &
  & 0.31210666E-10_JPRB, 0.32372473E-10_JPRB, 0.33878064E-10_JPRB, 0.35833912E-10_JPRB, 0.38307611E-10_JPRB, 0.41354298E-10_JPRB, &
  & 0.45083232E-10_JPRB, 0.49543543E-10_JPRB, 0.54766271E-10_JPRB, 0.60699709E-10_JPRB, 0.67204096E-10_JPRB, 0.74027492E-10_JPRB, &
  & 0.80747117E-10_JPRB, 0.87108203E-10_JPRB, 0.92673383E-10_JPRB, 0.97099592E-10_JPRB, 0.10014541E-09_JPRB, 0.10158743E-09_JPRB, &
  & 0.10123045E-09_JPRB, 0.98927935E-10_JPRB, 0.94632122E-10_JPRB, 0.88522793E-10_JPRB, 0.80918654E-10_JPRB, 0.72322037E-10_JPRB, &
  & 0.63490185E-10_JPRB, 0.55061004E-10_JPRB, 0.47596704E-10_JPRB, 0.41675080E-10_JPRB, 0.37639839E-10_JPRB, 0.35474963E-10_JPRB, &
  & 0.34980248E-10_JPRB, 0.35640376E-10_JPRB, 0.36872928E-10_JPRB, 0.38220822E-10_JPRB, 0.39399869E-10_JPRB, 0.40039781E-10_JPRB, &
  & 0.39939135E-10_JPRB, 0.39010493E-10_JPRB, 0.37286438E-10_JPRB, 0.34938916E-10_JPRB, 0.32186774E-10_JPRB, 0.29215401E-10_JPRB, &
  & 0.26123034E-10_JPRB, 0.22998945E-10_JPRB, 0.19929773E-10_JPRB, 0.16985798E-10_JPRB, 0.14255068E-10_JPRB, 0.11801227E-10_JPRB, &
  & 0.96872102E-11_JPRB, 0.79383097E-11_JPRB, 0.65437647E-11_JPRB, 0.54741710E-11_JPRB, 0.46990094E-11_JPRB, 0.41566993E-11_JPRB, &
  & 0.37518985E-11_JPRB, 0.34360164E-11_JPRB, 0.31170513E-11_JPRB, 0.26589668E-11_JPRB /)

RGHG6(:,17, 2) = (/ &
  & 0.45224231E-10_JPRB, 0.46805160E-10_JPRB, 0.47682958E-10_JPRB, 0.48583786E-10_JPRB, 0.49695026E-10_JPRB, 0.51099854E-10_JPRB, &
  & 0.52850387E-10_JPRB, 0.54993482E-10_JPRB, 0.57560061E-10_JPRB, 0.60649027E-10_JPRB, 0.64332040E-10_JPRB, 0.68665240E-10_JPRB, &
  & 0.73733075E-10_JPRB, 0.79564896E-10_JPRB, 0.86218074E-10_JPRB, 0.93607663E-10_JPRB, 0.10154231E-09_JPRB, 0.10970793E-09_JPRB, &
  & 0.11755166E-09_JPRB, 0.12472380E-09_JPRB, 0.13067725E-09_JPRB, 0.13499604E-09_JPRB, 0.13738854E-09_JPRB, 0.13764109E-09_JPRB, &
  & 0.13560823E-09_JPRB, 0.13124216E-09_JPRB, 0.12467549E-09_JPRB, 0.11618625E-09_JPRB, 0.10646421E-09_JPRB, 0.96238108E-10_JPRB, &
  & 0.85929194E-10_JPRB, 0.76620904E-10_JPRB, 0.68845089E-10_JPRB, 0.63314937E-10_JPRB, 0.60272579E-10_JPRB, 0.59799943E-10_JPRB, &
  & 0.61484748E-10_JPRB, 0.64488734E-10_JPRB, 0.67907485E-10_JPRB, 0.71006936E-10_JPRB, 0.73384590E-10_JPRB, 0.74737848E-10_JPRB, &
  & 0.74754127E-10_JPRB, 0.73274872E-10_JPRB, 0.70487484E-10_JPRB, 0.66744388E-10_JPRB, 0.62336081E-10_JPRB, 0.57487955E-10_JPRB, &
  & 0.52346114E-10_JPRB, 0.47038949E-10_JPRB, 0.41706090E-10_JPRB, 0.36484114E-10_JPRB, 0.31509583E-10_JPRB, 0.26921161E-10_JPRB, &
  & 0.22840728E-10_JPRB, 0.19350613E-10_JPRB, 0.16447914E-10_JPRB, 0.14118047E-10_JPRB, 0.12321956E-10_JPRB, 0.10965159E-10_JPRB, &
  & 0.99568288E-11_JPRB, 0.90885511E-11_JPRB, 0.82643501E-11_JPRB, 0.69905119E-11_JPRB /)

RGHG6(:,18, 2) = (/ &
  & 0.64014787E-10_JPRB, 0.67548474E-10_JPRB, 0.69609048E-10_JPRB, 0.71652136E-10_JPRB, 0.74000521E-10_JPRB, 0.76784322E-10_JPRB, &
  & 0.80022849E-10_JPRB, 0.83745802E-10_JPRB, 0.87942112E-10_JPRB, 0.92690300E-10_JPRB, 0.98019419E-10_JPRB, 0.10397926E-09_JPRB, &
  & 0.11059224E-09_JPRB, 0.11780962E-09_JPRB, 0.12574590E-09_JPRB, 0.13426281E-09_JPRB, 0.14311861E-09_JPRB, 0.15194969E-09_JPRB, &
  & 0.16014565E-09_JPRB, 0.16726991E-09_JPRB, 0.17272024E-09_JPRB, 0.17606104E-09_JPRB, 0.17699026E-09_JPRB, 0.17536612E-09_JPRB, &
  & 0.17118332E-09_JPRB, 0.16463619E-09_JPRB, 0.15608233E-09_JPRB, 0.14619958E-09_JPRB, 0.13542771E-09_JPRB, 0.12446515E-09_JPRB, &
  & 0.11449428E-09_JPRB, 0.10595259E-09_JPRB, 0.99442982E-10_JPRB, 0.95550255E-10_JPRB, 0.94564918E-10_JPRB, 0.96420080E-10_JPRB, &
  & 0.10054960E-09_JPRB, 0.10585584E-09_JPRB, 0.11114858E-09_JPRB, 0.11562724E-09_JPRB, 0.11866533E-09_JPRB, 0.11982465E-09_JPRB, &
  & 0.11901569E-09_JPRB, 0.11638832E-09_JPRB, 0.11225836E-09_JPRB, 0.10694540E-09_JPRB, 0.10075214E-09_JPRB, 0.93948349E-10_JPRB, &
  & 0.86701271E-10_JPRB, 0.79164092E-10_JPRB, 0.71523475E-10_JPRB, 0.63958672E-10_JPRB, 0.56652745E-10_JPRB, 0.49793884E-10_JPRB, &
  & 0.43573908E-10_JPRB, 0.38111837E-10_JPRB, 0.33427872E-10_JPRB, 0.29494240E-10_JPRB, 0.26283406E-10_JPRB, 0.23754941E-10_JPRB, &
  & 0.21689504E-10_JPRB, 0.19945915E-10_JPRB, 0.18152688E-10_JPRB, 0.15436701E-10_JPRB /)

RGHG6(:,19, 2) = (/ &
  & 0.85423668E-10_JPRB, 0.91401012E-10_JPRB, 0.94887466E-10_JPRB, 0.98161437E-10_JPRB, 0.10179463E-09_JPRB, 0.10600114E-09_JPRB, &
  & 0.11085216E-09_JPRB, 0.11633954E-09_JPRB, 0.12240813E-09_JPRB, 0.12906008E-09_JPRB, 0.13624851E-09_JPRB, 0.14395699E-09_JPRB, &
  & 0.15216901E-09_JPRB, 0.16070514E-09_JPRB, 0.16965873E-09_JPRB, 0.17890137E-09_JPRB, 0.18812799E-09_JPRB, 0.19693774E-09_JPRB, &
  & 0.20473649E-09_JPRB, 0.21108151E-09_JPRB, 0.21537912E-09_JPRB, 0.21719850E-09_JPRB, 0.21630811E-09_JPRB, 0.21267166E-09_JPRB, &
  & 0.20649171E-09_JPRB, 0.19822247E-09_JPRB, 0.18849988E-09_JPRB, 0.17797208E-09_JPRB, 0.16768184E-09_JPRB, 0.15847924E-09_JPRB, &
  & 0.15075348E-09_JPRB, 0.14488524E-09_JPRB, 0.14127345E-09_JPRB, 0.14030689E-09_JPRB, 0.14200767E-09_JPRB, 0.14618957E-09_JPRB, &
  & 0.15208193E-09_JPRB, 0.15850510E-09_JPRB, 0.16425229E-09_JPRB, 0.16848144E-09_JPRB, 0.17071045E-09_JPRB, 0.17075702E-09_JPRB, &
  & 0.16860509E-09_JPRB, 0.16443463E-09_JPRB, 0.15857028E-09_JPRB, 0.15144357E-09_JPRB, 0.14340272E-09_JPRB, 0.13469638E-09_JPRB, &
  & 0.12547761E-09_JPRB, 0.11592056E-09_JPRB, 0.10626418E-09_JPRB, 0.96699974E-10_JPRB, 0.87438730E-10_JPRB, 0.78695869E-10_JPRB, &
  & 0.70688330E-10_JPRB, 0.63552233E-10_JPRB, 0.57291935E-10_JPRB, 0.51870619E-10_JPRB, 0.47252140E-10_JPRB, 0.43359417E-10_JPRB, &
  & 0.40085196E-10_JPRB, 0.37122361E-10_JPRB, 0.33997711E-10_JPRB, 0.29228737E-10_JPRB /)

RGHG6(:,20, 2) = (/ &
  & 0.10778330E-09_JPRB, 0.11469623E-09_JPRB, 0.11967584E-09_JPRB, 0.12462638E-09_JPRB, 0.12997245E-09_JPRB, 0.13590887E-09_JPRB, &
  & 0.14245710E-09_JPRB, 0.14966985E-09_JPRB, 0.15750767E-09_JPRB, 0.16592255E-09_JPRB, 0.17482082E-09_JPRB, 0.18406865E-09_JPRB, &
  & 0.19362938E-09_JPRB, 0.20325810E-09_JPRB, 0.21292075E-09_JPRB, 0.22250979E-09_JPRB, 0.23168714E-09_JPRB, 0.24005797E-09_JPRB, &
  & 0.24708077E-09_JPRB, 0.25235533E-09_JPRB, 0.25536692E-09_JPRB, 0.25573954E-09_JPRB, 0.25330069E-09_JPRB, 0.24815314E-09_JPRB, &
  & 0.24068447E-09_JPRB, 0.23156675E-09_JPRB, 0.22172209E-09_JPRB, 0.21230687E-09_JPRB, 0.20423106E-09_JPRB, 0.19789474E-09_JPRB, &
  & 0.19380472E-09_JPRB, 0.19201374E-09_JPRB, 0.19252140E-09_JPRB, 0.19513834E-09_JPRB, 0.19963352E-09_JPRB, 0.20548804E-09_JPRB, &
  & 0.21200247E-09_JPRB, 0.21819659E-09_JPRB, 0.22295228E-09_JPRB, 0.22555049E-09_JPRB, 0.22572386E-09_JPRB, 0.22354778E-09_JPRB, &
  & 0.21917904E-09_JPRB, 0.21291398E-09_JPRB, 0.20514947E-09_JPRB, 0.19624677E-09_JPRB, 0.18647986E-09_JPRB, 0.17605607E-09_JPRB, &
  & 0.16514293E-09_JPRB, 0.15397572E-09_JPRB, 0.14279497E-09_JPRB, 0.13180056E-09_JPRB, 0.12120813E-09_JPRB, 0.11122599E-09_JPRB, &
  & 0.10205116E-09_JPRB, 0.93796040E-10_JPRB, 0.86456856E-10_JPRB, 0.79936946E-10_JPRB, 0.74184311E-10_JPRB, 0.69144322E-10_JPRB, &
  & 0.64674238E-10_JPRB, 0.60393385E-10_JPRB, 0.55935614E-10_JPRB, 0.48428823E-10_JPRB /)

RGHG6(:,21, 2) = (/ &
  & 0.12985865E-09_JPRB, 0.13893565E-09_JPRB, 0.14443001E-09_JPRB, 0.15005787E-09_JPRB, 0.15651325E-09_JPRB, 0.16389048E-09_JPRB, &
  & 0.17208583E-09_JPRB, 0.18088391E-09_JPRB, 0.19023945E-09_JPRB, 0.20009165E-09_JPRB, 0.21031295E-09_JPRB, 0.22072787E-09_JPRB, &
  & 0.23123058E-09_JPRB, 0.24160668E-09_JPRB, 0.25170144E-09_JPRB, 0.26137031E-09_JPRB, 0.27033445E-09_JPRB, 0.27820510E-09_JPRB, &
  & 0.28453312E-09_JPRB, 0.28895814E-09_JPRB, 0.29104605E-09_JPRB, 0.29051944E-09_JPRB, 0.28730907E-09_JPRB, 0.28155089E-09_JPRB, &
  & 0.27385330E-09_JPRB, 0.26505612E-09_JPRB, 0.25630198E-09_JPRB, 0.24872762E-09_JPRB, 0.24320521E-09_JPRB, 0.24039556E-09_JPRB, &
  & 0.24035357E-09_JPRB, 0.24281180E-09_JPRB, 0.24726501E-09_JPRB, 0.25290006E-09_JPRB, 0.25952673E-09_JPRB, 0.26643501E-09_JPRB, &
  & 0.27274885E-09_JPRB, 0.27752428E-09_JPRB, 0.28008337E-09_JPRB, 0.28013047E-09_JPRB, 0.27771549E-09_JPRB, 0.27307254E-09_JPRB, &
  & 0.26650862E-09_JPRB, 0.25834088E-09_JPRB, 0.24887081E-09_JPRB, 0.23841329E-09_JPRB, 0.22718014E-09_JPRB, 0.21537155E-09_JPRB, &
  & 0.20325440E-09_JPRB, 0.19102483E-09_JPRB, 0.17893419E-09_JPRB, 0.16717616E-09_JPRB, 0.15593951E-09_JPRB, 0.14538816E-09_JPRB, &
  & 0.13567468E-09_JPRB, 0.12687396E-09_JPRB, 0.11892443E-09_JPRB, 0.11173213E-09_JPRB, 0.10520718E-09_JPRB, 0.99270876E-10_JPRB, &
  & 0.93729281E-10_JPRB, 0.88421812E-10_JPRB, 0.82241311E-10_JPRB, 0.72608398E-10_JPRB /)

RGHG6(:,22, 2) = (/ &
  & 0.15190003E-09_JPRB, 0.16238409E-09_JPRB, 0.16894579E-09_JPRB, 0.17524986E-09_JPRB, 0.18215035E-09_JPRB, 0.19007755E-09_JPRB, &
  & 0.19907433E-09_JPRB, 0.20892019E-09_JPRB, 0.21930324E-09_JPRB, 0.23010663E-09_JPRB, 0.24119134E-09_JPRB, 0.25234825E-09_JPRB, &
  & 0.26343139E-09_JPRB, 0.27424768E-09_JPRB, 0.28459415E-09_JPRB, 0.29428507E-09_JPRB, 0.30306344E-09_JPRB, 0.31060254E-09_JPRB, &
  & 0.31651948E-09_JPRB, 0.32054309E-09_JPRB, 0.32234693E-09_JPRB, 0.32170266E-09_JPRB, 0.31857603E-09_JPRB, 0.31327449E-09_JPRB, &
  & 0.30627859E-09_JPRB, 0.29868580E-09_JPRB, 0.29156577E-09_JPRB, 0.28612215E-09_JPRB, 0.28320862E-09_JPRB, 0.28343189E-09_JPRB, &
  & 0.28661157E-09_JPRB, 0.29224606E-09_JPRB, 0.29915004E-09_JPRB, 0.30689662E-09_JPRB, 0.31452055E-09_JPRB, 0.32124003E-09_JPRB, &
  & 0.32638717E-09_JPRB, 0.32930553E-09_JPRB, 0.32961919E-09_JPRB, 0.32731717E-09_JPRB, 0.32266859E-09_JPRB, 0.31603126E-09_JPRB, &
  & 0.30778224E-09_JPRB, 0.29817857E-09_JPRB, 0.28751207E-09_JPRB, 0.27596953E-09_JPRB, 0.26376906E-09_JPRB, 0.25121905E-09_JPRB, &
  & 0.23848185E-09_JPRB, 0.22581804E-09_JPRB, 0.21346713E-09_JPRB, 0.20159108E-09_JPRB, 0.19032781E-09_JPRB, 0.17977896E-09_JPRB, &
  & 0.17003135E-09_JPRB, 0.16110602E-09_JPRB, 0.15293031E-09_JPRB, 0.14536577E-09_JPRB, 0.13832588E-09_JPRB, 0.13170458E-09_JPRB, &
  & 0.12538856E-09_JPRB, 0.11887274E-09_JPRB, 0.11177630E-09_JPRB, 0.99313287E-10_JPRB /)

RGHG6(:,23, 2) = (/ &
  & 0.17309162E-09_JPRB, 0.18391696E-09_JPRB, 0.19111959E-09_JPRB, 0.19813867E-09_JPRB, 0.20575174E-09_JPRB, 0.21414005E-09_JPRB, &
  & 0.22344852E-09_JPRB, 0.23367472E-09_JPRB, 0.24455843E-09_JPRB, 0.25583641E-09_JPRB, 0.26734379E-09_JPRB, 0.27885844E-09_JPRB, &
  & 0.29021877E-09_JPRB, 0.30121158E-09_JPRB, 0.31166350E-09_JPRB, 0.32137676E-09_JPRB, 0.33011902E-09_JPRB, 0.33762640E-09_JPRB, &
  & 0.34359618E-09_JPRB, 0.34779296E-09_JPRB, 0.34994568E-09_JPRB, 0.34992015E-09_JPRB, 0.34774822E-09_JPRB, 0.34363024E-09_JPRB, &
  & 0.33822803E-09_JPRB, 0.33241110E-09_JPRB, 0.32718472E-09_JPRB, 0.32367439E-09_JPRB, 0.32280228E-09_JPRB, 0.32491565E-09_JPRB, &
  & 0.32993139E-09_JPRB, 0.33681521E-09_JPRB, 0.34476927E-09_JPRB, 0.35283237E-09_JPRB, 0.36011932E-09_JPRB, 0.36592374E-09_JPRB, &
  & 0.36961542E-09_JPRB, 0.37080386E-09_JPRB, 0.36928557E-09_JPRB, 0.36528952E-09_JPRB, 0.35915176E-09_JPRB, 0.35129546E-09_JPRB, &
  & 0.34207057E-09_JPRB, 0.33170203E-09_JPRB, 0.32038938E-09_JPRB, 0.30832553E-09_JPRB, 0.29581296E-09_JPRB, 0.28306876E-09_JPRB, &
  & 0.27033881E-09_JPRB, 0.25785646E-09_JPRB, 0.24582622E-09_JPRB, 0.23437277E-09_JPRB, 0.22356207E-09_JPRB, 0.21343273E-09_JPRB, &
  & 0.20399651E-09_JPRB, 0.19523674E-09_JPRB, 0.18704494E-09_JPRB, 0.17932156E-09_JPRB, 0.17193545E-09_JPRB, 0.16477295E-09_JPRB, &
  & 0.15765556E-09_JPRB, 0.15040844E-09_JPRB, 0.14176846E-09_JPRB, 0.12756765E-09_JPRB /)

RGHG6(:,24, 2) = (/ &
  & 0.19325928E-09_JPRB, 0.20466996E-09_JPRB, 0.21180832E-09_JPRB, 0.21892134E-09_JPRB, 0.22677746E-09_JPRB, 0.23557090E-09_JPRB, &
  & 0.24515559E-09_JPRB, 0.25546010E-09_JPRB, 0.26644170E-09_JPRB, 0.27783001E-09_JPRB, 0.28944452E-09_JPRB, 0.30106648E-09_JPRB, &
  & 0.31251507E-09_JPRB, 0.32359782E-09_JPRB, 0.33411848E-09_JPRB, 0.34389222E-09_JPRB, 0.35272438E-09_JPRB, 0.36039383E-09_JPRB, &
  & 0.36667155E-09_JPRB, 0.37139794E-09_JPRB, 0.37439102E-09_JPRB, 0.37554609E-09_JPRB, 0.37483139E-09_JPRB, 0.37252307E-09_JPRB, &
  & 0.36911402E-09_JPRB, 0.36530723E-09_JPRB, 0.36199280E-09_JPRB, 0.36010656E-09_JPRB, 0.36041711E-09_JPRB, 0.36336167E-09_JPRB, &
  & 0.36857409E-09_JPRB, 0.37534584E-09_JPRB, 0.38284284E-09_JPRB, 0.39007761E-09_JPRB, 0.39621342E-09_JPRB, 0.40063655E-09_JPRB, &
  & 0.40284226E-09_JPRB, 0.40255269E-09_JPRB, 0.39974546E-09_JPRB, 0.39472811E-09_JPRB, 0.38784342E-09_JPRB, 0.37950262E-09_JPRB, &
  & 0.36998080E-09_JPRB, 0.35943784E-09_JPRB, 0.34804681E-09_JPRB, 0.33603337E-09_JPRB, 0.32368760E-09_JPRB, 0.31127056E-09_JPRB, &
  & 0.29901959E-09_JPRB, 0.28715791E-09_JPRB, 0.27586536E-09_JPRB, 0.26520020E-09_JPRB, 0.25516494E-09_JPRB, 0.24571870E-09_JPRB, &
  & 0.23680580E-09_JPRB, 0.22836223E-09_JPRB, 0.22030923E-09_JPRB, 0.21250607E-09_JPRB, 0.20484284E-09_JPRB, 0.19719855E-09_JPRB, &
  & 0.18944532E-09_JPRB, 0.18119098E-09_JPRB, 0.17173624E-09_JPRB, 0.15530606E-09_JPRB /)

RGHG6(:,25, 2) = (/ &
  & 0.21243259E-09_JPRB, 0.22384351E-09_JPRB, 0.23120225E-09_JPRB, 0.23831093E-09_JPRB, 0.24610333E-09_JPRB, 0.25484775E-09_JPRB, &
  & 0.26448171E-09_JPRB, 0.27474237E-09_JPRB, 0.28553770E-09_JPRB, 0.29678113E-09_JPRB, 0.30824207E-09_JPRB, 0.31974182E-09_JPRB, &
  & 0.33109820E-09_JPRB, 0.34211461E-09_JPRB, 0.35262926E-09_JPRB, 0.36245773E-09_JPRB, 0.37143597E-09_JPRB, 0.37941131E-09_JPRB, &
  & 0.38622977E-09_JPRB, 0.39176667E-09_JPRB, 0.39586084E-09_JPRB, 0.39840883E-09_JPRB, 0.39941542E-09_JPRB, 0.39909076E-09_JPRB, &
  & 0.39776971E-09_JPRB, 0.39594802E-09_JPRB, 0.39440118E-09_JPRB, 0.39372280E-09_JPRB, 0.39470771E-09_JPRB, 0.39755180E-09_JPRB, &
  & 0.40212350E-09_JPRB, 0.40787279E-09_JPRB, 0.41399692E-09_JPRB, 0.41969667E-09_JPRB, 0.42429968E-09_JPRB, 0.42718781E-09_JPRB, &
  & 0.42802439E-09_JPRB, 0.42657167E-09_JPRB, 0.42294820E-09_JPRB, 0.41745299E-09_JPRB, 0.41040282E-09_JPRB, 0.40210690E-09_JPRB, &
  & 0.39277026E-09_JPRB, 0.38251485E-09_JPRB, 0.37147702E-09_JPRB, 0.35989836E-09_JPRB, 0.34806397E-09_JPRB, 0.33629044E-09_JPRB, &
  & 0.32483397E-09_JPRB, 0.31389480E-09_JPRB, 0.30357761E-09_JPRB, 0.29390429E-09_JPRB, 0.28479930E-09_JPRB, 0.27616279E-09_JPRB, &
  & 0.26787994E-09_JPRB, 0.25986793E-09_JPRB, 0.25201399E-09_JPRB, 0.24420674E-09_JPRB, 0.23631716E-09_JPRB, 0.22822463E-09_JPRB, &
  & 0.21981053E-09_JPRB, 0.21085020E-09_JPRB, 0.20025843E-09_JPRB, 0.18215808E-09_JPRB /)

RGHG6(:,26, 2) = (/ &
  & 0.23070736E-09_JPRB, 0.24205637E-09_JPRB, 0.24936880E-09_JPRB, 0.25646402E-09_JPRB, 0.26414620E-09_JPRB, 0.27267621E-09_JPRB, &
  & 0.28206024E-09_JPRB, 0.29209668E-09_JPRB, 0.30257574E-09_JPRB, 0.31346739E-09_JPRB, 0.32462877E-09_JPRB, 0.33587116E-09_JPRB, &
  & 0.34701744E-09_JPRB, 0.35790781E-09_JPRB, 0.36835723E-09_JPRB, 0.37821216E-09_JPRB, 0.38734904E-09_JPRB, 0.39564904E-09_JPRB, &
  & 0.40298528E-09_JPRB, 0.40926074E-09_JPRB, 0.41437154E-09_JPRB, 0.41825338E-09_JPRB, 0.42090548E-09_JPRB, 0.42244533E-09_JPRB, &
  & 0.42303566E-09_JPRB, 0.42301462E-09_JPRB, 0.42289838E-09_JPRB, 0.42321199E-09_JPRB, 0.42444170E-09_JPRB, 0.42683698E-09_JPRB, &
  & 0.43035825E-09_JPRB, 0.43466769E-09_JPRB, 0.43914411E-09_JPRB, 0.44314497E-09_JPRB, 0.44614884E-09_JPRB, 0.44760376E-09_JPRB, &
  & 0.44727494E-09_JPRB, 0.44500115E-09_JPRB, 0.44095622E-09_JPRB, 0.43539816E-09_JPRB, 0.42854217E-09_JPRB, 0.42062523E-09_JPRB, &
  & 0.41178760E-09_JPRB, 0.40209300E-09_JPRB, 0.39166159E-09_JPRB, 0.38074721E-09_JPRB, 0.36965617E-09_JPRB, 0.35872791E-09_JPRB, &
  & 0.34823963E-09_JPRB, 0.33831765E-09_JPRB, 0.32905539E-09_JPRB, 0.32041264E-09_JPRB, 0.31226230E-09_JPRB, 0.30446731E-09_JPRB, &
  & 0.29686612E-09_JPRB, 0.28933123E-09_JPRB, 0.28175678E-09_JPRB, 0.27399555E-09_JPRB, 0.26593283E-09_JPRB, 0.25746111E-09_JPRB, &
  & 0.24848223E-09_JPRB, 0.23878793E-09_JPRB, 0.22738342E-09_JPRB, 0.20772482E-09_JPRB /)

RGHG6(:,27, 2) = (/ &
  & 0.24841679E-09_JPRB, 0.25963470E-09_JPRB, 0.26679475E-09_JPRB, 0.27373387E-09_JPRB, 0.28119768E-09_JPRB, 0.28944766E-09_JPRB, &
  & 0.29844160E-09_JPRB, 0.30805924E-09_JPRB, 0.31810149E-09_JPRB, 0.32849107E-09_JPRB, 0.33919673E-09_JPRB, 0.35003928E-09_JPRB, &
  & 0.36088321E-09_JPRB, 0.37153666E-09_JPRB, 0.38186976E-09_JPRB, 0.39173195E-09_JPRB, 0.40099085E-09_JPRB, 0.40952297E-09_JPRB, &
  & 0.41723802E-09_JPRB, 0.42408554E-09_JPRB, 0.43001344E-09_JPRB, 0.43497098E-09_JPRB, 0.43894544E-09_JPRB, 0.44196988E-09_JPRB, &
  & 0.44412801E-09_JPRB, 0.44559814E-09_JPRB, 0.44666329E-09_JPRB, 0.44771681E-09_JPRB, 0.44907728E-09_JPRB, 0.45099863E-09_JPRB, &
  & 0.45351009E-09_JPRB, 0.45640991E-09_JPRB, 0.45930093E-09_JPRB, 0.46173015E-09_JPRB, 0.46329263E-09_JPRB, 0.46355386E-09_JPRB, &
  & 0.46234644E-09_JPRB, 0.45958587E-09_JPRB, 0.45541768E-09_JPRB, 0.45004006E-09_JPRB, 0.44362625E-09_JPRB, 0.43630885E-09_JPRB, &
  & 0.42815762E-09_JPRB, 0.41919801E-09_JPRB, 0.40955514E-09_JPRB, 0.39942583E-09_JPRB, 0.38915460E-09_JPRB, 0.37914402E-09_JPRB, &
  & 0.36958925E-09_JPRB, 0.36066294E-09_JPRB, 0.35239975E-09_JPRB, 0.34470632E-09_JPRB, 0.33745812E-09_JPRB, 0.33044215E-09_JPRB, &
  & 0.32349540E-09_JPRB, 0.31647698E-09_JPRB, 0.30921915E-09_JPRB, 0.30160169E-09_JPRB, 0.29347275E-09_JPRB, 0.28473165E-09_JPRB, &
  & 0.27534852E-09_JPRB, 0.26516567E-09_JPRB, 0.25316674E-09_JPRB, 0.23239803E-09_JPRB /)

RGHG6(:,28, 2) = (/ &
  & 0.26575200E-09_JPRB, 0.27677013E-09_JPRB, 0.28374184E-09_JPRB, 0.29040215E-09_JPRB, 0.29756644E-09_JPRB, 0.30541780E-09_JPRB, &
  & 0.31396258E-09_JPRB, 0.32304937E-09_JPRB, 0.33252978E-09_JPRB, 0.34234779E-09_JPRB, 0.35246517E-09_JPRB, 0.36280939E-09_JPRB, &
  & 0.37320724E-09_JPRB, 0.38354703E-09_JPRB, 0.39366488E-09_JPRB, 0.40341533E-09_JPRB, 0.41267170E-09_JPRB, 0.42133566E-09_JPRB, &
  & 0.42932860E-09_JPRB, 0.43659809E-09_JPRB, 0.44310061E-09_JPRB, 0.44881102E-09_JPRB, 0.45372506E-09_JPRB, 0.45783460E-09_JPRB, &
  & 0.46115672E-09_JPRB, 0.46374285E-09_JPRB, 0.46574039E-09_JPRB, 0.46735793E-09_JPRB, 0.46883314E-09_JPRB, 0.47037674E-09_JPRB, &
  & 0.47205340E-09_JPRB, 0.47379722E-09_JPRB, 0.47538656E-09_JPRB, 0.47652227E-09_JPRB, 0.47691989E-09_JPRB, 0.47627463E-09_JPRB, &
  & 0.47447224E-09_JPRB, 0.47147714E-09_JPRB, 0.46740850E-09_JPRB, 0.46243068E-09_JPRB, 0.45662105E-09_JPRB, 0.45001139E-09_JPRB, &
  & 0.44262843E-09_JPRB, 0.43449278E-09_JPRB, 0.42566251E-09_JPRB, 0.41637799E-09_JPRB, 0.40698420E-09_JPRB, 0.39780132E-09_JPRB, &
  & 0.38914330E-09_JPRB, 0.38110298E-09_JPRB, 0.37371020E-09_JPRB, 0.36684880E-09_JPRB, 0.36034806E-09_JPRB, 0.35401784E-09_JPRB, &
  & 0.34767114E-09_JPRB, 0.34113093E-09_JPRB, 0.33424954E-09_JPRB, 0.32684142E-09_JPRB, 0.31877084E-09_JPRB, 0.30994951E-09_JPRB, &
  & 0.30040997E-09_JPRB, 0.29004549E-09_JPRB, 0.27796135E-09_JPRB, 0.25658622E-09_JPRB /)

RGHG6(:,29, 2) = (/ &
  & 0.28292924E-09_JPRB, 0.29365074E-09_JPRB, 0.30035077E-09_JPRB, 0.30670894E-09_JPRB, 0.31343692E-09_JPRB, 0.32084244E-09_JPRB, &
  & 0.32885397E-09_JPRB, 0.33735789E-09_JPRB, 0.34619652E-09_JPRB, 0.35537473E-09_JPRB, 0.36482362E-09_JPRB, 0.37457662E-09_JPRB, &
  & 0.38453488E-09_JPRB, 0.39449627E-09_JPRB, 0.40433956E-09_JPRB, 0.41392642E-09_JPRB, 0.42313103E-09_JPRB, 0.43182627E-09_JPRB, &
  & 0.43992718E-09_JPRB, 0.44739018E-09_JPRB, 0.45419890E-09_JPRB, 0.46034043E-09_JPRB, 0.46582299E-09_JPRB, 0.47062948E-09_JPRB, &
  & 0.47471810E-09_JPRB, 0.47805931E-09_JPRB, 0.48068605E-09_JPRB, 0.48271576E-09_JPRB, 0.48429355E-09_JPRB, 0.48558207E-09_JPRB, &
  & 0.48668236E-09_JPRB, 0.48758553E-09_JPRB, 0.48821314E-09_JPRB, 0.48838028E-09_JPRB, 0.48792387E-09_JPRB, 0.48665538E-09_JPRB, &
  & 0.48450810E-09_JPRB, 0.48150312E-09_JPRB, 0.47773213E-09_JPRB, 0.47326343E-09_JPRB, 0.46809528E-09_JPRB, 0.46222917E-09_JPRB, &
  & 0.45564139E-09_JPRB, 0.44831638E-09_JPRB, 0.44034135E-09_JPRB, 0.43189721E-09_JPRB, 0.42329942E-09_JPRB, 0.41493800E-09_JPRB, &
  & 0.40703454E-09_JPRB, 0.39976633E-09_JPRB, 0.39309231E-09_JPRB, 0.38689382E-09_JPRB, 0.38101763E-09_JPRB, 0.37524914E-09_JPRB, &
  & 0.36940079E-09_JPRB, 0.36331876E-09_JPRB, 0.35677922E-09_JPRB, 0.34964603E-09_JPRB, 0.34173733E-09_JPRB, 0.33303588E-09_JPRB, &
  & 0.32360886E-09_JPRB, 0.31360092E-09_JPRB, 0.30169980E-09_JPRB, 0.28099478E-09_JPRB /)

RGHG6(:,30, 2) = (/ &
  & 0.29996367E-09_JPRB, 0.31035688E-09_JPRB, 0.31670427E-09_JPRB, 0.32262967E-09_JPRB, 0.32892886E-09_JPRB, 0.33579031E-09_JPRB, &
  & 0.34324038E-09_JPRB, 0.35111938E-09_JPRB, 0.35929990E-09_JPRB, 0.36777015E-09_JPRB, 0.37653947E-09_JPRB, 0.38559259E-09_JPRB, &
  & 0.39495740E-09_JPRB, 0.40453776E-09_JPRB, 0.41413639E-09_JPRB, 0.42357573E-09_JPRB, 0.43269055E-09_JPRB, 0.44135415E-09_JPRB, &
  & 0.44945395E-09_JPRB, 0.45695686E-09_JPRB, 0.46385984E-09_JPRB, 0.47018395E-09_JPRB, 0.47594112E-09_JPRB, 0.48110355E-09_JPRB, &
  & 0.48560905E-09_JPRB, 0.48935245E-09_JPRB, 0.49235543E-09_JPRB, 0.49462240E-09_JPRB, 0.49627086E-09_JPRB, 0.49740456E-09_JPRB, &
  & 0.49815085E-09_JPRB, 0.49849308E-09_JPRB, 0.49848226E-09_JPRB, 0.49798882E-09_JPRB, 0.49698079E-09_JPRB, 0.49535731E-09_JPRB, &
  & 0.49310916E-09_JPRB, 0.49025956E-09_JPRB, 0.48683912E-09_JPRB, 0.48287940E-09_JPRB, 0.47835991E-09_JPRB, 0.47321352E-09_JPRB, &
  & 0.46738696E-09_JPRB, 0.46084514E-09_JPRB, 0.45365400E-09_JPRB, 0.44600423E-09_JPRB, 0.43819570E-09_JPRB, 0.43053167E-09_JPRB, &
  & 0.42334225E-09_JPRB, 0.41669657E-09_JPRB, 0.41060280E-09_JPRB, 0.40495368E-09_JPRB, 0.39954853E-09_JPRB, 0.39423736E-09_JPRB, &
  & 0.38880896E-09_JPRB, 0.38309156E-09_JPRB, 0.37690437E-09_JPRB, 0.37004469E-09_JPRB, 0.36239867E-09_JPRB, 0.35396153E-09_JPRB, &
  & 0.34504241E-09_JPRB, 0.33556208E-09_JPRB, 0.32484571E-09_JPRB, 0.30514791E-09_JPRB /)

RGHG6(:,31, 2) = (/ &
  & 0.31689457E-09_JPRB, 0.32676387E-09_JPRB, 0.33272798E-09_JPRB, 0.33823089E-09_JPRB, 0.34399578E-09_JPRB, 0.35033432E-09_JPRB, &
  & 0.35719966E-09_JPRB, 0.36444703E-09_JPRB, 0.37197562E-09_JPRB, 0.37973866E-09_JPRB, 0.38780795E-09_JPRB, 0.39624612E-09_JPRB, &
  & 0.40502873E-09_JPRB, 0.41411163E-09_JPRB, 0.42338222E-09_JPRB, 0.43262621E-09_JPRB, 0.44162940E-09_JPRB, 0.45020757E-09_JPRB, &
  & 0.45824622E-09_JPRB, 0.46569509E-09_JPRB, 0.47256654E-09_JPRB, 0.47889193E-09_JPRB, 0.48469229E-09_JPRB, 0.48993459E-09_JPRB, &
  & 0.49455245E-09_JPRB, 0.49842058E-09_JPRB, 0.50155874E-09_JPRB, 0.50390325E-09_JPRB, 0.50556781E-09_JPRB, 0.50661403E-09_JPRB, &
  & 0.50714477E-09_JPRB, 0.50716226E-09_JPRB, 0.50677079E-09_JPRB, 0.50588711E-09_JPRB, 0.50457749E-09_JPRB, 0.50279636E-09_JPRB, &
  & 0.50057192E-09_JPRB, 0.49793342E-09_JPRB, 0.49489984E-09_JPRB, 0.49147320E-09_JPRB, 0.48757048E-09_JPRB, 0.48309179E-09_JPRB, &
  & 0.47794696E-09_JPRB, 0.47209447E-09_JPRB, 0.46562559E-09_JPRB, 0.45869863E-09_JPRB, 0.45158302E-09_JPRB, 0.44462273E-09_JPRB, &
  & 0.43801307E-09_JPRB, 0.43193374E-09_JPRB, 0.42632672E-09_JPRB, 0.42108816E-09_JPRB, 0.41608478E-09_JPRB, 0.41111839E-09_JPRB, &
  & 0.40603509E-09_JPRB, 0.40065445E-09_JPRB, 0.39477480E-09_JPRB, 0.38822648E-09_JPRB, 0.38089476E-09_JPRB, 0.37292824E-09_JPRB, &
  & 0.36461417E-09_JPRB, 0.35623465E-09_JPRB, 0.34644632E-09_JPRB, 0.32907208E-09_JPRB /)

RGHG6(:,32, 2) = (/ &
  & 0.33348449E-09_JPRB, 0.34286510E-09_JPRB, 0.34835596E-09_JPRB, 0.35338332E-09_JPRB, 0.35867070E-09_JPRB, 0.36445166E-09_JPRB, &
  & 0.37075149E-09_JPRB, 0.37738704E-09_JPRB, 0.38426601E-09_JPRB, 0.39133338E-09_JPRB, 0.39869538E-09_JPRB, 0.40645565E-09_JPRB, &
  & 0.41468923E-09_JPRB, 0.42333903E-09_JPRB, 0.43226983E-09_JPRB, 0.44128584E-09_JPRB, 0.45014087E-09_JPRB, 0.45861620E-09_JPRB, &
  & 0.46655713E-09_JPRB, 0.47390325E-09_JPRB, 0.48065707E-09_JPRB, 0.48686360E-09_JPRB, 0.49252291E-09_JPRB, 0.49764826E-09_JPRB, &
  & 0.50211352E-09_JPRB, 0.50589977E-09_JPRB, 0.50895621E-09_JPRB, 0.51125520E-09_JPRB, 0.51286797E-09_JPRB, 0.51385551E-09_JPRB, &
  & 0.51425308E-09_JPRB, 0.51413329E-09_JPRB, 0.51354937E-09_JPRB, 0.51250643E-09_JPRB, 0.51109272E-09_JPRB, 0.50931309E-09_JPRB, &
  & 0.50723342E-09_JPRB, 0.50487753E-09_JPRB, 0.50224086E-09_JPRB, 0.49927867E-09_JPRB, 0.49589416E-09_JPRB, 0.49196541E-09_JPRB, &
  & 0.48738169E-09_JPRB, 0.48211579E-09_JPRB, 0.47623339E-09_JPRB, 0.46994075E-09_JPRB, 0.46348192E-09_JPRB, 0.45710452E-09_JPRB, &
  & 0.45108628E-09_JPRB, 0.44547957E-09_JPRB, 0.44028517E-09_JPRB, 0.43541795E-09_JPRB, 0.43071752E-09_JPRB, 0.42605952E-09_JPRB, &
  & 0.42127257E-09_JPRB, 0.41619252E-09_JPRB, 0.41063430E-09_JPRB, 0.40441572E-09_JPRB, 0.39749881E-09_JPRB, 0.39006670E-09_JPRB, &
  & 0.38259540E-09_JPRB, 0.37507464E-09_JPRB, 0.36676073E-09_JPRB, 0.35133788E-09_JPRB /)

RGHG6(:,33, 2) = (/ &
  & 0.34964201E-09_JPRB, 0.35836015E-09_JPRB, 0.36347403E-09_JPRB, 0.36806333E-09_JPRB, 0.37285397E-09_JPRB, 0.37813647E-09_JPRB, &
  & 0.38388792E-09_JPRB, 0.38993830E-09_JPRB, 0.39618903E-09_JPRB, 0.40258774E-09_JPRB, 0.40927045E-09_JPRB, 0.41637091E-09_JPRB, &
  & 0.42398590E-09_JPRB, 0.43214676E-09_JPRB, 0.44075157E-09_JPRB, 0.44956730E-09_JPRB, 0.45829870E-09_JPRB, 0.46668402E-09_JPRB, &
  & 0.47453030E-09_JPRB, 0.48174192E-09_JPRB, 0.48833104E-09_JPRB, 0.49431104E-09_JPRB, 0.49972343E-09_JPRB, 0.50452864E-09_JPRB, &
  & 0.50869842E-09_JPRB, 0.51221116E-09_JPRB, 0.51502713E-09_JPRB, 0.51717364E-09_JPRB, 0.51867249E-09_JPRB, 0.51959348E-09_JPRB, &
  & 0.51992632E-09_JPRB, 0.51978488E-09_JPRB, 0.51916338E-09_JPRB, 0.51813992E-09_JPRB, 0.51677679E-09_JPRB, 0.51513682E-09_JPRB, &
  & 0.51328736E-09_JPRB, 0.51123550E-09_JPRB, 0.50896631E-09_JPRB, 0.50641230E-09_JPRB, 0.50344462E-09_JPRB, 0.49992621E-09_JPRB, &
  & 0.49577026E-09_JPRB, 0.49093618E-09_JPRB, 0.48554549E-09_JPRB, 0.47977605E-09_JPRB, 0.47385784E-09_JPRB, 0.46806453E-09_JPRB, &
  & 0.46253124E-09_JPRB, 0.45737802E-09_JPRB, 0.45256227E-09_JPRB, 0.44800180E-09_JPRB, 0.44359549E-09_JPRB, 0.43919676E-09_JPRB, &
  & 0.43468867E-09_JPRB, 0.42990353E-09_JPRB, 0.42467085E-09_JPRB, 0.41883566E-09_JPRB, 0.41238818E-09_JPRB, 0.40558890E-09_JPRB, &
  & 0.39884279E-09_JPRB, 0.39232420E-09_JPRB, 0.38492418E-09_JPRB, 0.37168602E-09_JPRB /)

RGHG6(:,34, 2) = (/ &
  & 0.36507022E-09_JPRB, 0.37330880E-09_JPRB, 0.37796549E-09_JPRB, 0.38216111E-09_JPRB, 0.38653641E-09_JPRB, 0.39133591E-09_JPRB, &
  & 0.39657608E-09_JPRB, 0.40208198E-09_JPRB, 0.40772336E-09_JPRB, 0.41348197E-09_JPRB, 0.41950621E-09_JPRB, 0.42597098E-09_JPRB, &
  & 0.43303428E-09_JPRB, 0.44073262E-09_JPRB, 0.44898579E-09_JPRB, 0.45755857E-09_JPRB, 0.46615062E-09_JPRB, 0.47444920E-09_JPRB, &
  & 0.48218352E-09_JPRB, 0.48925541E-09_JPRB, 0.49563459E-09_JPRB, 0.50134047E-09_JPRB, 0.50637550E-09_JPRB, 0.51077809E-09_JPRB, &
  & 0.51449506E-09_JPRB, 0.51760657E-09_JPRB, 0.52006599E-09_JPRB, 0.52195576E-09_JPRB, 0.52328641E-09_JPRB, 0.52410726E-09_JPRB, &
  & 0.52442417E-09_JPRB, 0.52431931E-09_JPRB, 0.52378707E-09_JPRB, 0.52290128E-09_JPRB, 0.52171073E-09_JPRB, 0.52030319E-09_JPRB, &
  & 0.51872318E-09_JPRB, 0.51698945E-09_JPRB, 0.51507593E-09_JPRB, 0.51288113E-09_JPRB, 0.51025628E-09_JPRB, 0.50705934E-09_JPRB, &
  & 0.50318666E-09_JPRB, 0.49867982E-09_JPRB, 0.49364068E-09_JPRB, 0.48828991E-09_JPRB, 0.48285909E-09_JPRB, 0.47752069E-09_JPRB, &
  & 0.47246190E-09_JPRB, 0.46769860E-09_JPRB, 0.46322360E-09_JPRB, 0.45896426E-09_JPRB, 0.45480494E-09_JPRB, 0.45066231E-09_JPRB, &
  & 0.44641041E-09_JPRB, 0.44191101E-09_JPRB, 0.43701154E-09_JPRB, 0.43159340E-09_JPRB, 0.42566828E-09_JPRB, 0.41949488E-09_JPRB, &
  & 0.41349046E-09_JPRB, 0.40762949E-09_JPRB, 0.40123341E-09_JPRB, 0.38945244E-09_JPRB /)

RGHG6(:,35, 2) = (/ &
  & 0.37981557E-09_JPRB, 0.38745651E-09_JPRB, 0.39181036E-09_JPRB, 0.39564849E-09_JPRB, 0.39962930E-09_JPRB, 0.40402076E-09_JPRB, &
  & 0.40878251E-09_JPRB, 0.41377121E-09_JPRB, 0.41883150E-09_JPRB, 0.42398285E-09_JPRB, 0.42936382E-09_JPRB, 0.43517623E-09_JPRB, &
  & 0.44162290E-09_JPRB, 0.44883780E-09_JPRB, 0.45676310E-09_JPRB, 0.46513737E-09_JPRB, 0.47361703E-09_JPRB, 0.48182586E-09_JPRB, &
  & 0.48946119E-09_JPRB, 0.49637827E-09_JPRB, 0.50252269E-09_JPRB, 0.50788751E-09_JPRB, 0.51248783E-09_JPRB, 0.51637278E-09_JPRB, &
  & 0.51954563E-09_JPRB, 0.52213994E-09_JPRB, 0.52413385E-09_JPRB, 0.52568805E-09_JPRB, 0.52677779E-09_JPRB, 0.52746574E-09_JPRB, &
  & 0.52776628E-09_JPRB, 0.52772031E-09_JPRB, 0.52733551E-09_JPRB, 0.52664850E-09_JPRB, 0.52570792E-09_JPRB, 0.52457755E-09_JPRB, &
  & 0.52329990E-09_JPRB, 0.52189741E-09_JPRB, 0.52031479E-09_JPRB, 0.51844862E-09_JPRB, 0.51614646E-09_JPRB, 0.51323867E-09_JPRB, &
  & 0.50965521E-09_JPRB, 0.50538129E-09_JPRB, 0.50063353E-09_JPRB, 0.49561882E-09_JPRB, 0.49055382E-09_JPRB, 0.48565019E-09_JPRB, &
  & 0.48095955E-09_JPRB, 0.47655574E-09_JPRB, 0.47238896E-09_JPRB, 0.46838106E-09_JPRB, 0.46446894E-09_JPRB, 0.46055285E-09_JPRB, &
  & 0.45653639E-09_JPRB, 0.45230530E-09_JPRB, 0.44774368E-09_JPRB, 0.44273912E-09_JPRB, 0.43735668E-09_JPRB, 0.43181153E-09_JPRB, &
  & 0.42642384E-09_JPRB, 0.42125808E-09_JPRB, 0.41546386E-09_JPRB, 0.40510903E-09_JPRB /)

RGHG6(:,36, 2) = (/ &
  & 0.39378154E-09_JPRB, 0.40096787E-09_JPRB, 0.40494488E-09_JPRB, 0.40848000E-09_JPRB, 0.41214782E-09_JPRB, 0.41614934E-09_JPRB, &
  & 0.42048315E-09_JPRB, 0.42498274E-09_JPRB, 0.42949802E-09_JPRB, 0.43405407E-09_JPRB, 0.43881418E-09_JPRB, 0.44400131E-09_JPRB, &
  & 0.44985674E-09_JPRB, 0.45656243E-09_JPRB, 0.46411128E-09_JPRB, 0.47226006E-09_JPRB, 0.48061394E-09_JPRB, 0.48873344E-09_JPRB, &
  & 0.49626481E-09_JPRB, 0.50301796E-09_JPRB, 0.50888072E-09_JPRB, 0.51383786E-09_JPRB, 0.51790183E-09_JPRB, 0.52116267E-09_JPRB, &
  & 0.52369131E-09_JPRB, 0.52567523E-09_JPRB, 0.52717575E-09_JPRB, 0.52833216E-09_JPRB, 0.52916604E-09_JPRB, 0.52970389E-09_JPRB, &
  & 0.52996840E-09_JPRB, 0.52996885E-09_JPRB, 0.52971172E-09_JPRB, 0.52921206E-09_JPRB, 0.52850413E-09_JPRB, 0.52763266E-09_JPRB, &
  & 0.52663729E-09_JPRB, 0.52552435E-09_JPRB, 0.52424409E-09_JPRB, 0.52270144E-09_JPRB, 0.52073734E-09_JPRB, 0.51819782E-09_JPRB, &
  & 0.51493548E-09_JPRB, 0.51100724E-09_JPRB, 0.50653293E-09_JPRB, 0.50182464E-09_JPRB, 0.49711318E-09_JPRB, 0.49252963E-09_JPRB, &
  & 0.48818743E-09_JPRB, 0.48407572E-09_JPRB, 0.48016274E-09_JPRB, 0.47639798E-09_JPRB, 0.47269438E-09_JPRB, 0.46898752E-09_JPRB, &
  & 0.46519283E-09_JPRB, 0.46122522E-09_JPRB, 0.45697354E-09_JPRB, 0.45240001E-09_JPRB, 0.44752801E-09_JPRB, 0.44258369E-09_JPRB, &
  & 0.43780529E-09_JPRB, 0.43315826E-09_JPRB, 0.42803069E-09_JPRB, 0.41872425E-09_JPRB /)

RGHG6(:,37, 2) = (/ &
  & 0.40712966E-09_JPRB, 0.41373135E-09_JPRB, 0.41743403E-09_JPRB, 0.42068557E-09_JPRB, 0.42406068E-09_JPRB, 0.42774995E-09_JPRB, &
  & 0.43168868E-09_JPRB, 0.43572840E-09_JPRB, 0.43972673E-09_JPRB, 0.44371876E-09_JPRB, 0.44786522E-09_JPRB, 0.45240134E-09_JPRB, &
  & 0.45763973E-09_JPRB, 0.46380721E-09_JPRB, 0.47097437E-09_JPRB, 0.47888443E-09_JPRB, 0.48708720E-09_JPRB, 0.49510063E-09_JPRB, &
  & 0.50251880E-09_JPRB, 0.50904070E-09_JPRB, 0.51451621E-09_JPRB, 0.51894372E-09_JPRB, 0.52231830E-09_JPRB, 0.52487298E-09_JPRB, &
  & 0.52673649E-09_JPRB, 0.52814986E-09_JPRB, 0.52920313E-09_JPRB, 0.53003435E-09_JPRB, 0.53064930E-09_JPRB, 0.53106836E-09_JPRB, &
  & 0.53129462E-09_JPRB, 0.53131977E-09_JPRB, 0.53114496E-09_JPRB, 0.53077420E-09_JPRB, 0.53023241E-09_JPRB, 0.52955246E-09_JPRB, &
  & 0.52876603E-09_JPRB, 0.52787580E-09_JPRB, 0.52684096E-09_JPRB, 0.52557741E-09_JPRB, 0.52395221E-09_JPRB, 0.52179500E-09_JPRB, &
  & 0.51898852E-09_JPRB, 0.51545151E-09_JPRB, 0.51137916E-09_JPRB, 0.50699961E-09_JPRB, 0.50259891E-09_JPRB, 0.49833415E-09_JPRB, &
  & 0.49426113E-09_JPRB, 0.49039728E-09_JPRB, 0.48671267E-09_JPRB, 0.48314519E-09_JPRB, 0.47964166E-09_JPRB, 0.47613552E-09_JPRB, &
  & 0.47256288E-09_JPRB, 0.46885362E-09_JPRB, 0.46493745E-09_JPRB, 0.46075993E-09_JPRB, 0.45639564E-09_JPRB, 0.45199433E-09_JPRB, &
  & 0.44775056E-09_JPRB, 0.44362761E-09_JPRB, 0.43905074E-09_JPRB, 0.43078457E-09_JPRB /)

RGHG6(:,38, 2) = (/ &
  & 0.41980325E-09_JPRB, 0.42587164E-09_JPRB, 0.42922027E-09_JPRB, 0.43224874E-09_JPRB, 0.43538573E-09_JPRB, 0.43879672E-09_JPRB, &
  & 0.44239018E-09_JPRB, 0.44599591E-09_JPRB, 0.44950879E-09_JPRB, 0.45295903E-09_JPRB, 0.45651291E-09_JPRB, 0.46043569E-09_JPRB, &
  & 0.46501666E-09_JPRB, 0.47060716E-09_JPRB, 0.47730309E-09_JPRB, 0.48492543E-09_JPRB, 0.49295151E-09_JPRB, 0.50080695E-09_JPRB, &
  & 0.50801885E-09_JPRB, 0.51420174E-09_JPRB, 0.51913618E-09_JPRB, 0.52284344E-09_JPRB, 0.52551841E-09_JPRB, 0.52739946E-09_JPRB, &
  & 0.52873550E-09_JPRB, 0.52972571E-09_JPRB, 0.53047827E-09_JPRB, 0.53108529E-09_JPRB, 0.53155896E-09_JPRB, 0.53189875E-09_JPRB, &
  & 0.53209648E-09_JPRB, 0.53213450E-09_JPRB, 0.53200788E-09_JPRB, 0.53171623E-09_JPRB, 0.53128024E-09_JPRB, 0.53072707E-09_JPRB, &
  & 0.53008464E-09_JPRB, 0.52935056E-09_JPRB, 0.52849403E-09_JPRB, 0.52744359E-09_JPRB, 0.52608629E-09_JPRB, 0.52428445E-09_JPRB, &
  & 0.52188653E-09_JPRB, 0.51883392E-09_JPRB, 0.51518451E-09_JPRB, 0.51120591E-09_JPRB, 0.50713606E-09_JPRB, 0.50315274E-09_JPRB, &
  & 0.49932758E-09_JPRB, 0.49567800E-09_JPRB, 0.49217347E-09_JPRB, 0.48878790E-09_JPRB, 0.48546672E-09_JPRB, 0.48216564E-09_JPRB, &
  & 0.47883608E-09_JPRB, 0.47541443E-09_JPRB, 0.47184390E-09_JPRB, 0.46808496E-09_JPRB, 0.46418414E-09_JPRB, 0.46027920E-09_JPRB, &
  & 0.45650828E-09_JPRB, 0.45285453E-09_JPRB, 0.44875775E-09_JPRB, 0.44146711E-09_JPRB /)

RGHG6(:,39, 2) = (/ &
  & 0.43181386E-09_JPRB, 0.43721948E-09_JPRB, 0.44032208E-09_JPRB, 0.44310128E-09_JPRB, 0.44606557E-09_JPRB, 0.44923587E-09_JPRB, &
  & 0.45251558E-09_JPRB, 0.45572043E-09_JPRB, 0.45876994E-09_JPRB, 0.46171433E-09_JPRB, 0.46473489E-09_JPRB, 0.46804211E-09_JPRB, &
  & 0.47201976E-09_JPRB, 0.47697635E-09_JPRB, 0.48318033E-09_JPRB, 0.49043214E-09_JPRB, 0.49820692E-09_JPRB, 0.50582122E-09_JPRB, &
  & 0.51264570E-09_JPRB, 0.51829019E-09_JPRB, 0.52253446E-09_JPRB, 0.52554516E-09_JPRB, 0.52760007E-09_JPRB, 0.52900273E-09_JPRB, &
  & 0.52999083E-09_JPRB, 0.53072119E-09_JPRB, 0.53129073E-09_JPRB, 0.53176502E-09_JPRB, 0.53215110E-09_JPRB, 0.53244215E-09_JPRB, &
  & 0.53262084E-09_JPRB, 0.53266547E-09_JPRB, 0.53256671E-09_JPRB, 0.53232457E-09_JPRB, 0.53195565E-09_JPRB, 0.53148830E-09_JPRB, &
  & 0.53094362E-09_JPRB, 0.53032134E-09_JPRB, 0.52959176E-09_JPRB, 0.52869586E-09_JPRB, 0.52754179E-09_JPRB, 0.52600740E-09_JPRB, &
  & 0.52396987E-09_JPRB, 0.52133531E-09_JPRB, 0.51814064E-09_JPRB, 0.51455978E-09_JPRB, 0.51083215E-09_JPRB, 0.50712995E-09_JPRB, &
  & 0.50354254E-09_JPRB, 0.50006865E-09_JPRB, 0.49672710E-09_JPRB, 0.49349269E-09_JPRB, 0.49034204E-09_JPRB, 0.48725285E-09_JPRB, &
  & 0.48417842E-09_JPRB, 0.48108306E-09_JPRB, 0.47788490E-09_JPRB, 0.47455201E-09_JPRB, 0.47110205E-09_JPRB, 0.46764431E-09_JPRB, &
  & 0.46430812E-09_JPRB, 0.46103790E-09_JPRB, 0.45745022E-09_JPRB, 0.45097753E-09_JPRB /)

RGHG6(:,40, 2) = (/ &
  & 0.44293330E-09_JPRB, 0.44778575E-09_JPRB, 0.45056189E-09_JPRB, 0.45319790E-09_JPRB, 0.45597986E-09_JPRB, 0.45896906E-09_JPRB, &
  & 0.46195492E-09_JPRB, 0.46477966E-09_JPRB, 0.46740739E-09_JPRB, 0.46990439E-09_JPRB, 0.47242460E-09_JPRB, 0.47522869E-09_JPRB, &
  & 0.47858506E-09_JPRB, 0.48293597E-09_JPRB, 0.48855536E-09_JPRB, 0.49538607E-09_JPRB, 0.50282989E-09_JPRB, 0.51007398E-09_JPRB, &
  & 0.51639504E-09_JPRB, 0.52133536E-09_JPRB, 0.52490745E-09_JPRB, 0.52731847E-09_JPRB, 0.52894000E-09_JPRB, 0.53002908E-09_JPRB, &
  & 0.53080612E-09_JPRB, 0.53138255E-09_JPRB, 0.53184651E-09_JPRB, 0.53223992E-09_JPRB, 0.53257304E-09_JPRB, 0.53283233E-09_JPRB, &
  & 0.53299698E-09_JPRB, 0.53304416E-09_JPRB, 0.53296223E-09_JPRB, 0.53275145E-09_JPRB, 0.53242832E-09_JPRB, 0.53201932E-09_JPRB, &
  & 0.53154586E-09_JPRB, 0.53100413E-09_JPRB, 0.53036914E-09_JPRB, 0.52958987E-09_JPRB, 0.52858695E-09_JPRB, 0.52726040E-09_JPRB, &
  & 0.52549887E-09_JPRB, 0.52321025E-09_JPRB, 0.52040589E-09_JPRB, 0.51720939E-09_JPRB, 0.51383348E-09_JPRB, 0.51042798E-09_JPRB, &
  & 0.50705445E-09_JPRB, 0.50376225E-09_JPRB, 0.50054866E-09_JPRB, 0.49743304E-09_JPRB, 0.49443705E-09_JPRB, 0.49154547E-09_JPRB, &
  & 0.48875193E-09_JPRB, 0.48598625E-09_JPRB, 0.48318788E-09_JPRB, 0.48027932E-09_JPRB, 0.47727622E-09_JPRB, 0.47425119E-09_JPRB, &
  & 0.47130266E-09_JPRB, 0.46843163E-09_JPRB, 0.46520560E-09_JPRB, 0.45953766E-09_JPRB /)

RGHG6(:,41, 2) = (/ &
  & 0.45310028E-09_JPRB, 0.45739942E-09_JPRB, 0.45995746E-09_JPRB, 0.46240839E-09_JPRB, 0.46508405E-09_JPRB, 0.46788545E-09_JPRB, &
  & 0.47059889E-09_JPRB, 0.47308568E-09_JPRB, 0.47532583E-09_JPRB, 0.47743409E-09_JPRB, 0.47954829E-09_JPRB, 0.48188209E-09_JPRB, &
  & 0.48474580E-09_JPRB, 0.48849996E-09_JPRB, 0.49354187E-09_JPRB, 0.49988258E-09_JPRB, 0.50689591E-09_JPRB, 0.51368038E-09_JPRB, &
  & 0.51935378E-09_JPRB, 0.52361415E-09_JPRB, 0.52656618E-09_JPRB, 0.52852900E-09_JPRB, 0.52984545E-09_JPRB, 0.53073174E-09_JPRB, &
  & 0.53137794E-09_JPRB, 0.53186083E-09_JPRB, 0.53225924E-09_JPRB, 0.53260452E-09_JPRB, 0.53290128E-09_JPRB, 0.53313914E-09_JPRB, &
  & 0.53329119E-09_JPRB, 0.53333754E-09_JPRB, 0.53326571E-09_JPRB, 0.53307603E-09_JPRB, 0.53278432E-09_JPRB, 0.53241866E-09_JPRB, &
  & 0.53199700E-09_JPRB, 0.53151789E-09_JPRB, 0.53095650E-09_JPRB, 0.53026805E-09_JPRB, 0.52938565E-09_JPRB, 0.52822180E-09_JPRB, &
  & 0.52667992E-09_JPRB, 0.52467941E-09_JPRB, 0.52220284E-09_JPRB, 0.51936411E-09_JPRB, 0.51631027E-09_JPRB, 0.51318727E-09_JPRB, &
  & 0.51005650E-09_JPRB, 0.50692273E-09_JPRB, 0.50381516E-09_JPRB, 0.50080501E-09_JPRB, 0.49792115E-09_JPRB, 0.49523108E-09_JPRB, &
  & 0.49269755E-09_JPRB, 0.49027249E-09_JPRB, 0.48785370E-09_JPRB, 0.48537141E-09_JPRB, 0.48280202E-09_JPRB, 0.48019921E-09_JPRB, &
  & 0.47764637E-09_JPRB, 0.47510629E-09_JPRB, 0.47228971E-09_JPRB, 0.46726961E-09_JPRB /)

RGHG6(:,42, 2) = (/ &
  & 0.46228646E-09_JPRB, 0.46611814E-09_JPRB, 0.46845472E-09_JPRB, 0.47076398E-09_JPRB, 0.47331267E-09_JPRB, 0.47594501E-09_JPRB, &
  & 0.47840626E-09_JPRB, 0.48057897E-09_JPRB, 0.48250137E-09_JPRB, 0.48427834E-09_JPRB, 0.48605575E-09_JPRB, 0.48802279E-09_JPRB, &
  & 0.49043669E-09_JPRB, 0.49368776E-09_JPRB, 0.49816318E-09_JPRB, 0.50397359E-09_JPRB, 0.51051458E-09_JPRB, 0.51668092E-09_JPRB, &
  & 0.52172477E-09_JPRB, 0.52532534E-09_JPRB, 0.52778132E-09_JPRB, 0.52940302E-09_JPRB, 0.53050075E-09_JPRB, 0.53125288E-09_JPRB, &
  & 0.53181115E-09_JPRB, 0.53223459E-09_JPRB, 0.53259280E-09_JPRB, 0.53290417E-09_JPRB, 0.53317850E-09_JPRB, 0.53339705E-09_JPRB, &
  & 0.53353794E-09_JPRB, 0.53358012E-09_JPRB, 0.53351357E-09_JPRB, 0.53333793E-09_JPRB, 0.53306964E-09_JPRB, 0.53273569E-09_JPRB, &
  & 0.53235488E-09_JPRB, 0.53192467E-09_JPRB, 0.53142302E-09_JPRB, 0.53081062E-09_JPRB, 0.53002730E-09_JPRB, 0.52899890E-09_JPRB, &
  & 0.52764032E-09_JPRB, 0.52587046E-09_JPRB, 0.52367743E-09_JPRB, 0.52113369E-09_JPRB, 0.51839838E-09_JPRB, 0.51556176E-09_JPRB, &
  & 0.51266308E-09_JPRB, 0.50969590E-09_JPRB, 0.50670762E-09_JPRB, 0.50375476E-09_JPRB, 0.50100002E-09_JPRB, 0.49848198E-09_JPRB, &
  & 0.49621190E-09_JPRB, 0.49409998E-09_JPRB, 0.49204318E-09_JPRB, 0.48995108E-09_JPRB, 0.48779419E-09_JPRB, 0.48560200E-09_JPRB, &
  & 0.48342147E-09_JPRB, 0.48123405E-09_JPRB, 0.47874277E-09_JPRB, 0.47433252E-09_JPRB /)

RGHG6(:,43, 2) = (/ &
  & 0.47056126E-09_JPRB, 0.47399695E-09_JPRB, 0.47612964E-09_JPRB, 0.47829157E-09_JPRB, 0.48069632E-09_JPRB, 0.48315285E-09_JPRB, &
  & 0.48538451E-09_JPRB, 0.48729548E-09_JPRB, 0.48895854E-09_JPRB, 0.49046917E-09_JPRB, 0.49198079E-09_JPRB, 0.49364524E-09_JPRB, &
  & 0.49571214E-09_JPRB, 0.49851473E-09_JPRB, 0.50249666E-09_JPRB, 0.50777205E-09_JPRB, 0.51375060E-09_JPRB, 0.51929383E-09_JPRB, &
  & 0.52361721E-09_JPRB, 0.52666360E-09_JPRB, 0.52870436E-09_JPRB, 0.53006888E-09_JPRB, 0.53100524E-09_JPRB, 0.53166377E-09_JPRB, &
  & 0.53216065E-09_JPRB, 0.53254601E-09_JPRB, 0.53287630E-09_JPRB, 0.53316784E-09_JPRB, 0.53342214E-09_JPRB, 0.53362681E-09_JPRB, &
  & 0.53375404E-09_JPRB, 0.53379001E-09_JPRB, 0.53372512E-09_JPRB, 0.53355914E-09_JPRB, 0.53330773E-09_JPRB, 0.53299865E-09_JPRB, &
  & 0.53264976E-09_JPRB, 0.53225951E-09_JPRB, 0.53180793E-09_JPRB, 0.53125915E-09_JPRB, 0.53056204E-09_JPRB, 0.52965038E-09_JPRB, &
  & 0.52844967E-09_JPRB, 0.52688576E-09_JPRB, 0.52493321E-09_JPRB, 0.52266647E-09_JPRB, 0.52020166E-09_JPRB, 0.51763827E-09_JPRB, &
  & 0.51497440E-09_JPRB, 0.51219873E-09_JPRB, 0.50931459E-09_JPRB, 0.50648125E-09_JPRB, 0.50383053E-09_JPRB, 0.50151067E-09_JPRB, &
  & 0.49948690E-09_JPRB, 0.49766141E-09_JPRB, 0.49592225E-09_JPRB, 0.49417692E-09_JPRB, 0.49238852E-09_JPRB, 0.49057075E-09_JPRB, &
  & 0.48874671E-09_JPRB, 0.48687310E-09_JPRB, 0.48471716E-09_JPRB, 0.48083937E-09_JPRB /)

RGHG6(:,44, 2) = (/ &
  & 0.47802534E-09_JPRB, 0.48115389E-09_JPRB, 0.48307158E-09_JPRB, 0.48507803E-09_JPRB, 0.48732018E-09_JPRB, 0.48960513E-09_JPRB, &
  & 0.49163090E-09_JPRB, 0.49335386E-09_JPRB, 0.49480237E-09_JPRB, 0.49611976E-09_JPRB, 0.49740934E-09_JPRB, 0.49883714E-09_JPRB, &
  & 0.50060778E-09_JPRB, 0.50304483E-09_JPRB, 0.50655780E-09_JPRB, 0.51133198E-09_JPRB, 0.51669091E-09_JPRB, 0.52152349E-09_JPRB, &
  & 0.52519189E-09_JPRB, 0.52772064E-09_JPRB, 0.52943250E-09_JPRB, 0.53059362E-09_JPRB, 0.53141158E-09_JPRB, 0.53200011E-09_JPRB, &
  & 0.53245436E-09_JPRB, 0.53281540E-09_JPRB, 0.53312765E-09_JPRB, 0.53340438E-09_JPRB, 0.53364668E-09_JPRB, 0.53383475E-09_JPRB, &
  & 0.53394950E-09_JPRB, 0.53397653E-09_JPRB, 0.53391025E-09_JPRB, 0.53375021E-09_JPRB, 0.53351162E-09_JPRB, 0.53322152E-09_JPRB, &
  & 0.53289850E-09_JPRB, 0.53254134E-09_JPRB, 0.53213145E-09_JPRB, 0.53163807E-09_JPRB, 0.53101545E-09_JPRB, 0.53020771E-09_JPRB, &
  & 0.52914817E-09_JPRB, 0.52776727E-09_JPRB, 0.52603333E-09_JPRB, 0.52400295E-09_JPRB, 0.52179755E-09_JPRB, 0.51948368E-09_JPRB, &
  & 0.51705906E-09_JPRB, 0.51447535E-09_JPRB, 0.51177013E-09_JPRB, 0.50905591E-09_JPRB, 0.50658833E-09_JPRB, 0.50446791E-09_JPRB, &
  & 0.50268223E-09_JPRB, 0.50111482E-09_JPRB, 0.49964310E-09_JPRB, 0.49819099E-09_JPRB, 0.49671600E-09_JPRB, 0.49522414E-09_JPRB, &
  & 0.49371573E-09_JPRB, 0.49214438E-09_JPRB, 0.49028454E-09_JPRB, 0.48690779E-09_JPRB /)

RGHG6(:,45, 2) = (/ &
  & 0.48486892E-09_JPRB, 0.48761828E-09_JPRB, 0.48942955E-09_JPRB, 0.49122828E-09_JPRB, 0.49332594E-09_JPRB, 0.49543708E-09_JPRB, &
  & 0.49733617E-09_JPRB, 0.49888854E-09_JPRB, 0.50021010E-09_JPRB, 0.50135907E-09_JPRB, 0.50248489E-09_JPRB, 0.50371013E-09_JPRB, &
  & 0.50521864E-09_JPRB, 0.50733645E-09_JPRB, 0.51040955E-09_JPRB, 0.51463472E-09_JPRB, 0.51934862E-09_JPRB, 0.52343968E-09_JPRB, &
  & 0.52647331E-09_JPRB, 0.52857391E-09_JPRB, 0.53001048E-09_JPRB, 0.53102034E-09_JPRB, 0.53174098E-09_JPRB, 0.53228438E-09_JPRB, &
  & 0.53270732E-09_JPRB, 0.53305188E-09_JPRB, 0.53335542E-09_JPRB, 0.53362242E-09_JPRB, 0.53385213E-09_JPRB, 0.53402760E-09_JPRB, &
  & 0.53412696E-09_JPRB, 0.53414406E-09_JPRB, 0.53407423E-09_JPRB, 0.53391735E-09_JPRB, 0.53368748E-09_JPRB, 0.53341243E-09_JPRB, &
  & 0.53311056E-09_JPRB, 0.53278026E-09_JPRB, 0.53240612E-09_JPRB, 0.53195925E-09_JPRB, 0.53140203E-09_JPRB, 0.53068644E-09_JPRB, &
  & 0.52975729E-09_JPRB, 0.52854837E-09_JPRB, 0.52702398E-09_JPRB, 0.52522225E-09_JPRB, 0.52324833E-09_JPRB, 0.52117349E-09_JPRB, &
  & 0.51897375E-09_JPRB, 0.51661198E-09_JPRB, 0.51408899E-09_JPRB, 0.51159915E-09_JPRB, 0.50932569E-09_JPRB, 0.50745258E-09_JPRB, &
  & 0.50589266E-09_JPRB, 0.50455018E-09_JPRB, 0.50330995E-09_JPRB, 0.50209359E-09_JPRB, 0.50087789E-09_JPRB, 0.49965687E-09_JPRB, &
  & 0.49841986E-09_JPRB, 0.49711113E-09_JPRB, 0.49553939E-09_JPRB, 0.49262711E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART3',1,ZHOOK_HANDLE)
END SUBROUTINE PART3




SUBROUTINE PART4
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART4',0,ZHOOK_HANDLE)



RGHG6(:,46, 2) = (/ &
  & 0.49105919E-09_JPRB, 0.49366011E-09_JPRB, 0.49521598E-09_JPRB, 0.49693039E-09_JPRB, 0.49883264E-09_JPRB, 0.50083465E-09_JPRB, &
  & 0.50260651E-09_JPRB, 0.50408655E-09_JPRB, 0.50528093E-09_JPRB, 0.50631771E-09_JPRB, 0.50729843E-09_JPRB, 0.50833904E-09_JPRB, &
  & 0.50964166E-09_JPRB, 0.51139570E-09_JPRB, 0.51408516E-09_JPRB, 0.51770238E-09_JPRB, 0.52168592E-09_JPRB, 0.52506338E-09_JPRB, &
  & 0.52752802E-09_JPRB, 0.52925736E-09_JPRB, 0.53047977E-09_JPRB, 0.53136201E-09_JPRB, 0.53202048E-09_JPRB, 0.53252408E-09_JPRB, &
  & 0.53292798E-09_JPRB, 0.53326721E-09_JPRB, 0.53356120E-09_JPRB, 0.53382448E-09_JPRB, 0.53404475E-09_JPRB, 0.53420390E-09_JPRB, &
  & 0.53428900E-09_JPRB, 0.53429472E-09_JPRB, 0.53421945E-09_JPRB, 0.53406285E-09_JPRB, 0.53383958E-09_JPRB, 0.53357635E-09_JPRB, &
  & 0.53329113E-09_JPRB, 0.53298377E-09_JPRB, 0.53263804E-09_JPRB, 0.53223143E-09_JPRB, 0.53173005E-09_JPRB, 0.53109733E-09_JPRB, &
  & 0.53028726E-09_JPRB, 0.52924531E-09_JPRB, 0.52792792E-09_JPRB, 0.52635607E-09_JPRB, 0.52461885E-09_JPRB, 0.52277188E-09_JPRB, &
  & 0.52080756E-09_JPRB, 0.51866089E-09_JPRB, 0.51639010E-09_JPRB, 0.51410720E-09_JPRB, 0.51213056E-09_JPRB, 0.51047122E-09_JPRB, &
  & 0.50915133E-09_JPRB, 0.50800758E-09_JPRB, 0.50695753E-09_JPRB, 0.50594173E-09_JPRB, 0.50493293E-09_JPRB, 0.50393145E-09_JPRB, &
  & 0.50291971E-09_JPRB, 0.50184223E-09_JPRB, 0.50052262E-09_JPRB, 0.49805532E-09_JPRB /)

RGHG6(:,47, 2) = (/ &
  & 0.49685484E-09_JPRB, 0.49915116E-09_JPRB, 0.50066901E-09_JPRB, 0.50218268E-09_JPRB, 0.50399201E-09_JPRB, 0.50587501E-09_JPRB, &
  & 0.50758614E-09_JPRB, 0.50898641E-09_JPRB, 0.51009930E-09_JPRB, 0.51103188E-09_JPRB, 0.51187510E-09_JPRB, 0.51277560E-09_JPRB, &
  & 0.51382493E-09_JPRB, 0.51534926E-09_JPRB, 0.51747467E-09_JPRB, 0.52052529E-09_JPRB, 0.52372051E-09_JPRB, 0.52640936E-09_JPRB, &
  & 0.52838384E-09_JPRB, 0.52981031E-09_JPRB, 0.53085480E-09_JPRB, 0.53164678E-09_JPRB, 0.53224919E-09_JPRB, 0.53273363E-09_JPRB, &
  & 0.53312621E-09_JPRB, 0.53345939E-09_JPRB, 0.53375682E-09_JPRB, 0.53401228E-09_JPRB, 0.53422206E-09_JPRB, 0.53436727E-09_JPRB, &
  & 0.53443572E-09_JPRB, 0.53442950E-09_JPRB, 0.53434712E-09_JPRB, 0.53418947E-09_JPRB, 0.53397003E-09_JPRB, 0.53371613E-09_JPRB, &
  & 0.53344501E-09_JPRB, 0.53315508E-09_JPRB, 0.53283428E-09_JPRB, 0.53245980E-09_JPRB, 0.53200722E-09_JPRB, 0.53144694E-09_JPRB, &
  & 0.53074822E-09_JPRB, 0.52986721E-09_JPRB, 0.52876559E-09_JPRB, 0.52744531E-09_JPRB, 0.52595800E-09_JPRB, 0.52436522E-09_JPRB, &
  & 0.52263310E-09_JPRB, 0.52074312E-09_JPRB, 0.51868787E-09_JPRB, 0.51671284E-09_JPRB, 0.51494237E-09_JPRB, 0.51357063E-09_JPRB, &
  & 0.51243537E-09_JPRB, 0.51148114E-09_JPRB, 0.51059840E-09_JPRB, 0.50974230E-09_JPRB, 0.50890475E-09_JPRB, 0.50807974E-09_JPRB, &
  & 0.50725085E-09_JPRB, 0.50636290E-09_JPRB, 0.50527066E-09_JPRB, 0.50320226E-09_JPRB /)

RGHG6(:,48, 2) = (/ &
  & 0.50219467E-09_JPRB, 0.50435484E-09_JPRB, 0.50570359E-09_JPRB, 0.50715471E-09_JPRB, 0.50883747E-09_JPRB, 0.51064719E-09_JPRB, &
  & 0.51231014E-09_JPRB, 0.51364268E-09_JPRB, 0.51468180E-09_JPRB, 0.51549670E-09_JPRB, 0.51623383E-09_JPRB, 0.51696131E-09_JPRB, &
  & 0.51785071E-09_JPRB, 0.51899307E-09_JPRB, 0.52074295E-09_JPRB, 0.52298660E-09_JPRB, 0.52546650E-09_JPRB, 0.52752014E-09_JPRB, &
  & 0.52907817E-09_JPRB, 0.53025384E-09_JPRB, 0.53116078E-09_JPRB, 0.53187532E-09_JPRB, 0.53244925E-09_JPRB, 0.53291543E-09_JPRB, &
  & 0.53330534E-09_JPRB, 0.53364363E-09_JPRB, 0.53393601E-09_JPRB, 0.53419058E-09_JPRB, 0.53438781E-09_JPRB, 0.53451527E-09_JPRB, &
  & 0.53456850E-09_JPRB, 0.53454968E-09_JPRB, 0.53445959E-09_JPRB, 0.53429872E-09_JPRB, 0.53408239E-09_JPRB, 0.53383586E-09_JPRB, &
  & 0.53357546E-09_JPRB, 0.53330079E-09_JPRB, 0.53299842E-09_JPRB, 0.53265192E-09_JPRB, 0.53223953E-09_JPRB, 0.53174387E-09_JPRB, &
  & 0.53114579E-09_JPRB, 0.53042049E-09_JPRB, 0.52954091E-09_JPRB, 0.52849680E-09_JPRB, 0.52731264E-09_JPRB, 0.52599658E-09_JPRB, &
  & 0.52454746E-09_JPRB, 0.52290450E-09_JPRB, 0.52113491E-09_JPRB, 0.51937332E-09_JPRB, 0.51790394E-09_JPRB, 0.51671734E-09_JPRB, &
  & 0.51578891E-09_JPRB, 0.51498400E-09_JPRB, 0.51424137E-09_JPRB, 0.51352167E-09_JPRB, 0.51281612E-09_JPRB, 0.51212989E-09_JPRB, &
  & 0.51144422E-09_JPRB, 0.51070859E-09_JPRB, 0.50980059E-09_JPRB, 0.50807114E-09_JPRB /)

RGHG6(:,49, 2) = (/ &
  & 0.50717935E-09_JPRB, 0.50917648E-09_JPRB, 0.51045768E-09_JPRB, 0.51181365E-09_JPRB, 0.51342675E-09_JPRB, 0.51519122E-09_JPRB, &
  & 0.51680227E-09_JPRB, 0.51807503E-09_JPRB, 0.51900034E-09_JPRB, 0.51971560E-09_JPRB, 0.52031190E-09_JPRB, 0.52090221E-09_JPRB, &
  & 0.52155830E-09_JPRB, 0.52241866E-09_JPRB, 0.52358673E-09_JPRB, 0.52517474E-09_JPRB, 0.52689819E-09_JPRB, 0.52842725E-09_JPRB, &
  & 0.52964200E-09_JPRB, 0.53061294E-09_JPRB, 0.53140781E-09_JPRB, 0.53206861E-09_JPRB, 0.53261784E-09_JPRB, 0.53308191E-09_JPRB, &
  & 0.53347460E-09_JPRB, 0.53381499E-09_JPRB, 0.53411126E-09_JPRB, 0.53435661E-09_JPRB, 0.53453958E-09_JPRB, 0.53465010E-09_JPRB, &
  & 0.53468746E-09_JPRB, 0.53465643E-09_JPRB, 0.53455790E-09_JPRB, 0.53439397E-09_JPRB, 0.53417926E-09_JPRB, 0.53393878E-09_JPRB, &
  & 0.53368759E-09_JPRB, 0.53342419E-09_JPRB, 0.53313776E-09_JPRB, 0.53281290E-09_JPRB, 0.53243554E-09_JPRB, 0.53199556E-09_JPRB, &
  & 0.53148924E-09_JPRB, 0.53090987E-09_JPRB, 0.53025129E-09_JPRB, 0.52950366E-09_JPRB, 0.52865823E-09_JPRB, 0.52769067E-09_JPRB, &
  & 0.52655175E-09_JPRB, 0.52521693E-09_JPRB, 0.52372140E-09_JPRB, 0.52224713E-09_JPRB, 0.52100357E-09_JPRB, 0.52002874E-09_JPRB, &
  & 0.51925603E-09_JPRB, 0.51858362E-09_JPRB, 0.51795240E-09_JPRB, 0.51733484E-09_JPRB, 0.51672988E-09_JPRB, 0.51614280E-09_JPRB, &
  & 0.51555987E-09_JPRB, 0.51493465E-09_JPRB, 0.51416243E-09_JPRB, 0.51269244E-09_JPRB /)

RGHG6(:,50, 2) = (/ &
  & 0.51180060E-09_JPRB, 0.51367510E-09_JPRB, 0.51486798E-09_JPRB, 0.51617804E-09_JPRB, 0.51775151E-09_JPRB, 0.51949822E-09_JPRB, &
  & 0.52104854E-09_JPRB, 0.52221066E-09_JPRB, 0.52299787E-09_JPRB, 0.52355509E-09_JPRB, 0.52399557E-09_JPRB, 0.52439886E-09_JPRB, &
  & 0.52481258E-09_JPRB, 0.52533311E-09_JPRB, 0.52598970E-09_JPRB, 0.52695454E-09_JPRB, 0.52807220E-09_JPRB, 0.52916205E-09_JPRB, &
  & 0.53010152E-09_JPRB, 0.53090943E-09_JPRB, 0.53161381E-09_JPRB, 0.53223126E-09_JPRB, 0.53277122E-09_JPRB, 0.53323479E-09_JPRB, &
  & 0.53363669E-09_JPRB, 0.53398197E-09_JPRB, 0.53427585E-09_JPRB, 0.53451094E-09_JPRB, 0.53467852E-09_JPRB, 0.53477084E-09_JPRB, &
  & 0.53479371E-09_JPRB, 0.53475108E-09_JPRB, 0.53464433E-09_JPRB, 0.53447680E-09_JPRB, 0.53426386E-09_JPRB, 0.53402860E-09_JPRB, &
  & 0.53378457E-09_JPRB, 0.53353078E-09_JPRB, 0.53325638E-09_JPRB, 0.53294991E-09_JPRB, 0.53260113E-09_JPRB, 0.53221016E-09_JPRB, &
  & 0.53178550E-09_JPRB, 0.53134058E-09_JPRB, 0.53088423E-09_JPRB, 0.53042182E-09_JPRB, 0.52991500E-09_JPRB, 0.52931404E-09_JPRB, &
  & 0.52854726E-09_JPRB, 0.52757937E-09_JPRB, 0.52643512E-09_JPRB, 0.52530302E-09_JPRB, 0.52430332E-09_JPRB, 0.52354843E-09_JPRB, &
  & 0.52290683E-09_JPRB, 0.52235172E-09_JPRB, 0.52181159E-09_JPRB, 0.52126725E-09_JPRB, 0.52073029E-09_JPRB, 0.52020749E-09_JPRB, &
  & 0.51968718E-09_JPRB, 0.51913007E-09_JPRB, 0.51844246E-09_JPRB, 0.51713495E-09_JPRB /)

RGHG6(:,51, 2) = (/ &
  & 0.51607318E-09_JPRB, 0.51775928E-09_JPRB, 0.51894344E-09_JPRB, 0.52017313E-09_JPRB, 0.52175436E-09_JPRB, 0.52342553E-09_JPRB, &
  & 0.52486815E-09_JPRB, 0.52579097E-09_JPRB, 0.52635379E-09_JPRB, 0.52670485E-09_JPRB, 0.52695304E-09_JPRB, 0.52714944E-09_JPRB, &
  & 0.52734533E-09_JPRB, 0.52754739E-09_JPRB, 0.52786897E-09_JPRB, 0.52831328E-09_JPRB, 0.52901133E-09_JPRB, 0.52975874E-09_JPRB, &
  & 0.53048721E-09_JPRB, 0.53116117E-09_JPRB, 0.53179261E-09_JPRB, 0.53237853E-09_JPRB, 0.53291005E-09_JPRB, 0.53338312E-09_JPRB, &
  & 0.53379101E-09_JPRB, 0.53414245E-09_JPRB, 0.53442895E-09_JPRB, 0.53465271E-09_JPRB, 0.53480192E-09_JPRB, 0.53487931E-09_JPRB, &
  & 0.53488852E-09_JPRB, 0.53483501E-09_JPRB, 0.53472032E-09_JPRB, 0.53454952E-09_JPRB, 0.53433796E-09_JPRB, 0.53410726E-09_JPRB, &
  & 0.53386967E-09_JPRB, 0.53362331E-09_JPRB, 0.53335913E-09_JPRB, 0.53306737E-09_JPRB, 0.53274385E-09_JPRB, 0.53239568E-09_JPRB, &
  & 0.53204513E-09_JPRB, 0.53171711E-09_JPRB, 0.53143834E-09_JPRB, 0.53119847E-09_JPRB, 0.53096760E-09_JPRB, 0.53067151E-09_JPRB, &
  & 0.53025823E-09_JPRB, 0.52968624E-09_JPRB, 0.52898858E-09_JPRB, 0.52823601E-09_JPRB, 0.52759958E-09_JPRB, 0.52703603E-09_JPRB, &
  & 0.52658633E-09_JPRB, 0.52614646E-09_JPRB, 0.52570237E-09_JPRB, 0.52524018E-09_JPRB, 0.52476157E-09_JPRB, 0.52428895E-09_JPRB, &
  & 0.52381383E-09_JPRB, 0.52330013E-09_JPRB, 0.52265936E-09_JPRB, 0.52145493E-09_JPRB /)

RGHG6(:,52, 2) = (/ &
  & 0.51980381E-09_JPRB, 0.52148341E-09_JPRB, 0.52248411E-09_JPRB, 0.52374804E-09_JPRB, 0.52517346E-09_JPRB, 0.52671151E-09_JPRB, &
  & 0.52776705E-09_JPRB, 0.52837190E-09_JPRB, 0.52867360E-09_JPRB, 0.52883897E-09_JPRB, 0.52893429E-09_JPRB, 0.52899890E-09_JPRB, &
  & 0.52904325E-09_JPRB, 0.52909610E-09_JPRB, 0.52916777E-09_JPRB, 0.52937543E-09_JPRB, 0.52973215E-09_JPRB, 0.53025295E-09_JPRB, &
  & 0.53081434E-09_JPRB, 0.53138949E-09_JPRB, 0.53195931E-09_JPRB, 0.53251847E-09_JPRB, 0.53304700E-09_JPRB, 0.53352323E-09_JPRB, &
  & 0.53394139E-09_JPRB, 0.53428928E-09_JPRB, 0.53457111E-09_JPRB, 0.53477761E-09_JPRB, 0.53491278E-09_JPRB, 0.53497573E-09_JPRB, &
  & 0.53497329E-09_JPRB, 0.53490939E-09_JPRB, 0.53478733E-09_JPRB, 0.53461346E-09_JPRB, 0.53440330E-09_JPRB, 0.53417698E-09_JPRB, &
  & 0.53394467E-09_JPRB, 0.53370530E-09_JPRB, 0.53344951E-09_JPRB, 0.53317123E-09_JPRB, 0.53286953E-09_JPRB, 0.53256127E-09_JPRB, &
  & 0.53227567E-09_JPRB, 0.53205162E-09_JPRB, 0.53190474E-09_JPRB, 0.53182503E-09_JPRB, 0.53175975E-09_JPRB, 0.53166022E-09_JPRB, &
  & 0.53148352E-09_JPRB, 0.53121618E-09_JPRB, 0.53086602E-09_JPRB, 0.53049609E-09_JPRB, 0.53013371E-09_JPRB, 0.52984128E-09_JPRB, &
  & 0.52955318E-09_JPRB, 0.52927851E-09_JPRB, 0.52897670E-09_JPRB, 0.52863280E-09_JPRB, 0.52827009E-09_JPRB, 0.52789384E-09_JPRB, &
  & 0.52750354E-09_JPRB, 0.52707183E-09_JPRB, 0.52651966E-09_JPRB, 0.52543914E-09_JPRB /)

RGHG6(:,53, 2) = (/ &
  & 0.52313859E-09_JPRB, 0.52450244E-09_JPRB, 0.52558446E-09_JPRB, 0.52658555E-09_JPRB, 0.52787857E-09_JPRB, 0.52894733E-09_JPRB, &
  & 0.52961729E-09_JPRB, 0.52991422E-09_JPRB, 0.53004895E-09_JPRB, 0.53010840E-09_JPRB, 0.53013349E-09_JPRB, 0.53013838E-09_JPRB, &
  & 0.53012883E-09_JPRB, 0.53011284E-09_JPRB, 0.53009841E-09_JPRB, 0.53013421E-09_JPRB, 0.53032728E-09_JPRB, 0.53066274E-09_JPRB, &
  & 0.53110705E-09_JPRB, 0.53159999E-09_JPRB, 0.53212573E-09_JPRB, 0.53266108E-09_JPRB, 0.53318150E-09_JPRB, 0.53366189E-09_JPRB, &
  & 0.53407789E-09_JPRB, 0.53442600E-09_JPRB, 0.53469534E-09_JPRB, 0.53489069E-09_JPRB, 0.53501059E-09_JPRB, 0.53506222E-09_JPRB, &
  & 0.53504939E-09_JPRB, 0.53497595E-09_JPRB, 0.53484678E-09_JPRB, 0.53466997E-09_JPRB, 0.53446142E-09_JPRB, 0.53423876E-09_JPRB, &
  & 0.53401189E-09_JPRB, 0.53377841E-09_JPRB, 0.53353144E-09_JPRB, 0.53326510E-09_JPRB, 0.53298577E-09_JPRB, 0.53271304E-09_JPRB, &
  & 0.53248900E-09_JPRB, 0.53234600E-09_JPRB, 0.53229782E-09_JPRB, 0.53231108E-09_JPRB, 0.53233618E-09_JPRB, 0.53233196E-09_JPRB, &
  & 0.53227689E-09_JPRB, 0.53216614E-09_JPRB, 0.53200971E-09_JPRB, 0.53182980E-09_JPRB, 0.53166616E-09_JPRB, 0.53150706E-09_JPRB, &
  & 0.53136706E-09_JPRB, 0.53121457E-09_JPRB, 0.53104060E-09_JPRB, 0.53084170E-09_JPRB, 0.53061372E-09_JPRB, 0.53037480E-09_JPRB, &
  & 0.53012156E-09_JPRB, 0.52983251E-09_JPRB, 0.52945165E-09_JPRB, 0.52865728E-09_JPRB /)

RGHG6(:,54, 2) = (/ &
  & 0.52574123E-09_JPRB, 0.52713700E-09_JPRB, 0.52788679E-09_JPRB, 0.52881011E-09_JPRB, 0.52966087E-09_JPRB, 0.53035504E-09_JPRB, &
  & 0.53068233E-09_JPRB, 0.53081950E-09_JPRB, 0.53086824E-09_JPRB, 0.53088345E-09_JPRB, 0.53088145E-09_JPRB, 0.53086779E-09_JPRB, &
  & 0.53084509E-09_JPRB, 0.53080523E-09_JPRB, 0.53076599E-09_JPRB, 0.53073435E-09_JPRB, 0.53079635E-09_JPRB, 0.53102162E-09_JPRB, &
  & 0.53137095E-09_JPRB, 0.53180649E-09_JPRB, 0.53229271E-09_JPRB, 0.53280835E-09_JPRB, 0.53331867E-09_JPRB, 0.53379184E-09_JPRB, &
  & 0.53420701E-09_JPRB, 0.53454680E-09_JPRB, 0.53480892E-09_JPRB, 0.53499072E-09_JPRB, 0.53509980E-09_JPRB, 0.53514021E-09_JPRB, &
  & 0.53511756E-09_JPRB, 0.53503579E-09_JPRB, 0.53490007E-09_JPRB, 0.53472082E-09_JPRB, 0.53451349E-09_JPRB, 0.53429483E-09_JPRB, &
  & 0.53407267E-09_JPRB, 0.53384563E-09_JPRB, 0.53360683E-09_JPRB, 0.53335453E-09_JPRB, 0.53309562E-09_JPRB, 0.53286026E-09_JPRB, &
  & 0.53268623E-09_JPRB, 0.53261073E-09_JPRB, 0.53262672E-09_JPRB, 0.53269117E-09_JPRB, 0.53275945E-09_JPRB, 0.53279636E-09_JPRB, &
  & 0.53279381E-09_JPRB, 0.53275145E-09_JPRB, 0.53267835E-09_JPRB, 0.53259297E-09_JPRB, 0.53250537E-09_JPRB, 0.53243010E-09_JPRB, &
  & 0.53235272E-09_JPRB, 0.53227300E-09_JPRB, 0.53218008E-09_JPRB, 0.53206528E-09_JPRB, 0.53193866E-09_JPRB, 0.53180299E-09_JPRB, &
  & 0.53166099E-09_JPRB, 0.53150767E-09_JPRB, 0.53131877E-09_JPRB, 0.53096988E-09_JPRB /)

RGHG6(:,55, 2) = (/ &
  & 0.52794236E-09_JPRB, 0.52897658E-09_JPRB, 0.52970528E-09_JPRB, 0.53026794E-09_JPRB, 0.53082716E-09_JPRB, 0.53118576E-09_JPRB, &
  & 0.53134575E-09_JPRB, 0.53139515E-09_JPRB, 0.53140803E-09_JPRB, 0.53140575E-09_JPRB, 0.53139548E-09_JPRB, 0.53137922E-09_JPRB, &
  & 0.53135274E-09_JPRB, 0.53131965E-09_JPRB, 0.53126104E-09_JPRB, 0.53121219E-09_JPRB, 0.53120702E-09_JPRB, 0.53133675E-09_JPRB, &
  & 0.53161908E-09_JPRB, 0.53200616E-09_JPRB, 0.53246424E-09_JPRB, 0.53295712E-09_JPRB, 0.53345428E-09_JPRB, 0.53391780E-09_JPRB, &
  & 0.53432492E-09_JPRB, 0.53465893E-09_JPRB, 0.53491084E-09_JPRB, 0.53508337E-09_JPRB, 0.53518090E-09_JPRB, 0.53521160E-09_JPRB, &
  & 0.53517979E-09_JPRB, 0.53509042E-09_JPRB, 0.53494942E-09_JPRB, 0.53476740E-09_JPRB, 0.53456189E-09_JPRB, 0.53434679E-09_JPRB, &
  & 0.53412952E-09_JPRB, 0.53390892E-09_JPRB, 0.53367977E-09_JPRB, 0.53344112E-09_JPRB, 0.53320642E-09_JPRB, 0.53300264E-09_JPRB, &
  & 0.53287513E-09_JPRB, 0.53284760E-09_JPRB, 0.53290355E-09_JPRB, 0.53299931E-09_JPRB, 0.53308336E-09_JPRB, 0.53313659E-09_JPRB, &
  & 0.53315480E-09_JPRB, 0.53314131E-09_JPRB, 0.53310578E-09_JPRB, 0.53305904E-09_JPRB, 0.53301430E-09_JPRB, 0.53296995E-09_JPRB, &
  & 0.53292903E-09_JPRB, 0.53288368E-09_JPRB, 0.53282923E-09_JPRB, 0.53276472E-09_JPRB, 0.53268834E-09_JPRB, 0.53260801E-09_JPRB, &
  & 0.53252414E-09_JPRB, 0.53243060E-09_JPRB, 0.53231269E-09_JPRB, 0.53206284E-09_JPRB /)

RGHG6(:,56, 2) = (/ &
  & 0.52952159E-09_JPRB, 0.53043925E-09_JPRB, 0.53087112E-09_JPRB, 0.53125065E-09_JPRB, 0.53155297E-09_JPRB, 0.53173321E-09_JPRB, &
  & 0.53179494E-09_JPRB, 0.53180865E-09_JPRB, 0.53180632E-09_JPRB, 0.53179805E-09_JPRB, 0.53178673E-09_JPRB, 0.53177057E-09_JPRB, &
  & 0.53174998E-09_JPRB, 0.53171478E-09_JPRB, 0.53167315E-09_JPRB, 0.53160110E-09_JPRB, 0.53156285E-09_JPRB, 0.53163196E-09_JPRB, &
  & 0.53185689E-09_JPRB, 0.53220556E-09_JPRB, 0.53263410E-09_JPRB, 0.53310845E-09_JPRB, 0.53358645E-09_JPRB, 0.53403959E-09_JPRB, &
  & 0.53443705E-09_JPRB, 0.53476246E-09_JPRB, 0.53500626E-09_JPRB, 0.53516808E-09_JPRB, 0.53525651E-09_JPRB, 0.53527777E-09_JPRB, &
  & 0.53523763E-09_JPRB, 0.53514132E-09_JPRB, 0.53499571E-09_JPRB, 0.53481258E-09_JPRB, 0.53460841E-09_JPRB, 0.53439658E-09_JPRB, &
  & 0.53418481E-09_JPRB, 0.53397081E-09_JPRB, 0.53375193E-09_JPRB, 0.53352944E-09_JPRB, 0.53331645E-09_JPRB, 0.53314564E-09_JPRB, &
  & 0.53305338E-09_JPRB, 0.53306093E-09_JPRB, 0.53314586E-09_JPRB, 0.53325311E-09_JPRB, 0.53334626E-09_JPRB, 0.53340354E-09_JPRB, &
  & 0.53342825E-09_JPRB, 0.53342630E-09_JPRB, 0.53340732E-09_JPRB, 0.53338090E-09_JPRB, 0.53335270E-09_JPRB, 0.53332755E-09_JPRB, &
  & 0.53330151E-09_JPRB, 0.53327359E-09_JPRB, 0.53324045E-09_JPRB, 0.53319810E-09_JPRB, 0.53315063E-09_JPRB, 0.53309979E-09_JPRB, &
  & 0.53304772E-09_JPRB, 0.53299520E-09_JPRB, 0.53293642E-09_JPRB, 0.53284582E-09_JPRB /)

RGHG6(:,57, 2) = (/ &
  & 0.53074034E-09_JPRB, 0.53136895E-09_JPRB, 0.53167604E-09_JPRB, 0.53188903E-09_JPRB, 0.53204113E-09_JPRB, 0.53212001E-09_JPRB, &
  & 0.53213883E-09_JPRB, 0.53213578E-09_JPRB, 0.53212773E-09_JPRB, 0.53211863E-09_JPRB, 0.53210780E-09_JPRB, 0.53209503E-09_JPRB, &
  & 0.53207611E-09_JPRB, 0.53205140E-09_JPRB, 0.53200461E-09_JPRB, 0.53194993E-09_JPRB, 0.53188270E-09_JPRB, 0.53190796E-09_JPRB, &
  & 0.53208982E-09_JPRB, 0.53240362E-09_JPRB, 0.53280663E-09_JPRB, 0.53325655E-09_JPRB, 0.53372068E-09_JPRB, 0.53415705E-09_JPRB, &
  & 0.53454541E-09_JPRB, 0.53486093E-09_JPRB, 0.53509486E-09_JPRB, 0.53524812E-09_JPRB, 0.53532667E-09_JPRB, 0.53533972E-09_JPRB, &
  & 0.53529220E-09_JPRB, 0.53519006E-09_JPRB, 0.53504112E-09_JPRB, 0.53485727E-09_JPRB, 0.53465482E-09_JPRB, 0.53444726E-09_JPRB, &
  & 0.53424021E-09_JPRB, 0.53403432E-09_JPRB, 0.53382604E-09_JPRB, 0.53361932E-09_JPRB, 0.53343002E-09_JPRB, 0.53328597E-09_JPRB, &
  & 0.53322396E-09_JPRB, 0.53325727E-09_JPRB, 0.53335608E-09_JPRB, 0.53347587E-09_JPRB, 0.53356802E-09_JPRB, 0.53362553E-09_JPRB, &
  & 0.53365068E-09_JPRB, 0.53365284E-09_JPRB, 0.53364130E-09_JPRB, 0.53362331E-09_JPRB, 0.53360527E-09_JPRB, 0.53358712E-09_JPRB, &
  & 0.53356985E-09_JPRB, 0.53355054E-09_JPRB, 0.53352672E-09_JPRB, 0.53349813E-09_JPRB, 0.53346377E-09_JPRB, 0.53342741E-09_JPRB, &
  & 0.53339033E-09_JPRB, 0.53335047E-09_JPRB, 0.53330512E-09_JPRB, 0.53322236E-09_JPRB /)

RGHG6(:,58, 2) = (/ &
  & 0.53159493E-09_JPRB, 0.53203431E-09_JPRB, 0.53221533E-09_JPRB, 0.53232535E-09_JPRB, 0.53240135E-09_JPRB, 0.53242666E-09_JPRB, &
  & 0.53242444E-09_JPRB, 0.53241467E-09_JPRB, 0.53240579E-09_JPRB, 0.53239702E-09_JPRB, 0.53238836E-09_JPRB, 0.53237731E-09_JPRB, &
  & 0.53236338E-09_JPRB, 0.53233951E-09_JPRB, 0.53230664E-09_JPRB, 0.53224297E-09_JPRB, 0.53217886E-09_JPRB, 0.53217497E-09_JPRB, &
  & 0.53232019E-09_JPRB, 0.53260324E-09_JPRB, 0.53297861E-09_JPRB, 0.53340893E-09_JPRB, 0.53385157E-09_JPRB, 0.53427662E-09_JPRB, &
  & 0.53465044E-09_JPRB, 0.53495508E-09_JPRB, 0.53517929E-09_JPRB, 0.53532218E-09_JPRB, 0.53539267E-09_JPRB, 0.53539828E-09_JPRB, &
  & 0.53534488E-09_JPRB, 0.53523863E-09_JPRB, 0.53508692E-09_JPRB, 0.53490340E-09_JPRB, 0.53470334E-09_JPRB, 0.53449944E-09_JPRB, &
  & 0.53429916E-09_JPRB, 0.53410043E-09_JPRB, 0.53390375E-09_JPRB, 0.53371341E-09_JPRB, 0.53354499E-09_JPRB, 0.53342653E-09_JPRB, &
  & 0.53338761E-09_JPRB, 0.53343746E-09_JPRB, 0.53354954E-09_JPRB, 0.53366989E-09_JPRB, 0.53376414E-09_JPRB, 0.53381838E-09_JPRB, &
  & 0.53384142E-09_JPRB, 0.53384386E-09_JPRB, 0.53383475E-09_JPRB, 0.53382121E-09_JPRB, 0.53380644E-09_JPRB, 0.53379301E-09_JPRB, &
  & 0.53377913E-09_JPRB, 0.53376392E-09_JPRB, 0.53374577E-09_JPRB, 0.53372240E-09_JPRB, 0.53369598E-09_JPRB, 0.53366744E-09_JPRB, &
  & 0.53363769E-09_JPRB, 0.53360744E-09_JPRB, 0.53357124E-09_JPRB, 0.53351096E-09_JPRB /)

RGHG6(:,59, 2) = (/ &
  & 0.53222710E-09_JPRB, 0.53250904E-09_JPRB, 0.53260457E-09_JPRB, 0.53266136E-09_JPRB, 0.53268734E-09_JPRB, 0.53268834E-09_JPRB, &
  & 0.53267690E-09_JPRB, 0.53266574E-09_JPRB, 0.53265670E-09_JPRB, 0.53264959E-09_JPRB, 0.53264226E-09_JPRB, 0.53263405E-09_JPRB, &
  & 0.53262172E-09_JPRB, 0.53260407E-09_JPRB, 0.53256982E-09_JPRB, 0.53251958E-09_JPRB, 0.53244614E-09_JPRB, 0.53243004E-09_JPRB, &
  & 0.53254973E-09_JPRB, 0.53280430E-09_JPRB, 0.53315485E-09_JPRB, 0.53356131E-09_JPRB, 0.53398741E-09_JPRB, 0.53439386E-09_JPRB, &
  & 0.53475452E-09_JPRB, 0.53504595E-09_JPRB, 0.53525817E-09_JPRB, 0.53539234E-09_JPRB, 0.53545463E-09_JPRB, 0.53545413E-09_JPRB, &
  & 0.53539645E-09_JPRB, 0.53528759E-09_JPRB, 0.53513505E-09_JPRB, 0.53495203E-09_JPRB, 0.53475463E-09_JPRB, 0.53455607E-09_JPRB, &
  & 0.53436122E-09_JPRB, 0.53417126E-09_JPRB, 0.53398569E-09_JPRB, 0.53381072E-09_JPRB, 0.53366250E-09_JPRB, 0.53356547E-09_JPRB, &
  & 0.53354537E-09_JPRB, 0.53360827E-09_JPRB, 0.53372384E-09_JPRB, 0.53384924E-09_JPRB, 0.53393989E-09_JPRB, 0.53399185E-09_JPRB, &
  & 0.53401161E-09_JPRB, 0.53401272E-09_JPRB, 0.53400384E-09_JPRB, 0.53399096E-09_JPRB, 0.53397814E-09_JPRB, 0.53396554E-09_JPRB, &
  & 0.53395349E-09_JPRB, 0.53394017E-09_JPRB, 0.53392385E-09_JPRB, 0.53390448E-09_JPRB, 0.53388149E-09_JPRB, 0.53385724E-09_JPRB, &
  & 0.53383270E-09_JPRB, 0.53380622E-09_JPRB, 0.53377652E-09_JPRB, 0.53372129E-09_JPRB /)

RGHG6(:,60, 2) = (/ &
  & 0.53281024E-09_JPRB, 0.53288207E-09_JPRB, 0.53291571E-09_JPRB, 0.53293170E-09_JPRB, 0.53293531E-09_JPRB, 0.53292448E-09_JPRB, &
  & 0.53290944E-09_JPRB, 0.53289767E-09_JPRB, 0.53288995E-09_JPRB, 0.53288401E-09_JPRB, 0.53287891E-09_JPRB, 0.53287258E-09_JPRB, &
  & 0.53286375E-09_JPRB, 0.53284743E-09_JPRB, 0.53282023E-09_JPRB, 0.53276661E-09_JPRB, 0.53269911E-09_JPRB, 0.53267668E-09_JPRB, &
  & 0.53277788E-09_JPRB, 0.53300858E-09_JPRB, 0.53333393E-09_JPRB, 0.53371868E-09_JPRB, 0.53412358E-09_JPRB, 0.53451321E-09_JPRB, &
  & 0.53485660E-09_JPRB, 0.53513299E-09_JPRB, 0.53533372E-09_JPRB, 0.53545762E-09_JPRB, 0.53551291E-09_JPRB, 0.53550775E-09_JPRB, &
  & 0.53544752E-09_JPRB, 0.53533783E-09_JPRB, 0.53518578E-09_JPRB, 0.53500465E-09_JPRB, 0.53481086E-09_JPRB, 0.53461696E-09_JPRB, &
  & 0.53442895E-09_JPRB, 0.53424704E-09_JPRB, 0.53407251E-09_JPRB, 0.53391219E-09_JPRB, 0.53378169E-09_JPRB, 0.53370369E-09_JPRB, &
  & 0.53369886E-09_JPRB, 0.53376981E-09_JPRB, 0.53388938E-09_JPRB, 0.53401178E-09_JPRB, 0.53410282E-09_JPRB, 0.53415100E-09_JPRB, &
  & 0.53416804E-09_JPRB, 0.53416688E-09_JPRB, 0.53415644E-09_JPRB, 0.53414340E-09_JPRB, 0.53412996E-09_JPRB, 0.53411792E-09_JPRB, &
  & 0.53410565E-09_JPRB, 0.53409238E-09_JPRB, 0.53407695E-09_JPRB, 0.53405813E-09_JPRB, 0.53403737E-09_JPRB, 0.53401550E-09_JPRB, &
  & 0.53399307E-09_JPRB, 0.53397076E-09_JPRB, 0.53394428E-09_JPRB, 0.53390098E-09_JPRB /)

RGHG6(:,61, 2) = (/ &
  & 0.53309201E-09_JPRB, 0.53314381E-09_JPRB, 0.53315929E-09_JPRB, 0.53316374E-09_JPRB, 0.53315874E-09_JPRB, 0.53314375E-09_JPRB, &
  & 0.53312810E-09_JPRB, 0.53311711E-09_JPRB, 0.53311039E-09_JPRB, 0.53310639E-09_JPRB, 0.53310323E-09_JPRB, 0.53309973E-09_JPRB, &
  & 0.53309324E-09_JPRB, 0.53308097E-09_JPRB, 0.53305349E-09_JPRB, 0.53300442E-09_JPRB, 0.53293786E-09_JPRB, 0.53291688E-09_JPRB, &
  & 0.53300570E-09_JPRB, 0.53321508E-09_JPRB, 0.53351706E-09_JPRB, 0.53387961E-09_JPRB, 0.53426280E-09_JPRB, 0.53463217E-09_JPRB, &
  & 0.53495691E-09_JPRB, 0.53521731E-09_JPRB, 0.53540450E-09_JPRB, 0.53551902E-09_JPRB, 0.53556781E-09_JPRB, 0.53555926E-09_JPRB, &
  & 0.53549826E-09_JPRB, 0.53538968E-09_JPRB, 0.53524007E-09_JPRB, 0.53506211E-09_JPRB, 0.53487242E-09_JPRB, 0.53468380E-09_JPRB, &
  & 0.53450216E-09_JPRB, 0.53432803E-09_JPRB, 0.53416394E-09_JPRB, 0.53401683E-09_JPRB, 0.53390253E-09_JPRB, 0.53384092E-09_JPRB, &
  & 0.53384863E-09_JPRB, 0.53392557E-09_JPRB, 0.53404470E-09_JPRB, 0.53416632E-09_JPRB, 0.53425403E-09_JPRB, 0.53430088E-09_JPRB, &
  & 0.53431504E-09_JPRB, 0.53431110E-09_JPRB, 0.53429849E-09_JPRB, 0.53428317E-09_JPRB, 0.53426885E-09_JPRB, 0.53425520E-09_JPRB, &
  & 0.53424221E-09_JPRB, 0.53422811E-09_JPRB, 0.53421179E-09_JPRB, 0.53419325E-09_JPRB, 0.53417260E-09_JPRB, 0.53415161E-09_JPRB, &
  & 0.53413085E-09_JPRB, 0.53410903E-09_JPRB, 0.53408544E-09_JPRB, 0.53404314E-09_JPRB /)

RGHG6(:,62, 2) = (/ &
  & 0.53333282E-09_JPRB, 0.53336613E-09_JPRB, 0.53337451E-09_JPRB, 0.53337385E-09_JPRB, 0.53336591E-09_JPRB, 0.53335181E-09_JPRB, &
  & 0.53333638E-09_JPRB, 0.53332583E-09_JPRB, 0.53332050E-09_JPRB, 0.53331839E-09_JPRB, 0.53331822E-09_JPRB, 0.53331828E-09_JPRB, &
  & 0.53331606E-09_JPRB, 0.53330634E-09_JPRB, 0.53328164E-09_JPRB, 0.53323151E-09_JPRB, 0.53317095E-09_JPRB, 0.53315330E-09_JPRB, &
  & 0.53323301E-09_JPRB, 0.53342386E-09_JPRB, 0.53370419E-09_JPRB, 0.53404370E-09_JPRB, 0.53440447E-09_JPRB, 0.53475119E-09_JPRB, &
  & 0.53505594E-09_JPRB, 0.53529831E-09_JPRB, 0.53547172E-09_JPRB, 0.53557636E-09_JPRB, 0.53561955E-09_JPRB, 0.53560889E-09_JPRB, &
  & 0.53554877E-09_JPRB, 0.53544336E-09_JPRB, 0.53529786E-09_JPRB, 0.53512489E-09_JPRB, 0.53493981E-09_JPRB, 0.53475702E-09_JPRB, &
  & 0.53458094E-09_JPRB, 0.53441451E-09_JPRB, 0.53425953E-09_JPRB, 0.53412480E-09_JPRB, 0.53402471E-09_JPRB, 0.53397742E-09_JPRB, &
  & 0.53399563E-09_JPRB, 0.53407689E-09_JPRB, 0.53419474E-09_JPRB, 0.53431193E-09_JPRB, 0.53439786E-09_JPRB, 0.53444249E-09_JPRB, &
  & 0.53445492E-09_JPRB, 0.53444837E-09_JPRB, 0.53443283E-09_JPRB, 0.53441540E-09_JPRB, 0.53439841E-09_JPRB, 0.53438326E-09_JPRB, &
  & 0.53436822E-09_JPRB, 0.53435240E-09_JPRB, 0.53433485E-09_JPRB, 0.53431487E-09_JPRB, 0.53429394E-09_JPRB, 0.53427279E-09_JPRB, &
  & 0.53425175E-09_JPRB, 0.53423121E-09_JPRB, 0.53420762E-09_JPRB, 0.53416926E-09_JPRB /)

RGHG6(:,63, 2) = (/ &
  & 0.53353777E-09_JPRB, 0.53356597E-09_JPRB, 0.53357185E-09_JPRB, 0.53357030E-09_JPRB, 0.53356319E-09_JPRB, 0.53355009E-09_JPRB, &
  & 0.53353616E-09_JPRB, 0.53352606E-09_JPRB, 0.53352189E-09_JPRB, 0.53352245E-09_JPRB, 0.53352645E-09_JPRB, 0.53353155E-09_JPRB, &
  & 0.53353455E-09_JPRB, 0.53352855E-09_JPRB, 0.53350352E-09_JPRB, 0.53345545E-09_JPRB, 0.53340132E-09_JPRB, 0.53338756E-09_JPRB, &
  & 0.53346050E-09_JPRB, 0.53363519E-09_JPRB, 0.53389465E-09_JPRB, 0.53421129E-09_JPRB, 0.53454718E-09_JPRB, 0.53487070E-09_JPRB, &
  & 0.53515259E-09_JPRB, 0.53537652E-09_JPRB, 0.53553528E-09_JPRB, 0.53563010E-09_JPRB, 0.53566807E-09_JPRB, 0.53565641E-09_JPRB, &
  & 0.53559879E-09_JPRB, 0.53549831E-09_JPRB, 0.53535926E-09_JPRB, 0.53519233E-09_JPRB, 0.53501392E-09_JPRB, 0.53483595E-09_JPRB, &
  & 0.53466637E-09_JPRB, 0.53450605E-09_JPRB, 0.53436028E-09_JPRB, 0.53423632E-09_JPRB, 0.53414884E-09_JPRB, 0.53411386E-09_JPRB, &
  & 0.53414057E-09_JPRB, 0.53422439E-09_JPRB, 0.53433963E-09_JPRB, 0.53445232E-09_JPRB, 0.53453453E-09_JPRB, 0.53457822E-09_JPRB, &
  & 0.53458937E-09_JPRB, 0.53458071E-09_JPRB, 0.53456273E-09_JPRB, 0.53454208E-09_JPRB, 0.53452276E-09_JPRB, 0.53450455E-09_JPRB, &
  & 0.53448707E-09_JPRB, 0.53446886E-09_JPRB, 0.53444871E-09_JPRB, 0.53442717E-09_JPRB, 0.53440474E-09_JPRB, 0.53438259E-09_JPRB, &
  & 0.53436111E-09_JPRB, 0.53433941E-09_JPRB, 0.53431592E-09_JPRB, 0.53427562E-09_JPRB /)

RGHG6(:,64, 2) = (/ &
  & 0.53372451E-09_JPRB, 0.53375115E-09_JPRB, 0.53375737E-09_JPRB, 0.53375682E-09_JPRB, 0.53375115E-09_JPRB, 0.53374077E-09_JPRB, &
  & 0.53372817E-09_JPRB, 0.53371929E-09_JPRB, 0.53371646E-09_JPRB, 0.53372001E-09_JPRB, 0.53372884E-09_JPRB, 0.53374083E-09_JPRB, &
  & 0.53374888E-09_JPRB, 0.53374494E-09_JPRB, 0.53372090E-09_JPRB, 0.53367583E-09_JPRB, 0.53362853E-09_JPRB, 0.53361854E-09_JPRB, &
  & 0.53368621E-09_JPRB, 0.53384691E-09_JPRB, 0.53408672E-09_JPRB, 0.53437899E-09_JPRB, 0.53469001E-09_JPRB, 0.53498711E-09_JPRB, &
  & 0.53524624E-09_JPRB, 0.53545030E-09_JPRB, 0.53559446E-09_JPRB, 0.53567961E-09_JPRB, 0.53571292E-09_JPRB, 0.53570082E-09_JPRB, &
  & 0.53564680E-09_JPRB, 0.53555266E-09_JPRB, 0.53542143E-09_JPRB, 0.53526328E-09_JPRB, 0.53509142E-09_JPRB, 0.53492089E-09_JPRB, &
  & 0.53475624E-09_JPRB, 0.53460308E-09_JPRB, 0.53446492E-09_JPRB, 0.53435123E-09_JPRB, 0.53427468E-09_JPRB, 0.53425009E-09_JPRB, &
  & 0.53428334E-09_JPRB, 0.53436827E-09_JPRB, 0.53447979E-09_JPRB, 0.53458676E-09_JPRB, 0.53466537E-09_JPRB, 0.53470728E-09_JPRB, &
  & 0.53471805E-09_JPRB, 0.53470817E-09_JPRB, 0.53468796E-09_JPRB, 0.53466487E-09_JPRB, 0.53464222E-09_JPRB, 0.53462118E-09_JPRB, &
  & 0.53460047E-09_JPRB, 0.53457894E-09_JPRB, 0.53455618E-09_JPRB, 0.53453186E-09_JPRB, 0.53450755E-09_JPRB, 0.53448379E-09_JPRB, &
  & 0.53446048E-09_JPRB, 0.53443772E-09_JPRB, 0.53441174E-09_JPRB, 0.53436872E-09_JPRB /)

RGHG6(:,65, 2) = (/ &
  & 0.53389537E-09_JPRB, 0.53392502E-09_JPRB, 0.53393312E-09_JPRB, 0.53393462E-09_JPRB, 0.53393134E-09_JPRB, 0.53392346E-09_JPRB, &
  & 0.53391364E-09_JPRB, 0.53390609E-09_JPRB, 0.53390548E-09_JPRB, 0.53391297E-09_JPRB, 0.53392746E-09_JPRB, 0.53394489E-09_JPRB, &
  & 0.53395699E-09_JPRB, 0.53395471E-09_JPRB, 0.53393251E-09_JPRB, 0.53389182E-09_JPRB, 0.53385096E-09_JPRB, 0.53384486E-09_JPRB, &
  & 0.53390903E-09_JPRB, 0.53405685E-09_JPRB, 0.53427701E-09_JPRB, 0.53454524E-09_JPRB, 0.53482885E-09_JPRB, 0.53509974E-09_JPRB, &
  & 0.53533422E-09_JPRB, 0.53551874E-09_JPRB, 0.53564803E-09_JPRB, 0.53572380E-09_JPRB, 0.53575289E-09_JPRB, 0.53574101E-09_JPRB, &
  & 0.53569110E-09_JPRB, 0.53560412E-09_JPRB, 0.53548238E-09_JPRB, 0.53533411E-09_JPRB, 0.53517146E-09_JPRB, 0.53500765E-09_JPRB, &
  & 0.53485039E-09_JPRB, 0.53470361E-09_JPRB, 0.53457361E-09_JPRB, 0.53446908E-09_JPRB, 0.53440236E-09_JPRB, 0.53438598E-09_JPRB, &
  & 0.53442378E-09_JPRB, 0.53450810E-09_JPRB, 0.53461496E-09_JPRB, 0.53471577E-09_JPRB, 0.53478977E-09_JPRB, 0.53483018E-09_JPRB, &
  & 0.53484051E-09_JPRB, 0.53483024E-09_JPRB, 0.53480870E-09_JPRB, 0.53478327E-09_JPRB, 0.53475818E-09_JPRB, 0.53473376E-09_JPRB, &
  & 0.53470978E-09_JPRB, 0.53468507E-09_JPRB, 0.53465871E-09_JPRB, 0.53463206E-09_JPRB, 0.53460547E-09_JPRB, 0.53457944E-09_JPRB, &
  & 0.53455401E-09_JPRB, 0.53452787E-09_JPRB, 0.53449850E-09_JPRB, 0.53444765E-09_JPRB /)

RGHG6(:,66, 2) = (/ &
  & 0.53405436E-09_JPRB, 0.53408916E-09_JPRB, 0.53410071E-09_JPRB, 0.53410498E-09_JPRB, 0.53410443E-09_JPRB, 0.53409954E-09_JPRB, &
  & 0.53409233E-09_JPRB, 0.53408777E-09_JPRB, 0.53409049E-09_JPRB, 0.53410193E-09_JPRB, 0.53412214E-09_JPRB, 0.53414345E-09_JPRB, &
  & 0.53415783E-09_JPRB, 0.53415727E-09_JPRB, 0.53413779E-09_JPRB, 0.53410198E-09_JPRB, 0.53406757E-09_JPRB, 0.53406535E-09_JPRB, &
  & 0.53412630E-09_JPRB, 0.53426219E-09_JPRB, 0.53446297E-09_JPRB, 0.53470584E-09_JPRB, 0.53496235E-09_JPRB, 0.53520571E-09_JPRB, &
  & 0.53541616E-09_JPRB, 0.53558097E-09_JPRB, 0.53569577E-09_JPRB, 0.53576266E-09_JPRB, 0.53578780E-09_JPRB, 0.53577642E-09_JPRB, &
  & 0.53573085E-09_JPRB, 0.53565136E-09_JPRB, 0.53553972E-09_JPRB, 0.53540261E-09_JPRB, 0.53525012E-09_JPRB, 0.53509575E-09_JPRB, &
  & 0.53494587E-09_JPRB, 0.53480703E-09_JPRB, 0.53468496E-09_JPRB, 0.53458932E-09_JPRB, 0.53453109E-09_JPRB, 0.53452154E-09_JPRB, &
  & 0.53456201E-09_JPRB, 0.53464400E-09_JPRB, 0.53474503E-09_JPRB, 0.53483939E-09_JPRB, 0.53490856E-09_JPRB, 0.53494648E-09_JPRB, &
  & 0.53495658E-09_JPRB, 0.53494648E-09_JPRB, 0.53492460E-09_JPRB, 0.53489779E-09_JPRB, 0.53487059E-09_JPRB, 0.53484384E-09_JPRB, &
  & 0.53481675E-09_JPRB, 0.53478849E-09_JPRB, 0.53475963E-09_JPRB, 0.53472987E-09_JPRB, 0.53470106E-09_JPRB, 0.53467281E-09_JPRB, &
  & 0.53464411E-09_JPRB, 0.53461463E-09_JPRB, 0.53457905E-09_JPRB, 0.53451749E-09_JPRB /)

RGHG6(:,67, 2) = (/ &
  & 0.53420601E-09_JPRB, 0.53424687E-09_JPRB, 0.53426163E-09_JPRB, 0.53426913E-09_JPRB, 0.53427163E-09_JPRB, 0.53426991E-09_JPRB, &
  & 0.53426596E-09_JPRB, 0.53426485E-09_JPRB, 0.53427124E-09_JPRB, 0.53428773E-09_JPRB, 0.53431104E-09_JPRB, 0.53433535E-09_JPRB, &
  & 0.53435123E-09_JPRB, 0.53435256E-09_JPRB, 0.53433608E-09_JPRB, 0.53430516E-09_JPRB, 0.53427684E-09_JPRB, 0.53427801E-09_JPRB, &
  & 0.53433563E-09_JPRB, 0.53445931E-09_JPRB, 0.53464050E-09_JPRB, 0.53485849E-09_JPRB, 0.53508747E-09_JPRB, 0.53530430E-09_JPRB, &
  & 0.53549098E-09_JPRB, 0.53563709E-09_JPRB, 0.53573801E-09_JPRB, 0.53579680E-09_JPRB, 0.53581811E-09_JPRB, 0.53580729E-09_JPRB, &
  & 0.53576588E-09_JPRB, 0.53569388E-09_JPRB, 0.53559274E-09_JPRB, 0.53546712E-09_JPRB, 0.53532639E-09_JPRB, 0.53518201E-09_JPRB, &
  & 0.53504146E-09_JPRB, 0.53491123E-09_JPRB, 0.53479809E-09_JPRB, 0.53471100E-09_JPRB, 0.53466065E-09_JPRB, 0.53465621E-09_JPRB, &
  & 0.53469768E-09_JPRB, 0.53477589E-09_JPRB, 0.53487048E-09_JPRB, 0.53495763E-09_JPRB, 0.53502192E-09_JPRB, 0.53505722E-09_JPRB, &
  & 0.53506655E-09_JPRB, 0.53505672E-09_JPRB, 0.53503485E-09_JPRB, 0.53500798E-09_JPRB, 0.53497984E-09_JPRB, 0.53495108E-09_JPRB, &
  & 0.53492188E-09_JPRB, 0.53489163E-09_JPRB, 0.53485977E-09_JPRB, 0.53482824E-09_JPRB, 0.53479710E-09_JPRB, 0.53476645E-09_JPRB, &
  & 0.53473526E-09_JPRB, 0.53470034E-09_JPRB, 0.53465782E-09_JPRB, 0.53457855E-09_JPRB /)

RGHG6(:,68, 2) = (/ &
  & 0.53434479E-09_JPRB, 0.53439508E-09_JPRB, 0.53441551E-09_JPRB, 0.53442717E-09_JPRB, 0.53443350E-09_JPRB, 0.53443527E-09_JPRB, &
  & 0.53443505E-09_JPRB, 0.53443783E-09_JPRB, 0.53444854E-09_JPRB, 0.53446852E-09_JPRB, 0.53449473E-09_JPRB, 0.53452021E-09_JPRB, &
  & 0.53453697E-09_JPRB, 0.53453991E-09_JPRB, 0.53452631E-09_JPRB, 0.53450000E-09_JPRB, 0.53447702E-09_JPRB, 0.53448052E-09_JPRB, &
  & 0.53453370E-09_JPRB, 0.53464516E-09_JPRB, 0.53480692E-09_JPRB, 0.53500049E-09_JPRB, 0.53520344E-09_JPRB, 0.53539478E-09_JPRB, &
  & 0.53555943E-09_JPRB, 0.53568733E-09_JPRB, 0.53577570E-09_JPRB, 0.53582649E-09_JPRB, 0.53584448E-09_JPRB, 0.53583432E-09_JPRB, &
  & 0.53579685E-09_JPRB, 0.53573224E-09_JPRB, 0.53564131E-09_JPRB, 0.53552734E-09_JPRB, 0.53539861E-09_JPRB, 0.53526572E-09_JPRB, &
  & 0.53513516E-09_JPRB, 0.53501475E-09_JPRB, 0.53491089E-09_JPRB, 0.53483251E-09_JPRB, 0.53478943E-09_JPRB, 0.53478905E-09_JPRB, &
  & 0.53483029E-09_JPRB, 0.53490390E-09_JPRB, 0.53499066E-09_JPRB, 0.53507121E-09_JPRB, 0.53512966E-09_JPRB, 0.53516225E-09_JPRB, &
  & 0.53517085E-09_JPRB, 0.53516125E-09_JPRB, 0.53514015E-09_JPRB, 0.53511351E-09_JPRB, 0.53508542E-09_JPRB, 0.53505606E-09_JPRB, &
  & 0.53502591E-09_JPRB, 0.53499405E-09_JPRB, 0.53496141E-09_JPRB, 0.53492788E-09_JPRB, 0.53489591E-09_JPRB, 0.53486371E-09_JPRB, &
  & 0.53482963E-09_JPRB, 0.53479110E-09_JPRB, 0.53473814E-09_JPRB, 0.53463939E-09_JPRB /)

RGHG6(:,69, 2) = (/ &
  & 0.53447680E-09_JPRB, 0.53453902E-09_JPRB, 0.53456484E-09_JPRB, 0.53458121E-09_JPRB, 0.53459148E-09_JPRB, 0.53459726E-09_JPRB, &
  & 0.53460092E-09_JPRB, 0.53460791E-09_JPRB, 0.53462240E-09_JPRB, 0.53464505E-09_JPRB, 0.53467231E-09_JPRB, 0.53469817E-09_JPRB, &
  & 0.53471516E-09_JPRB, 0.53471932E-09_JPRB, 0.53470806E-09_JPRB, 0.53468585E-09_JPRB, 0.53466670E-09_JPRB, 0.53467142E-09_JPRB, &
  & 0.53471916E-09_JPRB, 0.53481808E-09_JPRB, 0.53496113E-09_JPRB, 0.53513183E-09_JPRB, 0.53530980E-09_JPRB, 0.53547777E-09_JPRB, &
  & 0.53562133E-09_JPRB, 0.53573279E-09_JPRB, 0.53580901E-09_JPRB, 0.53585281E-09_JPRB, 0.53586791E-09_JPRB, 0.53585808E-09_JPRB, &
  & 0.53582472E-09_JPRB, 0.53576699E-09_JPRB, 0.53568611E-09_JPRB, 0.53558391E-09_JPRB, 0.53546745E-09_JPRB, 0.53534616E-09_JPRB, &
  & 0.53522675E-09_JPRB, 0.53511662E-09_JPRB, 0.53502269E-09_JPRB, 0.53495308E-09_JPRB, 0.53491672E-09_JPRB, 0.53491939E-09_JPRB, &
  & 0.53495969E-09_JPRB, 0.53502758E-09_JPRB, 0.53510696E-09_JPRB, 0.53517946E-09_JPRB, 0.53523308E-09_JPRB, 0.53526245E-09_JPRB, &
  & 0.53527027E-09_JPRB, 0.53526100E-09_JPRB, 0.53524074E-09_JPRB, 0.53521526E-09_JPRB, 0.53518795E-09_JPRB, 0.53515903E-09_JPRB, &
  & 0.53512889E-09_JPRB, 0.53509708E-09_JPRB, 0.53506410E-09_JPRB, 0.53503074E-09_JPRB, 0.53499793E-09_JPRB, 0.53496541E-09_JPRB, &
  & 0.53493043E-09_JPRB, 0.53488808E-09_JPRB, 0.53482690E-09_JPRB, 0.53470522E-09_JPRB /)

RGHG6(:,70, 2) = (/ &
  & 0.53460369E-09_JPRB, 0.53467875E-09_JPRB, 0.53471211E-09_JPRB, 0.53473326E-09_JPRB, 0.53474786E-09_JPRB, 0.53475718E-09_JPRB, &
  & 0.53476484E-09_JPRB, 0.53477556E-09_JPRB, 0.53479277E-09_JPRB, 0.53481714E-09_JPRB, 0.53484400E-09_JPRB, 0.53486909E-09_JPRB, &
  & 0.53488536E-09_JPRB, 0.53488991E-09_JPRB, 0.53488081E-09_JPRB, 0.53486154E-09_JPRB, 0.53484517E-09_JPRB, 0.53484983E-09_JPRB, &
  & 0.53489158E-09_JPRB, 0.53497839E-09_JPRB, 0.53510346E-09_JPRB, 0.53525218E-09_JPRB, 0.53540727E-09_JPRB, 0.53555288E-09_JPRB, &
  & 0.53567750E-09_JPRB, 0.53577343E-09_JPRB, 0.53583893E-09_JPRB, 0.53587618E-09_JPRB, 0.53588856E-09_JPRB, 0.53587940E-09_JPRB, &
  & 0.53584959E-09_JPRB, 0.53579874E-09_JPRB, 0.53572768E-09_JPRB, 0.53563709E-09_JPRB, 0.53553273E-09_JPRB, 0.53542393E-09_JPRB, &
  & 0.53531551E-09_JPRB, 0.53521643E-09_JPRB, 0.53513249E-09_JPRB, 0.53507154E-09_JPRB, 0.53504134E-09_JPRB, 0.53504656E-09_JPRB, &
  & 0.53508520E-09_JPRB, 0.53514720E-09_JPRB, 0.53521854E-09_JPRB, 0.53528398E-09_JPRB, 0.53533161E-09_JPRB, 0.53535809E-09_JPRB, &
  & 0.53536497E-09_JPRB, 0.53535637E-09_JPRB, 0.53533755E-09_JPRB, 0.53531357E-09_JPRB, 0.53528798E-09_JPRB, 0.53526039E-09_JPRB, &
  & 0.53523164E-09_JPRB, 0.53520072E-09_JPRB, 0.53516885E-09_JPRB, 0.53513610E-09_JPRB, 0.53510424E-09_JPRB, 0.53507221E-09_JPRB, &
  & 0.53503746E-09_JPRB, 0.53499394E-09_JPRB, 0.53492677E-09_JPRB, 0.53478788E-09_JPRB /)

RGHG6(:,71, 2) = (/ &
  & 0.53472859E-09_JPRB, 0.53481947E-09_JPRB, 0.53485893E-09_JPRB, 0.53488508E-09_JPRB, 0.53490307E-09_JPRB, 0.53491594E-09_JPRB, &
  & 0.53492688E-09_JPRB, 0.53494059E-09_JPRB, 0.53495980E-09_JPRB, 0.53498345E-09_JPRB, 0.53500920E-09_JPRB, 0.53503196E-09_JPRB, &
  & 0.53504706E-09_JPRB, 0.53505150E-09_JPRB, 0.53504357E-09_JPRB, 0.53502663E-09_JPRB, 0.53501192E-09_JPRB, 0.53501614E-09_JPRB, &
  & 0.53505178E-09_JPRB, 0.53512661E-09_JPRB, 0.53523458E-09_JPRB, 0.53536287E-09_JPRB, 0.53549598E-09_JPRB, 0.53562121E-09_JPRB, &
  & 0.53572791E-09_JPRB, 0.53581001E-09_JPRB, 0.53586541E-09_JPRB, 0.53589677E-09_JPRB, 0.53590676E-09_JPRB, 0.53589827E-09_JPRB, &
  & 0.53587229E-09_JPRB, 0.53582794E-09_JPRB, 0.53576654E-09_JPRB, 0.53568672E-09_JPRB, 0.53559507E-09_JPRB, 0.53549820E-09_JPRB, &
  & 0.53540172E-09_JPRB, 0.53531368E-09_JPRB, 0.53523952E-09_JPRB, 0.53518706E-09_JPRB, 0.53516264E-09_JPRB, 0.53516980E-09_JPRB, &
  & 0.53520627E-09_JPRB, 0.53526222E-09_JPRB, 0.53532551E-09_JPRB, 0.53538318E-09_JPRB, 0.53542570E-09_JPRB, 0.53544857E-09_JPRB, &
  & 0.53545485E-09_JPRB, 0.53544719E-09_JPRB, 0.53543003E-09_JPRB, 0.53540850E-09_JPRB, 0.53538507E-09_JPRB, 0.53536009E-09_JPRB, &
  & 0.53533333E-09_JPRB, 0.53530469E-09_JPRB, 0.53527499E-09_JPRB, 0.53524396E-09_JPRB, 0.53521360E-09_JPRB, 0.53518323E-09_JPRB, &
  & 0.53514959E-09_JPRB, 0.53510707E-09_JPRB, 0.53503774E-09_JPRB, 0.53488997E-09_JPRB /)

RGHG6(:,72, 2) = (/ &
  & 0.53485616E-09_JPRB, 0.53496163E-09_JPRB, 0.53500759E-09_JPRB, 0.53503713E-09_JPRB, 0.53505744E-09_JPRB, 0.53507276E-09_JPRB, &
  & 0.53508631E-09_JPRB, 0.53510202E-09_JPRB, 0.53512100E-09_JPRB, 0.53514404E-09_JPRB, 0.53516608E-09_JPRB, 0.53518673E-09_JPRB, &
  & 0.53519938E-09_JPRB, 0.53520316E-09_JPRB, 0.53519578E-09_JPRB, 0.53518046E-09_JPRB, 0.53516719E-09_JPRB, 0.53517019E-09_JPRB, &
  & 0.53520016E-09_JPRB, 0.53526356E-09_JPRB, 0.53535532E-09_JPRB, 0.53546390E-09_JPRB, 0.53557697E-09_JPRB, 0.53568294E-09_JPRB, &
  & 0.53577320E-09_JPRB, 0.53584254E-09_JPRB, 0.53588872E-09_JPRB, 0.53591481E-09_JPRB, 0.53592297E-09_JPRB, 0.53591531E-09_JPRB, &
  & 0.53589277E-09_JPRB, 0.53585492E-09_JPRB, 0.53580240E-09_JPRB, 0.53573390E-09_JPRB, 0.53565397E-09_JPRB, 0.53556992E-09_JPRB, &
  & 0.53548482E-09_JPRB, 0.53540805E-09_JPRB, 0.53534366E-09_JPRB, 0.53529930E-09_JPRB, 0.53528010E-09_JPRB, 0.53528854E-09_JPRB, &
  & 0.53532245E-09_JPRB, 0.53537164E-09_JPRB, 0.53542681E-09_JPRB, 0.53547738E-09_JPRB, 0.53551408E-09_JPRB, 0.53553384E-09_JPRB, &
  & 0.53553950E-09_JPRB, 0.53553301E-09_JPRB, 0.53551796E-09_JPRB, 0.53549876E-09_JPRB, 0.53547899E-09_JPRB, 0.53545618E-09_JPRB, &
  & 0.53543286E-09_JPRB, 0.53540694E-09_JPRB, 0.53538013E-09_JPRB, 0.53535182E-09_JPRB, 0.53532373E-09_JPRB, 0.53529559E-09_JPRB, &
  & 0.53526444E-09_JPRB, 0.53522387E-09_JPRB, 0.53515525E-09_JPRB, 0.53500271E-09_JPRB /)

RGHG6(:,73, 2) = (/ &
  & 0.53500054E-09_JPRB, 0.53511073E-09_JPRB, 0.53515786E-09_JPRB, 0.53518795E-09_JPRB, 0.53520888E-09_JPRB, 0.53522531E-09_JPRB, &
  & 0.53524013E-09_JPRB, 0.53525623E-09_JPRB, 0.53527482E-09_JPRB, 0.53529431E-09_JPRB, 0.53531440E-09_JPRB, 0.53533078E-09_JPRB, &
  & 0.53534160E-09_JPRB, 0.53534421E-09_JPRB, 0.53533700E-09_JPRB, 0.53532268E-09_JPRB, 0.53531063E-09_JPRB, 0.53531224E-09_JPRB, &
  & 0.53533716E-09_JPRB, 0.53538973E-09_JPRB, 0.53546606E-09_JPRB, 0.53555649E-09_JPRB, 0.53565052E-09_JPRB, 0.53573884E-09_JPRB, &
  & 0.53581395E-09_JPRB, 0.53587146E-09_JPRB, 0.53590932E-09_JPRB, 0.53593086E-09_JPRB, 0.53593746E-09_JPRB, 0.53593047E-09_JPRB, &
  & 0.53591143E-09_JPRB, 0.53587956E-09_JPRB, 0.53583593E-09_JPRB, 0.53577770E-09_JPRB, 0.53570981E-09_JPRB, 0.53563765E-09_JPRB, &
  & 0.53556493E-09_JPRB, 0.53549898E-09_JPRB, 0.53544441E-09_JPRB, 0.53540772E-09_JPRB, 0.53539306E-09_JPRB, 0.53540206E-09_JPRB, &
  & 0.53543225E-09_JPRB, 0.53547472E-09_JPRB, 0.53552202E-09_JPRB, 0.53556481E-09_JPRB, 0.53559668E-09_JPRB, 0.53561316E-09_JPRB, &
  & 0.53561822E-09_JPRB, 0.53561300E-09_JPRB, 0.53560012E-09_JPRB, 0.53558413E-09_JPRB, 0.53556687E-09_JPRB, 0.53554816E-09_JPRB, &
  & 0.53552751E-09_JPRB, 0.53550508E-09_JPRB, 0.53548194E-09_JPRB, 0.53545629E-09_JPRB, 0.53543142E-09_JPRB, 0.53540611E-09_JPRB, &
  & 0.53537791E-09_JPRB, 0.53534088E-09_JPRB, 0.53527499E-09_JPRB, 0.53512378E-09_JPRB /)

RGHG6(:,74, 2) = (/ &
  & 0.53514670E-09_JPRB, 0.53525961E-09_JPRB, 0.53530491E-09_JPRB, 0.53533450E-09_JPRB, 0.53535426E-09_JPRB, 0.53537025E-09_JPRB, &
  & 0.53538518E-09_JPRB, 0.53540045E-09_JPRB, 0.53541654E-09_JPRB, 0.53543442E-09_JPRB, 0.53544991E-09_JPRB, 0.53546440E-09_JPRB, &
  & 0.53547233E-09_JPRB, 0.53547389E-09_JPRB, 0.53546678E-09_JPRB, 0.53545351E-09_JPRB, 0.53544236E-09_JPRB, 0.53544269E-09_JPRB, &
  & 0.53546312E-09_JPRB, 0.53550564E-09_JPRB, 0.53556731E-09_JPRB, 0.53564070E-09_JPRB, 0.53571730E-09_JPRB, 0.53578947E-09_JPRB, &
  & 0.53585036E-09_JPRB, 0.53589727E-09_JPRB, 0.53592730E-09_JPRB, 0.53594468E-09_JPRB, 0.53595023E-09_JPRB, 0.53594396E-09_JPRB, &
  & 0.53592830E-09_JPRB, 0.53590188E-09_JPRB, 0.53586685E-09_JPRB, 0.53581872E-09_JPRB, 0.53576232E-09_JPRB, 0.53570198E-09_JPRB, &
  & 0.53564114E-09_JPRB, 0.53558624E-09_JPRB, 0.53554100E-09_JPRB, 0.53551158E-09_JPRB, 0.53550081E-09_JPRB, 0.53550941E-09_JPRB, &
  & 0.53553595E-09_JPRB, 0.53557087E-09_JPRB, 0.53561000E-09_JPRB, 0.53564642E-09_JPRB, 0.53567273E-09_JPRB, 0.53568627E-09_JPRB, &
  & 0.53569094E-09_JPRB, 0.53568711E-09_JPRB, 0.53567645E-09_JPRB, 0.53566279E-09_JPRB, 0.53564941E-09_JPRB, 0.53563287E-09_JPRB, &
  & 0.53561611E-09_JPRB, 0.53559696E-09_JPRB, 0.53557753E-09_JPRB, 0.53555554E-09_JPRB, 0.53553384E-09_JPRB, 0.53551197E-09_JPRB, &
  & 0.53548760E-09_JPRB, 0.53545474E-09_JPRB, 0.53539378E-09_JPRB, 0.53524912E-09_JPRB /)

RGHG6(:,75, 2) = (/ &
  & 0.53529320E-09_JPRB, 0.53540367E-09_JPRB, 0.53544652E-09_JPRB, 0.53547317E-09_JPRB, 0.53549098E-09_JPRB, 0.53550531E-09_JPRB, &
  & 0.53551907E-09_JPRB, 0.53553240E-09_JPRB, 0.53554655E-09_JPRB, 0.53556060E-09_JPRB, 0.53557414E-09_JPRB, 0.53558497E-09_JPRB, &
  & 0.53559113E-09_JPRB, 0.53559168E-09_JPRB, 0.53558491E-09_JPRB, 0.53557281E-09_JPRB, 0.53556293E-09_JPRB, 0.53556237E-09_JPRB, &
  & 0.53557858E-09_JPRB, 0.53561167E-09_JPRB, 0.53566002E-09_JPRB, 0.53571769E-09_JPRB, 0.53577831E-09_JPRB, 0.53583538E-09_JPRB, &
  & 0.53588312E-09_JPRB, 0.53592025E-09_JPRB, 0.53594335E-09_JPRB, 0.53595678E-09_JPRB, 0.53596161E-09_JPRB, 0.53595611E-09_JPRB, &
  & 0.53594368E-09_JPRB, 0.53592236E-09_JPRB, 0.53589549E-09_JPRB, 0.53585653E-09_JPRB, 0.53581162E-09_JPRB, 0.53576216E-09_JPRB, &
  & 0.53571353E-09_JPRB, 0.53566929E-09_JPRB, 0.53563320E-09_JPRB, 0.53561044E-09_JPRB, 0.53560278E-09_JPRB, 0.53561050E-09_JPRB, &
  & 0.53563254E-09_JPRB, 0.53566018E-09_JPRB, 0.53569171E-09_JPRB, 0.53572069E-09_JPRB, 0.53574317E-09_JPRB, 0.53575328E-09_JPRB, &
  & 0.53575738E-09_JPRB, 0.53575511E-09_JPRB, 0.53574634E-09_JPRB, 0.53573540E-09_JPRB, 0.53572480E-09_JPRB, 0.53571136E-09_JPRB, &
  & 0.53569732E-09_JPRB, 0.53568167E-09_JPRB, 0.53566651E-09_JPRB, 0.53564814E-09_JPRB, 0.53563043E-09_JPRB, 0.53561217E-09_JPRB, &
  & 0.53559207E-09_JPRB, 0.53556409E-09_JPRB, 0.53550969E-09_JPRB, 0.53537580E-09_JPRB /)

RGHG6(:,76, 2) = (/ &
  & 0.53543681E-09_JPRB, 0.53554244E-09_JPRB, 0.53557930E-09_JPRB, 0.53560306E-09_JPRB, 0.53561766E-09_JPRB, 0.53562960E-09_JPRB, &
  & 0.53564125E-09_JPRB, 0.53565213E-09_JPRB, 0.53566296E-09_JPRB, 0.53567439E-09_JPRB, 0.53568405E-09_JPRB, 0.53569316E-09_JPRB, &
  & 0.53569715E-09_JPRB, 0.53569738E-09_JPRB, 0.53569160E-09_JPRB, 0.53568111E-09_JPRB, 0.53567295E-09_JPRB, 0.53567184E-09_JPRB, &
  & 0.53568416E-09_JPRB, 0.53570887E-09_JPRB, 0.53574462E-09_JPRB, 0.53578819E-09_JPRB, 0.53583371E-09_JPRB, 0.53587690E-09_JPRB, &
  & 0.53591231E-09_JPRB, 0.53594063E-09_JPRB, 0.53595728E-09_JPRB, 0.53596727E-09_JPRB, 0.53597182E-09_JPRB, 0.53596688E-09_JPRB, &
  & 0.53595739E-09_JPRB, 0.53594085E-09_JPRB, 0.53592175E-09_JPRB, 0.53589150E-09_JPRB, 0.53585741E-09_JPRB, 0.53581883E-09_JPRB, &
  & 0.53578170E-09_JPRB, 0.53574811E-09_JPRB, 0.53572058E-09_JPRB, 0.53570404E-09_JPRB, 0.53569882E-09_JPRB, 0.53570504E-09_JPRB, &
  & 0.53572258E-09_JPRB, 0.53574262E-09_JPRB, 0.53576632E-09_JPRB, 0.53578936E-09_JPRB, 0.53580718E-09_JPRB, 0.53581412E-09_JPRB, &
  & 0.53581789E-09_JPRB, 0.53581706E-09_JPRB, 0.53580990E-09_JPRB, 0.53580118E-09_JPRB, 0.53579402E-09_JPRB, 0.53578270E-09_JPRB, &
  & 0.53577187E-09_JPRB, 0.53575949E-09_JPRB, 0.53574883E-09_JPRB, 0.53573457E-09_JPRB, 0.53572063E-09_JPRB, 0.53570631E-09_JPRB, &
  & 0.53569071E-09_JPRB, 0.53566807E-09_JPRB, 0.53562083E-09_JPRB, 0.53550270E-09_JPRB /)

RGHG6(:,77, 2) = (/ &
  & 0.53557814E-09_JPRB, 0.53567240E-09_JPRB, 0.53570282E-09_JPRB, 0.53572224E-09_JPRB, 0.53573335E-09_JPRB, 0.53574190E-09_JPRB, &
  & 0.53575111E-09_JPRB, 0.53575866E-09_JPRB, 0.53576588E-09_JPRB, 0.53577354E-09_JPRB, 0.53578003E-09_JPRB, 0.53578664E-09_JPRB, &
  & 0.53578930E-09_JPRB, 0.53578997E-09_JPRB, 0.53578625E-09_JPRB, 0.53577831E-09_JPRB, 0.53577220E-09_JPRB, 0.53577104E-09_JPRB, &
  & 0.53577998E-09_JPRB, 0.53579685E-09_JPRB, 0.53582150E-09_JPRB, 0.53585175E-09_JPRB, 0.53588356E-09_JPRB, 0.53591381E-09_JPRB, &
  & 0.53593813E-09_JPRB, 0.53595861E-09_JPRB, 0.53596960E-09_JPRB, 0.53597654E-09_JPRB, 0.53598104E-09_JPRB, 0.53597643E-09_JPRB, &
  & 0.53596966E-09_JPRB, 0.53595717E-09_JPRB, 0.53594557E-09_JPRB, 0.53592325E-09_JPRB, 0.53589938E-09_JPRB, 0.53587090E-09_JPRB, &
  & 0.53584504E-09_JPRB, 0.53582133E-09_JPRB, 0.53580196E-09_JPRB, 0.53579136E-09_JPRB, 0.53578780E-09_JPRB, 0.53579186E-09_JPRB, &
  & 0.53580462E-09_JPRB, 0.53581750E-09_JPRB, 0.53583410E-09_JPRB, 0.53585053E-09_JPRB, 0.53586496E-09_JPRB, 0.53586841E-09_JPRB, &
  & 0.53587196E-09_JPRB, 0.53587262E-09_JPRB, 0.53586674E-09_JPRB, 0.53586025E-09_JPRB, 0.53585647E-09_JPRB, 0.53584709E-09_JPRB, &
  & 0.53583921E-09_JPRB, 0.53582999E-09_JPRB, 0.53582438E-09_JPRB, 0.53581373E-09_JPRB, 0.53580385E-09_JPRB, 0.53579313E-09_JPRB, &
  & 0.53578253E-09_JPRB, 0.53576482E-09_JPRB, 0.53572635E-09_JPRB, 0.53562776E-09_JPRB /)

RGHG6(:,78, 2) = (/ &
  & 0.53571458E-09_JPRB, 0.53578908E-09_JPRB, 0.53580823E-09_JPRB, 0.53582383E-09_JPRB, 0.53583094E-09_JPRB, 0.53583626E-09_JPRB, &
  & 0.53584298E-09_JPRB, 0.53584670E-09_JPRB, 0.53584992E-09_JPRB, 0.53585397E-09_JPRB, 0.53585691E-09_JPRB, 0.53586197E-09_JPRB, &
  & 0.53586346E-09_JPRB, 0.53586535E-09_JPRB, 0.53586408E-09_JPRB, 0.53585925E-09_JPRB, 0.53585569E-09_JPRB, 0.53585464E-09_JPRB, &
  & 0.53586124E-09_JPRB, 0.53587174E-09_JPRB, 0.53588645E-09_JPRB, 0.53590565E-09_JPRB, 0.53592530E-09_JPRB, 0.53594479E-09_JPRB, &
  & 0.53595955E-09_JPRB, 0.53597349E-09_JPRB, 0.53597971E-09_JPRB, 0.53598392E-09_JPRB, 0.53598875E-09_JPRB, 0.53598442E-09_JPRB, &
  & 0.53598004E-09_JPRB, 0.53597093E-09_JPRB, 0.53596594E-09_JPRB, 0.53595017E-09_JPRB, 0.53593530E-09_JPRB, 0.53591570E-09_JPRB, &
  & 0.53589988E-09_JPRB, 0.53588506E-09_JPRB, 0.53587285E-09_JPRB, 0.53586713E-09_JPRB, 0.53586424E-09_JPRB, 0.53586569E-09_JPRB, &
  & 0.53587423E-09_JPRB, 0.53588034E-09_JPRB, 0.53589067E-09_JPRB, 0.53590193E-09_JPRB, 0.53591309E-09_JPRB, 0.53591359E-09_JPRB, &
  & 0.53591687E-09_JPRB, 0.53591931E-09_JPRB, 0.53591420E-09_JPRB, 0.53590937E-09_JPRB, 0.53590882E-09_JPRB, 0.53590105E-09_JPRB, &
  & 0.53589583E-09_JPRB, 0.53588944E-09_JPRB, 0.53588817E-09_JPRB, 0.53588084E-09_JPRB, 0.53587434E-09_JPRB, 0.53586707E-09_JPRB, &
  & 0.53586102E-09_JPRB, 0.53584803E-09_JPRB, 0.53582050E-09_JPRB, 0.53575006E-09_JPRB /)

RGHG6(:,79, 2) = (/ &
  & 0.53580290E-09_JPRB, 0.53585419E-09_JPRB, 0.53586424E-09_JPRB, 0.53587668E-09_JPRB, 0.53588178E-09_JPRB, 0.53588495E-09_JPRB, &
  & 0.53589055E-09_JPRB, 0.53589194E-09_JPRB, 0.53589266E-09_JPRB, 0.53589505E-09_JPRB, 0.53589616E-09_JPRB, 0.53590093E-09_JPRB, &
  & 0.53590204E-09_JPRB, 0.53590482E-09_JPRB, 0.53590510E-09_JPRB, 0.53590171E-09_JPRB, 0.53589960E-09_JPRB, 0.53589888E-09_JPRB, &
  & 0.53590477E-09_JPRB, 0.53591159E-09_JPRB, 0.53592125E-09_JPRB, 0.53593441E-09_JPRB, 0.53594756E-09_JPRB, 0.53596128E-09_JPRB, &
  & 0.53597077E-09_JPRB, 0.53598143E-09_JPRB, 0.53598498E-09_JPRB, 0.53598775E-09_JPRB, 0.53599314E-09_JPRB, 0.53598870E-09_JPRB, &
  & 0.53598537E-09_JPRB, 0.53597804E-09_JPRB, 0.53597710E-09_JPRB, 0.53596472E-09_JPRB, 0.53595478E-09_JPRB, 0.53593957E-09_JPRB, &
  & 0.53592936E-09_JPRB, 0.53591942E-09_JPRB, 0.53591082E-09_JPRB, 0.53590782E-09_JPRB, 0.53590499E-09_JPRB, 0.53590477E-09_JPRB, &
  & 0.53591087E-09_JPRB, 0.53591315E-09_JPRB, 0.53592003E-09_JPRB, 0.53592852E-09_JPRB, 0.53593874E-09_JPRB, 0.53593718E-09_JPRB, &
  & 0.53594051E-09_JPRB, 0.53594429E-09_JPRB, 0.53593924E-09_JPRB, 0.53593507E-09_JPRB, 0.53593652E-09_JPRB, 0.53592902E-09_JPRB, &
  & 0.53592508E-09_JPRB, 0.53591986E-09_JPRB, 0.53592164E-09_JPRB, 0.53591559E-09_JPRB, 0.53591076E-09_JPRB, 0.53590515E-09_JPRB, &
  & 0.53590182E-09_JPRB, 0.53589211E-09_JPRB, 0.53587246E-09_JPRB, 0.53582877E-09_JPRB /)

RGHG6(:,80, 2) = (/ &
  & 0.53586130E-09_JPRB, 0.53588578E-09_JPRB, 0.53588861E-09_JPRB, 0.53589982E-09_JPRB, 0.53590371E-09_JPRB, 0.53590599E-09_JPRB, &
  & 0.53591109E-09_JPRB, 0.53591137E-09_JPRB, 0.53591109E-09_JPRB, 0.53591281E-09_JPRB, 0.53591337E-09_JPRB, 0.53591820E-09_JPRB, &
  & 0.53591909E-09_JPRB, 0.53592253E-09_JPRB, 0.53592342E-09_JPRB, 0.53592064E-09_JPRB, 0.53591914E-09_JPRB, 0.53591853E-09_JPRB, &
  & 0.53592419E-09_JPRB, 0.53592963E-09_JPRB, 0.53593679E-09_JPRB, 0.53594734E-09_JPRB, 0.53595750E-09_JPRB, 0.53596860E-09_JPRB, &
  & 0.53597576E-09_JPRB, 0.53598498E-09_JPRB, 0.53598725E-09_JPRB, 0.53598936E-09_JPRB, 0.53599525E-09_JPRB, 0.53599047E-09_JPRB, &
  & 0.53598781E-09_JPRB, 0.53598098E-09_JPRB, 0.53598226E-09_JPRB, 0.53597132E-09_JPRB, 0.53596361E-09_JPRB, 0.53595028E-09_JPRB, &
  & 0.53594268E-09_JPRB, 0.53593485E-09_JPRB, 0.53592797E-09_JPRB, 0.53592630E-09_JPRB, 0.53592342E-09_JPRB, 0.53592225E-09_JPRB, &
  & 0.53592736E-09_JPRB, 0.53592775E-09_JPRB, 0.53593302E-09_JPRB, 0.53594029E-09_JPRB, 0.53595017E-09_JPRB, 0.53594723E-09_JPRB, &
  & 0.53595073E-09_JPRB, 0.53595545E-09_JPRB, 0.53595017E-09_JPRB, 0.53594607E-09_JPRB, 0.53594879E-09_JPRB, 0.53594118E-09_JPRB, &
  & 0.53593768E-09_JPRB, 0.53593296E-09_JPRB, 0.53593607E-09_JPRB, 0.53593063E-09_JPRB, 0.53592636E-09_JPRB, 0.53592153E-09_JPRB, &
  & 0.53591948E-09_JPRB, 0.53591137E-09_JPRB, 0.53589710E-09_JPRB, 0.53588145E-09_JPRB /)

RGHG6(:,81, 2) = (/ &
  & 0.53590166E-09_JPRB, 0.53589921E-09_JPRB, 0.53589877E-09_JPRB, 0.53590959E-09_JPRB, 0.53591304E-09_JPRB, 0.53591503E-09_JPRB, &
  & 0.53591998E-09_JPRB, 0.53591964E-09_JPRB, 0.53591886E-09_JPRB, 0.53592059E-09_JPRB, 0.53592064E-09_JPRB, 0.53592591E-09_JPRB, &
  & 0.53592669E-09_JPRB, 0.53593030E-09_JPRB, 0.53593141E-09_JPRB, 0.53592891E-09_JPRB, 0.53592775E-09_JPRB, 0.53592702E-09_JPRB, &
  & 0.53593285E-09_JPRB, 0.53593752E-09_JPRB, 0.53594362E-09_JPRB, 0.53595278E-09_JPRB, 0.53596172E-09_JPRB, 0.53597177E-09_JPRB, &
  & 0.53597798E-09_JPRB, 0.53598659E-09_JPRB, 0.53598814E-09_JPRB, 0.53598992E-09_JPRB, 0.53599625E-09_JPRB, 0.53599131E-09_JPRB, &
  & 0.53598886E-09_JPRB, 0.53598226E-09_JPRB, 0.53598448E-09_JPRB, 0.53597415E-09_JPRB, 0.53596738E-09_JPRB, 0.53595495E-09_JPRB, &
  & 0.53594845E-09_JPRB, 0.53594168E-09_JPRB, 0.53593552E-09_JPRB, 0.53593446E-09_JPRB, 0.53593158E-09_JPRB, 0.53592997E-09_JPRB, &
  & 0.53593474E-09_JPRB, 0.53593407E-09_JPRB, 0.53593874E-09_JPRB, 0.53594529E-09_JPRB, 0.53595534E-09_JPRB, 0.53595151E-09_JPRB, &
  & 0.53595511E-09_JPRB, 0.53596039E-09_JPRB, 0.53595489E-09_JPRB, 0.53595084E-09_JPRB, 0.53595406E-09_JPRB, 0.53594623E-09_JPRB, &
  & 0.53594307E-09_JPRB, 0.53593846E-09_JPRB, 0.53594240E-09_JPRB, 0.53593707E-09_JPRB, 0.53593319E-09_JPRB, 0.53592847E-09_JPRB, &
  & 0.53592697E-09_JPRB, 0.53591925E-09_JPRB, 0.53590726E-09_JPRB, 0.53591803E-09_JPRB /)

RGHG6(:,82, 2) = (/ &
  & 0.53590488E-09_JPRB, 0.53590371E-09_JPRB, 0.53590332E-09_JPRB, 0.53591448E-09_JPRB, 0.53591759E-09_JPRB, 0.53591925E-09_JPRB, &
  & 0.53592425E-09_JPRB, 0.53592375E-09_JPRB, 0.53592275E-09_JPRB, 0.53592425E-09_JPRB, 0.53592453E-09_JPRB, 0.53592947E-09_JPRB, &
  & 0.53593041E-09_JPRB, 0.53593419E-09_JPRB, 0.53593557E-09_JPRB, 0.53593313E-09_JPRB, 0.53593191E-09_JPRB, 0.53593130E-09_JPRB, &
  & 0.53593713E-09_JPRB, 0.53594140E-09_JPRB, 0.53594684E-09_JPRB, 0.53595561E-09_JPRB, 0.53596383E-09_JPRB, 0.53597321E-09_JPRB, &
  & 0.53597887E-09_JPRB, 0.53598725E-09_JPRB, 0.53598853E-09_JPRB, 0.53599009E-09_JPRB, 0.53599675E-09_JPRB, 0.53599158E-09_JPRB, &
  & 0.53598931E-09_JPRB, 0.53598276E-09_JPRB, 0.53598553E-09_JPRB, 0.53597560E-09_JPRB, 0.53596916E-09_JPRB, 0.53595728E-09_JPRB, &
  & 0.53595123E-09_JPRB, 0.53594512E-09_JPRB, 0.53593929E-09_JPRB, 0.53593863E-09_JPRB, 0.53593568E-09_JPRB, 0.53593391E-09_JPRB, &
  & 0.53593835E-09_JPRB, 0.53593702E-09_JPRB, 0.53594129E-09_JPRB, 0.53594768E-09_JPRB, 0.53595783E-09_JPRB, 0.53595350E-09_JPRB, &
  & 0.53595733E-09_JPRB, 0.53596289E-09_JPRB, 0.53595728E-09_JPRB, 0.53595312E-09_JPRB, 0.53595672E-09_JPRB, 0.53594862E-09_JPRB, &
  & 0.53594557E-09_JPRB, 0.53594107E-09_JPRB, 0.53594551E-09_JPRB, 0.53594018E-09_JPRB, 0.53593641E-09_JPRB, 0.53593185E-09_JPRB, &
  & 0.53593052E-09_JPRB, 0.53592286E-09_JPRB, 0.53591054E-09_JPRB, 0.53592097E-09_JPRB /)

RGHG6(:,83, 2) = (/ &
  & 0.53590710E-09_JPRB, 0.53590632E-09_JPRB, 0.53590576E-09_JPRB, 0.53591720E-09_JPRB, 0.53592025E-09_JPRB, 0.53592186E-09_JPRB, &
  & 0.53592664E-09_JPRB, 0.53592575E-09_JPRB, 0.53592469E-09_JPRB, 0.53592641E-09_JPRB, 0.53592625E-09_JPRB, 0.53593191E-09_JPRB, &
  & 0.53593252E-09_JPRB, 0.53593635E-09_JPRB, 0.53593779E-09_JPRB, 0.53593552E-09_JPRB, 0.53593430E-09_JPRB, 0.53593358E-09_JPRB, &
  & 0.53593968E-09_JPRB, 0.53594351E-09_JPRB, 0.53594884E-09_JPRB, 0.53595695E-09_JPRB, 0.53596494E-09_JPRB, 0.53597404E-09_JPRB, &
  & 0.53597926E-09_JPRB, 0.53598770E-09_JPRB, 0.53598859E-09_JPRB, 0.53598997E-09_JPRB, 0.53599702E-09_JPRB, 0.53599170E-09_JPRB, &
  & 0.53598936E-09_JPRB, 0.53598292E-09_JPRB, 0.53598592E-09_JPRB, 0.53597626E-09_JPRB, 0.53597016E-09_JPRB, 0.53595856E-09_JPRB, &
  & 0.53595295E-09_JPRB, 0.53594706E-09_JPRB, 0.53594157E-09_JPRB, 0.53594096E-09_JPRB, 0.53593807E-09_JPRB, 0.53593596E-09_JPRB, &
  & 0.53594035E-09_JPRB, 0.53593857E-09_JPRB, 0.53594273E-09_JPRB, 0.53594901E-09_JPRB, 0.53595944E-09_JPRB, 0.53595461E-09_JPRB, &
  & 0.53595850E-09_JPRB, 0.53596433E-09_JPRB, 0.53595856E-09_JPRB, 0.53595434E-09_JPRB, 0.53595839E-09_JPRB, 0.53594995E-09_JPRB, &
  & 0.53594695E-09_JPRB, 0.53594246E-09_JPRB, 0.53594723E-09_JPRB, 0.53594196E-09_JPRB, 0.53593829E-09_JPRB, 0.53593363E-09_JPRB, &
  & 0.53593247E-09_JPRB, 0.53592469E-09_JPRB, 0.53591231E-09_JPRB, 0.53592308E-09_JPRB /)

RGHG6(:,84, 2) = (/ &
  & 0.53590871E-09_JPRB, 0.53590804E-09_JPRB, 0.53590732E-09_JPRB, 0.53591886E-09_JPRB, 0.53592186E-09_JPRB, 0.53592325E-09_JPRB, &
  & 0.53592825E-09_JPRB, 0.53592741E-09_JPRB, 0.53592619E-09_JPRB, 0.53592741E-09_JPRB, 0.53592797E-09_JPRB, 0.53593252E-09_JPRB, &
  & 0.53593380E-09_JPRB, 0.53593757E-09_JPRB, 0.53593924E-09_JPRB, 0.53593707E-09_JPRB, 0.53593591E-09_JPRB, 0.53593519E-09_JPRB, &
  & 0.53594124E-09_JPRB, 0.53594496E-09_JPRB, 0.53594962E-09_JPRB, 0.53595783E-09_JPRB, 0.53596544E-09_JPRB, 0.53597449E-09_JPRB, &
  & 0.53597965E-09_JPRB, 0.53598798E-09_JPRB, 0.53598859E-09_JPRB, 0.53598992E-09_JPRB, 0.53599730E-09_JPRB, 0.53599170E-09_JPRB, &
  & 0.53598942E-09_JPRB, 0.53598287E-09_JPRB, 0.53598603E-09_JPRB, 0.53597671E-09_JPRB, 0.53597049E-09_JPRB, 0.53595961E-09_JPRB, &
  & 0.53595395E-09_JPRB, 0.53594829E-09_JPRB, 0.53594301E-09_JPRB, 0.53594251E-09_JPRB, 0.53593963E-09_JPRB, 0.53593724E-09_JPRB, &
  & 0.53594162E-09_JPRB, 0.53593946E-09_JPRB, 0.53594346E-09_JPRB, 0.53594978E-09_JPRB, 0.53596039E-09_JPRB, 0.53595522E-09_JPRB, &
  & 0.53595917E-09_JPRB, 0.53596527E-09_JPRB, 0.53595922E-09_JPRB, 0.53595500E-09_JPRB, 0.53595933E-09_JPRB, 0.53595078E-09_JPRB, &
  & 0.53594773E-09_JPRB, 0.53594318E-09_JPRB, 0.53594840E-09_JPRB, 0.53594307E-09_JPRB, 0.53593946E-09_JPRB, 0.53593469E-09_JPRB, &
  & 0.53593363E-09_JPRB, 0.53592586E-09_JPRB, 0.53591342E-09_JPRB, 0.53592464E-09_JPRB /)

RGHG6(:,85, 2) = (/ &
  & 0.53590982E-09_JPRB, 0.53590926E-09_JPRB, 0.53590826E-09_JPRB, 0.53591998E-09_JPRB, 0.53592286E-09_JPRB, 0.53592475E-09_JPRB, &
  & 0.53592886E-09_JPRB, 0.53592797E-09_JPRB, 0.53592714E-09_JPRB, 0.53592836E-09_JPRB, 0.53592886E-09_JPRB, 0.53593330E-09_JPRB, &
  & 0.53593463E-09_JPRB, 0.53593824E-09_JPRB, 0.53593996E-09_JPRB, 0.53593807E-09_JPRB, 0.53593679E-09_JPRB, 0.53593602E-09_JPRB, &
  & 0.53594246E-09_JPRB, 0.53594573E-09_JPRB, 0.53595040E-09_JPRB, 0.53595811E-09_JPRB, 0.53596577E-09_JPRB, 0.53597482E-09_JPRB, &
  & 0.53597976E-09_JPRB, 0.53598820E-09_JPRB, 0.53598848E-09_JPRB, 0.53598981E-09_JPRB, 0.53599752E-09_JPRB, 0.53599170E-09_JPRB, &
  & 0.53598942E-09_JPRB, 0.53598292E-09_JPRB, 0.53598620E-09_JPRB, 0.53597687E-09_JPRB, 0.53597093E-09_JPRB, 0.53596005E-09_JPRB, &
  & 0.53595461E-09_JPRB, 0.53594917E-09_JPRB, 0.53594396E-09_JPRB, 0.53594351E-09_JPRB, 0.53594051E-09_JPRB, 0.53593796E-09_JPRB, &
  & 0.53594251E-09_JPRB, 0.53593996E-09_JPRB, 0.53594407E-09_JPRB, 0.53595023E-09_JPRB, 0.53596105E-09_JPRB, 0.53595556E-09_JPRB, &
  & 0.53595950E-09_JPRB, 0.53596583E-09_JPRB, 0.53595978E-09_JPRB, 0.53595545E-09_JPRB, 0.53595994E-09_JPRB, 0.53595139E-09_JPRB, &
  & 0.53594823E-09_JPRB, 0.53594373E-09_JPRB, 0.53594912E-09_JPRB, 0.53594384E-09_JPRB, 0.53594024E-09_JPRB, 0.53593541E-09_JPRB, &
  & 0.53593452E-09_JPRB, 0.53592664E-09_JPRB, 0.53591404E-09_JPRB, 0.53592564E-09_JPRB /)

RGHG6(:,86, 2) = (/ &
  & 0.53591048E-09_JPRB, 0.53591009E-09_JPRB, 0.53590871E-09_JPRB, 0.53592075E-09_JPRB, 0.53592369E-09_JPRB, 0.53592503E-09_JPRB, &
  & 0.53592930E-09_JPRB, 0.53592875E-09_JPRB, 0.53592814E-09_JPRB, 0.53592908E-09_JPRB, 0.53593008E-09_JPRB, 0.53593324E-09_JPRB, &
  & 0.53593502E-09_JPRB, 0.53593824E-09_JPRB, 0.53594018E-09_JPRB, 0.53593874E-09_JPRB, 0.53593746E-09_JPRB, 0.53593674E-09_JPRB, &
  & 0.53594296E-09_JPRB, 0.53594634E-09_JPRB, 0.53595056E-09_JPRB, 0.53595850E-09_JPRB, 0.53596594E-09_JPRB, 0.53597504E-09_JPRB, &
  & 0.53597993E-09_JPRB, 0.53598848E-09_JPRB, 0.53598842E-09_JPRB, 0.53598981E-09_JPRB, 0.53599764E-09_JPRB, 0.53599158E-09_JPRB, &
  & 0.53598936E-09_JPRB, 0.53598276E-09_JPRB, 0.53598614E-09_JPRB, 0.53597715E-09_JPRB, 0.53597116E-09_JPRB, 0.53596061E-09_JPRB, &
  & 0.53595500E-09_JPRB, 0.53594967E-09_JPRB, 0.53594446E-09_JPRB, 0.53594429E-09_JPRB, 0.53594118E-09_JPRB, 0.53593824E-09_JPRB, &
  & 0.53594301E-09_JPRB, 0.53594013E-09_JPRB, 0.53594423E-09_JPRB, 0.53595045E-09_JPRB, 0.53596144E-09_JPRB, 0.53595578E-09_JPRB, &
  & 0.53595972E-09_JPRB, 0.53596627E-09_JPRB, 0.53596011E-09_JPRB, 0.53595561E-09_JPRB, 0.53596044E-09_JPRB, 0.53595173E-09_JPRB, &
  & 0.53594856E-09_JPRB, 0.53594396E-09_JPRB, 0.53594967E-09_JPRB, 0.53594440E-09_JPRB, 0.53594074E-09_JPRB, 0.53593580E-09_JPRB, &
  & 0.53593496E-09_JPRB, 0.53592702E-09_JPRB, 0.53591453E-09_JPRB, 0.53592630E-09_JPRB /)

RGHG6(:,87, 2) = (/ &
  & 0.53591087E-09_JPRB, 0.53591048E-09_JPRB, 0.53590887E-09_JPRB, 0.53592136E-09_JPRB, 0.53592408E-09_JPRB, 0.53592630E-09_JPRB, &
  & 0.53592930E-09_JPRB, 0.53592897E-09_JPRB, 0.53592875E-09_JPRB, 0.53592975E-09_JPRB, 0.53593074E-09_JPRB, 0.53593363E-09_JPRB, &
  & 0.53593530E-09_JPRB, 0.53593818E-09_JPRB, 0.53594013E-09_JPRB, 0.53593913E-09_JPRB, 0.53593791E-09_JPRB, 0.53593724E-09_JPRB, &
  & 0.53594335E-09_JPRB, 0.53594645E-09_JPRB, 0.53595078E-09_JPRB, 0.53595850E-09_JPRB, 0.53596599E-09_JPRB, 0.53597526E-09_JPRB, &
  & 0.53597987E-09_JPRB, 0.53598870E-09_JPRB, 0.53598848E-09_JPRB, 0.53598959E-09_JPRB, 0.53599786E-09_JPRB, 0.53599158E-09_JPRB, &
  & 0.53598931E-09_JPRB, 0.53598270E-09_JPRB, 0.53598631E-09_JPRB, 0.53597726E-09_JPRB, 0.53597166E-09_JPRB, 0.53596050E-09_JPRB, &
  & 0.53595534E-09_JPRB, 0.53594995E-09_JPRB, 0.53594457E-09_JPRB, 0.53594484E-09_JPRB, 0.53594140E-09_JPRB, 0.53593829E-09_JPRB, &
  & 0.53594340E-09_JPRB, 0.53594007E-09_JPRB, 0.53594440E-09_JPRB, 0.53595062E-09_JPRB, 0.53596177E-09_JPRB, 0.53595589E-09_JPRB, &
  & 0.53595994E-09_JPRB, 0.53596655E-09_JPRB, 0.53596039E-09_JPRB, 0.53595578E-09_JPRB, 0.53596061E-09_JPRB, 0.53595184E-09_JPRB, &
  & 0.53594879E-09_JPRB, 0.53594407E-09_JPRB, 0.53595001E-09_JPRB, 0.53594468E-09_JPRB, 0.53594101E-09_JPRB, 0.53593607E-09_JPRB, &
  & 0.53593524E-09_JPRB, 0.53592730E-09_JPRB, 0.53591453E-09_JPRB, 0.53592669E-09_JPRB /)

RGHG6(:,88, 2) = (/ &
  & 0.53591109E-09_JPRB, 0.53591076E-09_JPRB, 0.53590904E-09_JPRB, 0.53592142E-09_JPRB, 0.53592458E-09_JPRB, 0.53592591E-09_JPRB, &
  & 0.53592975E-09_JPRB, 0.53592930E-09_JPRB, 0.53592908E-09_JPRB, 0.53592986E-09_JPRB, 0.53593097E-09_JPRB, 0.53593358E-09_JPRB, &
  & 0.53593530E-09_JPRB, 0.53593818E-09_JPRB, 0.53594018E-09_JPRB, 0.53593940E-09_JPRB, 0.53593807E-09_JPRB, 0.53593741E-09_JPRB, &
  & 0.53594362E-09_JPRB, 0.53594673E-09_JPRB, 0.53595078E-09_JPRB, 0.53595861E-09_JPRB, 0.53596594E-09_JPRB, 0.53597538E-09_JPRB, &
  & 0.53597987E-09_JPRB, 0.53598892E-09_JPRB, 0.53598831E-09_JPRB, 0.53598953E-09_JPRB, 0.53599797E-09_JPRB, 0.53599153E-09_JPRB, &
  & 0.53598925E-09_JPRB, 0.53598248E-09_JPRB, 0.53598653E-09_JPRB, 0.53597760E-09_JPRB, 0.53597177E-09_JPRB, 0.53596061E-09_JPRB, &
  & 0.53595534E-09_JPRB, 0.53595012E-09_JPRB, 0.53594451E-09_JPRB, 0.53594523E-09_JPRB, 0.53594185E-09_JPRB, 0.53593813E-09_JPRB, &
  & 0.53594357E-09_JPRB, 0.53593996E-09_JPRB, 0.53594434E-09_JPRB, 0.53595051E-09_JPRB, 0.53596189E-09_JPRB, 0.53595589E-09_JPRB, &
  & 0.53595994E-09_JPRB, 0.53596672E-09_JPRB, 0.53596050E-09_JPRB, 0.53595584E-09_JPRB, 0.53596078E-09_JPRB, 0.53595178E-09_JPRB, &
  & 0.53594884E-09_JPRB, 0.53594412E-09_JPRB, 0.53595006E-09_JPRB, 0.53594490E-09_JPRB, 0.53594118E-09_JPRB, 0.53593613E-09_JPRB, &
  & 0.53593535E-09_JPRB, 0.53592741E-09_JPRB, 0.53591470E-09_JPRB, 0.53592702E-09_JPRB /)

RGHG6(:,89, 2) = (/ &
  & 0.53591126E-09_JPRB, 0.53591082E-09_JPRB, 0.53590909E-09_JPRB, 0.53592175E-09_JPRB, 0.53592453E-09_JPRB, 0.53592669E-09_JPRB, &
  & 0.53592975E-09_JPRB, 0.53592913E-09_JPRB, 0.53592886E-09_JPRB, 0.53592986E-09_JPRB, 0.53593086E-09_JPRB, 0.53593374E-09_JPRB, &
  & 0.53593557E-09_JPRB, 0.53593852E-09_JPRB, 0.53594040E-09_JPRB, 0.53593951E-09_JPRB, 0.53593818E-09_JPRB, 0.53593741E-09_JPRB, &
  & 0.53594390E-09_JPRB, 0.53594679E-09_JPRB, 0.53595084E-09_JPRB, 0.53595856E-09_JPRB, 0.53596594E-09_JPRB, 0.53597549E-09_JPRB, &
  & 0.53597976E-09_JPRB, 0.53598909E-09_JPRB, 0.53598831E-09_JPRB, 0.53598942E-09_JPRB, 0.53599819E-09_JPRB, 0.53599142E-09_JPRB, &
  & 0.53598936E-09_JPRB, 0.53598226E-09_JPRB, 0.53598698E-09_JPRB, 0.53597754E-09_JPRB, 0.53597227E-09_JPRB, 0.53596028E-09_JPRB, &
  & 0.53595539E-09_JPRB, 0.53595017E-09_JPRB, 0.53594429E-09_JPRB, 0.53594557E-09_JPRB, 0.53594185E-09_JPRB, 0.53593791E-09_JPRB, &
  & 0.53594379E-09_JPRB, 0.53593990E-09_JPRB, 0.53594446E-09_JPRB, 0.53595062E-09_JPRB, 0.53596222E-09_JPRB, 0.53595578E-09_JPRB, &
  & 0.53595989E-09_JPRB, 0.53596694E-09_JPRB, 0.53596061E-09_JPRB, 0.53595572E-09_JPRB, 0.53596100E-09_JPRB, 0.53595189E-09_JPRB, &
  & 0.53594906E-09_JPRB, 0.53594418E-09_JPRB, 0.53595023E-09_JPRB, 0.53594507E-09_JPRB, 0.53594135E-09_JPRB, 0.53593613E-09_JPRB, &
  & 0.53593563E-09_JPRB, 0.53592758E-09_JPRB, 0.53591453E-09_JPRB, 0.53592719E-09_JPRB /)

RGHG6(:,90, 2) = (/ &
  & 0.53591126E-09_JPRB, 0.53591082E-09_JPRB, 0.53590882E-09_JPRB, 0.53592186E-09_JPRB, 0.53592464E-09_JPRB, 0.53592569E-09_JPRB, &
  & 0.53593036E-09_JPRB, 0.53592919E-09_JPRB, 0.53592830E-09_JPRB, 0.53592936E-09_JPRB, 0.53593030E-09_JPRB, 0.53593396E-09_JPRB, &
  & 0.53593557E-09_JPRB, 0.53593907E-09_JPRB, 0.53594101E-09_JPRB, 0.53593963E-09_JPRB, 0.53593802E-09_JPRB, 0.53593718E-09_JPRB, &
  & 0.53594418E-09_JPRB, 0.53594679E-09_JPRB, 0.53595073E-09_JPRB, 0.53595861E-09_JPRB, 0.53596583E-09_JPRB, 0.53597565E-09_JPRB, &
  & 0.53597954E-09_JPRB, 0.53598931E-09_JPRB, 0.53598820E-09_JPRB, 0.53598903E-09_JPRB, 0.53599863E-09_JPRB, 0.53599131E-09_JPRB, &
  & 0.53598970E-09_JPRB, 0.53598193E-09_JPRB, 0.53598775E-09_JPRB, 0.53597743E-09_JPRB, 0.53597260E-09_JPRB, 0.53595978E-09_JPRB, &
  & 0.53595534E-09_JPRB, 0.53595028E-09_JPRB, 0.53594407E-09_JPRB, 0.53594590E-09_JPRB, 0.53594196E-09_JPRB, 0.53593763E-09_JPRB, &
  & 0.53594418E-09_JPRB, 0.53593979E-09_JPRB, 0.53594440E-09_JPRB, 0.53595051E-09_JPRB, 0.53596277E-09_JPRB, 0.53595561E-09_JPRB, &
  & 0.53595994E-09_JPRB, 0.53596738E-09_JPRB, 0.53596066E-09_JPRB, 0.53595556E-09_JPRB, 0.53596144E-09_JPRB, 0.53595173E-09_JPRB, &
  & 0.53594906E-09_JPRB, 0.53594390E-09_JPRB, 0.53595056E-09_JPRB, 0.53594512E-09_JPRB, 0.53594146E-09_JPRB, 0.53593591E-09_JPRB, &
  & 0.53593574E-09_JPRB, 0.53592747E-09_JPRB, 0.53591415E-09_JPRB, 0.53592736E-09_JPRB /)

RGHG6(:,91, 2) = (/ &
  & 0.53591126E-09_JPRB, 0.53591098E-09_JPRB, 0.53590732E-09_JPRB, 0.53592264E-09_JPRB, 0.53592458E-09_JPRB, 0.53592497E-09_JPRB, &
  & 0.53593213E-09_JPRB, 0.53592936E-09_JPRB, 0.53592641E-09_JPRB, 0.53592930E-09_JPRB, 0.53592786E-09_JPRB, 0.53593613E-09_JPRB, &
  & 0.53593507E-09_JPRB, 0.53594018E-09_JPRB, 0.53594201E-09_JPRB, 0.53593963E-09_JPRB, 0.53593791E-09_JPRB, 0.53593641E-09_JPRB, &
  & 0.53594457E-09_JPRB, 0.53594679E-09_JPRB, 0.53595040E-09_JPRB, 0.53595861E-09_JPRB, 0.53596566E-09_JPRB, 0.53597604E-09_JPRB, &
  & 0.53597915E-09_JPRB, 0.53599014E-09_JPRB, 0.53598809E-09_JPRB, 0.53598836E-09_JPRB, 0.53600008E-09_JPRB, 0.53599092E-09_JPRB, &
  & 0.53599003E-09_JPRB, 0.53598054E-09_JPRB, 0.53598975E-09_JPRB, 0.53597682E-09_JPRB, 0.53597377E-09_JPRB, 0.53595850E-09_JPRB, &
  & 0.53595517E-09_JPRB, 0.53595034E-09_JPRB, 0.53594346E-09_JPRB, 0.53594623E-09_JPRB, 0.53594201E-09_JPRB, 0.53593679E-09_JPRB, &
  & 0.53594496E-09_JPRB, 0.53593918E-09_JPRB, 0.53594429E-09_JPRB, 0.53595012E-09_JPRB, 0.53596411E-09_JPRB, 0.53595484E-09_JPRB, &
  & 0.53595972E-09_JPRB, 0.53596833E-09_JPRB, 0.53596055E-09_JPRB, 0.53595473E-09_JPRB, 0.53596244E-09_JPRB, 0.53595123E-09_JPRB, &
  & 0.53594934E-09_JPRB, 0.53594323E-09_JPRB, 0.53595139E-09_JPRB, 0.53594501E-09_JPRB, 0.53594157E-09_JPRB, 0.53593563E-09_JPRB, &
  & 0.53593624E-09_JPRB, 0.53592736E-09_JPRB, 0.53591320E-09_JPRB, 0.53592769E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART4',1,ZHOOK_HANDLE)
END SUBROUTINE PART4






SUBROUTINE PART5
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART5',0,ZHOOK_HANDLE)



!-- Month=  3 ------------

RGHG6(:, 1, 3) = (/ &
  & 0.24630249E-36_JPRB, 0.91937609E-36_JPRB, 0.24504333E-35_JPRB, 0.43603935E-35_JPRB, 0.66881166E-35_JPRB, 0.10124502E-34_JPRB, &
  & 0.15580750E-34_JPRB, 0.24567668E-34_JPRB, 0.39437454E-34_JPRB, 0.64275721E-34_JPRB, 0.10603860E-33_JPRB, 0.16857645E-33_JPRB, &
  & 0.26685875E-33_JPRB, 0.43099822E-33_JPRB, 0.68898874E-33_JPRB, 0.10871956E-32_JPRB, 0.16932203E-32_JPRB, 0.25875404E-32_JPRB, &
  & 0.38632078E-32_JPRB, 0.56163034E-32_JPRB, 0.79272694E-32_JPRB, 0.10864692E-31_JPRB, 0.14501336E-31_JPRB, 0.18958324E-31_JPRB, &
  & 0.24491303E-31_JPRB, 0.31628324E-31_JPRB, 0.39163202E-31_JPRB, 0.46879749E-31_JPRB, 0.54619974E-31_JPRB, 0.61803373E-31_JPRB, &
  & 0.67606618E-31_JPRB, 0.70725257E-31_JPRB, 0.70282225E-31_JPRB, 0.66714253E-31_JPRB, 0.59551190E-31_JPRB, 0.49731210E-31_JPRB, &
  & 0.38429082E-31_JPRB, 0.27581664E-31_JPRB, 0.19094397E-31_JPRB, 0.12847363E-31_JPRB, 0.85228344E-32_JPRB, 0.55365255E-32_JPRB, &
  & 0.34946929E-32_JPRB, 0.21330186E-32_JPRB, 0.12620159E-32_JPRB, 0.72987895E-33_JPRB, 0.41568658E-33_JPRB, 0.23460057E-33_JPRB, &
  & 0.13185955E-33_JPRB, 0.74152629E-34_JPRB, 0.41956593E-34_JPRB, 0.24029535E-34_JPRB, 0.14010093E-34_JPRB, 0.83625281E-35_JPRB, &
  & 0.51356454E-35_JPRB, 0.32624467E-35_JPRB, 0.21539940E-35_JPRB, 0.14856000E-35_JPRB, 0.10739157E-35_JPRB, 0.81608197E-36_JPRB, &
  & 0.62600975E-36_JPRB, 0.45261582E-36_JPRB, 0.30053029E-36_JPRB, 0.21353461E-36_JPRB /)

RGHG6(:, 2, 3) = (/ &
  & 0.91826341E-35_JPRB, 0.40554171E-34_JPRB, 0.10256374E-33_JPRB, 0.17782429E-33_JPRB, 0.27275758E-33_JPRB, 0.41376621E-33_JPRB, &
  & 0.63795511E-33_JPRB, 0.10070951E-32_JPRB, 0.16166739E-32_JPRB, 0.26306355E-32_JPRB, 0.43120740E-32_JPRB, 0.68518420E-32_JPRB, &
  & 0.10855694E-31_JPRB, 0.17446114E-31_JPRB, 0.27816937E-31_JPRB, 0.43823670E-31_JPRB, 0.68015531E-31_JPRB, 0.10347216E-30_JPRB, &
  & 0.15372952E-30_JPRB, 0.22259899E-30_JPRB, 0.31361465E-30_JPRB, 0.43058513E-30_JPRB, 0.57769491E-30_JPRB, 0.76156442E-30_JPRB, &
  & 0.98803403E-30_JPRB, 0.12621116E-29_JPRB, 0.15608307E-29_JPRB, 0.18722191E-29_JPRB, 0.21796187E-29_JPRB, 0.24650965E-29_JPRB, &
  & 0.26943372E-29_JPRB, 0.28172379E-29_JPRB, 0.27973423E-29_JPRB, 0.26462797E-29_JPRB, 0.23570055E-29_JPRB, 0.19652992E-29_JPRB, &
  & 0.15228376E-29_JPRB, 0.11028195E-29_JPRB, 0.76912591E-30_JPRB, 0.51991015E-30_JPRB, 0.34357666E-30_JPRB, 0.22250246E-30_JPRB, &
  & 0.14035153E-30_JPRB, 0.85961657E-31_JPRB, 0.51230295E-31_JPRB, 0.29932562E-31_JPRB, 0.17243030E-31_JPRB, 0.98442436E-32_JPRB, &
  & 0.55933853E-32_JPRB, 0.31761218E-32_JPRB, 0.18117788E-32_JPRB, 0.10439774E-32_JPRB, 0.61080698E-33_JPRB, 0.36479562E-33_JPRB, &
  & 0.22345186E-33_JPRB, 0.14120228E-33_JPRB, 0.92586504E-34_JPRB, 0.63408364E-34_JPRB, 0.45555118E-34_JPRB, 0.34199912E-34_JPRB, &
  & 0.26134764E-34_JPRB, 0.19359784E-34_JPRB, 0.13142200E-34_JPRB, 0.82557421E-35_JPRB /)

RGHG6(:, 3, 3) = (/ &
  & 0.35575482E-33_JPRB, 0.20746390E-32_JPRB, 0.50873926E-32_JPRB, 0.85948033E-32_JPRB, 0.13095636E-31_JPRB, 0.19869698E-31_JPRB, &
  & 0.30716514E-31_JPRB, 0.48591651E-31_JPRB, 0.78195553E-31_JPRB, 0.12737599E-30_JPRB, 0.20878921E-30_JPRB, 0.33176607E-30_JPRB, &
  & 0.52499219E-30_JPRB, 0.84076284E-30_JPRB, 0.13323139E-29_JPRB, 0.20844216E-29_JPRB, 0.32065075E-29_JPRB, 0.48333996E-29_JPRB, &
  & 0.71441589E-29_JPRB, 0.10334167E-28_JPRB, 0.14628440E-28_JPRB, 0.20252502E-28_JPRB, 0.27475314E-28_JPRB, 0.36503559E-28_JPRB, &
  & 0.47607568E-28_JPRB, 0.60464980E-28_JPRB, 0.74681304E-28_JPRB, 0.89374916E-28_JPRB, 0.10409755E-27_JPRB, 0.11768193E-27_JPRB, &
  & 0.12860404E-27_JPRB, 0.13438133E-27_JPRB, 0.13326053E-27_JPRB, 0.12583174E-27_JPRB, 0.11183442E-27_JPRB, 0.93318648E-28_JPRB, &
  & 0.72419600E-28_JPRB, 0.52823088E-28_JPRB, 0.36979227E-28_JPRB, 0.25000245E-28_JPRB, 0.16414259E-28_JPRB, 0.10513843E-28_JPRB, &
  & 0.65591276E-29_JPRB, 0.39812147E-29_JPRB, 0.23650376E-29_JPRB, 0.13862690E-29_JPRB, 0.80637022E-30_JPRB, 0.46653678E-30_JPRB, &
  & 0.26892892E-30_JPRB, 0.15477611E-30_JPRB, 0.89238100E-31_JPRB, 0.51773256E-31_JPRB, 0.30362105E-31_JPRB, 0.18087933E-31_JPRB, &
  & 0.11003275E-31_JPRB, 0.68802772E-32_JPRB, 0.44536359E-32_JPRB, 0.30138909E-32_JPRB, 0.21434941E-32_JPRB, 0.15999903E-32_JPRB, &
  & 0.12237615E-32_JPRB, 0.90708271E-33_JPRB, 0.59156423E-33_JPRB, 0.29631639E-33_JPRB /)

RGHG6(:, 4, 3) = (/ &
  & 0.39426369E-31_JPRB, 0.23446652E-30_JPRB, 0.50875212E-30_JPRB, 0.82082824E-30_JPRB, 0.12344582E-29_JPRB, 0.18720812E-29_JPRB, &
  & 0.28944664E-29_JPRB, 0.45846352E-29_JPRB, 0.73770550E-29_JPRB, 0.12021644E-28_JPRB, 0.19696293E-28_JPRB, 0.31243203E-28_JPRB, &
  & 0.49313948E-28_JPRB, 0.78548409E-28_JPRB, 0.12367294E-27_JPRB, 0.19170143E-27_JPRB, 0.29170458E-27_JPRB, 0.43532921E-27_JPRB, &
  & 0.63736379E-27_JPRB, 0.91778535E-27_JPRB, 0.12981816E-26_JPRB, 0.18039450E-26_JPRB, 0.24571328E-26_JPRB, 0.32798795E-26_JPRB, &
  & 0.42654402E-26_JPRB, 0.54035088E-26_JPRB, 0.66369318E-26_JPRB, 0.79340718E-26_JPRB, 0.92244364E-26_JPRB, 0.10423381E-25_JPRB, &
  & 0.11380089E-25_JPRB, 0.11877899E-25_JPRB, 0.11767990E-25_JPRB, 0.11101569E-25_JPRB, 0.98760139E-26_JPRB, 0.82477164E-26_JPRB, &
  & 0.64273860E-26_JPRB, 0.47066069E-26_JPRB, 0.33146826E-26_JPRB, 0.22469759E-26_JPRB, 0.14715059E-26_JPRB, 0.93760481E-27_JPRB, &
  & 0.58124898E-27_JPRB, 0.35154880E-27_JPRB, 0.20919976E-27_JPRB, 0.12373234E-27_JPRB, 0.72931422E-28_JPRB, 0.42865342E-28_JPRB, &
  & 0.25109438E-28_JPRB, 0.14659282E-28_JPRB, 0.85504594E-29_JPRB, 0.50002897E-29_JPRB, 0.29441258E-29_JPRB, 0.17543967E-29_JPRB, &
  & 0.10638492E-29_JPRB, 0.66139331E-30_JPRB, 0.42531516E-30_JPRB, 0.28569976E-30_JPRB, 0.20235505E-30_JPRB, 0.15112910E-30_JPRB, &
  & 0.11724652E-30_JPRB, 0.89636511E-31_JPRB, 0.59510224E-31_JPRB, 0.25625204E-31_JPRB /)

RGHG6(:, 5, 3) = (/ &
  & 0.19318356E-28_JPRB, 0.68336171E-28_JPRB, 0.12384366E-27_JPRB, 0.18890431E-27_JPRB, 0.28177489E-27_JPRB, 0.42607603E-27_JPRB, &
  & 0.65680172E-27_JPRB, 0.10352131E-26_JPRB, 0.16570749E-26_JPRB, 0.26816294E-26_JPRB, 0.43596567E-26_JPRB, 0.68478519E-26_JPRB, &
  & 0.10680892E-25_JPRB, 0.16787093E-25_JPRB, 0.26005379E-25_JPRB, 0.39597970E-25_JPRB, 0.59114802E-25_JPRB, 0.86385847E-25_JPRB, &
  & 0.12404727E-24_JPRB, 0.17523058E-24_JPRB, 0.24385155E-24_JPRB, 0.33399843E-24_JPRB, 0.44960136E-24_JPRB, 0.59228214E-24_JPRB, &
  & 0.76123105E-24_JPRB, 0.95124053E-24_JPRB, 0.11570864E-23_JPRB, 0.13709322E-23_JPRB, 0.15845344E-23_JPRB, 0.17817905E-23_JPRB, &
  & 0.19387752E-23_JPRB, 0.20202373E-23_JPRB, 0.20015815E-23_JPRB, 0.18934492E-23_JPRB, 0.16921879E-23_JPRB, 0.14235089E-23_JPRB, &
  & 0.11186681E-23_JPRB, 0.82861042E-24_JPRB, 0.59096672E-24_JPRB, 0.40617220E-24_JPRB, 0.26937199E-24_JPRB, 0.17375315E-24_JPRB, &
  & 0.10899390E-24_JPRB, 0.66917444E-25_JPRB, 0.40577677E-25_JPRB, 0.24519248E-25_JPRB, 0.14797555E-25_JPRB, 0.89074468E-26_JPRB, &
  & 0.53369129E-26_JPRB, 0.31819980E-26_JPRB, 0.18903547E-26_JPRB, 0.11227716E-26_JPRB, 0.66953130E-27_JPRB, 0.40306825E-27_JPRB, &
  & 0.24648863E-27_JPRB, 0.15435067E-27_JPRB, 0.99789219E-28_JPRB, 0.67375860E-28_JPRB, 0.47853973E-28_JPRB, 0.35943579E-28_JPRB, &
  & 0.28306984E-28_JPRB, 0.22731363E-28_JPRB, 0.17169315E-28_JPRB, 0.96941669E-29_JPRB /)

RGHG6(:, 6, 3) = (/ &
  & 0.16384253E-25_JPRB, 0.42057370E-25_JPRB, 0.67752576E-25_JPRB, 0.10110993E-24_JPRB, 0.14954720E-24_JPRB, 0.22382580E-24_JPRB, &
  & 0.34036077E-24_JPRB, 0.52757671E-24_JPRB, 0.82706840E-24_JPRB, 0.13065610E-23_JPRB, 0.20662531E-23_JPRB, 0.31435661E-23_JPRB, &
  & 0.47323967E-23_JPRB, 0.71571102E-23_JPRB, 0.10647379E-22_JPRB, 0.15537639E-22_JPRB, 0.22195209E-22_JPRB, 0.31035757E-22_JPRB, &
  & 0.42621076E-22_JPRB, 0.57662615E-22_JPRB, 0.76973071E-22_JPRB, 0.10140474E-21_JPRB, 0.13164773E-21_JPRB, 0.16775936E-21_JPRB, &
  & 0.20921525E-21_JPRB, 0.25469252E-21_JPRB, 0.30301771E-21_JPRB, 0.35270569E-21_JPRB, 0.40195980E-21_JPRB, 0.44744766E-21_JPRB, &
  & 0.48392979E-21_JPRB, 0.50318229E-21_JPRB, 0.49963930E-21_JPRB, 0.47553893E-21_JPRB, 0.42953438E-21_JPRB, 0.36657425E-21_JPRB, &
  & 0.29331454E-21_JPRB, 0.22203001E-21_JPRB, 0.16259294E-21_JPRB, 0.11512462E-21_JPRB, 0.79006420E-22_JPRB, 0.52795220E-22_JPRB, &
  & 0.34463519E-22_JPRB, 0.22049398E-22_JPRB, 0.13964108E-22_JPRB, 0.88262917E-23_JPRB, 0.55719707E-23_JPRB, 0.35052679E-23_JPRB, &
  & 0.21931154E-23_JPRB, 0.13625148E-23_JPRB, 0.84176202E-24_JPRB, 0.51865938E-24_JPRB, 0.32008766E-24_JPRB, 0.19897722E-24_JPRB, &
  & 0.12537047E-24_JPRB, 0.80695146E-25_JPRB, 0.53494981E-25_JPRB, 0.36866619E-25_JPRB, 0.26637719E-25_JPRB, 0.20269396E-25_JPRB, &
  & 0.16177676E-25_JPRB, 0.13404875E-25_JPRB, 0.11035543E-25_JPRB, 0.81291069E-26_JPRB /)

RGHG6(:, 7, 3) = (/ &
  & 0.13482747E-22_JPRB, 0.32371633E-22_JPRB, 0.51007961E-22_JPRB, 0.75267302E-22_JPRB, 0.10969189E-21_JPRB, 0.16111232E-21_JPRB, &
  & 0.23917864E-21_JPRB, 0.35996612E-21_JPRB, 0.54501398E-21_JPRB, 0.82701875E-21_JPRB, 0.12501043E-20_JPRB, 0.18076332E-20_JPRB, &
  & 0.25743286E-20_JPRB, 0.36734889E-20_JPRB, 0.51460110E-20_JPRB, 0.70652743E-20_JPRB, 0.94945778E-20_JPRB, 0.12494986E-19_JPRB, &
  & 0.16174066E-19_JPRB, 0.20668772E-19_JPRB, 0.26134135E-19_JPRB, 0.32724367E-19_JPRB, 0.40510537E-19_JPRB, 0.49476555E-19_JPRB, &
  & 0.59343734E-19_JPRB, 0.69920181E-19_JPRB, 0.80882276E-19_JPRB, 0.92052885E-19_JPRB, 0.10309228E-18_JPRB, 0.11339620E-18_JPRB, &
  & 0.12181528E-18_JPRB, 0.12648576E-18_JPRB, 0.12600579E-18_JPRB, 0.12088428E-18_JPRB, 0.11059106E-18_JPRB, 0.96044891E-19_JPRB, &
  & 0.78572995E-19_JPRB, 0.61099457E-19_JPRB, 0.46208959E-19_JPRB, 0.34002862E-19_JPRB, 0.24353092E-19_JPRB, 0.17100786E-19_JPRB, &
  & 0.11762533E-19_JPRB, 0.79595026E-20_JPRB, 0.53432451E-20_JPRB, 0.35829894E-20_JPRB, 0.24008081E-20_JPRB, 0.16035647E-20_JPRB, &
  & 0.10641097E-20_JPRB, 0.70071048E-21_JPRB, 0.45814159E-21_JPRB, 0.29823039E-21_JPRB, 0.19402726E-21_JPRB, 0.12682813E-21_JPRB, &
  & 0.83783579E-22_JPRB, 0.56336937E-22_JPRB, 0.38841302E-22_JPRB, 0.27702791E-22_JPRB, 0.20587632E-22_JPRB, 0.16026604E-22_JPRB, &
  & 0.13034144E-22_JPRB, 0.10934687E-22_JPRB, 0.92619922E-23_JPRB, 0.71588220E-23_JPRB /)

RGHG6(:, 8, 3) = (/ &
  & 0.95579056E-20_JPRB, 0.22630292E-19_JPRB, 0.35363299E-19_JPRB, 0.51595578E-19_JPRB, 0.74124747E-19_JPRB, 0.10679748E-18_JPRB, &
  & 0.15473708E-18_JPRB, 0.22601940E-18_JPRB, 0.33017922E-18_JPRB, 0.48053129E-18_JPRB, 0.69290656E-18_JPRB, 0.94981376E-18_JPRB, &
  & 0.12758186E-17_JPRB, 0.17120170E-17_JPRB, 0.22511354E-17_JPRB, 0.28986429E-17_JPRB, 0.36541101E-17_JPRB, 0.45153639E-17_JPRB, &
  & 0.54982943E-17_JPRB, 0.66262866E-17_JPRB, 0.79259032E-17_JPRB, 0.94187863E-17_JPRB, 0.11112735E-16_JPRB, 0.12973832E-16_JPRB, &
  & 0.14966308E-16_JPRB, 0.17027291E-16_JPRB, 0.19141429E-16_JPRB, 0.21276374E-16_JPRB, 0.23409615E-16_JPRB, 0.25432500E-16_JPRB, &
  & 0.27139756E-16_JPRB, 0.28136704E-16_JPRB, 0.28123132E-16_JPRB, 0.27196334E-16_JPRB, 0.25202603E-16_JPRB, 0.22283905E-16_JPRB, &
  & 0.18647328E-16_JPRB, 0.14915555E-16_JPRB, 0.11671853E-16_JPRB, 0.89350610E-17_JPRB, 0.67018194E-17_JPRB, 0.49499017E-17_JPRB, &
  & 0.35975594E-17_JPRB, 0.25808440E-17_JPRB, 0.18391071E-17_JPRB, 0.13116998E-17_JPRB, 0.93561448E-18_JPRB, 0.66522976E-18_JPRB, &
  & 0.46993837E-18_JPRB, 0.32907840E-18_JPRB, 0.22849947E-18_JPRB, 0.15764672E-18_JPRB, 0.10842129E-18_JPRB, 0.74680140E-19_JPRB, &
  & 0.51787442E-19_JPRB, 0.36400028E-19_JPRB, 0.26106705E-19_JPRB, 0.19270019E-19_JPRB, 0.14740633E-19_JPRB, 0.11748874E-19_JPRB, &
  & 0.97233441E-20_JPRB, 0.82946820E-20_JPRB, 0.70612338E-20_JPRB, 0.55673226E-20_JPRB /)

RGHG6(:, 9, 3) = (/ &
  & 0.56727422E-17_JPRB, 0.13335283E-16_JPRB, 0.20685428E-16_JPRB, 0.29954149E-16_JPRB, 0.42547656E-16_JPRB, 0.60373928E-16_JPRB, &
  & 0.85707307E-16_JPRB, 0.12197390E-15_JPRB, 0.17254673E-15_JPRB, 0.24164254E-15_JPRB, 0.33332038E-15_JPRB, 0.43417130E-15_JPRB, &
  & 0.55112373E-15_JPRB, 0.69644145E-15_JPRB, 0.86030521E-15_JPRB, 0.10395795E-14_JPRB, 0.12297635E-14_JPRB, 0.14271242E-14_JPRB, &
  & 0.16348292E-14_JPRB, 0.18577302E-14_JPRB, 0.21015554E-14_JPRB, 0.23697343E-14_JPRB, 0.26617979E-14_JPRB, 0.29731193E-14_JPRB, &
  & 0.32942594E-14_JPRB, 0.36224791E-14_JPRB, 0.39553360E-14_JPRB, 0.42954176E-14_JPRB, 0.46408910E-14_JPRB, 0.49776827E-14_JPRB, &
  & 0.52706714E-14_JPRB, 0.54507434E-14_JPRB, 0.54621297E-14_JPRB, 0.53231011E-14_JPRB, 0.49986303E-14_JPRB, 0.45017984E-14_JPRB, &
  & 0.38578035E-14_JPRB, 0.31774607E-14_JPRB, 0.25767176E-14_JPRB, 0.20560450E-14_JPRB, 0.16158716E-14_JPRB, 0.12566024E-14_JPRB, &
  & 0.96565906E-15_JPRB, 0.73367495E-15_JPRB, 0.55540903E-15_JPRB, 0.42120090E-15_JPRB, 0.31986614E-15_JPRB, 0.24226008E-15_JPRB, &
  & 0.18220208E-15_JPRB, 0.13569756E-15_JPRB, 0.10001959E-15_JPRB, 0.73055897E-16_JPRB, 0.53013886E-16_JPRB, 0.38369567E-16_JPRB, &
  & 0.27839032E-16_JPRB, 0.20371819E-16_JPRB, 0.15140592E-16_JPRB, 0.11522141E-16_JPRB, 0.90422554E-17_JPRB, 0.73552743E-17_JPRB, &
  & 0.61912004E-17_JPRB, 0.53295921E-17_JPRB, 0.45964433E-17_JPRB, 0.36201775E-17_JPRB /)

RGHG6(:,10, 3) = (/ &
  & 0.28029186E-14_JPRB, 0.65281969E-14_JPRB, 0.10095274E-13_JPRB, 0.14534814E-13_JPRB, 0.20493512E-13_JPRB, 0.28740963E-13_JPRB, &
  & 0.40130334E-13_JPRB, 0.55852275E-13_JPRB, 0.76781782E-13_JPRB, 0.10381290E-12_JPRB, 0.13737663E-12_JPRB, 0.17052643E-12_JPRB, &
  & 0.20504876E-12_JPRB, 0.24448477E-12_JPRB, 0.28414700E-12_JPRB, 0.32252377E-12_JPRB, 0.35822894E-12_JPRB, 0.39052339E-12_JPRB, &
  & 0.42077160E-12_JPRB, 0.45072916E-12_JPRB, 0.48188000E-12_JPRB, 0.51522399E-12_JPRB, 0.55087244E-12_JPRB, 0.58815317E-12_JPRB, &
  & 0.62634490E-12_JPRB, 0.66539227E-12_JPRB, 0.70597944E-12_JPRB, 0.74886072E-12_JPRB, 0.79438713E-12_JPRB, 0.84060992E-12_JPRB, &
  & 0.88255808E-12_JPRB, 0.90956875E-12_JPRB, 0.91314911E-12_JPRB, 0.89650493E-12_JPRB, 0.85302842E-12_JPRB, 0.78298148E-12_JPRB, &
  & 0.68760319E-12_JPRB, 0.58410405E-12_JPRB, 0.49138932E-12_JPRB, 0.40915052E-12_JPRB, 0.33725523E-12_JPRB, 0.27633841E-12_JPRB, &
  & 0.22440987E-12_JPRB, 0.18084841E-12_JPRB, 0.14532975E-12_JPRB, 0.11730394E-12_JPRB, 0.94870157E-13_JPRB, 0.76549078E-13_JPRB, &
  & 0.61297789E-13_JPRB, 0.48532044E-13_JPRB, 0.37938538E-13_JPRB, 0.29294983E-13_JPRB, 0.22382154E-13_JPRB, 0.16980187E-13_JPRB, &
  & 0.12845184E-13_JPRB, 0.97539867E-14_JPRB, 0.74831795E-14_JPRB, 0.58509292E-14_JPRB, 0.46925981E-14_JPRB, 0.38862812E-14_JPRB, &
  & 0.33073096E-14_JPRB, 0.28815921E-14_JPRB, 0.24879467E-14_JPRB, 0.19803190E-14_JPRB /)

RGHG6(:,11, 3) = (/ &
  & 0.26698538E-13_JPRB, 0.54010588E-13_JPRB, 0.76533696E-13_JPRB, 0.10138495E-12_JPRB, 0.13229356E-12_JPRB, 0.17055315E-12_JPRB, &
  & 0.21797221E-12_JPRB, 0.27580238E-12_JPRB, 0.34495630E-12_JPRB, 0.42705959E-12_JPRB, 0.52639848E-12_JPRB, 0.65320188E-12_JPRB, &
  & 0.79713043E-12_JPRB, 0.94585245E-12_JPRB, 0.11006237E-11_JPRB, 0.12579688E-11_JPRB, 0.14118520E-11_JPRB, 0.15615970E-11_JPRB, &
  & 0.16994738E-11_JPRB, 0.18188554E-11_JPRB, 0.19174220E-11_JPRB, 0.19964288E-11_JPRB, 0.20587095E-11_JPRB, 0.21048638E-11_JPRB, &
  & 0.21353160E-11_JPRB, 0.21499913E-11_JPRB, 0.21602739E-11_JPRB, 0.21741064E-11_JPRB, 0.21948927E-11_JPRB, 0.22145211E-11_JPRB, &
  & 0.22153551E-11_JPRB, 0.21849989E-11_JPRB, 0.21039581E-11_JPRB, 0.19651431E-11_JPRB, 0.17579802E-11_JPRB, 0.15329751E-11_JPRB, &
  & 0.13407987E-11_JPRB, 0.11713141E-11_JPRB, 0.10026209E-11_JPRB, 0.84276574E-12_JPRB, 0.69576078E-12_JPRB, 0.56541273E-12_JPRB, &
  & 0.45563287E-12_JPRB, 0.36835172E-12_JPRB, 0.30150212E-12_JPRB, 0.24952742E-12_JPRB, 0.20845887E-12_JPRB, 0.17472535E-12_JPRB, &
  & 0.14644401E-12_JPRB, 0.12262449E-12_JPRB, 0.10238707E-12_JPRB, 0.84946170E-13_JPRB, 0.69922170E-13_JPRB, 0.57133063E-13_JPRB, &
  & 0.46504480E-13_JPRB, 0.37885365E-13_JPRB, 0.31110829E-13_JPRB, 0.25940181E-13_JPRB, 0.22089862E-13_JPRB, 0.19246059E-13_JPRB, &
  & 0.17191606E-13_JPRB, 0.15500432E-13_JPRB, 0.14020628E-13_JPRB, 0.11749579E-13_JPRB /)

RGHG6(:,12, 3) = (/ &
  & 0.14135160E-12_JPRB, 0.24770740E-12_JPRB, 0.33155491E-12_JPRB, 0.40652743E-12_JPRB, 0.50582243E-12_JPRB, 0.61905738E-12_JPRB, &
  & 0.76045794E-12_JPRB, 0.93355358E-12_JPRB, 0.11402943E-11_JPRB, 0.13827184E-11_JPRB, 0.16603035E-11_JPRB, 0.19710060E-11_JPRB, &
  & 0.23375551E-11_JPRB, 0.27632696E-11_JPRB, 0.32318488E-11_JPRB, 0.37360358E-11_JPRB, 0.42501545E-11_JPRB, 0.47467841E-11_JPRB, &
  & 0.51915256E-11_JPRB, 0.55768116E-11_JPRB, 0.58752352E-11_JPRB, 0.60816296E-11_JPRB, 0.61801866E-11_JPRB, 0.61893732E-11_JPRB, &
  & 0.61264839E-11_JPRB, 0.60079559E-11_JPRB, 0.58484940E-11_JPRB, 0.56718215E-11_JPRB, 0.54933896E-11_JPRB, 0.53092114E-11_JPRB, &
  & 0.50990262E-11_JPRB, 0.48374568E-11_JPRB, 0.45138750E-11_JPRB, 0.41309360E-11_JPRB, 0.37002632E-11_JPRB, 0.32604887E-11_JPRB, &
  & 0.27977438E-11_JPRB, 0.23740528E-11_JPRB, 0.20184765E-11_JPRB, 0.17248041E-11_JPRB, 0.14747924E-11_JPRB, 0.12563060E-11_JPRB, &
  & 0.10634539E-11_JPRB, 0.89636588E-12_JPRB, 0.75331798E-12_JPRB, 0.63425187E-12_JPRB, 0.53416223E-12_JPRB, 0.44986768E-12_JPRB, &
  & 0.37824523E-12_JPRB, 0.31766625E-12_JPRB, 0.26676805E-12_JPRB, 0.22363155E-12_JPRB, 0.18690060E-12_JPRB, 0.15586222E-12_JPRB, &
  & 0.12999121E-12_JPRB, 0.10897070E-12_JPRB, 0.92306317E-13_JPRB, 0.79457315E-13_JPRB, 0.69698574E-13_JPRB, 0.62506681E-13_JPRB, &
  & 0.56911778E-13_JPRB, 0.52611673E-13_JPRB, 0.48227085E-13_JPRB, 0.42181834E-13_JPRB /)

RGHG6(:,13, 3) = (/ &
  & 0.58961793E-12_JPRB, 0.93202204E-12_JPRB, 0.11942482E-11_JPRB, 0.14058748E-11_JPRB, 0.16539673E-11_JPRB, 0.19258445E-11_JPRB, &
  & 0.22424989E-11_JPRB, 0.26165309E-11_JPRB, 0.30597673E-11_JPRB, 0.35884073E-11_JPRB, 0.42193579E-11_JPRB, 0.49599552E-11_JPRB, &
  & 0.57936221E-11_JPRB, 0.67407408E-11_JPRB, 0.78113020E-11_JPRB, 0.89885885E-11_JPRB, 0.10222299E-10_JPRB, 0.11454776E-10_JPRB, &
  & 0.12599479E-10_JPRB, 0.13604759E-10_JPRB, 0.14368741E-10_JPRB, 0.14859830E-10_JPRB, 0.15080808E-10_JPRB, 0.15050874E-10_JPRB, &
  & 0.14805554E-10_JPRB, 0.14384522E-10_JPRB, 0.13829582E-10_JPRB, 0.13167961E-10_JPRB, 0.12425773E-10_JPRB, 0.11623249E-10_JPRB, &
  & 0.10766497E-10_JPRB, 0.98584968E-11_JPRB, 0.89104774E-11_JPRB, 0.79577039E-11_JPRB, 0.69812138E-11_JPRB, 0.60603120E-11_JPRB, &
  & 0.52956359E-11_JPRB, 0.46866777E-11_JPRB, 0.42054723E-11_JPRB, 0.38139908E-11_JPRB, 0.34848699E-11_JPRB, 0.31799249E-11_JPRB, &
  & 0.28852708E-11_JPRB, 0.25882196E-11_JPRB, 0.22942876E-11_JPRB, 0.20028842E-11_JPRB, 0.17288058E-11_JPRB, 0.14816098E-11_JPRB, &
  & 0.12627895E-11_JPRB, 0.10712795E-11_JPRB, 0.90515475E-12_JPRB, 0.76225750E-12_JPRB, 0.63920901E-12_JPRB, 0.53412618E-12_JPRB, &
  & 0.44601868E-12_JPRB, 0.37384993E-12_JPRB, 0.31619856E-12_JPRB, 0.27131428E-12_JPRB, 0.23702817E-12_JPRB, 0.21094185E-12_JPRB, &
  & 0.19167141E-12_JPRB, 0.17532078E-12_JPRB, 0.16087788E-12_JPRB, 0.13855816E-12_JPRB /)

RGHG6(:,14, 3) = (/ &
  & 0.21282308E-11_JPRB, 0.31014874E-11_JPRB, 0.37470149E-11_JPRB, 0.42743894E-11_JPRB, 0.47895728E-11_JPRB, 0.53330990E-11_JPRB, &
  & 0.59344430E-11_JPRB, 0.66244193E-11_JPRB, 0.74280590E-11_JPRB, 0.83734651E-11_JPRB, 0.94880779E-11_JPRB, 0.10805849E-10_JPRB, &
  & 0.12364680E-10_JPRB, 0.14143853E-10_JPRB, 0.16145882E-10_JPRB, 0.18355201E-10_JPRB, 0.20715884E-10_JPRB, 0.23113816E-10_JPRB, &
  & 0.25375849E-10_JPRB, 0.27366403E-10_JPRB, 0.28954469E-10_JPRB, 0.30032629E-10_JPRB, 0.30565547E-10_JPRB, 0.30565092E-10_JPRB, &
  & 0.30097747E-10_JPRB, 0.29221518E-10_JPRB, 0.27979926E-10_JPRB, 0.26443335E-10_JPRB, 0.24668389E-10_JPRB, 0.22714868E-10_JPRB, &
  & 0.20642987E-10_JPRB, 0.18542650E-10_JPRB, 0.16512704E-10_JPRB, 0.14646088E-10_JPRB, 0.12982691E-10_JPRB, 0.11646145E-10_JPRB, &
  & 0.10674751E-10_JPRB, 0.10006511E-10_JPRB, 0.95650189E-11_JPRB, 0.92450596E-11_JPRB, 0.89842474E-11_JPRB, 0.87005281E-11_JPRB, &
  & 0.83598233E-11_JPRB, 0.78901547E-11_JPRB, 0.72859479E-11_JPRB, 0.65648155E-11_JPRB, 0.58078416E-11_JPRB, 0.50869317E-11_JPRB, &
  & 0.44271427E-11_JPRB, 0.38376854E-11_JPRB, 0.33103589E-11_JPRB, 0.28410451E-11_JPRB, 0.24242041E-11_JPRB, 0.20570518E-11_JPRB, &
  & 0.17385802E-11_JPRB, 0.14686724E-11_JPRB, 0.12456831E-11_JPRB, 0.10655859E-11_JPRB, 0.92328857E-12_JPRB, 0.81446807E-12_JPRB, &
  & 0.72866951E-12_JPRB, 0.66144426E-12_JPRB, 0.59530928E-12_JPRB, 0.50644141E-12_JPRB /)

RGHG6(:,15, 3) = (/ &
  & 0.61895610E-11_JPRB, 0.84822305E-11_JPRB, 0.97369213E-11_JPRB, 0.10769925E-10_JPRB, 0.11732114E-10_JPRB, 0.12698405E-10_JPRB, &
  & 0.13716853E-10_JPRB, 0.14825693E-10_JPRB, 0.16060007E-10_JPRB, 0.17485076E-10_JPRB, 0.19171541E-10_JPRB, 0.21176715E-10_JPRB, &
  & 0.23552323E-10_JPRB, 0.26336541E-10_JPRB, 0.29507865E-10_JPRB, 0.33015170E-10_JPRB, 0.36776925E-10_JPRB, 0.40627036E-10_JPRB, &
  & 0.44326515E-10_JPRB, 0.47608865E-10_JPRB, 0.50255286E-10_JPRB, 0.52082470E-10_JPRB, 0.53042917E-10_JPRB, 0.53136606E-10_JPRB, &
  & 0.52452050E-10_JPRB, 0.51049248E-10_JPRB, 0.48920274E-10_JPRB, 0.46214376E-10_JPRB, 0.43036106E-10_JPRB, 0.39529376E-10_JPRB, &
  & 0.35833864E-10_JPRB, 0.32169298E-10_JPRB, 0.28810086E-10_JPRB, 0.25958902E-10_JPRB, 0.23680615E-10_JPRB, 0.22129729E-10_JPRB, &
  & 0.21280960E-10_JPRB, 0.20994075E-10_JPRB, 0.21078998E-10_JPRB, 0.21284462E-10_JPRB, 0.21540042E-10_JPRB, 0.21670081E-10_JPRB, &
  & 0.21472825E-10_JPRB, 0.20804912E-10_JPRB, 0.19638915E-10_JPRB, 0.18104056E-10_JPRB, 0.16386167E-10_JPRB, 0.14659395E-10_JPRB, &
  & 0.13037640E-10_JPRB, 0.11559337E-10_JPRB, 0.10211258E-10_JPRB, 0.89798897E-11_JPRB, 0.78460398E-11_JPRB, 0.68084436E-11_JPRB, &
  & 0.58746228E-11_JPRB, 0.50532599E-11_JPRB, 0.43468488E-11_JPRB, 0.37558862E-11_JPRB, 0.32752217E-11_JPRB, 0.28927646E-11_JPRB, &
  & 0.25967637E-11_JPRB, 0.23469842E-11_JPRB, 0.21189834E-11_JPRB, 0.17896504E-11_JPRB /)

RGHG6(:,16, 3) = (/ &
  & 0.14384019E-10_JPRB, 0.18533224E-10_JPRB, 0.20742869E-10_JPRB, 0.22454271E-10_JPRB, 0.23990409E-10_JPRB, 0.25466499E-10_JPRB, &
  & 0.26958798E-10_JPRB, 0.28550447E-10_JPRB, 0.30323764E-10_JPRB, 0.32375692E-10_JPRB, 0.34791968E-10_JPRB, 0.37643690E-10_JPRB, &
  & 0.40975581E-10_JPRB, 0.44819627E-10_JPRB, 0.49193653E-10_JPRB, 0.54054455E-10_JPRB, 0.59284300E-10_JPRB, 0.64643360E-10_JPRB, &
  & 0.69838288E-10_JPRB, 0.74460021E-10_JPRB, 0.78165183E-10_JPRB, 0.80716309E-10_JPRB, 0.82031132E-10_JPRB, 0.82134105E-10_JPRB, &
  & 0.81128465E-10_JPRB, 0.79073546E-10_JPRB, 0.76171833E-10_JPRB, 0.72285226E-10_JPRB, 0.67573724E-10_JPRB, 0.62401299E-10_JPRB, &
  & 0.57152449E-10_JPRB, 0.51951634E-10_JPRB, 0.47304171E-10_JPRB, 0.43594871E-10_JPRB, 0.40982089E-10_JPRB, 0.39626722E-10_JPRB, &
  & 0.39500903E-10_JPRB, 0.40291097E-10_JPRB, 0.41620353E-10_JPRB, 0.43062037E-10_JPRB, 0.44307020E-10_JPRB, 0.44991684E-10_JPRB, &
  & 0.44935146E-10_JPRB, 0.44023181E-10_JPRB, 0.42217025E-10_JPRB, 0.39635722E-10_JPRB, 0.36565060E-10_JPRB, 0.33356717E-10_JPRB, &
  & 0.30261516E-10_JPRB, 0.27379361E-10_JPRB, 0.24707071E-10_JPRB, 0.22207979E-10_JPRB, 0.19844444E-10_JPRB, 0.17610193E-10_JPRB, &
  & 0.15525182E-10_JPRB, 0.13625030E-10_JPRB, 0.11939126E-10_JPRB, 0.10484499E-10_JPRB, 0.92708818E-11_JPRB, 0.82986656E-11_JPRB, &
  & 0.75129165E-11_JPRB, 0.68665217E-11_JPRB, 0.62420225E-11_JPRB, 0.53673637E-11_JPRB /)

RGHG6(:,17, 3) = (/ &
  & 0.27425383E-10_JPRB, 0.33521918E-10_JPRB, 0.36670500E-10_JPRB, 0.39185231E-10_JPRB, 0.41521002E-10_JPRB, 0.43847703E-10_JPRB, &
  & 0.46242905E-10_JPRB, 0.48778360E-10_JPRB, 0.51511045E-10_JPRB, 0.54546777E-10_JPRB, 0.57964022E-10_JPRB, 0.61821742E-10_JPRB, &
  & 0.66196486E-10_JPRB, 0.71130317E-10_JPRB, 0.76602939E-10_JPRB, 0.82633095E-10_JPRB, 0.89070445E-10_JPRB, 0.95678500E-10_JPRB, &
  & 0.10205656E-09_JPRB, 0.10768952E-09_JPRB, 0.11215067E-09_JPRB, 0.11513425E-09_JPRB, 0.11655388E-09_JPRB, 0.11646141E-09_JPRB, &
  & 0.11498897E-09_JPRB, 0.11238693E-09_JPRB, 0.10843323E-09_JPRB, 0.10362255E-09_JPRB, 0.98314294E-10_JPRB, 0.92306295E-10_JPRB, &
  & 0.85918016E-10_JPRB, 0.79774465E-10_JPRB, 0.74418208E-10_JPRB, 0.70365817E-10_JPRB, 0.67848963E-10_JPRB, 0.67110727E-10_JPRB, &
  & 0.68046249E-10_JPRB, 0.70189091E-10_JPRB, 0.72867705E-10_JPRB, 0.75497837E-10_JPRB, 0.77651489E-10_JPRB, 0.78995969E-10_JPRB, &
  & 0.79174375E-10_JPRB, 0.77932681E-10_JPRB, 0.75215147E-10_JPRB, 0.71257479E-10_JPRB, 0.66567835E-10_JPRB, 0.61652461E-10_JPRB, &
  & 0.56834853E-10_JPRB, 0.52262961E-10_JPRB, 0.47959095E-10_JPRB, 0.43864797E-10_JPRB, 0.39924349E-10_JPRB, 0.36117876E-10_JPRB, &
  & 0.32479519E-10_JPRB, 0.29074066E-10_JPRB, 0.25967187E-10_JPRB, 0.23230405E-10_JPRB, 0.20911741E-10_JPRB, 0.19008163E-10_JPRB, &
  & 0.17477353E-10_JPRB, 0.16172138E-10_JPRB, 0.14914944E-10_JPRB, 0.13115424E-10_JPRB /)

RGHG6(:,18, 3) = (/ &
  & 0.44938914E-10_JPRB, 0.53389210E-10_JPRB, 0.57876225E-10_JPRB, 0.61470468E-10_JPRB, 0.64835991E-10_JPRB, 0.68264797E-10_JPRB, &
  & 0.71861496E-10_JPRB, 0.75687727E-10_JPRB, 0.79757603E-10_JPRB, 0.84138953E-10_JPRB, 0.88911122E-10_JPRB, 0.94016565E-10_JPRB, &
  & 0.99533444E-10_JPRB, 0.10552280E-09_JPRB, 0.11193412E-09_JPRB, 0.11880619E-09_JPRB, 0.12599422E-09_JPRB, 0.13325759E-09_JPRB, &
  & 0.14017196E-09_JPRB, 0.14621102E-09_JPRB, 0.15087843E-09_JPRB, 0.15383425E-09_JPRB, 0.15500523E-09_JPRB, 0.15448538E-09_JPRB, &
  & 0.15252644E-09_JPRB, 0.14927337E-09_JPRB, 0.14510967E-09_JPRB, 0.14063467E-09_JPRB, 0.13498294E-09_JPRB, 0.12892433E-09_JPRB, &
  & 0.12276803E-09_JPRB, 0.11700389E-09_JPRB, 0.11212834E-09_JPRB, 0.10869750E-09_JPRB, 0.10698953E-09_JPRB, 0.10723337E-09_JPRB, &
  & 0.10927787E-09_JPRB, 0.11254138E-09_JPRB, 0.11617986E-09_JPRB, 0.11950825E-09_JPRB, 0.12191226E-09_JPRB, 0.12298505E-09_JPRB, &
  & 0.12242574E-09_JPRB, 0.12005830E-09_JPRB, 0.11591344E-09_JPRB, 0.11035505E-09_JPRB, 0.10396511E-09_JPRB, 0.97279046E-10_JPRB, &
  & 0.90694376E-10_JPRB, 0.84404754E-10_JPRB, 0.78427764E-10_JPRB, 0.72698063E-10_JPRB, 0.67141667E-10_JPRB, 0.61727151E-10_JPRB, &
  & 0.56482440E-10_JPRB, 0.51490385E-10_JPRB, 0.46861112E-10_JPRB, 0.42711418E-10_JPRB, 0.39141683E-10_JPRB, 0.36194655E-10_JPRB, &
  & 0.33773491E-10_JPRB, 0.31683538E-10_JPRB, 0.29674579E-10_JPRB, 0.26646378E-10_JPRB /)

RGHG6(:,19, 3) = (/ &
  & 0.66086088E-10_JPRB, 0.76910818E-10_JPRB, 0.82930801E-10_JPRB, 0.87934715E-10_JPRB, 0.92662357E-10_JPRB, 0.97453552E-10_JPRB, &
  & 0.10246816E-09_JPRB, 0.10781413E-09_JPRB, 0.11348809E-09_JPRB, 0.11949140E-09_JPRB, 0.12587485E-09_JPRB, 0.13244690E-09_JPRB, &
  & 0.13918673E-09_JPRB, 0.14617170E-09_JPRB, 0.15332283E-09_JPRB, 0.16066823E-09_JPRB, 0.16809089E-09_JPRB, 0.17535935E-09_JPRB, &
  & 0.18211321E-09_JPRB, 0.18788109E-09_JPRB, 0.19218740E-09_JPRB, 0.19471313E-09_JPRB, 0.19539524E-09_JPRB, 0.19441734E-09_JPRB, &
  & 0.19207237E-09_JPRB, 0.18878014E-09_JPRB, 0.18522882E-09_JPRB, 0.18055757E-09_JPRB, 0.17595271E-09_JPRB, 0.17128439E-09_JPRB, &
  & 0.16694597E-09_JPRB, 0.16313989E-09_JPRB, 0.16020406E-09_JPRB, 0.15865213E-09_JPRB, 0.15855105E-09_JPRB, 0.15999298E-09_JPRB, &
  & 0.16274841E-09_JPRB, 0.16629055E-09_JPRB, 0.16978939E-09_JPRB, 0.17243126E-09_JPRB, 0.17376127E-09_JPRB, 0.17344505E-09_JPRB, &
  & 0.17125047E-09_JPRB, 0.16708213E-09_JPRB, 0.16106533E-09_JPRB, 0.15363856E-09_JPRB, 0.14539481E-09_JPRB, 0.13694534E-09_JPRB, &
  & 0.12869954E-09_JPRB, 0.12081389E-09_JPRB, 0.11330427E-09_JPRB, 0.10610157E-09_JPRB, 0.99132230E-10_JPRB, 0.92351543E-10_JPRB, &
  & 0.85779987E-10_JPRB, 0.79488721E-10_JPRB, 0.73590557E-10_JPRB, 0.68238741E-10_JPRB, 0.63587018E-10_JPRB, 0.59689781E-10_JPRB, &
  & 0.56427592E-10_JPRB, 0.53636713E-10_JPRB, 0.50770513E-10_JPRB, 0.46681277E-10_JPRB /)

RGHG6(:,20, 3) = (/ &
  & 0.90019617E-10_JPRB, 0.10323689E-09_JPRB, 0.11055584E-09_JPRB, 0.11677906E-09_JPRB, 0.12281087E-09_JPRB, 0.12898747E-09_JPRB, &
  & 0.13548948E-09_JPRB, 0.14239668E-09_JPRB, 0.14970694E-09_JPRB, 0.15733131E-09_JPRB, 0.16528827E-09_JPRB, 0.17329313E-09_JPRB, &
  & 0.18118064E-09_JPRB, 0.18901072E-09_JPRB, 0.19669205E-09_JPRB, 0.20420965E-09_JPRB, 0.21149962E-09_JPRB, 0.21836961E-09_JPRB, &
  & 0.22454846E-09_JPRB, 0.22967676E-09_JPRB, 0.23336585E-09_JPRB, 0.23534971E-09_JPRB, 0.23560059E-09_JPRB, 0.23428734E-09_JPRB, &
  & 0.23179449E-09_JPRB, 0.22876823E-09_JPRB, 0.22511915E-09_JPRB, 0.22185709E-09_JPRB, 0.21910823E-09_JPRB, 0.21696406E-09_JPRB, &
  & 0.21555570E-09_JPRB, 0.21475141E-09_JPRB, 0.21479567E-09_JPRB, 0.21585664E-09_JPRB, 0.21771840E-09_JPRB, 0.22041817E-09_JPRB, &
  & 0.22362986E-09_JPRB, 0.22664289E-09_JPRB, 0.22877286E-09_JPRB, 0.22953212E-09_JPRB, 0.22862533E-09_JPRB, 0.22589522E-09_JPRB, &
  & 0.22126115E-09_JPRB, 0.21474202E-09_JPRB, 0.20656928E-09_JPRB, 0.19720256E-09_JPRB, 0.18727603E-09_JPRB, 0.17732006E-09_JPRB, &
  & 0.16764323E-09_JPRB, 0.15840618E-09_JPRB, 0.14963394E-09_JPRB, 0.14127857E-09_JPRB, 0.13326787E-09_JPRB, 0.12555028E-09_JPRB, &
  & 0.11811660E-09_JPRB, 0.11099958E-09_JPRB, 0.10428838E-09_JPRB, 0.98137387E-10_JPRB, 0.92708514E-10_JPRB, 0.88082881E-10_JPRB, &
  & 0.84220478E-10_JPRB, 0.80718918E-10_JPRB, 0.77356822E-10_JPRB, 0.71983280E-10_JPRB /)

RGHG6(:,21, 3) = (/ &
  & 0.11529089E-09_JPRB, 0.13028231E-09_JPRB, 0.13867726E-09_JPRB, 0.14593786E-09_JPRB, 0.15306605E-09_JPRB, 0.16041433E-09_JPRB, &
  & 0.16815174E-09_JPRB, 0.17637765E-09_JPRB, 0.18504370E-09_JPRB, 0.19402105E-09_JPRB, 0.20321227E-09_JPRB, 0.21236191E-09_JPRB, &
  & 0.22118853E-09_JPRB, 0.22966677E-09_JPRB, 0.23773736E-09_JPRB, 0.24531491E-09_JPRB, 0.25237176E-09_JPRB, 0.25880423E-09_JPRB, &
  & 0.26443056E-09_JPRB, 0.26900060E-09_JPRB, 0.27223632E-09_JPRB, 0.27396016E-09_JPRB, 0.27411495E-09_JPRB, 0.27290353E-09_JPRB, &
  & 0.27078950E-09_JPRB, 0.26795249E-09_JPRB, 0.26532501E-09_JPRB, 0.26348804E-09_JPRB, 0.26263874E-09_JPRB, 0.26293701E-09_JPRB, &
  & 0.26444730E-09_JPRB, 0.26677108E-09_JPRB, 0.26999022E-09_JPRB, 0.27353636E-09_JPRB, 0.27721148E-09_JPRB, 0.28067249E-09_JPRB, &
  & 0.28355215E-09_JPRB, 0.28526595E-09_JPRB, 0.28543901E-09_JPRB, 0.28382136E-09_JPRB, 0.28033251E-09_JPRB, 0.27500807E-09_JPRB, &
  & 0.26791272E-09_JPRB, 0.25920402E-09_JPRB, 0.24914903E-09_JPRB, 0.23823377E-09_JPRB, 0.22696921E-09_JPRB, 0.21580379E-09_JPRB, &
  & 0.20504003E-09_JPRB, 0.19483783E-09_JPRB, 0.18521991E-09_JPRB, 0.17613969E-09_JPRB, 0.16753333E-09_JPRB, 0.15933350E-09_JPRB, &
  & 0.15149756E-09_JPRB, 0.14400871E-09_JPRB, 0.13690833E-09_JPRB, 0.13030770E-09_JPRB, 0.12439313E-09_JPRB, 0.11927219E-09_JPRB, &
  & 0.11481863E-09_JPRB, 0.11093131E-09_JPRB, 0.10675848E-09_JPRB, 0.10081056E-09_JPRB /)

RGHG6(:,22, 3) = (/ &
  & 0.14076881E-09_JPRB, 0.15693397E-09_JPRB, 0.16609455E-09_JPRB, 0.17395141E-09_JPRB, 0.18174705E-09_JPRB, 0.18988457E-09_JPRB, &
  & 0.19849859E-09_JPRB, 0.20763538E-09_JPRB, 0.21723409E-09_JPRB, 0.22711938E-09_JPRB, 0.23712465E-09_JPRB, 0.24701197E-09_JPRB, &
  & 0.25648783E-09_JPRB, 0.26542002E-09_JPRB, 0.27376226E-09_JPRB, 0.28145006E-09_JPRB, 0.28843936E-09_JPRB, 0.29467340E-09_JPRB, &
  & 0.30004846E-09_JPRB, 0.30441599E-09_JPRB, 0.30758807E-09_JPRB, 0.30943770E-09_JPRB, 0.30995220E-09_JPRB, 0.30930991E-09_JPRB, &
  & 0.30768998E-09_JPRB, 0.30578109E-09_JPRB, 0.30419117E-09_JPRB, 0.30349054E-09_JPRB, 0.30407560E-09_JPRB, 0.30625275E-09_JPRB, &
  & 0.30974615E-09_JPRB, 0.31434877E-09_JPRB, 0.31950781E-09_JPRB, 0.32461001E-09_JPRB, 0.32921296E-09_JPRB, 0.33279296E-09_JPRB, &
  & 0.33494235E-09_JPRB, 0.33528030E-09_JPRB, 0.33360176E-09_JPRB, 0.32990907E-09_JPRB, 0.32429681E-09_JPRB, 0.31694625E-09_JPRB, &
  & 0.30804956E-09_JPRB, 0.29783179E-09_JPRB, 0.28658495E-09_JPRB, 0.27469749E-09_JPRB, 0.26262081E-09_JPRB, 0.25077115E-09_JPRB, &
  & 0.23945712E-09_JPRB, 0.22878788E-09_JPRB, 0.21877355E-09_JPRB, 0.20940709E-09_JPRB, 0.20061730E-09_JPRB, 0.19231441E-09_JPRB, &
  & 0.18441935E-09_JPRB, 0.17686752E-09_JPRB, 0.16965371E-09_JPRB, 0.16285857E-09_JPRB, 0.15662441E-09_JPRB, 0.15107726E-09_JPRB, &
  & 0.14624907E-09_JPRB, 0.14170620E-09_JPRB, 0.13727029E-09_JPRB, 0.13010579E-09_JPRB /)

RGHG6(:,23, 3) = (/ &
  & 0.16542785E-09_JPRB, 0.18218282E-09_JPRB, 0.19177668E-09_JPRB, 0.20007256E-09_JPRB, 0.20822996E-09_JPRB, 0.21673513E-09_JPRB, &
  & 0.22579658E-09_JPRB, 0.23540397E-09_JPRB, 0.24546043E-09_JPRB, 0.25581098E-09_JPRB, 0.26623376E-09_JPRB, 0.27651409E-09_JPRB, &
  & 0.28640348E-09_JPRB, 0.29569622E-09_JPRB, 0.30429026E-09_JPRB, 0.31214570E-09_JPRB, 0.31923741E-09_JPRB, 0.32553638E-09_JPRB, &
  & 0.33098510E-09_JPRB, 0.33552086E-09_JPRB, 0.33899622E-09_JPRB, 0.34133471E-09_JPRB, 0.34253322E-09_JPRB, 0.34266273E-09_JPRB, &
  & 0.34197578E-09_JPRB, 0.34097811E-09_JPRB, 0.34024852E-09_JPRB, 0.34040701E-09_JPRB, 0.34200570E-09_JPRB, 0.34507025E-09_JPRB, &
  & 0.34968939E-09_JPRB, 0.35529521E-09_JPRB, 0.36117345E-09_JPRB, 0.36673437E-09_JPRB, 0.37127854E-09_JPRB, 0.37430409E-09_JPRB, &
  & 0.37544831E-09_JPRB, 0.37445480E-09_JPRB, 0.37132411E-09_JPRB, 0.36615933E-09_JPRB, 0.35919268E-09_JPRB, 0.35066205E-09_JPRB, &
  & 0.34084618E-09_JPRB, 0.32996392E-09_JPRB, 0.31825678E-09_JPRB, 0.30605343E-09_JPRB, 0.29377936E-09_JPRB, 0.28184813E-09_JPRB, &
  & 0.27046665E-09_JPRB, 0.25972943E-09_JPRB, 0.24973923E-09_JPRB, 0.24045710E-09_JPRB, 0.23179726E-09_JPRB, 0.22364852E-09_JPRB, &
  & 0.21589533E-09_JPRB, 0.20844367E-09_JPRB, 0.20125158E-09_JPRB, 0.19436032E-09_JPRB, 0.18791371E-09_JPRB, 0.18204036E-09_JPRB, &
  & 0.17668270E-09_JPRB, 0.17180052E-09_JPRB, 0.16650727E-09_JPRB, 0.15871564E-09_JPRB /)

RGHG6(:,24, 3) = (/ &
  & 0.18891848E-09_JPRB, 0.20573392E-09_JPRB, 0.21525132E-09_JPRB, 0.22364614E-09_JPRB, 0.23198865E-09_JPRB, 0.24066055E-09_JPRB, &
  & 0.24985103E-09_JPRB, 0.25959629E-09_JPRB, 0.26977703E-09_JPRB, 0.28022945E-09_JPRB, 0.29078481E-09_JPRB, 0.30120528E-09_JPRB, &
  & 0.31126893E-09_JPRB, 0.32079864E-09_JPRB, 0.32965580E-09_JPRB, 0.33776565E-09_JPRB, 0.34511338E-09_JPRB, 0.35168735E-09_JPRB, &
  & 0.35746009E-09_JPRB, 0.36239858E-09_JPRB, 0.36640468E-09_JPRB, 0.36944336E-09_JPRB, 0.37146117E-09_JPRB, 0.37248779E-09_JPRB, &
  & 0.37279130E-09_JPRB, 0.37267833E-09_JPRB, 0.37272235E-09_JPRB, 0.37353701E-09_JPRB, 0.37555364E-09_JPRB, 0.37903733E-09_JPRB, &
  & 0.38385981E-09_JPRB, 0.38945078E-09_JPRB, 0.39511924E-09_JPRB, 0.40022635E-09_JPRB, 0.40403325E-09_JPRB, 0.40609635E-09_JPRB, &
  & 0.40614195E-09_JPRB, 0.40400616E-09_JPRB, 0.39982750E-09_JPRB, 0.39378276E-09_JPRB, 0.38618109E-09_JPRB, 0.37726294E-09_JPRB, &
  & 0.36729578E-09_JPRB, 0.35646880E-09_JPRB, 0.34495223E-09_JPRB, 0.33303446E-09_JPRB, 0.32108560E-09_JPRB, 0.30941452E-09_JPRB, &
  & 0.29825911E-09_JPRB, 0.28782293E-09_JPRB, 0.27813885E-09_JPRB, 0.26918295E-09_JPRB, 0.26084832E-09_JPRB, 0.25298774E-09_JPRB, &
  & 0.24546309E-09_JPRB, 0.23815980E-09_JPRB, 0.23102274E-09_JPRB, 0.22407685E-09_JPRB, 0.21743746E-09_JPRB, 0.21122323E-09_JPRB, &
  & 0.20549519E-09_JPRB, 0.19996969E-09_JPRB, 0.19430539E-09_JPRB, 0.18529160E-09_JPRB /)

RGHG6(:,25, 3) = (/ &
  & 0.21099363E-09_JPRB, 0.22740271E-09_JPRB, 0.23685431E-09_JPRB, 0.24501645E-09_JPRB, 0.25320604E-09_JPRB, 0.26184765E-09_JPRB, &
  & 0.27099784E-09_JPRB, 0.28063951E-09_JPRB, 0.29070585E-09_JPRB, 0.30106162E-09_JPRB, 0.31154004E-09_JPRB, 0.32198175E-09_JPRB, &
  & 0.33216380E-09_JPRB, 0.34185138E-09_JPRB, 0.35091102E-09_JPRB, 0.35926975E-09_JPRB, 0.36690284E-09_JPRB, 0.37380379E-09_JPRB, &
  & 0.37996373E-09_JPRB, 0.38536827E-09_JPRB, 0.38996523E-09_JPRB, 0.39370365E-09_JPRB, 0.39652495E-09_JPRB, 0.39844422E-09_JPRB, &
  & 0.39966958E-09_JPRB, 0.40039899E-09_JPRB, 0.40117265E-09_JPRB, 0.40244430E-09_JPRB, 0.40468678E-09_JPRB, 0.40813133E-09_JPRB, &
  & 0.41255352E-09_JPRB, 0.41755088E-09_JPRB, 0.42243109E-09_JPRB, 0.42656864E-09_JPRB, 0.42932380E-09_JPRB, 0.43030338E-09_JPRB, &
  & 0.42930678E-09_JPRB, 0.42628451E-09_JPRB, 0.42146017E-09_JPRB, 0.41505813E-09_JPRB, 0.40735834E-09_JPRB, 0.39860124E-09_JPRB, &
  & 0.38900733E-09_JPRB, 0.37869638E-09_JPRB, 0.36778114E-09_JPRB, 0.35647446E-09_JPRB, 0.34507538E-09_JPRB, 0.33391989E-09_JPRB, &
  & 0.32331507E-09_JPRB, 0.31339187E-09_JPRB, 0.30421188E-09_JPRB, 0.29572955E-09_JPRB, 0.28781194E-09_JPRB, 0.28029276E-09_JPRB, &
  & 0.27301569E-09_JPRB, 0.26585970E-09_JPRB, 0.25875740E-09_JPRB, 0.25174091E-09_JPRB, 0.24492278E-09_JPRB, 0.23841926E-09_JPRB, &
  & 0.23226572E-09_JPRB, 0.22636773E-09_JPRB, 0.21998589E-09_JPRB, 0.21007375E-09_JPRB /)

RGHG6(:,26, 3) = (/ &
  & 0.23166481E-09_JPRB, 0.24755192E-09_JPRB, 0.25660551E-09_JPRB, 0.26457592E-09_JPRB, 0.27248456E-09_JPRB, 0.28080074E-09_JPRB, &
  & 0.28974656E-09_JPRB, 0.29915673E-09_JPRB, 0.30894426E-09_JPRB, 0.31903480E-09_JPRB, 0.32931108E-09_JPRB, 0.33960035E-09_JPRB, &
  & 0.34975006E-09_JPRB, 0.35955600E-09_JPRB, 0.36881598E-09_JPRB, 0.37741660E-09_JPRB, 0.38532694E-09_JPRB, 0.39254350E-09_JPRB, &
  & 0.39907005E-09_JPRB, 0.40490181E-09_JPRB, 0.41000622E-09_JPRB, 0.41434234E-09_JPRB, 0.41785705E-09_JPRB, 0.42057482E-09_JPRB, &
  & 0.42260245E-09_JPRB, 0.42413739E-09_JPRB, 0.42553275E-09_JPRB, 0.42719267E-09_JPRB, 0.42954587E-09_JPRB, 0.43265166E-09_JPRB, &
  & 0.43647944E-09_JPRB, 0.44056944E-09_JPRB, 0.44439155E-09_JPRB, 0.44738863E-09_JPRB, 0.44903561E-09_JPRB, 0.44901124E-09_JPRB, &
  & 0.44718368E-09_JPRB, 0.44359616E-09_JPRB, 0.43847137E-09_JPRB, 0.43208495E-09_JPRB, 0.42468465E-09_JPRB, 0.41645082E-09_JPRB, &
  & 0.40752623E-09_JPRB, 0.39797934E-09_JPRB, 0.38785664E-09_JPRB, 0.37732634E-09_JPRB, 0.36665890E-09_JPRB, 0.35622025E-09_JPRB, &
  & 0.34627440E-09_JPRB, 0.33696584E-09_JPRB, 0.32834938E-09_JPRB, 0.32037248E-09_JPRB, 0.31288611E-09_JPRB, 0.30570546E-09_JPRB, &
  & 0.29866065E-09_JPRB, 0.29162614E-09_JPRB, 0.28454611E-09_JPRB, 0.27744859E-09_JPRB, 0.27044778E-09_JPRB, 0.26368369E-09_JPRB, &
  & 0.25721308E-09_JPRB, 0.25087155E-09_JPRB, 0.24404562E-09_JPRB, 0.23327340E-09_JPRB /)

RGHG6(:,27, 3) = (/ &
  & 0.25118604E-09_JPRB, 0.26614719E-09_JPRB, 0.27484298E-09_JPRB, 0.28246872E-09_JPRB, 0.29009828E-09_JPRB, 0.29811326E-09_JPRB, &
  & 0.30663799E-09_JPRB, 0.31571698E-09_JPRB, 0.32514533E-09_JPRB, 0.33488098E-09_JPRB, 0.34486938E-09_JPRB, 0.35499717E-09_JPRB, &
  & 0.36505313E-09_JPRB, 0.37482095E-09_JPRB, 0.38414461E-09_JPRB, 0.39290882E-09_JPRB, 0.40105702E-09_JPRB, 0.40855488E-09_JPRB, &
  & 0.41538703E-09_JPRB, 0.42154305E-09_JPRB, 0.42701917E-09_JPRB, 0.43179338E-09_JPRB, 0.43584142E-09_JPRB, 0.43918444E-09_JPRB, &
  & 0.44188997E-09_JPRB, 0.44411952E-09_JPRB, 0.44608361E-09_JPRB, 0.44809839E-09_JPRB, 0.45040566E-09_JPRB, 0.45314019E-09_JPRB, &
  & 0.45623344E-09_JPRB, 0.45935625E-09_JPRB, 0.46209417E-09_JPRB, 0.46399801E-09_JPRB, 0.46465443E-09_JPRB, 0.46380982E-09_JPRB, &
  & 0.46138682E-09_JPRB, 0.45749463E-09_JPRB, 0.45241641E-09_JPRB, 0.44639073E-09_JPRB, 0.43955120E-09_JPRB, 0.43203968E-09_JPRB, &
  & 0.42394516E-09_JPRB, 0.41526188E-09_JPRB, 0.40603965E-09_JPRB, 0.39635950E-09_JPRB, 0.38651396E-09_JPRB, 0.37683351E-09_JPRB, &
  & 0.36756631E-09_JPRB, 0.35889067E-09_JPRB, 0.35083900E-09_JPRB, 0.34333927E-09_JPRB, 0.33624808E-09_JPRB, 0.32936698E-09_JPRB, &
  & 0.32252376E-09_JPRB, 0.31559902E-09_JPRB, 0.30852101E-09_JPRB, 0.30134786E-09_JPRB, 0.29419256E-09_JPRB, 0.28720906E-09_JPRB, &
  & 0.28047786E-09_JPRB, 0.27385194E-09_JPRB, 0.26671032E-09_JPRB, 0.25516372E-09_JPRB /)

RGHG6(:,28, 3) = (/ &
  & 0.26939787E-09_JPRB, 0.28371153E-09_JPRB, 0.29187619E-09_JPRB, 0.29912411E-09_JPRB, 0.30641045E-09_JPRB, 0.31405004E-09_JPRB, &
  & 0.32220088E-09_JPRB, 0.33080957E-09_JPRB, 0.33981842E-09_JPRB, 0.34914424E-09_JPRB, 0.35877273E-09_JPRB, 0.36859796E-09_JPRB, &
  & 0.37850401E-09_JPRB, 0.38828510E-09_JPRB, 0.39770454E-09_JPRB, 0.40659434E-09_JPRB, 0.41488249E-09_JPRB, 0.42253742E-09_JPRB, &
  & 0.42954448E-09_JPRB, 0.43589299E-09_JPRB, 0.44158721E-09_JPRB, 0.44663195E-09_JPRB, 0.45103010E-09_JPRB, 0.45480678E-09_JPRB, &
  & 0.45800963E-09_JPRB, 0.46074131E-09_JPRB, 0.46313842E-09_JPRB, 0.46539458E-09_JPRB, 0.46763859E-09_JPRB, 0.47000148E-09_JPRB, &
  & 0.47241105E-09_JPRB, 0.47465393E-09_JPRB, 0.47642729E-09_JPRB, 0.47740178E-09_JPRB, 0.47726495E-09_JPRB, 0.47583326E-09_JPRB, &
  & 0.47310295E-09_JPRB, 0.46923143E-09_JPRB, 0.46443069E-09_JPRB, 0.45890095E-09_JPRB, 0.45277559E-09_JPRB, 0.44609622E-09_JPRB, &
  & 0.43888432E-09_JPRB, 0.43112297E-09_JPRB, 0.42277870E-09_JPRB, 0.41398840E-09_JPRB, 0.40496853E-09_JPRB, 0.39603598E-09_JPRB, &
  & 0.38745659E-09_JPRB, 0.37937570E-09_JPRB, 0.37182313E-09_JPRB, 0.36474326E-09_JPRB, 0.35798409E-09_JPRB, 0.35135655E-09_JPRB, &
  & 0.34469966E-09_JPRB, 0.33786798E-09_JPRB, 0.33082653E-09_JPRB, 0.32358252E-09_JPRB, 0.31629488E-09_JPRB, 0.30913450E-09_JPRB, &
  & 0.30219402E-09_JPRB, 0.29537683E-09_JPRB, 0.28792058E-09_JPRB, 0.27606872E-09_JPRB /)

RGHG6(:,29, 3) = (/ &
  & 0.28666386E-09_JPRB, 0.30004954E-09_JPRB, 0.30792388E-09_JPRB, 0.31478142E-09_JPRB, 0.32166661E-09_JPRB, 0.32895736E-09_JPRB, &
  & 0.33665981E-09_JPRB, 0.34482167E-09_JPRB, 0.35335715E-09_JPRB, 0.36224174E-09_JPRB, 0.37147924E-09_JPRB, 0.38103293E-09_JPRB, &
  & 0.39071388E-09_JPRB, 0.40034420E-09_JPRB, 0.40974146E-09_JPRB, 0.41870185E-09_JPRB, 0.42710252E-09_JPRB, 0.43487616E-09_JPRB, &
  & 0.44199427E-09_JPRB, 0.44844545E-09_JPRB, 0.45424808E-09_JPRB, 0.45941964E-09_JPRB, 0.46400384E-09_JPRB, 0.46802756E-09_JPRB, &
  & 0.47154125E-09_JPRB, 0.47458415E-09_JPRB, 0.47724802E-09_JPRB, 0.47961385E-09_JPRB, 0.48176285E-09_JPRB, 0.48377607E-09_JPRB, &
  & 0.48560250E-09_JPRB, 0.48710680E-09_JPRB, 0.48810439E-09_JPRB, 0.48835130E-09_JPRB, 0.48764193E-09_JPRB, 0.48585608E-09_JPRB, &
  & 0.48302679E-09_JPRB, 0.47930832E-09_JPRB, 0.47494508E-09_JPRB, 0.47008553E-09_JPRB, 0.46474916E-09_JPRB, 0.45893017E-09_JPRB, &
  & 0.45261656E-09_JPRB, 0.44572893E-09_JPRB, 0.43828341E-09_JPRB, 0.43032941E-09_JPRB, 0.42211690E-09_JPRB, 0.41391271E-09_JPRB, &
  & 0.40595721E-09_JPRB, 0.39841241E-09_JPRB, 0.39130216E-09_JPRB, 0.38457071E-09_JPRB, 0.37809675E-09_JPRB, 0.37169195E-09_JPRB, &
  & 0.36520370E-09_JPRB, 0.35849468E-09_JPRB, 0.35149217E-09_JPRB, 0.34423076E-09_JPRB, 0.33684014E-09_JPRB, 0.32952274E-09_JPRB, &
  & 0.32241404E-09_JPRB, 0.31543496E-09_JPRB, 0.30793443E-09_JPRB, 0.29572275E-09_JPRB /)

RGHG6(:,30, 3) = (/ &
  & 0.30277936E-09_JPRB, 0.31564740E-09_JPRB, 0.32298136E-09_JPRB, 0.32956854E-09_JPRB, 0.33612765E-09_JPRB, 0.34298511E-09_JPRB, &
  & 0.35028952E-09_JPRB, 0.35798506E-09_JPRB, 0.36602668E-09_JPRB, 0.37445605E-09_JPRB, 0.38326203E-09_JPRB, 0.39240861E-09_JPRB, &
  & 0.40180109E-09_JPRB, 0.41125889E-09_JPRB, 0.42060216E-09_JPRB, 0.42960985E-09_JPRB, 0.43808504E-09_JPRB, 0.44593559E-09_JPRB, &
  & 0.45311313E-09_JPRB, 0.45960347E-09_JPRB, 0.46542772E-09_JPRB, 0.47062954E-09_JPRB, 0.47526388E-09_JPRB, 0.47937393E-09_JPRB, &
  & 0.48301235E-09_JPRB, 0.48616922E-09_JPRB, 0.48893989E-09_JPRB, 0.49128929E-09_JPRB, 0.49329923E-09_JPRB, 0.49499432E-09_JPRB, &
  & 0.49634102E-09_JPRB, 0.49727389E-09_JPRB, 0.49768351E-09_JPRB, 0.49741372E-09_JPRB, 0.49633675E-09_JPRB, 0.49438714E-09_JPRB, &
  & 0.49164772E-09_JPRB, 0.48829768E-09_JPRB, 0.48447896E-09_JPRB, 0.48026277E-09_JPRB, 0.47566656E-09_JPRB, 0.47064674E-09_JPRB, &
  & 0.46515808E-09_JPRB, 0.45911497E-09_JPRB, 0.45246634E-09_JPRB, 0.44531923E-09_JPRB, 0.43785309E-09_JPRB, 0.43031512E-09_JPRB, &
  & 0.42295689E-09_JPRB, 0.41588635E-09_JPRB, 0.40916417E-09_JPRB, 0.40275183E-09_JPRB, 0.39651887E-09_JPRB, 0.39032849E-09_JPRB, &
  & 0.38402378E-09_JPRB, 0.37745909E-09_JPRB, 0.37055947E-09_JPRB, 0.36331765E-09_JPRB, 0.35585768E-09_JPRB, 0.34841025E-09_JPRB, &
  & 0.34117786E-09_JPRB, 0.33410516E-09_JPRB, 0.32646866E-09_JPRB, 0.31421166E-09_JPRB /)

RGHG6(:,31, 3) = (/ &
  & 0.31813313E-09_JPRB, 0.33028413E-09_JPRB, 0.33743242E-09_JPRB, 0.34361769E-09_JPRB, 0.34984582E-09_JPRB, 0.35636996E-09_JPRB, &
  & 0.36322817E-09_JPRB, 0.37048081E-09_JPRB, 0.37805312E-09_JPRB, 0.38599596E-09_JPRB, 0.39438125E-09_JPRB, 0.40320833E-09_JPRB, &
  & 0.41234557E-09_JPRB, 0.42157108E-09_JPRB, 0.43072282E-09_JPRB, 0.43964449E-09_JPRB, 0.44812243E-09_JPRB, 0.45599233E-09_JPRB, &
  & 0.46317317E-09_JPRB, 0.46964810E-09_JPRB, 0.47543186E-09_JPRB, 0.48058091E-09_JPRB, 0.48516424E-09_JPRB, 0.48922244E-09_JPRB, &
  & 0.49282906E-09_JPRB, 0.49593135E-09_JPRB, 0.49866083E-09_JPRB, 0.50088433E-09_JPRB, 0.50272120E-09_JPRB, 0.50412824E-09_JPRB, &
  & 0.50509552E-09_JPRB, 0.50561438E-09_JPRB, 0.50560800E-09_JPRB, 0.50501581E-09_JPRB, 0.50375243E-09_JPRB, 0.50182342E-09_JPRB, &
  & 0.49932275E-09_JPRB, 0.49635612E-09_JPRB, 0.49304621E-09_JPRB, 0.48945875E-09_JPRB, 0.48554116E-09_JPRB, 0.48123050E-09_JPRB, &
  & 0.47645615E-09_JPRB, 0.47112303E-09_JPRB, 0.46521584E-09_JPRB, 0.45878490E-09_JPRB, 0.45200108E-09_JPRB, 0.44510678E-09_JPRB, &
  & 0.43827186E-09_JPRB, 0.43166209E-09_JPRB, 0.42530407E-09_JPRB, 0.41917292E-09_JPRB, 0.41319015E-09_JPRB, 0.40722409E-09_JPRB, &
  & 0.40112669E-09_JPRB, 0.39476691E-09_JPRB, 0.38801928E-09_JPRB, 0.38086817E-09_JPRB, 0.37340875E-09_JPRB, 0.36590422E-09_JPRB, &
  & 0.35857073E-09_JPRB, 0.35146064E-09_JPRB, 0.34383818E-09_JPRB, 0.33149430E-09_JPRB /)

RGHG6(:,32, 3) = (/ &
  & 0.33265052E-09_JPRB, 0.34445524E-09_JPRB, 0.35113507E-09_JPRB, 0.35710176E-09_JPRB, 0.36299727E-09_JPRB, 0.36914444E-09_JPRB, &
  & 0.37564002E-09_JPRB, 0.38243556E-09_JPRB, 0.38954831E-09_JPRB, 0.39702713E-09_JPRB, 0.40492776E-09_JPRB, 0.41327211E-09_JPRB, &
  & 0.42205689E-09_JPRB, 0.43110146E-09_JPRB, 0.44013115E-09_JPRB, 0.44894180E-09_JPRB, 0.45735357E-09_JPRB, 0.46518572E-09_JPRB, &
  & 0.47232651E-09_JPRB, 0.47873577E-09_JPRB, 0.48442789E-09_JPRB, 0.48947346E-09_JPRB, 0.49391274E-09_JPRB, 0.49784249E-09_JPRB, &
  & 0.50126991E-09_JPRB, 0.50421772E-09_JPRB, 0.50677523E-09_JPRB, 0.50881127E-09_JPRB, 0.51043586E-09_JPRB, 0.51159010E-09_JPRB, &
  & 0.51227089E-09_JPRB, 0.51250071E-09_JPRB, 0.51223692E-09_JPRB, 0.51147581E-09_JPRB, 0.51016874E-09_JPRB, 0.50835780E-09_JPRB, &
  & 0.50611504E-09_JPRB, 0.50354720E-09_JPRB, 0.50075105E-09_JPRB, 0.49772836E-09_JPRB, 0.49441035E-09_JPRB, 0.49068793E-09_JPRB, &
  & 0.48647603E-09_JPRB, 0.48172200E-09_JPRB, 0.47641457E-09_JPRB, 0.47061294E-09_JPRB, 0.46445908E-09_JPRB, 0.45811788E-09_JPRB, &
  & 0.45181670E-09_JPRB, 0.44562778E-09_JPRB, 0.43962015E-09_JPRB, 0.43379578E-09_JPRB, 0.42806594E-09_JPRB, 0.42235340E-09_JPRB, &
  & 0.41651455E-09_JPRB, 0.41040474E-09_JPRB, 0.40389717E-09_JPRB, 0.39693238E-09_JPRB, 0.38958481E-09_JPRB, 0.38210660E-09_JPRB, &
  & 0.37482373E-09_JPRB, 0.36772690E-09_JPRB, 0.36012618E-09_JPRB, 0.34781025E-09_JPRB /)

RGHG6(:,33, 3) = (/ &
  & 0.34671160E-09_JPRB, 0.35792305E-09_JPRB, 0.36443609E-09_JPRB, 0.37002629E-09_JPRB, 0.37563075E-09_JPRB, 0.38145342E-09_JPRB, &
  & 0.38755740E-09_JPRB, 0.39392900E-09_JPRB, 0.40057632E-09_JPRB, 0.40757228E-09_JPRB, 0.41501969E-09_JPRB, 0.42295503E-09_JPRB, &
  & 0.43131157E-09_JPRB, 0.44000009E-09_JPRB, 0.44881890E-09_JPRB, 0.45750481E-09_JPRB, 0.46583049E-09_JPRB, 0.47358545E-09_JPRB, &
  & 0.48063897E-09_JPRB, 0.48694548E-09_JPRB, 0.49249999E-09_JPRB, 0.49739352E-09_JPRB, 0.50163335E-09_JPRB, 0.50536603E-09_JPRB, &
  & 0.50854299E-09_JPRB, 0.51125898E-09_JPRB, 0.51356480E-09_JPRB, 0.51537147E-09_JPRB, 0.51676563E-09_JPRB, 0.51769838E-09_JPRB, &
  & 0.51817201E-09_JPRB, 0.51821530E-09_JPRB, 0.51782661E-09_JPRB, 0.51701732E-09_JPRB, 0.51578070E-09_JPRB, 0.51416321E-09_JPRB, &
  & 0.51224180E-09_JPRB, 0.51009996E-09_JPRB, 0.50776183E-09_JPRB, 0.50519050E-09_JPRB, 0.50230964E-09_JPRB, 0.49903109E-09_JPRB, &
  & 0.49526216E-09_JPRB, 0.49094595E-09_JPRB, 0.48610194E-09_JPRB, 0.48080168E-09_JPRB, 0.47516435E-09_JPRB, 0.46937337E-09_JPRB, &
  & 0.46352477E-09_JPRB, 0.45776313E-09_JPRB, 0.45212287E-09_JPRB, 0.44659854E-09_JPRB, 0.44116599E-09_JPRB, 0.43573745E-09_JPRB, &
  & 0.43019477E-09_JPRB, 0.42440365E-09_JPRB, 0.41822237E-09_JPRB, 0.41155723E-09_JPRB, 0.40445847E-09_JPRB, 0.39718884E-09_JPRB, &
  & 0.39003339E-09_JPRB, 0.38307624E-09_JPRB, 0.37559061E-09_JPRB, 0.36332992E-09_JPRB /)

RGHG6(:,34, 3) = (/ &
  & 0.36020212E-09_JPRB, 0.37108250E-09_JPRB, 0.37715159E-09_JPRB, 0.38253320E-09_JPRB, 0.38781853E-09_JPRB, 0.39329573E-09_JPRB, &
  & 0.39904849E-09_JPRB, 0.40499293E-09_JPRB, 0.41118145E-09_JPRB, 0.41767897E-09_JPRB, 0.42460094E-09_JPRB, 0.43204679E-09_JPRB, &
  & 0.44002266E-09_JPRB, 0.44839168E-09_JPRB, 0.45694187E-09_JPRB, 0.46542287E-09_JPRB, 0.47359239E-09_JPRB, 0.48121634E-09_JPRB, &
  & 0.48813997E-09_JPRB, 0.49430460E-09_JPRB, 0.49968707E-09_JPRB, 0.50439253E-09_JPRB, 0.50839871E-09_JPRB, 0.51188676E-09_JPRB, &
  & 0.51477811E-09_JPRB, 0.51721027E-09_JPRB, 0.51922339E-09_JPRB, 0.52076976E-09_JPRB, 0.52192983E-09_JPRB, 0.52266852E-09_JPRB, &
  & 0.52299642E-09_JPRB, 0.52294225E-09_JPRB, 0.52252641E-09_JPRB, 0.52177013E-09_JPRB, 0.52068322E-09_JPRB, 0.51932081E-09_JPRB, &
  & 0.51774185E-09_JPRB, 0.51598403E-09_JPRB, 0.51403271E-09_JPRB, 0.51183069E-09_JPRB, 0.50928350E-09_JPRB, 0.50629928E-09_JPRB, &
  & 0.50280852E-09_JPRB, 0.49880189E-09_JPRB, 0.49430421E-09_JPRB, 0.48941362E-09_JPRB, 0.48424498E-09_JPRB, 0.47889065E-09_JPRB, &
  & 0.47350113E-09_JPRB, 0.46813320E-09_JPRB, 0.46284546E-09_JPRB, 0.45766124E-09_JPRB, 0.45253684E-09_JPRB, 0.44742768E-09_JPRB, &
  & 0.44222528E-09_JPRB, 0.43680132E-09_JPRB, 0.43101964E-09_JPRB, 0.42476653E-09_JPRB, 0.41807457E-09_JPRB, 0.41113862E-09_JPRB, &
  & 0.40429129E-09_JPRB, 0.39755768E-09_JPRB, 0.39023818E-09_JPRB, 0.37816217E-09_JPRB /)

RGHG6(:,35, 3) = (/ &
  & 0.37336431E-09_JPRB, 0.38362744E-09_JPRB, 0.38951944E-09_JPRB, 0.39454270E-09_JPRB, 0.39955828E-09_JPRB, 0.40473347E-09_JPRB, &
  & 0.41009574E-09_JPRB, 0.41562484E-09_JPRB, 0.42134249E-09_JPRB, 0.42733744E-09_JPRB, 0.43374265E-09_JPRB, 0.44066265E-09_JPRB, &
  & 0.44814191E-09_JPRB, 0.45611340E-09_JPRB, 0.46438145E-09_JPRB, 0.47265575E-09_JPRB, 0.48064092E-09_JPRB, 0.48809540E-09_JPRB, &
  & 0.49484722E-09_JPRB, 0.50083448E-09_JPRB, 0.50601973E-09_JPRB, 0.51050641E-09_JPRB, 0.51426213E-09_JPRB, 0.51745552E-09_JPRB, &
  & 0.52003163E-09_JPRB, 0.52213467E-09_JPRB, 0.52381433E-09_JPRB, 0.52507448E-09_JPRB, 0.52599392E-09_JPRB, 0.52655946E-09_JPRB, &
  & 0.52678406E-09_JPRB, 0.52669774E-09_JPRB, 0.52632343E-09_JPRB, 0.52568133E-09_JPRB, 0.52479437E-09_JPRB, 0.52370203E-09_JPRB, &
  & 0.52244331E-09_JPRB, 0.52102433E-09_JPRB, 0.51940385E-09_JPRB, 0.51750809E-09_JPRB, 0.51523086E-09_JPRB, 0.51247590E-09_JPRB, &
  & 0.50920657E-09_JPRB, 0.50540933E-09_JPRB, 0.50118820E-09_JPRB, 0.49662502E-09_JPRB, 0.49182236E-09_JPRB, 0.48688525E-09_JPRB, &
  & 0.48186388E-09_JPRB, 0.47686710E-09_JPRB, 0.47192950E-09_JPRB, 0.46706838E-09_JPRB, 0.46228349E-09_JPRB, 0.45751208E-09_JPRB, &
  & 0.45267273E-09_JPRB, 0.44765611E-09_JPRB, 0.44232684E-09_JPRB, 0.43656523E-09_JPRB, 0.43037243E-09_JPRB, 0.42392545E-09_JPRB, &
  & 0.41747644E-09_JPRB, 0.41106890E-09_JPRB, 0.40403583E-09_JPRB, 0.39223044E-09_JPRB /)

RGHG6(:,36, 3) = (/ &
  & 0.38597650E-09_JPRB, 0.39582340E-09_JPRB, 0.40129777E-09_JPRB, 0.40613138E-09_JPRB, 0.41086473E-09_JPRB, 0.41572207E-09_JPRB, &
  & 0.42072870E-09_JPRB, 0.42582810E-09_JPRB, 0.43106574E-09_JPRB, 0.43653617E-09_JPRB, 0.44239407E-09_JPRB, 0.44878823E-09_JPRB, &
  & 0.45579390E-09_JPRB, 0.46334414E-09_JPRB, 0.47125553E-09_JPRB, 0.47924748E-09_JPRB, 0.48699217E-09_JPRB, 0.49423410E-09_JPRB, &
  & 0.50077714E-09_JPRB, 0.50657301E-09_JPRB, 0.51154997E-09_JPRB, 0.51577664E-09_JPRB, 0.51924109E-09_JPRB, 0.52206867E-09_JPRB, &
  & 0.52426585E-09_JPRB, 0.52597099E-09_JPRB, 0.52728605E-09_JPRB, 0.52823851E-09_JPRB, 0.52892257E-09_JPRB, 0.52933380E-09_JPRB, &
  & 0.52948712E-09_JPRB, 0.52940341E-09_JPRB, 0.52909910E-09_JPRB, 0.52859211E-09_JPRB, 0.52789872E-09_JPRB, 0.52705007E-09_JPRB, &
  & 0.52606247E-09_JPRB, 0.52492527E-09_JPRB, 0.52359034E-09_JPRB, 0.52196952E-09_JPRB, 0.51994842E-09_JPRB, 0.51743948E-09_JPRB, &
  & 0.51437893E-09_JPRB, 0.51082732E-09_JPRB, 0.50684401E-09_JPRB, 0.50258353E-09_JPRB, 0.49811727E-09_JPRB, 0.49350574E-09_JPRB, &
  & 0.48883469E-09_JPRB, 0.48415266E-09_JPRB, 0.47952642E-09_JPRB, 0.47499515E-09_JPRB, 0.47053544E-09_JPRB, 0.46611609E-09_JPRB, &
  & 0.46166196E-09_JPRB, 0.45706913E-09_JPRB, 0.45221066E-09_JPRB, 0.44697776E-09_JPRB, 0.44134896E-09_JPRB, 0.43544840E-09_JPRB, &
  & 0.42949772E-09_JPRB, 0.42350801E-09_JPRB, 0.41682677E-09_JPRB, 0.40548073E-09_JPRB /)

RGHG6(:,37, 3) = (/ &
  & 0.39816922E-09_JPRB, 0.40740147E-09_JPRB, 0.41266487E-09_JPRB, 0.41721498E-09_JPRB, 0.42172554E-09_JPRB, 0.42631426E-09_JPRB, &
  & 0.43094536E-09_JPRB, 0.43562209E-09_JPRB, 0.44037515E-09_JPRB, 0.44531964E-09_JPRB, 0.45061593E-09_JPRB, 0.45642995E-09_JPRB, &
  & 0.46288301E-09_JPRB, 0.46996906E-09_JPRB, 0.47751803E-09_JPRB, 0.48520532E-09_JPRB, 0.49267962E-09_JPRB, 0.49967752E-09_JPRB, &
  & 0.50600474E-09_JPRB, 0.51156968E-09_JPRB, 0.51629945E-09_JPRB, 0.52019911E-09_JPRB, 0.52326593E-09_JPRB, 0.52563565E-09_JPRB, &
  & 0.52737414E-09_JPRB, 0.52866855E-09_JPRB, 0.52962085E-09_JPRB, 0.53030713E-09_JPRB, 0.53079607E-09_JPRB, 0.53109195E-09_JPRB, &
  & 0.53120053E-09_JPRB, 0.53113136E-09_JPRB, 0.53089211E-09_JPRB, 0.53049476E-09_JPRB, 0.52995375E-09_JPRB, 0.52928811E-09_JPRB, &
  & 0.52850507E-09_JPRB, 0.52759019E-09_JPRB, 0.52648985E-09_JPRB, 0.52512078E-09_JPRB, 0.52337157E-09_JPRB, 0.52113341E-09_JPRB, &
  & 0.51837529E-09_JPRB, 0.51508653E-09_JPRB, 0.51141752E-09_JPRB, 0.50745230E-09_JPRB, 0.50330112E-09_JPRB, 0.49900611E-09_JPRB, &
  & 0.49461729E-09_JPRB, 0.49021281E-09_JPRB, 0.48586951E-09_JPRB, 0.48162485E-09_JPRB, 0.47748999E-09_JPRB, 0.47342247E-09_JPRB, &
  & 0.46935378E-09_JPRB, 0.46518944E-09_JPRB, 0.46081067E-09_JPRB, 0.45610801E-09_JPRB, 0.45105494E-09_JPRB, 0.44574194E-09_JPRB, &
  & 0.44033982E-09_JPRB, 0.43483039E-09_JPRB, 0.42861187E-09_JPRB, 0.41787226E-09_JPRB /)

RGHG6(:,38, 3) = (/ &
  & 0.40984000E-09_JPRB, 0.41853532E-09_JPRB, 0.42347359E-09_JPRB, 0.42783677E-09_JPRB, 0.43214685E-09_JPRB, 0.43647436E-09_JPRB, &
  & 0.44076573E-09_JPRB, 0.44501777E-09_JPRB, 0.44928328E-09_JPRB, 0.45369106E-09_JPRB, 0.45842241E-09_JPRB, 0.46366472E-09_JPRB, &
  & 0.46955906E-09_JPRB, 0.47612997E-09_JPRB, 0.48323451E-09_JPRB, 0.49056770E-09_JPRB, 0.49773513E-09_JPRB, 0.50445403E-09_JPRB, &
  & 0.51051513E-09_JPRB, 0.51579724E-09_JPRB, 0.52017995E-09_JPRB, 0.52364518E-09_JPRB, 0.52622212E-09_JPRB, 0.52810006E-09_JPRB, &
  & 0.52941063E-09_JPRB, 0.53035704E-09_JPRB, 0.53104576E-09_JPRB, 0.53154448E-09_JPRB, 0.53190868E-09_JPRB, 0.53213445E-09_JPRB, &
  & 0.53222088E-09_JPRB, 0.53216653E-09_JPRB, 0.53197391E-09_JPRB, 0.53165206E-09_JPRB, 0.53121318E-09_JPRB, 0.53067278E-09_JPRB, &
  & 0.53003379E-09_JPRB, 0.52927779E-09_JPRB, 0.52835913E-09_JPRB, 0.52719973E-09_JPRB, 0.52569543E-09_JPRB, 0.52375260E-09_JPRB, &
  & 0.52129878E-09_JPRB, 0.51837029E-09_JPRB, 0.51502141E-09_JPRB, 0.51139865E-09_JPRB, 0.50755711E-09_JPRB, 0.50355603E-09_JPRB, &
  & 0.49943094E-09_JPRB, 0.49527127E-09_JPRB, 0.49116067E-09_JPRB, 0.48718285E-09_JPRB, 0.48334420E-09_JPRB, 0.47961601E-09_JPRB, &
  & 0.47592963E-09_JPRB, 0.47218690E-09_JPRB, 0.46827869E-09_JPRB, 0.46409823E-09_JPRB, 0.45961507E-09_JPRB, 0.45490145E-09_JPRB, &
  & 0.45007509E-09_JPRB, 0.44511356E-09_JPRB, 0.43942214E-09_JPRB, 0.42947268E-09_JPRB /)

RGHG6(:,39, 3) = (/ &
  & 0.42105081E-09_JPRB, 0.42915452E-09_JPRB, 0.43379753E-09_JPRB, 0.43796439E-09_JPRB, 0.44208179E-09_JPRB, 0.44618245E-09_JPRB, &
  & 0.45015128E-09_JPRB, 0.45399090E-09_JPRB, 0.45777601E-09_JPRB, 0.46165646E-09_JPRB, 0.46581106E-09_JPRB, 0.47044874E-09_JPRB, &
  & 0.47575210E-09_JPRB, 0.48179238E-09_JPRB, 0.48843751E-09_JPRB, 0.49537269E-09_JPRB, 0.50221916E-09_JPRB, 0.50862914E-09_JPRB, &
  & 0.51436039E-09_JPRB, 0.51923610E-09_JPRB, 0.52314775E-09_JPRB, 0.52610166E-09_JPRB, 0.52819882E-09_JPRB, 0.52966315E-09_JPRB, &
  & 0.53065924E-09_JPRB, 0.53137655E-09_JPRB, 0.53189780E-09_JPRB, 0.53228766E-09_JPRB, 0.53258026E-09_JPRB, 0.53276816E-09_JPRB, &
  & 0.53284521E-09_JPRB, 0.53280352E-09_JPRB, 0.53264182E-09_JPRB, 0.53236832E-09_JPRB, 0.53199656E-09_JPRB, 0.53153898E-09_JPRB, &
  & 0.53099908E-09_JPRB, 0.53035620E-09_JPRB, 0.52957039E-09_JPRB, 0.52857213E-09_JPRB, 0.52727162E-09_JPRB, 0.52557342E-09_JPRB, &
  & 0.52342830E-09_JPRB, 0.52081922E-09_JPRB, 0.51783333E-09_JPRB, 0.51454485E-09_JPRB, 0.51103788E-09_JPRB, 0.50732946E-09_JPRB, &
  & 0.50347215E-09_JPRB, 0.49952253E-09_JPRB, 0.49562821E-09_JPRB, 0.49187315E-09_JPRB, 0.48830168E-09_JPRB, 0.48488996E-09_JPRB, &
  & 0.48156223E-09_JPRB, 0.47822984E-09_JPRB, 0.47477006E-09_JPRB, 0.47109694E-09_JPRB, 0.46717241E-09_JPRB, 0.46305471E-09_JPRB, &
  & 0.45883436E-09_JPRB, 0.45444354E-09_JPRB, 0.44937162E-09_JPRB, 0.44034434E-09_JPRB /)

RGHG6(:,40, 3) = (/ &
  & 0.43180476E-09_JPRB, 0.43925441E-09_JPRB, 0.44360748E-09_JPRB, 0.44753512E-09_JPRB, 0.45150039E-09_JPRB, 0.45537488E-09_JPRB, &
  & 0.45904180E-09_JPRB, 0.46248375E-09_JPRB, 0.46581244E-09_JPRB, 0.46916437E-09_JPRB, 0.47276288E-09_JPRB, 0.47681342E-09_JPRB, &
  & 0.48152421E-09_JPRB, 0.48700194E-09_JPRB, 0.49316007E-09_JPRB, 0.49966498E-09_JPRB, 0.50611748E-09_JPRB, 0.51216148E-09_JPRB, &
  & 0.51750576E-09_JPRB, 0.52191867E-09_JPRB, 0.52530902E-09_JPRB, 0.52777838E-09_JPRB, 0.52948101E-09_JPRB, 0.53065163E-09_JPRB, &
  & 0.53144167E-09_JPRB, 0.53201682E-09_JPRB, 0.53243920E-09_JPRB, 0.53276500E-09_JPRB, 0.53301702E-09_JPRB, 0.53318461E-09_JPRB, &
  & 0.53325794E-09_JPRB, 0.53322552E-09_JPRB, 0.53308441E-09_JPRB, 0.53284283E-09_JPRB, 0.53251492E-09_JPRB, 0.53211557E-09_JPRB, &
  & 0.53164328E-09_JPRB, 0.53108345E-09_JPRB, 0.53039573E-09_JPRB, 0.52952176E-09_JPRB, 0.52837817E-09_JPRB, 0.52688676E-09_JPRB, &
  & 0.52498800E-09_JPRB, 0.52268312E-09_JPRB, 0.52001581E-09_JPRB, 0.51706722E-09_JPRB, 0.51388671E-09_JPRB, 0.51049226E-09_JPRB, &
  & 0.50688576E-09_JPRB, 0.50316934E-09_JPRB, 0.49945248E-09_JPRB, 0.49589316E-09_JPRB, 0.49255727E-09_JPRB, 0.48942367E-09_JPRB, &
  & 0.48643251E-09_JPRB, 0.48347260E-09_JPRB, 0.48044368E-09_JPRB, 0.47724685E-09_JPRB, 0.47386572E-09_JPRB, 0.47033760E-09_JPRB, &
  & 0.46671678E-09_JPRB, 0.46294230E-09_JPRB, 0.45850887E-09_JPRB, 0.45055676E-09_JPRB /)

RGHG6(:,41, 3) = (/ &
  & 0.44204984E-09_JPRB, 0.44886617E-09_JPRB, 0.45284557E-09_JPRB, 0.45657267E-09_JPRB, 0.46032980E-09_JPRB, 0.46400223E-09_JPRB, &
  & 0.46738163E-09_JPRB, 0.47045701E-09_JPRB, 0.47333509E-09_JPRB, 0.47620330E-09_JPRB, 0.47925036E-09_JPRB, 0.48272458E-09_JPRB, &
  & 0.48685739E-09_JPRB, 0.49178900E-09_JPRB, 0.49745019E-09_JPRB, 0.50353827E-09_JPRB, 0.50959093E-09_JPRB, 0.51521531E-09_JPRB, &
  & 0.52007287E-09_JPRB, 0.52398014E-09_JPRB, 0.52688648E-09_JPRB, 0.52894328E-09_JPRB, 0.53035176E-09_JPRB, 0.53131466E-09_JPRB, &
  & 0.53197130E-09_JPRB, 0.53245547E-09_JPRB, 0.53281596E-09_JPRB, 0.53310328E-09_JPRB, 0.53333005E-09_JPRB, 0.53348570E-09_JPRB, &
  & 0.53355720E-09_JPRB, 0.53353133E-09_JPRB, 0.53340415E-09_JPRB, 0.53318439E-09_JPRB, 0.53288812E-09_JPRB, 0.53252791E-09_JPRB, &
  & 0.53210752E-09_JPRB, 0.53160765E-09_JPRB, 0.53099758E-09_JPRB, 0.53022048E-09_JPRB, 0.52920768E-09_JPRB, 0.52788296E-09_JPRB, &
  & 0.52620119E-09_JPRB, 0.52414717E-09_JPRB, 0.52176907E-09_JPRB, 0.51913068E-09_JPRB, 0.51626170E-09_JPRB, 0.51316484E-09_JPRB, &
  & 0.50984406E-09_JPRB, 0.50633431E-09_JPRB, 0.50280485E-09_JPRB, 0.49942256E-09_JPRB, 0.49628207E-09_JPRB, 0.49340554E-09_JPRB, &
  & 0.49070675E-09_JPRB, 0.48809429E-09_JPRB, 0.48545185E-09_JPRB, 0.48270798E-09_JPRB, 0.47983595E-09_JPRB, 0.47687182E-09_JPRB, &
  & 0.47384396E-09_JPRB, 0.47066118E-09_JPRB, 0.46690762E-09_JPRB, 0.46007137E-09_JPRB /)

RGHG6(:,42, 3) = (/ &
  & 0.45176451E-09_JPRB, 0.45790055E-09_JPRB, 0.46155990E-09_JPRB, 0.46500181E-09_JPRB, 0.46857551E-09_JPRB, 0.47203580E-09_JPRB, &
  & 0.47513521E-09_JPRB, 0.47786575E-09_JPRB, 0.48034066E-09_JPRB, 0.48274823E-09_JPRB, 0.48530213E-09_JPRB, 0.48824034E-09_JPRB, &
  & 0.49181020E-09_JPRB, 0.49621157E-09_JPRB, 0.50138588E-09_JPRB, 0.50702498E-09_JPRB, 0.51267984E-09_JPRB, 0.51785504E-09_JPRB, &
  & 0.52222521E-09_JPRB, 0.52560828E-09_JPRB, 0.52807292E-09_JPRB, 0.52979782E-09_JPRB, 0.53097993E-09_JPRB, 0.53179600E-09_JPRB, &
  & 0.53236104E-09_JPRB, 0.53278360E-09_JPRB, 0.53310384E-09_JPRB, 0.53336535E-09_JPRB, 0.53357574E-09_JPRB, 0.53372284E-09_JPRB, &
  & 0.53379240E-09_JPRB, 0.53377058E-09_JPRB, 0.53365345E-09_JPRB, 0.53345001E-09_JPRB, 0.53317556E-09_JPRB, 0.53284632E-09_JPRB, &
  & 0.53246185E-09_JPRB, 0.53201099E-09_JPRB, 0.53146060E-09_JPRB, 0.53076604E-09_JPRB, 0.52986227E-09_JPRB, 0.52868748E-09_JPRB, &
  & 0.52719279E-09_JPRB, 0.52536742E-09_JPRB, 0.52324273E-09_JPRB, 0.52087235E-09_JPRB, 0.51829496E-09_JPRB, 0.51548815E-09_JPRB, &
  & 0.51242888E-09_JPRB, 0.50916066E-09_JPRB, 0.50581622E-09_JPRB, 0.50259497E-09_JPRB, 0.49965587E-09_JPRB, 0.49699839E-09_JPRB, &
  & 0.49457194E-09_JPRB, 0.49226379E-09_JPRB, 0.48997661E-09_JPRB, 0.48763654E-09_JPRB, 0.48523380E-09_JPRB, 0.48278681E-09_JPRB, &
  & 0.48030269E-09_JPRB, 0.47769072E-09_JPRB, 0.47457427E-09_JPRB, 0.46885756E-09_JPRB /)

RGHG6(:,43, 3) = (/ &
  & 0.46091744E-09_JPRB, 0.46639442E-09_JPRB, 0.46969362E-09_JPRB, 0.47286913E-09_JPRB, 0.47621446E-09_JPRB, 0.47944587E-09_JPRB, &
  & 0.48230592E-09_JPRB, 0.48471049E-09_JPRB, 0.48683085E-09_JPRB, 0.48883775E-09_JPRB, 0.49095117E-09_JPRB, 0.49339749E-09_JPRB, &
  & 0.49647170E-09_JPRB, 0.50035132E-09_JPRB, 0.50507593E-09_JPRB, 0.51028370E-09_JPRB, 0.51548094E-09_JPRB, 0.52018667E-09_JPRB, &
  & 0.52402338E-09_JPRB, 0.52692350E-09_JPRB, 0.52900018E-09_JPRB, 0.53045091E-09_JPRB, 0.53146143E-09_JPRB, 0.53216698E-09_JPRB, &
  & 0.53266702E-09_JPRB, 0.53304638E-09_JPRB, 0.53333887E-09_JPRB, 0.53358346E-09_JPRB, 0.53378130E-09_JPRB, 0.53392191E-09_JPRB, &
  & 0.53398874E-09_JPRB, 0.53396920E-09_JPRB, 0.53385923E-09_JPRB, 0.53366755E-09_JPRB, 0.53341082E-09_JPRB, 0.53310284E-09_JPRB, &
  & 0.53274823E-09_JPRB, 0.53233357E-09_JPRB, 0.53183413E-09_JPRB, 0.53120824E-09_JPRB, 0.53040333E-09_JPRB, 0.52936244E-09_JPRB, &
  & 0.52804577E-09_JPRB, 0.52643107E-09_JPRB, 0.52453963E-09_JPRB, 0.52242022E-09_JPRB, 0.52009608E-09_JPRB, 0.51755566E-09_JPRB, &
  & 0.51476318E-09_JPRB, 0.51172849E-09_JPRB, 0.50858617E-09_JPRB, 0.50556437E-09_JPRB, 0.50280746E-09_JPRB, 0.50037574E-09_JPRB, &
  & 0.49818977E-09_JPRB, 0.49615462E-09_JPRB, 0.49417470E-09_JPRB, 0.49219229E-09_JPRB, 0.49019760E-09_JPRB, 0.48820420E-09_JPRB, &
  & 0.48620008E-09_JPRB, 0.48408716E-09_JPRB, 0.48155363E-09_JPRB, 0.47687027E-09_JPRB /)

RGHG6(:,44, 3) = (/ &
  & 0.46938603E-09_JPRB, 0.47432408E-09_JPRB, 0.47724441E-09_JPRB, 0.48016946E-09_JPRB, 0.48325161E-09_JPRB, 0.48630339E-09_JPRB, &
  & 0.48888976E-09_JPRB, 0.49105403E-09_JPRB, 0.49285021E-09_JPRB, 0.49452992E-09_JPRB, 0.49626075E-09_JPRB, 0.49830229E-09_JPRB, &
  & 0.50088511E-09_JPRB, 0.50432880E-09_JPRB, 0.50858429E-09_JPRB, 0.51337645E-09_JPRB, 0.51811710E-09_JPRB, 0.52227134E-09_JPRB, &
  & 0.52557692E-09_JPRB, 0.52800192E-09_JPRB, 0.52974192E-09_JPRB, 0.53096921E-09_JPRB, 0.53184324E-09_JPRB, 0.53246446E-09_JPRB, &
  & 0.53291843E-09_JPRB, 0.53326588E-09_JPRB, 0.53354032E-09_JPRB, 0.53377258E-09_JPRB, 0.53396199E-09_JPRB, 0.53409599E-09_JPRB, &
  & 0.53415927E-09_JPRB, 0.53414012E-09_JPRB, 0.53403504E-09_JPRB, 0.53385291E-09_JPRB, 0.53360855E-09_JPRB, 0.53331783E-09_JPRB, &
  & 0.53298427E-09_JPRB, 0.53260008E-09_JPRB, 0.53214128E-09_JPRB, 0.53157606E-09_JPRB, 0.53085841E-09_JPRB, 0.52994492E-09_JPRB, &
  & 0.52879773E-09_JPRB, 0.52739224E-09_JPRB, 0.52572940E-09_JPRB, 0.52384075E-09_JPRB, 0.52175830E-09_JPRB, 0.51946358E-09_JPRB, &
  & 0.51691990E-09_JPRB, 0.51412791E-09_JPRB, 0.51122018E-09_JPRB, 0.50840127E-09_JPRB, 0.50587434E-09_JPRB, 0.50365323E-09_JPRB, &
  & 0.50169230E-09_JPRB, 0.49989690E-09_JPRB, 0.49818050E-09_JPRB, 0.49649884E-09_JPRB, 0.49484716E-09_JPRB, 0.49323057E-09_JPRB, &
  & 0.49162413E-09_JPRB, 0.48993665E-09_JPRB, 0.48790011E-09_JPRB, 0.48411736E-09_JPRB /)

RGHG6(:,45, 3) = (/ &
  & 0.47727644E-09_JPRB, 0.48156901E-09_JPRB, 0.48429133E-09_JPRB, 0.48688387E-09_JPRB, 0.48979637E-09_JPRB, 0.49259558E-09_JPRB, &
  & 0.49503346E-09_JPRB, 0.49692089E-09_JPRB, 0.49849458E-09_JPRB, 0.49988169E-09_JPRB, 0.50132060E-09_JPRB, 0.50299065E-09_JPRB, &
  & 0.50520221E-09_JPRB, 0.50817006E-09_JPRB, 0.51204307E-09_JPRB, 0.51636900E-09_JPRB, 0.52057986E-09_JPRB, 0.52415794E-09_JPRB, &
  & 0.52689281E-09_JPRB, 0.52889670E-09_JPRB, 0.53034055E-09_JPRB, 0.53138527E-09_JPRB, 0.53215066E-09_JPRB, 0.53270943E-09_JPRB, &
  & 0.53312865E-09_JPRB, 0.53345428E-09_JPRB, 0.53371751E-09_JPRB, 0.53394172E-09_JPRB, 0.53412386E-09_JPRB, 0.53425209E-09_JPRB, &
  & 0.53431010E-09_JPRB, 0.53428967E-09_JPRB, 0.53418797E-09_JPRB, 0.53401228E-09_JPRB, 0.53377780E-09_JPRB, 0.53349886E-09_JPRB, &
  & 0.53318266E-09_JPRB, 0.53282095E-09_JPRB, 0.53239763E-09_JPRB, 0.53188326E-09_JPRB, 0.53124577E-09_JPRB, 0.53044946E-09_JPRB, &
  & 0.52946952E-09_JPRB, 0.52827598E-09_JPRB, 0.52685389E-09_JPRB, 0.52521021E-09_JPRB, 0.52336158E-09_JPRB, 0.52130417E-09_JPRB, &
  & 0.51899091E-09_JPRB, 0.51644211E-09_JPRB, 0.51376409E-09_JPRB, 0.51121524E-09_JPRB, 0.50890742E-09_JPRB, 0.50691723E-09_JPRB, &
  & 0.50516680E-09_JPRB, 0.50357718E-09_JPRB, 0.50208476E-09_JPRB, 0.50064830E-09_JPRB, 0.49927223E-09_JPRB, 0.49795656E-09_JPRB, &
  & 0.49666898E-09_JPRB, 0.49531917E-09_JPRB, 0.49369087E-09_JPRB, 0.49065385E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART5',1,ZHOOK_HANDLE)
END SUBROUTINE PART5




SUBROUTINE PART6
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART6',0,ZHOOK_HANDLE)



RGHG6(:,46, 3) = (/ &
  & 0.48437743E-09_JPRB, 0.48835602E-09_JPRB, 0.49070742E-09_JPRB, 0.49317939E-09_JPRB, 0.49581955E-09_JPRB, 0.49849336E-09_JPRB, &
  & 0.50070648E-09_JPRB, 0.50243604E-09_JPRB, 0.50377913E-09_JPRB, 0.50496463E-09_JPRB, 0.50615362E-09_JPRB, 0.50755344E-09_JPRB, &
  & 0.50940346E-09_JPRB, 0.51201238E-09_JPRB, 0.51542881E-09_JPRB, 0.51928029E-09_JPRB, 0.52288512E-09_JPRB, 0.52580607E-09_JPRB, &
  & 0.52801702E-09_JPRB, 0.52962595E-09_JPRB, 0.53082583E-09_JPRB, 0.53172095E-09_JPRB, 0.53240140E-09_JPRB, 0.53291166E-09_JPRB, &
  & 0.53330773E-09_JPRB, 0.53361937E-09_JPRB, 0.53387555E-09_JPRB, 0.53409527E-09_JPRB, 0.53427196E-09_JPRB, 0.53439275E-09_JPRB, &
  & 0.53444510E-09_JPRB, 0.53442178E-09_JPRB, 0.53432142E-09_JPRB, 0.53415067E-09_JPRB, 0.53392246E-09_JPRB, 0.53365318E-09_JPRB, &
  & 0.53334848E-09_JPRB, 0.53300669E-09_JPRB, 0.53261068E-09_JPRB, 0.53214233E-09_JPRB, 0.53157423E-09_JPRB, 0.53088894E-09_JPRB, &
  & 0.53006810E-09_JPRB, 0.52909327E-09_JPRB, 0.52793292E-09_JPRB, 0.52656640E-09_JPRB, 0.52498300E-09_JPRB, 0.52315718E-09_JPRB, &
  & 0.52107740E-09_JPRB, 0.51873628E-09_JPRB, 0.51633048E-09_JPRB, 0.51400495E-09_JPRB, 0.51197951E-09_JPRB, 0.51019994E-09_JPRB, &
  & 0.50864868E-09_JPRB, 0.50724813E-09_JPRB, 0.50593668E-09_JPRB, 0.50470106E-09_JPRB, 0.50354027E-09_JPRB, 0.50245763E-09_JPRB, &
  & 0.50141347E-09_JPRB, 0.50033122E-09_JPRB, 0.49901933E-09_JPRB, 0.49658294E-09_JPRB /)

RGHG6(:,47, 3) = (/ &
  & 0.49091914E-09_JPRB, 0.49448295E-09_JPRB, 0.49673632E-09_JPRB, 0.49895493E-09_JPRB, 0.50147830E-09_JPRB, 0.50396443E-09_JPRB, &
  & 0.50604054E-09_JPRB, 0.50758742E-09_JPRB, 0.50877202E-09_JPRB, 0.50978310E-09_JPRB, 0.51078808E-09_JPRB, 0.51196863E-09_JPRB, &
  & 0.51354454E-09_JPRB, 0.51580373E-09_JPRB, 0.51877097E-09_JPRB, 0.52203913E-09_JPRB, 0.52494054E-09_JPRB, 0.52723204E-09_JPRB, &
  & 0.52893473E-09_JPRB, 0.53022453E-09_JPRB, 0.53121552E-09_JPRB, 0.53199228E-09_JPRB, 0.53260502E-09_JPRB, 0.53308269E-09_JPRB, &
  & 0.53346233E-09_JPRB, 0.53376525E-09_JPRB, 0.53402066E-09_JPRB, 0.53423627E-09_JPRB, 0.53440735E-09_JPRB, 0.53452121E-09_JPRB, &
  & 0.53456600E-09_JPRB, 0.53453847E-09_JPRB, 0.53443838E-09_JPRB, 0.53427013E-09_JPRB, 0.53404692E-09_JPRB, 0.53378341E-09_JPRB, &
  & 0.53348947E-09_JPRB, 0.53316140E-09_JPRB, 0.53279070E-09_JPRB, 0.53235949E-09_JPRB, 0.53185523E-09_JPRB, 0.53126747E-09_JPRB, &
  & 0.53059895E-09_JPRB, 0.52983690E-09_JPRB, 0.52895843E-09_JPRB, 0.52791072E-09_JPRB, 0.52664190E-09_JPRB, 0.52510063E-09_JPRB, &
  & 0.52323318E-09_JPRB, 0.52113286E-09_JPRB, 0.51891375E-09_JPRB, 0.51689647E-09_JPRB, 0.51507715E-09_JPRB, 0.51353327E-09_JPRB, &
  & 0.51216331E-09_JPRB, 0.51092214E-09_JPRB, 0.50977095E-09_JPRB, 0.50869042E-09_JPRB, 0.50769916E-09_JPRB, 0.50679227E-09_JPRB, &
  & 0.50593457E-09_JPRB, 0.50504878E-09_JPRB, 0.50398397E-09_JPRB, 0.50200172E-09_JPRB /)

RGHG6(:,48, 3) = (/ &
  & 0.49685656E-09_JPRB, 0.50018079E-09_JPRB, 0.50227156E-09_JPRB, 0.50439103E-09_JPRB, 0.50677124E-09_JPRB, 0.50912763E-09_JPRB, &
  & 0.51106214E-09_JPRB, 0.51246163E-09_JPRB, 0.51350763E-09_JPRB, 0.51438009E-09_JPRB, 0.51524329E-09_JPRB, 0.51624682E-09_JPRB, &
  & 0.51759774E-09_JPRB, 0.51947835E-09_JPRB, 0.52196897E-09_JPRB, 0.52450572E-09_JPRB, 0.52670474E-09_JPRB, 0.52838889E-09_JPRB, &
  & 0.52968657E-09_JPRB, 0.53070137E-09_JPRB, 0.53152904E-09_JPRB, 0.53221105E-09_JPRB, 0.53277333E-09_JPRB, 0.53322818E-09_JPRB, &
  & 0.53359844E-09_JPRB, 0.53389992E-09_JPRB, 0.53415322E-09_JPRB, 0.53436755E-09_JPRB, 0.53453286E-09_JPRB, 0.53463750E-09_JPRB, &
  & 0.53467475E-09_JPRB, 0.53464222E-09_JPRB, 0.53454058E-09_JPRB, 0.53437366E-09_JPRB, 0.53415350E-09_JPRB, 0.53389537E-09_JPRB, &
  & 0.53360860E-09_JPRB, 0.53329396E-09_JPRB, 0.53294225E-09_JPRB, 0.53254495E-09_JPRB, 0.53209359E-09_JPRB, 0.53159466E-09_JPRB, &
  & 0.53105886E-09_JPRB, 0.53049543E-09_JPRB, 0.52988258E-09_JPRB, 0.52917370E-09_JPRB, 0.52826671E-09_JPRB, 0.52706223E-09_JPRB, &
  & 0.52550414E-09_JPRB, 0.52360483E-09_JPRB, 0.52168547E-09_JPRB, 0.51985888E-09_JPRB, 0.51831306E-09_JPRB, 0.51694782E-09_JPRB, &
  & 0.51574517E-09_JPRB, 0.51464533E-09_JPRB, 0.51361637E-09_JPRB, 0.51266225E-09_JPRB, 0.51179616E-09_JPRB, 0.51102061E-09_JPRB, &
  & 0.51029619E-09_JPRB, 0.50955840E-09_JPRB, 0.50866794E-09_JPRB, 0.50702692E-09_JPRB /)

RGHG6(:,49, 3) = (/ &
  & 0.50226262E-09_JPRB, 0.50546228E-09_JPRB, 0.50744031E-09_JPRB, 0.50950194E-09_JPRB, 0.51178101E-09_JPRB, 0.51404647E-09_JPRB, &
  & 0.51583932E-09_JPRB, 0.51710586E-09_JPRB, 0.51802351E-09_JPRB, 0.51877747E-09_JPRB, 0.51951532E-09_JPRB, 0.52034671E-09_JPRB, &
  & 0.52144533E-09_JPRB, 0.52294757E-09_JPRB, 0.52474058E-09_JPRB, 0.52658466E-09_JPRB, 0.52810201E-09_JPRB, 0.52931359E-09_JPRB, &
  & 0.53027754E-09_JPRB, 0.53108457E-09_JPRB, 0.53177968E-09_JPRB, 0.53238908E-09_JPRB, 0.53291394E-09_JPRB, 0.53335658E-09_JPRB, &
  & 0.53372318E-09_JPRB, 0.53402416E-09_JPRB, 0.53427962E-09_JPRB, 0.53448945E-09_JPRB, 0.53464777E-09_JPRB, 0.53474347E-09_JPRB, &
  & 0.53477228E-09_JPRB, 0.53473448E-09_JPRB, 0.53463040E-09_JPRB, 0.53446414E-09_JPRB, 0.53424604E-09_JPRB, 0.53399229E-09_JPRB, &
  & 0.53371263E-09_JPRB, 0.53340798E-09_JPRB, 0.53307353E-09_JPRB, 0.53270310E-09_JPRB, 0.53229837E-09_JPRB, 0.53187338E-09_JPRB, &
  & 0.53145310E-09_JPRB, 0.53105298E-09_JPRB, 0.53066951E-09_JPRB, 0.53024007E-09_JPRB, 0.52968335E-09_JPRB, 0.52886284E-09_JPRB, &
  & 0.52766574E-09_JPRB, 0.52616872E-09_JPRB, 0.52450927E-09_JPRB, 0.52302307E-09_JPRB, 0.52168947E-09_JPRB, 0.52051607E-09_JPRB, &
  & 0.51945404E-09_JPRB, 0.51846832E-09_JPRB, 0.51753651E-09_JPRB, 0.51667054E-09_JPRB, 0.51589405E-09_JPRB, 0.51520710E-09_JPRB, &
  & 0.51457627E-09_JPRB, 0.51393562E-09_JPRB, 0.51316751E-09_JPRB, 0.51175991E-09_JPRB /)

RGHG6(:,50, 3) = (/ &
  & 0.50723942E-09_JPRB, 0.51033000E-09_JPRB, 0.51227533E-09_JPRB, 0.51429122E-09_JPRB, 0.51654647E-09_JPRB, 0.51872318E-09_JPRB, &
  & 0.52036825E-09_JPRB, 0.52148597E-09_JPRB, 0.52225596E-09_JPRB, 0.52287524E-09_JPRB, 0.52343524E-09_JPRB, 0.52407750E-09_JPRB, &
  & 0.52483007E-09_JPRB, 0.52581595E-09_JPRB, 0.52699572E-09_JPRB, 0.52815141E-09_JPRB, 0.52917343E-09_JPRB, 0.53002042E-09_JPRB, &
  & 0.53074439E-09_JPRB, 0.53139082E-09_JPRB, 0.53198401E-09_JPRB, 0.53253563E-09_JPRB, 0.53303639E-09_JPRB, 0.53347327E-09_JPRB, &
  & 0.53384042E-09_JPRB, 0.53414495E-09_JPRB, 0.53439864E-09_JPRB, 0.53460375E-09_JPRB, 0.53475330E-09_JPRB, 0.53483923E-09_JPRB, &
  & 0.53486010E-09_JPRB, 0.53481708E-09_JPRB, 0.53471022E-09_JPRB, 0.53454369E-09_JPRB, 0.53432797E-09_JPRB, 0.53407806E-09_JPRB, &
  & 0.53380439E-09_JPRB, 0.53350896E-09_JPRB, 0.53318805E-09_JPRB, 0.53284077E-09_JPRB, 0.53247462E-09_JPRB, 0.53211219E-09_JPRB, &
  & 0.53178650E-09_JPRB, 0.53151938E-09_JPRB, 0.53129545E-09_JPRB, 0.53107529E-09_JPRB, 0.53076232E-09_JPRB, 0.53026744E-09_JPRB, &
  & 0.52949323E-09_JPRB, 0.52841742E-09_JPRB, 0.52727922E-09_JPRB, 0.52615434E-09_JPRB, 0.52512206E-09_JPRB, 0.52417815E-09_JPRB, &
  & 0.52327009E-09_JPRB, 0.52239502E-09_JPRB, 0.52155325E-09_JPRB, 0.52075044E-09_JPRB, 0.52003291E-09_JPRB, 0.51940413E-09_JPRB, &
  & 0.51882915E-09_JPRB, 0.51824889E-09_JPRB, 0.51755861E-09_JPRB, 0.51629295E-09_JPRB /)

RGHG6(:,51, 3) = (/ &
  & 0.51186017E-09_JPRB, 0.51478610E-09_JPRB, 0.51677401E-09_JPRB, 0.51873439E-09_JPRB, 0.52097870E-09_JPRB, 0.52299420E-09_JPRB, &
  & 0.52443433E-09_JPRB, 0.52530658E-09_JPRB, 0.52587690E-09_JPRB, 0.52628402E-09_JPRB, 0.52665106E-09_JPRB, 0.52699589E-09_JPRB, &
  & 0.52743454E-09_JPRB, 0.52795224E-09_JPRB, 0.52860016E-09_JPRB, 0.52930282E-09_JPRB, 0.52996241E-09_JPRB, 0.53056326E-09_JPRB, &
  & 0.53111593E-09_JPRB, 0.53164040E-09_JPRB, 0.53215643E-09_JPRB, 0.53266419E-09_JPRB, 0.53314719E-09_JPRB, 0.53358395E-09_JPRB, &
  & 0.53395488E-09_JPRB, 0.53426130E-09_JPRB, 0.53451304E-09_JPRB, 0.53471033E-09_JPRB, 0.53484989E-09_JPRB, 0.53492677E-09_JPRB, &
  & 0.53493993E-09_JPRB, 0.53489146E-09_JPRB, 0.53478155E-09_JPRB, 0.53461435E-09_JPRB, 0.53440058E-09_JPRB, 0.53415466E-09_JPRB, &
  & 0.53388682E-09_JPRB, 0.53359922E-09_JPRB, 0.53329036E-09_JPRB, 0.53296229E-09_JPRB, 0.53262844E-09_JPRB, 0.53232074E-09_JPRB, &
  & 0.53207400E-09_JPRB, 0.53190352E-09_JPRB, 0.53179494E-09_JPRB, 0.53169269E-09_JPRB, 0.53154192E-09_JPRB, 0.53125959E-09_JPRB, &
  & 0.53079396E-09_JPRB, 0.53018556E-09_JPRB, 0.52949195E-09_JPRB, 0.52882410E-09_JPRB, 0.52818822E-09_JPRB, 0.52752563E-09_JPRB, &
  & 0.52686605E-09_JPRB, 0.52617849E-09_JPRB, 0.52545684E-09_JPRB, 0.52475668E-09_JPRB, 0.52410487E-09_JPRB, 0.52352822E-09_JPRB, &
  & 0.52300003E-09_JPRB, 0.52246568E-09_JPRB, 0.52182159E-09_JPRB, 0.52066118E-09_JPRB /)

RGHG6(:,52, 3) = (/ &
  & 0.51592353E-09_JPRB, 0.51898286E-09_JPRB, 0.52073690E-09_JPRB, 0.52276006E-09_JPRB, 0.52476923E-09_JPRB, 0.52649868E-09_JPRB, &
  & 0.52752275E-09_JPRB, 0.52809612E-09_JPRB, 0.52842053E-09_JPRB, 0.52864269E-09_JPRB, 0.52880589E-09_JPRB, 0.52897664E-09_JPRB, &
  & 0.52914634E-09_JPRB, 0.52939375E-09_JPRB, 0.52971594E-09_JPRB, 0.53011850E-09_JPRB, 0.53055227E-09_JPRB, 0.53098526E-09_JPRB, &
  & 0.53141513E-09_JPRB, 0.53185484E-09_JPRB, 0.53230942E-09_JPRB, 0.53278304E-09_JPRB, 0.53325566E-09_JPRB, 0.53369204E-09_JPRB, &
  & 0.53406651E-09_JPRB, 0.53437388E-09_JPRB, 0.53462074E-09_JPRB, 0.53480925E-09_JPRB, 0.53493876E-09_JPRB, 0.53500682E-09_JPRB, &
  & 0.53501281E-09_JPRB, 0.53495897E-09_JPRB, 0.53484606E-09_JPRB, 0.53467791E-09_JPRB, 0.53446580E-09_JPRB, 0.53422405E-09_JPRB, &
  & 0.53396149E-09_JPRB, 0.53368154E-09_JPRB, 0.53338300E-09_JPRB, 0.53307231E-09_JPRB, 0.53276866E-09_JPRB, 0.53250726E-09_JPRB, &
  & 0.53232491E-09_JPRB, 0.53222904E-09_JPRB, 0.53218890E-09_JPRB, 0.53216220E-09_JPRB, 0.53209420E-09_JPRB, 0.53194493E-09_JPRB, &
  & 0.53169186E-09_JPRB, 0.53135313E-09_JPRB, 0.53101051E-09_JPRB, 0.53067989E-09_JPRB, 0.53033689E-09_JPRB, 0.52999705E-09_JPRB, &
  & 0.52960258E-09_JPRB, 0.52915988E-09_JPRB, 0.52867427E-09_JPRB, 0.52814403E-09_JPRB, 0.52763843E-09_JPRB, 0.52717458E-09_JPRB, &
  & 0.52673543E-09_JPRB, 0.52627958E-09_JPRB, 0.52572358E-09_JPRB, 0.52466942E-09_JPRB /)

RGHG6(:,53, 3) = (/ &
  & 0.51976984E-09_JPRB, 0.52241494E-09_JPRB, 0.52434157E-09_JPRB, 0.52597071E-09_JPRB, 0.52768756E-09_JPRB, 0.52885785E-09_JPRB, &
  & 0.52948440E-09_JPRB, 0.52978621E-09_JPRB, 0.52994875E-09_JPRB, 0.53004573E-09_JPRB, 0.53011961E-09_JPRB, 0.53017568E-09_JPRB, &
  & 0.53024674E-09_JPRB, 0.53033422E-09_JPRB, 0.53048971E-09_JPRB, 0.53071708E-09_JPRB, 0.53100224E-09_JPRB, 0.53132199E-09_JPRB, &
  & 0.53166882E-09_JPRB, 0.53204230E-09_JPRB, 0.53245591E-09_JPRB, 0.53290311E-09_JPRB, 0.53336446E-09_JPRB, 0.53380023E-09_JPRB, &
  & 0.53417487E-09_JPRB, 0.53448046E-09_JPRB, 0.53472149E-09_JPRB, 0.53490112E-09_JPRB, 0.53502075E-09_JPRB, 0.53508042E-09_JPRB, &
  & 0.53507992E-09_JPRB, 0.53502058E-09_JPRB, 0.53490445E-09_JPRB, 0.53473526E-09_JPRB, 0.53452509E-09_JPRB, 0.53428661E-09_JPRB, &
  & 0.53402988E-09_JPRB, 0.53375682E-09_JPRB, 0.53346944E-09_JPRB, 0.53317561E-09_JPRB, 0.53289934E-09_JPRB, 0.53268023E-09_JPRB, &
  & 0.53255039E-09_JPRB, 0.53250554E-09_JPRB, 0.53251126E-09_JPRB, 0.53252552E-09_JPRB, 0.53250826E-09_JPRB, 0.53243260E-09_JPRB, &
  & 0.53229277E-09_JPRB, 0.53212246E-09_JPRB, 0.53195054E-09_JPRB, 0.53178706E-09_JPRB, 0.53163479E-09_JPRB, 0.53145599E-09_JPRB, &
  & 0.53126220E-09_JPRB, 0.53102756E-09_JPRB, 0.53074234E-09_JPRB, 0.53043336E-09_JPRB, 0.53011617E-09_JPRB, 0.52981597E-09_JPRB, &
  & 0.52952720E-09_JPRB, 0.52921179E-09_JPRB, 0.52880056E-09_JPRB, 0.52798976E-09_JPRB /)

RGHG6(:,54, 3) = (/ &
  & 0.52289950E-09_JPRB, 0.52564197E-09_JPRB, 0.52703331E-09_JPRB, 0.52845373E-09_JPRB, 0.52957744E-09_JPRB, 0.53029831E-09_JPRB, &
  & 0.53062810E-09_JPRB, 0.53077964E-09_JPRB, 0.53085381E-09_JPRB, 0.53089733E-09_JPRB, 0.53092286E-09_JPRB, 0.53094368E-09_JPRB, &
  & 0.53095983E-09_JPRB, 0.53098936E-09_JPRB, 0.53104943E-09_JPRB, 0.53117333E-09_JPRB, 0.53136195E-09_JPRB, 0.53160265E-09_JPRB, &
  & 0.53188787E-09_JPRB, 0.53221960E-09_JPRB, 0.53259891E-09_JPRB, 0.53302796E-09_JPRB, 0.53347826E-09_JPRB, 0.53390725E-09_JPRB, &
  & 0.53427862E-09_JPRB, 0.53458005E-09_JPRB, 0.53481508E-09_JPRB, 0.53498633E-09_JPRB, 0.53509719E-09_JPRB, 0.53514881E-09_JPRB, &
  & 0.53514182E-09_JPRB, 0.53507737E-09_JPRB, 0.53495763E-09_JPRB, 0.53478799E-09_JPRB, 0.53457899E-09_JPRB, 0.53434451E-09_JPRB, &
  & 0.53409271E-09_JPRB, 0.53382787E-09_JPRB, 0.53355120E-09_JPRB, 0.53327598E-09_JPRB, 0.53302679E-09_JPRB, 0.53284405E-09_JPRB, &
  & 0.53275429E-09_JPRB, 0.53274662E-09_JPRB, 0.53278215E-09_JPRB, 0.53282023E-09_JPRB, 0.53283045E-09_JPRB, 0.53279786E-09_JPRB, &
  & 0.53272331E-09_JPRB, 0.53262972E-09_JPRB, 0.53254268E-09_JPRB, 0.53246468E-09_JPRB, 0.53238192E-09_JPRB, 0.53230009E-09_JPRB, &
  & 0.53219701E-09_JPRB, 0.53207450E-09_JPRB, 0.53192828E-09_JPRB, 0.53175636E-09_JPRB, 0.53158450E-09_JPRB, 0.53142402E-09_JPRB, &
  & 0.53126425E-09_JPRB, 0.53109184E-09_JPRB, 0.53086191E-09_JPRB, 0.53038324E-09_JPRB /)

RGHG6(:,55, 3) = (/ &
  & 0.52579663E-09_JPRB, 0.52793347E-09_JPRB, 0.52917182E-09_JPRB, 0.53005844E-09_JPRB, 0.53075999E-09_JPRB, 0.53116045E-09_JPRB, &
  & 0.53133298E-09_JPRB, 0.53140620E-09_JPRB, 0.53144034E-09_JPRB, 0.53145732E-09_JPRB, 0.53146665E-09_JPRB, 0.53146976E-09_JPRB, &
  & 0.53146931E-09_JPRB, 0.53146915E-09_JPRB, 0.53148536E-09_JPRB, 0.53154298E-09_JPRB, 0.53166355E-09_JPRB, 0.53184684E-09_JPRB, &
  & 0.53208815E-09_JPRB, 0.53238625E-09_JPRB, 0.53274568E-09_JPRB, 0.53315713E-09_JPRB, 0.53359450E-09_JPRB, 0.53401261E-09_JPRB, &
  & 0.53437699E-09_JPRB, 0.53467342E-09_JPRB, 0.53490246E-09_JPRB, 0.53506671E-09_JPRB, 0.53516902E-09_JPRB, 0.53521287E-09_JPRB, &
  & 0.53519944E-09_JPRB, 0.53513022E-09_JPRB, 0.53500715E-09_JPRB, 0.53483673E-09_JPRB, 0.53462967E-09_JPRB, 0.53439853E-09_JPRB, &
  & 0.53415250E-09_JPRB, 0.53389543E-09_JPRB, 0.53363225E-09_JPRB, 0.53337557E-09_JPRB, 0.53315330E-09_JPRB, 0.53300070E-09_JPRB, &
  & 0.53294191E-09_JPRB, 0.53296051E-09_JPRB, 0.53301435E-09_JPRB, 0.53307031E-09_JPRB, 0.53309623E-09_JPRB, 0.53308707E-09_JPRB, &
  & 0.53304444E-09_JPRB, 0.53299420E-09_JPRB, 0.53294580E-09_JPRB, 0.53290128E-09_JPRB, 0.53286053E-09_JPRB, 0.53281179E-09_JPRB, &
  & 0.53275939E-09_JPRB, 0.53269356E-09_JPRB, 0.53261207E-09_JPRB, 0.53252108E-09_JPRB, 0.53242821E-09_JPRB, 0.53234095E-09_JPRB, &
  & 0.53225957E-09_JPRB, 0.53216676E-09_JPRB, 0.53203836E-09_JPRB, 0.53172144E-09_JPRB /)

RGHG6(:,56, 3) = (/ &
  & 0.52803723E-09_JPRB, 0.52977139E-09_JPRB, 0.53053950E-09_JPRB, 0.53109261E-09_JPRB, 0.53150140E-09_JPRB, 0.53171856E-09_JPRB, &
  & 0.53181060E-09_JPRB, 0.53184640E-09_JPRB, 0.53186178E-09_JPRB, 0.53186849E-09_JPRB, 0.53187021E-09_JPRB, 0.53186772E-09_JPRB, &
  & 0.53186183E-09_JPRB, 0.53185034E-09_JPRB, 0.53184357E-09_JPRB, 0.53186144E-09_JPRB, 0.53193216E-09_JPRB, 0.53207022E-09_JPRB, &
  & 0.53227700E-09_JPRB, 0.53255145E-09_JPRB, 0.53289212E-09_JPRB, 0.53328947E-09_JPRB, 0.53371008E-09_JPRB, 0.53411608E-09_JPRB, &
  & 0.53447080E-09_JPRB, 0.53476201E-09_JPRB, 0.53498550E-09_JPRB, 0.53514226E-09_JPRB, 0.53523741E-09_JPRB, 0.53527333E-09_JPRB, &
  & 0.53525356E-09_JPRB, 0.53518012E-09_JPRB, 0.53505433E-09_JPRB, 0.53488314E-09_JPRB, 0.53467830E-09_JPRB, 0.53445076E-09_JPRB, &
  & 0.53421045E-09_JPRB, 0.53396287E-09_JPRB, 0.53371313E-09_JPRB, 0.53347698E-09_JPRB, 0.53327881E-09_JPRB, 0.53315258E-09_JPRB, &
  & 0.53311572E-09_JPRB, 0.53315247E-09_JPRB, 0.53322252E-09_JPRB, 0.53328725E-09_JPRB, 0.53332461E-09_JPRB, 0.53332788E-09_JPRB, &
  & 0.53330373E-09_JPRB, 0.53327243E-09_JPRB, 0.53324289E-09_JPRB, 0.53321725E-09_JPRB, 0.53319010E-09_JPRB, 0.53316385E-09_JPRB, &
  & 0.53313132E-09_JPRB, 0.53309324E-09_JPRB, 0.53304733E-09_JPRB, 0.53299343E-09_JPRB, 0.53294058E-09_JPRB, 0.53289495E-09_JPRB, &
  & 0.53285276E-09_JPRB, 0.53281463E-09_JPRB, 0.53277577E-09_JPRB, 0.53273452E-09_JPRB /)

RGHG6(:,57, 3) = (/ &
  & 0.52980759E-09_JPRB, 0.53096832E-09_JPRB, 0.53144267E-09_JPRB, 0.53177596E-09_JPRB, 0.53199201E-09_JPRB, 0.53211946E-09_JPRB, &
  & 0.53216836E-09_JPRB, 0.53218696E-09_JPRB, 0.53219407E-09_JPRB, 0.53219629E-09_JPRB, 0.53219568E-09_JPRB, 0.53219218E-09_JPRB, &
  & 0.53218396E-09_JPRB, 0.53217147E-09_JPRB, 0.53215388E-09_JPRB, 0.53214777E-09_JPRB, 0.53218235E-09_JPRB, 0.53228444E-09_JPRB, &
  & 0.53246230E-09_JPRB, 0.53271565E-09_JPRB, 0.53304045E-09_JPRB, 0.53342036E-09_JPRB, 0.53382621E-09_JPRB, 0.53421606E-09_JPRB, &
  & 0.53456362E-09_JPRB, 0.53484756E-09_JPRB, 0.53506499E-09_JPRB, 0.53521515E-09_JPRB, 0.53530247E-09_JPRB, 0.53533150E-09_JPRB, &
  & 0.53530547E-09_JPRB, 0.53522792E-09_JPRB, 0.53510008E-09_JPRB, 0.53492855E-09_JPRB, 0.53472637E-09_JPRB, 0.53450305E-09_JPRB, &
  & 0.53426963E-09_JPRB, 0.53403149E-09_JPRB, 0.53379651E-09_JPRB, 0.53357946E-09_JPRB, 0.53340460E-09_JPRB, 0.53329902E-09_JPRB, &
  & 0.53327909E-09_JPRB, 0.53332994E-09_JPRB, 0.53340860E-09_JPRB, 0.53348415E-09_JPRB, 0.53352711E-09_JPRB, 0.53353749E-09_JPRB, &
  & 0.53352184E-09_JPRB, 0.53350113E-09_JPRB, 0.53348020E-09_JPRB, 0.53346139E-09_JPRB, 0.53344396E-09_JPRB, 0.53342453E-09_JPRB, &
  & 0.53340388E-09_JPRB, 0.53337890E-09_JPRB, 0.53334814E-09_JPRB, 0.53331373E-09_JPRB, 0.53327953E-09_JPRB, 0.53324833E-09_JPRB, &
  & 0.53322191E-09_JPRB, 0.53319449E-09_JPRB, 0.53316401E-09_JPRB, 0.53311383E-09_JPRB /)

RGHG6(:,58, 3) = (/ &
  & 0.53112781E-09_JPRB, 0.53177407E-09_JPRB, 0.53205951E-09_JPRB, 0.53222926E-09_JPRB, 0.53236382E-09_JPRB, 0.53243121E-09_JPRB, &
  & 0.53246080E-09_JPRB, 0.53247079E-09_JPRB, 0.53247451E-09_JPRB, 0.53247529E-09_JPRB, 0.53247429E-09_JPRB, 0.53247073E-09_JPRB, &
  & 0.53246452E-09_JPRB, 0.53245069E-09_JPRB, 0.53243154E-09_JPRB, 0.53241206E-09_JPRB, 0.53242144E-09_JPRB, 0.53249560E-09_JPRB, &
  & 0.53264815E-09_JPRB, 0.53288163E-09_JPRB, 0.53318849E-09_JPRB, 0.53355215E-09_JPRB, 0.53393967E-09_JPRB, 0.53431881E-09_JPRB, &
  & 0.53465438E-09_JPRB, 0.53493199E-09_JPRB, 0.53514193E-09_JPRB, 0.53528454E-09_JPRB, 0.53536503E-09_JPRB, 0.53538751E-09_JPRB, &
  & 0.53535598E-09_JPRB, 0.53527449E-09_JPRB, 0.53514548E-09_JPRB, 0.53497445E-09_JPRB, 0.53477522E-09_JPRB, 0.53455695E-09_JPRB, &
  & 0.53433080E-09_JPRB, 0.53410348E-09_JPRB, 0.53388255E-09_JPRB, 0.53368421E-09_JPRB, 0.53352900E-09_JPRB, 0.53344201E-09_JPRB, &
  & 0.53343507E-09_JPRB, 0.53349447E-09_JPRB, 0.53358284E-09_JPRB, 0.53366239E-09_JPRB, 0.53371202E-09_JPRB, 0.53372551E-09_JPRB, &
  & 0.53371457E-09_JPRB, 0.53369709E-09_JPRB, 0.53368004E-09_JPRB, 0.53366500E-09_JPRB, 0.53364979E-09_JPRB, 0.53363536E-09_JPRB, &
  & 0.53361876E-09_JPRB, 0.53360000E-09_JPRB, 0.53357774E-09_JPRB, 0.53355181E-09_JPRB, 0.53352595E-09_JPRB, 0.53350369E-09_JPRB, &
  & 0.53348248E-09_JPRB, 0.53346211E-09_JPRB, 0.53343724E-09_JPRB, 0.53339388E-09_JPRB /)

RGHG6(:,59, 3) = (/ &
  & 0.53191374E-09_JPRB, 0.53232485E-09_JPRB, 0.53247340E-09_JPRB, 0.53258342E-09_JPRB, 0.53265159E-09_JPRB, 0.53269589E-09_JPRB, &
  & 0.53271343E-09_JPRB, 0.53272031E-09_JPRB, 0.53272303E-09_JPRB, 0.53272387E-09_JPRB, 0.53272353E-09_JPRB, 0.53272142E-09_JPRB, &
  & 0.53271604E-09_JPRB, 0.53270555E-09_JPRB, 0.53268467E-09_JPRB, 0.53265925E-09_JPRB, 0.53265253E-09_JPRB, 0.53270521E-09_JPRB, &
  & 0.53283644E-09_JPRB, 0.53305044E-09_JPRB, 0.53333915E-09_JPRB, 0.53368443E-09_JPRB, 0.53405719E-09_JPRB, 0.53442079E-09_JPRB, &
  & 0.53474725E-09_JPRB, 0.53501470E-09_JPRB, 0.53521648E-09_JPRB, 0.53535160E-09_JPRB, 0.53542504E-09_JPRB, 0.53544164E-09_JPRB, &
  & 0.53540555E-09_JPRB, 0.53532123E-09_JPRB, 0.53519134E-09_JPRB, 0.53502236E-09_JPRB, 0.53482585E-09_JPRB, 0.53461385E-09_JPRB, &
  & 0.53439608E-09_JPRB, 0.53417892E-09_JPRB, 0.53397242E-09_JPRB, 0.53379035E-09_JPRB, 0.53365340E-09_JPRB, 0.53358162E-09_JPRB, &
  & 0.53358523E-09_JPRB, 0.53365184E-09_JPRB, 0.53374422E-09_JPRB, 0.53383009E-09_JPRB, 0.53388255E-09_JPRB, 0.53389881E-09_JPRB, &
  & 0.53388938E-09_JPRB, 0.53387339E-09_JPRB, 0.53385685E-09_JPRB, 0.53384186E-09_JPRB, 0.53382815E-09_JPRB, 0.53381410E-09_JPRB, &
  & 0.53379989E-09_JPRB, 0.53378363E-09_JPRB, 0.53376453E-09_JPRB, 0.53374344E-09_JPRB, 0.53372262E-09_JPRB, 0.53370341E-09_JPRB, &
  & 0.53368676E-09_JPRB, 0.53366866E-09_JPRB, 0.53364735E-09_JPRB, 0.53360677E-09_JPRB /)

RGHG6(:,60, 3) = (/ &
  & 0.53254617E-09_JPRB, 0.53271743E-09_JPRB, 0.53280347E-09_JPRB, 0.53285643E-09_JPRB, 0.53290222E-09_JPRB, 0.53292781E-09_JPRB, &
  & 0.53294119E-09_JPRB, 0.53294669E-09_JPRB, 0.53294968E-09_JPRB, 0.53295135E-09_JPRB, 0.53295224E-09_JPRB, 0.53295190E-09_JPRB, &
  & 0.53294918E-09_JPRB, 0.53294025E-09_JPRB, 0.53292187E-09_JPRB, 0.53289284E-09_JPRB, 0.53287674E-09_JPRB, 0.53291399E-09_JPRB, &
  & 0.53302696E-09_JPRB, 0.53322280E-09_JPRB, 0.53349286E-09_JPRB, 0.53382093E-09_JPRB, 0.53417665E-09_JPRB, 0.53452631E-09_JPRB, &
  & 0.53483951E-09_JPRB, 0.53509647E-09_JPRB, 0.53528865E-09_JPRB, 0.53541543E-09_JPRB, 0.53548227E-09_JPRB, 0.53549387E-09_JPRB, &
  & 0.53545468E-09_JPRB, 0.53536836E-09_JPRB, 0.53523880E-09_JPRB, 0.53507238E-09_JPRB, 0.53487992E-09_JPRB, 0.53467430E-09_JPRB, &
  & 0.53446497E-09_JPRB, 0.53425880E-09_JPRB, 0.53406507E-09_JPRB, 0.53389854E-09_JPRB, 0.53377702E-09_JPRB, 0.53371907E-09_JPRB, &
  & 0.53373173E-09_JPRB, 0.53380272E-09_JPRB, 0.53389904E-09_JPRB, 0.53398641E-09_JPRB, 0.53404331E-09_JPRB, 0.53406130E-09_JPRB, &
  & 0.53405275E-09_JPRB, 0.53403526E-09_JPRB, 0.53401772E-09_JPRB, 0.53400162E-09_JPRB, 0.53398636E-09_JPRB, 0.53397242E-09_JPRB, &
  & 0.53395777E-09_JPRB, 0.53394222E-09_JPRB, 0.53392457E-09_JPRB, 0.53390525E-09_JPRB, 0.53388616E-09_JPRB, 0.53386995E-09_JPRB, &
  & 0.53385418E-09_JPRB, 0.53383908E-09_JPRB, 0.53382010E-09_JPRB, 0.53378557E-09_JPRB /)

RGHG6(:,61, 3) = (/ &
  & 0.53287169E-09_JPRB, 0.53300120E-09_JPRB, 0.53305294E-09_JPRB, 0.53309213E-09_JPRB, 0.53311938E-09_JPRB, 0.53314014E-09_JPRB, &
  & 0.53315119E-09_JPRB, 0.53315763E-09_JPRB, 0.53316174E-09_JPRB, 0.53316501E-09_JPRB, 0.53316784E-09_JPRB, 0.53316984E-09_JPRB, &
  & 0.53317001E-09_JPRB, 0.53316485E-09_JPRB, 0.53314719E-09_JPRB, 0.53311683E-09_JPRB, 0.53309535E-09_JPRB, 0.53312177E-09_JPRB, &
  & 0.53321991E-09_JPRB, 0.53339833E-09_JPRB, 0.53365096E-09_JPRB, 0.53396187E-09_JPRB, 0.53429955E-09_JPRB, 0.53463373E-09_JPRB, &
  & 0.53493238E-09_JPRB, 0.53517663E-09_JPRB, 0.53535787E-09_JPRB, 0.53547639E-09_JPRB, 0.53553678E-09_JPRB, 0.53554450E-09_JPRB, &
  & 0.53550320E-09_JPRB, 0.53541671E-09_JPRB, 0.53528826E-09_JPRB, 0.53512567E-09_JPRB, 0.53493793E-09_JPRB, 0.53473953E-09_JPRB, &
  & 0.53453847E-09_JPRB, 0.53434268E-09_JPRB, 0.53416127E-09_JPRB, 0.53400806E-09_JPRB, 0.53390081E-09_JPRB, 0.53385452E-09_JPRB, &
  & 0.53387494E-09_JPRB, 0.53394955E-09_JPRB, 0.53404708E-09_JPRB, 0.53413646E-09_JPRB, 0.53419519E-09_JPRB, 0.53421617E-09_JPRB, &
  & 0.53420801E-09_JPRB, 0.53418914E-09_JPRB, 0.53416849E-09_JPRB, 0.53414939E-09_JPRB, 0.53413246E-09_JPRB, 0.53411620E-09_JPRB, &
  & 0.53410076E-09_JPRB, 0.53408444E-09_JPRB, 0.53406646E-09_JPRB, 0.53404769E-09_JPRB, 0.53403004E-09_JPRB, 0.53401406E-09_JPRB, &
  & 0.53400029E-09_JPRB, 0.53398541E-09_JPRB, 0.53396798E-09_JPRB, 0.53393467E-09_JPRB /)

RGHG6(:,62, 3) = (/ &
  & 0.53314764E-09_JPRB, 0.53323362E-09_JPRB, 0.53327287E-09_JPRB, 0.53329818E-09_JPRB, 0.53332061E-09_JPRB, 0.53333704E-09_JPRB, &
  & 0.53334903E-09_JPRB, 0.53335669E-09_JPRB, 0.53336280E-09_JPRB, 0.53336835E-09_JPRB, 0.53337390E-09_JPRB, 0.53337956E-09_JPRB, &
  & 0.53338373E-09_JPRB, 0.53338223E-09_JPRB, 0.53336618E-09_JPRB, 0.53333460E-09_JPRB, 0.53331056E-09_JPRB, 0.53332921E-09_JPRB, &
  & 0.53341481E-09_JPRB, 0.53357774E-09_JPRB, 0.53381399E-09_JPRB, 0.53410648E-09_JPRB, 0.53442684E-09_JPRB, 0.53474253E-09_JPRB, &
  & 0.53502525E-09_JPRB, 0.53525478E-09_JPRB, 0.53542465E-09_JPRB, 0.53553417E-09_JPRB, 0.53558874E-09_JPRB, 0.53559346E-09_JPRB, &
  & 0.53555155E-09_JPRB, 0.53546634E-09_JPRB, 0.53534083E-09_JPRB, 0.53518279E-09_JPRB, 0.53500115E-09_JPRB, 0.53480953E-09_JPRB, &
  & 0.53461691E-09_JPRB, 0.53443072E-09_JPRB, 0.53426064E-09_JPRB, 0.53412003E-09_JPRB, 0.53402494E-09_JPRB, 0.53398908E-09_JPRB, &
  & 0.53401616E-09_JPRB, 0.53409327E-09_JPRB, 0.53419130E-09_JPRB, 0.53428045E-09_JPRB, 0.53434090E-09_JPRB, 0.53436444E-09_JPRB, &
  & 0.53435767E-09_JPRB, 0.53433674E-09_JPRB, 0.53431259E-09_JPRB, 0.53428995E-09_JPRB, 0.53426918E-09_JPRB, 0.53425075E-09_JPRB, &
  & 0.53423288E-09_JPRB, 0.53421484E-09_JPRB, 0.53419608E-09_JPRB, 0.53417687E-09_JPRB, 0.53415899E-09_JPRB, 0.53414401E-09_JPRB, &
  & 0.53412974E-09_JPRB, 0.53411592E-09_JPRB, 0.53409888E-09_JPRB, 0.53406751E-09_JPRB /)

RGHG6(:,63, 3) = (/ &
  & 0.53336535E-09_JPRB, 0.53343774E-09_JPRB, 0.53346794E-09_JPRB, 0.53348981E-09_JPRB, 0.53350752E-09_JPRB, 0.53352367E-09_JPRB, &
  & 0.53353622E-09_JPRB, 0.53354665E-09_JPRB, 0.53355559E-09_JPRB, 0.53356453E-09_JPRB, 0.53357418E-09_JPRB, 0.53358451E-09_JPRB, &
  & 0.53359406E-09_JPRB, 0.53359606E-09_JPRB, 0.53358040E-09_JPRB, 0.53354837E-09_JPRB, 0.53352328E-09_JPRB, 0.53353605E-09_JPRB, &
  & 0.53361160E-09_JPRB, 0.53376109E-09_JPRB, 0.53398130E-09_JPRB, 0.53425614E-09_JPRB, 0.53455640E-09_JPRB, 0.53485355E-09_JPRB, &
  & 0.53511728E-09_JPRB, 0.53533150E-09_JPRB, 0.53548871E-09_JPRB, 0.53558935E-09_JPRB, 0.53563831E-09_JPRB, 0.53564081E-09_JPRB, &
  & 0.53559962E-09_JPRB, 0.53551696E-09_JPRB, 0.53539606E-09_JPRB, 0.53524385E-09_JPRB, 0.53506916E-09_JPRB, 0.53488491E-09_JPRB, &
  & 0.53470051E-09_JPRB, 0.53452359E-09_JPRB, 0.53436366E-09_JPRB, 0.53423427E-09_JPRB, 0.53415022E-09_JPRB, 0.53412352E-09_JPRB, &
  & 0.53415594E-09_JPRB, 0.53423471E-09_JPRB, 0.53433202E-09_JPRB, 0.53442034E-09_JPRB, 0.53448113E-09_JPRB, 0.53450688E-09_JPRB, &
  & 0.53450211E-09_JPRB, 0.53448035E-09_JPRB, 0.53445270E-09_JPRB, 0.53442550E-09_JPRB, 0.53440108E-09_JPRB, 0.53437876E-09_JPRB, &
  & 0.53435817E-09_JPRB, 0.53433796E-09_JPRB, 0.53431709E-09_JPRB, 0.53429700E-09_JPRB, 0.53427895E-09_JPRB, 0.53426308E-09_JPRB, &
  & 0.53424920E-09_JPRB, 0.53423443E-09_JPRB, 0.53421700E-09_JPRB, 0.53418431E-09_JPRB /)

RGHG6(:,64, 3) = (/ &
  & 0.53355875E-09_JPRB, 0.53362104E-09_JPRB, 0.53364868E-09_JPRB, 0.53366778E-09_JPRB, 0.53368510E-09_JPRB, 0.53370069E-09_JPRB, &
  & 0.53371557E-09_JPRB, 0.53372834E-09_JPRB, 0.53374127E-09_JPRB, 0.53375460E-09_JPRB, 0.53376981E-09_JPRB, 0.53378646E-09_JPRB, &
  & 0.53380111E-09_JPRB, 0.53380489E-09_JPRB, 0.53378890E-09_JPRB, 0.53375776E-09_JPRB, 0.53373267E-09_JPRB, 0.53374205E-09_JPRB, &
  & 0.53380922E-09_JPRB, 0.53394650E-09_JPRB, 0.53415128E-09_JPRB, 0.53440730E-09_JPRB, 0.53468813E-09_JPRB, 0.53496374E-09_JPRB, &
  & 0.53520810E-09_JPRB, 0.53540528E-09_JPRB, 0.53554927E-09_JPRB, 0.53564059E-09_JPRB, 0.53568461E-09_JPRB, 0.53568544E-09_JPRB, &
  & 0.53564586E-09_JPRB, 0.53556731E-09_JPRB, 0.53545257E-09_JPRB, 0.53530774E-09_JPRB, 0.53514077E-09_JPRB, 0.53496502E-09_JPRB, &
  & 0.53478882E-09_JPRB, 0.53462079E-09_JPRB, 0.53447052E-09_JPRB, 0.53435106E-09_JPRB, 0.53427684E-09_JPRB, 0.53425780E-09_JPRB, &
  & 0.53429450E-09_JPRB, 0.53437366E-09_JPRB, 0.53446925E-09_JPRB, 0.53455579E-09_JPRB, 0.53461602E-09_JPRB, 0.53464289E-09_JPRB, &
  & 0.53464022E-09_JPRB, 0.53461863E-09_JPRB, 0.53458871E-09_JPRB, 0.53455773E-09_JPRB, 0.53452887E-09_JPRB, 0.53450294E-09_JPRB, &
  & 0.53447902E-09_JPRB, 0.53445559E-09_JPRB, 0.53443283E-09_JPRB, 0.53441102E-09_JPRB, 0.53439198E-09_JPRB, 0.53437571E-09_JPRB, &
  & 0.53436022E-09_JPRB, 0.53434457E-09_JPRB, 0.53432508E-09_JPRB, 0.53428889E-09_JPRB /)

RGHG6(:,65, 3) = (/ &
  & 0.53372778E-09_JPRB, 0.53378990E-09_JPRB, 0.53381699E-09_JPRB, 0.53383675E-09_JPRB, 0.53385407E-09_JPRB, 0.53387128E-09_JPRB, &
  & 0.53388760E-09_JPRB, 0.53390459E-09_JPRB, 0.53392102E-09_JPRB, 0.53394067E-09_JPRB, 0.53396171E-09_JPRB, 0.53398480E-09_JPRB, &
  & 0.53400290E-09_JPRB, 0.53400689E-09_JPRB, 0.53399135E-09_JPRB, 0.53396193E-09_JPRB, 0.53393773E-09_JPRB, 0.53394467E-09_JPRB, &
  & 0.53400562E-09_JPRB, 0.53413202E-09_JPRB, 0.53432186E-09_JPRB, 0.53455923E-09_JPRB, 0.53481830E-09_JPRB, 0.53507176E-09_JPRB, &
  & 0.53529520E-09_JPRB, 0.53547483E-09_JPRB, 0.53560534E-09_JPRB, 0.53568761E-09_JPRB, 0.53572669E-09_JPRB, 0.53572635E-09_JPRB, &
  & 0.53568905E-09_JPRB, 0.53561555E-09_JPRB, 0.53550808E-09_JPRB, 0.53537180E-09_JPRB, 0.53521465E-09_JPRB, 0.53504767E-09_JPRB, &
  & 0.53488075E-09_JPRB, 0.53472149E-09_JPRB, 0.53458071E-09_JPRB, 0.53447080E-09_JPRB, 0.53440519E-09_JPRB, 0.53439242E-09_JPRB, &
  & 0.53443150E-09_JPRB, 0.53450983E-09_JPRB, 0.53460258E-09_JPRB, 0.53468652E-09_JPRB, 0.53474553E-09_JPRB, 0.53477267E-09_JPRB, &
  & 0.53477139E-09_JPRB, 0.53475069E-09_JPRB, 0.53471971E-09_JPRB, 0.53468641E-09_JPRB, 0.53465393E-09_JPRB, 0.53462440E-09_JPRB, &
  & 0.53459659E-09_JPRB, 0.53457055E-09_JPRB, 0.53454474E-09_JPRB, 0.53452154E-09_JPRB, 0.53450117E-09_JPRB, 0.53448318E-09_JPRB, &
  & 0.53446647E-09_JPRB, 0.53444815E-09_JPRB, 0.53442523E-09_JPRB, 0.53438187E-09_JPRB /)

RGHG6(:,66, 3) = (/ &
  & 0.53388227E-09_JPRB, 0.53394728E-09_JPRB, 0.53397708E-09_JPRB, 0.53399851E-09_JPRB, 0.53401789E-09_JPRB, 0.53403659E-09_JPRB, &
  & 0.53405602E-09_JPRB, 0.53407545E-09_JPRB, 0.53409815E-09_JPRB, 0.53412219E-09_JPRB, 0.53415095E-09_JPRB, 0.53417742E-09_JPRB, &
  & 0.53419702E-09_JPRB, 0.53420107E-09_JPRB, 0.53418697E-09_JPRB, 0.53416016E-09_JPRB, 0.53413790E-09_JPRB, 0.53414384E-09_JPRB, &
  & 0.53419968E-09_JPRB, 0.53431626E-09_JPRB, 0.53449084E-09_JPRB, 0.53470861E-09_JPRB, 0.53494520E-09_JPRB, 0.53517524E-09_JPRB, &
  & 0.53537741E-09_JPRB, 0.53553917E-09_JPRB, 0.53565635E-09_JPRB, 0.53572974E-09_JPRB, 0.53576399E-09_JPRB, 0.53576277E-09_JPRB, &
  & 0.53572807E-09_JPRB, 0.53566018E-09_JPRB, 0.53556082E-09_JPRB, 0.53543436E-09_JPRB, 0.53528776E-09_JPRB, 0.53513138E-09_JPRB, &
  & 0.53497412E-09_JPRB, 0.53482457E-09_JPRB, 0.53469340E-09_JPRB, 0.53459287E-09_JPRB, 0.53453475E-09_JPRB, 0.53452692E-09_JPRB, &
  & 0.53456750E-09_JPRB, 0.53464322E-09_JPRB, 0.53473215E-09_JPRB, 0.53481286E-09_JPRB, 0.53486954E-09_JPRB, 0.53489657E-09_JPRB, &
  & 0.53489596E-09_JPRB, 0.53487609E-09_JPRB, 0.53484539E-09_JPRB, 0.53481053E-09_JPRB, 0.53477633E-09_JPRB, 0.53474342E-09_JPRB, &
  & 0.53471305E-09_JPRB, 0.53468341E-09_JPRB, 0.53465604E-09_JPRB, 0.53463062E-09_JPRB, 0.53460875E-09_JPRB, 0.53458926E-09_JPRB, &
  & 0.53456983E-09_JPRB, 0.53454852E-09_JPRB, 0.53452026E-09_JPRB, 0.53446519E-09_JPRB /)

RGHG6(:,67, 3) = (/ &
  & 0.53402799E-09_JPRB, 0.53409865E-09_JPRB, 0.53413118E-09_JPRB, 0.53415572E-09_JPRB, 0.53417770E-09_JPRB, 0.53419941E-09_JPRB, &
  & 0.53422139E-09_JPRB, 0.53424543E-09_JPRB, 0.53427129E-09_JPRB, 0.53430249E-09_JPRB, 0.53433391E-09_JPRB, 0.53436305E-09_JPRB, &
  & 0.53438293E-09_JPRB, 0.53438770E-09_JPRB, 0.53437543E-09_JPRB, 0.53435167E-09_JPRB, 0.53433175E-09_JPRB, 0.53433763E-09_JPRB, &
  & 0.53438909E-09_JPRB, 0.53449578E-09_JPRB, 0.53465538E-09_JPRB, 0.53485300E-09_JPRB, 0.53506638E-09_JPRB, 0.53527272E-09_JPRB, &
  & 0.53545363E-09_JPRB, 0.53559801E-09_JPRB, 0.53570198E-09_JPRB, 0.53576693E-09_JPRB, 0.53579680E-09_JPRB, 0.53579491E-09_JPRB, &
  & 0.53576299E-09_JPRB, 0.53570087E-09_JPRB, 0.53561000E-09_JPRB, 0.53549404E-09_JPRB, 0.53535898E-09_JPRB, 0.53521410E-09_JPRB, &
  & 0.53506766E-09_JPRB, 0.53492877E-09_JPRB, 0.53480775E-09_JPRB, 0.53471649E-09_JPRB, 0.53466553E-09_JPRB, 0.53466143E-09_JPRB, &
  & 0.53470200E-09_JPRB, 0.53477428E-09_JPRB, 0.53485827E-09_JPRB, 0.53493454E-09_JPRB, 0.53498878E-09_JPRB, 0.53501464E-09_JPRB, &
  & 0.53501453E-09_JPRB, 0.53499571E-09_JPRB, 0.53496524E-09_JPRB, 0.53493054E-09_JPRB, 0.53489480E-09_JPRB, 0.53486066E-09_JPRB, &
  & 0.53482735E-09_JPRB, 0.53479648E-09_JPRB, 0.53476668E-09_JPRB, 0.53474014E-09_JPRB, 0.53471666E-09_JPRB, 0.53469518E-09_JPRB, &
  & 0.53467364E-09_JPRB, 0.53464799E-09_JPRB, 0.53461258E-09_JPRB, 0.53454169E-09_JPRB /)

RGHG6(:,68, 3) = (/ &
  & 0.53416516E-09_JPRB, 0.53424293E-09_JPRB, 0.53428084E-09_JPRB, 0.53430910E-09_JPRB, 0.53433491E-09_JPRB, 0.53435983E-09_JPRB, &
  & 0.53438537E-09_JPRB, 0.53441257E-09_JPRB, 0.53444343E-09_JPRB, 0.53447713E-09_JPRB, 0.53451155E-09_JPRB, 0.53454097E-09_JPRB, &
  & 0.53456101E-09_JPRB, 0.53456650E-09_JPRB, 0.53455640E-09_JPRB, 0.53453580E-09_JPRB, 0.53451876E-09_JPRB, 0.53452459E-09_JPRB, &
  & 0.53457183E-09_JPRB, 0.53466875E-09_JPRB, 0.53481264E-09_JPRB, 0.53498989E-09_JPRB, 0.53518001E-09_JPRB, 0.53536348E-09_JPRB, &
  & 0.53552385E-09_JPRB, 0.53565141E-09_JPRB, 0.53574312E-09_JPRB, 0.53579996E-09_JPRB, 0.53582583E-09_JPRB, 0.53582333E-09_JPRB, &
  & 0.53579413E-09_JPRB, 0.53573795E-09_JPRB, 0.53565569E-09_JPRB, 0.53555044E-09_JPRB, 0.53542754E-09_JPRB, 0.53529453E-09_JPRB, &
  & 0.53516003E-09_JPRB, 0.53503230E-09_JPRB, 0.53492211E-09_JPRB, 0.53484039E-09_JPRB, 0.53479604E-09_JPRB, 0.53479504E-09_JPRB, &
  & 0.53483479E-09_JPRB, 0.53490234E-09_JPRB, 0.53498073E-09_JPRB, 0.53505217E-09_JPRB, 0.53510268E-09_JPRB, 0.53512739E-09_JPRB, &
  & 0.53512728E-09_JPRB, 0.53510929E-09_JPRB, 0.53508004E-09_JPRB, 0.53504573E-09_JPRB, 0.53501037E-09_JPRB, 0.53497506E-09_JPRB, &
  & 0.53494131E-09_JPRB, 0.53490873E-09_JPRB, 0.53487809E-09_JPRB, 0.53485011E-09_JPRB, 0.53482574E-09_JPRB, 0.53480309E-09_JPRB, &
  & 0.53477955E-09_JPRB, 0.53475085E-09_JPRB, 0.53470850E-09_JPRB, 0.53461841E-09_JPRB /)

RGHG6(:,69, 3) = (/ &
  & 0.53429661E-09_JPRB, 0.53438570E-09_JPRB, 0.53442806E-09_JPRB, 0.53446148E-09_JPRB, 0.53449106E-09_JPRB, 0.53451982E-09_JPRB, &
  & 0.53454841E-09_JPRB, 0.53457883E-09_JPRB, 0.53461247E-09_JPRB, 0.53464821E-09_JPRB, 0.53468313E-09_JPRB, 0.53471216E-09_JPRB, &
  & 0.53473204E-09_JPRB, 0.53473820E-09_JPRB, 0.53472998E-09_JPRB, 0.53471239E-09_JPRB, 0.53469779E-09_JPRB, 0.53470345E-09_JPRB, &
  & 0.53474603E-09_JPRB, 0.53483273E-09_JPRB, 0.53496113E-09_JPRB, 0.53511806E-09_JPRB, 0.53528598E-09_JPRB, 0.53544730E-09_JPRB, &
  & 0.53558835E-09_JPRB, 0.53570010E-09_JPRB, 0.53578020E-09_JPRB, 0.53582955E-09_JPRB, 0.53585164E-09_JPRB, 0.53584864E-09_JPRB, &
  & 0.53582228E-09_JPRB, 0.53577187E-09_JPRB, 0.53569843E-09_JPRB, 0.53560401E-09_JPRB, 0.53549321E-09_JPRB, 0.53537264E-09_JPRB, &
  & 0.53525012E-09_JPRB, 0.53513438E-09_JPRB, 0.53503546E-09_JPRB, 0.53496330E-09_JPRB, 0.53492555E-09_JPRB, 0.53492699E-09_JPRB, &
  & 0.53496491E-09_JPRB, 0.53502780E-09_JPRB, 0.53509969E-09_JPRB, 0.53516530E-09_JPRB, 0.53521215E-09_JPRB, 0.53523491E-09_JPRB, &
  & 0.53523497E-09_JPRB, 0.53521809E-09_JPRB, 0.53519006E-09_JPRB, 0.53515697E-09_JPRB, 0.53512239E-09_JPRB, 0.53508753E-09_JPRB, &
  & 0.53505356E-09_JPRB, 0.53502108E-09_JPRB, 0.53499011E-09_JPRB, 0.53496202E-09_JPRB, 0.53493709E-09_JPRB, 0.53491406E-09_JPRB, &
  & 0.53488985E-09_JPRB, 0.53485893E-09_JPRB, 0.53480931E-09_JPRB, 0.53470295E-09_JPRB /)

RGHG6(:,70, 3) = (/ &
  & 0.53442584E-09_JPRB, 0.53452553E-09_JPRB, 0.53457638E-09_JPRB, 0.53461408E-09_JPRB, 0.53464849E-09_JPRB, 0.53467997E-09_JPRB, &
  & 0.53471128E-09_JPRB, 0.53474397E-09_JPRB, 0.53477900E-09_JPRB, 0.53481519E-09_JPRB, 0.53484900E-09_JPRB, 0.53487703E-09_JPRB, &
  & 0.53489585E-09_JPRB, 0.53490212E-09_JPRB, 0.53489557E-09_JPRB, 0.53488058E-09_JPRB, 0.53486821E-09_JPRB, 0.53487309E-09_JPRB, &
  & 0.53491073E-09_JPRB, 0.53498700E-09_JPRB, 0.53509969E-09_JPRB, 0.53523708E-09_JPRB, 0.53538363E-09_JPRB, 0.53552446E-09_JPRB, &
  & 0.53564708E-09_JPRB, 0.53574428E-09_JPRB, 0.53581345E-09_JPRB, 0.53585580E-09_JPRB, 0.53587457E-09_JPRB, 0.53587146E-09_JPRB, &
  & 0.53584787E-09_JPRB, 0.53580335E-09_JPRB, 0.53573845E-09_JPRB, 0.53565474E-09_JPRB, 0.53555604E-09_JPRB, 0.53544769E-09_JPRB, &
  & 0.53533777E-09_JPRB, 0.53523425E-09_JPRB, 0.53514659E-09_JPRB, 0.53508403E-09_JPRB, 0.53505245E-09_JPRB, 0.53505589E-09_JPRB, &
  & 0.53509192E-09_JPRB, 0.53514909E-09_JPRB, 0.53521476E-09_JPRB, 0.53527416E-09_JPRB, 0.53531646E-09_JPRB, 0.53533722E-09_JPRB, &
  & 0.53533727E-09_JPRB, 0.53532156E-09_JPRB, 0.53529547E-09_JPRB, 0.53526428E-09_JPRB, 0.53523136E-09_JPRB, 0.53519766E-09_JPRB, &
  & 0.53516491E-09_JPRB, 0.53513349E-09_JPRB, 0.53510335E-09_JPRB, 0.53507598E-09_JPRB, 0.53505156E-09_JPRB, 0.53502885E-09_JPRB, &
  & 0.53500493E-09_JPRB, 0.53497312E-09_JPRB, 0.53492072E-09_JPRB, 0.53480087E-09_JPRB /)

RGHG6(:,71, 3) = (/ &
  & 0.53455157E-09_JPRB, 0.53466964E-09_JPRB, 0.53472649E-09_JPRB, 0.53477012E-09_JPRB, 0.53480737E-09_JPRB, 0.53484156E-09_JPRB, &
  & 0.53487392E-09_JPRB, 0.53490778E-09_JPRB, 0.53494292E-09_JPRB, 0.53497767E-09_JPRB, 0.53500981E-09_JPRB, 0.53503563E-09_JPRB, &
  & 0.53505278E-09_JPRB, 0.53505861E-09_JPRB, 0.53505272E-09_JPRB, 0.53503962E-09_JPRB, 0.53502902E-09_JPRB, 0.53503274E-09_JPRB, &
  & 0.53506538E-09_JPRB, 0.53513111E-09_JPRB, 0.53522869E-09_JPRB, 0.53534727E-09_JPRB, 0.53547344E-09_JPRB, 0.53559490E-09_JPRB, &
  & 0.53570082E-09_JPRB, 0.53578408E-09_JPRB, 0.53584348E-09_JPRB, 0.53587940E-09_JPRB, 0.53589500E-09_JPRB, 0.53589183E-09_JPRB, &
  & 0.53587113E-09_JPRB, 0.53583232E-09_JPRB, 0.53577592E-09_JPRB, 0.53570270E-09_JPRB, 0.53561605E-09_JPRB, 0.53552018E-09_JPRB, &
  & 0.53542276E-09_JPRB, 0.53533122E-09_JPRB, 0.53525484E-09_JPRB, 0.53520149E-09_JPRB, 0.53517568E-09_JPRB, 0.53518079E-09_JPRB, &
  & 0.53521393E-09_JPRB, 0.53526605E-09_JPRB, 0.53532434E-09_JPRB, 0.53537735E-09_JPRB, 0.53541527E-09_JPRB, 0.53543364E-09_JPRB, &
  & 0.53543370E-09_JPRB, 0.53541982E-09_JPRB, 0.53539584E-09_JPRB, 0.53536736E-09_JPRB, 0.53533700E-09_JPRB, 0.53530536E-09_JPRB, &
  & 0.53527477E-09_JPRB, 0.53524529E-09_JPRB, 0.53521726E-09_JPRB, 0.53519122E-09_JPRB, 0.53516824E-09_JPRB, 0.53514682E-09_JPRB, &
  & 0.53512389E-09_JPRB, 0.53509308E-09_JPRB, 0.53504001E-09_JPRB, 0.53491700E-09_JPRB /)

RGHG6(:,72, 3) = (/ &
  & 0.53468124E-09_JPRB, 0.53481580E-09_JPRB, 0.53488214E-09_JPRB, 0.53492899E-09_JPRB, 0.53496868E-09_JPRB, 0.53500321E-09_JPRB, &
  & 0.53503618E-09_JPRB, 0.53506943E-09_JPRB, 0.53510246E-09_JPRB, 0.53513577E-09_JPRB, 0.53516430E-09_JPRB, 0.53518739E-09_JPRB, &
  & 0.53520233E-09_JPRB, 0.53520677E-09_JPRB, 0.53520111E-09_JPRB, 0.53518900E-09_JPRB, 0.53518007E-09_JPRB, 0.53518234E-09_JPRB, &
  & 0.53520993E-09_JPRB, 0.53526539E-09_JPRB, 0.53534860E-09_JPRB, 0.53544885E-09_JPRB, 0.53555615E-09_JPRB, 0.53565946E-09_JPRB, &
  & 0.53574911E-09_JPRB, 0.53581994E-09_JPRB, 0.53587051E-09_JPRB, 0.53590049E-09_JPRB, 0.53591342E-09_JPRB, 0.53590993E-09_JPRB, &
  & 0.53589239E-09_JPRB, 0.53585908E-09_JPRB, 0.53581073E-09_JPRB, 0.53574806E-09_JPRB, 0.53567306E-09_JPRB, 0.53558957E-09_JPRB, &
  & 0.53550470E-09_JPRB, 0.53542509E-09_JPRB, 0.53535976E-09_JPRB, 0.53531501E-09_JPRB, 0.53529425E-09_JPRB, 0.53530036E-09_JPRB, &
  & 0.53533067E-09_JPRB, 0.53537630E-09_JPRB, 0.53542804E-09_JPRB, 0.53547422E-09_JPRB, 0.53550736E-09_JPRB, 0.53552340E-09_JPRB, &
  & 0.53552379E-09_JPRB, 0.53551152E-09_JPRB, 0.53549043E-09_JPRB, 0.53546528E-09_JPRB, 0.53543819E-09_JPRB, 0.53540977E-09_JPRB, &
  & 0.53538191E-09_JPRB, 0.53535570E-09_JPRB, 0.53532995E-09_JPRB, 0.53530658E-09_JPRB, 0.53528526E-09_JPRB, 0.53526555E-09_JPRB, &
  & 0.53524435E-09_JPRB, 0.53521537E-09_JPRB, 0.53516430E-09_JPRB, 0.53504273E-09_JPRB /)

RGHG6(:,73, 3) = (/ &
  & 0.53483434E-09_JPRB, 0.53497595E-09_JPRB, 0.53504373E-09_JPRB, 0.53509064E-09_JPRB, 0.53512955E-09_JPRB, 0.53516336E-09_JPRB, &
  & 0.53519472E-09_JPRB, 0.53522586E-09_JPRB, 0.53525706E-09_JPRB, 0.53528598E-09_JPRB, 0.53531168E-09_JPRB, 0.53533095E-09_JPRB, &
  & 0.53534321E-09_JPRB, 0.53534593E-09_JPRB, 0.53533966E-09_JPRB, 0.53532828E-09_JPRB, 0.53532045E-09_JPRB, 0.53532123E-09_JPRB, &
  & 0.53534410E-09_JPRB, 0.53538990E-09_JPRB, 0.53545923E-09_JPRB, 0.53554250E-09_JPRB, 0.53563165E-09_JPRB, 0.53571825E-09_JPRB, &
  & 0.53579308E-09_JPRB, 0.53585214E-09_JPRB, 0.53589455E-09_JPRB, 0.53591931E-09_JPRB, 0.53592991E-09_JPRB, 0.53592641E-09_JPRB, &
  & 0.53591159E-09_JPRB, 0.53588356E-09_JPRB, 0.53584298E-09_JPRB, 0.53579058E-09_JPRB, 0.53572702E-09_JPRB, 0.53565596E-09_JPRB, &
  & 0.53558336E-09_JPRB, 0.53551530E-09_JPRB, 0.53546045E-09_JPRB, 0.53542371E-09_JPRB, 0.53540733E-09_JPRB, 0.53541410E-09_JPRB, &
  & 0.53544047E-09_JPRB, 0.53548044E-09_JPRB, 0.53552429E-09_JPRB, 0.53556376E-09_JPRB, 0.53559257E-09_JPRB, 0.53560600E-09_JPRB, &
  & 0.53560678E-09_JPRB, 0.53559668E-09_JPRB, 0.53557847E-09_JPRB, 0.53555721E-09_JPRB, 0.53553395E-09_JPRB, 0.53550858E-09_JPRB, &
  & 0.53548493E-09_JPRB, 0.53546156E-09_JPRB, 0.53543969E-09_JPRB, 0.53541832E-09_JPRB, 0.53539950E-09_JPRB, 0.53538179E-09_JPRB, &
  & 0.53536270E-09_JPRB, 0.53533622E-09_JPRB, 0.53528887E-09_JPRB, 0.53517235E-09_JPRB /)

RGHG6(:,74, 3) = (/ &
  & 0.53499366E-09_JPRB, 0.53513943E-09_JPRB, 0.53520555E-09_JPRB, 0.53525034E-09_JPRB, 0.53528615E-09_JPRB, 0.53531718E-09_JPRB, &
  & 0.53534638E-09_JPRB, 0.53537424E-09_JPRB, 0.53540156E-09_JPRB, 0.53542759E-09_JPRB, 0.53544863E-09_JPRB, 0.53546473E-09_JPRB, &
  & 0.53547417E-09_JPRB, 0.53547500E-09_JPRB, 0.53546789E-09_JPRB, 0.53545673E-09_JPRB, 0.53545024E-09_JPRB, 0.53544974E-09_JPRB, &
  & 0.53546789E-09_JPRB, 0.53550475E-09_JPRB, 0.53556104E-09_JPRB, 0.53562860E-09_JPRB, 0.53570087E-09_JPRB, 0.53577215E-09_JPRB, &
  & 0.53583288E-09_JPRB, 0.53588123E-09_JPRB, 0.53591598E-09_JPRB, 0.53593618E-09_JPRB, 0.53594462E-09_JPRB, 0.53594118E-09_JPRB, &
  & 0.53592913E-09_JPRB, 0.53590626E-09_JPRB, 0.53587301E-09_JPRB, 0.53582988E-09_JPRB, 0.53577781E-09_JPRB, 0.53571836E-09_JPRB, &
  & 0.53565830E-09_JPRB, 0.53560151E-09_JPRB, 0.53555649E-09_JPRB, 0.53552723E-09_JPRB, 0.53551436E-09_JPRB, 0.53552107E-09_JPRB, &
  & 0.53554372E-09_JPRB, 0.53557681E-09_JPRB, 0.53561350E-09_JPRB, 0.53564631E-09_JPRB, 0.53567045E-09_JPRB, 0.53568172E-09_JPRB, &
  & 0.53568266E-09_JPRB, 0.53567439E-09_JPRB, 0.53565963E-09_JPRB, 0.53564225E-09_JPRB, 0.53562277E-09_JPRB, 0.53560134E-09_JPRB, &
  & 0.53558080E-09_JPRB, 0.53556209E-09_JPRB, 0.53554294E-09_JPRB, 0.53552474E-09_JPRB, 0.53550808E-09_JPRB, 0.53549287E-09_JPRB, &
  & 0.53547644E-09_JPRB, 0.53545290E-09_JPRB, 0.53541011E-09_JPRB, 0.53530125E-09_JPRB /)

RGHG6(:,75, 3) = (/ &
  & 0.53515742E-09_JPRB, 0.53530064E-09_JPRB, 0.53536431E-09_JPRB, 0.53540256E-09_JPRB, 0.53543470E-09_JPRB, 0.53546190E-09_JPRB, &
  & 0.53548754E-09_JPRB, 0.53551175E-09_JPRB, 0.53553528E-09_JPRB, 0.53555671E-09_JPRB, 0.53557431E-09_JPRB, 0.53558691E-09_JPRB, &
  & 0.53559396E-09_JPRB, 0.53559290E-09_JPRB, 0.53558524E-09_JPRB, 0.53557458E-09_JPRB, 0.53556959E-09_JPRB, 0.53556759E-09_JPRB, &
  & 0.53558169E-09_JPRB, 0.53560995E-09_JPRB, 0.53565480E-09_JPRB, 0.53570759E-09_JPRB, 0.53576471E-09_JPRB, 0.53582172E-09_JPRB, &
  & 0.53586896E-09_JPRB, 0.53590726E-09_JPRB, 0.53593519E-09_JPRB, 0.53595117E-09_JPRB, 0.53595789E-09_JPRB, 0.53595439E-09_JPRB, &
  & 0.53594501E-09_JPRB, 0.53592691E-09_JPRB, 0.53590038E-09_JPRB, 0.53586635E-09_JPRB, 0.53582544E-09_JPRB, 0.53577726E-09_JPRB, &
  & 0.53572918E-09_JPRB, 0.53568328E-09_JPRB, 0.53564775E-09_JPRB, 0.53562499E-09_JPRB, 0.53561516E-09_JPRB, 0.53562138E-09_JPRB, &
  & 0.53563953E-09_JPRB, 0.53566651E-09_JPRB, 0.53569582E-09_JPRB, 0.53572191E-09_JPRB, 0.53574223E-09_JPRB, 0.53575078E-09_JPRB, &
  & 0.53575183E-09_JPRB, 0.53574550E-09_JPRB, 0.53573346E-09_JPRB, 0.53572019E-09_JPRB, 0.53570481E-09_JPRB, 0.53568605E-09_JPRB, &
  & 0.53566990E-09_JPRB, 0.53565458E-09_JPRB, 0.53563981E-09_JPRB, 0.53562399E-09_JPRB, 0.53561017E-09_JPRB, 0.53559779E-09_JPRB, &
  & 0.53558435E-09_JPRB, 0.53556415E-09_JPRB, 0.53552623E-09_JPRB, 0.53542593E-09_JPRB /)

RGHG6(:,76, 3) = (/ &
  & 0.53532201E-09_JPRB, 0.53545912E-09_JPRB, 0.53551441E-09_JPRB, 0.53554644E-09_JPRB, 0.53557275E-09_JPRB, 0.53559557E-09_JPRB, &
  & 0.53561738E-09_JPRB, 0.53563692E-09_JPRB, 0.53565624E-09_JPRB, 0.53567317E-09_JPRB, 0.53568638E-09_JPRB, 0.53569593E-09_JPRB, &
  & 0.53570121E-09_JPRB, 0.53569893E-09_JPRB, 0.53569138E-09_JPRB, 0.53568178E-09_JPRB, 0.53567872E-09_JPRB, 0.53567561E-09_JPRB, &
  & 0.53568572E-09_JPRB, 0.53570653E-09_JPRB, 0.53574079E-09_JPRB, 0.53578075E-09_JPRB, 0.53582316E-09_JPRB, 0.53586713E-09_JPRB, &
  & 0.53590143E-09_JPRB, 0.53593063E-09_JPRB, 0.53595234E-09_JPRB, 0.53596466E-09_JPRB, 0.53596977E-09_JPRB, 0.53596605E-09_JPRB, &
  & 0.53595961E-09_JPRB, 0.53594568E-09_JPRB, 0.53592530E-09_JPRB, 0.53590005E-09_JPRB, 0.53586979E-09_JPRB, 0.53583205E-09_JPRB, &
  & 0.53579557E-09_JPRB, 0.53576044E-09_JPRB, 0.53573368E-09_JPRB, 0.53571697E-09_JPRB, 0.53570937E-09_JPRB, 0.53571458E-09_JPRB, &
  & 0.53572841E-09_JPRB, 0.53574906E-09_JPRB, 0.53577159E-09_JPRB, 0.53579136E-09_JPRB, 0.53580751E-09_JPRB, 0.53581362E-09_JPRB, &
  & 0.53581456E-09_JPRB, 0.53580967E-09_JPRB, 0.53580074E-09_JPRB, 0.53579119E-09_JPRB, 0.53577931E-09_JPRB, 0.53576366E-09_JPRB, &
  & 0.53575089E-09_JPRB, 0.53573995E-09_JPRB, 0.53572891E-09_JPRB, 0.53571647E-09_JPRB, 0.53570515E-09_JPRB, 0.53569577E-09_JPRB, &
  & 0.53568588E-09_JPRB, 0.53566918E-09_JPRB, 0.53563709E-09_JPRB, 0.53554516E-09_JPRB /)

RGHG6(:,77, 3) = (/ &
  & 0.53548832E-09_JPRB, 0.53560872E-09_JPRB, 0.53565624E-09_JPRB, 0.53567850E-09_JPRB, 0.53569932E-09_JPRB, 0.53571669E-09_JPRB, &
  & 0.53573396E-09_JPRB, 0.53574878E-09_JPRB, 0.53576277E-09_JPRB, 0.53577515E-09_JPRB, 0.53578386E-09_JPRB, 0.53579052E-09_JPRB, &
  & 0.53579458E-09_JPRB, 0.53579174E-09_JPRB, 0.53578536E-09_JPRB, 0.53577731E-09_JPRB, 0.53577676E-09_JPRB, 0.53577293E-09_JPRB, &
  & 0.53577992E-09_JPRB, 0.53579358E-09_JPRB, 0.53581933E-09_JPRB, 0.53584698E-09_JPRB, 0.53587634E-09_JPRB, 0.53590832E-09_JPRB, &
  & 0.53593030E-09_JPRB, 0.53595145E-09_JPRB, 0.53596749E-09_JPRB, 0.53597654E-09_JPRB, 0.53598048E-09_JPRB, 0.53597654E-09_JPRB, &
  & 0.53597282E-09_JPRB, 0.53596255E-09_JPRB, 0.53594784E-09_JPRB, 0.53593074E-09_JPRB, 0.53590998E-09_JPRB, 0.53588256E-09_JPRB, &
  & 0.53585669E-09_JPRB, 0.53583188E-09_JPRB, 0.53581356E-09_JPRB, 0.53580218E-09_JPRB, 0.53579624E-09_JPRB, 0.53579996E-09_JPRB, &
  & 0.53580890E-09_JPRB, 0.53582405E-09_JPRB, 0.53584048E-09_JPRB, 0.53585381E-09_JPRB, 0.53586646E-09_JPRB, 0.53586968E-09_JPRB, &
  & 0.53587063E-09_JPRB, 0.53586724E-09_JPRB, 0.53586069E-09_JPRB, 0.53585497E-09_JPRB, 0.53584681E-09_JPRB, 0.53583321E-09_JPRB, &
  & 0.53582411E-09_JPRB, 0.53581717E-09_JPRB, 0.53581045E-09_JPRB, 0.53580068E-09_JPRB, 0.53579230E-09_JPRB, 0.53578603E-09_JPRB, &
  & 0.53577981E-09_JPRB, 0.53576682E-09_JPRB, 0.53574090E-09_JPRB, 0.53566035E-09_JPRB /)

RGHG6(:,78, 3) = (/ &
  & 0.53565175E-09_JPRB, 0.53574489E-09_JPRB, 0.53577831E-09_JPRB, 0.53579136E-09_JPRB, 0.53580618E-09_JPRB, 0.53581861E-09_JPRB, &
  & 0.53583127E-09_JPRB, 0.53584021E-09_JPRB, 0.53584981E-09_JPRB, 0.53585675E-09_JPRB, 0.53586158E-09_JPRB, 0.53586569E-09_JPRB, &
  & 0.53586929E-09_JPRB, 0.53586652E-09_JPRB, 0.53586185E-09_JPRB, 0.53585625E-09_JPRB, 0.53585852E-09_JPRB, 0.53585480E-09_JPRB, &
  & 0.53585936E-09_JPRB, 0.53586752E-09_JPRB, 0.53588606E-09_JPRB, 0.53590349E-09_JPRB, 0.53592120E-09_JPRB, 0.53594296E-09_JPRB, &
  & 0.53595450E-09_JPRB, 0.53596866E-09_JPRB, 0.53598015E-09_JPRB, 0.53598659E-09_JPRB, 0.53598948E-09_JPRB, 0.53598531E-09_JPRB, &
  & 0.53598392E-09_JPRB, 0.53597676E-09_JPRB, 0.53596705E-09_JPRB, 0.53595667E-09_JPRB, 0.53594462E-09_JPRB, 0.53592580E-09_JPRB, &
  & 0.53590948E-09_JPRB, 0.53589372E-09_JPRB, 0.53588273E-09_JPRB, 0.53587579E-09_JPRB, 0.53587068E-09_JPRB, 0.53587229E-09_JPRB, &
  & 0.53587668E-09_JPRB, 0.53588722E-09_JPRB, 0.53589788E-09_JPRB, 0.53590576E-09_JPRB, 0.53591553E-09_JPRB, 0.53591620E-09_JPRB, &
  & 0.53591714E-09_JPRB, 0.53591487E-09_JPRB, 0.53591065E-09_JPRB, 0.53590826E-09_JPRB, 0.53590327E-09_JPRB, 0.53589111E-09_JPRB, &
  & 0.53588528E-09_JPRB, 0.53588195E-09_JPRB, 0.53587906E-09_JPRB, 0.53587179E-09_JPRB, 0.53586574E-09_JPRB, 0.53586258E-09_JPRB, &
  & 0.53585986E-09_JPRB, 0.53585031E-09_JPRB, 0.53583371E-09_JPRB, 0.53577076E-09_JPRB /)

RGHG6(:,79, 3) = (/ &
  & 0.53575794E-09_JPRB, 0.53582039E-09_JPRB, 0.53584376E-09_JPRB, 0.53584909E-09_JPRB, 0.53586130E-09_JPRB, 0.53587107E-09_JPRB, &
  & 0.53588134E-09_JPRB, 0.53588761E-09_JPRB, 0.53589388E-09_JPRB, 0.53589916E-09_JPRB, 0.53590166E-09_JPRB, 0.53590488E-09_JPRB, &
  & 0.53590848E-09_JPRB, 0.53590549E-09_JPRB, 0.53590149E-09_JPRB, 0.53589705E-09_JPRB, 0.53590160E-09_JPRB, 0.53589760E-09_JPRB, &
  & 0.53590121E-09_JPRB, 0.53590632E-09_JPRB, 0.53592186E-09_JPRB, 0.53593374E-09_JPRB, 0.53594529E-09_JPRB, 0.53596189E-09_JPRB, &
  & 0.53596733E-09_JPRB, 0.53597782E-09_JPRB, 0.53598725E-09_JPRB, 0.53599236E-09_JPRB, 0.53599480E-09_JPRB, 0.53599020E-09_JPRB, &
  & 0.53599031E-09_JPRB, 0.53598465E-09_JPRB, 0.53597748E-09_JPRB, 0.53597116E-09_JPRB, 0.53596400E-09_JPRB, 0.53594967E-09_JPRB, &
  & 0.53593840E-09_JPRB, 0.53592736E-09_JPRB, 0.53592053E-09_JPRB, 0.53591565E-09_JPRB, 0.53591070E-09_JPRB, 0.53591104E-09_JPRB, &
  & 0.53591265E-09_JPRB, 0.53592070E-09_JPRB, 0.53592858E-09_JPRB, 0.53593308E-09_JPRB, 0.53594179E-09_JPRB, 0.53594057E-09_JPRB, &
  & 0.53594168E-09_JPRB, 0.53594007E-09_JPRB, 0.53593674E-09_JPRB, 0.53593641E-09_JPRB, 0.53593319E-09_JPRB, 0.53592086E-09_JPRB, &
  & 0.53591664E-09_JPRB, 0.53591515E-09_JPRB, 0.53591465E-09_JPRB, 0.53590837E-09_JPRB, 0.53590327E-09_JPRB, 0.53590171E-09_JPRB, &
  & 0.53590127E-09_JPRB, 0.53589450E-09_JPRB, 0.53588545E-09_JPRB, 0.53584198E-09_JPRB /)

RGHG6(:,80, 3) = (/ &
  & 0.53582866E-09_JPRB, 0.53585686E-09_JPRB, 0.53587240E-09_JPRB, 0.53587385E-09_JPRB, 0.53588473E-09_JPRB, 0.53589344E-09_JPRB, &
  & 0.53590310E-09_JPRB, 0.53590743E-09_JPRB, 0.53591387E-09_JPRB, 0.53591742E-09_JPRB, 0.53591975E-09_JPRB, 0.53592242E-09_JPRB, &
  & 0.53592647E-09_JPRB, 0.53592319E-09_JPRB, 0.53591920E-09_JPRB, 0.53591503E-09_JPRB, 0.53592103E-09_JPRB, 0.53591664E-09_JPRB, &
  & 0.53591986E-09_JPRB, 0.53592347E-09_JPRB, 0.53593802E-09_JPRB, 0.53594740E-09_JPRB, 0.53595622E-09_JPRB, 0.53597043E-09_JPRB, &
  & 0.53597293E-09_JPRB, 0.53598193E-09_JPRB, 0.53599064E-09_JPRB, 0.53599530E-09_JPRB, 0.53599758E-09_JPRB, 0.53599253E-09_JPRB, &
  & 0.53599342E-09_JPRB, 0.53598831E-09_JPRB, 0.53598248E-09_JPRB, 0.53597798E-09_JPRB, 0.53597310E-09_JPRB, 0.53596072E-09_JPRB, &
  & 0.53595173E-09_JPRB, 0.53594285E-09_JPRB, 0.53593785E-09_JPRB, 0.53593407E-09_JPRB, 0.53592897E-09_JPRB, 0.53592847E-09_JPRB, &
  & 0.53592858E-09_JPRB, 0.53593580E-09_JPRB, 0.53594246E-09_JPRB, 0.53594545E-09_JPRB, 0.53595384E-09_JPRB, 0.53595151E-09_JPRB, &
  & 0.53595250E-09_JPRB, 0.53595101E-09_JPRB, 0.53594817E-09_JPRB, 0.53594890E-09_JPRB, 0.53594634E-09_JPRB, 0.53593341E-09_JPRB, &
  & 0.53592975E-09_JPRB, 0.53592930E-09_JPRB, 0.53592997E-09_JPRB, 0.53592386E-09_JPRB, 0.53591909E-09_JPRB, 0.53591831E-09_JPRB, &
  & 0.53591931E-09_JPRB, 0.53591370E-09_JPRB, 0.53591059E-09_JPRB, 0.53588894E-09_JPRB /)

RGHG6(:,81, 3) = (/ &
  & 0.53587762E-09_JPRB, 0.53587207E-09_JPRB, 0.53588445E-09_JPRB, 0.53588411E-09_JPRB, 0.53589466E-09_JPRB, 0.53590316E-09_JPRB, &
  & 0.53591209E-09_JPRB, 0.53591687E-09_JPRB, 0.53592142E-09_JPRB, 0.53592608E-09_JPRB, 0.53592752E-09_JPRB, 0.53593058E-09_JPRB, &
  & 0.53593452E-09_JPRB, 0.53593108E-09_JPRB, 0.53592702E-09_JPRB, 0.53592275E-09_JPRB, 0.53592963E-09_JPRB, 0.53592486E-09_JPRB, &
  & 0.53592791E-09_JPRB, 0.53593097E-09_JPRB, 0.53594529E-09_JPRB, 0.53595350E-09_JPRB, 0.53596089E-09_JPRB, 0.53597432E-09_JPRB, &
  & 0.53597538E-09_JPRB, 0.53598387E-09_JPRB, 0.53599220E-09_JPRB, 0.53599680E-09_JPRB, 0.53599902E-09_JPRB, 0.53599364E-09_JPRB, &
  & 0.53599503E-09_JPRB, 0.53599009E-09_JPRB, 0.53598470E-09_JPRB, 0.53598104E-09_JPRB, 0.53597721E-09_JPRB, 0.53596572E-09_JPRB, &
  & 0.53595783E-09_JPRB, 0.53594990E-09_JPRB, 0.53594573E-09_JPRB, 0.53594240E-09_JPRB, 0.53593718E-09_JPRB, 0.53593635E-09_JPRB, &
  & 0.53593563E-09_JPRB, 0.53594257E-09_JPRB, 0.53594862E-09_JPRB, 0.53595073E-09_JPRB, 0.53595917E-09_JPRB, 0.53595611E-09_JPRB, &
  & 0.53595728E-09_JPRB, 0.53595572E-09_JPRB, 0.53595312E-09_JPRB, 0.53595434E-09_JPRB, 0.53595212E-09_JPRB, 0.53593863E-09_JPRB, &
  & 0.53593524E-09_JPRB, 0.53593513E-09_JPRB, 0.53593641E-09_JPRB, 0.53593036E-09_JPRB, 0.53592564E-09_JPRB, 0.53592530E-09_JPRB, &
  & 0.53592686E-09_JPRB, 0.53592186E-09_JPRB, 0.53592120E-09_JPRB, 0.53592109E-09_JPRB /)

RGHG6(:,82, 3) = (/ &
  & 0.53588151E-09_JPRB, 0.53587706E-09_JPRB, 0.53588978E-09_JPRB, 0.53588894E-09_JPRB, 0.53589960E-09_JPRB, 0.53590737E-09_JPRB, &
  & 0.53591703E-09_JPRB, 0.53592014E-09_JPRB, 0.53592680E-09_JPRB, 0.53592958E-09_JPRB, 0.53593191E-09_JPRB, 0.53593424E-09_JPRB, &
  & 0.53593874E-09_JPRB, 0.53593502E-09_JPRB, 0.53593086E-09_JPRB, 0.53592653E-09_JPRB, 0.53593402E-09_JPRB, 0.53592897E-09_JPRB, &
  & 0.53593185E-09_JPRB, 0.53593463E-09_JPRB, 0.53594895E-09_JPRB, 0.53595639E-09_JPRB, 0.53596322E-09_JPRB, 0.53597626E-09_JPRB, &
  & 0.53597649E-09_JPRB, 0.53598470E-09_JPRB, 0.53599303E-09_JPRB, 0.53599764E-09_JPRB, 0.53599974E-09_JPRB, 0.53599414E-09_JPRB, &
  & 0.53599586E-09_JPRB, 0.53599086E-09_JPRB, 0.53598581E-09_JPRB, 0.53598259E-09_JPRB, 0.53597921E-09_JPRB, 0.53596816E-09_JPRB, &
  & 0.53596078E-09_JPRB, 0.53595361E-09_JPRB, 0.53594973E-09_JPRB, 0.53594662E-09_JPRB, 0.53594135E-09_JPRB, 0.53594018E-09_JPRB, &
  & 0.53593913E-09_JPRB, 0.53594595E-09_JPRB, 0.53595173E-09_JPRB, 0.53595339E-09_JPRB, 0.53596194E-09_JPRB, 0.53595839E-09_JPRB, &
  & 0.53595955E-09_JPRB, 0.53595806E-09_JPRB, 0.53595556E-09_JPRB, 0.53595700E-09_JPRB, 0.53595495E-09_JPRB, 0.53594096E-09_JPRB, &
  & 0.53593774E-09_JPRB, 0.53593796E-09_JPRB, 0.53593968E-09_JPRB, 0.53593346E-09_JPRB, 0.53592875E-09_JPRB, 0.53592858E-09_JPRB, &
  & 0.53593052E-09_JPRB, 0.53592542E-09_JPRB, 0.53592480E-09_JPRB, 0.53592364E-09_JPRB /)

RGHG6(:,83, 3) = (/ &
  & 0.53588423E-09_JPRB, 0.53587995E-09_JPRB, 0.53589277E-09_JPRB, 0.53589150E-09_JPRB, 0.53590221E-09_JPRB, 0.53591076E-09_JPRB, &
  & 0.53591881E-09_JPRB, 0.53592381E-09_JPRB, 0.53592747E-09_JPRB, 0.53593258E-09_JPRB, 0.53593374E-09_JPRB, 0.53593707E-09_JPRB, &
  & 0.53594090E-09_JPRB, 0.53593718E-09_JPRB, 0.53593291E-09_JPRB, 0.53592863E-09_JPRB, 0.53593652E-09_JPRB, 0.53593119E-09_JPRB, &
  & 0.53593419E-09_JPRB, 0.53593652E-09_JPRB, 0.53595106E-09_JPRB, 0.53595811E-09_JPRB, 0.53596450E-09_JPRB, 0.53597748E-09_JPRB, &
  & 0.53597704E-09_JPRB, 0.53598520E-09_JPRB, 0.53599358E-09_JPRB, 0.53599819E-09_JPRB, 0.53600030E-09_JPRB, 0.53599442E-09_JPRB, &
  & 0.53599641E-09_JPRB, 0.53599136E-09_JPRB, 0.53598642E-09_JPRB, 0.53598331E-09_JPRB, 0.53598020E-09_JPRB, 0.53596966E-09_JPRB, &
  & 0.53596255E-09_JPRB, 0.53595578E-09_JPRB, 0.53595217E-09_JPRB, 0.53594923E-09_JPRB, 0.53594390E-09_JPRB, 0.53594251E-09_JPRB, &
  & 0.53594107E-09_JPRB, 0.53594790E-09_JPRB, 0.53595350E-09_JPRB, 0.53595484E-09_JPRB, 0.53596366E-09_JPRB, 0.53595972E-09_JPRB, &
  & 0.53596083E-09_JPRB, 0.53595939E-09_JPRB, 0.53595678E-09_JPRB, 0.53595850E-09_JPRB, 0.53595667E-09_JPRB, 0.53594212E-09_JPRB, &
  & 0.53593896E-09_JPRB, 0.53593951E-09_JPRB, 0.53594140E-09_JPRB, 0.53593507E-09_JPRB, 0.53593041E-09_JPRB, 0.53593047E-09_JPRB, &
  & 0.53593258E-09_JPRB, 0.53592747E-09_JPRB, 0.53592697E-09_JPRB, 0.53592553E-09_JPRB /)

RGHG6(:,84, 3) = (/ &
  & 0.53588611E-09_JPRB, 0.53588167E-09_JPRB, 0.53589461E-09_JPRB, 0.53589311E-09_JPRB, 0.53590399E-09_JPRB, 0.53591159E-09_JPRB, &
  & 0.53592147E-09_JPRB, 0.53592408E-09_JPRB, 0.53593086E-09_JPRB, 0.53593324E-09_JPRB, 0.53593580E-09_JPRB, 0.53593802E-09_JPRB, &
  & 0.53594224E-09_JPRB, 0.53593863E-09_JPRB, 0.53593441E-09_JPRB, 0.53593002E-09_JPRB, 0.53593802E-09_JPRB, 0.53593263E-09_JPRB, &
  & 0.53593552E-09_JPRB, 0.53593779E-09_JPRB, 0.53595239E-09_JPRB, 0.53595922E-09_JPRB, 0.53596533E-09_JPRB, 0.53597826E-09_JPRB, &
  & 0.53597732E-09_JPRB, 0.53598553E-09_JPRB, 0.53599392E-09_JPRB, 0.53599858E-09_JPRB, 0.53600063E-09_JPRB, 0.53599464E-09_JPRB, &
  & 0.53599669E-09_JPRB, 0.53599164E-09_JPRB, 0.53598670E-09_JPRB, 0.53598387E-09_JPRB, 0.53598059E-09_JPRB, 0.53597071E-09_JPRB, &
  & 0.53596383E-09_JPRB, 0.53595722E-09_JPRB, 0.53595373E-09_JPRB, 0.53595062E-09_JPRB, 0.53594562E-09_JPRB, 0.53594401E-09_JPRB, &
  & 0.53594240E-09_JPRB, 0.53594901E-09_JPRB, 0.53595461E-09_JPRB, 0.53595572E-09_JPRB, 0.53596472E-09_JPRB, 0.53596044E-09_JPRB, &
  & 0.53596150E-09_JPRB, 0.53596017E-09_JPRB, 0.53595761E-09_JPRB, 0.53595939E-09_JPRB, 0.53595761E-09_JPRB, 0.53594290E-09_JPRB, &
  & 0.53593968E-09_JPRB, 0.53594035E-09_JPRB, 0.53594251E-09_JPRB, 0.53593613E-09_JPRB, 0.53593141E-09_JPRB, 0.53593158E-09_JPRB, &
  & 0.53593385E-09_JPRB, 0.53592875E-09_JPRB, 0.53592836E-09_JPRB, 0.53592680E-09_JPRB /)

RGHG6(:,85, 3) = (/ &
  & 0.53588728E-09_JPRB, 0.53588289E-09_JPRB, 0.53589572E-09_JPRB, 0.53589411E-09_JPRB, 0.53590482E-09_JPRB, 0.53591426E-09_JPRB, &
  & 0.53592147E-09_JPRB, 0.53592691E-09_JPRB, 0.53593024E-09_JPRB, 0.53593474E-09_JPRB, 0.53593635E-09_JPRB, 0.53593924E-09_JPRB, &
  & 0.53594212E-09_JPRB, 0.53593935E-09_JPRB, 0.53593535E-09_JPRB, 0.53593124E-09_JPRB, 0.53593885E-09_JPRB, 0.53593358E-09_JPRB, &
  & 0.53593652E-09_JPRB, 0.53593840E-09_JPRB, 0.53595328E-09_JPRB, 0.53595994E-09_JPRB, 0.53596577E-09_JPRB, 0.53597893E-09_JPRB, &
  & 0.53597732E-09_JPRB, 0.53598564E-09_JPRB, 0.53599414E-09_JPRB, 0.53599886E-09_JPRB, 0.53600102E-09_JPRB, 0.53599469E-09_JPRB, &
  & 0.53599702E-09_JPRB, 0.53599192E-09_JPRB, 0.53598698E-09_JPRB, 0.53598415E-09_JPRB, 0.53598109E-09_JPRB, 0.53597121E-09_JPRB, &
  & 0.53596450E-09_JPRB, 0.53595817E-09_JPRB, 0.53595478E-09_JPRB, 0.53595189E-09_JPRB, 0.53594673E-09_JPRB, 0.53594507E-09_JPRB, &
  & 0.53594335E-09_JPRB, 0.53594984E-09_JPRB, 0.53595545E-09_JPRB, 0.53595628E-09_JPRB, 0.53596549E-09_JPRB, 0.53596094E-09_JPRB, &
  & 0.53596194E-09_JPRB, 0.53596050E-09_JPRB, 0.53595806E-09_JPRB, 0.53596011E-09_JPRB, 0.53595833E-09_JPRB, 0.53594323E-09_JPRB, &
  & 0.53594001E-09_JPRB, 0.53594090E-09_JPRB, 0.53594318E-09_JPRB, 0.53593679E-09_JPRB, 0.53593202E-09_JPRB, 0.53593230E-09_JPRB, &
  & 0.53593469E-09_JPRB, 0.53592958E-09_JPRB, 0.53592925E-09_JPRB, 0.53592764E-09_JPRB /)

RGHG6(:,86, 3) = (/ &
  & 0.53588806E-09_JPRB, 0.53588345E-09_JPRB, 0.53589655E-09_JPRB, 0.53589466E-09_JPRB, 0.53590643E-09_JPRB, 0.53591387E-09_JPRB, &
  & 0.53592408E-09_JPRB, 0.53592691E-09_JPRB, 0.53593224E-09_JPRB, 0.53593480E-09_JPRB, 0.53593707E-09_JPRB, 0.53593924E-09_JPRB, &
  & 0.53594168E-09_JPRB, 0.53593968E-09_JPRB, 0.53593618E-09_JPRB, 0.53593258E-09_JPRB, 0.53593918E-09_JPRB, 0.53593430E-09_JPRB, &
  & 0.53593713E-09_JPRB, 0.53593890E-09_JPRB, 0.53595384E-09_JPRB, 0.53596033E-09_JPRB, 0.53596599E-09_JPRB, 0.53597948E-09_JPRB, &
  & 0.53597732E-09_JPRB, 0.53598570E-09_JPRB, 0.53599436E-09_JPRB, 0.53599908E-09_JPRB, 0.53600124E-09_JPRB, 0.53599486E-09_JPRB, &
  & 0.53599719E-09_JPRB, 0.53599192E-09_JPRB, 0.53598714E-09_JPRB, 0.53598442E-09_JPRB, 0.53598126E-09_JPRB, 0.53597182E-09_JPRB, &
  & 0.53596488E-09_JPRB, 0.53595872E-09_JPRB, 0.53595556E-09_JPRB, 0.53595245E-09_JPRB, 0.53594756E-09_JPRB, 0.53594562E-09_JPRB, &
  & 0.53594396E-09_JPRB, 0.53595040E-09_JPRB, 0.53595600E-09_JPRB, 0.53595667E-09_JPRB, 0.53596605E-09_JPRB, 0.53596128E-09_JPRB, &
  & 0.53596216E-09_JPRB, 0.53596078E-09_JPRB, 0.53595828E-09_JPRB, 0.53596050E-09_JPRB, 0.53595872E-09_JPRB, 0.53594346E-09_JPRB, &
  & 0.53594018E-09_JPRB, 0.53594118E-09_JPRB, 0.53594368E-09_JPRB, 0.53593718E-09_JPRB, 0.53593235E-09_JPRB, 0.53593269E-09_JPRB, &
  & 0.53593524E-09_JPRB, 0.53593008E-09_JPRB, 0.53592975E-09_JPRB, 0.53592819E-09_JPRB /)

RGHG6(:,87, 3) = (/ &
  & 0.53588856E-09_JPRB, 0.53588395E-09_JPRB, 0.53589699E-09_JPRB, 0.53589549E-09_JPRB, 0.53590626E-09_JPRB, 0.53591709E-09_JPRB, &
  & 0.53592331E-09_JPRB, 0.53592869E-09_JPRB, 0.53593185E-09_JPRB, 0.53593524E-09_JPRB, 0.53593702E-09_JPRB, 0.53593913E-09_JPRB, &
  & 0.53594107E-09_JPRB, 0.53593957E-09_JPRB, 0.53593663E-09_JPRB, 0.53593363E-09_JPRB, 0.53593924E-09_JPRB, 0.53593485E-09_JPRB, &
  & 0.53593746E-09_JPRB, 0.53593896E-09_JPRB, 0.53595417E-09_JPRB, 0.53596072E-09_JPRB, 0.53596605E-09_JPRB, 0.53597993E-09_JPRB, &
  & 0.53597726E-09_JPRB, 0.53598570E-09_JPRB, 0.53599442E-09_JPRB, 0.53599924E-09_JPRB, 0.53600152E-09_JPRB, 0.53599486E-09_JPRB, &
  & 0.53599747E-09_JPRB, 0.53599203E-09_JPRB, 0.53598725E-09_JPRB, 0.53598459E-09_JPRB, 0.53598198E-09_JPRB, 0.53597182E-09_JPRB, &
  & 0.53596533E-09_JPRB, 0.53595889E-09_JPRB, 0.53595578E-09_JPRB, 0.53595323E-09_JPRB, 0.53594762E-09_JPRB, 0.53594595E-09_JPRB, &
  & 0.53594384E-09_JPRB, 0.53595101E-09_JPRB, 0.53595650E-09_JPRB, 0.53595700E-09_JPRB, 0.53596649E-09_JPRB, 0.53596144E-09_JPRB, &
  & 0.53596244E-09_JPRB, 0.53596094E-09_JPRB, 0.53595844E-09_JPRB, 0.53596078E-09_JPRB, 0.53595905E-09_JPRB, 0.53594351E-09_JPRB, &
  & 0.53594013E-09_JPRB, 0.53594135E-09_JPRB, 0.53594407E-09_JPRB, 0.53593729E-09_JPRB, 0.53593252E-09_JPRB, 0.53593296E-09_JPRB, &
  & 0.53593557E-09_JPRB, 0.53593041E-09_JPRB, 0.53593002E-09_JPRB, 0.53592852E-09_JPRB /)

RGHG6(:,88, 3) = (/ &
  & 0.53588872E-09_JPRB, 0.53588434E-09_JPRB, 0.53589710E-09_JPRB, 0.53589549E-09_JPRB, 0.53590798E-09_JPRB, 0.53591531E-09_JPRB, &
  & 0.53592519E-09_JPRB, 0.53592819E-09_JPRB, 0.53593274E-09_JPRB, 0.53593524E-09_JPRB, 0.53593724E-09_JPRB, 0.53593918E-09_JPRB, &
  & 0.53594107E-09_JPRB, 0.53593968E-09_JPRB, 0.53593685E-09_JPRB, 0.53593407E-09_JPRB, 0.53593940E-09_JPRB, 0.53593513E-09_JPRB, &
  & 0.53593774E-09_JPRB, 0.53593924E-09_JPRB, 0.53595434E-09_JPRB, 0.53596089E-09_JPRB, 0.53596605E-09_JPRB, 0.53598037E-09_JPRB, &
  & 0.53597704E-09_JPRB, 0.53598559E-09_JPRB, 0.53599453E-09_JPRB, 0.53599947E-09_JPRB, 0.53600191E-09_JPRB, 0.53599492E-09_JPRB, &
  & 0.53599764E-09_JPRB, 0.53599214E-09_JPRB, 0.53598737E-09_JPRB, 0.53598481E-09_JPRB, 0.53598248E-09_JPRB, 0.53597221E-09_JPRB, &
  & 0.53596533E-09_JPRB, 0.53595883E-09_JPRB, 0.53595622E-09_JPRB, 0.53595356E-09_JPRB, 0.53594773E-09_JPRB, 0.53594607E-09_JPRB, &
  & 0.53594379E-09_JPRB, 0.53595128E-09_JPRB, 0.53595695E-09_JPRB, 0.53595717E-09_JPRB, 0.53596683E-09_JPRB, 0.53596150E-09_JPRB, &
  & 0.53596244E-09_JPRB, 0.53596111E-09_JPRB, 0.53595856E-09_JPRB, 0.53596094E-09_JPRB, 0.53595917E-09_JPRB, 0.53594340E-09_JPRB, &
  & 0.53594013E-09_JPRB, 0.53594151E-09_JPRB, 0.53594429E-09_JPRB, 0.53593741E-09_JPRB, 0.53593247E-09_JPRB, 0.53593291E-09_JPRB, &
  & 0.53593574E-09_JPRB, 0.53593052E-09_JPRB, 0.53593024E-09_JPRB, 0.53592880E-09_JPRB /)

RGHG6(:,89, 3) = (/ &
  & 0.53588889E-09_JPRB, 0.53588500E-09_JPRB, 0.53589705E-09_JPRB, 0.53589577E-09_JPRB, 0.53590637E-09_JPRB, 0.53591742E-09_JPRB, &
  & 0.53592375E-09_JPRB, 0.53592897E-09_JPRB, 0.53593230E-09_JPRB, 0.53593557E-09_JPRB, 0.53593741E-09_JPRB, 0.53593951E-09_JPRB, &
  & 0.53594151E-09_JPRB, 0.53593996E-09_JPRB, 0.53593685E-09_JPRB, 0.53593385E-09_JPRB, 0.53593985E-09_JPRB, 0.53593513E-09_JPRB, &
  & 0.53593791E-09_JPRB, 0.53593907E-09_JPRB, 0.53595450E-09_JPRB, 0.53596105E-09_JPRB, 0.53596605E-09_JPRB, 0.53598065E-09_JPRB, &
  & 0.53597687E-09_JPRB, 0.53598559E-09_JPRB, 0.53599458E-09_JPRB, 0.53599958E-09_JPRB, 0.53600213E-09_JPRB, 0.53599486E-09_JPRB, &
  & 0.53599802E-09_JPRB, 0.53599225E-09_JPRB, 0.53598742E-09_JPRB, 0.53598498E-09_JPRB, 0.53598337E-09_JPRB, 0.53597182E-09_JPRB, &
  & 0.53596544E-09_JPRB, 0.53595867E-09_JPRB, 0.53595639E-09_JPRB, 0.53595417E-09_JPRB, 0.53594734E-09_JPRB, 0.53594607E-09_JPRB, &
  & 0.53594329E-09_JPRB, 0.53595167E-09_JPRB, 0.53595722E-09_JPRB, 0.53595728E-09_JPRB, 0.53596722E-09_JPRB, 0.53596155E-09_JPRB, &
  & 0.53596239E-09_JPRB, 0.53596116E-09_JPRB, 0.53595856E-09_JPRB, 0.53596089E-09_JPRB, 0.53595933E-09_JPRB, 0.53594329E-09_JPRB, &
  & 0.53594024E-09_JPRB, 0.53594168E-09_JPRB, 0.53594451E-09_JPRB, 0.53593752E-09_JPRB, 0.53593247E-09_JPRB, 0.53593291E-09_JPRB, &
  & 0.53593596E-09_JPRB, 0.53593069E-09_JPRB, 0.53593036E-09_JPRB, 0.53592891E-09_JPRB /)

RGHG6(:,90, 3) = (/ &
  & 0.53588889E-09_JPRB, 0.53588550E-09_JPRB, 0.53589672E-09_JPRB, 0.53589500E-09_JPRB, 0.53590671E-09_JPRB, 0.53591448E-09_JPRB, &
  & 0.53592469E-09_JPRB, 0.53592764E-09_JPRB, 0.53593263E-09_JPRB, 0.53593580E-09_JPRB, 0.53593785E-09_JPRB, 0.53594035E-09_JPRB, &
  & 0.53594301E-09_JPRB, 0.53594063E-09_JPRB, 0.53593652E-09_JPRB, 0.53593285E-09_JPRB, 0.53594085E-09_JPRB, 0.53593496E-09_JPRB, &
  & 0.53593802E-09_JPRB, 0.53593874E-09_JPRB, 0.53595478E-09_JPRB, 0.53596111E-09_JPRB, 0.53596577E-09_JPRB, 0.53598126E-09_JPRB, &
  & 0.53597649E-09_JPRB, 0.53598559E-09_JPRB, 0.53599469E-09_JPRB, 0.53599974E-09_JPRB, 0.53600241E-09_JPRB, 0.53599453E-09_JPRB, &
  & 0.53599825E-09_JPRB, 0.53599214E-09_JPRB, 0.53598731E-09_JPRB, 0.53598509E-09_JPRB, 0.53598403E-09_JPRB, 0.53597177E-09_JPRB, &
  & 0.53596538E-09_JPRB, 0.53595844E-09_JPRB, 0.53595650E-09_JPRB, 0.53595445E-09_JPRB, 0.53594706E-09_JPRB, 0.53594607E-09_JPRB, &
  & 0.53594290E-09_JPRB, 0.53595195E-09_JPRB, 0.53595756E-09_JPRB, 0.53595711E-09_JPRB, 0.53596783E-09_JPRB, 0.53596150E-09_JPRB, &
  & 0.53596250E-09_JPRB, 0.53596128E-09_JPRB, 0.53595850E-09_JPRB, 0.53596105E-09_JPRB, 0.53595978E-09_JPRB, 0.53594296E-09_JPRB, &
  & 0.53594001E-09_JPRB, 0.53594168E-09_JPRB, 0.53594484E-09_JPRB, 0.53593757E-09_JPRB, 0.53593235E-09_JPRB, 0.53593280E-09_JPRB, &
  & 0.53593624E-09_JPRB, 0.53593052E-09_JPRB, 0.53593047E-09_JPRB, 0.53592902E-09_JPRB /)

RGHG6(:,91, 3) = (/ &
  & 0.53588900E-09_JPRB, 0.53588589E-09_JPRB, 0.53589677E-09_JPRB, 0.53589372E-09_JPRB, 0.53590593E-09_JPRB, 0.53591381E-09_JPRB, &
  & 0.53592408E-09_JPRB, 0.53592580E-09_JPRB, 0.53593208E-09_JPRB, 0.53593713E-09_JPRB, 0.53593741E-09_JPRB, 0.53594063E-09_JPRB, &
  & 0.53594695E-09_JPRB, 0.53594107E-09_JPRB, 0.53593596E-09_JPRB, 0.53593024E-09_JPRB, 0.53594312E-09_JPRB, 0.53593391E-09_JPRB, &
  & 0.53593824E-09_JPRB, 0.53593779E-09_JPRB, 0.53595550E-09_JPRB, 0.53596139E-09_JPRB, 0.53596511E-09_JPRB, 0.53598259E-09_JPRB, &
  & 0.53597560E-09_JPRB, 0.53598559E-09_JPRB, 0.53599508E-09_JPRB, 0.53599991E-09_JPRB, 0.53600341E-09_JPRB, 0.53599353E-09_JPRB, &
  & 0.53599919E-09_JPRB, 0.53599220E-09_JPRB, 0.53598709E-09_JPRB, 0.53598492E-09_JPRB, 0.53598520E-09_JPRB, 0.53597105E-09_JPRB, &
  & 0.53596538E-09_JPRB, 0.53595806E-09_JPRB, 0.53595656E-09_JPRB, 0.53595495E-09_JPRB, 0.53594662E-09_JPRB, 0.53594618E-09_JPRB, &
  & 0.53594212E-09_JPRB, 0.53595217E-09_JPRB, 0.53595806E-09_JPRB, 0.53595645E-09_JPRB, 0.53596888E-09_JPRB, 0.53596100E-09_JPRB, &
  & 0.53596266E-09_JPRB, 0.53596133E-09_JPRB, 0.53595817E-09_JPRB, 0.53596133E-09_JPRB, 0.53596083E-09_JPRB, 0.53594185E-09_JPRB, &
  & 0.53593985E-09_JPRB, 0.53594168E-09_JPRB, 0.53594562E-09_JPRB, 0.53593735E-09_JPRB, 0.53593185E-09_JPRB, 0.53593263E-09_JPRB, &
  & 0.53593679E-09_JPRB, 0.53593013E-09_JPRB, 0.53593047E-09_JPRB, 0.53592897E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART6',1,ZHOOK_HANDLE)
END SUBROUTINE PART6






SUBROUTINE PART7
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART7',0,ZHOOK_HANDLE)



!-- Month=  4 ------------

RGHG6(:, 1, 4) = (/ &
  & 0.23975717E-36_JPRB, 0.96354601E-36_JPRB, 0.18808710E-35_JPRB, 0.32407742E-35_JPRB, 0.47876592E-35_JPRB, 0.69093117E-35_JPRB, &
  & 0.10000648E-34_JPRB, 0.14545259E-34_JPRB, 0.21544737E-34_JPRB, 0.32038939E-34_JPRB, 0.48492086E-34_JPRB, 0.74736657E-34_JPRB, &
  & 0.11625545E-33_JPRB, 0.18126272E-33_JPRB, 0.28256021E-33_JPRB, 0.43633262E-33_JPRB, 0.66039135E-33_JPRB, 0.97187742E-33_JPRB, &
  & 0.13960632E-32_JPRB, 0.19591698E-32_JPRB, 0.26975481E-32_JPRB, 0.36631049E-32_JPRB, 0.49241668E-32_JPRB, 0.65519102E-32_JPRB, &
  & 0.87101582E-32_JPRB, 0.11625315E-31_JPRB, 0.15119125E-31_JPRB, 0.19127648E-31_JPRB, 0.23199232E-31_JPRB, 0.26824666E-31_JPRB, &
  & 0.29636281E-31_JPRB, 0.31748933E-31_JPRB, 0.32947819E-31_JPRB, 0.33219121E-31_JPRB, 0.29393201E-31_JPRB, 0.22951892E-31_JPRB, &
  & 0.16641786E-31_JPRB, 0.11745783E-31_JPRB, 0.81891740E-32_JPRB, 0.58076988E-32_JPRB, 0.42018266E-32_JPRB, 0.29581686E-32_JPRB, &
  & 0.20106770E-32_JPRB, 0.12996588E-32_JPRB, 0.80487476E-33_JPRB, 0.48047721E-33_JPRB, 0.27565069E-33_JPRB, 0.15380205E-33_JPRB, &
  & 0.86812146E-34_JPRB, 0.51297161E-34_JPRB, 0.31130991E-34_JPRB, 0.18613662E-34_JPRB, 0.10954435E-34_JPRB, 0.64923671E-35_JPRB, &
  & 0.39107859E-35_JPRB, 0.24248982E-35_JPRB, 0.15607125E-35_JPRB, 0.10527305E-35_JPRB, 0.75054357E-36_JPRB, 0.57415974E-36_JPRB, &
  & 0.44564748E-36_JPRB, 0.31171837E-36_JPRB, 0.13937853E-36_JPRB, 0.20826768E-37_JPRB /)

RGHG6(:, 2, 4) = (/ &
  & 0.10164722E-34_JPRB, 0.38285627E-34_JPRB, 0.80965853E-34_JPRB, 0.13312226E-33_JPRB, 0.19551164E-33_JPRB, 0.28231852E-33_JPRB, &
  & 0.40875033E-33_JPRB, 0.59549883E-33_JPRB, 0.88247364E-33_JPRB, 0.13145266E-32_JPRB, 0.19922666E-32_JPRB, 0.30707887E-32_JPRB, &
  & 0.47744742E-32_JPRB, 0.74348592E-32_JPRB, 0.11551461E-31_JPRB, 0.17736714E-31_JPRB, 0.26666148E-31_JPRB, 0.39017038E-31_JPRB, &
  & 0.55777783E-31_JPRB, 0.78085786E-31_JPRB, 0.10750592E-30_JPRB, 0.14636708E-30_JPRB, 0.19760624E-30_JPRB, 0.26492629E-30_JPRB, &
  & 0.35250433E-30_JPRB, 0.46556568E-30_JPRB, 0.60230901E-30_JPRB, 0.75836332E-30_JPRB, 0.91790404E-30_JPRB, 0.10633149E-29_JPRB, &
  & 0.11799538E-29_JPRB, 0.12674266E-29_JPRB, 0.13153298E-29_JPRB, 0.13134286E-29_JPRB, 0.11603761E-29_JPRB, 0.91210594E-30_JPRB, &
  & 0.66708585E-30_JPRB, 0.47203283E-30_JPRB, 0.33092230E-30_JPRB, 0.23569997E-30_JPRB, 0.16877994E-30_JPRB, 0.11824753E-30_JPRB, &
  & 0.80170995E-31_JPRB, 0.51932829E-31_JPRB, 0.32310228E-31_JPRB, 0.19421011E-31_JPRB, 0.11235353E-31_JPRB, 0.63252866E-32_JPRB, &
  & 0.35874736E-32_JPRB, 0.21142454E-32_JPRB, 0.12759922E-32_JPRB, 0.76436516E-33_JPRB, 0.45228435E-33_JPRB, 0.26914823E-33_JPRB, &
  & 0.16236478E-33_JPRB, 0.10098787E-33_JPRB, 0.65107142E-34_JPRB, 0.44112968E-34_JPRB, 0.31562075E-34_JPRB, 0.23798615E-34_JPRB, &
  & 0.18274528E-34_JPRB, 0.12942755E-34_JPRB, 0.65178385E-35_JPRB, 0.14775861E-35_JPRB /)

RGHG6(:, 3, 4) = (/ &
  & 0.37951487E-33_JPRB, 0.18034624E-32_JPRB, 0.40345137E-32_JPRB, 0.64635247E-32_JPRB, 0.94516858E-32_JPRB, 0.13607646E-31_JPRB, &
  & 0.19703216E-31_JPRB, 0.28707758E-31_JPRB, 0.42542028E-31_JPRB, 0.63401881E-31_JPRB, 0.96122371E-31_JPRB, 0.14822752E-30_JPRB, &
  & 0.23028426E-30_JPRB, 0.35756168E-30_JPRB, 0.55225834E-30_JPRB, 0.84146447E-30_JPRB, 0.12547193E-29_JPRB, 0.18239516E-29_JPRB, &
  & 0.26003353E-29_JPRB, 0.36436086E-29_JPRB, 0.50410268E-29_JPRB, 0.69111093E-29_JPRB, 0.94214063E-29_JPRB, 0.12685876E-28_JPRB, &
  & 0.16935161E-28_JPRB, 0.22228488E-28_JPRB, 0.28643706E-28_JPRB, 0.35963341E-28_JPRB, 0.43497344E-28_JPRB, 0.50467842E-28_JPRB, &
  & 0.56106751E-28_JPRB, 0.60374901E-28_JPRB, 0.62627077E-28_JPRB, 0.62309395E-28_JPRB, 0.55003380E-28_JPRB, 0.43341215E-28_JPRB, &
  & 0.31822089E-28_JPRB, 0.22638706E-28_JPRB, 0.15943343E-28_JPRB, 0.11364798E-28_JPRB, 0.81090077E-29_JPRB, 0.56310927E-29_JPRB, &
  & 0.37837941E-29_JPRB, 0.24239687E-29_JPRB, 0.14986683E-29_JPRB, 0.89922760E-30_JPRB, 0.52314746E-30_JPRB, 0.29779917E-30_JPRB, &
  & 0.17135181E-30_JPRB, 0.10218058E-30_JPRB, 0.62093832E-31_JPRB, 0.37435413E-31_JPRB, 0.22292569E-31_JPRB, 0.13308916E-31_JPRB, &
  & 0.80701654E-32_JPRB, 0.50141784E-32_JPRB, 0.32392260E-32_JPRB, 0.21900547E-32_JPRB, 0.15620865E-32_JPRB, 0.11729402E-32_JPRB, &
  & 0.90444243E-33_JPRB, 0.65898181E-33_JPRB, 0.35733462E-33_JPRB, 0.81303337E-34_JPRB /)

RGHG6(:, 4, 4) = (/ &
  & 0.35850503E-31_JPRB, 0.19670273E-30_JPRB, 0.40398849E-30_JPRB, 0.62705604E-30_JPRB, 0.90104924E-30_JPRB, 0.12944700E-29_JPRB, &
  & 0.18700729E-29_JPRB, 0.27157561E-29_JPRB, 0.40190682E-29_JPRB, 0.59718852E-29_JPRB, 0.90370140E-29_JPRB, 0.13908476E-28_JPRB, &
  & 0.21547581E-28_JPRB, 0.33293397E-28_JPRB, 0.51062885E-28_JPRB, 0.77073610E-28_JPRB, 0.11380919E-27_JPRB, 0.16394367E-27_JPRB, &
  & 0.23207853E-27_JPRB, 0.32395394E-27_JPRB, 0.44760417E-27_JPRB, 0.61458452E-27_JPRB, 0.83812119E-27_JPRB, 0.11308910E-26_JPRB, &
  & 0.15017921E-26_JPRB, 0.19656927E-26_JPRB, 0.25243674E-26_JPRB, 0.31656707E-26_JPRB, 0.38287302E-26_JPRB, 0.44404379E-26_JPRB, &
  & 0.49362825E-26_JPRB, 0.53070656E-26_JPRB, 0.55060477E-26_JPRB, 0.54803635E-26_JPRB, 0.48418114E-26_JPRB, 0.38237810E-26_JPRB, &
  & 0.28186029E-26_JPRB, 0.20144239E-26_JPRB, 0.14281176E-26_JPRB, 0.10241366E-26_JPRB, 0.73160850E-27_JPRB, 0.50763166E-27_JPRB, &
  & 0.33924269E-27_JPRB, 0.21613200E-27_JPRB, 0.13306366E-27_JPRB, 0.80162844E-28_JPRB, 0.46987388E-28_JPRB, 0.27101256E-28_JPRB, &
  & 0.15849589E-28_JPRB, 0.95902118E-29_JPRB, 0.58946310E-29_JPRB, 0.35872792E-29_JPRB, 0.21541673E-29_JPRB, 0.12966463E-29_JPRB, &
  & 0.78944113E-30_JPRB, 0.49371026E-30_JPRB, 0.31930040E-30_JPRB, 0.21590533E-30_JPRB, 0.15384329E-30_JPRB, 0.11552066E-30_JPRB, &
  & 0.90538150E-31_JPRB, 0.69282162E-31_JPRB, 0.43302185E-31_JPRB, 0.12180315E-31_JPRB /)

RGHG6(:, 5, 4) = (/ &
  & 0.16892795E-28_JPRB, 0.56636658E-28_JPRB, 0.99954621E-28_JPRB, 0.14616554E-27_JPRB, 0.20828612E-27_JPRB, 0.29734613E-27_JPRB, &
  & 0.42676571E-27_JPRB, 0.61564103E-27_JPRB, 0.90381706E-27_JPRB, 0.13318087E-26_JPRB, 0.19958828E-26_JPRB, 0.30397834E-26_JPRB, &
  & 0.46525537E-26_JPRB, 0.70873945E-26_JPRB, 0.10689980E-25_JPRB, 0.15842324E-25_JPRB, 0.22931643E-25_JPRB, 0.32372846E-25_JPRB, &
  & 0.44932895E-25_JPRB, 0.61550391E-25_JPRB, 0.83572615E-25_JPRB, 0.11287176E-24_JPRB, 0.15174274E-24_JPRB, 0.20147738E-24_JPRB, &
  & 0.26426406E-24_JPRB, 0.34156943E-24_JPRB, 0.43504318E-24_JPRB, 0.54254116E-24_JPRB, 0.65289452E-24_JPRB, 0.75389228E-24_JPRB, &
  & 0.83441033E-24_JPRB, 0.89553058E-24_JPRB, 0.92971360E-24_JPRB, 0.92928298E-24_JPRB, 0.82651634E-24_JPRB, 0.65758222E-24_JPRB, &
  & 0.48903997E-24_JPRB, 0.35367494E-24_JPRB, 0.25431305E-24_JPRB, 0.18525093E-24_JPRB, 0.13452113E-24_JPRB, 0.94660092E-25_JPRB, &
  & 0.64130151E-25_JPRB, 0.41334222E-25_JPRB, 0.25860793E-25_JPRB, 0.15848536E-25_JPRB, 0.94863821E-26_JPRB, 0.55960733E-26_JPRB, &
  & 0.33488390E-26_JPRB, 0.20704868E-26_JPRB, 0.12969197E-26_JPRB, 0.80297003E-27_JPRB, 0.48995706E-27_JPRB, 0.29907684E-27_JPRB, &
  & 0.18464418E-27_JPRB, 0.11665720E-27_JPRB, 0.76128586E-28_JPRB, 0.51841887E-28_JPRB, 0.37039753E-28_JPRB, 0.27980371E-28_JPRB, &
  & 0.22238903E-28_JPRB, 0.18104346E-28_JPRB, 0.13593271E-28_JPRB, 0.74001902E-29_JPRB /)

RGHG6(:, 6, 4) = (/ &
  & 0.14058275E-25_JPRB, 0.34783256E-25_JPRB, 0.54627853E-25_JPRB, 0.78337117E-25_JPRB, 0.11041156E-24_JPRB, 0.15559978E-24_JPRB, &
  & 0.21992330E-24_JPRB, 0.31133951E-24_JPRB, 0.44765800E-24_JPRB, 0.64334319E-24_JPRB, 0.93723973E-24_JPRB, 0.13824132E-23_JPRB, &
  & 0.20418460E-23_JPRB, 0.29918997E-23_JPRB, 0.43310724E-23_JPRB, 0.61471781E-23_JPRB, 0.85164769E-23_JPRB, 0.11497992E-22_JPRB, &
  & 0.15269189E-22_JPRB, 0.20024807E-22_JPRB, 0.26072416E-22_JPRB, 0.33838857E-22_JPRB, 0.43835663E-22_JPRB, 0.56281458E-22_JPRB, &
  & 0.71603440E-22_JPRB, 0.90238758E-22_JPRB, 0.11262995E-21_JPRB, 0.13822060E-21_JPRB, 0.16419808E-21_JPRB, 0.18756207E-21_JPRB, &
  & 0.20613213E-21_JPRB, 0.22056049E-21_JPRB, 0.22957609E-21_JPRB, 0.23137025E-21_JPRB, 0.20839297E-21_JPRB, 0.16846508E-21_JPRB, &
  & 0.12763800E-21_JPRB, 0.94401735E-22_JPRB, 0.69772923E-22_JPRB, 0.52477801E-22_JPRB, 0.39505381E-22_JPRB, 0.28864531E-22_JPRB, &
  & 0.20353561E-22_JPRB, 0.13685923E-22_JPRB, 0.89441475E-23_JPRB, 0.57471337E-23_JPRB, 0.36067793E-23_JPRB, 0.22308091E-23_JPRB, &
  & 0.13994026E-23_JPRB, 0.90463265E-24_JPRB, 0.59075604E-24_JPRB, 0.38024279E-24_JPRB, 0.24056580E-24_JPRB, 0.15184786E-24_JPRB, &
  & 0.96620824E-25_JPRB, 0.62735285E-25_JPRB, 0.41934123E-25_JPRB, 0.29080914E-25_JPRB, 0.21147265E-25_JPRB, 0.16167576E-25_JPRB, &
  & 0.13048430E-25_JPRB, 0.10954664E-25_JPRB, 0.92781845E-26_JPRB, 0.71792721E-26_JPRB /)

RGHG6(:, 7, 4) = (/ &
  & 0.11164237E-22_JPRB, 0.25953609E-22_JPRB, 0.40029472E-22_JPRB, 0.56786146E-22_JPRB, 0.78887877E-22_JPRB, 0.10900600E-21_JPRB, &
  & 0.15033281E-21_JPRB, 0.20680901E-21_JPRB, 0.28743819E-21_JPRB, 0.39737643E-21_JPRB, 0.55375971E-21_JPRB, 0.77741699E-21_JPRB, &
  & 0.10880795E-20_JPRB, 0.15059619E-20_JPRB, 0.20547877E-20_JPRB, 0.27476884E-20_JPRB, 0.35848311E-20_JPRB, 0.45615513E-20_JPRB, &
  & 0.57132989E-20_JPRB, 0.70816936E-20_JPRB, 0.87353262E-20_JPRB, 0.10776813E-19_JPRB, 0.13318093E-19_JPRB, 0.16392363E-19_JPRB, &
  & 0.20064332E-19_JPRB, 0.24473247E-19_JPRB, 0.29707041E-19_JPRB, 0.35669194E-19_JPRB, 0.41622110E-19_JPRB, 0.46944403E-19_JPRB, &
  & 0.51189048E-19_JPRB, 0.54667649E-19_JPRB, 0.57118120E-19_JPRB, 0.58151553E-19_JPRB, 0.53192214E-19_JPRB, 0.43839190E-19_JPRB, &
  & 0.33991430E-19_JPRB, 0.25853372E-19_JPRB, 0.19758049E-19_JPRB, 0.15480317E-19_JPRB, 0.12189674E-19_JPRB, 0.93689110E-20_JPRB, &
  & 0.69716939E-20_JPRB, 0.49691857E-20_JPRB, 0.34581659E-20_JPRB, 0.23707210E-20_JPRB, 0.15896371E-20_JPRB, 0.10512341E-20_JPRB, &
  & 0.70419505E-21_JPRB, 0.48551160E-21_JPRB, 0.33717765E-21_JPRB, 0.22998587E-21_JPRB, 0.15365564E-21_JPRB, 0.10206827E-21_JPRB, &
  & 0.68089507E-22_JPRB, 0.46151626E-22_JPRB, 0.32033568E-22_JPRB, 0.22987511E-22_JPRB, 0.17168494E-22_JPRB, 0.13456557E-22_JPRB, &
  & 0.11058098E-22_JPRB, 0.94488166E-23_JPRB, 0.82183892E-23_JPRB, 0.68471367E-23_JPRB /)

RGHG6(:, 8, 4) = (/ &
  & 0.74537326E-20_JPRB, 0.17161626E-19_JPRB, 0.26309572E-19_JPRB, 0.36973154E-19_JPRB, 0.50667120E-19_JPRB, 0.68712743E-19_JPRB, &
  & 0.92573705E-19_JPRB, 0.12378662E-18_JPRB, 0.16648796E-18_JPRB, 0.22138424E-18_JPRB, 0.29504612E-18_JPRB, 0.39394787E-18_JPRB, &
  & 0.52191411E-18_JPRB, 0.68125758E-18_JPRB, 0.87515264E-18_JPRB, 0.11006608E-17_JPRB, 0.13512634E-17_JPRB, 0.16183836E-17_JPRB, &
  & 0.19109938E-17_JPRB, 0.22370694E-17_JPRB, 0.26129227E-17_JPRB, 0.30618123E-17_JPRB, 0.36089903E-17_JPRB, 0.42488612E-17_JPRB, &
  & 0.50026312E-17_JPRB, 0.58897460E-17_JPRB, 0.69451126E-17_JPRB, 0.81398799E-17_JPRB, 0.93262894E-17_JPRB, 0.10380793E-16_JPRB, &
  & 0.11238302E-16_JPRB, 0.11980699E-16_JPRB, 0.12569844E-16_JPRB, 0.12929544E-16_JPRB, 0.12012737E-16_JPRB, 0.10099429E-16_JPRB, &
  & 0.80220290E-17_JPRB, 0.62826063E-17_JPRB, 0.49765584E-17_JPRB, 0.40650137E-17_JPRB, 0.33587621E-17_JPRB, 0.27176777E-17_JPRB, &
  & 0.21407908E-17_JPRB, 0.16223986E-17_JPRB, 0.12052414E-17_JPRB, 0.88474639E-18_JPRB, 0.63615876E-18_JPRB, 0.45104840E-18_JPRB, &
  & 0.32402559E-18_JPRB, 0.23925468E-18_JPRB, 0.17744707E-18_JPRB, 0.12874921E-18_JPRB, 0.91138282E-19_JPRB, 0.63898823E-19_JPRB, &
  & 0.44804471E-19_JPRB, 0.31776567E-19_JPRB, 0.22973072E-19_JPRB, 0.17066008E-19_JPRB, 0.13145991E-19_JPRB, 0.10554235E-19_JPRB, &
  & 0.88575203E-20_JPRB, 0.76839311E-20_JPRB, 0.67705735E-20_JPRB, 0.57270956E-20_JPRB /)

RGHG6(:, 9, 4) = (/ &
  & 0.40730216E-17_JPRB, 0.93513364E-17_JPRB, 0.14250858E-16_JPRB, 0.19904710E-16_JPRB, 0.26993393E-16_JPRB, 0.36071705E-16_JPRB, &
  & 0.47684957E-16_JPRB, 0.62303899E-16_JPRB, 0.81474339E-16_JPRB, 0.10474313E-15_JPRB, 0.13412371E-15_JPRB, 0.17105375E-15_JPRB, &
  & 0.21532143E-15_JPRB, 0.26597729E-15_JPRB, 0.32246671E-15_JPRB, 0.38240171E-15_JPRB, 0.44249136E-15_JPRB, 0.49973451E-15_JPRB, &
  & 0.55703274E-15_JPRB, 0.61662050E-15_JPRB, 0.68258325E-15_JPRB, 0.76013515E-15_JPRB, 0.85406237E-15_JPRB, 0.96275893E-15_JPRB, &
  & 0.10886977E-14_JPRB, 0.12385835E-14_JPRB, 0.14172773E-14_JPRB, 0.16221942E-14_JPRB, 0.18240173E-14_JPRB, 0.20041346E-14_JPRB, &
  & 0.21532761E-14_JPRB, 0.22911293E-14_JPRB, 0.24126723E-14_JPRB, 0.25062413E-14_JPRB, 0.23641278E-14_JPRB, 0.20274549E-14_JPRB, &
  & 0.16507972E-14_JPRB, 0.13332755E-14_JPRB, 0.10957539E-14_JPRB, 0.93501479E-15_JPRB, 0.81043006E-15_JPRB, 0.69129498E-15_JPRB, &
  & 0.57635616E-15_JPRB, 0.46442001E-15_JPRB, 0.36832206E-15_JPRB, 0.28942118E-15_JPRB, 0.22300382E-15_JPRB, 0.16956093E-15_JPRB, &
  & 0.13060848E-15_JPRB, 0.10332035E-15_JPRB, 0.81849316E-16_JPRB, 0.63147140E-16_JPRB, 0.47312226E-16_JPRB, 0.34961411E-16_JPRB, &
  & 0.25720433E-16_JPRB, 0.19049606E-16_JPRB, 0.14308721E-16_JPRB, 0.10990841E-16_JPRB, 0.87007481E-17_JPRB, 0.71488216E-17_JPRB, &
  & 0.61062287E-17_JPRB, 0.53723681E-17_JPRB, 0.47844759E-17_JPRB, 0.40862313E-17_JPRB /)

RGHG6(:,10, 4) = (/ &
  & 0.18177933E-14_JPRB, 0.41383040E-14_JPRB, 0.63015020E-14_JPRB, 0.87518773E-14_JPRB, 0.11791030E-13_JPRB, 0.15586153E-13_JPRB, &
  & 0.20309768E-13_JPRB, 0.26052308E-13_JPRB, 0.33291492E-13_JPRB, 0.41579567E-13_JPRB, 0.51400477E-13_JPRB, 0.62897895E-13_JPRB, &
  & 0.75540052E-13_JPRB, 0.88620605E-13_JPRB, 0.10173398E-12_JPRB, 0.11401688E-12_JPRB, 0.12461337E-12_JPRB, 0.13290705E-12_JPRB, &
  & 0.14002043E-12_JPRB, 0.14669793E-12_JPRB, 0.15397121E-12_JPRB, 0.16297109E-12_JPRB, 0.17460837E-12_JPRB, 0.18828882E-12_JPRB, &
  & 0.20473667E-12_JPRB, 0.22488196E-12_JPRB, 0.24995045E-12_JPRB, 0.27923556E-12_JPRB, 0.30822700E-12_JPRB, 0.33417125E-12_JPRB, &
  & 0.35623465E-12_JPRB, 0.37805750E-12_JPRB, 0.39938037E-12_JPRB, 0.41863632E-12_JPRB, 0.40069274E-12_JPRB, 0.35049220E-12_JPRB, &
  & 0.29271483E-12_JPRB, 0.24403163E-12_JPRB, 0.20841568E-12_JPRB, 0.18583643E-12_JPRB, 0.16914771E-12_JPRB, 0.15212938E-12_JPRB, &
  & 0.13430442E-12_JPRB, 0.11508501E-12_JPRB, 0.97404384E-13_JPRB, 0.81891843E-13_JPRB, 0.67608476E-13_JPRB, 0.55101465E-13_JPRB, &
  & 0.45510352E-13_JPRB, 0.38568815E-13_JPRB, 0.32626452E-13_JPRB, 0.26750519E-13_JPRB, 0.21192973E-13_JPRB, 0.16481313E-13_JPRB, &
  & 0.12696866E-13_JPRB, 0.97981646E-14_JPRB, 0.76288683E-14_JPRB, 0.60406045E-14_JPRB, 0.49044508E-14_JPRB, 0.41107432E-14_JPRB, &
  & 0.35651862E-14_JPRB, 0.31740254E-14_JPRB, 0.28502218E-14_JPRB, 0.24533443E-14_JPRB /)

RGHG6(:,11, 4) = (/ &
  & 0.20776092E-13_JPRB, 0.42245436E-13_JPRB, 0.59953744E-13_JPRB, 0.80067917E-13_JPRB, 0.10392400E-12_JPRB, 0.13346987E-12_JPRB, &
  & 0.16980055E-12_JPRB, 0.21385783E-12_JPRB, 0.26724876E-12_JPRB, 0.32871766E-12_JPRB, 0.39818073E-12_JPRB, 0.47570476E-12_JPRB, &
  & 0.55286353E-12_JPRB, 0.63304667E-12_JPRB, 0.71464834E-12_JPRB, 0.79372067E-12_JPRB, 0.86957600E-12_JPRB, 0.93413385E-12_JPRB, &
  & 0.97788227E-12_JPRB, 0.10043430E-11_JPRB, 0.10131126E-11_JPRB, 0.10041492E-11_JPRB, 0.98090926E-12_JPRB, 0.94014618E-12_JPRB, &
  & 0.89017552E-12_JPRB, 0.84219220E-12_JPRB, 0.80692273E-12_JPRB, 0.79159894E-12_JPRB, 0.80474852E-12_JPRB, 0.84364639E-12_JPRB, &
  & 0.88408095E-12_JPRB, 0.91801393E-12_JPRB, 0.93280819E-12_JPRB, 0.91321525E-12_JPRB, 0.87706285E-12_JPRB, 0.83871170E-12_JPRB, &
  & 0.78593761E-12_JPRB, 0.71729905E-12_JPRB, 0.64635363E-12_JPRB, 0.57473465E-12_JPRB, 0.50286213E-12_JPRB, 0.43942944E-12_JPRB, &
  & 0.38429776E-12_JPRB, 0.33500370E-12_JPRB, 0.28980724E-12_JPRB, 0.24672468E-12_JPRB, 0.20770732E-12_JPRB, 0.17532915E-12_JPRB, &
  & 0.14958050E-12_JPRB, 0.12817282E-12_JPRB, 0.10805450E-12_JPRB, 0.89174938E-13_JPRB, 0.72296329E-13_JPRB, 0.58180755E-13_JPRB, &
  & 0.46898984E-13_JPRB, 0.38260776E-13_JPRB, 0.31685802E-13_JPRB, 0.26743984E-13_JPRB, 0.23091695E-13_JPRB, 0.20450662E-13_JPRB, &
  & 0.18602080E-13_JPRB, 0.17228259E-13_JPRB, 0.16110499E-13_JPRB, 0.14731445E-13_JPRB /)

RGHG6(:,12, 4) = (/ &
  & 0.11798457E-12_JPRB, 0.20817336E-12_JPRB, 0.27942085E-12_JPRB, 0.35265340E-12_JPRB, 0.43811580E-12_JPRB, 0.53901545E-12_JPRB, &
  & 0.65905869E-12_JPRB, 0.80099230E-12_JPRB, 0.96937779E-12_JPRB, 0.11704192E-11_JPRB, 0.13966027E-11_JPRB, 0.16510495E-11_JPRB, &
  & 0.19382252E-11_JPRB, 0.22380307E-11_JPRB, 0.25383892E-11_JPRB, 0.28425905E-11_JPRB, 0.31296469E-11_JPRB, 0.33609784E-11_JPRB, &
  & 0.35187450E-11_JPRB, 0.36132863E-11_JPRB, 0.36255127E-11_JPRB, 0.35601951E-11_JPRB, 0.34218164E-11_JPRB, 0.32070093E-11_JPRB, &
  & 0.29542419E-11_JPRB, 0.27174337E-11_JPRB, 0.25219102E-11_JPRB, 0.23688302E-11_JPRB, 0.22616965E-11_JPRB, 0.22256272E-11_JPRB, &
  & 0.22595736E-11_JPRB, 0.23201805E-11_JPRB, 0.23740905E-11_JPRB, 0.23729653E-11_JPRB, 0.23397519E-11_JPRB, 0.22604746E-11_JPRB, &
  & 0.21468413E-11_JPRB, 0.20166856E-11_JPRB, 0.18594679E-11_JPRB, 0.16802180E-11_JPRB, 0.15149793E-11_JPRB, 0.13654766E-11_JPRB, &
  & 0.12333893E-11_JPRB, 0.11030638E-11_JPRB, 0.97236368E-12_JPRB, 0.84897009E-12_JPRB, 0.73857570E-12_JPRB, 0.64015828E-12_JPRB, &
  & 0.55254862E-12_JPRB, 0.47257554E-12_JPRB, 0.39858736E-12_JPRB, 0.33231827E-12_JPRB, 0.27461548E-12_JPRB, 0.22588127E-12_JPRB, &
  & 0.18548599E-12_JPRB, 0.15369191E-12_JPRB, 0.12955279E-12_JPRB, 0.11161896E-12_JPRB, 0.98437453E-13_JPRB, 0.88959032E-13_JPRB, &
  & 0.82241749E-13_JPRB, 0.77375484E-13_JPRB, 0.73379054E-13_JPRB, 0.68939063E-13_JPRB /)

RGHG6(:,13, 4) = (/ &
  & 0.45073759E-12_JPRB, 0.72993635E-12_JPRB, 0.92772708E-12_JPRB, 0.11319216E-11_JPRB, 0.13608531E-11_JPRB, 0.16311902E-11_JPRB, &
  & 0.19504754E-11_JPRB, 0.23263435E-11_JPRB, 0.27632627E-11_JPRB, 0.32704477E-11_JPRB, 0.38687877E-11_JPRB, 0.45461621E-11_JPRB, &
  & 0.52852787E-11_JPRB, 0.60743567E-11_JPRB, 0.68762036E-11_JPRB, 0.76839013E-11_JPRB, 0.84515520E-11_JPRB, 0.90932721E-11_JPRB, &
  & 0.95637135E-11_JPRB, 0.98299988E-11_JPRB, 0.98686814E-11_JPRB, 0.96899754E-11_JPRB, 0.93380980E-11_JPRB, 0.88062179E-11_JPRB, &
  & 0.81676497E-11_JPRB, 0.75224185E-11_JPRB, 0.69369736E-11_JPRB, 0.64502648E-11_JPRB, 0.60766752E-11_JPRB, 0.58238848E-11_JPRB, &
  & 0.56988173E-11_JPRB, 0.56888782E-11_JPRB, 0.57489491E-11_JPRB, 0.58519726E-11_JPRB, 0.58764187E-11_JPRB, 0.57653257E-11_JPRB, &
  & 0.55760622E-11_JPRB, 0.52961017E-11_JPRB, 0.49916351E-11_JPRB, 0.47293927E-11_JPRB, 0.44789472E-11_JPRB, 0.41952765E-11_JPRB, &
  & 0.38900094E-11_JPRB, 0.35540837E-11_JPRB, 0.32180519E-11_JPRB, 0.28938182E-11_JPRB, 0.25718637E-11_JPRB, 0.22655816E-11_JPRB, &
  & 0.19772788E-11_JPRB, 0.17161103E-11_JPRB, 0.14801599E-11_JPRB, 0.12712544E-11_JPRB, 0.10890207E-11_JPRB, 0.93233060E-12_JPRB, &
  & 0.79698921E-12_JPRB, 0.68311172E-12_JPRB, 0.58947053E-12_JPRB, 0.51538564E-12_JPRB, 0.45901878E-12_JPRB, 0.41766110E-12_JPRB, &
  & 0.38859614E-12_JPRB, 0.36750149E-12_JPRB, 0.35200708E-12_JPRB, 0.33746543E-12_JPRB /)

RGHG6(:,14, 4) = (/ &
  & 0.14055551E-11_JPRB, 0.20931269E-11_JPRB, 0.25788456E-11_JPRB, 0.30398800E-11_JPRB, 0.35529565E-11_JPRB, 0.41396977E-11_JPRB, &
  & 0.48236831E-11_JPRB, 0.56251618E-11_JPRB, 0.65596881E-11_JPRB, 0.76342162E-11_JPRB, 0.88427217E-11_JPRB, 0.10211183E-10_JPRB, &
  & 0.11721906E-10_JPRB, 0.13327138E-10_JPRB, 0.14972249E-10_JPRB, 0.16599189E-10_JPRB, 0.18164742E-10_JPRB, 0.19541327E-10_JPRB, &
  & 0.20616817E-10_JPRB, 0.21299388E-10_JPRB, 0.21544457E-10_JPRB, 0.21365144E-10_JPRB, 0.20806816E-10_JPRB, 0.19926370E-10_JPRB, &
  & 0.18852173E-10_JPRB, 0.17686677E-10_JPRB, 0.16527821E-10_JPRB, 0.15479951E-10_JPRB, 0.14599920E-10_JPRB, 0.13882904E-10_JPRB, &
  & 0.13305510E-10_JPRB, 0.12867915E-10_JPRB, 0.12544331E-10_JPRB, 0.12263110E-10_JPRB, 0.12144575E-10_JPRB, 0.12152422E-10_JPRB, &
  & 0.12198643E-10_JPRB, 0.12236651E-10_JPRB, 0.12226776E-10_JPRB, 0.12038274E-10_JPRB, 0.11694662E-10_JPRB, 0.11253712E-10_JPRB, &
  & 0.10743349E-10_JPRB, 0.10122061E-10_JPRB, 0.93976632E-11_JPRB, 0.85842392E-11_JPRB, 0.77360158E-11_JPRB, 0.69200422E-11_JPRB, &
  & 0.61643286E-11_JPRB, 0.54978127E-11_JPRB, 0.48952010E-11_JPRB, 0.43547436E-11_JPRB, 0.38698831E-11_JPRB, 0.34374307E-11_JPRB, &
  & 0.30477519E-11_JPRB, 0.27034438E-11_JPRB, 0.24042972E-11_JPRB, 0.21532387E-11_JPRB, 0.19523610E-11_JPRB, 0.17996401E-11_JPRB, &
  & 0.16893157E-11_JPRB, 0.16125550E-11_JPRB, 0.15592752E-11_JPRB, 0.15278704E-11_JPRB /)

RGHG6(:,15, 4) = (/ &
  & 0.37745189E-11_JPRB, 0.53001015E-11_JPRB, 0.62814389E-11_JPRB, 0.72008176E-11_JPRB, 0.81660486E-11_JPRB, 0.92425720E-11_JPRB, &
  & 0.10468846E-10_JPRB, 0.11880835E-10_JPRB, 0.13511709E-10_JPRB, 0.15391338E-10_JPRB, 0.17517680E-10_JPRB, 0.19851513E-10_JPRB, &
  & 0.22371435E-10_JPRB, 0.25030304E-10_JPRB, 0.27753553E-10_JPRB, 0.30450590E-10_JPRB, 0.33044907E-10_JPRB, 0.35414602E-10_JPRB, &
  & 0.37398772E-10_JPRB, 0.38847828E-10_JPRB, 0.39652327E-10_JPRB, 0.39800798E-10_JPRB, 0.39378570E-10_JPRB, 0.38454136E-10_JPRB, &
  & 0.37176914E-10_JPRB, 0.35761664E-10_JPRB, 0.34236832E-10_JPRB, 0.32625316E-10_JPRB, 0.31053930E-10_JPRB, 0.29550362E-10_JPRB, &
  & 0.28065276E-10_JPRB, 0.26695011E-10_JPRB, 0.25576392E-10_JPRB, 0.24711519E-10_JPRB, 0.24179493E-10_JPRB, 0.24051587E-10_JPRB, &
  & 0.24352926E-10_JPRB, 0.24862943E-10_JPRB, 0.25380708E-10_JPRB, 0.25846898E-10_JPRB, 0.26083791E-10_JPRB, 0.25938515E-10_JPRB, &
  & 0.25366780E-10_JPRB, 0.24289093E-10_JPRB, 0.22802298E-10_JPRB, 0.21076522E-10_JPRB, 0.19291008E-10_JPRB, 0.17583074E-10_JPRB, &
  & 0.16014905E-10_JPRB, 0.14630325E-10_JPRB, 0.13365666E-10_JPRB, 0.12212446E-10_JPRB, 0.11141735E-10_JPRB, 0.10150559E-10_JPRB, &
  & 0.92232957E-11_JPRB, 0.83777161E-11_JPRB, 0.76215484E-11_JPRB, 0.69708432E-11_JPRB, 0.64350851E-11_JPRB, 0.60206536E-11_JPRB, &
  & 0.57211705E-11_JPRB, 0.55137917E-11_JPRB, 0.53869153E-11_JPRB, 0.53415163E-11_JPRB /)

RGHG6(:,16, 4) = (/ &
  & 0.89139529E-11_JPRB, 0.11788079E-10_JPRB, 0.13540519E-10_JPRB, 0.15089253E-10_JPRB, 0.16664822E-10_JPRB, 0.18370182E-10_JPRB, &
  & 0.20279455E-10_JPRB, 0.22449272E-10_JPRB, 0.24932501E-10_JPRB, 0.27750958E-10_JPRB, 0.30921314E-10_JPRB, 0.34399573E-10_JPRB, &
  & 0.38112593E-10_JPRB, 0.41952501E-10_JPRB, 0.45866911E-10_JPRB, 0.49760140E-10_JPRB, 0.53528210E-10_JPRB, 0.57051891E-10_JPRB, &
  & 0.60190741E-10_JPRB, 0.62740133E-10_JPRB, 0.64553578E-10_JPRB, 0.65522872E-10_JPRB, 0.65778945E-10_JPRB, 0.65370501E-10_JPRB, &
  & 0.64461887E-10_JPRB, 0.63218319E-10_JPRB, 0.61749841E-10_JPRB, 0.59923400E-10_JPRB, 0.57761684E-10_JPRB, 0.55348070E-10_JPRB, &
  & 0.52711290E-10_JPRB, 0.49955921E-10_JPRB, 0.47481036E-10_JPRB, 0.45533948E-10_JPRB, 0.44359828E-10_JPRB, 0.44091251E-10_JPRB, &
  & 0.44734695E-10_JPRB, 0.46081722E-10_JPRB, 0.47793904E-10_JPRB, 0.49286002E-10_JPRB, 0.50195351E-10_JPRB, 0.50382889E-10_JPRB, &
  & 0.49723746E-10_JPRB, 0.48112181E-10_JPRB, 0.45739107E-10_JPRB, 0.42898567E-10_JPRB, 0.39881789E-10_JPRB, 0.36919894E-10_JPRB, &
  & 0.34200056E-10_JPRB, 0.31775610E-10_JPRB, 0.29541009E-10_JPRB, 0.27458088E-10_JPRB, 0.25479474E-10_JPRB, 0.23599225E-10_JPRB, &
  & 0.21800764E-10_JPRB, 0.20131900E-10_JPRB, 0.18625297E-10_JPRB, 0.17310811E-10_JPRB, 0.16223372E-10_JPRB, 0.15375359E-10_JPRB, &
  & 0.14765847E-10_JPRB, 0.14363683E-10_JPRB, 0.14139491E-10_JPRB, 0.14162066E-10_JPRB /)

RGHG6(:,17, 4) = (/ &
  & 0.18237870E-10_JPRB, 0.22884479E-10_JPRB, 0.25528165E-10_JPRB, 0.27818216E-10_JPRB, 0.30082079E-10_JPRB, 0.32497654E-10_JPRB, &
  & 0.35180539E-10_JPRB, 0.38215101E-10_JPRB, 0.41677370E-10_JPRB, 0.45608663E-10_JPRB, 0.49957281E-10_JPRB, 0.54665689E-10_JPRB, &
  & 0.59625055E-10_JPRB, 0.64704020E-10_JPRB, 0.69811920E-10_JPRB, 0.74900371E-10_JPRB, 0.79870277E-10_JPRB, 0.84592305E-10_JPRB, &
  & 0.88960658E-10_JPRB, 0.92816851E-10_JPRB, 0.95888075E-10_JPRB, 0.98182074E-10_JPRB, 0.99623684E-10_JPRB, 0.10030868E-09_JPRB, &
  & 0.10050200E-09_JPRB, 0.10004193E-09_JPRB, 0.99204978E-10_JPRB, 0.97774441E-10_JPRB, 0.95557097E-10_JPRB, 0.92491924E-10_JPRB, &
  & 0.88765544E-10_JPRB, 0.84605559E-10_JPRB, 0.80556901E-10_JPRB, 0.77127270E-10_JPRB, 0.74861138E-10_JPRB, 0.74106825E-10_JPRB, &
  & 0.74907303E-10_JPRB, 0.76907619E-10_JPRB, 0.79562724E-10_JPRB, 0.82169056E-10_JPRB, 0.84009896E-10_JPRB, 0.84686674E-10_JPRB, &
  & 0.83986353E-10_JPRB, 0.81793752E-10_JPRB, 0.78410847E-10_JPRB, 0.74250092E-10_JPRB, 0.69746202E-10_JPRB, 0.65341732E-10_JPRB, &
  & 0.61256458E-10_JPRB, 0.57545746E-10_JPRB, 0.54087318E-10_JPRB, 0.50822319E-10_JPRB, 0.47692111E-10_JPRB, 0.44687011E-10_JPRB, &
  & 0.41793690E-10_JPRB, 0.39094700E-10_JPRB, 0.36643071E-10_JPRB, 0.34503154E-10_JPRB, 0.32722849E-10_JPRB, 0.31345565E-10_JPRB, &
  & 0.30371192E-10_JPRB, 0.29756652E-10_JPRB, 0.29478506E-10_JPRB, 0.29735620E-10_JPRB /)

RGHG6(:,18, 4) = (/ &
  & 0.32760260E-10_JPRB, 0.39268921E-10_JPRB, 0.42917694E-10_JPRB, 0.45967407E-10_JPRB, 0.48979747E-10_JPRB, 0.52186519E-10_JPRB, &
  & 0.55752972E-10_JPRB, 0.59800942E-10_JPRB, 0.64389293E-10_JPRB, 0.69553537E-10_JPRB, 0.75210997E-10_JPRB, 0.81208942E-10_JPRB, &
  & 0.87396888E-10_JPRB, 0.93617010E-10_JPRB, 0.99796296E-10_JPRB, 0.10588937E-09_JPRB, 0.11187908E-09_JPRB, 0.11764197E-09_JPRB, &
  & 0.12310909E-09_JPRB, 0.12811842E-09_JPRB, 0.13251342E-09_JPRB, 0.13612128E-09_JPRB, 0.13891495E-09_JPRB, 0.14100277E-09_JPRB, &
  & 0.14236611E-09_JPRB, 0.14324178E-09_JPRB, 0.14365008E-09_JPRB, 0.14326666E-09_JPRB, 0.14179907E-09_JPRB, 0.13906110E-09_JPRB, &
  & 0.13504445E-09_JPRB, 0.13023375E-09_JPRB, 0.12525976E-09_JPRB, 0.12078084E-09_JPRB, 0.11756461E-09_JPRB, 0.11617665E-09_JPRB, &
  & 0.11677570E-09_JPRB, 0.11901174E-09_JPRB, 0.12206156E-09_JPRB, 0.12504334E-09_JPRB, 0.12711578E-09_JPRB, 0.12762516E-09_JPRB, &
  & 0.12633893E-09_JPRB, 0.12315970E-09_JPRB, 0.11846306E-09_JPRB, 0.11277267E-09_JPRB, 0.10671893E-09_JPRB, 0.10077338E-09_JPRB, &
  & 0.95185672E-10_JPRB, 0.90029366E-10_JPRB, 0.85197432E-10_JPRB, 0.80643880E-10_JPRB, 0.76305059E-10_JPRB, 0.72165676E-10_JPRB, &
  & 0.68203290E-10_JPRB, 0.64507920E-10_JPRB, 0.61146976E-10_JPRB, 0.58199081E-10_JPRB, 0.55754925E-10_JPRB, 0.53871997E-10_JPRB, &
  & 0.52571968E-10_JPRB, 0.51792445E-10_JPRB, 0.51528653E-10_JPRB, 0.52141479E-10_JPRB /)

RGHG6(:,19, 4) = (/ &
  & 0.52557660E-10_JPRB, 0.61061822E-10_JPRB, 0.65679059E-10_JPRB, 0.69623883E-10_JPRB, 0.73439851E-10_JPRB, 0.77507958E-10_JPRB, &
  & 0.82029855E-10_JPRB, 0.87136659E-10_JPRB, 0.92905711E-10_JPRB, 0.99334652E-10_JPRB, 0.10628007E-09_JPRB, 0.11357025E-09_JPRB, &
  & 0.12093702E-09_JPRB, 0.12819178E-09_JPRB, 0.13524884E-09_JPRB, 0.14210254E-09_JPRB, 0.14878861E-09_JPRB, 0.15526663E-09_JPRB, &
  & 0.16148163E-09_JPRB, 0.16735327E-09_JPRB, 0.17272211E-09_JPRB, 0.17737084E-09_JPRB, 0.18151408E-09_JPRB, 0.18473977E-09_JPRB, &
  & 0.18748582E-09_JPRB, 0.18971651E-09_JPRB, 0.19133536E-09_JPRB, 0.19213627E-09_JPRB, 0.19196336E-09_JPRB, 0.19044136E-09_JPRB, &
  & 0.18757056E-09_JPRB, 0.18367452E-09_JPRB, 0.17920357E-09_JPRB, 0.17492376E-09_JPRB, 0.17165237E-09_JPRB, 0.16993479E-09_JPRB, &
  & 0.17013002E-09_JPRB, 0.17180186E-09_JPRB, 0.17411105E-09_JPRB, 0.17619108E-09_JPRB, 0.17719434E-09_JPRB, 0.17648466E-09_JPRB, &
  & 0.17380268E-09_JPRB, 0.16907462E-09_JPRB, 0.16271082E-09_JPRB, 0.15535327E-09_JPRB, 0.14762859E-09_JPRB, 0.14005343E-09_JPRB, &
  & 0.13290784E-09_JPRB, 0.12631959E-09_JPRB, 0.12017937E-09_JPRB, 0.11443671E-09_JPRB, 0.10903437E-09_JPRB, 0.10395360E-09_JPRB, &
  & 0.99149952E-10_JPRB, 0.94689548E-10_JPRB, 0.90624036E-10_JPRB, 0.87047557E-10_JPRB, 0.84070674E-10_JPRB, 0.81787646E-10_JPRB, &
  & 0.80216299E-10_JPRB, 0.79325879E-10_JPRB, 0.79076419E-10_JPRB, 0.80030656E-10_JPRB /)

RGHG6(:,20, 4) = (/ &
  & 0.77099743E-10_JPRB, 0.87085179E-10_JPRB, 0.92759175E-10_JPRB, 0.97467735E-10_JPRB, 0.10216249E-09_JPRB, 0.10713849E-09_JPRB, &
  & 0.11265944E-09_JPRB, 0.11886110E-09_JPRB, 0.12582085E-09_JPRB, 0.13348780E-09_JPRB, 0.14166956E-09_JPRB, 0.15010083E-09_JPRB, &
  & 0.15850826E-09_JPRB, 0.16663466E-09_JPRB, 0.17437869E-09_JPRB, 0.18174325E-09_JPRB, 0.18880314E-09_JPRB, 0.19560743E-09_JPRB, &
  & 0.20216187E-09_JPRB, 0.20841356E-09_JPRB, 0.21426008E-09_JPRB, 0.21962011E-09_JPRB, 0.22430791E-09_JPRB, 0.22853283E-09_JPRB, &
  & 0.23214124E-09_JPRB, 0.23524727E-09_JPRB, 0.23790950E-09_JPRB, 0.23990554E-09_JPRB, 0.24126237E-09_JPRB, 0.24158006E-09_JPRB, &
  & 0.24089358E-09_JPRB, 0.23917168E-09_JPRB, 0.23679886E-09_JPRB, 0.23415800E-09_JPRB, 0.23188369E-09_JPRB, 0.23049807E-09_JPRB, &
  & 0.23014954E-09_JPRB, 0.23052459E-09_JPRB, 0.23120873E-09_JPRB, 0.23127018E-09_JPRB, 0.23003853E-09_JPRB, 0.22705031E-09_JPRB, &
  & 0.22216674E-09_JPRB, 0.21536326E-09_JPRB, 0.20710791E-09_JPRB, 0.19799618E-09_JPRB, 0.18872576E-09_JPRB, 0.17977875E-09_JPRB, &
  & 0.17142525E-09_JPRB, 0.16372426E-09_JPRB, 0.15654586E-09_JPRB, 0.14985507E-09_JPRB, 0.14363190E-09_JPRB, 0.13786293E-09_JPRB, &
  & 0.13249335E-09_JPRB, 0.12754886E-09_JPRB, 0.12304295E-09_JPRB, 0.11905454E-09_JPRB, 0.11569971E-09_JPRB, 0.11309123E-09_JPRB, &
  & 0.11129395E-09_JPRB, 0.11022044E-09_JPRB, 0.10990946E-09_JPRB, 0.11088576E-09_JPRB /)

RGHG6(:,21, 4) = (/ &
  & 0.10447978E-09_JPRB, 0.11613042E-09_JPRB, 0.12243873E-09_JPRB, 0.12797081E-09_JPRB, 0.13338218E-09_JPRB, 0.13920297E-09_JPRB, &
  & 0.14566363E-09_JPRB, 0.15286446E-09_JPRB, 0.16085366E-09_JPRB, 0.16957938E-09_JPRB, 0.17874381E-09_JPRB, 0.18809450E-09_JPRB, &
  & 0.19729293E-09_JPRB, 0.20608934E-09_JPRB, 0.21434697E-09_JPRB, 0.22206482E-09_JPRB, 0.22931997E-09_JPRB, 0.23621152E-09_JPRB, &
  & 0.24280808E-09_JPRB, 0.24910995E-09_JPRB, 0.25506150E-09_JPRB, 0.26053484E-09_JPRB, 0.26557204E-09_JPRB, 0.26995597E-09_JPRB, &
  & 0.27381350E-09_JPRB, 0.27732414E-09_JPRB, 0.28057498E-09_JPRB, 0.28360814E-09_JPRB, 0.28636385E-09_JPRB, 0.28859740E-09_JPRB, &
  & 0.29028072E-09_JPRB, 0.29115477E-09_JPRB, 0.29142547E-09_JPRB, 0.29100428E-09_JPRB, 0.29028893E-09_JPRB, 0.28947997E-09_JPRB, &
  & 0.28880173E-09_JPRB, 0.28795169E-09_JPRB, 0.28660471E-09_JPRB, 0.28418953E-09_JPRB, 0.28031161E-09_JPRB, 0.27471314E-09_JPRB, &
  & 0.26743571E-09_JPRB, 0.25857538E-09_JPRB, 0.24858804E-09_JPRB, 0.23811525E-09_JPRB, 0.22773705E-09_JPRB, 0.21787941E-09_JPRB, &
  & 0.20867955E-09_JPRB, 0.20013746E-09_JPRB, 0.19217321E-09_JPRB, 0.18480696E-09_JPRB, 0.17804198E-09_JPRB, 0.17186318E-09_JPRB, &
  & 0.16619497E-09_JPRB, 0.16101288E-09_JPRB, 0.15629047E-09_JPRB, 0.15206540E-09_JPRB, 0.14844811E-09_JPRB, 0.14556395E-09_JPRB, &
  & 0.14346725E-09_JPRB, 0.14216900E-09_JPRB, 0.14157833E-09_JPRB, 0.14227254E-09_JPRB /)

RGHG6(:,22, 4) = (/ &
  & 0.13323369E-09_JPRB, 0.14562887E-09_JPRB, 0.15280274E-09_JPRB, 0.15883879E-09_JPRB, 0.16493416E-09_JPRB, 0.17143137E-09_JPRB, &
  & 0.17862162E-09_JPRB, 0.18659915E-09_JPRB, 0.19536538E-09_JPRB, 0.20482137E-09_JPRB, 0.21471040E-09_JPRB, 0.22467442E-09_JPRB, &
  & 0.23443650E-09_JPRB, 0.24370650E-09_JPRB, 0.25235153E-09_JPRB, 0.26033950E-09_JPRB, 0.26774929E-09_JPRB, 0.27468905E-09_JPRB, &
  & 0.28123659E-09_JPRB, 0.28744740E-09_JPRB, 0.29329097E-09_JPRB, 0.29873060E-09_JPRB, 0.30363634E-09_JPRB, 0.30797678E-09_JPRB, &
  & 0.31180905E-09_JPRB, 0.31532671E-09_JPRB, 0.31874300E-09_JPRB, 0.32224351E-09_JPRB, 0.32591416E-09_JPRB, 0.32959813E-09_JPRB, &
  & 0.33311787E-09_JPRB, 0.33615469E-09_JPRB, 0.33857470E-09_JPRB, 0.34006614E-09_JPRB, 0.34071798E-09_JPRB, 0.34048964E-09_JPRB, &
  & 0.33947523E-09_JPRB, 0.33747233E-09_JPRB, 0.33431613E-09_JPRB, 0.32973746E-09_JPRB, 0.32359748E-09_JPRB, 0.31586217E-09_JPRB, &
  & 0.30672692E-09_JPRB, 0.29638231E-09_JPRB, 0.28531386E-09_JPRB, 0.27402358E-09_JPRB, 0.26301447E-09_JPRB, 0.25258587E-09_JPRB, &
  & 0.24285110E-09_JPRB, 0.23382596E-09_JPRB, 0.22544563E-09_JPRB, 0.21774901E-09_JPRB, 0.21075697E-09_JPRB, 0.20443899E-09_JPRB, &
  & 0.19869553E-09_JPRB, 0.19345825E-09_JPRB, 0.18866421E-09_JPRB, 0.18431595E-09_JPRB, 0.18049415E-09_JPRB, 0.17732797E-09_JPRB, &
  & 0.17493477E-09_JPRB, 0.17324774E-09_JPRB, 0.17228073E-09_JPRB, 0.17216249E-09_JPRB /)

RGHG6(:,23, 4) = (/ &
  & 0.16127991E-09_JPRB, 0.17449185E-09_JPRB, 0.18190884E-09_JPRB, 0.18848069E-09_JPRB, 0.19501024E-09_JPRB, 0.20200469E-09_JPRB, &
  & 0.20969693E-09_JPRB, 0.21816353E-09_JPRB, 0.22737985E-09_JPRB, 0.23725258E-09_JPRB, 0.24751115E-09_JPRB, 0.25784749E-09_JPRB, &
  & 0.26795935E-09_JPRB, 0.27756769E-09_JPRB, 0.28650379E-09_JPRB, 0.29473571E-09_JPRB, 0.30230285E-09_JPRB, 0.30931663E-09_JPRB, &
  & 0.31586883E-09_JPRB, 0.32200836E-09_JPRB, 0.32774602E-09_JPRB, 0.33303826E-09_JPRB, 0.33780181E-09_JPRB, 0.34198810E-09_JPRB, &
  & 0.34566702E-09_JPRB, 0.34905334E-09_JPRB, 0.35243219E-09_JPRB, 0.35599440E-09_JPRB, 0.35998907E-09_JPRB, 0.36442377E-09_JPRB, &
  & 0.36892128E-09_JPRB, 0.37321607E-09_JPRB, 0.37682815E-09_JPRB, 0.37941000E-09_JPRB, 0.38075137E-09_JPRB, 0.38072195E-09_JPRB, &
  & 0.37930012E-09_JPRB, 0.37636783E-09_JPRB, 0.37191222E-09_JPRB, 0.36585651E-09_JPRB, 0.35826916E-09_JPRB, 0.34922606E-09_JPRB, &
  & 0.33907885E-09_JPRB, 0.32804989E-09_JPRB, 0.31656036E-09_JPRB, 0.30502212E-09_JPRB, 0.29386210E-09_JPRB, 0.28334526E-09_JPRB, &
  & 0.27354061E-09_JPRB, 0.26440647E-09_JPRB, 0.25592845E-09_JPRB, 0.24818425E-09_JPRB, 0.24118471E-09_JPRB, 0.23488866E-09_JPRB, &
  & 0.22917997E-09_JPRB, 0.22396252E-09_JPRB, 0.21914526E-09_JPRB, 0.21470078E-09_JPRB, 0.21069901E-09_JPRB, 0.20726862E-09_JPRB, &
  & 0.20451404E-09_JPRB, 0.20247441E-09_JPRB, 0.20097106E-09_JPRB, 0.19998266E-09_JPRB /)

RGHG6(:,24, 4) = (/ &
  & 0.18792751E-09_JPRB, 0.20134092E-09_JPRB, 0.20902971E-09_JPRB, 0.21576962E-09_JPRB, 0.22258308E-09_JPRB, 0.22985551E-09_JPRB, &
  & 0.23781124E-09_JPRB, 0.24650954E-09_JPRB, 0.25591065E-09_JPRB, 0.26591104E-09_JPRB, 0.27630392E-09_JPRB, 0.28679742E-09_JPRB, &
  & 0.29707733E-09_JPRB, 0.30689001E-09_JPRB, 0.31605055E-09_JPRB, 0.32450218E-09_JPRB, 0.33226655E-09_JPRB, 0.33943071E-09_JPRB, &
  & 0.34604883E-09_JPRB, 0.35219094E-09_JPRB, 0.35788067E-09_JPRB, 0.36305903E-09_JPRB, 0.36770015E-09_JPRB, 0.37172837E-09_JPRB, &
  & 0.37526271E-09_JPRB, 0.37847975E-09_JPRB, 0.38167336E-09_JPRB, 0.38515185E-09_JPRB, 0.38914058E-09_JPRB, 0.39363385E-09_JPRB, &
  & 0.39838033E-09_JPRB, 0.40304293E-09_JPRB, 0.40702619E-09_JPRB, 0.40989304E-09_JPRB, 0.41132148E-09_JPRB, 0.41111931E-09_JPRB, &
  & 0.40921305E-09_JPRB, 0.40559842E-09_JPRB, 0.40033135E-09_JPRB, 0.39345838E-09_JPRB, 0.38515682E-09_JPRB, 0.37563344E-09_JPRB, &
  & 0.36525030E-09_JPRB, 0.35423617E-09_JPRB, 0.34295453E-09_JPRB, 0.33174277E-09_JPRB, 0.32093178E-09_JPRB, 0.31070205E-09_JPRB, &
  & 0.30106853E-09_JPRB, 0.29207817E-09_JPRB, 0.28376235E-09_JPRB, 0.27615674E-09_JPRB, 0.26927993E-09_JPRB, 0.26307501E-09_JPRB, &
  & 0.25742264E-09_JPRB, 0.25221500E-09_JPRB, 0.24735614E-09_JPRB, 0.24280566E-09_JPRB, 0.23861746E-09_JPRB, 0.23492072E-09_JPRB, &
  & 0.23185798E-09_JPRB, 0.22941635E-09_JPRB, 0.22749687E-09_JPRB, 0.22554131E-09_JPRB /)

RGHG6(:,25, 4) = (/ &
  & 0.21292376E-09_JPRB, 0.22605523E-09_JPRB, 0.23380664E-09_JPRB, 0.24053856E-09_JPRB, 0.24739524E-09_JPRB, 0.25473196E-09_JPRB, &
  & 0.26271521E-09_JPRB, 0.27142416E-09_JPRB, 0.28077948E-09_JPRB, 0.29070049E-09_JPRB, 0.30103112E-09_JPRB, 0.31152195E-09_JPRB, &
  & 0.32189032E-09_JPRB, 0.33184344E-09_JPRB, 0.34119016E-09_JPRB, 0.34983957E-09_JPRB, 0.35778930E-09_JPRB, 0.36510059E-09_JPRB, &
  & 0.37182776E-09_JPRB, 0.37803330E-09_JPRB, 0.38372611E-09_JPRB, 0.38885956E-09_JPRB, 0.39341524E-09_JPRB, 0.39734008E-09_JPRB, &
  & 0.40074893E-09_JPRB, 0.40379833E-09_JPRB, 0.40679257E-09_JPRB, 0.41005496E-09_JPRB, 0.41376441E-09_JPRB, 0.41801448E-09_JPRB, &
  & 0.42255274E-09_JPRB, 0.42699455E-09_JPRB, 0.43078113E-09_JPRB, 0.43342097E-09_JPRB, 0.43456391E-09_JPRB, 0.43399284E-09_JPRB, &
  & 0.43162432E-09_JPRB, 0.42749282E-09_JPRB, 0.42177209E-09_JPRB, 0.41461931E-09_JPRB, 0.40622858E-09_JPRB, 0.39682227E-09_JPRB, &
  & 0.38677558E-09_JPRB, 0.37628581E-09_JPRB, 0.36564887E-09_JPRB, 0.35509853E-09_JPRB, 0.34485581E-09_JPRB, 0.33507130E-09_JPRB, &
  & 0.32585973E-09_JPRB, 0.31725159E-09_JPRB, 0.30923292E-09_JPRB, 0.30187799E-09_JPRB, 0.29518676E-09_JPRB, 0.28909167E-09_JPRB, &
  & 0.28347949E-09_JPRB, 0.27824731E-09_JPRB, 0.27330455E-09_JPRB, 0.26861247E-09_JPRB, 0.26422603E-09_JPRB, 0.26027736E-09_JPRB, &
  & 0.25690974E-09_JPRB, 0.25415481E-09_JPRB, 0.25180708E-09_JPRB, 0.24913863E-09_JPRB /)

RGHG6(:,26, 4) = (/ &
  & 0.23593294E-09_JPRB, 0.24894181E-09_JPRB, 0.25622363E-09_JPRB, 0.26292465E-09_JPRB, 0.26961458E-09_JPRB, 0.27680500E-09_JPRB, &
  & 0.28467664E-09_JPRB, 0.29318911E-09_JPRB, 0.30234512E-09_JPRB, 0.31205974E-09_JPRB, 0.32219666E-09_JPRB, 0.33256875E-09_JPRB, &
  & 0.34288747E-09_JPRB, 0.35288802E-09_JPRB, 0.36235520E-09_JPRB, 0.37118136E-09_JPRB, 0.37933565E-09_JPRB, 0.38683545E-09_JPRB, &
  & 0.39371420E-09_JPRB, 0.40001599E-09_JPRB, 0.40574152E-09_JPRB, 0.41087447E-09_JPRB, 0.41538456E-09_JPRB, 0.41926523E-09_JPRB, &
  & 0.42258946E-09_JPRB, 0.42552725E-09_JPRB, 0.42835768E-09_JPRB, 0.43130186E-09_JPRB, 0.43469067E-09_JPRB, 0.43848641E-09_JPRB, &
  & 0.44251819E-09_JPRB, 0.44641091E-09_JPRB, 0.44968568E-09_JPRB, 0.45184806E-09_JPRB, 0.45253754E-09_JPRB, 0.45154400E-09_JPRB, &
  & 0.44879817E-09_JPRB, 0.44444698E-09_JPRB, 0.43863768E-09_JPRB, 0.43156317E-09_JPRB, 0.42345358E-09_JPRB, 0.41458439E-09_JPRB, &
  & 0.40521814E-09_JPRB, 0.39555703E-09_JPRB, 0.38577333E-09_JPRB, 0.37603512E-09_JPRB, 0.36649395E-09_JPRB, 0.35735084E-09_JPRB, &
  & 0.34866449E-09_JPRB, 0.34045566E-09_JPRB, 0.33279199E-09_JPRB, 0.32571362E-09_JPRB, 0.31920536E-09_JPRB, 0.31320538E-09_JPRB, &
  & 0.30760394E-09_JPRB, 0.30230821E-09_JPRB, 0.29724051E-09_JPRB, 0.29237338E-09_JPRB, 0.28776811E-09_JPRB, 0.28357122E-09_JPRB, &
  & 0.27993774E-09_JPRB, 0.27689259E-09_JPRB, 0.27417532E-09_JPRB, 0.27080979E-09_JPRB /)

RGHG6(:,27, 4) = (/ &
  & 0.25766031E-09_JPRB, 0.26949620E-09_JPRB, 0.27679709E-09_JPRB, 0.28302780E-09_JPRB, 0.28954539E-09_JPRB, 0.29650463E-09_JPRB, &
  & 0.30407016E-09_JPRB, 0.31233219E-09_JPRB, 0.32116801E-09_JPRB, 0.33055969E-09_JPRB, 0.34043990E-09_JPRB, 0.35061154E-09_JPRB, &
  & 0.36084968E-09_JPRB, 0.37084957E-09_JPRB, 0.38040227E-09_JPRB, 0.38935941E-09_JPRB, 0.39766793E-09_JPRB, 0.40532147E-09_JPRB, &
  & 0.41233528E-09_JPRB, 0.41872589E-09_JPRB, 0.42449880E-09_JPRB, 0.42964243E-09_JPRB, 0.43414050E-09_JPRB, 0.43800583E-09_JPRB, &
  & 0.44128903E-09_JPRB, 0.44416346E-09_JPRB, 0.44682757E-09_JPRB, 0.44954770E-09_JPRB, 0.45252571E-09_JPRB, 0.45574644E-09_JPRB, &
  & 0.45912948E-09_JPRB, 0.46234949E-09_JPRB, 0.46497878E-09_JPRB, 0.46657778E-09_JPRB, 0.46679627E-09_JPRB, 0.46546347E-09_JPRB, &
  & 0.46254386E-09_JPRB, 0.45810741E-09_JPRB, 0.45241783E-09_JPRB, 0.44575058E-09_JPRB, 0.43825721E-09_JPRB, 0.43015963E-09_JPRB, &
  & 0.42169437E-09_JPRB, 0.41298320E-09_JPRB, 0.40415599E-09_JPRB, 0.39526957E-09_JPRB, 0.38650372E-09_JPRB, 0.37799058E-09_JPRB, &
  & 0.36981285E-09_JPRB, 0.36205564E-09_JPRB, 0.35474679E-09_JPRB, 0.34792674E-09_JPRB, 0.34158262E-09_JPRB, 0.33564607E-09_JPRB, &
  & 0.33002584E-09_JPRB, 0.32463526E-09_JPRB, 0.31941552E-09_JPRB, 0.31435154E-09_JPRB, 0.30952141E-09_JPRB, 0.30508857E-09_JPRB, &
  & 0.30122177E-09_JPRB, 0.29792765E-09_JPRB, 0.29494812E-09_JPRB, 0.29099284E-09_JPRB /)

RGHG6(:,28, 4) = (/ &
  & 0.27722741E-09_JPRB, 0.28882921E-09_JPRB, 0.29525940E-09_JPRB, 0.30138844E-09_JPRB, 0.30751626E-09_JPRB, 0.31416278E-09_JPRB, &
  & 0.32145536E-09_JPRB, 0.32932848E-09_JPRB, 0.33781292E-09_JPRB, 0.34685235E-09_JPRB, 0.35638484E-09_JPRB, 0.36630191E-09_JPRB, &
  & 0.37635930E-09_JPRB, 0.38632031E-09_JPRB, 0.39593495E-09_JPRB, 0.40501313E-09_JPRB, 0.41344461E-09_JPRB, 0.42120210E-09_JPRB, &
  & 0.42830728E-09_JPRB, 0.43476384E-09_JPRB, 0.44056858E-09_JPRB, 0.44571744E-09_JPRB, 0.45020634E-09_JPRB, 0.45405268E-09_JPRB, &
  & 0.45731041E-09_JPRB, 0.46011453E-09_JPRB, 0.46262602E-09_JPRB, 0.46511112E-09_JPRB, 0.46766158E-09_JPRB, 0.47033766E-09_JPRB, &
  & 0.47305704E-09_JPRB, 0.47558724E-09_JPRB, 0.47755455E-09_JPRB, 0.47859905E-09_JPRB, 0.47840154E-09_JPRB, 0.47681409E-09_JPRB, &
  & 0.47379678E-09_JPRB, 0.46955950E-09_JPRB, 0.46433188E-09_JPRB, 0.45825499E-09_JPRB, 0.45152324E-09_JPRB, 0.44433252E-09_JPRB, &
  & 0.43684251E-09_JPRB, 0.42913645E-09_JPRB, 0.42122575E-09_JPRB, 0.41320969E-09_JPRB, 0.40516224E-09_JPRB, 0.39725709E-09_JPRB, &
  & 0.38959935E-09_JPRB, 0.38225337E-09_JPRB, 0.37525630E-09_JPRB, 0.36865899E-09_JPRB, 0.36243533E-09_JPRB, 0.35653783E-09_JPRB, &
  & 0.35087894E-09_JPRB, 0.34538483E-09_JPRB, 0.34000514E-09_JPRB, 0.33474101E-09_JPRB, 0.32969399E-09_JPRB, 0.32504549E-09_JPRB, &
  & 0.32098457E-09_JPRB, 0.31751143E-09_JPRB, 0.31428130E-09_JPRB, 0.30997038E-09_JPRB /)

RGHG6(:,29, 4) = (/ &
  & 0.29552011E-09_JPRB, 0.30587127E-09_JPRB, 0.31240971E-09_JPRB, 0.31795333E-09_JPRB, 0.32386380E-09_JPRB, 0.33022082E-09_JPRB, &
  & 0.33712116E-09_JPRB, 0.34465858E-09_JPRB, 0.35272904E-09_JPRB, 0.36136624E-09_JPRB, 0.37055875E-09_JPRB, 0.38016898E-09_JPRB, &
  & 0.39000986E-09_JPRB, 0.39979595E-09_JPRB, 0.40932593E-09_JPRB, 0.41844680E-09_JPRB, 0.42700821E-09_JPRB, 0.43489337E-09_JPRB, &
  & 0.44208576E-09_JPRB, 0.44858872E-09_JPRB, 0.45441306E-09_JPRB, 0.45954374E-09_JPRB, 0.46401150E-09_JPRB, 0.46781445E-09_JPRB, &
  & 0.47104226E-09_JPRB, 0.47376408E-09_JPRB, 0.47615450E-09_JPRB, 0.47839649E-09_JPRB, 0.48054982E-09_JPRB, 0.48270182E-09_JPRB, &
  & 0.48480181E-09_JPRB, 0.48667126E-09_JPRB, 0.48803095E-09_JPRB, 0.48857518E-09_JPRB, 0.48804766E-09_JPRB, 0.48633508E-09_JPRB, &
  & 0.48347898E-09_JPRB, 0.47960458E-09_JPRB, 0.47484811E-09_JPRB, 0.46946091E-09_JPRB, 0.46359616E-09_JPRB, 0.45735310E-09_JPRB, &
  & 0.45086246E-09_JPRB, 0.44411849E-09_JPRB, 0.43714166E-09_JPRB, 0.42991039E-09_JPRB, 0.42256473E-09_JPRB, 0.41520634E-09_JPRB, &
  & 0.40800338E-09_JPRB, 0.40102105E-09_JPRB, 0.39430306E-09_JPRB, 0.38789066E-09_JPRB, 0.38177109E-09_JPRB, 0.37589776E-09_JPRB, &
  & 0.37020104E-09_JPRB, 0.36460568E-09_JPRB, 0.35908365E-09_JPRB, 0.35363826E-09_JPRB, 0.34839792E-09_JPRB, 0.34356618E-09_JPRB, &
  & 0.33934067E-09_JPRB, 0.33572281E-09_JPRB, 0.33237652E-09_JPRB, 0.32771250E-09_JPRB /)

RGHG6(:,30, 4) = (/ &
  & 0.31173686E-09_JPRB, 0.32198944E-09_JPRB, 0.32772657E-09_JPRB, 0.33328229E-09_JPRB, 0.33881398E-09_JPRB, 0.34486011E-09_JPRB, &
  & 0.35148140E-09_JPRB, 0.35860476E-09_JPRB, 0.36628550E-09_JPRB, 0.37451839E-09_JPRB, 0.38330747E-09_JPRB, 0.39259676E-09_JPRB, &
  & 0.40219891E-09_JPRB, 0.41187326E-09_JPRB, 0.42133866E-09_JPRB, 0.43038817E-09_JPRB, 0.43893394E-09_JPRB, 0.44685775E-09_JPRB, &
  & 0.45408793E-09_JPRB, 0.46059398E-09_JPRB, 0.46640225E-09_JPRB, 0.47147913E-09_JPRB, 0.47589876E-09_JPRB, 0.47961729E-09_JPRB, &
  & 0.48279669E-09_JPRB, 0.48540044E-09_JPRB, 0.48767235E-09_JPRB, 0.48967241E-09_JPRB, 0.49148047E-09_JPRB, 0.49316834E-09_JPRB, &
  & 0.49472060E-09_JPRB, 0.49600857E-09_JPRB, 0.49684218E-09_JPRB, 0.49697502E-09_JPRB, 0.49621984E-09_JPRB, 0.49448812E-09_JPRB, &
  & 0.49179111E-09_JPRB, 0.48823900E-09_JPRB, 0.48410892E-09_JPRB, 0.47953314E-09_JPRB, 0.47456683E-09_JPRB, 0.46926218E-09_JPRB, &
  & 0.46367388E-09_JPRB, 0.45783830E-09_JPRB, 0.45165036E-09_JPRB, 0.44517764E-09_JPRB, 0.43846293E-09_JPRB, 0.43165177E-09_JPRB, &
  & 0.42487588E-09_JPRB, 0.41822876E-09_JPRB, 0.41176995E-09_JPRB, 0.40553239E-09_JPRB, 0.39950773E-09_JPRB, 0.39367204E-09_JPRB, &
  & 0.38795386E-09_JPRB, 0.38229525E-09_JPRB, 0.37666359E-09_JPRB, 0.37107817E-09_JPRB, 0.36569053E-09_JPRB, 0.36071543E-09_JPRB, &
  & 0.35638303E-09_JPRB, 0.35266956E-09_JPRB, 0.34919084E-09_JPRB, 0.34433750E-09_JPRB /)

RGHG6(:,31, 4) = (/ &
  & 0.32683919E-09_JPRB, 0.33624270E-09_JPRB, 0.34218076E-09_JPRB, 0.34724434E-09_JPRB, 0.35265876E-09_JPRB, 0.35844683E-09_JPRB, &
  & 0.36470438E-09_JPRB, 0.37149400E-09_JPRB, 0.37875766E-09_JPRB, 0.38657313E-09_JPRB, 0.39498205E-09_JPRB, 0.40390380E-09_JPRB, &
  & 0.41319276E-09_JPRB, 0.42262324E-09_JPRB, 0.43196280E-09_JPRB, 0.44097476E-09_JPRB, 0.44948317E-09_JPRB, 0.45739168E-09_JPRB, &
  & 0.46459833E-09_JPRB, 0.47106274E-09_JPRB, 0.47680232E-09_JPRB, 0.48178828E-09_JPRB, 0.48611876E-09_JPRB, 0.48972204E-09_JPRB, &
  & 0.49281129E-09_JPRB, 0.49528187E-09_JPRB, 0.49741472E-09_JPRB, 0.49918542E-09_JPRB, 0.50070337E-09_JPRB, 0.50199783E-09_JPRB, &
  & 0.50309140E-09_JPRB, 0.50390098E-09_JPRB, 0.50430060E-09_JPRB, 0.50411664E-09_JPRB, 0.50320964E-09_JPRB, 0.50151033E-09_JPRB, &
  & 0.49906240E-09_JPRB, 0.49604310E-09_JPRB, 0.49254228E-09_JPRB, 0.48864290E-09_JPRB, 0.48444082E-09_JPRB, 0.47995924E-09_JPRB, &
  & 0.47521131E-09_JPRB, 0.47012788E-09_JPRB, 0.46467666E-09_JPRB, 0.45882409E-09_JPRB, 0.45269935E-09_JPRB, 0.44640350E-09_JPRB, &
  & 0.44004561E-09_JPRB, 0.43373455E-09_JPRB, 0.42753504E-09_JPRB, 0.42147619E-09_JPRB, 0.41557857E-09_JPRB, 0.40981346E-09_JPRB, &
  & 0.40412154E-09_JPRB, 0.39844739E-09_JPRB, 0.39276110E-09_JPRB, 0.38709852E-09_JPRB, 0.38161813E-09_JPRB, 0.37657538E-09_JPRB, &
  & 0.37216752E-09_JPRB, 0.36841213E-09_JPRB, 0.36487774E-09_JPRB, 0.35985506E-09_JPRB /)

RGHG6(:,32, 4) = (/ &
  & 0.34046999E-09_JPRB, 0.34994954E-09_JPRB, 0.35531184E-09_JPRB, 0.36045075E-09_JPRB, 0.36556055E-09_JPRB, 0.37111714E-09_JPRB, &
  & 0.37710529E-09_JPRB, 0.38351233E-09_JPRB, 0.39038345E-09_JPRB, 0.39777606E-09_JPRB, 0.40575238E-09_JPRB, 0.41429760E-09_JPRB, &
  & 0.42325676E-09_JPRB, 0.43242018E-09_JPRB, 0.44155932E-09_JPRB, 0.45043114E-09_JPRB, 0.45884932E-09_JPRB, 0.46668464E-09_JPRB, &
  & 0.47381854E-09_JPRB, 0.48019494E-09_JPRB, 0.48581200E-09_JPRB, 0.49067705E-09_JPRB, 0.49487558E-09_JPRB, 0.49835014E-09_JPRB, &
  & 0.50129828E-09_JPRB, 0.50364518E-09_JPRB, 0.50560206E-09_JPRB, 0.50718363E-09_JPRB, 0.50844179E-09_JPRB, 0.50942472E-09_JPRB, &
  & 0.51015164E-09_JPRB, 0.51058713E-09_JPRB, 0.51065685E-09_JPRB, 0.51024585E-09_JPRB, 0.50926119E-09_JPRB, 0.50766957E-09_JPRB, &
  & 0.50554938E-09_JPRB, 0.50297083E-09_JPRB, 0.50001292E-09_JPRB, 0.49675331E-09_JPRB, 0.49320553E-09_JPRB, 0.48939613E-09_JPRB, &
  & 0.48529958E-09_JPRB, 0.48085647E-09_JPRB, 0.47599846E-09_JPRB, 0.47074200E-09_JPRB, 0.46514534E-09_JPRB, 0.45932733E-09_JPRB, &
  & 0.45340026E-09_JPRB, 0.44743351E-09_JPRB, 0.44150736E-09_JPRB, 0.43567452E-09_JPRB, 0.42994464E-09_JPRB, 0.42430850E-09_JPRB, &
  & 0.41870596E-09_JPRB, 0.41308776E-09_JPRB, 0.40741643E-09_JPRB, 0.40175074E-09_JPRB, 0.39626155E-09_JPRB, 0.39120554E-09_JPRB, &
  & 0.38681630E-09_JPRB, 0.38304637E-09_JPRB, 0.37948114E-09_JPRB, 0.37435491E-09_JPRB /)

RGHG6(:,33, 4) = (/ &
  & 0.35348460E-09_JPRB, 0.36245160E-09_JPRB, 0.36800327E-09_JPRB, 0.37277548E-09_JPRB, 0.37779394E-09_JPRB, 0.38310841E-09_JPRB, &
  & 0.38878192E-09_JPRB, 0.39485473E-09_JPRB, 0.40131334E-09_JPRB, 0.40826656E-09_JPRB, 0.41580969E-09_JPRB, 0.42392853E-09_JPRB, &
  & 0.43251935E-09_JPRB, 0.44136650E-09_JPRB, 0.45024443E-09_JPRB, 0.45893439E-09_JPRB, 0.46719451E-09_JPRB, 0.47488907E-09_JPRB, &
  & 0.48188031E-09_JPRB, 0.48813020E-09_JPRB, 0.49359067E-09_JPRB, 0.49830273E-09_JPRB, 0.50234383E-09_JPRB, 0.50567783E-09_JPRB, &
  & 0.50846133E-09_JPRB, 0.51067472E-09_JPRB, 0.51245436E-09_JPRB, 0.51385873E-09_JPRB, 0.51490245E-09_JPRB, 0.51563820E-09_JPRB, &
  & 0.51608895E-09_JPRB, 0.51624971E-09_JPRB, 0.51608762E-09_JPRB, 0.51553495E-09_JPRB, 0.51454202E-09_JPRB, 0.51310883E-09_JPRB, &
  & 0.51127064E-09_JPRB, 0.50908333E-09_JPRB, 0.50660481E-09_JPRB, 0.50386761E-09_JPRB, 0.50085924E-09_JPRB, 0.49757587E-09_JPRB, &
  & 0.49398385E-09_JPRB, 0.49002108E-09_JPRB, 0.48566062E-09_JPRB, 0.48088988E-09_JPRB, 0.47578008E-09_JPRB, 0.47042753E-09_JPRB, &
  & 0.46490373E-09_JPRB, 0.45930526E-09_JPRB, 0.45369061E-09_JPRB, 0.44811724E-09_JPRB, 0.44262011E-09_JPRB, 0.43718179E-09_JPRB, &
  & 0.43174631E-09_JPRB, 0.42626111E-09_JPRB, 0.42069526E-09_JPRB, 0.41510848E-09_JPRB, 0.40968839E-09_JPRB, 0.40471465E-09_JPRB, &
  & 0.40037637E-09_JPRB, 0.39665443E-09_JPRB, 0.39309572E-09_JPRB, 0.38790562E-09_JPRB /)

RGHG6(:,34, 4) = (/ &
  & 0.36568987E-09_JPRB, 0.37472581E-09_JPRB, 0.37985731E-09_JPRB, 0.38465453E-09_JPRB, 0.38942183E-09_JPRB, 0.39449558E-09_JPRB, &
  & 0.39990317E-09_JPRB, 0.40560333E-09_JPRB, 0.41165660E-09_JPRB, 0.41816359E-09_JPRB, 0.42522852E-09_JPRB, 0.43289061E-09_JPRB, &
  & 0.44105353E-09_JPRB, 0.44955409E-09_JPRB, 0.45814871E-09_JPRB, 0.46658821E-09_JPRB, 0.47464066E-09_JPRB, 0.48213006E-09_JPRB, &
  & 0.48891585E-09_JPRB, 0.49498367E-09_JPRB, 0.50027765E-09_JPRB, 0.50481785E-09_JPRB, 0.50868820E-09_JPRB, 0.51187266E-09_JPRB, &
  & 0.51447996E-09_JPRB, 0.51654730E-09_JPRB, 0.51815469E-09_JPRB, 0.51938831E-09_JPRB, 0.52025539E-09_JPRB, 0.52080074E-09_JPRB, &
  & 0.52105625E-09_JPRB, 0.52103366E-09_JPRB, 0.52073051E-09_JPRB, 0.52011612E-09_JPRB, 0.51917309E-09_JPRB, 0.51790838E-09_JPRB, &
  & 0.51634064E-09_JPRB, 0.51450949E-09_JPRB, 0.51243332E-09_JPRB, 0.51009624E-09_JPRB, 0.50747928E-09_JPRB, 0.50455973E-09_JPRB, &
  & 0.50132332E-09_JPRB, 0.49772381E-09_JPRB, 0.49373627E-09_JPRB, 0.48937987E-09_JPRB, 0.48470172E-09_JPRB, 0.47976151E-09_JPRB, &
  & 0.47464799E-09_JPRB, 0.46941301E-09_JPRB, 0.46412757E-09_JPRB, 0.45886706E-09_JPRB, 0.45365278E-09_JPRB, 0.44847787E-09_JPRB, &
  & 0.44328871E-09_JPRB, 0.43802317E-09_JPRB, 0.43264553E-09_JPRB, 0.42723333E-09_JPRB, 0.42197662E-09_JPRB, 0.41714093E-09_JPRB, &
  & 0.41293347E-09_JPRB, 0.40928683E-09_JPRB, 0.40576284E-09_JPRB, 0.40056627E-09_JPRB /)

RGHG6(:,35, 4) = (/ &
  & 0.37761830E-09_JPRB, 0.38624914E-09_JPRB, 0.39144260E-09_JPRB, 0.39593467E-09_JPRB, 0.40056775E-09_JPRB, 0.40539308E-09_JPRB, &
  & 0.41047860E-09_JPRB, 0.41582626E-09_JPRB, 0.42145809E-09_JPRB, 0.42749940E-09_JPRB, 0.43408471E-09_JPRB, 0.44126536E-09_JPRB, &
  & 0.44898629E-09_JPRB, 0.45706650E-09_JPRB, 0.46531656E-09_JPRB, 0.47346971E-09_JPRB, 0.48126708E-09_JPRB, 0.48852045E-09_JPRB, &
  & 0.49507026E-09_JPRB, 0.50090787E-09_JPRB, 0.50601401E-09_JPRB, 0.51037780E-09_JPRB, 0.51406690E-09_JPRB, 0.51708926E-09_JPRB, &
  & 0.51951066E-09_JPRB, 0.52140542E-09_JPRB, 0.52283999E-09_JPRB, 0.52390087E-09_JPRB, 0.52461452E-09_JPRB, 0.52501770E-09_JPRB, &
  & 0.52514648E-09_JPRB, 0.52502153E-09_JPRB, 0.52465793E-09_JPRB, 0.52404853E-09_JPRB, 0.52319454E-09_JPRB, 0.52210386E-09_JPRB, &
  & 0.52079308E-09_JPRB, 0.51927573E-09_JPRB, 0.51752541E-09_JPRB, 0.51550131E-09_JPRB, 0.51314925E-09_JPRB, 0.51046595E-09_JPRB, &
  & 0.50745091E-09_JPRB, 0.50409421E-09_JPRB, 0.50040100E-09_JPRB, 0.49638232E-09_JPRB, 0.49207882E-09_JPRB, 0.48753374E-09_JPRB, &
  & 0.48277826E-09_JPRB, 0.47789755E-09_JPRB, 0.47295312E-09_JPRB, 0.46801529E-09_JPRB, 0.46312390E-09_JPRB, 0.45826806E-09_JPRB, &
  & 0.45338505E-09_JPRB, 0.44840961E-09_JPRB, 0.44331505E-09_JPRB, 0.43816051E-09_JPRB, 0.43314627E-09_JPRB, 0.42853082E-09_JPRB, &
  & 0.42448872E-09_JPRB, 0.42095821E-09_JPRB, 0.41751552E-09_JPRB, 0.41234394E-09_JPRB /)

RGHG6(:,36, 4) = (/ &
  & 0.38907669E-09_JPRB, 0.39754700E-09_JPRB, 0.40241030E-09_JPRB, 0.40683423E-09_JPRB, 0.41123266E-09_JPRB, 0.41580517E-09_JPRB, &
  & 0.42059325E-09_JPRB, 0.42555409E-09_JPRB, 0.43076265E-09_JPRB, 0.43633855E-09_JPRB, 0.44241258E-09_JPRB, 0.44907519E-09_JPRB, &
  & 0.45630952E-09_JPRB, 0.46397902E-09_JPRB, 0.47183685E-09_JPRB, 0.47963966E-09_JPRB, 0.48712046E-09_JPRB, 0.49410398E-09_JPRB, &
  & 0.50041615E-09_JPRB, 0.50602877E-09_JPRB, 0.51094129E-09_JPRB, 0.51513022E-09_JPRB, 0.51862215E-09_JPRB, 0.52144605E-09_JPRB, &
  & 0.52364874E-09_JPRB, 0.52532229E-09_JPRB, 0.52655552E-09_JPRB, 0.52743132E-09_JPRB, 0.52800059E-09_JPRB, 0.52829663E-09_JPRB, &
  & 0.52835547E-09_JPRB, 0.52819560E-09_JPRB, 0.52783877E-09_JPRB, 0.52729004E-09_JPRB, 0.52655802E-09_JPRB, 0.52565180E-09_JPRB, &
  & 0.52457788E-09_JPRB, 0.52332128E-09_JPRB, 0.52183990E-09_JPRB, 0.52006183E-09_JPRB, 0.51792487E-09_JPRB, 0.51540583E-09_JPRB, &
  & 0.51254062E-09_JPRB, 0.50936166E-09_JPRB, 0.50589394E-09_JPRB, 0.50216731E-09_JPRB, 0.49818077E-09_JPRB, 0.49395138E-09_JPRB, &
  & 0.48952992E-09_JPRB, 0.48496018E-09_JPRB, 0.48033078E-09_JPRB, 0.47571852E-09_JPRB, 0.47116183E-09_JPRB, 0.46665033E-09_JPRB, &
  & 0.46211965E-09_JPRB, 0.45749701E-09_JPRB, 0.45274490E-09_JPRB, 0.44793189E-09_JPRB, 0.44323500E-09_JPRB, 0.43889350E-09_JPRB, &
  & 0.43507423E-09_JPRB, 0.43170190E-09_JPRB, 0.42836212E-09_JPRB, 0.42329829E-09_JPRB /)

RGHG6(:,37, 4) = (/ &
  & 0.40026271E-09_JPRB, 0.40832487E-09_JPRB, 0.41303366E-09_JPRB, 0.41723741E-09_JPRB, 0.42146842E-09_JPRB, 0.42580783E-09_JPRB, &
  & 0.43027545E-09_JPRB, 0.43485870E-09_JPRB, 0.43962922E-09_JPRB, 0.44472331E-09_JPRB, 0.45028964E-09_JPRB, 0.45642501E-09_JPRB, &
  & 0.46313611E-09_JPRB, 0.47031889E-09_JPRB, 0.47776255E-09_JPRB, 0.48518267E-09_JPRB, 0.49231558E-09_JPRB, 0.49897902E-09_JPRB, &
  & 0.50504589E-09_JPRB, 0.51044480E-09_JPRB, 0.51516719E-09_JPRB, 0.51916627E-09_JPRB, 0.52242094E-09_JPRB, 0.52496602E-09_JPRB, &
  & 0.52687227E-09_JPRB, 0.52826360E-09_JPRB, 0.52925198E-09_JPRB, 0.52993343E-09_JPRB, 0.53036686E-09_JPRB, 0.53058363E-09_JPRB, &
  & 0.53061294E-09_JPRB, 0.53046567E-09_JPRB, 0.53015997E-09_JPRB, 0.52970489E-09_JPRB, 0.52911242E-09_JPRB, 0.52838650E-09_JPRB, &
  & 0.52752341E-09_JPRB, 0.52649274E-09_JPRB, 0.52523791E-09_JPRB, 0.52368543E-09_JPRB, 0.52175630E-09_JPRB, 0.51941740E-09_JPRB, &
  & 0.51670879E-09_JPRB, 0.51368754E-09_JPRB, 0.51042370E-09_JPRB, 0.50692772E-09_JPRB, 0.50321397E-09_JPRB, 0.49927890E-09_JPRB, &
  & 0.49513116E-09_JPRB, 0.49083870E-09_JPRB, 0.48648874E-09_JPRB, 0.48217386E-09_JPRB, 0.47794607E-09_JPRB, 0.47378973E-09_JPRB, &
  & 0.46963228E-09_JPRB, 0.46539658E-09_JPRB, 0.46104373E-09_JPRB, 0.45662130E-09_JPRB, 0.45230053E-09_JPRB, 0.44829399E-09_JPRB, &
  & 0.44474049E-09_JPRB, 0.44156323E-09_JPRB, 0.43838344E-09_JPRB, 0.43347437E-09_JPRB /)

RGHG6(:,38, 4) = (/ &
  & 0.41113396E-09_JPRB, 0.41867459E-09_JPRB, 0.42318271E-09_JPRB, 0.42720000E-09_JPRB, 0.43128617E-09_JPRB, 0.43541545E-09_JPRB, &
  & 0.43957993E-09_JPRB, 0.44378612E-09_JPRB, 0.44811743E-09_JPRB, 0.45271770E-09_JPRB, 0.45775064E-09_JPRB, 0.46333243E-09_JPRB, &
  & 0.46951137E-09_JPRB, 0.47619497E-09_JPRB, 0.48316751E-09_JPRB, 0.49016607E-09_JPRB, 0.49691562E-09_JPRB, 0.50325000E-09_JPRB, &
  & 0.50904853E-09_JPRB, 0.51422838E-09_JPRB, 0.51871857E-09_JPRB, 0.52245941E-09_JPRB, 0.52539167E-09_JPRB, 0.52757188E-09_JPRB, &
  & 0.52912702E-09_JPRB, 0.53021265E-09_JPRB, 0.53096827E-09_JPRB, 0.53148064E-09_JPRB, 0.53180865E-09_JPRB, 0.53197347E-09_JPRB, &
  & 0.53199495E-09_JPRB, 0.53187571E-09_JPRB, 0.53162780E-09_JPRB, 0.53126137E-09_JPRB, 0.53078730E-09_JPRB, 0.53021060E-09_JPRB, &
  & 0.52951771E-09_JPRB, 0.52867677E-09_JPRB, 0.52762783E-09_JPRB, 0.52629417E-09_JPRB, 0.52459137E-09_JPRB, 0.52247839E-09_JPRB, &
  & 0.51997207E-09_JPRB, 0.51715521E-09_JPRB, 0.51409360E-09_JPRB, 0.51084653E-09_JPRB, 0.50739374E-09_JPRB, 0.50371363E-09_JPRB, &
  & 0.49981508E-09_JPRB, 0.49575338E-09_JPRB, 0.49164062E-09_JPRB, 0.48759347E-09_JPRB, 0.48367393E-09_JPRB, 0.47986431E-09_JPRB, &
  & 0.47608861E-09_JPRB, 0.47225718E-09_JPRB, 0.46832432E-09_JPRB, 0.46432946E-09_JPRB, 0.46042470E-09_JPRB, 0.45679527E-09_JPRB, &
  & 0.45355147E-09_JPRB, 0.45061704E-09_JPRB, 0.44762929E-09_JPRB, 0.44295451E-09_JPRB /)

RGHG6(:,39, 4) = (/ &
  & 0.42154424E-09_JPRB, 0.42867285E-09_JPRB, 0.43280821E-09_JPRB, 0.43675305E-09_JPRB, 0.44065784E-09_JPRB, 0.44463055E-09_JPRB, &
  & 0.44852283E-09_JPRB, 0.45235149E-09_JPRB, 0.45623469E-09_JPRB, 0.46034498E-09_JPRB, 0.46483523E-09_JPRB, 0.46985538E-09_JPRB, &
  & 0.47546661E-09_JPRB, 0.48161569E-09_JPRB, 0.48810106E-09_JPRB, 0.49465276E-09_JPRB, 0.50101134E-09_JPRB, 0.50699400E-09_JPRB, &
  & 0.51249605E-09_JPRB, 0.51741100E-09_JPRB, 0.52160271E-09_JPRB, 0.52497379E-09_JPRB, 0.52751509E-09_JPRB, 0.52931515E-09_JPRB, &
  & 0.53054866E-09_JPRB, 0.53139054E-09_JPRB, 0.53197191E-09_JPRB, 0.53237059E-09_JPRB, 0.53263138E-09_JPRB, 0.53276722E-09_JPRB, &
  & 0.53278948E-09_JPRB, 0.53269478E-09_JPRB, 0.53249027E-09_JPRB, 0.53218646E-09_JPRB, 0.53179555E-09_JPRB, 0.53132021E-09_JPRB, &
  & 0.53075150E-09_JPRB, 0.53005511E-09_JPRB, 0.52917853E-09_JPRB, 0.52804483E-09_JPRB, 0.52657195E-09_JPRB, 0.52469995E-09_JPRB, &
  & 0.52244581E-09_JPRB, 0.51986265E-09_JPRB, 0.51705912E-09_JPRB, 0.51406235E-09_JPRB, 0.51087368E-09_JPRB, 0.50744919E-09_JPRB, &
  & 0.50377413E-09_JPRB, 0.49991006E-09_JPRB, 0.49599602E-09_JPRB, 0.49218163E-09_JPRB, 0.48854382E-09_JPRB, 0.48506565E-09_JPRB, &
  & 0.48165849E-09_JPRB, 0.47822951E-09_JPRB, 0.47471699E-09_JPRB, 0.47116122E-09_JPRB, 0.46769044E-09_JPRB, 0.46446647E-09_JPRB, &
  & 0.46156634E-09_JPRB, 0.45890441E-09_JPRB, 0.45615231E-09_JPRB, 0.45177270E-09_JPRB /)

RGHG6(:,40, 4) = (/ &
  & 0.43157483E-09_JPRB, 0.43802681E-09_JPRB, 0.44206064E-09_JPRB, 0.44574044E-09_JPRB, 0.44962634E-09_JPRB, 0.45343601E-09_JPRB, &
  & 0.45706855E-09_JPRB, 0.46054149E-09_JPRB, 0.46398924E-09_JPRB, 0.46758286E-09_JPRB, 0.47153537E-09_JPRB, 0.47598725E-09_JPRB, &
  & 0.48103854E-09_JPRB, 0.48664617E-09_JPRB, 0.49262333E-09_JPRB, 0.49870430E-09_JPRB, 0.50464277E-09_JPRB, 0.51026550E-09_JPRB, &
  & 0.51542626E-09_JPRB, 0.52001281E-09_JPRB, 0.52384203E-09_JPRB, 0.52680876E-09_JPRB, 0.52895710E-09_JPRB, 0.53043736E-09_JPRB, &
  & 0.53142973E-09_JPRB, 0.53210236E-09_JPRB, 0.53257193E-09_JPRB, 0.53289917E-09_JPRB, 0.53312077E-09_JPRB, 0.53324151E-09_JPRB, &
  & 0.53326649E-09_JPRB, 0.53318927E-09_JPRB, 0.53301374E-09_JPRB, 0.53275084E-09_JPRB, 0.53241261E-09_JPRB, 0.53200555E-09_JPRB, &
  & 0.53151861E-09_JPRB, 0.53092769E-09_JPRB, 0.53018229E-09_JPRB, 0.52921639E-09_JPRB, 0.52794952E-09_JPRB, 0.52632321E-09_JPRB, &
  & 0.52432514E-09_JPRB, 0.52201898E-09_JPRB, 0.51947413E-09_JPRB, 0.51675636E-09_JPRB, 0.51383015E-09_JPRB, 0.51064358E-09_JPRB, &
  & 0.50717419E-09_JPRB, 0.50348631E-09_JPRB, 0.49973947E-09_JPRB, 0.49612886E-09_JPRB, 0.49274834E-09_JPRB, 0.48957899E-09_JPRB, &
  & 0.48652199E-09_JPRB, 0.48347010E-09_JPRB, 0.48036536E-09_JPRB, 0.47723142E-09_JPRB, 0.47419507E-09_JPRB, 0.47138116E-09_JPRB, &
  & 0.46883769E-09_JPRB, 0.46647186E-09_JPRB, 0.46398091E-09_JPRB, 0.45994195E-09_JPRB /)

RGHG6(:,41, 4) = (/ &
  & 0.44099138E-09_JPRB, 0.44702958E-09_JPRB, 0.45069024E-09_JPRB, 0.45435894E-09_JPRB, 0.45810333E-09_JPRB, 0.46181750E-09_JPRB, &
  & 0.46521917E-09_JPRB, 0.46833870E-09_JPRB, 0.47134385E-09_JPRB, 0.47445364E-09_JPRB, 0.47785159E-09_JPRB, 0.48174043E-09_JPRB, &
  & 0.48622462E-09_JPRB, 0.49129156E-09_JPRB, 0.49676785E-09_JPRB, 0.50239135E-09_JPRB, 0.50791177E-09_JPRB, 0.51315052E-09_JPRB, &
  & 0.51795618E-09_JPRB, 0.52214127E-09_JPRB, 0.52557009E-09_JPRB, 0.52814458E-09_JPRB, 0.52995935E-09_JPRB, 0.53118904E-09_JPRB, &
  & 0.53200971E-09_JPRB, 0.53256827E-09_JPRB, 0.53296345E-09_JPRB, 0.53324606E-09_JPRB, 0.53344318E-09_JPRB, 0.53355559E-09_JPRB, &
  & 0.53358362E-09_JPRB, 0.53351912E-09_JPRB, 0.53336308E-09_JPRB, 0.53312760E-09_JPRB, 0.53282523E-09_JPRB, 0.53246202E-09_JPRB, &
  & 0.53203403E-09_JPRB, 0.53151678E-09_JPRB, 0.53087168E-09_JPRB, 0.53003990E-09_JPRB, 0.52895305E-09_JPRB, 0.52755195E-09_JPRB, &
  & 0.52582116E-09_JPRB, 0.52378146E-09_JPRB, 0.52151833E-09_JPRB, 0.51905685E-09_JPRB, 0.51638355E-09_JPRB, 0.51343191E-09_JPRB, &
  & 0.51015958E-09_JPRB, 0.50662774E-09_JPRB, 0.50303728E-09_JPRB, 0.49960924E-09_JPRB, 0.49647170E-09_JPRB, 0.49358884E-09_JPRB, &
  & 0.49085447E-09_JPRB, 0.48815330E-09_JPRB, 0.48542015E-09_JPRB, 0.48268539E-09_JPRB, 0.48005594E-09_JPRB, 0.47763804E-09_JPRB, &
  & 0.47544391E-09_JPRB, 0.47337528E-09_JPRB, 0.47115206E-09_JPRB, 0.46748377E-09_JPRB /)

RGHG6(:,42, 4) = (/ &
  & 0.44992721E-09_JPRB, 0.45547327E-09_JPRB, 0.45899520E-09_JPRB, 0.46246282E-09_JPRB, 0.46619852E-09_JPRB, 0.46979015E-09_JPRB, &
  & 0.47295551E-09_JPRB, 0.47573906E-09_JPRB, 0.47832915E-09_JPRB, 0.48094589E-09_JPRB, 0.48382331E-09_JPRB, 0.48715276E-09_JPRB, &
  & 0.49108717E-09_JPRB, 0.49562365E-09_JPRB, 0.50060489E-09_JPRB, 0.50577559E-09_JPRB, 0.51088639E-09_JPRB, 0.51573845E-09_JPRB, &
  & 0.52014676E-09_JPRB, 0.52393079E-09_JPRB, 0.52693477E-09_JPRB, 0.52915350E-09_JPRB, 0.53069027E-09_JPRB, 0.53172849E-09_JPRB, &
  & 0.53242422E-09_JPRB, 0.53290194E-09_JPRB, 0.53324678E-09_JPRB, 0.53349841E-09_JPRB, 0.53367955E-09_JPRB, 0.53378701E-09_JPRB, &
  & 0.53381782E-09_JPRB, 0.53376265E-09_JPRB, 0.53362137E-09_JPRB, 0.53340526E-09_JPRB, 0.53312715E-09_JPRB, 0.53279670E-09_JPRB, &
  & 0.53240901E-09_JPRB, 0.53194799E-09_JPRB, 0.53137922E-09_JPRB, 0.53065613E-09_JPRB, 0.52972282E-09_JPRB, 0.52853139E-09_JPRB, &
  & 0.52705407E-09_JPRB, 0.52530208E-09_JPRB, 0.52330290E-09_JPRB, 0.52110832E-09_JPRB, 0.51867555E-09_JPRB, 0.51593696E-09_JPRB, &
  & 0.51284998E-09_JPRB, 0.50947913E-09_JPRB, 0.50603205E-09_JPRB, 0.50279569E-09_JPRB, 0.49988957E-09_JPRB, 0.49728144E-09_JPRB, &
  & 0.49484261E-09_JPRB, 0.49245769E-09_JPRB, 0.49006099E-09_JPRB, 0.48768189E-09_JPRB, 0.48542420E-09_JPRB, 0.48336468E-09_JPRB, &
  & 0.48149501E-09_JPRB, 0.47970794E-09_JPRB, 0.47775117E-09_JPRB, 0.47445203E-09_JPRB /)

RGHG6(:,43, 4) = (/ &
  & 0.45841630E-09_JPRB, 0.46356127E-09_JPRB, 0.46687287E-09_JPRB, 0.47023868E-09_JPRB, 0.47389026E-09_JPRB, 0.47735571E-09_JPRB, &
  & 0.48030568E-09_JPRB, 0.48275406E-09_JPRB, 0.48495363E-09_JPRB, 0.48712290E-09_JPRB, 0.48949350E-09_JPRB, 0.49228926E-09_JPRB, &
  & 0.49568083E-09_JPRB, 0.49971055E-09_JPRB, 0.50422344E-09_JPRB, 0.50895888E-09_JPRB, 0.51366100E-09_JPRB, 0.51811699E-09_JPRB, &
  & 0.52211035E-09_JPRB, 0.52545468E-09_JPRB, 0.52805388E-09_JPRB, 0.52994459E-09_JPRB, 0.53125260E-09_JPRB, 0.53214039E-09_JPRB, &
  & 0.53274113E-09_JPRB, 0.53316085E-09_JPRB, 0.53346827E-09_JPRB, 0.53369870E-09_JPRB, 0.53386828E-09_JPRB, 0.53397237E-09_JPRB, &
  & 0.53400551E-09_JPRB, 0.53395777E-09_JPRB, 0.53382776E-09_JPRB, 0.53362653E-09_JPRB, 0.53336724E-09_JPRB, 0.53305904E-09_JPRB, &
  & 0.53270260E-09_JPRB, 0.53228316E-09_JPRB, 0.53177485E-09_JPRB, 0.53114135E-09_JPRB, 0.53034044E-09_JPRB, 0.52933724E-09_JPRB, &
  & 0.52811105E-09_JPRB, 0.52663973E-09_JPRB, 0.52493865E-09_JPRB, 0.52299404E-09_JPRB, 0.52079857E-09_JPRB, 0.51827109E-09_JPRB, &
  & 0.51536725E-09_JPRB, 0.51215210E-09_JPRB, 0.50887883E-09_JPRB, 0.50583659E-09_JPRB, 0.50317106E-09_JPRB, 0.50082166E-09_JPRB, &
  & 0.49865695E-09_JPRB, 0.49655269E-09_JPRB, 0.49445092E-09_JPRB, 0.49238391E-09_JPRB, 0.49044763E-09_JPRB, 0.48870152E-09_JPRB, &
  & 0.48711768E-09_JPRB, 0.48558707E-09_JPRB, 0.48387810E-09_JPRB, 0.48094251E-09_JPRB /)

RGHG6(:,44, 4) = (/ &
  & 0.46647303E-09_JPRB, 0.47132498E-09_JPRB, 0.47441784E-09_JPRB, 0.47767673E-09_JPRB, 0.48120430E-09_JPRB, 0.48455978E-09_JPRB, &
  & 0.48725279E-09_JPRB, 0.48941795E-09_JPRB, 0.49124754E-09_JPRB, 0.49302029E-09_JPRB, 0.49493559E-09_JPRB, 0.49723309E-09_JPRB, &
  & 0.50011578E-09_JPRB, 0.50365867E-09_JPRB, 0.50772647E-09_JPRB, 0.51204474E-09_JPRB, 0.51634402E-09_JPRB, 0.52036281E-09_JPRB, &
  & 0.52390431E-09_JPRB, 0.52678406E-09_JPRB, 0.52898819E-09_JPRB, 0.53058452E-09_JPRB, 0.53170046E-09_JPRB, 0.53246707E-09_JPRB, &
  & 0.53299570E-09_JPRB, 0.53337118E-09_JPRB, 0.53365190E-09_JPRB, 0.53386628E-09_JPRB, 0.53402799E-09_JPRB, 0.53412952E-09_JPRB, &
  & 0.53416438E-09_JPRB, 0.53412264E-09_JPRB, 0.53400201E-09_JPRB, 0.53381310E-09_JPRB, 0.53356730E-09_JPRB, 0.53327642E-09_JPRB, &
  & 0.53294186E-09_JPRB, 0.53255467E-09_JPRB, 0.53209459E-09_JPRB, 0.53153509E-09_JPRB, 0.53084870E-09_JPRB, 0.53001692E-09_JPRB, &
  & 0.52902299E-09_JPRB, 0.52784976E-09_JPRB, 0.52644589E-09_JPRB, 0.52480265E-09_JPRB, 0.52284765E-09_JPRB, 0.52053190E-09_JPRB, &
  & 0.51781296E-09_JPRB, 0.51477589E-09_JPRB, 0.51168303E-09_JPRB, 0.50886395E-09_JPRB, 0.50643978E-09_JPRB, 0.50434090E-09_JPRB, &
  & 0.50242133E-09_JPRB, 0.50056725E-09_JPRB, 0.49872012E-09_JPRB, 0.49691856E-09_JPRB, 0.49525328E-09_JPRB, 0.49376991E-09_JPRB, &
  & 0.49242888E-09_JPRB, 0.49112409E-09_JPRB, 0.48964438E-09_JPRB, 0.48705862E-09_JPRB /)

RGHG6(:,45, 4) = (/ &
  & 0.47416293E-09_JPRB, 0.47867532E-09_JPRB, 0.48165644E-09_JPRB, 0.48473692E-09_JPRB, 0.48818938E-09_JPRB, 0.49136467E-09_JPRB, &
  & 0.49385451E-09_JPRB, 0.49571736E-09_JPRB, 0.49725463E-09_JPRB, 0.49867155E-09_JPRB, 0.50020987E-09_JPRB, 0.50205995E-09_JPRB, &
  & 0.50447008E-09_JPRB, 0.50755944E-09_JPRB, 0.51120808E-09_JPRB, 0.51512683E-09_JPRB, 0.51897941E-09_JPRB, 0.52253818E-09_JPRB, &
  & 0.52554133E-09_JPRB, 0.52795068E-09_JPRB, 0.52976951E-09_JPRB, 0.53110910E-09_JPRB, 0.53206189E-09_JPRB, 0.53273308E-09_JPRB, &
  & 0.53320437E-09_JPRB, 0.53354737E-09_JPRB, 0.53380839E-09_JPRB, 0.53401195E-09_JPRB, 0.53416777E-09_JPRB, 0.53426719E-09_JPRB, &
  & 0.53430310E-09_JPRB, 0.53426591E-09_JPRB, 0.53415367E-09_JPRB, 0.53397436E-09_JPRB, 0.53373950E-09_JPRB, 0.53346033E-09_JPRB, &
  & 0.53314225E-09_JPRB, 0.53277899E-09_JPRB, 0.53235727E-09_JPRB, 0.53185961E-09_JPRB, 0.53127158E-09_JPRB, 0.53058880E-09_JPRB, &
  & 0.52981425E-09_JPRB, 0.52891380E-09_JPRB, 0.52785115E-09_JPRB, 0.52651694E-09_JPRB, 0.52486193E-09_JPRB, 0.52278598E-09_JPRB, &
  & 0.52026966E-09_JPRB, 0.51741750E-09_JPRB, 0.51453558E-09_JPRB, 0.51194970E-09_JPRB, 0.50977245E-09_JPRB, 0.50790283E-09_JPRB, &
  & 0.50621324E-09_JPRB, 0.50457444E-09_JPRB, 0.50294824E-09_JPRB, 0.50136967E-09_JPRB, 0.49992893E-09_JPRB, 0.49866078E-09_JPRB, &
  & 0.49752302E-09_JPRB, 0.49641080E-09_JPRB, 0.49514071E-09_JPRB, 0.49288779E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART7',1,ZHOOK_HANDLE)
END SUBROUTINE PART7




SUBROUTINE PART8
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART8',0,ZHOOK_HANDLE)



RGHG6(:,46, 4) = (/ &
  & 0.48139964E-09_JPRB, 0.48565985E-09_JPRB, 0.48848819E-09_JPRB, 0.49146892E-09_JPRB, 0.49477794E-09_JPRB, 0.49780335E-09_JPRB, &
  & 0.50005639E-09_JPRB, 0.50168325E-09_JPRB, 0.50294702E-09_JPRB, 0.50410820E-09_JPRB, 0.50532067E-09_JPRB, 0.50682808E-09_JPRB, &
  & 0.50882082E-09_JPRB, 0.51148674E-09_JPRB, 0.51474647E-09_JPRB, 0.51822735E-09_JPRB, 0.52161830E-09_JPRB, 0.52457894E-09_JPRB, &
  & 0.52703841E-09_JPRB, 0.52894661E-09_JPRB, 0.53042543E-09_JPRB, 0.53153665E-09_JPRB, 0.53235727E-09_JPRB, 0.53295041E-09_JPRB, &
  & 0.53337834E-09_JPRB, 0.53369736E-09_JPRB, 0.53394394E-09_JPRB, 0.53414057E-09_JPRB, 0.53429239E-09_JPRB, 0.53438975E-09_JPRB, &
  & 0.53442650E-09_JPRB, 0.53439303E-09_JPRB, 0.53428717E-09_JPRB, 0.53411647E-09_JPRB, 0.53388927E-09_JPRB, 0.53361893E-09_JPRB, &
  & 0.53331173E-09_JPRB, 0.53296700E-09_JPRB, 0.53257576E-09_JPRB, 0.53212951E-09_JPRB, 0.53162447E-09_JPRB, 0.53107252E-09_JPRB, &
  & 0.53047922E-09_JPRB, 0.52983873E-09_JPRB, 0.52907584E-09_JPRB, 0.52811056E-09_JPRB, 0.52679250E-09_JPRB, 0.52503124E-09_JPRB, &
  & 0.52276711E-09_JPRB, 0.52013099E-09_JPRB, 0.51746712E-09_JPRB, 0.51512761E-09_JPRB, 0.51318055E-09_JPRB, 0.51154281E-09_JPRB, &
  & 0.51004456E-09_JPRB, 0.50860627E-09_JPRB, 0.50716592E-09_JPRB, 0.50577720E-09_JPRB, 0.50452043E-09_JPRB, 0.50342946E-09_JPRB, &
  & 0.50245663E-09_JPRB, 0.50151133E-09_JPRB, 0.50042237E-09_JPRB, 0.49848886E-09_JPRB /)

RGHG6(:,47, 4) = (/ &
  & 0.48809912E-09_JPRB, 0.49223997E-09_JPRB, 0.49489490E-09_JPRB, 0.49781079E-09_JPRB, 0.50096932E-09_JPRB, 0.50383009E-09_JPRB, &
  & 0.50587562E-09_JPRB, 0.50727889E-09_JPRB, 0.50835275E-09_JPRB, 0.50928717E-09_JPRB, 0.51029220E-09_JPRB, 0.51149729E-09_JPRB, &
  & 0.51317700E-09_JPRB, 0.51547855E-09_JPRB, 0.51831478E-09_JPRB, 0.52135035E-09_JPRB, 0.52411731E-09_JPRB, 0.52646826E-09_JPRB, &
  & 0.52831700E-09_JPRB, 0.52979404E-09_JPRB, 0.53095983E-09_JPRB, 0.53188576E-09_JPRB, 0.53259669E-09_JPRB, 0.53312987E-09_JPRB, &
  & 0.53352478E-09_JPRB, 0.53382565E-09_JPRB, 0.53406329E-09_JPRB, 0.53425542E-09_JPRB, 0.53440447E-09_JPRB, 0.53450067E-09_JPRB, &
  & 0.53453753E-09_JPRB, 0.53450655E-09_JPRB, 0.53440646E-09_JPRB, 0.53424182E-09_JPRB, 0.53402077E-09_JPRB, 0.53375648E-09_JPRB, &
  & 0.53345739E-09_JPRB, 0.53312649E-09_JPRB, 0.53276028E-09_JPRB, 0.53235644E-09_JPRB, 0.53192178E-09_JPRB, 0.53147364E-09_JPRB, &
  & 0.53103544E-09_JPRB, 0.53059018E-09_JPRB, 0.53009869E-09_JPRB, 0.52944621E-09_JPRB, 0.52851384E-09_JPRB, 0.52714078E-09_JPRB, &
  & 0.52523419E-09_JPRB, 0.52288052E-09_JPRB, 0.52047594E-09_JPRB, 0.51838284E-09_JPRB, 0.51668053E-09_JPRB, 0.51523197E-09_JPRB, &
  & 0.51393167E-09_JPRB, 0.51265203E-09_JPRB, 0.51138005E-09_JPRB, 0.51014692E-09_JPRB, 0.50904414E-09_JPRB, 0.50809584E-09_JPRB, &
  & 0.50726096E-09_JPRB, 0.50644944E-09_JPRB, 0.50552162E-09_JPRB, 0.50386284E-09_JPRB /)

RGHG6(:,48, 4) = (/ &
  & 0.49436721E-09_JPRB, 0.49824522E-09_JPRB, 0.50095261E-09_JPRB, 0.50368332E-09_JPRB, 0.50680021E-09_JPRB, 0.50946231E-09_JPRB, &
  & 0.51132842E-09_JPRB, 0.51256610E-09_JPRB, 0.51347171E-09_JPRB, 0.51426863E-09_JPRB, 0.51507992E-09_JPRB, 0.51610710E-09_JPRB, &
  & 0.51749066E-09_JPRB, 0.51944271E-09_JPRB, 0.52184990E-09_JPRB, 0.52425447E-09_JPRB, 0.52636490E-09_JPRB, 0.52804183E-09_JPRB, &
  & 0.52938548E-09_JPRB, 0.53047339E-09_JPRB, 0.53139537E-09_JPRB, 0.53216564E-09_JPRB, 0.53279170E-09_JPRB, 0.53327853E-09_JPRB, &
  & 0.53364957E-09_JPRB, 0.53393845E-09_JPRB, 0.53416926E-09_JPRB, 0.53435917E-09_JPRB, 0.53450622E-09_JPRB, 0.53460109E-09_JPRB, &
  & 0.53463800E-09_JPRB, 0.53460891E-09_JPRB, 0.53451288E-09_JPRB, 0.53435334E-09_JPRB, 0.53413729E-09_JPRB, 0.53387711E-09_JPRB, &
  & 0.53358457E-09_JPRB, 0.53326482E-09_JPRB, 0.53291865E-09_JPRB, 0.53255017E-09_JPRB, 0.53217164E-09_JPRB, 0.53180998E-09_JPRB, &
  & 0.53148341E-09_JPRB, 0.53119231E-09_JPRB, 0.53088428E-09_JPRB, 0.53048738E-09_JPRB, 0.52987775E-09_JPRB, 0.52892168E-09_JPRB, &
  & 0.52746452E-09_JPRB, 0.52554278E-09_JPRB, 0.52350202E-09_JPRB, 0.52170923E-09_JPRB, 0.52024124E-09_JPRB, 0.51899945E-09_JPRB, &
  & 0.51785154E-09_JPRB, 0.51672883E-09_JPRB, 0.51558702E-09_JPRB, 0.51448729E-09_JPRB, 0.51350602E-09_JPRB, 0.51267512E-09_JPRB, &
  & 0.51194549E-09_JPRB, 0.51124438E-09_JPRB, 0.51043930E-09_JPRB, 0.50901106E-09_JPRB /)

RGHG6(:,49, 4) = (/ &
  & 0.50005861E-09_JPRB, 0.50393689E-09_JPRB, 0.50648957E-09_JPRB, 0.50927162E-09_JPRB, 0.51221760E-09_JPRB, 0.51476678E-09_JPRB, &
  & 0.51646210E-09_JPRB, 0.51755911E-09_JPRB, 0.51834670E-09_JPRB, 0.51901067E-09_JPRB, 0.51970039E-09_JPRB, 0.52051197E-09_JPRB, &
  & 0.52166249E-09_JPRB, 0.52318472E-09_JPRB, 0.52499105E-09_JPRB, 0.52671884E-09_JPRB, 0.52814492E-09_JPRB, 0.52928301E-09_JPRB, &
  & 0.53021010E-09_JPRB, 0.53101501E-09_JPRB, 0.53173815E-09_JPRB, 0.53239058E-09_JPRB, 0.53294968E-09_JPRB, 0.53340343E-09_JPRB, &
  & 0.53375870E-09_JPRB, 0.53403909E-09_JPRB, 0.53426619E-09_JPRB, 0.53445393E-09_JPRB, 0.53459870E-09_JPRB, 0.53469296E-09_JPRB, &
  & 0.53472948E-09_JPRB, 0.53470178E-09_JPRB, 0.53460891E-09_JPRB, 0.53445337E-09_JPRB, 0.53424076E-09_JPRB, 0.53398536E-09_JPRB, &
  & 0.53369770E-09_JPRB, 0.53338728E-09_JPRB, 0.53305771E-09_JPRB, 0.53271731E-09_JPRB, 0.53238497E-09_JPRB, 0.53208815E-09_JPRB, &
  & 0.53185023E-09_JPRB, 0.53165916E-09_JPRB, 0.53148014E-09_JPRB, 0.53124133E-09_JPRB, 0.53087029E-09_JPRB, 0.53024696E-09_JPRB, &
  & 0.52925847E-09_JPRB, 0.52788396E-09_JPRB, 0.52634985E-09_JPRB, 0.52497506E-09_JPRB, 0.52379279E-09_JPRB, 0.52276611E-09_JPRB, &
  & 0.52178650E-09_JPRB, 0.52079674E-09_JPRB, 0.51977800E-09_JPRB, 0.51878457E-09_JPRB, 0.51790472E-09_JPRB, 0.51716187E-09_JPRB, &
  & 0.51651716E-09_JPRB, 0.51589705E-09_JPRB, 0.51518395E-09_JPRB, 0.51392762E-09_JPRB /)

RGHG6(:,50, 4) = (/ &
  & 0.50526239E-09_JPRB, 0.50917542E-09_JPRB, 0.51168936E-09_JPRB, 0.51442911E-09_JPRB, 0.51730098E-09_JPRB, 0.51967297E-09_JPRB, &
  & 0.52119642E-09_JPRB, 0.52214028E-09_JPRB, 0.52279459E-09_JPRB, 0.52332555E-09_JPRB, 0.52384241E-09_JPRB, 0.52446558E-09_JPRB, &
  & 0.52522930E-09_JPRB, 0.52628724E-09_JPRB, 0.52743915E-09_JPRB, 0.52853427E-09_JPRB, 0.52944171E-09_JPRB, 0.53019089E-09_JPRB, &
  & 0.53083604E-09_JPRB, 0.53143290E-09_JPRB, 0.53201193E-09_JPRB, 0.53256816E-09_JPRB, 0.53307903E-09_JPRB, 0.53351024E-09_JPRB, &
  & 0.53385640E-09_JPRB, 0.53413218E-09_JPRB, 0.53435700E-09_JPRB, 0.53454197E-09_JPRB, 0.53468441E-09_JPRB, 0.53477739E-09_JPRB, &
  & 0.53481330E-09_JPRB, 0.53478671E-09_JPRB, 0.53469640E-09_JPRB, 0.53454385E-09_JPRB, 0.53433535E-09_JPRB, 0.53408322E-09_JPRB, &
  & 0.53380100E-09_JPRB, 0.53349813E-09_JPRB, 0.53318172E-09_JPRB, 0.53286392E-09_JPRB, 0.53256793E-09_JPRB, 0.53232446E-09_JPRB, &
  & 0.53214977E-09_JPRB, 0.53203164E-09_JPRB, 0.53192667E-09_JPRB, 0.53179139E-09_JPRB, 0.53156013E-09_JPRB, 0.53117494E-09_JPRB, &
  & 0.53054844E-09_JPRB, 0.52967064E-09_JPRB, 0.52872567E-09_JPRB, 0.52781668E-09_JPRB, 0.52702726E-09_JPRB, 0.52626581E-09_JPRB, &
  & 0.52551458E-09_JPRB, 0.52470123E-09_JPRB, 0.52383181E-09_JPRB, 0.52295668E-09_JPRB, 0.52217303E-09_JPRB, 0.52151289E-09_JPRB, &
  & 0.52093607E-09_JPRB, 0.52037613E-09_JPRB, 0.51973764E-09_JPRB, 0.51859084E-09_JPRB /)

RGHG6(:,51, 4) = (/ &
  & 0.51022053E-09_JPRB, 0.51382759E-09_JPRB, 0.51657062E-09_JPRB, 0.51909094E-09_JPRB, 0.52186933E-09_JPRB, 0.52393689E-09_JPRB, &
  & 0.52518329E-09_JPRB, 0.52590499E-09_JPRB, 0.52636578E-09_JPRB, 0.52672416E-09_JPRB, 0.52705512E-09_JPRB, 0.52740307E-09_JPRB, &
  & 0.52788052E-09_JPRB, 0.52843491E-09_JPRB, 0.52912202E-09_JPRB, 0.52976812E-09_JPRB, 0.53034449E-09_JPRB, 0.53084492E-09_JPRB, &
  & 0.53130705E-09_JPRB, 0.53176102E-09_JPRB, 0.53222937E-09_JPRB, 0.53271643E-09_JPRB, 0.53318677E-09_JPRB, 0.53360505E-09_JPRB, &
  & 0.53394700E-09_JPRB, 0.53422156E-09_JPRB, 0.53444377E-09_JPRB, 0.53462557E-09_JPRB, 0.53476490E-09_JPRB, 0.53485605E-09_JPRB, &
  & 0.53489096E-09_JPRB, 0.53486515E-09_JPRB, 0.53477661E-09_JPRB, 0.53462662E-09_JPRB, 0.53442156E-09_JPRB, 0.53417359E-09_JPRB, &
  & 0.53389609E-09_JPRB, 0.53359978E-09_JPRB, 0.53329396E-09_JPRB, 0.53299459E-09_JPRB, 0.53272886E-09_JPRB, 0.53252891E-09_JPRB, &
  & 0.53240468E-09_JPRB, 0.53233290E-09_JPRB, 0.53227855E-09_JPRB, 0.53219806E-09_JPRB, 0.53205995E-09_JPRB, 0.53181537E-09_JPRB, &
  & 0.53142873E-09_JPRB, 0.53093185E-09_JPRB, 0.53039623E-09_JPRB, 0.52992799E-09_JPRB, 0.52947907E-09_JPRB, 0.52904980E-09_JPRB, &
  & 0.52857402E-09_JPRB, 0.52803051E-09_JPRB, 0.52739146E-09_JPRB, 0.52671184E-09_JPRB, 0.52607352E-09_JPRB, 0.52551752E-09_JPRB, &
  & 0.52502369E-09_JPRB, 0.52453925E-09_JPRB, 0.52395460E-09_JPRB, 0.52293547E-09_JPRB /)

RGHG6(:,52, 4) = (/ &
  & 0.51438798E-09_JPRB, 0.51844529E-09_JPRB, 0.52063442E-09_JPRB, 0.52328863E-09_JPRB, 0.52553251E-09_JPRB, 0.52717158E-09_JPRB, &
  & 0.52802701E-09_JPRB, 0.52847982E-09_JPRB, 0.52875687E-09_JPRB, 0.52895144E-09_JPRB, 0.52912158E-09_JPRB, 0.52931148E-09_JPRB, &
  & 0.52952054E-09_JPRB, 0.52984095E-09_JPRB, 0.53020072E-09_JPRB, 0.53059990E-09_JPRB, 0.53097249E-09_JPRB, 0.53132432E-09_JPRB, &
  & 0.53166627E-09_JPRB, 0.53202331E-09_JPRB, 0.53241422E-09_JPRB, 0.53284044E-09_JPRB, 0.53328453E-09_JPRB, 0.53369287E-09_JPRB, &
  & 0.53403371E-09_JPRB, 0.53430793E-09_JPRB, 0.53452803E-09_JPRB, 0.53470617E-09_JPRB, 0.53484145E-09_JPRB, 0.53492993E-09_JPRB, &
  & 0.53496335E-09_JPRB, 0.53493776E-09_JPRB, 0.53485072E-09_JPRB, 0.53470306E-09_JPRB, 0.53450150E-09_JPRB, 0.53425769E-09_JPRB, &
  & 0.53398452E-09_JPRB, 0.53369392E-09_JPRB, 0.53339755E-09_JPRB, 0.53311416E-09_JPRB, 0.53287574E-09_JPRB, 0.53271171E-09_JPRB, &
  & 0.53262533E-09_JPRB, 0.53258820E-09_JPRB, 0.53256294E-09_JPRB, 0.53252114E-09_JPRB, 0.53243288E-09_JPRB, 0.53228061E-09_JPRB, &
  & 0.53204469E-09_JPRB, 0.53175725E-09_JPRB, 0.53149629E-09_JPRB, 0.53126198E-09_JPRB, 0.53105853E-09_JPRB, 0.53085031E-09_JPRB, &
  & 0.53061772E-09_JPRB, 0.53032956E-09_JPRB, 0.52996368E-09_JPRB, 0.52953553E-09_JPRB, 0.52910742E-09_JPRB, 0.52872084E-09_JPRB, &
  & 0.52836002E-09_JPRB, 0.52798299E-09_JPRB, 0.52753152E-09_JPRB, 0.52663868E-09_JPRB /)

RGHG6(:,53, 4) = (/ &
  & 0.51854332E-09_JPRB, 0.52185423E-09_JPRB, 0.52444982E-09_JPRB, 0.52633953E-09_JPRB, 0.52820193E-09_JPRB, 0.52926097E-09_JPRB, &
  & 0.52978077E-09_JPRB, 0.53003657E-09_JPRB, 0.53018023E-09_JPRB, 0.53028171E-09_JPRB, 0.53036653E-09_JPRB, 0.53044868E-09_JPRB, &
  & 0.53056753E-09_JPRB, 0.53071031E-09_JPRB, 0.53093097E-09_JPRB, 0.53117355E-09_JPRB, 0.53142962E-09_JPRB, 0.53168547E-09_JPRB, &
  & 0.53195154E-09_JPRB, 0.53224192E-09_JPRB, 0.53257410E-09_JPRB, 0.53296084E-09_JPRB, 0.53337662E-09_JPRB, 0.53377835E-09_JPRB, &
  & 0.53411864E-09_JPRB, 0.53439181E-09_JPRB, 0.53460980E-09_JPRB, 0.53478366E-09_JPRB, 0.53491517E-09_JPRB, 0.53499993E-09_JPRB, &
  & 0.53503130E-09_JPRB, 0.53500548E-09_JPRB, 0.53491955E-09_JPRB, 0.53477406E-09_JPRB, 0.53457583E-09_JPRB, 0.53433580E-09_JPRB, &
  & 0.53406712E-09_JPRB, 0.53378191E-09_JPRB, 0.53349475E-09_JPRB, 0.53322774E-09_JPRB, 0.53301275E-09_JPRB, 0.53287980E-09_JPRB, &
  & 0.53282284E-09_JPRB, 0.53280935E-09_JPRB, 0.53280585E-09_JPRB, 0.53278615E-09_JPRB, 0.53273408E-09_JPRB, 0.53263316E-09_JPRB, &
  & 0.53248445E-09_JPRB, 0.53232924E-09_JPRB, 0.53219085E-09_JPRB, 0.53208532E-09_JPRB, 0.53199217E-09_JPRB, 0.53189975E-09_JPRB, &
  & 0.53179550E-09_JPRB, 0.53165827E-09_JPRB, 0.53147731E-09_JPRB, 0.53125182E-09_JPRB, 0.53101784E-09_JPRB, 0.53079557E-09_JPRB, &
  & 0.53058541E-09_JPRB, 0.53036120E-09_JPRB, 0.53005333E-09_JPRB, 0.52945121E-09_JPRB /)

RGHG6(:,54, 4) = (/ &
  & 0.52165067E-09_JPRB, 0.52529353E-09_JPRB, 0.52695837E-09_JPRB, 0.52870097E-09_JPRB, 0.52985871E-09_JPRB, 0.53053678E-09_JPRB, &
  & 0.53082982E-09_JPRB, 0.53096805E-09_JPRB, 0.53104565E-09_JPRB, 0.53109683E-09_JPRB, 0.53113824E-09_JPRB, 0.53118282E-09_JPRB, &
  & 0.53123123E-09_JPRB, 0.53131977E-09_JPRB, 0.53143656E-09_JPRB, 0.53159810E-09_JPRB, 0.53177734E-09_JPRB, 0.53197224E-09_JPRB, &
  & 0.53218580E-09_JPRB, 0.53243132E-09_JPRB, 0.53272525E-09_JPRB, 0.53307586E-09_JPRB, 0.53347471E-09_JPRB, 0.53386451E-09_JPRB, &
  & 0.53420124E-09_JPRB, 0.53447236E-09_JPRB, 0.53468796E-09_JPRB, 0.53485866E-09_JPRB, 0.53498528E-09_JPRB, 0.53506682E-09_JPRB, &
  & 0.53509569E-09_JPRB, 0.53506871E-09_JPRB, 0.53498350E-09_JPRB, 0.53484001E-09_JPRB, 0.53464522E-09_JPRB, 0.53440918E-09_JPRB, &
  & 0.53414451E-09_JPRB, 0.53386540E-09_JPRB, 0.53358845E-09_JPRB, 0.53333760E-09_JPRB, 0.53314603E-09_JPRB, 0.53303695E-09_JPRB, &
  & 0.53300209E-09_JPRB, 0.53300681E-09_JPRB, 0.53301907E-09_JPRB, 0.53301646E-09_JPRB, 0.53298432E-09_JPRB, 0.53291793E-09_JPRB, &
  & 0.53282351E-09_JPRB, 0.53273053E-09_JPRB, 0.53266097E-09_JPRB, 0.53260851E-09_JPRB, 0.53256433E-09_JPRB, 0.53252258E-09_JPRB, &
  & 0.53247251E-09_JPRB, 0.53240945E-09_JPRB, 0.53231963E-09_JPRB, 0.53220672E-09_JPRB, 0.53208565E-09_JPRB, 0.53197585E-09_JPRB, &
  & 0.53187021E-09_JPRB, 0.53175792E-09_JPRB, 0.53162019E-09_JPRB, 0.53133614E-09_JPRB /)

RGHG6(:,55, 4) = (/ &
  & 0.52468258E-09_JPRB, 0.52743265E-09_JPRB, 0.52908949E-09_JPRB, 0.53012661E-09_JPRB, 0.53093141E-09_JPRB, 0.53132426E-09_JPRB, &
  & 0.53149418E-09_JPRB, 0.53157218E-09_JPRB, 0.53161375E-09_JPRB, 0.53164156E-09_JPRB, 0.53166394E-09_JPRB, 0.53168436E-09_JPRB, &
  & 0.53171423E-09_JPRB, 0.53175303E-09_JPRB, 0.53182814E-09_JPRB, 0.53192961E-09_JPRB, 0.53205923E-09_JPRB, 0.53221061E-09_JPRB, &
  & 0.53238847E-09_JPRB, 0.53260252E-09_JPRB, 0.53286880E-09_JPRB, 0.53319915E-09_JPRB, 0.53357541E-09_JPRB, 0.53395366E-09_JPRB, &
  & 0.53428217E-09_JPRB, 0.53454968E-09_JPRB, 0.53476329E-09_JPRB, 0.53492999E-09_JPRB, 0.53505345E-09_JPRB, 0.53513061E-09_JPRB, &
  & 0.53515675E-09_JPRB, 0.53512822E-09_JPRB, 0.53504323E-09_JPRB, 0.53490207E-09_JPRB, 0.53471028E-09_JPRB, 0.53447846E-09_JPRB, &
  & 0.53421850E-09_JPRB, 0.53394600E-09_JPRB, 0.53368043E-09_JPRB, 0.53344701E-09_JPRB, 0.53327542E-09_JPRB, 0.53318649E-09_JPRB, &
  & 0.53316795E-09_JPRB, 0.53318716E-09_JPRB, 0.53321164E-09_JPRB, 0.53322152E-09_JPRB, 0.53320448E-09_JPRB, 0.53315763E-09_JPRB, &
  & 0.53309290E-09_JPRB, 0.53303850E-09_JPRB, 0.53299792E-09_JPRB, 0.53296989E-09_JPRB, 0.53294730E-09_JPRB, 0.53292504E-09_JPRB, &
  & 0.53290061E-09_JPRB, 0.53286719E-09_JPRB, 0.53282190E-09_JPRB, 0.53276239E-09_JPRB, 0.53270033E-09_JPRB, 0.53264143E-09_JPRB, &
  & 0.53258831E-09_JPRB, 0.53253080E-09_JPRB, 0.53244820E-09_JPRB, 0.53225996E-09_JPRB /)

RGHG6(:,56, 4) = (/ &
  & 0.52697025E-09_JPRB, 0.52938326E-09_JPRB, 0.53037236E-09_JPRB, 0.53113319E-09_JPRB, 0.53161292E-09_JPRB, 0.53185484E-09_JPRB, &
  & 0.53195681E-09_JPRB, 0.53200161E-09_JPRB, 0.53202642E-09_JPRB, 0.53204241E-09_JPRB, 0.53205473E-09_JPRB, 0.53206711E-09_JPRB, &
  & 0.53207994E-09_JPRB, 0.53210447E-09_JPRB, 0.53214272E-09_JPRB, 0.53220983E-09_JPRB, 0.53230154E-09_JPRB, 0.53242083E-09_JPRB, &
  & 0.53257110E-09_JPRB, 0.53276383E-09_JPRB, 0.53301130E-09_JPRB, 0.53332272E-09_JPRB, 0.53368304E-09_JPRB, 0.53404325E-09_JPRB, &
  & 0.53436194E-09_JPRB, 0.53462484E-09_JPRB, 0.53483551E-09_JPRB, 0.53499988E-09_JPRB, 0.53511895E-09_JPRB, 0.53519250E-09_JPRB, &
  & 0.53521543E-09_JPRB, 0.53518479E-09_JPRB, 0.53509958E-09_JPRB, 0.53496046E-09_JPRB, 0.53477245E-09_JPRB, 0.53454485E-09_JPRB, &
  & 0.53429011E-09_JPRB, 0.53402560E-09_JPRB, 0.53377247E-09_JPRB, 0.53355564E-09_JPRB, 0.53340327E-09_JPRB, 0.53333016E-09_JPRB, &
  & 0.53332405E-09_JPRB, 0.53335397E-09_JPRB, 0.53338967E-09_JPRB, 0.53340937E-09_JPRB, 0.53340210E-09_JPRB, 0.53336818E-09_JPRB, &
  & 0.53332283E-09_JPRB, 0.53328497E-09_JPRB, 0.53325999E-09_JPRB, 0.53324267E-09_JPRB, 0.53322846E-09_JPRB, 0.53321580E-09_JPRB, &
  & 0.53320076E-09_JPRB, 0.53318239E-09_JPRB, 0.53315607E-09_JPRB, 0.53312277E-09_JPRB, 0.53308702E-09_JPRB, 0.53305693E-09_JPRB, &
  & 0.53302968E-09_JPRB, 0.53300442E-09_JPRB, 0.53297966E-09_JPRB, 0.53294996E-09_JPRB /)

RGHG6(:,57, 4) = (/ &
  & 0.52885107E-09_JPRB, 0.53060067E-09_JPRB, 0.53132521E-09_JPRB, 0.53179217E-09_JPRB, 0.53209026E-09_JPRB, 0.53224369E-09_JPRB, &
  & 0.53230642E-09_JPRB, 0.53233595E-09_JPRB, 0.53235116E-09_JPRB, 0.53236132E-09_JPRB, 0.53236937E-09_JPRB, 0.53237625E-09_JPRB, &
  & 0.53238497E-09_JPRB, 0.53239574E-09_JPRB, 0.53241905E-09_JPRB, 0.53245869E-09_JPRB, 0.53252264E-09_JPRB, 0.53261529E-09_JPRB, &
  & 0.53274424E-09_JPRB, 0.53291888E-09_JPRB, 0.53315286E-09_JPRB, 0.53344967E-09_JPRB, 0.53379084E-09_JPRB, 0.53413446E-09_JPRB, &
  & 0.53444171E-09_JPRB, 0.53469912E-09_JPRB, 0.53490745E-09_JPRB, 0.53506805E-09_JPRB, 0.53518356E-09_JPRB, 0.53525268E-09_JPRB, &
  & 0.53527216E-09_JPRB, 0.53523930E-09_JPRB, 0.53515370E-09_JPRB, 0.53501653E-09_JPRB, 0.53483207E-09_JPRB, 0.53460936E-09_JPRB, &
  & 0.53436144E-09_JPRB, 0.53410554E-09_JPRB, 0.53386567E-09_JPRB, 0.53366528E-09_JPRB, 0.53352894E-09_JPRB, 0.53346971E-09_JPRB, &
  & 0.53347343E-09_JPRB, 0.53351173E-09_JPRB, 0.53355564E-09_JPRB, 0.53358401E-09_JPRB, 0.53358451E-09_JPRB, 0.53355897E-09_JPRB, &
  & 0.53352289E-09_JPRB, 0.53349569E-09_JPRB, 0.53347649E-09_JPRB, 0.53346338E-09_JPRB, 0.53345295E-09_JPRB, 0.53344301E-09_JPRB, &
  & 0.53343263E-09_JPRB, 0.53341942E-09_JPRB, 0.53340188E-09_JPRB, 0.53337967E-09_JPRB, 0.53335703E-09_JPRB, 0.53333649E-09_JPRB, &
  & 0.53331900E-09_JPRB, 0.53330129E-09_JPRB, 0.53327937E-09_JPRB, 0.53324217E-09_JPRB /)

RGHG6(:,58, 4) = (/ &
  & 0.53058624E-09_JPRB, 0.53155308E-09_JPRB, 0.53198407E-09_JPRB, 0.53225835E-09_JPRB, 0.53245341E-09_JPRB, 0.53254917E-09_JPRB, &
  & 0.53259336E-09_JPRB, 0.53261262E-09_JPRB, 0.53262389E-09_JPRB, 0.53263116E-09_JPRB, 0.53263699E-09_JPRB, 0.53264260E-09_JPRB, &
  & 0.53264770E-09_JPRB, 0.53265525E-09_JPRB, 0.53266669E-09_JPRB, 0.53269017E-09_JPRB, 0.53273230E-09_JPRB, 0.53280341E-09_JPRB, &
  & 0.53291266E-09_JPRB, 0.53307364E-09_JPRB, 0.53329341E-09_JPRB, 0.53357579E-09_JPRB, 0.53389981E-09_JPRB, 0.53422666E-09_JPRB, &
  & 0.53452309E-09_JPRB, 0.53477506E-09_JPRB, 0.53497917E-09_JPRB, 0.53513660E-09_JPRB, 0.53524740E-09_JPRB, 0.53531179E-09_JPRB, &
  & 0.53532756E-09_JPRB, 0.53529270E-09_JPRB, 0.53520621E-09_JPRB, 0.53507082E-09_JPRB, 0.53489047E-09_JPRB, 0.53467342E-09_JPRB, &
  & 0.53443283E-09_JPRB, 0.53418797E-09_JPRB, 0.53396093E-09_JPRB, 0.53377575E-09_JPRB, 0.53365412E-09_JPRB, 0.53360577E-09_JPRB, &
  & 0.53361754E-09_JPRB, 0.53366239E-09_JPRB, 0.53371285E-09_JPRB, 0.53374799E-09_JPRB, 0.53375526E-09_JPRB, 0.53373567E-09_JPRB, &
  & 0.53370630E-09_JPRB, 0.53368154E-09_JPRB, 0.53366495E-09_JPRB, 0.53365268E-09_JPRB, 0.53364257E-09_JPRB, 0.53363380E-09_JPRB, &
  & 0.53362414E-09_JPRB, 0.53361315E-09_JPRB, 0.53359878E-09_JPRB, 0.53358135E-09_JPRB, 0.53356319E-09_JPRB, 0.53354809E-09_JPRB, &
  & 0.53353388E-09_JPRB, 0.53351962E-09_JPRB, 0.53350213E-09_JPRB, 0.53346738E-09_JPRB /)

RGHG6(:,59, 4) = (/ &
  & 0.53154220E-09_JPRB, 0.53217836E-09_JPRB, 0.53243265E-09_JPRB, 0.53261973E-09_JPRB, 0.53273741E-09_JPRB, 0.53280763E-09_JPRB, &
  & 0.53283833E-09_JPRB, 0.53285404E-09_JPRB, 0.53286281E-09_JPRB, 0.53286919E-09_JPRB, 0.53287463E-09_JPRB, 0.53287946E-09_JPRB, &
  & 0.53288496E-09_JPRB, 0.53289007E-09_JPRB, 0.53289767E-09_JPRB, 0.53290994E-09_JPRB, 0.53293581E-09_JPRB, 0.53298838E-09_JPRB, &
  & 0.53308158E-09_JPRB, 0.53322746E-09_JPRB, 0.53343469E-09_JPRB, 0.53370180E-09_JPRB, 0.53400884E-09_JPRB, 0.53432087E-09_JPRB, &
  & 0.53460736E-09_JPRB, 0.53485244E-09_JPRB, 0.53505206E-09_JPRB, 0.53520477E-09_JPRB, 0.53531068E-09_JPRB, 0.53537025E-09_JPRB, &
  & 0.53538207E-09_JPRB, 0.53534494E-09_JPRB, 0.53525812E-09_JPRB, 0.53512444E-09_JPRB, 0.53494853E-09_JPRB, 0.53473775E-09_JPRB, &
  & 0.53450644E-09_JPRB, 0.53427240E-09_JPRB, 0.53405902E-09_JPRB, 0.53388782E-09_JPRB, 0.53377858E-09_JPRB, 0.53373950E-09_JPRB, &
  & 0.53375782E-09_JPRB, 0.53380766E-09_JPRB, 0.53386295E-09_JPRB, 0.53390370E-09_JPRB, 0.53391680E-09_JPRB, 0.53390292E-09_JPRB, &
  & 0.53387567E-09_JPRB, 0.53385280E-09_JPRB, 0.53383487E-09_JPRB, 0.53382149E-09_JPRB, 0.53381066E-09_JPRB, 0.53380056E-09_JPRB, &
  & 0.53379068E-09_JPRB, 0.53377930E-09_JPRB, 0.53376542E-09_JPRB, 0.53374938E-09_JPRB, 0.53373395E-09_JPRB, 0.53371996E-09_JPRB, &
  & 0.53370797E-09_JPRB, 0.53369487E-09_JPRB, 0.53367755E-09_JPRB, 0.53364374E-09_JPRB /)

RGHG6(:,60, 4) = (/ &
  & 0.53228721E-09_JPRB, 0.53262106E-09_JPRB, 0.53278659E-09_JPRB, 0.53289639E-09_JPRB, 0.53298377E-09_JPRB, 0.53303256E-09_JPRB, &
  & 0.53305865E-09_JPRB, 0.53307153E-09_JPRB, 0.53307997E-09_JPRB, 0.53308624E-09_JPRB, 0.53309190E-09_JPRB, 0.53309779E-09_JPRB, &
  & 0.53310362E-09_JPRB, 0.53311028E-09_JPRB, 0.53311583E-09_JPRB, 0.53312182E-09_JPRB, 0.53313531E-09_JPRB, 0.53317301E-09_JPRB, &
  & 0.53325055E-09_JPRB, 0.53338339E-09_JPRB, 0.53357657E-09_JPRB, 0.53382870E-09_JPRB, 0.53412041E-09_JPRB, 0.53441818E-09_JPRB, &
  & 0.53469396E-09_JPRB, 0.53493177E-09_JPRB, 0.53512506E-09_JPRB, 0.53527222E-09_JPRB, 0.53537297E-09_JPRB, 0.53542776E-09_JPRB, &
  & 0.53543581E-09_JPRB, 0.53539667E-09_JPRB, 0.53530996E-09_JPRB, 0.53517801E-09_JPRB, 0.53500709E-09_JPRB, 0.53480348E-09_JPRB, &
  & 0.53458188E-09_JPRB, 0.53436011E-09_JPRB, 0.53415944E-09_JPRB, 0.53400134E-09_JPRB, 0.53390292E-09_JPRB, 0.53387161E-09_JPRB, &
  & 0.53389504E-09_JPRB, 0.53394872E-09_JPRB, 0.53400784E-09_JPRB, 0.53405258E-09_JPRB, 0.53407118E-09_JPRB, 0.53406252E-09_JPRB, &
  & 0.53403848E-09_JPRB, 0.53401339E-09_JPRB, 0.53399357E-09_JPRB, 0.53397753E-09_JPRB, 0.53396387E-09_JPRB, 0.53395210E-09_JPRB, &
  & 0.53394017E-09_JPRB, 0.53392746E-09_JPRB, 0.53391275E-09_JPRB, 0.53389648E-09_JPRB, 0.53388083E-09_JPRB, 0.53386834E-09_JPRB, &
  & 0.53385618E-09_JPRB, 0.53384386E-09_JPRB, 0.53382776E-09_JPRB, 0.53379440E-09_JPRB /)

RGHG6(:,61, 4) = (/ &
  & 0.53269900E-09_JPRB, 0.53294102E-09_JPRB, 0.53304988E-09_JPRB, 0.53313409E-09_JPRB, 0.53319493E-09_JPRB, 0.53323684E-09_JPRB, &
  & 0.53325899E-09_JPRB, 0.53327220E-09_JPRB, 0.53328075E-09_JPRB, 0.53328791E-09_JPRB, 0.53329485E-09_JPRB, 0.53330207E-09_JPRB, &
  & 0.53331073E-09_JPRB, 0.53331894E-09_JPRB, 0.53332572E-09_JPRB, 0.53332777E-09_JPRB, 0.53333193E-09_JPRB, 0.53335691E-09_JPRB, &
  & 0.53342142E-09_JPRB, 0.53354071E-09_JPRB, 0.53372046E-09_JPRB, 0.53395821E-09_JPRB, 0.53423421E-09_JPRB, 0.53451849E-09_JPRB, &
  & 0.53478327E-09_JPRB, 0.53501181E-09_JPRB, 0.53519777E-09_JPRB, 0.53533850E-09_JPRB, 0.53543375E-09_JPRB, 0.53548399E-09_JPRB, &
  & 0.53548888E-09_JPRB, 0.53544813E-09_JPRB, 0.53536170E-09_JPRB, 0.53523280E-09_JPRB, 0.53506688E-09_JPRB, 0.53487192E-09_JPRB, &
  & 0.53466043E-09_JPRB, 0.53445065E-09_JPRB, 0.53426263E-09_JPRB, 0.53411620E-09_JPRB, 0.53402760E-09_JPRB, 0.53400268E-09_JPRB, &
  & 0.53403021E-09_JPRB, 0.53408666E-09_JPRB, 0.53414845E-09_JPRB, 0.53419646E-09_JPRB, 0.53421961E-09_JPRB, 0.53421623E-09_JPRB, &
  & 0.53419463E-09_JPRB, 0.53416926E-09_JPRB, 0.53414528E-09_JPRB, 0.53412508E-09_JPRB, 0.53410804E-09_JPRB, 0.53409244E-09_JPRB, &
  & 0.53407806E-09_JPRB, 0.53406291E-09_JPRB, 0.53404614E-09_JPRB, 0.53402882E-09_JPRB, 0.53401361E-09_JPRB, 0.53400018E-09_JPRB, &
  & 0.53398863E-09_JPRB, 0.53397575E-09_JPRB, 0.53395843E-09_JPRB, 0.53392357E-09_JPRB /)

RGHG6(:,62, 4) = (/ &
  & 0.53302657E-09_JPRB, 0.53319332E-09_JPRB, 0.53327631E-09_JPRB, 0.53333715E-09_JPRB, 0.53338872E-09_JPRB, 0.53342408E-09_JPRB, &
  & 0.53344662E-09_JPRB, 0.53346016E-09_JPRB, 0.53347043E-09_JPRB, 0.53347909E-09_JPRB, 0.53348803E-09_JPRB, 0.53349819E-09_JPRB, &
  & 0.53350957E-09_JPRB, 0.53352212E-09_JPRB, 0.53353022E-09_JPRB, 0.53352939E-09_JPRB, 0.53352633E-09_JPRB, 0.53354099E-09_JPRB, &
  & 0.53359372E-09_JPRB, 0.53370053E-09_JPRB, 0.53386712E-09_JPRB, 0.53409077E-09_JPRB, 0.53435190E-09_JPRB, 0.53462162E-09_JPRB, &
  & 0.53487426E-09_JPRB, 0.53509264E-09_JPRB, 0.53527016E-09_JPRB, 0.53540344E-09_JPRB, 0.53549298E-09_JPRB, 0.53553889E-09_JPRB, &
  & 0.53554094E-09_JPRB, 0.53549931E-09_JPRB, 0.53541455E-09_JPRB, 0.53528915E-09_JPRB, 0.53512944E-09_JPRB, 0.53494309E-09_JPRB, &
  & 0.53474247E-09_JPRB, 0.53454458E-09_JPRB, 0.53436827E-09_JPRB, 0.53423277E-09_JPRB, 0.53415283E-09_JPRB, 0.53413346E-09_JPRB, &
  & 0.53416416E-09_JPRB, 0.53422250E-09_JPRB, 0.53428584E-09_JPRB, 0.53433641E-09_JPRB, 0.53436311E-09_JPRB, 0.53436433E-09_JPRB, &
  & 0.53434668E-09_JPRB, 0.53432037E-09_JPRB, 0.53429366E-09_JPRB, 0.53426852E-09_JPRB, 0.53424626E-09_JPRB, 0.53422666E-09_JPRB, &
  & 0.53420829E-09_JPRB, 0.53418964E-09_JPRB, 0.53417060E-09_JPRB, 0.53415183E-09_JPRB, 0.53413540E-09_JPRB, 0.53412236E-09_JPRB, &
  & 0.53410953E-09_JPRB, 0.53409616E-09_JPRB, 0.53407767E-09_JPRB, 0.53403881E-09_JPRB /)

RGHG6(:,63, 4) = (/ &
  & 0.53327509E-09_JPRB, 0.53340610E-09_JPRB, 0.53347077E-09_JPRB, 0.53352234E-09_JPRB, 0.53356553E-09_JPRB, 0.53360005E-09_JPRB, &
  & 0.53362265E-09_JPRB, 0.53363880E-09_JPRB, 0.53365096E-09_JPRB, 0.53366256E-09_JPRB, 0.53367466E-09_JPRB, 0.53368854E-09_JPRB, &
  & 0.53370525E-09_JPRB, 0.53372184E-09_JPRB, 0.53373145E-09_JPRB, 0.53372762E-09_JPRB, 0.53371840E-09_JPRB, 0.53372484E-09_JPRB, &
  & 0.53376759E-09_JPRB, 0.53386268E-09_JPRB, 0.53401716E-09_JPRB, 0.53422694E-09_JPRB, 0.53447269E-09_JPRB, 0.53472782E-09_JPRB, &
  & 0.53496696E-09_JPRB, 0.53517407E-09_JPRB, 0.53534149E-09_JPRB, 0.53546717E-09_JPRB, 0.53555038E-09_JPRB, 0.53559202E-09_JPRB, &
  & 0.53559196E-09_JPRB, 0.53555044E-09_JPRB, 0.53546811E-09_JPRB, 0.53534788E-09_JPRB, 0.53519500E-09_JPRB, 0.53501836E-09_JPRB, &
  & 0.53482829E-09_JPRB, 0.53464222E-09_JPRB, 0.53447685E-09_JPRB, 0.53435145E-09_JPRB, 0.53427945E-09_JPRB, 0.53426485E-09_JPRB, &
  & 0.53429755E-09_JPRB, 0.53435650E-09_JPRB, 0.53442067E-09_JPRB, 0.53447280E-09_JPRB, 0.53450239E-09_JPRB, 0.53450744E-09_JPRB, &
  & 0.53449306E-09_JPRB, 0.53446830E-09_JPRB, 0.53443883E-09_JPRB, 0.53440963E-09_JPRB, 0.53438198E-09_JPRB, 0.53435739E-09_JPRB, &
  & 0.53433413E-09_JPRB, 0.53431221E-09_JPRB, 0.53428961E-09_JPRB, 0.53426913E-09_JPRB, 0.53425220E-09_JPRB, 0.53423749E-09_JPRB, &
  & 0.53422433E-09_JPRB, 0.53420907E-09_JPRB, 0.53418769E-09_JPRB, 0.53414340E-09_JPRB /)

RGHG6(:,64, 4) = (/ &
  & 0.53347921E-09_JPRB, 0.53358862E-09_JPRB, 0.53364529E-09_JPRB, 0.53369020E-09_JPRB, 0.53373095E-09_JPRB, 0.53376398E-09_JPRB, &
  & 0.53378962E-09_JPRB, 0.53380778E-09_JPRB, 0.53382399E-09_JPRB, 0.53383886E-09_JPRB, 0.53385585E-09_JPRB, 0.53387539E-09_JPRB, &
  & 0.53389798E-09_JPRB, 0.53391913E-09_JPRB, 0.53392823E-09_JPRB, 0.53392091E-09_JPRB, 0.53390709E-09_JPRB, 0.53390720E-09_JPRB, &
  & 0.53394139E-09_JPRB, 0.53402638E-09_JPRB, 0.53416888E-09_JPRB, 0.53436544E-09_JPRB, 0.53459570E-09_JPRB, 0.53483551E-09_JPRB, &
  & 0.53506011E-09_JPRB, 0.53525456E-09_JPRB, 0.53541160E-09_JPRB, 0.53552823E-09_JPRB, 0.53560517E-09_JPRB, 0.53564247E-09_JPRB, &
  & 0.53564092E-09_JPRB, 0.53560018E-09_JPRB, 0.53552152E-09_JPRB, 0.53540750E-09_JPRB, 0.53526306E-09_JPRB, 0.53509619E-09_JPRB, &
  & 0.53491733E-09_JPRB, 0.53474286E-09_JPRB, 0.53458821E-09_JPRB, 0.53447202E-09_JPRB, 0.53440713E-09_JPRB, 0.53439642E-09_JPRB, &
  & 0.53442994E-09_JPRB, 0.53448845E-09_JPRB, 0.53455235E-09_JPRB, 0.53460519E-09_JPRB, 0.53463683E-09_JPRB, 0.53464477E-09_JPRB, &
  & 0.53463328E-09_JPRB, 0.53460952E-09_JPRB, 0.53457988E-09_JPRB, 0.53454718E-09_JPRB, 0.53451565E-09_JPRB, 0.53448534E-09_JPRB, &
  & 0.53445837E-09_JPRB, 0.53443128E-09_JPRB, 0.53440630E-09_JPRB, 0.53438365E-09_JPRB, 0.53436489E-09_JPRB, 0.53434962E-09_JPRB, &
  & 0.53433419E-09_JPRB, 0.53431704E-09_JPRB, 0.53429189E-09_JPRB, 0.53423727E-09_JPRB /)

RGHG6(:,65, 4) = (/ &
  & 0.53364602E-09_JPRB, 0.53375004E-09_JPRB, 0.53380317E-09_JPRB, 0.53384697E-09_JPRB, 0.53388594E-09_JPRB, 0.53392046E-09_JPRB, &
  & 0.53394722E-09_JPRB, 0.53397026E-09_JPRB, 0.53398941E-09_JPRB, 0.53401056E-09_JPRB, 0.53403293E-09_JPRB, 0.53405996E-09_JPRB, &
  & 0.53408877E-09_JPRB, 0.53411142E-09_JPRB, 0.53411847E-09_JPRB, 0.53410842E-09_JPRB, 0.53409144E-09_JPRB, 0.53408689E-09_JPRB, &
  & 0.53411436E-09_JPRB, 0.53419014E-09_JPRB, 0.53432198E-09_JPRB, 0.53450455E-09_JPRB, 0.53471988E-09_JPRB, 0.53494303E-09_JPRB, &
  & 0.53515226E-09_JPRB, 0.53533300E-09_JPRB, 0.53547805E-09_JPRB, 0.53558574E-09_JPRB, 0.53565574E-09_JPRB, 0.53568910E-09_JPRB, &
  & 0.53568633E-09_JPRB, 0.53564742E-09_JPRB, 0.53557325E-09_JPRB, 0.53546656E-09_JPRB, 0.53533156E-09_JPRB, 0.53517552E-09_JPRB, &
  & 0.53500820E-09_JPRB, 0.53484528E-09_JPRB, 0.53470117E-09_JPRB, 0.53459392E-09_JPRB, 0.53453569E-09_JPRB, 0.53452787E-09_JPRB, &
  & 0.53456117E-09_JPRB, 0.53461802E-09_JPRB, 0.53468074E-09_JPRB, 0.53473348E-09_JPRB, 0.53476629E-09_JPRB, 0.53477622E-09_JPRB, &
  & 0.53476673E-09_JPRB, 0.53474447E-09_JPRB, 0.53471438E-09_JPRB, 0.53468063E-09_JPRB, 0.53464544E-09_JPRB, 0.53461258E-09_JPRB, &
  & 0.53458027E-09_JPRB, 0.53455057E-09_JPRB, 0.53452176E-09_JPRB, 0.53449722E-09_JPRB, 0.53447707E-09_JPRB, 0.53445948E-09_JPRB, &
  & 0.53444282E-09_JPRB, 0.53442217E-09_JPRB, 0.53439131E-09_JPRB, 0.53432447E-09_JPRB /)

RGHG6(:,66, 4) = (/ &
  & 0.53378890E-09_JPRB, 0.53389460E-09_JPRB, 0.53395072E-09_JPRB, 0.53399496E-09_JPRB, 0.53403526E-09_JPRB, 0.53407062E-09_JPRB, &
  & 0.53410110E-09_JPRB, 0.53412608E-09_JPRB, 0.53415206E-09_JPRB, 0.53417737E-09_JPRB, 0.53420851E-09_JPRB, 0.53424165E-09_JPRB, &
  & 0.53427424E-09_JPRB, 0.53429622E-09_JPRB, 0.53430105E-09_JPRB, 0.53428911E-09_JPRB, 0.53427057E-09_JPRB, 0.53426297E-09_JPRB, &
  & 0.53428528E-09_JPRB, 0.53435334E-09_JPRB, 0.53447430E-09_JPRB, 0.53464377E-09_JPRB, 0.53484250E-09_JPRB, 0.53504906E-09_JPRB, &
  & 0.53524163E-09_JPRB, 0.53540783E-09_JPRB, 0.53554061E-09_JPRB, 0.53563831E-09_JPRB, 0.53570148E-09_JPRB, 0.53573085E-09_JPRB, &
  & 0.53572730E-09_JPRB, 0.53569060E-09_JPRB, 0.53562216E-09_JPRB, 0.53552329E-09_JPRB, 0.53539884E-09_JPRB, 0.53525423E-09_JPRB, &
  & 0.53509935E-09_JPRB, 0.53494814E-09_JPRB, 0.53481503E-09_JPRB, 0.53471660E-09_JPRB, 0.53466426E-09_JPRB, 0.53465865E-09_JPRB, &
  & 0.53469096E-09_JPRB, 0.53474525E-09_JPRB, 0.53480553E-09_JPRB, 0.53485716E-09_JPRB, 0.53489047E-09_JPRB, 0.53490179E-09_JPRB, &
  & 0.53489413E-09_JPRB, 0.53487303E-09_JPRB, 0.53484323E-09_JPRB, 0.53480864E-09_JPRB, 0.53477256E-09_JPRB, 0.53473631E-09_JPRB, &
  & 0.53470200E-09_JPRB, 0.53466842E-09_JPRB, 0.53463772E-09_JPRB, 0.53461086E-09_JPRB, 0.53458871E-09_JPRB, 0.53456983E-09_JPRB, &
  & 0.53455035E-09_JPRB, 0.53452687E-09_JPRB, 0.53448990E-09_JPRB, 0.53440813E-09_JPRB /)

RGHG6(:,67, 4) = (/ &
  & 0.53391536E-09_JPRB, 0.53403226E-09_JPRB, 0.53409110E-09_JPRB, 0.53413929E-09_JPRB, 0.53418170E-09_JPRB, 0.53421922E-09_JPRB, &
  & 0.53425175E-09_JPRB, 0.53428184E-09_JPRB, 0.53431065E-09_JPRB, 0.53434457E-09_JPRB, 0.53437993E-09_JPRB, 0.53441845E-09_JPRB, &
  & 0.53445115E-09_JPRB, 0.53447158E-09_JPRB, 0.53447546E-09_JPRB, 0.53446325E-09_JPRB, 0.53444421E-09_JPRB, 0.53443489E-09_JPRB, &
  & 0.53445343E-09_JPRB, 0.53451449E-09_JPRB, 0.53462557E-09_JPRB, 0.53478050E-09_JPRB, 0.53496318E-09_JPRB, 0.53515137E-09_JPRB, &
  & 0.53532739E-09_JPRB, 0.53547800E-09_JPRB, 0.53559812E-09_JPRB, 0.53568605E-09_JPRB, 0.53574223E-09_JPRB, 0.53576793E-09_JPRB, &
  & 0.53576366E-09_JPRB, 0.53572979E-09_JPRB, 0.53566690E-09_JPRB, 0.53557697E-09_JPRB, 0.53546312E-09_JPRB, 0.53533089E-09_JPRB, &
  & 0.53518867E-09_JPRB, 0.53505006E-09_JPRB, 0.53492821E-09_JPRB, 0.53483878E-09_JPRB, 0.53479210E-09_JPRB, 0.53478832E-09_JPRB, &
  & 0.53481891E-09_JPRB, 0.53486970E-09_JPRB, 0.53492666E-09_JPRB, 0.53497656E-09_JPRB, 0.53500959E-09_JPRB, 0.53502186E-09_JPRB, &
  & 0.53501559E-09_JPRB, 0.53499555E-09_JPRB, 0.53496629E-09_JPRB, 0.53493182E-09_JPRB, 0.53489496E-09_JPRB, 0.53485777E-09_JPRB, &
  & 0.53482119E-09_JPRB, 0.53478610E-09_JPRB, 0.53475335E-09_JPRB, 0.53472504E-09_JPRB, 0.53470117E-09_JPRB, 0.53468008E-09_JPRB, &
  & 0.53465932E-09_JPRB, 0.53463234E-09_JPRB, 0.53458915E-09_JPRB, 0.53449378E-09_JPRB /)

RGHG6(:,68, 4) = (/ &
  & 0.53403737E-09_JPRB, 0.53416271E-09_JPRB, 0.53423099E-09_JPRB, 0.53428212E-09_JPRB, 0.53432792E-09_JPRB, 0.53436811E-09_JPRB, &
  & 0.53440291E-09_JPRB, 0.53443605E-09_JPRB, 0.53447069E-09_JPRB, 0.53450772E-09_JPRB, 0.53454841E-09_JPRB, 0.53458710E-09_JPRB, &
  & 0.53461929E-09_JPRB, 0.53463867E-09_JPRB, 0.53464200E-09_JPRB, 0.53463034E-09_JPRB, 0.53461202E-09_JPRB, 0.53460231E-09_JPRB, &
  & 0.53461768E-09_JPRB, 0.53467270E-09_JPRB, 0.53477328E-09_JPRB, 0.53491428E-09_JPRB, 0.53507904E-09_JPRB, 0.53524951E-09_JPRB, &
  & 0.53540777E-09_JPRB, 0.53554339E-09_JPRB, 0.53565075E-09_JPRB, 0.53572885E-09_JPRB, 0.53577842E-09_JPRB, 0.53580074E-09_JPRB, &
  & 0.53579619E-09_JPRB, 0.53576521E-09_JPRB, 0.53570848E-09_JPRB, 0.53562682E-09_JPRB, 0.53552440E-09_JPRB, 0.53540428E-09_JPRB, &
  & 0.53527566E-09_JPRB, 0.53514937E-09_JPRB, 0.53503946E-09_JPRB, 0.53495919E-09_JPRB, 0.53491811E-09_JPRB, 0.53491567E-09_JPRB, &
  & 0.53494442E-09_JPRB, 0.53499094E-09_JPRB, 0.53504434E-09_JPRB, 0.53509153E-09_JPRB, 0.53512372E-09_JPRB, 0.53513638E-09_JPRB, &
  & 0.53513122E-09_JPRB, 0.53511245E-09_JPRB, 0.53508420E-09_JPRB, 0.53505034E-09_JPRB, 0.53501348E-09_JPRB, 0.53497612E-09_JPRB, &
  & 0.53493882E-09_JPRB, 0.53490246E-09_JPRB, 0.53486904E-09_JPRB, 0.53483945E-09_JPRB, 0.53481441E-09_JPRB, 0.53479238E-09_JPRB, &
  & 0.53476973E-09_JPRB, 0.53474092E-09_JPRB, 0.53469285E-09_JPRB, 0.53458721E-09_JPRB /)

RGHG6(:,69, 4) = (/ &
  & 0.53414839E-09_JPRB, 0.53429677E-09_JPRB, 0.53436933E-09_JPRB, 0.53442767E-09_JPRB, 0.53447557E-09_JPRB, 0.53451787E-09_JPRB, &
  & 0.53455546E-09_JPRB, 0.53459109E-09_JPRB, 0.53462890E-09_JPRB, 0.53466936E-09_JPRB, 0.53471072E-09_JPRB, 0.53474919E-09_JPRB, &
  & 0.53477983E-09_JPRB, 0.53479837E-09_JPRB, 0.53480159E-09_JPRB, 0.53479088E-09_JPRB, 0.53477406E-09_JPRB, 0.53476451E-09_JPRB, &
  & 0.53477772E-09_JPRB, 0.53482641E-09_JPRB, 0.53491661E-09_JPRB, 0.53504251E-09_JPRB, 0.53519017E-09_JPRB, 0.53534177E-09_JPRB, &
  & 0.53548316E-09_JPRB, 0.53560367E-09_JPRB, 0.53569865E-09_JPRB, 0.53576749E-09_JPRB, 0.53581078E-09_JPRB, 0.53582982E-09_JPRB, &
  & 0.53582522E-09_JPRB, 0.53579741E-09_JPRB, 0.53574661E-09_JPRB, 0.53567384E-09_JPRB, 0.53558186E-09_JPRB, 0.53547483E-09_JPRB, &
  & 0.53535887E-09_JPRB, 0.53524557E-09_JPRB, 0.53514737E-09_JPRB, 0.53507643E-09_JPRB, 0.53504090E-09_JPRB, 0.53503990E-09_JPRB, &
  & 0.53506632E-09_JPRB, 0.53510907E-09_JPRB, 0.53515814E-09_JPRB, 0.53520227E-09_JPRB, 0.53523286E-09_JPRB, 0.53524551E-09_JPRB, &
  & 0.53524113E-09_JPRB, 0.53522387E-09_JPRB, 0.53519683E-09_JPRB, 0.53516402E-09_JPRB, 0.53512816E-09_JPRB, 0.53509136E-09_JPRB, &
  & 0.53505428E-09_JPRB, 0.53501803E-09_JPRB, 0.53498445E-09_JPRB, 0.53495480E-09_JPRB, 0.53492932E-09_JPRB, 0.53490662E-09_JPRB, &
  & 0.53488375E-09_JPRB, 0.53485344E-09_JPRB, 0.53480198E-09_JPRB, 0.53468752E-09_JPRB /)

RGHG6(:,70, 4) = (/ &
  & 0.53426286E-09_JPRB, 0.53442611E-09_JPRB, 0.53451488E-09_JPRB, 0.53457538E-09_JPRB, 0.53462690E-09_JPRB, 0.53467020E-09_JPRB, &
  & 0.53470872E-09_JPRB, 0.53474708E-09_JPRB, 0.53478616E-09_JPRB, 0.53482757E-09_JPRB, 0.53486809E-09_JPRB, 0.53490479E-09_JPRB, &
  & 0.53493365E-09_JPRB, 0.53495108E-09_JPRB, 0.53495436E-09_JPRB, 0.53494487E-09_JPRB, 0.53492977E-09_JPRB, 0.53492100E-09_JPRB, &
  & 0.53493221E-09_JPRB, 0.53497479E-09_JPRB, 0.53505400E-09_JPRB, 0.53516508E-09_JPRB, 0.53529453E-09_JPRB, 0.53542826E-09_JPRB, &
  & 0.53555288E-09_JPRB, 0.53565902E-09_JPRB, 0.53574223E-09_JPRB, 0.53580240E-09_JPRB, 0.53583987E-09_JPRB, 0.53585580E-09_JPRB, &
  & 0.53585131E-09_JPRB, 0.53582666E-09_JPRB, 0.53578197E-09_JPRB, 0.53571764E-09_JPRB, 0.53563676E-09_JPRB, 0.53554167E-09_JPRB, &
  & 0.53543886E-09_JPRB, 0.53533805E-09_JPRB, 0.53525140E-09_JPRB, 0.53518961E-09_JPRB, 0.53515964E-09_JPRB, 0.53515969E-09_JPRB, &
  & 0.53518406E-09_JPRB, 0.53522264E-09_JPRB, 0.53526761E-09_JPRB, 0.53530796E-09_JPRB, 0.53533650E-09_JPRB, 0.53534865E-09_JPRB, &
  & 0.53534505E-09_JPRB, 0.53532934E-09_JPRB, 0.53530425E-09_JPRB, 0.53527305E-09_JPRB, 0.53523874E-09_JPRB, 0.53520360E-09_JPRB, &
  & 0.53516780E-09_JPRB, 0.53513260E-09_JPRB, 0.53510002E-09_JPRB, 0.53507110E-09_JPRB, 0.53504629E-09_JPRB, 0.53502408E-09_JPRB, &
  & 0.53500149E-09_JPRB, 0.53497157E-09_JPRB, 0.53491861E-09_JPRB, 0.53479865E-09_JPRB /)

RGHG6(:,71, 4) = (/ &
  & 0.53438054E-09_JPRB, 0.53457050E-09_JPRB, 0.53466453E-09_JPRB, 0.53473048E-09_JPRB, 0.53478144E-09_JPRB, 0.53482530E-09_JPRB, &
  & 0.53486415E-09_JPRB, 0.53490268E-09_JPRB, 0.53494226E-09_JPRB, 0.53498250E-09_JPRB, 0.53502108E-09_JPRB, 0.53505500E-09_JPRB, &
  & 0.53508137E-09_JPRB, 0.53509702E-09_JPRB, 0.53510008E-09_JPRB, 0.53509175E-09_JPRB, 0.53507848E-09_JPRB, 0.53507043E-09_JPRB, &
  & 0.53507981E-09_JPRB, 0.53511640E-09_JPRB, 0.53518484E-09_JPRB, 0.53528065E-09_JPRB, 0.53539284E-09_JPRB, 0.53550864E-09_JPRB, &
  & 0.53561744E-09_JPRB, 0.53570970E-09_JPRB, 0.53578181E-09_JPRB, 0.53583371E-09_JPRB, 0.53586580E-09_JPRB, 0.53587906E-09_JPRB, &
  & 0.53587473E-09_JPRB, 0.53585347E-09_JPRB, 0.53581461E-09_JPRB, 0.53575883E-09_JPRB, 0.53568816E-09_JPRB, 0.53560528E-09_JPRB, &
  & 0.53551474E-09_JPRB, 0.53542659E-09_JPRB, 0.53535104E-09_JPRB, 0.53529819E-09_JPRB, 0.53527333E-09_JPRB, 0.53527455E-09_JPRB, &
  & 0.53529625E-09_JPRB, 0.53533139E-09_JPRB, 0.53537125E-09_JPRB, 0.53540800E-09_JPRB, 0.53543392E-09_JPRB, 0.53544530E-09_JPRB, &
  & 0.53544225E-09_JPRB, 0.53542848E-09_JPRB, 0.53540561E-09_JPRB, 0.53537685E-09_JPRB, 0.53534516E-09_JPRB, 0.53531229E-09_JPRB, &
  & 0.53527910E-09_JPRB, 0.53524574E-09_JPRB, 0.53521532E-09_JPRB, 0.53518817E-09_JPRB, 0.53516502E-09_JPRB, 0.53514393E-09_JPRB, &
  & 0.53512272E-09_JPRB, 0.53509447E-09_JPRB, 0.53504418E-09_JPRB, 0.53492838E-09_JPRB /)

RGHG6(:,72, 4) = (/ &
  & 0.53452004E-09_JPRB, 0.53472327E-09_JPRB, 0.53482518E-09_JPRB, 0.53489041E-09_JPRB, 0.53494081E-09_JPRB, 0.53498300E-09_JPRB, &
  & 0.53502103E-09_JPRB, 0.53505894E-09_JPRB, 0.53509630E-09_JPRB, 0.53513505E-09_JPRB, 0.53516980E-09_JPRB, 0.53520022E-09_JPRB, &
  & 0.53522325E-09_JPRB, 0.53523647E-09_JPRB, 0.53523880E-09_JPRB, 0.53523114E-09_JPRB, 0.53521948E-09_JPRB, 0.53521221E-09_JPRB, &
  & 0.53521976E-09_JPRB, 0.53525046E-09_JPRB, 0.53530813E-09_JPRB, 0.53538968E-09_JPRB, 0.53548477E-09_JPRB, 0.53558352E-09_JPRB, &
  & 0.53567661E-09_JPRB, 0.53575594E-09_JPRB, 0.53581761E-09_JPRB, 0.53586197E-09_JPRB, 0.53588911E-09_JPRB, 0.53589994E-09_JPRB, &
  & 0.53589588E-09_JPRB, 0.53587784E-09_JPRB, 0.53584481E-09_JPRB, 0.53579685E-09_JPRB, 0.53573651E-09_JPRB, 0.53566496E-09_JPRB, &
  & 0.53558696E-09_JPRB, 0.53551075E-09_JPRB, 0.53544602E-09_JPRB, 0.53540172E-09_JPRB, 0.53538146E-09_JPRB, 0.53538329E-09_JPRB, &
  & 0.53540283E-09_JPRB, 0.53543336E-09_JPRB, 0.53546878E-09_JPRB, 0.53550103E-09_JPRB, 0.53552413E-09_JPRB, 0.53553462E-09_JPRB, &
  & 0.53553229E-09_JPRB, 0.53552074E-09_JPRB, 0.53550048E-09_JPRB, 0.53547505E-09_JPRB, 0.53544646E-09_JPRB, 0.53541738E-09_JPRB, &
  & 0.53538701E-09_JPRB, 0.53535715E-09_JPRB, 0.53532911E-09_JPRB, 0.53530469E-09_JPRB, 0.53528365E-09_JPRB, 0.53526467E-09_JPRB, &
  & 0.53524518E-09_JPRB, 0.53521931E-09_JPRB, 0.53517302E-09_JPRB, 0.53506377E-09_JPRB /)

RGHG6(:,73, 4) = (/ &
  & 0.53468729E-09_JPRB, 0.53489169E-09_JPRB, 0.53499283E-09_JPRB, 0.53505406E-09_JPRB, 0.53510152E-09_JPRB, 0.53514143E-09_JPRB, &
  & 0.53517729E-09_JPRB, 0.53521260E-09_JPRB, 0.53524801E-09_JPRB, 0.53528210E-09_JPRB, 0.53531379E-09_JPRB, 0.53533955E-09_JPRB, &
  & 0.53535876E-09_JPRB, 0.53536908E-09_JPRB, 0.53536980E-09_JPRB, 0.53536242E-09_JPRB, 0.53535182E-09_JPRB, 0.53534538E-09_JPRB, &
  & 0.53535121E-09_JPRB, 0.53537608E-09_JPRB, 0.53542382E-09_JPRB, 0.53549137E-09_JPRB, 0.53557025E-09_JPRB, 0.53565269E-09_JPRB, &
  & 0.53573118E-09_JPRB, 0.53579829E-09_JPRB, 0.53584998E-09_JPRB, 0.53588722E-09_JPRB, 0.53590976E-09_JPRB, 0.53591848E-09_JPRB, &
  & 0.53591476E-09_JPRB, 0.53589977E-09_JPRB, 0.53587257E-09_JPRB, 0.53583232E-09_JPRB, 0.53578114E-09_JPRB, 0.53572130E-09_JPRB, &
  & 0.53565485E-09_JPRB, 0.53559024E-09_JPRB, 0.53553595E-09_JPRB, 0.53549942E-09_JPRB, 0.53548344E-09_JPRB, 0.53548560E-09_JPRB, &
  & 0.53550231E-09_JPRB, 0.53552929E-09_JPRB, 0.53555882E-09_JPRB, 0.53558702E-09_JPRB, 0.53560678E-09_JPRB, 0.53561633E-09_JPRB, &
  & 0.53561450E-09_JPRB, 0.53560550E-09_JPRB, 0.53558813E-09_JPRB, 0.53556631E-09_JPRB, 0.53554178E-09_JPRB, 0.53551619E-09_JPRB, &
  & 0.53549093E-09_JPRB, 0.53546395E-09_JPRB, 0.53543986E-09_JPRB, 0.53541793E-09_JPRB, 0.53539984E-09_JPRB, 0.53538285E-09_JPRB, &
  & 0.53536525E-09_JPRB, 0.53534194E-09_JPRB, 0.53530014E-09_JPRB, 0.53519900E-09_JPRB /)

RGHG6(:,74, 4) = (/ &
  & 0.53486393E-09_JPRB, 0.53506716E-09_JPRB, 0.53516097E-09_JPRB, 0.53521737E-09_JPRB, 0.53525995E-09_JPRB, 0.53529647E-09_JPRB, &
  & 0.53532906E-09_JPRB, 0.53536192E-09_JPRB, 0.53539129E-09_JPRB, 0.53542354E-09_JPRB, 0.53544880E-09_JPRB, 0.53547067E-09_JPRB, &
  & 0.53548588E-09_JPRB, 0.53549287E-09_JPRB, 0.53549198E-09_JPRB, 0.53548455E-09_JPRB, 0.53547494E-09_JPRB, 0.53546917E-09_JPRB, &
  & 0.53547328E-09_JPRB, 0.53549287E-09_JPRB, 0.53553106E-09_JPRB, 0.53558602E-09_JPRB, 0.53564941E-09_JPRB, 0.53571669E-09_JPRB, &
  & 0.53578153E-09_JPRB, 0.53583699E-09_JPRB, 0.53587912E-09_JPRB, 0.53590993E-09_JPRB, 0.53592830E-09_JPRB, 0.53593519E-09_JPRB, &
  & 0.53593158E-09_JPRB, 0.53591970E-09_JPRB, 0.53589810E-09_JPRB, 0.53586474E-09_JPRB, 0.53582278E-09_JPRB, 0.53577337E-09_JPRB, &
  & 0.53571869E-09_JPRB, 0.53566523E-09_JPRB, 0.53562044E-09_JPRB, 0.53559124E-09_JPRB, 0.53557858E-09_JPRB, 0.53558080E-09_JPRB, &
  & 0.53559523E-09_JPRB, 0.53561744E-09_JPRB, 0.53564198E-09_JPRB, 0.53566568E-09_JPRB, 0.53568239E-09_JPRB, 0.53569077E-09_JPRB, &
  & 0.53568933E-09_JPRB, 0.53568272E-09_JPRB, 0.53566845E-09_JPRB, 0.53565058E-09_JPRB, 0.53563004E-09_JPRB, 0.53560922E-09_JPRB, &
  & 0.53558757E-09_JPRB, 0.53556554E-09_JPRB, 0.53554422E-09_JPRB, 0.53552612E-09_JPRB, 0.53551069E-09_JPRB, 0.53549615E-09_JPRB, &
  & 0.53548049E-09_JPRB, 0.53545945E-09_JPRB, 0.53542271E-09_JPRB, 0.53532961E-09_JPRB /)

RGHG6(:,75, 4) = (/ &
  & 0.53504834E-09_JPRB, 0.53523963E-09_JPRB, 0.53532723E-09_JPRB, 0.53537463E-09_JPRB, 0.53541194E-09_JPRB, 0.53544424E-09_JPRB, &
  & 0.53547272E-09_JPRB, 0.53550092E-09_JPRB, 0.53552696E-09_JPRB, 0.53555205E-09_JPRB, 0.53557442E-09_JPRB, 0.53559079E-09_JPRB, &
  & 0.53560245E-09_JPRB, 0.53560678E-09_JPRB, 0.53560439E-09_JPRB, 0.53559718E-09_JPRB, 0.53558841E-09_JPRB, 0.53558358E-09_JPRB, &
  & 0.53558608E-09_JPRB, 0.53560067E-09_JPRB, 0.53563048E-09_JPRB, 0.53567362E-09_JPRB, 0.53572319E-09_JPRB, 0.53577615E-09_JPRB, &
  & 0.53582805E-09_JPRB, 0.53587240E-09_JPRB, 0.53590554E-09_JPRB, 0.53593036E-09_JPRB, 0.53594484E-09_JPRB, 0.53594990E-09_JPRB, &
  & 0.53594673E-09_JPRB, 0.53593763E-09_JPRB, 0.53592109E-09_JPRB, 0.53589433E-09_JPRB, 0.53586091E-09_JPRB, 0.53582194E-09_JPRB, &
  & 0.53577798E-09_JPRB, 0.53573518E-09_JPRB, 0.53569943E-09_JPRB, 0.53567689E-09_JPRB, 0.53566723E-09_JPRB, 0.53566934E-09_JPRB, &
  & 0.53568106E-09_JPRB, 0.53569921E-09_JPRB, 0.53571830E-09_JPRB, 0.53573773E-09_JPRB, 0.53575133E-09_JPRB, 0.53575860E-09_JPRB, &
  & 0.53575705E-09_JPRB, 0.53575305E-09_JPRB, 0.53574151E-09_JPRB, 0.53572785E-09_JPRB, 0.53571125E-09_JPRB, 0.53569438E-09_JPRB, &
  & 0.53567772E-09_JPRB, 0.53565929E-09_JPRB, 0.53564209E-09_JPRB, 0.53562715E-09_JPRB, 0.53561500E-09_JPRB, 0.53560273E-09_JPRB, &
  & 0.53558918E-09_JPRB, 0.53557081E-09_JPRB, 0.53553817E-09_JPRB, 0.53545401E-09_JPRB /)

RGHG6(:,76, 4) = (/ &
  & 0.53523191E-09_JPRB, 0.53541099E-09_JPRB, 0.53548538E-09_JPRB, 0.53552396E-09_JPRB, 0.53555477E-09_JPRB, 0.53558169E-09_JPRB, &
  & 0.53560589E-09_JPRB, 0.53562949E-09_JPRB, 0.53564819E-09_JPRB, 0.53567012E-09_JPRB, 0.53568538E-09_JPRB, 0.53569843E-09_JPRB, &
  & 0.53570670E-09_JPRB, 0.53570914E-09_JPRB, 0.53570598E-09_JPRB, 0.53569965E-09_JPRB, 0.53569221E-09_JPRB, 0.53568849E-09_JPRB, &
  & 0.53568944E-09_JPRB, 0.53569971E-09_JPRB, 0.53572180E-09_JPRB, 0.53575516E-09_JPRB, 0.53579163E-09_JPRB, 0.53583121E-09_JPRB, &
  & 0.53587101E-09_JPRB, 0.53590482E-09_JPRB, 0.53592930E-09_JPRB, 0.53594873E-09_JPRB, 0.53595972E-09_JPRB, 0.53596327E-09_JPRB, &
  & 0.53596022E-09_JPRB, 0.53595373E-09_JPRB, 0.53594224E-09_JPRB, 0.53592125E-09_JPRB, 0.53589611E-09_JPRB, 0.53586641E-09_JPRB, &
  & 0.53583310E-09_JPRB, 0.53580029E-09_JPRB, 0.53577298E-09_JPRB, 0.53575649E-09_JPRB, 0.53574933E-09_JPRB, 0.53575111E-09_JPRB, &
  & 0.53576055E-09_JPRB, 0.53577448E-09_JPRB, 0.53578847E-09_JPRB, 0.53580368E-09_JPRB, 0.53581389E-09_JPRB, 0.53582017E-09_JPRB, &
  & 0.53581850E-09_JPRB, 0.53581695E-09_JPRB, 0.53580790E-09_JPRB, 0.53579802E-09_JPRB, 0.53578542E-09_JPRB, 0.53577198E-09_JPRB, &
  & 0.53576010E-09_JPRB, 0.53574584E-09_JPRB, 0.53573201E-09_JPRB, 0.53572086E-09_JPRB, 0.53571220E-09_JPRB, 0.53570254E-09_JPRB, &
  & 0.53569105E-09_JPRB, 0.53567489E-09_JPRB, 0.53564736E-09_JPRB, 0.53557059E-09_JPRB /)

RGHG6(:,77, 4) = (/ &
  & 0.53541760E-09_JPRB, 0.53557253E-09_JPRB, 0.53563465E-09_JPRB, 0.53566207E-09_JPRB, 0.53568566E-09_JPRB, 0.53570781E-09_JPRB, &
  & 0.53572580E-09_JPRB, 0.53574434E-09_JPRB, 0.53575627E-09_JPRB, 0.53577198E-09_JPRB, 0.53578270E-09_JPRB, 0.53579113E-09_JPRB, &
  & 0.53579702E-09_JPRB, 0.53579841E-09_JPRB, 0.53579530E-09_JPRB, 0.53579052E-09_JPRB, 0.53578481E-09_JPRB, 0.53578275E-09_JPRB, &
  & 0.53578264E-09_JPRB, 0.53578919E-09_JPRB, 0.53580496E-09_JPRB, 0.53582966E-09_JPRB, 0.53585425E-09_JPRB, 0.53588128E-09_JPRB, &
  & 0.53590987E-09_JPRB, 0.53593396E-09_JPRB, 0.53595028E-09_JPRB, 0.53596499E-09_JPRB, 0.53597304E-09_JPRB, 0.53597515E-09_JPRB, &
  & 0.53597199E-09_JPRB, 0.53596783E-09_JPRB, 0.53596122E-09_JPRB, 0.53594562E-09_JPRB, 0.53592752E-09_JPRB, 0.53590699E-09_JPRB, &
  & 0.53588323E-09_JPRB, 0.53585991E-09_JPRB, 0.53584048E-09_JPRB, 0.53582960E-09_JPRB, 0.53582450E-09_JPRB, 0.53582577E-09_JPRB, &
  & 0.53583243E-09_JPRB, 0.53584259E-09_JPRB, 0.53585192E-09_JPRB, 0.53586313E-09_JPRB, 0.53587024E-09_JPRB, 0.53587540E-09_JPRB, &
  & 0.53587312E-09_JPRB, 0.53587418E-09_JPRB, 0.53586702E-09_JPRB, 0.53586113E-09_JPRB, 0.53585181E-09_JPRB, 0.53584204E-09_JPRB, &
  & 0.53583471E-09_JPRB, 0.53582427E-09_JPRB, 0.53581367E-09_JPRB, 0.53580629E-09_JPRB, 0.53580135E-09_JPRB, 0.53579402E-09_JPRB, &
  & 0.53578475E-09_JPRB, 0.53577109E-09_JPRB, 0.53574822E-09_JPRB, 0.53568144E-09_JPRB /)

RGHG6(:,78, 4) = (/ &
  & 0.53559951E-09_JPRB, 0.53572047E-09_JPRB, 0.53576349E-09_JPRB, 0.53578025E-09_JPRB, 0.53579696E-09_JPRB, 0.53581345E-09_JPRB, &
  & 0.53582616E-09_JPRB, 0.53583832E-09_JPRB, 0.53584343E-09_JPRB, 0.53585403E-09_JPRB, 0.53585991E-09_JPRB, 0.53586502E-09_JPRB, &
  & 0.53586874E-09_JPRB, 0.53586996E-09_JPRB, 0.53586724E-09_JPRB, 0.53586469E-09_JPRB, 0.53586108E-09_JPRB, 0.53586113E-09_JPRB, &
  & 0.53586041E-09_JPRB, 0.53586424E-09_JPRB, 0.53587479E-09_JPRB, 0.53589305E-09_JPRB, 0.53590743E-09_JPRB, 0.53592392E-09_JPRB, &
  & 0.53594285E-09_JPRB, 0.53595872E-09_JPRB, 0.53596777E-09_JPRB, 0.53597859E-09_JPRB, 0.53598403E-09_JPRB, 0.53598515E-09_JPRB, &
  & 0.53598198E-09_JPRB, 0.53597987E-09_JPRB, 0.53597737E-09_JPRB, 0.53596627E-09_JPRB, 0.53595423E-09_JPRB, 0.53594168E-09_JPRB, &
  & 0.53592619E-09_JPRB, 0.53591087E-09_JPRB, 0.53589833E-09_JPRB, 0.53589216E-09_JPRB, 0.53588872E-09_JPRB, 0.53588944E-09_JPRB, &
  & 0.53589361E-09_JPRB, 0.53590060E-09_JPRB, 0.53590538E-09_JPRB, 0.53591326E-09_JPRB, 0.53591698E-09_JPRB, 0.53592136E-09_JPRB, &
  & 0.53591825E-09_JPRB, 0.53592170E-09_JPRB, 0.53591614E-09_JPRB, 0.53591359E-09_JPRB, 0.53590754E-09_JPRB, 0.53590010E-09_JPRB, &
  & 0.53589727E-09_JPRB, 0.53588983E-09_JPRB, 0.53588228E-09_JPRB, 0.53587829E-09_JPRB, 0.53587668E-09_JPRB, 0.53587185E-09_JPRB, &
  & 0.53586430E-09_JPRB, 0.53585258E-09_JPRB, 0.53583749E-09_JPRB, 0.53578603E-09_JPRB /)

RGHG6(:,79, 4) = (/ &
  & 0.53571747E-09_JPRB, 0.53580301E-09_JPRB, 0.53583299E-09_JPRB, 0.53584132E-09_JPRB, 0.53585442E-09_JPRB, 0.53586863E-09_JPRB, &
  & 0.53587756E-09_JPRB, 0.53588722E-09_JPRB, 0.53588789E-09_JPRB, 0.53589660E-09_JPRB, 0.53589966E-09_JPRB, 0.53590327E-09_JPRB, &
  & 0.53590621E-09_JPRB, 0.53590737E-09_JPRB, 0.53590454E-09_JPRB, 0.53590327E-09_JPRB, 0.53590077E-09_JPRB, 0.53590232E-09_JPRB, &
  & 0.53590121E-09_JPRB, 0.53590365E-09_JPRB, 0.53591193E-09_JPRB, 0.53592714E-09_JPRB, 0.53593585E-09_JPRB, 0.53594662E-09_JPRB, &
  & 0.53596066E-09_JPRB, 0.53597216E-09_JPRB, 0.53597732E-09_JPRB, 0.53598637E-09_JPRB, 0.53599036E-09_JPRB, 0.53599075E-09_JPRB, &
  & 0.53598714E-09_JPRB, 0.53598626E-09_JPRB, 0.53598653E-09_JPRB, 0.53597782E-09_JPRB, 0.53596888E-09_JPRB, 0.53596078E-09_JPRB, &
  & 0.53594956E-09_JPRB, 0.53593846E-09_JPRB, 0.53592936E-09_JPRB, 0.53592586E-09_JPRB, 0.53592297E-09_JPRB, 0.53592336E-09_JPRB, &
  & 0.53592608E-09_JPRB, 0.53593130E-09_JPRB, 0.53593363E-09_JPRB, 0.53593963E-09_JPRB, 0.53594162E-09_JPRB, 0.53594579E-09_JPRB, &
  & 0.53594162E-09_JPRB, 0.53594684E-09_JPRB, 0.53594179E-09_JPRB, 0.53594135E-09_JPRB, 0.53593679E-09_JPRB, 0.53593036E-09_JPRB, &
  & 0.53593013E-09_JPRB, 0.53592403E-09_JPRB, 0.53591759E-09_JPRB, 0.53591537E-09_JPRB, 0.53591598E-09_JPRB, 0.53591215E-09_JPRB, &
  & 0.53590526E-09_JPRB, 0.53589527E-09_JPRB, 0.53588639E-09_JPRB, 0.53585253E-09_JPRB /)

RGHG6(:,80, 4) = (/ &
  & 0.53579519E-09_JPRB, 0.53584320E-09_JPRB, 0.53586341E-09_JPRB, 0.53586768E-09_JPRB, 0.53587906E-09_JPRB, 0.53589233E-09_JPRB, &
  & 0.53590032E-09_JPRB, 0.53590821E-09_JPRB, 0.53590754E-09_JPRB, 0.53591481E-09_JPRB, 0.53591753E-09_JPRB, 0.53592031E-09_JPRB, &
  & 0.53592303E-09_JPRB, 0.53592414E-09_JPRB, 0.53592109E-09_JPRB, 0.53592047E-09_JPRB, 0.53591842E-09_JPRB, 0.53592097E-09_JPRB, &
  & 0.53591948E-09_JPRB, 0.53592120E-09_JPRB, 0.53592852E-09_JPRB, 0.53594285E-09_JPRB, 0.53594884E-09_JPRB, 0.53595695E-09_JPRB, &
  & 0.53596888E-09_JPRB, 0.53597837E-09_JPRB, 0.53598154E-09_JPRB, 0.53598997E-09_JPRB, 0.53599347E-09_JPRB, 0.53599358E-09_JPRB, &
  & 0.53598959E-09_JPRB, 0.53598942E-09_JPRB, 0.53599108E-09_JPRB, 0.53598331E-09_JPRB, 0.53597571E-09_JPRB, 0.53596966E-09_JPRB, &
  & 0.53596039E-09_JPRB, 0.53595095E-09_JPRB, 0.53594346E-09_JPRB, 0.53594112E-09_JPRB, 0.53593857E-09_JPRB, 0.53593868E-09_JPRB, &
  & 0.53594079E-09_JPRB, 0.53594523E-09_JPRB, 0.53594618E-09_JPRB, 0.53595151E-09_JPRB, 0.53595250E-09_JPRB, 0.53595672E-09_JPRB, &
  & 0.53595189E-09_JPRB, 0.53595822E-09_JPRB, 0.53595317E-09_JPRB, 0.53595373E-09_JPRB, 0.53594967E-09_JPRB, 0.53594340E-09_JPRB, &
  & 0.53594451E-09_JPRB, 0.53593885E-09_JPRB, 0.53593274E-09_JPRB, 0.53593147E-09_JPRB, 0.53593308E-09_JPRB, 0.53592969E-09_JPRB, &
  & 0.53592292E-09_JPRB, 0.53591342E-09_JPRB, 0.53590948E-09_JPRB, 0.53589566E-09_JPRB /)

RGHG6(:,81, 4) = (/ &
  & 0.53584820E-09_JPRB, 0.53586008E-09_JPRB, 0.53587640E-09_JPRB, 0.53587867E-09_JPRB, 0.53588944E-09_JPRB, 0.53590266E-09_JPRB, &
  & 0.53590943E-09_JPRB, 0.53591753E-09_JPRB, 0.53591553E-09_JPRB, 0.53592397E-09_JPRB, 0.53592553E-09_JPRB, 0.53592825E-09_JPRB, &
  & 0.53593058E-09_JPRB, 0.53593163E-09_JPRB, 0.53592841E-09_JPRB, 0.53592802E-09_JPRB, 0.53592630E-09_JPRB, 0.53592936E-09_JPRB, &
  & 0.53592764E-09_JPRB, 0.53592891E-09_JPRB, 0.53593580E-09_JPRB, 0.53594995E-09_JPRB, 0.53595450E-09_JPRB, 0.53596139E-09_JPRB, &
  & 0.53597249E-09_JPRB, 0.53598120E-09_JPRB, 0.53598337E-09_JPRB, 0.53599164E-09_JPRB, 0.53599503E-09_JPRB, 0.53599486E-09_JPRB, &
  & 0.53599059E-09_JPRB, 0.53599081E-09_JPRB, 0.53599325E-09_JPRB, 0.53598581E-09_JPRB, 0.53597876E-09_JPRB, 0.53597365E-09_JPRB, &
  & 0.53596516E-09_JPRB, 0.53595672E-09_JPRB, 0.53594978E-09_JPRB, 0.53594790E-09_JPRB, 0.53594545E-09_JPRB, 0.53594551E-09_JPRB, &
  & 0.53594718E-09_JPRB, 0.53595139E-09_JPRB, 0.53595167E-09_JPRB, 0.53595678E-09_JPRB, 0.53595733E-09_JPRB, 0.53596150E-09_JPRB, &
  & 0.53595622E-09_JPRB, 0.53596333E-09_JPRB, 0.53595811E-09_JPRB, 0.53595911E-09_JPRB, 0.53595534E-09_JPRB, 0.53594901E-09_JPRB, &
  & 0.53595095E-09_JPRB, 0.53594523E-09_JPRB, 0.53593913E-09_JPRB, 0.53593835E-09_JPRB, 0.53594051E-09_JPRB, 0.53593713E-09_JPRB, &
  & 0.53593041E-09_JPRB, 0.53592081E-09_JPRB, 0.53591898E-09_JPRB, 0.53592475E-09_JPRB /)

RGHG6(:,82, 4) = (/ &
  & 0.53585247E-09_JPRB, 0.53586569E-09_JPRB, 0.53588206E-09_JPRB, 0.53588384E-09_JPRB, 0.53589461E-09_JPRB, 0.53590743E-09_JPRB, &
  & 0.53591537E-09_JPRB, 0.53592220E-09_JPRB, 0.53592042E-09_JPRB, 0.53592669E-09_JPRB, 0.53592958E-09_JPRB, 0.53593174E-09_JPRB, &
  & 0.53593441E-09_JPRB, 0.53593535E-09_JPRB, 0.53593208E-09_JPRB, 0.53593174E-09_JPRB, 0.53593019E-09_JPRB, 0.53593363E-09_JPRB, &
  & 0.53593169E-09_JPRB, 0.53593263E-09_JPRB, 0.53593940E-09_JPRB, 0.53595345E-09_JPRB, 0.53595728E-09_JPRB, 0.53596344E-09_JPRB, &
  & 0.53597432E-09_JPRB, 0.53598265E-09_JPRB, 0.53598437E-09_JPRB, 0.53599253E-09_JPRB, 0.53599580E-09_JPRB, 0.53599564E-09_JPRB, &
  & 0.53599114E-09_JPRB, 0.53599153E-09_JPRB, 0.53599442E-09_JPRB, 0.53598714E-09_JPRB, 0.53598037E-09_JPRB, 0.53597560E-09_JPRB, &
  & 0.53596749E-09_JPRB, 0.53595944E-09_JPRB, 0.53595295E-09_JPRB, 0.53595128E-09_JPRB, 0.53594895E-09_JPRB, 0.53594901E-09_JPRB, &
  & 0.53595056E-09_JPRB, 0.53595467E-09_JPRB, 0.53595450E-09_JPRB, 0.53595944E-09_JPRB, 0.53595955E-09_JPRB, 0.53596394E-09_JPRB, &
  & 0.53595828E-09_JPRB, 0.53596599E-09_JPRB, 0.53596050E-09_JPRB, 0.53596189E-09_JPRB, 0.53595811E-09_JPRB, 0.53595184E-09_JPRB, &
  & 0.53595411E-09_JPRB, 0.53594851E-09_JPRB, 0.53594235E-09_JPRB, 0.53594162E-09_JPRB, 0.53594418E-09_JPRB, 0.53594096E-09_JPRB, &
  & 0.53593391E-09_JPRB, 0.53592414E-09_JPRB, 0.53592197E-09_JPRB, 0.53592697E-09_JPRB /)

RGHG6(:,83, 4) = (/ &
  & 0.53585525E-09_JPRB, 0.53586913E-09_JPRB, 0.53588528E-09_JPRB, 0.53588689E-09_JPRB, 0.53589722E-09_JPRB, 0.53591082E-09_JPRB, &
  & 0.53591626E-09_JPRB, 0.53592453E-09_JPRB, 0.53592214E-09_JPRB, 0.53593091E-09_JPRB, 0.53593185E-09_JPRB, 0.53593441E-09_JPRB, &
  & 0.53593641E-09_JPRB, 0.53593746E-09_JPRB, 0.53593413E-09_JPRB, 0.53593391E-09_JPRB, 0.53593235E-09_JPRB, 0.53593602E-09_JPRB, &
  & 0.53593407E-09_JPRB, 0.53593485E-09_JPRB, 0.53594129E-09_JPRB, 0.53595584E-09_JPRB, 0.53595894E-09_JPRB, 0.53596477E-09_JPRB, &
  & 0.53597538E-09_JPRB, 0.53598359E-09_JPRB, 0.53598481E-09_JPRB, 0.53599308E-09_JPRB, 0.53599636E-09_JPRB, 0.53599603E-09_JPRB, &
  & 0.53599136E-09_JPRB, 0.53599192E-09_JPRB, 0.53599503E-09_JPRB, 0.53598770E-09_JPRB, 0.53598120E-09_JPRB, 0.53597671E-09_JPRB, &
  & 0.53596888E-09_JPRB, 0.53596128E-09_JPRB, 0.53595506E-09_JPRB, 0.53595339E-09_JPRB, 0.53595106E-09_JPRB, 0.53595095E-09_JPRB, &
  & 0.53595245E-09_JPRB, 0.53595645E-09_JPRB, 0.53595611E-09_JPRB, 0.53596089E-09_JPRB, 0.53596089E-09_JPRB, 0.53596538E-09_JPRB, &
  & 0.53595944E-09_JPRB, 0.53596760E-09_JPRB, 0.53596194E-09_JPRB, 0.53596344E-09_JPRB, 0.53595978E-09_JPRB, 0.53595334E-09_JPRB, &
  & 0.53595595E-09_JPRB, 0.53595028E-09_JPRB, 0.53594396E-09_JPRB, 0.53594346E-09_JPRB, 0.53594640E-09_JPRB, 0.53594312E-09_JPRB, &
  & 0.53593596E-09_JPRB, 0.53592586E-09_JPRB, 0.53592375E-09_JPRB, 0.53592852E-09_JPRB /)

RGHG6(:,84, 4) = (/ &
  & 0.53585719E-09_JPRB, 0.53587113E-09_JPRB, 0.53588733E-09_JPRB, 0.53588867E-09_JPRB, 0.53589944E-09_JPRB, 0.53591198E-09_JPRB, &
  & 0.53592053E-09_JPRB, 0.53592619E-09_JPRB, 0.53592503E-09_JPRB, 0.53593008E-09_JPRB, 0.53593330E-09_JPRB, 0.53593519E-09_JPRB, &
  & 0.53593763E-09_JPRB, 0.53593852E-09_JPRB, 0.53593552E-09_JPRB, 0.53593519E-09_JPRB, 0.53593369E-09_JPRB, 0.53593757E-09_JPRB, &
  & 0.53593552E-09_JPRB, 0.53593607E-09_JPRB, 0.53594246E-09_JPRB, 0.53595733E-09_JPRB, 0.53595994E-09_JPRB, 0.53596533E-09_JPRB, &
  & 0.53597615E-09_JPRB, 0.53598415E-09_JPRB, 0.53598492E-09_JPRB, 0.53599347E-09_JPRB, 0.53599664E-09_JPRB, 0.53599619E-09_JPRB, &
  & 0.53599142E-09_JPRB, 0.53599214E-09_JPRB, 0.53599541E-09_JPRB, 0.53598820E-09_JPRB, 0.53598170E-09_JPRB, 0.53597721E-09_JPRB, &
  & 0.53596960E-09_JPRB, 0.53596216E-09_JPRB, 0.53595639E-09_JPRB, 0.53595450E-09_JPRB, 0.53595250E-09_JPRB, 0.53595234E-09_JPRB, &
  & 0.53595367E-09_JPRB, 0.53595739E-09_JPRB, 0.53595700E-09_JPRB, 0.53596189E-09_JPRB, 0.53596161E-09_JPRB, 0.53596627E-09_JPRB, &
  & 0.53596017E-09_JPRB, 0.53596866E-09_JPRB, 0.53596283E-09_JPRB, 0.53596450E-09_JPRB, 0.53596078E-09_JPRB, 0.53595417E-09_JPRB, &
  & 0.53595706E-09_JPRB, 0.53595128E-09_JPRB, 0.53594501E-09_JPRB, 0.53594462E-09_JPRB, 0.53594768E-09_JPRB, 0.53594451E-09_JPRB, &
  & 0.53593724E-09_JPRB, 0.53592702E-09_JPRB, 0.53592492E-09_JPRB, 0.53592958E-09_JPRB /)

RGHG6(:,85, 4) = (/ &
  & 0.53585836E-09_JPRB, 0.53587251E-09_JPRB, 0.53588867E-09_JPRB, 0.53588989E-09_JPRB, 0.53590010E-09_JPRB, 0.53591442E-09_JPRB, &
  & 0.53591942E-09_JPRB, 0.53592708E-09_JPRB, 0.53592580E-09_JPRB, 0.53593274E-09_JPRB, 0.53593407E-09_JPRB, 0.53593646E-09_JPRB, &
  & 0.53593813E-09_JPRB, 0.53593890E-09_JPRB, 0.53593652E-09_JPRB, 0.53593591E-09_JPRB, 0.53593474E-09_JPRB, 0.53593852E-09_JPRB, &
  & 0.53593646E-09_JPRB, 0.53593691E-09_JPRB, 0.53594329E-09_JPRB, 0.53595839E-09_JPRB, 0.53596061E-09_JPRB, 0.53596583E-09_JPRB, &
  & 0.53597671E-09_JPRB, 0.53598465E-09_JPRB, 0.53598492E-09_JPRB, 0.53599369E-09_JPRB, 0.53599702E-09_JPRB, 0.53599652E-09_JPRB, &
  & 0.53599158E-09_JPRB, 0.53599242E-09_JPRB, 0.53599580E-09_JPRB, 0.53598842E-09_JPRB, 0.53598204E-09_JPRB, 0.53597760E-09_JPRB, &
  & 0.53596999E-09_JPRB, 0.53596294E-09_JPRB, 0.53595717E-09_JPRB, 0.53595539E-09_JPRB, 0.53595350E-09_JPRB, 0.53595334E-09_JPRB, &
  & 0.53595450E-09_JPRB, 0.53595800E-09_JPRB, 0.53595772E-09_JPRB, 0.53596244E-09_JPRB, 0.53596211E-09_JPRB, 0.53596688E-09_JPRB, &
  & 0.53596066E-09_JPRB, 0.53596955E-09_JPRB, 0.53596350E-09_JPRB, 0.53596516E-09_JPRB, 0.53596161E-09_JPRB, 0.53595489E-09_JPRB, &
  & 0.53595806E-09_JPRB, 0.53595223E-09_JPRB, 0.53594573E-09_JPRB, 0.53594545E-09_JPRB, 0.53594867E-09_JPRB, 0.53594545E-09_JPRB, &
  & 0.53593807E-09_JPRB, 0.53592747E-09_JPRB, 0.53592564E-09_JPRB, 0.53593013E-09_JPRB /)

RGHG6(:,86, 4) = (/ &
  & 0.53585913E-09_JPRB, 0.53587335E-09_JPRB, 0.53588944E-09_JPRB, 0.53589050E-09_JPRB, 0.53590204E-09_JPRB, 0.53591453E-09_JPRB, &
  & 0.53592275E-09_JPRB, 0.53592752E-09_JPRB, 0.53592786E-09_JPRB, 0.53593185E-09_JPRB, 0.53593469E-09_JPRB, 0.53593635E-09_JPRB, &
  & 0.53593818E-09_JPRB, 0.53593885E-09_JPRB, 0.53593713E-09_JPRB, 0.53593646E-09_JPRB, 0.53593552E-09_JPRB, 0.53593885E-09_JPRB, &
  & 0.53593702E-09_JPRB, 0.53593741E-09_JPRB, 0.53594379E-09_JPRB, 0.53595911E-09_JPRB, 0.53596094E-09_JPRB, 0.53596599E-09_JPRB, &
  & 0.53597715E-09_JPRB, 0.53598498E-09_JPRB, 0.53598498E-09_JPRB, 0.53599403E-09_JPRB, 0.53599736E-09_JPRB, 0.53599675E-09_JPRB, &
  & 0.53599164E-09_JPRB, 0.53599253E-09_JPRB, 0.53599591E-09_JPRB, 0.53598886E-09_JPRB, 0.53598237E-09_JPRB, 0.53597798E-09_JPRB, &
  & 0.53597038E-09_JPRB, 0.53596316E-09_JPRB, 0.53595761E-09_JPRB, 0.53595584E-09_JPRB, 0.53595406E-09_JPRB, 0.53595395E-09_JPRB, &
  & 0.53595511E-09_JPRB, 0.53595839E-09_JPRB, 0.53595806E-09_JPRB, 0.53596294E-09_JPRB, 0.53596250E-09_JPRB, 0.53596727E-09_JPRB, &
  & 0.53596094E-09_JPRB, 0.53597016E-09_JPRB, 0.53596400E-09_JPRB, 0.53596572E-09_JPRB, 0.53596211E-09_JPRB, 0.53595528E-09_JPRB, &
  & 0.53595856E-09_JPRB, 0.53595278E-09_JPRB, 0.53594607E-09_JPRB, 0.53594590E-09_JPRB, 0.53594940E-09_JPRB, 0.53594634E-09_JPRB, &
  & 0.53593874E-09_JPRB, 0.53592797E-09_JPRB, 0.53592586E-09_JPRB, 0.53593047E-09_JPRB /)

RGHG6(:,87, 4) = (/ &
  & 0.53585963E-09_JPRB, 0.53587401E-09_JPRB, 0.53588989E-09_JPRB, 0.53589116E-09_JPRB, 0.53590171E-09_JPRB, 0.53591676E-09_JPRB, &
  & 0.53592186E-09_JPRB, 0.53592830E-09_JPRB, 0.53592841E-09_JPRB, 0.53593335E-09_JPRB, 0.53593491E-09_JPRB, 0.53593696E-09_JPRB, &
  & 0.53593813E-09_JPRB, 0.53593868E-09_JPRB, 0.53593741E-09_JPRB, 0.53593674E-09_JPRB, 0.53593602E-09_JPRB, 0.53593907E-09_JPRB, &
  & 0.53593746E-09_JPRB, 0.53593774E-09_JPRB, 0.53594384E-09_JPRB, 0.53595961E-09_JPRB, 0.53596128E-09_JPRB, 0.53596605E-09_JPRB, &
  & 0.53597737E-09_JPRB, 0.53598526E-09_JPRB, 0.53598492E-09_JPRB, 0.53599414E-09_JPRB, 0.53599747E-09_JPRB, 0.53599702E-09_JPRB, &
  & 0.53599164E-09_JPRB, 0.53599258E-09_JPRB, 0.53599619E-09_JPRB, 0.53598909E-09_JPRB, 0.53598265E-09_JPRB, 0.53597859E-09_JPRB, &
  & 0.53597093E-09_JPRB, 0.53596344E-09_JPRB, 0.53595761E-09_JPRB, 0.53595600E-09_JPRB, 0.53595406E-09_JPRB, 0.53595406E-09_JPRB, &
  & 0.53595522E-09_JPRB, 0.53595889E-09_JPRB, 0.53595833E-09_JPRB, 0.53596327E-09_JPRB, 0.53596266E-09_JPRB, 0.53596744E-09_JPRB, &
  & 0.53596116E-09_JPRB, 0.53597049E-09_JPRB, 0.53596411E-09_JPRB, 0.53596605E-09_JPRB, 0.53596244E-09_JPRB, 0.53595561E-09_JPRB, &
  & 0.53595889E-09_JPRB, 0.53595295E-09_JPRB, 0.53594634E-09_JPRB, 0.53594623E-09_JPRB, 0.53594978E-09_JPRB, 0.53594668E-09_JPRB, &
  & 0.53593907E-09_JPRB, 0.53592814E-09_JPRB, 0.53592591E-09_JPRB, 0.53593058E-09_JPRB /)

RGHG6(:,88, 4) = (/ &
  & 0.53586063E-09_JPRB, 0.53587479E-09_JPRB, 0.53588978E-09_JPRB, 0.53589128E-09_JPRB, 0.53590354E-09_JPRB, 0.53591576E-09_JPRB, &
  & 0.53592364E-09_JPRB, 0.53592830E-09_JPRB, 0.53592919E-09_JPRB, 0.53593280E-09_JPRB, 0.53593519E-09_JPRB, 0.53593668E-09_JPRB, &
  & 0.53593818E-09_JPRB, 0.53593874E-09_JPRB, 0.53593768E-09_JPRB, 0.53593707E-09_JPRB, 0.53593641E-09_JPRB, 0.53593929E-09_JPRB, &
  & 0.53593779E-09_JPRB, 0.53593802E-09_JPRB, 0.53594401E-09_JPRB, 0.53596000E-09_JPRB, 0.53596133E-09_JPRB, 0.53596605E-09_JPRB, &
  & 0.53597760E-09_JPRB, 0.53598542E-09_JPRB, 0.53598481E-09_JPRB, 0.53599442E-09_JPRB, 0.53599764E-09_JPRB, 0.53599714E-09_JPRB, &
  & 0.53599170E-09_JPRB, 0.53599269E-09_JPRB, 0.53599647E-09_JPRB, 0.53598936E-09_JPRB, 0.53598287E-09_JPRB, 0.53597915E-09_JPRB, &
  & 0.53597116E-09_JPRB, 0.53596344E-09_JPRB, 0.53595717E-09_JPRB, 0.53595600E-09_JPRB, 0.53595389E-09_JPRB, 0.53595389E-09_JPRB, &
  & 0.53595534E-09_JPRB, 0.53595939E-09_JPRB, 0.53595839E-09_JPRB, 0.53596361E-09_JPRB, 0.53596272E-09_JPRB, 0.53596760E-09_JPRB, &
  & 0.53596133E-09_JPRB, 0.53597093E-09_JPRB, 0.53596433E-09_JPRB, 0.53596644E-09_JPRB, 0.53596272E-09_JPRB, 0.53595578E-09_JPRB, &
  & 0.53595917E-09_JPRB, 0.53595306E-09_JPRB, 0.53594640E-09_JPRB, 0.53594634E-09_JPRB, 0.53595017E-09_JPRB, 0.53594712E-09_JPRB, &
  & 0.53593924E-09_JPRB, 0.53592825E-09_JPRB, 0.53592597E-09_JPRB, 0.53593074E-09_JPRB /)

RGHG6(:,89, 4) = (/ &
  & 0.53586202E-09_JPRB, 0.53587573E-09_JPRB, 0.53588928E-09_JPRB, 0.53589139E-09_JPRB, 0.53590193E-09_JPRB, 0.53591692E-09_JPRB, &
  & 0.53592231E-09_JPRB, 0.53592875E-09_JPRB, 0.53592880E-09_JPRB, 0.53593358E-09_JPRB, 0.53593519E-09_JPRB, 0.53593702E-09_JPRB, &
  & 0.53593818E-09_JPRB, 0.53593874E-09_JPRB, 0.53593763E-09_JPRB, 0.53593707E-09_JPRB, 0.53593630E-09_JPRB, 0.53593957E-09_JPRB, &
  & 0.53593785E-09_JPRB, 0.53593807E-09_JPRB, 0.53594418E-09_JPRB, 0.53596022E-09_JPRB, 0.53596144E-09_JPRB, 0.53596594E-09_JPRB, &
  & 0.53597782E-09_JPRB, 0.53598564E-09_JPRB, 0.53598476E-09_JPRB, 0.53599453E-09_JPRB, 0.53599797E-09_JPRB, 0.53599736E-09_JPRB, &
  & 0.53599164E-09_JPRB, 0.53599264E-09_JPRB, 0.53599669E-09_JPRB, 0.53598953E-09_JPRB, 0.53598298E-09_JPRB, 0.53597971E-09_JPRB, &
  & 0.53597160E-09_JPRB, 0.53596361E-09_JPRB, 0.53595678E-09_JPRB, 0.53595611E-09_JPRB, 0.53595361E-09_JPRB, 0.53595384E-09_JPRB, &
  & 0.53595522E-09_JPRB, 0.53596000E-09_JPRB, 0.53595844E-09_JPRB, 0.53596388E-09_JPRB, 0.53596277E-09_JPRB, 0.53596783E-09_JPRB, &
  & 0.53596128E-09_JPRB, 0.53597121E-09_JPRB, 0.53596438E-09_JPRB, 0.53596677E-09_JPRB, 0.53596289E-09_JPRB, 0.53595595E-09_JPRB, &
  & 0.53595950E-09_JPRB, 0.53595328E-09_JPRB, 0.53594634E-09_JPRB, 0.53594645E-09_JPRB, 0.53595034E-09_JPRB, 0.53594723E-09_JPRB, &
  & 0.53593940E-09_JPRB, 0.53592825E-09_JPRB, 0.53592591E-09_JPRB, 0.53593080E-09_JPRB /)

RGHG6(:,90, 4) = (/ &
  & 0.53586335E-09_JPRB, 0.53587668E-09_JPRB, 0.53588856E-09_JPRB, 0.53589078E-09_JPRB, 0.53590210E-09_JPRB, 0.53591565E-09_JPRB, &
  & 0.53592275E-09_JPRB, 0.53592902E-09_JPRB, 0.53592808E-09_JPRB, 0.53593352E-09_JPRB, 0.53593585E-09_JPRB, 0.53593729E-09_JPRB, &
  & 0.53593896E-09_JPRB, 0.53593951E-09_JPRB, 0.53593768E-09_JPRB, 0.53593702E-09_JPRB, 0.53593602E-09_JPRB, 0.53594007E-09_JPRB, &
  & 0.53593779E-09_JPRB, 0.53593796E-09_JPRB, 0.53594390E-09_JPRB, 0.53596072E-09_JPRB, 0.53596128E-09_JPRB, 0.53596572E-09_JPRB, &
  & 0.53597798E-09_JPRB, 0.53598603E-09_JPRB, 0.53598453E-09_JPRB, 0.53599475E-09_JPRB, 0.53599813E-09_JPRB, 0.53599758E-09_JPRB, &
  & 0.53599142E-09_JPRB, 0.53599258E-09_JPRB, 0.53599736E-09_JPRB, 0.53598964E-09_JPRB, 0.53598292E-09_JPRB, 0.53598004E-09_JPRB, &
  & 0.53597166E-09_JPRB, 0.53596355E-09_JPRB, 0.53595628E-09_JPRB, 0.53595622E-09_JPRB, 0.53595339E-09_JPRB, 0.53595367E-09_JPRB, &
  & 0.53595511E-09_JPRB, 0.53596044E-09_JPRB, 0.53595833E-09_JPRB, 0.53596416E-09_JPRB, 0.53596261E-09_JPRB, 0.53596810E-09_JPRB, &
  & 0.53596094E-09_JPRB, 0.53597177E-09_JPRB, 0.53596416E-09_JPRB, 0.53596705E-09_JPRB, 0.53596300E-09_JPRB, 0.53595572E-09_JPRB, &
  & 0.53595972E-09_JPRB, 0.53595328E-09_JPRB, 0.53594623E-09_JPRB, 0.53594651E-09_JPRB, 0.53595067E-09_JPRB, 0.53594745E-09_JPRB, &
  & 0.53593951E-09_JPRB, 0.53592808E-09_JPRB, 0.53592575E-09_JPRB, 0.53593097E-09_JPRB /)

RGHG6(:,91, 4) = (/ &
  & 0.53586380E-09_JPRB, 0.53587751E-09_JPRB, 0.53588750E-09_JPRB, 0.53588961E-09_JPRB, 0.53590088E-09_JPRB, 0.53591598E-09_JPRB, &
  & 0.53592036E-09_JPRB, 0.53593296E-09_JPRB, 0.53591931E-09_JPRB, 0.53593724E-09_JPRB, 0.53593652E-09_JPRB, 0.53593724E-09_JPRB, &
  & 0.53594063E-09_JPRB, 0.53594157E-09_JPRB, 0.53593679E-09_JPRB, 0.53593696E-09_JPRB, 0.53593502E-09_JPRB, 0.53594118E-09_JPRB, &
  & 0.53593746E-09_JPRB, 0.53593746E-09_JPRB, 0.53594318E-09_JPRB, 0.53596183E-09_JPRB, 0.53596105E-09_JPRB, 0.53596527E-09_JPRB, &
  & 0.53597832E-09_JPRB, 0.53598670E-09_JPRB, 0.53598365E-09_JPRB, 0.53599525E-09_JPRB, 0.53599847E-09_JPRB, 0.53599813E-09_JPRB, &
  & 0.53599081E-09_JPRB, 0.53599231E-09_JPRB, 0.53599858E-09_JPRB, 0.53598959E-09_JPRB, 0.53598259E-09_JPRB, 0.53598054E-09_JPRB, &
  & 0.53597166E-09_JPRB, 0.53596350E-09_JPRB, 0.53595572E-09_JPRB, 0.53595656E-09_JPRB, 0.53595312E-09_JPRB, 0.53595361E-09_JPRB, &
  & 0.53595489E-09_JPRB, 0.53596111E-09_JPRB, 0.53595783E-09_JPRB, 0.53596466E-09_JPRB, 0.53596216E-09_JPRB, 0.53596899E-09_JPRB, &
  & 0.53595978E-09_JPRB, 0.53597304E-09_JPRB, 0.53596344E-09_JPRB, 0.53596744E-09_JPRB, 0.53596316E-09_JPRB, 0.53595495E-09_JPRB, &
  & 0.53596061E-09_JPRB, 0.53595334E-09_JPRB, 0.53594573E-09_JPRB, 0.53594629E-09_JPRB, 0.53595117E-09_JPRB, 0.53594773E-09_JPRB, &
  & 0.53593951E-09_JPRB, 0.53592725E-09_JPRB, 0.53592553E-09_JPRB, 0.53593108E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART8',1,ZHOOK_HANDLE)
END SUBROUTINE PART8






SUBROUTINE PART9
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART9',0,ZHOOK_HANDLE)



!-- Month=  5 ------------

RGHG6(:, 1, 5) = (/ &
  & 0.64809230E-37_JPRB, 0.57485711E-36_JPRB, 0.10281249E-35_JPRB, 0.14982263E-35_JPRB, 0.18985159E-35_JPRB, 0.24710807E-35_JPRB, &
  & 0.33041360E-35_JPRB, 0.45953668E-35_JPRB, 0.66368021E-35_JPRB, 0.98714412E-35_JPRB, 0.14997298E-34_JPRB, 0.23076896E-34_JPRB, &
  & 0.35546108E-34_JPRB, 0.54474865E-34_JPRB, 0.82236747E-34_JPRB, 0.12152472E-33_JPRB, 0.17592919E-33_JPRB, 0.24932286E-33_JPRB, &
  & 0.34680582E-33_JPRB, 0.47667187E-33_JPRB, 0.65327731E-33_JPRB, 0.89891743E-33_JPRB, 0.12550727E-32_JPRB, 0.17923587E-32_JPRB, &
  & 0.26229349E-32_JPRB, 0.39240948E-32_JPRB, 0.58190034E-32_JPRB, 0.83917836E-32_JPRB, 0.11164180E-31_JPRB, 0.13764082E-31_JPRB, &
  & 0.16096435E-31_JPRB, 0.17113778E-31_JPRB, 0.18238456E-31_JPRB, 0.19581764E-31_JPRB, 0.20192329E-31_JPRB, 0.19695568E-31_JPRB, &
  & 0.17110734E-31_JPRB, 0.12857735E-31_JPRB, 0.87881699E-32_JPRB, 0.60109102E-32_JPRB, 0.43323862E-32_JPRB, 0.31683290E-32_JPRB, &
  & 0.22303554E-32_JPRB, 0.14439767E-32_JPRB, 0.86726541E-33_JPRB, 0.49158586E-33_JPRB, 0.27500132E-33_JPRB, 0.16379078E-33_JPRB, &
  & 0.10190216E-33_JPRB, 0.61538553E-34_JPRB, 0.34289136E-34_JPRB, 0.18044239E-34_JPRB, 0.95604884E-35_JPRB, 0.53070341E-35_JPRB, &
  & 0.31282065E-35_JPRB, 0.19042808E-35_JPRB, 0.11869264E-35_JPRB, 0.78490139E-36_JPRB, 0.56442253E-36_JPRB, 0.44442349E-36_JPRB, &
  & 0.36997042E-36_JPRB, 0.27543947E-36_JPRB, 0.11085060E-36_JPRB, 0.60336717E-38_JPRB /)

RGHG6(:, 2, 5) = (/ &
  & 0.52278490E-35_JPRB, 0.22094764E-34_JPRB, 0.42263255E-34_JPRB, 0.60661179E-34_JPRB, 0.78157615E-34_JPRB, 0.10133005E-33_JPRB, &
  & 0.13555195E-33_JPRB, 0.18916115E-33_JPRB, 0.27410887E-33_JPRB, 0.40823909E-33_JPRB, 0.62054590E-33_JPRB, 0.95396381E-33_JPRB, &
  & 0.14672726E-32_JPRB, 0.22427510E-32_JPRB, 0.33745052E-32_JPRB, 0.49683136E-32_JPRB, 0.71614951E-32_JPRB, 0.10108110E-31_JPRB, &
  & 0.14022108E-31_JPRB, 0.19260291E-31_JPRB, 0.26438443E-31_JPRB, 0.36540357E-31_JPRB, 0.51328901E-31_JPRB, 0.73895037E-31_JPRB, &
  & 0.10841540E-30_JPRB, 0.16049760E-30_JPRB, 0.23390252E-30_JPRB, 0.33179259E-30_JPRB, 0.43880471E-30_JPRB, 0.54202317E-30_JPRB, &
  & 0.63386713E-30_JPRB, 0.68282943E-30_JPRB, 0.73034945E-30_JPRB, 0.78069508E-30_JPRB, 0.80138086E-30_JPRB, 0.77505938E-30_JPRB, &
  & 0.67235310E-30_JPRB, 0.50914930E-30_JPRB, 0.35546408E-30_JPRB, 0.24543041E-30_JPRB, 0.17484592E-30_JPRB, 0.12668702E-30_JPRB, &
  & 0.88764270E-31_JPRB, 0.57559744E-31_JPRB, 0.34780304E-31_JPRB, 0.19926536E-31_JPRB, 0.11257031E-31_JPRB, 0.66942860E-32_JPRB, &
  & 0.41534943E-32_JPRB, 0.25076582E-32_JPRB, 0.14058301E-32_JPRB, 0.74816120E-33_JPRB, 0.39710904E-33_JPRB, 0.21985696E-33_JPRB, &
  & 0.12845908E-33_JPRB, 0.78386492E-34_JPRB, 0.49281390E-34_JPRB, 0.32929988E-34_JPRB, 0.23737442E-34_JPRB, 0.18505234E-34_JPRB, &
  & 0.15057859E-34_JPRB, 0.11272121E-34_JPRB, 0.57009295E-35_JPRB, 0.10365534E-35_JPRB /)

RGHG6(:, 3, 5) = (/ &
  & 0.21517840E-33_JPRB, 0.10411693E-32_JPRB, 0.20807449E-32_JPRB, 0.29323908E-32_JPRB, 0.37807855E-32_JPRB, 0.48733461E-32_JPRB, &
  & 0.65037840E-32_JPRB, 0.90641378E-32_JPRB, 0.13112625E-31_JPRB, 0.19545762E-31_JPRB, 0.29719586E-31_JPRB, 0.45747102E-31_JPRB, &
  & 0.70406463E-31_JPRB, 0.10757376E-30_JPRB, 0.16152804E-30_JPRB, 0.23697637E-30_JPRB, 0.34021971E-30_JPRB, 0.47852955E-30_JPRB, &
  & 0.66246249E-30_JPRB, 0.91008268E-30_JPRB, 0.12528099E-29_JPRB, 0.17398588E-29_JPRB, 0.24630208E-29_JPRB, 0.35593657E-29_JPRB, &
  & 0.52431776E-29_JPRB, 0.76901284E-29_JPRB, 0.11122890E-28_JPRB, 0.15647043E-28_JPRB, 0.20647213E-28_JPRB, 0.25546073E-28_JPRB, &
  & 0.29923318E-28_JPRB, 0.32419817E-28_JPRB, 0.34743520E-28_JPRB, 0.37110368E-28_JPRB, 0.38018576E-28_JPRB, 0.36660013E-28_JPRB, &
  & 0.31765398E-28_JPRB, 0.24282189E-28_JPRB, 0.17080900E-28_JPRB, 0.11862036E-28_JPRB, 0.83941130E-29_JPRB, 0.60372081E-29_JPRB, &
  & 0.41947920E-29_JPRB, 0.26784391E-29_JPRB, 0.15965107E-29_JPRB, 0.90952032E-30_JPRB, 0.51918966E-30_JPRB, 0.31454094E-30_JPRB, &
  & 0.19896124E-30_JPRB, 0.12116323E-30_JPRB, 0.68720799E-31_JPRB, 0.36822707E-31_JPRB, 0.19678892E-31_JPRB, 0.10871958E-31_JPRB, &
  & 0.63765022E-32_JPRB, 0.38820569E-32_JPRB, 0.24602006E-32_JPRB, 0.16491519E-32_JPRB, 0.11923132E-32_JPRB, 0.93032048E-33_JPRB, &
  & 0.76033707E-33_JPRB, 0.59102185E-33_JPRB, 0.34134280E-33_JPRB, 0.79078478E-34_JPRB /)

RGHG6(:, 4, 5) = (/ &
  & 0.22381980E-31_JPRB, 0.11536705E-30_JPRB, 0.20889837E-30_JPRB, 0.28544003E-30_JPRB, 0.36180545E-30_JPRB, 0.46532795E-30_JPRB, &
  & 0.61807145E-30_JPRB, 0.85684755E-30_JPRB, 0.12364359E-29_JPRB, 0.18350321E-29_JPRB, 0.27860506E-29_JPRB, 0.42824820E-29_JPRB, &
  & 0.65793732E-29_JPRB, 0.10025370E-28_JPRB, 0.14986085E-28_JPRB, 0.21848365E-28_JPRB, 0.31150078E-28_JPRB, 0.43511145E-28_JPRB, &
  & 0.59858974E-28_JPRB, 0.81809899E-28_JPRB, 0.11218939E-27_JPRB, 0.15537386E-27_JPRB, 0.21915812E-27_JPRB, 0.31625647E-27_JPRB, &
  & 0.46210036E-27_JPRB, 0.67521457E-27_JPRB, 0.97103154E-27_JPRB, 0.13650223E-26_JPRB, 0.18027384E-26_JPRB, 0.22322834E-26_JPRB, &
  & 0.26176978E-26_JPRB, 0.28363966E-26_JPRB, 0.30433805E-26_JPRB, 0.32547180E-26_JPRB, 0.33402512E-26_JPRB, 0.32253354E-26_JPRB, &
  & 0.28037836E-26_JPRB, 0.21504310E-26_JPRB, 0.15301516E-26_JPRB, 0.10674943E-26_JPRB, 0.75658607E-27_JPRB, 0.54486523E-27_JPRB, &
  & 0.37737160E-27_JPRB, 0.23857127E-27_JPRB, 0.14079599E-27_JPRB, 0.80195879E-28_JPRB, 0.46349102E-28_JPRB, 0.28741128E-28_JPRB, &
  & 0.18481136E-28_JPRB, 0.11418055E-28_JPRB, 0.65234497E-29_JPRB, 0.35283860E-29_JPRB, 0.18960906E-29_JPRB, 0.10567388E-29_JPRB, &
  & 0.62057394E-30_JPRB, 0.38086301E-30_JPRB, 0.24148684E-30_JPRB, 0.16227589E-30_JPRB, 0.11749892E-30_JPRB, 0.92185029E-31_JPRB, &
  & 0.76925796E-31_JPRB, 0.63097187E-31_JPRB, 0.42930876E-31_JPRB, 0.13614608E-31_JPRB /)

RGHG6(:, 5, 5) = (/ &
  & 0.11926740E-28_JPRB, 0.33707939E-28_JPRB, 0.52013494E-28_JPRB, 0.66861812E-28_JPRB, 0.84190029E-28_JPRB, 0.10766184E-27_JPRB, &
  & 0.14214964E-27_JPRB, 0.19561179E-27_JPRB, 0.27918153E-27_JPRB, 0.41074168E-27_JPRB, 0.61705375E-27_JPRB, 0.93873340E-27_JPRB, &
  & 0.14252542E-26_JPRB, 0.21426527E-26_JPRB, 0.31531444E-26_JPRB, 0.45176277E-26_JPRB, 0.63211120E-26_JPRB, 0.86587877E-26_JPRB, &
  & 0.11676929E-25_JPRB, 0.15642311E-25_JPRB, 0.21025855E-25_JPRB, 0.28539250E-25_JPRB, 0.39479841E-25_JPRB, 0.55822374E-25_JPRB, &
  & 0.80327487E-25_JPRB, 0.11563964E-24_JPRB, 0.16507775E-24_JPRB, 0.23132419E-24_JPRB, 0.30483281E-24_JPRB, 0.37650810E-24_JPRB, &
  & 0.44039013E-24_JPRB, 0.47605739E-24_JPRB, 0.51111570E-24_JPRB, 0.54907860E-24_JPRB, 0.56752138E-24_JPRB, 0.55304203E-24_JPRB, &
  & 0.48512510E-24_JPRB, 0.37680841E-24_JPRB, 0.27161373E-24_JPRB, 0.19279279E-24_JPRB, 0.13889635E-24_JPRB, 0.10163635E-24_JPRB, &
  & 0.71562306E-25_JPRB, 0.45759350E-25_JPRB, 0.27357502E-25_JPRB, 0.15862890E-25_JPRB, 0.93863994E-26_JPRB, 0.59689723E-26_JPRB, &
  & 0.39320822E-26_JPRB, 0.24725809E-26_JPRB, 0.14378715E-26_JPRB, 0.78900525E-27_JPRB, 0.43067434E-27_JPRB, 0.24310229E-27_JPRB, &
  & 0.14483877E-27_JPRB, 0.89600707E-28_JPRB, 0.57226077E-28_JPRB, 0.38538225E-28_JPRB, 0.27930167E-28_JPRB, 0.21986994E-28_JPRB, &
  & 0.18613239E-28_JPRB, 0.16276533E-28_JPRB, 0.13284976E-28_JPRB, 0.91372203E-29_JPRB /)

RGHG6(:, 6, 5) = (/ &
  & 0.10088164E-25_JPRB, 0.20706610E-25_JPRB, 0.28339677E-25_JPRB, 0.35778685E-25_JPRB, 0.44629239E-25_JPRB, 0.56573209E-25_JPRB, &
  & 0.73585253E-25_JPRB, 0.99371551E-25_JPRB, 0.13873990E-24_JPRB, 0.19878867E-24_JPRB, 0.29028844E-24_JPRB, 0.42778650E-24_JPRB, &
  & 0.62704473E-24_JPRB, 0.90713551E-24_JPRB, 0.12815056E-23_JPRB, 0.17581252E-23_JPRB, 0.23526593E-23_JPRB, 0.30788011E-23_JPRB, &
  & 0.39654302E-23_JPRB, 0.50751879E-23_JPRB, 0.65251703E-23_JPRB, 0.84863163E-23_JPRB, 0.11278115E-22_JPRB, 0.15382420E-22_JPRB, &
  & 0.21437566E-22_JPRB, 0.30112547E-22_JPRB, 0.42151426E-22_JPRB, 0.58326735E-22_JPRB, 0.76036409E-22_JPRB, 0.93059138E-22_JPRB, &
  & 0.10817132E-21_JPRB, 0.11648923E-21_JPRB, 0.12533744E-21_JPRB, 0.13570844E-21_JPRB, 0.14216076E-21_JPRB, 0.14104766E-21_JPRB, &
  & 0.12632299E-21_JPRB, 0.10024950E-21_JPRB, 0.74200598E-22_JPRB, 0.54328371E-22_JPRB, 0.40570321E-22_JPRB, 0.30917333E-22_JPRB, &
  & 0.22692816E-22_JPRB, 0.15145498E-22_JPRB, 0.94805887E-23_JPRB, 0.57639061E-23_JPRB, 0.35851646E-23_JPRB, 0.23965072E-23_JPRB, &
  & 0.16542548E-23_JPRB, 0.10881106E-23_JPRB, 0.65908609E-24_JPRB, 0.37610613E-24_JPRB, 0.21299378E-24_JPRB, 0.12447748E-24_JPRB, &
  & 0.76425140E-25_JPRB, 0.48564139E-25_JPRB, 0.31634321E-25_JPRB, 0.21581157E-25_JPRB, 0.15696175E-25_JPRB, 0.12328025E-25_JPRB, &
  & 0.10354411E-25_JPRB, 0.90021409E-26_JPRB, 0.76386619E-26_JPRB, 0.52201515E-26_JPRB /)

RGHG6(:, 7, 5) = (/ &
  & 0.78438806E-23_JPRB, 0.15121727E-22_JPRB, 0.20372256E-22_JPRB, 0.25491764E-22_JPRB, 0.31487784E-22_JPRB, 0.39230545E-22_JPRB, &
  & 0.50031266E-22_JPRB, 0.65693723E-22_JPRB, 0.88664779E-22_JPRB, 0.12222915E-21_JPRB, 0.17085589E-21_JPRB, 0.23992784E-21_JPRB, &
  & 0.33362248E-21_JPRB, 0.45640074E-21_JPRB, 0.60790475E-21_JPRB, 0.78539345E-21_JPRB, 0.98842782E-21_JPRB, 0.12165997E-20_JPRB, &
  & 0.14744847E-20_JPRB, 0.17785304E-20_JPRB, 0.21607670E-20_JPRB, 0.26651872E-20_JPRB, 0.33737296E-20_JPRB, 0.44091110E-20_JPRB, &
  & 0.59223280E-20_JPRB, 0.80606020E-20_JPRB, 0.10998552E-19_JPRB, 0.14918971E-19_JPRB, 0.19129015E-19_JPRB, 0.23118299E-19_JPRB, &
  & 0.26671048E-19_JPRB, 0.28640663E-19_JPRB, 0.30921814E-19_JPRB, 0.33807224E-19_JPRB, 0.35985009E-19_JPRB, 0.36495493E-19_JPRB, &
  & 0.33534406E-19_JPRB, 0.27355535E-19_JPRB, 0.20885230E-19_JPRB, 0.15885794E-19_JPRB, 0.12426662E-19_JPRB, 0.99734507E-20_JPRB, &
  & 0.77382213E-20_JPRB, 0.54782318E-20_JPRB, 0.36495168E-20_JPRB, 0.23728995E-20_JPRB, 0.15811985E-20_JPRB, 0.11334170E-20_JPRB, &
  & 0.83781239E-21_JPRB, 0.58830747E-21_JPRB, 0.37957866E-21_JPRB, 0.23001341E-21_JPRB, 0.13796453E-21_JPRB, 0.85094842E-22_JPRB, &
  & 0.54899954E-22_JPRB, 0.36455339E-22_JPRB, 0.24659860E-22_JPRB, 0.17281394E-22_JPRB, 0.12772288E-22_JPRB, 0.10034259E-22_JPRB, &
  & 0.83635980E-23_JPRB, 0.72317475E-23_JPRB, 0.62234365E-23_JPRB, 0.50791338E-23_JPRB /)

RGHG6(:, 8, 5) = (/ &
  & 0.50504756E-20_JPRB, 0.96584581E-20_JPRB, 0.12948651E-19_JPRB, 0.16095230E-19_JPRB, 0.19654217E-19_JPRB, 0.24176316E-19_JPRB, &
  & 0.30168647E-19_JPRB, 0.38635348E-19_JPRB, 0.50459323E-19_JPRB, 0.66969408E-19_JPRB, 0.89672705E-19_JPRB, 0.12002091E-18_JPRB, &
  & 0.15833630E-18_JPRB, 0.20471337E-18_JPRB, 0.25719253E-18_JPRB, 0.31267802E-18_JPRB, 0.37020148E-18_JPRB, 0.42851151E-18_JPRB, &
  & 0.48877777E-18_JPRB, 0.55561825E-18_JPRB, 0.63790597E-18_JPRB, 0.74595427E-18_JPRB, 0.89987376E-18_JPRB, 0.11260430E-17_JPRB, &
  & 0.14574596E-17_JPRB, 0.19193425E-17_JPRB, 0.25453812E-17_JPRB, 0.33739272E-17_JPRB, 0.42453262E-17_JPRB, 0.50631303E-17_JPRB, &
  & 0.57974235E-17_JPRB, 0.62158942E-17_JPRB, 0.67390917E-17_JPRB, 0.74438091E-17_JPRB, 0.80532311E-17_JPRB, 0.83514752E-17_JPRB, &
  & 0.78826540E-17_JPRB, 0.66195381E-17_JPRB, 0.52228986E-17_JPRB, 0.41367848E-17_JPRB, 0.33952517E-17_JPRB, 0.28780829E-17_JPRB, &
  & 0.23657428E-17_JPRB, 0.17792829E-17_JPRB, 0.12658620E-17_JPRB, 0.88191826E-18_JPRB, 0.63220525E-18_JPRB, 0.48829025E-18_JPRB, &
  & 0.38824694E-18_JPRB, 0.29254194E-18_JPRB, 0.20191122E-18_JPRB, 0.13054815E-18_JPRB, 0.83317024E-19_JPRB, 0.54481986E-19_JPRB, &
  & 0.37104828E-19_JPRB, 0.25874959E-19_JPRB, 0.18276362E-19_JPRB, 0.13275091E-19_JPRB, 0.10049207E-19_JPRB, 0.80076051E-20_JPRB, &
  & 0.67124539E-20_JPRB, 0.58236730E-20_JPRB, 0.51265504E-20_JPRB, 0.44447359E-20_JPRB /)

RGHG6(:, 9, 5) = (/ &
  & 0.26363474E-17_JPRB, 0.50257836E-17_JPRB, 0.67036719E-17_JPRB, 0.82878824E-17_JPRB, 0.10044657E-16_JPRB, 0.12188309E-16_JPRB, &
  & 0.14991153E-16_JPRB, 0.18767534E-16_JPRB, 0.23855125E-16_JPRB, 0.30643121E-16_JPRB, 0.39512724E-16_JPRB, 0.50672611E-16_JPRB, &
  & 0.63730170E-16_JPRB, 0.78264441E-16_JPRB, 0.93086651E-16_JPRB, 0.10697528E-15_JPRB, 0.11956448E-15_JPRB, 0.13065981E-15_JPRB, &
  & 0.14072748E-15_JPRB, 0.15123237E-15_JPRB, 0.16447503E-15_JPRB, 0.18273731E-15_JPRB, 0.21016395E-15_JPRB, 0.25217240E-15_JPRB, &
  & 0.31402555E-15_JPRB, 0.39978012E-15_JPRB, 0.51441020E-15_JPRB, 0.66498863E-15_JPRB, 0.82041218E-15_JPRB, 0.96526371E-15_JPRB, &
  & 0.10972725E-14_JPRB, 0.11749341E-14_JPRB, 0.12796110E-14_JPRB, 0.14281205E-14_JPRB, 0.15700219E-14_JPRB, 0.16639888E-14_JPRB, &
  & 0.16131110E-14_JPRB, 0.13964925E-14_JPRB, 0.11414667E-14_JPRB, 0.94299702E-15_JPRB, 0.81340029E-15_JPRB, 0.72845940E-15_JPRB, &
  & 0.63478142E-15_JPRB, 0.50747528E-15_JPRB, 0.38524895E-15_JPRB, 0.28762184E-15_JPRB, 0.22174429E-15_JPRB, 0.18454540E-15_JPRB, &
  & 0.15794300E-15_JPRB, 0.12769791E-15_JPRB, 0.94315114E-16_JPRB, 0.65061878E-16_JPRB, 0.44186152E-16_JPRB, 0.30632391E-16_JPRB, &
  & 0.22012469E-16_JPRB, 0.16112034E-16_JPRB, 0.11882615E-16_JPRB, 0.89575289E-17_JPRB, 0.69843326E-17_JPRB, 0.56829376E-17_JPRB, &
  & 0.48305536E-17_JPRB, 0.42457014E-17_JPRB, 0.37879574E-17_JPRB, 0.33742196E-17_JPRB /)

RGHG6(:,10, 5) = (/ &
  & 0.11117583E-14_JPRB, 0.21025475E-14_JPRB, 0.27998848E-14_JPRB, 0.34422830E-14_JPRB, 0.41451844E-14_JPRB, 0.49884625E-14_JPRB, &
  & 0.60488236E-14_JPRB, 0.74516622E-14_JPRB, 0.92563871E-14_JPRB, 0.11569491E-13_JPRB, 0.14444336E-13_JPRB, 0.17842981E-13_JPRB, &
  & 0.21507918E-13_JPRB, 0.25202340E-13_JPRB, 0.28516774E-13_JPRB, 0.31095396E-13_JPRB, 0.32945651E-13_JPRB, 0.34106246E-13_JPRB, &
  & 0.34805106E-13_JPRB, 0.35458239E-13_JPRB, 0.36622730E-13_JPRB, 0.38716402E-13_JPRB, 0.42526898E-13_JPRB, 0.48867750E-13_JPRB, &
  & 0.58567131E-13_JPRB, 0.71938732E-13_JPRB, 0.89755297E-13_JPRB, 0.11303984E-12_JPRB, 0.13672516E-12_JPRB, 0.15869811E-12_JPRB, &
  & 0.17901651E-12_JPRB, 0.19141511E-12_JPRB, 0.20934383E-12_JPRB, 0.23600089E-12_JPRB, 0.26357218E-12_JPRB, 0.28533014E-12_JPRB, &
  & 0.28403002E-12_JPRB, 0.25375649E-12_JPRB, 0.21529040E-12_JPRB, 0.18588330E-12_JPRB, 0.16862805E-12_JPRB, 0.15965246E-12_JPRB, &
  & 0.14754163E-12_JPRB, 0.12544985E-12_JPRB, 0.10165608E-12_JPRB, 0.81319811E-13_JPRB, 0.67395762E-13_JPRB, 0.60429058E-13_JPRB, &
  & 0.55638667E-13_JPRB, 0.48275775E-13_JPRB, 0.38149236E-13_JPRB, 0.28082266E-13_JPRB, 0.20289873E-13_JPRB, 0.14904373E-13_JPRB, &
  & 0.11289718E-13_JPRB, 0.86590230E-14_JPRB, 0.66559811E-14_JPRB, 0.51999492E-14_JPRB, 0.41771658E-14_JPRB, 0.34785134E-14_JPRB, &
  & 0.30085613E-14_JPRB, 0.26773098E-14_JPRB, 0.24172783E-14_JPRB, 0.21780703E-14_JPRB /)

RGHG6(:,11, 5) = (/ &
  & 0.17223629E-13_JPRB, 0.28456211E-13_JPRB, 0.35575553E-13_JPRB, 0.42421263E-13_JPRB, 0.49685204E-13_JPRB, 0.58526528E-13_JPRB, &
  & 0.69919473E-13_JPRB, 0.84780876E-13_JPRB, 0.10425566E-12_JPRB, 0.12909087E-12_JPRB, 0.15969553E-12_JPRB, 0.19613731E-12_JPRB, &
  & 0.23702484E-12_JPRB, 0.27778111E-12_JPRB, 0.31357742E-12_JPRB, 0.34146725E-12_JPRB, 0.35772294E-12_JPRB, 0.36266563E-12_JPRB, &
  & 0.35677564E-12_JPRB, 0.34422091E-12_JPRB, 0.32944429E-12_JPRB, 0.31513496E-12_JPRB, 0.30437068E-12_JPRB, 0.30053439E-12_JPRB, &
  & 0.30502868E-12_JPRB, 0.31788260E-12_JPRB, 0.33758039E-12_JPRB, 0.36124879E-12_JPRB, 0.40350508E-12_JPRB, 0.47287082E-12_JPRB, &
  & 0.56206033E-12_JPRB, 0.67628395E-12_JPRB, 0.78767017E-12_JPRB, 0.84804787E-12_JPRB, 0.89626754E-12_JPRB, 0.91197557E-12_JPRB, &
  & 0.90307070E-12_JPRB, 0.89501789E-12_JPRB, 0.87824903E-12_JPRB, 0.83245460E-12_JPRB, 0.75727136E-12_JPRB, 0.66054117E-12_JPRB, &
  & 0.55888448E-12_JPRB, 0.47690855E-12_JPRB, 0.42076114E-12_JPRB, 0.37499555E-12_JPRB, 0.33350173E-12_JPRB, 0.28856336E-12_JPRB, &
  & 0.23913651E-12_JPRB, 0.18965095E-12_JPRB, 0.14669598E-12_JPRB, 0.11268848E-12_JPRB, 0.87145033E-13_JPRB, 0.68282822E-13_JPRB, &
  & 0.54806101E-13_JPRB, 0.45200700E-13_JPRB, 0.38136842E-13_JPRB, 0.32993661E-13_JPRB, 0.29158032E-13_JPRB, 0.26264052E-13_JPRB, &
  & 0.24057291E-13_JPRB, 0.22429190E-13_JPRB, 0.21447628E-13_JPRB, 0.21369339E-13_JPRB /)

RGHG6(:,12, 5) = (/ &
  & 0.13675508E-12_JPRB, 0.19471832E-12_JPRB, 0.23187626E-12_JPRB, 0.26513690E-12_JPRB, 0.30275831E-12_JPRB, 0.34801670E-12_JPRB, &
  & 0.40715421E-12_JPRB, 0.48573515E-12_JPRB, 0.58819177E-12_JPRB, 0.71903345E-12_JPRB, 0.87785649E-12_JPRB, 0.10639202E-11_JPRB, &
  & 0.12705105E-11_JPRB, 0.14797479E-11_JPRB, 0.16734378E-11_JPRB, 0.18382696E-11_JPRB, 0.19479414E-11_JPRB, 0.19930134E-11_JPRB, &
  & 0.19507252E-11_JPRB, 0.18370268E-11_JPRB, 0.16783900E-11_JPRB, 0.15088945E-11_JPRB, 0.13517510E-11_JPRB, 0.12171942E-11_JPRB, &
  & 0.11078046E-11_JPRB, 0.10370770E-11_JPRB, 0.10212731E-11_JPRB, 0.10659321E-11_JPRB, 0.11629525E-11_JPRB, 0.13244176E-11_JPRB, &
  & 0.15761501E-11_JPRB, 0.18880774E-11_JPRB, 0.22261771E-11_JPRB, 0.26325394E-11_JPRB, 0.29220281E-11_JPRB, 0.30906165E-11_JPRB, &
  & 0.31654206E-11_JPRB, 0.30911144E-11_JPRB, 0.29089376E-11_JPRB, 0.26633290E-11_JPRB, 0.23909225E-11_JPRB, 0.21242730E-11_JPRB, &
  & 0.18901731E-11_JPRB, 0.16928383E-11_JPRB, 0.15060637E-11_JPRB, 0.13188091E-11_JPRB, 0.11362782E-11_JPRB, 0.96377940E-12_JPRB, &
  & 0.81141143E-12_JPRB, 0.67658753E-12_JPRB, 0.56206255E-12_JPRB, 0.46578935E-12_JPRB, 0.38604948E-12_JPRB, 0.32137474E-12_JPRB, &
  & 0.27104691E-12_JPRB, 0.23312182E-12_JPRB, 0.20492565E-12_JPRB, 0.18485205E-12_JPRB, 0.17034281E-12_JPRB, 0.15994411E-12_JPRB, &
  & 0.15310465E-12_JPRB, 0.15001189E-12_JPRB, 0.15170692E-12_JPRB, 0.16234400E-12_JPRB /)

RGHG6(:,13, 5) = (/ &
  & 0.65549752E-12_JPRB, 0.82658224E-12_JPRB, 0.92757366E-12_JPRB, 0.10254098E-11_JPRB, 0.11333564E-11_JPRB, 0.12703728E-11_JPRB, &
  & 0.14503007E-11_JPRB, 0.16897933E-11_JPRB, 0.20031526E-11_JPRB, 0.24004099E-11_JPRB, 0.28845609E-11_JPRB, 0.34475370E-11_JPRB, &
  & 0.40685094E-11_JPRB, 0.47015989E-11_JPRB, 0.52891645E-11_JPRB, 0.57861636E-11_JPRB, 0.61334470E-11_JPRB, 0.62718064E-11_JPRB, &
  & 0.61826781E-11_JPRB, 0.58851734E-11_JPRB, 0.54452892E-11_JPRB, 0.49386046E-11_JPRB, 0.44453438E-11_JPRB, 0.39896047E-11_JPRB, &
  & 0.36025755E-11_JPRB, 0.33210906E-11_JPRB, 0.31512536E-11_JPRB, 0.31024077E-11_JPRB, 0.32146740E-11_JPRB, 0.34935806E-11_JPRB, &
  & 0.39300507E-11_JPRB, 0.45673222E-11_JPRB, 0.54277507E-11_JPRB, 0.61731189E-11_JPRB, 0.69541820E-11_JPRB, 0.76105901E-11_JPRB, &
  & 0.79348221E-11_JPRB, 0.80059995E-11_JPRB, 0.78413422E-11_JPRB, 0.74463699E-11_JPRB, 0.68951047E-11_JPRB, 0.62757707E-11_JPRB, &
  & 0.56467860E-11_JPRB, 0.50306985E-11_JPRB, 0.44595950E-11_JPRB, 0.39388744E-11_JPRB, 0.34667143E-11_JPRB, 0.30460877E-11_JPRB, &
  & 0.26757476E-11_JPRB, 0.23416117E-11_JPRB, 0.20470010E-11_JPRB, 0.17852292E-11_JPRB, 0.15582283E-11_JPRB, 0.13642551E-11_JPRB, &
  & 0.12045859E-11_JPRB, 0.10777117E-11_JPRB, 0.98007605E-12_JPRB, 0.91101519E-12_JPRB, 0.86397426E-12_JPRB, 0.83545464E-12_JPRB, &
  & 0.82452849E-12_JPRB, 0.83328342E-12_JPRB, 0.86814209E-12_JPRB, 0.97135245E-12_JPRB /)

RGHG6(:,14, 5) = (/ &
  & 0.22708645E-11_JPRB, 0.25706303E-11_JPRB, 0.27610887E-11_JPRB, 0.29482269E-11_JPRB, 0.31734381E-11_JPRB, 0.34675574E-11_JPRB, &
  & 0.38664133E-11_JPRB, 0.44060164E-11_JPRB, 0.51110375E-11_JPRB, 0.59988828E-11_JPRB, 0.70693130E-11_JPRB, 0.82986803E-11_JPRB, &
  & 0.96247680E-11_JPRB, 0.10960909E-10_JPRB, 0.12185763E-10_JPRB, 0.13189621E-10_JPRB, 0.13897711E-10_JPRB, 0.14243164E-10_JPRB, &
  & 0.14202563E-10_JPRB, 0.13823293E-10_JPRB, 0.13200986E-10_JPRB, 0.12425458E-10_JPRB, 0.11563336E-10_JPRB, 0.10723175E-10_JPRB, &
  & 0.99996209E-11_JPRB, 0.94358306E-11_JPRB, 0.90646397E-11_JPRB, 0.89077808E-11_JPRB, 0.90191899E-11_JPRB, 0.94783998E-11_JPRB, &
  & 0.10324743E-10_JPRB, 0.11464244E-10_JPRB, 0.12744284E-10_JPRB, 0.14222564E-10_JPRB, 0.15415018E-10_JPRB, 0.16340308E-10_JPRB, &
  & 0.17131761E-10_JPRB, 0.17507799E-10_JPRB, 0.17487047E-10_JPRB, 0.17085885E-10_JPRB, 0.16334208E-10_JPRB, 0.15335178E-10_JPRB, &
  & 0.14178836E-10_JPRB, 0.12978106E-10_JPRB, 0.11819174E-10_JPRB, 0.10685685E-10_JPRB, 0.96122207E-11_JPRB, 0.86473294E-11_JPRB, &
  & 0.78019717E-11_JPRB, 0.70424912E-11_JPRB, 0.63668905E-11_JPRB, 0.57630537E-11_JPRB, 0.52284947E-11_JPRB, 0.47568234E-11_JPRB, &
  & 0.43550042E-11_JPRB, 0.40240792E-11_JPRB, 0.37616125E-11_JPRB, 0.35760240E-11_JPRB, 0.34577044E-11_JPRB, 0.34026553E-11_JPRB, &
  & 0.34138992E-11_JPRB, 0.35043457E-11_JPRB, 0.37127545E-11_JPRB, 0.42868500E-11_JPRB /)

RGHG6(:,15, 5) = (/ &
  & 0.62703254E-11_JPRB, 0.65638181E-11_JPRB, 0.67686529E-11_JPRB, 0.70189514E-11_JPRB, 0.73537582E-11_JPRB, 0.78312192E-11_JPRB, &
  & 0.85172520E-11_JPRB, 0.94617612E-11_JPRB, 0.10713973E-10_JPRB, 0.12292220E-10_JPRB, 0.14184250E-10_JPRB, 0.16332996E-10_JPRB, &
  & 0.18625327E-10_JPRB, 0.20924935E-10_JPRB, 0.23059128E-10_JPRB, 0.24846084E-10_JPRB, 0.26199522E-10_JPRB, 0.27110963E-10_JPRB, &
  & 0.27577338E-10_JPRB, 0.27644585E-10_JPRB, 0.27370595E-10_JPRB, 0.26801894E-10_JPRB, 0.26073241E-10_JPRB, 0.25331999E-10_JPRB, &
  & 0.24641154E-10_JPRB, 0.24074766E-10_JPRB, 0.23693204E-10_JPRB, 0.23475251E-10_JPRB, 0.23489129E-10_JPRB, 0.23746078E-10_JPRB, &
  & 0.24260883E-10_JPRB, 0.25075272E-10_JPRB, 0.26213195E-10_JPRB, 0.27533751E-10_JPRB, 0.29172938E-10_JPRB, 0.30775445E-10_JPRB, &
  & 0.31985220E-10_JPRB, 0.33012714E-10_JPRB, 0.33687487E-10_JPRB, 0.33788070E-10_JPRB, 0.33260485E-10_JPRB, 0.32141192E-10_JPRB, &
  & 0.30540688E-10_JPRB, 0.28635084E-10_JPRB, 0.26586167E-10_JPRB, 0.24462038E-10_JPRB, 0.22424904E-10_JPRB, 0.20572422E-10_JPRB, &
  & 0.18928536E-10_JPRB, 0.17452109E-10_JPRB, 0.16145925E-10_JPRB, 0.14976437E-10_JPRB, 0.13926975E-10_JPRB, 0.12986232E-10_JPRB, &
  & 0.12172129E-10_JPRB, 0.11489942E-10_JPRB, 0.10944255E-10_JPRB, 0.10567874E-10_JPRB, 0.10353576E-10_JPRB, 0.10305192E-10_JPRB, &
  & 0.10439160E-10_JPRB, 0.10800622E-10_JPRB, 0.11533197E-10_JPRB, 0.13451166E-10_JPRB /)

RGHG6(:,16, 5) = (/ &
  & 0.14457951E-10_JPRB, 0.14333352E-10_JPRB, 0.14349589E-10_JPRB, 0.14511835E-10_JPRB, 0.14848754E-10_JPRB, 0.15451173E-10_JPRB, &
  & 0.16389407E-10_JPRB, 0.17761804E-10_JPRB, 0.19621211E-10_JPRB, 0.21995773E-10_JPRB, 0.24844595E-10_JPRB, 0.28081299E-10_JPRB, &
  & 0.31541037E-10_JPRB, 0.35012111E-10_JPRB, 0.38360363E-10_JPRB, 0.41401538E-10_JPRB, 0.44005976E-10_JPRB, 0.46165648E-10_JPRB, &
  & 0.47917510E-10_JPRB, 0.49301983E-10_JPRB, 0.50352843E-10_JPRB, 0.51169416E-10_JPRB, 0.51911163E-10_JPRB, 0.52634151E-10_JPRB, &
  & 0.53356437E-10_JPRB, 0.53972816E-10_JPRB, 0.54463493E-10_JPRB, 0.54554777E-10_JPRB, 0.54286336E-10_JPRB, 0.53595579E-10_JPRB, &
  & 0.52650787E-10_JPRB, 0.51731570E-10_JPRB, 0.51002164E-10_JPRB, 0.50627180E-10_JPRB, 0.50846764E-10_JPRB, 0.51890828E-10_JPRB, &
  & 0.53651698E-10_JPRB, 0.55553170E-10_JPRB, 0.57365356E-10_JPRB, 0.58615494E-10_JPRB, 0.58967789E-10_JPRB, 0.58290824E-10_JPRB, &
  & 0.56611302E-10_JPRB, 0.54122602E-10_JPRB, 0.51117551E-10_JPRB, 0.47806734E-10_JPRB, 0.44494609E-10_JPRB, 0.41362400E-10_JPRB, &
  & 0.38534734E-10_JPRB, 0.35974650E-10_JPRB, 0.33708987E-10_JPRB, 0.31681557E-10_JPRB, 0.29864711E-10_JPRB, 0.28241038E-10_JPRB, &
  & 0.26840164E-10_JPRB, 0.25673448E-10_JPRB, 0.24760097E-10_JPRB, 0.24166426E-10_JPRB, 0.23895658E-10_JPRB, 0.23960313E-10_JPRB, &
  & 0.24395395E-10_JPRB, 0.25302463E-10_JPRB, 0.27022841E-10_JPRB, 0.31177894E-10_JPRB /)

RGHG6(:,17, 5) = (/ &
  & 0.28242599E-10_JPRB, 0.27220823E-10_JPRB, 0.26780508E-10_JPRB, 0.26628255E-10_JPRB, 0.26783985E-10_JPRB, 0.27333273E-10_JPRB, &
  & 0.28409055E-10_JPRB, 0.30114612E-10_JPRB, 0.32541879E-10_JPRB, 0.35706695E-10_JPRB, 0.39552403E-10_JPRB, 0.43937354E-10_JPRB, &
  & 0.48659729E-10_JPRB, 0.53469541E-10_JPRB, 0.58163297E-10_JPRB, 0.62690457E-10_JPRB, 0.66979013E-10_JPRB, 0.71005930E-10_JPRB, &
  & 0.74792034E-10_JPRB, 0.78464457E-10_JPRB, 0.82189804E-10_JPRB, 0.85961266E-10_JPRB, 0.89742276E-10_JPRB, 0.93491971E-10_JPRB, &
  & 0.97052352E-10_JPRB, 0.10014031E-09_JPRB, 0.10246579E-09_JPRB, 0.10356340E-09_JPRB, 0.10311710E-09_JPRB, 0.10104731E-09_JPRB, &
  & 0.97629925E-10_JPRB, 0.93501477E-10_JPRB, 0.89352081E-10_JPRB, 0.85807271E-10_JPRB, 0.83469821E-10_JPRB, 0.82717451E-10_JPRB, &
  & 0.83650378E-10_JPRB, 0.86015417E-10_JPRB, 0.88880146E-10_JPRB, 0.91538152E-10_JPRB, 0.93248687E-10_JPRB, 0.93513849E-10_JPRB, &
  & 0.92176197E-10_JPRB, 0.89413539E-10_JPRB, 0.85626457E-10_JPRB, 0.81118966E-10_JPRB, 0.76304366E-10_JPRB, 0.71577064E-10_JPRB, &
  & 0.67217551E-10_JPRB, 0.63250731E-10_JPRB, 0.59712187E-10_JPRB, 0.56530561E-10_JPRB, 0.53684123E-10_JPRB, 0.51166522E-10_JPRB, &
  & 0.49022873E-10_JPRB, 0.47279569E-10_JPRB, 0.45970765E-10_JPRB, 0.45186511E-10_JPRB, 0.44929806E-10_JPRB, 0.45209492E-10_JPRB, &
  & 0.46074838E-10_JPRB, 0.47666360E-10_JPRB, 0.50517136E-10_JPRB, 0.57168041E-10_JPRB /)

RGHG6(:,18, 5) = (/ &
  & 0.47905260E-10_JPRB, 0.45683589E-10_JPRB, 0.44614638E-10_JPRB, 0.43989125E-10_JPRB, 0.43794399E-10_JPRB, 0.44146530E-10_JPRB, &
  & 0.45201193E-10_JPRB, 0.47137474E-10_JPRB, 0.50035680E-10_JPRB, 0.53921045E-10_JPRB, 0.58706102E-10_JPRB, 0.64192311E-10_JPRB, &
  & 0.70141823E-10_JPRB, 0.76300986E-10_JPRB, 0.82433407E-10_JPRB, 0.88437667E-10_JPRB, 0.94395200E-10_JPRB, 0.10038941E-09_JPRB, &
  & 0.10653670E-09_JPRB, 0.11295541E-09_JPRB, 0.11962900E-09_JPRB, 0.12653398E-09_JPRB, 0.13370405E-09_JPRB, 0.14101666E-09_JPRB, &
  & 0.14810020E-09_JPRB, 0.15445262E-09_JPRB, 0.15944390E-09_JPRB, 0.16225413E-09_JPRB, 0.16227855E-09_JPRB, 0.15946948E-09_JPRB, &
  & 0.15404789E-09_JPRB, 0.14697461E-09_JPRB, 0.13926793E-09_JPRB, 0.13204873E-09_JPRB, 0.12651837E-09_JPRB, 0.12340398E-09_JPRB, &
  & 0.12295871E-09_JPRB, 0.12477706E-09_JPRB, 0.12819013E-09_JPRB, 0.13185927E-09_JPRB, 0.13460412E-09_JPRB, 0.13571121E-09_JPRB, &
  & 0.13478069E-09_JPRB, 0.13185864E-09_JPRB, 0.12736412E-09_JPRB, 0.12165191E-09_JPRB, 0.11536888E-09_JPRB, 0.10907747E-09_JPRB, &
  & 0.10319439E-09_JPRB, 0.97724502E-10_JPRB, 0.92729199E-10_JPRB, 0.88175002E-10_JPRB, 0.84099602E-10_JPRB, 0.80538125E-10_JPRB, &
  & 0.77568105E-10_JPRB, 0.75232383E-10_JPRB, 0.73555453E-10_JPRB, 0.72620930E-10_JPRB, 0.72411285E-10_JPRB, 0.72921967E-10_JPRB, &
  & 0.74182167E-10_JPRB, 0.76359037E-10_JPRB, 0.80065184E-10_JPRB, 0.88436279E-10_JPRB /)

RGHG6(:,19, 5) = (/ &
  & 0.72553095E-10_JPRB, 0.69289637E-10_JPRB, 0.67635314E-10_JPRB, 0.66570201E-10_JPRB, 0.66021424E-10_JPRB, 0.66128693E-10_JPRB, &
  & 0.67111650E-10_JPRB, 0.69163661E-10_JPRB, 0.72420320E-10_JPRB, 0.76901360E-10_JPRB, 0.82493866E-10_JPRB, 0.88968853E-10_JPRB, &
  & 0.95997162E-10_JPRB, 0.10333030E-09_JPRB, 0.11077334E-09_JPRB, 0.11820039E-09_JPRB, 0.12563200E-09_JPRB, 0.13319218E-09_JPRB, &
  & 0.14099753E-09_JPRB, 0.14918751E-09_JPRB, 0.15797391E-09_JPRB, 0.16743026E-09_JPRB, 0.17746823E-09_JPRB, 0.18769966E-09_JPRB, &
  & 0.19769920E-09_JPRB, 0.20681797E-09_JPRB, 0.21419692E-09_JPRB, 0.21893821E-09_JPRB, 0.22043664E-09_JPRB, 0.21843763E-09_JPRB, &
  & 0.21314903E-09_JPRB, 0.20531410E-09_JPRB, 0.19600004E-09_JPRB, 0.18655744E-09_JPRB, 0.17860884E-09_JPRB, 0.17330536E-09_JPRB, &
  & 0.17114909E-09_JPRB, 0.17191944E-09_JPRB, 0.17476738E-09_JPRB, 0.17826807E-09_JPRB, 0.18110514E-09_JPRB, 0.18220099E-09_JPRB, &
  & 0.18105295E-09_JPRB, 0.17763913E-09_JPRB, 0.17233695E-09_JPRB, 0.16558349E-09_JPRB, 0.15810109E-09_JPRB, 0.15050770E-09_JPRB, &
  & 0.14315331E-09_JPRB, 0.13607904E-09_JPRB, 0.12950482E-09_JPRB, 0.12353990E-09_JPRB, 0.11828191E-09_JPRB, 0.11379065E-09_JPRB, &
  & 0.11014228E-09_JPRB, 0.10735404E-09_JPRB, 0.10540713E-09_JPRB, 0.10435318E-09_JPRB, 0.10414483E-09_JPRB, 0.10474710E-09_JPRB, &
  & 0.10617456E-09_JPRB, 0.10857335E-09_JPRB, 0.11252383E-09_JPRB, 0.12155217E-09_JPRB /)

RGHG6(:,20, 5) = (/ &
  & 0.10077225E-09_JPRB, 0.96871441E-10_JPRB, 0.94906263E-10_JPRB, 0.93600253E-10_JPRB, 0.92857021E-10_JPRB, 0.92830514E-10_JPRB, &
  & 0.93781691E-10_JPRB, 0.95969808E-10_JPRB, 0.99542596E-10_JPRB, 0.10453959E-09_JPRB, 0.11083387E-09_JPRB, 0.11813799E-09_JPRB, &
  & 0.12611505E-09_JPRB, 0.13440878E-09_JPRB, 0.14283044E-09_JPRB, 0.15128961E-09_JPRB, 0.15981670E-09_JPRB, 0.16850060E-09_JPRB, &
  & 0.17745859E-09_JPRB, 0.18686784E-09_JPRB, 0.19687260E-09_JPRB, 0.20742433E-09_JPRB, 0.21859160E-09_JPRB, 0.23018312E-09_JPRB, &
  & 0.24164346E-09_JPRB, 0.25225680E-09_JPRB, 0.26138172E-09_JPRB, 0.26795260E-09_JPRB, 0.27144048E-09_JPRB, 0.27152586E-09_JPRB, &
  & 0.26829705E-09_JPRB, 0.26213248E-09_JPRB, 0.25399388E-09_JPRB, 0.24493127E-09_JPRB, 0.23648805E-09_JPRB, 0.23002023E-09_JPRB, &
  & 0.22638105E-09_JPRB, 0.22552993E-09_JPRB, 0.22679780E-09_JPRB, 0.22875470E-09_JPRB, 0.23023006E-09_JPRB, 0.23017738E-09_JPRB, &
  & 0.22795740E-09_JPRB, 0.22349313E-09_JPRB, 0.21715299E-09_JPRB, 0.20933001E-09_JPRB, 0.20068069E-09_JPRB, 0.19168088E-09_JPRB, &
  & 0.18279178E-09_JPRB, 0.17427212E-09_JPRB, 0.16646376E-09_JPRB, 0.15948648E-09_JPRB, 0.15344662E-09_JPRB, 0.14840060E-09_JPRB, &
  & 0.14437572E-09_JPRB, 0.14133289E-09_JPRB, 0.13920499E-09_JPRB, 0.13800250E-09_JPRB, 0.13766058E-09_JPRB, 0.13813184E-09_JPRB, &
  & 0.13941323E-09_JPRB, 0.14162897E-09_JPRB, 0.14531720E-09_JPRB, 0.15385572E-09_JPRB /)

RGHG6(:,21, 5) = (/ &
  & 0.13059158E-09_JPRB, 0.12672430E-09_JPRB, 0.12480954E-09_JPRB, 0.12356624E-09_JPRB, 0.12290410E-09_JPRB, 0.12299937E-09_JPRB, &
  & 0.12414046E-09_JPRB, 0.12660187E-09_JPRB, 0.13057491E-09_JPRB, 0.13610366E-09_JPRB, 0.14303911E-09_JPRB, 0.15110632E-09_JPRB, &
  & 0.15989338E-09_JPRB, 0.16903187E-09_JPRB, 0.17823451E-09_JPRB, 0.18739241E-09_JPRB, 0.19653890E-09_JPRB, 0.20579688E-09_JPRB, &
  & 0.21528310E-09_JPRB, 0.22509214E-09_JPRB, 0.23534016E-09_JPRB, 0.24610392E-09_JPRB, 0.25724889E-09_JPRB, 0.26871189E-09_JPRB, &
  & 0.28015662E-09_JPRB, 0.29095995E-09_JPRB, 0.30054428E-09_JPRB, 0.30830688E-09_JPRB, 0.31371772E-09_JPRB, 0.31633565E-09_JPRB, &
  & 0.31603825E-09_JPRB, 0.31299174E-09_JPRB, 0.30778502E-09_JPRB, 0.30105921E-09_JPRB, 0.29417069E-09_JPRB, 0.28823599E-09_JPRB, &
  & 0.28399921E-09_JPRB, 0.28150962E-09_JPRB, 0.28051048E-09_JPRB, 0.27997860E-09_JPRB, 0.27893052E-09_JPRB, 0.27655608E-09_JPRB, &
  & 0.27240393E-09_JPRB, 0.26635377E-09_JPRB, 0.25864844E-09_JPRB, 0.24958449E-09_JPRB, 0.23966235E-09_JPRB, 0.22950511E-09_JPRB, &
  & 0.21968861E-09_JPRB, 0.21048949E-09_JPRB, 0.20210703E-09_JPRB, 0.19462533E-09_JPRB, 0.18818874E-09_JPRB, 0.18284230E-09_JPRB, &
  & 0.17858870E-09_JPRB, 0.17534434E-09_JPRB, 0.17300412E-09_JPRB, 0.17154916E-09_JPRB, 0.17090268E-09_JPRB, 0.17101441E-09_JPRB, &
  & 0.17186658E-09_JPRB, 0.17354924E-09_JPRB, 0.17651443E-09_JPRB, 0.18340714E-09_JPRB /)

RGHG6(:,22, 5) = (/ &
  & 0.16031944E-09_JPRB, 0.15702437E-09_JPRB, 0.15551004E-09_JPRB, 0.15464416E-09_JPRB, 0.15437066E-09_JPRB, 0.15487395E-09_JPRB, &
  & 0.15644530E-09_JPRB, 0.15940213E-09_JPRB, 0.16391695E-09_JPRB, 0.17005004E-09_JPRB, 0.17767356E-09_JPRB, 0.18645491E-09_JPRB, &
  & 0.19600511E-09_JPRB, 0.20587576E-09_JPRB, 0.21574834E-09_JPRB, 0.22544561E-09_JPRB, 0.23495977E-09_JPRB, 0.24438646E-09_JPRB, &
  & 0.25384889E-09_JPRB, 0.26343816E-09_JPRB, 0.27323255E-09_JPRB, 0.28326302E-09_JPRB, 0.29349398E-09_JPRB, 0.30382036E-09_JPRB, &
  & 0.31415459E-09_JPRB, 0.32420089E-09_JPRB, 0.33361500E-09_JPRB, 0.34177122E-09_JPRB, 0.34829137E-09_JPRB, 0.35292377E-09_JPRB, &
  & 0.35536976E-09_JPRB, 0.35556225E-09_JPRB, 0.35371828E-09_JPRB, 0.35013847E-09_JPRB, 0.34569758E-09_JPRB, 0.34103237E-09_JPRB, &
  & 0.33693626E-09_JPRB, 0.33339617E-09_JPRB, 0.33040073E-09_JPRB, 0.32731201E-09_JPRB, 0.32351732E-09_JPRB, 0.31847805E-09_JPRB, &
  & 0.31198372E-09_JPRB, 0.30401723E-09_JPRB, 0.29480027E-09_JPRB, 0.28455943E-09_JPRB, 0.27387947E-09_JPRB, 0.26333671E-09_JPRB, &
  & 0.25334357E-09_JPRB, 0.24398383E-09_JPRB, 0.23541513E-09_JPRB, 0.22779742E-09_JPRB, 0.22125012E-09_JPRB, 0.21579211E-09_JPRB, &
  & 0.21139154E-09_JPRB, 0.20794773E-09_JPRB, 0.20534922E-09_JPRB, 0.20354922E-09_JPRB, 0.20247858E-09_JPRB, 0.20208851E-09_JPRB, &
  & 0.20236474E-09_JPRB, 0.20335925E-09_JPRB, 0.20537612E-09_JPRB, 0.21060154E-09_JPRB /)

RGHG6(:,23, 5) = (/ &
  & 0.18850274E-09_JPRB, 0.18628486E-09_JPRB, 0.18542015E-09_JPRB, 0.18513731E-09_JPRB, 0.18545510E-09_JPRB, 0.18656250E-09_JPRB, &
  & 0.18878910E-09_JPRB, 0.19240950E-09_JPRB, 0.19761318E-09_JPRB, 0.20443607E-09_JPRB, 0.21273164E-09_JPRB, 0.22221125E-09_JPRB, &
  & 0.23241929E-09_JPRB, 0.24292152E-09_JPRB, 0.25331659E-09_JPRB, 0.26340372E-09_JPRB, 0.27312280E-09_JPRB, 0.28252078E-09_JPRB, &
  & 0.29168959E-09_JPRB, 0.30071987E-09_JPRB, 0.30961908E-09_JPRB, 0.31842229E-09_JPRB, 0.32714095E-09_JPRB, 0.33581687E-09_JPRB, &
  & 0.34442083E-09_JPRB, 0.35292111E-09_JPRB, 0.36127792E-09_JPRB, 0.36928935E-09_JPRB, 0.37644041E-09_JPRB, 0.38239037E-09_JPRB, &
  & 0.38683315E-09_JPRB, 0.38954395E-09_JPRB, 0.39045814E-09_JPRB, 0.38966350E-09_JPRB, 0.38753142E-09_JPRB, 0.38444858E-09_JPRB, &
  & 0.38080467E-09_JPRB, 0.37675990E-09_JPRB, 0.37231906E-09_JPRB, 0.36720496E-09_JPRB, 0.36113382E-09_JPRB, 0.35391357E-09_JPRB, &
  & 0.34550107E-09_JPRB, 0.33598377E-09_JPRB, 0.32561800E-09_JPRB, 0.31473329E-09_JPRB, 0.30380545E-09_JPRB, 0.29322478E-09_JPRB, &
  & 0.28324851E-09_JPRB, 0.27396729E-09_JPRB, 0.26554850E-09_JPRB, 0.25808713E-09_JPRB, 0.25165928E-09_JPRB, 0.24625563E-09_JPRB, &
  & 0.24181429E-09_JPRB, 0.23822483E-09_JPRB, 0.23537339E-09_JPRB, 0.23321178E-09_JPRB, 0.23168123E-09_JPRB, 0.23075408E-09_JPRB, &
  & 0.23042193E-09_JPRB, 0.23071146E-09_JPRB, 0.23181038E-09_JPRB, 0.23518484E-09_JPRB /)

RGHG6(:,24, 5) = (/ &
  & 0.21469937E-09_JPRB, 0.21364976E-09_JPRB, 0.21351192E-09_JPRB, 0.21388301E-09_JPRB, 0.21485172E-09_JPRB, 0.21666138E-09_JPRB, &
  & 0.21959780E-09_JPRB, 0.22395313E-09_JPRB, 0.22985464E-09_JPRB, 0.23732849E-09_JPRB, 0.24622820E-09_JPRB, 0.25624791E-09_JPRB, &
  & 0.26696453E-09_JPRB, 0.27791058E-09_JPRB, 0.28867014E-09_JPRB, 0.29898181E-09_JPRB, 0.30876138E-09_JPRB, 0.31801453E-09_JPRB, &
  & 0.32679520E-09_JPRB, 0.33514719E-09_JPRB, 0.34309974E-09_JPRB, 0.35065303E-09_JPRB, 0.35785955E-09_JPRB, 0.36482170E-09_JPRB, &
  & 0.37167056E-09_JPRB, 0.37855757E-09_JPRB, 0.38558609E-09_JPRB, 0.39268930E-09_JPRB, 0.39972139E-09_JPRB, 0.40623227E-09_JPRB, &
  & 0.41178652E-09_JPRB, 0.41603590E-09_JPRB, 0.41872131E-09_JPRB, 0.41977774E-09_JPRB, 0.41924300E-09_JPRB, 0.41731746E-09_JPRB, &
  & 0.41414927E-09_JPRB, 0.40991258E-09_JPRB, 0.40461384E-09_JPRB, 0.39829037E-09_JPRB, 0.39082745E-09_JPRB, 0.38224995E-09_JPRB, &
  & 0.37268730E-09_JPRB, 0.36232661E-09_JPRB, 0.35147948E-09_JPRB, 0.34041392E-09_JPRB, 0.32951855E-09_JPRB, 0.31911948E-09_JPRB, &
  & 0.30944292E-09_JPRB, 0.30053607E-09_JPRB, 0.29249267E-09_JPRB, 0.28537667E-09_JPRB, 0.27922481E-09_JPRB, 0.27399549E-09_JPRB, &
  & 0.26960092E-09_JPRB, 0.26592281E-09_JPRB, 0.26285438E-09_JPRB, 0.26035085E-09_JPRB, 0.25838026E-09_JPRB, 0.25693545E-09_JPRB, &
  & 0.25602809E-09_JPRB, 0.25567981E-09_JPRB, 0.25596336E-09_JPRB, 0.25757696E-09_JPRB /)

RGHG6(:,25, 5) = (/ &
  & 0.23879523E-09_JPRB, 0.23885119E-09_JPRB, 0.23937458E-09_JPRB, 0.24032640E-09_JPRB, 0.24191069E-09_JPRB, 0.24435054E-09_JPRB, &
  & 0.24794131E-09_JPRB, 0.25293234E-09_JPRB, 0.25942420E-09_JPRB, 0.26739841E-09_JPRB, 0.27671956E-09_JPRB, 0.28706765E-09_JPRB, &
  & 0.29805139E-09_JPRB, 0.30921180E-09_JPRB, 0.32012895E-09_JPRB, 0.33051553E-09_JPRB, 0.34024508E-09_JPRB, 0.34930026E-09_JPRB, &
  & 0.35770348E-09_JPRB, 0.36546352E-09_JPRB, 0.37259787E-09_JPRB, 0.37911313E-09_JPRB, 0.38505499E-09_JPRB, 0.39059045E-09_JPRB, &
  & 0.39590545E-09_JPRB, 0.40129017E-09_JPRB, 0.40700182E-09_JPRB, 0.41311943E-09_JPRB, 0.41951159E-09_JPRB, 0.42589407E-09_JPRB, &
  & 0.43177384E-09_JPRB, 0.43669360E-09_JPRB, 0.44025647E-09_JPRB, 0.44227380E-09_JPRB, 0.44259713E-09_JPRB, 0.44128745E-09_JPRB, &
  & 0.43839221E-09_JPRB, 0.43409179E-09_JPRB, 0.42842443E-09_JPRB, 0.42148790E-09_JPRB, 0.41336271E-09_JPRB, 0.40418865E-09_JPRB, &
  & 0.39419268E-09_JPRB, 0.38361664E-09_JPRB, 0.37275616E-09_JPRB, 0.36191458E-09_JPRB, 0.35143921E-09_JPRB, 0.34156702E-09_JPRB, &
  & 0.33246422E-09_JPRB, 0.32415309E-09_JPRB, 0.31666608E-09_JPRB, 0.31001646E-09_JPRB, 0.30422467E-09_JPRB, 0.29922081E-09_JPRB, &
  & 0.29491151E-09_JPRB, 0.29118224E-09_JPRB, 0.28793457E-09_JPRB, 0.28513156E-09_JPRB, 0.28276220E-09_JPRB, 0.28084607E-09_JPRB, &
  & 0.27941355E-09_JPRB, 0.27848024E-09_JPRB, 0.27807262E-09_JPRB, 0.27857117E-09_JPRB /)

RGHG6(:,26, 5) = (/ &
  & 0.26101363E-09_JPRB, 0.26200933E-09_JPRB, 0.26300906E-09_JPRB, 0.26445532E-09_JPRB, 0.26648267E-09_JPRB, 0.26939653E-09_JPRB, &
  & 0.27348238E-09_JPRB, 0.27891714E-09_JPRB, 0.28579775E-09_JPRB, 0.29407088E-09_JPRB, 0.30355296E-09_JPRB, 0.31400735E-09_JPRB, &
  & 0.32501288E-09_JPRB, 0.33618294E-09_JPRB, 0.34708617E-09_JPRB, 0.35743916E-09_JPRB, 0.36706480E-09_JPRB, 0.37592632E-09_JPRB, &
  & 0.38401110E-09_JPRB, 0.39131742E-09_JPRB, 0.39784881E-09_JPRB, 0.40361747E-09_JPRB, 0.40867715E-09_JPRB, 0.41318243E-09_JPRB, &
  & 0.41736242E-09_JPRB, 0.42153944E-09_JPRB, 0.42605042E-09_JPRB, 0.43108919E-09_JPRB, 0.43666706E-09_JPRB, 0.44249776E-09_JPRB, &
  & 0.44812837E-09_JPRB, 0.45308854E-09_JPRB, 0.45688694E-09_JPRB, 0.45923582E-09_JPRB, 0.45988593E-09_JPRB, 0.45881240E-09_JPRB, &
  & 0.45604637E-09_JPRB, 0.45169582E-09_JPRB, 0.44591572E-09_JPRB, 0.43879306E-09_JPRB, 0.43052886E-09_JPRB, 0.42131540E-09_JPRB, &
  & 0.41141110E-09_JPRB, 0.40110240E-09_JPRB, 0.39071063E-09_JPRB, 0.38050507E-09_JPRB, 0.37072498E-09_JPRB, 0.36161504E-09_JPRB, &
  & 0.35326875E-09_JPRB, 0.34564093E-09_JPRB, 0.33872977E-09_JPRB, 0.33256539E-09_JPRB, 0.32711733E-09_JPRB, 0.32232594E-09_JPRB, &
  & 0.31810057E-09_JPRB, 0.31433689E-09_JPRB, 0.31094594E-09_JPRB, 0.30789801E-09_JPRB, 0.30519887E-09_JPRB, 0.30288858E-09_JPRB, &
  & 0.30101216E-09_JPRB, 0.29957431E-09_JPRB, 0.29851552E-09_JPRB, 0.29776107E-09_JPRB /)

RGHG6(:,27, 5) = (/ &
  & 0.28161687E-09_JPRB, 0.28312294E-09_JPRB, 0.28458544E-09_JPRB, 0.28628422E-09_JPRB, 0.28863373E-09_JPRB, 0.29185881E-09_JPRB, &
  & 0.29621308E-09_JPRB, 0.30193334E-09_JPRB, 0.30898384E-09_JPRB, 0.31731268E-09_JPRB, 0.32677977E-09_JPRB, 0.33708780E-09_JPRB, &
  & 0.34795630E-09_JPRB, 0.35896136E-09_JPRB, 0.36974210E-09_JPRB, 0.37997716E-09_JPRB, 0.38946754E-09_JPRB, 0.39815284E-09_JPRB, &
  & 0.40600046E-09_JPRB, 0.41300663E-09_JPRB, 0.41916443E-09_JPRB, 0.42447196E-09_JPRB, 0.42897799E-09_JPRB, 0.43282578E-09_JPRB, &
  & 0.43623496E-09_JPRB, 0.43952536E-09_JPRB, 0.44307485E-09_JPRB, 0.44709958E-09_JPRB, 0.45170928E-09_JPRB, 0.45677875E-09_JPRB, &
  & 0.46182896E-09_JPRB, 0.46643078E-09_JPRB, 0.47006071E-09_JPRB, 0.47234855E-09_JPRB, 0.47301807E-09_JPRB, 0.47198823E-09_JPRB, &
  & 0.46927023E-09_JPRB, 0.46492835E-09_JPRB, 0.45918108E-09_JPRB, 0.45220810E-09_JPRB, 0.44414264E-09_JPRB, 0.43526843E-09_JPRB, &
  & 0.42585904E-09_JPRB, 0.41622730E-09_JPRB, 0.40661852E-09_JPRB, 0.39723427E-09_JPRB, 0.38833209E-09_JPRB, 0.38005843E-09_JPRB, &
  & 0.37244943E-09_JPRB, 0.36548015E-09_JPRB, 0.35913864E-09_JPRB, 0.35339567E-09_JPRB, 0.34824149E-09_JPRB, 0.34362169E-09_JPRB, &
  & 0.33945594E-09_JPRB, 0.33565822E-09_JPRB, 0.33215286E-09_JPRB, 0.32891082E-09_JPRB, 0.32595243E-09_JPRB, 0.32333539E-09_JPRB, &
  & 0.32111769E-09_JPRB, 0.31930200E-09_JPRB, 0.31777234E-09_JPRB, 0.31611655E-09_JPRB /)

RGHG6(:,28, 5) = (/ &
  & 0.30021088E-09_JPRB, 0.30240183E-09_JPRB, 0.30398251E-09_JPRB, 0.30596137E-09_JPRB, 0.30846148E-09_JPRB, 0.31183939E-09_JPRB, &
  & 0.31639263E-09_JPRB, 0.32217473E-09_JPRB, 0.32925182E-09_JPRB, 0.33749270E-09_JPRB, 0.34673581E-09_JPRB, 0.35681058E-09_JPRB, &
  & 0.36737791E-09_JPRB, 0.37813225E-09_JPRB, 0.38869302E-09_JPRB, 0.39875786E-09_JPRB, 0.40812534E-09_JPRB, 0.41666806E-09_JPRB, &
  & 0.42435477E-09_JPRB, 0.43117615E-09_JPRB, 0.43711257E-09_JPRB, 0.44215415E-09_JPRB, 0.44634740E-09_JPRB, 0.44981488E-09_JPRB, &
  & 0.45274451E-09_JPRB, 0.45544127E-09_JPRB, 0.45822338E-09_JPRB, 0.46139695E-09_JPRB, 0.46510693E-09_JPRB, 0.46928228E-09_JPRB, &
  & 0.47358428E-09_JPRB, 0.47758586E-09_JPRB, 0.48080651E-09_JPRB, 0.48281551E-09_JPRB, 0.48334858E-09_JPRB, 0.48227522E-09_JPRB, &
  & 0.47958970E-09_JPRB, 0.47539372E-09_JPRB, 0.46986443E-09_JPRB, 0.46320370E-09_JPRB, 0.45560566E-09_JPRB, 0.44735587E-09_JPRB, &
  & 0.43873180E-09_JPRB, 0.42998355E-09_JPRB, 0.42130024E-09_JPRB, 0.41287476E-09_JPRB, 0.40486892E-09_JPRB, 0.39739695E-09_JPRB, &
  & 0.39049100E-09_JPRB, 0.38410897E-09_JPRB, 0.37820355E-09_JPRB, 0.37278519E-09_JPRB, 0.36784109E-09_JPRB, 0.36333200E-09_JPRB, &
  & 0.35919390E-09_JPRB, 0.35535405E-09_JPRB, 0.35174472E-09_JPRB, 0.34834599E-09_JPRB, 0.34518494E-09_JPRB, 0.34232556E-09_JPRB, &
  & 0.33984324E-09_JPRB, 0.33773229E-09_JPRB, 0.33583983E-09_JPRB, 0.33351344E-09_JPRB /)

RGHG6(:,29, 5) = (/ &
  & 0.31723141E-09_JPRB, 0.31953790E-09_JPRB, 0.32147415E-09_JPRB, 0.32348657E-09_JPRB, 0.32612715E-09_JPRB, 0.32962302E-09_JPRB, &
  & 0.33418629E-09_JPRB, 0.34001918E-09_JPRB, 0.34698378E-09_JPRB, 0.35501613E-09_JPRB, 0.36399475E-09_JPRB, 0.37370049E-09_JPRB, &
  & 0.38394449E-09_JPRB, 0.39438014E-09_JPRB, 0.40468598E-09_JPRB, 0.41454276E-09_JPRB, 0.42374365E-09_JPRB, 0.43216469E-09_JPRB, &
  & 0.43973691E-09_JPRB, 0.44643000E-09_JPRB, 0.45223364E-09_JPRB, 0.45712339E-09_JPRB, 0.46115745E-09_JPRB, 0.46442550E-09_JPRB, &
  & 0.46708609E-09_JPRB, 0.46941029E-09_JPRB, 0.47165666E-09_JPRB, 0.47413923E-09_JPRB, 0.47704607E-09_JPRB, 0.48034715E-09_JPRB, &
  & 0.48383025E-09_JPRB, 0.48711507E-09_JPRB, 0.48978621E-09_JPRB, 0.49140852E-09_JPRB, 0.49172161E-09_JPRB, 0.49058041E-09_JPRB, &
  & 0.48798787E-09_JPRB, 0.48402810E-09_JPRB, 0.47888060E-09_JPRB, 0.47273230E-09_JPRB, 0.46580556E-09_JPRB, 0.45837514E-09_JPRB, &
  & 0.45070134E-09_JPRB, 0.44294882E-09_JPRB, 0.43529702E-09_JPRB, 0.42780951E-09_JPRB, 0.42063575E-09_JPRB, 0.41387616E-09_JPRB, &
  & 0.40755085E-09_JPRB, 0.40159959E-09_JPRB, 0.39602888E-09_JPRB, 0.39083445E-09_JPRB, 0.38601933E-09_JPRB, 0.38156900E-09_JPRB, &
  & 0.37742803E-09_JPRB, 0.37353942E-09_JPRB, 0.36984293E-09_JPRB, 0.36631428E-09_JPRB, 0.36298800E-09_JPRB, 0.35993120E-09_JPRB, &
  & 0.35722558E-09_JPRB, 0.35486541E-09_JPRB, 0.35265862E-09_JPRB, 0.34969083E-09_JPRB /)

RGHG6(:,30, 5) = (/ &
  & 0.33217917E-09_JPRB, 0.33505770E-09_JPRB, 0.33696662E-09_JPRB, 0.33919281E-09_JPRB, 0.34187853E-09_JPRB, 0.34540765E-09_JPRB, &
  & 0.35003950E-09_JPRB, 0.35576339E-09_JPRB, 0.36258885E-09_JPRB, 0.37037334E-09_JPRB, 0.37899944E-09_JPRB, 0.38835785E-09_JPRB, &
  & 0.39819498E-09_JPRB, 0.40828488E-09_JPRB, 0.41831053E-09_JPRB, 0.42794557E-09_JPRB, 0.43697324E-09_JPRB, 0.44525178E-09_JPRB, &
  & 0.45272011E-09_JPRB, 0.45929485E-09_JPRB, 0.46500415E-09_JPRB, 0.46978910E-09_JPRB, 0.47374316E-09_JPRB, 0.47690507E-09_JPRB, &
  & 0.47942922E-09_JPRB, 0.48152415E-09_JPRB, 0.48340670E-09_JPRB, 0.48536919E-09_JPRB, 0.48760301E-09_JPRB, 0.49012661E-09_JPRB, &
  & 0.49281729E-09_JPRB, 0.49537002E-09_JPRB, 0.49744481E-09_JPRB, 0.49864146E-09_JPRB, 0.49871474E-09_JPRB, 0.49752757E-09_JPRB, &
  & 0.49506782E-09_JPRB, 0.49144344E-09_JPRB, 0.48680721E-09_JPRB, 0.48134569E-09_JPRB, 0.47524173E-09_JPRB, 0.46875875E-09_JPRB, &
  & 0.46208309E-09_JPRB, 0.45536333E-09_JPRB, 0.44864390E-09_JPRB, 0.44205392E-09_JPRB, 0.43559295E-09_JPRB, 0.42941378E-09_JPRB, &
  & 0.42354609E-09_JPRB, 0.41792958E-09_JPRB, 0.41258463E-09_JPRB, 0.40752524E-09_JPRB, 0.40277670E-09_JPRB, 0.39834391E-09_JPRB, &
  & 0.39419040E-09_JPRB, 0.39026424E-09_JPRB, 0.38650333E-09_JPRB, 0.38288775E-09_JPRB, 0.37944667E-09_JPRB, 0.37624415E-09_JPRB, &
  & 0.37337652E-09_JPRB, 0.37082840E-09_JPRB, 0.36839090E-09_JPRB, 0.36500969E-09_JPRB /)

RGHG6(:,31, 5) = (/ &
  & 0.34583175E-09_JPRB, 0.34877864E-09_JPRB, 0.35103420E-09_JPRB, 0.35327208E-09_JPRB, 0.35607026E-09_JPRB, 0.35965977E-09_JPRB, &
  & 0.36422068E-09_JPRB, 0.36987463E-09_JPRB, 0.37647530E-09_JPRB, 0.38395259E-09_JPRB, 0.39224013E-09_JPRB, 0.40118175E-09_JPRB, &
  & 0.41064352E-09_JPRB, 0.42033349E-09_JPRB, 0.43001297E-09_JPRB, 0.43940449E-09_JPRB, 0.44824403E-09_JPRB, 0.45637022E-09_JPRB, &
  & 0.46372428E-09_JPRB, 0.47018384E-09_JPRB, 0.47579635E-09_JPRB, 0.48049875E-09_JPRB, 0.48438786E-09_JPRB, 0.48749416E-09_JPRB, &
  & 0.48994453E-09_JPRB, 0.49190718E-09_JPRB, 0.49356746E-09_JPRB, 0.49514881E-09_JPRB, 0.49685928E-09_JPRB, 0.49871718E-09_JPRB, &
  & 0.50069826E-09_JPRB, 0.50257343E-09_JPRB, 0.50406734E-09_JPRB, 0.50484994E-09_JPRB, 0.50469157E-09_JPRB, 0.50347659E-09_JPRB, &
  & 0.50120486E-09_JPRB, 0.49797694E-09_JPRB, 0.49393162E-09_JPRB, 0.48921078E-09_JPRB, 0.48399990E-09_JPRB, 0.47847648E-09_JPRB, &
  & 0.47279552E-09_JPRB, 0.46703352E-09_JPRB, 0.46123103E-09_JPRB, 0.45536239E-09_JPRB, 0.44955084E-09_JPRB, 0.44384238E-09_JPRB, &
  & 0.43831186E-09_JPRB, 0.43294759E-09_JPRB, 0.42775261E-09_JPRB, 0.42277748E-09_JPRB, 0.41807308E-09_JPRB, 0.41365181E-09_JPRB, &
  & 0.40949344E-09_JPRB, 0.40554896E-09_JPRB, 0.40176090E-09_JPRB, 0.39810216E-09_JPRB, 0.39459666E-09_JPRB, 0.39131182E-09_JPRB, &
  & 0.38833337E-09_JPRB, 0.38566109E-09_JPRB, 0.38306375E-09_JPRB, 0.37938716E-09_JPRB /)

RGHG6(:,32, 5) = (/ &
  & 0.35798697E-09_JPRB, 0.36152104E-09_JPRB, 0.36376274E-09_JPRB, 0.36623099E-09_JPRB, 0.36907821E-09_JPRB, 0.37267284E-09_JPRB, &
  & 0.37721132E-09_JPRB, 0.38266784E-09_JPRB, 0.38901352E-09_JPRB, 0.39616238E-09_JPRB, 0.40403558E-09_JPRB, 0.41257628E-09_JPRB, &
  & 0.42158843E-09_JPRB, 0.43090073E-09_JPRB, 0.44022222E-09_JPRB, 0.44930504E-09_JPRB, 0.45793053E-09_JPRB, 0.46587273E-09_JPRB, &
  & 0.47308252E-09_JPRB, 0.47942716E-09_JPRB, 0.48492282E-09_JPRB, 0.48955046E-09_JPRB, 0.49336357E-09_JPRB, 0.49642979E-09_JPRB, &
  & 0.49882876E-09_JPRB, 0.50070986E-09_JPRB, 0.50222737E-09_JPRB, 0.50355325E-09_JPRB, 0.50486071E-09_JPRB, 0.50619908E-09_JPRB, &
  & 0.50757742E-09_JPRB, 0.50886112E-09_JPRB, 0.50983212E-09_JPRB, 0.51022664E-09_JPRB, 0.50985255E-09_JPRB, 0.50862980E-09_JPRB, &
  & 0.50657989E-09_JPRB, 0.50378213E-09_JPRB, 0.50034576E-09_JPRB, 0.49638277E-09_JPRB, 0.49202042E-09_JPRB, 0.48740978E-09_JPRB, &
  & 0.48261117E-09_JPRB, 0.47770365E-09_JPRB, 0.47264492E-09_JPRB, 0.46745097E-09_JPRB, 0.46216644E-09_JPRB, 0.45687726E-09_JPRB, &
  & 0.45164197E-09_JPRB, 0.44647763E-09_JPRB, 0.44141774E-09_JPRB, 0.43652279E-09_JPRB, 0.43186651E-09_JPRB, 0.42747381E-09_JPRB, &
  & 0.42333889E-09_JPRB, 0.41941159E-09_JPRB, 0.41563283E-09_JPRB, 0.41197826E-09_JPRB, 0.40846329E-09_JPRB, 0.40514844E-09_JPRB, &
  & 0.40212433E-09_JPRB, 0.39937872E-09_JPRB, 0.39667625E-09_JPRB, 0.39278486E-09_JPRB /)

RGHG6(:,33, 5) = (/ &
  & 0.36945769E-09_JPRB, 0.37315712E-09_JPRB, 0.37577486E-09_JPRB, 0.37827191E-09_JPRB, 0.38121781E-09_JPRB, 0.38482448E-09_JPRB, &
  & 0.38922496E-09_JPRB, 0.39448420E-09_JPRB, 0.40050982E-09_JPRB, 0.40725920E-09_JPRB, 0.41472034E-09_JPRB, 0.42278450E-09_JPRB, &
  & 0.43135467E-09_JPRB, 0.44019738E-09_JPRB, 0.44913162E-09_JPRB, 0.45790186E-09_JPRB, 0.46627274E-09_JPRB, 0.47402826E-09_JPRB, &
  & 0.48106108E-09_JPRB, 0.48728066E-09_JPRB, 0.49265370E-09_JPRB, 0.49719168E-09_JPRB, 0.50092502E-09_JPRB, 0.50393739E-09_JPRB, &
  & 0.50628890E-09_JPRB, 0.50810528E-09_JPRB, 0.50951876E-09_JPRB, 0.51066662E-09_JPRB, 0.51168503E-09_JPRB, 0.51263072E-09_JPRB, &
  & 0.51353638E-09_JPRB, 0.51433319E-09_JPRB, 0.51486804E-09_JPRB, 0.51494814E-09_JPRB, 0.51443172E-09_JPRB, 0.51325733E-09_JPRB, &
  & 0.51142696E-09_JPRB, 0.50902349E-09_JPRB, 0.50613980E-09_JPRB, 0.50285470E-09_JPRB, 0.49924748E-09_JPRB, 0.49539733E-09_JPRB, &
  & 0.49137500E-09_JPRB, 0.48714288E-09_JPRB, 0.48272797E-09_JPRB, 0.47806553E-09_JPRB, 0.47324883E-09_JPRB, 0.46834508E-09_JPRB, &
  & 0.46338480E-09_JPRB, 0.45842855E-09_JPRB, 0.45350979E-09_JPRB, 0.44872212E-09_JPRB, 0.44414505E-09_JPRB, 0.43982346E-09_JPRB, &
  & 0.43574988E-09_JPRB, 0.43187873E-09_JPRB, 0.42815390E-09_JPRB, 0.42454901E-09_JPRB, 0.42107318E-09_JPRB, 0.41779247E-09_JPRB, &
  & 0.41477138E-09_JPRB, 0.41201290E-09_JPRB, 0.40926190E-09_JPRB, 0.40524387E-09_JPRB /)

RGHG6(:,34, 5) = (/ &
  & 0.38008721E-09_JPRB, 0.38436387E-09_JPRB, 0.38699965E-09_JPRB, 0.38970438E-09_JPRB, 0.39267434E-09_JPRB, 0.39623260E-09_JPRB, &
  & 0.40050396E-09_JPRB, 0.40548473E-09_JPRB, 0.41115319E-09_JPRB, 0.41748735E-09_JPRB, 0.42445886E-09_JPRB, 0.43204859E-09_JPRB, &
  & 0.44011411E-09_JPRB, 0.44851309E-09_JPRB, 0.45700416E-09_JPRB, 0.46540174E-09_JPRB, 0.47348775E-09_JPRB, 0.48103432E-09_JPRB, &
  & 0.48788884E-09_JPRB, 0.49396082E-09_JPRB, 0.49921428E-09_JPRB, 0.50364762E-09_JPRB, 0.50729931E-09_JPRB, 0.51023852E-09_JPRB, &
  & 0.51253635E-09_JPRB, 0.51428856E-09_JPRB, 0.51561611E-09_JPRB, 0.51662602E-09_JPRB, 0.51743426E-09_JPRB, 0.51809440E-09_JPRB, &
  & 0.51864890E-09_JPRB, 0.51907095E-09_JPRB, 0.51926358E-09_JPRB, 0.51909815E-09_JPRB, 0.51847177E-09_JPRB, 0.51735183E-09_JPRB, &
  & 0.51577032E-09_JPRB, 0.51375382E-09_JPRB, 0.51135934E-09_JPRB, 0.50863619E-09_JPRB, 0.50563198E-09_JPRB, 0.50240290E-09_JPRB, &
  & 0.49895121E-09_JPRB, 0.49529103E-09_JPRB, 0.49136245E-09_JPRB, 0.48717341E-09_JPRB, 0.48275434E-09_JPRB, 0.47818305E-09_JPRB, &
  & 0.47351739E-09_JPRB, 0.46877291E-09_JPRB, 0.46403104E-09_JPRB, 0.45938930E-09_JPRB, 0.45493731E-09_JPRB, 0.45073267E-09_JPRB, &
  & 0.44676568E-09_JPRB, 0.44299289E-09_JPRB, 0.43936277E-09_JPRB, 0.43585258E-09_JPRB, 0.43247311E-09_JPRB, 0.42927667E-09_JPRB, &
  & 0.42632700E-09_JPRB, 0.42360673E-09_JPRB, 0.42086745E-09_JPRB, 0.41681553E-09_JPRB /)

RGHG6(:,35, 5) = (/ &
  & 0.39037051E-09_JPRB, 0.39484749E-09_JPRB, 0.39778497E-09_JPRB, 0.40050774E-09_JPRB, 0.40352183E-09_JPRB, 0.40702258E-09_JPRB, &
  & 0.41109971E-09_JPRB, 0.41579715E-09_JPRB, 0.42108050E-09_JPRB, 0.42695569E-09_JPRB, 0.43344561E-09_JPRB, 0.44050222E-09_JPRB, &
  & 0.44805595E-09_JPRB, 0.45594231E-09_JPRB, 0.46399606E-09_JPRB, 0.47200155E-09_JPRB, 0.47974869E-09_JPRB, 0.48705195E-09_JPRB, &
  & 0.49372939E-09_JPRB, 0.49965654E-09_JPRB, 0.50479065E-09_JPRB, 0.50912446E-09_JPRB, 0.51268567E-09_JPRB, 0.51554289E-09_JPRB, &
  & 0.51776766E-09_JPRB, 0.51944599E-09_JPRB, 0.52068960E-09_JPRB, 0.52158661E-09_JPRB, 0.52223725E-09_JPRB, 0.52269034E-09_JPRB, &
  & 0.52299537E-09_JPRB, 0.52314930E-09_JPRB, 0.52309934E-09_JPRB, 0.52277305E-09_JPRB, 0.52210930E-09_JPRB, 0.52108184E-09_JPRB, &
  & 0.51970739E-09_JPRB, 0.51802485E-09_JPRB, 0.51604249E-09_JPRB, 0.51376403E-09_JPRB, 0.51121396E-09_JPRB, 0.50842291E-09_JPRB, &
  & 0.50541304E-09_JPRB, 0.50214405E-09_JPRB, 0.49862453E-09_JPRB, 0.49480553E-09_JPRB, 0.49074095E-09_JPRB, 0.48649290E-09_JPRB, &
  & 0.48208859E-09_JPRB, 0.47758569E-09_JPRB, 0.47304644E-09_JPRB, 0.46858556E-09_JPRB, 0.46430809E-09_JPRB, 0.46026399E-09_JPRB, &
  & 0.45644619E-09_JPRB, 0.45281301E-09_JPRB, 0.44931930E-09_JPRB, 0.44594531E-09_JPRB, 0.44270687E-09_JPRB, 0.43965259E-09_JPRB, &
  & 0.43682719E-09_JPRB, 0.43420528E-09_JPRB, 0.43153958E-09_JPRB, 0.42754017E-09_JPRB /)

RGHG6(:,36, 5) = (/ &
  & 0.40008707E-09_JPRB, 0.40495579E-09_JPRB, 0.40793963E-09_JPRB, 0.41078027E-09_JPRB, 0.41380638E-09_JPRB, 0.41721418E-09_JPRB, &
  & 0.42110954E-09_JPRB, 0.42549853E-09_JPRB, 0.43038392E-09_JPRB, 0.43579668E-09_JPRB, 0.44176812E-09_JPRB, 0.44829723E-09_JPRB, &
  & 0.45530957E-09_JPRB, 0.46268367E-09_JPRB, 0.47024429E-09_JPRB, 0.47783388E-09_JPRB, 0.48523424E-09_JPRB, 0.49225440E-09_JPRB, &
  & 0.49873461E-09_JPRB, 0.50452720E-09_JPRB, 0.50955495E-09_JPRB, 0.51379762E-09_JPRB, 0.51726945E-09_JPRB, 0.52002769E-09_JPRB, &
  & 0.52215082E-09_JPRB, 0.52372873E-09_JPRB, 0.52486820E-09_JPRB, 0.52565657E-09_JPRB, 0.52618021E-09_JPRB, 0.52648996E-09_JPRB, &
  & 0.52662724E-09_JPRB, 0.52661264E-09_JPRB, 0.52641858E-09_JPRB, 0.52601556E-09_JPRB, 0.52537574E-09_JPRB, 0.52448618E-09_JPRB, &
  & 0.52332721E-09_JPRB, 0.52190974E-09_JPRB, 0.52024807E-09_JPRB, 0.51830906E-09_JPRB, 0.51607774E-09_JPRB, 0.51358801E-09_JPRB, &
  & 0.51085142E-09_JPRB, 0.50788301E-09_JPRB, 0.50464743E-09_JPRB, 0.50114768E-09_JPRB, 0.49739035E-09_JPRB, 0.49341981E-09_JPRB, &
  & 0.48927856E-09_JPRB, 0.48500493E-09_JPRB, 0.48068383E-09_JPRB, 0.47643567E-09_JPRB, 0.47236248E-09_JPRB, 0.46851978E-09_JPRB, &
  & 0.46489032E-09_JPRB, 0.46143359E-09_JPRB, 0.45810841E-09_JPRB, 0.45490703E-09_JPRB, 0.45185150E-09_JPRB, 0.44898349E-09_JPRB, &
  & 0.44633622E-09_JPRB, 0.44386594E-09_JPRB, 0.44132956E-09_JPRB, 0.43747714E-09_JPRB /)

RGHG6(:,37, 5) = (/ &
  & 0.40943868E-09_JPRB, 0.41449710E-09_JPRB, 0.41763035E-09_JPRB, 0.42052195E-09_JPRB, 0.42356429E-09_JPRB, 0.42690754E-09_JPRB, &
  & 0.43061057E-09_JPRB, 0.43469317E-09_JPRB, 0.43917686E-09_JPRB, 0.44411755E-09_JPRB, 0.44957083E-09_JPRB, 0.45554854E-09_JPRB, &
  & 0.46200563E-09_JPRB, 0.46883891E-09_JPRB, 0.47589777E-09_JPRB, 0.48302906E-09_JPRB, 0.49005899E-09_JPRB, 0.49679050E-09_JPRB, &
  & 0.50306054E-09_JPRB, 0.50871585E-09_JPRB, 0.51364263E-09_JPRB, 0.51779764E-09_JPRB, 0.52115656E-09_JPRB, 0.52377136E-09_JPRB, &
  & 0.52572829E-09_JPRB, 0.52714383E-09_JPRB, 0.52813326E-09_JPRB, 0.52879612E-09_JPRB, 0.52920524E-09_JPRB, 0.52942001E-09_JPRB, &
  & 0.52946236E-09_JPRB, 0.52936727E-09_JPRB, 0.52912175E-09_JPRB, 0.52871396E-09_JPRB, 0.52813920E-09_JPRB, 0.52738458E-09_JPRB, &
  & 0.52645438E-09_JPRB, 0.52530735E-09_JPRB, 0.52391791E-09_JPRB, 0.52225713E-09_JPRB, 0.52028204E-09_JPRB, 0.51799431E-09_JPRB, &
  & 0.51544874E-09_JPRB, 0.51266691E-09_JPRB, 0.50966120E-09_JPRB, 0.50640303E-09_JPRB, 0.50290877E-09_JPRB, 0.49919474E-09_JPRB, &
  & 0.49528637E-09_JPRB, 0.49123366E-09_JPRB, 0.48713328E-09_JPRB, 0.48310506E-09_JPRB, 0.47926435E-09_JPRB, 0.47564896E-09_JPRB, &
  & 0.47223869E-09_JPRB, 0.46898774E-09_JPRB, 0.46586024E-09_JPRB, 0.46285925E-09_JPRB, 0.46001708E-09_JPRB, 0.45737267E-09_JPRB, &
  & 0.45494181E-09_JPRB, 0.45266546E-09_JPRB, 0.45030893E-09_JPRB, 0.44667781E-09_JPRB /)

RGHG6(:,38, 5) = (/ &
  & 0.41841611E-09_JPRB, 0.42357889E-09_JPRB, 0.42682263E-09_JPRB, 0.42976248E-09_JPRB, 0.43287673E-09_JPRB, 0.43615400E-09_JPRB, &
  & 0.43968285E-09_JPRB, 0.44346696E-09_JPRB, 0.44754564E-09_JPRB, 0.45200935E-09_JPRB, 0.45694210E-09_JPRB, 0.46236664E-09_JPRB, &
  & 0.46825793E-09_JPRB, 0.47453136E-09_JPRB, 0.48106175E-09_JPRB, 0.48771270E-09_JPRB, 0.49432891E-09_JPRB, 0.50074817E-09_JPRB, &
  & 0.50679372E-09_JPRB, 0.51230087E-09_JPRB, 0.51710913E-09_JPRB, 0.52111299E-09_JPRB, 0.52429122E-09_JPRB, 0.52666649E-09_JPRB, &
  & 0.52836935E-09_JPRB, 0.52955113E-09_JPRB, 0.53035043E-09_JPRB, 0.53087246E-09_JPRB, 0.53118338E-09_JPRB, 0.53133481E-09_JPRB, &
  & 0.53134330E-09_JPRB, 0.53122956E-09_JPRB, 0.53099786E-09_JPRB, 0.53064225E-09_JPRB, 0.53016297E-09_JPRB, 0.52955956E-09_JPRB, &
  & 0.52881888E-09_JPRB, 0.52792115E-09_JPRB, 0.52679977E-09_JPRB, 0.52540539E-09_JPRB, 0.52368848E-09_JPRB, 0.52163229E-09_JPRB, &
  & 0.51927196E-09_JPRB, 0.51665860E-09_JPRB, 0.51383153E-09_JPRB, 0.51078630E-09_JPRB, 0.50751658E-09_JPRB, 0.50402454E-09_JPRB, &
  & 0.50032622E-09_JPRB, 0.49647719E-09_JPRB, 0.49258253E-09_JPRB, 0.48878096E-09_JPRB, 0.48517829E-09_JPRB, 0.48180804E-09_JPRB, &
  & 0.47863796E-09_JPRB, 0.47561272E-09_JPRB, 0.47270421E-09_JPRB, 0.46992416E-09_JPRB, 0.46731791E-09_JPRB, 0.46491977E-09_JPRB, &
  & 0.46273127E-09_JPRB, 0.46067761E-09_JPRB, 0.45853238E-09_JPRB, 0.45518436E-09_JPRB /)

RGHG6(:,39, 5) = (/ &
  & 0.42702855E-09_JPRB, 0.43231149E-09_JPRB, 0.43550907E-09_JPRB, 0.43860526E-09_JPRB, 0.44172332E-09_JPRB, 0.44500864E-09_JPRB, &
  & 0.44837362E-09_JPRB, 0.45185733E-09_JPRB, 0.45553522E-09_JPRB, 0.45952867E-09_JPRB, 0.46393300E-09_JPRB, 0.46880866E-09_JPRB, &
  & 0.47413140E-09_JPRB, 0.47983795E-09_JPRB, 0.48582166E-09_JPRB, 0.49197202E-09_JPRB, 0.49815840E-09_JPRB, 0.50423066E-09_JPRB, &
  & 0.51001425E-09_JPRB, 0.51533122E-09_JPRB, 0.51995153E-09_JPRB, 0.52371940E-09_JPRB, 0.52659188E-09_JPRB, 0.52866167E-09_JPRB, &
  & 0.53007509E-09_JPRB, 0.53102323E-09_JPRB, 0.53165061E-09_JPRB, 0.53205568E-09_JPRB, 0.53229765E-09_JPRB, 0.53240889E-09_JPRB, &
  & 0.53241067E-09_JPRB, 0.53230481E-09_JPRB, 0.53210319E-09_JPRB, 0.53180249E-09_JPRB, 0.53141247E-09_JPRB, 0.53092752E-09_JPRB, &
  & 0.53034299E-09_JPRB, 0.52963200E-09_JPRB, 0.52875154E-09_JPRB, 0.52762705E-09_JPRB, 0.52619553E-09_JPRB, 0.52442289E-09_JPRB, &
  & 0.52231880E-09_JPRB, 0.51993404E-09_JPRB, 0.51730042E-09_JPRB, 0.51445564E-09_JPRB, 0.51138938E-09_JPRB, 0.50809978E-09_JPRB, &
  & 0.50459470E-09_JPRB, 0.50092880E-09_JPRB, 0.49722843E-09_JPRB, 0.49364102E-09_JPRB, 0.49027477E-09_JPRB, 0.48715421E-09_JPRB, &
  & 0.48422910E-09_JPRB, 0.48144189E-09_JPRB, 0.47876181E-09_JPRB, 0.47621651E-09_JPRB, 0.47385651E-09_JPRB, 0.47171705E-09_JPRB, &
  & 0.46977977E-09_JPRB, 0.46796089E-09_JPRB, 0.46604109E-09_JPRB, 0.46301551E-09_JPRB /)

RGHG6(:,40, 5) = (/ &
  & 0.43546908E-09_JPRB, 0.44055840E-09_JPRB, 0.44387477E-09_JPRB, 0.44692991E-09_JPRB, 0.45021725E-09_JPRB, 0.45345791E-09_JPRB, &
  & 0.45668372E-09_JPRB, 0.45987789E-09_JPRB, 0.46316159E-09_JPRB, 0.46667670E-09_JPRB, 0.47057019E-09_JPRB, 0.47489590E-09_JPRB, &
  & 0.47965931E-09_JPRB, 0.48480459E-09_JPRB, 0.49024312E-09_JPRB, 0.49587850E-09_JPRB, 0.50161109E-09_JPRB, 0.50731080E-09_JPRB, &
  & 0.51279936E-09_JPRB, 0.51783988E-09_JPRB, 0.52220683E-09_JPRB, 0.52565824E-09_JPRB, 0.52819304E-09_JPRB, 0.52995019E-09_JPRB, &
  & 0.53112026E-09_JPRB, 0.53188742E-09_JPRB, 0.53239213E-09_JPRB, 0.53271804E-09_JPRB, 0.53291566E-09_JPRB, 0.53300681E-09_JPRB, &
  & 0.53300553E-09_JPRB, 0.53291421E-09_JPRB, 0.53273613E-09_JPRB, 0.53247573E-09_JPRB, 0.53214361E-09_JPRB, 0.53174004E-09_JPRB, &
  & 0.53125798E-09_JPRB, 0.53068289E-09_JPRB, 0.52997862E-09_JPRB, 0.52908633E-09_JPRB, 0.52793625E-09_JPRB, 0.52647164E-09_JPRB, &
  & 0.52467841E-09_JPRB, 0.52257015E-09_JPRB, 0.52019228E-09_JPRB, 0.51755966E-09_JPRB, 0.51469745E-09_JPRB, 0.51159532E-09_JPRB, &
  & 0.50826687E-09_JPRB, 0.50477056E-09_JPRB, 0.50124555E-09_JPRB, 0.49785959E-09_JPRB, 0.49472004E-09_JPRB, 0.49183935E-09_JPRB, &
  & 0.48915566E-09_JPRB, 0.48660176E-09_JPRB, 0.48415361E-09_JPRB, 0.48184201E-09_JPRB, 0.47973159E-09_JPRB, 0.47784710E-09_JPRB, &
  & 0.47615878E-09_JPRB, 0.47457005E-09_JPRB, 0.47288196E-09_JPRB, 0.47018345E-09_JPRB /)

RGHG6(:,41, 5) = (/ &
  & 0.44365606E-09_JPRB, 0.44863926E-09_JPRB, 0.45176554E-09_JPRB, 0.45497711E-09_JPRB, 0.45825183E-09_JPRB, 0.46154652E-09_JPRB, &
  & 0.46461179E-09_JPRB, 0.46752036E-09_JPRB, 0.47040882E-09_JPRB, 0.47346815E-09_JPRB, 0.47684445E-09_JPRB, 0.48063953E-09_JPRB, &
  & 0.48486021E-09_JPRB, 0.48946208E-09_JPRB, 0.49436816E-09_JPRB, 0.49950455E-09_JPRB, 0.50477600E-09_JPRB, 0.51007226E-09_JPRB, &
  & 0.51521809E-09_JPRB, 0.51995236E-09_JPRB, 0.52397281E-09_JPRB, 0.52710070E-09_JPRB, 0.52931565E-09_JPRB, 0.53081084E-09_JPRB, &
  & 0.53179128E-09_JPRB, 0.53242932E-09_JPRB, 0.53284982E-09_JPRB, 0.53312443E-09_JPRB, 0.53329313E-09_JPRB, 0.53337434E-09_JPRB, &
  & 0.53337290E-09_JPRB, 0.53329308E-09_JPRB, 0.53313459E-09_JPRB, 0.53289956E-09_JPRB, 0.53260701E-09_JPRB, 0.53225541E-09_JPRB, &
  & 0.53184168E-09_JPRB, 0.53135862E-09_JPRB, 0.53077853E-09_JPRB, 0.53005944E-09_JPRB, 0.52914345E-09_JPRB, 0.52797522E-09_JPRB, &
  & 0.52650934E-09_JPRB, 0.52472127E-09_JPRB, 0.52262461E-09_JPRB, 0.52024091E-09_JPRB, 0.51758225E-09_JPRB, 0.51466653E-09_JPRB, &
  & 0.51150745E-09_JPRB, 0.50816706E-09_JPRB, 0.50480303E-09_JPRB, 0.50160182E-09_JPRB, 0.49867399E-09_JPRB, 0.49601823E-09_JPRB, &
  & 0.49356330E-09_JPRB, 0.49123428E-09_JPRB, 0.48900672E-09_JPRB, 0.48692439E-09_JPRB, 0.48505200E-09_JPRB, 0.48341020E-09_JPRB, &
  & 0.48195348E-09_JPRB, 0.48058235E-09_JPRB, 0.47910886E-09_JPRB, 0.47673260E-09_JPRB /)

RGHG6(:,42, 5) = (/ &
  & 0.45175050E-09_JPRB, 0.45641013E-09_JPRB, 0.45948798E-09_JPRB, 0.46260221E-09_JPRB, 0.46599341E-09_JPRB, 0.46924903E-09_JPRB, &
  & 0.47216303E-09_JPRB, 0.47478466E-09_JPRB, 0.47729842E-09_JPRB, 0.47990456E-09_JPRB, 0.48278637E-09_JPRB, 0.48606075E-09_JPRB, &
  & 0.48976267E-09_JPRB, 0.49385174E-09_JPRB, 0.49825682E-09_JPRB, 0.50290538E-09_JPRB, 0.50772891E-09_JPRB, 0.51260934E-09_JPRB, &
  & 0.51737592E-09_JPRB, 0.52174942E-09_JPRB, 0.52542282E-09_JPRB, 0.52820498E-09_JPRB, 0.53014471E-09_JPRB, 0.53142568E-09_JPRB, &
  & 0.53225979E-09_JPRB, 0.53280380E-09_JPRB, 0.53316440E-09_JPRB, 0.53340415E-09_JPRB, 0.53355403E-09_JPRB, 0.53362881E-09_JPRB, &
  & 0.53363058E-09_JPRB, 0.53355831E-09_JPRB, 0.53341709E-09_JPRB, 0.53319998E-09_JPRB, 0.53293492E-09_JPRB, 0.53261934E-09_JPRB, &
  & 0.53225285E-09_JPRB, 0.53183236E-09_JPRB, 0.53134197E-09_JPRB, 0.53074800E-09_JPRB, 0.53001237E-09_JPRB, 0.52908927E-09_JPRB, &
  & 0.52793098E-09_JPRB, 0.52648635E-09_JPRB, 0.52470972E-09_JPRB, 0.52260735E-09_JPRB, 0.52018367E-09_JPRB, 0.51745813E-09_JPRB, &
  & 0.51446675E-09_JPRB, 0.51127891E-09_JPRB, 0.50806198E-09_JPRB, 0.50503440E-09_JPRB, 0.50230214E-09_JPRB, 0.49985777E-09_JPRB, &
  & 0.49761484E-09_JPRB, 0.49549564E-09_JPRB, 0.49347620E-09_JPRB, 0.49160642E-09_JPRB, 0.48995413E-09_JPRB, 0.48853105E-09_JPRB, &
  & 0.48728066E-09_JPRB, 0.48610255E-09_JPRB, 0.48482568E-09_JPRB, 0.48274001E-09_JPRB /)

RGHG6(:,43, 5) = (/ &
  & 0.45971771E-09_JPRB, 0.46408766E-09_JPRB, 0.46694443E-09_JPRB, 0.47001930E-09_JPRB, 0.47339338E-09_JPRB, 0.47660681E-09_JPRB, &
  & 0.47935128E-09_JPRB, 0.48168669E-09_JPRB, 0.48384013E-09_JPRB, 0.48602700E-09_JPRB, 0.48843818E-09_JPRB, 0.49121474E-09_JPRB, &
  & 0.49442467E-09_JPRB, 0.49803778E-09_JPRB, 0.50197563E-09_JPRB, 0.50617344E-09_JPRB, 0.51054716E-09_JPRB, 0.51500648E-09_JPRB, &
  & 0.51935950E-09_JPRB, 0.52334748E-09_JPRB, 0.52663857E-09_JPRB, 0.52909982E-09_JPRB, 0.53078680E-09_JPRB, 0.53189442E-09_JPRB, &
  & 0.53261234E-09_JPRB, 0.53308485E-09_JPRB, 0.53340166E-09_JPRB, 0.53361593E-09_JPRB, 0.53375337E-09_JPRB, 0.53382410E-09_JPRB, &
  & 0.53383031E-09_JPRB, 0.53376520E-09_JPRB, 0.53363730E-09_JPRB, 0.53343618E-09_JPRB, 0.53318999E-09_JPRB, 0.53290194E-09_JPRB, &
  & 0.53256793E-09_JPRB, 0.53219407E-09_JPRB, 0.53176635E-09_JPRB, 0.53126753E-09_JPRB, 0.53066901E-09_JPRB, 0.52994253E-09_JPRB, &
  & 0.52904947E-09_JPRB, 0.52792754E-09_JPRB, 0.52651122E-09_JPRB, 0.52473575E-09_JPRB, 0.52258897E-09_JPRB, 0.52008842E-09_JPRB, &
  & 0.51727589E-09_JPRB, 0.51424004E-09_JPRB, 0.51117366E-09_JPRB, 0.50830529E-09_JPRB, 0.50576110E-09_JPRB, 0.50351090E-09_JPRB, &
  & 0.50146703E-09_JPRB, 0.49954174E-09_JPRB, 0.49771370E-09_JPRB, 0.49603732E-09_JPRB, 0.49458015E-09_JPRB, 0.49334653E-09_JPRB, &
  & 0.49227200E-09_JPRB, 0.49125998E-09_JPRB, 0.49015020E-09_JPRB, 0.48832033E-09_JPRB /)

RGHG6(:,44, 5) = (/ &
  & 0.46759951E-09_JPRB, 0.47155646E-09_JPRB, 0.47428061E-09_JPRB, 0.47718163E-09_JPRB, 0.48049947E-09_JPRB, 0.48363891E-09_JPRB, &
  & 0.48618026E-09_JPRB, 0.48824766E-09_JPRB, 0.49007021E-09_JPRB, 0.49187510E-09_JPRB, 0.49385218E-09_JPRB, 0.49617266E-09_JPRB, &
  & 0.49892146E-09_JPRB, 0.50209586E-09_JPRB, 0.50561616E-09_JPRB, 0.50938087E-09_JPRB, 0.51333110E-09_JPRB, 0.51734034E-09_JPRB, &
  & 0.52126203E-09_JPRB, 0.52479554E-09_JPRB, 0.52770738E-09_JPRB, 0.52984250E-09_JPRB, 0.53130761E-09_JPRB, 0.53226668E-09_JPRB, &
  & 0.53289217E-09_JPRB, 0.53330806E-09_JPRB, 0.53359206E-09_JPRB, 0.53378757E-09_JPRB, 0.53391686E-09_JPRB, 0.53398569E-09_JPRB, &
  & 0.53399613E-09_JPRB, 0.53393845E-09_JPRB, 0.53382188E-09_JPRB, 0.53363447E-09_JPRB, 0.53340377E-09_JPRB, 0.53313542E-09_JPRB, &
  & 0.53282656E-09_JPRB, 0.53248467E-09_JPRB, 0.53210553E-09_JPRB, 0.53167604E-09_JPRB, 0.53118504E-09_JPRB, 0.53061494E-09_JPRB, &
  & 0.52993876E-09_JPRB, 0.52910865E-09_JPRB, 0.52803839E-09_JPRB, 0.52663873E-09_JPRB, 0.52483812E-09_JPRB, 0.52261551E-09_JPRB, &
  & 0.52001647E-09_JPRB, 0.51714832E-09_JPRB, 0.51423266E-09_JPRB, 0.51153509E-09_JPRB, 0.50916449E-09_JPRB, 0.50710591E-09_JPRB, &
  & 0.50524451E-09_JPRB, 0.50349991E-09_JPRB, 0.50184790E-09_JPRB, 0.50034354E-09_JPRB, 0.49905607E-09_JPRB, 0.49797966E-09_JPRB, &
  & 0.49705401E-09_JPRB, 0.49617666E-09_JPRB, 0.49521243E-09_JPRB, 0.49359672E-09_JPRB /)

RGHG6(:,45, 5) = (/ &
  & 0.47519788E-09_JPRB, 0.47893656E-09_JPRB, 0.48133941E-09_JPRB, 0.48414089E-09_JPRB, 0.48732662E-09_JPRB, 0.49032778E-09_JPRB, &
  & 0.49267934E-09_JPRB, 0.49448873E-09_JPRB, 0.49602161E-09_JPRB, 0.49749554E-09_JPRB, 0.49910581E-09_JPRB, 0.50100357E-09_JPRB, &
  & 0.50334070E-09_JPRB, 0.50611521E-09_JPRB, 0.50924331E-09_JPRB, 0.51262561E-09_JPRB, 0.51613464E-09_JPRB, 0.51969323E-09_JPRB, &
  & 0.52309757E-09_JPRB, 0.52616755E-09_JPRB, 0.52863636E-09_JPRB, 0.53047822E-09_JPRB, 0.53173460E-09_JPRB, 0.53257043E-09_JPRB, &
  & 0.53312021E-09_JPRB, 0.53349158E-09_JPRB, 0.53375043E-09_JPRB, 0.53393279E-09_JPRB, 0.53405663E-09_JPRB, 0.53412558E-09_JPRB, &
  & 0.53413995E-09_JPRB, 0.53408999E-09_JPRB, 0.53398291E-09_JPRB, 0.53380822E-09_JPRB, 0.53358995E-09_JPRB, 0.53333682E-09_JPRB, &
  & 0.53304511E-09_JPRB, 0.53272831E-09_JPRB, 0.53238314E-09_JPRB, 0.53200883E-09_JPRB, 0.53159899E-09_JPRB, 0.53115051E-09_JPRB, &
  & 0.53064936E-09_JPRB, 0.53005295E-09_JPRB, 0.52929605E-09_JPRB, 0.52826976E-09_JPRB, 0.52686394E-09_JPRB, 0.52500604E-09_JPRB, &
  & 0.52267957E-09_JPRB, 0.52002558E-09_JPRB, 0.51729865E-09_JPRB, 0.51476395E-09_JPRB, 0.51259069E-09_JPRB, 0.51070326E-09_JPRB, &
  & 0.50902627E-09_JPRB, 0.50744975E-09_JPRB, 0.50595966E-09_JPRB, 0.50461069E-09_JPRB, 0.50346560E-09_JPRB, 0.50252502E-09_JPRB, &
  & 0.50171567E-09_JPRB, 0.50095578E-09_JPRB, 0.50010684E-09_JPRB, 0.49868054E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART9',1,ZHOOK_HANDLE)
END SUBROUTINE PART9




SUBROUTINE PART10
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART10',0,ZHOOK_HANDLE)



RGHG6(:,46, 5) = (/ &
  & 0.48265325E-09_JPRB, 0.48589666E-09_JPRB, 0.48827492E-09_JPRB, 0.49077464E-09_JPRB, 0.49386251E-09_JPRB, 0.49671689E-09_JPRB, &
  & 0.49886018E-09_JPRB, 0.50044824E-09_JPRB, 0.50173488E-09_JPRB, 0.50294485E-09_JPRB, 0.50423593E-09_JPRB, 0.50580434E-09_JPRB, &
  & 0.50775284E-09_JPRB, 0.51016896E-09_JPRB, 0.51295129E-09_JPRB, 0.51594123E-09_JPRB, 0.51903071E-09_JPRB, 0.52206278E-09_JPRB, &
  & 0.52492583E-09_JPRB, 0.52741866E-09_JPRB, 0.52947935E-09_JPRB, 0.53100935E-09_JPRB, 0.53209226E-09_JPRB, 0.53281962E-09_JPRB, &
  & 0.53330867E-09_JPRB, 0.53364513E-09_JPRB, 0.53388494E-09_JPRB, 0.53405813E-09_JPRB, 0.53417909E-09_JPRB, 0.53424964E-09_JPRB, &
  & 0.53426819E-09_JPRB, 0.53422600E-09_JPRB, 0.53412741E-09_JPRB, 0.53396365E-09_JPRB, 0.53375615E-09_JPRB, 0.53351379E-09_JPRB, &
  & 0.53323557E-09_JPRB, 0.53293525E-09_JPRB, 0.53261795E-09_JPRB, 0.53228355E-09_JPRB, 0.53193860E-09_JPRB, 0.53158378E-09_JPRB, &
  & 0.53121163E-09_JPRB, 0.53079929E-09_JPRB, 0.53028482E-09_JPRB, 0.52958210E-09_JPRB, 0.52857574E-09_JPRB, 0.52713156E-09_JPRB, &
  & 0.52519772E-09_JPRB, 0.52283933E-09_JPRB, 0.52033278E-09_JPRB, 0.51802557E-09_JPRB, 0.51601834E-09_JPRB, 0.51433924E-09_JPRB, &
  & 0.51282217E-09_JPRB, 0.51141363E-09_JPRB, 0.51007371E-09_JPRB, 0.50886312E-09_JPRB, 0.50784627E-09_JPRB, 0.50701421E-09_JPRB, &
  & 0.50630844E-09_JPRB, 0.50563920E-09_JPRB, 0.50489496E-09_JPRB, 0.50362647E-09_JPRB /)

RGHG6(:,47, 5) = (/ &
  & 0.48959725E-09_JPRB, 0.49275062E-09_JPRB, 0.49475224E-09_JPRB, 0.49724425E-09_JPRB, 0.50008786E-09_JPRB, 0.50280435E-09_JPRB, &
  & 0.50477666E-09_JPRB, 0.50617061E-09_JPRB, 0.50726678E-09_JPRB, 0.50825810E-09_JPRB, 0.50932247E-09_JPRB, 0.51058380E-09_JPRB, &
  & 0.51223836E-09_JPRB, 0.51431581E-09_JPRB, 0.51675753E-09_JPRB, 0.51937638E-09_JPRB, 0.52197868E-09_JPRB, 0.52443694E-09_JPRB, &
  & 0.52664717E-09_JPRB, 0.52858967E-09_JPRB, 0.53019406E-09_JPRB, 0.53146659E-09_JPRB, 0.53238502E-09_JPRB, 0.53302590E-09_JPRB, &
  & 0.53346555E-09_JPRB, 0.53377480E-09_JPRB, 0.53400045E-09_JPRB, 0.53416782E-09_JPRB, 0.53428761E-09_JPRB, 0.53436111E-09_JPRB, &
  & 0.53438415E-09_JPRB, 0.53434951E-09_JPRB, 0.53425864E-09_JPRB, 0.53410476E-09_JPRB, 0.53390642E-09_JPRB, 0.53367211E-09_JPRB, &
  & 0.53340271E-09_JPRB, 0.53311622E-09_JPRB, 0.53281796E-09_JPRB, 0.53251736E-09_JPRB, 0.53222082E-09_JPRB, 0.53193583E-09_JPRB, &
  & 0.53166183E-09_JPRB, 0.53137594E-09_JPRB, 0.53103993E-09_JPRB, 0.53058186E-09_JPRB, 0.52990423E-09_JPRB, 0.52889215E-09_JPRB, &
  & 0.52741639E-09_JPRB, 0.52547805E-09_JPRB, 0.52331017E-09_JPRB, 0.52122723E-09_JPRB, 0.51946997E-09_JPRB, 0.51795424E-09_JPRB, &
  & 0.51662835E-09_JPRB, 0.51536575E-09_JPRB, 0.51416932E-09_JPRB, 0.51308519E-09_JPRB, 0.51217858E-09_JPRB, 0.51144422E-09_JPRB, &
  & 0.51082139E-09_JPRB, 0.51023319E-09_JPRB, 0.50957377E-09_JPRB, 0.50844406E-09_JPRB /)

RGHG6(:,48, 5) = (/ &
  & 0.49627785E-09_JPRB, 0.49906845E-09_JPRB, 0.50110727E-09_JPRB, 0.50331217E-09_JPRB, 0.50612281E-09_JPRB, 0.50867832E-09_JPRB, &
  & 0.51051091E-09_JPRB, 0.51175814E-09_JPRB, 0.51269822E-09_JPRB, 0.51353022E-09_JPRB, 0.51439319E-09_JPRB, 0.51544330E-09_JPRB, &
  & 0.51680166E-09_JPRB, 0.51858073E-09_JPRB, 0.52065730E-09_JPRB, 0.52282001E-09_JPRB, 0.52484317E-09_JPRB, 0.52664140E-09_JPRB, &
  & 0.52820370E-09_JPRB, 0.52958804E-09_JPRB, 0.53081511E-09_JPRB, 0.53183541E-09_JPRB, 0.53262622E-09_JPRB, 0.53319493E-09_JPRB, &
  & 0.53359644E-09_JPRB, 0.53388549E-09_JPRB, 0.53410087E-09_JPRB, 0.53426463E-09_JPRB, 0.53438520E-09_JPRB, 0.53446203E-09_JPRB, &
  & 0.53448990E-09_JPRB, 0.53446275E-09_JPRB, 0.53437871E-09_JPRB, 0.53423393E-09_JPRB, 0.53404359E-09_JPRB, 0.53381460E-09_JPRB, &
  & 0.53355298E-09_JPRB, 0.53327570E-09_JPRB, 0.53299409E-09_JPRB, 0.53271776E-09_JPRB, 0.53245947E-09_JPRB, 0.53222760E-09_JPRB, &
  & 0.53202076E-09_JPRB, 0.53182680E-09_JPRB, 0.53160776E-09_JPRB, 0.53131655E-09_JPRB, 0.53088550E-09_JPRB, 0.53022076E-09_JPRB, &
  & 0.52921029E-09_JPRB, 0.52779192E-09_JPRB, 0.52606886E-09_JPRB, 0.52436205E-09_JPRB, 0.52285065E-09_JPRB, 0.52156457E-09_JPRB, &
  & 0.52039345E-09_JPRB, 0.51928650E-09_JPRB, 0.51821397E-09_JPRB, 0.51724297E-09_JPRB, 0.51643445E-09_JPRB, 0.51578325E-09_JPRB, &
  & 0.51523202E-09_JPRB, 0.51471044E-09_JPRB, 0.51412208E-09_JPRB, 0.51311017E-09_JPRB /)

RGHG6(:,49, 5) = (/ &
  & 0.50249238E-09_JPRB, 0.50518689E-09_JPRB, 0.50706184E-09_JPRB, 0.50926963E-09_JPRB, 0.51193805E-09_JPRB, 0.51441651E-09_JPRB, &
  & 0.51612625E-09_JPRB, 0.51724930E-09_JPRB, 0.51805688E-09_JPRB, 0.51874871E-09_JPRB, 0.51944155E-09_JPRB, 0.52027666E-09_JPRB, &
  & 0.52136656E-09_JPRB, 0.52276666E-09_JPRB, 0.52437993E-09_JPRB, 0.52593491E-09_JPRB, 0.52731480E-09_JPRB, 0.52846139E-09_JPRB, &
  & 0.52947774E-09_JPRB, 0.53040816E-09_JPRB, 0.53131194E-09_JPRB, 0.53213622E-09_JPRB, 0.53281690E-09_JPRB, 0.53333227E-09_JPRB, &
  & 0.53370619E-09_JPRB, 0.53398086E-09_JPRB, 0.53418964E-09_JPRB, 0.53435151E-09_JPRB, 0.53447341E-09_JPRB, 0.53455418E-09_JPRB, &
  & 0.53458726E-09_JPRB, 0.53456706E-09_JPRB, 0.53448956E-09_JPRB, 0.53435306E-09_JPRB, 0.53416926E-09_JPRB, 0.53394505E-09_JPRB, &
  & 0.53368926E-09_JPRB, 0.53342025E-09_JPRB, 0.53315063E-09_JPRB, 0.53289423E-09_JPRB, 0.53266436E-09_JPRB, 0.53247112E-09_JPRB, &
  & 0.53231597E-09_JPRB, 0.53218063E-09_JPRB, 0.53204102E-09_JPRB, 0.53185595E-09_JPRB, 0.53158550E-09_JPRB, 0.53116700E-09_JPRB, &
  & 0.53052851E-09_JPRB, 0.52959781E-09_JPRB, 0.52843346E-09_JPRB, 0.52720522E-09_JPRB, 0.52604893E-09_JPRB, 0.52502958E-09_JPRB, &
  & 0.52405691E-09_JPRB, 0.52310128E-09_JPRB, 0.52215549E-09_JPRB, 0.52128873E-09_JPRB, 0.52056731E-09_JPRB, 0.51999016E-09_JPRB, &
  & 0.51949983E-09_JPRB, 0.51903565E-09_JPRB, 0.51850385E-09_JPRB, 0.51758553E-09_JPRB /)

RGHG6(:,50, 5) = (/ &
  & 0.50826110E-09_JPRB, 0.51098542E-09_JPRB, 0.51276061E-09_JPRB, 0.51495180E-09_JPRB, 0.51750532E-09_JPRB, 0.51982701E-09_JPRB, &
  & 0.52135751E-09_JPRB, 0.52230292E-09_JPRB, 0.52296262E-09_JPRB, 0.52347771E-09_JPRB, 0.52400628E-09_JPRB, 0.52458626E-09_JPRB, &
  & 0.52535487E-09_JPRB, 0.52630700E-09_JPRB, 0.52733479E-09_JPRB, 0.52830823E-09_JPRB, 0.52911497E-09_JPRB, 0.52981147E-09_JPRB, &
  & 0.53042204E-09_JPRB, 0.53105598E-09_JPRB, 0.53170396E-09_JPRB, 0.53236920E-09_JPRB, 0.53296678E-09_JPRB, 0.53344318E-09_JPRB, &
  & 0.53379939E-09_JPRB, 0.53406513E-09_JPRB, 0.53426985E-09_JPRB, 0.53443072E-09_JPRB, 0.53455451E-09_JPRB, 0.53463906E-09_JPRB, &
  & 0.53467769E-09_JPRB, 0.53466365E-09_JPRB, 0.53459248E-09_JPRB, 0.53446358E-09_JPRB, 0.53428517E-09_JPRB, 0.53406557E-09_JPRB, &
  & 0.53381521E-09_JPRB, 0.53355276E-09_JPRB, 0.53329297E-09_JPRB, 0.53305094E-09_JPRB, 0.53284283E-09_JPRB, 0.53268062E-09_JPRB, &
  & 0.53256088E-09_JPRB, 0.53247001E-09_JPRB, 0.53237820E-09_JPRB, 0.53226157E-09_JPRB, 0.53208749E-09_JPRB, 0.53182686E-09_JPRB, &
  & 0.53143001E-09_JPRB, 0.53087590E-09_JPRB, 0.53018423E-09_JPRB, 0.52942717E-09_JPRB, 0.52872973E-09_JPRB, 0.52801918E-09_JPRB, &
  & 0.52733540E-09_JPRB, 0.52659588E-09_JPRB, 0.52583071E-09_JPRB, 0.52509624E-09_JPRB, 0.52448335E-09_JPRB, 0.52398086E-09_JPRB, &
  & 0.52355842E-09_JPRB, 0.52314081E-09_JPRB, 0.52266763E-09_JPRB, 0.52180799E-09_JPRB /)

RGHG6(:,51, 5) = (/ &
  & 0.51373727E-09_JPRB, 0.51615501E-09_JPRB, 0.51811111E-09_JPRB, 0.52001098E-09_JPRB, 0.52241489E-09_JPRB, 0.52433707E-09_JPRB, &
  & 0.52552035E-09_JPRB, 0.52621330E-09_JPRB, 0.52664917E-09_JPRB, 0.52700888E-09_JPRB, 0.52731708E-09_JPRB, 0.52769672E-09_JPRB, &
  & 0.52813609E-09_JPRB, 0.52869209E-09_JPRB, 0.52929261E-09_JPRB, 0.52983895E-09_JPRB, 0.53031790E-09_JPRB, 0.53072230E-09_JPRB, &
  & 0.53112625E-09_JPRB, 0.53153459E-09_JPRB, 0.53202248E-09_JPRB, 0.53255367E-09_JPRB, 0.53308202E-09_JPRB, 0.53353355E-09_JPRB, &
  & 0.53388011E-09_JPRB, 0.53414162E-09_JPRB, 0.53434435E-09_JPRB, 0.53450488E-09_JPRB, 0.53463023E-09_JPRB, 0.53471816E-09_JPRB, &
  & 0.53476190E-09_JPRB, 0.53475380E-09_JPRB, 0.53468896E-09_JPRB, 0.53456645E-09_JPRB, 0.53439347E-09_JPRB, 0.53417798E-09_JPRB, &
  & 0.53393290E-09_JPRB, 0.53367621E-09_JPRB, 0.53342375E-09_JPRB, 0.53319282E-09_JPRB, 0.53300231E-09_JPRB, 0.53286336E-09_JPRB, &
  & 0.53277383E-09_JPRB, 0.53271132E-09_JPRB, 0.53265392E-09_JPRB, 0.53257621E-09_JPRB, 0.53246407E-09_JPRB, 0.53229221E-09_JPRB, &
  & 0.53204940E-09_JPRB, 0.53172039E-09_JPRB, 0.53133309E-09_JPRB, 0.53095117E-09_JPRB, 0.53055754E-09_JPRB, 0.53020155E-09_JPRB, &
  & 0.52980231E-09_JPRB, 0.52936644E-09_JPRB, 0.52886273E-09_JPRB, 0.52835619E-09_JPRB, 0.52789539E-09_JPRB, 0.52752136E-09_JPRB, &
  & 0.52717608E-09_JPRB, 0.52684518E-09_JPRB, 0.52641663E-09_JPRB, 0.52566917E-09_JPRB /)

RGHG6(:,52, 5) = (/ &
  & 0.51830235E-09_JPRB, 0.52095744E-09_JPRB, 0.52239069E-09_JPRB, 0.52428478E-09_JPRB, 0.52606675E-09_JPRB, 0.52749666E-09_JPRB, &
  & 0.52827348E-09_JPRB, 0.52869531E-09_JPRB, 0.52897065E-09_JPRB, 0.52916282E-09_JPRB, 0.52936239E-09_JPRB, 0.52955473E-09_JPRB, &
  & 0.52981797E-09_JPRB, 0.53012922E-09_JPRB, 0.53047361E-09_JPRB, 0.53080446E-09_JPRB, 0.53109139E-09_JPRB, 0.53136190E-09_JPRB, &
  & 0.53161775E-09_JPRB, 0.53192206E-09_JPRB, 0.53227217E-09_JPRB, 0.53270610E-09_JPRB, 0.53317889E-09_JPRB, 0.53360860E-09_JPRB, &
  & 0.53395227E-09_JPRB, 0.53421290E-09_JPRB, 0.53441490E-09_JPRB, 0.53457533E-09_JPRB, 0.53470173E-09_JPRB, 0.53479238E-09_JPRB, &
  & 0.53484073E-09_JPRB, 0.53483817E-09_JPRB, 0.53477933E-09_JPRB, 0.53466298E-09_JPRB, 0.53449467E-09_JPRB, 0.53428389E-09_JPRB, &
  & 0.53404348E-09_JPRB, 0.53379162E-09_JPRB, 0.53354510E-09_JPRB, 0.53332372E-09_JPRB, 0.53314736E-09_JPRB, 0.53302962E-09_JPRB, &
  & 0.53296140E-09_JPRB, 0.53292204E-09_JPRB, 0.53288501E-09_JPRB, 0.53283489E-09_JPRB, 0.53275595E-09_JPRB, 0.53264260E-09_JPRB, &
  & 0.53248206E-09_JPRB, 0.53228610E-09_JPRB, 0.53207805E-09_JPRB, 0.53187077E-09_JPRB, 0.53169946E-09_JPRB, 0.53152094E-09_JPRB, &
  & 0.53134697E-09_JPRB, 0.53113702E-09_JPRB, 0.53088905E-09_JPRB, 0.53060989E-09_JPRB, 0.53035698E-09_JPRB, 0.53012167E-09_JPRB, &
  & 0.52991572E-09_JPRB, 0.52967802E-09_JPRB, 0.52939275E-09_JPRB, 0.52876153E-09_JPRB /)

RGHG6(:,53, 5) = (/ &
  & 0.52241383E-09_JPRB, 0.52437121E-09_JPRB, 0.52592458E-09_JPRB, 0.52714916E-09_JPRB, 0.52855087E-09_JPRB, 0.52944926E-09_JPRB, &
  & 0.52992771E-09_JPRB, 0.53017857E-09_JPRB, 0.53032873E-09_JPRB, 0.53045179E-09_JPRB, 0.53055138E-09_JPRB, 0.53067745E-09_JPRB, &
  & 0.53081806E-09_JPRB, 0.53100846E-09_JPRB, 0.53122179E-09_JPRB, 0.53142990E-09_JPRB, 0.53162597E-09_JPRB, 0.53180482E-09_JPRB, &
  & 0.53200000E-09_JPRB, 0.53221166E-09_JPRB, 0.53249138E-09_JPRB, 0.53284521E-09_JPRB, 0.53326099E-09_JPRB, 0.53367838E-09_JPRB, &
  & 0.53401894E-09_JPRB, 0.53428018E-09_JPRB, 0.53448240E-09_JPRB, 0.53464272E-09_JPRB, 0.53477001E-09_JPRB, 0.53486277E-09_JPRB, &
  & 0.53491495E-09_JPRB, 0.53491744E-09_JPRB, 0.53486410E-09_JPRB, 0.53475335E-09_JPRB, 0.53459037E-09_JPRB, 0.53438381E-09_JPRB, &
  & 0.53414784E-09_JPRB, 0.53390015E-09_JPRB, 0.53365917E-09_JPRB, 0.53344634E-09_JPRB, 0.53328364E-09_JPRB, 0.53318244E-09_JPRB, &
  & 0.53313320E-09_JPRB, 0.53310933E-09_JPRB, 0.53308863E-09_JPRB, 0.53305405E-09_JPRB, 0.53299931E-09_JPRB, 0.53291543E-09_JPRB, &
  & 0.53280802E-09_JPRB, 0.53268334E-09_JPRB, 0.53256000E-09_JPRB, 0.53245997E-09_JPRB, 0.53236843E-09_JPRB, 0.53229399E-09_JPRB, &
  & 0.53221472E-09_JPRB, 0.53212418E-09_JPRB, 0.53201132E-09_JPRB, 0.53188509E-09_JPRB, 0.53175653E-09_JPRB, 0.53164873E-09_JPRB, &
  & 0.53153698E-09_JPRB, 0.53142557E-09_JPRB, 0.53125404E-09_JPRB, 0.53089916E-09_JPRB /)

RGHG6(:,54, 5) = (/ &
  & 0.52545007E-09_JPRB, 0.52726618E-09_JPRB, 0.52814131E-09_JPRB, 0.52919413E-09_JPRB, 0.53006355E-09_JPRB, 0.53065652E-09_JPRB, &
  & 0.53093829E-09_JPRB, 0.53108551E-09_JPRB, 0.53117843E-09_JPRB, 0.53124405E-09_JPRB, 0.53131216E-09_JPRB, 0.53137822E-09_JPRB, &
  & 0.53147220E-09_JPRB, 0.53158872E-09_JPRB, 0.53172872E-09_JPRB, 0.53187266E-09_JPRB, 0.53200822E-09_JPRB, 0.53214561E-09_JPRB, &
  & 0.53228522E-09_JPRB, 0.53245974E-09_JPRB, 0.53267768E-09_JPRB, 0.53297317E-09_JPRB, 0.53335325E-09_JPRB, 0.53374410E-09_JPRB, &
  & 0.53408344E-09_JPRB, 0.53434412E-09_JPRB, 0.53454630E-09_JPRB, 0.53470722E-09_JPRB, 0.53483523E-09_JPRB, 0.53493004E-09_JPRB, &
  & 0.53498522E-09_JPRB, 0.53499177E-09_JPRB, 0.53494337E-09_JPRB, 0.53483801E-09_JPRB, 0.53468047E-09_JPRB, 0.53447879E-09_JPRB, &
  & 0.53424654E-09_JPRB, 0.53400295E-09_JPRB, 0.53376736E-09_JPRB, 0.53356364E-09_JPRB, 0.53341359E-09_JPRB, 0.53332744E-09_JPRB, &
  & 0.53329163E-09_JPRB, 0.53328086E-09_JPRB, 0.53327115E-09_JPRB, 0.53324922E-09_JPRB, 0.53320709E-09_JPRB, 0.53314492E-09_JPRB, &
  & 0.53306387E-09_JPRB, 0.53297911E-09_JPRB, 0.53290516E-09_JPRB, 0.53284388E-09_JPRB, 0.53280069E-09_JPRB, 0.53276233E-09_JPRB, &
  & 0.53272636E-09_JPRB, 0.53268479E-09_JPRB, 0.53263238E-09_JPRB, 0.53257038E-09_JPRB, 0.53251381E-09_JPRB, 0.53246030E-09_JPRB, &
  & 0.53241611E-09_JPRB, 0.53236793E-09_JPRB, 0.53232124E-09_JPRB, 0.53225502E-09_JPRB /)

RGHG6(:,55, 5) = (/ &
  & 0.52767712E-09_JPRB, 0.52898430E-09_JPRB, 0.52981658E-09_JPRB, 0.53044835E-09_JPRB, 0.53106086E-09_JPRB, 0.53142235E-09_JPRB, &
  & 0.53160032E-09_JPRB, 0.53168997E-09_JPRB, 0.53174465E-09_JPRB, 0.53178884E-09_JPRB, 0.53182642E-09_JPRB, 0.53187355E-09_JPRB, &
  & 0.53192900E-09_JPRB, 0.53200827E-09_JPRB, 0.53210436E-09_JPRB, 0.53220578E-09_JPRB, 0.53230820E-09_JPRB, 0.53240978E-09_JPRB, &
  & 0.53252575E-09_JPRB, 0.53266175E-09_JPRB, 0.53284771E-09_JPRB, 0.53310834E-09_JPRB, 0.53344196E-09_JPRB, 0.53381954E-09_JPRB, &
  & 0.53414689E-09_JPRB, 0.53440580E-09_JPRB, 0.53460769E-09_JPRB, 0.53476917E-09_JPRB, 0.53489824E-09_JPRB, 0.53499449E-09_JPRB, &
  & 0.53505173E-09_JPRB, 0.53506144E-09_JPRB, 0.53501753E-09_JPRB, 0.53491767E-09_JPRB, 0.53476579E-09_JPRB, 0.53456889E-09_JPRB, &
  & 0.53434118E-09_JPRB, 0.53410132E-09_JPRB, 0.53387200E-09_JPRB, 0.53367749E-09_JPRB, 0.53353955E-09_JPRB, 0.53346561E-09_JPRB, &
  & 0.53344118E-09_JPRB, 0.53343990E-09_JPRB, 0.53343957E-09_JPRB, 0.53342603E-09_JPRB, 0.53339427E-09_JPRB, 0.53334220E-09_JPRB, &
  & 0.53327909E-09_JPRB, 0.53321580E-09_JPRB, 0.53316296E-09_JPRB, 0.53312710E-09_JPRB, 0.53309968E-09_JPRB, 0.53307952E-09_JPRB, &
  & 0.53306015E-09_JPRB, 0.53303789E-09_JPRB, 0.53300997E-09_JPRB, 0.53297855E-09_JPRB, 0.53294624E-09_JPRB, 0.53292026E-09_JPRB, &
  & 0.53289417E-09_JPRB, 0.53286908E-09_JPRB, 0.53283333E-09_JPRB, 0.53276883E-09_JPRB /)

RGHG6(:,56, 5) = (/ &
  & 0.52960125E-09_JPRB, 0.53044230E-09_JPRB, 0.53088467E-09_JPRB, 0.53133342E-09_JPRB, 0.53172300E-09_JPRB, 0.53195731E-09_JPRB, &
  & 0.53206772E-09_JPRB, 0.53212512E-09_JPRB, 0.53216120E-09_JPRB, 0.53218796E-09_JPRB, 0.53221511E-09_JPRB, 0.53224325E-09_JPRB, &
  & 0.53228283E-09_JPRB, 0.53233545E-09_JPRB, 0.53240301E-09_JPRB, 0.53247784E-09_JPRB, 0.53255389E-09_JPRB, 0.53263566E-09_JPRB, &
  & 0.53272664E-09_JPRB, 0.53284482E-09_JPRB, 0.53300636E-09_JPRB, 0.53323412E-09_JPRB, 0.53355048E-09_JPRB, 0.53389609E-09_JPRB, &
  & 0.53421262E-09_JPRB, 0.53446603E-09_JPRB, 0.53466742E-09_JPRB, 0.53482963E-09_JPRB, 0.53495980E-09_JPRB, 0.53505711E-09_JPRB, &
  & 0.53511534E-09_JPRB, 0.53512739E-09_JPRB, 0.53508720E-09_JPRB, 0.53499261E-09_JPRB, 0.53484644E-09_JPRB, 0.53465493E-09_JPRB, &
  & 0.53443172E-09_JPRB, 0.53419708E-09_JPRB, 0.53397420E-09_JPRB, 0.53378940E-09_JPRB, 0.53366300E-09_JPRB, 0.53359950E-09_JPRB, &
  & 0.53358362E-09_JPRB, 0.53359001E-09_JPRB, 0.53359694E-09_JPRB, 0.53359062E-09_JPRB, 0.53356525E-09_JPRB, 0.53352156E-09_JPRB, &
  & 0.53346705E-09_JPRB, 0.53341498E-09_JPRB, 0.53337568E-09_JPRB, 0.53334775E-09_JPRB, 0.53332999E-09_JPRB, 0.53331600E-09_JPRB, &
  & 0.53330329E-09_JPRB, 0.53328930E-09_JPRB, 0.53327193E-09_JPRB, 0.53325150E-09_JPRB, 0.53323290E-09_JPRB, 0.53321614E-09_JPRB, &
  & 0.53320187E-09_JPRB, 0.53318649E-09_JPRB, 0.53317051E-09_JPRB, 0.53314303E-09_JPRB /)

RGHG6(:,57, 5) = (/ &
  & 0.53074822E-09_JPRB, 0.53133264E-09_JPRB, 0.53165766E-09_JPRB, 0.53195137E-09_JPRB, 0.53219434E-09_JPRB, 0.53235027E-09_JPRB, &
  & 0.53242449E-09_JPRB, 0.53246291E-09_JPRB, 0.53248672E-09_JPRB, 0.53250615E-09_JPRB, 0.53252369E-09_JPRB, 0.53254479E-09_JPRB, &
  & 0.53257121E-09_JPRB, 0.53260868E-09_JPRB, 0.53265725E-09_JPRB, 0.53271221E-09_JPRB, 0.53277083E-09_JPRB, 0.53283372E-09_JPRB, &
  & 0.53291010E-09_JPRB, 0.53301019E-09_JPRB, 0.53315447E-09_JPRB, 0.53336996E-09_JPRB, 0.53365518E-09_JPRB, 0.53398252E-09_JPRB, &
  & 0.53428062E-09_JPRB, 0.53452759E-09_JPRB, 0.53472704E-09_JPRB, 0.53489013E-09_JPRB, 0.53502086E-09_JPRB, 0.53511856E-09_JPRB, &
  & 0.53517746E-09_JPRB, 0.53519061E-09_JPRB, 0.53515331E-09_JPRB, 0.53506355E-09_JPRB, 0.53492305E-09_JPRB, 0.53473725E-09_JPRB, &
  & 0.53451954E-09_JPRB, 0.53429050E-09_JPRB, 0.53407556E-09_JPRB, 0.53390092E-09_JPRB, 0.53378474E-09_JPRB, 0.53373017E-09_JPRB, &
  & 0.53372096E-09_JPRB, 0.53373300E-09_JPRB, 0.53374571E-09_JPRB, 0.53374505E-09_JPRB, 0.53372556E-09_JPRB, 0.53368721E-09_JPRB, &
  & 0.53363880E-09_JPRB, 0.53359273E-09_JPRB, 0.53355731E-09_JPRB, 0.53353522E-09_JPRB, 0.53351962E-09_JPRB, 0.53350824E-09_JPRB, &
  & 0.53349780E-09_JPRB, 0.53348614E-09_JPRB, 0.53347216E-09_JPRB, 0.53345683E-09_JPRB, 0.53344190E-09_JPRB, 0.53342963E-09_JPRB, &
  & 0.53341781E-09_JPRB, 0.53340610E-09_JPRB, 0.53338972E-09_JPRB, 0.53336074E-09_JPRB /)

RGHG6(:,58, 5) = (/ &
  & 0.53168514E-09_JPRB, 0.53202065E-09_JPRB, 0.53221683E-09_JPRB, 0.53239196E-09_JPRB, 0.53256199E-09_JPRB, 0.53266180E-09_JPRB, &
  & 0.53271371E-09_JPRB, 0.53274057E-09_JPRB, 0.53275823E-09_JPRB, 0.53277183E-09_JPRB, 0.53278559E-09_JPRB, 0.53280069E-09_JPRB, &
  & 0.53282079E-09_JPRB, 0.53284832E-09_JPRB, 0.53288413E-09_JPRB, 0.53292570E-09_JPRB, 0.53296989E-09_JPRB, 0.53301930E-09_JPRB, &
  & 0.53308025E-09_JPRB, 0.53316768E-09_JPRB, 0.53330035E-09_JPRB, 0.53349758E-09_JPRB, 0.53376875E-09_JPRB, 0.53407040E-09_JPRB, &
  & 0.53435290E-09_JPRB, 0.53459182E-09_JPRB, 0.53478938E-09_JPRB, 0.53495169E-09_JPRB, 0.53508259E-09_JPRB, 0.53517979E-09_JPRB, &
  & 0.53523841E-09_JPRB, 0.53525206E-09_JPRB, 0.53521698E-09_JPRB, 0.53513111E-09_JPRB, 0.53499610E-09_JPRB, 0.53481675E-09_JPRB, &
  & 0.53460547E-09_JPRB, 0.53438365E-09_JPRB, 0.53417720E-09_JPRB, 0.53401239E-09_JPRB, 0.53390564E-09_JPRB, 0.53385840E-09_JPRB, &
  & 0.53385446E-09_JPRB, 0.53387084E-09_JPRB, 0.53388766E-09_JPRB, 0.53389160E-09_JPRB, 0.53387716E-09_JPRB, 0.53384441E-09_JPRB, &
  & 0.53380000E-09_JPRB, 0.53375632E-09_JPRB, 0.53372340E-09_JPRB, 0.53370064E-09_JPRB, 0.53368582E-09_JPRB, 0.53367422E-09_JPRB, &
  & 0.53366350E-09_JPRB, 0.53365201E-09_JPRB, 0.53363847E-09_JPRB, 0.53362348E-09_JPRB, 0.53361005E-09_JPRB, 0.53359828E-09_JPRB, &
  & 0.53358773E-09_JPRB, 0.53357618E-09_JPRB, 0.53356242E-09_JPRB, 0.53353455E-09_JPRB /)

RGHG6(:,59, 5) = (/ &
  & 0.53226673E-09_JPRB, 0.53249505E-09_JPRB, 0.53262228E-09_JPRB, 0.53274529E-09_JPRB, 0.53284743E-09_JPRB, 0.53292187E-09_JPRB, &
  & 0.53295868E-09_JPRB, 0.53297955E-09_JPRB, 0.53299287E-09_JPRB, 0.53300414E-09_JPRB, 0.53301497E-09_JPRB, 0.53302784E-09_JPRB, &
  & 0.53304422E-09_JPRB, 0.53306615E-09_JPRB, 0.53309474E-09_JPRB, 0.53312676E-09_JPRB, 0.53316052E-09_JPRB, 0.53319699E-09_JPRB, &
  & 0.53324550E-09_JPRB, 0.53332017E-09_JPRB, 0.53344129E-09_JPRB, 0.53362820E-09_JPRB, 0.53387944E-09_JPRB, 0.53416183E-09_JPRB, &
  & 0.53442906E-09_JPRB, 0.53466054E-09_JPRB, 0.53485461E-09_JPRB, 0.53501570E-09_JPRB, 0.53514521E-09_JPRB, 0.53524124E-09_JPRB, &
  & 0.53529886E-09_JPRB, 0.53531252E-09_JPRB, 0.53527877E-09_JPRB, 0.53519633E-09_JPRB, 0.53506632E-09_JPRB, 0.53489374E-09_JPRB, &
  & 0.53469035E-09_JPRB, 0.53447669E-09_JPRB, 0.53428034E-09_JPRB, 0.53412458E-09_JPRB, 0.53402610E-09_JPRB, 0.53398497E-09_JPRB, &
  & 0.53398508E-09_JPRB, 0.53400462E-09_JPRB, 0.53402444E-09_JPRB, 0.53403193E-09_JPRB, 0.53402188E-09_JPRB, 0.53399424E-09_JPRB, &
  & 0.53395444E-09_JPRB, 0.53391236E-09_JPRB, 0.53387811E-09_JPRB, 0.53385463E-09_JPRB, 0.53383792E-09_JPRB, 0.53382460E-09_JPRB, &
  & 0.53381249E-09_JPRB, 0.53379923E-09_JPRB, 0.53378413E-09_JPRB, 0.53376825E-09_JPRB, 0.53375349E-09_JPRB, 0.53374127E-09_JPRB, &
  & 0.53372984E-09_JPRB, 0.53371818E-09_JPRB, 0.53370230E-09_JPRB, 0.53367383E-09_JPRB /)

RGHG6(:,60, 5) = (/ &
  & 0.53272131E-09_JPRB, 0.53286064E-09_JPRB, 0.53294341E-09_JPRB, 0.53301874E-09_JPRB, 0.53309474E-09_JPRB, 0.53314542E-09_JPRB, &
  & 0.53317517E-09_JPRB, 0.53319155E-09_JPRB, 0.53320348E-09_JPRB, 0.53321308E-09_JPRB, 0.53322324E-09_JPRB, 0.53323485E-09_JPRB, &
  & 0.53324978E-09_JPRB, 0.53326976E-09_JPRB, 0.53329419E-09_JPRB, 0.53332094E-09_JPRB, 0.53334615E-09_JPRB, 0.53337185E-09_JPRB, &
  & 0.53340765E-09_JPRB, 0.53347105E-09_JPRB, 0.53358146E-09_JPRB, 0.53375537E-09_JPRB, 0.53399052E-09_JPRB, 0.53425497E-09_JPRB, &
  & 0.53450910E-09_JPRB, 0.53473281E-09_JPRB, 0.53492327E-09_JPRB, 0.53508181E-09_JPRB, 0.53520899E-09_JPRB, 0.53530280E-09_JPRB, &
  & 0.53535881E-09_JPRB, 0.53537186E-09_JPRB, 0.53533900E-09_JPRB, 0.53525956E-09_JPRB, 0.53513438E-09_JPRB, 0.53496901E-09_JPRB, &
  & 0.53477389E-09_JPRB, 0.53457094E-09_JPRB, 0.53438393E-09_JPRB, 0.53423788E-09_JPRB, 0.53414673E-09_JPRB, 0.53411048E-09_JPRB, &
  & 0.53411348E-09_JPRB, 0.53413529E-09_JPRB, 0.53415727E-09_JPRB, 0.53416754E-09_JPRB, 0.53416138E-09_JPRB, 0.53413851E-09_JPRB, &
  & 0.53410304E-09_JPRB, 0.53406346E-09_JPRB, 0.53402799E-09_JPRB, 0.53400145E-09_JPRB, 0.53398164E-09_JPRB, 0.53396587E-09_JPRB, &
  & 0.53395066E-09_JPRB, 0.53393479E-09_JPRB, 0.53391686E-09_JPRB, 0.53389820E-09_JPRB, 0.53388161E-09_JPRB, 0.53386762E-09_JPRB, &
  & 0.53385474E-09_JPRB, 0.53384097E-09_JPRB, 0.53382448E-09_JPRB, 0.53379173E-09_JPRB /)

RGHG6(:,61, 5) = (/ &
  & 0.53303484E-09_JPRB, 0.53313759E-09_JPRB, 0.53319671E-09_JPRB, 0.53325266E-09_JPRB, 0.53330468E-09_JPRB, 0.53334631E-09_JPRB, &
  & 0.53337013E-09_JPRB, 0.53338534E-09_JPRB, 0.53339599E-09_JPRB, 0.53340576E-09_JPRB, 0.53341564E-09_JPRB, 0.53342775E-09_JPRB, &
  & 0.53344340E-09_JPRB, 0.53346344E-09_JPRB, 0.53348742E-09_JPRB, 0.53351079E-09_JPRB, 0.53352933E-09_JPRB, 0.53354460E-09_JPRB, &
  & 0.53356908E-09_JPRB, 0.53362115E-09_JPRB, 0.53372079E-09_JPRB, 0.53388205E-09_JPRB, 0.53410149E-09_JPRB, 0.53435023E-09_JPRB, &
  & 0.53459248E-09_JPRB, 0.53480886E-09_JPRB, 0.53499466E-09_JPRB, 0.53514970E-09_JPRB, 0.53527366E-09_JPRB, 0.53536459E-09_JPRB, &
  & 0.53541804E-09_JPRB, 0.53543009E-09_JPRB, 0.53539800E-09_JPRB, 0.53532151E-09_JPRB, 0.53520133E-09_JPRB, 0.53504362E-09_JPRB, &
  & 0.53485821E-09_JPRB, 0.53466553E-09_JPRB, 0.53448923E-09_JPRB, 0.53435223E-09_JPRB, 0.53426785E-09_JPRB, 0.53423549E-09_JPRB, &
  & 0.53424054E-09_JPRB, 0.53426352E-09_JPRB, 0.53428711E-09_JPRB, 0.53429966E-09_JPRB, 0.53429666E-09_JPRB, 0.53427807E-09_JPRB, &
  & 0.53424754E-09_JPRB, 0.53421073E-09_JPRB, 0.53417532E-09_JPRB, 0.53414551E-09_JPRB, 0.53412219E-09_JPRB, 0.53410210E-09_JPRB, &
  & 0.53408350E-09_JPRB, 0.53406340E-09_JPRB, 0.53404159E-09_JPRB, 0.53401961E-09_JPRB, 0.53400001E-09_JPRB, 0.53398336E-09_JPRB, &
  & 0.53396804E-09_JPRB, 0.53395222E-09_JPRB, 0.53393107E-09_JPRB, 0.53389354E-09_JPRB /)

RGHG6(:,62, 5) = (/ &
  & 0.53329152E-09_JPRB, 0.53336857E-09_JPRB, 0.53341243E-09_JPRB, 0.53345339E-09_JPRB, 0.53349536E-09_JPRB, 0.53352878E-09_JPRB, &
  & 0.53355120E-09_JPRB, 0.53356530E-09_JPRB, 0.53357657E-09_JPRB, 0.53358662E-09_JPRB, 0.53359794E-09_JPRB, 0.53361160E-09_JPRB, &
  & 0.53362942E-09_JPRB, 0.53365201E-09_JPRB, 0.53367699E-09_JPRB, 0.53369842E-09_JPRB, 0.53371063E-09_JPRB, 0.53371640E-09_JPRB, &
  & 0.53373017E-09_JPRB, 0.53377180E-09_JPRB, 0.53386034E-09_JPRB, 0.53400939E-09_JPRB, 0.53421378E-09_JPRB, 0.53444804E-09_JPRB, &
  & 0.53467875E-09_JPRB, 0.53488791E-09_JPRB, 0.53506827E-09_JPRB, 0.53521904E-09_JPRB, 0.53533911E-09_JPRB, 0.53542648E-09_JPRB, &
  & 0.53547700E-09_JPRB, 0.53548754E-09_JPRB, 0.53545612E-09_JPRB, 0.53538263E-09_JPRB, 0.53526800E-09_JPRB, 0.53511806E-09_JPRB, &
  & 0.53494298E-09_JPRB, 0.53476151E-09_JPRB, 0.53459565E-09_JPRB, 0.53446780E-09_JPRB, 0.53438975E-09_JPRB, 0.53436061E-09_JPRB, &
  & 0.53436677E-09_JPRB, 0.53439048E-09_JPRB, 0.53441479E-09_JPRB, 0.53442917E-09_JPRB, 0.53442889E-09_JPRB, 0.53441401E-09_JPRB, &
  & 0.53438742E-09_JPRB, 0.53435462E-09_JPRB, 0.53431998E-09_JPRB, 0.53428834E-09_JPRB, 0.53426086E-09_JPRB, 0.53423654E-09_JPRB, &
  & 0.53421301E-09_JPRB, 0.53418803E-09_JPRB, 0.53416205E-09_JPRB, 0.53413574E-09_JPRB, 0.53411275E-09_JPRB, 0.53409321E-09_JPRB, &
  & 0.53407484E-09_JPRB, 0.53405480E-09_JPRB, 0.53403004E-09_JPRB, 0.53398092E-09_JPRB /)

RGHG6(:,63, 5) = (/ &
  & 0.53350541E-09_JPRB, 0.53356586E-09_JPRB, 0.53360111E-09_JPRB, 0.53363441E-09_JPRB, 0.53366855E-09_JPRB, 0.53369897E-09_JPRB, &
  & 0.53371979E-09_JPRB, 0.53373500E-09_JPRB, 0.53374682E-09_JPRB, 0.53375887E-09_JPRB, 0.53377203E-09_JPRB, 0.53378890E-09_JPRB, &
  & 0.53381083E-09_JPRB, 0.53383753E-09_JPRB, 0.53386484E-09_JPRB, 0.53388421E-09_JPRB, 0.53389015E-09_JPRB, 0.53388721E-09_JPRB, &
  & 0.53389149E-09_JPRB, 0.53392324E-09_JPRB, 0.53400123E-09_JPRB, 0.53413785E-09_JPRB, 0.53432864E-09_JPRB, 0.53454846E-09_JPRB, &
  & 0.53476851E-09_JPRB, 0.53496946E-09_JPRB, 0.53514387E-09_JPRB, 0.53528937E-09_JPRB, 0.53540472E-09_JPRB, 0.53548771E-09_JPRB, &
  & 0.53553512E-09_JPRB, 0.53554405E-09_JPRB, 0.53551336E-09_JPRB, 0.53544336E-09_JPRB, 0.53533500E-09_JPRB, 0.53519350E-09_JPRB, &
  & 0.53502913E-09_JPRB, 0.53485899E-09_JPRB, 0.53470411E-09_JPRB, 0.53458488E-09_JPRB, 0.53451277E-09_JPRB, 0.53448629E-09_JPRB, &
  & 0.53449295E-09_JPRB, 0.53451626E-09_JPRB, 0.53454080E-09_JPRB, 0.53455634E-09_JPRB, 0.53455840E-09_JPRB, 0.53454680E-09_JPRB, &
  & 0.53452387E-09_JPRB, 0.53449434E-09_JPRB, 0.53446192E-09_JPRB, 0.53442961E-09_JPRB, 0.53439869E-09_JPRB, 0.53437027E-09_JPRB, &
  & 0.53434124E-09_JPRB, 0.53431221E-09_JPRB, 0.53428056E-09_JPRB, 0.53425098E-09_JPRB, 0.53422433E-09_JPRB, 0.53420113E-09_JPRB, &
  & 0.53417903E-09_JPRB, 0.53415516E-09_JPRB, 0.53412208E-09_JPRB, 0.53406268E-09_JPRB /)

RGHG6(:,64, 5) = (/ &
  & 0.53368587E-09_JPRB, 0.53373878E-09_JPRB, 0.53376914E-09_JPRB, 0.53379801E-09_JPRB, 0.53382881E-09_JPRB, 0.53385685E-09_JPRB, &
  & 0.53387877E-09_JPRB, 0.53389454E-09_JPRB, 0.53390903E-09_JPRB, 0.53392296E-09_JPRB, 0.53394000E-09_JPRB, 0.53396121E-09_JPRB, &
  & 0.53398885E-09_JPRB, 0.53402099E-09_JPRB, 0.53404975E-09_JPRB, 0.53406618E-09_JPRB, 0.53406601E-09_JPRB, 0.53405574E-09_JPRB, &
  & 0.53405202E-09_JPRB, 0.53407467E-09_JPRB, 0.53414284E-09_JPRB, 0.53426835E-09_JPRB, 0.53444504E-09_JPRB, 0.53465204E-09_JPRB, &
  & 0.53486027E-09_JPRB, 0.53505284E-09_JPRB, 0.53522009E-09_JPRB, 0.53535937E-09_JPRB, 0.53546895E-09_JPRB, 0.53554694E-09_JPRB, &
  & 0.53559074E-09_JPRB, 0.53559829E-09_JPRB, 0.53556870E-09_JPRB, 0.53550259E-09_JPRB, 0.53540122E-09_JPRB, 0.53526888E-09_JPRB, &
  & 0.53511579E-09_JPRB, 0.53495719E-09_JPRB, 0.53481314E-09_JPRB, 0.53470278E-09_JPRB, 0.53463628E-09_JPRB, 0.53461191E-09_JPRB, &
  & 0.53461813E-09_JPRB, 0.53464033E-09_JPRB, 0.53466431E-09_JPRB, 0.53468058E-09_JPRB, 0.53468463E-09_JPRB, 0.53467558E-09_JPRB, &
  & 0.53465599E-09_JPRB, 0.53462945E-09_JPRB, 0.53459920E-09_JPRB, 0.53456717E-09_JPRB, 0.53453514E-09_JPRB, 0.53450211E-09_JPRB, &
  & 0.53447002E-09_JPRB, 0.53443466E-09_JPRB, 0.53440052E-09_JPRB, 0.53436616E-09_JPRB, 0.53433619E-09_JPRB, 0.53430949E-09_JPRB, &
  & 0.53428351E-09_JPRB, 0.53425381E-09_JPRB, 0.53421528E-09_JPRB, 0.53413746E-09_JPRB /)

RGHG6(:,65, 5) = (/ &
  & 0.53384097E-09_JPRB, 0.53389237E-09_JPRB, 0.53392152E-09_JPRB, 0.53394900E-09_JPRB, 0.53397819E-09_JPRB, 0.53400645E-09_JPRB, &
  & 0.53402871E-09_JPRB, 0.53404753E-09_JPRB, 0.53406357E-09_JPRB, 0.53408189E-09_JPRB, 0.53410276E-09_JPRB, 0.53413074E-09_JPRB, &
  & 0.53416527E-09_JPRB, 0.53420124E-09_JPRB, 0.53423033E-09_JPRB, 0.53424259E-09_JPRB, 0.53423727E-09_JPRB, 0.53422128E-09_JPRB, &
  & 0.53421084E-09_JPRB, 0.53422577E-09_JPRB, 0.53428501E-09_JPRB, 0.53439908E-09_JPRB, 0.53456373E-09_JPRB, 0.53475679E-09_JPRB, &
  & 0.53495397E-09_JPRB, 0.53513638E-09_JPRB, 0.53529564E-09_JPRB, 0.53542731E-09_JPRB, 0.53553029E-09_JPRB, 0.53560262E-09_JPRB, &
  & 0.53564264E-09_JPRB, 0.53564880E-09_JPRB, 0.53562083E-09_JPRB, 0.53555921E-09_JPRB, 0.53546523E-09_JPRB, 0.53534316E-09_JPRB, &
  & 0.53520155E-09_JPRB, 0.53505506E-09_JPRB, 0.53492222E-09_JPRB, 0.53482041E-09_JPRB, 0.53475901E-09_JPRB, 0.53473626E-09_JPRB, &
  & 0.53474170E-09_JPRB, 0.53476223E-09_JPRB, 0.53478527E-09_JPRB, 0.53480159E-09_JPRB, 0.53480681E-09_JPRB, 0.53480020E-09_JPRB, &
  & 0.53478350E-09_JPRB, 0.53475968E-09_JPRB, 0.53473143E-09_JPRB, 0.53470045E-09_JPRB, 0.53466720E-09_JPRB, 0.53463284E-09_JPRB, &
  & 0.53459592E-09_JPRB, 0.53455873E-09_JPRB, 0.53451982E-09_JPRB, 0.53448318E-09_JPRB, 0.53444965E-09_JPRB, 0.53441956E-09_JPRB, &
  & 0.53438964E-09_JPRB, 0.53435634E-09_JPRB, 0.53430660E-09_JPRB, 0.53421761E-09_JPRB /)

RGHG6(:,66, 5) = (/ &
  & 0.53397947E-09_JPRB, 0.53403265E-09_JPRB, 0.53406302E-09_JPRB, 0.53409066E-09_JPRB, 0.53412014E-09_JPRB, 0.53414895E-09_JPRB, &
  & 0.53417365E-09_JPRB, 0.53419386E-09_JPRB, 0.53421434E-09_JPRB, 0.53423543E-09_JPRB, 0.53426352E-09_JPRB, 0.53429761E-09_JPRB, &
  & 0.53433791E-09_JPRB, 0.53437621E-09_JPRB, 0.53440274E-09_JPRB, 0.53441213E-09_JPRB, 0.53440302E-09_JPRB, 0.53438293E-09_JPRB, &
  & 0.53436755E-09_JPRB, 0.53437610E-09_JPRB, 0.53442706E-09_JPRB, 0.53453120E-09_JPRB, 0.53468235E-09_JPRB, 0.53486326E-09_JPRB, &
  & 0.53504734E-09_JPRB, 0.53521920E-09_JPRB, 0.53536858E-09_JPRB, 0.53549193E-09_JPRB, 0.53558713E-09_JPRB, 0.53565330E-09_JPRB, &
  & 0.53568949E-09_JPRB, 0.53569449E-09_JPRB, 0.53566845E-09_JPRB, 0.53561178E-09_JPRB, 0.53552601E-09_JPRB, 0.53541432E-09_JPRB, &
  & 0.53528515E-09_JPRB, 0.53515081E-09_JPRB, 0.53502935E-09_JPRB, 0.53493610E-09_JPRB, 0.53487970E-09_JPRB, 0.53485827E-09_JPRB, &
  & 0.53486288E-09_JPRB, 0.53488125E-09_JPRB, 0.53490284E-09_JPRB, 0.53491866E-09_JPRB, 0.53492488E-09_JPRB, 0.53492022E-09_JPRB, &
  & 0.53490617E-09_JPRB, 0.53488503E-09_JPRB, 0.53485882E-09_JPRB, 0.53482885E-09_JPRB, 0.53479582E-09_JPRB, 0.53475974E-09_JPRB, &
  & 0.53472154E-09_JPRB, 0.53468086E-09_JPRB, 0.53464050E-09_JPRB, 0.53460070E-09_JPRB, 0.53456484E-09_JPRB, 0.53453181E-09_JPRB, &
  & 0.53449917E-09_JPRB, 0.53446075E-09_JPRB, 0.53440674E-09_JPRB, 0.53430166E-09_JPRB /)

RGHG6(:,67, 5) = (/ &
  & 0.53410576E-09_JPRB, 0.53416499E-09_JPRB, 0.53419713E-09_JPRB, 0.53422700E-09_JPRB, 0.53425792E-09_JPRB, 0.53428773E-09_JPRB, &
  & 0.53431465E-09_JPRB, 0.53433824E-09_JPRB, 0.53436144E-09_JPRB, 0.53438898E-09_JPRB, 0.53442156E-09_JPRB, 0.53446220E-09_JPRB, &
  & 0.53450455E-09_JPRB, 0.53454052E-09_JPRB, 0.53456595E-09_JPRB, 0.53457372E-09_JPRB, 0.53456273E-09_JPRB, 0.53454030E-09_JPRB, &
  & 0.53452165E-09_JPRB, 0.53452531E-09_JPRB, 0.53456900E-09_JPRB, 0.53466281E-09_JPRB, 0.53480259E-09_JPRB, 0.53496890E-09_JPRB, &
  & 0.53514049E-09_JPRB, 0.53529969E-09_JPRB, 0.53543842E-09_JPRB, 0.53555205E-09_JPRB, 0.53563931E-09_JPRB, 0.53569899E-09_JPRB, &
  & 0.53573118E-09_JPRB, 0.53573534E-09_JPRB, 0.53571164E-09_JPRB, 0.53566035E-09_JPRB, 0.53558252E-09_JPRB, 0.53548194E-09_JPRB, &
  & 0.53536470E-09_JPRB, 0.53524318E-09_JPRB, 0.53513288E-09_JPRB, 0.53504851E-09_JPRB, 0.53499716E-09_JPRB, 0.53497701E-09_JPRB, &
  & 0.53498067E-09_JPRB, 0.53499677E-09_JPRB, 0.53501648E-09_JPRB, 0.53503163E-09_JPRB, 0.53503851E-09_JPRB, 0.53503568E-09_JPRB, &
  & 0.53502397E-09_JPRB, 0.53500554E-09_JPRB, 0.53498139E-09_JPRB, 0.53495269E-09_JPRB, 0.53492016E-09_JPRB, 0.53488391E-09_JPRB, &
  & 0.53484422E-09_JPRB, 0.53480270E-09_JPRB, 0.53476007E-09_JPRB, 0.53471927E-09_JPRB, 0.53468119E-09_JPRB, 0.53464644E-09_JPRB, &
  & 0.53461136E-09_JPRB, 0.53457150E-09_JPRB, 0.53450894E-09_JPRB, 0.53439508E-09_JPRB /)

RGHG6(:,68, 5) = (/ &
  & 0.53422244E-09_JPRB, 0.53428922E-09_JPRB, 0.53432725E-09_JPRB, 0.53435995E-09_JPRB, 0.53439303E-09_JPRB, 0.53442667E-09_JPRB, &
  & 0.53445420E-09_JPRB, 0.53448185E-09_JPRB, 0.53450855E-09_JPRB, 0.53454030E-09_JPRB, 0.53457855E-09_JPRB, 0.53462157E-09_JPRB, &
  & 0.53466354E-09_JPRB, 0.53469928E-09_JPRB, 0.53472304E-09_JPRB, 0.53472843E-09_JPRB, 0.53471610E-09_JPRB, 0.53469296E-09_JPRB, &
  & 0.53467264E-09_JPRB, 0.53467286E-09_JPRB, 0.53470989E-09_JPRB, 0.53479438E-09_JPRB, 0.53492094E-09_JPRB, 0.53507393E-09_JPRB, &
  & 0.53523086E-09_JPRB, 0.53537708E-09_JPRB, 0.53550392E-09_JPRB, 0.53560750E-09_JPRB, 0.53568655E-09_JPRB, 0.53574012E-09_JPRB, &
  & 0.53576854E-09_JPRB, 0.53577193E-09_JPRB, 0.53575056E-09_JPRB, 0.53570448E-09_JPRB, 0.53563526E-09_JPRB, 0.53554500E-09_JPRB, &
  & 0.53544036E-09_JPRB, 0.53533100E-09_JPRB, 0.53523197E-09_JPRB, 0.53515620E-09_JPRB, 0.53510985E-09_JPRB, 0.53509130E-09_JPRB, &
  & 0.53509391E-09_JPRB, 0.53510790E-09_JPRB, 0.53512589E-09_JPRB, 0.53514021E-09_JPRB, 0.53514754E-09_JPRB, 0.53514626E-09_JPRB, &
  & 0.53513682E-09_JPRB, 0.53512084E-09_JPRB, 0.53509885E-09_JPRB, 0.53507176E-09_JPRB, 0.53504007E-09_JPRB, 0.53500415E-09_JPRB, &
  & 0.53496452E-09_JPRB, 0.53492233E-09_JPRB, 0.53487936E-09_JPRB, 0.53483745E-09_JPRB, 0.53479876E-09_JPRB, 0.53476290E-09_JPRB, &
  & 0.53472732E-09_JPRB, 0.53468557E-09_JPRB, 0.53462168E-09_JPRB, 0.53449717E-09_JPRB /)

RGHG6(:,69, 5) = (/ &
  & 0.53432969E-09_JPRB, 0.53441251E-09_JPRB, 0.53445570E-09_JPRB, 0.53449356E-09_JPRB, 0.53453070E-09_JPRB, 0.53456400E-09_JPRB, &
  & 0.53459692E-09_JPRB, 0.53462396E-09_JPRB, 0.53465654E-09_JPRB, 0.53469040E-09_JPRB, 0.53473193E-09_JPRB, 0.53477378E-09_JPRB, &
  & 0.53481169E-09_JPRB, 0.53484273E-09_JPRB, 0.53486693E-09_JPRB, 0.53487531E-09_JPRB, 0.53486410E-09_JPRB, 0.53484106E-09_JPRB, &
  & 0.53482063E-09_JPRB, 0.53481852E-09_JPRB, 0.53484994E-09_JPRB, 0.53492444E-09_JPRB, 0.53503812E-09_JPRB, 0.53517579E-09_JPRB, &
  & 0.53531835E-09_JPRB, 0.53545057E-09_JPRB, 0.53556543E-09_JPRB, 0.53565880E-09_JPRB, 0.53572935E-09_JPRB, 0.53577681E-09_JPRB, &
  & 0.53580179E-09_JPRB, 0.53580457E-09_JPRB, 0.53578558E-09_JPRB, 0.53574495E-09_JPRB, 0.53568378E-09_JPRB, 0.53560406E-09_JPRB, &
  & 0.53551114E-09_JPRB, 0.53541394E-09_JPRB, 0.53532584E-09_JPRB, 0.53525862E-09_JPRB, 0.53521737E-09_JPRB, 0.53520055E-09_JPRB, &
  & 0.53520260E-09_JPRB, 0.53521465E-09_JPRB, 0.53523080E-09_JPRB, 0.53524440E-09_JPRB, 0.53525212E-09_JPRB, 0.53525201E-09_JPRB, &
  & 0.53524468E-09_JPRB, 0.53523097E-09_JPRB, 0.53521121E-09_JPRB, 0.53518606E-09_JPRB, 0.53515575E-09_JPRB, 0.53512095E-09_JPRB, &
  & 0.53508203E-09_JPRB, 0.53504040E-09_JPRB, 0.53499760E-09_JPRB, 0.53495619E-09_JPRB, 0.53491761E-09_JPRB, 0.53488175E-09_JPRB, &
  & 0.53484644E-09_JPRB, 0.53480548E-09_JPRB, 0.53473886E-09_JPRB, 0.53460669E-09_JPRB /)

RGHG6(:,70, 5) = (/ &
  & 0.53443461E-09_JPRB, 0.53453336E-09_JPRB, 0.53458771E-09_JPRB, 0.53463051E-09_JPRB, 0.53466992E-09_JPRB, 0.53470728E-09_JPRB, &
  & 0.53473787E-09_JPRB, 0.53477067E-09_JPRB, 0.53480209E-09_JPRB, 0.53484028E-09_JPRB, 0.53488047E-09_JPRB, 0.53492116E-09_JPRB, &
  & 0.53495908E-09_JPRB, 0.53499144E-09_JPRB, 0.53501287E-09_JPRB, 0.53501703E-09_JPRB, 0.53500632E-09_JPRB, 0.53498489E-09_JPRB, &
  & 0.53496513E-09_JPRB, 0.53496163E-09_JPRB, 0.53498772E-09_JPRB, 0.53505228E-09_JPRB, 0.53515203E-09_JPRB, 0.53527477E-09_JPRB, &
  & 0.53540189E-09_JPRB, 0.53552018E-09_JPRB, 0.53562277E-09_JPRB, 0.53570570E-09_JPRB, 0.53576826E-09_JPRB, 0.53581006E-09_JPRB, &
  & 0.53583171E-09_JPRB, 0.53583382E-09_JPRB, 0.53581733E-09_JPRB, 0.53578186E-09_JPRB, 0.53572868E-09_JPRB, 0.53565891E-09_JPRB, &
  & 0.53557742E-09_JPRB, 0.53549187E-09_JPRB, 0.53541427E-09_JPRB, 0.53535543E-09_JPRB, 0.53531918E-09_JPRB, 0.53530447E-09_JPRB, &
  & 0.53530597E-09_JPRB, 0.53531651E-09_JPRB, 0.53533095E-09_JPRB, 0.53534394E-09_JPRB, 0.53535176E-09_JPRB, 0.53535282E-09_JPRB, &
  & 0.53534738E-09_JPRB, 0.53533583E-09_JPRB, 0.53531835E-09_JPRB, 0.53529531E-09_JPRB, 0.53526689E-09_JPRB, 0.53523386E-09_JPRB, &
  & 0.53519661E-09_JPRB, 0.53515647E-09_JPRB, 0.53511517E-09_JPRB, 0.53507521E-09_JPRB, 0.53503785E-09_JPRB, 0.53500326E-09_JPRB, &
  & 0.53496935E-09_JPRB, 0.53493049E-09_JPRB, 0.53486493E-09_JPRB, 0.53472576E-09_JPRB /)

RGHG6(:,71, 5) = (/ &
  & 0.53453908E-09_JPRB, 0.53466465E-09_JPRB, 0.53472526E-09_JPRB, 0.53477367E-09_JPRB, 0.53481530E-09_JPRB, 0.53485133E-09_JPRB, &
  & 0.53488469E-09_JPRB, 0.53491567E-09_JPRB, 0.53495064E-09_JPRB, 0.53498628E-09_JPRB, 0.53502586E-09_JPRB, 0.53506249E-09_JPRB, &
  & 0.53509264E-09_JPRB, 0.53511989E-09_JPRB, 0.53514371E-09_JPRB, 0.53515203E-09_JPRB, 0.53514287E-09_JPRB, 0.53512333E-09_JPRB, &
  & 0.53510513E-09_JPRB, 0.53510063E-09_JPRB, 0.53512200E-09_JPRB, 0.53517657E-09_JPRB, 0.53526256E-09_JPRB, 0.53536930E-09_JPRB, &
  & 0.53548121E-09_JPRB, 0.53558541E-09_JPRB, 0.53567595E-09_JPRB, 0.53574883E-09_JPRB, 0.53580357E-09_JPRB, 0.53583965E-09_JPRB, &
  & 0.53585808E-09_JPRB, 0.53586008E-09_JPRB, 0.53584592E-09_JPRB, 0.53581556E-09_JPRB, 0.53576982E-09_JPRB, 0.53570987E-09_JPRB, &
  & 0.53563914E-09_JPRB, 0.53556481E-09_JPRB, 0.53549754E-09_JPRB, 0.53544652E-09_JPRB, 0.53541521E-09_JPRB, 0.53540261E-09_JPRB, &
  & 0.53540400E-09_JPRB, 0.53541321E-09_JPRB, 0.53542604E-09_JPRB, 0.53543819E-09_JPRB, 0.53544591E-09_JPRB, 0.53544774E-09_JPRB, &
  & 0.53544402E-09_JPRB, 0.53543442E-09_JPRB, 0.53541932E-09_JPRB, 0.53539884E-09_JPRB, 0.53537280E-09_JPRB, 0.53534227E-09_JPRB, &
  & 0.53530769E-09_JPRB, 0.53527005E-09_JPRB, 0.53523164E-09_JPRB, 0.53519378E-09_JPRB, 0.53515925E-09_JPRB, 0.53512689E-09_JPRB, &
  & 0.53509563E-09_JPRB, 0.53506066E-09_JPRB, 0.53500016E-09_JPRB, 0.53486809E-09_JPRB /)

RGHG6(:,72, 5) = (/ &
  & 0.53466148E-09_JPRB, 0.53480059E-09_JPRB, 0.53487442E-09_JPRB, 0.53492344E-09_JPRB, 0.53496585E-09_JPRB, 0.53500071E-09_JPRB, &
  & 0.53503324E-09_JPRB, 0.53506488E-09_JPRB, 0.53509763E-09_JPRB, 0.53513294E-09_JPRB, 0.53516813E-09_JPRB, 0.53520188E-09_JPRB, &
  & 0.53523092E-09_JPRB, 0.53525595E-09_JPRB, 0.53527516E-09_JPRB, 0.53528076E-09_JPRB, 0.53527338E-09_JPRB, 0.53525595E-09_JPRB, &
  & 0.53523941E-09_JPRB, 0.53523458E-09_JPRB, 0.53525123E-09_JPRB, 0.53529642E-09_JPRB, 0.53536858E-09_JPRB, 0.53545990E-09_JPRB, &
  & 0.53555649E-09_JPRB, 0.53564680E-09_JPRB, 0.53572541E-09_JPRB, 0.53578825E-09_JPRB, 0.53583565E-09_JPRB, 0.53586646E-09_JPRB, &
  & 0.53588189E-09_JPRB, 0.53588367E-09_JPRB, 0.53587207E-09_JPRB, 0.53584603E-09_JPRB, 0.53580751E-09_JPRB, 0.53575672E-09_JPRB, &
  & 0.53569660E-09_JPRB, 0.53563259E-09_JPRB, 0.53557536E-09_JPRB, 0.53553190E-09_JPRB, 0.53550525E-09_JPRB, 0.53549465E-09_JPRB, &
  & 0.53549620E-09_JPRB, 0.53550392E-09_JPRB, 0.53551524E-09_JPRB, 0.53552646E-09_JPRB, 0.53553373E-09_JPRB, 0.53553623E-09_JPRB, &
  & 0.53553367E-09_JPRB, 0.53552596E-09_JPRB, 0.53551336E-09_JPRB, 0.53549570E-09_JPRB, 0.53547267E-09_JPRB, 0.53544535E-09_JPRB, &
  & 0.53541432E-09_JPRB, 0.53538074E-09_JPRB, 0.53534532E-09_JPRB, 0.53531207E-09_JPRB, 0.53527999E-09_JPRB, 0.53525151E-09_JPRB, &
  & 0.53522331E-09_JPRB, 0.53519267E-09_JPRB, 0.53513910E-09_JPRB, 0.53501381E-09_JPRB /)

RGHG6(:,73, 5) = (/ &
  & 0.53479848E-09_JPRB, 0.53495852E-09_JPRB, 0.53502913E-09_JPRB, 0.53508076E-09_JPRB, 0.53511962E-09_JPRB, 0.53515348E-09_JPRB, &
  & 0.53518390E-09_JPRB, 0.53521382E-09_JPRB, 0.53524596E-09_JPRB, 0.53527566E-09_JPRB, 0.53530863E-09_JPRB, 0.53533472E-09_JPRB, &
  & 0.53535304E-09_JPRB, 0.53537402E-09_JPRB, 0.53539595E-09_JPRB, 0.53540361E-09_JPRB, 0.53539667E-09_JPRB, 0.53538129E-09_JPRB, &
  & 0.53536653E-09_JPRB, 0.53536142E-09_JPRB, 0.53537424E-09_JPRB, 0.53541044E-09_JPRB, 0.53546956E-09_JPRB, 0.53554572E-09_JPRB, &
  & 0.53562754E-09_JPRB, 0.53570398E-09_JPRB, 0.53577121E-09_JPRB, 0.53582433E-09_JPRB, 0.53586446E-09_JPRB, 0.53589022E-09_JPRB, &
  & 0.53590299E-09_JPRB, 0.53590460E-09_JPRB, 0.53589544E-09_JPRB, 0.53587362E-09_JPRB, 0.53584187E-09_JPRB, 0.53579990E-09_JPRB, &
  & 0.53574950E-09_JPRB, 0.53569560E-09_JPRB, 0.53564742E-09_JPRB, 0.53561111E-09_JPRB, 0.53558913E-09_JPRB, 0.53558008E-09_JPRB, &
  & 0.53558169E-09_JPRB, 0.53558813E-09_JPRB, 0.53559790E-09_JPRB, 0.53560817E-09_JPRB, 0.53561489E-09_JPRB, 0.53561744E-09_JPRB, &
  & 0.53561588E-09_JPRB, 0.53560967E-09_JPRB, 0.53559940E-09_JPRB, 0.53558513E-09_JPRB, 0.53556515E-09_JPRB, 0.53554183E-09_JPRB, &
  & 0.53551530E-09_JPRB, 0.53548566E-09_JPRB, 0.53545590E-09_JPRB, 0.53542559E-09_JPRB, 0.53539884E-09_JPRB, 0.53537308E-09_JPRB, &
  & 0.53534888E-09_JPRB, 0.53532234E-09_JPRB, 0.53527416E-09_JPRB, 0.53515936E-09_JPRB /)

RGHG6(:,74, 5) = (/ &
  & 0.53495652E-09_JPRB, 0.53511418E-09_JPRB, 0.53519167E-09_JPRB, 0.53523680E-09_JPRB, 0.53527449E-09_JPRB, 0.53530391E-09_JPRB, &
  & 0.53533294E-09_JPRB, 0.53536076E-09_JPRB, 0.53538757E-09_JPRB, 0.53541704E-09_JPRB, 0.53544147E-09_JPRB, 0.53546628E-09_JPRB, &
  & 0.53548382E-09_JPRB, 0.53550259E-09_JPRB, 0.53551447E-09_JPRB, 0.53551841E-09_JPRB, 0.53551219E-09_JPRB, 0.53549870E-09_JPRB, &
  & 0.53548532E-09_JPRB, 0.53548044E-09_JPRB, 0.53548976E-09_JPRB, 0.53551780E-09_JPRB, 0.53556465E-09_JPRB, 0.53562671E-09_JPRB, &
  & 0.53569449E-09_JPRB, 0.53575755E-09_JPRB, 0.53581378E-09_JPRB, 0.53585725E-09_JPRB, 0.53589067E-09_JPRB, 0.53591170E-09_JPRB, &
  & 0.53592220E-09_JPRB, 0.53592347E-09_JPRB, 0.53591648E-09_JPRB, 0.53589849E-09_JPRB, 0.53587312E-09_JPRB, 0.53583926E-09_JPRB, &
  & 0.53579802E-09_JPRB, 0.53575350E-09_JPRB, 0.53571425E-09_JPRB, 0.53568422E-09_JPRB, 0.53566618E-09_JPRB, 0.53565896E-09_JPRB, &
  & 0.53566068E-09_JPRB, 0.53566562E-09_JPRB, 0.53567395E-09_JPRB, 0.53568322E-09_JPRB, 0.53568922E-09_JPRB, 0.53569144E-09_JPRB, &
  & 0.53569071E-09_JPRB, 0.53568561E-09_JPRB, 0.53567778E-09_JPRB, 0.53566657E-09_JPRB, 0.53565008E-09_JPRB, 0.53563093E-09_JPRB, &
  & 0.53560889E-09_JPRB, 0.53558485E-09_JPRB, 0.53555888E-09_JPRB, 0.53553478E-09_JPRB, 0.53551036E-09_JPRB, 0.53548982E-09_JPRB, &
  & 0.53546861E-09_JPRB, 0.53544608E-09_JPRB, 0.53540483E-09_JPRB, 0.53529747E-09_JPRB /)

RGHG6(:,75, 5) = (/ &
  & 0.53511401E-09_JPRB, 0.53527882E-09_JPRB, 0.53534815E-09_JPRB, 0.53539073E-09_JPRB, 0.53542248E-09_JPRB, 0.53544935E-09_JPRB, &
  & 0.53547450E-09_JPRB, 0.53549842E-09_JPRB, 0.53552401E-09_JPRB, 0.53554444E-09_JPRB, 0.53556731E-09_JPRB, 0.53558019E-09_JPRB, &
  & 0.53558352E-09_JPRB, 0.53559313E-09_JPRB, 0.53561794E-09_JPRB, 0.53562388E-09_JPRB, 0.53561910E-09_JPRB, 0.53560745E-09_JPRB, &
  & 0.53559573E-09_JPRB, 0.53559107E-09_JPRB, 0.53559734E-09_JPRB, 0.53561794E-09_JPRB, 0.53565385E-09_JPRB, 0.53570309E-09_JPRB, &
  & 0.53575766E-09_JPRB, 0.53580779E-09_JPRB, 0.53585342E-09_JPRB, 0.53588733E-09_JPRB, 0.53591387E-09_JPRB, 0.53593036E-09_JPRB, &
  & 0.53593840E-09_JPRB, 0.53593974E-09_JPRB, 0.53593519E-09_JPRB, 0.53592081E-09_JPRB, 0.53590127E-09_JPRB, 0.53587518E-09_JPRB, &
  & 0.53584237E-09_JPRB, 0.53580673E-09_JPRB, 0.53577565E-09_JPRB, 0.53575172E-09_JPRB, 0.53573734E-09_JPRB, 0.53573118E-09_JPRB, &
  & 0.53573285E-09_JPRB, 0.53573657E-09_JPRB, 0.53574351E-09_JPRB, 0.53575194E-09_JPRB, 0.53575722E-09_JPRB, 0.53575866E-09_JPRB, &
  & 0.53575849E-09_JPRB, 0.53575444E-09_JPRB, 0.53574878E-09_JPRB, 0.53574084E-09_JPRB, 0.53572718E-09_JPRB, 0.53571236E-09_JPRB, &
  & 0.53569504E-09_JPRB, 0.53567561E-09_JPRB, 0.53565569E-09_JPRB, 0.53563487E-09_JPRB, 0.53561622E-09_JPRB, 0.53559807E-09_JPRB, &
  & 0.53558163E-09_JPRB, 0.53556309E-09_JPRB, 0.53552651E-09_JPRB, 0.53542976E-09_JPRB /)

RGHG6(:,76, 5) = (/ &
  & 0.53528354E-09_JPRB, 0.53543575E-09_JPRB, 0.53550153E-09_JPRB, 0.53553550E-09_JPRB, 0.53556287E-09_JPRB, 0.53558369E-09_JPRB, &
  & 0.53560589E-09_JPRB, 0.53562621E-09_JPRB, 0.53564492E-09_JPRB, 0.53566473E-09_JPRB, 0.53567911E-09_JPRB, 0.53569305E-09_JPRB, &
  & 0.53569643E-09_JPRB, 0.53571064E-09_JPRB, 0.53571736E-09_JPRB, 0.53572063E-09_JPRB, 0.53571708E-09_JPRB, 0.53570737E-09_JPRB, &
  & 0.53569704E-09_JPRB, 0.53569305E-09_JPRB, 0.53569676E-09_JPRB, 0.53571103E-09_JPRB, 0.53573723E-09_JPRB, 0.53577476E-09_JPRB, &
  & 0.53581717E-09_JPRB, 0.53585464E-09_JPRB, 0.53589011E-09_JPRB, 0.53591476E-09_JPRB, 0.53593491E-09_JPRB, 0.53594745E-09_JPRB, &
  & 0.53595378E-09_JPRB, 0.53595511E-09_JPRB, 0.53595245E-09_JPRB, 0.53594074E-09_JPRB, 0.53592664E-09_JPRB, 0.53590765E-09_JPRB, &
  & 0.53588278E-09_JPRB, 0.53585530E-09_JPRB, 0.53583199E-09_JPRB, 0.53581339E-09_JPRB, 0.53580240E-09_JPRB, 0.53579718E-09_JPRB, &
  & 0.53579907E-09_JPRB, 0.53580151E-09_JPRB, 0.53580690E-09_JPRB, 0.53581473E-09_JPRB, 0.53581900E-09_JPRB, 0.53581956E-09_JPRB, &
  & 0.53581983E-09_JPRB, 0.53581650E-09_JPRB, 0.53581306E-09_JPRB, 0.53580818E-09_JPRB, 0.53579707E-09_JPRB, 0.53578630E-09_JPRB, &
  & 0.53577359E-09_JPRB, 0.53575955E-09_JPRB, 0.53574384E-09_JPRB, 0.53572874E-09_JPRB, 0.53571270E-09_JPRB, 0.53569960E-09_JPRB, &
  & 0.53568644E-09_JPRB, 0.53567256E-09_JPRB, 0.53564142E-09_JPRB, 0.53555332E-09_JPRB /)

RGHG6(:,77, 5) = (/ &
  & 0.53545290E-09_JPRB, 0.53558902E-09_JPRB, 0.53564486E-09_JPRB, 0.53567073E-09_JPRB, 0.53569110E-09_JPRB, 0.53570659E-09_JPRB, &
  & 0.53572374E-09_JPRB, 0.53573856E-09_JPRB, 0.53575411E-09_JPRB, 0.53576560E-09_JPRB, 0.53577620E-09_JPRB, 0.53577864E-09_JPRB, &
  & 0.53576804E-09_JPRB, 0.53577376E-09_JPRB, 0.53579896E-09_JPRB, 0.53580518E-09_JPRB, 0.53580418E-09_JPRB, 0.53579668E-09_JPRB, &
  & 0.53578791E-09_JPRB, 0.53578497E-09_JPRB, 0.53578691E-09_JPRB, 0.53579569E-09_JPRB, 0.53581362E-09_JPRB, 0.53584076E-09_JPRB, &
  & 0.53587190E-09_JPRB, 0.53589777E-09_JPRB, 0.53592347E-09_JPRB, 0.53593963E-09_JPRB, 0.53595345E-09_JPRB, 0.53596172E-09_JPRB, &
  & 0.53596616E-09_JPRB, 0.53596738E-09_JPRB, 0.53596699E-09_JPRB, 0.53595833E-09_JPRB, 0.53594928E-09_JPRB, 0.53593685E-09_JPRB, &
  & 0.53591914E-09_JPRB, 0.53589905E-09_JPRB, 0.53588295E-09_JPRB, 0.53586940E-09_JPRB, 0.53586130E-09_JPRB, 0.53585691E-09_JPRB, &
  & 0.53585902E-09_JPRB, 0.53586013E-09_JPRB, 0.53586408E-09_JPRB, 0.53587140E-09_JPRB, 0.53587468E-09_JPRB, 0.53587407E-09_JPRB, &
  & 0.53587457E-09_JPRB, 0.53587174E-09_JPRB, 0.53587024E-09_JPRB, 0.53586852E-09_JPRB, 0.53585925E-09_JPRB, 0.53585258E-09_JPRB, &
  & 0.53584420E-09_JPRB, 0.53583499E-09_JPRB, 0.53582438E-09_JPRB, 0.53581306E-09_JPRB, 0.53580163E-09_JPRB, 0.53579158E-09_JPRB, &
  & 0.53578308E-09_JPRB, 0.53577348E-09_JPRB, 0.53574745E-09_JPRB, 0.53567129E-09_JPRB /)

RGHG6(:,78, 5) = (/ &
  & 0.53562366E-09_JPRB, 0.53572791E-09_JPRB, 0.53576993E-09_JPRB, 0.53578636E-09_JPRB, 0.53580068E-09_JPRB, 0.53580929E-09_JPRB, &
  & 0.53582200E-09_JPRB, 0.53583138E-09_JPRB, 0.53584098E-09_JPRB, 0.53584925E-09_JPRB, 0.53585497E-09_JPRB, 0.53585697E-09_JPRB, &
  & 0.53584720E-09_JPRB, 0.53585347E-09_JPRB, 0.53586874E-09_JPRB, 0.53587440E-09_JPRB, 0.53587557E-09_JPRB, 0.53587024E-09_JPRB, &
  & 0.53586291E-09_JPRB, 0.53586152E-09_JPRB, 0.53586235E-09_JPRB, 0.53586713E-09_JPRB, 0.53587829E-09_JPRB, 0.53589705E-09_JPRB, &
  & 0.53591864E-09_JPRB, 0.53593491E-09_JPRB, 0.53595184E-09_JPRB, 0.53596061E-09_JPRB, 0.53596944E-09_JPRB, 0.53597438E-09_JPRB, &
  & 0.53597798E-09_JPRB, 0.53597898E-09_JPRB, 0.53597998E-09_JPRB, 0.53597304E-09_JPRB, 0.53596827E-09_JPRB, 0.53596144E-09_JPRB, &
  & 0.53594995E-09_JPRB, 0.53593607E-09_JPRB, 0.53592614E-09_JPRB, 0.53591692E-09_JPRB, 0.53591137E-09_JPRB, 0.53590754E-09_JPRB, &
  & 0.53590976E-09_JPRB, 0.53590965E-09_JPRB, 0.53591220E-09_JPRB, 0.53591931E-09_JPRB, 0.53592158E-09_JPRB, 0.53591948E-09_JPRB, &
  & 0.53592014E-09_JPRB, 0.53591742E-09_JPRB, 0.53591748E-09_JPRB, 0.53591837E-09_JPRB, 0.53591065E-09_JPRB, 0.53590732E-09_JPRB, &
  & 0.53590277E-09_JPRB, 0.53589816E-09_JPRB, 0.53589150E-09_JPRB, 0.53588456E-09_JPRB, 0.53587590E-09_JPRB, 0.53586963E-09_JPRB, &
  & 0.53586485E-09_JPRB, 0.53585963E-09_JPRB, 0.53584043E-09_JPRB, 0.53578270E-09_JPRB /)

RGHG6(:,79, 5) = (/ &
  & 0.53573407E-09_JPRB, 0.53580557E-09_JPRB, 0.53583715E-09_JPRB, 0.53584670E-09_JPRB, 0.53585769E-09_JPRB, 0.53586241E-09_JPRB, &
  & 0.53587279E-09_JPRB, 0.53587884E-09_JPRB, 0.53588634E-09_JPRB, 0.53589211E-09_JPRB, 0.53589644E-09_JPRB, 0.53589827E-09_JPRB, &
  & 0.53588795E-09_JPRB, 0.53589516E-09_JPRB, 0.53590471E-09_JPRB, 0.53591048E-09_JPRB, 0.53591342E-09_JPRB, 0.53590909E-09_JPRB, &
  & 0.53590232E-09_JPRB, 0.53590182E-09_JPRB, 0.53590216E-09_JPRB, 0.53590460E-09_JPRB, 0.53591237E-09_JPRB, 0.53592686E-09_JPRB, &
  & 0.53594390E-09_JPRB, 0.53595495E-09_JPRB, 0.53596733E-09_JPRB, 0.53597177E-09_JPRB, 0.53597776E-09_JPRB, 0.53598098E-09_JPRB, &
  & 0.53598426E-09_JPRB, 0.53598531E-09_JPRB, 0.53598731E-09_JPRB, 0.53598098E-09_JPRB, 0.53597876E-09_JPRB, 0.53597526E-09_JPRB, &
  & 0.53596699E-09_JPRB, 0.53595622E-09_JPRB, 0.53594945E-09_JPRB, 0.53594235E-09_JPRB, 0.53593791E-09_JPRB, 0.53593407E-09_JPRB, &
  & 0.53593652E-09_JPRB, 0.53593546E-09_JPRB, 0.53593741E-09_JPRB, 0.53594484E-09_JPRB, 0.53594645E-09_JPRB, 0.53594318E-09_JPRB, &
  & 0.53594390E-09_JPRB, 0.53594085E-09_JPRB, 0.53594196E-09_JPRB, 0.53594457E-09_JPRB, 0.53593691E-09_JPRB, 0.53593546E-09_JPRB, &
  & 0.53593296E-09_JPRB, 0.53593074E-09_JPRB, 0.53592625E-09_JPRB, 0.53592125E-09_JPRB, 0.53591409E-09_JPRB, 0.53590926E-09_JPRB, &
  & 0.53590693E-09_JPRB, 0.53590510E-09_JPRB, 0.53589139E-09_JPRB, 0.53585270E-09_JPRB /)

RGHG6(:,80, 5) = (/ &
  & 0.53580712E-09_JPRB, 0.53584287E-09_JPRB, 0.53586680E-09_JPRB, 0.53587290E-09_JPRB, 0.53588239E-09_JPRB, 0.53588511E-09_JPRB, &
  & 0.53589483E-09_JPRB, 0.53589938E-09_JPRB, 0.53590632E-09_JPRB, 0.53591126E-09_JPRB, 0.53591503E-09_JPRB, 0.53591692E-09_JPRB, &
  & 0.53590610E-09_JPRB, 0.53591409E-09_JPRB, 0.53592075E-09_JPRB, 0.53592675E-09_JPRB, 0.53593074E-09_JPRB, 0.53592675E-09_JPRB, &
  & 0.53592003E-09_JPRB, 0.53592014E-09_JPRB, 0.53592014E-09_JPRB, 0.53592125E-09_JPRB, 0.53592747E-09_JPRB, 0.53594035E-09_JPRB, &
  & 0.53595550E-09_JPRB, 0.53596422E-09_JPRB, 0.53597449E-09_JPRB, 0.53597676E-09_JPRB, 0.53598143E-09_JPRB, 0.53598387E-09_JPRB, &
  & 0.53598703E-09_JPRB, 0.53598820E-09_JPRB, 0.53599092E-09_JPRB, 0.53598481E-09_JPRB, 0.53598376E-09_JPRB, 0.53598193E-09_JPRB, &
  & 0.53597499E-09_JPRB, 0.53596549E-09_JPRB, 0.53596017E-09_JPRB, 0.53595384E-09_JPRB, 0.53594984E-09_JPRB, 0.53594584E-09_JPRB, &
  & 0.53594834E-09_JPRB, 0.53594684E-09_JPRB, 0.53594840E-09_JPRB, 0.53595628E-09_JPRB, 0.53595772E-09_JPRB, 0.53595350E-09_JPRB, &
  & 0.53595423E-09_JPRB, 0.53595089E-09_JPRB, 0.53595250E-09_JPRB, 0.53595606E-09_JPRB, 0.53594817E-09_JPRB, 0.53594751E-09_JPRB, &
  & 0.53594595E-09_JPRB, 0.53594507E-09_JPRB, 0.53594129E-09_JPRB, 0.53593707E-09_JPRB, 0.53593030E-09_JPRB, 0.53592614E-09_JPRB, &
  & 0.53592497E-09_JPRB, 0.53592503E-09_JPRB, 0.53591553E-09_JPRB, 0.53589788E-09_JPRB /)

RGHG6(:,81, 5) = (/ &
  & 0.53585697E-09_JPRB, 0.53585852E-09_JPRB, 0.53587956E-09_JPRB, 0.53588395E-09_JPRB, 0.53589305E-09_JPRB, 0.53589494E-09_JPRB, &
  & 0.53590421E-09_JPRB, 0.53590876E-09_JPRB, 0.53591481E-09_JPRB, 0.53592014E-09_JPRB, 0.53592325E-09_JPRB, 0.53592530E-09_JPRB, &
  & 0.53591431E-09_JPRB, 0.53592247E-09_JPRB, 0.53592769E-09_JPRB, 0.53593391E-09_JPRB, 0.53593879E-09_JPRB, 0.53593496E-09_JPRB, &
  & 0.53592786E-09_JPRB, 0.53592841E-09_JPRB, 0.53592825E-09_JPRB, 0.53592863E-09_JPRB, 0.53593407E-09_JPRB, 0.53594623E-09_JPRB, &
  & 0.53596072E-09_JPRB, 0.53596827E-09_JPRB, 0.53597776E-09_JPRB, 0.53597904E-09_JPRB, 0.53598304E-09_JPRB, 0.53598509E-09_JPRB, &
  & 0.53598831E-09_JPRB, 0.53598942E-09_JPRB, 0.53599247E-09_JPRB, 0.53598631E-09_JPRB, 0.53598581E-09_JPRB, 0.53598487E-09_JPRB, &
  & 0.53597854E-09_JPRB, 0.53596971E-09_JPRB, 0.53596494E-09_JPRB, 0.53595894E-09_JPRB, 0.53595500E-09_JPRB, 0.53595089E-09_JPRB, &
  & 0.53595328E-09_JPRB, 0.53595173E-09_JPRB, 0.53595317E-09_JPRB, 0.53596128E-09_JPRB, 0.53596272E-09_JPRB, 0.53595783E-09_JPRB, &
  & 0.53595861E-09_JPRB, 0.53595495E-09_JPRB, 0.53595695E-09_JPRB, 0.53596128E-09_JPRB, 0.53595289E-09_JPRB, 0.53595284E-09_JPRB, &
  & 0.53595162E-09_JPRB, 0.53595117E-09_JPRB, 0.53594773E-09_JPRB, 0.53594384E-09_JPRB, 0.53593724E-09_JPRB, 0.53593313E-09_JPRB, &
  & 0.53593258E-09_JPRB, 0.53593352E-09_JPRB, 0.53592558E-09_JPRB, 0.53592819E-09_JPRB /)

RGHG6(:,82, 5) = (/ &
  & 0.53586086E-09_JPRB, 0.53586358E-09_JPRB, 0.53588517E-09_JPRB, 0.53588922E-09_JPRB, 0.53589816E-09_JPRB, 0.53589938E-09_JPRB, &
  & 0.53590915E-09_JPRB, 0.53591231E-09_JPRB, 0.53591998E-09_JPRB, 0.53592386E-09_JPRB, 0.53592769E-09_JPRB, 0.53592941E-09_JPRB, &
  & 0.53591864E-09_JPRB, 0.53592686E-09_JPRB, 0.53593108E-09_JPRB, 0.53593752E-09_JPRB, 0.53594290E-09_JPRB, 0.53593907E-09_JPRB, &
  & 0.53593185E-09_JPRB, 0.53593258E-09_JPRB, 0.53593230E-09_JPRB, 0.53593208E-09_JPRB, 0.53593702E-09_JPRB, 0.53594912E-09_JPRB, &
  & 0.53596350E-09_JPRB, 0.53597038E-09_JPRB, 0.53597948E-09_JPRB, 0.53598004E-09_JPRB, 0.53598370E-09_JPRB, 0.53598553E-09_JPRB, &
  & 0.53598881E-09_JPRB, 0.53599009E-09_JPRB, 0.53599336E-09_JPRB, 0.53598720E-09_JPRB, 0.53598698E-09_JPRB, 0.53598631E-09_JPRB, &
  & 0.53598037E-09_JPRB, 0.53597188E-09_JPRB, 0.53596716E-09_JPRB, 0.53596133E-09_JPRB, 0.53595750E-09_JPRB, 0.53595350E-09_JPRB, &
  & 0.53595572E-09_JPRB, 0.53595411E-09_JPRB, 0.53595528E-09_JPRB, 0.53596383E-09_JPRB, 0.53596516E-09_JPRB, 0.53595989E-09_JPRB, &
  & 0.53596066E-09_JPRB, 0.53595683E-09_JPRB, 0.53595911E-09_JPRB, 0.53596377E-09_JPRB, 0.53595517E-09_JPRB, 0.53595528E-09_JPRB, &
  & 0.53595423E-09_JPRB, 0.53595411E-09_JPRB, 0.53595089E-09_JPRB, 0.53594723E-09_JPRB, 0.53594046E-09_JPRB, 0.53593652E-09_JPRB, &
  & 0.53593613E-09_JPRB, 0.53593735E-09_JPRB, 0.53592891E-09_JPRB, 0.53593058E-09_JPRB /)

RGHG6(:,83, 5) = (/ &
  & 0.53586352E-09_JPRB, 0.53586657E-09_JPRB, 0.53588839E-09_JPRB, 0.53589216E-09_JPRB, 0.53590116E-09_JPRB, 0.53590254E-09_JPRB, &
  & 0.53591120E-09_JPRB, 0.53591620E-09_JPRB, 0.53592120E-09_JPRB, 0.53592708E-09_JPRB, 0.53592947E-09_JPRB, 0.53593119E-09_JPRB, &
  & 0.53592192E-09_JPRB, 0.53592908E-09_JPRB, 0.53593302E-09_JPRB, 0.53593946E-09_JPRB, 0.53594529E-09_JPRB, 0.53594168E-09_JPRB, &
  & 0.53593402E-09_JPRB, 0.53593496E-09_JPRB, 0.53593457E-09_JPRB, 0.53593407E-09_JPRB, 0.53593857E-09_JPRB, 0.53595067E-09_JPRB, &
  & 0.53596527E-09_JPRB, 0.53597149E-09_JPRB, 0.53598048E-09_JPRB, 0.53598065E-09_JPRB, 0.53598415E-09_JPRB, 0.53598581E-09_JPRB, &
  & 0.53598914E-09_JPRB, 0.53599031E-09_JPRB, 0.53599375E-09_JPRB, 0.53598748E-09_JPRB, 0.53598759E-09_JPRB, 0.53598698E-09_JPRB, &
  & 0.53598115E-09_JPRB, 0.53597304E-09_JPRB, 0.53596844E-09_JPRB, 0.53596277E-09_JPRB, 0.53595889E-09_JPRB, 0.53595506E-09_JPRB, &
  & 0.53595695E-09_JPRB, 0.53595539E-09_JPRB, 0.53595650E-09_JPRB, 0.53596516E-09_JPRB, 0.53596655E-09_JPRB, 0.53596105E-09_JPRB, &
  & 0.53596177E-09_JPRB, 0.53595800E-09_JPRB, 0.53596033E-09_JPRB, 0.53596533E-09_JPRB, 0.53595639E-09_JPRB, 0.53595661E-09_JPRB, &
  & 0.53595578E-09_JPRB, 0.53595584E-09_JPRB, 0.53595267E-09_JPRB, 0.53594901E-09_JPRB, 0.53594240E-09_JPRB, 0.53593846E-09_JPRB, &
  & 0.53593813E-09_JPRB, 0.53593946E-09_JPRB, 0.53593091E-09_JPRB, 0.53593219E-09_JPRB /)

RGHG6(:,84, 5) = (/ &
  & 0.53586519E-09_JPRB, 0.53586841E-09_JPRB, 0.53589039E-09_JPRB, 0.53589400E-09_JPRB, 0.53590299E-09_JPRB, 0.53590377E-09_JPRB, &
  & 0.53591370E-09_JPRB, 0.53591664E-09_JPRB, 0.53592436E-09_JPRB, 0.53592752E-09_JPRB, 0.53593108E-09_JPRB, 0.53593213E-09_JPRB, &
  & 0.53592414E-09_JPRB, 0.53593047E-09_JPRB, 0.53593413E-09_JPRB, 0.53594063E-09_JPRB, 0.53594668E-09_JPRB, 0.53594318E-09_JPRB, &
  & 0.53593541E-09_JPRB, 0.53593652E-09_JPRB, 0.53593607E-09_JPRB, 0.53593530E-09_JPRB, 0.53593963E-09_JPRB, 0.53595173E-09_JPRB, &
  & 0.53596638E-09_JPRB, 0.53597232E-09_JPRB, 0.53598115E-09_JPRB, 0.53598098E-09_JPRB, 0.53598442E-09_JPRB, 0.53598581E-09_JPRB, &
  & 0.53598931E-09_JPRB, 0.53599047E-09_JPRB, 0.53599403E-09_JPRB, 0.53598770E-09_JPRB, 0.53598798E-09_JPRB, 0.53598737E-09_JPRB, &
  & 0.53598170E-09_JPRB, 0.53597393E-09_JPRB, 0.53596916E-09_JPRB, 0.53596377E-09_JPRB, 0.53595994E-09_JPRB, 0.53595628E-09_JPRB, &
  & 0.53595767E-09_JPRB, 0.53595628E-09_JPRB, 0.53595722E-09_JPRB, 0.53596594E-09_JPRB, 0.53596749E-09_JPRB, 0.53596183E-09_JPRB, &
  & 0.53596255E-09_JPRB, 0.53595861E-09_JPRB, 0.53596105E-09_JPRB, 0.53596622E-09_JPRB, 0.53595706E-09_JPRB, 0.53595728E-09_JPRB, &
  & 0.53595661E-09_JPRB, 0.53595689E-09_JPRB, 0.53595373E-09_JPRB, 0.53595028E-09_JPRB, 0.53594346E-09_JPRB, 0.53593951E-09_JPRB, &
  & 0.53593929E-09_JPRB, 0.53594085E-09_JPRB, 0.53593208E-09_JPRB, 0.53593330E-09_JPRB /)

RGHG6(:,85, 5) = (/ &
  & 0.53586635E-09_JPRB, 0.53586957E-09_JPRB, 0.53589183E-09_JPRB, 0.53589533E-09_JPRB, 0.53590432E-09_JPRB, 0.53590610E-09_JPRB, &
  & 0.53591398E-09_JPRB, 0.53591959E-09_JPRB, 0.53592386E-09_JPRB, 0.53592908E-09_JPRB, 0.53593086E-09_JPRB, 0.53593185E-09_JPRB, &
  & 0.53592708E-09_JPRB, 0.53593180E-09_JPRB, 0.53593530E-09_JPRB, 0.53594112E-09_JPRB, 0.53594701E-09_JPRB, 0.53594423E-09_JPRB, &
  & 0.53593641E-09_JPRB, 0.53593746E-09_JPRB, 0.53593685E-09_JPRB, 0.53593591E-09_JPRB, 0.53594007E-09_JPRB, 0.53595228E-09_JPRB, &
  & 0.53596716E-09_JPRB, 0.53597266E-09_JPRB, 0.53598170E-09_JPRB, 0.53598120E-09_JPRB, 0.53598453E-09_JPRB, 0.53598592E-09_JPRB, &
  & 0.53598942E-09_JPRB, 0.53599053E-09_JPRB, 0.53599414E-09_JPRB, 0.53598787E-09_JPRB, 0.53598825E-09_JPRB, 0.53598759E-09_JPRB, &
  & 0.53598198E-09_JPRB, 0.53597421E-09_JPRB, 0.53596955E-09_JPRB, 0.53596438E-09_JPRB, 0.53596061E-09_JPRB, 0.53595706E-09_JPRB, &
  & 0.53595811E-09_JPRB, 0.53595672E-09_JPRB, 0.53595778E-09_JPRB, 0.53596627E-09_JPRB, 0.53596794E-09_JPRB, 0.53596239E-09_JPRB, &
  & 0.53596305E-09_JPRB, 0.53595900E-09_JPRB, 0.53596161E-09_JPRB, 0.53596705E-09_JPRB, 0.53595756E-09_JPRB, 0.53595794E-09_JPRB, &
  & 0.53595739E-09_JPRB, 0.53595778E-09_JPRB, 0.53595450E-09_JPRB, 0.53595095E-09_JPRB, 0.53594429E-09_JPRB, 0.53594018E-09_JPRB, &
  & 0.53594007E-09_JPRB, 0.53594185E-09_JPRB, 0.53593291E-09_JPRB, 0.53593396E-09_JPRB /)

RGHG6(:,86, 5) = (/ &
  & 0.53586702E-09_JPRB, 0.53587046E-09_JPRB, 0.53589277E-09_JPRB, 0.53589599E-09_JPRB, 0.53590526E-09_JPRB, 0.53590654E-09_JPRB, &
  & 0.53591642E-09_JPRB, 0.53591964E-09_JPRB, 0.53592597E-09_JPRB, 0.53592863E-09_JPRB, 0.53593169E-09_JPRB, 0.53593235E-09_JPRB, &
  & 0.53592875E-09_JPRB, 0.53593219E-09_JPRB, 0.53593557E-09_JPRB, 0.53594107E-09_JPRB, 0.53594651E-09_JPRB, 0.53594462E-09_JPRB, &
  & 0.53593729E-09_JPRB, 0.53593824E-09_JPRB, 0.53593757E-09_JPRB, 0.53593641E-09_JPRB, 0.53594040E-09_JPRB, 0.53595262E-09_JPRB, &
  & 0.53596766E-09_JPRB, 0.53597304E-09_JPRB, 0.53598204E-09_JPRB, 0.53598131E-09_JPRB, 0.53598470E-09_JPRB, 0.53598592E-09_JPRB, &
  & 0.53598953E-09_JPRB, 0.53599070E-09_JPRB, 0.53599430E-09_JPRB, 0.53598787E-09_JPRB, 0.53598848E-09_JPRB, 0.53598792E-09_JPRB, &
  & 0.53598215E-09_JPRB, 0.53597454E-09_JPRB, 0.53596977E-09_JPRB, 0.53596461E-09_JPRB, 0.53596078E-09_JPRB, 0.53595739E-09_JPRB, &
  & 0.53595839E-09_JPRB, 0.53595706E-09_JPRB, 0.53595789E-09_JPRB, 0.53596660E-09_JPRB, 0.53596810E-09_JPRB, 0.53596261E-09_JPRB, &
  & 0.53596338E-09_JPRB, 0.53595928E-09_JPRB, 0.53596172E-09_JPRB, 0.53596733E-09_JPRB, 0.53595778E-09_JPRB, 0.53595817E-09_JPRB, &
  & 0.53595756E-09_JPRB, 0.53595817E-09_JPRB, 0.53595495E-09_JPRB, 0.53595151E-09_JPRB, 0.53594468E-09_JPRB, 0.53594074E-09_JPRB, &
  & 0.53594063E-09_JPRB, 0.53594257E-09_JPRB, 0.53593335E-09_JPRB, 0.53593441E-09_JPRB /)

RGHG6(:,87, 5) = (/ &
  & 0.53586752E-09_JPRB, 0.53587124E-09_JPRB, 0.53589300E-09_JPRB, 0.53589677E-09_JPRB, 0.53590576E-09_JPRB, 0.53590893E-09_JPRB, &
  & 0.53591609E-09_JPRB, 0.53592170E-09_JPRB, 0.53592542E-09_JPRB, 0.53592963E-09_JPRB, 0.53593108E-09_JPRB, 0.53593202E-09_JPRB, &
  & 0.53593041E-09_JPRB, 0.53593352E-09_JPRB, 0.53593618E-09_JPRB, 0.53594096E-09_JPRB, 0.53594584E-09_JPRB, 0.53594457E-09_JPRB, &
  & 0.53593807E-09_JPRB, 0.53593868E-09_JPRB, 0.53593796E-09_JPRB, 0.53593663E-09_JPRB, 0.53594051E-09_JPRB, 0.53595289E-09_JPRB, &
  & 0.53596794E-09_JPRB, 0.53597315E-09_JPRB, 0.53598237E-09_JPRB, 0.53598148E-09_JPRB, 0.53598470E-09_JPRB, 0.53598598E-09_JPRB, &
  & 0.53598970E-09_JPRB, 0.53599070E-09_JPRB, 0.53599447E-09_JPRB, 0.53598781E-09_JPRB, 0.53598875E-09_JPRB, 0.53598853E-09_JPRB, &
  & 0.53598304E-09_JPRB, 0.53597471E-09_JPRB, 0.53597016E-09_JPRB, 0.53596466E-09_JPRB, 0.53596078E-09_JPRB, 0.53595711E-09_JPRB, &
  & 0.53595850E-09_JPRB, 0.53595695E-09_JPRB, 0.53595806E-09_JPRB, 0.53596688E-09_JPRB, 0.53596838E-09_JPRB, 0.53596283E-09_JPRB, &
  & 0.53596344E-09_JPRB, 0.53595950E-09_JPRB, 0.53596183E-09_JPRB, 0.53596749E-09_JPRB, 0.53595794E-09_JPRB, 0.53595839E-09_JPRB, &
  & 0.53595772E-09_JPRB, 0.53595833E-09_JPRB, 0.53595528E-09_JPRB, 0.53595167E-09_JPRB, 0.53594496E-09_JPRB, 0.53594101E-09_JPRB, &
  & 0.53594090E-09_JPRB, 0.53594290E-09_JPRB, 0.53593358E-09_JPRB, 0.53593469E-09_JPRB /)

RGHG6(:,88, 5) = (/ &
  & 0.53586802E-09_JPRB, 0.53587262E-09_JPRB, 0.53589283E-09_JPRB, 0.53589677E-09_JPRB, 0.53590621E-09_JPRB, 0.53590843E-09_JPRB, &
  & 0.53591781E-09_JPRB, 0.53592147E-09_JPRB, 0.53592697E-09_JPRB, 0.53592941E-09_JPRB, 0.53593197E-09_JPRB, 0.53593263E-09_JPRB, &
  & 0.53593102E-09_JPRB, 0.53593335E-09_JPRB, 0.53593630E-09_JPRB, 0.53594085E-09_JPRB, 0.53594573E-09_JPRB, 0.53594484E-09_JPRB, &
  & 0.53593840E-09_JPRB, 0.53593896E-09_JPRB, 0.53593813E-09_JPRB, 0.53593663E-09_JPRB, 0.53594051E-09_JPRB, 0.53595289E-09_JPRB, &
  & 0.53596816E-09_JPRB, 0.53597332E-09_JPRB, 0.53598254E-09_JPRB, 0.53598143E-09_JPRB, 0.53598470E-09_JPRB, 0.53598598E-09_JPRB, &
  & 0.53598970E-09_JPRB, 0.53599064E-09_JPRB, 0.53599458E-09_JPRB, 0.53598775E-09_JPRB, 0.53598898E-09_JPRB, 0.53598920E-09_JPRB, &
  & 0.53598365E-09_JPRB, 0.53597504E-09_JPRB, 0.53597043E-09_JPRB, 0.53596450E-09_JPRB, 0.53596050E-09_JPRB, 0.53595622E-09_JPRB, &
  & 0.53595856E-09_JPRB, 0.53595667E-09_JPRB, 0.53595761E-09_JPRB, 0.53596744E-09_JPRB, 0.53596849E-09_JPRB, 0.53596294E-09_JPRB, &
  & 0.53596350E-09_JPRB, 0.53595961E-09_JPRB, 0.53596189E-09_JPRB, 0.53596738E-09_JPRB, 0.53595800E-09_JPRB, 0.53595839E-09_JPRB, &
  & 0.53595783E-09_JPRB, 0.53595856E-09_JPRB, 0.53595556E-09_JPRB, 0.53595206E-09_JPRB, 0.53594490E-09_JPRB, 0.53594118E-09_JPRB, &
  & 0.53594118E-09_JPRB, 0.53594329E-09_JPRB, 0.53593374E-09_JPRB, 0.53593491E-09_JPRB /)

RGHG6(:,89, 5) = (/ &
  & 0.53586896E-09_JPRB, 0.53587418E-09_JPRB, 0.53589227E-09_JPRB, 0.53589694E-09_JPRB, 0.53590610E-09_JPRB, 0.53590921E-09_JPRB, &
  & 0.53591681E-09_JPRB, 0.53592220E-09_JPRB, 0.53592630E-09_JPRB, 0.53593008E-09_JPRB, 0.53593147E-09_JPRB, 0.53593230E-09_JPRB, &
  & 0.53593097E-09_JPRB, 0.53593374E-09_JPRB, 0.53593630E-09_JPRB, 0.53594107E-09_JPRB, 0.53594629E-09_JPRB, 0.53594512E-09_JPRB, &
  & 0.53593824E-09_JPRB, 0.53593913E-09_JPRB, 0.53593829E-09_JPRB, 0.53593652E-09_JPRB, 0.53594040E-09_JPRB, 0.53595295E-09_JPRB, &
  & 0.53596838E-09_JPRB, 0.53597343E-09_JPRB, 0.53598276E-09_JPRB, 0.53598143E-09_JPRB, 0.53598481E-09_JPRB, 0.53598598E-09_JPRB, &
  & 0.53598981E-09_JPRB, 0.53599070E-09_JPRB, 0.53599480E-09_JPRB, 0.53598764E-09_JPRB, 0.53598909E-09_JPRB, 0.53598975E-09_JPRB, &
  & 0.53598437E-09_JPRB, 0.53597510E-09_JPRB, 0.53597093E-09_JPRB, 0.53596450E-09_JPRB, 0.53596033E-09_JPRB, 0.53595522E-09_JPRB, &
  & 0.53595894E-09_JPRB, 0.53595645E-09_JPRB, 0.53595739E-09_JPRB, 0.53596777E-09_JPRB, 0.53596866E-09_JPRB, 0.53596300E-09_JPRB, &
  & 0.53596350E-09_JPRB, 0.53595972E-09_JPRB, 0.53596183E-09_JPRB, 0.53596738E-09_JPRB, 0.53595800E-09_JPRB, 0.53595839E-09_JPRB, &
  & 0.53595783E-09_JPRB, 0.53595856E-09_JPRB, 0.53595567E-09_JPRB, 0.53595212E-09_JPRB, 0.53594496E-09_JPRB, 0.53594124E-09_JPRB, &
  & 0.53594124E-09_JPRB, 0.53594351E-09_JPRB, 0.53593369E-09_JPRB, 0.53593491E-09_JPRB /)

RGHG6(:,90, 5) = (/ &
  & 0.53586996E-09_JPRB, 0.53587590E-09_JPRB, 0.53589116E-09_JPRB, 0.53589633E-09_JPRB, 0.53590615E-09_JPRB, 0.53590715E-09_JPRB, &
  & 0.53591692E-09_JPRB, 0.53592086E-09_JPRB, 0.53592725E-09_JPRB, 0.53593030E-09_JPRB, 0.53593241E-09_JPRB, 0.53593280E-09_JPRB, &
  & 0.53593008E-09_JPRB, 0.53593296E-09_JPRB, 0.53593596E-09_JPRB, 0.53594162E-09_JPRB, 0.53594784E-09_JPRB, 0.53594607E-09_JPRB, &
  & 0.53593757E-09_JPRB, 0.53593924E-09_JPRB, 0.53593840E-09_JPRB, 0.53593646E-09_JPRB, 0.53594018E-09_JPRB, 0.53595295E-09_JPRB, &
  & 0.53596871E-09_JPRB, 0.53597343E-09_JPRB, 0.53598326E-09_JPRB, 0.53598131E-09_JPRB, 0.53598481E-09_JPRB, 0.53598587E-09_JPRB, &
  & 0.53598986E-09_JPRB, 0.53599059E-09_JPRB, 0.53599525E-09_JPRB, 0.53598737E-09_JPRB, 0.53598920E-09_JPRB, 0.53599020E-09_JPRB, &
  & 0.53598481E-09_JPRB, 0.53597510E-09_JPRB, 0.53597127E-09_JPRB, 0.53596427E-09_JPRB, 0.53596039E-09_JPRB, 0.53595406E-09_JPRB, &
  & 0.53595944E-09_JPRB, 0.53595606E-09_JPRB, 0.53595695E-09_JPRB, 0.53596827E-09_JPRB, 0.53596910E-09_JPRB, 0.53596289E-09_JPRB, &
  & 0.53596372E-09_JPRB, 0.53595961E-09_JPRB, 0.53596183E-09_JPRB, 0.53596783E-09_JPRB, 0.53595783E-09_JPRB, 0.53595833E-09_JPRB, &
  & 0.53595783E-09_JPRB, 0.53595872E-09_JPRB, 0.53595572E-09_JPRB, 0.53595228E-09_JPRB, 0.53594490E-09_JPRB, 0.53594118E-09_JPRB, &
  & 0.53594129E-09_JPRB, 0.53594384E-09_JPRB, 0.53593341E-09_JPRB, 0.53593491E-09_JPRB /)

RGHG6(:,91, 5) = (/ &
  & 0.53587046E-09_JPRB, 0.53587690E-09_JPRB, 0.53588944E-09_JPRB, 0.53589594E-09_JPRB, 0.53590704E-09_JPRB, 0.53590515E-09_JPRB, &
  & 0.53591614E-09_JPRB, 0.53591753E-09_JPRB, 0.53592625E-09_JPRB, 0.53593147E-09_JPRB, 0.53593679E-09_JPRB, 0.53593746E-09_JPRB, &
  & 0.53592020E-09_JPRB, 0.53593424E-09_JPRB, 0.53593502E-09_JPRB, 0.53594268E-09_JPRB, 0.53595117E-09_JPRB, 0.53594706E-09_JPRB, &
  & 0.53593607E-09_JPRB, 0.53593951E-09_JPRB, 0.53593857E-09_JPRB, 0.53593602E-09_JPRB, 0.53593957E-09_JPRB, 0.53595267E-09_JPRB, &
  & 0.53596955E-09_JPRB, 0.53597299E-09_JPRB, 0.53598403E-09_JPRB, 0.53598104E-09_JPRB, 0.53598503E-09_JPRB, 0.53598559E-09_JPRB, &
  & 0.53599009E-09_JPRB, 0.53599031E-09_JPRB, 0.53599636E-09_JPRB, 0.53598642E-09_JPRB, 0.53598920E-09_JPRB, 0.53599070E-09_JPRB, &
  & 0.53598526E-09_JPRB, 0.53597460E-09_JPRB, 0.53597177E-09_JPRB, 0.53596405E-09_JPRB, 0.53596061E-09_JPRB, 0.53595300E-09_JPRB, &
  & 0.53596039E-09_JPRB, 0.53595556E-09_JPRB, 0.53595606E-09_JPRB, 0.53596932E-09_JPRB, 0.53597016E-09_JPRB, 0.53596205E-09_JPRB, &
  & 0.53596411E-09_JPRB, 0.53595883E-09_JPRB, 0.53596133E-09_JPRB, 0.53596916E-09_JPRB, 0.53595683E-09_JPRB, 0.53595850E-09_JPRB, &
  & 0.53595778E-09_JPRB, 0.53595905E-09_JPRB, 0.53595584E-09_JPRB, 0.53595256E-09_JPRB, 0.53594462E-09_JPRB, 0.53594090E-09_JPRB, &
  & 0.53594118E-09_JPRB, 0.53594440E-09_JPRB, 0.53593274E-09_JPRB, 0.53593491E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART10',1,ZHOOK_HANDLE)
END SUBROUTINE PART10






SUBROUTINE PART11
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART11',0,ZHOOK_HANDLE)



!-- Month=  6 ------------

RGHG6(:, 1, 6) = (/ &
  & 0.27524607E-37_JPRB, 0.17214472E-36_JPRB, 0.31235851E-36_JPRB, 0.39530899E-36_JPRB, 0.46483379E-36_JPRB, 0.56011344E-36_JPRB, &
  & 0.69166720E-36_JPRB, 0.89776865E-36_JPRB, 0.12307054E-35_JPRB, 0.17768384E-35_JPRB, 0.26611364E-35_JPRB, 0.40760503E-35_JPRB, &
  & 0.63107789E-35_JPRB, 0.97641724E-35_JPRB, 0.14984300E-34_JPRB, 0.22709023E-34_JPRB, 0.34148145E-34_JPRB, 0.51589646E-34_JPRB, &
  & 0.79378321E-34_JPRB, 0.12645684E-33_JPRB, 0.21074146E-33_JPRB, 0.36654315E-33_JPRB, 0.65375357E-33_JPRB, 0.11752470E-32_JPRB, &
  & 0.20834706E-32_JPRB, 0.35972919E-32_JPRB, 0.57386345E-32_JPRB, 0.84674847E-32_JPRB, 0.11464643E-31_JPRB, 0.14881165E-31_JPRB, &
  & 0.18145973E-31_JPRB, 0.20765814E-31_JPRB, 0.22577154E-31_JPRB, 0.23567555E-31_JPRB, 0.23758369E-31_JPRB, 0.23323382E-31_JPRB, &
  & 0.22278818E-31_JPRB, 0.20504327E-31_JPRB, 0.17642068E-31_JPRB, 0.14350564E-31_JPRB, 0.11189047E-31_JPRB, 0.84323485E-32_JPRB, &
  & 0.60818998E-32_JPRB, 0.42052671E-32_JPRB, 0.27657220E-32_JPRB, 0.16919022E-32_JPRB, 0.96600858E-33_JPRB, 0.54445147E-33_JPRB, &
  & 0.29903052E-33_JPRB, 0.16249784E-33_JPRB, 0.85760280E-34_JPRB, 0.44478720E-34_JPRB, 0.23115448E-34_JPRB, 0.12072179E-34_JPRB, &
  & 0.63740944E-35_JPRB, 0.34243250E-35_JPRB, 0.19370554E-35_JPRB, 0.11916039E-35_JPRB, 0.81707592E-36_JPRB, 0.63726328E-36_JPRB, &
  & 0.54381645E-36_JPRB, 0.43245192E-36_JPRB, 0.20333291E-36_JPRB, 0.12233184E-37_JPRB /)

RGHG6(:, 2, 6) = (/ &
  & 0.19676865E-35_JPRB, 0.69494833E-35_JPRB, 0.12332698E-34_JPRB, 0.16052807E-34_JPRB, 0.19145289E-34_JPRB, 0.22916845E-34_JPRB, &
  & 0.28336666E-34_JPRB, 0.36985191E-34_JPRB, 0.50995666E-34_JPRB, 0.73843476E-34_JPRB, 0.11074857E-33_JPRB, 0.16956616E-33_JPRB, &
  & 0.26210705E-33_JPRB, 0.40467059E-33_JPRB, 0.61991389E-33_JPRB, 0.93929125E-33_JPRB, 0.14151593E-32_JPRB, 0.21461460E-32_JPRB, &
  & 0.33198326E-32_JPRB, 0.53162143E-32_JPRB, 0.88861363E-32_JPRB, 0.15450092E-31_JPRB, 0.27487642E-31_JPRB, 0.49215292E-31_JPRB, &
  & 0.86477946E-31_JPRB, 0.14625571E-30_JPRB, 0.22874250E-30_JPRB, 0.33412174E-30_JPRB, 0.45242276E-30_JPRB, 0.58582327E-30_JPRB, &
  & 0.71587004E-30_JPRB, 0.82326076E-30_JPRB, 0.89844707E-30_JPRB, 0.93949449E-30_JPRB, 0.94742588E-30_JPRB, 0.92863508E-30_JPRB, &
  & 0.88409494E-30_JPRB, 0.80885954E-30_JPRB, 0.69997172E-30_JPRB, 0.57219905E-30_JPRB, 0.44582391E-30_JPRB, 0.33528299E-30_JPRB, &
  & 0.24154150E-30_JPRB, 0.16702462E-30_JPRB, 0.11001070E-30_JPRB, 0.67701410E-31_JPRB, 0.39273510E-31_JPRB, 0.22332343E-31_JPRB, &
  & 0.12403274E-31_JPRB, 0.67547454E-32_JPRB, 0.35892684E-32_JPRB, 0.18773638E-32_JPRB, 0.97609497E-33_JPRB, 0.50813365E-33_JPRB, &
  & 0.26658878E-33_JPRB, 0.14366931E-33_JPRB, 0.81103284E-34_JPRB, 0.49718417E-34_JPRB, 0.33969827E-34_JPRB, 0.26157510E-34_JPRB, &
  & 0.21836496E-34_JPRB, 0.17232442E-34_JPRB, 0.91479677E-35_JPRB, 0.12809563E-35_JPRB /)

RGHG6(:, 3, 6) = (/ &
  & 0.76624645E-34_JPRB, 0.32889985E-33_JPRB, 0.59995395E-33_JPRB, 0.78454504E-33_JPRB, 0.93355906E-33_JPRB, 0.11101475E-32_JPRB, &
  & 0.13662010E-32_JPRB, 0.17777659E-32_JPRB, 0.24445896E-32_JPRB, 0.35391990E-32_JPRB, 0.53047672E-32_JPRB, 0.81222487E-32_JPRB, &
  & 0.12550481E-31_JPRB, 0.19354858E-31_JPRB, 0.29588935E-31_JPRB, 0.44694499E-31_JPRB, 0.67094173E-31_JPRB, 0.10144857E-30_JPRB, &
  & 0.15677476E-30_JPRB, 0.25170270E-30_JPRB, 0.42335062E-30_JPRB, 0.74193747E-30_JPRB, 0.13292701E-29_JPRB, 0.23822834E-29_JPRB, &
  & 0.41755293E-29_JPRB, 0.69746996E-29_JPRB, 0.10810419E-28_JPRB, 0.15701007E-28_JPRB, 0.21255138E-28_JPRB, 0.27545258E-28_JPRB, &
  & 0.33728652E-28_JPRB, 0.38934696E-28_JPRB, 0.42601904E-28_JPRB, 0.44620553E-28_JPRB, 0.45024417E-28_JPRB, 0.44118592E-28_JPRB, &
  & 0.41966976E-28_JPRB, 0.38437749E-28_JPRB, 0.33422739E-28_JPRB, 0.27481853E-28_JPRB, 0.21377403E-28_JPRB, 0.15972717E-28_JPRB, &
  & 0.11393289E-28_JPRB, 0.77930528E-29_JPRB, 0.50947020E-29_JPRB, 0.31251343E-29_JPRB, 0.18331910E-29_JPRB, 0.10574861E-29_JPRB, &
  & 0.59920768E-30_JPRB, 0.32908025E-30_JPRB, 0.17663874E-30_JPRB, 0.92798426E-31_JPRB, 0.48422965E-31_JPRB, 0.25179165E-31_JPRB, &
  & 0.13218656E-31_JPRB, 0.71162378E-32_JPRB, 0.40166499E-32_JPRB, 0.24580683E-32_JPRB, 0.16792398E-32_JPRB, 0.12935326E-32_JPRB, &
  & 0.10857272E-32_JPRB, 0.88998413E-33_JPRB, 0.54427152E-33_JPRB, 0.96987295E-34_JPRB /)

RGHG6(:, 4, 6) = (/ &
  & 0.73779697E-32_JPRB, 0.35314310E-31_JPRB, 0.60579807E-31_JPRB, 0.77009098E-31_JPRB, 0.90274087E-31_JPRB, 0.10677309E-30_JPRB, &
  & 0.13059358E-30_JPRB, 0.16897461E-30_JPRB, 0.23138910E-30_JPRB, 0.33339531E-30_JPRB, 0.49857276E-30_JPRB, 0.76141528E-30_JPRB, &
  & 0.11735025E-29_JPRB, 0.18033012E-29_JPRB, 0.27435613E-29_JPRB, 0.41175916E-29_JPRB, 0.61344442E-29_JPRB, 0.92057586E-29_JPRB, &
  & 0.14138909E-28_JPRB, 0.22626303E-28_JPRB, 0.38037447E-28_JPRB, 0.66633372E-28_JPRB, 0.11895703E-27_JPRB, 0.21199346E-27_JPRB, &
  & 0.36764168E-27_JPRB, 0.60955196E-27_JPRB, 0.93912148E-27_JPRB, 0.13620890E-26_JPRB, 0.18457144E-26_JPRB, 0.23952708E-26_JPRB, &
  & 0.29397660E-26_JPRB, 0.33976894E-26_JPRB, 0.37250255E-26_JPRB, 0.39089306E-26_JPRB, 0.39523476E-26_JPRB, 0.38815154E-26_JPRB, &
  & 0.37035864E-26_JPRB, 0.34066623E-26_JPRB, 0.29868936E-26_JPRB, 0.24750763E-26_JPRB, 0.19332620E-26_JPRB, 0.14444745E-26_JPRB, &
  & 0.10238070E-26_JPRB, 0.69695514E-27_JPRB, 0.45458360E-27_JPRB, 0.27958523E-27_JPRB, 0.16549757E-27_JPRB, 0.97217555E-28_JPRB, &
  & 0.55703503E-28_JPRB, 0.30940615E-28_JPRB, 0.16663849E-28_JPRB, 0.87955964E-29_JPRB, 0.46012644E-29_JPRB, 0.24044348E-29_JPRB, &
  & 0.12654770E-29_JPRB, 0.68436402E-30_JPRB, 0.38640328E-30_JPRB, 0.23670417E-30_JPRB, 0.16196246E-30_JPRB, 0.12564576E-30_JPRB, &
  & 0.10783089E-30_JPRB, 0.94082101E-31_JPRB, 0.70743724E-31_JPRB, 0.21468961E-31_JPRB /)

RGHG6(:, 5, 6) = (/ &
  & 0.36500679E-29_JPRB, 0.10298754E-28_JPRB, 0.15070451E-28_JPRB, 0.18169804E-28_JPRB, 0.21079834E-28_JPRB, 0.24817193E-28_JPRB, &
  & 0.30168158E-28_JPRB, 0.38759900E-28_JPRB, 0.52526628E-28_JPRB, 0.75036849E-28_JPRB, 0.11103624E-27_JPRB, 0.16778918E-27_JPRB, &
  & 0.25552483E-27_JPRB, 0.38735179E-27_JPRB, 0.58023955E-27_JPRB, 0.85589598E-27_JPRB, 0.12512366E-26_JPRB, 0.18408770E-26_JPRB, &
  & 0.27713477E-26_JPRB, 0.43491735E-26_JPRB, 0.71710576E-26_JPRB, 0.12309601E-25_JPRB, 0.21504398E-25_JPRB, 0.37459177E-25_JPRB, &
  & 0.63736251E-25_JPRB, 0.10400224E-24_JPRB, 0.15874872E-24_JPRB, 0.22913071E-24_JPRB, 0.30965603E-24_JPRB, 0.40167229E-24_JPRB, &
  & 0.49242063E-24_JPRB, 0.56934384E-24_JPRB, 0.62499739E-24_JPRB, 0.65839490E-24_JPRB, 0.67002976E-24_JPRB, 0.66383932E-24_JPRB, &
  & 0.64022506E-24_JPRB, 0.59678782E-24_JPRB, 0.53138469E-24_JPRB, 0.44811066E-24_JPRB, 0.35614351E-24_JPRB, 0.26990861E-24_JPRB, &
  & 0.19422373E-24_JPRB, 0.13405049E-24_JPRB, 0.88938829E-25_JPRB, 0.55731538E-25_JPRB, 0.33740792E-25_JPRB, 0.20238026E-25_JPRB, &
  & 0.11843434E-25_JPRB, 0.66683175E-26_JPRB, 0.36379923E-26_JPRB, 0.19394473E-26_JPRB, 0.10262471E-26_JPRB, 0.54216315E-27_JPRB, &
  & 0.28881953E-27_JPRB, 0.15748577E-27_JPRB, 0.89452284E-28_JPRB, 0.54802776E-28_JPRB, 0.37483571E-28_JPRB, 0.28987232E-28_JPRB, &
  & 0.25045691E-28_JPRB, 0.23225218E-28_JPRB, 0.21315567E-28_JPRB, 0.16614909E-28_JPRB /)

RGHG6(:, 6, 6) = (/ &
  & 0.30751890E-26_JPRB, 0.63025514E-26_JPRB, 0.82166951E-26_JPRB, 0.97156448E-26_JPRB, 0.11188346E-25_JPRB, 0.13053106E-25_JPRB, &
  & 0.15662248E-25_JPRB, 0.19775558E-25_JPRB, 0.26261854E-25_JPRB, 0.36568051E-25_JPRB, 0.52624658E-25_JPRB, 0.77052457E-25_JPRB, &
  & 0.11333952E-24_JPRB, 0.16537676E-24_JPRB, 0.23779509E-24_JPRB, 0.33570688E-24_JPRB, 0.46864067E-24_JPRB, 0.65707055E-24_JPRB, &
  & 0.94157008E-24_JPRB, 0.14069307E-23_JPRB, 0.22138486E-23_JPRB, 0.36401777E-23_JPRB, 0.61158769E-23_JPRB, 0.10288770E-22_JPRB, &
  & 0.16970971E-22_JPRB, 0.27010534E-22_JPRB, 0.40404566E-22_JPRB, 0.57467539E-22_JPRB, 0.76822979E-22_JPRB, 0.98915370E-22_JPRB, &
  & 0.12072735E-21_JPRB, 0.13927290E-21_JPRB, 0.15320286E-21_JPRB, 0.16253868E-21_JPRB, 0.16740443E-21_JPRB, 0.16869879E-21_JPRB, &
  & 0.16619737E-21_JPRB, 0.15882423E-21_JPRB, 0.14551237E-21_JPRB, 0.12668258E-21_JPRB, 0.10416725E-21_JPRB, 0.82090734E-22_JPRB, &
  & 0.61450870E-22_JPRB, 0.44349577E-22_JPRB, 0.30826037E-22_JPRB, 0.20259766E-22_JPRB, 0.12876079E-22_JPRB, 0.81064175E-23_JPRB, &
  & 0.49614077E-23_JPRB, 0.29153714E-23_JPRB, 0.16527008E-23_JPRB, 0.91380592E-24_JPRB, 0.50047850E-24_JPRB, 0.27311439E-24_JPRB, &
  & 0.14976667E-24_JPRB, 0.83685742E-25_JPRB, 0.48260181E-25_JPRB, 0.29732334E-25_JPRB, 0.20016050E-25_JPRB, 0.15106330E-25_JPRB, &
  & 0.12546016E-25_JPRB, 0.11017691E-25_JPRB, 0.95731252E-26_JPRB, 0.56599672E-26_JPRB /)

RGHG6(:, 7, 6) = (/ &
  & 0.23757035E-23_JPRB, 0.45811519E-23_JPRB, 0.58776022E-23_JPRB, 0.69030646E-23_JPRB, 0.78733604E-23_JPRB, 0.90561342E-23_JPRB, &
  & 0.10669094E-22_JPRB, 0.13140806E-22_JPRB, 0.16911565E-22_JPRB, 0.22689612E-22_JPRB, 0.31273630E-22_JPRB, 0.43652243E-22_JPRB, &
  & 0.60925905E-22_JPRB, 0.84049513E-22_JPRB, 0.11384721E-21_JPRB, 0.15104474E-21_JPRB, 0.19763127E-21_JPRB, 0.25926831E-21_JPRB, &
  & 0.34729656E-21_JPRB, 0.48578140E-21_JPRB, 0.71927605E-21_JPRB, 0.11223267E-20_JPRB, 0.18046411E-20_JPRB, 0.29250480E-20_JPRB, &
  & 0.46696769E-20_JPRB, 0.72192479E-20_JPRB, 0.10527209E-19_JPRB, 0.14665029E-19_JPRB, 0.19289526E-19_JPRB, 0.24563579E-19_JPRB, &
  & 0.29779436E-19_JPRB, 0.34274119E-19_JPRB, 0.37814239E-19_JPRB, 0.40455081E-19_JPRB, 0.42274742E-19_JPRB, 0.43467924E-19_JPRB, &
  & 0.43929902E-19_JPRB, 0.43272060E-19_JPRB, 0.41038993E-19_JPRB, 0.37128729E-19_JPRB, 0.31896446E-19_JPRB, 0.26372852E-19_JPRB, &
  & 0.20857148E-19_JPRB, 0.15965841E-19_JPRB, 0.11816533E-19_JPRB, 0.82947491E-20_JPRB, 0.56369750E-20_JPRB, 0.37977615E-20_JPRB, &
  & 0.24864542E-20_JPRB, 0.15593953E-20_JPRB, 0.94162315E-21_JPRB, 0.55295075E-21_JPRB, 0.32059502E-21_JPRB, 0.18450198E-21_JPRB, &
  & 0.10615806E-21_JPRB, 0.61879512E-22_JPRB, 0.36853969E-22_JPRB, 0.22971661E-22_JPRB, 0.15389386E-22_JPRB, 0.11210931E-22_JPRB, &
  & 0.89250547E-23_JPRB, 0.76052841E-23_JPRB, 0.66146713E-23_JPRB, 0.53705714E-23_JPRB /)

RGHG6(:, 8, 6) = (/ &
  & 0.15157059E-20_JPRB, 0.28992305E-20_JPRB, 0.37055010E-20_JPRB, 0.43265181E-20_JPRB, 0.48890825E-20_JPRB, 0.55616813E-20_JPRB, &
  & 0.64312303E-20_JPRB, 0.77482977E-20_JPRB, 0.96815384E-20_JPRB, 0.12527834E-19_JPRB, 0.16556543E-19_JPRB, 0.22035285E-19_JPRB, &
  & 0.29189339E-19_JPRB, 0.38045038E-19_JPRB, 0.48550093E-19_JPRB, 0.60487363E-19_JPRB, 0.74165802E-19_JPRB, 0.91003445E-19_JPRB, &
  & 0.11390233E-18_JPRB, 0.14901692E-18_JPRB, 0.20742377E-18_JPRB, 0.30697469E-18_JPRB, 0.47261776E-18_JPRB, 0.73860549E-18_JPRB, &
  & 0.11414673E-17_JPRB, 0.17130613E-17_JPRB, 0.24301557E-17_JPRB, 0.33081800E-17_JPRB, 0.42744922E-17_JPRB, 0.53775189E-17_JPRB, &
  & 0.64735386E-17_JPRB, 0.74403407E-17_JPRB, 0.82372043E-17_JPRB, 0.88963655E-17_JPRB, 0.94355169E-17_JPRB, 0.99046805E-17_JPRB, &
  & 0.10275349E-16_JPRB, 0.10443860E-16_JPRB, 0.10268853E-16_JPRB, 0.96770189E-17_JPRB, 0.86974187E-17_JPRB, 0.75736301E-17_JPRB, &
  & 0.63346873E-17_JPRB, 0.51583186E-17_JPRB, 0.40768031E-17_JPRB, 0.30626261E-17_JPRB, 0.22334882E-17_JPRB, 0.16172357E-17_JPRB, &
  & 0.11378479E-17_JPRB, 0.76617108E-18_JPRB, 0.49574113E-18_JPRB, 0.31115518E-18_JPRB, 0.19214319E-18_JPRB, 0.11722699E-18_JPRB, &
  & 0.71206874E-19_JPRB, 0.43540555E-19_JPRB, 0.27011415E-19_JPRB, 0.17337394E-19_JPRB, 0.11692228E-19_JPRB, 0.84751165E-20_JPRB, &
  & 0.66406665E-20_JPRB, 0.55918451E-20_JPRB, 0.50616434E-20_JPRB, 0.46856841E-20_JPRB /)

RGHG6(:, 9, 6) = (/ &
  & 0.78086791E-18_JPRB, 0.14886075E-17_JPRB, 0.18955919E-17_JPRB, 0.22013621E-17_JPRB, 0.24752730E-17_JPRB, 0.27805703E-17_JPRB, &
  & 0.31798891E-17_JPRB, 0.37532750E-17_JPRB, 0.45810362E-17_JPRB, 0.57485851E-17_JPRB, 0.73243030E-17_JPRB, 0.93468795E-17_JPRB, &
  & 0.11809292E-16_JPRB, 0.14620641E-16_JPRB, 0.17652668E-16_JPRB, 0.20757130E-16_JPRB, 0.23959781E-16_JPRB, 0.27637666E-16_JPRB, &
  & 0.32484994E-16_JPRB, 0.39937117E-16_JPRB, 0.52424775E-16_JPRB, 0.73701925E-16_JPRB, 0.10858818E-15_JPRB, 0.16343072E-15_JPRB, &
  & 0.24404727E-15_JPRB, 0.35474703E-15_JPRB, 0.48888561E-15_JPRB, 0.64929094E-15_JPRB, 0.82326404E-15_JPRB, 0.10220696E-14_JPRB, &
  & 0.12220689E-14_JPRB, 0.14023350E-14_JPRB, 0.15598462E-14_JPRB, 0.17015151E-14_JPRB, 0.18330725E-14_JPRB, 0.19651219E-14_JPRB, &
  & 0.20933396E-14_JPRB, 0.21964754E-14_JPRB, 0.22413828E-14_JPRB, 0.22032752E-14_JPRB, 0.20767126E-14_JPRB, 0.19061598E-14_JPRB, &
  & 0.16889555E-14_JPRB, 0.14633665E-14_JPRB, 0.12350826E-14_JPRB, 0.99329849E-15_JPRB, 0.77723177E-15_JPRB, 0.60495400E-15_JPRB, &
  & 0.45770341E-15_JPRB, 0.33101026E-15_JPRB, 0.22970385E-15_JPRB, 0.15421182E-15_JPRB, 0.10149685E-15_JPRB, 0.65704683E-16_JPRB, &
  & 0.42119329E-16_JPRB, 0.27065578E-16_JPRB, 0.17536472E-16_JPRB, 0.11662656E-16_JPRB, 0.80729362E-17_JPRB, 0.59213199E-17_JPRB, &
  & 0.46672103E-17_JPRB, 0.39727781E-17_JPRB, 0.36627826E-17_JPRB, 0.35856323E-17_JPRB /)

RGHG6(:,10, 6) = (/ &
  & 0.32333085E-15_JPRB, 0.61321670E-15_JPRB, 0.77829411E-15_JPRB, 0.90153084E-15_JPRB, 0.10056556E-14_JPRB, 0.11250876E-14_JPRB, &
  & 0.12681165E-14_JPRB, 0.14790860E-14_JPRB, 0.17681855E-14_JPRB, 0.21640730E-14_JPRB, 0.26731428E-14_JPRB, 0.32889741E-14_JPRB, &
  & 0.39861565E-14_JPRB, 0.47110698E-14_JPRB, 0.54110620E-14_JPRB, 0.60340260E-14_JPRB, 0.65915511E-14_JPRB, 0.71846842E-14_JPRB, &
  & 0.79739394E-14_JPRB, 0.92596837E-14_JPRB, 0.11512609E-13_JPRB, 0.15400348E-13_JPRB, 0.21709217E-13_JPRB, 0.31375805E-13_JPRB, &
  & 0.45134388E-13_JPRB, 0.63417892E-13_JPRB, 0.84745545E-13_JPRB, 0.10974109E-12_JPRB, 0.13640730E-12_JPRB, 0.16707726E-12_JPRB, &
  & 0.19823795E-12_JPRB, 0.22724024E-12_JPRB, 0.25389497E-12_JPRB, 0.27992571E-12_JPRB, 0.30645029E-12_JPRB, 0.33567748E-12_JPRB, &
  & 0.36734081E-12_JPRB, 0.39810397E-12_JPRB, 0.42196531E-12_JPRB, 0.43326036E-12_JPRB, 0.42886861E-12_JPRB, 0.41559096E-12_JPRB, &
  & 0.39041090E-12_JPRB, 0.36020232E-12_JPRB, 0.32480399E-12_JPRB, 0.27971877E-12_JPRB, 0.23488356E-12_JPRB, 0.19658855E-12_JPRB, &
  & 0.15991016E-12_JPRB, 0.12424708E-12_JPRB, 0.92463011E-13_JPRB, 0.66409077E-13_JPRB, 0.46585633E-13_JPRB, 0.31989863E-13_JPRB, &
  & 0.21644147E-13_JPRB, 0.14595503E-13_JPRB, 0.98776434E-14_JPRB, 0.68199311E-14_JPRB, 0.48652865E-14_JPRB, 0.36524061E-14_JPRB, &
  & 0.29260933E-14_JPRB, 0.25199616E-14_JPRB, 0.23591710E-14_JPRB, 0.23501393E-14_JPRB /)

RGHG6(:,11, 6) = (/ &
  & 0.66287680E-14_JPRB, 0.10811092E-13_JPRB, 0.12936351E-13_JPRB, 0.14419725E-13_JPRB, 0.15750559E-13_JPRB, 0.17138041E-13_JPRB, &
  & 0.19121503E-13_JPRB, 0.21848805E-13_JPRB, 0.25954392E-13_JPRB, 0.31611754E-13_JPRB, 0.39037163E-13_JPRB, 0.48154037E-13_JPRB, &
  & 0.58442441E-13_JPRB, 0.69089787E-13_JPRB, 0.78898652E-13_JPRB, 0.86456375E-13_JPRB, 0.91111594E-13_JPRB, 0.93027758E-13_JPRB, &
  & 0.92923458E-13_JPRB, 0.92730809E-13_JPRB, 0.94744389E-13_JPRB, 0.10158655E-12_JPRB, 0.11527929E-12_JPRB, 0.13762185E-12_JPRB, &
  & 0.16923153E-12_JPRB, 0.21080642E-12_JPRB, 0.26660019E-12_JPRB, 0.33248843E-12_JPRB, 0.43084194E-12_JPRB, 0.56178901E-12_JPRB, &
  & 0.70970611E-12_JPRB, 0.88006474E-12_JPRB, 0.10605843E-11_JPRB, 0.12198299E-11_JPRB, 0.13589129E-11_JPRB, 0.14834385E-11_JPRB, &
  & 0.15777613E-11_JPRB, 0.16384688E-11_JPRB, 0.16649738E-11_JPRB, 0.16468351E-11_JPRB, 0.15902132E-11_JPRB, 0.15054998E-11_JPRB, &
  & 0.13972119E-11_JPRB, 0.12830580E-11_JPRB, 0.11415986E-11_JPRB, 0.99591407E-12_JPRB, 0.85449914E-12_JPRB, 0.70782914E-12_JPRB, &
  & 0.56243167E-12_JPRB, 0.43485482E-12_JPRB, 0.33030881E-12_JPRB, 0.24573301E-12_JPRB, 0.18047750E-12_JPRB, 0.13141982E-12_JPRB, &
  & 0.95879915E-13_JPRB, 0.70967307E-13_JPRB, 0.53704430E-13_JPRB, 0.42085577E-13_JPRB, 0.34395128E-13_JPRB, 0.29424962E-13_JPRB, &
  & 0.26466217E-13_JPRB, 0.25217103E-13_JPRB, 0.25648867E-13_JPRB, 0.28968229E-13_JPRB /)

RGHG6(:,12, 6) = (/ &
  & 0.74564351E-13_JPRB, 0.10477572E-12_JPRB, 0.11839756E-12_JPRB, 0.12721919E-12_JPRB, 0.13444768E-12_JPRB, 0.14322801E-12_JPRB, &
  & 0.15521761E-12_JPRB, 0.17484560E-12_JPRB, 0.20387743E-12_JPRB, 0.24605123E-12_JPRB, 0.30237095E-12_JPRB, 0.37230527E-12_JPRB, &
  & 0.45199020E-12_JPRB, 0.53589522E-12_JPRB, 0.61054189E-12_JPRB, 0.66625145E-12_JPRB, 0.69167111E-12_JPRB, 0.68912465E-12_JPRB, &
  & 0.66061436E-12_JPRB, 0.61631939E-12_JPRB, 0.56788753E-12_JPRB, 0.53045643E-12_JPRB, 0.51380368E-12_JPRB, 0.52530907E-12_JPRB, &
  & 0.56809093E-12_JPRB, 0.64756956E-12_JPRB, 0.77179186E-12_JPRB, 0.96513303E-12_JPRB, 0.12203580E-11_JPRB, 0.15499776E-11_JPRB, &
  & 0.20349920E-11_JPRB, 0.26444760E-11_JPRB, 0.32791779E-11_JPRB, 0.39329334E-11_JPRB, 0.45680139E-11_JPRB, 0.50308026E-11_JPRB, &
  & 0.53055338E-11_JPRB, 0.54106906E-11_JPRB, 0.53623876E-11_JPRB, 0.51598491E-11_JPRB, 0.48478613E-11_JPRB, 0.44727022E-11_JPRB, &
  & 0.40612635E-11_JPRB, 0.36320656E-11_JPRB, 0.31886633E-11_JPRB, 0.27490083E-11_JPRB, 0.23149651E-11_JPRB, 0.19236418E-11_JPRB, &
  & 0.15819323E-11_JPRB, 0.12861140E-11_JPRB, 0.10346303E-11_JPRB, 0.82295607E-12_JPRB, 0.65236922E-12_JPRB, 0.51883671E-12_JPRB, &
  & 0.41742464E-12_JPRB, 0.34229241E-12_JPRB, 0.28780496E-12_JPRB, 0.25085768E-12_JPRB, 0.22671649E-12_JPRB, 0.21273878E-12_JPRB, &
  & 0.20705825E-12_JPRB, 0.21078676E-12_JPRB, 0.22620916E-12_JPRB, 0.27875852E-12_JPRB /)

RGHG6(:,13, 6) = (/ &
  & 0.52016648E-12_JPRB, 0.63576331E-12_JPRB, 0.67961381E-12_JPRB, 0.70296931E-12_JPRB, 0.72150359E-12_JPRB, 0.74558160E-12_JPRB, &
  & 0.78884447E-12_JPRB, 0.86196875E-12_JPRB, 0.98289660E-12_JPRB, 0.11603727E-11_JPRB, 0.14019425E-11_JPRB, 0.17031102E-11_JPRB, &
  & 0.20442493E-11_JPRB, 0.23985171E-11_JPRB, 0.27113240E-11_JPRB, 0.29362743E-11_JPRB, 0.30415457E-11_JPRB, 0.30192684E-11_JPRB, &
  & 0.28714340E-11_JPRB, 0.26368924E-11_JPRB, 0.23674053E-11_JPRB, 0.21192243E-11_JPRB, 0.19405874E-11_JPRB, 0.18511627E-11_JPRB, &
  & 0.18564677E-11_JPRB, 0.19641777E-11_JPRB, 0.21979723E-11_JPRB, 0.25801362E-11_JPRB, 0.31963479E-11_JPRB, 0.41444049E-11_JPRB, &
  & 0.53793150E-11_JPRB, 0.68403083E-11_JPRB, 0.85383905E-11_JPRB, 0.10185781E-10_JPRB, 0.11427180E-10_JPRB, 0.12487931E-10_JPRB, &
  & 0.13209454E-10_JPRB, 0.13489924E-10_JPRB, 0.13323215E-10_JPRB, 0.12764886E-10_JPRB, 0.11927593E-10_JPRB, 0.10930029E-10_JPRB, &
  & 0.98660385E-11_JPRB, 0.88101089E-11_JPRB, 0.77495874E-11_JPRB, 0.67263322E-11_JPRB, 0.57910903E-11_JPRB, 0.49642131E-11_JPRB, &
  & 0.42131437E-11_JPRB, 0.35526083E-11_JPRB, 0.29973329E-11_JPRB, 0.25327167E-11_JPRB, 0.21594662E-11_JPRB, 0.18637440E-11_JPRB, &
  & 0.16327540E-11_JPRB, 0.14576330E-11_JPRB, 0.13321155E-11_JPRB, 0.12543636E-11_JPRB, 0.12167098E-11_JPRB, 0.12157012E-11_JPRB, &
  & 0.12484935E-11_JPRB, 0.13274502E-11_JPRB, 0.14865307E-11_JPRB, 0.19192016E-11_JPRB /)

RGHG6(:,14, 6) = (/ &
  & 0.23784685E-11_JPRB, 0.25568061E-11_JPRB, 0.25958771E-11_JPRB, 0.25923836E-11_JPRB, 0.25862134E-11_JPRB, 0.26051288E-11_JPRB, &
  & 0.26776602E-11_JPRB, 0.28424652E-11_JPRB, 0.31329112E-11_JPRB, 0.35799343E-11_JPRB, 0.41910533E-11_JPRB, 0.49506727E-11_JPRB, &
  & 0.58060752E-11_JPRB, 0.66804487E-11_JPRB, 0.74607742E-11_JPRB, 0.80185285E-11_JPRB, 0.82966672E-11_JPRB, 0.82861166E-11_JPRB, &
  & 0.79998629E-11_JPRB, 0.74966431E-11_JPRB, 0.69059975E-11_JPRB, 0.63736611E-11_JPRB, 0.59581788E-11_JPRB, 0.57095765E-11_JPRB, &
  & 0.56473888E-11_JPRB, 0.58011543E-11_JPRB, 0.62201173E-11_JPRB, 0.69908302E-11_JPRB, 0.82033070E-11_JPRB, 0.98973572E-11_JPRB, &
  & 0.12063147E-10_JPRB, 0.14818573E-10_JPRB, 0.17806808E-10_JPRB, 0.20769067E-10_JPRB, 0.23807871E-10_JPRB, 0.25902050E-10_JPRB, &
  & 0.26996986E-10_JPRB, 0.27340371E-10_JPRB, 0.27045036E-10_JPRB, 0.26032319E-10_JPRB, 0.24504577E-10_JPRB, 0.22661272E-10_JPRB, &
  & 0.20654350E-10_JPRB, 0.18613567E-10_JPRB, 0.16562161E-10_JPRB, 0.14614409E-10_JPRB, 0.12827957E-10_JPRB, 0.11232166E-10_JPRB, &
  & 0.98205203E-11_JPRB, 0.86280080E-11_JPRB, 0.76550814E-11_JPRB, 0.68532619E-11_JPRB, 0.62132677E-11_JPRB, 0.57022698E-11_JPRB, &
  & 0.53014069E-11_JPRB, 0.50080344E-11_JPRB, 0.48216084E-11_JPRB, 0.47564223E-11_JPRB, 0.48013269E-11_JPRB, 0.49580318E-11_JPRB, &
  & 0.52411972E-11_JPRB, 0.56824107E-11_JPRB, 0.65150836E-11_JPRB, 0.83734686E-11_JPRB /)

RGHG6(:,15, 6) = (/ &
  & 0.76788671E-11_JPRB, 0.74848374E-11_JPRB, 0.72805165E-11_JPRB, 0.70706297E-11_JPRB, 0.68867004E-11_JPRB, 0.67804894E-11_JPRB, &
  & 0.67994560E-11_JPRB, 0.70108285E-11_JPRB, 0.74844141E-11_JPRB, 0.82692837E-11_JPRB, 0.93797956E-11_JPRB, 0.10780369E-10_JPRB, &
  & 0.12373948E-10_JPRB, 0.14025328E-10_JPRB, 0.15591231E-10_JPRB, 0.16854936E-10_JPRB, 0.17646913E-10_JPRB, 0.17910604E-10_JPRB, &
  & 0.17738934E-10_JPRB, 0.17344152E-10_JPRB, 0.16870262E-10_JPRB, 0.16421307E-10_JPRB, 0.16098943E-10_JPRB, 0.15988500E-10_JPRB, &
  & 0.16151469E-10_JPRB, 0.16660876E-10_JPRB, 0.17610935E-10_JPRB, 0.19071441E-10_JPRB, 0.21152260E-10_JPRB, 0.23996072E-10_JPRB, &
  & 0.27678445E-10_JPRB, 0.31700923E-10_JPRB, 0.35911669E-10_JPRB, 0.39684339E-10_JPRB, 0.42541651E-10_JPRB, 0.45033473E-10_JPRB, &
  & 0.46938332E-10_JPRB, 0.47617969E-10_JPRB, 0.47235924E-10_JPRB, 0.45922061E-10_JPRB, 0.43842083E-10_JPRB, 0.41198579E-10_JPRB, &
  & 0.38194906E-10_JPRB, 0.35047531E-10_JPRB, 0.31820439E-10_JPRB, 0.28668434E-10_JPRB, 0.25718217E-10_JPRB, 0.23120911E-10_JPRB, &
  & 0.20876077E-10_JPRB, 0.19000393E-10_JPRB, 0.17468754E-10_JPRB, 0.16199365E-10_JPRB, 0.15186753E-10_JPRB, 0.14386512E-10_JPRB, &
  & 0.13786194E-10_JPRB, 0.13397784E-10_JPRB, 0.13238004E-10_JPRB, 0.13343839E-10_JPRB, 0.13701065E-10_JPRB, 0.14320615E-10_JPRB, &
  & 0.15248167E-10_JPRB, 0.16522636E-10_JPRB, 0.18800289E-10_JPRB, 0.23342335E-10_JPRB /)

RGHG6(:,16, 6) = (/ &
  & 0.18438010E-10_JPRB, 0.17151325E-10_JPRB, 0.16269422E-10_JPRB, 0.15522937E-10_JPRB, 0.14887949E-10_JPRB, 0.14414094E-10_JPRB, &
  & 0.14176824E-10_JPRB, 0.14282365E-10_JPRB, 0.14835421E-10_JPRB, 0.15921197E-10_JPRB, 0.17560627E-10_JPRB, 0.19707696E-10_JPRB, &
  & 0.22226460E-10_JPRB, 0.24891547E-10_JPRB, 0.27500266E-10_JPRB, 0.29891867E-10_JPRB, 0.31911876E-10_JPRB, 0.33561202E-10_JPRB, &
  & 0.34877042E-10_JPRB, 0.35908051E-10_JPRB, 0.36804657E-10_JPRB, 0.37725330E-10_JPRB, 0.38759652E-10_JPRB, 0.40034510E-10_JPRB, &
  & 0.41629415E-10_JPRB, 0.43667431E-10_JPRB, 0.46183859E-10_JPRB, 0.49234505E-10_JPRB, 0.52687809E-10_JPRB, 0.56386621E-10_JPRB, &
  & 0.59952772E-10_JPRB, 0.63455886E-10_JPRB, 0.66766793E-10_JPRB, 0.69609811E-10_JPRB, 0.71834427E-10_JPRB, 0.73114834E-10_JPRB, &
  & 0.73493100E-10_JPRB, 0.73860709E-10_JPRB, 0.73718635E-10_JPRB, 0.72612243E-10_JPRB, 0.70575878E-10_JPRB, 0.67699110E-10_JPRB, &
  & 0.64144211E-10_JPRB, 0.60151002E-10_JPRB, 0.55791722E-10_JPRB, 0.51370363E-10_JPRB, 0.47200504E-10_JPRB, 0.43489309E-10_JPRB, &
  & 0.40201627E-10_JPRB, 0.37370176E-10_JPRB, 0.34998417E-10_JPRB, 0.32997799E-10_JPRB, 0.31391990E-10_JPRB, 0.30145914E-10_JPRB, &
  & 0.29265295E-10_JPRB, 0.28781871E-10_JPRB, 0.28724027E-10_JPRB, 0.29150810E-10_JPRB, 0.30035942E-10_JPRB, 0.31373584E-10_JPRB, &
  & 0.33219812E-10_JPRB, 0.35639273E-10_JPRB, 0.39626295E-10_JPRB, 0.47185811E-10_JPRB /)

RGHG6(:,17, 6) = (/ &
  & 0.35589701E-10_JPRB, 0.32532248E-10_JPRB, 0.30505966E-10_JPRB, 0.28904591E-10_JPRB, 0.27508364E-10_JPRB, 0.26391295E-10_JPRB, &
  & 0.25643036E-10_JPRB, 0.25417470E-10_JPRB, 0.25877219E-10_JPRB, 0.27154241E-10_JPRB, 0.29318801E-10_JPRB, 0.32309780E-10_JPRB, &
  & 0.36018976E-10_JPRB, 0.40250844E-10_JPRB, 0.44715641E-10_JPRB, 0.49199179E-10_JPRB, 0.53632647E-10_JPRB, 0.57899213E-10_JPRB, &
  & 0.61996679E-10_JPRB, 0.66043671E-10_JPRB, 0.70158622E-10_JPRB, 0.74485772E-10_JPRB, 0.79147890E-10_JPRB, 0.84304216E-10_JPRB, &
  & 0.89915103E-10_JPRB, 0.95850557E-10_JPRB, 0.10159046E-09_JPRB, 0.10664207E-09_JPRB, 0.11041260E-09_JPRB, 0.11299893E-09_JPRB, &
  & 0.11395747E-09_JPRB, 0.11372386E-09_JPRB, 0.11255955E-09_JPRB, 0.11082727E-09_JPRB, 0.10906271E-09_JPRB, 0.10784793E-09_JPRB, &
  & 0.10731769E-09_JPRB, 0.10673935E-09_JPRB, 0.10642785E-09_JPRB, 0.10582087E-09_JPRB, 0.10447997E-09_JPRB, 0.10215107E-09_JPRB, &
  & 0.98782843E-10_JPRB, 0.94514577E-10_JPRB, 0.89466670E-10_JPRB, 0.84119378E-10_JPRB, 0.78854943E-10_JPRB, 0.73919357E-10_JPRB, &
  & 0.69300191E-10_JPRB, 0.65133302E-10_JPRB, 0.61510984E-10_JPRB, 0.58394622E-10_JPRB, 0.55866173E-10_JPRB, 0.53922106E-10_JPRB, &
  & 0.52583372E-10_JPRB, 0.51891425E-10_JPRB, 0.51873866E-10_JPRB, 0.52593454E-10_JPRB, 0.53981975E-10_JPRB, 0.56002675E-10_JPRB, &
  & 0.58663276E-10_JPRB, 0.62105938E-10_JPRB, 0.67226093E-10_JPRB, 0.77032138E-10_JPRB /)

RGHG6(:,18, 6) = (/ &
  & 0.58038230E-10_JPRB, 0.53060403E-10_JPRB, 0.49870292E-10_JPRB, 0.47262826E-10_JPRB, 0.44999018E-10_JPRB, 0.43059934E-10_JPRB, &
  & 0.41611624E-10_JPRB, 0.40854580E-10_JPRB, 0.41027674E-10_JPRB, 0.42361246E-10_JPRB, 0.44957871E-10_JPRB, 0.48800242E-10_JPRB, &
  & 0.53774742E-10_JPRB, 0.59734717E-10_JPRB, 0.66515446E-10_JPRB, 0.73821102E-10_JPRB, 0.81346589E-10_JPRB, 0.88976881E-10_JPRB, &
  & 0.96703048E-10_JPRB, 0.10461491E-09_JPRB, 0.11284619E-09_JPRB, 0.12156506E-09_JPRB, 0.13090073E-09_JPRB, 0.14097662E-09_JPRB, &
  & 0.15148290E-09_JPRB, 0.16172133E-09_JPRB, 0.17089367E-09_JPRB, 0.17802147E-09_JPRB, 0.18215465E-09_JPRB, 0.18292526E-09_JPRB, &
  & 0.18037262E-09_JPRB, 0.17525939E-09_JPRB, 0.16840995E-09_JPRB, 0.16082241E-09_JPRB, 0.15360176E-09_JPRB, 0.14793534E-09_JPRB, &
  & 0.14443299E-09_JPRB, 0.14332799E-09_JPRB, 0.14348983E-09_JPRB, 0.14400139E-09_JPRB, 0.14401304E-09_JPRB, 0.14287867E-09_JPRB, &
  & 0.14036754E-09_JPRB, 0.13650434E-09_JPRB, 0.13142848E-09_JPRB, 0.12561004E-09_JPRB, 0.11946460E-09_JPRB, 0.11325729E-09_JPRB, &
  & 0.10714372E-09_JPRB, 0.10140738E-09_JPRB, 0.96260007E-10_JPRB, 0.91723205E-10_JPRB, 0.87961097E-10_JPRB, 0.85018652E-10_JPRB, &
  & 0.82937851E-10_JPRB, 0.81776586E-10_JPRB, 0.81547970E-10_JPRB, 0.82288322E-10_JPRB, 0.83880909E-10_JPRB, 0.86227879E-10_JPRB, &
  & 0.89290478E-10_JPRB, 0.93195944E-10_JPRB, 0.98575814E-10_JPRB, 0.10932491E-09_JPRB /)

RGHG6(:,19, 6) = (/ &
  & 0.84301802E-10_JPRB, 0.77668399E-10_JPRB, 0.73505688E-10_JPRB, 0.70078290E-10_JPRB, 0.66992099E-10_JPRB, 0.64267369E-10_JPRB, &
  & 0.62047992E-10_JPRB, 0.60646856E-10_JPRB, 0.60399831E-10_JPRB, 0.61634323E-10_JPRB, 0.64513249E-10_JPRB, 0.69064643E-10_JPRB, &
  & 0.75195655E-10_JPRB, 0.82741765E-10_JPRB, 0.91464045E-10_JPRB, 0.10111186E-09_JPRB, 0.11142388E-09_JPRB, 0.12208322E-09_JPRB, &
  & 0.13286471E-09_JPRB, 0.14382653E-09_JPRB, 0.15524818E-09_JPRB, 0.16739778E-09_JPRB, 0.18041514E-09_JPRB, 0.19432903E-09_JPRB, &
  & 0.20864796E-09_JPRB, 0.22250675E-09_JPRB, 0.23461630E-09_JPRB, 0.24343400E-09_JPRB, 0.24805158E-09_JPRB, 0.24807231E-09_JPRB, &
  & 0.24379523E-09_JPRB, 0.23584587E-09_JPRB, 0.22532691E-09_JPRB, 0.21368428E-09_JPRB, 0.20263599E-09_JPRB, 0.19358787E-09_JPRB, &
  & 0.18765385E-09_JPRB, 0.18491941E-09_JPRB, 0.18491189E-09_JPRB, 0.18607614E-09_JPRB, 0.18720295E-09_JPRB, 0.18732235E-09_JPRB, &
  & 0.18584678E-09_JPRB, 0.18266712E-09_JPRB, 0.17785476E-09_JPRB, 0.17181721E-09_JPRB, 0.16492074E-09_JPRB, 0.15761174E-09_JPRB, &
  & 0.15018893E-09_JPRB, 0.14303987E-09_JPRB, 0.13643552E-09_JPRB, 0.13045803E-09_JPRB, 0.12535900E-09_JPRB, 0.12123109E-09_JPRB, &
  & 0.11816696E-09_JPRB, 0.11625322E-09_JPRB, 0.11549028E-09_JPRB, 0.11587747E-09_JPRB, 0.11724507E-09_JPRB, 0.11943993E-09_JPRB, &
  & 0.12235954E-09_JPRB, 0.12608208E-09_JPRB, 0.13114691E-09_JPRB, 0.14136231E-09_JPRB /)

RGHG6(:,20, 6) = (/ &
  & 0.11273218E-09_JPRB, 0.10499672E-09_JPRB, 0.10028865E-09_JPRB, 0.96321257E-10_JPRB, 0.92685609E-10_JPRB, 0.89333929E-10_JPRB, &
  & 0.86472662E-10_JPRB, 0.84440795E-10_JPRB, 0.83745760E-10_JPRB, 0.84764598E-10_JPRB, 0.87713156E-10_JPRB, 0.92645627E-10_JPRB, &
  & 0.99487613E-10_JPRB, 0.10808324E-09_JPRB, 0.11822529E-09_JPRB, 0.12954893E-09_JPRB, 0.14161358E-09_JPRB, 0.15404851E-09_JPRB, &
  & 0.16669074E-09_JPRB, 0.17952348E-09_JPRB, 0.19275768E-09_JPRB, 0.20676638E-09_JPRB, 0.22172990E-09_JPRB, 0.23769051E-09_JPRB, &
  & 0.25418004E-09_JPRB, 0.27006813E-09_JPRB, 0.28391953E-09_JPRB, 0.29416763E-09_JPRB, 0.29991137E-09_JPRB, 0.30078673E-09_JPRB, &
  & 0.29701347E-09_JPRB, 0.28902497E-09_JPRB, 0.27785194E-09_JPRB, 0.26490976E-09_JPRB, 0.25209909E-09_JPRB, 0.24125366E-09_JPRB, &
  & 0.23371222E-09_JPRB, 0.22989874E-09_JPRB, 0.22931852E-09_JPRB, 0.23043213E-09_JPRB, 0.23185595E-09_JPRB, 0.23238630E-09_JPRB, &
  & 0.23138071E-09_JPRB, 0.22859301E-09_JPRB, 0.22389363E-09_JPRB, 0.21757886E-09_JPRB, 0.21011569E-09_JPRB, 0.20206779E-09_JPRB, &
  & 0.19377266E-09_JPRB, 0.18558746E-09_JPRB, 0.17781261E-09_JPRB, 0.17065832E-09_JPRB, 0.16440461E-09_JPRB, 0.15920983E-09_JPRB, &
  & 0.15520527E-09_JPRB, 0.15248088E-09_JPRB, 0.15101760E-09_JPRB, 0.15078679E-09_JPRB, 0.15159254E-09_JPRB, 0.15324657E-09_JPRB, &
  & 0.15561687E-09_JPRB, 0.15871167E-09_JPRB, 0.16301414E-09_JPRB, 0.17151167E-09_JPRB /)

RGHG6(:,21, 6) = (/ &
  & 0.14243701E-09_JPRB, 0.13410259E-09_JPRB, 0.12916132E-09_JPRB, 0.12495310E-09_JPRB, 0.12103876E-09_JPRB, 0.11734516E-09_JPRB, &
  & 0.11404264E-09_JPRB, 0.11161617E-09_JPRB, 0.11057447E-09_JPRB, 0.11137384E-09_JPRB, 0.11427535E-09_JPRB, 0.11935883E-09_JPRB, &
  & 0.12652683E-09_JPRB, 0.13558975E-09_JPRB, 0.14628464E-09_JPRB, 0.15826612E-09_JPRB, 0.17112008E-09_JPRB, 0.18441099E-09_JPRB, &
  & 0.19784292E-09_JPRB, 0.21144500E-09_JPRB, 0.22537984E-09_JPRB, 0.24001148E-09_JPRB, 0.25565142E-09_JPRB, 0.27230890E-09_JPRB, &
  & 0.28941269E-09_JPRB, 0.30609457E-09_JPRB, 0.32074662E-09_JPRB, 0.33192823E-09_JPRB, 0.33893438E-09_JPRB, 0.34149264E-09_JPRB, &
  & 0.33959391E-09_JPRB, 0.33354111E-09_JPRB, 0.32415090E-09_JPRB, 0.31246308E-09_JPRB, 0.30035932E-09_JPRB, 0.28954045E-09_JPRB, &
  & 0.28154340E-09_JPRB, 0.27700156E-09_JPRB, 0.27532812E-09_JPRB, 0.27555411E-09_JPRB, 0.27614763E-09_JPRB, 0.27605510E-09_JPRB, &
  & 0.27444386E-09_JPRB, 0.27109626E-09_JPRB, 0.26592376E-09_JPRB, 0.25923397E-09_JPRB, 0.25146493E-09_JPRB, 0.24307115E-09_JPRB, &
  & 0.23425095E-09_JPRB, 0.22537062E-09_JPRB, 0.21687009E-09_JPRB, 0.20894625E-09_JPRB, 0.20193482E-09_JPRB, 0.19605303E-09_JPRB, &
  & 0.19141146E-09_JPRB, 0.18804973E-09_JPRB, 0.18592322E-09_JPRB, 0.18498506E-09_JPRB, 0.18505149E-09_JPRB, 0.18594110E-09_JPRB, &
  & 0.18750507E-09_JPRB, 0.18971452E-09_JPRB, 0.19285981E-09_JPRB, 0.19938373E-09_JPRB /)

RGHG6(:,22, 6) = (/ &
  & 0.17196516E-09_JPRB, 0.16377280E-09_JPRB, 0.15890726E-09_JPRB, 0.15476827E-09_JPRB, 0.15087576E-09_JPRB, 0.14714679E-09_JPRB, &
  & 0.14380927E-09_JPRB, 0.14128701E-09_JPRB, 0.14017662E-09_JPRB, 0.14095060E-09_JPRB, 0.14389671E-09_JPRB, 0.14908151E-09_JPRB, &
  & 0.15641599E-09_JPRB, 0.16566458E-09_JPRB, 0.17651754E-09_JPRB, 0.18858833E-09_JPRB, 0.20145621E-09_JPRB, 0.21474082E-09_JPRB, &
  & 0.22821889E-09_JPRB, 0.24183791E-09_JPRB, 0.25579824E-09_JPRB, 0.27036320E-09_JPRB, 0.28569280E-09_JPRB, 0.30179767E-09_JPRB, &
  & 0.31837025E-09_JPRB, 0.33439884E-09_JPRB, 0.34880265E-09_JPRB, 0.36051651E-09_JPRB, 0.36862885E-09_JPRB, 0.37288314E-09_JPRB, &
  & 0.37328729E-09_JPRB, 0.37003314E-09_JPRB, 0.36365369E-09_JPRB, 0.35497208E-09_JPRB, 0.34533984E-09_JPRB, 0.33636141E-09_JPRB, &
  & 0.32893727E-09_JPRB, 0.32396316E-09_JPRB, 0.32123251E-09_JPRB, 0.31978717E-09_JPRB, 0.31862993E-09_JPRB, 0.31693684E-09_JPRB, &
  & 0.31406777E-09_JPRB, 0.30967645E-09_JPRB, 0.30368583E-09_JPRB, 0.29640163E-09_JPRB, 0.28817568E-09_JPRB, 0.27929242E-09_JPRB, &
  & 0.27002284E-09_JPRB, 0.26080985E-09_JPRB, 0.25196301E-09_JPRB, 0.24371127E-09_JPRB, 0.23643140E-09_JPRB, 0.23027416E-09_JPRB, &
  & 0.22529677E-09_JPRB, 0.22149543E-09_JPRB, 0.21880367E-09_JPRB, 0.21717253E-09_JPRB, 0.21645896E-09_JPRB, 0.21651292E-09_JPRB, &
  & 0.21720917E-09_JPRB, 0.21850081E-09_JPRB, 0.22057309E-09_JPRB, 0.22498980E-09_JPRB /)

RGHG6(:,23, 6) = (/ &
  & 0.20057514E-09_JPRB, 0.19286782E-09_JPRB, 0.18839864E-09_JPRB, 0.18458080E-09_JPRB, 0.18101806E-09_JPRB, 0.17762913E-09_JPRB, &
  & 0.17459716E-09_JPRB, 0.17241225E-09_JPRB, 0.17162943E-09_JPRB, 0.17274447E-09_JPRB, 0.17602660E-09_JPRB, 0.18153579E-09_JPRB, &
  & 0.18912577E-09_JPRB, 0.19853219E-09_JPRB, 0.20940516E-09_JPRB, 0.22133968E-09_JPRB, 0.23394608E-09_JPRB, 0.24687305E-09_JPRB, &
  & 0.25990482E-09_JPRB, 0.27308469E-09_JPRB, 0.28642658E-09_JPRB, 0.30004943E-09_JPRB, 0.31423736E-09_JPRB, 0.32899614E-09_JPRB, &
  & 0.34398545E-09_JPRB, 0.35868927E-09_JPRB, 0.37208320E-09_JPRB, 0.38320236E-09_JPRB, 0.39177775E-09_JPRB, 0.39740913E-09_JPRB, &
  & 0.39993431E-09_JPRB, 0.39946846E-09_JPRB, 0.39634646E-09_JPRB, 0.39115955E-09_JPRB, 0.38468484E-09_JPRB, 0.37825965E-09_JPRB, &
  & 0.37231399E-09_JPRB, 0.36745262E-09_JPRB, 0.36366343E-09_JPRB, 0.36039982E-09_JPRB, 0.35716080E-09_JPRB, 0.35336861E-09_JPRB, &
  & 0.34868264E-09_JPRB, 0.34296188E-09_JPRB, 0.33605790E-09_JPRB, 0.32806197E-09_JPRB, 0.31918640E-09_JPRB, 0.30986019E-09_JPRB, &
  & 0.30043748E-09_JPRB, 0.29120145E-09_JPRB, 0.28244779E-09_JPRB, 0.27442729E-09_JPRB, 0.26732550E-09_JPRB, 0.26122168E-09_JPRB, &
  & 0.25614075E-09_JPRB, 0.25206845E-09_JPRB, 0.24894600E-09_JPRB, 0.24673186E-09_JPRB, 0.24531815E-09_JPRB, 0.24458868E-09_JPRB, &
  & 0.24444080E-09_JPRB, 0.24481572E-09_JPRB, 0.24580468E-09_JPRB, 0.24840680E-09_JPRB /)

RGHG6(:,24, 6) = (/ &
  & 0.22725689E-09_JPRB, 0.22056088E-09_JPRB, 0.21666535E-09_JPRB, 0.21341715E-09_JPRB, 0.21043292E-09_JPRB, 0.20765403E-09_JPRB, &
  & 0.20529592E-09_JPRB, 0.20380769E-09_JPRB, 0.20376023E-09_JPRB, 0.20560367E-09_JPRB, 0.20957282E-09_JPRB, 0.21568881E-09_JPRB, &
  & 0.22377387E-09_JPRB, 0.23350458E-09_JPRB, 0.24447322E-09_JPRB, 0.25625940E-09_JPRB, 0.26849908E-09_JPRB, 0.28091035E-09_JPRB, &
  & 0.29327199E-09_JPRB, 0.30552169E-09_JPRB, 0.31776251E-09_JPRB, 0.33010181E-09_JPRB, 0.34254505E-09_JPRB, 0.35514419E-09_JPRB, &
  & 0.36779238E-09_JPRB, 0.38015160E-09_JPRB, 0.39186912E-09_JPRB, 0.40228415E-09_JPRB, 0.41070225E-09_JPRB, 0.41703366E-09_JPRB, &
  & 0.42110226E-09_JPRB, 0.42288528E-09_JPRB, 0.42254139E-09_JPRB, 0.42037959E-09_JPRB, 0.41684486E-09_JPRB, 0.41265358E-09_JPRB, &
  & 0.40818465E-09_JPRB, 0.40377146E-09_JPRB, 0.39935311E-09_JPRB, 0.39481929E-09_JPRB, 0.38982764E-09_JPRB, 0.38418105E-09_JPRB, &
  & 0.37771061E-09_JPRB, 0.37041162E-09_JPRB, 0.36226719E-09_JPRB, 0.35343578E-09_JPRB, 0.34421158E-09_JPRB, 0.33493250E-09_JPRB, &
  & 0.32577416E-09_JPRB, 0.31699768E-09_JPRB, 0.30884709E-09_JPRB, 0.30136832E-09_JPRB, 0.29467859E-09_JPRB, 0.28882380E-09_JPRB, &
  & 0.28379746E-09_JPRB, 0.27958910E-09_JPRB, 0.27616071E-09_JPRB, 0.27349117E-09_JPRB, 0.27151215E-09_JPRB, 0.27014063E-09_JPRB, &
  & 0.26929414E-09_JPRB, 0.26889996E-09_JPRB, 0.26894045E-09_JPRB, 0.26985530E-09_JPRB /)

RGHG6(:,25, 6) = (/ &
  & 0.25191743E-09_JPRB, 0.24634847E-09_JPRB, 0.24316454E-09_JPRB, 0.24062211E-09_JPRB, 0.23835167E-09_JPRB, 0.23636079E-09_JPRB, &
  & 0.23487295E-09_JPRB, 0.23434185E-09_JPRB, 0.23528704E-09_JPRB, 0.23810742E-09_JPRB, 0.24298347E-09_JPRB, 0.24987995E-09_JPRB, &
  & 0.25857938E-09_JPRB, 0.26870581E-09_JPRB, 0.27984054E-09_JPRB, 0.29152933E-09_JPRB, 0.30339445E-09_JPRB, 0.31516950E-09_JPRB, &
  & 0.32669450E-09_JPRB, 0.33794537E-09_JPRB, 0.34889211E-09_JPRB, 0.35954006E-09_JPRB, 0.36991604E-09_JPRB, 0.38018802E-09_JPRB, &
  & 0.39031581E-09_JPRB, 0.40024359E-09_JPRB, 0.40976322E-09_JPRB, 0.41861573E-09_JPRB, 0.42653051E-09_JPRB, 0.43307696E-09_JPRB, &
  & 0.43807680E-09_JPRB, 0.44139659E-09_JPRB, 0.44304260E-09_JPRB, 0.44307824E-09_JPRB, 0.44175066E-09_JPRB, 0.43932791E-09_JPRB, &
  & 0.43605744E-09_JPRB, 0.43207876E-09_JPRB, 0.42743473E-09_JPRB, 0.42205806E-09_JPRB, 0.41593978E-09_JPRB, 0.40901998E-09_JPRB, &
  & 0.40134210E-09_JPRB, 0.39298190E-09_JPRB, 0.38405676E-09_JPRB, 0.37479433E-09_JPRB, 0.36549458E-09_JPRB, 0.35638359E-09_JPRB, &
  & 0.34766687E-09_JPRB, 0.33950104E-09_JPRB, 0.33194703E-09_JPRB, 0.32504252E-09_JPRB, 0.31884231E-09_JPRB, 0.31331795E-09_JPRB, &
  & 0.30845157E-09_JPRB, 0.30422004E-09_JPRB, 0.30059955E-09_JPRB, 0.29759184E-09_JPRB, 0.29516564E-09_JPRB, 0.29327568E-09_JPRB, &
  & 0.29186548E-09_JPRB, 0.29085856E-09_JPRB, 0.29017003E-09_JPRB, 0.28974401E-09_JPRB /)

RGHG6(:,26, 6) = (/ &
  & 0.27431724E-09_JPRB, 0.27001198E-09_JPRB, 0.26769290E-09_JPRB, 0.26585031E-09_JPRB, 0.26433741E-09_JPRB, 0.26317329E-09_JPRB, &
  & 0.26261043E-09_JPRB, 0.26308686E-09_JPRB, 0.26507349E-09_JPRB, 0.26889685E-09_JPRB, 0.27466346E-09_JPRB, 0.28230829E-09_JPRB, &
  & 0.29154329E-09_JPRB, 0.30199451E-09_JPRB, 0.31319933E-09_JPRB, 0.32472644E-09_JPRB, 0.33619021E-09_JPRB, 0.34733977E-09_JPRB, &
  & 0.35803532E-09_JPRB, 0.36821335E-09_JPRB, 0.37782577E-09_JPRB, 0.38680814E-09_JPRB, 0.39527703E-09_JPRB, 0.40338005E-09_JPRB, &
  & 0.41114778E-09_JPRB, 0.41868276E-09_JPRB, 0.42605205E-09_JPRB, 0.43326834E-09_JPRB, 0.44016493E-09_JPRB, 0.44651341E-09_JPRB, &
  & 0.45191045E-09_JPRB, 0.45611087E-09_JPRB, 0.45896381E-09_JPRB, 0.46037246E-09_JPRB, 0.46040072E-09_JPRB, 0.45912471E-09_JPRB, &
  & 0.45664406E-09_JPRB, 0.45300880E-09_JPRB, 0.44836457E-09_JPRB, 0.44259352E-09_JPRB, 0.43591220E-09_JPRB, 0.42834020E-09_JPRB, &
  & 0.42008047E-09_JPRB, 0.41127582E-09_JPRB, 0.40211962E-09_JPRB, 0.39284018E-09_JPRB, 0.38369588E-09_JPRB, 0.37497339E-09_JPRB, &
  & 0.36680137E-09_JPRB, 0.35925207E-09_JPRB, 0.35235412E-09_JPRB, 0.34607364E-09_JPRB, 0.34037340E-09_JPRB, 0.33522637E-09_JPRB, &
  & 0.33058298E-09_JPRB, 0.32642003E-09_JPRB, 0.32271932E-09_JPRB, 0.31949315E-09_JPRB, 0.31674208E-09_JPRB, 0.31445557E-09_JPRB, &
  & 0.31260503E-09_JPRB, 0.31111955E-09_JPRB, 0.30985989E-09_JPRB, 0.30844544E-09_JPRB /)

RGHG6(:,27, 6) = (/ &
  & 0.29473388E-09_JPRB, 0.29179570E-09_JPRB, 0.29014532E-09_JPRB, 0.28900496E-09_JPRB, 0.28817027E-09_JPRB, 0.28775823E-09_JPRB, &
  & 0.28803432E-09_JPRB, 0.28942376E-09_JPRB, 0.29231681E-09_JPRB, 0.29697872E-09_JPRB, 0.30346356E-09_JPRB, 0.31162781E-09_JPRB, &
  & 0.32120273E-09_JPRB, 0.33177036E-09_JPRB, 0.34290601E-09_JPRB, 0.35416198E-09_JPRB, 0.36519077E-09_JPRB, 0.37572606E-09_JPRB, &
  & 0.38563780E-09_JPRB, 0.39485609E-09_JPRB, 0.40328366E-09_JPRB, 0.41089693E-09_JPRB, 0.41778148E-09_JPRB, 0.42406353E-09_JPRB, &
  & 0.42988879E-09_JPRB, 0.43542575E-09_JPRB, 0.44097098E-09_JPRB, 0.44666415E-09_JPRB, 0.45247378E-09_JPRB, 0.45820064E-09_JPRB, &
  & 0.46350054E-09_JPRB, 0.46801985E-09_JPRB, 0.47145488E-09_JPRB, 0.47358206E-09_JPRB, 0.47432830E-09_JPRB, 0.47367521E-09_JPRB, &
  & 0.47164161E-09_JPRB, 0.46825416E-09_JPRB, 0.46364801E-09_JPRB, 0.45785500E-09_JPRB, 0.45094994E-09_JPRB, 0.44322118E-09_JPRB, &
  & 0.43481041E-09_JPRB, 0.42600251E-09_JPRB, 0.41697312E-09_JPRB, 0.40800111E-09_JPRB, 0.39935438E-09_JPRB, 0.39125114E-09_JPRB, &
  & 0.38378159E-09_JPRB, 0.37695227E-09_JPRB, 0.37072340E-09_JPRB, 0.36502337E-09_JPRB, 0.35981479E-09_JPRB, 0.35503622E-09_JPRB, &
  & 0.35064082E-09_JPRB, 0.34660574E-09_JPRB, 0.34291767E-09_JPRB, 0.33959616E-09_JPRB, 0.33666131E-09_JPRB, 0.33412650E-09_JPRB, &
  & 0.33198400E-09_JPRB, 0.33016700E-09_JPRB, 0.32850447E-09_JPRB, 0.32637085E-09_JPRB /)

RGHG6(:,28, 6) = (/ &
  & 0.31363553E-09_JPRB, 0.31154007E-09_JPRB, 0.31058517E-09_JPRB, 0.30997913E-09_JPRB, 0.30972169E-09_JPRB, 0.30993025E-09_JPRB, &
  & 0.31090136E-09_JPRB, 0.31300065E-09_JPRB, 0.31661190E-09_JPRB, 0.32189057E-09_JPRB, 0.32882191E-09_JPRB, 0.33728040E-09_JPRB, &
  & 0.34693659E-09_JPRB, 0.35743980E-09_JPRB, 0.36834166E-09_JPRB, 0.37925024E-09_JPRB, 0.38980350E-09_JPRB, 0.39976800E-09_JPRB, &
  & 0.40899742E-09_JPRB, 0.41740406E-09_JPRB, 0.42490056E-09_JPRB, 0.43145998E-09_JPRB, 0.43713430E-09_JPRB, 0.44204898E-09_JPRB, &
  & 0.44639151E-09_JPRB, 0.45040288E-09_JPRB, 0.45444487E-09_JPRB, 0.45878346E-09_JPRB, 0.46351251E-09_JPRB, 0.46853077E-09_JPRB, &
  & 0.47346083E-09_JPRB, 0.47790483E-09_JPRB, 0.48148285E-09_JPRB, 0.48388249E-09_JPRB, 0.48493998E-09_JPRB, 0.48457705E-09_JPRB, &
  & 0.48278131E-09_JPRB, 0.47958026E-09_JPRB, 0.47506626E-09_JPRB, 0.46937165E-09_JPRB, 0.46258589E-09_JPRB, 0.45494281E-09_JPRB, &
  & 0.44674969E-09_JPRB, 0.43822848E-09_JPRB, 0.42963505E-09_JPRB, 0.42124926E-09_JPRB, 0.41329212E-09_JPRB, 0.40596312E-09_JPRB, &
  & 0.39926334E-09_JPRB, 0.39315115E-09_JPRB, 0.38754949E-09_JPRB, 0.38238826E-09_JPRB, 0.37760700E-09_JPRB, 0.37315495E-09_JPRB, &
  & 0.36899034E-09_JPRB, 0.36509629E-09_JPRB, 0.36146464E-09_JPRB, 0.35811307E-09_JPRB, 0.35506384E-09_JPRB, 0.35234177E-09_JPRB, &
  & 0.34995490E-09_JPRB, 0.34783312E-09_JPRB, 0.34574441E-09_JPRB, 0.34265912E-09_JPRB /)

RGHG6(:,29, 6) = (/ &
  & 0.33063899E-09_JPRB, 0.32940195E-09_JPRB, 0.32891262E-09_JPRB, 0.32875724E-09_JPRB, 0.32894593E-09_JPRB, 0.32964229E-09_JPRB, &
  & 0.33112307E-09_JPRB, 0.33379904E-09_JPRB, 0.33790287E-09_JPRB, 0.34357422E-09_JPRB, 0.35076533E-09_JPRB, 0.35927805E-09_JPRB, &
  & 0.36886097E-09_JPRB, 0.37912790E-09_JPRB, 0.38970283E-09_JPRB, 0.40018958E-09_JPRB, 0.41027240E-09_JPRB, 0.41971177E-09_JPRB, &
  & 0.42835835E-09_JPRB, 0.43611276E-09_JPRB, 0.44289966E-09_JPRB, 0.44868179E-09_JPRB, 0.45348467E-09_JPRB, 0.45744145E-09_JPRB, &
  & 0.46074486E-09_JPRB, 0.46366574E-09_JPRB, 0.46660753E-09_JPRB, 0.46985416E-09_JPRB, 0.47359822E-09_JPRB, 0.47780968E-09_JPRB, &
  & 0.48221749E-09_JPRB, 0.48634580E-09_JPRB, 0.48978199E-09_JPRB, 0.49216631E-09_JPRB, 0.49327786E-09_JPRB, 0.49301563E-09_JPRB, &
  & 0.49136201E-09_JPRB, 0.48833293E-09_JPRB, 0.48401455E-09_JPRB, 0.47851545E-09_JPRB, 0.47203097E-09_JPRB, 0.46475662E-09_JPRB, &
  & 0.45699095E-09_JPRB, 0.44900364E-09_JPRB, 0.44110460E-09_JPRB, 0.43345369E-09_JPRB, 0.42629325E-09_JPRB, 0.41973014E-09_JPRB, &
  & 0.41375492E-09_JPRB, 0.40827275E-09_JPRB, 0.40319834E-09_JPRB, 0.39846026E-09_JPRB, 0.39401710E-09_JPRB, 0.38982562E-09_JPRB, &
  & 0.38585229E-09_JPRB, 0.38209064E-09_JPRB, 0.37853026E-09_JPRB, 0.37519035E-09_JPRB, 0.37209424E-09_JPRB, 0.36927261E-09_JPRB, &
  & 0.36675046E-09_JPRB, 0.36447068E-09_JPRB, 0.36222536E-09_JPRB, 0.35908232E-09_JPRB /)

RGHG6(:,30, 6) = (/ &
  & 0.34591255E-09_JPRB, 0.34532238E-09_JPRB, 0.34523662E-09_JPRB, 0.34542663E-09_JPRB, 0.34595862E-09_JPRB, 0.34701653E-09_JPRB, &
  & 0.34891981E-09_JPRB, 0.35196035E-09_JPRB, 0.35642214E-09_JPRB, 0.36232667E-09_JPRB, 0.36958345E-09_JPRB, 0.37804199E-09_JPRB, &
  & 0.38740144E-09_JPRB, 0.39735371E-09_JPRB, 0.40752365E-09_JPRB, 0.41756940E-09_JPRB, 0.42718912E-09_JPRB, 0.43615322E-09_JPRB, &
  & 0.44431103E-09_JPRB, 0.45155060E-09_JPRB, 0.45779106E-09_JPRB, 0.46299808E-09_JPRB, 0.46719306E-09_JPRB, 0.47049925E-09_JPRB, &
  & 0.47311366E-09_JPRB, 0.47530885E-09_JPRB, 0.47746551E-09_JPRB, 0.47990234E-09_JPRB, 0.48285187E-09_JPRB, 0.48630699E-09_JPRB, &
  & 0.49007931E-09_JPRB, 0.49374371E-09_JPRB, 0.49686305E-09_JPRB, 0.49905885E-09_JPRB, 0.50008320E-09_JPRB, 0.49981752E-09_JPRB, &
  & 0.49825161E-09_JPRB, 0.49542415E-09_JPRB, 0.49138843E-09_JPRB, 0.48626103E-09_JPRB, 0.48019200E-09_JPRB, 0.47345183E-09_JPRB, &
  & 0.46634913E-09_JPRB, 0.45909701E-09_JPRB, 0.45195475E-09_JPRB, 0.44508872E-09_JPRB, 0.43869047E-09_JPRB, 0.43285342E-09_JPRB, &
  & 0.42747011E-09_JPRB, 0.42248749E-09_JPRB, 0.41782000E-09_JPRB, 0.41338927E-09_JPRB, 0.40918868E-09_JPRB, 0.40518741E-09_JPRB, &
  & 0.40136711E-09_JPRB, 0.39772316E-09_JPRB, 0.39425133E-09_JPRB, 0.39096557E-09_JPRB, 0.38788850E-09_JPRB, 0.38505302E-09_JPRB, &
  & 0.38248851E-09_JPRB, 0.38014469E-09_JPRB, 0.37779840E-09_JPRB, 0.37430573E-09_JPRB /)

RGHG6(:,31, 6) = (/ &
  & 0.35960770E-09_JPRB, 0.35957889E-09_JPRB, 0.35980310E-09_JPRB, 0.36025533E-09_JPRB, 0.36105868E-09_JPRB, 0.36240924E-09_JPRB, &
  & 0.36457945E-09_JPRB, 0.36792316E-09_JPRB, 0.37257111E-09_JPRB, 0.37855560E-09_JPRB, 0.38578582E-09_JPRB, 0.39405432E-09_JPRB, &
  & 0.40314302E-09_JPRB, 0.41270098E-09_JPRB, 0.42243725E-09_JPRB, 0.43201825E-09_JPRB, 0.44118931E-09_JPRB, 0.44971710E-09_JPRB, &
  & 0.45745818E-09_JPRB, 0.46428164E-09_JPRB, 0.47010579E-09_JPRB, 0.47489035E-09_JPRB, 0.47866600E-09_JPRB, 0.48155219E-09_JPRB, &
  & 0.48373378E-09_JPRB, 0.48548443E-09_JPRB, 0.48713378E-09_JPRB, 0.48898535E-09_JPRB, 0.49129129E-09_JPRB, 0.49408472E-09_JPRB, &
  & 0.49722498E-09_JPRB, 0.50035431E-09_JPRB, 0.50305282E-09_JPRB, 0.50494592E-09_JPRB, 0.50580018E-09_JPRB, 0.50550192E-09_JPRB, &
  & 0.50403187E-09_JPRB, 0.50143251E-09_JPRB, 0.49777527E-09_JPRB, 0.49312043E-09_JPRB, 0.48765436E-09_JPRB, 0.48157450E-09_JPRB, &
  & 0.47520882E-09_JPRB, 0.46876847E-09_JPRB, 0.46241791E-09_JPRB, 0.45635015E-09_JPRB, 0.45060039E-09_JPRB, 0.44533904E-09_JPRB, &
  & 0.44043366E-09_JPRB, 0.43581205E-09_JPRB, 0.43141862E-09_JPRB, 0.42720316E-09_JPRB, 0.42316811E-09_JPRB, 0.41930587E-09_JPRB, &
  & 0.41560960E-09_JPRB, 0.41207612E-09_JPRB, 0.40870449E-09_JPRB, 0.40550477E-09_JPRB, 0.40249454E-09_JPRB, 0.39970169E-09_JPRB, &
  & 0.39715070E-09_JPRB, 0.39478740E-09_JPRB, 0.39238418E-09_JPRB, 0.38872267E-09_JPRB /)

RGHG6(:,32, 6) = (/ &
  & 0.37203557E-09_JPRB, 0.37244591E-09_JPRB, 0.37289885E-09_JPRB, 0.37358824E-09_JPRB, 0.37460807E-09_JPRB, 0.37617670E-09_JPRB, &
  & 0.37858580E-09_JPRB, 0.38206810E-09_JPRB, 0.38680070E-09_JPRB, 0.39275702E-09_JPRB, 0.39982315E-09_JPRB, 0.40785100E-09_JPRB, &
  & 0.41657353E-09_JPRB, 0.42572618E-09_JPRB, 0.43499121E-09_JPRB, 0.44410881E-09_JPRB, 0.45284726E-09_JPRB, 0.46096776E-09_JPRB, &
  & 0.46833781E-09_JPRB, 0.47481807E-09_JPRB, 0.48031751E-09_JPRB, 0.48480026E-09_JPRB, 0.48829474E-09_JPRB, 0.49092047E-09_JPRB, &
  & 0.49285570E-09_JPRB, 0.49433913E-09_JPRB, 0.49568732E-09_JPRB, 0.49714011E-09_JPRB, 0.49895676E-09_JPRB, 0.50118865E-09_JPRB, &
  & 0.50374321E-09_JPRB, 0.50632648E-09_JPRB, 0.50856425E-09_JPRB, 0.51012067E-09_JPRB, 0.51076310E-09_JPRB, 0.51040433E-09_JPRB, &
  & 0.50904569E-09_JPRB, 0.50672178E-09_JPRB, 0.50347809E-09_JPRB, 0.49940241E-09_JPRB, 0.49458948E-09_JPRB, 0.48929794E-09_JPRB, &
  & 0.48372822E-09_JPRB, 0.47809745E-09_JPRB, 0.47249371E-09_JPRB, 0.46708332E-09_JPRB, 0.46193294E-09_JPRB, 0.45706486E-09_JPRB, &
  & 0.45251167E-09_JPRB, 0.44814480E-09_JPRB, 0.44393833E-09_JPRB, 0.43987047E-09_JPRB, 0.43595211E-09_JPRB, 0.43219567E-09_JPRB, &
  & 0.42860673E-09_JPRB, 0.42518089E-09_JPRB, 0.42191875E-09_JPRB, 0.41882631E-09_JPRB, 0.41591608E-09_JPRB, 0.41320741E-09_JPRB, &
  & 0.41071707E-09_JPRB, 0.40839088E-09_JPRB, 0.40599915E-09_JPRB, 0.40239584E-09_JPRB /)

RGHG6(:,33, 6) = (/ &
  & 0.38338724E-09_JPRB, 0.38412790E-09_JPRB, 0.38484183E-09_JPRB, 0.38571613E-09_JPRB, 0.38693970E-09_JPRB, 0.38869874E-09_JPRB, &
  & 0.39123804E-09_JPRB, 0.39481518E-09_JPRB, 0.39950870E-09_JPRB, 0.40531434E-09_JPRB, 0.41215131E-09_JPRB, 0.41983417E-09_JPRB, &
  & 0.42816678E-09_JPRB, 0.43685403E-09_JPRB, 0.44565979E-09_JPRB, 0.45430210E-09_JPRB, 0.46260834E-09_JPRB, 0.47035820E-09_JPRB, &
  & 0.47739046E-09_JPRB, 0.48357918E-09_JPRB, 0.48882964E-09_JPRB, 0.49309945E-09_JPRB, 0.49641857E-09_JPRB, 0.49890103E-09_JPRB, &
  & 0.50070981E-09_JPRB, 0.50206173E-09_JPRB, 0.50324023E-09_JPRB, 0.50443699E-09_JPRB, 0.50588195E-09_JPRB, 0.50764842E-09_JPRB, &
  & 0.50967802E-09_JPRB, 0.51173388E-09_JPRB, 0.51351040E-09_JPRB, 0.51471621E-09_JPRB, 0.51516541E-09_JPRB, 0.51476079E-09_JPRB, &
  & 0.51351895E-09_JPRB, 0.51148319E-09_JPRB, 0.50869126E-09_JPRB, 0.50517912E-09_JPRB, 0.50108190E-09_JPRB, 0.49653187E-09_JPRB, &
  & 0.49176901E-09_JPRB, 0.48687981E-09_JPRB, 0.48197768E-09_JPRB, 0.47712906E-09_JPRB, 0.47243726E-09_JPRB, 0.46791243E-09_JPRB, &
  & 0.46357068E-09_JPRB, 0.45939236E-09_JPRB, 0.45530926E-09_JPRB, 0.45134846E-09_JPRB, 0.44752257E-09_JPRB, 0.44386253E-09_JPRB, &
  & 0.44037510E-09_JPRB, 0.43705756E-09_JPRB, 0.43391282E-09_JPRB, 0.43094306E-09_JPRB, 0.42815582E-09_JPRB, 0.42556683E-09_JPRB, &
  & 0.42317527E-09_JPRB, 0.42092982E-09_JPRB, 0.41860701E-09_JPRB, 0.41503384E-09_JPRB /)

RGHG6(:,34, 6) = (/ &
  & 0.39369397E-09_JPRB, 0.39490036E-09_JPRB, 0.39580800E-09_JPRB, 0.39689499E-09_JPRB, 0.39828191E-09_JPRB, 0.40018444E-09_JPRB, &
  & 0.40283474E-09_JPRB, 0.40639686E-09_JPRB, 0.41097828E-09_JPRB, 0.41656370E-09_JPRB, 0.42307130E-09_JPRB, 0.43037507E-09_JPRB, &
  & 0.43824960E-09_JPRB, 0.44646944E-09_JPRB, 0.45478690E-09_JPRB, 0.46297657E-09_JPRB, 0.47085247E-09_JPRB, 0.47824178E-09_JPRB, &
  & 0.48497362E-09_JPRB, 0.49091531E-09_JPRB, 0.49597387E-09_JPRB, 0.50010285E-09_JPRB, 0.50332732E-09_JPRB, 0.50574450E-09_JPRB, &
  & 0.50751048E-09_JPRB, 0.50881133E-09_JPRB, 0.50989163E-09_JPRB, 0.51093230E-09_JPRB, 0.51209431E-09_JPRB, 0.51348592E-09_JPRB, &
  & 0.51505544E-09_JPRB, 0.51663496E-09_JPRB, 0.51798205E-09_JPRB, 0.51886329E-09_JPRB, 0.51911853E-09_JPRB, 0.51869165E-09_JPRB, &
  & 0.51758375E-09_JPRB, 0.51583476E-09_JPRB, 0.51346871E-09_JPRB, 0.51052318E-09_JPRB, 0.50705762E-09_JPRB, 0.50323007E-09_JPRB, &
  & 0.49915400E-09_JPRB, 0.49494242E-09_JPRB, 0.49061843E-09_JPRB, 0.48625398E-09_JPRB, 0.48193455E-09_JPRB, 0.47767346E-09_JPRB, &
  & 0.47351378E-09_JPRB, 0.46945536E-09_JPRB, 0.46548423E-09_JPRB, 0.46161153E-09_JPRB, 0.45787771E-09_JPRB, 0.45431653E-09_JPRB, &
  & 0.45093287E-09_JPRB, 0.44773063E-09_JPRB, 0.44470808E-09_JPRB, 0.44187221E-09_JPRB, 0.43922821E-09_JPRB, 0.43678100E-09_JPRB, &
  & 0.43452592E-09_JPRB, 0.43240533E-09_JPRB, 0.43019571E-09_JPRB, 0.42680273E-09_JPRB /)

RGHG6(:,35, 6) = (/ &
  & 0.40332032E-09_JPRB, 0.40485132E-09_JPRB, 0.40600409E-09_JPRB, 0.40724249E-09_JPRB, 0.40878154E-09_JPRB, 0.41080048E-09_JPRB, &
  & 0.41348328E-09_JPRB, 0.41700152E-09_JPRB, 0.42140560E-09_JPRB, 0.42670406E-09_JPRB, 0.43284909E-09_JPRB, 0.43970960E-09_JPRB, &
  & 0.44711176E-09_JPRB, 0.45483128E-09_JPRB, 0.46266543E-09_JPRB, 0.47040155E-09_JPRB, 0.47786614E-09_JPRB, 0.48490678E-09_JPRB, &
  & 0.49136800E-09_JPRB, 0.49711102E-09_JPRB, 0.50202975E-09_JPRB, 0.50607574E-09_JPRB, 0.50926396E-09_JPRB, 0.51167220E-09_JPRB, &
  & 0.51343807E-09_JPRB, 0.51473747E-09_JPRB, 0.51576604E-09_JPRB, 0.51669663E-09_JPRB, 0.51765314E-09_JPRB, 0.51872473E-09_JPRB, &
  & 0.51989729E-09_JPRB, 0.52105192E-09_JPRB, 0.52201793E-09_JPRB, 0.52261218E-09_JPRB, 0.52271210E-09_JPRB, 0.52227250E-09_JPRB, &
  & 0.52130417E-09_JPRB, 0.51982280E-09_JPRB, 0.51785060E-09_JPRB, 0.51539567E-09_JPRB, 0.51251076E-09_JPRB, 0.50926829E-09_JPRB, &
  & 0.50579863E-09_JPRB, 0.50212728E-09_JPRB, 0.49829418E-09_JPRB, 0.49432758E-09_JPRB, 0.49031068E-09_JPRB, 0.48627963E-09_JPRB, &
  & 0.48226378E-09_JPRB, 0.47832349E-09_JPRB, 0.47444720E-09_JPRB, 0.47067061E-09_JPRB, 0.46704007E-09_JPRB, 0.46358767E-09_JPRB, &
  & 0.46032028E-09_JPRB, 0.45723822E-09_JPRB, 0.45434639E-09_JPRB, 0.45165086E-09_JPRB, 0.44916004E-09_JPRB, 0.44687526E-09_JPRB, &
  & 0.44478066E-09_JPRB, 0.44281356E-09_JPRB, 0.44076590E-09_JPRB, 0.43759119E-09_JPRB /)

RGHG6(:,36, 6) = (/ &
  & 0.41224985E-09_JPRB, 0.41417042E-09_JPRB, 0.41548309E-09_JPRB, 0.41688708E-09_JPRB, 0.41854531E-09_JPRB, 0.42063736E-09_JPRB, &
  & 0.42333456E-09_JPRB, 0.42674381E-09_JPRB, 0.43093462E-09_JPRB, 0.43591941E-09_JPRB, 0.44165863E-09_JPRB, 0.44805848E-09_JPRB, &
  & 0.45495768E-09_JPRB, 0.46217252E-09_JPRB, 0.46951132E-09_JPRB, 0.47679971E-09_JPRB, 0.48387133E-09_JPRB, 0.49058119E-09_JPRB, &
  & 0.49679511E-09_JPRB, 0.50237914E-09_JPRB, 0.50721588E-09_JPRB, 0.51123017E-09_JPRB, 0.51441568E-09_JPRB, 0.51683802E-09_JPRB, &
  & 0.51862192E-09_JPRB, 0.51992349E-09_JPRB, 0.52091570E-09_JPRB, 0.52174925E-09_JPRB, 0.52253252E-09_JPRB, 0.52333848E-09_JPRB, &
  & 0.52416976E-09_JPRB, 0.52495996E-09_JPRB, 0.52559257E-09_JPRB, 0.52594595E-09_JPRB, 0.52592908E-09_JPRB, 0.52550919E-09_JPRB, &
  & 0.52468102E-09_JPRB, 0.52345955E-09_JPRB, 0.52183818E-09_JPRB, 0.51981569E-09_JPRB, 0.51739679E-09_JPRB, 0.51465154E-09_JPRB, &
  & 0.51163607E-09_JPRB, 0.50840998E-09_JPRB, 0.50496174E-09_JPRB, 0.50133087E-09_JPRB, 0.49757259E-09_JPRB, 0.49372806E-09_JPRB, &
  & 0.48986137E-09_JPRB, 0.48603022E-09_JPRB, 0.48225690E-09_JPRB, 0.47859017E-09_JPRB, 0.47507553E-09_JPRB, 0.47174964E-09_JPRB, &
  & 0.46861048E-09_JPRB, 0.46565979E-09_JPRB, 0.46290180E-09_JPRB, 0.46035431E-09_JPRB, 0.45802642E-09_JPRB, 0.45591686E-09_JPRB, &
  & 0.45400289E-09_JPRB, 0.45221668E-09_JPRB, 0.45035470E-09_JPRB, 0.44747181E-09_JPRB /)

RGHG6(:,37, 6) = (/ &
  & 0.42071274E-09_JPRB, 0.42290801E-09_JPRB, 0.42440751E-09_JPRB, 0.42593956E-09_JPRB, 0.42769843E-09_JPRB, 0.42985046E-09_JPRB, &
  & 0.43250978E-09_JPRB, 0.43578446E-09_JPRB, 0.43972745E-09_JPRB, 0.44436557E-09_JPRB, 0.44968396E-09_JPRB, 0.45560081E-09_JPRB, &
  & 0.46197968E-09_JPRB, 0.46867421E-09_JPRB, 0.47551896E-09_JPRB, 0.48235271E-09_JPRB, 0.48904031E-09_JPRB, 0.49543941E-09_JPRB, &
  & 0.50142990E-09_JPRB, 0.50687682E-09_JPRB, 0.51165167E-09_JPRB, 0.51565491E-09_JPRB, 0.51883753E-09_JPRB, 0.52124993E-09_JPRB, &
  & 0.52299687E-09_JPRB, 0.52425037E-09_JPRB, 0.52516402E-09_JPRB, 0.52588428E-09_JPRB, 0.52650534E-09_JPRB, 0.52709009E-09_JPRB, &
  & 0.52764898E-09_JPRB, 0.52814925E-09_JPRB, 0.52852422E-09_JPRB, 0.52869564E-09_JPRB, 0.52861016E-09_JPRB, 0.52823318E-09_JPRB, &
  & 0.52756949E-09_JPRB, 0.52659677E-09_JPRB, 0.52530819E-09_JPRB, 0.52367244E-09_JPRB, 0.52167626E-09_JPRB, 0.51933602E-09_JPRB, &
  & 0.51670768E-09_JPRB, 0.51381588E-09_JPRB, 0.51068416E-09_JPRB, 0.50733173E-09_JPRB, 0.50379723E-09_JPRB, 0.50012749E-09_JPRB, &
  & 0.49640220E-09_JPRB, 0.49268895E-09_JPRB, 0.48903087E-09_JPRB, 0.48548271E-09_JPRB, 0.48210502E-09_JPRB, 0.47891768E-09_JPRB, &
  & 0.47591986E-09_JPRB, 0.47310778E-09_JPRB, 0.47049381E-09_JPRB, 0.46810056E-09_JPRB, 0.46594462E-09_JPRB, 0.46402157E-09_JPRB, &
  & 0.46230109E-09_JPRB, 0.46070708E-09_JPRB, 0.45905307E-09_JPRB, 0.45647902E-09_JPRB /)

RGHG6(:,38, 6) = (/ &
  & 0.42876050E-09_JPRB, 0.43119047E-09_JPRB, 0.43285767E-09_JPRB, 0.43449971E-09_JPRB, 0.43637549E-09_JPRB, 0.43855269E-09_JPRB, &
  & 0.44115611E-09_JPRB, 0.44425991E-09_JPRB, 0.44792264E-09_JPRB, 0.45219151E-09_JPRB, 0.45706933E-09_JPRB, 0.46248691E-09_JPRB, &
  & 0.46833748E-09_JPRB, 0.47449816E-09_JPRB, 0.48083826E-09_JPRB, 0.48722193E-09_JPRB, 0.49351867E-09_JPRB, 0.49961535E-09_JPRB, &
  & 0.50538729E-09_JPRB, 0.51069965E-09_JPRB, 0.51539384E-09_JPRB, 0.51931742E-09_JPRB, 0.52240545E-09_JPRB, 0.52468296E-09_JPRB, &
  & 0.52628452E-09_JPRB, 0.52738558E-09_JPRB, 0.52816584E-09_JPRB, 0.52875060E-09_JPRB, 0.52923022E-09_JPRB, 0.52965010E-09_JPRB, &
  & 0.53002430E-09_JPRB, 0.53033589E-09_JPRB, 0.53054477E-09_JPRB, 0.53061078E-09_JPRB, 0.53049543E-09_JPRB, 0.53018595E-09_JPRB, &
  & 0.52967353E-09_JPRB, 0.52893401E-09_JPRB, 0.52794963E-09_JPRB, 0.52668819E-09_JPRB, 0.52510113E-09_JPRB, 0.52317078E-09_JPRB, &
  & 0.52091526E-09_JPRB, 0.51835758E-09_JPRB, 0.51551574E-09_JPRB, 0.51240767E-09_JPRB, 0.50907917E-09_JPRB, 0.50558352E-09_JPRB, &
  & 0.50200299E-09_JPRB, 0.49842397E-09_JPRB, 0.49489224E-09_JPRB, 0.49148208E-09_JPRB, 0.48824988E-09_JPRB, 0.48521365E-09_JPRB, &
  & 0.48236648E-09_JPRB, 0.47970100E-09_JPRB, 0.47723664E-09_JPRB, 0.47500492E-09_JPRB, 0.47302867E-09_JPRB, 0.47129933E-09_JPRB, &
  & 0.46977766E-09_JPRB, 0.46837906E-09_JPRB, 0.46693277E-09_JPRB, 0.46467591E-09_JPRB /)

RGHG6(:,39, 6) = (/ &
  & 0.43643789E-09_JPRB, 0.43910603E-09_JPRB, 0.44087076E-09_JPRB, 0.44268283E-09_JPRB, 0.44462209E-09_JPRB, 0.44684845E-09_JPRB, &
  & 0.44936879E-09_JPRB, 0.45227228E-09_JPRB, 0.45563206E-09_JPRB, 0.45951185E-09_JPRB, 0.46392656E-09_JPRB, 0.46883980E-09_JPRB, &
  & 0.47415327E-09_JPRB, 0.47977661E-09_JPRB, 0.48560489E-09_JPRB, 0.49152710E-09_JPRB, 0.49743099E-09_JPRB, 0.50321008E-09_JPRB, &
  & 0.50874327E-09_JPRB, 0.51389043E-09_JPRB, 0.51842974E-09_JPRB, 0.52217836E-09_JPRB, 0.52502896E-09_JPRB, 0.52705967E-09_JPRB, &
  & 0.52843080E-09_JPRB, 0.52934945E-09_JPRB, 0.52998411E-09_JPRB, 0.53045424E-09_JPRB, 0.53082960E-09_JPRB, 0.53114635E-09_JPRB, &
  & 0.53141358E-09_JPRB, 0.53162086E-09_JPRB, 0.53174121E-09_JPRB, 0.53175347E-09_JPRB, 0.53163463E-09_JPRB, 0.53137494E-09_JPRB, &
  & 0.53098176E-09_JPRB, 0.53041105E-09_JPRB, 0.52967464E-09_JPRB, 0.52872762E-09_JPRB, 0.52750887E-09_JPRB, 0.52598714E-09_JPRB, &
  & 0.52414567E-09_JPRB, 0.52197180E-09_JPRB, 0.51945603E-09_JPRB, 0.51662635E-09_JPRB, 0.51352050E-09_JPRB, 0.51020999E-09_JPRB, &
  & 0.50679211E-09_JPRB, 0.50335747E-09_JPRB, 0.49997129E-09_JPRB, 0.49671056E-09_JPRB, 0.49363491E-09_JPRB, 0.49075605E-09_JPRB, &
  & 0.48806126E-09_JPRB, 0.48554721E-09_JPRB, 0.48323584E-09_JPRB, 0.48117166E-09_JPRB, 0.47937904E-09_JPRB, 0.47784565E-09_JPRB, &
  & 0.47651771E-09_JPRB, 0.47531074E-09_JPRB, 0.47405946E-09_JPRB, 0.47210996E-09_JPRB /)

RGHG6(:,40, 6) = (/ &
  & 0.44383786E-09_JPRB, 0.44659790E-09_JPRB, 0.44856224E-09_JPRB, 0.45043241E-09_JPRB, 0.45254056E-09_JPRB, 0.45476098E-09_JPRB, &
  & 0.45719817E-09_JPRB, 0.45989376E-09_JPRB, 0.46293402E-09_JPRB, 0.46640186E-09_JPRB, 0.47035098E-09_JPRB, 0.47474913E-09_JPRB, &
  & 0.47953258E-09_JPRB, 0.48462157E-09_JPRB, 0.48993709E-09_JPRB, 0.49538795E-09_JPRB, 0.50087984E-09_JPRB, 0.50631183E-09_JPRB, &
  & 0.51156912E-09_JPRB, 0.51646182E-09_JPRB, 0.52077842E-09_JPRB, 0.52426075E-09_JPRB, 0.52683796E-09_JPRB, 0.52860349E-09_JPRB, &
  & 0.52976412E-09_JPRB, 0.53052662E-09_JPRB, 0.53105170E-09_JPRB, 0.53143967E-09_JPRB, 0.53174809E-09_JPRB, 0.53200327E-09_JPRB, &
  & 0.53221089E-09_JPRB, 0.53236288E-09_JPRB, 0.53243815E-09_JPRB, 0.53242405E-09_JPRB, 0.53230720E-09_JPRB, 0.53208343E-09_JPRB, &
  & 0.53176258E-09_JPRB, 0.53130567E-09_JPRB, 0.53073790E-09_JPRB, 0.53001042E-09_JPRB, 0.52908006E-09_JPRB, 0.52791005E-09_JPRB, &
  & 0.52646387E-09_JPRB, 0.52469390E-09_JPRB, 0.52256283E-09_JPRB, 0.52005433E-09_JPRB, 0.51721483E-09_JPRB, 0.51412319E-09_JPRB, &
  & 0.51088150E-09_JPRB, 0.50761156E-09_JPRB, 0.50438614E-09_JPRB, 0.50128529E-09_JPRB, 0.49837245E-09_JPRB, 0.49565235E-09_JPRB, &
  & 0.49311072E-09_JPRB, 0.49074400E-09_JPRB, 0.48858767E-09_JPRB, 0.48668919E-09_JPRB, 0.48508042E-09_JPRB, 0.48373544E-09_JPRB, &
  & 0.48259324E-09_JPRB, 0.48155985E-09_JPRB, 0.48049481E-09_JPRB, 0.47881921E-09_JPRB /)

RGHG6(:,41, 6) = (/ &
  & 0.45089446E-09_JPRB, 0.45384335E-09_JPRB, 0.45581647E-09_JPRB, 0.45790985E-09_JPRB, 0.46005560E-09_JPRB, 0.46234133E-09_JPRB, &
  & 0.46467594E-09_JPRB, 0.46715615E-09_JPRB, 0.46987425E-09_JPRB, 0.47293830E-09_JPRB, 0.47640852E-09_JPRB, 0.48030058E-09_JPRB, &
  & 0.48456195E-09_JPRB, 0.48912974E-09_JPRB, 0.49393695E-09_JPRB, 0.49891502E-09_JPRB, 0.50397470E-09_JPRB, 0.50902887E-09_JPRB, &
  & 0.51395571E-09_JPRB, 0.51856808E-09_JPRB, 0.52257870E-09_JPRB, 0.52577642E-09_JPRB, 0.52808186E-09_JPRB, 0.52962862E-09_JPRB, &
  & 0.53062593E-09_JPRB, 0.53127569E-09_JPRB, 0.53172328E-09_JPRB, 0.53205573E-09_JPRB, 0.53231974E-09_JPRB, 0.53253674E-09_JPRB, &
  & 0.53271015E-09_JPRB, 0.53283050E-09_JPRB, 0.53288246E-09_JPRB, 0.53285432E-09_JPRB, 0.53274279E-09_JPRB, 0.53254151E-09_JPRB, &
  & 0.53226829E-09_JPRB, 0.53188737E-09_JPRB, 0.53142524E-09_JPRB, 0.53085086E-09_JPRB, 0.53012167E-09_JPRB, 0.52921939E-09_JPRB, &
  & 0.52810079E-09_JPRB, 0.52670263E-09_JPRB, 0.52495663E-09_JPRB, 0.52281235E-09_JPRB, 0.52027926E-09_JPRB, 0.51743293E-09_JPRB, &
  & 0.51439752E-09_JPRB, 0.51130400E-09_JPRB, 0.50825427E-09_JPRB, 0.50532167E-09_JPRB, 0.50257354E-09_JPRB, 0.50001137E-09_JPRB, &
  & 0.49761739E-09_JPRB, 0.49539772E-09_JPRB, 0.49338778E-09_JPRB, 0.49165388E-09_JPRB, 0.49021920E-09_JPRB, 0.48905124E-09_JPRB, &
  & 0.48807586E-09_JPRB, 0.48720183E-09_JPRB, 0.48629445E-09_JPRB, 0.48486742E-09_JPRB /)

RGHG6(:,42, 6) = (/ &
  & 0.45777371E-09_JPRB, 0.46072018E-09_JPRB, 0.46285464E-09_JPRB, 0.46496507E-09_JPRB, 0.46729876E-09_JPRB, 0.46957233E-09_JPRB, &
  & 0.47182402E-09_JPRB, 0.47409726E-09_JPRB, 0.47650656E-09_JPRB, 0.47916709E-09_JPRB, 0.48217891E-09_JPRB, 0.48557530E-09_JPRB, &
  & 0.48933113E-09_JPRB, 0.49339549E-09_JPRB, 0.49770965E-09_JPRB, 0.50220678E-09_JPRB, 0.50682447E-09_JPRB, 0.51146648E-09_JPRB, &
  & 0.51602744E-09_JPRB, 0.52030835E-09_JPRB, 0.52403720E-09_JPRB, 0.52694893E-09_JPRB, 0.52900950E-09_JPRB, 0.53036531E-09_JPRB, &
  & 0.53123217E-09_JPRB, 0.53179738E-09_JPRB, 0.53218874E-09_JPRB, 0.53248117E-09_JPRB, 0.53271493E-09_JPRB, 0.53290661E-09_JPRB, &
  & 0.53305821E-09_JPRB, 0.53316046E-09_JPRB, 0.53319921E-09_JPRB, 0.53316418E-09_JPRB, 0.53305804E-09_JPRB, 0.53287397E-09_JPRB, &
  & 0.53263333E-09_JPRB, 0.53230248E-09_JPRB, 0.53191596E-09_JPRB, 0.53144039E-09_JPRB, 0.53085725E-09_JPRB, 0.53014815E-09_JPRB, &
  & 0.52927718E-09_JPRB, 0.52818727E-09_JPRB, 0.52679450E-09_JPRB, 0.52501936E-09_JPRB, 0.52282528E-09_JPRB, 0.52026367E-09_JPRB, &
  & 0.51745375E-09_JPRB, 0.51455518E-09_JPRB, 0.51168902E-09_JPRB, 0.50893290E-09_JPRB, 0.50635085E-09_JPRB, 0.50394672E-09_JPRB, &
  & 0.50169968E-09_JPRB, 0.49961729E-09_JPRB, 0.49775389E-09_JPRB, 0.49617310E-09_JPRB, 0.49490129E-09_JPRB, 0.49389171E-09_JPRB, &
  & 0.49306326E-09_JPRB, 0.49232329E-09_JPRB, 0.49155485E-09_JPRB, 0.49033133E-09_JPRB /)

RGHG6(:,43, 6) = (/ &
  & 0.46444537E-09_JPRB, 0.46748327E-09_JPRB, 0.46954185E-09_JPRB, 0.47182808E-09_JPRB, 0.47418325E-09_JPRB, 0.47651855E-09_JPRB, &
  & 0.47867288E-09_JPRB, 0.48075288E-09_JPRB, 0.48287030E-09_JPRB, 0.48515986E-09_JPRB, 0.48773041E-09_JPRB, 0.49065307E-09_JPRB, &
  & 0.49392784E-09_JPRB, 0.49751242E-09_JPRB, 0.50134535E-09_JPRB, 0.50537541E-09_JPRB, 0.50952642E-09_JPRB, 0.51373944E-09_JPRB, &
  & 0.51789711E-09_JPRB, 0.52183091E-09_JPRB, 0.52524102E-09_JPRB, 0.52789617E-09_JPRB, 0.52973886E-09_JPRB, 0.53093441E-09_JPRB, &
  & 0.53169330E-09_JPRB, 0.53219062E-09_JPRB, 0.53253890E-09_JPRB, 0.53280175E-09_JPRB, 0.53301330E-09_JPRB, 0.53318749E-09_JPRB, &
  & 0.53332538E-09_JPRB, 0.53341603E-09_JPRB, 0.53344740E-09_JPRB, 0.53341043E-09_JPRB, 0.53330867E-09_JPRB, 0.53313975E-09_JPRB, &
  & 0.53292015E-09_JPRB, 0.53263000E-09_JPRB, 0.53228993E-09_JPRB, 0.53189098E-09_JPRB, 0.53140803E-09_JPRB, 0.53083971E-09_JPRB, &
  & 0.53015781E-09_JPRB, 0.52931037E-09_JPRB, 0.52822346E-09_JPRB, 0.52680377E-09_JPRB, 0.52496996E-09_JPRB, 0.52272453E-09_JPRB, &
  & 0.52017024E-09_JPRB, 0.51748089E-09_JPRB, 0.51480054E-09_JPRB, 0.51222554E-09_JPRB, 0.50981269E-09_JPRB, 0.50756671E-09_JPRB, &
  & 0.50546489E-09_JPRB, 0.50352378E-09_JPRB, 0.50179788E-09_JPRB, 0.50036481E-09_JPRB, 0.49923954E-09_JPRB, 0.49836862E-09_JPRB, &
  & 0.49766291E-09_JPRB, 0.49703619E-09_JPRB, 0.49637683E-09_JPRB, 0.49531973E-09_JPRB /)

RGHG6(:,44, 6) = (/ &
  & 0.47113108E-09_JPRB, 0.47401444E-09_JPRB, 0.47615467E-09_JPRB, 0.47835552E-09_JPRB, 0.48086285E-09_JPRB, 0.48317261E-09_JPRB, &
  & 0.48526311E-09_JPRB, 0.48716042E-09_JPRB, 0.48901710E-09_JPRB, 0.49096111E-09_JPRB, 0.49313265E-09_JPRB, 0.49561133E-09_JPRB, &
  & 0.49843435E-09_JPRB, 0.50156224E-09_JPRB, 0.50494342E-09_JPRB, 0.50849819E-09_JPRB, 0.51218813E-09_JPRB, 0.51593280E-09_JPRB, &
  & 0.51967386E-09_JPRB, 0.52321525E-09_JPRB, 0.52631405E-09_JPRB, 0.52869092E-09_JPRB, 0.53033594E-09_JPRB, 0.53139088E-09_JPRB, &
  & 0.53206145E-09_JPRB, 0.53250371E-09_JPRB, 0.53281768E-09_JPRB, 0.53305776E-09_JPRB, 0.53325316E-09_JPRB, 0.53341531E-09_JPRB, &
  & 0.53354371E-09_JPRB, 0.53362798E-09_JPRB, 0.53365545E-09_JPRB, 0.53361876E-09_JPRB, 0.53352195E-09_JPRB, 0.53336557E-09_JPRB, &
  & 0.53316251E-09_JPRB, 0.53289984E-09_JPRB, 0.53259808E-09_JPRB, 0.53224963E-09_JPRB, 0.53184374E-09_JPRB, 0.53137883E-09_JPRB, &
  & 0.53083732E-09_JPRB, 0.53018284E-09_JPRB, 0.52935262E-09_JPRB, 0.52825128E-09_JPRB, 0.52678717E-09_JPRB, 0.52488952E-09_JPRB, &
  & 0.52263205E-09_JPRB, 0.52016491E-09_JPRB, 0.51768101E-09_JPRB, 0.51529259E-09_JPRB, 0.51305343E-09_JPRB, 0.51097071E-09_JPRB, &
  & 0.50902099E-09_JPRB, 0.50721993E-09_JPRB, 0.50563581E-09_JPRB, 0.50433918E-09_JPRB, 0.50334720E-09_JPRB, 0.50259241E-09_JPRB, &
  & 0.50199045E-09_JPRB, 0.50145077E-09_JPRB, 0.50088206E-09_JPRB, 0.49994819E-09_JPRB /)

RGHG6(:,45, 6) = (/ &
  & 0.47781168E-09_JPRB, 0.48062704E-09_JPRB, 0.48250970E-09_JPRB, 0.48481608E-09_JPRB, 0.48724202E-09_JPRB, 0.48963272E-09_JPRB, &
  & 0.49162058E-09_JPRB, 0.49337068E-09_JPRB, 0.49498405E-09_JPRB, 0.49663612E-09_JPRB, 0.49843718E-09_JPRB, 0.50052118E-09_JPRB, &
  & 0.50291965E-09_JPRB, 0.50562798E-09_JPRB, 0.50856253E-09_JPRB, 0.51167509E-09_JPRB, 0.51487570E-09_JPRB, 0.51815152E-09_JPRB, &
  & 0.52140797E-09_JPRB, 0.52455013E-09_JPRB, 0.52727017E-09_JPRB, 0.52938987E-09_JPRB, 0.53083482E-09_JPRB, 0.53176857E-09_JPRB, &
  & 0.53236282E-09_JPRB, 0.53276067E-09_JPRB, 0.53304716E-09_JPRB, 0.53326993E-09_JPRB, 0.53345328E-09_JPRB, 0.53360716E-09_JPRB, &
  & 0.53372978E-09_JPRB, 0.53381033E-09_JPRB, 0.53383653E-09_JPRB, 0.53380200E-09_JPRB, 0.53371024E-09_JPRB, 0.53356458E-09_JPRB, &
  & 0.53337357E-09_JPRB, 0.53313332E-09_JPRB, 0.53285659E-09_JPRB, 0.53254895E-09_JPRB, 0.53219840E-09_JPRB, 0.53181060E-09_JPRB, &
  & 0.53137700E-09_JPRB, 0.53087001E-09_JPRB, 0.53024257E-09_JPRB, 0.52942190E-09_JPRB, 0.52829591E-09_JPRB, 0.52678667E-09_JPRB, &
  & 0.52485660E-09_JPRB, 0.52266441E-09_JPRB, 0.52038907E-09_JPRB, 0.51819721E-09_JPRB, 0.51614579E-09_JPRB, 0.51423238E-09_JPRB, &
  & 0.51244575E-09_JPRB, 0.51079885E-09_JPRB, 0.50935395E-09_JPRB, 0.50819138E-09_JPRB, 0.50731397E-09_JPRB, 0.50666027E-09_JPRB, &
  & 0.50613652E-09_JPRB, 0.50567045E-09_JPRB, 0.50516530E-09_JPRB, 0.50433185E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART11',1,ZHOOK_HANDLE)
END SUBROUTINE PART11




SUBROUTINE PART12
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART12',0,ZHOOK_HANDLE)



RGHG6(:,46, 6) = (/ &
  & 0.48416798E-09_JPRB, 0.48687210E-09_JPRB, 0.48890841E-09_JPRB, 0.49098753E-09_JPRB, 0.49358184E-09_JPRB, 0.49588522E-09_JPRB, &
  & 0.49785559E-09_JPRB, 0.49943799E-09_JPRB, 0.50085930E-09_JPRB, 0.50223053E-09_JPRB, 0.50373017E-09_JPRB, 0.50543986E-09_JPRB, &
  & 0.50746152E-09_JPRB, 0.50976157E-09_JPRB, 0.51229210E-09_JPRB, 0.51493981E-09_JPRB, 0.51767834E-09_JPRB, 0.52043303E-09_JPRB, &
  & 0.52320381E-09_JPRB, 0.52582982E-09_JPRB, 0.52817689E-09_JPRB, 0.52998805E-09_JPRB, 0.53126037E-09_JPRB, 0.53208066E-09_JPRB, &
  & 0.53261345E-09_JPRB, 0.53297455E-09_JPRB, 0.53323979E-09_JPRB, 0.53344906E-09_JPRB, 0.53362409E-09_JPRB, 0.53377247E-09_JPRB, &
  & 0.53389182E-09_JPRB, 0.53397092E-09_JPRB, 0.53399785E-09_JPRB, 0.53396670E-09_JPRB, 0.53388044E-09_JPRB, 0.53374344E-09_JPRB, &
  & 0.53356253E-09_JPRB, 0.53333715E-09_JPRB, 0.53308252E-09_JPRB, 0.53280264E-09_JPRB, 0.53249499E-09_JPRB, 0.53216620E-09_JPRB, &
  & 0.53181137E-09_JPRB, 0.53141636E-09_JPRB, 0.53094795E-09_JPRB, 0.53034399E-09_JPRB, 0.52952864E-09_JPRB, 0.52838128E-09_JPRB, &
  & 0.52685656E-09_JPRB, 0.52498023E-09_JPRB, 0.52297622E-09_JPRB, 0.52099730E-09_JPRB, 0.51913801E-09_JPRB, 0.51741267E-09_JPRB, &
  & 0.51580090E-09_JPRB, 0.51431148E-09_JPRB, 0.51301347E-09_JPRB, 0.51197191E-09_JPRB, 0.51119931E-09_JPRB, 0.51062393E-09_JPRB, &
  & 0.51016785E-09_JPRB, 0.50975335E-09_JPRB, 0.50930465E-09_JPRB, 0.50854088E-09_JPRB /)

RGHG6(:,47, 6) = (/ &
  & 0.49108501E-09_JPRB, 0.49353210E-09_JPRB, 0.49520477E-09_JPRB, 0.49737325E-09_JPRB, 0.49976545E-09_JPRB, 0.50219245E-09_JPRB, &
  & 0.50403204E-09_JPRB, 0.50550653E-09_JPRB, 0.50671362E-09_JPRB, 0.50786714E-09_JPRB, 0.50906312E-09_JPRB, 0.51046189E-09_JPRB, &
  & 0.51211257E-09_JPRB, 0.51404425E-09_JPRB, 0.51615662E-09_JPRB, 0.51838012E-09_JPRB, 0.52061061E-09_JPRB, 0.52284244E-09_JPRB, &
  & 0.52501886E-09_JPRB, 0.52712379E-09_JPRB, 0.52899540E-09_JPRB, 0.53052734E-09_JPRB, 0.53161414E-09_JPRB, 0.53234250E-09_JPRB, &
  & 0.53282162E-09_JPRB, 0.53315424E-09_JPRB, 0.53340249E-09_JPRB, 0.53360222E-09_JPRB, 0.53377114E-09_JPRB, 0.53391647E-09_JPRB, &
  & 0.53403448E-09_JPRB, 0.53411398E-09_JPRB, 0.53414301E-09_JPRB, 0.53411620E-09_JPRB, 0.53403559E-09_JPRB, 0.53390597E-09_JPRB, &
  & 0.53373250E-09_JPRB, 0.53351984E-09_JPRB, 0.53328064E-09_JPRB, 0.53302324E-09_JPRB, 0.53274851E-09_JPRB, 0.53246196E-09_JPRB, &
  & 0.53216787E-09_JPRB, 0.53185512E-09_JPRB, 0.53150112E-09_JPRB, 0.53107058E-09_JPRB, 0.53049204E-09_JPRB, 0.52969024E-09_JPRB, &
  & 0.52855809E-09_JPRB, 0.52711147E-09_JPRB, 0.52542437E-09_JPRB, 0.52372123E-09_JPRB, 0.52208438E-09_JPRB, 0.52055610E-09_JPRB, &
  & 0.51912447E-09_JPRB, 0.51780191E-09_JPRB, 0.51663601E-09_JPRB, 0.51570898E-09_JPRB, 0.51502169E-09_JPRB, 0.51451393E-09_JPRB, &
  & 0.51410720E-09_JPRB, 0.51373678E-09_JPRB, 0.51332644E-09_JPRB, 0.51262172E-09_JPRB /)

RGHG6(:,48, 6) = (/ &
  & 0.49715576E-09_JPRB, 0.49971788E-09_JPRB, 0.50160742E-09_JPRB, 0.50364363E-09_JPRB, 0.50621424E-09_JPRB, 0.50854060E-09_JPRB, &
  & 0.51037585E-09_JPRB, 0.51167542E-09_JPRB, 0.51271221E-09_JPRB, 0.51362048E-09_JPRB, 0.51456939E-09_JPRB, 0.51564319E-09_JPRB, &
  & 0.51696064E-09_JPRB, 0.51851007E-09_JPRB, 0.52022309E-09_JPRB, 0.52196636E-09_JPRB, 0.52367244E-09_JPRB, 0.52529253E-09_JPRB, &
  & 0.52683874E-09_JPRB, 0.52834104E-09_JPRB, 0.52976079E-09_JPRB, 0.53098265E-09_JPRB, 0.53191557E-09_JPRB, 0.53255844E-09_JPRB, &
  & 0.53299615E-09_JPRB, 0.53330562E-09_JPRB, 0.53354138E-09_JPRB, 0.53373372E-09_JPRB, 0.53389904E-09_JPRB, 0.53404264E-09_JPRB, &
  & 0.53416072E-09_JPRB, 0.53424193E-09_JPRB, 0.53427446E-09_JPRB, 0.53425264E-09_JPRB, 0.53417781E-09_JPRB, 0.53405408E-09_JPRB, &
  & 0.53388732E-09_JPRB, 0.53368404E-09_JPRB, 0.53345822E-09_JPRB, 0.53321803E-09_JPRB, 0.53296662E-09_JPRB, 0.53271415E-09_JPRB, &
  & 0.53246252E-09_JPRB, 0.53221000E-09_JPRB, 0.53194282E-09_JPRB, 0.53163229E-09_JPRB, 0.53124127E-09_JPRB, 0.53070337E-09_JPRB, &
  & 0.52995763E-09_JPRB, 0.52893778E-09_JPRB, 0.52771820E-09_JPRB, 0.52635707E-09_JPRB, 0.52501925E-09_JPRB, 0.52371868E-09_JPRB, &
  & 0.52247939E-09_JPRB, 0.52130578E-09_JPRB, 0.52026078E-09_JPRB, 0.51941995E-09_JPRB, 0.51880111E-09_JPRB, 0.51834231E-09_JPRB, &
  & 0.51797339E-09_JPRB, 0.51763321E-09_JPRB, 0.51725185E-09_JPRB, 0.51658783E-09_JPRB /)

RGHG6(:,49, 6) = (/ &
  & 0.50340643E-09_JPRB, 0.50612459E-09_JPRB, 0.50800336E-09_JPRB, 0.51014648E-09_JPRB, 0.51265486E-09_JPRB, 0.51505039E-09_JPRB, &
  & 0.51674065E-09_JPRB, 0.51789090E-09_JPRB, 0.51871496E-09_JPRB, 0.51941218E-09_JPRB, 0.52008919E-09_JPRB, 0.52087962E-09_JPRB, &
  & 0.52183846E-09_JPRB, 0.52299537E-09_JPRB, 0.52424803E-09_JPRB, 0.52546700E-09_JPRB, 0.52657190E-09_JPRB, 0.52755655E-09_JPRB, &
  & 0.52849963E-09_JPRB, 0.52942695E-09_JPRB, 0.53042892E-09_JPRB, 0.53137428E-09_JPRB, 0.53216093E-09_JPRB, 0.53273774E-09_JPRB, &
  & 0.53314198E-09_JPRB, 0.53343452E-09_JPRB, 0.53366067E-09_JPRB, 0.53384824E-09_JPRB, 0.53401106E-09_JPRB, 0.53415433E-09_JPRB, &
  & 0.53427363E-09_JPRB, 0.53435745E-09_JPRB, 0.53439420E-09_JPRB, 0.53437754E-09_JPRB, 0.53430838E-09_JPRB, 0.53418980E-09_JPRB, &
  & 0.53402877E-09_JPRB, 0.53383431E-09_JPRB, 0.53361870E-09_JPRB, 0.53339189E-09_JPRB, 0.53315963E-09_JPRB, 0.53292987E-09_JPRB, &
  & 0.53271165E-09_JPRB, 0.53250293E-09_JPRB, 0.53229643E-09_JPRB, 0.53207411E-09_JPRB, 0.53181065E-09_JPRB, 0.53146959E-09_JPRB, &
  & 0.53100779E-09_JPRB, 0.53039845E-09_JPRB, 0.52962101E-09_JPRB, 0.52875193E-09_JPRB, 0.52778759E-09_JPRB, 0.52681548E-09_JPRB, &
  & 0.52581917E-09_JPRB, 0.52481508E-09_JPRB, 0.52387883E-09_JPRB, 0.52311244E-09_JPRB, 0.52253857E-09_JPRB, 0.52211663E-09_JPRB, &
  & 0.52177140E-09_JPRB, 0.52145110E-09_JPRB, 0.52108445E-09_JPRB, 0.52043991E-09_JPRB /)

RGHG6(:,50, 6) = (/ &
  & 0.50973537E-09_JPRB, 0.51240900E-09_JPRB, 0.51419258E-09_JPRB, 0.51627663E-09_JPRB, 0.51868565E-09_JPRB, 0.52088939E-09_JPRB, &
  & 0.52236582E-09_JPRB, 0.52327925E-09_JPRB, 0.52388927E-09_JPRB, 0.52436433E-09_JPRB, 0.52482740E-09_JPRB, 0.52532989E-09_JPRB, &
  & 0.52596916E-09_JPRB, 0.52672289E-09_JPRB, 0.52750820E-09_JPRB, 0.52822136E-09_JPRB, 0.52881916E-09_JPRB, 0.52933258E-09_JPRB, &
  & 0.52979987E-09_JPRB, 0.53035792E-09_JPRB, 0.53097443E-09_JPRB, 0.53170163E-09_JPRB, 0.53236188E-09_JPRB, 0.53288490E-09_JPRB, &
  & 0.53326565E-09_JPRB, 0.53354582E-09_JPRB, 0.53376525E-09_JPRB, 0.53394911E-09_JPRB, 0.53411048E-09_JPRB, 0.53425397E-09_JPRB, &
  & 0.53437510E-09_JPRB, 0.53446225E-09_JPRB, 0.53450366E-09_JPRB, 0.53449251E-09_JPRB, 0.53442867E-09_JPRB, 0.53431426E-09_JPRB, &
  & 0.53415966E-09_JPRB, 0.53397170E-09_JPRB, 0.53376603E-09_JPRB, 0.53354982E-09_JPRB, 0.53333071E-09_JPRB, 0.53311977E-09_JPRB, &
  & 0.53292454E-09_JPRB, 0.53275051E-09_JPRB, 0.53258731E-09_JPRB, 0.53242655E-09_JPRB, 0.53224658E-09_JPRB, 0.53203364E-09_JPRB, &
  & 0.53176163E-09_JPRB, 0.53141974E-09_JPRB, 0.53100940E-09_JPRB, 0.53051891E-09_JPRB, 0.52999349E-09_JPRB, 0.52939886E-09_JPRB, &
  & 0.52874116E-09_JPRB, 0.52802757E-09_JPRB, 0.52728705E-09_JPRB, 0.52663807E-09_JPRB, 0.52614990E-09_JPRB, 0.52576721E-09_JPRB, &
  & 0.52545784E-09_JPRB, 0.52515098E-09_JPRB, 0.52479832E-09_JPRB, 0.52413945E-09_JPRB /)

RGHG6(:,51, 6) = (/ &
  & 0.51532784E-09_JPRB, 0.51778026E-09_JPRB, 0.51954036E-09_JPRB, 0.52128363E-09_JPRB, 0.52340038E-09_JPRB, 0.52517635E-09_JPRB, &
  & 0.52630195E-09_JPRB, 0.52693294E-09_JPRB, 0.52733845E-09_JPRB, 0.52765042E-09_JPRB, 0.52792754E-09_JPRB, 0.52825333E-09_JPRB, &
  & 0.52863347E-09_JPRB, 0.52909560E-09_JPRB, 0.52955595E-09_JPRB, 0.52995042E-09_JPRB, 0.53026150E-09_JPRB, 0.53051047E-09_JPRB, &
  & 0.53076799E-09_JPRB, 0.53104038E-09_JPRB, 0.53146398E-09_JPRB, 0.53196120E-09_JPRB, 0.53252569E-09_JPRB, 0.53300697E-09_JPRB, &
  & 0.53337157E-09_JPRB, 0.53364407E-09_JPRB, 0.53385901E-09_JPRB, 0.53404003E-09_JPRB, 0.53420041E-09_JPRB, 0.53434446E-09_JPRB, &
  & 0.53446741E-09_JPRB, 0.53455806E-09_JPRB, 0.53460442E-09_JPRB, 0.53459853E-09_JPRB, 0.53453919E-09_JPRB, 0.53443039E-09_JPRB, &
  & 0.53427962E-09_JPRB, 0.53410026E-09_JPRB, 0.53390137E-09_JPRB, 0.53369459E-09_JPRB, 0.53348620E-09_JPRB, 0.53328797E-09_JPRB, &
  & 0.53311427E-09_JPRB, 0.53296345E-09_JPRB, 0.53283544E-09_JPRB, 0.53271276E-09_JPRB, 0.53259075E-09_JPRB, 0.53245092E-09_JPRB, &
  & 0.53229171E-09_JPRB, 0.53210258E-09_JPRB, 0.53188542E-09_JPRB, 0.53165045E-09_JPRB, 0.53138355E-09_JPRB, 0.53109811E-09_JPRB, &
  & 0.53077531E-09_JPRB, 0.53038207E-09_JPRB, 0.52995930E-09_JPRB, 0.52956139E-09_JPRB, 0.52922017E-09_JPRB, 0.52896093E-09_JPRB, &
  & 0.52871391E-09_JPRB, 0.52847104E-09_JPRB, 0.52814214E-09_JPRB, 0.52753479E-09_JPRB /)

RGHG6(:,52, 6) = (/ &
  & 0.52034549E-09_JPRB, 0.52235538E-09_JPRB, 0.52357518E-09_JPRB, 0.52502125E-09_JPRB, 0.52656962E-09_JPRB, 0.52790317E-09_JPRB, &
  & 0.52865512E-09_JPRB, 0.52907734E-09_JPRB, 0.52933585E-09_JPRB, 0.52952653E-09_JPRB, 0.52971261E-09_JPRB, 0.52990212E-09_JPRB, &
  & 0.53015486E-09_JPRB, 0.53044025E-09_JPRB, 0.53072763E-09_JPRB, 0.53096150E-09_JPRB, 0.53113802E-09_JPRB, 0.53128402E-09_JPRB, &
  & 0.53141169E-09_JPRB, 0.53159716E-09_JPRB, 0.53182325E-09_JPRB, 0.53221105E-09_JPRB, 0.53266080E-09_JPRB, 0.53310906E-09_JPRB, &
  & 0.53346494E-09_JPRB, 0.53373300E-09_JPRB, 0.53394489E-09_JPRB, 0.53412386E-09_JPRB, 0.53428301E-09_JPRB, 0.53442728E-09_JPRB, &
  & 0.53455207E-09_JPRB, 0.53464638E-09_JPRB, 0.53469740E-09_JPRB, 0.53469662E-09_JPRB, 0.53464277E-09_JPRB, 0.53453736E-09_JPRB, &
  & 0.53439381E-09_JPRB, 0.53421850E-09_JPRB, 0.53402821E-09_JPRB, 0.53382804E-09_JPRB, 0.53362792E-09_JPRB, 0.53344312E-09_JPRB, &
  & 0.53328308E-09_JPRB, 0.53315558E-09_JPRB, 0.53304849E-09_JPRB, 0.53295712E-09_JPRB, 0.53286581E-09_JPRB, 0.53277460E-09_JPRB, &
  & 0.53267235E-09_JPRB, 0.53256383E-09_JPRB, 0.53244820E-09_JPRB, 0.53232457E-09_JPRB, 0.53220356E-09_JPRB, 0.53207477E-09_JPRB, &
  & 0.53192850E-09_JPRB, 0.53176741E-09_JPRB, 0.53157800E-09_JPRB, 0.53139038E-09_JPRB, 0.53124116E-09_JPRB, 0.53109883E-09_JPRB, &
  & 0.53097443E-09_JPRB, 0.53081967E-09_JPRB, 0.53061788E-09_JPRB, 0.53012555E-09_JPRB /)

RGHG6(:,53, 6) = (/ &
  & 0.52399607E-09_JPRB, 0.52551430E-09_JPRB, 0.52654542E-09_JPRB, 0.52752458E-09_JPRB, 0.52867177E-09_JPRB, 0.52956622E-09_JPRB, &
  & 0.53008309E-09_JPRB, 0.53034976E-09_JPRB, 0.53051552E-09_JPRB, 0.53064342E-09_JPRB, 0.53075411E-09_JPRB, 0.53089044E-09_JPRB, &
  & 0.53104537E-09_JPRB, 0.53124488E-09_JPRB, 0.53143578E-09_JPRB, 0.53159133E-09_JPRB, 0.53170773E-09_JPRB, 0.53179444E-09_JPRB, &
  & 0.53188809E-09_JPRB, 0.53198390E-09_JPRB, 0.53216337E-09_JPRB, 0.53240623E-09_JPRB, 0.53279137E-09_JPRB, 0.53320148E-09_JPRB, &
  & 0.53354898E-09_JPRB, 0.53381505E-09_JPRB, 0.53402494E-09_JPRB, 0.53420213E-09_JPRB, 0.53436011E-09_JPRB, 0.53450439E-09_JPRB, &
  & 0.53463073E-09_JPRB, 0.53472810E-09_JPRB, 0.53478377E-09_JPRB, 0.53478832E-09_JPRB, 0.53473881E-09_JPRB, 0.53463983E-09_JPRB, &
  & 0.53449928E-09_JPRB, 0.53433180E-09_JPRB, 0.53414584E-09_JPRB, 0.53395177E-09_JPRB, 0.53376031E-09_JPRB, 0.53358462E-09_JPRB, &
  & 0.53344112E-09_JPRB, 0.53332816E-09_JPRB, 0.53324112E-09_JPRB, 0.53316629E-09_JPRB, 0.53309962E-09_JPRB, 0.53303123E-09_JPRB, &
  & 0.53296412E-09_JPRB, 0.53289401E-09_JPRB, 0.53282456E-09_JPRB, 0.53276017E-09_JPRB, 0.53269700E-09_JPRB, 0.53263616E-09_JPRB, &
  & 0.53257460E-09_JPRB, 0.53250060E-09_JPRB, 0.53242238E-09_JPRB, 0.53234805E-09_JPRB, 0.53227878E-09_JPRB, 0.53222537E-09_JPRB, &
  & 0.53216631E-09_JPRB, 0.53210431E-09_JPRB, 0.53200322E-09_JPRB, 0.53175941E-09_JPRB /)

RGHG6(:,54, 6) = (/ &
  & 0.52698040E-09_JPRB, 0.52797788E-09_JPRB, 0.52858784E-09_JPRB, 0.52928639E-09_JPRB, 0.53004101E-09_JPRB, 0.53065280E-09_JPRB, &
  & 0.53098387E-09_JPRB, 0.53116445E-09_JPRB, 0.53127419E-09_JPRB, 0.53135507E-09_JPRB, 0.53143623E-09_JPRB, 0.53151877E-09_JPRB, &
  & 0.53163601E-09_JPRB, 0.53177035E-09_JPRB, 0.53191074E-09_JPRB, 0.53202265E-09_JPRB, 0.53210419E-09_JPRB, 0.53217164E-09_JPRB, &
  & 0.53222737E-09_JPRB, 0.53231020E-09_JPRB, 0.53241117E-09_JPRB, 0.53261701E-09_JPRB, 0.53291194E-09_JPRB, 0.53328919E-09_JPRB, &
  & 0.53362909E-09_JPRB, 0.53389215E-09_JPRB, 0.53410038E-09_JPRB, 0.53427579E-09_JPRB, 0.53443316E-09_JPRB, 0.53457694E-09_JPRB, &
  & 0.53470445E-09_JPRB, 0.53480442E-09_JPRB, 0.53486415E-09_JPRB, 0.53487381E-09_JPRB, 0.53483007E-09_JPRB, 0.53473537E-09_JPRB, &
  & 0.53460136E-09_JPRB, 0.53443744E-09_JPRB, 0.53425653E-09_JPRB, 0.53406818E-09_JPRB, 0.53388288E-09_JPRB, 0.53371968E-09_JPRB, &
  & 0.53358773E-09_JPRB, 0.53348947E-09_JPRB, 0.53341492E-09_JPRB, 0.53335519E-09_JPRB, 0.53330018E-09_JPRB, 0.53324889E-09_JPRB, &
  & 0.53319638E-09_JPRB, 0.53314669E-09_JPRB, 0.53310084E-09_JPRB, 0.53305871E-09_JPRB, 0.53302351E-09_JPRB, 0.53299137E-09_JPRB, &
  & 0.53295818E-09_JPRB, 0.53292526E-09_JPRB, 0.53288829E-09_JPRB, 0.53285309E-09_JPRB, 0.53282695E-09_JPRB, 0.53280225E-09_JPRB, &
  & 0.53278287E-09_JPRB, 0.53276267E-09_JPRB, 0.53274818E-09_JPRB, 0.53275651E-09_JPRB /)

RGHG6(:,55, 6) = (/ &
  & 0.52882976E-09_JPRB, 0.52956955E-09_JPRB, 0.53002708E-09_JPRB, 0.53048577E-09_JPRB, 0.53098209E-09_JPRB, 0.53138144E-09_JPRB, &
  & 0.53161053E-09_JPRB, 0.53172933E-09_JPRB, 0.53180371E-09_JPRB, 0.53186167E-09_JPRB, 0.53191296E-09_JPRB, 0.53197763E-09_JPRB, &
  & 0.53205318E-09_JPRB, 0.53215687E-09_JPRB, 0.53225985E-09_JPRB, 0.53234583E-09_JPRB, 0.53241045E-09_JPRB, 0.53245791E-09_JPRB, &
  & 0.53250748E-09_JPRB, 0.53255750E-09_JPRB, 0.53265037E-09_JPRB, 0.53278820E-09_JPRB, 0.53304539E-09_JPRB, 0.53338284E-09_JPRB, &
  & 0.53370708E-09_JPRB, 0.53396609E-09_JPRB, 0.53417193E-09_JPRB, 0.53434679E-09_JPRB, 0.53450261E-09_JPRB, 0.53464666E-09_JPRB, &
  & 0.53477456E-09_JPRB, 0.53487670E-09_JPRB, 0.53493987E-09_JPRB, 0.53495436E-09_JPRB, 0.53491572E-09_JPRB, 0.53482724E-09_JPRB, &
  & 0.53469773E-09_JPRB, 0.53453830E-09_JPRB, 0.53436133E-09_JPRB, 0.53417692E-09_JPRB, 0.53400090E-09_JPRB, 0.53384680E-09_JPRB, &
  & 0.53372762E-09_JPRB, 0.53364085E-09_JPRB, 0.53357696E-09_JPRB, 0.53352628E-09_JPRB, 0.53348143E-09_JPRB, 0.53343707E-09_JPRB, &
  & 0.53339438E-09_JPRB, 0.53335325E-09_JPRB, 0.53331595E-09_JPRB, 0.53328608E-09_JPRB, 0.53326088E-09_JPRB, 0.53323934E-09_JPRB, &
  & 0.53322002E-09_JPRB, 0.53319860E-09_JPRB, 0.53317761E-09_JPRB, 0.53315941E-09_JPRB, 0.53314325E-09_JPRB, 0.53313132E-09_JPRB, &
  & 0.53311877E-09_JPRB, 0.53310661E-09_JPRB, 0.53309074E-09_JPRB, 0.53306887E-09_JPRB /)

RGHG6(:,56, 6) = (/ &
  & 0.53039295E-09_JPRB, 0.53077981E-09_JPRB, 0.53104571E-09_JPRB, 0.53132998E-09_JPRB, 0.53165705E-09_JPRB, 0.53191551E-09_JPRB, &
  & 0.53206700E-09_JPRB, 0.53215138E-09_JPRB, 0.53220361E-09_JPRB, 0.53224314E-09_JPRB, 0.53228288E-09_JPRB, 0.53232496E-09_JPRB, &
  & 0.53238552E-09_JPRB, 0.53245852E-09_JPRB, 0.53253962E-09_JPRB, 0.53260796E-09_JPRB, 0.53265881E-09_JPRB, 0.53270016E-09_JPRB, &
  & 0.53273408E-09_JPRB, 0.53278132E-09_JPRB, 0.53284233E-09_JPRB, 0.53296767E-09_JPRB, 0.53317822E-09_JPRB, 0.53348170E-09_JPRB, &
  & 0.53378807E-09_JPRB, 0.53403898E-09_JPRB, 0.53424221E-09_JPRB, 0.53441507E-09_JPRB, 0.53457133E-09_JPRB, 0.53471438E-09_JPRB, &
  & 0.53484289E-09_JPRB, 0.53494620E-09_JPRB, 0.53501187E-09_JPRB, 0.53503046E-09_JPRB, 0.53499727E-09_JPRB, 0.53491456E-09_JPRB, &
  & 0.53479016E-09_JPRB, 0.53463500E-09_JPRB, 0.53446086E-09_JPRB, 0.53428256E-09_JPRB, 0.53411287E-09_JPRB, 0.53397031E-09_JPRB, &
  & 0.53386173E-09_JPRB, 0.53378452E-09_JPRB, 0.53372928E-09_JPRB, 0.53368598E-09_JPRB, 0.53364685E-09_JPRB, 0.53360849E-09_JPRB, &
  & 0.53356930E-09_JPRB, 0.53353161E-09_JPRB, 0.53349880E-09_JPRB, 0.53347110E-09_JPRB, 0.53344990E-09_JPRB, 0.53343252E-09_JPRB, &
  & 0.53341564E-09_JPRB, 0.53340010E-09_JPRB, 0.53338434E-09_JPRB, 0.53337035E-09_JPRB, 0.53336024E-09_JPRB, 0.53335092E-09_JPRB, &
  & 0.53334298E-09_JPRB, 0.53333360E-09_JPRB, 0.53332350E-09_JPRB, 0.53330623E-09_JPRB /)

RGHG6(:,57, 6) = (/ &
  & 0.53128968E-09_JPRB, 0.53157406E-09_JPRB, 0.53175248E-09_JPRB, 0.53194971E-09_JPRB, 0.53214599E-09_JPRB, 0.53232074E-09_JPRB, &
  & 0.53242605E-09_JPRB, 0.53248506E-09_JPRB, 0.53252275E-09_JPRB, 0.53255284E-09_JPRB, 0.53258031E-09_JPRB, 0.53261462E-09_JPRB, &
  & 0.53265636E-09_JPRB, 0.53271471E-09_JPRB, 0.53277716E-09_JPRB, 0.53283328E-09_JPRB, 0.53287663E-09_JPRB, 0.53290872E-09_JPRB, &
  & 0.53293914E-09_JPRB, 0.53297139E-09_JPRB, 0.53302918E-09_JPRB, 0.53312738E-09_JPRB, 0.53331606E-09_JPRB, 0.53359056E-09_JPRB, &
  & 0.53387311E-09_JPRB, 0.53411342E-09_JPRB, 0.53431215E-09_JPRB, 0.53448446E-09_JPRB, 0.53463894E-09_JPRB, 0.53478222E-09_JPRB, &
  & 0.53491023E-09_JPRB, 0.53501403E-09_JPRB, 0.53508120E-09_JPRB, 0.53510324E-09_JPRB, 0.53507487E-09_JPRB, 0.53499805E-09_JPRB, &
  & 0.53487909E-09_JPRB, 0.53472760E-09_JPRB, 0.53455840E-09_JPRB, 0.53438409E-09_JPRB, 0.53422383E-09_JPRB, 0.53409011E-09_JPRB, &
  & 0.53399141E-09_JPRB, 0.53392268E-09_JPRB, 0.53387383E-09_JPRB, 0.53383609E-09_JPRB, 0.53380178E-09_JPRB, 0.53376703E-09_JPRB, &
  & 0.53373078E-09_JPRB, 0.53369453E-09_JPRB, 0.53366084E-09_JPRB, 0.53363369E-09_JPRB, 0.53361193E-09_JPRB, 0.53359372E-09_JPRB, &
  & 0.53357813E-09_JPRB, 0.53356219E-09_JPRB, 0.53354743E-09_JPRB, 0.53353549E-09_JPRB, 0.53352545E-09_JPRB, 0.53351779E-09_JPRB, &
  & 0.53350957E-09_JPRB, 0.53350102E-09_JPRB, 0.53348881E-09_JPRB, 0.53346699E-09_JPRB /)

RGHG6(:,58, 6) = (/ &
  & 0.53197768E-09_JPRB, 0.53215610E-09_JPRB, 0.53227822E-09_JPRB, 0.53239635E-09_JPRB, 0.53253391E-09_JPRB, 0.53264426E-09_JPRB, &
  & 0.53271859E-09_JPRB, 0.53276156E-09_JPRB, 0.53279026E-09_JPRB, 0.53281241E-09_JPRB, 0.53283511E-09_JPRB, 0.53285998E-09_JPRB, &
  & 0.53289489E-09_JPRB, 0.53293886E-09_JPRB, 0.53299043E-09_JPRB, 0.53303761E-09_JPRB, 0.53307431E-09_JPRB, 0.53310190E-09_JPRB, &
  & 0.53312388E-09_JPRB, 0.53315208E-09_JPRB, 0.53319543E-09_JPRB, 0.53328636E-09_JPRB, 0.53345633E-09_JPRB, 0.53370264E-09_JPRB, &
  & 0.53396298E-09_JPRB, 0.53419119E-09_JPRB, 0.53438520E-09_JPRB, 0.53455457E-09_JPRB, 0.53470883E-09_JPRB, 0.53485050E-09_JPRB, &
  & 0.53497812E-09_JPRB, 0.53508153E-09_JPRB, 0.53514920E-09_JPRB, 0.53517368E-09_JPRB, 0.53514954E-09_JPRB, 0.53507798E-09_JPRB, &
  & 0.53496413E-09_JPRB, 0.53481819E-09_JPRB, 0.53465266E-09_JPRB, 0.53448584E-09_JPRB, 0.53433230E-09_JPRB, 0.53420868E-09_JPRB, &
  & 0.53411831E-09_JPRB, 0.53405591E-09_JPRB, 0.53401272E-09_JPRB, 0.53397897E-09_JPRB, 0.53394844E-09_JPRB, 0.53391669E-09_JPRB, &
  & 0.53388277E-09_JPRB, 0.53384736E-09_JPRB, 0.53381310E-09_JPRB, 0.53378330E-09_JPRB, 0.53375904E-09_JPRB, 0.53373911E-09_JPRB, &
  & 0.53372029E-09_JPRB, 0.53370297E-09_JPRB, 0.53368709E-09_JPRB, 0.53367355E-09_JPRB, 0.53366378E-09_JPRB, 0.53365495E-09_JPRB, &
  & 0.53364685E-09_JPRB, 0.53363702E-09_JPRB, 0.53362470E-09_JPRB, 0.53359983E-09_JPRB /)

RGHG6(:,59, 6) = (/ &
  & 0.53244020E-09_JPRB, 0.53258092E-09_JPRB, 0.53266458E-09_JPRB, 0.53275173E-09_JPRB, 0.53283555E-09_JPRB, 0.53291505E-09_JPRB, &
  & 0.53296684E-09_JPRB, 0.53300014E-09_JPRB, 0.53302185E-09_JPRB, 0.53304050E-09_JPRB, 0.53305793E-09_JPRB, 0.53307991E-09_JPRB, &
  & 0.53310711E-09_JPRB, 0.53314486E-09_JPRB, 0.53318794E-09_JPRB, 0.53322941E-09_JPRB, 0.53326182E-09_JPRB, 0.53328375E-09_JPRB, &
  & 0.53330046E-09_JPRB, 0.53331906E-09_JPRB, 0.53335725E-09_JPRB, 0.53343802E-09_JPRB, 0.53359350E-09_JPRB, 0.53381882E-09_JPRB, &
  & 0.53405730E-09_JPRB, 0.53427351E-09_JPRB, 0.53446136E-09_JPRB, 0.53462862E-09_JPRB, 0.53478061E-09_JPRB, 0.53492122E-09_JPRB, &
  & 0.53504695E-09_JPRB, 0.53514920E-09_JPRB, 0.53521687E-09_JPRB, 0.53524263E-09_JPRB, 0.53522159E-09_JPRB, 0.53515486E-09_JPRB, &
  & 0.53504667E-09_JPRB, 0.53490545E-09_JPRB, 0.53474702E-09_JPRB, 0.53458560E-09_JPRB, 0.53444171E-09_JPRB, 0.53432597E-09_JPRB, &
  & 0.53424265E-09_JPRB, 0.53418636E-09_JPRB, 0.53414673E-09_JPRB, 0.53411653E-09_JPRB, 0.53408855E-09_JPRB, 0.53405935E-09_JPRB, &
  & 0.53402777E-09_JPRB, 0.53399374E-09_JPRB, 0.53395899E-09_JPRB, 0.53392679E-09_JPRB, 0.53389926E-09_JPRB, 0.53387483E-09_JPRB, &
  & 0.53385291E-09_JPRB, 0.53383181E-09_JPRB, 0.53381249E-09_JPRB, 0.53379767E-09_JPRB, 0.53378535E-09_JPRB, 0.53377558E-09_JPRB, &
  & 0.53376559E-09_JPRB, 0.53375454E-09_JPRB, 0.53373927E-09_JPRB, 0.53371130E-09_JPRB /)

RGHG6(:,60, 6) = (/ &
  & 0.53281513E-09_JPRB, 0.53291310E-09_JPRB, 0.53297416E-09_JPRB, 0.53303073E-09_JPRB, 0.53309290E-09_JPRB, 0.53314586E-09_JPRB, &
  & 0.53318627E-09_JPRB, 0.53321136E-09_JPRB, 0.53323029E-09_JPRB, 0.53324539E-09_JPRB, 0.53326177E-09_JPRB, 0.53327998E-09_JPRB, &
  & 0.53330546E-09_JPRB, 0.53333782E-09_JPRB, 0.53337695E-09_JPRB, 0.53341470E-09_JPRB, 0.53344362E-09_JPRB, 0.53346094E-09_JPRB, &
  & 0.53347005E-09_JPRB, 0.53348126E-09_JPRB, 0.53351074E-09_JPRB, 0.53358507E-09_JPRB, 0.53372956E-09_JPRB, 0.53393401E-09_JPRB, &
  & 0.53415500E-09_JPRB, 0.53435961E-09_JPRB, 0.53454224E-09_JPRB, 0.53470589E-09_JPRB, 0.53485577E-09_JPRB, 0.53499394E-09_JPRB, &
  & 0.53511751E-09_JPRB, 0.53521776E-09_JPRB, 0.53528398E-09_JPRB, 0.53531013E-09_JPRB, 0.53529159E-09_JPRB, 0.53522914E-09_JPRB, &
  & 0.53512617E-09_JPRB, 0.53499200E-09_JPRB, 0.53483917E-09_JPRB, 0.53468685E-09_JPRB, 0.53455013E-09_JPRB, 0.53444271E-09_JPRB, &
  & 0.53436605E-09_JPRB, 0.53431354E-09_JPRB, 0.53427773E-09_JPRB, 0.53424964E-09_JPRB, 0.53422394E-09_JPRB, 0.53419658E-09_JPRB, &
  & 0.53416693E-09_JPRB, 0.53413468E-09_JPRB, 0.53410054E-09_JPRB, 0.53406696E-09_JPRB, 0.53403587E-09_JPRB, 0.53400756E-09_JPRB, &
  & 0.53398086E-09_JPRB, 0.53395488E-09_JPRB, 0.53393207E-09_JPRB, 0.53391280E-09_JPRB, 0.53389854E-09_JPRB, 0.53388571E-09_JPRB, &
  & 0.53387356E-09_JPRB, 0.53385946E-09_JPRB, 0.53384136E-09_JPRB, 0.53380650E-09_JPRB /)

RGHG6(:,61, 6) = (/ &
  & 0.53309929E-09_JPRB, 0.53317784E-09_JPRB, 0.53322369E-09_JPRB, 0.53326726E-09_JPRB, 0.53331023E-09_JPRB, 0.53335170E-09_JPRB, &
  & 0.53338201E-09_JPRB, 0.53340432E-09_JPRB, 0.53342020E-09_JPRB, 0.53343518E-09_JPRB, 0.53344973E-09_JPRB, 0.53346866E-09_JPRB, &
  & 0.53349208E-09_JPRB, 0.53352434E-09_JPRB, 0.53356120E-09_JPRB, 0.53359689E-09_JPRB, 0.53362287E-09_JPRB, 0.53363441E-09_JPRB, &
  & 0.53363569E-09_JPRB, 0.53363824E-09_JPRB, 0.53366089E-09_JPRB, 0.53372873E-09_JPRB, 0.53386084E-09_JPRB, 0.53404930E-09_JPRB, &
  & 0.53425442E-09_JPRB, 0.53444982E-09_JPRB, 0.53462662E-09_JPRB, 0.53478699E-09_JPRB, 0.53493410E-09_JPRB, 0.53506954E-09_JPRB, &
  & 0.53518967E-09_JPRB, 0.53528687E-09_JPRB, 0.53535076E-09_JPRB, 0.53537647E-09_JPRB, 0.53535953E-09_JPRB, 0.53530091E-09_JPRB, &
  & 0.53520394E-09_JPRB, 0.53507604E-09_JPRB, 0.53493221E-09_JPRB, 0.53478710E-09_JPRB, 0.53465965E-09_JPRB, 0.53455940E-09_JPRB, &
  & 0.53448768E-09_JPRB, 0.53443944E-09_JPRB, 0.53440563E-09_JPRB, 0.53437960E-09_JPRB, 0.53435539E-09_JPRB, 0.53432980E-09_JPRB, &
  & 0.53430166E-09_JPRB, 0.53427096E-09_JPRB, 0.53423810E-09_JPRB, 0.53420446E-09_JPRB, 0.53417143E-09_JPRB, 0.53413940E-09_JPRB, &
  & 0.53410787E-09_JPRB, 0.53407767E-09_JPRB, 0.53404892E-09_JPRB, 0.53402605E-09_JPRB, 0.53400706E-09_JPRB, 0.53399118E-09_JPRB, &
  & 0.53397520E-09_JPRB, 0.53395721E-09_JPRB, 0.53393312E-09_JPRB, 0.53388899E-09_JPRB /)

RGHG6(:,62, 6) = (/ &
  & 0.53334026E-09_JPRB, 0.53340160E-09_JPRB, 0.53343729E-09_JPRB, 0.53347021E-09_JPRB, 0.53350480E-09_JPRB, 0.53353655E-09_JPRB, &
  & 0.53356308E-09_JPRB, 0.53358201E-09_JPRB, 0.53359805E-09_JPRB, 0.53361204E-09_JPRB, 0.53362825E-09_JPRB, 0.53364690E-09_JPRB, &
  & 0.53367316E-09_JPRB, 0.53370575E-09_JPRB, 0.53374372E-09_JPRB, 0.53377824E-09_JPRB, 0.53380039E-09_JPRB, 0.53380522E-09_JPRB, &
  & 0.53379845E-09_JPRB, 0.53379295E-09_JPRB, 0.53380877E-09_JPRB, 0.53386895E-09_JPRB, 0.53399063E-09_JPRB, 0.53416388E-09_JPRB, &
  & 0.53435656E-09_JPRB, 0.53454302E-09_JPRB, 0.53471488E-09_JPRB, 0.53487181E-09_JPRB, 0.53501586E-09_JPRB, 0.53514793E-09_JPRB, &
  & 0.53526372E-09_JPRB, 0.53535676E-09_JPRB, 0.53541738E-09_JPRB, 0.53544180E-09_JPRB, 0.53542587E-09_JPRB, 0.53537103E-09_JPRB, &
  & 0.53527976E-09_JPRB, 0.53515964E-09_JPRB, 0.53502353E-09_JPRB, 0.53488847E-09_JPRB, 0.53476895E-09_JPRB, 0.53467564E-09_JPRB, &
  & 0.53460902E-09_JPRB, 0.53456312E-09_JPRB, 0.53453159E-09_JPRB, 0.53450677E-09_JPRB, 0.53448401E-09_JPRB, 0.53445970E-09_JPRB, &
  & 0.53443333E-09_JPRB, 0.53440397E-09_JPRB, 0.53437232E-09_JPRB, 0.53433913E-09_JPRB, 0.53430532E-09_JPRB, 0.53427035E-09_JPRB, &
  & 0.53423610E-09_JPRB, 0.53420079E-09_JPRB, 0.53416838E-09_JPRB, 0.53413951E-09_JPRB, 0.53411642E-09_JPRB, 0.53409555E-09_JPRB, &
  & 0.53407512E-09_JPRB, 0.53405147E-09_JPRB, 0.53402027E-09_JPRB, 0.53396054E-09_JPRB /)

RGHG6(:,63, 6) = (/ &
  & 0.53353855E-09_JPRB, 0.53359239E-09_JPRB, 0.53362337E-09_JPRB, 0.53365151E-09_JPRB, 0.53367993E-09_JPRB, 0.53370780E-09_JPRB, &
  & 0.53373084E-09_JPRB, 0.53374982E-09_JPRB, 0.53376542E-09_JPRB, 0.53378146E-09_JPRB, 0.53379839E-09_JPRB, 0.53382099E-09_JPRB, &
  & 0.53384924E-09_JPRB, 0.53388594E-09_JPRB, 0.53392474E-09_JPRB, 0.53395732E-09_JPRB, 0.53397475E-09_JPRB, 0.53397342E-09_JPRB, &
  & 0.53395921E-09_JPRB, 0.53394644E-09_JPRB, 0.53395538E-09_JPRB, 0.53400795E-09_JPRB, 0.53411903E-09_JPRB, 0.53427979E-09_JPRB, &
  & 0.53446086E-09_JPRB, 0.53463967E-09_JPRB, 0.53480653E-09_JPRB, 0.53495974E-09_JPRB, 0.53510041E-09_JPRB, 0.53522808E-09_JPRB, &
  & 0.53533922E-09_JPRB, 0.53542704E-09_JPRB, 0.53548349E-09_JPRB, 0.53550570E-09_JPRB, 0.53549076E-09_JPRB, 0.53543942E-09_JPRB, &
  & 0.53535426E-09_JPRB, 0.53524174E-09_JPRB, 0.53511534E-09_JPRB, 0.53498928E-09_JPRB, 0.53487853E-09_JPRB, 0.53479177E-09_JPRB, &
  & 0.53472904E-09_JPRB, 0.53468618E-09_JPRB, 0.53465565E-09_JPRB, 0.53463201E-09_JPRB, 0.53461019E-09_JPRB, 0.53458721E-09_JPRB, &
  & 0.53456239E-09_JPRB, 0.53453464E-09_JPRB, 0.53450416E-09_JPRB, 0.53447180E-09_JPRB, 0.53443749E-09_JPRB, 0.53440158E-09_JPRB, &
  & 0.53436411E-09_JPRB, 0.53432675E-09_JPRB, 0.53428945E-09_JPRB, 0.53425686E-09_JPRB, 0.53422783E-09_JPRB, 0.53420246E-09_JPRB, &
  & 0.53417665E-09_JPRB, 0.53414723E-09_JPRB, 0.53410626E-09_JPRB, 0.53403076E-09_JPRB /)

RGHG6(:,64, 6) = (/ &
  & 0.53371096E-09_JPRB, 0.53376142E-09_JPRB, 0.53378979E-09_JPRB, 0.53381521E-09_JPRB, 0.53384108E-09_JPRB, 0.53386612E-09_JPRB, &
  & 0.53388871E-09_JPRB, 0.53390747E-09_JPRB, 0.53392524E-09_JPRB, 0.53394256E-09_JPRB, 0.53396376E-09_JPRB, 0.53398952E-09_JPRB, &
  & 0.53402449E-09_JPRB, 0.53406513E-09_JPRB, 0.53410554E-09_JPRB, 0.53413590E-09_JPRB, 0.53414734E-09_JPRB, 0.53413846E-09_JPRB, &
  & 0.53411747E-09_JPRB, 0.53409821E-09_JPRB, 0.53410065E-09_JPRB, 0.53414567E-09_JPRB, 0.53424692E-09_JPRB, 0.53439647E-09_JPRB, &
  & 0.53456711E-09_JPRB, 0.53473853E-09_JPRB, 0.53490040E-09_JPRB, 0.53504962E-09_JPRB, 0.53518556E-09_JPRB, 0.53530835E-09_JPRB, &
  & 0.53541349E-09_JPRB, 0.53549554E-09_JPRB, 0.53554738E-09_JPRB, 0.53556692E-09_JPRB, 0.53555249E-09_JPRB, 0.53550486E-09_JPRB, &
  & 0.53542593E-09_JPRB, 0.53532195E-09_JPRB, 0.53520488E-09_JPRB, 0.53508897E-09_JPRB, 0.53498661E-09_JPRB, 0.53490595E-09_JPRB, &
  & 0.53484750E-09_JPRB, 0.53480653E-09_JPRB, 0.53477728E-09_JPRB, 0.53475413E-09_JPRB, 0.53473326E-09_JPRB, 0.53471150E-09_JPRB, &
  & 0.53468813E-09_JPRB, 0.53466204E-09_JPRB, 0.53463317E-09_JPRB, 0.53460186E-09_JPRB, 0.53456772E-09_JPRB, 0.53453092E-09_JPRB, &
  & 0.53449234E-09_JPRB, 0.53445237E-09_JPRB, 0.53441285E-09_JPRB, 0.53437554E-09_JPRB, 0.53434268E-09_JPRB, 0.53431215E-09_JPRB, &
  & 0.53428195E-09_JPRB, 0.53424642E-09_JPRB, 0.53419846E-09_JPRB, 0.53410482E-09_JPRB /)

RGHG6(:,65, 6) = (/ &
  & 0.53386251E-09_JPRB, 0.53391336E-09_JPRB, 0.53394161E-09_JPRB, 0.53396648E-09_JPRB, 0.53399124E-09_JPRB, 0.53401567E-09_JPRB, &
  & 0.53403781E-09_JPRB, 0.53405824E-09_JPRB, 0.53407728E-09_JPRB, 0.53409882E-09_JPRB, 0.53412313E-09_JPRB, 0.53415605E-09_JPRB, &
  & 0.53419608E-09_JPRB, 0.53424021E-09_JPRB, 0.53427962E-09_JPRB, 0.53430471E-09_JPRB, 0.53431121E-09_JPRB, 0.53429849E-09_JPRB, &
  & 0.53427279E-09_JPRB, 0.53424798E-09_JPRB, 0.53424459E-09_JPRB, 0.53428256E-09_JPRB, 0.53437510E-09_JPRB, 0.53451366E-09_JPRB, &
  & 0.53467503E-09_JPRB, 0.53483884E-09_JPRB, 0.53499516E-09_JPRB, 0.53513893E-09_JPRB, 0.53526972E-09_JPRB, 0.53538579E-09_JPRB, &
  & 0.53548432E-09_JPRB, 0.53555982E-09_JPRB, 0.53560673E-09_JPRB, 0.53562377E-09_JPRB, 0.53561000E-09_JPRB, 0.53556604E-09_JPRB, &
  & 0.53549387E-09_JPRB, 0.53539850E-09_JPRB, 0.53529159E-09_JPRB, 0.53518540E-09_JPRB, 0.53509169E-09_JPRB, 0.53501731E-09_JPRB, &
  & 0.53496252E-09_JPRB, 0.53492355E-09_JPRB, 0.53489518E-09_JPRB, 0.53487270E-09_JPRB, 0.53485244E-09_JPRB, 0.53483207E-09_JPRB, &
  & 0.53481025E-09_JPRB, 0.53478605E-09_JPRB, 0.53475907E-09_JPRB, 0.53472898E-09_JPRB, 0.53469562E-09_JPRB, 0.53465898E-09_JPRB, &
  & 0.53461929E-09_JPRB, 0.53457816E-09_JPRB, 0.53453614E-09_JPRB, 0.53449628E-09_JPRB, 0.53445931E-09_JPRB, 0.53442539E-09_JPRB, &
  & 0.53439092E-09_JPRB, 0.53435251E-09_JPRB, 0.53429561E-09_JPRB, 0.53419141E-09_JPRB /)

RGHG6(:,66, 6) = (/ &
  & 0.53399862E-09_JPRB, 0.53405280E-09_JPRB, 0.53408267E-09_JPRB, 0.53410854E-09_JPRB, 0.53413374E-09_JPRB, 0.53415861E-09_JPRB, &
  & 0.53418170E-09_JPRB, 0.53420324E-09_JPRB, 0.53422561E-09_JPRB, 0.53424970E-09_JPRB, 0.53428073E-09_JPRB, 0.53431870E-09_JPRB, &
  & 0.53436505E-09_JPRB, 0.53441157E-09_JPRB, 0.53444871E-09_JPRB, 0.53447136E-09_JPRB, 0.53447335E-09_JPRB, 0.53445504E-09_JPRB, &
  & 0.53442456E-09_JPRB, 0.53439569E-09_JPRB, 0.53438753E-09_JPRB, 0.53441934E-09_JPRB, 0.53450283E-09_JPRB, 0.53463212E-09_JPRB, &
  & 0.53478344E-09_JPRB, 0.53493926E-09_JPRB, 0.53508836E-09_JPRB, 0.53522603E-09_JPRB, 0.53534960E-09_JPRB, 0.53545851E-09_JPRB, &
  & 0.53554933E-09_JPRB, 0.53561788E-09_JPRB, 0.53566018E-09_JPRB, 0.53567489E-09_JPRB, 0.53566196E-09_JPRB, 0.53562205E-09_JPRB, &
  & 0.53555660E-09_JPRB, 0.53547028E-09_JPRB, 0.53537341E-09_JPRB, 0.53527732E-09_JPRB, 0.53519195E-09_JPRB, 0.53512383E-09_JPRB, &
  & 0.53507271E-09_JPRB, 0.53503602E-09_JPRB, 0.53500893E-09_JPRB, 0.53498711E-09_JPRB, 0.53496790E-09_JPRB, 0.53494864E-09_JPRB, &
  & 0.53492849E-09_JPRB, 0.53490634E-09_JPRB, 0.53488125E-09_JPRB, 0.53485283E-09_JPRB, 0.53482080E-09_JPRB, 0.53478477E-09_JPRB, &
  & 0.53474503E-09_JPRB, 0.53470312E-09_JPRB, 0.53465965E-09_JPRB, 0.53461757E-09_JPRB, 0.53457816E-09_JPRB, 0.53454102E-09_JPRB, &
  & 0.53450450E-09_JPRB, 0.53446220E-09_JPRB, 0.53440274E-09_JPRB, 0.53428484E-09_JPRB /)

RGHG6(:,67, 6) = (/ &
  & 0.53412308E-09_JPRB, 0.53418303E-09_JPRB, 0.53421612E-09_JPRB, 0.53424420E-09_JPRB, 0.53427163E-09_JPRB, 0.53429738E-09_JPRB, &
  & 0.53432236E-09_JPRB, 0.53434573E-09_JPRB, 0.53437071E-09_JPRB, 0.53439980E-09_JPRB, 0.53443489E-09_JPRB, 0.53447907E-09_JPRB, &
  & 0.53452787E-09_JPRB, 0.53457239E-09_JPRB, 0.53460697E-09_JPRB, 0.53462590E-09_JPRB, 0.53462484E-09_JPRB, 0.53460536E-09_JPRB, &
  & 0.53457272E-09_JPRB, 0.53454124E-09_JPRB, 0.53452942E-09_JPRB, 0.53455562E-09_JPRB, 0.53463162E-09_JPRB, 0.53475008E-09_JPRB, &
  & 0.53489213E-09_JPRB, 0.53503862E-09_JPRB, 0.53517946E-09_JPRB, 0.53530919E-09_JPRB, 0.53542454E-09_JPRB, 0.53552529E-09_JPRB, &
  & 0.53560800E-09_JPRB, 0.53566979E-09_JPRB, 0.53570753E-09_JPRB, 0.53572036E-09_JPRB, 0.53570848E-09_JPRB, 0.53567245E-09_JPRB, &
  & 0.53561378E-09_JPRB, 0.53553650E-09_JPRB, 0.53544952E-09_JPRB, 0.53536314E-09_JPRB, 0.53528637E-09_JPRB, 0.53522431E-09_JPRB, &
  & 0.53517751E-09_JPRB, 0.53514315E-09_JPRB, 0.53511751E-09_JPRB, 0.53509680E-09_JPRB, 0.53507876E-09_JPRB, 0.53506111E-09_JPRB, &
  & 0.53504279E-09_JPRB, 0.53502286E-09_JPRB, 0.53499993E-09_JPRB, 0.53497351E-09_JPRB, 0.53494303E-09_JPRB, 0.53490812E-09_JPRB, &
  & 0.53486893E-09_JPRB, 0.53482685E-09_JPRB, 0.53478266E-09_JPRB, 0.53473925E-09_JPRB, 0.53469829E-09_JPRB, 0.53465948E-09_JPRB, &
  & 0.53462090E-09_JPRB, 0.53457838E-09_JPRB, 0.53451227E-09_JPRB, 0.53438659E-09_JPRB /)

RGHG6(:,68, 6) = (/ &
  & 0.53423255E-09_JPRB, 0.53430493E-09_JPRB, 0.53434324E-09_JPRB, 0.53437599E-09_JPRB, 0.53440580E-09_JPRB, 0.53443516E-09_JPRB, &
  & 0.53446059E-09_JPRB, 0.53448757E-09_JPRB, 0.53451454E-09_JPRB, 0.53454796E-09_JPRB, 0.53458732E-09_JPRB, 0.53463406E-09_JPRB, &
  & 0.53468224E-09_JPRB, 0.53472549E-09_JPRB, 0.53475774E-09_JPRB, 0.53477500E-09_JPRB, 0.53477228E-09_JPRB, 0.53475102E-09_JPRB, &
  & 0.53471733E-09_JPRB, 0.53468463E-09_JPRB, 0.53467036E-09_JPRB, 0.53469207E-09_JPRB, 0.53475957E-09_JPRB, 0.53486804E-09_JPRB, &
  & 0.53499905E-09_JPRB, 0.53513549E-09_JPRB, 0.53526672E-09_JPRB, 0.53538718E-09_JPRB, 0.53549370E-09_JPRB, 0.53558585E-09_JPRB, &
  & 0.53566057E-09_JPRB, 0.53571564E-09_JPRB, 0.53574911E-09_JPRB, 0.53576032E-09_JPRB, 0.53574983E-09_JPRB, 0.53571775E-09_JPRB, &
  & 0.53566573E-09_JPRB, 0.53559696E-09_JPRB, 0.53551963E-09_JPRB, 0.53544269E-09_JPRB, 0.53537386E-09_JPRB, 0.53531829E-09_JPRB, &
  & 0.53527566E-09_JPRB, 0.53524407E-09_JPRB, 0.53522048E-09_JPRB, 0.53520127E-09_JPRB, 0.53518473E-09_JPRB, 0.53516885E-09_JPRB, &
  & 0.53515270E-09_JPRB, 0.53513494E-09_JPRB, 0.53511445E-09_JPRB, 0.53509025E-09_JPRB, 0.53506177E-09_JPRB, 0.53502841E-09_JPRB, &
  & 0.53499039E-09_JPRB, 0.53494875E-09_JPRB, 0.53490479E-09_JPRB, 0.53486116E-09_JPRB, 0.53481952E-09_JPRB, 0.53478005E-09_JPRB, &
  & 0.53474125E-09_JPRB, 0.53469790E-09_JPRB, 0.53463217E-09_JPRB, 0.53449828E-09_JPRB /)

RGHG6(:,69, 6) = (/ &
  & 0.53433524E-09_JPRB, 0.53442251E-09_JPRB, 0.53446914E-09_JPRB, 0.53450611E-09_JPRB, 0.53454119E-09_JPRB, 0.53457117E-09_JPRB, &
  & 0.53460109E-09_JPRB, 0.53462712E-09_JPRB, 0.53465976E-09_JPRB, 0.53469390E-09_JPRB, 0.53473653E-09_JPRB, 0.53478244E-09_JPRB, &
  & 0.53482940E-09_JPRB, 0.53487004E-09_JPRB, 0.53489962E-09_JPRB, 0.53491506E-09_JPRB, 0.53491178E-09_JPRB, 0.53489119E-09_JPRB, &
  & 0.53485816E-09_JPRB, 0.53482574E-09_JPRB, 0.53481058E-09_JPRB, 0.53482785E-09_JPRB, 0.53488741E-09_JPRB, 0.53498445E-09_JPRB, &
  & 0.53510418E-09_JPRB, 0.53522931E-09_JPRB, 0.53534993E-09_JPRB, 0.53546051E-09_JPRB, 0.53555749E-09_JPRB, 0.53564109E-09_JPRB, &
  & 0.53570764E-09_JPRB, 0.53575661E-09_JPRB, 0.53578597E-09_JPRB, 0.53579585E-09_JPRB, 0.53578664E-09_JPRB, 0.53575877E-09_JPRB, &
  & 0.53571292E-09_JPRB, 0.53565241E-09_JPRB, 0.53558419E-09_JPRB, 0.53551619E-09_JPRB, 0.53545512E-09_JPRB, 0.53540583E-09_JPRB, &
  & 0.53536769E-09_JPRB, 0.53533938E-09_JPRB, 0.53531796E-09_JPRB, 0.53530080E-09_JPRB, 0.53528587E-09_JPRB, 0.53527210E-09_JPRB, &
  & 0.53525806E-09_JPRB, 0.53524279E-09_JPRB, 0.53522475E-09_JPRB, 0.53520305E-09_JPRB, 0.53517674E-09_JPRB, 0.53514543E-09_JPRB, &
  & 0.53510929E-09_JPRB, 0.53506888E-09_JPRB, 0.53502591E-09_JPRB, 0.53498306E-09_JPRB, 0.53494204E-09_JPRB, 0.53490312E-09_JPRB, &
  & 0.53486454E-09_JPRB, 0.53482285E-09_JPRB, 0.53475591E-09_JPRB, 0.53461763E-09_JPRB /)

RGHG6(:,70, 6) = (/ &
  & 0.53443538E-09_JPRB, 0.53454136E-09_JPRB, 0.53459603E-09_JPRB, 0.53463961E-09_JPRB, 0.53467708E-09_JPRB, 0.53471116E-09_JPRB, &
  & 0.53473992E-09_JPRB, 0.53477106E-09_JPRB, 0.53480187E-09_JPRB, 0.53484023E-09_JPRB, 0.53488064E-09_JPRB, 0.53492577E-09_JPRB, &
  & 0.53496996E-09_JPRB, 0.53500832E-09_JPRB, 0.53503629E-09_JPRB, 0.53505028E-09_JPRB, 0.53504629E-09_JPRB, 0.53502691E-09_JPRB, &
  & 0.53499577E-09_JPRB, 0.53496518E-09_JPRB, 0.53494914E-09_JPRB, 0.53496280E-09_JPRB, 0.53501392E-09_JPRB, 0.53509941E-09_JPRB, &
  & 0.53520655E-09_JPRB, 0.53531957E-09_JPRB, 0.53542887E-09_JPRB, 0.53552884E-09_JPRB, 0.53561644E-09_JPRB, 0.53569127E-09_JPRB, &
  & 0.53575006E-09_JPRB, 0.53579302E-09_JPRB, 0.53581861E-09_JPRB, 0.53582727E-09_JPRB, 0.53581944E-09_JPRB, 0.53579541E-09_JPRB, &
  & 0.53575572E-09_JPRB, 0.53570298E-09_JPRB, 0.53564320E-09_JPRB, 0.53558386E-09_JPRB, 0.53553034E-09_JPRB, 0.53548715E-09_JPRB, &
  & 0.53545374E-09_JPRB, 0.53542876E-09_JPRB, 0.53540994E-09_JPRB, 0.53539501E-09_JPRB, 0.53538218E-09_JPRB, 0.53537030E-09_JPRB, &
  & 0.53535859E-09_JPRB, 0.53534566E-09_JPRB, 0.53533011E-09_JPRB, 0.53531113E-09_JPRB, 0.53528748E-09_JPRB, 0.53525867E-09_JPRB, &
  & 0.53522492E-09_JPRB, 0.53518673E-09_JPRB, 0.53514559E-09_JPRB, 0.53510474E-09_JPRB, 0.53506538E-09_JPRB, 0.53502863E-09_JPRB, &
  & 0.53499150E-09_JPRB, 0.53495203E-09_JPRB, 0.53488813E-09_JPRB, 0.53474791E-09_JPRB /)

RGHG6(:,71, 6) = (/ &
  & 0.53453669E-09_JPRB, 0.53466637E-09_JPRB, 0.53472871E-09_JPRB, 0.53477772E-09_JPRB, 0.53481769E-09_JPRB, 0.53485294E-09_JPRB, &
  & 0.53488364E-09_JPRB, 0.53491350E-09_JPRB, 0.53494797E-09_JPRB, 0.53498211E-09_JPRB, 0.53502291E-09_JPRB, 0.53506399E-09_JPRB, &
  & 0.53510574E-09_JPRB, 0.53514015E-09_JPRB, 0.53516513E-09_JPRB, 0.53517812E-09_JPRB, 0.53517518E-09_JPRB, 0.53515758E-09_JPRB, &
  & 0.53512872E-09_JPRB, 0.53510069E-09_JPRB, 0.53508525E-09_JPRB, 0.53509552E-09_JPRB, 0.53513843E-09_JPRB, 0.53521182E-09_JPRB, &
  & 0.53530591E-09_JPRB, 0.53540644E-09_JPRB, 0.53550375E-09_JPRB, 0.53559313E-09_JPRB, 0.53567073E-09_JPRB, 0.53573718E-09_JPRB, &
  & 0.53578847E-09_JPRB, 0.53582566E-09_JPRB, 0.53584781E-09_JPRB, 0.53585519E-09_JPRB, 0.53584870E-09_JPRB, 0.53582849E-09_JPRB, &
  & 0.53579435E-09_JPRB, 0.53574911E-09_JPRB, 0.53569732E-09_JPRB, 0.53564608E-09_JPRB, 0.53559973E-09_JPRB, 0.53556282E-09_JPRB, &
  & 0.53553378E-09_JPRB, 0.53551252E-09_JPRB, 0.53549620E-09_JPRB, 0.53548360E-09_JPRB, 0.53547267E-09_JPRB, 0.53546290E-09_JPRB, &
  & 0.53545318E-09_JPRB, 0.53544275E-09_JPRB, 0.53542987E-09_JPRB, 0.53541360E-09_JPRB, 0.53539273E-09_JPRB, 0.53536714E-09_JPRB, &
  & 0.53533639E-09_JPRB, 0.53530130E-09_JPRB, 0.53526322E-09_JPRB, 0.53522525E-09_JPRB, 0.53518928E-09_JPRB, 0.53515514E-09_JPRB, &
  & 0.53512117E-09_JPRB, 0.53508536E-09_JPRB, 0.53502769E-09_JPRB, 0.53489907E-09_JPRB /)

RGHG6(:,72, 6) = (/ &
  & 0.53464899E-09_JPRB, 0.53479637E-09_JPRB, 0.53487220E-09_JPRB, 0.53492233E-09_JPRB, 0.53496546E-09_JPRB, 0.53499905E-09_JPRB, &
  & 0.53503058E-09_JPRB, 0.53506122E-09_JPRB, 0.53509153E-09_JPRB, 0.53512783E-09_JPRB, 0.53516080E-09_JPRB, 0.53520111E-09_JPRB, &
  & 0.53523785E-09_JPRB, 0.53526922E-09_JPRB, 0.53529142E-09_JPRB, 0.53530180E-09_JPRB, 0.53529842E-09_JPRB, 0.53528360E-09_JPRB, &
  & 0.53525762E-09_JPRB, 0.53523241E-09_JPRB, 0.53521754E-09_JPRB, 0.53522492E-09_JPRB, 0.53525973E-09_JPRB, 0.53532145E-09_JPRB, &
  & 0.53540222E-09_JPRB, 0.53548954E-09_JPRB, 0.53557503E-09_JPRB, 0.53565313E-09_JPRB, 0.53572102E-09_JPRB, 0.53577925E-09_JPRB, &
  & 0.53582316E-09_JPRB, 0.53585503E-09_JPRB, 0.53587362E-09_JPRB, 0.53588001E-09_JPRB, 0.53587468E-09_JPRB, 0.53585825E-09_JPRB, &
  & 0.53582921E-09_JPRB, 0.53579091E-09_JPRB, 0.53574678E-09_JPRB, 0.53570315E-09_JPRB, 0.53566396E-09_JPRB, 0.53563254E-09_JPRB, &
  & 0.53560811E-09_JPRB, 0.53558996E-09_JPRB, 0.53557647E-09_JPRB, 0.53556609E-09_JPRB, 0.53555699E-09_JPRB, 0.53554922E-09_JPRB, &
  & 0.53554133E-09_JPRB, 0.53553295E-09_JPRB, 0.53552263E-09_JPRB, 0.53550903E-09_JPRB, 0.53549148E-09_JPRB, 0.53546928E-09_JPRB, &
  & 0.53544258E-09_JPRB, 0.53541099E-09_JPRB, 0.53537674E-09_JPRB, 0.53534355E-09_JPRB, 0.53531102E-09_JPRB, 0.53528143E-09_JPRB, &
  & 0.53525084E-09_JPRB, 0.53521898E-09_JPRB, 0.53516869E-09_JPRB, 0.53505123E-09_JPRB /)

RGHG6(:,73, 6) = (/ &
  & 0.53478449E-09_JPRB, 0.53495208E-09_JPRB, 0.53502258E-09_JPRB, 0.53507787E-09_JPRB, 0.53511606E-09_JPRB, 0.53515137E-09_JPRB, &
  & 0.53518046E-09_JPRB, 0.53520877E-09_JPRB, 0.53524096E-09_JPRB, 0.53526694E-09_JPRB, 0.53530252E-09_JPRB, 0.53533267E-09_JPRB, &
  & 0.53536725E-09_JPRB, 0.53539195E-09_JPRB, 0.53541083E-09_JPRB, 0.53541932E-09_JPRB, 0.53541610E-09_JPRB, 0.53540272E-09_JPRB, &
  & 0.53537930E-09_JPRB, 0.53535787E-09_JPRB, 0.53534421E-09_JPRB, 0.53534915E-09_JPRB, 0.53537685E-09_JPRB, 0.53542693E-09_JPRB, &
  & 0.53549482E-09_JPRB, 0.53556887E-09_JPRB, 0.53564225E-09_JPRB, 0.53570931E-09_JPRB, 0.53576737E-09_JPRB, 0.53581778E-09_JPRB, &
  & 0.53585431E-09_JPRB, 0.53588128E-09_JPRB, 0.53589666E-09_JPRB, 0.53590204E-09_JPRB, 0.53589788E-09_JPRB, 0.53588467E-09_JPRB, &
  & 0.53586052E-09_JPRB, 0.53582866E-09_JPRB, 0.53579163E-09_JPRB, 0.53575538E-09_JPRB, 0.53572241E-09_JPRB, 0.53569676E-09_JPRB, &
  & 0.53567617E-09_JPRB, 0.53566140E-09_JPRB, 0.53565030E-09_JPRB, 0.53564198E-09_JPRB, 0.53563454E-09_JPRB, 0.53562843E-09_JPRB, &
  & 0.53562216E-09_JPRB, 0.53561572E-09_JPRB, 0.53560756E-09_JPRB, 0.53559684E-09_JPRB, 0.53558225E-09_JPRB, 0.53556415E-09_JPRB, &
  & 0.53554117E-09_JPRB, 0.53551430E-09_JPRB, 0.53548477E-09_JPRB, 0.53545568E-09_JPRB, 0.53542859E-09_JPRB, 0.53540250E-09_JPRB, &
  & 0.53537641E-09_JPRB, 0.53534860E-09_JPRB, 0.53530408E-09_JPRB, 0.53520016E-09_JPRB /)

RGHG6(:,74, 6) = (/ &
  & 0.53494287E-09_JPRB, 0.53510640E-09_JPRB, 0.53518479E-09_JPRB, 0.53523252E-09_JPRB, 0.53527111E-09_JPRB, 0.53530147E-09_JPRB, &
  & 0.53532956E-09_JPRB, 0.53535704E-09_JPRB, 0.53538113E-09_JPRB, 0.53541049E-09_JPRB, 0.53543253E-09_JPRB, 0.53546445E-09_JPRB, &
  & 0.53549004E-09_JPRB, 0.53551114E-09_JPRB, 0.53552462E-09_JPRB, 0.53553045E-09_JPRB, 0.53552651E-09_JPRB, 0.53551497E-09_JPRB, &
  & 0.53549487E-09_JPRB, 0.53547650E-09_JPRB, 0.53546401E-09_JPRB, 0.53546734E-09_JPRB, 0.53548854E-09_JPRB, 0.53552801E-09_JPRB, &
  & 0.53558352E-09_JPRB, 0.53564458E-09_JPRB, 0.53570592E-09_JPRB, 0.53576199E-09_JPRB, 0.53581051E-09_JPRB, 0.53585308E-09_JPRB, &
  & 0.53588256E-09_JPRB, 0.53590488E-09_JPRB, 0.53591720E-09_JPRB, 0.53592164E-09_JPRB, 0.53591859E-09_JPRB, 0.53590832E-09_JPRB, &
  & 0.53588833E-09_JPRB, 0.53586258E-09_JPRB, 0.53583232E-09_JPRB, 0.53580268E-09_JPRB, 0.53577576E-09_JPRB, 0.53575522E-09_JPRB, &
  & 0.53573851E-09_JPRB, 0.53572635E-09_JPRB, 0.53571775E-09_JPRB, 0.53571142E-09_JPRB, 0.53570542E-09_JPRB, 0.53570076E-09_JPRB, &
  & 0.53569565E-09_JPRB, 0.53569083E-09_JPRB, 0.53568500E-09_JPRB, 0.53567673E-09_JPRB, 0.53566540E-09_JPRB, 0.53565058E-09_JPRB, &
  & 0.53563221E-09_JPRB, 0.53561000E-09_JPRB, 0.53558491E-09_JPRB, 0.53556160E-09_JPRB, 0.53553800E-09_JPRB, 0.53551669E-09_JPRB, &
  & 0.53549443E-09_JPRB, 0.53547067E-09_JPRB, 0.53543303E-09_JPRB, 0.53533888E-09_JPRB /)

RGHG6(:,75, 6) = (/ &
  & 0.53509974E-09_JPRB, 0.53527238E-09_JPRB, 0.53534055E-09_JPRB, 0.53538712E-09_JPRB, 0.53541832E-09_JPRB, 0.53544730E-09_JPRB, &
  & 0.53547167E-09_JPRB, 0.53549448E-09_JPRB, 0.53551963E-09_JPRB, 0.53553734E-09_JPRB, 0.53556215E-09_JPRB, 0.53558158E-09_JPRB, &
  & 0.53560573E-09_JPRB, 0.53561916E-09_JPRB, 0.53562887E-09_JPRB, 0.53563282E-09_JPRB, 0.53562899E-09_JPRB, 0.53561916E-09_JPRB, &
  & 0.53560201E-09_JPRB, 0.53558713E-09_JPRB, 0.53557631E-09_JPRB, 0.53557841E-09_JPRB, 0.53559424E-09_JPRB, 0.53562405E-09_JPRB, &
  & 0.53566807E-09_JPRB, 0.53571658E-09_JPRB, 0.53576582E-09_JPRB, 0.53581184E-09_JPRB, 0.53585048E-09_JPRB, 0.53588523E-09_JPRB, &
  & 0.53590810E-09_JPRB, 0.53592625E-09_JPRB, 0.53593552E-09_JPRB, 0.53593890E-09_JPRB, 0.53593679E-09_JPRB, 0.53592925E-09_JPRB, &
  & 0.53591309E-09_JPRB, 0.53589294E-09_JPRB, 0.53586890E-09_JPRB, 0.53584559E-09_JPRB, 0.53582422E-09_JPRB, 0.53580868E-09_JPRB, &
  & 0.53579519E-09_JPRB, 0.53578553E-09_JPRB, 0.53577909E-09_JPRB, 0.53577465E-09_JPRB, 0.53576987E-09_JPRB, 0.53576665E-09_JPRB, &
  & 0.53576255E-09_JPRB, 0.53575916E-09_JPRB, 0.53575538E-09_JPRB, 0.53574944E-09_JPRB, 0.53574101E-09_JPRB, 0.53572968E-09_JPRB, &
  & 0.53571525E-09_JPRB, 0.53569749E-09_JPRB, 0.53567734E-09_JPRB, 0.53565796E-09_JPRB, 0.53563942E-09_JPRB, 0.53562155E-09_JPRB, &
  & 0.53560378E-09_JPRB, 0.53558458E-09_JPRB, 0.53555177E-09_JPRB, 0.53546900E-09_JPRB /)

RGHG6(:,76, 6) = (/ &
  & 0.53527077E-09_JPRB, 0.53543070E-09_JPRB, 0.53549404E-09_JPRB, 0.53553212E-09_JPRB, 0.53555838E-09_JPRB, 0.53558158E-09_JPRB, &
  & 0.53560251E-09_JPRB, 0.53562293E-09_JPRB, 0.53564048E-09_JPRB, 0.53565852E-09_JPRB, 0.53567184E-09_JPRB, 0.53569171E-09_JPRB, &
  & 0.53570764E-09_JPRB, 0.53571864E-09_JPRB, 0.53572330E-09_JPRB, 0.53572563E-09_JPRB, 0.53572224E-09_JPRB, 0.53571503E-09_JPRB, &
  & 0.53570104E-09_JPRB, 0.53568955E-09_JPRB, 0.53568056E-09_JPRB, 0.53568205E-09_JPRB, 0.53569332E-09_JPRB, 0.53571475E-09_JPRB, &
  & 0.53574833E-09_JPRB, 0.53578475E-09_JPRB, 0.53582222E-09_JPRB, 0.53585836E-09_JPRB, 0.53588733E-09_JPRB, 0.53591453E-09_JPRB, &
  & 0.53593130E-09_JPRB, 0.53594518E-09_JPRB, 0.53595178E-09_JPRB, 0.53595439E-09_JPRB, 0.53595289E-09_JPRB, 0.53594795E-09_JPRB, &
  & 0.53593496E-09_JPRB, 0.53591992E-09_JPRB, 0.53590177E-09_JPRB, 0.53588423E-09_JPRB, 0.53586813E-09_JPRB, 0.53585730E-09_JPRB, &
  & 0.53584687E-09_JPRB, 0.53583937E-09_JPRB, 0.53583499E-09_JPRB, 0.53583205E-09_JPRB, 0.53582838E-09_JPRB, 0.53582644E-09_JPRB, &
  & 0.53582327E-09_JPRB, 0.53582100E-09_JPRB, 0.53581933E-09_JPRB, 0.53581523E-09_JPRB, 0.53580940E-09_JPRB, 0.53580068E-09_JPRB, &
  & 0.53579036E-09_JPRB, 0.53577720E-09_JPRB, 0.53576066E-09_JPRB, 0.53574678E-09_JPRB, 0.53573135E-09_JPRB, 0.53571791E-09_JPRB, &
  & 0.53570415E-09_JPRB, 0.53568999E-09_JPRB, 0.53566296E-09_JPRB, 0.53558841E-09_JPRB /)

RGHG6(:,77, 6) = (/ &
  & 0.53544280E-09_JPRB, 0.53558591E-09_JPRB, 0.53563792E-09_JPRB, 0.53566807E-09_JPRB, 0.53568561E-09_JPRB, 0.53570431E-09_JPRB, &
  & 0.53571969E-09_JPRB, 0.53573479E-09_JPRB, 0.53575039E-09_JPRB, 0.53575938E-09_JPRB, 0.53577132E-09_JPRB, 0.53578308E-09_JPRB, &
  & 0.53579596E-09_JPRB, 0.53580429E-09_JPRB, 0.53580551E-09_JPRB, 0.53580718E-09_JPRB, 0.53580507E-09_JPRB, 0.53580063E-09_JPRB, &
  & 0.53578963E-09_JPRB, 0.53578186E-09_JPRB, 0.53577476E-09_JPRB, 0.53577642E-09_JPRB, 0.53578442E-09_JPRB, 0.53579841E-09_JPRB, &
  & 0.53582289E-09_JPRB, 0.53584803E-09_JPRB, 0.53587479E-09_JPRB, 0.53590121E-09_JPRB, 0.53592125E-09_JPRB, 0.53594090E-09_JPRB, &
  & 0.53595212E-09_JPRB, 0.53596227E-09_JPRB, 0.53596627E-09_JPRB, 0.53596805E-09_JPRB, 0.53596722E-09_JPRB, 0.53596450E-09_JPRB, &
  & 0.53595428E-09_JPRB, 0.53594384E-09_JPRB, 0.53593108E-09_JPRB, 0.53591886E-09_JPRB, 0.53590754E-09_JPRB, 0.53590110E-09_JPRB, &
  & 0.53589327E-09_JPRB, 0.53588767E-09_JPRB, 0.53588500E-09_JPRB, 0.53588367E-09_JPRB, 0.53588095E-09_JPRB, 0.53588017E-09_JPRB, &
  & 0.53587779E-09_JPRB, 0.53587612E-09_JPRB, 0.53587657E-09_JPRB, 0.53587401E-09_JPRB, 0.53587035E-09_JPRB, 0.53586358E-09_JPRB, &
  & 0.53585691E-09_JPRB, 0.53584792E-09_JPRB, 0.53583554E-09_JPRB, 0.53582611E-09_JPRB, 0.53581473E-09_JPRB, 0.53580501E-09_JPRB, &
  & 0.53579569E-09_JPRB, 0.53578691E-09_JPRB, 0.53576488E-09_JPRB, 0.53570098E-09_JPRB /)

RGHG6(:,78, 6) = (/ &
  & 0.53561700E-09_JPRB, 0.53572735E-09_JPRB, 0.53576354E-09_JPRB, 0.53578503E-09_JPRB, 0.53579441E-09_JPRB, 0.53580718E-09_JPRB, &
  & 0.53581711E-09_JPRB, 0.53582766E-09_JPRB, 0.53583760E-09_JPRB, 0.53584209E-09_JPRB, 0.53584726E-09_JPRB, 0.53585808E-09_JPRB, &
  & 0.53586496E-09_JPRB, 0.53587368E-09_JPRB, 0.53587174E-09_JPRB, 0.53587318E-09_JPRB, 0.53587235E-09_JPRB, 0.53587079E-09_JPRB, &
  & 0.53586258E-09_JPRB, 0.53585852E-09_JPRB, 0.53585353E-09_JPRB, 0.53585608E-09_JPRB, 0.53586163E-09_JPRB, 0.53586985E-09_JPRB, &
  & 0.53588700E-09_JPRB, 0.53590282E-09_JPRB, 0.53592036E-09_JPRB, 0.53593813E-09_JPRB, 0.53595028E-09_JPRB, 0.53596355E-09_JPRB, &
  & 0.53596966E-09_JPRB, 0.53597665E-09_JPRB, 0.53597837E-09_JPRB, 0.53597926E-09_JPRB, 0.53597887E-09_JPRB, 0.53597826E-09_JPRB, &
  & 0.53597021E-09_JPRB, 0.53596388E-09_JPRB, 0.53595561E-09_JPRB, 0.53594768E-09_JPRB, 0.53594068E-09_JPRB, 0.53593813E-09_JPRB, &
  & 0.53593247E-09_JPRB, 0.53592841E-09_JPRB, 0.53592719E-09_JPRB, 0.53592714E-09_JPRB, 0.53592503E-09_JPRB, 0.53592530E-09_JPRB, &
  & 0.53592331E-09_JPRB, 0.53592214E-09_JPRB, 0.53592425E-09_JPRB, 0.53592286E-09_JPRB, 0.53592086E-09_JPRB, 0.53591509E-09_JPRB, &
  & 0.53591148E-09_JPRB, 0.53590621E-09_JPRB, 0.53589688E-09_JPRB, 0.53589250E-09_JPRB, 0.53588389E-09_JPRB, 0.53587829E-09_JPRB, &
  & 0.53587307E-09_JPRB, 0.53586946E-09_JPRB, 0.53585464E-09_JPRB, 0.53580645E-09_JPRB /)

RGHG6(:,79, 6) = (/ &
  & 0.53573007E-09_JPRB, 0.53580690E-09_JPRB, 0.53583110E-09_JPRB, 0.53584642E-09_JPRB, 0.53585053E-09_JPRB, 0.53586102E-09_JPRB, &
  & 0.53586724E-09_JPRB, 0.53587546E-09_JPRB, 0.53588350E-09_JPRB, 0.53588411E-09_JPRB, 0.53588722E-09_JPRB, 0.53589649E-09_JPRB, &
  & 0.53590088E-09_JPRB, 0.53591004E-09_JPRB, 0.53590582E-09_JPRB, 0.53590721E-09_JPRB, 0.53590715E-09_JPRB, 0.53590749E-09_JPRB, &
  & 0.53590066E-09_JPRB, 0.53589888E-09_JPRB, 0.53589488E-09_JPRB, 0.53589821E-09_JPRB, 0.53590288E-09_JPRB, 0.53590776E-09_JPRB, &
  & 0.53592153E-09_JPRB, 0.53593230E-09_JPRB, 0.53594512E-09_JPRB, 0.53595833E-09_JPRB, 0.53596622E-09_JPRB, 0.53597599E-09_JPRB, &
  & 0.53597921E-09_JPRB, 0.53598465E-09_JPRB, 0.53598481E-09_JPRB, 0.53598537E-09_JPRB, 0.53598531E-09_JPRB, 0.53598609E-09_JPRB, &
  & 0.53597882E-09_JPRB, 0.53597454E-09_JPRB, 0.53596882E-09_JPRB, 0.53596311E-09_JPRB, 0.53595833E-09_JPRB, 0.53595811E-09_JPRB, &
  & 0.53595345E-09_JPRB, 0.53595001E-09_JPRB, 0.53594956E-09_JPRB, 0.53595006E-09_JPRB, 0.53594801E-09_JPRB, 0.53594901E-09_JPRB, &
  & 0.53594712E-09_JPRB, 0.53594595E-09_JPRB, 0.53594934E-09_JPRB, 0.53594845E-09_JPRB, 0.53594729E-09_JPRB, 0.53594190E-09_JPRB, &
  & 0.53594001E-09_JPRB, 0.53593652E-09_JPRB, 0.53592841E-09_JPRB, 0.53592664E-09_JPRB, 0.53591920E-09_JPRB, 0.53591542E-09_JPRB, &
  & 0.53591231E-09_JPRB, 0.53591331E-09_JPRB, 0.53590421E-09_JPRB, 0.53587362E-09_JPRB /)

RGHG6(:,80, 6) = (/ &
  & 0.53580518E-09_JPRB, 0.53584559E-09_JPRB, 0.53586080E-09_JPRB, 0.53587335E-09_JPRB, 0.53587473E-09_JPRB, 0.53588417E-09_JPRB, &
  & 0.53588928E-09_JPRB, 0.53589566E-09_JPRB, 0.53590421E-09_JPRB, 0.53590293E-09_JPRB, 0.53590510E-09_JPRB, 0.53591359E-09_JPRB, &
  & 0.53591687E-09_JPRB, 0.53592641E-09_JPRB, 0.53592086E-09_JPRB, 0.53592203E-09_JPRB, 0.53592258E-09_JPRB, 0.53592408E-09_JPRB, &
  & 0.53591775E-09_JPRB, 0.53591726E-09_JPRB, 0.53591365E-09_JPRB, 0.53591770E-09_JPRB, 0.53592181E-09_JPRB, 0.53592492E-09_JPRB, &
  & 0.53593729E-09_JPRB, 0.53594568E-09_JPRB, 0.53595645E-09_JPRB, 0.53596777E-09_JPRB, 0.53597365E-09_JPRB, 0.53598187E-09_JPRB, &
  & 0.53598365E-09_JPRB, 0.53598853E-09_JPRB, 0.53598781E-09_JPRB, 0.53598803E-09_JPRB, 0.53598820E-09_JPRB, 0.53598964E-09_JPRB, &
  & 0.53598270E-09_JPRB, 0.53597932E-09_JPRB, 0.53597476E-09_JPRB, 0.53596999E-09_JPRB, 0.53596622E-09_JPRB, 0.53596699E-09_JPRB, &
  & 0.53596283E-09_JPRB, 0.53595950E-09_JPRB, 0.53595939E-09_JPRB, 0.53596039E-09_JPRB, 0.53595828E-09_JPRB, 0.53595950E-09_JPRB, &
  & 0.53595750E-09_JPRB, 0.53595633E-09_JPRB, 0.53596050E-09_JPRB, 0.53595983E-09_JPRB, 0.53595905E-09_JPRB, 0.53595361E-09_JPRB, &
  & 0.53595262E-09_JPRB, 0.53594995E-09_JPRB, 0.53594201E-09_JPRB, 0.53594140E-09_JPRB, 0.53593402E-09_JPRB, 0.53593108E-09_JPRB, &
  & 0.53592919E-09_JPRB, 0.53593252E-09_JPRB, 0.53592808E-09_JPRB, 0.53591831E-09_JPRB /)

RGHG6(:,81, 6) = (/ &
  & 0.53585680E-09_JPRB, 0.53586185E-09_JPRB, 0.53587340E-09_JPRB, 0.53588484E-09_JPRB, 0.53588495E-09_JPRB, 0.53589427E-09_JPRB, &
  & 0.53589821E-09_JPRB, 0.53590637E-09_JPRB, 0.53591248E-09_JPRB, 0.53591093E-09_JPRB, 0.53591220E-09_JPRB, 0.53592186E-09_JPRB, &
  & 0.53592386E-09_JPRB, 0.53593380E-09_JPRB, 0.53592741E-09_JPRB, 0.53592863E-09_JPRB, 0.53592930E-09_JPRB, 0.53593158E-09_JPRB, &
  & 0.53592525E-09_JPRB, 0.53592569E-09_JPRB, 0.53592208E-09_JPRB, 0.53592636E-09_JPRB, 0.53593036E-09_JPRB, 0.53593247E-09_JPRB, &
  & 0.53594457E-09_JPRB, 0.53595173E-09_JPRB, 0.53596161E-09_JPRB, 0.53597216E-09_JPRB, 0.53597704E-09_JPRB, 0.53598453E-09_JPRB, &
  & 0.53598570E-09_JPRB, 0.53599025E-09_JPRB, 0.53598909E-09_JPRB, 0.53598920E-09_JPRB, 0.53598936E-09_JPRB, 0.53599131E-09_JPRB, &
  & 0.53598437E-09_JPRB, 0.53598143E-09_JPRB, 0.53597721E-09_JPRB, 0.53597293E-09_JPRB, 0.53596971E-09_JPRB, 0.53597099E-09_JPRB, &
  & 0.53596705E-09_JPRB, 0.53596372E-09_JPRB, 0.53596372E-09_JPRB, 0.53596488E-09_JPRB, 0.53596272E-09_JPRB, 0.53596416E-09_JPRB, &
  & 0.53596205E-09_JPRB, 0.53596078E-09_JPRB, 0.53596549E-09_JPRB, 0.53596494E-09_JPRB, 0.53596433E-09_JPRB, 0.53595883E-09_JPRB, &
  & 0.53595839E-09_JPRB, 0.53595595E-09_JPRB, 0.53594795E-09_JPRB, 0.53594779E-09_JPRB, 0.53594029E-09_JPRB, 0.53593768E-09_JPRB, &
  & 0.53593624E-09_JPRB, 0.53594074E-09_JPRB, 0.53593829E-09_JPRB, 0.53594978E-09_JPRB /)

RGHG6(:,82, 6) = (/ &
  & 0.53586080E-09_JPRB, 0.53586735E-09_JPRB, 0.53587901E-09_JPRB, 0.53589044E-09_JPRB, 0.53589000E-09_JPRB, 0.53589883E-09_JPRB, &
  & 0.53590349E-09_JPRB, 0.53590837E-09_JPRB, 0.53591720E-09_JPRB, 0.53591559E-09_JPRB, 0.53591748E-09_JPRB, 0.53592430E-09_JPRB, &
  & 0.53592736E-09_JPRB, 0.53593724E-09_JPRB, 0.53593058E-09_JPRB, 0.53593180E-09_JPRB, 0.53593247E-09_JPRB, 0.53593524E-09_JPRB, &
  & 0.53592902E-09_JPRB, 0.53592991E-09_JPRB, 0.53592614E-09_JPRB, 0.53593086E-09_JPRB, 0.53593474E-09_JPRB, 0.53593602E-09_JPRB, &
  & 0.53594812E-09_JPRB, 0.53595484E-09_JPRB, 0.53596422E-09_JPRB, 0.53597449E-09_JPRB, 0.53597876E-09_JPRB, 0.53598598E-09_JPRB, &
  & 0.53598670E-09_JPRB, 0.53599120E-09_JPRB, 0.53598970E-09_JPRB, 0.53598981E-09_JPRB, 0.53599009E-09_JPRB, 0.53599203E-09_JPRB, &
  & 0.53598515E-09_JPRB, 0.53598237E-09_JPRB, 0.53597837E-09_JPRB, 0.53597438E-09_JPRB, 0.53597149E-09_JPRB, 0.53597277E-09_JPRB, &
  & 0.53596899E-09_JPRB, 0.53596572E-09_JPRB, 0.53596572E-09_JPRB, 0.53596699E-09_JPRB, 0.53596477E-09_JPRB, 0.53596649E-09_JPRB, &
  & 0.53596433E-09_JPRB, 0.53596289E-09_JPRB, 0.53596799E-09_JPRB, 0.53596755E-09_JPRB, 0.53596710E-09_JPRB, 0.53596139E-09_JPRB, &
  & 0.53596116E-09_JPRB, 0.53595894E-09_JPRB, 0.53595073E-09_JPRB, 0.53595084E-09_JPRB, 0.53594323E-09_JPRB, 0.53594074E-09_JPRB, &
  & 0.53593946E-09_JPRB, 0.53594446E-09_JPRB, 0.53594179E-09_JPRB, 0.53595234E-09_JPRB /)

RGHG6(:,83, 6) = (/ &
  & 0.53586363E-09_JPRB, 0.53587051E-09_JPRB, 0.53588223E-09_JPRB, 0.53589361E-09_JPRB, 0.53589266E-09_JPRB, 0.53590199E-09_JPRB, &
  & 0.53590521E-09_JPRB, 0.53591409E-09_JPRB, 0.53591859E-09_JPRB, 0.53591742E-09_JPRB, 0.53591853E-09_JPRB, 0.53592719E-09_JPRB, &
  & 0.53592941E-09_JPRB, 0.53593890E-09_JPRB, 0.53593224E-09_JPRB, 0.53593346E-09_JPRB, 0.53593430E-09_JPRB, 0.53593746E-09_JPRB, &
  & 0.53593113E-09_JPRB, 0.53593230E-09_JPRB, 0.53592841E-09_JPRB, 0.53593341E-09_JPRB, 0.53593724E-09_JPRB, 0.53593785E-09_JPRB, &
  & 0.53595045E-09_JPRB, 0.53595656E-09_JPRB, 0.53596594E-09_JPRB, 0.53597582E-09_JPRB, 0.53597982E-09_JPRB, 0.53598670E-09_JPRB, &
  & 0.53598731E-09_JPRB, 0.53599170E-09_JPRB, 0.53599014E-09_JPRB, 0.53599014E-09_JPRB, 0.53599036E-09_JPRB, 0.53599236E-09_JPRB, &
  & 0.53598548E-09_JPRB, 0.53598270E-09_JPRB, 0.53597898E-09_JPRB, 0.53597515E-09_JPRB, 0.53597243E-09_JPRB, 0.53597360E-09_JPRB, &
  & 0.53597005E-09_JPRB, 0.53596688E-09_JPRB, 0.53596694E-09_JPRB, 0.53596821E-09_JPRB, 0.53596605E-09_JPRB, 0.53596783E-09_JPRB, &
  & 0.53596561E-09_JPRB, 0.53596422E-09_JPRB, 0.53596960E-09_JPRB, 0.53596905E-09_JPRB, 0.53596871E-09_JPRB, 0.53596283E-09_JPRB, &
  & 0.53596283E-09_JPRB, 0.53596066E-09_JPRB, 0.53595223E-09_JPRB, 0.53595256E-09_JPRB, 0.53594484E-09_JPRB, 0.53594240E-09_JPRB, &
  & 0.53594129E-09_JPRB, 0.53594662E-09_JPRB, 0.53594390E-09_JPRB, 0.53595428E-09_JPRB /)

RGHG6(:,84, 6) = (/ &
  & 0.53586552E-09_JPRB, 0.53587257E-09_JPRB, 0.53588428E-09_JPRB, 0.53589561E-09_JPRB, 0.53589466E-09_JPRB, 0.53590332E-09_JPRB, &
  & 0.53590832E-09_JPRB, 0.53591237E-09_JPRB, 0.53592075E-09_JPRB, 0.53591975E-09_JPRB, 0.53592181E-09_JPRB, 0.53592708E-09_JPRB, &
  & 0.53593052E-09_JPRB, 0.53593907E-09_JPRB, 0.53593374E-09_JPRB, 0.53593457E-09_JPRB, 0.53593530E-09_JPRB, 0.53593852E-09_JPRB, &
  & 0.53593241E-09_JPRB, 0.53593391E-09_JPRB, 0.53592980E-09_JPRB, 0.53593513E-09_JPRB, 0.53593885E-09_JPRB, 0.53593907E-09_JPRB, &
  & 0.53595173E-09_JPRB, 0.53595778E-09_JPRB, 0.53596672E-09_JPRB, 0.53597687E-09_JPRB, 0.53598043E-09_JPRB, 0.53598725E-09_JPRB, &
  & 0.53598764E-09_JPRB, 0.53599197E-09_JPRB, 0.53599031E-09_JPRB, 0.53599014E-09_JPRB, 0.53599047E-09_JPRB, 0.53599253E-09_JPRB, &
  & 0.53598564E-09_JPRB, 0.53598287E-09_JPRB, 0.53597926E-09_JPRB, 0.53597565E-09_JPRB, 0.53597310E-09_JPRB, 0.53597415E-09_JPRB, &
  & 0.53597082E-09_JPRB, 0.53596766E-09_JPRB, 0.53596766E-09_JPRB, 0.53596894E-09_JPRB, 0.53596677E-09_JPRB, 0.53596860E-09_JPRB, &
  & 0.53596649E-09_JPRB, 0.53596488E-09_JPRB, 0.53597049E-09_JPRB, 0.53597016E-09_JPRB, 0.53596977E-09_JPRB, 0.53596383E-09_JPRB, &
  & 0.53596394E-09_JPRB, 0.53596166E-09_JPRB, 0.53595306E-09_JPRB, 0.53595350E-09_JPRB, 0.53594573E-09_JPRB, 0.53594335E-09_JPRB, &
  & 0.53594240E-09_JPRB, 0.53594795E-09_JPRB, 0.53594529E-09_JPRB, 0.53595561E-09_JPRB /)

RGHG6(:,85, 6) = (/ &
  & 0.53586680E-09_JPRB, 0.53587379E-09_JPRB, 0.53588550E-09_JPRB, 0.53589688E-09_JPRB, 0.53589544E-09_JPRB, 0.53590521E-09_JPRB, &
  & 0.53590815E-09_JPRB, 0.53591709E-09_JPRB, 0.53592042E-09_JPRB, 0.53592064E-09_JPRB, 0.53592186E-09_JPRB, 0.53592891E-09_JPRB, &
  & 0.53593163E-09_JPRB, 0.53593818E-09_JPRB, 0.53593452E-09_JPRB, 0.53593524E-09_JPRB, 0.53593607E-09_JPRB, 0.53593907E-09_JPRB, &
  & 0.53593335E-09_JPRB, 0.53593491E-09_JPRB, 0.53593069E-09_JPRB, 0.53593630E-09_JPRB, 0.53594001E-09_JPRB, 0.53593963E-09_JPRB, &
  & 0.53595289E-09_JPRB, 0.53595839E-09_JPRB, 0.53596783E-09_JPRB, 0.53597754E-09_JPRB, 0.53598082E-09_JPRB, 0.53598759E-09_JPRB, &
  & 0.53598798E-09_JPRB, 0.53599220E-09_JPRB, 0.53599042E-09_JPRB, 0.53599020E-09_JPRB, 0.53599059E-09_JPRB, 0.53599281E-09_JPRB, &
  & 0.53598570E-09_JPRB, 0.53598292E-09_JPRB, 0.53597948E-09_JPRB, 0.53597587E-09_JPRB, 0.53597349E-09_JPRB, 0.53597426E-09_JPRB, &
  & 0.53597105E-09_JPRB, 0.53596821E-09_JPRB, 0.53596827E-09_JPRB, 0.53596938E-09_JPRB, 0.53596733E-09_JPRB, 0.53596905E-09_JPRB, &
  & 0.53596699E-09_JPRB, 0.53596538E-09_JPRB, 0.53597116E-09_JPRB, 0.53597071E-09_JPRB, 0.53597043E-09_JPRB, 0.53596444E-09_JPRB, &
  & 0.53596461E-09_JPRB, 0.53596244E-09_JPRB, 0.53595367E-09_JPRB, 0.53595428E-09_JPRB, 0.53594634E-09_JPRB, 0.53594396E-09_JPRB, &
  & 0.53594307E-09_JPRB, 0.53594890E-09_JPRB, 0.53594612E-09_JPRB, 0.53595661E-09_JPRB /)

RGHG6(:,86, 6) = (/ &
  & 0.53586757E-09_JPRB, 0.53587468E-09_JPRB, 0.53588628E-09_JPRB, 0.53589794E-09_JPRB, 0.53589710E-09_JPRB, 0.53590499E-09_JPRB, &
  & 0.53591143E-09_JPRB, 0.53591470E-09_JPRB, 0.53592197E-09_JPRB, 0.53592208E-09_JPRB, 0.53592486E-09_JPRB, 0.53592830E-09_JPRB, &
  & 0.53593197E-09_JPRB, 0.53593663E-09_JPRB, 0.53593496E-09_JPRB, 0.53593563E-09_JPRB, 0.53593652E-09_JPRB, 0.53593902E-09_JPRB, &
  & 0.53593424E-09_JPRB, 0.53593557E-09_JPRB, 0.53593141E-09_JPRB, 0.53593702E-09_JPRB, 0.53594085E-09_JPRB, 0.53594013E-09_JPRB, &
  & 0.53595339E-09_JPRB, 0.53595900E-09_JPRB, 0.53596805E-09_JPRB, 0.53597815E-09_JPRB, 0.53598115E-09_JPRB, 0.53598803E-09_JPRB, &
  & 0.53598814E-09_JPRB, 0.53599247E-09_JPRB, 0.53599047E-09_JPRB, 0.53599014E-09_JPRB, 0.53599064E-09_JPRB, 0.53599297E-09_JPRB, &
  & 0.53598564E-09_JPRB, 0.53598304E-09_JPRB, 0.53597959E-09_JPRB, 0.53597604E-09_JPRB, 0.53597371E-09_JPRB, 0.53597460E-09_JPRB, &
  & 0.53597149E-09_JPRB, 0.53596844E-09_JPRB, 0.53596855E-09_JPRB, 0.53596960E-09_JPRB, 0.53596766E-09_JPRB, 0.53596932E-09_JPRB, &
  & 0.53596738E-09_JPRB, 0.53596583E-09_JPRB, 0.53597143E-09_JPRB, 0.53597121E-09_JPRB, 0.53597088E-09_JPRB, 0.53596499E-09_JPRB, &
  & 0.53596511E-09_JPRB, 0.53596289E-09_JPRB, 0.53595406E-09_JPRB, 0.53595484E-09_JPRB, 0.53594662E-09_JPRB, 0.53594434E-09_JPRB, &
  & 0.53594351E-09_JPRB, 0.53594945E-09_JPRB, 0.53594673E-09_JPRB, 0.53595722E-09_JPRB /)

RGHG6(:,87, 6) = (/ &
  & 0.53586818E-09_JPRB, 0.53587518E-09_JPRB, 0.53588656E-09_JPRB, 0.53589821E-09_JPRB, 0.53589694E-09_JPRB, 0.53590765E-09_JPRB, &
  & 0.53591021E-09_JPRB, 0.53591864E-09_JPRB, 0.53592120E-09_JPRB, 0.53592281E-09_JPRB, 0.53592419E-09_JPRB, 0.53592941E-09_JPRB, &
  & 0.53593174E-09_JPRB, 0.53593585E-09_JPRB, 0.53593502E-09_JPRB, 0.53593574E-09_JPRB, 0.53593663E-09_JPRB, 0.53593874E-09_JPRB, &
  & 0.53593485E-09_JPRB, 0.53593591E-09_JPRB, 0.53593185E-09_JPRB, 0.53593746E-09_JPRB, 0.53594129E-09_JPRB, 0.53594029E-09_JPRB, &
  & 0.53595389E-09_JPRB, 0.53595917E-09_JPRB, 0.53596855E-09_JPRB, 0.53597848E-09_JPRB, 0.53598131E-09_JPRB, 0.53598836E-09_JPRB, &
  & 0.53598814E-09_JPRB, 0.53599253E-09_JPRB, 0.53599047E-09_JPRB, 0.53599014E-09_JPRB, 0.53599070E-09_JPRB, 0.53599336E-09_JPRB, &
  & 0.53598564E-09_JPRB, 0.53598315E-09_JPRB, 0.53597976E-09_JPRB, 0.53597615E-09_JPRB, 0.53597382E-09_JPRB, 0.53597504E-09_JPRB, &
  & 0.53597149E-09_JPRB, 0.53596849E-09_JPRB, 0.53596871E-09_JPRB, 0.53596971E-09_JPRB, 0.53596799E-09_JPRB, 0.53596938E-09_JPRB, &
  & 0.53596760E-09_JPRB, 0.53596627E-09_JPRB, 0.53597166E-09_JPRB, 0.53597149E-09_JPRB, 0.53597110E-09_JPRB, 0.53596533E-09_JPRB, &
  & 0.53596544E-09_JPRB, 0.53596316E-09_JPRB, 0.53595428E-09_JPRB, 0.53595511E-09_JPRB, 0.53594684E-09_JPRB, 0.53594468E-09_JPRB, &
  & 0.53594384E-09_JPRB, 0.53594990E-09_JPRB, 0.53594701E-09_JPRB, 0.53595761E-09_JPRB /)

RGHG6(:,88, 6) = (/ &
  & 0.53586879E-09_JPRB, 0.53587601E-09_JPRB, 0.53588683E-09_JPRB, 0.53589855E-09_JPRB, 0.53589899E-09_JPRB, 0.53590610E-09_JPRB, &
  & 0.53591326E-09_JPRB, 0.53591631E-09_JPRB, 0.53592247E-09_JPRB, 0.53592314E-09_JPRB, 0.53592597E-09_JPRB, 0.53592880E-09_JPRB, &
  & 0.53593202E-09_JPRB, 0.53593541E-09_JPRB, 0.53593496E-09_JPRB, 0.53593585E-09_JPRB, 0.53593679E-09_JPRB, 0.53593874E-09_JPRB, &
  & 0.53593507E-09_JPRB, 0.53593607E-09_JPRB, 0.53593202E-09_JPRB, 0.53593763E-09_JPRB, 0.53594162E-09_JPRB, 0.53594046E-09_JPRB, &
  & 0.53595411E-09_JPRB, 0.53595939E-09_JPRB, 0.53596871E-09_JPRB, 0.53597882E-09_JPRB, 0.53598143E-09_JPRB, 0.53598864E-09_JPRB, &
  & 0.53598820E-09_JPRB, 0.53599264E-09_JPRB, 0.53599047E-09_JPRB, 0.53599014E-09_JPRB, 0.53599070E-09_JPRB, 0.53599380E-09_JPRB, &
  & 0.53598559E-09_JPRB, 0.53598331E-09_JPRB, 0.53597982E-09_JPRB, 0.53597587E-09_JPRB, 0.53597349E-09_JPRB, 0.53597543E-09_JPRB, &
  & 0.53597154E-09_JPRB, 0.53596816E-09_JPRB, 0.53596877E-09_JPRB, 0.53596982E-09_JPRB, 0.53596816E-09_JPRB, 0.53596944E-09_JPRB, &
  & 0.53596783E-09_JPRB, 0.53596672E-09_JPRB, 0.53597154E-09_JPRB, 0.53597160E-09_JPRB, 0.53597121E-09_JPRB, 0.53596566E-09_JPRB, &
  & 0.53596572E-09_JPRB, 0.53596327E-09_JPRB, 0.53595439E-09_JPRB, 0.53595528E-09_JPRB, 0.53594695E-09_JPRB, 0.53594468E-09_JPRB, &
  & 0.53594390E-09_JPRB, 0.53595017E-09_JPRB, 0.53594718E-09_JPRB, 0.53595789E-09_JPRB /)

RGHG6(:,89, 6) = (/ &
  & 0.53586979E-09_JPRB, 0.53587701E-09_JPRB, 0.53588689E-09_JPRB, 0.53589799E-09_JPRB, 0.53589744E-09_JPRB, 0.53590815E-09_JPRB, &
  & 0.53591120E-09_JPRB, 0.53591886E-09_JPRB, 0.53592175E-09_JPRB, 0.53592336E-09_JPRB, 0.53592492E-09_JPRB, 0.53592930E-09_JPRB, &
  & 0.53593174E-09_JPRB, 0.53593591E-09_JPRB, 0.53593519E-09_JPRB, 0.53593602E-09_JPRB, 0.53593691E-09_JPRB, 0.53593918E-09_JPRB, &
  & 0.53593530E-09_JPRB, 0.53593641E-09_JPRB, 0.53593219E-09_JPRB, 0.53593779E-09_JPRB, 0.53594185E-09_JPRB, 0.53594046E-09_JPRB, &
  & 0.53595445E-09_JPRB, 0.53595939E-09_JPRB, 0.53596894E-09_JPRB, 0.53597915E-09_JPRB, 0.53598143E-09_JPRB, 0.53598892E-09_JPRB, &
  & 0.53598820E-09_JPRB, 0.53599286E-09_JPRB, 0.53599047E-09_JPRB, 0.53599009E-09_JPRB, 0.53599059E-09_JPRB, 0.53599403E-09_JPRB, &
  & 0.53598537E-09_JPRB, 0.53598342E-09_JPRB, 0.53597993E-09_JPRB, 0.53597565E-09_JPRB, 0.53597293E-09_JPRB, 0.53597599E-09_JPRB, &
  & 0.53597132E-09_JPRB, 0.53596799E-09_JPRB, 0.53596882E-09_JPRB, 0.53596994E-09_JPRB, 0.53596821E-09_JPRB, 0.53596938E-09_JPRB, &
  & 0.53596794E-09_JPRB, 0.53596694E-09_JPRB, 0.53597154E-09_JPRB, 0.53597166E-09_JPRB, 0.53597132E-09_JPRB, 0.53596594E-09_JPRB, &
  & 0.53596594E-09_JPRB, 0.53596344E-09_JPRB, 0.53595445E-09_JPRB, 0.53595556E-09_JPRB, 0.53594695E-09_JPRB, 0.53594479E-09_JPRB, &
  & 0.53594384E-09_JPRB, 0.53595040E-09_JPRB, 0.53594723E-09_JPRB, 0.53595806E-09_JPRB /)

RGHG6(:,90, 6) = (/ &
  & 0.53587063E-09_JPRB, 0.53587795E-09_JPRB, 0.53588622E-09_JPRB, 0.53589799E-09_JPRB, 0.53589760E-09_JPRB, 0.53590632E-09_JPRB, &
  & 0.53591204E-09_JPRB, 0.53591642E-09_JPRB, 0.53592242E-09_JPRB, 0.53592286E-09_JPRB, 0.53592530E-09_JPRB, 0.53592869E-09_JPRB, &
  & 0.53593219E-09_JPRB, 0.53593707E-09_JPRB, 0.53593519E-09_JPRB, 0.53593607E-09_JPRB, 0.53593702E-09_JPRB, 0.53594007E-09_JPRB, &
  & 0.53593469E-09_JPRB, 0.53593652E-09_JPRB, 0.53593185E-09_JPRB, 0.53593791E-09_JPRB, 0.53594201E-09_JPRB, 0.53594024E-09_JPRB, &
  & 0.53595473E-09_JPRB, 0.53595933E-09_JPRB, 0.53596899E-09_JPRB, 0.53597937E-09_JPRB, 0.53598131E-09_JPRB, 0.53598931E-09_JPRB, &
  & 0.53598809E-09_JPRB, 0.53599314E-09_JPRB, 0.53599047E-09_JPRB, 0.53599009E-09_JPRB, 0.53599053E-09_JPRB, 0.53599458E-09_JPRB, &
  & 0.53598526E-09_JPRB, 0.53598354E-09_JPRB, 0.53598009E-09_JPRB, 0.53597543E-09_JPRB, 0.53597254E-09_JPRB, 0.53597665E-09_JPRB, &
  & 0.53597132E-09_JPRB, 0.53596766E-09_JPRB, 0.53596882E-09_JPRB, 0.53597010E-09_JPRB, 0.53596816E-09_JPRB, 0.53596949E-09_JPRB, &
  & 0.53596794E-09_JPRB, 0.53596688E-09_JPRB, 0.53597166E-09_JPRB, 0.53597188E-09_JPRB, 0.53597154E-09_JPRB, 0.53596588E-09_JPRB, &
  & 0.53596610E-09_JPRB, 0.53596361E-09_JPRB, 0.53595423E-09_JPRB, 0.53595584E-09_JPRB, 0.53594684E-09_JPRB, 0.53594479E-09_JPRB, &
  & 0.53594368E-09_JPRB, 0.53595067E-09_JPRB, 0.53594718E-09_JPRB, 0.53595822E-09_JPRB /)

RGHG6(:,91, 6) = (/ &
  & 0.53587029E-09_JPRB, 0.53587790E-09_JPRB, 0.53588339E-09_JPRB, 0.53590010E-09_JPRB, 0.53589533E-09_JPRB, 0.53590649E-09_JPRB, &
  & 0.53590776E-09_JPRB, 0.53591442E-09_JPRB, 0.53592403E-09_JPRB, 0.53592203E-09_JPRB, 0.53592408E-09_JPRB, 0.53592730E-09_JPRB, &
  & 0.53593047E-09_JPRB, 0.53594623E-09_JPRB, 0.53593285E-09_JPRB, 0.53593607E-09_JPRB, 0.53593635E-09_JPRB, 0.53594240E-09_JPRB, &
  & 0.53593346E-09_JPRB, 0.53593718E-09_JPRB, 0.53593097E-09_JPRB, 0.53593807E-09_JPRB, 0.53594251E-09_JPRB, 0.53593918E-09_JPRB, &
  & 0.53595539E-09_JPRB, 0.53595905E-09_JPRB, 0.53596894E-09_JPRB, 0.53597993E-09_JPRB, 0.53598082E-09_JPRB, 0.53599003E-09_JPRB, &
  & 0.53598759E-09_JPRB, 0.53599380E-09_JPRB, 0.53599014E-09_JPRB, 0.53598997E-09_JPRB, 0.53599036E-09_JPRB, 0.53599553E-09_JPRB, &
  & 0.53598476E-09_JPRB, 0.53598370E-09_JPRB, 0.53598026E-09_JPRB, 0.53597532E-09_JPRB, 0.53597188E-09_JPRB, 0.53597771E-09_JPRB, &
  & 0.53597127E-09_JPRB, 0.53596699E-09_JPRB, 0.53596882E-09_JPRB, 0.53597060E-09_JPRB, 0.53596749E-09_JPRB, 0.53596999E-09_JPRB, &
  & 0.53596788E-09_JPRB, 0.53596605E-09_JPRB, 0.53597216E-09_JPRB, 0.53597193E-09_JPRB, 0.53597199E-09_JPRB, 0.53596527E-09_JPRB, &
  & 0.53596633E-09_JPRB, 0.53596405E-09_JPRB, 0.53595345E-09_JPRB, 0.53595645E-09_JPRB, 0.53594634E-09_JPRB, 0.53594473E-09_JPRB, &
  & 0.53594329E-09_JPRB, 0.53595128E-09_JPRB, 0.53594690E-09_JPRB, 0.53595856E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART12',1,ZHOOK_HANDLE)
END SUBROUTINE PART12






SUBROUTINE PART13
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART13',0,ZHOOK_HANDLE)



!-- Month=  7 ------------

RGHG6(:, 1, 7) = (/ &
  & 0.11480887E-37_JPRB, 0.24273539E-37_JPRB, 0.37171448E-37_JPRB, 0.49576650E-37_JPRB, 0.61926641E-37_JPRB, 0.77974009E-37_JPRB, &
  & 0.10021503E-36_JPRB, 0.13519373E-36_JPRB, 0.19326224E-36_JPRB, 0.29177523E-36_JPRB, 0.46103513E-36_JPRB, 0.75803709E-36_JPRB, &
  & 0.12938415E-35_JPRB, 0.22859128E-35_JPRB, 0.41743588E-35_JPRB, 0.78396519E-35_JPRB, 0.15073181E-34_JPRB, 0.29511010E-34_JPRB, &
  & 0.58583241E-34_JPRB, 0.11749141E-33_JPRB, 0.23741625E-33_JPRB, 0.47903994E-33_JPRB, 0.95118532E-33_JPRB, 0.18288543E-32_JPRB, &
  & 0.33927871E-32_JPRB, 0.56153181E-32_JPRB, 0.91316435E-32_JPRB, 0.13748935E-31_JPRB, 0.18972699E-31_JPRB, 0.24387717E-31_JPRB, &
  & 0.29238862E-31_JPRB, 0.33101192E-31_JPRB, 0.36077376E-31_JPRB, 0.38178628E-31_JPRB, 0.39685227E-31_JPRB, 0.40791200E-31_JPRB, &
  & 0.41281043E-31_JPRB, 0.40554279E-31_JPRB, 0.38076795E-31_JPRB, 0.34047342E-31_JPRB, 0.29293698E-31_JPRB, 0.24034807E-31_JPRB, &
  & 0.18719413E-31_JPRB, 0.13812876E-31_JPRB, 0.95454285E-32_JPRB, 0.61853793E-32_JPRB, 0.37207192E-32_JPRB, 0.20886845E-32_JPRB, &
  & 0.11531420E-32_JPRB, 0.62249213E-33_JPRB, 0.33236205E-33_JPRB, 0.17402134E-33_JPRB, 0.90017268E-34_JPRB, 0.46466858E-34_JPRB, &
  & 0.24544236E-34_JPRB, 0.13238882E-34_JPRB, 0.75715705E-35_JPRB, 0.45848796E-35_JPRB, 0.30122089E-35_JPRB, 0.22096915E-35_JPRB, &
  & 0.18454368E-35_JPRB, 0.15624398E-35_JPRB, 0.69621656E-36_JPRB, 0.47379947E-37_JPRB /)

RGHG6(:, 2, 7) = (/ &
  & 0.45599230E-36_JPRB, 0.96956303E-36_JPRB, 0.15314089E-35_JPRB, 0.20507044E-35_JPRB, 0.25625662E-35_JPRB, 0.32121606E-35_JPRB, &
  & 0.41453998E-35_JPRB, 0.56365499E-35_JPRB, 0.81281137E-35_JPRB, 0.12370690E-34_JPRB, 0.19715112E-34_JPRB, 0.32704675E-34_JPRB, &
  & 0.56326848E-34_JPRB, 0.10041215E-33_JPRB, 0.18485652E-33_JPRB, 0.34953370E-33_JPRB, 0.67517167E-33_JPRB, 0.13241266E-32_JPRB, &
  & 0.26215787E-32_JPRB, 0.52121868E-32_JPRB, 0.10362983E-31_JPRB, 0.20464690E-31_JPRB, 0.39765845E-31_JPRB, 0.75174498E-31_JPRB, &
  & 0.13700894E-30_JPRB, 0.22684018E-30_JPRB, 0.36362700E-30_JPRB, 0.54237568E-30_JPRB, 0.74685889E-30_JPRB, 0.96052775E-30_JPRB, &
  & 0.11558901E-29_JPRB, 0.13150665E-29_JPRB, 0.14387272E-29_JPRB, 0.15263442E-29_JPRB, 0.15875262E-29_JPRB, 0.16288758E-29_JPRB, &
  & 0.16421325E-29_JPRB, 0.16055306E-29_JPRB, 0.15058731E-29_JPRB, 0.13513483E-29_JPRB, 0.11609700E-29_JPRB, 0.95064626E-30_JPRB, &
  & 0.73937650E-30_JPRB, 0.54545303E-30_JPRB, 0.37755818E-30_JPRB, 0.24550301E-30_JPRB, 0.14965983E-30_JPRB, 0.85900490E-31_JPRB, &
  & 0.47507463E-31_JPRB, 0.25785224E-31_JPRB, 0.13897282E-31_JPRB, 0.73401438E-32_JPRB, 0.38162769E-32_JPRB, 0.19663985E-32_JPRB, &
  & 0.10287174E-32_JPRB, 0.55306394E-33_JPRB, 0.31181310E-33_JPRB, 0.18661678E-33_JPRB, 0.12177593E-33_JPRB, 0.88773913E-34_JPRB, &
  & 0.73238062E-34_JPRB, 0.61163554E-34_JPRB, 0.29118571E-34_JPRB, 0.28038245E-35_JPRB /)

RGHG6(:, 3, 7) = (/ &
  & 0.15454117E-34_JPRB, 0.42979956E-34_JPRB, 0.73543369E-34_JPRB, 0.99472031E-34_JPRB, 0.12389231E-33_JPRB, 0.15423753E-33_JPRB, &
  & 0.19773323E-33_JPRB, 0.26759780E-33_JPRB, 0.38431452E-33_JPRB, 0.58368956E-33_JPRB, 0.92789226E-33_JPRB, 0.15352255E-32_JPRB, &
  & 0.26368045E-32_JPRB, 0.46880948E-32_JPRB, 0.86218103E-32_JPRB, 0.16335974E-31_JPRB, 0.31752259E-31_JPRB, 0.62872561E-31_JPRB, &
  & 0.12577130E-30_JPRB, 0.25196162E-30_JPRB, 0.50229118E-30_JPRB, 0.98966985E-30_JPRB, 0.19147317E-29_JPRB, 0.36010542E-29_JPRB, &
  & 0.65324482E-29_JPRB, 0.10784302E-28_JPRB, 0.17190270E-28_JPRB, 0.25506851E-28_JPRB, 0.35096273E-28_JPRB, 0.45199749E-28_JPRB, &
  & 0.54545345E-28_JPRB, 0.62310400E-28_JPRB, 0.68367022E-28_JPRB, 0.72683230E-28_JPRB, 0.75672014E-28_JPRB, 0.77605191E-28_JPRB, &
  & 0.78132354E-28_JPRB, 0.76346662E-28_JPRB, 0.71757297E-28_JPRB, 0.64697217E-28_JPRB, 0.55623282E-28_JPRB, 0.45400380E-28_JPRB, &
  & 0.35053225E-28_JPRB, 0.25619716E-28_JPRB, 0.17603714E-28_JPRB, 0.11426178E-28_JPRB, 0.70337309E-29_JPRB, 0.41093883E-29_JPRB, &
  & 0.22945971E-29_JPRB, 0.12588374E-29_JPRB, 0.68128441E-30_JPRB, 0.36208350E-30_JPRB, 0.18870703E-30_JPRB, 0.97371340E-31_JPRB, &
  & 0.50817479E-31_JPRB, 0.27204204E-31_JPRB, 0.15254174E-31_JPRB, 0.90512029E-32_JPRB, 0.58879388E-32_JPRB, 0.42925560E-32_JPRB, &
  & 0.35683351E-32_JPRB, 0.30956379E-32_JPRB, 0.17229351E-32_JPRB, 0.21421644E-33_JPRB /)

RGHG6(:, 4, 7) = (/ &
  & 0.10793350E-32_JPRB, 0.42274388E-32_JPRB, 0.72822933E-32_JPRB, 0.97062273E-32_JPRB, 0.11901711E-31_JPRB, 0.14715958E-31_JPRB, &
  & 0.18723730E-31_JPRB, 0.25132263E-31_JPRB, 0.35889729E-31_JPRB, 0.54148483E-31_JPRB, 0.85609238E-31_JPRB, 0.14075992E-30_JPRB, &
  & 0.24010709E-30_JPRB, 0.42384076E-30_JPRB, 0.77477651E-30_JPRB, 0.14635626E-29_JPRB, 0.28499285E-29_JPRB, 0.56791160E-29_JPRB, &
  & 0.11452114E-28_JPRB, 0.23070953E-28_JPRB, 0.46004111E-28_JPRB, 0.90158522E-28_JPRB, 0.17274942E-27_JPRB, 0.32147830E-27_JPRB, &
  & 0.57681717E-27_JPRB, 0.94594014E-27_JPRB, 0.14980371E-26_JPRB, 0.22174797E-26_JPRB, 0.30502075E-26_JPRB, 0.39333441E-26_JPRB, &
  & 0.47592048E-26_JPRB, 0.54469470E-26_JPRB, 0.59911039E-26_JPRB, 0.63847867E-26_JPRB, 0.66617439E-26_JPRB, 0.68488965E-26_JPRB, &
  & 0.69122804E-26_JPRB, 0.67776194E-26_JPRB, 0.64088943E-26_JPRB, 0.58195363E-26_JPRB, 0.50356331E-26_JPRB, 0.41182661E-26_JPRB, &
  & 0.31694135E-26_JPRB, 0.23084672E-26_JPRB, 0.15803366E-26_JPRB, 0.10301447E-26_JPRB, 0.64086499E-27_JPRB, 0.37919461E-27_JPRB, &
  & 0.21416023E-27_JPRB, 0.11786918E-27_JPRB, 0.64054582E-28_JPRB, 0.34082698E-28_JPRB, 0.17812502E-28_JPRB, 0.92139520E-29_JPRB, &
  & 0.48246907E-29_JPRB, 0.25929088E-29_JPRB, 0.14517357E-29_JPRB, 0.86171090E-30_JPRB, 0.55995040E-30_JPRB, 0.40967948E-30_JPRB, &
  & 0.34674542E-30_JPRB, 0.32031464E-30_JPRB, 0.22645457E-30_JPRB, 0.79173929E-31_JPRB /)

RGHG6(:, 5, 7) = (/ &
  & 0.39079627E-30_JPRB, 0.11722619E-29_JPRB, 0.18002088E-29_JPRB, 0.22846844E-29_JPRB, 0.27682241E-29_JPRB, 0.34096999E-29_JPRB, &
  & 0.43050974E-29_JPRB, 0.57413548E-29_JPRB, 0.81085894E-29_JPRB, 0.12121254E-28_JPRB, 0.18941137E-28_JPRB, 0.30757959E-28_JPRB, &
  & 0.51734968E-28_JPRB, 0.89903060E-28_JPRB, 0.16167857E-27_JPRB, 0.30061503E-27_JPRB, 0.57724569E-27_JPRB, 0.11365382E-26_JPRB, &
  & 0.22654048E-26_JPRB, 0.45023181E-26_JPRB, 0.88249253E-26_JPRB, 0.16934594E-25_JPRB, 0.31697091E-25_JPRB, 0.57570114E-25_JPRB, &
  & 0.10099002E-24_JPRB, 0.16276138E-24_JPRB, 0.25449353E-24_JPRB, 0.37375628E-24_JPRB, 0.51235993E-24_JPRB, 0.66021771E-24_JPRB, &
  & 0.79837634E-24_JPRB, 0.91491575E-24_JPRB, 0.10085068E-23_JPRB, 0.10789761E-23_JPRB, 0.11333748E-23_JPRB, 0.11751221E-23_JPRB, &
  & 0.11986824E-23_JPRB, 0.11901991E-23_JPRB, 0.11420816E-23_JPRB, 0.10547959E-23_JPRB, 0.92862073E-24_JPRB, 0.77168090E-24_JPRB, &
  & 0.60302303E-24_JPRB, 0.44514001E-24_JPRB, 0.30983459E-24_JPRB, 0.20573162E-24_JPRB, 0.13088301E-24_JPRB, 0.79119532E-25_JPRB, &
  & 0.45409105E-25_JPRB, 0.25332462E-25_JPRB, 0.13900124E-25_JPRB, 0.74642458E-26_JPRB, 0.39364487E-26_JPRB, 0.20577993E-26_JPRB, &
  & 0.10893454E-26_JPRB, 0.59046075E-27_JPRB, 0.33299743E-27_JPRB, 0.19778255E-27_JPRB, 0.12852383E-27_JPRB, 0.93663276E-28_JPRB, &
  & 0.79522971E-28_JPRB, 0.77946995E-28_JPRB, 0.68634095E-28_JPRB, 0.73353833E-28_JPRB /)

RGHG6(:, 6, 7) = (/ &
  & 0.31550202E-27_JPRB, 0.71542019E-27_JPRB, 0.98463245E-27_JPRB, 0.12254379E-26_JPRB, 0.14748423E-26_JPRB, 0.17988929E-26_JPRB, &
  & 0.22484111E-26_JPRB, 0.29458154E-26_JPRB, 0.40785773E-26_JPRB, 0.59352516E-26_JPRB, 0.90063864E-26_JPRB, 0.14136093E-25_JPRB, &
  & 0.22888494E-25_JPRB, 0.38138713E-25_JPRB, 0.65560862E-25_JPRB, 0.11629380E-24_JPRB, 0.21294435E-24_JPRB, 0.40018159E-24_JPRB, &
  & 0.76290403E-24_JPRB, 0.14535647E-23_JPRB, 0.27377169E-23_JPRB, 0.50586321E-23_JPRB, 0.91315659E-23_JPRB, 0.16022339E-22_JPRB, &
  & 0.27207857E-22_JPRB, 0.42658316E-22_JPRB, 0.65160037E-22_JPRB, 0.94109541E-22_JPRB, 0.12756340E-21_JPRB, 0.16315451E-21_JPRB, &
  & 0.19657863E-21_JPRB, 0.22492287E-21_JPRB, 0.24851325E-21_JPRB, 0.26773808E-21_JPRB, 0.28442689E-21_JPRB, 0.29986135E-21_JPRB, &
  & 0.31228433E-21_JPRB, 0.31776229E-21_JPRB, 0.31357087E-21_JPRB, 0.29881173E-21_JPRB, 0.27227566E-21_JPRB, 0.23493007E-21_JPRB, &
  & 0.19093164E-21_JPRB, 0.14718497E-21_JPRB, 0.10704981E-21_JPRB, 0.74539543E-22_JPRB, 0.49744123E-22_JPRB, 0.31529780E-22_JPRB, &
  & 0.18914707E-22_JPRB, 0.10988749E-22_JPRB, 0.62610229E-23_JPRB, 0.34831297E-23_JPRB, 0.18989259E-23_JPRB, 0.10239111E-23_JPRB, &
  & 0.55776248E-24_JPRB, 0.30962958E-24_JPRB, 0.17743661E-24_JPRB, 0.10610899E-24_JPRB, 0.68391615E-25_JPRB, 0.48943300E-25_JPRB, &
  & 0.40211605E-25_JPRB, 0.37466280E-25_JPRB, 0.31549876E-25_JPRB, 0.26340186E-25_JPRB /)

RGHG6(:, 7, 7) = (/ &
  & 0.24826049E-24_JPRB, 0.52994694E-24_JPRB, 0.71734485E-24_JPRB, 0.88721096E-24_JPRB, 0.10571485E-23_JPRB, 0.12746115E-23_JPRB, &
  & 0.15630330E-23_JPRB, 0.20020467E-23_JPRB, 0.26784046E-23_JPRB, 0.37470917E-23_JPRB, 0.54256200E-23_JPRB, 0.80799757E-23_JPRB, &
  & 0.12341452E-22_JPRB, 0.19299607E-22_JPRB, 0.31012142E-22_JPRB, 0.51279401E-22_JPRB, 0.87457209E-22_JPRB, 0.15335666E-21_JPRB, &
  & 0.27400888E-21_JPRB, 0.49254511E-21_JPRB, 0.88189075E-21_JPRB, 0.15599102E-20_JPRB, 0.27102536E-20_JPRB, 0.45926013E-20_JPRB, &
  & 0.75495813E-20_JPRB, 0.11482218E-19_JPRB, 0.17078137E-19_JPRB, 0.24142988E-19_JPRB, 0.32213008E-19_JPRB, 0.40781555E-19_JPRB, &
  & 0.48830417E-19_JPRB, 0.55777222E-19_JPRB, 0.61799672E-19_JPRB, 0.67093828E-19_JPRB, 0.72253076E-19_JPRB, 0.77635418E-19_JPRB, &
  & 0.82888234E-19_JPRB, 0.86868854E-19_JPRB, 0.88667597E-19_JPRB, 0.87781667E-19_JPRB, 0.83479901E-19_JPRB, 0.75519347E-19_JPRB, &
  & 0.64715464E-19_JPRB, 0.52783296E-19_JPRB, 0.40803592E-19_JPRB, 0.30262328E-19_JPRB, 0.21567159E-19_JPRB, 0.14606155E-19_JPRB, &
  & 0.93569766E-20_JPRB, 0.57960776E-20_JPRB, 0.35153350E-20_JPRB, 0.20753069E-20_JPRB, 0.11966886E-20_JPRB, 0.68001355E-21_JPRB, &
  & 0.38840371E-21_JPRB, 0.22471472E-21_JPRB, 0.13280242E-21_JPRB, 0.80718236E-22_JPRB, 0.52080572E-22_JPRB, 0.36495703E-22_JPRB, &
  & 0.28995659E-22_JPRB, 0.26333054E-22_JPRB, 0.22125974E-22_JPRB, 0.24719013E-22_JPRB /)

RGHG6(:, 8, 7) = (/ &
  & 0.16327752E-21_JPRB, 0.34486096E-21_JPRB, 0.46470001E-21_JPRB, 0.57193178E-21_JPRB, 0.67604799E-21_JPRB, 0.80627325E-21_JPRB, &
  & 0.97344062E-21_JPRB, 0.12187984E-20_JPRB, 0.15816638E-20_JPRB, 0.21273318E-20_JPRB, 0.29422956E-20_JPRB, 0.41565886E-20_JPRB, &
  & 0.59847236E-20_JPRB, 0.87726058E-20_JPRB, 0.13152414E-19_JPRB, 0.20223661E-19_JPRB, 0.32031852E-19_JPRB, 0.52223008E-19_JPRB, &
  & 0.87139729E-19_JPRB, 0.14730731E-18_JPRB, 0.25020370E-18_JPRB, 0.42350293E-18_JPRB, 0.70907209E-18_JPRB, 0.11625452E-17_JPRB, &
  & 0.18538693E-17_JPRB, 0.27355673E-17_JPRB, 0.39600867E-17_JPRB, 0.54735786E-17_JPRB, 0.71809369E-17_JPRB, 0.89870014E-17_JPRB, &
  & 0.10696641E-16_JPRB, 0.12201763E-16_JPRB, 0.13566858E-16_JPRB, 0.14858310E-16_JPRB, 0.16224686E-16_JPRB, 0.17779043E-16_JPRB, &
  & 0.19470068E-16_JPRB, 0.21037464E-16_JPRB, 0.22241596E-16_JPRB, 0.22916155E-16_JPRB, 0.22789076E-16_JPRB, 0.21668003E-16_JPRB, &
  & 0.19611020E-16_JPRB, 0.16979482E-16_JPRB, 0.13972907E-16_JPRB, 0.11071504E-16_JPRB, 0.84486706E-17_JPRB, 0.61355857E-17_JPRB, &
  & 0.42158906E-17_JPRB, 0.28008803E-17_JPRB, 0.18191726E-17_JPRB, 0.11470345E-17_JPRB, 0.70379737E-18_JPRB, 0.42369416E-18_JPRB, &
  & 0.25518685E-18_JPRB, 0.15461368E-18_JPRB, 0.95018599E-19_JPRB, 0.59353763E-19_JPRB, 0.38798196E-19_JPRB, 0.27240011E-19_JPRB, &
  & 0.21482271E-19_JPRB, 0.19324474E-19_JPRB, 0.16796938E-19_JPRB, 0.20992190E-19_JPRB /)

RGHG6(:, 9, 7) = (/ &
  & 0.87164823E-19_JPRB, 0.18256941E-18_JPRB, 0.24559047E-18_JPRB, 0.30026641E-18_JPRB, 0.35416296E-18_JPRB, 0.41770509E-18_JPRB, &
  & 0.49947616E-18_JPRB, 0.61417556E-18_JPRB, 0.77768083E-18_JPRB, 0.10127362E-17_JPRB, 0.13463199E-17_JPRB, 0.18151325E-17_JPRB, &
  & 0.24774260E-17_JPRB, 0.34214409E-17_JPRB, 0.48088757E-17_JPRB, 0.69062509E-17_JPRB, 0.10197362E-16_JPRB, 0.15509810E-16_JPRB, &
  & 0.24227478E-16_JPRB, 0.38559911E-16_JPRB, 0.62137794E-16_JPRB, 0.10057439E-15_JPRB, 0.16208960E-15_JPRB, 0.25693876E-15_JPRB, &
  & 0.39726952E-15_JPRB, 0.56763786E-15_JPRB, 0.79916764E-15_JPRB, 0.10785966E-14_JPRB, 0.13892310E-14_JPRB, 0.17173517E-14_JPRB, &
  & 0.20304549E-14_JPRB, 0.23138414E-14_JPRB, 0.25841427E-14_JPRB, 0.28580734E-14_JPRB, 0.31685576E-14_JPRB, 0.35439158E-14_JPRB, &
  & 0.39830687E-14_JPRB, 0.44402903E-14_JPRB, 0.48672385E-14_JPRB, 0.52261789E-14_JPRB, 0.54436360E-14_JPRB, 0.54480939E-14_JPRB, &
  & 0.52161610E-14_JPRB, 0.47963207E-14_JPRB, 0.42059942E-14_JPRB, 0.35604581E-14_JPRB, 0.29097710E-14_JPRB, 0.22661092E-14_JPRB, &
  & 0.16705538E-14_JPRB, 0.11908975E-14_JPRB, 0.82899406E-15_JPRB, 0.55862458E-15_JPRB, 0.36489658E-15_JPRB, 0.23281291E-15_JPRB, &
  & 0.14784065E-15_JPRB, 0.93922706E-16_JPRB, 0.60084937E-16_JPRB, 0.38797993E-16_JPRB, 0.26008085E-16_JPRB, 0.18544317E-16_JPRB, &
  & 0.14763222E-16_JPRB, 0.13443723E-16_JPRB, 0.11869059E-16_JPRB, 0.15583199E-16_JPRB /)

RGHG6(:,10, 7) = (/ &
  & 0.37413147E-16_JPRB, 0.77930969E-16_JPRB, 0.10414410E-15_JPRB, 0.12765591E-15_JPRB, 0.14917502E-15_JPRB, 0.17595231E-15_JPRB, &
  & 0.20769763E-15_JPRB, 0.25288441E-15_JPRB, 0.31380517E-15_JPRB, 0.39828799E-15_JPRB, 0.51220262E-15_JPRB, 0.66322087E-15_JPRB, &
  & 0.86334585E-15_JPRB, 0.11300177E-14_JPRB, 0.14974990E-14_JPRB, 0.20197587E-14_JPRB, 0.27952032E-14_JPRB, 0.39856466E-14_JPRB, &
  & 0.58518775E-14_JPRB, 0.87955749E-14_JPRB, 0.13459799E-13_JPRB, 0.20816341E-13_JPRB, 0.32232016E-13_JPRB, 0.49229457E-13_JPRB, &
  & 0.73592438E-13_JPRB, 0.10161323E-12_JPRB, 0.13884757E-12_JPRB, 0.18279205E-12_JPRB, 0.23090438E-12_JPRB, 0.28162645E-12_JPRB, &
  & 0.33060788E-12_JPRB, 0.37629109E-12_JPRB, 0.42232613E-12_JPRB, 0.47212511E-12_JPRB, 0.53198526E-12_JPRB, 0.60788641E-12_JPRB, &
  & 0.70176319E-12_JPRB, 0.80769462E-12_JPRB, 0.91882849E-12_JPRB, 0.10293985E-11_JPRB, 0.11246830E-11_JPRB, 0.11865709E-11_JPRB, &
  & 0.12031351E-11_JPRB, 0.11763560E-11_JPRB, 0.10999183E-11_JPRB, 0.99546424E-12_JPRB, 0.87151618E-12_JPRB, 0.72796803E-12_JPRB, &
  & 0.57580736E-12_JPRB, 0.44044401E-12_JPRB, 0.32855427E-12_JPRB, 0.23657275E-12_JPRB, 0.16447702E-12_JPRB, 0.11117728E-12_JPRB, &
  & 0.74402073E-13_JPRB, 0.49510231E-13_JPRB, 0.32982541E-13_JPRB, 0.22032216E-13_JPRB, 0.15196201E-13_JPRB, 0.11087646E-13_JPRB, &
  & 0.89790981E-14_JPRB, 0.82769519E-14_JPRB, 0.74171770E-14_JPRB, 0.99020083E-14_JPRB /)

RGHG6(:,11, 7) = (/ &
  & 0.90522972E-15_JPRB, 0.16367451E-14_JPRB, 0.20807775E-14_JPRB, 0.24166358E-14_JPRB, 0.27656989E-14_JPRB, 0.31243789E-14_JPRB, &
  & 0.36341165E-14_JPRB, 0.42991725E-14_JPRB, 0.52607980E-14_JPRB, 0.65665450E-14_JPRB, 0.82856763E-14_JPRB, 0.10438669E-13_JPRB, &
  & 0.13016667E-13_JPRB, 0.15962370E-13_JPRB, 0.19233008E-13_JPRB, 0.22785903E-13_JPRB, 0.26767356E-13_JPRB, 0.31630863E-13_JPRB, &
  & 0.38253024E-13_JPRB, 0.47848945E-13_JPRB, 0.62454301E-13_JPRB, 0.84766450E-13_JPRB, 0.11806771E-12_JPRB, 0.16586119E-12_JPRB, &
  & 0.23122961E-12_JPRB, 0.32419382E-12_JPRB, 0.43783491E-12_JPRB, 0.58233041E-12_JPRB, 0.78473577E-12_JPRB, 0.10377481E-11_JPRB, &
  & 0.13242929E-11_JPRB, 0.16271964E-11_JPRB, 0.19351419E-11_JPRB, 0.22263855E-11_JPRB, 0.24928555E-11_JPRB, 0.27373796E-11_JPRB, &
  & 0.29538641E-11_JPRB, 0.31508962E-11_JPRB, 0.33270747E-11_JPRB, 0.34476215E-11_JPRB, 0.34938528E-11_JPRB, 0.34503880E-11_JPRB, &
  & 0.33181136E-11_JPRB, 0.31091707E-11_JPRB, 0.28401183E-11_JPRB, 0.25282187E-11_JPRB, 0.21684197E-11_JPRB, 0.17879462E-11_JPRB, &
  & 0.14442961E-11_JPRB, 0.11373314E-11_JPRB, 0.86843288E-12_JPRB, 0.64403284E-12_JPRB, 0.47105072E-12_JPRB, 0.34229035E-12_JPRB, &
  & 0.24959933E-12_JPRB, 0.18372047E-12_JPRB, 0.13755358E-12_JPRB, 0.10680499E-12_JPRB, 0.87396243E-13_JPRB, 0.77294846E-13_JPRB, &
  & 0.72722773E-13_JPRB, 0.76464158E-13_JPRB, 0.80096493E-13_JPRB, 0.10995147E-12_JPRB /)

RGHG6(:,12, 7) = (/ &
  & 0.12955975E-13_JPRB, 0.20624107E-13_JPRB, 0.24488793E-13_JPRB, 0.27476426E-13_JPRB, 0.29992275E-13_JPRB, 0.33137664E-13_JPRB, &
  & 0.37049557E-13_JPRB, 0.43085435E-13_JPRB, 0.51656643E-13_JPRB, 0.63875385E-13_JPRB, 0.80133830E-13_JPRB, 0.10047272E-12_JPRB, &
  & 0.12429256E-12_JPRB, 0.15017882E-12_JPRB, 0.17585900E-12_JPRB, 0.19891459E-12_JPRB, 0.21685748E-12_JPRB, 0.22936053E-12_JPRB, &
  & 0.23882721E-12_JPRB, 0.25010641E-12_JPRB, 0.27070509E-12_JPRB, 0.30955541E-12_JPRB, 0.37570324E-12_JPRB, 0.47912575E-12_JPRB, &
  & 0.63377808E-12_JPRB, 0.84848426E-12_JPRB, 0.11601103E-11_JPRB, 0.15953504E-11_JPRB, 0.21625401E-11_JPRB, 0.29286610E-11_JPRB, &
  & 0.39575409E-11_JPRB, 0.51807647E-11_JPRB, 0.64232725E-11_JPRB, 0.75870664E-11_JPRB, 0.86283064E-11_JPRB, 0.94191113E-11_JPRB, &
  & 0.99196207E-11_JPRB, 0.10127560E-10_JPRB, 0.10035312E-10_JPRB, 0.97463522E-11_JPRB, 0.92972149E-11_JPRB, 0.86861603E-11_JPRB, &
  & 0.79683959E-11_JPRB, 0.71848083E-11_JPRB, 0.63589910E-11_JPRB, 0.55073376E-11_JPRB, 0.46950490E-11_JPRB, 0.39376740E-11_JPRB, &
  & 0.32212167E-11_JPRB, 0.25804595E-11_JPRB, 0.20504527E-11_JPRB, 0.16210687E-11_JPRB, 0.12854226E-11_JPRB, 0.10231748E-11_JPRB, &
  & 0.82544789E-12_JPRB, 0.67979617E-12_JPRB, 0.57774586E-12_JPRB, 0.51238733E-12_JPRB, 0.47724520E-12_JPRB, 0.47349884E-12_JPRB, &
  & 0.49407727E-12_JPRB, 0.54185600E-12_JPRB, 0.65273752E-12_JPRB, 0.84306948E-12_JPRB /)

RGHG6(:,13, 7) = (/ &
  & 0.12529620E-12_JPRB, 0.17430427E-12_JPRB, 0.19592186E-12_JPRB, 0.20888194E-12_JPRB, 0.21975716E-12_JPRB, 0.23163364E-12_JPRB, &
  & 0.25057818E-12_JPRB, 0.28006579E-12_JPRB, 0.32702717E-12_JPRB, 0.39559285E-12_JPRB, 0.48921961E-12_JPRB, 0.60821964E-12_JPRB, &
  & 0.74707287E-12_JPRB, 0.89698577E-12_JPRB, 0.10415273E-11_JPRB, 0.11614640E-11_JPRB, 0.12381933E-11_JPRB, 0.12636601E-11_JPRB, &
  & 0.12472788E-11_JPRB, 0.12092896E-11_JPRB, 0.11809834E-11_JPRB, 0.11929054E-11_JPRB, 0.12704337E-11_JPRB, 0.14347220E-11_JPRB, &
  & 0.17106883E-11_JPRB, 0.21375939E-11_JPRB, 0.27723954E-11_JPRB, 0.37156875E-11_JPRB, 0.50937709E-11_JPRB, 0.70233840E-11_JPRB, &
  & 0.95576247E-11_JPRB, 0.12509210E-10_JPRB, 0.15650198E-10_JPRB, 0.18616273E-10_JPRB, 0.20982733E-10_JPRB, 0.22626493E-10_JPRB, &
  & 0.23466592E-10_JPRB, 0.23466328E-10_JPRB, 0.22795545E-10_JPRB, 0.21596185E-10_JPRB, 0.20046713E-10_JPRB, 0.18258093E-10_JPRB, &
  & 0.16352045E-10_JPRB, 0.14423553E-10_JPRB, 0.12571600E-10_JPRB, 0.10855110E-10_JPRB, 0.92715471E-11_JPRB, 0.77891704E-11_JPRB, &
  & 0.65128129E-11_JPRB, 0.54651045E-11_JPRB, 0.46055321E-11_JPRB, 0.38989571E-11_JPRB, 0.33366727E-11_JPRB, 0.28925850E-11_JPRB, &
  & 0.25604438E-11_JPRB, 0.23243219E-11_JPRB, 0.21712855E-11_JPRB, 0.20954456E-11_JPRB, 0.20984458E-11_JPRB, 0.21815464E-11_JPRB, &
  & 0.23584992E-11_JPRB, 0.25938778E-11_JPRB, 0.31231805E-11_JPRB, 0.40503781E-11_JPRB /)

RGHG6(:,14, 7) = (/ &
  & 0.84641490E-12_JPRB, 0.10334932E-11_JPRB, 0.10945542E-11_JPRB, 0.11145593E-11_JPRB, 0.11196205E-11_JPRB, 0.11291821E-11_JPRB, &
  & 0.11619266E-11_JPRB, 0.12395171E-11_JPRB, 0.13811155E-11_JPRB, 0.16049963E-11_JPRB, 0.19188830E-11_JPRB, 0.23201024E-11_JPRB, &
  & 0.27856005E-11_JPRB, 0.32764538E-11_JPRB, 0.37417083E-11_JPRB, 0.41148474E-11_JPRB, 0.43393813E-11_JPRB, 0.44050570E-11_JPRB, &
  & 0.43472925E-11_JPRB, 0.42178886E-11_JPRB, 0.40867136E-11_JPRB, 0.40204229E-11_JPRB, 0.40749036E-11_JPRB, 0.42998569E-11_JPRB, &
  & 0.47545817E-11_JPRB, 0.55152831E-11_JPRB, 0.67216328E-11_JPRB, 0.85600606E-11_JPRB, 0.11258728E-10_JPRB, 0.14896546E-10_JPRB, &
  & 0.19357389E-10_JPRB, 0.24662064E-10_JPRB, 0.30205071E-10_JPRB, 0.35325950E-10_JPRB, 0.39518017E-10_JPRB, 0.42360546E-10_JPRB, &
  & 0.43488421E-10_JPRB, 0.43093713E-10_JPRB, 0.41464672E-10_JPRB, 0.38987768E-10_JPRB, 0.35954406E-10_JPRB, 0.32564645E-10_JPRB, &
  & 0.29087253E-10_JPRB, 0.25697416E-10_JPRB, 0.22510003E-10_JPRB, 0.19564661E-10_JPRB, 0.16944373E-10_JPRB, 0.14681242E-10_JPRB, &
  & 0.12770545E-10_JPRB, 0.11180902E-10_JPRB, 0.98940812E-11_JPRB, 0.88602944E-11_JPRB, 0.80663870E-11_JPRB, 0.74633485E-11_JPRB, &
  & 0.70423251E-11_JPRB, 0.67752236E-11_JPRB, 0.66489266E-11_JPRB, 0.66670111E-11_JPRB, 0.68490968E-11_JPRB, 0.71974909E-11_JPRB, &
  & 0.77638816E-11_JPRB, 0.84527073E-11_JPRB, 0.98043561E-11_JPRB, 0.12232691E-10_JPRB /)

RGHG6(:,15, 7) = (/ &
  & 0.39630417E-11_JPRB, 0.42648801E-11_JPRB, 0.42770106E-11_JPRB, 0.41769726E-11_JPRB, 0.40427930E-11_JPRB, 0.39198167E-11_JPRB, &
  & 0.38607329E-11_JPRB, 0.39205475E-11_JPRB, 0.41482937E-11_JPRB, 0.45828931E-11_JPRB, 0.52357940E-11_JPRB, 0.60886947E-11_JPRB, &
  & 0.70870350E-11_JPRB, 0.81350395E-11_JPRB, 0.91426693E-11_JPRB, 0.10016479E-10_JPRB, 0.10688531E-10_JPRB, 0.11123703E-10_JPRB, &
  & 0.11344130E-10_JPRB, 0.11419575E-10_JPRB, 0.11451098E-10_JPRB, 0.11533988E-10_JPRB, 0.11762730E-10_JPRB, 0.12238666E-10_JPRB, &
  & 0.13085015E-10_JPRB, 0.14448233E-10_JPRB, 0.16538951E-10_JPRB, 0.19597050E-10_JPRB, 0.23840093E-10_JPRB, 0.29512715E-10_JPRB, &
  & 0.36587677E-10_JPRB, 0.44412057E-10_JPRB, 0.52279278E-10_JPRB, 0.59196655E-10_JPRB, 0.64511577E-10_JPRB, 0.67491374E-10_JPRB, &
  & 0.68463971E-10_JPRB, 0.67539772E-10_JPRB, 0.65070491E-10_JPRB, 0.61437667E-10_JPRB, 0.57092938E-10_JPRB, 0.52272235E-10_JPRB, &
  & 0.47303630E-10_JPRB, 0.42408646E-10_JPRB, 0.37761558E-10_JPRB, 0.33545902E-10_JPRB, 0.29842517E-10_JPRB, 0.26598803E-10_JPRB, &
  & 0.23869061E-10_JPRB, 0.21669418E-10_JPRB, 0.19957425E-10_JPRB, 0.18632143E-10_JPRB, 0.17659575E-10_JPRB, 0.16954644E-10_JPRB, &
  & 0.16508395E-10_JPRB, 0.16285830E-10_JPRB, 0.16282328E-10_JPRB, 0.16516358E-10_JPRB, 0.17035724E-10_JPRB, 0.17850121E-10_JPRB, &
  & 0.19015045E-10_JPRB, 0.20425075E-10_JPRB, 0.22833622E-10_JPRB, 0.27262120E-10_JPRB /)

RGHG6(:,16, 7) = (/ &
  & 0.12684827E-10_JPRB, 0.12412796E-10_JPRB, 0.11921282E-10_JPRB, 0.11344812E-10_JPRB, 0.10715366E-10_JPRB, 0.10140637E-10_JPRB, &
  & 0.96953227E-11_JPRB, 0.95009512E-11_JPRB, 0.96520925E-11_JPRB, 0.10224662E-10_JPRB, 0.11251729E-10_JPRB, 0.12715576E-10_JPRB, &
  & 0.14558478E-10_JPRB, 0.16669862E-10_JPRB, 0.18878021E-10_JPRB, 0.21036469E-10_JPRB, 0.22982609E-10_JPRB, 0.24657804E-10_JPRB, &
  & 0.26083193E-10_JPRB, 0.27309868E-10_JPRB, 0.28441444E-10_JPRB, 0.29599743E-10_JPRB, 0.30924908E-10_JPRB, 0.32584251E-10_JPRB, &
  & 0.34785411E-10_JPRB, 0.37731918E-10_JPRB, 0.41676090E-10_JPRB, 0.46849247E-10_JPRB, 0.53358009E-10_JPRB, 0.61159335E-10_JPRB, &
  & 0.69695014E-10_JPRB, 0.78288646E-10_JPRB, 0.86326793E-10_JPRB, 0.92601780E-10_JPRB, 0.96763507E-10_JPRB, 0.98789858E-10_JPRB, &
  & 0.98586077E-10_JPRB, 0.96538409E-10_JPRB, 0.93285046E-10_JPRB, 0.89126047E-10_JPRB, 0.84287209E-10_JPRB, 0.78821533E-10_JPRB, &
  & 0.73018092E-10_JPRB, 0.67115251E-10_JPRB, 0.61416143E-10_JPRB, 0.56089262E-10_JPRB, 0.51288668E-10_JPRB, 0.47053170E-10_JPRB, &
  & 0.43488883E-10_JPRB, 0.40589976E-10_JPRB, 0.38288022E-10_JPRB, 0.36454537E-10_JPRB, 0.35066939E-10_JPRB, 0.34029973E-10_JPRB, &
  & 0.33363732E-10_JPRB, 0.33044959E-10_JPRB, 0.33079837E-10_JPRB, 0.33501084E-10_JPRB, 0.34367821E-10_JPRB, 0.35693122E-10_JPRB, &
  & 0.37467345E-10_JPRB, 0.39675135E-10_JPRB, 0.42997959E-10_JPRB, 0.49331206E-10_JPRB /)

RGHG6(:,17, 7) = (/ &
  & 0.28588378E-10_JPRB, 0.26932505E-10_JPRB, 0.25317522E-10_JPRB, 0.23853811E-10_JPRB, 0.22347351E-10_JPRB, 0.20917382E-10_JPRB, &
  & 0.19728292E-10_JPRB, 0.18952392E-10_JPRB, 0.18777199E-10_JPRB, 0.19344047E-10_JPRB, 0.20754433E-10_JPRB, 0.23020592E-10_JPRB, &
  & 0.26094217E-10_JPRB, 0.29897137E-10_JPRB, 0.34288211E-10_JPRB, 0.38991130E-10_JPRB, 0.43806115E-10_JPRB, 0.48508697E-10_JPRB, &
  & 0.52994470E-10_JPRB, 0.57252966E-10_JPRB, 0.61409322E-10_JPRB, 0.65652123E-10_JPRB, 0.70216305E-10_JPRB, 0.75370994E-10_JPRB, &
  & 0.81357629E-10_JPRB, 0.88254785E-10_JPRB, 0.96025826E-10_JPRB, 0.10424075E-09_JPRB, 0.11230550E-09_JPRB, 0.11962922E-09_JPRB, &
  & 0.12605909E-09_JPRB, 0.13110635E-09_JPRB, 0.13457051E-09_JPRB, 0.13603672E-09_JPRB, 0.13567038E-09_JPRB, 0.13384034E-09_JPRB, &
  & 0.13122781E-09_JPRB, 0.12853985E-09_JPRB, 0.12549917E-09_JPRB, 0.12205408E-09_JPRB, 0.11810813E-09_JPRB, 0.11346207E-09_JPRB, &
  & 0.10818173E-09_JPRB, 0.10242820E-09_JPRB, 0.96448863E-10_JPRB, 0.90513430E-10_JPRB, 0.84861437E-10_JPRB, 0.79638574E-10_JPRB, &
  & 0.74983957E-10_JPRB, 0.70951620E-10_JPRB, 0.67519025E-10_JPRB, 0.64593844E-10_JPRB, 0.62207517E-10_JPRB, 0.60289440E-10_JPRB, &
  & 0.58915921E-10_JPRB, 0.58090054E-10_JPRB, 0.57830678E-10_JPRB, 0.58169046E-10_JPRB, 0.59153286E-10_JPRB, 0.60761993E-10_JPRB, &
  & 0.62919232E-10_JPRB, 0.65673980E-10_JPRB, 0.69470714E-10_JPRB, 0.77002876E-10_JPRB /)

RGHG6(:,18, 7) = (/ &
  & 0.50280377E-10_JPRB, 0.46830931E-10_JPRB, 0.43898440E-10_JPRB, 0.41455103E-10_JPRB, 0.38928288E-10_JPRB, 0.36502995E-10_JPRB, &
  & 0.34350089E-10_JPRB, 0.32765696E-10_JPRB, 0.32063931E-10_JPRB, 0.32510526E-10_JPRB, 0.34315144E-10_JPRB, 0.37591298E-10_JPRB, &
  & 0.42375974E-10_JPRB, 0.48590420E-10_JPRB, 0.56118266E-10_JPRB, 0.64683384E-10_JPRB, 0.73788822E-10_JPRB, 0.83031262E-10_JPRB, &
  & 0.92167121E-10_JPRB, 0.10115354E-09_JPRB, 0.11012816E-09_JPRB, 0.11934150E-09_JPRB, 0.12915244E-09_JPRB, 0.13990764E-09_JPRB, &
  & 0.15161385E-09_JPRB, 0.16357472E-09_JPRB, 0.17483370E-09_JPRB, 0.18452874E-09_JPRB, 0.19172219E-09_JPRB, 0.19600130E-09_JPRB, &
  & 0.19698314E-09_JPRB, 0.19524188E-09_JPRB, 0.19124069E-09_JPRB, 0.18552412E-09_JPRB, 0.17908068E-09_JPRB, 0.17301972E-09_JPRB, &
  & 0.16788398E-09_JPRB, 0.16380536E-09_JPRB, 0.16121512E-09_JPRB, 0.15944253E-09_JPRB, 0.15775481E-09_JPRB, 0.15535950E-09_JPRB, &
  & 0.15198037E-09_JPRB, 0.14755724E-09_JPRB, 0.14228951E-09_JPRB, 0.13641938E-09_JPRB, 0.13026771E-09_JPRB, 0.12405572E-09_JPRB, &
  & 0.11803562E-09_JPRB, 0.11236602E-09_JPRB, 0.10716506E-09_JPRB, 0.10245708E-09_JPRB, 0.98381497E-10_JPRB, 0.94955196E-10_JPRB, &
  & 0.92326501E-10_JPRB, 0.90520050E-10_JPRB, 0.89540375E-10_JPRB, 0.89396754E-10_JPRB, 0.90107484E-10_JPRB, 0.91602954E-10_JPRB, &
  & 0.93751611E-10_JPRB, 0.96545355E-10_JPRB, 0.10034863E-09_JPRB, 0.10802383E-09_JPRB /)

RGHG6(:,19, 7) = (/ &
  & 0.75499433E-10_JPRB, 0.70511465E-10_JPRB, 0.66589151E-10_JPRB, 0.63197773E-10_JPRB, 0.59787730E-10_JPRB, 0.56412028E-10_JPRB, &
  & 0.53293859E-10_JPRB, 0.50841484E-10_JPRB, 0.49508859E-10_JPRB, 0.49738717E-10_JPRB, 0.51860290E-10_JPRB, 0.56099420E-10_JPRB, &
  & 0.62564211E-10_JPRB, 0.71293686E-10_JPRB, 0.82099320E-10_JPRB, 0.94567340E-10_JPRB, 0.10803851E-09_JPRB, 0.12174477E-09_JPRB, &
  & 0.13518046E-09_JPRB, 0.14825896E-09_JPRB, 0.16126107E-09_JPRB, 0.17454635E-09_JPRB, 0.18845231E-09_JPRB, 0.20327887E-09_JPRB, &
  & 0.21875551E-09_JPRB, 0.23399380E-09_JPRB, 0.24771765E-09_JPRB, 0.25812791E-09_JPRB, 0.26418862E-09_JPRB, 0.26537297E-09_JPRB, &
  & 0.26212144E-09_JPRB, 0.25497024E-09_JPRB, 0.24510730E-09_JPRB, 0.23352076E-09_JPRB, 0.22161477E-09_JPRB, 0.21137253E-09_JPRB, &
  & 0.20392951E-09_JPRB, 0.19979399E-09_JPRB, 0.19852875E-09_JPRB, 0.19905681E-09_JPRB, 0.20010812E-09_JPRB, 0.20053392E-09_JPRB, &
  & 0.19965327E-09_JPRB, 0.19716648E-09_JPRB, 0.19316891E-09_JPRB, 0.18786923E-09_JPRB, 0.18162324E-09_JPRB, 0.17469005E-09_JPRB, &
  & 0.16740688E-09_JPRB, 0.16007601E-09_JPRB, 0.15297692E-09_JPRB, 0.14627410E-09_JPRB, 0.14023326E-09_JPRB, 0.13501469E-09_JPRB, &
  & 0.13084334E-09_JPRB, 0.12776133E-09_JPRB, 0.12575087E-09_JPRB, 0.12478472E-09_JPRB, 0.12484258E-09_JPRB, 0.12581636E-09_JPRB, &
  & 0.12753239E-09_JPRB, 0.12992409E-09_JPRB, 0.13328691E-09_JPRB, 0.14018953E-09_JPRB /)

RGHG6(:,20, 7) = (/ &
  & 0.10293250E-09_JPRB, 0.96558983E-10_JPRB, 0.92021772E-10_JPRB, 0.87949079E-10_JPRB, 0.83889527E-10_JPRB, 0.79761781E-10_JPRB, &
  & 0.75835803E-10_JPRB, 0.72547912E-10_JPRB, 0.70537062E-10_JPRB, 0.70412634E-10_JPRB, 0.72633503E-10_JPRB, 0.77500353E-10_JPRB, &
  & 0.85196294E-10_JPRB, 0.95686348E-10_JPRB, 0.10879994E-09_JPRB, 0.12394538E-09_JPRB, 0.14021977E-09_JPRB, 0.15668684E-09_JPRB, &
  & 0.17273807E-09_JPRB, 0.18816723E-09_JPRB, 0.20326861E-09_JPRB, 0.21857041E-09_JPRB, 0.23449204E-09_JPRB, 0.25121905E-09_JPRB, &
  & 0.26850680E-09_JPRB, 0.28534083E-09_JPRB, 0.30001507E-09_JPRB, 0.31080899E-09_JPRB, 0.31660219E-09_JPRB, 0.31707720E-09_JPRB, &
  & 0.31256056E-09_JPRB, 0.30359534E-09_JPRB, 0.29135203E-09_JPRB, 0.27729141E-09_JPRB, 0.26302902E-09_JPRB, 0.25092067E-09_JPRB, &
  & 0.24232361E-09_JPRB, 0.23801205E-09_JPRB, 0.23730742E-09_JPRB, 0.23916213E-09_JPRB, 0.24208824E-09_JPRB, 0.24449431E-09_JPRB, &
  & 0.24549565E-09_JPRB, 0.24467103E-09_JPRB, 0.24192037E-09_JPRB, 0.23734953E-09_JPRB, 0.23129265E-09_JPRB, 0.22401793E-09_JPRB, &
  & 0.21594555E-09_JPRB, 0.20748929E-09_JPRB, 0.19902646E-09_JPRB, 0.19078260E-09_JPRB, 0.18318180E-09_JPRB, 0.17646580E-09_JPRB, &
  & 0.17090759E-09_JPRB, 0.16657942E-09_JPRB, 0.16346793E-09_JPRB, 0.16153139E-09_JPRB, 0.16072035E-09_JPRB, 0.16090328E-09_JPRB, &
  & 0.16189455E-09_JPRB, 0.16360191E-09_JPRB, 0.16623355E-09_JPRB, 0.17177336E-09_JPRB /)

RGHG6(:,21, 7) = (/ &
  & 0.13153481E-09_JPRB, 0.12417900E-09_JPRB, 0.11930498E-09_JPRB, 0.11483416E-09_JPRB, 0.11030792E-09_JPRB, 0.10565467E-09_JPRB, &
  & 0.10103626E-09_JPRB, 0.97024187E-10_JPRB, 0.94326526E-10_JPRB, 0.93703094E-10_JPRB, 0.95696839E-10_JPRB, 0.10066248E-09_JPRB, &
  & 0.10875639E-09_JPRB, 0.11996126E-09_JPRB, 0.13394974E-09_JPRB, 0.15010804E-09_JPRB, 0.16745348E-09_JPRB, 0.18494815E-09_JPRB, &
  & 0.20191343E-09_JPRB, 0.21823962E-09_JPRB, 0.23412289E-09_JPRB, 0.25006638E-09_JPRB, 0.26661687E-09_JPRB, 0.28403002E-09_JPRB, &
  & 0.30200706E-09_JPRB, 0.31947414E-09_JPRB, 0.33480732E-09_JPRB, 0.34623943E-09_JPRB, 0.35272527E-09_JPRB, 0.35403053E-09_JPRB, &
  & 0.35033249E-09_JPRB, 0.34212194E-09_JPRB, 0.33035552E-09_JPRB, 0.31635639E-09_JPRB, 0.30211006E-09_JPRB, 0.28984998E-09_JPRB, &
  & 0.28102173E-09_JPRB, 0.27653602E-09_JPRB, 0.27631800E-09_JPRB, 0.27868466E-09_JPRB, 0.28215780E-09_JPRB, 0.28526725E-09_JPRB, &
  & 0.28698949E-09_JPRB, 0.28676533E-09_JPRB, 0.28449498E-09_JPRB, 0.28032193E-09_JPRB, 0.27448305E-09_JPRB, 0.26721197E-09_JPRB, &
  & 0.25892635E-09_JPRB, 0.25005006E-09_JPRB, 0.24093624E-09_JPRB, 0.23192473E-09_JPRB, 0.22347316E-09_JPRB, 0.21586914E-09_JPRB, &
  & 0.20939091E-09_JPRB, 0.20412871E-09_JPRB, 0.20008968E-09_JPRB, 0.19724311E-09_JPRB, 0.19554769E-09_JPRB, 0.19487202E-09_JPRB, &
  & 0.19503227E-09_JPRB, 0.19591044E-09_JPRB, 0.19762961E-09_JPRB, 0.20169877E-09_JPRB /)

RGHG6(:,22, 7) = (/ &
  & 0.16088156E-09_JPRB, 0.15296778E-09_JPRB, 0.14778866E-09_JPRB, 0.14308635E-09_JPRB, 0.13828472E-09_JPRB, 0.13322007E-09_JPRB, &
  & 0.12811062E-09_JPRB, 0.12344775E-09_JPRB, 0.12011465E-09_JPRB, 0.11888615E-09_JPRB, 0.12038680E-09_JPRB, 0.12498329E-09_JPRB, &
  & 0.13280949E-09_JPRB, 0.14376556E-09_JPRB, 0.15752330E-09_JPRB, 0.17339147E-09_JPRB, 0.19044868E-09_JPRB, 0.20775881E-09_JPRB, &
  & 0.22465570E-09_JPRB, 0.24095867E-09_JPRB, 0.25694619E-09_JPRB, 0.27301739E-09_JPRB, 0.28963401E-09_JPRB, 0.30713745E-09_JPRB, &
  & 0.32521283E-09_JPRB, 0.34298739E-09_JPRB, 0.35868200E-09_JPRB, 0.37084219E-09_JPRB, 0.37852613E-09_JPRB, 0.38139364E-09_JPRB, &
  & 0.37954340E-09_JPRB, 0.37347905E-09_JPRB, 0.36392334E-09_JPRB, 0.35218276E-09_JPRB, 0.33991465E-09_JPRB, 0.32898420E-09_JPRB, &
  & 0.32103495E-09_JPRB, 0.31684919E-09_JPRB, 0.31593053E-09_JPRB, 0.31761571E-09_JPRB, 0.32031933E-09_JPRB, 0.32276598E-09_JPRB, &
  & 0.32398845E-09_JPRB, 0.32353126E-09_JPRB, 0.32115066E-09_JPRB, 0.31685585E-09_JPRB, 0.31089137E-09_JPRB, 0.30352670E-09_JPRB, &
  & 0.29518579E-09_JPRB, 0.28619607E-09_JPRB, 0.27694530E-09_JPRB, 0.26777736E-09_JPRB, 0.25911309E-09_JPRB, 0.25122970E-09_JPRB, &
  & 0.24435790E-09_JPRB, 0.23857921E-09_JPRB, 0.23391192E-09_JPRB, 0.23035515E-09_JPRB, 0.22789412E-09_JPRB, 0.22643466E-09_JPRB, &
  & 0.22581553E-09_JPRB, 0.22590753E-09_JPRB, 0.22672901E-09_JPRB, 0.22926346E-09_JPRB /)

RGHG6(:,23, 7) = (/ &
  & 0.19013989E-09_JPRB, 0.18186395E-09_JPRB, 0.17673871E-09_JPRB, 0.17195612E-09_JPRB, 0.16704067E-09_JPRB, 0.16181551E-09_JPRB, &
  & 0.15638156E-09_JPRB, 0.15134764E-09_JPRB, 0.14751510E-09_JPRB, 0.14575041E-09_JPRB, 0.14669245E-09_JPRB, 0.15071708E-09_JPRB, &
  & 0.15791292E-09_JPRB, 0.16814336E-09_JPRB, 0.18102760E-09_JPRB, 0.19592690E-09_JPRB, 0.21199896E-09_JPRB, 0.22843824E-09_JPRB, &
  & 0.24469485E-09_JPRB, 0.26060912E-09_JPRB, 0.27634298E-09_JPRB, 0.29228028E-09_JPRB, 0.30875169E-09_JPRB, 0.32595510E-09_JPRB, &
  & 0.34377895E-09_JPRB, 0.36126585E-09_JPRB, 0.37707534E-09_JPRB, 0.38972878E-09_JPRB, 0.39833317E-09_JPRB, 0.40273726E-09_JPRB, &
  & 0.40307499E-09_JPRB, 0.39973633E-09_JPRB, 0.39333006E-09_JPRB, 0.38498224E-09_JPRB, 0.37580258E-09_JPRB, 0.36745421E-09_JPRB, &
  & 0.36096443E-09_JPRB, 0.35697659E-09_JPRB, 0.35544567E-09_JPRB, 0.35558381E-09_JPRB, 0.35643086E-09_JPRB, 0.35701625E-09_JPRB, &
  & 0.35666398E-09_JPRB, 0.35488434E-09_JPRB, 0.35155232E-09_JPRB, 0.34671849E-09_JPRB, 0.34049399E-09_JPRB, 0.33306558E-09_JPRB, &
  & 0.32475478E-09_JPRB, 0.31592706E-09_JPRB, 0.30693847E-09_JPRB, 0.29807484E-09_JPRB, 0.28969060E-09_JPRB, 0.28197897E-09_JPRB, &
  & 0.27511937E-09_JPRB, 0.26918723E-09_JPRB, 0.26420588E-09_JPRB, 0.26018737E-09_JPRB, 0.25714886E-09_JPRB, 0.25503066E-09_JPRB, &
  & 0.25372232E-09_JPRB, 0.25310276E-09_JPRB, 0.25313768E-09_JPRB, 0.25439609E-09_JPRB /)

RGHG6(:,24, 7) = (/ &
  & 0.21823746E-09_JPRB, 0.21041882E-09_JPRB, 0.20534742E-09_JPRB, 0.20073770E-09_JPRB, 0.19595747E-09_JPRB, 0.19081686E-09_JPRB, &
  & 0.18544724E-09_JPRB, 0.18034310E-09_JPRB, 0.17635064E-09_JPRB, 0.17432036E-09_JPRB, 0.17490551E-09_JPRB, 0.17847036E-09_JPRB, &
  & 0.18508875E-09_JPRB, 0.19456968E-09_JPRB, 0.20651711E-09_JPRB, 0.22033569E-09_JPRB, 0.23528465E-09_JPRB, 0.25069744E-09_JPRB, &
  & 0.26612104E-09_JPRB, 0.28138147E-09_JPRB, 0.29658376E-09_JPRB, 0.31195682E-09_JPRB, 0.32781183E-09_JPRB, 0.34429354E-09_JPRB, &
  & 0.36113723E-09_JPRB, 0.37764641E-09_JPRB, 0.39266196E-09_JPRB, 0.40511636E-09_JPRB, 0.41439638E-09_JPRB, 0.42015480E-09_JPRB, &
  & 0.42253870E-09_JPRB, 0.42192375E-09_JPRB, 0.41885359E-09_JPRB, 0.41405648E-09_JPRB, 0.40841652E-09_JPRB, 0.40293066E-09_JPRB, &
  & 0.39825829E-09_JPRB, 0.39480516E-09_JPRB, 0.39237655E-09_JPRB, 0.39081191E-09_JPRB, 0.38945125E-09_JPRB, 0.38778969E-09_JPRB, &
  & 0.38535289E-09_JPRB, 0.38189546E-09_JPRB, 0.37721598E-09_JPRB, 0.37135561E-09_JPRB, 0.36453385E-09_JPRB, 0.35690562E-09_JPRB, &
  & 0.34874839E-09_JPRB, 0.34032430E-09_JPRB, 0.33186678E-09_JPRB, 0.32360095E-09_JPRB, 0.31574263E-09_JPRB, 0.30844066E-09_JPRB, &
  & 0.30184244E-09_JPRB, 0.29600289E-09_JPRB, 0.29095229E-09_JPRB, 0.28671526E-09_JPRB, 0.28332039E-09_JPRB, 0.28074584E-09_JPRB, &
  & 0.27891098E-09_JPRB, 0.27770480E-09_JPRB, 0.27702302E-09_JPRB, 0.27700972E-09_JPRB /)

RGHG6(:,25, 7) = (/ &
  & 0.24494490E-09_JPRB, 0.23753841E-09_JPRB, 0.23297636E-09_JPRB, 0.22872579E-09_JPRB, 0.22437530E-09_JPRB, 0.21968369E-09_JPRB, &
  & 0.21475144E-09_JPRB, 0.21003997E-09_JPRB, 0.20635178E-09_JPRB, 0.20451178E-09_JPRB, 0.20515445E-09_JPRB, 0.20863450E-09_JPRB, &
  & 0.21501051E-09_JPRB, 0.22406663E-09_JPRB, 0.23538874E-09_JPRB, 0.24839072E-09_JPRB, 0.26242336E-09_JPRB, 0.27689542E-09_JPRB, &
  & 0.29143049E-09_JPRB, 0.30586902E-09_JPRB, 0.32022829E-09_JPRB, 0.33465841E-09_JPRB, 0.34926564E-09_JPRB, 0.36419565E-09_JPRB, &
  & 0.37925518E-09_JPRB, 0.39390660E-09_JPRB, 0.40746426E-09_JPRB, 0.41908052E-09_JPRB, 0.42820142E-09_JPRB, 0.43476370E-09_JPRB, &
  & 0.43878021E-09_JPRB, 0.44048398E-09_JPRB, 0.44029086E-09_JPRB, 0.43861281E-09_JPRB, 0.43602202E-09_JPRB, 0.43295101E-09_JPRB, &
  & 0.42984449E-09_JPRB, 0.42686296E-09_JPRB, 0.42385145E-09_JPRB, 0.42090445E-09_JPRB, 0.41767331E-09_JPRB, 0.41395851E-09_JPRB, &
  & 0.40962181E-09_JPRB, 0.40456077E-09_JPRB, 0.39876485E-09_JPRB, 0.39219800E-09_JPRB, 0.38492801E-09_JPRB, 0.37711922E-09_JPRB, &
  & 0.36907050E-09_JPRB, 0.36097275E-09_JPRB, 0.35301989E-09_JPRB, 0.34531930E-09_JPRB, 0.33803055E-09_JPRB, 0.33125164E-09_JPRB, &
  & 0.32504613E-09_JPRB, 0.31945230E-09_JPRB, 0.31449357E-09_JPRB, 0.31020386E-09_JPRB, 0.30662928E-09_JPRB, 0.30377201E-09_JPRB, &
  & 0.30158512E-09_JPRB, 0.29996711E-09_JPRB, 0.29876884E-09_JPRB, 0.29775216E-09_JPRB /)

RGHG6(:,26, 7) = (/ &
  & 0.26950581E-09_JPRB, 0.26309363E-09_JPRB, 0.25911034E-09_JPRB, 0.25548691E-09_JPRB, 0.25177999E-09_JPRB, 0.24783453E-09_JPRB, &
  & 0.24369246E-09_JPRB, 0.23981631E-09_JPRB, 0.23689700E-09_JPRB, 0.23572172E-09_JPRB, 0.23688290E-09_JPRB, 0.24071695E-09_JPRB, &
  & 0.24725780E-09_JPRB, 0.25628874E-09_JPRB, 0.26735950E-09_JPRB, 0.27991059E-09_JPRB, 0.29328728E-09_JPRB, 0.30698083E-09_JPRB, &
  & 0.32060787E-09_JPRB, 0.33397987E-09_JPRB, 0.34703973E-09_JPRB, 0.35991732E-09_JPRB, 0.37270070E-09_JPRB, 0.38535922E-09_JPRB, &
  & 0.39795783E-09_JPRB, 0.41013609E-09_JPRB, 0.42151838E-09_JPRB, 0.43175349E-09_JPRB, 0.44045473E-09_JPRB, 0.44730994E-09_JPRB, &
  & 0.45237694E-09_JPRB, 0.45577533E-09_JPRB, 0.45769069E-09_JPRB, 0.45830864E-09_JPRB, 0.45789858E-09_JPRB, 0.45662191E-09_JPRB, &
  & 0.45464005E-09_JPRB, 0.45200460E-09_JPRB, 0.44871673E-09_JPRB, 0.44475468E-09_JPRB, 0.44023407E-09_JPRB, 0.43500428E-09_JPRB, &
  & 0.42923426E-09_JPRB, 0.42285508E-09_JPRB, 0.41599033E-09_JPRB, 0.40868903E-09_JPRB, 0.40113537E-09_JPRB, 0.39346029E-09_JPRB, &
  & 0.38578485E-09_JPRB, 0.37824457E-09_JPRB, 0.37092632E-09_JPRB, 0.36392986E-09_JPRB, 0.35733280E-09_JPRB, 0.35115896E-09_JPRB, &
  & 0.34544018E-09_JPRB, 0.34019509E-09_JPRB, 0.33544700E-09_JPRB, 0.33124242E-09_JPRB, 0.32763617E-09_JPRB, 0.32464945E-09_JPRB, &
  & 0.32225927E-09_JPRB, 0.32038006E-09_JPRB, 0.31884140E-09_JPRB, 0.31721703E-09_JPRB /)

RGHG6(:,27, 7) = (/ &
  & 0.29206718E-09_JPRB, 0.28681910E-09_JPRB, 0.28357244E-09_JPRB, 0.28066693E-09_JPRB, 0.27776026E-09_JPRB, 0.27469768E-09_JPRB, &
  & 0.27159769E-09_JPRB, 0.26880062E-09_JPRB, 0.26697536E-09_JPRB, 0.26679475E-09_JPRB, 0.26879401E-09_JPRB, 0.27326172E-09_JPRB, &
  & 0.28022906E-09_JPRB, 0.28944522E-09_JPRB, 0.30047934E-09_JPRB, 0.31272770E-09_JPRB, 0.32559525E-09_JPRB, 0.33853878E-09_JPRB, &
  & 0.35118100E-09_JPRB, 0.36324505E-09_JPRB, 0.37476133E-09_JPRB, 0.38586520E-09_JPRB, 0.39636019E-09_JPRB, 0.40652817E-09_JPRB, &
  & 0.41643441E-09_JPRB, 0.42590456E-09_JPRB, 0.43498738E-09_JPRB, 0.44350232E-09_JPRB, 0.45126552E-09_JPRB, 0.45807194E-09_JPRB, &
  & 0.46375184E-09_JPRB, 0.46822191E-09_JPRB, 0.47148024E-09_JPRB, 0.47352394E-09_JPRB, 0.47441973E-09_JPRB, 0.47418869E-09_JPRB, &
  & 0.47286702E-09_JPRB, 0.47045717E-09_JPRB, 0.46705345E-09_JPRB, 0.46258955E-09_JPRB, 0.45733684E-09_JPRB, 0.45128762E-09_JPRB, &
  & 0.44467108E-09_JPRB, 0.43757759E-09_JPRB, 0.43014370E-09_JPRB, 0.42251927E-09_JPRB, 0.41489329E-09_JPRB, 0.40741754E-09_JPRB, &
  & 0.40019751E-09_JPRB, 0.39326925E-09_JPRB, 0.38665923E-09_JPRB, 0.38037631E-09_JPRB, 0.37444656E-09_JPRB, 0.36887229E-09_JPRB, &
  & 0.36364947E-09_JPRB, 0.35878772E-09_JPRB, 0.35431338E-09_JPRB, 0.35027245E-09_JPRB, 0.34672168E-09_JPRB, 0.34369230E-09_JPRB, &
  & 0.34117753E-09_JPRB, 0.33909861E-09_JPRB, 0.33725794E-09_JPRB, 0.33492334E-09_JPRB /)

RGHG6(:,28, 7) = (/ &
  & 0.31301531E-09_JPRB, 0.30878475E-09_JPRB, 0.30626726E-09_JPRB, 0.30407632E-09_JPRB, 0.30193836E-09_JPRB, 0.29979488E-09_JPRB, &
  & 0.29772038E-09_JPRB, 0.29608999E-09_JPRB, 0.29543545E-09_JPRB, 0.29635017E-09_JPRB, 0.29927200E-09_JPRB, 0.30444888E-09_JPRB, &
  & 0.31185507E-09_JPRB, 0.32125816E-09_JPRB, 0.33220174E-09_JPRB, 0.34412728E-09_JPRB, 0.35641487E-09_JPRB, 0.36857967E-09_JPRB, &
  & 0.38014908E-09_JPRB, 0.39090048E-09_JPRB, 0.40090059E-09_JPRB, 0.41011528E-09_JPRB, 0.41845102E-09_JPRB, 0.42627207E-09_JPRB, &
  & 0.43366472E-09_JPRB, 0.44074250E-09_JPRB, 0.44768436E-09_JPRB, 0.45453116E-09_JPRB, 0.46126630E-09_JPRB, 0.46767179E-09_JPRB, &
  & 0.47344645E-09_JPRB, 0.47841053E-09_JPRB, 0.48236626E-09_JPRB, 0.48515586E-09_JPRB, 0.48671145E-09_JPRB, 0.48699067E-09_JPRB, &
  & 0.48598880E-09_JPRB, 0.48370802E-09_JPRB, 0.48025756E-09_JPRB, 0.47567339E-09_JPRB, 0.47007165E-09_JPRB, 0.46371507E-09_JPRB, &
  & 0.45673110E-09_JPRB, 0.44938603E-09_JPRB, 0.44180343E-09_JPRB, 0.43424514E-09_JPRB, 0.42688975E-09_JPRB, 0.41985093E-09_JPRB, &
  & 0.41318238E-09_JPRB, 0.40688247E-09_JPRB, 0.40091450E-09_JPRB, 0.39526796E-09_JPRB, 0.38993808E-09_JPRB, 0.38489634E-09_JPRB, &
  & 0.38012701E-09_JPRB, 0.37563380E-09_JPRB, 0.37143891E-09_JPRB, 0.36758499E-09_JPRB, 0.36412698E-09_JPRB, 0.36110648E-09_JPRB, &
  & 0.35853459E-09_JPRB, 0.35634509E-09_JPRB, 0.35433209E-09_JPRB, 0.35172129E-09_JPRB /)

RGHG6(:,29, 7) = (/ &
  & 0.33204844E-09_JPRB, 0.32887071E-09_JPRB, 0.32697578E-09_JPRB, 0.32542685E-09_JPRB, 0.32399206E-09_JPRB, 0.32264008E-09_JPRB, &
  & 0.32151434E-09_JPRB, 0.32092315E-09_JPRB, 0.32134720E-09_JPRB, 0.32326528E-09_JPRB, 0.32702938E-09_JPRB, 0.33279512E-09_JPRB, &
  & 0.34053119E-09_JPRB, 0.34996273E-09_JPRB, 0.36067960E-09_JPRB, 0.37212464E-09_JPRB, 0.38375206E-09_JPRB, 0.39505335E-09_JPRB, &
  & 0.40560438E-09_JPRB, 0.41515699E-09_JPRB, 0.42372578E-09_JPRB, 0.43129528E-09_JPRB, 0.43787596E-09_JPRB, 0.44372653E-09_JPRB, &
  & 0.44907084E-09_JPRB, 0.45416632E-09_JPRB, 0.45929083E-09_JPRB, 0.46467830E-09_JPRB, 0.47033322E-09_JPRB, 0.47615201E-09_JPRB, &
  & 0.48179133E-09_JPRB, 0.48686377E-09_JPRB, 0.49107801E-09_JPRB, 0.49416155E-09_JPRB, 0.49597354E-09_JPRB, 0.49644583E-09_JPRB, &
  & 0.49557553E-09_JPRB, 0.49338056E-09_JPRB, 0.48994314E-09_JPRB, 0.48539017E-09_JPRB, 0.47980059E-09_JPRB, 0.47336746E-09_JPRB, &
  & 0.46639892E-09_JPRB, 0.45905463E-09_JPRB, 0.45164966E-09_JPRB, 0.44440188E-09_JPRB, 0.43750639E-09_JPRB, 0.43105386E-09_JPRB, &
  & 0.42504006E-09_JPRB, 0.41937237E-09_JPRB, 0.41401527E-09_JPRB, 0.40893777E-09_JPRB, 0.40412415E-09_JPRB, 0.39954473E-09_JPRB, &
  & 0.39518205E-09_JPRB, 0.39103823E-09_JPRB, 0.38712966E-09_JPRB, 0.38350070E-09_JPRB, 0.38020714E-09_JPRB, 0.37729869E-09_JPRB, &
  & 0.37479703E-09_JPRB, 0.37264120E-09_JPRB, 0.37063383E-09_JPRB, 0.36784159E-09_JPRB /)

RGHG6(:,30, 7) = (/ &
  & 0.34916292E-09_JPRB, 0.34689326E-09_JPRB, 0.34560399E-09_JPRB, 0.34458611E-09_JPRB, 0.34371761E-09_JPRB, 0.34302816E-09_JPRB, &
  & 0.34266354E-09_JPRB, 0.34293673E-09_JPRB, 0.34425388E-09_JPRB, 0.34699432E-09_JPRB, 0.35140424E-09_JPRB, 0.35760020E-09_JPRB, &
  & 0.36547229E-09_JPRB, 0.37477643E-09_JPRB, 0.38509732E-09_JPRB, 0.39595696E-09_JPRB, 0.40683309E-09_JPRB, 0.41728571E-09_JPRB, &
  & 0.42689940E-09_JPRB, 0.43543563E-09_JPRB, 0.44281762E-09_JPRB, 0.44909571E-09_JPRB, 0.45431003E-09_JPRB, 0.45868651E-09_JPRB, &
  & 0.46250132E-09_JPRB, 0.46610360E-09_JPRB, 0.46987447E-09_JPRB, 0.47405813E-09_JPRB, 0.47879195E-09_JPRB, 0.48390697E-09_JPRB, &
  & 0.48915277E-09_JPRB, 0.49407090E-09_JPRB, 0.49824295E-09_JPRB, 0.50133986E-09_JPRB, 0.50317345E-09_JPRB, 0.50367188E-09_JPRB, &
  & 0.50284921E-09_JPRB, 0.50074878E-09_JPRB, 0.49741972E-09_JPRB, 0.49299353E-09_JPRB, 0.48757237E-09_JPRB, 0.48135052E-09_JPRB, &
  & 0.47456705E-09_JPRB, 0.46752824E-09_JPRB, 0.46050508E-09_JPRB, 0.45371018E-09_JPRB, 0.44739579E-09_JPRB, 0.44154505E-09_JPRB, &
  & 0.43613968E-09_JPRB, 0.43105300E-09_JPRB, 0.42621370E-09_JPRB, 0.42161991E-09_JPRB, 0.41724249E-09_JPRB, 0.41305279E-09_JPRB, &
  & 0.40904671E-09_JPRB, 0.40522058E-09_JPRB, 0.40159476E-09_JPRB, 0.39821307E-09_JPRB, 0.39512557E-09_JPRB, 0.39237769E-09_JPRB, &
  & 0.38998332E-09_JPRB, 0.38787379E-09_JPRB, 0.38580411E-09_JPRB, 0.38272494E-09_JPRB /)

RGHG6(:,31, 7) = (/ &
  & 0.36466047E-09_JPRB, 0.36304348E-09_JPRB, 0.36219158E-09_JPRB, 0.36158568E-09_JPRB, 0.36116488E-09_JPRB, 0.36098727E-09_JPRB, &
  & 0.36122641E-09_JPRB, 0.36218192E-09_JPRB, 0.36418316E-09_JPRB, 0.36752909E-09_JPRB, 0.37239781E-09_JPRB, 0.37881259E-09_JPRB, &
  & 0.38667092E-09_JPRB, 0.39569042E-09_JPRB, 0.40551856E-09_JPRB, 0.41571560E-09_JPRB, 0.42584211E-09_JPRB, 0.43547058E-09_JPRB, &
  & 0.44426146E-09_JPRB, 0.45196358E-09_JPRB, 0.45846105E-09_JPRB, 0.46377119E-09_JPRB, 0.46798637E-09_JPRB, 0.47132526E-09_JPRB, &
  & 0.47408982E-09_JPRB, 0.47667081E-09_JPRB, 0.47945059E-09_JPRB, 0.48270665E-09_JPRB, 0.48660737E-09_JPRB, 0.49107640E-09_JPRB, &
  & 0.49582755E-09_JPRB, 0.50040455E-09_JPRB, 0.50434651E-09_JPRB, 0.50727428E-09_JPRB, 0.50899085E-09_JPRB, 0.50943505E-09_JPRB, &
  & 0.50863980E-09_JPRB, 0.50665705E-09_JPRB, 0.50355031E-09_JPRB, 0.49936266E-09_JPRB, 0.49425047E-09_JPRB, 0.48837362E-09_JPRB, &
  & 0.48201004E-09_JPRB, 0.47540122E-09_JPRB, 0.46888010E-09_JPRB, 0.46266838E-09_JPRB, 0.45691556E-09_JPRB, 0.45163864E-09_JPRB, &
  & 0.44673379E-09_JPRB, 0.44213277E-09_JPRB, 0.43771392E-09_JPRB, 0.43348822E-09_JPRB, 0.42945356E-09_JPRB, 0.42558010E-09_JPRB, &
  & 0.42186771E-09_JPRB, 0.41831627E-09_JPRB, 0.41494932E-09_JPRB, 0.41179912E-09_JPRB, 0.40891124E-09_JPRB, 0.40632159E-09_JPRB, &
  & 0.40404061E-09_JPRB, 0.40199899E-09_JPRB, 0.39998399E-09_JPRB, 0.39707285E-09_JPRB /)

RGHG6(:,32, 7) = (/ &
  & 0.37851169E-09_JPRB, 0.37736775E-09_JPRB, 0.37686851E-09_JPRB, 0.37659237E-09_JPRB, 0.37652945E-09_JPRB, 0.37676362E-09_JPRB, &
  & 0.37748599E-09_JPRB, 0.37895390E-09_JPRB, 0.38146331E-09_JPRB, 0.38522058E-09_JPRB, 0.39033590E-09_JPRB, 0.39681186E-09_JPRB, &
  & 0.40449247E-09_JPRB, 0.41313533E-09_JPRB, 0.42240261E-09_JPRB, 0.43192813E-09_JPRB, 0.44132786E-09_JPRB, 0.45022813E-09_JPRB, &
  & 0.45831272E-09_JPRB, 0.46534282E-09_JPRB, 0.47118709E-09_JPRB, 0.47583332E-09_JPRB, 0.47937659E-09_JPRB, 0.48203835E-09_JPRB, &
  & 0.48413495E-09_JPRB, 0.48605214E-09_JPRB, 0.48815446E-09_JPRB, 0.49074106E-09_JPRB, 0.49396937E-09_JPRB, 0.49781790E-09_JPRB, &
  & 0.50201593E-09_JPRB, 0.50614912E-09_JPRB, 0.50971916E-09_JPRB, 0.51235954E-09_JPRB, 0.51387322E-09_JPRB, 0.51422272E-09_JPRB, &
  & 0.51345855E-09_JPRB, 0.51164328E-09_JPRB, 0.50880755E-09_JPRB, 0.50501348E-09_JPRB, 0.50030358E-09_JPRB, 0.49490673E-09_JPRB, &
  & 0.48906879E-09_JPRB, 0.48306448E-09_JPRB, 0.47711068E-09_JPRB, 0.47146004E-09_JPRB, 0.46622994E-09_JPRB, 0.46142351E-09_JPRB, &
  & 0.45691650E-09_JPRB, 0.45264725E-09_JPRB, 0.44854920E-09_JPRB, 0.44459747E-09_JPRB, 0.44081316E-09_JPRB, 0.43718468E-09_JPRB, &
  & 0.43370818E-09_JPRB, 0.43039028E-09_JPRB, 0.42724896E-09_JPRB, 0.42431050E-09_JPRB, 0.42161000E-09_JPRB, 0.41918002E-09_JPRB, &
  & 0.41702916E-09_JPRB, 0.41509018E-09_JPRB, 0.41315071E-09_JPRB, 0.41018167E-09_JPRB /)

RGHG6(:,33, 7) = (/ &
  & 0.39066123E-09_JPRB, 0.39006098E-09_JPRB, 0.38986592E-09_JPRB, 0.38987552E-09_JPRB, 0.39011697E-09_JPRB, 0.39069842E-09_JPRB, &
  & 0.39179734E-09_JPRB, 0.39366901E-09_JPRB, 0.39651665E-09_JPRB, 0.40050513E-09_JPRB, 0.40570675E-09_JPRB, 0.41207043E-09_JPRB, &
  & 0.41947076E-09_JPRB, 0.42765178E-09_JPRB, 0.43634688E-09_JPRB, 0.44521170E-09_JPRB, 0.45394635E-09_JPRB, 0.46220422E-09_JPRB, &
  & 0.46970511E-09_JPRB, 0.47622251E-09_JPRB, 0.48160470E-09_JPRB, 0.48582027E-09_JPRB, 0.48894788E-09_JPRB, 0.49122301E-09_JPRB, &
  & 0.49294868E-09_JPRB, 0.49447257E-09_JPRB, 0.49615884E-09_JPRB, 0.49825616E-09_JPRB, 0.50094118E-09_JPRB, 0.50421467E-09_JPRB, &
  & 0.50786170E-09_JPRB, 0.51146298E-09_JPRB, 0.51457516E-09_JPRB, 0.51684085E-09_JPRB, 0.51810067E-09_JPRB, 0.51833610E-09_JPRB, &
  & 0.51761334E-09_JPRB, 0.51598947E-09_JPRB, 0.51349558E-09_JPRB, 0.51012583E-09_JPRB, 0.50596638E-09_JPRB, 0.50115229E-09_JPRB, &
  & 0.49592219E-09_JPRB, 0.49057453E-09_JPRB, 0.48523835E-09_JPRB, 0.48013149E-09_JPRB, 0.47529725E-09_JPRB, 0.47084447E-09_JPRB, &
  & 0.46664150E-09_JPRB, 0.46258913E-09_JPRB, 0.45869233E-09_JPRB, 0.45493365E-09_JPRB, 0.45132498E-09_JPRB, 0.44788256E-09_JPRB, &
  & 0.44459680E-09_JPRB, 0.44147541E-09_JPRB, 0.43853315E-09_JPRB, 0.43578449E-09_JPRB, 0.43326262E-09_JPRB, 0.43099282E-09_JPRB, &
  & 0.42897666E-09_JPRB, 0.42714787E-09_JPRB, 0.42530465E-09_JPRB, 0.42249182E-09_JPRB /)

RGHG6(:,34, 7) = (/ &
  & 0.40154619E-09_JPRB, 0.40140086E-09_JPRB, 0.40146789E-09_JPRB, 0.40172787E-09_JPRB, 0.40223710E-09_JPRB, 0.40310699E-09_JPRB, &
  & 0.40452075E-09_JPRB, 0.40666587E-09_JPRB, 0.40972417E-09_JPRB, 0.41379902E-09_JPRB, 0.41892828E-09_JPRB, 0.42507534E-09_JPRB, &
  & 0.43209353E-09_JPRB, 0.43978518E-09_JPRB, 0.44790072E-09_JPRB, 0.45616452E-09_JPRB, 0.46428589E-09_JPRB, 0.47199600E-09_JPRB, &
  & 0.47901605E-09_JPRB, 0.48514803E-09_JPRB, 0.49022814E-09_JPRB, 0.49418480E-09_JPRB, 0.49711879E-09_JPRB, 0.49922422E-09_JPRB, &
  & 0.50080179E-09_JPRB, 0.50213395E-09_JPRB, 0.50357873E-09_JPRB, 0.50534810E-09_JPRB, 0.50760096E-09_JPRB, 0.51035409E-09_JPRB, &
  & 0.51341648E-09_JPRB, 0.51644278E-09_JPRB, 0.51902105E-09_JPRB, 0.52086074E-09_JPRB, 0.52183652E-09_JPRB, 0.52194937E-09_JPRB, &
  & 0.52127641E-09_JPRB, 0.51985938E-09_JPRB, 0.51770921E-09_JPRB, 0.51483257E-09_JPRB, 0.51123950E-09_JPRB, 0.50708160E-09_JPRB, &
  & 0.50256793E-09_JPRB, 0.49784094E-09_JPRB, 0.49313026E-09_JPRB, 0.48848880E-09_JPRB, 0.48401838E-09_JPRB, 0.47976223E-09_JPRB, &
  & 0.47576815E-09_JPRB, 0.47185794E-09_JPRB, 0.46808085E-09_JPRB, 0.46444987E-09_JPRB, 0.46097318E-09_JPRB, 0.45767151E-09_JPRB, &
  & 0.45454202E-09_JPRB, 0.45158915E-09_JPRB, 0.44881693E-09_JPRB, 0.44624054E-09_JPRB, 0.44388182E-09_JPRB, 0.44176177E-09_JPRB, &
  & 0.43987408E-09_JPRB, 0.43815751E-09_JPRB, 0.43640094E-09_JPRB, 0.43369974E-09_JPRB /)

RGHG6(:,35, 7) = (/ &
  & 0.41139739E-09_JPRB, 0.41161860E-09_JPRB, 0.41192377E-09_JPRB, 0.41240988E-09_JPRB, 0.41315157E-09_JPRB, 0.41426440E-09_JPRB, &
  & 0.41590068E-09_JPRB, 0.41823250E-09_JPRB, 0.42137746E-09_JPRB, 0.42541370E-09_JPRB, 0.43037682E-09_JPRB, 0.43620785E-09_JPRB, &
  & 0.44281023E-09_JPRB, 0.44998894E-09_JPRB, 0.45755744E-09_JPRB, 0.46525542E-09_JPRB, 0.47284870E-09_JPRB, 0.48007648E-09_JPRB, &
  & 0.48670928E-09_JPRB, 0.49254201E-09_JPRB, 0.49742926E-09_JPRB, 0.50129884E-09_JPRB, 0.50421328E-09_JPRB, 0.50632099E-09_JPRB, &
  & 0.50789384E-09_JPRB, 0.50920324E-09_JPRB, 0.51052562E-09_JPRB, 0.51206384E-09_JPRB, 0.51394794E-09_JPRB, 0.51619925E-09_JPRB, &
  & 0.51867055E-09_JPRB, 0.52106597E-09_JPRB, 0.52307114E-09_JPRB, 0.52445726E-09_JPRB, 0.52514371E-09_JPRB, 0.52514065E-09_JPRB, &
  & 0.52452426E-09_JPRB, 0.52330529E-09_JPRB, 0.52151528E-09_JPRB, 0.51911148E-09_JPRB, 0.51611121E-09_JPRB, 0.51261795E-09_JPRB, &
  & 0.50876792E-09_JPRB, 0.50471544E-09_JPRB, 0.50053406E-09_JPRB, 0.49634152E-09_JPRB, 0.49214516E-09_JPRB, 0.48807064E-09_JPRB, &
  & 0.48417587E-09_JPRB, 0.48036181E-09_JPRB, 0.47665349E-09_JPRB, 0.47311044E-09_JPRB, 0.46973420E-09_JPRB, 0.46654935E-09_JPRB, &
  & 0.46355353E-09_JPRB, 0.46074472E-09_JPRB, 0.45812393E-09_JPRB, 0.45569798E-09_JPRB, 0.45348958E-09_JPRB, 0.45151180E-09_JPRB, &
  & 0.44975523E-09_JPRB, 0.44815326E-09_JPRB, 0.44652154E-09_JPRB, 0.44397672E-09_JPRB /)

RGHG6(:,36, 7) = (/ &
  & 0.42040918E-09_JPRB, 0.42096193E-09_JPRB, 0.42147894E-09_JPRB, 0.42215981E-09_JPRB, 0.42309414E-09_JPRB, 0.42438802E-09_JPRB, &
  & 0.42617626E-09_JPRB, 0.42858708E-09_JPRB, 0.43171922E-09_JPRB, 0.43563728E-09_JPRB, 0.44035001E-09_JPRB, 0.44583201E-09_JPRB, &
  & 0.45198301E-09_JPRB, 0.45866694E-09_JPRB, 0.46570198E-09_JPRB, 0.47289178E-09_JPRB, 0.47999976E-09_JPRB, 0.48682186E-09_JPRB, &
  & 0.49314658E-09_JPRB, 0.49877635E-09_JPRB, 0.50357646E-09_JPRB, 0.50746296E-09_JPRB, 0.51043503E-09_JPRB, 0.51264293E-09_JPRB, &
  & 0.51428978E-09_JPRB, 0.51563054E-09_JPRB, 0.51689342E-09_JPRB, 0.51824156E-09_JPRB, 0.51978843E-09_JPRB, 0.52154742E-09_JPRB, &
  & 0.52341120E-09_JPRB, 0.52517357E-09_JPRB, 0.52660248E-09_JPRB, 0.52755739E-09_JPRB, 0.52798110E-09_JPRB, 0.52789639E-09_JPRB, &
  & 0.52735100E-09_JPRB, 0.52634175E-09_JPRB, 0.52490090E-09_JPRB, 0.52295462E-09_JPRB, 0.52050791E-09_JPRB, 0.51764609E-09_JPRB, &
  & 0.51443166E-09_JPRB, 0.51094334E-09_JPRB, 0.50728055E-09_JPRB, 0.50344201E-09_JPRB, 0.49950799E-09_JPRB, 0.49559834E-09_JPRB, &
  & 0.49178561E-09_JPRB, 0.48802484E-09_JPRB, 0.48437770E-09_JPRB, 0.48090559E-09_JPRB, 0.47761772E-09_JPRB, 0.47453902E-09_JPRB, &
  & 0.47166338E-09_JPRB, 0.46898502E-09_JPRB, 0.46649651E-09_JPRB, 0.46420981E-09_JPRB, 0.46214033E-09_JPRB, 0.46030069E-09_JPRB, &
  & 0.45867393E-09_JPRB, 0.45719667E-09_JPRB, 0.45567711E-09_JPRB, 0.45331414E-09_JPRB /)

RGHG6(:,37, 7) = (/ &
  & 0.42882384E-09_JPRB, 0.42967763E-09_JPRB, 0.43036755E-09_JPRB, 0.43120851E-09_JPRB, 0.43228460E-09_JPRB, 0.43369816E-09_JPRB, &
  & 0.43555284E-09_JPRB, 0.43795884E-09_JPRB, 0.44100013E-09_JPRB, 0.44472606E-09_JPRB, 0.44915663E-09_JPRB, 0.45425541E-09_JPRB, &
  & 0.45995754E-09_JPRB, 0.46614557E-09_JPRB, 0.47267967E-09_JPRB, 0.47937154E-09_JPRB, 0.48604304E-09_JPRB, 0.49249171E-09_JPRB, &
  & 0.49854981E-09_JPRB, 0.50404736E-09_JPRB, 0.50881283E-09_JPRB, 0.51273824E-09_JPRB, 0.51579047E-09_JPRB, 0.51805765E-09_JPRB, &
  & 0.51973859E-09_JPRB, 0.52105470E-09_JPRB, 0.52220706E-09_JPRB, 0.52335131E-09_JPRB, 0.52456622E-09_JPRB, 0.52587174E-09_JPRB, &
  & 0.52719096E-09_JPRB, 0.52839488E-09_JPRB, 0.52934307E-09_JPRB, 0.52994675E-09_JPRB, 0.53018318E-09_JPRB, 0.53006155E-09_JPRB, &
  & 0.52961946E-09_JPRB, 0.52883209E-09_JPRB, 0.52773258E-09_JPRB, 0.52621180E-09_JPRB, 0.52431903E-09_JPRB, 0.52202065E-09_JPRB, &
  & 0.51936477E-09_JPRB, 0.51641513E-09_JPRB, 0.51317794E-09_JPRB, 0.50969229E-09_JPRB, 0.50602583E-09_JPRB, 0.50228938E-09_JPRB, &
  & 0.49855220E-09_JPRB, 0.49484961E-09_JPRB, 0.49127424E-09_JPRB, 0.48787469E-09_JPRB, 0.48467863E-09_JPRB, 0.48170545E-09_JPRB, &
  & 0.47894599E-09_JPRB, 0.47638615E-09_JPRB, 0.47402243E-09_JPRB, 0.47186205E-09_JPRB, 0.46992554E-09_JPRB, 0.46822035E-09_JPRB, &
  & 0.46672638E-09_JPRB, 0.46537127E-09_JPRB, 0.46398427E-09_JPRB, 0.46181320E-09_JPRB /)

RGHG6(:,38, 7) = (/ &
  & 0.43687129E-09_JPRB, 0.43794332E-09_JPRB, 0.43877194E-09_JPRB, 0.43971343E-09_JPRB, 0.44089365E-09_JPRB, 0.44236173E-09_JPRB, &
  & 0.44421641E-09_JPRB, 0.44655046E-09_JPRB, 0.44943355E-09_JPRB, 0.45292481E-09_JPRB, 0.45703946E-09_JPRB, 0.46175097E-09_JPRB, &
  & 0.46699938E-09_JPRB, 0.47270154E-09_JPRB, 0.47873716E-09_JPRB, 0.48495458E-09_JPRB, 0.49118715E-09_JPRB, 0.49728377E-09_JPRB, &
  & 0.50308946E-09_JPRB, 0.50843324E-09_JPRB, 0.51314752E-09_JPRB, 0.51703286E-09_JPRB, 0.52002530E-09_JPRB, 0.52221033E-09_JPRB, &
  & 0.52377236E-09_JPRB, 0.52494892E-09_JPRB, 0.52593752E-09_JPRB, 0.52686500E-09_JPRB, 0.52780214E-09_JPRB, 0.52875715E-09_JPRB, &
  & 0.52968269E-09_JPRB, 0.53050142E-09_JPRB, 0.53112542E-09_JPRB, 0.53150478E-09_JPRB, 0.53163118E-09_JPRB, 0.53151272E-09_JPRB, &
  & 0.53117111E-09_JPRB, 0.53058857E-09_JPRB, 0.52977533E-09_JPRB, 0.52865556E-09_JPRB, 0.52724014E-09_JPRB, 0.52546789E-09_JPRB, &
  & 0.52336019E-09_JPRB, 0.52091348E-09_JPRB, 0.51812638E-09_JPRB, 0.51501003E-09_JPRB, 0.51163068E-09_JPRB, 0.50808419E-09_JPRB, &
  & 0.50445992E-09_JPRB, 0.50085980E-09_JPRB, 0.49737603E-09_JPRB, 0.49407234E-09_JPRB, 0.49098109E-09_JPRB, 0.48812177E-09_JPRB, &
  & 0.48547821E-09_JPRB, 0.48303417E-09_JPRB, 0.48078469E-09_JPRB, 0.47874366E-09_JPRB, 0.47693344E-09_JPRB, 0.47536053E-09_JPRB, &
  & 0.47399673E-09_JPRB, 0.47276782E-09_JPRB, 0.47151122E-09_JPRB, 0.46954102E-09_JPRB /)

RGHG6(:,39, 7) = (/ &
  & 0.44464951E-09_JPRB, 0.44586482E-09_JPRB, 0.44676410E-09_JPRB, 0.44779153E-09_JPRB, 0.44900750E-09_JPRB, 0.45049958E-09_JPRB, &
  & 0.45230822E-09_JPRB, 0.45451520E-09_JPRB, 0.45720211E-09_JPRB, 0.46042578E-09_JPRB, 0.46420237E-09_JPRB, 0.46852089E-09_JPRB, &
  & 0.47332332E-09_JPRB, 0.47854182E-09_JPRB, 0.48408277E-09_JPRB, 0.48981658E-09_JPRB, 0.49560872E-09_JPRB, 0.50133453E-09_JPRB, &
  & 0.50685456E-09_JPRB, 0.51201138E-09_JPRB, 0.51654026E-09_JPRB, 0.52025356E-09_JPRB, 0.52304283E-09_JPRB, 0.52501159E-09_JPRB, &
  & 0.52638538E-09_JPRB, 0.52739724E-09_JPRB, 0.52822846E-09_JPRB, 0.52899030E-09_JPRB, 0.52973181E-09_JPRB, 0.53046079E-09_JPRB, &
  & 0.53114524E-09_JPRB, 0.53173316E-09_JPRB, 0.53216981E-09_JPRB, 0.53242050E-09_JPRB, 0.53248822E-09_JPRB, 0.53237803E-09_JPRB, &
  & 0.53211074E-09_JPRB, 0.53166749E-09_JPRB, 0.53106042E-09_JPRB, 0.53023519E-09_JPRB, 0.52918980E-09_JPRB, 0.52786880E-09_JPRB, &
  & 0.52626598E-09_JPRB, 0.52433036E-09_JPRB, 0.52202742E-09_JPRB, 0.51933646E-09_JPRB, 0.51629623E-09_JPRB, 0.51299254E-09_JPRB, &
  & 0.50955173E-09_JPRB, 0.50609233E-09_JPRB, 0.50273558E-09_JPRB, 0.49955323E-09_JPRB, 0.49658766E-09_JPRB, 0.49385435E-09_JPRB, &
  & 0.49133053E-09_JPRB, 0.48899840E-09_JPRB, 0.48685717E-09_JPRB, 0.48492860E-09_JPRB, 0.48323939E-09_JPRB, 0.48179372E-09_JPRB, &
  & 0.48055582E-09_JPRB, 0.47944870E-09_JPRB, 0.47831616E-09_JPRB, 0.47655352E-09_JPRB /)

RGHG6(:,40, 7) = (/ &
  & 0.45214854E-09_JPRB, 0.45344539E-09_JPRB, 0.45440054E-09_JPRB, 0.45543916E-09_JPRB, 0.45670623E-09_JPRB, 0.45817736E-09_JPRB, &
  & 0.45991350E-09_JPRB, 0.46198076E-09_JPRB, 0.46444343E-09_JPRB, 0.46737214E-09_JPRB, 0.47080567E-09_JPRB, 0.47472398E-09_JPRB, &
  & 0.47908444E-09_JPRB, 0.48382837E-09_JPRB, 0.48887372E-09_JPRB, 0.49411542E-09_JPRB, 0.49944698E-09_JPRB, 0.50476368E-09_JPRB, &
  & 0.50995513E-09_JPRB, 0.51481330E-09_JPRB, 0.51910604E-09_JPRB, 0.52254828E-09_JPRB, 0.52507920E-09_JPRB, 0.52682808E-09_JPRB, &
  & 0.52802801E-09_JPRB, 0.52890725E-09_JPRB, 0.52962534E-09_JPRB, 0.53027066E-09_JPRB, 0.53088439E-09_JPRB, 0.53147070E-09_JPRB, &
  & 0.53200877E-09_JPRB, 0.53246413E-09_JPRB, 0.53279131E-09_JPRB, 0.53297033E-09_JPRB, 0.53300397E-09_JPRB, 0.53290306E-09_JPRB, &
  & 0.53267885E-09_JPRB, 0.53232480E-09_JPRB, 0.53184540E-09_JPRB, 0.53121019E-09_JPRB, 0.53041499E-09_JPRB, 0.52942606E-09_JPRB, &
  & 0.52822186E-09_JPRB, 0.52674043E-09_JPRB, 0.52492105E-09_JPRB, 0.52269189E-09_JPRB, 0.52004634E-09_JPRB, 0.51706045E-09_JPRB, &
  & 0.51385135E-09_JPRB, 0.51058713E-09_JPRB, 0.50739668E-09_JPRB, 0.50436916E-09_JPRB, 0.50155236E-09_JPRB, 0.49895504E-09_JPRB, &
  & 0.49655735E-09_JPRB, 0.49433502E-09_JPRB, 0.49229953E-09_JPRB, 0.49047577E-09_JPRB, 0.48890242E-09_JPRB, 0.48757726E-09_JPRB, &
  & 0.48645843E-09_JPRB, 0.48546167E-09_JPRB, 0.48445048E-09_JPRB, 0.48286830E-09_JPRB /)

RGHG6(:,41, 7) = (/ &
  & 0.45940610E-09_JPRB, 0.46073093E-09_JPRB, 0.46166304E-09_JPRB, 0.46273496E-09_JPRB, 0.46398757E-09_JPRB, 0.46545365E-09_JPRB, &
  & 0.46711640E-09_JPRB, 0.46902443E-09_JPRB, 0.47125881E-09_JPRB, 0.47389204E-09_JPRB, 0.47696558E-09_JPRB, 0.48048637E-09_JPRB, &
  & 0.48441162E-09_JPRB, 0.48868454E-09_JPRB, 0.49323678E-09_JPRB, 0.49798210E-09_JPRB, 0.50282822E-09_JPRB, 0.50771215E-09_JPRB, &
  & 0.51251947E-09_JPRB, 0.51707078E-09_JPRB, 0.52104432E-09_JPRB, 0.52421134E-09_JPRB, 0.52649779E-09_JPRB, 0.52805738E-09_JPRB, &
  & 0.52912263E-09_JPRB, 0.52990301E-09_JPRB, 0.53053739E-09_JPRB, 0.53110127E-09_JPRB, 0.53162569E-09_JPRB, 0.53211752E-09_JPRB, &
  & 0.53256466E-09_JPRB, 0.53293553E-09_JPRB, 0.53319860E-09_JPRB, 0.53333360E-09_JPRB, 0.53334792E-09_JPRB, 0.53325366E-09_JPRB, &
  & 0.53305865E-09_JPRB, 0.53276195E-09_JPRB, 0.53236243E-09_JPRB, 0.53185045E-09_JPRB, 0.53121763E-09_JPRB, 0.53045002E-09_JPRB, &
  & 0.52953586E-09_JPRB, 0.52840232E-09_JPRB, 0.52699817E-09_JPRB, 0.52520754E-09_JPRB, 0.52299159E-09_JPRB, 0.52035315E-09_JPRB, &
  & 0.51743909E-09_JPRB, 0.51440385E-09_JPRB, 0.51141230E-09_JPRB, 0.50856808E-09_JPRB, 0.50591764E-09_JPRB, 0.50347543E-09_JPRB, &
  & 0.50120780E-09_JPRB, 0.49910281E-09_JPRB, 0.49716592E-09_JPRB, 0.49544657E-09_JPRB, 0.49398136E-09_JPRB, 0.49276982E-09_JPRB, &
  & 0.49175786E-09_JPRB, 0.49086357E-09_JPRB, 0.48995163E-09_JPRB, 0.48853677E-09_JPRB /)

RGHG6(:,42, 7) = (/ &
  & 0.46669957E-09_JPRB, 0.46775050E-09_JPRB, 0.46861670E-09_JPRB, 0.46964244E-09_JPRB, 0.47093168E-09_JPRB, 0.47237447E-09_JPRB, &
  & 0.47396304E-09_JPRB, 0.47573095E-09_JPRB, 0.47773918E-09_JPRB, 0.48007270E-09_JPRB, 0.48279547E-09_JPRB, 0.48591953E-09_JPRB, &
  & 0.48941223E-09_JPRB, 0.49322418E-09_JPRB, 0.49728904E-09_JPRB, 0.50152860E-09_JPRB, 0.50588844E-09_JPRB, 0.51029997E-09_JPRB, &
  & 0.51469840E-09_JPRB, 0.51888310E-09_JPRB, 0.52257415E-09_JPRB, 0.52548060E-09_JPRB, 0.52755605E-09_JPRB, 0.52895832E-09_JPRB, &
  & 0.52991522E-09_JPRB, 0.53061811E-09_JPRB, 0.53118815E-09_JPRB, 0.53168780E-09_JPRB, 0.53214683E-09_JPRB, 0.53257249E-09_JPRB, &
  & 0.53295562E-09_JPRB, 0.53327370E-09_JPRB, 0.53349297E-09_JPRB, 0.53360105E-09_JPRB, 0.53360383E-09_JPRB, 0.53351534E-09_JPRB, &
  & 0.53334231E-09_JPRB, 0.53308408E-09_JPRB, 0.53274252E-09_JPRB, 0.53230892E-09_JPRB, 0.53178695E-09_JPRB, 0.53116889E-09_JPRB, &
  & 0.53045113E-09_JPRB, 0.52957588E-09_JPRB, 0.52849392E-09_JPRB, 0.52708593E-09_JPRB, 0.52526822E-09_JPRB, 0.52301391E-09_JPRB, &
  & 0.52040788E-09_JPRB, 0.51762961E-09_JPRB, 0.51485644E-09_JPRB, 0.51221305E-09_JPRB, 0.50975141E-09_JPRB, 0.50747040E-09_JPRB, &
  & 0.50535065E-09_JPRB, 0.50336224E-09_JPRB, 0.50153320E-09_JPRB, 0.49991167E-09_JPRB, 0.49855203E-09_JPRB, 0.49744442E-09_JPRB, &
  & 0.49653015E-09_JPRB, 0.49572185E-09_JPRB, 0.49489796E-09_JPRB, 0.49361337E-09_JPRB /)

RGHG6(:,43, 7) = (/ &
  & 0.47288706E-09_JPRB, 0.47419207E-09_JPRB, 0.47512050E-09_JPRB, 0.47622828E-09_JPRB, 0.47753301E-09_JPRB, 0.47900151E-09_JPRB, &
  & 0.48053078E-09_JPRB, 0.48216403E-09_JPRB, 0.48396120E-09_JPRB, 0.48601284E-09_JPRB, 0.48839011E-09_JPRB, 0.49112348E-09_JPRB, &
  & 0.49419385E-09_JPRB, 0.49755083E-09_JPRB, 0.50113091E-09_JPRB, 0.50487808E-09_JPRB, 0.50872867E-09_JPRB, 0.51267468E-09_JPRB, &
  & 0.51663956E-09_JPRB, 0.52047516E-09_JPRB, 0.52385341E-09_JPRB, 0.52651494E-09_JPRB, 0.52839710E-09_JPRB, 0.52966359E-09_JPRB, &
  & 0.53052929E-09_JPRB, 0.53116733E-09_JPRB, 0.53168336E-09_JPRB, 0.53213212E-09_JPRB, 0.53253985E-09_JPRB, 0.53291610E-09_JPRB, &
  & 0.53325544E-09_JPRB, 0.53353411E-09_JPRB, 0.53372562E-09_JPRB, 0.53381494E-09_JPRB, 0.53381144E-09_JPRB, 0.53372856E-09_JPRB, &
  & 0.53357285E-09_JPRB, 0.53334470E-09_JPRB, 0.53304300E-09_JPRB, 0.53266819E-09_JPRB, 0.53222193E-09_JPRB, 0.53170629E-09_JPRB, &
  & 0.53112870E-09_JPRB, 0.53043886E-09_JPRB, 0.52960103E-09_JPRB, 0.52850402E-09_JPRB, 0.52705257E-09_JPRB, 0.52516524E-09_JPRB, &
  & 0.52288085E-09_JPRB, 0.52036614E-09_JPRB, 0.51781873E-09_JPRB, 0.51538740E-09_JPRB, 0.51311994E-09_JPRB, 0.51101784E-09_JPRB, &
  & 0.50905075E-09_JPRB, 0.50719762E-09_JPRB, 0.50547627E-09_JPRB, 0.50395976E-09_JPRB, 0.50270105E-09_JPRB, 0.50169124E-09_JPRB, &
  & 0.50086335E-09_JPRB, 0.50012972E-09_JPRB, 0.49937487E-09_JPRB, 0.49819016E-09_JPRB /)

RGHG6(:,44, 7) = (/ &
  & 0.47901505E-09_JPRB, 0.48049459E-09_JPRB, 0.48148657E-09_JPRB, 0.48257914E-09_JPRB, 0.48395804E-09_JPRB, 0.48540516E-09_JPRB, &
  & 0.48690135E-09_JPRB, 0.48840443E-09_JPRB, 0.49000998E-09_JPRB, 0.49179205E-09_JPRB, 0.49384041E-09_JPRB, 0.49619747E-09_JPRB, &
  & 0.49885185E-09_JPRB, 0.50175897E-09_JPRB, 0.50487076E-09_JPRB, 0.50811272E-09_JPRB, 0.51147708E-09_JPRB, 0.51492050E-09_JPRB, &
  & 0.51844784E-09_JPRB, 0.52188753E-09_JPRB, 0.52497384E-09_JPRB, 0.52739035E-09_JPRB, 0.52909616E-09_JPRB, 0.53023996E-09_JPRB, &
  & 0.53102567E-09_JPRB, 0.53160709E-09_JPRB, 0.53207688E-09_JPRB, 0.53248306E-09_JPRB, 0.53285099E-09_JPRB, 0.53319033E-09_JPRB, &
  & 0.53349603E-09_JPRB, 0.53374805E-09_JPRB, 0.53391841E-09_JPRB, 0.53399590E-09_JPRB, 0.53398946E-09_JPRB, 0.53391253E-09_JPRB, &
  & 0.53377147E-09_JPRB, 0.53356614E-09_JPRB, 0.53329707E-09_JPRB, 0.53296378E-09_JPRB, 0.53257343E-09_JPRB, 0.53213300E-09_JPRB, &
  & 0.53165111E-09_JPRB, 0.53110294E-09_JPRB, 0.53044535E-09_JPRB, 0.52960192E-09_JPRB, 0.52846555E-09_JPRB, 0.52692439E-09_JPRB, &
  & 0.52497368E-09_JPRB, 0.52271898E-09_JPRB, 0.52040383E-09_JPRB, 0.51818067E-09_JPRB, 0.51611354E-09_JPRB, 0.51419874E-09_JPRB, &
  & 0.51240245E-09_JPRB, 0.51069438E-09_JPRB, 0.50909915E-09_JPRB, 0.50768972E-09_JPRB, 0.50653348E-09_JPRB, 0.50561505E-09_JPRB, &
  & 0.50486304E-09_JPRB, 0.50419258E-09_JPRB, 0.50349236E-09_JPRB, 0.50238153E-09_JPRB /)

RGHG6(:,45, 7) = (/ &
  & 0.48601118E-09_JPRB, 0.48705856E-09_JPRB, 0.48785576E-09_JPRB, 0.48892540E-09_JPRB, 0.49023802E-09_JPRB, 0.49173909E-09_JPRB, &
  & 0.49314591E-09_JPRB, 0.49455162E-09_JPRB, 0.49596055E-09_JPRB, 0.49749799E-09_JPRB, 0.49923093E-09_JPRB, 0.50122340E-09_JPRB, &
  & 0.50347398E-09_JPRB, 0.50594751E-09_JPRB, 0.50857840E-09_JPRB, 0.51134780E-09_JPRB, 0.51419136E-09_JPRB, 0.51716154E-09_JPRB, &
  & 0.52020466E-09_JPRB, 0.52325427E-09_JPRB, 0.52598592E-09_JPRB, 0.52815857E-09_JPRB, 0.52968635E-09_JPRB, 0.53071963E-09_JPRB, &
  & 0.53143340E-09_JPRB, 0.53196542E-09_JPRB, 0.53239513E-09_JPRB, 0.53276716E-09_JPRB, 0.53310351E-09_JPRB, 0.53341448E-09_JPRB, &
  & 0.53369592E-09_JPRB, 0.53392724E-09_JPRB, 0.53408372E-09_JPRB, 0.53415361E-09_JPRB, 0.53414678E-09_JPRB, 0.53407595E-09_JPRB, &
  & 0.53394716E-09_JPRB, 0.53376076E-09_JPRB, 0.53351695E-09_JPRB, 0.53321592E-09_JPRB, 0.53286864E-09_JPRB, 0.53248078E-09_JPRB, &
  & 0.53207327E-09_JPRB, 0.53162447E-09_JPRB, 0.53110660E-09_JPRB, 0.53046095E-09_JPRB, 0.52958543E-09_JPRB, 0.52838117E-09_JPRB, &
  & 0.52675242E-09_JPRB, 0.52479693E-09_JPRB, 0.52271082E-09_JPRB, 0.52069576E-09_JPRB, 0.51883309E-09_JPRB, 0.51711330E-09_JPRB, &
  & 0.51550014E-09_JPRB, 0.51395943E-09_JPRB, 0.51250082E-09_JPRB, 0.51121163E-09_JPRB, 0.51015558E-09_JPRB, 0.50932136E-09_JPRB, &
  & 0.50863735E-09_JPRB, 0.50801940E-09_JPRB, 0.50736365E-09_JPRB, 0.50630278E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART13',1,ZHOOK_HANDLE)
END SUBROUTINE PART13




SUBROUTINE PART14
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART14',0,ZHOOK_HANDLE)



RGHG6(:,46, 7) = (/ &
  & 0.49141530E-09_JPRB, 0.49304549E-09_JPRB, 0.49408339E-09_JPRB, 0.49517435E-09_JPRB, 0.49660981E-09_JPRB, 0.49803922E-09_JPRB, &
  & 0.49944981E-09_JPRB, 0.50069898E-09_JPRB, 0.50194199E-09_JPRB, 0.50322074E-09_JPRB, 0.50465782E-09_JPRB, 0.50629501E-09_JPRB, &
  & 0.50815102E-09_JPRB, 0.51018456E-09_JPRB, 0.51236437E-09_JPRB, 0.51461996E-09_JPRB, 0.51698645E-09_JPRB, 0.51942606E-09_JPRB, &
  & 0.52200005E-09_JPRB, 0.52456384E-09_JPRB, 0.52693949E-09_JPRB, 0.52882937E-09_JPRB, 0.53019106E-09_JPRB, 0.53111904E-09_JPRB, &
  & 0.53177046E-09_JPRB, 0.53225857E-09_JPRB, 0.53265553E-09_JPRB, 0.53299892E-09_JPRB, 0.53331123E-09_JPRB, 0.53360094E-09_JPRB, &
  & 0.53386368E-09_JPRB, 0.53408056E-09_JPRB, 0.53422700E-09_JPRB, 0.53429305E-09_JPRB, 0.53428795E-09_JPRB, 0.53422328E-09_JPRB, &
  & 0.53410509E-09_JPRB, 0.53393456E-09_JPRB, 0.53370997E-09_JPRB, 0.53343707E-09_JPRB, 0.53311910E-09_JPRB, 0.53277627E-09_JPRB, &
  & 0.53241722E-09_JPRB, 0.53204596E-09_JPRB, 0.53163096E-09_JPRB, 0.53113380E-09_JPRB, 0.53047777E-09_JPRB, 0.52955801E-09_JPRB, &
  & 0.52828270E-09_JPRB, 0.52664345E-09_JPRB, 0.52482929E-09_JPRB, 0.52303772E-09_JPRB, 0.52138127E-09_JPRB, 0.51986787E-09_JPRB, &
  & 0.51845062E-09_JPRB, 0.51708332E-09_JPRB, 0.51578253E-09_JPRB, 0.51461385E-09_JPRB, 0.51365806E-09_JPRB, 0.51289961E-09_JPRB, &
  & 0.51227356E-09_JPRB, 0.51170024E-09_JPRB, 0.51108034E-09_JPRB, 0.51005883E-09_JPRB /)

RGHG6(:,47, 7) = (/ &
  & 0.49851634E-09_JPRB, 0.49973592E-09_JPRB, 0.50061844E-09_JPRB, 0.50175181E-09_JPRB, 0.50311749E-09_JPRB, 0.50463994E-09_JPRB, &
  & 0.50590543E-09_JPRB, 0.50704901E-09_JPRB, 0.50806370E-09_JPRB, 0.50909998E-09_JPRB, 0.51021770E-09_JPRB, 0.51150201E-09_JPRB, &
  & 0.51295929E-09_JPRB, 0.51456456E-09_JPRB, 0.51625904E-09_JPRB, 0.51804333E-09_JPRB, 0.51987337E-09_JPRB, 0.52181376E-09_JPRB, &
  & 0.52382509E-09_JPRB, 0.52589938E-09_JPRB, 0.52782373E-09_JPRB, 0.52943333E-09_JPRB, 0.53061699E-09_JPRB, 0.53145188E-09_JPRB, &
  & 0.53204668E-09_JPRB, 0.53249888E-09_JPRB, 0.53286736E-09_JPRB, 0.53318927E-09_JPRB, 0.53348242E-09_JPRB, 0.53375615E-09_JPRB, &
  & 0.53400578E-09_JPRB, 0.53421167E-09_JPRB, 0.53435206E-09_JPRB, 0.53441712E-09_JPRB, 0.53441507E-09_JPRB, 0.53435673E-09_JPRB, &
  & 0.53424798E-09_JPRB, 0.53408955E-09_JPRB, 0.53388377E-09_JPRB, 0.53362931E-09_JPRB, 0.53334132E-09_JPRB, 0.53302479E-09_JPRB, &
  & 0.53270865E-09_JPRB, 0.53238736E-09_JPRB, 0.53205140E-09_JPRB, 0.53166593E-09_JPRB, 0.53117849E-09_JPRB, 0.53051147E-09_JPRB, &
  & 0.52956228E-09_JPRB, 0.52830934E-09_JPRB, 0.52681681E-09_JPRB, 0.52530302E-09_JPRB, 0.52387611E-09_JPRB, 0.52257471E-09_JPRB, &
  & 0.52135363E-09_JPRB, 0.52017340E-09_JPRB, 0.51902072E-09_JPRB, 0.51797766E-09_JPRB, 0.51711008E-09_JPRB, 0.51641874E-09_JPRB, &
  & 0.51584043E-09_JPRB, 0.51530402E-09_JPRB, 0.51471283E-09_JPRB, 0.51372301E-09_JPRB /)

RGHG6(:,48, 7) = (/ &
  & 0.50408322E-09_JPRB, 0.50580751E-09_JPRB, 0.50702020E-09_JPRB, 0.50830362E-09_JPRB, 0.50989740E-09_JPRB, 0.51138405E-09_JPRB, &
  & 0.51264992E-09_JPRB, 0.51360100E-09_JPRB, 0.51441612E-09_JPRB, 0.51517618E-09_JPRB, 0.51598292E-09_JPRB, 0.51690069E-09_JPRB, &
  & 0.51795429E-09_JPRB, 0.51911614E-09_JPRB, 0.52034688E-09_JPRB, 0.52160770E-09_JPRB, 0.52291915E-09_JPRB, 0.52427018E-09_JPRB, &
  & 0.52570709E-09_JPRB, 0.52719262E-09_JPRB, 0.52866456E-09_JPRB, 0.52996080E-09_JPRB, 0.53098087E-09_JPRB, 0.53172627E-09_JPRB, &
  & 0.53227378E-09_JPRB, 0.53269422E-09_JPRB, 0.53304117E-09_JPRB, 0.53334465E-09_JPRB, 0.53362409E-09_JPRB, 0.53388616E-09_JPRB, &
  & 0.53412580E-09_JPRB, 0.53432486E-09_JPRB, 0.53446170E-09_JPRB, 0.53452792E-09_JPRB, 0.53452986E-09_JPRB, 0.53447774E-09_JPRB, &
  & 0.53437688E-09_JPRB, 0.53423010E-09_JPRB, 0.53403709E-09_JPRB, 0.53380422E-09_JPRB, 0.53353322E-09_JPRB, 0.53324506E-09_JPRB, &
  & 0.53295263E-09_JPRB, 0.53267235E-09_JPRB, 0.53239158E-09_JPRB, 0.53208976E-09_JPRB, 0.53173127E-09_JPRB, 0.53126037E-09_JPRB, &
  & 0.53061833E-09_JPRB, 0.52974330E-09_JPRB, 0.52869303E-09_JPRB, 0.52752641E-09_JPRB, 0.52640386E-09_JPRB, 0.52534466E-09_JPRB, &
  & 0.52433136E-09_JPRB, 0.52332338E-09_JPRB, 0.52231652E-09_JPRB, 0.52137222E-09_JPRB, 0.52057891E-09_JPRB, 0.51993471E-09_JPRB, &
  & 0.51939175E-09_JPRB, 0.51887961E-09_JPRB, 0.51830873E-09_JPRB, 0.51733723E-09_JPRB /)

RGHG6(:,49, 7) = (/ &
  & 0.50965682E-09_JPRB, 0.51171567E-09_JPRB, 0.51308502E-09_JPRB, 0.51457538E-09_JPRB, 0.51625870E-09_JPRB, 0.51788146E-09_JPRB, &
  & 0.51905102E-09_JPRB, 0.51988586E-09_JPRB, 0.52051474E-09_JPRB, 0.52104687E-09_JPRB, 0.52158566E-09_JPRB, 0.52217963E-09_JPRB, &
  & 0.52286619E-09_JPRB, 0.52361376E-09_JPRB, 0.52438576E-09_JPRB, 0.52515359E-09_JPRB, 0.52590954E-09_JPRB, 0.52668286E-09_JPRB, &
  & 0.52750238E-09_JPRB, 0.52841304E-09_JPRB, 0.52943089E-09_JPRB, 0.53042704E-09_JPRB, 0.53128552E-09_JPRB, 0.53195404E-09_JPRB, &
  & 0.53245974E-09_JPRB, 0.53285548E-09_JPRB, 0.53318383E-09_JPRB, 0.53347404E-09_JPRB, 0.53374222E-09_JPRB, 0.53399557E-09_JPRB, &
  & 0.53422838E-09_JPRB, 0.53442251E-09_JPRB, 0.53455829E-09_JPRB, 0.53462690E-09_JPRB, 0.53463384E-09_JPRB, 0.53458776E-09_JPRB, &
  & 0.53449378E-09_JPRB, 0.53435661E-09_JPRB, 0.53417726E-09_JPRB, 0.53395888E-09_JPRB, 0.53370819E-09_JPRB, 0.53343546E-09_JPRB, &
  & 0.53316679E-09_JPRB, 0.53291205E-09_JPRB, 0.53267263E-09_JPRB, 0.53243171E-09_JPRB, 0.53216603E-09_JPRB, 0.53184485E-09_JPRB, &
  & 0.53143245E-09_JPRB, 0.53091320E-09_JPRB, 0.53026905E-09_JPRB, 0.52957116E-09_JPRB, 0.52882576E-09_JPRB, 0.52808491E-09_JPRB, &
  & 0.52733573E-09_JPRB, 0.52652260E-09_JPRB, 0.52566451E-09_JPRB, 0.52482108E-09_JPRB, 0.52408089E-09_JPRB, 0.52347526E-09_JPRB, &
  & 0.52295174E-09_JPRB, 0.52245475E-09_JPRB, 0.52189003E-09_JPRB, 0.52091637E-09_JPRB /)

RGHG6(:,50, 7) = (/ &
  & 0.51531324E-09_JPRB, 0.51714338E-09_JPRB, 0.51840171E-09_JPRB, 0.51981242E-09_JPRB, 0.52145643E-09_JPRB, 0.52297489E-09_JPRB, &
  & 0.52402638E-09_JPRB, 0.52472215E-09_JPRB, 0.52518823E-09_JPRB, 0.52558047E-09_JPRB, 0.52593424E-09_JPRB, 0.52632193E-09_JPRB, &
  & 0.52674803E-09_JPRB, 0.52719745E-09_JPRB, 0.52762233E-09_JPRB, 0.52800486E-09_JPRB, 0.52834631E-09_JPRB, 0.52866833E-09_JPRB, &
  & 0.52902249E-09_JPRB, 0.52949700E-09_JPRB, 0.53009636E-09_JPRB, 0.53083532E-09_JPRB, 0.53154275E-09_JPRB, 0.53214200E-09_JPRB, &
  & 0.53261406E-09_JPRB, 0.53298926E-09_JPRB, 0.53330362E-09_JPRB, 0.53358246E-09_JPRB, 0.53384219E-09_JPRB, 0.53408888E-09_JPRB, &
  & 0.53431654E-09_JPRB, 0.53450788E-09_JPRB, 0.53464388E-09_JPRB, 0.53471583E-09_JPRB, 0.53472815E-09_JPRB, 0.53468713E-09_JPRB, &
  & 0.53460047E-09_JPRB, 0.53447113E-09_JPRB, 0.53430388E-09_JPRB, 0.53409976E-09_JPRB, 0.53386434E-09_JPRB, 0.53360827E-09_JPRB, &
  & 0.53335358E-09_JPRB, 0.53312049E-09_JPRB, 0.53290994E-09_JPRB, 0.53271254E-09_JPRB, 0.53251120E-09_JPRB, 0.53229238E-09_JPRB, &
  & 0.53204063E-09_JPRB, 0.53175009E-09_JPRB, 0.53142934E-09_JPRB, 0.53106963E-09_JPRB, 0.53069971E-09_JPRB, 0.53030491E-09_JPRB, &
  & 0.52985272E-09_JPRB, 0.52934568E-09_JPRB, 0.52872912E-09_JPRB, 0.52807148E-09_JPRB, 0.52746479E-09_JPRB, 0.52692700E-09_JPRB, &
  & 0.52645488E-09_JPRB, 0.52598126E-09_JPRB, 0.52542581E-09_JPRB, 0.52442556E-09_JPRB /)

RGHG6(:,51, 7) = (/ &
  & 0.51960425E-09_JPRB, 0.52132787E-09_JPRB, 0.52246751E-09_JPRB, 0.52365051E-09_JPRB, 0.52506849E-09_JPRB, 0.52631888E-09_JPRB, &
  & 0.52717875E-09_JPRB, 0.52767651E-09_JPRB, 0.52803617E-09_JPRB, 0.52829502E-09_JPRB, 0.52854793E-09_JPRB, 0.52880444E-09_JPRB, &
  & 0.52908511E-09_JPRB, 0.52936044E-09_JPRB, 0.52959725E-09_JPRB, 0.52978127E-09_JPRB, 0.52991639E-09_JPRB, 0.53002747E-09_JPRB, &
  & 0.53015858E-09_JPRB, 0.53034721E-09_JPRB, 0.53070198E-09_JPRB, 0.53117921E-09_JPRB, 0.53176308E-09_JPRB, 0.53229987E-09_JPRB, &
  & 0.53274418E-09_JPRB, 0.53310367E-09_JPRB, 0.53340643E-09_JPRB, 0.53367655E-09_JPRB, 0.53392873E-09_JPRB, 0.53416960E-09_JPRB, &
  & 0.53439347E-09_JPRB, 0.53458293E-09_JPRB, 0.53472027E-09_JPRB, 0.53479632E-09_JPRB, 0.53481386E-09_JPRB, 0.53477861E-09_JPRB, &
  & 0.53469706E-09_JPRB, 0.53457744E-09_JPRB, 0.53441901E-09_JPRB, 0.53422933E-09_JPRB, 0.53400645E-09_JPRB, 0.53376403E-09_JPRB, &
  & 0.53352289E-09_JPRB, 0.53330523E-09_JPRB, 0.53311611E-09_JPRB, 0.53294824E-09_JPRB, 0.53279298E-09_JPRB, 0.53263849E-09_JPRB, &
  & 0.53248506E-09_JPRB, 0.53232940E-09_JPRB, 0.53217053E-09_JPRB, 0.53201271E-09_JPRB, 0.53184618E-09_JPRB, 0.53166849E-09_JPRB, &
  & 0.53147609E-09_JPRB, 0.53122168E-09_JPRB, 0.53092097E-09_JPRB, 0.53056259E-09_JPRB, 0.53018984E-09_JPRB, 0.52984883E-09_JPRB, &
  & 0.52950122E-09_JPRB, 0.52913168E-09_JPRB, 0.52864557E-09_JPRB, 0.52770305E-09_JPRB /)

RGHG6(:,52, 7) = (/ &
  & 0.52361293E-09_JPRB, 0.52472271E-09_JPRB, 0.52549176E-09_JPRB, 0.52638882E-09_JPRB, 0.52744675E-09_JPRB, 0.52842741E-09_JPRB, &
  & 0.52902799E-09_JPRB, 0.52941240E-09_JPRB, 0.52963989E-09_JPRB, 0.52983296E-09_JPRB, 0.52999882E-09_JPRB, 0.53017835E-09_JPRB, &
  & 0.53037164E-09_JPRB, 0.53055521E-09_JPRB, 0.53070132E-09_JPRB, 0.53079841E-09_JPRB, 0.53085664E-09_JPRB, 0.53089416E-09_JPRB, &
  & 0.53093296E-09_JPRB, 0.53101923E-09_JPRB, 0.53117644E-09_JPRB, 0.53151311E-09_JPRB, 0.53195109E-09_JPRB, 0.53243565E-09_JPRB, &
  & 0.53285709E-09_JPRB, 0.53320426E-09_JPRB, 0.53349825E-09_JPRB, 0.53376009E-09_JPRB, 0.53400601E-09_JPRB, 0.53424132E-09_JPRB, &
  & 0.53446125E-09_JPRB, 0.53464966E-09_JPRB, 0.53478905E-09_JPRB, 0.53486959E-09_JPRB, 0.53489257E-09_JPRB, 0.53486221E-09_JPRB, &
  & 0.53478832E-09_JPRB, 0.53467425E-09_JPRB, 0.53452748E-09_JPRB, 0.53434690E-09_JPRB, 0.53413735E-09_JPRB, 0.53390653E-09_JPRB, &
  & 0.53367771E-09_JPRB, 0.53347204E-09_JPRB, 0.53329985E-09_JPRB, 0.53315380E-09_JPRB, 0.53302657E-09_JPRB, 0.53291638E-09_JPRB, &
  & 0.53281723E-09_JPRB, 0.53273114E-09_JPRB, 0.53265359E-09_JPRB, 0.53257887E-09_JPRB, 0.53250881E-09_JPRB, 0.53243832E-09_JPRB, &
  & 0.53235411E-09_JPRB, 0.53226162E-09_JPRB, 0.53213400E-09_JPRB, 0.53198601E-09_JPRB, 0.53183252E-09_JPRB, 0.53166593E-09_JPRB, &
  & 0.53149696E-09_JPRB, 0.53128602E-09_JPRB, 0.53098387E-09_JPRB, 0.53028137E-09_JPRB /)

RGHG6(:,53, 7) = (/ &
  & 0.52612248E-09_JPRB, 0.52703542E-09_JPRB, 0.52764249E-09_JPRB, 0.52828941E-09_JPRB, 0.52906896E-09_JPRB, 0.52975269E-09_JPRB, &
  & 0.53021232E-09_JPRB, 0.53045734E-09_JPRB, 0.53063215E-09_JPRB, 0.53075422E-09_JPRB, 0.53087418E-09_JPRB, 0.53099941E-09_JPRB, &
  & 0.53113547E-09_JPRB, 0.53126759E-09_JPRB, 0.53136651E-09_JPRB, 0.53142690E-09_JPRB, 0.53145599E-09_JPRB, 0.53146743E-09_JPRB, &
  & 0.53147914E-09_JPRB, 0.53150651E-09_JPRB, 0.53160260E-09_JPRB, 0.53178428E-09_JPRB, 0.53213867E-09_JPRB, 0.53255778E-09_JPRB, &
  & 0.53295873E-09_JPRB, 0.53329574E-09_JPRB, 0.53358151E-09_JPRB, 0.53383703E-09_JPRB, 0.53407606E-09_JPRB, 0.53430615E-09_JPRB, &
  & 0.53452243E-09_JPRB, 0.53470983E-09_JPRB, 0.53485183E-09_JPRB, 0.53493671E-09_JPRB, 0.53496546E-09_JPRB, 0.53494137E-09_JPRB, &
  & 0.53487231E-09_JPRB, 0.53476717E-09_JPRB, 0.53462718E-09_JPRB, 0.53445731E-09_JPRB, 0.53425731E-09_JPRB, 0.53403759E-09_JPRB, &
  & 0.53381988E-09_JPRB, 0.53362731E-09_JPRB, 0.53346649E-09_JPRB, 0.53333610E-09_JPRB, 0.53323052E-09_JPRB, 0.53314431E-09_JPRB, &
  & 0.53307792E-09_JPRB, 0.53302529E-09_JPRB, 0.53298244E-09_JPRB, 0.53294735E-09_JPRB, 0.53291543E-09_JPRB, 0.53288407E-09_JPRB, &
  & 0.53285354E-09_JPRB, 0.53281241E-09_JPRB, 0.53276561E-09_JPRB, 0.53270721E-09_JPRB, 0.53264104E-09_JPRB, 0.53257687E-09_JPRB, &
  & 0.53250099E-09_JPRB, 0.53241189E-09_JPRB, 0.53227805E-09_JPRB, 0.53192584E-09_JPRB /)

RGHG6(:,54, 7) = (/ &
  & 0.52827370E-09_JPRB, 0.52882199E-09_JPRB, 0.52921356E-09_JPRB, 0.52965649E-09_JPRB, 0.53018873E-09_JPRB, 0.53067750E-09_JPRB, &
  & 0.53098020E-09_JPRB, 0.53117116E-09_JPRB, 0.53128174E-09_JPRB, 0.53137406E-09_JPRB, 0.53145560E-09_JPRB, 0.53154436E-09_JPRB, &
  & 0.53164639E-09_JPRB, 0.53174287E-09_JPRB, 0.53181698E-09_JPRB, 0.53185917E-09_JPRB, 0.53187676E-09_JPRB, 0.53188043E-09_JPRB, &
  & 0.53188048E-09_JPRB, 0.53189175E-09_JPRB, 0.53192950E-09_JPRB, 0.53206284E-09_JPRB, 0.53230553E-09_JPRB, 0.53267823E-09_JPRB, &
  & 0.53305482E-09_JPRB, 0.53338117E-09_JPRB, 0.53365984E-09_JPRB, 0.53390775E-09_JPRB, 0.53414151E-09_JPRB, 0.53436583E-09_JPRB, &
  & 0.53457849E-09_JPRB, 0.53476545E-09_JPRB, 0.53490956E-09_JPRB, 0.53499960E-09_JPRB, 0.53503380E-09_JPRB, 0.53501531E-09_JPRB, &
  & 0.53495319E-09_JPRB, 0.53485366E-09_JPRB, 0.53472177E-09_JPRB, 0.53455940E-09_JPRB, 0.53436794E-09_JPRB, 0.53415961E-09_JPRB, &
  & 0.53395299E-09_JPRB, 0.53377114E-09_JPRB, 0.53362276E-09_JPRB, 0.53350391E-09_JPRB, 0.53341065E-09_JPRB, 0.53334137E-09_JPRB, &
  & 0.53329013E-09_JPRB, 0.53325355E-09_JPRB, 0.53322702E-09_JPRB, 0.53320603E-09_JPRB, 0.53318960E-09_JPRB, 0.53317550E-09_JPRB, &
  & 0.53315963E-09_JPRB, 0.53314358E-09_JPRB, 0.53312155E-09_JPRB, 0.53309646E-09_JPRB, 0.53307048E-09_JPRB, 0.53304194E-09_JPRB, &
  & 0.53301435E-09_JPRB, 0.53298510E-09_JPRB, 0.53295979E-09_JPRB, 0.53295662E-09_JPRB /)

RGHG6(:,55, 7) = (/ &
  & 0.52962634E-09_JPRB, 0.53005550E-09_JPRB, 0.53033788E-09_JPRB, 0.53065069E-09_JPRB, 0.53100202E-09_JPRB, 0.53132854E-09_JPRB, &
  & 0.53155447E-09_JPRB, 0.53167748E-09_JPRB, 0.53176341E-09_JPRB, 0.53182470E-09_JPRB, 0.53188420E-09_JPRB, 0.53194960E-09_JPRB, &
  & 0.53202265E-09_JPRB, 0.53209859E-09_JPRB, 0.53215554E-09_JPRB, 0.53218902E-09_JPRB, 0.53220195E-09_JPRB, 0.53220250E-09_JPRB, &
  & 0.53219779E-09_JPRB, 0.53219790E-09_JPRB, 0.53222066E-09_JPRB, 0.53229088E-09_JPRB, 0.53248783E-09_JPRB, 0.53279881E-09_JPRB, &
  & 0.53315041E-09_JPRB, 0.53346377E-09_JPRB, 0.53373383E-09_JPRB, 0.53397620E-09_JPRB, 0.53420285E-09_JPRB, 0.53442284E-09_JPRB, &
  & 0.53463201E-09_JPRB, 0.53481797E-09_JPRB, 0.53496452E-09_JPRB, 0.53505889E-09_JPRB, 0.53509841E-09_JPRB, 0.53508603E-09_JPRB, &
  & 0.53502985E-09_JPRB, 0.53493654E-09_JPRB, 0.53481064E-09_JPRB, 0.53465476E-09_JPRB, 0.53447197E-09_JPRB, 0.53427224E-09_JPRB, &
  & 0.53407873E-09_JPRB, 0.53390842E-09_JPRB, 0.53376964E-09_JPRB, 0.53366023E-09_JPRB, 0.53357707E-09_JPRB, 0.53351540E-09_JPRB, &
  & 0.53347238E-09_JPRB, 0.53344240E-09_JPRB, 0.53342092E-09_JPRB, 0.53340615E-09_JPRB, 0.53339488E-09_JPRB, 0.53338511E-09_JPRB, &
  & 0.53337673E-09_JPRB, 0.53336596E-09_JPRB, 0.53335431E-09_JPRB, 0.53334037E-09_JPRB, 0.53332505E-09_JPRB, 0.53331051E-09_JPRB, &
  & 0.53329419E-09_JPRB, 0.53327720E-09_JPRB, 0.53325810E-09_JPRB, 0.53323362E-09_JPRB /)

RGHG6(:,56, 7) = (/ &
  & 0.53072086E-09_JPRB, 0.53098176E-09_JPRB, 0.53117111E-09_JPRB, 0.53137034E-09_JPRB, 0.53161081E-09_JPRB, 0.53182969E-09_JPRB, &
  & 0.53197990E-09_JPRB, 0.53207594E-09_JPRB, 0.53213328E-09_JPRB, 0.53218024E-09_JPRB, 0.53222327E-09_JPRB, 0.53227045E-09_JPRB, &
  & 0.53232785E-09_JPRB, 0.53238558E-09_JPRB, 0.53243293E-09_JPRB, 0.53246119E-09_JPRB, 0.53247196E-09_JPRB, 0.53247129E-09_JPRB, &
  & 0.53246496E-09_JPRB, 0.53245858E-09_JPRB, 0.53246468E-09_JPRB, 0.53251614E-09_JPRB, 0.53265703E-09_JPRB, 0.53292742E-09_JPRB, &
  & 0.53324861E-09_JPRB, 0.53354665E-09_JPRB, 0.53380739E-09_JPRB, 0.53404198E-09_JPRB, 0.53426413E-09_JPRB, 0.53447857E-09_JPRB, &
  & 0.53468485E-09_JPRB, 0.53486987E-09_JPRB, 0.53501775E-09_JPRB, 0.53511595E-09_JPRB, 0.53516053E-09_JPRB, 0.53515403E-09_JPRB, &
  & 0.53510346E-09_JPRB, 0.53501603E-09_JPRB, 0.53489546E-09_JPRB, 0.53474536E-09_JPRB, 0.53456928E-09_JPRB, 0.53438109E-09_JPRB, &
  & 0.53419824E-09_JPRB, 0.53403937E-09_JPRB, 0.53391042E-09_JPRB, 0.53380889E-09_JPRB, 0.53373184E-09_JPRB, 0.53367583E-09_JPRB, &
  & 0.53363558E-09_JPRB, 0.53360694E-09_JPRB, 0.53358701E-09_JPRB, 0.53357241E-09_JPRB, 0.53356175E-09_JPRB, 0.53355353E-09_JPRB, &
  & 0.53354487E-09_JPRB, 0.53353671E-09_JPRB, 0.53352661E-09_JPRB, 0.53351590E-09_JPRB, 0.53350563E-09_JPRB, 0.53349464E-09_JPRB, &
  & 0.53348392E-09_JPRB, 0.53347188E-09_JPRB, 0.53345867E-09_JPRB, 0.53344024E-09_JPRB /)

RGHG6(:,57, 7) = (/ &
  & 0.53143356E-09_JPRB, 0.53164184E-09_JPRB, 0.53177501E-09_JPRB, 0.53191979E-09_JPRB, 0.53207039E-09_JPRB, 0.53222021E-09_JPRB, &
  & 0.53232962E-09_JPRB, 0.53239491E-09_JPRB, 0.53243998E-09_JPRB, 0.53247373E-09_JPRB, 0.53250615E-09_JPRB, 0.53254312E-09_JPRB, &
  & 0.53258598E-09_JPRB, 0.53263383E-09_JPRB, 0.53267335E-09_JPRB, 0.53269900E-09_JPRB, 0.53270949E-09_JPRB, 0.53270827E-09_JPRB, &
  & 0.53269916E-09_JPRB, 0.53268889E-09_JPRB, 0.53268623E-09_JPRB, 0.53271459E-09_JPRB, 0.53283028E-09_JPRB, 0.53306137E-09_JPRB, &
  & 0.53335225E-09_JPRB, 0.53363181E-09_JPRB, 0.53388194E-09_JPRB, 0.53411003E-09_JPRB, 0.53432558E-09_JPRB, 0.53453630E-09_JPRB, &
  & 0.53473853E-09_JPRB, 0.53492233E-09_JPRB, 0.53507082E-09_JPRB, 0.53517196E-09_JPRB, 0.53522065E-09_JPRB, 0.53521954E-09_JPRB, &
  & 0.53517507E-09_JPRB, 0.53509247E-09_JPRB, 0.53497701E-09_JPRB, 0.53483201E-09_JPRB, 0.53466376E-09_JPRB, 0.53448468E-09_JPRB, &
  & 0.53431409E-09_JPRB, 0.53416616E-09_JPRB, 0.53404525E-09_JPRB, 0.53395088E-09_JPRB, 0.53387927E-09_JPRB, 0.53382598E-09_JPRB, &
  & 0.53378713E-09_JPRB, 0.53375832E-09_JPRB, 0.53373633E-09_JPRB, 0.53372040E-09_JPRB, 0.53370841E-09_JPRB, 0.53369786E-09_JPRB, &
  & 0.53368898E-09_JPRB, 0.53367855E-09_JPRB, 0.53366811E-09_JPRB, 0.53365740E-09_JPRB, 0.53364668E-09_JPRB, 0.53363702E-09_JPRB, &
  & 0.53362659E-09_JPRB, 0.53361543E-09_JPRB, 0.53360222E-09_JPRB, 0.53357985E-09_JPRB /)

RGHG6(:,58, 7) = (/ &
  & 0.53200966E-09_JPRB, 0.53214599E-09_JPRB, 0.53223964E-09_JPRB, 0.53233223E-09_JPRB, 0.53243954E-09_JPRB, 0.53253857E-09_JPRB, &
  & 0.53261573E-09_JPRB, 0.53266652E-09_JPRB, 0.53269966E-09_JPRB, 0.53272636E-09_JPRB, 0.53275218E-09_JPRB, 0.53278071E-09_JPRB, &
  & 0.53281685E-09_JPRB, 0.53285620E-09_JPRB, 0.53289223E-09_JPRB, 0.53291660E-09_JPRB, 0.53292742E-09_JPRB, 0.53292554E-09_JPRB, &
  & 0.53291482E-09_JPRB, 0.53289784E-09_JPRB, 0.53288751E-09_JPRB, 0.53290439E-09_JPRB, 0.53299787E-09_JPRB, 0.53319943E-09_JPRB, &
  & 0.53346166E-09_JPRB, 0.53372212E-09_JPRB, 0.53396054E-09_JPRB, 0.53418070E-09_JPRB, 0.53439081E-09_JPRB, 0.53459620E-09_JPRB, &
  & 0.53479504E-09_JPRB, 0.53497662E-09_JPRB, 0.53512494E-09_JPRB, 0.53522753E-09_JPRB, 0.53527971E-09_JPRB, 0.53528343E-09_JPRB, &
  & 0.53524407E-09_JPRB, 0.53516713E-09_JPRB, 0.53505600E-09_JPRB, 0.53491633E-09_JPRB, 0.53475530E-09_JPRB, 0.53458682E-09_JPRB, &
  & 0.53442761E-09_JPRB, 0.53428872E-09_JPRB, 0.53417670E-09_JPRB, 0.53408772E-09_JPRB, 0.53402038E-09_JPRB, 0.53396954E-09_JPRB, &
  & 0.53393134E-09_JPRB, 0.53390165E-09_JPRB, 0.53387805E-09_JPRB, 0.53385901E-09_JPRB, 0.53384341E-09_JPRB, 0.53383098E-09_JPRB, &
  & 0.53381777E-09_JPRB, 0.53380550E-09_JPRB, 0.53379218E-09_JPRB, 0.53377941E-09_JPRB, 0.53376814E-09_JPRB, 0.53375682E-09_JPRB, &
  & 0.53374594E-09_JPRB, 0.53373406E-09_JPRB, 0.53371996E-09_JPRB, 0.53369675E-09_JPRB /)

RGHG6(:,59, 7) = (/ &
  & 0.53241134E-09_JPRB, 0.53252536E-09_JPRB, 0.53259591E-09_JPRB, 0.53266536E-09_JPRB, 0.53273552E-09_JPRB, 0.53280741E-09_JPRB, &
  & 0.53286364E-09_JPRB, 0.53290228E-09_JPRB, 0.53292903E-09_JPRB, 0.53295091E-09_JPRB, 0.53297183E-09_JPRB, 0.53299676E-09_JPRB, &
  & 0.53302673E-09_JPRB, 0.53306259E-09_JPRB, 0.53309634E-09_JPRB, 0.53312132E-09_JPRB, 0.53313332E-09_JPRB, 0.53313098E-09_JPRB, &
  & 0.53311638E-09_JPRB, 0.53309468E-09_JPRB, 0.53307520E-09_JPRB, 0.53308230E-09_JPRB, 0.53316201E-09_JPRB, 0.53334032E-09_JPRB, &
  & 0.53357635E-09_JPRB, 0.53381777E-09_JPRB, 0.53404475E-09_JPRB, 0.53425681E-09_JPRB, 0.53446081E-09_JPRB, 0.53466076E-09_JPRB, &
  & 0.53485522E-09_JPRB, 0.53503368E-09_JPRB, 0.53518073E-09_JPRB, 0.53528371E-09_JPRB, 0.53533794E-09_JPRB, 0.53534543E-09_JPRB, &
  & 0.53531113E-09_JPRB, 0.53523885E-09_JPRB, 0.53513310E-09_JPRB, 0.53499882E-09_JPRB, 0.53484589E-09_JPRB, 0.53468774E-09_JPRB, &
  & 0.53453825E-09_JPRB, 0.53441018E-09_JPRB, 0.53430349E-09_JPRB, 0.53422072E-09_JPRB, 0.53415661E-09_JPRB, 0.53410776E-09_JPRB, &
  & 0.53407001E-09_JPRB, 0.53403987E-09_JPRB, 0.53401478E-09_JPRB, 0.53399296E-09_JPRB, 0.53397481E-09_JPRB, 0.53395699E-09_JPRB, &
  & 0.53394111E-09_JPRB, 0.53392368E-09_JPRB, 0.53390692E-09_JPRB, 0.53389126E-09_JPRB, 0.53387661E-09_JPRB, 0.53386373E-09_JPRB, &
  & 0.53385041E-09_JPRB, 0.53383642E-09_JPRB, 0.53382010E-09_JPRB, 0.53379179E-09_JPRB /)

RGHG6(:,60, 7) = (/ &
  & 0.53274724E-09_JPRB, 0.53283467E-09_JPRB, 0.53288696E-09_JPRB, 0.53293603E-09_JPRB, 0.53298854E-09_JPRB, 0.53303900E-09_JPRB, &
  & 0.53308280E-09_JPRB, 0.53311361E-09_JPRB, 0.53313642E-09_JPRB, 0.53315496E-09_JPRB, 0.53317417E-09_JPRB, 0.53319582E-09_JPRB, &
  & 0.53322435E-09_JPRB, 0.53325783E-09_JPRB, 0.53329191E-09_JPRB, 0.53331822E-09_JPRB, 0.53333182E-09_JPRB, 0.53332866E-09_JPRB, &
  & 0.53331023E-09_JPRB, 0.53328003E-09_JPRB, 0.53325339E-09_JPRB, 0.53325339E-09_JPRB, 0.53332327E-09_JPRB, 0.53348120E-09_JPRB, &
  & 0.53369464E-09_JPRB, 0.53391913E-09_JPRB, 0.53413435E-09_JPRB, 0.53433891E-09_JPRB, 0.53453619E-09_JPRB, 0.53473082E-09_JPRB, &
  & 0.53491978E-09_JPRB, 0.53509452E-09_JPRB, 0.53523874E-09_JPRB, 0.53534049E-09_JPRB, 0.53539578E-09_JPRB, 0.53540611E-09_JPRB, &
  & 0.53537563E-09_JPRB, 0.53530863E-09_JPRB, 0.53520788E-09_JPRB, 0.53508042E-09_JPRB, 0.53493571E-09_JPRB, 0.53478705E-09_JPRB, &
  & 0.53464949E-09_JPRB, 0.53452764E-09_JPRB, 0.53442939E-09_JPRB, 0.53435006E-09_JPRB, 0.53428922E-09_JPRB, 0.53424171E-09_JPRB, &
  & 0.53420435E-09_JPRB, 0.53417404E-09_JPRB, 0.53414811E-09_JPRB, 0.53412513E-09_JPRB, 0.53410321E-09_JPRB, 0.53408317E-09_JPRB, &
  & 0.53406135E-09_JPRB, 0.53403987E-09_JPRB, 0.53401794E-09_JPRB, 0.53399762E-09_JPRB, 0.53398008E-09_JPRB, 0.53396321E-09_JPRB, &
  & 0.53394683E-09_JPRB, 0.53392962E-09_JPRB, 0.53390881E-09_JPRB, 0.53387433E-09_JPRB /)

RGHG6(:,61, 7) = (/ &
  & 0.53301630E-09_JPRB, 0.53308785E-09_JPRB, 0.53313026E-09_JPRB, 0.53316856E-09_JPRB, 0.53320731E-09_JPRB, 0.53324722E-09_JPRB, &
  & 0.53328136E-09_JPRB, 0.53330818E-09_JPRB, 0.53332805E-09_JPRB, 0.53334581E-09_JPRB, 0.53336341E-09_JPRB, 0.53338528E-09_JPRB, &
  & 0.53341243E-09_JPRB, 0.53344673E-09_JPRB, 0.53348181E-09_JPRB, 0.53351035E-09_JPRB, 0.53352500E-09_JPRB, 0.53352034E-09_JPRB, &
  & 0.53349641E-09_JPRB, 0.53345961E-09_JPRB, 0.53342519E-09_JPRB, 0.53342059E-09_JPRB, 0.53348093E-09_JPRB, 0.53362237E-09_JPRB, &
  & 0.53381588E-09_JPRB, 0.53402516E-09_JPRB, 0.53423022E-09_JPRB, 0.53442678E-09_JPRB, 0.53461829E-09_JPRB, 0.53480603E-09_JPRB, &
  & 0.53498989E-09_JPRB, 0.53515903E-09_JPRB, 0.53529930E-09_JPRB, 0.53539850E-09_JPRB, 0.53545307E-09_JPRB, 0.53546512E-09_JPRB, &
  & 0.53543836E-09_JPRB, 0.53537569E-09_JPRB, 0.53528126E-09_JPRB, 0.53516058E-09_JPRB, 0.53502469E-09_JPRB, 0.53488691E-09_JPRB, &
  & 0.53475696E-09_JPRB, 0.53464577E-09_JPRB, 0.53455129E-09_JPRB, 0.53447746E-09_JPRB, 0.53441873E-09_JPRB, 0.53437266E-09_JPRB, &
  & 0.53433563E-09_JPRB, 0.53430493E-09_JPRB, 0.53427873E-09_JPRB, 0.53425459E-09_JPRB, 0.53423166E-09_JPRB, 0.53420779E-09_JPRB, &
  & 0.53418303E-09_JPRB, 0.53415594E-09_JPRB, 0.53412902E-09_JPRB, 0.53410398E-09_JPRB, 0.53408133E-09_JPRB, 0.53406057E-09_JPRB, &
  & 0.53403976E-09_JPRB, 0.53401711E-09_JPRB, 0.53399074E-09_JPRB, 0.53394372E-09_JPRB /)

RGHG6(:,62, 7) = (/ &
  & 0.53324878E-09_JPRB, 0.53330790E-09_JPRB, 0.53334148E-09_JPRB, 0.53337224E-09_JPRB, 0.53340388E-09_JPRB, 0.53343557E-09_JPRB, &
  & 0.53346549E-09_JPRB, 0.53348925E-09_JPRB, 0.53350907E-09_JPRB, 0.53352639E-09_JPRB, 0.53354510E-09_JPRB, 0.53356686E-09_JPRB, &
  & 0.53359611E-09_JPRB, 0.53363164E-09_JPRB, 0.53366939E-09_JPRB, 0.53369975E-09_JPRB, 0.53371479E-09_JPRB, 0.53370747E-09_JPRB, &
  & 0.53367749E-09_JPRB, 0.53363386E-09_JPRB, 0.53359406E-09_JPRB, 0.53358473E-09_JPRB, 0.53363702E-09_JPRB, 0.53376287E-09_JPRB, &
  & 0.53394011E-09_JPRB, 0.53413568E-09_JPRB, 0.53433119E-09_JPRB, 0.53452115E-09_JPRB, 0.53470600E-09_JPRB, 0.53488813E-09_JPRB, &
  & 0.53506488E-09_JPRB, 0.53522808E-09_JPRB, 0.53536248E-09_JPRB, 0.53545746E-09_JPRB, 0.53551030E-09_JPRB, 0.53552285E-09_JPRB, &
  & 0.53549898E-09_JPRB, 0.53544119E-09_JPRB, 0.53535265E-09_JPRB, 0.53524002E-09_JPRB, 0.53511318E-09_JPRB, 0.53498445E-09_JPRB, &
  & 0.53486571E-09_JPRB, 0.53475963E-09_JPRB, 0.53467297E-09_JPRB, 0.53460192E-09_JPRB, 0.53454602E-09_JPRB, 0.53450100E-09_JPRB, &
  & 0.53446453E-09_JPRB, 0.53443372E-09_JPRB, 0.53440735E-09_JPRB, 0.53438270E-09_JPRB, 0.53435861E-09_JPRB, 0.53433313E-09_JPRB, &
  & 0.53430482E-09_JPRB, 0.53427424E-09_JPRB, 0.53424226E-09_JPRB, 0.53421206E-09_JPRB, 0.53418481E-09_JPRB, 0.53415905E-09_JPRB, &
  & 0.53413285E-09_JPRB, 0.53410498E-09_JPRB, 0.53406907E-09_JPRB, 0.53400706E-09_JPRB /)

RGHG6(:,63, 7) = (/ &
  & 0.53344362E-09_JPRB, 0.53349758E-09_JPRB, 0.53352839E-09_JPRB, 0.53355542E-09_JPRB, 0.53358240E-09_JPRB, 0.53361049E-09_JPRB, &
  & 0.53363680E-09_JPRB, 0.53366045E-09_JPRB, 0.53368027E-09_JPRB, 0.53369947E-09_JPRB, 0.53371957E-09_JPRB, 0.53374483E-09_JPRB, &
  & 0.53377652E-09_JPRB, 0.53381582E-09_JPRB, 0.53385568E-09_JPRB, 0.53388705E-09_JPRB, 0.53390037E-09_JPRB, 0.53388910E-09_JPRB, &
  & 0.53385429E-09_JPRB, 0.53380539E-09_JPRB, 0.53376092E-09_JPRB, 0.53374744E-09_JPRB, 0.53379162E-09_JPRB, 0.53390486E-09_JPRB, &
  & 0.53406718E-09_JPRB, 0.53425098E-09_JPRB, 0.53443799E-09_JPRB, 0.53462101E-09_JPRB, 0.53480043E-09_JPRB, 0.53497573E-09_JPRB, &
  & 0.53514565E-09_JPRB, 0.53530053E-09_JPRB, 0.53542809E-09_JPRB, 0.53551752E-09_JPRB, 0.53556715E-09_JPRB, 0.53557941E-09_JPRB, &
  & 0.53555771E-09_JPRB, 0.53550447E-09_JPRB, 0.53542265E-09_JPRB, 0.53531796E-09_JPRB, 0.53520066E-09_JPRB, 0.53508226E-09_JPRB, &
  & 0.53497090E-09_JPRB, 0.53487403E-09_JPRB, 0.53479132E-09_JPRB, 0.53472504E-09_JPRB, 0.53467114E-09_JPRB, 0.53462745E-09_JPRB, &
  & 0.53459159E-09_JPRB, 0.53456112E-09_JPRB, 0.53453453E-09_JPRB, 0.53450988E-09_JPRB, 0.53448507E-09_JPRB, 0.53445820E-09_JPRB, &
  & 0.53442778E-09_JPRB, 0.53439408E-09_JPRB, 0.53435845E-09_JPRB, 0.53432375E-09_JPRB, 0.53429172E-09_JPRB, 0.53426130E-09_JPRB, &
  & 0.53423066E-09_JPRB, 0.53419613E-09_JPRB, 0.53415222E-09_JPRB, 0.53407151E-09_JPRB /)

RGHG6(:,64, 7) = (/ &
  & 0.53361648E-09_JPRB, 0.53366855E-09_JPRB, 0.53369748E-09_JPRB, 0.53372268E-09_JPRB, 0.53374782E-09_JPRB, 0.53377314E-09_JPRB, &
  & 0.53379878E-09_JPRB, 0.53382210E-09_JPRB, 0.53384425E-09_JPRB, 0.53386551E-09_JPRB, 0.53388971E-09_JPRB, 0.53391835E-09_JPRB, &
  & 0.53395555E-09_JPRB, 0.53399807E-09_JPRB, 0.53403987E-09_JPRB, 0.53407029E-09_JPRB, 0.53408089E-09_JPRB, 0.53406557E-09_JPRB, &
  & 0.53402599E-09_JPRB, 0.53397314E-09_JPRB, 0.53392563E-09_JPRB, 0.53390770E-09_JPRB, 0.53394528E-09_JPRB, 0.53404736E-09_JPRB, &
  & 0.53419735E-09_JPRB, 0.53437033E-09_JPRB, 0.53454896E-09_JPRB, 0.53472560E-09_JPRB, 0.53489851E-09_JPRB, 0.53506727E-09_JPRB, &
  & 0.53522853E-09_JPRB, 0.53537458E-09_JPRB, 0.53549326E-09_JPRB, 0.53557619E-09_JPRB, 0.53562188E-09_JPRB, 0.53563315E-09_JPRB, &
  & 0.53561350E-09_JPRB, 0.53556481E-09_JPRB, 0.53548954E-09_JPRB, 0.53539356E-09_JPRB, 0.53528587E-09_JPRB, 0.53517674E-09_JPRB, &
  & 0.53507510E-09_JPRB, 0.53498406E-09_JPRB, 0.53490778E-09_JPRB, 0.53484467E-09_JPRB, 0.53479327E-09_JPRB, 0.53475102E-09_JPRB, &
  & 0.53471599E-09_JPRB, 0.53468613E-09_JPRB, 0.53465993E-09_JPRB, 0.53463534E-09_JPRB, 0.53461030E-09_JPRB, 0.53458271E-09_JPRB, &
  & 0.53455068E-09_JPRB, 0.53451482E-09_JPRB, 0.53447630E-09_JPRB, 0.53443799E-09_JPRB, 0.53440191E-09_JPRB, 0.53436749E-09_JPRB, &
  & 0.53433247E-09_JPRB, 0.53429416E-09_JPRB, 0.53424165E-09_JPRB, 0.53414417E-09_JPRB /)

RGHG6(:,65, 7) = (/ &
  & 0.53377169E-09_JPRB, 0.53382410E-09_JPRB, 0.53385329E-09_JPRB, 0.53387816E-09_JPRB, 0.53390231E-09_JPRB, 0.53392712E-09_JPRB, &
  & 0.53395155E-09_JPRB, 0.53397675E-09_JPRB, 0.53400045E-09_JPRB, 0.53402638E-09_JPRB, 0.53405458E-09_JPRB, 0.53408983E-09_JPRB, &
  & 0.53413152E-09_JPRB, 0.53417759E-09_JPRB, 0.53421922E-09_JPRB, 0.53424748E-09_JPRB, 0.53425481E-09_JPRB, 0.53423582E-09_JPRB, &
  & 0.53419358E-09_JPRB, 0.53413846E-09_JPRB, 0.53408750E-09_JPRB, 0.53406624E-09_JPRB, 0.53409788E-09_JPRB, 0.53419069E-09_JPRB, &
  & 0.53432953E-09_JPRB, 0.53449239E-09_JPRB, 0.53466298E-09_JPRB, 0.53483223E-09_JPRB, 0.53499810E-09_JPRB, 0.53515881E-09_JPRB, &
  & 0.53531080E-09_JPRB, 0.53544635E-09_JPRB, 0.53555571E-09_JPRB, 0.53563121E-09_JPRB, 0.53567251E-09_JPRB, 0.53568283E-09_JPRB, &
  & 0.53566490E-09_JPRB, 0.53562060E-09_JPRB, 0.53555244E-09_JPRB, 0.53546506E-09_JPRB, 0.53536725E-09_JPRB, 0.53526800E-09_JPRB, &
  & 0.53517429E-09_JPRB, 0.53509114E-09_JPRB, 0.53501975E-09_JPRB, 0.53496074E-09_JPRB, 0.53491150E-09_JPRB, 0.53487115E-09_JPRB, &
  & 0.53483717E-09_JPRB, 0.53480825E-09_JPRB, 0.53478283E-09_JPRB, 0.53475868E-09_JPRB, 0.53473387E-09_JPRB, 0.53470600E-09_JPRB, &
  & 0.53467314E-09_JPRB, 0.53463595E-09_JPRB, 0.53459526E-09_JPRB, 0.53455418E-09_JPRB, 0.53451488E-09_JPRB, 0.53447718E-09_JPRB, &
  & 0.53443933E-09_JPRB, 0.53439791E-09_JPRB, 0.53433952E-09_JPRB, 0.53422816E-09_JPRB /)

RGHG6(:,66, 7) = (/ &
  & 0.53391130E-09_JPRB, 0.53396815E-09_JPRB, 0.53399896E-09_JPRB, 0.53402527E-09_JPRB, 0.53405036E-09_JPRB, 0.53407501E-09_JPRB, &
  & 0.53410054E-09_JPRB, 0.53412574E-09_JPRB, 0.53415383E-09_JPRB, 0.53418259E-09_JPRB, 0.53421761E-09_JPRB, 0.53425753E-09_JPRB, &
  & 0.53430432E-09_JPRB, 0.53435095E-09_JPRB, 0.53439131E-09_JPRB, 0.53441707E-09_JPRB, 0.53442167E-09_JPRB, 0.53440036E-09_JPRB, &
  & 0.53435589E-09_JPRB, 0.53429866E-09_JPRB, 0.53424687E-09_JPRB, 0.53422317E-09_JPRB, 0.53424970E-09_JPRB, 0.53433469E-09_JPRB, &
  & 0.53446308E-09_JPRB, 0.53461607E-09_JPRB, 0.53477756E-09_JPRB, 0.53493859E-09_JPRB, 0.53509597E-09_JPRB, 0.53524746E-09_JPRB, &
  & 0.53538901E-09_JPRB, 0.53551341E-09_JPRB, 0.53561255E-09_JPRB, 0.53568078E-09_JPRB, 0.53571780E-09_JPRB, 0.53572691E-09_JPRB, &
  & 0.53571064E-09_JPRB, 0.53567079E-09_JPRB, 0.53560961E-09_JPRB, 0.53553140E-09_JPRB, 0.53544319E-09_JPRB, 0.53535371E-09_JPRB, &
  & 0.53526883E-09_JPRB, 0.53519261E-09_JPRB, 0.53512694E-09_JPRB, 0.53507176E-09_JPRB, 0.53502558E-09_JPRB, 0.53498728E-09_JPRB, &
  & 0.53495480E-09_JPRB, 0.53492710E-09_JPRB, 0.53490273E-09_JPRB, 0.53487953E-09_JPRB, 0.53485538E-09_JPRB, 0.53482774E-09_JPRB, &
  & 0.53479488E-09_JPRB, 0.53475679E-09_JPRB, 0.53471477E-09_JPRB, 0.53467175E-09_JPRB, 0.53463017E-09_JPRB, 0.53459032E-09_JPRB, &
  & 0.53455051E-09_JPRB, 0.53450772E-09_JPRB, 0.53444565E-09_JPRB, 0.53432508E-09_JPRB /)

RGHG6(:,67, 7) = (/ &
  & 0.53403904E-09_JPRB, 0.53410276E-09_JPRB, 0.53413807E-09_JPRB, 0.53416699E-09_JPRB, 0.53419441E-09_JPRB, 0.53422083E-09_JPRB, &
  & 0.53424665E-09_JPRB, 0.53427468E-09_JPRB, 0.53430366E-09_JPRB, 0.53433896E-09_JPRB, 0.53437704E-09_JPRB, 0.53442256E-09_JPRB, &
  & 0.53446997E-09_JPRB, 0.53451599E-09_JPRB, 0.53455451E-09_JPRB, 0.53457805E-09_JPRB, 0.53458071E-09_JPRB, 0.53455823E-09_JPRB, &
  & 0.53451349E-09_JPRB, 0.53445687E-09_JPRB, 0.53440441E-09_JPRB, 0.53437899E-09_JPRB, 0.53440119E-09_JPRB, 0.53447802E-09_JPRB, &
  & 0.53459687E-09_JPRB, 0.53473931E-09_JPRB, 0.53489080E-09_JPRB, 0.53504245E-09_JPRB, 0.53518984E-09_JPRB, 0.53533089E-09_JPRB, &
  & 0.53546118E-09_JPRB, 0.53557436E-09_JPRB, 0.53566362E-09_JPRB, 0.53572463E-09_JPRB, 0.53575749E-09_JPRB, 0.53576577E-09_JPRB, &
  & 0.53575111E-09_JPRB, 0.53571564E-09_JPRB, 0.53566118E-09_JPRB, 0.53559168E-09_JPRB, 0.53551330E-09_JPRB, 0.53543314E-09_JPRB, &
  & 0.53535704E-09_JPRB, 0.53528815E-09_JPRB, 0.53522820E-09_JPRB, 0.53517740E-09_JPRB, 0.53513460E-09_JPRB, 0.53509891E-09_JPRB, &
  & 0.53506860E-09_JPRB, 0.53504257E-09_JPRB, 0.53501942E-09_JPRB, 0.53499766E-09_JPRB, 0.53497445E-09_JPRB, 0.53494764E-09_JPRB, &
  & 0.53491517E-09_JPRB, 0.53487698E-09_JPRB, 0.53483457E-09_JPRB, 0.53479049E-09_JPRB, 0.53474791E-09_JPRB, 0.53470689E-09_JPRB, &
  & 0.53466620E-09_JPRB, 0.53462285E-09_JPRB, 0.53455868E-09_JPRB, 0.53442922E-09_JPRB /)

RGHG6(:,68, 7) = (/ &
  & 0.53414972E-09_JPRB, 0.53422944E-09_JPRB, 0.53427096E-09_JPRB, 0.53430549E-09_JPRB, 0.53433630E-09_JPRB, 0.53436533E-09_JPRB, &
  & 0.53439347E-09_JPRB, 0.53442245E-09_JPRB, 0.53445603E-09_JPRB, 0.53449212E-09_JPRB, 0.53453536E-09_JPRB, 0.53458066E-09_JPRB, &
  & 0.53462795E-09_JPRB, 0.53467214E-09_JPRB, 0.53470878E-09_JPRB, 0.53473059E-09_JPRB, 0.53473231E-09_JPRB, 0.53470967E-09_JPRB, &
  & 0.53466559E-09_JPRB, 0.53461008E-09_JPRB, 0.53455917E-09_JPRB, 0.53453342E-09_JPRB, 0.53455140E-09_JPRB, 0.53462074E-09_JPRB, &
  & 0.53472926E-09_JPRB, 0.53486060E-09_JPRB, 0.53500132E-09_JPRB, 0.53514215E-09_JPRB, 0.53527877E-09_JPRB, 0.53540844E-09_JPRB, &
  & 0.53552718E-09_JPRB, 0.53562932E-09_JPRB, 0.53570903E-09_JPRB, 0.53576343E-09_JPRB, 0.53579252E-09_JPRB, 0.53579974E-09_JPRB, &
  & 0.53578686E-09_JPRB, 0.53575550E-09_JPRB, 0.53570742E-09_JPRB, 0.53564619E-09_JPRB, 0.53557692E-09_JPRB, 0.53550614E-09_JPRB, &
  & 0.53543847E-09_JPRB, 0.53537719E-09_JPRB, 0.53532317E-09_JPRB, 0.53527699E-09_JPRB, 0.53523813E-09_JPRB, 0.53520555E-09_JPRB, &
  & 0.53517790E-09_JPRB, 0.53515403E-09_JPRB, 0.53513255E-09_JPRB, 0.53511229E-09_JPRB, 0.53509042E-09_JPRB, 0.53506488E-09_JPRB, &
  & 0.53503363E-09_JPRB, 0.53499599E-09_JPRB, 0.53495397E-09_JPRB, 0.53491006E-09_JPRB, 0.53486737E-09_JPRB, 0.53482663E-09_JPRB, &
  & 0.53478610E-09_JPRB, 0.53474403E-09_JPRB, 0.53468074E-09_JPRB, 0.53455118E-09_JPRB /)

RGHG6(:,69, 7) = (/ &
  & 0.53425153E-09_JPRB, 0.53435079E-09_JPRB, 0.53440324E-09_JPRB, 0.53444316E-09_JPRB, 0.53447874E-09_JPRB, 0.53451049E-09_JPRB, &
  & 0.53454052E-09_JPRB, 0.53457189E-09_JPRB, 0.53460658E-09_JPRB, 0.53464549E-09_JPRB, 0.53468807E-09_JPRB, 0.53473326E-09_JPRB, &
  & 0.53477855E-09_JPRB, 0.53482058E-09_JPRB, 0.53485544E-09_JPRB, 0.53487570E-09_JPRB, 0.53487687E-09_JPRB, 0.53485499E-09_JPRB, &
  & 0.53481347E-09_JPRB, 0.53476146E-09_JPRB, 0.53471266E-09_JPRB, 0.53468657E-09_JPRB, 0.53470073E-09_JPRB, 0.53476173E-09_JPRB, &
  & 0.53485982E-09_JPRB, 0.53497951E-09_JPRB, 0.53510835E-09_JPRB, 0.53523763E-09_JPRB, 0.53536248E-09_JPRB, 0.53548044E-09_JPRB, &
  & 0.53558746E-09_JPRB, 0.53567872E-09_JPRB, 0.53574956E-09_JPRB, 0.53579774E-09_JPRB, 0.53582344E-09_JPRB, 0.53582982E-09_JPRB, &
  & 0.53581856E-09_JPRB, 0.53579102E-09_JPRB, 0.53574911E-09_JPRB, 0.53569549E-09_JPRB, 0.53563487E-09_JPRB, 0.53557275E-09_JPRB, &
  & 0.53551363E-09_JPRB, 0.53545979E-09_JPRB, 0.53541188E-09_JPRB, 0.53537091E-09_JPRB, 0.53533583E-09_JPRB, 0.53530697E-09_JPRB, &
  & 0.53528221E-09_JPRB, 0.53526089E-09_JPRB, 0.53524168E-09_JPRB, 0.53522331E-09_JPRB, 0.53520322E-09_JPRB, 0.53517951E-09_JPRB, &
  & 0.53514998E-09_JPRB, 0.53511379E-09_JPRB, 0.53507293E-09_JPRB, 0.53503035E-09_JPRB, 0.53498900E-09_JPRB, 0.53494953E-09_JPRB, &
  & 0.53491050E-09_JPRB, 0.53487026E-09_JPRB, 0.53480981E-09_JPRB, 0.53467974E-09_JPRB /)

RGHG6(:,70, 7) = (/ &
  & 0.53434590E-09_JPRB, 0.53447435E-09_JPRB, 0.53453636E-09_JPRB, 0.53458382E-09_JPRB, 0.53462301E-09_JPRB, 0.53465715E-09_JPRB, &
  & 0.53468890E-09_JPRB, 0.53472204E-09_JPRB, 0.53475724E-09_JPRB, 0.53479615E-09_JPRB, 0.53483695E-09_JPRB, 0.53488014E-09_JPRB, &
  & 0.53492288E-09_JPRB, 0.53496246E-09_JPRB, 0.53499527E-09_JPRB, 0.53501392E-09_JPRB, 0.53501525E-09_JPRB, 0.53499488E-09_JPRB, &
  & 0.53495636E-09_JPRB, 0.53490817E-09_JPRB, 0.53486299E-09_JPRB, 0.53483784E-09_JPRB, 0.53484828E-09_JPRB, 0.53490085E-09_JPRB, &
  & 0.53498772E-09_JPRB, 0.53509525E-09_JPRB, 0.53521187E-09_JPRB, 0.53532856E-09_JPRB, 0.53544141E-09_JPRB, 0.53554738E-09_JPRB, &
  & 0.53564303E-09_JPRB, 0.53572380E-09_JPRB, 0.53578608E-09_JPRB, 0.53582838E-09_JPRB, 0.53585081E-09_JPRB, 0.53585641E-09_JPRB, &
  & 0.53584670E-09_JPRB, 0.53582283E-09_JPRB, 0.53578669E-09_JPRB, 0.53574006E-09_JPRB, 0.53568749E-09_JPRB, 0.53563348E-09_JPRB, &
  & 0.53558280E-09_JPRB, 0.53553595E-09_JPRB, 0.53549465E-09_JPRB, 0.53545857E-09_JPRB, 0.53542787E-09_JPRB, 0.53540250E-09_JPRB, &
  & 0.53538129E-09_JPRB, 0.53536264E-09_JPRB, 0.53534593E-09_JPRB, 0.53532978E-09_JPRB, 0.53531191E-09_JPRB, 0.53529037E-09_JPRB, &
  & 0.53526322E-09_JPRB, 0.53522936E-09_JPRB, 0.53519089E-09_JPRB, 0.53515087E-09_JPRB, 0.53511201E-09_JPRB, 0.53507543E-09_JPRB, &
  & 0.53503879E-09_JPRB, 0.53500165E-09_JPRB, 0.53494559E-09_JPRB, 0.53482380E-09_JPRB /)

RGHG6(:,71, 7) = (/ &
  & 0.53444504E-09_JPRB, 0.53460153E-09_JPRB, 0.53467675E-09_JPRB, 0.53472932E-09_JPRB, 0.53477084E-09_JPRB, 0.53480731E-09_JPRB, &
  & 0.53483984E-09_JPRB, 0.53487298E-09_JPRB, 0.53490912E-09_JPRB, 0.53494370E-09_JPRB, 0.53498395E-09_JPRB, 0.53502269E-09_JPRB, &
  & 0.53506277E-09_JPRB, 0.53509908E-09_JPRB, 0.53512927E-09_JPRB, 0.53514587E-09_JPRB, 0.53514770E-09_JPRB, 0.53512916E-09_JPRB, &
  & 0.53509486E-09_JPRB, 0.53505184E-09_JPRB, 0.53501048E-09_JPRB, 0.53498650E-09_JPRB, 0.53499322E-09_JPRB, 0.53503735E-09_JPRB, &
  & 0.53511268E-09_JPRB, 0.53520777E-09_JPRB, 0.53531118E-09_JPRB, 0.53541549E-09_JPRB, 0.53551585E-09_JPRB, 0.53560967E-09_JPRB, &
  & 0.53569421E-09_JPRB, 0.53576482E-09_JPRB, 0.53581906E-09_JPRB, 0.53585580E-09_JPRB, 0.53587501E-09_JPRB, 0.53588006E-09_JPRB, &
  & 0.53587174E-09_JPRB, 0.53585131E-09_JPRB, 0.53582050E-09_JPRB, 0.53578059E-09_JPRB, 0.53573523E-09_JPRB, 0.53568938E-09_JPRB, &
  & 0.53564586E-09_JPRB, 0.53560661E-09_JPRB, 0.53557087E-09_JPRB, 0.53554006E-09_JPRB, 0.53551358E-09_JPRB, 0.53549204E-09_JPRB, &
  & 0.53547405E-09_JPRB, 0.53545834E-09_JPRB, 0.53544413E-09_JPRB, 0.53543026E-09_JPRB, 0.53541493E-09_JPRB, 0.53539623E-09_JPRB, &
  & 0.53537214E-09_JPRB, 0.53534144E-09_JPRB, 0.53530613E-09_JPRB, 0.53526966E-09_JPRB, 0.53523480E-09_JPRB, 0.53520155E-09_JPRB, &
  & 0.53516880E-09_JPRB, 0.53513471E-09_JPRB, 0.53508570E-09_JPRB, 0.53497606E-09_JPRB /)

RGHG6(:,72, 7) = (/ &
  & 0.53455090E-09_JPRB, 0.53474158E-09_JPRB, 0.53482557E-09_JPRB, 0.53488114E-09_JPRB, 0.53492583E-09_JPRB, 0.53496119E-09_JPRB, &
  & 0.53499438E-09_JPRB, 0.53502813E-09_JPRB, 0.53505889E-09_JPRB, 0.53509508E-09_JPRB, 0.53512661E-09_JPRB, 0.53516463E-09_JPRB, &
  & 0.53519883E-09_JPRB, 0.53523164E-09_JPRB, 0.53525878E-09_JPRB, 0.53527321E-09_JPRB, 0.53527510E-09_JPRB, 0.53525806E-09_JPRB, &
  & 0.53522808E-09_JPRB, 0.53518973E-09_JPRB, 0.53515309E-09_JPRB, 0.53513066E-09_JPRB, 0.53513466E-09_JPRB, 0.53517069E-09_JPRB, &
  & 0.53523436E-09_JPRB, 0.53531640E-09_JPRB, 0.53540705E-09_JPRB, 0.53549826E-09_JPRB, 0.53558630E-09_JPRB, 0.53566773E-09_JPRB, &
  & 0.53574145E-09_JPRB, 0.53580251E-09_JPRB, 0.53584903E-09_JPRB, 0.53588051E-09_JPRB, 0.53589677E-09_JPRB, 0.53590105E-09_JPRB, &
  & 0.53589394E-09_JPRB, 0.53587679E-09_JPRB, 0.53585097E-09_JPRB, 0.53581700E-09_JPRB, 0.53577887E-09_JPRB, 0.53573979E-09_JPRB, &
  & 0.53570415E-09_JPRB, 0.53567062E-09_JPRB, 0.53564103E-09_JPRB, 0.53561489E-09_JPRB, 0.53559257E-09_JPRB, 0.53557486E-09_JPRB, &
  & 0.53556021E-09_JPRB, 0.53554700E-09_JPRB, 0.53553528E-09_JPRB, 0.53552374E-09_JPRB, 0.53551086E-09_JPRB, 0.53549537E-09_JPRB, &
  & 0.53547466E-09_JPRB, 0.53544763E-09_JPRB, 0.53541654E-09_JPRB, 0.53538451E-09_JPRB, 0.53535409E-09_JPRB, 0.53532534E-09_JPRB, &
  & 0.53529625E-09_JPRB, 0.53526605E-09_JPRB, 0.53522248E-09_JPRB, 0.53512550E-09_JPRB /)

RGHG6(:,73, 7) = (/ &
  & 0.53469829E-09_JPRB, 0.53489968E-09_JPRB, 0.53498461E-09_JPRB, 0.53504190E-09_JPRB, 0.53508364E-09_JPRB, 0.53511995E-09_JPRB, &
  & 0.53515187E-09_JPRB, 0.53518134E-09_JPRB, 0.53521410E-09_JPRB, 0.53523919E-09_JPRB, 0.53527394E-09_JPRB, 0.53530119E-09_JPRB, &
  & 0.53533333E-09_JPRB, 0.53536020E-09_JPRB, 0.53538363E-09_JPRB, 0.53539478E-09_JPRB, 0.53539717E-09_JPRB, 0.53538052E-09_JPRB, &
  & 0.53535493E-09_JPRB, 0.53532218E-09_JPRB, 0.53528981E-09_JPRB, 0.53526966E-09_JPRB, 0.53527105E-09_JPRB, 0.53529964E-09_JPRB, &
  & 0.53535187E-09_JPRB, 0.53542148E-09_JPRB, 0.53549865E-09_JPRB, 0.53557708E-09_JPRB, 0.53565236E-09_JPRB, 0.53572213E-09_JPRB, &
  & 0.53578525E-09_JPRB, 0.53583693E-09_JPRB, 0.53587612E-09_JPRB, 0.53590254E-09_JPRB, 0.53591598E-09_JPRB, 0.53591942E-09_JPRB, &
  & 0.53591365E-09_JPRB, 0.53589955E-09_JPRB, 0.53587840E-09_JPRB, 0.53585025E-09_JPRB, 0.53581839E-09_JPRB, 0.53578608E-09_JPRB, &
  & 0.53575644E-09_JPRB, 0.53572924E-09_JPRB, 0.53570470E-09_JPRB, 0.53568305E-09_JPRB, 0.53566451E-09_JPRB, 0.53565047E-09_JPRB, &
  & 0.53563881E-09_JPRB, 0.53562815E-09_JPRB, 0.53561877E-09_JPRB, 0.53560950E-09_JPRB, 0.53559907E-09_JPRB, 0.53558674E-09_JPRB, &
  & 0.53556942E-09_JPRB, 0.53554677E-09_JPRB, 0.53551974E-09_JPRB, 0.53549271E-09_JPRB, 0.53546712E-09_JPRB, 0.53544252E-09_JPRB, &
  & 0.53541771E-09_JPRB, 0.53539095E-09_JPRB, 0.53535298E-09_JPRB, 0.53526789E-09_JPRB /)

RGHG6(:,74, 7) = (/ &
  & 0.53486143E-09_JPRB, 0.53506671E-09_JPRB, 0.53515059E-09_JPRB, 0.53520255E-09_JPRB, 0.53524407E-09_JPRB, 0.53527677E-09_JPRB, &
  & 0.53530574E-09_JPRB, 0.53533544E-09_JPRB, 0.53535881E-09_JPRB, 0.53538785E-09_JPRB, 0.53540905E-09_JPRB, 0.53543819E-09_JPRB, &
  & 0.53546062E-09_JPRB, 0.53548327E-09_JPRB, 0.53550259E-09_JPRB, 0.53550980E-09_JPRB, 0.53551164E-09_JPRB, 0.53549648E-09_JPRB, &
  & 0.53547444E-09_JPRB, 0.53544663E-09_JPRB, 0.53541921E-09_JPRB, 0.53540150E-09_JPRB, 0.53540095E-09_JPRB, 0.53542287E-09_JPRB, &
  & 0.53546473E-09_JPRB, 0.53552213E-09_JPRB, 0.53558613E-09_JPRB, 0.53565186E-09_JPRB, 0.53571469E-09_JPRB, 0.53577287E-09_JPRB, &
  & 0.53582533E-09_JPRB, 0.53586841E-09_JPRB, 0.53590071E-09_JPRB, 0.53592236E-09_JPRB, 0.53593296E-09_JPRB, 0.53593580E-09_JPRB, &
  & 0.53593113E-09_JPRB, 0.53591986E-09_JPRB, 0.53590327E-09_JPRB, 0.53588028E-09_JPRB, 0.53585419E-09_JPRB, 0.53582760E-09_JPRB, &
  & 0.53580423E-09_JPRB, 0.53578197E-09_JPRB, 0.53576238E-09_JPRB, 0.53574484E-09_JPRB, 0.53572985E-09_JPRB, 0.53571930E-09_JPRB, &
  & 0.53571048E-09_JPRB, 0.53570187E-09_JPRB, 0.53569471E-09_JPRB, 0.53568744E-09_JPRB, 0.53567928E-09_JPRB, 0.53566995E-09_JPRB, &
  & 0.53565624E-09_JPRB, 0.53563731E-09_JPRB, 0.53561494E-09_JPRB, 0.53559246E-09_JPRB, 0.53557164E-09_JPRB, 0.53555110E-09_JPRB, &
  & 0.53553029E-09_JPRB, 0.53550731E-09_JPRB, 0.53547483E-09_JPRB, 0.53539861E-09_JPRB /)

RGHG6(:,75, 7) = (/ &
  & 0.53503524E-09_JPRB, 0.53523763E-09_JPRB, 0.53531302E-09_JPRB, 0.53536120E-09_JPRB, 0.53539700E-09_JPRB, 0.53542693E-09_JPRB, &
  & 0.53545318E-09_JPRB, 0.53547666E-09_JPRB, 0.53550187E-09_JPRB, 0.53551891E-09_JPRB, 0.53554416E-09_JPRB, 0.53556104E-09_JPRB, &
  & 0.53558152E-09_JPRB, 0.53559684E-09_JPRB, 0.53561239E-09_JPRB, 0.53561705E-09_JPRB, 0.53561761E-09_JPRB, 0.53560439E-09_JPRB, &
  & 0.53558602E-09_JPRB, 0.53556370E-09_JPRB, 0.53554072E-09_JPRB, 0.53552579E-09_JPRB, 0.53552385E-09_JPRB, 0.53554017E-09_JPRB, &
  & 0.53557236E-09_JPRB, 0.53561838E-09_JPRB, 0.53566945E-09_JPRB, 0.53572241E-09_JPRB, 0.53577326E-09_JPRB, 0.53582017E-09_JPRB, &
  & 0.53586252E-09_JPRB, 0.53589722E-09_JPRB, 0.53592292E-09_JPRB, 0.53594029E-09_JPRB, 0.53594817E-09_JPRB, 0.53595040E-09_JPRB, &
  & 0.53594645E-09_JPRB, 0.53593779E-09_JPRB, 0.53592519E-09_JPRB, 0.53590710E-09_JPRB, 0.53588661E-09_JPRB, 0.53586519E-09_JPRB, &
  & 0.53584759E-09_JPRB, 0.53582994E-09_JPRB, 0.53581456E-09_JPRB, 0.53580085E-09_JPRB, 0.53578897E-09_JPRB, 0.53578164E-09_JPRB, &
  & 0.53577526E-09_JPRB, 0.53576865E-09_JPRB, 0.53576360E-09_JPRB, 0.53575799E-09_JPRB, 0.53575172E-09_JPRB, 0.53574511E-09_JPRB, &
  & 0.53573485E-09_JPRB, 0.53571986E-09_JPRB, 0.53570148E-09_JPRB, 0.53568355E-09_JPRB, 0.53566696E-09_JPRB, 0.53565052E-09_JPRB, &
  & 0.53563326E-09_JPRB, 0.53561450E-09_JPRB, 0.53558591E-09_JPRB, 0.53551963E-09_JPRB /)

RGHG6(:,76, 7) = (/ &
  & 0.53521715E-09_JPRB, 0.53540550E-09_JPRB, 0.53547100E-09_JPRB, 0.53551030E-09_JPRB, 0.53554139E-09_JPRB, 0.53556587E-09_JPRB, &
  & 0.53558730E-09_JPRB, 0.53560956E-09_JPRB, 0.53562610E-09_JPRB, 0.53564475E-09_JPRB, 0.53565874E-09_JPRB, 0.53567628E-09_JPRB, &
  & 0.53568877E-09_JPRB, 0.53569998E-09_JPRB, 0.53571114E-09_JPRB, 0.53571458E-09_JPRB, 0.53571453E-09_JPRB, 0.53570332E-09_JPRB, &
  & 0.53568905E-09_JPRB, 0.53567190E-09_JPRB, 0.53565363E-09_JPRB, 0.53564170E-09_JPRB, 0.53563881E-09_JPRB, 0.53565063E-09_JPRB, &
  & 0.53567428E-09_JPRB, 0.53570987E-09_JPRB, 0.53574839E-09_JPRB, 0.53578919E-09_JPRB, 0.53582805E-09_JPRB, 0.53586369E-09_JPRB, &
  & 0.53589688E-09_JPRB, 0.53592353E-09_JPRB, 0.53594329E-09_JPRB, 0.53595639E-09_JPRB, 0.53596172E-09_JPRB, 0.53596327E-09_JPRB, &
  & 0.53596005E-09_JPRB, 0.53595389E-09_JPRB, 0.53594501E-09_JPRB, 0.53593141E-09_JPRB, 0.53591587E-09_JPRB, 0.53589921E-09_JPRB, &
  & 0.53588672E-09_JPRB, 0.53587323E-09_JPRB, 0.53586174E-09_JPRB, 0.53585147E-09_JPRB, 0.53584254E-09_JPRB, 0.53583815E-09_JPRB, &
  & 0.53583382E-09_JPRB, 0.53582910E-09_JPRB, 0.53582611E-09_JPRB, 0.53582166E-09_JPRB, 0.53581684E-09_JPRB, 0.53581273E-09_JPRB, &
  & 0.53580557E-09_JPRB, 0.53579452E-09_JPRB, 0.53578003E-09_JPRB, 0.53576610E-09_JPRB, 0.53575400E-09_JPRB, 0.53574067E-09_JPRB, &
  & 0.53572780E-09_JPRB, 0.53571242E-09_JPRB, 0.53568955E-09_JPRB, 0.53562832E-09_JPRB /)

RGHG6(:,77, 7) = (/ &
  & 0.53540311E-09_JPRB, 0.53556826E-09_JPRB, 0.53561955E-09_JPRB, 0.53564980E-09_JPRB, 0.53567356E-09_JPRB, 0.53569260E-09_JPRB, &
  & 0.53570848E-09_JPRB, 0.53572502E-09_JPRB, 0.53573940E-09_JPRB, 0.53574872E-09_JPRB, 0.53576366E-09_JPRB, 0.53577326E-09_JPRB, &
  & 0.53578303E-09_JPRB, 0.53578997E-09_JPRB, 0.53579757E-09_JPRB, 0.53580057E-09_JPRB, 0.53580068E-09_JPRB, 0.53579119E-09_JPRB, &
  & 0.53578125E-09_JPRB, 0.53576971E-09_JPRB, 0.53575600E-09_JPRB, 0.53574739E-09_JPRB, 0.53574439E-09_JPRB, 0.53575283E-09_JPRB, &
  & 0.53576915E-09_JPRB, 0.53579530E-09_JPRB, 0.53582205E-09_JPRB, 0.53585120E-09_JPRB, 0.53587845E-09_JPRB, 0.53590365E-09_JPRB, &
  & 0.53592791E-09_JPRB, 0.53594751E-09_JPRB, 0.53596166E-09_JPRB, 0.53597093E-09_JPRB, 0.53597371E-09_JPRB, 0.53597449E-09_JPRB, &
  & 0.53597171E-09_JPRB, 0.53596794E-09_JPRB, 0.53596261E-09_JPRB, 0.53595306E-09_JPRB, 0.53594212E-09_JPRB, 0.53592947E-09_JPRB, &
  & 0.53592197E-09_JPRB, 0.53591198E-09_JPRB, 0.53590377E-09_JPRB, 0.53589666E-09_JPRB, 0.53589022E-09_JPRB, 0.53588867E-09_JPRB, &
  & 0.53588606E-09_JPRB, 0.53588306E-09_JPRB, 0.53588167E-09_JPRB, 0.53587812E-09_JPRB, 0.53587385E-09_JPRB, 0.53587196E-09_JPRB, &
  & 0.53586779E-09_JPRB, 0.53586047E-09_JPRB, 0.53584970E-09_JPRB, 0.53583993E-09_JPRB, 0.53583210E-09_JPRB, 0.53582272E-09_JPRB, &
  & 0.53581312E-09_JPRB, 0.53580224E-09_JPRB, 0.53578325E-09_JPRB, 0.53573035E-09_JPRB /)

RGHG6(:,78, 7) = (/ &
  & 0.53559063E-09_JPRB, 0.53571747E-09_JPRB, 0.53574944E-09_JPRB, 0.53576971E-09_JPRB, 0.53578686E-09_JPRB, 0.53579929E-09_JPRB, &
  & 0.53580923E-09_JPRB, 0.53582150E-09_JPRB, 0.53582938E-09_JPRB, 0.53583515E-09_JPRB, 0.53584465E-09_JPRB, 0.53585253E-09_JPRB, &
  & 0.53585825E-09_JPRB, 0.53586258E-09_JPRB, 0.53586741E-09_JPRB, 0.53587029E-09_JPRB, 0.53587096E-09_JPRB, 0.53586313E-09_JPRB, &
  & 0.53585708E-09_JPRB, 0.53585086E-09_JPRB, 0.53584137E-09_JPRB, 0.53583632E-09_JPRB, 0.53583393E-09_JPRB, 0.53584026E-09_JPRB, &
  & 0.53585070E-09_JPRB, 0.53586940E-09_JPRB, 0.53588606E-09_JPRB, 0.53590488E-09_JPRB, 0.53592203E-09_JPRB, 0.53593768E-09_JPRB, &
  & 0.53595450E-09_JPRB, 0.53596799E-09_JPRB, 0.53597732E-09_JPRB, 0.53598331E-09_JPRB, 0.53598365E-09_JPRB, 0.53598398E-09_JPRB, &
  & 0.53598148E-09_JPRB, 0.53597971E-09_JPRB, 0.53597737E-09_JPRB, 0.53597127E-09_JPRB, 0.53596422E-09_JPRB, 0.53595506E-09_JPRB, &
  & 0.53595173E-09_JPRB, 0.53594462E-09_JPRB, 0.53593907E-09_JPRB, 0.53593441E-09_JPRB, 0.53592997E-09_JPRB, 0.53593063E-09_JPRB, &
  & 0.53592919E-09_JPRB, 0.53592736E-09_JPRB, 0.53592775E-09_JPRB, 0.53592442E-09_JPRB, 0.53592036E-09_JPRB, 0.53592009E-09_JPRB, &
  & 0.53591825E-09_JPRB, 0.53591442E-09_JPRB, 0.53590671E-09_JPRB, 0.53590082E-09_JPRB, 0.53589783E-09_JPRB, 0.53589105E-09_JPRB, &
  & 0.53588545E-09_JPRB, 0.53587812E-09_JPRB, 0.53586624E-09_JPRB, 0.53582394E-09_JPRB /)

RGHG6(:,79, 7) = (/ &
  & 0.53571336E-09_JPRB, 0.53580207E-09_JPRB, 0.53581883E-09_JPRB, 0.53583199E-09_JPRB, 0.53584570E-09_JPRB, 0.53585525E-09_JPRB, &
  & 0.53586113E-09_JPRB, 0.53587190E-09_JPRB, 0.53587673E-09_JPRB, 0.53587906E-09_JPRB, 0.53588789E-09_JPRB, 0.53589372E-09_JPRB, &
  & 0.53589760E-09_JPRB, 0.53590027E-09_JPRB, 0.53590360E-09_JPRB, 0.53590654E-09_JPRB, 0.53590776E-09_JPRB, 0.53590055E-09_JPRB, &
  & 0.53589688E-09_JPRB, 0.53589366E-09_JPRB, 0.53588639E-09_JPRB, 0.53588350E-09_JPRB, 0.53588117E-09_JPRB, 0.53588695E-09_JPRB, &
  & 0.53589438E-09_JPRB, 0.53590954E-09_JPRB, 0.53592064E-09_JPRB, 0.53593385E-09_JPRB, 0.53594562E-09_JPRB, 0.53595606E-09_JPRB, &
  & 0.53596905E-09_JPRB, 0.53597954E-09_JPRB, 0.53598614E-09_JPRB, 0.53599025E-09_JPRB, 0.53598909E-09_JPRB, 0.53598909E-09_JPRB, &
  & 0.53598670E-09_JPRB, 0.53598620E-09_JPRB, 0.53598553E-09_JPRB, 0.53598137E-09_JPRB, 0.53597626E-09_JPRB, 0.53596866E-09_JPRB, &
  & 0.53596783E-09_JPRB, 0.53596189E-09_JPRB, 0.53595772E-09_JPRB, 0.53595423E-09_JPRB, 0.53595062E-09_JPRB, 0.53595273E-09_JPRB, &
  & 0.53595184E-09_JPRB, 0.53595062E-09_JPRB, 0.53595178E-09_JPRB, 0.53594840E-09_JPRB, 0.53594423E-09_JPRB, 0.53594496E-09_JPRB, &
  & 0.53594457E-09_JPRB, 0.53594257E-09_JPRB, 0.53593613E-09_JPRB, 0.53593213E-09_JPRB, 0.53593180E-09_JPRB, 0.53592619E-09_JPRB, &
  & 0.53592242E-09_JPRB, 0.53591809E-09_JPRB, 0.53591159E-09_JPRB, 0.53588339E-09_JPRB /)

RGHG6(:,80, 7) = (/ &
  & 0.53579580E-09_JPRB, 0.53584365E-09_JPRB, 0.53584909E-09_JPRB, 0.53585886E-09_JPRB, 0.53587118E-09_JPRB, 0.53587929E-09_JPRB, &
  & 0.53588428E-09_JPRB, 0.53589316E-09_JPRB, 0.53589766E-09_JPRB, 0.53589810E-09_JPRB, 0.53590776E-09_JPRB, 0.53591209E-09_JPRB, &
  & 0.53591537E-09_JPRB, 0.53591698E-09_JPRB, 0.53591948E-09_JPRB, 0.53592270E-09_JPRB, 0.53592430E-09_JPRB, 0.53591720E-09_JPRB, &
  & 0.53591470E-09_JPRB, 0.53591320E-09_JPRB, 0.53590671E-09_JPRB, 0.53590488E-09_JPRB, 0.53590243E-09_JPRB, 0.53590815E-09_JPRB, &
  & 0.53591426E-09_JPRB, 0.53592797E-09_JPRB, 0.53593657E-09_JPRB, 0.53594723E-09_JPRB, 0.53595628E-09_JPRB, 0.53596438E-09_JPRB, &
  & 0.53597582E-09_JPRB, 0.53598509E-09_JPRB, 0.53599053E-09_JPRB, 0.53599386E-09_JPRB, 0.53599170E-09_JPRB, 0.53599147E-09_JPRB, &
  & 0.53598903E-09_JPRB, 0.53598909E-09_JPRB, 0.53598936E-09_JPRB, 0.53598603E-09_JPRB, 0.53598187E-09_JPRB, 0.53597488E-09_JPRB, &
  & 0.53597510E-09_JPRB, 0.53596966E-09_JPRB, 0.53596594E-09_JPRB, 0.53596294E-09_JPRB, 0.53595967E-09_JPRB, 0.53596261E-09_JPRB, &
  & 0.53596194E-09_JPRB, 0.53596089E-09_JPRB, 0.53596272E-09_JPRB, 0.53595917E-09_JPRB, 0.53595461E-09_JPRB, 0.53595606E-09_JPRB, &
  & 0.53595628E-09_JPRB, 0.53595522E-09_JPRB, 0.53594879E-09_JPRB, 0.53594551E-09_JPRB, 0.53594668E-09_JPRB, 0.53594118E-09_JPRB, &
  & 0.53593852E-09_JPRB, 0.53593552E-09_JPRB, 0.53593369E-09_JPRB, 0.53592231E-09_JPRB /)

RGHG6(:,81, 7) = (/ &
  & 0.53585308E-09_JPRB, 0.53586141E-09_JPRB, 0.53586180E-09_JPRB, 0.53587007E-09_JPRB, 0.53588189E-09_JPRB, 0.53588972E-09_JPRB, &
  & 0.53589327E-09_JPRB, 0.53590404E-09_JPRB, 0.53590643E-09_JPRB, 0.53590810E-09_JPRB, 0.53591465E-09_JPRB, 0.53592047E-09_JPRB, &
  & 0.53592297E-09_JPRB, 0.53592442E-09_JPRB, 0.53592653E-09_JPRB, 0.53592980E-09_JPRB, 0.53593174E-09_JPRB, 0.53592453E-09_JPRB, &
  & 0.53592275E-09_JPRB, 0.53592214E-09_JPRB, 0.53591587E-09_JPRB, 0.53591459E-09_JPRB, 0.53591176E-09_JPRB, 0.53591759E-09_JPRB, &
  & 0.53592308E-09_JPRB, 0.53593635E-09_JPRB, 0.53594373E-09_JPRB, 0.53595317E-09_JPRB, 0.53596116E-09_JPRB, 0.53596816E-09_JPRB, &
  & 0.53597893E-09_JPRB, 0.53598770E-09_JPRB, 0.53599264E-09_JPRB, 0.53599558E-09_JPRB, 0.53599286E-09_JPRB, 0.53599247E-09_JPRB, &
  & 0.53598997E-09_JPRB, 0.53599036E-09_JPRB, 0.53599108E-09_JPRB, 0.53598825E-09_JPRB, 0.53598426E-09_JPRB, 0.53597754E-09_JPRB, &
  & 0.53597832E-09_JPRB, 0.53597310E-09_JPRB, 0.53596944E-09_JPRB, 0.53596660E-09_JPRB, 0.53596350E-09_JPRB, 0.53596699E-09_JPRB, &
  & 0.53596644E-09_JPRB, 0.53596538E-09_JPRB, 0.53596760E-09_JPRB, 0.53596394E-09_JPRB, 0.53595917E-09_JPRB, 0.53596100E-09_JPRB, &
  & 0.53596161E-09_JPRB, 0.53596089E-09_JPRB, 0.53595445E-09_JPRB, 0.53595128E-09_JPRB, 0.53595306E-09_JPRB, 0.53594756E-09_JPRB, &
  & 0.53594518E-09_JPRB, 0.53594279E-09_JPRB, 0.53594307E-09_JPRB, 0.53594917E-09_JPRB /)

RGHG6(:,82, 7) = (/ &
  & 0.53585769E-09_JPRB, 0.53586746E-09_JPRB, 0.53586729E-09_JPRB, 0.53587534E-09_JPRB, 0.53588722E-09_JPRB, 0.53589461E-09_JPRB, &
  & 0.53589960E-09_JPRB, 0.53590671E-09_JPRB, 0.53591098E-09_JPRB, 0.53591109E-09_JPRB, 0.53592081E-09_JPRB, 0.53592397E-09_JPRB, &
  & 0.53592691E-09_JPRB, 0.53592791E-09_JPRB, 0.53592980E-09_JPRB, 0.53593330E-09_JPRB, 0.53593546E-09_JPRB, 0.53592808E-09_JPRB, &
  & 0.53592669E-09_JPRB, 0.53592680E-09_JPRB, 0.53592047E-09_JPRB, 0.53591953E-09_JPRB, 0.53591620E-09_JPRB, 0.53592225E-09_JPRB, &
  & 0.53592730E-09_JPRB, 0.53594085E-09_JPRB, 0.53594729E-09_JPRB, 0.53595622E-09_JPRB, 0.53596350E-09_JPRB, 0.53596988E-09_JPRB, &
  & 0.53598037E-09_JPRB, 0.53598898E-09_JPRB, 0.53599375E-09_JPRB, 0.53599652E-09_JPRB, 0.53599353E-09_JPRB, 0.53599303E-09_JPRB, &
  & 0.53599042E-09_JPRB, 0.53599108E-09_JPRB, 0.53599197E-09_JPRB, 0.53598925E-09_JPRB, 0.53598564E-09_JPRB, 0.53597904E-09_JPRB, &
  & 0.53597982E-09_JPRB, 0.53597471E-09_JPRB, 0.53597121E-09_JPRB, 0.53596844E-09_JPRB, 0.53596533E-09_JPRB, 0.53596927E-09_JPRB, &
  & 0.53596871E-09_JPRB, 0.53596766E-09_JPRB, 0.53597010E-09_JPRB, 0.53596627E-09_JPRB, 0.53596133E-09_JPRB, 0.53596344E-09_JPRB, &
  & 0.53596416E-09_JPRB, 0.53596372E-09_JPRB, 0.53595717E-09_JPRB, 0.53595411E-09_JPRB, 0.53595628E-09_JPRB, 0.53595067E-09_JPRB, &
  & 0.53594856E-09_JPRB, 0.53594612E-09_JPRB, 0.53594629E-09_JPRB, 0.53595128E-09_JPRB /)

RGHG6(:,83, 7) = (/ &
  & 0.53586091E-09_JPRB, 0.53587101E-09_JPRB, 0.53587035E-09_JPRB, 0.53587823E-09_JPRB, 0.53588994E-09_JPRB, 0.53589760E-09_JPRB, &
  & 0.53590060E-09_JPRB, 0.53591143E-09_JPRB, 0.53591320E-09_JPRB, 0.53591576E-09_JPRB, 0.53592047E-09_JPRB, 0.53592664E-09_JPRB, &
  & 0.53592886E-09_JPRB, 0.53592991E-09_JPRB, 0.53593180E-09_JPRB, 0.53593513E-09_JPRB, 0.53593746E-09_JPRB, 0.53593002E-09_JPRB, &
  & 0.53592891E-09_JPRB, 0.53592963E-09_JPRB, 0.53592319E-09_JPRB, 0.53592231E-09_JPRB, 0.53591870E-09_JPRB, 0.53592492E-09_JPRB, &
  & 0.53592975E-09_JPRB, 0.53594323E-09_JPRB, 0.53594951E-09_JPRB, 0.53595789E-09_JPRB, 0.53596494E-09_JPRB, 0.53597093E-09_JPRB, &
  & 0.53598131E-09_JPRB, 0.53598981E-09_JPRB, 0.53599464E-09_JPRB, 0.53599719E-09_JPRB, 0.53599386E-09_JPRB, 0.53599325E-09_JPRB, &
  & 0.53599075E-09_JPRB, 0.53599153E-09_JPRB, 0.53599253E-09_JPRB, 0.53598992E-09_JPRB, 0.53598626E-09_JPRB, 0.53597982E-09_JPRB, &
  & 0.53598059E-09_JPRB, 0.53597571E-09_JPRB, 0.53597210E-09_JPRB, 0.53596955E-09_JPRB, 0.53596638E-09_JPRB, 0.53597049E-09_JPRB, &
  & 0.53596999E-09_JPRB, 0.53596888E-09_JPRB, 0.53597149E-09_JPRB, 0.53596771E-09_JPRB, 0.53596261E-09_JPRB, 0.53596494E-09_JPRB, &
  & 0.53596577E-09_JPRB, 0.53596538E-09_JPRB, 0.53595867E-09_JPRB, 0.53595572E-09_JPRB, 0.53595822E-09_JPRB, 0.53595239E-09_JPRB, &
  & 0.53595034E-09_JPRB, 0.53594790E-09_JPRB, 0.53594823E-09_JPRB, 0.53595289E-09_JPRB /)

RGHG6(:,84, 7) = (/ &
  & 0.53586313E-09_JPRB, 0.53587340E-09_JPRB, 0.53587218E-09_JPRB, 0.53588001E-09_JPRB, 0.53589200E-09_JPRB, 0.53589927E-09_JPRB, &
  & 0.53590482E-09_JPRB, 0.53591054E-09_JPRB, 0.53591526E-09_JPRB, 0.53591576E-09_JPRB, 0.53592430E-09_JPRB, 0.53592719E-09_JPRB, &
  & 0.53592997E-09_JPRB, 0.53593108E-09_JPRB, 0.53593280E-09_JPRB, 0.53593618E-09_JPRB, 0.53593852E-09_JPRB, 0.53593130E-09_JPRB, &
  & 0.53593047E-09_JPRB, 0.53593130E-09_JPRB, 0.53592469E-09_JPRB, 0.53592414E-09_JPRB, 0.53592020E-09_JPRB, 0.53592680E-09_JPRB, &
  & 0.53593091E-09_JPRB, 0.53594529E-09_JPRB, 0.53595062E-09_JPRB, 0.53595911E-09_JPRB, 0.53596566E-09_JPRB, 0.53597160E-09_JPRB, &
  & 0.53598181E-09_JPRB, 0.53599031E-09_JPRB, 0.53599503E-09_JPRB, 0.53599758E-09_JPRB, 0.53599414E-09_JPRB, 0.53599342E-09_JPRB, &
  & 0.53599092E-09_JPRB, 0.53599175E-09_JPRB, 0.53599286E-09_JPRB, 0.53599031E-09_JPRB, 0.53598670E-09_JPRB, 0.53598032E-09_JPRB, &
  & 0.53598115E-09_JPRB, 0.53597626E-09_JPRB, 0.53597277E-09_JPRB, 0.53597016E-09_JPRB, 0.53596716E-09_JPRB, 0.53597121E-09_JPRB, &
  & 0.53597060E-09_JPRB, 0.53596971E-09_JPRB, 0.53597249E-09_JPRB, 0.53596871E-09_JPRB, 0.53596333E-09_JPRB, 0.53596572E-09_JPRB, &
  & 0.53596683E-09_JPRB, 0.53596649E-09_JPRB, 0.53595972E-09_JPRB, 0.53595672E-09_JPRB, 0.53595939E-09_JPRB, 0.53595350E-09_JPRB, &
  & 0.53595151E-09_JPRB, 0.53594912E-09_JPRB, 0.53594951E-09_JPRB, 0.53595395E-09_JPRB /)

RGHG6(:,85, 7) = (/ &
  & 0.53586469E-09_JPRB, 0.53587496E-09_JPRB, 0.53587335E-09_JPRB, 0.53588117E-09_JPRB, 0.53589311E-09_JPRB, 0.53590099E-09_JPRB, &
  & 0.53590388E-09_JPRB, 0.53591448E-09_JPRB, 0.53591609E-09_JPRB, 0.53591942E-09_JPRB, 0.53592308E-09_JPRB, 0.53592808E-09_JPRB, &
  & 0.53593036E-09_JPRB, 0.53593174E-09_JPRB, 0.53593358E-09_JPRB, 0.53593663E-09_JPRB, 0.53593863E-09_JPRB, 0.53593230E-09_JPRB, &
  & 0.53593147E-09_JPRB, 0.53593241E-09_JPRB, 0.53592580E-09_JPRB, 0.53592547E-09_JPRB, 0.53592114E-09_JPRB, 0.53592791E-09_JPRB, &
  & 0.53593208E-09_JPRB, 0.53594618E-09_JPRB, 0.53595167E-09_JPRB, 0.53595967E-09_JPRB, 0.53596633E-09_JPRB, 0.53597204E-09_JPRB, &
  & 0.53598231E-09_JPRB, 0.53599070E-09_JPRB, 0.53599541E-09_JPRB, 0.53599791E-09_JPRB, 0.53599430E-09_JPRB, 0.53599353E-09_JPRB, &
  & 0.53599097E-09_JPRB, 0.53599197E-09_JPRB, 0.53599308E-09_JPRB, 0.53599059E-09_JPRB, 0.53598709E-09_JPRB, 0.53598076E-09_JPRB, &
  & 0.53598148E-09_JPRB, 0.53597682E-09_JPRB, 0.53597293E-09_JPRB, 0.53597049E-09_JPRB, 0.53596766E-09_JPRB, 0.53597160E-09_JPRB, &
  & 0.53597105E-09_JPRB, 0.53597021E-09_JPRB, 0.53597310E-09_JPRB, 0.53596938E-09_JPRB, 0.53596388E-09_JPRB, 0.53596633E-09_JPRB, &
  & 0.53596749E-09_JPRB, 0.53596738E-09_JPRB, 0.53596033E-09_JPRB, 0.53595745E-09_JPRB, 0.53596028E-09_JPRB, 0.53595434E-09_JPRB, &
  & 0.53595228E-09_JPRB, 0.53594990E-09_JPRB, 0.53595028E-09_JPRB, 0.53595478E-09_JPRB /)

RGHG6(:,86, 7) = (/ &
  & 0.53586569E-09_JPRB, 0.53587590E-09_JPRB, 0.53587390E-09_JPRB, 0.53588189E-09_JPRB, 0.53589466E-09_JPRB, 0.53590121E-09_JPRB, &
  & 0.53590837E-09_JPRB, 0.53591259E-09_JPRB, 0.53591787E-09_JPRB, 0.53591914E-09_JPRB, 0.53592530E-09_JPRB, 0.53592797E-09_JPRB, &
  & 0.53593052E-09_JPRB, 0.53593208E-09_JPRB, 0.53593385E-09_JPRB, 0.53593641E-09_JPRB, 0.53593807E-09_JPRB, 0.53593324E-09_JPRB, &
  & 0.53593230E-09_JPRB, 0.53593313E-09_JPRB, 0.53592653E-09_JPRB, 0.53592619E-09_JPRB, 0.53592170E-09_JPRB, 0.53592863E-09_JPRB, &
  & 0.53593219E-09_JPRB, 0.53594729E-09_JPRB, 0.53595195E-09_JPRB, 0.53596033E-09_JPRB, 0.53596649E-09_JPRB, 0.53597221E-09_JPRB, &
  & 0.53598259E-09_JPRB, 0.53599103E-09_JPRB, 0.53599575E-09_JPRB, 0.53599819E-09_JPRB, 0.53599436E-09_JPRB, 0.53599358E-09_JPRB, &
  & 0.53599103E-09_JPRB, 0.53599214E-09_JPRB, 0.53599342E-09_JPRB, 0.53599086E-09_JPRB, 0.53598725E-09_JPRB, 0.53598070E-09_JPRB, &
  & 0.53598187E-09_JPRB, 0.53597687E-09_JPRB, 0.53597338E-09_JPRB, 0.53597071E-09_JPRB, 0.53596821E-09_JPRB, 0.53597188E-09_JPRB, &
  & 0.53597138E-09_JPRB, 0.53597060E-09_JPRB, 0.53597332E-09_JPRB, 0.53596982E-09_JPRB, 0.53596416E-09_JPRB, 0.53596672E-09_JPRB, &
  & 0.53596805E-09_JPRB, 0.53596794E-09_JPRB, 0.53596078E-09_JPRB, 0.53595789E-09_JPRB, 0.53596083E-09_JPRB, 0.53595495E-09_JPRB, &
  & 0.53595278E-09_JPRB, 0.53595034E-09_JPRB, 0.53595089E-09_JPRB, 0.53595528E-09_JPRB /)

RGHG6(:,87, 7) = (/ &
  & 0.53586641E-09_JPRB, 0.53587640E-09_JPRB, 0.53587446E-09_JPRB, 0.53588278E-09_JPRB, 0.53589400E-09_JPRB, 0.53590365E-09_JPRB, &
  & 0.53590637E-09_JPRB, 0.53591642E-09_JPRB, 0.53591820E-09_JPRB, 0.53592175E-09_JPRB, 0.53592475E-09_JPRB, 0.53592830E-09_JPRB, &
  & 0.53593036E-09_JPRB, 0.53593197E-09_JPRB, 0.53593374E-09_JPRB, 0.53593607E-09_JPRB, 0.53593746E-09_JPRB, 0.53593374E-09_JPRB, &
  & 0.53593280E-09_JPRB, 0.53593341E-09_JPRB, 0.53592714E-09_JPRB, 0.53592675E-09_JPRB, 0.53592225E-09_JPRB, 0.53592925E-09_JPRB, &
  & 0.53593274E-09_JPRB, 0.53594751E-09_JPRB, 0.53595223E-09_JPRB, 0.53596039E-09_JPRB, 0.53596660E-09_JPRB, 0.53597221E-09_JPRB, &
  & 0.53598287E-09_JPRB, 0.53599147E-09_JPRB, 0.53599614E-09_JPRB, 0.53599841E-09_JPRB, 0.53599447E-09_JPRB, 0.53599353E-09_JPRB, &
  & 0.53599092E-09_JPRB, 0.53599214E-09_JPRB, 0.53599369E-09_JPRB, 0.53599114E-09_JPRB, 0.53598759E-09_JPRB, 0.53598054E-09_JPRB, &
  & 0.53598209E-09_JPRB, 0.53597704E-09_JPRB, 0.53597338E-09_JPRB, 0.53597093E-09_JPRB, 0.53596860E-09_JPRB, 0.53597188E-09_JPRB, &
  & 0.53597149E-09_JPRB, 0.53597093E-09_JPRB, 0.53597338E-09_JPRB, 0.53596999E-09_JPRB, 0.53596466E-09_JPRB, 0.53596699E-09_JPRB, &
  & 0.53596838E-09_JPRB, 0.53596844E-09_JPRB, 0.53596111E-09_JPRB, 0.53595822E-09_JPRB, 0.53596116E-09_JPRB, 0.53595517E-09_JPRB, &
  & 0.53595306E-09_JPRB, 0.53595084E-09_JPRB, 0.53595134E-09_JPRB, 0.53595567E-09_JPRB /)

RGHG6(:,88, 7) = (/ &
  & 0.53586713E-09_JPRB, 0.53587668E-09_JPRB, 0.53587501E-09_JPRB, 0.53588256E-09_JPRB, 0.53589616E-09_JPRB, 0.53590221E-09_JPRB, &
  & 0.53591048E-09_JPRB, 0.53591437E-09_JPRB, 0.53591931E-09_JPRB, 0.53592092E-09_JPRB, 0.53592575E-09_JPRB, 0.53592825E-09_JPRB, &
  & 0.53593058E-09_JPRB, 0.53593213E-09_JPRB, 0.53593374E-09_JPRB, 0.53593580E-09_JPRB, 0.53593718E-09_JPRB, 0.53593402E-09_JPRB, &
  & 0.53593313E-09_JPRB, 0.53593380E-09_JPRB, 0.53592730E-09_JPRB, 0.53592714E-09_JPRB, 0.53592258E-09_JPRB, 0.53592941E-09_JPRB, &
  & 0.53593263E-09_JPRB, 0.53594790E-09_JPRB, 0.53595223E-09_JPRB, 0.53596061E-09_JPRB, 0.53596655E-09_JPRB, 0.53597227E-09_JPRB, &
  & 0.53598298E-09_JPRB, 0.53599153E-09_JPRB, 0.53599630E-09_JPRB, 0.53599869E-09_JPRB, 0.53599458E-09_JPRB, 0.53599358E-09_JPRB, &
  & 0.53599092E-09_JPRB, 0.53599225E-09_JPRB, 0.53599414E-09_JPRB, 0.53599147E-09_JPRB, 0.53598781E-09_JPRB, 0.53598015E-09_JPRB, &
  & 0.53598248E-09_JPRB, 0.53597687E-09_JPRB, 0.53597338E-09_JPRB, 0.53597099E-09_JPRB, 0.53596882E-09_JPRB, 0.53597182E-09_JPRB, &
  & 0.53597154E-09_JPRB, 0.53597121E-09_JPRB, 0.53597332E-09_JPRB, 0.53597021E-09_JPRB, 0.53596499E-09_JPRB, 0.53596716E-09_JPRB, &
  & 0.53596860E-09_JPRB, 0.53596866E-09_JPRB, 0.53596122E-09_JPRB, 0.53595833E-09_JPRB, 0.53596144E-09_JPRB, 0.53595528E-09_JPRB, &
  & 0.53595323E-09_JPRB, 0.53595089E-09_JPRB, 0.53595151E-09_JPRB, 0.53595600E-09_JPRB /)

RGHG6(:,89, 7) = (/ &
  & 0.53586813E-09_JPRB, 0.53587657E-09_JPRB, 0.53587562E-09_JPRB, 0.53588295E-09_JPRB, 0.53589433E-09_JPRB, 0.53590415E-09_JPRB, &
  & 0.53590743E-09_JPRB, 0.53591664E-09_JPRB, 0.53591870E-09_JPRB, 0.53592181E-09_JPRB, 0.53592508E-09_JPRB, 0.53592847E-09_JPRB, &
  & 0.53593063E-09_JPRB, 0.53593219E-09_JPRB, 0.53593385E-09_JPRB, 0.53593618E-09_JPRB, 0.53593768E-09_JPRB, 0.53593385E-09_JPRB, &
  & 0.53593313E-09_JPRB, 0.53593396E-09_JPRB, 0.53592736E-09_JPRB, 0.53592730E-09_JPRB, 0.53592270E-09_JPRB, 0.53592963E-09_JPRB, &
  & 0.53593274E-09_JPRB, 0.53594823E-09_JPRB, 0.53595234E-09_JPRB, 0.53596072E-09_JPRB, 0.53596660E-09_JPRB, 0.53597221E-09_JPRB, &
  & 0.53598315E-09_JPRB, 0.53599170E-09_JPRB, 0.53599652E-09_JPRB, 0.53599902E-09_JPRB, 0.53599458E-09_JPRB, 0.53599347E-09_JPRB, &
  & 0.53599075E-09_JPRB, 0.53599225E-09_JPRB, 0.53599442E-09_JPRB, 0.53599170E-09_JPRB, 0.53598820E-09_JPRB, 0.53597976E-09_JPRB, &
  & 0.53598281E-09_JPRB, 0.53597687E-09_JPRB, 0.53597332E-09_JPRB, 0.53597093E-09_JPRB, 0.53596877E-09_JPRB, 0.53597177E-09_JPRB, &
  & 0.53597160E-09_JPRB, 0.53597127E-09_JPRB, 0.53597327E-09_JPRB, 0.53597027E-09_JPRB, 0.53596527E-09_JPRB, 0.53596738E-09_JPRB, &
  & 0.53596882E-09_JPRB, 0.53596888E-09_JPRB, 0.53596133E-09_JPRB, 0.53595850E-09_JPRB, 0.53596172E-09_JPRB, 0.53595545E-09_JPRB, &
  & 0.53595334E-09_JPRB, 0.53595106E-09_JPRB, 0.53595151E-09_JPRB, 0.53595617E-09_JPRB /)

RGHG6(:,90, 7) = (/ &
  & 0.53586868E-09_JPRB, 0.53587629E-09_JPRB, 0.53587557E-09_JPRB, 0.53588223E-09_JPRB, 0.53589505E-09_JPRB, 0.53590221E-09_JPRB, &
  & 0.53590865E-09_JPRB, 0.53591426E-09_JPRB, 0.53591831E-09_JPRB, 0.53591986E-09_JPRB, 0.53592553E-09_JPRB, 0.53592880E-09_JPRB, &
  & 0.53593119E-09_JPRB, 0.53593252E-09_JPRB, 0.53593419E-09_JPRB, 0.53593691E-09_JPRB, 0.53593890E-09_JPRB, 0.53593363E-09_JPRB, &
  & 0.53593302E-09_JPRB, 0.53593441E-09_JPRB, 0.53592702E-09_JPRB, 0.53592741E-09_JPRB, 0.53592247E-09_JPRB, 0.53592980E-09_JPRB, &
  & 0.53593241E-09_JPRB, 0.53594856E-09_JPRB, 0.53595228E-09_JPRB, 0.53596078E-09_JPRB, 0.53596644E-09_JPRB, 0.53597193E-09_JPRB, &
  & 0.53598326E-09_JPRB, 0.53599203E-09_JPRB, 0.53599680E-09_JPRB, 0.53599941E-09_JPRB, 0.53599447E-09_JPRB, 0.53599347E-09_JPRB, &
  & 0.53599059E-09_JPRB, 0.53599220E-09_JPRB, 0.53599469E-09_JPRB, 0.53599181E-09_JPRB, 0.53598842E-09_JPRB, 0.53597915E-09_JPRB, &
  & 0.53598348E-09_JPRB, 0.53597682E-09_JPRB, 0.53597327E-09_JPRB, 0.53597082E-09_JPRB, 0.53596849E-09_JPRB, 0.53597193E-09_JPRB, &
  & 0.53597160E-09_JPRB, 0.53597127E-09_JPRB, 0.53597349E-09_JPRB, 0.53597043E-09_JPRB, 0.53596516E-09_JPRB, 0.53596744E-09_JPRB, &
  & 0.53596916E-09_JPRB, 0.53596921E-09_JPRB, 0.53596128E-09_JPRB, 0.53595822E-09_JPRB, 0.53596200E-09_JPRB, 0.53595545E-09_JPRB, &
  & 0.53595339E-09_JPRB, 0.53595101E-09_JPRB, 0.53595156E-09_JPRB, 0.53595622E-09_JPRB /)

RGHG6(:,91, 7) = (/ &
  & 0.53586796E-09_JPRB, 0.53587590E-09_JPRB, 0.53587440E-09_JPRB, 0.53588156E-09_JPRB, 0.53589455E-09_JPRB, 0.53590193E-09_JPRB, &
  & 0.53590299E-09_JPRB, 0.53591603E-09_JPRB, 0.53591659E-09_JPRB, 0.53591581E-09_JPRB, 0.53592775E-09_JPRB, 0.53593130E-09_JPRB, &
  & 0.53593285E-09_JPRB, 0.53593252E-09_JPRB, 0.53593346E-09_JPRB, 0.53593813E-09_JPRB, 0.53594240E-09_JPRB, 0.53593169E-09_JPRB, &
  & 0.53593263E-09_JPRB, 0.53593541E-09_JPRB, 0.53592641E-09_JPRB, 0.53592786E-09_JPRB, 0.53592158E-09_JPRB, 0.53593002E-09_JPRB, &
  & 0.53593152E-09_JPRB, 0.53594940E-09_JPRB, 0.53595200E-09_JPRB, 0.53596094E-09_JPRB, 0.53596633E-09_JPRB, 0.53597127E-09_JPRB, &
  & 0.53598359E-09_JPRB, 0.53599225E-09_JPRB, 0.53599708E-09_JPRB, 0.53600013E-09_JPRB, 0.53599419E-09_JPRB, 0.53599364E-09_JPRB, &
  & 0.53599031E-09_JPRB, 0.53599220E-09_JPRB, 0.53599508E-09_JPRB, 0.53599192E-09_JPRB, 0.53598892E-09_JPRB, 0.53597793E-09_JPRB, &
  & 0.53598498E-09_JPRB, 0.53597654E-09_JPRB, 0.53597304E-09_JPRB, 0.53597088E-09_JPRB, 0.53596722E-09_JPRB, 0.53597277E-09_JPRB, &
  & 0.53597177E-09_JPRB, 0.53597105E-09_JPRB, 0.53597432E-09_JPRB, 0.53597077E-09_JPRB, 0.53596405E-09_JPRB, 0.53596755E-09_JPRB, &
  & 0.53596927E-09_JPRB, 0.53596977E-09_JPRB, 0.53596089E-09_JPRB, 0.53595783E-09_JPRB, 0.53596261E-09_JPRB, 0.53595511E-09_JPRB, &
  & 0.53595339E-09_JPRB, 0.53595078E-09_JPRB, 0.53595162E-09_JPRB, 0.53595645E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART14',1,ZHOOK_HANDLE)
END SUBROUTINE PART14






SUBROUTINE PART15
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART15',0,ZHOOK_HANDLE)



!-- Month=  8 ------------

RGHG6(:, 1, 8) = (/ &
  & 0.36901766E-38_JPRB, 0.52205416E-38_JPRB, 0.80502593E-38_JPRB, 0.12449022E-37_JPRB, 0.18290489E-37_JPRB, 0.27924246E-37_JPRB, &
  & 0.45686652E-37_JPRB, 0.79923142E-37_JPRB, 0.14761664E-36_JPRB, 0.28423922E-36_JPRB, 0.56534290E-36_JPRB, 0.11519676E-35_JPRB, &
  & 0.23841462E-35_JPRB, 0.49556310E-35_JPRB, 0.10221588E-34_JPRB, 0.20695505E-34_JPRB, 0.40821504E-34_JPRB, 0.78383065E-34_JPRB, &
  & 0.14702002E-33_JPRB, 0.27266576E-33_JPRB, 0.50594443E-33_JPRB, 0.94364187E-33_JPRB, 0.17602089E-32_JPRB, 0.32463782E-32_JPRB, &
  & 0.58092619E-32_JPRB, 0.97295535E-32_JPRB, 0.15139549E-31_JPRB, 0.21898227E-31_JPRB, 0.30371486E-31_JPRB, 0.40328960E-31_JPRB, &
  & 0.50028828E-31_JPRB, 0.57863210E-31_JPRB, 0.63528170E-31_JPRB, 0.67015386E-31_JPRB, 0.68982381E-31_JPRB, 0.69640646E-31_JPRB, &
  & 0.68882082E-31_JPRB, 0.66183136E-31_JPRB, 0.61477655E-31_JPRB, 0.54196937E-31_JPRB, 0.45797827E-31_JPRB, 0.37301783E-31_JPRB, &
  & 0.29159754E-31_JPRB, 0.21876717E-31_JPRB, 0.15580056E-31_JPRB, 0.10440761E-31_JPRB, 0.65274393E-32_JPRB, 0.38575228E-32_JPRB, &
  & 0.22455592E-32_JPRB, 0.12635619E-32_JPRB, 0.70460233E-33_JPRB, 0.39160024E-33_JPRB, 0.21884151E-33_JPRB, 0.12270058E-33_JPRB, &
  & 0.69342716E-34_JPRB, 0.39800141E-34_JPRB, 0.23249239E-34_JPRB, 0.14027780E-34_JPRB, 0.88431405E-35_JPRB, 0.60134274E-35_JPRB, &
  & 0.42001997E-35_JPRB, 0.27500787E-35_JPRB, 0.10288816E-35_JPRB, 0.11129824E-36_JPRB /)

RGHG6(:, 2, 8) = (/ &
  & 0.14478277E-36_JPRB, 0.23515322E-36_JPRB, 0.36641489E-36_JPRB, 0.54665810E-36_JPRB, 0.81279732E-36_JPRB, 0.12675200E-35_JPRB, &
  & 0.21131845E-35_JPRB, 0.37533526E-35_JPRB, 0.70070799E-35_JPRB, 0.13585208E-34_JPRB, 0.27103875E-34_JPRB, 0.55169738E-34_JPRB, &
  & 0.11354093E-33_JPRB, 0.23371071E-33_JPRB, 0.47591960E-33_JPRB, 0.94989724E-33_JPRB, 0.18479166E-32_JPRB, 0.35043760E-32_JPRB, &
  & 0.65015344E-32_JPRB, 0.11912626E-31_JPRB, 0.21756233E-31_JPRB, 0.39804795E-31_JPRB, 0.72823891E-31_JPRB, 0.13226018E-30_JPRB, &
  & 0.23369622E-30_JPRB, 0.38920562E-30_JPRB, 0.60326521E-30_JPRB, 0.87091342E-30_JPRB, 0.12028279E-29_JPRB, 0.15951396E-29_JPRB, &
  & 0.19809164E-29_JPRB, 0.22986689E-29_JPRB, 0.25315851E-29_JPRB, 0.26766766E-29_JPRB, 0.27557855E-29_JPRB, 0.27774782E-29_JPRB, &
  & 0.27387796E-29_JPRB, 0.26233242E-29_JPRB, 0.24273165E-29_JPRB, 0.21504296E-29_JPRB, 0.18235280E-29_JPRB, 0.14803339E-29_JPRB, &
  & 0.11535254E-29_JPRB, 0.86397979E-30_JPRB, 0.61600282E-30_JPRB, 0.41448062E-30_JPRB, 0.26125698E-30_JPRB, 0.15689432E-30_JPRB, &
  & 0.91503160E-31_JPRB, 0.51702785E-31_JPRB, 0.28913317E-31_JPRB, 0.16115499E-31_JPRB, 0.90234583E-32_JPRB, 0.50633872E-32_JPRB, &
  & 0.28586276E-32_JPRB, 0.16358633E-32_JPRB, 0.95220672E-33_JPRB, 0.57180334E-33_JPRB, 0.35956393E-33_JPRB, 0.24238615E-33_JPRB, &
  & 0.16836224E-33_JPRB, 0.11038873E-33_JPRB, 0.45001345E-34_JPRB, 0.51776813E-35_JPRB /)

RGHG6(:, 3, 8) = (/ &
  & 0.42476798E-35_JPRB, 0.91991236E-35_JPRB, 0.15597785E-34_JPRB, 0.23224230E-34_JPRB, 0.33978364E-34_JPRB, 0.52377273E-34_JPRB, &
  & 0.87334811E-34_JPRB, 0.15656423E-33_JPRB, 0.29694043E-33_JPRB, 0.58694545E-33_JPRB, 0.11967306E-32_JPRB, 0.24891947E-32_JPRB, &
  & 0.52291425E-32_JPRB, 0.10955749E-31_JPRB, 0.22631874E-31_JPRB, 0.45668273E-31_JPRB, 0.89551229E-31_JPRB, 0.17068518E-30_JPRB, &
  & 0.31724660E-30_JPRB, 0.58016430E-30_JPRB, 0.10536252E-29_JPRB, 0.19122923E-29_JPRB, 0.34756520E-29_JPRB, 0.62792497E-29_JPRB, &
  & 0.11101652E-28_JPRB, 0.18473868E-28_JPRB, 0.28647823E-28_JPRB, 0.41271340E-28_JPRB, 0.56916303E-28_JPRB, 0.75422017E-28_JPRB, &
  & 0.93780426E-28_JPRB, 0.10910949E-27_JPRB, 0.12045395E-27_JPRB, 0.12758954E-27_JPRB, 0.13146109E-27_JPRB, 0.13245134E-27_JPRB, &
  & 0.13047577E-27_JPRB, 0.12493973E-27_JPRB, 0.11570920E-27_JPRB, 0.10299879E-27_JPRB, 0.87610607E-28_JPRB, 0.70945560E-28_JPRB, &
  & 0.54863262E-28_JPRB, 0.40736756E-28_JPRB, 0.28824593E-28_JPRB, 0.19328132E-28_JPRB, 0.12211185E-28_JPRB, 0.74390872E-29_JPRB, &
  & 0.43774684E-29_JPRB, 0.25025767E-29_JPRB, 0.14055700E-29_JPRB, 0.78689553E-30_JPRB, 0.44127889E-30_JPRB, 0.24785470E-30_JPRB, &
  & 0.13992536E-30_JPRB, 0.79972795E-31_JPRB, 0.46475441E-31_JPRB, 0.27862581E-31_JPRB, 0.17471020E-31_JPRB, 0.11749116E-31_JPRB, &
  & 0.81967552E-32_JPRB, 0.55852152E-32_JPRB, 0.26379087E-32_JPRB, 0.33086600E-33_JPRB /)

RGHG6(:, 4, 8) = (/ &
  & 0.24786628E-33_JPRB, 0.79274007E-33_JPRB, 0.14227645E-32_JPRB, 0.20583161E-32_JPRB, 0.29144671E-32_JPRB, 0.43926942E-32_JPRB, &
  & 0.72268254E-32_JPRB, 0.12898187E-31_JPRB, 0.24543971E-31_JPRB, 0.48956401E-31_JPRB, 0.10120101E-30_JPRB, 0.21422162E-30_JPRB, &
  & 0.45853928E-30_JPRB, 0.97826126E-30_JPRB, 0.20525670E-29_JPRB, 0.41925682E-29_JPRB, 0.82900579E-29_JPRB, 0.15868957E-28_JPRB, &
  & 0.29494546E-28_JPRB, 0.53707066E-28_JPRB, 0.96749681E-28_JPRB, 0.17379207E-27_JPRB, 0.31221628E-27_JPRB, 0.55967370E-27_JPRB, &
  & 0.98165420E-27_JPRB, 0.16301830E-26_JPRB, 0.25178593E-26_JPRB, 0.36210888E-26_JPRB, 0.49832001E-26_JPRB, 0.66047287E-26_JPRB, &
  & 0.82187450E-26_JPRB, 0.95773815E-26_JPRB, 0.10590906E-25_JPRB, 0.11243128E-25_JPRB, 0.11608741E-25_JPRB, 0.11724585E-25_JPRB, &
  & 0.11581117E-25_JPRB, 0.11124100E-25_JPRB, 0.10354763E-25_JPRB, 0.92776205E-26_JPRB, 0.79483668E-26_JPRB, 0.64498261E-26_JPRB, &
  & 0.49773707E-26_JPRB, 0.36824909E-26_JPRB, 0.25979713E-26_JPRB, 0.17434071E-26_JPRB, 0.11093247E-26_JPRB, 0.68276749E-27_JPRB, &
  & 0.40731054E-27_JPRB, 0.23442780E-27_JPRB, 0.13252869E-27_JPRB, 0.74400714E-28_JPRB, 0.41817533E-28_JPRB, 0.23525246E-28_JPRB, &
  & 0.13297708E-28_JPRB, 0.76096531E-29_JPRB, 0.44268895E-29_JPRB, 0.26542971E-29_JPRB, 0.16646014E-29_JPRB, 0.11183113E-29_JPRB, &
  & 0.78993455E-30_JPRB, 0.56914587E-30_JPRB, 0.33500632E-30_JPRB, 0.75469323E-31_JPRB /)

RGHG6(:, 5, 8) = (/ &
  & 0.70332296E-31_JPRB, 0.20809262E-30_JPRB, 0.34122861E-30_JPRB, 0.46887301E-30_JPRB, 0.65291019E-30_JPRB, 0.97107485E-30_JPRB, &
  & 0.15777367E-29_JPRB, 0.27861706E-29_JPRB, 0.52434699E-29_JPRB, 0.10377916E-28_JPRB, 0.21336081E-28_JPRB, 0.45029614E-28_JPRB, &
  & 0.96253200E-28_JPRB, 0.20504199E-27_JPRB, 0.42897923E-27_JPRB, 0.87139143E-27_JPRB, 0.17078182E-26_JPRB, 0.32286060E-26_JPRB, &
  & 0.59060013E-26_JPRB, 0.10552864E-25_JPRB, 0.18611061E-25_JPRB, 0.32678831E-25_JPRB, 0.57414357E-25_JPRB, 0.10060317E-24_JPRB, &
  & 0.17336569E-24_JPRB, 0.28318381E-24_JPRB, 0.43278314E-24_JPRB, 0.61682400E-24_JPRB, 0.84459629E-24_JPRB, 0.11157936E-23_JPRB, &
  & 0.13876817E-23_JPRB, 0.16170429E-23_JPRB, 0.17921740E-23_JPRB, 0.19093674E-23_JPRB, 0.19840378E-23_JPRB, 0.20208171E-23_JPRB, &
  & 0.20169663E-23_JPRB, 0.19614531E-23_JPRB, 0.18509882E-23_JPRB, 0.16858182E-23_JPRB, 0.14685101E-23_JPRB, 0.12118951E-23_JPRB, &
  & 0.94861894E-24_JPRB, 0.71203670E-24_JPRB, 0.51024850E-24_JPRB, 0.34845367E-24_JPRB, 0.22607077E-24_JPRB, 0.14225935E-24_JPRB, &
  & 0.86422646E-25_JPRB, 0.50589188E-25_JPRB, 0.28961303E-25_JPRB, 0.16431905E-25_JPRB, 0.93195149E-26_JPRB, 0.52845553E-26_JPRB, &
  & 0.30085333E-26_JPRB, 0.17320778E-26_JPRB, 0.10128563E-26_JPRB, 0.60980705E-27_JPRB, 0.38317151E-27_JPRB, 0.25753198E-27_JPRB, &
  & 0.18285802E-27_JPRB, 0.13969541E-27_JPRB, 0.10104280E-27_JPRB, 0.53860689E-28_JPRB /)

RGHG6(:, 6, 8) = (/ &
  & 0.56531178E-28_JPRB, 0.12674128E-27_JPRB, 0.18748430E-27_JPRB, 0.25348134E-27_JPRB, 0.35072463E-27_JPRB, 0.51663027E-27_JPRB, &
  & 0.82518385E-27_JPRB, 0.14197907E-26_JPRB, 0.25965168E-26_JPRB, 0.49730092E-26_JPRB, 0.98828186E-26_JPRB, 0.20123808E-25_JPRB, &
  & 0.41453562E-25_JPRB, 0.85052481E-25_JPRB, 0.17123159E-24_JPRB, 0.33443162E-24_JPRB, 0.62948295E-24_JPRB, 0.11417243E-23_JPRB, &
  & 0.20028163E-23_JPRB, 0.34331479E-23_JPRB, 0.58161089E-23_JPRB, 0.98294972E-23_JPRB, 0.16654154E-22_JPRB, 0.28237317E-22_JPRB, &
  & 0.47148033E-22_JPRB, 0.75035389E-22_JPRB, 0.11207368E-21_JPRB, 0.15701535E-21_JPRB, 0.21212376E-21_JPRB, 0.27795899E-21_JPRB, &
  & 0.34389211E-21_JPRB, 0.40024354E-21_JPRB, 0.44437855E-21_JPRB, 0.47659452E-21_JPRB, 0.50073432E-21_JPRB, 0.51826420E-21_JPRB, &
  & 0.52796938E-21_JPRB, 0.52595414E-21_JPRB, 0.51030122E-21_JPRB, 0.47922969E-21_JPRB, 0.43211927E-21_JPRB, 0.36976852E-21_JPRB, &
  & 0.30114261E-21_JPRB, 0.23563106E-21_JPRB, 0.17632596E-21_JPRB, 0.12602586E-21_JPRB, 0.85690754E-22_JPRB, 0.56490285E-22_JPRB, &
  & 0.35914994E-22_JPRB, 0.21926370E-22_JPRB, 0.13048590E-22_JPRB, 0.76725795E-23_JPRB, 0.44935418E-23_JPRB, 0.26226044E-23_JPRB, &
  & 0.15312223E-23_JPRB, 0.90098516E-24_JPRB, 0.53648103E-24_JPRB, 0.32767261E-24_JPRB, 0.20786150E-24_JPRB, 0.14026754E-24_JPRB, &
  & 0.99280308E-25_JPRB, 0.75628471E-25_JPRB, 0.58209153E-25_JPRB, 0.33985511E-25_JPRB /)

RGHG6(:, 7, 8) = (/ &
  & 0.47677539E-25_JPRB, 0.99017858E-25_JPRB, 0.14429280E-24_JPRB, 0.19415181E-24_JPRB, 0.26724889E-24_JPRB, 0.38657835E-24_JPRB, &
  & 0.59895122E-24_JPRB, 0.99040609E-24_JPRB, 0.17258699E-23_JPRB, 0.31364017E-23_JPRB, 0.58863519E-23_JPRB, 0.11275206E-22_JPRB, &
  & 0.21791563E-22_JPRB, 0.41883251E-22_JPRB, 0.79029032E-22_JPRB, 0.14480470E-21_JPRB, 0.25613917E-21_JPRB, 0.43755285E-21_JPRB, &
  & 0.72482787E-21_JPRB, 0.11774273E-20_JPRB, 0.18984187E-20_JPRB, 0.30684519E-20_JPRB, 0.49965433E-20_JPRB, 0.81723603E-20_JPRB, &
  & 0.13212953E-19_JPRB, 0.20400797E-19_JPRB, 0.29683082E-19_JPRB, 0.40683573E-19_JPRB, 0.54061478E-19_JPRB, 0.70007688E-19_JPRB, &
  & 0.86059031E-19_JPRB, 0.99922100E-19_JPRB, 0.11123772E-18_JPRB, 0.12019968E-18_JPRB, 0.12795464E-18_JPRB, 0.13492993E-18_JPRB, &
  & 0.14082508E-18_JPRB, 0.14444034E-18_JPRB, 0.14492794E-18_JPRB, 0.14138517E-18_JPRB, 0.13295818E-18_JPRB, 0.11925910E-18_JPRB, &
  & 0.10219771E-18_JPRB, 0.84504978E-19_JPRB, 0.67037942E-19_JPRB, 0.50916805E-19_JPRB, 0.36884856E-19_JPRB, 0.25943295E-19_JPRB, &
  & 0.17595020E-19_JPRB, 0.11444603E-19_JPRB, 0.72431885E-20_JPRB, 0.45143018E-20_JPRB, 0.27922411E-20_JPRB, 0.17130888E-20_JPRB, &
  & 0.10462606E-20_JPRB, 0.64024981E-21_JPRB, 0.39432097E-21_JPRB, 0.24757909E-21_JPRB, 0.16044130E-21_JPRB, 0.10956503E-21_JPRB, &
  & 0.77638302E-22_JPRB, 0.58942242E-22_JPRB, 0.45518006E-22_JPRB, 0.29893357E-22_JPRB /)

RGHG6(:, 8, 8) = (/ &
  & 0.34376189E-22_JPRB, 0.70310876E-22_JPRB, 0.10177950E-21_JPRB, 0.13708930E-21_JPRB, 0.18688268E-21_JPRB, 0.26569482E-21_JPRB, &
  & 0.39960142E-21_JPRB, 0.63493120E-21_JPRB, 0.10555615E-20_JPRB, 0.18197006E-20_JPRB, 0.32222958E-20_JPRB, 0.57944143E-20_JPRB, &
  & 0.10463727E-19_JPRB, 0.18748813E-19_JPRB, 0.32943282E-19_JPRB, 0.56285266E-19_JPRB, 0.93070479E-19_JPRB, 0.14912371E-18_JPRB, &
  & 0.23257462E-18_JPRB, 0.35724478E-18_JPRB, 0.54741831E-18_JPRB, 0.84564866E-18_JPRB, 0.13237165E-17_JPRB, 0.20915663E-17_JPRB, &
  & 0.32767941E-17_JPRB, 0.49121066E-17_JPRB, 0.69541852E-17_JPRB, 0.93160737E-17_JPRB, 0.12162106E-16_JPRB, 0.15560048E-16_JPRB, &
  & 0.18998107E-16_JPRB, 0.22022438E-16_JPRB, 0.24593833E-16_JPRB, 0.26799899E-16_JPRB, 0.28921427E-16_JPRB, 0.31087307E-16_JPRB, &
  & 0.33256661E-16_JPRB, 0.35147890E-16_JPRB, 0.36519657E-16_JPRB, 0.37064785E-16_JPRB, 0.36433097E-16_JPRB, 0.34302972E-16_JPRB, &
  & 0.31010915E-16_JPRB, 0.27152652E-16_JPRB, 0.22875653E-16_JPRB, 0.18505834E-16_JPRB, 0.14312314E-16_JPRB, 0.10769278E-16_JPRB, &
  & 0.78194376E-17_JPRB, 0.54418810E-17_JPRB, 0.36798192E-17_JPRB, 0.24441816E-17_JPRB, 0.16047548E-17_JPRB, 0.10402804E-17_JPRB, &
  & 0.66748766E-18_JPRB, 0.42667599E-18_JPRB, 0.27277413E-18_JPRB, 0.17673108E-18_JPRB, 0.11735320E-18_JPRB, 0.81576526E-19_JPRB, &
  & 0.58357237E-19_JPRB, 0.44382476E-19_JPRB, 0.34634356E-19_JPRB, 0.23419438E-19_JPRB /)

RGHG6(:, 9, 8) = (/ &
  & 0.20335657E-19_JPRB, 0.41251529E-19_JPRB, 0.59327022E-19_JPRB, 0.79902390E-19_JPRB, 0.10835122E-18_JPRB, 0.15188380E-18_JPRB, &
  & 0.22336172E-18_JPRB, 0.34384158E-18_JPRB, 0.54986940E-18_JPRB, 0.90562453E-18_JPRB, 0.15233224E-17_JPRB, 0.25845943E-17_JPRB, &
  & 0.43800206E-17_JPRB, 0.73314474E-17_JPRB, 0.12013396E-16_JPRB, 0.19144214E-16_JPRB, 0.29592601E-16_JPRB, 0.44487064E-16_JPRB, &
  & 0.65350279E-16_JPRB, 0.94938920E-16_JPRB, 0.13822871E-15_JPRB, 0.20395066E-15_JPRB, 0.30652418E-15_JPRB, 0.46743815E-15_JPRB, &
  & 0.70909278E-15_JPRB, 0.10303224E-14_JPRB, 0.14177376E-14_JPRB, 0.18536837E-14_JPRB, 0.23753976E-14_JPRB, 0.30007942E-14_JPRB, &
  & 0.36385647E-14_JPRB, 0.42117727E-14_JPRB, 0.47219978E-14_JPRB, 0.51937612E-14_JPRB, 0.56876107E-14_JPRB, 0.62365545E-14_JPRB, &
  & 0.68423025E-14_JPRB, 0.74562481E-14_JPRB, 0.80297199E-14_JPRB, 0.84889379E-14_JPRB, 0.87333391E-14_JPRB, 0.86464928E-14_JPRB, &
  & 0.82538982E-14_JPRB, 0.76602873E-14_JPRB, 0.68597243E-14_JPRB, 0.59116441E-14_JPRB, 0.48813857E-14_JPRB, 0.39299309E-14_JPRB, &
  & 0.30542562E-14_JPRB, 0.22739362E-14_JPRB, 0.16425031E-14_JPRB, 0.11621093E-14_JPRB, 0.80952072E-15_JPRB, 0.55392302E-15_JPRB, &
  & 0.37312617E-15_JPRB, 0.24880688E-15_JPRB, 0.16493932E-15_JPRB, 0.11011876E-15_JPRB, 0.74905102E-16_JPRB, 0.52988006E-16_JPRB, &
  & 0.38337376E-16_JPRB, 0.29401675E-16_JPRB, 0.23081494E-16_JPRB, 0.15837996E-16_JPRB /)

RGHG6(:,10, 8) = (/ &
  & 0.98938014E-17_JPRB, 0.19402678E-16_JPRB, 0.28193042E-16_JPRB, 0.37710959E-16_JPRB, 0.51092263E-16_JPRB, 0.70975088E-16_JPRB, &
  & 0.10274123E-15_JPRB, 0.15456684E-15_JPRB, 0.23965410E-15_JPRB, 0.38014087E-15_JPRB, 0.61128790E-15_JPRB, 0.98449316E-15_JPRB, &
  & 0.15733762E-14_JPRB, 0.24718262E-14_JPRB, 0.37897753E-14_JPRB, 0.56477319E-14_JPRB, 0.81766572E-14_JPRB, 0.11549562E-13_JPRB, &
  & 0.15995330E-13_JPRB, 0.21992370E-13_JPRB, 0.30422503E-13_JPRB, 0.42820521E-13_JPRB, 0.61695928E-13_JPRB, 0.90529133E-13_JPRB, &
  & 0.13259565E-12_JPRB, 0.18638471E-12_JPRB, 0.24874013E-12_JPRB, 0.31707254E-12_JPRB, 0.39846850E-12_JPRB, 0.49669399E-12_JPRB, &
  & 0.59798997E-12_JPRB, 0.69113221E-12_JPRB, 0.77827425E-12_JPRB, 0.86466576E-12_JPRB, 0.96168744E-12_JPRB, 0.10765930E-11_JPRB, &
  & 0.12121816E-11_JPRB, 0.13628587E-11_JPRB, 0.15223693E-11_JPRB, 0.16781638E-11_JPRB, 0.18091555E-11_JPRB, 0.18857971E-11_JPRB, &
  & 0.19032950E-11_JPRB, 0.18744351E-11_JPRB, 0.17857224E-11_JPRB, 0.16408225E-11_JPRB, 0.14472340E-11_JPRB, 0.12467184E-11_JPRB, &
  & 0.10371049E-11_JPRB, 0.82557550E-12_JPRB, 0.63648788E-12_JPRB, 0.47917459E-12_JPRB, 0.35366957E-12_JPRB, 0.25512565E-12_JPRB, &
  & 0.18013089E-12_JPRB, 0.12512842E-12_JPRB, 0.85867179E-13_JPRB, 0.58976343E-13_JPRB, 0.41018478E-13_JPRB, 0.29508016E-13_JPRB, &
  & 0.21583540E-13_JPRB, 0.16668877E-13_JPRB, 0.13174153E-13_JPRB, 0.91007676E-14_JPRB /)

RGHG6(:,11, 8) = (/ &
  & 0.20320905E-15_JPRB, 0.37716069E-15_JPRB, 0.49362798E-15_JPRB, 0.63130530E-15_JPRB, 0.79331809E-15_JPRB, 0.10243809E-14_JPRB, &
  & 0.13616065E-14_JPRB, 0.18663710E-14_JPRB, 0.26205215E-14_JPRB, 0.37424380E-14_JPRB, 0.53913622E-14_JPRB, 0.77564806E-14_JPRB, &
  & 0.11055010E-13_JPRB, 0.15508238E-13_JPRB, 0.21337424E-13_JPRB, 0.28738601E-13_JPRB, 0.37914794E-13_JPRB, 0.49271720E-13_JPRB, &
  & 0.63429595E-13_JPRB, 0.81636649E-13_JPRB, 0.10623342E-12_JPRB, 0.14146117E-12_JPRB, 0.19403378E-12_JPRB, 0.27381764E-12_JPRB, &
  & 0.39065767E-12_JPRB, 0.55452843E-12_JPRB, 0.77594273E-12_JPRB, 0.10658411E-11_JPRB, 0.14333283E-11_JPRB, 0.18674333E-11_JPRB, &
  & 0.23397265E-11_JPRB, 0.28305598E-11_JPRB, 0.33204867E-11_JPRB, 0.37828013E-11_JPRB, 0.42015141E-11_JPRB, 0.45791092E-11_JPRB, &
  & 0.48897292E-11_JPRB, 0.51336938E-11_JPRB, 0.53019672E-11_JPRB, 0.53645205E-11_JPRB, 0.53163880E-11_JPRB, 0.51729771E-11_JPRB, &
  & 0.49467032E-11_JPRB, 0.46236522E-11_JPRB, 0.42174831E-11_JPRB, 0.37531796E-11_JPRB, 0.32659403E-11_JPRB, 0.27640956E-11_JPRB, &
  & 0.22545943E-11_JPRB, 0.18065991E-11_JPRB, 0.14261324E-11_JPRB, 0.11089265E-11_JPRB, 0.84958906E-12_JPRB, 0.64341989E-12_JPRB, &
  & 0.48597514E-12_JPRB, 0.36818769E-12_JPRB, 0.28108925E-12_JPRB, 0.22027454E-12_JPRB, 0.17665231E-12_JPRB, 0.14838976E-12_JPRB, &
  & 0.12920838E-12_JPRB, 0.11553257E-12_JPRB, 0.11205484E-12_JPRB, 0.91808993E-13_JPRB /)

RGHG6(:,12, 8) = (/ &
  & 0.27249730E-14_JPRB, 0.43920255E-14_JPRB, 0.57004563E-14_JPRB, 0.68694668E-14_JPRB, 0.83500643E-14_JPRB, 0.10270839E-13_JPRB, &
  & 0.13012841E-13_JPRB, 0.16948802E-13_JPRB, 0.22558092E-13_JPRB, 0.30422455E-13_JPRB, 0.41175955E-13_JPRB, 0.55306461E-13_JPRB, &
  & 0.73101464E-13_JPRB, 0.94465803E-13_JPRB, 0.11897147E-12_JPRB, 0.14600972E-12_JPRB, 0.17492971E-12_JPRB, 0.20635106E-12_JPRB, &
  & 0.24133121E-12_JPRB, 0.28282707E-12_JPRB, 0.33669812E-12_JPRB, 0.41304953E-12_JPRB, 0.52819901E-12_JPRB, 0.70469336E-12_JPRB, &
  & 0.97155487E-12_JPRB, 0.13594703E-11_JPRB, 0.18989855E-11_JPRB, 0.26186867E-11_JPRB, 0.35640635E-11_JPRB, 0.48235626E-11_JPRB, &
  & 0.64082971E-11_JPRB, 0.81709179E-11_JPRB, 0.99346555E-11_JPRB, 0.11541048E-10_JPRB, 0.12853001E-10_JPRB, 0.13826441E-10_JPRB, &
  & 0.14368839E-10_JPRB, 0.14542752E-10_JPRB, 0.14321460E-10_JPRB, 0.13774003E-10_JPRB, 0.13006765E-10_JPRB, 0.12071446E-10_JPRB, &
  & 0.11008456E-10_JPRB, 0.98826329E-11_JPRB, 0.87288987E-11_JPRB, 0.75816020E-11_JPRB, 0.64564755E-11_JPRB, 0.54154129E-11_JPRB, &
  & 0.44948615E-11_JPRB, 0.36835899E-11_JPRB, 0.29935117E-11_JPRB, 0.24258753E-11_JPRB, 0.19702150E-11_JPRB, 0.16122135E-11_JPRB, &
  & 0.13373259E-11_JPRB, 0.11280731E-11_JPRB, 0.97317824E-12_JPRB, 0.86647719E-12_JPRB, 0.79781765E-12_JPRB, 0.75221014E-12_JPRB, &
  & 0.75223833E-12_JPRB, 0.72649460E-12_JPRB, 0.77496879E-12_JPRB, 0.71316076E-12_JPRB /)

RGHG6(:,13, 8) = (/ &
  & 0.24203697E-13_JPRB, 0.38352663E-13_JPRB, 0.46403270E-13_JPRB, 0.54572754E-13_JPRB, 0.63427277E-13_JPRB, 0.75249770E-13_JPRB, &
  & 0.91741407E-13_JPRB, 0.11540037E-12_JPRB, 0.14893398E-12_JPRB, 0.19538411E-12_JPRB, 0.25752593E-12_JPRB, 0.33697234E-12_JPRB, &
  & 0.43294199E-12_JPRB, 0.54181594E-12_JPRB, 0.65733329E-12_JPRB, 0.77179712E-12_JPRB, 0.87973341E-12_JPRB, 0.97656041E-12_JPRB, &
  & 0.10625474E-11_JPRB, 0.11458491E-11_JPRB, 0.12417726E-11_JPRB, 0.13726349E-11_JPRB, 0.15707930E-11_JPRB, 0.18812979E-11_JPRB, &
  & 0.23561773E-11_JPRB, 0.30557978E-11_JPRB, 0.40700446E-11_JPRB, 0.55225195E-11_JPRB, 0.74986189E-11_JPRB, 0.10056493E-10_JPRB, &
  & 0.13305419E-10_JPRB, 0.17051048E-10_JPRB, 0.20882534E-10_JPRB, 0.24323221E-10_JPRB, 0.27116340E-10_JPRB, 0.29033097E-10_JPRB, &
  & 0.29938121E-10_JPRB, 0.29871595E-10_JPRB, 0.28938282E-10_JPRB, 0.27358140E-10_JPRB, 0.25346380E-10_JPRB, 0.23054395E-10_JPRB, &
  & 0.20651876E-10_JPRB, 0.18244503E-10_JPRB, 0.15910388E-10_JPRB, 0.13701453E-10_JPRB, 0.11693105E-10_JPRB, 0.99174297E-11_JPRB, &
  & 0.83433460E-11_JPRB, 0.70339182E-11_JPRB, 0.59807675E-11_JPRB, 0.51504365E-11_JPRB, 0.45035928E-11_JPRB, 0.40054626E-11_JPRB, &
  & 0.36326621E-11_JPRB, 0.33592994E-11_JPRB, 0.31741016E-11_JPRB, 0.30699087E-11_JPRB, 0.30452030E-11_JPRB, 0.30540991E-11_JPRB, &
  & 0.31888780E-11_JPRB, 0.32443295E-11_JPRB, 0.35689954E-11_JPRB, 0.37669139E-11_JPRB /)

RGHG6(:,14, 8) = (/ &
  & 0.17551668E-12_JPRB, 0.24943391E-12_JPRB, 0.29019666E-12_JPRB, 0.32245609E-12_JPRB, 0.35733509E-12_JPRB, 0.40199194E-12_JPRB, &
  & 0.46603314E-12_JPRB, 0.55968679E-12_JPRB, 0.69420132E-12_JPRB, 0.88120732E-12_JPRB, 0.11295374E-11_JPRB, 0.14425898E-11_JPRB, &
  & 0.18130995E-11_JPRB, 0.22211274E-11_JPRB, 0.26355394E-11_JPRB, 0.30228162E-11_JPRB, 0.33582980E-11_JPRB, 0.36336979E-11_JPRB, &
  & 0.38479870E-11_JPRB, 0.40211779E-11_JPRB, 0.41834314E-11_JPRB, 0.43792218E-11_JPRB, 0.46675303E-11_JPRB, 0.51269509E-11_JPRB, &
  & 0.58536895E-11_JPRB, 0.69690659E-11_JPRB, 0.86104917E-11_JPRB, 0.10946053E-10_JPRB, 0.14237219E-10_JPRB, 0.18549693E-10_JPRB, &
  & 0.23778314E-10_JPRB, 0.29786368E-10_JPRB, 0.35963628E-10_JPRB, 0.41602371E-10_JPRB, 0.46141941E-10_JPRB, 0.49093857E-10_JPRB, &
  & 0.50363623E-10_JPRB, 0.50032763E-10_JPRB, 0.48331363E-10_JPRB, 0.45586455E-10_JPRB, 0.42137571E-10_JPRB, 0.38305137E-10_JPRB, &
  & 0.34320390E-10_JPRB, 0.30372215E-10_JPRB, 0.26603733E-10_JPRB, 0.23125217E-10_JPRB, 0.19995229E-10_JPRB, 0.17312778E-10_JPRB, &
  & 0.15085591E-10_JPRB, 0.13297810E-10_JPRB, 0.11902528E-10_JPRB, 0.10838891E-10_JPRB, 0.10047064E-10_JPRB, 0.94750700E-11_JPRB, &
  & 0.90926433E-11_JPRB, 0.88575865E-11_JPRB, 0.87603882E-11_JPRB, 0.87955381E-11_JPRB, 0.89576515E-11_JPRB, 0.91965142E-11_JPRB, &
  & 0.96330765E-11_JPRB, 0.10014676E-10_JPRB, 0.10837821E-10_JPRB, 0.11954716E-10_JPRB /)

RGHG6(:,15, 8) = (/ &
  & 0.10311312E-11_JPRB, 0.13183892E-11_JPRB, 0.14321751E-11_JPRB, 0.14964889E-11_JPRB, 0.15521761E-11_JPRB, 0.16322985E-11_JPRB, &
  & 0.17689783E-11_JPRB, 0.19951042E-11_JPRB, 0.23423262E-11_JPRB, 0.28404176E-11_JPRB, 0.35099545E-11_JPRB, 0.43530977E-11_JPRB, &
  & 0.53492692E-11_JPRB, 0.64430206E-11_JPRB, 0.75543521E-11_JPRB, 0.86035181E-11_JPRB, 0.95290043E-11_JPRB, 0.10307552E-10_JPRB, &
  & 0.10940741E-10_JPRB, 0.11458511E-10_JPRB, 0.11910034E-10_JPRB, 0.12359423E-10_JPRB, 0.12894201E-10_JPRB, 0.13634712E-10_JPRB, &
  & 0.14732816E-10_JPRB, 0.16373083E-10_JPRB, 0.18803183E-10_JPRB, 0.22248937E-10_JPRB, 0.26913765E-10_JPRB, 0.32994503E-10_JPRB, &
  & 0.40301443E-10_JPRB, 0.48436474E-10_JPRB, 0.56636348E-10_JPRB, 0.64054810E-10_JPRB, 0.69749789E-10_JPRB, 0.73500157E-10_JPRB, &
  & 0.75073607E-10_JPRB, 0.74517163E-10_JPRB, 0.72205117E-10_JPRB, 0.68569275E-10_JPRB, 0.64021351E-10_JPRB, 0.58900537E-10_JPRB, &
  & 0.53506848E-10_JPRB, 0.48087881E-10_JPRB, 0.42867324E-10_JPRB, 0.38047454E-10_JPRB, 0.33785096E-10_JPRB, 0.30197612E-10_JPRB, &
  & 0.27252978E-10_JPRB, 0.24955130E-10_JPRB, 0.23232643E-10_JPRB, 0.21983620E-10_JPRB, 0.21110929E-10_JPRB, 0.20534475E-10_JPRB, &
  & 0.20213177E-10_JPRB, 0.20091658E-10_JPRB, 0.20167470E-10_JPRB, 0.20446259E-10_JPRB, 0.20908188E-10_JPRB, 0.21536687E-10_JPRB, &
  & 0.22394147E-10_JPRB, 0.23328598E-10_JPRB, 0.24809356E-10_JPRB, 0.27285967E-10_JPRB /)

RGHG6(:,16, 8) = (/ &
  & 0.48719960E-11_JPRB, 0.54817800E-11_JPRB, 0.55545286E-11_JPRB, 0.54487192E-11_JPRB, 0.53072325E-11_JPRB, 0.52191671E-11_JPRB, &
  & 0.52800368E-11_JPRB, 0.55716972E-11_JPRB, 0.61630328E-11_JPRB, 0.71167768E-11_JPRB, 0.84730738E-11_JPRB, 0.10243953E-10_JPRB, &
  & 0.12395833E-10_JPRB, 0.14844015E-10_JPRB, 0.17438911E-10_JPRB, 0.20011524E-10_JPRB, 0.22426418E-10_JPRB, 0.24605054E-10_JPRB, &
  & 0.26516959E-10_JPRB, 0.28211289E-10_JPRB, 0.29762283E-10_JPRB, 0.31266510E-10_JPRB, 0.32838784E-10_JPRB, 0.34631589E-10_JPRB, &
  & 0.36828790E-10_JPRB, 0.39655574E-10_JPRB, 0.43351631E-10_JPRB, 0.48145925E-10_JPRB, 0.54190569E-10_JPRB, 0.61461003E-10_JPRB, &
  & 0.69802143E-10_JPRB, 0.78557223E-10_JPRB, 0.87056105E-10_JPRB, 0.94306653E-10_JPRB, 0.99830533E-10_JPRB, 0.10311909E-09_JPRB, &
  & 0.10410715E-09_JPRB, 0.10326380E-09_JPRB, 0.10091977E-09_JPRB, 0.97318285E-10_JPRB, 0.92685130E-10_JPRB, 0.87265181E-10_JPRB, &
  & 0.81272850E-10_JPRB, 0.74986739E-10_JPRB, 0.68715138E-10_JPRB, 0.62770969E-10_JPRB, 0.57422078E-10_JPRB, 0.52877452E-10_JPRB, &
  & 0.49126765E-10_JPRB, 0.46180816E-10_JPRB, 0.43938519E-10_JPRB, 0.42271631E-10_JPRB, 0.41064704E-10_JPRB, 0.40233952E-10_JPRB, &
  & 0.39747830E-10_JPRB, 0.39546491E-10_JPRB, 0.39638827E-10_JPRB, 0.40043809E-10_JPRB, 0.40731023E-10_JPRB, 0.41704529E-10_JPRB, &
  & 0.42957707E-10_JPRB, 0.44474743E-10_JPRB, 0.46605674E-10_JPRB, 0.50443125E-10_JPRB /)

RGHG6(:,17, 8) = (/ &
  & 0.17083959E-10_JPRB, 0.16860634E-10_JPRB, 0.15935449E-10_JPRB, 0.14955610E-10_JPRB, 0.13954891E-10_JPRB, 0.13140437E-10_JPRB, &
  & 0.12676971E-10_JPRB, 0.12728364E-10_JPRB, 0.13430633E-10_JPRB, 0.14900517E-10_JPRB, 0.17229300E-10_JPRB, 0.20458716E-10_JPRB, &
  & 0.24562600E-10_JPRB, 0.29398945E-10_JPRB, 0.34730469E-10_JPRB, 0.40240193E-10_JPRB, 0.45644391E-10_JPRB, 0.50764615E-10_JPRB, &
  & 0.55522947E-10_JPRB, 0.59968780E-10_JPRB, 0.64238309E-10_JPRB, 0.68502773E-10_JPRB, 0.72952575E-10_JPRB, 0.77761728E-10_JPRB, &
  & 0.83058803E-10_JPRB, 0.88865110E-10_JPRB, 0.95154121E-10_JPRB, 0.10169232E-09_JPRB, 0.10829476E-09_JPRB, 0.11463933E-09_JPRB, &
  & 0.12065340E-09_JPRB, 0.12607868E-09_JPRB, 0.13081258E-09_JPRB, 0.13425200E-09_JPRB, 0.13619295E-09_JPRB, 0.13679806E-09_JPRB, &
  & 0.13671286E-09_JPRB, 0.13583173E-09_JPRB, 0.13423913E-09_JPRB, 0.13196191E-09_JPRB, 0.12886665E-09_JPRB, 0.12486176E-09_JPRB, &
  & 0.11991060E-09_JPRB, 0.11416463E-09_JPRB, 0.10791334E-09_JPRB, 0.10153364E-09_JPRB, 0.95423766E-10_JPRB, 0.89926275E-10_JPRB, &
  & 0.85090580E-10_JPRB, 0.80994537E-10_JPRB, 0.77574232E-10_JPRB, 0.74737563E-10_JPRB, 0.72414116E-10_JPRB, 0.70578876E-10_JPRB, &
  & 0.69247226E-10_JPRB, 0.68380759E-10_JPRB, 0.68003533E-10_JPRB, 0.68131362E-10_JPRB, 0.68715963E-10_JPRB, 0.69744467E-10_JPRB, &
  & 0.71177966E-10_JPRB, 0.73045042E-10_JPRB, 0.75571278E-10_JPRB, 0.80381632E-10_JPRB /)

RGHG6(:,18, 8) = (/ &
  & 0.38630286E-10_JPRB, 0.36204064E-10_JPRB, 0.33201143E-10_JPRB, 0.30830880E-10_JPRB, 0.28366174E-10_JPRB, 0.26373266E-10_JPRB, &
  & 0.24953782E-10_JPRB, 0.24434567E-10_JPRB, 0.25061252E-10_JPRB, 0.27049852E-10_JPRB, 0.30569478E-10_JPRB, 0.35720912E-10_JPRB, &
  & 0.42487205E-10_JPRB, 0.50686545E-10_JPRB, 0.59920263E-10_JPRB, 0.69660291E-10_JPRB, 0.79389911E-10_JPRB, 0.88784910E-10_JPRB, &
  & 0.97731850E-10_JPRB, 0.10631486E-09_JPRB, 0.11471454E-09_JPRB, 0.12320855E-09_JPRB, 0.13210659E-09_JPRB, 0.14155785E-09_JPRB, &
  & 0.15131976E-09_JPRB, 0.16106809E-09_JPRB, 0.17011768E-09_JPRB, 0.17766202E-09_JPRB, 0.18307876E-09_JPRB, 0.18620991E-09_JPRB, &
  & 0.18715801E-09_JPRB, 0.18632333E-09_JPRB, 0.18420948E-09_JPRB, 0.18105896E-09_JPRB, 0.17770083E-09_JPRB, 0.17474369E-09_JPRB, &
  & 0.17241371E-09_JPRB, 0.17106710E-09_JPRB, 0.17064195E-09_JPRB, 0.17063205E-09_JPRB, 0.17038002E-09_JPRB, 0.16930463E-09_JPRB, &
  & 0.16697754E-09_JPRB, 0.16328489E-09_JPRB, 0.15839251E-09_JPRB, 0.15261750E-09_JPRB, 0.14638660E-09_JPRB, 0.14012964E-09_JPRB, &
  & 0.13401111E-09_JPRB, 0.12825813E-09_JPRB, 0.12294162E-09_JPRB, 0.11812193E-09_JPRB, 0.11386547E-09_JPRB, 0.11025156E-09_JPRB, &
  & 0.10736397E-09_JPRB, 0.10520126E-09_JPRB, 0.10379864E-09_JPRB, 0.10315862E-09_JPRB, 0.10320290E-09_JPRB, 0.10388326E-09_JPRB, &
  & 0.10513108E-09_JPRB, 0.10694187E-09_JPRB, 0.10955808E-09_JPRB, 0.11477443E-09_JPRB /)

RGHG6(:,19, 8) = (/ &
  & 0.64423897E-10_JPRB, 0.59660867E-10_JPRB, 0.54963596E-10_JPRB, 0.51323237E-10_JPRB, 0.47568539E-10_JPRB, 0.44383705E-10_JPRB, &
  & 0.41945360E-10_JPRB, 0.40739287E-10_JPRB, 0.41178099E-10_JPRB, 0.43618234E-10_JPRB, 0.48338618E-10_JPRB, 0.55495743E-10_JPRB, &
  & 0.65057071E-10_JPRB, 0.76719776E-10_JPRB, 0.89918753E-10_JPRB, 0.10386952E-09_JPRB, 0.11779464E-09_JPRB, 0.13115772E-09_JPRB, &
  & 0.14375984E-09_JPRB, 0.15579092E-09_JPRB, 0.16753392E-09_JPRB, 0.17927326E-09_JPRB, 0.19135662E-09_JPRB, 0.20396165E-09_JPRB, &
  & 0.21700806E-09_JPRB, 0.22975792E-09_JPRB, 0.24100541E-09_JPRB, 0.24929575E-09_JPRB, 0.25373437E-09_JPRB, 0.25405031E-09_JPRB, &
  & 0.25077015E-09_JPRB, 0.24462288E-09_JPRB, 0.23678831E-09_JPRB, 0.22793406E-09_JPRB, 0.21970915E-09_JPRB, 0.21313375E-09_JPRB, &
  & 0.20875249E-09_JPRB, 0.20703594E-09_JPRB, 0.20778217E-09_JPRB, 0.21008018E-09_JPRB, 0.21278629E-09_JPRB, 0.21486139E-09_JPRB, &
  & 0.21555305E-09_JPRB, 0.21451220E-09_JPRB, 0.21168731E-09_JPRB, 0.20725577E-09_JPRB, 0.20156413E-09_JPRB, 0.19504215E-09_JPRB, &
  & 0.18796119E-09_JPRB, 0.18067414E-09_JPRB, 0.17344813E-09_JPRB, 0.16654650E-09_JPRB, 0.16020817E-09_JPRB, 0.15463630E-09_JPRB, &
  & 0.14998737E-09_JPRB, 0.14630074E-09_JPRB, 0.14361168E-09_JPRB, 0.14191040E-09_JPRB, 0.14110633E-09_JPRB, 0.14112742E-09_JPRB, &
  & 0.14187852E-09_JPRB, 0.14332477E-09_JPRB, 0.14571290E-09_JPRB, 0.15074825E-09_JPRB /)

RGHG6(:,20, 8) = (/ &
  & 0.91969238E-10_JPRB, 0.85179287E-10_JPRB, 0.79541040E-10_JPRB, 0.74795656E-10_JPRB, 0.70241313E-10_JPRB, 0.66053135E-10_JPRB, &
  & 0.62766028E-10_JPRB, 0.60913247E-10_JPRB, 0.61086636E-10_JPRB, 0.63770912E-10_JPRB, 0.69340547E-10_JPRB, 0.77969950E-10_JPRB, &
  & 0.89573259E-10_JPRB, 0.10372552E-09_JPRB, 0.11964471E-09_JPRB, 0.13633428E-09_JPRB, 0.15285348E-09_JPRB, 0.16858009E-09_JPRB, &
  & 0.18327768E-09_JPRB, 0.19707116E-09_JPRB, 0.21043783E-09_JPRB, 0.22376807E-09_JPRB, 0.23737223E-09_JPRB, 0.25151045E-09_JPRB, &
  & 0.26605582E-09_JPRB, 0.28021285E-09_JPRB, 0.29255018E-09_JPRB, 0.30149519E-09_JPRB, 0.30592151E-09_JPRB, 0.30563158E-09_JPRB, &
  & 0.30100325E-09_JPRB, 0.29280672E-09_JPRB, 0.28233871E-09_JPRB, 0.27067187E-09_JPRB, 0.25949504E-09_JPRB, 0.25045063E-09_JPRB, &
  & 0.24506683E-09_JPRB, 0.24335092E-09_JPRB, 0.24467897E-09_JPRB, 0.24825442E-09_JPRB, 0.25277730E-09_JPRB, 0.25695857E-09_JPRB, &
  & 0.25985006E-09_JPRB, 0.26089794E-09_JPRB, 0.25987865E-09_JPRB, 0.25683375E-09_JPRB, 0.25198990E-09_JPRB, 0.24570176E-09_JPRB, &
  & 0.23826000E-09_JPRB, 0.23011060E-09_JPRB, 0.22168441E-09_JPRB, 0.21337673E-09_JPRB, 0.20553678E-09_JPRB, 0.19847599E-09_JPRB, &
  & 0.19242319E-09_JPRB, 0.18745706E-09_JPRB, 0.18361493E-09_JPRB, 0.18088270E-09_JPRB, 0.17917419E-09_JPRB, 0.17841878E-09_JPRB, &
  & 0.17851869E-09_JPRB, 0.17941647E-09_JPRB, 0.18128189E-09_JPRB, 0.18566160E-09_JPRB /)

RGHG6(:,21, 8) = (/ &
  & 0.12030520E-09_JPRB, 0.11182168E-09_JPRB, 0.10565439E-09_JPRB, 0.10025956E-09_JPRB, 0.94964932E-10_JPRB, 0.90145155E-10_JPRB, &
  & 0.86145598E-10_JPRB, 0.83703447E-10_JPRB, 0.83482957E-10_JPRB, 0.86079026E-10_JPRB, 0.91895297E-10_JPRB, 0.10110776E-09_JPRB, &
  & 0.11355857E-09_JPRB, 0.12871597E-09_JPRB, 0.14571902E-09_JPRB, 0.16349345E-09_JPRB, 0.18103691E-09_JPRB, 0.19768713E-09_JPRB, &
  & 0.21324530E-09_JPRB, 0.22784336E-09_JPRB, 0.24179042E-09_JPRB, 0.25563193E-09_JPRB, 0.26974989E-09_JPRB, 0.28444466E-09_JPRB, &
  & 0.29961078E-09_JPRB, 0.31447764E-09_JPRB, 0.32762948E-09_JPRB, 0.33742997E-09_JPRB, 0.34276426E-09_JPRB, 0.34336425E-09_JPRB, &
  & 0.33942840E-09_JPRB, 0.33166031E-09_JPRB, 0.32118180E-09_JPRB, 0.30926769E-09_JPRB, 0.29760128E-09_JPRB, 0.28809596E-09_JPRB, &
  & 0.28183611E-09_JPRB, 0.27957309E-09_JPRB, 0.28100783E-09_JPRB, 0.28482489E-09_JPRB, 0.28977992E-09_JPRB, 0.29464609E-09_JPRB, &
  & 0.29841563E-09_JPRB, 0.30042888E-09_JPRB, 0.30040129E-09_JPRB, 0.29824551E-09_JPRB, 0.29404926E-09_JPRB, 0.28812147E-09_JPRB, &
  & 0.28077402E-09_JPRB, 0.27247468E-09_JPRB, 0.26364957E-09_JPRB, 0.25473726E-09_JPRB, 0.24618740E-09_JPRB, 0.23836183E-09_JPRB, &
  & 0.23151370E-09_JPRB, 0.22574574E-09_JPRB, 0.22110172E-09_JPRB, 0.21756832E-09_JPRB, 0.21508098E-09_JPRB, 0.21357295E-09_JPRB, &
  & 0.21296914E-09_JPRB, 0.21321243E-09_JPRB, 0.21443758E-09_JPRB, 0.21777798E-09_JPRB /)

RGHG6(:,22, 8) = (/ &
  & 0.14898571E-09_JPRB, 0.13937915E-09_JPRB, 0.13279647E-09_JPRB, 0.12679563E-09_JPRB, 0.12111641E-09_JPRB, 0.11562172E-09_JPRB, &
  & 0.11099670E-09_JPRB, 0.10790602E-09_JPRB, 0.10712398E-09_JPRB, 0.10926320E-09_JPRB, 0.11474725E-09_JPRB, 0.12369498E-09_JPRB, &
  & 0.13592022E-09_JPRB, 0.15086758E-09_JPRB, 0.16766212E-09_JPRB, 0.18527237E-09_JPRB, 0.20275441E-09_JPRB, 0.21945901E-09_JPRB, &
  & 0.23508781E-09_JPRB, 0.24983493E-09_JPRB, 0.26401281E-09_JPRB, 0.27804353E-09_JPRB, 0.29238631E-09_JPRB, 0.30735670E-09_JPRB, &
  & 0.32293512E-09_JPRB, 0.33838748E-09_JPRB, 0.35232633E-09_JPRB, 0.36317566E-09_JPRB, 0.36984396E-09_JPRB, 0.37201647E-09_JPRB, &
  & 0.36987055E-09_JPRB, 0.36399714E-09_JPRB, 0.35526276E-09_JPRB, 0.34497127E-09_JPRB, 0.33470124E-09_JPRB, 0.32603131E-09_JPRB, &
  & 0.32015529E-09_JPRB, 0.31756134E-09_JPRB, 0.31803166E-09_JPRB, 0.32091602E-09_JPRB, 0.32492331E-09_JPRB, 0.32907702E-09_JPRB, &
  & 0.33231085E-09_JPRB, 0.33410522E-09_JPRB, 0.33408454E-09_JPRB, 0.33206354E-09_JPRB, 0.32810690E-09_JPRB, 0.32244857E-09_JPRB, &
  & 0.31533132E-09_JPRB, 0.30716371E-09_JPRB, 0.29840216E-09_JPRB, 0.28951708E-09_JPRB, 0.28092689E-09_JPRB, 0.27296856E-09_JPRB, &
  & 0.26588032E-09_JPRB, 0.25976576E-09_JPRB, 0.25467314E-09_JPRB, 0.25061089E-09_JPRB, 0.24753818E-09_JPRB, 0.24542296E-09_JPRB, &
  & 0.24420099E-09_JPRB, 0.24381705E-09_JPRB, 0.24435373E-09_JPRB, 0.24668503E-09_JPRB /)

RGHG6(:,23, 8) = (/ &
  & 0.17781726E-09_JPRB, 0.16725767E-09_JPRB, 0.16037330E-09_JPRB, 0.15409116E-09_JPRB, 0.14782855E-09_JPRB, 0.14187175E-09_JPRB, &
  & 0.13657081E-09_JPRB, 0.13278915E-09_JPRB, 0.13130527E-09_JPRB, 0.13273875E-09_JPRB, 0.13748784E-09_JPRB, 0.14563893E-09_JPRB, &
  & 0.15696404E-09_JPRB, 0.17093257E-09_JPRB, 0.18676526E-09_JPRB, 0.20352053E-09_JPRB, 0.22032634E-09_JPRB, 0.23660812E-09_JPRB, &
  & 0.25208655E-09_JPRB, 0.26680014E-09_JPRB, 0.28105224E-09_JPRB, 0.29524444E-09_JPRB, 0.30981617E-09_JPRB, 0.32504516E-09_JPRB, &
  & 0.34096137E-09_JPRB, 0.35674286E-09_JPRB, 0.37119618E-09_JPRB, 0.38287379E-09_JPRB, 0.39089609E-09_JPRB, 0.39491696E-09_JPRB, &
  & 0.39504297E-09_JPRB, 0.39175196E-09_JPRB, 0.38578760E-09_JPRB, 0.37824679E-09_JPRB, 0.37028261E-09_JPRB, 0.36339357E-09_JPRB, &
  & 0.35839076E-09_JPRB, 0.35574171E-09_JPRB, 0.35548686E-09_JPRB, 0.35676603E-09_JPRB, 0.35892470E-09_JPRB, 0.36119510E-09_JPRB, &
  & 0.36292444E-09_JPRB, 0.36348563E-09_JPRB, 0.36255837E-09_JPRB, 0.36001202E-09_JPRB, 0.35576370E-09_JPRB, 0.34999373E-09_JPRB, &
  & 0.34297593E-09_JPRB, 0.33510136E-09_JPRB, 0.32673433E-09_JPRB, 0.31825223E-09_JPRB, 0.31000971E-09_JPRB, 0.30231243E-09_JPRB, &
  & 0.29535685E-09_JPRB, 0.28923156E-09_JPRB, 0.28398178E-09_JPRB, 0.27962174E-09_JPRB, 0.27615338E-09_JPRB, 0.27356464E-09_JPRB, &
  & 0.27184133E-09_JPRB, 0.27093439E-09_JPRB, 0.27073777E-09_JPRB, 0.27169450E-09_JPRB /)

RGHG6(:,24, 8) = (/ &
  & 0.20577831E-09_JPRB, 0.19505136E-09_JPRB, 0.18792898E-09_JPRB, 0.18139677E-09_JPRB, 0.17491594E-09_JPRB, 0.16846825E-09_JPRB, &
  & 0.16264615E-09_JPRB, 0.15822510E-09_JPRB, 0.15602336E-09_JPRB, 0.15668042E-09_JPRB, 0.16055970E-09_JPRB, 0.16770789E-09_JPRB, &
  & 0.17789738E-09_JPRB, 0.19064943E-09_JPRB, 0.20527251E-09_JPRB, 0.22097932E-09_JPRB, 0.23699234E-09_JPRB, 0.25274072E-09_JPRB, &
  & 0.26794530E-09_JPRB, 0.28263897E-09_JPRB, 0.29699893E-09_JPRB, 0.31134387E-09_JPRB, 0.32603364E-09_JPRB, 0.34129477E-09_JPRB, &
  & 0.35707076E-09_JPRB, 0.37278619E-09_JPRB, 0.38727546E-09_JPRB, 0.39943721E-09_JPRB, 0.40838638E-09_JPRB, 0.41394593E-09_JPRB, &
  & 0.41628545E-09_JPRB, 0.41575215E-09_JPRB, 0.41297904E-09_JPRB, 0.40867215E-09_JPRB, 0.40380060E-09_JPRB, 0.39919057E-09_JPRB, &
  & 0.39547379E-09_JPRB, 0.39298920E-09_JPRB, 0.39158554E-09_JPRB, 0.39112105E-09_JPRB, 0.39102246E-09_JPRB, 0.39100162E-09_JPRB, &
  & 0.39049541E-09_JPRB, 0.38929304E-09_JPRB, 0.38695031E-09_JPRB, 0.38335396E-09_JPRB, 0.37850595E-09_JPRB, 0.37254119E-09_JPRB, &
  & 0.36562767E-09_JPRB, 0.35802608E-09_JPRB, 0.35005901E-09_JPRB, 0.34204792E-09_JPRB, 0.33430592E-09_JPRB, 0.32705622E-09_JPRB, &
  & 0.32043712E-09_JPRB, 0.31451300E-09_JPRB, 0.30931910E-09_JPRB, 0.30487649E-09_JPRB, 0.30119710E-09_JPRB, 0.29829864E-09_JPRB, &
  & 0.29618030E-09_JPRB, 0.29480060E-09_JPRB, 0.29403524E-09_JPRB, 0.29396144E-09_JPRB /)

RGHG6(:,25, 8) = (/ &
  & 0.23206738E-09_JPRB, 0.22160457E-09_JPRB, 0.21481039E-09_JPRB, 0.20836258E-09_JPRB, 0.20191289E-09_JPRB, 0.19537197E-09_JPRB, &
  & 0.18931814E-09_JPRB, 0.18449618E-09_JPRB, 0.18177040E-09_JPRB, 0.18179087E-09_JPRB, 0.18490107E-09_JPRB, 0.19114972E-09_JPRB, &
  & 0.20032899E-09_JPRB, 0.21201363E-09_JPRB, 0.22561966E-09_JPRB, 0.24044122E-09_JPRB, 0.25579366E-09_JPRB, 0.27111322E-09_JPRB, &
  & 0.28608707E-09_JPRB, 0.30065278E-09_JPRB, 0.31494138E-09_JPRB, 0.32918229E-09_JPRB, 0.34359485E-09_JPRB, 0.35836867E-09_JPRB, &
  & 0.37336889E-09_JPRB, 0.38811832E-09_JPRB, 0.40182235E-09_JPRB, 0.41360712E-09_JPRB, 0.42309151E-09_JPRB, 0.42993700E-09_JPRB, &
  & 0.43417439E-09_JPRB, 0.43610152E-09_JPRB, 0.43619369E-09_JPRB, 0.43490109E-09_JPRB, 0.43279461E-09_JPRB, 0.43034429E-09_JPRB, &
  & 0.42791712E-09_JPRB, 0.42572010E-09_JPRB, 0.42352225E-09_JPRB, 0.42161333E-09_JPRB, 0.41954798E-09_JPRB, 0.41735937E-09_JPRB, &
  & 0.41470460E-09_JPRB, 0.41156531E-09_JPRB, 0.40770209E-09_JPRB, 0.40298237E-09_JPRB, 0.39734055E-09_JPRB, 0.39095222E-09_JPRB, &
  & 0.38401879E-09_JPRB, 0.37672482E-09_JPRB, 0.36925973E-09_JPRB, 0.36185432E-09_JPRB, 0.35471931E-09_JPRB, 0.34802086E-09_JPRB, &
  & 0.34184391E-09_JPRB, 0.33623498E-09_JPRB, 0.33122122E-09_JPRB, 0.32682712E-09_JPRB, 0.32307951E-09_JPRB, 0.32000322E-09_JPRB, &
  & 0.31761982E-09_JPRB, 0.31584807E-09_JPRB, 0.31459951E-09_JPRB, 0.31372613E-09_JPRB /)

RGHG6(:,26, 8) = (/ &
  & 0.25629684E-09_JPRB, 0.24690822E-09_JPRB, 0.24057303E-09_JPRB, 0.23478661E-09_JPRB, 0.22865060E-09_JPRB, 0.22255102E-09_JPRB, &
  & 0.21666341E-09_JPRB, 0.21187722E-09_JPRB, 0.20899457E-09_JPRB, 0.20868962E-09_JPRB, 0.21132769E-09_JPRB, 0.21699278E-09_JPRB, &
  & 0.22549664E-09_JPRB, 0.23648544E-09_JPRB, 0.24943003E-09_JPRB, 0.26369495E-09_JPRB, 0.27859634E-09_JPRB, 0.29356456E-09_JPRB, &
  & 0.30822153E-09_JPRB, 0.32245842E-09_JPRB, 0.33628336E-09_JPRB, 0.34986447E-09_JPRB, 0.36335135E-09_JPRB, 0.37691258E-09_JPRB, &
  & 0.39042702E-09_JPRB, 0.40360965E-09_JPRB, 0.41604287E-09_JPRB, 0.42713894E-09_JPRB, 0.43638543E-09_JPRB, 0.44370735E-09_JPRB, &
  & 0.44917570E-09_JPRB, 0.45292226E-09_JPRB, 0.45518395E-09_JPRB, 0.45618254E-09_JPRB, 0.45619633E-09_JPRB, 0.45542256E-09_JPRB, &
  & 0.45399229E-09_JPRB, 0.45202503E-09_JPRB, 0.44943560E-09_JPRB, 0.44641685E-09_JPRB, 0.44291859E-09_JPRB, 0.43903875E-09_JPRB, &
  & 0.43477030E-09_JPRB, 0.43008136E-09_JPRB, 0.42492146E-09_JPRB, 0.41925502E-09_JPRB, 0.41312395E-09_JPRB, 0.40658690E-09_JPRB, &
  & 0.39973669E-09_JPRB, 0.39272152E-09_JPRB, 0.38570239E-09_JPRB, 0.37884229E-09_JPRB, 0.37228626E-09_JPRB, 0.36612829E-09_JPRB, &
  & 0.36041292E-09_JPRB, 0.35516531E-09_JPRB, 0.35040454E-09_JPRB, 0.34615788E-09_JPRB, 0.34245284E-09_JPRB, 0.33931824E-09_JPRB, &
  & 0.33676614E-09_JPRB, 0.33473652E-09_JPRB, 0.33309713E-09_JPRB, 0.33141770E-09_JPRB /)

RGHG6(:,27, 8) = (/ &
  & 0.27890160E-09_JPRB, 0.27081831E-09_JPRB, 0.26547878E-09_JPRB, 0.26027000E-09_JPRB, 0.25515642E-09_JPRB, 0.24967689E-09_JPRB, &
  & 0.24450886E-09_JPRB, 0.24018848E-09_JPRB, 0.23759156E-09_JPRB, 0.23737398E-09_JPRB, 0.23993199E-09_JPRB, 0.24536836E-09_JPRB, &
  & 0.25356955E-09_JPRB, 0.26419658E-09_JPRB, 0.27677347E-09_JPRB, 0.29067032E-09_JPRB, 0.30520617E-09_JPRB, 0.31973885E-09_JPRB, &
  & 0.33388742E-09_JPRB, 0.34738407E-09_JPRB, 0.36027065E-09_JPRB, 0.37261291E-09_JPRB, 0.38455295E-09_JPRB, 0.39629094E-09_JPRB, &
  & 0.40773798E-09_JPRB, 0.41883161E-09_JPRB, 0.42930690E-09_JPRB, 0.43899984E-09_JPRB, 0.44778498E-09_JPRB, 0.45536325E-09_JPRB, &
  & 0.46160481E-09_JPRB, 0.46652643E-09_JPRB, 0.47019322E-09_JPRB, 0.47264687E-09_JPRB, 0.47398030E-09_JPRB, 0.47423376E-09_JPRB, &
  & 0.47343640E-09_JPRB, 0.47164150E-09_JPRB, 0.46888182E-09_JPRB, 0.46523807E-09_JPRB, 0.46091636E-09_JPRB, 0.45599188E-09_JPRB, &
  & 0.45067478E-09_JPRB, 0.44496201E-09_JPRB, 0.43892279E-09_JPRB, 0.43255211E-09_JPRB, 0.42599588E-09_JPRB, 0.41938264E-09_JPRB, &
  & 0.41279824E-09_JPRB, 0.40625242E-09_JPRB, 0.39979844E-09_JPRB, 0.39354814E-09_JPRB, 0.38759007E-09_JPRB, 0.38198017E-09_JPRB, &
  & 0.37673448E-09_JPRB, 0.37186640E-09_JPRB, 0.36739153E-09_JPRB, 0.36333633E-09_JPRB, 0.35973188E-09_JPRB, 0.35661427E-09_JPRB, &
  & 0.35398723E-09_JPRB, 0.35180778E-09_JPRB, 0.34991399E-09_JPRB, 0.34761652E-09_JPRB /)

RGHG6(:,28, 8) = (/ &
  & 0.30043171E-09_JPRB, 0.29375655E-09_JPRB, 0.28923852E-09_JPRB, 0.28518202E-09_JPRB, 0.28079172E-09_JPRB, 0.27645483E-09_JPRB, &
  & 0.27215480E-09_JPRB, 0.26868405E-09_JPRB, 0.26674160E-09_JPRB, 0.26697705E-09_JPRB, 0.26978225E-09_JPRB, 0.27530472E-09_JPRB, &
  & 0.28342828E-09_JPRB, 0.29386946E-09_JPRB, 0.30614453E-09_JPRB, 0.31965716E-09_JPRB, 0.33366665E-09_JPRB, 0.34757056E-09_JPRB, &
  & 0.36087972E-09_JPRB, 0.37332998E-09_JPRB, 0.38492590E-09_JPRB, 0.39563966E-09_JPRB, 0.40579673E-09_JPRB, 0.41543285E-09_JPRB, &
  & 0.42466852E-09_JPRB, 0.43357437E-09_JPRB, 0.44217918E-09_JPRB, 0.45045634E-09_JPRB, 0.45833107E-09_JPRB, 0.46558199E-09_JPRB, &
  & 0.47203513E-09_JPRB, 0.47751914E-09_JPRB, 0.48191640E-09_JPRB, 0.48513210E-09_JPRB, 0.48713650E-09_JPRB, 0.48789961E-09_JPRB, &
  & 0.48742183E-09_JPRB, 0.48573051E-09_JPRB, 0.48292004E-09_JPRB, 0.47903798E-09_JPRB, 0.47431115E-09_JPRB, 0.46890225E-09_JPRB, &
  & 0.46301712E-09_JPRB, 0.45678691E-09_JPRB, 0.45030180E-09_JPRB, 0.44369713E-09_JPRB, 0.43710513E-09_JPRB, 0.43067006E-09_JPRB, &
  & 0.42439940E-09_JPRB, 0.41830245E-09_JPRB, 0.41238285E-09_JPRB, 0.40669063E-09_JPRB, 0.40127435E-09_JPRB, 0.39615800E-09_JPRB, &
  & 0.39134096E-09_JPRB, 0.38682621E-09_JPRB, 0.38262485E-09_JPRB, 0.37875897E-09_JPRB, 0.37527059E-09_JPRB, 0.37219453E-09_JPRB, &
  & 0.36955392E-09_JPRB, 0.36730588E-09_JPRB, 0.36526968E-09_JPRB, 0.36269046E-09_JPRB /)

RGHG6(:,29, 8) = (/ &
  & 0.32098654E-09_JPRB, 0.31557335E-09_JPRB, 0.31207426E-09_JPRB, 0.30870714E-09_JPRB, 0.30547803E-09_JPRB, 0.30200428E-09_JPRB, &
  & 0.29879793E-09_JPRB, 0.29628844E-09_JPRB, 0.29520220E-09_JPRB, 0.29610625E-09_JPRB, 0.29937092E-09_JPRB, 0.30511388E-09_JPRB, &
  & 0.31325331E-09_JPRB, 0.32348560E-09_JPRB, 0.33536837E-09_JPRB, 0.34829165E-09_JPRB, 0.36156456E-09_JPRB, 0.37456535E-09_JPRB, &
  & 0.38682585E-09_JPRB, 0.39804629E-09_JPRB, 0.40821155E-09_JPRB, 0.41733381E-09_JPRB, 0.42565912E-09_JPRB, 0.43331411E-09_JPRB, &
  & 0.44048040E-09_JPRB, 0.44741189E-09_JPRB, 0.45423498E-09_JPRB, 0.46108400E-09_JPRB, 0.46792686E-09_JPRB, 0.47465543E-09_JPRB, &
  & 0.48093601E-09_JPRB, 0.48652116E-09_JPRB, 0.49116633E-09_JPRB, 0.49466031E-09_JPRB, 0.49690507E-09_JPRB, 0.49784549E-09_JPRB, &
  & 0.49748372E-09_JPRB, 0.49584614E-09_JPRB, 0.49304394E-09_JPRB, 0.48914711E-09_JPRB, 0.48430926E-09_JPRB, 0.47875642E-09_JPRB, &
  & 0.47267729E-09_JPRB, 0.46626997E-09_JPRB, 0.45968598E-09_JPRB, 0.45311785E-09_JPRB, 0.44673532E-09_JPRB, 0.44063408E-09_JPRB, &
  & 0.43481546E-09_JPRB, 0.42921885E-09_JPRB, 0.42382359E-09_JPRB, 0.41864542E-09_JPRB, 0.41372045E-09_JPRB, 0.40905013E-09_JPRB, &
  & 0.40462489E-09_JPRB, 0.40044604E-09_JPRB, 0.39652504E-09_JPRB, 0.39289766E-09_JPRB, 0.38960618E-09_JPRB, 0.38668793E-09_JPRB, &
  & 0.38415812E-09_JPRB, 0.38196071E-09_JPRB, 0.37989045E-09_JPRB, 0.37688003E-09_JPRB /)

RGHG6(:,30, 8) = (/ &
  & 0.34029771E-09_JPRB, 0.33603748E-09_JPRB, 0.33325404E-09_JPRB, 0.33081360E-09_JPRB, 0.32826003E-09_JPRB, 0.32581068E-09_JPRB, &
  & 0.32353475E-09_JPRB, 0.32201686E-09_JPRB, 0.32182154E-09_JPRB, 0.32345485E-09_JPRB, 0.32721376E-09_JPRB, 0.33320802E-09_JPRB, &
  & 0.34130640E-09_JPRB, 0.35123635E-09_JPRB, 0.36255499E-09_JPRB, 0.37470535E-09_JPRB, 0.38702067E-09_JPRB, 0.39897960E-09_JPRB, &
  & 0.41008691E-09_JPRB, 0.42007026E-09_JPRB, 0.42888837E-09_JPRB, 0.43657586E-09_JPRB, 0.44329287E-09_JPRB, 0.44927864E-09_JPRB, &
  & 0.45477594E-09_JPRB, 0.46006338E-09_JPRB, 0.46541460E-09_JPRB, 0.47099319E-09_JPRB, 0.47684845E-09_JPRB, 0.48283810E-09_JPRB, &
  & 0.48871546E-09_JPRB, 0.49410448E-09_JPRB, 0.49866444E-09_JPRB, 0.50212995E-09_JPRB, 0.50435395E-09_JPRB, 0.50528176E-09_JPRB, &
  & 0.50492832E-09_JPRB, 0.50333310E-09_JPRB, 0.50057958E-09_JPRB, 0.49679383E-09_JPRB, 0.49204346E-09_JPRB, 0.48656335E-09_JPRB, &
  & 0.48056137E-09_JPRB, 0.47425480E-09_JPRB, 0.46786475E-09_JPRB, 0.46156937E-09_JPRB, 0.45553550E-09_JPRB, 0.44984955E-09_JPRB, &
  & 0.44448081E-09_JPRB, 0.43935144E-09_JPRB, 0.43443391E-09_JPRB, 0.42971912E-09_JPRB, 0.42521689E-09_JPRB, 0.42093387E-09_JPRB, &
  & 0.41685111E-09_JPRB, 0.41297010E-09_JPRB, 0.40931822E-09_JPRB, 0.40592557E-09_JPRB, 0.40282414E-09_JPRB, 0.40004611E-09_JPRB, &
  & 0.39760154E-09_JPRB, 0.39542689E-09_JPRB, 0.39329151E-09_JPRB, 0.39026382E-09_JPRB /)

RGHG6(:,31, 8) = (/ &
  & 0.35804268E-09_JPRB, 0.35475481E-09_JPRB, 0.35266284E-09_JPRB, 0.35075481E-09_JPRB, 0.34900016E-09_JPRB, 0.34726866E-09_JPRB, &
  & 0.34588976E-09_JPRB, 0.34525971E-09_JPRB, 0.34589359E-09_JPRB, 0.34819667E-09_JPRB, 0.35240680E-09_JPRB, 0.35855410E-09_JPRB, &
  & 0.36652528E-09_JPRB, 0.37601547E-09_JPRB, 0.38663689E-09_JPRB, 0.39786746E-09_JPRB, 0.40915793E-09_JPRB, 0.41999296E-09_JPRB, &
  & 0.42999421E-09_JPRB, 0.43886084E-09_JPRB, 0.44652237E-09_JPRB, 0.45302007E-09_JPRB, 0.45849993E-09_JPRB, 0.46321136E-09_JPRB, &
  & 0.46744392E-09_JPRB, 0.47150395E-09_JPRB, 0.47567544E-09_JPRB, 0.48019144E-09_JPRB, 0.48513737E-09_JPRB, 0.49040100E-09_JPRB, &
  & 0.49572857E-09_JPRB, 0.50071053E-09_JPRB, 0.50497861E-09_JPRB, 0.50821108E-09_JPRB, 0.51025983E-09_JPRB, 0.51107329E-09_JPRB, &
  & 0.51068438E-09_JPRB, 0.50913934E-09_JPRB, 0.50651583E-09_JPRB, 0.50288723E-09_JPRB, 0.49839305E-09_JPRB, 0.49314319E-09_JPRB, &
  & 0.48739812E-09_JPRB, 0.48139354E-09_JPRB, 0.47533311E-09_JPRB, 0.46942528E-09_JPRB, 0.46382528E-09_JPRB, 0.45859222E-09_JPRB, &
  & 0.45366125E-09_JPRB, 0.44895990E-09_JPRB, 0.44444637E-09_JPRB, 0.44011306E-09_JPRB, 0.43595069E-09_JPRB, 0.43197834E-09_JPRB, &
  & 0.42817969E-09_JPRB, 0.42455539E-09_JPRB, 0.42113643E-09_JPRB, 0.41794088E-09_JPRB, 0.41500106E-09_JPRB, 0.41235693E-09_JPRB, &
  & 0.41002679E-09_JPRB, 0.40795270E-09_JPRB, 0.40593065E-09_JPRB, 0.40286841E-09_JPRB /)

RGHG6(:,32, 8) = (/ &
  & 0.37390019E-09_JPRB, 0.37141687E-09_JPRB, 0.36987832E-09_JPRB, 0.36857564E-09_JPRB, 0.36735232E-09_JPRB, 0.36632891E-09_JPRB, &
  & 0.36568806E-09_JPRB, 0.36583780E-09_JPRB, 0.36719044E-09_JPRB, 0.37005551E-09_JPRB, 0.37457754E-09_JPRB, 0.38077475E-09_JPRB, &
  & 0.38847692E-09_JPRB, 0.39743162E-09_JPRB, 0.40726103E-09_JPRB, 0.41754006E-09_JPRB, 0.42778697E-09_JPRB, 0.43758522E-09_JPRB, &
  & 0.44656048E-09_JPRB, 0.45448675E-09_JPRB, 0.46124843E-09_JPRB, 0.46685311E-09_JPRB, 0.47145793E-09_JPRB, 0.47528192E-09_JPRB, &
  & 0.47863941E-09_JPRB, 0.48183246E-09_JPRB, 0.48516285E-09_JPRB, 0.48885090E-09_JPRB, 0.49299143E-09_JPRB, 0.49753202E-09_JPRB, &
  & 0.50221788E-09_JPRB, 0.50667331E-09_JPRB, 0.51049148E-09_JPRB, 0.51335936E-09_JPRB, 0.51513604E-09_JPRB, 0.51578031E-09_JPRB, &
  & 0.51534682E-09_JPRB, 0.51388288E-09_JPRB, 0.51143645E-09_JPRB, 0.50808341E-09_JPRB, 0.50388688E-09_JPRB, 0.49903248E-09_JPRB, &
  & 0.49369658E-09_JPRB, 0.48809884E-09_JPRB, 0.48250254E-09_JPRB, 0.47704679E-09_JPRB, 0.47189214E-09_JPRB, 0.46705062E-09_JPRB, &
  & 0.46250112E-09_JPRB, 0.45814696E-09_JPRB, 0.45394716E-09_JPRB, 0.44991055E-09_JPRB, 0.44601930E-09_JPRB, 0.44228671E-09_JPRB, &
  & 0.43871712E-09_JPRB, 0.43531687E-09_JPRB, 0.43210349E-09_JPRB, 0.42909809E-09_JPRB, 0.42633555E-09_JPRB, 0.42385684E-09_JPRB, &
  & 0.42167630E-09_JPRB, 0.41972772E-09_JPRB, 0.41777007E-09_JPRB, 0.41474441E-09_JPRB /)

RGHG6(:,33, 8) = (/ &
  & 0.38795173E-09_JPRB, 0.38619369E-09_JPRB, 0.38513057E-09_JPRB, 0.38425840E-09_JPRB, 0.38355771E-09_JPRB, 0.38308492E-09_JPRB, &
  & 0.38308143E-09_JPRB, 0.38388648E-09_JPRB, 0.38581369E-09_JPRB, 0.38908521E-09_JPRB, 0.39379489E-09_JPRB, 0.39988557E-09_JPRB, &
  & 0.40723111E-09_JPRB, 0.41556439E-09_JPRB, 0.42459281E-09_JPRB, 0.43392587E-09_JPRB, 0.44322115E-09_JPRB, 0.45207676E-09_JPRB, &
  & 0.46020660E-09_JPRB, 0.46737308E-09_JPRB, 0.47346416E-09_JPRB, 0.47848370E-09_JPRB, 0.48250304E-09_JPRB, 0.48577392E-09_JPRB, &
  & 0.48857496E-09_JPRB, 0.49120236E-09_JPRB, 0.49393067E-09_JPRB, 0.49697607E-09_JPRB, 0.50045001E-09_JPRB, 0.50430710E-09_JPRB, &
  & 0.50833637E-09_JPRB, 0.51216742E-09_JPRB, 0.51543902E-09_JPRB, 0.51785265E-09_JPRB, 0.51929921E-09_JPRB, 0.51975108E-09_JPRB, &
  & 0.51927934E-09_JPRB, 0.51791493E-09_JPRB, 0.51570703E-09_JPRB, 0.51267551E-09_JPRB, 0.50889909E-09_JPRB, 0.50448606E-09_JPRB, &
  & 0.49966375E-09_JPRB, 0.49462340E-09_JPRB, 0.48947918E-09_JPRB, 0.48452409E-09_JPRB, 0.47975263E-09_JPRB, 0.47527438E-09_JPRB, &
  & 0.47101117E-09_JPRB, 0.46694154E-09_JPRB, 0.46297607E-09_JPRB, 0.45914630E-09_JPRB, 0.45545934E-09_JPRB, 0.45191664E-09_JPRB, &
  & 0.44853737E-09_JPRB, 0.44532969E-09_JPRB, 0.44230297E-09_JPRB, 0.43947301E-09_JPRB, 0.43687778E-09_JPRB, 0.43454684E-09_JPRB, &
  & 0.43249165E-09_JPRB, 0.43064077E-09_JPRB, 0.42877452E-09_JPRB, 0.42587484E-09_JPRB /)

RGHG6(:,34, 8) = (/ &
  & 0.40048831E-09_JPRB, 0.39926290E-09_JPRB, 0.39859313E-09_JPRB, 0.39811432E-09_JPRB, 0.39781858E-09_JPRB, 0.39781889E-09_JPRB, &
  & 0.39833509E-09_JPRB, 0.39964640E-09_JPRB, 0.40200232E-09_JPRB, 0.40553966E-09_JPRB, 0.41027576E-09_JPRB, 0.41617493E-09_JPRB, &
  & 0.42307052E-09_JPRB, 0.43077375E-09_JPRB, 0.43900961E-09_JPRB, 0.44749682E-09_JPRB, 0.45590776E-09_JPRB, 0.46398507E-09_JPRB, &
  & 0.47142473E-09_JPRB, 0.47803977E-09_JPRB, 0.48368842E-09_JPRB, 0.48829013E-09_JPRB, 0.49199606E-09_JPRB, 0.49497428E-09_JPRB, &
  & 0.49747856E-09_JPRB, 0.49976645E-09_JPRB, 0.50209836E-09_JPRB, 0.50466287E-09_JPRB, 0.50755988E-09_JPRB, 0.51077564E-09_JPRB, &
  & 0.51411414E-09_JPRB, 0.51727672E-09_JPRB, 0.51993304E-09_JPRB, 0.52184385E-09_JPRB, 0.52293342E-09_JPRB, 0.52318982E-09_JPRB, &
  & 0.52268984E-09_JPRB, 0.52144472E-09_JPRB, 0.51949417E-09_JPRB, 0.51684557E-09_JPRB, 0.51351962E-09_JPRB, 0.50963245E-09_JPRB, &
  & 0.50536997E-09_JPRB, 0.50091042E-09_JPRB, 0.49631999E-09_JPRB, 0.49175375E-09_JPRB, 0.48737936E-09_JPRB, 0.48318027E-09_JPRB, &
  & 0.47913634E-09_JPRB, 0.47525872E-09_JPRB, 0.47148224E-09_JPRB, 0.46779142E-09_JPRB, 0.46425816E-09_JPRB, 0.46087145E-09_JPRB, &
  & 0.45765025E-09_JPRB, 0.45461024E-09_JPRB, 0.45175189E-09_JPRB, 0.44908749E-09_JPRB, 0.44664294E-09_JPRB, 0.44445087E-09_JPRB, &
  & 0.44252133E-09_JPRB, 0.44079274E-09_JPRB, 0.43904255E-09_JPRB, 0.43624443E-09_JPRB /)

RGHG6(:,35, 8) = (/ &
  & 0.41144826E-09_JPRB, 0.41085982E-09_JPRB, 0.41053477E-09_JPRB, 0.41037976E-09_JPRB, 0.41043063E-09_JPRB, 0.41081130E-09_JPRB, &
  & 0.41172349E-09_JPRB, 0.41341217E-09_JPRB, 0.41604742E-09_JPRB, 0.41969703E-09_JPRB, 0.42437631E-09_JPRB, 0.42998013E-09_JPRB, &
  & 0.43641901E-09_JPRB, 0.44348408E-09_JPRB, 0.45100035E-09_JPRB, 0.45869900E-09_JPRB, 0.46637311E-09_JPRB, 0.47376231E-09_JPRB, &
  & 0.48064697E-09_JPRB, 0.48684345E-09_JPRB, 0.49217791E-09_JPRB, 0.49661703E-09_JPRB, 0.50022642E-09_JPRB, 0.50311338E-09_JPRB, &
  & 0.50550303E-09_JPRB, 0.50761917E-09_JPRB, 0.50968069E-09_JPRB, 0.51186261E-09_JPRB, 0.51425575E-09_JPRB, 0.51684734E-09_JPRB, &
  & 0.51949756E-09_JPRB, 0.52195398E-09_JPRB, 0.52397320E-09_JPRB, 0.52537419E-09_JPRB, 0.52611254E-09_JPRB, 0.52619420E-09_JPRB, &
  & 0.52567933E-09_JPRB, 0.52456972E-09_JPRB, 0.52290111E-09_JPRB, 0.52062848E-09_JPRB, 0.51778737E-09_JPRB, 0.51444543E-09_JPRB, &
  & 0.51075971E-09_JPRB, 0.50689364E-09_JPRB, 0.50280835E-09_JPRB, 0.49864485E-09_JPRB, 0.49458815E-09_JPRB, 0.49063553E-09_JPRB, &
  & 0.48676096E-09_JPRB, 0.48301563E-09_JPRB, 0.47937576E-09_JPRB, 0.47579213E-09_JPRB, 0.47236948E-09_JPRB, 0.46911602E-09_JPRB, &
  & 0.46603810E-09_JPRB, 0.46315662E-09_JPRB, 0.46046014E-09_JPRB, 0.45795279E-09_JPRB, 0.45565615E-09_JPRB, 0.45359935E-09_JPRB, &
  & 0.45179194E-09_JPRB, 0.45016649E-09_JPRB, 0.44850340E-09_JPRB, 0.44584650E-09_JPRB /)

RGHG6(:,36, 8) = (/ &
  & 0.42139245E-09_JPRB, 0.42123699E-09_JPRB, 0.42121440E-09_JPRB, 0.42133508E-09_JPRB, 0.42167064E-09_JPRB, 0.42234649E-09_JPRB, &
  & 0.42355430E-09_JPRB, 0.42548692E-09_JPRB, 0.42826598E-09_JPRB, 0.43193629E-09_JPRB, 0.43644394E-09_JPRB, 0.44173609E-09_JPRB, &
  & 0.44768300E-09_JPRB, 0.45416054E-09_JPRB, 0.46099125E-09_JPRB, 0.46801385E-09_JPRB, 0.47501175E-09_JPRB, 0.48183763E-09_JPRB, &
  & 0.48828963E-09_JPRB, 0.49416893E-09_JPRB, 0.49936338E-09_JPRB, 0.50376819E-09_JPRB, 0.50738092E-09_JPRB, 0.51029198E-09_JPRB, &
  & 0.51264493E-09_JPRB, 0.51465660E-09_JPRB, 0.51651017E-09_JPRB, 0.51835380E-09_JPRB, 0.52027316E-09_JPRB, 0.52226945E-09_JPRB, &
  & 0.52423910E-09_JPRB, 0.52601851E-09_JPRB, 0.52743215E-09_JPRB, 0.52836924E-09_JPRB, 0.52880800E-09_JPRB, 0.52876326E-09_JPRB, &
  & 0.52826787E-09_JPRB, 0.52732552E-09_JPRB, 0.52593419E-09_JPRB, 0.52405352E-09_JPRB, 0.52167970E-09_JPRB, 0.51887716E-09_JPRB, &
  & 0.51576454E-09_JPRB, 0.51238908E-09_JPRB, 0.50877813E-09_JPRB, 0.50501536E-09_JPRB, 0.50124827E-09_JPRB, 0.49749338E-09_JPRB, &
  & 0.49375998E-09_JPRB, 0.49012727E-09_JPRB, 0.48657478E-09_JPRB, 0.48309051E-09_JPRB, 0.47977172E-09_JPRB, 0.47664356E-09_JPRB, &
  & 0.47371257E-09_JPRB, 0.47098714E-09_JPRB, 0.46845161E-09_JPRB, 0.46609949E-09_JPRB, 0.46394671E-09_JPRB, 0.46202292E-09_JPRB, &
  & 0.46033316E-09_JPRB, 0.45881399E-09_JPRB, 0.45725082E-09_JPRB, 0.45472312E-09_JPRB /)

RGHG6(:,37, 8) = (/ &
  & 0.43038673E-09_JPRB, 0.43064668E-09_JPRB, 0.43088766E-09_JPRB, 0.43124654E-09_JPRB, 0.43181497E-09_JPRB, 0.43272583E-09_JPRB, &
  & 0.43414008E-09_JPRB, 0.43621104E-09_JPRB, 0.43903375E-09_JPRB, 0.44260812E-09_JPRB, 0.44690546E-09_JPRB, 0.45182408E-09_JPRB, &
  & 0.45729523E-09_JPRB, 0.46319173E-09_JPRB, 0.46940613E-09_JPRB, 0.47578691E-09_JPRB, 0.48221843E-09_JPRB, 0.48852555E-09_JPRB, &
  & 0.49461429E-09_JPRB, 0.50030502E-09_JPRB, 0.50540971E-09_JPRB, 0.50981669E-09_JPRB, 0.51344345E-09_JPRB, 0.51632021E-09_JPRB, &
  & 0.51860177E-09_JPRB, 0.52044918E-09_JPRB, 0.52206095E-09_JPRB, 0.52357141E-09_JPRB, 0.52505450E-09_JPRB, 0.52652072E-09_JPRB, &
  & 0.52791221E-09_JPRB, 0.52912319E-09_JPRB, 0.53005217E-09_JPRB, 0.53063615E-09_JPRB, 0.53086935E-09_JPRB, 0.53076588E-09_JPRB, &
  & 0.53034216E-09_JPRB, 0.52959437E-09_JPRB, 0.52850163E-09_JPRB, 0.52701293E-09_JPRB, 0.52511129E-09_JPRB, 0.52283006E-09_JPRB, &
  & 0.52021309E-09_JPRB, 0.51729510E-09_JPRB, 0.51412663E-09_JPRB, 0.51075116E-09_JPRB, 0.50724935E-09_JPRB, 0.50367149E-09_JPRB, &
  & 0.50008647E-09_JPRB, 0.49654786E-09_JPRB, 0.49306953E-09_JPRB, 0.48968524E-09_JPRB, 0.48648102E-09_JPRB, 0.48348703E-09_JPRB, &
  & 0.48070947E-09_JPRB, 0.47814808E-09_JPRB, 0.47577403E-09_JPRB, 0.47357607E-09_JPRB, 0.47156873E-09_JPRB, 0.46977822E-09_JPRB, &
  & 0.46820825E-09_JPRB, 0.46679077E-09_JPRB, 0.46532780E-09_JPRB, 0.46294055E-09_JPRB /)

RGHG6(:,38, 8) = (/ &
  & 0.43868098E-09_JPRB, 0.43930654E-09_JPRB, 0.43977311E-09_JPRB, 0.44033283E-09_JPRB, 0.44110682E-09_JPRB, 0.44220225E-09_JPRB, &
  & 0.44375578E-09_JPRB, 0.44588702E-09_JPRB, 0.44865103E-09_JPRB, 0.45206366E-09_JPRB, 0.45607360E-09_JPRB, 0.46060647E-09_JPRB, &
  & 0.46558143E-09_JPRB, 0.47092324E-09_JPRB, 0.47654225E-09_JPRB, 0.48234855E-09_JPRB, 0.48823923E-09_JPRB, 0.49412269E-09_JPRB, &
  & 0.49986748E-09_JPRB, 0.50533377E-09_JPRB, 0.51034155E-09_JPRB, 0.51465254E-09_JPRB, 0.51815663E-09_JPRB, 0.52087468E-09_JPRB, &
  & 0.52292476E-09_JPRB, 0.52453519E-09_JPRB, 0.52587701E-09_JPRB, 0.52708088E-09_JPRB, 0.52821464E-09_JPRB, 0.52929006E-09_JPRB, &
  & 0.53027466E-09_JPRB, 0.53110571E-09_JPRB, 0.53171961E-09_JPRB, 0.53208560E-09_JPRB, 0.53220522E-09_JPRB, 0.53209481E-09_JPRB, &
  & 0.53176108E-09_JPRB, 0.53120214E-09_JPRB, 0.53038840E-09_JPRB, 0.52927707E-09_JPRB, 0.52782945E-09_JPRB, 0.52605142E-09_JPRB, &
  & 0.52391197E-09_JPRB, 0.52147203E-09_JPRB, 0.51873444E-09_JPRB, 0.51572457E-09_JPRB, 0.51249333E-09_JPRB, 0.50912297E-09_JPRB, &
  & 0.50568499E-09_JPRB, 0.50225180E-09_JPRB, 0.49886351E-09_JPRB, 0.49559723E-09_JPRB, 0.49252513E-09_JPRB, 0.48968102E-09_JPRB, &
  & 0.48707105E-09_JPRB, 0.48467907E-09_JPRB, 0.48247112E-09_JPRB, 0.48043020E-09_JPRB, 0.47857063E-09_JPRB, 0.47691789E-09_JPRB, &
  & 0.47547011E-09_JPRB, 0.47416016E-09_JPRB, 0.47279614E-09_JPRB, 0.47056120E-09_JPRB /)

RGHG6(:,39, 8) = (/ &
  & 0.44644879E-09_JPRB, 0.44737847E-09_JPRB, 0.44802789E-09_JPRB, 0.44877044E-09_JPRB, 0.44970699E-09_JPRB, 0.45095722E-09_JPRB, &
  & 0.45260506E-09_JPRB, 0.45471982E-09_JPRB, 0.45736215E-09_JPRB, 0.46054138E-09_JPRB, 0.46422038E-09_JPRB, 0.46833676E-09_JPRB, &
  & 0.47282106E-09_JPRB, 0.47761423E-09_JPRB, 0.48266635E-09_JPRB, 0.48791537E-09_JPRB, 0.49330218E-09_JPRB, 0.49875670E-09_JPRB, &
  & 0.50417009E-09_JPRB, 0.50939553E-09_JPRB, 0.51416582E-09_JPRB, 0.51826499E-09_JPRB, 0.52150834E-09_JPRB, 0.52393601E-09_JPRB, &
  & 0.52573096E-09_JPRB, 0.52709392E-09_JPRB, 0.52820920E-09_JPRB, 0.52918520E-09_JPRB, 0.53007870E-09_JPRB, 0.53090243E-09_JPRB, &
  & 0.53163968E-09_JPRB, 0.53224458E-09_JPRB, 0.53267923E-09_JPRB, 0.53292354E-09_JPRB, 0.53298632E-09_JPRB, 0.53288096E-09_JPRB, &
  & 0.53261701E-09_JPRB, 0.53219162E-09_JPRB, 0.53158816E-09_JPRB, 0.53076610E-09_JPRB, 0.52970200E-09_JPRB, 0.52836147E-09_JPRB, &
  & 0.52670612E-09_JPRB, 0.52476107E-09_JPRB, 0.52247806E-09_JPRB, 0.51986704E-09_JPRB, 0.51696036E-09_JPRB, 0.51382448E-09_JPRB, &
  & 0.51056442E-09_JPRB, 0.50725291E-09_JPRB, 0.50398558E-09_JPRB, 0.50085608E-09_JPRB, 0.49793625E-09_JPRB, 0.49526128E-09_JPRB, &
  & 0.49282983E-09_JPRB, 0.49061494E-09_JPRB, 0.48857463E-09_JPRB, 0.48669280E-09_JPRB, 0.48498261E-09_JPRB, 0.48346976E-09_JPRB, &
  & 0.48214710E-09_JPRB, 0.48094662E-09_JPRB, 0.47969079E-09_JPRB, 0.47762372E-09_JPRB /)

RGHG6(:,40, 8) = (/ &
  & 0.45386023E-09_JPRB, 0.45500098E-09_JPRB, 0.45579013E-09_JPRB, 0.45664614E-09_JPRB, 0.45773690E-09_JPRB, 0.45910664E-09_JPRB, &
  & 0.46079429E-09_JPRB, 0.46286136E-09_JPRB, 0.46532300E-09_JPRB, 0.46822046E-09_JPRB, 0.47154181E-09_JPRB, 0.47522691E-09_JPRB, &
  & 0.47922388E-09_JPRB, 0.48348869E-09_JPRB, 0.48799154E-09_JPRB, 0.49270393E-09_JPRB, 0.49759563E-09_JPRB, 0.50261162E-09_JPRB, &
  & 0.50767318E-09_JPRB, 0.51256877E-09_JPRB, 0.51707011E-09_JPRB, 0.52084720E-09_JPRB, 0.52378885E-09_JPRB, 0.52594717E-09_JPRB, &
  & 0.52750776E-09_JPRB, 0.52868454E-09_JPRB, 0.52963306E-09_JPRB, 0.53045068E-09_JPRB, 0.53118560E-09_JPRB, 0.53185234E-09_JPRB, &
  & 0.53243743E-09_JPRB, 0.53291227E-09_JPRB, 0.53324345E-09_JPRB, 0.53342070E-09_JPRB, 0.53345256E-09_JPRB, 0.53335369E-09_JPRB, &
  & 0.53313298E-09_JPRB, 0.53279159E-09_JPRB, 0.53232008E-09_JPRB, 0.53169247E-09_JPRB, 0.53089322E-09_JPRB, 0.52988991E-09_JPRB, &
  & 0.52864191E-09_JPRB, 0.52715182E-09_JPRB, 0.52533589E-09_JPRB, 0.52316246E-09_JPRB, 0.52062604E-09_JPRB, 0.51778148E-09_JPRB, &
  & 0.51472698E-09_JPRB, 0.51158033E-09_JPRB, 0.50846410E-09_JPRB, 0.50549392E-09_JPRB, 0.50274723E-09_JPRB, 0.50025545E-09_JPRB, &
  & 0.49801213E-09_JPRB, 0.49597626E-09_JPRB, 0.49410781E-09_JPRB, 0.49238380E-09_JPRB, 0.49082560E-09_JPRB, 0.48945281E-09_JPRB, &
  & 0.48825610E-09_JPRB, 0.48716586E-09_JPRB, 0.48602061E-09_JPRB, 0.48412618E-09_JPRB /)

RGHG6(:,41, 8) = (/ &
  & 0.46106935E-09_JPRB, 0.46232576E-09_JPRB, 0.46313933E-09_JPRB, 0.46408313E-09_JPRB, 0.46526258E-09_JPRB, 0.46671517E-09_JPRB, &
  & 0.46843746E-09_JPRB, 0.47039173E-09_JPRB, 0.47265170E-09_JPRB, 0.47524945E-09_JPRB, 0.47819204E-09_JPRB, 0.48145121E-09_JPRB, &
  & 0.48497628E-09_JPRB, 0.48873372E-09_JPRB, 0.49271026E-09_JPRB, 0.49690141E-09_JPRB, 0.50129634E-09_JPRB, 0.50587767E-09_JPRB, &
  & 0.51053606E-09_JPRB, 0.51511317E-09_JPRB, 0.51926752E-09_JPRB, 0.52274923E-09_JPRB, 0.52540328E-09_JPRB, 0.52732524E-09_JPRB, &
  & 0.52870652E-09_JPRB, 0.52973897E-09_JPRB, 0.53056648E-09_JPRB, 0.53127158E-09_JPRB, 0.53189736E-09_JPRB, 0.53245758E-09_JPRB, &
  & 0.53294785E-09_JPRB, 0.53333937E-09_JPRB, 0.53360977E-09_JPRB, 0.53374644E-09_JPRB, 0.53376131E-09_JPRB, 0.53366778E-09_JPRB, &
  & 0.53347560E-09_JPRB, 0.53318694E-09_JPRB, 0.53279936E-09_JPRB, 0.53229610E-09_JPRB, 0.53167076E-09_JPRB, 0.53090077E-09_JPRB, &
  & 0.52995525E-09_JPRB, 0.52882937E-09_JPRB, 0.52742427E-09_JPRB, 0.52568411E-09_JPRB, 0.52355253E-09_JPRB, 0.52103011E-09_JPRB, &
  & 0.51824106E-09_JPRB, 0.51528942E-09_JPRB, 0.51235399E-09_JPRB, 0.50956001E-09_JPRB, 0.50699478E-09_JPRB, 0.50469545E-09_JPRB, &
  & 0.50264126E-09_JPRB, 0.50079163E-09_JPRB, 0.49909388E-09_JPRB, 0.49753296E-09_JPRB, 0.49612436E-09_JPRB, 0.49489057E-09_JPRB, &
  & 0.49381571E-09_JPRB, 0.49283261E-09_JPRB, 0.49179172E-09_JPRB, 0.49007054E-09_JPRB /)

RGHG6(:,42, 8) = (/ &
  & 0.46849408E-09_JPRB, 0.46945858E-09_JPRB, 0.47019560E-09_JPRB, 0.47111598E-09_JPRB, 0.47235993E-09_JPRB, 0.47388871E-09_JPRB, &
  & 0.47556770E-09_JPRB, 0.47742338E-09_JPRB, 0.47945536E-09_JPRB, 0.48174698E-09_JPRB, 0.48432314E-09_JPRB, 0.48716831E-09_JPRB, &
  & 0.49024435E-09_JPRB, 0.49352428E-09_JPRB, 0.49700233E-09_JPRB, 0.50068572E-09_JPRB, 0.50459520E-09_JPRB, 0.50871285E-09_JPRB, &
  & 0.51298715E-09_JPRB, 0.51719001E-09_JPRB, 0.52104449E-09_JPRB, 0.52422000E-09_JPRB, 0.52662474E-09_JPRB, 0.52834892E-09_JPRB, &
  & 0.52958055E-09_JPRB, 0.53050025E-09_JPRB, 0.53123245E-09_JPRB, 0.53185167E-09_JPRB, 0.53239618E-09_JPRB, 0.53288235E-09_JPRB, &
  & 0.53330440E-09_JPRB, 0.53364335E-09_JPRB, 0.53387261E-09_JPRB, 0.53398447E-09_JPRB, 0.53398930E-09_JPRB, 0.53390115E-09_JPRB, &
  & 0.53372906E-09_JPRB, 0.53347704E-09_JPRB, 0.53314531E-09_JPRB, 0.53272448E-09_JPRB, 0.53221449E-09_JPRB, 0.53160476E-09_JPRB, &
  & 0.53087112E-09_JPRB, 0.53001203E-09_JPRB, 0.52894106E-09_JPRB, 0.52757987E-09_JPRB, 0.52583771E-09_JPRB, 0.52368099E-09_JPRB, &
  & 0.52117310E-09_JPRB, 0.51845250E-09_JPRB, 0.51571514E-09_JPRB, 0.51310761E-09_JPRB, 0.51073279E-09_JPRB, 0.50862520E-09_JPRB, &
  & 0.50676802E-09_JPRB, 0.50510435E-09_JPRB, 0.50358517E-09_JPRB, 0.50218574E-09_JPRB, 0.50092613E-09_JPRB, 0.49982413E-09_JPRB, &
  & 0.49886362E-09_JPRB, 0.49797899E-09_JPRB, 0.49703575E-09_JPRB, 0.49546994E-09_JPRB /)

RGHG6(:,43, 8) = (/ &
  & 0.47486742E-09_JPRB, 0.47603849E-09_JPRB, 0.47682874E-09_JPRB, 0.47779730E-09_JPRB, 0.47910631E-09_JPRB, 0.48065341E-09_JPRB, &
  & 0.48232418E-09_JPRB, 0.48402987E-09_JPRB, 0.48584925E-09_JPRB, 0.48784787E-09_JPRB, 0.49007531E-09_JPRB, 0.49253002E-09_JPRB, &
  & 0.49518595E-09_JPRB, 0.49801890E-09_JPRB, 0.50102456E-09_JPRB, 0.50422666E-09_JPRB, 0.50764432E-09_JPRB, 0.51131094E-09_JPRB, &
  & 0.51515059E-09_JPRB, 0.51900972E-09_JPRB, 0.52253096E-09_JPRB, 0.52543470E-09_JPRB, 0.52760585E-09_JPRB, 0.52915472E-09_JPRB, &
  & 0.53026089E-09_JPRB, 0.53108479E-09_JPRB, 0.53173943E-09_JPRB, 0.53228971E-09_JPRB, 0.53277194E-09_JPRB, 0.53320121E-09_JPRB, &
  & 0.53357596E-09_JPRB, 0.53387561E-09_JPRB, 0.53407823E-09_JPRB, 0.53417348E-09_JPRB, 0.53417304E-09_JPRB, 0.53409033E-09_JPRB, &
  & 0.53393417E-09_JPRB, 0.53370869E-09_JPRB, 0.53341698E-09_JPRB, 0.53305366E-09_JPRB, 0.53262345E-09_JPRB, 0.53212451E-09_JPRB, &
  & 0.53154270E-09_JPRB, 0.53087668E-09_JPRB, 0.53006149E-09_JPRB, 0.52901145E-09_JPRB, 0.52763216E-09_JPRB, 0.52582394E-09_JPRB, &
  & 0.52362603E-09_JPRB, 0.52115445E-09_JPRB, 0.51862786E-09_JPRB, 0.51620841E-09_JPRB, 0.51402116E-09_JPRB, 0.51211219E-09_JPRB, &
  & 0.51045085E-09_JPRB, 0.50898219E-09_JPRB, 0.50764232E-09_JPRB, 0.50640681E-09_JPRB, 0.50528981E-09_JPRB, 0.50431104E-09_JPRB, &
  & 0.50345378E-09_JPRB, 0.50265714E-09_JPRB, 0.50179977E-09_JPRB, 0.50037074E-09_JPRB /)

RGHG6(:,44, 8) = (/ &
  & 0.48090087E-09_JPRB, 0.48244597E-09_JPRB, 0.48331417E-09_JPRB, 0.48431159E-09_JPRB, 0.48562693E-09_JPRB, 0.48720006E-09_JPRB, &
  & 0.48878385E-09_JPRB, 0.49035354E-09_JPRB, 0.49195997E-09_JPRB, 0.49368476E-09_JPRB, 0.49558585E-09_JPRB, 0.49767884E-09_JPRB, &
  & 0.49994098E-09_JPRB, 0.50235238E-09_JPRB, 0.50492027E-09_JPRB, 0.50765092E-09_JPRB, 0.51060278E-09_JPRB, 0.51378085E-09_JPRB, &
  & 0.51720200E-09_JPRB, 0.52065402E-09_JPRB, 0.52385646E-09_JPRB, 0.52647237E-09_JPRB, 0.52842491E-09_JPRB, 0.52981602E-09_JPRB, &
  & 0.53080956E-09_JPRB, 0.53155158E-09_JPRB, 0.53214028E-09_JPRB, 0.53263416E-09_JPRB, 0.53306681E-09_JPRB, 0.53345345E-09_JPRB, &
  & 0.53379179E-09_JPRB, 0.53406418E-09_JPRB, 0.53424720E-09_JPRB, 0.53433208E-09_JPRB, 0.53432930E-09_JPRB, 0.53425248E-09_JPRB, &
  & 0.53410953E-09_JPRB, 0.53390503E-09_JPRB, 0.53364213E-09_JPRB, 0.53332155E-09_JPRB, 0.53294769E-09_JPRB, 0.53253024E-09_JPRB, &
  & 0.53205734E-09_JPRB, 0.53153476E-09_JPRB, 0.53091276E-09_JPRB, 0.53011517E-09_JPRB, 0.52904531E-09_JPRB, 0.52758042E-09_JPRB, &
  & 0.52570065E-09_JPRB, 0.52349058E-09_JPRB, 0.52117416E-09_JPRB, 0.51894350E-09_JPRB, 0.51694898E-09_JPRB, 0.51523630E-09_JPRB, &
  & 0.51378002E-09_JPRB, 0.51250687E-09_JPRB, 0.51135035E-09_JPRB, 0.51027493E-09_JPRB, 0.50929316E-09_JPRB, 0.50842563E-09_JPRB, &
  & 0.50765969E-09_JPRB, 0.50694138E-09_JPRB, 0.50615906E-09_JPRB, 0.50485022E-09_JPRB /)

RGHG6(:,45, 8) = (/ &
  & 0.48857818E-09_JPRB, 0.48939158E-09_JPRB, 0.49002680E-09_JPRB, 0.49087823E-09_JPRB, 0.49214999E-09_JPRB, 0.49364168E-09_JPRB, &
  & 0.49512011E-09_JPRB, 0.49653337E-09_JPRB, 0.49792143E-09_JPRB, 0.49938853E-09_JPRB, 0.50098486E-09_JPRB, 0.50273252E-09_JPRB, &
  & 0.50462079E-09_JPRB, 0.50663884E-09_JPRB, 0.50877563E-09_JPRB, 0.51107374E-09_JPRB, 0.51354060E-09_JPRB, 0.51626725E-09_JPRB, &
  & 0.51919052E-09_JPRB, 0.52224364E-09_JPRB, 0.52505583E-09_JPRB, 0.52738303E-09_JPRB, 0.52911986E-09_JPRB, 0.53036309E-09_JPRB, &
  & 0.53125837E-09_JPRB, 0.53192872E-09_JPRB, 0.53246169E-09_JPRB, 0.53290999E-09_JPRB, 0.53330340E-09_JPRB, 0.53365712E-09_JPRB, &
  & 0.53396865E-09_JPRB, 0.53422045E-09_JPRB, 0.53439042E-09_JPRB, 0.53446908E-09_JPRB, 0.53446636E-09_JPRB, 0.53439553E-09_JPRB, &
  & 0.53426374E-09_JPRB, 0.53407567E-09_JPRB, 0.53383581E-09_JPRB, 0.53354576E-09_JPRB, 0.53321614E-09_JPRB, 0.53285593E-09_JPRB, &
  & 0.53246757E-09_JPRB, 0.53204779E-09_JPRB, 0.53157267E-09_JPRB, 0.53097066E-09_JPRB, 0.53016147E-09_JPRB, 0.52901628E-09_JPRB, &
  & 0.52745475E-09_JPRB, 0.52553173E-09_JPRB, 0.52343546E-09_JPRB, 0.52140264E-09_JPRB, 0.51960314E-09_JPRB, 0.51809723E-09_JPRB, &
  & 0.51684945E-09_JPRB, 0.51577320E-09_JPRB, 0.51479560E-09_JPRB, 0.51387405E-09_JPRB, 0.51301585E-09_JPRB, 0.51224697E-09_JPRB, &
  & 0.51156035E-09_JPRB, 0.51091020E-09_JPRB, 0.51019711E-09_JPRB, 0.50899662E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART15',1,ZHOOK_HANDLE)
END SUBROUTINE PART15




SUBROUTINE PART16
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART16',0,ZHOOK_HANDLE)



RGHG6(:,46, 8) = (/ &
  & 0.49375065E-09_JPRB, 0.49541021E-09_JPRB, 0.49637100E-09_JPRB, 0.49741106E-09_JPRB, 0.49869897E-09_JPRB, 0.50014226E-09_JPRB, &
  & 0.50150206E-09_JPRB, 0.50271587E-09_JPRB, 0.50389370E-09_JPRB, 0.50509164E-09_JPRB, 0.50638643E-09_JPRB, 0.50779775E-09_JPRB, &
  & 0.50932336E-09_JPRB, 0.51094562E-09_JPRB, 0.51268406E-09_JPRB, 0.51453075E-09_JPRB, 0.51656435E-09_JPRB, 0.51877536E-09_JPRB, &
  & 0.52124571E-09_JPRB, 0.52377430E-09_JPRB, 0.52618870E-09_JPRB, 0.52818649E-09_JPRB, 0.52970961E-09_JPRB, 0.53081817E-09_JPRB, &
  & 0.53162408E-09_JPRB, 0.53223326E-09_JPRB, 0.53272031E-09_JPRB, 0.53313126E-09_JPRB, 0.53349491E-09_JPRB, 0.53382349E-09_JPRB, &
  & 0.53411492E-09_JPRB, 0.53435223E-09_JPRB, 0.53451299E-09_JPRB, 0.53458848E-09_JPRB, 0.53458787E-09_JPRB, 0.53452309E-09_JPRB, &
  & 0.53440147E-09_JPRB, 0.53422700E-09_JPRB, 0.53400362E-09_JPRB, 0.53373977E-09_JPRB, 0.53344068E-09_JPRB, 0.53312732E-09_JPRB, &
  & 0.53279725E-09_JPRB, 0.53245763E-09_JPRB, 0.53208643E-09_JPRB, 0.53163468E-09_JPRB, 0.53103294E-09_JPRB, 0.53016563E-09_JPRB, &
  & 0.52893823E-09_JPRB, 0.52732346E-09_JPRB, 0.52548743E-09_JPRB, 0.52367044E-09_JPRB, 0.52207966E-09_JPRB, 0.52079024E-09_JPRB, &
  & 0.51974380E-09_JPRB, 0.51885907E-09_JPRB, 0.51804711E-09_JPRB, 0.51726645E-09_JPRB, 0.51652105E-09_JPRB, 0.51583660E-09_JPRB, &
  & 0.51521948E-09_JPRB, 0.51463067E-09_JPRB, 0.51398086E-09_JPRB, 0.51288640E-09_JPRB /)

RGHG6(:,47, 8) = (/ &
  & 0.50065591E-09_JPRB, 0.50204085E-09_JPRB, 0.50300863E-09_JPRB, 0.50409360E-09_JPRB, 0.50544735E-09_JPRB, 0.50685317E-09_JPRB, &
  & 0.50804305E-09_JPRB, 0.50907267E-09_JPRB, 0.50999005E-09_JPRB, 0.51091137E-09_JPRB, 0.51188576E-09_JPRB, 0.51294941E-09_JPRB, &
  & 0.51410032E-09_JPRB, 0.51533999E-09_JPRB, 0.51665755E-09_JPRB, 0.51809668E-09_JPRB, 0.51965132E-09_JPRB, 0.52140486E-09_JPRB, &
  & 0.52329563E-09_JPRB, 0.52531940E-09_JPRB, 0.52723309E-09_JPRB, 0.52890098E-09_JPRB, 0.53021060E-09_JPRB, 0.53119131E-09_JPRB, &
  & 0.53192073E-09_JPRB, 0.53247801E-09_JPRB, 0.53292681E-09_JPRB, 0.53330940E-09_JPRB, 0.53364962E-09_JPRB, 0.53395988E-09_JPRB, &
  & 0.53423710E-09_JPRB, 0.53446358E-09_JPRB, 0.53461890E-09_JPRB, 0.53469362E-09_JPRB, 0.53469629E-09_JPRB, 0.53463795E-09_JPRB, &
  & 0.53452487E-09_JPRB, 0.53436122E-09_JPRB, 0.53415311E-09_JPRB, 0.53390653E-09_JPRB, 0.53363580E-09_JPRB, 0.53335258E-09_JPRB, &
  & 0.53307048E-09_JPRB, 0.53278504E-09_JPRB, 0.53249105E-09_JPRB, 0.53214805E-09_JPRB, 0.53170252E-09_JPRB, 0.53107396E-09_JPRB, &
  & 0.53015187E-09_JPRB, 0.52890214E-09_JPRB, 0.52737392E-09_JPRB, 0.52582749E-09_JPRB, 0.52446919E-09_JPRB, 0.52338606E-09_JPRB, &
  & 0.52253873E-09_JPRB, 0.52181898E-09_JPRB, 0.52115651E-09_JPRB, 0.52049998E-09_JPRB, 0.51984950E-09_JPRB, 0.51923987E-09_JPRB, &
  & 0.51868132E-09_JPRB, 0.51814697E-09_JPRB, 0.51755639E-09_JPRB, 0.51656140E-09_JPRB /)

RGHG6(:,48, 8) = (/ &
  & 0.50620574E-09_JPRB, 0.50802801E-09_JPRB, 0.50926086E-09_JPRB, 0.51057769E-09_JPRB, 0.51210008E-09_JPRB, 0.51353111E-09_JPRB, &
  & 0.51466353E-09_JPRB, 0.51549565E-09_JPRB, 0.51618732E-09_JPRB, 0.51682647E-09_JPRB, 0.51747900E-09_JPRB, 0.51818705E-09_JPRB, &
  & 0.51896309E-09_JPRB, 0.51980636E-09_JPRB, 0.52072791E-09_JPRB, 0.52172316E-09_JPRB, 0.52282872E-09_JPRB, 0.52403215E-09_JPRB, &
  & 0.52536764E-09_JPRB, 0.52677296E-09_JPRB, 0.52820887E-09_JPRB, 0.52952509E-09_JPRB, 0.53063148E-09_JPRB, 0.53149812E-09_JPRB, &
  & 0.53215948E-09_JPRB, 0.53267341E-09_JPRB, 0.53309229E-09_JPRB, 0.53345200E-09_JPRB, 0.53377547E-09_JPRB, 0.53407245E-09_JPRB, &
  & 0.53433907E-09_JPRB, 0.53455873E-09_JPRB, 0.53471061E-09_JPRB, 0.53478649E-09_JPRB, 0.53479332E-09_JPRB, 0.53474120E-09_JPRB, &
  & 0.53463595E-09_JPRB, 0.53448235E-09_JPRB, 0.53428501E-09_JPRB, 0.53405608E-09_JPRB, 0.53380311E-09_JPRB, 0.53354726E-09_JPRB, &
  & 0.53329441E-09_JPRB, 0.53305332E-09_JPRB, 0.53281107E-09_JPRB, 0.53254678E-09_JPRB, 0.53221827E-09_JPRB, 0.53176941E-09_JPRB, &
  & 0.53113036E-09_JPRB, 0.53023264E-09_JPRB, 0.52911614E-09_JPRB, 0.52790278E-09_JPRB, 0.52682059E-09_JPRB, 0.52596338E-09_JPRB, &
  & 0.52528570E-09_JPRB, 0.52471222E-09_JPRB, 0.52416971E-09_JPRB, 0.52361487E-09_JPRB, 0.52304355E-09_JPRB, 0.52249050E-09_JPRB, &
  & 0.52198001E-09_JPRB, 0.52148902E-09_JPRB, 0.52094784E-09_JPRB, 0.52003563E-09_JPRB /)

RGHG6(:,49, 8) = (/ &
  & 0.51147192E-09_JPRB, 0.51349724E-09_JPRB, 0.51485338E-09_JPRB, 0.51629551E-09_JPRB, 0.51794141E-09_JPRB, 0.51947630E-09_JPRB, &
  & 0.52056681E-09_JPRB, 0.52131610E-09_JPRB, 0.52186616E-09_JPRB, 0.52230686E-09_JPRB, 0.52272348E-09_JPRB, 0.52314514E-09_JPRB, &
  & 0.52360027E-09_JPRB, 0.52409305E-09_JPRB, 0.52462851E-09_JPRB, 0.52521110E-09_JPRB, 0.52583204E-09_JPRB, 0.52650551E-09_JPRB, &
  & 0.52724969E-09_JPRB, 0.52810450E-09_JPRB, 0.52906696E-09_JPRB, 0.53006649E-09_JPRB, 0.53098348E-09_JPRB, 0.53174737E-09_JPRB, &
  & 0.53235188E-09_JPRB, 0.53283067E-09_JPRB, 0.53322524E-09_JPRB, 0.53356797E-09_JPRB, 0.53387872E-09_JPRB, 0.53416616E-09_JPRB, &
  & 0.53442573E-09_JPRB, 0.53464017E-09_JPRB, 0.53479060E-09_JPRB, 0.53486854E-09_JPRB, 0.53488042E-09_JPRB, 0.53483457E-09_JPRB, &
  & 0.53473670E-09_JPRB, 0.53459148E-09_JPRB, 0.53440546E-09_JPRB, 0.53418886E-09_JPRB, 0.53395344E-09_JPRB, 0.53371424E-09_JPRB, &
  & 0.53348703E-09_JPRB, 0.53327237E-09_JPRB, 0.53307075E-09_JPRB, 0.53285931E-09_JPRB, 0.53261384E-09_JPRB, 0.53229859E-09_JPRB, &
  & 0.53187121E-09_JPRB, 0.53130211E-09_JPRB, 0.53058086E-09_JPRB, 0.52979804E-09_JPRB, 0.52905669E-09_JPRB, 0.52844629E-09_JPRB, &
  & 0.52794391E-09_JPRB, 0.52750493E-09_JPRB, 0.52706711E-09_JPRB, 0.52659782E-09_JPRB, 0.52609322E-09_JPRB, 0.52558674E-09_JPRB, &
  & 0.52511084E-09_JPRB, 0.52465454E-09_JPRB, 0.52414884E-09_JPRB, 0.52329946E-09_JPRB /)

RGHG6(:,50, 8) = (/ &
  & 0.51659721E-09_JPRB, 0.51832144E-09_JPRB, 0.51950355E-09_JPRB, 0.52083804E-09_JPRB, 0.52239824E-09_JPRB, 0.52385563E-09_JPRB, &
  & 0.52486637E-09_JPRB, 0.52553928E-09_JPRB, 0.52598270E-09_JPRB, 0.52633797E-09_JPRB, 0.52662863E-09_JPRB, 0.52690552E-09_JPRB, &
  & 0.52717158E-09_JPRB, 0.52743571E-09_JPRB, 0.52769578E-09_JPRB, 0.52794968E-09_JPRB, 0.52820276E-09_JPRB, 0.52846838E-09_JPRB, &
  & 0.52878413E-09_JPRB, 0.52921612E-09_JPRB, 0.52980348E-09_JPRB, 0.53052596E-09_JPRB, 0.53127608E-09_JPRB, 0.53195115E-09_JPRB, &
  & 0.53250815E-09_JPRB, 0.53295879E-09_JPRB, 0.53333477E-09_JPRB, 0.53366400E-09_JPRB, 0.53396532E-09_JPRB, 0.53424576E-09_JPRB, &
  & 0.53449983E-09_JPRB, 0.53471089E-09_JPRB, 0.53486071E-09_JPRB, 0.53494176E-09_JPRB, 0.53495885E-09_JPRB, 0.53491905E-09_JPRB, &
  & 0.53482829E-09_JPRB, 0.53469146E-09_JPRB, 0.53451554E-09_JPRB, 0.53431048E-09_JPRB, 0.53408861E-09_JPRB, 0.53386406E-09_JPRB, &
  & 0.53365040E-09_JPRB, 0.53346011E-09_JPRB, 0.53328286E-09_JPRB, 0.53310989E-09_JPRB, 0.53292021E-09_JPRB, 0.53269578E-09_JPRB, &
  & 0.53241739E-09_JPRB, 0.53207522E-09_JPRB, 0.53167859E-09_JPRB, 0.53124999E-09_JPRB, 0.53084909E-09_JPRB, 0.53049776E-09_JPRB, &
  & 0.53019622E-09_JPRB, 0.52990423E-09_JPRB, 0.52960247E-09_JPRB, 0.52925159E-09_JPRB, 0.52884197E-09_JPRB, 0.52840937E-09_JPRB, &
  & 0.52798887E-09_JPRB, 0.52757176E-09_JPRB, 0.52710691E-09_JPRB, 0.52630150E-09_JPRB /)

RGHG6(:,51, 8) = (/ &
  & 0.52046023E-09_JPRB, 0.52198806E-09_JPRB, 0.52302840E-09_JPRB, 0.52413052E-09_JPRB, 0.52548565E-09_JPRB, 0.52670651E-09_JPRB, &
  & 0.52756566E-09_JPRB, 0.52807680E-09_JPRB, 0.52844551E-09_JPRB, 0.52870097E-09_JPRB, 0.52892846E-09_JPRB, 0.52912441E-09_JPRB, &
  & 0.52930249E-09_JPRB, 0.52945187E-09_JPRB, 0.52957166E-09_JPRB, 0.52966403E-09_JPRB, 0.52973448E-09_JPRB, 0.52980248E-09_JPRB, &
  & 0.52990234E-09_JPRB, 0.53008464E-09_JPRB, 0.53041893E-09_JPRB, 0.53091698E-09_JPRB, 0.53152105E-09_JPRB, 0.53211907E-09_JPRB, &
  & 0.53263771E-09_JPRB, 0.53306626E-09_JPRB, 0.53342758E-09_JPRB, 0.53374627E-09_JPRB, 0.53403948E-09_JPRB, 0.53431409E-09_JPRB, &
  & 0.53456384E-09_JPRB, 0.53477256E-09_JPRB, 0.53492272E-09_JPRB, 0.53500748E-09_JPRB, 0.53502991E-09_JPRB, 0.53499621E-09_JPRB, &
  & 0.53491217E-09_JPRB, 0.53478399E-09_JPRB, 0.53461724E-09_JPRB, 0.53442456E-09_JPRB, 0.53421245E-09_JPRB, 0.53399846E-09_JPRB, &
  & 0.53379906E-09_JPRB, 0.53361959E-09_JPRB, 0.53346377E-09_JPRB, 0.53331478E-09_JPRB, 0.53316318E-09_JPRB, 0.53299731E-09_JPRB, &
  & 0.53281368E-09_JPRB, 0.53261262E-09_JPRB, 0.53240212E-09_JPRB, 0.53219479E-09_JPRB, 0.53200760E-09_JPRB, 0.53184623E-09_JPRB, &
  & 0.53170102E-09_JPRB, 0.53156202E-09_JPRB, 0.53140259E-09_JPRB, 0.53120608E-09_JPRB, 0.53095872E-09_JPRB, 0.53066551E-09_JPRB, &
  & 0.53035465E-09_JPRB, 0.53003246E-09_JPRB, 0.52963828E-09_JPRB, 0.52892457E-09_JPRB /)

RGHG6(:,52, 8) = (/ &
  & 0.52395199E-09_JPRB, 0.52497673E-09_JPRB, 0.52567856E-09_JPRB, 0.52654253E-09_JPRB, 0.52757143E-09_JPRB, 0.52856497E-09_JPRB, &
  & 0.52919297E-09_JPRB, 0.52960403E-09_JPRB, 0.52984983E-09_JPRB, 0.53005261E-09_JPRB, 0.53021021E-09_JPRB, 0.53035759E-09_JPRB, &
  & 0.53048188E-09_JPRB, 0.53057714E-09_JPRB, 0.53063753E-09_JPRB, 0.53066540E-09_JPRB, 0.53067062E-09_JPRB, 0.53066723E-09_JPRB, &
  & 0.53067922E-09_JPRB, 0.53074617E-09_JPRB, 0.53091997E-09_JPRB, 0.53125626E-09_JPRB, 0.53173338E-09_JPRB, 0.53226212E-09_JPRB, &
  & 0.53274807E-09_JPRB, 0.53315952E-09_JPRB, 0.53350913E-09_JPRB, 0.53381843E-09_JPRB, 0.53410482E-09_JPRB, 0.53437360E-09_JPRB, &
  & 0.53461968E-09_JPRB, 0.53482652E-09_JPRB, 0.53497806E-09_JPRB, 0.53506694E-09_JPRB, 0.53509441E-09_JPRB, 0.53506688E-09_JPRB, &
  & 0.53499000E-09_JPRB, 0.53486943E-09_JPRB, 0.53471361E-09_JPRB, 0.53452942E-09_JPRB, 0.53432875E-09_JPRB, 0.53412397E-09_JPRB, &
  & 0.53393051E-09_JPRB, 0.53376509E-09_JPRB, 0.53361932E-09_JPRB, 0.53348859E-09_JPRB, 0.53336136E-09_JPRB, 0.53323462E-09_JPRB, &
  & 0.53310756E-09_JPRB, 0.53298599E-09_JPRB, 0.53287225E-09_JPRB, 0.53277266E-09_JPRB, 0.53268878E-09_JPRB, 0.53262172E-09_JPRB, &
  & 0.53256372E-09_JPRB, 0.53250621E-09_JPRB, 0.53244209E-09_JPRB, 0.53235849E-09_JPRB, 0.53224236E-09_JPRB, 0.53209537E-09_JPRB, &
  & 0.53192528E-09_JPRB, 0.53172700E-09_JPRB, 0.53146976E-09_JPRB, 0.53092702E-09_JPRB /)

RGHG6(:,53, 8) = (/ &
  & 0.52621540E-09_JPRB, 0.52704757E-09_JPRB, 0.52762966E-09_JPRB, 0.52825189E-09_JPRB, 0.52905252E-09_JPRB, 0.52976951E-09_JPRB, &
  & 0.53026666E-09_JPRB, 0.53054044E-09_JPRB, 0.53073718E-09_JPRB, 0.53086924E-09_JPRB, 0.53099153E-09_JPRB, 0.53109656E-09_JPRB, &
  & 0.53118887E-09_JPRB, 0.53125526E-09_JPRB, 0.53129012E-09_JPRB, 0.53129562E-09_JPRB, 0.53127958E-09_JPRB, 0.53125365E-09_JPRB, &
  & 0.53123383E-09_JPRB, 0.53124594E-09_JPRB, 0.53133514E-09_JPRB, 0.53155297E-09_JPRB, 0.53192550E-09_JPRB, 0.53239091E-09_JPRB, &
  & 0.53284704E-09_JPRB, 0.53324317E-09_JPRB, 0.53358218E-09_JPRB, 0.53388377E-09_JPRB, 0.53416271E-09_JPRB, 0.53442639E-09_JPRB, &
  & 0.53466875E-09_JPRB, 0.53487431E-09_JPRB, 0.53502786E-09_JPRB, 0.53512078E-09_JPRB, 0.53515381E-09_JPRB, 0.53513255E-09_JPRB, &
  & 0.53506211E-09_JPRB, 0.53495008E-09_JPRB, 0.53480248E-09_JPRB, 0.53462945E-09_JPRB, 0.53443694E-09_JPRB, 0.53423960E-09_JPRB, &
  & 0.53405658E-09_JPRB, 0.53389493E-09_JPRB, 0.53376026E-09_JPRB, 0.53364030E-09_JPRB, 0.53353078E-09_JPRB, 0.53342797E-09_JPRB, &
  & 0.53333638E-09_JPRB, 0.53325677E-09_JPRB, 0.53319166E-09_JPRB, 0.53313975E-09_JPRB, 0.53310228E-09_JPRB, 0.53307336E-09_JPRB, &
  & 0.53305044E-09_JPRB, 0.53302851E-09_JPRB, 0.53300331E-09_JPRB, 0.53296911E-09_JPRB, 0.53292082E-09_JPRB, 0.53285409E-09_JPRB, &
  & 0.53277238E-09_JPRB, 0.53267729E-09_JPRB, 0.53254651E-09_JPRB, 0.53223476E-09_JPRB /)

RGHG6(:,54, 8) = (/ &
  & 0.52816812E-09_JPRB, 0.52871824E-09_JPRB, 0.52909266E-09_JPRB, 0.52954990E-09_JPRB, 0.53010474E-09_JPRB, 0.53064220E-09_JPRB, &
  & 0.53098181E-09_JPRB, 0.53119953E-09_JPRB, 0.53132598E-09_JPRB, 0.53143118E-09_JPRB, 0.53151405E-09_JPRB, 0.53159466E-09_JPRB, &
  & 0.53166410E-09_JPRB, 0.53171401E-09_JPRB, 0.53173776E-09_JPRB, 0.53173577E-09_JPRB, 0.53171456E-09_JPRB, 0.53168225E-09_JPRB, &
  & 0.53165128E-09_JPRB, 0.53163873E-09_JPRB, 0.53167687E-09_JPRB, 0.53181948E-09_JPRB, 0.53210858E-09_JPRB, 0.53251353E-09_JPRB, &
  & 0.53294058E-09_JPRB, 0.53332072E-09_JPRB, 0.53365012E-09_JPRB, 0.53394272E-09_JPRB, 0.53421539E-09_JPRB, 0.53447335E-09_JPRB, &
  & 0.53471239E-09_JPRB, 0.53491761E-09_JPRB, 0.53507310E-09_JPRB, 0.53517035E-09_JPRB, 0.53520899E-09_JPRB, 0.53519372E-09_JPRB, &
  & 0.53513000E-09_JPRB, 0.53502536E-09_JPRB, 0.53488708E-09_JPRB, 0.53472171E-09_JPRB, 0.53453841E-09_JPRB, 0.53435006E-09_JPRB, &
  & 0.53417154E-09_JPRB, 0.53401938E-09_JPRB, 0.53388960E-09_JPRB, 0.53377852E-09_JPRB, 0.53367977E-09_JPRB, 0.53359422E-09_JPRB, &
  & 0.53352217E-09_JPRB, 0.53346616E-09_JPRB, 0.53342364E-09_JPRB, 0.53339433E-09_JPRB, 0.53337390E-09_JPRB, 0.53336091E-09_JPRB, &
  & 0.53335059E-09_JPRB, 0.53334126E-09_JPRB, 0.53333032E-09_JPRB, 0.53331545E-09_JPRB, 0.53329330E-09_JPRB, 0.53326299E-09_JPRB, &
  & 0.53322713E-09_JPRB, 0.53318910E-09_JPRB, 0.53315102E-09_JPRB, 0.53310928E-09_JPRB /)

RGHG6(:,55, 8) = (/ &
  & 0.52947019E-09_JPRB, 0.52989707E-09_JPRB, 0.53018817E-09_JPRB, 0.53050930E-09_JPRB, 0.53089599E-09_JPRB, 0.53126614E-09_JPRB, &
  & 0.53152749E-09_JPRB, 0.53167137E-09_JPRB, 0.53177313E-09_JPRB, 0.53184201E-09_JPRB, 0.53190713E-09_JPRB, 0.53196553E-09_JPRB, &
  & 0.53201965E-09_JPRB, 0.53205967E-09_JPRB, 0.53207844E-09_JPRB, 0.53207527E-09_JPRB, 0.53205396E-09_JPRB, 0.53202148E-09_JPRB, &
  & 0.53198468E-09_JPRB, 0.53195903E-09_JPRB, 0.53196847E-09_JPRB, 0.53206017E-09_JPRB, 0.53228449E-09_JPRB, 0.53263910E-09_JPRB, &
  & 0.53303251E-09_JPRB, 0.53339638E-09_JPRB, 0.53371346E-09_JPRB, 0.53399868E-09_JPRB, 0.53426380E-09_JPRB, 0.53451688E-09_JPRB, &
  & 0.53475285E-09_JPRB, 0.53495752E-09_JPRB, 0.53511517E-09_JPRB, 0.53521693E-09_JPRB, 0.53526100E-09_JPRB, 0.53525162E-09_JPRB, &
  & 0.53519433E-09_JPRB, 0.53509697E-09_JPRB, 0.53496618E-09_JPRB, 0.53480936E-09_JPRB, 0.53463356E-09_JPRB, 0.53445254E-09_JPRB, &
  & 0.53428362E-09_JPRB, 0.53413585E-09_JPRB, 0.53401294E-09_JPRB, 0.53390753E-09_JPRB, 0.53381760E-09_JPRB, 0.53374138E-09_JPRB, &
  & 0.53368177E-09_JPRB, 0.53363691E-09_JPRB, 0.53360583E-09_JPRB, 0.53358484E-09_JPRB, 0.53357258E-09_JPRB, 0.53356419E-09_JPRB, &
  & 0.53355853E-09_JPRB, 0.53355304E-09_JPRB, 0.53354687E-09_JPRB, 0.53353827E-09_JPRB, 0.53352545E-09_JPRB, 0.53350785E-09_JPRB, &
  & 0.53348648E-09_JPRB, 0.53346322E-09_JPRB, 0.53343707E-09_JPRB, 0.53339261E-09_JPRB /)

RGHG6(:,56, 8) = (/ &
  & 0.53055998E-09_JPRB, 0.53082982E-09_JPRB, 0.53102256E-09_JPRB, 0.53123517E-09_JPRB, 0.53150145E-09_JPRB, 0.53175686E-09_JPRB, &
  & 0.53193561E-09_JPRB, 0.53205079E-09_JPRB, 0.53211835E-09_JPRB, 0.53217419E-09_JPRB, 0.53221977E-09_JPRB, 0.53226601E-09_JPRB, &
  & 0.53230864E-09_JPRB, 0.53234217E-09_JPRB, 0.53235938E-09_JPRB, 0.53235771E-09_JPRB, 0.53233867E-09_JPRB, 0.53230653E-09_JPRB, &
  & 0.53226756E-09_JPRB, 0.53223220E-09_JPRB, 0.53222238E-09_JPRB, 0.53227972E-09_JPRB, 0.53246008E-09_JPRB, 0.53276616E-09_JPRB, &
  & 0.53312865E-09_JPRB, 0.53347093E-09_JPRB, 0.53377658E-09_JPRB, 0.53405202E-09_JPRB, 0.53431121E-09_JPRB, 0.53455906E-09_JPRB, &
  & 0.53479210E-09_JPRB, 0.53499621E-09_JPRB, 0.53515586E-09_JPRB, 0.53526145E-09_JPRB, 0.53531068E-09_JPRB, 0.53530702E-09_JPRB, &
  & 0.53525601E-09_JPRB, 0.53516558E-09_JPRB, 0.53504207E-09_JPRB, 0.53489174E-09_JPRB, 0.53472371E-09_JPRB, 0.53455113E-09_JPRB, &
  & 0.53438881E-09_JPRB, 0.53424898E-09_JPRB, 0.53413080E-09_JPRB, 0.53403137E-09_JPRB, 0.53394711E-09_JPRB, 0.53387844E-09_JPRB, &
  & 0.53382471E-09_JPRB, 0.53378540E-09_JPRB, 0.53375815E-09_JPRB, 0.53374116E-09_JPRB, 0.53373012E-09_JPRB, 0.53372368E-09_JPRB, &
  & 0.53371846E-09_JPRB, 0.53371385E-09_JPRB, 0.53370852E-09_JPRB, 0.53370153E-09_JPRB, 0.53369204E-09_JPRB, 0.53367921E-09_JPRB, &
  & 0.53366445E-09_JPRB, 0.53364885E-09_JPRB, 0.53363158E-09_JPRB, 0.53360549E-09_JPRB /)

RGHG6(:,57, 8) = (/ &
  & 0.53128263E-09_JPRB, 0.53150018E-09_JPRB, 0.53164029E-09_JPRB, 0.53179572E-09_JPRB, 0.53196458E-09_JPRB, 0.53214277E-09_JPRB, &
  & 0.53227689E-09_JPRB, 0.53235605E-09_JPRB, 0.53241128E-09_JPRB, 0.53245031E-09_JPRB, 0.53248750E-09_JPRB, 0.53252303E-09_JPRB, &
  & 0.53255839E-09_JPRB, 0.53258803E-09_JPRB, 0.53260507E-09_JPRB, 0.53260607E-09_JPRB, 0.53258997E-09_JPRB, 0.53255905E-09_JPRB, &
  & 0.53251703E-09_JPRB, 0.53247429E-09_JPRB, 0.53245003E-09_JPRB, 0.53248439E-09_JPRB, 0.53262961E-09_JPRB, 0.53289956E-09_JPRB, &
  & 0.53322791E-09_JPRB, 0.53354898E-09_JPRB, 0.53384025E-09_JPRB, 0.53410720E-09_JPRB, 0.53435928E-09_JPRB, 0.53460231E-09_JPRB, &
  & 0.53483185E-09_JPRB, 0.53503502E-09_JPRB, 0.53519589E-09_JPRB, 0.53530508E-09_JPRB, 0.53535876E-09_JPRB, 0.53536053E-09_JPRB, &
  & 0.53531585E-09_JPRB, 0.53523164E-09_JPRB, 0.53511456E-09_JPRB, 0.53497157E-09_JPRB, 0.53481014E-09_JPRB, 0.53464561E-09_JPRB, &
  & 0.53449167E-09_JPRB, 0.53435750E-09_JPRB, 0.53424515E-09_JPRB, 0.53415056E-09_JPRB, 0.53407212E-09_JPRB, 0.53400773E-09_JPRB, &
  & 0.53395777E-09_JPRB, 0.53392069E-09_JPRB, 0.53389460E-09_JPRB, 0.53387689E-09_JPRB, 0.53386623E-09_JPRB, 0.53385835E-09_JPRB, &
  & 0.53385257E-09_JPRB, 0.53384708E-09_JPRB, 0.53384108E-09_JPRB, 0.53383387E-09_JPRB, 0.53382415E-09_JPRB, 0.53381244E-09_JPRB, &
  & 0.53379923E-09_JPRB, 0.53378546E-09_JPRB, 0.53377036E-09_JPRB, 0.53374366E-09_JPRB /)

RGHG6(:,58, 8) = (/ &
  & 0.53187643E-09_JPRB, 0.53202376E-09_JPRB, 0.53212423E-09_JPRB, 0.53222271E-09_JPRB, 0.53234250E-09_JPRB, 0.53246124E-09_JPRB, &
  & 0.53255722E-09_JPRB, 0.53262100E-09_JPRB, 0.53266114E-09_JPRB, 0.53269383E-09_JPRB, 0.53272242E-09_JPRB, 0.53275229E-09_JPRB, &
  & 0.53278293E-09_JPRB, 0.53281035E-09_JPRB, 0.53282895E-09_JPRB, 0.53283322E-09_JPRB, 0.53282045E-09_JPRB, 0.53279026E-09_JPRB, &
  & 0.53274540E-09_JPRB, 0.53269472E-09_JPRB, 0.53265869E-09_JPRB, 0.53267624E-09_JPRB, 0.53279781E-09_JPRB, 0.53303495E-09_JPRB, &
  & 0.53333227E-09_JPRB, 0.53363125E-09_JPRB, 0.53390842E-09_JPRB, 0.53416577E-09_JPRB, 0.53441096E-09_JPRB, 0.53464844E-09_JPRB, &
  & 0.53487409E-09_JPRB, 0.53507532E-09_JPRB, 0.53523708E-09_JPRB, 0.53534810E-09_JPRB, 0.53540583E-09_JPRB, 0.53541260E-09_JPRB, &
  & 0.53537375E-09_JPRB, 0.53529597E-09_JPRB, 0.53518534E-09_JPRB, 0.53504828E-09_JPRB, 0.53489485E-09_JPRB, 0.53473781E-09_JPRB, &
  & 0.53459154E-09_JPRB, 0.53446381E-09_JPRB, 0.53435667E-09_JPRB, 0.53426696E-09_JPRB, 0.53419275E-09_JPRB, 0.53413240E-09_JPRB, &
  & 0.53408516E-09_JPRB, 0.53404847E-09_JPRB, 0.53402166E-09_JPRB, 0.53400268E-09_JPRB, 0.53398896E-09_JPRB, 0.53397964E-09_JPRB, &
  & 0.53397181E-09_JPRB, 0.53396465E-09_JPRB, 0.53395732E-09_JPRB, 0.53394833E-09_JPRB, 0.53393767E-09_JPRB, 0.53392490E-09_JPRB, &
  & 0.53391153E-09_JPRB, 0.53389848E-09_JPRB, 0.53388405E-09_JPRB, 0.53386129E-09_JPRB /)

RGHG6(:,59, 8) = (/ &
  & 0.53230520E-09_JPRB, 0.53242377E-09_JPRB, 0.53249616E-09_JPRB, 0.53256921E-09_JPRB, 0.53264637E-09_JPRB, 0.53273230E-09_JPRB, &
  & 0.53280386E-09_JPRB, 0.53285215E-09_JPRB, 0.53288596E-09_JPRB, 0.53291199E-09_JPRB, 0.53293686E-09_JPRB, 0.53296290E-09_JPRB, &
  & 0.53299087E-09_JPRB, 0.53301830E-09_JPRB, 0.53303895E-09_JPRB, 0.53304694E-09_JPRB, 0.53303767E-09_JPRB, 0.53300764E-09_JPRB, &
  & 0.53295890E-09_JPRB, 0.53290061E-09_JPRB, 0.53285437E-09_JPRB, 0.53285976E-09_JPRB, 0.53296267E-09_JPRB, 0.53317190E-09_JPRB, &
  & 0.53344157E-09_JPRB, 0.53371857E-09_JPRB, 0.53398208E-09_JPRB, 0.53422955E-09_JPRB, 0.53446775E-09_JPRB, 0.53469901E-09_JPRB, &
  & 0.53492005E-09_JPRB, 0.53511867E-09_JPRB, 0.53527927E-09_JPRB, 0.53539195E-09_JPRB, 0.53545213E-09_JPRB, 0.53546334E-09_JPRB, &
  & 0.53543042E-09_JPRB, 0.53535837E-09_JPRB, 0.53525395E-09_JPRB, 0.53512406E-09_JPRB, 0.53497734E-09_JPRB, 0.53482885E-09_JPRB, &
  & 0.53468974E-09_JPRB, 0.53456850E-09_JPRB, 0.53446592E-09_JPRB, 0.53438065E-09_JPRB, 0.53431043E-09_JPRB, 0.53425353E-09_JPRB, &
  & 0.53420796E-09_JPRB, 0.53417265E-09_JPRB, 0.53414456E-09_JPRB, 0.53412286E-09_JPRB, 0.53410654E-09_JPRB, 0.53409377E-09_JPRB, &
  & 0.53408322E-09_JPRB, 0.53407367E-09_JPRB, 0.53406352E-09_JPRB, 0.53405247E-09_JPRB, 0.53403904E-09_JPRB, 0.53402427E-09_JPRB, &
  & 0.53400928E-09_JPRB, 0.53399452E-09_JPRB, 0.53397908E-09_JPRB, 0.53395299E-09_JPRB /)

RGHG6(:,60, 8) = (/ &
  & 0.53266158E-09_JPRB, 0.53274773E-09_JPRB, 0.53280053E-09_JPRB, 0.53285021E-09_JPRB, 0.53290711E-09_JPRB, 0.53296734E-09_JPRB, &
  & 0.53302290E-09_JPRB, 0.53306282E-09_JPRB, 0.53309085E-09_JPRB, 0.53311416E-09_JPRB, 0.53313642E-09_JPRB, 0.53316063E-09_JPRB, &
  & 0.53318827E-09_JPRB, 0.53321636E-09_JPRB, 0.53324034E-09_JPRB, 0.53325222E-09_JPRB, 0.53324567E-09_JPRB, 0.53321547E-09_JPRB, &
  & 0.53316157E-09_JPRB, 0.53309579E-09_JPRB, 0.53304156E-09_JPRB, 0.53303806E-09_JPRB, 0.53312499E-09_JPRB, 0.53331028E-09_JPRB, &
  & 0.53355398E-09_JPRB, 0.53381211E-09_JPRB, 0.53406163E-09_JPRB, 0.53430038E-09_JPRB, 0.53453042E-09_JPRB, 0.53475563E-09_JPRB, &
  & 0.53497085E-09_JPRB, 0.53516547E-09_JPRB, 0.53532451E-09_JPRB, 0.53543647E-09_JPRB, 0.53549831E-09_JPRB, 0.53551286E-09_JPRB, &
  & 0.53548488E-09_JPRB, 0.53541904E-09_JPRB, 0.53532101E-09_JPRB, 0.53519766E-09_JPRB, 0.53505950E-09_JPRB, 0.53491850E-09_JPRB, &
  & 0.53478744E-09_JPRB, 0.53467136E-09_JPRB, 0.53457416E-09_JPRB, 0.53449267E-09_JPRB, 0.53442600E-09_JPRB, 0.53437144E-09_JPRB, &
  & 0.53432819E-09_JPRB, 0.53429339E-09_JPRB, 0.53426563E-09_JPRB, 0.53424176E-09_JPRB, 0.53422222E-09_JPRB, 0.53420524E-09_JPRB, &
  & 0.53419136E-09_JPRB, 0.53417792E-09_JPRB, 0.53416488E-09_JPRB, 0.53414984E-09_JPRB, 0.53413307E-09_JPRB, 0.53411486E-09_JPRB, &
  & 0.53409704E-09_JPRB, 0.53408028E-09_JPRB, 0.53406213E-09_JPRB, 0.53403315E-09_JPRB /)

RGHG6(:,61, 8) = (/ &
  & 0.53294369E-09_JPRB, 0.53301180E-09_JPRB, 0.53305232E-09_JPRB, 0.53309035E-09_JPRB, 0.53313115E-09_JPRB, 0.53317806E-09_JPRB, &
  & 0.53322213E-09_JPRB, 0.53325627E-09_JPRB, 0.53328186E-09_JPRB, 0.53330329E-09_JPRB, 0.53332500E-09_JPRB, 0.53334936E-09_JPRB, &
  & 0.53337779E-09_JPRB, 0.53340898E-09_JPRB, 0.53343618E-09_JPRB, 0.53345217E-09_JPRB, 0.53344762E-09_JPRB, 0.53341498E-09_JPRB, &
  & 0.53335680E-09_JPRB, 0.53328436E-09_JPRB, 0.53322391E-09_JPRB, 0.53321320E-09_JPRB, 0.53328592E-09_JPRB, 0.53344962E-09_JPRB, &
  & 0.53367077E-09_JPRB, 0.53391069E-09_JPRB, 0.53414817E-09_JPRB, 0.53437732E-09_JPRB, 0.53460059E-09_JPRB, 0.53481836E-09_JPRB, &
  & 0.53502769E-09_JPRB, 0.53521698E-09_JPRB, 0.53537219E-09_JPRB, 0.53548260E-09_JPRB, 0.53554433E-09_JPRB, 0.53556126E-09_JPRB, &
  & 0.53553767E-09_JPRB, 0.53547744E-09_JPRB, 0.53538601E-09_JPRB, 0.53527033E-09_JPRB, 0.53513977E-09_JPRB, 0.53500787E-09_JPRB, &
  & 0.53488330E-09_JPRB, 0.53477434E-09_JPRB, 0.53468091E-09_JPRB, 0.53460358E-09_JPRB, 0.53453952E-09_JPRB, 0.53448740E-09_JPRB, &
  & 0.53444554E-09_JPRB, 0.53441213E-09_JPRB, 0.53438443E-09_JPRB, 0.53436072E-09_JPRB, 0.53433791E-09_JPRB, 0.53431826E-09_JPRB, &
  & 0.53429894E-09_JPRB, 0.53428195E-09_JPRB, 0.53426380E-09_JPRB, 0.53424454E-09_JPRB, 0.53422294E-09_JPRB, 0.53420052E-09_JPRB, &
  & 0.53417903E-09_JPRB, 0.53415850E-09_JPRB, 0.53413629E-09_JPRB, 0.53410004E-09_JPRB /)

RGHG6(:,62, 8) = (/ &
  & 0.53318461E-09_JPRB, 0.53323829E-09_JPRB, 0.53326960E-09_JPRB, 0.53329891E-09_JPRB, 0.53333166E-09_JPRB, 0.53336874E-09_JPRB, &
  & 0.53340676E-09_JPRB, 0.53343796E-09_JPRB, 0.53346227E-09_JPRB, 0.53348409E-09_JPRB, 0.53350618E-09_JPRB, 0.53353216E-09_JPRB, &
  & 0.53356386E-09_JPRB, 0.53359833E-09_JPRB, 0.53363025E-09_JPRB, 0.53364857E-09_JPRB, 0.53364385E-09_JPRB, 0.53360932E-09_JPRB, &
  & 0.53354554E-09_JPRB, 0.53346905E-09_JPRB, 0.53340393E-09_JPRB, 0.53338678E-09_JPRB, 0.53344684E-09_JPRB, 0.53359067E-09_JPRB, &
  & 0.53379207E-09_JPRB, 0.53401555E-09_JPRB, 0.53424098E-09_JPRB, 0.53446203E-09_JPRB, 0.53467736E-09_JPRB, 0.53488863E-09_JPRB, &
  & 0.53509058E-09_JPRB, 0.53527371E-09_JPRB, 0.53542382E-09_JPRB, 0.53553029E-09_JPRB, 0.53559074E-09_JPRB, 0.53560867E-09_JPRB, &
  & 0.53558852E-09_JPRB, 0.53553390E-09_JPRB, 0.53544946E-09_JPRB, 0.53534133E-09_JPRB, 0.53521976E-09_JPRB, 0.53509541E-09_JPRB, &
  & 0.53497928E-09_JPRB, 0.53487531E-09_JPRB, 0.53478710E-09_JPRB, 0.53471311E-09_JPRB, 0.53465204E-09_JPRB, 0.53460192E-09_JPRB, &
  & 0.53456145E-09_JPRB, 0.53452870E-09_JPRB, 0.53450189E-09_JPRB, 0.53447785E-09_JPRB, 0.53445570E-09_JPRB, 0.53443150E-09_JPRB, &
  & 0.53440979E-09_JPRB, 0.53438648E-09_JPRB, 0.53436366E-09_JPRB, 0.53433841E-09_JPRB, 0.53431154E-09_JPRB, 0.53428406E-09_JPRB, &
  & 0.53425830E-09_JPRB, 0.53423288E-09_JPRB, 0.53420518E-09_JPRB, 0.53415777E-09_JPRB /)

RGHG6(:,63, 8) = (/ &
  & 0.53338739E-09_JPRB, 0.53343419E-09_JPRB, 0.53346139E-09_JPRB, 0.53348631E-09_JPRB, 0.53351357E-09_JPRB, 0.53354582E-09_JPRB, &
  & 0.53357957E-09_JPRB, 0.53360971E-09_JPRB, 0.53363491E-09_JPRB, 0.53365778E-09_JPRB, 0.53368276E-09_JPRB, 0.53371202E-09_JPRB, &
  & 0.53374788E-09_JPRB, 0.53378790E-09_JPRB, 0.53382232E-09_JPRB, 0.53384230E-09_JPRB, 0.53383620E-09_JPRB, 0.53379762E-09_JPRB, &
  & 0.53373145E-09_JPRB, 0.53365151E-09_JPRB, 0.53358284E-09_JPRB, 0.53355953E-09_JPRB, 0.53360794E-09_JPRB, 0.53373533E-09_JPRB, &
  & 0.53391802E-09_JPRB, 0.53412685E-09_JPRB, 0.53434124E-09_JPRB, 0.53455368E-09_JPRB, 0.53476201E-09_JPRB, 0.53496541E-09_JPRB, &
  & 0.53516003E-09_JPRB, 0.53533500E-09_JPRB, 0.53547811E-09_JPRB, 0.53557930E-09_JPRB, 0.53563698E-09_JPRB, 0.53565491E-09_JPRB, &
  & 0.53563759E-09_JPRB, 0.53558835E-09_JPRB, 0.53551075E-09_JPRB, 0.53541094E-09_JPRB, 0.53529803E-09_JPRB, 0.53518268E-09_JPRB, &
  & 0.53507337E-09_JPRB, 0.53497612E-09_JPRB, 0.53489202E-09_JPRB, 0.53482185E-09_JPRB, 0.53476329E-09_JPRB, 0.53471522E-09_JPRB, &
  & 0.53467597E-09_JPRB, 0.53464416E-09_JPRB, 0.53461796E-09_JPRB, 0.53459459E-09_JPRB, 0.53457172E-09_JPRB, 0.53454807E-09_JPRB, &
  & 0.53452104E-09_JPRB, 0.53449473E-09_JPRB, 0.53446525E-09_JPRB, 0.53443455E-09_JPRB, 0.53440158E-09_JPRB, 0.53436983E-09_JPRB, &
  & 0.53433835E-09_JPRB, 0.53430838E-09_JPRB, 0.53427174E-09_JPRB, 0.53421173E-09_JPRB /)

RGHG6(:,64, 8) = (/ &
  & 0.53356652E-09_JPRB, 0.53361027E-09_JPRB, 0.53363491E-09_JPRB, 0.53365740E-09_JPRB, 0.53368215E-09_JPRB, 0.53371080E-09_JPRB, &
  & 0.53374327E-09_JPRB, 0.53377308E-09_JPRB, 0.53380023E-09_JPRB, 0.53382637E-09_JPRB, 0.53385446E-09_JPRB, 0.53388921E-09_JPRB, &
  & 0.53393096E-09_JPRB, 0.53397486E-09_JPRB, 0.53401206E-09_JPRB, 0.53403060E-09_JPRB, 0.53402172E-09_JPRB, 0.53398114E-09_JPRB, &
  & 0.53391247E-09_JPRB, 0.53383098E-09_JPRB, 0.53375998E-09_JPRB, 0.53373161E-09_JPRB, 0.53377047E-09_JPRB, 0.53388277E-09_JPRB, &
  & 0.53404980E-09_JPRB, 0.53424420E-09_JPRB, 0.53444771E-09_JPRB, 0.53465171E-09_JPRB, 0.53485194E-09_JPRB, 0.53504745E-09_JPRB, &
  & 0.53523308E-09_JPRB, 0.53539911E-09_JPRB, 0.53553323E-09_JPRB, 0.53562776E-09_JPRB, 0.53568161E-09_JPRB, 0.53569904E-09_JPRB, &
  & 0.53568411E-09_JPRB, 0.53563987E-09_JPRB, 0.53556931E-09_JPRB, 0.53547794E-09_JPRB, 0.53537430E-09_JPRB, 0.53526733E-09_JPRB, &
  & 0.53516597E-09_JPRB, 0.53507443E-09_JPRB, 0.53499521E-09_JPRB, 0.53492849E-09_JPRB, 0.53487276E-09_JPRB, 0.53482657E-09_JPRB, &
  & 0.53478860E-09_JPRB, 0.53475802E-09_JPRB, 0.53473226E-09_JPRB, 0.53470955E-09_JPRB, 0.53468707E-09_JPRB, 0.53466209E-09_JPRB, &
  & 0.53463467E-09_JPRB, 0.53460336E-09_JPRB, 0.53456989E-09_JPRB, 0.53453314E-09_JPRB, 0.53449606E-09_JPRB, 0.53445864E-09_JPRB, &
  & 0.53442384E-09_JPRB, 0.53438642E-09_JPRB, 0.53434263E-09_JPRB, 0.53426302E-09_JPRB /)

RGHG6(:,65, 8) = (/ &
  & 0.53372717E-09_JPRB, 0.53377069E-09_JPRB, 0.53379517E-09_JPRB, 0.53381699E-09_JPRB, 0.53384047E-09_JPRB, 0.53386834E-09_JPRB, &
  & 0.53389881E-09_JPRB, 0.53393118E-09_JPRB, 0.53395999E-09_JPRB, 0.53399030E-09_JPRB, 0.53402377E-09_JPRB, 0.53406402E-09_JPRB, &
  & 0.53411137E-09_JPRB, 0.53415888E-09_JPRB, 0.53419513E-09_JPRB, 0.53421212E-09_JPRB, 0.53420102E-09_JPRB, 0.53415861E-09_JPRB, &
  & 0.53408938E-09_JPRB, 0.53400723E-09_JPRB, 0.53393512E-09_JPRB, 0.53390292E-09_JPRB, 0.53393345E-09_JPRB, 0.53403360E-09_JPRB, &
  & 0.53418586E-09_JPRB, 0.53436705E-09_JPRB, 0.53455962E-09_JPRB, 0.53475396E-09_JPRB, 0.53494553E-09_JPRB, 0.53513161E-09_JPRB, &
  & 0.53530724E-09_JPRB, 0.53546256E-09_JPRB, 0.53558680E-09_JPRB, 0.53567362E-09_JPRB, 0.53572319E-09_JPRB, 0.53573956E-09_JPRB, &
  & 0.53572669E-09_JPRB, 0.53568722E-09_JPRB, 0.53562388E-09_JPRB, 0.53554128E-09_JPRB, 0.53544680E-09_JPRB, 0.53534888E-09_JPRB, &
  & 0.53525523E-09_JPRB, 0.53517007E-09_JPRB, 0.53509558E-09_JPRB, 0.53503268E-09_JPRB, 0.53497945E-09_JPRB, 0.53493543E-09_JPRB, &
  & 0.53489901E-09_JPRB, 0.53486937E-09_JPRB, 0.53484456E-09_JPRB, 0.53482252E-09_JPRB, 0.53480043E-09_JPRB, 0.53477556E-09_JPRB, &
  & 0.53474636E-09_JPRB, 0.53471327E-09_JPRB, 0.53467564E-09_JPRB, 0.53463539E-09_JPRB, 0.53459359E-09_JPRB, 0.53455346E-09_JPRB, &
  & 0.53451293E-09_JPRB, 0.53447163E-09_JPRB, 0.53441690E-09_JPRB, 0.53432125E-09_JPRB /)

RGHG6(:,66, 8) = (/ &
  & 0.53387361E-09_JPRB, 0.53392052E-09_JPRB, 0.53394633E-09_JPRB, 0.53396915E-09_JPRB, 0.53399318E-09_JPRB, 0.53402038E-09_JPRB, &
  & 0.53405247E-09_JPRB, 0.53408367E-09_JPRB, 0.53411825E-09_JPRB, 0.53415117E-09_JPRB, 0.53419058E-09_JPRB, 0.53423677E-09_JPRB, &
  & 0.53428756E-09_JPRB, 0.53433530E-09_JPRB, 0.53437060E-09_JPRB, 0.53438559E-09_JPRB, 0.53437288E-09_JPRB, 0.53433014E-09_JPRB, &
  & 0.53426141E-09_JPRB, 0.53417998E-09_JPRB, 0.53410792E-09_JPRB, 0.53407367E-09_JPRB, 0.53409788E-09_JPRB, 0.53418692E-09_JPRB, &
  & 0.53432586E-09_JPRB, 0.53449406E-09_JPRB, 0.53467447E-09_JPRB, 0.53485816E-09_JPRB, 0.53503951E-09_JPRB, 0.53521498E-09_JPRB, &
  & 0.53537913E-09_JPRB, 0.53552279E-09_JPRB, 0.53563642E-09_JPRB, 0.53571542E-09_JPRB, 0.53576055E-09_JPRB, 0.53577554E-09_JPRB, &
  & 0.53576465E-09_JPRB, 0.53572974E-09_JPRB, 0.53567345E-09_JPRB, 0.53559962E-09_JPRB, 0.53551480E-09_JPRB, 0.53542598E-09_JPRB, &
  & 0.53534022E-09_JPRB, 0.53526183E-09_JPRB, 0.53519233E-09_JPRB, 0.53513310E-09_JPRB, 0.53508298E-09_JPRB, 0.53504112E-09_JPRB, &
  & 0.53500643E-09_JPRB, 0.53497823E-09_JPRB, 0.53495464E-09_JPRB, 0.53493354E-09_JPRB, 0.53491200E-09_JPRB, 0.53488713E-09_JPRB, &
  & 0.53485755E-09_JPRB, 0.53482269E-09_JPRB, 0.53478283E-09_JPRB, 0.53473959E-09_JPRB, 0.53469523E-09_JPRB, 0.53465171E-09_JPRB, &
  & 0.53460825E-09_JPRB, 0.53456262E-09_JPRB, 0.53450033E-09_JPRB, 0.53438798E-09_JPRB /)

RGHG6(:,67, 8) = (/ &
  & 0.53400862E-09_JPRB, 0.53406179E-09_JPRB, 0.53409099E-09_JPRB, 0.53411620E-09_JPRB, 0.53414206E-09_JPRB, 0.53417104E-09_JPRB, &
  & 0.53420246E-09_JPRB, 0.53423865E-09_JPRB, 0.53427252E-09_JPRB, 0.53431298E-09_JPRB, 0.53435517E-09_JPRB, 0.53440508E-09_JPRB, &
  & 0.53445670E-09_JPRB, 0.53450316E-09_JPRB, 0.53453697E-09_JPRB, 0.53455057E-09_JPRB, 0.53453719E-09_JPRB, 0.53449511E-09_JPRB, &
  & 0.53442822E-09_JPRB, 0.53434923E-09_JPRB, 0.53427918E-09_JPRB, 0.53424354E-09_JPRB, 0.53426263E-09_JPRB, 0.53434179E-09_JPRB, &
  & 0.53446803E-09_JPRB, 0.53462273E-09_JPRB, 0.53479055E-09_JPRB, 0.53496207E-09_JPRB, 0.53513183E-09_JPRB, 0.53529547E-09_JPRB, &
  & 0.53544696E-09_JPRB, 0.53557853E-09_JPRB, 0.53568150E-09_JPRB, 0.53575283E-09_JPRB, 0.53579358E-09_JPRB, 0.53580729E-09_JPRB, &
  & 0.53579796E-09_JPRB, 0.53576754E-09_JPRB, 0.53571791E-09_JPRB, 0.53565258E-09_JPRB, 0.53557714E-09_JPRB, 0.53549754E-09_JPRB, &
  & 0.53542015E-09_JPRB, 0.53534838E-09_JPRB, 0.53528437E-09_JPRB, 0.53522925E-09_JPRB, 0.53518229E-09_JPRB, 0.53514315E-09_JPRB, &
  & 0.53511051E-09_JPRB, 0.53508414E-09_JPRB, 0.53506205E-09_JPRB, 0.53504207E-09_JPRB, 0.53502153E-09_JPRB, 0.53499721E-09_JPRB, &
  & 0.53496757E-09_JPRB, 0.53493210E-09_JPRB, 0.53489091E-09_JPRB, 0.53484611E-09_JPRB, 0.53479970E-09_JPRB, 0.53475446E-09_JPRB, &
  & 0.53470856E-09_JPRB, 0.53466015E-09_JPRB, 0.53459182E-09_JPRB, 0.53446286E-09_JPRB /)

RGHG6(:,68, 8) = (/ &
  & 0.53413146E-09_JPRB, 0.53419635E-09_JPRB, 0.53423155E-09_JPRB, 0.53426091E-09_JPRB, 0.53429017E-09_JPRB, 0.53432103E-09_JPRB, &
  & 0.53435523E-09_JPRB, 0.53439020E-09_JPRB, 0.53443094E-09_JPRB, 0.53447058E-09_JPRB, 0.53451787E-09_JPRB, 0.53456756E-09_JPRB, &
  & 0.53461779E-09_JPRB, 0.53466243E-09_JPRB, 0.53469462E-09_JPRB, 0.53470722E-09_JPRB, 0.53469412E-09_JPRB, 0.53465365E-09_JPRB, &
  & 0.53458987E-09_JPRB, 0.53451477E-09_JPRB, 0.53444760E-09_JPRB, 0.53441235E-09_JPRB, 0.53442695E-09_JPRB, 0.53449689E-09_JPRB, &
  & 0.53461036E-09_JPRB, 0.53475163E-09_JPRB, 0.53490579E-09_JPRB, 0.53506438E-09_JPRB, 0.53522115E-09_JPRB, 0.53537175E-09_JPRB, &
  & 0.53551058E-09_JPRB, 0.53562982E-09_JPRB, 0.53572236E-09_JPRB, 0.53578603E-09_JPRB, 0.53582255E-09_JPRB, 0.53583510E-09_JPRB, &
  & 0.53582744E-09_JPRB, 0.53580085E-09_JPRB, 0.53575744E-09_JPRB, 0.53570021E-09_JPRB, 0.53563382E-09_JPRB, 0.53556343E-09_JPRB, &
  & 0.53549415E-09_JPRB, 0.53542953E-09_JPRB, 0.53537108E-09_JPRB, 0.53532034E-09_JPRB, 0.53527721E-09_JPRB, 0.53524085E-09_JPRB, &
  & 0.53521115E-09_JPRB, 0.53518678E-09_JPRB, 0.53516636E-09_JPRB, 0.53514798E-09_JPRB, 0.53512855E-09_JPRB, 0.53510535E-09_JPRB, &
  & 0.53507643E-09_JPRB, 0.53504107E-09_JPRB, 0.53499977E-09_JPRB, 0.53495447E-09_JPRB, 0.53490740E-09_JPRB, 0.53486160E-09_JPRB, &
  & 0.53481430E-09_JPRB, 0.53476557E-09_JPRB, 0.53469279E-09_JPRB, 0.53455473E-09_JPRB /)

RGHG6(:,69, 8) = (/ &
  & 0.53424221E-09_JPRB, 0.53432664E-09_JPRB, 0.53436999E-09_JPRB, 0.53440580E-09_JPRB, 0.53443905E-09_JPRB, 0.53447302E-09_JPRB, &
  & 0.53450799E-09_JPRB, 0.53454602E-09_JPRB, 0.53458576E-09_JPRB, 0.53462923E-09_JPRB, 0.53467519E-09_JPRB, 0.53472393E-09_JPRB, &
  & 0.53477189E-09_JPRB, 0.53481397E-09_JPRB, 0.53484445E-09_JPRB, 0.53485621E-09_JPRB, 0.53484384E-09_JPRB, 0.53480609E-09_JPRB, &
  & 0.53474686E-09_JPRB, 0.53467680E-09_JPRB, 0.53461402E-09_JPRB, 0.53457938E-09_JPRB, 0.53459021E-09_JPRB, 0.53465082E-09_JPRB, &
  & 0.53475202E-09_JPRB, 0.53487914E-09_JPRB, 0.53501925E-09_JPRB, 0.53516397E-09_JPRB, 0.53530691E-09_JPRB, 0.53544413E-09_JPRB, &
  & 0.53556976E-09_JPRB, 0.53567689E-09_JPRB, 0.53575938E-09_JPRB, 0.53581611E-09_JPRB, 0.53584859E-09_JPRB, 0.53585986E-09_JPRB, &
  & 0.53585342E-09_JPRB, 0.53583044E-09_JPRB, 0.53579274E-09_JPRB, 0.53574295E-09_JPRB, 0.53568516E-09_JPRB, 0.53562327E-09_JPRB, &
  & 0.53556209E-09_JPRB, 0.53550475E-09_JPRB, 0.53545246E-09_JPRB, 0.53540661E-09_JPRB, 0.53536731E-09_JPRB, 0.53533455E-09_JPRB, &
  & 0.53530769E-09_JPRB, 0.53528587E-09_JPRB, 0.53526755E-09_JPRB, 0.53525095E-09_JPRB, 0.53523314E-09_JPRB, 0.53521132E-09_JPRB, &
  & 0.53518379E-09_JPRB, 0.53514970E-09_JPRB, 0.53510935E-09_JPRB, 0.53506499E-09_JPRB, 0.53501831E-09_JPRB, 0.53497357E-09_JPRB, &
  & 0.53492649E-09_JPRB, 0.53487820E-09_JPRB, 0.53480503E-09_JPRB, 0.53465687E-09_JPRB /)

RGHG6(:,70, 8) = (/ &
  & 0.53434440E-09_JPRB, 0.53445404E-09_JPRB, 0.53451071E-09_JPRB, 0.53455296E-09_JPRB, 0.53459126E-09_JPRB, 0.53462734E-09_JPRB, &
  & 0.53466376E-09_JPRB, 0.53470173E-09_JPRB, 0.53474208E-09_JPRB, 0.53478427E-09_JPRB, 0.53482846E-09_JPRB, 0.53487464E-09_JPRB, &
  & 0.53491933E-09_JPRB, 0.53495869E-09_JPRB, 0.53498717E-09_JPRB, 0.53499805E-09_JPRB, 0.53498694E-09_JPRB, 0.53495258E-09_JPRB, &
  & 0.53489868E-09_JPRB, 0.53483490E-09_JPRB, 0.53477711E-09_JPRB, 0.53474403E-09_JPRB, 0.53475113E-09_JPRB, 0.53480287E-09_JPRB, &
  & 0.53489146E-09_JPRB, 0.53500449E-09_JPRB, 0.53513038E-09_JPRB, 0.53526072E-09_JPRB, 0.53538957E-09_JPRB, 0.53551291E-09_JPRB, &
  & 0.53562527E-09_JPRB, 0.53572047E-09_JPRB, 0.53579319E-09_JPRB, 0.53584309E-09_JPRB, 0.53587174E-09_JPRB, 0.53588178E-09_JPRB, &
  & 0.53587640E-09_JPRB, 0.53585669E-09_JPRB, 0.53582438E-09_JPRB, 0.53578142E-09_JPRB, 0.53573151E-09_JPRB, 0.53567761E-09_JPRB, &
  & 0.53562460E-09_JPRB, 0.53557425E-09_JPRB, 0.53552851E-09_JPRB, 0.53548760E-09_JPRB, 0.53545263E-09_JPRB, 0.53542359E-09_JPRB, &
  & 0.53540017E-09_JPRB, 0.53538118E-09_JPRB, 0.53536520E-09_JPRB, 0.53535060E-09_JPRB, 0.53533444E-09_JPRB, 0.53531474E-09_JPRB, &
  & 0.53528920E-09_JPRB, 0.53525723E-09_JPRB, 0.53521881E-09_JPRB, 0.53517690E-09_JPRB, 0.53513238E-09_JPRB, 0.53509008E-09_JPRB, &
  & 0.53504479E-09_JPRB, 0.53499910E-09_JPRB, 0.53492866E-09_JPRB, 0.53478311E-09_JPRB /)

RGHG6(:,71, 8) = (/ &
  & 0.53444371E-09_JPRB, 0.53458804E-09_JPRB, 0.53465621E-09_JPRB, 0.53470628E-09_JPRB, 0.53474752E-09_JPRB, 0.53478560E-09_JPRB, &
  & 0.53482219E-09_JPRB, 0.53485893E-09_JPRB, 0.53489890E-09_JPRB, 0.53493654E-09_JPRB, 0.53497901E-09_JPRB, 0.53502047E-09_JPRB, &
  & 0.53506177E-09_JPRB, 0.53509758E-09_JPRB, 0.53512356E-09_JPRB, 0.53513344E-09_JPRB, 0.53512372E-09_JPRB, 0.53509297E-09_JPRB, &
  & 0.53504512E-09_JPRB, 0.53498816E-09_JPRB, 0.53493610E-09_JPRB, 0.53490484E-09_JPRB, 0.53490889E-09_JPRB, 0.53495186E-09_JPRB, &
  & 0.53502819E-09_JPRB, 0.53512700E-09_JPRB, 0.53523835E-09_JPRB, 0.53535443E-09_JPRB, 0.53546867E-09_JPRB, 0.53557819E-09_JPRB, &
  & 0.53567728E-09_JPRB, 0.53576082E-09_JPRB, 0.53582411E-09_JPRB, 0.53586729E-09_JPRB, 0.53589233E-09_JPRB, 0.53590121E-09_JPRB, &
  & 0.53589677E-09_JPRB, 0.53588001E-09_JPRB, 0.53585258E-09_JPRB, 0.53581589E-09_JPRB, 0.53577315E-09_JPRB, 0.53572735E-09_JPRB, &
  & 0.53568122E-09_JPRB, 0.53563842E-09_JPRB, 0.53559890E-09_JPRB, 0.53556343E-09_JPRB, 0.53553295E-09_JPRB, 0.53550797E-09_JPRB, &
  & 0.53548777E-09_JPRB, 0.53547167E-09_JPRB, 0.53545812E-09_JPRB, 0.53544580E-09_JPRB, 0.53543153E-09_JPRB, 0.53541421E-09_JPRB, &
  & 0.53539151E-09_JPRB, 0.53536242E-09_JPRB, 0.53532723E-09_JPRB, 0.53528881E-09_JPRB, 0.53524762E-09_JPRB, 0.53520882E-09_JPRB, &
  & 0.53516758E-09_JPRB, 0.53512478E-09_JPRB, 0.53506211E-09_JPRB, 0.53492449E-09_JPRB /)

RGHG6(:,72, 8) = (/ &
  & 0.53455429E-09_JPRB, 0.53473059E-09_JPRB, 0.53481181E-09_JPRB, 0.53486571E-09_JPRB, 0.53490956E-09_JPRB, 0.53494753E-09_JPRB, &
  & 0.53498317E-09_JPRB, 0.53501958E-09_JPRB, 0.53505295E-09_JPRB, 0.53509114E-09_JPRB, 0.53512456E-09_JPRB, 0.53516441E-09_JPRB, &
  & 0.53520000E-09_JPRB, 0.53523191E-09_JPRB, 0.53525490E-09_JPRB, 0.53526317E-09_JPRB, 0.53525440E-09_JPRB, 0.53522786E-09_JPRB, &
  & 0.53518562E-09_JPRB, 0.53513560E-09_JPRB, 0.53508953E-09_JPRB, 0.53506072E-09_JPRB, 0.53506238E-09_JPRB, 0.53509708E-09_JPRB, &
  & 0.53516142E-09_JPRB, 0.53524601E-09_JPRB, 0.53534305E-09_JPRB, 0.53544469E-09_JPRB, 0.53554444E-09_JPRB, 0.53563998E-09_JPRB, &
  & 0.53572613E-09_JPRB, 0.53579802E-09_JPRB, 0.53585225E-09_JPRB, 0.53588928E-09_JPRB, 0.53591087E-09_JPRB, 0.53591848E-09_JPRB, &
  & 0.53591476E-09_JPRB, 0.53590077E-09_JPRB, 0.53587790E-09_JPRB, 0.53584670E-09_JPRB, 0.53581123E-09_JPRB, 0.53577215E-09_JPRB, &
  & 0.53573340E-09_JPRB, 0.53569688E-09_JPRB, 0.53566390E-09_JPRB, 0.53563348E-09_JPRB, 0.53560772E-09_JPRB, 0.53558674E-09_JPRB, &
  & 0.53557003E-09_JPRB, 0.53555677E-09_JPRB, 0.53554544E-09_JPRB, 0.53553512E-09_JPRB, 0.53552285E-09_JPRB, 0.53550842E-09_JPRB, &
  & 0.53548860E-09_JPRB, 0.53546362E-09_JPRB, 0.53543225E-09_JPRB, 0.53539806E-09_JPRB, 0.53536148E-09_JPRB, 0.53532712E-09_JPRB, &
  & 0.53529020E-09_JPRB, 0.53525245E-09_JPRB, 0.53519600E-09_JPRB, 0.53507188E-09_JPRB /)

RGHG6(:,73, 8) = (/ &
  & 0.53470184E-09_JPRB, 0.53489296E-09_JPRB, 0.53497606E-09_JPRB, 0.53503135E-09_JPRB, 0.53507382E-09_JPRB, 0.53511107E-09_JPRB, &
  & 0.53514559E-09_JPRB, 0.53517646E-09_JPRB, 0.53521099E-09_JPRB, 0.53523763E-09_JPRB, 0.53527283E-09_JPRB, 0.53530241E-09_JPRB, &
  & 0.53533483E-09_JPRB, 0.53536137E-09_JPRB, 0.53538085E-09_JPRB, 0.53538712E-09_JPRB, 0.53537907E-09_JPRB, 0.53535548E-09_JPRB, &
  & 0.53531951E-09_JPRB, 0.53527610E-09_JPRB, 0.53523636E-09_JPRB, 0.53521038E-09_JPRB, 0.53521021E-09_JPRB, 0.53523730E-09_JPRB, &
  & 0.53529003E-09_JPRB, 0.53536087E-09_JPRB, 0.53544369E-09_JPRB, 0.53553140E-09_JPRB, 0.53561650E-09_JPRB, 0.53569860E-09_JPRB, &
  & 0.53577165E-09_JPRB, 0.53583260E-09_JPRB, 0.53587801E-09_JPRB, 0.53590898E-09_JPRB, 0.53592736E-09_JPRB, 0.53593385E-09_JPRB, &
  & 0.53593080E-09_JPRB, 0.53591925E-09_JPRB, 0.53590049E-09_JPRB, 0.53587462E-09_JPRB, 0.53584553E-09_JPRB, 0.53581317E-09_JPRB, &
  & 0.53578042E-09_JPRB, 0.53575017E-09_JPRB, 0.53572308E-09_JPRB, 0.53569776E-09_JPRB, 0.53567661E-09_JPRB, 0.53565963E-09_JPRB, &
  & 0.53564597E-09_JPRB, 0.53563548E-09_JPRB, 0.53562615E-09_JPRB, 0.53561777E-09_JPRB, 0.53560767E-09_JPRB, 0.53559562E-09_JPRB, &
  & 0.53557930E-09_JPRB, 0.53555804E-09_JPRB, 0.53553134E-09_JPRB, 0.53550198E-09_JPRB, 0.53547072E-09_JPRB, 0.53544086E-09_JPRB, &
  & 0.53540933E-09_JPRB, 0.53537552E-09_JPRB, 0.53532673E-09_JPRB, 0.53521509E-09_JPRB /)

RGHG6(:,74, 8) = (/ &
  & 0.53486748E-09_JPRB, 0.53506188E-09_JPRB, 0.53514509E-09_JPRB, 0.53519600E-09_JPRB, 0.53523713E-09_JPRB, 0.53527138E-09_JPRB, &
  & 0.53530202E-09_JPRB, 0.53533239E-09_JPRB, 0.53535709E-09_JPRB, 0.53538662E-09_JPRB, 0.53540833E-09_JPRB, 0.53543897E-09_JPRB, &
  & 0.53546234E-09_JPRB, 0.53548460E-09_JPRB, 0.53550031E-09_JPRB, 0.53550397E-09_JPRB, 0.53549615E-09_JPRB, 0.53547622E-09_JPRB, &
  & 0.53544508E-09_JPRB, 0.53540844E-09_JPRB, 0.53537502E-09_JPRB, 0.53535226E-09_JPRB, 0.53535099E-09_JPRB, 0.53537136E-09_JPRB, &
  & 0.53541366E-09_JPRB, 0.53547111E-09_JPRB, 0.53554022E-09_JPRB, 0.53561400E-09_JPRB, 0.53568477E-09_JPRB, 0.53575383E-09_JPRB, &
  & 0.53581406E-09_JPRB, 0.53586424E-09_JPRB, 0.53590160E-09_JPRB, 0.53592686E-09_JPRB, 0.53594218E-09_JPRB, 0.53594729E-09_JPRB, &
  & 0.53594501E-09_JPRB, 0.53593563E-09_JPRB, 0.53592059E-09_JPRB, 0.53589949E-09_JPRB, 0.53587651E-09_JPRB, 0.53585014E-09_JPRB, &
  & 0.53582300E-09_JPRB, 0.53579846E-09_JPRB, 0.53577709E-09_JPRB, 0.53575627E-09_JPRB, 0.53573956E-09_JPRB, 0.53572613E-09_JPRB, &
  & 0.53571547E-09_JPRB, 0.53570748E-09_JPRB, 0.53570004E-09_JPRB, 0.53569338E-09_JPRB, 0.53568500E-09_JPRB, 0.53567589E-09_JPRB, &
  & 0.53566218E-09_JPRB, 0.53564525E-09_JPRB, 0.53562288E-09_JPRB, 0.53559834E-09_JPRB, 0.53557292E-09_JPRB, 0.53554772E-09_JPRB, &
  & 0.53552118E-09_JPRB, 0.53549232E-09_JPRB, 0.53544985E-09_JPRB, 0.53535026E-09_JPRB /)

RGHG6(:,75, 8) = (/ &
  & 0.53504101E-09_JPRB, 0.53523436E-09_JPRB, 0.53530969E-09_JPRB, 0.53535665E-09_JPRB, 0.53539262E-09_JPRB, 0.53542321E-09_JPRB, &
  & 0.53545091E-09_JPRB, 0.53547444E-09_JPRB, 0.53550042E-09_JPRB, 0.53551807E-09_JPRB, 0.53554239E-09_JPRB, 0.53556148E-09_JPRB, &
  & 0.53558208E-09_JPRB, 0.53559834E-09_JPRB, 0.53561078E-09_JPRB, 0.53561233E-09_JPRB, 0.53560500E-09_JPRB, 0.53558857E-09_JPRB, &
  & 0.53556287E-09_JPRB, 0.53553256E-09_JPRB, 0.53550542E-09_JPRB, 0.53548582E-09_JPRB, 0.53548377E-09_JPRB, 0.53549853E-09_JPRB, &
  & 0.53553134E-09_JPRB, 0.53557636E-09_JPRB, 0.53563221E-09_JPRB, 0.53569210E-09_JPRB, 0.53574922E-09_JPRB, 0.53580562E-09_JPRB, &
  & 0.53585353E-09_JPRB, 0.53589350E-09_JPRB, 0.53592292E-09_JPRB, 0.53594307E-09_JPRB, 0.53595539E-09_JPRB, 0.53595911E-09_JPRB, &
  & 0.53595761E-09_JPRB, 0.53595012E-09_JPRB, 0.53593863E-09_JPRB, 0.53592186E-09_JPRB, 0.53590482E-09_JPRB, 0.53588373E-09_JPRB, &
  & 0.53586185E-09_JPRB, 0.53584226E-09_JPRB, 0.53582605E-09_JPRB, 0.53580951E-09_JPRB, 0.53579685E-09_JPRB, 0.53578697E-09_JPRB, &
  & 0.53577881E-09_JPRB, 0.53577326E-09_JPRB, 0.53576715E-09_JPRB, 0.53576221E-09_JPRB, 0.53575555E-09_JPRB, 0.53574878E-09_JPRB, &
  & 0.53573812E-09_JPRB, 0.53572458E-09_JPRB, 0.53570648E-09_JPRB, 0.53568694E-09_JPRB, 0.53566684E-09_JPRB, 0.53564664E-09_JPRB, &
  & 0.53562488E-09_JPRB, 0.53560112E-09_JPRB, 0.53556348E-09_JPRB, 0.53547711E-09_JPRB /)

RGHG6(:,76, 8) = (/ &
  & 0.53522303E-09_JPRB, 0.53540133E-09_JPRB, 0.53546978E-09_JPRB, 0.53550764E-09_JPRB, 0.53553878E-09_JPRB, 0.53556376E-09_JPRB, &
  & 0.53558635E-09_JPRB, 0.53560778E-09_JPRB, 0.53562521E-09_JPRB, 0.53564364E-09_JPRB, 0.53565635E-09_JPRB, 0.53567595E-09_JPRB, &
  & 0.53568855E-09_JPRB, 0.53570115E-09_JPRB, 0.53571092E-09_JPRB, 0.53571064E-09_JPRB, 0.53570431E-09_JPRB, 0.53569182E-09_JPRB, &
  & 0.53567151E-09_JPRB, 0.53564747E-09_JPRB, 0.53562643E-09_JPRB, 0.53560995E-09_JPRB, 0.53560817E-09_JPRB, 0.53561833E-09_JPRB, &
  & 0.53564309E-09_JPRB, 0.53567628E-09_JPRB, 0.53571925E-09_JPRB, 0.53576621E-09_JPRB, 0.53580967E-09_JPRB, 0.53585364E-09_JPRB, &
  & 0.53589000E-09_JPRB, 0.53592009E-09_JPRB, 0.53594240E-09_JPRB, 0.53595750E-09_JPRB, 0.53596722E-09_JPRB, 0.53596966E-09_JPRB, &
  & 0.53596882E-09_JPRB, 0.53596300E-09_JPRB, 0.53595495E-09_JPRB, 0.53594185E-09_JPRB, 0.53593041E-09_JPRB, 0.53591437E-09_JPRB, &
  & 0.53589672E-09_JPRB, 0.53588178E-09_JPRB, 0.53587051E-09_JPRB, 0.53585769E-09_JPRB, 0.53584892E-09_JPRB, 0.53584182E-09_JPRB, &
  & 0.53583593E-09_JPRB, 0.53583266E-09_JPRB, 0.53582772E-09_JPRB, 0.53582438E-09_JPRB, 0.53581917E-09_JPRB, 0.53581500E-09_JPRB, &
  & 0.53580662E-09_JPRB, 0.53579674E-09_JPRB, 0.53578242E-09_JPRB, 0.53576765E-09_JPRB, 0.53575328E-09_JPRB, 0.53573757E-09_JPRB, &
  & 0.53572086E-09_JPRB, 0.53570148E-09_JPRB, 0.53567040E-09_JPRB, 0.53559268E-09_JPRB /)

RGHG6(:,77, 8) = (/ &
  & 0.53540627E-09_JPRB, 0.53556420E-09_JPRB, 0.53561977E-09_JPRB, 0.53564897E-09_JPRB, 0.53567262E-09_JPRB, 0.53569171E-09_JPRB, &
  & 0.53570881E-09_JPRB, 0.53572369E-09_JPRB, 0.53573979E-09_JPRB, 0.53574889E-09_JPRB, 0.53576077E-09_JPRB, 0.53577304E-09_JPRB, &
  & 0.53578231E-09_JPRB, 0.53579075E-09_JPRB, 0.53579885E-09_JPRB, 0.53579741E-09_JPRB, 0.53579258E-09_JPRB, 0.53578392E-09_JPRB, &
  & 0.53576943E-09_JPRB, 0.53575167E-09_JPRB, 0.53573662E-09_JPRB, 0.53572347E-09_JPRB, 0.53572247E-09_JPRB, 0.53572902E-09_JPRB, &
  & 0.53574689E-09_JPRB, 0.53576932E-09_JPRB, 0.53580035E-09_JPRB, 0.53583499E-09_JPRB, 0.53586535E-09_JPRB, 0.53589766E-09_JPRB, &
  & 0.53592314E-09_JPRB, 0.53594440E-09_JPRB, 0.53595983E-09_JPRB, 0.53597055E-09_JPRB, 0.53597776E-09_JPRB, 0.53597871E-09_JPRB, &
  & 0.53597865E-09_JPRB, 0.53597415E-09_JPRB, 0.53596916E-09_JPRB, 0.53595950E-09_JPRB, 0.53595339E-09_JPRB, 0.53594196E-09_JPRB, &
  & 0.53592830E-09_JPRB, 0.53591720E-09_JPRB, 0.53591021E-09_JPRB, 0.53590082E-09_JPRB, 0.53589527E-09_JPRB, 0.53589067E-09_JPRB, &
  & 0.53588634E-09_JPRB, 0.53588534E-09_JPRB, 0.53588117E-09_JPRB, 0.53587945E-09_JPRB, 0.53587534E-09_JPRB, 0.53587368E-09_JPRB, &
  & 0.53586763E-09_JPRB, 0.53586113E-09_JPRB, 0.53585036E-09_JPRB, 0.53584037E-09_JPRB, 0.53583138E-09_JPRB, 0.53582022E-09_JPRB, &
  & 0.53580784E-09_JPRB, 0.53579424E-09_JPRB, 0.53576682E-09_JPRB, 0.53570282E-09_JPRB /)

RGHG6(:,78, 8) = (/ &
  & 0.53559224E-09_JPRB, 0.53571231E-09_JPRB, 0.53575139E-09_JPRB, 0.53576987E-09_JPRB, 0.53578730E-09_JPRB, 0.53579946E-09_JPRB, &
  & 0.53581095E-09_JPRB, 0.53582067E-09_JPRB, 0.53583110E-09_JPRB, 0.53583638E-09_JPRB, 0.53584143E-09_JPRB, 0.53585281E-09_JPRB, &
  & 0.53585758E-09_JPRB, 0.53586335E-09_JPRB, 0.53587029E-09_JPRB, 0.53586779E-09_JPRB, 0.53586452E-09_JPRB, 0.53585952E-09_JPRB, &
  & 0.53585031E-09_JPRB, 0.53583826E-09_JPRB, 0.53582933E-09_JPRB, 0.53581922E-09_JPRB, 0.53582005E-09_JPRB, 0.53582411E-09_JPRB, &
  & 0.53583682E-09_JPRB, 0.53584986E-09_JPRB, 0.53587068E-09_JPRB, 0.53589488E-09_JPRB, 0.53591326E-09_JPRB, 0.53593580E-09_JPRB, &
  & 0.53595139E-09_JPRB, 0.53596511E-09_JPRB, 0.53597460E-09_JPRB, 0.53598143E-09_JPRB, 0.53598664E-09_JPRB, 0.53598648E-09_JPRB, &
  & 0.53598720E-09_JPRB, 0.53598365E-09_JPRB, 0.53598120E-09_JPRB, 0.53597426E-09_JPRB, 0.53597282E-09_JPRB, 0.53596527E-09_JPRB, &
  & 0.53595473E-09_JPRB, 0.53594684E-09_JPRB, 0.53594351E-09_JPRB, 0.53593663E-09_JPRB, 0.53593385E-09_JPRB, 0.53593102E-09_JPRB, &
  & 0.53592780E-09_JPRB, 0.53592847E-09_JPRB, 0.53592458E-09_JPRB, 0.53592408E-09_JPRB, 0.53592092E-09_JPRB, 0.53592181E-09_JPRB, &
  & 0.53591753E-09_JPRB, 0.53591415E-09_JPRB, 0.53590643E-09_JPRB, 0.53590060E-09_JPRB, 0.53589699E-09_JPRB, 0.53588961E-09_JPRB, &
  & 0.53588145E-09_JPRB, 0.53587224E-09_JPRB, 0.53585242E-09_JPRB, 0.53580418E-09_JPRB /)

RGHG6(:,79, 8) = (/ &
  & 0.53571353E-09_JPRB, 0.53579613E-09_JPRB, 0.53582211E-09_JPRB, 0.53583293E-09_JPRB, 0.53584703E-09_JPRB, 0.53585592E-09_JPRB, &
  & 0.53586413E-09_JPRB, 0.53587057E-09_JPRB, 0.53587973E-09_JPRB, 0.53588112E-09_JPRB, 0.53588400E-09_JPRB, 0.53589400E-09_JPRB, &
  & 0.53589666E-09_JPRB, 0.53590105E-09_JPRB, 0.53590787E-09_JPRB, 0.53590454E-09_JPRB, 0.53590199E-09_JPRB, 0.53589905E-09_JPRB, &
  & 0.53589294E-09_JPRB, 0.53588384E-09_JPRB, 0.53587834E-09_JPRB, 0.53586968E-09_JPRB, 0.53587174E-09_JPRB, 0.53587462E-09_JPRB, &
  & 0.53588495E-09_JPRB, 0.53589277E-09_JPRB, 0.53590854E-09_JPRB, 0.53592736E-09_JPRB, 0.53593913E-09_JPRB, 0.53595667E-09_JPRB, &
  & 0.53596705E-09_JPRB, 0.53597660E-09_JPRB, 0.53598259E-09_JPRB, 0.53598748E-09_JPRB, 0.53599170E-09_JPRB, 0.53599059E-09_JPRB, &
  & 0.53599186E-09_JPRB, 0.53598875E-09_JPRB, 0.53598792E-09_JPRB, 0.53598226E-09_JPRB, 0.53598359E-09_JPRB, 0.53597815E-09_JPRB, &
  & 0.53596877E-09_JPRB, 0.53596227E-09_JPRB, 0.53596100E-09_JPRB, 0.53595528E-09_JPRB, 0.53595395E-09_JPRB, 0.53595206E-09_JPRB, &
  & 0.53594906E-09_JPRB, 0.53595106E-09_JPRB, 0.53594679E-09_JPRB, 0.53594712E-09_JPRB, 0.53594407E-09_JPRB, 0.53594662E-09_JPRB, &
  & 0.53594290E-09_JPRB, 0.53594140E-09_JPRB, 0.53593485E-09_JPRB, 0.53593124E-09_JPRB, 0.53593074E-09_JPRB, 0.53592525E-09_JPRB, &
  & 0.53591914E-09_JPRB, 0.53591359E-09_JPRB, 0.53589844E-09_JPRB, 0.53586874E-09_JPRB /)

RGHG6(:,80, 8) = (/ &
  & 0.53579513E-09_JPRB, 0.53583676E-09_JPRB, 0.53585320E-09_JPRB, 0.53586025E-09_JPRB, 0.53587290E-09_JPRB, 0.53588012E-09_JPRB, &
  & 0.53588728E-09_JPRB, 0.53589205E-09_JPRB, 0.53590121E-09_JPRB, 0.53590088E-09_JPRB, 0.53590266E-09_JPRB, 0.53591226E-09_JPRB, &
  & 0.53591398E-09_JPRB, 0.53591781E-09_JPRB, 0.53592486E-09_JPRB, 0.53592092E-09_JPRB, 0.53591881E-09_JPRB, 0.53591698E-09_JPRB, &
  & 0.53591226E-09_JPRB, 0.53590449E-09_JPRB, 0.53590071E-09_JPRB, 0.53589227E-09_JPRB, 0.53589522E-09_JPRB, 0.53589738E-09_JPRB, &
  & 0.53590676E-09_JPRB, 0.53591204E-09_JPRB, 0.53592569E-09_JPRB, 0.53594218E-09_JPRB, 0.53595089E-09_JPRB, 0.53596638E-09_JPRB, &
  & 0.53597432E-09_JPRB, 0.53598187E-09_JPRB, 0.53598637E-09_JPRB, 0.53599025E-09_JPRB, 0.53599408E-09_JPRB, 0.53599258E-09_JPRB, &
  & 0.53599419E-09_JPRB, 0.53599114E-09_JPRB, 0.53599108E-09_JPRB, 0.53598603E-09_JPRB, 0.53598881E-09_JPRB, 0.53598409E-09_JPRB, &
  & 0.53597510E-09_JPRB, 0.53596916E-09_JPRB, 0.53596877E-09_JPRB, 0.53596350E-09_JPRB, 0.53596294E-09_JPRB, 0.53596139E-09_JPRB, &
  & 0.53595844E-09_JPRB, 0.53596116E-09_JPRB, 0.53595650E-09_JPRB, 0.53595711E-09_JPRB, 0.53595395E-09_JPRB, 0.53595767E-09_JPRB, &
  & 0.53595395E-09_JPRB, 0.53595328E-09_JPRB, 0.53594684E-09_JPRB, 0.53594423E-09_JPRB, 0.53594540E-09_JPRB, 0.53594057E-09_JPRB, &
  & 0.53593552E-09_JPRB, 0.53593163E-09_JPRB, 0.53592020E-09_JPRB, 0.53591076E-09_JPRB /)

RGHG6(:,81, 8) = (/ &
  & 0.53585170E-09_JPRB, 0.53585403E-09_JPRB, 0.53586635E-09_JPRB, 0.53587179E-09_JPRB, 0.53588411E-09_JPRB, 0.53589094E-09_JPRB, &
  & 0.53589722E-09_JPRB, 0.53590254E-09_JPRB, 0.53591004E-09_JPRB, 0.53590948E-09_JPRB, 0.53591032E-09_JPRB, 0.53592059E-09_JPRB, &
  & 0.53592164E-09_JPRB, 0.53592519E-09_JPRB, 0.53593230E-09_JPRB, 0.53592819E-09_JPRB, 0.53592630E-09_JPRB, 0.53592503E-09_JPRB, &
  & 0.53592103E-09_JPRB, 0.53591370E-09_JPRB, 0.53591087E-09_JPRB, 0.53590210E-09_JPRB, 0.53590571E-09_JPRB, 0.53590737E-09_JPRB, &
  & 0.53591637E-09_JPRB, 0.53592047E-09_JPRB, 0.53593330E-09_JPRB, 0.53594890E-09_JPRB, 0.53595633E-09_JPRB, 0.53597060E-09_JPRB, &
  & 0.53597748E-09_JPRB, 0.53598431E-09_JPRB, 0.53598820E-09_JPRB, 0.53599158E-09_JPRB, 0.53599525E-09_JPRB, 0.53599347E-09_JPRB, &
  & 0.53599514E-09_JPRB, 0.53599214E-09_JPRB, 0.53599253E-09_JPRB, 0.53598775E-09_JPRB, 0.53599120E-09_JPRB, 0.53598692E-09_JPRB, &
  & 0.53597804E-09_JPRB, 0.53597210E-09_JPRB, 0.53597204E-09_JPRB, 0.53596694E-09_JPRB, 0.53596694E-09_JPRB, 0.53596566E-09_JPRB, &
  & 0.53596255E-09_JPRB, 0.53596583E-09_JPRB, 0.53596083E-09_JPRB, 0.53596150E-09_JPRB, 0.53595811E-09_JPRB, 0.53596250E-09_JPRB, &
  & 0.53595872E-09_JPRB, 0.53595850E-09_JPRB, 0.53595195E-09_JPRB, 0.53594967E-09_JPRB, 0.53595178E-09_JPRB, 0.53594723E-09_JPRB, &
  & 0.53594251E-09_JPRB, 0.53593940E-09_JPRB, 0.53592913E-09_JPRB, 0.53593946E-09_JPRB /)

RGHG6(:,82, 8) = (/ &
  & 0.53585614E-09_JPRB, 0.53585975E-09_JPRB, 0.53587201E-09_JPRB, 0.53587723E-09_JPRB, 0.53588955E-09_JPRB, 0.53589594E-09_JPRB, &
  & 0.53590238E-09_JPRB, 0.53590599E-09_JPRB, 0.53591492E-09_JPRB, 0.53591392E-09_JPRB, 0.53591542E-09_JPRB, 0.53592369E-09_JPRB, &
  & 0.53592530E-09_JPRB, 0.53592886E-09_JPRB, 0.53593607E-09_JPRB, 0.53593174E-09_JPRB, 0.53592991E-09_JPRB, 0.53592908E-09_JPRB, &
  & 0.53592547E-09_JPRB, 0.53591837E-09_JPRB, 0.53591603E-09_JPRB, 0.53590682E-09_JPRB, 0.53591093E-09_JPRB, 0.53591220E-09_JPRB, &
  & 0.53592109E-09_JPRB, 0.53592453E-09_JPRB, 0.53593691E-09_JPRB, 0.53595239E-09_JPRB, 0.53595905E-09_JPRB, 0.53597288E-09_JPRB, &
  & 0.53597915E-09_JPRB, 0.53598553E-09_JPRB, 0.53598909E-09_JPRB, 0.53599225E-09_JPRB, 0.53599591E-09_JPRB, 0.53599403E-09_JPRB, &
  & 0.53599575E-09_JPRB, 0.53599269E-09_JPRB, 0.53599325E-09_JPRB, 0.53598875E-09_JPRB, 0.53599236E-09_JPRB, 0.53598831E-09_JPRB, &
  & 0.53597943E-09_JPRB, 0.53597360E-09_JPRB, 0.53597377E-09_JPRB, 0.53596871E-09_JPRB, 0.53596888E-09_JPRB, 0.53596777E-09_JPRB, &
  & 0.53596466E-09_JPRB, 0.53596810E-09_JPRB, 0.53596283E-09_JPRB, 0.53596372E-09_JPRB, 0.53596022E-09_JPRB, 0.53596522E-09_JPRB, &
  & 0.53596105E-09_JPRB, 0.53596111E-09_JPRB, 0.53595428E-09_JPRB, 0.53595217E-09_JPRB, 0.53595495E-09_JPRB, 0.53595051E-09_JPRB, &
  & 0.53594579E-09_JPRB, 0.53594273E-09_JPRB, 0.53593208E-09_JPRB, 0.53594185E-09_JPRB /)

RGHG6(:,83, 8) = (/ &
  & 0.53585925E-09_JPRB, 0.53586313E-09_JPRB, 0.53587540E-09_JPRB, 0.53588023E-09_JPRB, 0.53589255E-09_JPRB, 0.53589910E-09_JPRB, &
  & 0.53590482E-09_JPRB, 0.53591054E-09_JPRB, 0.53591626E-09_JPRB, 0.53591592E-09_JPRB, 0.53591664E-09_JPRB, 0.53592647E-09_JPRB, &
  & 0.53592741E-09_JPRB, 0.53593097E-09_JPRB, 0.53593813E-09_JPRB, 0.53593385E-09_JPRB, 0.53593197E-09_JPRB, 0.53593141E-09_JPRB, &
  & 0.53592802E-09_JPRB, 0.53592097E-09_JPRB, 0.53591898E-09_JPRB, 0.53590937E-09_JPRB, 0.53591392E-09_JPRB, 0.53591476E-09_JPRB, &
  & 0.53592386E-09_JPRB, 0.53592664E-09_JPRB, 0.53593918E-09_JPRB, 0.53595417E-09_JPRB, 0.53596061E-09_JPRB, 0.53597404E-09_JPRB, &
  & 0.53598015E-09_JPRB, 0.53598626E-09_JPRB, 0.53598959E-09_JPRB, 0.53599264E-09_JPRB, 0.53599614E-09_JPRB, 0.53599414E-09_JPRB, &
  & 0.53599608E-09_JPRB, 0.53599292E-09_JPRB, 0.53599358E-09_JPRB, 0.53598936E-09_JPRB, 0.53599303E-09_JPRB, 0.53598909E-09_JPRB, &
  & 0.53598026E-09_JPRB, 0.53597443E-09_JPRB, 0.53597465E-09_JPRB, 0.53596966E-09_JPRB, 0.53596994E-09_JPRB, 0.53596894E-09_JPRB, &
  & 0.53596583E-09_JPRB, 0.53596949E-09_JPRB, 0.53596400E-09_JPRB, 0.53596499E-09_JPRB, 0.53596128E-09_JPRB, 0.53596655E-09_JPRB, &
  & 0.53596233E-09_JPRB, 0.53596250E-09_JPRB, 0.53595556E-09_JPRB, 0.53595361E-09_JPRB, 0.53595678E-09_JPRB, 0.53595245E-09_JPRB, &
  & 0.53594768E-09_JPRB, 0.53594473E-09_JPRB, 0.53593363E-09_JPRB, 0.53594346E-09_JPRB /)

RGHG6(:,84, 8) = (/ &
  & 0.53586147E-09_JPRB, 0.53586541E-09_JPRB, 0.53587751E-09_JPRB, 0.53588206E-09_JPRB, 0.53589455E-09_JPRB, 0.53590077E-09_JPRB, &
  & 0.53590726E-09_JPRB, 0.53591054E-09_JPRB, 0.53591842E-09_JPRB, 0.53591809E-09_JPRB, 0.53592009E-09_JPRB, 0.53592636E-09_JPRB, &
  & 0.53592880E-09_JPRB, 0.53593230E-09_JPRB, 0.53593879E-09_JPRB, 0.53593507E-09_JPRB, 0.53593335E-09_JPRB, 0.53593291E-09_JPRB, &
  & 0.53592969E-09_JPRB, 0.53592264E-09_JPRB, 0.53592081E-09_JPRB, 0.53591076E-09_JPRB, 0.53591581E-09_JPRB, 0.53591626E-09_JPRB, &
  & 0.53592558E-09_JPRB, 0.53592791E-09_JPRB, 0.53594007E-09_JPRB, 0.53595578E-09_JPRB, 0.53596155E-09_JPRB, 0.53597488E-09_JPRB, &
  & 0.53598070E-09_JPRB, 0.53598670E-09_JPRB, 0.53598986E-09_JPRB, 0.53599286E-09_JPRB, 0.53599641E-09_JPRB, 0.53599430E-09_JPRB, &
  & 0.53599630E-09_JPRB, 0.53599297E-09_JPRB, 0.53599380E-09_JPRB, 0.53598959E-09_JPRB, 0.53599336E-09_JPRB, 0.53598959E-09_JPRB, &
  & 0.53598104E-09_JPRB, 0.53597488E-09_JPRB, 0.53597515E-09_JPRB, 0.53597010E-09_JPRB, 0.53597055E-09_JPRB, 0.53596966E-09_JPRB, &
  & 0.53596649E-09_JPRB, 0.53597038E-09_JPRB, 0.53596472E-09_JPRB, 0.53596583E-09_JPRB, 0.53596194E-09_JPRB, 0.53596744E-09_JPRB, &
  & 0.53596322E-09_JPRB, 0.53596350E-09_JPRB, 0.53595633E-09_JPRB, 0.53595434E-09_JPRB, 0.53595789E-09_JPRB, 0.53595350E-09_JPRB, &
  & 0.53594884E-09_JPRB, 0.53594612E-09_JPRB, 0.53593480E-09_JPRB, 0.53594462E-09_JPRB /)

RGHG6(:,85, 8) = (/ &
  & 0.53586297E-09_JPRB, 0.53586685E-09_JPRB, 0.53587884E-09_JPRB, 0.53588334E-09_JPRB, 0.53589588E-09_JPRB, 0.53590277E-09_JPRB, &
  & 0.53590798E-09_JPRB, 0.53591398E-09_JPRB, 0.53591820E-09_JPRB, 0.53591920E-09_JPRB, 0.53592064E-09_JPRB, 0.53592741E-09_JPRB, &
  & 0.53592963E-09_JPRB, 0.53593324E-09_JPRB, 0.53593829E-09_JPRB, 0.53593574E-09_JPRB, 0.53593430E-09_JPRB, 0.53593374E-09_JPRB, &
  & 0.53593074E-09_JPRB, 0.53592364E-09_JPRB, 0.53592214E-09_JPRB, 0.53591165E-09_JPRB, 0.53591698E-09_JPRB, 0.53591720E-09_JPRB, &
  & 0.53592675E-09_JPRB, 0.53592830E-09_JPRB, 0.53594129E-09_JPRB, 0.53595633E-09_JPRB, 0.53596239E-09_JPRB, 0.53597526E-09_JPRB, &
  & 0.53598115E-09_JPRB, 0.53598703E-09_JPRB, 0.53599009E-09_JPRB, 0.53599303E-09_JPRB, 0.53599658E-09_JPRB, 0.53599447E-09_JPRB, &
  & 0.53599641E-09_JPRB, 0.53599308E-09_JPRB, 0.53599386E-09_JPRB, 0.53598981E-09_JPRB, 0.53599375E-09_JPRB, 0.53599020E-09_JPRB, &
  & 0.53598115E-09_JPRB, 0.53597521E-09_JPRB, 0.53597538E-09_JPRB, 0.53597060E-09_JPRB, 0.53597105E-09_JPRB, 0.53597021E-09_JPRB, &
  & 0.53596699E-09_JPRB, 0.53597088E-09_JPRB, 0.53596527E-09_JPRB, 0.53596649E-09_JPRB, 0.53596239E-09_JPRB, 0.53596810E-09_JPRB, &
  & 0.53596383E-09_JPRB, 0.53596411E-09_JPRB, 0.53595678E-09_JPRB, 0.53595489E-09_JPRB, 0.53595867E-09_JPRB, 0.53595434E-09_JPRB, &
  & 0.53594962E-09_JPRB, 0.53594701E-09_JPRB, 0.53593552E-09_JPRB, 0.53594529E-09_JPRB /)

RGHG6(:,86, 8) = (/ &
  & 0.53586385E-09_JPRB, 0.53586779E-09_JPRB, 0.53587967E-09_JPRB, 0.53588411E-09_JPRB, 0.53589738E-09_JPRB, 0.53590316E-09_JPRB, &
  & 0.53591059E-09_JPRB, 0.53591376E-09_JPRB, 0.53591964E-09_JPRB, 0.53592047E-09_JPRB, 0.53592286E-09_JPRB, 0.53592719E-09_JPRB, &
  & 0.53593013E-09_JPRB, 0.53593324E-09_JPRB, 0.53593729E-09_JPRB, 0.53593607E-09_JPRB, 0.53593480E-09_JPRB, 0.53593424E-09_JPRB, &
  & 0.53593141E-09_JPRB, 0.53592464E-09_JPRB, 0.53592292E-09_JPRB, 0.53591231E-09_JPRB, 0.53591781E-09_JPRB, 0.53591775E-09_JPRB, &
  & 0.53592758E-09_JPRB, 0.53592863E-09_JPRB, 0.53594112E-09_JPRB, 0.53595739E-09_JPRB, 0.53596239E-09_JPRB, 0.53597599E-09_JPRB, &
  & 0.53598143E-09_JPRB, 0.53598720E-09_JPRB, 0.53599020E-09_JPRB, 0.53599308E-09_JPRB, 0.53599669E-09_JPRB, 0.53599453E-09_JPRB, &
  & 0.53599658E-09_JPRB, 0.53599303E-09_JPRB, 0.53599403E-09_JPRB, 0.53598986E-09_JPRB, 0.53599414E-09_JPRB, 0.53599047E-09_JPRB, &
  & 0.53598165E-09_JPRB, 0.53597515E-09_JPRB, 0.53597571E-09_JPRB, 0.53597071E-09_JPRB, 0.53597121E-09_JPRB, 0.53597060E-09_JPRB, &
  & 0.53596744E-09_JPRB, 0.53597116E-09_JPRB, 0.53596566E-09_JPRB, 0.53596688E-09_JPRB, 0.53596266E-09_JPRB, 0.53596844E-09_JPRB, &
  & 0.53596422E-09_JPRB, 0.53596450E-09_JPRB, 0.53595700E-09_JPRB, 0.53595517E-09_JPRB, 0.53595928E-09_JPRB, 0.53595484E-09_JPRB, &
  & 0.53595023E-09_JPRB, 0.53594779E-09_JPRB, 0.53593596E-09_JPRB, 0.53594590E-09_JPRB /)

RGHG6(:,87, 8) = (/ &
  & 0.53586441E-09_JPRB, 0.53586852E-09_JPRB, 0.53588034E-09_JPRB, 0.53588511E-09_JPRB, 0.53589716E-09_JPRB, 0.53590565E-09_JPRB, &
  & 0.53591021E-09_JPRB, 0.53591609E-09_JPRB, 0.53591948E-09_JPRB, 0.53592142E-09_JPRB, 0.53592342E-09_JPRB, 0.53592769E-09_JPRB, &
  & 0.53593019E-09_JPRB, 0.53593319E-09_JPRB, 0.53593635E-09_JPRB, 0.53593585E-09_JPRB, 0.53593507E-09_JPRB, 0.53593452E-09_JPRB, &
  & 0.53593191E-09_JPRB, 0.53592519E-09_JPRB, 0.53592353E-09_JPRB, 0.53591276E-09_JPRB, 0.53591820E-09_JPRB, 0.53591809E-09_JPRB, &
  & 0.53592814E-09_JPRB, 0.53592852E-09_JPRB, 0.53594146E-09_JPRB, 0.53595750E-09_JPRB, 0.53596266E-09_JPRB, 0.53597643E-09_JPRB, &
  & 0.53598165E-09_JPRB, 0.53598748E-09_JPRB, 0.53599036E-09_JPRB, 0.53599331E-09_JPRB, 0.53599691E-09_JPRB, 0.53599453E-09_JPRB, &
  & 0.53599680E-09_JPRB, 0.53599308E-09_JPRB, 0.53599430E-09_JPRB, 0.53598970E-09_JPRB, 0.53599469E-09_JPRB, 0.53599108E-09_JPRB, &
  & 0.53598126E-09_JPRB, 0.53597510E-09_JPRB, 0.53597576E-09_JPRB, 0.53597093E-09_JPRB, 0.53597138E-09_JPRB, 0.53597082E-09_JPRB, &
  & 0.53596777E-09_JPRB, 0.53597116E-09_JPRB, 0.53596588E-09_JPRB, 0.53596710E-09_JPRB, 0.53596283E-09_JPRB, 0.53596871E-09_JPRB, &
  & 0.53596444E-09_JPRB, 0.53596477E-09_JPRB, 0.53595711E-09_JPRB, 0.53595517E-09_JPRB, 0.53595950E-09_JPRB, 0.53595522E-09_JPRB, &
  & 0.53595056E-09_JPRB, 0.53594806E-09_JPRB, 0.53593613E-09_JPRB, 0.53594623E-09_JPRB /)

RGHG6(:,88, 8) = (/ &
  & 0.53586496E-09_JPRB, 0.53586952E-09_JPRB, 0.53588045E-09_JPRB, 0.53588500E-09_JPRB, 0.53589866E-09_JPRB, 0.53590432E-09_JPRB, &
  & 0.53591198E-09_JPRB, 0.53591520E-09_JPRB, 0.53592031E-09_JPRB, 0.53592164E-09_JPRB, 0.53592397E-09_JPRB, 0.53592764E-09_JPRB, &
  & 0.53593024E-09_JPRB, 0.53593296E-09_JPRB, 0.53593607E-09_JPRB, 0.53593580E-09_JPRB, 0.53593513E-09_JPRB, 0.53593463E-09_JPRB, &
  & 0.53593208E-09_JPRB, 0.53592564E-09_JPRB, 0.53592381E-09_JPRB, 0.53591304E-09_JPRB, 0.53591864E-09_JPRB, 0.53591809E-09_JPRB, &
  & 0.53592841E-09_JPRB, 0.53592836E-09_JPRB, 0.53594124E-09_JPRB, 0.53595817E-09_JPRB, 0.53596239E-09_JPRB, 0.53597699E-09_JPRB, &
  & 0.53598181E-09_JPRB, 0.53598764E-09_JPRB, 0.53599047E-09_JPRB, 0.53599347E-09_JPRB, 0.53599725E-09_JPRB, 0.53599458E-09_JPRB, &
  & 0.53599702E-09_JPRB, 0.53599297E-09_JPRB, 0.53599464E-09_JPRB, 0.53598942E-09_JPRB, 0.53599541E-09_JPRB, 0.53599164E-09_JPRB, &
  & 0.53598137E-09_JPRB, 0.53597465E-09_JPRB, 0.53597587E-09_JPRB, 0.53597093E-09_JPRB, 0.53597138E-09_JPRB, 0.53597093E-09_JPRB, &
  & 0.53596799E-09_JPRB, 0.53597116E-09_JPRB, 0.53596616E-09_JPRB, 0.53596716E-09_JPRB, 0.53596294E-09_JPRB, 0.53596882E-09_JPRB, &
  & 0.53596455E-09_JPRB, 0.53596494E-09_JPRB, 0.53595722E-09_JPRB, 0.53595528E-09_JPRB, 0.53595983E-09_JPRB, 0.53595539E-09_JPRB, &
  & 0.53595078E-09_JPRB, 0.53594845E-09_JPRB, 0.53593624E-09_JPRB, 0.53594634E-09_JPRB /)

RGHG6(:,89, 8) = (/ &
  & 0.53586569E-09_JPRB, 0.53587035E-09_JPRB, 0.53588040E-09_JPRB, 0.53588523E-09_JPRB, 0.53589744E-09_JPRB, 0.53590565E-09_JPRB, &
  & 0.53591043E-09_JPRB, 0.53591620E-09_JPRB, 0.53591992E-09_JPRB, 0.53592153E-09_JPRB, 0.53592358E-09_JPRB, 0.53592797E-09_JPRB, &
  & 0.53593058E-09_JPRB, 0.53593352E-09_JPRB, 0.53593674E-09_JPRB, 0.53593613E-09_JPRB, 0.53593530E-09_JPRB, 0.53593485E-09_JPRB, &
  & 0.53593230E-09_JPRB, 0.53592558E-09_JPRB, 0.53592419E-09_JPRB, 0.53591298E-09_JPRB, 0.53591875E-09_JPRB, 0.53591814E-09_JPRB, &
  & 0.53592875E-09_JPRB, 0.53592825E-09_JPRB, 0.53594129E-09_JPRB, 0.53595839E-09_JPRB, 0.53596244E-09_JPRB, 0.53597737E-09_JPRB, &
  & 0.53598187E-09_JPRB, 0.53598792E-09_JPRB, 0.53599070E-09_JPRB, 0.53599358E-09_JPRB, 0.53599741E-09_JPRB, 0.53599458E-09_JPRB, &
  & 0.53599714E-09_JPRB, 0.53599281E-09_JPRB, 0.53599480E-09_JPRB, 0.53598892E-09_JPRB, 0.53599603E-09_JPRB, 0.53599220E-09_JPRB, &
  & 0.53598104E-09_JPRB, 0.53597432E-09_JPRB, 0.53597615E-09_JPRB, 0.53597105E-09_JPRB, 0.53597154E-09_JPRB, 0.53597093E-09_JPRB, &
  & 0.53596794E-09_JPRB, 0.53597116E-09_JPRB, 0.53596622E-09_JPRB, 0.53596716E-09_JPRB, 0.53596300E-09_JPRB, 0.53596888E-09_JPRB, &
  & 0.53596455E-09_JPRB, 0.53596511E-09_JPRB, 0.53595722E-09_JPRB, 0.53595522E-09_JPRB, 0.53596000E-09_JPRB, 0.53595550E-09_JPRB, &
  & 0.53595095E-09_JPRB, 0.53594862E-09_JPRB, 0.53593624E-09_JPRB, 0.53594656E-09_JPRB /)

RGHG6(:,90, 8) = (/ &
  & 0.53586630E-09_JPRB, 0.53587135E-09_JPRB, 0.53587967E-09_JPRB, 0.53588445E-09_JPRB, 0.53589788E-09_JPRB, 0.53590354E-09_JPRB, &
  & 0.53591065E-09_JPRB, 0.53591415E-09_JPRB, 0.53592042E-09_JPRB, 0.53592086E-09_JPRB, 0.53592297E-09_JPRB, 0.53592808E-09_JPRB, &
  & 0.53593080E-09_JPRB, 0.53593396E-09_JPRB, 0.53593829E-09_JPRB, 0.53593685E-09_JPRB, 0.53593552E-09_JPRB, 0.53593530E-09_JPRB, &
  & 0.53593258E-09_JPRB, 0.53592530E-09_JPRB, 0.53592453E-09_JPRB, 0.53591254E-09_JPRB, 0.53591892E-09_JPRB, 0.53591792E-09_JPRB, &
  & 0.53592908E-09_JPRB, 0.53592786E-09_JPRB, 0.53594118E-09_JPRB, 0.53595883E-09_JPRB, 0.53596211E-09_JPRB, 0.53597787E-09_JPRB, &
  & 0.53598187E-09_JPRB, 0.53598814E-09_JPRB, 0.53599075E-09_JPRB, 0.53599369E-09_JPRB, 0.53599786E-09_JPRB, 0.53599447E-09_JPRB, &
  & 0.53599736E-09_JPRB, 0.53599264E-09_JPRB, 0.53599519E-09_JPRB, 0.53598842E-09_JPRB, 0.53599652E-09_JPRB, 0.53599275E-09_JPRB, &
  & 0.53598093E-09_JPRB, 0.53597382E-09_JPRB, 0.53597643E-09_JPRB, 0.53597077E-09_JPRB, 0.53597166E-09_JPRB, 0.53597116E-09_JPRB, &
  & 0.53596783E-09_JPRB, 0.53597138E-09_JPRB, 0.53596616E-09_JPRB, 0.53596733E-09_JPRB, 0.53596277E-09_JPRB, 0.53596916E-09_JPRB, &
  & 0.53596455E-09_JPRB, 0.53596544E-09_JPRB, 0.53595700E-09_JPRB, 0.53595511E-09_JPRB, 0.53596044E-09_JPRB, 0.53595567E-09_JPRB, &
  & 0.53595095E-09_JPRB, 0.53594873E-09_JPRB, 0.53593591E-09_JPRB, 0.53594662E-09_JPRB /)

RGHG6(:,91, 8) = (/ &
  & 0.53586613E-09_JPRB, 0.53587201E-09_JPRB, 0.53587829E-09_JPRB, 0.53588345E-09_JPRB, 0.53589799E-09_JPRB, 0.53590310E-09_JPRB, &
  & 0.53590893E-09_JPRB, 0.53591193E-09_JPRB, 0.53592397E-09_JPRB, 0.53591875E-09_JPRB, 0.53591787E-09_JPRB, 0.53593135E-09_JPRB, &
  & 0.53593024E-09_JPRB, 0.53593358E-09_JPRB, 0.53594362E-09_JPRB, 0.53593652E-09_JPRB, 0.53593491E-09_JPRB, 0.53593574E-09_JPRB, &
  & 0.53593313E-09_JPRB, 0.53592453E-09_JPRB, 0.53592530E-09_JPRB, 0.53591126E-09_JPRB, 0.53591942E-09_JPRB, 0.53591720E-09_JPRB, &
  & 0.53592991E-09_JPRB, 0.53592691E-09_JPRB, 0.53594090E-09_JPRB, 0.53595978E-09_JPRB, 0.53596105E-09_JPRB, 0.53597865E-09_JPRB, &
  & 0.53598181E-09_JPRB, 0.53598848E-09_JPRB, 0.53599075E-09_JPRB, 0.53599375E-09_JPRB, 0.53599858E-09_JPRB, 0.53599408E-09_JPRB, &
  & 0.53599797E-09_JPRB, 0.53599214E-09_JPRB, 0.53599586E-09_JPRB, 0.53598731E-09_JPRB, 0.53599752E-09_JPRB, 0.53599353E-09_JPRB, &
  & 0.53598043E-09_JPRB, 0.53597271E-09_JPRB, 0.53597721E-09_JPRB, 0.53597027E-09_JPRB, 0.53597182E-09_JPRB, 0.53597143E-09_JPRB, &
  & 0.53596722E-09_JPRB, 0.53597221E-09_JPRB, 0.53596566E-09_JPRB, 0.53596783E-09_JPRB, 0.53596183E-09_JPRB, 0.53597005E-09_JPRB, &
  & 0.53596427E-09_JPRB, 0.53596610E-09_JPRB, 0.53595656E-09_JPRB, 0.53595456E-09_JPRB, 0.53596105E-09_JPRB, 0.53595567E-09_JPRB, &
  & 0.53595078E-09_JPRB, 0.53594912E-09_JPRB, 0.53593491E-09_JPRB, 0.53594684E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART16',1,ZHOOK_HANDLE)
END SUBROUTINE PART16






SUBROUTINE PART17
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART17',0,ZHOOK_HANDLE)



!-- Month=  9 ------------

RGHG6(:, 1, 9) = (/ &
  & 0.28229158E-37_JPRB, 0.38234462E-37_JPRB, 0.61583816E-37_JPRB, 0.99963633E-37_JPRB, 0.15948223E-36_JPRB, 0.26005570E-36_JPRB, &
  & 0.43836266E-36_JPRB, 0.75907517E-36_JPRB, 0.13388180E-35_JPRB, 0.23874051E-35_JPRB, 0.42855727E-35_JPRB, 0.77020895E-35_JPRB, &
  & 0.13789166E-34_JPRB, 0.24455549E-34_JPRB, 0.42824909E-34_JPRB, 0.73916520E-34_JPRB, 0.12573707E-33_JPRB, 0.21127086E-33_JPRB, &
  & 0.35184598E-33_JPRB, 0.58467018E-33_JPRB, 0.97531620E-33_JPRB, 0.16367480E-32_JPRB, 0.27500121E-32_JPRB, 0.45743804E-32_JPRB, &
  & 0.73941276E-32_JPRB, 0.11526502E-31_JPRB, 0.17600029E-31_JPRB, 0.26851106E-31_JPRB, 0.38667146E-31_JPRB, 0.49616265E-31_JPRB, &
  & 0.58370189E-31_JPRB, 0.64749508E-31_JPRB, 0.69508850E-31_JPRB, 0.72422900E-31_JPRB, 0.73413907E-31_JPRB, 0.72099399E-31_JPRB, &
  & 0.68852660E-31_JPRB, 0.63311667E-31_JPRB, 0.55913852E-31_JPRB, 0.47417470E-31_JPRB, 0.37741192E-31_JPRB, 0.29801089E-31_JPRB, &
  & 0.22967263E-31_JPRB, 0.17134720E-31_JPRB, 0.12325962E-31_JPRB, 0.85257804E-32_JPRB, 0.56569358E-32_JPRB, 0.36096162E-32_JPRB, &
  & 0.22472690E-32_JPRB, 0.13720844E-32_JPRB, 0.83243881E-33_JPRB, 0.49941856E-33_JPRB, 0.29776007E-33_JPRB, 0.17788970E-33_JPRB, &
  & 0.10736922E-33_JPRB, 0.65615297E-34_JPRB, 0.41126306E-34_JPRB, 0.26624112E-34_JPRB, 0.17875720E-34_JPRB, 0.12432428E-34_JPRB, &
  & 0.87055789E-35_JPRB, 0.53941939E-35_JPRB, 0.24903042E-35_JPRB, 0.14868931E-35_JPRB /)

RGHG6(:, 2, 9) = (/ &
  & 0.11925867E-35_JPRB, 0.18486105E-35_JPRB, 0.29200335E-35_JPRB, 0.46068516E-35_JPRB, 0.73686843E-35_JPRB, 0.12088298E-34_JPRB, &
  & 0.20450914E-34_JPRB, 0.35403356E-34_JPRB, 0.62216494E-34_JPRB, 0.11028681E-33_JPRB, 0.19641386E-33_JPRB, 0.34955216E-33_JPRB, &
  & 0.61859968E-33_JPRB, 0.10831055E-32_JPRB, 0.18710349E-32_JPRB, 0.31853968E-32_JPRB, 0.53494614E-32_JPRB, 0.88889039E-32_JPRB, &
  & 0.14670211E-31_JPRB, 0.24184812E-31_JPRB, 0.40020457E-31_JPRB, 0.66617387E-31_JPRB, 0.11109130E-30_JPRB, 0.18395777E-30_JPRB, &
  & 0.29672129E-30_JPRB, 0.46336375E-30_JPRB, 0.70936213E-30_JPRB, 0.10723623E-29_JPRB, 0.15283447E-29_JPRB, 0.19628555E-29_JPRB, &
  & 0.23171324E-29_JPRB, 0.25795659E-29_JPRB, 0.27743448E-29_JPRB, 0.28909164E-29_JPRB, 0.29241471E-29_JPRB, 0.28643173E-29_JPRB, &
  & 0.27251521E-29_JPRB, 0.25021697E-29_JPRB, 0.22075491E-29_JPRB, 0.18727382E-29_JPRB, 0.15152817E-29_JPRB, 0.11914307E-29_JPRB, &
  & 0.91275773E-30_JPRB, 0.67946606E-30_JPRB, 0.48922932E-30_JPRB, 0.33991526E-30_JPRB, 0.22718488E-30_JPRB, 0.14627409E-30_JPRB, &
  & 0.91811545E-31_JPRB, 0.56428454E-31_JPRB, 0.34257776E-31_JPRB, 0.20571704E-31_JPRB, 0.12280473E-31_JPRB, 0.73391909E-32_JPRB, &
  & 0.44245820E-32_JPRB, 0.27005186E-32_JPRB, 0.16875970E-32_JPRB, 0.10886603E-32_JPRB, 0.72853678E-33_JPRB, 0.50438699E-33_JPRB, &
  & 0.35178413E-33_JPRB, 0.22561502E-33_JPRB, 0.11591837E-33_JPRB, 0.53897162E-34_JPRB /)

RGHG6(:, 3, 9) = (/ &
  & 0.29915947E-34_JPRB, 0.61500757E-34_JPRB, 0.10771013E-33_JPRB, 0.17820743E-33_JPRB, 0.29304372E-33_JPRB, 0.49722878E-33_JPRB, &
  & 0.87067636E-33_JPRB, 0.15587961E-32_JPRB, 0.28204802E-32_JPRB, 0.51235637E-32_JPRB, 0.93113494E-32_JPRB, 0.16825875E-31_JPRB, &
  & 0.30078408E-31_JPRB, 0.52916959E-31_JPRB, 0.91422004E-31_JPRB, 0.15510138E-30_JPRB, 0.25901294E-30_JPRB, 0.42760366E-30_JPRB, &
  & 0.70118746E-30_JPRB, 0.11490580E-29_JPRB, 0.18917661E-29_JPRB, 0.31385771E-29_JPRB, 0.52386592E-29_JPRB, 0.86929617E-29_JPRB, &
  & 0.14107410E-28_JPRB, 0.22108440E-28_JPRB, 0.33886677E-28_JPRB, 0.51127777E-28_JPRB, 0.72422531E-28_JPRB, 0.93042615E-28_JPRB, &
  & 0.11002490E-27_JPRB, 0.12287540E-27_JPRB, 0.13238297E-27_JPRB, 0.13807909E-27_JPRB, 0.13960233E-27_JPRB, 0.13659280E-27_JPRB, &
  & 0.12976306E-27_JPRB, 0.11901367E-27_JPRB, 0.10517040E-27_JPRB, 0.89388812E-28_JPRB, 0.72892404E-28_JPRB, 0.57149227E-28_JPRB, &
  & 0.43557307E-28_JPRB, 0.32145537E-28_JPRB, 0.22992444E-28_JPRB, 0.15911042E-28_JPRB, 0.10638327E-28_JPRB, 0.68833481E-29_JPRB, &
  & 0.43580488E-29_JPRB, 0.27035010E-29_JPRB, 0.16518250E-29_JPRB, 0.99626833E-30_JPRB, 0.59581050E-30_JPRB, 0.35611042E-30_JPRB, &
  & 0.21438800E-30_JPRB, 0.13046355E-30_JPRB, 0.81261701E-31_JPRB, 0.52245087E-31_JPRB, 0.34869950E-31_JPRB, 0.24133042E-31_JPRB, &
  & 0.17023712E-31_JPRB, 0.11112429E-31_JPRB, 0.57524594E-32_JPRB, 0.18651236E-32_JPRB /)

RGHG6(:, 4, 9) = (/ &
  & 0.13558898E-32_JPRB, 0.42284846E-32_JPRB, 0.83752114E-32_JPRB, 0.13964720E-31_JPRB, 0.23281444E-31_JPRB, 0.40240686E-31_JPRB, &
  & 0.72540644E-31_JPRB, 0.13349158E-30_JPRB, 0.24779113E-30_JPRB, 0.46023086E-30_JPRB, 0.85217002E-30_JPRB, 0.15628571E-29_JPRB, &
  & 0.28216382E-29_JPRB, 0.49868774E-29_JPRB, 0.86114738E-29_JPRB, 0.14543979E-28_JPRB, 0.24113269E-28_JPRB, 0.39467809E-28_JPRB, &
  & 0.64132938E-28_JPRB, 0.10413503E-27_JPRB, 0.17000515E-27_JPRB, 0.28014697E-27_JPRB, 0.46521021E-27_JPRB, 0.77243316E-27_JPRB, &
  & 0.12515555E-26_JPRB, 0.19629866E-26_JPRB, 0.30054164E-26_JPRB, 0.45146841E-26_JPRB, 0.63794792E-26_JPRB, 0.81851645E-26_JPRB, &
  & 0.96921754E-26_JPRB, 0.10842922E-25_JPRB, 0.11705878E-25_JPRB, 0.12232507E-25_JPRB, 0.12392496E-25_JPRB, 0.12147171E-25_JPRB, &
  & 0.11558701E-25_JPRB, 0.10619462E-25_JPRB, 0.93995743E-26_JPRB, 0.80333527E-26_JPRB, 0.65806700E-26_JPRB, 0.51842791E-26_JPRB, &
  & 0.39461180E-26_JPRB, 0.29079520E-26_JPRB, 0.20757521E-26_JPRB, 0.14376805E-26_JPRB, 0.96517738E-27_JPRB, 0.62922746E-27_JPRB, &
  & 0.40232513E-27_JPRB, 0.25199628E-27_JPRB, 0.15516227E-27_JPRB, 0.94007523E-28_JPRB, 0.56352855E-28_JPRB, 0.33689943E-28_JPRB, &
  & 0.20257732E-28_JPRB, 0.12312481E-28_JPRB, 0.76540180E-29_JPRB, 0.49150567E-29_JPRB, 0.32795645E-29_JPRB, 0.22748426E-29_JPRB, &
  & 0.16288242E-29_JPRB, 0.11188609E-29_JPRB, 0.61716148E-30_JPRB, 0.16844568E-30_JPRB /)

RGHG6(:, 5, 9) = (/ &
  & 0.30415928E-30_JPRB, 0.10005821E-29_JPRB, 0.18651896E-29_JPRB, 0.30309409E-29_JPRB, 0.50259154E-29_JPRB, 0.87361642E-29_JPRB, &
  & 0.15816739E-28_JPRB, 0.29266594E-28_JPRB, 0.54458462E-28_JPRB, 0.10123523E-27_JPRB, 0.18741179E-27_JPRB, 0.34290099E-27_JPRB, &
  & 0.61580623E-27_JPRB, 0.10784734E-26_JPRB, 0.18381740E-26_JPRB, 0.30539679E-26_JPRB, 0.49694358E-26_JPRB, 0.79714556E-26_JPRB, &
  & 0.12685871E-25_JPRB, 0.20170551E-25_JPRB, 0.32245146E-25_JPRB, 0.52082797E-25_JPRB, 0.84991510E-25_JPRB, 0.13873454E-24_JPRB, &
  & 0.22220597E-24_JPRB, 0.34410487E-24_JPRB, 0.52131390E-24_JPRB, 0.77620546E-24_JPRB, 0.10886671E-23_JPRB, 0.13915005E-23_JPRB, &
  & 0.16457831E-23_JPRB, 0.18421575E-23_JPRB, 0.19933056E-23_JPRB, 0.20915130E-23_JPRB, 0.21322463E-23_JPRB, 0.21069996E-23_JPRB, &
  & 0.20234860E-23_JPRB, 0.18775765E-23_JPRB, 0.16805313E-23_JPRB, 0.14548178E-23_JPRB, 0.12116057E-23_JPRB, 0.96957711E-24_JPRB, &
  & 0.75023399E-24_JPRB, 0.56121433E-24_JPRB, 0.40698414E-24_JPRB, 0.28671899E-24_JPRB, 0.19604421E-24_JPRB, 0.13028812E-24_JPRB, &
  & 0.84918941E-25_JPRB, 0.54148127E-25_JPRB, 0.33849602E-25_JPRB, 0.20764187E-25_JPRB, 0.12562541E-25_JPRB, 0.75614798E-26_JPRB, &
  & 0.45721126E-26_JPRB, 0.27887362E-26_JPRB, 0.17404209E-26_JPRB, 0.11204722E-26_JPRB, 0.74919296E-27_JPRB, 0.52121741E-27_JPRB, &
  & 0.37741737E-27_JPRB, 0.27384473E-27_JPRB, 0.17885518E-27_JPRB, 0.71077666E-28_JPRB /)

RGHG6(:, 6, 9) = (/ &
  & 0.25067500E-27_JPRB, 0.61561787E-27_JPRB, 0.10379222E-26_JPRB, 0.16543996E-26_JPRB, 0.27246008E-26_JPRB, 0.46769102E-26_JPRB, &
  & 0.83202254E-26_JPRB, 0.15023508E-25_JPRB, 0.27208232E-25_JPRB, 0.49146629E-25_JPRB, 0.88235152E-25_JPRB, 0.15631497E-24_JPRB, &
  & 0.27122201E-24_JPRB, 0.45775814E-24_JPRB, 0.74999126E-24_JPRB, 0.11953126E-23_JPRB, 0.18632520E-23_JPRB, 0.28617519E-23_JPRB, &
  & 0.43602109E-23_JPRB, 0.66408851E-23_JPRB, 0.10181181E-22_JPRB, 0.15801057E-22_JPRB, 0.24837349E-22_JPRB, 0.39223351E-22_JPRB, &
  & 0.60904271E-22_JPRB, 0.91888822E-22_JPRB, 0.13606041E-21_JPRB, 0.19870554E-21_JPRB, 0.27475551E-21_JPRB, 0.34796834E-21_JPRB, &
  & 0.40946162E-21_JPRB, 0.45808751E-21_JPRB, 0.49710218E-21_JPRB, 0.52526479E-21_JPRB, 0.54160458E-21_JPRB, 0.54354203E-21_JPRB, &
  & 0.53225952E-21_JPRB, 0.50504253E-21_JPRB, 0.46374782E-21_JPRB, 0.41353767E-21_JPRB, 0.35612309E-21_JPRB, 0.29566603E-21_JPRB, &
  & 0.23796038E-21_JPRB, 0.18538819E-21_JPRB, 0.14027415E-21_JPRB, 0.10320540E-21_JPRB, 0.73753074E-22_JPRB, 0.51232855E-22_JPRB, &
  & 0.34881473E-22_JPRB, 0.23192954E-22_JPRB, 0.15082860E-22_JPRB, 0.95922236E-23_JPRB, 0.59938744E-23_JPRB, 0.37120485E-23_JPRB, &
  & 0.22987221E-23_JPRB, 0.14319048E-23_JPRB, 0.90813460E-24_JPRB, 0.59264019E-24_JPRB, 0.40018948E-24_JPRB, 0.28051292E-24_JPRB, &
  & 0.20456736E-24_JPRB, 0.15219900E-24_JPRB, 0.11072621E-24_JPRB, 0.60010584E-25_JPRB /)

RGHG6(:, 7, 9) = (/ &
  & 0.24300732E-24_JPRB, 0.53268395E-24_JPRB, 0.87108565E-24_JPRB, 0.13556356E-23_JPRB, 0.21851893E-23_JPRB, 0.36244901E-23_JPRB, &
  & 0.61784217E-23_JPRB, 0.10632516E-22_JPRB, 0.18301926E-22_JPRB, 0.31319778E-22_JPRB, 0.53185671E-22_JPRB, 0.88958544E-22_JPRB, &
  & 0.14555759E-21_JPRB, 0.23146840E-21_JPRB, 0.35713157E-21_JPRB, 0.53597487E-21_JPRB, 0.78713803E-21_JPRB, 0.11398697E-20_JPRB, &
  & 0.16397767E-20_JPRB, 0.23617198E-20_JPRB, 0.34328658E-20_JPRB, 0.50671121E-20_JPRB, 0.76069250E-20_JPRB, 0.11523259E-19_JPRB, &
  & 0.17238618E-19_JPRB, 0.25168297E-19_JPRB, 0.36210448E-19_JPRB, 0.51676416E-19_JPRB, 0.70189248E-19_JPRB, 0.87792776E-19_JPRB, &
  & 0.10264090E-18_JPRB, 0.11465001E-18_JPRB, 0.12485469E-18_JPRB, 0.13301161E-18_JPRB, 0.13898255E-18_JPRB, 0.14208397E-18_JPRB, &
  & 0.14244683E-18_JPRB, 0.13904977E-18_JPRB, 0.13194872E-18_JPRB, 0.12220675E-18_JPRB, 0.10980384E-18_JPRB, 0.95582510E-19_JPRB, &
  & 0.80903337E-19_JPRB, 0.66542796E-19_JPRB, 0.53255361E-19_JPRB, 0.41531918E-19_JPRB, 0.31495173E-19_JPRB, 0.23236209E-19_JPRB, &
  & 0.16807257E-19_JPRB, 0.11869247E-19_JPRB, 0.81869264E-20_JPRB, 0.55093282E-20_JPRB, 0.36304618E-20_JPRB, 0.23594620E-20_JPRB, &
  & 0.15261788E-20_JPRB, 0.98577089E-21_JPRB, 0.64523814E-21_JPRB, 0.43156886E-21_JPRB, 0.29729247E-21_JPRB, 0.21147025E-21_JPRB, &
  & 0.15614208E-21_JPRB, 0.11705253E-21_JPRB, 0.87184749E-22_JPRB, 0.50068614E-22_JPRB /)

RGHG6(:, 8, 9) = (/ &
  & 0.20845704E-21_JPRB, 0.44252103E-21_JPRB, 0.69981196E-21_JPRB, 0.10673714E-20_JPRB, 0.16617424E-20_JPRB, 0.26507524E-20_JPRB, &
  & 0.43122816E-20_JPRB, 0.70595536E-20_JPRB, 0.11505669E-19_JPRB, 0.18596224E-19_JPRB, 0.29714344E-19_JPRB, 0.46657972E-19_JPRB, &
  & 0.71556209E-19_JPRB, 0.10658738E-18_JPRB, 0.15407990E-18_JPRB, 0.21683087E-18_JPRB, 0.29894302E-18_JPRB, 0.40703986E-18_JPRB, &
  & 0.55145272E-18_JPRB, 0.74973428E-18_JPRB, 0.10312427E-17_JPRB, 0.14458435E-17_JPRB, 0.20704310E-17_JPRB, 0.30044352E-17_JPRB, &
  & 0.43258105E-17_JPRB, 0.60989271E-17_JPRB, 0.85220613E-17_JPRB, 0.11868546E-16_JPRB, 0.15828432E-16_JPRB, 0.19552153E-16_JPRB, &
  & 0.22697538E-16_JPRB, 0.25325294E-16_JPRB, 0.27683211E-16_JPRB, 0.29752386E-16_JPRB, 0.31520227E-16_JPRB, 0.32841866E-16_JPRB, &
  & 0.33731744E-16_JPRB, 0.33907688E-16_JPRB, 0.33303661E-16_JPRB, 0.32088963E-16_JPRB, 0.30149380E-16_JPRB, 0.27556508E-16_JPRB, &
  & 0.24603804E-16_JPRB, 0.21400048E-16_JPRB, 0.18161225E-16_JPRB, 0.15043749E-16_JPRB, 0.12128621E-16_JPRB, 0.95205229E-17_JPRB, &
  & 0.73326203E-17_JPRB, 0.55120938E-17_JPRB, 0.40437816E-17_JPRB, 0.28880343E-17_JPRB, 0.20126425E-17_JPRB, 0.13774791E-17_JPRB, &
  & 0.93218974E-18_JPRB, 0.62658559E-18_JPRB, 0.42348328E-18_JPRB, 0.29093845E-18_JPRB, 0.20456953E-18_JPRB, 0.14788516E-18_JPRB, &
  & 0.11037912E-18_JPRB, 0.83558716E-19_JPRB, 0.62541355E-19_JPRB, 0.36332823E-19_JPRB /)

RGHG6(:, 9, 9) = (/ &
  & 0.15108215E-18_JPRB, 0.30821623E-18_JPRB, 0.47704633E-18_JPRB, 0.71039765E-18_JPRB, 0.10738424E-17_JPRB, 0.16546067E-17_JPRB, &
  & 0.25883904E-17_JPRB, 0.40522801E-17_JPRB, 0.62936533E-17_JPRB, 0.96394682E-17_JPRB, 0.14536578E-16_JPRB, 0.21457480E-16_JPRB, &
  & 0.30853827E-16_JPRB, 0.43037896E-16_JPRB, 0.58261341E-16_JPRB, 0.76846283E-16_JPRB, 0.99435944E-16_JPRB, 0.12727004E-15_JPRB, &
  & 0.16239185E-15_JPRB, 0.20836426E-15_JPRB, 0.27123864E-15_JPRB, 0.36101222E-15_JPRB, 0.49267290E-15_JPRB, 0.68433470E-15_JPRB, &
  & 0.94628869E-15_JPRB, 0.12876719E-14_JPRB, 0.17443469E-14_JPRB, 0.23707546E-14_JPRB, 0.31039662E-14_JPRB, 0.37854944E-14_JPRB, &
  & 0.43649459E-14_JPRB, 0.48643285E-14_JPRB, 0.53399083E-14_JPRB, 0.57921439E-14_JPRB, 0.62251501E-14_JPRB, 0.66133876E-14_JPRB, &
  & 0.69613449E-14_JPRB, 0.72088408E-14_JPRB, 0.73328252E-14_JPRB, 0.73562643E-14_JPRB, 0.72325992E-14_JPRB, 0.69513504E-14_JPRB, &
  & 0.65510024E-14_JPRB, 0.60342801E-14_JPRB, 0.54355675E-14_JPRB, 0.47848641E-14_JPRB, 0.41031699E-14_JPRB, 0.34262836E-14_JPRB, &
  & 0.28079221E-14_JPRB, 0.22446428E-14_JPRB, 0.17484028E-14_JPRB, 0.13222000E-14_JPRB, 0.97208593E-15_JPRB, 0.69815240E-15_JPRB, &
  & 0.49323666E-15_JPRB, 0.34351675E-15_JPRB, 0.23924303E-15_JPRB, 0.16819238E-15_JPRB, 0.12038202E-15_JPRB, 0.88131965E-16_JPRB, &
  & 0.66333771E-16_JPRB, 0.50563175E-16_JPRB, 0.37904589E-16_JPRB, 0.22215778E-16_JPRB /)

RGHG6(:,10, 9) = (/ &
  & 0.89260127E-16_JPRB, 0.17498819E-15_JPRB, 0.26837807E-15_JPRB, 0.38921969E-15_JPRB, 0.57824472E-15_JPRB, 0.86516491E-15_JPRB, &
  & 0.13113345E-14_JPRB, 0.19784583E-14_JPRB, 0.29430236E-14_JPRB, 0.42944685E-14_JPRB, 0.61349512E-14_JPRB, 0.85367504E-14_JPRB, &
  & 0.11531008E-13_JPRB, 0.15078733E-13_JPRB, 0.19126966E-13_JPRB, 0.23652033E-13_JPRB, 0.28723877E-13_JPRB, 0.34556091E-13_JPRB, &
  & 0.41515165E-13_JPRB, 0.50260164E-13_JPRB, 0.61880121E-13_JPRB, 0.78129770E-13_JPRB, 0.10149787E-12_JPRB, 0.13468735E-12_JPRB, &
  & 0.17866306E-12_JPRB, 0.23419515E-12_JPRB, 0.30741268E-12_JPRB, 0.40741098E-12_JPRB, 0.52347612E-12_JPRB, 0.63030120E-12_JPRB, &
  & 0.72161813E-12_JPRB, 0.80331748E-12_JPRB, 0.88566182E-12_JPRB, 0.96998451E-12_JPRB, 0.10579930E-11_JPRB, 0.11466366E-11_JPRB, &
  & 0.12374675E-11_JPRB, 0.13208050E-11_JPRB, 0.13921947E-11_JPRB, 0.14550093E-11_JPRB, 0.14980007E-11_JPRB, 0.15146965E-11_JPRB, &
  & 0.15079394E-11_JPRB, 0.14720626E-11_JPRB, 0.14084488E-11_JPRB, 0.13191184E-11_JPRB, 0.12038288E-11_JPRB, 0.10697966E-11_JPRB, &
  & 0.93282044E-12_JPRB, 0.79219660E-12_JPRB, 0.65414536E-12_JPRB, 0.52262291E-12_JPRB, 0.40408088E-12_JPRB, 0.30368435E-12_JPRB, &
  & 0.22306855E-12_JPRB, 0.16056399E-12_JPRB, 0.11477248E-12_JPRB, 0.82332029E-13_JPRB, 0.59776538E-13_JPRB, 0.44156827E-13_JPRB, &
  & 0.33483226E-13_JPRB, 0.25476017E-13_JPRB, 0.19301358E-13_JPRB, 0.11200199E-13_JPRB /)

RGHG6(:,11, 9) = (/ &
  & 0.74818134E-15_JPRB, 0.13468141E-14_JPRB, 0.18607577E-14_JPRB, 0.25777661E-14_JPRB, 0.35417442E-14_JPRB, 0.50282641E-14_JPRB, &
  & 0.72053654E-14_JPRB, 0.10357902E-13_JPRB, 0.14747104E-13_JPRB, 0.20640341E-13_JPRB, 0.28305019E-13_JPRB, 0.37873814E-13_JPRB, &
  & 0.49268688E-13_JPRB, 0.62223731E-13_JPRB, 0.76523098E-13_JPRB, 0.92031688E-13_JPRB, 0.10893032E-12_JPRB, 0.12797798E-12_JPRB, &
  & 0.15031838E-12_JPRB, 0.17788735E-12_JPRB, 0.21402235E-12_JPRB, 0.26433998E-12_JPRB, 0.33729969E-12_JPRB, 0.44355321E-12_JPRB, &
  & 0.59280380E-12_JPRB, 0.78920280E-12_JPRB, 0.10268465E-11_JPRB, 0.12856292E-11_JPRB, 0.15736481E-11_JPRB, 0.19324499E-11_JPRB, &
  & 0.23533944E-11_JPRB, 0.27827575E-11_JPRB, 0.32077084E-11_JPRB, 0.36042445E-11_JPRB, 0.39545606E-11_JPRB, 0.42398775E-11_JPRB, &
  & 0.44610088E-11_JPRB, 0.45870439E-11_JPRB, 0.46521467E-11_JPRB, 0.46248803E-11_JPRB, 0.45299845E-11_JPRB, 0.43801295E-11_JPRB, &
  & 0.41720806E-11_JPRB, 0.39171643E-11_JPRB, 0.36141760E-11_JPRB, 0.32743586E-11_JPRB, 0.29137864E-11_JPRB, 0.25421332E-11_JPRB, &
  & 0.21720605E-11_JPRB, 0.18220982E-11_JPRB, 0.15048655E-11_JPRB, 0.12219110E-11_JPRB, 0.97833861E-12_JPRB, 0.77602383E-12_JPRB, &
  & 0.61235207E-12_JPRB, 0.48389851E-12_JPRB, 0.38496178E-12_JPRB, 0.30954517E-12_JPRB, 0.25197186E-12_JPRB, 0.20859214E-12_JPRB, &
  & 0.17422858E-12_JPRB, 0.14839289E-12_JPRB, 0.12128288E-12_JPRB, 0.87014041E-13_JPRB /)

RGHG6(:,12, 9) = (/ &
  & 0.41789556E-14_JPRB, 0.68081866E-14_JPRB, 0.93285712E-14_JPRB, 0.12140804E-13_JPRB, 0.16264420E-13_JPRB, 0.21967440E-13_JPRB, &
  & 0.30313615E-13_JPRB, 0.42012262E-13_JPRB, 0.57945422E-13_JPRB, 0.78880397E-13_JPRB, 0.10554360E-12_JPRB, 0.13813622E-12_JPRB, &
  & 0.17611917E-12_JPRB, 0.21851813E-12_JPRB, 0.26435619E-12_JPRB, 0.31222757E-12_JPRB, 0.36281779E-12_JPRB, 0.41650835E-12_JPRB, &
  & 0.47504996E-12_JPRB, 0.54238385E-12_JPRB, 0.62510582E-12_JPRB, 0.73385335E-12_JPRB, 0.88500160E-12_JPRB, 0.11010393E-11_JPRB, &
  & 0.14055857E-11_JPRB, 0.18196013E-11_JPRB, 0.23624052E-11_JPRB, 0.30601043E-11_JPRB, 0.39201697E-11_JPRB, 0.49131667E-11_JPRB, &
  & 0.60023631E-11_JPRB, 0.71529436E-11_JPRB, 0.83218094E-11_JPRB, 0.94191582E-11_JPRB, 0.10355771E-10_JPRB, 0.11084165E-10_JPRB, &
  & 0.11553892E-10_JPRB, 0.11738071E-10_JPRB, 0.11670194E-10_JPRB, 0.11338023E-10_JPRB, 0.10844966E-10_JPRB, 0.10209436E-10_JPRB, &
  & 0.94833273E-11_JPRB, 0.86882203E-11_JPRB, 0.78427846E-11_JPRB, 0.69728294E-11_JPRB, 0.61053862E-11_JPRB, 0.52649833E-11_JPRB, &
  & 0.44876672E-11_JPRB, 0.37901826E-11_JPRB, 0.31826132E-11_JPRB, 0.26611883E-11_JPRB, 0.22231435E-11_JPRB, 0.18633474E-11_JPRB, &
  & 0.15748115E-11_JPRB, 0.13479677E-11_JPRB, 0.11728726E-11_JPRB, 0.10358233E-11_JPRB, 0.92749755E-12_JPRB, 0.83591077E-12_JPRB, &
  & 0.75642135E-12_JPRB, 0.68353586E-12_JPRB, 0.60426409E-12_JPRB, 0.46516648E-12_JPRB /)

RGHG6(:,13, 9) = (/ &
  & 0.19501550E-13_JPRB, 0.32724925E-13_JPRB, 0.43280843E-13_JPRB, 0.56673043E-13_JPRB, 0.73704226E-13_JPRB, 0.98208964E-13_JPRB, &
  & 0.13243853E-12_JPRB, 0.18000961E-12_JPRB, 0.24400355E-12_JPRB, 0.32725713E-12_JPRB, 0.43209994E-12_JPRB, 0.55865306E-12_JPRB, &
  & 0.70438322E-12_JPRB, 0.86396510E-12_JPRB, 0.10317745E-11_JPRB, 0.12027386E-11_JPRB, 0.13712382E-11_JPRB, 0.15347089E-11_JPRB, &
  & 0.16955955E-11_JPRB, 0.18590218E-11_JPRB, 0.20347077E-11_JPRB, 0.22369188E-11_JPRB, 0.24890047E-11_JPRB, 0.28300051E-11_JPRB, &
  & 0.33081034E-11_JPRB, 0.39746908E-11_JPRB, 0.48788005E-11_JPRB, 0.60686716E-11_JPRB, 0.75818934E-11_JPRB, 0.94408743E-11_JPRB, &
  & 0.11647291E-10_JPRB, 0.14028877E-10_JPRB, 0.16466247E-10_JPRB, 0.18763680E-10_JPRB, 0.20765343E-10_JPRB, 0.22303140E-10_JPRB, &
  & 0.23247643E-10_JPRB, 0.23566647E-10_JPRB, 0.23306104E-10_JPRB, 0.22538105E-10_JPRB, 0.21398126E-10_JPRB, 0.20002947E-10_JPRB, &
  & 0.18416511E-10_JPRB, 0.16725650E-10_JPRB, 0.14986909E-10_JPRB, 0.13259078E-10_JPRB, 0.11601818E-10_JPRB, 0.10074482E-10_JPRB, &
  & 0.87084281E-11_JPRB, 0.75313054E-11_JPRB, 0.65406179E-11_JPRB, 0.57191513E-11_JPRB, 0.50535166E-11_JPRB, 0.45306025E-11_JPRB, &
  & 0.41311828E-11_JPRB, 0.38318901E-11_JPRB, 0.36118031E-11_JPRB, 0.34418410E-11_JPRB, 0.33020273E-11_JPRB, 0.31687719E-11_JPRB, &
  & 0.30209914E-11_JPRB, 0.28655956E-11_JPRB, 0.26185180E-11_JPRB, 0.22133853E-11_JPRB /)

RGHG6(:,14, 9) = (/ &
  & 0.80853184E-13_JPRB, 0.13477269E-12_JPRB, 0.18066036E-12_JPRB, 0.23279447E-12_JPRB, 0.30193366E-12_JPRB, 0.39572935E-12_JPRB, &
  & 0.52575278E-12_JPRB, 0.70314344E-12_JPRB, 0.93869162E-12_JPRB, 0.12412893E-11_JPRB, 0.16172109E-11_JPRB, 0.20638883E-11_JPRB, &
  & 0.25699046E-11_JPRB, 0.31132375E-11_JPRB, 0.36695087E-11_JPRB, 0.42185721E-11_JPRB, 0.47424473E-11_JPRB, 0.52232693E-11_JPRB, &
  & 0.56581727E-11_JPRB, 0.60544564E-11_JPRB, 0.64217429E-11_JPRB, 0.67760693E-11_JPRB, 0.71488336E-11_JPRB, 0.75976820E-11_JPRB, &
  & 0.82062464E-11_JPRB, 0.90747063E-11_JPRB, 0.10319151E-10_JPRB, 0.12046211E-10_JPRB, 0.14359335E-10_JPRB, 0.17280425E-10_JPRB, &
  & 0.20705214E-10_JPRB, 0.24540727E-10_JPRB, 0.28554553E-10_JPRB, 0.32424383E-10_JPRB, 0.35787717E-10_JPRB, 0.38345313E-10_JPRB, &
  & 0.39967456E-10_JPRB, 0.40593202E-10_JPRB, 0.40262949E-10_JPRB, 0.39095199E-10_JPRB, 0.37257326E-10_JPRB, 0.34926419E-10_JPRB, &
  & 0.32260049E-10_JPRB, 0.29381515E-10_JPRB, 0.26434367E-10_JPRB, 0.23547594E-10_JPRB, 0.20844068E-10_JPRB, 0.18426172E-10_JPRB, &
  & 0.16358560E-10_JPRB, 0.14641082E-10_JPRB, 0.13248104E-10_JPRB, 0.12145168E-10_JPRB, 0.11299075E-10_JPRB, 0.10674911E-10_JPRB, &
  & 0.10236001E-10_JPRB, 0.99394338E-11_JPRB, 0.97510238E-11_JPRB, 0.96264038E-11_JPRB, 0.95187564E-11_JPRB, 0.94129470E-11_JPRB, &
  & 0.92144053E-11_JPRB, 0.90116734E-11_JPRB, 0.85279735E-11_JPRB, 0.76490949E-11_JPRB /)

RGHG6(:,15, 9) = (/ &
  & 0.28076190E-12_JPRB, 0.46713940E-12_JPRB, 0.62074949E-12_JPRB, 0.79145739E-12_JPRB, 0.10105342E-11_JPRB, 0.13011365E-11_JPRB, &
  & 0.16957640E-11_JPRB, 0.22247512E-11_JPRB, 0.29182603E-11_JPRB, 0.37988293E-11_JPRB, 0.48794298E-11_JPRB, 0.61474931E-11_JPRB, &
  & 0.75632677E-11_JPRB, 0.90610922E-11_JPRB, 0.10566195E-10_JPRB, 0.12017702E-10_JPRB, 0.13383293E-10_JPRB, 0.14625938E-10_JPRB, &
  & 0.15727541E-10_JPRB, 0.16697404E-10_JPRB, 0.17547273E-10_JPRB, 0.18280339E-10_JPRB, 0.18918606E-10_JPRB, 0.19537375E-10_JPRB, &
  & 0.20261952E-10_JPRB, 0.21235274E-10_JPRB, 0.22636119E-10_JPRB, 0.24691015E-10_JPRB, 0.27556657E-10_JPRB, 0.31322816E-10_JPRB, &
  & 0.35887446E-10_JPRB, 0.40954250E-10_JPRB, 0.46346364E-10_JPRB, 0.51573780E-10_JPRB, 0.56177438E-10_JPRB, 0.59863281E-10_JPRB, &
  & 0.62348508E-10_JPRB, 0.63528377E-10_JPRB, 0.63453916E-10_JPRB, 0.62229395E-10_JPRB, 0.59991415E-10_JPRB, 0.56915528E-10_JPRB, &
  & 0.53193696E-10_JPRB, 0.49056627E-10_JPRB, 0.44745204E-10_JPRB, 0.40521017E-10_JPRB, 0.36625269E-10_JPRB, 0.33232288E-10_JPRB, &
  & 0.30408891E-10_JPRB, 0.28136464E-10_JPRB, 0.26351149E-10_JPRB, 0.24979825E-10_JPRB, 0.23953823E-10_JPRB, 0.23215926E-10_JPRB, &
  & 0.22709669E-10_JPRB, 0.22379348E-10_JPRB, 0.22183829E-10_JPRB, 0.22065159E-10_JPRB, 0.21966035E-10_JPRB, 0.21853856E-10_JPRB, &
  & 0.21607291E-10_JPRB, 0.21350569E-10_JPRB, 0.20594146E-10_JPRB, 0.19213769E-10_JPRB /)

RGHG6(:,16, 9) = (/ &
  & 0.85156377E-12_JPRB, 0.14012715E-11_JPRB, 0.18053201E-11_JPRB, 0.22536443E-11_JPRB, 0.27944810E-11_JPRB, 0.35060852E-11_JPRB, &
  & 0.44494347E-11_JPRB, 0.57012554E-11_JPRB, 0.73277755E-11_JPRB, 0.93826310E-11_JPRB, 0.11890936E-10_JPRB, 0.14822069E-10_JPRB, &
  & 0.18079085E-10_JPRB, 0.21506612E-10_JPRB, 0.24936622E-10_JPRB, 0.28222289E-10_JPRB, 0.31281443E-10_JPRB, 0.34079420E-10_JPRB, &
  & 0.36581752E-10_JPRB, 0.38804127E-10_JPRB, 0.40769686E-10_JPRB, 0.42472841E-10_JPRB, 0.43911971E-10_JPRB, 0.45120255E-10_JPRB, &
  & 0.46227681E-10_JPRB, 0.47430074E-10_JPRB, 0.48874592E-10_JPRB, 0.50821847E-10_JPRB, 0.53603309E-10_JPRB, 0.57351731E-10_JPRB, &
  & 0.62015268E-10_JPRB, 0.67339585E-10_JPRB, 0.73070730E-10_JPRB, 0.78635591E-10_JPRB, 0.83686259E-10_JPRB, 0.87800330E-10_JPRB, &
  & 0.90799750E-10_JPRB, 0.92663120E-10_JPRB, 0.93350515E-10_JPRB, 0.92827732E-10_JPRB, 0.91059701E-10_JPRB, 0.88059109E-10_JPRB, &
  & 0.83948168E-10_JPRB, 0.78979323E-10_JPRB, 0.73552046E-10_JPRB, 0.68116179E-10_JPRB, 0.63094779E-10_JPRB, 0.58758498E-10_JPRB, &
  & 0.55190623E-10_JPRB, 0.52338078E-10_JPRB, 0.50072588E-10_JPRB, 0.48263511E-10_JPRB, 0.46808203E-10_JPRB, 0.45636644E-10_JPRB, &
  & 0.44700511E-10_JPRB, 0.43962889E-10_JPRB, 0.43402636E-10_JPRB, 0.42968875E-10_JPRB, 0.42606325E-10_JPRB, 0.42251484E-10_JPRB, &
  & 0.41813813E-10_JPRB, 0.41286061E-10_JPRB, 0.40171672E-10_JPRB, 0.38103694E-10_JPRB /)

RGHG6(:,17, 9) = (/ &
  & 0.24580403E-11_JPRB, 0.38082610E-11_JPRB, 0.47210426E-11_JPRB, 0.56322134E-11_JPRB, 0.67115384E-11_JPRB, 0.80851532E-11_JPRB, &
  & 0.99002430E-11_JPRB, 0.12296803E-10_JPRB, 0.15407012E-10_JPRB, 0.19331786E-10_JPRB, 0.24118020E-10_JPRB, 0.29691527E-10_JPRB, &
  & 0.35860519E-10_JPRB, 0.42324231E-10_JPRB, 0.48769919E-10_JPRB, 0.54949427E-10_JPRB, 0.60708369E-10_JPRB, 0.66018052E-10_JPRB, &
  & 0.70883140E-10_JPRB, 0.75335869E-10_JPRB, 0.79498720E-10_JPRB, 0.83380844E-10_JPRB, 0.86844344E-10_JPRB, 0.89739251E-10_JPRB, &
  & 0.92015597E-10_JPRB, 0.93808808E-10_JPRB, 0.95490560E-10_JPRB, 0.97133510E-10_JPRB, 0.98848735E-10_JPRB, 0.10115108E-09_JPRB, &
  & 0.10413320E-09_JPRB, 0.10758387E-09_JPRB, 0.11133194E-09_JPRB, 0.11503209E-09_JPRB, 0.11855456E-09_JPRB, 0.12179302E-09_JPRB, &
  & 0.12476285E-09_JPRB, 0.12728428E-09_JPRB, 0.12918436E-09_JPRB, 0.13018520E-09_JPRB, 0.12998032E-09_JPRB, 0.12829887E-09_JPRB, &
  & 0.12505391E-09_JPRB, 0.12041658E-09_JPRB, 0.11481910E-09_JPRB, 0.10887520E-09_JPRB, 0.10318135E-09_JPRB, 0.98139386E-10_JPRB, &
  & 0.93875491E-10_JPRB, 0.90297887E-10_JPRB, 0.87233762E-10_JPRB, 0.84521570E-10_JPRB, 0.82053822E-10_JPRB, 0.79792575E-10_JPRB, &
  & 0.77749855E-10_JPRB, 0.75954638E-10_JPRB, 0.74437227E-10_JPRB, 0.73172662E-10_JPRB, 0.72111109E-10_JPRB, 0.71171798E-10_JPRB, &
  & 0.70267972E-10_JPRB, 0.69179933E-10_JPRB, 0.67689007E-10_JPRB, 0.64340686E-10_JPRB /)

RGHG6(:,18, 9) = (/ &
  & 0.69093837E-11_JPRB, 0.97506361E-11_JPRB, 0.11391013E-10_JPRB, 0.12829823E-10_JPRB, 0.14478399E-10_JPRB, 0.16566842E-10_JPRB, &
  & 0.19359674E-10_JPRB, 0.23103739E-10_JPRB, 0.28007572E-10_JPRB, 0.34223138E-10_JPRB, 0.41794797E-10_JPRB, 0.50577535E-10_JPRB, &
  & 0.60220710E-10_JPRB, 0.70252817E-10_JPRB, 0.80192956E-10_JPRB, 0.89695695E-10_JPRB, 0.98591801E-10_JPRB, 0.10685275E-09_JPRB, &
  & 0.11460007E-09_JPRB, 0.12193201E-09_JPRB, 0.12895220E-09_JPRB, 0.13572410E-09_JPRB, 0.14216754E-09_JPRB, 0.14808212E-09_JPRB, &
  & 0.15314197E-09_JPRB, 0.15698721E-09_JPRB, 0.15948057E-09_JPRB, 0.16089277E-09_JPRB, 0.16156872E-09_JPRB, 0.16147264E-09_JPRB, &
  & 0.16086822E-09_JPRB, 0.15998050E-09_JPRB, 0.15941609E-09_JPRB, 0.15937877E-09_JPRB, 0.15986823E-09_JPRB, 0.16098073E-09_JPRB, &
  & 0.16284626E-09_JPRB, 0.16546869E-09_JPRB, 0.16847235E-09_JPRB, 0.17126220E-09_JPRB, 0.17319635E-09_JPRB, 0.17370028E-09_JPRB, &
  & 0.17242545E-09_JPRB, 0.16936118E-09_JPRB, 0.16484786E-09_JPRB, 0.15947216E-09_JPRB, 0.15388379E-09_JPRB, 0.14856519E-09_JPRB, &
  & 0.14370076E-09_JPRB, 0.13924842E-09_JPRB, 0.13505451E-09_JPRB, 0.13098593E-09_JPRB, 0.12698613E-09_JPRB, 0.12310211E-09_JPRB, &
  & 0.11945429E-09_JPRB, 0.11615724E-09_JPRB, 0.11329368E-09_JPRB, 0.11086380E-09_JPRB, 0.10881826E-09_JPRB, 0.10706516E-09_JPRB, &
  & 0.10546954E-09_JPRB, 0.10377828E-09_JPRB, 0.10163159E-09_JPRB, 0.97043762E-10_JPRB /)

RGHG6(:,19, 9) = (/ &
  & 0.17763796E-10_JPRB, 0.22581740E-10_JPRB, 0.24570184E-10_JPRB, 0.26169488E-10_JPRB, 0.27938138E-10_JPRB, 0.30328122E-10_JPRB, &
  & 0.33749403E-10_JPRB, 0.38551586E-10_JPRB, 0.45011585E-10_JPRB, 0.53304416E-10_JPRB, 0.63431004E-10_JPRB, 0.75116732E-10_JPRB, &
  & 0.87851622E-10_JPRB, 0.10093285E-09_JPRB, 0.11375338E-09_JPRB, 0.12586657E-09_JPRB, 0.13709701E-09_JPRB, 0.14750438E-09_JPRB, &
  & 0.15726349E-09_JPRB, 0.16665527E-09_JPRB, 0.17581932E-09_JPRB, 0.18488441E-09_JPRB, 0.19386767E-09_JPRB, 0.20257197E-09_JPRB, &
  & 0.21054163E-09_JPRB, 0.21712711E-09_JPRB, 0.22173736E-09_JPRB, 0.22404482E-09_JPRB, 0.22412962E-09_JPRB, 0.22234091E-09_JPRB, &
  & 0.21912566E-09_JPRB, 0.21490022E-09_JPRB, 0.21046050E-09_JPRB, 0.20649846E-09_JPRB, 0.20386587E-09_JPRB, 0.20277127E-09_JPRB, &
  & 0.20319756E-09_JPRB, 0.20525277E-09_JPRB, 0.20872007E-09_JPRB, 0.21276364E-09_JPRB, 0.21644957E-09_JPRB, 0.21899067E-09_JPRB, &
  & 0.21982259E-09_JPRB, 0.21875275E-09_JPRB, 0.21593972E-09_JPRB, 0.21180291E-09_JPRB, 0.20689706E-09_JPRB, 0.20169365E-09_JPRB, &
  & 0.19645550E-09_JPRB, 0.19121923E-09_JPRB, 0.18591798E-09_JPRB, 0.18049966E-09_JPRB, 0.17500645E-09_JPRB, 0.16959617E-09_JPRB, &
  & 0.16447259E-09_JPRB, 0.15980769E-09_JPRB, 0.15571901E-09_JPRB, 0.15221900E-09_JPRB, 0.14926055E-09_JPRB, 0.14674612E-09_JPRB, &
  & 0.14445481E-09_JPRB, 0.14220081E-09_JPRB, 0.13937185E-09_JPRB, 0.13404991E-09_JPRB /)

RGHG6(:,20, 9) = (/ &
  & 0.38479095E-10_JPRB, 0.43231082E-10_JPRB, 0.44786497E-10_JPRB, 0.45730988E-10_JPRB, 0.47025672E-10_JPRB, 0.49115337E-10_JPRB, &
  & 0.52574865E-10_JPRB, 0.57822889E-10_JPRB, 0.65188410E-10_JPRB, 0.74801096E-10_JPRB, 0.86610816E-10_JPRB, 0.10022580E-09_JPRB, &
  & 0.11494965E-09_JPRB, 0.12998363E-09_JPRB, 0.14456636E-09_JPRB, 0.15826382E-09_JPRB, 0.17091593E-09_JPRB, 0.18260775E-09_JPRB, &
  & 0.19362917E-09_JPRB, 0.20429219E-09_JPRB, 0.21490426E-09_JPRB, 0.22564370E-09_JPRB, 0.23655625E-09_JPRB, 0.24746671E-09_JPRB, &
  & 0.25781066E-09_JPRB, 0.26672012E-09_JPRB, 0.27331781E-09_JPRB, 0.27703362E-09_JPRB, 0.27773206E-09_JPRB, 0.27569327E-09_JPRB, &
  & 0.27135041E-09_JPRB, 0.26529592E-09_JPRB, 0.25850794E-09_JPRB, 0.25169783E-09_JPRB, 0.24605931E-09_JPRB, 0.24247238E-09_JPRB, &
  & 0.24205704E-09_JPRB, 0.24417585E-09_JPRB, 0.24788643E-09_JPRB, 0.25254837E-09_JPRB, 0.25718286E-09_JPRB, 0.26093330E-09_JPRB, &
  & 0.26316357E-09_JPRB, 0.26360047E-09_JPRB, 0.26222491E-09_JPRB, 0.25925448E-09_JPRB, 0.25509236E-09_JPRB, 0.25016242E-09_JPRB, &
  & 0.24475597E-09_JPRB, 0.23899102E-09_JPRB, 0.23290994E-09_JPRB, 0.22657004E-09_JPRB, 0.22011397E-09_JPRB, 0.21376620E-09_JPRB, &
  & 0.20775670E-09_JPRB, 0.20226941E-09_JPRB, 0.19742402E-09_JPRB, 0.19323580E-09_JPRB, 0.18965883E-09_JPRB, 0.18658032E-09_JPRB, &
  & 0.18382967E-09_JPRB, 0.18109995E-09_JPRB, 0.17808709E-09_JPRB, 0.17210229E-09_JPRB /)

RGHG6(:,21, 9) = (/ &
  & 0.65535050E-10_JPRB, 0.68886813E-10_JPRB, 0.69269944E-10_JPRB, 0.69305360E-10_JPRB, 0.69760454E-10_JPRB, 0.71208726E-10_JPRB, &
  & 0.74243021E-10_JPRB, 0.79339431E-10_JPRB, 0.86842478E-10_JPRB, 0.96894687E-10_JPRB, 0.10934046E-09_JPRB, 0.12372796E-09_JPRB, &
  & 0.13931167E-09_JPRB, 0.15516474E-09_JPRB, 0.17056398E-09_JPRB, 0.18499643E-09_JPRB, 0.19835003E-09_JPRB, 0.21076191E-09_JPRB, &
  & 0.22249591E-09_JPRB, 0.23395191E-09_JPRB, 0.24548091E-09_JPRB, 0.25732813E-09_JPRB, 0.26955121E-09_JPRB, 0.28198591E-09_JPRB, &
  & 0.29396299E-09_JPRB, 0.30457312E-09_JPRB, 0.31279712E-09_JPRB, 0.31800168E-09_JPRB, 0.31999717E-09_JPRB, 0.31892675E-09_JPRB, &
  & 0.31510405E-09_JPRB, 0.30909450E-09_JPRB, 0.30192768E-09_JPRB, 0.29453726E-09_JPRB, 0.28827662E-09_JPRB, 0.28422945E-09_JPRB, &
  & 0.28237945E-09_JPRB, 0.28320363E-09_JPRB, 0.28635122E-09_JPRB, 0.29062810E-09_JPRB, 0.29515942E-09_JPRB, 0.29894826E-09_JPRB, &
  & 0.30156505E-09_JPRB, 0.30260419E-09_JPRB, 0.30190586E-09_JPRB, 0.29957617E-09_JPRB, 0.29585748E-09_JPRB, 0.29109851E-09_JPRB, &
  & 0.28560174E-09_JPRB, 0.27955746E-09_JPRB, 0.27308764E-09_JPRB, 0.26633359E-09_JPRB, 0.25950039E-09_JPRB, 0.25282493E-09_JPRB, &
  & 0.24653299E-09_JPRB, 0.24078406E-09_JPRB, 0.23566188E-09_JPRB, 0.23117878E-09_JPRB, 0.22730665E-09_JPRB, 0.22391941E-09_JPRB, &
  & 0.22087991E-09_JPRB, 0.21805377E-09_JPRB, 0.21469916E-09_JPRB, 0.20899781E-09_JPRB /)

RGHG6(:,22, 9) = (/ &
  & 0.95012484E-10_JPRB, 0.96447926E-10_JPRB, 0.95739347E-10_JPRB, 0.94809709E-10_JPRB, 0.94311926E-10_JPRB, 0.94916935E-10_JPRB, &
  & 0.97193295E-10_JPRB, 0.10168097E-09_JPRB, 0.10874679E-09_JPRB, 0.11846660E-09_JPRB, 0.13071703E-09_JPRB, 0.14497928E-09_JPRB, &
  & 0.16049065E-09_JPRB, 0.17638241E-09_JPRB, 0.19185742E-09_JPRB, 0.20648511E-09_JPRB, 0.22010226E-09_JPRB, 0.23284544E-09_JPRB, &
  & 0.24504015E-09_JPRB, 0.25702626E-09_JPRB, 0.26918762E-09_JPRB, 0.28178687E-09_JPRB, 0.29491654E-09_JPRB, 0.30835895E-09_JPRB, &
  & 0.32153855E-09_JPRB, 0.33338285E-09_JPRB, 0.34296499E-09_JPRB, 0.34958378E-09_JPRB, 0.35305656E-09_JPRB, 0.35350395E-09_JPRB, &
  & 0.35117478E-09_JPRB, 0.34650896E-09_JPRB, 0.34038455E-09_JPRB, 0.33368153E-09_JPRB, 0.32764377E-09_JPRB, 0.32328179E-09_JPRB, &
  & 0.32123104E-09_JPRB, 0.32160985E-09_JPRB, 0.32374517E-09_JPRB, 0.32697842E-09_JPRB, 0.33043074E-09_JPRB, 0.33357231E-09_JPRB, &
  & 0.33562242E-09_JPRB, 0.33633640E-09_JPRB, 0.33557876E-09_JPRB, 0.33326858E-09_JPRB, 0.32958331E-09_JPRB, 0.32482486E-09_JPRB, &
  & 0.31926090E-09_JPRB, 0.31308670E-09_JPRB, 0.30647490E-09_JPRB, 0.29962738E-09_JPRB, 0.29277997E-09_JPRB, 0.28617417E-09_JPRB, &
  & 0.27999297E-09_JPRB, 0.27434990E-09_JPRB, 0.26929142E-09_JPRB, 0.26480637E-09_JPRB, 0.26081684E-09_JPRB, 0.25727676E-09_JPRB, &
  & 0.25413352E-09_JPRB, 0.25112737E-09_JPRB, 0.24800406E-09_JPRB, 0.24212421E-09_JPRB /)

RGHG6(:,23, 9) = (/ &
  & 0.12501331E-09_JPRB, 0.12469070E-09_JPRB, 0.12294021E-09_JPRB, 0.12098561E-09_JPRB, 0.11951552E-09_JPRB, 0.11914503E-09_JPRB, &
  & 0.12048246E-09_JPRB, 0.12407547E-09_JPRB, 0.13029100E-09_JPRB, 0.13924149E-09_JPRB, 0.15072790E-09_JPRB, 0.16429832E-09_JPRB, &
  & 0.17922100E-09_JPRB, 0.19465393E-09_JPRB, 0.20989852E-09_JPRB, 0.22445409E-09_JPRB, 0.23818963E-09_JPRB, 0.25119387E-09_JPRB, &
  & 0.26372932E-09_JPRB, 0.27613756E-09_JPRB, 0.28879099E-09_JPRB, 0.30189437E-09_JPRB, 0.31562311E-09_JPRB, 0.32966857E-09_JPRB, &
  & 0.34346359E-09_JPRB, 0.35600453E-09_JPRB, 0.36643255E-09_JPRB, 0.37424075E-09_JPRB, 0.37927764E-09_JPRB, 0.38149572E-09_JPRB, &
  & 0.38109613E-09_JPRB, 0.37843900E-09_JPRB, 0.37423245E-09_JPRB, 0.36926423E-09_JPRB, 0.36452652E-09_JPRB, 0.36081230E-09_JPRB, &
  & 0.35866782E-09_JPRB, 0.35837344E-09_JPRB, 0.35951281E-09_JPRB, 0.36136397E-09_JPRB, 0.36337652E-09_JPRB, 0.36502032E-09_JPRB, &
  & 0.36597098E-09_JPRB, 0.36578568E-09_JPRB, 0.36428413E-09_JPRB, 0.36153291E-09_JPRB, 0.35754488E-09_JPRB, 0.35256006E-09_JPRB, &
  & 0.34683834E-09_JPRB, 0.34058534E-09_JPRB, 0.33397957E-09_JPRB, 0.32723749E-09_JPRB, 0.32059946E-09_JPRB, 0.31427327E-09_JPRB, &
  & 0.30838901E-09_JPRB, 0.30301478E-09_JPRB, 0.29815933E-09_JPRB, 0.29379443E-09_JPRB, 0.28985375E-09_JPRB, 0.28630326E-09_JPRB, &
  & 0.28307759E-09_JPRB, 0.28009434E-09_JPRB, 0.27679142E-09_JPRB, 0.27157973E-09_JPRB /)

RGHG6(:,24, 9) = (/ &
  & 0.15451666E-09_JPRB, 0.15275513E-09_JPRB, 0.15002936E-09_JPRB, 0.14724824E-09_JPRB, 0.14486773E-09_JPRB, 0.14353405E-09_JPRB, &
  & 0.14387616E-09_JPRB, 0.14645368E-09_JPRB, 0.15164529E-09_JPRB, 0.15956372E-09_JPRB, 0.17005716E-09_JPRB, 0.18268248E-09_JPRB, &
  & 0.19679983E-09_JPRB, 0.21166296E-09_JPRB, 0.22657595E-09_JPRB, 0.24108829E-09_JPRB, 0.25495211E-09_JPRB, 0.26822028E-09_JPRB, &
  & 0.28111075E-09_JPRB, 0.29388558E-09_JPRB, 0.30688552E-09_JPRB, 0.32028707E-09_JPRB, 0.33425618E-09_JPRB, 0.34847164E-09_JPRB, &
  & 0.36236436E-09_JPRB, 0.37523826E-09_JPRB, 0.38627312E-09_JPRB, 0.39487655E-09_JPRB, 0.40092077E-09_JPRB, 0.40458381E-09_JPRB, &
  & 0.40603562E-09_JPRB, 0.40551895E-09_JPRB, 0.40354714E-09_JPRB, 0.40071629E-09_JPRB, 0.39768300E-09_JPRB, 0.39498546E-09_JPRB, &
  & 0.39326020E-09_JPRB, 0.39246190E-09_JPRB, 0.39247572E-09_JPRB, 0.39281800E-09_JPRB, 0.39316742E-09_JPRB, 0.39315573E-09_JPRB, &
  & 0.39253947E-09_JPRB, 0.39119732E-09_JPRB, 0.38878811E-09_JPRB, 0.38529493E-09_JPRB, 0.38082851E-09_JPRB, 0.37559533E-09_JPRB, &
  & 0.36973602E-09_JPRB, 0.36343084E-09_JPRB, 0.35689021E-09_JPRB, 0.35033459E-09_JPRB, 0.34398454E-09_JPRB, 0.33799488E-09_JPRB, &
  & 0.33245218E-09_JPRB, 0.32737724E-09_JPRB, 0.32275874E-09_JPRB, 0.31853334E-09_JPRB, 0.31468284E-09_JPRB, 0.31118291E-09_JPRB, &
  & 0.30800562E-09_JPRB, 0.30499675E-09_JPRB, 0.30185010E-09_JPRB, 0.29652911E-09_JPRB /)

RGHG6(:,25, 9) = (/ &
  & 0.18267585E-09_JPRB, 0.17984264E-09_JPRB, 0.17662272E-09_JPRB, 0.17326712E-09_JPRB, 0.17031056E-09_JPRB, 0.16821236E-09_JPRB, &
  & 0.16768428E-09_JPRB, 0.16929061E-09_JPRB, 0.17345177E-09_JPRB, 0.18030401E-09_JPRB, 0.18975223E-09_JPRB, 0.20141666E-09_JPRB, &
  & 0.21474252E-09_JPRB, 0.22906779E-09_JPRB, 0.24374960E-09_JPRB, 0.25827618E-09_JPRB, 0.27237332E-09_JPRB, 0.28596653E-09_JPRB, &
  & 0.29917663E-09_JPRB, 0.31222608E-09_JPRB, 0.32535064E-09_JPRB, 0.33871769E-09_JPRB, 0.35244552E-09_JPRB, 0.36634840E-09_JPRB, &
  & 0.37987824E-09_JPRB, 0.39231290E-09_JPRB, 0.40307319E-09_JPRB, 0.41193307E-09_JPRB, 0.41882781E-09_JPRB, 0.42371598E-09_JPRB, &
  & 0.42674858E-09_JPRB, 0.42812437E-09_JPRB, 0.42820267E-09_JPRB, 0.42736076E-09_JPRB, 0.42606846E-09_JPRB, 0.42465867E-09_JPRB, &
  & 0.42332376E-09_JPRB, 0.42217008E-09_JPRB, 0.42115295E-09_JPRB, 0.42018025E-09_JPRB, 0.41898957E-09_JPRB, 0.41749515E-09_JPRB, &
  & 0.41542367E-09_JPRB, 0.41280196E-09_JPRB, 0.40942794E-09_JPRB, 0.40524351E-09_JPRB, 0.40025658E-09_JPRB, 0.39468440E-09_JPRB, &
  & 0.38871611E-09_JPRB, 0.38247350E-09_JPRB, 0.37610390E-09_JPRB, 0.36981140E-09_JPRB, 0.36378547E-09_JPRB, 0.35815056E-09_JPRB, &
  & 0.35294526E-09_JPRB, 0.34817288E-09_JPRB, 0.34378236E-09_JPRB, 0.33973185E-09_JPRB, 0.33599934E-09_JPRB, 0.33257452E-09_JPRB, &
  & 0.32944136E-09_JPRB, 0.32650435E-09_JPRB, 0.32341047E-09_JPRB, 0.31834577E-09_JPRB /)

RGHG6(:,26, 9) = (/ &
  & 0.20909652E-09_JPRB, 0.20591233E-09_JPRB, 0.20255239E-09_JPRB, 0.19917828E-09_JPRB, 0.19594946E-09_JPRB, 0.19351976E-09_JPRB, &
  & 0.19239071E-09_JPRB, 0.19323899E-09_JPRB, 0.19651006E-09_JPRB, 0.20242424E-09_JPRB, 0.21091098E-09_JPRB, 0.22171275E-09_JPRB, &
  & 0.23434121E-09_JPRB, 0.24821464E-09_JPRB, 0.26273198E-09_JPRB, 0.27734984E-09_JPRB, 0.29166833E-09_JPRB, 0.30554659E-09_JPRB, &
  & 0.31897757E-09_JPRB, 0.33206882E-09_JPRB, 0.34504968E-09_JPRB, 0.35805664E-09_JPRB, 0.37113856E-09_JPRB, 0.38416334E-09_JPRB, &
  & 0.39673612E-09_JPRB, 0.40827289E-09_JPRB, 0.41848097E-09_JPRB, 0.42717302E-09_JPRB, 0.43423870E-09_JPRB, 0.43983261E-09_JPRB, &
  & 0.44396570E-09_JPRB, 0.44675372E-09_JPRB, 0.44841325E-09_JPRB, 0.44912643E-09_JPRB, 0.44910506E-09_JPRB, 0.44854498E-09_JPRB, &
  & 0.44757881E-09_JPRB, 0.44623163E-09_JPRB, 0.44455825E-09_JPRB, 0.44260240E-09_JPRB, 0.44026308E-09_JPRB, 0.43758575E-09_JPRB, &
  & 0.43445067E-09_JPRB, 0.43084145E-09_JPRB, 0.42665993E-09_JPRB, 0.42190101E-09_JPRB, 0.41661255E-09_JPRB, 0.41089968E-09_JPRB, &
  & 0.40488315E-09_JPRB, 0.39870668E-09_JPRB, 0.39252945E-09_JPRB, 0.38651260E-09_JPRB, 0.38080739E-09_JPRB, 0.37549650E-09_JPRB, &
  & 0.37059866E-09_JPRB, 0.36608991E-09_JPRB, 0.36191480E-09_JPRB, 0.35803768E-09_JPRB, 0.35443845E-09_JPRB, 0.35110731E-09_JPRB, &
  & 0.34803654E-09_JPRB, 0.34517100E-09_JPRB, 0.34212236E-09_JPRB, 0.33738232E-09_JPRB /)

RGHG6(:,27, 9) = (/ &
  & 0.23412863E-09_JPRB, 0.23119726E-09_JPRB, 0.22821153E-09_JPRB, 0.22502350E-09_JPRB, 0.22207713E-09_JPRB, 0.21956983E-09_JPRB, &
  & 0.21823215E-09_JPRB, 0.21864018E-09_JPRB, 0.22130271E-09_JPRB, 0.22646968E-09_JPRB, 0.23419541E-09_JPRB, 0.24425470E-09_JPRB, &
  & 0.25627572E-09_JPRB, 0.26973096E-09_JPRB, 0.28404704E-09_JPRB, 0.29863867E-09_JPRB, 0.31307590E-09_JPRB, 0.32704059E-09_JPRB, &
  & 0.34039377E-09_JPRB, 0.35328540E-09_JPRB, 0.36579600E-09_JPRB, 0.37807077E-09_JPRB, 0.39011286E-09_JPRB, 0.40188666E-09_JPRB, &
  & 0.41312356E-09_JPRB, 0.42350962E-09_JPRB, 0.43286397E-09_JPRB, 0.44100873E-09_JPRB, 0.44792589E-09_JPRB, 0.45364440E-09_JPRB, &
  & 0.45832296E-09_JPRB, 0.46198653E-09_JPRB, 0.46469020E-09_JPRB, 0.46645798E-09_JPRB, 0.46733878E-09_JPRB, 0.46739423E-09_JPRB, &
  & 0.46667448E-09_JPRB, 0.46522428E-09_JPRB, 0.46311166E-09_JPRB, 0.46047169E-09_JPRB, 0.45734655E-09_JPRB, 0.45382742E-09_JPRB, &
  & 0.44994150E-09_JPRB, 0.44564111E-09_JPRB, 0.44090270E-09_JPRB, 0.43570425E-09_JPRB, 0.43017134E-09_JPRB, 0.42442191E-09_JPRB, &
  & 0.41855841E-09_JPRB, 0.41262410E-09_JPRB, 0.40672832E-09_JPRB, 0.40102488E-09_JPRB, 0.39563877E-09_JPRB, 0.39063053E-09_JPRB, &
  & 0.38599257E-09_JPRB, 0.38168374E-09_JPRB, 0.37766090E-09_JPRB, 0.37388190E-09_JPRB, 0.37032366E-09_JPRB, 0.36699604E-09_JPRB, &
  & 0.36392284E-09_JPRB, 0.36100681E-09_JPRB, 0.35808628E-09_JPRB, 0.35360256E-09_JPRB /)

RGHG6(:,28, 9) = (/ &
  & 0.25887584E-09_JPRB, 0.25634633E-09_JPRB, 0.25378860E-09_JPRB, 0.25116212E-09_JPRB, 0.24847116E-09_JPRB, 0.24628927E-09_JPRB, &
  & 0.24499280E-09_JPRB, 0.24526320E-09_JPRB, 0.24759489E-09_JPRB, 0.25230293E-09_JPRB, 0.25944508E-09_JPRB, 0.26891517E-09_JPRB, &
  & 0.28037397E-09_JPRB, 0.29336189E-09_JPRB, 0.30731961E-09_JPRB, 0.32168501E-09_JPRB, 0.33594527E-09_JPRB, 0.34963388E-09_JPRB, &
  & 0.36265219E-09_JPRB, 0.37501982E-09_JPRB, 0.38676393E-09_JPRB, 0.39800740E-09_JPRB, 0.40877982E-09_JPRB, 0.41909201E-09_JPRB, &
  & 0.42881942E-09_JPRB, 0.43776921E-09_JPRB, 0.44584803E-09_JPRB, 0.45310652E-09_JPRB, 0.45960552E-09_JPRB, 0.46536239E-09_JPRB, &
  & 0.47030901E-09_JPRB, 0.47443988E-09_JPRB, 0.47772331E-09_JPRB, 0.48008802E-09_JPRB, 0.48148563E-09_JPRB, 0.48189758E-09_JPRB, &
  & 0.48132814E-09_JPRB, 0.47983334E-09_JPRB, 0.47749227E-09_JPRB, 0.47446524E-09_JPRB, 0.47089743E-09_JPRB, 0.46688947E-09_JPRB, &
  & 0.46254978E-09_JPRB, 0.45786847E-09_JPRB, 0.45284221E-09_JPRB, 0.44749199E-09_JPRB, 0.44192197E-09_JPRB, 0.43625623E-09_JPRB, &
  & 0.43056880E-09_JPRB, 0.42489182E-09_JPRB, 0.41929471E-09_JPRB, 0.41390075E-09_JPRB, 0.40880699E-09_JPRB, 0.40405754E-09_JPRB, &
  & 0.39964393E-09_JPRB, 0.39553522E-09_JPRB, 0.39168435E-09_JPRB, 0.38806020E-09_JPRB, 0.38466397E-09_JPRB, 0.38151515E-09_JPRB, &
  & 0.37862796E-09_JPRB, 0.37600226E-09_JPRB, 0.37323139E-09_JPRB, 0.36879055E-09_JPRB /)

RGHG6(:,29, 9) = (/ &
  & 0.28327390E-09_JPRB, 0.28134761E-09_JPRB, 0.27932265E-09_JPRB, 0.27706096E-09_JPRB, 0.27493288E-09_JPRB, 0.27305863E-09_JPRB, &
  & 0.27202421E-09_JPRB, 0.27236635E-09_JPRB, 0.27460487E-09_JPRB, 0.27904237E-09_JPRB, 0.28581046E-09_JPRB, 0.29478725E-09_JPRB, &
  & 0.30570765E-09_JPRB, 0.31813574E-09_JPRB, 0.33154945E-09_JPRB, 0.34539033E-09_JPRB, 0.35914022E-09_JPRB, 0.37219450E-09_JPRB, &
  & 0.38461573E-09_JPRB, 0.39619713E-09_JPRB, 0.40697617E-09_JPRB, 0.41704412E-09_JPRB, 0.42646681E-09_JPRB, 0.43531104E-09_JPRB, &
  & 0.44353157E-09_JPRB, 0.45105097E-09_JPRB, 0.45795046E-09_JPRB, 0.46432153E-09_JPRB, 0.47018112E-09_JPRB, 0.47560622E-09_JPRB, &
  & 0.48050613E-09_JPRB, 0.48475124E-09_JPRB, 0.48824356E-09_JPRB, 0.49084581E-09_JPRB, 0.49245835E-09_JPRB, 0.49302273E-09_JPRB, &
  & 0.49252336E-09_JPRB, 0.49101839E-09_JPRB, 0.48860815E-09_JPRB, 0.48542054E-09_JPRB, 0.48167137E-09_JPRB, 0.47745097E-09_JPRB, &
  & 0.47292226E-09_JPRB, 0.46809473E-09_JPRB, 0.46299944E-09_JPRB, 0.45766391E-09_JPRB, 0.45218437E-09_JPRB, 0.44667500E-09_JPRB, &
  & 0.44117437E-09_JPRB, 0.43573661E-09_JPRB, 0.43044004E-09_JPRB, 0.42537260E-09_JPRB, 0.42059248E-09_JPRB, 0.41611722E-09_JPRB, &
  & 0.41193882E-09_JPRB, 0.40802367E-09_JPRB, 0.40434800E-09_JPRB, 0.40089454E-09_JPRB, 0.39765963E-09_JPRB, 0.39465481E-09_JPRB, &
  & 0.39189563E-09_JPRB, 0.38926626E-09_JPRB, 0.38657322E-09_JPRB, 0.38211717E-09_JPRB /)

RGHG6(:,30, 9) = (/ &
  & 0.30709441E-09_JPRB, 0.30560610E-09_JPRB, 0.30395475E-09_JPRB, 0.30228725E-09_JPRB, 0.30056102E-09_JPRB, 0.29915542E-09_JPRB, &
  & 0.29843705E-09_JPRB, 0.29897407E-09_JPRB, 0.30125452E-09_JPRB, 0.30559413E-09_JPRB, 0.31207545E-09_JPRB, 0.32063871E-09_JPRB, &
  & 0.33100453E-09_JPRB, 0.34278175E-09_JPRB, 0.35544603E-09_JPRB, 0.36855119E-09_JPRB, 0.38144407E-09_JPRB, 0.39370057E-09_JPRB, &
  & 0.40523657E-09_JPRB, 0.41589002E-09_JPRB, 0.42562495E-09_JPRB, 0.43452431E-09_JPRB, 0.44268564E-09_JPRB, 0.45017695E-09_JPRB, &
  & 0.45703544E-09_JPRB, 0.46330692E-09_JPRB, 0.46911686E-09_JPRB, 0.47459398E-09_JPRB, 0.47980053E-09_JPRB, 0.48474513E-09_JPRB, &
  & 0.48935200E-09_JPRB, 0.49344995E-09_JPRB, 0.49687954E-09_JPRB, 0.49946719E-09_JPRB, 0.50108961E-09_JPRB, 0.50166976E-09_JPRB, &
  & 0.50118798E-09_JPRB, 0.49970289E-09_JPRB, 0.49731930E-09_JPRB, 0.49415139E-09_JPRB, 0.49038268E-09_JPRB, 0.48617871E-09_JPRB, &
  & 0.48162763E-09_JPRB, 0.47685383E-09_JPRB, 0.47183835E-09_JPRB, 0.46664927E-09_JPRB, 0.46137036E-09_JPRB, 0.45609355E-09_JPRB, &
  & 0.45087534E-09_JPRB, 0.44573992E-09_JPRB, 0.44074336E-09_JPRB, 0.43595980E-09_JPRB, 0.43143497E-09_JPRB, 0.42717108E-09_JPRB, &
  & 0.42315706E-09_JPRB, 0.41938625E-09_JPRB, 0.41583142E-09_JPRB, 0.41247203E-09_JPRB, 0.40930553E-09_JPRB, 0.40635445E-09_JPRB, &
  & 0.40364020E-09_JPRB, 0.40117126E-09_JPRB, 0.39859849E-09_JPRB, 0.39475317E-09_JPRB /)

RGHG6(:,31, 9) = (/ &
  & 0.32951195E-09_JPRB, 0.32843300E-09_JPRB, 0.32722025E-09_JPRB, 0.32595587E-09_JPRB, 0.32474873E-09_JPRB, 0.32376138E-09_JPRB, &
  & 0.32341141E-09_JPRB, 0.32421996E-09_JPRB, 0.32663228E-09_JPRB, 0.33092237E-09_JPRB, 0.33719760E-09_JPRB, 0.34534095E-09_JPRB, &
  & 0.35511830E-09_JPRB, 0.36613548E-09_JPRB, 0.37793960E-09_JPRB, 0.39006917E-09_JPRB, 0.40199585E-09_JPRB, 0.41330414E-09_JPRB, &
  & 0.42386489E-09_JPRB, 0.43353365E-09_JPRB, 0.44227039E-09_JPRB, 0.45012907E-09_JPRB, 0.45716833E-09_JPRB, 0.46352344E-09_JPRB, &
  & 0.46924864E-09_JPRB, 0.47448528E-09_JPRB, 0.47938348E-09_JPRB, 0.48405058E-09_JPRB, 0.48858395E-09_JPRB, 0.49297899E-09_JPRB, &
  & 0.49715493E-09_JPRB, 0.50092763E-09_JPRB, 0.50411691E-09_JPRB, 0.50652504E-09_JPRB, 0.50802718E-09_JPRB, 0.50854188E-09_JPRB, &
  & 0.50805282E-09_JPRB, 0.50661364E-09_JPRB, 0.50432319E-09_JPRB, 0.50128823E-09_JPRB, 0.49765564E-09_JPRB, 0.49356808E-09_JPRB, &
  & 0.48919246E-09_JPRB, 0.48455473E-09_JPRB, 0.47974552E-09_JPRB, 0.47477688E-09_JPRB, 0.46974546E-09_JPRB, 0.46474719E-09_JPRB, &
  & 0.45982129E-09_JPRB, 0.45499177E-09_JPRB, 0.45029130E-09_JPRB, 0.44576476E-09_JPRB, 0.44145218E-09_JPRB, 0.43736142E-09_JPRB, &
  & 0.43349957E-09_JPRB, 0.42986226E-09_JPRB, 0.42642456E-09_JPRB, 0.42317252E-09_JPRB, 0.42012646E-09_JPRB, 0.41732073E-09_JPRB, &
  & 0.41478643E-09_JPRB, 0.41243248E-09_JPRB, 0.41003978E-09_JPRB, 0.40597548E-09_JPRB /)

RGHG6(:,32, 9) = (/ &
  & 0.35017514E-09_JPRB, 0.34950751E-09_JPRB, 0.34862346E-09_JPRB, 0.34776532E-09_JPRB, 0.34693809E-09_JPRB, 0.34636288E-09_JPRB, &
  & 0.34640185E-09_JPRB, 0.34750144E-09_JPRB, 0.35007733E-09_JPRB, 0.35436939E-09_JPRB, 0.36040693E-09_JPRB, 0.36811260E-09_JPRB, &
  & 0.37723535E-09_JPRB, 0.38742681E-09_JPRB, 0.39826281E-09_JPRB, 0.40934806E-09_JPRB, 0.42021722E-09_JPRB, 0.43056497E-09_JPRB, &
  & 0.44018195E-09_JPRB, 0.44896298E-09_JPRB, 0.45681464E-09_JPRB, 0.46377466E-09_JPRB, 0.46992710E-09_JPRB, 0.47535836E-09_JPRB, &
  & 0.48020771E-09_JPRB, 0.48461762E-09_JPRB, 0.48874355E-09_JPRB, 0.49271687E-09_JPRB, 0.49661741E-09_JPRB, 0.50044890E-09_JPRB, &
  & 0.50412363E-09_JPRB, 0.50746957E-09_JPRB, 0.51030269E-09_JPRB, 0.51243054E-09_JPRB, 0.51373533E-09_JPRB, 0.51414156E-09_JPRB, &
  & 0.51363930E-09_JPRB, 0.51227561E-09_JPRB, 0.51011789E-09_JPRB, 0.50730253E-09_JPRB, 0.50389726E-09_JPRB, 0.50003257E-09_JPRB, &
  & 0.49588433E-09_JPRB, 0.49151461E-09_JPRB, 0.48694832E-09_JPRB, 0.48225862E-09_JPRB, 0.47752347E-09_JPRB, 0.47280535E-09_JPRB, &
  & 0.46816240E-09_JPRB, 0.46360593E-09_JPRB, 0.45916723E-09_JPRB, 0.45487594E-09_JPRB, 0.45076742E-09_JPRB, 0.44686035E-09_JPRB, &
  & 0.44314041E-09_JPRB, 0.43962786E-09_JPRB, 0.43630002E-09_JPRB, 0.43315285E-09_JPRB, 0.43021470E-09_JPRB, 0.42750520E-09_JPRB, &
  & 0.42503301E-09_JPRB, 0.42276010E-09_JPRB, 0.42035891E-09_JPRB, 0.41666343E-09_JPRB /)

RGHG6(:,33, 9) = (/ &
  & 0.36891928E-09_JPRB, 0.36858505E-09_JPRB, 0.36800432E-09_JPRB, 0.36741479E-09_JPRB, 0.36693656E-09_JPRB, 0.36673842E-09_JPRB, &
  & 0.36712441E-09_JPRB, 0.36852965E-09_JPRB, 0.37127418E-09_JPRB, 0.37552295E-09_JPRB, 0.38131548E-09_JPRB, 0.38851902E-09_JPRB, &
  & 0.39693962E-09_JPRB, 0.40625855E-09_JPRB, 0.41612874E-09_JPRB, 0.42614759E-09_JPRB, 0.43600676E-09_JPRB, 0.44539439E-09_JPRB, &
  & 0.45415494E-09_JPRB, 0.46213222E-09_JPRB, 0.46929099E-09_JPRB, 0.47559395E-09_JPRB, 0.48106752E-09_JPRB, 0.48582516E-09_JPRB, &
  & 0.49001292E-09_JPRB, 0.49378218E-09_JPRB, 0.49728843E-09_JPRB, 0.50065774E-09_JPRB, 0.50397891E-09_JPRB, 0.50724835E-09_JPRB, &
  & 0.51039406E-09_JPRB, 0.51325505E-09_JPRB, 0.51566723E-09_JPRB, 0.51745830E-09_JPRB, 0.51852495E-09_JPRB, 0.51880589E-09_JPRB, &
  & 0.51829463E-09_JPRB, 0.51702465E-09_JPRB, 0.51504850E-09_JPRB, 0.51248361E-09_JPRB, 0.50937765E-09_JPRB, 0.50579629E-09_JPRB, &
  & 0.50193677E-09_JPRB, 0.49785653E-09_JPRB, 0.49360632E-09_JPRB, 0.48919657E-09_JPRB, 0.48474486E-09_JPRB, 0.48032200E-09_JPRB, &
  & 0.47594673E-09_JPRB, 0.47165716E-09_JPRB, 0.46745702E-09_JPRB, 0.46338675E-09_JPRB, 0.45946189E-09_JPRB, 0.45571633E-09_JPRB, &
  & 0.45214493E-09_JPRB, 0.44874818E-09_JPRB, 0.44552378E-09_JPRB, 0.44246970E-09_JPRB, 0.43960985E-09_JPRB, 0.43697646E-09_JPRB, &
  & 0.43460499E-09_JPRB, 0.43242560E-09_JPRB, 0.43021950E-09_JPRB, 0.42650108E-09_JPRB /)

RGHG6(:,34, 9) = (/ &
  & 0.38532610E-09_JPRB, 0.38541415E-09_JPRB, 0.38516379E-09_JPRB, 0.38487130E-09_JPRB, 0.38469894E-09_JPRB, 0.38482326E-09_JPRB, &
  & 0.38555154E-09_JPRB, 0.38721126E-09_JPRB, 0.39007761E-09_JPRB, 0.39426976E-09_JPRB, 0.39974396E-09_JPRB, 0.40642870E-09_JPRB, &
  & 0.41412213E-09_JPRB, 0.42258486E-09_JPRB, 0.43150217E-09_JPRB, 0.44056436E-09_JPRB, 0.44946097E-09_JPRB, 0.45800891E-09_JPRB, &
  & 0.46601867E-09_JPRB, 0.47337523E-09_JPRB, 0.47999543E-09_JPRB, 0.48577903E-09_JPRB, 0.49076787E-09_JPRB, 0.49506155E-09_JPRB, &
  & 0.49878102E-09_JPRB, 0.50206145E-09_JPRB, 0.50506394E-09_JPRB, 0.50791754E-09_JPRB, 0.51070081E-09_JPRB, 0.51343013E-09_JPRB, &
  & 0.51603610E-09_JPRB, 0.51839077E-09_JPRB, 0.52035232E-09_JPRB, 0.52178339E-09_JPRB, 0.52259769E-09_JPRB, 0.52275240E-09_JPRB, &
  & 0.52224058E-09_JPRB, 0.52108146E-09_JPRB, 0.51931559E-09_JPRB, 0.51703175E-09_JPRB, 0.51422272E-09_JPRB, 0.51098881E-09_JPRB, &
  & 0.50743931E-09_JPRB, 0.50366278E-09_JPRB, 0.49973842E-09_JPRB, 0.49563592E-09_JPRB, 0.49143839E-09_JPRB, 0.48730281E-09_JPRB, &
  & 0.48318238E-09_JPRB, 0.47912296E-09_JPRB, 0.47513604E-09_JPRB, 0.47127169E-09_JPRB, 0.46752285E-09_JPRB, 0.46393811E-09_JPRB, &
  & 0.46051862E-09_JPRB, 0.45725287E-09_JPRB, 0.45414736E-09_JPRB, 0.45120049E-09_JPRB, 0.44844034E-09_JPRB, 0.44590912E-09_JPRB, &
  & 0.44362777E-09_JPRB, 0.44153584E-09_JPRB, 0.43931611E-09_JPRB, 0.43575607E-09_JPRB /)

RGHG6(:,35, 9) = (/ &
  & 0.39998657E-09_JPRB, 0.40022524E-09_JPRB, 0.40026057E-09_JPRB, 0.40023651E-09_JPRB, 0.40033649E-09_JPRB, 0.40075629E-09_JPRB, &
  & 0.40174319E-09_JPRB, 0.40361325E-09_JPRB, 0.40655374E-09_JPRB, 0.41060830E-09_JPRB, 0.41576759E-09_JPRB, 0.42190434E-09_JPRB, &
  & 0.42890708E-09_JPRB, 0.43654635E-09_JPRB, 0.44460105E-09_JPRB, 0.45276591E-09_JPRB, 0.46083345E-09_JPRB, 0.46862975E-09_JPRB, &
  & 0.47599963E-09_JPRB, 0.48284354E-09_JPRB, 0.48904064E-09_JPRB, 0.49449017E-09_JPRB, 0.49919346E-09_JPRB, 0.50319571E-09_JPRB, &
  & 0.50658983E-09_JPRB, 0.50950788E-09_JPRB, 0.51209686E-09_JPRB, 0.51449217E-09_JPRB, 0.51678206E-09_JPRB, 0.51898530E-09_JPRB, &
  & 0.52106008E-09_JPRB, 0.52290811E-09_JPRB, 0.52441862E-09_JPRB, 0.52549215E-09_JPRB, 0.52606336E-09_JPRB, 0.52610416E-09_JPRB, &
  & 0.52560589E-09_JPRB, 0.52457355E-09_JPRB, 0.52303512E-09_JPRB, 0.52103161E-09_JPRB, 0.51854454E-09_JPRB, 0.51564158E-09_JPRB, &
  & 0.51241306E-09_JPRB, 0.50896948E-09_JPRB, 0.50534721E-09_JPRB, 0.50153148E-09_JPRB, 0.49759358E-09_JPRB, 0.49371229E-09_JPRB, &
  & 0.48983545E-09_JPRB, 0.48598081E-09_JPRB, 0.48218696E-09_JPRB, 0.47851018E-09_JPRB, 0.47494403E-09_JPRB, 0.47151849E-09_JPRB, &
  & 0.46827342E-09_JPRB, 0.46516868E-09_JPRB, 0.46220316E-09_JPRB, 0.45938006E-09_JPRB, 0.45672738E-09_JPRB, 0.45428594E-09_JPRB, &
  & 0.45208243E-09_JPRB, 0.45004658E-09_JPRB, 0.44794668E-09_JPRB, 0.44442372E-09_JPRB /)

RGHG6(:,36, 9) = (/ &
  & 0.41259091E-09_JPRB, 0.41330370E-09_JPRB, 0.41355463E-09_JPRB, 0.41375536E-09_JPRB, 0.41409018E-09_JPRB, 0.41473397E-09_JPRB, &
  & 0.41594203E-09_JPRB, 0.41794274E-09_JPRB, 0.42088014E-09_JPRB, 0.42478615E-09_JPRB, 0.42957865E-09_JPRB, 0.43520659E-09_JPRB, &
  & 0.44154036E-09_JPRB, 0.44843768E-09_JPRB, 0.45567969E-09_JPRB, 0.46307150E-09_JPRB, 0.47037396E-09_JPRB, 0.47751691E-09_JPRB, &
  & 0.48435994E-09_JPRB, 0.49077636E-09_JPRB, 0.49667692E-09_JPRB, 0.50193688E-09_JPRB, 0.50647186E-09_JPRB, 0.51029242E-09_JPRB, &
  & 0.51344440E-09_JPRB, 0.51605670E-09_JPRB, 0.51828764E-09_JPRB, 0.52026966E-09_JPRB, 0.52209531E-09_JPRB, 0.52380378E-09_JPRB, &
  & 0.52537436E-09_JPRB, 0.52674110E-09_JPRB, 0.52783211E-09_JPRB, 0.52857801E-09_JPRB, 0.52893878E-09_JPRB, 0.52889632E-09_JPRB, &
  & 0.52843707E-09_JPRB, 0.52755478E-09_JPRB, 0.52625670E-09_JPRB, 0.52454346E-09_JPRB, 0.52236820E-09_JPRB, 0.51978555E-09_JPRB, &
  & 0.51689708E-09_JPRB, 0.51378229E-09_JPRB, 0.51041826E-09_JPRB, 0.50686749E-09_JPRB, 0.50320753E-09_JPRB, 0.49954374E-09_JPRB, &
  & 0.49588056E-09_JPRB, 0.49220200E-09_JPRB, 0.48858795E-09_JPRB, 0.48508686E-09_JPRB, 0.48170651E-09_JPRB, 0.47846976E-09_JPRB, &
  & 0.47541654E-09_JPRB, 0.47249554E-09_JPRB, 0.46969456E-09_JPRB, 0.46701948E-09_JPRB, 0.46449100E-09_JPRB, 0.46215709E-09_JPRB, &
  & 0.46004395E-09_JPRB, 0.45809653E-09_JPRB, 0.45602563E-09_JPRB, 0.45259227E-09_JPRB /)

RGHG6(:,37, 9) = (/ &
  & 0.42381879E-09_JPRB, 0.42491349E-09_JPRB, 0.42534384E-09_JPRB, 0.42573312E-09_JPRB, 0.42625375E-09_JPRB, 0.42709397E-09_JPRB, &
  & 0.42845144E-09_JPRB, 0.43052928E-09_JPRB, 0.43342285E-09_JPRB, 0.43710913E-09_JPRB, 0.44155160E-09_JPRB, 0.44665849E-09_JPRB, &
  & 0.45237561E-09_JPRB, 0.45856483E-09_JPRB, 0.46508483E-09_JPRB, 0.47174198E-09_JPRB, 0.47841237E-09_JPRB, 0.48493137E-09_JPRB, &
  & 0.49132481E-09_JPRB, 0.49743776E-09_JPRB, 0.50311699E-09_JPRB, 0.50822418E-09_JPRB, 0.51261895E-09_JPRB, 0.51623039E-09_JPRB, &
  & 0.51912274E-09_JPRB, 0.52141808E-09_JPRB, 0.52329258E-09_JPRB, 0.52488780E-09_JPRB, 0.52629912E-09_JPRB, 0.52757243E-09_JPRB, &
  & 0.52870636E-09_JPRB, 0.52966787E-09_JPRB, 0.53041077E-09_JPRB, 0.53089694E-09_JPRB, 0.53110411E-09_JPRB, 0.53102217E-09_JPRB, &
  & 0.53063864E-09_JPRB, 0.52993510E-09_JPRB, 0.52890259E-09_JPRB, 0.52749966E-09_JPRB, 0.52565724E-09_JPRB, 0.52343319E-09_JPRB, &
  & 0.52089183E-09_JPRB, 0.51804661E-09_JPRB, 0.51494820E-09_JPRB, 0.51166837E-09_JPRB, 0.50826521E-09_JPRB, 0.50480059E-09_JPRB, &
  & 0.50130944E-09_JPRB, 0.49780852E-09_JPRB, 0.49436305E-09_JPRB, 0.49102983E-09_JPRB, 0.48783738E-09_JPRB, 0.48481125E-09_JPRB, &
  & 0.48196791E-09_JPRB, 0.47925985E-09_JPRB, 0.47665560E-09_JPRB, 0.47415388E-09_JPRB, 0.47177595E-09_JPRB, 0.46956788E-09_JPRB, &
  & 0.46755616E-09_JPRB, 0.46567672E-09_JPRB, 0.46368179E-09_JPRB, 0.46031778E-09_JPRB /)

RGHG6(:,38, 9) = (/ &
  & 0.43427295E-09_JPRB, 0.43533380E-09_JPRB, 0.43590470E-09_JPRB, 0.43644602E-09_JPRB, 0.43713860E-09_JPRB, 0.43813422E-09_JPRB, &
  & 0.43961504E-09_JPRB, 0.44172094E-09_JPRB, 0.44450493E-09_JPRB, 0.44795281E-09_JPRB, 0.45200599E-09_JPRB, 0.45661125E-09_JPRB, &
  & 0.46171664E-09_JPRB, 0.46724502E-09_JPRB, 0.47307497E-09_JPRB, 0.47907495E-09_JPRB, 0.48514559E-09_JPRB, 0.49119636E-09_JPRB, &
  & 0.49713933E-09_JPRB, 0.50293075E-09_JPRB, 0.50840010E-09_JPRB, 0.51329829E-09_JPRB, 0.51743504E-09_JPRB, 0.52074639E-09_JPRB, &
  & 0.52327787E-09_JPRB, 0.52521765E-09_JPRB, 0.52674604E-09_JPRB, 0.52800692E-09_JPRB, 0.52908833E-09_JPRB, 0.53003624E-09_JPRB, &
  & 0.53085852E-09_JPRB, 0.53153659E-09_JPRB, 0.53204563E-09_JPRB, 0.53236321E-09_JPRB, 0.53247950E-09_JPRB, 0.53239363E-09_JPRB, &
  & 0.53209431E-09_JPRB, 0.53156785E-09_JPRB, 0.53079480E-09_JPRB, 0.52971277E-09_JPRB, 0.52825144E-09_JPRB, 0.52643501E-09_JPRB, &
  & 0.52425142E-09_JPRB, 0.52173182E-09_JPRB, 0.51893323E-09_JPRB, 0.51592569E-09_JPRB, 0.51274757E-09_JPRB, 0.50948101E-09_JPRB, &
  & 0.50615639E-09_JPRB, 0.50281629E-09_JPRB, 0.49952814E-09_JPRB, 0.49636700E-09_JPRB, 0.49337417E-09_JPRB, 0.49057886E-09_JPRB, &
  & 0.48797016E-09_JPRB, 0.48549453E-09_JPRB, 0.48311194E-09_JPRB, 0.48080689E-09_JPRB, 0.47860077E-09_JPRB, 0.47653570E-09_JPRB, &
  & 0.47463700E-09_JPRB, 0.47284915E-09_JPRB, 0.47092508E-09_JPRB, 0.46764792E-09_JPRB /)

RGHG6(:,39, 9) = (/ &
  & 0.44336187E-09_JPRB, 0.44470291E-09_JPRB, 0.44542428E-09_JPRB, 0.44612669E-09_JPRB, 0.44697163E-09_JPRB, 0.44811818E-09_JPRB, &
  & 0.44969473E-09_JPRB, 0.45178386E-09_JPRB, 0.45442416E-09_JPRB, 0.45758941E-09_JPRB, 0.46123833E-09_JPRB, 0.46533549E-09_JPRB, &
  & 0.46984988E-09_JPRB, 0.47473353E-09_JPRB, 0.47991328E-09_JPRB, 0.48528859E-09_JPRB, 0.49077659E-09_JPRB, 0.49634086E-09_JPRB, &
  & 0.50190596E-09_JPRB, 0.50737525E-09_JPRB, 0.51252913E-09_JPRB, 0.51712334E-09_JPRB, 0.52090560E-09_JPRB, 0.52381821E-09_JPRB, &
  & 0.52598792E-09_JPRB, 0.52760118E-09_JPRB, 0.52884924E-09_JPRB, 0.52986165E-09_JPRB, 0.53071680E-09_JPRB, 0.53145360E-09_JPRB, &
  & 0.53208304E-09_JPRB, 0.53259319E-09_JPRB, 0.53296662E-09_JPRB, 0.53318944E-09_JPRB, 0.53325894E-09_JPRB, 0.53317739E-09_JPRB, &
  & 0.53294130E-09_JPRB, 0.53254190E-09_JPRB, 0.53196564E-09_JPRB, 0.53115567E-09_JPRB, 0.53004551E-09_JPRB, 0.52863369E-09_JPRB, &
  & 0.52686155E-09_JPRB, 0.52473709E-09_JPRB, 0.52230176E-09_JPRB, 0.51958898E-09_JPRB, 0.51666516E-09_JPRB, 0.51360494E-09_JPRB, &
  & 0.51044968E-09_JPRB, 0.50726223E-09_JPRB, 0.50413146E-09_JPRB, 0.50114324E-09_JPRB, 0.49836041E-09_JPRB, 0.49580479E-09_JPRB, &
  & 0.49344112E-09_JPRB, 0.49121479E-09_JPRB, 0.48906601E-09_JPRB, 0.48697846E-09_JPRB, 0.48496124E-09_JPRB, 0.48305970E-09_JPRB, &
  & 0.48129245E-09_JPRB, 0.47960819E-09_JPRB, 0.47776466E-09_JPRB, 0.47461185E-09_JPRB /)

RGHG6(:,40, 9) = (/ &
  & 0.45172224E-09_JPRB, 0.45322510E-09_JPRB, 0.45409723E-09_JPRB, 0.45492546E-09_JPRB, 0.45593479E-09_JPRB, 0.45722190E-09_JPRB, &
  & 0.45886203E-09_JPRB, 0.46091753E-09_JPRB, 0.46337439E-09_JPRB, 0.46623178E-09_JPRB, 0.46947163E-09_JPRB, 0.47306403E-09_JPRB, &
  & 0.47700682E-09_JPRB, 0.48127691E-09_JPRB, 0.48583249E-09_JPRB, 0.49061533E-09_JPRB, 0.49557086E-09_JPRB, 0.50064447E-09_JPRB, &
  & 0.50580073E-09_JPRB, 0.51088689E-09_JPRB, 0.51570759E-09_JPRB, 0.51991139E-09_JPRB, 0.52330079E-09_JPRB, 0.52585325E-09_JPRB, &
  & 0.52770799E-09_JPRB, 0.52907256E-09_JPRB, 0.53011723E-09_JPRB, 0.53095939E-09_JPRB, 0.53166505E-09_JPRB, 0.53227095E-09_JPRB, &
  & 0.53278409E-09_JPRB, 0.53319738E-09_JPRB, 0.53349464E-09_JPRB, 0.53366556E-09_JPRB, 0.53370980E-09_JPRB, 0.53363280E-09_JPRB, &
  & 0.53343557E-09_JPRB, 0.53311483E-09_JPRB, 0.53266624E-09_JPRB, 0.53204269E-09_JPRB, 0.53119842E-09_JPRB, 0.53011817E-09_JPRB, &
  & 0.52873261E-09_JPRB, 0.52703009E-09_JPRB, 0.52500115E-09_JPRB, 0.52263727E-09_JPRB, 0.52001059E-09_JPRB, 0.51718180E-09_JPRB, &
  & 0.51420324E-09_JPRB, 0.51118160E-09_JPRB, 0.50821053E-09_JPRB, 0.50540150E-09_JPRB, 0.50283494E-09_JPRB, 0.50051635E-09_JPRB, &
  & 0.49840476E-09_JPRB, 0.49642490E-09_JPRB, 0.49452148E-09_JPRB, 0.49265458E-09_JPRB, 0.49084226E-09_JPRB, 0.48911558E-09_JPRB, &
  & 0.48749788E-09_JPRB, 0.48593057E-09_JPRB, 0.48420568E-09_JPRB, 0.48119220E-09_JPRB /)

RGHG6(:,41, 9) = (/ &
  & 0.45947168E-09_JPRB, 0.46110468E-09_JPRB, 0.46204074E-09_JPRB, 0.46301654E-09_JPRB, 0.46415494E-09_JPRB, 0.46556692E-09_JPRB, &
  & 0.46727494E-09_JPRB, 0.46924559E-09_JPRB, 0.47151016E-09_JPRB, 0.47405835E-09_JPRB, 0.47688692E-09_JPRB, 0.47999921E-09_JPRB, &
  & 0.48339993E-09_JPRB, 0.48709203E-09_JPRB, 0.49105847E-09_JPRB, 0.49526822E-09_JPRB, 0.49969007E-09_JPRB, 0.50430105E-09_JPRB, &
  & 0.50902277E-09_JPRB, 0.51374904E-09_JPRB, 0.51816612E-09_JPRB, 0.52200122E-09_JPRB, 0.52502125E-09_JPRB, 0.52725591E-09_JPRB, &
  & 0.52886595E-09_JPRB, 0.53004123E-09_JPRB, 0.53093951E-09_JPRB, 0.53166066E-09_JPRB, 0.53226618E-09_JPRB, 0.53278404E-09_JPRB, &
  & 0.53322491E-09_JPRB, 0.53357818E-09_JPRB, 0.53383054E-09_JPRB, 0.53397065E-09_JPRB, 0.53400062E-09_JPRB, 0.53392712E-09_JPRB, &
  & 0.53375421E-09_JPRB, 0.53348337E-09_JPRB, 0.53311444E-09_JPRB, 0.53261739E-09_JPRB, 0.53195243E-09_JPRB, 0.53111665E-09_JPRB, &
  & 0.53004334E-09_JPRB, 0.52871446E-09_JPRB, 0.52708138E-09_JPRB, 0.52511284E-09_JPRB, 0.52281257E-09_JPRB, 0.52024274E-09_JPRB, &
  & 0.51747362E-09_JPRB, 0.51462201E-09_JPRB, 0.51181448E-09_JPRB, 0.50919202E-09_JPRB, 0.50683652E-09_JPRB, 0.50475468E-09_JPRB, &
  & 0.50288451E-09_JPRB, 0.50115256E-09_JPRB, 0.49948279E-09_JPRB, 0.49784338E-09_JPRB, 0.49623505E-09_JPRB, 0.49469695E-09_JPRB, &
  & 0.49323917E-09_JPRB, 0.49181542E-09_JPRB, 0.49021159E-09_JPRB, 0.48740484E-09_JPRB /)

RGHG6(:,42, 9) = (/ &
  & 0.46679272E-09_JPRB, 0.46844806E-09_JPRB, 0.46948273E-09_JPRB, 0.47050902E-09_JPRB, 0.47178450E-09_JPRB, 0.47331156E-09_JPRB, &
  & 0.47502158E-09_JPRB, 0.47692172E-09_JPRB, 0.47897442E-09_JPRB, 0.48121884E-09_JPRB, 0.48366389E-09_JPRB, 0.48632437E-09_JPRB, &
  & 0.48922644E-09_JPRB, 0.49238424E-09_JPRB, 0.49580157E-09_JPRB, 0.49946591E-09_JPRB, 0.50337268E-09_JPRB, 0.50750076E-09_JPRB, &
  & 0.51181603E-09_JPRB, 0.51612903E-09_JPRB, 0.52019583E-09_JPRB, 0.52364540E-09_JPRB, 0.52633331E-09_JPRB, 0.52829879E-09_JPRB, &
  & 0.52970650E-09_JPRB, 0.53073518E-09_JPRB, 0.53152061E-09_JPRB, 0.53215315E-09_JPRB, 0.53268390E-09_JPRB, 0.53314181E-09_JPRB, &
  & 0.53353155E-09_JPRB, 0.53384613E-09_JPRB, 0.53406879E-09_JPRB, 0.53418991E-09_JPRB, 0.53421129E-09_JPRB, 0.53414084E-09_JPRB, &
  & 0.53398524E-09_JPRB, 0.53374727E-09_JPRB, 0.53343330E-09_JPRB, 0.53301968E-09_JPRB, 0.53248095E-09_JPRB, 0.53181726E-09_JPRB, &
  & 0.53097954E-09_JPRB, 0.52994692E-09_JPRB, 0.52867344E-09_JPRB, 0.52706950E-09_JPRB, 0.52512494E-09_JPRB, 0.52283966E-09_JPRB, &
  & 0.52029436E-09_JPRB, 0.51763355E-09_JPRB, 0.51500576E-09_JPRB, 0.51256932E-09_JPRB, 0.51042803E-09_JPRB, 0.50856913E-09_JPRB, &
  & 0.50693377E-09_JPRB, 0.50543297E-09_JPRB, 0.50399479E-09_JPRB, 0.50257176E-09_JPRB, 0.50117160E-09_JPRB, 0.49981985E-09_JPRB, &
  & 0.49853460E-09_JPRB, 0.49726046E-09_JPRB, 0.49582027E-09_JPRB, 0.49325288E-09_JPRB /)

RGHG6(:,43, 9) = (/ &
  & 0.47390664E-09_JPRB, 0.47557080E-09_JPRB, 0.47655835E-09_JPRB, 0.47764137E-09_JPRB, 0.47897558E-09_JPRB, 0.48055282E-09_JPRB, &
  & 0.48228010E-09_JPRB, 0.48405568E-09_JPRB, 0.48591331E-09_JPRB, 0.48787091E-09_JPRB, 0.48996013E-09_JPRB, 0.49221299E-09_JPRB, &
  & 0.49466053E-09_JPRB, 0.49733562E-09_JPRB, 0.50024379E-09_JPRB, 0.50339605E-09_JPRB, 0.50679411E-09_JPRB, 0.51046034E-09_JPRB, &
  & 0.51432725E-09_JPRB, 0.51826876E-09_JPRB, 0.52192711E-09_JPRB, 0.52502036E-09_JPRB, 0.52739058E-09_JPRB, 0.52911819E-09_JPRB, &
  & 0.53035748E-09_JPRB, 0.53126514E-09_JPRB, 0.53196181E-09_JPRB, 0.53252386E-09_JPRB, 0.53299909E-09_JPRB, 0.53341048E-09_JPRB, &
  & 0.53376481E-09_JPRB, 0.53405114E-09_JPRB, 0.53425397E-09_JPRB, 0.53436211E-09_JPRB, 0.53437821E-09_JPRB, 0.53431098E-09_JPRB, &
  & 0.53416810E-09_JPRB, 0.53395488E-09_JPRB, 0.53367860E-09_JPRB, 0.53332633E-09_JPRB, 0.53287535E-09_JPRB, 0.53233740E-09_JPRB, &
  & 0.53167432E-09_JPRB, 0.53087507E-09_JPRB, 0.52988858E-09_JPRB, 0.52862875E-09_JPRB, 0.52702426E-09_JPRB, 0.52504134E-09_JPRB, &
  & 0.52274735E-09_JPRB, 0.52028903E-09_JPRB, 0.51784810E-09_JPRB, 0.51560789E-09_JPRB, 0.51366644E-09_JPRB, 0.51202365E-09_JPRB, &
  & 0.51060728E-09_JPRB, 0.50932891E-09_JPRB, 0.50810650E-09_JPRB, 0.50689575E-09_JPRB, 0.50569277E-09_JPRB, 0.50452731E-09_JPRB, &
  & 0.50341153E-09_JPRB, 0.50230370E-09_JPRB, 0.50103599E-09_JPRB, 0.49877225E-09_JPRB /)

RGHG6(:,44, 9) = (/ &
  & 0.48079618E-09_JPRB, 0.48251414E-09_JPRB, 0.48349807E-09_JPRB, 0.48454074E-09_JPRB, 0.48587417E-09_JPRB, 0.48748205E-09_JPRB, &
  & 0.48913862E-09_JPRB, 0.49080362E-09_JPRB, 0.49245918E-09_JPRB, 0.49415133E-09_JPRB, 0.49591875E-09_JPRB, 0.49779997E-09_JPRB, &
  & 0.49984894E-09_JPRB, 0.50208343E-09_JPRB, 0.50453497E-09_JPRB, 0.50720206E-09_JPRB, 0.51012583E-09_JPRB, 0.51330445E-09_JPRB, &
  & 0.51674848E-09_JPRB, 0.52023241E-09_JPRB, 0.52349575E-09_JPRB, 0.52620008E-09_JPRB, 0.52827370E-09_JPRB, 0.52978716E-09_JPRB, &
  & 0.53088051E-09_JPRB, 0.53168769E-09_JPRB, 0.53231064E-09_JPRB, 0.53281685E-09_JPRB, 0.53324756E-09_JPRB, 0.53362442E-09_JPRB, &
  & 0.53395133E-09_JPRB, 0.53421773E-09_JPRB, 0.53440591E-09_JPRB, 0.53450544E-09_JPRB, 0.53451837E-09_JPRB, 0.53445465E-09_JPRB, &
  & 0.53432264E-09_JPRB, 0.53412785E-09_JPRB, 0.53388027E-09_JPRB, 0.53357185E-09_JPRB, 0.53318677E-09_JPRB, 0.53274180E-09_JPRB, &
  & 0.53221172E-09_JPRB, 0.53159049E-09_JPRB, 0.53084209E-09_JPRB, 0.52987259E-09_JPRB, 0.52859361E-09_JPRB, 0.52692750E-09_JPRB, &
  & 0.52489002E-09_JPRB, 0.52265120E-09_JPRB, 0.52040922E-09_JPRB, 0.51835852E-09_JPRB, 0.51662202E-09_JPRB, 0.51518323E-09_JPRB, &
  & 0.51397631E-09_JPRB, 0.51290516E-09_JPRB, 0.51188814E-09_JPRB, 0.51087418E-09_JPRB, 0.50985888E-09_JPRB, 0.50886684E-09_JPRB, &
  & 0.50791743E-09_JPRB, 0.50697208E-09_JPRB, 0.50589583E-09_JPRB, 0.50397098E-09_JPRB /)

RGHG6(:,45, 9) = (/ &
  & 0.48849336E-09_JPRB, 0.48965731E-09_JPRB, 0.49043025E-09_JPRB, 0.49135324E-09_JPRB, 0.49264270E-09_JPRB, 0.49417048E-09_JPRB, &
  & 0.49575732E-09_JPRB, 0.49727256E-09_JPRB, 0.49872817E-09_JPRB, 0.50016857E-09_JPRB, 0.50163662E-09_JPRB, 0.50319365E-09_JPRB, &
  & 0.50487037E-09_JPRB, 0.50672488E-09_JPRB, 0.50875149E-09_JPRB, 0.51099003E-09_JPRB, 0.51344362E-09_JPRB, 0.51618193E-09_JPRB, &
  & 0.51911381E-09_JPRB, 0.52214855E-09_JPRB, 0.52491650E-09_JPRB, 0.52723698E-09_JPRB, 0.52901888E-09_JPRB, 0.53033944E-09_JPRB, &
  & 0.53130711E-09_JPRB, 0.53202937E-09_JPRB, 0.53259203E-09_JPRB, 0.53305305E-09_JPRB, 0.53344901E-09_JPRB, 0.53379895E-09_JPRB, &
  & 0.53410543E-09_JPRB, 0.53435700E-09_JPRB, 0.53453481E-09_JPRB, 0.53462829E-09_JPRB, 0.53463978E-09_JPRB, 0.53458005E-09_JPRB, &
  & 0.53445703E-09_JPRB, 0.53427729E-09_JPRB, 0.53405064E-09_JPRB, 0.53377552E-09_JPRB, 0.53344035E-09_JPRB, 0.53306543E-09_JPRB, &
  & 0.53263732E-09_JPRB, 0.53215427E-09_JPRB, 0.53158966E-09_JPRB, 0.53086402E-09_JPRB, 0.52988530E-09_JPRB, 0.52852894E-09_JPRB, &
  & 0.52678106E-09_JPRB, 0.52477966E-09_JPRB, 0.52274191E-09_JPRB, 0.52089849E-09_JPRB, 0.51935523E-09_JPRB, 0.51811777E-09_JPRB, &
  & 0.51710963E-09_JPRB, 0.51622956E-09_JPRB, 0.51540072E-09_JPRB, 0.51456805E-09_JPRB, 0.51372134E-09_JPRB, 0.51288851E-09_JPRB, &
  & 0.51208870E-09_JPRB, 0.51130161E-09_JPRB, 0.51041049E-09_JPRB, 0.50883475E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART17',1,ZHOOK_HANDLE)
END SUBROUTINE PART17




SUBROUTINE PART18
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART18',0,ZHOOK_HANDLE)



RGHG6(:,46, 9) = (/ &
  & 0.49442062E-09_JPRB, 0.49606613E-09_JPRB, 0.49701754E-09_JPRB, 0.49802473E-09_JPRB, 0.49928167E-09_JPRB, 0.50077464E-09_JPRB, &
  & 0.50223348E-09_JPRB, 0.50357946E-09_JPRB, 0.50482385E-09_JPRB, 0.50601012E-09_JPRB, 0.50720078E-09_JPRB, 0.50844062E-09_JPRB, &
  & 0.50980153E-09_JPRB, 0.51128823E-09_JPRB, 0.51295213E-09_JPRB, 0.51477950E-09_JPRB, 0.51683069E-09_JPRB, 0.51907123E-09_JPRB, &
  & 0.52152893E-09_JPRB, 0.52396132E-09_JPRB, 0.52623866E-09_JPRB, 0.52814020E-09_JPRB, 0.52965088E-09_JPRB, 0.53079768E-09_JPRB, &
  & 0.53165589E-09_JPRB, 0.53230698E-09_JPRB, 0.53282057E-09_JPRB, 0.53324534E-09_JPRB, 0.53361437E-09_JPRB, 0.53394356E-09_JPRB, &
  & 0.53423482E-09_JPRB, 0.53447524E-09_JPRB, 0.53464577E-09_JPRB, 0.53473520E-09_JPRB, 0.53474680E-09_JPRB, 0.53469107E-09_JPRB, &
  & 0.53457622E-09_JPRB, 0.53440774E-09_JPRB, 0.53419746E-09_JPRB, 0.53394750E-09_JPRB, 0.53365035E-09_JPRB, 0.53332982E-09_JPRB, &
  & 0.53297916E-09_JPRB, 0.53259941E-09_JPRB, 0.53217541E-09_JPRB, 0.53164245E-09_JPRB, 0.53091442E-09_JPRB, 0.52987048E-09_JPRB, &
  & 0.52843674E-09_JPRB, 0.52670546E-09_JPRB, 0.52490901E-09_JPRB, 0.52326138E-09_JPRB, 0.52192417E-09_JPRB, 0.52088128E-09_JPRB, &
  & 0.52005161E-09_JPRB, 0.51934723E-09_JPRB, 0.51868138E-09_JPRB, 0.51800697E-09_JPRB, 0.51731064E-09_JPRB, 0.51661436E-09_JPRB, &
  & 0.51594945E-09_JPRB, 0.51530025E-09_JPRB, 0.51457927E-09_JPRB, 0.51332405E-09_JPRB /)

RGHG6(:,47, 9) = (/ &
  & 0.50115867E-09_JPRB, 0.50267157E-09_JPRB, 0.50363108E-09_JPRB, 0.50465498E-09_JPRB, 0.50594151E-09_JPRB, 0.50735338E-09_JPRB, &
  & 0.50866827E-09_JPRB, 0.50981874E-09_JPRB, 0.51082144E-09_JPRB, 0.51174726E-09_JPRB, 0.51265048E-09_JPRB, 0.51360399E-09_JPRB, &
  & 0.51463700E-09_JPRB, 0.51581217E-09_JPRB, 0.51711879E-09_JPRB, 0.51859739E-09_JPRB, 0.52021210E-09_JPRB, 0.52200227E-09_JPRB, &
  & 0.52383942E-09_JPRB, 0.52570104E-09_JPRB, 0.52741095E-09_JPRB, 0.52893040E-09_JPRB, 0.53018256E-09_JPRB, 0.53117566E-09_JPRB, &
  & 0.53194071E-09_JPRB, 0.53253280E-09_JPRB, 0.53300625E-09_JPRB, 0.53340310E-09_JPRB, 0.53375110E-09_JPRB, 0.53406496E-09_JPRB, &
  & 0.53434474E-09_JPRB, 0.53457705E-09_JPRB, 0.53474214E-09_JPRB, 0.53482929E-09_JPRB, 0.53484189E-09_JPRB, 0.53479021E-09_JPRB, &
  & 0.53468219E-09_JPRB, 0.53452337E-09_JPRB, 0.53432520E-09_JPRB, 0.53409388E-09_JPRB, 0.53382765E-09_JPRB, 0.53354737E-09_JPRB, &
  & 0.53325533E-09_JPRB, 0.53295229E-09_JPRB, 0.53262966E-09_JPRB, 0.53223842E-09_JPRB, 0.53171395E-09_JPRB, 0.53094562E-09_JPRB, &
  & 0.52984550E-09_JPRB, 0.52844751E-09_JPRB, 0.52691268E-09_JPRB, 0.52550558E-09_JPRB, 0.52436189E-09_JPRB, 0.52349491E-09_JPRB, &
  & 0.52283161E-09_JPRB, 0.52226901E-09_JPRB, 0.52174431E-09_JPRB, 0.52120208E-09_JPRB, 0.52062971E-09_JPRB, 0.52005134E-09_JPRB, &
  & 0.51949772E-09_JPRB, 0.51896543E-09_JPRB, 0.51838472E-09_JPRB, 0.51739146E-09_JPRB /)

RGHG6(:,48, 9) = (/ &
  & 0.50716392E-09_JPRB, 0.50887389E-09_JPRB, 0.50996041E-09_JPRB, 0.51109483E-09_JPRB, 0.51243138E-09_JPRB, 0.51381954E-09_JPRB, &
  & 0.51501864E-09_JPRB, 0.51596100E-09_JPRB, 0.51672361E-09_JPRB, 0.51737925E-09_JPRB, 0.51800797E-09_JPRB, 0.51865889E-09_JPRB, &
  & 0.51939913E-09_JPRB, 0.52024729E-09_JPRB, 0.52123339E-09_JPRB, 0.52231952E-09_JPRB, 0.52351712E-09_JPRB, 0.52473453E-09_JPRB, &
  & 0.52598859E-09_JPRB, 0.52721894E-09_JPRB, 0.52844518E-09_JPRB, 0.52959759E-09_JPRB, 0.53062782E-09_JPRB, 0.53148647E-09_JPRB, &
  & 0.53217297E-09_JPRB, 0.53271654E-09_JPRB, 0.53315868E-09_JPRB, 0.53353350E-09_JPRB, 0.53386595E-09_JPRB, 0.53416832E-09_JPRB, &
  & 0.53443966E-09_JPRB, 0.53466537E-09_JPRB, 0.53482674E-09_JPRB, 0.53491234E-09_JPRB, 0.53492688E-09_JPRB, 0.53487920E-09_JPRB, &
  & 0.53477739E-09_JPRB, 0.53462640E-09_JPRB, 0.53443761E-09_JPRB, 0.53422139E-09_JPRB, 0.53397781E-09_JPRB, 0.53372867E-09_JPRB, &
  & 0.53347959E-09_JPRB, 0.53323235E-09_JPRB, 0.53298066E-09_JPRB, 0.53269145E-09_JPRB, 0.53231403E-09_JPRB, 0.53177429E-09_JPRB, &
  & 0.53099009E-09_JPRB, 0.52995602E-09_JPRB, 0.52877147E-09_JPRB, 0.52762467E-09_JPRB, 0.52669097E-09_JPRB, 0.52599286E-09_JPRB, &
  & 0.52546095E-09_JPRB, 0.52501931E-09_JPRB, 0.52460203E-09_JPRB, 0.52416566E-09_JPRB, 0.52369298E-09_JPRB, 0.52320592E-09_JPRB, &
  & 0.52274018E-09_JPRB, 0.52229820E-09_JPRB, 0.52182314E-09_JPRB, 0.52102389E-09_JPRB /)

RGHG6(:,49, 9) = (/ &
  & 0.51252208E-09_JPRB, 0.51439530E-09_JPRB, 0.51558724E-09_JPRB, 0.51680732E-09_JPRB, 0.51822968E-09_JPRB, 0.51966298E-09_JPRB, &
  & 0.52078725E-09_JPRB, 0.52158888E-09_JPRB, 0.52215771E-09_JPRB, 0.52260030E-09_JPRB, 0.52298432E-09_JPRB, 0.52338373E-09_JPRB, &
  & 0.52383636E-09_JPRB, 0.52437815E-09_JPRB, 0.52500176E-09_JPRB, 0.52569044E-09_JPRB, 0.52637406E-09_JPRB, 0.52706695E-09_JPRB, &
  & 0.52775434E-09_JPRB, 0.52849058E-09_JPRB, 0.52929761E-09_JPRB, 0.53015781E-09_JPRB, 0.53099464E-09_JPRB, 0.53174143E-09_JPRB, &
  & 0.53236304E-09_JPRB, 0.53286836E-09_JPRB, 0.53328575E-09_JPRB, 0.53364413E-09_JPRB, 0.53396471E-09_JPRB, 0.53425830E-09_JPRB, &
  & 0.53452270E-09_JPRB, 0.53474369E-09_JPRB, 0.53490151E-09_JPRB, 0.53498672E-09_JPRB, 0.53500337E-09_JPRB, 0.53495958E-09_JPRB, &
  & 0.53486338E-09_JPRB, 0.53471927E-09_JPRB, 0.53453891E-09_JPRB, 0.53433358E-09_JPRB, 0.53410842E-09_JPRB, 0.53388144E-09_JPRB, &
  & 0.53366450E-09_JPRB, 0.53345572E-09_JPRB, 0.53325527E-09_JPRB, 0.53303412E-09_JPRB, 0.53276161E-09_JPRB, 0.53238730E-09_JPRB, &
  & 0.53186383E-09_JPRB, 0.53117666E-09_JPRB, 0.53037336E-09_JPRB, 0.52956189E-09_JPRB, 0.52887006E-09_JPRB, 0.52833987E-09_JPRB, &
  & 0.52792837E-09_JPRB, 0.52758653E-09_JPRB, 0.52725391E-09_JPRB, 0.52689919E-09_JPRB, 0.52650440E-09_JPRB, 0.52608712E-09_JPRB, &
  & 0.52568655E-09_JPRB, 0.52531035E-09_JPRB, 0.52490767E-09_JPRB, 0.52424365E-09_JPRB /)

RGHG6(:,50, 9) = (/ &
  & 0.51769766E-09_JPRB, 0.51928634E-09_JPRB, 0.52030052E-09_JPRB, 0.52142279E-09_JPRB, 0.52276905E-09_JPRB, 0.52413296E-09_JPRB, &
  & 0.52516563E-09_JPRB, 0.52584037E-09_JPRB, 0.52627613E-09_JPRB, 0.52657650E-09_JPRB, 0.52682347E-09_JPRB, 0.52705046E-09_JPRB, &
  & 0.52729887E-09_JPRB, 0.52758337E-09_JPRB, 0.52789328E-09_JPRB, 0.52819665E-09_JPRB, 0.52849380E-09_JPRB, 0.52877697E-09_JPRB, &
  & 0.52908944E-09_JPRB, 0.52948079E-09_JPRB, 0.52998933E-09_JPRB, 0.53061594E-09_JPRB, 0.53129773E-09_JPRB, 0.53195093E-09_JPRB, &
  & 0.53252064E-09_JPRB, 0.53299609E-09_JPRB, 0.53339466E-09_JPRB, 0.53374022E-09_JPRB, 0.53405175E-09_JPRB, 0.53433835E-09_JPRB, &
  & 0.53459714E-09_JPRB, 0.53481347E-09_JPRB, 0.53496840E-09_JPRB, 0.53505367E-09_JPRB, 0.53507260E-09_JPRB, 0.53503280E-09_JPRB, &
  & 0.53494204E-09_JPRB, 0.53480465E-09_JPRB, 0.53463145E-09_JPRB, 0.53443566E-09_JPRB, 0.53422367E-09_JPRB, 0.53401394E-09_JPRB, &
  & 0.53381743E-09_JPRB, 0.53364002E-09_JPRB, 0.53347093E-09_JPRB, 0.53329852E-09_JPRB, 0.53309457E-09_JPRB, 0.53283433E-09_JPRB, &
  & 0.53249394E-09_JPRB, 0.53207794E-09_JPRB, 0.53160359E-09_JPRB, 0.53112637E-09_JPRB, 0.53070132E-09_JPRB, 0.53035704E-09_JPRB, &
  & 0.53008514E-09_JPRB, 0.52983767E-09_JPRB, 0.52959781E-09_JPRB, 0.52932569E-09_JPRB, 0.52900662E-09_JPRB, 0.52865973E-09_JPRB, &
  & 0.52831922E-09_JPRB, 0.52799282E-09_JPRB, 0.52764976E-09_JPRB, 0.52706400E-09_JPRB /)

RGHG6(:,51, 9) = (/ &
  & 0.52157922E-09_JPRB, 0.52292737E-09_JPRB, 0.52381771E-09_JPRB, 0.52473514E-09_JPRB, 0.52590976E-09_JPRB, 0.52708216E-09_JPRB, &
  & 0.52793592E-09_JPRB, 0.52845339E-09_JPRB, 0.52876942E-09_JPRB, 0.52898641E-09_JPRB, 0.52914545E-09_JPRB, 0.52928939E-09_JPRB, &
  & 0.52942600E-09_JPRB, 0.52955906E-09_JPRB, 0.52967813E-09_JPRB, 0.52977689E-09_JPRB, 0.52985405E-09_JPRB, 0.52993387E-09_JPRB, &
  & 0.53004590E-09_JPRB, 0.53023202E-09_JPRB, 0.53054444E-09_JPRB, 0.53099525E-09_JPRB, 0.53154919E-09_JPRB, 0.53212629E-09_JPRB, &
  & 0.53265437E-09_JPRB, 0.53310639E-09_JPRB, 0.53349086E-09_JPRB, 0.53382632E-09_JPRB, 0.53413035E-09_JPRB, 0.53441090E-09_JPRB, &
  & 0.53466442E-09_JPRB, 0.53487637E-09_JPRB, 0.53502880E-09_JPRB, 0.53511451E-09_JPRB, 0.53513588E-09_JPRB, 0.53510019E-09_JPRB, &
  & 0.53501448E-09_JPRB, 0.53488380E-09_JPRB, 0.53471794E-09_JPRB, 0.53452998E-09_JPRB, 0.53432836E-09_JPRB, 0.53412974E-09_JPRB, &
  & 0.53395149E-09_JPRB, 0.53379012E-09_JPRB, 0.53364868E-09_JPRB, 0.53350568E-09_JPRB, 0.53334870E-09_JPRB, 0.53316279E-09_JPRB, &
  & 0.53294280E-09_JPRB, 0.53269722E-09_JPRB, 0.53244514E-09_JPRB, 0.53219906E-09_JPRB, 0.53198790E-09_JPRB, 0.53181470E-09_JPRB, &
  & 0.53166693E-09_JPRB, 0.53153681E-09_JPRB, 0.53139387E-09_JPRB, 0.53122645E-09_JPRB, 0.53101673E-09_JPRB, 0.53076671E-09_JPRB, &
  & 0.53050658E-09_JPRB, 0.53025251E-09_JPRB, 0.52995858E-09_JPRB, 0.52946969E-09_JPRB /)

RGHG6(:,52, 9) = (/ &
  & 0.52499510E-09_JPRB, 0.52581245E-09_JPRB, 0.52636911E-09_JPRB, 0.52709037E-09_JPRB, 0.52799265E-09_JPRB, 0.52894245E-09_JPRB, &
  & 0.52958699E-09_JPRB, 0.52996429E-09_JPRB, 0.53018856E-09_JPRB, 0.53033267E-09_JPRB, 0.53044608E-09_JPRB, 0.53053717E-09_JPRB, &
  & 0.53061799E-09_JPRB, 0.53068200E-09_JPRB, 0.53071936E-09_JPRB, 0.53072791E-09_JPRB, 0.53071991E-09_JPRB, 0.53071103E-09_JPRB, &
  & 0.53072841E-09_JPRB, 0.53080806E-09_JPRB, 0.53099075E-09_JPRB, 0.53131466E-09_JPRB, 0.53176641E-09_JPRB, 0.53227772E-09_JPRB, &
  & 0.53277127E-09_JPRB, 0.53320504E-09_JPRB, 0.53357729E-09_JPRB, 0.53390448E-09_JPRB, 0.53420202E-09_JPRB, 0.53447691E-09_JPRB, &
  & 0.53472560E-09_JPRB, 0.53493332E-09_JPRB, 0.53508409E-09_JPRB, 0.53517013E-09_JPRB, 0.53519400E-09_JPRB, 0.53516230E-09_JPRB, &
  & 0.53508192E-09_JPRB, 0.53495763E-09_JPRB, 0.53479954E-09_JPRB, 0.53461885E-09_JPRB, 0.53442545E-09_JPRB, 0.53423749E-09_JPRB, &
  & 0.53406618E-09_JPRB, 0.53392424E-09_JPRB, 0.53379479E-09_JPRB, 0.53367538E-09_JPRB, 0.53354909E-09_JPRB, 0.53341148E-09_JPRB, &
  & 0.53326527E-09_JPRB, 0.53312099E-09_JPRB, 0.53298588E-09_JPRB, 0.53287041E-09_JPRB, 0.53277366E-09_JPRB, 0.53269950E-09_JPRB, &
  & 0.53263860E-09_JPRB, 0.53257998E-09_JPRB, 0.53251781E-09_JPRB, 0.53243787E-09_JPRB, 0.53232840E-09_JPRB, 0.53219029E-09_JPRB, &
  & 0.53203475E-09_JPRB, 0.53186544E-09_JPRB, 0.53167148E-09_JPRB, 0.53128357E-09_JPRB /)

RGHG6(:,53, 9) = (/ &
  & 0.52699495E-09_JPRB, 0.52767574E-09_JPRB, 0.52817783E-09_JPRB, 0.52869126E-09_JPRB, 0.52942628E-09_JPRB, 0.53013421E-09_JPRB, &
  & 0.53061755E-09_JPRB, 0.53088134E-09_JPRB, 0.53103488E-09_JPRB, 0.53113869E-09_JPRB, 0.53121357E-09_JPRB, 0.53127786E-09_JPRB, &
  & 0.53132909E-09_JPRB, 0.53136195E-09_JPRB, 0.53136651E-09_JPRB, 0.53134336E-09_JPRB, 0.53130278E-09_JPRB, 0.53126004E-09_JPRB, &
  & 0.53123445E-09_JPRB, 0.53125460E-09_JPRB, 0.53136073E-09_JPRB, 0.53159188E-09_JPRB, 0.53195925E-09_JPRB, 0.53241689E-09_JPRB, &
  & 0.53287863E-09_JPRB, 0.53329463E-09_JPRB, 0.53365662E-09_JPRB, 0.53397586E-09_JPRB, 0.53426719E-09_JPRB, 0.53453736E-09_JPRB, &
  & 0.53478100E-09_JPRB, 0.53498539E-09_JPRB, 0.53513449E-09_JPRB, 0.53522126E-09_JPRB, 0.53524785E-09_JPRB, 0.53522031E-09_JPRB, &
  & 0.53514476E-09_JPRB, 0.53502719E-09_JPRB, 0.53487637E-09_JPRB, 0.53470334E-09_JPRB, 0.53451754E-09_JPRB, 0.53433497E-09_JPRB, &
  & 0.53417659E-09_JPRB, 0.53403826E-09_JPRB, 0.53392546E-09_JPRB, 0.53381832E-09_JPRB, 0.53371385E-09_JPRB, 0.53360816E-09_JPRB, &
  & 0.53350746E-09_JPRB, 0.53341764E-09_JPRB, 0.53334454E-09_JPRB, 0.53328575E-09_JPRB, 0.53324456E-09_JPRB, 0.53321303E-09_JPRB, &
  & 0.53318872E-09_JPRB, 0.53316596E-09_JPRB, 0.53313959E-09_JPRB, 0.53310450E-09_JPRB, 0.53305471E-09_JPRB, 0.53298643E-09_JPRB, &
  & 0.53290639E-09_JPRB, 0.53282123E-09_JPRB, 0.53271049E-09_JPRB, 0.53248683E-09_JPRB /)

RGHG6(:,54, 9) = (/ &
  & 0.52871019E-09_JPRB, 0.52918442E-09_JPRB, 0.52948801E-09_JPRB, 0.52990823E-09_JPRB, 0.53041582E-09_JPRB, 0.53096533E-09_JPRB, &
  & 0.53130284E-09_JPRB, 0.53149130E-09_JPRB, 0.53159854E-09_JPRB, 0.53166854E-09_JPRB, 0.53172344E-09_JPRB, 0.53176713E-09_JPRB, &
  & 0.53180271E-09_JPRB, 0.53182159E-09_JPRB, 0.53181465E-09_JPRB, 0.53178151E-09_JPRB, 0.53173060E-09_JPRB, 0.53167426E-09_JPRB, &
  & 0.53162857E-09_JPRB, 0.53161597E-09_JPRB, 0.53167082E-09_JPRB, 0.53183774E-09_JPRB, 0.53214311E-09_JPRB, 0.53254806E-09_JPRB, &
  & 0.53298133E-09_JPRB, 0.53337895E-09_JPRB, 0.53372939E-09_JPRB, 0.53404142E-09_JPRB, 0.53432681E-09_JPRB, 0.53459237E-09_JPRB, &
  & 0.53483162E-09_JPRB, 0.53503324E-09_JPRB, 0.53518096E-09_JPRB, 0.53526850E-09_JPRB, 0.53529786E-09_JPRB, 0.53527444E-09_JPRB, &
  & 0.53520410E-09_JPRB, 0.53509269E-09_JPRB, 0.53494892E-09_JPRB, 0.53478322E-09_JPRB, 0.53460458E-09_JPRB, 0.53443089E-09_JPRB, &
  & 0.53427457E-09_JPRB, 0.53414928E-09_JPRB, 0.53404015E-09_JPRB, 0.53394583E-09_JPRB, 0.53385552E-09_JPRB, 0.53377125E-09_JPRB, &
  & 0.53369725E-09_JPRB, 0.53363847E-09_JPRB, 0.53359367E-09_JPRB, 0.53356375E-09_JPRB, 0.53354265E-09_JPRB, 0.53352966E-09_JPRB, &
  & 0.53351917E-09_JPRB, 0.53350935E-09_JPRB, 0.53349780E-09_JPRB, 0.53348137E-09_JPRB, 0.53345711E-09_JPRB, 0.53342419E-09_JPRB, &
  & 0.53338695E-09_JPRB, 0.53334948E-09_JPRB, 0.53331528E-09_JPRB, 0.53327398E-09_JPRB /)

RGHG6(:,55, 9) = (/ &
  & 0.52985694E-09_JPRB, 0.53021526E-09_JPRB, 0.53049543E-09_JPRB, 0.53077298E-09_JPRB, 0.53117688E-09_JPRB, 0.53154819E-09_JPRB, &
  & 0.53180083E-09_JPRB, 0.53193011E-09_JPRB, 0.53200633E-09_JPRB, 0.53205712E-09_JPRB, 0.53209537E-09_JPRB, 0.53212812E-09_JPRB, &
  & 0.53215365E-09_JPRB, 0.53216642E-09_JPRB, 0.53215699E-09_JPRB, 0.53212279E-09_JPRB, 0.53207033E-09_JPRB, 0.53200894E-09_JPRB, &
  & 0.53195087E-09_JPRB, 0.53191779E-09_JPRB, 0.53194005E-09_JPRB, 0.53206251E-09_JPRB, 0.53231508E-09_JPRB, 0.53268218E-09_JPRB, &
  & 0.53308119E-09_JPRB, 0.53345983E-09_JPRB, 0.53379795E-09_JPRB, 0.53410215E-09_JPRB, 0.53438226E-09_JPRB, 0.53464316E-09_JPRB, &
  & 0.53487870E-09_JPRB, 0.53507782E-09_JPRB, 0.53522420E-09_JPRB, 0.53531263E-09_JPRB, 0.53534510E-09_JPRB, 0.53532584E-09_JPRB, &
  & 0.53526028E-09_JPRB, 0.53515492E-09_JPRB, 0.53501792E-09_JPRB, 0.53485849E-09_JPRB, 0.53468785E-09_JPRB, 0.53451976E-09_JPRB, &
  & 0.53437360E-09_JPRB, 0.53424998E-09_JPRB, 0.53415056E-09_JPRB, 0.53406224E-09_JPRB, 0.53398314E-09_JPRB, 0.53391236E-09_JPRB, &
  & 0.53385518E-09_JPRB, 0.53381188E-09_JPRB, 0.53378280E-09_JPRB, 0.53376326E-09_JPRB, 0.53375243E-09_JPRB, 0.53374483E-09_JPRB, &
  & 0.53373961E-09_JPRB, 0.53373439E-09_JPRB, 0.53372778E-09_JPRB, 0.53371840E-09_JPRB, 0.53370408E-09_JPRB, 0.53368454E-09_JPRB, &
  & 0.53366161E-09_JPRB, 0.53363819E-09_JPRB, 0.53361127E-09_JPRB, 0.53356797E-09_JPRB /)

RGHG6(:,56, 9) = (/ &
  & 0.53080768E-09_JPRB, 0.53107085E-09_JPRB, 0.53124238E-09_JPRB, 0.53146881E-09_JPRB, 0.53173099E-09_JPRB, 0.53200722E-09_JPRB, &
  & 0.53217603E-09_JPRB, 0.53227212E-09_JPRB, 0.53232607E-09_JPRB, 0.53236304E-09_JPRB, 0.53239219E-09_JPRB, 0.53241656E-09_JPRB, &
  & 0.53243682E-09_JPRB, 0.53244725E-09_JPRB, 0.53243931E-09_JPRB, 0.53240889E-09_JPRB, 0.53235788E-09_JPRB, 0.53229432E-09_JPRB, &
  & 0.53222904E-09_JPRB, 0.53217974E-09_JPRB, 0.53217863E-09_JPRB, 0.53226845E-09_JPRB, 0.53248739E-09_JPRB, 0.53281207E-09_JPRB, &
  & 0.53318361E-09_JPRB, 0.53353943E-09_JPRB, 0.53386462E-09_JPRB, 0.53416066E-09_JPRB, 0.53443505E-09_JPRB, 0.53469168E-09_JPRB, &
  & 0.53492361E-09_JPRB, 0.53511989E-09_JPRB, 0.53526494E-09_JPRB, 0.53535454E-09_JPRB, 0.53538995E-09_JPRB, 0.53537463E-09_JPRB, &
  & 0.53531413E-09_JPRB, 0.53521448E-09_JPRB, 0.53508320E-09_JPRB, 0.53493104E-09_JPRB, 0.53476679E-09_JPRB, 0.53460741E-09_JPRB, &
  & 0.53446592E-09_JPRB, 0.53435062E-09_JPRB, 0.53425459E-09_JPRB, 0.53417365E-09_JPRB, 0.53410160E-09_JPRB, 0.53404048E-09_JPRB, &
  & 0.53399224E-09_JPRB, 0.53395804E-09_JPRB, 0.53393506E-09_JPRB, 0.53392168E-09_JPRB, 0.53391314E-09_JPRB, 0.53390836E-09_JPRB, &
  & 0.53390425E-09_JPRB, 0.53390026E-09_JPRB, 0.53389532E-09_JPRB, 0.53388810E-09_JPRB, 0.53387800E-09_JPRB, 0.53386418E-09_JPRB, &
  & 0.53384869E-09_JPRB, 0.53383259E-09_JPRB, 0.53381582E-09_JPRB, 0.53378796E-09_JPRB /)

RGHG6(:,57, 9) = (/ &
  & 0.53147320E-09_JPRB, 0.53167720E-09_JPRB, 0.53183030E-09_JPRB, 0.53198296E-09_JPRB, 0.53217758E-09_JPRB, 0.53235860E-09_JPRB, &
  & 0.53248467E-09_JPRB, 0.53255167E-09_JPRB, 0.53259253E-09_JPRB, 0.53262050E-09_JPRB, 0.53264282E-09_JPRB, 0.53266302E-09_JPRB, &
  & 0.53268007E-09_JPRB, 0.53269061E-09_JPRB, 0.53268612E-09_JPRB, 0.53266053E-09_JPRB, 0.53261340E-09_JPRB, 0.53254884E-09_JPRB, &
  & 0.53247606E-09_JPRB, 0.53241511E-09_JPRB, 0.53239596E-09_JPRB, 0.53246418E-09_JPRB, 0.53265103E-09_JPRB, 0.53294680E-09_JPRB, &
  & 0.53328547E-09_JPRB, 0.53362070E-09_JPRB, 0.53393168E-09_JPRB, 0.53421889E-09_JPRB, 0.53448779E-09_JPRB, 0.53473925E-09_JPRB, &
  & 0.53496768E-09_JPRB, 0.53516042E-09_JPRB, 0.53530419E-09_JPRB, 0.53539528E-09_JPRB, 0.53543336E-09_JPRB, 0.53542198E-09_JPRB, &
  & 0.53536620E-09_JPRB, 0.53527216E-09_JPRB, 0.53514737E-09_JPRB, 0.53500043E-09_JPRB, 0.53484395E-09_JPRB, 0.53469129E-09_JPRB, &
  & 0.53455762E-09_JPRB, 0.53444671E-09_JPRB, 0.53435689E-09_JPRB, 0.53428079E-09_JPRB, 0.53421517E-09_JPRB, 0.53415983E-09_JPRB, &
  & 0.53411731E-09_JPRB, 0.53408700E-09_JPRB, 0.53406735E-09_JPRB, 0.53405458E-09_JPRB, 0.53404758E-09_JPRB, 0.53404237E-09_JPRB, &
  & 0.53403837E-09_JPRB, 0.53403426E-09_JPRB, 0.53402915E-09_JPRB, 0.53402266E-09_JPRB, 0.53401317E-09_JPRB, 0.53400173E-09_JPRB, &
  & 0.53398896E-09_JPRB, 0.53397625E-09_JPRB, 0.53396154E-09_JPRB, 0.53393673E-09_JPRB /)

RGHG6(:,58, 9) = (/ &
  & 0.53201210E-09_JPRB, 0.53217564E-09_JPRB, 0.53228033E-09_JPRB, 0.53239657E-09_JPRB, 0.53252580E-09_JPRB, 0.53265448E-09_JPRB, &
  & 0.53274174E-09_JPRB, 0.53279342E-09_JPRB, 0.53282440E-09_JPRB, 0.53284671E-09_JPRB, 0.53286553E-09_JPRB, 0.53288263E-09_JPRB, &
  & 0.53289889E-09_JPRB, 0.53291038E-09_JPRB, 0.53291016E-09_JPRB, 0.53289045E-09_JPRB, 0.53284693E-09_JPRB, 0.53278210E-09_JPRB, &
  & 0.53270399E-09_JPRB, 0.53263172E-09_JPRB, 0.53259919E-09_JPRB, 0.53264965E-09_JPRB, 0.53281479E-09_JPRB, 0.53307853E-09_JPRB, &
  & 0.53339083E-09_JPRB, 0.53370458E-09_JPRB, 0.53400140E-09_JPRB, 0.53427940E-09_JPRB, 0.53454163E-09_JPRB, 0.53478816E-09_JPRB, &
  & 0.53501176E-09_JPRB, 0.53520055E-09_JPRB, 0.53534349E-09_JPRB, 0.53543525E-09_JPRB, 0.53547566E-09_JPRB, 0.53546795E-09_JPRB, &
  & 0.53541704E-09_JPRB, 0.53532867E-09_JPRB, 0.53520943E-09_JPRB, 0.53506943E-09_JPRB, 0.53491922E-09_JPRB, 0.53477428E-09_JPRB, &
  & 0.53464683E-09_JPRB, 0.53454180E-09_JPRB, 0.53445642E-09_JPRB, 0.53438548E-09_JPRB, 0.53432470E-09_JPRB, 0.53427407E-09_JPRB, &
  & 0.53423493E-09_JPRB, 0.53420623E-09_JPRB, 0.53418664E-09_JPRB, 0.53417415E-09_JPRB, 0.53416532E-09_JPRB, 0.53415949E-09_JPRB, &
  & 0.53415450E-09_JPRB, 0.53414939E-09_JPRB, 0.53414378E-09_JPRB, 0.53413629E-09_JPRB, 0.53412713E-09_JPRB, 0.53411586E-09_JPRB, &
  & 0.53410454E-09_JPRB, 0.53409333E-09_JPRB, 0.53408172E-09_JPRB, 0.53406185E-09_JPRB /)

RGHG6(:,59, 9) = (/ &
  & 0.53242455E-09_JPRB, 0.53255389E-09_JPRB, 0.53263954E-09_JPRB, 0.53272176E-09_JPRB, 0.53281335E-09_JPRB, 0.53290272E-09_JPRB, &
  & 0.53296811E-09_JPRB, 0.53300780E-09_JPRB, 0.53303328E-09_JPRB, 0.53305227E-09_JPRB, 0.53306870E-09_JPRB, 0.53308513E-09_JPRB, &
  & 0.53310112E-09_JPRB, 0.53311500E-09_JPRB, 0.53311944E-09_JPRB, 0.53310528E-09_JPRB, 0.53306604E-09_JPRB, 0.53300026E-09_JPRB, &
  & 0.53291677E-09_JPRB, 0.53283633E-09_JPRB, 0.53279342E-09_JPRB, 0.53283084E-09_JPRB, 0.53297378E-09_JPRB, 0.53321186E-09_JPRB, &
  & 0.53349825E-09_JPRB, 0.53379196E-09_JPRB, 0.53407528E-09_JPRB, 0.53434362E-09_JPRB, 0.53459848E-09_JPRB, 0.53483901E-09_JPRB, &
  & 0.53505711E-09_JPRB, 0.53524218E-09_JPRB, 0.53538302E-09_JPRB, 0.53547528E-09_JPRB, 0.53551741E-09_JPRB, 0.53551297E-09_JPRB, &
  & 0.53546673E-09_JPRB, 0.53538385E-09_JPRB, 0.53527122E-09_JPRB, 0.53513721E-09_JPRB, 0.53499449E-09_JPRB, 0.53485633E-09_JPRB, &
  & 0.53473515E-09_JPRB, 0.53463528E-09_JPRB, 0.53455446E-09_JPRB, 0.53448801E-09_JPRB, 0.53443161E-09_JPRB, 0.53438476E-09_JPRB, &
  & 0.53434751E-09_JPRB, 0.53431970E-09_JPRB, 0.53429927E-09_JPRB, 0.53428451E-09_JPRB, 0.53427435E-09_JPRB, 0.53426630E-09_JPRB, &
  & 0.53425964E-09_JPRB, 0.53425320E-09_JPRB, 0.53424570E-09_JPRB, 0.53423721E-09_JPRB, 0.53422650E-09_JPRB, 0.53421495E-09_JPRB, &
  & 0.53420346E-09_JPRB, 0.53419291E-09_JPRB, 0.53418120E-09_JPRB, 0.53416238E-09_JPRB /)

RGHG6(:,60, 9) = (/ &
  & 0.53276605E-09_JPRB, 0.53286814E-09_JPRB, 0.53293009E-09_JPRB, 0.53299060E-09_JPRB, 0.53305566E-09_JPRB, 0.53312033E-09_JPRB, &
  & 0.53317106E-09_JPRB, 0.53320381E-09_JPRB, 0.53322596E-09_JPRB, 0.53324306E-09_JPRB, 0.53325899E-09_JPRB, 0.53327520E-09_JPRB, &
  & 0.53329308E-09_JPRB, 0.53330962E-09_JPRB, 0.53331906E-09_JPRB, 0.53331034E-09_JPRB, 0.53327370E-09_JPRB, 0.53320781E-09_JPRB, &
  & 0.53311933E-09_JPRB, 0.53303301E-09_JPRB, 0.53298232E-09_JPRB, 0.53300786E-09_JPRB, 0.53313221E-09_JPRB, 0.53334537E-09_JPRB, &
  & 0.53360827E-09_JPRB, 0.53388399E-09_JPRB, 0.53415361E-09_JPRB, 0.53441213E-09_JPRB, 0.53465937E-09_JPRB, 0.53489296E-09_JPRB, &
  & 0.53510529E-09_JPRB, 0.53528565E-09_JPRB, 0.53542432E-09_JPRB, 0.53551535E-09_JPRB, 0.53555865E-09_JPRB, 0.53555699E-09_JPRB, &
  & 0.53551530E-09_JPRB, 0.53543814E-09_JPRB, 0.53533156E-09_JPRB, 0.53520488E-09_JPRB, 0.53506893E-09_JPRB, 0.53493804E-09_JPRB, &
  & 0.53482302E-09_JPRB, 0.53472798E-09_JPRB, 0.53465143E-09_JPRB, 0.53458882E-09_JPRB, 0.53453630E-09_JPRB, 0.53449228E-09_JPRB, &
  & 0.53445742E-09_JPRB, 0.53442945E-09_JPRB, 0.53440818E-09_JPRB, 0.53439148E-09_JPRB, 0.53437832E-09_JPRB, 0.53436794E-09_JPRB, &
  & 0.53435911E-09_JPRB, 0.53435018E-09_JPRB, 0.53434102E-09_JPRB, 0.53432969E-09_JPRB, 0.53431715E-09_JPRB, 0.53430382E-09_JPRB, &
  & 0.53429183E-09_JPRB, 0.53428084E-09_JPRB, 0.53426985E-09_JPRB, 0.53425142E-09_JPRB /)

RGHG6(:,61, 9) = (/ &
  & 0.53304183E-09_JPRB, 0.53312293E-09_JPRB, 0.53317228E-09_JPRB, 0.53321775E-09_JPRB, 0.53326599E-09_JPRB, 0.53331584E-09_JPRB, &
  & 0.53335697E-09_JPRB, 0.53338584E-09_JPRB, 0.53340643E-09_JPRB, 0.53342331E-09_JPRB, 0.53343963E-09_JPRB, 0.53345761E-09_JPRB, &
  & 0.53347765E-09_JPRB, 0.53349875E-09_JPRB, 0.53351296E-09_JPRB, 0.53350846E-09_JPRB, 0.53347421E-09_JPRB, 0.53340588E-09_JPRB, &
  & 0.53331534E-09_JPRB, 0.53322458E-09_JPRB, 0.53316840E-09_JPRB, 0.53318344E-09_JPRB, 0.53328969E-09_JPRB, 0.53348070E-09_JPRB, &
  & 0.53372212E-09_JPRB, 0.53398030E-09_JPRB, 0.53423710E-09_JPRB, 0.53448590E-09_JPRB, 0.53472510E-09_JPRB, 0.53495114E-09_JPRB, &
  & 0.53515692E-09_JPRB, 0.53533211E-09_JPRB, 0.53546684E-09_JPRB, 0.53555627E-09_JPRB, 0.53559956E-09_JPRB, 0.53559995E-09_JPRB, &
  & 0.53556248E-09_JPRB, 0.53549076E-09_JPRB, 0.53539095E-09_JPRB, 0.53527160E-09_JPRB, 0.53514343E-09_JPRB, 0.53501964E-09_JPRB, &
  & 0.53491056E-09_JPRB, 0.53482041E-09_JPRB, 0.53474775E-09_JPRB, 0.53468857E-09_JPRB, 0.53463922E-09_JPRB, 0.53459798E-09_JPRB, &
  & 0.53456428E-09_JPRB, 0.53453753E-09_JPRB, 0.53451532E-09_JPRB, 0.53449656E-09_JPRB, 0.53448079E-09_JPRB, 0.53446747E-09_JPRB, &
  & 0.53445515E-09_JPRB, 0.53444377E-09_JPRB, 0.53443078E-09_JPRB, 0.53441662E-09_JPRB, 0.53440058E-09_JPRB, 0.53438526E-09_JPRB, &
  & 0.53437166E-09_JPRB, 0.53436011E-09_JPRB, 0.53434784E-09_JPRB, 0.53432891E-09_JPRB /)

RGHG6(:,62, 9) = (/ &
  & 0.53327726E-09_JPRB, 0.53334270E-09_JPRB, 0.53338078E-09_JPRB, 0.53341626E-09_JPRB, 0.53345411E-09_JPRB, 0.53349386E-09_JPRB, &
  & 0.53352978E-09_JPRB, 0.53355709E-09_JPRB, 0.53357768E-09_JPRB, 0.53359583E-09_JPRB, 0.53361376E-09_JPRB, 0.53363441E-09_JPRB, &
  & 0.53365889E-09_JPRB, 0.53368465E-09_JPRB, 0.53370403E-09_JPRB, 0.53370242E-09_JPRB, 0.53366750E-09_JPRB, 0.53359916E-09_JPRB, &
  & 0.53350602E-09_JPRB, 0.53341381E-09_JPRB, 0.53335281E-09_JPRB, 0.53335830E-09_JPRB, 0.53344862E-09_JPRB, 0.53361876E-09_JPRB, &
  & 0.53384014E-09_JPRB, 0.53408206E-09_JPRB, 0.53432642E-09_JPRB, 0.53456517E-09_JPRB, 0.53479604E-09_JPRB, 0.53501426E-09_JPRB, &
  & 0.53521282E-09_JPRB, 0.53538179E-09_JPRB, 0.53551158E-09_JPRB, 0.53559757E-09_JPRB, 0.53564009E-09_JPRB, 0.53564203E-09_JPRB, &
  & 0.53560839E-09_JPRB, 0.53554217E-09_JPRB, 0.53544946E-09_JPRB, 0.53533761E-09_JPRB, 0.53521731E-09_JPRB, 0.53510091E-09_JPRB, &
  & 0.53499793E-09_JPRB, 0.53491256E-09_JPRB, 0.53484361E-09_JPRB, 0.53478755E-09_JPRB, 0.53474092E-09_JPRB, 0.53470173E-09_JPRB, &
  & 0.53466964E-09_JPRB, 0.53464322E-09_JPRB, 0.53462113E-09_JPRB, 0.53460147E-09_JPRB, 0.53458360E-09_JPRB, 0.53456684E-09_JPRB, &
  & 0.53455185E-09_JPRB, 0.53453575E-09_JPRB, 0.53451926E-09_JPRB, 0.53449989E-09_JPRB, 0.53448013E-09_JPRB, 0.53446148E-09_JPRB, &
  & 0.53444638E-09_JPRB, 0.53443283E-09_JPRB, 0.53441973E-09_JPRB, 0.53439769E-09_JPRB /)

RGHG6(:,63, 9) = (/ &
  & 0.53347610E-09_JPRB, 0.53353250E-09_JPRB, 0.53356519E-09_JPRB, 0.53359472E-09_JPRB, 0.53362598E-09_JPRB, 0.53366023E-09_JPRB, &
  & 0.53369298E-09_JPRB, 0.53372001E-09_JPRB, 0.53374233E-09_JPRB, 0.53376226E-09_JPRB, 0.53378379E-09_JPRB, 0.53380839E-09_JPRB, &
  & 0.53383842E-09_JPRB, 0.53387045E-09_JPRB, 0.53389321E-09_JPRB, 0.53389237E-09_JPRB, 0.53385690E-09_JPRB, 0.53378696E-09_JPRB, &
  & 0.53369453E-09_JPRB, 0.53360094E-09_JPRB, 0.53353688E-09_JPRB, 0.53353405E-09_JPRB, 0.53360993E-09_JPRB, 0.53376165E-09_JPRB, &
  & 0.53396393E-09_JPRB, 0.53419041E-09_JPRB, 0.53442212E-09_JPRB, 0.53465066E-09_JPRB, 0.53487276E-09_JPRB, 0.53508237E-09_JPRB, &
  & 0.53527316E-09_JPRB, 0.53543431E-09_JPRB, 0.53555776E-09_JPRB, 0.53563964E-09_JPRB, 0.53568022E-09_JPRB, 0.53568316E-09_JPRB, &
  & 0.53565280E-09_JPRB, 0.53559240E-09_JPRB, 0.53550647E-09_JPRB, 0.53540272E-09_JPRB, 0.53529065E-09_JPRB, 0.53518179E-09_JPRB, &
  & 0.53508487E-09_JPRB, 0.53500426E-09_JPRB, 0.53493887E-09_JPRB, 0.53488564E-09_JPRB, 0.53484145E-09_JPRB, 0.53480415E-09_JPRB, &
  & 0.53477311E-09_JPRB, 0.53474752E-09_JPRB, 0.53472582E-09_JPRB, 0.53470611E-09_JPRB, 0.53468713E-09_JPRB, 0.53466837E-09_JPRB, &
  & 0.53464888E-09_JPRB, 0.53462962E-09_JPRB, 0.53460714E-09_JPRB, 0.53458288E-09_JPRB, 0.53455729E-09_JPRB, 0.53453530E-09_JPRB, &
  & 0.53451676E-09_JPRB, 0.53450133E-09_JPRB, 0.53448479E-09_JPRB, 0.53445931E-09_JPRB /)

RGHG6(:,64, 9) = (/ &
  & 0.53365151E-09_JPRB, 0.53370319E-09_JPRB, 0.53373228E-09_JPRB, 0.53375832E-09_JPRB, 0.53378602E-09_JPRB, 0.53381644E-09_JPRB, &
  & 0.53384808E-09_JPRB, 0.53387594E-09_JPRB, 0.53390037E-09_JPRB, 0.53392424E-09_JPRB, 0.53394955E-09_JPRB, 0.53398075E-09_JPRB, &
  & 0.53401716E-09_JPRB, 0.53405375E-09_JPRB, 0.53407845E-09_JPRB, 0.53407667E-09_JPRB, 0.53403998E-09_JPRB, 0.53397087E-09_JPRB, &
  & 0.53387916E-09_JPRB, 0.53378590E-09_JPRB, 0.53371974E-09_JPRB, 0.53371019E-09_JPRB, 0.53377391E-09_JPRB, 0.53390858E-09_JPRB, &
  & 0.53409382E-09_JPRB, 0.53430471E-09_JPRB, 0.53452398E-09_JPRB, 0.53474192E-09_JPRB, 0.53495419E-09_JPRB, 0.53515470E-09_JPRB, &
  & 0.53533600E-09_JPRB, 0.53548854E-09_JPRB, 0.53560428E-09_JPRB, 0.53568083E-09_JPRB, 0.53571875E-09_JPRB, 0.53572230E-09_JPRB, &
  & 0.53569527E-09_JPRB, 0.53564025E-09_JPRB, 0.53556171E-09_JPRB, 0.53546600E-09_JPRB, 0.53536259E-09_JPRB, 0.53526128E-09_JPRB, &
  & 0.53517057E-09_JPRB, 0.53509480E-09_JPRB, 0.53503285E-09_JPRB, 0.53498217E-09_JPRB, 0.53494009E-09_JPRB, 0.53490457E-09_JPRB, &
  & 0.53487464E-09_JPRB, 0.53485005E-09_JPRB, 0.53482879E-09_JPRB, 0.53480942E-09_JPRB, 0.53478999E-09_JPRB, 0.53476967E-09_JPRB, &
  & 0.53474830E-09_JPRB, 0.53472393E-09_JPRB, 0.53469723E-09_JPRB, 0.53466653E-09_JPRB, 0.53463622E-09_JPRB, 0.53460902E-09_JPRB, &
  & 0.53458726E-09_JPRB, 0.53456728E-09_JPRB, 0.53454713E-09_JPRB, 0.53451260E-09_JPRB /)

RGHG6(:,65, 9) = (/ &
  & 0.53380939E-09_JPRB, 0.53385935E-09_JPRB, 0.53388732E-09_JPRB, 0.53391191E-09_JPRB, 0.53393767E-09_JPRB, 0.53396670E-09_JPRB, &
  & 0.53399696E-09_JPRB, 0.53402716E-09_JPRB, 0.53405452E-09_JPRB, 0.53408261E-09_JPRB, 0.53411409E-09_JPRB, 0.53415089E-09_JPRB, &
  & 0.53419358E-09_JPRB, 0.53423288E-09_JPRB, 0.53425653E-09_JPRB, 0.53425375E-09_JPRB, 0.53421745E-09_JPRB, 0.53414972E-09_JPRB, &
  & 0.53406013E-09_JPRB, 0.53396843E-09_JPRB, 0.53390159E-09_JPRB, 0.53388705E-09_JPRB, 0.53394023E-09_JPRB, 0.53406035E-09_JPRB, &
  & 0.53422911E-09_JPRB, 0.53442489E-09_JPRB, 0.53463101E-09_JPRB, 0.53483723E-09_JPRB, 0.53503885E-09_JPRB, 0.53522869E-09_JPRB, &
  & 0.53539950E-09_JPRB, 0.53554200E-09_JPRB, 0.53564914E-09_JPRB, 0.53571969E-09_JPRB, 0.53575483E-09_JPRB, 0.53575866E-09_JPRB, &
  & 0.53573451E-09_JPRB, 0.53568516E-09_JPRB, 0.53561389E-09_JPRB, 0.53552696E-09_JPRB, 0.53543203E-09_JPRB, 0.53533861E-09_JPRB, &
  & 0.53525429E-09_JPRB, 0.53518323E-09_JPRB, 0.53512461E-09_JPRB, 0.53507665E-09_JPRB, 0.53503663E-09_JPRB, 0.53500260E-09_JPRB, &
  & 0.53497401E-09_JPRB, 0.53495020E-09_JPRB, 0.53492966E-09_JPRB, 0.53491045E-09_JPRB, 0.53489141E-09_JPRB, 0.53487037E-09_JPRB, &
  & 0.53484683E-09_JPRB, 0.53481991E-09_JPRB, 0.53478832E-09_JPRB, 0.53475374E-09_JPRB, 0.53471788E-09_JPRB, 0.53468641E-09_JPRB, &
  & 0.53465865E-09_JPRB, 0.53463411E-09_JPRB, 0.53460597E-09_JPRB, 0.53456084E-09_JPRB /)

RGHG6(:,66, 9) = (/ &
  & 0.53395000E-09_JPRB, 0.53400395E-09_JPRB, 0.53403321E-09_JPRB, 0.53405852E-09_JPRB, 0.53408428E-09_JPRB, 0.53411242E-09_JPRB, &
  & 0.53414384E-09_JPRB, 0.53417448E-09_JPRB, 0.53420690E-09_JPRB, 0.53423910E-09_JPRB, 0.53427657E-09_JPRB, 0.53431964E-09_JPRB, &
  & 0.53436494E-09_JPRB, 0.53440385E-09_JPRB, 0.53442661E-09_JPRB, 0.53442362E-09_JPRB, 0.53438848E-09_JPRB, 0.53432314E-09_JPRB, &
  & 0.53423699E-09_JPRB, 0.53414800E-09_JPRB, 0.53408211E-09_JPRB, 0.53406435E-09_JPRB, 0.53410903E-09_JPRB, 0.53421578E-09_JPRB, &
  & 0.53436910E-09_JPRB, 0.53454963E-09_JPRB, 0.53474142E-09_JPRB, 0.53493493E-09_JPRB, 0.53512422E-09_JPRB, 0.53530219E-09_JPRB, &
  & 0.53546123E-09_JPRB, 0.53559274E-09_JPRB, 0.53569099E-09_JPRB, 0.53575527E-09_JPRB, 0.53578753E-09_JPRB, 0.53579136E-09_JPRB, &
  & 0.53577009E-09_JPRB, 0.53572619E-09_JPRB, 0.53566246E-09_JPRB, 0.53558413E-09_JPRB, 0.53549820E-09_JPRB, 0.53541288E-09_JPRB, &
  & 0.53533517E-09_JPRB, 0.53526883E-09_JPRB, 0.53521376E-09_JPRB, 0.53516824E-09_JPRB, 0.53513022E-09_JPRB, 0.53509797E-09_JPRB, &
  & 0.53507071E-09_JPRB, 0.53504789E-09_JPRB, 0.53502824E-09_JPRB, 0.53500959E-09_JPRB, 0.53499066E-09_JPRB, 0.53496940E-09_JPRB, &
  & 0.53494476E-09_JPRB, 0.53491545E-09_JPRB, 0.53488136E-09_JPRB, 0.53484334E-09_JPRB, 0.53480420E-09_JPRB, 0.53476745E-09_JPRB, &
  & 0.53473509E-09_JPRB, 0.53470284E-09_JPRB, 0.53466637E-09_JPRB, 0.53460353E-09_JPRB /)

RGHG6(:,67, 9) = (/ &
  & 0.53407845E-09_JPRB, 0.53414018E-09_JPRB, 0.53417337E-09_JPRB, 0.53420085E-09_JPRB, 0.53422811E-09_JPRB, 0.53425731E-09_JPRB, &
  & 0.53428861E-09_JPRB, 0.53432336E-09_JPRB, 0.53435695E-09_JPRB, 0.53439603E-09_JPRB, 0.53443744E-09_JPRB, 0.53448357E-09_JPRB, &
  & 0.53452931E-09_JPRB, 0.53456639E-09_JPRB, 0.53458843E-09_JPRB, 0.53458588E-09_JPRB, 0.53455279E-09_JPRB, 0.53449101E-09_JPRB, &
  & 0.53440929E-09_JPRB, 0.53432481E-09_JPRB, 0.53426102E-09_JPRB, 0.53424137E-09_JPRB, 0.53427884E-09_JPRB, 0.53437366E-09_JPRB, &
  & 0.53451171E-09_JPRB, 0.53467641E-09_JPRB, 0.53485349E-09_JPRB, 0.53503274E-09_JPRB, 0.53520843E-09_JPRB, 0.53537358E-09_JPRB, &
  & 0.53551985E-09_JPRB, 0.53564014E-09_JPRB, 0.53572918E-09_JPRB, 0.53578725E-09_JPRB, 0.53581650E-09_JPRB, 0.53582050E-09_JPRB, &
  & 0.53580190E-09_JPRB, 0.53576316E-09_JPRB, 0.53570659E-09_JPRB, 0.53563698E-09_JPRB, 0.53555999E-09_JPRB, 0.53548299E-09_JPRB, &
  & 0.53541233E-09_JPRB, 0.53535087E-09_JPRB, 0.53529947E-09_JPRB, 0.53525667E-09_JPRB, 0.53522081E-09_JPRB, 0.53519034E-09_JPRB, &
  & 0.53516441E-09_JPRB, 0.53514299E-09_JPRB, 0.53512444E-09_JPRB, 0.53510657E-09_JPRB, 0.53508803E-09_JPRB, 0.53506660E-09_JPRB, &
  & 0.53504140E-09_JPRB, 0.53501092E-09_JPRB, 0.53497501E-09_JPRB, 0.53493543E-09_JPRB, 0.53489352E-09_JPRB, 0.53485388E-09_JPRB, &
  & 0.53481575E-09_JPRB, 0.53477733E-09_JPRB, 0.53472893E-09_JPRB, 0.53464599E-09_JPRB /)

RGHG6(:,68, 9) = (/ &
  & 0.53419658E-09_JPRB, 0.53427140E-09_JPRB, 0.53431037E-09_JPRB, 0.53434179E-09_JPRB, 0.53437166E-09_JPRB, 0.53440236E-09_JPRB, &
  & 0.53443583E-09_JPRB, 0.53447063E-09_JPRB, 0.53450999E-09_JPRB, 0.53454996E-09_JPRB, 0.53459542E-09_JPRB, 0.53464178E-09_JPRB, &
  & 0.53468546E-09_JPRB, 0.53472088E-09_JPRB, 0.53474247E-09_JPRB, 0.53474070E-09_JPRB, 0.53471005E-09_JPRB, 0.53465254E-09_JPRB, &
  & 0.53457672E-09_JPRB, 0.53449772E-09_JPRB, 0.53443727E-09_JPRB, 0.53441701E-09_JPRB, 0.53444787E-09_JPRB, 0.53453125E-09_JPRB, &
  & 0.53465443E-09_JPRB, 0.53480365E-09_JPRB, 0.53496479E-09_JPRB, 0.53512927E-09_JPRB, 0.53529048E-09_JPRB, 0.53544158E-09_JPRB, &
  & 0.53557508E-09_JPRB, 0.53568383E-09_JPRB, 0.53576410E-09_JPRB, 0.53581595E-09_JPRB, 0.53584231E-09_JPRB, 0.53584626E-09_JPRB, &
  & 0.53583010E-09_JPRB, 0.53579630E-09_JPRB, 0.53574661E-09_JPRB, 0.53568522E-09_JPRB, 0.53561705E-09_JPRB, 0.53554838E-09_JPRB, &
  & 0.53548466E-09_JPRB, 0.53542887E-09_JPRB, 0.53538141E-09_JPRB, 0.53534149E-09_JPRB, 0.53530802E-09_JPRB, 0.53527932E-09_JPRB, &
  & 0.53525528E-09_JPRB, 0.53523530E-09_JPRB, 0.53521798E-09_JPRB, 0.53520122E-09_JPRB, 0.53518334E-09_JPRB, 0.53516230E-09_JPRB, &
  & 0.53513705E-09_JPRB, 0.53510613E-09_JPRB, 0.53506949E-09_JPRB, 0.53502891E-09_JPRB, 0.53498606E-09_JPRB, 0.53494398E-09_JPRB, &
  & 0.53490257E-09_JPRB, 0.53485827E-09_JPRB, 0.53479920E-09_JPRB, 0.53469557E-09_JPRB /)

RGHG6(:,69, 9) = (/ &
  & 0.53430566E-09_JPRB, 0.53439997E-09_JPRB, 0.53444710E-09_JPRB, 0.53448407E-09_JPRB, 0.53451699E-09_JPRB, 0.53455007E-09_JPRB, &
  & 0.53458421E-09_JPRB, 0.53462168E-09_JPRB, 0.53466093E-09_JPRB, 0.53470423E-09_JPRB, 0.53474897E-09_JPRB, 0.53479393E-09_JPRB, &
  & 0.53483490E-09_JPRB, 0.53486793E-09_JPRB, 0.53488902E-09_JPRB, 0.53488824E-09_JPRB, 0.53486066E-09_JPRB, 0.53480820E-09_JPRB, &
  & 0.53473870E-09_JPRB, 0.53466626E-09_JPRB, 0.53461036E-09_JPRB, 0.53458943E-09_JPRB, 0.53461457E-09_JPRB, 0.53468685E-09_JPRB, &
  & 0.53479593E-09_JPRB, 0.53492910E-09_JPRB, 0.53507471E-09_JPRB, 0.53522348E-09_JPRB, 0.53536986E-09_JPRB, 0.53550669E-09_JPRB, &
  & 0.53562693E-09_JPRB, 0.53572435E-09_JPRB, 0.53579585E-09_JPRB, 0.53584182E-09_JPRB, 0.53586546E-09_JPRB, 0.53586902E-09_JPRB, &
  & 0.53585519E-09_JPRB, 0.53582577E-09_JPRB, 0.53578258E-09_JPRB, 0.53572902E-09_JPRB, 0.53566923E-09_JPRB, 0.53560872E-09_JPRB, &
  & 0.53555227E-09_JPRB, 0.53550214E-09_JPRB, 0.53545918E-09_JPRB, 0.53542271E-09_JPRB, 0.53539162E-09_JPRB, 0.53536536E-09_JPRB, &
  & 0.53534333E-09_JPRB, 0.53532512E-09_JPRB, 0.53530924E-09_JPRB, 0.53529381E-09_JPRB, 0.53527710E-09_JPRB, 0.53525695E-09_JPRB, &
  & 0.53523203E-09_JPRB, 0.53520144E-09_JPRB, 0.53516502E-09_JPRB, 0.53512472E-09_JPRB, 0.53508142E-09_JPRB, 0.53503868E-09_JPRB, &
  & 0.53499494E-09_JPRB, 0.53494720E-09_JPRB, 0.53487914E-09_JPRB, 0.53475468E-09_JPRB /)

RGHG6(:,70, 9) = (/ &
  & 0.53441002E-09_JPRB, 0.53452787E-09_JPRB, 0.53458671E-09_JPRB, 0.53462912E-09_JPRB, 0.53466631E-09_JPRB, 0.53470062E-09_JPRB, &
  & 0.53473598E-09_JPRB, 0.53477367E-09_JPRB, 0.53481325E-09_JPRB, 0.53485555E-09_JPRB, 0.53489835E-09_JPRB, 0.53494043E-09_JPRB, &
  & 0.53497834E-09_JPRB, 0.53500904E-09_JPRB, 0.53502941E-09_JPRB, 0.53502913E-09_JPRB, 0.53500454E-09_JPRB, 0.53495741E-09_JPRB, &
  & 0.53489491E-09_JPRB, 0.53482957E-09_JPRB, 0.53477817E-09_JPRB, 0.53475757E-09_JPRB, 0.53477722E-09_JPRB, 0.53483934E-09_JPRB, &
  & 0.53493432E-09_JPRB, 0.53505211E-09_JPRB, 0.53518184E-09_JPRB, 0.53531513E-09_JPRB, 0.53544602E-09_JPRB, 0.53556848E-09_JPRB, &
  & 0.53567561E-09_JPRB, 0.53576188E-09_JPRB, 0.53582483E-09_JPRB, 0.53586502E-09_JPRB, 0.53588600E-09_JPRB, 0.53588933E-09_JPRB, &
  & 0.53587762E-09_JPRB, 0.53585231E-09_JPRB, 0.53581511E-09_JPRB, 0.53576876E-09_JPRB, 0.53571680E-09_JPRB, 0.53566396E-09_JPRB, &
  & 0.53561472E-09_JPRB, 0.53557064E-09_JPRB, 0.53553245E-09_JPRB, 0.53549976E-09_JPRB, 0.53547161E-09_JPRB, 0.53544802E-09_JPRB, &
  & 0.53542826E-09_JPRB, 0.53541205E-09_JPRB, 0.53539795E-09_JPRB, 0.53538401E-09_JPRB, 0.53536858E-09_JPRB, 0.53534982E-09_JPRB, &
  & 0.53532612E-09_JPRB, 0.53529708E-09_JPRB, 0.53526195E-09_JPRB, 0.53522298E-09_JPRB, 0.53518029E-09_JPRB, 0.53513788E-09_JPRB, &
  & 0.53509353E-09_JPRB, 0.53504479E-09_JPRB, 0.53497107E-09_JPRB, 0.53483251E-09_JPRB /)

RGHG6(:,71, 9) = (/ &
  & 0.53451599E-09_JPRB, 0.53466320E-09_JPRB, 0.53473087E-09_JPRB, 0.53477989E-09_JPRB, 0.53481930E-09_JPRB, 0.53485533E-09_JPRB, &
  & 0.53489058E-09_JPRB, 0.53492705E-09_JPRB, 0.53496618E-09_JPRB, 0.53500349E-09_JPRB, 0.53504462E-09_JPRB, 0.53508148E-09_JPRB, &
  & 0.53511451E-09_JPRB, 0.53514104E-09_JPRB, 0.53516125E-09_JPRB, 0.53516275E-09_JPRB, 0.53514154E-09_JPRB, 0.53509980E-09_JPRB, &
  & 0.53504456E-09_JPRB, 0.53498628E-09_JPRB, 0.53494009E-09_JPRB, 0.53491983E-09_JPRB, 0.53493487E-09_JPRB, 0.53498722E-09_JPRB, &
  & 0.53506916E-09_JPRB, 0.53517163E-09_JPRB, 0.53528587E-09_JPRB, 0.53540361E-09_JPRB, 0.53551935E-09_JPRB, 0.53562721E-09_JPRB, &
  & 0.53572136E-09_JPRB, 0.53579657E-09_JPRB, 0.53585147E-09_JPRB, 0.53588606E-09_JPRB, 0.53590432E-09_JPRB, 0.53590737E-09_JPRB, &
  & 0.53589738E-09_JPRB, 0.53587607E-09_JPRB, 0.53584437E-09_JPRB, 0.53580462E-09_JPRB, 0.53575999E-09_JPRB, 0.53571458E-09_JPRB, &
  & 0.53567206E-09_JPRB, 0.53563409E-09_JPRB, 0.53560101E-09_JPRB, 0.53557236E-09_JPRB, 0.53554766E-09_JPRB, 0.53552690E-09_JPRB, &
  & 0.53550975E-09_JPRB, 0.53549581E-09_JPRB, 0.53548349E-09_JPRB, 0.53547117E-09_JPRB, 0.53545757E-09_JPRB, 0.53544058E-09_JPRB, &
  & 0.53541888E-09_JPRB, 0.53539206E-09_JPRB, 0.53535948E-09_JPRB, 0.53532273E-09_JPRB, 0.53528210E-09_JPRB, 0.53524135E-09_JPRB, &
  & 0.53519833E-09_JPRB, 0.53515048E-09_JPRB, 0.53507604E-09_JPRB, 0.53492938E-09_JPRB /)

RGHG6(:,72, 9) = (/ &
  & 0.53463634E-09_JPRB, 0.53480631E-09_JPRB, 0.53488319E-09_JPRB, 0.53493487E-09_JPRB, 0.53497673E-09_JPRB, 0.53501215E-09_JPRB, &
  & 0.53504645E-09_JPRB, 0.53508226E-09_JPRB, 0.53511445E-09_JPRB, 0.53515231E-09_JPRB, 0.53518429E-09_JPRB, 0.53521931E-09_JPRB, &
  & 0.53524862E-09_JPRB, 0.53527199E-09_JPRB, 0.53528970E-09_JPRB, 0.53529020E-09_JPRB, 0.53527138E-09_JPRB, 0.53523491E-09_JPRB, &
  & 0.53518678E-09_JPRB, 0.53513610E-09_JPRB, 0.53509469E-09_JPRB, 0.53507576E-09_JPRB, 0.53508675E-09_JPRB, 0.53513027E-09_JPRB, &
  & 0.53519938E-09_JPRB, 0.53528715E-09_JPRB, 0.53538635E-09_JPRB, 0.53548876E-09_JPRB, 0.53558930E-09_JPRB, 0.53568283E-09_JPRB, &
  & 0.53576416E-09_JPRB, 0.53582871E-09_JPRB, 0.53587590E-09_JPRB, 0.53590504E-09_JPRB, 0.53592086E-09_JPRB, 0.53592358E-09_JPRB, &
  & 0.53591520E-09_JPRB, 0.53589722E-09_JPRB, 0.53587074E-09_JPRB, 0.53583704E-09_JPRB, 0.53579918E-09_JPRB, 0.53576077E-09_JPRB, &
  & 0.53572480E-09_JPRB, 0.53569249E-09_JPRB, 0.53566457E-09_JPRB, 0.53564014E-09_JPRB, 0.53561888E-09_JPRB, 0.53560129E-09_JPRB, &
  & 0.53558691E-09_JPRB, 0.53557536E-09_JPRB, 0.53556498E-09_JPRB, 0.53555438E-09_JPRB, 0.53554278E-09_JPRB, 0.53552796E-09_JPRB, &
  & 0.53550853E-09_JPRB, 0.53548538E-09_JPRB, 0.53545546E-09_JPRB, 0.53542282E-09_JPRB, 0.53538479E-09_JPRB, 0.53534760E-09_JPRB, &
  & 0.53530702E-09_JPRB, 0.53526261E-09_JPRB, 0.53519011E-09_JPRB, 0.53504295E-09_JPRB /)

RGHG6(:,73, 9) = (/ &
  & 0.53478727E-09_JPRB, 0.53496363E-09_JPRB, 0.53504112E-09_JPRB, 0.53509364E-09_JPRB, 0.53513421E-09_JPRB, 0.53516902E-09_JPRB, &
  & 0.53520133E-09_JPRB, 0.53523141E-09_JPRB, 0.53526455E-09_JPRB, 0.53529015E-09_JPRB, 0.53532395E-09_JPRB, 0.53534865E-09_JPRB, &
  & 0.53537086E-09_JPRB, 0.53538879E-09_JPRB, 0.53540827E-09_JPRB, 0.53541049E-09_JPRB, 0.53539406E-09_JPRB, 0.53536187E-09_JPRB, &
  & 0.53532123E-09_JPRB, 0.53527732E-09_JPRB, 0.53524168E-09_JPRB, 0.53522409E-09_JPRB, 0.53523164E-09_JPRB, 0.53526711E-09_JPRB, &
  & 0.53532445E-09_JPRB, 0.53539789E-09_JPRB, 0.53548244E-09_JPRB, 0.53557009E-09_JPRB, 0.53565541E-09_JPRB, 0.53573534E-09_JPRB, &
  & 0.53580373E-09_JPRB, 0.53585847E-09_JPRB, 0.53589821E-09_JPRB, 0.53592208E-09_JPRB, 0.53593557E-09_JPRB, 0.53593785E-09_JPRB, &
  & 0.53593086E-09_JPRB, 0.53591609E-09_JPRB, 0.53589444E-09_JPRB, 0.53586641E-09_JPRB, 0.53583482E-09_JPRB, 0.53580262E-09_JPRB, &
  & 0.53577282E-09_JPRB, 0.53574600E-09_JPRB, 0.53572291E-09_JPRB, 0.53570270E-09_JPRB, 0.53568494E-09_JPRB, 0.53567045E-09_JPRB, &
  & 0.53565874E-09_JPRB, 0.53564952E-09_JPRB, 0.53564120E-09_JPRB, 0.53563215E-09_JPRB, 0.53562266E-09_JPRB, 0.53560967E-09_JPRB, &
  & 0.53559368E-09_JPRB, 0.53557347E-09_JPRB, 0.53554844E-09_JPRB, 0.53551918E-09_JPRB, 0.53548621E-09_JPRB, 0.53545246E-09_JPRB, &
  & 0.53541666E-09_JPRB, 0.53537591E-09_JPRB, 0.53530974E-09_JPRB, 0.53516680E-09_JPRB /)

RGHG6(:,74, 9) = (/ &
  & 0.53495053E-09_JPRB, 0.53512567E-09_JPRB, 0.53520050E-09_JPRB, 0.53524973E-09_JPRB, 0.53528909E-09_JPRB, 0.53532018E-09_JPRB, &
  & 0.53534888E-09_JPRB, 0.53537763E-09_JPRB, 0.53540072E-09_JPRB, 0.53542915E-09_JPRB, 0.53545013E-09_JPRB, 0.53547577E-09_JPRB, &
  & 0.53549476E-09_JPRB, 0.53550891E-09_JPRB, 0.53552307E-09_JPRB, 0.53552335E-09_JPRB, 0.53550858E-09_JPRB, 0.53548077E-09_JPRB, &
  & 0.53544669E-09_JPRB, 0.53541027E-09_JPRB, 0.53537980E-09_JPRB, 0.53536442E-09_JPRB, 0.53536908E-09_JPRB, 0.53539717E-09_JPRB, &
  & 0.53544358E-09_JPRB, 0.53550342E-09_JPRB, 0.53557397E-09_JPRB, 0.53564692E-09_JPRB, 0.53571769E-09_JPRB, 0.53578431E-09_JPRB, &
  & 0.53584071E-09_JPRB, 0.53588556E-09_JPRB, 0.53591853E-09_JPRB, 0.53593735E-09_JPRB, 0.53594879E-09_JPRB, 0.53595067E-09_JPRB, &
  & 0.53594512E-09_JPRB, 0.53593302E-09_JPRB, 0.53591598E-09_JPRB, 0.53589300E-09_JPRB, 0.53586718E-09_JPRB, 0.53584054E-09_JPRB, &
  & 0.53581650E-09_JPRB, 0.53579496E-09_JPRB, 0.53577648E-09_JPRB, 0.53576016E-09_JPRB, 0.53574578E-09_JPRB, 0.53573407E-09_JPRB, &
  & 0.53572502E-09_JPRB, 0.53571791E-09_JPRB, 0.53571125E-09_JPRB, 0.53570376E-09_JPRB, 0.53569615E-09_JPRB, 0.53568544E-09_JPRB, &
  & 0.53567178E-09_JPRB, 0.53565591E-09_JPRB, 0.53563448E-09_JPRB, 0.53561067E-09_JPRB, 0.53558191E-09_JPRB, 0.53555377E-09_JPRB, &
  & 0.53552268E-09_JPRB, 0.53548777E-09_JPRB, 0.53542770E-09_JPRB, 0.53529431E-09_JPRB /)

RGHG6(:,75, 9) = (/ &
  & 0.53511906E-09_JPRB, 0.53528659E-09_JPRB, 0.53535498E-09_JPRB, 0.53540072E-09_JPRB, 0.53543525E-09_JPRB, 0.53546267E-09_JPRB, &
  & 0.53548771E-09_JPRB, 0.53551014E-09_JPRB, 0.53553351E-09_JPRB, 0.53555049E-09_JPRB, 0.53557303E-09_JPRB, 0.53558746E-09_JPRB, &
  & 0.53559712E-09_JPRB, 0.53560462E-09_JPRB, 0.53562510E-09_JPRB, 0.53562721E-09_JPRB, 0.53561466E-09_JPRB, 0.53559074E-09_JPRB, &
  & 0.53556387E-09_JPRB, 0.53553390E-09_JPRB, 0.53550903E-09_JPRB, 0.53549570E-09_JPRB, 0.53549809E-09_JPRB, 0.53551985E-09_JPRB, &
  & 0.53555649E-09_JPRB, 0.53560373E-09_JPRB, 0.53566057E-09_JPRB, 0.53571936E-09_JPRB, 0.53577615E-09_JPRB, 0.53582971E-09_JPRB, &
  & 0.53587462E-09_JPRB, 0.53591037E-09_JPRB, 0.53593702E-09_JPRB, 0.53595089E-09_JPRB, 0.53596044E-09_JPRB, 0.53596189E-09_JPRB, &
  & 0.53595756E-09_JPRB, 0.53594795E-09_JPRB, 0.53593513E-09_JPRB, 0.53591692E-09_JPRB, 0.53589655E-09_JPRB, 0.53587501E-09_JPRB, &
  & 0.53585647E-09_JPRB, 0.53583937E-09_JPRB, 0.53582538E-09_JPRB, 0.53581273E-09_JPRB, 0.53580129E-09_JPRB, 0.53579241E-09_JPRB, &
  & 0.53578553E-09_JPRB, 0.53578059E-09_JPRB, 0.53577548E-09_JPRB, 0.53576910E-09_JPRB, 0.53576332E-09_JPRB, 0.53575455E-09_JPRB, &
  & 0.53574384E-09_JPRB, 0.53573102E-09_JPRB, 0.53571447E-09_JPRB, 0.53569477E-09_JPRB, 0.53567184E-09_JPRB, 0.53564841E-09_JPRB, &
  & 0.53562366E-09_JPRB, 0.53559435E-09_JPRB, 0.53554211E-09_JPRB, 0.53542076E-09_JPRB /)

RGHG6(:,76, 9) = (/ &
  & 0.53528904E-09_JPRB, 0.53544247E-09_JPRB, 0.53550347E-09_JPRB, 0.53554206E-09_JPRB, 0.53557264E-09_JPRB, 0.53559390E-09_JPRB, &
  & 0.53561433E-09_JPRB, 0.53563409E-09_JPRB, 0.53564964E-09_JPRB, 0.53566662E-09_JPRB, 0.53567983E-09_JPRB, 0.53569349E-09_JPRB, &
  & 0.53570232E-09_JPRB, 0.53570809E-09_JPRB, 0.53572108E-09_JPRB, 0.53572236E-09_JPRB, 0.53571214E-09_JPRB, 0.53569199E-09_JPRB, &
  & 0.53567212E-09_JPRB, 0.53564880E-09_JPRB, 0.53562904E-09_JPRB, 0.53561811E-09_JPRB, 0.53561855E-09_JPRB, 0.53563504E-09_JPRB, &
  & 0.53566318E-09_JPRB, 0.53569837E-09_JPRB, 0.53574223E-09_JPRB, 0.53578725E-09_JPRB, 0.53583071E-09_JPRB, 0.53587135E-09_JPRB, &
  & 0.53590576E-09_JPRB, 0.53593302E-09_JPRB, 0.53595384E-09_JPRB, 0.53596305E-09_JPRB, 0.53597110E-09_JPRB, 0.53597227E-09_JPRB, &
  & 0.53596894E-09_JPRB, 0.53596122E-09_JPRB, 0.53595245E-09_JPRB, 0.53593857E-09_JPRB, 0.53592331E-09_JPRB, 0.53590643E-09_JPRB, &
  & 0.53589277E-09_JPRB, 0.53588006E-09_JPRB, 0.53587013E-09_JPRB, 0.53586080E-09_JPRB, 0.53585214E-09_JPRB, 0.53584537E-09_JPRB, &
  & 0.53584059E-09_JPRB, 0.53583737E-09_JPRB, 0.53583366E-09_JPRB, 0.53582827E-09_JPRB, 0.53582444E-09_JPRB, 0.53581745E-09_JPRB, &
  & 0.53580912E-09_JPRB, 0.53579963E-09_JPRB, 0.53578697E-09_JPRB, 0.53577198E-09_JPRB, 0.53575444E-09_JPRB, 0.53573646E-09_JPRB, &
  & 0.53571791E-09_JPRB, 0.53569488E-09_JPRB, 0.53565130E-09_JPRB, 0.53554389E-09_JPRB /)

RGHG6(:,77, 9) = (/ &
  & 0.53545818E-09_JPRB, 0.53559235E-09_JPRB, 0.53564209E-09_JPRB, 0.53567395E-09_JPRB, 0.53569849E-09_JPRB, 0.53571353E-09_JPRB, &
  & 0.53572874E-09_JPRB, 0.53574356E-09_JPRB, 0.53575622E-09_JPRB, 0.53576527E-09_JPRB, 0.53577692E-09_JPRB, 0.53578253E-09_JPRB, &
  & 0.53578053E-09_JPRB, 0.53577742E-09_JPRB, 0.53580268E-09_JPRB, 0.53580640E-09_JPRB, 0.53579902E-09_JPRB, 0.53578264E-09_JPRB, &
  & 0.53577021E-09_JPRB, 0.53575322E-09_JPRB, 0.53573856E-09_JPRB, 0.53573018E-09_JPRB, 0.53572924E-09_JPRB, 0.53574151E-09_JPRB, &
  & 0.53576227E-09_JPRB, 0.53578619E-09_JPRB, 0.53581772E-09_JPRB, 0.53585014E-09_JPRB, 0.53588056E-09_JPRB, 0.53590926E-09_JPRB, &
  & 0.53593380E-09_JPRB, 0.53595345E-09_JPRB, 0.53596899E-09_JPRB, 0.53597349E-09_JPRB, 0.53598020E-09_JPRB, 0.53598104E-09_JPRB, &
  & 0.53597865E-09_JPRB, 0.53597277E-09_JPRB, 0.53596783E-09_JPRB, 0.53595783E-09_JPRB, 0.53594740E-09_JPRB, 0.53593435E-09_JPRB, &
  & 0.53592547E-09_JPRB, 0.53591670E-09_JPRB, 0.53591032E-09_JPRB, 0.53590427E-09_JPRB, 0.53589749E-09_JPRB, 0.53589272E-09_JPRB, &
  & 0.53588950E-09_JPRB, 0.53588789E-09_JPRB, 0.53588545E-09_JPRB, 0.53588090E-09_JPRB, 0.53587901E-09_JPRB, 0.53587362E-09_JPRB, &
  & 0.53586729E-09_JPRB, 0.53586119E-09_JPRB, 0.53585236E-09_JPRB, 0.53584154E-09_JPRB, 0.53582938E-09_JPRB, 0.53581661E-09_JPRB, &
  & 0.53580457E-09_JPRB, 0.53578825E-09_JPRB, 0.53575266E-09_JPRB, 0.53566368E-09_JPRB /)

RGHG6(:,78, 9) = (/ &
  & 0.53562754E-09_JPRB, 0.53572835E-09_JPRB, 0.53576327E-09_JPRB, 0.53578642E-09_JPRB, 0.53580634E-09_JPRB, 0.53581395E-09_JPRB, &
  & 0.53582416E-09_JPRB, 0.53583510E-09_JPRB, 0.53584215E-09_JPRB, 0.53584759E-09_JPRB, 0.53585447E-09_JPRB, 0.53585747E-09_JPRB, &
  & 0.53585647E-09_JPRB, 0.53585375E-09_JPRB, 0.53587207E-09_JPRB, 0.53587551E-09_JPRB, 0.53587063E-09_JPRB, 0.53585736E-09_JPRB, &
  & 0.53585214E-09_JPRB, 0.53584093E-09_JPRB, 0.53583132E-09_JPRB, 0.53582583E-09_JPRB, 0.53582416E-09_JPRB, 0.53583332E-09_JPRB, &
  & 0.53584825E-09_JPRB, 0.53586224E-09_JPRB, 0.53588312E-09_JPRB, 0.53590465E-09_JPRB, 0.53592319E-09_JPRB, 0.53594168E-09_JPRB, &
  & 0.53595745E-09_JPRB, 0.53597060E-09_JPRB, 0.53598181E-09_JPRB, 0.53598220E-09_JPRB, 0.53598825E-09_JPRB, 0.53598903E-09_JPRB, &
  & 0.53598737E-09_JPRB, 0.53598259E-09_JPRB, 0.53598070E-09_JPRB, 0.53597404E-09_JPRB, 0.53596771E-09_JPRB, 0.53595794E-09_JPRB, &
  & 0.53595289E-09_JPRB, 0.53594740E-09_JPRB, 0.53594396E-09_JPRB, 0.53594040E-09_JPRB, 0.53593519E-09_JPRB, 0.53593163E-09_JPRB, &
  & 0.53592986E-09_JPRB, 0.53592936E-09_JPRB, 0.53592780E-09_JPRB, 0.53592392E-09_JPRB, 0.53592392E-09_JPRB, 0.53591986E-09_JPRB, &
  & 0.53591553E-09_JPRB, 0.53591231E-09_JPRB, 0.53590699E-09_JPRB, 0.53589966E-09_JPRB, 0.53589261E-09_JPRB, 0.53588423E-09_JPRB, &
  & 0.53587812E-09_JPRB, 0.53586768E-09_JPRB, 0.53584320E-09_JPRB, 0.53577759E-09_JPRB /)

RGHG6(:,79, 9) = (/ &
  & 0.53573856E-09_JPRB, 0.53580462E-09_JPRB, 0.53582733E-09_JPRB, 0.53584509E-09_JPRB, 0.53586297E-09_JPRB, 0.53586596E-09_JPRB, &
  & 0.53587335E-09_JPRB, 0.53588251E-09_JPRB, 0.53588700E-09_JPRB, 0.53588900E-09_JPRB, 0.53589488E-09_JPRB, 0.53589583E-09_JPRB, &
  & 0.53589561E-09_JPRB, 0.53589311E-09_JPRB, 0.53590837E-09_JPRB, 0.53591176E-09_JPRB, 0.53590837E-09_JPRB, 0.53589622E-09_JPRB, &
  & 0.53589544E-09_JPRB, 0.53588739E-09_JPRB, 0.53588045E-09_JPRB, 0.53587673E-09_JPRB, 0.53587440E-09_JPRB, 0.53588251E-09_JPRB, &
  & 0.53589461E-09_JPRB, 0.53590310E-09_JPRB, 0.53591859E-09_JPRB, 0.53593419E-09_JPRB, 0.53594640E-09_JPRB, 0.53595939E-09_JPRB, &
  & 0.53597032E-09_JPRB, 0.53598004E-09_JPRB, 0.53598920E-09_JPRB, 0.53598692E-09_JPRB, 0.53599286E-09_JPRB, 0.53599358E-09_JPRB, &
  & 0.53599236E-09_JPRB, 0.53598792E-09_JPRB, 0.53598792E-09_JPRB, 0.53598287E-09_JPRB, 0.53597871E-09_JPRB, 0.53597049E-09_JPRB, &
  & 0.53596744E-09_JPRB, 0.53596361E-09_JPRB, 0.53596172E-09_JPRB, 0.53595955E-09_JPRB, 0.53595473E-09_JPRB, 0.53595162E-09_JPRB, &
  & 0.53595067E-09_JPRB, 0.53595084E-09_JPRB, 0.53594967E-09_JPRB, 0.53594573E-09_JPRB, 0.53594718E-09_JPRB, 0.53594351E-09_JPRB, &
  & 0.53593990E-09_JPRB, 0.53593857E-09_JPRB, 0.53593491E-09_JPRB, 0.53592925E-09_JPRB, 0.53592475E-09_JPRB, 0.53591853E-09_JPRB, &
  & 0.53591592E-09_JPRB, 0.53590998E-09_JPRB, 0.53589266E-09_JPRB, 0.53585003E-09_JPRB /)

RGHG6(:,80, 9) = (/ &
  & 0.53581378E-09_JPRB, 0.53584126E-09_JPRB, 0.53585508E-09_JPRB, 0.53587029E-09_JPRB, 0.53588778E-09_JPRB, 0.53588850E-09_JPRB, &
  & 0.53589455E-09_JPRB, 0.53590304E-09_JPRB, 0.53590632E-09_JPRB, 0.53590693E-09_JPRB, 0.53591237E-09_JPRB, 0.53591243E-09_JPRB, &
  & 0.53591287E-09_JPRB, 0.53591043E-09_JPRB, 0.53592453E-09_JPRB, 0.53592819E-09_JPRB, 0.53592530E-09_JPRB, 0.53591331E-09_JPRB, &
  & 0.53591509E-09_JPRB, 0.53590837E-09_JPRB, 0.53590266E-09_JPRB, 0.53589966E-09_JPRB, 0.53589699E-09_JPRB, 0.53590465E-09_JPRB, &
  & 0.53591576E-09_JPRB, 0.53592164E-09_JPRB, 0.53593457E-09_JPRB, 0.53594768E-09_JPRB, 0.53595700E-09_JPRB, 0.53596755E-09_JPRB, &
  & 0.53597615E-09_JPRB, 0.53598442E-09_JPRB, 0.53599275E-09_JPRB, 0.53598898E-09_JPRB, 0.53599503E-09_JPRB, 0.53599580E-09_JPRB, &
  & 0.53599480E-09_JPRB, 0.53599031E-09_JPRB, 0.53599136E-09_JPRB, 0.53598714E-09_JPRB, 0.53598381E-09_JPRB, 0.53597615E-09_JPRB, &
  & 0.53597404E-09_JPRB, 0.53597088E-09_JPRB, 0.53596988E-09_JPRB, 0.53596827E-09_JPRB, 0.53596350E-09_JPRB, 0.53596055E-09_JPRB, &
  & 0.53595989E-09_JPRB, 0.53596044E-09_JPRB, 0.53595961E-09_JPRB, 0.53595517E-09_JPRB, 0.53595728E-09_JPRB, 0.53595361E-09_JPRB, &
  & 0.53595023E-09_JPRB, 0.53594967E-09_JPRB, 0.53594679E-09_JPRB, 0.53594168E-09_JPRB, 0.53593852E-09_JPRB, 0.53593296E-09_JPRB, &
  & 0.53593219E-09_JPRB, 0.53592841E-09_JPRB, 0.53591637E-09_JPRB, 0.53589722E-09_JPRB /)

RGHG6(:,81, 9) = (/ &
  & 0.53586668E-09_JPRB, 0.53585664E-09_JPRB, 0.53586657E-09_JPRB, 0.53588084E-09_JPRB, 0.53589855E-09_JPRB, 0.53589805E-09_JPRB, &
  & 0.53590360E-09_JPRB, 0.53591215E-09_JPRB, 0.53591459E-09_JPRB, 0.53591487E-09_JPRB, 0.53591975E-09_JPRB, 0.53591964E-09_JPRB, &
  & 0.53592047E-09_JPRB, 0.53591798E-09_JPRB, 0.53593163E-09_JPRB, 0.53593552E-09_JPRB, 0.53593296E-09_JPRB, 0.53592070E-09_JPRB, &
  & 0.53592397E-09_JPRB, 0.53591775E-09_JPRB, 0.53591265E-09_JPRB, 0.53590993E-09_JPRB, 0.53590682E-09_JPRB, 0.53591442E-09_JPRB, &
  & 0.53592508E-09_JPRB, 0.53592991E-09_JPRB, 0.53594168E-09_JPRB, 0.53595373E-09_JPRB, 0.53596172E-09_JPRB, 0.53597105E-09_JPRB, &
  & 0.53597876E-09_JPRB, 0.53598642E-09_JPRB, 0.53599436E-09_JPRB, 0.53598981E-09_JPRB, 0.53599603E-09_JPRB, 0.53599691E-09_JPRB, &
  & 0.53599591E-09_JPRB, 0.53599147E-09_JPRB, 0.53599292E-09_JPRB, 0.53598903E-09_JPRB, 0.53598603E-09_JPRB, 0.53597865E-09_JPRB, &
  & 0.53597687E-09_JPRB, 0.53597415E-09_JPRB, 0.53597343E-09_JPRB, 0.53597227E-09_JPRB, 0.53596744E-09_JPRB, 0.53596438E-09_JPRB, &
  & 0.53596405E-09_JPRB, 0.53596477E-09_JPRB, 0.53596405E-09_JPRB, 0.53595933E-09_JPRB, 0.53596172E-09_JPRB, 0.53595789E-09_JPRB, &
  & 0.53595456E-09_JPRB, 0.53595428E-09_JPRB, 0.53595173E-09_JPRB, 0.53594695E-09_JPRB, 0.53594423E-09_JPRB, 0.53593896E-09_JPRB, &
  & 0.53593896E-09_JPRB, 0.53593630E-09_JPRB, 0.53592619E-09_JPRB, 0.53592963E-09_JPRB /)

RGHG6(:,82, 9) = (/ &
  & 0.53587101E-09_JPRB, 0.53586147E-09_JPRB, 0.53587146E-09_JPRB, 0.53588589E-09_JPRB, 0.53590377E-09_JPRB, 0.53590271E-09_JPRB, &
  & 0.53590837E-09_JPRB, 0.53591603E-09_JPRB, 0.53591853E-09_JPRB, 0.53591837E-09_JPRB, 0.53592347E-09_JPRB, 0.53592308E-09_JPRB, &
  & 0.53592403E-09_JPRB, 0.53592164E-09_JPRB, 0.53593507E-09_JPRB, 0.53593924E-09_JPRB, 0.53593668E-09_JPRB, 0.53592419E-09_JPRB, &
  & 0.53592836E-09_JPRB, 0.53592253E-09_JPRB, 0.53591753E-09_JPRB, 0.53591498E-09_JPRB, 0.53591159E-09_JPRB, 0.53591920E-09_JPRB, &
  & 0.53592969E-09_JPRB, 0.53593391E-09_JPRB, 0.53594534E-09_JPRB, 0.53595667E-09_JPRB, 0.53596411E-09_JPRB, 0.53597293E-09_JPRB, &
  & 0.53598004E-09_JPRB, 0.53598737E-09_JPRB, 0.53599519E-09_JPRB, 0.53599031E-09_JPRB, 0.53599658E-09_JPRB, 0.53599747E-09_JPRB, &
  & 0.53599652E-09_JPRB, 0.53599208E-09_JPRB, 0.53599375E-09_JPRB, 0.53598997E-09_JPRB, 0.53598714E-09_JPRB, 0.53597982E-09_JPRB, &
  & 0.53597837E-09_JPRB, 0.53597576E-09_JPRB, 0.53597532E-09_JPRB, 0.53597421E-09_JPRB, 0.53596932E-09_JPRB, 0.53596633E-09_JPRB, &
  & 0.53596599E-09_JPRB, 0.53596683E-09_JPRB, 0.53596610E-09_JPRB, 0.53596116E-09_JPRB, 0.53596394E-09_JPRB, 0.53596000E-09_JPRB, &
  & 0.53595661E-09_JPRB, 0.53595656E-09_JPRB, 0.53595406E-09_JPRB, 0.53594940E-09_JPRB, 0.53594695E-09_JPRB, 0.53594201E-09_JPRB, &
  & 0.53594235E-09_JPRB, 0.53593974E-09_JPRB, 0.53592947E-09_JPRB, 0.53593213E-09_JPRB /)

RGHG6(:,83, 9) = (/ &
  & 0.53587401E-09_JPRB, 0.53586424E-09_JPRB, 0.53587423E-09_JPRB, 0.53588856E-09_JPRB, 0.53590676E-09_JPRB, 0.53590549E-09_JPRB, &
  & 0.53591054E-09_JPRB, 0.53591903E-09_JPRB, 0.53592070E-09_JPRB, 0.53592109E-09_JPRB, 0.53592492E-09_JPRB, 0.53592486E-09_JPRB, &
  & 0.53592591E-09_JPRB, 0.53592386E-09_JPRB, 0.53593696E-09_JPRB, 0.53594135E-09_JPRB, 0.53593890E-09_JPRB, 0.53592614E-09_JPRB, &
  & 0.53593097E-09_JPRB, 0.53592519E-09_JPRB, 0.53592025E-09_JPRB, 0.53591781E-09_JPRB, 0.53591409E-09_JPRB, 0.53592203E-09_JPRB, &
  & 0.53593241E-09_JPRB, 0.53593624E-09_JPRB, 0.53594740E-09_JPRB, 0.53595839E-09_JPRB, 0.53596549E-09_JPRB, 0.53597382E-09_JPRB, &
  & 0.53598070E-09_JPRB, 0.53598787E-09_JPRB, 0.53599569E-09_JPRB, 0.53599059E-09_JPRB, 0.53599691E-09_JPRB, 0.53599786E-09_JPRB, &
  & 0.53599680E-09_JPRB, 0.53599236E-09_JPRB, 0.53599403E-09_JPRB, 0.53599047E-09_JPRB, 0.53598770E-09_JPRB, 0.53598048E-09_JPRB, &
  & 0.53597909E-09_JPRB, 0.53597665E-09_JPRB, 0.53597637E-09_JPRB, 0.53597538E-09_JPRB, 0.53597038E-09_JPRB, 0.53596744E-09_JPRB, &
  & 0.53596722E-09_JPRB, 0.53596799E-09_JPRB, 0.53596738E-09_JPRB, 0.53596216E-09_JPRB, 0.53596516E-09_JPRB, 0.53596105E-09_JPRB, &
  & 0.53595767E-09_JPRB, 0.53595783E-09_JPRB, 0.53595539E-09_JPRB, 0.53595084E-09_JPRB, 0.53594845E-09_JPRB, 0.53594346E-09_JPRB, &
  & 0.53594418E-09_JPRB, 0.53594185E-09_JPRB, 0.53593141E-09_JPRB, 0.53593396E-09_JPRB /)

RGHG6(:,84, 9) = (/ &
  & 0.53587618E-09_JPRB, 0.53586607E-09_JPRB, 0.53587568E-09_JPRB, 0.53589033E-09_JPRB, 0.53590876E-09_JPRB, 0.53590721E-09_JPRB, &
  & 0.53591298E-09_JPRB, 0.53591959E-09_JPRB, 0.53592181E-09_JPRB, 0.53592203E-09_JPRB, 0.53592614E-09_JPRB, 0.53592608E-09_JPRB, &
  & 0.53592702E-09_JPRB, 0.53592580E-09_JPRB, 0.53593768E-09_JPRB, 0.53594257E-09_JPRB, 0.53594024E-09_JPRB, 0.53592747E-09_JPRB, &
  & 0.53593263E-09_JPRB, 0.53592691E-09_JPRB, 0.53592186E-09_JPRB, 0.53591953E-09_JPRB, 0.53591559E-09_JPRB, 0.53592347E-09_JPRB, &
  & 0.53593424E-09_JPRB, 0.53593768E-09_JPRB, 0.53594873E-09_JPRB, 0.53595961E-09_JPRB, 0.53596622E-09_JPRB, 0.53597449E-09_JPRB, &
  & 0.53598115E-09_JPRB, 0.53598825E-09_JPRB, 0.53599591E-09_JPRB, 0.53599064E-09_JPRB, 0.53599719E-09_JPRB, 0.53599813E-09_JPRB, &
  & 0.53599702E-09_JPRB, 0.53599258E-09_JPRB, 0.53599425E-09_JPRB, 0.53599081E-09_JPRB, 0.53598809E-09_JPRB, 0.53598087E-09_JPRB, &
  & 0.53597971E-09_JPRB, 0.53597715E-09_JPRB, 0.53597704E-09_JPRB, 0.53597621E-09_JPRB, 0.53597099E-09_JPRB, 0.53596805E-09_JPRB, &
  & 0.53596783E-09_JPRB, 0.53596882E-09_JPRB, 0.53596810E-09_JPRB, 0.53596294E-09_JPRB, 0.53596594E-09_JPRB, 0.53596172E-09_JPRB, &
  & 0.53595833E-09_JPRB, 0.53595861E-09_JPRB, 0.53595611E-09_JPRB, 0.53595151E-09_JPRB, 0.53594934E-09_JPRB, 0.53594429E-09_JPRB, &
  & 0.53594534E-09_JPRB, 0.53594312E-09_JPRB, 0.53593269E-09_JPRB, 0.53593524E-09_JPRB /)

RGHG6(:,85, 9) = (/ &
  & 0.53587756E-09_JPRB, 0.53586724E-09_JPRB, 0.53587684E-09_JPRB, 0.53589144E-09_JPRB, 0.53591009E-09_JPRB, 0.53590882E-09_JPRB, &
  & 0.53591342E-09_JPRB, 0.53592120E-09_JPRB, 0.53592275E-09_JPRB, 0.53592369E-09_JPRB, 0.53592630E-09_JPRB, 0.53592680E-09_JPRB, &
  & 0.53592780E-09_JPRB, 0.53592797E-09_JPRB, 0.53593752E-09_JPRB, 0.53594235E-09_JPRB, 0.53594057E-09_JPRB, 0.53592897E-09_JPRB, &
  & 0.53593358E-09_JPRB, 0.53592802E-09_JPRB, 0.53592319E-09_JPRB, 0.53592064E-09_JPRB, 0.53591642E-09_JPRB, 0.53592464E-09_JPRB, &
  & 0.53593535E-09_JPRB, 0.53593857E-09_JPRB, 0.53594962E-09_JPRB, 0.53596017E-09_JPRB, 0.53596688E-09_JPRB, 0.53597471E-09_JPRB, &
  & 0.53598143E-09_JPRB, 0.53598848E-09_JPRB, 0.53599619E-09_JPRB, 0.53599070E-09_JPRB, 0.53599736E-09_JPRB, 0.53599836E-09_JPRB, &
  & 0.53599714E-09_JPRB, 0.53599264E-09_JPRB, 0.53599453E-09_JPRB, 0.53599114E-09_JPRB, 0.53598836E-09_JPRB, 0.53598120E-09_JPRB, &
  & 0.53598004E-09_JPRB, 0.53597765E-09_JPRB, 0.53597754E-09_JPRB, 0.53597671E-09_JPRB, 0.53597138E-09_JPRB, 0.53596855E-09_JPRB, &
  & 0.53596833E-09_JPRB, 0.53596932E-09_JPRB, 0.53596866E-09_JPRB, 0.53596333E-09_JPRB, 0.53596649E-09_JPRB, 0.53596211E-09_JPRB, &
  & 0.53595867E-09_JPRB, 0.53595917E-09_JPRB, 0.53595667E-09_JPRB, 0.53595212E-09_JPRB, 0.53594995E-09_JPRB, 0.53594496E-09_JPRB, &
  & 0.53594618E-09_JPRB, 0.53594407E-09_JPRB, 0.53593341E-09_JPRB, 0.53593613E-09_JPRB /)

RGHG6(:,86, 9) = (/ &
  & 0.53587879E-09_JPRB, 0.53586779E-09_JPRB, 0.53587718E-09_JPRB, 0.53589200E-09_JPRB, 0.53591098E-09_JPRB, 0.53590987E-09_JPRB, &
  & 0.53591620E-09_JPRB, 0.53592075E-09_JPRB, 0.53592319E-09_JPRB, 0.53592414E-09_JPRB, 0.53592658E-09_JPRB, 0.53592741E-09_JPRB, &
  & 0.53592875E-09_JPRB, 0.53592997E-09_JPRB, 0.53593691E-09_JPRB, 0.53594129E-09_JPRB, 0.53594013E-09_JPRB, 0.53593052E-09_JPRB, &
  & 0.53593396E-09_JPRB, 0.53592880E-09_JPRB, 0.53592392E-09_JPRB, 0.53592147E-09_JPRB, 0.53591687E-09_JPRB, 0.53592497E-09_JPRB, &
  & 0.53593624E-09_JPRB, 0.53593896E-09_JPRB, 0.53594995E-09_JPRB, 0.53596094E-09_JPRB, 0.53596710E-09_JPRB, 0.53597521E-09_JPRB, &
  & 0.53598159E-09_JPRB, 0.53598875E-09_JPRB, 0.53599647E-09_JPRB, 0.53599081E-09_JPRB, 0.53599758E-09_JPRB, 0.53599852E-09_JPRB, &
  & 0.53599730E-09_JPRB, 0.53599269E-09_JPRB, 0.53599480E-09_JPRB, 0.53599142E-09_JPRB, 0.53598859E-09_JPRB, 0.53598115E-09_JPRB, &
  & 0.53598015E-09_JPRB, 0.53597776E-09_JPRB, 0.53597782E-09_JPRB, 0.53597715E-09_JPRB, 0.53597171E-09_JPRB, 0.53596882E-09_JPRB, &
  & 0.53596860E-09_JPRB, 0.53596966E-09_JPRB, 0.53596894E-09_JPRB, 0.53596350E-09_JPRB, 0.53596683E-09_JPRB, 0.53596250E-09_JPRB, &
  & 0.53595900E-09_JPRB, 0.53595955E-09_JPRB, 0.53595695E-09_JPRB, 0.53595245E-09_JPRB, 0.53595034E-09_JPRB, 0.53594507E-09_JPRB, &
  & 0.53594668E-09_JPRB, 0.53594457E-09_JPRB, 0.53593396E-09_JPRB, 0.53593674E-09_JPRB /)

RGHG6(:,87, 9) = (/ &
  & 0.53587934E-09_JPRB, 0.53586818E-09_JPRB, 0.53587779E-09_JPRB, 0.53589327E-09_JPRB, 0.53591132E-09_JPRB, 0.53591165E-09_JPRB, &
  & 0.53591559E-09_JPRB, 0.53592197E-09_JPRB, 0.53592353E-09_JPRB, 0.53592486E-09_JPRB, 0.53592675E-09_JPRB, 0.53592780E-09_JPRB, &
  & 0.53592925E-09_JPRB, 0.53593074E-09_JPRB, 0.53593646E-09_JPRB, 0.53594018E-09_JPRB, 0.53593951E-09_JPRB, 0.53593169E-09_JPRB, &
  & 0.53593435E-09_JPRB, 0.53592925E-09_JPRB, 0.53592442E-09_JPRB, 0.53592181E-09_JPRB, 0.53591698E-09_JPRB, 0.53592542E-09_JPRB, &
  & 0.53593674E-09_JPRB, 0.53593885E-09_JPRB, 0.53595045E-09_JPRB, 0.53596116E-09_JPRB, 0.53596749E-09_JPRB, 0.53597526E-09_JPRB, &
  & 0.53598187E-09_JPRB, 0.53598909E-09_JPRB, 0.53599675E-09_JPRB, 0.53599081E-09_JPRB, 0.53599775E-09_JPRB, 0.53599863E-09_JPRB, &
  & 0.53599747E-09_JPRB, 0.53599258E-09_JPRB, 0.53599508E-09_JPRB, 0.53599153E-09_JPRB, 0.53598886E-09_JPRB, 0.53598093E-09_JPRB, &
  & 0.53598020E-09_JPRB, 0.53597782E-09_JPRB, 0.53597810E-09_JPRB, 0.53597743E-09_JPRB, 0.53597182E-09_JPRB, 0.53596894E-09_JPRB, &
  & 0.53596877E-09_JPRB, 0.53596988E-09_JPRB, 0.53596927E-09_JPRB, 0.53596361E-09_JPRB, 0.53596705E-09_JPRB, 0.53596261E-09_JPRB, &
  & 0.53595905E-09_JPRB, 0.53595961E-09_JPRB, 0.53595706E-09_JPRB, 0.53595273E-09_JPRB, 0.53595062E-09_JPRB, 0.53594523E-09_JPRB, &
  & 0.53594701E-09_JPRB, 0.53594501E-09_JPRB, 0.53593413E-09_JPRB, 0.53593718E-09_JPRB /)

RGHG6(:,88, 9) = (/ &
  & 0.53587984E-09_JPRB, 0.53586857E-09_JPRB, 0.53587790E-09_JPRB, 0.53589272E-09_JPRB, 0.53591209E-09_JPRB, 0.53591154E-09_JPRB, &
  & 0.53591775E-09_JPRB, 0.53592164E-09_JPRB, 0.53592397E-09_JPRB, 0.53592508E-09_JPRB, 0.53592714E-09_JPRB, 0.53592819E-09_JPRB, &
  & 0.53592963E-09_JPRB, 0.53593130E-09_JPRB, 0.53593646E-09_JPRB, 0.53594013E-09_JPRB, 0.53593951E-09_JPRB, 0.53593219E-09_JPRB, &
  & 0.53593457E-09_JPRB, 0.53592969E-09_JPRB, 0.53592464E-09_JPRB, 0.53592214E-09_JPRB, 0.53591703E-09_JPRB, 0.53592553E-09_JPRB, &
  & 0.53593718E-09_JPRB, 0.53593874E-09_JPRB, 0.53595040E-09_JPRB, 0.53596155E-09_JPRB, 0.53596744E-09_JPRB, 0.53597554E-09_JPRB, &
  & 0.53598204E-09_JPRB, 0.53598931E-09_JPRB, 0.53599708E-09_JPRB, 0.53599070E-09_JPRB, 0.53599802E-09_JPRB, 0.53599891E-09_JPRB, &
  & 0.53599764E-09_JPRB, 0.53599242E-09_JPRB, 0.53599547E-09_JPRB, 0.53599175E-09_JPRB, 0.53598920E-09_JPRB, 0.53598059E-09_JPRB, &
  & 0.53598032E-09_JPRB, 0.53597782E-09_JPRB, 0.53597810E-09_JPRB, 0.53597765E-09_JPRB, 0.53597204E-09_JPRB, 0.53596910E-09_JPRB, &
  & 0.53596899E-09_JPRB, 0.53597005E-09_JPRB, 0.53596944E-09_JPRB, 0.53596361E-09_JPRB, 0.53596722E-09_JPRB, 0.53596277E-09_JPRB, &
  & 0.53595922E-09_JPRB, 0.53595972E-09_JPRB, 0.53595717E-09_JPRB, 0.53595273E-09_JPRB, 0.53595067E-09_JPRB, 0.53594512E-09_JPRB, &
  & 0.53594718E-09_JPRB, 0.53594523E-09_JPRB, 0.53593435E-09_JPRB, 0.53593735E-09_JPRB /)

RGHG6(:,89, 9) = (/ &
  & 0.53587956E-09_JPRB, 0.53586929E-09_JPRB, 0.53587829E-09_JPRB, 0.53589333E-09_JPRB, 0.53591198E-09_JPRB, 0.53591176E-09_JPRB, &
  & 0.53591587E-09_JPRB, 0.53592225E-09_JPRB, 0.53592375E-09_JPRB, 0.53592497E-09_JPRB, 0.53592697E-09_JPRB, 0.53592797E-09_JPRB, &
  & 0.53592947E-09_JPRB, 0.53593097E-09_JPRB, 0.53593685E-09_JPRB, 0.53594063E-09_JPRB, 0.53593990E-09_JPRB, 0.53593185E-09_JPRB, &
  & 0.53593485E-09_JPRB, 0.53592975E-09_JPRB, 0.53592486E-09_JPRB, 0.53592220E-09_JPRB, 0.53591698E-09_JPRB, 0.53592564E-09_JPRB, &
  & 0.53593735E-09_JPRB, 0.53593852E-09_JPRB, 0.53595051E-09_JPRB, 0.53596166E-09_JPRB, 0.53596755E-09_JPRB, 0.53597549E-09_JPRB, &
  & 0.53598209E-09_JPRB, 0.53598936E-09_JPRB, 0.53599741E-09_JPRB, 0.53599042E-09_JPRB, 0.53599819E-09_JPRB, 0.53599908E-09_JPRB, &
  & 0.53599780E-09_JPRB, 0.53599220E-09_JPRB, 0.53599586E-09_JPRB, 0.53599175E-09_JPRB, 0.53598948E-09_JPRB, 0.53598015E-09_JPRB, &
  & 0.53598037E-09_JPRB, 0.53597787E-09_JPRB, 0.53597837E-09_JPRB, 0.53597787E-09_JPRB, 0.53597199E-09_JPRB, 0.53596916E-09_JPRB, &
  & 0.53596905E-09_JPRB, 0.53597021E-09_JPRB, 0.53596960E-09_JPRB, 0.53596366E-09_JPRB, 0.53596738E-09_JPRB, 0.53596283E-09_JPRB, &
  & 0.53595928E-09_JPRB, 0.53595983E-09_JPRB, 0.53595717E-09_JPRB, 0.53595273E-09_JPRB, 0.53595067E-09_JPRB, 0.53594507E-09_JPRB, &
  & 0.53594729E-09_JPRB, 0.53594551E-09_JPRB, 0.53593435E-09_JPRB, 0.53593752E-09_JPRB /)

RGHG6(:,90, 9) = (/ &
  & 0.53587967E-09_JPRB, 0.53586985E-09_JPRB, 0.53587756E-09_JPRB, 0.53589233E-09_JPRB, 0.53591259E-09_JPRB, 0.53591015E-09_JPRB, &
  & 0.53591653E-09_JPRB, 0.53592186E-09_JPRB, 0.53592386E-09_JPRB, 0.53592475E-09_JPRB, 0.53592730E-09_JPRB, 0.53592786E-09_JPRB, &
  & 0.53592919E-09_JPRB, 0.53593030E-09_JPRB, 0.53593791E-09_JPRB, 0.53594262E-09_JPRB, 0.53594129E-09_JPRB, 0.53593047E-09_JPRB, &
  & 0.53593530E-09_JPRB, 0.53592969E-09_JPRB, 0.53592480E-09_JPRB, 0.53592242E-09_JPRB, 0.53591664E-09_JPRB, 0.53592569E-09_JPRB, &
  & 0.53593774E-09_JPRB, 0.53593835E-09_JPRB, 0.53595062E-09_JPRB, 0.53596189E-09_JPRB, 0.53596744E-09_JPRB, 0.53597560E-09_JPRB, &
  & 0.53598215E-09_JPRB, 0.53598948E-09_JPRB, 0.53599813E-09_JPRB, 0.53598997E-09_JPRB, 0.53599852E-09_JPRB, 0.53599941E-09_JPRB, &
  & 0.53599813E-09_JPRB, 0.53599192E-09_JPRB, 0.53599625E-09_JPRB, 0.53599186E-09_JPRB, 0.53598975E-09_JPRB, 0.53597971E-09_JPRB, &
  & 0.53598037E-09_JPRB, 0.53597776E-09_JPRB, 0.53597843E-09_JPRB, 0.53597804E-09_JPRB, 0.53597204E-09_JPRB, 0.53596921E-09_JPRB, &
  & 0.53596905E-09_JPRB, 0.53597027E-09_JPRB, 0.53596982E-09_JPRB, 0.53596355E-09_JPRB, 0.53596766E-09_JPRB, 0.53596283E-09_JPRB, &
  & 0.53595905E-09_JPRB, 0.53595983E-09_JPRB, 0.53595733E-09_JPRB, 0.53595267E-09_JPRB, 0.53595078E-09_JPRB, 0.53594490E-09_JPRB, &
  & 0.53594751E-09_JPRB, 0.53594573E-09_JPRB, 0.53593407E-09_JPRB, 0.53593763E-09_JPRB /)

RGHG6(:,91, 9) = (/ &
  & 0.53588051E-09_JPRB, 0.53586952E-09_JPRB, 0.53587512E-09_JPRB, 0.53589172E-09_JPRB, 0.53591487E-09_JPRB, 0.53590832E-09_JPRB, &
  & 0.53591342E-09_JPRB, 0.53592392E-09_JPRB, 0.53592403E-09_JPRB, 0.53592236E-09_JPRB, 0.53592952E-09_JPRB, 0.53592691E-09_JPRB, &
  & 0.53592925E-09_JPRB, 0.53592419E-09_JPRB, 0.53594135E-09_JPRB, 0.53594662E-09_JPRB, 0.53594418E-09_JPRB, 0.53592636E-09_JPRB, &
  & 0.53593696E-09_JPRB, 0.53592952E-09_JPRB, 0.53592453E-09_JPRB, 0.53592264E-09_JPRB, 0.53591570E-09_JPRB, 0.53592542E-09_JPRB, &
  & 0.53593857E-09_JPRB, 0.53593763E-09_JPRB, 0.53595062E-09_JPRB, 0.53596222E-09_JPRB, 0.53596716E-09_JPRB, 0.53597560E-09_JPRB, &
  & 0.53598204E-09_JPRB, 0.53598931E-09_JPRB, 0.53599997E-09_JPRB, 0.53598825E-09_JPRB, 0.53599913E-09_JPRB, 0.53599974E-09_JPRB, &
  & 0.53599847E-09_JPRB, 0.53599108E-09_JPRB, 0.53599697E-09_JPRB, 0.53599164E-09_JPRB, 0.53599031E-09_JPRB, 0.53597893E-09_JPRB, &
  & 0.53598059E-09_JPRB, 0.53597754E-09_JPRB, 0.53597865E-09_JPRB, 0.53597848E-09_JPRB, 0.53597171E-09_JPRB, 0.53596894E-09_JPRB, &
  & 0.53596899E-09_JPRB, 0.53597038E-09_JPRB, 0.53597027E-09_JPRB, 0.53596272E-09_JPRB, 0.53596816E-09_JPRB, 0.53596266E-09_JPRB, &
  & 0.53595883E-09_JPRB, 0.53596005E-09_JPRB, 0.53595750E-09_JPRB, 0.53595245E-09_JPRB, 0.53595095E-09_JPRB, 0.53594429E-09_JPRB, &
  & 0.53594784E-09_JPRB, 0.53594607E-09_JPRB, 0.53593330E-09_JPRB, 0.53593768E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART18',1,ZHOOK_HANDLE)
END SUBROUTINE PART18






SUBROUTINE PART19
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART19',0,ZHOOK_HANDLE)



!-- Month= 10 ------------

RGHG6(:, 1,10) = (/ &
  & 0.13701752E-36_JPRB, 0.25441345E-36_JPRB, 0.43480332E-36_JPRB, 0.65740458E-36_JPRB, 0.93435891E-36_JPRB, 0.13437158E-35_JPRB, &
  & 0.20045280E-35_JPRB, 0.30995929E-35_JPRB, 0.48935681E-35_JPRB, 0.78653128E-35_JPRB, 0.12783088E-34_JPRB, 0.20920823E-34_JPRB, &
  & 0.34055291E-34_JPRB, 0.54667077E-34_JPRB, 0.86726578E-34_JPRB, 0.13703704E-33_JPRB, 0.21593340E-33_JPRB, 0.34789357E-33_JPRB, &
  & 0.56874820E-33_JPRB, 0.93361159E-33_JPRB, 0.15266224E-32_JPRB, 0.24457886E-32_JPRB, 0.37937266E-32_JPRB, 0.57318354E-32_JPRB, &
  & 0.84625895E-32_JPRB, 0.12227530E-31_JPRB, 0.17508071E-31_JPRB, 0.25732726E-31_JPRB, 0.38261263E-31_JPRB, 0.52602955E-31_JPRB, &
  & 0.58740487E-31_JPRB, 0.60882491E-31_JPRB, 0.63039952E-31_JPRB, 0.61087814E-31_JPRB, 0.55500049E-31_JPRB, 0.48534069E-31_JPRB, &
  & 0.41391780E-31_JPRB, 0.34490706E-31_JPRB, 0.27018461E-31_JPRB, 0.20495389E-31_JPRB, 0.14548932E-31_JPRB, 0.10387351E-31_JPRB, &
  & 0.74305327E-32_JPRB, 0.52773837E-32_JPRB, 0.36508290E-32_JPRB, 0.24730006E-32_JPRB, 0.16137400E-32_JPRB, 0.10175413E-32_JPRB, &
  & 0.61872595E-33_JPRB, 0.36350648E-33_JPRB, 0.21350070E-33_JPRB, 0.12503986E-33_JPRB, 0.74315195E-34_JPRB, 0.45460594E-34_JPRB, &
  & 0.29092702E-34_JPRB, 0.19817553E-34_JPRB, 0.14491405E-34_JPRB, 0.11349447E-34_JPRB, 0.94025299E-35_JPRB, 0.80739149E-35_JPRB, &
  & 0.69332234E-35_JPRB, 0.55793472E-35_JPRB, 0.41771982E-35_JPRB, 0.32907542E-35_JPRB /)

RGHG6(:, 2,10) = (/ &
  & 0.51641643E-35_JPRB, 0.10919805E-34_JPRB, 0.18636410E-34_JPRB, 0.27757434E-34_JPRB, 0.39633738E-34_JPRB, 0.57497435E-34_JPRB, &
  & 0.86351471E-34_JPRB, 0.13331983E-33_JPRB, 0.21058417E-33_JPRB, 0.33687046E-33_JPRB, 0.54406553E-33_JPRB, 0.88323064E-33_JPRB, &
  & 0.14259803E-32_JPRB, 0.22737247E-32_JPRB, 0.35873884E-32_JPRB, 0.56376400E-32_JPRB, 0.88673336E-32_JPRB, 0.14218223E-31_JPRB, &
  & 0.23114515E-31_JPRB, 0.37751583E-31_JPRB, 0.61422419E-31_JPRB, 0.98064065E-31_JPRB, 0.15195952E-30_JPRB, 0.22983733E-30_JPRB, &
  & 0.34043309E-30_JPRB, 0.49420881E-30_JPRB, 0.71271295E-30_JPRB, 0.10371758E-29_JPRB, 0.15293638E-29_JPRB, 0.20704887E-29_JPRB, &
  & 0.23315859E-29_JPRB, 0.24318240E-29_JPRB, 0.25034891E-29_JPRB, 0.24184312E-29_JPRB, 0.21928147E-29_JPRB, 0.19143879E-29_JPRB, &
  & 0.16310471E-29_JPRB, 0.13543534E-29_JPRB, 0.10699159E-29_JPRB, 0.81604971E-30_JPRB, 0.59296994E-30_JPRB, 0.42446062E-30_JPRB, &
  & 0.30269403E-30_JPRB, 0.21480838E-30_JPRB, 0.14927445E-30_JPRB, 0.10182558E-30_JPRB, 0.67318569E-31_JPRB, 0.43149953E-31_JPRB, &
  & 0.26727092E-31_JPRB, 0.15991572E-31_JPRB, 0.94498248E-32_JPRB, 0.55332517E-32_JPRB, 0.32664137E-32_JPRB, 0.19771124E-32_JPRB, &
  & 0.12489537E-32_JPRB, 0.83899513E-33_JPRB, 0.60473766E-33_JPRB, 0.46765996E-33_JPRB, 0.38353359E-33_JPRB, 0.32709007E-33_JPRB, &
  & 0.28079924E-33_JPRB, 0.23050250E-33_JPRB, 0.17336316E-33_JPRB, 0.12251280E-33_JPRB /)

RGHG6(:, 3,10) = (/ &
  & 0.16972808E-33_JPRB, 0.48330285E-33_JPRB, 0.87411633E-33_JPRB, 0.13092407E-32_JPRB, 0.18740991E-32_JPRB, 0.27449966E-32_JPRB, &
  & 0.41446682E-32_JPRB, 0.64617946E-32_JPRB, 0.10224790E-31_JPRB, 0.16443162E-31_JPRB, 0.26650632E-31_JPRB, 0.43333659E-31_JPRB, &
  & 0.69980411E-31_JPRB, 0.11138810E-30_JPRB, 0.17486776E-30_JPRB, 0.27301082E-30_JPRB, 0.42595242E-30_JPRB, 0.67611445E-30_JPRB, &
  & 0.10886637E-29_JPRB, 0.17656815E-29_JPRB, 0.28672006E-29_JPRB, 0.45917657E-29_JPRB, 0.71621189E-29_JPRB, 0.10916869E-28_JPRB, &
  & 0.16292240E-28_JPRB, 0.23826919E-28_JPRB, 0.34321597E-28_JPRB, 0.49973907E-28_JPRB, 0.72936574E-28_JPRB, 0.98334631E-28_JPRB, &
  & 0.11095612E-27_JPRB, 0.11595716E-27_JPRB, 0.11913541E-27_JPRB, 0.11487882E-27_JPRB, 0.10398801E-27_JPRB, 0.90615461E-28_JPRB, &
  & 0.77094566E-28_JPRB, 0.63978616E-28_JPRB, 0.50727448E-28_JPRB, 0.38874120E-28_JPRB, 0.28528283E-28_JPRB, 0.20428920E-28_JPRB, &
  & 0.14548106E-28_JPRB, 0.10281527E-28_JPRB, 0.71258844E-29_JPRB, 0.48586349E-29_JPRB, 0.32212250E-29_JPRB, 0.20780113E-29_JPRB, &
  & 0.12987725E-29_JPRB, 0.78427972E-30_JPRB, 0.46571074E-30_JPRB, 0.27228676E-30_JPRB, 0.15938617E-30_JPRB, 0.95164778E-31_JPRB, &
  & 0.59226601E-31_JPRB, 0.39252801E-31_JPRB, 0.28100310E-31_JPRB, 0.21708808E-31_JPRB, 0.17903669E-31_JPRB, 0.15435037E-31_JPRB, &
  & 0.13439521E-31_JPRB, 0.11090688E-31_JPRB, 0.80005255E-32_JPRB, 0.45358132E-32_JPRB /)

RGHG6(:, 4,10) = (/ &
  & 0.12975408E-31_JPRB, 0.47613757E-31_JPRB, 0.85208899E-31_JPRB, 0.12483930E-30_JPRB, 0.17764259E-30_JPRB, 0.26034461E-30_JPRB, &
  & 0.39541608E-30_JPRB, 0.61426985E-30_JPRB, 0.97567526E-30_JPRB, 0.15700908E-29_JPRB, 0.25489532E-29_JPRB, 0.41530471E-29_JPRB, &
  & 0.66983287E-29_JPRB, 0.10611307E-28_JPRB, 0.16545748E-28_JPRB, 0.25579160E-28_JPRB, 0.39449515E-28_JPRB, 0.61822863E-28_JPRB, &
  & 0.98276197E-28_JPRB, 0.15774199E-27_JPRB, 0.25467241E-27_JPRB, 0.40762832E-27_JPRB, 0.63680840E-27_JPRB, 0.97475609E-27_JPRB, &
  & 0.14594639E-26_JPRB, 0.21323998E-26_JPRB, 0.30731350E-26_JPRB, 0.44369674E-26_JPRB, 0.64671218E-26_JPRB, 0.86875210E-26_JPRB, &
  & 0.98052976E-26_JPRB, 0.10245863E-25_JPRB, 0.10526968E-25_JPRB, 0.10157910E-25_JPRB, 0.91947670E-26_JPRB, 0.80106175E-26_JPRB, &
  & 0.68155595E-26_JPRB, 0.56578360E-26_JPRB, 0.44917547E-26_JPRB, 0.34575820E-26_JPRB, 0.25472715E-26_JPRB, 0.18352433E-26_JPRB, &
  & 0.13098868E-26_JPRB, 0.92865174E-27_JPRB, 0.64548582E-27_JPRB, 0.44201777E-27_JPRB, 0.29489298E-27_JPRB, 0.19181984E-27_JPRB, &
  & 0.12103081E-27_JPRB, 0.73743316E-28_JPRB, 0.44048744E-28_JPRB, 0.25768876E-28_JPRB, 0.15000433E-28_JPRB, 0.88676134E-29_JPRB, &
  & 0.54534497E-29_JPRB, 0.35894944E-29_JPRB, 0.25634626E-29_JPRB, 0.19913281E-29_JPRB, 0.16589127E-29_JPRB, 0.14546927E-29_JPRB, &
  & 0.13045091E-29_JPRB, 0.11187995E-29_JPRB, 0.81642277E-30_JPRB, 0.37698687E-30_JPRB /)

RGHG6(:, 5,10) = (/ &
  & 0.55857961E-29_JPRB, 0.13504398E-28_JPRB, 0.21096236E-28_JPRB, 0.29649370E-28_JPRB, 0.41971677E-28_JPRB, 0.61483430E-28_JPRB, &
  & 0.92655099E-28_JPRB, 0.14293554E-27_JPRB, 0.22452405E-27_JPRB, 0.35804208E-27_JPRB, 0.57658279E-27_JPRB, 0.92942153E-27_JPRB, &
  & 0.14808156E-26_JPRB, 0.23119953E-26_JPRB, 0.35422744E-26_JPRB, 0.53707207E-26_JPRB, 0.81114838E-26_JPRB, 0.12425763E-25_JPRB, &
  & 0.19310449E-25_JPRB, 0.30330836E-25_JPRB, 0.48036702E-25_JPRB, 0.75635848E-25_JPRB, 0.11662382E-24_JPRB, 0.17623983E-24_JPRB, &
  & 0.26093813E-24_JPRB, 0.37715585E-24_JPRB, 0.53615178E-24_JPRB, 0.76752488E-24_JPRB, 0.11077492E-23_JPRB, 0.14826403E-23_JPRB, &
  & 0.16683688E-23_JPRB, 0.17408328E-23_JPRB, 0.17917556E-23_JPRB, 0.17351861E-23_JPRB, 0.15786203E-23_JPRB, 0.13829891E-23_JPRB, &
  & 0.11843307E-23_JPRB, 0.99158682E-24_JPRB, 0.79370678E-24_JPRB, 0.61805009E-24_JPRB, 0.46191681E-24_JPRB, 0.33786932E-24_JPRB, &
  & 0.24536961E-24_JPRB, 0.17709442E-24_JPRB, 0.12526892E-24_JPRB, 0.87408019E-25_JPRB, 0.59454770E-25_JPRB, 0.39451316E-25_JPRB, &
  & 0.25387735E-25_JPRB, 0.15756934E-25_JPRB, 0.95616066E-26_JPRB, 0.56606582E-26_JPRB, 0.33205782E-26_JPRB, 0.19703681E-26_JPRB, &
  & 0.12157285E-26_JPRB, 0.80204515E-27_JPRB, 0.57636058E-27_JPRB, 0.45034978E-27_JPRB, 0.37793898E-27_JPRB, 0.33475838E-27_JPRB, &
  & 0.30689809E-27_JPRB, 0.28046726E-27_JPRB, 0.23535071E-27_JPRB, 0.14793129E-27_JPRB /)

RGHG6(:, 6,10) = (/ &
  & 0.46453812E-26_JPRB, 0.85867171E-26_JPRB, 0.12194537E-25_JPRB, 0.16922724E-25_JPRB, 0.23836024E-25_JPRB, 0.34545137E-25_JPRB, &
  & 0.50999925E-25_JPRB, 0.76730744E-25_JPRB, 0.11693935E-24_JPRB, 0.18078513E-24_JPRB, 0.28106029E-24_JPRB, 0.43712390E-24_JPRB, &
  & 0.67032726E-24_JPRB, 0.10052904E-23_JPRB, 0.14771379E-23_JPRB, 0.21441527E-23_JPRB, 0.30961623E-23_JPRB, 0.45309926E-23_JPRB, &
  & 0.67245170E-23_JPRB, 0.10097344E-22_JPRB, 0.15308576E-22_JPRB, 0.23152702E-22_JPRB, 0.34363428E-22_JPRB, 0.50205594E-22_JPRB, &
  & 0.72058739E-22_JPRB, 0.10127111E-21_JPRB, 0.14066622E-21_JPRB, 0.19709938E-21_JPRB, 0.28036008E-21_JPRB, 0.37127248E-21_JPRB, &
  & 0.41482699E-21_JPRB, 0.43168943E-21_JPRB, 0.44541212E-21_JPRB, 0.43456396E-21_JPRB, 0.39961959E-21_JPRB, 0.35508119E-21_JPRB, &
  & 0.30957563E-21_JPRB, 0.26470537E-21_JPRB, 0.21696555E-21_JPRB, 0.17377553E-21_JPRB, 0.13400323E-21_JPRB, 0.10140250E-21_JPRB, &
  & 0.76540536E-22_JPRB, 0.57414622E-22_JPRB, 0.42285560E-22_JPRB, 0.30739022E-22_JPRB, 0.21798328E-22_JPRB, 0.15086176E-22_JPRB, &
  & 0.10122125E-22_JPRB, 0.65438647E-23_JPRB, 0.41314957E-23_JPRB, 0.25394931E-23_JPRB, 0.15428061E-23_JPRB, 0.94632859E-24_JPRB, &
  & 0.60088354E-24_JPRB, 0.40701355E-24_JPRB, 0.29821388E-24_JPRB, 0.23670656E-24_JPRB, 0.20085445E-24_JPRB, 0.17936701E-24_JPRB, &
  & 0.16599620E-24_JPRB, 0.15618892E-24_JPRB, 0.14576025E-24_JPRB, 0.12378686E-24_JPRB /)

RGHG6(:, 7,10) = (/ &
  & 0.45609618E-23_JPRB, 0.75424435E-23_JPRB, 0.10451299E-22_JPRB, 0.14270809E-22_JPRB, 0.19759557E-22_JPRB, 0.27774070E-22_JPRB, &
  & 0.39619681E-22_JPRB, 0.56982642E-22_JPRB, 0.82880314E-22_JPRB, 0.12134575E-21_JPRB, 0.17832463E-21_JPRB, 0.26129431E-21_JPRB, &
  & 0.37717204E-21_JPRB, 0.53208161E-21_JPRB, 0.73493705E-21_JPRB, 0.10024850E-20_JPRB, 0.13601541E-20_JPRB, 0.18700395E-20_JPRB, &
  & 0.26097330E-20_JPRB, 0.36888677E-20_JPRB, 0.52798753E-20_JPRB, 0.75592231E-20_JPRB, 0.10676544E-19_JPRB, 0.14902858E-19_JPRB, &
  & 0.20535922E-19_JPRB, 0.27874067E-19_JPRB, 0.37534593E-19_JPRB, 0.51336806E-19_JPRB, 0.71646643E-19_JPRB, 0.93610557E-19_JPRB, &
  & 0.10363231E-18_JPRB, 0.10748021E-18_JPRB, 0.11121056E-18_JPRB, 0.10943103E-18_JPRB, 0.10200435E-18_JPRB, 0.92320103E-19_JPRB, &
  & 0.82353779E-19_JPRB, 0.72441001E-19_JPRB, 0.61296190E-19_JPRB, 0.51000538E-19_JPRB, 0.40925872E-19_JPRB, 0.32451795E-19_JPRB, &
  & 0.25672111E-19_JPRB, 0.20293270E-19_JPRB, 0.15729143E-19_JPRB, 0.12064144E-19_JPRB, 0.90300076E-20_JPRB, 0.66038077E-20_JPRB, &
  & 0.46851853E-20_JPRB, 0.32034078E-20_JPRB, 0.21413816E-20_JPRB, 0.13929149E-20_JPRB, 0.89540827E-21_JPRB, 0.57947132E-21_JPRB, &
  & 0.38719204E-21_JPRB, 0.27359494E-21_JPRB, 0.20768156E-21_JPRB, 0.16920126E-21_JPRB, 0.14635489E-21_JPRB, 0.13246786E-21_JPRB, &
  & 0.12375878E-21_JPRB, 0.11728511E-21_JPRB, 0.11163226E-21_JPRB, 0.10046372E-21_JPRB /)

RGHG6(:, 8,10) = (/ &
  & 0.39975054E-20_JPRB, 0.64221277E-20_JPRB, 0.86788743E-20_JPRB, 0.11628407E-19_JPRB, 0.15614713E-19_JPRB, 0.21239521E-19_JPRB, &
  & 0.29038059E-19_JPRB, 0.39968773E-19_JPRB, 0.55135872E-19_JPRB, 0.76313421E-19_JPRB, 0.10541086E-18_JPRB, 0.14483874E-18_JPRB, &
  & 0.19577301E-18_JPRB, 0.25845879E-18_JPRB, 0.33404422E-18_JPRB, 0.42642706E-18_JPRB, 0.54155308E-18_JPRB, 0.69730669E-18_JPRB, &
  & 0.91206185E-18_JPRB, 0.12104468E-17_JPRB, 0.16299872E-17_JPRB, 0.22054786E-17_JPRB, 0.29557266E-17_JPRB, 0.39332078E-17_JPRB, &
  & 0.51957121E-17_JPRB, 0.67897061E-17_JPRB, 0.88607198E-17_JPRB, 0.11802225E-16_JPRB, 0.16160772E-16_JPRB, 0.20819211E-16_JPRB, &
  & 0.22826269E-16_JPRB, 0.23591110E-16_JPRB, 0.24479509E-16_JPRB, 0.24297423E-16_JPRB, 0.22964236E-16_JPRB, 0.21181556E-16_JPRB, &
  & 0.19361740E-16_JPRB, 0.17533337E-16_JPRB, 0.15362193E-16_JPRB, 0.13296039E-16_JPRB, 0.11168632E-16_JPRB, 0.92779018E-17_JPRB, &
  & 0.77463587E-17_JPRB, 0.64555582E-17_JPRB, 0.52834698E-17_JPRB, 0.42804210E-17_JPRB, 0.33838271E-17_JPRB, 0.26161874E-17_JPRB, &
  & 0.19634571E-17_JPRB, 0.14206450E-17_JPRB, 0.10071182E-17_JPRB, 0.69451227E-18_JPRB, 0.47271201E-18_JPRB, 0.32342571E-18_JPRB, &
  & 0.22698213E-18_JPRB, 0.16756722E-18_JPRB, 0.13161494E-18_JPRB, 0.11013309E-18_JPRB, 0.97140194E-19_JPRB, 0.89106707E-19_JPRB, &
  & 0.83985031E-19_JPRB, 0.80051270E-19_JPRB, 0.76541536E-19_JPRB, 0.69455144E-19_JPRB /)

RGHG6(:, 9,10) = (/ &
  & 0.30309957E-17_JPRB, 0.47201962E-17_JPRB, 0.62852529E-17_JPRB, 0.81931818E-17_JPRB, 0.10712066E-16_JPRB, 0.14074913E-16_JPRB, &
  & 0.18551335E-16_JPRB, 0.24426773E-16_JPRB, 0.32107446E-16_JPRB, 0.42055629E-16_JPRB, 0.54722656E-16_JPRB, 0.70573184E-16_JPRB, &
  & 0.89341965E-16_JPRB, 0.11034025E-15_JPRB, 0.13334240E-15_JPRB, 0.15918505E-15_JPRB, 0.18909611E-15_JPRB, 0.22789977E-15_JPRB, &
  & 0.27928881E-15_JPRB, 0.34773598E-15_JPRB, 0.44056666E-15_JPRB, 0.56278335E-15_JPRB, 0.71529280E-15_JPRB, 0.90683803E-15_JPRB, &
  & 0.11462140E-14_JPRB, 0.14420323E-14_JPRB, 0.18204102E-14_JPRB, 0.23617936E-14_JPRB, 0.31711116E-14_JPRB, 0.40292866E-14_JPRB, &
  & 0.43768894E-14_JPRB, 0.45086475E-14_JPRB, 0.46917926E-14_JPRB, 0.46964978E-14_JPRB, 0.44997905E-14_JPRB, 0.42309037E-14_JPRB, &
  & 0.39619632E-14_JPRB, 0.36958428E-14_JPRB, 0.33543151E-14_JPRB, 0.30257391E-14_JPRB, 0.26595196E-14_JPRB, 0.23271150E-14_JPRB, &
  & 0.20481286E-14_JPRB, 0.18068195E-14_JPRB, 0.15619319E-14_JPRB, 0.13378229E-14_JPRB, 0.11165066E-14_JPRB, 0.91156182E-15_JPRB, &
  & 0.72250375E-15_JPRB, 0.55196235E-15_JPRB, 0.41391464E-15_JPRB, 0.30148910E-15_JPRB, 0.21641639E-15_JPRB, 0.15541676E-15_JPRB, &
  & 0.11401499E-15_JPRB, 0.87262208E-16_JPRB, 0.70603459E-16_JPRB, 0.60393356E-16_JPRB, 0.54111664E-16_JPRB, 0.50168838E-16_JPRB, &
  & 0.47544634E-16_JPRB, 0.45576355E-16_JPRB, 0.43545663E-16_JPRB, 0.39933583E-16_JPRB /)

RGHG6(:,10,10) = (/ &
  & 0.19217973E-14_JPRB, 0.29579708E-14_JPRB, 0.38424578E-14_JPRB, 0.49170102E-14_JPRB, 0.62540834E-14_JPRB, 0.79783431E-14_JPRB, &
  & 0.10147229E-13_JPRB, 0.12835847E-13_JPRB, 0.16101542E-13_JPRB, 0.20018191E-13_JPRB, 0.24590867E-13_JPRB, 0.29818731E-13_JPRB, &
  & 0.35390558E-13_JPRB, 0.40898796E-13_JPRB, 0.46198424E-13_JPRB, 0.51542422E-13_JPRB, 0.57224882E-13_JPRB, 0.64513201E-13_JPRB, &
  & 0.74032055E-13_JPRB, 0.86441196E-13_JPRB, 0.10295009E-12_JPRB, 0.12408459E-12_JPRB, 0.14942820E-12_JPRB, 0.18025991E-12_JPRB, &
  & 0.21793952E-12_JPRB, 0.26360310E-12_JPRB, 0.32190404E-12_JPRB, 0.40652602E-12_JPRB, 0.53514685E-12_JPRB, 0.67089113E-12_JPRB, &
  & 0.72237057E-12_JPRB, 0.74196584E-12_JPRB, 0.77446946E-12_JPRB, 0.78188844E-12_JPRB, 0.75958407E-12_JPRB, 0.72803769E-12_JPRB, &
  & 0.69886366E-12_JPRB, 0.67157017E-12_JPRB, 0.63180998E-12_JPRB, 0.59372966E-12_JPRB, 0.54707703E-12_JPRB, 0.50361939E-12_JPRB, &
  & 0.46845199E-12_JPRB, 0.43746211E-12_JPRB, 0.40025519E-12_JPRB, 0.36298145E-12_JPRB, 0.32005369E-12_JPRB, 0.27600256E-12_JPRB, &
  & 0.23086687E-12_JPRB, 0.18586470E-12_JPRB, 0.14705990E-12_JPRB, 0.11268299E-12_JPRB, 0.84814737E-13_JPRB, 0.63612235E-13_JPRB, &
  & 0.48409810E-13_JPRB, 0.38220251E-13_JPRB, 0.31665246E-13_JPRB, 0.27565061E-13_JPRB, 0.24990648E-13_JPRB, 0.23322580E-13_JPRB, &
  & 0.22226422E-13_JPRB, 0.21271633E-13_JPRB, 0.20484226E-13_JPRB, 0.18645645E-13_JPRB /)

RGHG6(:,11,10) = (/ &
  & 0.10132945E-13_JPRB, 0.14247050E-13_JPRB, 0.17890874E-13_JPRB, 0.21956105E-13_JPRB, 0.27076064E-13_JPRB, 0.33545751E-13_JPRB, &
  & 0.41617053E-13_JPRB, 0.51449103E-13_JPRB, 0.63196390E-13_JPRB, 0.77082722E-13_JPRB, 0.93260476E-13_JPRB, 0.11209523E-12_JPRB, &
  & 0.13305054E-12_JPRB, 0.15513697E-12_JPRB, 0.17793479E-12_JPRB, 0.20118727E-12_JPRB, 0.22319058E-12_JPRB, 0.24582715E-12_JPRB, &
  & 0.27287390E-12_JPRB, 0.30760171E-12_JPRB, 0.35363569E-12_JPRB, 0.41374385E-12_JPRB, 0.48906246E-12_JPRB, 0.58411560E-12_JPRB, &
  & 0.69460052E-12_JPRB, 0.81669621E-12_JPRB, 0.94917683E-12_JPRB, 0.10794515E-11_JPRB, 0.11898197E-11_JPRB, 0.13241329E-11_JPRB, &
  & 0.15609602E-11_JPRB, 0.17610664E-11_JPRB, 0.18755104E-11_JPRB, 0.19763616E-11_JPRB, 0.20661040E-11_JPRB, 0.21247114E-11_JPRB, &
  & 0.21398569E-11_JPRB, 0.21223457E-11_JPRB, 0.20690121E-11_JPRB, 0.20198719E-11_JPRB, 0.19541137E-11_JPRB, 0.18817649E-11_JPRB, &
  & 0.18125356E-11_JPRB, 0.17363972E-11_JPRB, 0.16387114E-11_JPRB, 0.15293188E-11_JPRB, 0.14052232E-11_JPRB, 0.12744300E-11_JPRB, &
  & 0.11384985E-11_JPRB, 0.10017836E-11_JPRB, 0.86458141E-12_JPRB, 0.72344615E-12_JPRB, 0.59148053E-12_JPRB, 0.47736630E-12_JPRB, &
  & 0.38692704E-12_JPRB, 0.32000851E-12_JPRB, 0.27249687E-12_JPRB, 0.23904725E-12_JPRB, 0.21521230E-12_JPRB, 0.19795750E-12_JPRB, &
  & 0.18454080E-12_JPRB, 0.17510464E-12_JPRB, 0.16370458E-12_JPRB, 0.15117798E-12_JPRB /)

RGHG6(:,12,10) = (/ &
  & 0.38711594E-13_JPRB, 0.54172846E-13_JPRB, 0.66621743E-13_JPRB, 0.81293262E-13_JPRB, 0.99374752E-13_JPRB, 0.12264957E-12_JPRB, &
  & 0.15203790E-12_JPRB, 0.18825165E-12_JPRB, 0.23171639E-12_JPRB, 0.28296750E-12_JPRB, 0.34242802E-12_JPRB, 0.41083673E-12_JPRB, &
  & 0.48754832E-12_JPRB, 0.56927976E-12_JPRB, 0.65494902E-12_JPRB, 0.74774307E-12_JPRB, 0.84147625E-12_JPRB, 0.93277404E-12_JPRB, &
  & 0.10285208E-11_JPRB, 0.11343800E-11_JPRB, 0.12567107E-11_JPRB, 0.13959680E-11_JPRB, 0.15632206E-11_JPRB, 0.17609203E-11_JPRB, &
  & 0.19763731E-11_JPRB, 0.22099440E-11_JPRB, 0.24640637E-11_JPRB, 0.27524463E-11_JPRB, 0.30858382E-11_JPRB, 0.34161148E-11_JPRB, &
  & 0.36819211E-11_JPRB, 0.40260850E-11_JPRB, 0.44066092E-11_JPRB, 0.47841102E-11_JPRB, 0.51045622E-11_JPRB, 0.53347990E-11_JPRB, &
  & 0.54708772E-11_JPRB, 0.55322608E-11_JPRB, 0.55257799E-11_JPRB, 0.54875817E-11_JPRB, 0.53912651E-11_JPRB, 0.52391737E-11_JPRB, &
  & 0.50620549E-11_JPRB, 0.48323056E-11_JPRB, 0.45421843E-11_JPRB, 0.42055209E-11_JPRB, 0.38383463E-11_JPRB, 0.34574008E-11_JPRB, &
  & 0.30757538E-11_JPRB, 0.26886330E-11_JPRB, 0.23201426E-11_JPRB, 0.19794630E-11_JPRB, 0.16782012E-11_JPRB, 0.14244766E-11_JPRB, &
  & 0.12194813E-11_JPRB, 0.10597107E-11_JPRB, 0.93793593E-12_JPRB, 0.84505612E-12_JPRB, 0.77435031E-12_JPRB, 0.71918296E-12_JPRB, &
  & 0.67848537E-12_JPRB, 0.64090595E-12_JPRB, 0.61230881E-12_JPRB, 0.55149076E-12_JPRB /)

RGHG6(:,13,10) = (/ &
  & 0.13776994E-12_JPRB, 0.19238512E-12_JPRB, 0.23958979E-12_JPRB, 0.29267355E-12_JPRB, 0.35987234E-12_JPRB, 0.44640561E-12_JPRB, &
  & 0.55695986E-12_JPRB, 0.69441192E-12_JPRB, 0.85992899E-12_JPRB, 0.10542676E-11_JPRB, 0.12769833E-11_JPRB, 0.15290649E-11_JPRB, &
  & 0.18085620E-11_JPRB, 0.21081682E-11_JPRB, 0.24166710E-11_JPRB, 0.27445865E-11_JPRB, 0.30913971E-11_JPRB, 0.34398706E-11_JPRB, &
  & 0.37808780E-11_JPRB, 0.41175613E-11_JPRB, 0.44688615E-11_JPRB, 0.48268286E-11_JPRB, 0.51640506E-11_JPRB, 0.54624994E-11_JPRB, &
  & 0.57024459E-11_JPRB, 0.59055811E-11_JPRB, 0.61298579E-11_JPRB, 0.64114465E-11_JPRB, 0.67266860E-11_JPRB, 0.71268035E-11_JPRB, &
  & 0.76955491E-11_JPRB, 0.83681456E-11_JPRB, 0.91326929E-11_JPRB, 0.99663012E-11_JPRB, 0.10773155E-10_JPRB, 0.11482662E-10_JPRB, &
  & 0.12051229E-10_JPRB, 0.12445513E-10_JPRB, 0.12667264E-10_JPRB, 0.12721319E-10_JPRB, 0.12621472E-10_JPRB, 0.12339907E-10_JPRB, &
  & 0.11912673E-10_JPRB, 0.11349071E-10_JPRB, 0.10651664E-10_JPRB, 0.98457423E-11_JPRB, 0.89786460E-11_JPRB, 0.80948963E-11_JPRB, &
  & 0.72162901E-11_JPRB, 0.63898348E-11_JPRB, 0.56091035E-11_JPRB, 0.48985082E-11_JPRB, 0.42735281E-11_JPRB, 0.37474702E-11_JPRB, &
  & 0.33185735E-11_JPRB, 0.29788583E-11_JPRB, 0.27136461E-11_JPRB, 0.25050550E-11_JPRB, 0.23356174E-11_JPRB, 0.22035212E-11_JPRB, &
  & 0.20789119E-11_JPRB, 0.19938703E-11_JPRB, 0.18698209E-11_JPRB, 0.17223229E-11_JPRB /)

RGHG6(:,14,10) = (/ &
  & 0.42889130E-12_JPRB, 0.61133027E-12_JPRB, 0.76230862E-12_JPRB, 0.93807210E-12_JPRB, 0.11568965E-11_JPRB, 0.14399443E-11_JPRB, &
  & 0.18021880E-11_JPRB, 0.22538208E-11_JPRB, 0.27976148E-11_JPRB, 0.34323820E-11_JPRB, 0.41511469E-11_JPRB, 0.49503427E-11_JPRB, &
  & 0.58225777E-11_JPRB, 0.67598878E-11_JPRB, 0.77288714E-11_JPRB, 0.87181399E-11_JPRB, 0.97438307E-11_JPRB, 0.10808634E-10_JPRB, &
  & 0.11882201E-10_JPRB, 0.12886759E-10_JPRB, 0.13756841E-10_JPRB, 0.14462759E-10_JPRB, 0.14935664E-10_JPRB, 0.15168224E-10_JPRB, &
  & 0.15134590E-10_JPRB, 0.14921965E-10_JPRB, 0.14646164E-10_JPRB, 0.14362132E-10_JPRB, 0.14215906E-10_JPRB, 0.14449031E-10_JPRB, &
  & 0.15074050E-10_JPRB, 0.16024678E-10_JPRB, 0.17320775E-10_JPRB, 0.18910516E-10_JPRB, 0.20655439E-10_JPRB, 0.22371018E-10_JPRB, &
  & 0.23853673E-10_JPRB, 0.24983128E-10_JPRB, 0.25710316E-10_JPRB, 0.26034001E-10_JPRB, 0.25961440E-10_JPRB, 0.25474168E-10_JPRB, &
  & 0.24627165E-10_JPRB, 0.23456558E-10_JPRB, 0.22041181E-10_JPRB, 0.20453642E-10_JPRB, 0.18785209E-10_JPRB, 0.17117106E-10_JPRB, &
  & 0.15500082E-10_JPRB, 0.13971083E-10_JPRB, 0.12576989E-10_JPRB, 0.11329894E-10_JPRB, 0.10236234E-10_JPRB, 0.93032032E-11_JPRB, &
  & 0.85250505E-11_JPRB, 0.78878154E-11_JPRB, 0.73665917E-11_JPRB, 0.69338450E-11_JPRB, 0.65567881E-11_JPRB, 0.62421457E-11_JPRB, &
  & 0.59207222E-11_JPRB, 0.56778488E-11_JPRB, 0.53320733E-11_JPRB, 0.48281787E-11_JPRB /)

RGHG6(:,15,10) = (/ &
  & 0.11530467E-11_JPRB, 0.16436642E-11_JPRB, 0.20593605E-11_JPRB, 0.25315906E-11_JPRB, 0.31203035E-11_JPRB, 0.38725702E-11_JPRB, &
  & 0.48285755E-11_JPRB, 0.60126348E-11_JPRB, 0.74284832E-11_JPRB, 0.90647993E-11_JPRB, 0.10891888E-10_JPRB, 0.12884640E-10_JPRB, &
  & 0.15013383E-10_JPRB, 0.17271504E-10_JPRB, 0.19624094E-10_JPRB, 0.22009741E-10_JPRB, 0.24397453E-10_JPRB, 0.26788202E-10_JPRB, &
  & 0.29146106E-10_JPRB, 0.31402735E-10_JPRB, 0.33353969E-10_JPRB, 0.34820383E-10_JPRB, 0.35621589E-10_JPRB, 0.35693417E-10_JPRB, &
  & 0.34974433E-10_JPRB, 0.33640819E-10_JPRB, 0.31886493E-10_JPRB, 0.30037219E-10_JPRB, 0.28681614E-10_JPRB, 0.28027317E-10_JPRB, &
  & 0.28234420E-10_JPRB, 0.29384061E-10_JPRB, 0.31295092E-10_JPRB, 0.33903040E-10_JPRB, 0.36901135E-10_JPRB, 0.39989866E-10_JPRB, &
  & 0.42857322E-10_JPRB, 0.45220071E-10_JPRB, 0.46898502E-10_JPRB, 0.47807425E-10_JPRB, 0.47917160E-10_JPRB, 0.47201510E-10_JPRB, &
  & 0.45790659E-10_JPRB, 0.43774529E-10_JPRB, 0.41328777E-10_JPRB, 0.38646676E-10_JPRB, 0.35905060E-10_JPRB, 0.33221818E-10_JPRB, &
  & 0.30670060E-10_JPRB, 0.28329058E-10_JPRB, 0.26198922E-10_JPRB, 0.24267657E-10_JPRB, 0.22527785E-10_JPRB, 0.20990709E-10_JPRB, &
  & 0.19646704E-10_JPRB, 0.18488724E-10_JPRB, 0.17487614E-10_JPRB, 0.16613044E-10_JPRB, 0.15825797E-10_JPRB, 0.15108971E-10_JPRB, &
  & 0.14411352E-10_JPRB, 0.13796027E-10_JPRB, 0.12924235E-10_JPRB, 0.11775346E-10_JPRB /)

RGHG6(:,16,10) = (/ &
  & 0.27061554E-11_JPRB, 0.38361966E-11_JPRB, 0.47741620E-11_JPRB, 0.58370114E-11_JPRB, 0.71410746E-11_JPRB, 0.87853414E-11_JPRB, &
  & 0.10840826E-10_JPRB, 0.13350441E-10_JPRB, 0.16310397E-10_JPRB, 0.19684004E-10_JPRB, 0.23393105E-10_JPRB, 0.27362525E-10_JPRB, &
  & 0.31509420E-10_JPRB, 0.35809241E-10_JPRB, 0.40238667E-10_JPRB, 0.44736111E-10_JPRB, 0.49210483E-10_JPRB, 0.53623626E-10_JPRB, &
  & 0.57848698E-10_JPRB, 0.61792821E-10_JPRB, 0.65221537E-10_JPRB, 0.67744477E-10_JPRB, 0.68996517E-10_JPRB, 0.68852465E-10_JPRB, &
  & 0.67215414E-10_JPRB, 0.64231905E-10_JPRB, 0.60268825E-10_JPRB, 0.56243767E-10_JPRB, 0.52826552E-10_JPRB, 0.50607463E-10_JPRB, &
  & 0.49888871E-10_JPRB, 0.50727051E-10_JPRB, 0.53050640E-10_JPRB, 0.56545595E-10_JPRB, 0.60838244E-10_JPRB, 0.65526126E-10_JPRB, &
  & 0.70092335E-10_JPRB, 0.74095244E-10_JPRB, 0.77177445E-10_JPRB, 0.79110295E-10_JPRB, 0.79737029E-10_JPRB, 0.78990751E-10_JPRB, &
  & 0.77084526E-10_JPRB, 0.74227832E-10_JPRB, 0.70738491E-10_JPRB, 0.66948738E-10_JPRB, 0.63136447E-10_JPRB, 0.59478887E-10_JPRB, &
  & 0.56066388E-10_JPRB, 0.52923829E-10_JPRB, 0.50002107E-10_JPRB, 0.47249631E-10_JPRB, 0.44635129E-10_JPRB, 0.42171964E-10_JPRB, &
  & 0.39874014E-10_JPRB, 0.37763390E-10_JPRB, 0.35845701E-10_JPRB, 0.34109254E-10_JPRB, 0.32528376E-10_JPRB, 0.31077481E-10_JPRB, &
  & 0.29695454E-10_JPRB, 0.28423108E-10_JPRB, 0.26707411E-10_JPRB, 0.24404799E-10_JPRB /)

RGHG6(:,17,10) = (/ &
  & 0.56999761E-11_JPRB, 0.79143194E-11_JPRB, 0.97014818E-11_JPRB, 0.11706332E-10_JPRB, 0.14128478E-10_JPRB, 0.17129298E-10_JPRB, &
  & 0.20808941E-10_JPRB, 0.25210152E-10_JPRB, 0.30304054E-10_JPRB, 0.36004963E-10_JPRB, 0.42163634E-10_JPRB, 0.48632723E-10_JPRB, &
  & 0.55256303E-10_JPRB, 0.61969416E-10_JPRB, 0.68727843E-10_JPRB, 0.75505352E-10_JPRB, 0.82208615E-10_JPRB, 0.88820576E-10_JPRB, &
  & 0.95156452E-10_JPRB, 0.10099167E-09_JPRB, 0.10609419E-09_JPRB, 0.11003116E-09_JPRB, 0.11225667E-09_JPRB, 0.11250127E-09_JPRB, &
  & 0.11054264E-09_JPRB, 0.10644459E-09_JPRB, 0.10077173E-09_JPRB, 0.94644126E-10_JPRB, 0.88983633E-10_JPRB, 0.85079915E-10_JPRB, &
  & 0.82956898E-10_JPRB, 0.82893588E-10_JPRB, 0.84769788E-10_JPRB, 0.88537448E-10_JPRB, 0.93664916E-10_JPRB, 0.99429423E-10_JPRB, &
  & 0.10527999E-09_JPRB, 0.11074910E-09_JPRB, 0.11528695E-09_JPRB, 0.11846391E-09_JPRB, 0.11997522E-09_JPRB, 0.11966016E-09_JPRB, &
  & 0.11774896E-09_JPRB, 0.11453316E-09_JPRB, 0.11047697E-09_JPRB, 0.10604061E-09_JPRB, 0.10159220E-09_JPRB, 0.97353813E-10_JPRB, &
  & 0.93385522E-10_JPRB, 0.89647269E-10_JPRB, 0.86012447E-10_JPRB, 0.82372623E-10_JPRB, 0.78669959E-10_JPRB, 0.74934350E-10_JPRB, &
  & 0.71226372E-10_JPRB, 0.67646756E-10_JPRB, 0.64278131E-10_JPRB, 0.61158148E-10_JPRB, 0.58304431E-10_JPRB, 0.55701589E-10_JPRB, &
  & 0.53320105E-10_JPRB, 0.50950300E-10_JPRB, 0.48338604E-10_JPRB, 0.43857883E-10_JPRB /)

RGHG6(:,18,10) = (/ &
  & 0.10880590E-10_JPRB, 0.14557716E-10_JPRB, 0.17497866E-10_JPRB, 0.20685047E-10_JPRB, 0.24523166E-10_JPRB, 0.29180047E-10_JPRB, &
  & 0.34781199E-10_JPRB, 0.41343439E-10_JPRB, 0.48781118E-10_JPRB, 0.56941445E-10_JPRB, 0.65600303E-10_JPRB, 0.74538889E-10_JPRB, &
  & 0.83546302E-10_JPRB, 0.92518646E-10_JPRB, 0.10137984E-09_JPRB, 0.11010172E-09_JPRB, 0.11863825E-09_JPRB, 0.12696946E-09_JPRB, &
  & 0.13502120E-09_JPRB, 0.14258469E-09_JPRB, 0.14936928E-09_JPRB, 0.15493833E-09_JPRB, 0.15866895E-09_JPRB, 0.16015292E-09_JPRB, &
  & 0.15900881E-09_JPRB, 0.15530957E-09_JPRB, 0.14974184E-09_JPRB, 0.14313416E-09_JPRB, 0.13662781E-09_JPRB, 0.13110518E-09_JPRB, &
  & 0.12744308E-09_JPRB, 0.12597400E-09_JPRB, 0.12666650E-09_JPRB, 0.12941680E-09_JPRB, 0.13394158E-09_JPRB, 0.13972859E-09_JPRB, &
  & 0.14610364E-09_JPRB, 0.15237421E-09_JPRB, 0.15798231E-09_JPRB, 0.16229258E-09_JPRB, 0.16486704E-09_JPRB, 0.16541910E-09_JPRB, &
  & 0.16411425E-09_JPRB, 0.16126592E-09_JPRB, 0.15738499E-09_JPRB, 0.15302223E-09_JPRB, 0.14858528E-09_JPRB, 0.14428675E-09_JPRB, &
  & 0.14014175E-09_JPRB, 0.13605360E-09_JPRB, 0.13185364E-09_JPRB, 0.12738403E-09_JPRB, 0.12256759E-09_JPRB, 0.11744558E-09_JPRB, &
  & 0.11214374E-09_JPRB, 0.10685873E-09_JPRB, 0.10179554E-09_JPRB, 0.97050687E-10_JPRB, 0.92692284E-10_JPRB, 0.88710747E-10_JPRB, &
  & 0.85053312E-10_JPRB, 0.81508730E-10_JPRB, 0.77574724E-10_JPRB, 0.70710236E-10_JPRB /)

RGHG6(:,19,10) = (/ &
  & 0.18743628E-10_JPRB, 0.24238686E-10_JPRB, 0.28329773E-10_JPRB, 0.32842500E-10_JPRB, 0.38081930E-10_JPRB, 0.44403189E-10_JPRB, &
  & 0.51858802E-10_JPRB, 0.60429779E-10_JPRB, 0.69964527E-10_JPRB, 0.80244214E-10_JPRB, 0.90972133E-10_JPRB, 0.10188857E-09_JPRB, &
  & 0.11274984E-09_JPRB, 0.12344087E-09_JPRB, 0.13388217E-09_JPRB, 0.14403381E-09_JPRB, 0.15389372E-09_JPRB, 0.16352941E-09_JPRB, &
  & 0.17288644E-09_JPRB, 0.18185881E-09_JPRB, 0.19019177E-09_JPRB, 0.19748185E-09_JPRB, 0.20310928E-09_JPRB, 0.20658121E-09_JPRB, &
  & 0.20739285E-09_JPRB, 0.20549458E-09_JPRB, 0.20135579E-09_JPRB, 0.19578779E-09_JPRB, 0.18977175E-09_JPRB, 0.18416560E-09_JPRB, &
  & 0.17969753E-09_JPRB, 0.17677024E-09_JPRB, 0.17566036E-09_JPRB, 0.17653334E-09_JPRB, 0.17927859E-09_JPRB, 0.18376672E-09_JPRB, &
  & 0.18959531E-09_JPRB, 0.19584984E-09_JPRB, 0.20190363E-09_JPRB, 0.20695293E-09_JPRB, 0.21045166E-09_JPRB, 0.21195132E-09_JPRB, &
  & 0.21157222E-09_JPRB, 0.20952684E-09_JPRB, 0.20629620E-09_JPRB, 0.20241982E-09_JPRB, 0.19830962E-09_JPRB, 0.19416338E-09_JPRB, &
  & 0.18997429E-09_JPRB, 0.18565652E-09_JPRB, 0.18103360E-09_JPRB, 0.17593954E-09_JPRB, 0.17028981E-09_JPRB, 0.16412317E-09_JPRB, &
  & 0.15760690E-09_JPRB, 0.15102630E-09_JPRB, 0.14459076E-09_JPRB, 0.13848260E-09_JPRB, 0.13279135E-09_JPRB, 0.12754479E-09_JPRB, &
  & 0.12263995E-09_JPRB, 0.11803364E-09_JPRB, 0.11261483E-09_JPRB, 0.10381141E-09_JPRB /)

RGHG6(:,20,10) = (/ &
  & 0.29605218E-10_JPRB, 0.36777276E-10_JPRB, 0.42176526E-10_JPRB, 0.47724959E-10_JPRB, 0.54258889E-10_JPRB, 0.61913134E-10_JPRB, &
  & 0.70833117E-10_JPRB, 0.80939519E-10_JPRB, 0.92033346E-10_JPRB, 0.10382945E-09_JPRB, 0.11601557E-09_JPRB, 0.12829027E-09_JPRB, &
  & 0.14041113E-09_JPRB, 0.15225968E-09_JPRB, 0.16376717E-09_JPRB, 0.17491919E-09_JPRB, 0.18570270E-09_JPRB, 0.19621106E-09_JPRB, &
  & 0.20648613E-09_JPRB, 0.21654391E-09_JPRB, 0.22621240E-09_JPRB, 0.23513347E-09_JPRB, 0.24271593E-09_JPRB, 0.24845725E-09_JPRB, &
  & 0.25178579E-09_JPRB, 0.25247046E-09_JPRB, 0.25078448E-09_JPRB, 0.24737526E-09_JPRB, 0.24300864E-09_JPRB, 0.23818436E-09_JPRB, &
  & 0.23359856E-09_JPRB, 0.22971343E-09_JPRB, 0.22689049E-09_JPRB, 0.22579105E-09_JPRB, 0.22658421E-09_JPRB, 0.22900680E-09_JPRB, &
  & 0.23325941E-09_JPRB, 0.23892149E-09_JPRB, 0.24474450E-09_JPRB, 0.25002969E-09_JPRB, 0.25396665E-09_JPRB, 0.25622926E-09_JPRB, &
  & 0.25662114E-09_JPRB, 0.25532154E-09_JPRB, 0.25272612E-09_JPRB, 0.24929672E-09_JPRB, 0.24542385E-09_JPRB, 0.24131339E-09_JPRB, &
  & 0.23701213E-09_JPRB, 0.23246587E-09_JPRB, 0.22752626E-09_JPRB, 0.22204298E-09_JPRB, 0.21594428E-09_JPRB, 0.20929233E-09_JPRB, &
  & 0.20226852E-09_JPRB, 0.19509577E-09_JPRB, 0.18800107E-09_JPRB, 0.18113389E-09_JPRB, 0.17461867E-09_JPRB, 0.16850341E-09_JPRB, &
  & 0.16286028E-09_JPRB, 0.15714383E-09_JPRB, 0.15131479E-09_JPRB, 0.13986200E-09_JPRB /)

RGHG6(:,21,10) = (/ &
  & 0.43122245E-10_JPRB, 0.52150777E-10_JPRB, 0.58475620E-10_JPRB, 0.65007361E-10_JPRB, 0.72350077E-10_JPRB, 0.80918210E-10_JPRB, &
  & 0.90732546E-10_JPRB, 0.10173706E-09_JPRB, 0.11370766E-09_JPRB, 0.12637294E-09_JPRB, 0.13936827E-09_JPRB, 0.15241367E-09_JPRB, &
  & 0.16525482E-09_JPRB, 0.17777363E-09_JPRB, 0.18990788E-09_JPRB, 0.20165575E-09_JPRB, 0.21306770E-09_JPRB, 0.22425216E-09_JPRB, &
  & 0.23528024E-09_JPRB, 0.24619812E-09_JPRB, 0.25698296E-09_JPRB, 0.26734462E-09_JPRB, 0.27677197E-09_JPRB, 0.28467637E-09_JPRB, &
  & 0.29038974E-09_JPRB, 0.29365235E-09_JPRB, 0.29463396E-09_JPRB, 0.29373626E-09_JPRB, 0.29142738E-09_JPRB, 0.28812577E-09_JPRB, &
  & 0.28418218E-09_JPRB, 0.28007102E-09_JPRB, 0.27628416E-09_JPRB, 0.27356795E-09_JPRB, 0.27268995E-09_JPRB, 0.27375632E-09_JPRB, &
  & 0.27657901E-09_JPRB, 0.28066696E-09_JPRB, 0.28563496E-09_JPRB, 0.29047451E-09_JPRB, 0.29443800E-09_JPRB, 0.29680952E-09_JPRB, &
  & 0.29754185E-09_JPRB, 0.29663771E-09_JPRB, 0.29436809E-09_JPRB, 0.29110950E-09_JPRB, 0.28722802E-09_JPRB, 0.28297414E-09_JPRB, &
  & 0.27844796E-09_JPRB, 0.27362876E-09_JPRB, 0.26840730E-09_JPRB, 0.26269345E-09_JPRB, 0.25647270E-09_JPRB, 0.24981126E-09_JPRB, &
  & 0.24284072E-09_JPRB, 0.23571733E-09_JPRB, 0.22859969E-09_JPRB, 0.22162230E-09_JPRB, 0.21488911E-09_JPRB, 0.20846866E-09_JPRB, &
  & 0.20227500E-09_JPRB, 0.19644311E-09_JPRB, 0.18919359E-09_JPRB, 0.17767318E-09_JPRB /)

RGHG6(:,22,10) = (/ &
  & 0.59176657E-10_JPRB, 0.69523130E-10_JPRB, 0.76920789E-10_JPRB, 0.83868433E-10_JPRB, 0.91779258E-10_JPRB, 0.10072404E-09_JPRB, &
  & 0.11086633E-09_JPRB, 0.12216106E-09_JPRB, 0.13442342E-09_JPRB, 0.14735882E-09_JPRB, 0.16067095E-09_JPRB, 0.17403634E-09_JPRB, &
  & 0.18722693E-09_JPRB, 0.20010621E-09_JPRB, 0.21261679E-09_JPRB, 0.22475266E-09_JPRB, 0.23657909E-09_JPRB, 0.24822683E-09_JPRB, &
  & 0.25983704E-09_JPRB, 0.27149258E-09_JPRB, 0.28320177E-09_JPRB, 0.29473701E-09_JPRB, 0.30560757E-09_JPRB, 0.31524575E-09_JPRB, &
  & 0.32305417E-09_JPRB, 0.32860312E-09_JPRB, 0.33194530E-09_JPRB, 0.33330910E-09_JPRB, 0.33299852E-09_JPRB, 0.33130118E-09_JPRB, &
  & 0.32843933E-09_JPRB, 0.32477257E-09_JPRB, 0.32079139E-09_JPRB, 0.31722808E-09_JPRB, 0.31497149E-09_JPRB, 0.31437716E-09_JPRB, &
  & 0.31583894E-09_JPRB, 0.31917050E-09_JPRB, 0.32326741E-09_JPRB, 0.32740480E-09_JPRB, 0.33084735E-09_JPRB, 0.33302100E-09_JPRB, &
  & 0.33362735E-09_JPRB, 0.33271202E-09_JPRB, 0.33045566E-09_JPRB, 0.32711583E-09_JPRB, 0.32302133E-09_JPRB, 0.31850356E-09_JPRB, &
  & 0.31365471E-09_JPRB, 0.30851638E-09_JPRB, 0.30305136E-09_JPRB, 0.29723737E-09_JPRB, 0.29109620E-09_JPRB, 0.28470309E-09_JPRB, &
  & 0.27812208E-09_JPRB, 0.27144381E-09_JPRB, 0.26476107E-09_JPRB, 0.25812721E-09_JPRB, 0.25160640E-09_JPRB, 0.24524788E-09_JPRB, &
  & 0.23914529E-09_JPRB, 0.23277977E-09_JPRB, 0.22607063E-09_JPRB, 0.21307850E-09_JPRB /)

RGHG6(:,23,10) = (/ &
  & 0.77241630E-10_JPRB, 0.88613394E-10_JPRB, 0.96511833E-10_JPRB, 0.10383931E-09_JPRB, 0.11183341E-09_JPRB, 0.12079339E-09_JPRB, &
  & 0.13084646E-09_JPRB, 0.14197871E-09_JPRB, 0.15406118E-09_JPRB, 0.16688427E-09_JPRB, 0.18013292E-09_JPRB, 0.19354582E-09_JPRB, &
  & 0.20687078E-09_JPRB, 0.21996317E-09_JPRB, 0.23273888E-09_JPRB, 0.24516703E-09_JPRB, 0.25732882E-09_JPRB, 0.26934666E-09_JPRB, &
  & 0.28141942E-09_JPRB, 0.29360489E-09_JPRB, 0.30594927E-09_JPRB, 0.31834413E-09_JPRB, 0.33024666E-09_JPRB, 0.34117537E-09_JPRB, &
  & 0.35043277E-09_JPRB, 0.35765976E-09_JPRB, 0.36281048E-09_JPRB, 0.36599510E-09_JPRB, 0.36741124E-09_JPRB, 0.36724074E-09_JPRB, &
  & 0.36563713E-09_JPRB, 0.36285336E-09_JPRB, 0.35937953E-09_JPRB, 0.35586145E-09_JPRB, 0.35326261E-09_JPRB, 0.35207090E-09_JPRB, &
  & 0.35252581E-09_JPRB, 0.35447179E-09_JPRB, 0.35732958E-09_JPRB, 0.36045988E-09_JPRB, 0.36306569E-09_JPRB, 0.36468351E-09_JPRB, &
  & 0.36495659E-09_JPRB, 0.36373496E-09_JPRB, 0.36117151E-09_JPRB, 0.35757627E-09_JPRB, 0.35319131E-09_JPRB, 0.34834033E-09_JPRB, &
  & 0.34317529E-09_JPRB, 0.33775632E-09_JPRB, 0.33209305E-09_JPRB, 0.32624059E-09_JPRB, 0.32027361E-09_JPRB, 0.31426212E-09_JPRB, &
  & 0.30821698E-09_JPRB, 0.30215744E-09_JPRB, 0.29607802E-09_JPRB, 0.28997754E-09_JPRB, 0.28389202E-09_JPRB, 0.27785632E-09_JPRB, &
  & 0.27184821E-09_JPRB, 0.26589458E-09_JPRB, 0.25862529E-09_JPRB, 0.24612534E-09_JPRB /)

RGHG6(:,24,10) = (/ &
  & 0.96880219E-10_JPRB, 0.10905354E-09_JPRB, 0.11704802E-09_JPRB, 0.12440171E-09_JPRB, 0.13225085E-09_JPRB, 0.14093628E-09_JPRB, &
  & 0.15060619E-09_JPRB, 0.16131363E-09_JPRB, 0.17296442E-09_JPRB, 0.18540729E-09_JPRB, 0.19841183E-09_JPRB, 0.21170700E-09_JPRB, &
  & 0.22506293E-09_JPRB, 0.23830757E-09_JPRB, 0.25132790E-09_JPRB, 0.26404523E-09_JPRB, 0.27651476E-09_JPRB, 0.28882471E-09_JPRB, &
  & 0.30119798E-09_JPRB, 0.31375533E-09_JPRB, 0.32649961E-09_JPRB, 0.33929376E-09_JPRB, 0.35175399E-09_JPRB, 0.36333245E-09_JPRB, &
  & 0.37341119E-09_JPRB, 0.38164077E-09_JPRB, 0.38796996E-09_JPRB, 0.39249093E-09_JPRB, 0.39529474E-09_JPRB, 0.39648987E-09_JPRB, &
  & 0.39616541E-09_JPRB, 0.39450529E-09_JPRB, 0.39192621E-09_JPRB, 0.38906448E-09_JPRB, 0.38655462E-09_JPRB, 0.38495859E-09_JPRB, &
  & 0.38478437E-09_JPRB, 0.38580006E-09_JPRB, 0.38757711E-09_JPRB, 0.38956349E-09_JPRB, 0.39119691E-09_JPRB, 0.39197356E-09_JPRB, &
  & 0.39164719E-09_JPRB, 0.39002340E-09_JPRB, 0.38708875E-09_JPRB, 0.38312647E-09_JPRB, 0.37841449E-09_JPRB, 0.37324432E-09_JPRB, &
  & 0.36775660E-09_JPRB, 0.36208814E-09_JPRB, 0.35630143E-09_JPRB, 0.35050290E-09_JPRB, 0.34479083E-09_JPRB, 0.33918351E-09_JPRB, &
  & 0.33367392E-09_JPRB, 0.32822056E-09_JPRB, 0.32275926E-09_JPRB, 0.31724345E-09_JPRB, 0.31165973E-09_JPRB, 0.30603220E-09_JPRB, &
  & 0.30040123E-09_JPRB, 0.29450950E-09_JPRB, 0.28776667E-09_JPRB, 0.27548747E-09_JPRB /)

RGHG6(:,25,10) = (/ &
  & 0.11787454E-09_JPRB, 0.13058225E-09_JPRB, 0.13848522E-09_JPRB, 0.14563462E-09_JPRB, 0.15310296E-09_JPRB, 0.16133660E-09_JPRB, &
  & 0.17047785E-09_JPRB, 0.18059636E-09_JPRB, 0.19168825E-09_JPRB, 0.20363360E-09_JPRB, 0.21627063E-09_JPRB, 0.22936551E-09_JPRB, &
  & 0.24268365E-09_JPRB, 0.25603852E-09_JPRB, 0.26927321E-09_JPRB, 0.28227654E-09_JPRB, 0.29502312E-09_JPRB, 0.30758027E-09_JPRB, &
  & 0.32013606E-09_JPRB, 0.33277922E-09_JPRB, 0.34560227E-09_JPRB, 0.35842246E-09_JPRB, 0.37095466E-09_JPRB, 0.38268033E-09_JPRB, &
  & 0.39311143E-09_JPRB, 0.40191747E-09_JPRB, 0.40899309E-09_JPRB, 0.41430923E-09_JPRB, 0.41801032E-09_JPRB, 0.42019940E-09_JPRB, &
  & 0.42096471E-09_JPRB, 0.42043485E-09_JPRB, 0.41891593E-09_JPRB, 0.41693177E-09_JPRB, 0.41494244E-09_JPRB, 0.41346368E-09_JPRB, &
  & 0.41284179E-09_JPRB, 0.41297674E-09_JPRB, 0.41377865E-09_JPRB, 0.41470066E-09_JPRB, 0.41532530E-09_JPRB, 0.41520690E-09_JPRB, &
  & 0.41415027E-09_JPRB, 0.41201803E-09_JPRB, 0.40872888E-09_JPRB, 0.40446990E-09_JPRB, 0.39949519E-09_JPRB, 0.39410103E-09_JPRB, &
  & 0.38844722E-09_JPRB, 0.38264342E-09_JPRB, 0.37679651E-09_JPRB, 0.37107428E-09_JPRB, 0.36556780E-09_JPRB, 0.36029679E-09_JPRB, &
  & 0.35521905E-09_JPRB, 0.35025302E-09_JPRB, 0.34531589E-09_JPRB, 0.34032804E-09_JPRB, 0.33526032E-09_JPRB, 0.33011152E-09_JPRB, &
  & 0.32489367E-09_JPRB, 0.31945144E-09_JPRB, 0.31315098E-09_JPRB, 0.30135441E-09_JPRB /)

RGHG6(:,26,10) = (/ &
  & 0.14015232E-09_JPRB, 0.15337577E-09_JPRB, 0.16097043E-09_JPRB, 0.16775442E-09_JPRB, 0.17477239E-09_JPRB, 0.18242106E-09_JPRB, &
  & 0.19095503E-09_JPRB, 0.20044383E-09_JPRB, 0.21088917E-09_JPRB, 0.22229105E-09_JPRB, 0.23448599E-09_JPRB, 0.24730351E-09_JPRB, &
  & 0.26051086E-09_JPRB, 0.27390562E-09_JPRB, 0.28728964E-09_JPRB, 0.30049330E-09_JPRB, 0.31347613E-09_JPRB, 0.32617711E-09_JPRB, &
  & 0.33874512E-09_JPRB, 0.35128436E-09_JPRB, 0.36386871E-09_JPRB, 0.37640119E-09_JPRB, 0.38859202E-09_JPRB, 0.40004600E-09_JPRB, &
  & 0.41038989E-09_JPRB, 0.41923445E-09_JPRB, 0.42652040E-09_JPRB, 0.43227880E-09_JPRB, 0.43656628E-09_JPRB, 0.43946663E-09_JPRB, &
  & 0.44107951E-09_JPRB, 0.44153475E-09_JPRB, 0.44103304E-09_JPRB, 0.43995524E-09_JPRB, 0.43868101E-09_JPRB, 0.43748413E-09_JPRB, &
  & 0.43660717E-09_JPRB, 0.43620002E-09_JPRB, 0.43609893E-09_JPRB, 0.43603224E-09_JPRB, 0.43572010E-09_JPRB, 0.43481330E-09_JPRB, &
  & 0.43310805E-09_JPRB, 0.43047305E-09_JPRB, 0.42683584E-09_JPRB, 0.42231788E-09_JPRB, 0.41712486E-09_JPRB, 0.41150344E-09_JPRB, &
  & 0.40566173E-09_JPRB, 0.39977760E-09_JPRB, 0.39400122E-09_JPRB, 0.38846068E-09_JPRB, 0.38321182E-09_JPRB, 0.37825362E-09_JPRB, &
  & 0.37352915E-09_JPRB, 0.36895545E-09_JPRB, 0.36443168E-09_JPRB, 0.35987929E-09_JPRB, 0.35526007E-09_JPRB, 0.35056866E-09_JPRB, &
  & 0.34578840E-09_JPRB, 0.34086736E-09_JPRB, 0.33488087E-09_JPRB, 0.32456351E-09_JPRB /)

RGHG6(:,27,10) = (/ &
  & 0.16380579E-09_JPRB, 0.17726511E-09_JPRB, 0.18467569E-09_JPRB, 0.19105661E-09_JPRB, 0.19751756E-09_JPRB, 0.20460775E-09_JPRB, &
  & 0.21248187E-09_JPRB, 0.22129977E-09_JPRB, 0.23112115E-09_JPRB, 0.24190269E-09_JPRB, 0.25361127E-09_JPRB, 0.26605695E-09_JPRB, &
  & 0.27904745E-09_JPRB, 0.29235706E-09_JPRB, 0.30575423E-09_JPRB, 0.31908473E-09_JPRB, 0.33207143E-09_JPRB, 0.34481462E-09_JPRB, &
  & 0.35722797E-09_JPRB, 0.36952585E-09_JPRB, 0.38160386E-09_JPRB, 0.39356388E-09_JPRB, 0.40510209E-09_JPRB, 0.41595208E-09_JPRB, &
  & 0.42579140E-09_JPRB, 0.43431289E-09_JPRB, 0.44148357E-09_JPRB, 0.44729498E-09_JPRB, 0.45184831E-09_JPRB, 0.45520790E-09_JPRB, &
  & 0.45744589E-09_JPRB, 0.45867043E-09_JPRB, 0.45902337E-09_JPRB, 0.45874576E-09_JPRB, 0.45809198E-09_JPRB, 0.45725784E-09_JPRB, &
  & 0.45635487E-09_JPRB, 0.45552892E-09_JPRB, 0.45475168E-09_JPRB, 0.45388787E-09_JPRB, 0.45278001E-09_JPRB, 0.45120013E-09_JPRB, &
  & 0.44896398E-09_JPRB, 0.44593074E-09_JPRB, 0.44203352E-09_JPRB, 0.43733578E-09_JPRB, 0.43205109E-09_JPRB, 0.42642551E-09_JPRB, &
  & 0.42064965E-09_JPRB, 0.41481463E-09_JPRB, 0.40907805E-09_JPRB, 0.40362585E-09_JPRB, 0.39854084E-09_JPRB, 0.39379716E-09_JPRB, &
  & 0.38933548E-09_JPRB, 0.38506165E-09_JPRB, 0.38087483E-09_JPRB, 0.37669112E-09_JPRB, 0.37245809E-09_JPRB, 0.36817147E-09_JPRB, &
  & 0.36385753E-09_JPRB, 0.35930220E-09_JPRB, 0.35427425E-09_JPRB, 0.34463676E-09_JPRB /)

RGHG6(:,28,10) = (/ &
  & 0.18867449E-09_JPRB, 0.20231664E-09_JPRB, 0.20944556E-09_JPRB, 0.21541974E-09_JPRB, 0.22142793E-09_JPRB, 0.22788973E-09_JPRB, &
  & 0.23516195E-09_JPRB, 0.24333840E-09_JPRB, 0.25248525E-09_JPRB, 0.26267893E-09_JPRB, 0.27381955E-09_JPRB, 0.28580943E-09_JPRB, &
  & 0.29845365E-09_JPRB, 0.31152020E-09_JPRB, 0.32480124E-09_JPRB, 0.33798569E-09_JPRB, 0.35083458E-09_JPRB, 0.36341991E-09_JPRB, &
  & 0.37552408E-09_JPRB, 0.38735554E-09_JPRB, 0.39879852E-09_JPRB, 0.40997528E-09_JPRB, 0.42067583E-09_JPRB, 0.43068696E-09_JPRB, &
  & 0.43975729E-09_JPRB, 0.44769713E-09_JPRB, 0.45443699E-09_JPRB, 0.46009446E-09_JPRB, 0.46468271E-09_JPRB, 0.46826182E-09_JPRB, &
  & 0.47089138E-09_JPRB, 0.47265086E-09_JPRB, 0.47363286E-09_JPRB, 0.47397325E-09_JPRB, 0.47381665E-09_JPRB, 0.47327725E-09_JPRB, &
  & 0.47241955E-09_JPRB, 0.47135607E-09_JPRB, 0.47012022E-09_JPRB, 0.46868975E-09_JPRB, 0.46698390E-09_JPRB, 0.46487864E-09_JPRB, &
  & 0.46222012E-09_JPRB, 0.45889262E-09_JPRB, 0.45481136E-09_JPRB, 0.45001347E-09_JPRB, 0.44468293E-09_JPRB, 0.43901763E-09_JPRB, &
  & 0.43319348E-09_JPRB, 0.42737605E-09_JPRB, 0.42182277E-09_JPRB, 0.41662804E-09_JPRB, 0.41178583E-09_JPRB, 0.40728543E-09_JPRB, &
  & 0.40306661E-09_JPRB, 0.39904691E-09_JPRB, 0.39513084E-09_JPRB, 0.39123510E-09_JPRB, 0.38732520E-09_JPRB, 0.38339004E-09_JPRB, &
  & 0.37942502E-09_JPRB, 0.37545789E-09_JPRB, 0.37063347E-09_JPRB, 0.36250383E-09_JPRB /)

RGHG6(:,29,10) = (/ &
  & 0.21453876E-09_JPRB, 0.22808327E-09_JPRB, 0.23501226E-09_JPRB, 0.24062807E-09_JPRB, 0.24611130E-09_JPRB, 0.25207611E-09_JPRB, &
  & 0.25872299E-09_JPRB, 0.26627139E-09_JPRB, 0.27481473E-09_JPRB, 0.28435523E-09_JPRB, 0.29491823E-09_JPRB, 0.30636443E-09_JPRB, &
  & 0.31853448E-09_JPRB, 0.33119624E-09_JPRB, 0.34417680E-09_JPRB, 0.35693548E-09_JPRB, 0.36954603E-09_JPRB, 0.38171732E-09_JPRB, &
  & 0.39335923E-09_JPRB, 0.40455975E-09_JPRB, 0.41527642E-09_JPRB, 0.42555812E-09_JPRB, 0.43531148E-09_JPRB, 0.44438248E-09_JPRB, &
  & 0.45256504E-09_JPRB, 0.45976412E-09_JPRB, 0.46598053E-09_JPRB, 0.47126586E-09_JPRB, 0.47568083E-09_JPRB, 0.47926918E-09_JPRB, &
  & 0.48207449E-09_JPRB, 0.48414506E-09_JPRB, 0.48553123E-09_JPRB, 0.48629539E-09_JPRB, 0.48649779E-09_JPRB, 0.48619053E-09_JPRB, &
  & 0.48539678E-09_JPRB, 0.48421095E-09_JPRB, 0.48269888E-09_JPRB, 0.48090815E-09_JPRB, 0.47880500E-09_JPRB, 0.47634019E-09_JPRB, &
  & 0.47341098E-09_JPRB, 0.46989007E-09_JPRB, 0.46573045E-09_JPRB, 0.46091261E-09_JPRB, 0.45559206E-09_JPRB, 0.44996679E-09_JPRB, &
  & 0.44421902E-09_JPRB, 0.43860057E-09_JPRB, 0.43326120E-09_JPRB, 0.42824477E-09_JPRB, 0.42358625E-09_JPRB, 0.41927151E-09_JPRB, &
  & 0.41523943E-09_JPRB, 0.41141054E-09_JPRB, 0.40769410E-09_JPRB, 0.40402612E-09_JPRB, 0.40036396E-09_JPRB, 0.39672304E-09_JPRB, &
  & 0.39313292E-09_JPRB, 0.38938500E-09_JPRB, 0.38525405E-09_JPRB, 0.37772721E-09_JPRB /)

RGHG6(:,30,10) = (/ &
  & 0.24083835E-09_JPRB, 0.25428648E-09_JPRB, 0.26086908E-09_JPRB, 0.26609914E-09_JPRB, 0.27117272E-09_JPRB, 0.27657199E-09_JPRB, &
  & 0.28268307E-09_JPRB, 0.28963976E-09_JPRB, 0.29753766E-09_JPRB, 0.30647501E-09_JPRB, 0.31639352E-09_JPRB, 0.32723046E-09_JPRB, &
  & 0.33881045E-09_JPRB, 0.35094422E-09_JPRB, 0.36336703E-09_JPRB, 0.37561243E-09_JPRB, 0.38770628E-09_JPRB, 0.39933756E-09_JPRB, &
  & 0.41037801E-09_JPRB, 0.42085521E-09_JPRB, 0.43077716E-09_JPRB, 0.44015164E-09_JPRB, 0.44893309E-09_JPRB, 0.45702703E-09_JPRB, &
  & 0.46429399E-09_JPRB, 0.47069698E-09_JPRB, 0.47627485E-09_JPRB, 0.48110177E-09_JPRB, 0.48522714E-09_JPRB, 0.48867788E-09_JPRB, &
  & 0.49149251E-09_JPRB, 0.49368898E-09_JPRB, 0.49528781E-09_JPRB, 0.49629828E-09_JPRB, 0.49672588E-09_JPRB, 0.49657994E-09_JPRB, &
  & 0.49585736E-09_JPRB, 0.49463944E-09_JPRB, 0.49298388E-09_JPRB, 0.49099785E-09_JPRB, 0.48866516E-09_JPRB, 0.48599447E-09_JPRB, &
  & 0.48291532E-09_JPRB, 0.47932436E-09_JPRB, 0.47515325E-09_JPRB, 0.47040061E-09_JPRB, 0.46517673E-09_JPRB, 0.45968049E-09_JPRB, &
  & 0.45413928E-09_JPRB, 0.44874859E-09_JPRB, 0.44358234E-09_JPRB, 0.43871579E-09_JPRB, 0.43420509E-09_JPRB, 0.43004081E-09_JPRB, &
  & 0.42615544E-09_JPRB, 0.42247228E-09_JPRB, 0.41892201E-09_JPRB, 0.41543355E-09_JPRB, 0.41198739E-09_JPRB, 0.40857279E-09_JPRB, &
  & 0.40516335E-09_JPRB, 0.40174972E-09_JPRB, 0.39777531E-09_JPRB, 0.39108417E-09_JPRB /)

RGHG6(:,31,10) = (/ &
  & 0.26717117E-09_JPRB, 0.28012168E-09_JPRB, 0.28641453E-09_JPRB, 0.29128885E-09_JPRB, 0.29589192E-09_JPRB, 0.30086175E-09_JPRB, &
  & 0.30642444E-09_JPRB, 0.31280800E-09_JPRB, 0.32012085E-09_JPRB, 0.32839120E-09_JPRB, 0.33765593E-09_JPRB, 0.34781245E-09_JPRB, &
  & 0.35870129E-09_JPRB, 0.37016615E-09_JPRB, 0.38187858E-09_JPRB, 0.39349457E-09_JPRB, 0.40490783E-09_JPRB, 0.41586024E-09_JPRB, &
  & 0.42621603E-09_JPRB, 0.43595383E-09_JPRB, 0.44507381E-09_JPRB, 0.45357482E-09_JPRB, 0.46143028E-09_JPRB, 0.46858933E-09_JPRB, &
  & 0.47498677E-09_JPRB, 0.48060689E-09_JPRB, 0.48554272E-09_JPRB, 0.48985216E-09_JPRB, 0.49360288E-09_JPRB, 0.49681786E-09_JPRB, &
  & 0.49951587E-09_JPRB, 0.50169913E-09_JPRB, 0.50335719E-09_JPRB, 0.50447208E-09_JPRB, 0.50501231E-09_JPRB, 0.50495980E-09_JPRB, &
  & 0.50430360E-09_JPRB, 0.50310300E-09_JPRB, 0.50140725E-09_JPRB, 0.49934573E-09_JPRB, 0.49691889E-09_JPRB, 0.49415633E-09_JPRB, &
  & 0.49103294E-09_JPRB, 0.48744192E-09_JPRB, 0.48332816E-09_JPRB, 0.47867793E-09_JPRB, 0.47358367E-09_JPRB, 0.46824417E-09_JPRB, &
  & 0.46288545E-09_JPRB, 0.45765858E-09_JPRB, 0.45266965E-09_JPRB, 0.44803122E-09_JPRB, 0.44375872E-09_JPRB, 0.43978987E-09_JPRB, &
  & 0.43606199E-09_JPRB, 0.43251239E-09_JPRB, 0.42907747E-09_JPRB, 0.42571277E-09_JPRB, 0.42239051E-09_JPRB, 0.41910944E-09_JPRB, &
  & 0.41589318E-09_JPRB, 0.41262568E-09_JPRB, 0.40905854E-09_JPRB, 0.40271389E-09_JPRB /)

RGHG6(:,32,10) = (/ &
  & 0.29275579E-09_JPRB, 0.30512326E-09_JPRB, 0.31099420E-09_JPRB, 0.31547986E-09_JPRB, 0.31976399E-09_JPRB, 0.32426681E-09_JPRB, &
  & 0.32938166E-09_JPRB, 0.33523986E-09_JPRB, 0.34193978E-09_JPRB, 0.34957851E-09_JPRB, 0.35812781E-09_JPRB, 0.36753556E-09_JPRB, &
  & 0.37765541E-09_JPRB, 0.38832770E-09_JPRB, 0.39922884E-09_JPRB, 0.41012033E-09_JPRB, 0.42077802E-09_JPRB, 0.43099702E-09_JPRB, &
  & 0.44063575E-09_JPRB, 0.44966070E-09_JPRB, 0.45801379E-09_JPRB, 0.46570631E-09_JPRB, 0.47273246E-09_JPRB, 0.47905657E-09_JPRB, &
  & 0.48465665E-09_JPRB, 0.48956122E-09_JPRB, 0.49386367E-09_JPRB, 0.49766291E-09_JPRB, 0.50100862E-09_JPRB, 0.50392712E-09_JPRB, &
  & 0.50642668E-09_JPRB, 0.50849153E-09_JPRB, 0.51009708E-09_JPRB, 0.51120619E-09_JPRB, 0.51177479E-09_JPRB, 0.51176335E-09_JPRB, &
  & 0.51116228E-09_JPRB, 0.51000615E-09_JPRB, 0.50834204E-09_JPRB, 0.50628746E-09_JPRB, 0.50386034E-09_JPRB, 0.50109872E-09_JPRB, &
  & 0.49798249E-09_JPRB, 0.49446042E-09_JPRB, 0.49043880E-09_JPRB, 0.48593651E-09_JPRB, 0.48105731E-09_JPRB, 0.47597087E-09_JPRB, &
  & 0.47086868E-09_JPRB, 0.46588355E-09_JPRB, 0.46114815E-09_JPRB, 0.45673304E-09_JPRB, 0.45262877E-09_JPRB, 0.44880055E-09_JPRB, &
  & 0.44518852E-09_JPRB, 0.44173160E-09_JPRB, 0.43839210E-09_JPRB, 0.43512230E-09_JPRB, 0.43190607E-09_JPRB, 0.42875800E-09_JPRB, &
  & 0.42567841E-09_JPRB, 0.42262815E-09_JPRB, 0.41909404E-09_JPRB, 0.41319367E-09_JPRB /)

RGHG6(:,33,10) = (/ &
  & 0.31703462E-09_JPRB, 0.32856007E-09_JPRB, 0.33401595E-09_JPRB, 0.33823955E-09_JPRB, 0.34213710E-09_JPRB, 0.34634659E-09_JPRB, &
  & 0.35103404E-09_JPRB, 0.35640865E-09_JPRB, 0.36256367E-09_JPRB, 0.36953196E-09_JPRB, 0.37735809E-09_JPRB, 0.38596765E-09_JPRB, &
  & 0.39524778E-09_JPRB, 0.40503909E-09_JPRB, 0.41509715E-09_JPRB, 0.42516485E-09_JPRB, 0.43505377E-09_JPRB, 0.44452553E-09_JPRB, &
  & 0.45348175E-09_JPRB, 0.46181653E-09_JPRB, 0.46950344E-09_JPRB, 0.47651699E-09_JPRB, 0.48282972E-09_JPRB, 0.48844861E-09_JPRB, &
  & 0.49336313E-09_JPRB, 0.49763682E-09_JPRB, 0.50137372E-09_JPRB, 0.50466969E-09_JPRB, 0.50760035E-09_JPRB, 0.51018523E-09_JPRB, &
  & 0.51242532E-09_JPRB, 0.51429822E-09_JPRB, 0.51576832E-09_JPRB, 0.51679561E-09_JPRB, 0.51732979E-09_JPRB, 0.51732368E-09_JPRB, &
  & 0.51676818E-09_JPRB, 0.51567595E-09_JPRB, 0.51408650E-09_JPRB, 0.51209753E-09_JPRB, 0.50973725E-09_JPRB, 0.50702581E-09_JPRB, &
  & 0.50397642E-09_JPRB, 0.50054644E-09_JPRB, 0.49665722E-09_JPRB, 0.49234328E-09_JPRB, 0.48770443E-09_JPRB, 0.48288418E-09_JPRB, &
  & 0.47805238E-09_JPRB, 0.47334858E-09_JPRB, 0.46888193E-09_JPRB, 0.46469620E-09_JPRB, 0.46079099E-09_JPRB, 0.45711590E-09_JPRB, &
  & 0.45363102E-09_JPRB, 0.45028661E-09_JPRB, 0.44702914E-09_JPRB, 0.44383716E-09_JPRB, 0.44070558E-09_JPRB, 0.43764875E-09_JPRB, &
  & 0.43468268E-09_JPRB, 0.43169235E-09_JPRB, 0.42842957E-09_JPRB, 0.42274481E-09_JPRB /)

RGHG6(:,34,10) = (/ &
  & 0.33945505E-09_JPRB, 0.35007808E-09_JPRB, 0.35516912E-09_JPRB, 0.35903849E-09_JPRB, 0.36276804E-09_JPRB, 0.36663467E-09_JPRB, &
  & 0.37100373E-09_JPRB, 0.37595757E-09_JPRB, 0.38156897E-09_JPRB, 0.38792430E-09_JPRB, 0.39500878E-09_JPRB, 0.40280357E-09_JPRB, &
  & 0.41121606E-09_JPRB, 0.42010734E-09_JPRB, 0.42928330E-09_JPRB, 0.43853329E-09_JPRB, 0.44764192E-09_JPRB, 0.45641591E-09_JPRB, &
  & 0.46472798E-09_JPRB, 0.47247317E-09_JPRB, 0.47959170E-09_JPRB, 0.48604493E-09_JPRB, 0.49178733E-09_JPRB, 0.49682253E-09_JPRB, &
  & 0.50117610E-09_JPRB, 0.50490478E-09_JPRB, 0.50813637E-09_JPRB, 0.51097276E-09_JPRB, 0.51348897E-09_JPRB, 0.51571858E-09_JPRB, &
  & 0.51765880E-09_JPRB, 0.51928634E-09_JPRB, 0.52056448E-09_JPRB, 0.52145738E-09_JPRB, 0.52191451E-09_JPRB, 0.52189231E-09_JPRB, &
  & 0.52137977E-09_JPRB, 0.52036492E-09_JPRB, 0.51888133E-09_JPRB, 0.51700139E-09_JPRB, 0.51474180E-09_JPRB, 0.51212407E-09_JPRB, &
  & 0.50917887E-09_JPRB, 0.50585464E-09_JPRB, 0.50211774E-09_JPRB, 0.49801874E-09_JPRB, 0.49363835E-09_JPRB, 0.48911247E-09_JPRB, &
  & 0.48459148E-09_JPRB, 0.48017584E-09_JPRB, 0.47596393E-09_JPRB, 0.47201748E-09_JPRB, 0.46831161E-09_JPRB, 0.46482246E-09_JPRB, &
  & 0.46148482E-09_JPRB, 0.45825213E-09_JPRB, 0.45508194E-09_JPRB, 0.45196336E-09_JPRB, 0.44889870E-09_JPRB, 0.44591714E-09_JPRB, &
  & 0.44303580E-09_JPRB, 0.44021656E-09_JPRB, 0.43704690E-09_JPRB, 0.43164330E-09_JPRB /)

RGHG6(:,35,10) = (/ &
  & 0.35972367E-09_JPRB, 0.36946779E-09_JPRB, 0.37415129E-09_JPRB, 0.37786108E-09_JPRB, 0.38129294E-09_JPRB, 0.38499243E-09_JPRB, &
  & 0.38904541E-09_JPRB, 0.39361592E-09_JPRB, 0.39876272E-09_JPRB, 0.40450773E-09_JPRB, 0.41090067E-09_JPRB, 0.41789672E-09_JPRB, &
  & 0.42545581E-09_JPRB, 0.43345816E-09_JPRB, 0.44177803E-09_JPRB, 0.45021614E-09_JPRB, 0.45858883E-09_JPRB, 0.46671517E-09_JPRB, &
  & 0.47446491E-09_JPRB, 0.48171284E-09_JPRB, 0.48837756E-09_JPRB, 0.49438315E-09_JPRB, 0.49969068E-09_JPRB, 0.50428217E-09_JPRB, &
  & 0.50817384E-09_JPRB, 0.51145183E-09_JPRB, 0.51422921E-09_JPRB, 0.51663140E-09_JPRB, 0.51874033E-09_JPRB, 0.52059879E-09_JPRB, &
  & 0.52220983E-09_JPRB, 0.52355803E-09_JPRB, 0.52460930E-09_JPRB, 0.52533555E-09_JPRB, 0.52569182E-09_JPRB, 0.52564531E-09_JPRB, &
  & 0.52517796E-09_JPRB, 0.52425908E-09_JPRB, 0.52291027E-09_JPRB, 0.52116816E-09_JPRB, 0.51903570E-09_JPRB, 0.51654919E-09_JPRB, &
  & 0.51371518E-09_JPRB, 0.51050952E-09_JPRB, 0.50693683E-09_JPRB, 0.50305471E-09_JPRB, 0.49893956E-09_JPRB, 0.49471321E-09_JPRB, &
  & 0.49049564E-09_JPRB, 0.48638377E-09_JPRB, 0.48243948E-09_JPRB, 0.47872967E-09_JPRB, 0.47524035E-09_JPRB, 0.47193144E-09_JPRB, &
  & 0.46874438E-09_JPRB, 0.46564858E-09_JPRB, 0.46259033E-09_JPRB, 0.45955936E-09_JPRB, 0.45657733E-09_JPRB, 0.45368190E-09_JPRB, &
  & 0.45090595E-09_JPRB, 0.44815346E-09_JPRB, 0.44511750E-09_JPRB, 0.43993853E-09_JPRB /)

RGHG6(:,36,10) = (/ &
  & 0.37792525E-09_JPRB, 0.38675524E-09_JPRB, 0.39113102E-09_JPRB, 0.39454212E-09_JPRB, 0.39787354E-09_JPRB, 0.40132075E-09_JPRB, &
  & 0.40514195E-09_JPRB, 0.40937401E-09_JPRB, 0.41406711E-09_JPRB, 0.41928255E-09_JPRB, 0.42501078E-09_JPRB, 0.43126130E-09_JPRB, &
  & 0.43799700E-09_JPRB, 0.44516407E-09_JPRB, 0.45264922E-09_JPRB, 0.46033574E-09_JPRB, 0.46799981E-09_JPRB, 0.47554888E-09_JPRB, &
  & 0.48278787E-09_JPRB, 0.48963944E-09_JPRB, 0.49596832E-09_JPRB, 0.50167409E-09_JPRB, 0.50665955E-09_JPRB, 0.51090482E-09_JPRB, &
  & 0.51441451E-09_JPRB, 0.51727511E-09_JPRB, 0.51963589E-09_JPRB, 0.52162219E-09_JPRB, 0.52333216E-09_JPRB, 0.52481502E-09_JPRB, &
  & 0.52608934E-09_JPRB, 0.52713917E-09_JPRB, 0.52794907E-09_JPRB, 0.52849553E-09_JPRB, 0.52874433E-09_JPRB, 0.52867694E-09_JPRB, &
  & 0.52826488E-09_JPRB, 0.52746840E-09_JPRB, 0.52628862E-09_JPRB, 0.52471738E-09_JPRB, 0.52275412E-09_JPRB, 0.52041360E-09_JPRB, &
  & 0.51770371E-09_JPRB, 0.51462196E-09_JPRB, 0.51121241E-09_JPRB, 0.50754911E-09_JPRB, 0.50369953E-09_JPRB, 0.49976062E-09_JPRB, &
  & 0.49583382E-09_JPRB, 0.49199822E-09_JPRB, 0.48830051E-09_JPRB, 0.48481974E-09_JPRB, 0.48154053E-09_JPRB, 0.47843485E-09_JPRB, &
  & 0.47542925E-09_JPRB, 0.47249404E-09_JPRB, 0.46958004E-09_JPRB, 0.46666221E-09_JPRB, 0.46377721E-09_JPRB, 0.46096738E-09_JPRB, &
  & 0.45826543E-09_JPRB, 0.45562462E-09_JPRB, 0.45271603E-09_JPRB, 0.44771981E-09_JPRB /)

RGHG6(:,37,10) = (/ &
  & 0.39432482E-09_JPRB, 0.40220824E-09_JPRB, 0.40619577E-09_JPRB, 0.40944409E-09_JPRB, 0.41255593E-09_JPRB, 0.41587514E-09_JPRB, &
  & 0.41944806E-09_JPRB, 0.42336928E-09_JPRB, 0.42767051E-09_JPRB, 0.43237247E-09_JPRB, 0.43749965E-09_JPRB, 0.44303880E-09_JPRB, &
  & 0.44900517E-09_JPRB, 0.45537346E-09_JPRB, 0.46208884E-09_JPRB, 0.46905091E-09_JPRB, 0.47610405E-09_JPRB, 0.48307658E-09_JPRB, &
  & 0.48989718E-09_JPRB, 0.49640725E-09_JPRB, 0.50248278E-09_JPRB, 0.50795484E-09_JPRB, 0.51268423E-09_JPRB, 0.51658933E-09_JPRB, &
  & 0.51970694E-09_JPRB, 0.52215660E-09_JPRB, 0.52410276E-09_JPRB, 0.52569193E-09_JPRB, 0.52702520E-09_JPRB, 0.52815824E-09_JPRB, &
  & 0.52910931E-09_JPRB, 0.52988414E-09_JPRB, 0.53046811E-09_JPRB, 0.53084981E-09_JPRB, 0.53100624E-09_JPRB, 0.53093152E-09_JPRB, &
  & 0.53059090E-09_JPRB, 0.52995069E-09_JPRB, 0.52898153E-09_JPRB, 0.52764609E-09_JPRB, 0.52591387E-09_JPRB, 0.52377375E-09_JPRB, &
  & 0.52122073E-09_JPRB, 0.51828419E-09_JPRB, 0.51505067E-09_JPRB, 0.51158949E-09_JPRB, 0.50798316E-09_JPRB, 0.50431403E-09_JPRB, &
  & 0.50064625E-09_JPRB, 0.49705279E-09_JPRB, 0.49359006E-09_JPRB, 0.49031623E-09_JPRB, 0.48725235E-09_JPRB, 0.48435089E-09_JPRB, &
  & 0.48155208E-09_JPRB, 0.47880921E-09_JPRB, 0.47607518E-09_JPRB, 0.47330773E-09_JPRB, 0.47054449E-09_JPRB, 0.46783771E-09_JPRB, &
  & 0.46523335E-09_JPRB, 0.46267853E-09_JPRB, 0.45984702E-09_JPRB, 0.45503623E-09_JPRB /)

RGHG6(:,38,10) = (/ &
  & 0.40924969E-09_JPRB, 0.41614862E-09_JPRB, 0.41973527E-09_JPRB, 0.42272930E-09_JPRB, 0.42571421E-09_JPRB, 0.42884657E-09_JPRB, &
  & 0.43222434E-09_JPRB, 0.43585635E-09_JPRB, 0.43977652E-09_JPRB, 0.44400719E-09_JPRB, 0.44855605E-09_JPRB, 0.45342877E-09_JPRB, &
  & 0.45866030E-09_JPRB, 0.46428292E-09_JPRB, 0.47028259E-09_JPRB, 0.47656845E-09_JPRB, 0.48306004E-09_JPRB, 0.48956100E-09_JPRB, &
  & 0.49596505E-09_JPRB, 0.50214549E-09_JPRB, 0.50795168E-09_JPRB, 0.51314553E-09_JPRB, 0.51752480E-09_JPRB, 0.52102328E-09_JPRB, &
  & 0.52369498E-09_JPRB, 0.52571464E-09_JPRB, 0.52726912E-09_JPRB, 0.52850713E-09_JPRB, 0.52952376E-09_JPRB, 0.53037225E-09_JPRB, &
  & 0.53107813E-09_JPRB, 0.53164217E-09_JPRB, 0.53206278E-09_JPRB, 0.53232629E-09_JPRB, 0.53242338E-09_JPRB, 0.53235438E-09_JPRB, &
  & 0.53208876E-09_JPRB, 0.53160371E-09_JPRB, 0.53086097E-09_JPRB, 0.52980387E-09_JPRB, 0.52837867E-09_JPRB, 0.52652505E-09_JPRB, &
  & 0.52421828E-09_JPRB, 0.52150428E-09_JPRB, 0.51846638E-09_JPRB, 0.51522125E-09_JPRB, 0.51184923E-09_JPRB, 0.50842219E-09_JPRB, &
  & 0.50498467E-09_JPRB, 0.50160276E-09_JPRB, 0.49833815E-09_JPRB, 0.49525872E-09_JPRB, 0.49239596E-09_JPRB, 0.48970999E-09_JPRB, &
  & 0.48714094E-09_JPRB, 0.48462212E-09_JPRB, 0.48210508E-09_JPRB, 0.47952703E-09_JPRB, 0.47692023E-09_JPRB, 0.47433701E-09_JPRB, &
  & 0.47182930E-09_JPRB, 0.46935378E-09_JPRB, 0.46663179E-09_JPRB, 0.46193055E-09_JPRB /)

RGHG6(:,39,10) = (/ &
  & 0.42288190E-09_JPRB, 0.42876525E-09_JPRB, 0.43194018E-09_JPRB, 0.43471771E-09_JPRB, 0.43752590E-09_JPRB, 0.44052265E-09_JPRB, &
  & 0.44369863E-09_JPRB, 0.44705842E-09_JPRB, 0.45061360E-09_JPRB, 0.45438750E-09_JPRB, 0.45838225E-09_JPRB, 0.46262022E-09_JPRB, &
  & 0.46716675E-09_JPRB, 0.47208576E-09_JPRB, 0.47741960E-09_JPRB, 0.48310195E-09_JPRB, 0.48901666E-09_JPRB, 0.49507193E-09_JPRB, &
  & 0.50109489E-09_JPRB, 0.50695320E-09_JPRB, 0.51240234E-09_JPRB, 0.51719989E-09_JPRB, 0.52111560E-09_JPRB, 0.52411908E-09_JPRB, &
  & 0.52634069E-09_JPRB, 0.52797433E-09_JPRB, 0.52921179E-09_JPRB, 0.53018567E-09_JPRB, 0.53098054E-09_JPRB, 0.53164195E-09_JPRB, &
  & 0.53218940E-09_JPRB, 0.53262661E-09_JPRB, 0.53294891E-09_JPRB, 0.53314392E-09_JPRB, 0.53320992E-09_JPRB, 0.53314869E-09_JPRB, &
  & 0.53293869E-09_JPRB, 0.53257021E-09_JPRB, 0.53200555E-09_JPRB, 0.53119703E-09_JPRB, 0.53007487E-09_JPRB, 0.52856014E-09_JPRB, &
  & 0.52660148E-09_JPRB, 0.52420496E-09_JPRB, 0.52144888E-09_JPRB, 0.51844629E-09_JPRB, 0.51531091E-09_JPRB, 0.51211041E-09_JPRB, &
  & 0.50888721E-09_JPRB, 0.50568916E-09_JPRB, 0.50259874E-09_JPRB, 0.49970039E-09_JPRB, 0.49702636E-09_JPRB, 0.49456000E-09_JPRB, &
  & 0.49222665E-09_JPRB, 0.48996046E-09_JPRB, 0.48767868E-09_JPRB, 0.48532633E-09_JPRB, 0.48290205E-09_JPRB, 0.48046744E-09_JPRB, &
  & 0.47807008E-09_JPRB, 0.47569881E-09_JPRB, 0.47304077E-09_JPRB, 0.46848542E-09_JPRB /)

RGHG6(:,40,10) = (/ &
  & 0.43529330E-09_JPRB, 0.44021944E-09_JPRB, 0.44302775E-09_JPRB, 0.44555823E-09_JPRB, 0.44821805E-09_JPRB, 0.45107298E-09_JPRB, &
  & 0.45406565E-09_JPRB, 0.45715945E-09_JPRB, 0.46036319E-09_JPRB, 0.46368792E-09_JPRB, 0.46715809E-09_JPRB, 0.47080340E-09_JPRB, &
  & 0.47471166E-09_JPRB, 0.47898896E-09_JPRB, 0.48369675E-09_JPRB, 0.48881910E-09_JPRB, 0.49424409E-09_JPRB, 0.49982452E-09_JPRB, &
  & 0.50544657E-09_JPRB, 0.51090265E-09_JPRB, 0.51594334E-09_JPRB, 0.52023924E-09_JPRB, 0.52363847E-09_JPRB, 0.52617688E-09_JPRB, &
  & 0.52801474E-09_JPRB, 0.52935661E-09_JPRB, 0.53036864E-09_JPRB, 0.53116689E-09_JPRB, 0.53181914E-09_JPRB, 0.53236510E-09_JPRB, &
  & 0.53281901E-09_JPRB, 0.53318217E-09_JPRB, 0.53344951E-09_JPRB, 0.53360555E-09_JPRB, 0.53365551E-09_JPRB, 0.53359911E-09_JPRB, &
  & 0.53342458E-09_JPRB, 0.53312965E-09_JPRB, 0.53268562E-09_JPRB, 0.53205407E-09_JPRB, 0.53117488E-09_JPRB, 0.52996757E-09_JPRB, &
  & 0.52837440E-09_JPRB, 0.52636073E-09_JPRB, 0.52395427E-09_JPRB, 0.52125088E-09_JPRB, 0.51837867E-09_JPRB, 0.51540833E-09_JPRB, &
  & 0.51238236E-09_JPRB, 0.50936344E-09_JPRB, 0.50642829E-09_JPRB, 0.50368659E-09_JPRB, 0.50120263E-09_JPRB, 0.49894672E-09_JPRB, &
  & 0.49685817E-09_JPRB, 0.49483756E-09_JPRB, 0.49280707E-09_JPRB, 0.49068727E-09_JPRB, 0.48847548E-09_JPRB, 0.48621079E-09_JPRB, &
  & 0.48396193E-09_JPRB, 0.48169402E-09_JPRB, 0.47916482E-09_JPRB, 0.47472271E-09_JPRB /)

RGHG6(:,41,10) = (/ &
  & 0.44648940E-09_JPRB, 0.45065682E-09_JPRB, 0.45310145E-09_JPRB, 0.45542192E-09_JPRB, 0.45793724E-09_JPRB, 0.46066234E-09_JPRB, &
  & 0.46348608E-09_JPRB, 0.46632331E-09_JPRB, 0.46918180E-09_JPRB, 0.47208715E-09_JPRB, 0.47506044E-09_JPRB, 0.47815996E-09_JPRB, &
  & 0.48149168E-09_JPRB, 0.48517973E-09_JPRB, 0.48931736E-09_JPRB, 0.49389870E-09_JPRB, 0.49882731E-09_JPRB, 0.50397347E-09_JPRB, &
  & 0.50916554E-09_JPRB, 0.51419996E-09_JPRB, 0.51874072E-09_JPRB, 0.52252480E-09_JPRB, 0.52543508E-09_JPRB, 0.52757476E-09_JPRB, &
  & 0.52912064E-09_JPRB, 0.53025018E-09_JPRB, 0.53110766E-09_JPRB, 0.53178695E-09_JPRB, 0.53234678E-09_JPRB, 0.53281812E-09_JPRB, &
  & 0.53321364E-09_JPRB, 0.53353150E-09_JPRB, 0.53376520E-09_JPRB, 0.53389748E-09_JPRB, 0.53393784E-09_JPRB, 0.53388366E-09_JPRB, &
  & 0.53373189E-09_JPRB, 0.53348426E-09_JPRB, 0.53311894E-09_JPRB, 0.53261079E-09_JPRB, 0.53190707E-09_JPRB, 0.53094690E-09_JPRB, &
  & 0.52967186E-09_JPRB, 0.52802834E-09_JPRB, 0.52599736E-09_JPRB, 0.52365190E-09_JPRB, 0.52105609E-09_JPRB, 0.51832777E-09_JPRB, &
  & 0.51551408E-09_JPRB, 0.51266136E-09_JPRB, 0.50987647E-09_JPRB, 0.50729876E-09_JPRB, 0.50498705E-09_JPRB, 0.50294446E-09_JPRB, &
  & 0.50108040E-09_JPRB, 0.49930426E-09_JPRB, 0.49751026E-09_JPRB, 0.49562904E-09_JPRB, 0.49363363E-09_JPRB, 0.49156884E-09_JPRB, &
  & 0.48948190E-09_JPRB, 0.48738102E-09_JPRB, 0.48497789E-09_JPRB, 0.48075049E-09_JPRB /)

RGHG6(:,42,10) = (/ &
  & 0.45659299E-09_JPRB, 0.46013326E-09_JPRB, 0.46229884E-09_JPRB, 0.46443113E-09_JPRB, 0.46682397E-09_JPRB, 0.46945364E-09_JPRB, &
  & 0.47211035E-09_JPRB, 0.47470994E-09_JPRB, 0.47724541E-09_JPRB, 0.47975263E-09_JPRB, 0.48227611E-09_JPRB, 0.48488197E-09_JPRB, &
  & 0.48769155E-09_JPRB, 0.49084725E-09_JPRB, 0.49445975E-09_JPRB, 0.49854043E-09_JPRB, 0.50299948E-09_JPRB, 0.50768989E-09_JPRB, &
  & 0.51244753E-09_JPRB, 0.51700527E-09_JPRB, 0.52104504E-09_JPRB, 0.52430704E-09_JPRB, 0.52678095E-09_JPRB, 0.52859150E-09_JPRB, &
  & 0.52990617E-09_JPRB, 0.53087912E-09_JPRB, 0.53162430E-09_JPRB, 0.53222021E-09_JPRB, 0.53271521E-09_JPRB, 0.53313598E-09_JPRB, &
  & 0.53349181E-09_JPRB, 0.53377930E-09_JPRB, 0.53399035E-09_JPRB, 0.53410643E-09_JPRB, 0.53414007E-09_JPRB, 0.53408650E-09_JPRB, &
  & 0.53395027E-09_JPRB, 0.53373383E-09_JPRB, 0.53342430E-09_JPRB, 0.53300248E-09_JPRB, 0.53242938E-09_JPRB, 0.53165788E-09_JPRB, &
  & 0.53064075E-09_JPRB, 0.52931881E-09_JPRB, 0.52766869E-09_JPRB, 0.52566251E-09_JPRB, 0.52339005E-09_JPRB, 0.52090804E-09_JPRB, &
  & 0.51830201E-09_JPRB, 0.51563531E-09_JPRB, 0.51301424E-09_JPRB, 0.51059151E-09_JPRB, 0.50846954E-09_JPRB, 0.50662513E-09_JPRB, &
  & 0.50497972E-09_JPRB, 0.50342308E-09_JPRB, 0.50185506E-09_JPRB, 0.50019655E-09_JPRB, 0.49842203E-09_JPRB, 0.49656484E-09_JPRB, &
  & 0.49468935E-09_JPRB, 0.49277121E-09_JPRB, 0.49058829E-09_JPRB, 0.48664572E-09_JPRB /)

RGHG6(:,43,10) = (/ &
  & 0.46572651E-09_JPRB, 0.46879967E-09_JPRB, 0.47073601E-09_JPRB, 0.47272258E-09_JPRB, 0.47503229E-09_JPRB, 0.47756954E-09_JPRB, &
  & 0.48009385E-09_JPRB, 0.48246551E-09_JPRB, 0.48470267E-09_JPRB, 0.48685467E-09_JPRB, 0.48896948E-09_JPRB, 0.49113741E-09_JPRB, &
  & 0.49348392E-09_JPRB, 0.49615539E-09_JPRB, 0.49928173E-09_JPRB, 0.50289023E-09_JPRB, 0.50688664E-09_JPRB, 0.51113380E-09_JPRB, &
  & 0.51542959E-09_JPRB, 0.51949195E-09_JPRB, 0.52298404E-09_JPRB, 0.52575894E-09_JPRB, 0.52783827E-09_JPRB, 0.52937299E-09_JPRB, &
  & 0.53050375E-09_JPRB, 0.53135352E-09_JPRB, 0.53201427E-09_JPRB, 0.53254862E-09_JPRB, 0.53299637E-09_JPRB, 0.53338023E-09_JPRB, &
  & 0.53370747E-09_JPRB, 0.53397292E-09_JPRB, 0.53416749E-09_JPRB, 0.53427129E-09_JPRB, 0.53429927E-09_JPRB, 0.53424581E-09_JPRB, &
  & 0.53412036E-09_JPRB, 0.53392679E-09_JPRB, 0.53365740E-09_JPRB, 0.53330018E-09_JPRB, 0.53282512E-09_JPRB, 0.53220028E-09_JPRB, &
  & 0.53138632E-09_JPRB, 0.53034216E-09_JPRB, 0.52901128E-09_JPRB, 0.52737037E-09_JPRB, 0.52539206E-09_JPRB, 0.52318316E-09_JPRB, &
  & 0.52080346E-09_JPRB, 0.51833071E-09_JPRB, 0.51589227E-09_JPRB, 0.51365606E-09_JPRB, 0.51171811E-09_JPRB, 0.51007126E-09_JPRB, &
  & 0.50862919E-09_JPRB, 0.50727428E-09_JPRB, 0.50591170E-09_JPRB, 0.50446347E-09_JPRB, 0.50290405E-09_JPRB, 0.50127014E-09_JPRB, &
  & 0.49961557E-09_JPRB, 0.49794296E-09_JPRB, 0.49601884E-09_JPRB, 0.49251109E-09_JPRB /)

RGHG6(:,44,10) = (/ &
  & 0.47409227E-09_JPRB, 0.47681309E-09_JPRB, 0.47857684E-09_JPRB, 0.48044801E-09_JPRB, 0.48267640E-09_JPRB, 0.48516346E-09_JPRB, &
  & 0.48754845E-09_JPRB, 0.48971832E-09_JPRB, 0.49168669E-09_JPRB, 0.49351184E-09_JPRB, 0.49527488E-09_JPRB, 0.49705817E-09_JPRB, &
  & 0.49898752E-09_JPRB, 0.50123250E-09_JPRB, 0.50391058E-09_JPRB, 0.50707022E-09_JPRB, 0.51063165E-09_JPRB, 0.51441507E-09_JPRB, &
  & 0.51821680E-09_JPRB, 0.52171373E-09_JPRB, 0.52466281E-09_JPRB, 0.52695848E-09_JPRB, 0.52869753E-09_JPRB, 0.52999716E-09_JPRB, &
  & 0.53097732E-09_JPRB, 0.53172888E-09_JPRB, 0.53232413E-09_JPRB, 0.53281124E-09_JPRB, 0.53322402E-09_JPRB, 0.53358040E-09_JPRB, &
  & 0.53388616E-09_JPRB, 0.53413474E-09_JPRB, 0.53431604E-09_JPRB, 0.53441029E-09_JPRB, 0.53443294E-09_JPRB, 0.53437943E-09_JPRB, &
  & 0.53426186E-09_JPRB, 0.53408505E-09_JPRB, 0.53384647E-09_JPRB, 0.53353805E-09_JPRB, 0.53313925E-09_JPRB, 0.53262800E-09_JPRB, &
  & 0.53197746E-09_JPRB, 0.53115495E-09_JPRB, 0.53012011E-09_JPRB, 0.52878885E-09_JPRB, 0.52714860E-09_JPRB, 0.52520205E-09_JPRB, &
  & 0.52305410E-09_JPRB, 0.52079935E-09_JPRB, 0.51856902E-09_JPRB, 0.51653015E-09_JPRB, 0.51479354E-09_JPRB, 0.51334570E-09_JPRB, &
  & 0.51208798E-09_JPRB, 0.51092253E-09_JPRB, 0.50974780E-09_JPRB, 0.50849586E-09_JPRB, 0.50714677E-09_JPRB, 0.50573346E-09_JPRB, &
  & 0.50432453E-09_JPRB, 0.50290927E-09_JPRB, 0.50129267E-09_JPRB, 0.49833959E-09_JPRB /)

RGHG6(:,45,10) = (/ &
  & 0.48187165E-09_JPRB, 0.48433341E-09_JPRB, 0.48596049E-09_JPRB, 0.48771587E-09_JPRB, 0.48990600E-09_JPRB, 0.49230786E-09_JPRB, &
  & 0.49458493E-09_JPRB, 0.49655391E-09_JPRB, 0.49826698E-09_JPRB, 0.49981430E-09_JPRB, 0.50125892E-09_JPRB, 0.50270615E-09_JPRB, &
  & 0.50429205E-09_JPRB, 0.50613314E-09_JPRB, 0.50841070E-09_JPRB, 0.51115756E-09_JPRB, 0.51427185E-09_JPRB, 0.51758864E-09_JPRB, &
  & 0.52081550E-09_JPRB, 0.52371885E-09_JPRB, 0.52609350E-09_JPRB, 0.52796767E-09_JPRB, 0.52940119E-09_JPRB, 0.53050664E-09_JPRB, &
  & 0.53136134E-09_JPRB, 0.53203397E-09_JPRB, 0.53257698E-09_JPRB, 0.53302873E-09_JPRB, 0.53341487E-09_JPRB, 0.53375088E-09_JPRB, &
  & 0.53404031E-09_JPRB, 0.53427568E-09_JPRB, 0.53444571E-09_JPRB, 0.53453192E-09_JPRB, 0.53454929E-09_JPRB, 0.53449573E-09_JPRB, &
  & 0.53438387E-09_JPRB, 0.53422006E-09_JPRB, 0.53400473E-09_JPRB, 0.53373395E-09_JPRB, 0.53339455E-09_JPRB, 0.53297194E-09_JPRB, &
  & 0.53245058E-09_JPRB, 0.53181254E-09_JPRB, 0.53101207E-09_JPRB, 0.52999177E-09_JPRB, 0.52865784E-09_JPRB, 0.52700910E-09_JPRB, &
  & 0.52510951E-09_JPRB, 0.52307614E-09_JPRB, 0.52106397E-09_JPRB, 0.51925325E-09_JPRB, 0.51772447E-09_JPRB, 0.51646942E-09_JPRB, &
  & 0.51539856E-09_JPRB, 0.51440385E-09_JPRB, 0.51340621E-09_JPRB, 0.51234139E-09_JPRB, 0.51119053E-09_JPRB, 0.50999927E-09_JPRB, &
  & 0.50882504E-09_JPRB, 0.50766819E-09_JPRB, 0.50636778E-09_JPRB, 0.50399307E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART19',1,ZHOOK_HANDLE)
END SUBROUTINE PART19




SUBROUTINE PART20
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART20',0,ZHOOK_HANDLE)



RGHG6(:,46,10) = (/ &
  & 0.48922033E-09_JPRB, 0.49150251E-09_JPRB, 0.49300491E-09_JPRB, 0.49470072E-09_JPRB, 0.49677673E-09_JPRB, 0.49914889E-09_JPRB, &
  & 0.50126125E-09_JPRB, 0.50303622E-09_JPRB, 0.50451598E-09_JPRB, 0.50578797E-09_JPRB, 0.50696242E-09_JPRB, 0.50812887E-09_JPRB, &
  & 0.50938587E-09_JPRB, 0.51091276E-09_JPRB, 0.51280474E-09_JPRB, 0.51514731E-09_JPRB, 0.51783805E-09_JPRB, 0.52059684E-09_JPRB, &
  & 0.52321658E-09_JPRB, 0.52546256E-09_JPRB, 0.52732407E-09_JPRB, 0.52880278E-09_JPRB, 0.52998639E-09_JPRB, 0.53092586E-09_JPRB, &
  & 0.53167792E-09_JPRB, 0.53228588E-09_JPRB, 0.53278820E-09_JPRB, 0.53321236E-09_JPRB, 0.53357918E-09_JPRB, 0.53390009E-09_JPRB, &
  & 0.53417670E-09_JPRB, 0.53440097E-09_JPRB, 0.53456128E-09_JPRB, 0.53464061E-09_JPRB, 0.53465288E-09_JPRB, 0.53459914E-09_JPRB, &
  & 0.53449134E-09_JPRB, 0.53433757E-09_JPRB, 0.53414007E-09_JPRB, 0.53389843E-09_JPRB, 0.53360499E-09_JPRB, 0.53325228E-09_JPRB, &
  & 0.53283244E-09_JPRB, 0.53233523E-09_JPRB, 0.53173582E-09_JPRB, 0.53096816E-09_JPRB, 0.52994925E-09_JPRB, 0.52861504E-09_JPRB, &
  & 0.52698051E-09_JPRB, 0.52518973E-09_JPRB, 0.52341614E-09_JPRB, 0.52182031E-09_JPRB, 0.52051780E-09_JPRB, 0.51945409E-09_JPRB, &
  & 0.51855437E-09_JPRB, 0.51772492E-09_JPRB, 0.51688986E-09_JPRB, 0.51599813E-09_JPRB, 0.51503785E-09_JPRB, 0.51404864E-09_JPRB, &
  & 0.51309129E-09_JPRB, 0.51216648E-09_JPRB, 0.51113846E-09_JPRB, 0.50930038E-09_JPRB /)

RGHG6(:,47,10) = (/ &
  & 0.49629229E-09_JPRB, 0.49843030E-09_JPRB, 0.49987686E-09_JPRB, 0.50144289E-09_JPRB, 0.50349930E-09_JPRB, 0.50569460E-09_JPRB, &
  & 0.50767490E-09_JPRB, 0.50922211E-09_JPRB, 0.51044946E-09_JPRB, 0.51148202E-09_JPRB, 0.51240079E-09_JPRB, 0.51330540E-09_JPRB, &
  & 0.51431248E-09_JPRB, 0.51551136E-09_JPRB, 0.51707771E-09_JPRB, 0.51902660E-09_JPRB, 0.52120530E-09_JPRB, 0.52338223E-09_JPRB, &
  & 0.52530774E-09_JPRB, 0.52696475E-09_JPRB, 0.52833965E-09_JPRB, 0.52950250E-09_JPRB, 0.53046845E-09_JPRB, 0.53127447E-09_JPRB, &
  & 0.53194182E-09_JPRB, 0.53249760E-09_JPRB, 0.53296728E-09_JPRB, 0.53337101E-09_JPRB, 0.53372329E-09_JPRB, 0.53403271E-09_JPRB, &
  & 0.53429910E-09_JPRB, 0.53451427E-09_JPRB, 0.53466548E-09_JPRB, 0.53473875E-09_JPRB, 0.53474614E-09_JPRB, 0.53469229E-09_JPRB, &
  & 0.53458737E-09_JPRB, 0.53444105E-09_JPRB, 0.53425708E-09_JPRB, 0.53403792E-09_JPRB, 0.53378035E-09_JPRB, 0.53348137E-09_JPRB, &
  & 0.53313953E-09_JPRB, 0.53275268E-09_JPRB, 0.53230298E-09_JPRB, 0.53174698E-09_JPRB, 0.53100874E-09_JPRB, 0.52998855E-09_JPRB, &
  & 0.52868265E-09_JPRB, 0.52715582E-09_JPRB, 0.52561944E-09_JPRB, 0.52426696E-09_JPRB, 0.52315602E-09_JPRB, 0.52227878E-09_JPRB, &
  & 0.52153654E-09_JPRB, 0.52085308E-09_JPRB, 0.52016669E-09_JPRB, 0.51942906E-09_JPRB, 0.51863702E-09_JPRB, 0.51782650E-09_JPRB, &
  & 0.51705468E-09_JPRB, 0.51631782E-09_JPRB, 0.51551646E-09_JPRB, 0.51409854E-09_JPRB /)

RGHG6(:,48,10) = (/ &
  & 0.50314747E-09_JPRB, 0.50523424E-09_JPRB, 0.50659166E-09_JPRB, 0.50812848E-09_JPRB, 0.51000126E-09_JPRB, 0.51211235E-09_JPRB, &
  & 0.51384103E-09_JPRB, 0.51515014E-09_JPRB, 0.51613014E-09_JPRB, 0.51690635E-09_JPRB, 0.51759169E-09_JPRB, 0.51826454E-09_JPRB, &
  & 0.51900484E-09_JPRB, 0.51994137E-09_JPRB, 0.52113885E-09_JPRB, 0.52264432E-09_JPRB, 0.52426286E-09_JPRB, 0.52575699E-09_JPRB, &
  & 0.52706345E-09_JPRB, 0.52818183E-09_JPRB, 0.52918198E-09_JPRB, 0.53007315E-09_JPRB, 0.53086974E-09_JPRB, 0.53156490E-09_JPRB, &
  & 0.53216442E-09_JPRB, 0.53267890E-09_JPRB, 0.53312355E-09_JPRB, 0.53351129E-09_JPRB, 0.53385257E-09_JPRB, 0.53415306E-09_JPRB, &
  & 0.53441090E-09_JPRB, 0.53461713E-09_JPRB, 0.53476040E-09_JPRB, 0.53482807E-09_JPRB, 0.53483112E-09_JPRB, 0.53477689E-09_JPRB, &
  & 0.53467397E-09_JPRB, 0.53453331E-09_JPRB, 0.53435956E-09_JPRB, 0.53415766E-09_JPRB, 0.53392746E-09_JPRB, 0.53366978E-09_JPRB, &
  & 0.53338733E-09_JPRB, 0.53308175E-09_JPRB, 0.53274446E-09_JPRB, 0.53234817E-09_JPRB, 0.53182980E-09_JPRB, 0.53111993E-09_JPRB, &
  & 0.53014193E-09_JPRB, 0.52895860E-09_JPRB, 0.52769872E-09_JPRB, 0.52656746E-09_JPRB, 0.52566046E-09_JPRB, 0.52493515E-09_JPRB, &
  & 0.52432947E-09_JPRB, 0.52377125E-09_JPRB, 0.52320748E-09_JPRB, 0.52260218E-09_JPRB, 0.52194915E-09_JPRB, 0.52128790E-09_JPRB, &
  & 0.52066185E-09_JPRB, 0.52007404E-09_JPRB, 0.51943844E-09_JPRB, 0.51833132E-09_JPRB /)

RGHG6(:,49,10) = (/ &
  & 0.50977661E-09_JPRB, 0.51178944E-09_JPRB, 0.51311744E-09_JPRB, 0.51453236E-09_JPRB, 0.51631754E-09_JPRB, 0.51817134E-09_JPRB, &
  & 0.51967353E-09_JPRB, 0.52070059E-09_JPRB, 0.52141680E-09_JPRB, 0.52195820E-09_JPRB, 0.52241167E-09_JPRB, 0.52285570E-09_JPRB, &
  & 0.52335775E-09_JPRB, 0.52397331E-09_JPRB, 0.52479954E-09_JPRB, 0.52576232E-09_JPRB, 0.52675653E-09_JPRB, 0.52764754E-09_JPRB, &
  & 0.52842769E-09_JPRB, 0.52915317E-09_JPRB, 0.52985427E-09_JPRB, 0.53054366E-09_JPRB, 0.53120064E-09_JPRB, 0.53180926E-09_JPRB, &
  & 0.53235533E-09_JPRB, 0.53283800E-09_JPRB, 0.53326321E-09_JPRB, 0.53363897E-09_JPRB, 0.53397103E-09_JPRB, 0.53426369E-09_JPRB, &
  & 0.53451349E-09_JPRB, 0.53471194E-09_JPRB, 0.53484717E-09_JPRB, 0.53490984E-09_JPRB, 0.53490895E-09_JPRB, 0.53485388E-09_JPRB, &
  & 0.53475285E-09_JPRB, 0.53461624E-09_JPRB, 0.53445093E-09_JPRB, 0.53426230E-09_JPRB, 0.53405314E-09_JPRB, 0.53382648E-09_JPRB, &
  & 0.53358823E-09_JPRB, 0.53334165E-09_JPRB, 0.53308585E-09_JPRB, 0.53279969E-09_JPRB, 0.53244925E-09_JPRB, 0.53197291E-09_JPRB, &
  & 0.53132693E-09_JPRB, 0.53049398E-09_JPRB, 0.52958515E-09_JPRB, 0.52871957E-09_JPRB, 0.52800098E-09_JPRB, 0.52742138E-09_JPRB, &
  & 0.52693050E-09_JPRB, 0.52647503E-09_JPRB, 0.52601196E-09_JPRB, 0.52551169E-09_JPRB, 0.52497218E-09_JPRB, 0.52442600E-09_JPRB, &
  & 0.52391425E-09_JPRB, 0.52343568E-09_JPRB, 0.52291765E-09_JPRB, 0.52202981E-09_JPRB /)

RGHG6(:,50,10) = (/ &
  & 0.51586246E-09_JPRB, 0.51775662E-09_JPRB, 0.51895477E-09_JPRB, 0.52023241E-09_JPRB, 0.52178772E-09_JPRB, 0.52337956E-09_JPRB, &
  & 0.52454885E-09_JPRB, 0.52529425E-09_JPRB, 0.52576732E-09_JPRB, 0.52609500E-09_JPRB, 0.52636062E-09_JPRB, 0.52660781E-09_JPRB, &
  & 0.52687799E-09_JPRB, 0.52721677E-09_JPRB, 0.52762211E-09_JPRB, 0.52811022E-09_JPRB, 0.52858434E-09_JPRB, 0.52902832E-09_JPRB, &
  & 0.52945515E-09_JPRB, 0.52990323E-09_JPRB, 0.53039495E-09_JPRB, 0.53092730E-09_JPRB, 0.53147775E-09_JPRB, 0.53201699E-09_JPRB, &
  & 0.53252230E-09_JPRB, 0.53298088E-09_JPRB, 0.53339194E-09_JPRB, 0.53375737E-09_JPRB, 0.53408172E-09_JPRB, 0.53436633E-09_JPRB, &
  & 0.53460875E-09_JPRB, 0.53479898E-09_JPRB, 0.53492710E-09_JPRB, 0.53498517E-09_JPRB, 0.53498117E-09_JPRB, 0.53492510E-09_JPRB, &
  & 0.53482563E-09_JPRB, 0.53469240E-09_JPRB, 0.53453381E-09_JPRB, 0.53435578E-09_JPRB, 0.53416227E-09_JPRB, 0.53395877E-09_JPRB, &
  & 0.53375215E-09_JPRB, 0.53355015E-09_JPRB, 0.53334920E-09_JPRB, 0.53314186E-09_JPRB, 0.53290083E-09_JPRB, 0.53259536E-09_JPRB, &
  & 0.53219296E-09_JPRB, 0.53169458E-09_JPRB, 0.53112476E-09_JPRB, 0.53057070E-09_JPRB, 0.53007532E-09_JPRB, 0.52965754E-09_JPRB, &
  & 0.52928562E-09_JPRB, 0.52893212E-09_JPRB, 0.52856597E-09_JPRB, 0.52815907E-09_JPRB, 0.52771848E-09_JPRB, 0.52726840E-09_JPRB, &
  & 0.52684812E-09_JPRB, 0.52644694E-09_JPRB, 0.52601862E-09_JPRB, 0.52526156E-09_JPRB /)

RGHG6(:,51,10) = (/ &
  & 0.52101001E-09_JPRB, 0.52256688E-09_JPRB, 0.52353538E-09_JPRB, 0.52456650E-09_JPRB, 0.52580268E-09_JPRB, 0.52703009E-09_JPRB, &
  & 0.52787075E-09_JPRB, 0.52835336E-09_JPRB, 0.52863658E-09_JPRB, 0.52882465E-09_JPRB, 0.52896210E-09_JPRB, 0.52908344E-09_JPRB, &
  & 0.52920412E-09_JPRB, 0.52933447E-09_JPRB, 0.52949201E-09_JPRB, 0.52965587E-09_JPRB, 0.52982996E-09_JPRB, 0.53000898E-09_JPRB, &
  & 0.53021976E-09_JPRB, 0.53048754E-09_JPRB, 0.53083138E-09_JPRB, 0.53124682E-09_JPRB, 0.53171328E-09_JPRB, 0.53219834E-09_JPRB, &
  & 0.53267163E-09_JPRB, 0.53311194E-09_JPRB, 0.53351173E-09_JPRB, 0.53386867E-09_JPRB, 0.53418525E-09_JPRB, 0.53446264E-09_JPRB, &
  & 0.53469706E-09_JPRB, 0.53487997E-09_JPRB, 0.53500115E-09_JPRB, 0.53505489E-09_JPRB, 0.53504828E-09_JPRB, 0.53499138E-09_JPRB, &
  & 0.53489335E-09_JPRB, 0.53476368E-09_JPRB, 0.53461091E-09_JPRB, 0.53444099E-09_JPRB, 0.53425953E-09_JPRB, 0.53407206E-09_JPRB, &
  & 0.53389027E-09_JPRB, 0.53371751E-09_JPRB, 0.53355936E-09_JPRB, 0.53340288E-09_JPRB, 0.53323707E-09_JPRB, 0.53304233E-09_JPRB, &
  & 0.53280713E-09_JPRB, 0.53253213E-09_JPRB, 0.53223775E-09_JPRB, 0.53194382E-09_JPRB, 0.53167765E-09_JPRB, 0.53143434E-09_JPRB, &
  & 0.53121130E-09_JPRB, 0.53098320E-09_JPRB, 0.53073040E-09_JPRB, 0.53044202E-09_JPRB, 0.53010885E-09_JPRB, 0.52976590E-09_JPRB, &
  & 0.52943050E-09_JPRB, 0.52911114E-09_JPRB, 0.52874055E-09_JPRB, 0.52810339E-09_JPRB /)

RGHG6(:,52,10) = (/ &
  & 0.52514637E-09_JPRB, 0.52608295E-09_JPRB, 0.52672111E-09_JPRB, 0.52745780E-09_JPRB, 0.52838323E-09_JPRB, 0.52925975E-09_JPRB, &
  & 0.52981508E-09_JPRB, 0.53011545E-09_JPRB, 0.53028337E-09_JPRB, 0.53038529E-09_JPRB, 0.53045879E-09_JPRB, 0.53051397E-09_JPRB, &
  & 0.53055982E-09_JPRB, 0.53059879E-09_JPRB, 0.53062754E-09_JPRB, 0.53064964E-09_JPRB, 0.53067206E-09_JPRB, 0.53071403E-09_JPRB, &
  & 0.53079907E-09_JPRB, 0.53095256E-09_JPRB, 0.53119131E-09_JPRB, 0.53151983E-09_JPRB, 0.53191995E-09_JPRB, 0.53236193E-09_JPRB, &
  & 0.53280869E-09_JPRB, 0.53323485E-09_JPRB, 0.53362359E-09_JPRB, 0.53397303E-09_JPRB, 0.53428217E-09_JPRB, 0.53455218E-09_JPRB, &
  & 0.53477955E-09_JPRB, 0.53495508E-09_JPRB, 0.53506993E-09_JPRB, 0.53511978E-09_JPRB, 0.53511101E-09_JPRB, 0.53505361E-09_JPRB, &
  & 0.53495719E-09_JPRB, 0.53483096E-09_JPRB, 0.53468341E-09_JPRB, 0.53452065E-09_JPRB, 0.53434762E-09_JPRB, 0.53417337E-09_JPRB, &
  & 0.53400678E-09_JPRB, 0.53386018E-09_JPRB, 0.53372828E-09_JPRB, 0.53361104E-09_JPRB, 0.53349453E-09_JPRB, 0.53337113E-09_JPRB, &
  & 0.53323745E-09_JPRB, 0.53309757E-09_JPRB, 0.53295757E-09_JPRB, 0.53282712E-09_JPRB, 0.53270810E-09_JPRB, 0.53260218E-09_JPRB, &
  & 0.53249549E-09_JPRB, 0.53238280E-09_JPRB, 0.53224869E-09_JPRB, 0.53207816E-09_JPRB, 0.53187699E-09_JPRB, 0.53165250E-09_JPRB, &
  & 0.53143234E-09_JPRB, 0.53120319E-09_JPRB, 0.53094057E-09_JPRB, 0.53041632E-09_JPRB /)

RGHG6(:,53,10) = (/ &
  & 0.52748617E-09_JPRB, 0.52823901E-09_JPRB, 0.52875265E-09_JPRB, 0.52930199E-09_JPRB, 0.52997778E-09_JPRB, 0.53058602E-09_JPRB, &
  & 0.53095200E-09_JPRB, 0.53113469E-09_JPRB, 0.53123195E-09_JPRB, 0.53129157E-09_JPRB, 0.53132909E-09_JPRB, 0.53135507E-09_JPRB, &
  & 0.53136912E-09_JPRB, 0.53136917E-09_JPRB, 0.53134991E-09_JPRB, 0.53131299E-09_JPRB, 0.53126814E-09_JPRB, 0.53124072E-09_JPRB, &
  & 0.53125426E-09_JPRB, 0.53133298E-09_JPRB, 0.53149862E-09_JPRB, 0.53176036E-09_JPRB, 0.53210908E-09_JPRB, 0.53251398E-09_JPRB, &
  & 0.53293925E-09_JPRB, 0.53334848E-09_JPRB, 0.53372928E-09_JPRB, 0.53406934E-09_JPRB, 0.53437249E-09_JPRB, 0.53463561E-09_JPRB, &
  & 0.53485605E-09_JPRB, 0.53502491E-09_JPRB, 0.53513388E-09_JPRB, 0.53518051E-09_JPRB, 0.53517013E-09_JPRB, 0.53511262E-09_JPRB, &
  & 0.53501753E-09_JPRB, 0.53489480E-09_JPRB, 0.53475241E-09_JPRB, 0.53459542E-09_JPRB, 0.53443006E-09_JPRB, 0.53426397E-09_JPRB, &
  & 0.53411331E-09_JPRB, 0.53398058E-09_JPRB, 0.53387444E-09_JPRB, 0.53378169E-09_JPRB, 0.53370031E-09_JPRB, 0.53362226E-09_JPRB, &
  & 0.53354737E-09_JPRB, 0.53347715E-09_JPRB, 0.53341420E-09_JPRB, 0.53335891E-09_JPRB, 0.53331184E-09_JPRB, 0.53326721E-09_JPRB, &
  & 0.53322435E-09_JPRB, 0.53317301E-09_JPRB, 0.53310806E-09_JPRB, 0.53302301E-09_JPRB, 0.53291305E-09_JPRB, 0.53279292E-09_JPRB, &
  & 0.53266946E-09_JPRB, 0.53254723E-09_JPRB, 0.53239224E-09_JPRB, 0.53207727E-09_JPRB /)

RGHG6(:,54,10) = (/ &
  & 0.52919324E-09_JPRB, 0.52975413E-09_JPRB, 0.53010424E-09_JPRB, 0.53052074E-09_JPRB, 0.53099852E-09_JPRB, 0.53142474E-09_JPRB, &
  & 0.53165539E-09_JPRB, 0.53177007E-09_JPRB, 0.53182914E-09_JPRB, 0.53186255E-09_JPRB, 0.53188376E-09_JPRB, 0.53189486E-09_JPRB, &
  & 0.53189619E-09_JPRB, 0.53188293E-09_JPRB, 0.53184923E-09_JPRB, 0.53178850E-09_JPRB, 0.53171717E-09_JPRB, 0.53165400E-09_JPRB, &
  & 0.53162491E-09_JPRB, 0.53165461E-09_JPRB, 0.53176769E-09_JPRB, 0.53198018E-09_JPRB, 0.53228710E-09_JPRB, 0.53266180E-09_JPRB, &
  & 0.53306237E-09_JPRB, 0.53345861E-09_JPRB, 0.53382510E-09_JPRB, 0.53415972E-09_JPRB, 0.53445570E-09_JPRB, 0.53471316E-09_JPRB, &
  & 0.53492727E-09_JPRB, 0.53508958E-09_JPRB, 0.53519356E-09_JPRB, 0.53523735E-09_JPRB, 0.53522597E-09_JPRB, 0.53516885E-09_JPRB, &
  & 0.53507559E-09_JPRB, 0.53495608E-09_JPRB, 0.53481791E-09_JPRB, 0.53466659E-09_JPRB, 0.53450705E-09_JPRB, 0.53435073E-09_JPRB, &
  & 0.53420773E-09_JPRB, 0.53409327E-09_JPRB, 0.53400018E-09_JPRB, 0.53392946E-09_JPRB, 0.53387095E-09_JPRB, 0.53382154E-09_JPRB, &
  & 0.53377947E-09_JPRB, 0.53374472E-09_JPRB, 0.53371624E-09_JPRB, 0.53369342E-09_JPRB, 0.53367399E-09_JPRB, 0.53365679E-09_JPRB, &
  & 0.53363702E-09_JPRB, 0.53361393E-09_JPRB, 0.53358168E-09_JPRB, 0.53353638E-09_JPRB, 0.53347948E-09_JPRB, 0.53341598E-09_JPRB, &
  & 0.53335647E-09_JPRB, 0.53330140E-09_JPRB, 0.53325089E-09_JPRB, 0.53318755E-09_JPRB /)

RGHG6(:,55,10) = (/ &
  & 0.53034588E-09_JPRB, 0.53075977E-09_JPRB, 0.53105415E-09_JPRB, 0.53134319E-09_JPRB, 0.53170046E-09_JPRB, 0.53197946E-09_JPRB, &
  & 0.53213467E-09_JPRB, 0.53220528E-09_JPRB, 0.53224170E-09_JPRB, 0.53226240E-09_JPRB, 0.53227400E-09_JPRB, 0.53227900E-09_JPRB, &
  & 0.53227589E-09_JPRB, 0.53226001E-09_JPRB, 0.53222249E-09_JPRB, 0.53216020E-09_JPRB, 0.53207594E-09_JPRB, 0.53199450E-09_JPRB, &
  & 0.53193899E-09_JPRB, 0.53193505E-09_JPRB, 0.53201066E-09_JPRB, 0.53218574E-09_JPRB, 0.53245958E-09_JPRB, 0.53280541E-09_JPRB, &
  & 0.53318416E-09_JPRB, 0.53356031E-09_JPRB, 0.53391769E-09_JPRB, 0.53424265E-09_JPRB, 0.53453375E-09_JPRB, 0.53478555E-09_JPRB, &
  & 0.53499344E-09_JPRB, 0.53514987E-09_JPRB, 0.53524912E-09_JPRB, 0.53529076E-09_JPRB, 0.53527904E-09_JPRB, 0.53522287E-09_JPRB, &
  & 0.53513177E-09_JPRB, 0.53501514E-09_JPRB, 0.53488097E-09_JPRB, 0.53473420E-09_JPRB, 0.53458160E-09_JPRB, 0.53443161E-09_JPRB, &
  & 0.53430138E-09_JPRB, 0.53419480E-09_JPRB, 0.53411792E-09_JPRB, 0.53406013E-09_JPRB, 0.53401827E-09_JPRB, 0.53398652E-09_JPRB, &
  & 0.53396287E-09_JPRB, 0.53394528E-09_JPRB, 0.53393256E-09_JPRB, 0.53392279E-09_JPRB, 0.53391502E-09_JPRB, 0.53390692E-09_JPRB, &
  & 0.53389815E-09_JPRB, 0.53388560E-09_JPRB, 0.53386789E-09_JPRB, 0.53384236E-09_JPRB, 0.53380833E-09_JPRB, 0.53377169E-09_JPRB, &
  & 0.53373606E-09_JPRB, 0.53370247E-09_JPRB, 0.53366522E-09_JPRB, 0.53360433E-09_JPRB /)

RGHG6(:,56,10) = (/ &
  & 0.53119231E-09_JPRB, 0.53152405E-09_JPRB, 0.53171778E-09_JPRB, 0.53194887E-09_JPRB, 0.53219018E-09_JPRB, 0.53238935E-09_JPRB, &
  & 0.53248678E-09_JPRB, 0.53253346E-09_JPRB, 0.53255644E-09_JPRB, 0.53256932E-09_JPRB, 0.53257654E-09_JPRB, 0.53257876E-09_JPRB, &
  & 0.53257454E-09_JPRB, 0.53255983E-09_JPRB, 0.53252680E-09_JPRB, 0.53246479E-09_JPRB, 0.53237981E-09_JPRB, 0.53228766E-09_JPRB, &
  & 0.53221411E-09_JPRB, 0.53218657E-09_JPRB, 0.53223481E-09_JPRB, 0.53238197E-09_JPRB, 0.53262816E-09_JPRB, 0.53294708E-09_JPRB, &
  & 0.53330207E-09_JPRB, 0.53366139E-09_JPRB, 0.53400456E-09_JPRB, 0.53432248E-09_JPRB, 0.53460719E-09_JPRB, 0.53485344E-09_JPRB, &
  & 0.53505539E-09_JPRB, 0.53520610E-09_JPRB, 0.53530158E-09_JPRB, 0.53534144E-09_JPRB, 0.53532978E-09_JPRB, 0.53527521E-09_JPRB, &
  & 0.53518667E-09_JPRB, 0.53507310E-09_JPRB, 0.53494204E-09_JPRB, 0.53480037E-09_JPRB, 0.53465288E-09_JPRB, 0.53451227E-09_JPRB, &
  & 0.53438903E-09_JPRB, 0.53429516E-09_JPRB, 0.53422661E-09_JPRB, 0.53418076E-09_JPRB, 0.53414972E-09_JPRB, 0.53412907E-09_JPRB, &
  & 0.53411531E-09_JPRB, 0.53410631E-09_JPRB, 0.53410038E-09_JPRB, 0.53409610E-09_JPRB, 0.53409233E-09_JPRB, 0.53408844E-09_JPRB, &
  & 0.53408311E-09_JPRB, 0.53407578E-09_JPRB, 0.53406446E-09_JPRB, 0.53404753E-09_JPRB, 0.53402593E-09_JPRB, 0.53400240E-09_JPRB, &
  & 0.53397986E-09_JPRB, 0.53395843E-09_JPRB, 0.53393651E-09_JPRB, 0.53390153E-09_JPRB /)

RGHG6(:,57,10) = (/ &
  & 0.53181581E-09_JPRB, 0.53206117E-09_JPRB, 0.53222871E-09_JPRB, 0.53238647E-09_JPRB, 0.53256782E-09_JPRB, 0.53269877E-09_JPRB, &
  & 0.53276705E-09_JPRB, 0.53279769E-09_JPRB, 0.53281368E-09_JPRB, 0.53282273E-09_JPRB, 0.53282762E-09_JPRB, 0.53282906E-09_JPRB, &
  & 0.53282567E-09_JPRB, 0.53281357E-09_JPRB, 0.53278537E-09_JPRB, 0.53273108E-09_JPRB, 0.53264593E-09_JPRB, 0.53254801E-09_JPRB, &
  & 0.53246230E-09_JPRB, 0.53241817E-09_JPRB, 0.53244686E-09_JPRB, 0.53257149E-09_JPRB, 0.53279275E-09_JPRB, 0.53308769E-09_JPRB, &
  & 0.53341920E-09_JPRB, 0.53376031E-09_JPRB, 0.53409133E-09_JPRB, 0.53439964E-09_JPRB, 0.53467764E-09_JPRB, 0.53491761E-09_JPRB, &
  & 0.53511351E-09_JPRB, 0.53525911E-09_JPRB, 0.53535126E-09_JPRB, 0.53538995E-09_JPRB, 0.53537919E-09_JPRB, 0.53532656E-09_JPRB, &
  & 0.53524096E-09_JPRB, 0.53513038E-09_JPRB, 0.53500310E-09_JPRB, 0.53486482E-09_JPRB, 0.53472426E-09_JPRB, 0.53459004E-09_JPRB, &
  & 0.53447724E-09_JPRB, 0.53439053E-09_JPRB, 0.53433158E-09_JPRB, 0.53429333E-09_JPRB, 0.53427018E-09_JPRB, 0.53425636E-09_JPRB, &
  & 0.53424831E-09_JPRB, 0.53424321E-09_JPRB, 0.53423982E-09_JPRB, 0.53423710E-09_JPRB, 0.53423477E-09_JPRB, 0.53423166E-09_JPRB, &
  & 0.53422788E-09_JPRB, 0.53422211E-09_JPRB, 0.53421367E-09_JPRB, 0.53420135E-09_JPRB, 0.53418542E-09_JPRB, 0.53416860E-09_JPRB, &
  & 0.53415256E-09_JPRB, 0.53413718E-09_JPRB, 0.53411975E-09_JPRB, 0.53408977E-09_JPRB /)

RGHG6(:,58,10) = (/ &
  & 0.53231974E-09_JPRB, 0.53250099E-09_JPRB, 0.53261084E-09_JPRB, 0.53273502E-09_JPRB, 0.53286114E-09_JPRB, 0.53295546E-09_JPRB, &
  & 0.53300209E-09_JPRB, 0.53302462E-09_JPRB, 0.53303634E-09_JPRB, 0.53304344E-09_JPRB, 0.53304772E-09_JPRB, 0.53304938E-09_JPRB, &
  & 0.53304738E-09_JPRB, 0.53303889E-09_JPRB, 0.53301596E-09_JPRB, 0.53296789E-09_JPRB, 0.53288707E-09_JPRB, 0.53278554E-09_JPRB, &
  & 0.53269189E-09_JPRB, 0.53263632E-09_JPRB, 0.53265037E-09_JPRB, 0.53275645E-09_JPRB, 0.53295574E-09_JPRB, 0.53322624E-09_JPRB, &
  & 0.53353727E-09_JPRB, 0.53386034E-09_JPRB, 0.53417837E-09_JPRB, 0.53447630E-09_JPRB, 0.53474630E-09_JPRB, 0.53497923E-09_JPRB, &
  & 0.53516852E-09_JPRB, 0.53530974E-09_JPRB, 0.53539917E-09_JPRB, 0.53543725E-09_JPRB, 0.53542770E-09_JPRB, 0.53537769E-09_JPRB, &
  & 0.53529525E-09_JPRB, 0.53518812E-09_JPRB, 0.53506388E-09_JPRB, 0.53493082E-09_JPRB, 0.53479460E-09_JPRB, 0.53466853E-09_JPRB, &
  & 0.53456295E-09_JPRB, 0.53448473E-09_JPRB, 0.53443255E-09_JPRB, 0.53440086E-09_JPRB, 0.53438315E-09_JPRB, 0.53437388E-09_JPRB, &
  & 0.53436855E-09_JPRB, 0.53436489E-09_JPRB, 0.53436189E-09_JPRB, 0.53435900E-09_JPRB, 0.53435600E-09_JPRB, 0.53435284E-09_JPRB, &
  & 0.53434879E-09_JPRB, 0.53434362E-09_JPRB, 0.53433613E-09_JPRB, 0.53432542E-09_JPRB, 0.53431248E-09_JPRB, 0.53429905E-09_JPRB, &
  & 0.53428650E-09_JPRB, 0.53427462E-09_JPRB, 0.53426175E-09_JPRB, 0.53423982E-09_JPRB /)

RGHG6(:,59,10) = (/ &
  & 0.53267679E-09_JPRB, 0.53282362E-09_JPRB, 0.53291932E-09_JPRB, 0.53301014E-09_JPRB, 0.53310401E-09_JPRB, 0.53317273E-09_JPRB, &
  & 0.53320837E-09_JPRB, 0.53322607E-09_JPRB, 0.53323618E-09_JPRB, 0.53324278E-09_JPRB, 0.53324739E-09_JPRB, 0.53325033E-09_JPRB, &
  & 0.53325039E-09_JPRB, 0.53324473E-09_JPRB, 0.53322757E-09_JPRB, 0.53318538E-09_JPRB, 0.53310856E-09_JPRB, 0.53300647E-09_JPRB, &
  & 0.53290777E-09_JPRB, 0.53284527E-09_JPRB, 0.53284843E-09_JPRB, 0.53293836E-09_JPRB, 0.53311661E-09_JPRB, 0.53336596E-09_JPRB, &
  & 0.53365640E-09_JPRB, 0.53396265E-09_JPRB, 0.53426680E-09_JPRB, 0.53455351E-09_JPRB, 0.53481425E-09_JPRB, 0.53503857E-09_JPRB, &
  & 0.53522198E-09_JPRB, 0.53535859E-09_JPRB, 0.53544569E-09_JPRB, 0.53548338E-09_JPRB, 0.53547550E-09_JPRB, 0.53542848E-09_JPRB, &
  & 0.53534954E-09_JPRB, 0.53524596E-09_JPRB, 0.53512611E-09_JPRB, 0.53499649E-09_JPRB, 0.53486660E-09_JPRB, 0.53474647E-09_JPRB, &
  & 0.53464855E-09_JPRB, 0.53457699E-09_JPRB, 0.53453086E-09_JPRB, 0.53450427E-09_JPRB, 0.53449056E-09_JPRB, 0.53448412E-09_JPRB, &
  & 0.53448035E-09_JPRB, 0.53447663E-09_JPRB, 0.53447269E-09_JPRB, 0.53446847E-09_JPRB, 0.53446453E-09_JPRB, 0.53446025E-09_JPRB, &
  & 0.53445570E-09_JPRB, 0.53444982E-09_JPRB, 0.53444216E-09_JPRB, 0.53443205E-09_JPRB, 0.53442006E-09_JPRB, 0.53440830E-09_JPRB, &
  & 0.53439742E-09_JPRB, 0.53438709E-09_JPRB, 0.53437554E-09_JPRB, 0.53435567E-09_JPRB /)

RGHG6(:,60,10) = (/ &
  & 0.53297922E-09_JPRB, 0.53310023E-09_JPRB, 0.53317067E-09_JPRB, 0.53324201E-09_JPRB, 0.53331312E-09_JPRB, 0.53336552E-09_JPRB, &
  & 0.53339472E-09_JPRB, 0.53341032E-09_JPRB, 0.53342003E-09_JPRB, 0.53342708E-09_JPRB, 0.53343296E-09_JPRB, 0.53343746E-09_JPRB, &
  & 0.53344029E-09_JPRB, 0.53343852E-09_JPRB, 0.53342530E-09_JPRB, 0.53338922E-09_JPRB, 0.53331561E-09_JPRB, 0.53321436E-09_JPRB, &
  & 0.53311466E-09_JPRB, 0.53304799E-09_JPRB, 0.53304283E-09_JPRB, 0.53311838E-09_JPRB, 0.53327792E-09_JPRB, 0.53350646E-09_JPRB, &
  & 0.53377774E-09_JPRB, 0.53406762E-09_JPRB, 0.53435728E-09_JPRB, 0.53463184E-09_JPRB, 0.53488153E-09_JPRB, 0.53509774E-09_JPRB, &
  & 0.53527416E-09_JPRB, 0.53540650E-09_JPRB, 0.53549126E-09_JPRB, 0.53552879E-09_JPRB, 0.53552268E-09_JPRB, 0.53547883E-09_JPRB, &
  & 0.53540355E-09_JPRB, 0.53530441E-09_JPRB, 0.53518856E-09_JPRB, 0.53506377E-09_JPRB, 0.53493865E-09_JPRB, 0.53482518E-09_JPRB, &
  & 0.53473354E-09_JPRB, 0.53466820E-09_JPRB, 0.53462723E-09_JPRB, 0.53460458E-09_JPRB, 0.53459392E-09_JPRB, 0.53458937E-09_JPRB, &
  & 0.53458626E-09_JPRB, 0.53458182E-09_JPRB, 0.53457622E-09_JPRB, 0.53457017E-09_JPRB, 0.53456434E-09_JPRB, 0.53455895E-09_JPRB, &
  & 0.53455296E-09_JPRB, 0.53454619E-09_JPRB, 0.53453753E-09_JPRB, 0.53452665E-09_JPRB, 0.53451465E-09_JPRB, 0.53450327E-09_JPRB, &
  & 0.53449301E-09_JPRB, 0.53448346E-09_JPRB, 0.53447319E-09_JPRB, 0.53445559E-09_JPRB /)

RGHG6(:,61,10) = (/ &
  & 0.53322569E-09_JPRB, 0.53332594E-09_JPRB, 0.53338656E-09_JPRB, 0.53344218E-09_JPRB, 0.53349714E-09_JPRB, 0.53354093E-09_JPRB, &
  & 0.53356675E-09_JPRB, 0.53358207E-09_JPRB, 0.53359245E-09_JPRB, 0.53360077E-09_JPRB, 0.53360832E-09_JPRB, 0.53361571E-09_JPRB, &
  & 0.53362170E-09_JPRB, 0.53362414E-09_JPRB, 0.53361598E-09_JPRB, 0.53358268E-09_JPRB, 0.53351240E-09_JPRB, 0.53341381E-09_JPRB, &
  & 0.53331484E-09_JPRB, 0.53324661E-09_JPRB, 0.53323457E-09_JPRB, 0.53329791E-09_JPRB, 0.53343996E-09_JPRB, 0.53364929E-09_JPRB, &
  & 0.53390226E-09_JPRB, 0.53417515E-09_JPRB, 0.53445026E-09_JPRB, 0.53471183E-09_JPRB, 0.53495008E-09_JPRB, 0.53515670E-09_JPRB, &
  & 0.53532656E-09_JPRB, 0.53545379E-09_JPRB, 0.53553606E-09_JPRB, 0.53557347E-09_JPRB, 0.53556920E-09_JPRB, 0.53552834E-09_JPRB, &
  & 0.53545723E-09_JPRB, 0.53536242E-09_JPRB, 0.53525134E-09_JPRB, 0.53513105E-09_JPRB, 0.53501170E-09_JPRB, 0.53490407E-09_JPRB, &
  & 0.53481852E-09_JPRB, 0.53475852E-09_JPRB, 0.53472182E-09_JPRB, 0.53470262E-09_JPRB, 0.53469429E-09_JPRB, 0.53469101E-09_JPRB, &
  & 0.53468813E-09_JPRB, 0.53468308E-09_JPRB, 0.53467542E-09_JPRB, 0.53466698E-09_JPRB, 0.53465921E-09_JPRB, 0.53465166E-09_JPRB, &
  & 0.53464427E-09_JPRB, 0.53463572E-09_JPRB, 0.53462546E-09_JPRB, 0.53461341E-09_JPRB, 0.53460047E-09_JPRB, 0.53458843E-09_JPRB, &
  & 0.53457788E-09_JPRB, 0.53456817E-09_JPRB, 0.53455768E-09_JPRB, 0.53454030E-09_JPRB /)

RGHG6(:,62,10) = (/ &
  & 0.53344212E-09_JPRB, 0.53352750E-09_JPRB, 0.53357591E-09_JPRB, 0.53362137E-09_JPRB, 0.53366667E-09_JPRB, 0.53370353E-09_JPRB, &
  & 0.53372839E-09_JPRB, 0.53374427E-09_JPRB, 0.53375615E-09_JPRB, 0.53376648E-09_JPRB, 0.53377686E-09_JPRB, 0.53378763E-09_JPRB, &
  & 0.53379862E-09_JPRB, 0.53380589E-09_JPRB, 0.53380178E-09_JPRB, 0.53377092E-09_JPRB, 0.53370247E-09_JPRB, 0.53360699E-09_JPRB, &
  & 0.53351112E-09_JPRB, 0.53344229E-09_JPRB, 0.53342503E-09_JPRB, 0.53347782E-09_JPRB, 0.53360433E-09_JPRB, 0.53379551E-09_JPRB, &
  & 0.53402993E-09_JPRB, 0.53428639E-09_JPRB, 0.53454619E-09_JPRB, 0.53479410E-09_JPRB, 0.53501997E-09_JPRB, 0.53521737E-09_JPRB, &
  & 0.53537941E-09_JPRB, 0.53550137E-09_JPRB, 0.53558064E-09_JPRB, 0.53561738E-09_JPRB, 0.53561466E-09_JPRB, 0.53557703E-09_JPRB, &
  & 0.53551014E-09_JPRB, 0.53542015E-09_JPRB, 0.53531402E-09_JPRB, 0.53519911E-09_JPRB, 0.53508531E-09_JPRB, 0.53498350E-09_JPRB, &
  & 0.53490345E-09_JPRB, 0.53484822E-09_JPRB, 0.53481519E-09_JPRB, 0.53479876E-09_JPRB, 0.53479210E-09_JPRB, 0.53478966E-09_JPRB, &
  & 0.53478699E-09_JPRB, 0.53478133E-09_JPRB, 0.53477234E-09_JPRB, 0.53476146E-09_JPRB, 0.53475113E-09_JPRB, 0.53474158E-09_JPRB, &
  & 0.53473170E-09_JPRB, 0.53472105E-09_JPRB, 0.53470867E-09_JPRB, 0.53469434E-09_JPRB, 0.53467980E-09_JPRB, 0.53466664E-09_JPRB, &
  & 0.53465521E-09_JPRB, 0.53464477E-09_JPRB, 0.53463373E-09_JPRB, 0.53461507E-09_JPRB /)

RGHG6(:,63,10) = (/ &
  & 0.53362792E-09_JPRB, 0.53370419E-09_JPRB, 0.53374727E-09_JPRB, 0.53378590E-09_JPRB, 0.53382393E-09_JPRB, 0.53385762E-09_JPRB, &
  & 0.53388161E-09_JPRB, 0.53389909E-09_JPRB, 0.53391297E-09_JPRB, 0.53392607E-09_JPRB, 0.53394000E-09_JPRB, 0.53395566E-09_JPRB, &
  & 0.53397209E-09_JPRB, 0.53398491E-09_JPRB, 0.53398347E-09_JPRB, 0.53395321E-09_JPRB, 0.53388705E-09_JPRB, 0.53379678E-09_JPRB, &
  & 0.53370441E-09_JPRB, 0.53363608E-09_JPRB, 0.53361526E-09_JPRB, 0.53365901E-09_JPRB, 0.53377180E-09_JPRB, 0.53394578E-09_JPRB, &
  & 0.53416233E-09_JPRB, 0.53440175E-09_JPRB, 0.53464599E-09_JPRB, 0.53487959E-09_JPRB, 0.53509303E-09_JPRB, 0.53527999E-09_JPRB, &
  & 0.53543359E-09_JPRB, 0.53554927E-09_JPRB, 0.53562482E-09_JPRB, 0.53566063E-09_JPRB, 0.53565913E-09_JPRB, 0.53562460E-09_JPRB, &
  & 0.53556204E-09_JPRB, 0.53547711E-09_JPRB, 0.53537652E-09_JPRB, 0.53526727E-09_JPRB, 0.53515931E-09_JPRB, 0.53506349E-09_JPRB, &
  & 0.53498844E-09_JPRB, 0.53493743E-09_JPRB, 0.53490767E-09_JPRB, 0.53489330E-09_JPRB, 0.53488797E-09_JPRB, 0.53488597E-09_JPRB, &
  & 0.53488342E-09_JPRB, 0.53487759E-09_JPRB, 0.53486754E-09_JPRB, 0.53485499E-09_JPRB, 0.53484228E-09_JPRB, 0.53483001E-09_JPRB, &
  & 0.53481775E-09_JPRB, 0.53480420E-09_JPRB, 0.53478871E-09_JPRB, 0.53477178E-09_JPRB, 0.53475474E-09_JPRB, 0.53473947E-09_JPRB, &
  & 0.53472649E-09_JPRB, 0.53471449E-09_JPRB, 0.53470151E-09_JPRB, 0.53468030E-09_JPRB /)

RGHG6(:,64,10) = (/ &
  & 0.53379501E-09_JPRB, 0.53386606E-09_JPRB, 0.53390525E-09_JPRB, 0.53393939E-09_JPRB, 0.53397364E-09_JPRB, 0.53400417E-09_JPRB, &
  & 0.53402893E-09_JPRB, 0.53404742E-09_JPRB, 0.53406424E-09_JPRB, 0.53408056E-09_JPRB, 0.53409926E-09_JPRB, 0.53412108E-09_JPRB, &
  & 0.53414428E-09_JPRB, 0.53416221E-09_JPRB, 0.53416249E-09_JPRB, 0.53413185E-09_JPRB, 0.53406868E-09_JPRB, 0.53398252E-09_JPRB, &
  & 0.53389432E-09_JPRB, 0.53382743E-09_JPRB, 0.53380439E-09_JPRB, 0.53384097E-09_JPRB, 0.53394156E-09_JPRB, 0.53409965E-09_JPRB, &
  & 0.53429877E-09_JPRB, 0.53452132E-09_JPRB, 0.53474924E-09_JPRB, 0.53496824E-09_JPRB, 0.53516841E-09_JPRB, 0.53534399E-09_JPRB, &
  & 0.53548810E-09_JPRB, 0.53559679E-09_JPRB, 0.53566790E-09_JPRB, 0.53570204E-09_JPRB, 0.53570154E-09_JPRB, 0.53567006E-09_JPRB, &
  & 0.53561217E-09_JPRB, 0.53553262E-09_JPRB, 0.53543797E-09_JPRB, 0.53533478E-09_JPRB, 0.53523314E-09_JPRB, 0.53514310E-09_JPRB, &
  & 0.53507293E-09_JPRB, 0.53502575E-09_JPRB, 0.53499843E-09_JPRB, 0.53498578E-09_JPRB, 0.53498123E-09_JPRB, 0.53497951E-09_JPRB, &
  & 0.53497712E-09_JPRB, 0.53497112E-09_JPRB, 0.53496119E-09_JPRB, 0.53494742E-09_JPRB, 0.53493254E-09_JPRB, 0.53491789E-09_JPRB, &
  & 0.53490251E-09_JPRB, 0.53488580E-09_JPRB, 0.53486715E-09_JPRB, 0.53484667E-09_JPRB, 0.53482679E-09_JPRB, 0.53480920E-09_JPRB, &
  & 0.53479376E-09_JPRB, 0.53477928E-09_JPRB, 0.53476357E-09_JPRB, 0.53473659E-09_JPRB /)

RGHG6(:,65,10) = (/ &
  & 0.53394777E-09_JPRB, 0.53401683E-09_JPRB, 0.53405358E-09_JPRB, 0.53408600E-09_JPRB, 0.53411708E-09_JPRB, 0.53414656E-09_JPRB, &
  & 0.53417054E-09_JPRB, 0.53419208E-09_JPRB, 0.53421090E-09_JPRB, 0.53423221E-09_JPRB, 0.53425597E-09_JPRB, 0.53428417E-09_JPRB, &
  & 0.53431276E-09_JPRB, 0.53433213E-09_JPRB, 0.53433180E-09_JPRB, 0.53430282E-09_JPRB, 0.53424398E-09_JPRB, 0.53416388E-09_JPRB, &
  & 0.53408034E-09_JPRB, 0.53401628E-09_JPRB, 0.53399218E-09_JPRB, 0.53402316E-09_JPRB, 0.53411309E-09_JPRB, 0.53425597E-09_JPRB, &
  & 0.53443844E-09_JPRB, 0.53464350E-09_JPRB, 0.53485477E-09_JPRB, 0.53505811E-09_JPRB, 0.53524452E-09_JPRB, 0.53540772E-09_JPRB, &
  & 0.53554161E-09_JPRB, 0.53564253E-09_JPRB, 0.53570859E-09_JPRB, 0.53574056E-09_JPRB, 0.53574084E-09_JPRB, 0.53571247E-09_JPRB, &
  & 0.53565935E-09_JPRB, 0.53558585E-09_JPRB, 0.53549748E-09_JPRB, 0.53540122E-09_JPRB, 0.53530613E-09_JPRB, 0.53522198E-09_JPRB, &
  & 0.53515653E-09_JPRB, 0.53511245E-09_JPRB, 0.53508725E-09_JPRB, 0.53507571E-09_JPRB, 0.53507176E-09_JPRB, 0.53507015E-09_JPRB, &
  & 0.53506766E-09_JPRB, 0.53506172E-09_JPRB, 0.53505200E-09_JPRB, 0.53503796E-09_JPRB, 0.53502197E-09_JPRB, 0.53500482E-09_JPRB, &
  & 0.53498694E-09_JPRB, 0.53496702E-09_JPRB, 0.53494464E-09_JPRB, 0.53492111E-09_JPRB, 0.53489813E-09_JPRB, 0.53487742E-09_JPRB, &
  & 0.53485893E-09_JPRB, 0.53484106E-09_JPRB, 0.53482035E-09_JPRB, 0.53478566E-09_JPRB /)

RGHG6(:,66,10) = (/ &
  & 0.53408411E-09_JPRB, 0.53415661E-09_JPRB, 0.53419530E-09_JPRB, 0.53422705E-09_JPRB, 0.53425758E-09_JPRB, 0.53428545E-09_JPRB, &
  & 0.53431115E-09_JPRB, 0.53433274E-09_JPRB, 0.53435684E-09_JPRB, 0.53438082E-09_JPRB, 0.53441163E-09_JPRB, 0.53444477E-09_JPRB, &
  & 0.53447657E-09_JPRB, 0.53449778E-09_JPRB, 0.53449822E-09_JPRB, 0.53447086E-09_JPRB, 0.53441540E-09_JPRB, 0.53434035E-09_JPRB, &
  & 0.53426247E-09_JPRB, 0.53420196E-09_JPRB, 0.53417831E-09_JPRB, 0.53420479E-09_JPRB, 0.53428478E-09_JPRB, 0.53441390E-09_JPRB, &
  & 0.53457955E-09_JPRB, 0.53476706E-09_JPRB, 0.53496063E-09_JPRB, 0.53514743E-09_JPRB, 0.53531934E-09_JPRB, 0.53546950E-09_JPRB, &
  & 0.53559268E-09_JPRB, 0.53568527E-09_JPRB, 0.53574584E-09_JPRB, 0.53577548E-09_JPRB, 0.53577609E-09_JPRB, 0.53575100E-09_JPRB, &
  & 0.53570276E-09_JPRB, 0.53563565E-09_JPRB, 0.53555449E-09_JPRB, 0.53546545E-09_JPRB, 0.53537735E-09_JPRB, 0.53529919E-09_JPRB, &
  & 0.53523846E-09_JPRB, 0.53519733E-09_JPRB, 0.53517385E-09_JPRB, 0.53516314E-09_JPRB, 0.53515947E-09_JPRB, 0.53515786E-09_JPRB, &
  & 0.53515531E-09_JPRB, 0.53514926E-09_JPRB, 0.53513982E-09_JPRB, 0.53512628E-09_JPRB, 0.53510946E-09_JPRB, 0.53509103E-09_JPRB, &
  & 0.53507043E-09_JPRB, 0.53504778E-09_JPRB, 0.53502286E-09_JPRB, 0.53499627E-09_JPRB, 0.53497062E-09_JPRB, 0.53494709E-09_JPRB, &
  & 0.53492499E-09_JPRB, 0.53490229E-09_JPRB, 0.53487553E-09_JPRB, 0.53482757E-09_JPRB /)

RGHG6(:,67,10) = (/ &
  & 0.53420957E-09_JPRB, 0.53429106E-09_JPRB, 0.53433213E-09_JPRB, 0.53436572E-09_JPRB, 0.53439614E-09_JPRB, 0.53442450E-09_JPRB, &
  & 0.53444948E-09_JPRB, 0.53447491E-09_JPRB, 0.53449933E-09_JPRB, 0.53453064E-09_JPRB, 0.53456378E-09_JPRB, 0.53460092E-09_JPRB, &
  & 0.53463284E-09_JPRB, 0.53465277E-09_JPRB, 0.53465332E-09_JPRB, 0.53462884E-09_JPRB, 0.53457944E-09_JPRB, 0.53451149E-09_JPRB, &
  & 0.53443971E-09_JPRB, 0.53438393E-09_JPRB, 0.53436133E-09_JPRB, 0.53438387E-09_JPRB, 0.53445509E-09_JPRB, 0.53457050E-09_JPRB, &
  & 0.53471993E-09_JPRB, 0.53488908E-09_JPRB, 0.53506483E-09_JPRB, 0.53523475E-09_JPRB, 0.53539145E-09_JPRB, 0.53552823E-09_JPRB, &
  & 0.53564031E-09_JPRB, 0.53572463E-09_JPRB, 0.53577953E-09_JPRB, 0.53580651E-09_JPRB, 0.53580751E-09_JPRB, 0.53578531E-09_JPRB, &
  & 0.53574228E-09_JPRB, 0.53568161E-09_JPRB, 0.53560806E-09_JPRB, 0.53552696E-09_JPRB, 0.53544613E-09_JPRB, 0.53537436E-09_JPRB, &
  & 0.53531812E-09_JPRB, 0.53528015E-09_JPRB, 0.53525806E-09_JPRB, 0.53524785E-09_JPRB, 0.53524418E-09_JPRB, 0.53524246E-09_JPRB, &
  & 0.53523974E-09_JPRB, 0.53523386E-09_JPRB, 0.53522453E-09_JPRB, 0.53521143E-09_JPRB, 0.53519467E-09_JPRB, 0.53517529E-09_JPRB, &
  & 0.53515326E-09_JPRB, 0.53512877E-09_JPRB, 0.53510152E-09_JPRB, 0.53507287E-09_JPRB, 0.53504517E-09_JPRB, 0.53501864E-09_JPRB, &
  & 0.53499322E-09_JPRB, 0.53496541E-09_JPRB, 0.53493010E-09_JPRB, 0.53486621E-09_JPRB /)

RGHG6(:,68,10) = (/ &
  & 0.53432803E-09_JPRB, 0.53442106E-09_JPRB, 0.53446758E-09_JPRB, 0.53450322E-09_JPRB, 0.53453486E-09_JPRB, 0.53456317E-09_JPRB, &
  & 0.53458965E-09_JPRB, 0.53461513E-09_JPRB, 0.53464494E-09_JPRB, 0.53467675E-09_JPRB, 0.53471449E-09_JPRB, 0.53475141E-09_JPRB, &
  & 0.53478361E-09_JPRB, 0.53480476E-09_JPRB, 0.53480631E-09_JPRB, 0.53478399E-09_JPRB, 0.53473825E-09_JPRB, 0.53467636E-09_JPRB, &
  & 0.53461130E-09_JPRB, 0.53456051E-09_JPRB, 0.53453930E-09_JPRB, 0.53455840E-09_JPRB, 0.53462090E-09_JPRB, 0.53472360E-09_JPRB, &
  & 0.53485660E-09_JPRB, 0.53500809E-09_JPRB, 0.53516558E-09_JPRB, 0.53531868E-09_JPRB, 0.53546012E-09_JPRB, 0.53558347E-09_JPRB, &
  & 0.53568461E-09_JPRB, 0.53576032E-09_JPRB, 0.53580967E-09_JPRB, 0.53583404E-09_JPRB, 0.53583538E-09_JPRB, 0.53581600E-09_JPRB, &
  & 0.53577781E-09_JPRB, 0.53572369E-09_JPRB, 0.53565774E-09_JPRB, 0.53558474E-09_JPRB, 0.53551158E-09_JPRB, 0.53544630E-09_JPRB, &
  & 0.53539512E-09_JPRB, 0.53536015E-09_JPRB, 0.53533949E-09_JPRB, 0.53532978E-09_JPRB, 0.53532595E-09_JPRB, 0.53532423E-09_JPRB, &
  & 0.53532123E-09_JPRB, 0.53531551E-09_JPRB, 0.53530669E-09_JPRB, 0.53529403E-09_JPRB, 0.53527743E-09_JPRB, 0.53525773E-09_JPRB, &
  & 0.53523497E-09_JPRB, 0.53520921E-09_JPRB, 0.53518101E-09_JPRB, 0.53515126E-09_JPRB, 0.53512189E-09_JPRB, 0.53509391E-09_JPRB, &
  & 0.53506499E-09_JPRB, 0.53503280E-09_JPRB, 0.53498883E-09_JPRB, 0.53490729E-09_JPRB /)

RGHG6(:,69,10) = (/ &
  & 0.53444216E-09_JPRB, 0.53455101E-09_JPRB, 0.53460286E-09_JPRB, 0.53464189E-09_JPRB, 0.53467464E-09_JPRB, 0.53470361E-09_JPRB, &
  & 0.53473059E-09_JPRB, 0.53475824E-09_JPRB, 0.53478855E-09_JPRB, 0.53482363E-09_JPRB, 0.53486066E-09_JPRB, 0.53489707E-09_JPRB, &
  & 0.53492732E-09_JPRB, 0.53494620E-09_JPRB, 0.53494797E-09_JPRB, 0.53492916E-09_JPRB, 0.53488952E-09_JPRB, 0.53483457E-09_JPRB, &
  & 0.53477622E-09_JPRB, 0.53473020E-09_JPRB, 0.53471050E-09_JPRB, 0.53472632E-09_JPRB, 0.53478083E-09_JPRB, 0.53487093E-09_JPRB, &
  & 0.53498850E-09_JPRB, 0.53512261E-09_JPRB, 0.53526261E-09_JPRB, 0.53539906E-09_JPRB, 0.53552524E-09_JPRB, 0.53563559E-09_JPRB, &
  & 0.53572558E-09_JPRB, 0.53579285E-09_JPRB, 0.53583671E-09_JPRB, 0.53585852E-09_JPRB, 0.53585986E-09_JPRB, 0.53584331E-09_JPRB, &
  & 0.53580973E-09_JPRB, 0.53576199E-09_JPRB, 0.53570343E-09_JPRB, 0.53563831E-09_JPRB, 0.53557292E-09_JPRB, 0.53551458E-09_JPRB, &
  & 0.53546856E-09_JPRB, 0.53543686E-09_JPRB, 0.53541810E-09_JPRB, 0.53540905E-09_JPRB, 0.53540528E-09_JPRB, 0.53540339E-09_JPRB, &
  & 0.53540039E-09_JPRB, 0.53539506E-09_JPRB, 0.53538657E-09_JPRB, 0.53537430E-09_JPRB, 0.53535826E-09_JPRB, 0.53533883E-09_JPRB, &
  & 0.53531590E-09_JPRB, 0.53529003E-09_JPRB, 0.53526156E-09_JPRB, 0.53523119E-09_JPRB, 0.53520166E-09_JPRB, 0.53517202E-09_JPRB, &
  & 0.53514176E-09_JPRB, 0.53510524E-09_JPRB, 0.53505417E-09_JPRB, 0.53495441E-09_JPRB /)

RGHG6(:,70,10) = (/ &
  & 0.53455662E-09_JPRB, 0.53468174E-09_JPRB, 0.53474092E-09_JPRB, 0.53478239E-09_JPRB, 0.53481664E-09_JPRB, 0.53484628E-09_JPRB, &
  & 0.53487370E-09_JPRB, 0.53490229E-09_JPRB, 0.53493332E-09_JPRB, 0.53496790E-09_JPRB, 0.53500360E-09_JPRB, 0.53503790E-09_JPRB, &
  & 0.53506638E-09_JPRB, 0.53508586E-09_JPRB, 0.53508731E-09_JPRB, 0.53506999E-09_JPRB, 0.53503418E-09_JPRB, 0.53498567E-09_JPRB, &
  & 0.53493343E-09_JPRB, 0.53489213E-09_JPRB, 0.53487381E-09_JPRB, 0.53488652E-09_JPRB, 0.53493332E-09_JPRB, 0.53501176E-09_JPRB, &
  & 0.53511451E-09_JPRB, 0.53523208E-09_JPRB, 0.53535509E-09_JPRB, 0.53547539E-09_JPRB, 0.53558702E-09_JPRB, 0.53568416E-09_JPRB, &
  & 0.53576349E-09_JPRB, 0.53582250E-09_JPRB, 0.53586102E-09_JPRB, 0.53588040E-09_JPRB, 0.53588162E-09_JPRB, 0.53586746E-09_JPRB, &
  & 0.53583832E-09_JPRB, 0.53579674E-09_JPRB, 0.53574523E-09_JPRB, 0.53568794E-09_JPRB, 0.53563037E-09_JPRB, 0.53557880E-09_JPRB, &
  & 0.53553822E-09_JPRB, 0.53551019E-09_JPRB, 0.53549348E-09_JPRB, 0.53548510E-09_JPRB, 0.53548149E-09_JPRB, 0.53547988E-09_JPRB, &
  & 0.53547700E-09_JPRB, 0.53547194E-09_JPRB, 0.53546384E-09_JPRB, 0.53545252E-09_JPRB, 0.53543736E-09_JPRB, 0.53541865E-09_JPRB, &
  & 0.53539645E-09_JPRB, 0.53537136E-09_JPRB, 0.53534344E-09_JPRB, 0.53531374E-09_JPRB, 0.53528421E-09_JPRB, 0.53525467E-09_JPRB, &
  & 0.53522292E-09_JPRB, 0.53518512E-09_JPRB, 0.53512755E-09_JPRB, 0.53501409E-09_JPRB /)

RGHG6(:,71,10) = (/ &
  & 0.53467619E-09_JPRB, 0.53481836E-09_JPRB, 0.53488169E-09_JPRB, 0.53492588E-09_JPRB, 0.53496052E-09_JPRB, 0.53499061E-09_JPRB, &
  & 0.53501842E-09_JPRB, 0.53504623E-09_JPRB, 0.53507743E-09_JPRB, 0.53510907E-09_JPRB, 0.53514260E-09_JPRB, 0.53517291E-09_JPRB, &
  & 0.53519794E-09_JPRB, 0.53521387E-09_JPRB, 0.53521554E-09_JPRB, 0.53520155E-09_JPRB, 0.53517096E-09_JPRB, 0.53512828E-09_JPRB, &
  & 0.53508209E-09_JPRB, 0.53504534E-09_JPRB, 0.53502847E-09_JPRB, 0.53503824E-09_JPRB, 0.53507793E-09_JPRB, 0.53514554E-09_JPRB, &
  & 0.53523419E-09_JPRB, 0.53533628E-09_JPRB, 0.53544286E-09_JPRB, 0.53554783E-09_JPRB, 0.53564519E-09_JPRB, 0.53572968E-09_JPRB, &
  & 0.53579868E-09_JPRB, 0.53584970E-09_JPRB, 0.53588312E-09_JPRB, 0.53589999E-09_JPRB, 0.53590110E-09_JPRB, 0.53588928E-09_JPRB, &
  & 0.53586402E-09_JPRB, 0.53582833E-09_JPRB, 0.53578370E-09_JPRB, 0.53573379E-09_JPRB, 0.53568361E-09_JPRB, 0.53563881E-09_JPRB, &
  & 0.53560367E-09_JPRB, 0.53557930E-09_JPRB, 0.53556493E-09_JPRB, 0.53555765E-09_JPRB, 0.53555449E-09_JPRB, 0.53555316E-09_JPRB, &
  & 0.53555049E-09_JPRB, 0.53554594E-09_JPRB, 0.53553856E-09_JPRB, 0.53552823E-09_JPRB, 0.53551424E-09_JPRB, 0.53549692E-09_JPRB, &
  & 0.53547644E-09_JPRB, 0.53545290E-09_JPRB, 0.53542681E-09_JPRB, 0.53539839E-09_JPRB, 0.53536975E-09_JPRB, 0.53534094E-09_JPRB, &
  & 0.53530980E-09_JPRB, 0.53527116E-09_JPRB, 0.53521132E-09_JPRB, 0.53508797E-09_JPRB /)

RGHG6(:,72,10) = (/ &
  & 0.53480720E-09_JPRB, 0.53495963E-09_JPRB, 0.53502625E-09_JPRB, 0.53507049E-09_JPRB, 0.53510502E-09_JPRB, 0.53513471E-09_JPRB, &
  & 0.53516175E-09_JPRB, 0.53518923E-09_JPRB, 0.53521632E-09_JPRB, 0.53524718E-09_JPRB, 0.53527466E-09_JPRB, 0.53530225E-09_JPRB, &
  & 0.53532384E-09_JPRB, 0.53533977E-09_JPRB, 0.53533949E-09_JPRB, 0.53532623E-09_JPRB, 0.53529925E-09_JPRB, 0.53526239E-09_JPRB, &
  & 0.53522187E-09_JPRB, 0.53518939E-09_JPRB, 0.53517418E-09_JPRB, 0.53518157E-09_JPRB, 0.53521471E-09_JPRB, 0.53527205E-09_JPRB, &
  & 0.53534766E-09_JPRB, 0.53543464E-09_JPRB, 0.53552596E-09_JPRB, 0.53561600E-09_JPRB, 0.53569971E-09_JPRB, 0.53577204E-09_JPRB, &
  & 0.53583099E-09_JPRB, 0.53587440E-09_JPRB, 0.53590271E-09_JPRB, 0.53591753E-09_JPRB, 0.53591859E-09_JPRB, 0.53590854E-09_JPRB, &
  & 0.53588700E-09_JPRB, 0.53585686E-09_JPRB, 0.53581889E-09_JPRB, 0.53577581E-09_JPRB, 0.53573307E-09_JPRB, 0.53569471E-09_JPRB, &
  & 0.53566485E-09_JPRB, 0.53564436E-09_JPRB, 0.53563221E-09_JPRB, 0.53562599E-09_JPRB, 0.53562332E-09_JPRB, 0.53562271E-09_JPRB, &
  & 0.53562027E-09_JPRB, 0.53561633E-09_JPRB, 0.53560972E-09_JPRB, 0.53560067E-09_JPRB, 0.53558824E-09_JPRB, 0.53557320E-09_JPRB, &
  & 0.53555427E-09_JPRB, 0.53553417E-09_JPRB, 0.53550997E-09_JPRB, 0.53548371E-09_JPRB, 0.53545779E-09_JPRB, 0.53542992E-09_JPRB, &
  & 0.53540061E-09_JPRB, 0.53536359E-09_JPRB, 0.53530280E-09_JPRB, 0.53517696E-09_JPRB /)

RGHG6(:,73,10) = (/ &
  & 0.53495541E-09_JPRB, 0.53510674E-09_JPRB, 0.53517180E-09_JPRB, 0.53521426E-09_JPRB, 0.53524690E-09_JPRB, 0.53527532E-09_JPRB, &
  & 0.53530103E-09_JPRB, 0.53532484E-09_JPRB, 0.53535137E-09_JPRB, 0.53537486E-09_JPRB, 0.53540156E-09_JPRB, 0.53542265E-09_JPRB, &
  & 0.53544102E-09_JPRB, 0.53545268E-09_JPRB, 0.53545307E-09_JPRB, 0.53544197E-09_JPRB, 0.53541876E-09_JPRB, 0.53538723E-09_JPRB, &
  & 0.53535232E-09_JPRB, 0.53532395E-09_JPRB, 0.53531063E-09_JPRB, 0.53531612E-09_JPRB, 0.53534321E-09_JPRB, 0.53539106E-09_JPRB, &
  & 0.53545407E-09_JPRB, 0.53552729E-09_JPRB, 0.53560367E-09_JPRB, 0.53567994E-09_JPRB, 0.53575033E-09_JPRB, 0.53581112E-09_JPRB, &
  & 0.53586047E-09_JPRB, 0.53589672E-09_JPRB, 0.53592031E-09_JPRB, 0.53593308E-09_JPRB, 0.53593407E-09_JPRB, 0.53592553E-09_JPRB, &
  & 0.53590765E-09_JPRB, 0.53588284E-09_JPRB, 0.53585092E-09_JPRB, 0.53581439E-09_JPRB, 0.53577864E-09_JPRB, 0.53574645E-09_JPRB, &
  & 0.53572180E-09_JPRB, 0.53570470E-09_JPRB, 0.53569471E-09_JPRB, 0.53568955E-09_JPRB, 0.53568749E-09_JPRB, 0.53568749E-09_JPRB, &
  & 0.53568533E-09_JPRB, 0.53568217E-09_JPRB, 0.53567661E-09_JPRB, 0.53566906E-09_JPRB, 0.53565874E-09_JPRB, 0.53564519E-09_JPRB, &
  & 0.53562976E-09_JPRB, 0.53561156E-09_JPRB, 0.53559118E-09_JPRB, 0.53556803E-09_JPRB, 0.53554394E-09_JPRB, 0.53552007E-09_JPRB, &
  & 0.53549210E-09_JPRB, 0.53545840E-09_JPRB, 0.53540145E-09_JPRB, 0.53527582E-09_JPRB /)

RGHG6(:,74,10) = (/ &
  & 0.53510762E-09_JPRB, 0.53525423E-09_JPRB, 0.53531435E-09_JPRB, 0.53535310E-09_JPRB, 0.53538285E-09_JPRB, 0.53540883E-09_JPRB, &
  & 0.53543175E-09_JPRB, 0.53545396E-09_JPRB, 0.53547405E-09_JPRB, 0.53549754E-09_JPRB, 0.53551613E-09_JPRB, 0.53553595E-09_JPRB, &
  & 0.53554983E-09_JPRB, 0.53556137E-09_JPRB, 0.53555915E-09_JPRB, 0.53554888E-09_JPRB, 0.53552923E-09_JPRB, 0.53550303E-09_JPRB, &
  & 0.53547333E-09_JPRB, 0.53544930E-09_JPRB, 0.53543792E-09_JPRB, 0.53544191E-09_JPRB, 0.53546323E-09_JPRB, 0.53550220E-09_JPRB, &
  & 0.53555377E-09_JPRB, 0.53561389E-09_JPRB, 0.53567645E-09_JPRB, 0.53573940E-09_JPRB, 0.53579741E-09_JPRB, 0.53584709E-09_JPRB, &
  & 0.53588756E-09_JPRB, 0.53591681E-09_JPRB, 0.53593596E-09_JPRB, 0.53594684E-09_JPRB, 0.53594795E-09_JPRB, 0.53594068E-09_JPRB, &
  & 0.53592586E-09_JPRB, 0.53590610E-09_JPRB, 0.53587995E-09_JPRB, 0.53584970E-09_JPRB, 0.53582067E-09_JPRB, 0.53579441E-09_JPRB, &
  & 0.53577465E-09_JPRB, 0.53576071E-09_JPRB, 0.53575272E-09_JPRB, 0.53574845E-09_JPRB, 0.53574661E-09_JPRB, 0.53574717E-09_JPRB, &
  & 0.53574528E-09_JPRB, 0.53574301E-09_JPRB, 0.53573851E-09_JPRB, 0.53573251E-09_JPRB, 0.53572419E-09_JPRB, 0.53571347E-09_JPRB, &
  & 0.53569932E-09_JPRB, 0.53568538E-09_JPRB, 0.53566773E-09_JPRB, 0.53564753E-09_JPRB, 0.53562849E-09_JPRB, 0.53560573E-09_JPRB, &
  & 0.53558269E-09_JPRB, 0.53555260E-09_JPRB, 0.53549903E-09_JPRB, 0.53538179E-09_JPRB /)

RGHG6(:,75,10) = (/ &
  & 0.53526084E-09_JPRB, 0.53539656E-09_JPRB, 0.53545129E-09_JPRB, 0.53548477E-09_JPRB, 0.53551030E-09_JPRB, 0.53553323E-09_JPRB, &
  & 0.53555366E-09_JPRB, 0.53557103E-09_JPRB, 0.53559013E-09_JPRB, 0.53560628E-09_JPRB, 0.53562454E-09_JPRB, 0.53563792E-09_JPRB, &
  & 0.53564925E-09_JPRB, 0.53565741E-09_JPRB, 0.53565541E-09_JPRB, 0.53564680E-09_JPRB, 0.53563065E-09_JPRB, 0.53560972E-09_JPRB, &
  & 0.53558535E-09_JPRB, 0.53556526E-09_JPRB, 0.53555593E-09_JPRB, 0.53555865E-09_JPRB, 0.53557514E-09_JPRB, 0.53560562E-09_JPRB, &
  & 0.53564653E-09_JPRB, 0.53569460E-09_JPRB, 0.53574412E-09_JPRB, 0.53579458E-09_JPRB, 0.53584048E-09_JPRB, 0.53587978E-09_JPRB, &
  & 0.53591187E-09_JPRB, 0.53593480E-09_JPRB, 0.53594973E-09_JPRB, 0.53595922E-09_JPRB, 0.53596044E-09_JPRB, 0.53595417E-09_JPRB, &
  & 0.53594218E-09_JPRB, 0.53592719E-09_JPRB, 0.53590660E-09_JPRB, 0.53588212E-09_JPRB, 0.53585947E-09_JPRB, 0.53583860E-09_JPRB, &
  & 0.53582350E-09_JPRB, 0.53581256E-09_JPRB, 0.53580623E-09_JPRB, 0.53580251E-09_JPRB, 0.53580096E-09_JPRB, 0.53580218E-09_JPRB, &
  & 0.53580035E-09_JPRB, 0.53579896E-09_JPRB, 0.53579524E-09_JPRB, 0.53579108E-09_JPRB, 0.53578486E-09_JPRB, 0.53577537E-09_JPRB, &
  & 0.53576432E-09_JPRB, 0.53575244E-09_JPRB, 0.53573901E-09_JPRB, 0.53572313E-09_JPRB, 0.53570609E-09_JPRB, 0.53568905E-09_JPRB, &
  & 0.53566773E-09_JPRB, 0.53564342E-09_JPRB, 0.53559635E-09_JPRB, 0.53548699E-09_JPRB /)

RGHG6(:,76,10) = (/ &
  & 0.53540955E-09_JPRB, 0.53553412E-09_JPRB, 0.53558080E-09_JPRB, 0.53560778E-09_JPRB, 0.53562832E-09_JPRB, 0.53564797E-09_JPRB, &
  & 0.53566485E-09_JPRB, 0.53567978E-09_JPRB, 0.53569321E-09_JPRB, 0.53570859E-09_JPRB, 0.53572019E-09_JPRB, 0.53573163E-09_JPRB, &
  & 0.53573845E-09_JPRB, 0.53574517E-09_JPRB, 0.53574223E-09_JPRB, 0.53573557E-09_JPRB, 0.53572319E-09_JPRB, 0.53570814E-09_JPRB, &
  & 0.53568860E-09_JPRB, 0.53567228E-09_JPRB, 0.53566507E-09_JPRB, 0.53566690E-09_JPRB, 0.53567872E-09_JPRB, 0.53570182E-09_JPRB, &
  & 0.53573290E-09_JPRB, 0.53576971E-09_JPRB, 0.53580684E-09_JPRB, 0.53584537E-09_JPRB, 0.53588006E-09_JPRB, 0.53590943E-09_JPRB, &
  & 0.53593391E-09_JPRB, 0.53595095E-09_JPRB, 0.53596194E-09_JPRB, 0.53597016E-09_JPRB, 0.53597143E-09_JPRB, 0.53596605E-09_JPRB, &
  & 0.53595667E-09_JPRB, 0.53594629E-09_JPRB, 0.53593063E-09_JPRB, 0.53591170E-09_JPRB, 0.53589505E-09_JPRB, 0.53587967E-09_JPRB, &
  & 0.53586863E-09_JPRB, 0.53586036E-09_JPRB, 0.53585553E-09_JPRB, 0.53585225E-09_JPRB, 0.53585059E-09_JPRB, 0.53585236E-09_JPRB, &
  & 0.53585042E-09_JPRB, 0.53584986E-09_JPRB, 0.53584687E-09_JPRB, 0.53584442E-09_JPRB, 0.53584004E-09_JPRB, 0.53583243E-09_JPRB, &
  & 0.53582250E-09_JPRB, 0.53581423E-09_JPRB, 0.53580462E-09_JPRB, 0.53579152E-09_JPRB, 0.53578064E-09_JPRB, 0.53576465E-09_JPRB, &
  & 0.53574933E-09_JPRB, 0.53572902E-09_JPRB, 0.53568944E-09_JPRB, 0.53559290E-09_JPRB /)

RGHG6(:,77,10) = (/ &
  & 0.53555477E-09_JPRB, 0.53566351E-09_JPRB, 0.53570159E-09_JPRB, 0.53572125E-09_JPRB, 0.53573607E-09_JPRB, 0.53575228E-09_JPRB, &
  & 0.53576649E-09_JPRB, 0.53577676E-09_JPRB, 0.53578753E-09_JPRB, 0.53579774E-09_JPRB, 0.53580679E-09_JPRB, 0.53581362E-09_JPRB, &
  & 0.53581750E-09_JPRB, 0.53582205E-09_JPRB, 0.53581867E-09_JPRB, 0.53581428E-09_JPRB, 0.53580601E-09_JPRB, 0.53579685E-09_JPRB, &
  & 0.53578225E-09_JPRB, 0.53576971E-09_JPRB, 0.53576477E-09_JPRB, 0.53576593E-09_JPRB, 0.53577381E-09_JPRB, 0.53578991E-09_JPRB, &
  & 0.53581217E-09_JPRB, 0.53583871E-09_JPRB, 0.53586402E-09_JPRB, 0.53589172E-09_JPRB, 0.53591587E-09_JPRB, 0.53593613E-09_JPRB, &
  & 0.53595350E-09_JPRB, 0.53596511E-09_JPRB, 0.53597260E-09_JPRB, 0.53597954E-09_JPRB, 0.53598126E-09_JPRB, 0.53597660E-09_JPRB, &
  & 0.53596932E-09_JPRB, 0.53596322E-09_JPRB, 0.53595228E-09_JPRB, 0.53593813E-09_JPRB, 0.53592736E-09_JPRB, 0.53591692E-09_JPRB, &
  & 0.53590987E-09_JPRB, 0.53590404E-09_JPRB, 0.53590044E-09_JPRB, 0.53589722E-09_JPRB, 0.53589522E-09_JPRB, 0.53589783E-09_JPRB, &
  & 0.53589538E-09_JPRB, 0.53589583E-09_JPRB, 0.53589322E-09_JPRB, 0.53589255E-09_JPRB, 0.53589022E-09_JPRB, 0.53588334E-09_JPRB, &
  & 0.53587518E-09_JPRB, 0.53586952E-09_JPRB, 0.53586391E-09_JPRB, 0.53585492E-09_JPRB, 0.53584720E-09_JPRB, 0.53583604E-09_JPRB, &
  & 0.53582350E-09_JPRB, 0.53580951E-09_JPRB, 0.53577726E-09_JPRB, 0.53569638E-09_JPRB /)

RGHG6(:,78,10) = (/ &
  & 0.53569504E-09_JPRB, 0.53578009E-09_JPRB, 0.53580618E-09_JPRB, 0.53581789E-09_JPRB, 0.53582699E-09_JPRB, 0.53584015E-09_JPRB, &
  & 0.53585153E-09_JPRB, 0.53585814E-09_JPRB, 0.53586452E-09_JPRB, 0.53587229E-09_JPRB, 0.53587679E-09_JPRB, 0.53588051E-09_JPRB, &
  & 0.53588151E-09_JPRB, 0.53588411E-09_JPRB, 0.53588117E-09_JPRB, 0.53587879E-09_JPRB, 0.53587451E-09_JPRB, 0.53587107E-09_JPRB, &
  & 0.53586130E-09_JPRB, 0.53585231E-09_JPRB, 0.53584975E-09_JPRB, 0.53585081E-09_JPRB, 0.53585536E-09_JPRB, 0.53586569E-09_JPRB, &
  & 0.53588023E-09_JPRB, 0.53589805E-09_JPRB, 0.53591287E-09_JPRB, 0.53593141E-09_JPRB, 0.53594607E-09_JPRB, 0.53595878E-09_JPRB, &
  & 0.53596999E-09_JPRB, 0.53597710E-09_JPRB, 0.53598143E-09_JPRB, 0.53598748E-09_JPRB, 0.53598953E-09_JPRB, 0.53598537E-09_JPRB, &
  & 0.53597982E-09_JPRB, 0.53597748E-09_JPRB, 0.53597049E-09_JPRB, 0.53596055E-09_JPRB, 0.53595495E-09_JPRB, 0.53594879E-09_JPRB, &
  & 0.53594484E-09_JPRB, 0.53594090E-09_JPRB, 0.53593807E-09_JPRB, 0.53593474E-09_JPRB, 0.53593230E-09_JPRB, 0.53593574E-09_JPRB, &
  & 0.53593274E-09_JPRB, 0.53593402E-09_JPRB, 0.53593158E-09_JPRB, 0.53593258E-09_JPRB, 0.53593213E-09_JPRB, 0.53592591E-09_JPRB, &
  & 0.53591875E-09_JPRB, 0.53591553E-09_JPRB, 0.53591398E-09_JPRB, 0.53590737E-09_JPRB, 0.53590477E-09_JPRB, 0.53589511E-09_JPRB, &
  & 0.53588756E-09_JPRB, 0.53587806E-09_JPRB, 0.53585653E-09_JPRB, 0.53579724E-09_JPRB /)

RGHG6(:,79,10) = (/ &
  & 0.53578597E-09_JPRB, 0.53584587E-09_JPRB, 0.53586219E-09_JPRB, 0.53586785E-09_JPRB, 0.53587357E-09_JPRB, 0.53588556E-09_JPRB, &
  & 0.53589622E-09_JPRB, 0.53590016E-09_JPRB, 0.53590438E-09_JPRB, 0.53591070E-09_JPRB, 0.53591320E-09_JPRB, 0.53591520E-09_JPRB, &
  & 0.53591448E-09_JPRB, 0.53591609E-09_JPRB, 0.53591342E-09_JPRB, 0.53591237E-09_JPRB, 0.53591032E-09_JPRB, 0.53591065E-09_JPRB, &
  & 0.53590332E-09_JPRB, 0.53589611E-09_JPRB, 0.53589527E-09_JPRB, 0.53589649E-09_JPRB, 0.53589938E-09_JPRB, 0.53590660E-09_JPRB, &
  & 0.53591720E-09_JPRB, 0.53593041E-09_JPRB, 0.53593946E-09_JPRB, 0.53595306E-09_JPRB, 0.53596239E-09_JPRB, 0.53597093E-09_JPRB, &
  & 0.53597893E-09_JPRB, 0.53598337E-09_JPRB, 0.53598603E-09_JPRB, 0.53599192E-09_JPRB, 0.53599430E-09_JPRB, 0.53599014E-09_JPRB, &
  & 0.53598520E-09_JPRB, 0.53598520E-09_JPRB, 0.53598037E-09_JPRB, 0.53597249E-09_JPRB, 0.53596971E-09_JPRB, 0.53596588E-09_JPRB, &
  & 0.53596383E-09_JPRB, 0.53596083E-09_JPRB, 0.53595844E-09_JPRB, 0.53595450E-09_JPRB, 0.53595151E-09_JPRB, 0.53595578E-09_JPRB, &
  & 0.53595206E-09_JPRB, 0.53595428E-09_JPRB, 0.53595145E-09_JPRB, 0.53595361E-09_JPRB, 0.53595456E-09_JPRB, 0.53594795E-09_JPRB, &
  & 0.53594079E-09_JPRB, 0.53593896E-09_JPRB, 0.53593990E-09_JPRB, 0.53593446E-09_JPRB, 0.53593430E-09_JPRB, 0.53592553E-09_JPRB, &
  & 0.53592003E-09_JPRB, 0.53591442E-09_JPRB, 0.53590010E-09_JPRB, 0.53586169E-09_JPRB /)

RGHG6(:,80,10) = (/ &
  & 0.53584714E-09_JPRB, 0.53587790E-09_JPRB, 0.53588689E-09_JPRB, 0.53588933E-09_JPRB, 0.53589322E-09_JPRB, 0.53590510E-09_JPRB, &
  & 0.53591570E-09_JPRB, 0.53591831E-09_JPRB, 0.53592175E-09_JPRB, 0.53592758E-09_JPRB, 0.53592930E-09_JPRB, 0.53593052E-09_JPRB, &
  & 0.53592891E-09_JPRB, 0.53593013E-09_JPRB, 0.53592752E-09_JPRB, 0.53592719E-09_JPRB, 0.53592625E-09_JPRB, 0.53592869E-09_JPRB, &
  & 0.53592242E-09_JPRB, 0.53591576E-09_JPRB, 0.53591587E-09_JPRB, 0.53591720E-09_JPRB, 0.53591931E-09_JPRB, 0.53592514E-09_JPRB, &
  & 0.53593407E-09_JPRB, 0.53594529E-09_JPRB, 0.53595167E-09_JPRB, 0.53596300E-09_JPRB, 0.53596988E-09_JPRB, 0.53597649E-09_JPRB, &
  & 0.53598287E-09_JPRB, 0.53598620E-09_JPRB, 0.53598798E-09_JPRB, 0.53599397E-09_JPRB, 0.53599675E-09_JPRB, 0.53599242E-09_JPRB, &
  & 0.53598775E-09_JPRB, 0.53598892E-09_JPRB, 0.53598503E-09_JPRB, 0.53597793E-09_JPRB, 0.53597654E-09_JPRB, 0.53597382E-09_JPRB, &
  & 0.53597277E-09_JPRB, 0.53596999E-09_JPRB, 0.53596766E-09_JPRB, 0.53596344E-09_JPRB, 0.53595994E-09_JPRB, 0.53596483E-09_JPRB, &
  & 0.53596039E-09_JPRB, 0.53596311E-09_JPRB, 0.53596011E-09_JPRB, 0.53596294E-09_JPRB, 0.53596461E-09_JPRB, 0.53595745E-09_JPRB, &
  & 0.53594990E-09_JPRB, 0.53594873E-09_JPRB, 0.53595101E-09_JPRB, 0.53594590E-09_JPRB, 0.53594729E-09_JPRB, 0.53593829E-09_JPRB, &
  & 0.53593391E-09_JPRB, 0.53593008E-09_JPRB, 0.53592103E-09_JPRB, 0.53590421E-09_JPRB /)

RGHG6(:,81,10) = (/ &
  & 0.53588967E-09_JPRB, 0.53589166E-09_JPRB, 0.53589733E-09_JPRB, 0.53589838E-09_JPRB, 0.53590149E-09_JPRB, 0.53591342E-09_JPRB, &
  & 0.53592408E-09_JPRB, 0.53592630E-09_JPRB, 0.53592891E-09_JPRB, 0.53593507E-09_JPRB, 0.53593613E-09_JPRB, 0.53593713E-09_JPRB, &
  & 0.53593519E-09_JPRB, 0.53593624E-09_JPRB, 0.53593369E-09_JPRB, 0.53593358E-09_JPRB, 0.53593330E-09_JPRB, 0.53593685E-09_JPRB, &
  & 0.53593097E-09_JPRB, 0.53592453E-09_JPRB, 0.53592508E-09_JPRB, 0.53592641E-09_JPRB, 0.53592819E-09_JPRB, 0.53593346E-09_JPRB, &
  & 0.53594162E-09_JPRB, 0.53595189E-09_JPRB, 0.53595700E-09_JPRB, 0.53596749E-09_JPRB, 0.53597315E-09_JPRB, 0.53597887E-09_JPRB, &
  & 0.53598470E-09_JPRB, 0.53598731E-09_JPRB, 0.53598875E-09_JPRB, 0.53599492E-09_JPRB, 0.53599780E-09_JPRB, 0.53599336E-09_JPRB, &
  & 0.53598892E-09_JPRB, 0.53599053E-09_JPRB, 0.53598709E-09_JPRB, 0.53598043E-09_JPRB, 0.53597971E-09_JPRB, 0.53597748E-09_JPRB, &
  & 0.53597682E-09_JPRB, 0.53597426E-09_JPRB, 0.53597188E-09_JPRB, 0.53596738E-09_JPRB, 0.53596355E-09_JPRB, 0.53596894E-09_JPRB, &
  & 0.53596416E-09_JPRB, 0.53596716E-09_JPRB, 0.53596383E-09_JPRB, 0.53596694E-09_JPRB, 0.53596905E-09_JPRB, 0.53596150E-09_JPRB, &
  & 0.53595378E-09_JPRB, 0.53595284E-09_JPRB, 0.53595584E-09_JPRB, 0.53595062E-09_JPRB, 0.53595278E-09_JPRB, 0.53594384E-09_JPRB, &
  & 0.53593979E-09_JPRB, 0.53593663E-09_JPRB, 0.53592969E-09_JPRB, 0.53593341E-09_JPRB /)

RGHG6(:,82,10) = (/ &
  & 0.53589311E-09_JPRB, 0.53589627E-09_JPRB, 0.53590188E-09_JPRB, 0.53590260E-09_JPRB, 0.53590543E-09_JPRB, 0.53591759E-09_JPRB, &
  & 0.53592836E-09_JPRB, 0.53593013E-09_JPRB, 0.53593285E-09_JPRB, 0.53593835E-09_JPRB, 0.53593957E-09_JPRB, 0.53594029E-09_JPRB, &
  & 0.53593824E-09_JPRB, 0.53593918E-09_JPRB, 0.53593663E-09_JPRB, 0.53593668E-09_JPRB, 0.53593674E-09_JPRB, 0.53594101E-09_JPRB, &
  & 0.53593524E-09_JPRB, 0.53592875E-09_JPRB, 0.53592969E-09_JPRB, 0.53593108E-09_JPRB, 0.53593258E-09_JPRB, 0.53593746E-09_JPRB, &
  & 0.53594540E-09_JPRB, 0.53595534E-09_JPRB, 0.53595994E-09_JPRB, 0.53596971E-09_JPRB, 0.53597482E-09_JPRB, 0.53598015E-09_JPRB, &
  & 0.53598537E-09_JPRB, 0.53598781E-09_JPRB, 0.53598909E-09_JPRB, 0.53599541E-09_JPRB, 0.53599847E-09_JPRB, 0.53599386E-09_JPRB, &
  & 0.53598942E-09_JPRB, 0.53599120E-09_JPRB, 0.53598809E-09_JPRB, 0.53598159E-09_JPRB, 0.53598115E-09_JPRB, 0.53597932E-09_JPRB, &
  & 0.53597898E-09_JPRB, 0.53597654E-09_JPRB, 0.53597410E-09_JPRB, 0.53596938E-09_JPRB, 0.53596527E-09_JPRB, 0.53597105E-09_JPRB, &
  & 0.53596583E-09_JPRB, 0.53596910E-09_JPRB, 0.53596555E-09_JPRB, 0.53596899E-09_JPRB, 0.53597127E-09_JPRB, 0.53596344E-09_JPRB, &
  & 0.53595539E-09_JPRB, 0.53595473E-09_JPRB, 0.53595811E-09_JPRB, 0.53595295E-09_JPRB, 0.53595550E-09_JPRB, 0.53594634E-09_JPRB, &
  & 0.53594257E-09_JPRB, 0.53593951E-09_JPRB, 0.53593252E-09_JPRB, 0.53593568E-09_JPRB /)

RGHG6(:,83,10) = (/ &
  & 0.53589555E-09_JPRB, 0.53589894E-09_JPRB, 0.53590449E-09_JPRB, 0.53590488E-09_JPRB, 0.53590760E-09_JPRB, 0.53591975E-09_JPRB, &
  & 0.53593058E-09_JPRB, 0.53593247E-09_JPRB, 0.53593474E-09_JPRB, 0.53594068E-09_JPRB, 0.53594146E-09_JPRB, 0.53594201E-09_JPRB, &
  & 0.53593996E-09_JPRB, 0.53594074E-09_JPRB, 0.53593818E-09_JPRB, 0.53593852E-09_JPRB, 0.53593874E-09_JPRB, 0.53594340E-09_JPRB, &
  & 0.53593768E-09_JPRB, 0.53593119E-09_JPRB, 0.53593230E-09_JPRB, 0.53593363E-09_JPRB, 0.53593507E-09_JPRB, 0.53593985E-09_JPRB, &
  & 0.53594745E-09_JPRB, 0.53595728E-09_JPRB, 0.53596150E-09_JPRB, 0.53597105E-09_JPRB, 0.53597582E-09_JPRB, 0.53598082E-09_JPRB, &
  & 0.53598570E-09_JPRB, 0.53598803E-09_JPRB, 0.53598920E-09_JPRB, 0.53599575E-09_JPRB, 0.53599886E-09_JPRB, 0.53599414E-09_JPRB, &
  & 0.53598975E-09_JPRB, 0.53599158E-09_JPRB, 0.53598859E-09_JPRB, 0.53598248E-09_JPRB, 0.53598220E-09_JPRB, 0.53598048E-09_JPRB, &
  & 0.53598026E-09_JPRB, 0.53597793E-09_JPRB, 0.53597543E-09_JPRB, 0.53597043E-09_JPRB, 0.53596610E-09_JPRB, 0.53597221E-09_JPRB, &
  & 0.53596677E-09_JPRB, 0.53597021E-09_JPRB, 0.53596644E-09_JPRB, 0.53597010E-09_JPRB, 0.53597260E-09_JPRB, 0.53596455E-09_JPRB, &
  & 0.53595628E-09_JPRB, 0.53595572E-09_JPRB, 0.53595944E-09_JPRB, 0.53595417E-09_JPRB, 0.53595706E-09_JPRB, 0.53594773E-09_JPRB, &
  & 0.53594396E-09_JPRB, 0.53594101E-09_JPRB, 0.53593413E-09_JPRB, 0.53593741E-09_JPRB /)

RGHG6(:,84,10) = (/ &
  & 0.53589722E-09_JPRB, 0.53590071E-09_JPRB, 0.53590615E-09_JPRB, 0.53590621E-09_JPRB, 0.53590876E-09_JPRB, 0.53592125E-09_JPRB, &
  & 0.53593219E-09_JPRB, 0.53593391E-09_JPRB, 0.53593663E-09_JPRB, 0.53594140E-09_JPRB, 0.53594257E-09_JPRB, 0.53594301E-09_JPRB, &
  & 0.53594101E-09_JPRB, 0.53594162E-09_JPRB, 0.53593918E-09_JPRB, 0.53593951E-09_JPRB, 0.53593996E-09_JPRB, 0.53594484E-09_JPRB, &
  & 0.53593924E-09_JPRB, 0.53593269E-09_JPRB, 0.53593402E-09_JPRB, 0.53593535E-09_JPRB, 0.53593663E-09_JPRB, 0.53594124E-09_JPRB, &
  & 0.53594884E-09_JPRB, 0.53595839E-09_JPRB, 0.53596244E-09_JPRB, 0.53597199E-09_JPRB, 0.53597632E-09_JPRB, 0.53598126E-09_JPRB, &
  & 0.53598603E-09_JPRB, 0.53598820E-09_JPRB, 0.53598920E-09_JPRB, 0.53599586E-09_JPRB, 0.53599902E-09_JPRB, 0.53599436E-09_JPRB, &
  & 0.53598997E-09_JPRB, 0.53599175E-09_JPRB, 0.53598898E-09_JPRB, 0.53598292E-09_JPRB, 0.53598270E-09_JPRB, 0.53598115E-09_JPRB, &
  & 0.53598115E-09_JPRB, 0.53597882E-09_JPRB, 0.53597626E-09_JPRB, 0.53597116E-09_JPRB, 0.53596660E-09_JPRB, 0.53597293E-09_JPRB, &
  & 0.53596733E-09_JPRB, 0.53597088E-09_JPRB, 0.53596699E-09_JPRB, 0.53597071E-09_JPRB, 0.53597338E-09_JPRB, 0.53596522E-09_JPRB, &
  & 0.53595672E-09_JPRB, 0.53595611E-09_JPRB, 0.53596005E-09_JPRB, 0.53595484E-09_JPRB, 0.53595811E-09_JPRB, 0.53594834E-09_JPRB, &
  & 0.53594479E-09_JPRB, 0.53594190E-09_JPRB, 0.53593519E-09_JPRB, 0.53593846E-09_JPRB /)

RGHG6(:,85,10) = (/ &
  & 0.53589844E-09_JPRB, 0.53590188E-09_JPRB, 0.53590737E-09_JPRB, 0.53590710E-09_JPRB, 0.53590954E-09_JPRB, 0.53592297E-09_JPRB, &
  & 0.53593285E-09_JPRB, 0.53593552E-09_JPRB, 0.53593763E-09_JPRB, 0.53594196E-09_JPRB, 0.53594296E-09_JPRB, 0.53594329E-09_JPRB, &
  & 0.53594185E-09_JPRB, 0.53594196E-09_JPRB, 0.53594007E-09_JPRB, 0.53594035E-09_JPRB, 0.53594074E-09_JPRB, 0.53594568E-09_JPRB, &
  & 0.53594046E-09_JPRB, 0.53593380E-09_JPRB, 0.53593513E-09_JPRB, 0.53593646E-09_JPRB, 0.53593763E-09_JPRB, 0.53594224E-09_JPRB, &
  & 0.53594967E-09_JPRB, 0.53595944E-09_JPRB, 0.53596322E-09_JPRB, 0.53597266E-09_JPRB, 0.53597671E-09_JPRB, 0.53598131E-09_JPRB, &
  & 0.53598614E-09_JPRB, 0.53598820E-09_JPRB, 0.53598920E-09_JPRB, 0.53599603E-09_JPRB, 0.53599924E-09_JPRB, 0.53599447E-09_JPRB, &
  & 0.53599014E-09_JPRB, 0.53599197E-09_JPRB, 0.53598914E-09_JPRB, 0.53598331E-09_JPRB, 0.53598304E-09_JPRB, 0.53598159E-09_JPRB, &
  & 0.53598193E-09_JPRB, 0.53597948E-09_JPRB, 0.53597682E-09_JPRB, 0.53597160E-09_JPRB, 0.53596694E-09_JPRB, 0.53597343E-09_JPRB, &
  & 0.53596777E-09_JPRB, 0.53597138E-09_JPRB, 0.53596738E-09_JPRB, 0.53597121E-09_JPRB, 0.53597404E-09_JPRB, 0.53596561E-09_JPRB, &
  & 0.53595700E-09_JPRB, 0.53595650E-09_JPRB, 0.53596061E-09_JPRB, 0.53595528E-09_JPRB, 0.53595867E-09_JPRB, 0.53594912E-09_JPRB, &
  & 0.53594529E-09_JPRB, 0.53594257E-09_JPRB, 0.53593568E-09_JPRB, 0.53593918E-09_JPRB /)

RGHG6(:,86,10) = (/ &
  & 0.53589899E-09_JPRB, 0.53590260E-09_JPRB, 0.53590798E-09_JPRB, 0.53590771E-09_JPRB, 0.53591093E-09_JPRB, 0.53592292E-09_JPRB, &
  & 0.53593424E-09_JPRB, 0.53593624E-09_JPRB, 0.53593885E-09_JPRB, 0.53594174E-09_JPRB, 0.53594290E-09_JPRB, 0.53594318E-09_JPRB, &
  & 0.53594218E-09_JPRB, 0.53594212E-09_JPRB, 0.53594074E-09_JPRB, 0.53594085E-09_JPRB, 0.53594146E-09_JPRB, 0.53594573E-09_JPRB, &
  & 0.53594107E-09_JPRB, 0.53593463E-09_JPRB, 0.53593591E-09_JPRB, 0.53593724E-09_JPRB, 0.53593818E-09_JPRB, 0.53594257E-09_JPRB, &
  & 0.53595017E-09_JPRB, 0.53596017E-09_JPRB, 0.53596350E-09_JPRB, 0.53597327E-09_JPRB, 0.53597699E-09_JPRB, 0.53598159E-09_JPRB, &
  & 0.53598626E-09_JPRB, 0.53598820E-09_JPRB, 0.53598909E-09_JPRB, 0.53599619E-09_JPRB, 0.53599941E-09_JPRB, 0.53599464E-09_JPRB, &
  & 0.53599014E-09_JPRB, 0.53599225E-09_JPRB, 0.53598942E-09_JPRB, 0.53598326E-09_JPRB, 0.53598320E-09_JPRB, 0.53598181E-09_JPRB, &
  & 0.53598243E-09_JPRB, 0.53597993E-09_JPRB, 0.53597726E-09_JPRB, 0.53597193E-09_JPRB, 0.53596710E-09_JPRB, 0.53597393E-09_JPRB, &
  & 0.53596810E-09_JPRB, 0.53597166E-09_JPRB, 0.53596749E-09_JPRB, 0.53597149E-09_JPRB, 0.53597454E-09_JPRB, 0.53596594E-09_JPRB, &
  & 0.53595706E-09_JPRB, 0.53595656E-09_JPRB, 0.53596089E-09_JPRB, 0.53595550E-09_JPRB, 0.53595911E-09_JPRB, 0.53594917E-09_JPRB, &
  & 0.53594562E-09_JPRB, 0.53594279E-09_JPRB, 0.53593602E-09_JPRB, 0.53593974E-09_JPRB /)

RGHG6(:,87,10) = (/ &
  & 0.53589944E-09_JPRB, 0.53590293E-09_JPRB, 0.53590832E-09_JPRB, 0.53590793E-09_JPRB, 0.53591082E-09_JPRB, 0.53592625E-09_JPRB, &
  & 0.53593352E-09_JPRB, 0.53593707E-09_JPRB, 0.53593896E-09_JPRB, 0.53594174E-09_JPRB, 0.53594273E-09_JPRB, 0.53594307E-09_JPRB, &
  & 0.53594240E-09_JPRB, 0.53594229E-09_JPRB, 0.53594112E-09_JPRB, 0.53594129E-09_JPRB, 0.53594196E-09_JPRB, 0.53594568E-09_JPRB, &
  & 0.53594162E-09_JPRB, 0.53593524E-09_JPRB, 0.53593635E-09_JPRB, 0.53593768E-09_JPRB, 0.53593846E-09_JPRB, 0.53594290E-09_JPRB, &
  & 0.53595034E-09_JPRB, 0.53596078E-09_JPRB, 0.53596366E-09_JPRB, 0.53597371E-09_JPRB, 0.53597715E-09_JPRB, 0.53598159E-09_JPRB, &
  & 0.53598637E-09_JPRB, 0.53598809E-09_JPRB, 0.53598903E-09_JPRB, 0.53599625E-09_JPRB, 0.53599958E-09_JPRB, 0.53599458E-09_JPRB, &
  & 0.53599014E-09_JPRB, 0.53599253E-09_JPRB, 0.53598970E-09_JPRB, 0.53598320E-09_JPRB, 0.53598342E-09_JPRB, 0.53598198E-09_JPRB, &
  & 0.53598287E-09_JPRB, 0.53598020E-09_JPRB, 0.53597748E-09_JPRB, 0.53597204E-09_JPRB, 0.53596727E-09_JPRB, 0.53597410E-09_JPRB, &
  & 0.53596833E-09_JPRB, 0.53597188E-09_JPRB, 0.53596760E-09_JPRB, 0.53597160E-09_JPRB, 0.53597488E-09_JPRB, 0.53596594E-09_JPRB, &
  & 0.53595711E-09_JPRB, 0.53595661E-09_JPRB, 0.53596105E-09_JPRB, 0.53595561E-09_JPRB, 0.53595922E-09_JPRB, 0.53594956E-09_JPRB, &
  & 0.53594573E-09_JPRB, 0.53594307E-09_JPRB, 0.53593613E-09_JPRB, 0.53594001E-09_JPRB /)

RGHG6(:,88,10) = (/ &
  & 0.53589955E-09_JPRB, 0.53590332E-09_JPRB, 0.53590854E-09_JPRB, 0.53590815E-09_JPRB, 0.53591270E-09_JPRB, 0.53592386E-09_JPRB, &
  & 0.53593507E-09_JPRB, 0.53593713E-09_JPRB, 0.53593963E-09_JPRB, 0.53594179E-09_JPRB, 0.53594273E-09_JPRB, 0.53594296E-09_JPRB, &
  & 0.53594235E-09_JPRB, 0.53594229E-09_JPRB, 0.53594135E-09_JPRB, 0.53594151E-09_JPRB, 0.53594218E-09_JPRB, 0.53594573E-09_JPRB, &
  & 0.53594185E-09_JPRB, 0.53593563E-09_JPRB, 0.53593663E-09_JPRB, 0.53593796E-09_JPRB, 0.53593868E-09_JPRB, 0.53594307E-09_JPRB, &
  & 0.53595045E-09_JPRB, 0.53596133E-09_JPRB, 0.53596361E-09_JPRB, 0.53597432E-09_JPRB, 0.53597726E-09_JPRB, 0.53598170E-09_JPRB, &
  & 0.53598648E-09_JPRB, 0.53598814E-09_JPRB, 0.53598881E-09_JPRB, 0.53599636E-09_JPRB, 0.53599963E-09_JPRB, 0.53599480E-09_JPRB, &
  & 0.53599009E-09_JPRB, 0.53599275E-09_JPRB, 0.53598981E-09_JPRB, 0.53598304E-09_JPRB, 0.53598354E-09_JPRB, 0.53598215E-09_JPRB, &
  & 0.53598315E-09_JPRB, 0.53598043E-09_JPRB, 0.53597765E-09_JPRB, 0.53597210E-09_JPRB, 0.53596733E-09_JPRB, 0.53597421E-09_JPRB, &
  & 0.53596844E-09_JPRB, 0.53597193E-09_JPRB, 0.53596777E-09_JPRB, 0.53597182E-09_JPRB, 0.53597510E-09_JPRB, 0.53596599E-09_JPRB, &
  & 0.53595706E-09_JPRB, 0.53595661E-09_JPRB, 0.53596116E-09_JPRB, 0.53595561E-09_JPRB, 0.53595950E-09_JPRB, 0.53594956E-09_JPRB, &
  & 0.53594573E-09_JPRB, 0.53594296E-09_JPRB, 0.53593618E-09_JPRB, 0.53594018E-09_JPRB /)

RGHG6(:,89,10) = (/ &
  & 0.53589966E-09_JPRB, 0.53590349E-09_JPRB, 0.53590860E-09_JPRB, 0.53590793E-09_JPRB, 0.53591054E-09_JPRB, 0.53592658E-09_JPRB, &
  & 0.53593385E-09_JPRB, 0.53593735E-09_JPRB, 0.53593918E-09_JPRB, 0.53594201E-09_JPRB, 0.53594296E-09_JPRB, 0.53594329E-09_JPRB, &
  & 0.53594240E-09_JPRB, 0.53594229E-09_JPRB, 0.53594129E-09_JPRB, 0.53594151E-09_JPRB, 0.53594229E-09_JPRB, 0.53594623E-09_JPRB, &
  & 0.53594212E-09_JPRB, 0.53593557E-09_JPRB, 0.53593668E-09_JPRB, 0.53593807E-09_JPRB, 0.53593868E-09_JPRB, 0.53594301E-09_JPRB, &
  & 0.53595056E-09_JPRB, 0.53596166E-09_JPRB, 0.53596361E-09_JPRB, 0.53597454E-09_JPRB, 0.53597732E-09_JPRB, 0.53598176E-09_JPRB, &
  & 0.53598659E-09_JPRB, 0.53598809E-09_JPRB, 0.53598864E-09_JPRB, 0.53599658E-09_JPRB, 0.53599991E-09_JPRB, 0.53599475E-09_JPRB, &
  & 0.53598981E-09_JPRB, 0.53599292E-09_JPRB, 0.53598997E-09_JPRB, 0.53598276E-09_JPRB, 0.53598365E-09_JPRB, 0.53598220E-09_JPRB, &
  & 0.53598342E-09_JPRB, 0.53598043E-09_JPRB, 0.53597782E-09_JPRB, 0.53597216E-09_JPRB, 0.53596722E-09_JPRB, 0.53597426E-09_JPRB, &
  & 0.53596833E-09_JPRB, 0.53597182E-09_JPRB, 0.53596760E-09_JPRB, 0.53597182E-09_JPRB, 0.53597526E-09_JPRB, 0.53596599E-09_JPRB, &
  & 0.53595700E-09_JPRB, 0.53595656E-09_JPRB, 0.53596128E-09_JPRB, 0.53595556E-09_JPRB, 0.53595967E-09_JPRB, 0.53594967E-09_JPRB, &
  & 0.53594573E-09_JPRB, 0.53594301E-09_JPRB, 0.53593607E-09_JPRB, 0.53594035E-09_JPRB /)

RGHG6(:,90,10) = (/ &
  & 0.53589977E-09_JPRB, 0.53590365E-09_JPRB, 0.53590865E-09_JPRB, 0.53590776E-09_JPRB, 0.53591043E-09_JPRB, 0.53592331E-09_JPRB, &
  & 0.53593530E-09_JPRB, 0.53593696E-09_JPRB, 0.53593940E-09_JPRB, 0.53594257E-09_JPRB, 0.53594362E-09_JPRB, 0.53594384E-09_JPRB, &
  & 0.53594246E-09_JPRB, 0.53594251E-09_JPRB, 0.53594096E-09_JPRB, 0.53594129E-09_JPRB, 0.53594212E-09_JPRB, 0.53594729E-09_JPRB, &
  & 0.53594229E-09_JPRB, 0.53593535E-09_JPRB, 0.53593679E-09_JPRB, 0.53593818E-09_JPRB, 0.53593868E-09_JPRB, 0.53594301E-09_JPRB, &
  & 0.53595045E-09_JPRB, 0.53596211E-09_JPRB, 0.53596344E-09_JPRB, 0.53597493E-09_JPRB, 0.53597743E-09_JPRB, 0.53598170E-09_JPRB, &
  & 0.53598664E-09_JPRB, 0.53598809E-09_JPRB, 0.53598831E-09_JPRB, 0.53599675E-09_JPRB, 0.53600041E-09_JPRB, 0.53599480E-09_JPRB, &
  & 0.53598953E-09_JPRB, 0.53599319E-09_JPRB, 0.53599020E-09_JPRB, 0.53598237E-09_JPRB, 0.53598381E-09_JPRB, 0.53598220E-09_JPRB, &
  & 0.53598365E-09_JPRB, 0.53598059E-09_JPRB, 0.53597798E-09_JPRB, 0.53597210E-09_JPRB, 0.53596699E-09_JPRB, 0.53597471E-09_JPRB, &
  & 0.53596816E-09_JPRB, 0.53597204E-09_JPRB, 0.53596738E-09_JPRB, 0.53597193E-09_JPRB, 0.53597565E-09_JPRB, 0.53596583E-09_JPRB, &
  & 0.53595667E-09_JPRB, 0.53595645E-09_JPRB, 0.53596155E-09_JPRB, 0.53595539E-09_JPRB, 0.53596000E-09_JPRB, 0.53594940E-09_JPRB, &
  & 0.53594562E-09_JPRB, 0.53594296E-09_JPRB, 0.53593585E-09_JPRB, 0.53594040E-09_JPRB /)

RGHG6(:,91,10) = (/ &
  & 0.53589971E-09_JPRB, 0.53590388E-09_JPRB, 0.53590871E-09_JPRB, 0.53590732E-09_JPRB, 0.53590787E-09_JPRB, 0.53592308E-09_JPRB, &
  & 0.53593613E-09_JPRB, 0.53593624E-09_JPRB, 0.53593702E-09_JPRB, 0.53594507E-09_JPRB, 0.53594490E-09_JPRB, 0.53594579E-09_JPRB, &
  & 0.53594107E-09_JPRB, 0.53594362E-09_JPRB, 0.53593957E-09_JPRB, 0.53594112E-09_JPRB, 0.53594112E-09_JPRB, 0.53594951E-09_JPRB, &
  & 0.53594235E-09_JPRB, 0.53593446E-09_JPRB, 0.53593685E-09_JPRB, 0.53593824E-09_JPRB, 0.53593846E-09_JPRB, 0.53594273E-09_JPRB, &
  & 0.53595028E-09_JPRB, 0.53596277E-09_JPRB, 0.53596277E-09_JPRB, 0.53597560E-09_JPRB, 0.53597721E-09_JPRB, 0.53598165E-09_JPRB, &
  & 0.53598703E-09_JPRB, 0.53598831E-09_JPRB, 0.53598759E-09_JPRB, 0.53599730E-09_JPRB, 0.53600135E-09_JPRB, 0.53599480E-09_JPRB, &
  & 0.53598870E-09_JPRB, 0.53599386E-09_JPRB, 0.53599047E-09_JPRB, 0.53598170E-09_JPRB, 0.53598409E-09_JPRB, 0.53598198E-09_JPRB, &
  & 0.53598387E-09_JPRB, 0.53598048E-09_JPRB, 0.53597821E-09_JPRB, 0.53597204E-09_JPRB, 0.53596605E-09_JPRB, 0.53597560E-09_JPRB, &
  & 0.53596755E-09_JPRB, 0.53597266E-09_JPRB, 0.53596672E-09_JPRB, 0.53597204E-09_JPRB, 0.53597665E-09_JPRB, 0.53596583E-09_JPRB, &
  & 0.53595611E-09_JPRB, 0.53595606E-09_JPRB, 0.53596222E-09_JPRB, 0.53595467E-09_JPRB, 0.53596100E-09_JPRB, 0.53594895E-09_JPRB, &
  & 0.53594540E-09_JPRB, 0.53594301E-09_JPRB, 0.53593535E-09_JPRB, 0.53594040E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART20',1,ZHOOK_HANDLE)
END SUBROUTINE PART20






SUBROUTINE PART21
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART21',0,ZHOOK_HANDLE)



!-- Month= 11 ------------

RGHG6(:, 1,11) = (/ &
  & 0.13927180E-36_JPRB, 0.18293100E-35_JPRB, 0.39062239E-35_JPRB, 0.47361065E-35_JPRB, 0.50012090E-35_JPRB, 0.52462175E-35_JPRB, &
  & 0.57026152E-35_JPRB, 0.66853020E-35_JPRB, 0.87934647E-35_JPRB, 0.12861933E-34_JPRB, 0.21325616E-34_JPRB, 0.38086683E-34_JPRB, &
  & 0.59792152E-34_JPRB, 0.91762384E-34_JPRB, 0.17530018E-33_JPRB, 0.28427558E-33_JPRB, 0.40934772E-33_JPRB, 0.65612798E-33_JPRB, &
  & 0.12078691E-32_JPRB, 0.21858035E-32_JPRB, 0.35459331E-32_JPRB, 0.53498379E-32_JPRB, 0.76833389E-32_JPRB, 0.10665281E-31_JPRB, &
  & 0.14247666E-31_JPRB, 0.18074140E-31_JPRB, 0.22059107E-31_JPRB, 0.25936422E-31_JPRB, 0.28919621E-31_JPRB, 0.31104677E-31_JPRB, &
  & 0.31741313E-31_JPRB, 0.31979206E-31_JPRB, 0.32489098E-31_JPRB, 0.28763788E-31_JPRB, 0.23914754E-31_JPRB, 0.19554622E-31_JPRB, &
  & 0.14535891E-31_JPRB, 0.10007755E-31_JPRB, 0.66930804E-32_JPRB, 0.42553028E-32_JPRB, 0.26615802E-32_JPRB, 0.16604085E-32_JPRB, &
  & 0.10397596E-32_JPRB, 0.65302233E-33_JPRB, 0.40551221E-33_JPRB, 0.24885794E-33_JPRB, 0.15001809E-33_JPRB, 0.88577368E-34_JPRB, &
  & 0.50413337E-34_JPRB, 0.28680329E-34_JPRB, 0.16176780E-34_JPRB, 0.92894553E-35_JPRB, 0.54900680E-35_JPRB, 0.34365574E-35_JPRB, &
  & 0.23473004E-35_JPRB, 0.17909692E-35_JPRB, 0.15295403E-35_JPRB, 0.14303610E-35_JPRB, 0.14154630E-35_JPRB, 0.14283664E-35_JPRB, &
  & 0.14125558E-35_JPRB, 0.13083562E-35_JPRB, 0.11033266E-35_JPRB, 0.90288857E-36_JPRB /)

RGHG6(:, 2,11) = (/ &
  & 0.10803037E-34_JPRB, 0.81014715E-34_JPRB, 0.15758510E-33_JPRB, 0.19020096E-33_JPRB, 0.20303588E-33_JPRB, 0.21599070E-33_JPRB, &
  & 0.23960336E-33_JPRB, 0.28688780E-33_JPRB, 0.37976825E-33_JPRB, 0.55770145E-33_JPRB, 0.89504252E-33_JPRB, 0.15321595E-32_JPRB, &
  & 0.24098448E-32_JPRB, 0.37923780E-32_JPRB, 0.70308448E-32_JPRB, 0.11331416E-31_JPRB, 0.16679921E-31_JPRB, 0.27116169E-31_JPRB, &
  & 0.49426516E-31_JPRB, 0.88110672E-31_JPRB, 0.14200591E-30_JPRB, 0.21357547E-30_JPRB, 0.30640741E-30_JPRB, 0.42525097E-30_JPRB, &
  & 0.56857467E-30_JPRB, 0.72242949E-30_JPRB, 0.88186423E-30_JPRB, 0.10289803E-29_JPRB, 0.11510658E-29_JPRB, 0.12379201E-29_JPRB, &
  & 0.12678410E-29_JPRB, 0.12768269E-29_JPRB, 0.12768891E-29_JPRB, 0.11339973E-29_JPRB, 0.94303414E-30_JPRB, 0.76367401E-30_JPRB, &
  & 0.57169914E-30_JPRB, 0.39989594E-30_JPRB, 0.27107567E-30_JPRB, 0.17673069E-30_JPRB, 0.11214787E-30_JPRB, 0.70719668E-31_JPRB, &
  & 0.44609038E-31_JPRB, 0.28215746E-31_JPRB, 0.17721052E-31_JPRB, 0.11028975E-31_JPRB, 0.67667362E-32_JPRB, 0.40746734E-32_JPRB, &
  & 0.23817312E-32_JPRB, 0.13761979E-32_JPRB, 0.78489769E-33_JPRB, 0.45066658E-33_JPRB, 0.26416857E-33_JPRB, 0.16238734E-33_JPRB, &
  & 0.10784068E-33_JPRB, 0.79513463E-34_JPRB, 0.65620204E-34_JPRB, 0.59675796E-34_JPRB, 0.57867802E-34_JPRB, 0.57617900E-34_JPRB, &
  & 0.56641218E-34_JPRB, 0.52664908E-34_JPRB, 0.44309852E-34_JPRB, 0.33855380E-34_JPRB /)

RGHG6(:, 3,11) = (/ &
  & 0.76620067E-33_JPRB, 0.48276400E-32_JPRB, 0.82078202E-32_JPRB, 0.95506367E-32_JPRB, 0.10132661E-31_JPRB, 0.10805154E-31_JPRB, &
  & 0.12038568E-31_JPRB, 0.14449350E-31_JPRB, 0.19165034E-31_JPRB, 0.27711580E-31_JPRB, 0.44532622E-31_JPRB, 0.74523438E-31_JPRB, &
  & 0.11736526E-30_JPRB, 0.18531631E-30_JPRB, 0.33835006E-30_JPRB, 0.54158688E-30_JPRB, 0.79444479E-30_JPRB, 0.12773491E-29_JPRB, &
  & 0.23095601E-29_JPRB, 0.41136494E-29_JPRB, 0.66404635E-29_JPRB, 0.10028246E-28_JPRB, 0.14485449E-28_JPRB, 0.20273198E-28_JPRB, &
  & 0.27287063E-28_JPRB, 0.34777850E-28_JPRB, 0.42316238E-28_JPRB, 0.49208202E-28_JPRB, 0.54936791E-28_JPRB, 0.59049524E-28_JPRB, &
  & 0.60505166E-28_JPRB, 0.60846892E-28_JPRB, 0.60503264E-28_JPRB, 0.53655680E-28_JPRB, 0.44538234E-28_JPRB, 0.35917023E-28_JPRB, &
  & 0.26931964E-28_JPRB, 0.18953979E-28_JPRB, 0.12966376E-28_JPRB, 0.85397584E-29_JPRB, 0.54767177E-29_JPRB, 0.34670783E-29_JPRB, &
  & 0.21943767E-29_JPRB, 0.13908713E-29_JPRB, 0.87683453E-30_JPRB, 0.54915537E-30_JPRB, 0.33989445E-30_JPRB, 0.20683124E-30_JPRB, &
  & 0.12226518E-30_JPRB, 0.71063671E-31_JPRB, 0.40446072E-31_JPRB, 0.22916295E-31_JPRB, 0.13107329E-31_JPRB, 0.77984227E-32_JPRB, &
  & 0.50139624E-32_JPRB, 0.36158926E-32_JPRB, 0.29774899E-32_JPRB, 0.27478255E-32_JPRB, 0.27301047E-32_JPRB, 0.27908289E-32_JPRB, &
  & 0.28066592E-32_JPRB, 0.26410192E-32_JPRB, 0.21581984E-32_JPRB, 0.14005504E-32_JPRB /)

RGHG6(:, 4,11) = (/ &
  & 0.18455847E-30_JPRB, 0.62738390E-30_JPRB, 0.87054479E-30_JPRB, 0.95743253E-30_JPRB, 0.99891601E-30_JPRB, 0.10587940E-29_JPRB, &
  & 0.11726940E-29_JPRB, 0.13960923E-29_JPRB, 0.18323576E-29_JPRB, 0.26627157E-29_JPRB, 0.42316860E-29_JPRB, 0.71428927E-29_JPRB, &
  & 0.11175862E-28_JPRB, 0.17532759E-28_JPRB, 0.31701514E-28_JPRB, 0.50289052E-28_JPRB, 0.72903731E-28_JPRB, 0.11550545E-27_JPRB, &
  & 0.20674372E-27_JPRB, 0.36762760E-27_JPRB, 0.59231826E-27_JPRB, 0.89472812E-27_JPRB, 0.12946648E-26_JPRB, 0.18201652E-26_JPRB, &
  & 0.24571226E-26_JPRB, 0.31221932E-26_JPRB, 0.37854142E-26_JPRB, 0.43746705E-26_JPRB, 0.48701306E-26_JPRB, 0.52242464E-26_JPRB, &
  & 0.53438975E-26_JPRB, 0.53659952E-26_JPRB, 0.53315365E-26_JPRB, 0.47221387E-26_JPRB, 0.39122763E-26_JPRB, 0.31539429E-26_JPRB, &
  & 0.23625078E-26_JPRB, 0.16645712E-26_JPRB, 0.11423089E-26_JPRB, 0.75773653E-27_JPRB, 0.48865349E-27_JPRB, 0.31185267E-27_JPRB, &
  & 0.19875713E-27_JPRB, 0.12701324E-27_JPRB, 0.80854812E-28_JPRB, 0.51194299E-28_JPRB, 0.32069129E-28_JPRB, 0.19747234E-28_JPRB, &
  & 0.11795033E-28_JPRB, 0.68928882E-29_JPRB, 0.39145647E-29_JPRB, 0.21909665E-29_JPRB, 0.12246080E-29_JPRB, 0.70727605E-30_JPRB, &
  & 0.44238094E-30_JPRB, 0.31577747E-30_JPRB, 0.26287035E-30_JPRB, 0.24948137E-30_JPRB, 0.25665741E-30_JPRB, 0.27255833E-30_JPRB, &
  & 0.28591547E-30_JPRB, 0.28126766E-30_JPRB, 0.23563240E-30_JPRB, 0.13159442E-30_JPRB /)

RGHG6(:, 5,11) = (/ &
  & 0.12511847E-27_JPRB, 0.18706440E-27_JPRB, 0.21504876E-27_JPRB, 0.22430240E-27_JPRB, 0.23277786E-27_JPRB, 0.24674600E-27_JPRB, &
  & 0.27212458E-27_JPRB, 0.32124182E-27_JPRB, 0.41830630E-27_JPRB, 0.59983936E-27_JPRB, 0.95661162E-27_JPRB, 0.15976402E-26_JPRB, &
  & 0.24656539E-26_JPRB, 0.38091170E-26_JPRB, 0.67489146E-26_JPRB, 0.10502906E-25_JPRB, 0.14940705E-25_JPRB, 0.23135352E-25_JPRB, &
  & 0.40571280E-25_JPRB, 0.70893580E-25_JPRB, 0.11232716E-24_JPRB, 0.16690386E-24_JPRB, 0.23823274E-24_JPRB, 0.33058809E-24_JPRB, &
  & 0.44104996E-24_JPRB, 0.55357072E-24_JPRB, 0.66238693E-24_JPRB, 0.75766944E-24_JPRB, 0.83609080E-24_JPRB, 0.89139567E-24_JPRB, &
  & 0.90751840E-24_JPRB, 0.90915391E-24_JPRB, 0.90513249E-24_JPRB, 0.80239608E-24_JPRB, 0.66669652E-24_JPRB, 0.54022634E-24_JPRB, &
  & 0.40668203E-24_JPRB, 0.28784748E-24_JPRB, 0.19946750E-24_JPRB, 0.13379467E-24_JPRB, 0.87527988E-25_JPRB, 0.56778449E-25_JPRB, &
  & 0.36872597E-25_JPRB, 0.24067947E-25_JPRB, 0.15665254E-25_JPRB, 0.10153037E-25_JPRB, 0.65101470E-26_JPRB, 0.40986724E-26_JPRB, &
  & 0.24973397E-26_JPRB, 0.14824819E-26_JPRB, 0.85051830E-27_JPRB, 0.47783699E-27_JPRB, 0.26657998E-27_JPRB, 0.15324773E-27_JPRB, &
  & 0.95791049E-28_JPRB, 0.68821662E-28_JPRB, 0.58212641E-28_JPRB, 0.56219610E-28_JPRB, 0.58830497E-28_JPRB, 0.63702023E-28_JPRB, &
  & 0.69051684E-28_JPRB, 0.73040869E-28_JPRB, 0.70257220E-28_JPRB, 0.56173575E-28_JPRB /)

RGHG6(:, 6,11) = (/ &
  & 0.51193024E-25_JPRB, 0.89655114E-25_JPRB, 0.10515676E-24_JPRB, 0.11327333E-24_JPRB, 0.12025972E-24_JPRB, 0.12965927E-24_JPRB, &
  & 0.14431493E-24_JPRB, 0.16970307E-24_JPRB, 0.21799143E-24_JPRB, 0.30617627E-24_JPRB, 0.47309438E-24_JPRB, 0.76421586E-24_JPRB, &
  & 0.11341528E-23_JPRB, 0.16787571E-23_JPRB, 0.28400065E-23_JPRB, 0.42291764E-23_JPRB, 0.57479971E-23_JPRB, 0.84883713E-23_JPRB, &
  & 0.14188051E-22_JPRB, 0.23694062E-22_JPRB, 0.35939029E-22_JPRB, 0.51274570E-22_JPRB, 0.70359072E-22_JPRB, 0.94342337E-22_JPRB, &
  & 0.12199069E-21_JPRB, 0.14895880E-21_JPRB, 0.17410264E-21_JPRB, 0.19507478E-21_JPRB, 0.21173899E-21_JPRB, 0.22297523E-21_JPRB, &
  & 0.22514613E-21_JPRB, 0.22486156E-21_JPRB, 0.22453698E-21_JPRB, 0.20024776E-21_JPRB, 0.16787826E-21_JPRB, 0.13802526E-21_JPRB, &
  & 0.10551887E-21_JPRB, 0.76007991E-22_JPRB, 0.53887278E-22_JPRB, 0.37044126E-22_JPRB, 0.24937425E-22_JPRB, 0.16672796E-22_JPRB, &
  & 0.11226381E-22_JPRB, 0.76077951E-23_JPRB, 0.51551106E-23_JPRB, 0.34820431E-23_JPRB, 0.23284149E-23_JPRB, 0.15281765E-23_JPRB, &
  & 0.96888232E-24_JPRB, 0.59742956E-24_JPRB, 0.35491390E-24_JPRB, 0.20625079E-24_JPRB, 0.11901756E-24_JPRB, 0.71052283E-25_JPRB, &
  & 0.46244758E-25_JPRB, 0.34548857E-25_JPRB, 0.30080912E-25_JPRB, 0.29593186E-25_JPRB, 0.31301982E-25_JPRB, 0.34158833E-25_JPRB, &
  & 0.37431906E-25_JPRB, 0.40932686E-25_JPRB, 0.44059934E-25_JPRB, 0.47434752E-25_JPRB /)

RGHG6(:, 7,11) = (/ &
  & 0.47026810E-22_JPRB, 0.64238130E-22_JPRB, 0.74337285E-22_JPRB, 0.80912106E-22_JPRB, 0.87690687E-22_JPRB, 0.95923164E-22_JPRB, &
  & 0.10734413E-21_JPRB, 0.12542062E-21_JPRB, 0.15696797E-21_JPRB, 0.21178179E-21_JPRB, 0.31058655E-21_JPRB, 0.47237556E-21_JPRB, &
  & 0.65965296E-21_JPRB, 0.91550799E-21_JPRB, 0.14477694E-20_JPRB, 0.20199452E-20_JPRB, 0.25690570E-20_JPRB, 0.35425044E-20_JPRB, &
  & 0.55384346E-20_JPRB, 0.86849740E-20_JPRB, 0.12424809E-19_JPRB, 0.16766985E-19_JPRB, 0.21870300E-19_JPRB, 0.27992887E-19_JPRB, &
  & 0.34785417E-19_JPRB, 0.41033865E-19_JPRB, 0.46552978E-19_JPRB, 0.50862935E-19_JPRB, 0.54078416E-19_JPRB, 0.56092733E-19_JPRB, &
  & 0.56103441E-19_JPRB, 0.55860327E-19_JPRB, 0.55962769E-19_JPRB, 0.50310382E-19_JPRB, 0.42732186E-19_JPRB, 0.35777264E-19_JPRB, &
  & 0.27958469E-19_JPRB, 0.20666015E-19_JPRB, 0.15094610E-19_JPRB, 0.10739347E-19_JPRB, 0.74736043E-20_JPRB, 0.52091453E-20_JPRB, &
  & 0.36553592E-20_JPRB, 0.25983573E-20_JPRB, 0.18473999E-20_JPRB, 0.13127320E-20_JPRB, 0.92474754E-21_JPRB, 0.64014863E-21_JPRB, &
  & 0.42796297E-21_JPRB, 0.27861540E-21_JPRB, 0.17475228E-21_JPRB, 0.10742953E-21_JPRB, 0.65874871E-22_JPRB, 0.41980019E-22_JPRB, &
  & 0.29228180E-22_JPRB, 0.23155616E-22_JPRB, 0.21054677E-22_JPRB, 0.21291539E-22_JPRB, 0.22904712E-22_JPRB, 0.25257890E-22_JPRB, &
  & 0.27873835E-22_JPRB, 0.30720661E-22_JPRB, 0.33626708E-22_JPRB, 0.38375609E-22_JPRB /)

RGHG6(:, 8,11) = (/ &
  & 0.40141046E-19_JPRB, 0.49445842E-19_JPRB, 0.55200257E-19_JPRB, 0.59903373E-19_JPRB, 0.64734612E-19_JPRB, 0.70576614E-19_JPRB, &
  & 0.78114265E-19_JPRB, 0.89179712E-19_JPRB, 0.10769226E-18_JPRB, 0.13831225E-18_JPRB, 0.19105957E-18_JPRB, 0.27232693E-18_JPRB, &
  & 0.35624880E-18_JPRB, 0.46119093E-18_JPRB, 0.67867016E-18_JPRB, 0.88330161E-18_JPRB, 0.10454221E-17_JPRB, 0.13387389E-17_JPRB, &
  & 0.19497396E-17_JPRB, 0.28631589E-17_JPRB, 0.38509551E-17_JPRB, 0.49048994E-17_JPRB, 0.60612123E-17_JPRB, 0.73917654E-17_JPRB, &
  & 0.88046221E-17_JPRB, 0.10010593E-16_JPRB, 0.11005430E-16_JPRB, 0.11706014E-16_JPRB, 0.12180886E-16_JPRB, 0.12437868E-16_JPRB, &
  & 0.12321090E-16_JPRB, 0.12228237E-16_JPRB, 0.12283163E-16_JPRB, 0.11133835E-16_JPRB, 0.95864898E-17_JPRB, 0.81743154E-17_JPRB, &
  & 0.65465497E-17_JPRB, 0.49771664E-17_JPRB, 0.37649767E-17_JPRB, 0.27742087E-17_JPRB, 0.20139904E-17_JPRB, 0.14600895E-17_JPRB, &
  & 0.10749288E-17_JPRB, 0.80053764E-18_JPRB, 0.59807490E-18_JPRB, 0.44690883E-18_JPRB, 0.33171863E-18_JPRB, 0.24236454E-18_JPRB, &
  & 0.17101809E-18_JPRB, 0.11793705E-18_JPRB, 0.78378562E-19_JPRB, 0.51257878E-19_JPRB, 0.33488963E-19_JPRB, 0.22816181E-19_JPRB, &
  & 0.16929993E-19_JPRB, 0.14167764E-19_JPRB, 0.13414562E-19_JPRB, 0.13938921E-19_JPRB, 0.15258652E-19_JPRB, 0.17020349E-19_JPRB, &
  & 0.18917529E-19_JPRB, 0.20946181E-19_JPRB, 0.22957477E-19_JPRB, 0.26350338E-19_JPRB /)

RGHG6(:, 9,11) = (/ &
  & 0.30318797E-16_JPRB, 0.35662390E-16_JPRB, 0.39017094E-16_JPRB, 0.41610623E-16_JPRB, 0.44321786E-16_JPRB, 0.47382077E-16_JPRB, &
  & 0.51097315E-16_JPRB, 0.56358343E-16_JPRB, 0.65140817E-16_JPRB, 0.79382757E-16_JPRB, 0.10333488E-15_JPRB, 0.13812438E-15_JPRB, &
  & 0.16932377E-15_JPRB, 0.20439329E-15_JPRB, 0.27986344E-15_JPRB, 0.33970013E-15_JPRB, 0.37378357E-15_JPRB, 0.44401149E-15_JPRB, &
  & 0.60229919E-15_JPRB, 0.82855312E-15_JPRB, 0.10474282E-14_JPRB, 0.12579091E-14_JPRB, 0.14713283E-14_JPRB, 0.17069471E-14_JPRB, &
  & 0.19453429E-14_JPRB, 0.21283128E-14_JPRB, 0.22641669E-14_JPRB, 0.23430005E-14_JPRB, 0.23853784E-14_JPRB, 0.23976009E-14_JPRB, &
  & 0.23518952E-14_JPRB, 0.23254074E-14_JPRB, 0.23402826E-14_JPRB, 0.21377299E-14_JPRB, 0.18654840E-14_JPRB, 0.16209376E-14_JPRB, &
  & 0.13302391E-14_JPRB, 0.10442349E-14_JPRB, 0.81816982E-15_JPRB, 0.62902154E-15_JPRB, 0.47578428E-15_JPRB, 0.36206439E-15_JPRB, &
  & 0.27886776E-15_JPRB, 0.21843804E-15_JPRB, 0.17124349E-15_JPRB, 0.13454856E-15_JPRB, 0.10511361E-15_JPRB, 0.80975516E-16_JPRB, &
  & 0.60220138E-16_JPRB, 0.43947550E-16_JPRB, 0.30914165E-16_JPRB, 0.21445815E-16_JPRB, 0.14871278E-16_JPRB, 0.10733277E-16_JPRB, &
  & 0.84022021E-17_JPRB, 0.73493029E-17_JPRB, 0.71928698E-17_JPRB, 0.76448677E-17_JPRB, 0.84936196E-17_JPRB, 0.95596188E-17_JPRB, &
  & 0.10707020E-16_JPRB, 0.11830670E-16_JPRB, 0.13092908E-16_JPRB, 0.14858951E-16_JPRB /)

RGHG6(:,10,11) = (/ &
  & 0.19757770E-13_JPRB, 0.22824689E-13_JPRB, 0.24545807E-13_JPRB, 0.25753246E-13_JPRB, 0.26852245E-13_JPRB, 0.27951984E-13_JPRB, &
  & 0.29158303E-13_JPRB, 0.30899193E-13_JPRB, 0.34081340E-13_JPRB, 0.39391738E-13_JPRB, 0.48352855E-13_JPRB, 0.60738835E-13_JPRB, &
  & 0.69806750E-13_JPRB, 0.78602455E-13_JPRB, 0.10014515E-12_JPRB, 0.11337288E-12_JPRB, 0.11597448E-12_JPRB, 0.12773785E-12_JPRB, &
  & 0.16134746E-12_JPRB, 0.20786472E-12_JPRB, 0.24680822E-12_JPRB, 0.27920147E-12_JPRB, 0.30876693E-12_JPRB, 0.34027108E-12_JPRB, &
  & 0.37048587E-12_JPRB, 0.38945081E-12_JPRB, 0.40051805E-12_JPRB, 0.40303026E-12_JPRB, 0.40142366E-12_JPRB, 0.39716277E-12_JPRB, &
  & 0.38576279E-12_JPRB, 0.37988690E-12_JPRB, 0.38297241E-12_JPRB, 0.35250473E-12_JPRB, 0.31185693E-12_JPRB, 0.27609574E-12_JPRB, &
  & 0.23252965E-12_JPRB, 0.18843190E-12_JPRB, 0.15341278E-12_JPRB, 0.12296311E-12_JPRB, 0.97572639E-13_JPRB, 0.77778875E-13_JPRB, &
  & 0.63047407E-13_JPRB, 0.51907019E-13_JPRB, 0.42801357E-13_JPRB, 0.35374197E-13_JPRB, 0.29101287E-13_JPRB, 0.23630154E-13_JPRB, &
  & 0.18495861E-13_JPRB, 0.14256466E-13_JPRB, 0.10582479E-13_JPRB, 0.77520777E-14_JPRB, 0.56652083E-14_JPRB, 0.42971680E-14_JPRB, &
  & 0.35147547E-14_JPRB, 0.31873210E-14_JPRB, 0.32040184E-14_JPRB, 0.34678215E-14_JPRB, 0.38982692E-14_JPRB, 0.44229951E-14_JPRB, &
  & 0.49506594E-14_JPRB, 0.55335972E-14_JPRB, 0.60280514E-14_JPRB, 0.69807090E-14_JPRB /)

RGHG6(:,11,11) = (/ &
  & 0.97314924E-13_JPRB, 0.10776081E-12_JPRB, 0.11331069E-12_JPRB, 0.11943037E-12_JPRB, 0.12690637E-12_JPRB, 0.13575355E-12_JPRB, &
  & 0.14588020E-12_JPRB, 0.15730977E-12_JPRB, 0.17074538E-12_JPRB, 0.18726443E-12_JPRB, 0.21068742E-12_JPRB, 0.24637722E-12_JPRB, &
  & 0.29259646E-12_JPRB, 0.33054597E-12_JPRB, 0.37945124E-12_JPRB, 0.46935351E-12_JPRB, 0.56041857E-12_JPRB, 0.64067902E-12_JPRB, &
  & 0.72519285E-12_JPRB, 0.83790749E-12_JPRB, 0.96827559E-12_JPRB, 0.11072461E-11_JPRB, 0.12319254E-11_JPRB, 0.13401291E-11_JPRB, &
  & 0.14154131E-11_JPRB, 0.14501362E-11_JPRB, 0.14461845E-11_JPRB, 0.14174663E-11_JPRB, 0.13661187E-11_JPRB, 0.12872990E-11_JPRB, &
  & 0.12091847E-11_JPRB, 0.11127001E-11_JPRB, 0.10018431E-11_JPRB, 0.91302823E-12_JPRB, 0.81496084E-12_JPRB, 0.74575350E-12_JPRB, &
  & 0.69584339E-12_JPRB, 0.64274584E-12_JPRB, 0.59605446E-12_JPRB, 0.56622556E-12_JPRB, 0.53730181E-12_JPRB, 0.50482372E-12_JPRB, &
  & 0.46127127E-12_JPRB, 0.41536869E-12_JPRB, 0.36852756E-12_JPRB, 0.32282678E-12_JPRB, 0.27653848E-12_JPRB, 0.23301055E-12_JPRB, &
  & 0.19037105E-12_JPRB, 0.15328692E-12_JPRB, 0.11992673E-12_JPRB, 0.92774096E-13_JPRB, 0.71619238E-13_JPRB, 0.57004098E-13_JPRB, &
  & 0.47934963E-13_JPRB, 0.43079235E-13_JPRB, 0.41413785E-13_JPRB, 0.41825897E-13_JPRB, 0.43492743E-13_JPRB, 0.45702191E-13_JPRB, &
  & 0.48053833E-13_JPRB, 0.49868289E-13_JPRB, 0.51928439E-13_JPRB, 0.53565127E-13_JPRB /)

RGHG6(:,12,11) = (/ &
  & 0.41455164E-12_JPRB, 0.42790375E-12_JPRB, 0.44502154E-12_JPRB, 0.47077771E-12_JPRB, 0.50521458E-12_JPRB, 0.54833763E-12_JPRB, &
  & 0.59998978E-12_JPRB, 0.65994345E-12_JPRB, 0.72883344E-12_JPRB, 0.80420317E-12_JPRB, 0.89041719E-12_JPRB, 0.99777847E-12_JPRB, &
  & 0.11427619E-11_JPRB, 0.13220027E-11_JPRB, 0.14952058E-11_JPRB, 0.17167587E-11_JPRB, 0.20141473E-11_JPRB, 0.23662975E-11_JPRB, &
  & 0.27362819E-11_JPRB, 0.31262454E-11_JPRB, 0.35327132E-11_JPRB, 0.39367871E-11_JPRB, 0.43021433E-11_JPRB, 0.45753670E-11_JPRB, &
  & 0.47129388E-11_JPRB, 0.46966350E-11_JPRB, 0.45383458E-11_JPRB, 0.42607922E-11_JPRB, 0.38932061E-11_JPRB, 0.35150825E-11_JPRB, &
  & 0.31270624E-11_JPRB, 0.27967763E-11_JPRB, 0.25215728E-11_JPRB, 0.23250256E-11_JPRB, 0.21566158E-11_JPRB, 0.19934714E-11_JPRB, &
  & 0.18969570E-11_JPRB, 0.18673767E-11_JPRB, 0.18543240E-11_JPRB, 0.18380469E-11_JPRB, 0.18189508E-11_JPRB, 0.18162048E-11_JPRB, &
  & 0.18071430E-11_JPRB, 0.17664175E-11_JPRB, 0.16856218E-11_JPRB, 0.15741143E-11_JPRB, 0.14308677E-11_JPRB, 0.12688499E-11_JPRB, &
  & 0.10923009E-11_JPRB, 0.91888541E-12_JPRB, 0.75466944E-12_JPRB, 0.61139874E-12_JPRB, 0.49556149E-12_JPRB, 0.40926092E-12_JPRB, &
  & 0.35095529E-12_JPRB, 0.31380023E-12_JPRB, 0.29351706E-12_JPRB, 0.28423742E-12_JPRB, 0.28203373E-12_JPRB, 0.28365515E-12_JPRB, &
  & 0.28644407E-12_JPRB, 0.28920494E-12_JPRB, 0.29018021E-12_JPRB, 0.28693909E-12_JPRB /)

RGHG6(:,13,11) = (/ &
  & 0.14056800E-11_JPRB, 0.14113398E-11_JPRB, 0.14683286E-11_JPRB, 0.15580051E-11_JPRB, 0.16778952E-11_JPRB, 0.18289840E-11_JPRB, &
  & 0.20127524E-11_JPRB, 0.22302299E-11_JPRB, 0.24833664E-11_JPRB, 0.27624136E-11_JPRB, 0.30707674E-11_JPRB, 0.34170861E-11_JPRB, &
  & 0.38237694E-11_JPRB, 0.43446436E-11_JPRB, 0.49663581E-11_JPRB, 0.56656316E-11_JPRB, 0.64908998E-11_JPRB, 0.74670608E-11_JPRB, &
  & 0.85435331E-11_JPRB, 0.96364687E-11_JPRB, 0.10663893E-10_JPRB, 0.11590996E-10_JPRB, 0.12328824E-10_JPRB, 0.12763404E-10_JPRB, &
  & 0.12811168E-10_JPRB, 0.12439320E-10_JPRB, 0.11719528E-10_JPRB, 0.10727830E-10_JPRB, 0.95985069E-11_JPRB, 0.83871217E-11_JPRB, &
  & 0.73111552E-11_JPRB, 0.63714624E-11_JPRB, 0.56682714E-11_JPRB, 0.51860456E-11_JPRB, 0.50052189E-11_JPRB, 0.50235202E-11_JPRB, &
  & 0.50915153E-11_JPRB, 0.51555843E-11_JPRB, 0.52282059E-11_JPRB, 0.53538480E-11_JPRB, 0.54927022E-11_JPRB, 0.56428594E-11_JPRB, &
  & 0.57865965E-11_JPRB, 0.58285117E-11_JPRB, 0.57149901E-11_JPRB, 0.54627492E-11_JPRB, 0.50890785E-11_JPRB, 0.46189194E-11_JPRB, &
  & 0.40889158E-11_JPRB, 0.35483587E-11_JPRB, 0.30278306E-11_JPRB, 0.25567048E-11_JPRB, 0.21564653E-11_JPRB, 0.18351364E-11_JPRB, &
  & 0.15936889E-11_JPRB, 0.14187009E-11_JPRB, 0.12987922E-11_JPRB, 0.12181807E-11_JPRB, 0.11656816E-11_JPRB, 0.11317623E-11_JPRB, &
  & 0.11081957E-11_JPRB, 0.10907825E-11_JPRB, 0.10676171E-11_JPRB, 0.10312760E-11_JPRB /)

RGHG6(:,14,11) = (/ &
  & 0.37585655E-11_JPRB, 0.38236601E-11_JPRB, 0.40099851E-11_JPRB, 0.42704802E-11_JPRB, 0.46042146E-11_JPRB, 0.50179956E-11_JPRB, &
  & 0.55196420E-11_JPRB, 0.61152285E-11_JPRB, 0.68118623E-11_JPRB, 0.75867038E-11_JPRB, 0.84441672E-11_JPRB, 0.93871690E-11_JPRB, &
  & 0.10423723E-10_JPRB, 0.11625455E-10_JPRB, 0.13069801E-10_JPRB, 0.14775360E-10_JPRB, 0.16715306E-10_JPRB, 0.18886811E-10_JPRB, &
  & 0.21203548E-10_JPRB, 0.23502663E-10_JPRB, 0.25554307E-10_JPRB, 0.27245234E-10_JPRB, 0.28396679E-10_JPRB, 0.28834502E-10_JPRB, &
  & 0.28430130E-10_JPRB, 0.27146601E-10_JPRB, 0.25160062E-10_JPRB, 0.22679707E-10_JPRB, 0.19979329E-10_JPRB, 0.17449667E-10_JPRB, &
  & 0.15184954E-10_JPRB, 0.13496678E-10_JPRB, 0.12297477E-10_JPRB, 0.11739696E-10_JPRB, 0.11656695E-10_JPRB, 0.11876869E-10_JPRB, &
  & 0.12271306E-10_JPRB, 0.12749525E-10_JPRB, 0.13250496E-10_JPRB, 0.13782163E-10_JPRB, 0.14296633E-10_JPRB, 0.14738336E-10_JPRB, &
  & 0.15102645E-10_JPRB, 0.15251755E-10_JPRB, 0.15035471E-10_JPRB, 0.14509454E-10_JPRB, 0.13708730E-10_JPRB, 0.12658989E-10_JPRB, &
  & 0.11442219E-10_JPRB, 0.10158870E-10_JPRB, 0.88838815E-11_JPRB, 0.76860011E-11_JPRB, 0.66225688E-11_JPRB, 0.57210699E-11_JPRB, &
  & 0.49915944E-11_JPRB, 0.44202367E-11_JPRB, 0.39855775E-11_JPRB, 0.36592309E-11_JPRB, 0.34182761E-11_JPRB, 0.32424107E-11_JPRB, &
  & 0.31149345E-11_JPRB, 0.30113047E-11_JPRB, 0.29171908E-11_JPRB, 0.27447194E-11_JPRB /)

RGHG6(:,15,11) = (/ &
  & 0.82628314E-11_JPRB, 0.86525119E-11_JPRB, 0.91492838E-11_JPRB, 0.97671142E-11_JPRB, 0.10525738E-10_JPRB, 0.11448093E-10_JPRB, &
  & 0.12555015E-10_JPRB, 0.13862208E-10_JPRB, 0.15381725E-10_JPRB, 0.17070467E-10_JPRB, 0.18928491E-10_JPRB, 0.20952167E-10_JPRB, &
  & 0.23131606E-10_JPRB, 0.25526584E-10_JPRB, 0.28219111E-10_JPRB, 0.31339292E-10_JPRB, 0.34850883E-10_JPRB, 0.38731490E-10_JPRB, &
  & 0.42737900E-10_JPRB, 0.46571653E-10_JPRB, 0.49835452E-10_JPRB, 0.52308994E-10_JPRB, 0.53687804E-10_JPRB, 0.53767678E-10_JPRB, &
  & 0.52386304E-10_JPRB, 0.49563020E-10_JPRB, 0.45714935E-10_JPRB, 0.41157511E-10_JPRB, 0.36391563E-10_JPRB, 0.31817361E-10_JPRB, &
  & 0.28016275E-10_JPRB, 0.25138584E-10_JPRB, 0.23554169E-10_JPRB, 0.23158786E-10_JPRB, 0.23725646E-10_JPRB, 0.24941965E-10_JPRB, &
  & 0.26447271E-10_JPRB, 0.27970152E-10_JPRB, 0.29357676E-10_JPRB, 0.30597580E-10_JPRB, 0.31649565E-10_JPRB, 0.32459327E-10_JPRB, &
  & 0.32935099E-10_JPRB, 0.32940480E-10_JPRB, 0.32413437E-10_JPRB, 0.31413604E-10_JPRB, 0.29965461E-10_JPRB, 0.28100574E-10_JPRB, &
  & 0.25899317E-10_JPRB, 0.23508143E-10_JPRB, 0.21054790E-10_JPRB, 0.18661394E-10_JPRB, 0.16426251E-10_JPRB, 0.14431085E-10_JPRB, &
  & 0.12719551E-10_JPRB, 0.11299454E-10_JPRB, 0.10149931E-10_JPRB, 0.92399352E-11_JPRB, 0.85332921E-11_JPRB, 0.79925675E-11_JPRB, &
  & 0.75923989E-11_JPRB, 0.72675017E-11_JPRB, 0.69622559E-11_JPRB, 0.64779787E-11_JPRB /)

RGHG6(:,16,11) = (/ &
  & 0.15881329E-10_JPRB, 0.16916912E-10_JPRB, 0.17935447E-10_JPRB, 0.19127170E-10_JPRB, 0.20557138E-10_JPRB, 0.22273516E-10_JPRB, &
  & 0.24312748E-10_JPRB, 0.26699819E-10_JPRB, 0.29442681E-10_JPRB, 0.32461353E-10_JPRB, 0.35736865E-10_JPRB, 0.39244961E-10_JPRB, &
  & 0.42962300E-10_JPRB, 0.46952428E-10_JPRB, 0.51259951E-10_JPRB, 0.56044950E-10_JPRB, 0.61281688E-10_JPRB, 0.66908874E-10_JPRB, &
  & 0.72605082E-10_JPRB, 0.77926852E-10_JPRB, 0.82328866E-10_JPRB, 0.85437137E-10_JPRB, 0.86813286E-10_JPRB, 0.86224264E-10_JPRB, &
  & 0.83575896E-10_JPRB, 0.78954912E-10_JPRB, 0.72938468E-10_JPRB, 0.66157815E-10_JPRB, 0.59147250E-10_JPRB, 0.52855949E-10_JPRB, &
  & 0.47747414E-10_JPRB, 0.44361119E-10_JPRB, 0.42673615E-10_JPRB, 0.42831350E-10_JPRB, 0.44598544E-10_JPRB, 0.47394973E-10_JPRB, &
  & 0.50594376E-10_JPRB, 0.53646126E-10_JPRB, 0.56260781E-10_JPRB, 0.58386879E-10_JPRB, 0.59951398E-10_JPRB, 0.60883000E-10_JPRB, &
  & 0.61122052E-10_JPRB, 0.60673570E-10_JPRB, 0.59572958E-10_JPRB, 0.57894564E-10_JPRB, 0.55654883E-10_JPRB, 0.52880349E-10_JPRB, &
  & 0.49635390E-10_JPRB, 0.46021364E-10_JPRB, 0.42151303E-10_JPRB, 0.38201081E-10_JPRB, 0.34345152E-10_JPRB, 0.30730755E-10_JPRB, &
  & 0.27472746E-10_JPRB, 0.24631205E-10_JPRB, 0.22230717E-10_JPRB, 0.20252000E-10_JPRB, 0.18665673E-10_JPRB, 0.17430203E-10_JPRB, &
  & 0.16464743E-10_JPRB, 0.15741748E-10_JPRB, 0.14970601E-10_JPRB, 0.13931453E-10_JPRB /)

RGHG6(:,17,11) = (/ &
  & 0.27286194E-10_JPRB, 0.29155324E-10_JPRB, 0.30844251E-10_JPRB, 0.32768885E-10_JPRB, 0.35057134E-10_JPRB, 0.37783283E-10_JPRB, &
  & 0.41003204E-10_JPRB, 0.44734348E-10_JPRB, 0.48969301E-10_JPRB, 0.53575352E-10_JPRB, 0.58488672E-10_JPRB, 0.63647532E-10_JPRB, &
  & 0.69006106E-10_JPRB, 0.74649488E-10_JPRB, 0.80613835E-10_JPRB, 0.87033297E-10_JPRB, 0.93907375E-10_JPRB, 0.10113956E-09_JPRB, &
  & 0.10828534E-09_JPRB, 0.11480174E-09_JPRB, 0.12005780E-09_JPRB, 0.12361528E-09_JPRB, 0.12491717E-09_JPRB, 0.12366641E-09_JPRB, &
  & 0.11985084E-09_JPRB, 0.11367693E-09_JPRB, 0.10593938E-09_JPRB, 0.97451318E-10_JPRB, 0.89178588E-10_JPRB, 0.81895123E-10_JPRB, &
  & 0.76253691E-10_JPRB, 0.72724063E-10_JPRB, 0.71596638E-10_JPRB, 0.72829381E-10_JPRB, 0.75985281E-10_JPRB, 0.80461991E-10_JPRB, &
  & 0.85367859E-10_JPRB, 0.90002950E-10_JPRB, 0.93834079E-10_JPRB, 0.96730401E-10_JPRB, 0.98558002E-10_JPRB, 0.99322300E-10_JPRB, &
  & 0.99102386E-10_JPRB, 0.98026420E-10_JPRB, 0.96213808E-10_JPRB, 0.93797851E-10_JPRB, 0.90815383E-10_JPRB, 0.87273820E-10_JPRB, &
  & 0.83152082E-10_JPRB, 0.78456713E-10_JPRB, 0.73266400E-10_JPRB, 0.67741875E-10_JPRB, 0.62087738E-10_JPRB, 0.56532598E-10_JPRB, &
  & 0.51309786E-10_JPRB, 0.46573630E-10_JPRB, 0.42424095E-10_JPRB, 0.38902360E-10_JPRB, 0.35998298E-10_JPRB, 0.33684281E-10_JPRB, &
  & 0.31909930E-10_JPRB, 0.30447964E-10_JPRB, 0.29140218E-10_JPRB, 0.26943005E-10_JPRB /)

RGHG6(:,18,11) = (/ &
  & 0.41816064E-10_JPRB, 0.44717206E-10_JPRB, 0.47140819E-10_JPRB, 0.49857309E-10_JPRB, 0.53061770E-10_JPRB, 0.56875577E-10_JPRB, &
  & 0.61349308E-10_JPRB, 0.66506869E-10_JPRB, 0.72292491E-10_JPRB, 0.78529919E-10_JPRB, 0.85103286E-10_JPRB, 0.91899398E-10_JPRB, &
  & 0.98844072E-10_JPRB, 0.10602105E-09_JPRB, 0.11348567E-09_JPRB, 0.12135086E-09_JPRB, 0.12955753E-09_JPRB, 0.13803031E-09_JPRB, &
  & 0.14629598E-09_JPRB, 0.15372184E-09_JPRB, 0.15963508E-09_JPRB, 0.16356067E-09_JPRB, 0.16491100E-09_JPRB, 0.16333584E-09_JPRB, &
  & 0.15892504E-09_JPRB, 0.15208211E-09_JPRB, 0.14377036E-09_JPRB, 0.13492506E-09_JPRB, 0.12645884E-09_JPRB, 0.11939416E-09_JPRB, &
  & 0.11407540E-09_JPRB, 0.11129822E-09_JPRB, 0.11099550E-09_JPRB, 0.11316541E-09_JPRB, 0.11728897E-09_JPRB, 0.12273747E-09_JPRB, &
  & 0.12875447E-09_JPRB, 0.13435446E-09_JPRB, 0.13898876E-09_JPRB, 0.14224139E-09_JPRB, 0.14411511E-09_JPRB, 0.14459062E-09_JPRB, &
  & 0.14389277E-09_JPRB, 0.14222808E-09_JPRB, 0.13981646E-09_JPRB, 0.13683936E-09_JPRB, 0.13335576E-09_JPRB, 0.12932733E-09_JPRB, &
  & 0.12463755E-09_JPRB, 0.11921637E-09_JPRB, 0.11305871E-09_JPRB, 0.10626774E-09_JPRB, 0.99053474E-10_JPRB, 0.91706101E-10_JPRB, &
  & 0.84519038E-10_JPRB, 0.77781372E-10_JPRB, 0.71703719E-10_JPRB, 0.66391850E-10_JPRB, 0.61912697E-10_JPRB, 0.58262950E-10_JPRB, &
  & 0.55403356E-10_JPRB, 0.53092569E-10_JPRB, 0.50900242E-10_JPRB, 0.47393155E-10_JPRB /)

RGHG6(:,19,11) = (/ &
  & 0.58184249E-10_JPRB, 0.62163004E-10_JPRB, 0.65375934E-10_JPRB, 0.68872456E-10_JPRB, 0.72978013E-10_JPRB, 0.77820667E-10_JPRB, &
  & 0.83485954E-10_JPRB, 0.89941984E-10_JPRB, 0.97120881E-10_JPRB, 0.10480132E-09_JPRB, 0.11283258E-09_JPRB, 0.12107004E-09_JPRB, &
  & 0.12941442E-09_JPRB, 0.13794058E-09_JPRB, 0.14668752E-09_JPRB, 0.15576998E-09_JPRB, 0.16510306E-09_JPRB, 0.17456975E-09_JPRB, &
  & 0.18369256E-09_JPRB, 0.19185212E-09_JPRB, 0.19835916E-09_JPRB, 0.20276758E-09_JPRB, 0.20450099E-09_JPRB, 0.20327083E-09_JPRB, &
  & 0.19917451E-09_JPRB, 0.19273905E-09_JPRB, 0.18510138E-09_JPRB, 0.17719978E-09_JPRB, 0.17011072E-09_JPRB, 0.16426815E-09_JPRB, &
  & 0.16049428E-09_JPRB, 0.15881431E-09_JPRB, 0.15926042E-09_JPRB, 0.16178503E-09_JPRB, 0.16600968E-09_JPRB, 0.17133645E-09_JPRB, &
  & 0.17717908E-09_JPRB, 0.18277624E-09_JPRB, 0.18749123E-09_JPRB, 0.19080938E-09_JPRB, 0.19252641E-09_JPRB, 0.19272905E-09_JPRB, &
  & 0.19161496E-09_JPRB, 0.18951410E-09_JPRB, 0.18666863E-09_JPRB, 0.18331042E-09_JPRB, 0.17948573E-09_JPRB, 0.17512612E-09_JPRB, &
  & 0.17009111E-09_JPRB, 0.16427326E-09_JPRB, 0.15760328E-09_JPRB, 0.15012452E-09_JPRB, 0.14199339E-09_JPRB, 0.13347279E-09_JPRB, &
  & 0.12489282E-09_JPRB, 0.11661674E-09_JPRB, 0.10892887E-09_JPRB, 0.10204847E-09_JPRB, 0.96087784E-10_JPRB, 0.91135266E-10_JPRB, &
  & 0.87089946E-10_JPRB, 0.83914355E-10_JPRB, 0.80600221E-10_JPRB, 0.75778883E-10_JPRB /)

RGHG6(:,20,11) = (/ &
  & 0.75565797E-10_JPRB, 0.80570453E-10_JPRB, 0.84399460E-10_JPRB, 0.88591370E-10_JPRB, 0.93462599E-10_JPRB, 0.99218342E-10_JPRB, &
  & 0.10588075E-09_JPRB, 0.11343389E-09_JPRB, 0.12172392E-09_JPRB, 0.13053164E-09_JPRB, 0.13970258E-09_JPRB, 0.14908297E-09_JPRB, &
  & 0.15855883E-09_JPRB, 0.16819041E-09_JPRB, 0.17802837E-09_JPRB, 0.18813495E-09_JPRB, 0.19839136E-09_JPRB, 0.20866310E-09_JPRB, &
  & 0.21854468E-09_JPRB, 0.22744154E-09_JPRB, 0.23468918E-09_JPRB, 0.23985944E-09_JPRB, 0.24241648E-09_JPRB, 0.24214497E-09_JPRB, &
  & 0.23925184E-09_JPRB, 0.23437538E-09_JPRB, 0.22859051E-09_JPRB, 0.22280228E-09_JPRB, 0.21782437E-09_JPRB, 0.21415798E-09_JPRB, &
  & 0.21199616E-09_JPRB, 0.21139895E-09_JPRB, 0.21216837E-09_JPRB, 0.21427804E-09_JPRB, 0.21754644E-09_JPRB, 0.22176781E-09_JPRB, &
  & 0.22660154E-09_JPRB, 0.23136346E-09_JPRB, 0.23537822E-09_JPRB, 0.23848379E-09_JPRB, 0.23993693E-09_JPRB, 0.23994015E-09_JPRB, &
  & 0.23856159E-09_JPRB, 0.23616836E-09_JPRB, 0.23301558E-09_JPRB, 0.22933550E-09_JPRB, 0.22520186E-09_JPRB, 0.22056321E-09_JPRB, &
  & 0.21530720E-09_JPRB, 0.20932600E-09_JPRB, 0.20252794E-09_JPRB, 0.19490515E-09_JPRB, 0.18655372E-09_JPRB, 0.17764420E-09_JPRB, &
  & 0.16849223E-09_JPRB, 0.15944460E-09_JPRB, 0.15087262E-09_JPRB, 0.14299847E-09_JPRB, 0.13601785E-09_JPRB, 0.13002374E-09_JPRB, &
  & 0.12516525E-09_JPRB, 0.12081347E-09_JPRB, 0.11704798E-09_JPRB, 0.10980756E-09_JPRB /)

RGHG6(:,21,11) = (/ &
  & 0.93167488E-10_JPRB, 0.98984744E-10_JPRB, 0.10345043E-09_JPRB, 0.10818771E-09_JPRB, 0.11370033E-09_JPRB, 0.12013299E-09_JPRB, &
  & 0.12756139E-09_JPRB, 0.13588010E-09_JPRB, 0.14495959E-09_JPRB, 0.15456633E-09_JPRB, 0.16454850E-09_JPRB, 0.17477263E-09_JPRB, &
  & 0.18513335E-09_JPRB, 0.19564317E-09_JPRB, 0.20634555E-09_JPRB, 0.21731301E-09_JPRB, 0.22842016E-09_JPRB, 0.23945976E-09_JPRB, &
  & 0.25003979E-09_JPRB, 0.25970603E-09_JPRB, 0.26788610E-09_JPRB, 0.27413646E-09_JPRB, 0.27800695E-09_JPRB, 0.27932781E-09_JPRB, &
  & 0.27832359E-09_JPRB, 0.27565047E-09_JPRB, 0.27232572E-09_JPRB, 0.26910452E-09_JPRB, 0.26651029E-09_JPRB, 0.26487965E-09_JPRB, &
  & 0.26415836E-09_JPRB, 0.26413577E-09_JPRB, 0.26460673E-09_JPRB, 0.26572208E-09_JPRB, 0.26749747E-09_JPRB, 0.27003522E-09_JPRB, &
  & 0.27335006E-09_JPRB, 0.27686306E-09_JPRB, 0.28025954E-09_JPRB, 0.28266514E-09_JPRB, 0.28399255E-09_JPRB, 0.28374714E-09_JPRB, &
  & 0.28225347E-09_JPRB, 0.27968822E-09_JPRB, 0.27624153E-09_JPRB, 0.27226232E-09_JPRB, 0.26783484E-09_JPRB, 0.26292457E-09_JPRB, &
  & 0.25749528E-09_JPRB, 0.25145774E-09_JPRB, 0.24473260E-09_JPRB, 0.23730340E-09_JPRB, 0.22917968E-09_JPRB, 0.22048835E-09_JPRB, &
  & 0.21145190E-09_JPRB, 0.20240423E-09_JPRB, 0.19363702E-09_JPRB, 0.18542423E-09_JPRB, 0.17795446E-09_JPRB, 0.17138893E-09_JPRB, &
  & 0.16565058E-09_JPRB, 0.16097092E-09_JPRB, 0.15552490E-09_JPRB, 0.14792750E-09_JPRB /)

RGHG6(:,22,11) = (/ &
  & 0.11030311E-09_JPRB, 0.11701720E-09_JPRB, 0.12194480E-09_JPRB, 0.12720328E-09_JPRB, 0.13318414E-09_JPRB, 0.14012423E-09_JPRB, &
  & 0.14802058E-09_JPRB, 0.15683006E-09_JPRB, 0.16638531E-09_JPRB, 0.17649175E-09_JPRB, 0.18701975E-09_JPRB, 0.19784716E-09_JPRB, &
  & 0.20888476E-09_JPRB, 0.22011130E-09_JPRB, 0.23153886E-09_JPRB, 0.24318081E-09_JPRB, 0.25494398E-09_JPRB, 0.26667540E-09_JPRB, &
  & 0.27799543E-09_JPRB, 0.28849528E-09_JPRB, 0.29772579E-09_JPRB, 0.30531103E-09_JPRB, 0.31080871E-09_JPRB, 0.31404002E-09_JPRB, &
  & 0.31525402E-09_JPRB, 0.31504435E-09_JPRB, 0.31420380E-09_JPRB, 0.31333602E-09_JPRB, 0.31273362E-09_JPRB, 0.31254838E-09_JPRB, &
  & 0.31258324E-09_JPRB, 0.31259129E-09_JPRB, 0.31243272E-09_JPRB, 0.31240840E-09_JPRB, 0.31279540E-09_JPRB, 0.31377101E-09_JPRB, &
  & 0.31564062E-09_JPRB, 0.31803254E-09_JPRB, 0.32034578E-09_JPRB, 0.32229877E-09_JPRB, 0.32323713E-09_JPRB, 0.32292655E-09_JPRB, &
  & 0.32128181E-09_JPRB, 0.31858019E-09_JPRB, 0.31495531E-09_JPRB, 0.31065045E-09_JPRB, 0.30591629E-09_JPRB, 0.30076264E-09_JPRB, &
  & 0.29516556E-09_JPRB, 0.28911756E-09_JPRB, 0.28256048E-09_JPRB, 0.27547195E-09_JPRB, 0.26782696E-09_JPRB, 0.25968871E-09_JPRB, &
  & 0.25122759E-09_JPRB, 0.24265029E-09_JPRB, 0.23421090E-09_JPRB, 0.22611212E-09_JPRB, 0.21854878E-09_JPRB, 0.21166612E-09_JPRB, &
  & 0.20566504E-09_JPRB, 0.19992205E-09_JPRB, 0.19467795E-09_JPRB, 0.18453518E-09_JPRB /)

RGHG6(:,23,11) = (/ &
  & 0.12693807E-09_JPRB, 0.13424291E-09_JPRB, 0.13972733E-09_JPRB, 0.14535452E-09_JPRB, 0.15171987E-09_JPRB, 0.15897393E-09_JPRB, &
  & 0.16717203E-09_JPRB, 0.17622459E-09_JPRB, 0.18602737E-09_JPRB, 0.19642535E-09_JPRB, 0.20730208E-09_JPRB, 0.21854921E-09_JPRB, &
  & 0.23010566E-09_JPRB, 0.24191912E-09_JPRB, 0.25395458E-09_JPRB, 0.26617131E-09_JPRB, 0.27847674E-09_JPRB, 0.29074113E-09_JPRB, &
  & 0.30269109E-09_JPRB, 0.31399511E-09_JPRB, 0.32427216E-09_JPRB, 0.33316558E-09_JPRB, 0.34028677E-09_JPRB, 0.34546940E-09_JPRB, &
  & 0.34883668E-09_JPRB, 0.35081626E-09_JPRB, 0.35202008E-09_JPRB, 0.35289091E-09_JPRB, 0.35359762E-09_JPRB, 0.35414327E-09_JPRB, &
  & 0.35440478E-09_JPRB, 0.35421091E-09_JPRB, 0.35353429E-09_JPRB, 0.35264619E-09_JPRB, 0.35200834E-09_JPRB, 0.35184713E-09_JPRB, &
  & 0.35255698E-09_JPRB, 0.35386519E-09_JPRB, 0.35544079E-09_JPRB, 0.35682568E-09_JPRB, 0.35732051E-09_JPRB, 0.35681030E-09_JPRB, &
  & 0.35509617E-09_JPRB, 0.35223924E-09_JPRB, 0.34847103E-09_JPRB, 0.34396697E-09_JPRB, 0.33894937E-09_JPRB, 0.33356948E-09_JPRB, &
  & 0.32784489E-09_JPRB, 0.32183745E-09_JPRB, 0.31547878E-09_JPRB, 0.30874908E-09_JPRB, 0.30164360E-09_JPRB, 0.29420505E-09_JPRB, &
  & 0.28650285E-09_JPRB, 0.27864891E-09_JPRB, 0.27079528E-09_JPRB, 0.26308655E-09_JPRB, 0.25569713E-09_JPRB, 0.24877189E-09_JPRB, &
  & 0.24233554E-09_JPRB, 0.23655256E-09_JPRB, 0.22977426E-09_JPRB, 0.21938404E-09_JPRB /)

RGHG6(:,24,11) = (/ &
  & 0.14296625E-09_JPRB, 0.15089957E-09_JPRB, 0.15674717E-09_JPRB, 0.16272877E-09_JPRB, 0.16935828E-09_JPRB, 0.17684204E-09_JPRB, &
  & 0.18518979E-09_JPRB, 0.19436872E-09_JPRB, 0.20428007E-09_JPRB, 0.21481902E-09_JPRB, 0.22590357E-09_JPRB, 0.23742108E-09_JPRB, &
  & 0.24931288E-09_JPRB, 0.26153407E-09_JPRB, 0.27404173E-09_JPRB, 0.28673625E-09_JPRB, 0.29946548E-09_JPRB, 0.31209638E-09_JPRB, &
  & 0.32448894E-09_JPRB, 0.33641123E-09_JPRB, 0.34754644E-09_JPRB, 0.35757086E-09_JPRB, 0.36610845E-09_JPRB, 0.37291883E-09_JPRB, &
  & 0.37801920E-09_JPRB, 0.38171213E-09_JPRB, 0.38440470E-09_JPRB, 0.38640158E-09_JPRB, 0.38783943E-09_JPRB, 0.38874065E-09_JPRB, &
  & 0.38903394E-09_JPRB, 0.38864748E-09_JPRB, 0.38766837E-09_JPRB, 0.38631956E-09_JPRB, 0.38505743E-09_JPRB, 0.38426623E-09_JPRB, &
  & 0.38415704E-09_JPRB, 0.38466511E-09_JPRB, 0.38552414E-09_JPRB, 0.38626338E-09_JPRB, 0.38641335E-09_JPRB, 0.38562409E-09_JPRB, &
  & 0.38379006E-09_JPRB, 0.38081871E-09_JPRB, 0.37687964E-09_JPRB, 0.37221870E-09_JPRB, 0.36702000E-09_JPRB, 0.36150738E-09_JPRB, &
  & 0.35570458E-09_JPRB, 0.34971137E-09_JPRB, 0.34351905E-09_JPRB, 0.33714651E-09_JPRB, 0.33058078E-09_JPRB, 0.32383454E-09_JPRB, &
  & 0.31691255E-09_JPRB, 0.30984662E-09_JPRB, 0.30268424E-09_JPRB, 0.29551878E-09_JPRB, 0.28846611E-09_JPRB, 0.28165395E-09_JPRB, &
  & 0.27520880E-09_JPRB, 0.26880459E-09_JPRB, 0.26208924E-09_JPRB, 0.25009622E-09_JPRB /)

RGHG6(:,25,11) = (/ &
  & 0.15865222E-09_JPRB, 0.16716092E-09_JPRB, 0.17337549E-09_JPRB, 0.17960897E-09_JPRB, 0.18645679E-09_JPRB, 0.19408611E-09_JPRB, &
  & 0.20253145E-09_JPRB, 0.21174930E-09_JPRB, 0.22168539E-09_JPRB, 0.23226719E-09_JPRB, 0.24343647E-09_JPRB, 0.25509275E-09_JPRB, &
  & 0.26715757E-09_JPRB, 0.27956679E-09_JPRB, 0.29226593E-09_JPRB, 0.30516470E-09_JPRB, 0.31814706E-09_JPRB, 0.33107131E-09_JPRB, &
  & 0.34375008E-09_JPRB, 0.35604425E-09_JPRB, 0.36774550E-09_JPRB, 0.37855241E-09_JPRB, 0.38808046E-09_JPRB, 0.39605758E-09_JPRB, &
  & 0.40241888E-09_JPRB, 0.40730980E-09_JPRB, 0.41101686E-09_JPRB, 0.41374046E-09_JPRB, 0.41560638E-09_JPRB, 0.41667908E-09_JPRB, &
  & 0.41695949E-09_JPRB, 0.41649573E-09_JPRB, 0.41544179E-09_JPRB, 0.41403414E-09_JPRB, 0.41257764E-09_JPRB, 0.41148479E-09_JPRB, &
  & 0.41094206E-09_JPRB, 0.41088130E-09_JPRB, 0.41116160E-09_JPRB, 0.41132178E-09_JPRB, 0.41103101E-09_JPRB, 0.40992174E-09_JPRB, &
  & 0.40787604E-09_JPRB, 0.40479442E-09_JPRB, 0.40074516E-09_JPRB, 0.39595163E-09_JPRB, 0.39061912E-09_JPRB, 0.38498196E-09_JPRB, &
  & 0.37915834E-09_JPRB, 0.37323988E-09_JPRB, 0.36721856E-09_JPRB, 0.36114528E-09_JPRB, 0.35503872E-09_JPRB, 0.34889266E-09_JPRB, &
  & 0.34266928E-09_JPRB, 0.33632816E-09_JPRB, 0.32987230E-09_JPRB, 0.32332712E-09_JPRB, 0.31677713E-09_JPRB, 0.31031841E-09_JPRB, &
  & 0.30400008E-09_JPRB, 0.29770203E-09_JPRB, 0.29060140E-09_JPRB, 0.27797958E-09_JPRB /)

RGHG6(:,26,11) = (/ &
  & 0.17437421E-09_JPRB, 0.18354707E-09_JPRB, 0.19005401E-09_JPRB, 0.19652839E-09_JPRB, 0.20352969E-09_JPRB, 0.21126116E-09_JPRB, &
  & 0.21974267E-09_JPRB, 0.22894758E-09_JPRB, 0.23883193E-09_JPRB, 0.24937058E-09_JPRB, 0.26050487E-09_JPRB, 0.27216329E-09_JPRB, &
  & 0.28425903E-09_JPRB, 0.29670258E-09_JPRB, 0.30942565E-09_JPRB, 0.32231809E-09_JPRB, 0.33525829E-09_JPRB, 0.34816208E-09_JPRB, &
  & 0.36090658E-09_JPRB, 0.37332984E-09_JPRB, 0.38525921E-09_JPRB, 0.39643525E-09_JPRB, 0.40649062E-09_JPRB, 0.41514980E-09_JPRB, &
  & 0.42227583E-09_JPRB, 0.42793322E-09_JPRB, 0.43230411E-09_JPRB, 0.43551993E-09_JPRB, 0.43769158E-09_JPRB, 0.43891749E-09_JPRB, &
  & 0.43926993E-09_JPRB, 0.43888804E-09_JPRB, 0.43795559E-09_JPRB, 0.43672396E-09_JPRB, 0.43537518E-09_JPRB, 0.43421650E-09_JPRB, &
  & 0.43345136E-09_JPRB, 0.43304302E-09_JPRB, 0.43280909E-09_JPRB, 0.43249354E-09_JPRB, 0.43177101E-09_JPRB, 0.43034026E-09_JPRB, &
  & 0.42806680E-09_JPRB, 0.42485276E-09_JPRB, 0.42072354E-09_JPRB, 0.41584569E-09_JPRB, 0.41043621E-09_JPRB, 0.40472609E-09_JPRB, &
  & 0.39887477E-09_JPRB, 0.39298176E-09_JPRB, 0.38711775E-09_JPRB, 0.38134079E-09_JPRB, 0.37564563E-09_JPRB, 0.37000519E-09_JPRB, &
  & 0.36435777E-09_JPRB, 0.35864958E-09_JPRB, 0.35285186E-09_JPRB, 0.34696743E-09_JPRB, 0.34104480E-09_JPRB, 0.33513226E-09_JPRB, &
  & 0.32926847E-09_JPRB, 0.32334935E-09_JPRB, 0.31631667E-09_JPRB, 0.30425337E-09_JPRB /)

RGHG6(:,27,11) = (/ &
  & 0.19060453E-09_JPRB, 0.20055502E-09_JPRB, 0.20736797E-09_JPRB, 0.21400792E-09_JPRB, 0.22112157E-09_JPRB, 0.22888039E-09_JPRB, &
  & 0.23732791E-09_JPRB, 0.24643890E-09_JPRB, 0.25619165E-09_JPRB, 0.26655411E-09_JPRB, 0.27752406E-09_JPRB, 0.28901917E-09_JPRB, &
  & 0.30093567E-09_JPRB, 0.31326902E-09_JPRB, 0.32584976E-09_JPRB, 0.33863753E-09_JPRB, 0.35140407E-09_JPRB, 0.36410874E-09_JPRB, &
  & 0.37663989E-09_JPRB, 0.38886511E-09_JPRB, 0.40064252E-09_JPRB, 0.41179082E-09_JPRB, 0.42194320E-09_JPRB, 0.43086315E-09_JPRB, &
  & 0.43836523E-09_JPRB, 0.44443796E-09_JPRB, 0.44921655E-09_JPRB, 0.45277315E-09_JPRB, 0.45520368E-09_JPRB, 0.45661225E-09_JPRB, &
  & 0.45712434E-09_JPRB, 0.45693382E-09_JPRB, 0.45623791E-09_JPRB, 0.45527426E-09_JPRB, 0.45418738E-09_JPRB, 0.45312906E-09_JPRB, &
  & 0.45228771E-09_JPRB, 0.45164311E-09_JPRB, 0.45102513E-09_JPRB, 0.45029203E-09_JPRB, 0.44918005E-09_JPRB, 0.44746182E-09_JPRB, &
  & 0.44498930E-09_JPRB, 0.44166126E-09_JPRB, 0.43747905E-09_JPRB, 0.43257645E-09_JPRB, 0.42716847E-09_JPRB, 0.42149165E-09_JPRB, &
  & 0.41567974E-09_JPRB, 0.40984705E-09_JPRB, 0.40410023E-09_JPRB, 0.39852244E-09_JPRB, 0.39313389E-09_JPRB, 0.38788645E-09_JPRB, &
  & 0.38271294E-09_JPRB, 0.37754938E-09_JPRB, 0.37235284E-09_JPRB, 0.36711087E-09_JPRB, 0.36184608E-09_JPRB, 0.35661743E-09_JPRB, &
  & 0.35143544E-09_JPRB, 0.34605238E-09_JPRB, 0.34004227E-09_JPRB, 0.32856173E-09_JPRB /)

RGHG6(:,28,11) = (/ &
  & 0.20778637E-09_JPRB, 0.21855784E-09_JPRB, 0.22563458E-09_JPRB, 0.23243821E-09_JPRB, 0.23955712E-09_JPRB, 0.24726829E-09_JPRB, &
  & 0.25559216E-09_JPRB, 0.26451788E-09_JPRB, 0.27400990E-09_JPRB, 0.28409508E-09_JPRB, 0.29473235E-09_JPRB, 0.30588415E-09_JPRB, &
  & 0.31747233E-09_JPRB, 0.32947836E-09_JPRB, 0.34170400E-09_JPRB, 0.35416753E-09_JPRB, 0.36660347E-09_JPRB, 0.37898104E-09_JPRB, &
  & 0.39114545E-09_JPRB, 0.40298154E-09_JPRB, 0.41438614E-09_JPRB, 0.42521350E-09_JPRB, 0.43516857E-09_JPRB, 0.44402121E-09_JPRB, &
  & 0.45158693E-09_JPRB, 0.45781143E-09_JPRB, 0.46279794E-09_JPRB, 0.46657589E-09_JPRB, 0.46922310E-09_JPRB, 0.47082627E-09_JPRB, &
  & 0.47154336E-09_JPRB, 0.47159177E-09_JPRB, 0.47117349E-09_JPRB, 0.47050291E-09_JPRB, 0.46969484E-09_JPRB, 0.46881271E-09_JPRB, &
  & 0.46797233E-09_JPRB, 0.46718041E-09_JPRB, 0.46629656E-09_JPRB, 0.46523019E-09_JPRB, 0.46379700E-09_JPRB, 0.46182486E-09_JPRB, &
  & 0.45918275E-09_JPRB, 0.45577123E-09_JPRB, 0.45155885E-09_JPRB, 0.44665269E-09_JPRB, 0.44123849E-09_JPRB, 0.43550125E-09_JPRB, &
  & 0.42966919E-09_JPRB, 0.42394413E-09_JPRB, 0.41844589E-09_JPRB, 0.41317394E-09_JPRB, 0.40810585E-09_JPRB, 0.40322023E-09_JPRB, &
  & 0.39845630E-09_JPRB, 0.39375142E-09_JPRB, 0.38906842E-09_JPRB, 0.38439077E-09_JPRB, 0.37974801E-09_JPRB, 0.37516179E-09_JPRB, &
  & 0.37064785E-09_JPRB, 0.36609954E-09_JPRB, 0.36063377E-09_JPRB, 0.35109499E-09_JPRB /)

RGHG6(:,29,11) = (/ &
  & 0.22617340E-09_JPRB, 0.23763169E-09_JPRB, 0.24502983E-09_JPRB, 0.25184016E-09_JPRB, 0.25893473E-09_JPRB, 0.26648406E-09_JPRB, &
  & 0.27459146E-09_JPRB, 0.28321889E-09_JPRB, 0.29236882E-09_JPRB, 0.30202207E-09_JPRB, 0.31222158E-09_JPRB, 0.32288144E-09_JPRB, &
  & 0.33402989E-09_JPRB, 0.34550757E-09_JPRB, 0.35728678E-09_JPRB, 0.36928482E-09_JPRB, 0.38127212E-09_JPRB, 0.39314679E-09_JPRB, &
  & 0.40478770E-09_JPRB, 0.41608716E-09_JPRB, 0.42695633E-09_JPRB, 0.43727733E-09_JPRB, 0.44682105E-09_JPRB, 0.45537379E-09_JPRB, &
  & 0.46277993E-09_JPRB, 0.46894261E-09_JPRB, 0.47395410E-09_JPRB, 0.47783349E-09_JPRB, 0.48062809E-09_JPRB, 0.48240700E-09_JPRB, &
  & 0.48332777E-09_JPRB, 0.48361098E-09_JPRB, 0.48345539E-09_JPRB, 0.48305304E-09_JPRB, 0.48248650E-09_JPRB, 0.48178106E-09_JPRB, &
  & 0.48098342E-09_JPRB, 0.48010840E-09_JPRB, 0.47904786E-09_JPRB, 0.47774162E-09_JPRB, 0.47606313E-09_JPRB, 0.47389265E-09_JPRB, &
  & 0.47111831E-09_JPRB, 0.46765225E-09_JPRB, 0.46345472E-09_JPRB, 0.45859641E-09_JPRB, 0.45322579E-09_JPRB, 0.44759119E-09_JPRB, &
  & 0.44195403E-09_JPRB, 0.43643456E-09_JPRB, 0.43106760E-09_JPRB, 0.42593618E-09_JPRB, 0.42110787E-09_JPRB, 0.41651910E-09_JPRB, &
  & 0.41209211E-09_JPRB, 0.40776432E-09_JPRB, 0.40349374E-09_JPRB, 0.39927500E-09_JPRB, 0.39512615E-09_JPRB, 0.39109896E-09_JPRB, &
  & 0.38717002E-09_JPRB, 0.38318107E-09_JPRB, 0.37869716E-09_JPRB, 0.37045170E-09_JPRB /)

RGHG6(:,30,11) = (/ &
  & 0.24557256E-09_JPRB, 0.25780747E-09_JPRB, 0.26525457E-09_JPRB, 0.27212493E-09_JPRB, 0.27903019E-09_JPRB, 0.28636327E-09_JPRB, &
  & 0.29414882E-09_JPRB, 0.30240041E-09_JPRB, 0.31107761E-09_JPRB, 0.32023476E-09_JPRB, 0.32986233E-09_JPRB, 0.33994821E-09_JPRB, &
  & 0.35052175E-09_JPRB, 0.36139358E-09_JPRB, 0.37262024E-09_JPRB, 0.38408804E-09_JPRB, 0.39554587E-09_JPRB, 0.40685155E-09_JPRB, &
  & 0.41787551E-09_JPRB, 0.42852832E-09_JPRB, 0.43872905E-09_JPRB, 0.44839688E-09_JPRB, 0.45738016E-09_JPRB, 0.46548826E-09_JPRB, &
  & 0.47253679E-09_JPRB, 0.47847826E-09_JPRB, 0.48336152E-09_JPRB, 0.48722831E-09_JPRB, 0.49008880E-09_JPRB, 0.49199517E-09_JPRB, &
  & 0.49308552E-09_JPRB, 0.49356641E-09_JPRB, 0.49362942E-09_JPRB, 0.49344306E-09_JPRB, 0.49306231E-09_JPRB, 0.49249793E-09_JPRB, &
  & 0.49175414E-09_JPRB, 0.49083815E-09_JPRB, 0.48966775E-09_JPRB, 0.48820459E-09_JPRB, 0.48635967E-09_JPRB, 0.48405258E-09_JPRB, &
  & 0.48118881E-09_JPRB, 0.47770277E-09_JPRB, 0.47354215E-09_JPRB, 0.46875143E-09_JPRB, 0.46348436E-09_JPRB, 0.45797255E-09_JPRB, &
  & 0.45244858E-09_JPRB, 0.44702339E-09_JPRB, 0.44186882E-09_JPRB, 0.43706661E-09_JPRB, 0.43254925E-09_JPRB, 0.42824735E-09_JPRB, &
  & 0.42409587E-09_JPRB, 0.42004747E-09_JPRB, 0.41607637E-09_JPRB, 0.41217918E-09_JPRB, 0.40840054E-09_JPRB, 0.40476086E-09_JPRB, &
  & 0.40128306E-09_JPRB, 0.39781939E-09_JPRB, 0.39384718E-09_JPRB, 0.38687922E-09_JPRB /)

RGHG6(:,31,11) = (/ &
  & 0.26597399E-09_JPRB, 0.27849018E-09_JPRB, 0.28614369E-09_JPRB, 0.29282221E-09_JPRB, 0.29955624E-09_JPRB, 0.30656222E-09_JPRB, &
  & 0.31397440E-09_JPRB, 0.32175446E-09_JPRB, 0.32991376E-09_JPRB, 0.33846087E-09_JPRB, 0.34745232E-09_JPRB, 0.35688402E-09_JPRB, &
  & 0.36677092E-09_JPRB, 0.37698547E-09_JPRB, 0.38758816E-09_JPRB, 0.39843784E-09_JPRB, 0.40931467E-09_JPRB, 0.42002668E-09_JPRB, &
  & 0.43041753E-09_JPRB, 0.44036474E-09_JPRB, 0.44984150E-09_JPRB, 0.45880666E-09_JPRB, 0.46714804E-09_JPRB, 0.47469173E-09_JPRB, &
  & 0.48128174E-09_JPRB, 0.48685911E-09_JPRB, 0.49151089E-09_JPRB, 0.49524779E-09_JPRB, 0.49808613E-09_JPRB, 0.50005317E-09_JPRB, &
  & 0.50126103E-09_JPRB, 0.50188986E-09_JPRB, 0.50211546E-09_JPRB, 0.50208271E-09_JPRB, 0.50183036E-09_JPRB, 0.50135934E-09_JPRB, &
  & 0.50066473E-09_JPRB, 0.49972954E-09_JPRB, 0.49850224E-09_JPRB, 0.49694782E-09_JPRB, 0.49500543E-09_JPRB, 0.49261867E-09_JPRB, &
  & 0.48970950E-09_JPRB, 0.48622967E-09_JPRB, 0.48212706E-09_JPRB, 0.47744131E-09_JPRB, 0.47231818E-09_JPRB, 0.46700760E-09_JPRB, &
  & 0.46167661E-09_JPRB, 0.45652918E-09_JPRB, 0.45166057E-09_JPRB, 0.44707901E-09_JPRB, 0.44276896E-09_JPRB, 0.43867521E-09_JPRB, &
  & 0.43473933E-09_JPRB, 0.43090659E-09_JPRB, 0.42714524E-09_JPRB, 0.42347839E-09_JPRB, 0.41994414E-09_JPRB, 0.41660164E-09_JPRB, &
  & 0.41341947E-09_JPRB, 0.41030288E-09_JPRB, 0.40679979E-09_JPRB, 0.40069290E-09_JPRB /)

RGHG6(:,32,11) = (/ &
  & 0.28675051E-09_JPRB, 0.29960689E-09_JPRB, 0.30704633E-09_JPRB, 0.31362316E-09_JPRB, 0.32004988E-09_JPRB, 0.32671604E-09_JPRB, &
  & 0.33368691E-09_JPRB, 0.34096850E-09_JPRB, 0.34853148E-09_JPRB, 0.35643524E-09_JPRB, 0.36471001E-09_JPRB, 0.37341830E-09_JPRB, &
  & 0.38254477E-09_JPRB, 0.39207390E-09_JPRB, 0.40199624E-09_JPRB, 0.41219042E-09_JPRB, 0.42244139E-09_JPRB, 0.43253001E-09_JPRB, &
  & 0.44227183E-09_JPRB, 0.45155457E-09_JPRB, 0.46033510E-09_JPRB, 0.46859328E-09_JPRB, 0.47625970E-09_JPRB, 0.48318510E-09_JPRB, &
  & 0.48923965E-09_JPRB, 0.49439808E-09_JPRB, 0.49871240E-09_JPRB, 0.50223453E-09_JPRB, 0.50496390E-09_JPRB, 0.50692173E-09_JPRB, &
  & 0.50818894E-09_JPRB, 0.50890903E-09_JPRB, 0.50924065E-09_JPRB, 0.50930266E-09_JPRB, 0.50912563E-09_JPRB, 0.50871374E-09_JPRB, &
  & 0.50805438E-09_JPRB, 0.50711552E-09_JPRB, 0.50586940E-09_JPRB, 0.50427240E-09_JPRB, 0.50228777E-09_JPRB, 0.49986426E-09_JPRB, &
  & 0.49694676E-09_JPRB, 0.49349669E-09_JPRB, 0.48947274E-09_JPRB, 0.48492826E-09_JPRB, 0.48003007E-09_JPRB, 0.47494358E-09_JPRB, &
  & 0.46986837E-09_JPRB, 0.46496088E-09_JPRB, 0.46032272E-09_JPRB, 0.45598447E-09_JPRB, 0.45190671E-09_JPRB, 0.44804002E-09_JPRB, &
  & 0.44430085E-09_JPRB, 0.44063270E-09_JPRB, 0.43703427E-09_JPRB, 0.43351969E-09_JPRB, 0.43016649E-09_JPRB, 0.42701123E-09_JPRB, &
  & 0.42408413E-09_JPRB, 0.42121137E-09_JPRB, 0.41804449E-09_JPRB, 0.41254863E-09_JPRB /)

RGHG6(:,33,11) = (/ &
  & 0.30776587E-09_JPRB, 0.32037817E-09_JPRB, 0.32771494E-09_JPRB, 0.33398220E-09_JPRB, 0.34010272E-09_JPRB, 0.34638792E-09_JPRB, &
  & 0.35291256E-09_JPRB, 0.35965764E-09_JPRB, 0.36662107E-09_JPRB, 0.37382725E-09_JPRB, 0.38135173E-09_JPRB, 0.38926953E-09_JPRB, &
  & 0.39760231E-09_JPRB, 0.40639364E-09_JPRB, 0.41562218E-09_JPRB, 0.42514603E-09_JPRB, 0.43478721E-09_JPRB, 0.44429119E-09_JPRB, &
  & 0.45342166E-09_JPRB, 0.46206522E-09_JPRB, 0.47018045E-09_JPRB, 0.47777227E-09_JPRB, 0.48476095E-09_JPRB, 0.49105414E-09_JPRB, &
  & 0.49654236E-09_JPRB, 0.50121424E-09_JPRB, 0.50515059E-09_JPRB, 0.50839066E-09_JPRB, 0.51095039E-09_JPRB, 0.51283683E-09_JPRB, &
  & 0.51410382E-09_JPRB, 0.51486448E-09_JPRB, 0.51524990E-09_JPRB, 0.51535759E-09_JPRB, 0.51521898E-09_JPRB, 0.51484539E-09_JPRB, &
  & 0.51420818E-09_JPRB, 0.51328430E-09_JPRB, 0.51204396E-09_JPRB, 0.51044313E-09_JPRB, 0.50845589E-09_JPRB, 0.50603005E-09_JPRB, &
  & 0.50313193E-09_JPRB, 0.49972781E-09_JPRB, 0.49581061E-09_JPRB, 0.49145282E-09_JPRB, 0.48676441E-09_JPRB, 0.48192689E-09_JPRB, &
  & 0.47711091E-09_JPRB, 0.47249094E-09_JPRB, 0.46813331E-09_JPRB, 0.46405224E-09_JPRB, 0.46022303E-09_JPRB, 0.45655607E-09_JPRB, &
  & 0.45298063E-09_JPRB, 0.44945861E-09_JPRB, 0.44597856E-09_JPRB, 0.44259102E-09_JPRB, 0.43936310E-09_JPRB, 0.43637843E-09_JPRB, &
  & 0.43359752E-09_JPRB, 0.43094672E-09_JPRB, 0.42799367E-09_JPRB, 0.42300854E-09_JPRB /)

RGHG6(:,34,11) = (/ &
  & 0.32846592E-09_JPRB, 0.34062489E-09_JPRB, 0.34756925E-09_JPRB, 0.35350303E-09_JPRB, 0.35928921E-09_JPRB, 0.36516926E-09_JPRB, &
  & 0.37124392E-09_JPRB, 0.37747186E-09_JPRB, 0.38382122E-09_JPRB, 0.39033729E-09_JPRB, 0.39708548E-09_JPRB, 0.40417744E-09_JPRB, &
  & 0.41169701E-09_JPRB, 0.41971773E-09_JPRB, 0.42823303E-09_JPRB, 0.43710152E-09_JPRB, 0.44613654E-09_JPRB, 0.45507093E-09_JPRB, &
  & 0.46366330E-09_JPRB, 0.47176779E-09_JPRB, 0.47932847E-09_JPRB, 0.48632270E-09_JPRB, 0.49269777E-09_JPRB, 0.49837739E-09_JPRB, &
  & 0.50330057E-09_JPRB, 0.50747417E-09_JPRB, 0.51098537E-09_JPRB, 0.51389515E-09_JPRB, 0.51622345E-09_JPRB, 0.51797450E-09_JPRB, &
  & 0.51918625E-09_JPRB, 0.51993787E-09_JPRB, 0.52033183E-09_JPRB, 0.52044924E-09_JPRB, 0.52033228E-09_JPRB, 0.51998073E-09_JPRB, &
  & 0.51936827E-09_JPRB, 0.51848015E-09_JPRB, 0.51726545E-09_JPRB, 0.51569526E-09_JPRB, 0.51373217E-09_JPRB, 0.51133103E-09_JPRB, &
  & 0.50846755E-09_JPRB, 0.50512705E-09_JPRB, 0.50132992E-09_JPRB, 0.49714438E-09_JPRB, 0.49269994E-09_JPRB, 0.48814175E-09_JPRB, &
  & 0.48366072E-09_JPRB, 0.47934406E-09_JPRB, 0.47526749E-09_JPRB, 0.47143756E-09_JPRB, 0.46779919E-09_JPRB, 0.46429915E-09_JPRB, &
  & 0.46087098E-09_JPRB, 0.45747686E-09_JPRB, 0.45412574E-09_JPRB, 0.45085011E-09_JPRB, 0.44775034E-09_JPRB, 0.44487913E-09_JPRB, &
  & 0.44227000E-09_JPRB, 0.43975512E-09_JPRB, 0.43704904E-09_JPRB, 0.43241341E-09_JPRB /)

RGHG6(:,35,11) = (/ &
  & 0.34861439E-09_JPRB, 0.35995340E-09_JPRB, 0.36635503E-09_JPRB, 0.37188766E-09_JPRB, 0.37723602E-09_JPRB, 0.38273607E-09_JPRB, &
  & 0.38836345E-09_JPRB, 0.39408349E-09_JPRB, 0.39985615E-09_JPRB, 0.40568837E-09_JPRB, 0.41167708E-09_JPRB, 0.41794301E-09_JPRB, &
  & 0.42464404E-09_JPRB, 0.43188175E-09_JPRB, 0.43968446E-09_JPRB, 0.44791998E-09_JPRB, 0.45639886E-09_JPRB, 0.46482848E-09_JPRB, &
  & 0.47296950E-09_JPRB, 0.48062948E-09_JPRB, 0.48773396E-09_JPRB, 0.49422688E-09_JPRB, 0.50005983E-09_JPRB, 0.50517923E-09_JPRB, &
  & 0.50955440E-09_JPRB, 0.51322446E-09_JPRB, 0.51628712E-09_JPRB, 0.51882204E-09_JPRB, 0.52086302E-09_JPRB, 0.52242399E-09_JPRB, &
  & 0.52352472E-09_JPRB, 0.52422322E-09_JPRB, 0.52459209E-09_JPRB, 0.52470434E-09_JPRB, 0.52460192E-09_JPRB, 0.52426952E-09_JPRB, &
  & 0.52370430E-09_JPRB, 0.52287225E-09_JPRB, 0.52171811E-09_JPRB, 0.52021271E-09_JPRB, 0.51830307E-09_JPRB, 0.51594728E-09_JPRB, &
  & 0.51313476E-09_JPRB, 0.50986337E-09_JPRB, 0.50618604E-09_JPRB, 0.50218929E-09_JPRB, 0.49798127E-09_JPRB, 0.49372428E-09_JPRB, &
  & 0.48952015E-09_JPRB, 0.48548932E-09_JPRB, 0.48167725E-09_JPRB, 0.47807003E-09_JPRB, 0.47464066E-09_JPRB, 0.47132065E-09_JPRB, &
  & 0.46805354E-09_JPRB, 0.46480370E-09_JPRB, 0.46157184E-09_JPRB, 0.45841528E-09_JPRB, 0.45541909E-09_JPRB, 0.45268084E-09_JPRB, &
  & 0.45017759E-09_JPRB, 0.44783630E-09_JPRB, 0.44526138E-09_JPRB, 0.44099452E-09_JPRB /)

RGHG6(:,36,11) = (/ &
  & 0.36809497E-09_JPRB, 0.37815359E-09_JPRB, 0.38393771E-09_JPRB, 0.38890247E-09_JPRB, 0.39384207E-09_JPRB, 0.39889322E-09_JPRB, &
  & 0.40409145E-09_JPRB, 0.40933423E-09_JPRB, 0.41454679E-09_JPRB, 0.41974085E-09_JPRB, 0.42499387E-09_JPRB, 0.43046725E-09_JPRB, &
  & 0.43636064E-09_JPRB, 0.44283310E-09_JPRB, 0.44993603E-09_JPRB, 0.45758564E-09_JPRB, 0.46555820E-09_JPRB, 0.47358112E-09_JPRB, &
  & 0.48134402E-09_JPRB, 0.48865573E-09_JPRB, 0.49538285E-09_JPRB, 0.50146187E-09_JPRB, 0.50681531E-09_JPRB, 0.51141869E-09_JPRB, &
  & 0.51526589E-09_JPRB, 0.51842575E-09_JPRB, 0.52101840E-09_JPRB, 0.52313698E-09_JPRB, 0.52484106E-09_JPRB, 0.52614979E-09_JPRB, &
  & 0.52709098E-09_JPRB, 0.52769805E-09_JPRB, 0.52802102E-09_JPRB, 0.52812837E-09_JPRB, 0.52803711E-09_JPRB, 0.52774385E-09_JPRB, &
  & 0.52725246E-09_JPRB, 0.52650623E-09_JPRB, 0.52546634E-09_JPRB, 0.52407761E-09_JPRB, 0.52227045E-09_JPRB, 0.52000737E-09_JPRB, &
  & 0.51726301E-09_JPRB, 0.51408067E-09_JPRB, 0.51052484E-09_JPRB, 0.50670268E-09_JPRB, 0.50273896E-09_JPRB, 0.49874027E-09_JPRB, &
  & 0.49482507E-09_JPRB, 0.49106014E-09_JPRB, 0.48748572E-09_JPRB, 0.48409443E-09_JPRB, 0.48083820E-09_JPRB, 0.47769033E-09_JPRB, &
  & 0.47457360E-09_JPRB, 0.47146909E-09_JPRB, 0.46837340E-09_JPRB, 0.46534579E-09_JPRB, 0.46247053E-09_JPRB, 0.45983611E-09_JPRB, &
  & 0.45746656E-09_JPRB, 0.45521895E-09_JPRB, 0.45284015E-09_JPRB, 0.44882156E-09_JPRB /)

RGHG6(:,37,11) = (/ &
  & 0.38671644E-09_JPRB, 0.39534420E-09_JPRB, 0.40026879E-09_JPRB, 0.40465883E-09_JPRB, 0.40906428E-09_JPRB, 0.41368542E-09_JPRB, &
  & 0.41844084E-09_JPRB, 0.42321141E-09_JPRB, 0.42789999E-09_JPRB, 0.43248263E-09_JPRB, 0.43704967E-09_JPRB, 0.44177664E-09_JPRB, &
  & 0.44689649E-09_JPRB, 0.45263140E-09_JPRB, 0.45906115E-09_JPRB, 0.46616350E-09_JPRB, 0.47367543E-09_JPRB, 0.48133714E-09_JPRB, &
  & 0.48882409E-09_JPRB, 0.49587595E-09_JPRB, 0.50230892E-09_JPRB, 0.50801413E-09_JPRB, 0.51291399E-09_JPRB, 0.51697779E-09_JPRB, &
  & 0.52025473E-09_JPRB, 0.52285659E-09_JPRB, 0.52493176E-09_JPRB, 0.52659743E-09_JPRB, 0.52792476E-09_JPRB, 0.52895399E-09_JPRB, &
  & 0.52970478E-09_JPRB, 0.53020072E-09_JPRB, 0.53047505E-09_JPRB, 0.53057747E-09_JPRB, 0.53050520E-09_JPRB, 0.53027593E-09_JPRB, &
  & 0.52987259E-09_JPRB, 0.52925853E-09_JPRB, 0.52838817E-09_JPRB, 0.52718818E-09_JPRB, 0.52558574E-09_JPRB, 0.52349497E-09_JPRB, &
  & 0.52090871E-09_JPRB, 0.51785004E-09_JPRB, 0.51443250E-09_JPRB, 0.51078081E-09_JPRB, 0.50702481E-09_JPRB, 0.50327109E-09_JPRB, &
  & 0.49959387E-09_JPRB, 0.49606003E-09_JPRB, 0.49269622E-09_JPRB, 0.48949389E-09_JPRB, 0.48641574E-09_JPRB, 0.48343041E-09_JPRB, &
  & 0.48048671E-09_JPRB, 0.47755644E-09_JPRB, 0.47462750E-09_JPRB, 0.47174853E-09_JPRB, 0.46899917E-09_JPRB, 0.46647347E-09_JPRB, &
  & 0.46418827E-09_JPRB, 0.46206869E-09_JPRB, 0.45977211E-09_JPRB, 0.45600201E-09_JPRB /)

RGHG6(:,38,11) = (/ &
  & 0.40433804E-09_JPRB, 0.41130591E-09_JPRB, 0.41542766E-09_JPRB, 0.41916137E-09_JPRB, 0.42304457E-09_JPRB, 0.42719378E-09_JPRB, &
  & 0.43149903E-09_JPRB, 0.43580234E-09_JPRB, 0.43997389E-09_JPRB, 0.44398382E-09_JPRB, 0.44791720E-09_JPRB, 0.45196125E-09_JPRB, &
  & 0.45636428E-09_JPRB, 0.46139392E-09_JPRB, 0.46720011E-09_JPRB, 0.47375925E-09_JPRB, 0.48090054E-09_JPRB, 0.48823412E-09_JPRB, &
  & 0.49545162E-09_JPRB, 0.50225435E-09_JPRB, 0.50838117E-09_JPRB, 0.51365096E-09_JPRB, 0.51798293E-09_JPRB, 0.52141752E-09_JPRB, &
  & 0.52406646E-09_JPRB, 0.52610066E-09_JPRB, 0.52768595E-09_JPRB, 0.52894322E-09_JPRB, 0.52994820E-09_JPRB, 0.53073523E-09_JPRB, &
  & 0.53132621E-09_JPRB, 0.53172589E-09_JPRB, 0.53196153E-09_JPRB, 0.53205629E-09_JPRB, 0.53200772E-09_JPRB, 0.53183696E-09_JPRB, &
  & 0.53152205E-09_JPRB, 0.53104349E-09_JPRB, 0.53035576E-09_JPRB, 0.52939231E-09_JPRB, 0.52805932E-09_JPRB, 0.52626831E-09_JPRB, &
  & 0.52395205E-09_JPRB, 0.52113619E-09_JPRB, 0.51790428E-09_JPRB, 0.51444116E-09_JPRB, 0.51088966E-09_JPRB, 0.50734683E-09_JPRB, &
  & 0.50388277E-09_JPRB, 0.50054427E-09_JPRB, 0.49735271E-09_JPRB, 0.49431553E-09_JPRB, 0.49140308E-09_JPRB, 0.48859733E-09_JPRB, &
  & 0.48585647E-09_JPRB, 0.48313442E-09_JPRB, 0.48041021E-09_JPRB, 0.47770904E-09_JPRB, 0.47510096E-09_JPRB, 0.47267362E-09_JPRB, &
  & 0.47047721E-09_JPRB, 0.46840959E-09_JPRB, 0.46623105E-09_JPRB, 0.46260018E-09_JPRB /)

RGHG6(:,39,11) = (/ &
  & 0.42051770E-09_JPRB, 0.42603837E-09_JPRB, 0.42934645E-09_JPRB, 0.43247031E-09_JPRB, 0.43584530E-09_JPRB, 0.43952059E-09_JPRB, &
  & 0.44337495E-09_JPRB, 0.44720042E-09_JPRB, 0.45086646E-09_JPRB, 0.45433929E-09_JPRB, 0.45770565E-09_JPRB, 0.46113577E-09_JPRB, &
  & 0.46491092E-09_JPRB, 0.46927362E-09_JPRB, 0.47449261E-09_JPRB, 0.48054821E-09_JPRB, 0.48726628E-09_JPRB, 0.49430160E-09_JPRB, &
  & 0.50122811E-09_JPRB, 0.50767590E-09_JPRB, 0.51334081E-09_JPRB, 0.51801635E-09_JPRB, 0.52168797E-09_JPRB, 0.52447979E-09_JPRB, &
  & 0.52657517E-09_JPRB, 0.52815302E-09_JPRB, 0.52937510E-09_JPRB, 0.53034704E-09_JPRB, 0.53113186E-09_JPRB, 0.53176130E-09_JPRB, &
  & 0.53224475E-09_JPRB, 0.53258092E-09_JPRB, 0.53279153E-09_JPRB, 0.53287635E-09_JPRB, 0.53284821E-09_JPRB, 0.53271521E-09_JPRB, &
  & 0.53246685E-09_JPRB, 0.53209226E-09_JPRB, 0.53155036E-09_JPRB, 0.53078841E-09_JPRB, 0.52972249E-09_JPRB, 0.52825505E-09_JPRB, &
  & 0.52630855E-09_JPRB, 0.52382143E-09_JPRB, 0.52088561E-09_JPRB, 0.51766830E-09_JPRB, 0.51432791E-09_JPRB, 0.51098875E-09_JPRB, &
  & 0.50771282E-09_JPRB, 0.50453974E-09_JPRB, 0.50150090E-09_JPRB, 0.49861482E-09_JPRB, 0.49587018E-09_JPRB, 0.49325810E-09_JPRB, &
  & 0.49073262E-09_JPRB, 0.48825444E-09_JPRB, 0.48576571E-09_JPRB, 0.48327320E-09_JPRB, 0.48082527E-09_JPRB, 0.47850823E-09_JPRB, &
  & 0.47637500E-09_JPRB, 0.47438037E-09_JPRB, 0.47223148E-09_JPRB, 0.46872245E-09_JPRB /)

RGHG6(:,40,11) = (/ &
  & 0.43498494E-09_JPRB, 0.43927340E-09_JPRB, 0.44194853E-09_JPRB, 0.44456847E-09_JPRB, 0.44747389E-09_JPRB, 0.45073992E-09_JPRB, &
  & 0.45414517E-09_JPRB, 0.45750292E-09_JPRB, 0.46068677E-09_JPRB, 0.46366883E-09_JPRB, 0.46652537E-09_JPRB, 0.46944970E-09_JPRB, &
  & 0.47264670E-09_JPRB, 0.47645338E-09_JPRB, 0.48107462E-09_JPRB, 0.48666476E-09_JPRB, 0.49298438E-09_JPRB, 0.49965282E-09_JPRB, &
  & 0.50618976E-09_JPRB, 0.51216315E-09_JPRB, 0.51720644E-09_JPRB, 0.52120536E-09_JPRB, 0.52422838E-09_JPRB, 0.52647958E-09_JPRB, &
  & 0.52814875E-09_JPRB, 0.52941063E-09_JPRB, 0.53039340E-09_JPRB, 0.53118432E-09_JPRB, 0.53183574E-09_JPRB, 0.53236693E-09_JPRB, &
  & 0.53278437E-09_JPRB, 0.53308125E-09_JPRB, 0.53327487E-09_JPRB, 0.53335186E-09_JPRB, 0.53333626E-09_JPRB, 0.53322530E-09_JPRB, &
  & 0.53302257E-09_JPRB, 0.53271543E-09_JPRB, 0.53227706E-09_JPRB, 0.53166321E-09_JPRB, 0.53080662E-09_JPRB, 0.52962479E-09_JPRB, &
  & 0.52801497E-09_JPRB, 0.52590915E-09_JPRB, 0.52334098E-09_JPRB, 0.52042115E-09_JPRB, 0.51734150E-09_JPRB, 0.51421389E-09_JPRB, &
  & 0.51111942E-09_JPRB, 0.50810461E-09_JPRB, 0.50520321E-09_JPRB, 0.50245230E-09_JPRB, 0.49988091E-09_JPRB, 0.49745891E-09_JPRB, &
  & 0.49517779E-09_JPRB, 0.49294446E-09_JPRB, 0.49071713E-09_JPRB, 0.48844784E-09_JPRB, 0.48618465E-09_JPRB, 0.48399029E-09_JPRB, &
  & 0.48194576E-09_JPRB, 0.47998860E-09_JPRB, 0.47790871E-09_JPRB, 0.47445364E-09_JPRB /)

RGHG6(:,41,11) = (/ &
  & 0.44760917E-09_JPRB, 0.45103205E-09_JPRB, 0.45321880E-09_JPRB, 0.45543025E-09_JPRB, 0.45800383E-09_JPRB, 0.46089288E-09_JPRB, &
  & 0.46391416E-09_JPRB, 0.46683735E-09_JPRB, 0.46957382E-09_JPRB, 0.47211357E-09_JPRB, 0.47454707E-09_JPRB, 0.47700377E-09_JPRB, &
  & 0.47975357E-09_JPRB, 0.48301346E-09_JPRB, 0.48713478E-09_JPRB, 0.49220028E-09_JPRB, 0.49809862E-09_JPRB, 0.50435728E-09_JPRB, &
  & 0.51044824E-09_JPRB, 0.51582022E-09_JPRB, 0.52020049E-09_JPRB, 0.52353177E-09_JPRB, 0.52600019E-09_JPRB, 0.52782256E-09_JPRB, &
  & 0.52918714E-09_JPRB, 0.53022892E-09_JPRB, 0.53105437E-09_JPRB, 0.53173038E-09_JPRB, 0.53229421E-09_JPRB, 0.53276455E-09_JPRB, &
  & 0.53313692E-09_JPRB, 0.53341009E-09_JPRB, 0.53358845E-09_JPRB, 0.53366134E-09_JPRB, 0.53365101E-09_JPRB, 0.53355448E-09_JPRB, &
  & 0.53338123E-09_JPRB, 0.53312033E-09_JPRB, 0.53275334E-09_JPRB, 0.53224669E-09_JPRB, 0.53154720E-09_JPRB, 0.53058269E-09_JPRB, &
  & 0.52926125E-09_JPRB, 0.52751453E-09_JPRB, 0.52531401E-09_JPRB, 0.52275073E-09_JPRB, 0.51994026E-09_JPRB, 0.51705173E-09_JPRB, &
  & 0.51415272E-09_JPRB, 0.51129245E-09_JPRB, 0.50852439E-09_JPRB, 0.50592158E-09_JPRB, 0.50349813E-09_JPRB, 0.50129578E-09_JPRB, &
  & 0.49922955E-09_JPRB, 0.49725912E-09_JPRB, 0.49527665E-09_JPRB, 0.49324717E-09_JPRB, 0.49118165E-09_JPRB, 0.48914905E-09_JPRB, &
  & 0.48720583E-09_JPRB, 0.48534043E-09_JPRB, 0.48330140E-09_JPRB, 0.47993726E-09_JPRB /)

RGHG6(:,42,11) = (/ &
  & 0.45857593E-09_JPRB, 0.46138882E-09_JPRB, 0.46323320E-09_JPRB, 0.46518256E-09_JPRB, 0.46747772E-09_JPRB, 0.47012100E-09_JPRB, &
  & 0.47280202E-09_JPRB, 0.47535093E-09_JPRB, 0.47769594E-09_JPRB, 0.47985799E-09_JPRB, 0.48190596E-09_JPRB, 0.48399945E-09_JPRB, &
  & 0.48630544E-09_JPRB, 0.48913595E-09_JPRB, 0.49273319E-09_JPRB, 0.49733423E-09_JPRB, 0.50276094E-09_JPRB, 0.50855908E-09_JPRB, &
  & 0.51408006E-09_JPRB, 0.51883275E-09_JPRB, 0.52252902E-09_JPRB, 0.52527593E-09_JPRB, 0.52728710E-09_JPRB, 0.52878540E-09_JPRB, &
  & 0.52992177E-09_JPRB, 0.53080951E-09_JPRB, 0.53152605E-09_JPRB, 0.53212179E-09_JPRB, 0.53262911E-09_JPRB, 0.53305549E-09_JPRB, &
  & 0.53339561E-09_JPRB, 0.53365284E-09_JPRB, 0.53381666E-09_JPRB, 0.53388760E-09_JPRB, 0.53387766E-09_JPRB, 0.53379162E-09_JPRB, &
  & 0.53363780E-09_JPRB, 0.53340965E-09_JPRB, 0.53309540E-09_JPRB, 0.53266802E-09_JPRB, 0.53208793E-09_JPRB, 0.53129201E-09_JPRB, &
  & 0.53021071E-09_JPRB, 0.52876803E-09_JPRB, 0.52692384E-09_JPRB, 0.52468418E-09_JPRB, 0.52219384E-09_JPRB, 0.51954951E-09_JPRB, &
  & 0.51685828E-09_JPRB, 0.51417398E-09_JPRB, 0.51155802E-09_JPRB, 0.50908200E-09_JPRB, 0.50684323E-09_JPRB, 0.50482241E-09_JPRB, &
  & 0.50299448E-09_JPRB, 0.50124921E-09_JPRB, 0.49951138E-09_JPRB, 0.49771232E-09_JPRB, 0.49586074E-09_JPRB, 0.49401350E-09_JPRB, &
  & 0.49223181E-09_JPRB, 0.49047799E-09_JPRB, 0.48855897E-09_JPRB, 0.48532439E-09_JPRB /)

RGHG6(:,43,11) = (/ &
  & 0.46816317E-09_JPRB, 0.47056642E-09_JPRB, 0.47218596E-09_JPRB, 0.47392856E-09_JPRB, 0.47608134E-09_JPRB, 0.47851334E-09_JPRB, &
  & 0.48095145E-09_JPRB, 0.48318716E-09_JPRB, 0.48520954E-09_JPRB, 0.48704418E-09_JPRB, 0.48877841E-09_JPRB, 0.49052457E-09_JPRB, &
  & 0.49248350E-09_JPRB, 0.49486787E-09_JPRB, 0.49801346E-09_JPRB, 0.50210497E-09_JPRB, 0.50706078E-09_JPRB, 0.51233345E-09_JPRB, &
  & 0.51726989E-09_JPRB, 0.52132387E-09_JPRB, 0.52439525E-09_JPRB, 0.52663157E-09_JPRB, 0.52827381E-09_JPRB, 0.52951543E-09_JPRB, &
  & 0.53048027E-09_JPRB, 0.53125143E-09_JPRB, 0.53188837E-09_JPRB, 0.53242910E-09_JPRB, 0.53289345E-09_JPRB, 0.53329002E-09_JPRB, &
  & 0.53360416E-09_JPRB, 0.53384880E-09_JPRB, 0.53399934E-09_JPRB, 0.53406790E-09_JPRB, 0.53405674E-09_JPRB, 0.53397758E-09_JPRB, &
  & 0.53383709E-09_JPRB, 0.53363380E-09_JPRB, 0.53335908E-09_JPRB, 0.53299404E-09_JPRB, 0.53250604E-09_JPRB, 0.53184745E-09_JPRB, &
  & 0.53096044E-09_JPRB, 0.52977867E-09_JPRB, 0.52823640E-09_JPRB, 0.52634136E-09_JPRB, 0.52413085E-09_JPRB, 0.52175453E-09_JPRB, &
  & 0.51929311E-09_JPRB, 0.51680432E-09_JPRB, 0.51435312E-09_JPRB, 0.51205157E-09_JPRB, 0.50997612E-09_JPRB, 0.50816018E-09_JPRB, &
  & 0.50653620E-09_JPRB, 0.50500942E-09_JPRB, 0.50348858E-09_JPRB, 0.50191123E-09_JPRB, 0.50027993E-09_JPRB, 0.49865012E-09_JPRB, &
  & 0.49706539E-09_JPRB, 0.49549820E-09_JPRB, 0.49374610E-09_JPRB, 0.49076171E-09_JPRB /)

RGHG6(:,44,11) = (/ &
  & 0.47667181E-09_JPRB, 0.47880172E-09_JPRB, 0.48024823E-09_JPRB, 0.48187782E-09_JPRB, 0.48389909E-09_JPRB, 0.48622656E-09_JPRB, &
  & 0.48846022E-09_JPRB, 0.49046373E-09_JPRB, 0.49221965E-09_JPRB, 0.49378712E-09_JPRB, 0.49524240E-09_JPRB, 0.49670429E-09_JPRB, &
  & 0.49831933E-09_JPRB, 0.50033327E-09_JPRB, 0.50301679E-09_JPRB, 0.50663612E-09_JPRB, 0.51108467E-09_JPRB, 0.51579624E-09_JPRB, &
  & 0.52004695E-09_JPRB, 0.52342686E-09_JPRB, 0.52591131E-09_JPRB, 0.52771354E-09_JPRB, 0.52905769E-09_JPRB, 0.53009486E-09_JPRB, &
  & 0.53092419E-09_JPRB, 0.53160554E-09_JPRB, 0.53218341E-09_JPRB, 0.53268234E-09_JPRB, 0.53311722E-09_JPRB, 0.53348959E-09_JPRB, &
  & 0.53378352E-09_JPRB, 0.53401594E-09_JPRB, 0.53415572E-09_JPRB, 0.53422028E-09_JPRB, 0.53420746E-09_JPRB, 0.53413240E-09_JPRB, &
  & 0.53400157E-09_JPRB, 0.53381694E-09_JPRB, 0.53357324E-09_JPRB, 0.53325722E-09_JPRB, 0.53284366E-09_JPRB, 0.53229621E-09_JPRB, &
  & 0.53156934E-09_JPRB, 0.53060462E-09_JPRB, 0.52934762E-09_JPRB, 0.52774152E-09_JPRB, 0.52583959E-09_JPRB, 0.52371762E-09_JPRB, &
  & 0.52149357E-09_JPRB, 0.51922633E-09_JPRB, 0.51697813E-09_JPRB, 0.51485971E-09_JPRB, 0.51297699E-09_JPRB, 0.51136201E-09_JPRB, &
  & 0.50992921E-09_JPRB, 0.50860194E-09_JPRB, 0.50727844E-09_JPRB, 0.50590959E-09_JPRB, 0.50450100E-09_JPRB, 0.50310323E-09_JPRB, &
  & 0.50175264E-09_JPRB, 0.50041099E-09_JPRB, 0.49889726E-09_JPRB, 0.49628485E-09_JPRB /)

RGHG6(:,45,11) = (/ &
  & 0.48435600E-09_JPRB, 0.48627502E-09_JPRB, 0.48761534E-09_JPRB, 0.48912452E-09_JPRB, 0.49109716E-09_JPRB, 0.49331284E-09_JPRB, &
  & 0.49542326E-09_JPRB, 0.49723398E-09_JPRB, 0.49877996E-09_JPRB, 0.50012411E-09_JPRB, 0.50134286E-09_JPRB, 0.50254395E-09_JPRB, &
  & 0.50387716E-09_JPRB, 0.50553040E-09_JPRB, 0.50779309E-09_JPRB, 0.51094368E-09_JPRB, 0.51485555E-09_JPRB, 0.51894228E-09_JPRB, &
  & 0.52247351E-09_JPRB, 0.52518151E-09_JPRB, 0.52714688E-09_JPRB, 0.52859328E-09_JPRB, 0.52969129E-09_JPRB, 0.53056770E-09_JPRB, &
  & 0.53128785E-09_JPRB, 0.53189914E-09_JPRB, 0.53243077E-09_JPRB, 0.53290061E-09_JPRB, 0.53331256E-09_JPRB, 0.53366606E-09_JPRB, &
  & 0.53394372E-09_JPRB, 0.53416366E-09_JPRB, 0.53429416E-09_JPRB, 0.53435367E-09_JPRB, 0.53433891E-09_JPRB, 0.53426585E-09_JPRB, &
  & 0.53414195E-09_JPRB, 0.53397176E-09_JPRB, 0.53375238E-09_JPRB, 0.53347526E-09_JPRB, 0.53312188E-09_JPRB, 0.53266430E-09_JPRB, &
  & 0.53206917E-09_JPRB, 0.53129207E-09_JPRB, 0.53027349E-09_JPRB, 0.52896698E-09_JPRB, 0.52734145E-09_JPRB, 0.52549076E-09_JPRB, &
  & 0.52350968E-09_JPRB, 0.52146748E-09_JPRB, 0.51943883E-09_JPRB, 0.51754212E-09_JPRB, 0.51587351E-09_JPRB, 0.51445065E-09_JPRB, &
  & 0.51321514E-09_JPRB, 0.51206345E-09_JPRB, 0.51092708E-09_JPRB, 0.50975629E-09_JPRB, 0.50856486E-09_JPRB, 0.50740301E-09_JPRB, &
  & 0.50629634E-09_JPRB, 0.50519755E-09_JPRB, 0.50395565E-09_JPRB, 0.50178395E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART21',1,ZHOOK_HANDLE)
END SUBROUTINE PART21




SUBROUTINE PART22
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART22',0,ZHOOK_HANDLE)



RGHG6(:,46,11) = (/ &
  & 0.49138865E-09_JPRB, 0.49316840E-09_JPRB, 0.49438864E-09_JPRB, 0.49584442E-09_JPRB, 0.49770316E-09_JPRB, 0.49988824E-09_JPRB, &
  & 0.50186622E-09_JPRB, 0.50352977E-09_JPRB, 0.50490079E-09_JPRB, 0.50604321E-09_JPRB, 0.50706017E-09_JPRB, 0.50804361E-09_JPRB, &
  & 0.50911836E-09_JPRB, 0.51046645E-09_JPRB, 0.51236226E-09_JPRB, 0.51501237E-09_JPRB, 0.51838861E-09_JPRB, 0.52174132E-09_JPRB, &
  & 0.52454602E-09_JPRB, 0.52662741E-09_JPRB, 0.52815791E-09_JPRB, 0.52930571E-09_JPRB, 0.53021387E-09_JPRB, 0.53095839E-09_JPRB, &
  & 0.53159327E-09_JPRB, 0.53214849E-09_JPRB, 0.53264521E-09_JPRB, 0.53309235E-09_JPRB, 0.53348803E-09_JPRB, 0.53382576E-09_JPRB, &
  & 0.53408966E-09_JPRB, 0.53429694E-09_JPRB, 0.53441945E-09_JPRB, 0.53447291E-09_JPRB, 0.53445603E-09_JPRB, 0.53438354E-09_JPRB, &
  & 0.53426469E-09_JPRB, 0.53410498E-09_JPRB, 0.53390498E-09_JPRB, 0.53365884E-09_JPRB, 0.53335325E-09_JPRB, 0.53296900E-09_JPRB, &
  & 0.53248084E-09_JPRB, 0.53185817E-09_JPRB, 0.53105692E-09_JPRB, 0.53001198E-09_JPRB, 0.52868776E-09_JPRB, 0.52711008E-09_JPRB, &
  & 0.52536658E-09_JPRB, 0.52355753E-09_JPRB, 0.52176818E-09_JPRB, 0.52009380E-09_JPRB, 0.51865939E-09_JPRB, 0.51743881E-09_JPRB, &
  & 0.51638505E-09_JPRB, 0.51540711E-09_JPRB, 0.51444282E-09_JPRB, 0.51345905E-09_JPRB, 0.51247462E-09_JPRB, 0.51153570E-09_JPRB, &
  & 0.51065263E-09_JPRB, 0.50978749E-09_JPRB, 0.50879972E-09_JPRB, 0.50707794E-09_JPRB /)

RGHG6(:,47,11) = (/ &
  & 0.49791771E-09_JPRB, 0.49954885E-09_JPRB, 0.50071253E-09_JPRB, 0.50203908E-09_JPRB, 0.50388066E-09_JPRB, 0.50593396E-09_JPRB, &
  & 0.50783538E-09_JPRB, 0.50935811E-09_JPRB, 0.51055399E-09_JPRB, 0.51153187E-09_JPRB, 0.51236304E-09_JPRB, 0.51315696E-09_JPRB, &
  & 0.51401994E-09_JPRB, 0.51511095E-09_JPRB, 0.51663412E-09_JPRB, 0.51885868E-09_JPRB, 0.52154880E-09_JPRB, 0.52417864E-09_JPRB, &
  & 0.52625343E-09_JPRB, 0.52781024E-09_JPRB, 0.52897381E-09_JPRB, 0.52989191E-09_JPRB, 0.53064364E-09_JPRB, 0.53128801E-09_JPRB, &
  & 0.53185428E-09_JPRB, 0.53236571E-09_JPRB, 0.53283544E-09_JPRB, 0.53326571E-09_JPRB, 0.53364840E-09_JPRB, 0.53397220E-09_JPRB, &
  & 0.53422389E-09_JPRB, 0.53441862E-09_JPRB, 0.53453370E-09_JPRB, 0.53458094E-09_JPRB, 0.53456145E-09_JPRB, 0.53448862E-09_JPRB, &
  & 0.53437293E-09_JPRB, 0.53422156E-09_JPRB, 0.53403632E-09_JPRB, 0.53381471E-09_JPRB, 0.53354759E-09_JPRB, 0.53322080E-09_JPRB, &
  & 0.53281962E-09_JPRB, 0.53232330E-09_JPRB, 0.53170074E-09_JPRB, 0.53090116E-09_JPRB, 0.52986920E-09_JPRB, 0.52858035E-09_JPRB, &
  & 0.52710786E-09_JPRB, 0.52553401E-09_JPRB, 0.52396598E-09_JPRB, 0.52255056E-09_JPRB, 0.52131721E-09_JPRB, 0.52030869E-09_JPRB, &
  & 0.51942006E-09_JPRB, 0.51860483E-09_JPRB, 0.51779958E-09_JPRB, 0.51698518E-09_JPRB, 0.51618715E-09_JPRB, 0.51543875E-09_JPRB, &
  & 0.51475235E-09_JPRB, 0.51407734E-09_JPRB, 0.51331617E-09_JPRB, 0.51197035E-09_JPRB /)

RGHG6(:,48,11) = (/ &
  & 0.50399179E-09_JPRB, 0.50552929E-09_JPRB, 0.50658544E-09_JPRB, 0.50786864E-09_JPRB, 0.50955073E-09_JPRB, 0.51157589E-09_JPRB, &
  & 0.51334387E-09_JPRB, 0.51472782E-09_JPRB, 0.51577786E-09_JPRB, 0.51658056E-09_JPRB, 0.51725646E-09_JPRB, 0.51788285E-09_JPRB, &
  & 0.51856064E-09_JPRB, 0.51941207E-09_JPRB, 0.52061316E-09_JPRB, 0.52230037E-09_JPRB, 0.52431681E-09_JPRB, 0.52617077E-09_JPRB, &
  & 0.52763899E-09_JPRB, 0.52875226E-09_JPRB, 0.52963711E-09_JPRB, 0.53036919E-09_JPRB, 0.53100335E-09_JPRB, 0.53156779E-09_JPRB, &
  & 0.53208232E-09_JPRB, 0.53256072E-09_JPRB, 0.53300947E-09_JPRB, 0.53342530E-09_JPRB, 0.53379717E-09_JPRB, 0.53410798E-09_JPRB, &
  & 0.53434807E-09_JPRB, 0.53453070E-09_JPRB, 0.53463867E-09_JPRB, 0.53467963E-09_JPRB, 0.53465715E-09_JPRB, 0.53458332E-09_JPRB, &
  & 0.53446975E-09_JPRB, 0.53432425E-09_JPRB, 0.53415100E-09_JPRB, 0.53394861E-09_JPRB, 0.53371152E-09_JPRB, 0.53343086E-09_JPRB, &
  & 0.53309718E-09_JPRB, 0.53270088E-09_JPRB, 0.53222327E-09_JPRB, 0.53163218E-09_JPRB, 0.53086929E-09_JPRB, 0.52990112E-09_JPRB, &
  & 0.52872018E-09_JPRB, 0.52741139E-09_JPRB, 0.52610100E-09_JPRB, 0.52488947E-09_JPRB, 0.52389182E-09_JPRB, 0.52304250E-09_JPRB, &
  & 0.52231863E-09_JPRB, 0.52163890E-09_JPRB, 0.52097243E-09_JPRB, 0.52030397E-09_JPRB, 0.51965748E-09_JPRB, 0.51906834E-09_JPRB, &
  & 0.51853050E-09_JPRB, 0.51801136E-09_JPRB, 0.51741728E-09_JPRB, 0.51637483E-09_JPRB /)

RGHG6(:,49,11) = (/ &
  & 0.50966265E-09_JPRB, 0.51108534E-09_JPRB, 0.51208188E-09_JPRB, 0.51324850E-09_JPRB, 0.51487292E-09_JPRB, 0.51674887E-09_JPRB, &
  & 0.51842874E-09_JPRB, 0.51966687E-09_JPRB, 0.52054527E-09_JPRB, 0.52119742E-09_JPRB, 0.52171378E-09_JPRB, 0.52218452E-09_JPRB, &
  & 0.52268401E-09_JPRB, 0.52328597E-09_JPRB, 0.52413357E-09_JPRB, 0.52524096E-09_JPRB, 0.52655619E-09_JPRB, 0.52774901E-09_JPRB, &
  & 0.52871812E-09_JPRB, 0.52950566E-09_JPRB, 0.53017130E-09_JPRB, 0.53076399E-09_JPRB, 0.53130522E-09_JPRB, 0.53180987E-09_JPRB, &
  & 0.53228622E-09_JPRB, 0.53273963E-09_JPRB, 0.53317284E-09_JPRB, 0.53357635E-09_JPRB, 0.53393590E-09_JPRB, 0.53423455E-09_JPRB, &
  & 0.53446325E-09_JPRB, 0.53463434E-09_JPRB, 0.53473515E-09_JPRB, 0.53477034E-09_JPRB, 0.53474447E-09_JPRB, 0.53466953E-09_JPRB, &
  & 0.53455707E-09_JPRB, 0.53441640E-09_JPRB, 0.53425209E-09_JPRB, 0.53406513E-09_JPRB, 0.53385163E-09_JPRB, 0.53360605E-09_JPRB, &
  & 0.53332505E-09_JPRB, 0.53300492E-09_JPRB, 0.53264032E-09_JPRB, 0.53221111E-09_JPRB, 0.53168514E-09_JPRB, 0.53101040E-09_JPRB, &
  & 0.53016502E-09_JPRB, 0.52917626E-09_JPRB, 0.52813370E-09_JPRB, 0.52718319E-09_JPRB, 0.52635946E-09_JPRB, 0.52568333E-09_JPRB, &
  & 0.52508403E-09_JPRB, 0.52452298E-09_JPRB, 0.52396848E-09_JPRB, 0.52341459E-09_JPRB, 0.52288979E-09_JPRB, 0.52241689E-09_JPRB, &
  & 0.52199467E-09_JPRB, 0.52158566E-09_JPRB, 0.52111843E-09_JPRB, 0.52029070E-09_JPRB /)

RGHG6(:,50,11) = (/ &
  & 0.51488203E-09_JPRB, 0.51620297E-09_JPRB, 0.51711452E-09_JPRB, 0.51819865E-09_JPRB, 0.51969562E-09_JPRB, 0.52147481E-09_JPRB, &
  & 0.52296889E-09_JPRB, 0.52402299E-09_JPRB, 0.52471566E-09_JPRB, 0.52518567E-09_JPRB, 0.52554133E-09_JPRB, 0.52584642E-09_JPRB, &
  & 0.52614635E-09_JPRB, 0.52650961E-09_JPRB, 0.52694088E-09_JPRB, 0.52756177E-09_JPRB, 0.52825078E-09_JPRB, 0.52894639E-09_JPRB, &
  & 0.52955690E-09_JPRB, 0.53010096E-09_JPRB, 0.53060839E-09_JPRB, 0.53109273E-09_JPRB, 0.53156324E-09_JPRB, 0.53202370E-09_JPRB, &
  & 0.53247223E-09_JPRB, 0.53290911E-09_JPRB, 0.53332883E-09_JPRB, 0.53371990E-09_JPRB, 0.53406668E-09_JPRB, 0.53435195E-09_JPRB, &
  & 0.53457055E-09_JPRB, 0.53473076E-09_JPRB, 0.53482452E-09_JPRB, 0.53485416E-09_JPRB, 0.53482491E-09_JPRB, 0.53474836E-09_JPRB, &
  & 0.53463695E-09_JPRB, 0.53449989E-09_JPRB, 0.53434313E-09_JPRB, 0.53416799E-09_JPRB, 0.53397237E-09_JPRB, 0.53375399E-09_JPRB, &
  & 0.53351218E-09_JPRB, 0.53325006E-09_JPRB, 0.53296884E-09_JPRB, 0.53266441E-09_JPRB, 0.53231475E-09_JPRB, 0.53188914E-09_JPRB, &
  & 0.53135596E-09_JPRB, 0.53071092E-09_JPRB, 0.53000954E-09_JPRB, 0.52932247E-09_JPRB, 0.52872651E-09_JPRB, 0.52820071E-09_JPRB, &
  & 0.52772547E-09_JPRB, 0.52727078E-09_JPRB, 0.52681021E-09_JPRB, 0.52635063E-09_JPRB, 0.52591898E-09_JPRB, 0.52553550E-09_JPRB, &
  & 0.52519650E-09_JPRB, 0.52486548E-09_JPRB, 0.52448701E-09_JPRB, 0.52379778E-09_JPRB /)

RGHG6(:,51,11) = (/ &
  & 0.51956695E-09_JPRB, 0.52075022E-09_JPRB, 0.52158028E-09_JPRB, 0.52256383E-09_JPRB, 0.52390753E-09_JPRB, 0.52544613E-09_JPRB, &
  & 0.52668936E-09_JPRB, 0.52745064E-09_JPRB, 0.52790283E-09_JPRB, 0.52818522E-09_JPRB, 0.52837745E-09_JPRB, 0.52852689E-09_JPRB, &
  & 0.52866456E-09_JPRB, 0.52879734E-09_JPRB, 0.52897614E-09_JPRB, 0.52918758E-09_JPRB, 0.52949728E-09_JPRB, 0.52984334E-09_JPRB, &
  & 0.53020832E-09_JPRB, 0.53058397E-09_JPRB, 0.53097032E-09_JPRB, 0.53137261E-09_JPRB, 0.53179039E-09_JPRB, 0.53221594E-09_JPRB, &
  & 0.53264659E-09_JPRB, 0.53306998E-09_JPRB, 0.53347932E-09_JPRB, 0.53385635E-09_JPRB, 0.53418892E-09_JPRB, 0.53446164E-09_JPRB, &
  & 0.53467014E-09_JPRB, 0.53482085E-09_JPRB, 0.53490756E-09_JPRB, 0.53493193E-09_JPRB, 0.53489946E-09_JPRB, 0.53482152E-09_JPRB, &
  & 0.53471050E-09_JPRB, 0.53457672E-09_JPRB, 0.53442600E-09_JPRB, 0.53426041E-09_JPRB, 0.53407878E-09_JPRB, 0.53388005E-09_JPRB, &
  & 0.53366811E-09_JPRB, 0.53344890E-09_JPRB, 0.53323179E-09_JPRB, 0.53301646E-09_JPRB, 0.53279586E-09_JPRB, 0.53254873E-09_JPRB, &
  & 0.53225407E-09_JPRB, 0.53190580E-09_JPRB, 0.53151999E-09_JPRB, 0.53113652E-09_JPRB, 0.53076904E-09_JPRB, 0.53043175E-09_JPRB, &
  & 0.53010529E-09_JPRB, 0.52976634E-09_JPRB, 0.52941518E-09_JPRB, 0.52905452E-09_JPRB, 0.52871107E-09_JPRB, 0.52840854E-09_JPRB, &
  & 0.52813687E-09_JPRB, 0.52787208E-09_JPRB, 0.52755117E-09_JPRB, 0.52697130E-09_JPRB /)

RGHG6(:,52,11) = (/ &
  & 0.52352322E-09_JPRB, 0.52457588E-09_JPRB, 0.52527760E-09_JPRB, 0.52610694E-09_JPRB, 0.52721921E-09_JPRB, 0.52841953E-09_JPRB, &
  & 0.52923832E-09_JPRB, 0.52969706E-09_JPRB, 0.52993576E-09_JPRB, 0.53006843E-09_JPRB, 0.53014970E-09_JPRB, 0.53020294E-09_JPRB, &
  & 0.53023863E-09_JPRB, 0.53026561E-09_JPRB, 0.53028293E-09_JPRB, 0.53031485E-09_JPRB, 0.53038551E-09_JPRB, 0.53052651E-09_JPRB, &
  & 0.53072813E-09_JPRB, 0.53098070E-09_JPRB, 0.53128024E-09_JPRB, 0.53162003E-09_JPRB, 0.53199312E-09_JPRB, 0.53239690E-09_JPRB, &
  & 0.53281024E-09_JPRB, 0.53322563E-09_JPRB, 0.53362087E-09_JPRB, 0.53398608E-09_JPRB, 0.53430288E-09_JPRB, 0.53456362E-09_JPRB, &
  & 0.53476307E-09_JPRB, 0.53490518E-09_JPRB, 0.53498522E-09_JPRB, 0.53500460E-09_JPRB, 0.53496901E-09_JPRB, 0.53488980E-09_JPRB, &
  & 0.53477933E-09_JPRB, 0.53464838E-09_JPRB, 0.53450294E-09_JPRB, 0.53434479E-09_JPRB, 0.53417337E-09_JPRB, 0.53399030E-09_JPRB, &
  & 0.53379978E-09_JPRB, 0.53361515E-09_JPRB, 0.53344479E-09_JPRB, 0.53329746E-09_JPRB, 0.53316412E-09_JPRB, 0.53303340E-09_JPRB, &
  & 0.53289101E-09_JPRB, 0.53273236E-09_JPRB, 0.53256133E-09_JPRB, 0.53238619E-09_JPRB, 0.53221699E-09_JPRB, 0.53204469E-09_JPRB, &
  & 0.53186183E-09_JPRB, 0.53166382E-09_JPRB, 0.53143651E-09_JPRB, 0.53119426E-09_JPRB, 0.53096033E-09_JPRB, 0.53075000E-09_JPRB, &
  & 0.53056093E-09_JPRB, 0.53036636E-09_JPRB, 0.53013016E-09_JPRB, 0.52965249E-09_JPRB /)

RGHG6(:,53,11) = (/ &
  & 0.52665705E-09_JPRB, 0.52748017E-09_JPRB, 0.52805949E-09_JPRB, 0.52869314E-09_JPRB, 0.52950122E-09_JPRB, 0.53027638E-09_JPRB, &
  & 0.53076588E-09_JPRB, 0.53099436E-09_JPRB, 0.53110405E-09_JPRB, 0.53115856E-09_JPRB, 0.53118532E-09_JPRB, 0.53119564E-09_JPRB, &
  & 0.53119253E-09_JPRB, 0.53117555E-09_JPRB, 0.53113630E-09_JPRB, 0.53108656E-09_JPRB, 0.53104388E-09_JPRB, 0.53105975E-09_JPRB, &
  & 0.53115257E-09_JPRB, 0.53132065E-09_JPRB, 0.53155252E-09_JPRB, 0.53184257E-09_JPRB, 0.53218668E-09_JPRB, 0.53256505E-09_JPRB, &
  & 0.53297000E-09_JPRB, 0.53337046E-09_JPRB, 0.53375709E-09_JPRB, 0.53410504E-09_JPRB, 0.53441018E-09_JPRB, 0.53465876E-09_JPRB, &
  & 0.53484989E-09_JPRB, 0.53498395E-09_JPRB, 0.53505755E-09_JPRB, 0.53507254E-09_JPRB, 0.53503418E-09_JPRB, 0.53495397E-09_JPRB, &
  & 0.53484411E-09_JPRB, 0.53471583E-09_JPRB, 0.53457472E-09_JPRB, 0.53442278E-09_JPRB, 0.53426019E-09_JPRB, 0.53408761E-09_JPRB, &
  & 0.53391624E-09_JPRB, 0.53375621E-09_JPRB, 0.53362609E-09_JPRB, 0.53352556E-09_JPRB, 0.53345206E-09_JPRB, 0.53339133E-09_JPRB, &
  & 0.53333288E-09_JPRB, 0.53327043E-09_JPRB, 0.53320404E-09_JPRB, 0.53313509E-09_JPRB, 0.53306232E-09_JPRB, 0.53298488E-09_JPRB, &
  & 0.53289784E-09_JPRB, 0.53279070E-09_JPRB, 0.53266680E-09_JPRB, 0.53252758E-09_JPRB, 0.53239152E-09_JPRB, 0.53227045E-09_JPRB, &
  & 0.53216170E-09_JPRB, 0.53205207E-09_JPRB, 0.53191140E-09_JPRB, 0.53161492E-09_JPRB /)

RGHG6(:,54,11) = (/ &
  & 0.52888405E-09_JPRB, 0.52954280E-09_JPRB, 0.52994181E-09_JPRB, 0.53038690E-09_JPRB, 0.53091465E-09_JPRB, 0.53138999E-09_JPRB, &
  & 0.53163962E-09_JPRB, 0.53175148E-09_JPRB, 0.53179772E-09_JPRB, 0.53181681E-09_JPRB, 0.53182181E-09_JPRB, 0.53181715E-09_JPRB, &
  & 0.53180282E-09_JPRB, 0.53177274E-09_JPRB, 0.53172539E-09_JPRB, 0.53163995E-09_JPRB, 0.53154997E-09_JPRB, 0.53149196E-09_JPRB, &
  & 0.53151267E-09_JPRB, 0.53161703E-09_JPRB, 0.53180038E-09_JPRB, 0.53205390E-09_JPRB, 0.53236693E-09_JPRB, 0.53273252E-09_JPRB, &
  & 0.53311816E-09_JPRB, 0.53351146E-09_JPRB, 0.53388038E-09_JPRB, 0.53421900E-09_JPRB, 0.53450960E-09_JPRB, 0.53474863E-09_JPRB, &
  & 0.53493093E-09_JPRB, 0.53505733E-09_JPRB, 0.53512528E-09_JPRB, 0.53513627E-09_JPRB, 0.53509563E-09_JPRB, 0.53501481E-09_JPRB, &
  & 0.53490579E-09_JPRB, 0.53477972E-09_JPRB, 0.53464277E-09_JPRB, 0.53449617E-09_JPRB, 0.53433979E-09_JPRB, 0.53417853E-09_JPRB, &
  & 0.53401972E-09_JPRB, 0.53388494E-09_JPRB, 0.53378180E-09_JPRB, 0.53371846E-09_JPRB, 0.53368243E-09_JPRB, 0.53366200E-09_JPRB, &
  & 0.53364563E-09_JPRB, 0.53362764E-09_JPRB, 0.53360527E-09_JPRB, 0.53357851E-09_JPRB, 0.53354809E-09_JPRB, 0.53351201E-09_JPRB, &
  & 0.53346727E-09_JPRB, 0.53341315E-09_JPRB, 0.53334354E-09_JPRB, 0.53326638E-09_JPRB, 0.53319127E-09_JPRB, 0.53312799E-09_JPRB, &
  & 0.53307392E-09_JPRB, 0.53302573E-09_JPRB, 0.53297827E-09_JPRB, 0.53291466E-09_JPRB /)

RGHG6(:,55,11) = (/ &
  & 0.53042293E-09_JPRB, 0.53087523E-09_JPRB, 0.53116989E-09_JPRB, 0.53145732E-09_JPRB, 0.53178967E-09_JPRB, 0.53205607E-09_JPRB, &
  & 0.53218829E-09_JPRB, 0.53223687E-09_JPRB, 0.53225413E-09_JPRB, 0.53225796E-09_JPRB, 0.53225480E-09_JPRB, 0.53224591E-09_JPRB, &
  & 0.53222943E-09_JPRB, 0.53220250E-09_JPRB, 0.53215049E-09_JPRB, 0.53207316E-09_JPRB, 0.53195454E-09_JPRB, 0.53185528E-09_JPRB, &
  & 0.53182592E-09_JPRB, 0.53188598E-09_JPRB, 0.53203109E-09_JPRB, 0.53225441E-09_JPRB, 0.53254762E-09_JPRB, 0.53288973E-09_JPRB, &
  & 0.53326488E-09_JPRB, 0.53363947E-09_JPRB, 0.53400029E-09_JPRB, 0.53432364E-09_JPRB, 0.53460486E-09_JPRB, 0.53483307E-09_JPRB, &
  & 0.53500709E-09_JPRB, 0.53512605E-09_JPRB, 0.53518845E-09_JPRB, 0.53519633E-09_JPRB, 0.53515420E-09_JPRB, 0.53507310E-09_JPRB, &
  & 0.53496524E-09_JPRB, 0.53484156E-09_JPRB, 0.53470750E-09_JPRB, 0.53456534E-09_JPRB, 0.53441634E-09_JPRB, 0.53426241E-09_JPRB, &
  & 0.53411986E-09_JPRB, 0.53400068E-09_JPRB, 0.53392379E-09_JPRB, 0.53388416E-09_JPRB, 0.53387295E-09_JPRB, 0.53387506E-09_JPRB, &
  & 0.53387944E-09_JPRB, 0.53388038E-09_JPRB, 0.53387600E-09_JPRB, 0.53386651E-09_JPRB, 0.53385252E-09_JPRB, 0.53383431E-09_JPRB, &
  & 0.53381105E-09_JPRB, 0.53377897E-09_JPRB, 0.53373939E-09_JPRB, 0.53369281E-09_JPRB, 0.53364846E-09_JPRB, 0.53360949E-09_JPRB, &
  & 0.53357713E-09_JPRB, 0.53354565E-09_JPRB, 0.53350963E-09_JPRB, 0.53344412E-09_JPRB /)

RGHG6(:,56,11) = (/ &
  & 0.53145099E-09_JPRB, 0.53178095E-09_JPRB, 0.53196636E-09_JPRB, 0.53214994E-09_JPRB, 0.53235227E-09_JPRB, 0.53250254E-09_JPRB, &
  & 0.53256444E-09_JPRB, 0.53258453E-09_JPRB, 0.53258858E-09_JPRB, 0.53258647E-09_JPRB, 0.53258087E-09_JPRB, 0.53257176E-09_JPRB, &
  & 0.53255744E-09_JPRB, 0.53253280E-09_JPRB, 0.53249283E-09_JPRB, 0.53241311E-09_JPRB, 0.53229887E-09_JPRB, 0.53217203E-09_JPRB, &
  & 0.53210736E-09_JPRB, 0.53213400E-09_JPRB, 0.53225163E-09_JPRB, 0.53245114E-09_JPRB, 0.53272153E-09_JPRB, 0.53304711E-09_JPRB, &
  & 0.53340238E-09_JPRB, 0.53376598E-09_JPRB, 0.53411114E-09_JPRB, 0.53442539E-09_JPRB, 0.53469468E-09_JPRB, 0.53491345E-09_JPRB, &
  & 0.53507854E-09_JPRB, 0.53519084E-09_JPRB, 0.53524840E-09_JPRB, 0.53525373E-09_JPRB, 0.53521065E-09_JPRB, 0.53513011E-09_JPRB, &
  & 0.53502347E-09_JPRB, 0.53490168E-09_JPRB, 0.53477067E-09_JPRB, 0.53463289E-09_JPRB, 0.53448890E-09_JPRB, 0.53434601E-09_JPRB, &
  & 0.53421345E-09_JPRB, 0.53411320E-09_JPRB, 0.53405236E-09_JPRB, 0.53403137E-09_JPRB, 0.53403582E-09_JPRB, 0.53405058E-09_JPRB, &
  & 0.53406507E-09_JPRB, 0.53407395E-09_JPRB, 0.53407645E-09_JPRB, 0.53407351E-09_JPRB, 0.53406668E-09_JPRB, 0.53405630E-09_JPRB, &
  & 0.53404181E-09_JPRB, 0.53402283E-09_JPRB, 0.53399685E-09_JPRB, 0.53396743E-09_JPRB, 0.53393839E-09_JPRB, 0.53391447E-09_JPRB, &
  & 0.53389315E-09_JPRB, 0.53387383E-09_JPRB, 0.53385263E-09_JPRB, 0.53381838E-09_JPRB /)

RGHG6(:,57,11) = (/ &
  & 0.53213811E-09_JPRB, 0.53238142E-09_JPRB, 0.53250981E-09_JPRB, 0.53262744E-09_JPRB, 0.53274474E-09_JPRB, 0.53282490E-09_JPRB, &
  & 0.53285354E-09_JPRB, 0.53285898E-09_JPRB, 0.53285742E-09_JPRB, 0.53285343E-09_JPRB, 0.53284760E-09_JPRB, 0.53283955E-09_JPRB, &
  & 0.53282745E-09_JPRB, 0.53280824E-09_JPRB, 0.53277172E-09_JPRB, 0.53270877E-09_JPRB, 0.53259158E-09_JPRB, 0.53245452E-09_JPRB, &
  & 0.53236676E-09_JPRB, 0.53236954E-09_JPRB, 0.53246463E-09_JPRB, 0.53264398E-09_JPRB, 0.53289473E-09_JPRB, 0.53320043E-09_JPRB, &
  & 0.53353921E-09_JPRB, 0.53388660E-09_JPRB, 0.53422067E-09_JPRB, 0.53452226E-09_JPRB, 0.53478089E-09_JPRB, 0.53498955E-09_JPRB, &
  & 0.53514643E-09_JPRB, 0.53525218E-09_JPRB, 0.53530563E-09_JPRB, 0.53530896E-09_JPRB, 0.53526594E-09_JPRB, 0.53518645E-09_JPRB, &
  & 0.53508137E-09_JPRB, 0.53496196E-09_JPRB, 0.53483351E-09_JPRB, 0.53469912E-09_JPRB, 0.53456189E-09_JPRB, 0.53442600E-09_JPRB, &
  & 0.53430749E-09_JPRB, 0.53421889E-09_JPRB, 0.53417332E-09_JPRB, 0.53416466E-09_JPRB, 0.53417931E-09_JPRB, 0.53420179E-09_JPRB, &
  & 0.53422067E-09_JPRB, 0.53423271E-09_JPRB, 0.53423710E-09_JPRB, 0.53423621E-09_JPRB, 0.53423188E-09_JPRB, 0.53422489E-09_JPRB, &
  & 0.53421523E-09_JPRB, 0.53420146E-09_JPRB, 0.53418392E-09_JPRB, 0.53416294E-09_JPRB, 0.53414301E-09_JPRB, 0.53412502E-09_JPRB, &
  & 0.53411009E-09_JPRB, 0.53409499E-09_JPRB, 0.53407756E-09_JPRB, 0.53404553E-09_JPRB /)

RGHG6(:,58,11) = (/ &
  & 0.53272309E-09_JPRB, 0.53283800E-09_JPRB, 0.53290850E-09_JPRB, 0.53297222E-09_JPRB, 0.53304133E-09_JPRB, 0.53308130E-09_JPRB, &
  & 0.53309174E-09_JPRB, 0.53309129E-09_JPRB, 0.53308818E-09_JPRB, 0.53308413E-09_JPRB, 0.53307925E-09_JPRB, 0.53307281E-09_JPRB, &
  & 0.53306315E-09_JPRB, 0.53304705E-09_JPRB, 0.53301819E-09_JPRB, 0.53295873E-09_JPRB, 0.53285448E-09_JPRB, 0.53271110E-09_JPRB, &
  & 0.53260923E-09_JPRB, 0.53259563E-09_JPRB, 0.53267357E-09_JPRB, 0.53283422E-09_JPRB, 0.53306654E-09_JPRB, 0.53335314E-09_JPRB, &
  & 0.53367455E-09_JPRB, 0.53400695E-09_JPRB, 0.53432714E-09_JPRB, 0.53461646E-09_JPRB, 0.53486349E-09_JPRB, 0.53506238E-09_JPRB, &
  & 0.53521071E-09_JPRB, 0.53531107E-09_JPRB, 0.53536076E-09_JPRB, 0.53536303E-09_JPRB, 0.53532057E-09_JPRB, 0.53524268E-09_JPRB, &
  & 0.53514004E-09_JPRB, 0.53502286E-09_JPRB, 0.53489713E-09_JPRB, 0.53476668E-09_JPRB, 0.53463411E-09_JPRB, 0.53450772E-09_JPRB, &
  & 0.53439836E-09_JPRB, 0.53432259E-09_JPRB, 0.53428728E-09_JPRB, 0.53428745E-09_JPRB, 0.53430915E-09_JPRB, 0.53433591E-09_JPRB, &
  & 0.53435745E-09_JPRB, 0.53436927E-09_JPRB, 0.53437343E-09_JPRB, 0.53437244E-09_JPRB, 0.53436872E-09_JPRB, 0.53436300E-09_JPRB, &
  & 0.53435506E-09_JPRB, 0.53434468E-09_JPRB, 0.53433064E-09_JPRB, 0.53431448E-09_JPRB, 0.53429838E-09_JPRB, 0.53428495E-09_JPRB, &
  & 0.53427235E-09_JPRB, 0.53426064E-09_JPRB, 0.53424654E-09_JPRB, 0.53422167E-09_JPRB /)

RGHG6(:,59,11) = (/ &
  & 0.53306431E-09_JPRB, 0.53315746E-09_JPRB, 0.53320248E-09_JPRB, 0.53324412E-09_JPRB, 0.53327920E-09_JPRB, 0.53329818E-09_JPRB, &
  & 0.53330051E-09_JPRB, 0.53329807E-09_JPRB, 0.53329485E-09_JPRB, 0.53329174E-09_JPRB, 0.53328808E-09_JPRB, 0.53328325E-09_JPRB, &
  & 0.53327587E-09_JPRB, 0.53326277E-09_JPRB, 0.53323773E-09_JPRB, 0.53318699E-09_JPRB, 0.53308624E-09_JPRB, 0.53294696E-09_JPRB, &
  & 0.53283972E-09_JPRB, 0.53281540E-09_JPRB, 0.53287896E-09_JPRB, 0.53302363E-09_JPRB, 0.53323779E-09_JPRB, 0.53350691E-09_JPRB, &
  & 0.53381027E-09_JPRB, 0.53412696E-09_JPRB, 0.53443228E-09_JPRB, 0.53470850E-09_JPRB, 0.53494342E-09_JPRB, 0.53513177E-09_JPRB, &
  & 0.53527316E-09_JPRB, 0.53536775E-09_JPRB, 0.53541460E-09_JPRB, 0.53541604E-09_JPRB, 0.53537458E-09_JPRB, 0.53529919E-09_JPRB, &
  & 0.53519933E-09_JPRB, 0.53508492E-09_JPRB, 0.53496196E-09_JPRB, 0.53483490E-09_JPRB, 0.53470806E-09_JPRB, 0.53458815E-09_JPRB, &
  & 0.53448906E-09_JPRB, 0.53442284E-09_JPRB, 0.53439619E-09_JPRB, 0.53440286E-09_JPRB, 0.53442900E-09_JPRB, 0.53445881E-09_JPRB, &
  & 0.53448046E-09_JPRB, 0.53449167E-09_JPRB, 0.53449434E-09_JPRB, 0.53449228E-09_JPRB, 0.53448795E-09_JPRB, 0.53448218E-09_JPRB, &
  & 0.53447491E-09_JPRB, 0.53446519E-09_JPRB, 0.53445304E-09_JPRB, 0.53443894E-09_JPRB, 0.53442561E-09_JPRB, 0.53441340E-09_JPRB, &
  & 0.53440308E-09_JPRB, 0.53439209E-09_JPRB, 0.53437915E-09_JPRB, 0.53435500E-09_JPRB /)

RGHG6(:,60,11) = (/ &
  & 0.53335969E-09_JPRB, 0.53341442E-09_JPRB, 0.53344329E-09_JPRB, 0.53346455E-09_JPRB, 0.53348387E-09_JPRB, 0.53349081E-09_JPRB, &
  & 0.53348959E-09_JPRB, 0.53348692E-09_JPRB, 0.53348492E-09_JPRB, 0.53348326E-09_JPRB, 0.53348148E-09_JPRB, 0.53347876E-09_JPRB, &
  & 0.53347377E-09_JPRB, 0.53346394E-09_JPRB, 0.53344223E-09_JPRB, 0.53339538E-09_JPRB, 0.53330018E-09_JPRB, 0.53316601E-09_JPRB, &
  & 0.53306054E-09_JPRB, 0.53303012E-09_JPRB, 0.53308219E-09_JPRB, 0.53321225E-09_JPRB, 0.53341026E-09_JPRB, 0.53366139E-09_JPRB, &
  & 0.53394777E-09_JPRB, 0.53424726E-09_JPRB, 0.53453730E-09_JPRB, 0.53479909E-09_JPRB, 0.53502119E-09_JPRB, 0.53519977E-09_JPRB, &
  & 0.53533289E-09_JPRB, 0.53542276E-09_JPRB, 0.53546684E-09_JPRB, 0.53546811E-09_JPRB, 0.53542826E-09_JPRB, 0.53535559E-09_JPRB, &
  & 0.53525917E-09_JPRB, 0.53514776E-09_JPRB, 0.53502780E-09_JPRB, 0.53490445E-09_JPRB, 0.53478205E-09_JPRB, 0.53466964E-09_JPRB, &
  & 0.53457849E-09_JPRB, 0.53452126E-09_JPRB, 0.53450144E-09_JPRB, 0.53451243E-09_JPRB, 0.53454147E-09_JPRB, 0.53457266E-09_JPRB, &
  & 0.53459481E-09_JPRB, 0.53460425E-09_JPRB, 0.53460492E-09_JPRB, 0.53460131E-09_JPRB, 0.53459598E-09_JPRB, 0.53458937E-09_JPRB, &
  & 0.53458149E-09_JPRB, 0.53457194E-09_JPRB, 0.53456006E-09_JPRB, 0.53454685E-09_JPRB, 0.53453386E-09_JPRB, 0.53452298E-09_JPRB, &
  & 0.53451255E-09_JPRB, 0.53450266E-09_JPRB, 0.53449045E-09_JPRB, 0.53446864E-09_JPRB /)

RGHG6(:,61,11) = (/ &
  & 0.53357596E-09_JPRB, 0.53362492E-09_JPRB, 0.53364430E-09_JPRB, 0.53365801E-09_JPRB, 0.53366606E-09_JPRB, 0.53366722E-09_JPRB, &
  & 0.53366456E-09_JPRB, 0.53366273E-09_JPRB, 0.53366211E-09_JPRB, 0.53366245E-09_JPRB, 0.53366311E-09_JPRB, 0.53366300E-09_JPRB, &
  & 0.53366100E-09_JPRB, 0.53365390E-09_JPRB, 0.53363580E-09_JPRB, 0.53359028E-09_JPRB, 0.53349908E-09_JPRB, 0.53337412E-09_JPRB, &
  & 0.53327398E-09_JPRB, 0.53324067E-09_JPRB, 0.53328386E-09_JPRB, 0.53340132E-09_JPRB, 0.53358395E-09_JPRB, 0.53381816E-09_JPRB, &
  & 0.53408661E-09_JPRB, 0.53436905E-09_JPRB, 0.53464244E-09_JPRB, 0.53488913E-09_JPRB, 0.53509819E-09_JPRB, 0.53526583E-09_JPRB, &
  & 0.53539195E-09_JPRB, 0.53547633E-09_JPRB, 0.53551819E-09_JPRB, 0.53551935E-09_JPRB, 0.53548144E-09_JPRB, 0.53541194E-09_JPRB, &
  & 0.53531907E-09_JPRB, 0.53521099E-09_JPRB, 0.53509425E-09_JPRB, 0.53497434E-09_JPRB, 0.53485727E-09_JPRB, 0.53475080E-09_JPRB, &
  & 0.53466787E-09_JPRB, 0.53461796E-09_JPRB, 0.53460381E-09_JPRB, 0.53461807E-09_JPRB, 0.53464849E-09_JPRB, 0.53468069E-09_JPRB, &
  & 0.53470212E-09_JPRB, 0.53471028E-09_JPRB, 0.53470872E-09_JPRB, 0.53470312E-09_JPRB, 0.53469601E-09_JPRB, 0.53468824E-09_JPRB, &
  & 0.53467925E-09_JPRB, 0.53466853E-09_JPRB, 0.53465604E-09_JPRB, 0.53464261E-09_JPRB, 0.53463012E-09_JPRB, 0.53461857E-09_JPRB, &
  & 0.53460880E-09_JPRB, 0.53459837E-09_JPRB, 0.53458621E-09_JPRB, 0.53456362E-09_JPRB /)

RGHG6(:,62,11) = (/ &
  & 0.53377691E-09_JPRB, 0.53381150E-09_JPRB, 0.53382493E-09_JPRB, 0.53383187E-09_JPRB, 0.53383475E-09_JPRB, 0.53383253E-09_JPRB, &
  & 0.53382920E-09_JPRB, 0.53382809E-09_JPRB, 0.53382920E-09_JPRB, 0.53383203E-09_JPRB, 0.53383575E-09_JPRB, 0.53383958E-09_JPRB, &
  & 0.53384175E-09_JPRB, 0.53383886E-09_JPRB, 0.53382282E-09_JPRB, 0.53377880E-09_JPRB, 0.53369048E-09_JPRB, 0.53357485E-09_JPRB, &
  & 0.53348242E-09_JPRB, 0.53344834E-09_JPRB, 0.53348465E-09_JPRB, 0.53359112E-09_JPRB, 0.53375948E-09_JPRB, 0.53397681E-09_JPRB, &
  & 0.53422750E-09_JPRB, 0.53449206E-09_JPRB, 0.53474858E-09_JPRB, 0.53497928E-09_JPRB, 0.53517463E-09_JPRB, 0.53533178E-09_JPRB, &
  & 0.53544957E-09_JPRB, 0.53552895E-09_JPRB, 0.53556853E-09_JPRB, 0.53556970E-09_JPRB, 0.53553395E-09_JPRB, 0.53546773E-09_JPRB, &
  & 0.53537874E-09_JPRB, 0.53527432E-09_JPRB, 0.53516097E-09_JPRB, 0.53504495E-09_JPRB, 0.53493249E-09_JPRB, 0.53483284E-09_JPRB, &
  & 0.53475674E-09_JPRB, 0.53471344E-09_JPRB, 0.53470384E-09_JPRB, 0.53472049E-09_JPRB, 0.53475163E-09_JPRB, 0.53478366E-09_JPRB, &
  & 0.53480520E-09_JPRB, 0.53481203E-09_JPRB, 0.53480848E-09_JPRB, 0.53480032E-09_JPRB, 0.53479121E-09_JPRB, 0.53478111E-09_JPRB, &
  & 0.53477034E-09_JPRB, 0.53475813E-09_JPRB, 0.53474436E-09_JPRB, 0.53473004E-09_JPRB, 0.53471649E-09_JPRB, 0.53470511E-09_JPRB, &
  & 0.53469429E-09_JPRB, 0.53468374E-09_JPRB, 0.53467081E-09_JPRB, 0.53464771E-09_JPRB /)

RGHG6(:,63,11) = (/ &
  & 0.53394911E-09_JPRB, 0.53398069E-09_JPRB, 0.53399069E-09_JPRB, 0.53399457E-09_JPRB, 0.53399413E-09_JPRB, 0.53398974E-09_JPRB, &
  & 0.53398586E-09_JPRB, 0.53398519E-09_JPRB, 0.53398791E-09_JPRB, 0.53399341E-09_JPRB, 0.53400151E-09_JPRB, 0.53401034E-09_JPRB, &
  & 0.53401789E-09_JPRB, 0.53401938E-09_JPRB, 0.53400517E-09_JPRB, 0.53396071E-09_JPRB, 0.53387611E-09_JPRB, 0.53377219E-09_JPRB, &
  & 0.53368721E-09_JPRB, 0.53365384E-09_JPRB, 0.53368532E-09_JPRB, 0.53378207E-09_JPRB, 0.53393678E-09_JPRB, 0.53413785E-09_JPRB, &
  & 0.53437088E-09_JPRB, 0.53461718E-09_JPRB, 0.53485560E-09_JPRB, 0.53507015E-09_JPRB, 0.53525157E-09_JPRB, 0.53539734E-09_JPRB, &
  & 0.53550697E-09_JPRB, 0.53558075E-09_JPRB, 0.53561777E-09_JPRB, 0.53561883E-09_JPRB, 0.53558535E-09_JPRB, 0.53552296E-09_JPRB, &
  & 0.53543803E-09_JPRB, 0.53533755E-09_JPRB, 0.53522820E-09_JPRB, 0.53511617E-09_JPRB, 0.53500893E-09_JPRB, 0.53491511E-09_JPRB, &
  & 0.53484561E-09_JPRB, 0.53480786E-09_JPRB, 0.53480209E-09_JPRB, 0.53482041E-09_JPRB, 0.53485139E-09_JPRB, 0.53488314E-09_JPRB, &
  & 0.53490445E-09_JPRB, 0.53491078E-09_JPRB, 0.53490556E-09_JPRB, 0.53489524E-09_JPRB, 0.53488314E-09_JPRB, 0.53487081E-09_JPRB, &
  & 0.53485755E-09_JPRB, 0.53484289E-09_JPRB, 0.53482707E-09_JPRB, 0.53481120E-09_JPRB, 0.53479698E-09_JPRB, 0.53478411E-09_JPRB, &
  & 0.53477278E-09_JPRB, 0.53476074E-09_JPRB, 0.53474658E-09_JPRB, 0.53472077E-09_JPRB /)

RGHG6(:,64,11) = (/ &
  & 0.53410815E-09_JPRB, 0.53413718E-09_JPRB, 0.53414595E-09_JPRB, 0.53414834E-09_JPRB, 0.53414650E-09_JPRB, 0.53414112E-09_JPRB, &
  & 0.53413629E-09_JPRB, 0.53413568E-09_JPRB, 0.53413968E-09_JPRB, 0.53414823E-09_JPRB, 0.53416072E-09_JPRB, 0.53417615E-09_JPRB, &
  & 0.53418980E-09_JPRB, 0.53419547E-09_JPRB, 0.53418242E-09_JPRB, 0.53413818E-09_JPRB, 0.53406024E-09_JPRB, 0.53396526E-09_JPRB, &
  & 0.53388788E-09_JPRB, 0.53385657E-09_JPRB, 0.53388460E-09_JPRB, 0.53397292E-09_JPRB, 0.53411486E-09_JPRB, 0.53430010E-09_JPRB, &
  & 0.53451527E-09_JPRB, 0.53474275E-09_JPRB, 0.53496307E-09_JPRB, 0.53516064E-09_JPRB, 0.53532773E-09_JPRB, 0.53546184E-09_JPRB, &
  & 0.53556282E-09_JPRB, 0.53563076E-09_JPRB, 0.53566496E-09_JPRB, 0.53566596E-09_JPRB, 0.53563493E-09_JPRB, 0.53557653E-09_JPRB, &
  & 0.53549609E-09_JPRB, 0.53540011E-09_JPRB, 0.53529492E-09_JPRB, 0.53518751E-09_JPRB, 0.53508525E-09_JPRB, 0.53499744E-09_JPRB, &
  & 0.53493376E-09_JPRB, 0.53490079E-09_JPRB, 0.53489801E-09_JPRB, 0.53491733E-09_JPRB, 0.53494820E-09_JPRB, 0.53497873E-09_JPRB, &
  & 0.53499977E-09_JPRB, 0.53500626E-09_JPRB, 0.53500032E-09_JPRB, 0.53498772E-09_JPRB, 0.53497334E-09_JPRB, 0.53495763E-09_JPRB, &
  & 0.53494142E-09_JPRB, 0.53492399E-09_JPRB, 0.53490590E-09_JPRB, 0.53488819E-09_JPRB, 0.53487192E-09_JPRB, 0.53485810E-09_JPRB, &
  & 0.53484489E-09_JPRB, 0.53483162E-09_JPRB, 0.53481491E-09_JPRB, 0.53478477E-09_JPRB /)

RGHG6(:,65,11) = (/ &
  & 0.53425542E-09_JPRB, 0.53428495E-09_JPRB, 0.53429333E-09_JPRB, 0.53429561E-09_JPRB, 0.53429339E-09_JPRB, 0.53428750E-09_JPRB, &
  & 0.53428240E-09_JPRB, 0.53428184E-09_JPRB, 0.53428706E-09_JPRB, 0.53429894E-09_JPRB, 0.53431637E-09_JPRB, 0.53433757E-09_JPRB, &
  & 0.53435684E-09_JPRB, 0.53436516E-09_JPRB, 0.53435240E-09_JPRB, 0.53431071E-09_JPRB, 0.53423915E-09_JPRB, 0.53415422E-09_JPRB, &
  & 0.53408433E-09_JPRB, 0.53405580E-09_JPRB, 0.53408156E-09_JPRB, 0.53416221E-09_JPRB, 0.53429206E-09_JPRB, 0.53446170E-09_JPRB, &
  & 0.53465887E-09_JPRB, 0.53486721E-09_JPRB, 0.53506860E-09_JPRB, 0.53524934E-09_JPRB, 0.53540161E-09_JPRB, 0.53552385E-09_JPRB, &
  & 0.53561577E-09_JPRB, 0.53567750E-09_JPRB, 0.53570864E-09_JPRB, 0.53570959E-09_JPRB, 0.53568117E-09_JPRB, 0.53562704E-09_JPRB, &
  & 0.53555171E-09_JPRB, 0.53546101E-09_JPRB, 0.53536087E-09_JPRB, 0.53525850E-09_JPRB, 0.53516164E-09_JPRB, 0.53507954E-09_JPRB, &
  & 0.53502136E-09_JPRB, 0.53499222E-09_JPRB, 0.53499161E-09_JPRB, 0.53501154E-09_JPRB, 0.53504157E-09_JPRB, 0.53507088E-09_JPRB, &
  & 0.53509114E-09_JPRB, 0.53509791E-09_JPRB, 0.53509203E-09_JPRB, 0.53507843E-09_JPRB, 0.53506127E-09_JPRB, 0.53504290E-09_JPRB, &
  & 0.53502325E-09_JPRB, 0.53500299E-09_JPRB, 0.53498217E-09_JPRB, 0.53496230E-09_JPRB, 0.53494453E-09_JPRB, 0.53492821E-09_JPRB, &
  & 0.53491345E-09_JPRB, 0.53489713E-09_JPRB, 0.53487687E-09_JPRB, 0.53483939E-09_JPRB /)

RGHG6(:,66,11) = (/ &
  & 0.53438787E-09_JPRB, 0.53442262E-09_JPRB, 0.53443355E-09_JPRB, 0.53443705E-09_JPRB, 0.53443555E-09_JPRB, 0.53443033E-09_JPRB, &
  & 0.53442528E-09_JPRB, 0.53442517E-09_JPRB, 0.53443250E-09_JPRB, 0.53444699E-09_JPRB, 0.53446964E-09_JPRB, 0.53449534E-09_JPRB, &
  & 0.53451765E-09_JPRB, 0.53452787E-09_JPRB, 0.53451649E-09_JPRB, 0.53447863E-09_JPRB, 0.53441424E-09_JPRB, 0.53433791E-09_JPRB, &
  & 0.53427557E-09_JPRB, 0.53425059E-09_JPRB, 0.53427474E-09_JPRB, 0.53434851E-09_JPRB, 0.53446658E-09_JPRB, 0.53462063E-09_JPRB, &
  & 0.53479943E-09_JPRB, 0.53498811E-09_JPRB, 0.53517057E-09_JPRB, 0.53533378E-09_JPRB, 0.53547133E-09_JPRB, 0.53558158E-09_JPRB, &
  & 0.53566462E-09_JPRB, 0.53572002E-09_JPRB, 0.53574800E-09_JPRB, 0.53574895E-09_JPRB, 0.53572324E-09_JPRB, 0.53567362E-09_JPRB, &
  & 0.53560395E-09_JPRB, 0.53551913E-09_JPRB, 0.53542515E-09_JPRB, 0.53532856E-09_JPRB, 0.53523774E-09_JPRB, 0.53516125E-09_JPRB, &
  & 0.53510801E-09_JPRB, 0.53508220E-09_JPRB, 0.53508298E-09_JPRB, 0.53510274E-09_JPRB, 0.53513166E-09_JPRB, 0.53515931E-09_JPRB, &
  & 0.53517879E-09_JPRB, 0.53518512E-09_JPRB, 0.53517979E-09_JPRB, 0.53516569E-09_JPRB, 0.53514737E-09_JPRB, 0.53512605E-09_JPRB, &
  & 0.53510396E-09_JPRB, 0.53508065E-09_JPRB, 0.53505778E-09_JPRB, 0.53503574E-09_JPRB, 0.53501548E-09_JPRB, 0.53499744E-09_JPRB, &
  & 0.53497939E-09_JPRB, 0.53496008E-09_JPRB, 0.53493432E-09_JPRB, 0.53488602E-09_JPRB /)

RGHG6(:,67,11) = (/ &
  & 0.53451649E-09_JPRB, 0.53455662E-09_JPRB, 0.53456928E-09_JPRB, 0.53457438E-09_JPRB, 0.53457394E-09_JPRB, 0.53456983E-09_JPRB, &
  & 0.53456595E-09_JPRB, 0.53456711E-09_JPRB, 0.53457594E-09_JPRB, 0.53459476E-09_JPRB, 0.53461990E-09_JPRB, 0.53464871E-09_JPRB, &
  & 0.53467253E-09_JPRB, 0.53468402E-09_JPRB, 0.53467447E-09_JPRB, 0.53464039E-09_JPRB, 0.53458304E-09_JPRB, 0.53451582E-09_JPRB, &
  & 0.53446103E-09_JPRB, 0.53443955E-09_JPRB, 0.53446203E-09_JPRB, 0.53452898E-09_JPRB, 0.53463539E-09_JPRB, 0.53477378E-09_JPRB, &
  & 0.53493454E-09_JPRB, 0.53510352E-09_JPRB, 0.53526694E-09_JPRB, 0.53541316E-09_JPRB, 0.53553600E-09_JPRB, 0.53563448E-09_JPRB, &
  & 0.53570881E-09_JPRB, 0.53575822E-09_JPRB, 0.53578320E-09_JPRB, 0.53578386E-09_JPRB, 0.53576077E-09_JPRB, 0.53571592E-09_JPRB, &
  & 0.53565224E-09_JPRB, 0.53557403E-09_JPRB, 0.53548688E-09_JPRB, 0.53539695E-09_JPRB, 0.53531257E-09_JPRB, 0.53524207E-09_JPRB, &
  & 0.53519333E-09_JPRB, 0.53517041E-09_JPRB, 0.53517202E-09_JPRB, 0.53519095E-09_JPRB, 0.53521820E-09_JPRB, 0.53524418E-09_JPRB, &
  & 0.53526245E-09_JPRB, 0.53526850E-09_JPRB, 0.53526344E-09_JPRB, 0.53524968E-09_JPRB, 0.53523019E-09_JPRB, 0.53520804E-09_JPRB, &
  & 0.53518345E-09_JPRB, 0.53515853E-09_JPRB, 0.53513327E-09_JPRB, 0.53510935E-09_JPRB, 0.53508742E-09_JPRB, 0.53506655E-09_JPRB, &
  & 0.53504651E-09_JPRB, 0.53502247E-09_JPRB, 0.53499016E-09_JPRB, 0.53492683E-09_JPRB /)

RGHG6(:,68,11) = (/ &
  & 0.53463489E-09_JPRB, 0.53468346E-09_JPRB, 0.53470067E-09_JPRB, 0.53470806E-09_JPRB, 0.53470950E-09_JPRB, 0.53470722E-09_JPRB, &
  & 0.53470495E-09_JPRB, 0.53470794E-09_JPRB, 0.53471955E-09_JPRB, 0.53473986E-09_JPRB, 0.53476779E-09_JPRB, 0.53479721E-09_JPRB, &
  & 0.53482141E-09_JPRB, 0.53483362E-09_JPRB, 0.53482552E-09_JPRB, 0.53479576E-09_JPRB, 0.53474519E-09_JPRB, 0.53468641E-09_JPRB, &
  & 0.53463856E-09_JPRB, 0.53462029E-09_JPRB, 0.53464105E-09_JPRB, 0.53470101E-09_JPRB, 0.53479587E-09_JPRB, 0.53491916E-09_JPRB, &
  & 0.53506183E-09_JPRB, 0.53521199E-09_JPRB, 0.53535704E-09_JPRB, 0.53548671E-09_JPRB, 0.53559551E-09_JPRB, 0.53568278E-09_JPRB, &
  & 0.53574867E-09_JPRB, 0.53579235E-09_JPRB, 0.53581428E-09_JPRB, 0.53581478E-09_JPRB, 0.53579413E-09_JPRB, 0.53575389E-09_JPRB, &
  & 0.53569643E-09_JPRB, 0.53562532E-09_JPRB, 0.53554550E-09_JPRB, 0.53546273E-09_JPRB, 0.53538551E-09_JPRB, 0.53532107E-09_JPRB, &
  & 0.53527693E-09_JPRB, 0.53525662E-09_JPRB, 0.53525845E-09_JPRB, 0.53527643E-09_JPRB, 0.53530175E-09_JPRB, 0.53532578E-09_JPRB, &
  & 0.53534266E-09_JPRB, 0.53534827E-09_JPRB, 0.53534321E-09_JPRB, 0.53532972E-09_JPRB, 0.53531052E-09_JPRB, 0.53528737E-09_JPRB, &
  & 0.53526250E-09_JPRB, 0.53523597E-09_JPRB, 0.53520977E-09_JPRB, 0.53518445E-09_JPRB, 0.53516069E-09_JPRB, 0.53513893E-09_JPRB, &
  & 0.53511529E-09_JPRB, 0.53508842E-09_JPRB, 0.53504823E-09_JPRB, 0.53496924E-09_JPRB /)

RGHG6(:,69,11) = (/ &
  & 0.53474902E-09_JPRB, 0.53480859E-09_JPRB, 0.53482951E-09_JPRB, 0.53483973E-09_JPRB, 0.53484339E-09_JPRB, 0.53484334E-09_JPRB, &
  & 0.53484334E-09_JPRB, 0.53484861E-09_JPRB, 0.53486210E-09_JPRB, 0.53488441E-09_JPRB, 0.53491239E-09_JPRB, 0.53494142E-09_JPRB, &
  & 0.53496491E-09_JPRB, 0.53497717E-09_JPRB, 0.53497001E-09_JPRB, 0.53494414E-09_JPRB, 0.53489974E-09_JPRB, 0.53484861E-09_JPRB, &
  & 0.53480720E-09_JPRB, 0.53479149E-09_JPRB, 0.53481009E-09_JPRB, 0.53486315E-09_JPRB, 0.53494686E-09_JPRB, 0.53505550E-09_JPRB, &
  & 0.53518112E-09_JPRB, 0.53531307E-09_JPRB, 0.53544064E-09_JPRB, 0.53555482E-09_JPRB, 0.53565030E-09_JPRB, 0.53572685E-09_JPRB, &
  & 0.53578475E-09_JPRB, 0.53582289E-09_JPRB, 0.53584209E-09_JPRB, 0.53584215E-09_JPRB, 0.53582394E-09_JPRB, 0.53578825E-09_JPRB, &
  & 0.53573695E-09_JPRB, 0.53567278E-09_JPRB, 0.53560056E-09_JPRB, 0.53552573E-09_JPRB, 0.53545590E-09_JPRB, 0.53539778E-09_JPRB, &
  & 0.53535837E-09_JPRB, 0.53534044E-09_JPRB, 0.53534271E-09_JPRB, 0.53535926E-09_JPRB, 0.53538246E-09_JPRB, 0.53540455E-09_JPRB, &
  & 0.53541988E-09_JPRB, 0.53542487E-09_JPRB, 0.53541971E-09_JPRB, 0.53540683E-09_JPRB, 0.53538779E-09_JPRB, 0.53536531E-09_JPRB, &
  & 0.53534022E-09_JPRB, 0.53531374E-09_JPRB, 0.53528693E-09_JPRB, 0.53526100E-09_JPRB, 0.53523713E-09_JPRB, 0.53521326E-09_JPRB, &
  & 0.53518945E-09_JPRB, 0.53515881E-09_JPRB, 0.53511284E-09_JPRB, 0.53501770E-09_JPRB /)

RGHG6(:,70,11) = (/ &
  & 0.53486099E-09_JPRB, 0.53493110E-09_JPRB, 0.53495730E-09_JPRB, 0.53497040E-09_JPRB, 0.53497640E-09_JPRB, 0.53497889E-09_JPRB, &
  & 0.53498139E-09_JPRB, 0.53498905E-09_JPRB, 0.53500399E-09_JPRB, 0.53502680E-09_JPRB, 0.53505345E-09_JPRB, 0.53508065E-09_JPRB, &
  & 0.53510230E-09_JPRB, 0.53511395E-09_JPRB, 0.53510751E-09_JPRB, 0.53508520E-09_JPRB, 0.53504612E-09_JPRB, 0.53500149E-09_JPRB, &
  & 0.53496535E-09_JPRB, 0.53495175E-09_JPRB, 0.53496824E-09_JPRB, 0.53501442E-09_JPRB, 0.53508759E-09_JPRB, 0.53518245E-09_JPRB, &
  & 0.53529198E-09_JPRB, 0.53540694E-09_JPRB, 0.53551819E-09_JPRB, 0.53561744E-09_JPRB, 0.53570065E-09_JPRB, 0.53576688E-09_JPRB, &
  & 0.53581739E-09_JPRB, 0.53585025E-09_JPRB, 0.53586680E-09_JPRB, 0.53586652E-09_JPRB, 0.53585064E-09_JPRB, 0.53581917E-09_JPRB, &
  & 0.53577398E-09_JPRB, 0.53571697E-09_JPRB, 0.53565252E-09_JPRB, 0.53558546E-09_JPRB, 0.53552301E-09_JPRB, 0.53547133E-09_JPRB, &
  & 0.53543686E-09_JPRB, 0.53542165E-09_JPRB, 0.53542409E-09_JPRB, 0.53543947E-09_JPRB, 0.53546034E-09_JPRB, 0.53548044E-09_JPRB, &
  & 0.53549415E-09_JPRB, 0.53549831E-09_JPRB, 0.53549315E-09_JPRB, 0.53548099E-09_JPRB, 0.53546284E-09_JPRB, 0.53544125E-09_JPRB, &
  & 0.53541732E-09_JPRB, 0.53539156E-09_JPRB, 0.53536536E-09_JPRB, 0.53534005E-09_JPRB, 0.53531601E-09_JPRB, 0.53529292E-09_JPRB, &
  & 0.53526783E-09_JPRB, 0.53523697E-09_JPRB, 0.53518628E-09_JPRB, 0.53507987E-09_JPRB /)

RGHG6(:,71,11) = (/ &
  & 0.53497395E-09_JPRB, 0.53505467E-09_JPRB, 0.53508442E-09_JPRB, 0.53510024E-09_JPRB, 0.53510846E-09_JPRB, 0.53511323E-09_JPRB, &
  & 0.53511828E-09_JPRB, 0.53512761E-09_JPRB, 0.53514382E-09_JPRB, 0.53516486E-09_JPRB, 0.53518989E-09_JPRB, 0.53521365E-09_JPRB, &
  & 0.53523291E-09_JPRB, 0.53524368E-09_JPRB, 0.53523674E-09_JPRB, 0.53521776E-09_JPRB, 0.53518356E-09_JPRB, 0.53514482E-09_JPRB, &
  & 0.53511323E-09_JPRB, 0.53510107E-09_JPRB, 0.53511534E-09_JPRB, 0.53515536E-09_JPRB, 0.53521837E-09_JPRB, 0.53530053E-09_JPRB, &
  & 0.53539456E-09_JPRB, 0.53549376E-09_JPRB, 0.53558957E-09_JPRB, 0.53567506E-09_JPRB, 0.53574656E-09_JPRB, 0.53580340E-09_JPRB, &
  & 0.53584670E-09_JPRB, 0.53587484E-09_JPRB, 0.53588883E-09_JPRB, 0.53588822E-09_JPRB, 0.53587457E-09_JPRB, 0.53584737E-09_JPRB, &
  & 0.53580795E-09_JPRB, 0.53575777E-09_JPRB, 0.53570115E-09_JPRB, 0.53564181E-09_JPRB, 0.53558702E-09_JPRB, 0.53554167E-09_JPRB, &
  & 0.53551197E-09_JPRB, 0.53549937E-09_JPRB, 0.53550220E-09_JPRB, 0.53551652E-09_JPRB, 0.53553512E-09_JPRB, 0.53555299E-09_JPRB, &
  & 0.53556504E-09_JPRB, 0.53556864E-09_JPRB, 0.53556348E-09_JPRB, 0.53555260E-09_JPRB, 0.53553567E-09_JPRB, 0.53551569E-09_JPRB, &
  & 0.53549376E-09_JPRB, 0.53546961E-09_JPRB, 0.53544508E-09_JPRB, 0.53542110E-09_JPRB, 0.53539806E-09_JPRB, 0.53537580E-09_JPRB, &
  & 0.53535182E-09_JPRB, 0.53532068E-09_JPRB, 0.53526955E-09_JPRB, 0.53515625E-09_JPRB /)

RGHG6(:,72,11) = (/ &
  & 0.53509086E-09_JPRB, 0.53517790E-09_JPRB, 0.53521082E-09_JPRB, 0.53522808E-09_JPRB, 0.53523774E-09_JPRB, 0.53524463E-09_JPRB, &
  & 0.53525151E-09_JPRB, 0.53526239E-09_JPRB, 0.53527754E-09_JPRB, 0.53529803E-09_JPRB, 0.53531840E-09_JPRB, 0.53533977E-09_JPRB, &
  & 0.53535543E-09_JPRB, 0.53536514E-09_JPRB, 0.53535848E-09_JPRB, 0.53534160E-09_JPRB, 0.53531191E-09_JPRB, 0.53527816E-09_JPRB, &
  & 0.53525057E-09_JPRB, 0.53523963E-09_JPRB, 0.53525218E-09_JPRB, 0.53528609E-09_JPRB, 0.53533966E-09_JPRB, 0.53540927E-09_JPRB, &
  & 0.53548943E-09_JPRB, 0.53557342E-09_JPRB, 0.53565530E-09_JPRB, 0.53572785E-09_JPRB, 0.53578852E-09_JPRB, 0.53583626E-09_JPRB, &
  & 0.53587312E-09_JPRB, 0.53589666E-09_JPRB, 0.53590860E-09_JPRB, 0.53590771E-09_JPRB, 0.53589622E-09_JPRB, 0.53587279E-09_JPRB, &
  & 0.53583898E-09_JPRB, 0.53579546E-09_JPRB, 0.53574650E-09_JPRB, 0.53569493E-09_JPRB, 0.53564736E-09_JPRB, 0.53560845E-09_JPRB, &
  & 0.53558336E-09_JPRB, 0.53557325E-09_JPRB, 0.53557653E-09_JPRB, 0.53558979E-09_JPRB, 0.53560612E-09_JPRB, 0.53562171E-09_JPRB, &
  & 0.53563221E-09_JPRB, 0.53563520E-09_JPRB, 0.53563026E-09_JPRB, 0.53562077E-09_JPRB, 0.53560584E-09_JPRB, 0.53558813E-09_JPRB, &
  & 0.53556842E-09_JPRB, 0.53554750E-09_JPRB, 0.53552479E-09_JPRB, 0.53550264E-09_JPRB, 0.53548205E-09_JPRB, 0.53546062E-09_JPRB, &
  & 0.53543830E-09_JPRB, 0.53540933E-09_JPRB, 0.53535804E-09_JPRB, 0.53524363E-09_JPRB /)

RGHG6(:,73,11) = (/ &
  & 0.53521371E-09_JPRB, 0.53530180E-09_JPRB, 0.53533461E-09_JPRB, 0.53535210E-09_JPRB, 0.53536225E-09_JPRB, 0.53537025E-09_JPRB, &
  & 0.53537846E-09_JPRB, 0.53538896E-09_JPRB, 0.53540428E-09_JPRB, 0.53542032E-09_JPRB, 0.53543953E-09_JPRB, 0.53545585E-09_JPRB, &
  & 0.53546922E-09_JPRB, 0.53547750E-09_JPRB, 0.53547156E-09_JPRB, 0.53545601E-09_JPRB, 0.53543037E-09_JPRB, 0.53540128E-09_JPRB, &
  & 0.53537741E-09_JPRB, 0.53536803E-09_JPRB, 0.53537880E-09_JPRB, 0.53540711E-09_JPRB, 0.53545135E-09_JPRB, 0.53550980E-09_JPRB, &
  & 0.53557636E-09_JPRB, 0.53564697E-09_JPRB, 0.53571525E-09_JPRB, 0.53577587E-09_JPRB, 0.53582616E-09_JPRB, 0.53586574E-09_JPRB, &
  & 0.53589683E-09_JPRB, 0.53591626E-09_JPRB, 0.53592625E-09_JPRB, 0.53592508E-09_JPRB, 0.53591542E-09_JPRB, 0.53589583E-09_JPRB, &
  & 0.53586724E-09_JPRB, 0.53583016E-09_JPRB, 0.53578891E-09_JPRB, 0.53574473E-09_JPRB, 0.53570437E-09_JPRB, 0.53567151E-09_JPRB, &
  & 0.53565086E-09_JPRB, 0.53564286E-09_JPRB, 0.53564631E-09_JPRB, 0.53565835E-09_JPRB, 0.53567240E-09_JPRB, 0.53568588E-09_JPRB, &
  & 0.53569493E-09_JPRB, 0.53569754E-09_JPRB, 0.53569321E-09_JPRB, 0.53568550E-09_JPRB, 0.53567251E-09_JPRB, 0.53565719E-09_JPRB, &
  & 0.53564098E-09_JPRB, 0.53562227E-09_JPRB, 0.53560267E-09_JPRB, 0.53558363E-09_JPRB, 0.53556409E-09_JPRB, 0.53554583E-09_JPRB, &
  & 0.53552485E-09_JPRB, 0.53549787E-09_JPRB, 0.53545091E-09_JPRB, 0.53533639E-09_JPRB /)

RGHG6(:,74,11) = (/ &
  & 0.53533528E-09_JPRB, 0.53542176E-09_JPRB, 0.53545346E-09_JPRB, 0.53547011E-09_JPRB, 0.53547977E-09_JPRB, 0.53548804E-09_JPRB, &
  & 0.53549609E-09_JPRB, 0.53550675E-09_JPRB, 0.53551896E-09_JPRB, 0.53553478E-09_JPRB, 0.53554838E-09_JPRB, 0.53556326E-09_JPRB, &
  & 0.53557325E-09_JPRB, 0.53558002E-09_JPRB, 0.53557514E-09_JPRB, 0.53556132E-09_JPRB, 0.53553950E-09_JPRB, 0.53551441E-09_JPRB, &
  & 0.53549409E-09_JPRB, 0.53548588E-09_JPRB, 0.53549565E-09_JPRB, 0.53551863E-09_JPRB, 0.53555421E-09_JPRB, 0.53560195E-09_JPRB, &
  & 0.53565641E-09_JPRB, 0.53571431E-09_JPRB, 0.53576987E-09_JPRB, 0.53581961E-09_JPRB, 0.53586019E-09_JPRB, 0.53589227E-09_JPRB, &
  & 0.53591798E-09_JPRB, 0.53593358E-09_JPRB, 0.53594174E-09_JPRB, 0.53594063E-09_JPRB, 0.53593280E-09_JPRB, 0.53591653E-09_JPRB, &
  & 0.53589294E-09_JPRB, 0.53586219E-09_JPRB, 0.53582833E-09_JPRB, 0.53579130E-09_JPRB, 0.53575760E-09_JPRB, 0.53573074E-09_JPRB, &
  & 0.53571414E-09_JPRB, 0.53570809E-09_JPRB, 0.53571142E-09_JPRB, 0.53572208E-09_JPRB, 0.53573368E-09_JPRB, 0.53574517E-09_JPRB, &
  & 0.53575305E-09_JPRB, 0.53575555E-09_JPRB, 0.53575189E-09_JPRB, 0.53574623E-09_JPRB, 0.53573529E-09_JPRB, 0.53572241E-09_JPRB, &
  & 0.53570831E-09_JPRB, 0.53569349E-09_JPRB, 0.53567656E-09_JPRB, 0.53565957E-09_JPRB, 0.53564425E-09_JPRB, 0.53562654E-09_JPRB, &
  & 0.53560911E-09_JPRB, 0.53558535E-09_JPRB, 0.53554094E-09_JPRB, 0.53543453E-09_JPRB /)

RGHG6(:,75,11) = (/ &
  & 0.53545340E-09_JPRB, 0.53553617E-09_JPRB, 0.53556598E-09_JPRB, 0.53558075E-09_JPRB, 0.53558918E-09_JPRB, 0.53559684E-09_JPRB, &
  & 0.53560467E-09_JPRB, 0.53561344E-09_JPRB, 0.53562510E-09_JPRB, 0.53563642E-09_JPRB, 0.53564908E-09_JPRB, 0.53565974E-09_JPRB, &
  & 0.53566818E-09_JPRB, 0.53567339E-09_JPRB, 0.53566995E-09_JPRB, 0.53565730E-09_JPRB, 0.53563909E-09_JPRB, 0.53561788E-09_JPRB, &
  & 0.53560106E-09_JPRB, 0.53559435E-09_JPRB, 0.53560323E-09_JPRB, 0.53562127E-09_JPRB, 0.53564875E-09_JPRB, 0.53568650E-09_JPRB, &
  & 0.53572963E-09_JPRB, 0.53577609E-09_JPRB, 0.53581967E-09_JPRB, 0.53585913E-09_JPRB, 0.53589050E-09_JPRB, 0.53591592E-09_JPRB, &
  & 0.53593685E-09_JPRB, 0.53594890E-09_JPRB, 0.53595584E-09_JPRB, 0.53595450E-09_JPRB, 0.53594823E-09_JPRB, 0.53593530E-09_JPRB, &
  & 0.53591620E-09_JPRB, 0.53589166E-09_JPRB, 0.53586491E-09_JPRB, 0.53583471E-09_JPRB, 0.53580773E-09_JPRB, 0.53578614E-09_JPRB, &
  & 0.53577320E-09_JPRB, 0.53576871E-09_JPRB, 0.53577176E-09_JPRB, 0.53578075E-09_JPRB, 0.53578997E-09_JPRB, 0.53579974E-09_JPRB, &
  & 0.53580634E-09_JPRB, 0.53580879E-09_JPRB, 0.53580579E-09_JPRB, 0.53580246E-09_JPRB, 0.53579330E-09_JPRB, 0.53578214E-09_JPRB, &
  & 0.53577137E-09_JPRB, 0.53575877E-09_JPRB, 0.53574517E-09_JPRB, 0.53573218E-09_JPRB, 0.53571803E-09_JPRB, 0.53570437E-09_JPRB, &
  & 0.53568849E-09_JPRB, 0.53566857E-09_JPRB, 0.53563032E-09_JPRB, 0.53553023E-09_JPRB /)

RGHG6(:,76,11) = (/ &
  & 0.53556720E-09_JPRB, 0.53564464E-09_JPRB, 0.53567134E-09_JPRB, 0.53568394E-09_JPRB, 0.53569033E-09_JPRB, 0.53569710E-09_JPRB, &
  & 0.53570359E-09_JPRB, 0.53571125E-09_JPRB, 0.53571986E-09_JPRB, 0.53573002E-09_JPRB, 0.53573795E-09_JPRB, 0.53574722E-09_JPRB, &
  & 0.53575305E-09_JPRB, 0.53575688E-09_JPRB, 0.53575511E-09_JPRB, 0.53574439E-09_JPRB, 0.53572996E-09_JPRB, 0.53571253E-09_JPRB, &
  & 0.53569882E-09_JPRB, 0.53569338E-09_JPRB, 0.53570204E-09_JPRB, 0.53571581E-09_JPRB, 0.53573546E-09_JPRB, 0.53576410E-09_JPRB, &
  & 0.53579657E-09_JPRB, 0.53583243E-09_JPRB, 0.53586502E-09_JPRB, 0.53589477E-09_JPRB, 0.53591742E-09_JPRB, 0.53593702E-09_JPRB, &
  & 0.53595373E-09_JPRB, 0.53596255E-09_JPRB, 0.53596816E-09_JPRB, 0.53596666E-09_JPRB, 0.53596211E-09_JPRB, 0.53595228E-09_JPRB, &
  & 0.53593729E-09_JPRB, 0.53591875E-09_JPRB, 0.53589877E-09_JPRB, 0.53587529E-09_JPRB, 0.53585469E-09_JPRB, 0.53583799E-09_JPRB, &
  & 0.53582827E-09_JPRB, 0.53582500E-09_JPRB, 0.53582738E-09_JPRB, 0.53583515E-09_JPRB, 0.53584148E-09_JPRB, 0.53584953E-09_JPRB, &
  & 0.53585480E-09_JPRB, 0.53585725E-09_JPRB, 0.53585480E-09_JPRB, 0.53585392E-09_JPRB, 0.53584631E-09_JPRB, 0.53583693E-09_JPRB, &
  & 0.53582810E-09_JPRB, 0.53581950E-09_JPRB, 0.53580873E-09_JPRB, 0.53579846E-09_JPRB, 0.53578869E-09_JPRB, 0.53577587E-09_JPRB, &
  & 0.53576404E-09_JPRB, 0.53574772E-09_JPRB, 0.53571497E-09_JPRB, 0.53562638E-09_JPRB /)

RGHG6(:,77,11) = (/ &
  & 0.53567600E-09_JPRB, 0.53574534E-09_JPRB, 0.53576865E-09_JPRB, 0.53577859E-09_JPRB, 0.53578258E-09_JPRB, 0.53578803E-09_JPRB, &
  & 0.53579363E-09_JPRB, 0.53579874E-09_JPRB, 0.53580568E-09_JPRB, 0.53581201E-09_JPRB, 0.53581739E-09_JPRB, 0.53582333E-09_JPRB, &
  & 0.53582760E-09_JPRB, 0.53583044E-09_JPRB, 0.53583077E-09_JPRB, 0.53582155E-09_JPRB, 0.53581151E-09_JPRB, 0.53579763E-09_JPRB, &
  & 0.53578736E-09_JPRB, 0.53578320E-09_JPRB, 0.53579230E-09_JPRB, 0.53580174E-09_JPRB, 0.53581417E-09_JPRB, 0.53583438E-09_JPRB, &
  & 0.53585747E-09_JPRB, 0.53588323E-09_JPRB, 0.53590576E-09_JPRB, 0.53592653E-09_JPRB, 0.53594112E-09_JPRB, 0.53595545E-09_JPRB, &
  & 0.53596855E-09_JPRB, 0.53597443E-09_JPRB, 0.53597909E-09_JPRB, 0.53597760E-09_JPRB, 0.53597460E-09_JPRB, 0.53596749E-09_JPRB, &
  & 0.53595633E-09_JPRB, 0.53594340E-09_JPRB, 0.53592986E-09_JPRB, 0.53591265E-09_JPRB, 0.53589788E-09_JPRB, 0.53588556E-09_JPRB, &
  & 0.53587884E-09_JPRB, 0.53587651E-09_JPRB, 0.53587806E-09_JPRB, 0.53588445E-09_JPRB, 0.53588800E-09_JPRB, 0.53589438E-09_JPRB, &
  & 0.53589844E-09_JPRB, 0.53590088E-09_JPRB, 0.53589849E-09_JPRB, 0.53590038E-09_JPRB, 0.53589400E-09_JPRB, 0.53588556E-09_JPRB, &
  & 0.53587967E-09_JPRB, 0.53587407E-09_JPRB, 0.53586668E-09_JPRB, 0.53586036E-09_JPRB, 0.53585258E-09_JPRB, 0.53584326E-09_JPRB, &
  & 0.53583338E-09_JPRB, 0.53582172E-09_JPRB, 0.53579541E-09_JPRB, 0.53572019E-09_JPRB /)

RGHG6(:,78,11) = (/ &
  & 0.53577853E-09_JPRB, 0.53583432E-09_JPRB, 0.53585186E-09_JPRB, 0.53585886E-09_JPRB, 0.53586019E-09_JPRB, 0.53586469E-09_JPRB, &
  & 0.53586896E-09_JPRB, 0.53587212E-09_JPRB, 0.53587629E-09_JPRB, 0.53588001E-09_JPRB, 0.53588145E-09_JPRB, 0.53588539E-09_JPRB, &
  & 0.53588783E-09_JPRB, 0.53588994E-09_JPRB, 0.53589289E-09_JPRB, 0.53588539E-09_JPRB, 0.53587940E-09_JPRB, 0.53586896E-09_JPRB, &
  & 0.53586202E-09_JPRB, 0.53585941E-09_JPRB, 0.53586913E-09_JPRB, 0.53587523E-09_JPRB, 0.53588106E-09_JPRB, 0.53589411E-09_JPRB, &
  & 0.53590921E-09_JPRB, 0.53592625E-09_JPRB, 0.53594024E-09_JPRB, 0.53595339E-09_JPRB, 0.53596083E-09_JPRB, 0.53597071E-09_JPRB, &
  & 0.53598098E-09_JPRB, 0.53598426E-09_JPRB, 0.53598803E-09_JPRB, 0.53598664E-09_JPRB, 0.53598492E-09_JPRB, 0.53598026E-09_JPRB, &
  & 0.53597232E-09_JPRB, 0.53596444E-09_JPRB, 0.53595645E-09_JPRB, 0.53594468E-09_JPRB, 0.53593496E-09_JPRB, 0.53592647E-09_JPRB, &
  & 0.53592208E-09_JPRB, 0.53592053E-09_JPRB, 0.53592125E-09_JPRB, 0.53592641E-09_JPRB, 0.53592708E-09_JPRB, 0.53593213E-09_JPRB, &
  & 0.53593485E-09_JPRB, 0.53593713E-09_JPRB, 0.53593480E-09_JPRB, 0.53593935E-09_JPRB, 0.53593380E-09_JPRB, 0.53592625E-09_JPRB, &
  & 0.53592242E-09_JPRB, 0.53592003E-09_JPRB, 0.53591542E-09_JPRB, 0.53591226E-09_JPRB, 0.53590771E-09_JPRB, 0.53589977E-09_JPRB, &
  & 0.53589305E-09_JPRB, 0.53588511E-09_JPRB, 0.53586774E-09_JPRB, 0.53581234E-09_JPRB /)

RGHG6(:,79,11) = (/ &
  & 0.53584376E-09_JPRB, 0.53588406E-09_JPRB, 0.53589655E-09_JPRB, 0.53590088E-09_JPRB, 0.53590044E-09_JPRB, 0.53590443E-09_JPRB, &
  & 0.53590832E-09_JPRB, 0.53591004E-09_JPRB, 0.53591298E-09_JPRB, 0.53591509E-09_JPRB, 0.53591442E-09_JPRB, 0.53591731E-09_JPRB, &
  & 0.53591914E-09_JPRB, 0.53592097E-09_JPRB, 0.53592591E-09_JPRB, 0.53591870E-09_JPRB, 0.53591531E-09_JPRB, 0.53590626E-09_JPRB, &
  & 0.53590110E-09_JPRB, 0.53589949E-09_JPRB, 0.53591087E-09_JPRB, 0.53591515E-09_JPRB, 0.53591709E-09_JPRB, 0.53592625E-09_JPRB, &
  & 0.53593707E-09_JPRB, 0.53594967E-09_JPRB, 0.53595922E-09_JPRB, 0.53596821E-09_JPRB, 0.53597121E-09_JPRB, 0.53597882E-09_JPRB, &
  & 0.53598787E-09_JPRB, 0.53598970E-09_JPRB, 0.53599336E-09_JPRB, 0.53599192E-09_JPRB, 0.53599092E-09_JPRB, 0.53598737E-09_JPRB, &
  & 0.53598093E-09_JPRB, 0.53597593E-09_JPRB, 0.53597105E-09_JPRB, 0.53596211E-09_JPRB, 0.53595489E-09_JPRB, 0.53594812E-09_JPRB, &
  & 0.53594501E-09_JPRB, 0.53594379E-09_JPRB, 0.53594401E-09_JPRB, 0.53594879E-09_JPRB, 0.53594751E-09_JPRB, 0.53595206E-09_JPRB, &
  & 0.53595417E-09_JPRB, 0.53595645E-09_JPRB, 0.53595378E-09_JPRB, 0.53596039E-09_JPRB, 0.53595506E-09_JPRB, 0.53594712E-09_JPRB, &
  & 0.53594462E-09_JPRB, 0.53594407E-09_JPRB, 0.53594085E-09_JPRB, 0.53593974E-09_JPRB, 0.53593641E-09_JPRB, 0.53592941E-09_JPRB, &
  & 0.53592353E-09_JPRB, 0.53591886E-09_JPRB, 0.53590793E-09_JPRB, 0.53587190E-09_JPRB /)

RGHG6(:,80,11) = (/ &
  & 0.53588650E-09_JPRB, 0.53590804E-09_JPRB, 0.53591614E-09_JPRB, 0.53591920E-09_JPRB, 0.53591770E-09_JPRB, 0.53592153E-09_JPRB, &
  & 0.53592542E-09_JPRB, 0.53592641E-09_JPRB, 0.53592891E-09_JPRB, 0.53593041E-09_JPRB, 0.53592869E-09_JPRB, 0.53593119E-09_JPRB, &
  & 0.53593280E-09_JPRB, 0.53593457E-09_JPRB, 0.53594090E-09_JPRB, 0.53593369E-09_JPRB, 0.53593130E-09_JPRB, 0.53592270E-09_JPRB, &
  & 0.53591831E-09_JPRB, 0.53591731E-09_JPRB, 0.53592986E-09_JPRB, 0.53593330E-09_JPRB, 0.53593335E-09_JPRB, 0.53594079E-09_JPRB, &
  & 0.53594984E-09_JPRB, 0.53596050E-09_JPRB, 0.53596799E-09_JPRB, 0.53597488E-09_JPRB, 0.53597565E-09_JPRB, 0.53598243E-09_JPRB, &
  & 0.53599131E-09_JPRB, 0.53599242E-09_JPRB, 0.53599608E-09_JPRB, 0.53599458E-09_JPRB, 0.53599380E-09_JPRB, 0.53599086E-09_JPRB, &
  & 0.53598498E-09_JPRB, 0.53598120E-09_JPRB, 0.53597798E-09_JPRB, 0.53596999E-09_JPRB, 0.53596383E-09_JPRB, 0.53595789E-09_JPRB, &
  & 0.53595534E-09_JPRB, 0.53595423E-09_JPRB, 0.53595417E-09_JPRB, 0.53595889E-09_JPRB, 0.53595656E-09_JPRB, 0.53596083E-09_JPRB, &
  & 0.53596261E-09_JPRB, 0.53596511E-09_JPRB, 0.53596205E-09_JPRB, 0.53597010E-09_JPRB, 0.53596455E-09_JPRB, 0.53595611E-09_JPRB, &
  & 0.53595411E-09_JPRB, 0.53595450E-09_JPRB, 0.53595189E-09_JPRB, 0.53595173E-09_JPRB, 0.53594906E-09_JPRB, 0.53594190E-09_JPRB, &
  & 0.53593679E-09_JPRB, 0.53593358E-09_JPRB, 0.53592736E-09_JPRB, 0.53591165E-09_JPRB /)

RGHG6(:,81,11) = (/ &
  & 0.53591492E-09_JPRB, 0.53591814E-09_JPRB, 0.53592458E-09_JPRB, 0.53592714E-09_JPRB, 0.53592514E-09_JPRB, 0.53592897E-09_JPRB, &
  & 0.53593274E-09_JPRB, 0.53593352E-09_JPRB, 0.53593557E-09_JPRB, 0.53593702E-09_JPRB, 0.53593480E-09_JPRB, 0.53593718E-09_JPRB, &
  & 0.53593879E-09_JPRB, 0.53594046E-09_JPRB, 0.53594756E-09_JPRB, 0.53594018E-09_JPRB, 0.53593835E-09_JPRB, 0.53592975E-09_JPRB, &
  & 0.53592564E-09_JPRB, 0.53592480E-09_JPRB, 0.53593852E-09_JPRB, 0.53594140E-09_JPRB, 0.53594063E-09_JPRB, 0.53594718E-09_JPRB, &
  & 0.53595550E-09_JPRB, 0.53596533E-09_JPRB, 0.53597182E-09_JPRB, 0.53597793E-09_JPRB, 0.53597760E-09_JPRB, 0.53598387E-09_JPRB, &
  & 0.53599275E-09_JPRB, 0.53599358E-09_JPRB, 0.53599741E-09_JPRB, 0.53599591E-09_JPRB, 0.53599525E-09_JPRB, 0.53599236E-09_JPRB, &
  & 0.53598681E-09_JPRB, 0.53598359E-09_JPRB, 0.53598098E-09_JPRB, 0.53597360E-09_JPRB, 0.53596788E-09_JPRB, 0.53596216E-09_JPRB, &
  & 0.53595983E-09_JPRB, 0.53595867E-09_JPRB, 0.53595856E-09_JPRB, 0.53596338E-09_JPRB, 0.53596028E-09_JPRB, 0.53596455E-09_JPRB, &
  & 0.53596633E-09_JPRB, 0.53596888E-09_JPRB, 0.53596561E-09_JPRB, 0.53597454E-09_JPRB, 0.53596877E-09_JPRB, 0.53595983E-09_JPRB, &
  & 0.53595822E-09_JPRB, 0.53595900E-09_JPRB, 0.53595667E-09_JPRB, 0.53595700E-09_JPRB, 0.53595473E-09_JPRB, 0.53594745E-09_JPRB, &
  & 0.53594229E-09_JPRB, 0.53593974E-09_JPRB, 0.53593557E-09_JPRB, 0.53593929E-09_JPRB /)

RGHG6(:,82,11) = (/ &
  & 0.53591720E-09_JPRB, 0.53592153E-09_JPRB, 0.53592836E-09_JPRB, 0.53593091E-09_JPRB, 0.53592875E-09_JPRB, 0.53593247E-09_JPRB, &
  & 0.53593646E-09_JPRB, 0.53593685E-09_JPRB, 0.53593907E-09_JPRB, 0.53594040E-09_JPRB, 0.53593785E-09_JPRB, 0.53594007E-09_JPRB, &
  & 0.53594168E-09_JPRB, 0.53594335E-09_JPRB, 0.53595101E-09_JPRB, 0.53594340E-09_JPRB, 0.53594190E-09_JPRB, 0.53593302E-09_JPRB, &
  & 0.53592913E-09_JPRB, 0.53592852E-09_JPRB, 0.53594251E-09_JPRB, 0.53594557E-09_JPRB, 0.53594412E-09_JPRB, 0.53595040E-09_JPRB, &
  & 0.53595833E-09_JPRB, 0.53596777E-09_JPRB, 0.53597382E-09_JPRB, 0.53597937E-09_JPRB, 0.53597848E-09_JPRB, 0.53598453E-09_JPRB, &
  & 0.53599358E-09_JPRB, 0.53599425E-09_JPRB, 0.53599825E-09_JPRB, 0.53599658E-09_JPRB, 0.53599597E-09_JPRB, 0.53599319E-09_JPRB, &
  & 0.53598775E-09_JPRB, 0.53598481E-09_JPRB, 0.53598265E-09_JPRB, 0.53597560E-09_JPRB, 0.53596994E-09_JPRB, 0.53596422E-09_JPRB, &
  & 0.53596205E-09_JPRB, 0.53596094E-09_JPRB, 0.53596072E-09_JPRB, 0.53596561E-09_JPRB, 0.53596205E-09_JPRB, 0.53596638E-09_JPRB, &
  & 0.53596799E-09_JPRB, 0.53597071E-09_JPRB, 0.53596733E-09_JPRB, 0.53597682E-09_JPRB, 0.53597093E-09_JPRB, 0.53596166E-09_JPRB, &
  & 0.53596005E-09_JPRB, 0.53596122E-09_JPRB, 0.53595905E-09_JPRB, 0.53595967E-09_JPRB, 0.53595745E-09_JPRB, 0.53595006E-09_JPRB, &
  & 0.53594490E-09_JPRB, 0.53594251E-09_JPRB, 0.53593829E-09_JPRB, 0.53594151E-09_JPRB /)

RGHG6(:,83,11) = (/ &
  & 0.53591864E-09_JPRB, 0.53592347E-09_JPRB, 0.53593058E-09_JPRB, 0.53593313E-09_JPRB, 0.53593080E-09_JPRB, 0.53593446E-09_JPRB, &
  & 0.53593835E-09_JPRB, 0.53593885E-09_JPRB, 0.53594079E-09_JPRB, 0.53594201E-09_JPRB, 0.53593957E-09_JPRB, 0.53594174E-09_JPRB, &
  & 0.53594323E-09_JPRB, 0.53594496E-09_JPRB, 0.53595295E-09_JPRB, 0.53594529E-09_JPRB, 0.53594384E-09_JPRB, 0.53593491E-09_JPRB, &
  & 0.53593097E-09_JPRB, 0.53593024E-09_JPRB, 0.53594518E-09_JPRB, 0.53594795E-09_JPRB, 0.53594612E-09_JPRB, 0.53595217E-09_JPRB, &
  & 0.53596000E-09_JPRB, 0.53596921E-09_JPRB, 0.53597493E-09_JPRB, 0.53598032E-09_JPRB, 0.53597887E-09_JPRB, 0.53598487E-09_JPRB, &
  & 0.53599408E-09_JPRB, 0.53599458E-09_JPRB, 0.53599880E-09_JPRB, 0.53599697E-09_JPRB, 0.53599636E-09_JPRB, 0.53599353E-09_JPRB, &
  & 0.53598831E-09_JPRB, 0.53598542E-09_JPRB, 0.53598342E-09_JPRB, 0.53597682E-09_JPRB, 0.53597105E-09_JPRB, 0.53596549E-09_JPRB, &
  & 0.53596322E-09_JPRB, 0.53596211E-09_JPRB, 0.53596172E-09_JPRB, 0.53596694E-09_JPRB, 0.53596294E-09_JPRB, 0.53596738E-09_JPRB, &
  & 0.53596894E-09_JPRB, 0.53597188E-09_JPRB, 0.53596821E-09_JPRB, 0.53597821E-09_JPRB, 0.53597221E-09_JPRB, 0.53596266E-09_JPRB, &
  & 0.53596116E-09_JPRB, 0.53596239E-09_JPRB, 0.53596055E-09_JPRB, 0.53596116E-09_JPRB, 0.53595900E-09_JPRB, 0.53595151E-09_JPRB, &
  & 0.53594640E-09_JPRB, 0.53594401E-09_JPRB, 0.53593979E-09_JPRB, 0.53594312E-09_JPRB /)

RGHG6(:,84,11) = (/ &
  & 0.53591959E-09_JPRB, 0.53592469E-09_JPRB, 0.53593191E-09_JPRB, 0.53593446E-09_JPRB, 0.53593202E-09_JPRB, 0.53593585E-09_JPRB, &
  & 0.53593963E-09_JPRB, 0.53594018E-09_JPRB, 0.53594201E-09_JPRB, 0.53594296E-09_JPRB, 0.53594074E-09_JPRB, 0.53594257E-09_JPRB, &
  & 0.53594423E-09_JPRB, 0.53594590E-09_JPRB, 0.53595389E-09_JPRB, 0.53594651E-09_JPRB, 0.53594523E-09_JPRB, 0.53593607E-09_JPRB, &
  & 0.53593219E-09_JPRB, 0.53593147E-09_JPRB, 0.53594651E-09_JPRB, 0.53594940E-09_JPRB, 0.53594729E-09_JPRB, 0.53595323E-09_JPRB, &
  & 0.53596094E-09_JPRB, 0.53597027E-09_JPRB, 0.53597571E-09_JPRB, 0.53598082E-09_JPRB, 0.53597909E-09_JPRB, 0.53598498E-09_JPRB, &
  & 0.53599430E-09_JPRB, 0.53599480E-09_JPRB, 0.53599908E-09_JPRB, 0.53599730E-09_JPRB, 0.53599664E-09_JPRB, 0.53599386E-09_JPRB, &
  & 0.53598875E-09_JPRB, 0.53598592E-09_JPRB, 0.53598392E-09_JPRB, 0.53597760E-09_JPRB, 0.53597210E-09_JPRB, 0.53596627E-09_JPRB, &
  & 0.53596400E-09_JPRB, 0.53596272E-09_JPRB, 0.53596233E-09_JPRB, 0.53596771E-09_JPRB, 0.53596355E-09_JPRB, 0.53596788E-09_JPRB, &
  & 0.53596932E-09_JPRB, 0.53597243E-09_JPRB, 0.53596882E-09_JPRB, 0.53597926E-09_JPRB, 0.53597299E-09_JPRB, 0.53596327E-09_JPRB, &
  & 0.53596177E-09_JPRB, 0.53596311E-09_JPRB, 0.53596133E-09_JPRB, 0.53596222E-09_JPRB, 0.53596005E-09_JPRB, 0.53595239E-09_JPRB, &
  & 0.53594718E-09_JPRB, 0.53594490E-09_JPRB, 0.53594085E-09_JPRB, 0.53594429E-09_JPRB /)

RGHG6(:,85,11) = (/ &
  & 0.53592014E-09_JPRB, 0.53592547E-09_JPRB, 0.53593285E-09_JPRB, 0.53593552E-09_JPRB, 0.53593285E-09_JPRB, 0.53593674E-09_JPRB, &
  & 0.53594040E-09_JPRB, 0.53594112E-09_JPRB, 0.53594257E-09_JPRB, 0.53594329E-09_JPRB, 0.53594190E-09_JPRB, 0.53594340E-09_JPRB, &
  & 0.53594484E-09_JPRB, 0.53594695E-09_JPRB, 0.53595373E-09_JPRB, 0.53594762E-09_JPRB, 0.53594595E-09_JPRB, 0.53593685E-09_JPRB, &
  & 0.53593285E-09_JPRB, 0.53593208E-09_JPRB, 0.53594795E-09_JPRB, 0.53595062E-09_JPRB, 0.53594784E-09_JPRB, 0.53595378E-09_JPRB, &
  & 0.53596161E-09_JPRB, 0.53597093E-09_JPRB, 0.53597621E-09_JPRB, 0.53598126E-09_JPRB, 0.53597915E-09_JPRB, 0.53598509E-09_JPRB, &
  & 0.53599453E-09_JPRB, 0.53599497E-09_JPRB, 0.53599936E-09_JPRB, 0.53599752E-09_JPRB, 0.53599686E-09_JPRB, 0.53599397E-09_JPRB, &
  & 0.53598898E-09_JPRB, 0.53598626E-09_JPRB, 0.53598437E-09_JPRB, 0.53597832E-09_JPRB, 0.53597238E-09_JPRB, 0.53596666E-09_JPRB, &
  & 0.53596433E-09_JPRB, 0.53596316E-09_JPRB, 0.53596277E-09_JPRB, 0.53596838E-09_JPRB, 0.53596383E-09_JPRB, 0.53596827E-09_JPRB, &
  & 0.53596960E-09_JPRB, 0.53597282E-09_JPRB, 0.53596916E-09_JPRB, 0.53597998E-09_JPRB, 0.53597365E-09_JPRB, 0.53596383E-09_JPRB, &
  & 0.53596222E-09_JPRB, 0.53596350E-09_JPRB, 0.53596189E-09_JPRB, 0.53596289E-09_JPRB, 0.53596083E-09_JPRB, 0.53595300E-09_JPRB, &
  & 0.53594773E-09_JPRB, 0.53594545E-09_JPRB, 0.53594151E-09_JPRB, 0.53594512E-09_JPRB /)

RGHG6(:,86,11) = (/ &
  & 0.53592036E-09_JPRB, 0.53592591E-09_JPRB, 0.53593358E-09_JPRB, 0.53593618E-09_JPRB, 0.53593346E-09_JPRB, 0.53593729E-09_JPRB, &
  & 0.53594101E-09_JPRB, 0.53594174E-09_JPRB, 0.53594312E-09_JPRB, 0.53594351E-09_JPRB, 0.53594279E-09_JPRB, 0.53594384E-09_JPRB, &
  & 0.53594540E-09_JPRB, 0.53594745E-09_JPRB, 0.53595273E-09_JPRB, 0.53594817E-09_JPRB, 0.53594634E-09_JPRB, 0.53593779E-09_JPRB, &
  & 0.53593363E-09_JPRB, 0.53593258E-09_JPRB, 0.53594862E-09_JPRB, 0.53595139E-09_JPRB, 0.53594806E-09_JPRB, 0.53595406E-09_JPRB, &
  & 0.53596200E-09_JPRB, 0.53597154E-09_JPRB, 0.53597665E-09_JPRB, 0.53598176E-09_JPRB, 0.53597915E-09_JPRB, 0.53598515E-09_JPRB, &
  & 0.53599475E-09_JPRB, 0.53599519E-09_JPRB, 0.53599958E-09_JPRB, 0.53599764E-09_JPRB, 0.53599686E-09_JPRB, 0.53599408E-09_JPRB, &
  & 0.53598914E-09_JPRB, 0.53598648E-09_JPRB, 0.53598481E-09_JPRB, 0.53597848E-09_JPRB, 0.53597282E-09_JPRB, 0.53596672E-09_JPRB, &
  & 0.53596461E-09_JPRB, 0.53596338E-09_JPRB, 0.53596294E-09_JPRB, 0.53596877E-09_JPRB, 0.53596405E-09_JPRB, 0.53596849E-09_JPRB, &
  & 0.53596977E-09_JPRB, 0.53597327E-09_JPRB, 0.53596938E-09_JPRB, 0.53598065E-09_JPRB, 0.53597410E-09_JPRB, 0.53596405E-09_JPRB, &
  & 0.53596255E-09_JPRB, 0.53596383E-09_JPRB, 0.53596227E-09_JPRB, 0.53596333E-09_JPRB, 0.53596122E-09_JPRB, 0.53595339E-09_JPRB, &
  & 0.53594817E-09_JPRB, 0.53594590E-09_JPRB, 0.53594179E-09_JPRB, 0.53594579E-09_JPRB /)

RGHG6(:,87,11) = (/ &
  & 0.53592053E-09_JPRB, 0.53592630E-09_JPRB, 0.53593391E-09_JPRB, 0.53593646E-09_JPRB, 0.53593380E-09_JPRB, 0.53593840E-09_JPRB, &
  & 0.53594118E-09_JPRB, 0.53594229E-09_JPRB, 0.53594329E-09_JPRB, 0.53594373E-09_JPRB, 0.53594351E-09_JPRB, 0.53594451E-09_JPRB, &
  & 0.53594590E-09_JPRB, 0.53594784E-09_JPRB, 0.53595189E-09_JPRB, 0.53594845E-09_JPRB, 0.53594645E-09_JPRB, 0.53593824E-09_JPRB, &
  & 0.53593413E-09_JPRB, 0.53593296E-09_JPRB, 0.53594895E-09_JPRB, 0.53595189E-09_JPRB, 0.53594806E-09_JPRB, 0.53595411E-09_JPRB, &
  & 0.53596233E-09_JPRB, 0.53597216E-09_JPRB, 0.53597693E-09_JPRB, 0.53598204E-09_JPRB, 0.53597898E-09_JPRB, 0.53598509E-09_JPRB, &
  & 0.53599503E-09_JPRB, 0.53599530E-09_JPRB, 0.53599980E-09_JPRB, 0.53599786E-09_JPRB, 0.53599697E-09_JPRB, 0.53599419E-09_JPRB, &
  & 0.53598920E-09_JPRB, 0.53598659E-09_JPRB, 0.53598526E-09_JPRB, 0.53597893E-09_JPRB, 0.53597277E-09_JPRB, 0.53596677E-09_JPRB, &
  & 0.53596472E-09_JPRB, 0.53596344E-09_JPRB, 0.53596300E-09_JPRB, 0.53596894E-09_JPRB, 0.53596405E-09_JPRB, 0.53596866E-09_JPRB, &
  & 0.53596988E-09_JPRB, 0.53597343E-09_JPRB, 0.53596949E-09_JPRB, 0.53598109E-09_JPRB, 0.53597438E-09_JPRB, 0.53596411E-09_JPRB, &
  & 0.53596266E-09_JPRB, 0.53596388E-09_JPRB, 0.53596244E-09_JPRB, 0.53596355E-09_JPRB, 0.53596144E-09_JPRB, 0.53595367E-09_JPRB, &
  & 0.53594851E-09_JPRB, 0.53594618E-09_JPRB, 0.53594190E-09_JPRB, 0.53594618E-09_JPRB /)

RGHG6(:,88,11) = (/ &
  & 0.53592064E-09_JPRB, 0.53592647E-09_JPRB, 0.53593419E-09_JPRB, 0.53593679E-09_JPRB, 0.53593430E-09_JPRB, 0.53593802E-09_JPRB, &
  & 0.53594162E-09_JPRB, 0.53594246E-09_JPRB, 0.53594357E-09_JPRB, 0.53594390E-09_JPRB, 0.53594368E-09_JPRB, 0.53594462E-09_JPRB, &
  & 0.53594601E-09_JPRB, 0.53594779E-09_JPRB, 0.53595167E-09_JPRB, 0.53594862E-09_JPRB, 0.53594645E-09_JPRB, 0.53593874E-09_JPRB, &
  & 0.53593435E-09_JPRB, 0.53593308E-09_JPRB, 0.53594945E-09_JPRB, 0.53595245E-09_JPRB, 0.53594801E-09_JPRB, 0.53595406E-09_JPRB, &
  & 0.53596239E-09_JPRB, 0.53597266E-09_JPRB, 0.53597704E-09_JPRB, 0.53598231E-09_JPRB, 0.53597876E-09_JPRB, 0.53598503E-09_JPRB, &
  & 0.53599530E-09_JPRB, 0.53599541E-09_JPRB, 0.53599991E-09_JPRB, 0.53599791E-09_JPRB, 0.53599708E-09_JPRB, 0.53599436E-09_JPRB, &
  & 0.53598920E-09_JPRB, 0.53598670E-09_JPRB, 0.53598559E-09_JPRB, 0.53597904E-09_JPRB, 0.53597293E-09_JPRB, 0.53596649E-09_JPRB, &
  & 0.53596483E-09_JPRB, 0.53596344E-09_JPRB, 0.53596300E-09_JPRB, 0.53596916E-09_JPRB, 0.53596405E-09_JPRB, 0.53596871E-09_JPRB, &
  & 0.53596971E-09_JPRB, 0.53597349E-09_JPRB, 0.53596960E-09_JPRB, 0.53598148E-09_JPRB, 0.53597449E-09_JPRB, 0.53596405E-09_JPRB, &
  & 0.53596277E-09_JPRB, 0.53596400E-09_JPRB, 0.53596266E-09_JPRB, 0.53596377E-09_JPRB, 0.53596161E-09_JPRB, 0.53595373E-09_JPRB, &
  & 0.53594856E-09_JPRB, 0.53594634E-09_JPRB, 0.53594212E-09_JPRB, 0.53594651E-09_JPRB /)

RGHG6(:,89,11) = (/ &
  & 0.53592086E-09_JPRB, 0.53592658E-09_JPRB, 0.53593430E-09_JPRB, 0.53593685E-09_JPRB, 0.53593391E-09_JPRB, 0.53593868E-09_JPRB, &
  & 0.53594146E-09_JPRB, 0.53594257E-09_JPRB, 0.53594351E-09_JPRB, 0.53594384E-09_JPRB, 0.53594351E-09_JPRB, 0.53594457E-09_JPRB, &
  & 0.53594601E-09_JPRB, 0.53594795E-09_JPRB, 0.53595228E-09_JPRB, 0.53594879E-09_JPRB, 0.53594684E-09_JPRB, 0.53593852E-09_JPRB, &
  & 0.53593430E-09_JPRB, 0.53593302E-09_JPRB, 0.53594962E-09_JPRB, 0.53595289E-09_JPRB, 0.53594795E-09_JPRB, 0.53595411E-09_JPRB, &
  & 0.53596239E-09_JPRB, 0.53597293E-09_JPRB, 0.53597721E-09_JPRB, 0.53598248E-09_JPRB, 0.53597859E-09_JPRB, 0.53598492E-09_JPRB, &
  & 0.53599547E-09_JPRB, 0.53599547E-09_JPRB, 0.53600024E-09_JPRB, 0.53599791E-09_JPRB, 0.53599714E-09_JPRB, 0.53599442E-09_JPRB, &
  & 0.53598920E-09_JPRB, 0.53598659E-09_JPRB, 0.53598587E-09_JPRB, 0.53597904E-09_JPRB, 0.53597282E-09_JPRB, 0.53596644E-09_JPRB, &
  & 0.53596494E-09_JPRB, 0.53596350E-09_JPRB, 0.53596289E-09_JPRB, 0.53596938E-09_JPRB, 0.53596400E-09_JPRB, 0.53596871E-09_JPRB, &
  & 0.53596971E-09_JPRB, 0.53597354E-09_JPRB, 0.53596955E-09_JPRB, 0.53598181E-09_JPRB, 0.53597465E-09_JPRB, 0.53596405E-09_JPRB, &
  & 0.53596289E-09_JPRB, 0.53596411E-09_JPRB, 0.53596272E-09_JPRB, 0.53596388E-09_JPRB, 0.53596183E-09_JPRB, 0.53595395E-09_JPRB, &
  & 0.53594873E-09_JPRB, 0.53594645E-09_JPRB, 0.53594196E-09_JPRB, 0.53594668E-09_JPRB /)

RGHG6(:,90,11) = (/ &
  & 0.53592120E-09_JPRB, 0.53592664E-09_JPRB, 0.53593446E-09_JPRB, 0.53593713E-09_JPRB, 0.53593363E-09_JPRB, 0.53593791E-09_JPRB, &
  & 0.53594185E-09_JPRB, 0.53594246E-09_JPRB, 0.53594379E-09_JPRB, 0.53594401E-09_JPRB, 0.53594318E-09_JPRB, 0.53594429E-09_JPRB, &
  & 0.53594595E-09_JPRB, 0.53594795E-09_JPRB, 0.53595395E-09_JPRB, 0.53594895E-09_JPRB, 0.53594740E-09_JPRB, 0.53593807E-09_JPRB, &
  & 0.53593385E-09_JPRB, 0.53593224E-09_JPRB, 0.53595034E-09_JPRB, 0.53595328E-09_JPRB, 0.53594756E-09_JPRB, 0.53595400E-09_JPRB, &
  & 0.53596244E-09_JPRB, 0.53597327E-09_JPRB, 0.53597721E-09_JPRB, 0.53598276E-09_JPRB, 0.53597826E-09_JPRB, 0.53598487E-09_JPRB, &
  & 0.53599580E-09_JPRB, 0.53599541E-09_JPRB, 0.53600063E-09_JPRB, 0.53599797E-09_JPRB, 0.53599725E-09_JPRB, 0.53599458E-09_JPRB, &
  & 0.53598920E-09_JPRB, 0.53598648E-09_JPRB, 0.53598614E-09_JPRB, 0.53597909E-09_JPRB, 0.53597282E-09_JPRB, 0.53596633E-09_JPRB, &
  & 0.53596483E-09_JPRB, 0.53596350E-09_JPRB, 0.53596272E-09_JPRB, 0.53596966E-09_JPRB, 0.53596377E-09_JPRB, 0.53596888E-09_JPRB, &
  & 0.53596971E-09_JPRB, 0.53597382E-09_JPRB, 0.53596921E-09_JPRB, 0.53598248E-09_JPRB, 0.53597476E-09_JPRB, 0.53596372E-09_JPRB, &
  & 0.53596277E-09_JPRB, 0.53596416E-09_JPRB, 0.53596272E-09_JPRB, 0.53596405E-09_JPRB, 0.53596200E-09_JPRB, 0.53595384E-09_JPRB, &
  & 0.53594867E-09_JPRB, 0.53594651E-09_JPRB, 0.53594196E-09_JPRB, 0.53594690E-09_JPRB /)

RGHG6(:,91,11) = (/ &
  & 0.53592136E-09_JPRB, 0.53592597E-09_JPRB, 0.53593446E-09_JPRB, 0.53593757E-09_JPRB, 0.53593274E-09_JPRB, 0.53593774E-09_JPRB, &
  & 0.53594218E-09_JPRB, 0.53594196E-09_JPRB, 0.53594457E-09_JPRB, 0.53594523E-09_JPRB, 0.53594107E-09_JPRB, 0.53594390E-09_JPRB, &
  & 0.53594595E-09_JPRB, 0.53594640E-09_JPRB, 0.53595872E-09_JPRB, 0.53594773E-09_JPRB, 0.53594884E-09_JPRB, 0.53593702E-09_JPRB, &
  & 0.53593341E-09_JPRB, 0.53593069E-09_JPRB, 0.53595145E-09_JPRB, 0.53595395E-09_JPRB, 0.53594684E-09_JPRB, 0.53595384E-09_JPRB, &
  & 0.53596233E-09_JPRB, 0.53597371E-09_JPRB, 0.53597715E-09_JPRB, 0.53598348E-09_JPRB, 0.53597754E-09_JPRB, 0.53598459E-09_JPRB, &
  & 0.53599669E-09_JPRB, 0.53599503E-09_JPRB, 0.53600135E-09_JPRB, 0.53599780E-09_JPRB, 0.53599741E-09_JPRB, 0.53599492E-09_JPRB, &
  & 0.53598886E-09_JPRB, 0.53598637E-09_JPRB, 0.53598664E-09_JPRB, 0.53597909E-09_JPRB, 0.53597282E-09_JPRB, 0.53596594E-09_JPRB, &
  & 0.53596488E-09_JPRB, 0.53596333E-09_JPRB, 0.53596227E-09_JPRB, 0.53597060E-09_JPRB, 0.53596300E-09_JPRB, 0.53596905E-09_JPRB, &
  & 0.53596955E-09_JPRB, 0.53597438E-09_JPRB, 0.53596805E-09_JPRB, 0.53598398E-09_JPRB, 0.53597504E-09_JPRB, 0.53596300E-09_JPRB, &
  & 0.53596272E-09_JPRB, 0.53596433E-09_JPRB, 0.53596261E-09_JPRB, 0.53596427E-09_JPRB, 0.53596227E-09_JPRB, 0.53595350E-09_JPRB, &
  & 0.53594840E-09_JPRB, 0.53594656E-09_JPRB, 0.53594162E-09_JPRB, 0.53594695E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART22',1,ZHOOK_HANDLE)
END SUBROUTINE PART22






SUBROUTINE PART23
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART23',0,ZHOOK_HANDLE)



!-- Month= 12 ------------

RGHG6(:, 1,12) = (/ &
  & 0.53933148E-36_JPRB, 0.95997180E-35_JPRB, 0.14286545E-34_JPRB, 0.12295517E-34_JPRB, 0.10734682E-34_JPRB, 0.10204013E-34_JPRB, &
  & 0.10464296E-34_JPRB, 0.11818944E-34_JPRB, 0.15003966E-34_JPRB, 0.21409365E-34_JPRB, 0.35038100E-34_JPRB, 0.69048716E-34_JPRB, &
  & 0.14476405E-33_JPRB, 0.25676105E-33_JPRB, 0.41668575E-33_JPRB, 0.74308719E-33_JPRB, 0.13786132E-32_JPRB, 0.24259177E-32_JPRB, &
  & 0.40792236E-32_JPRB, 0.67808134E-32_JPRB, 0.10866164E-31_JPRB, 0.16403239E-31_JPRB, 0.23451391E-31_JPRB, 0.31847025E-31_JPRB, &
  & 0.41208718E-31_JPRB, 0.50987785E-31_JPRB, 0.60372120E-31_JPRB, 0.68805963E-31_JPRB, 0.73830737E-31_JPRB, 0.75641310E-31_JPRB, &
  & 0.73909960E-31_JPRB, 0.68201759E-31_JPRB, 0.58935178E-31_JPRB, 0.48438411E-31_JPRB, 0.37514107E-31_JPRB, 0.27090731E-31_JPRB, &
  & 0.18657299E-31_JPRB, 0.11907299E-31_JPRB, 0.68041668E-32_JPRB, 0.39282149E-32_JPRB, 0.21282226E-32_JPRB, 0.11110835E-32_JPRB, &
  & 0.58714799E-33_JPRB, 0.31373655E-33_JPRB, 0.17017947E-33_JPRB, 0.93291341E-34_JPRB, 0.51224875E-34_JPRB, 0.28014889E-34_JPRB, &
  & 0.15262356E-34_JPRB, 0.83121621E-35_JPRB, 0.45392485E-35_JPRB, 0.25042830E-35_JPRB, 0.14059420E-35_JPRB, 0.81541759E-36_JPRB, &
  & 0.49949465E-36_JPRB, 0.33140285E-36_JPRB, 0.24297148E-36_JPRB, 0.19785707E-36_JPRB, 0.17616944E-36_JPRB, 0.16597075E-36_JPRB, &
  & 0.15807425E-36_JPRB, 0.14482915E-36_JPRB, 0.12148045E-36_JPRB, 0.99409380E-37_JPRB /)

RGHG6(:, 2,12) = (/ &
  & 0.47524674E-34_JPRB, 0.39464945E-33_JPRB, 0.54294206E-33_JPRB, 0.48483783E-33_JPRB, 0.43471599E-33_JPRB, 0.42127812E-33_JPRB, &
  & 0.44389142E-33_JPRB, 0.51503394E-33_JPRB, 0.66357721E-33_JPRB, 0.95936098E-33_JPRB, 0.15584324E-32_JPRB, 0.29478434E-32_JPRB, &
  & 0.58158178E-32_JPRB, 0.10295687E-31_JPRB, 0.17041691E-31_JPRB, 0.30391013E-31_JPRB, 0.55940083E-31_JPRB, 0.98463204E-31_JPRB, &
  & 0.16557829E-30_JPRB, 0.27351835E-30_JPRB, 0.43498040E-30_JPRB, 0.65371376E-30_JPRB, 0.93339104E-30_JPRB, 0.12687344E-29_JPRB, &
  & 0.16457775E-29_JPRB, 0.20408455E-29_JPRB, 0.24165179E-29_JPRB, 0.27357869E-29_JPRB, 0.29462980E-29_JPRB, 0.30231247E-29_JPRB, &
  & 0.29526656E-29_JPRB, 0.27220009E-29_JPRB, 0.23510203E-29_JPRB, 0.19239933E-29_JPRB, 0.14835655E-29_JPRB, 0.10723275E-29_JPRB, &
  & 0.73888119E-30_JPRB, 0.47567451E-30_JPRB, 0.28265674E-30_JPRB, 0.16531113E-30_JPRB, 0.91320794E-31_JPRB, 0.48848338E-31_JPRB, &
  & 0.26200864E-31_JPRB, 0.14220569E-31_JPRB, 0.78270791E-32_JPRB, 0.43576766E-32_JPRB, 0.24375308E-32_JPRB, 0.13630086E-32_JPRB, &
  & 0.76073770E-33_JPRB, 0.42412920E-33_JPRB, 0.23656516E-33_JPRB, 0.13266893E-33_JPRB, 0.75264556E-34_JPRB, 0.43718050E-34_JPRB, &
  & 0.26469676E-34_JPRB, 0.17094922E-34_JPRB, 0.12026030E-34_JPRB, 0.93333003E-35_JPRB, 0.79366690E-35_JPRB, 0.72046805E-35_JPRB, &
  & 0.67023116E-35_JPRB, 0.60855638E-35_JPRB, 0.50992520E-35_JPRB, 0.39124723E-35_JPRB /)

RGHG6(:, 3,12) = (/ &
  & 0.38128147E-32_JPRB, 0.23360349E-31_JPRB, 0.27580383E-31_JPRB, 0.23921860E-31_JPRB, 0.21399839E-31_JPRB, 0.20813241E-31_JPRB, &
  & 0.22063811E-31_JPRB, 0.25735686E-31_JPRB, 0.33306792E-31_JPRB, 0.47750379E-31_JPRB, 0.78141481E-31_JPRB, 0.14411064E-30_JPRB, &
  & 0.28241969E-30_JPRB, 0.49658298E-30_JPRB, 0.82393813E-30_JPRB, 0.14532955E-29_JPRB, 0.26499891E-29_JPRB, 0.46220412E-29_JPRB, &
  & 0.77098873E-29_JPRB, 0.12683272E-28_JPRB, 0.20212639E-28_JPRB, 0.30592175E-28_JPRB, 0.44121830E-28_JPRB, 0.60594986E-28_JPRB, &
  & 0.79177863E-28_JPRB, 0.98491528E-28_JPRB, 0.11636259E-27_JPRB, 0.13111222E-27_JPRB, 0.14107861E-27_JPRB, 0.14469586E-27_JPRB, &
  & 0.14121281E-27_JPRB, 0.12999928E-27_JPRB, 0.11206527E-27_JPRB, 0.91364419E-28_JPRB, 0.70197595E-28_JPRB, 0.50645367E-28_JPRB, &
  & 0.34892738E-28_JPRB, 0.22569812E-28_JPRB, 0.13610551E-28_JPRB, 0.80185792E-29_JPRB, 0.44773858E-29_JPRB, 0.24030396E-29_JPRB, &
  & 0.12964999E-29_JPRB, 0.70689881E-30_JPRB, 0.39207220E-30_JPRB, 0.22039492E-30_JPRB, 0.12463964E-30_JPRB, 0.70440241E-31_JPRB, &
  & 0.39623152E-31_JPRB, 0.22142111E-31_JPRB, 0.12283462E-31_JPRB, 0.67862538E-32_JPRB, 0.37519517E-32_JPRB, 0.21007434E-32_JPRB, &
  & 0.12164113E-32_JPRB, 0.75083113E-33_JPRB, 0.51197169E-33_JPRB, 0.39461359E-33_JPRB, 0.34198891E-33_JPRB, 0.32073570E-33_JPRB, &
  & 0.30852264E-33_JPRB, 0.28562350E-33_JPRB, 0.23371730E-33_JPRB, 0.15289689E-33_JPRB /)

RGHG6(:, 4,12) = (/ &
  & 0.10911311E-29_JPRB, 0.30424553E-29_JPRB, 0.28798131E-29_JPRB, 0.23448829E-29_JPRB, 0.20511026E-29_JPRB, 0.19755900E-29_JPRB, &
  & 0.20765130E-29_JPRB, 0.24009455E-29_JPRB, 0.30855226E-29_JPRB, 0.44473672E-29_JPRB, 0.72266406E-29_JPRB, 0.13630887E-28_JPRB, &
  & 0.26706564E-28_JPRB, 0.46832706E-28_JPRB, 0.76957711E-28_JPRB, 0.13453418E-27_JPRB, 0.24216942E-27_JPRB, 0.41809883E-27_JPRB, &
  & 0.68983084E-27_JPRB, 0.11263246E-26_JPRB, 0.17931463E-26_JPRB, 0.27198715E-26_JPRB, 0.39474831E-26_JPRB, 0.54521702E-26_JPRB, &
  & 0.71456307E-26_JPRB, 0.88734711E-26_JPRB, 0.10430220E-25_JPRB, 0.11693598E-25_JPRB, 0.12540204E-25_JPRB, 0.12840683E-25_JPRB, &
  & 0.12509768E-25_JPRB, 0.11492589E-25_JPRB, 0.98806546E-26_JPRB, 0.80413738E-26_JPRB, 0.61629527E-26_JPRB, 0.44390728E-26_JPRB, &
  & 0.30540380E-26_JPRB, 0.19778896E-26_JPRB, 0.11959734E-26_JPRB, 0.70963527E-27_JPRB, 0.39763200E-27_JPRB, 0.21552757E-27_JPRB, &
  & 0.11727007E-27_JPRB, 0.64835824E-28_JPRB, 0.36528924E-28_JPRB, 0.20881011E-28_JPRB, 0.11999642E-28_JPRB, 0.68706663E-29_JPRB, &
  & 0.38946061E-29_JPRB, 0.21768965E-29_JPRB, 0.11970761E-29_JPRB, 0.64889305E-30_JPRB, 0.34808424E-30_JPRB, 0.18704014E-30_JPRB, &
  & 0.10316828E-30_JPRB, 0.60998165E-31_JPRB, 0.40764807E-31_JPRB, 0.32035718E-31_JPRB, 0.29178444E-31_JPRB, 0.29117268E-31_JPRB, &
  & 0.29799993E-31_JPRB, 0.29173713E-31_JPRB, 0.24583736E-31_JPRB, 0.13815472E-31_JPRB /)

RGHG6(:, 5,12) = (/ &
  & 0.64320509E-27_JPRB, 0.82886151E-27_JPRB, 0.66317351E-27_JPRB, 0.51312966E-27_JPRB, 0.44828191E-27_JPRB, 0.43449013E-27_JPRB, &
  & 0.45722761E-27_JPRB, 0.52812552E-27_JPRB, 0.67540317E-27_JPRB, 0.96668779E-27_JPRB, 0.15840651E-26_JPRB, 0.29919543E-26_JPRB, &
  & 0.58770137E-26_JPRB, 0.10145140E-25_JPRB, 0.16386827E-25_JPRB, 0.28059163E-25_JPRB, 0.49524577E-25_JPRB, 0.83809729E-25_JPRB, &
  & 0.13541586E-24_JPRB, 0.21685187E-24_JPRB, 0.33918583E-24_JPRB, 0.50711268E-24_JPRB, 0.72670557E-24_JPRB, 0.99265651E-24_JPRB, &
  & 0.12854684E-23_JPRB, 0.15763876E-23_JPRB, 0.18295359E-23_JPRB, 0.20285957E-23_JPRB, 0.21583988E-23_JPRB, 0.21967100E-23_JPRB, &
  & 0.21310385E-23_JPRB, 0.19520251E-23_JPRB, 0.16770343E-23_JPRB, 0.13650495E-23_JPRB, 0.10491019E-23_JPRB, 0.75684508E-24_JPRB, &
  & 0.52303445E-24_JPRB, 0.34020484E-24_JPRB, 0.20724372E-24_JPRB, 0.12431637E-24_JPRB, 0.70744960E-25_JPRB, 0.38964259E-25_JPRB, &
  & 0.21713025E-25_JPRB, 0.12327536E-25_JPRB, 0.71500557E-26_JPRB, 0.42092177E-26_JPRB, 0.24872576E-26_JPRB, 0.14592434E-26_JPRB, &
  & 0.84291415E-27_JPRB, 0.47675621E-27_JPRB, 0.26329701E-27_JPRB, 0.14228778E-27_JPRB, 0.75614772E-28_JPRB, 0.40049689E-28_JPRB, &
  & 0.21744268E-28_JPRB, 0.12707096E-28_JPRB, 0.85285775E-29_JPRB, 0.68465862E-29_JPRB, 0.64400539E-29_JPRB, 0.66540654E-29_JPRB, &
  & 0.71074361E-29_JPRB, 0.74994200E-29_JPRB, 0.72478883E-29_JPRB, 0.57082521E-29_JPRB /)

RGHG6(:, 6,12) = (/ &
  & 0.15746620E-24_JPRB, 0.29013170E-24_JPRB, 0.25802844E-24_JPRB, 0.21616906E-24_JPRB, 0.20002010E-24_JPRB, 0.20391934E-24_JPRB, &
  & 0.22372041E-24_JPRB, 0.26313106E-24_JPRB, 0.33963206E-24_JPRB, 0.47906132E-24_JPRB, 0.76709959E-24_JPRB, 0.14167485E-23_JPRB, &
  & 0.26936533E-23_JPRB, 0.44627155E-23_JPRB, 0.68933451E-23_JPRB, 0.11275200E-22_JPRB, 0.18989517E-22_JPRB, 0.30663901E-22_JPRB, &
  & 0.47306960E-22_JPRB, 0.72325860E-22_JPRB, 0.10830338E-21_JPRB, 0.15533333E-21_JPRB, 0.21449630E-21_JPRB, 0.28318683E-21_JPRB, &
  & 0.35574345E-21_JPRB, 0.42448936E-21_JPRB, 0.48100164E-21_JPRB, 0.52283050E-21_JPRB, 0.54752904E-21_JPRB, 0.55091925E-21_JPRB, &
  & 0.53068766E-21_JPRB, 0.48488263E-21_JPRB, 0.41703734E-21_JPRB, 0.34153790E-21_JPRB, 0.26453205E-21_JPRB, 0.19302629E-21_JPRB, &
  & 0.13518191E-21_JPRB, 0.89490653E-22_JPRB, 0.55522069E-22_JPRB, 0.34179847E-22_JPRB, 0.19946877E-22_JPRB, 0.11326657E-22_JPRB, &
  & 0.65358652E-23_JPRB, 0.38613716E-23_JPRB, 0.23371085E-23_JPRB, 0.14374255E-23_JPRB, 0.88707892E-24_JPRB, 0.54244235E-24_JPRB, &
  & 0.32539295E-24_JPRB, 0.19023675E-24_JPRB, 0.10805446E-24_JPRB, 0.59875356E-25_JPRB, 0.32599341E-25_JPRB, 0.17746720E-25_JPRB, &
  & 0.99616562E-26_JPRB, 0.60647942E-26_JPRB, 0.42451799E-26_JPRB, 0.35300524E-26_JPRB, 0.33969861E-26_JPRB, 0.35615344E-26_JPRB, &
  & 0.38588795E-26_JPRB, 0.42204051E-26_JPRB, 0.45577167E-26_JPRB, 0.48187018E-26_JPRB /)

RGHG6(:, 7,12) = (/ &
  & 0.13888301E-21_JPRB, 0.16708598E-21_JPRB, 0.14632162E-21_JPRB, 0.12562659E-21_JPRB, 0.12298153E-21_JPRB, 0.13284890E-21_JPRB, &
  & 0.15249663E-21_JPRB, 0.18544490E-21_JPRB, 0.23717069E-21_JPRB, 0.32668568E-21_JPRB, 0.49787463E-21_JPRB, 0.87039747E-21_JPRB, &
  & 0.15594550E-20_JPRB, 0.24255609E-20_JPRB, 0.35043018E-20_JPRB, 0.53518182E-20_JPRB, 0.84199223E-20_JPRB, 0.12722728E-19_JPRB, &
  & 0.18387123E-19_JPRB, 0.26397648E-19_JPRB, 0.37234084E-19_JPRB, 0.50561018E-19_JPRB, 0.66396754E-19_JPRB, 0.83862020E-19_JPRB, &
  & 0.10128171E-18_JPRB, 0.11680731E-18_JPRB, 0.12851355E-18_JPRB, 0.13631821E-18_JPRB, 0.14005906E-18_JPRB, 0.13904102E-18_JPRB, &
  & 0.13294355E-18_JPRB, 0.12124744E-18_JPRB, 0.10465498E-18_JPRB, 0.86351678E-19_JPRB, 0.67674638E-19_JPRB, 0.50111894E-19_JPRB, &
  & 0.35808125E-19_JPRB, 0.24265172E-19_JPRB, 0.15472633E-19_JPRB, 0.98301053E-20_JPRB, 0.59252393E-20_JPRB, 0.34766595E-20_JPRB, &
  & 0.20861281E-20_JPRB, 0.12872122E-20_JPRB, 0.81673291E-21_JPRB, 0.52790870E-21_JPRB, 0.34276019E-21_JPRB, 0.22054259E-21_JPRB, &
  & 0.13911269E-21_JPRB, 0.85394654E-22_JPRB, 0.50872491E-22_JPRB, 0.29564938E-22_JPRB, 0.16944978E-22_JPRB, 0.97691020E-23_JPRB, &
  & 0.58620049E-23_JPRB, 0.38345637E-23_JPRB, 0.28733842E-23_JPRB, 0.25145630E-23_JPRB, 0.24967962E-23_JPRB, 0.26637289E-23_JPRB, &
  & 0.29172145E-23_JPRB, 0.32210828E-23_JPRB, 0.35464129E-23_JPRB, 0.39873420E-23_JPRB /)

RGHG6(:, 8,12) = (/ &
  & 0.11838243E-18_JPRB, 0.11617293E-18_JPRB, 0.94851851E-19_JPRB, 0.81650817E-19_JPRB, 0.81496231E-19_JPRB, 0.90466592E-19_JPRB, &
  & 0.10602721E-18_JPRB, 0.12832530E-18_JPRB, 0.16118142E-18_JPRB, 0.21169047E-18_JPRB, 0.30492266E-18_JPRB, 0.49998963E-18_JPRB, &
  & 0.83973323E-18_JPRB, 0.12199307E-17_JPRB, 0.16385666E-17_JPRB, 0.23234804E-17_JPRB, 0.33990256E-17_JPRB, 0.47830594E-17_JPRB, &
  & 0.64498866E-17_JPRB, 0.86626672E-17_JPRB, 0.11481140E-16_JPRB, 0.14711404E-16_JPRB, 0.18334058E-16_JPRB, 0.22082410E-16_JPRB, &
  & 0.25581757E-16_JPRB, 0.28445861E-16_JPRB, 0.30334195E-16_JPRB, 0.31357874E-16_JPRB, 0.31579152E-16_JPRB, 0.30914032E-16_JPRB, &
  & 0.29329108E-16_JPRB, 0.26697387E-16_JPRB, 0.23117316E-16_JPRB, 0.19223312E-16_JPRB, 0.15245286E-16_JPRB, 0.11476487E-16_JPRB, &
  & 0.83804505E-17_JPRB, 0.58356674E-17_JPRB, 0.38389312E-17_JPRB, 0.25276150E-17_JPRB, 0.15772854E-17_JPRB, 0.95796893E-18_JPRB, &
  & 0.59758691E-18_JPRB, 0.38477033E-18_JPRB, 0.25572201E-18_JPRB, 0.17357798E-18_JPRB, 0.11855588E-18_JPRB, 0.80346328E-19_JPRB, &
  & 0.53432152E-19_JPRB, 0.34619228E-19_JPRB, 0.21777226E-19_JPRB, 0.13398563E-19_JPRB, 0.81482686E-20_JPRB, 0.50106118E-20_JPRB, &
  & 0.32186030E-20_JPRB, 0.22571188E-20_JPRB, 0.17987053E-20_JPRB, 0.16486847E-20_JPRB, 0.16866110E-20_JPRB, 0.18324765E-20_JPRB, &
  & 0.20294517E-20_JPRB, 0.22560487E-20_JPRB, 0.24949583E-20_JPRB, 0.28250847E-20_JPRB /)

RGHG6(:, 9,12) = (/ &
  & 0.90353521E-16_JPRB, 0.81216953E-16_JPRB, 0.64107622E-16_JPRB, 0.54065709E-16_JPRB, 0.53755934E-16_JPRB, 0.59353213E-16_JPRB, &
  & 0.68536533E-16_JPRB, 0.80957285E-16_JPRB, 0.97482150E-16_JPRB, 0.12169108E-15_JPRB, 0.16484472E-15_JPRB, 0.25354319E-15_JPRB, &
  & 0.39942569E-15_JPRB, 0.54160965E-15_JPRB, 0.67564515E-15_JPRB, 0.88890496E-15_JPRB, 0.12086265E-14_JPRB, 0.15835356E-14_JPRB, &
  & 0.19909270E-14_JPRB, 0.25005700E-14_JPRB, 0.31113752E-14_JPRB, 0.37596540E-14_JPRB, 0.44373718E-14_JPRB, 0.50888748E-14_JPRB, &
  & 0.56404521E-14_JPRB, 0.60361825E-14_JPRB, 0.62291934E-14_JPRB, 0.62690607E-14_JPRB, 0.61822123E-14_JPRB, 0.59612989E-14_JPRB, &
  & 0.56039954E-14_JPRB, 0.50827504E-14_JPRB, 0.44094981E-14_JPRB, 0.36934164E-14_JPRB, 0.29657859E-14_JPRB, 0.22745431E-14_JPRB, &
  & 0.17014578E-14_JPRB, 0.12216306E-14_JPRB, 0.83236154E-15_JPRB, 0.57052354E-15_JPRB, 0.37026867E-15_JPRB, 0.23358829E-15_JPRB, &
  & 0.15166503E-15_JPRB, 0.10197313E-15_JPRB, 0.70958405E-16_JPRB, 0.50562037E-16_JPRB, 0.36311273E-16_JPRB, 0.25913276E-16_JPRB, &
  & 0.18178876E-16_JPRB, 0.12445205E-16_JPRB, 0.82848185E-17_JPRB, 0.54000782E-17_JPRB, 0.34854727E-17_JPRB, 0.22750385E-17_JPRB, &
  & 0.15525922E-17_JPRB, 0.11521839E-17_JPRB, 0.96405936E-18_JPRB, 0.91603201E-18_JPRB, 0.95954895E-18_JPRB, 0.10580602E-17_JPRB, &
  & 0.11833986E-17_JPRB, 0.13188579E-17_JPRB, 0.14698518E-17_JPRB, 0.16573920E-17_JPRB /)

RGHG6(:,10,12) = (/ &
  & 0.59677347E-13_JPRB, 0.52298233E-13_JPRB, 0.40354327E-13_JPRB, 0.33476494E-13_JPRB, 0.32648458E-13_JPRB, 0.35187975E-13_JPRB, &
  & 0.39410471E-13_JPRB, 0.44775466E-13_JPRB, 0.51493938E-13_JPRB, 0.60851037E-13_JPRB, 0.77510630E-13_JPRB, 0.11193699E-12_JPRB, &
  & 0.16539440E-12_JPRB, 0.20933399E-12_JPRB, 0.24251272E-12_JPRB, 0.29598814E-12_JPRB, 0.37403376E-12_JPRB, 0.45613464E-12_JPRB, &
  & 0.53441751E-12_JPRB, 0.62721990E-12_JPRB, 0.73210643E-12_JPRB, 0.83289864E-12_JPRB, 0.92984962E-12_JPRB, 0.10130664E-11_JPRB, &
  & 0.10725699E-11_JPRB, 0.11026505E-11_JPRB, 0.10997903E-11_JPRB, 0.10763399E-11_JPRB, 0.10383065E-11_JPRB, 0.98510458E-12_JPRB, &
  & 0.91638437E-12_JPRB, 0.82712152E-12_JPRB, 0.71829652E-12_JPRB, 0.60600450E-12_JPRB, 0.49326488E-12_JPRB, 0.38594122E-12_JPRB, &
  & 0.29650086E-12_JPRB, 0.21984905E-12_JPRB, 0.15579420E-12_JPRB, 0.11137133E-12_JPRB, 0.75629756E-13_JPRB, 0.49735779E-13_JPRB, &
  & 0.33750753E-13_JPRB, 0.23718711E-13_JPRB, 0.17307568E-13_JPRB, 0.12956070E-13_JPRB, 0.97880586E-14_JPRB, 0.73577932E-14_JPRB, &
  & 0.54444728E-14_JPRB, 0.39367343E-14_JPRB, 0.27690263E-14_JPRB, 0.19080844E-14_JPRB, 0.13004047E-14_JPRB, 0.89538561E-15_JPRB, &
  & 0.64295222E-15_JPRB, 0.50001594E-15_JPRB, 0.43485700E-15_JPRB, 0.42499838E-15_JPRB, 0.45346555E-15_JPRB, 0.50576496E-15_JPRB, &
  & 0.56776751E-15_JPRB, 0.63901320E-15_JPRB, 0.70421488E-15_JPRB, 0.80596064E-15_JPRB /)

RGHG6(:,11,12) = (/ &
  & 0.47227776E-12_JPRB, 0.32068117E-12_JPRB, 0.23490967E-12_JPRB, 0.20884111E-12_JPRB, 0.20700238E-12_JPRB, 0.21695850E-12_JPRB, &
  & 0.23592554E-12_JPRB, 0.26411116E-12_JPRB, 0.30216568E-12_JPRB, 0.34718907E-12_JPRB, 0.39791992E-12_JPRB, 0.46059098E-12_JPRB, &
  & 0.56074600E-12_JPRB, 0.72067325E-12_JPRB, 0.90102958E-12_JPRB, 0.10869746E-11_JPRB, 0.13103030E-11_JPRB, 0.15812526E-11_JPRB, &
  & 0.18939164E-11_JPRB, 0.22280598E-11_JPRB, 0.25747434E-11_JPRB, 0.29083485E-11_JPRB, 0.32231717E-11_JPRB, 0.34955780E-11_JPRB, &
  & 0.36858164E-11_JPRB, 0.37772658E-11_JPRB, 0.37505966E-11_JPRB, 0.36321484E-11_JPRB, 0.34361849E-11_JPRB, 0.31669207E-11_JPRB, &
  & 0.28428555E-11_JPRB, 0.24761584E-11_JPRB, 0.20675425E-11_JPRB, 0.16538384E-11_JPRB, 0.12900049E-11_JPRB, 0.98860113E-12_JPRB, &
  & 0.75419922E-12_JPRB, 0.58007765E-12_JPRB, 0.44423831E-12_JPRB, 0.33362489E-12_JPRB, 0.25249787E-12_JPRB, 0.19162829E-12_JPRB, &
  & 0.14702969E-12_JPRB, 0.11587828E-12_JPRB, 0.93521145E-13_JPRB, 0.76885425E-13_JPRB, 0.62950709E-13_JPRB, 0.50890898E-13_JPRB, &
  & 0.40458976E-13_JPRB, 0.31390296E-13_JPRB, 0.23682682E-13_JPRB, 0.17538185E-13_JPRB, 0.12874198E-13_JPRB, 0.95677191E-14_JPRB, &
  & 0.73939336E-14_JPRB, 0.60996575E-14_JPRB, 0.54492476E-14_JPRB, 0.52516869E-14_JPRB, 0.53454174E-14_JPRB, 0.55895264E-14_JPRB, &
  & 0.58764444E-14_JPRB, 0.60881391E-14_JPRB, 0.62339190E-14_JPRB, 0.61905356E-14_JPRB /)

RGHG6(:,12,12) = (/ &
  & 0.17059675E-11_JPRB, 0.12228287E-11_JPRB, 0.10276070E-11_JPRB, 0.95814470E-12_JPRB, 0.92553070E-12_JPRB, 0.91987117E-12_JPRB, &
  & 0.94356890E-12_JPRB, 0.10011843E-11_JPRB, 0.11008323E-11_JPRB, 0.12436561E-11_JPRB, 0.14301744E-11_JPRB, 0.16547225E-11_JPRB, &
  & 0.19191875E-11_JPRB, 0.22666079E-11_JPRB, 0.27328270E-11_JPRB, 0.33016725E-11_JPRB, 0.39421851E-11_JPRB, 0.46604699E-11_JPRB, &
  & 0.54747140E-11_JPRB, 0.63551716E-11_JPRB, 0.72610581E-11_JPRB, 0.81265394E-11_JPRB, 0.89114723E-11_JPRB, 0.95750439E-11_JPRB, &
  & 0.10020445E-10_JPRB, 0.10189528E-10_JPRB, 0.10031791E-10_JPRB, 0.95858859E-11_JPRB, 0.88921544E-11_JPRB, 0.79798954E-11_JPRB, &
  & 0.69087978E-11_JPRB, 0.57498550E-11_JPRB, 0.46164851E-11_JPRB, 0.35989879E-11_JPRB, 0.27568559E-11_JPRB, 0.21205184E-11_JPRB, &
  & 0.16639812E-11_JPRB, 0.13313571E-11_JPRB, 0.10802151E-11_JPRB, 0.89504240E-12_JPRB, 0.75913397E-12_JPRB, 0.65987656E-12_JPRB, &
  & 0.58461585E-12_JPRB, 0.52361479E-12_JPRB, 0.46716494E-12_JPRB, 0.41227124E-12_JPRB, 0.35805809E-12_JPRB, 0.30454575E-12_JPRB, &
  & 0.25227690E-12_JPRB, 0.20399723E-12_JPRB, 0.16058267E-12_JPRB, 0.12422817E-12_JPRB, 0.95476619E-13_JPRB, 0.74287263E-13_JPRB, &
  & 0.59719645E-13_JPRB, 0.50494158E-13_JPRB, 0.45203821E-13_JPRB, 0.42671470E-13_JPRB, 0.41908246E-13_JPRB, 0.42125361E-13_JPRB, &
  & 0.42668241E-13_JPRB, 0.43201719E-13_JPRB, 0.43416378E-13_JPRB, 0.42938872E-13_JPRB /)

RGHG6(:,13,12) = (/ &
  & 0.50060368E-11_JPRB, 0.37993567E-11_JPRB, 0.34090788E-11_JPRB, 0.31807458E-11_JPRB, 0.30432250E-11_JPRB, 0.29847431E-11_JPRB, &
  & 0.29999037E-11_JPRB, 0.30941270E-11_JPRB, 0.32884515E-11_JPRB, 0.35940279E-11_JPRB, 0.40295436E-11_JPRB, 0.46061406E-11_JPRB, &
  & 0.53215583E-11_JPRB, 0.61782346E-11_JPRB, 0.71989411E-11_JPRB, 0.84435011E-11_JPRB, 0.98858569E-11_JPRB, 0.11475839E-10_JPRB, &
  & 0.13222732E-10_JPRB, 0.15052504E-10_JPRB, 0.16872968E-10_JPRB, 0.18574666E-10_JPRB, 0.20087942E-10_JPRB, 0.21298052E-10_JPRB, &
  & 0.22042354E-10_JPRB, 0.22171430E-10_JPRB, 0.21593567E-10_JPRB, 0.20361456E-10_JPRB, 0.18555182E-10_JPRB, 0.16297914E-10_JPRB, &
  & 0.13830918E-10_JPRB, 0.11322344E-10_JPRB, 0.89412280E-11_JPRB, 0.69140665E-11_JPRB, 0.53624089E-11_JPRB, 0.42582205E-11_JPRB, &
  & 0.35156040E-11_JPRB, 0.30413944E-11_JPRB, 0.27425629E-11_JPRB, 0.25507079E-11_JPRB, 0.24287941E-11_JPRB, 0.23558852E-11_JPRB, &
  & 0.22957430E-11_JPRB, 0.22253182E-11_JPRB, 0.21289897E-11_JPRB, 0.19790255E-11_JPRB, 0.17889959E-11_JPRB, 0.15776844E-11_JPRB, &
  & 0.13492363E-11_JPRB, 0.11244135E-11_JPRB, 0.91366552E-12_JPRB, 0.73014240E-12_JPRB, 0.57867307E-12_JPRB, 0.46298094E-12_JPRB, &
  & 0.37880948E-12_JPRB, 0.32167829E-12_JPRB, 0.28450064E-12_JPRB, 0.26170182E-12_JPRB, 0.24837261E-12_JPRB, 0.24080507E-12_JPRB, &
  & 0.23588022E-12_JPRB, 0.23165730E-12_JPRB, 0.22511853E-12_JPRB, 0.21245438E-12_JPRB /)

RGHG6(:,14,12) = (/ &
  & 0.11000708E-10_JPRB, 0.91125284E-11_JPRB, 0.83277369E-11_JPRB, 0.78968386E-11_JPRB, 0.77001070E-11_JPRB, 0.76723723E-11_JPRB, &
  & 0.77880098E-11_JPRB, 0.80518500E-11_JPRB, 0.84998484E-11_JPRB, 0.91413465E-11_JPRB, 0.10010141E-10_JPRB, 0.11134212E-10_JPRB, &
  & 0.12549599E-10_JPRB, 0.14277465E-10_JPRB, 0.16278649E-10_JPRB, 0.18611515E-10_JPRB, 0.21237774E-10_JPRB, 0.24075547E-10_JPRB, &
  & 0.27129025E-10_JPRB, 0.30243499E-10_JPRB, 0.33247904E-10_JPRB, 0.35938818E-10_JPRB, 0.38222425E-10_JPRB, 0.39903355E-10_JPRB, &
  & 0.40727373E-10_JPRB, 0.40448415E-10_JPRB, 0.38923167E-10_JPRB, 0.36266930E-10_JPRB, 0.32681909E-10_JPRB, 0.28448667E-10_JPRB, &
  & 0.23891394E-10_JPRB, 0.19518588E-10_JPRB, 0.15627803E-10_JPRB, 0.12565619E-10_JPRB, 0.10333189E-10_JPRB, 0.89120352E-11_JPRB, &
  & 0.80824548E-11_JPRB, 0.76295342E-11_JPRB, 0.74175648E-11_JPRB, 0.73756634E-11_JPRB, 0.74368168E-11_JPRB, 0.75536192E-11_JPRB, &
  & 0.76335266E-11_JPRB, 0.76188240E-11_JPRB, 0.74870951E-11_JPRB, 0.71535633E-11_JPRB, 0.66660835E-11_JPRB, 0.60618702E-11_JPRB, &
  & 0.53516228E-11_JPRB, 0.46069711E-11_JPRB, 0.38786236E-11_JPRB, 0.32082032E-11_JPRB, 0.26289090E-11_JPRB, 0.21599539E-11_JPRB, &
  & 0.17980554E-11_JPRB, 0.15323308E-11_JPRB, 0.13429211E-11_JPRB, 0.12108162E-11_JPRB, 0.11196958E-11_JPRB, 0.10563915E-11_JPRB, &
  & 0.10102221E-11_JPRB, 0.97083680E-12_JPRB, 0.92903463E-12_JPRB, 0.84710629E-12_JPRB /)

RGHG6(:,15,12) = (/ &
  & 0.19887062E-10_JPRB, 0.17506226E-10_JPRB, 0.16611781E-10_JPRB, 0.16308897E-10_JPRB, 0.16336146E-10_JPRB, 0.16595416E-10_JPRB, &
  & 0.17057390E-10_JPRB, 0.17740667E-10_JPRB, 0.18703148E-10_JPRB, 0.19956892E-10_JPRB, 0.21539288E-10_JPRB, 0.23486591E-10_JPRB, &
  & 0.25853772E-10_JPRB, 0.28706374E-10_JPRB, 0.31988988E-10_JPRB, 0.35735866E-10_JPRB, 0.39845755E-10_JPRB, 0.44180905E-10_JPRB, &
  & 0.48708659E-10_JPRB, 0.53184047E-10_JPRB, 0.57335379E-10_JPRB, 0.60866742E-10_JPRB, 0.63632918E-10_JPRB, 0.65367739E-10_JPRB, &
  & 0.65731295E-10_JPRB, 0.64447517E-10_JPRB, 0.61362228E-10_JPRB, 0.56690083E-10_JPRB, 0.50742043E-10_JPRB, 0.44035338E-10_JPRB, &
  & 0.37363092E-10_JPRB, 0.31154912E-10_JPRB, 0.25956338E-10_JPRB, 0.22102747E-10_JPRB, 0.19721513E-10_JPRB, 0.18509302E-10_JPRB, &
  & 0.18148687E-10_JPRB, 0.18274833E-10_JPRB, 0.18639191E-10_JPRB, 0.19124809E-10_JPRB, 0.19623596E-10_JPRB, 0.20039002E-10_JPRB, &
  & 0.20262535E-10_JPRB, 0.20222723E-10_JPRB, 0.19879209E-10_JPRB, 0.19195397E-10_JPRB, 0.18192552E-10_JPRB, 0.16880131E-10_JPRB, &
  & 0.15318394E-10_JPRB, 0.13611913E-10_JPRB, 0.11865183E-10_JPRB, 0.10177867E-10_JPRB, 0.86389385E-11_JPRB, 0.73119436E-11_JPRB, &
  & 0.62186610E-11_JPRB, 0.53537695E-11_JPRB, 0.46896267E-11_JPRB, 0.41887578E-11_JPRB, 0.38151387E-11_JPRB, 0.35353944E-11_JPRB, &
  & 0.33289608E-11_JPRB, 0.31507581E-11_JPRB, 0.29827317E-11_JPRB, 0.26686563E-11_JPRB /)

RGHG6(:,16,12) = (/ &
  & 0.32100319E-10_JPRB, 0.29865922E-10_JPRB, 0.29504840E-10_JPRB, 0.29642136E-10_JPRB, 0.30101099E-10_JPRB, 0.30836216E-10_JPRB, &
  & 0.31845804E-10_JPRB, 0.33175580E-10_JPRB, 0.34919821E-10_JPRB, 0.37097277E-10_JPRB, 0.39752833E-10_JPRB, 0.42900090E-10_JPRB, &
  & 0.46578387E-10_JPRB, 0.50845238E-10_JPRB, 0.55631572E-10_JPRB, 0.60966544E-10_JPRB, 0.66669385E-10_JPRB, 0.72506494E-10_JPRB, &
  & 0.78413505E-10_JPRB, 0.84031768E-10_JPRB, 0.88991522E-10_JPRB, 0.92881321E-10_JPRB, 0.95527808E-10_JPRB, 0.96632757E-10_JPRB, &
  & 0.95827131E-10_JPRB, 0.92888898E-10_JPRB, 0.87735874E-10_JPRB, 0.80778884E-10_JPRB, 0.72590323E-10_JPRB, 0.63882052E-10_JPRB, &
  & 0.55412289E-10_JPRB, 0.48018936E-10_JPRB, 0.42365340E-10_JPRB, 0.38728989E-10_JPRB, 0.37026292E-10_JPRB, 0.36967662E-10_JPRB, &
  & 0.37940207E-10_JPRB, 0.39379007E-10_JPRB, 0.40853994E-10_JPRB, 0.42154245E-10_JPRB, 0.43119085E-10_JPRB, 0.43647624E-10_JPRB, &
  & 0.43679727E-10_JPRB, 0.43204492E-10_JPRB, 0.42262697E-10_JPRB, 0.40853675E-10_JPRB, 0.38969376E-10_JPRB, 0.36616626E-10_JPRB, &
  & 0.33853812E-10_JPRB, 0.30791144E-10_JPRB, 0.27573627E-10_JPRB, 0.24359029E-10_JPRB, 0.21297112E-10_JPRB, 0.18512157E-10_JPRB, &
  & 0.16083305E-10_JPRB, 0.14047399E-10_JPRB, 0.12392714E-10_JPRB, 0.11075089E-10_JPRB, 0.10044166E-10_JPRB, 0.92503331E-11_JPRB, &
  & 0.86225081E-11_JPRB, 0.81462328E-11_JPRB, 0.76185577E-11_JPRB, 0.68700453E-11_JPRB /)

RGHG6(:,17,12) = (/ &
  & 0.46492785E-10_JPRB, 0.45982218E-10_JPRB, 0.46233944E-10_JPRB, 0.46961001E-10_JPRB, 0.48095587E-10_JPRB, 0.49600990E-10_JPRB, &
  & 0.51493518E-10_JPRB, 0.53836012E-10_JPRB, 0.56753345E-10_JPRB, 0.60265501E-10_JPRB, 0.64401005E-10_JPRB, 0.69131673E-10_JPRB, &
  & 0.74455934E-10_JPRB, 0.80395961E-10_JPRB, 0.86814618E-10_JPRB, 0.93742132E-10_JPRB, 0.10094865E-09_JPRB, 0.10811059E-09_JPRB, &
  & 0.11507474E-09_JPRB, 0.12139140E-09_JPRB, 0.12660782E-09_JPRB, 0.13023460E-09_JPRB, 0.13206417E-09_JPRB, 0.13181914E-09_JPRB, &
  & 0.12922308E-09_JPRB, 0.12422981E-09_JPRB, 0.11696917E-09_JPRB, 0.10810968E-09_JPRB, 0.98304372E-10_JPRB, 0.88470065E-10_JPRB, &
  & 0.79597301E-10_JPRB, 0.72468823E-10_JPRB, 0.67552741E-10_JPRB, 0.65314996E-10_JPRB, 0.65528478E-10_JPRB, 0.67607690E-10_JPRB, &
  & 0.70708120E-10_JPRB, 0.73941672E-10_JPRB, 0.76655640E-10_JPRB, 0.78584611E-10_JPRB, 0.79594005E-10_JPRB, 0.79685855E-10_JPRB, &
  & 0.78934484E-10_JPRB, 0.77459802E-10_JPRB, 0.75401518E-10_JPRB, 0.72812506E-10_JPRB, 0.69676140E-10_JPRB, 0.65986702E-10_JPRB, &
  & 0.61781406E-10_JPRB, 0.57142912E-10_JPRB, 0.52218608E-10_JPRB, 0.47197718E-10_JPRB, 0.42251789E-10_JPRB, 0.37564299E-10_JPRB, &
  & 0.33297382E-10_JPRB, 0.29560038E-10_JPRB, 0.26399712E-10_JPRB, 0.23788515E-10_JPRB, 0.21673443E-10_JPRB, 0.19991087E-10_JPRB, &
  & 0.18695425E-10_JPRB, 0.17593357E-10_JPRB, 0.16617097E-10_JPRB, 0.14859192E-10_JPRB /)

RGHG6(:,18,12) = (/ &
  & 0.63396052E-10_JPRB, 0.63642064E-10_JPRB, 0.64809921E-10_JPRB, 0.66537442E-10_JPRB, 0.68755397E-10_JPRB, 0.71444926E-10_JPRB, &
  & 0.74610186E-10_JPRB, 0.78347800E-10_JPRB, 0.82765184E-10_JPRB, 0.87892811E-10_JPRB, 0.93744755E-10_JPRB, 0.10024560E-09_JPRB, &
  & 0.10733801E-09_JPRB, 0.11500762E-09_JPRB, 0.12305153E-09_JPRB, 0.13143502E-09_JPRB, 0.13990820E-09_JPRB, 0.14808799E-09_JPRB, &
  & 0.15571380E-09_JPRB, 0.16228444E-09_JPRB, 0.16726076E-09_JPRB, 0.17012193E-09_JPRB, 0.17067302E-09_JPRB, 0.16870672E-09_JPRB, &
  & 0.16415173E-09_JPRB, 0.15720769E-09_JPRB, 0.14828749E-09_JPRB, 0.13832739E-09_JPRB, 0.12833345E-09_JPRB, 0.11916952E-09_JPRB, &
  & 0.11154665E-09_JPRB, 0.10635996E-09_JPRB, 0.10382347E-09_JPRB, 0.10401546E-09_JPRB, 0.10664671E-09_JPRB, 0.11098292E-09_JPRB, &
  & 0.11598205E-09_JPRB, 0.12057834E-09_JPRB, 0.12393482E-09_JPRB, 0.12581546E-09_JPRB, 0.12618942E-09_JPRB, 0.12522974E-09_JPRB, &
  & 0.12320731E-09_JPRB, 0.12031429E-09_JPRB, 0.11682662E-09_JPRB, 0.11280253E-09_JPRB, 0.10826047E-09_JPRB, 0.10317031E-09_JPRB, &
  & 0.97536819E-10_JPRB, 0.91410997E-10_JPRB, 0.84911182E-10_JPRB, 0.78169006E-10_JPRB, 0.71361278E-10_JPRB, 0.64719806E-10_JPRB, &
  & 0.58469493E-10_JPRB, 0.52828006E-10_JPRB, 0.47908691E-10_JPRB, 0.43723785E-10_JPRB, 0.40248953E-10_JPRB, 0.37426486E-10_JPRB, &
  & 0.35193733E-10_JPRB, 0.33374074E-10_JPRB, 0.31601041E-10_JPRB, 0.28716841E-10_JPRB /)

RGHG6(:,19,12) = (/ &
  & 0.80731519E-10_JPRB, 0.83035578E-10_JPRB, 0.85324789E-10_JPRB, 0.88045744E-10_JPRB, 0.91312839E-10_JPRB, 0.95155564E-10_JPRB, &
  & 0.99639019E-10_JPRB, 0.10480796E-09_JPRB, 0.11078118E-09_JPRB, 0.11754862E-09_JPRB, 0.12509169E-09_JPRB, 0.13330774E-09_JPRB, &
  & 0.14206414E-09_JPRB, 0.15129135E-09_JPRB, 0.16075243E-09_JPRB, 0.17033655E-09_JPRB, 0.17976558E-09_JPRB, 0.18866245E-09_JPRB, &
  & 0.19665741E-09_JPRB, 0.20319484E-09_JPRB, 0.20771870E-09_JPRB, 0.20969462E-09_JPRB, 0.20897523E-09_JPRB, 0.20545472E-09_JPRB, &
  & 0.19933891E-09_JPRB, 0.19114094E-09_JPRB, 0.18166596E-09_JPRB, 0.17215761E-09_JPRB, 0.16344509E-09_JPRB, 0.15641707E-09_JPRB, &
  & 0.15185347E-09_JPRB, 0.14979379E-09_JPRB, 0.15030252E-09_JPRB, 0.15320403E-09_JPRB, 0.15792372E-09_JPRB, 0.16368300E-09_JPRB, &
  & 0.16947065E-09_JPRB, 0.17420651E-09_JPRB, 0.17725395E-09_JPRB, 0.17846513E-09_JPRB, 0.17782179E-09_JPRB, 0.17550762E-09_JPRB, &
  & 0.17201478E-09_JPRB, 0.16765814E-09_JPRB, 0.16270515E-09_JPRB, 0.15729797E-09_JPRB, 0.15144953E-09_JPRB, 0.14513410E-09_JPRB, &
  & 0.13833337E-09_JPRB, 0.13105191E-09_JPRB, 0.12331543E-09_JPRB, 0.11522476E-09_JPRB, 0.10694931E-09_JPRB, 0.98700853E-10_JPRB, &
  & 0.90781167E-10_JPRB, 0.83468746E-10_JPRB, 0.76946248E-10_JPRB, 0.71280738E-10_JPRB, 0.66474201E-10_JPRB, 0.62521807E-10_JPRB, &
  & 0.59300780E-10_JPRB, 0.56760825E-10_JPRB, 0.54073333E-10_JPRB, 0.50074434E-10_JPRB /)

RGHG6(:,20,12) = (/ &
  & 0.10016925E-09_JPRB, 0.10377486E-09_JPRB, 0.10688466E-09_JPRB, 0.11039157E-09_JPRB, 0.11451258E-09_JPRB, 0.11935074E-09_JPRB, &
  & 0.12492513E-09_JPRB, 0.13134753E-09_JPRB, 0.13865858E-09_JPRB, 0.14683182E-09_JPRB, 0.15583058E-09_JPRB, 0.16548014E-09_JPRB, &
  & 0.17562013E-09_JPRB, 0.18610290E-09_JPRB, 0.19670056E-09_JPRB, 0.20723392E-09_JPRB, 0.21734833E-09_JPRB, 0.22668604E-09_JPRB, &
  & 0.23492167E-09_JPRB, 0.24142904E-09_JPRB, 0.24562730E-09_JPRB, 0.24701594E-09_JPRB, 0.24550473E-09_JPRB, 0.24114435E-09_JPRB, &
  & 0.23438260E-09_JPRB, 0.22609140E-09_JPRB, 0.21735239E-09_JPRB, 0.20932484E-09_JPRB, 0.20316585E-09_JPRB, 0.19954226E-09_JPRB, &
  & 0.19845353E-09_JPRB, 0.19985731E-09_JPRB, 0.20320177E-09_JPRB, 0.20806218E-09_JPRB, 0.21376589E-09_JPRB, 0.21962294E-09_JPRB, &
  & 0.22500959E-09_JPRB, 0.22917764E-09_JPRB, 0.23131290E-09_JPRB, 0.23117250E-09_JPRB, 0.22929908E-09_JPRB, 0.22574299E-09_JPRB, &
  & 0.22102435E-09_JPRB, 0.21545944E-09_JPRB, 0.20930739E-09_JPRB, 0.20279177E-09_JPRB, 0.19593102E-09_JPRB, 0.18873797E-09_JPRB, &
  & 0.18113487E-09_JPRB, 0.17308172E-09_JPRB, 0.16456851E-09_JPRB, 0.15568070E-09_JPRB, 0.14652818E-09_JPRB, 0.13731880E-09_JPRB, &
  & 0.12835759E-09_JPRB, 0.11994489E-09_JPRB, 0.11231671E-09_JPRB, 0.10557186E-09_JPRB, 0.99772565E-10_JPRB, 0.94909615E-10_JPRB, &
  & 0.91042326E-10_JPRB, 0.87604035E-10_JPRB, 0.84626361E-10_JPRB, 0.78691900E-10_JPRB /)

RGHG6(:,21,12) = (/ &
  & 0.11898803E-09_JPRB, 0.12398824E-09_JPRB, 0.12791083E-09_JPRB, 0.13216073E-09_JPRB, 0.13705620E-09_JPRB, 0.14270642E-09_JPRB, &
  & 0.14920810E-09_JPRB, 0.15658105E-09_JPRB, 0.16491981E-09_JPRB, 0.17418862E-09_JPRB, 0.18427297E-09_JPRB, 0.19501577E-09_JPRB, &
  & 0.20619756E-09_JPRB, 0.21759859E-09_JPRB, 0.22898797E-09_JPRB, 0.24022179E-09_JPRB, 0.25093427E-09_JPRB, 0.26067648E-09_JPRB, &
  & 0.26914210E-09_JPRB, 0.27578975E-09_JPRB, 0.28005415E-09_JPRB, 0.28147290E-09_JPRB, 0.27999988E-09_JPRB, 0.27582081E-09_JPRB, &
  & 0.26957442E-09_JPRB, 0.26229036E-09_JPRB, 0.25514668E-09_JPRB, 0.24953087E-09_JPRB, 0.24639807E-09_JPRB, 0.24593788E-09_JPRB, &
  & 0.24795066E-09_JPRB, 0.25181965E-09_JPRB, 0.25684738E-09_JPRB, 0.26239963E-09_JPRB, 0.26779601E-09_JPRB, 0.27278985E-09_JPRB, &
  & 0.27684025E-09_JPRB, 0.27944247E-09_JPRB, 0.28044728E-09_JPRB, 0.27950392E-09_JPRB, 0.27670516E-09_JPRB, 0.27234268E-09_JPRB, &
  & 0.26686292E-09_JPRB, 0.26053393E-09_JPRB, 0.25370211E-09_JPRB, 0.24643279E-09_JPRB, 0.23895211E-09_JPRB, 0.23121514E-09_JPRB, &
  & 0.22316549E-09_JPRB, 0.21476365E-09_JPRB, 0.20600278E-09_JPRB, 0.19691374E-09_JPRB, 0.18754559E-09_JPRB, 0.17807708E-09_JPRB, &
  & 0.16875767E-09_JPRB, 0.15989601E-09_JPRB, 0.15172888E-09_JPRB, 0.14441330E-09_JPRB, 0.13803662E-09_JPRB, 0.13265554E-09_JPRB, &
  & 0.12811624E-09_JPRB, 0.12452728E-09_JPRB, 0.12030482E-09_JPRB, 0.11428822E-09_JPRB /)

RGHG6(:,22,12) = (/ &
  & 0.13731587E-09_JPRB, 0.14334406E-09_JPRB, 0.14787432E-09_JPRB, 0.15269352E-09_JPRB, 0.15819414E-09_JPRB, 0.16453319E-09_JPRB, &
  & 0.17171649E-09_JPRB, 0.17981168E-09_JPRB, 0.18886043E-09_JPRB, 0.19885099E-09_JPRB, 0.20971883E-09_JPRB, 0.22118665E-09_JPRB, &
  & 0.23309019E-09_JPRB, 0.24516739E-09_JPRB, 0.25713540E-09_JPRB, 0.26882063E-09_JPRB, 0.27995753E-09_JPRB, 0.29018735E-09_JPRB, &
  & 0.29913585E-09_JPRB, 0.30627512E-09_JPRB, 0.31110603E-09_JPRB, 0.31324149E-09_JPRB, 0.31269831E-09_JPRB, 0.30971822E-09_JPRB, &
  & 0.30504874E-09_JPRB, 0.29972419E-09_JPRB, 0.29492275E-09_JPRB, 0.29186786E-09_JPRB, 0.29113106E-09_JPRB, 0.29283076E-09_JPRB, &
  & 0.29642863E-09_JPRB, 0.30129443E-09_JPRB, 0.30657557E-09_JPRB, 0.31159184E-09_JPRB, 0.31608582E-09_JPRB, 0.31981001E-09_JPRB, &
  & 0.32262520E-09_JPRB, 0.32401656E-09_JPRB, 0.32381287E-09_JPRB, 0.32179440E-09_JPRB, 0.31837105E-09_JPRB, 0.31370012E-09_JPRB, &
  & 0.30784567E-09_JPRB, 0.30123651E-09_JPRB, 0.29401465E-09_JPRB, 0.28646999E-09_JPRB, 0.27869743E-09_JPRB, 0.27077648E-09_JPRB, &
  & 0.26264241E-09_JPRB, 0.25430930E-09_JPRB, 0.24573535E-09_JPRB, 0.23687705E-09_JPRB, 0.22778379E-09_JPRB, 0.21856740E-09_JPRB, &
  & 0.20944126E-09_JPRB, 0.20063448E-09_JPRB, 0.19239769E-09_JPRB, 0.18489398E-09_JPRB, 0.17825699E-09_JPRB, 0.17255056E-09_JPRB, &
  & 0.16785275E-09_JPRB, 0.16352564E-09_JPRB, 0.15967463E-09_JPRB, 0.15177438E-09_JPRB /)

RGHG6(:,23,12) = (/ &
  & 0.15526580E-09_JPRB, 0.16190586E-09_JPRB, 0.16683013E-09_JPRB, 0.17201240E-09_JPRB, 0.17789872E-09_JPRB, 0.18464040E-09_JPRB, &
  & 0.19229987E-09_JPRB, 0.20085800E-09_JPRB, 0.21036074E-09_JPRB, 0.22082135E-09_JPRB, 0.23214516E-09_JPRB, 0.24409313E-09_JPRB, &
  & 0.25642033E-09_JPRB, 0.26892458E-09_JPRB, 0.28135050E-09_JPRB, 0.29348712E-09_JPRB, 0.30502334E-09_JPRB, 0.31566125E-09_JPRB, &
  & 0.32514319E-09_JPRB, 0.33305686E-09_JPRB, 0.33896277E-09_JPRB, 0.34251213E-09_JPRB, 0.34368358E-09_JPRB, 0.34277742E-09_JPRB, &
  & 0.34044692E-09_JPRB, 0.33757400E-09_JPRB, 0.33510250E-09_JPRB, 0.33401409E-09_JPRB, 0.33468964E-09_JPRB, 0.33711725E-09_JPRB, &
  & 0.34093384E-09_JPRB, 0.34540226E-09_JPRB, 0.34970016E-09_JPRB, 0.35357409E-09_JPRB, 0.35678913E-09_JPRB, 0.35911826E-09_JPRB, &
  & 0.36050560E-09_JPRB, 0.36077802E-09_JPRB, 0.35990039E-09_JPRB, 0.35759717E-09_JPRB, 0.35397585E-09_JPRB, 0.34919415E-09_JPRB, &
  & 0.34333700E-09_JPRB, 0.33677150E-09_JPRB, 0.32953812E-09_JPRB, 0.32198555E-09_JPRB, 0.31425221E-09_JPRB, 0.30643826E-09_JPRB, &
  & 0.29853489E-09_JPRB, 0.29051200E-09_JPRB, 0.28234201E-09_JPRB, 0.27397953E-09_JPRB, 0.26543787E-09_JPRB, 0.25680230E-09_JPRB, &
  & 0.24817948E-09_JPRB, 0.23976354E-09_JPRB, 0.23173446E-09_JPRB, 0.22428440E-09_JPRB, 0.21757769E-09_JPRB, 0.21172181E-09_JPRB, &
  & 0.20665053E-09_JPRB, 0.20238493E-09_JPRB, 0.19740540E-09_JPRB, 0.18969398E-09_JPRB /)

RGHG6(:,24,12) = (/ &
  & 0.17266857E-09_JPRB, 0.17972530E-09_JPRB, 0.18489257E-09_JPRB, 0.19027759E-09_JPRB, 0.19635310E-09_JPRB, 0.20331115E-09_JPRB, &
  & 0.21118253E-09_JPRB, 0.21999923E-09_JPRB, 0.22976418E-09_JPRB, 0.24044700E-09_JPRB, 0.25200936E-09_JPRB, 0.26417588E-09_JPRB, &
  & 0.27670208E-09_JPRB, 0.28934305E-09_JPRB, 0.30189629E-09_JPRB, 0.31423053E-09_JPRB, 0.32611913E-09_JPRB, 0.33729353E-09_JPRB, &
  & 0.34751843E-09_JPRB, 0.35643666E-09_JPRB, 0.36366593E-09_JPRB, 0.36891940E-09_JPRB, 0.37220158E-09_JPRB, 0.37372996E-09_JPRB, &
  & 0.37394016E-09_JPRB, 0.37350670E-09_JPRB, 0.37301598E-09_JPRB, 0.37318895E-09_JPRB, 0.37438391E-09_JPRB, 0.37656528E-09_JPRB, &
  & 0.37950237E-09_JPRB, 0.38264517E-09_JPRB, 0.38558448E-09_JPRB, 0.38807438E-09_JPRB, 0.39001613E-09_JPRB, 0.39120512E-09_JPRB, &
  & 0.39163428E-09_JPRB, 0.39122966E-09_JPRB, 0.38975045E-09_JPRB, 0.38719764E-09_JPRB, 0.38365985E-09_JPRB, 0.37901207E-09_JPRB, &
  & 0.37350353E-09_JPRB, 0.36717038E-09_JPRB, 0.36026837E-09_JPRB, 0.35292785E-09_JPRB, 0.34542472E-09_JPRB, 0.33784228E-09_JPRB, &
  & 0.33026795E-09_JPRB, 0.32265632E-09_JPRB, 0.31497555E-09_JPRB, 0.30721525E-09_JPRB, 0.29934483E-09_JPRB, 0.29140276E-09_JPRB, &
  & 0.28345154E-09_JPRB, 0.27557986E-09_JPRB, 0.26795824E-09_JPRB, 0.26072539E-09_JPRB, 0.25407251E-09_JPRB, 0.24812796E-09_JPRB, &
  & 0.24295954E-09_JPRB, 0.23817476E-09_JPRB, 0.23341540E-09_JPRB, 0.22453686E-09_JPRB /)

RGHG6(:,25,12) = (/ &
  & 0.18974619E-09_JPRB, 0.19704885E-09_JPRB, 0.20233251E-09_JPRB, 0.20777705E-09_JPRB, 0.21390037E-09_JPRB, 0.22088531E-09_JPRB, &
  & 0.22881842E-09_JPRB, 0.23769850E-09_JPRB, 0.24752853E-09_JPRB, 0.25828117E-09_JPRB, 0.26985950E-09_JPRB, 0.28205724E-09_JPRB, &
  & 0.29462838E-09_JPRB, 0.30736441E-09_JPRB, 0.32004779E-09_JPRB, 0.33248443E-09_JPRB, 0.34453954E-09_JPRB, 0.35603212E-09_JPRB, &
  & 0.36675624E-09_JPRB, 0.37647291E-09_JPRB, 0.38491516E-09_JPRB, 0.39183387E-09_JPRB, 0.39713893E-09_JPRB, 0.40088699E-09_JPRB, &
  & 0.40333090E-09_JPRB, 0.40486858E-09_JPRB, 0.40594281E-09_JPRB, 0.40696790E-09_JPRB, 0.40815479E-09_JPRB, 0.40965292E-09_JPRB, &
  & 0.41137951E-09_JPRB, 0.41315509E-09_JPRB, 0.41469950E-09_JPRB, 0.41593642E-09_JPRB, 0.41680126E-09_JPRB, 0.41715481E-09_JPRB, &
  & 0.41687129E-09_JPRB, 0.41592987E-09_JPRB, 0.41425088E-09_JPRB, 0.41168882E-09_JPRB, 0.40827300E-09_JPRB, 0.40395393E-09_JPRB, &
  & 0.39884251E-09_JPRB, 0.39293385E-09_JPRB, 0.38642084E-09_JPRB, 0.37943712E-09_JPRB, 0.37225256E-09_JPRB, 0.36500558E-09_JPRB, &
  & 0.35776412E-09_JPRB, 0.35056635E-09_JPRB, 0.34337422E-09_JPRB, 0.33619746E-09_JPRB, 0.32898134E-09_JPRB, 0.32174707E-09_JPRB, &
  & 0.31448955E-09_JPRB, 0.30727998E-09_JPRB, 0.30017938E-09_JPRB, 0.29334529E-09_JPRB, 0.28691316E-09_JPRB, 0.28103936E-09_JPRB, &
  & 0.27578018E-09_JPRB, 0.27094607E-09_JPRB, 0.26570768E-09_JPRB, 0.25636027E-09_JPRB /)

RGHG6(:,26,12) = (/ &
  & 0.20682850E-09_JPRB, 0.21423793E-09_JPRB, 0.21952744E-09_JPRB, 0.22493502E-09_JPRB, 0.23096600E-09_JPRB, 0.23787863E-09_JPRB, &
  & 0.24572816E-09_JPRB, 0.25452876E-09_JPRB, 0.26425742E-09_JPRB, 0.27487135E-09_JPRB, 0.28626809E-09_JPRB, 0.29823952E-09_JPRB, &
  & 0.31057065E-09_JPRB, 0.32307421E-09_JPRB, 0.33558989E-09_JPRB, 0.34798847E-09_JPRB, 0.36006473E-09_JPRB, 0.37168613E-09_JPRB, &
  & 0.38278264E-09_JPRB, 0.39317677E-09_JPRB, 0.40262102E-09_JPRB, 0.41085221E-09_JPRB, 0.41772508E-09_JPRB, 0.42319151E-09_JPRB, &
  & 0.42735993E-09_JPRB, 0.43040668E-09_JPRB, 0.43258205E-09_JPRB, 0.43414367E-09_JPRB, 0.43529141E-09_JPRB, 0.43622131E-09_JPRB, &
  & 0.43701737E-09_JPRB, 0.43766260E-09_JPRB, 0.43807907E-09_JPRB, 0.43833612E-09_JPRB, 0.43837053E-09_JPRB, 0.43809381E-09_JPRB, &
  & 0.43737672E-09_JPRB, 0.43616505E-09_JPRB, 0.43438059E-09_JPRB, 0.43193371E-09_JPRB, 0.42874604E-09_JPRB, 0.42479717E-09_JPRB, &
  & 0.42009674E-09_JPRB, 0.41463266E-09_JPRB, 0.40852058E-09_JPRB, 0.40191891E-09_JPRB, 0.39506398E-09_JPRB, 0.38814546E-09_JPRB, &
  & 0.38125408E-09_JPRB, 0.37443881E-09_JPRB, 0.36768810E-09_JPRB, 0.36102479E-09_JPRB, 0.35440656E-09_JPRB, 0.34782430E-09_JPRB, &
  & 0.34126080E-09_JPRB, 0.33472869E-09_JPRB, 0.32829384E-09_JPRB, 0.32199510E-09_JPRB, 0.31599401E-09_JPRB, 0.31038963E-09_JPRB, &
  & 0.30523070E-09_JPRB, 0.30043329E-09_JPRB, 0.29497838E-09_JPRB, 0.28577077E-09_JPRB /)

RGHG6(:,27,12) = (/ &
  & 0.22421169E-09_JPRB, 0.23165675E-09_JPRB, 0.23686508E-09_JPRB, 0.24213051E-09_JPRB, 0.24802094E-09_JPRB, 0.25474023E-09_JPRB, &
  & 0.26241248E-09_JPRB, 0.27101013E-09_JPRB, 0.28048164E-09_JPRB, 0.29078223E-09_JPRB, 0.30180858E-09_JPRB, 0.31340669E-09_JPRB, &
  & 0.32533579E-09_JPRB, 0.33745981E-09_JPRB, 0.34958941E-09_JPRB, 0.36165870E-09_JPRB, 0.37356590E-09_JPRB, 0.38520201E-09_JPRB, &
  & 0.39645978E-09_JPRB, 0.40717840E-09_JPRB, 0.41715167E-09_JPRB, 0.42615356E-09_JPRB, 0.43401852E-09_JPRB, 0.44062345E-09_JPRB, &
  & 0.44597542E-09_JPRB, 0.45009557E-09_JPRB, 0.45313264E-09_JPRB, 0.45518112E-09_JPRB, 0.45643611E-09_JPRB, 0.45706233E-09_JPRB, &
  & 0.45728199E-09_JPRB, 0.45717433E-09_JPRB, 0.45682710E-09_JPRB, 0.45640330E-09_JPRB, 0.45586043E-09_JPRB, 0.45515477E-09_JPRB, &
  & 0.45417470E-09_JPRB, 0.45280926E-09_JPRB, 0.45102988E-09_JPRB, 0.44874843E-09_JPRB, 0.44583615E-09_JPRB, 0.44225781E-09_JPRB, &
  & 0.43796639E-09_JPRB, 0.43293533E-09_JPRB, 0.42723583E-09_JPRB, 0.42101461E-09_JPRB, 0.41447573E-09_JPRB, 0.40783474E-09_JPRB, &
  & 0.40120587E-09_JPRB, 0.39471099E-09_JPRB, 0.38835749E-09_JPRB, 0.38214917E-09_JPRB, 0.37605474E-09_JPRB, 0.37006126E-09_JPRB, &
  & 0.36415290E-09_JPRB, 0.35832209E-09_JPRB, 0.35256237E-09_JPRB, 0.34693512E-09_JPRB, 0.34149078E-09_JPRB, 0.33635816E-09_JPRB, &
  & 0.33159875E-09_JPRB, 0.32693503E-09_JPRB, 0.32204384E-09_JPRB, 0.31257766E-09_JPRB /)

RGHG6(:,28,12) = (/ &
  & 0.24208921E-09_JPRB, 0.24948707E-09_JPRB, 0.25457528E-09_JPRB, 0.25969019E-09_JPRB, 0.26534053E-09_JPRB, 0.27184233E-09_JPRB, &
  & 0.27923575E-09_JPRB, 0.28749758E-09_JPRB, 0.29655606E-09_JPRB, 0.30637626E-09_JPRB, 0.31686759E-09_JPRB, 0.32793349E-09_JPRB, &
  & 0.33931732E-09_JPRB, 0.35094933E-09_JPRB, 0.36266515E-09_JPRB, 0.37433567E-09_JPRB, 0.38587927E-09_JPRB, 0.39722431E-09_JPRB, &
  & 0.40829892E-09_JPRB, 0.41896964E-09_JPRB, 0.42906140E-09_JPRB, 0.43837550E-09_JPRB, 0.44673526E-09_JPRB, 0.45400433E-09_JPRB, &
  & 0.46008600E-09_JPRB, 0.46493634E-09_JPRB, 0.46861870E-09_JPRB, 0.47113285E-09_JPRB, 0.47262788E-09_JPRB, 0.47323162E-09_JPRB, &
  & 0.47321613E-09_JPRB, 0.47272808E-09_JPRB, 0.47194182E-09_JPRB, 0.47109566E-09_JPRB, 0.47018806E-09_JPRB, 0.46921067E-09_JPRB, &
  & 0.46808091E-09_JPRB, 0.46668119E-09_JPRB, 0.46496207E-09_JPRB, 0.46285062E-09_JPRB, 0.46021159E-09_JPRB, 0.45697415E-09_JPRB, &
  & 0.45306536E-09_JPRB, 0.44843732E-09_JPRB, 0.44312223E-09_JPRB, 0.43723852E-09_JPRB, 0.43097984E-09_JPRB, 0.42456788E-09_JPRB, &
  & 0.41821066E-09_JPRB, 0.41199472E-09_JPRB, 0.40597453E-09_JPRB, 0.40016002E-09_JPRB, 0.39453515E-09_JPRB, 0.38908268E-09_JPRB, &
  & 0.38376272E-09_JPRB, 0.37856301E-09_JPRB, 0.37346815E-09_JPRB, 0.36846842E-09_JPRB, 0.36365094E-09_JPRB, 0.35906761E-09_JPRB, &
  & 0.35476605E-09_JPRB, 0.35067566E-09_JPRB, 0.34585695E-09_JPRB, 0.33765590E-09_JPRB /)

RGHG6(:,29,12) = (/ &
  & 0.26049146E-09_JPRB, 0.26781627E-09_JPRB, 0.27278016E-09_JPRB, 0.27768726E-09_JPRB, 0.28313643E-09_JPRB, 0.28932542E-09_JPRB, &
  & 0.29637220E-09_JPRB, 0.30419200E-09_JPRB, 0.31270345E-09_JPRB, 0.32187403E-09_JPRB, 0.33170941E-09_JPRB, 0.34205239E-09_JPRB, &
  & 0.35277625E-09_JPRB, 0.36376899E-09_JPRB, 0.37488410E-09_JPRB, 0.38602463E-09_JPRB, 0.39709402E-09_JPRB, 0.40802725E-09_JPRB, &
  & 0.41874754E-09_JPRB, 0.42914095E-09_JPRB, 0.43908613E-09_JPRB, 0.44839124E-09_JPRB, 0.45690082E-09_JPRB, 0.46445756E-09_JPRB, &
  & 0.47093413E-09_JPRB, 0.47625009E-09_JPRB, 0.48037885E-09_JPRB, 0.48330306E-09_JPRB, 0.48508902E-09_JPRB, 0.48584448E-09_JPRB, &
  & 0.48582477E-09_JPRB, 0.48522530E-09_JPRB, 0.48424548E-09_JPRB, 0.48317206E-09_JPRB, 0.48205839E-09_JPRB, 0.48092724E-09_JPRB, &
  & 0.47971788E-09_JPRB, 0.47834009E-09_JPRB, 0.47671611E-09_JPRB, 0.47477289E-09_JPRB, 0.47237747E-09_JPRB, 0.46943543E-09_JPRB, &
  & 0.46585591E-09_JPRB, 0.46157433E-09_JPRB, 0.45659060E-09_JPRB, 0.45099993E-09_JPRB, 0.44498477E-09_JPRB, 0.43883325E-09_JPRB, &
  & 0.43272075E-09_JPRB, 0.42679468E-09_JPRB, 0.42110349E-09_JPRB, 0.41566361E-09_JPRB, 0.41046322E-09_JPRB, 0.40546505E-09_JPRB, &
  & 0.40065384E-09_JPRB, 0.39597858E-09_JPRB, 0.39141684E-09_JPRB, 0.38697417E-09_JPRB, 0.38268402E-09_JPRB, 0.37864528E-09_JPRB, &
  & 0.37487000E-09_JPRB, 0.37118569E-09_JPRB, 0.36720454E-09_JPRB, 0.35972664E-09_JPRB /)

RGHG6(:,30,12) = (/ &
  & 0.27934818E-09_JPRB, 0.28657837E-09_JPRB, 0.29139205E-09_JPRB, 0.29613184E-09_JPRB, 0.30129713E-09_JPRB, 0.30718661E-09_JPRB, &
  & 0.31380748E-09_JPRB, 0.32108879E-09_JPRB, 0.32895037E-09_JPRB, 0.33738526E-09_JPRB, 0.34642081E-09_JPRB, 0.35594078E-09_JPRB, &
  & 0.36588776E-09_JPRB, 0.37615971E-09_JPRB, 0.38662701E-09_JPRB, 0.39719059E-09_JPRB, 0.40775167E-09_JPRB, 0.41820686E-09_JPRB, &
  & 0.42847517E-09_JPRB, 0.43844620E-09_JPRB, 0.44803028E-09_JPRB, 0.45710297E-09_JPRB, 0.46550080E-09_JPRB, 0.47307525E-09_JPRB, &
  & 0.47967491E-09_JPRB, 0.48520299E-09_JPRB, 0.48959581E-09_JPRB, 0.49281379E-09_JPRB, 0.49487103E-09_JPRB, 0.49584226E-09_JPRB, &
  & 0.49594168E-09_JPRB, 0.49538956E-09_JPRB, 0.49438359E-09_JPRB, 0.49322024E-09_JPRB, 0.49201720E-09_JPRB, 0.49080873E-09_JPRB, &
  & 0.48956794E-09_JPRB, 0.48822957E-09_JPRB, 0.48671034E-09_JPRB, 0.48492216E-09_JPRB, 0.48273135E-09_JPRB, 0.48002979E-09_JPRB, &
  & 0.47672016E-09_JPRB, 0.47272453E-09_JPRB, 0.46803061E-09_JPRB, 0.46271553E-09_JPRB, 0.45699128E-09_JPRB, 0.45109055E-09_JPRB, &
  & 0.44525200E-09_JPRB, 0.43960255E-09_JPRB, 0.43423415E-09_JPRB, 0.42914267E-09_JPRB, 0.42430232E-09_JPRB, 0.41968767E-09_JPRB, &
  & 0.41525738E-09_JPRB, 0.41098602E-09_JPRB, 0.40683507E-09_JPRB, 0.40280232E-09_JPRB, 0.39895792E-09_JPRB, 0.39535580E-09_JPRB, &
  & 0.39204029E-09_JPRB, 0.38886591E-09_JPRB, 0.38526618E-09_JPRB, 0.37890971E-09_JPRB /)

RGHG6(:,31,12) = (/ &
  & 0.29854910E-09_JPRB, 0.30561836E-09_JPRB, 0.31027428E-09_JPRB, 0.31477959E-09_JPRB, 0.31969277E-09_JPRB, 0.32520509E-09_JPRB, &
  & 0.33136702E-09_JPRB, 0.33807238E-09_JPRB, 0.34523234E-09_JPRB, 0.35286490E-09_JPRB, 0.36103456E-09_JPRB, 0.36965750E-09_JPRB, &
  & 0.37876519E-09_JPRB, 0.38825210E-09_JPRB, 0.39800846E-09_JPRB, 0.40795509E-09_JPRB, 0.41798073E-09_JPRB, 0.42795234E-09_JPRB, &
  & 0.43776544E-09_JPRB, 0.44729748E-09_JPRB, 0.45645704E-09_JPRB, 0.46516146E-09_JPRB, 0.47327703E-09_JPRB, 0.48066695E-09_JPRB, &
  & 0.48716420E-09_JPRB, 0.49266724E-09_JPRB, 0.49712895E-09_JPRB, 0.50050153E-09_JPRB, 0.50275528E-09_JPRB, 0.50392773E-09_JPRB, &
  & 0.50419180E-09_JPRB, 0.50376592E-09_JPRB, 0.50283899E-09_JPRB, 0.50168608E-09_JPRB, 0.50047344E-09_JPRB, 0.49924603E-09_JPRB, &
  & 0.49800608E-09_JPRB, 0.49671672E-09_JPRB, 0.49529048E-09_JPRB, 0.49362614E-09_JPRB, 0.49159404E-09_JPRB, 0.48907967E-09_JPRB, &
  & 0.48597604E-09_JPRB, 0.48221527E-09_JPRB, 0.47777687E-09_JPRB, 0.47274440E-09_JPRB, 0.46730469E-09_JPRB, 0.46170678E-09_JPRB, &
  & 0.45614901E-09_JPRB, 0.45081289E-09_JPRB, 0.44573975E-09_JPRB, 0.44093876E-09_JPRB, 0.43639631E-09_JPRB, 0.43208007E-09_JPRB, &
  & 0.42796552E-09_JPRB, 0.42398829E-09_JPRB, 0.42013293E-09_JPRB, 0.41641593E-09_JPRB, 0.41289505E-09_JPRB, 0.40966186E-09_JPRB, &
  & 0.40669756E-09_JPRB, 0.40388703E-09_JPRB, 0.40077971E-09_JPRB, 0.39522938E-09_JPRB /)

RGHG6(:,32,12) = (/ &
  & 0.31790018E-09_JPRB, 0.32471023E-09_JPRB, 0.32913369E-09_JPRB, 0.33339370E-09_JPRB, 0.33798586E-09_JPRB, 0.34312611E-09_JPRB, &
  & 0.34880879E-09_JPRB, 0.35491851E-09_JPRB, 0.36138129E-09_JPRB, 0.36821091E-09_JPRB, 0.37547337E-09_JPRB, 0.38319378E-09_JPRB, &
  & 0.39143483E-09_JPRB, 0.40015405E-09_JPRB, 0.40925857E-09_JPRB, 0.41862916E-09_JPRB, 0.42814022E-09_JPRB, 0.43762774E-09_JPRB, &
  & 0.44695952E-09_JPRB, 0.45601409E-09_JPRB, 0.46471890E-09_JPRB, 0.47298215E-09_JPRB, 0.48069915E-09_JPRB, 0.48771598E-09_JPRB, &
  & 0.49391458E-09_JPRB, 0.49921189E-09_JPRB, 0.50356619E-09_JPRB, 0.50693982E-09_JPRB, 0.50928017E-09_JPRB, 0.51060306E-09_JPRB, &
  & 0.51102911E-09_JPRB, 0.51076099E-09_JPRB, 0.50997417E-09_JPRB, 0.50890564E-09_JPRB, 0.50774007E-09_JPRB, 0.50653720E-09_JPRB, &
  & 0.50533044E-09_JPRB, 0.50409521E-09_JPRB, 0.50274396E-09_JPRB, 0.50116855E-09_JPRB, 0.49924925E-09_JPRB, 0.49686188E-09_JPRB, &
  & 0.49391574E-09_JPRB, 0.49033899E-09_JPRB, 0.48612303E-09_JPRB, 0.48136373E-09_JPRB, 0.47623289E-09_JPRB, 0.47091109E-09_JPRB, &
  & 0.46566662E-09_JPRB, 0.46060977E-09_JPRB, 0.45583198E-09_JPRB, 0.45132412E-09_JPRB, 0.44705270E-09_JPRB, 0.44300047E-09_JPRB, &
  & 0.43910592E-09_JPRB, 0.43535314E-09_JPRB, 0.43172266E-09_JPRB, 0.42823942E-09_JPRB, 0.42498408E-09_JPRB, 0.42201090E-09_JPRB, &
  & 0.41934600E-09_JPRB, 0.41680723E-09_JPRB, 0.41403508E-09_JPRB, 0.40908579E-09_JPRB /)

RGHG6(:,33,12) = (/ &
  & 0.33712866E-09_JPRB, 0.34354619E-09_JPRB, 0.34766659E-09_JPRB, 0.35163014E-09_JPRB, 0.35588732E-09_JPRB, 0.36063488E-09_JPRB, &
  & 0.36584449E-09_JPRB, 0.37139603E-09_JPRB, 0.37718076E-09_JPRB, 0.38322831E-09_JPRB, 0.38960396E-09_JPRB, 0.39642128E-09_JPRB, &
  & 0.40378700E-09_JPRB, 0.41173170E-09_JPRB, 0.42020559E-09_JPRB, 0.42907042E-09_JPRB, 0.43814613E-09_JPRB, 0.44721971E-09_JPRB, &
  & 0.45611165E-09_JPRB, 0.46472040E-09_JPRB, 0.47295756E-09_JPRB, 0.48073467E-09_JPRB, 0.48795445E-09_JPRB, 0.49450544E-09_JPRB, &
  & 0.50026155E-09_JPRB, 0.50517895E-09_JPRB, 0.50926363E-09_JPRB, 0.51248827E-09_JPRB, 0.51480537E-09_JPRB, 0.51620125E-09_JPRB, &
  & 0.51676186E-09_JPRB, 0.51665661E-09_JPRB, 0.51604498E-09_JPRB, 0.51511068E-09_JPRB, 0.51404148E-09_JPRB, 0.51290683E-09_JPRB, &
  & 0.51176363E-09_JPRB, 0.51058729E-09_JPRB, 0.50929339E-09_JPRB, 0.50778370E-09_JPRB, 0.50593207E-09_JPRB, 0.50362653E-09_JPRB, &
  & 0.50078514E-09_JPRB, 0.49734256E-09_JPRB, 0.49332027E-09_JPRB, 0.48881549E-09_JPRB, 0.48394672E-09_JPRB, 0.47895782E-09_JPRB, &
  & 0.47401788E-09_JPRB, 0.46929727E-09_JPRB, 0.46479803E-09_JPRB, 0.46052973E-09_JPRB, 0.45648804E-09_JPRB, 0.45263543E-09_JPRB, &
  & 0.44894877E-09_JPRB, 0.44538351E-09_JPRB, 0.44193990E-09_JPRB, 0.43865062E-09_JPRB, 0.43558812E-09_JPRB, 0.43283654E-09_JPRB, &
  & 0.43035017E-09_JPRB, 0.42804299E-09_JPRB, 0.42547338E-09_JPRB, 0.42104067E-09_JPRB /)

RGHG6(:,34,12) = (/ &
  & 0.35590714E-09_JPRB, 0.36177566E-09_JPRB, 0.36556788E-09_JPRB, 0.36917730E-09_JPRB, 0.37309861E-09_JPRB, 0.37745451E-09_JPRB, &
  & 0.38222620E-09_JPRB, 0.38724432E-09_JPRB, 0.39240589E-09_JPRB, 0.39770975E-09_JPRB, 0.40324319E-09_JPRB, 0.40918396E-09_JPRB, &
  & 0.41569359E-09_JPRB, 0.42287626E-09_JPRB, 0.43073684E-09_JPRB, 0.43912660E-09_JPRB, 0.44779574E-09_JPRB, 0.45652035E-09_JPRB, &
  & 0.46508036E-09_JPRB, 0.47332072E-09_JPRB, 0.48111537E-09_JPRB, 0.48839288E-09_JPRB, 0.49508975E-09_JPRB, 0.50109383E-09_JPRB, &
  & 0.50631027E-09_JPRB, 0.51073751E-09_JPRB, 0.51441834E-09_JPRB, 0.51736282E-09_JPRB, 0.51954135E-09_JPRB, 0.52092952E-09_JPRB, &
  & 0.52157711E-09_JPRB, 0.52162508E-09_JPRB, 0.52120308E-09_JPRB, 0.52044197E-09_JPRB, 0.51951765E-09_JPRB, 0.51850396E-09_JPRB, &
  & 0.51745197E-09_JPRB, 0.51634641E-09_JPRB, 0.51511084E-09_JPRB, 0.51364657E-09_JPRB, 0.51183435E-09_JPRB, 0.50957438E-09_JPRB, &
  & 0.50678439E-09_JPRB, 0.50343968E-09_JPRB, 0.49956933E-09_JPRB, 0.49526638E-09_JPRB, 0.49068855E-09_JPRB, 0.48599519E-09_JPRB, &
  & 0.48139415E-09_JPRB, 0.47693621E-09_JPRB, 0.47269161E-09_JPRB, 0.46867182E-09_JPRB, 0.46485288E-09_JPRB, 0.46121121E-09_JPRB, &
  & 0.45769100E-09_JPRB, 0.45429058E-09_JPRB, 0.45099963E-09_JPRB, 0.44786880E-09_JPRB, 0.44497978E-09_JPRB, 0.44237128E-09_JPRB, &
  & 0.44006609E-09_JPRB, 0.43787643E-09_JPRB, 0.43553391E-09_JPRB, 0.43138940E-09_JPRB /)

RGHG6(:,35,12) = (/ &
  & 0.37391620E-09_JPRB, 0.37919959E-09_JPRB, 0.38255704E-09_JPRB, 0.38583728E-09_JPRB, 0.38938275E-09_JPRB, 0.39338183E-09_JPRB, &
  & 0.39773149E-09_JPRB, 0.40226911E-09_JPRB, 0.40684478E-09_JPRB, 0.41145828E-09_JPRB, 0.41621595E-09_JPRB, 0.42131953E-09_JPRB, &
  & 0.42701226E-09_JPRB, 0.43346249E-09_JPRB, 0.44073883E-09_JPRB, 0.44869702E-09_JPRB, 0.45705945E-09_JPRB, 0.46549378E-09_JPRB, &
  & 0.47377280E-09_JPRB, 0.48168153E-09_JPRB, 0.48908505E-09_JPRB, 0.49590260E-09_JPRB, 0.50205928E-09_JPRB, 0.50745558E-09_JPRB, &
  & 0.51206134E-09_JPRB, 0.51590610E-09_JPRB, 0.51907811E-09_JPRB, 0.52162857E-09_JPRB, 0.52354965E-09_JPRB, 0.52483307E-09_JPRB, &
  & 0.52550064E-09_JPRB, 0.52567245E-09_JPRB, 0.52543181E-09_JPRB, 0.52487126E-09_JPRB, 0.52414317E-09_JPRB, 0.52329313E-09_JPRB, &
  & 0.52237503E-09_JPRB, 0.52137494E-09_JPRB, 0.52021792E-09_JPRB, 0.51881222E-09_JPRB, 0.51704674E-09_JPRB, 0.51481303E-09_JPRB, &
  & 0.51206300E-09_JPRB, 0.50878252E-09_JPRB, 0.50503235E-09_JPRB, 0.50092902E-09_JPRB, 0.49659094E-09_JPRB, 0.49221210E-09_JPRB, &
  & 0.48787252E-09_JPRB, 0.48370247E-09_JPRB, 0.47971649E-09_JPRB, 0.47591225E-09_JPRB, 0.47228305E-09_JPRB, 0.46878934E-09_JPRB, &
  & 0.46543414E-09_JPRB, 0.46217652E-09_JPRB, 0.45903778E-09_JPRB, 0.45604992E-09_JPRB, 0.45329260E-09_JPRB, 0.45083176E-09_JPRB, &
  & 0.44862764E-09_JPRB, 0.44659715E-09_JPRB, 0.44435583E-09_JPRB, 0.44053033E-09_JPRB /)

RGHG6(:,36,12) = (/ &
  & 0.39097942E-09_JPRB, 0.39555959E-09_JPRB, 0.39854309E-09_JPRB, 0.40142817E-09_JPRB, 0.40464798E-09_JPRB, 0.40827633E-09_JPRB, &
  & 0.41224474E-09_JPRB, 0.41632398E-09_JPRB, 0.42036299E-09_JPRB, 0.42434187E-09_JPRB, 0.42838449E-09_JPRB, 0.43271745E-09_JPRB, &
  & 0.43763032E-09_JPRB, 0.44337387E-09_JPRB, 0.45008602E-09_JPRB, 0.45762921E-09_JPRB, 0.46571935E-09_JPRB, 0.47395382E-09_JPRB, &
  & 0.48200660E-09_JPRB, 0.48966298E-09_JPRB, 0.49673765E-09_JPRB, 0.50312771E-09_JPRB, 0.50872129E-09_JPRB, 0.51347182E-09_JPRB, &
  & 0.51737742E-09_JPRB, 0.52055432E-09_JPRB, 0.52312221E-09_JPRB, 0.52516680E-09_JPRB, 0.52673271E-09_JPRB, 0.52780796E-09_JPRB, &
  & 0.52842286E-09_JPRB, 0.52866472E-09_JPRB, 0.52856497E-09_JPRB, 0.52820970E-09_JPRB, 0.52768717E-09_JPRB, 0.52702909E-09_JPRB, &
  & 0.52628768E-09_JPRB, 0.52543286E-09_JPRB, 0.52441068E-09_JPRB, 0.52313209E-09_JPRB, 0.52147348E-09_JPRB, 0.51933974E-09_JPRB, &
  & 0.51666915E-09_JPRB, 0.51347265E-09_JPRB, 0.50984356E-09_JPRB, 0.50589238E-09_JPRB, 0.50179716E-09_JPRB, 0.49765370E-09_JPRB, &
  & 0.49360538E-09_JPRB, 0.48968257E-09_JPRB, 0.48590554E-09_JPRB, 0.48228427E-09_JPRB, 0.47880638E-09_JPRB, 0.47548088E-09_JPRB, &
  & 0.47226889E-09_JPRB, 0.46916693E-09_JPRB, 0.46616289E-09_JPRB, 0.46331169E-09_JPRB, 0.46068227E-09_JPRB, 0.45832668E-09_JPRB, &
  & 0.45625095E-09_JPRB, 0.45431001E-09_JPRB, 0.45223547E-09_JPRB, 0.44863255E-09_JPRB /)

RGHG6(:,37,12) = (/ &
  & 0.40693696E-09_JPRB, 0.41086465E-09_JPRB, 0.41340514E-09_JPRB, 0.41595460E-09_JPRB, 0.41881892E-09_JPRB, 0.42211723E-09_JPRB, &
  & 0.42570816E-09_JPRB, 0.42936218E-09_JPRB, 0.43289988E-09_JPRB, 0.43630105E-09_JPRB, 0.43970472E-09_JPRB, 0.44333537E-09_JPRB, &
  & 0.44752008E-09_JPRB, 0.45257739E-09_JPRB, 0.45871573E-09_JPRB, 0.46587240E-09_JPRB, 0.47368037E-09_JPRB, 0.48175935E-09_JPRB, &
  & 0.48967330E-09_JPRB, 0.49711635E-09_JPRB, 0.50387677E-09_JPRB, 0.50977633E-09_JPRB, 0.51472770E-09_JPRB, 0.51872123E-09_JPRB, &
  & 0.52186766E-09_JPRB, 0.52431881E-09_JPRB, 0.52624993E-09_JPRB, 0.52777749E-09_JPRB, 0.52895682E-09_JPRB, 0.52980265E-09_JPRB, &
  & 0.53032539E-09_JPRB, 0.53058369E-09_JPRB, 0.53057375E-09_JPRB, 0.53037641E-09_JPRB, 0.53001831E-09_JPRB, 0.52954430E-09_JPRB, &
  & 0.52897309E-09_JPRB, 0.52828941E-09_JPRB, 0.52745031E-09_JPRB, 0.52636739E-09_JPRB, 0.52493226E-09_JPRB, 0.52301907E-09_JPRB, &
  & 0.52055404E-09_JPRB, 0.51753157E-09_JPRB, 0.51403765E-09_JPRB, 0.51026416E-09_JPRB, 0.50635379E-09_JPRB, 0.50246152E-09_JPRB, &
  & 0.49863974E-09_JPRB, 0.49492821E-09_JPRB, 0.49133730E-09_JPRB, 0.48787097E-09_JPRB, 0.48455240E-09_JPRB, 0.48136456E-09_JPRB, &
  & 0.47831233E-09_JPRB, 0.47536641E-09_JPRB, 0.47252535E-09_JPRB, 0.46981341E-09_JPRB, 0.46730547E-09_JPRB, 0.46506213E-09_JPRB, &
  & 0.46307908E-09_JPRB, 0.46125859E-09_JPRB, 0.45929183E-09_JPRB, 0.45592041E-09_JPRB /)

RGHG6(:,38,12) = (/ &
  & 0.42165976E-09_JPRB, 0.42494386E-09_JPRB, 0.42712062E-09_JPRB, 0.42933407E-09_JPRB, 0.43188361E-09_JPRB, 0.43485801E-09_JPRB, &
  & 0.43809345E-09_JPRB, 0.44134063E-09_JPRB, 0.44441473E-09_JPRB, 0.44731080E-09_JPRB, 0.45014428E-09_JPRB, 0.45318096E-09_JPRB, &
  & 0.45669030E-09_JPRB, 0.46110504E-09_JPRB, 0.46666332E-09_JPRB, 0.47343479E-09_JPRB, 0.48103027E-09_JPRB, 0.48892040E-09_JPRB, &
  & 0.49664356E-09_JPRB, 0.50383148E-09_JPRB, 0.51014265E-09_JPRB, 0.51539900E-09_JPRB, 0.51955096E-09_JPRB, 0.52272919E-09_JPRB, &
  & 0.52511606E-09_JPRB, 0.52693033E-09_JPRB, 0.52833904E-09_JPRB, 0.52945770E-09_JPRB, 0.53034632E-09_JPRB, 0.53100668E-09_JPRB, &
  & 0.53145816E-09_JPRB, 0.53170190E-09_JPRB, 0.53174981E-09_JPRB, 0.53164123E-09_JPRB, 0.53139698E-09_JPRB, 0.53105198E-09_JPRB, &
  & 0.53061316E-09_JPRB, 0.53007576E-09_JPRB, 0.52940374E-09_JPRB, 0.52853050E-09_JPRB, 0.52735183E-09_JPRB, 0.52574495E-09_JPRB, &
  & 0.52359400E-09_JPRB, 0.52085158E-09_JPRB, 0.51760601E-09_JPRB, 0.51402643E-09_JPRB, 0.51033616E-09_JPRB, 0.50664950E-09_JPRB, &
  & 0.50304022E-09_JPRB, 0.49952570E-09_JPRB, 0.49609539E-09_JPRB, 0.49277726E-09_JPRB, 0.48958659E-09_JPRB, 0.48655163E-09_JPRB, &
  & 0.48366927E-09_JPRB, 0.48091686E-09_JPRB, 0.47826254E-09_JPRB, 0.47571708E-09_JPRB, 0.47333792E-09_JPRB, 0.47119897E-09_JPRB, &
  & 0.46931314E-09_JPRB, 0.46758208E-09_JPRB, 0.46573484E-09_JPRB, 0.46255919E-09_JPRB /)

RGHG6(:,39,12) = (/ &
  & 0.43500398E-09_JPRB, 0.43773807E-09_JPRB, 0.43958615E-09_JPRB, 0.44150456E-09_JPRB, 0.44379075E-09_JPRB, 0.44645920E-09_JPRB, &
  & 0.44936310E-09_JPRB, 0.45222362E-09_JPRB, 0.45488799E-09_JPRB, 0.45733106E-09_JPRB, 0.45972018E-09_JPRB, 0.46221993E-09_JPRB, &
  & 0.46520329E-09_JPRB, 0.46896736E-09_JPRB, 0.47399606E-09_JPRB, 0.48029064E-09_JPRB, 0.48760462E-09_JPRB, 0.49530618E-09_JPRB, &
  & 0.50277194E-09_JPRB, 0.50949384E-09_JPRB, 0.51516630E-09_JPRB, 0.51961141E-09_JPRB, 0.52294902E-09_JPRB, 0.52539717E-09_JPRB, &
  & 0.52720578E-09_JPRB, 0.52856647E-09_JPRB, 0.52963040E-09_JPRB, 0.53048976E-09_JPRB, 0.53119059E-09_JPRB, 0.53173649E-09_JPRB, &
  & 0.53213545E-09_JPRB, 0.53236487E-09_JPRB, 0.53244587E-09_JPRB, 0.53238419E-09_JPRB, 0.53221250E-09_JPRB, 0.53194693E-09_JPRB, &
  & 0.53159976E-09_JPRB, 0.53116661E-09_JPRB, 0.53061944E-09_JPRB, 0.52990867E-09_JPRB, 0.52894644E-09_JPRB, 0.52761490E-09_JPRB, &
  & 0.52579902E-09_JPRB, 0.52341659E-09_JPRB, 0.52049320E-09_JPRB, 0.51720755E-09_JPRB, 0.51374049E-09_JPRB, 0.51027454E-09_JPRB, &
  & 0.50686572E-09_JPRB, 0.50351362E-09_JPRB, 0.50023369E-09_JPRB, 0.49704107E-09_JPRB, 0.49398746E-09_JPRB, 0.49112864E-09_JPRB, &
  & 0.48844107E-09_JPRB, 0.48591975E-09_JPRB, 0.48348081E-09_JPRB, 0.48113202E-09_JPRB, 0.47890170E-09_JPRB, 0.47688170E-09_JPRB, &
  & 0.47509041E-09_JPRB, 0.47345539E-09_JPRB, 0.47170473E-09_JPRB, 0.46870718E-09_JPRB /)

RGHG6(:,40,12) = (/ &
  & 0.44684245E-09_JPRB, 0.44914886E-09_JPRB, 0.45072970E-09_JPRB, 0.45243892E-09_JPRB, 0.45447446E-09_JPRB, 0.45690890E-09_JPRB, &
  & 0.45949705E-09_JPRB, 0.46201351E-09_JPRB, 0.46430459E-09_JPRB, 0.46640225E-09_JPRB, 0.46838716E-09_JPRB, 0.47052573E-09_JPRB, &
  & 0.47299942E-09_JPRB, 0.47629184E-09_JPRB, 0.48071686E-09_JPRB, 0.48661336E-09_JPRB, 0.49355342E-09_JPRB, 0.50090598E-09_JPRB, &
  & 0.50793553E-09_JPRB, 0.51404608E-09_JPRB, 0.51890220E-09_JPRB, 0.52255245E-09_JPRB, 0.52519561E-09_JPRB, 0.52711457E-09_JPRB, &
  & 0.52852450E-09_JPRB, 0.52959948E-09_JPRB, 0.53045002E-09_JPRB, 0.53115162E-09_JPRB, 0.53173749E-09_JPRB, 0.53221316E-09_JPRB, &
  & 0.53257176E-09_JPRB, 0.53279486E-09_JPRB, 0.53288784E-09_JPRB, 0.53285698E-09_JPRB, 0.53272697E-09_JPRB, 0.53251242E-09_JPRB, &
  & 0.53222693E-09_JPRB, 0.53186444E-09_JPRB, 0.53140742E-09_JPRB, 0.53081328E-09_JPRB, 0.53001009E-09_JPRB, 0.52890070E-09_JPRB, &
  & 0.52737498E-09_JPRB, 0.52533977E-09_JPRB, 0.52278687E-09_JPRB, 0.51980720E-09_JPRB, 0.51663213E-09_JPRB, 0.51339522E-09_JPRB, &
  & 0.51017834E-09_JPRB, 0.50700005E-09_JPRB, 0.50385207E-09_JPRB, 0.50077742E-09_JPRB, 0.49787541E-09_JPRB, 0.49517429E-09_JPRB, &
  & 0.49272364E-09_JPRB, 0.49042514E-09_JPRB, 0.48824417E-09_JPRB, 0.48611204E-09_JPRB, 0.48407117E-09_JPRB, 0.48219051E-09_JPRB, &
  & 0.48051807E-09_JPRB, 0.47897858E-09_JPRB, 0.47733933E-09_JPRB, 0.47450066E-09_JPRB /)

RGHG6(:,41,12) = (/ &
  & 0.45723061E-09_JPRB, 0.45921134E-09_JPRB, 0.46060830E-09_JPRB, 0.46212731E-09_JPRB, 0.46402485E-09_JPRB, 0.46623438E-09_JPRB, &
  & 0.46856696E-09_JPRB, 0.47077070E-09_JPRB, 0.47276427E-09_JPRB, 0.47454707E-09_JPRB, 0.47627247E-09_JPRB, 0.47805093E-09_JPRB, &
  & 0.48021986E-09_JPRB, 0.48300564E-09_JPRB, 0.48697985E-09_JPRB, 0.49232080E-09_JPRB, 0.49886417E-09_JPRB, 0.50574750E-09_JPRB, &
  & 0.51218801E-09_JPRB, 0.51755394E-09_JPRB, 0.52165594E-09_JPRB, 0.52461463E-09_JPRB, 0.52673393E-09_JPRB, 0.52826882E-09_JPRB, &
  & 0.52941523E-09_JPRB, 0.53030130E-09_JPRB, 0.53101701E-09_JPRB, 0.53161858E-09_JPRB, 0.53212912E-09_JPRB, 0.53256000E-09_JPRB, &
  & 0.53288540E-09_JPRB, 0.53310417E-09_JPRB, 0.53320004E-09_JPRB, 0.53318872E-09_JPRB, 0.53308397E-09_JPRB, 0.53290405E-09_JPRB, &
  & 0.53265981E-09_JPRB, 0.53234894E-09_JPRB, 0.53195665E-09_JPRB, 0.53144888E-09_JPRB, 0.53076726E-09_JPRB, 0.52983062E-09_JPRB, &
  & 0.52854188E-09_JPRB, 0.52680643E-09_JPRB, 0.52458227E-09_JPRB, 0.52195814E-09_JPRB, 0.51906701E-09_JPRB, 0.51608506E-09_JPRB, &
  & 0.51307969E-09_JPRB, 0.51006022E-09_JPRB, 0.50703680E-09_JPRB, 0.50409465E-09_JPRB, 0.50130022E-09_JPRB, 0.49881127E-09_JPRB, &
  & 0.49655635E-09_JPRB, 0.49452625E-09_JPRB, 0.49258803E-09_JPRB, 0.49070831E-09_JPRB, 0.48888110E-09_JPRB, 0.48718596E-09_JPRB, &
  & 0.48566273E-09_JPRB, 0.48425441E-09_JPRB, 0.48273252E-09_JPRB, 0.48009058E-09_JPRB /)

RGHG6(:,42,12) = (/ &
  & 0.46631876E-09_JPRB, 0.46808191E-09_JPRB, 0.46933984E-09_JPRB, 0.47076676E-09_JPRB, 0.47252458E-09_JPRB, 0.47460291E-09_JPRB, &
  & 0.47670440E-09_JPRB, 0.47865512E-09_JPRB, 0.48038701E-09_JPRB, 0.48195026E-09_JPRB, 0.48342225E-09_JPRB, 0.48499504E-09_JPRB, &
  & 0.48681781E-09_JPRB, 0.48929977E-09_JPRB, 0.49275545E-09_JPRB, 0.49765370E-09_JPRB, 0.50368265E-09_JPRB, 0.51001303E-09_JPRB, &
  & 0.51573257E-09_JPRB, 0.52033478E-09_JPRB, 0.52372118E-09_JPRB, 0.52613069E-09_JPRB, 0.52784543E-09_JPRB, 0.52910659E-09_JPRB, &
  & 0.53006427E-09_JPRB, 0.53082250E-09_JPRB, 0.53144611E-09_JPRB, 0.53198002E-09_JPRB, 0.53244070E-09_JPRB, 0.53283555E-09_JPRB, &
  & 0.53313787E-09_JPRB, 0.53334692E-09_JPRB, 0.53344407E-09_JPRB, 0.53344335E-09_JPRB, 0.53335497E-09_JPRB, 0.53319849E-09_JPRB, &
  & 0.53298388E-09_JPRB, 0.53271149E-09_JPRB, 0.53236882E-09_JPRB, 0.53192806E-09_JPRB, 0.53134130E-09_JPRB, 0.53054044E-09_JPRB, &
  & 0.52944193E-09_JPRB, 0.52795934E-09_JPRB, 0.52604771E-09_JPRB, 0.52373339E-09_JPRB, 0.52115368E-09_JPRB, 0.51842919E-09_JPRB, &
  & 0.51564086E-09_JPRB, 0.51279531E-09_JPRB, 0.50991744E-09_JPRB, 0.50706161E-09_JPRB, 0.50443816E-09_JPRB, 0.50209625E-09_JPRB, &
  & 0.50009025E-09_JPRB, 0.49828625E-09_JPRB, 0.49661164E-09_JPRB, 0.49497945E-09_JPRB, 0.49340060E-09_JPRB, 0.49192439E-09_JPRB, &
  & 0.49059201E-09_JPRB, 0.48934679E-09_JPRB, 0.48798787E-09_JPRB, 0.48558607E-09_JPRB /)

RGHG6(:,43,12) = (/ &
  & 0.47434823E-09_JPRB, 0.47597776E-09_JPRB, 0.47715226E-09_JPRB, 0.47849497E-09_JPRB, 0.48020687E-09_JPRB, 0.48215687E-09_JPRB, &
  & 0.48409016E-09_JPRB, 0.48582915E-09_JPRB, 0.48736526E-09_JPRB, 0.48873267E-09_JPRB, 0.49003929E-09_JPRB, 0.49138971E-09_JPRB, &
  & 0.49300991E-09_JPRB, 0.49511240E-09_JPRB, 0.49820120E-09_JPRB, 0.50253096E-09_JPRB, 0.50804677E-09_JPRB, 0.51377652E-09_JPRB, &
  & 0.51875904E-09_JPRB, 0.52259069E-09_JPRB, 0.52534593E-09_JPRB, 0.52729460E-09_JPRB, 0.52869908E-09_JPRB, 0.52975196E-09_JPRB, &
  & 0.53057120E-09_JPRB, 0.53123722E-09_JPRB, 0.53179539E-09_JPRB, 0.53228122E-09_JPRB, 0.53270810E-09_JPRB, 0.53307109E-09_JPRB, &
  & 0.53335630E-09_JPRB, 0.53355170E-09_JPRB, 0.53364863E-09_JPRB, 0.53365257E-09_JPRB, 0.53357541E-09_JPRB, 0.53343491E-09_JPRB, &
  & 0.53324223E-09_JPRB, 0.53299931E-09_JPRB, 0.53269605E-09_JPRB, 0.53230947E-09_JPRB, 0.53180049E-09_JPRB, 0.53111260E-09_JPRB, &
  & 0.53017629E-09_JPRB, 0.52891314E-09_JPRB, 0.52726634E-09_JPRB, 0.52524934E-09_JPRB, 0.52294985E-09_JPRB, 0.52049315E-09_JPRB, &
  & 0.51793453E-09_JPRB, 0.51528254E-09_JPRB, 0.51254045E-09_JPRB, 0.50984550E-09_JPRB, 0.50734689E-09_JPRB, 0.50521531E-09_JPRB, &
  & 0.50341442E-09_JPRB, 0.50185095E-09_JPRB, 0.50041099E-09_JPRB, 0.49902976E-09_JPRB, 0.49770121E-09_JPRB, 0.49646715E-09_JPRB, &
  & 0.49535465E-09_JPRB, 0.49430604E-09_JPRB, 0.49314341E-09_JPRB, 0.49106053E-09_JPRB /)

RGHG6(:,44,12) = (/ &
  & 0.48157722E-09_JPRB, 0.48311144E-09_JPRB, 0.48424081E-09_JPRB, 0.48554638E-09_JPRB, 0.48720433E-09_JPRB, 0.48908327E-09_JPRB, &
  & 0.49087551E-09_JPRB, 0.49246246E-09_JPRB, 0.49383941E-09_JPRB, 0.49506466E-09_JPRB, 0.49621407E-09_JPRB, 0.49741061E-09_JPRB, &
  & 0.49879212E-09_JPRB, 0.50064164E-09_JPRB, 0.50327148E-09_JPRB, 0.50715693E-09_JPRB, 0.51204874E-09_JPRB, 0.51707333E-09_JPRB, &
  & 0.52130483E-09_JPRB, 0.52443405E-09_JPRB, 0.52664700E-09_JPRB, 0.52822063E-09_JPRB, 0.52938032E-09_JPRB, 0.53027127E-09_JPRB, &
  & 0.53098603E-09_JPRB, 0.53158233E-09_JPRB, 0.53209542E-09_JPRB, 0.53254445E-09_JPRB, 0.53294791E-09_JPRB, 0.53328425E-09_JPRB, &
  & 0.53355220E-09_JPRB, 0.53373428E-09_JPRB, 0.53382759E-09_JPRB, 0.53383331E-09_JPRB, 0.53376303E-09_JPRB, 0.53363358E-09_JPRB, &
  & 0.53345728E-09_JPRB, 0.53323729E-09_JPRB, 0.53296584E-09_JPRB, 0.53262456E-09_JPRB, 0.53218091E-09_JPRB, 0.53158972E-09_JPRB, &
  & 0.53079163E-09_JPRB, 0.52971832E-09_JPRB, 0.52831128E-09_JPRB, 0.52656018E-09_JPRB, 0.52453569E-09_JPRB, 0.52233240E-09_JPRB, &
  & 0.52000715E-09_JPRB, 0.51755850E-09_JPRB, 0.51501381E-09_JPRB, 0.51247390E-09_JPRB, 0.51017052E-09_JPRB, 0.50824572E-09_JPRB, &
  & 0.50665738E-09_JPRB, 0.50531407E-09_JPRB, 0.50409332E-09_JPRB, 0.50294208E-09_JPRB, 0.50185356E-09_JPRB, 0.50085852E-09_JPRB, &
  & 0.49996862E-09_JPRB, 0.49912707E-09_JPRB, 0.49818477E-09_JPRB, 0.49647225E-09_JPRB /)

RGHG6(:,45,12) = (/ &
  & 0.48817728E-09_JPRB, 0.48968885E-09_JPRB, 0.49077148E-09_JPRB, 0.49205529E-09_JPRB, 0.49367599E-09_JPRB, 0.49549093E-09_JPRB, &
  & 0.49718618E-09_JPRB, 0.49866078E-09_JPRB, 0.49992405E-09_JPRB, 0.50102983E-09_JPRB, 0.50205140E-09_JPRB, 0.50309107E-09_JPRB, &
  & 0.50428051E-09_JPRB, 0.50583637E-09_JPRB, 0.50809584E-09_JPRB, 0.51142574E-09_JPRB, 0.51571364E-09_JPRB, 0.52000482E-09_JPRB, &
  & 0.52344462E-09_JPRB, 0.52594162E-09_JPRB, 0.52769872E-09_JPRB, 0.52897287E-09_JPRB, 0.52993471E-09_JPRB, 0.53070282E-09_JPRB, &
  & 0.53133464E-09_JPRB, 0.53188026E-09_JPRB, 0.53235860E-09_JPRB, 0.53278448E-09_JPRB, 0.53316657E-09_JPRB, 0.53348215E-09_JPRB, &
  & 0.53373211E-09_JPRB, 0.53390092E-09_JPRB, 0.53398824E-09_JPRB, 0.53399352E-09_JPRB, 0.53392696E-09_JPRB, 0.53380478E-09_JPRB, &
  & 0.53364047E-09_JPRB, 0.53343835E-09_JPRB, 0.53319282E-09_JPRB, 0.53288901E-09_JPRB, 0.53250138E-09_JPRB, 0.53199223E-09_JPRB, &
  & 0.53131566E-09_JPRB, 0.53041233E-09_JPRB, 0.52922539E-09_JPRB, 0.52772842E-09_JPRB, 0.52595689E-09_JPRB, 0.52399807E-09_JPRB, &
  & 0.52190502E-09_JPRB, 0.51968141E-09_JPRB, 0.51733606E-09_JPRB, 0.51502924E-09_JPRB, 0.51295079E-09_JPRB, 0.51124810E-09_JPRB, &
  & 0.50988436E-09_JPRB, 0.50873494E-09_JPRB, 0.50771776E-09_JPRB, 0.50676846E-09_JPRB, 0.50589333E-09_JPRB, 0.50511201E-09_JPRB, &
  & 0.50442239E-09_JPRB, 0.50377330E-09_JPRB, 0.50304083E-09_JPRB, 0.50170029E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART23',1,ZHOOK_HANDLE)
END SUBROUTINE PART23




SUBROUTINE PART24
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART24',0,ZHOOK_HANDLE)



RGHG6(:,46,12) = (/ &
  & 0.49432419E-09_JPRB, 0.49579191E-09_JPRB, 0.49687371E-09_JPRB, 0.49811577E-09_JPRB, 0.49971255E-09_JPRB, 0.50146048E-09_JPRB, &
  & 0.50309429E-09_JPRB, 0.50448490E-09_JPRB, 0.50566362E-09_JPRB, 0.50666094E-09_JPRB, 0.50756704E-09_JPRB, 0.50845100E-09_JPRB, &
  & 0.50946264E-09_JPRB, 0.51073445E-09_JPRB, 0.51264104E-09_JPRB, 0.51541488E-09_JPRB, 0.51903204E-09_JPRB, 0.52250737E-09_JPRB, &
  & 0.52523447E-09_JPRB, 0.52716692E-09_JPRB, 0.52855431E-09_JPRB, 0.52958687E-09_JPRB, 0.53039867E-09_JPRB, 0.53106464E-09_JPRB, &
  & 0.53163796E-09_JPRB, 0.53214128E-09_JPRB, 0.53259935E-09_JPRB, 0.53300353E-09_JPRB, 0.53337196E-09_JPRB, 0.53366694E-09_JPRB, &
  & 0.53389942E-09_JPRB, 0.53405508E-09_JPRB, 0.53413463E-09_JPRB, 0.53413773E-09_JPRB, 0.53407245E-09_JPRB, 0.53395477E-09_JPRB, &
  & 0.53379906E-09_JPRB, 0.53361049E-09_JPRB, 0.53338584E-09_JPRB, 0.53311339E-09_JPRB, 0.53277227E-09_JPRB, 0.53233484E-09_JPRB, &
  & 0.53176319E-09_JPRB, 0.53101257E-09_JPRB, 0.53003141E-09_JPRB, 0.52877674E-09_JPRB, 0.52726179E-09_JPRB, 0.52554644E-09_JPRB, &
  & 0.52368249E-09_JPRB, 0.52167920E-09_JPRB, 0.51959231E-09_JPRB, 0.51750648E-09_JPRB, 0.51571170E-09_JPRB, 0.51424259E-09_JPRB, &
  & 0.51308785E-09_JPRB, 0.51213178E-09_JPRB, 0.51128507E-09_JPRB, 0.51051618E-09_JPRB, 0.50981835E-09_JPRB, 0.50921239E-09_JPRB, &
  & 0.50868643E-09_JPRB, 0.50819504E-09_JPRB, 0.50763771E-09_JPRB, 0.50662091E-09_JPRB /)

RGHG6(:,47,12) = (/ &
  & 0.50005150E-09_JPRB, 0.50152649E-09_JPRB, 0.50257393E-09_JPRB, 0.50380455E-09_JPRB, 0.50533988E-09_JPRB, 0.50705024E-09_JPRB, &
  & 0.50861226E-09_JPRB, 0.50995758E-09_JPRB, 0.51104077E-09_JPRB, 0.51194532E-09_JPRB, 0.51271676E-09_JPRB, 0.51347326E-09_JPRB, &
  & 0.51427451E-09_JPRB, 0.51534410E-09_JPRB, 0.51681387E-09_JPRB, 0.51910420E-09_JPRB, 0.52192384E-09_JPRB, 0.52463511E-09_JPRB, &
  & 0.52668281E-09_JPRB, 0.52816224E-09_JPRB, 0.52924920E-09_JPRB, 0.53009575E-09_JPRB, 0.53078630E-09_JPRB, 0.53137833E-09_JPRB, &
  & 0.53190319E-09_JPRB, 0.53237936E-09_JPRB, 0.53281851E-09_JPRB, 0.53321264E-09_JPRB, 0.53356147E-09_JPRB, 0.53384203E-09_JPRB, &
  & 0.53405530E-09_JPRB, 0.53419807E-09_JPRB, 0.53426930E-09_JPRB, 0.53426852E-09_JPRB, 0.53420257E-09_JPRB, 0.53408744E-09_JPRB, &
  & 0.53393739E-09_JPRB, 0.53375943E-09_JPRB, 0.53355137E-09_JPRB, 0.53330429E-09_JPRB, 0.53300270E-09_JPRB, 0.53262422E-09_JPRB, &
  & 0.53214411E-09_JPRB, 0.53152860E-09_JPRB, 0.53073623E-09_JPRB, 0.52972726E-09_JPRB, 0.52847476E-09_JPRB, 0.52701371E-09_JPRB, &
  & 0.52539095E-09_JPRB, 0.52363530E-09_JPRB, 0.52176202E-09_JPRB, 0.51999521E-09_JPRB, 0.51842020E-09_JPRB, 0.51721616E-09_JPRB, &
  & 0.51625154E-09_JPRB, 0.51546245E-09_JPRB, 0.51477406E-09_JPRB, 0.51414756E-09_JPRB, 0.51359617E-09_JPRB, 0.51312454E-09_JPRB, &
  & 0.51272453E-09_JPRB, 0.51235116E-09_JPRB, 0.51193194E-09_JPRB, 0.51115701E-09_JPRB /)

RGHG6(:,48,12) = (/ &
  & 0.50540738E-09_JPRB, 0.50686988E-09_JPRB, 0.50791121E-09_JPRB, 0.50910481E-09_JPRB, 0.51060661E-09_JPRB, 0.51224947E-09_JPRB, &
  & 0.51378868E-09_JPRB, 0.51505011E-09_JPRB, 0.51606164E-09_JPRB, 0.51683952E-09_JPRB, 0.51749804E-09_JPRB, 0.51809357E-09_JPRB, &
  & 0.51875026E-09_JPRB, 0.51953830E-09_JPRB, 0.52070226E-09_JPRB, 0.52233939E-09_JPRB, 0.52443028E-09_JPRB, 0.52636356E-09_JPRB, &
  & 0.52785820E-09_JPRB, 0.52896160E-09_JPRB, 0.52981841E-09_JPRB, 0.53051707E-09_JPRB, 0.53111815E-09_JPRB, 0.53165117E-09_JPRB, &
  & 0.53214305E-09_JPRB, 0.53259830E-09_JPRB, 0.53302657E-09_JPRB, 0.53340676E-09_JPRB, 0.53374288E-09_JPRB, 0.53400462E-09_JPRB, &
  & 0.53420157E-09_JPRB, 0.53433108E-09_JPRB, 0.53439325E-09_JPRB, 0.53438748E-09_JPRB, 0.53431987E-09_JPRB, 0.53420546E-09_JPRB, &
  & 0.53405957E-09_JPRB, 0.53388927E-09_JPRB, 0.53369420E-09_JPRB, 0.53346794E-09_JPRB, 0.53319787E-09_JPRB, 0.53286953E-09_JPRB, &
  & 0.53246546E-09_JPRB, 0.53196569E-09_JPRB, 0.53134736E-09_JPRB, 0.53056820E-09_JPRB, 0.52959892E-09_JPRB, 0.52842342E-09_JPRB, &
  & 0.52706733E-09_JPRB, 0.52555638E-09_JPRB, 0.52397786E-09_JPRB, 0.52242438E-09_JPRB, 0.52115923E-09_JPRB, 0.52014293E-09_JPRB, &
  & 0.51936649E-09_JPRB, 0.51872112E-09_JPRB, 0.51815641E-09_JPRB, 0.51765103E-09_JPRB, 0.51720661E-09_JPRB, 0.51683713E-09_JPRB, &
  & 0.51652521E-09_JPRB, 0.51623883E-09_JPRB, 0.51591331E-09_JPRB, 0.51532018E-09_JPRB /)

RGHG6(:,49,12) = (/ &
  & 0.51038074E-09_JPRB, 0.51181781E-09_JPRB, 0.51285209E-09_JPRB, 0.51401711E-09_JPRB, 0.51547849E-09_JPRB, 0.51709043E-09_JPRB, &
  & 0.51857035E-09_JPRB, 0.51977767E-09_JPRB, 0.52065968E-09_JPRB, 0.52131982E-09_JPRB, 0.52183358E-09_JPRB, 0.52229310E-09_JPRB, &
  & 0.52276128E-09_JPRB, 0.52331883E-09_JPRB, 0.52407845E-09_JPRB, 0.52513438E-09_JPRB, 0.52646687E-09_JPRB, 0.52775467E-09_JPRB, &
  & 0.52879084E-09_JPRB, 0.52961058E-09_JPRB, 0.53028509E-09_JPRB, 0.53087240E-09_JPRB, 0.53140337E-09_JPRB, 0.53189569E-09_JPRB, &
  & 0.53236304E-09_JPRB, 0.53280530E-09_JPRB, 0.53322335E-09_JPRB, 0.53359328E-09_JPRB, 0.53391058E-09_JPRB, 0.53415772E-09_JPRB, &
  & 0.53433791E-09_JPRB, 0.53445481E-09_JPRB, 0.53450810E-09_JPRB, 0.53449639E-09_JPRB, 0.53442584E-09_JPRB, 0.53431148E-09_JPRB, &
  & 0.53416810E-09_JPRB, 0.53400367E-09_JPRB, 0.53381882E-09_JPRB, 0.53360877E-09_JPRB, 0.53336457E-09_JPRB, 0.53307592E-09_JPRB, &
  & 0.53273463E-09_JPRB, 0.53233318E-09_JPRB, 0.53186017E-09_JPRB, 0.53129745E-09_JPRB, 0.53060328E-09_JPRB, 0.52974403E-09_JPRB, &
  & 0.52869986E-09_JPRB, 0.52748789E-09_JPRB, 0.52617566E-09_JPRB, 0.52493698E-09_JPRB, 0.52388993E-09_JPRB, 0.52308957E-09_JPRB, &
  & 0.52245647E-09_JPRB, 0.52193272E-09_JPRB, 0.52146842E-09_JPRB, 0.52105043E-09_JPRB, 0.52068749E-09_JPRB, 0.52038607E-09_JPRB, &
  & 0.52013654E-09_JPRB, 0.51990617E-09_JPRB, 0.51964633E-09_JPRB, 0.51916843E-09_JPRB /)

RGHG6(:,50,12) = (/ &
  & 0.51489152E-09_JPRB, 0.51635102E-09_JPRB, 0.51733023E-09_JPRB, 0.51849408E-09_JPRB, 0.51990906E-09_JPRB, 0.52149784E-09_JPRB, &
  & 0.52291443E-09_JPRB, 0.52398524E-09_JPRB, 0.52471127E-09_JPRB, 0.52519661E-09_JPRB, 0.52555249E-09_JPRB, 0.52584842E-09_JPRB, &
  & 0.52611981E-09_JPRB, 0.52643895E-09_JPRB, 0.52680676E-09_JPRB, 0.52736127E-09_JPRB, 0.52806931E-09_JPRB, 0.52884569E-09_JPRB, &
  & 0.52953830E-09_JPRB, 0.53013699E-09_JPRB, 0.53067672E-09_JPRB, 0.53117660E-09_JPRB, 0.53165455E-09_JPRB, 0.53211874E-09_JPRB, &
  & 0.53256938E-09_JPRB, 0.53300370E-09_JPRB, 0.53341070E-09_JPRB, 0.53376825E-09_JPRB, 0.53406840E-09_JPRB, 0.53429944E-09_JPRB, &
  & 0.53446536E-09_JPRB, 0.53457022E-09_JPRB, 0.53461413E-09_JPRB, 0.53459609E-09_JPRB, 0.53452254E-09_JPRB, 0.53440730E-09_JPRB, &
  & 0.53426563E-09_JPRB, 0.53410570E-09_JPRB, 0.53392879E-09_JPRB, 0.53373173E-09_JPRB, 0.53350752E-09_JPRB, 0.53325083E-09_JPRB, &
  & 0.53296018E-09_JPRB, 0.53263749E-09_JPRB, 0.53228755E-09_JPRB, 0.53190208E-09_JPRB, 0.53145593E-09_JPRB, 0.53090299E-09_JPRB, &
  & 0.53020144E-09_JPRB, 0.52934235E-09_JPRB, 0.52837851E-09_JPRB, 0.52745597E-09_JPRB, 0.52667182E-09_JPRB, 0.52606031E-09_JPRB, &
  & 0.52556576E-09_JPRB, 0.52514182E-09_JPRB, 0.52476401E-09_JPRB, 0.52441240E-09_JPRB, 0.52410709E-09_JPRB, 0.52385329E-09_JPRB, &
  & 0.52364191E-09_JPRB, 0.52344573E-09_JPRB, 0.52322191E-09_JPRB, 0.52280758E-09_JPRB /)

RGHG6(:,51,12) = (/ &
  & 0.51897941E-09_JPRB, 0.52029930E-09_JPRB, 0.52132804E-09_JPRB, 0.52239896E-09_JPRB, 0.52381827E-09_JPRB, 0.52529220E-09_JPRB, &
  & 0.52656390E-09_JPRB, 0.52738092E-09_JPRB, 0.52785987E-09_JPRB, 0.52814425E-09_JPRB, 0.52832966E-09_JPRB, 0.52846094E-09_JPRB, &
  & 0.52857713E-09_JPRB, 0.52867510E-09_JPRB, 0.52880844E-09_JPRB, 0.52897736E-09_JPRB, 0.52928739E-09_JPRB, 0.52969668E-09_JPRB, &
  & 0.53013849E-09_JPRB, 0.53057791E-09_JPRB, 0.53101001E-09_JPRB, 0.53144394E-09_JPRB, 0.53188387E-09_JPRB, 0.53232513E-09_JPRB, &
  & 0.53276705E-09_JPRB, 0.53319194E-09_JPRB, 0.53358967E-09_JPRB, 0.53393134E-09_JPRB, 0.53421506E-09_JPRB, 0.53443122E-09_JPRB, &
  & 0.53458377E-09_JPRB, 0.53467741E-09_JPRB, 0.53471239E-09_JPRB, 0.53468779E-09_JPRB, 0.53461091E-09_JPRB, 0.53449467E-09_JPRB, &
  & 0.53435423E-09_JPRB, 0.53419774E-09_JPRB, 0.53402716E-09_JPRB, 0.53383997E-09_JPRB, 0.53363175E-09_JPRB, 0.53340021E-09_JPRB, &
  & 0.53315019E-09_JPRB, 0.53289206E-09_JPRB, 0.53263927E-09_JPRB, 0.53239357E-09_JPRB, 0.53213817E-09_JPRB, 0.53183558E-09_JPRB, &
  & 0.53144533E-09_JPRB, 0.53094834E-09_JPRB, 0.53038196E-09_JPRB, 0.52980831E-09_JPRB, 0.52931937E-09_JPRB, 0.52890370E-09_JPRB, &
  & 0.52855614E-09_JPRB, 0.52824733E-09_JPRB, 0.52794885E-09_JPRB, 0.52767396E-09_JPRB, 0.52742094E-09_JPRB, 0.52720828E-09_JPRB, &
  & 0.52702814E-09_JPRB, 0.52685678E-09_JPRB, 0.52665339E-09_JPRB, 0.52627713E-09_JPRB /)

RGHG6(:,52,12) = (/ &
  & 0.52239024E-09_JPRB, 0.52377835E-09_JPRB, 0.52461868E-09_JPRB, 0.52572663E-09_JPRB, 0.52694193E-09_JPRB, 0.52825400E-09_JPRB, &
  & 0.52914439E-09_JPRB, 0.52964616E-09_JPRB, 0.52988752E-09_JPRB, 0.53001059E-09_JPRB, 0.53007609E-09_JPRB, 0.53011362E-09_JPRB, &
  & 0.53012983E-09_JPRB, 0.53013299E-09_JPRB, 0.53012400E-09_JPRB, 0.53012339E-09_JPRB, 0.53018556E-09_JPRB, 0.53036509E-09_JPRB, &
  & 0.53063243E-09_JPRB, 0.53095028E-09_JPRB, 0.53130489E-09_JPRB, 0.53168764E-09_JPRB, 0.53209481E-09_JPRB, 0.53252402E-09_JPRB, &
  & 0.53295396E-09_JPRB, 0.53337279E-09_JPRB, 0.53375515E-09_JPRB, 0.53408400E-09_JPRB, 0.53435051E-09_JPRB, 0.53455379E-09_JPRB, &
  & 0.53469429E-09_JPRB, 0.53477744E-09_JPRB, 0.53480365E-09_JPRB, 0.53477256E-09_JPRB, 0.53469212E-09_JPRB, 0.53457488E-09_JPRB, &
  & 0.53443544E-09_JPRB, 0.53428184E-09_JPRB, 0.53411631E-09_JPRB, 0.53393717E-09_JPRB, 0.53374133E-09_JPRB, 0.53353044E-09_JPRB, &
  & 0.53331339E-09_JPRB, 0.53310845E-09_JPRB, 0.53293131E-09_JPRB, 0.53278915E-09_JPRB, 0.53266414E-09_JPRB, 0.53252913E-09_JPRB, &
  & 0.53235505E-09_JPRB, 0.53213023E-09_JPRB, 0.53186389E-09_JPRB, 0.53159688E-09_JPRB, 0.53134358E-09_JPRB, 0.53112503E-09_JPRB, &
  & 0.53092475E-09_JPRB, 0.53073113E-09_JPRB, 0.53054533E-09_JPRB, 0.53035165E-09_JPRB, 0.53017563E-09_JPRB, 0.53002192E-09_JPRB, &
  & 0.52988874E-09_JPRB, 0.52975851E-09_JPRB, 0.52960020E-09_JPRB, 0.52928389E-09_JPRB /)

RGHG6(:,53,12) = (/ &
  & 0.52534554E-09_JPRB, 0.52643367E-09_JPRB, 0.52737070E-09_JPRB, 0.52819960E-09_JPRB, 0.52929072E-09_JPRB, 0.53016047E-09_JPRB, &
  & 0.53071258E-09_JPRB, 0.53094840E-09_JPRB, 0.53104898E-09_JPRB, 0.53108934E-09_JPRB, 0.53110272E-09_JPRB, 0.53110005E-09_JPRB, &
  & 0.53108251E-09_JPRB, 0.53105281E-09_JPRB, 0.53099203E-09_JPRB, 0.53092342E-09_JPRB, 0.53086580E-09_JPRB, 0.53090049E-09_JPRB, &
  & 0.53104576E-09_JPRB, 0.53127736E-09_JPRB, 0.53157068E-09_JPRB, 0.53191407E-09_JPRB, 0.53230031E-09_JPRB, 0.53271143E-09_JPRB, &
  & 0.53313531E-09_JPRB, 0.53354005E-09_JPRB, 0.53391130E-09_JPRB, 0.53422411E-09_JPRB, 0.53447707E-09_JPRB, 0.53466753E-09_JPRB, &
  & 0.53479704E-09_JPRB, 0.53487031E-09_JPRB, 0.53488836E-09_JPRB, 0.53485116E-09_JPRB, 0.53476729E-09_JPRB, 0.53464894E-09_JPRB, &
  & 0.53451032E-09_JPRB, 0.53435945E-09_JPRB, 0.53419841E-09_JPRB, 0.53402588E-09_JPRB, 0.53384114E-09_JPRB, 0.53364679E-09_JPRB, &
  & 0.53345861E-09_JPRB, 0.53329563E-09_JPRB, 0.53317900E-09_JPRB, 0.53310728E-09_JPRB, 0.53306504E-09_JPRB, 0.53302585E-09_JPRB, &
  & 0.53296911E-09_JPRB, 0.53288579E-09_JPRB, 0.53278143E-09_JPRB, 0.53266591E-09_JPRB, 0.53255600E-09_JPRB, 0.53244997E-09_JPRB, &
  & 0.53234883E-09_JPRB, 0.53224908E-09_JPRB, 0.53214028E-09_JPRB, 0.53203331E-09_JPRB, 0.53192806E-09_JPRB, 0.53183757E-09_JPRB, &
  & 0.53176141E-09_JPRB, 0.53168858E-09_JPRB, 0.53160076E-09_JPRB, 0.53141180E-09_JPRB /)

RGHG6(:,54,12) = (/ &
  & 0.52754562E-09_JPRB, 0.52868543E-09_JPRB, 0.52929150E-09_JPRB, 0.53008037E-09_JPRB, 0.53076388E-09_JPRB, 0.53133570E-09_JPRB, &
  & 0.53159860E-09_JPRB, 0.53170190E-09_JPRB, 0.53173471E-09_JPRB, 0.53174148E-09_JPRB, 0.53173599E-09_JPRB, 0.53172156E-09_JPRB, &
  & 0.53169924E-09_JPRB, 0.53165761E-09_JPRB, 0.53160298E-09_JPRB, 0.53149984E-09_JPRB, 0.53139670E-09_JPRB, 0.53134341E-09_JPRB, &
  & 0.53140370E-09_JPRB, 0.53156929E-09_JPRB, 0.53181798E-09_JPRB, 0.53213134E-09_JPRB, 0.53249521E-09_JPRB, 0.53289584E-09_JPRB, &
  & 0.53330385E-09_JPRB, 0.53369931E-09_JPRB, 0.53405458E-09_JPRB, 0.53435556E-09_JPRB, 0.53459476E-09_JPRB, 0.53477361E-09_JPRB, &
  & 0.53489274E-09_JPRB, 0.53495697E-09_JPRB, 0.53496718E-09_JPRB, 0.53492449E-09_JPRB, 0.53483751E-09_JPRB, 0.53471783E-09_JPRB, &
  & 0.53458038E-09_JPRB, 0.53443183E-09_JPRB, 0.53427501E-09_JPRB, 0.53410903E-09_JPRB, 0.53393334E-09_JPRB, 0.53375521E-09_JPRB, &
  & 0.53358984E-09_JPRB, 0.53346411E-09_JPRB, 0.53339078E-09_JPRB, 0.53336813E-09_JPRB, 0.53337373E-09_JPRB, 0.53338428E-09_JPRB, &
  & 0.53338278E-09_JPRB, 0.53336235E-09_JPRB, 0.53332416E-09_JPRB, 0.53327698E-09_JPRB, 0.53322541E-09_JPRB, 0.53317462E-09_JPRB, &
  & 0.53312327E-09_JPRB, 0.53306826E-09_JPRB, 0.53301141E-09_JPRB, 0.53294869E-09_JPRB, 0.53289068E-09_JPRB, 0.53284310E-09_JPRB, &
  & 0.53280613E-09_JPRB, 0.53277838E-09_JPRB, 0.53275750E-09_JPRB, 0.53274718E-09_JPRB /)

RGHG6(:,55,12) = (/ &
  & 0.52936028E-09_JPRB, 0.53017329E-09_JPRB, 0.53079358E-09_JPRB, 0.53125310E-09_JPRB, 0.53173482E-09_JPRB, 0.53202226E-09_JPRB, &
  & 0.53214816E-09_JPRB, 0.53218169E-09_JPRB, 0.53218591E-09_JPRB, 0.53217986E-09_JPRB, 0.53216886E-09_JPRB, 0.53215360E-09_JPRB, &
  & 0.53213045E-09_JPRB, 0.53209953E-09_JPRB, 0.53203880E-09_JPRB, 0.53195681E-09_JPRB, 0.53182436E-09_JPRB, 0.53172156E-09_JPRB, &
  & 0.53172133E-09_JPRB, 0.53183885E-09_JPRB, 0.53205162E-09_JPRB, 0.53234028E-09_JPRB, 0.53268662E-09_JPRB, 0.53306970E-09_JPRB, &
  & 0.53346655E-09_JPRB, 0.53384641E-09_JPRB, 0.53419069E-09_JPRB, 0.53447863E-09_JPRB, 0.53470572E-09_JPRB, 0.53487320E-09_JPRB, &
  & 0.53498245E-09_JPRB, 0.53503801E-09_JPRB, 0.53504096E-09_JPRB, 0.53499344E-09_JPRB, 0.53490373E-09_JPRB, 0.53478344E-09_JPRB, &
  & 0.53464638E-09_JPRB, 0.53450072E-09_JPRB, 0.53434762E-09_JPRB, 0.53418781E-09_JPRB, 0.53402194E-09_JPRB, 0.53385718E-09_JPRB, &
  & 0.53371485E-09_JPRB, 0.53361626E-09_JPRB, 0.53357707E-09_JPRB, 0.53358606E-09_JPRB, 0.53361920E-09_JPRB, 0.53365473E-09_JPRB, &
  & 0.53367760E-09_JPRB, 0.53368310E-09_JPRB, 0.53367294E-09_JPRB, 0.53365246E-09_JPRB, 0.53362792E-09_JPRB, 0.53360122E-09_JPRB, &
  & 0.53357274E-09_JPRB, 0.53354221E-09_JPRB, 0.53350668E-09_JPRB, 0.53346971E-09_JPRB, 0.53343285E-09_JPRB, 0.53340105E-09_JPRB, &
  & 0.53337590E-09_JPRB, 0.53335342E-09_JPRB, 0.53333005E-09_JPRB, 0.53329163E-09_JPRB /)

RGHG6(:,56,12) = (/ &
  & 0.53063598E-09_JPRB, 0.53136662E-09_JPRB, 0.53172811E-09_JPRB, 0.53207416E-09_JPRB, 0.53232996E-09_JPRB, 0.53248184E-09_JPRB, &
  & 0.53252469E-09_JPRB, 0.53252774E-09_JPRB, 0.53251992E-09_JPRB, 0.53250970E-09_JPRB, 0.53249799E-09_JPRB, 0.53248372E-09_JPRB, &
  & 0.53246585E-09_JPRB, 0.53243621E-09_JPRB, 0.53239491E-09_JPRB, 0.53230925E-09_JPRB, 0.53218990E-09_JPRB, 0.53205557E-09_JPRB, &
  & 0.53201210E-09_JPRB, 0.53209220E-09_JPRB, 0.53227756E-09_JPRB, 0.53254334E-09_JPRB, 0.53287186E-09_JPRB, 0.53323906E-09_JPRB, &
  & 0.53361965E-09_JPRB, 0.53398819E-09_JPRB, 0.53431903E-09_JPRB, 0.53459526E-09_JPRB, 0.53481070E-09_JPRB, 0.53496685E-09_JPRB, &
  & 0.53506666E-09_JPRB, 0.53511440E-09_JPRB, 0.53511107E-09_JPRB, 0.53505944E-09_JPRB, 0.53496757E-09_JPRB, 0.53484672E-09_JPRB, &
  & 0.53471100E-09_JPRB, 0.53456717E-09_JPRB, 0.53441868E-09_JPRB, 0.53426474E-09_JPRB, 0.53410815E-09_JPRB, 0.53395810E-09_JPRB, &
  & 0.53383320E-09_JPRB, 0.53375881E-09_JPRB, 0.53374305E-09_JPRB, 0.53377247E-09_JPRB, 0.53382282E-09_JPRB, 0.53387017E-09_JPRB, &
  & 0.53390359E-09_JPRB, 0.53391891E-09_JPRB, 0.53391958E-09_JPRB, 0.53391114E-09_JPRB, 0.53389804E-09_JPRB, 0.53388277E-09_JPRB, &
  & 0.53386584E-09_JPRB, 0.53384624E-09_JPRB, 0.53382443E-09_JPRB, 0.53379923E-09_JPRB, 0.53377436E-09_JPRB, 0.53375315E-09_JPRB, &
  & 0.53373517E-09_JPRB, 0.53371985E-09_JPRB, 0.53370441E-09_JPRB, 0.53368160E-09_JPRB /)

RGHG6(:,57,12) = (/ &
  & 0.53160532E-09_JPRB, 0.53213206E-09_JPRB, 0.53240790E-09_JPRB, 0.53260357E-09_JPRB, 0.53274607E-09_JPRB, 0.53280796E-09_JPRB, &
  & 0.53281340E-09_JPRB, 0.53280269E-09_JPRB, 0.53279059E-09_JPRB, 0.53277954E-09_JPRB, 0.53276883E-09_JPRB, 0.53275695E-09_JPRB, &
  & 0.53274130E-09_JPRB, 0.53272026E-09_JPRB, 0.53268034E-09_JPRB, 0.53261873E-09_JPRB, 0.53249727E-09_JPRB, 0.53235488E-09_JPRB, &
  & 0.53228316E-09_JPRB, 0.53233590E-09_JPRB, 0.53249688E-09_JPRB, 0.53274357E-09_JPRB, 0.53305249E-09_JPRB, 0.53340338E-09_JPRB, &
  & 0.53376920E-09_JPRB, 0.53412347E-09_JPRB, 0.53444182E-09_JPRB, 0.53470650E-09_JPRB, 0.53491001E-09_JPRB, 0.53505556E-09_JPRB, &
  & 0.53514654E-09_JPRB, 0.53518695E-09_JPRB, 0.53517835E-09_JPRB, 0.53512345E-09_JPRB, 0.53502991E-09_JPRB, 0.53490962E-09_JPRB, &
  & 0.53477478E-09_JPRB, 0.53463395E-09_JPRB, 0.53448884E-09_JPRB, 0.53434168E-09_JPRB, 0.53419430E-09_JPRB, 0.53405669E-09_JPRB, &
  & 0.53394955E-09_JPRB, 0.53389204E-09_JPRB, 0.53389348E-09_JPRB, 0.53393812E-09_JPRB, 0.53399718E-09_JPRB, 0.53405147E-09_JPRB, &
  & 0.53408800E-09_JPRB, 0.53410659E-09_JPRB, 0.53411087E-09_JPRB, 0.53410698E-09_JPRB, 0.53409921E-09_JPRB, 0.53408955E-09_JPRB, &
  & 0.53407817E-09_JPRB, 0.53406524E-09_JPRB, 0.53404942E-09_JPRB, 0.53403210E-09_JPRB, 0.53401411E-09_JPRB, 0.53399751E-09_JPRB, &
  & 0.53398380E-09_JPRB, 0.53397098E-09_JPRB, 0.53395688E-09_JPRB, 0.53393256E-09_JPRB /)

RGHG6(:,58,12) = (/ &
  & 0.53231303E-09_JPRB, 0.53269422E-09_JPRB, 0.53287053E-09_JPRB, 0.53298244E-09_JPRB, 0.53305332E-09_JPRB, 0.53306903E-09_JPRB, &
  & 0.53305582E-09_JPRB, 0.53303889E-09_JPRB, 0.53302585E-09_JPRB, 0.53301541E-09_JPRB, 0.53300597E-09_JPRB, 0.53299598E-09_JPRB, &
  & 0.53298388E-09_JPRB, 0.53296489E-09_JPRB, 0.53293608E-09_JPRB, 0.53287502E-09_JPRB, 0.53277338E-09_JPRB, 0.53262567E-09_JPRB, &
  & 0.53253901E-09_JPRB, 0.53257193E-09_JPRB, 0.53271293E-09_JPRB, 0.53293975E-09_JPRB, 0.53323229E-09_JPRB, 0.53356497E-09_JPRB, &
  & 0.53391580E-09_JPRB, 0.53425520E-09_JPRB, 0.53456084E-09_JPRB, 0.53481203E-09_JPRB, 0.53500482E-09_JPRB, 0.53514010E-09_JPRB, &
  & 0.53522248E-09_JPRB, 0.53525651E-09_JPRB, 0.53524346E-09_JPRB, 0.53518623E-09_JPRB, 0.53509197E-09_JPRB, 0.53497257E-09_JPRB, &
  & 0.53483973E-09_JPRB, 0.53470128E-09_JPRB, 0.53456056E-09_JPRB, 0.53441901E-09_JPRB, 0.53428045E-09_JPRB, 0.53415572E-09_JPRB, &
  & 0.53406202E-09_JPRB, 0.53401950E-09_JPRB, 0.53403348E-09_JPRB, 0.53408589E-09_JPRB, 0.53415294E-09_JPRB, 0.53420918E-09_JPRB, &
  & 0.53424670E-09_JPRB, 0.53426447E-09_JPRB, 0.53426930E-09_JPRB, 0.53426696E-09_JPRB, 0.53426130E-09_JPRB, 0.53425392E-09_JPRB, &
  & 0.53424543E-09_JPRB, 0.53423532E-09_JPRB, 0.53422372E-09_JPRB, 0.53420979E-09_JPRB, 0.53419535E-09_JPRB, 0.53418225E-09_JPRB, &
  & 0.53417049E-09_JPRB, 0.53415988E-09_JPRB, 0.53414834E-09_JPRB, 0.53412863E-09_JPRB /)

RGHG6(:,59,12) = (/ &
  & 0.53283983E-09_JPRB, 0.53311733E-09_JPRB, 0.53321342E-09_JPRB, 0.53327565E-09_JPRB, 0.53330013E-09_JPRB, 0.53329202E-09_JPRB, &
  & 0.53326976E-09_JPRB, 0.53325161E-09_JPRB, 0.53323868E-09_JPRB, 0.53322952E-09_JPRB, 0.53322180E-09_JPRB, 0.53321386E-09_JPRB, &
  & 0.53320370E-09_JPRB, 0.53318916E-09_JPRB, 0.53316168E-09_JPRB, 0.53311328E-09_JPRB, 0.53301241E-09_JPRB, 0.53287413E-09_JPRB, &
  & 0.53278237E-09_JPRB, 0.53280186E-09_JPRB, 0.53292581E-09_JPRB, 0.53313609E-09_JPRB, 0.53340993E-09_JPRB, 0.53372695E-09_JPRB, &
  & 0.53406030E-09_JPRB, 0.53438498E-09_JPRB, 0.53467497E-09_JPRB, 0.53491406E-09_JPRB, 0.53509475E-09_JPRB, 0.53522053E-09_JPRB, &
  & 0.53529542E-09_JPRB, 0.53532373E-09_JPRB, 0.53530708E-09_JPRB, 0.53524851E-09_JPRB, 0.53515448E-09_JPRB, 0.53503657E-09_JPRB, &
  & 0.53490617E-09_JPRB, 0.53477067E-09_JPRB, 0.53463356E-09_JPRB, 0.53449789E-09_JPRB, 0.53436794E-09_JPRB, 0.53425353E-09_JPRB, &
  & 0.53417315E-09_JPRB, 0.53414168E-09_JPRB, 0.53416382E-09_JPRB, 0.53422350E-09_JPRB, 0.53429261E-09_JPRB, 0.53435129E-09_JPRB, &
  & 0.53438681E-09_JPRB, 0.53440319E-09_JPRB, 0.53440685E-09_JPRB, 0.53440435E-09_JPRB, 0.53439919E-09_JPRB, 0.53439281E-09_JPRB, &
  & 0.53438542E-09_JPRB, 0.53437704E-09_JPRB, 0.53436677E-09_JPRB, 0.53435534E-09_JPRB, 0.53434290E-09_JPRB, 0.53433108E-09_JPRB, &
  & 0.53432092E-09_JPRB, 0.53431121E-09_JPRB, 0.53430010E-09_JPRB, 0.53428073E-09_JPRB /)

RGHG6(:,60,12) = (/ &
  & 0.53336646E-09_JPRB, 0.53344762E-09_JPRB, 0.53349059E-09_JPRB, 0.53351085E-09_JPRB, 0.53351207E-09_JPRB, 0.53349214E-09_JPRB, &
  & 0.53346666E-09_JPRB, 0.53344756E-09_JPRB, 0.53343596E-09_JPRB, 0.53342830E-09_JPRB, 0.53342247E-09_JPRB, 0.53341659E-09_JPRB, &
  & 0.53340904E-09_JPRB, 0.53339655E-09_JPRB, 0.53337434E-09_JPRB, 0.53332605E-09_JPRB, 0.53323479E-09_JPRB, 0.53310317E-09_JPRB, &
  & 0.53301524E-09_JPRB, 0.53302690E-09_JPRB, 0.53313731E-09_JPRB, 0.53333121E-09_JPRB, 0.53358928E-09_JPRB, 0.53388799E-09_JPRB, &
  & 0.53420512E-09_JPRB, 0.53451205E-09_JPRB, 0.53478716E-09_JPRB, 0.53501120E-09_JPRB, 0.53518096E-09_JPRB, 0.53529714E-09_JPRB, &
  & 0.53536509E-09_JPRB, 0.53538868E-09_JPRB, 0.53536930E-09_JPRB, 0.53530991E-09_JPRB, 0.53521709E-09_JPRB, 0.53510174E-09_JPRB, &
  & 0.53497395E-09_JPRB, 0.53484178E-09_JPRB, 0.53470861E-09_JPRB, 0.53457844E-09_JPRB, 0.53445592E-09_JPRB, 0.53435212E-09_JPRB, &
  & 0.53428212E-09_JPRB, 0.53426030E-09_JPRB, 0.53428878E-09_JPRB, 0.53435056E-09_JPRB, 0.53442278E-09_JPRB, 0.53448046E-09_JPRB, &
  & 0.53451521E-09_JPRB, 0.53452881E-09_JPRB, 0.53453070E-09_JPRB, 0.53452709E-09_JPRB, 0.53452143E-09_JPRB, 0.53451488E-09_JPRB, &
  & 0.53450766E-09_JPRB, 0.53449939E-09_JPRB, 0.53449006E-09_JPRB, 0.53447902E-09_JPRB, 0.53446758E-09_JPRB, 0.53445687E-09_JPRB, &
  & 0.53444704E-09_JPRB, 0.53443794E-09_JPRB, 0.53442767E-09_JPRB, 0.53440991E-09_JPRB /)

RGHG6(:,61,12) = (/ &
  & 0.53362470E-09_JPRB, 0.53368709E-09_JPRB, 0.53370652E-09_JPRB, 0.53371241E-09_JPRB, 0.53370264E-09_JPRB, 0.53367682E-09_JPRB, &
  & 0.53365024E-09_JPRB, 0.53363214E-09_JPRB, 0.53362126E-09_JPRB, 0.53361549E-09_JPRB, 0.53361193E-09_JPRB, 0.53360882E-09_JPRB, &
  & 0.53360416E-09_JPRB, 0.53359506E-09_JPRB, 0.53357446E-09_JPRB, 0.53352994E-09_JPRB, 0.53344063E-09_JPRB, 0.53332139E-09_JPRB, &
  & 0.53324067E-09_JPRB, 0.53324783E-09_JPRB, 0.53334731E-09_JPRB, 0.53352694E-09_JPRB, 0.53376803E-09_JPRB, 0.53405025E-09_JPRB, &
  & 0.53434851E-09_JPRB, 0.53463844E-09_JPRB, 0.53489585E-09_JPRB, 0.53510579E-09_JPRB, 0.53526300E-09_JPRB, 0.53537047E-09_JPRB, &
  & 0.53543192E-09_JPRB, 0.53545152E-09_JPRB, 0.53543037E-09_JPRB, 0.53537130E-09_JPRB, 0.53528043E-09_JPRB, 0.53516785E-09_JPRB, &
  & 0.53504345E-09_JPRB, 0.53491439E-09_JPRB, 0.53478522E-09_JPRB, 0.53466004E-09_JPRB, 0.53454513E-09_JPRB, 0.53445015E-09_JPRB, &
  & 0.53438992E-09_JPRB, 0.53437588E-09_JPRB, 0.53440841E-09_JPRB, 0.53447213E-09_JPRB, 0.53454330E-09_JPRB, 0.53460159E-09_JPRB, &
  & 0.53463395E-09_JPRB, 0.53464577E-09_JPRB, 0.53464544E-09_JPRB, 0.53464011E-09_JPRB, 0.53463312E-09_JPRB, 0.53462568E-09_JPRB, &
  & 0.53461768E-09_JPRB, 0.53460930E-09_JPRB, 0.53459948E-09_JPRB, 0.53458882E-09_JPRB, 0.53457744E-09_JPRB, 0.53456661E-09_JPRB, &
  & 0.53455707E-09_JPRB, 0.53454768E-09_JPRB, 0.53453714E-09_JPRB, 0.53451876E-09_JPRB /)

RGHG6(:,62,12) = (/ &
  & 0.53384708E-09_JPRB, 0.53388599E-09_JPRB, 0.53389587E-09_JPRB, 0.53389310E-09_JPRB, 0.53387711E-09_JPRB, 0.53385130E-09_JPRB, &
  & 0.53382415E-09_JPRB, 0.53380528E-09_JPRB, 0.53379584E-09_JPRB, 0.53379223E-09_JPRB, 0.53379212E-09_JPRB, 0.53379301E-09_JPRB, &
  & 0.53379240E-09_JPRB, 0.53378679E-09_JPRB, 0.53376897E-09_JPRB, 0.53372423E-09_JPRB, 0.53363902E-09_JPRB, 0.53353183E-09_JPRB, &
  & 0.53345994E-09_JPRB, 0.53346594E-09_JPRB, 0.53355659E-09_JPRB, 0.53372290E-09_JPRB, 0.53394833E-09_JPRB, 0.53421245E-09_JPRB, &
  & 0.53449262E-09_JPRB, 0.53476323E-09_JPRB, 0.53500310E-09_JPRB, 0.53519694E-09_JPRB, 0.53534249E-09_JPRB, 0.53544075E-09_JPRB, &
  & 0.53549626E-09_JPRB, 0.53551236E-09_JPRB, 0.53549026E-09_JPRB, 0.53543237E-09_JPRB, 0.53534410E-09_JPRB, 0.53523519E-09_JPRB, &
  & 0.53511395E-09_JPRB, 0.53498861E-09_JPRB, 0.53486304E-09_JPRB, 0.53474331E-09_JPRB, 0.53463484E-09_JPRB, 0.53454841E-09_JPRB, &
  & 0.53449634E-09_JPRB, 0.53448890E-09_JPRB, 0.53452465E-09_JPRB, 0.53458782E-09_JPRB, 0.53465848E-09_JPRB, 0.53471494E-09_JPRB, &
  & 0.53474708E-09_JPRB, 0.53475663E-09_JPRB, 0.53475391E-09_JPRB, 0.53474630E-09_JPRB, 0.53473753E-09_JPRB, 0.53472848E-09_JPRB, &
  & 0.53471944E-09_JPRB, 0.53470972E-09_JPRB, 0.53469951E-09_JPRB, 0.53468779E-09_JPRB, 0.53467586E-09_JPRB, 0.53466459E-09_JPRB, &
  & 0.53465421E-09_JPRB, 0.53464444E-09_JPRB, 0.53463350E-09_JPRB, 0.53461435E-09_JPRB /)

RGHG6(:,63,12) = (/ &
  & 0.53403293E-09_JPRB, 0.53406279E-09_JPRB, 0.53406635E-09_JPRB, 0.53405974E-09_JPRB, 0.53404364E-09_JPRB, 0.53401705E-09_JPRB, &
  & 0.53399002E-09_JPRB, 0.53397103E-09_JPRB, 0.53396143E-09_JPRB, 0.53396015E-09_JPRB, 0.53396443E-09_JPRB, 0.53397076E-09_JPRB, &
  & 0.53397609E-09_JPRB, 0.53397475E-09_JPRB, 0.53395810E-09_JPRB, 0.53391358E-09_JPRB, 0.53383342E-09_JPRB, 0.53373905E-09_JPRB, &
  & 0.53367621E-09_JPRB, 0.53368160E-09_JPRB, 0.53376509E-09_JPRB, 0.53391913E-09_JPRB, 0.53412902E-09_JPRB, 0.53437521E-09_JPRB, &
  & 0.53463567E-09_JPRB, 0.53488691E-09_JPRB, 0.53510774E-09_JPRB, 0.53528598E-09_JPRB, 0.53541860E-09_JPRB, 0.53550830E-09_JPRB, &
  & 0.53555815E-09_JPRB, 0.53557137E-09_JPRB, 0.53554888E-09_JPRB, 0.53549282E-09_JPRB, 0.53540800E-09_JPRB, 0.53530302E-09_JPRB, &
  & 0.53518590E-09_JPRB, 0.53506388E-09_JPRB, 0.53494276E-09_JPRB, 0.53482768E-09_JPRB, 0.53472576E-09_JPRB, 0.53464677E-09_JPRB, &
  & 0.53460203E-09_JPRB, 0.53460009E-09_JPRB, 0.53463778E-09_JPRB, 0.53470012E-09_JPRB, 0.53476812E-09_JPRB, 0.53482380E-09_JPRB, &
  & 0.53485483E-09_JPRB, 0.53486349E-09_JPRB, 0.53485838E-09_JPRB, 0.53484822E-09_JPRB, 0.53483684E-09_JPRB, 0.53482596E-09_JPRB, &
  & 0.53481497E-09_JPRB, 0.53480398E-09_JPRB, 0.53479188E-09_JPRB, 0.53477922E-09_JPRB, 0.53476601E-09_JPRB, 0.53475346E-09_JPRB, &
  & 0.53474236E-09_JPRB, 0.53473159E-09_JPRB, 0.53471932E-09_JPRB, 0.53469829E-09_JPRB /)

RGHG6(:,64,12) = (/ &
  & 0.53419974E-09_JPRB, 0.53422278E-09_JPRB, 0.53422422E-09_JPRB, 0.53421689E-09_JPRB, 0.53420057E-09_JPRB, 0.53417615E-09_JPRB, &
  & 0.53414961E-09_JPRB, 0.53412957E-09_JPRB, 0.53412064E-09_JPRB, 0.53412164E-09_JPRB, 0.53413035E-09_JPRB, 0.53414378E-09_JPRB, &
  & 0.53415478E-09_JPRB, 0.53415733E-09_JPRB, 0.53414168E-09_JPRB, 0.53409843E-09_JPRB, 0.53402477E-09_JPRB, 0.53394139E-09_JPRB, &
  & 0.53388671E-09_JPRB, 0.53389343E-09_JPRB, 0.53397126E-09_JPRB, 0.53411420E-09_JPRB, 0.53430838E-09_JPRB, 0.53453625E-09_JPRB, &
  & 0.53477661E-09_JPRB, 0.53500726E-09_JPRB, 0.53520899E-09_JPRB, 0.53537080E-09_JPRB, 0.53549098E-09_JPRB, 0.53557175E-09_JPRB, &
  & 0.53561616E-09_JPRB, 0.53562693E-09_JPRB, 0.53560473E-09_JPRB, 0.53555133E-09_JPRB, 0.53547072E-09_JPRB, 0.53537053E-09_JPRB, &
  & 0.53525778E-09_JPRB, 0.53514004E-09_JPRB, 0.53502314E-09_JPRB, 0.53491311E-09_JPRB, 0.53481708E-09_JPRB, 0.53474475E-09_JPRB, &
  & 0.53470661E-09_JPRB, 0.53470872E-09_JPRB, 0.53474752E-09_JPRB, 0.53480842E-09_JPRB, 0.53487376E-09_JPRB, 0.53492710E-09_JPRB, &
  & 0.53495819E-09_JPRB, 0.53496635E-09_JPRB, 0.53495963E-09_JPRB, 0.53494675E-09_JPRB, 0.53493288E-09_JPRB, 0.53491922E-09_JPRB, &
  & 0.53490612E-09_JPRB, 0.53489246E-09_JPRB, 0.53487870E-09_JPRB, 0.53486376E-09_JPRB, 0.53484900E-09_JPRB, 0.53483518E-09_JPRB, &
  & 0.53482241E-09_JPRB, 0.53481009E-09_JPRB, 0.53479599E-09_JPRB, 0.53477134E-09_JPRB /)

RGHG6(:,65,12) = (/ &
  & 0.53435395E-09_JPRB, 0.53437255E-09_JPRB, 0.53437277E-09_JPRB, 0.53436555E-09_JPRB, 0.53435106E-09_JPRB, 0.53432875E-09_JPRB, &
  & 0.53430338E-09_JPRB, 0.53428389E-09_JPRB, 0.53427540E-09_JPRB, 0.53427901E-09_JPRB, 0.53429294E-09_JPRB, 0.53431165E-09_JPRB, &
  & 0.53432792E-09_JPRB, 0.53433313E-09_JPRB, 0.53431864E-09_JPRB, 0.53427845E-09_JPRB, 0.53421223E-09_JPRB, 0.53413929E-09_JPRB, &
  & 0.53409277E-09_JPRB, 0.53410087E-09_JPRB, 0.53417354E-09_JPRB, 0.53430560E-09_JPRB, 0.53448423E-09_JPRB, 0.53469318E-09_JPRB, &
  & 0.53491284E-09_JPRB, 0.53512250E-09_JPRB, 0.53530463E-09_JPRB, 0.53545018E-09_JPRB, 0.53555776E-09_JPRB, 0.53562987E-09_JPRB, &
  & 0.53566901E-09_JPRB, 0.53567761E-09_JPRB, 0.53565641E-09_JPRB, 0.53560623E-09_JPRB, 0.53553056E-09_JPRB, 0.53543603E-09_JPRB, &
  & 0.53532867E-09_JPRB, 0.53521593E-09_JPRB, 0.53510396E-09_JPRB, 0.53499899E-09_JPRB, 0.53490862E-09_JPRB, 0.53484239E-09_JPRB, &
  & 0.53480959E-09_JPRB, 0.53481486E-09_JPRB, 0.53485399E-09_JPRB, 0.53491278E-09_JPRB, 0.53497506E-09_JPRB, 0.53502597E-09_JPRB, &
  & 0.53505644E-09_JPRB, 0.53506483E-09_JPRB, 0.53505728E-09_JPRB, 0.53504234E-09_JPRB, 0.53502536E-09_JPRB, 0.53500904E-09_JPRB, &
  & 0.53499288E-09_JPRB, 0.53497717E-09_JPRB, 0.53496046E-09_JPRB, 0.53494376E-09_JPRB, 0.53492683E-09_JPRB, 0.53491078E-09_JPRB, &
  & 0.53489618E-09_JPRB, 0.53488153E-09_JPRB, 0.53486438E-09_JPRB, 0.53483407E-09_JPRB /)

RGHG6(:,66,12) = (/ &
  & 0.53448795E-09_JPRB, 0.53451021E-09_JPRB, 0.53451255E-09_JPRB, 0.53450711E-09_JPRB, 0.53449478E-09_JPRB, 0.53447508E-09_JPRB, &
  & 0.53445220E-09_JPRB, 0.53443405E-09_JPRB, 0.53442761E-09_JPRB, 0.53443444E-09_JPRB, 0.53445220E-09_JPRB, 0.53447535E-09_JPRB, &
  & 0.53449445E-09_JPRB, 0.53450167E-09_JPRB, 0.53448890E-09_JPRB, 0.53445320E-09_JPRB, 0.53439431E-09_JPRB, 0.53433075E-09_JPRB, &
  & 0.53429161E-09_JPRB, 0.53430188E-09_JPRB, 0.53436966E-09_JPRB, 0.53449112E-09_JPRB, 0.53465404E-09_JPRB, 0.53484334E-09_JPRB, &
  & 0.53504201E-09_JPRB, 0.53523008E-09_JPRB, 0.53539340E-09_JPRB, 0.53552268E-09_JPRB, 0.53561811E-09_JPRB, 0.53568167E-09_JPRB, &
  & 0.53571592E-09_JPRB, 0.53572274E-09_JPRB, 0.53570254E-09_JPRB, 0.53565613E-09_JPRB, 0.53558630E-09_JPRB, 0.53549820E-09_JPRB, &
  & 0.53539739E-09_JPRB, 0.53529037E-09_JPRB, 0.53518423E-09_JPRB, 0.53508487E-09_JPRB, 0.53500038E-09_JPRB, 0.53493943E-09_JPRB, &
  & 0.53491100E-09_JPRB, 0.53491850E-09_JPRB, 0.53495708E-09_JPRB, 0.53501337E-09_JPRB, 0.53507232E-09_JPRB, 0.53512039E-09_JPRB, &
  & 0.53514965E-09_JPRB, 0.53515836E-09_JPRB, 0.53515092E-09_JPRB, 0.53513471E-09_JPRB, 0.53511573E-09_JPRB, 0.53509625E-09_JPRB, &
  & 0.53507765E-09_JPRB, 0.53505866E-09_JPRB, 0.53504007E-09_JPRB, 0.53502047E-09_JPRB, 0.53500138E-09_JPRB, 0.53498328E-09_JPRB, &
  & 0.53496596E-09_JPRB, 0.53494836E-09_JPRB, 0.53492677E-09_JPRB, 0.53488719E-09_JPRB /)

RGHG6(:,67,12) = (/ &
  & 0.53462035E-09_JPRB, 0.53464322E-09_JPRB, 0.53464672E-09_JPRB, 0.53464311E-09_JPRB, 0.53463312E-09_JPRB, 0.53461657E-09_JPRB, &
  & 0.53459626E-09_JPRB, 0.53458105E-09_JPRB, 0.53457749E-09_JPRB, 0.53458771E-09_JPRB, 0.53460864E-09_JPRB, 0.53463400E-09_JPRB, &
  & 0.53465476E-09_JPRB, 0.53466354E-09_JPRB, 0.53465288E-09_JPRB, 0.53462207E-09_JPRB, 0.53457011E-09_JPRB, 0.53451565E-09_JPRB, &
  & 0.53448335E-09_JPRB, 0.53449467E-09_JPRB, 0.53455745E-09_JPRB, 0.53466781E-09_JPRB, 0.53481475E-09_JPRB, 0.53498467E-09_JPRB, &
  & 0.53516186E-09_JPRB, 0.53532945E-09_JPRB, 0.53547378E-09_JPRB, 0.53558796E-09_JPRB, 0.53567173E-09_JPRB, 0.53572735E-09_JPRB, &
  & 0.53575705E-09_JPRB, 0.53576221E-09_JPRB, 0.53574334E-09_JPRB, 0.53570082E-09_JPRB, 0.53563703E-09_JPRB, 0.53555610E-09_JPRB, &
  & 0.53546240E-09_JPRB, 0.53536242E-09_JPRB, 0.53526261E-09_JPRB, 0.53516991E-09_JPRB, 0.53509136E-09_JPRB, 0.53503579E-09_JPRB, &
  & 0.53501098E-09_JPRB, 0.53501975E-09_JPRB, 0.53505711E-09_JPRB, 0.53511046E-09_JPRB, 0.53516558E-09_JPRB, 0.53521060E-09_JPRB, &
  & 0.53523819E-09_JPRB, 0.53524674E-09_JPRB, 0.53523974E-09_JPRB, 0.53522348E-09_JPRB, 0.53520283E-09_JPRB, 0.53518162E-09_JPRB, &
  & 0.53516003E-09_JPRB, 0.53513916E-09_JPRB, 0.53511756E-09_JPRB, 0.53509636E-09_JPRB, 0.53507510E-09_JPRB, 0.53505439E-09_JPRB, &
  & 0.53503479E-09_JPRB, 0.53501326E-09_JPRB, 0.53498561E-09_JPRB, 0.53493249E-09_JPRB /)

RGHG6(:,68,12) = (/ &
  & 0.53474236E-09_JPRB, 0.53476923E-09_JPRB, 0.53477534E-09_JPRB, 0.53477395E-09_JPRB, 0.53476645E-09_JPRB, 0.53475291E-09_JPRB, &
  & 0.53473687E-09_JPRB, 0.53472510E-09_JPRB, 0.53472504E-09_JPRB, 0.53473831E-09_JPRB, 0.53476140E-09_JPRB, 0.53478771E-09_JPRB, &
  & 0.53480897E-09_JPRB, 0.53481863E-09_JPRB, 0.53480942E-09_JPRB, 0.53478366E-09_JPRB, 0.53473803E-09_JPRB, 0.53469129E-09_JPRB, &
  & 0.53466465E-09_JPRB, 0.53467664E-09_JPRB, 0.53473409E-09_JPRB, 0.53483340E-09_JPRB, 0.53496452E-09_JPRB, 0.53511523E-09_JPRB, &
  & 0.53527233E-09_JPRB, 0.53541965E-09_JPRB, 0.53554661E-09_JPRB, 0.53564642E-09_JPRB, 0.53571925E-09_JPRB, 0.53576754E-09_JPRB, &
  & 0.53579302E-09_JPRB, 0.53579680E-09_JPRB, 0.53577914E-09_JPRB, 0.53574079E-09_JPRB, 0.53568328E-09_JPRB, 0.53560950E-09_JPRB, &
  & 0.53552374E-09_JPRB, 0.53543098E-09_JPRB, 0.53533877E-09_JPRB, 0.53525295E-09_JPRB, 0.53518096E-09_JPRB, 0.53513055E-09_JPRB, &
  & 0.53510918E-09_JPRB, 0.53511873E-09_JPRB, 0.53515414E-09_JPRB, 0.53520394E-09_JPRB, 0.53525512E-09_JPRB, 0.53529670E-09_JPRB, &
  & 0.53532240E-09_JPRB, 0.53533034E-09_JPRB, 0.53532373E-09_JPRB, 0.53530774E-09_JPRB, 0.53528698E-09_JPRB, 0.53526428E-09_JPRB, &
  & 0.53524157E-09_JPRB, 0.53521820E-09_JPRB, 0.53519544E-09_JPRB, 0.53517224E-09_JPRB, 0.53514948E-09_JPRB, 0.53512755E-09_JPRB, &
  & 0.53510502E-09_JPRB, 0.53508037E-09_JPRB, 0.53504579E-09_JPRB, 0.53497723E-09_JPRB /)

RGHG6(:,69,12) = (/ &
  & 0.53485993E-09_JPRB, 0.53489146E-09_JPRB, 0.53490007E-09_JPRB, 0.53490101E-09_JPRB, 0.53489613E-09_JPRB, 0.53488614E-09_JPRB, &
  & 0.53487409E-09_JPRB, 0.53486682E-09_JPRB, 0.53487070E-09_JPRB, 0.53488625E-09_JPRB, 0.53491017E-09_JPRB, 0.53493621E-09_JPRB, &
  & 0.53495713E-09_JPRB, 0.53496702E-09_JPRB, 0.53495841E-09_JPRB, 0.53493732E-09_JPRB, 0.53489724E-09_JPRB, 0.53485733E-09_JPRB, &
  & 0.53483523E-09_JPRB, 0.53484672E-09_JPRB, 0.53489818E-09_JPRB, 0.53498639E-09_JPRB, 0.53510230E-09_JPRB, 0.53523525E-09_JPRB, &
  & 0.53537286E-09_JPRB, 0.53550164E-09_JPRB, 0.53561194E-09_JPRB, 0.53569871E-09_JPRB, 0.53576171E-09_JPRB, 0.53580318E-09_JPRB, &
  & 0.53582472E-09_JPRB, 0.53582727E-09_JPRB, 0.53581106E-09_JPRB, 0.53577653E-09_JPRB, 0.53572502E-09_JPRB, 0.53565885E-09_JPRB, &
  & 0.53558080E-09_JPRB, 0.53549637E-09_JPRB, 0.53541188E-09_JPRB, 0.53533367E-09_JPRB, 0.53526850E-09_JPRB, 0.53522337E-09_JPRB, &
  & 0.53520505E-09_JPRB, 0.53521515E-09_JPRB, 0.53524840E-09_JPRB, 0.53529436E-09_JPRB, 0.53534133E-09_JPRB, 0.53537941E-09_JPRB, &
  & 0.53540278E-09_JPRB, 0.53540994E-09_JPRB, 0.53540350E-09_JPRB, 0.53538829E-09_JPRB, 0.53536781E-09_JPRB, 0.53534510E-09_JPRB, &
  & 0.53532156E-09_JPRB, 0.53529775E-09_JPRB, 0.53527366E-09_JPRB, 0.53524996E-09_JPRB, 0.53522675E-09_JPRB, 0.53520327E-09_JPRB, &
  & 0.53518001E-09_JPRB, 0.53515192E-09_JPRB, 0.53511118E-09_JPRB, 0.53502508E-09_JPRB /)

RGHG6(:,70,12) = (/ &
  & 0.53497162E-09_JPRB, 0.53500948E-09_JPRB, 0.53502147E-09_JPRB, 0.53502502E-09_JPRB, 0.53502314E-09_JPRB, 0.53501659E-09_JPRB, &
  & 0.53500915E-09_JPRB, 0.53500637E-09_JPRB, 0.53501359E-09_JPRB, 0.53503124E-09_JPRB, 0.53505450E-09_JPRB, 0.53507920E-09_JPRB, &
  & 0.53509852E-09_JPRB, 0.53510801E-09_JPRB, 0.53509952E-09_JPRB, 0.53508209E-09_JPRB, 0.53504706E-09_JPRB, 0.53501226E-09_JPRB, &
  & 0.53499360E-09_JPRB, 0.53500404E-09_JPRB, 0.53504934E-09_JPRB, 0.53512700E-09_JPRB, 0.53522881E-09_JPRB, 0.53534460E-09_JPRB, &
  & 0.53546445E-09_JPRB, 0.53557564E-09_JPRB, 0.53567095E-09_JPRB, 0.53574539E-09_JPRB, 0.53579935E-09_JPRB, 0.53583465E-09_JPRB, &
  & 0.53585275E-09_JPRB, 0.53585414E-09_JPRB, 0.53583932E-09_JPRB, 0.53580901E-09_JPRB, 0.53576349E-09_JPRB, 0.53570443E-09_JPRB, &
  & 0.53563443E-09_JPRB, 0.53555815E-09_JPRB, 0.53548205E-09_JPRB, 0.53541171E-09_JPRB, 0.53535332E-09_JPRB, 0.53531368E-09_JPRB, &
  & 0.53529847E-09_JPRB, 0.53530913E-09_JPRB, 0.53534005E-09_JPRB, 0.53538174E-09_JPRB, 0.53542420E-09_JPRB, 0.53545862E-09_JPRB, &
  & 0.53547955E-09_JPRB, 0.53548593E-09_JPRB, 0.53547961E-09_JPRB, 0.53546528E-09_JPRB, 0.53544580E-09_JPRB, 0.53542387E-09_JPRB, &
  & 0.53540100E-09_JPRB, 0.53537735E-09_JPRB, 0.53535354E-09_JPRB, 0.53532978E-09_JPRB, 0.53530669E-09_JPRB, 0.53528360E-09_JPRB, &
  & 0.53525934E-09_JPRB, 0.53523042E-09_JPRB, 0.53518429E-09_JPRB, 0.53508370E-09_JPRB /)

RGHG6(:,71,12) = (/ &
  & 0.53507920E-09_JPRB, 0.53512511E-09_JPRB, 0.53514049E-09_JPRB, 0.53514693E-09_JPRB, 0.53514787E-09_JPRB, 0.53514471E-09_JPRB, &
  & 0.53514160E-09_JPRB, 0.53514332E-09_JPRB, 0.53515342E-09_JPRB, 0.53517119E-09_JPRB, 0.53519356E-09_JPRB, 0.53521498E-09_JPRB, &
  & 0.53523225E-09_JPRB, 0.53524091E-09_JPRB, 0.53523230E-09_JPRB, 0.53521704E-09_JPRB, 0.53518678E-09_JPRB, 0.53515636E-09_JPRB, &
  & 0.53514038E-09_JPRB, 0.53514915E-09_JPRB, 0.53518850E-09_JPRB, 0.53525612E-09_JPRB, 0.53534416E-09_JPRB, 0.53544447E-09_JPRB, &
  & 0.53554716E-09_JPRB, 0.53564259E-09_JPRB, 0.53572391E-09_JPRB, 0.53578725E-09_JPRB, 0.53583282E-09_JPRB, 0.53586235E-09_JPRB, &
  & 0.53587745E-09_JPRB, 0.53587812E-09_JPRB, 0.53586491E-09_JPRB, 0.53583826E-09_JPRB, 0.53579846E-09_JPRB, 0.53574656E-09_JPRB, &
  & 0.53568466E-09_JPRB, 0.53561683E-09_JPRB, 0.53554894E-09_JPRB, 0.53548654E-09_JPRB, 0.53543520E-09_JPRB, 0.53540100E-09_JPRB, &
  & 0.53538901E-09_JPRB, 0.53540000E-09_JPRB, 0.53542837E-09_JPRB, 0.53546600E-09_JPRB, 0.53550370E-09_JPRB, 0.53553423E-09_JPRB, &
  & 0.53555260E-09_JPRB, 0.53555815E-09_JPRB, 0.53555205E-09_JPRB, 0.53553884E-09_JPRB, 0.53552085E-09_JPRB, 0.53550087E-09_JPRB, &
  & 0.53547944E-09_JPRB, 0.53545735E-09_JPRB, 0.53543447E-09_JPRB, 0.53541183E-09_JPRB, 0.53538990E-09_JPRB, 0.53536747E-09_JPRB, &
  & 0.53534382E-09_JPRB, 0.53531463E-09_JPRB, 0.53526644E-09_JPRB, 0.53515697E-09_JPRB /)

RGHG6(:,72,12) = (/ &
  & 0.53518401E-09_JPRB, 0.53523863E-09_JPRB, 0.53525795E-09_JPRB, 0.53526672E-09_JPRB, 0.53527027E-09_JPRB, 0.53526994E-09_JPRB, &
  & 0.53527077E-09_JPRB, 0.53527588E-09_JPRB, 0.53528754E-09_JPRB, 0.53530536E-09_JPRB, 0.53532384E-09_JPRB, 0.53534321E-09_JPRB, &
  & 0.53535709E-09_JPRB, 0.53536409E-09_JPRB, 0.53535631E-09_JPRB, 0.53534188E-09_JPRB, 0.53531618E-09_JPRB, 0.53528931E-09_JPRB, &
  & 0.53527560E-09_JPRB, 0.53528293E-09_JPRB, 0.53531651E-09_JPRB, 0.53537408E-09_JPRB, 0.53544985E-09_JPRB, 0.53553501E-09_JPRB, &
  & 0.53562221E-09_JPRB, 0.53570270E-09_JPRB, 0.53577148E-09_JPRB, 0.53582450E-09_JPRB, 0.53586263E-09_JPRB, 0.53588700E-09_JPRB, &
  & 0.53589949E-09_JPRB, 0.53589932E-09_JPRB, 0.53588761E-09_JPRB, 0.53586474E-09_JPRB, 0.53583049E-09_JPRB, 0.53578564E-09_JPRB, &
  & 0.53573174E-09_JPRB, 0.53567228E-09_JPRB, 0.53561272E-09_JPRB, 0.53555860E-09_JPRB, 0.53551408E-09_JPRB, 0.53548532E-09_JPRB, &
  & 0.53547605E-09_JPRB, 0.53548732E-09_JPRB, 0.53551324E-09_JPRB, 0.53554639E-09_JPRB, 0.53557919E-09_JPRB, 0.53560573E-09_JPRB, &
  & 0.53562149E-09_JPRB, 0.53562632E-09_JPRB, 0.53562066E-09_JPRB, 0.53560911E-09_JPRB, 0.53559357E-09_JPRB, 0.53557531E-09_JPRB, &
  & 0.53555671E-09_JPRB, 0.53553628E-09_JPRB, 0.53551585E-09_JPRB, 0.53549420E-09_JPRB, 0.53547461E-09_JPRB, 0.53545324E-09_JPRB, &
  & 0.53543081E-09_JPRB, 0.53540339E-09_JPRB, 0.53535487E-09_JPRB, 0.53524130E-09_JPRB /)

RGHG6(:,73,12) = (/ &
  & 0.53529686E-09_JPRB, 0.53535387E-09_JPRB, 0.53537386E-09_JPRB, 0.53538368E-09_JPRB, 0.53538890E-09_JPRB, 0.53539079E-09_JPRB, &
  & 0.53539423E-09_JPRB, 0.53540145E-09_JPRB, 0.53541394E-09_JPRB, 0.53542892E-09_JPRB, 0.53544635E-09_JPRB, 0.53546056E-09_JPRB, &
  & 0.53547239E-09_JPRB, 0.53547750E-09_JPRB, 0.53547050E-09_JPRB, 0.53545690E-09_JPRB, 0.53543492E-09_JPRB, 0.53541166E-09_JPRB, &
  & 0.53540011E-09_JPRB, 0.53540589E-09_JPRB, 0.53543364E-09_JPRB, 0.53548227E-09_JPRB, 0.53554577E-09_JPRB, 0.53561744E-09_JPRB, &
  & 0.53568977E-09_JPRB, 0.53575683E-09_JPRB, 0.53581389E-09_JPRB, 0.53585758E-09_JPRB, 0.53588900E-09_JPRB, 0.53590854E-09_JPRB, &
  & 0.53591864E-09_JPRB, 0.53591798E-09_JPRB, 0.53590787E-09_JPRB, 0.53588844E-09_JPRB, 0.53585958E-09_JPRB, 0.53582178E-09_JPRB, &
  & 0.53577565E-09_JPRB, 0.53572458E-09_JPRB, 0.53567328E-09_JPRB, 0.53562743E-09_JPRB, 0.53558968E-09_JPRB, 0.53556581E-09_JPRB, &
  & 0.53555921E-09_JPRB, 0.53557048E-09_JPRB, 0.53559335E-09_JPRB, 0.53562182E-09_JPRB, 0.53564997E-09_JPRB, 0.53567256E-09_JPRB, &
  & 0.53568555E-09_JPRB, 0.53569010E-09_JPRB, 0.53568533E-09_JPRB, 0.53567556E-09_JPRB, 0.53566207E-09_JPRB, 0.53564708E-09_JPRB, &
  & 0.53563037E-09_JPRB, 0.53561344E-09_JPRB, 0.53559435E-09_JPRB, 0.53557564E-09_JPRB, 0.53555760E-09_JPRB, 0.53553861E-09_JPRB, &
  & 0.53551796E-09_JPRB, 0.53549293E-09_JPRB, 0.53544641E-09_JPRB, 0.53533272E-09_JPRB /)

RGHG6(:,74,12) = (/ &
  & 0.53540727E-09_JPRB, 0.53546584E-09_JPRB, 0.53548566E-09_JPRB, 0.53549570E-09_JPRB, 0.53550192E-09_JPRB, 0.53550470E-09_JPRB, &
  & 0.53550964E-09_JPRB, 0.53551746E-09_JPRB, 0.53552890E-09_JPRB, 0.53554350E-09_JPRB, 0.53555577E-09_JPRB, 0.53556887E-09_JPRB, &
  & 0.53557708E-09_JPRB, 0.53558075E-09_JPRB, 0.53557436E-09_JPRB, 0.53556193E-09_JPRB, 0.53554339E-09_JPRB, 0.53552346E-09_JPRB, &
  & 0.53551419E-09_JPRB, 0.53551857E-09_JPRB, 0.53554083E-09_JPRB, 0.53558075E-09_JPRB, 0.53563326E-09_JPRB, 0.53569177E-09_JPRB, &
  & 0.53575083E-09_JPRB, 0.53580507E-09_JPRB, 0.53585170E-09_JPRB, 0.53588695E-09_JPRB, 0.53591226E-09_JPRB, 0.53592764E-09_JPRB, &
  & 0.53593568E-09_JPRB, 0.53593463E-09_JPRB, 0.53592586E-09_JPRB, 0.53590982E-09_JPRB, 0.53588639E-09_JPRB, 0.53585503E-09_JPRB, &
  & 0.53581667E-09_JPRB, 0.53577398E-09_JPRB, 0.53573068E-09_JPRB, 0.53569299E-09_JPRB, 0.53566146E-09_JPRB, 0.53564242E-09_JPRB, &
  & 0.53563776E-09_JPRB, 0.53564847E-09_JPRB, 0.53566823E-09_JPRB, 0.53569216E-09_JPRB, 0.53571542E-09_JPRB, 0.53573418E-09_JPRB, &
  & 0.53574506E-09_JPRB, 0.53574917E-09_JPRB, 0.53574539E-09_JPRB, 0.53573757E-09_JPRB, 0.53572691E-09_JPRB, 0.53571370E-09_JPRB, &
  & 0.53570043E-09_JPRB, 0.53568505E-09_JPRB, 0.53566962E-09_JPRB, 0.53565219E-09_JPRB, 0.53563787E-09_JPRB, 0.53562038E-09_JPRB, &
  & 0.53560212E-09_JPRB, 0.53558097E-09_JPRB, 0.53553739E-09_JPRB, 0.53542781E-09_JPRB /)

RGHG6(:,75,12) = (/ &
  & 0.53551408E-09_JPRB, 0.53557270E-09_JPRB, 0.53559168E-09_JPRB, 0.53560101E-09_JPRB, 0.53560778E-09_JPRB, 0.53561044E-09_JPRB, &
  & 0.53561566E-09_JPRB, 0.53562277E-09_JPRB, 0.53563393E-09_JPRB, 0.53564486E-09_JPRB, 0.53565635E-09_JPRB, 0.53566518E-09_JPRB, &
  & 0.53567240E-09_JPRB, 0.53567473E-09_JPRB, 0.53566851E-09_JPRB, 0.53565741E-09_JPRB, 0.53564231E-09_JPRB, 0.53562565E-09_JPRB, &
  & 0.53561855E-09_JPRB, 0.53562160E-09_JPRB, 0.53563898E-09_JPRB, 0.53567067E-09_JPRB, 0.53571275E-09_JPRB, 0.53575933E-09_JPRB, &
  & 0.53580579E-09_JPRB, 0.53584842E-09_JPRB, 0.53588534E-09_JPRB, 0.53591298E-09_JPRB, 0.53593280E-09_JPRB, 0.53594418E-09_JPRB, &
  & 0.53595062E-09_JPRB, 0.53594928E-09_JPRB, 0.53594212E-09_JPRB, 0.53592875E-09_JPRB, 0.53591098E-09_JPRB, 0.53588534E-09_JPRB, &
  & 0.53585514E-09_JPRB, 0.53582033E-09_JPRB, 0.53578497E-09_JPRB, 0.53575527E-09_JPRB, 0.53572979E-09_JPRB, 0.53571481E-09_JPRB, &
  & 0.53571164E-09_JPRB, 0.53572158E-09_JPRB, 0.53573840E-09_JPRB, 0.53575699E-09_JPRB, 0.53577576E-09_JPRB, 0.53579080E-09_JPRB, &
  & 0.53579918E-09_JPRB, 0.53580307E-09_JPRB, 0.53580074E-09_JPRB, 0.53579513E-09_JPRB, 0.53578642E-09_JPRB, 0.53577587E-09_JPRB, &
  & 0.53576432E-09_JPRB, 0.53575233E-09_JPRB, 0.53573868E-09_JPRB, 0.53572435E-09_JPRB, 0.53571275E-09_JPRB, 0.53569799E-09_JPRB, &
  & 0.53568244E-09_JPRB, 0.53566523E-09_JPRB, 0.53562693E-09_JPRB, 0.53552401E-09_JPRB /)

RGHG6(:,76,12) = (/ &
  & 0.53561600E-09_JPRB, 0.53567406E-09_JPRB, 0.53569066E-09_JPRB, 0.53569882E-09_JPRB, 0.53570581E-09_JPRB, 0.53570742E-09_JPRB, &
  & 0.53571220E-09_JPRB, 0.53571819E-09_JPRB, 0.53572702E-09_JPRB, 0.53573712E-09_JPRB, 0.53574395E-09_JPRB, 0.53575194E-09_JPRB, &
  & 0.53575677E-09_JPRB, 0.53575877E-09_JPRB, 0.53575311E-09_JPRB, 0.53574389E-09_JPRB, 0.53573235E-09_JPRB, 0.53571858E-09_JPRB, &
  & 0.53571392E-09_JPRB, 0.53571586E-09_JPRB, 0.53572841E-09_JPRB, 0.53575272E-09_JPRB, 0.53578508E-09_JPRB, 0.53582061E-09_JPRB, &
  & 0.53585542E-09_JPRB, 0.53588700E-09_JPRB, 0.53591526E-09_JPRB, 0.53593607E-09_JPRB, 0.53595101E-09_JPRB, 0.53595861E-09_JPRB, &
  & 0.53596394E-09_JPRB, 0.53596222E-09_JPRB, 0.53595656E-09_JPRB, 0.53594579E-09_JPRB, 0.53593346E-09_JPRB, 0.53591315E-09_JPRB, &
  & 0.53589128E-09_JPRB, 0.53586374E-09_JPRB, 0.53583571E-09_JPRB, 0.53581423E-09_JPRB, 0.53579419E-09_JPRB, 0.53578292E-09_JPRB, &
  & 0.53578070E-09_JPRB, 0.53578986E-09_JPRB, 0.53580312E-09_JPRB, 0.53581717E-09_JPRB, 0.53583094E-09_JPRB, 0.53584248E-09_JPRB, &
  & 0.53584831E-09_JPRB, 0.53585208E-09_JPRB, 0.53585081E-09_JPRB, 0.53584742E-09_JPRB, 0.53584115E-09_JPRB, 0.53583216E-09_JPRB, &
  & 0.53582333E-09_JPRB, 0.53581345E-09_JPRB, 0.53580285E-09_JPRB, 0.53579058E-09_JPRB, 0.53578331E-09_JPRB, 0.53577071E-09_JPRB, &
  & 0.53575772E-09_JPRB, 0.53574623E-09_JPRB, 0.53571314E-09_JPRB, 0.53561999E-09_JPRB /)

RGHG6(:,77,12) = (/ &
  & 0.53571336E-09_JPRB, 0.53576804E-09_JPRB, 0.53578181E-09_JPRB, 0.53578825E-09_JPRB, 0.53579546E-09_JPRB, 0.53579530E-09_JPRB, &
  & 0.53579929E-09_JPRB, 0.53580312E-09_JPRB, 0.53581062E-09_JPRB, 0.53581722E-09_JPRB, 0.53582161E-09_JPRB, 0.53582655E-09_JPRB, &
  & 0.53583060E-09_JPRB, 0.53583260E-09_JPRB, 0.53582777E-09_JPRB, 0.53582083E-09_JPRB, 0.53581328E-09_JPRB, 0.53580257E-09_JPRB, &
  & 0.53580040E-09_JPRB, 0.53580129E-09_JPRB, 0.53580956E-09_JPRB, 0.53582683E-09_JPRB, 0.53585048E-09_JPRB, 0.53587546E-09_JPRB, &
  & 0.53589955E-09_JPRB, 0.53592120E-09_JPRB, 0.53594168E-09_JPRB, 0.53595639E-09_JPRB, 0.53596699E-09_JPRB, 0.53597127E-09_JPRB, &
  & 0.53597565E-09_JPRB, 0.53597354E-09_JPRB, 0.53596949E-09_JPRB, 0.53596083E-09_JPRB, 0.53595378E-09_JPRB, 0.53593807E-09_JPRB, &
  & 0.53592469E-09_JPRB, 0.53590410E-09_JPRB, 0.53588328E-09_JPRB, 0.53586924E-09_JPRB, 0.53585425E-09_JPRB, 0.53584603E-09_JPRB, &
  & 0.53584437E-09_JPRB, 0.53585286E-09_JPRB, 0.53586291E-09_JPRB, 0.53587179E-09_JPRB, 0.53588112E-09_JPRB, 0.53588911E-09_JPRB, &
  & 0.53589233E-09_JPRB, 0.53589588E-09_JPRB, 0.53589555E-09_JPRB, 0.53589422E-09_JPRB, 0.53589011E-09_JPRB, 0.53588289E-09_JPRB, &
  & 0.53587629E-09_JPRB, 0.53586902E-09_JPRB, 0.53586102E-09_JPRB, 0.53585114E-09_JPRB, 0.53584825E-09_JPRB, 0.53583765E-09_JPRB, &
  & 0.53582749E-09_JPRB, 0.53582155E-09_JPRB, 0.53579552E-09_JPRB, 0.53571469E-09_JPRB /)

RGHG6(:,78,12) = (/ &
  & 0.53580490E-09_JPRB, 0.53585125E-09_JPRB, 0.53585930E-09_JPRB, 0.53586363E-09_JPRB, 0.53587129E-09_JPRB, 0.53586902E-09_JPRB, &
  & 0.53587218E-09_JPRB, 0.53587385E-09_JPRB, 0.53587917E-09_JPRB, 0.53588339E-09_JPRB, 0.53588378E-09_JPRB, 0.53588733E-09_JPRB, &
  & 0.53588983E-09_JPRB, 0.53589261E-09_JPRB, 0.53588894E-09_JPRB, 0.53588467E-09_JPRB, 0.53588112E-09_JPRB, 0.53587323E-09_JPRB, &
  & 0.53587357E-09_JPRB, 0.53587385E-09_JPRB, 0.53587840E-09_JPRB, 0.53588972E-09_JPRB, 0.53590588E-09_JPRB, 0.53592147E-09_JPRB, &
  & 0.53593652E-09_JPRB, 0.53594978E-09_JPRB, 0.53596377E-09_JPRB, 0.53597343E-09_JPRB, 0.53598026E-09_JPRB, 0.53598159E-09_JPRB, &
  & 0.53598537E-09_JPRB, 0.53598292E-09_JPRB, 0.53598032E-09_JPRB, 0.53597327E-09_JPRB, 0.53597093E-09_JPRB, 0.53595944E-09_JPRB, &
  & 0.53595356E-09_JPRB, 0.53593896E-09_JPRB, 0.53592436E-09_JPRB, 0.53591720E-09_JPRB, 0.53590626E-09_JPRB, 0.53590066E-09_JPRB, &
  & 0.53589938E-09_JPRB, 0.53590699E-09_JPRB, 0.53591409E-09_JPRB, 0.53591848E-09_JPRB, 0.53592336E-09_JPRB, 0.53592825E-09_JPRB, &
  & 0.53592875E-09_JPRB, 0.53593219E-09_JPRB, 0.53593258E-09_JPRB, 0.53593302E-09_JPRB, 0.53593108E-09_JPRB, 0.53592497E-09_JPRB, &
  & 0.53592086E-09_JPRB, 0.53591581E-09_JPRB, 0.53591004E-09_JPRB, 0.53590227E-09_JPRB, 0.53590354E-09_JPRB, 0.53589483E-09_JPRB, &
  & 0.53588711E-09_JPRB, 0.53588683E-09_JPRB, 0.53586952E-09_JPRB, 0.53580718E-09_JPRB /)

RGHG6(:,79,12) = (/ &
  & 0.53586346E-09_JPRB, 0.53589783E-09_JPRB, 0.53590032E-09_JPRB, 0.53590254E-09_JPRB, 0.53591098E-09_JPRB, 0.53590710E-09_JPRB, &
  & 0.53590998E-09_JPRB, 0.53591021E-09_JPRB, 0.53591470E-09_JPRB, 0.53591787E-09_JPRB, 0.53591609E-09_JPRB, 0.53591864E-09_JPRB, &
  & 0.53592075E-09_JPRB, 0.53592419E-09_JPRB, 0.53592086E-09_JPRB, 0.53591792E-09_JPRB, 0.53591687E-09_JPRB, 0.53591021E-09_JPRB, &
  & 0.53591265E-09_JPRB, 0.53591254E-09_JPRB, 0.53591498E-09_JPRB, 0.53592336E-09_JPRB, 0.53593585E-09_JPRB, 0.53594640E-09_JPRB, &
  & 0.53595656E-09_JPRB, 0.53596522E-09_JPRB, 0.53597593E-09_JPRB, 0.53598292E-09_JPRB, 0.53598792E-09_JPRB, 0.53598714E-09_JPRB, &
  & 0.53599086E-09_JPRB, 0.53598792E-09_JPRB, 0.53598614E-09_JPRB, 0.53597971E-09_JPRB, 0.53598032E-09_JPRB, 0.53597077E-09_JPRB, &
  & 0.53596955E-09_JPRB, 0.53595794E-09_JPRB, 0.53594629E-09_JPRB, 0.53594318E-09_JPRB, 0.53593419E-09_JPRB, 0.53592975E-09_JPRB, &
  & 0.53592852E-09_JPRB, 0.53593630E-09_JPRB, 0.53594201E-09_JPRB, 0.53594357E-09_JPRB, 0.53594584E-09_JPRB, 0.53594901E-09_JPRB, &
  & 0.53594773E-09_JPRB, 0.53595123E-09_JPRB, 0.53595195E-09_JPRB, 0.53595367E-09_JPRB, 0.53595284E-09_JPRB, 0.53594706E-09_JPRB, &
  & 0.53594418E-09_JPRB, 0.53594001E-09_JPRB, 0.53593546E-09_JPRB, 0.53592830E-09_JPRB, 0.53593230E-09_JPRB, 0.53592397E-09_JPRB, &
  & 0.53591748E-09_JPRB, 0.53592186E-09_JPRB, 0.53591120E-09_JPRB, 0.53586635E-09_JPRB /)

RGHG6(:,80,12) = (/ &
  & 0.53590155E-09_JPRB, 0.53592053E-09_JPRB, 0.53591814E-09_JPRB, 0.53591914E-09_JPRB, 0.53592814E-09_JPRB, 0.53592331E-09_JPRB, &
  & 0.53592625E-09_JPRB, 0.53592569E-09_JPRB, 0.53593041E-09_JPRB, 0.53593319E-09_JPRB, 0.53593024E-09_JPRB, 0.53593258E-09_JPRB, &
  & 0.53593435E-09_JPRB, 0.53593818E-09_JPRB, 0.53593491E-09_JPRB, 0.53593258E-09_JPRB, 0.53593269E-09_JPRB, 0.53592653E-09_JPRB, &
  & 0.53593024E-09_JPRB, 0.53592997E-09_JPRB, 0.53593135E-09_JPRB, 0.53593852E-09_JPRB, 0.53594956E-09_JPRB, 0.53595783E-09_JPRB, &
  & 0.53596561E-09_JPRB, 0.53597227E-09_JPRB, 0.53598176E-09_JPRB, 0.53598753E-09_JPRB, 0.53599170E-09_JPRB, 0.53598986E-09_JPRB, &
  & 0.53599353E-09_JPRB, 0.53599025E-09_JPRB, 0.53598870E-09_JPRB, 0.53598237E-09_JPRB, 0.53598448E-09_JPRB, 0.53597587E-09_JPRB, &
  & 0.53597704E-09_JPRB, 0.53596660E-09_JPRB, 0.53595617E-09_JPRB, 0.53595500E-09_JPRB, 0.53594668E-09_JPRB, 0.53594268E-09_JPRB, &
  & 0.53594157E-09_JPRB, 0.53594967E-09_JPRB, 0.53595495E-09_JPRB, 0.53595506E-09_JPRB, 0.53595600E-09_JPRB, 0.53595817E-09_JPRB, &
  & 0.53595578E-09_JPRB, 0.53595961E-09_JPRB, 0.53596050E-09_JPRB, 0.53596294E-09_JPRB, 0.53596261E-09_JPRB, 0.53595683E-09_JPRB, &
  & 0.53595428E-09_JPRB, 0.53595051E-09_JPRB, 0.53594629E-09_JPRB, 0.53593918E-09_JPRB, 0.53594473E-09_JPRB, 0.53593641E-09_JPRB, &
  & 0.53593030E-09_JPRB, 0.53593752E-09_JPRB, 0.53593174E-09_JPRB, 0.53590521E-09_JPRB /)

RGHG6(:,81,12) = (/ &
  & 0.53592708E-09_JPRB, 0.53593019E-09_JPRB, 0.53592569E-09_JPRB, 0.53592619E-09_JPRB, 0.53593557E-09_JPRB, 0.53593030E-09_JPRB, &
  & 0.53593319E-09_JPRB, 0.53593247E-09_JPRB, 0.53593685E-09_JPRB, 0.53593979E-09_JPRB, 0.53593646E-09_JPRB, 0.53593879E-09_JPRB, &
  & 0.53594035E-09_JPRB, 0.53594451E-09_JPRB, 0.53594112E-09_JPRB, 0.53593890E-09_JPRB, 0.53593968E-09_JPRB, 0.53593358E-09_JPRB, &
  & 0.53593807E-09_JPRB, 0.53593774E-09_JPRB, 0.53593857E-09_JPRB, 0.53594518E-09_JPRB, 0.53595572E-09_JPRB, 0.53596294E-09_JPRB, &
  & 0.53596977E-09_JPRB, 0.53597549E-09_JPRB, 0.53598437E-09_JPRB, 0.53598975E-09_JPRB, 0.53599347E-09_JPRB, 0.53599097E-09_JPRB, &
  & 0.53599492E-09_JPRB, 0.53599125E-09_JPRB, 0.53598981E-09_JPRB, 0.53598331E-09_JPRB, 0.53598637E-09_JPRB, 0.53597804E-09_JPRB, &
  & 0.53598037E-09_JPRB, 0.53597049E-09_JPRB, 0.53596061E-09_JPRB, 0.53596028E-09_JPRB, 0.53595223E-09_JPRB, 0.53594840E-09_JPRB, &
  & 0.53594712E-09_JPRB, 0.53595567E-09_JPRB, 0.53596089E-09_JPRB, 0.53596017E-09_JPRB, 0.53596033E-09_JPRB, 0.53596211E-09_JPRB, &
  & 0.53595917E-09_JPRB, 0.53596316E-09_JPRB, 0.53596411E-09_JPRB, 0.53596699E-09_JPRB, 0.53596705E-09_JPRB, 0.53596105E-09_JPRB, &
  & 0.53595883E-09_JPRB, 0.53595500E-09_JPRB, 0.53595089E-09_JPRB, 0.53594373E-09_JPRB, 0.53595017E-09_JPRB, 0.53594157E-09_JPRB, &
  & 0.53593552E-09_JPRB, 0.53594434E-09_JPRB, 0.53594057E-09_JPRB, 0.53593163E-09_JPRB /)

RGHG6(:,82,12) = (/ &
  & 0.53592908E-09_JPRB, 0.53593341E-09_JPRB, 0.53592886E-09_JPRB, 0.53592947E-09_JPRB, 0.53593913E-09_JPRB, 0.53593358E-09_JPRB, &
  & 0.53593641E-09_JPRB, 0.53593552E-09_JPRB, 0.53594035E-09_JPRB, 0.53594318E-09_JPRB, 0.53593929E-09_JPRB, 0.53594168E-09_JPRB, &
  & 0.53594329E-09_JPRB, 0.53594762E-09_JPRB, 0.53594412E-09_JPRB, 0.53594196E-09_JPRB, 0.53594301E-09_JPRB, 0.53593696E-09_JPRB, &
  & 0.53594201E-09_JPRB, 0.53594151E-09_JPRB, 0.53594207E-09_JPRB, 0.53594862E-09_JPRB, 0.53595872E-09_JPRB, 0.53596538E-09_JPRB, &
  & 0.53597177E-09_JPRB, 0.53597710E-09_JPRB, 0.53598570E-09_JPRB, 0.53599086E-09_JPRB, 0.53599447E-09_JPRB, 0.53599158E-09_JPRB, &
  & 0.53599558E-09_JPRB, 0.53599170E-09_JPRB, 0.53599020E-09_JPRB, 0.53598381E-09_JPRB, 0.53598720E-09_JPRB, 0.53597926E-09_JPRB, &
  & 0.53598187E-09_JPRB, 0.53597243E-09_JPRB, 0.53596289E-09_JPRB, 0.53596283E-09_JPRB, 0.53595506E-09_JPRB, 0.53595117E-09_JPRB, &
  & 0.53594995E-09_JPRB, 0.53595872E-09_JPRB, 0.53596394E-09_JPRB, 0.53596277E-09_JPRB, 0.53596244E-09_JPRB, 0.53596388E-09_JPRB, &
  & 0.53596072E-09_JPRB, 0.53596483E-09_JPRB, 0.53596588E-09_JPRB, 0.53596910E-09_JPRB, 0.53596921E-09_JPRB, 0.53596305E-09_JPRB, &
  & 0.53596089E-09_JPRB, 0.53595717E-09_JPRB, 0.53595306E-09_JPRB, 0.53594579E-09_JPRB, 0.53595273E-09_JPRB, 0.53594401E-09_JPRB, &
  & 0.53593796E-09_JPRB, 0.53594729E-09_JPRB, 0.53594373E-09_JPRB, 0.53593369E-09_JPRB /)

RGHG6(:,83,12) = (/ &
  & 0.53593052E-09_JPRB, 0.53593541E-09_JPRB, 0.53593069E-09_JPRB, 0.53593124E-09_JPRB, 0.53594112E-09_JPRB, 0.53593535E-09_JPRB, &
  & 0.53593818E-09_JPRB, 0.53593735E-09_JPRB, 0.53594190E-09_JPRB, 0.53594490E-09_JPRB, 0.53594118E-09_JPRB, 0.53594346E-09_JPRB, &
  & 0.53594501E-09_JPRB, 0.53594928E-09_JPRB, 0.53594573E-09_JPRB, 0.53594362E-09_JPRB, 0.53594490E-09_JPRB, 0.53593885E-09_JPRB, &
  & 0.53594423E-09_JPRB, 0.53594362E-09_JPRB, 0.53594401E-09_JPRB, 0.53595023E-09_JPRB, 0.53596055E-09_JPRB, 0.53596694E-09_JPRB, &
  & 0.53597304E-09_JPRB, 0.53597793E-09_JPRB, 0.53598659E-09_JPRB, 0.53599147E-09_JPRB, 0.53599508E-09_JPRB, 0.53599181E-09_JPRB, &
  & 0.53599597E-09_JPRB, 0.53599192E-09_JPRB, 0.53599047E-09_JPRB, 0.53598415E-09_JPRB, 0.53598759E-09_JPRB, 0.53598009E-09_JPRB, &
  & 0.53598259E-09_JPRB, 0.53597354E-09_JPRB, 0.53596433E-09_JPRB, 0.53596422E-09_JPRB, 0.53595661E-09_JPRB, 0.53595284E-09_JPRB, &
  & 0.53595156E-09_JPRB, 0.53596039E-09_JPRB, 0.53596583E-09_JPRB, 0.53596427E-09_JPRB, 0.53596355E-09_JPRB, 0.53596499E-09_JPRB, &
  & 0.53596139E-09_JPRB, 0.53596577E-09_JPRB, 0.53596683E-09_JPRB, 0.53597027E-09_JPRB, 0.53597043E-09_JPRB, 0.53596416E-09_JPRB, &
  & 0.53596205E-09_JPRB, 0.53595828E-09_JPRB, 0.53595428E-09_JPRB, 0.53594684E-09_JPRB, 0.53595428E-09_JPRB, 0.53594540E-09_JPRB, &
  & 0.53593918E-09_JPRB, 0.53594906E-09_JPRB, 0.53594551E-09_JPRB, 0.53593507E-09_JPRB /)

RGHG6(:,84,12) = (/ &
  & 0.53593147E-09_JPRB, 0.53593668E-09_JPRB, 0.53593185E-09_JPRB, 0.53593241E-09_JPRB, 0.53594240E-09_JPRB, 0.53593646E-09_JPRB, &
  & 0.53593924E-09_JPRB, 0.53593840E-09_JPRB, 0.53594340E-09_JPRB, 0.53594584E-09_JPRB, 0.53594229E-09_JPRB, 0.53594429E-09_JPRB, &
  & 0.53594618E-09_JPRB, 0.53595017E-09_JPRB, 0.53594673E-09_JPRB, 0.53594473E-09_JPRB, 0.53594607E-09_JPRB, 0.53594001E-09_JPRB, &
  & 0.53594557E-09_JPRB, 0.53594496E-09_JPRB, 0.53594512E-09_JPRB, 0.53595162E-09_JPRB, 0.53596166E-09_JPRB, 0.53596777E-09_JPRB, &
  & 0.53597371E-09_JPRB, 0.53597854E-09_JPRB, 0.53598720E-09_JPRB, 0.53599203E-09_JPRB, 0.53599553E-09_JPRB, 0.53599197E-09_JPRB, &
  & 0.53599630E-09_JPRB, 0.53599203E-09_JPRB, 0.53599064E-09_JPRB, 0.53598415E-09_JPRB, 0.53598759E-09_JPRB, 0.53598048E-09_JPRB, &
  & 0.53598287E-09_JPRB, 0.53597415E-09_JPRB, 0.53596527E-09_JPRB, 0.53596494E-09_JPRB, 0.53595767E-09_JPRB, 0.53595373E-09_JPRB, &
  & 0.53595239E-09_JPRB, 0.53596161E-09_JPRB, 0.53596694E-09_JPRB, 0.53596533E-09_JPRB, 0.53596422E-09_JPRB, 0.53596549E-09_JPRB, &
  & 0.53596177E-09_JPRB, 0.53596622E-09_JPRB, 0.53596749E-09_JPRB, 0.53597110E-09_JPRB, 0.53597121E-09_JPRB, 0.53596494E-09_JPRB, &
  & 0.53596272E-09_JPRB, 0.53595900E-09_JPRB, 0.53595495E-09_JPRB, 0.53594745E-09_JPRB, 0.53595517E-09_JPRB, 0.53594618E-09_JPRB, &
  & 0.53593985E-09_JPRB, 0.53595017E-09_JPRB, 0.53594679E-09_JPRB, 0.53593602E-09_JPRB /)

RGHG6(:,85,12) = (/ &
  & 0.53593208E-09_JPRB, 0.53593752E-09_JPRB, 0.53593247E-09_JPRB, 0.53593291E-09_JPRB, 0.53594329E-09_JPRB, 0.53593718E-09_JPRB, &
  & 0.53593996E-09_JPRB, 0.53593957E-09_JPRB, 0.53594362E-09_JPRB, 0.53594590E-09_JPRB, 0.53594362E-09_JPRB, 0.53594523E-09_JPRB, &
  & 0.53594690E-09_JPRB, 0.53595040E-09_JPRB, 0.53594745E-09_JPRB, 0.53594545E-09_JPRB, 0.53594679E-09_JPRB, 0.53594090E-09_JPRB, &
  & 0.53594651E-09_JPRB, 0.53594584E-09_JPRB, 0.53594584E-09_JPRB, 0.53595212E-09_JPRB, 0.53596250E-09_JPRB, 0.53596844E-09_JPRB, &
  & 0.53597421E-09_JPRB, 0.53597882E-09_JPRB, 0.53598770E-09_JPRB, 0.53599247E-09_JPRB, 0.53599591E-09_JPRB, 0.53599220E-09_JPRB, &
  & 0.53599658E-09_JPRB, 0.53599214E-09_JPRB, 0.53599059E-09_JPRB, 0.53598409E-09_JPRB, 0.53598759E-09_JPRB, 0.53598076E-09_JPRB, &
  & 0.53598315E-09_JPRB, 0.53597471E-09_JPRB, 0.53596588E-09_JPRB, 0.53596572E-09_JPRB, 0.53595828E-09_JPRB, 0.53595445E-09_JPRB, &
  & 0.53595317E-09_JPRB, 0.53596222E-09_JPRB, 0.53596788E-09_JPRB, 0.53596599E-09_JPRB, 0.53596450E-09_JPRB, 0.53596577E-09_JPRB, &
  & 0.53596194E-09_JPRB, 0.53596649E-09_JPRB, 0.53596783E-09_JPRB, 0.53597154E-09_JPRB, 0.53597188E-09_JPRB, 0.53596538E-09_JPRB, &
  & 0.53596316E-09_JPRB, 0.53595939E-09_JPRB, 0.53595534E-09_JPRB, 0.53594779E-09_JPRB, 0.53595584E-09_JPRB, 0.53594673E-09_JPRB, &
  & 0.53594024E-09_JPRB, 0.53595089E-09_JPRB, 0.53594768E-09_JPRB, 0.53593679E-09_JPRB /)

RGHG6(:,86,12) = (/ &
  & 0.53593219E-09_JPRB, 0.53593813E-09_JPRB, 0.53593291E-09_JPRB, 0.53593313E-09_JPRB, 0.53594401E-09_JPRB, 0.53593785E-09_JPRB, &
  & 0.53594057E-09_JPRB, 0.53594063E-09_JPRB, 0.53594407E-09_JPRB, 0.53594584E-09_JPRB, 0.53594451E-09_JPRB, 0.53594573E-09_JPRB, &
  & 0.53594729E-09_JPRB, 0.53595006E-09_JPRB, 0.53594790E-09_JPRB, 0.53594618E-09_JPRB, 0.53594701E-09_JPRB, 0.53594168E-09_JPRB, &
  & 0.53594718E-09_JPRB, 0.53594645E-09_JPRB, 0.53594607E-09_JPRB, 0.53595250E-09_JPRB, 0.53596294E-09_JPRB, 0.53596877E-09_JPRB, &
  & 0.53597449E-09_JPRB, 0.53597898E-09_JPRB, 0.53598825E-09_JPRB, 0.53599292E-09_JPRB, 0.53599619E-09_JPRB, 0.53599208E-09_JPRB, &
  & 0.53599675E-09_JPRB, 0.53599225E-09_JPRB, 0.53599059E-09_JPRB, 0.53598415E-09_JPRB, 0.53598781E-09_JPRB, 0.53598093E-09_JPRB, &
  & 0.53598359E-09_JPRB, 0.53597510E-09_JPRB, 0.53596605E-09_JPRB, 0.53596627E-09_JPRB, 0.53595867E-09_JPRB, 0.53595456E-09_JPRB, &
  & 0.53595323E-09_JPRB, 0.53596316E-09_JPRB, 0.53596860E-09_JPRB, 0.53596638E-09_JPRB, 0.53596472E-09_JPRB, 0.53596605E-09_JPRB, &
  & 0.53596205E-09_JPRB, 0.53596660E-09_JPRB, 0.53596810E-09_JPRB, 0.53597199E-09_JPRB, 0.53597227E-09_JPRB, 0.53596572E-09_JPRB, &
  & 0.53596350E-09_JPRB, 0.53595961E-09_JPRB, 0.53595561E-09_JPRB, 0.53594795E-09_JPRB, 0.53595633E-09_JPRB, 0.53594706E-09_JPRB, &
  & 0.53594046E-09_JPRB, 0.53595151E-09_JPRB, 0.53594834E-09_JPRB, 0.53593729E-09_JPRB /)

RGHG6(:,87,12) = (/ &
  & 0.53593241E-09_JPRB, 0.53593852E-09_JPRB, 0.53593308E-09_JPRB, 0.53593324E-09_JPRB, 0.53594440E-09_JPRB, 0.53593813E-09_JPRB, &
  & 0.53594085E-09_JPRB, 0.53594129E-09_JPRB, 0.53594429E-09_JPRB, 0.53594573E-09_JPRB, 0.53594501E-09_JPRB, 0.53594612E-09_JPRB, &
  & 0.53594756E-09_JPRB, 0.53594962E-09_JPRB, 0.53594795E-09_JPRB, 0.53594656E-09_JPRB, 0.53594712E-09_JPRB, 0.53594218E-09_JPRB, &
  & 0.53594740E-09_JPRB, 0.53594679E-09_JPRB, 0.53594618E-09_JPRB, 0.53595239E-09_JPRB, 0.53596327E-09_JPRB, 0.53596899E-09_JPRB, &
  & 0.53597471E-09_JPRB, 0.53597904E-09_JPRB, 0.53598870E-09_JPRB, 0.53599331E-09_JPRB, 0.53599658E-09_JPRB, 0.53599220E-09_JPRB, &
  & 0.53599686E-09_JPRB, 0.53599225E-09_JPRB, 0.53599053E-09_JPRB, 0.53598392E-09_JPRB, 0.53598787E-09_JPRB, 0.53598093E-09_JPRB, &
  & 0.53598420E-09_JPRB, 0.53597543E-09_JPRB, 0.53596588E-09_JPRB, 0.53596688E-09_JPRB, 0.53595867E-09_JPRB, 0.53595461E-09_JPRB, &
  & 0.53595306E-09_JPRB, 0.53596350E-09_JPRB, 0.53596921E-09_JPRB, 0.53596688E-09_JPRB, 0.53596488E-09_JPRB, 0.53596616E-09_JPRB, &
  & 0.53596200E-09_JPRB, 0.53596660E-09_JPRB, 0.53596827E-09_JPRB, 0.53597227E-09_JPRB, 0.53597260E-09_JPRB, 0.53596588E-09_JPRB, &
  & 0.53596361E-09_JPRB, 0.53595961E-09_JPRB, 0.53595561E-09_JPRB, 0.53594795E-09_JPRB, 0.53595656E-09_JPRB, 0.53594729E-09_JPRB, &
  & 0.53594046E-09_JPRB, 0.53595189E-09_JPRB, 0.53594873E-09_JPRB, 0.53593757E-09_JPRB /)

RGHG6(:,88,12) = (/ &
  & 0.53593247E-09_JPRB, 0.53593857E-09_JPRB, 0.53593319E-09_JPRB, 0.53593324E-09_JPRB, 0.53594473E-09_JPRB, 0.53593840E-09_JPRB, &
  & 0.53594112E-09_JPRB, 0.53594168E-09_JPRB, 0.53594440E-09_JPRB, 0.53594595E-09_JPRB, 0.53594540E-09_JPRB, 0.53594645E-09_JPRB, &
  & 0.53594768E-09_JPRB, 0.53594962E-09_JPRB, 0.53594812E-09_JPRB, 0.53594673E-09_JPRB, 0.53594729E-09_JPRB, 0.53594246E-09_JPRB, &
  & 0.53594768E-09_JPRB, 0.53594690E-09_JPRB, 0.53594618E-09_JPRB, 0.53595256E-09_JPRB, 0.53596355E-09_JPRB, 0.53596921E-09_JPRB, &
  & 0.53597482E-09_JPRB, 0.53597904E-09_JPRB, 0.53598903E-09_JPRB, 0.53599358E-09_JPRB, 0.53599680E-09_JPRB, 0.53599214E-09_JPRB, &
  & 0.53599702E-09_JPRB, 0.53599220E-09_JPRB, 0.53599059E-09_JPRB, 0.53598376E-09_JPRB, 0.53598798E-09_JPRB, 0.53598087E-09_JPRB, &
  & 0.53598476E-09_JPRB, 0.53597565E-09_JPRB, 0.53596561E-09_JPRB, 0.53596744E-09_JPRB, 0.53595867E-09_JPRB, 0.53595450E-09_JPRB, &
  & 0.53595284E-09_JPRB, 0.53596400E-09_JPRB, 0.53596960E-09_JPRB, 0.53596699E-09_JPRB, 0.53596488E-09_JPRB, 0.53596616E-09_JPRB, &
  & 0.53596194E-09_JPRB, 0.53596655E-09_JPRB, 0.53596838E-09_JPRB, 0.53597254E-09_JPRB, 0.53597277E-09_JPRB, 0.53596599E-09_JPRB, &
  & 0.53596372E-09_JPRB, 0.53595967E-09_JPRB, 0.53595578E-09_JPRB, 0.53594795E-09_JPRB, 0.53595683E-09_JPRB, 0.53594740E-09_JPRB, &
  & 0.53594046E-09_JPRB, 0.53595206E-09_JPRB, 0.53594917E-09_JPRB, 0.53593779E-09_JPRB /)

RGHG6(:,89,12) = (/ &
  & 0.53593269E-09_JPRB, 0.53593857E-09_JPRB, 0.53593330E-09_JPRB, 0.53593319E-09_JPRB, 0.53594518E-09_JPRB, 0.53593813E-09_JPRB, &
  & 0.53594118E-09_JPRB, 0.53594140E-09_JPRB, 0.53594457E-09_JPRB, 0.53594612E-09_JPRB, 0.53594529E-09_JPRB, 0.53594629E-09_JPRB, &
  & 0.53594773E-09_JPRB, 0.53594984E-09_JPRB, 0.53594806E-09_JPRB, 0.53594673E-09_JPRB, 0.53594751E-09_JPRB, 0.53594229E-09_JPRB, &
  & 0.53594773E-09_JPRB, 0.53594701E-09_JPRB, 0.53594607E-09_JPRB, 0.53595250E-09_JPRB, 0.53596377E-09_JPRB, 0.53596927E-09_JPRB, &
  & 0.53597482E-09_JPRB, 0.53597887E-09_JPRB, 0.53598925E-09_JPRB, 0.53599375E-09_JPRB, 0.53599708E-09_JPRB, 0.53599203E-09_JPRB, &
  & 0.53599702E-09_JPRB, 0.53599214E-09_JPRB, 0.53599059E-09_JPRB, 0.53598359E-09_JPRB, 0.53598831E-09_JPRB, 0.53598070E-09_JPRB, &
  & 0.53598531E-09_JPRB, 0.53597582E-09_JPRB, 0.53596527E-09_JPRB, 0.53596799E-09_JPRB, 0.53595867E-09_JPRB, 0.53595439E-09_JPRB, &
  & 0.53595273E-09_JPRB, 0.53596427E-09_JPRB, 0.53596999E-09_JPRB, 0.53596716E-09_JPRB, 0.53596494E-09_JPRB, 0.53596622E-09_JPRB, &
  & 0.53596166E-09_JPRB, 0.53596644E-09_JPRB, 0.53596838E-09_JPRB, 0.53597266E-09_JPRB, 0.53597299E-09_JPRB, 0.53596605E-09_JPRB, &
  & 0.53596383E-09_JPRB, 0.53595978E-09_JPRB, 0.53595584E-09_JPRB, 0.53594790E-09_JPRB, 0.53595717E-09_JPRB, 0.53594745E-09_JPRB, &
  & 0.53594040E-09_JPRB, 0.53595239E-09_JPRB, 0.53594928E-09_JPRB, 0.53593779E-09_JPRB /)

RGHG6(:,90,12) = (/ &
  & 0.53593296E-09_JPRB, 0.53593868E-09_JPRB, 0.53593335E-09_JPRB, 0.53593269E-09_JPRB, 0.53594590E-09_JPRB, 0.53593763E-09_JPRB, &
  & 0.53594118E-09_JPRB, 0.53594074E-09_JPRB, 0.53594451E-09_JPRB, 0.53594668E-09_JPRB, 0.53594496E-09_JPRB, 0.53594629E-09_JPRB, &
  & 0.53594795E-09_JPRB, 0.53595089E-09_JPRB, 0.53594817E-09_JPRB, 0.53594651E-09_JPRB, 0.53594795E-09_JPRB, 0.53594168E-09_JPRB, &
  & 0.53594817E-09_JPRB, 0.53594706E-09_JPRB, 0.53594590E-09_JPRB, 0.53595234E-09_JPRB, 0.53596394E-09_JPRB, 0.53596927E-09_JPRB, &
  & 0.53597493E-09_JPRB, 0.53597882E-09_JPRB, 0.53598948E-09_JPRB, 0.53599403E-09_JPRB, 0.53599752E-09_JPRB, 0.53599181E-09_JPRB, &
  & 0.53599747E-09_JPRB, 0.53599214E-09_JPRB, 0.53599081E-09_JPRB, 0.53598304E-09_JPRB, 0.53598886E-09_JPRB, 0.53598020E-09_JPRB, &
  & 0.53598603E-09_JPRB, 0.53597599E-09_JPRB, 0.53596483E-09_JPRB, 0.53596827E-09_JPRB, 0.53595861E-09_JPRB, 0.53595428E-09_JPRB, &
  & 0.53595239E-09_JPRB, 0.53596455E-09_JPRB, 0.53597038E-09_JPRB, 0.53596722E-09_JPRB, 0.53596488E-09_JPRB, 0.53596633E-09_JPRB, &
  & 0.53596139E-09_JPRB, 0.53596649E-09_JPRB, 0.53596838E-09_JPRB, 0.53597293E-09_JPRB, 0.53597327E-09_JPRB, 0.53596594E-09_JPRB, &
  & 0.53596372E-09_JPRB, 0.53595978E-09_JPRB, 0.53595600E-09_JPRB, 0.53594756E-09_JPRB, 0.53595772E-09_JPRB, 0.53594734E-09_JPRB, &
  & 0.53593990E-09_JPRB, 0.53595289E-09_JPRB, 0.53594951E-09_JPRB, 0.53593774E-09_JPRB /)

RGHG6(:,91,12) = (/ &
  & 0.53593358E-09_JPRB, 0.53593890E-09_JPRB, 0.53593296E-09_JPRB, 0.53593169E-09_JPRB, 0.53594751E-09_JPRB, 0.53593641E-09_JPRB, &
  & 0.53594185E-09_JPRB, 0.53593857E-09_JPRB, 0.53594490E-09_JPRB, 0.53594984E-09_JPRB, 0.53594229E-09_JPRB, 0.53594607E-09_JPRB, &
  & 0.53594768E-09_JPRB, 0.53595339E-09_JPRB, 0.53594773E-09_JPRB, 0.53594595E-09_JPRB, 0.53594906E-09_JPRB, 0.53594007E-09_JPRB, &
  & 0.53594890E-09_JPRB, 0.53594712E-09_JPRB, 0.53594523E-09_JPRB, 0.53595200E-09_JPRB, 0.53596450E-09_JPRB, 0.53596932E-09_JPRB, &
  & 0.53597510E-09_JPRB, 0.53597826E-09_JPRB, 0.53598997E-09_JPRB, 0.53599408E-09_JPRB, 0.53599808E-09_JPRB, 0.53599103E-09_JPRB, &
  & 0.53599825E-09_JPRB, 0.53599192E-09_JPRB, 0.53599153E-09_JPRB, 0.53598159E-09_JPRB, 0.53599014E-09_JPRB, 0.53597876E-09_JPRB, &
  & 0.53598787E-09_JPRB, 0.53597582E-09_JPRB, 0.53596372E-09_JPRB, 0.53596932E-09_JPRB, 0.53595833E-09_JPRB, 0.53595395E-09_JPRB, &
  & 0.53595145E-09_JPRB, 0.53596494E-09_JPRB, 0.53597105E-09_JPRB, 0.53596716E-09_JPRB, 0.53596466E-09_JPRB, 0.53596672E-09_JPRB, &
  & 0.53596072E-09_JPRB, 0.53596672E-09_JPRB, 0.53596821E-09_JPRB, 0.53597315E-09_JPRB, 0.53597365E-09_JPRB, 0.53596555E-09_JPRB, &
  & 0.53596394E-09_JPRB, 0.53595983E-09_JPRB, 0.53595617E-09_JPRB, 0.53594634E-09_JPRB, 0.53595911E-09_JPRB, 0.53594712E-09_JPRB, &
  & 0.53593868E-09_JPRB, 0.53595389E-09_JPRB, 0.53594945E-09_JPRB, 0.53593735E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C12CLIM:PART24',1,ZHOOK_HANDLE)
END SUBROUTINE PART24

END SUBROUTINE SU_C12CLIM
