!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0 
SUBROUTINE SU_C22CLIM


!**   HCFC22 FROM D.CARIOLLE 2D MODEL* 

!     PURPOSE.
!     --------

!**   INTERFACE.
!     ----------
!        CALL *SU_C22CLIM* FROM *SU_GHGCLIM*

!        EXPLICIT ARGUMENTS :
!        --------------------
!     ==== INPUTS ===
!     ==== OUTPUTS ===

!        IMPLICIT ARGUMENTS :   NONE
!        --------------------

!     METHOD.
!     -------

!     EXTERNALS.
!     ----------

!          NONE

!     REFERENCE.
!     ----------

!        SEE RADIATION'S PART OF THE MODEL'S DOCUMENTATION AND
!        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE "I.F.S"

!     AUTHOR.
!     -------
!     J.-J. MORCRETTE  E.C.M.W.F.    20080423

!     MODIFICATIONS.
!     --------------
!        Same history as suecaesu
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     R. Elkhatib 12-10-2005 Split for faster and more robust compilation.

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCLIM   ,ONLY : RGHG8

IMPLICIT NONE

!     -----------------------------------------------------------------

!*       0.1   ARGUMENTS.
!              ----------
! REAL(KIND=JPRB),INTENT(OUT) :: PCLC22(64,91,12)

!     ----------------------------------------------------------------- 

!*       0.2   LOCAL ARRAYS.
!              -------------

! REAL(KIND=JPRB),SAVE :: ZGHG7(64,91,12)

LOGICAL,SAVE :: LLFIRSTCALL = .TRUE.

REAL(KIND=JPRB) :: ZHOOK_HANDLE
!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM',0,ZHOOK_HANDLE)

IF(LLFIRSTCALL) THEN

  ALLOCATE(RGHG8(64,91,12))

  CALL PART1
  CALL PART2
  CALL PART3
  CALL PART4
  CALL PART5
  CALL PART6
  CALL PART7
  CALL PART8
  CALL PART9
  CALL PART10
  CALL PART11
  CALL PART12
  CALL PART13
  CALL PART14
  CALL PART15
  CALL PART16
  CALL PART17
  CALL PART18
  CALL PART19
  CALL PART20
  CALL PART21
  CALL PART22
  CALL PART23
  CALL PART24

ENDIF

! PCLC22(:,:,:)=ZGHG7(:,:,:)

!     ------------------------------------------------------------------

LLFIRSTCALL = .FALSE.

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM',1,ZHOOK_HANDLE)

!-----------------------------------------------------------------------------

CONTAINS

SUBROUTINE PART1
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART1',0,ZHOOK_HANDLE)



!-- Month=  1 ------------

RGHG8(:, 1, 1) = (/ &
  & 0.36211326E-10_JPRB, 0.36358975E-10_JPRB, 0.36430758E-10_JPRB, 0.36486217E-10_JPRB, 0.36532471E-10_JPRB, 0.36573237E-10_JPRB, &
  & 0.36612168E-10_JPRB, 0.36656820E-10_JPRB, 0.36704206E-10_JPRB, 0.36749607E-10_JPRB, 0.36796184E-10_JPRB, 0.36841429E-10_JPRB, &
  & 0.36892003E-10_JPRB, 0.36947514E-10_JPRB, 0.37008955E-10_JPRB, 0.37079610E-10_JPRB, 0.37158703E-10_JPRB, 0.37245217E-10_JPRB, &
  & 0.37331697E-10_JPRB, 0.37414356E-10_JPRB, 0.37485681E-10_JPRB, 0.37541970E-10_JPRB, 0.37583912E-10_JPRB, 0.37614849E-10_JPRB, &
  & 0.37637365E-10_JPRB, 0.37655528E-10_JPRB, 0.37671859E-10_JPRB, 0.37687655E-10_JPRB, 0.37701647E-10_JPRB, 0.37714335E-10_JPRB, &
  & 0.37726273E-10_JPRB, 0.37737983E-10_JPRB, 0.37746868E-10_JPRB, 0.37756170E-10_JPRB, 0.37766359E-10_JPRB, 0.37778568E-10_JPRB, &
  & 0.37794004E-10_JPRB, 0.37814474E-10_JPRB, 0.37841560E-10_JPRB, 0.37872275E-10_JPRB, 0.37900752E-10_JPRB, 0.37927928E-10_JPRB, &
  & 0.37951173E-10_JPRB, 0.37969565E-10_JPRB, 0.37981601E-10_JPRB, 0.37985500E-10_JPRB, 0.37979838E-10_JPRB, 0.37966887E-10_JPRB, &
  & 0.37947825E-10_JPRB, 0.37925416E-10_JPRB, 0.37902927E-10_JPRB, 0.37884744E-10_JPRB, 0.37872969E-10_JPRB, 0.37868403E-10_JPRB, &
  & 0.37870776E-10_JPRB, 0.37877944E-10_JPRB, 0.37887027E-10_JPRB, 0.37895957E-10_JPRB, 0.37903920E-10_JPRB, 0.37910522E-10_JPRB, &
  & 0.37916219E-10_JPRB, 0.37921159E-10_JPRB, 0.37925336E-10_JPRB, 0.37928785E-10_JPRB /)

RGHG8(:, 2, 1) = (/ &
  & 0.36287532E-10_JPRB, 0.36469088E-10_JPRB, 0.36579594E-10_JPRB, 0.36655543E-10_JPRB, 0.36719079E-10_JPRB, 0.36774916E-10_JPRB, &
  & 0.36826316E-10_JPRB, 0.36875343E-10_JPRB, 0.36926007E-10_JPRB, 0.36977102E-10_JPRB, 0.37037269E-10_JPRB, 0.37110166E-10_JPRB, &
  & 0.37200892E-10_JPRB, 0.37317122E-10_JPRB, 0.37460472E-10_JPRB, 0.37632945E-10_JPRB, 0.37824185E-10_JPRB, 0.38019768E-10_JPRB, &
  & 0.38197639E-10_JPRB, 0.38341982E-10_JPRB, 0.38443318E-10_JPRB, 0.38503228E-10_JPRB, 0.38530412E-10_JPRB, 0.38534710E-10_JPRB, &
  & 0.38523254E-10_JPRB, 0.38502666E-10_JPRB, 0.38474210E-10_JPRB, 0.38439751E-10_JPRB, 0.38403017E-10_JPRB, 0.38367295E-10_JPRB, &
  & 0.38334294E-10_JPRB, 0.38304533E-10_JPRB, 0.38276951E-10_JPRB, 0.38254767E-10_JPRB, 0.38239668E-10_JPRB, 0.38234072E-10_JPRB, &
  & 0.38240473E-10_JPRB, 0.38261564E-10_JPRB, 0.38297986E-10_JPRB, 0.38343852E-10_JPRB, 0.38388737E-10_JPRB, 0.38425461E-10_JPRB, &
  & 0.38446808E-10_JPRB, 0.38449795E-10_JPRB, 0.38434429E-10_JPRB, 0.38404287E-10_JPRB, 0.38366525E-10_JPRB, 0.38330374E-10_JPRB, &
  & 0.38300862E-10_JPRB, 0.38277395E-10_JPRB, 0.38255017E-10_JPRB, 0.38230086E-10_JPRB, 0.38202524E-10_JPRB, 0.38175622E-10_JPRB, &
  & 0.38152870E-10_JPRB, 0.38135734E-10_JPRB, 0.38124164E-10_JPRB, 0.38117447E-10_JPRB, 0.38114886E-10_JPRB, 0.38115865E-10_JPRB, &
  & 0.38119688E-10_JPRB, 0.38124469E-10_JPRB, 0.38130114E-10_JPRB, 0.38138888E-10_JPRB /)

RGHG8(:, 3, 1) = (/ &
  & 0.36228350E-10_JPRB, 0.36443886E-10_JPRB, 0.36572183E-10_JPRB, 0.36674913E-10_JPRB, 0.36763453E-10_JPRB, 0.36845089E-10_JPRB, &
  & 0.36924467E-10_JPRB, 0.37001131E-10_JPRB, 0.37078042E-10_JPRB, 0.37165347E-10_JPRB, 0.37267970E-10_JPRB, 0.37400465E-10_JPRB, &
  & 0.37572199E-10_JPRB, 0.37782891E-10_JPRB, 0.38032785E-10_JPRB, 0.38307645E-10_JPRB, 0.38591633E-10_JPRB, 0.38861716E-10_JPRB, &
  & 0.39095251E-10_JPRB, 0.39280003E-10_JPRB, 0.39409885E-10_JPRB, 0.39488489E-10_JPRB, 0.39526528E-10_JPRB, 0.39535694E-10_JPRB, &
  & 0.39524536E-10_JPRB, 0.39500403E-10_JPRB, 0.39466534E-10_JPRB, 0.39424346E-10_JPRB, 0.39376342E-10_JPRB, 0.39324644E-10_JPRB, &
  & 0.39270424E-10_JPRB, 0.39214430E-10_JPRB, 0.39157223E-10_JPRB, 0.39105347E-10_JPRB, 0.39065983E-10_JPRB, 0.39047356E-10_JPRB, &
  & 0.39056015E-10_JPRB, 0.39094714E-10_JPRB, 0.39160022E-10_JPRB, 0.39239660E-10_JPRB, 0.39313261E-10_JPRB, 0.39362836E-10_JPRB, &
  & 0.39374497E-10_JPRB, 0.39345017E-10_JPRB, 0.39278445E-10_JPRB, 0.39182976E-10_JPRB, 0.39069435E-10_JPRB, 0.38949580E-10_JPRB, &
  & 0.38830668E-10_JPRB, 0.38716655E-10_JPRB, 0.38612467E-10_JPRB, 0.38525530E-10_JPRB, 0.38459104E-10_JPRB, 0.38410490E-10_JPRB, &
  & 0.38376042E-10_JPRB, 0.38353917E-10_JPRB, 0.38342503E-10_JPRB, 0.38338901E-10_JPRB, 0.38340553E-10_JPRB, 0.38345233E-10_JPRB, &
  & 0.38351444E-10_JPRB, 0.38359212E-10_JPRB, 0.38368603E-10_JPRB, 0.38385600E-10_JPRB /)

RGHG8(:, 4, 1) = (/ &
  & 0.36090329E-10_JPRB, 0.36300438E-10_JPRB, 0.36430227E-10_JPRB, 0.36544788E-10_JPRB, 0.36654457E-10_JPRB, 0.36763651E-10_JPRB, &
  & 0.36879201E-10_JPRB, 0.36999688E-10_JPRB, 0.37132700E-10_JPRB, 0.37285775E-10_JPRB, 0.37470221E-10_JPRB, 0.37697661E-10_JPRB, &
  & 0.37973534E-10_JPRB, 0.38292904E-10_JPRB, 0.38636368E-10_JPRB, 0.38990495E-10_JPRB, 0.39335656E-10_JPRB, 0.39656979E-10_JPRB, &
  & 0.39935878E-10_JPRB, 0.40163504E-10_JPRB, 0.40336897E-10_JPRB, 0.40458574E-10_JPRB, 0.40537861E-10_JPRB, 0.40585126E-10_JPRB, &
  & 0.40608666E-10_JPRB, 0.40616788E-10_JPRB, 0.40611969E-10_JPRB, 0.40593390E-10_JPRB, 0.40560201E-10_JPRB, 0.40512357E-10_JPRB, &
  & 0.40451694E-10_JPRB, 0.40380952E-10_JPRB, 0.40303864E-10_JPRB, 0.40233487E-10_JPRB, 0.40184123E-10_JPRB, 0.40169222E-10_JPRB, &
  & 0.40197300E-10_JPRB, 0.40270721E-10_JPRB, 0.40381302E-10_JPRB, 0.40505564E-10_JPRB, 0.40606581E-10_JPRB, 0.40650254E-10_JPRB, &
  & 0.40620094E-10_JPRB, 0.40523116E-10_JPRB, 0.40376501E-10_JPRB, 0.40198997E-10_JPRB, 0.40007067E-10_JPRB, 0.39813021E-10_JPRB, &
  & 0.39622642E-10_JPRB, 0.39439434E-10_JPRB, 0.39268363E-10_JPRB, 0.39113560E-10_JPRB, 0.38975691E-10_JPRB, 0.38857730E-10_JPRB, &
  & 0.38764908E-10_JPRB, 0.38698766E-10_JPRB, 0.38656495E-10_JPRB, 0.38632320E-10_JPRB, 0.38621745E-10_JPRB, 0.38621099E-10_JPRB, &
  & 0.38627608E-10_JPRB, 0.38637923E-10_JPRB, 0.38652078E-10_JPRB, 0.38676309E-10_JPRB /)

RGHG8(:, 5, 1) = (/ &
  & 0.35902878E-10_JPRB, 0.36078113E-10_JPRB, 0.36198607E-10_JPRB, 0.36316054E-10_JPRB, 0.36440403E-10_JPRB, 0.36581675E-10_JPRB, &
  & 0.36745627E-10_JPRB, 0.36933658E-10_JPRB, 0.37149877E-10_JPRB, 0.37411893E-10_JPRB, 0.37727745E-10_JPRB, 0.38091641E-10_JPRB, &
  & 0.38496494E-10_JPRB, 0.38925408E-10_JPRB, 0.39366725E-10_JPRB, 0.39805090E-10_JPRB, 0.40226246E-10_JPRB, 0.40616344E-10_JPRB, &
  & 0.40964104E-10_JPRB, 0.41265814E-10_JPRB, 0.41518504E-10_JPRB, 0.41726587E-10_JPRB, 0.41893711E-10_JPRB, 0.42028044E-10_JPRB, &
  & 0.42135212E-10_JPRB, 0.42222177E-10_JPRB, 0.42291014E-10_JPRB, 0.42337654E-10_JPRB, 0.42355904E-10_JPRB, 0.42341450E-10_JPRB, &
  & 0.42295532E-10_JPRB, 0.42225345E-10_JPRB, 0.42142581E-10_JPRB, 0.42067513E-10_JPRB, 0.42021289E-10_JPRB, 0.42022615E-10_JPRB, &
  & 0.42083930E-10_JPRB, 0.42203463E-10_JPRB, 0.42360497E-10_JPRB, 0.42509305E-10_JPRB, 0.42584807E-10_JPRB, 0.42540922E-10_JPRB, &
  & 0.42377969E-10_JPRB, 0.42132312E-10_JPRB, 0.41844146E-10_JPRB, 0.41544001E-10_JPRB, 0.41249212E-10_JPRB, 0.40965668E-10_JPRB, &
  & 0.40691429E-10_JPRB, 0.40425680E-10_JPRB, 0.40171484E-10_JPRB, 0.39932578E-10_JPRB, 0.39713809E-10_JPRB, 0.39521796E-10_JPRB, &
  & 0.39361181E-10_JPRB, 0.39234935E-10_JPRB, 0.39144514E-10_JPRB, 0.39085700E-10_JPRB, 0.39052886E-10_JPRB, 0.39039084E-10_JPRB, &
  & 0.39037166E-10_JPRB, 0.39043692E-10_JPRB, 0.39057299E-10_JPRB, 0.39088878E-10_JPRB /)

RGHG8(:, 6, 1) = (/ &
  & 0.35724444E-10_JPRB, 0.35855183E-10_JPRB, 0.35969172E-10_JPRB, 0.36099044E-10_JPRB, 0.36255405E-10_JPRB, 0.36447820E-10_JPRB, &
  & 0.36687979E-10_JPRB, 0.36974854E-10_JPRB, 0.37321028E-10_JPRB, 0.37723880E-10_JPRB, 0.38192512E-10_JPRB, 0.38715392E-10_JPRB, &
  & 0.39272363E-10_JPRB, 0.39842570E-10_JPRB, 0.40407497E-10_JPRB, 0.40959340E-10_JPRB, 0.41490075E-10_JPRB, 0.41989540E-10_JPRB, &
  & 0.42452711E-10_JPRB, 0.42882583E-10_JPRB, 0.43282215E-10_JPRB, 0.43653747E-10_JPRB, 0.43998024E-10_JPRB, 0.44311426E-10_JPRB, &
  & 0.44594581E-10_JPRB, 0.44848267E-10_JPRB, 0.45071783E-10_JPRB, 0.45261742E-10_JPRB, 0.45405055E-10_JPRB, 0.45494494E-10_JPRB, &
  & 0.45527585E-10_JPRB, 0.45512771E-10_JPRB, 0.45466624E-10_JPRB, 0.45416691E-10_JPRB, 0.45388492E-10_JPRB, 0.45400021E-10_JPRB, &
  & 0.45458109E-10_JPRB, 0.45551646E-10_JPRB, 0.45642538E-10_JPRB, 0.45659837E-10_JPRB, 0.45524057E-10_JPRB, 0.45212743E-10_JPRB, &
  & 0.44777022E-10_JPRB, 0.44291879E-10_JPRB, 0.43809824E-10_JPRB, 0.43353703E-10_JPRB, 0.42927148E-10_JPRB, 0.42523422E-10_JPRB, &
  & 0.42134071E-10_JPRB, 0.41757407E-10_JPRB, 0.41395182E-10_JPRB, 0.41050646E-10_JPRB, 0.40730246E-10_JPRB, 0.40441955E-10_JPRB, &
  & 0.40193862E-10_JPRB, 0.39993467E-10_JPRB, 0.39842851E-10_JPRB, 0.39737418E-10_JPRB, 0.39670378E-10_JPRB, 0.39632492E-10_JPRB, &
  & 0.39614811E-10_JPRB, 0.39610402E-10_JPRB, 0.39614870E-10_JPRB, 0.39632388E-10_JPRB /)

RGHG8(:, 7, 1) = (/ &
  & 0.35601667E-10_JPRB, 0.35749757E-10_JPRB, 0.35891370E-10_JPRB, 0.36064714E-10_JPRB, 0.36280975E-10_JPRB, 0.36552608E-10_JPRB, &
  & 0.36895809E-10_JPRB, 0.37316303E-10_JPRB, 0.37815313E-10_JPRB, 0.38404665E-10_JPRB, 0.39068679E-10_JPRB, 0.39787514E-10_JPRB, &
  & 0.40536893E-10_JPRB, 0.41301303E-10_JPRB, 0.42061007E-10_JPRB, 0.42798320E-10_JPRB, 0.43504686E-10_JPRB, 0.44179670E-10_JPRB, &
  & 0.44822996E-10_JPRB, 0.45443278E-10_JPRB, 0.46049133E-10_JPRB, 0.46646676E-10_JPRB, 0.47233842E-10_JPRB, 0.47799147E-10_JPRB, &
  & 0.48333108E-10_JPRB, 0.48833694E-10_JPRB, 0.49301466E-10_JPRB, 0.49734567E-10_JPRB, 0.50129022E-10_JPRB, 0.50470867E-10_JPRB, &
  & 0.50751767E-10_JPRB, 0.50964045E-10_JPRB, 0.51103406E-10_JPRB, 0.51175481E-10_JPRB, 0.51187058E-10_JPRB, 0.51143652E-10_JPRB, &
  & 0.51045966E-10_JPRB, 0.50879981E-10_JPRB, 0.50606182E-10_JPRB, 0.50157309E-10_JPRB, 0.49488396E-10_JPRB, 0.48641986E-10_JPRB, &
  & 0.47743032E-10_JPRB, 0.46900182E-10_JPRB, 0.46158438E-10_JPRB, 0.45514495E-10_JPRB, 0.44942345E-10_JPRB, 0.44412630E-10_JPRB, &
  & 0.43906434E-10_JPRB, 0.43415181E-10_JPRB, 0.42934038E-10_JPRB, 0.42466718E-10_JPRB, 0.42024502E-10_JPRB, 0.41620547E-10_JPRB, &
  & 0.41268267E-10_JPRB, 0.40976732E-10_JPRB, 0.40750590E-10_JPRB, 0.40586933E-10_JPRB, 0.40477025E-10_JPRB, 0.40408909E-10_JPRB, &
  & 0.40368653E-10_JPRB, 0.40347316E-10_JPRB, 0.40337289E-10_JPRB, 0.40344113E-10_JPRB /)

RGHG8(:, 8, 1) = (/ &
  & 0.35844230E-10_JPRB, 0.36003190E-10_JPRB, 0.36204362E-10_JPRB, 0.36452098E-10_JPRB, 0.36770812E-10_JPRB, 0.37171353E-10_JPRB, &
  & 0.37673989E-10_JPRB, 0.38271095E-10_JPRB, 0.38970570E-10_JPRB, 0.39768480E-10_JPRB, 0.40676525E-10_JPRB, 0.41666892E-10_JPRB, &
  & 0.42709516E-10_JPRB, 0.43768263E-10_JPRB, 0.44821733E-10_JPRB, 0.45856357E-10_JPRB, 0.46860859E-10_JPRB, 0.47831409E-10_JPRB, &
  & 0.48773711E-10_JPRB, 0.49699703E-10_JPRB, 0.50618051E-10_JPRB, 0.51528871E-10_JPRB, 0.52429595E-10_JPRB, 0.53300843E-10_JPRB, &
  & 0.54127931E-10_JPRB, 0.54905407E-10_JPRB, 0.55645641E-10_JPRB, 0.56360795E-10_JPRB, 0.57051461E-10_JPRB, 0.57708831E-10_JPRB, &
  & 0.58300149E-10_JPRB, 0.58782222E-10_JPRB, 0.59101113E-10_JPRB, 0.59214147E-10_JPRB, 0.59092772E-10_JPRB, 0.58733074E-10_JPRB, &
  & 0.58160879E-10_JPRB, 0.57396834E-10_JPRB, 0.56431047E-10_JPRB, 0.55231753E-10_JPRB, 0.53786583E-10_JPRB, 0.52222716E-10_JPRB, &
  & 0.50756978E-10_JPRB, 0.49523170E-10_JPRB, 0.48527890E-10_JPRB, 0.47710953E-10_JPRB, 0.47006305E-10_JPRB, 0.46367910E-10_JPRB, &
  & 0.45768202E-10_JPRB, 0.45184273E-10_JPRB, 0.44602939E-10_JPRB, 0.44028850E-10_JPRB, 0.43474394E-10_JPRB, 0.42957003E-10_JPRB, &
  & 0.42493741E-10_JPRB, 0.42100941E-10_JPRB, 0.41787240E-10_JPRB, 0.41553639E-10_JPRB, 0.41390592E-10_JPRB, 0.41283230E-10_JPRB, &
  & 0.41212832E-10_JPRB, 0.41164808E-10_JPRB, 0.41129228E-10_JPRB, 0.41096276E-10_JPRB /)

RGHG8(:, 9, 1) = (/ &
  & 0.37118975E-10_JPRB, 0.37394986E-10_JPRB, 0.37648735E-10_JPRB, 0.37954084E-10_JPRB, 0.38355256E-10_JPRB, 0.38874064E-10_JPRB, &
  & 0.39531323E-10_JPRB, 0.40323876E-10_JPRB, 0.41241205E-10_JPRB, 0.42295653E-10_JPRB, 0.43477486E-10_JPRB, 0.44778226E-10_JPRB, &
  & 0.46171334E-10_JPRB, 0.47622840E-10_JPRB, 0.49089600E-10_JPRB, 0.50546119E-10_JPRB, 0.51979886E-10_JPRB, 0.53382156E-10_JPRB, &
  & 0.54750100E-10_JPRB, 0.56086576E-10_JPRB, 0.57401181E-10_JPRB, 0.58683162E-10_JPRB, 0.59913706E-10_JPRB, 0.61076304E-10_JPRB, &
  & 0.62150132E-10_JPRB, 0.63136656E-10_JPRB, 0.64059431E-10_JPRB, 0.64942586E-10_JPRB, 0.65793898E-10_JPRB, 0.66587791E-10_JPRB, &
  & 0.67263910E-10_JPRB, 0.67731737E-10_JPRB, 0.67890214E-10_JPRB, 0.67661550E-10_JPRB, 0.67013575E-10_JPRB, 0.65992344E-10_JPRB, &
  & 0.64685257E-10_JPRB, 0.63177935E-10_JPRB, 0.61490257E-10_JPRB, 0.59578266E-10_JPRB, 0.57448490E-10_JPRB, 0.55275083E-10_JPRB, &
  & 0.53335135E-10_JPRB, 0.51777665E-10_JPRB, 0.50562551E-10_JPRB, 0.49592812E-10_JPRB, 0.48785320E-10_JPRB, 0.48080102E-10_JPRB, &
  & 0.47424495E-10_JPRB, 0.46780427E-10_JPRB, 0.46136289E-10_JPRB, 0.45493123E-10_JPRB, 0.44859907E-10_JPRB, 0.44254704E-10_JPRB, &
  & 0.43700227E-10_JPRB, 0.43216070E-10_JPRB, 0.42820993E-10_JPRB, 0.42521861E-10_JPRB, 0.42313299E-10_JPRB, 0.42172231E-10_JPRB, &
  & 0.42078910E-10_JPRB, 0.42014371E-10_JPRB, 0.41963669E-10_JPRB, 0.41902395E-10_JPRB /)

RGHG8(:,10, 1) = (/ &
  & 0.41283321E-10_JPRB, 0.41390655E-10_JPRB, 0.41455384E-10_JPRB, 0.41675528E-10_JPRB, 0.41994144E-10_JPRB, 0.42487902E-10_JPRB, &
  & 0.43181403E-10_JPRB, 0.44066233E-10_JPRB, 0.45135617E-10_JPRB, 0.46394215E-10_JPRB, 0.47845054E-10_JPRB, 0.49465602E-10_JPRB, &
  & 0.51219886E-10_JPRB, 0.53076869E-10_JPRB, 0.55005861E-10_JPRB, 0.56966858E-10_JPRB, 0.58927488E-10_JPRB, 0.60861656E-10_JPRB, &
  & 0.62753976E-10_JPRB, 0.64585448E-10_JPRB, 0.66339927E-10_JPRB, 0.68003096E-10_JPRB, 0.69546403E-10_JPRB, 0.70930983E-10_JPRB, &
  & 0.72159549E-10_JPRB, 0.73225738E-10_JPRB, 0.74159810E-10_JPRB, 0.74985809E-10_JPRB, 0.75698836E-10_JPRB, 0.76260387E-10_JPRB, &
  & 0.76582768E-10_JPRB, 0.76554207E-10_JPRB, 0.76058909E-10_JPRB, 0.75023696E-10_JPRB, 0.73471132E-10_JPRB, 0.71535652E-10_JPRB, &
  & 0.69411150E-10_JPRB, 0.67211195E-10_JPRB, 0.64952127E-10_JPRB, 0.62579178E-10_JPRB, 0.60083605E-10_JPRB, 0.57590533E-10_JPRB, &
  & 0.55333644E-10_JPRB, 0.53489393E-10_JPRB, 0.52079795E-10_JPRB, 0.51005481E-10_JPRB, 0.50149076E-10_JPRB, 0.49409296E-10_JPRB, &
  & 0.48719580E-10_JPRB, 0.48049592E-10_JPRB, 0.47379899E-10_JPRB, 0.46701459E-10_JPRB, 0.46023216E-10_JPRB, 0.45364847E-10_JPRB, &
  & 0.44748715E-10_JPRB, 0.44205882E-10_JPRB, 0.43760245E-10_JPRB, 0.43428552E-10_JPRB, 0.43195246E-10_JPRB, 0.43043513E-10_JPRB, &
  & 0.42938968E-10_JPRB, 0.42861548E-10_JPRB, 0.42799295E-10_JPRB, 0.42724456E-10_JPRB /)

RGHG8(:,11, 1) = (/ &
  & 0.49395273E-10_JPRB, 0.48808037E-10_JPRB, 0.48357335E-10_JPRB, 0.48263848E-10_JPRB, 0.48278367E-10_JPRB, 0.48541782E-10_JPRB, &
  & 0.49074033E-10_JPRB, 0.49876450E-10_JPRB, 0.50937716E-10_JPRB, 0.52264193E-10_JPRB, 0.53860728E-10_JPRB, 0.55716889E-10_JPRB, &
  & 0.57801899E-10_JPRB, 0.60064169E-10_JPRB, 0.62450663E-10_JPRB, 0.64921145E-10_JPRB, 0.67421638E-10_JPRB, 0.69898289E-10_JPRB, &
  & 0.72306272E-10_JPRB, 0.74615501E-10_JPRB, 0.76780846E-10_JPRB, 0.78761761E-10_JPRB, 0.80542142E-10_JPRB, 0.82076991E-10_JPRB, &
  & 0.83355170E-10_JPRB, 0.84383139E-10_JPRB, 0.85157215E-10_JPRB, 0.85695909E-10_JPRB, 0.85969877E-10_JPRB, 0.85938277E-10_JPRB, &
  & 0.85514443E-10_JPRB, 0.84600570E-10_JPRB, 0.83104482E-10_JPRB, 0.81002538E-10_JPRB, 0.78392577E-10_JPRB, 0.75515483E-10_JPRB, &
  & 0.72648158E-10_JPRB, 0.69922394E-10_JPRB, 0.67303281E-10_JPRB, 0.64754827E-10_JPRB, 0.62190510E-10_JPRB, 0.59591339E-10_JPRB, &
  & 0.57166445E-10_JPRB, 0.55166569E-10_JPRB, 0.53628386E-10_JPRB, 0.52444722E-10_JPRB, 0.51484532E-10_JPRB, 0.50656486E-10_JPRB, &
  & 0.49903633E-10_JPRB, 0.49179924E-10_JPRB, 0.48457127E-10_JPRB, 0.47732641E-10_JPRB, 0.47012942E-10_JPRB, 0.46312294E-10_JPRB, &
  & 0.45661350E-10_JPRB, 0.45092034E-10_JPRB, 0.44636139E-10_JPRB, 0.44298971E-10_JPRB, 0.44075570E-10_JPRB, 0.43923819E-10_JPRB, &
  & 0.43822390E-10_JPRB, 0.43747811E-10_JPRB, 0.43678693E-10_JPRB, 0.43591925E-10_JPRB /)

RGHG8(:,12, 1) = (/ &
  & 0.59295700E-10_JPRB, 0.57954384E-10_JPRB, 0.57079352E-10_JPRB, 0.56630797E-10_JPRB, 0.56377989E-10_JPRB, 0.56397054E-10_JPRB, &
  & 0.56741702E-10_JPRB, 0.57415329E-10_JPRB, 0.58413357E-10_JPRB, 0.59744855E-10_JPRB, 0.61415498E-10_JPRB, 0.63414621E-10_JPRB, &
  & 0.65716169E-10_JPRB, 0.68280902E-10_JPRB, 0.71042207E-10_JPRB, 0.73922028E-10_JPRB, 0.76851248E-10_JPRB, 0.79752489E-10_JPRB, &
  & 0.82552257E-10_JPRB, 0.85196461E-10_JPRB, 0.87643247E-10_JPRB, 0.89827111E-10_JPRB, 0.91729416E-10_JPRB, 0.93320823E-10_JPRB, &
  & 0.94557390E-10_JPRB, 0.95446415E-10_JPRB, 0.95939381E-10_JPRB, 0.96041064E-10_JPRB, 0.95701731E-10_JPRB, 0.94890658E-10_JPRB, &
  & 0.93546823E-10_JPRB, 0.91621995E-10_JPRB, 0.89080930E-10_JPRB, 0.85972750E-10_JPRB, 0.82477129E-10_JPRB, 0.78915534E-10_JPRB, &
  & 0.75571285E-10_JPRB, 0.72576604E-10_JPRB, 0.69890857E-10_JPRB, 0.67372517E-10_JPRB, 0.64914428E-10_JPRB, 0.62523917E-10_JPRB, &
  & 0.60268388E-10_JPRB, 0.58255623E-10_JPRB, 0.56569804E-10_JPRB, 0.55179500E-10_JPRB, 0.54007063E-10_JPRB, 0.52967773E-10_JPRB, &
  & 0.51993798E-10_JPRB, 0.51050181E-10_JPRB, 0.50127132E-10_JPRB, 0.49223143E-10_JPRB, 0.48347541E-10_JPRB, 0.47528804E-10_JPRB, &
  & 0.46796081E-10_JPRB, 0.46182783E-10_JPRB, 0.45706570E-10_JPRB, 0.45373254E-10_JPRB, 0.45146401E-10_JPRB, 0.45003549E-10_JPRB, &
  & 0.44904049E-10_JPRB, 0.44827128E-10_JPRB, 0.44760234E-10_JPRB, 0.44654939E-10_JPRB /)

RGHG8(:,13, 1) = (/ &
  & 0.68797718E-10_JPRB, 0.67101998E-10_JPRB, 0.66191087E-10_JPRB, 0.65608026E-10_JPRB, 0.65289080E-10_JPRB, 0.65246329E-10_JPRB, &
  & 0.65534980E-10_JPRB, 0.66163200E-10_JPRB, 0.67127540E-10_JPRB, 0.68450516E-10_JPRB, 0.70148311E-10_JPRB, 0.72218224E-10_JPRB, &
  & 0.74629233E-10_JPRB, 0.77334646E-10_JPRB, 0.80273954E-10_JPRB, 0.83364905E-10_JPRB, 0.86509258E-10_JPRB, 0.89616176E-10_JPRB, &
  & 0.92599588E-10_JPRB, 0.95386948E-10_JPRB, 0.97924016E-10_JPRB, 0.10015492E-09_JPRB, 0.10204593E-09_JPRB, 0.10357119E-09_JPRB, &
  & 0.10467376E-09_JPRB, 0.10533504E-09_JPRB, 0.10548668E-09_JPRB, 0.10510691E-09_JPRB, 0.10414362E-09_JPRB, 0.10258078E-09_JPRB, &
  & 0.10039795E-09_JPRB, 0.97604085E-10_JPRB, 0.94257512E-10_JPRB, 0.90486889E-10_JPRB, 0.86562139E-10_JPRB, 0.82823887E-10_JPRB, &
  & 0.79524824E-10_JPRB, 0.76727180E-10_JPRB, 0.74336350E-10_JPRB, 0.72207455E-10_JPRB, 0.70227615E-10_JPRB, 0.68327760E-10_JPRB, &
  & 0.66485130E-10_JPRB, 0.64709280E-10_JPRB, 0.63019291E-10_JPRB, 0.61418988E-10_JPRB, 0.59885721E-10_JPRB, 0.58391542E-10_JPRB, &
  & 0.56918314E-10_JPRB, 0.55455578E-10_JPRB, 0.54007618E-10_JPRB, 0.52605947E-10_JPRB, 0.51294791E-10_JPRB, 0.50118371E-10_JPRB, &
  & 0.49117301E-10_JPRB, 0.48316982E-10_JPRB, 0.47722201E-10_JPRB, 0.47305493E-10_JPRB, 0.47036798E-10_JPRB, 0.46854798E-10_JPRB, &
  & 0.46728552E-10_JPRB, 0.46625585E-10_JPRB, 0.46515299E-10_JPRB, 0.46340001E-10_JPRB /)

RGHG8(:,14, 1) = (/ &
  & 0.77246265E-10_JPRB, 0.75599416E-10_JPRB, 0.74871581E-10_JPRB, 0.74454116E-10_JPRB, 0.74274545E-10_JPRB, 0.74350401E-10_JPRB, &
  & 0.74730847E-10_JPRB, 0.75422911E-10_JPRB, 0.76429280E-10_JPRB, 0.77774648E-10_JPRB, 0.79484697E-10_JPRB, 0.81561022E-10_JPRB, &
  & 0.83981253E-10_JPRB, 0.86695054E-10_JPRB, 0.89635140E-10_JPRB, 0.92721282E-10_JPRB, 0.95859730E-10_JPRB, 0.98949085E-10_JPRB, &
  & 0.10190142E-09_JPRB, 0.10463978E-09_JPRB, 0.10709968E-09_JPRB, 0.10922502E-09_JPRB, 0.11098444E-09_JPRB, 0.11233030E-09_JPRB, &
  & 0.11321970E-09_JPRB, 0.11359336E-09_JPRB, 0.11338942E-09_JPRB, 0.11256204E-09_JPRB, 0.11107058E-09_JPRB, 0.10891578E-09_JPRB, &
  & 0.10613388E-09_JPRB, 0.10282124E-09_JPRB, 0.99123848E-10_JPRB, 0.95285675E-10_JPRB, 0.91581243E-10_JPRB, 0.88296453E-10_JPRB, &
  & 0.85624473E-10_JPRB, 0.83510310E-10_JPRB, 0.81830008E-10_JPRB, 0.80428254E-10_JPRB, 0.79163641E-10_JPRB, 0.77927054E-10_JPRB, &
  & 0.76635663E-10_JPRB, 0.75234582E-10_JPRB, 0.73695917E-10_JPRB, 0.72019286E-10_JPRB, 0.70209727E-10_JPRB, 0.68267475E-10_JPRB, &
  & 0.66194231E-10_JPRB, 0.64015626E-10_JPRB, 0.61788116E-10_JPRB, 0.59592498E-10_JPRB, 0.57518136E-10_JPRB, 0.55659317E-10_JPRB, &
  & 0.54083914E-10_JPRB, 0.52823176E-10_JPRB, 0.51870161E-10_JPRB, 0.51189775E-10_JPRB, 0.50717919E-10_JPRB, 0.50398286E-10_JPRB, &
  & 0.50155942E-10_JPRB, 0.49950832E-10_JPRB, 0.49731736E-10_JPRB, 0.49350409E-10_JPRB /)

RGHG8(:,15, 1) = (/ &
  & 0.84541214E-10_JPRB, 0.83403437E-10_JPRB, 0.82962651E-10_JPRB, 0.82784023E-10_JPRB, 0.82833920E-10_JPRB, 0.83132064E-10_JPRB, &
  & 0.83718706E-10_JPRB, 0.84589988E-10_JPRB, 0.85740859E-10_JPRB, 0.87185537E-10_JPRB, 0.88940071E-10_JPRB, 0.91003038E-10_JPRB, &
  & 0.93356031E-10_JPRB, 0.95961447E-10_JPRB, 0.98762103E-10_JPRB, 0.10168535E-09_JPRB, 0.10464571E-09_JPRB, 0.10755193E-09_JPRB, &
  & 0.11031596E-09_JPRB, 0.11286050E-09_JPRB, 0.11511897E-09_JPRB, 0.11703385E-09_JPRB, 0.11856777E-09_JPRB, 0.11966568E-09_JPRB, &
  & 0.12028047E-09_JPRB, 0.12034168E-09_JPRB, 0.11978979E-09_JPRB, 0.11857361E-09_JPRB, 0.11668100E-09_JPRB, 0.11415491E-09_JPRB, &
  & 0.11108194E-09_JPRB, 0.10763845E-09_JPRB, 0.10406410E-09_JPRB, 0.10061731E-09_JPRB, 0.97623083E-10_JPRB, 0.95293905E-10_JPRB, &
  & 0.93645001E-10_JPRB, 0.92545097E-10_JPRB, 0.91764908E-10_JPRB, 0.91137348E-10_JPRB, 0.90521930E-10_JPRB, 0.89802048E-10_JPRB, &
  & 0.88903274E-10_JPRB, 0.87783607E-10_JPRB, 0.86421682E-10_JPRB, 0.84810665E-10_JPRB, 0.82942847E-10_JPRB, 0.80811066E-10_JPRB, &
  & 0.78416461E-10_JPRB, 0.75786634E-10_JPRB, 0.72979046E-10_JPRB, 0.70108176E-10_JPRB, 0.67298486E-10_JPRB, 0.64696831E-10_JPRB, &
  & 0.62403166E-10_JPRB, 0.60486366E-10_JPRB, 0.58954806E-10_JPRB, 0.57788510E-10_JPRB, 0.56932313E-10_JPRB, 0.56303531E-10_JPRB, &
  & 0.55832304E-10_JPRB, 0.55408744E-10_JPRB, 0.54975621E-10_JPRB, 0.54197941E-10_JPRB /)

RGHG8(:,16, 1) = (/ &
  & 0.90957325E-10_JPRB, 0.90364438E-10_JPRB, 0.90258905E-10_JPRB, 0.90394137E-10_JPRB, 0.90755917E-10_JPRB, 0.91361231E-10_JPRB, &
  & 0.92230543E-10_JPRB, 0.93351681E-10_JPRB, 0.94700053E-10_JPRB, 0.96280955E-10_JPRB, 0.98099771E-10_JPRB, 0.10015061E-09_JPRB, &
  & 0.10241800E-09_JPRB, 0.10487229E-09_JPRB, 0.10747061E-09_JPRB, 0.11015414E-09_JPRB, 0.11285085E-09_JPRB, 0.11548168E-09_JPRB, &
  & 0.11796410E-09_JPRB, 0.12023010E-09_JPRB, 0.12220727E-09_JPRB, 0.12384399E-09_JPRB, 0.12508844E-09_JPRB, 0.12588935E-09_JPRB, &
  & 0.12619439E-09_JPRB, 0.12593669E-09_JPRB, 0.12506435E-09_JPRB, 0.12355007E-09_JPRB, 0.12141141E-09_JPRB, 0.11873304E-09_JPRB, &
  & 0.11569124E-09_JPRB, 0.11250051E-09_JPRB, 0.10941510E-09_JPRB, 0.10676963E-09_JPRB, 0.10476295E-09_JPRB, 0.10351960E-09_JPRB, &
  & 0.10292373E-09_JPRB, 0.10274279E-09_JPRB, 0.10273431E-09_JPRB, 0.10269627E-09_JPRB, 0.10248974E-09_JPRB, 0.10204809E-09_JPRB, &
  & 0.10133882E-09_JPRB, 0.10034862E-09_JPRB, 0.99080175E-10_JPRB, 0.97538713E-10_JPRB, 0.95712126E-10_JPRB, 0.93575814E-10_JPRB, &
  & 0.91113318E-10_JPRB, 0.88336401E-10_JPRB, 0.85307386E-10_JPRB, 0.82125542E-10_JPRB, 0.78927358E-10_JPRB, 0.75849528E-10_JPRB, &
  & 0.73030054E-10_JPRB, 0.70560190E-10_JPRB, 0.68483039E-10_JPRB, 0.66791295E-10_JPRB, 0.65469144E-10_JPRB, 0.64456024E-10_JPRB, &
  & 0.63629060E-10_JPRB, 0.62937634E-10_JPRB, 0.62148772E-10_JPRB, 0.60917854E-10_JPRB /)

RGHG8(:,17, 1) = (/ &
  & 0.96708419E-10_JPRB, 0.96717447E-10_JPRB, 0.96962778E-10_JPRB, 0.97399457E-10_JPRB, 0.98052337E-10_JPRB, 0.98938933E-10_JPRB, &
  & 0.10007846E-09_JPRB, 0.10143938E-09_JPRB, 0.10299367E-09_JPRB, 0.10472706E-09_JPRB, 0.10663283E-09_JPRB, 0.10869405E-09_JPRB, &
  & 0.11089355E-09_JPRB, 0.11321022E-09_JPRB, 0.11560771E-09_JPRB, 0.11804184E-09_JPRB, 0.12045615E-09_JPRB, 0.12277994E-09_JPRB, &
  & 0.12494904E-09_JPRB, 0.12689630E-09_JPRB, 0.12855055E-09_JPRB, 0.12986602E-09_JPRB, 0.13078415E-09_JPRB, 0.13125973E-09_JPRB, &
  & 0.13124321E-09_JPRB, 0.13068677E-09_JPRB, 0.12956519E-09_JPRB, 0.12788041E-09_JPRB, 0.12570525E-09_JPRB, 0.12316662E-09_JPRB, &
  & 0.12046036E-09_JPRB, 0.11782138E-09_JPRB, 0.11552707E-09_JPRB, 0.11378766E-09_JPRB, 0.11278035E-09_JPRB, 0.11246105E-09_JPRB, &
  & 0.11269807E-09_JPRB, 0.11319134E-09_JPRB, 0.11366688E-09_JPRB, 0.11393943E-09_JPRB, 0.11392538E-09_JPRB, 0.11358068E-09_JPRB, &
  & 0.11290303E-09_JPRB, 0.11192119E-09_JPRB, 0.11066769E-09_JPRB, 0.10915393E-09_JPRB, 0.10736838E-09_JPRB, 0.10528038E-09_JPRB, &
  & 0.10286171E-09_JPRB, 0.10011618E-09_JPRB, 0.97087789E-10_JPRB, 0.93867587E-10_JPRB, 0.90566679E-10_JPRB, 0.87326063E-10_JPRB, &
  & 0.84275538E-10_JPRB, 0.81524419E-10_JPRB, 0.79123631E-10_JPRB, 0.77084478E-10_JPRB, 0.75392310E-10_JPRB, 0.74005142E-10_JPRB, &
  & 0.72883082E-10_JPRB, 0.71828363E-10_JPRB, 0.70773859E-10_JPRB, 0.68876911E-10_JPRB /)

RGHG8(:,18, 1) = (/ &
  & 0.10192047E-09_JPRB, 0.10240261E-09_JPRB, 0.10293246E-09_JPRB, 0.10362259E-09_JPRB, 0.10452245E-09_JPRB, 0.10565995E-09_JPRB, &
  & 0.10703675E-09_JPRB, 0.10862178E-09_JPRB, 0.11036457E-09_JPRB, 0.11224288E-09_JPRB, 0.11423902E-09_JPRB, 0.11632666E-09_JPRB, &
  & 0.11848300E-09_JPRB, 0.12069164E-09_JPRB, 0.12292103E-09_JPRB, 0.12513635E-09_JPRB, 0.12729717E-09_JPRB, 0.12933521E-09_JPRB, &
  & 0.13120058E-09_JPRB, 0.13283527E-09_JPRB, 0.13416761E-09_JPRB, 0.13515439E-09_JPRB, 0.13574505E-09_JPRB, 0.13590065E-09_JPRB, &
  & 0.13559008E-09_JPRB, 0.13479784E-09_JPRB, 0.13353296E-09_JPRB, 0.13185483E-09_JPRB, 0.12985570E-09_JPRB, 0.12772675E-09_JPRB, &
  & 0.12561706E-09_JPRB, 0.12376473E-09_JPRB, 0.12235793E-09_JPRB, 0.12152515E-09_JPRB, 0.12129438E-09_JPRB, 0.12164963E-09_JPRB, &
  & 0.12235121E-09_JPRB, 0.12314622E-09_JPRB, 0.12378631E-09_JPRB, 0.12413093E-09_JPRB, 0.12410106E-09_JPRB, 0.12369196E-09_JPRB, &
  & 0.12295003E-09_JPRB, 0.12192355E-09_JPRB, 0.12065125E-09_JPRB, 0.11915026E-09_JPRB, 0.11740821E-09_JPRB, 0.11539308E-09_JPRB, &
  & 0.11307736E-09_JPRB, 0.11045818E-09_JPRB, 0.10757242E-09_JPRB, 0.10448842E-09_JPRB, 0.10130179E-09_JPRB, 0.98125161E-10_JPRB, &
  & 0.95090519E-10_JPRB, 0.92300771E-10_JPRB, 0.89805621E-10_JPRB, 0.87608074E-10_JPRB, 0.85701321E-10_JPRB, 0.84079493E-10_JPRB, &
  & 0.82654432E-10_JPRB, 0.81370966E-10_JPRB, 0.79946563E-10_JPRB, 0.77581330E-10_JPRB /)

RGHG8(:,19, 1) = (/ &
  & 0.10673598E-09_JPRB, 0.10756728E-09_JPRB, 0.10830716E-09_JPRB, 0.10918164E-09_JPRB, 0.11026165E-09_JPRB, 0.11157446E-09_JPRB, &
  & 0.11312384E-09_JPRB, 0.11486338E-09_JPRB, 0.11674246E-09_JPRB, 0.11872452E-09_JPRB, 0.12078111E-09_JPRB, 0.12288545E-09_JPRB, &
  & 0.12500727E-09_JPRB, 0.12712886E-09_JPRB, 0.12922514E-09_JPRB, 0.13125925E-09_JPRB, 0.13320678E-09_JPRB, 0.13500837E-09_JPRB, &
  & 0.13660927E-09_JPRB, 0.13796508E-09_JPRB, 0.13901413E-09_JPRB, 0.13970930E-09_JPRB, 0.14001438E-09_JPRB, 0.13990284E-09_JPRB, &
  & 0.13937027E-09_JPRB, 0.13843858E-09_JPRB, 0.13716529E-09_JPRB, 0.13564824E-09_JPRB, 0.13404845E-09_JPRB, 0.13247640E-09_JPRB, &
  & 0.13115824E-09_JPRB, 0.13016310E-09_JPRB, 0.12958790E-09_JPRB, 0.12948054E-09_JPRB, 0.12981238E-09_JPRB, 0.13047330E-09_JPRB, &
  & 0.13131365E-09_JPRB, 0.13209821E-09_JPRB, 0.13263984E-09_JPRB, 0.13283737E-09_JPRB, 0.13267257E-09_JPRB, 0.13215555E-09_JPRB, &
  & 0.13132527E-09_JPRB, 0.13023685E-09_JPRB, 0.12893746E-09_JPRB, 0.12744222E-09_JPRB, 0.12573964E-09_JPRB, 0.12380504E-09_JPRB, &
  & 0.12161798E-09_JPRB, 0.11917768E-09_JPRB, 0.11651292E-09_JPRB, 0.11368031E-09_JPRB, 0.11075119E-09_JPRB, 0.10782500E-09_JPRB, &
  & 0.10501004E-09_JPRB, 0.10239365E-09_JPRB, 0.10001006E-09_JPRB, 0.97856466E-10_JPRB, 0.95919786E-10_JPRB, 0.94177624E-10_JPRB, &
  & 0.92604466E-10_JPRB, 0.91104686E-10_JPRB, 0.89406461E-10_JPRB, 0.86628073E-10_JPRB /)

RGHG8(:,20, 1) = (/ &
  & 0.11109793E-09_JPRB, 0.11222407E-09_JPRB, 0.11311131E-09_JPRB, 0.11410438E-09_JPRB, 0.11529352E-09_JPRB, 0.11671031E-09_JPRB, &
  & 0.11835026E-09_JPRB, 0.12017447E-09_JPRB, 0.12212323E-09_JPRB, 0.12415233E-09_JPRB, 0.12623350E-09_JPRB, 0.12832686E-09_JPRB, &
  & 0.13040805E-09_JPRB, 0.13245149E-09_JPRB, 0.13443963E-09_JPRB, 0.13633428E-09_JPRB, 0.13810758E-09_JPRB, 0.13972240E-09_JPRB, &
  & 0.14112089E-09_JPRB, 0.14225825E-09_JPRB, 0.14308535E-09_JPRB, 0.14356055E-09_JPRB, 0.14365725E-09_JPRB, 0.14336901E-09_JPRB, &
  & 0.14271904E-09_JPRB, 0.14176967E-09_JPRB, 0.14062568E-09_JPRB, 0.13941859E-09_JPRB, 0.13827485E-09_JPRB, 0.13738481E-09_JPRB, &
  & 0.13678149E-09_JPRB, 0.13653638E-09_JPRB, 0.13663633E-09_JPRB, 0.13701615E-09_JPRB, 0.13763583E-09_JPRB, 0.13839170E-09_JPRB, &
  & 0.13913885E-09_JPRB, 0.13973732E-09_JPRB, 0.14007363E-09_JPRB, 0.14006128E-09_JPRB, 0.13970231E-09_JPRB, 0.13903130E-09_JPRB, &
  & 0.13811027E-09_JPRB, 0.13697542E-09_JPRB, 0.13566004E-09_JPRB, 0.13417260E-09_JPRB, 0.13251537E-09_JPRB, 0.13067161E-09_JPRB, &
  & 0.12863119E-09_JPRB, 0.12639720E-09_JPRB, 0.12399608E-09_JPRB, 0.12147124E-09_JPRB, 0.11888114E-09_JPRB, 0.11630465E-09_JPRB, &
  & 0.11382597E-09_JPRB, 0.11150592E-09_JPRB, 0.10936754E-09_JPRB, 0.10739290E-09_JPRB, 0.10556573E-09_JPRB, 0.10386864E-09_JPRB, &
  & 0.10227606E-09_JPRB, 0.10065353E-09_JPRB, 0.98918831E-10_JPRB, 0.95634951E-10_JPRB /)

RGHG8(:,21, 1) = (/ &
  & 0.11489875E-09_JPRB, 0.11631211E-09_JPRB, 0.11732484E-09_JPRB, 0.11839753E-09_JPRB, 0.11964527E-09_JPRB, 0.12110679E-09_JPRB, &
  & 0.12278278E-09_JPRB, 0.12462828E-09_JPRB, 0.12658995E-09_JPRB, 0.12862408E-09_JPRB, 0.13068704E-09_JPRB, 0.13274823E-09_JPRB, &
  & 0.13477529E-09_JPRB, 0.13674629E-09_JPRB, 0.13863932E-09_JPRB, 0.14042620E-09_JPRB, 0.14207344E-09_JPRB, 0.14354694E-09_JPRB, &
  & 0.14480230E-09_JPRB, 0.14579218E-09_JPRB, 0.14647393E-09_JPRB, 0.14681507E-09_JPRB, 0.14680092E-09_JPRB, 0.14644277E-09_JPRB, &
  & 0.14579200E-09_JPRB, 0.14493975E-09_JPRB, 0.14401064E-09_JPRB, 0.14314099E-09_JPRB, 0.14249958E-09_JPRB, 0.14214463E-09_JPRB, &
  & 0.14212805E-09_JPRB, 0.14240388E-09_JPRB, 0.14290297E-09_JPRB, 0.14355260E-09_JPRB, 0.14425799E-09_JPRB, 0.14493608E-09_JPRB, &
  & 0.14550670E-09_JPRB, 0.14587050E-09_JPRB, 0.14595469E-09_JPRB, 0.14573641E-09_JPRB, 0.14523219E-09_JPRB, 0.14447374E-09_JPRB, &
  & 0.14350060E-09_JPRB, 0.14234336E-09_JPRB, 0.14103266E-09_JPRB, 0.13957291E-09_JPRB, 0.13798418E-09_JPRB, 0.13625270E-09_JPRB, &
  & 0.13438053E-09_JPRB, 0.13237325E-09_JPRB, 0.13025604E-09_JPRB, 0.12806384E-09_JPRB, 0.12584433E-09_JPRB, 0.12365654E-09_JPRB, &
  & 0.12155141E-09_JPRB, 0.11957084E-09_JPRB, 0.11771971E-09_JPRB, 0.11598494E-09_JPRB, 0.11434192E-09_JPRB, 0.11276871E-09_JPRB, &
  & 0.11121926E-09_JPRB, 0.10968195E-09_JPRB, 0.10774674E-09_JPRB, 0.10458179E-09_JPRB /)

RGHG8(:,22, 1) = (/ &
  & 0.11868594E-09_JPRB, 0.12007351E-09_JPRB, 0.12109649E-09_JPRB, 0.12218426E-09_JPRB, 0.12343777E-09_JPRB, 0.12489498E-09_JPRB, &
  & 0.12655078E-09_JPRB, 0.12837047E-09_JPRB, 0.13030063E-09_JPRB, 0.13229173E-09_JPRB, 0.13431234E-09_JPRB, 0.13631547E-09_JPRB, &
  & 0.13827769E-09_JPRB, 0.14017497E-09_JPRB, 0.14198795E-09_JPRB, 0.14369020E-09_JPRB, 0.14524787E-09_JPRB, 0.14662718E-09_JPRB, &
  & 0.14779132E-09_JPRB, 0.14870126E-09_JPRB, 0.14931834E-09_JPRB, 0.14961507E-09_JPRB, 0.14958916E-09_JPRB, 0.14926906E-09_JPRB, &
  & 0.14871726E-09_JPRB, 0.14804759E-09_JPRB, 0.14737520E-09_JPRB, 0.14685093E-09_JPRB, 0.14656880E-09_JPRB, 0.14660605E-09_JPRB, &
  & 0.14693287E-09_JPRB, 0.14747628E-09_JPRB, 0.14814210E-09_JPRB, 0.14884444E-09_JPRB, 0.14950331E-09_JPRB, 0.15005480E-09_JPRB, &
  & 0.15043868E-09_JPRB, 0.15059654E-09_JPRB, 0.15049809E-09_JPRB, 0.15013389E-09_JPRB, 0.14952692E-09_JPRB, 0.14871185E-09_JPRB, &
  & 0.14772446E-09_JPRB, 0.14658347E-09_JPRB, 0.14530785E-09_JPRB, 0.14391095E-09_JPRB, 0.14241239E-09_JPRB, 0.14081733E-09_JPRB, &
  & 0.13912689E-09_JPRB, 0.13735735E-09_JPRB, 0.13552849E-09_JPRB, 0.13367167E-09_JPRB, 0.13182040E-09_JPRB, 0.13000456E-09_JPRB, &
  & 0.12825817E-09_JPRB, 0.12659965E-09_JPRB, 0.12503162E-09_JPRB, 0.12353146E-09_JPRB, 0.12208021E-09_JPRB, 0.12065392E-09_JPRB, &
  & 0.11923393E-09_JPRB, 0.11769748E-09_JPRB, 0.11598871E-09_JPRB, 0.11266665E-09_JPRB /)

RGHG8(:,23, 1) = (/ &
  & 0.12198052E-09_JPRB, 0.12344883E-09_JPRB, 0.12446796E-09_JPRB, 0.12553139E-09_JPRB, 0.12675357E-09_JPRB, 0.12816694E-09_JPRB, &
  & 0.12977128E-09_JPRB, 0.13152807E-09_JPRB, 0.13339124E-09_JPRB, 0.13531856E-09_JPRB, 0.13726612E-09_JPRB, 0.13920078E-09_JPRB, &
  & 0.14109044E-09_JPRB, 0.14291260E-09_JPRB, 0.14464839E-09_JPRB, 0.14627854E-09_JPRB, 0.14777668E-09_JPRB, 0.14910892E-09_JPRB, &
  & 0.15023766E-09_JPRB, 0.15112683E-09_JPRB, 0.15174617E-09_JPRB, 0.15208051E-09_JPRB, 0.15213392E-09_JPRB, 0.15193839E-09_JPRB, &
  & 0.15157264E-09_JPRB, 0.15112646E-09_JPRB, 0.15071291E-09_JPRB, 0.15044337E-09_JPRB, 0.15041261E-09_JPRB, 0.15064192E-09_JPRB, &
  & 0.15109254E-09_JPRB, 0.15168350E-09_JPRB, 0.15233829E-09_JPRB, 0.15296892E-09_JPRB, 0.15350940E-09_JPRB, 0.15390975E-09_JPRB, &
  & 0.15413248E-09_JPRB, 0.15413387E-09_JPRB, 0.15390905E-09_JPRB, 0.15345768E-09_JPRB, 0.15280942E-09_JPRB, 0.15199142E-09_JPRB, &
  & 0.15102661E-09_JPRB, 0.14993166E-09_JPRB, 0.14871937E-09_JPRB, 0.14740942E-09_JPRB, 0.14602550E-09_JPRB, 0.14458014E-09_JPRB, &
  & 0.14308006E-09_JPRB, 0.14154465E-09_JPRB, 0.13999304E-09_JPRB, 0.13844695E-09_JPRB, 0.13692232E-09_JPRB, 0.13543792E-09_JPRB, &
  & 0.13400510E-09_JPRB, 0.13263193E-09_JPRB, 0.13130746E-09_JPRB, 0.13001869E-09_JPRB, 0.12874334E-09_JPRB, 0.12745950E-09_JPRB, &
  & 0.12613779E-09_JPRB, 0.12475691E-09_JPRB, 0.12302608E-09_JPRB, 0.11997131E-09_JPRB /)

RGHG8(:,24, 1) = (/ &
  & 0.12509103E-09_JPRB, 0.12651416E-09_JPRB, 0.12750290E-09_JPRB, 0.12852726E-09_JPRB, 0.12969391E-09_JPRB, 0.13104232E-09_JPRB, &
  & 0.13256721E-09_JPRB, 0.13423945E-09_JPRB, 0.13601630E-09_JPRB, 0.13785310E-09_JPRB, 0.13971738E-09_JPRB, 0.14156720E-09_JPRB, &
  & 0.14337910E-09_JPRB, 0.14513160E-09_JPRB, 0.14680683E-09_JPRB, 0.14837978E-09_JPRB, 0.14982736E-09_JPRB, 0.15112435E-09_JPRB, &
  & 0.15224288E-09_JPRB, 0.15315499E-09_JPRB, 0.15383519E-09_JPRB, 0.15426767E-09_JPRB, 0.15445842E-09_JPRB, 0.15445219E-09_JPRB, &
  & 0.15430343E-09_JPRB, 0.15409020E-09_JPRB, 0.15390079E-09_JPRB, 0.15381829E-09_JPRB, 0.15390568E-09_JPRB, 0.15417362E-09_JPRB, &
  & 0.15459251E-09_JPRB, 0.15510904E-09_JPRB, 0.15564336E-09_JPRB, 0.15613537E-09_JPRB, 0.15652703E-09_JPRB, 0.15678341E-09_JPRB, &
  & 0.15687091E-09_JPRB, 0.15676255E-09_JPRB, 0.15646186E-09_JPRB, 0.15597683E-09_JPRB, 0.15532628E-09_JPRB, 0.15453669E-09_JPRB, &
  & 0.15362181E-09_JPRB, 0.15259349E-09_JPRB, 0.15146513E-09_JPRB, 0.15025729E-09_JPRB, 0.14899745E-09_JPRB, 0.14770495E-09_JPRB, &
  & 0.14639029E-09_JPRB, 0.14507311E-09_JPRB, 0.14376708E-09_JPRB, 0.14248615E-09_JPRB, 0.14123938E-09_JPRB, 0.14003040E-09_JPRB, &
  & 0.13885995E-09_JPRB, 0.13772056E-09_JPRB, 0.13660542E-09_JPRB, 0.13549176E-09_JPRB, 0.13436416E-09_JPRB, 0.13320310E-09_JPRB, &
  & 0.13199013E-09_JPRB, 0.13067100E-09_JPRB, 0.12909811E-09_JPRB, 0.12618884E-09_JPRB /)

RGHG8(:,25, 1) = (/ &
  & 0.12795104E-09_JPRB, 0.12932713E-09_JPRB, 0.13027492E-09_JPRB, 0.13124564E-09_JPRB, 0.13234795E-09_JPRB, 0.13361638E-09_JPRB, &
  & 0.13505019E-09_JPRB, 0.13662127E-09_JPRB, 0.13829160E-09_JPRB, 0.14002621E-09_JPRB, 0.14178708E-09_JPRB, 0.14354121E-09_JPRB, &
  & 0.14526072E-09_JPRB, 0.14692547E-09_JPRB, 0.14852299E-09_JPRB, 0.15003976E-09_JPRB, 0.15145563E-09_JPRB, 0.15274737E-09_JPRB, &
  & 0.15388855E-09_JPRB, 0.15485099E-09_JPRB, 0.15561227E-09_JPRB, 0.15616541E-09_JPRB, 0.15652313E-09_JPRB, 0.15671534E-09_JPRB, &
  & 0.15677984E-09_JPRB, 0.15677921E-09_JPRB, 0.15676549E-09_JPRB, 0.15679598E-09_JPRB, 0.15692370E-09_JPRB, 0.15715312E-09_JPRB, &
  & 0.15747764E-09_JPRB, 0.15785188E-09_JPRB, 0.15823204E-09_JPRB, 0.15856763E-09_JPRB, 0.15881396E-09_JPRB, 0.15894354E-09_JPRB, &
  & 0.15892387E-09_JPRB, 0.15874174E-09_JPRB, 0.15839964E-09_JPRB, 0.15790957E-09_JPRB, 0.15728574E-09_JPRB, 0.15654435E-09_JPRB, &
  & 0.15569696E-09_JPRB, 0.15474889E-09_JPRB, 0.15371353E-09_JPRB, 0.15261324E-09_JPRB, 0.15147755E-09_JPRB, 0.15032678E-09_JPRB, &
  & 0.14917835E-09_JPRB, 0.14804717E-09_JPRB, 0.14694655E-09_JPRB, 0.14588318E-09_JPRB, 0.14485967E-09_JPRB, 0.14387119E-09_JPRB, &
  & 0.14290848E-09_JPRB, 0.14196411E-09_JPRB, 0.14101817E-09_JPRB, 0.14005697E-09_JPRB, 0.13905790E-09_JPRB, 0.13800443E-09_JPRB, &
  & 0.13688800E-09_JPRB, 0.13566538E-09_JPRB, 0.13421741E-09_JPRB, 0.13145066E-09_JPRB /)

RGHG8(:,26, 1) = (/ &
  & 0.13064068E-09_JPRB, 0.13195005E-09_JPRB, 0.13284795E-09_JPRB, 0.13376092E-09_JPRB, 0.13479183E-09_JPRB, 0.13597612E-09_JPRB, &
  & 0.13731172E-09_JPRB, 0.13877285E-09_JPRB, 0.14032756E-09_JPRB, 0.14194493E-09_JPRB, 0.14359447E-09_JPRB, 0.14524541E-09_JPRB, &
  & 0.14687397E-09_JPRB, 0.14846517E-09_JPRB, 0.15000017E-09_JPRB, 0.15146365E-09_JPRB, 0.15284023E-09_JPRB, 0.15411027E-09_JPRB, &
  & 0.15525242E-09_JPRB, 0.15624788E-09_JPRB, 0.15708307E-09_JPRB, 0.15775173E-09_JPRB, 0.15826003E-09_JPRB, 0.15862647E-09_JPRB, &
  & 0.15887518E-09_JPRB, 0.15904202E-09_JPRB, 0.15916363E-09_JPRB, 0.15927928E-09_JPRB, 0.15941171E-09_JPRB, 0.15958422E-09_JPRB, &
  & 0.15979580E-09_JPRB, 0.16002942E-09_JPRB, 0.16026268E-09_JPRB, 0.16045380E-09_JPRB, 0.16057532E-09_JPRB, 0.16059958E-09_JPRB, &
  & 0.16050017E-09_JPRB, 0.16027137E-09_JPRB, 0.15991432E-09_JPRB, 0.15943993E-09_JPRB, 0.15885790E-09_JPRB, 0.15817579E-09_JPRB, &
  & 0.15740120E-09_JPRB, 0.15653784E-09_JPRB, 0.15559684E-09_JPRB, 0.15459965E-09_JPRB, 0.15357662E-09_JPRB, 0.15254753E-09_JPRB, &
  & 0.15153985E-09_JPRB, 0.15056144E-09_JPRB, 0.14962571E-09_JPRB, 0.14873305E-09_JPRB, 0.14788074E-09_JPRB, 0.14706233E-09_JPRB, &
  & 0.14626547E-09_JPRB, 0.14547580E-09_JPRB, 0.14467903E-09_JPRB, 0.14384906E-09_JPRB, 0.14297073E-09_JPRB, 0.14202607E-09_JPRB, &
  & 0.14099877E-09_JPRB, 0.13989297E-09_JPRB, 0.13848785E-09_JPRB, 0.13598372E-09_JPRB /)

RGHG8(:,27, 1) = (/ &
  & 0.13319121E-09_JPRB, 0.13444525E-09_JPRB, 0.13528664E-09_JPRB, 0.13613960E-09_JPRB, 0.13709667E-09_JPRB, 0.13819275E-09_JPRB, &
  & 0.13942439E-09_JPRB, 0.14076934E-09_JPRB, 0.14219670E-09_JPRB, 0.14368468E-09_JPRB, 0.14520699E-09_JPRB, 0.14673887E-09_JPRB, &
  & 0.14825879E-09_JPRB, 0.14974905E-09_JPRB, 0.15120202E-09_JPRB, 0.15260349E-09_JPRB, 0.15393715E-09_JPRB, 0.15518617E-09_JPRB, &
  & 0.15633399E-09_JPRB, 0.15736336E-09_JPRB, 0.15826097E-09_JPRB, 0.15901992E-09_JPRB, 0.15964446E-09_JPRB, 0.16014418E-09_JPRB, &
  & 0.16053414E-09_JPRB, 0.16082985E-09_JPRB, 0.16105202E-09_JPRB, 0.16122223E-09_JPRB, 0.16136101E-09_JPRB, 0.16149077E-09_JPRB, &
  & 0.16161980E-09_JPRB, 0.16174372E-09_JPRB, 0.16185928E-09_JPRB, 0.16193515E-09_JPRB, 0.16195752E-09_JPRB, 0.16190142E-09_JPRB, &
  & 0.16174768E-09_JPRB, 0.16149428E-09_JPRB, 0.16114085E-09_JPRB, 0.16069443E-09_JPRB, 0.16016086E-09_JPRB, 0.15954335E-09_JPRB, &
  & 0.15884345E-09_JPRB, 0.15806326E-09_JPRB, 0.15721142E-09_JPRB, 0.15630590E-09_JPRB, 0.15537524E-09_JPRB, 0.15445174E-09_JPRB, &
  & 0.15355535E-09_JPRB, 0.15269991E-09_JPRB, 0.15189047E-09_JPRB, 0.15112743E-09_JPRB, 0.15040574E-09_JPRB, 0.14971691E-09_JPRB, &
  & 0.14904791E-09_JPRB, 0.14838618E-09_JPRB, 0.14770947E-09_JPRB, 0.14700077E-09_JPRB, 0.14623529E-09_JPRB, 0.14539805E-09_JPRB, &
  & 0.14448841E-09_JPRB, 0.14345802E-09_JPRB, 0.14225895E-09_JPRB, 0.13988434E-09_JPRB /)

RGHG8(:,28, 1) = (/ &
  & 0.13565608E-09_JPRB, 0.13684778E-09_JPRB, 0.13763975E-09_JPRB, 0.13842749E-09_JPRB, 0.13930980E-09_JPRB, 0.14031444E-09_JPRB, &
  & 0.14144044E-09_JPRB, 0.14266287E-09_JPRB, 0.14395798E-09_JPRB, 0.14531093E-09_JPRB, 0.14669864E-09_JPRB, 0.14810859E-09_JPRB, &
  & 0.14951863E-09_JPRB, 0.15091604E-09_JPRB, 0.15228682E-09_JPRB, 0.15361824E-09_JPRB, 0.15489757E-09_JPRB, 0.15611107E-09_JPRB, &
  & 0.15724280E-09_JPRB, 0.15827724E-09_JPRB, 0.15920318E-09_JPRB, 0.16001508E-09_JPRB, 0.16071530E-09_JPRB, 0.16130750E-09_JPRB, &
  & 0.16179703E-09_JPRB, 0.16218607E-09_JPRB, 0.16248472E-09_JPRB, 0.16270249E-09_JPRB, 0.16285613E-09_JPRB, 0.16296411E-09_JPRB, &
  & 0.16304111E-09_JPRB, 0.16309172E-09_JPRB, 0.16312306E-09_JPRB, 0.16311631E-09_JPRB, 0.16306574E-09_JPRB, 0.16295353E-09_JPRB, &
  & 0.16276670E-09_JPRB, 0.16250432E-09_JPRB, 0.16216596E-09_JPRB, 0.16175557E-09_JPRB, 0.16127383E-09_JPRB, 0.16072099E-09_JPRB, &
  & 0.16009338E-09_JPRB, 0.15939090E-09_JPRB, 0.15861752E-09_JPRB, 0.15779104E-09_JPRB, 0.15694332E-09_JPRB, 0.15610216E-09_JPRB, &
  & 0.15529507E-09_JPRB, 0.15453250E-09_JPRB, 0.15381968E-09_JPRB, 0.15315607E-09_JPRB, 0.15253215E-09_JPRB, 0.15194190E-09_JPRB, &
  & 0.15137125E-09_JPRB, 0.15080671E-09_JPRB, 0.15023163E-09_JPRB, 0.14962245E-09_JPRB, 0.14896311E-09_JPRB, 0.14823662E-09_JPRB, &
  & 0.14743537E-09_JPRB, 0.14656329E-09_JPRB, 0.14545175E-09_JPRB, 0.14338040E-09_JPRB /)

RGHG8(:,29, 1) = (/ &
  & 0.13806357E-09_JPRB, 0.13919792E-09_JPRB, 0.13992862E-09_JPRB, 0.14065560E-09_JPRB, 0.14145719E-09_JPRB, 0.14237021E-09_JPRB, &
  & 0.14338589E-09_JPRB, 0.14448548E-09_JPRB, 0.14564572E-09_JPRB, 0.14685736E-09_JPRB, 0.14810930E-09_JPRB, 0.14939089E-09_JPRB, &
  & 0.15068662E-09_JPRB, 0.15198201E-09_JPRB, 0.15326625E-09_JPRB, 0.15452672E-09_JPRB, 0.15575020E-09_JPRB, 0.15692059E-09_JPRB, &
  & 0.15802241E-09_JPRB, 0.15904224E-09_JPRB, 0.15997162E-09_JPRB, 0.16080685E-09_JPRB, 0.16154936E-09_JPRB, 0.16219841E-09_JPRB, &
  & 0.16275183E-09_JPRB, 0.16320496E-09_JPRB, 0.16355764E-09_JPRB, 0.16381618E-09_JPRB, 0.16398950E-09_JPRB, 0.16409442E-09_JPRB, &
  & 0.16414695E-09_JPRB, 0.16415658E-09_JPRB, 0.16413407E-09_JPRB, 0.16407360E-09_JPRB, 0.16397349E-09_JPRB, 0.16382641E-09_JPRB, &
  & 0.16362293E-09_JPRB, 0.16336385E-09_JPRB, 0.16304846E-09_JPRB, 0.16267816E-09_JPRB, 0.16224888E-09_JPRB, 0.16175651E-09_JPRB, &
  & 0.16119527E-09_JPRB, 0.16056118E-09_JPRB, 0.15985807E-09_JPRB, 0.15910204E-09_JPRB, 0.15832051E-09_JPRB, 0.15754979E-09_JPRB, &
  & 0.15681029E-09_JPRB, 0.15612117E-09_JPRB, 0.15548306E-09_JPRB, 0.15489288E-09_JPRB, 0.15434380E-09_JPRB, 0.15382515E-09_JPRB, &
  & 0.15332759E-09_JPRB, 0.15283722E-09_JPRB, 0.15233684E-09_JPRB, 0.15180972E-09_JPRB, 0.15123633E-09_JPRB, 0.15060830E-09_JPRB, &
  & 0.14992330E-09_JPRB, 0.14916418E-09_JPRB, 0.14824243E-09_JPRB, 0.14646231E-09_JPRB /)

RGHG8(:,30, 1) = (/ &
  & 0.14043305E-09_JPRB, 0.14149205E-09_JPRB, 0.14216944E-09_JPRB, 0.14282353E-09_JPRB, 0.14354784E-09_JPRB, 0.14436333E-09_JPRB, &
  & 0.14527203E-09_JPRB, 0.14624807E-09_JPRB, 0.14727733E-09_JPRB, 0.14834964E-09_JPRB, 0.14946729E-09_JPRB, 0.15062107E-09_JPRB, &
  & 0.15180066E-09_JPRB, 0.15299627E-09_JPRB, 0.15419513E-09_JPRB, 0.15538275E-09_JPRB, 0.15654412E-09_JPRB, 0.15766373E-09_JPRB, &
  & 0.15872573E-09_JPRB, 0.15971849E-09_JPRB, 0.16063535E-09_JPRB, 0.16147400E-09_JPRB, 0.16223263E-09_JPRB, 0.16290971E-09_JPRB, &
  & 0.16349828E-09_JPRB, 0.16398712E-09_JPRB, 0.16437680E-09_JPRB, 0.16466455E-09_JPRB, 0.16485767E-09_JPRB, 0.16496951E-09_JPRB, &
  & 0.16501557E-09_JPRB, 0.16500704E-09_JPRB, 0.16495467E-09_JPRB, 0.16486361E-09_JPRB, 0.16473478E-09_JPRB, 0.16456901E-09_JPRB, &
  & 0.16436227E-09_JPRB, 0.16411568E-09_JPRB, 0.16382860E-09_JPRB, 0.16349842E-09_JPRB, 0.16311799E-09_JPRB, 0.16267958E-09_JPRB, &
  & 0.16217579E-09_JPRB, 0.16160120E-09_JPRB, 0.16095826E-09_JPRB, 0.16026241E-09_JPRB, 0.15954113E-09_JPRB, 0.15882451E-09_JPRB, &
  & 0.15814440E-09_JPRB, 0.15751153E-09_JPRB, 0.15693075E-09_JPRB, 0.15639692E-09_JPRB, 0.15590057E-09_JPRB, 0.15543547E-09_JPRB, &
  & 0.15498933E-09_JPRB, 0.15455141E-09_JPRB, 0.15410695E-09_JPRB, 0.15363903E-09_JPRB, 0.15313652E-09_JPRB, 0.15259016E-09_JPRB, &
  & 0.15200669E-09_JPRB, 0.15137344E-09_JPRB, 0.15061281E-09_JPRB, 0.14912076E-09_JPRB /)

RGHG8(:,31, 1) = (/ &
  & 0.14275503E-09_JPRB, 0.14373186E-09_JPRB, 0.14434191E-09_JPRB, 0.14493019E-09_JPRB, 0.14556932E-09_JPRB, 0.14629382E-09_JPRB, &
  & 0.14709527E-09_JPRB, 0.14795712E-09_JPRB, 0.14886124E-09_JPRB, 0.14980328E-09_JPRB, 0.15079138E-09_JPRB, 0.15182117E-09_JPRB, &
  & 0.15288765E-09_JPRB, 0.15398263E-09_JPRB, 0.15509660E-09_JPRB, 0.15621318E-09_JPRB, 0.15731526E-09_JPRB, 0.15838433E-09_JPRB, &
  & 0.15940521E-09_JPRB, 0.16036653E-09_JPRB, 0.16126070E-09_JPRB, 0.16208682E-09_JPRB, 0.16284239E-09_JPRB, 0.16352253E-09_JPRB, &
  & 0.16411850E-09_JPRB, 0.16462137E-09_JPRB, 0.16502670E-09_JPRB, 0.16533067E-09_JPRB, 0.16553889E-09_JPRB, 0.16565986E-09_JPRB, &
  & 0.16570909E-09_JPRB, 0.16569686E-09_JPRB, 0.16563222E-09_JPRB, 0.16552867E-09_JPRB, 0.16538786E-09_JPRB, 0.16521801E-09_JPRB, &
  & 0.16501810E-09_JPRB, 0.16479038E-09_JPRB, 0.16453226E-09_JPRB, 0.16423905E-09_JPRB, 0.16390124E-09_JPRB, 0.16350893E-09_JPRB, &
  & 0.16305267E-09_JPRB, 0.16252709E-09_JPRB, 0.16193585E-09_JPRB, 0.16129222E-09_JPRB, 0.16062163E-09_JPRB, 0.15995831E-09_JPRB, &
  & 0.15932410E-09_JPRB, 0.15873905E-09_JPRB, 0.15820222E-09_JPRB, 0.15770862E-09_JPRB, 0.15725242E-09_JPRB, 0.15682336E-09_JPRB, &
  & 0.15641433E-09_JPRB, 0.15601286E-09_JPRB, 0.15560746E-09_JPRB, 0.15518482E-09_JPRB, 0.15473434E-09_JPRB, 0.15425618E-09_JPRB, &
  & 0.15375286E-09_JPRB, 0.15322522E-09_JPRB, 0.15257788E-09_JPRB, 0.15138353E-09_JPRB /)

RGHG8(:,32, 1) = (/ &
  & 0.14499990E-09_JPRB, 0.14588822E-09_JPRB, 0.14643359E-09_JPRB, 0.14695044E-09_JPRB, 0.14751395E-09_JPRB, 0.14814794E-09_JPRB, &
  & 0.14885350E-09_JPRB, 0.14960833E-09_JPRB, 0.15039947E-09_JPRB, 0.15122231E-09_JPRB, 0.15208981E-09_JPRB, 0.15300104E-09_JPRB, &
  & 0.15396014E-09_JPRB, 0.15496383E-09_JPRB, 0.15600014E-09_JPRB, 0.15705176E-09_JPRB, 0.15809867E-09_JPRB, 0.15912091E-09_JPRB, &
  & 0.16010002E-09_JPRB, 0.16102632E-09_JPRB, 0.16189260E-09_JPRB, 0.16269570E-09_JPRB, 0.16343032E-09_JPRB, 0.16409379E-09_JPRB, &
  & 0.16467440E-09_JPRB, 0.16516731E-09_JPRB, 0.16556866E-09_JPRB, 0.16587440E-09_JPRB, 0.16608942E-09_JPRB, 0.16621769E-09_JPRB, &
  & 0.16627424E-09_JPRB, 0.16626620E-09_JPRB, 0.16620277E-09_JPRB, 0.16610015E-09_JPRB, 0.16596113E-09_JPRB, 0.16579817E-09_JPRB, &
  & 0.16561337E-09_JPRB, 0.16540713E-09_JPRB, 0.16517739E-09_JPRB, 0.16491644E-09_JPRB, 0.16461382E-09_JPRB, 0.16425794E-09_JPRB, &
  & 0.16383940E-09_JPRB, 0.16335311E-09_JPRB, 0.16280256E-09_JPRB, 0.16220413E-09_JPRB, 0.16158130E-09_JPRB, 0.16096098E-09_JPRB, &
  & 0.16037248E-09_JPRB, 0.15982557E-09_JPRB, 0.15932389E-09_JPRB, 0.15886237E-09_JPRB, 0.15843392E-09_JPRB, 0.15803252E-09_JPRB, &
  & 0.15764789E-09_JPRB, 0.15727285E-09_JPRB, 0.15689568E-09_JPRB, 0.15650559E-09_JPRB, 0.15609683E-09_JPRB, 0.15566896E-09_JPRB, &
  & 0.15523163E-09_JPRB, 0.15477111E-09_JPRB, 0.15424660E-09_JPRB, 0.15323101E-09_JPRB /)

RGHG8(:,33, 1) = (/ &
  & 0.14714399E-09_JPRB, 0.14793528E-09_JPRB, 0.14841750E-09_JPRB, 0.14887133E-09_JPRB, 0.14936188E-09_JPRB, 0.14991852E-09_JPRB, &
  & 0.15053644E-09_JPRB, 0.15119811E-09_JPRB, 0.15188742E-09_JPRB, 0.15260461E-09_JPRB, 0.15335994E-09_JPRB, 0.15416093E-09_JPRB, &
  & 0.15501622E-09_JPRB, 0.15592874E-09_JPRB, 0.15689303E-09_JPRB, 0.15788945E-09_JPRB, 0.15889252E-09_JPRB, 0.15987757E-09_JPRB, &
  & 0.16082433E-09_JPRB, 0.16171836E-09_JPRB, 0.16255304E-09_JPRB, 0.16332354E-09_JPRB, 0.16402735E-09_JPRB, 0.16465372E-09_JPRB, &
  & 0.16520070E-09_JPRB, 0.16566275E-09_JPRB, 0.16604090E-09_JPRB, 0.16633508E-09_JPRB, 0.16654685E-09_JPRB, 0.16667784E-09_JPRB, &
  & 0.16674254E-09_JPRB, 0.16674281E-09_JPRB, 0.16669088E-09_JPRB, 0.16659893E-09_JPRB, 0.16647221E-09_JPRB, 0.16632459E-09_JPRB, &
  & 0.16615870E-09_JPRB, 0.16597577E-09_JPRB, 0.16577287E-09_JPRB, 0.16554096E-09_JPRB, 0.16526723E-09_JPRB, 0.16493919E-09_JPRB, &
  & 0.16454815E-09_JPRB, 0.16408988E-09_JPRB, 0.16357281E-09_JPRB, 0.16301124E-09_JPRB, 0.16242779E-09_JPRB, 0.16185141E-09_JPRB, &
  & 0.16130015E-09_JPRB, 0.16078879E-09_JPRB, 0.16031663E-09_JPRB, 0.15988041E-09_JPRB, 0.15947516E-09_JPRB, 0.15909234E-09_JPRB, &
  & 0.15872711E-09_JPRB, 0.15837048E-09_JPRB, 0.15801448E-09_JPRB, 0.15764920E-09_JPRB, 0.15727140E-09_JPRB, 0.15688298E-09_JPRB, &
  & 0.15648799E-09_JPRB, 0.15608867E-09_JPRB, 0.15560905E-09_JPRB, 0.15475946E-09_JPRB /)

RGHG8(:,34, 1) = (/ &
  & 0.14915275E-09_JPRB, 0.14985958E-09_JPRB, 0.15028163E-09_JPRB, 0.15067740E-09_JPRB, 0.15110777E-09_JPRB, 0.15159451E-09_JPRB, &
  & 0.15213787E-09_JPRB, 0.15271774E-09_JPRB, 0.15331870E-09_JPRB, 0.15394172E-09_JPRB, 0.15459606E-09_JPRB, 0.15529557E-09_JPRB, &
  & 0.15605656E-09_JPRB, 0.15688764E-09_JPRB, 0.15778527E-09_JPRB, 0.15873185E-09_JPRB, 0.15969737E-09_JPRB, 0.16065298E-09_JPRB, &
  & 0.16157367E-09_JPRB, 0.16243804E-09_JPRB, 0.16324074E-09_JPRB, 0.16397804E-09_JPRB, 0.16463705E-09_JPRB, 0.16521644E-09_JPRB, &
  & 0.16571071E-09_JPRB, 0.16612571E-09_JPRB, 0.16646576E-09_JPRB, 0.16673346E-09_JPRB, 0.16693120E-09_JPRB, 0.16705964E-09_JPRB, &
  & 0.16712959E-09_JPRB, 0.16714102E-09_JPRB, 0.16710711E-09_JPRB, 0.16703267E-09_JPRB, 0.16692696E-09_JPRB, 0.16680153E-09_JPRB, &
  & 0.16665880E-09_JPRB, 0.16650123E-09_JPRB, 0.16632452E-09_JPRB, 0.16611777E-09_JPRB, 0.16586764E-09_JPRB, 0.16556066E-09_JPRB, &
  & 0.16518813E-09_JPRB, 0.16475082E-09_JPRB, 0.16425697E-09_JPRB, 0.16372577E-09_JPRB, 0.16317973E-09_JPRB, 0.16263818E-09_JPRB, &
  & 0.16212356E-09_JPRB, 0.16164112E-09_JPRB, 0.16119434E-09_JPRB, 0.16078001E-09_JPRB, 0.16039112E-09_JPRB, 0.16002462E-09_JPRB, &
  & 0.15967315E-09_JPRB, 0.15933163E-09_JPRB, 0.15899032E-09_JPRB, 0.15864469E-09_JPRB, 0.15829044E-09_JPRB, 0.15792954E-09_JPRB, &
  & 0.15756817E-09_JPRB, 0.15719390E-09_JPRB, 0.15677727E-09_JPRB, 0.15600157E-09_JPRB /)

RGHG8(:,35, 1) = (/ &
  & 0.15102902E-09_JPRB, 0.15164955E-09_JPRB, 0.15202002E-09_JPRB, 0.15236670E-09_JPRB, 0.15274219E-09_JPRB, 0.15317217E-09_JPRB, &
  & 0.15365052E-09_JPRB, 0.15416030E-09_JPRB, 0.15468422E-09_JPRB, 0.15522418E-09_JPRB, 0.15578779E-09_JPRB, 0.15639399E-09_JPRB, &
  & 0.15706557E-09_JPRB, 0.15781951E-09_JPRB, 0.15865721E-09_JPRB, 0.15956095E-09_JPRB, 0.16049669E-09_JPRB, 0.16143054E-09_JPRB, &
  & 0.16233009E-09_JPRB, 0.16317067E-09_JPRB, 0.16394530E-09_JPRB, 0.16464105E-09_JPRB, 0.16525062E-09_JPRB, 0.16576886E-09_JPRB, &
  & 0.16620094E-09_JPRB, 0.16655509E-09_JPRB, 0.16684218E-09_JPRB, 0.16707223E-09_JPRB, 0.16724357E-09_JPRB, 0.16736297E-09_JPRB, &
  & 0.16743221E-09_JPRB, 0.16745581E-09_JPRB, 0.16743952E-09_JPRB, 0.16738734E-09_JPRB, 0.16730818E-09_JPRB, 0.16720841E-09_JPRB, &
  & 0.16709296E-09_JPRB, 0.16696326E-09_JPRB, 0.16681329E-09_JPRB, 0.16663169E-09_JPRB, 0.16640470E-09_JPRB, 0.16611724E-09_JPRB, &
  & 0.16576196E-09_JPRB, 0.16533930E-09_JPRB, 0.16486570E-09_JPRB, 0.16436116E-09_JPRB, 0.16384340E-09_JPRB, 0.16333696E-09_JPRB, &
  & 0.16284969E-09_JPRB, 0.16239358E-09_JPRB, 0.16196772E-09_JPRB, 0.16156879E-09_JPRB, 0.16119435E-09_JPRB, 0.16083929E-09_JPRB, &
  & 0.16050011E-09_JPRB, 0.16016875E-09_JPRB, 0.15984121E-09_JPRB, 0.15950975E-09_JPRB, 0.15917419E-09_JPRB, 0.15883471E-09_JPRB, &
  & 0.15849361E-09_JPRB, 0.15815101E-09_JPRB, 0.15774926E-09_JPRB, 0.15705068E-09_JPRB /)

RGHG8(:,36, 1) = (/ &
  & 0.15277002E-09_JPRB, 0.15331471E-09_JPRB, 0.15363677E-09_JPRB, 0.15393850E-09_JPRB, 0.15427055E-09_JPRB, 0.15464911E-09_JPRB, &
  & 0.15507318E-09_JPRB, 0.15552190E-09_JPRB, 0.15597991E-09_JPRB, 0.15644501E-09_JPRB, 0.15692786E-09_JPRB, 0.15744818E-09_JPRB, &
  & 0.15803461E-09_JPRB, 0.15871254E-09_JPRB, 0.15949114E-09_JPRB, 0.16035283E-09_JPRB, 0.16126432E-09_JPRB, 0.16218347E-09_JPRB, &
  & 0.16307020E-09_JPRB, 0.16389554E-09_JPRB, 0.16464052E-09_JPRB, 0.16529181E-09_JPRB, 0.16584022E-09_JPRB, 0.16628690E-09_JPRB, &
  & 0.16664294E-09_JPRB, 0.16692656E-09_JPRB, 0.16715353E-09_JPRB, 0.16733553E-09_JPRB, 0.16747610E-09_JPRB, 0.16757933E-09_JPRB, &
  & 0.16764409E-09_JPRB, 0.16767521E-09_JPRB, 0.16767208E-09_JPRB, 0.16764071E-09_JPRB, 0.16758464E-09_JPRB, 0.16751013E-09_JPRB, &
  & 0.16742133E-09_JPRB, 0.16731823E-09_JPRB, 0.16719570E-09_JPRB, 0.16704352E-09_JPRB, 0.16684579E-09_JPRB, 0.16658656E-09_JPRB, &
  & 0.16625532E-09_JPRB, 0.16585512E-09_JPRB, 0.16540265E-09_JPRB, 0.16492009E-09_JPRB, 0.16443247E-09_JPRB, 0.16395066E-09_JPRB, &
  & 0.16349051E-09_JPRB, 0.16305389E-09_JPRB, 0.16264268E-09_JPRB, 0.16225660E-09_JPRB, 0.16189211E-09_JPRB, 0.16154761E-09_JPRB, &
  & 0.16121730E-09_JPRB, 0.16089717E-09_JPRB, 0.16057959E-09_JPRB, 0.16026190E-09_JPRB, 0.15994023E-09_JPRB, 0.15961692E-09_JPRB, &
  & 0.15929508E-09_JPRB, 0.15896578E-09_JPRB, 0.15859863E-09_JPRB, 0.15794108E-09_JPRB /)

RGHG8(:,37, 1) = (/ &
  & 0.15439144E-09_JPRB, 0.15485921E-09_JPRB, 0.15513774E-09_JPRB, 0.15540194E-09_JPRB, 0.15569390E-09_JPRB, 0.15603172E-09_JPRB, &
  & 0.15640825E-09_JPRB, 0.15680486E-09_JPRB, 0.15720440E-09_JPRB, 0.15760344E-09_JPRB, 0.15801327E-09_JPRB, 0.15845332E-09_JPRB, &
  & 0.15896000E-09_JPRB, 0.15956142E-09_JPRB, 0.16028151E-09_JPRB, 0.16110539E-09_JPRB, 0.16199329E-09_JPRB, 0.16289949E-09_JPRB, &
  & 0.16377660E-09_JPRB, 0.16458461E-09_JPRB, 0.16529350E-09_JPRB, 0.16588717E-09_JPRB, 0.16635748E-09_JPRB, 0.16672057E-09_JPRB, &
  & 0.16699625E-09_JPRB, 0.16721012E-09_JPRB, 0.16737965E-09_JPRB, 0.16751960E-09_JPRB, 0.16763148E-09_JPRB, 0.16771898E-09_JPRB, &
  & 0.16777926E-09_JPRB, 0.16781242E-09_JPRB, 0.16781845E-09_JPRB, 0.16779987E-09_JPRB, 0.16776017E-09_JPRB, 0.16770467E-09_JPRB, &
  & 0.16763604E-09_JPRB, 0.16755476E-09_JPRB, 0.16745676E-09_JPRB, 0.16733276E-09_JPRB, 0.16716850E-09_JPRB, 0.16694686E-09_JPRB, &
  & 0.16665404E-09_JPRB, 0.16628780E-09_JPRB, 0.16586352E-09_JPRB, 0.16540906E-09_JPRB, 0.16494546E-09_JPRB, 0.16449075E-09_JPRB, &
  & 0.16404986E-09_JPRB, 0.16362911E-09_JPRB, 0.16323035E-09_JPRB, 0.16285276E-09_JPRB, 0.16249693E-09_JPRB, 0.16216040E-09_JPRB, &
  & 0.16184074E-09_JPRB, 0.16153154E-09_JPRB, 0.16122728E-09_JPRB, 0.16092097E-09_JPRB, 0.16061216E-09_JPRB, 0.16030163E-09_JPRB, &
  & 0.15999291E-09_JPRB, 0.15968411E-09_JPRB, 0.15933405E-09_JPRB, 0.15872678E-09_JPRB /)

RGHG8(:,38, 1) = (/ &
  & 0.15589061E-09_JPRB, 0.15628868E-09_JPRB, 0.15652701E-09_JPRB, 0.15675787E-09_JPRB, 0.15701734E-09_JPRB, 0.15732003E-09_JPRB, &
  & 0.15765673E-09_JPRB, 0.15800763E-09_JPRB, 0.15835525E-09_JPRB, 0.15869624E-09_JPRB, 0.15903817E-09_JPRB, 0.15940924E-09_JPRB, &
  & 0.15983531E-09_JPRB, 0.16036422E-09_JPRB, 0.16101787E-09_JPRB, 0.16180063E-09_JPRB, 0.16266719E-09_JPRB, 0.16355999E-09_JPRB, &
  & 0.16442175E-09_JPRB, 0.16520028E-09_JPRB, 0.16585447E-09_JPRB, 0.16636745E-09_JPRB, 0.16675217E-09_JPRB, 0.16703319E-09_JPRB, &
  & 0.16724024E-09_JPRB, 0.16740091E-09_JPRB, 0.16752939E-09_JPRB, 0.16763900E-09_JPRB, 0.16773202E-09_JPRB, 0.16780782E-09_JPRB, &
  & 0.16786465E-09_JPRB, 0.16789814E-09_JPRB, 0.16790908E-09_JPRB, 0.16789758E-09_JPRB, 0.16786804E-09_JPRB, 0.16782432E-09_JPRB, &
  & 0.16776944E-09_JPRB, 0.16770382E-09_JPRB, 0.16762411E-09_JPRB, 0.16752287E-09_JPRB, 0.16738749E-09_JPRB, 0.16720196E-09_JPRB, &
  & 0.16695138E-09_JPRB, 0.16662792E-09_JPRB, 0.16624392E-09_JPRB, 0.16582150E-09_JPRB, 0.16538765E-09_JPRB, 0.16495490E-09_JPRB, &
  & 0.16453312E-09_JPRB, 0.16412630E-09_JPRB, 0.16373621E-09_JPRB, 0.16336663E-09_JPRB, 0.16301843E-09_JPRB, 0.16269300E-09_JPRB, &
  & 0.16238683E-09_JPRB, 0.16209266E-09_JPRB, 0.16180332E-09_JPRB, 0.16151123E-09_JPRB, 0.16121375E-09_JPRB, 0.16091312E-09_JPRB, &
  & 0.16061627E-09_JPRB, 0.16032062E-09_JPRB, 0.15999453E-09_JPRB, 0.15943045E-09_JPRB /)

RGHG8(:,39, 1) = (/ &
  & 0.15726509E-09_JPRB, 0.15759717E-09_JPRB, 0.15780169E-09_JPRB, 0.15800337E-09_JPRB, 0.15823753E-09_JPRB, 0.15851040E-09_JPRB, &
  & 0.15881337E-09_JPRB, 0.15912328E-09_JPRB, 0.15942518E-09_JPRB, 0.15971260E-09_JPRB, 0.16000090E-09_JPRB, 0.16030424E-09_JPRB, &
  & 0.16066593E-09_JPRB, 0.16111670E-09_JPRB, 0.16170705E-09_JPRB, 0.16243880E-09_JPRB, 0.16327764E-09_JPRB, 0.16415179E-09_JPRB, &
  & 0.16498365E-09_JPRB, 0.16570803E-09_JPRB, 0.16628422E-09_JPRB, 0.16671281E-09_JPRB, 0.16701776E-09_JPRB, 0.16723695E-09_JPRB, &
  & 0.16739764E-09_JPRB, 0.16752369E-09_JPRB, 0.16762744E-09_JPRB, 0.16771877E-09_JPRB, 0.16779982E-09_JPRB, 0.16786873E-09_JPRB, &
  & 0.16792268E-09_JPRB, 0.16795634E-09_JPRB, 0.16796928E-09_JPRB, 0.16796184E-09_JPRB, 0.16793801E-09_JPRB, 0.16790172E-09_JPRB, &
  & 0.16785592E-09_JPRB, 0.16780100E-09_JPRB, 0.16773420E-09_JPRB, 0.16764942E-09_JPRB, 0.16753625E-09_JPRB, 0.16738062E-09_JPRB, &
  & 0.16716745E-09_JPRB, 0.16688821E-09_JPRB, 0.16654590E-09_JPRB, 0.16616256E-09_JPRB, 0.16575753E-09_JPRB, 0.16534965E-09_JPRB, &
  & 0.16494661E-09_JPRB, 0.16455184E-09_JPRB, 0.16417141E-09_JPRB, 0.16380934E-09_JPRB, 0.16347111E-09_JPRB, 0.16315922E-09_JPRB, &
  & 0.16286918E-09_JPRB, 0.16259527E-09_JPRB, 0.16232504E-09_JPRB, 0.16205022E-09_JPRB, 0.16176502E-09_JPRB, 0.16147411E-09_JPRB, &
  & 0.16118665E-09_JPRB, 0.16090546E-09_JPRB, 0.16059894E-09_JPRB, 0.16007691E-09_JPRB /)

RGHG8(:,40, 1) = (/ &
  & 0.15850182E-09_JPRB, 0.15878071E-09_JPRB, 0.15895578E-09_JPRB, 0.15913559E-09_JPRB, 0.15934642E-09_JPRB, 0.15959724E-09_JPRB, &
  & 0.15986917E-09_JPRB, 0.16014301E-09_JPRB, 0.16040264E-09_JPRB, 0.16064856E-09_JPRB, 0.16088517E-09_JPRB, 0.16114232E-09_JPRB, &
  & 0.16143786E-09_JPRB, 0.16182791E-09_JPRB, 0.16234727E-09_JPRB, 0.16302878E-09_JPRB, 0.16382894E-09_JPRB, 0.16466596E-09_JPRB, &
  & 0.16544881E-09_JPRB, 0.16609976E-09_JPRB, 0.16659282E-09_JPRB, 0.16694510E-09_JPRB, 0.16719169E-09_JPRB, 0.16736854E-09_JPRB, &
  & 0.16750071E-09_JPRB, 0.16760596E-09_JPRB, 0.16769552E-09_JPRB, 0.16777617E-09_JPRB, 0.16785009E-09_JPRB, 0.16791481E-09_JPRB, &
  & 0.16796638E-09_JPRB, 0.16799971E-09_JPRB, 0.16801334E-09_JPRB, 0.16800794E-09_JPRB, 0.16798735E-09_JPRB, 0.16795575E-09_JPRB, &
  & 0.16791600E-09_JPRB, 0.16786847E-09_JPRB, 0.16781089E-09_JPRB, 0.16773805E-09_JPRB, 0.16764130E-09_JPRB, 0.16750837E-09_JPRB, &
  & 0.16732619E-09_JPRB, 0.16708374E-09_JPRB, 0.16678328E-09_JPRB, 0.16643571E-09_JPRB, 0.16606437E-09_JPRB, 0.16568225E-09_JPRB, &
  & 0.16529772E-09_JPRB, 0.16491791E-09_JPRB, 0.16454688E-09_JPRB, 0.16419319E-09_JPRB, 0.16386642E-09_JPRB, 0.16356899E-09_JPRB, &
  & 0.16330108E-09_JPRB, 0.16304905E-09_JPRB, 0.16280288E-09_JPRB, 0.16254806E-09_JPRB, 0.16227948E-09_JPRB, 0.16200004E-09_JPRB, &
  & 0.16172348E-09_JPRB, 0.16145557E-09_JPRB, 0.16116800E-09_JPRB, 0.16068392E-09_JPRB /)

RGHG8(:,41, 1) = (/ &
  & 0.15960086E-09_JPRB, 0.15983678E-09_JPRB, 0.15998837E-09_JPRB, 0.16014898E-09_JPRB, 0.16034456E-09_JPRB, 0.16057417E-09_JPRB, &
  & 0.16082052E-09_JPRB, 0.16106130E-09_JPRB, 0.16128641E-09_JPRB, 0.16149376E-09_JPRB, 0.16169660E-09_JPRB, 0.16190677E-09_JPRB, &
  & 0.16216115E-09_JPRB, 0.16248677E-09_JPRB, 0.16294630E-09_JPRB, 0.16356595E-09_JPRB, 0.16432163E-09_JPRB, 0.16511185E-09_JPRB, &
  & 0.16582327E-09_JPRB, 0.16639562E-09_JPRB, 0.16681274E-09_JPRB, 0.16710483E-09_JPRB, 0.16731053E-09_JPRB, 0.16745852E-09_JPRB, &
  & 0.16757348E-09_JPRB, 0.16766585E-09_JPRB, 0.16774711E-09_JPRB, 0.16782183E-09_JPRB, 0.16789126E-09_JPRB, 0.16795339E-09_JPRB, &
  & 0.16800292E-09_JPRB, 0.16803534E-09_JPRB, 0.16804867E-09_JPRB, 0.16804408E-09_JPRB, 0.16802523E-09_JPRB, 0.16799659E-09_JPRB, &
  & 0.16796101E-09_JPRB, 0.16791890E-09_JPRB, 0.16786814E-09_JPRB, 0.16780445E-09_JPRB, 0.16772042E-09_JPRB, 0.16760557E-09_JPRB, &
  & 0.16744776E-09_JPRB, 0.16723709E-09_JPRB, 0.16697063E-09_JPRB, 0.16666041E-09_JPRB, 0.16631961E-09_JPRB, 0.16596378E-09_JPRB, &
  & 0.16560153E-09_JPRB, 0.16523657E-09_JPRB, 0.16487572E-09_JPRB, 0.16453193E-09_JPRB, 0.16421503E-09_JPRB, 0.16393682E-09_JPRB, &
  & 0.16368938E-09_JPRB, 0.16346399E-09_JPRB, 0.16324241E-09_JPRB, 0.16301260E-09_JPRB, 0.16276444E-09_JPRB, 0.16250208E-09_JPRB, &
  & 0.16224050E-09_JPRB, 0.16198760E-09_JPRB, 0.16171828E-09_JPRB, 0.16126822E-09_JPRB /)

RGHG8(:,42, 1) = (/ &
  & 0.16057092E-09_JPRB, 0.16077269E-09_JPRB, 0.16090713E-09_JPRB, 0.16105267E-09_JPRB, 0.16123383E-09_JPRB, 0.16144766E-09_JPRB, &
  & 0.16167043E-09_JPRB, 0.16188316E-09_JPRB, 0.16207838E-09_JPRB, 0.16225783E-09_JPRB, 0.16242935E-09_JPRB, 0.16261113E-09_JPRB, &
  & 0.16282234E-09_JPRB, 0.16310726E-09_JPRB, 0.16350599E-09_JPRB, 0.16406961E-09_JPRB, 0.16476863E-09_JPRB, 0.16549719E-09_JPRB, &
  & 0.16613681E-09_JPRB, 0.16662523E-09_JPRB, 0.16697649E-09_JPRB, 0.16722104E-09_JPRB, 0.16739660E-09_JPRB, 0.16752535E-09_JPRB, &
  & 0.16762861E-09_JPRB, 0.16771325E-09_JPRB, 0.16778992E-09_JPRB, 0.16786117E-09_JPRB, 0.16792841E-09_JPRB, 0.16798843E-09_JPRB, &
  & 0.16803603E-09_JPRB, 0.16806689E-09_JPRB, 0.16807927E-09_JPRB, 0.16807450E-09_JPRB, 0.16805636E-09_JPRB, 0.16802949E-09_JPRB, &
  & 0.16799684E-09_JPRB, 0.16795877E-09_JPRB, 0.16791343E-09_JPRB, 0.16785708E-09_JPRB, 0.16778338E-09_JPRB, 0.16768344E-09_JPRB, &
  & 0.16754664E-09_JPRB, 0.16736242E-09_JPRB, 0.16712759E-09_JPRB, 0.16684744E-09_JPRB, 0.16653730E-09_JPRB, 0.16620876E-09_JPRB, &
  & 0.16586880E-09_JPRB, 0.16552142E-09_JPRB, 0.16517408E-09_JPRB, 0.16483774E-09_JPRB, 0.16453566E-09_JPRB, 0.16427379E-09_JPRB, &
  & 0.16405083E-09_JPRB, 0.16385002E-09_JPRB, 0.16365544E-09_JPRB, 0.16345131E-09_JPRB, 0.16322843E-09_JPRB, 0.16298936E-09_JPRB, &
  & 0.16274725E-09_JPRB, 0.16251285E-09_JPRB, 0.16226169E-09_JPRB, 0.16184208E-09_JPRB /)

RGHG8(:,43, 1) = (/ &
  & 0.16142679E-09_JPRB, 0.16160501E-09_JPRB, 0.16172375E-09_JPRB, 0.16185786E-09_JPRB, 0.16202767E-09_JPRB, 0.16222701E-09_JPRB, &
  & 0.16243007E-09_JPRB, 0.16261940E-09_JPRB, 0.16279136E-09_JPRB, 0.16294752E-09_JPRB, 0.16309745E-09_JPRB, 0.16325294E-09_JPRB, &
  & 0.16343735E-09_JPRB, 0.16367782E-09_JPRB, 0.16403266E-09_JPRB, 0.16453608E-09_JPRB, 0.16517633E-09_JPRB, 0.16583251E-09_JPRB, &
  & 0.16638967E-09_JPRB, 0.16680722E-09_JPRB, 0.16710242E-09_JPRB, 0.16731005E-09_JPRB, 0.16746254E-09_JPRB, 0.16757806E-09_JPRB, &
  & 0.16767322E-09_JPRB, 0.16775356E-09_JPRB, 0.16782770E-09_JPRB, 0.16789783E-09_JPRB, 0.16796362E-09_JPRB, 0.16802229E-09_JPRB, &
  & 0.16806770E-09_JPRB, 0.16809643E-09_JPRB, 0.16810722E-09_JPRB, 0.16810153E-09_JPRB, 0.16808330E-09_JPRB, 0.16805740E-09_JPRB, &
  & 0.16802675E-09_JPRB, 0.16799176E-09_JPRB, 0.16795079E-09_JPRB, 0.16790060E-09_JPRB, 0.16783588E-09_JPRB, 0.16774901E-09_JPRB, &
  & 0.16763027E-09_JPRB, 0.16746964E-09_JPRB, 0.16726152E-09_JPRB, 0.16701068E-09_JPRB, 0.16672846E-09_JPRB, 0.16642646E-09_JPRB, &
  & 0.16611092E-09_JPRB, 0.16578430E-09_JPRB, 0.16545040E-09_JPRB, 0.16512924E-09_JPRB, 0.16484014E-09_JPRB, 0.16459949E-09_JPRB, &
  & 0.16439927E-09_JPRB, 0.16422304E-09_JPRB, 0.16405356E-09_JPRB, 0.16387562E-09_JPRB, 0.16368035E-09_JPRB, 0.16346860E-09_JPRB, &
  & 0.16325234E-09_JPRB, 0.16303922E-09_JPRB, 0.16280832E-09_JPRB, 0.16241886E-09_JPRB /)

RGHG8(:,44, 1) = (/ &
  & 0.16218965E-09_JPRB, 0.16234968E-09_JPRB, 0.16245845E-09_JPRB, 0.16258207E-09_JPRB, 0.16274217E-09_JPRB, 0.16292907E-09_JPRB, &
  & 0.16311580E-09_JPRB, 0.16328751E-09_JPRB, 0.16344084E-09_JPRB, 0.16358004E-09_JPRB, 0.16371156E-09_JPRB, 0.16384782E-09_JPRB, &
  & 0.16400604E-09_JPRB, 0.16421775E-09_JPRB, 0.16452253E-09_JPRB, 0.16497925E-09_JPRB, 0.16555490E-09_JPRB, 0.16613466E-09_JPRB, &
  & 0.16660870E-09_JPRB, 0.16695509E-09_JPRB, 0.16720283E-09_JPRB, 0.16738053E-09_JPRB, 0.16751549E-09_JPRB, 0.16762119E-09_JPRB, &
  & 0.16771105E-09_JPRB, 0.16778939E-09_JPRB, 0.16786285E-09_JPRB, 0.16793288E-09_JPRB, 0.16799882E-09_JPRB, 0.16805578E-09_JPRB, &
  & 0.16809892E-09_JPRB, 0.16812496E-09_JPRB, 0.16813351E-09_JPRB, 0.16812629E-09_JPRB, 0.16810742E-09_JPRB, 0.16808180E-09_JPRB, &
  & 0.16805249E-09_JPRB, 0.16801990E-09_JPRB, 0.16798252E-09_JPRB, 0.16793765E-09_JPRB, 0.16788081E-09_JPRB, 0.16780567E-09_JPRB, &
  & 0.16770373E-09_JPRB, 0.16756518E-09_JPRB, 0.16738289E-09_JPRB, 0.16715859E-09_JPRB, 0.16690256E-09_JPRB, 0.16662705E-09_JPRB, &
  & 0.16633669E-09_JPRB, 0.16603229E-09_JPRB, 0.16571987E-09_JPRB, 0.16541436E-09_JPRB, 0.16514642E-09_JPRB, 0.16492757E-09_JPRB, &
  & 0.16474991E-09_JPRB, 0.16459660E-09_JPRB, 0.16444962E-09_JPRB, 0.16429649E-09_JPRB, 0.16412834E-09_JPRB, 0.16394600E-09_JPRB, &
  & 0.16375878E-09_JPRB, 0.16357060E-09_JPRB, 0.16336298E-09_JPRB, 0.16300634E-09_JPRB /)

RGHG8(:,45, 1) = (/ &
  & 0.16288024E-09_JPRB, 0.16302734E-09_JPRB, 0.16312807E-09_JPRB, 0.16324354E-09_JPRB, 0.16339477E-09_JPRB, 0.16357184E-09_JPRB, &
  & 0.16374652E-09_JPRB, 0.16390467E-09_JPRB, 0.16404562E-09_JPRB, 0.16417080E-09_JPRB, 0.16428767E-09_JPRB, 0.16440697E-09_JPRB, &
  & 0.16454339E-09_JPRB, 0.16472475E-09_JPRB, 0.16499227E-09_JPRB, 0.16538927E-09_JPRB, 0.16589942E-09_JPRB, 0.16639637E-09_JPRB, &
  & 0.16679089E-09_JPRB, 0.16707702E-09_JPRB, 0.16728355E-09_JPRB, 0.16743815E-09_JPRB, 0.16755819E-09_JPRB, 0.16765796E-09_JPRB, &
  & 0.16774414E-09_JPRB, 0.16782206E-09_JPRB, 0.16789652E-09_JPRB, 0.16796783E-09_JPRB, 0.16803367E-09_JPRB, 0.16808976E-09_JPRB, &
  & 0.16812994E-09_JPRB, 0.16815289E-09_JPRB, 0.16815871E-09_JPRB, 0.16814940E-09_JPRB, 0.16812927E-09_JPRB, 0.16810342E-09_JPRB, &
  & 0.16807486E-09_JPRB, 0.16804408E-09_JPRB, 0.16800972E-09_JPRB, 0.16796944E-09_JPRB, 0.16791969E-09_JPRB, 0.16785537E-09_JPRB, &
  & 0.16776938E-09_JPRB, 0.16765214E-09_JPRB, 0.16749553E-09_JPRB, 0.16729769E-09_JPRB, 0.16706875E-09_JPRB, 0.16681907E-09_JPRB, &
  & 0.16655495E-09_JPRB, 0.16627630E-09_JPRB, 0.16598557E-09_JPRB, 0.16570660E-09_JPRB, 0.16546164E-09_JPRB, 0.16526835E-09_JPRB, &
  & 0.16511326E-09_JPRB, 0.16498009E-09_JPRB, 0.16485413E-09_JPRB, 0.16472242E-09_JPRB, 0.16457954E-09_JPRB, 0.16442570E-09_JPRB, &
  & 0.16426724E-09_JPRB, 0.16410649E-09_JPRB, 0.16392504E-09_JPRB, 0.16360734E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART1',1,ZHOOK_HANDLE)
END SUBROUTINE PART1




SUBROUTINE PART2
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART2',0,ZHOOK_HANDLE)



RGHG8(:,46, 1) = (/ &
  & 0.16351365E-09_JPRB, 0.16365484E-09_JPRB, 0.16374871E-09_JPRB, 0.16385870E-09_JPRB, 0.16400226E-09_JPRB, 0.16417041E-09_JPRB, &
  & 0.16433709E-09_JPRB, 0.16448748E-09_JPRB, 0.16461849E-09_JPRB, 0.16473288E-09_JPRB, 0.16483706E-09_JPRB, 0.16493924E-09_JPRB, &
  & 0.16505754E-09_JPRB, 0.16520843E-09_JPRB, 0.16543956E-09_JPRB, 0.16578122E-09_JPRB, 0.16621628E-09_JPRB, 0.16662682E-09_JPRB, &
  & 0.16694508E-09_JPRB, 0.16717706E-09_JPRB, 0.16734988E-09_JPRB, 0.16748443E-09_JPRB, 0.16759466E-09_JPRB, 0.16768893E-09_JPRB, &
  & 0.16777377E-09_JPRB, 0.16785323E-09_JPRB, 0.16792928E-09_JPRB, 0.16800261E-09_JPRB, 0.16806961E-09_JPRB, 0.16812340E-09_JPRB, &
  & 0.16816087E-09_JPRB, 0.16818025E-09_JPRB, 0.16818284E-09_JPRB, 0.16817094E-09_JPRB, 0.16814913E-09_JPRB, 0.16812263E-09_JPRB, &
  & 0.16809448E-09_JPRB, 0.16806505E-09_JPRB, 0.16803316E-09_JPRB, 0.16799696E-09_JPRB, 0.16795365E-09_JPRB, 0.16789956E-09_JPRB, &
  & 0.16782895E-09_JPRB, 0.16773363E-09_JPRB, 0.16760388E-09_JPRB, 0.16743536E-09_JPRB, 0.16723428E-09_JPRB, 0.16701263E-09_JPRB, &
  & 0.16677630E-09_JPRB, 0.16652393E-09_JPRB, 0.16626353E-09_JPRB, 0.16600833E-09_JPRB, 0.16579688E-09_JPRB, 0.16562665E-09_JPRB, &
  & 0.16549465E-09_JPRB, 0.16538083E-09_JPRB, 0.16527224E-09_JPRB, 0.16516055E-09_JPRB, 0.16503916E-09_JPRB, 0.16491028E-09_JPRB, &
  & 0.16477898E-09_JPRB, 0.16464442E-09_JPRB, 0.16449014E-09_JPRB, 0.16421660E-09_JPRB /)

RGHG8(:,47, 1) = (/ &
  & 0.16410864E-09_JPRB, 0.16424256E-09_JPRB, 0.16433464E-09_JPRB, 0.16443828E-09_JPRB, 0.16457619E-09_JPRB, 0.16473929E-09_JPRB, &
  & 0.16490040E-09_JPRB, 0.16504655E-09_JPRB, 0.16517057E-09_JPRB, 0.16527539E-09_JPRB, 0.16536608E-09_JPRB, 0.16545512E-09_JPRB, &
  & 0.16555056E-09_JPRB, 0.16568122E-09_JPRB, 0.16586364E-09_JPRB, 0.16615162E-09_JPRB, 0.16650067E-09_JPRB, 0.16682609E-09_JPRB, &
  & 0.16707415E-09_JPRB, 0.16725984E-09_JPRB, 0.16740381E-09_JPRB, 0.16752316E-09_JPRB, 0.16762433E-09_JPRB, 0.16771656E-09_JPRB, &
  & 0.16780136E-09_JPRB, 0.16788275E-09_JPRB, 0.16796266E-09_JPRB, 0.16803825E-09_JPRB, 0.16810522E-09_JPRB, 0.16815775E-09_JPRB, &
  & 0.16819136E-09_JPRB, 0.16820693E-09_JPRB, 0.16820594E-09_JPRB, 0.16819104E-09_JPRB, 0.16816716E-09_JPRB, 0.16813972E-09_JPRB, &
  & 0.16811164E-09_JPRB, 0.16808316E-09_JPRB, 0.16805339E-09_JPRB, 0.16802074E-09_JPRB, 0.16798336E-09_JPRB, 0.16793887E-09_JPRB, &
  & 0.16788347E-09_JPRB, 0.16781047E-09_JPRB, 0.16771004E-09_JPRB, 0.16757512E-09_JPRB, 0.16740676E-09_JPRB, 0.16721738E-09_JPRB, &
  & 0.16701135E-09_JPRB, 0.16679098E-09_JPRB, 0.16655650E-09_JPRB, 0.16633890E-09_JPRB, 0.16615026E-09_JPRB, 0.16601040E-09_JPRB, &
  & 0.16589732E-09_JPRB, 0.16580123E-09_JPRB, 0.16570947E-09_JPRB, 0.16561338E-09_JPRB, 0.16551105E-09_JPRB, 0.16540318E-09_JPRB, &
  & 0.16529444E-09_JPRB, 0.16518334E-09_JPRB, 0.16505530E-09_JPRB, 0.16482468E-09_JPRB /)

RGHG8(:,48, 1) = (/ &
  & 0.16466911E-09_JPRB, 0.16480317E-09_JPRB, 0.16489046E-09_JPRB, 0.16499291E-09_JPRB, 0.16512590E-09_JPRB, 0.16528497E-09_JPRB, &
  & 0.16544663E-09_JPRB, 0.16558967E-09_JPRB, 0.16570879E-09_JPRB, 0.16580268E-09_JPRB, 0.16588206E-09_JPRB, 0.16595429E-09_JPRB, &
  & 0.16603488E-09_JPRB, 0.16613359E-09_JPRB, 0.16628392E-09_JPRB, 0.16649372E-09_JPRB, 0.16675945E-09_JPRB, 0.16699768E-09_JPRB, &
  & 0.16718306E-09_JPRB, 0.16732812E-09_JPRB, 0.16744856E-09_JPRB, 0.16755421E-09_JPRB, 0.16765055E-09_JPRB, 0.16774067E-09_JPRB, &
  & 0.16782747E-09_JPRB, 0.16791300E-09_JPRB, 0.16799606E-09_JPRB, 0.16807462E-09_JPRB, 0.16814189E-09_JPRB, 0.16819135E-09_JPRB, &
  & 0.16822135E-09_JPRB, 0.16823279E-09_JPRB, 0.16822788E-09_JPRB, 0.16820967E-09_JPRB, 0.16818355E-09_JPRB, 0.16815491E-09_JPRB, &
  & 0.16812660E-09_JPRB, 0.16809887E-09_JPRB, 0.16807078E-09_JPRB, 0.16804137E-09_JPRB, 0.16800950E-09_JPRB, 0.16797429E-09_JPRB, &
  & 0.16793397E-09_JPRB, 0.16788401E-09_JPRB, 0.16781607E-09_JPRB, 0.16771953E-09_JPRB, 0.16759362E-09_JPRB, 0.16744146E-09_JPRB, &
  & 0.16727283E-09_JPRB, 0.16708494E-09_JPRB, 0.16688731E-09_JPRB, 0.16669459E-09_JPRB, 0.16654150E-09_JPRB, 0.16642140E-09_JPRB, &
  & 0.16632881E-09_JPRB, 0.16624788E-09_JPRB, 0.16616956E-09_JPRB, 0.16608800E-09_JPRB, 0.16600014E-09_JPRB, 0.16590920E-09_JPRB, &
  & 0.16581828E-09_JPRB, 0.16572621E-09_JPRB, 0.16561917E-09_JPRB, 0.16542709E-09_JPRB /)

RGHG8(:,49, 1) = (/ &
  & 0.16520602E-09_JPRB, 0.16533604E-09_JPRB, 0.16542523E-09_JPRB, 0.16552454E-09_JPRB, 0.16565797E-09_JPRB, 0.16581876E-09_JPRB, &
  & 0.16598259E-09_JPRB, 0.16612688E-09_JPRB, 0.16623750E-09_JPRB, 0.16632093E-09_JPRB, 0.16638581E-09_JPRB, 0.16644362E-09_JPRB, &
  & 0.16650303E-09_JPRB, 0.16657524E-09_JPRB, 0.16667454E-09_JPRB, 0.16681509E-09_JPRB, 0.16698573E-09_JPRB, 0.16714596E-09_JPRB, &
  & 0.16727560E-09_JPRB, 0.16738566E-09_JPRB, 0.16748541E-09_JPRB, 0.16758035E-09_JPRB, 0.16767236E-09_JPRB, 0.16776339E-09_JPRB, &
  & 0.16785337E-09_JPRB, 0.16794327E-09_JPRB, 0.16803121E-09_JPRB, 0.16811180E-09_JPRB, 0.16817786E-09_JPRB, 0.16822468E-09_JPRB, &
  & 0.16825044E-09_JPRB, 0.16825764E-09_JPRB, 0.16824861E-09_JPRB, 0.16822699E-09_JPRB, 0.16819837E-09_JPRB, 0.16816841E-09_JPRB, &
  & 0.16813972E-09_JPRB, 0.16811247E-09_JPRB, 0.16808593E-09_JPRB, 0.16805940E-09_JPRB, 0.16803278E-09_JPRB, 0.16800662E-09_JPRB, &
  & 0.16798138E-09_JPRB, 0.16795525E-09_JPRB, 0.16792141E-09_JPRB, 0.16787038E-09_JPRB, 0.16779329E-09_JPRB, 0.16769194E-09_JPRB, &
  & 0.16756631E-09_JPRB, 0.16741902E-09_JPRB, 0.16725574E-09_JPRB, 0.16709989E-09_JPRB, 0.16697208E-09_JPRB, 0.16687550E-09_JPRB, &
  & 0.16679909E-09_JPRB, 0.16673152E-09_JPRB, 0.16666483E-09_JPRB, 0.16659410E-09_JPRB, 0.16651794E-09_JPRB, 0.16643899E-09_JPRB, &
  & 0.16636115E-09_JPRB, 0.16628218E-09_JPRB, 0.16619107E-09_JPRB, 0.16602639E-09_JPRB /)

RGHG8(:,50, 1) = (/ &
  & 0.16571478E-09_JPRB, 0.16584820E-09_JPRB, 0.16593381E-09_JPRB, 0.16603778E-09_JPRB, 0.16617323E-09_JPRB, 0.16634313E-09_JPRB, &
  & 0.16651247E-09_JPRB, 0.16665266E-09_JPRB, 0.16675077E-09_JPRB, 0.16681624E-09_JPRB, 0.16686330E-09_JPRB, 0.16690174E-09_JPRB, &
  & 0.16693633E-09_JPRB, 0.16697768E-09_JPRB, 0.16702509E-09_JPRB, 0.16709623E-09_JPRB, 0.16718289E-09_JPRB, 0.16727314E-09_JPRB, &
  & 0.16735525E-09_JPRB, 0.16743479E-09_JPRB, 0.16751683E-09_JPRB, 0.16760229E-09_JPRB, 0.16769207E-09_JPRB, 0.16778468E-09_JPRB, &
  & 0.16787984E-09_JPRB, 0.16797500E-09_JPRB, 0.16806716E-09_JPRB, 0.16814891E-09_JPRB, 0.16821372E-09_JPRB, 0.16825676E-09_JPRB, &
  & 0.16827859E-09_JPRB, 0.16828139E-09_JPRB, 0.16826818E-09_JPRB, 0.16824296E-09_JPRB, 0.16821192E-09_JPRB, 0.16818054E-09_JPRB, &
  & 0.16815135E-09_JPRB, 0.16812442E-09_JPRB, 0.16809916E-09_JPRB, 0.16807535E-09_JPRB, 0.16805375E-09_JPRB, 0.16803661E-09_JPRB, &
  & 0.16802665E-09_JPRB, 0.16802464E-09_JPRB, 0.16802622E-09_JPRB, 0.16802168E-09_JPRB, 0.16800078E-09_JPRB, 0.16795694E-09_JPRB, &
  & 0.16788562E-09_JPRB, 0.16778832E-09_JPRB, 0.16766960E-09_JPRB, 0.16755332E-09_JPRB, 0.16745472E-09_JPRB, 0.16738123E-09_JPRB, &
  & 0.16731955E-09_JPRB, 0.16726423E-09_JPRB, 0.16720830E-09_JPRB, 0.16714635E-09_JPRB, 0.16707929E-09_JPRB, 0.16700917E-09_JPRB, &
  & 0.16693935E-09_JPRB, 0.16686907E-09_JPRB, 0.16678622E-09_JPRB, 0.16663702E-09_JPRB /)

RGHG8(:,51, 1) = (/ &
  & 0.16619892E-09_JPRB, 0.16632387E-09_JPRB, 0.16641788E-09_JPRB, 0.16651977E-09_JPRB, 0.16666768E-09_JPRB, 0.16684089E-09_JPRB, &
  & 0.16701139E-09_JPRB, 0.16712962E-09_JPRB, 0.16719998E-09_JPRB, 0.16724019E-09_JPRB, 0.16726459E-09_JPRB, 0.16728030E-09_JPRB, &
  & 0.16729282E-09_JPRB, 0.16730169E-09_JPRB, 0.16731284E-09_JPRB, 0.16732540E-09_JPRB, 0.16734980E-09_JPRB, 0.16738272E-09_JPRB, &
  & 0.16742516E-09_JPRB, 0.16747864E-09_JPRB, 0.16754456E-09_JPRB, 0.16762236E-09_JPRB, 0.16771033E-09_JPRB, 0.16780639E-09_JPRB, &
  & 0.16790663E-09_JPRB, 0.16800811E-09_JPRB, 0.16810316E-09_JPRB, 0.16818591E-09_JPRB, 0.16824808E-09_JPRB, 0.16828786E-09_JPRB, &
  & 0.16830572E-09_JPRB, 0.16830412E-09_JPRB, 0.16828665E-09_JPRB, 0.16825785E-09_JPRB, 0.16822432E-09_JPRB, 0.16819152E-09_JPRB, &
  & 0.16816176E-09_JPRB, 0.16813503E-09_JPRB, 0.16811091E-09_JPRB, 0.16808965E-09_JPRB, 0.16807308E-09_JPRB, 0.16806512E-09_JPRB, &
  & 0.16807072E-09_JPRB, 0.16809294E-09_JPRB, 0.16812819E-09_JPRB, 0.16816698E-09_JPRB, 0.16819698E-09_JPRB, 0.16820817E-09_JPRB, &
  & 0.16819607E-09_JPRB, 0.16815575E-09_JPRB, 0.16809518E-09_JPRB, 0.16802480E-09_JPRB, 0.16796502E-09_JPRB, 0.16791304E-09_JPRB, &
  & 0.16787073E-09_JPRB, 0.16782936E-09_JPRB, 0.16778459E-09_JPRB, 0.16773502E-09_JPRB, 0.16767714E-09_JPRB, 0.16761567E-09_JPRB, &
  & 0.16755385E-09_JPRB, 0.16748870E-09_JPRB, 0.16741152E-09_JPRB, 0.16726807E-09_JPRB /)

RGHG8(:,52, 1) = (/ &
  & 0.16663401E-09_JPRB, 0.16676993E-09_JPRB, 0.16685213E-09_JPRB, 0.16696700E-09_JPRB, 0.16710648E-09_JPRB, 0.16727875E-09_JPRB, &
  & 0.16741052E-09_JPRB, 0.16748886E-09_JPRB, 0.16752515E-09_JPRB, 0.16754127E-09_JPRB, 0.16754750E-09_JPRB, 0.16754848E-09_JPRB, &
  & 0.16754560E-09_JPRB, 0.16753754E-09_JPRB, 0.16752638E-09_JPRB, 0.16750573E-09_JPRB, 0.16748754E-09_JPRB, 0.16747798E-09_JPRB, &
  & 0.16748757E-09_JPRB, 0.16751873E-09_JPRB, 0.16757101E-09_JPRB, 0.16764197E-09_JPRB, 0.16772914E-09_JPRB, 0.16782867E-09_JPRB, &
  & 0.16793517E-09_JPRB, 0.16804080E-09_JPRB, 0.16813950E-09_JPRB, 0.16822121E-09_JPRB, 0.16828164E-09_JPRB, 0.16831783E-09_JPRB, &
  & 0.16833197E-09_JPRB, 0.16832601E-09_JPRB, 0.16830420E-09_JPRB, 0.16827183E-09_JPRB, 0.16823583E-09_JPRB, 0.16820166E-09_JPRB, &
  & 0.16817132E-09_JPRB, 0.16814478E-09_JPRB, 0.16812168E-09_JPRB, 0.16810289E-09_JPRB, 0.16809137E-09_JPRB, 0.16809282E-09_JPRB, &
  & 0.16811431E-09_JPRB, 0.16815968E-09_JPRB, 0.16822560E-09_JPRB, 0.16829806E-09_JPRB, 0.16836521E-09_JPRB, 0.16841671E-09_JPRB, &
  & 0.16844706E-09_JPRB, 0.16845604E-09_JPRB, 0.16844423E-09_JPRB, 0.16842086E-09_JPRB, 0.16839299E-09_JPRB, 0.16836876E-09_JPRB, &
  & 0.16834437E-09_JPRB, 0.16831972E-09_JPRB, 0.16829202E-09_JPRB, 0.16825680E-09_JPRB, 0.16821614E-09_JPRB, 0.16817002E-09_JPRB, &
  & 0.16812138E-09_JPRB, 0.16806975E-09_JPRB, 0.16800372E-09_JPRB, 0.16787560E-09_JPRB /)

RGHG8(:,53, 1) = (/ &
  & 0.16703165E-09_JPRB, 0.16714563E-09_JPRB, 0.16724415E-09_JPRB, 0.16733759E-09_JPRB, 0.16747392E-09_JPRB, 0.16759572E-09_JPRB, &
  & 0.16768120E-09_JPRB, 0.16771742E-09_JPRB, 0.16773030E-09_JPRB, 0.16773280E-09_JPRB, 0.16773041E-09_JPRB, 0.16772510E-09_JPRB, &
  & 0.16771561E-09_JPRB, 0.16770361E-09_JPRB, 0.16767847E-09_JPRB, 0.16764938E-09_JPRB, 0.16760157E-09_JPRB, 0.16756205E-09_JPRB, &
  & 0.16754444E-09_JPRB, 0.16755659E-09_JPRB, 0.16759705E-09_JPRB, 0.16766280E-09_JPRB, 0.16774976E-09_JPRB, 0.16785276E-09_JPRB, &
  & 0.16796360E-09_JPRB, 0.16807430E-09_JPRB, 0.16817414E-09_JPRB, 0.16825605E-09_JPRB, 0.16831388E-09_JPRB, 0.16834709E-09_JPRB, &
  & 0.16835751E-09_JPRB, 0.16834734E-09_JPRB, 0.16832115E-09_JPRB, 0.16828522E-09_JPRB, 0.16824685E-09_JPRB, 0.16821133E-09_JPRB, &
  & 0.16818044E-09_JPRB, 0.16815407E-09_JPRB, 0.16813206E-09_JPRB, 0.16811576E-09_JPRB, 0.16810939E-09_JPRB, 0.16812043E-09_JPRB, &
  & 0.16815734E-09_JPRB, 0.16822496E-09_JPRB, 0.16831427E-09_JPRB, 0.16841234E-09_JPRB, 0.16850069E-09_JPRB, 0.16857325E-09_JPRB, &
  & 0.16862650E-09_JPRB, 0.16865981E-09_JPRB, 0.16867502E-09_JPRB, 0.16867635E-09_JPRB, 0.16867059E-09_JPRB, 0.16866158E-09_JPRB, &
  & 0.16865184E-09_JPRB, 0.16864019E-09_JPRB, 0.16862525E-09_JPRB, 0.16860682E-09_JPRB, 0.16858256E-09_JPRB, 0.16855520E-09_JPRB, &
  & 0.16852611E-09_JPRB, 0.16849393E-09_JPRB, 0.16845338E-09_JPRB, 0.16836388E-09_JPRB /)

RGHG8(:,54, 1) = (/ &
  & 0.16735288E-09_JPRB, 0.16748239E-09_JPRB, 0.16755156E-09_JPRB, 0.16764640E-09_JPRB, 0.16773374E-09_JPRB, 0.16781268E-09_JPRB, &
  & 0.16784973E-09_JPRB, 0.16786185E-09_JPRB, 0.16786250E-09_JPRB, 0.16785899E-09_JPRB, 0.16785345E-09_JPRB, 0.16784581E-09_JPRB, &
  & 0.16783654E-09_JPRB, 0.16782002E-09_JPRB, 0.16780038E-09_JPRB, 0.16775564E-09_JPRB, 0.16770295E-09_JPRB, 0.16763740E-09_JPRB, &
  & 0.16759701E-09_JPRB, 0.16759291E-09_JPRB, 0.16762405E-09_JPRB, 0.16768566E-09_JPRB, 0.16777273E-09_JPRB, 0.16787842E-09_JPRB, &
  & 0.16799340E-09_JPRB, 0.16810688E-09_JPRB, 0.16820893E-09_JPRB, 0.16828983E-09_JPRB, 0.16834593E-09_JPRB, 0.16837598E-09_JPRB, &
  & 0.16838268E-09_JPRB, 0.16836836E-09_JPRB, 0.16833793E-09_JPRB, 0.16829847E-09_JPRB, 0.16825778E-09_JPRB, 0.16822095E-09_JPRB, &
  & 0.16818960E-09_JPRB, 0.16816341E-09_JPRB, 0.16814254E-09_JPRB, 0.16812889E-09_JPRB, 0.16812784E-09_JPRB, 0.16814829E-09_JPRB, &
  & 0.16820029E-09_JPRB, 0.16828559E-09_JPRB, 0.16839610E-09_JPRB, 0.16850756E-09_JPRB, 0.16860915E-09_JPRB, 0.16869076E-09_JPRB, &
  & 0.16875210E-09_JPRB, 0.16879481E-09_JPRB, 0.16882021E-09_JPRB, 0.16883162E-09_JPRB, 0.16883492E-09_JPRB, 0.16883404E-09_JPRB, &
  & 0.16883100E-09_JPRB, 0.16882633E-09_JPRB, 0.16881979E-09_JPRB, 0.16881010E-09_JPRB, 0.16879796E-09_JPRB, 0.16878351E-09_JPRB, &
  & 0.16876869E-09_JPRB, 0.16875443E-09_JPRB, 0.16873959E-09_JPRB, 0.16871887E-09_JPRB /)

RGHG8(:,55, 1) = (/ &
  & 0.16763216E-09_JPRB, 0.16773230E-09_JPRB, 0.16780924E-09_JPRB, 0.16786521E-09_JPRB, 0.16792200E-09_JPRB, 0.16795357E-09_JPRB, &
  & 0.16796367E-09_JPRB, 0.16796199E-09_JPRB, 0.16795701E-09_JPRB, 0.16795103E-09_JPRB, 0.16794449E-09_JPRB, 0.16793711E-09_JPRB, &
  & 0.16792681E-09_JPRB, 0.16791452E-09_JPRB, 0.16788865E-09_JPRB, 0.16785584E-09_JPRB, 0.16778534E-09_JPRB, 0.16770720E-09_JPRB, &
  & 0.16764699E-09_JPRB, 0.16762894E-09_JPRB, 0.16765243E-09_JPRB, 0.16771105E-09_JPRB, 0.16779834E-09_JPRB, 0.16790595E-09_JPRB, &
  & 0.16802387E-09_JPRB, 0.16814046E-09_JPRB, 0.16824339E-09_JPRB, 0.16832427E-09_JPRB, 0.16837798E-09_JPRB, 0.16840511E-09_JPRB, &
  & 0.16840804E-09_JPRB, 0.16838962E-09_JPRB, 0.16835509E-09_JPRB, 0.16831223E-09_JPRB, 0.16826907E-09_JPRB, 0.16823107E-09_JPRB, &
  & 0.16819916E-09_JPRB, 0.16817342E-09_JPRB, 0.16815381E-09_JPRB, 0.16814303E-09_JPRB, 0.16814741E-09_JPRB, 0.16817699E-09_JPRB, &
  & 0.16824153E-09_JPRB, 0.16834374E-09_JPRB, 0.16846594E-09_JPRB, 0.16859107E-09_JPRB, 0.16869720E-09_JPRB, 0.16878260E-09_JPRB, &
  & 0.16884653E-09_JPRB, 0.16889090E-09_JPRB, 0.16891885E-09_JPRB, 0.16893412E-09_JPRB, 0.16894069E-09_JPRB, 0.16894322E-09_JPRB, &
  & 0.16894346E-09_JPRB, 0.16894219E-09_JPRB, 0.16893933E-09_JPRB, 0.16893487E-09_JPRB, 0.16892809E-09_JPRB, 0.16891993E-09_JPRB, &
  & 0.16891097E-09_JPRB, 0.16890138E-09_JPRB, 0.16889007E-09_JPRB, 0.16886832E-09_JPRB /)

RGHG8(:,56, 1) = (/ &
  & 0.16784223E-09_JPRB, 0.16794482E-09_JPRB, 0.16799179E-09_JPRB, 0.16803071E-09_JPRB, 0.16805243E-09_JPRB, 0.16805590E-09_JPRB, &
  & 0.16804934E-09_JPRB, 0.16804053E-09_JPRB, 0.16803293E-09_JPRB, 0.16802609E-09_JPRB, 0.16801946E-09_JPRB, 0.16801203E-09_JPRB, &
  & 0.16800360E-09_JPRB, 0.16798954E-09_JPRB, 0.16797166E-09_JPRB, 0.16792862E-09_JPRB, 0.16786804E-09_JPRB, 0.16777107E-09_JPRB, &
  & 0.16769502E-09_JPRB, 0.16766588E-09_JPRB, 0.16768331E-09_JPRB, 0.16773949E-09_JPRB, 0.16782666E-09_JPRB, 0.16793598E-09_JPRB, &
  & 0.16805629E-09_JPRB, 0.16817495E-09_JPRB, 0.16827939E-09_JPRB, 0.16835912E-09_JPRB, 0.16841098E-09_JPRB, 0.16843495E-09_JPRB, &
  & 0.16843424E-09_JPRB, 0.16841184E-09_JPRB, 0.16837323E-09_JPRB, 0.16832703E-09_JPRB, 0.16828153E-09_JPRB, 0.16824217E-09_JPRB, &
  & 0.16821003E-09_JPRB, 0.16818458E-09_JPRB, 0.16816656E-09_JPRB, 0.16815886E-09_JPRB, 0.16816870E-09_JPRB, 0.16820650E-09_JPRB, &
  & 0.16828251E-09_JPRB, 0.16839520E-09_JPRB, 0.16853163E-09_JPRB, 0.16866089E-09_JPRB, 0.16877336E-09_JPRB, 0.16885947E-09_JPRB, &
  & 0.16892249E-09_JPRB, 0.16896617E-09_JPRB, 0.16899394E-09_JPRB, 0.16900928E-09_JPRB, 0.16901736E-09_JPRB, 0.16902102E-09_JPRB, &
  & 0.16902264E-09_JPRB, 0.16902292E-09_JPRB, 0.16902210E-09_JPRB, 0.16901994E-09_JPRB, 0.16901641E-09_JPRB, 0.16901150E-09_JPRB, &
  & 0.16900595E-09_JPRB, 0.16900004E-09_JPRB, 0.16899315E-09_JPRB, 0.16898150E-09_JPRB /)

RGHG8(:,57, 1) = (/ &
  & 0.16801549E-09_JPRB, 0.16809694E-09_JPRB, 0.16813415E-09_JPRB, 0.16815144E-09_JPRB, 0.16815149E-09_JPRB, 0.16813756E-09_JPRB, &
  & 0.16812104E-09_JPRB, 0.16810907E-09_JPRB, 0.16810012E-09_JPRB, 0.16809290E-09_JPRB, 0.16808627E-09_JPRB, 0.16807944E-09_JPRB, &
  & 0.16807059E-09_JPRB, 0.16805965E-09_JPRB, 0.16803774E-09_JPRB, 0.16800630E-09_JPRB, 0.16793200E-09_JPRB, 0.16783279E-09_JPRB, &
  & 0.16774318E-09_JPRB, 0.16770493E-09_JPRB, 0.16771745E-09_JPRB, 0.16777144E-09_JPRB, 0.16785875E-09_JPRB, 0.16796904E-09_JPRB, &
  & 0.16809140E-09_JPRB, 0.16821197E-09_JPRB, 0.16831647E-09_JPRB, 0.16839589E-09_JPRB, 0.16844522E-09_JPRB, 0.16846620E-09_JPRB, &
  & 0.16846192E-09_JPRB, 0.16843575E-09_JPRB, 0.16839337E-09_JPRB, 0.16834374E-09_JPRB, 0.16829595E-09_JPRB, 0.16825538E-09_JPRB, &
  & 0.16822267E-09_JPRB, 0.16819787E-09_JPRB, 0.16818139E-09_JPRB, 0.16817694E-09_JPRB, 0.16819210E-09_JPRB, 0.16823755E-09_JPRB, &
  & 0.16832188E-09_JPRB, 0.16844572E-09_JPRB, 0.16858684E-09_JPRB, 0.16872645E-09_JPRB, 0.16883953E-09_JPRB, 0.16892673E-09_JPRB, &
  & 0.16898823E-09_JPRB, 0.16902971E-09_JPRB, 0.16905570E-09_JPRB, 0.16907083E-09_JPRB, 0.16907858E-09_JPRB, 0.16908278E-09_JPRB, &
  & 0.16908491E-09_JPRB, 0.16908587E-09_JPRB, 0.16908591E-09_JPRB, 0.16908500E-09_JPRB, 0.16908289E-09_JPRB, 0.16907972E-09_JPRB, &
  & 0.16907573E-09_JPRB, 0.16907109E-09_JPRB, 0.16906518E-09_JPRB, 0.16905338E-09_JPRB /)

RGHG8(:,58, 1) = (/ &
  & 0.16815303E-09_JPRB, 0.16822113E-09_JPRB, 0.16824350E-09_JPRB, 0.16824669E-09_JPRB, 0.16823332E-09_JPRB, 0.16820881E-09_JPRB, &
  & 0.16818824E-09_JPRB, 0.16817367E-09_JPRB, 0.16816420E-09_JPRB, 0.16815674E-09_JPRB, 0.16815015E-09_JPRB, 0.16814317E-09_JPRB, &
  & 0.16813523E-09_JPRB, 0.16812265E-09_JPRB, 0.16810524E-09_JPRB, 0.16806520E-09_JPRB, 0.16800025E-09_JPRB, 0.16788788E-09_JPRB, &
  & 0.16779134E-09_JPRB, 0.16774707E-09_JPRB, 0.16775584E-09_JPRB, 0.16780809E-09_JPRB, 0.16789513E-09_JPRB, 0.16800665E-09_JPRB, &
  & 0.16813022E-09_JPRB, 0.16825140E-09_JPRB, 0.16835636E-09_JPRB, 0.16843409E-09_JPRB, 0.16848148E-09_JPRB, 0.16849944E-09_JPRB, &
  & 0.16849190E-09_JPRB, 0.16846226E-09_JPRB, 0.16841618E-09_JPRB, 0.16836342E-09_JPRB, 0.16831327E-09_JPRB, 0.16827123E-09_JPRB, &
  & 0.16823826E-09_JPRB, 0.16821387E-09_JPRB, 0.16819914E-09_JPRB, 0.16819790E-09_JPRB, 0.16821822E-09_JPRB, 0.16827008E-09_JPRB, &
  & 0.16836235E-09_JPRB, 0.16849093E-09_JPRB, 0.16864185E-09_JPRB, 0.16878224E-09_JPRB, 0.16890125E-09_JPRB, 0.16898749E-09_JPRB, &
  & 0.16904729E-09_JPRB, 0.16908625E-09_JPRB, 0.16911063E-09_JPRB, 0.16912430E-09_JPRB, 0.16913192E-09_JPRB, 0.16913583E-09_JPRB, &
  & 0.16913805E-09_JPRB, 0.16913922E-09_JPRB, 0.16913956E-09_JPRB, 0.16913906E-09_JPRB, 0.16913768E-09_JPRB, 0.16913529E-09_JPRB, &
  & 0.16913221E-09_JPRB, 0.16912842E-09_JPRB, 0.16912353E-09_JPRB, 0.16911417E-09_JPRB /)

RGHG8(:,59, 1) = (/ &
  & 0.16827129E-09_JPRB, 0.16832577E-09_JPRB, 0.16833443E-09_JPRB, 0.16832741E-09_JPRB, 0.16830731E-09_JPRB, 0.16827774E-09_JPRB, &
  & 0.16825351E-09_JPRB, 0.16823823E-09_JPRB, 0.16822799E-09_JPRB, 0.16822031E-09_JPRB, 0.16821354E-09_JPRB, 0.16820666E-09_JPRB, &
  & 0.16819791E-09_JPRB, 0.16818652E-09_JPRB, 0.16816495E-09_JPRB, 0.16813013E-09_JPRB, 0.16805296E-09_JPRB, 0.16794177E-09_JPRB, &
  & 0.16784078E-09_JPRB, 0.16779317E-09_JPRB, 0.16779919E-09_JPRB, 0.16785012E-09_JPRB, 0.16793721E-09_JPRB, 0.16804923E-09_JPRB, &
  & 0.16817343E-09_JPRB, 0.16829500E-09_JPRB, 0.16839864E-09_JPRB, 0.16847537E-09_JPRB, 0.16852013E-09_JPRB, 0.16853544E-09_JPRB, &
  & 0.16852499E-09_JPRB, 0.16849208E-09_JPRB, 0.16844273E-09_JPRB, 0.16838671E-09_JPRB, 0.16833428E-09_JPRB, 0.16829095E-09_JPRB, &
  & 0.16825749E-09_JPRB, 0.16823361E-09_JPRB, 0.16822049E-09_JPRB, 0.16822235E-09_JPRB, 0.16824732E-09_JPRB, 0.16830530E-09_JPRB, &
  & 0.16840261E-09_JPRB, 0.16853764E-09_JPRB, 0.16868945E-09_JPRB, 0.16883769E-09_JPRB, 0.16895613E-09_JPRB, 0.16904403E-09_JPRB, &
  & 0.16910180E-09_JPRB, 0.16913879E-09_JPRB, 0.16916110E-09_JPRB, 0.16917390E-09_JPRB, 0.16918061E-09_JPRB, 0.16918429E-09_JPRB, &
  & 0.16918626E-09_JPRB, 0.16918728E-09_JPRB, 0.16918758E-09_JPRB, 0.16918716E-09_JPRB, 0.16918589E-09_JPRB, 0.16918381E-09_JPRB, &
  & 0.16918097E-09_JPRB, 0.16917748E-09_JPRB, 0.16917284E-09_JPRB, 0.16916334E-09_JPRB /)

RGHG8(:,60, 1) = (/ &
  & 0.16841545E-09_JPRB, 0.16842061E-09_JPRB, 0.16841566E-09_JPRB, 0.16840269E-09_JPRB, 0.16837721E-09_JPRB, 0.16834656E-09_JPRB, &
  & 0.16832120E-09_JPRB, 0.16830420E-09_JPRB, 0.16829357E-09_JPRB, 0.16828547E-09_JPRB, 0.16827847E-09_JPRB, 0.16827109E-09_JPRB, &
  & 0.16826238E-09_JPRB, 0.16824885E-09_JPRB, 0.16822813E-09_JPRB, 0.16818459E-09_JPRB, 0.16810750E-09_JPRB, 0.16799212E-09_JPRB, &
  & 0.16789251E-09_JPRB, 0.16784404E-09_JPRB, 0.16784851E-09_JPRB, 0.16789864E-09_JPRB, 0.16798569E-09_JPRB, 0.16809790E-09_JPRB, &
  & 0.16822212E-09_JPRB, 0.16834253E-09_JPRB, 0.16844506E-09_JPRB, 0.16851945E-09_JPRB, 0.16856207E-09_JPRB, 0.16857481E-09_JPRB, &
  & 0.16856183E-09_JPRB, 0.16852623E-09_JPRB, 0.16847383E-09_JPRB, 0.16841492E-09_JPRB, 0.16836019E-09_JPRB, 0.16831547E-09_JPRB, &
  & 0.16828143E-09_JPRB, 0.16825785E-09_JPRB, 0.16824614E-09_JPRB, 0.16825086E-09_JPRB, 0.16828022E-09_JPRB, 0.16834305E-09_JPRB, &
  & 0.16844554E-09_JPRB, 0.16858263E-09_JPRB, 0.16873891E-09_JPRB, 0.16888618E-09_JPRB, 0.16900932E-09_JPRB, 0.16909621E-09_JPRB, &
  & 0.16915375E-09_JPRB, 0.16918861E-09_JPRB, 0.16920956E-09_JPRB, 0.16922086E-09_JPRB, 0.16922699E-09_JPRB, 0.16923005E-09_JPRB, &
  & 0.16923164E-09_JPRB, 0.16923235E-09_JPRB, 0.16923238E-09_JPRB, 0.16923171E-09_JPRB, 0.16923031E-09_JPRB, 0.16922802E-09_JPRB, &
  & 0.16922516E-09_JPRB, 0.16922169E-09_JPRB, 0.16921720E-09_JPRB, 0.16920862E-09_JPRB /)

RGHG8(:,61, 1) = (/ &
  & 0.16849158E-09_JPRB, 0.16849563E-09_JPRB, 0.16848825E-09_JPRB, 0.16847218E-09_JPRB, 0.16844871E-09_JPRB, 0.16841717E-09_JPRB, &
  & 0.16839077E-09_JPRB, 0.16837304E-09_JPRB, 0.16836156E-09_JPRB, 0.16835318E-09_JPRB, 0.16834581E-09_JPRB, 0.16833823E-09_JPRB, &
  & 0.16832835E-09_JPRB, 0.16831435E-09_JPRB, 0.16828847E-09_JPRB, 0.16824239E-09_JPRB, 0.16815706E-09_JPRB, 0.16804394E-09_JPRB, &
  & 0.16794864E-09_JPRB, 0.16790093E-09_JPRB, 0.16790486E-09_JPRB, 0.16795462E-09_JPRB, 0.16804144E-09_JPRB, 0.16815355E-09_JPRB, &
  & 0.16827664E-09_JPRB, 0.16839558E-09_JPRB, 0.16849550E-09_JPRB, 0.16856780E-09_JPRB, 0.16860773E-09_JPRB, 0.16861833E-09_JPRB, &
  & 0.16860341E-09_JPRB, 0.16856559E-09_JPRB, 0.16851065E-09_JPRB, 0.16844896E-09_JPRB, 0.16839211E-09_JPRB, 0.16834584E-09_JPRB, &
  & 0.16831120E-09_JPRB, 0.16828756E-09_JPRB, 0.16827703E-09_JPRB, 0.16828425E-09_JPRB, 0.16831729E-09_JPRB, 0.16838475E-09_JPRB, &
  & 0.16849078E-09_JPRB, 0.16863035E-09_JPRB, 0.16878593E-09_JPRB, 0.16893562E-09_JPRB, 0.16905759E-09_JPRB, 0.16914635E-09_JPRB, &
  & 0.16920305E-09_JPRB, 0.16923724E-09_JPRB, 0.16925664E-09_JPRB, 0.16926702E-09_JPRB, 0.16927210E-09_JPRB, 0.16927459E-09_JPRB, &
  & 0.16927566E-09_JPRB, 0.16927587E-09_JPRB, 0.16927539E-09_JPRB, 0.16927423E-09_JPRB, 0.16927226E-09_JPRB, 0.16926960E-09_JPRB, &
  & 0.16926630E-09_JPRB, 0.16926249E-09_JPRB, 0.16925766E-09_JPRB, 0.16924827E-09_JPRB /)

RGHG8(:,62, 1) = (/ &
  & 0.16856658E-09_JPRB, 0.16856719E-09_JPRB, 0.16855822E-09_JPRB, 0.16854325E-09_JPRB, 0.16851927E-09_JPRB, 0.16849028E-09_JPRB, &
  & 0.16846317E-09_JPRB, 0.16844393E-09_JPRB, 0.16843200E-09_JPRB, 0.16842325E-09_JPRB, 0.16841598E-09_JPRB, 0.16840808E-09_JPRB, &
  & 0.16839795E-09_JPRB, 0.16838123E-09_JPRB, 0.16835257E-09_JPRB, 0.16829826E-09_JPRB, 0.16820931E-09_JPRB, 0.16810131E-09_JPRB, &
  & 0.16801102E-09_JPRB, 0.16796517E-09_JPRB, 0.16796939E-09_JPRB, 0.16801904E-09_JPRB, 0.16810572E-09_JPRB, 0.16821682E-09_JPRB, &
  & 0.16833826E-09_JPRB, 0.16845438E-09_JPRB, 0.16855155E-09_JPRB, 0.16862070E-09_JPRB, 0.16865821E-09_JPRB, 0.16866683E-09_JPRB, &
  & 0.16865045E-09_JPRB, 0.16861115E-09_JPRB, 0.16855418E-09_JPRB, 0.16849021E-09_JPRB, 0.16843112E-09_JPRB, 0.16838340E-09_JPRB, &
  & 0.16834757E-09_JPRB, 0.16832385E-09_JPRB, 0.16831402E-09_JPRB, 0.16832333E-09_JPRB, 0.16835965E-09_JPRB, 0.16843074E-09_JPRB, &
  & 0.16853971E-09_JPRB, 0.16868043E-09_JPRB, 0.16883536E-09_JPRB, 0.16898262E-09_JPRB, 0.16910558E-09_JPRB, 0.16919385E-09_JPRB, &
  & 0.16925132E-09_JPRB, 0.16928484E-09_JPRB, 0.16930334E-09_JPRB, 0.16931248E-09_JPRB, 0.16931676E-09_JPRB, 0.16931842E-09_JPRB, &
  & 0.16931881E-09_JPRB, 0.16931836E-09_JPRB, 0.16931728E-09_JPRB, 0.16931541E-09_JPRB, 0.16931279E-09_JPRB, 0.16930934E-09_JPRB, &
  & 0.16930544E-09_JPRB, 0.16930107E-09_JPRB, 0.16929567E-09_JPRB, 0.16928578E-09_JPRB /)

RGHG8(:,63, 1) = (/ &
  & 0.16863688E-09_JPRB, 0.16863766E-09_JPRB, 0.16862903E-09_JPRB, 0.16861407E-09_JPRB, 0.16859283E-09_JPRB, 0.16856434E-09_JPRB, &
  & 0.16853738E-09_JPRB, 0.16851678E-09_JPRB, 0.16850418E-09_JPRB, 0.16849555E-09_JPRB, 0.16848861E-09_JPRB, 0.16848146E-09_JPRB, &
  & 0.16847068E-09_JPRB, 0.16845263E-09_JPRB, 0.16841827E-09_JPRB, 0.16835855E-09_JPRB, 0.16826937E-09_JPRB, 0.16816659E-09_JPRB, &
  & 0.16808160E-09_JPRB, 0.16803819E-09_JPRB, 0.16804325E-09_JPRB, 0.16809312E-09_JPRB, 0.16817900E-09_JPRB, 0.16828879E-09_JPRB, &
  & 0.16840730E-09_JPRB, 0.16852006E-09_JPRB, 0.16861337E-09_JPRB, 0.16867920E-09_JPRB, 0.16871396E-09_JPRB, 0.16872095E-09_JPRB, &
  & 0.16870375E-09_JPRB, 0.16866368E-09_JPRB, 0.16860544E-09_JPRB, 0.16853953E-09_JPRB, 0.16847865E-09_JPRB, 0.16842910E-09_JPRB, &
  & 0.16839224E-09_JPRB, 0.16836776E-09_JPRB, 0.16835830E-09_JPRB, 0.16836917E-09_JPRB, 0.16840800E-09_JPRB, 0.16848201E-09_JPRB, &
  & 0.16859331E-09_JPRB, 0.16873393E-09_JPRB, 0.16888699E-09_JPRB, 0.16903161E-09_JPRB, 0.16915190E-09_JPRB, 0.16924073E-09_JPRB, &
  & 0.16929827E-09_JPRB, 0.16933197E-09_JPRB, 0.16934973E-09_JPRB, 0.16935796E-09_JPRB, 0.16936121E-09_JPRB, 0.16936202E-09_JPRB, &
  & 0.16936164E-09_JPRB, 0.16936041E-09_JPRB, 0.16935839E-09_JPRB, 0.16935567E-09_JPRB, 0.16935198E-09_JPRB, 0.16934762E-09_JPRB, &
  & 0.16934276E-09_JPRB, 0.16933756E-09_JPRB, 0.16933130E-09_JPRB, 0.16931992E-09_JPRB /)

RGHG8(:,64, 1) = (/ &
  & 0.16870824E-09_JPRB, 0.16870920E-09_JPRB, 0.16870093E-09_JPRB, 0.16868723E-09_JPRB, 0.16866665E-09_JPRB, 0.16864010E-09_JPRB, &
  & 0.16861243E-09_JPRB, 0.16859081E-09_JPRB, 0.16857762E-09_JPRB, 0.16856930E-09_JPRB, 0.16856366E-09_JPRB, 0.16855761E-09_JPRB, &
  & 0.16854734E-09_JPRB, 0.16852683E-09_JPRB, 0.16848883E-09_JPRB, 0.16842619E-09_JPRB, 0.16833826E-09_JPRB, 0.16824085E-09_JPRB, &
  & 0.16816094E-09_JPRB, 0.16812061E-09_JPRB, 0.16812701E-09_JPRB, 0.16817682E-09_JPRB, 0.16826175E-09_JPRB, 0.16836868E-09_JPRB, &
  & 0.16848375E-09_JPRB, 0.16859189E-09_JPRB, 0.16868081E-09_JPRB, 0.16874258E-09_JPRB, 0.16877461E-09_JPRB, 0.16878013E-09_JPRB, &
  & 0.16876263E-09_JPRB, 0.16872261E-09_JPRB, 0.16866394E-09_JPRB, 0.16859708E-09_JPRB, 0.16853476E-09_JPRB, 0.16848387E-09_JPRB, &
  & 0.16844558E-09_JPRB, 0.16842025E-09_JPRB, 0.16841073E-09_JPRB, 0.16842253E-09_JPRB, 0.16846322E-09_JPRB, 0.16853934E-09_JPRB, &
  & 0.16865152E-09_JPRB, 0.16879154E-09_JPRB, 0.16894128E-09_JPRB, 0.16908171E-09_JPRB, 0.16919913E-09_JPRB, 0.16928631E-09_JPRB, &
  & 0.16934434E-09_JPRB, 0.16937843E-09_JPRB, 0.16939583E-09_JPRB, 0.16940327E-09_JPRB, 0.16940560E-09_JPRB, 0.16940545E-09_JPRB, &
  & 0.16940409E-09_JPRB, 0.16940185E-09_JPRB, 0.16939888E-09_JPRB, 0.16939493E-09_JPRB, 0.16939013E-09_JPRB, 0.16938451E-09_JPRB, &
  & 0.16937854E-09_JPRB, 0.16937221E-09_JPRB, 0.16936472E-09_JPRB, 0.16935130E-09_JPRB /)

RGHG8(:,65, 1) = (/ &
  & 0.16878074E-09_JPRB, 0.16878245E-09_JPRB, 0.16877487E-09_JPRB, 0.16876173E-09_JPRB, 0.16874251E-09_JPRB, 0.16871633E-09_JPRB, &
  & 0.16868906E-09_JPRB, 0.16866593E-09_JPRB, 0.16865323E-09_JPRB, 0.16864560E-09_JPRB, 0.16864161E-09_JPRB, 0.16863717E-09_JPRB, &
  & 0.16862715E-09_JPRB, 0.16860556E-09_JPRB, 0.16856544E-09_JPRB, 0.16850195E-09_JPRB, 0.16841660E-09_JPRB, 0.16832438E-09_JPRB, &
  & 0.16824955E-09_JPRB, 0.16821271E-09_JPRB, 0.16822053E-09_JPRB, 0.16827006E-09_JPRB, 0.16835271E-09_JPRB, 0.16845617E-09_JPRB, &
  & 0.16856604E-09_JPRB, 0.16866884E-09_JPRB, 0.16875237E-09_JPRB, 0.16880981E-09_JPRB, 0.16883889E-09_JPRB, 0.16884316E-09_JPRB, &
  & 0.16882580E-09_JPRB, 0.16878648E-09_JPRB, 0.16872853E-09_JPRB, 0.16866174E-09_JPRB, 0.16859902E-09_JPRB, 0.16854718E-09_JPRB, &
  & 0.16850794E-09_JPRB, 0.16848167E-09_JPRB, 0.16847179E-09_JPRB, 0.16848409E-09_JPRB, 0.16852592E-09_JPRB, 0.16860291E-09_JPRB, &
  & 0.16871517E-09_JPRB, 0.16885263E-09_JPRB, 0.16899852E-09_JPRB, 0.16913398E-09_JPRB, 0.16924691E-09_JPRB, 0.16933205E-09_JPRB, &
  & 0.16938953E-09_JPRB, 0.16942386E-09_JPRB, 0.16944145E-09_JPRB, 0.16944837E-09_JPRB, 0.16944980E-09_JPRB, 0.16944865E-09_JPRB, &
  & 0.16944621E-09_JPRB, 0.16944288E-09_JPRB, 0.16943856E-09_JPRB, 0.16943341E-09_JPRB, 0.16942717E-09_JPRB, 0.16942023E-09_JPRB, &
  & 0.16941291E-09_JPRB, 0.16940518E-09_JPRB, 0.16939605E-09_JPRB, 0.16937945E-09_JPRB /)

RGHG8(:,66, 1) = (/ &
  & 0.16885160E-09_JPRB, 0.16885637E-09_JPRB, 0.16884998E-09_JPRB, 0.16883803E-09_JPRB, 0.16881949E-09_JPRB, 0.16879408E-09_JPRB, &
  & 0.16876661E-09_JPRB, 0.16874369E-09_JPRB, 0.16873154E-09_JPRB, 0.16872559E-09_JPRB, 0.16872329E-09_JPRB, 0.16872029E-09_JPRB, &
  & 0.16871078E-09_JPRB, 0.16868879E-09_JPRB, 0.16864826E-09_JPRB, 0.16858574E-09_JPRB, 0.16850354E-09_JPRB, 0.16841659E-09_JPRB, &
  & 0.16834723E-09_JPRB, 0.16831393E-09_JPRB, 0.16832308E-09_JPRB, 0.16837137E-09_JPRB, 0.16845092E-09_JPRB, 0.16854912E-09_JPRB, &
  & 0.16865309E-09_JPRB, 0.16874918E-09_JPRB, 0.16882684E-09_JPRB, 0.16887944E-09_JPRB, 0.16890550E-09_JPRB, 0.16890868E-09_JPRB, &
  & 0.16889173E-09_JPRB, 0.16885376E-09_JPRB, 0.16879739E-09_JPRB, 0.16873189E-09_JPRB, 0.16866997E-09_JPRB, 0.16861833E-09_JPRB, &
  & 0.16857871E-09_JPRB, 0.16855191E-09_JPRB, 0.16854176E-09_JPRB, 0.16855414E-09_JPRB, 0.16859635E-09_JPRB, 0.16867339E-09_JPRB, &
  & 0.16878378E-09_JPRB, 0.16891789E-09_JPRB, 0.16905817E-09_JPRB, 0.16918811E-09_JPRB, 0.16929627E-09_JPRB, 0.16937796E-09_JPRB, &
  & 0.16943418E-09_JPRB, 0.16946852E-09_JPRB, 0.16948615E-09_JPRB, 0.16949292E-09_JPRB, 0.16949372E-09_JPRB, 0.16949167E-09_JPRB, &
  & 0.16948815E-09_JPRB, 0.16948348E-09_JPRB, 0.16947799E-09_JPRB, 0.16947133E-09_JPRB, 0.16946378E-09_JPRB, 0.16945539E-09_JPRB, &
  & 0.16944658E-09_JPRB, 0.16943734E-09_JPRB, 0.16942581E-09_JPRB, 0.16940491E-09_JPRB /)

RGHG8(:,67, 1) = (/ &
  & 0.16892533E-09_JPRB, 0.16893227E-09_JPRB, 0.16892703E-09_JPRB, 0.16891571E-09_JPRB, 0.16889806E-09_JPRB, 0.16887328E-09_JPRB, &
  & 0.16884631E-09_JPRB, 0.16882398E-09_JPRB, 0.16881374E-09_JPRB, 0.16880958E-09_JPRB, 0.16880912E-09_JPRB, 0.16880730E-09_JPRB, &
  & 0.16879845E-09_JPRB, 0.16877685E-09_JPRB, 0.16873697E-09_JPRB, 0.16867653E-09_JPRB, 0.16859825E-09_JPRB, 0.16851731E-09_JPRB, &
  & 0.16845322E-09_JPRB, 0.16842325E-09_JPRB, 0.16843282E-09_JPRB, 0.16847912E-09_JPRB, 0.16855406E-09_JPRB, 0.16864635E-09_JPRB, &
  & 0.16874291E-09_JPRB, 0.16883209E-09_JPRB, 0.16890309E-09_JPRB, 0.16895089E-09_JPRB, 0.16897386E-09_JPRB, 0.16897594E-09_JPRB, &
  & 0.16895964E-09_JPRB, 0.16892346E-09_JPRB, 0.16886940E-09_JPRB, 0.16880616E-09_JPRB, 0.16874623E-09_JPRB, 0.16869593E-09_JPRB, &
  & 0.16865682E-09_JPRB, 0.16863021E-09_JPRB, 0.16862001E-09_JPRB, 0.16863244E-09_JPRB, 0.16867453E-09_JPRB, 0.16875025E-09_JPRB, &
  & 0.16885787E-09_JPRB, 0.16898652E-09_JPRB, 0.16912069E-09_JPRB, 0.16924391E-09_JPRB, 0.16934665E-09_JPRB, 0.16942470E-09_JPRB, &
  & 0.16947861E-09_JPRB, 0.16951221E-09_JPRB, 0.16952985E-09_JPRB, 0.16953661E-09_JPRB, 0.16953712E-09_JPRB, 0.16953433E-09_JPRB, &
  & 0.16952988E-09_JPRB, 0.16952421E-09_JPRB, 0.16951730E-09_JPRB, 0.16950957E-09_JPRB, 0.16950071E-09_JPRB, 0.16949103E-09_JPRB, &
  & 0.16948098E-09_JPRB, 0.16946954E-09_JPRB, 0.16945541E-09_JPRB, 0.16942747E-09_JPRB /)

RGHG8(:,68, 1) = (/ &
  & 0.16899779E-09_JPRB, 0.16900870E-09_JPRB, 0.16900498E-09_JPRB, 0.16899496E-09_JPRB, 0.16897811E-09_JPRB, 0.16895407E-09_JPRB, &
  & 0.16892858E-09_JPRB, 0.16890765E-09_JPRB, 0.16889984E-09_JPRB, 0.16889788E-09_JPRB, 0.16889892E-09_JPRB, 0.16889821E-09_JPRB, &
  & 0.16889005E-09_JPRB, 0.16886920E-09_JPRB, 0.16883084E-09_JPRB, 0.16877344E-09_JPRB, 0.16869965E-09_JPRB, 0.16862473E-09_JPRB, &
  & 0.16856562E-09_JPRB, 0.16853828E-09_JPRB, 0.16854777E-09_JPRB, 0.16859100E-09_JPRB, 0.16866077E-09_JPRB, 0.16874589E-09_JPRB, &
  & 0.16883511E-09_JPRB, 0.16891639E-09_JPRB, 0.16898101E-09_JPRB, 0.16902377E-09_JPRB, 0.16904382E-09_JPRB, 0.16904494E-09_JPRB, &
  & 0.16902948E-09_JPRB, 0.16899540E-09_JPRB, 0.16894414E-09_JPRB, 0.16888396E-09_JPRB, 0.16882694E-09_JPRB, 0.16877892E-09_JPRB, &
  & 0.16874131E-09_JPRB, 0.16871546E-09_JPRB, 0.16870565E-09_JPRB, 0.16871807E-09_JPRB, 0.16875946E-09_JPRB, 0.16883325E-09_JPRB, &
  & 0.16893642E-09_JPRB, 0.16905891E-09_JPRB, 0.16918522E-09_JPRB, 0.16930153E-09_JPRB, 0.16939818E-09_JPRB, 0.16947180E-09_JPRB, &
  & 0.16952316E-09_JPRB, 0.16955543E-09_JPRB, 0.16957265E-09_JPRB, 0.16957942E-09_JPRB, 0.16957982E-09_JPRB, 0.16957669E-09_JPRB, &
  & 0.16957168E-09_JPRB, 0.16956504E-09_JPRB, 0.16955742E-09_JPRB, 0.16954854E-09_JPRB, 0.16953888E-09_JPRB, 0.16952835E-09_JPRB, &
  & 0.16951685E-09_JPRB, 0.16950397E-09_JPRB, 0.16948569E-09_JPRB, 0.16945044E-09_JPRB /)

RGHG8(:,69, 1) = (/ &
  & 0.16907134E-09_JPRB, 0.16908674E-09_JPRB, 0.16908483E-09_JPRB, 0.16907592E-09_JPRB, 0.16906028E-09_JPRB, 0.16903753E-09_JPRB, &
  & 0.16901366E-09_JPRB, 0.16899554E-09_JPRB, 0.16899029E-09_JPRB, 0.16899056E-09_JPRB, 0.16899283E-09_JPRB, 0.16899303E-09_JPRB, &
  & 0.16898555E-09_JPRB, 0.16896579E-09_JPRB, 0.16892930E-09_JPRB, 0.16887566E-09_JPRB, 0.16880661E-09_JPRB, 0.16873783E-09_JPRB, &
  & 0.16868321E-09_JPRB, 0.16865787E-09_JPRB, 0.16866630E-09_JPRB, 0.16870588E-09_JPRB, 0.16876966E-09_JPRB, 0.16884771E-09_JPRB, &
  & 0.16892863E-09_JPRB, 0.16900255E-09_JPRB, 0.16906040E-09_JPRB, 0.16909847E-09_JPRB, 0.16911572E-09_JPRB, 0.16911611E-09_JPRB, &
  & 0.16910165E-09_JPRB, 0.16906988E-09_JPRB, 0.16902187E-09_JPRB, 0.16896537E-09_JPRB, 0.16891187E-09_JPRB, 0.16886689E-09_JPRB, &
  & 0.16883134E-09_JPRB, 0.16880684E-09_JPRB, 0.16879768E-09_JPRB, 0.16881027E-09_JPRB, 0.16885070E-09_JPRB, 0.16892154E-09_JPRB, &
  & 0.16901960E-09_JPRB, 0.16913454E-09_JPRB, 0.16925258E-09_JPRB, 0.16936064E-09_JPRB, 0.16945087E-09_JPRB, 0.16951961E-09_JPRB, &
  & 0.16956776E-09_JPRB, 0.16959839E-09_JPRB, 0.16961486E-09_JPRB, 0.16962157E-09_JPRB, 0.16962196E-09_JPRB, 0.16961876E-09_JPRB, &
  & 0.16961352E-09_JPRB, 0.16960661E-09_JPRB, 0.16959836E-09_JPRB, 0.16958920E-09_JPRB, 0.16957905E-09_JPRB, 0.16956785E-09_JPRB, &
  & 0.16955579E-09_JPRB, 0.16954077E-09_JPRB, 0.16951951E-09_JPRB, 0.16947409E-09_JPRB /)

RGHG8(:,70, 1) = (/ &
  & 0.16914477E-09_JPRB, 0.16916624E-09_JPRB, 0.16916669E-09_JPRB, 0.16915946E-09_JPRB, 0.16914516E-09_JPRB, 0.16912405E-09_JPRB, &
  & 0.16910297E-09_JPRB, 0.16908783E-09_JPRB, 0.16908541E-09_JPRB, 0.16908755E-09_JPRB, 0.16909063E-09_JPRB, 0.16909132E-09_JPRB, &
  & 0.16908436E-09_JPRB, 0.16906569E-09_JPRB, 0.16903157E-09_JPRB, 0.16898175E-09_JPRB, 0.16891794E-09_JPRB, 0.16885471E-09_JPRB, &
  & 0.16880418E-09_JPRB, 0.16878038E-09_JPRB, 0.16878747E-09_JPRB, 0.16882283E-09_JPRB, 0.16888055E-09_JPRB, 0.16895074E-09_JPRB, &
  & 0.16902381E-09_JPRB, 0.16908988E-09_JPRB, 0.16914144E-09_JPRB, 0.16917487E-09_JPRB, 0.16918958E-09_JPRB, 0.16918948E-09_JPRB, &
  & 0.16917623E-09_JPRB, 0.16914704E-09_JPRB, 0.16910257E-09_JPRB, 0.16905026E-09_JPRB, 0.16900092E-09_JPRB, 0.16895943E-09_JPRB, &
  & 0.16892647E-09_JPRB, 0.16890374E-09_JPRB, 0.16889556E-09_JPRB, 0.16890821E-09_JPRB, 0.16894725E-09_JPRB, 0.16901462E-09_JPRB, &
  & 0.16910684E-09_JPRB, 0.16921337E-09_JPRB, 0.16932220E-09_JPRB, 0.16942173E-09_JPRB, 0.16950444E-09_JPRB, 0.16956793E-09_JPRB, &
  & 0.16961253E-09_JPRB, 0.16964116E-09_JPRB, 0.16965676E-09_JPRB, 0.16966330E-09_JPRB, 0.16966377E-09_JPRB, 0.16966083E-09_JPRB, &
  & 0.16965579E-09_JPRB, 0.16964895E-09_JPRB, 0.16964086E-09_JPRB, 0.16963166E-09_JPRB, 0.16962143E-09_JPRB, 0.16961013E-09_JPRB, &
  & 0.16959760E-09_JPRB, 0.16958177E-09_JPRB, 0.16955704E-09_JPRB, 0.16950348E-09_JPRB /)

RGHG8(:,71, 1) = (/ &
  & 0.16921975E-09_JPRB, 0.16924842E-09_JPRB, 0.16925153E-09_JPRB, 0.16924598E-09_JPRB, 0.16923335E-09_JPRB, 0.16921431E-09_JPRB, &
  & 0.16919638E-09_JPRB, 0.16918486E-09_JPRB, 0.16918487E-09_JPRB, 0.16918823E-09_JPRB, 0.16919169E-09_JPRB, 0.16919233E-09_JPRB, &
  & 0.16918562E-09_JPRB, 0.16916819E-09_JPRB, 0.16913648E-09_JPRB, 0.16909053E-09_JPRB, 0.16903222E-09_JPRB, 0.16897439E-09_JPRB, &
  & 0.16892790E-09_JPRB, 0.16890545E-09_JPRB, 0.16891080E-09_JPRB, 0.16894180E-09_JPRB, 0.16899274E-09_JPRB, 0.16905538E-09_JPRB, &
  & 0.16911997E-09_JPRB, 0.16917866E-09_JPRB, 0.16922387E-09_JPRB, 0.16925303E-09_JPRB, 0.16926539E-09_JPRB, 0.16926502E-09_JPRB, &
  & 0.16925318E-09_JPRB, 0.16922681E-09_JPRB, 0.16918625E-09_JPRB, 0.16913856E-09_JPRB, 0.16909378E-09_JPRB, 0.16905617E-09_JPRB, &
  & 0.16902624E-09_JPRB, 0.16900562E-09_JPRB, 0.16899857E-09_JPRB, 0.16901119E-09_JPRB, 0.16904847E-09_JPRB, 0.16911203E-09_JPRB, &
  & 0.16919707E-09_JPRB, 0.16929511E-09_JPRB, 0.16939383E-09_JPRB, 0.16948389E-09_JPRB, 0.16955895E-09_JPRB, 0.16961642E-09_JPRB, &
  & 0.16965715E-09_JPRB, 0.16968367E-09_JPRB, 0.16969814E-09_JPRB, 0.16970450E-09_JPRB, 0.16970517E-09_JPRB, 0.16970275E-09_JPRB, &
  & 0.16969824E-09_JPRB, 0.16969209E-09_JPRB, 0.16968441E-09_JPRB, 0.16967579E-09_JPRB, 0.16966580E-09_JPRB, 0.16965482E-09_JPRB, &
  & 0.16964238E-09_JPRB, 0.16962623E-09_JPRB, 0.16960013E-09_JPRB, 0.16954101E-09_JPRB /)

RGHG8(:,72, 1) = (/ &
  & 0.16929712E-09_JPRB, 0.16933367E-09_JPRB, 0.16933954E-09_JPRB, 0.16933581E-09_JPRB, 0.16932489E-09_JPRB, 0.16930825E-09_JPRB, &
  & 0.16929383E-09_JPRB, 0.16928585E-09_JPRB, 0.16928771E-09_JPRB, 0.16929158E-09_JPRB, 0.16929466E-09_JPRB, 0.16929474E-09_JPRB, &
  & 0.16928847E-09_JPRB, 0.16927192E-09_JPRB, 0.16924290E-09_JPRB, 0.16920086E-09_JPRB, 0.16914820E-09_JPRB, 0.16909560E-09_JPRB, &
  & 0.16905319E-09_JPRB, 0.16903222E-09_JPRB, 0.16903584E-09_JPRB, 0.16906210E-09_JPRB, 0.16910644E-09_JPRB, 0.16916098E-09_JPRB, &
  & 0.16921742E-09_JPRB, 0.16926852E-09_JPRB, 0.16930769E-09_JPRB, 0.16933273E-09_JPRB, 0.16934301E-09_JPRB, 0.16934257E-09_JPRB, &
  & 0.16933224E-09_JPRB, 0.16930901E-09_JPRB, 0.16927260E-09_JPRB, 0.16923006E-09_JPRB, 0.16919012E-09_JPRB, 0.16915684E-09_JPRB, &
  & 0.16913025E-09_JPRB, 0.16911209E-09_JPRB, 0.16910626E-09_JPRB, 0.16911877E-09_JPRB, 0.16915401E-09_JPRB, 0.16921249E-09_JPRB, &
  & 0.16929060E-09_JPRB, 0.16937821E-09_JPRB, 0.16946676E-09_JPRB, 0.16954720E-09_JPRB, 0.16961355E-09_JPRB, 0.16966485E-09_JPRB, &
  & 0.16970164E-09_JPRB, 0.16972536E-09_JPRB, 0.16973888E-09_JPRB, 0.16974487E-09_JPRB, 0.16974586E-09_JPRB, 0.16974411E-09_JPRB, &
  & 0.16974054E-09_JPRB, 0.16973509E-09_JPRB, 0.16972854E-09_JPRB, 0.16972034E-09_JPRB, 0.16971143E-09_JPRB, 0.16970078E-09_JPRB, &
  & 0.16968921E-09_JPRB, 0.16967329E-09_JPRB, 0.16964687E-09_JPRB, 0.16958482E-09_JPRB /)

RGHG8(:,73, 1) = (/ &
  & 0.16938612E-09_JPRB, 0.16942432E-09_JPRB, 0.16943102E-09_JPRB, 0.16942832E-09_JPRB, 0.16941890E-09_JPRB, 0.16940471E-09_JPRB, &
  & 0.16939386E-09_JPRB, 0.16938886E-09_JPRB, 0.16939163E-09_JPRB, 0.16939528E-09_JPRB, 0.16939807E-09_JPRB, 0.16939765E-09_JPRB, &
  & 0.16939099E-09_JPRB, 0.16937622E-09_JPRB, 0.16934947E-09_JPRB, 0.16931133E-09_JPRB, 0.16926449E-09_JPRB, 0.16921742E-09_JPRB, &
  & 0.16917955E-09_JPRB, 0.16916010E-09_JPRB, 0.16916198E-09_JPRB, 0.16918354E-09_JPRB, 0.16922096E-09_JPRB, 0.16926772E-09_JPRB, &
  & 0.16931583E-09_JPRB, 0.16935955E-09_JPRB, 0.16939276E-09_JPRB, 0.16941397E-09_JPRB, 0.16942234E-09_JPRB, 0.16942196E-09_JPRB, &
  & 0.16941323E-09_JPRB, 0.16939319E-09_JPRB, 0.16936141E-09_JPRB, 0.16932428E-09_JPRB, 0.16928950E-09_JPRB, 0.16926080E-09_JPRB, &
  & 0.16923785E-09_JPRB, 0.16922233E-09_JPRB, 0.16921778E-09_JPRB, 0.16923005E-09_JPRB, 0.16926245E-09_JPRB, 0.16931591E-09_JPRB, &
  & 0.16938471E-09_JPRB, 0.16946253E-09_JPRB, 0.16954008E-09_JPRB, 0.16960976E-09_JPRB, 0.16966815E-09_JPRB, 0.16971297E-09_JPRB, &
  & 0.16974490E-09_JPRB, 0.16976653E-09_JPRB, 0.16977837E-09_JPRB, 0.16978410E-09_JPRB, 0.16978534E-09_JPRB, 0.16978437E-09_JPRB, &
  & 0.16978144E-09_JPRB, 0.16977730E-09_JPRB, 0.16977135E-09_JPRB, 0.16976470E-09_JPRB, 0.16975618E-09_JPRB, 0.16974708E-09_JPRB, &
  & 0.16973607E-09_JPRB, 0.16972145E-09_JPRB, 0.16969542E-09_JPRB, 0.16963277E-09_JPRB /)

RGHG8(:,74, 1) = (/ &
  & 0.16947639E-09_JPRB, 0.16951647E-09_JPRB, 0.16952353E-09_JPRB, 0.16952167E-09_JPRB, 0.16951371E-09_JPRB, 0.16950204E-09_JPRB, &
  & 0.16949392E-09_JPRB, 0.16949103E-09_JPRB, 0.16949414E-09_JPRB, 0.16949772E-09_JPRB, 0.16949972E-09_JPRB, 0.16949878E-09_JPRB, &
  & 0.16949314E-09_JPRB, 0.16947875E-09_JPRB, 0.16945506E-09_JPRB, 0.16942099E-09_JPRB, 0.16937987E-09_JPRB, 0.16933889E-09_JPRB, &
  & 0.16930567E-09_JPRB, 0.16928831E-09_JPRB, 0.16928861E-09_JPRB, 0.16930557E-09_JPRB, 0.16933632E-09_JPRB, 0.16937524E-09_JPRB, &
  & 0.16941518E-09_JPRB, 0.16945166E-09_JPRB, 0.16947910E-09_JPRB, 0.16949665E-09_JPRB, 0.16950327E-09_JPRB, 0.16950308E-09_JPRB, &
  & 0.16949596E-09_JPRB, 0.16947926E-09_JPRB, 0.16945226E-09_JPRB, 0.16942080E-09_JPRB, 0.16939151E-09_JPRB, 0.16936762E-09_JPRB, &
  & 0.16934835E-09_JPRB, 0.16933567E-09_JPRB, 0.16933231E-09_JPRB, 0.16934404E-09_JPRB, 0.16937327E-09_JPRB, 0.16942001E-09_JPRB, &
  & 0.16947999E-09_JPRB, 0.16954624E-09_JPRB, 0.16961216E-09_JPRB, 0.16967250E-09_JPRB, 0.16972147E-09_JPRB, 0.16975973E-09_JPRB, &
  & 0.16978771E-09_JPRB, 0.16980585E-09_JPRB, 0.16981665E-09_JPRB, 0.16982188E-09_JPRB, 0.16982316E-09_JPRB, 0.16982274E-09_JPRB, &
  & 0.16982071E-09_JPRB, 0.16981716E-09_JPRB, 0.16981272E-09_JPRB, 0.16980661E-09_JPRB, 0.16979998E-09_JPRB, 0.16979142E-09_JPRB, &
  & 0.16978233E-09_JPRB, 0.16976878E-09_JPRB, 0.16974440E-09_JPRB, 0.16968360E-09_JPRB /)

RGHG8(:,75, 1) = (/ &
  & 0.16956690E-09_JPRB, 0.16960738E-09_JPRB, 0.16961513E-09_JPRB, 0.16961414E-09_JPRB, 0.16960755E-09_JPRB, 0.16959796E-09_JPRB, &
  & 0.16959219E-09_JPRB, 0.16959056E-09_JPRB, 0.16959376E-09_JPRB, 0.16959675E-09_JPRB, 0.16959860E-09_JPRB, 0.16959770E-09_JPRB, &
  & 0.16959179E-09_JPRB, 0.16957996E-09_JPRB, 0.16955841E-09_JPRB, 0.16952906E-09_JPRB, 0.16949422E-09_JPRB, 0.16945961E-09_JPRB, &
  & 0.16943150E-09_JPRB, 0.16941649E-09_JPRB, 0.16941559E-09_JPRB, 0.16942833E-09_JPRB, 0.16945262E-09_JPRB, 0.16948394E-09_JPRB, &
  & 0.16951592E-09_JPRB, 0.16954524E-09_JPRB, 0.16956707E-09_JPRB, 0.16958121E-09_JPRB, 0.16958618E-09_JPRB, 0.16958621E-09_JPRB, &
  & 0.16958064E-09_JPRB, 0.16956724E-09_JPRB, 0.16954516E-09_JPRB, 0.16951951E-09_JPRB, 0.16949593E-09_JPRB, 0.16947679E-09_JPRB, &
  & 0.16946135E-09_JPRB, 0.16945151E-09_JPRB, 0.16944919E-09_JPRB, 0.16946002E-09_JPRB, 0.16948512E-09_JPRB, 0.16952517E-09_JPRB, &
  & 0.16957444E-09_JPRB, 0.16962909E-09_JPRB, 0.16968411E-09_JPRB, 0.16973295E-09_JPRB, 0.16977428E-09_JPRB, 0.16980570E-09_JPRB, &
  & 0.16982855E-09_JPRB, 0.16984424E-09_JPRB, 0.16985308E-09_JPRB, 0.16985779E-09_JPRB, 0.16985899E-09_JPRB, 0.16985904E-09_JPRB, &
  & 0.16985738E-09_JPRB, 0.16985489E-09_JPRB, 0.16985105E-09_JPRB, 0.16984672E-09_JPRB, 0.16984097E-09_JPRB, 0.16983429E-09_JPRB, &
  & 0.16982640E-09_JPRB, 0.16981486E-09_JPRB, 0.16979278E-09_JPRB, 0.16973588E-09_JPRB /)

RGHG8(:,76, 1) = (/ &
  & 0.16965535E-09_JPRB, 0.16969667E-09_JPRB, 0.16970439E-09_JPRB, 0.16970428E-09_JPRB, 0.16969906E-09_JPRB, 0.16969147E-09_JPRB, &
  & 0.16968738E-09_JPRB, 0.16968646E-09_JPRB, 0.16968926E-09_JPRB, 0.16969190E-09_JPRB, 0.16969294E-09_JPRB, 0.16969182E-09_JPRB, &
  & 0.16968754E-09_JPRB, 0.16967683E-09_JPRB, 0.16965954E-09_JPRB, 0.16963525E-09_JPRB, 0.16960736E-09_JPRB, 0.16957970E-09_JPRB, &
  & 0.16955687E-09_JPRB, 0.16954461E-09_JPRB, 0.16954299E-09_JPRB, 0.16955203E-09_JPRB, 0.16957011E-09_JPRB, 0.16959399E-09_JPRB, &
  & 0.16961807E-09_JPRB, 0.16964048E-09_JPRB, 0.16965690E-09_JPRB, 0.16966784E-09_JPRB, 0.16967133E-09_JPRB, 0.16967161E-09_JPRB, &
  & 0.16966734E-09_JPRB, 0.16965718E-09_JPRB, 0.16964004E-09_JPRB, 0.16962043E-09_JPRB, 0.16960251E-09_JPRB, 0.16958823E-09_JPRB, &
  & 0.16957635E-09_JPRB, 0.16956928E-09_JPRB, 0.16956765E-09_JPRB, 0.16957714E-09_JPRB, 0.16959775E-09_JPRB, 0.16962985E-09_JPRB, &
  & 0.16966863E-09_JPRB, 0.16971125E-09_JPRB, 0.16975402E-09_JPRB, 0.16979344E-09_JPRB, 0.16982513E-09_JPRB, 0.16985002E-09_JPRB, &
  & 0.16986831E-09_JPRB, 0.16988050E-09_JPRB, 0.16988774E-09_JPRB, 0.16989180E-09_JPRB, 0.16989261E-09_JPRB, 0.16989304E-09_JPRB, &
  & 0.16989174E-09_JPRB, 0.16988982E-09_JPRB, 0.16988713E-09_JPRB, 0.16988394E-09_JPRB, 0.16987994E-09_JPRB, 0.16987445E-09_JPRB, &
  & 0.16986845E-09_JPRB, 0.16985888E-09_JPRB, 0.16983977E-09_JPRB, 0.16978892E-09_JPRB /)

RGHG8(:,77, 1) = (/ &
  & 0.16974240E-09_JPRB, 0.16978181E-09_JPRB, 0.16978975E-09_JPRB, 0.16979049E-09_JPRB, 0.16978668E-09_JPRB, 0.16978091E-09_JPRB, &
  & 0.16977848E-09_JPRB, 0.16977778E-09_JPRB, 0.16977979E-09_JPRB, 0.16978122E-09_JPRB, 0.16978145E-09_JPRB, 0.16978038E-09_JPRB, &
  & 0.16977693E-09_JPRB, 0.16976981E-09_JPRB, 0.16975650E-09_JPRB, 0.16973874E-09_JPRB, 0.16971845E-09_JPRB, 0.16969823E-09_JPRB, &
  & 0.16968094E-09_JPRB, 0.16967190E-09_JPRB, 0.16967007E-09_JPRB, 0.16967588E-09_JPRB, 0.16968822E-09_JPRB, 0.16970512E-09_JPRB, &
  & 0.16972176E-09_JPRB, 0.16973768E-09_JPRB, 0.16974905E-09_JPRB, 0.16975699E-09_JPRB, 0.16975910E-09_JPRB, 0.16975947E-09_JPRB, &
  & 0.16975628E-09_JPRB, 0.16974912E-09_JPRB, 0.16973668E-09_JPRB, 0.16972281E-09_JPRB, 0.16971037E-09_JPRB, 0.16970057E-09_JPRB, &
  & 0.16969216E-09_JPRB, 0.16968756E-09_JPRB, 0.16968629E-09_JPRB, 0.16969405E-09_JPRB, 0.16970925E-09_JPRB, 0.16973335E-09_JPRB, &
  & 0.16976073E-09_JPRB, 0.16979126E-09_JPRB, 0.16982278E-09_JPRB, 0.16985108E-09_JPRB, 0.16987474E-09_JPRB, 0.16989245E-09_JPRB, &
  & 0.16990594E-09_JPRB, 0.16991501E-09_JPRB, 0.16992013E-09_JPRB, 0.16992341E-09_JPRB, 0.16992363E-09_JPRB, 0.16992441E-09_JPRB, &
  & 0.16992321E-09_JPRB, 0.16992203E-09_JPRB, 0.16992008E-09_JPRB, 0.16991833E-09_JPRB, 0.16991585E-09_JPRB, 0.16991185E-09_JPRB, &
  & 0.16990767E-09_JPRB, 0.16990011E-09_JPRB, 0.16988473E-09_JPRB, 0.16984132E-09_JPRB /)

RGHG8(:,78, 1) = (/ &
  & 0.16982614E-09_JPRB, 0.16985943E-09_JPRB, 0.16986512E-09_JPRB, 0.16986654E-09_JPRB, 0.16986410E-09_JPRB, 0.16986039E-09_JPRB, &
  & 0.16985952E-09_JPRB, 0.16985888E-09_JPRB, 0.16985957E-09_JPRB, 0.16985968E-09_JPRB, 0.16985868E-09_JPRB, 0.16985756E-09_JPRB, &
  & 0.16985607E-09_JPRB, 0.16985220E-09_JPRB, 0.16984414E-09_JPRB, 0.16983290E-09_JPRB, 0.16982055E-09_JPRB, 0.16980779E-09_JPRB, &
  & 0.16979626E-09_JPRB, 0.16979092E-09_JPRB, 0.16978957E-09_JPRB, 0.16979305E-09_JPRB, 0.16980040E-09_JPRB, 0.16981117E-09_JPRB, &
  & 0.16982131E-09_JPRB, 0.16983151E-09_JPRB, 0.16983856E-09_JPRB, 0.16984386E-09_JPRB, 0.16984478E-09_JPRB, 0.16984512E-09_JPRB, &
  & 0.16984265E-09_JPRB, 0.16983802E-09_JPRB, 0.16982976E-09_JPRB, 0.16982110E-09_JPRB, 0.16981340E-09_JPRB, 0.16980735E-09_JPRB, &
  & 0.16980177E-09_JPRB, 0.16979913E-09_JPRB, 0.16979756E-09_JPRB, 0.16980299E-09_JPRB, 0.16981247E-09_JPRB, 0.16982825E-09_JPRB, &
  & 0.16984492E-09_JPRB, 0.16986400E-09_JPRB, 0.16988463E-09_JPRB, 0.16990367E-09_JPRB, 0.16991898E-09_JPRB, 0.16993051E-09_JPRB, &
  & 0.16993948E-09_JPRB, 0.16994532E-09_JPRB, 0.16994846E-09_JPRB, 0.16995090E-09_JPRB, 0.16995026E-09_JPRB, 0.16995130E-09_JPRB, &
  & 0.16995007E-09_JPRB, 0.16994943E-09_JPRB, 0.16994814E-09_JPRB, 0.16994756E-09_JPRB, 0.16994643E-09_JPRB, 0.16994380E-09_JPRB, &
  & 0.16994130E-09_JPRB, 0.16993572E-09_JPRB, 0.16992507E-09_JPRB, 0.16989260E-09_JPRB /)

RGHG8(:,79, 1) = (/ &
  & 0.16988008E-09_JPRB, 0.16990254E-09_JPRB, 0.16990506E-09_JPRB, 0.16990576E-09_JPRB, 0.16990390E-09_JPRB, 0.16990116E-09_JPRB, &
  & 0.16990133E-09_JPRB, 0.16990073E-09_JPRB, 0.16990090E-09_JPRB, 0.16990047E-09_JPRB, 0.16989903E-09_JPRB, 0.16989804E-09_JPRB, &
  & 0.16989760E-09_JPRB, 0.16989564E-09_JPRB, 0.16989005E-09_JPRB, 0.16988227E-09_JPRB, 0.16987411E-09_JPRB, 0.16986559E-09_JPRB, &
  & 0.16985717E-09_JPRB, 0.16985410E-09_JPRB, 0.16985316E-09_JPRB, 0.16985550E-09_JPRB, 0.16986028E-09_JPRB, 0.16986795E-09_JPRB, &
  & 0.16987468E-09_JPRB, 0.16988200E-09_JPRB, 0.16988676E-09_JPRB, 0.16989084E-09_JPRB, 0.16989110E-09_JPRB, 0.16989152E-09_JPRB, &
  & 0.16988942E-09_JPRB, 0.16988615E-09_JPRB, 0.16988008E-09_JPRB, 0.16987427E-09_JPRB, 0.16986908E-09_JPRB, 0.16986512E-09_JPRB, &
  & 0.16986089E-09_JPRB, 0.16985925E-09_JPRB, 0.16985720E-09_JPRB, 0.16986126E-09_JPRB, 0.16986743E-09_JPRB, 0.16987879E-09_JPRB, &
  & 0.16988945E-09_JPRB, 0.16990240E-09_JPRB, 0.16991744E-09_JPRB, 0.16993140E-09_JPRB, 0.16994262E-09_JPRB, 0.16995064E-09_JPRB, &
  & 0.16995733E-09_JPRB, 0.16996142E-09_JPRB, 0.16996343E-09_JPRB, 0.16996543E-09_JPRB, 0.16996414E-09_JPRB, 0.16996538E-09_JPRB, &
  & 0.16996396E-09_JPRB, 0.16996357E-09_JPRB, 0.16996254E-09_JPRB, 0.16996270E-09_JPRB, 0.16996232E-09_JPRB, 0.16996037E-09_JPRB, &
  & 0.16995880E-09_JPRB, 0.16995466E-09_JPRB, 0.16994758E-09_JPRB, 0.16992524E-09_JPRB /)

RGHG8(:,80, 1) = (/ &
  & 0.16991564E-09_JPRB, 0.16992330E-09_JPRB, 0.16992245E-09_JPRB, 0.16992274E-09_JPRB, 0.16992092E-09_JPRB, 0.16991858E-09_JPRB, &
  & 0.16991929E-09_JPRB, 0.16991887E-09_JPRB, 0.16991890E-09_JPRB, 0.16991852E-09_JPRB, 0.16991694E-09_JPRB, 0.16991615E-09_JPRB, &
  & 0.16991623E-09_JPRB, 0.16991507E-09_JPRB, 0.16991041E-09_JPRB, 0.16990404E-09_JPRB, 0.16989779E-09_JPRB, 0.16989113E-09_JPRB, &
  & 0.16988411E-09_JPRB, 0.16988219E-09_JPRB, 0.16988154E-09_JPRB, 0.16988341E-09_JPRB, 0.16988708E-09_JPRB, 0.16989340E-09_JPRB, &
  & 0.16989868E-09_JPRB, 0.16990480E-09_JPRB, 0.16990856E-09_JPRB, 0.16991220E-09_JPRB, 0.16991217E-09_JPRB, 0.16991270E-09_JPRB, &
  & 0.16991071E-09_JPRB, 0.16990806E-09_JPRB, 0.16990293E-09_JPRB, 0.16989843E-09_JPRB, 0.16989443E-09_JPRB, 0.16989136E-09_JPRB, &
  & 0.16988767E-09_JPRB, 0.16988648E-09_JPRB, 0.16988404E-09_JPRB, 0.16988749E-09_JPRB, 0.16989207E-09_JPRB, 0.16990145E-09_JPRB, &
  & 0.16990934E-09_JPRB, 0.16991947E-09_JPRB, 0.16993200E-09_JPRB, 0.16994381E-09_JPRB, 0.16995308E-09_JPRB, 0.16995956E-09_JPRB, &
  & 0.16996521E-09_JPRB, 0.16996857E-09_JPRB, 0.16997002E-09_JPRB, 0.16997181E-09_JPRB, 0.16997012E-09_JPRB, 0.16997150E-09_JPRB, &
  & 0.16996993E-09_JPRB, 0.16996965E-09_JPRB, 0.16996868E-09_JPRB, 0.16996921E-09_JPRB, 0.16996919E-09_JPRB, 0.16996754E-09_JPRB, &
  & 0.16996646E-09_JPRB, 0.16996293E-09_JPRB, 0.16995838E-09_JPRB, 0.16994656E-09_JPRB /)

RGHG8(:,81, 1) = (/ &
  & 0.16993996E-09_JPRB, 0.16993205E-09_JPRB, 0.16992975E-09_JPRB, 0.16992988E-09_JPRB, 0.16992818E-09_JPRB, 0.16992599E-09_JPRB, &
  & 0.16992695E-09_JPRB, 0.16992660E-09_JPRB, 0.16992666E-09_JPRB, 0.16992635E-09_JPRB, 0.16992489E-09_JPRB, 0.16992413E-09_JPRB, &
  & 0.16992449E-09_JPRB, 0.16992366E-09_JPRB, 0.16991929E-09_JPRB, 0.16991347E-09_JPRB, 0.16990803E-09_JPRB, 0.16990226E-09_JPRB, &
  & 0.16989581E-09_JPRB, 0.16989447E-09_JPRB, 0.16989390E-09_JPRB, 0.16989560E-09_JPRB, 0.16989879E-09_JPRB, 0.16990458E-09_JPRB, &
  & 0.16990920E-09_JPRB, 0.16991482E-09_JPRB, 0.16991818E-09_JPRB, 0.16992166E-09_JPRB, 0.16992147E-09_JPRB, 0.16992202E-09_JPRB, &
  & 0.16992012E-09_JPRB, 0.16991769E-09_JPRB, 0.16991297E-09_JPRB, 0.16990907E-09_JPRB, 0.16990565E-09_JPRB, 0.16990294E-09_JPRB, &
  & 0.16989950E-09_JPRB, 0.16989843E-09_JPRB, 0.16989583E-09_JPRB, 0.16989904E-09_JPRB, 0.16990293E-09_JPRB, 0.16991143E-09_JPRB, &
  & 0.16991800E-09_JPRB, 0.16992688E-09_JPRB, 0.16993840E-09_JPRB, 0.16994928E-09_JPRB, 0.16995770E-09_JPRB, 0.16996345E-09_JPRB, &
  & 0.16996869E-09_JPRB, 0.16997170E-09_JPRB, 0.16997286E-09_JPRB, 0.16997458E-09_JPRB, 0.16997265E-09_JPRB, 0.16997412E-09_JPRB, &
  & 0.16997243E-09_JPRB, 0.16997220E-09_JPRB, 0.16997129E-09_JPRB, 0.16997199E-09_JPRB, 0.16997219E-09_JPRB, 0.16997061E-09_JPRB, &
  & 0.16996976E-09_JPRB, 0.16996643E-09_JPRB, 0.16996293E-09_JPRB, 0.16996096E-09_JPRB /)

RGHG8(:,82, 1) = (/ &
  & 0.16994194E-09_JPRB, 0.16993501E-09_JPRB, 0.16993294E-09_JPRB, 0.16993328E-09_JPRB, 0.16993165E-09_JPRB, 0.16992953E-09_JPRB, &
  & 0.16993067E-09_JPRB, 0.16993039E-09_JPRB, 0.16993049E-09_JPRB, 0.16993029E-09_JPRB, 0.16992868E-09_JPRB, 0.16992807E-09_JPRB, &
  & 0.16992860E-09_JPRB, 0.16992793E-09_JPRB, 0.16992367E-09_JPRB, 0.16991805E-09_JPRB, 0.16991306E-09_JPRB, 0.16990764E-09_JPRB, &
  & 0.16990150E-09_JPRB, 0.16990040E-09_JPRB, 0.16989991E-09_JPRB, 0.16990154E-09_JPRB, 0.16990448E-09_JPRB, 0.16991000E-09_JPRB, &
  & 0.16991429E-09_JPRB, 0.16991972E-09_JPRB, 0.16992287E-09_JPRB, 0.16992628E-09_JPRB, 0.16992599E-09_JPRB, 0.16992663E-09_JPRB, &
  & 0.16992470E-09_JPRB, 0.16992238E-09_JPRB, 0.16991783E-09_JPRB, 0.16991425E-09_JPRB, 0.16991109E-09_JPRB, 0.16990860E-09_JPRB, &
  & 0.16990531E-09_JPRB, 0.16990430E-09_JPRB, 0.16990170E-09_JPRB, 0.16990470E-09_JPRB, 0.16990824E-09_JPRB, 0.16991633E-09_JPRB, &
  & 0.16992222E-09_JPRB, 0.16993043E-09_JPRB, 0.16994151E-09_JPRB, 0.16995194E-09_JPRB, 0.16995995E-09_JPRB, 0.16996538E-09_JPRB, &
  & 0.16997034E-09_JPRB, 0.16997324E-09_JPRB, 0.16997424E-09_JPRB, 0.16997594E-09_JPRB, 0.16997385E-09_JPRB, 0.16997541E-09_JPRB, &
  & 0.16997360E-09_JPRB, 0.16997345E-09_JPRB, 0.16997251E-09_JPRB, 0.16997330E-09_JPRB, 0.16997363E-09_JPRB, 0.16997215E-09_JPRB, &
  & 0.16997137E-09_JPRB, 0.16996798E-09_JPRB, 0.16996443E-09_JPRB, 0.16996209E-09_JPRB /)

RGHG8(:,83, 1) = (/ &
  & 0.16994330E-09_JPRB, 0.16993672E-09_JPRB, 0.16993475E-09_JPRB, 0.16993519E-09_JPRB, 0.16993361E-09_JPRB, 0.16993150E-09_JPRB, &
  & 0.16993272E-09_JPRB, 0.16993253E-09_JPRB, 0.16993261E-09_JPRB, 0.16993236E-09_JPRB, 0.16993101E-09_JPRB, 0.16993029E-09_JPRB, &
  & 0.16993089E-09_JPRB, 0.16993032E-09_JPRB, 0.16992613E-09_JPRB, 0.16992065E-09_JPRB, 0.16991586E-09_JPRB, 0.16991074E-09_JPRB, &
  & 0.16990459E-09_JPRB, 0.16990374E-09_JPRB, 0.16990329E-09_JPRB, 0.16990477E-09_JPRB, 0.16990763E-09_JPRB, 0.16991299E-09_JPRB, &
  & 0.16991711E-09_JPRB, 0.16992244E-09_JPRB, 0.16992546E-09_JPRB, 0.16992888E-09_JPRB, 0.16992850E-09_JPRB, 0.16992918E-09_JPRB, &
  & 0.16992725E-09_JPRB, 0.16992496E-09_JPRB, 0.16992049E-09_JPRB, 0.16991709E-09_JPRB, 0.16991414E-09_JPRB, 0.16991171E-09_JPRB, &
  & 0.16990859E-09_JPRB, 0.16990756E-09_JPRB, 0.16990501E-09_JPRB, 0.16990789E-09_JPRB, 0.16991125E-09_JPRB, 0.16991894E-09_JPRB, &
  & 0.16992451E-09_JPRB, 0.16993233E-09_JPRB, 0.16994328E-09_JPRB, 0.16995348E-09_JPRB, 0.16996127E-09_JPRB, 0.16996643E-09_JPRB, &
  & 0.16997136E-09_JPRB, 0.16997410E-09_JPRB, 0.16997502E-09_JPRB, 0.16997670E-09_JPRB, 0.16997452E-09_JPRB, 0.16997612E-09_JPRB, &
  & 0.16997424E-09_JPRB, 0.16997413E-09_JPRB, 0.16997317E-09_JPRB, 0.16997405E-09_JPRB, 0.16997447E-09_JPRB, 0.16997299E-09_JPRB, &
  & 0.16997230E-09_JPRB, 0.16996886E-09_JPRB, 0.16996528E-09_JPRB, 0.16996285E-09_JPRB /)

RGHG8(:,84, 1) = (/ &
  & 0.16994428E-09_JPRB, 0.16993781E-09_JPRB, 0.16993590E-09_JPRB, 0.16993637E-09_JPRB, 0.16993480E-09_JPRB, 0.16993269E-09_JPRB, &
  & 0.16993398E-09_JPRB, 0.16993379E-09_JPRB, 0.16993387E-09_JPRB, 0.16993376E-09_JPRB, 0.16993225E-09_JPRB, 0.16993175E-09_JPRB, &
  & 0.16993235E-09_JPRB, 0.16993178E-09_JPRB, 0.16992768E-09_JPRB, 0.16992223E-09_JPRB, 0.16991761E-09_JPRB, 0.16991250E-09_JPRB, &
  & 0.16990663E-09_JPRB, 0.16990583E-09_JPRB, 0.16990533E-09_JPRB, 0.16990680E-09_JPRB, 0.16990948E-09_JPRB, 0.16991483E-09_JPRB, &
  & 0.16991882E-09_JPRB, 0.16992409E-09_JPRB, 0.16992707E-09_JPRB, 0.16993049E-09_JPRB, 0.16993010E-09_JPRB, 0.16993079E-09_JPRB, &
  & 0.16992881E-09_JPRB, 0.16992655E-09_JPRB, 0.16992208E-09_JPRB, 0.16991883E-09_JPRB, 0.16991596E-09_JPRB, 0.16991364E-09_JPRB, &
  & 0.16991061E-09_JPRB, 0.16990959E-09_JPRB, 0.16990714E-09_JPRB, 0.16990993E-09_JPRB, 0.16991304E-09_JPRB, 0.16992070E-09_JPRB, &
  & 0.16992581E-09_JPRB, 0.16993357E-09_JPRB, 0.16994428E-09_JPRB, 0.16995444E-09_JPRB, 0.16996209E-09_JPRB, 0.16996711E-09_JPRB, &
  & 0.16997195E-09_JPRB, 0.16997465E-09_JPRB, 0.16997549E-09_JPRB, 0.16997717E-09_JPRB, 0.16997490E-09_JPRB, 0.16997659E-09_JPRB, &
  & 0.16997462E-09_JPRB, 0.16997452E-09_JPRB, 0.16997355E-09_JPRB, 0.16997448E-09_JPRB, 0.16997496E-09_JPRB, 0.16997355E-09_JPRB, &
  & 0.16997292E-09_JPRB, 0.16996940E-09_JPRB, 0.16996582E-09_JPRB, 0.16996334E-09_JPRB /)

RGHG8(:,85, 1) = (/ &
  & 0.16994491E-09_JPRB, 0.16993854E-09_JPRB, 0.16993661E-09_JPRB, 0.16993716E-09_JPRB, 0.16993562E-09_JPRB, 0.16993347E-09_JPRB, &
  & 0.16993477E-09_JPRB, 0.16993461E-09_JPRB, 0.16993466E-09_JPRB, 0.16993440E-09_JPRB, 0.16993337E-09_JPRB, 0.16993282E-09_JPRB, &
  & 0.16993319E-09_JPRB, 0.16993258E-09_JPRB, 0.16992872E-09_JPRB, 0.16992331E-09_JPRB, 0.16991875E-09_JPRB, 0.16991378E-09_JPRB, &
  & 0.16990780E-09_JPRB, 0.16990713E-09_JPRB, 0.16990662E-09_JPRB, 0.16990799E-09_JPRB, 0.16991070E-09_JPRB, 0.16991597E-09_JPRB, &
  & 0.16991991E-09_JPRB, 0.16992521E-09_JPRB, 0.16992807E-09_JPRB, 0.16993157E-09_JPRB, 0.16993107E-09_JPRB, 0.16993182E-09_JPRB, &
  & 0.16992979E-09_JPRB, 0.16992752E-09_JPRB, 0.16992308E-09_JPRB, 0.16991994E-09_JPRB, 0.16991716E-09_JPRB, 0.16991489E-09_JPRB, &
  & 0.16991196E-09_JPRB, 0.16991092E-09_JPRB, 0.16990845E-09_JPRB, 0.16991115E-09_JPRB, 0.16991430E-09_JPRB, 0.16992166E-09_JPRB, &
  & 0.16992685E-09_JPRB, 0.16993415E-09_JPRB, 0.16994511E-09_JPRB, 0.16995504E-09_JPRB, 0.16996266E-09_JPRB, 0.16996755E-09_JPRB, &
  & 0.16997237E-09_JPRB, 0.16997501E-09_JPRB, 0.16997581E-09_JPRB, 0.16997748E-09_JPRB, 0.16997515E-09_JPRB, 0.16997688E-09_JPRB, &
  & 0.16997483E-09_JPRB, 0.16997477E-09_JPRB, 0.16997379E-09_JPRB, 0.16997477E-09_JPRB, 0.16997533E-09_JPRB, 0.16997392E-09_JPRB, &
  & 0.16997334E-09_JPRB, 0.16996977E-09_JPRB, 0.16996617E-09_JPRB, 0.16996364E-09_JPRB /)

RGHG8(:,86, 1) = (/ &
  & 0.16994538E-09_JPRB, 0.16993899E-09_JPRB, 0.16993708E-09_JPRB, 0.16993768E-09_JPRB, 0.16993604E-09_JPRB, 0.16993396E-09_JPRB, &
  & 0.16993526E-09_JPRB, 0.16993512E-09_JPRB, 0.16993507E-09_JPRB, 0.16993479E-09_JPRB, 0.16993391E-09_JPRB, 0.16993348E-09_JPRB, &
  & 0.16993361E-09_JPRB, 0.16993291E-09_JPRB, 0.16992931E-09_JPRB, 0.16992413E-09_JPRB, 0.16991955E-09_JPRB, 0.16991458E-09_JPRB, &
  & 0.16990871E-09_JPRB, 0.16990796E-09_JPRB, 0.16990744E-09_JPRB, 0.16990878E-09_JPRB, 0.16991131E-09_JPRB, 0.16991675E-09_JPRB, &
  & 0.16992058E-09_JPRB, 0.16992596E-09_JPRB, 0.16992877E-09_JPRB, 0.16993229E-09_JPRB, 0.16993169E-09_JPRB, 0.16993250E-09_JPRB, &
  & 0.16993046E-09_JPRB, 0.16992818E-09_JPRB, 0.16992371E-09_JPRB, 0.16992063E-09_JPRB, 0.16991795E-09_JPRB, 0.16991575E-09_JPRB, &
  & 0.16991279E-09_JPRB, 0.16991177E-09_JPRB, 0.16990909E-09_JPRB, 0.16991193E-09_JPRB, 0.16991478E-09_JPRB, 0.16992263E-09_JPRB, &
  & 0.16992725E-09_JPRB, 0.16993487E-09_JPRB, 0.16994547E-09_JPRB, 0.16995552E-09_JPRB, 0.16996302E-09_JPRB, 0.16996785E-09_JPRB, &
  & 0.16997266E-09_JPRB, 0.16997521E-09_JPRB, 0.16997595E-09_JPRB, 0.16997766E-09_JPRB, 0.16997526E-09_JPRB, 0.16997707E-09_JPRB, &
  & 0.16997496E-09_JPRB, 0.16997490E-09_JPRB, 0.16997392E-09_JPRB, 0.16997495E-09_JPRB, 0.16997559E-09_JPRB, 0.16997420E-09_JPRB, &
  & 0.16997365E-09_JPRB, 0.16997002E-09_JPRB, 0.16996637E-09_JPRB, 0.16996382E-09_JPRB /)

RGHG8(:,87, 1) = (/ &
  & 0.16994563E-09_JPRB, 0.16993931E-09_JPRB, 0.16993736E-09_JPRB, 0.16993798E-09_JPRB, 0.16993640E-09_JPRB, 0.16993434E-09_JPRB, &
  & 0.16993545E-09_JPRB, 0.16993534E-09_JPRB, 0.16993526E-09_JPRB, 0.16993498E-09_JPRB, 0.16993432E-09_JPRB, 0.16993389E-09_JPRB, &
  & 0.16993386E-09_JPRB, 0.16993303E-09_JPRB, 0.16992968E-09_JPRB, 0.16992467E-09_JPRB, 0.16992016E-09_JPRB, 0.16991514E-09_JPRB, &
  & 0.16990927E-09_JPRB, 0.16990852E-09_JPRB, 0.16990791E-09_JPRB, 0.16990916E-09_JPRB, 0.16991165E-09_JPRB, 0.16991716E-09_JPRB, &
  & 0.16992099E-09_JPRB, 0.16992645E-09_JPRB, 0.16992915E-09_JPRB, 0.16993280E-09_JPRB, 0.16993208E-09_JPRB, 0.16993289E-09_JPRB, &
  & 0.16993082E-09_JPRB, 0.16992859E-09_JPRB, 0.16992414E-09_JPRB, 0.16992105E-09_JPRB, 0.16991844E-09_JPRB, 0.16991629E-09_JPRB, &
  & 0.16991326E-09_JPRB, 0.16991235E-09_JPRB, 0.16990932E-09_JPRB, 0.16991233E-09_JPRB, 0.16991519E-09_JPRB, 0.16992309E-09_JPRB, &
  & 0.16992778E-09_JPRB, 0.16993501E-09_JPRB, 0.16994590E-09_JPRB, 0.16995576E-09_JPRB, 0.16996325E-09_JPRB, 0.16996804E-09_JPRB, &
  & 0.16997283E-09_JPRB, 0.16997535E-09_JPRB, 0.16997610E-09_JPRB, 0.16997781E-09_JPRB, 0.16997534E-09_JPRB, 0.16997717E-09_JPRB, &
  & 0.16997502E-09_JPRB, 0.16997492E-09_JPRB, 0.16997399E-09_JPRB, 0.16997503E-09_JPRB, 0.16997573E-09_JPRB, 0.16997437E-09_JPRB, &
  & 0.16997381E-09_JPRB, 0.16997015E-09_JPRB, 0.16996647E-09_JPRB, 0.16996393E-09_JPRB /)

RGHG8(:,88, 1) = (/ &
  & 0.16994567E-09_JPRB, 0.16993951E-09_JPRB, 0.16993755E-09_JPRB, 0.16993820E-09_JPRB, 0.16993648E-09_JPRB, 0.16993451E-09_JPRB, &
  & 0.16993568E-09_JPRB, 0.16993554E-09_JPRB, 0.16993541E-09_JPRB, 0.16993515E-09_JPRB, 0.16993451E-09_JPRB, 0.16993409E-09_JPRB, &
  & 0.16993403E-09_JPRB, 0.16993315E-09_JPRB, 0.16992992E-09_JPRB, 0.16992506E-09_JPRB, 0.16992044E-09_JPRB, 0.16991551E-09_JPRB, &
  & 0.16990954E-09_JPRB, 0.16990881E-09_JPRB, 0.16990818E-09_JPRB, 0.16990941E-09_JPRB, 0.16991183E-09_JPRB, 0.16991746E-09_JPRB, &
  & 0.16992116E-09_JPRB, 0.16992673E-09_JPRB, 0.16992939E-09_JPRB, 0.16993312E-09_JPRB, 0.16993230E-09_JPRB, 0.16993316E-09_JPRB, &
  & 0.16993103E-09_JPRB, 0.16992886E-09_JPRB, 0.16992437E-09_JPRB, 0.16992133E-09_JPRB, 0.16991875E-09_JPRB, 0.16991661E-09_JPRB, &
  & 0.16991353E-09_JPRB, 0.16991272E-09_JPRB, 0.16990934E-09_JPRB, 0.16991270E-09_JPRB, 0.16991519E-09_JPRB, 0.16992363E-09_JPRB, &
  & 0.16992792E-09_JPRB, 0.16993533E-09_JPRB, 0.16994607E-09_JPRB, 0.16995594E-09_JPRB, 0.16996340E-09_JPRB, 0.16996814E-09_JPRB, &
  & 0.16997298E-09_JPRB, 0.16997542E-09_JPRB, 0.16997619E-09_JPRB, 0.16997789E-09_JPRB, 0.16997537E-09_JPRB, 0.16997723E-09_JPRB, &
  & 0.16997503E-09_JPRB, 0.16997496E-09_JPRB, 0.16997401E-09_JPRB, 0.16997510E-09_JPRB, 0.16997584E-09_JPRB, 0.16997448E-09_JPRB, &
  & 0.16997395E-09_JPRB, 0.16997023E-09_JPRB, 0.16996657E-09_JPRB, 0.16996400E-09_JPRB /)

RGHG8(:,89, 1) = (/ &
  & 0.16994554E-09_JPRB, 0.16993969E-09_JPRB, 0.16993768E-09_JPRB, 0.16993834E-09_JPRB, 0.16993676E-09_JPRB, 0.16993452E-09_JPRB, &
  & 0.16993576E-09_JPRB, 0.16993565E-09_JPRB, 0.16993557E-09_JPRB, 0.16993532E-09_JPRB, 0.16993462E-09_JPRB, 0.16993423E-09_JPRB, &
  & 0.16993426E-09_JPRB, 0.16993346E-09_JPRB, 0.16993008E-09_JPRB, 0.16992503E-09_JPRB, 0.16992059E-09_JPRB, 0.16991554E-09_JPRB, &
  & 0.16990961E-09_JPRB, 0.16990899E-09_JPRB, 0.16990832E-09_JPRB, 0.16990950E-09_JPRB, 0.16991192E-09_JPRB, 0.16991759E-09_JPRB, &
  & 0.16992127E-09_JPRB, 0.16992695E-09_JPRB, 0.16992949E-09_JPRB, 0.16993333E-09_JPRB, 0.16993244E-09_JPRB, 0.16993336E-09_JPRB, &
  & 0.16993117E-09_JPRB, 0.16992907E-09_JPRB, 0.16992449E-09_JPRB, 0.16992145E-09_JPRB, 0.16991888E-09_JPRB, 0.16991683E-09_JPRB, &
  & 0.16991361E-09_JPRB, 0.16991296E-09_JPRB, 0.16990925E-09_JPRB, 0.16991279E-09_JPRB, 0.16991525E-09_JPRB, 0.16992384E-09_JPRB, &
  & 0.16992804E-09_JPRB, 0.16993536E-09_JPRB, 0.16994620E-09_JPRB, 0.16995602E-09_JPRB, 0.16996352E-09_JPRB, 0.16996822E-09_JPRB, &
  & 0.16997306E-09_JPRB, 0.16997549E-09_JPRB, 0.16997623E-09_JPRB, 0.16997795E-09_JPRB, 0.16997538E-09_JPRB, 0.16997732E-09_JPRB, &
  & 0.16997509E-09_JPRB, 0.16997503E-09_JPRB, 0.16997401E-09_JPRB, 0.16997517E-09_JPRB, 0.16997594E-09_JPRB, 0.16997455E-09_JPRB, &
  & 0.16997406E-09_JPRB, 0.16997029E-09_JPRB, 0.16996653E-09_JPRB, 0.16996399E-09_JPRB /)

RGHG8(:,90, 1) = (/ &
  & 0.16994522E-09_JPRB, 0.16993987E-09_JPRB, 0.16993772E-09_JPRB, 0.16993851E-09_JPRB, 0.16993673E-09_JPRB, 0.16993429E-09_JPRB, &
  & 0.16993602E-09_JPRB, 0.16993579E-09_JPRB, 0.16993573E-09_JPRB, 0.16993550E-09_JPRB, 0.16993464E-09_JPRB, 0.16993421E-09_JPRB, &
  & 0.16993454E-09_JPRB, 0.16993389E-09_JPRB, 0.16993017E-09_JPRB, 0.16992494E-09_JPRB, 0.16992051E-09_JPRB, 0.16991557E-09_JPRB, &
  & 0.16990935E-09_JPRB, 0.16990902E-09_JPRB, 0.16990831E-09_JPRB, 0.16990953E-09_JPRB, 0.16991190E-09_JPRB, 0.16991766E-09_JPRB, &
  & 0.16992129E-09_JPRB, 0.16992711E-09_JPRB, 0.16992950E-09_JPRB, 0.16993353E-09_JPRB, 0.16993244E-09_JPRB, 0.16993357E-09_JPRB, &
  & 0.16993126E-09_JPRB, 0.16992925E-09_JPRB, 0.16992455E-09_JPRB, 0.16992151E-09_JPRB, 0.16991897E-09_JPRB, 0.16991693E-09_JPRB, &
  & 0.16991356E-09_JPRB, 0.16991313E-09_JPRB, 0.16990907E-09_JPRB, 0.16991294E-09_JPRB, 0.16991514E-09_JPRB, 0.16992407E-09_JPRB, &
  & 0.16992800E-09_JPRB, 0.16993536E-09_JPRB, 0.16994625E-09_JPRB, 0.16995613E-09_JPRB, 0.16996364E-09_JPRB, 0.16996828E-09_JPRB, &
  & 0.16997320E-09_JPRB, 0.16997562E-09_JPRB, 0.16997627E-09_JPRB, 0.16997811E-09_JPRB, 0.16997533E-09_JPRB, 0.16997743E-09_JPRB, &
  & 0.16997503E-09_JPRB, 0.16997503E-09_JPRB, 0.16997398E-09_JPRB, 0.16997524E-09_JPRB, 0.16997602E-09_JPRB, 0.16997456E-09_JPRB, &
  & 0.16997416E-09_JPRB, 0.16997026E-09_JPRB, 0.16996647E-09_JPRB, 0.16996396E-09_JPRB /)

RGHG8(:,91, 1) = (/ &
  & 0.16994472E-09_JPRB, 0.16994037E-09_JPRB, 0.16993754E-09_JPRB, 0.16993873E-09_JPRB, 0.16993701E-09_JPRB, 0.16993376E-09_JPRB, &
  & 0.16993638E-09_JPRB, 0.16993579E-09_JPRB, 0.16993597E-09_JPRB, 0.16993623E-09_JPRB, 0.16993422E-09_JPRB, 0.16993364E-09_JPRB, &
  & 0.16993509E-09_JPRB, 0.16993483E-09_JPRB, 0.16993021E-09_JPRB, 0.16992453E-09_JPRB, 0.16992049E-09_JPRB, 0.16991560E-09_JPRB, &
  & 0.16990880E-09_JPRB, 0.16990906E-09_JPRB, 0.16990820E-09_JPRB, 0.16990946E-09_JPRB, 0.16991168E-09_JPRB, 0.16991786E-09_JPRB, &
  & 0.16992116E-09_JPRB, 0.16992732E-09_JPRB, 0.16992946E-09_JPRB, 0.16993393E-09_JPRB, 0.16993230E-09_JPRB, 0.16993383E-09_JPRB, &
  & 0.16993126E-09_JPRB, 0.16992961E-09_JPRB, 0.16992445E-09_JPRB, 0.16992140E-09_JPRB, 0.16991893E-09_JPRB, 0.16991712E-09_JPRB, &
  & 0.16991318E-09_JPRB, 0.16991339E-09_JPRB, 0.16990850E-09_JPRB, 0.16991300E-09_JPRB, 0.16991471E-09_JPRB, 0.16992441E-09_JPRB, &
  & 0.16992781E-09_JPRB, 0.16993512E-09_JPRB, 0.16994638E-09_JPRB, 0.16995633E-09_JPRB, 0.16996388E-09_JPRB, 0.16996828E-09_JPRB, &
  & 0.16997340E-09_JPRB, 0.16997574E-09_JPRB, 0.16997621E-09_JPRB, 0.16997839E-09_JPRB, 0.16997499E-09_JPRB, 0.16997773E-09_JPRB, &
  & 0.16997491E-09_JPRB, 0.16997509E-09_JPRB, 0.16997384E-09_JPRB, 0.16997530E-09_JPRB, 0.16997619E-09_JPRB, 0.16997449E-09_JPRB, &
  & 0.16997435E-09_JPRB, 0.16997011E-09_JPRB, 0.16996628E-09_JPRB, 0.16996388E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART2',1,ZHOOK_HANDLE)
END SUBROUTINE PART2






SUBROUTINE PART3
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART3',0,ZHOOK_HANDLE)



!-- Month=  2 ------------

RGHG8(:, 1, 2) = (/ &
  & 0.35516153E-10_JPRB, 0.35563538E-10_JPRB, 0.35578106E-10_JPRB, 0.35600654E-10_JPRB, 0.35620232E-10_JPRB, 0.35639915E-10_JPRB, &
  & 0.35660683E-10_JPRB, 0.35694815E-10_JPRB, 0.35737548E-10_JPRB, 0.35790999E-10_JPRB, 0.35855145E-10_JPRB, 0.35929440E-10_JPRB, &
  & 0.36021325E-10_JPRB, 0.36132167E-10_JPRB, 0.36258281E-10_JPRB, 0.36399293E-10_JPRB, 0.36556484E-10_JPRB, 0.36725539E-10_JPRB, &
  & 0.36881474E-10_JPRB, 0.37005038E-10_JPRB, 0.37088839E-10_JPRB, 0.37139274E-10_JPRB, 0.37167755E-10_JPRB, 0.37183402E-10_JPRB, &
  & 0.37190525E-10_JPRB, 0.37191698E-10_JPRB, 0.37188086E-10_JPRB, 0.37181331E-10_JPRB, 0.37174343E-10_JPRB, 0.37169261E-10_JPRB, &
  & 0.37167106E-10_JPRB, 0.37168262E-10_JPRB, 0.37169264E-10_JPRB, 0.37173604E-10_JPRB, 0.37183305E-10_JPRB, 0.37199306E-10_JPRB, &
  & 0.37222683E-10_JPRB, 0.37257520E-10_JPRB, 0.37301245E-10_JPRB, 0.37343212E-10_JPRB, 0.37378208E-10_JPRB, 0.37406092E-10_JPRB, &
  & 0.37427544E-10_JPRB, 0.37443347E-10_JPRB, 0.37453630E-10_JPRB, 0.37456815E-10_JPRB, 0.37450897E-10_JPRB, 0.37438261E-10_JPRB, &
  & 0.37421847E-10_JPRB, 0.37406515E-10_JPRB, 0.37397016E-10_JPRB, 0.37396228E-10_JPRB, 0.37404389E-10_JPRB, 0.37419255E-10_JPRB, &
  & 0.37438330E-10_JPRB, 0.37458113E-10_JPRB, 0.37476244E-10_JPRB, 0.37492068E-10_JPRB, 0.37506012E-10_JPRB, 0.37518384E-10_JPRB, &
  & 0.37528942E-10_JPRB, 0.37537164E-10_JPRB, 0.37542310E-10_JPRB, 0.37545547E-10_JPRB /)

RGHG8(:, 2, 2) = (/ &
  & 0.35623400E-10_JPRB, 0.35690697E-10_JPRB, 0.35727039E-10_JPRB, 0.35760110E-10_JPRB, 0.35793743E-10_JPRB, 0.35828708E-10_JPRB, &
  & 0.35871573E-10_JPRB, 0.35931015E-10_JPRB, 0.36009536E-10_JPRB, 0.36111305E-10_JPRB, 0.36238238E-10_JPRB, 0.36394908E-10_JPRB, &
  & 0.36589010E-10_JPRB, 0.36822871E-10_JPRB, 0.37091618E-10_JPRB, 0.37383666E-10_JPRB, 0.37680751E-10_JPRB, 0.37950122E-10_JPRB, &
  & 0.38149872E-10_JPRB, 0.38264818E-10_JPRB, 0.38305671E-10_JPRB, 0.38296168E-10_JPRB, 0.38257786E-10_JPRB, 0.38203590E-10_JPRB, &
  & 0.38140532E-10_JPRB, 0.38069041E-10_JPRB, 0.37990281E-10_JPRB, 0.37912128E-10_JPRB, 0.37843360E-10_JPRB, 0.37786673E-10_JPRB, &
  & 0.37740779E-10_JPRB, 0.37703576E-10_JPRB, 0.37672965E-10_JPRB, 0.37652909E-10_JPRB, 0.37646972E-10_JPRB, 0.37659504E-10_JPRB, &
  & 0.37694101E-10_JPRB, 0.37752815E-10_JPRB, 0.37828130E-10_JPRB, 0.37904097E-10_JPRB, 0.37966047E-10_JPRB, 0.38005314E-10_JPRB, &
  & 0.38018325E-10_JPRB, 0.38005731E-10_JPRB, 0.37970717E-10_JPRB, 0.37917607E-10_JPRB, 0.37854476E-10_JPRB, 0.37793550E-10_JPRB, &
  & 0.37744342E-10_JPRB, 0.37709991E-10_JPRB, 0.37686847E-10_JPRB, 0.37669604E-10_JPRB, 0.37655871E-10_JPRB, 0.37645862E-10_JPRB, &
  & 0.37640467E-10_JPRB, 0.37639163E-10_JPRB, 0.37641081E-10_JPRB, 0.37645338E-10_JPRB, 0.37651344E-10_JPRB, 0.37658640E-10_JPRB, &
  & 0.37665742E-10_JPRB, 0.37671918E-10_JPRB, 0.37677299E-10_JPRB, 0.37682933E-10_JPRB /)

RGHG8(:, 3, 2) = (/ &
  & 0.35637722E-10_JPRB, 0.35741382E-10_JPRB, 0.35813841E-10_JPRB, 0.35883161E-10_JPRB, 0.35955072E-10_JPRB, 0.36033954E-10_JPRB, &
  & 0.36128846E-10_JPRB, 0.36249996E-10_JPRB, 0.36400688E-10_JPRB, 0.36585495E-10_JPRB, 0.36806204E-10_JPRB, 0.37064463E-10_JPRB, &
  & 0.37364851E-10_JPRB, 0.37703181E-10_JPRB, 0.38065197E-10_JPRB, 0.38431890E-10_JPRB, 0.38777450E-10_JPRB, 0.39067555E-10_JPRB, &
  & 0.39270951E-10_JPRB, 0.39380360E-10_JPRB, 0.39410905E-10_JPRB, 0.39388902E-10_JPRB, 0.39337554E-10_JPRB, 0.39271149E-10_JPRB, &
  & 0.39197225E-10_JPRB, 0.39120117E-10_JPRB, 0.39042068E-10_JPRB, 0.38966840E-10_JPRB, 0.38896060E-10_JPRB, 0.38828267E-10_JPRB, &
  & 0.38760977E-10_JPRB, 0.38694943E-10_JPRB, 0.38632660E-10_JPRB, 0.38586613E-10_JPRB, 0.38567580E-10_JPRB, 0.38583862E-10_JPRB, &
  & 0.38641212E-10_JPRB, 0.38737062E-10_JPRB, 0.38857220E-10_JPRB, 0.38975323E-10_JPRB, 0.39063686E-10_JPRB, 0.39101385E-10_JPRB, &
  & 0.39080215E-10_JPRB, 0.39005431E-10_JPRB, 0.38890238E-10_JPRB, 0.38749233E-10_JPRB, 0.38596838E-10_JPRB, 0.38447620E-10_JPRB, &
  & 0.38309841E-10_JPRB, 0.38185802E-10_JPRB, 0.38077728E-10_JPRB, 0.37990656E-10_JPRB, 0.37927501E-10_JPRB, 0.37885778E-10_JPRB, &
  & 0.37861120E-10_JPRB, 0.37849238E-10_JPRB, 0.37846615E-10_JPRB, 0.37849376E-10_JPRB, 0.37855094E-10_JPRB, 0.37862088E-10_JPRB, &
  & 0.37869794E-10_JPRB, 0.37876889E-10_JPRB, 0.37883512E-10_JPRB, 0.37891676E-10_JPRB /)

RGHG8(:, 4, 2) = (/ &
  & 0.35596370E-10_JPRB, 0.35733725E-10_JPRB, 0.35836771E-10_JPRB, 0.35946142E-10_JPRB, 0.36066095E-10_JPRB, 0.36201757E-10_JPRB, &
  & 0.36362170E-10_JPRB, 0.36558083E-10_JPRB, 0.36792590E-10_JPRB, 0.37069962E-10_JPRB, 0.37386570E-10_JPRB, 0.37740193E-10_JPRB, &
  & 0.38126082E-10_JPRB, 0.38531463E-10_JPRB, 0.38946339E-10_JPRB, 0.39353888E-10_JPRB, 0.39731506E-10_JPRB, 0.40056566E-10_JPRB, &
  & 0.40303649E-10_JPRB, 0.40469371E-10_JPRB, 0.40560475E-10_JPRB, 0.40597241E-10_JPRB, 0.40602393E-10_JPRB, 0.40594559E-10_JPRB, &
  & 0.40585972E-10_JPRB, 0.40581108E-10_JPRB, 0.40577281E-10_JPRB, 0.40566064E-10_JPRB, 0.40537736E-10_JPRB, 0.40486531E-10_JPRB, &
  & 0.40412999E-10_JPRB, 0.40323342E-10_JPRB, 0.40231020E-10_JPRB, 0.40160104E-10_JPRB, 0.40134167E-10_JPRB, 0.40169278E-10_JPRB, &
  & 0.40270867E-10_JPRB, 0.40432144E-10_JPRB, 0.40625954E-10_JPRB, 0.40804554E-10_JPRB, 0.40907729E-10_JPRB, 0.40890701E-10_JPRB, &
  & 0.40749834E-10_JPRB, 0.40518960E-10_JPRB, 0.40241692E-10_JPRB, 0.39950293E-10_JPRB, 0.39666430E-10_JPRB, 0.39404386E-10_JPRB, &
  & 0.39167856E-10_JPRB, 0.38955873E-10_JPRB, 0.38769921E-10_JPRB, 0.38611774E-10_JPRB, 0.38479990E-10_JPRB, 0.38373513E-10_JPRB, &
  & 0.38293438E-10_JPRB, 0.38238860E-10_JPRB, 0.38206313E-10_JPRB, 0.38189549E-10_JPRB, 0.38184178E-10_JPRB, 0.38186551E-10_JPRB, &
  & 0.38193140E-10_JPRB, 0.38201678E-10_JPRB, 0.38210296E-10_JPRB, 0.38224434E-10_JPRB /)

RGHG8(:, 5, 2) = (/ &
  & 0.35536147E-10_JPRB, 0.35700051E-10_JPRB, 0.35834859E-10_JPRB, 0.35986610E-10_JPRB, 0.36158052E-10_JPRB, 0.36354399E-10_JPRB, &
  & 0.36588316E-10_JPRB, 0.36867859E-10_JPRB, 0.37199240E-10_JPRB, 0.37584717E-10_JPRB, 0.38009533E-10_JPRB, 0.38462507E-10_JPRB, &
  & 0.38938543E-10_JPRB, 0.39425387E-10_JPRB, 0.39907435E-10_JPRB, 0.40373659E-10_JPRB, 0.40815046E-10_JPRB, 0.41215163E-10_JPRB, &
  & 0.41567028E-10_JPRB, 0.41868908E-10_JPRB, 0.42129935E-10_JPRB, 0.42365403E-10_JPRB, 0.42592607E-10_JPRB, 0.42822735E-10_JPRB, &
  & 0.43060947E-10_JPRB, 0.43297702E-10_JPRB, 0.43518487E-10_JPRB, 0.43698437E-10_JPRB, 0.43818248E-10_JPRB, 0.43859763E-10_JPRB, &
  & 0.43823740E-10_JPRB, 0.43727161E-10_JPRB, 0.43604776E-10_JPRB, 0.43506858E-10_JPRB, 0.43474137E-10_JPRB, 0.43529229E-10_JPRB, &
  & 0.43676514E-10_JPRB, 0.43895297E-10_JPRB, 0.44134314E-10_JPRB, 0.44298232E-10_JPRB, 0.44271573E-10_JPRB, 0.43994374E-10_JPRB, &
  & 0.43515080E-10_JPRB, 0.42944964E-10_JPRB, 0.42370843E-10_JPRB, 0.41836215E-10_JPRB, 0.41356522E-10_JPRB, 0.40931220E-10_JPRB, &
  & 0.40549814E-10_JPRB, 0.40204354E-10_JPRB, 0.39893554E-10_JPRB, 0.39617535E-10_JPRB, 0.39377855E-10_JPRB, 0.39178084E-10_JPRB, &
  & 0.39020075E-10_JPRB, 0.38902492E-10_JPRB, 0.38822209E-10_JPRB, 0.38771882E-10_JPRB, 0.38744247E-10_JPRB, 0.38731962E-10_JPRB, &
  & 0.38728638E-10_JPRB, 0.38730148E-10_JPRB, 0.38734585E-10_JPRB, 0.38742985E-10_JPRB /)

RGHG8(:, 6, 2) = (/ &
  & 0.35476753E-10_JPRB, 0.35666345E-10_JPRB, 0.35844307E-10_JPRB, 0.36053164E-10_JPRB, 0.36294724E-10_JPRB, 0.36571184E-10_JPRB, &
  & 0.36898189E-10_JPRB, 0.37285154E-10_JPRB, 0.37739617E-10_JPRB, 0.38263392E-10_JPRB, 0.38841222E-10_JPRB, 0.39442859E-10_JPRB, &
  & 0.40055778E-10_JPRB, 0.40667403E-10_JPRB, 0.41266011E-10_JPRB, 0.41842189E-10_JPRB, 0.42390404E-10_JPRB, 0.42911317E-10_JPRB, &
  & 0.43404717E-10_JPRB, 0.43887879E-10_JPRB, 0.44374344E-10_JPRB, 0.44884159E-10_JPRB, 0.45430121E-10_JPRB, 0.46013939E-10_JPRB, &
  & 0.46620204E-10_JPRB, 0.47226958E-10_JPRB, 0.47810499E-10_JPRB, 0.48354862E-10_JPRB, 0.48823282E-10_JPRB, 0.49198083E-10_JPRB, &
  & 0.49458358E-10_JPRB, 0.49615857E-10_JPRB, 0.49700910E-10_JPRB, 0.49763912E-10_JPRB, 0.49844719E-10_JPRB, 0.49963485E-10_JPRB, &
  & 0.50113583E-10_JPRB, 0.50253759E-10_JPRB, 0.50293960E-10_JPRB, 0.50096000E-10_JPRB, 0.49534925E-10_JPRB, 0.48620458E-10_JPRB, &
  & 0.47531402E-10_JPRB, 0.46452096E-10_JPRB, 0.45478572E-10_JPRB, 0.44630383E-10_JPRB, 0.43895790E-10_JPRB, 0.43249869E-10_JPRB, &
  & 0.42667821E-10_JPRB, 0.42135691E-10_JPRB, 0.41648070E-10_JPRB, 0.41204602E-10_JPRB, 0.40810452E-10_JPRB, 0.40472146E-10_JPRB, &
  & 0.40194473E-10_JPRB, 0.39979197E-10_JPRB, 0.39823117E-10_JPRB, 0.39717535E-10_JPRB, 0.39651726E-10_JPRB, 0.39613909E-10_JPRB, &
  & 0.39593696E-10_JPRB, 0.39582792E-10_JPRB, 0.39576641E-10_JPRB, 0.39571603E-10_JPRB /)

RGHG8(:, 7, 2) = (/ &
  & 0.35442069E-10_JPRB, 0.35691637E-10_JPRB, 0.35933641E-10_JPRB, 0.36232847E-10_JPRB, 0.36580190E-10_JPRB, 0.36980453E-10_JPRB, &
  & 0.37446036E-10_JPRB, 0.37991717E-10_JPRB, 0.38628774E-10_JPRB, 0.39360536E-10_JPRB, 0.40155736E-10_JPRB, 0.40985576E-10_JPRB, &
  & 0.41829359E-10_JPRB, 0.42660927E-10_JPRB, 0.43458868E-10_JPRB, 0.44216377E-10_JPRB, 0.44937436E-10_JPRB, 0.45628012E-10_JPRB, &
  & 0.46303985E-10_JPRB, 0.46986044E-10_JPRB, 0.47701933E-10_JPRB, 0.48476216E-10_JPRB, 0.49325273E-10_JPRB, 0.50247140E-10_JPRB, &
  & 0.51216857E-10_JPRB, 0.52208748E-10_JPRB, 0.53204507E-10_JPRB, 0.54182880E-10_JPRB, 0.55133745E-10_JPRB, 0.56014061E-10_JPRB, &
  & 0.56799097E-10_JPRB, 0.57455988E-10_JPRB, 0.57969969E-10_JPRB, 0.58342962E-10_JPRB, 0.58582077E-10_JPRB, 0.58684800E-10_JPRB, &
  & 0.58634320E-10_JPRB, 0.58383201E-10_JPRB, 0.57841312E-10_JPRB, 0.56892067E-10_JPRB, 0.55478698E-10_JPRB, 0.53745411E-10_JPRB, &
  & 0.51980507E-10_JPRB, 0.50399279E-10_JPRB, 0.49059333E-10_JPRB, 0.47938285E-10_JPRB, 0.46985485E-10_JPRB, 0.46146507E-10_JPRB, &
  & 0.45381067E-10_JPRB, 0.44666999E-10_JPRB, 0.43993788E-10_JPRB, 0.43363306E-10_JPRB, 0.42787454E-10_JPRB, 0.42281324E-10_JPRB, &
  & 0.41857330E-10_JPRB, 0.41520357E-10_JPRB, 0.41267371E-10_JPRB, 0.41089739E-10_JPRB, 0.40973475E-10_JPRB, 0.40901494E-10_JPRB, &
  & 0.40857356E-10_JPRB, 0.40828934E-10_JPRB, 0.40808371E-10_JPRB, 0.40790860E-10_JPRB /)

RGHG8(:, 8, 2) = (/ &
  & 0.35498295E-10_JPRB, 0.35856929E-10_JPRB, 0.36212311E-10_JPRB, 0.36647484E-10_JPRB, 0.37163481E-10_JPRB, 0.37754407E-10_JPRB, &
  & 0.38437635E-10_JPRB, 0.39227118E-10_JPRB, 0.40140724E-10_JPRB, 0.41168333E-10_JPRB, 0.42284426E-10_JPRB, 0.43451173E-10_JPRB, &
  & 0.44637013E-10_JPRB, 0.45805415E-10_JPRB, 0.46928749E-10_JPRB, 0.47988453E-10_JPRB, 0.48985416E-10_JPRB, 0.49931125E-10_JPRB, &
  & 0.50844891E-10_JPRB, 0.51758618E-10_JPRB, 0.52699595E-10_JPRB, 0.53697470E-10_JPRB, 0.54773484E-10_JPRB, 0.55923880E-10_JPRB, &
  & 0.57137253E-10_JPRB, 0.58383423E-10_JPRB, 0.59658264E-10_JPRB, 0.60958488E-10_JPRB, 0.62258802E-10_JPRB, 0.63526566E-10_JPRB, &
  & 0.64692161E-10_JPRB, 0.65679823E-10_JPRB, 0.66411675E-10_JPRB, 0.66841636E-10_JPRB, 0.66948114E-10_JPRB, 0.66729913E-10_JPRB, &
  & 0.66194127E-10_JPRB, 0.65323136E-10_JPRB, 0.64065780E-10_JPRB, 0.62357036E-10_JPRB, 0.60199040E-10_JPRB, 0.57813556E-10_JPRB, &
  & 0.55552542E-10_JPRB, 0.53632123E-10_JPRB, 0.52081693E-10_JPRB, 0.50832644E-10_JPRB, 0.49788493E-10_JPRB, 0.48869700E-10_JPRB, &
  & 0.48025334E-10_JPRB, 0.47222823E-10_JPRB, 0.46443863E-10_JPRB, 0.45690667E-10_JPRB, 0.44980703E-10_JPRB, 0.44337700E-10_JPRB, &
  & 0.43782339E-10_JPRB, 0.43327397E-10_JPRB, 0.42975446E-10_JPRB, 0.42720303E-10_JPRB, 0.42546657E-10_JPRB, 0.42433501E-10_JPRB, &
  & 0.42357090E-10_JPRB, 0.42299213E-10_JPRB, 0.42245228E-10_JPRB, 0.42158870E-10_JPRB /)

RGHG8(:, 9, 2) = (/ &
  & 0.36032177E-10_JPRB, 0.36610711E-10_JPRB, 0.37132738E-10_JPRB, 0.37762748E-10_JPRB, 0.38498808E-10_JPRB, 0.39349479E-10_JPRB, &
  & 0.40313770E-10_JPRB, 0.41416818E-10_JPRB, 0.42668757E-10_JPRB, 0.44066688E-10_JPRB, 0.45589546E-10_JPRB, 0.47196282E-10_JPRB, &
  & 0.48841799E-10_JPRB, 0.50471970E-10_JPRB, 0.52048331E-10_JPRB, 0.53550595E-10_JPRB, 0.54965692E-10_JPRB, 0.56297213E-10_JPRB, &
  & 0.57558205E-10_JPRB, 0.58776123E-10_JPRB, 0.59980923E-10_JPRB, 0.61190462E-10_JPRB, 0.62417162E-10_JPRB, 0.63667925E-10_JPRB, &
  & 0.64926342E-10_JPRB, 0.66195868E-10_JPRB, 0.67487738E-10_JPRB, 0.68811373E-10_JPRB, 0.70152543E-10_JPRB, 0.71447077E-10_JPRB, &
  & 0.72593598E-10_JPRB, 0.73466497E-10_JPRB, 0.73947411E-10_JPRB, 0.73965757E-10_JPRB, 0.73509490E-10_JPRB, 0.72629042E-10_JPRB, &
  & 0.71386307E-10_JPRB, 0.69824591E-10_JPRB, 0.67941160E-10_JPRB, 0.65685415E-10_JPRB, 0.63072630E-10_JPRB, 0.60307134E-10_JPRB, &
  & 0.57761584E-10_JPRB, 0.55680464E-10_JPRB, 0.54070130E-10_JPRB, 0.52805253E-10_JPRB, 0.51762008E-10_JPRB, 0.50855327E-10_JPRB, &
  & 0.50027597E-10_JPRB, 0.49232181E-10_JPRB, 0.48445373E-10_JPRB, 0.47666909E-10_JPRB, 0.46911239E-10_JPRB, 0.46204152E-10_JPRB, &
  & 0.45574634E-10_JPRB, 0.45043708E-10_JPRB, 0.44624256E-10_JPRB, 0.44315808E-10_JPRB, 0.44106850E-10_JPRB, 0.43967364E-10_JPRB, &
  & 0.43873759E-10_JPRB, 0.43802281E-10_JPRB, 0.43737583E-10_JPRB, 0.43649230E-10_JPRB /)

RGHG8(:,10, 2) = (/ &
  & 0.37677552E-10_JPRB, 0.38714351E-10_JPRB, 0.39532658E-10_JPRB, 0.40372605E-10_JPRB, 0.41359326E-10_JPRB, 0.42467165E-10_JPRB, &
  & 0.43724455E-10_JPRB, 0.45139951E-10_JPRB, 0.46731161E-10_JPRB, 0.48499295E-10_JPRB, 0.50422042E-10_JPRB, 0.52458111E-10_JPRB, &
  & 0.54564991E-10_JPRB, 0.56697355E-10_JPRB, 0.58806099E-10_JPRB, 0.60845641E-10_JPRB, 0.62794284E-10_JPRB, 0.64629815E-10_JPRB, &
  & 0.66350279E-10_JPRB, 0.67959714E-10_JPRB, 0.69469083E-10_JPRB, 0.70892403E-10_JPRB, 0.72225559E-10_JPRB, 0.73465144E-10_JPRB, &
  & 0.74622780E-10_JPRB, 0.75708780E-10_JPRB, 0.76763998E-10_JPRB, 0.77807580E-10_JPRB, 0.78822969E-10_JPRB, 0.79736474E-10_JPRB, &
  & 0.80419740E-10_JPRB, 0.80715684E-10_JPRB, 0.80483821E-10_JPRB, 0.79659473E-10_JPRB, 0.78281340E-10_JPRB, 0.76479732E-10_JPRB, &
  & 0.74424959E-10_JPRB, 0.72207303E-10_JPRB, 0.69825368E-10_JPRB, 0.67236883E-10_JPRB, 0.64404114E-10_JPRB, 0.61485955E-10_JPRB, &
  & 0.58831225E-10_JPRB, 0.56679453E-10_JPRB, 0.55027788E-10_JPRB, 0.53766241E-10_JPRB, 0.52770843E-10_JPRB, 0.51940972E-10_JPRB, &
  & 0.51190309E-10_JPRB, 0.50466187E-10_JPRB, 0.49744722E-10_JPRB, 0.49016735E-10_JPRB, 0.48290941E-10_JPRB, 0.47592600E-10_JPRB, &
  & 0.46951196E-10_JPRB, 0.46400116E-10_JPRB, 0.45959844E-10_JPRB, 0.45641241E-10_JPRB, 0.45422738E-10_JPRB, 0.45283090E-10_JPRB, &
  & 0.45184630E-10_JPRB, 0.45108948E-10_JPRB, 0.45038348E-10_JPRB, 0.44934705E-10_JPRB /)

RGHG8(:,11, 2) = (/ &
  & 0.42108414E-10_JPRB, 0.43907062E-10_JPRB, 0.44953489E-10_JPRB, 0.45932851E-10_JPRB, 0.46982883E-10_JPRB, 0.48167938E-10_JPRB, &
  & 0.49508068E-10_JPRB, 0.51036172E-10_JPRB, 0.52768342E-10_JPRB, 0.54718403E-10_JPRB, 0.56880074E-10_JPRB, 0.59219497E-10_JPRB, &
  & 0.61694538E-10_JPRB, 0.64252319E-10_JPRB, 0.66844440E-10_JPRB, 0.69416431E-10_JPRB, 0.71905149E-10_JPRB, 0.74271700E-10_JPRB, &
  & 0.76474639E-10_JPRB, 0.78501081E-10_JPRB, 0.80332511E-10_JPRB, 0.81956039E-10_JPRB, 0.83375147E-10_JPRB, 0.84576693E-10_JPRB, &
  & 0.85584345E-10_JPRB, 0.86412502E-10_JPRB, 0.87102353E-10_JPRB, 0.87669892E-10_JPRB, 0.88094768E-10_JPRB, 0.88303614E-10_JPRB, &
  & 0.88171311E-10_JPRB, 0.87548996E-10_JPRB, 0.86304255E-10_JPRB, 0.84392181E-10_JPRB, 0.81903949E-10_JPRB, 0.79084760E-10_JPRB, &
  & 0.76190894E-10_JPRB, 0.73387976E-10_JPRB, 0.70660630E-10_JPRB, 0.67901594E-10_JPRB, 0.65048057E-10_JPRB, 0.62162844E-10_JPRB, &
  & 0.59446142E-10_JPRB, 0.57188199E-10_JPRB, 0.55494127E-10_JPRB, 0.54249757E-10_JPRB, 0.53295760E-10_JPRB, 0.52501989E-10_JPRB, &
  & 0.51793129E-10_JPRB, 0.51125035E-10_JPRB, 0.50464747E-10_JPRB, 0.49797048E-10_JPRB, 0.49125922E-10_JPRB, 0.48467994E-10_JPRB, &
  & 0.47856250E-10_JPRB, 0.47324641E-10_JPRB, 0.46905924E-10_JPRB, 0.46602087E-10_JPRB, 0.46406826E-10_JPRB, 0.46275175E-10_JPRB, &
  & 0.46187928E-10_JPRB, 0.46118317E-10_JPRB, 0.46052693E-10_JPRB, 0.45956839E-10_JPRB /)

RGHG8(:,12, 2) = (/ &
  & 0.51173437E-10_JPRB, 0.52893655E-10_JPRB, 0.53685119E-10_JPRB, 0.54445046E-10_JPRB, 0.55261368E-10_JPRB, 0.56240006E-10_JPRB, &
  & 0.57420516E-10_JPRB, 0.58828532E-10_JPRB, 0.60492021E-10_JPRB, 0.62427959E-10_JPRB, 0.64640682E-10_JPRB, 0.67110151E-10_JPRB, &
  & 0.69799576E-10_JPRB, 0.72652169E-10_JPRB, 0.75600373E-10_JPRB, 0.78570012E-10_JPRB, 0.81490141E-10_JPRB, 0.84275670E-10_JPRB, &
  & 0.86871559E-10_JPRB, 0.89229679E-10_JPRB, 0.91314005E-10_JPRB, 0.93102144E-10_JPRB, 0.94590523E-10_JPRB, 0.95768421E-10_JPRB, &
  & 0.96648065E-10_JPRB, 0.97235130E-10_JPRB, 0.97543786E-10_JPRB, 0.97575260E-10_JPRB, 0.97301014E-10_JPRB, 0.96662754E-10_JPRB, &
  & 0.95564230E-10_JPRB, 0.93899631E-10_JPRB, 0.91583699E-10_JPRB, 0.88622693E-10_JPRB, 0.85175041E-10_JPRB, 0.81540830E-10_JPRB, &
  & 0.78050823E-10_JPRB, 0.74851736E-10_JPRB, 0.71924557E-10_JPRB, 0.69149811E-10_JPRB, 0.66380269E-10_JPRB, 0.63588509E-10_JPRB, &
  & 0.60945977E-10_JPRB, 0.58668043E-10_JPRB, 0.56866685E-10_JPRB, 0.55488711E-10_JPRB, 0.54406871E-10_JPRB, 0.53514124E-10_JPRB, &
  & 0.52727357E-10_JPRB, 0.51988660E-10_JPRB, 0.51268115E-10_JPRB, 0.50556184E-10_JPRB, 0.49852903E-10_JPRB, 0.49174487E-10_JPRB, &
  & 0.48549498E-10_JPRB, 0.48016511E-10_JPRB, 0.47598835E-10_JPRB, 0.47309819E-10_JPRB, 0.47115617E-10_JPRB, 0.46996729E-10_JPRB, &
  & 0.46912654E-10_JPRB, 0.46849497E-10_JPRB, 0.46790974E-10_JPRB, 0.46709182E-10_JPRB /)

RGHG8(:,13, 2) = (/ &
  & 0.62445896E-10_JPRB, 0.63400833E-10_JPRB, 0.63808070E-10_JPRB, 0.64270270E-10_JPRB, 0.64854261E-10_JPRB, 0.65619808E-10_JPRB, &
  & 0.66605853E-10_JPRB, 0.67846471E-10_JPRB, 0.69365021E-10_JPRB, 0.71189152E-10_JPRB, 0.73330543E-10_JPRB, 0.75775698E-10_JPRB, &
  & 0.78494565E-10_JPRB, 0.81435789E-10_JPRB, 0.84528912E-10_JPRB, 0.87689550E-10_JPRB, 0.90826457E-10_JPRB, 0.93839519E-10_JPRB, &
  & 0.96635061E-10_JPRB, 0.99169103E-10_JPRB, 0.10137400E-09_JPRB, 0.10323458E-09_JPRB, 0.10472652E-09_JPRB, 0.10584850E-09_JPRB, &
  & 0.10659617E-09_JPRB, 0.10695515E-09_JPRB, 0.10691451E-09_JPRB, 0.10644922E-09_JPRB, 0.10553044E-09_JPRB, 0.10411171E-09_JPRB, &
  & 0.10214155E-09_JPRB, 0.99572073E-10_JPRB, 0.96392019E-10_JPRB, 0.92668873E-10_JPRB, 0.88608870E-10_JPRB, 0.84578275E-10_JPRB, &
  & 0.80920444E-10_JPRB, 0.77752263E-10_JPRB, 0.74993046E-10_JPRB, 0.72499826E-10_JPRB, 0.70133857E-10_JPRB, 0.67802160E-10_JPRB, &
  & 0.65497871E-10_JPRB, 0.63316061E-10_JPRB, 0.61370908E-10_JPRB, 0.59697206E-10_JPRB, 0.58253333E-10_JPRB, 0.56968364E-10_JPRB, &
  & 0.55783711E-10_JPRB, 0.54660824E-10_JPRB, 0.53579724E-10_JPRB, 0.52533474E-10_JPRB, 0.51532029E-10_JPRB, 0.50600416E-10_JPRB, &
  & 0.49773002E-10_JPRB, 0.49083175E-10_JPRB, 0.48556097E-10_JPRB, 0.48182437E-10_JPRB, 0.47946702E-10_JPRB, 0.47790091E-10_JPRB, &
  & 0.47687895E-10_JPRB, 0.47607016E-10_JPRB, 0.47532513E-10_JPRB, 0.47424717E-10_JPRB /)

RGHG8(:,14, 2) = (/ &
  & 0.72924944E-10_JPRB, 0.73394478E-10_JPRB, 0.73669702E-10_JPRB, 0.74018160E-10_JPRB, 0.74517059E-10_JPRB, 0.75203732E-10_JPRB, &
  & 0.76106420E-10_JPRB, 0.77249464E-10_JPRB, 0.78658711E-10_JPRB, 0.80364555E-10_JPRB, 0.82385473E-10_JPRB, 0.84718087E-10_JPRB, &
  & 0.87338831E-10_JPRB, 0.90200618E-10_JPRB, 0.93239721E-10_JPRB, 0.96372646E-10_JPRB, 0.99512544E-10_JPRB, 0.10253699E-09_JPRB, &
  & 0.10535216E-09_JPRB, 0.10788231E-09_JPRB, 0.11006360E-09_JPRB, 0.11187289E-09_JPRB, 0.11328374E-09_JPRB, 0.11428761E-09_JPRB, &
  & 0.11486533E-09_JPRB, 0.11498889E-09_JPRB, 0.11462883E-09_JPRB, 0.11375012E-09_JPRB, 0.11232200E-09_JPRB, 0.11032299E-09_JPRB, &
  & 0.10774753E-09_JPRB, 0.10462298E-09_JPRB, 0.10102575E-09_JPRB, 0.97112859E-10_JPRB, 0.93120803E-10_JPRB, 0.89376916E-10_JPRB, &
  & 0.86159593E-10_JPRB, 0.83548411E-10_JPRB, 0.81444775E-10_JPRB, 0.79660153E-10_JPRB, 0.78010140E-10_JPRB, 0.76365053E-10_JPRB, &
  & 0.74636616E-10_JPRB, 0.72767493E-10_JPRB, 0.70801642E-10_JPRB, 0.68821705E-10_JPRB, 0.66872757E-10_JPRB, 0.64957928E-10_JPRB, &
  & 0.63070993E-10_JPRB, 0.61202939E-10_JPRB, 0.59358220E-10_JPRB, 0.57560144E-10_JPRB, 0.55846119E-10_JPRB, 0.54263569E-10_JPRB, &
  & 0.52868872E-10_JPRB, 0.51708169E-10_JPRB, 0.50804028E-10_JPRB, 0.50155522E-10_JPRB, 0.49715409E-10_JPRB, 0.49434012E-10_JPRB, &
  & 0.49232503E-10_JPRB, 0.49077180E-10_JPRB, 0.48924104E-10_JPRB, 0.48697851E-10_JPRB /)

RGHG8(:,15, 2) = (/ &
  & 0.81903366E-10_JPRB, 0.82320983E-10_JPRB, 0.82629126E-10_JPRB, 0.83046500E-10_JPRB, 0.83619348E-10_JPRB, 0.84370136E-10_JPRB, &
  & 0.85316608E-10_JPRB, 0.86468388E-10_JPRB, 0.87848555E-10_JPRB, 0.89482893E-10_JPRB, 0.91394045E-10_JPRB, 0.93582017E-10_JPRB, &
  & 0.96031155E-10_JPRB, 0.98706446E-10_JPRB, 0.10155526E-09_JPRB, 0.10450596E-09_JPRB, 0.10747291E-09_JPRB, 0.11034327E-09_JPRB, &
  & 0.11302309E-09_JPRB, 0.11541650E-09_JPRB, 0.11746766E-09_JPRB, 0.11913057E-09_JPRB, 0.12038472E-09_JPRB, 0.12121035E-09_JPRB, &
  & 0.12157848E-09_JPRB, 0.12145339E-09_JPRB, 0.12079729E-09_JPRB, 0.11957463E-09_JPRB, 0.11777672E-09_JPRB, 0.11541398E-09_JPRB, &
  & 0.11253344E-09_JPRB, 0.10923045E-09_JPRB, 0.10565698E-09_JPRB, 0.10200297E-09_JPRB, 0.98554873E-10_JPRB, 0.95637019E-10_JPRB, &
  & 0.93399580E-10_JPRB, 0.91814709E-10_JPRB, 0.90695194E-10_JPRB, 0.89820332E-10_JPRB, 0.88983765E-10_JPRB, 0.88071897E-10_JPRB, &
  & 0.86927639E-10_JPRB, 0.85443187E-10_JPRB, 0.83625246E-10_JPRB, 0.81552848E-10_JPRB, 0.79304154E-10_JPRB, 0.76927797E-10_JPRB, &
  & 0.74439899E-10_JPRB, 0.71858873E-10_JPRB, 0.69213017E-10_JPRB, 0.66548322E-10_JPRB, 0.63930458E-10_JPRB, 0.61453537E-10_JPRB, &
  & 0.59209852E-10_JPRB, 0.57282165E-10_JPRB, 0.55710162E-10_JPRB, 0.54514795E-10_JPRB, 0.53663948E-10_JPRB, 0.53068216E-10_JPRB, &
  & 0.52647151E-10_JPRB, 0.52291803E-10_JPRB, 0.51948917E-10_JPRB, 0.51401244E-10_JPRB /)

RGHG8(:,16, 2) = (/ &
  & 0.89537981E-10_JPRB, 0.90170739E-10_JPRB, 0.90650411E-10_JPRB, 0.91233042E-10_JPRB, 0.91965990E-10_JPRB, 0.92867755E-10_JPRB, &
  & 0.93935686E-10_JPRB, 0.95179885E-10_JPRB, 0.96605966E-10_JPRB, 0.98237356E-10_JPRB, 0.10008588E-09_JPRB, 0.10214989E-09_JPRB, &
  & 0.10441717E-09_JPRB, 0.10686745E-09_JPRB, 0.10946607E-09_JPRB, 0.11215544E-09_JPRB, 0.11485482E-09_JPRB, 0.11747595E-09_JPRB, &
  & 0.11991906E-09_JPRB, 0.12209413E-09_JPRB, 0.12393274E-09_JPRB, 0.12538555E-09_JPRB, 0.12642631E-09_JPRB, 0.12702854E-09_JPRB, &
  & 0.12715992E-09_JPRB, 0.12678235E-09_JPRB, 0.12586043E-09_JPRB, 0.12438503E-09_JPRB, 0.12236240E-09_JPRB, 0.11984407E-09_JPRB, &
  & 0.11694283E-09_JPRB, 0.11379900E-09_JPRB, 0.11060376E-09_JPRB, 0.10761009E-09_JPRB, 0.10509037E-09_JPRB, 0.10320259E-09_JPRB, &
  & 0.10204250E-09_JPRB, 0.10148375E-09_JPRB, 0.10127151E-09_JPRB, 0.10116394E-09_JPRB, 0.10099380E-09_JPRB, 0.10058530E-09_JPRB, &
  & 0.99806996E-10_JPRB, 0.98591572E-10_JPRB, 0.96953376E-10_JPRB, 0.94959512E-10_JPRB, 0.92678976E-10_JPRB, 0.90156313E-10_JPRB, &
  & 0.87417580E-10_JPRB, 0.84482761E-10_JPRB, 0.81384961E-10_JPRB, 0.78179990E-10_JPRB, 0.74945883E-10_JPRB, 0.71785834E-10_JPRB, &
  & 0.68826854E-10_JPRB, 0.66178445E-10_JPRB, 0.63915574E-10_JPRB, 0.62070175E-10_JPRB, 0.60661351E-10_JPRB, 0.59629426E-10_JPRB, &
  & 0.58825222E-10_JPRB, 0.58167800E-10_JPRB, 0.57467416E-10_JPRB, 0.56389716E-10_JPRB /)

RGHG8(:,17, 2) = (/ &
  & 0.96303007E-10_JPRB, 0.97225582E-10_JPRB, 0.97899966E-10_JPRB, 0.98667116E-10_JPRB, 0.99589330E-10_JPRB, 0.10067604E-09_JPRB, &
  & 0.10192090E-09_JPRB, 0.10330745E-09_JPRB, 0.10483540E-09_JPRB, 0.10651162E-09_JPRB, 0.10834592E-09_JPRB, 0.11033158E-09_JPRB, &
  & 0.11244623E-09_JPRB, 0.11467798E-09_JPRB, 0.11701869E-09_JPRB, 0.11941842E-09_JPRB, 0.12181424E-09_JPRB, 0.12413792E-09_JPRB, &
  & 0.12628817E-09_JPRB, 0.12818223E-09_JPRB, 0.12975063E-09_JPRB, 0.13094242E-09_JPRB, 0.13172601E-09_JPRB, 0.13207602E-09_JPRB, &
  & 0.13195998E-09_JPRB, 0.13134976E-09_JPRB, 0.13023303E-09_JPRB, 0.12861451E-09_JPRB, 0.12656093E-09_JPRB, 0.12416135E-09_JPRB, &
  & 0.12150282E-09_JPRB, 0.11879860E-09_JPRB, 0.11624908E-09_JPRB, 0.11407924E-09_JPRB, 0.11246646E-09_JPRB, 0.11156114E-09_JPRB, &
  & 0.11132414E-09_JPRB, 0.11154584E-09_JPRB, 0.11195191E-09_JPRB, 0.11230600E-09_JPRB, 0.11245402E-09_JPRB, 0.11227312E-09_JPRB, &
  & 0.11166690E-09_JPRB, 0.11059076E-09_JPRB, 0.10907585E-09_JPRB, 0.10719427E-09_JPRB, 0.10500262E-09_JPRB, 0.10253023E-09_JPRB, &
  & 0.99795096E-10_JPRB, 0.96813738E-10_JPRB, 0.93623102E-10_JPRB, 0.90274704E-10_JPRB, 0.86840188E-10_JPRB, 0.83427487E-10_JPRB, &
  & 0.80157839E-10_JPRB, 0.77150848E-10_JPRB, 0.74477390E-10_JPRB, 0.72192849E-10_JPRB, 0.70327549E-10_JPRB, 0.68843882E-10_JPRB, &
  & 0.67682748E-10_JPRB, 0.66625899E-10_JPRB, 0.65557004E-10_JPRB, 0.63762245E-10_JPRB /)

RGHG8(:,18, 2) = (/ &
  & 0.10205811E-09_JPRB, 0.10341419E-09_JPRB, 0.10431754E-09_JPRB, 0.10528138E-09_JPRB, 0.10639271E-09_JPRB, 0.10766846E-09_JPRB, &
  & 0.10908817E-09_JPRB, 0.11063486E-09_JPRB, 0.11228972E-09_JPRB, 0.11404690E-09_JPRB, 0.11590268E-09_JPRB, 0.11785611E-09_JPRB, &
  & 0.11987200E-09_JPRB, 0.12192838E-09_JPRB, 0.12404458E-09_JPRB, 0.12617926E-09_JPRB, 0.12828102E-09_JPRB, 0.13029347E-09_JPRB, &
  & 0.13213125E-09_JPRB, 0.13371916E-09_JPRB, 0.13498905E-09_JPRB, 0.13589695E-09_JPRB, 0.13640894E-09_JPRB, 0.13650306E-09_JPRB, &
  & 0.13616164E-09_JPRB, 0.13538254E-09_JPRB, 0.13418050E-09_JPRB, 0.13261323E-09_JPRB, 0.13072661E-09_JPRB, 0.12862580E-09_JPRB, &
  & 0.12649930E-09_JPRB, 0.12446502E-09_JPRB, 0.12269524E-09_JPRB, 0.12135716E-09_JPRB, 0.12058375E-09_JPRB, 0.12041163E-09_JPRB, &
  & 0.12075461E-09_JPRB, 0.12139026E-09_JPRB, 0.12205721E-09_JPRB, 0.12256290E-09_JPRB, 0.12277221E-09_JPRB, 0.12258305E-09_JPRB, &
  & 0.12195195E-09_JPRB, 0.12088268E-09_JPRB, 0.11942081E-09_JPRB, 0.11762256E-09_JPRB, 0.11553211E-09_JPRB, 0.11317049E-09_JPRB, &
  & 0.11054348E-09_JPRB, 0.10767200E-09_JPRB, 0.10459061E-09_JPRB, 0.10135134E-09_JPRB, 0.98021327E-10_JPRB, 0.94691789E-10_JPRB, &
  & 0.91476306E-10_JPRB, 0.88473985E-10_JPRB, 0.85745841E-10_JPRB, 0.83322516E-10_JPRB, 0.81236406E-10_JPRB, 0.79508913E-10_JPRB, &
  & 0.78023879E-10_JPRB, 0.76698710E-10_JPRB, 0.75245643E-10_JPRB, 0.72840504E-10_JPRB /)

RGHG8(:,19, 2) = (/ &
  & 0.10722439E-09_JPRB, 0.10886730E-09_JPRB, 0.10997578E-09_JPRB, 0.11110567E-09_JPRB, 0.11237266E-09_JPRB, 0.11379793E-09_JPRB, &
  & 0.11536507E-09_JPRB, 0.11704232E-09_JPRB, 0.11880796E-09_JPRB, 0.12064516E-09_JPRB, 0.12253548E-09_JPRB, 0.12447224E-09_JPRB, &
  & 0.12642731E-09_JPRB, 0.12836140E-09_JPRB, 0.13029618E-09_JPRB, 0.13221077E-09_JPRB, 0.13405553E-09_JPRB, 0.13578205E-09_JPRB, &
  & 0.13732419E-09_JPRB, 0.13861895E-09_JPRB, 0.13960760E-09_JPRB, 0.14024748E-09_JPRB, 0.14051214E-09_JPRB, 0.14038974E-09_JPRB, &
  & 0.13988395E-09_JPRB, 0.13902172E-09_JPRB, 0.13785255E-09_JPRB, 0.13643817E-09_JPRB, 0.13490453E-09_JPRB, 0.13337044E-09_JPRB, &
  & 0.13193022E-09_JPRB, 0.13067482E-09_JPRB, 0.12972126E-09_JPRB, 0.12916505E-09_JPRB, 0.12904121E-09_JPRB, 0.12933067E-09_JPRB, &
  & 0.12993243E-09_JPRB, 0.13064073E-09_JPRB, 0.13125490E-09_JPRB, 0.13162502E-09_JPRB, 0.13166315E-09_JPRB, 0.13132259E-09_JPRB, &
  & 0.13058835E-09_JPRB, 0.12946991E-09_JPRB, 0.12800652E-09_JPRB, 0.12624837E-09_JPRB, 0.12423408E-09_JPRB, 0.12197821E-09_JPRB, &
  & 0.11948165E-09_JPRB, 0.11677048E-09_JPRB, 0.11388664E-09_JPRB, 0.11087761E-09_JPRB, 0.10780361E-09_JPRB, 0.10474471E-09_JPRB, &
  & 0.10179370E-09_JPRB, 0.99028105E-10_JPRB, 0.96481573E-10_JPRB, 0.94169117E-10_JPRB, 0.92108619E-10_JPRB, 0.90292405E-10_JPRB, &
  & 0.88691533E-10_JPRB, 0.87167280E-10_JPRB, 0.85458730E-10_JPRB, 0.82632519E-10_JPRB /)

RGHG8(:,20, 2) = (/ &
  & 0.11202991E-09_JPRB, 0.11369182E-09_JPRB, 0.11488890E-09_JPRB, 0.11612993E-09_JPRB, 0.11750539E-09_JPRB, 0.11903847E-09_JPRB, &
  & 0.12070443E-09_JPRB, 0.12247466E-09_JPRB, 0.12431543E-09_JPRB, 0.12620294E-09_JPRB, 0.12811528E-09_JPRB, 0.13003079E-09_JPRB, &
  & 0.13193262E-09_JPRB, 0.13378088E-09_JPRB, 0.13557681E-09_JPRB, 0.13731419E-09_JPRB, 0.13895046E-09_JPRB, 0.14044411E-09_JPRB, &
  & 0.14174266E-09_JPRB, 0.14279540E-09_JPRB, 0.14355463E-09_JPRB, 0.14398557E-09_JPRB, 0.14406838E-09_JPRB, 0.14380529E-09_JPRB, &
  & 0.14322139E-09_JPRB, 0.14236977E-09_JPRB, 0.14133225E-09_JPRB, 0.14022786E-09_JPRB, 0.13916499E-09_JPRB, 0.13821266E-09_JPRB, &
  & 0.13746856E-09_JPRB, 0.13697191E-09_JPRB, 0.13675766E-09_JPRB, 0.13682455E-09_JPRB, 0.13714462E-09_JPRB, 0.13766401E-09_JPRB, &
  & 0.13828057E-09_JPRB, 0.13885845E-09_JPRB, 0.13925316E-09_JPRB, 0.13935916E-09_JPRB, 0.13913426E-09_JPRB, 0.13856916E-09_JPRB, &
  & 0.13767198E-09_JPRB, 0.13646116E-09_JPRB, 0.13497467E-09_JPRB, 0.13324544E-09_JPRB, 0.13130005E-09_JPRB, 0.12913751E-09_JPRB, &
  & 0.12677968E-09_JPRB, 0.12425722E-09_JPRB, 0.12161112E-09_JPRB, 0.11888734E-09_JPRB, 0.11613960E-09_JPRB, 0.11343271E-09_JPRB, &
  & 0.11083483E-09_JPRB, 0.10839842E-09_JPRB, 0.10614334E-09_JPRB, 0.10405969E-09_JPRB, 0.10215016E-09_JPRB, 0.10041060E-09_JPRB, &
  & 0.98803840E-10_JPRB, 0.97193552E-10_JPRB, 0.95426056E-10_JPRB, 0.92219260E-10_JPRB /)

RGHG8(:,21, 2) = (/ &
  & 0.11613938E-09_JPRB, 0.11806008E-09_JPRB, 0.11929770E-09_JPRB, 0.12055119E-09_JPRB, 0.12195137E-09_JPRB, 0.12351054E-09_JPRB, &
  & 0.12521012E-09_JPRB, 0.12700656E-09_JPRB, 0.12886846E-09_JPRB, 0.13076505E-09_JPRB, 0.13266743E-09_JPRB, 0.13454965E-09_JPRB, &
  & 0.13639109E-09_JPRB, 0.13816540E-09_JPRB, 0.13985686E-09_JPRB, 0.14145607E-09_JPRB, 0.14293643E-09_JPRB, 0.14425888E-09_JPRB, &
  & 0.14538327E-09_JPRB, 0.14626750E-09_JPRB, 0.14687362E-09_JPRB, 0.14717570E-09_JPRB, 0.14716571E-09_JPRB, 0.14685331E-09_JPRB, &
  & 0.14628596E-09_JPRB, 0.14553682E-09_JPRB, 0.14471138E-09_JPRB, 0.14392404E-09_JPRB, 0.14327331E-09_JPRB, 0.14285464E-09_JPRB, &
  & 0.14269597E-09_JPRB, 0.14278806E-09_JPRB, 0.14310279E-09_JPRB, 0.14355830E-09_JPRB, 0.14412284E-09_JPRB, 0.14472516E-09_JPRB, &
  & 0.14526656E-09_JPRB, 0.14563505E-09_JPRB, 0.14575161E-09_JPRB, 0.14557340E-09_JPRB, 0.14509689E-09_JPRB, 0.14433468E-09_JPRB, &
  & 0.14330731E-09_JPRB, 0.14203563E-09_JPRB, 0.14054058E-09_JPRB, 0.13884724E-09_JPRB, 0.13696495E-09_JPRB, 0.13490900E-09_JPRB, &
  & 0.13271323E-09_JPRB, 0.13040283E-09_JPRB, 0.12802119E-09_JPRB, 0.12560979E-09_JPRB, 0.12321226E-09_JPRB, 0.12087484E-09_JPRB, &
  & 0.11864433E-09_JPRB, 0.11655210E-09_JPRB, 0.11459730E-09_JPRB, 0.11277092E-09_JPRB, 0.11105873E-09_JPRB, 0.10944741E-09_JPRB, &
  & 0.10788758E-09_JPRB, 0.10633234E-09_JPRB, 0.10443122E-09_JPRB, 0.10125659E-09_JPRB /)

RGHG8(:,22, 2) = (/ &
  & 0.11998198E-09_JPRB, 0.12190142E-09_JPRB, 0.12315181E-09_JPRB, 0.12440964E-09_JPRB, 0.12578866E-09_JPRB, 0.12732806E-09_JPRB, &
  & 0.12900442E-09_JPRB, 0.13078209E-09_JPRB, 0.13261801E-09_JPRB, 0.13448045E-09_JPRB, 0.13634224E-09_JPRB, 0.13817258E-09_JPRB, &
  & 0.13994968E-09_JPRB, 0.14165233E-09_JPRB, 0.14326149E-09_JPRB, 0.14476147E-09_JPRB, 0.14613022E-09_JPRB, 0.14733814E-09_JPRB, &
  & 0.14835123E-09_JPRB, 0.14913799E-09_JPRB, 0.14967026E-09_JPRB, 0.14992844E-09_JPRB, 0.14990895E-09_JPRB, 0.14963771E-09_JPRB, &
  & 0.14915742E-09_JPRB, 0.14856463E-09_JPRB, 0.14795849E-09_JPRB, 0.14745632E-09_JPRB, 0.14714815E-09_JPRB, 0.14710720E-09_JPRB, &
  & 0.14733305E-09_JPRB, 0.14778985E-09_JPRB, 0.14837313E-09_JPRB, 0.14903270E-09_JPRB, 0.14967905E-09_JPRB, 0.15023423E-09_JPRB, &
  & 0.15062829E-09_JPRB, 0.15079282E-09_JPRB, 0.15068542E-09_JPRB, 0.15029905E-09_JPRB, 0.14965096E-09_JPRB, 0.14876703E-09_JPRB, &
  & 0.14767332E-09_JPRB, 0.14638352E-09_JPRB, 0.14491575E-09_JPRB, 0.14327824E-09_JPRB, 0.14148629E-09_JPRB, 0.13957700E-09_JPRB, &
  & 0.13756379E-09_JPRB, 0.13548590E-09_JPRB, 0.13338272E-09_JPRB, 0.13128811E-09_JPRB, 0.12923389E-09_JPRB, 0.12724805E-09_JPRB, &
  & 0.12535688E-09_JPRB, 0.12357372E-09_JPRB, 0.12189515E-09_JPRB, 0.12029847E-09_JPRB, 0.11876958E-09_JPRB, 0.11728757E-09_JPRB, &
  & 0.11582738E-09_JPRB, 0.11426488E-09_JPRB, 0.11248625E-09_JPRB, 0.10917842E-09_JPRB /)

RGHG8(:,23, 2) = (/ &
  & 0.12340287E-09_JPRB, 0.12530163E-09_JPRB, 0.12655572E-09_JPRB, 0.12778040E-09_JPRB, 0.12912367E-09_JPRB, 0.13060762E-09_JPRB, &
  & 0.13222458E-09_JPRB, 0.13393885E-09_JPRB, 0.13571247E-09_JPRB, 0.13751164E-09_JPRB, 0.13930761E-09_JPRB, 0.14107097E-09_JPRB, &
  & 0.14277905E-09_JPRB, 0.14440996E-09_JPRB, 0.14594796E-09_JPRB, 0.14737547E-09_JPRB, 0.14867237E-09_JPRB, 0.14981533E-09_JPRB, &
  & 0.15077807E-09_JPRB, 0.15153408E-09_JPRB, 0.15206032E-09_JPRB, 0.15234461E-09_JPRB, 0.15239088E-09_JPRB, 0.15221897E-09_JPRB, &
  & 0.15188846E-09_JPRB, 0.15147704E-09_JPRB, 0.15107875E-09_JPRB, 0.15079613E-09_JPRB, 0.15072138E-09_JPRB, 0.15089342E-09_JPRB, &
  & 0.15131167E-09_JPRB, 0.15189404E-09_JPRB, 0.15256822E-09_JPRB, 0.15324317E-09_JPRB, 0.15383862E-09_JPRB, 0.15428944E-09_JPRB, &
  & 0.15453605E-09_JPRB, 0.15453988E-09_JPRB, 0.15427852E-09_JPRB, 0.15376780E-09_JPRB, 0.15303186E-09_JPRB, 0.15210178E-09_JPRB, &
  & 0.15100077E-09_JPRB, 0.14974050E-09_JPRB, 0.14832882E-09_JPRB, 0.14677642E-09_JPRB, 0.14511711E-09_JPRB, 0.14336898E-09_JPRB, &
  & 0.14156010E-09_JPRB, 0.13972687E-09_JPRB, 0.13790297E-09_JPRB, 0.13611393E-09_JPRB, 0.13437673E-09_JPRB, 0.13270565E-09_JPRB, &
  & 0.13110946E-09_JPRB, 0.12959087E-09_JPRB, 0.12813801E-09_JPRB, 0.12673546E-09_JPRB, 0.12536013E-09_JPRB, 0.12399055E-09_JPRB, &
  & 0.12258941E-09_JPRB, 0.12111448E-09_JPRB, 0.11928712E-09_JPRB, 0.11609419E-09_JPRB /)

RGHG8(:,24, 2) = (/ &
  & 0.12653542E-09_JPRB, 0.12838504E-09_JPRB, 0.12957532E-09_JPRB, 0.13075707E-09_JPRB, 0.13203988E-09_JPRB, 0.13345904E-09_JPRB, &
  & 0.13499764E-09_JPRB, 0.13662556E-09_JPRB, 0.13831292E-09_JPRB, 0.14002599E-09_JPRB, 0.14174104E-09_JPRB, 0.14342905E-09_JPRB, &
  & 0.14506697E-09_JPRB, 0.14663445E-09_JPRB, 0.14811277E-09_JPRB, 0.14948542E-09_JPRB, 0.15073530E-09_JPRB, 0.15184301E-09_JPRB, &
  & 0.15278830E-09_JPRB, 0.15355255E-09_JPRB, 0.15411948E-09_JPRB, 0.15448028E-09_JPRB, 0.15463397E-09_JPRB, 0.15460828E-09_JPRB, &
  & 0.15444925E-09_JPRB, 0.15422118E-09_JPRB, 0.15400636E-09_JPRB, 0.15388824E-09_JPRB, 0.15393781E-09_JPRB, 0.15419822E-09_JPRB, &
  & 0.15464328E-09_JPRB, 0.15521318E-09_JPRB, 0.15583755E-09_JPRB, 0.15642654E-09_JPRB, 0.15690804E-09_JPRB, 0.15722851E-09_JPRB, &
  & 0.15734186E-09_JPRB, 0.15722235E-09_JPRB, 0.15686485E-09_JPRB, 0.15629315E-09_JPRB, 0.15553177E-09_JPRB, 0.15461098E-09_JPRB, &
  & 0.15354851E-09_JPRB, 0.15235016E-09_JPRB, 0.15102343E-09_JPRB, 0.14958762E-09_JPRB, 0.14807112E-09_JPRB, 0.14649547E-09_JPRB, &
  & 0.14489634E-09_JPRB, 0.14330294E-09_JPRB, 0.14174389E-09_JPRB, 0.14023400E-09_JPRB, 0.13877911E-09_JPRB, 0.13737957E-09_JPRB, &
  & 0.13603108E-09_JPRB, 0.13472876E-09_JPRB, 0.13346256E-09_JPRB, 0.13221015E-09_JPRB, 0.13095275E-09_JPRB, 0.12966819E-09_JPRB, &
  & 0.12833010E-09_JPRB, 0.12686151E-09_JPRB, 0.12511132E-09_JPRB, 0.12192077E-09_JPRB /)

RGHG8(:,25, 2) = (/ &
  & 0.12940468E-09_JPRB, 0.13117742E-09_JPRB, 0.13231574E-09_JPRB, 0.13342925E-09_JPRB, 0.13464171E-09_JPRB, 0.13597945E-09_JPRB, &
  & 0.13742893E-09_JPRB, 0.13895846E-09_JPRB, 0.14054040E-09_JPRB, 0.14215412E-09_JPRB, 0.14377385E-09_JPRB, 0.14537603E-09_JPRB, &
  & 0.14693757E-09_JPRB, 0.14843690E-09_JPRB, 0.14985839E-09_JPRB, 0.15118479E-09_JPRB, 0.15240118E-09_JPRB, 0.15349362E-09_JPRB, &
  & 0.15444808E-09_JPRB, 0.15524947E-09_JPRB, 0.15588289E-09_JPRB, 0.15633955E-09_JPRB, 0.15662191E-09_JPRB, 0.15675257E-09_JPRB, &
  & 0.15676493E-09_JPRB, 0.15670752E-09_JPRB, 0.15664850E-09_JPRB, 0.15664345E-09_JPRB, 0.15675998E-09_JPRB, 0.15701904E-09_JPRB, &
  & 0.15741086E-09_JPRB, 0.15789060E-09_JPRB, 0.15839272E-09_JPRB, 0.15884552E-09_JPRB, 0.15919210E-09_JPRB, 0.15938031E-09_JPRB, &
  & 0.15937965E-09_JPRB, 0.15916922E-09_JPRB, 0.15875679E-09_JPRB, 0.15816595E-09_JPRB, 0.15742031E-09_JPRB, 0.15654225E-09_JPRB, &
  & 0.15554398E-09_JPRB, 0.15442936E-09_JPRB, 0.15320528E-09_JPRB, 0.15189333E-09_JPRB, 0.15051793E-09_JPRB, 0.14911608E-09_JPRB, &
  & 0.14771726E-09_JPRB, 0.14634827E-09_JPRB, 0.14502727E-09_JPRB, 0.14376235E-09_JPRB, 0.14254851E-09_JPRB, 0.14137629E-09_JPRB, &
  & 0.14023389E-09_JPRB, 0.13911143E-09_JPRB, 0.13799285E-09_JPRB, 0.13686122E-09_JPRB, 0.13569545E-09_JPRB, 0.13447382E-09_JPRB, &
  & 0.13317228E-09_JPRB, 0.13174573E-09_JPRB, 0.13000517E-09_JPRB, 0.12686642E-09_JPRB /)

RGHG8(:,26, 2) = (/ &
  & 0.13206432E-09_JPRB, 0.13374607E-09_JPRB, 0.13482646E-09_JPRB, 0.13587520E-09_JPRB, 0.13700893E-09_JPRB, 0.13825602E-09_JPRB, &
  & 0.13960708E-09_JPRB, 0.14103203E-09_JPRB, 0.14250386E-09_JPRB, 0.14400825E-09_JPRB, 0.14552705E-09_JPRB, 0.14703877E-09_JPRB, &
  & 0.14852077E-09_JPRB, 0.14995469E-09_JPRB, 0.15132122E-09_JPRB, 0.15260500E-09_JPRB, 0.15379413E-09_JPRB, 0.15487729E-09_JPRB, &
  & 0.15584234E-09_JPRB, 0.15667714E-09_JPRB, 0.15737156E-09_JPRB, 0.15792014E-09_JPRB, 0.15832494E-09_JPRB, 0.15860102E-09_JPRB, &
  & 0.15876761E-09_JPRB, 0.15885902E-09_JPRB, 0.15892197E-09_JPRB, 0.15900320E-09_JPRB, 0.15914475E-09_JPRB, 0.15936963E-09_JPRB, &
  & 0.15967566E-09_JPRB, 0.16003565E-09_JPRB, 0.16039960E-09_JPRB, 0.16071054E-09_JPRB, 0.16092466E-09_JPRB, 0.16099583E-09_JPRB, &
  & 0.16090251E-09_JPRB, 0.16063104E-09_JPRB, 0.16019472E-09_JPRB, 0.15961503E-09_JPRB, 0.15890755E-09_JPRB, 0.15808904E-09_JPRB, &
  & 0.15716760E-09_JPRB, 0.15614411E-09_JPRB, 0.15502585E-09_JPRB, 0.15383449E-09_JPRB, 0.15260028E-09_JPRB, 0.15135933E-09_JPRB, &
  & 0.15014237E-09_JPRB, 0.14896871E-09_JPRB, 0.14785193E-09_JPRB, 0.14679211E-09_JPRB, 0.14577732E-09_JPRB, 0.14479286E-09_JPRB, &
  & 0.14382126E-09_JPRB, 0.14284564E-09_JPRB, 0.14185164E-09_JPRB, 0.14081794E-09_JPRB, 0.13972584E-09_JPRB, 0.13855597E-09_JPRB, &
  & 0.13728804E-09_JPRB, 0.13588386E-09_JPRB, 0.13417376E-09_JPRB, 0.13109576E-09_JPRB /)

RGHG8(:,27, 2) = (/ &
  & 0.13456559E-09_JPRB, 0.13615618E-09_JPRB, 0.13717172E-09_JPRB, 0.13815268E-09_JPRB, 0.13920351E-09_JPRB, 0.14035810E-09_JPRB, &
  & 0.14160396E-09_JPRB, 0.14291857E-09_JPRB, 0.14427629E-09_JPRB, 0.14566529E-09_JPRB, 0.14707670E-09_JPRB, 0.14849058E-09_JPRB, &
  & 0.14988996E-09_JPRB, 0.15125243E-09_JPRB, 0.15256349E-09_JPRB, 0.15380754E-09_JPRB, 0.15497113E-09_JPRB, 0.15604169E-09_JPRB, &
  & 0.15700970E-09_JPRB, 0.15786726E-09_JPRB, 0.15860877E-09_JPRB, 0.15923048E-09_JPRB, 0.15973324E-09_JPRB, 0.16012519E-09_JPRB, &
  & 0.16041744E-09_JPRB, 0.16063065E-09_JPRB, 0.16079130E-09_JPRB, 0.16093518E-09_JPRB, 0.16108981E-09_JPRB, 0.16127839E-09_JPRB, &
  & 0.16150385E-09_JPRB, 0.16175047E-09_JPRB, 0.16198617E-09_JPRB, 0.16217076E-09_JPRB, 0.16226986E-09_JPRB, 0.16224698E-09_JPRB, &
  & 0.16208677E-09_JPRB, 0.16178243E-09_JPRB, 0.16134587E-09_JPRB, 0.16079346E-09_JPRB, 0.16013796E-09_JPRB, 0.15938892E-09_JPRB, &
  & 0.15854976E-09_JPRB, 0.15761929E-09_JPRB, 0.15660689E-09_JPRB, 0.15552951E-09_JPRB, 0.15442174E-09_JPRB, 0.15332381E-09_JPRB, &
  & 0.15225930E-09_JPRB, 0.15124893E-09_JPRB, 0.15029916E-09_JPRB, 0.14940309E-09_JPRB, 0.14854888E-09_JPRB, 0.14771359E-09_JPRB, &
  & 0.14687887E-09_JPRB, 0.14602730E-09_JPRB, 0.14513717E-09_JPRB, 0.14419087E-09_JPRB, 0.14316615E-09_JPRB, 0.14204517E-09_JPRB, &
  & 0.14081739E-09_JPRB, 0.13945181E-09_JPRB, 0.13779880E-09_JPRB, 0.13480725E-09_JPRB /)

RGHG8(:,28, 2) = (/ &
  & 0.13693811E-09_JPRB, 0.13844206E-09_JPRB, 0.13939044E-09_JPRB, 0.14029605E-09_JPRB, 0.14126618E-09_JPRB, 0.14232338E-09_JPRB, &
  & 0.14346518E-09_JPRB, 0.14466782E-09_JPRB, 0.14590952E-09_JPRB, 0.14718340E-09_JPRB, 0.14848177E-09_JPRB, 0.14979505E-09_JPRB, &
  & 0.15110389E-09_JPRB, 0.15239388E-09_JPRB, 0.15364635E-09_JPRB, 0.15484528E-09_JPRB, 0.15597648E-09_JPRB, 0.15702914E-09_JPRB, &
  & 0.15799442E-09_JPRB, 0.15886509E-09_JPRB, 0.15963644E-09_JPRB, 0.16030723E-09_JPRB, 0.16087921E-09_JPRB, 0.16135597E-09_JPRB, &
  & 0.16174209E-09_JPRB, 0.16204650E-09_JPRB, 0.16228399E-09_JPRB, 0.16247510E-09_JPRB, 0.16264094E-09_JPRB, 0.16280075E-09_JPRB, &
  & 0.16296084E-09_JPRB, 0.16311616E-09_JPRB, 0.16324875E-09_JPRB, 0.16333150E-09_JPRB, 0.16333954E-09_JPRB, 0.16324737E-09_JPRB, &
  & 0.16304418E-09_JPRB, 0.16272750E-09_JPRB, 0.16230724E-09_JPRB, 0.16179767E-09_JPRB, 0.16120447E-09_JPRB, 0.16052895E-09_JPRB, &
  & 0.15977175E-09_JPRB, 0.15893277E-09_JPRB, 0.15801636E-09_JPRB, 0.15704475E-09_JPRB, 0.15605200E-09_JPRB, 0.15507026E-09_JPRB, &
  & 0.15413368E-09_JPRB, 0.15325316E-09_JPRB, 0.15243425E-09_JPRB, 0.15166704E-09_JPRB, 0.15093390E-09_JPRB, 0.15021528E-09_JPRB, &
  & 0.14949016E-09_JPRB, 0.14873738E-09_JPRB, 0.14793845E-09_JPRB, 0.14706912E-09_JPRB, 0.14610997E-09_JPRB, 0.14504553E-09_JPRB, &
  & 0.14387351E-09_JPRB, 0.14257413E-09_JPRB, 0.14101711E-09_JPRB, 0.13816152E-09_JPRB /)

RGHG8(:,29, 2) = (/ &
  & 0.13921161E-09_JPRB, 0.14062523E-09_JPRB, 0.14150411E-09_JPRB, 0.14233853E-09_JPRB, 0.14321902E-09_JPRB, 0.14418390E-09_JPRB, &
  & 0.14522188E-09_JPRB, 0.14631557E-09_JPRB, 0.14744242E-09_JPRB, 0.14860208E-09_JPRB, 0.14978714E-09_JPRB, 0.15099728E-09_JPRB, &
  & 0.15222117E-09_JPRB, 0.15343694E-09_JPRB, 0.15462961E-09_JPRB, 0.15578255E-09_JPRB, 0.15688147E-09_JPRB, 0.15791192E-09_JPRB, &
  & 0.15886412E-09_JPRB, 0.15973173E-09_JPRB, 0.16051344E-09_JPRB, 0.16120912E-09_JPRB, 0.16182167E-09_JPRB, 0.16235281E-09_JPRB, &
  & 0.16280124E-09_JPRB, 0.16316784E-09_JPRB, 0.16345741E-09_JPRB, 0.16368325E-09_JPRB, 0.16385886E-09_JPRB, 0.16399949E-09_JPRB, &
  & 0.16411499E-09_JPRB, 0.16420425E-09_JPRB, 0.16426140E-09_JPRB, 0.16426856E-09_JPRB, 0.16421084E-09_JPRB, 0.16407251E-09_JPRB, &
  & 0.16384671E-09_JPRB, 0.16353605E-09_JPRB, 0.16314852E-09_JPRB, 0.16269025E-09_JPRB, 0.16216030E-09_JPRB, 0.16155791E-09_JPRB, &
  & 0.16088016E-09_JPRB, 0.16012482E-09_JPRB, 0.15930023E-09_JPRB, 0.15842351E-09_JPRB, 0.15752590E-09_JPRB, 0.15664658E-09_JPRB, &
  & 0.15580850E-09_JPRB, 0.15503142E-09_JPRB, 0.15431226E-09_JPRB, 0.15364025E-09_JPRB, 0.15300020E-09_JPRB, 0.15236931E-09_JPRB, &
  & 0.15172717E-09_JPRB, 0.15105574E-09_JPRB, 0.15032918E-09_JPRB, 0.14952962E-09_JPRB, 0.14863352E-09_JPRB, 0.14763459E-09_JPRB, &
  & 0.14653570E-09_JPRB, 0.14534701E-09_JPRB, 0.14390424E-09_JPRB, 0.14130920E-09_JPRB /)

RGHG8(:,30, 2) = (/ &
  & 0.14139320E-09_JPRB, 0.14272085E-09_JPRB, 0.14352780E-09_JPRB, 0.14428164E-09_JPRB, 0.14508206E-09_JPRB, 0.14595124E-09_JPRB, &
  & 0.14689092E-09_JPRB, 0.14787896E-09_JPRB, 0.14889796E-09_JPRB, 0.14994425E-09_JPRB, 0.15102006E-09_JPRB, 0.15212356E-09_JPRB, &
  & 0.15325423E-09_JPRB, 0.15440026E-09_JPRB, 0.15553993E-09_JPRB, 0.15665309E-09_JPRB, 0.15772021E-09_JPRB, 0.15872677E-09_JPRB, &
  & 0.15966006E-09_JPRB, 0.16051523E-09_JPRB, 0.16129233E-09_JPRB, 0.16199442E-09_JPRB, 0.16262454E-09_JPRB, 0.16318241E-09_JPRB, &
  & 0.16366461E-09_JPRB, 0.16406393E-09_JPRB, 0.16438516E-09_JPRB, 0.16463089E-09_JPRB, 0.16481323E-09_JPRB, 0.16494230E-09_JPRB, &
  & 0.16503059E-09_JPRB, 0.16507552E-09_JPRB, 0.16508275E-09_JPRB, 0.16503827E-09_JPRB, 0.16493894E-09_JPRB, 0.16477585E-09_JPRB, &
  & 0.16454757E-09_JPRB, 0.16425669E-09_JPRB, 0.16390596E-09_JPRB, 0.16349813E-09_JPRB, 0.16303095E-09_JPRB, 0.16249781E-09_JPRB, &
  & 0.16189396E-09_JPRB, 0.16121618E-09_JPRB, 0.16047125E-09_JPRB, 0.15967828E-09_JPRB, 0.15886711E-09_JPRB, 0.15806791E-09_JPRB, &
  & 0.15731465E-09_JPRB, 0.15661511E-09_JPRB, 0.15597097E-09_JPRB, 0.15537206E-09_JPRB, 0.15479805E-09_JPRB, 0.15423318E-09_JPRB, &
  & 0.15365491E-09_JPRB, 0.15304384E-09_JPRB, 0.15237948E-09_JPRB, 0.15163786E-09_JPRB, 0.15080394E-09_JPRB, 0.14987342E-09_JPRB, &
  & 0.14887694E-09_JPRB, 0.14780301E-09_JPRB, 0.14656625E-09_JPRB, 0.14423597E-09_JPRB /)

RGHG8(:,31, 2) = (/ &
  & 0.14349610E-09_JPRB, 0.14472065E-09_JPRB, 0.14545834E-09_JPRB, 0.14613964E-09_JPRB, 0.14685372E-09_JPRB, 0.14763743E-09_JPRB, &
  & 0.14848360E-09_JPRB, 0.14937283E-09_JPRB, 0.15029088E-09_JPRB, 0.15123190E-09_JPRB, 0.15220263E-09_JPRB, 0.15321090E-09_JPRB, &
  & 0.15425403E-09_JPRB, 0.15532503E-09_JPRB, 0.15640947E-09_JPRB, 0.15748275E-09_JPRB, 0.15852071E-09_JPRB, 0.15950236E-09_JPRB, &
  & 0.16041508E-09_JPRB, 0.16125284E-09_JPRB, 0.16201707E-09_JPRB, 0.16271172E-09_JPRB, 0.16334044E-09_JPRB, 0.16390168E-09_JPRB, &
  & 0.16439149E-09_JPRB, 0.16479991E-09_JPRB, 0.16513217E-09_JPRB, 0.16538404E-09_JPRB, 0.16556802E-09_JPRB, 0.16569043E-09_JPRB, &
  & 0.16576159E-09_JPRB, 0.16578061E-09_JPRB, 0.16575794E-09_JPRB, 0.16568280E-09_JPRB, 0.16556145E-09_JPRB, 0.16538913E-09_JPRB, &
  & 0.16516799E-09_JPRB, 0.16490094E-09_JPRB, 0.16458956E-09_JPRB, 0.16423420E-09_JPRB, 0.16382683E-09_JPRB, 0.16335813E-09_JPRB, &
  & 0.16281998E-09_JPRB, 0.16220907E-09_JPRB, 0.16153537E-09_JPRB, 0.16081506E-09_JPRB, 0.16007537E-09_JPRB, 0.15935117E-09_JPRB, &
  & 0.15866224E-09_JPRB, 0.15802747E-09_JPRB, 0.15744142E-09_JPRB, 0.15689400E-09_JPRB, 0.15637167E-09_JPRB, 0.15585372E-09_JPRB, &
  & 0.15532378E-09_JPRB, 0.15476218E-09_JPRB, 0.15414674E-09_JPRB, 0.15345784E-09_JPRB, 0.15268142E-09_JPRB, 0.15183056E-09_JPRB, &
  & 0.15093411E-09_JPRB, 0.15001991E-09_JPRB, 0.14893982E-09_JPRB, 0.14698047E-09_JPRB /)

RGHG8(:,32, 2) = (/ &
  & 0.14550033E-09_JPRB, 0.14663383E-09_JPRB, 0.14729681E-09_JPRB, 0.14790495E-09_JPRB, 0.14854554E-09_JPRB, 0.14924550E-09_JPRB, &
  & 0.15000662E-09_JPRB, 0.15080576E-09_JPRB, 0.15162972E-09_JPRB, 0.15247212E-09_JPRB, 0.15334466E-09_JPRB, 0.15425830E-09_JPRB, &
  & 0.15522109E-09_JPRB, 0.15622627E-09_JPRB, 0.15725739E-09_JPRB, 0.15829141E-09_JPRB, 0.15930018E-09_JPRB, 0.16025917E-09_JPRB, &
  & 0.16115149E-09_JPRB, 0.16197017E-09_JPRB, 0.16271587E-09_JPRB, 0.16339384E-09_JPRB, 0.16400507E-09_JPRB, 0.16455264E-09_JPRB, &
  & 0.16502578E-09_JPRB, 0.16542520E-09_JPRB, 0.16574883E-09_JPRB, 0.16599597E-09_JPRB, 0.16617510E-09_JPRB, 0.16629276E-09_JPRB, &
  & 0.16635242E-09_JPRB, 0.16636065E-09_JPRB, 0.16632216E-09_JPRB, 0.16623505E-09_JPRB, 0.16610720E-09_JPRB, 0.16593801E-09_JPRB, &
  & 0.16573369E-09_JPRB, 0.16549616E-09_JPRB, 0.16522493E-09_JPRB, 0.16491582E-09_JPRB, 0.16455957E-09_JPRB, 0.16414459E-09_JPRB, &
  & 0.16366090E-09_JPRB, 0.16310686E-09_JPRB, 0.16249002E-09_JPRB, 0.16183183E-09_JPRB, 0.16115746E-09_JPRB, 0.16049215E-09_JPRB, &
  & 0.15986465E-09_JPRB, 0.15928045E-09_JPRB, 0.15874023E-09_JPRB, 0.15823545E-09_JPRB, 0.15774962E-09_JPRB, 0.15726970E-09_JPRB, &
  & 0.15677751E-09_JPRB, 0.15625554E-09_JPRB, 0.15568391E-09_JPRB, 0.15504255E-09_JPRB, 0.15432608E-09_JPRB, 0.15355187E-09_JPRB, &
  & 0.15276806E-09_JPRB, 0.15197402E-09_JPRB, 0.15108741E-09_JPRB, 0.14942146E-09_JPRB /)

RGHG8(:,33, 2) = (/ &
  & 0.14740358E-09_JPRB, 0.14843339E-09_JPRB, 0.14903805E-09_JPRB, 0.14958232E-09_JPRB, 0.15015199E-09_JPRB, 0.15078029E-09_JPRB, &
  & 0.15146354E-09_JPRB, 0.15218049E-09_JPRB, 0.15291793E-09_JPRB, 0.15366956E-09_JPRB, 0.15445066E-09_JPRB, 0.15527624E-09_JPRB, &
  & 0.15615666E-09_JPRB, 0.15709457E-09_JPRB, 0.15807743E-09_JPRB, 0.15907826E-09_JPRB, 0.16006385E-09_JPRB, 0.16100471E-09_JPRB, &
  & 0.16187988E-09_JPRB, 0.16267906E-09_JPRB, 0.16340368E-09_JPRB, 0.16405553E-09_JPRB, 0.16464015E-09_JPRB, 0.16515458E-09_JPRB, &
  & 0.16559801E-09_JPRB, 0.16597046E-09_JPRB, 0.16627062E-09_JPRB, 0.16650313E-09_JPRB, 0.16667144E-09_JPRB, 0.16678314E-09_JPRB, &
  & 0.16683643E-09_JPRB, 0.16684314E-09_JPRB, 0.16680103E-09_JPRB, 0.16671661E-09_JPRB, 0.16659436E-09_JPRB, 0.16643979E-09_JPRB, &
  & 0.16625895E-09_JPRB, 0.16605223E-09_JPRB, 0.16581815E-09_JPRB, 0.16555024E-09_JPRB, 0.16523609E-09_JPRB, 0.16486235E-09_JPRB, &
  & 0.16442113E-09_JPRB, 0.16390922E-09_JPRB, 0.16333995E-09_JPRB, 0.16273226E-09_JPRB, 0.16211020E-09_JPRB, 0.16150237E-09_JPRB, &
  & 0.16092297E-09_JPRB, 0.16038487E-09_JPRB, 0.15988399E-09_JPRB, 0.15941203E-09_JPRB, 0.15895837E-09_JPRB, 0.15850772E-09_JPRB, &
  & 0.15804758E-09_JPRB, 0.15756034E-09_JPRB, 0.15702797E-09_JPRB, 0.15643378E-09_JPRB, 0.15577600E-09_JPRB, 0.15508028E-09_JPRB, &
  & 0.15438778E-09_JPRB, 0.15371568E-09_JPRB, 0.15295060E-09_JPRB, 0.15156670E-09_JPRB /)

RGHG8(:,34, 2) = (/ &
  & 0.14918242E-09_JPRB, 0.15013701E-09_JPRB, 0.15067766E-09_JPRB, 0.15116708E-09_JPRB, 0.15167902E-09_JPRB, 0.15224143E-09_JPRB, &
  & 0.15285503E-09_JPRB, 0.15349855E-09_JPRB, 0.15415576E-09_JPRB, 0.15482404E-09_JPRB, 0.15552007E-09_JPRB, 0.15626345E-09_JPRB, &
  & 0.15707172E-09_JPRB, 0.15794854E-09_JPRB, 0.15888374E-09_JPRB, 0.15985013E-09_JPRB, 0.16081367E-09_JPRB, 0.16173941E-09_JPRB, &
  & 0.16259820E-09_JPRB, 0.16337930E-09_JPRB, 0.16407962E-09_JPRB, 0.16470193E-09_JPRB, 0.16524718E-09_JPRB, 0.16572085E-09_JPRB, &
  & 0.16611904E-09_JPRB, 0.16645231E-09_JPRB, 0.16671788E-09_JPRB, 0.16692585E-09_JPRB, 0.16707818E-09_JPRB, 0.16718009E-09_JPRB, &
  & 0.16723155E-09_JPRB, 0.16724075E-09_JPRB, 0.16720605E-09_JPRB, 0.16713356E-09_JPRB, 0.16702703E-09_JPRB, 0.16689450E-09_JPRB, &
  & 0.16673980E-09_JPRB, 0.16656466E-09_JPRB, 0.16636643E-09_JPRB, 0.16613529E-09_JPRB, 0.16585647E-09_JPRB, 0.16551606E-09_JPRB, &
  & 0.16510388E-09_JPRB, 0.16462454E-09_JPRB, 0.16408935E-09_JPRB, 0.16352186E-09_JPRB, 0.16294678E-09_JPRB, 0.16238254E-09_JPRB, &
  & 0.16184933E-09_JPRB, 0.16134930E-09_JPRB, 0.16088215E-09_JPRB, 0.16044047E-09_JPRB, 0.16001198E-09_JPRB, 0.15958787E-09_JPRB, &
  & 0.15915477E-09_JPRB, 0.15869819E-09_JPRB, 0.15820224E-09_JPRB, 0.15765442E-09_JPRB, 0.15705542E-09_JPRB, 0.15643117E-09_JPRB, &
  & 0.15582344E-09_JPRB, 0.15523051E-09_JPRB, 0.15458197E-09_JPRB, 0.15338382E-09_JPRB /)

RGHG8(:,35, 2) = (/ &
  & 0.15085214E-09_JPRB, 0.15172331E-09_JPRB, 0.15222103E-09_JPRB, 0.15266233E-09_JPRB, 0.15312208E-09_JPRB, 0.15363021E-09_JPRB, &
  & 0.15418128E-09_JPRB, 0.15475764E-09_JPRB, 0.15534098E-09_JPRB, 0.15593291E-09_JPRB, 0.15654897E-09_JPRB, 0.15721202E-09_JPRB, &
  & 0.15794444E-09_JPRB, 0.15876045E-09_JPRB, 0.15965283E-09_JPRB, 0.16059185E-09_JPRB, 0.16153857E-09_JPRB, 0.16245125E-09_JPRB, &
  & 0.16329686E-09_JPRB, 0.16405989E-09_JPRB, 0.16473470E-09_JPRB, 0.16532128E-09_JPRB, 0.16582211E-09_JPRB, 0.16624375E-09_JPRB, &
  & 0.16658773E-09_JPRB, 0.16687053E-09_JPRB, 0.16709066E-09_JPRB, 0.16726663E-09_JPRB, 0.16739603E-09_JPRB, 0.16748508E-09_JPRB, &
  & 0.16753464E-09_JPRB, 0.16754803E-09_JPRB, 0.16752569E-09_JPRB, 0.16747004E-09_JPRB, 0.16738551E-09_JPRB, 0.16727809E-09_JPRB, &
  & 0.16715188E-09_JPRB, 0.16700898E-09_JPRB, 0.16684389E-09_JPRB, 0.16664636E-09_JPRB, 0.16640109E-09_JPRB, 0.16609093E-09_JPRB, &
  & 0.16570863E-09_JPRB, 0.16525294E-09_JPRB, 0.16474627E-09_JPRB, 0.16421109E-09_JPRB, 0.16367069E-09_JPRB, 0.16314815E-09_JPRB, &
  & 0.16264984E-09_JPRB, 0.16218418E-09_JPRB, 0.16174649E-09_JPRB, 0.16132877E-09_JPRB, 0.16092415E-09_JPRB, 0.16052212E-09_JPRB, &
  & 0.16011230E-09_JPRB, 0.15968271E-09_JPRB, 0.15922122E-09_JPRB, 0.15871632E-09_JPRB, 0.15817436E-09_JPRB, 0.15761703E-09_JPRB, &
  & 0.15707660E-09_JPRB, 0.15655938E-09_JPRB, 0.15598142E-09_JPRB, 0.15494700E-09_JPRB /)

RGHG8(:,36, 2) = (/ &
  & 0.15241061E-09_JPRB, 0.15321874E-09_JPRB, 0.15366784E-09_JPRB, 0.15406963E-09_JPRB, 0.15448839E-09_JPRB, 0.15494667E-09_JPRB, &
  & 0.15544330E-09_JPRB, 0.15595837E-09_JPRB, 0.15647449E-09_JPRB, 0.15699389E-09_JPRB, 0.15753493E-09_JPRB, 0.15812264E-09_JPRB, &
  & 0.15878403E-09_JPRB, 0.15953899E-09_JPRB, 0.16038586E-09_JPRB, 0.16129674E-09_JPRB, 0.16222718E-09_JPRB, 0.16312844E-09_JPRB, &
  & 0.16396197E-09_JPRB, 0.16470723E-09_JPRB, 0.16535268E-09_JPRB, 0.16589780E-09_JPRB, 0.16634416E-09_JPRB, 0.16670362E-09_JPRB, &
  & 0.16698357E-09_JPRB, 0.16720646E-09_JPRB, 0.16737851E-09_JPRB, 0.16751604E-09_JPRB, 0.16762113E-09_JPRB, 0.16769580E-09_JPRB, &
  & 0.16774164E-09_JPRB, 0.16775836E-09_JPRB, 0.16774629E-09_JPRB, 0.16770606E-09_JPRB, 0.16764141E-09_JPRB, 0.16755697E-09_JPRB, &
  & 0.16745687E-09_JPRB, 0.16734178E-09_JPRB, 0.16720667E-09_JPRB, 0.16704191E-09_JPRB, 0.16683130E-09_JPRB, 0.16655889E-09_JPRB, &
  & 0.16620942E-09_JPRB, 0.16578824E-09_JPRB, 0.16530842E-09_JPRB, 0.16480257E-09_JPRB, 0.16429598E-09_JPRB, 0.16380333E-09_JPRB, &
  & 0.16333788E-09_JPRB, 0.16289942E-09_JPRB, 0.16248516E-09_JPRB, 0.16209004E-09_JPRB, 0.16170465E-09_JPRB, 0.16132207E-09_JPRB, &
  & 0.16093310E-09_JPRB, 0.16052883E-09_JPRB, 0.16009763E-09_JPRB, 0.15963555E-09_JPRB, 0.15914513E-09_JPRB, 0.15864907E-09_JPRB, &
  & 0.15817139E-09_JPRB, 0.15770929E-09_JPRB, 0.15720149E-09_JPRB, 0.15628392E-09_JPRB /)

RGHG8(:,37, 2) = (/ &
  & 0.15388302E-09_JPRB, 0.15461737E-09_JPRB, 0.15503114E-09_JPRB, 0.15539708E-09_JPRB, 0.15577911E-09_JPRB, 0.15619803E-09_JPRB, &
  & 0.15664579E-09_JPRB, 0.15710488E-09_JPRB, 0.15755876E-09_JPRB, 0.15801112E-09_JPRB, 0.15847998E-09_JPRB, 0.15899174E-09_JPRB, &
  & 0.15958126E-09_JPRB, 0.16027345E-09_JPRB, 0.16107564E-09_JPRB, 0.16195849E-09_JPRB, 0.16287138E-09_JPRB, 0.16376087E-09_JPRB, &
  & 0.16458247E-09_JPRB, 0.16530423E-09_JPRB, 0.16591030E-09_JPRB, 0.16640217E-09_JPRB, 0.16677931E-09_JPRB, 0.16706819E-09_JPRB, &
  & 0.16728208E-09_JPRB, 0.16744842E-09_JPRB, 0.16757649E-09_JPRB, 0.16768238E-09_JPRB, 0.16776636E-09_JPRB, 0.16782976E-09_JPRB, &
  & 0.16787177E-09_JPRB, 0.16788984E-09_JPRB, 0.16788387E-09_JPRB, 0.16785377E-09_JPRB, 0.16780283E-09_JPRB, 0.16773492E-09_JPRB, &
  & 0.16765381E-09_JPRB, 0.16755985E-09_JPRB, 0.16744893E-09_JPRB, 0.16731233E-09_JPRB, 0.16713625E-09_JPRB, 0.16690282E-09_JPRB, &
  & 0.16659937E-09_JPRB, 0.16621735E-09_JPRB, 0.16577693E-09_JPRB, 0.16530273E-09_JPRB, 0.16482538E-09_JPRB, 0.16436273E-09_JPRB, &
  & 0.16392193E-09_JPRB, 0.16350600E-09_JPRB, 0.16311247E-09_JPRB, 0.16273491E-09_JPRB, 0.16236756E-09_JPRB, 0.16200311E-09_JPRB, &
  & 0.16163454E-09_JPRB, 0.16125448E-09_JPRB, 0.16085538E-09_JPRB, 0.16043178E-09_JPRB, 0.15999123E-09_JPRB, 0.15954894E-09_JPRB, &
  & 0.15912482E-09_JPRB, 0.15871526E-09_JPRB, 0.15826425E-09_JPRB, 0.15745469E-09_JPRB /)

RGHG8(:,38, 2) = (/ &
  & 0.15526880E-09_JPRB, 0.15593764E-09_JPRB, 0.15630899E-09_JPRB, 0.15664728E-09_JPRB, 0.15699965E-09_JPRB, 0.15738438E-09_JPRB, &
  & 0.15779038E-09_JPRB, 0.15819786E-09_JPRB, 0.15859464E-09_JPRB, 0.15898391E-09_JPRB, 0.15938428E-09_JPRB, 0.15982554E-09_JPRB, &
  & 0.16034001E-09_JPRB, 0.16096671E-09_JPRB, 0.16171577E-09_JPRB, 0.16256650E-09_JPRB, 0.16346025E-09_JPRB, 0.16433356E-09_JPRB, &
  & 0.16513449E-09_JPRB, 0.16582240E-09_JPRB, 0.16637408E-09_JPRB, 0.16679329E-09_JPRB, 0.16710019E-09_JPRB, 0.16732121E-09_JPRB, &
  & 0.16748253E-09_JPRB, 0.16760653E-09_JPRB, 0.16770499E-09_JPRB, 0.16778888E-09_JPRB, 0.16785935E-09_JPRB, 0.16791531E-09_JPRB, &
  & 0.16795430E-09_JPRB, 0.16797280E-09_JPRB, 0.16796989E-09_JPRB, 0.16794539E-09_JPRB, 0.16790257E-09_JPRB, 0.16784521E-09_JPRB, &
  & 0.16777697E-09_JPRB, 0.16769769E-09_JPRB, 0.16760435E-09_JPRB, 0.16748937E-09_JPRB, 0.16734068E-09_JPRB, 0.16714369E-09_JPRB, &
  & 0.16688192E-09_JPRB, 0.16654865E-09_JPRB, 0.16615011E-09_JPRB, 0.16571483E-09_JPRB, 0.16526888E-09_JPRB, 0.16483234E-09_JPRB, &
  & 0.16441400E-09_JPRB, 0.16401709E-09_JPRB, 0.16363916E-09_JPRB, 0.16327752E-09_JPRB, 0.16292626E-09_JPRB, 0.16258032E-09_JPRB, &
  & 0.16223425E-09_JPRB, 0.16188120E-09_JPRB, 0.16151502E-09_JPRB, 0.16113172E-09_JPRB, 0.16073597E-09_JPRB, 0.16034209E-09_JPRB, &
  & 0.15996404E-09_JPRB, 0.15960068E-09_JPRB, 0.15919689E-09_JPRB, 0.15848516E-09_JPRB /)

RGHG8(:,39, 2) = (/ &
  & 0.15657337E-09_JPRB, 0.15716514E-09_JPRB, 0.15750685E-09_JPRB, 0.15781540E-09_JPRB, 0.15814669E-09_JPRB, 0.15850241E-09_JPRB, &
  & 0.15887121E-09_JPRB, 0.15923195E-09_JPRB, 0.15957516E-09_JPRB, 0.15990646E-09_JPRB, 0.16024609E-09_JPRB, 0.16061760E-09_JPRB, &
  & 0.16106402E-09_JPRB, 0.16161965E-09_JPRB, 0.16231413E-09_JPRB, 0.16312469E-09_JPRB, 0.16399228E-09_JPRB, 0.16484146E-09_JPRB, &
  & 0.16560353E-09_JPRB, 0.16623707E-09_JPRB, 0.16671896E-09_JPRB, 0.16706730E-09_JPRB, 0.16731178E-09_JPRB, 0.16748433E-09_JPRB, &
  & 0.16761102E-09_JPRB, 0.16770903E-09_JPRB, 0.16778956E-09_JPRB, 0.16786064E-09_JPRB, 0.16792288E-09_JPRB, 0.16797437E-09_JPRB, &
  & 0.16801137E-09_JPRB, 0.16802962E-09_JPRB, 0.16802783E-09_JPRB, 0.16800628E-09_JPRB, 0.16796810E-09_JPRB, 0.16791758E-09_JPRB, &
  & 0.16785784E-09_JPRB, 0.16778907E-09_JPRB, 0.16770821E-09_JPRB, 0.16760891E-09_JPRB, 0.16748139E-09_JPRB, 0.16731223E-09_JPRB, &
  & 0.16708775E-09_JPRB, 0.16679713E-09_JPRB, 0.16644422E-09_JPRB, 0.16604797E-09_JPRB, 0.16563489E-09_JPRB, 0.16522453E-09_JPRB, &
  & 0.16482783E-09_JPRB, 0.16444593E-09_JPRB, 0.16408176E-09_JPRB, 0.16373282E-09_JPRB, 0.16339648E-09_JPRB, 0.16306984E-09_JPRB, &
  & 0.16274755E-09_JPRB, 0.16242564E-09_JPRB, 0.16209514E-09_JPRB, 0.16175286E-09_JPRB, 0.16140057E-09_JPRB, 0.16104970E-09_JPRB, &
  & 0.16071358E-09_JPRB, 0.16038697E-09_JPRB, 0.16003243E-09_JPRB, 0.15940001E-09_JPRB /)

RGHG8(:,40, 2) = (/ &
  & 0.15777502E-09_JPRB, 0.15830326E-09_JPRB, 0.15860763E-09_JPRB, 0.15889903E-09_JPRB, 0.15920856E-09_JPRB, 0.15954280E-09_JPRB, &
  & 0.15987753E-09_JPRB, 0.16019469E-09_JPRB, 0.16048993E-09_JPRB, 0.16077051E-09_JPRB, 0.16105375E-09_JPRB, 0.16136881E-09_JPRB, &
  & 0.16174585E-09_JPRB, 0.16223434E-09_JPRB, 0.16286469E-09_JPRB, 0.16363019E-09_JPRB, 0.16446371E-09_JPRB, 0.16527558E-09_JPRB, &
  & 0.16598682E-09_JPRB, 0.16654828E-09_JPRB, 0.16696156E-09_JPRB, 0.16724856E-09_JPRB, 0.16744922E-09_JPRB, 0.16759012E-09_JPRB, &
  & 0.16769602E-09_JPRB, 0.16777887E-09_JPRB, 0.16784951E-09_JPRB, 0.16791307E-09_JPRB, 0.16797067E-09_JPRB, 0.16801939E-09_JPRB, &
  & 0.16805479E-09_JPRB, 0.16807236E-09_JPRB, 0.16807059E-09_JPRB, 0.16805030E-09_JPRB, 0.16801480E-09_JPRB, 0.16796858E-09_JPRB, &
  & 0.16791490E-09_JPRB, 0.16785358E-09_JPRB, 0.16778202E-09_JPRB, 0.16769472E-09_JPRB, 0.16758311E-09_JPRB, 0.16743605E-09_JPRB, &
  & 0.16724072E-09_JPRB, 0.16698620E-09_JPRB, 0.16667308E-09_JPRB, 0.16631516E-09_JPRB, 0.16593639E-09_JPRB, 0.16555432E-09_JPRB, &
  & 0.16517682E-09_JPRB, 0.16481071E-09_JPRB, 0.16445661E-09_JPRB, 0.16411691E-09_JPRB, 0.16379380E-09_JPRB, 0.16348514E-09_JPRB, &
  & 0.16318957E-09_JPRB, 0.16289936E-09_JPRB, 0.16260772E-09_JPRB, 0.16230658E-09_JPRB, 0.16199753E-09_JPRB, 0.16168838E-09_JPRB, &
  & 0.16138924E-09_JPRB, 0.16110069E-09_JPRB, 0.16078018E-09_JPRB, 0.16022431E-09_JPRB /)

RGHG8(:,41, 2) = (/ &
  & 0.15886947E-09_JPRB, 0.15933568E-09_JPRB, 0.15961503E-09_JPRB, 0.15988505E-09_JPRB, 0.16018201E-09_JPRB, 0.16049452E-09_JPRB, &
  & 0.16079825E-09_JPRB, 0.16107719E-09_JPRB, 0.16132881E-09_JPRB, 0.16156573E-09_JPRB, 0.16180357E-09_JPRB, 0.16206622E-09_JPRB, &
  & 0.16238862E-09_JPRB, 0.16281128E-09_JPRB, 0.16337873E-09_JPRB, 0.16409202E-09_JPRB, 0.16488118E-09_JPRB, 0.16564632E-09_JPRB, &
  & 0.16629126E-09_JPRB, 0.16678256E-09_JPRB, 0.16713193E-09_JPRB, 0.16737277E-09_JPRB, 0.16754258E-09_JPRB, 0.16766322E-09_JPRB, &
  & 0.16775670E-09_JPRB, 0.16783080E-09_JPRB, 0.16789575E-09_JPRB, 0.16795543E-09_JPRB, 0.16801013E-09_JPRB, 0.16805725E-09_JPRB, &
  & 0.16809099E-09_JPRB, 0.16810738E-09_JPRB, 0.16810492E-09_JPRB, 0.16808477E-09_JPRB, 0.16805060E-09_JPRB, 0.16800730E-09_JPRB, &
  & 0.16795783E-09_JPRB, 0.16790223E-09_JPRB, 0.16783791E-09_JPRB, 0.16776003E-09_JPRB, 0.16766134E-09_JPRB, 0.16753196E-09_JPRB, &
  & 0.16736049E-09_JPRB, 0.16713661E-09_JPRB, 0.16685762E-09_JPRB, 0.16653608E-09_JPRB, 0.16618937E-09_JPRB, 0.16583464E-09_JPRB, &
  & 0.16548009E-09_JPRB, 0.16512751E-09_JPRB, 0.16478115E-09_JPRB, 0.16444926E-09_JPRB, 0.16413484E-09_JPRB, 0.16384466E-09_JPRB, &
  & 0.16357396E-09_JPRB, 0.16331703E-09_JPRB, 0.16306262E-09_JPRB, 0.16280331E-09_JPRB, 0.16253657E-09_JPRB, 0.16226828E-09_JPRB, &
  & 0.16200714E-09_JPRB, 0.16174977E-09_JPRB, 0.16146774E-09_JPRB, 0.16097204E-09_JPRB /)

RGHG8(:,42, 2) = (/ &
  & 0.15985559E-09_JPRB, 0.16026985E-09_JPRB, 0.16052434E-09_JPRB, 0.16077817E-09_JPRB, 0.16106048E-09_JPRB, 0.16135381E-09_JPRB, &
  & 0.16162927E-09_JPRB, 0.16187304E-09_JPRB, 0.16208920E-09_JPRB, 0.16228927E-09_JPRB, 0.16248967E-09_JPRB, 0.16271176E-09_JPRB, &
  & 0.16298451E-09_JPRB, 0.16335210E-09_JPRB, 0.16385805E-09_JPRB, 0.16451504E-09_JPRB, 0.16525545E-09_JPRB, 0.16595687E-09_JPRB, &
  & 0.16653673E-09_JPRB, 0.16695922E-09_JPRB, 0.16725689E-09_JPRB, 0.16746256E-09_JPRB, 0.16761020E-09_JPRB, 0.16771787E-09_JPRB, &
  & 0.16780341E-09_JPRB, 0.16787258E-09_JPRB, 0.16793482E-09_JPRB, 0.16799220E-09_JPRB, 0.16804581E-09_JPRB, 0.16809129E-09_JPRB, &
  & 0.16812347E-09_JPRB, 0.16813803E-09_JPRB, 0.16813420E-09_JPRB, 0.16811343E-09_JPRB, 0.16807980E-09_JPRB, 0.16803825E-09_JPRB, &
  & 0.16799190E-09_JPRB, 0.16794069E-09_JPRB, 0.16788226E-09_JPRB, 0.16781242E-09_JPRB, 0.16772454E-09_JPRB, 0.16761029E-09_JPRB, &
  & 0.16745935E-09_JPRB, 0.16726093E-09_JPRB, 0.16701221E-09_JPRB, 0.16672130E-09_JPRB, 0.16640711E-09_JPRB, 0.16608115E-09_JPRB, &
  & 0.16574911E-09_JPRB, 0.16541139E-09_JPRB, 0.16507445E-09_JPRB, 0.16474509E-09_JPRB, 0.16444129E-09_JPRB, 0.16416658E-09_JPRB, &
  & 0.16392132E-09_JPRB, 0.16369513E-09_JPRB, 0.16347654E-09_JPRB, 0.16325574E-09_JPRB, 0.16302959E-09_JPRB, 0.16280136E-09_JPRB, &
  & 0.16257604E-09_JPRB, 0.16235216E-09_JPRB, 0.16210018E-09_JPRB, 0.16166044E-09_JPRB /)

RGHG8(:,43, 2) = (/ &
  & 0.16074247E-09_JPRB, 0.16111315E-09_JPRB, 0.16134492E-09_JPRB, 0.16158214E-09_JPRB, 0.16184819E-09_JPRB, 0.16212187E-09_JPRB, &
  & 0.16237174E-09_JPRB, 0.16258643E-09_JPRB, 0.16277379E-09_JPRB, 0.16294441E-09_JPRB, 0.16311548E-09_JPRB, 0.16330425E-09_JPRB, &
  & 0.16353895E-09_JPRB, 0.16385750E-09_JPRB, 0.16431032E-09_JPRB, 0.16491056E-09_JPRB, 0.16559278E-09_JPRB, 0.16622961E-09_JPRB, &
  & 0.16673377E-09_JPRB, 0.16709779E-09_JPRB, 0.16735166E-09_JPRB, 0.16753066E-09_JPRB, 0.16766209E-09_JPRB, 0.16776122E-09_JPRB, &
  & 0.16784174E-09_JPRB, 0.16790863E-09_JPRB, 0.16796964E-09_JPRB, 0.16802679E-09_JPRB, 0.16807937E-09_JPRB, 0.16812396E-09_JPRB, &
  & 0.16815380E-09_JPRB, 0.16816606E-09_JPRB, 0.16816031E-09_JPRB, 0.16813834E-09_JPRB, 0.16810450E-09_JPRB, 0.16806403E-09_JPRB, &
  & 0.16801995E-09_JPRB, 0.16797225E-09_JPRB, 0.16791876E-09_JPRB, 0.16785567E-09_JPRB, 0.16777749E-09_JPRB, 0.16767672E-09_JPRB, &
  & 0.16754415E-09_JPRB, 0.16736923E-09_JPRB, 0.16714713E-09_JPRB, 0.16688596E-09_JPRB, 0.16660022E-09_JPRB, 0.16630283E-09_JPRB, &
  & 0.16599466E-09_JPRB, 0.16567549E-09_JPRB, 0.16534656E-09_JPRB, 0.16502669E-09_JPRB, 0.16473065E-09_JPRB, 0.16447431E-09_JPRB, &
  & 0.16425289E-09_JPRB, 0.16405492E-09_JPRB, 0.16386775E-09_JPRB, 0.16368130E-09_JPRB, 0.16349146E-09_JPRB, 0.16329989E-09_JPRB, &
  & 0.16310915E-09_JPRB, 0.16291501E-09_JPRB, 0.16269411E-09_JPRB, 0.16230244E-09_JPRB /)

RGHG8(:,44, 2) = (/ &
  & 0.16154221E-09_JPRB, 0.16187923E-09_JPRB, 0.16208737E-09_JPRB, 0.16230725E-09_JPRB, 0.16255518E-09_JPRB, 0.16280979E-09_JPRB, &
  & 0.16303689E-09_JPRB, 0.16323093E-09_JPRB, 0.16339462E-09_JPRB, 0.16354404E-09_JPRB, 0.16369070E-09_JPRB, 0.16385356E-09_JPRB, &
  & 0.16405594E-09_JPRB, 0.16433485E-09_JPRB, 0.16473732E-09_JPRB, 0.16528504E-09_JPRB, 0.16590260E-09_JPRB, 0.16646480E-09_JPRB, &
  & 0.16689908E-09_JPRB, 0.16720744E-09_JPRB, 0.16742607E-09_JPRB, 0.16758377E-09_JPRB, 0.16770366E-09_JPRB, 0.16779672E-09_JPRB, &
  & 0.16787453E-09_JPRB, 0.16794097E-09_JPRB, 0.16800226E-09_JPRB, 0.16805983E-09_JPRB, 0.16811277E-09_JPRB, 0.16815559E-09_JPRB, &
  & 0.16818311E-09_JPRB, 0.16819245E-09_JPRB, 0.16818413E-09_JPRB, 0.16816042E-09_JPRB, 0.16812587E-09_JPRB, 0.16808584E-09_JPRB, &
  & 0.16804341E-09_JPRB, 0.16799855E-09_JPRB, 0.16794918E-09_JPRB, 0.16789213E-09_JPRB, 0.16782262E-09_JPRB, 0.16773440E-09_JPRB, &
  & 0.16761906E-09_JPRB, 0.16746632E-09_JPRB, 0.16726971E-09_JPRB, 0.16703502E-09_JPRB, 0.16677779E-09_JPRB, 0.16650763E-09_JPRB, &
  & 0.16622516E-09_JPRB, 0.16592545E-09_JPRB, 0.16561366E-09_JPRB, 0.16530338E-09_JPRB, 0.16502395E-09_JPRB, 0.16478621E-09_JPRB, &
  & 0.16458786E-09_JPRB, 0.16441522E-09_JPRB, 0.16425437E-09_JPRB, 0.16409682E-09_JPRB, 0.16393785E-09_JPRB, 0.16377821E-09_JPRB, &
  & 0.16361801E-09_JPRB, 0.16345252E-09_JPRB, 0.16325871E-09_JPRB, 0.16291164E-09_JPRB /)

RGHG8(:,45, 2) = (/ &
  & 0.16227640E-09_JPRB, 0.16257259E-09_JPRB, 0.16276898E-09_JPRB, 0.16296595E-09_JPRB, 0.16319787E-09_JPRB, 0.16343332E-09_JPRB, &
  & 0.16364671E-09_JPRB, 0.16382208E-09_JPRB, 0.16397214E-09_JPRB, 0.16410322E-09_JPRB, 0.16423213E-09_JPRB, 0.16437299E-09_JPRB, &
  & 0.16454689E-09_JPRB, 0.16479153E-09_JPRB, 0.16514697E-09_JPRB, 0.16563717E-09_JPRB, 0.16618719E-09_JPRB, 0.16667000E-09_JPRB, &
  & 0.16703484E-09_JPRB, 0.16729607E-09_JPRB, 0.16748453E-09_JPRB, 0.16762647E-09_JPRB, 0.16773673E-09_JPRB, 0.16782689E-09_JPRB, &
  & 0.16790344E-09_JPRB, 0.16797055E-09_JPRB, 0.16803374E-09_JPRB, 0.16809260E-09_JPRB, 0.16814557E-09_JPRB, 0.16818717E-09_JPRB, &
  & 0.16821146E-09_JPRB, 0.16821744E-09_JPRB, 0.16820609E-09_JPRB, 0.16818016E-09_JPRB, 0.16814439E-09_JPRB, 0.16810434E-09_JPRB, &
  & 0.16806311E-09_JPRB, 0.16802046E-09_JPRB, 0.16797472E-09_JPRB, 0.16792294E-09_JPRB, 0.16786138E-09_JPRB, 0.16778498E-09_JPRB, &
  & 0.16768670E-09_JPRB, 0.16755622E-09_JPRB, 0.16738581E-09_JPRB, 0.16717845E-09_JPRB, 0.16694825E-09_JPRB, 0.16670559E-09_JPRB, &
  & 0.16644862E-09_JPRB, 0.16617303E-09_JPRB, 0.16587939E-09_JPRB, 0.16559100E-09_JPRB, 0.16532949E-09_JPRB, 0.16511575E-09_JPRB, &
  & 0.16493922E-09_JPRB, 0.16478849E-09_JPRB, 0.16465024E-09_JPRB, 0.16451571E-09_JPRB, 0.16438209E-09_JPRB, 0.16424877E-09_JPRB, &
  & 0.16411468E-09_JPRB, 0.16397390E-09_JPRB, 0.16380637E-09_JPRB, 0.16350005E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART3',1,ZHOOK_HANDLE)
END SUBROUTINE PART3




SUBROUTINE PART4
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART4',0,ZHOOK_HANDLE)



RGHG8(:,46, 2) = (/ &
  & 0.16294269E-09_JPRB, 0.16322328E-09_JPRB, 0.16339212E-09_JPRB, 0.16358001E-09_JPRB, 0.16379065E-09_JPRB, 0.16401455E-09_JPRB, &
  & 0.16421448E-09_JPRB, 0.16438265E-09_JPRB, 0.16451925E-09_JPRB, 0.16463847E-09_JPRB, 0.16475186E-09_JPRB, 0.16487280E-09_JPRB, &
  & 0.16502474E-09_JPRB, 0.16522997E-09_JPRB, 0.16554542E-09_JPRB, 0.16597125E-09_JPRB, 0.16644339E-09_JPRB, 0.16684754E-09_JPRB, &
  & 0.16714818E-09_JPRB, 0.16736698E-09_JPRB, 0.16753141E-09_JPRB, 0.16765955E-09_JPRB, 0.16776455E-09_JPRB, 0.16785209E-09_JPRB, &
  & 0.16792921E-09_JPRB, 0.16799909E-09_JPRB, 0.16806395E-09_JPRB, 0.16812532E-09_JPRB, 0.16817883E-09_JPRB, 0.16821800E-09_JPRB, &
  & 0.16823896E-09_JPRB, 0.16824103E-09_JPRB, 0.16822625E-09_JPRB, 0.16819762E-09_JPRB, 0.16816032E-09_JPRB, 0.16811996E-09_JPRB, &
  & 0.16807944E-09_JPRB, 0.16803872E-09_JPRB, 0.16799591E-09_JPRB, 0.16794895E-09_JPRB, 0.16789470E-09_JPRB, 0.16782978E-09_JPRB, &
  & 0.16774847E-09_JPRB, 0.16764161E-09_JPRB, 0.16749956E-09_JPRB, 0.16732220E-09_JPRB, 0.16712144E-09_JPRB, 0.16690668E-09_JPRB, &
  & 0.16667775E-09_JPRB, 0.16642651E-09_JPRB, 0.16615981E-09_JPRB, 0.16589163E-09_JPRB, 0.16566015E-09_JPRB, 0.16546683E-09_JPRB, &
  & 0.16531412E-09_JPRB, 0.16518259E-09_JPRB, 0.16506263E-09_JPRB, 0.16494739E-09_JPRB, 0.16483362E-09_JPRB, 0.16472139E-09_JPRB, &
  & 0.16460872E-09_JPRB, 0.16448949E-09_JPRB, 0.16434465E-09_JPRB, 0.16407697E-09_JPRB /)

RGHG8(:,47, 2) = (/ &
  & 0.16357096E-09_JPRB, 0.16381999E-09_JPRB, 0.16398506E-09_JPRB, 0.16415171E-09_JPRB, 0.16435316E-09_JPRB, 0.16456539E-09_JPRB, &
  & 0.16476026E-09_JPRB, 0.16492113E-09_JPRB, 0.16504997E-09_JPRB, 0.16515865E-09_JPRB, 0.16525761E-09_JPRB, 0.16536388E-09_JPRB, &
  & 0.16548830E-09_JPRB, 0.16566984E-09_JPRB, 0.16592391E-09_JPRB, 0.16628991E-09_JPRB, 0.16667429E-09_JPRB, 0.16699921E-09_JPRB, &
  & 0.16724190E-09_JPRB, 0.16742450E-09_JPRB, 0.16756788E-09_JPRB, 0.16768636E-09_JPRB, 0.16778619E-09_JPRB, 0.16787433E-09_JPRB, &
  & 0.16795330E-09_JPRB, 0.16802576E-09_JPRB, 0.16809523E-09_JPRB, 0.16815815E-09_JPRB, 0.16821172E-09_JPRB, 0.16824864E-09_JPRB, &
  & 0.16826530E-09_JPRB, 0.16826308E-09_JPRB, 0.16824442E-09_JPRB, 0.16821289E-09_JPRB, 0.16817370E-09_JPRB, 0.16813276E-09_JPRB, &
  & 0.16809283E-09_JPRB, 0.16805352E-09_JPRB, 0.16801346E-09_JPRB, 0.16797064E-09_JPRB, 0.16792343E-09_JPRB, 0.16786966E-09_JPRB, &
  & 0.16780585E-09_JPRB, 0.16772424E-09_JPRB, 0.16761494E-09_JPRB, 0.16747358E-09_JPRB, 0.16730693E-09_JPRB, 0.16712512E-09_JPRB, &
  & 0.16692520E-09_JPRB, 0.16670411E-09_JPRB, 0.16646066E-09_JPRB, 0.16622488E-09_JPRB, 0.16601309E-09_JPRB, 0.16584926E-09_JPRB, &
  & 0.16571415E-09_JPRB, 0.16560109E-09_JPRB, 0.16549705E-09_JPRB, 0.16539672E-09_JPRB, 0.16529905E-09_JPRB, 0.16520339E-09_JPRB, &
  & 0.16510775E-09_JPRB, 0.16500581E-09_JPRB, 0.16488123E-09_JPRB, 0.16464764E-09_JPRB /)

RGHG8(:,48, 2) = (/ &
  & 0.16415645E-09_JPRB, 0.16439297E-09_JPRB, 0.16454091E-09_JPRB, 0.16470240E-09_JPRB, 0.16489238E-09_JPRB, 0.16509935E-09_JPRB, &
  & 0.16529207E-09_JPRB, 0.16544818E-09_JPRB, 0.16557099E-09_JPRB, 0.16566802E-09_JPRB, 0.16575641E-09_JPRB, 0.16584428E-09_JPRB, &
  & 0.16595243E-09_JPRB, 0.16609208E-09_JPRB, 0.16630657E-09_JPRB, 0.16658103E-09_JPRB, 0.16688184E-09_JPRB, 0.16712931E-09_JPRB, &
  & 0.16731985E-09_JPRB, 0.16747057E-09_JPRB, 0.16759669E-09_JPRB, 0.16770629E-09_JPRB, 0.16780473E-09_JPRB, 0.16789342E-09_JPRB, &
  & 0.16797587E-09_JPRB, 0.16805357E-09_JPRB, 0.16812590E-09_JPRB, 0.16819207E-09_JPRB, 0.16824485E-09_JPRB, 0.16827810E-09_JPRB, &
  & 0.16829041E-09_JPRB, 0.16828357E-09_JPRB, 0.16826082E-09_JPRB, 0.16822589E-09_JPRB, 0.16818484E-09_JPRB, 0.16814322E-09_JPRB, &
  & 0.16810353E-09_JPRB, 0.16806553E-09_JPRB, 0.16802763E-09_JPRB, 0.16798882E-09_JPRB, 0.16794817E-09_JPRB, 0.16790558E-09_JPRB, &
  & 0.16785970E-09_JPRB, 0.16780542E-09_JPRB, 0.16773347E-09_JPRB, 0.16763618E-09_JPRB, 0.16751442E-09_JPRB, 0.16737106E-09_JPRB, &
  & 0.16720780E-09_JPRB, 0.16701643E-09_JPRB, 0.16680483E-09_JPRB, 0.16659056E-09_JPRB, 0.16641018E-09_JPRB, 0.16626403E-09_JPRB, &
  & 0.16614971E-09_JPRB, 0.16605070E-09_JPRB, 0.16595966E-09_JPRB, 0.16587176E-09_JPRB, 0.16578589E-09_JPRB, 0.16570269E-09_JPRB, &
  & 0.16561987E-09_JPRB, 0.16553128E-09_JPRB, 0.16542245E-09_JPRB, 0.16521688E-09_JPRB /)

RGHG8(:,49, 2) = (/ &
  & 0.16471280E-09_JPRB, 0.16493509E-09_JPRB, 0.16507830E-09_JPRB, 0.16523261E-09_JPRB, 0.16541944E-09_JPRB, 0.16562701E-09_JPRB, &
  & 0.16581951E-09_JPRB, 0.16597350E-09_JPRB, 0.16608651E-09_JPRB, 0.16617456E-09_JPRB, 0.16624854E-09_JPRB, 0.16632232E-09_JPRB, &
  & 0.16640481E-09_JPRB, 0.16651339E-09_JPRB, 0.16665999E-09_JPRB, 0.16685581E-09_JPRB, 0.16706189E-09_JPRB, 0.16724086E-09_JPRB, &
  & 0.16738536E-09_JPRB, 0.16750801E-09_JPRB, 0.16761872E-09_JPRB, 0.16772200E-09_JPRB, 0.16781904E-09_JPRB, 0.16791127E-09_JPRB, &
  & 0.16799852E-09_JPRB, 0.16808116E-09_JPRB, 0.16815883E-09_JPRB, 0.16822614E-09_JPRB, 0.16827732E-09_JPRB, 0.16830667E-09_JPRB, &
  & 0.16831407E-09_JPRB, 0.16830239E-09_JPRB, 0.16827528E-09_JPRB, 0.16823713E-09_JPRB, 0.16819401E-09_JPRB, 0.16815160E-09_JPRB, &
  & 0.16811209E-09_JPRB, 0.16807503E-09_JPRB, 0.16803917E-09_JPRB, 0.16800393E-09_JPRB, 0.16796985E-09_JPRB, 0.16793851E-09_JPRB, &
  & 0.16791120E-09_JPRB, 0.16788571E-09_JPRB, 0.16785510E-09_JPRB, 0.16780963E-09_JPRB, 0.16774276E-09_JPRB, 0.16765155E-09_JPRB, &
  & 0.16753053E-09_JPRB, 0.16737745E-09_JPRB, 0.16719696E-09_JPRB, 0.16701354E-09_JPRB, 0.16685614E-09_JPRB, 0.16673159E-09_JPRB, &
  & 0.16663237E-09_JPRB, 0.16654586E-09_JPRB, 0.16646461E-09_JPRB, 0.16638520E-09_JPRB, 0.16630750E-09_JPRB, 0.16623226E-09_JPRB, &
  & 0.16615766E-09_JPRB, 0.16607776E-09_JPRB, 0.16597926E-09_JPRB, 0.16579309E-09_JPRB /)

RGHG8(:,50, 2) = (/ &
  & 0.16524221E-09_JPRB, 0.16545684E-09_JPRB, 0.16559434E-09_JPRB, 0.16574905E-09_JPRB, 0.16593901E-09_JPRB, 0.16615398E-09_JPRB, &
  & 0.16634827E-09_JPRB, 0.16649593E-09_JPRB, 0.16659690E-09_JPRB, 0.16666880E-09_JPRB, 0.16672586E-09_JPRB, 0.16677819E-09_JPRB, &
  & 0.16683185E-09_JPRB, 0.16689856E-09_JPRB, 0.16698051E-09_JPRB, 0.16709459E-09_JPRB, 0.16721920E-09_JPRB, 0.16733663E-09_JPRB, &
  & 0.16744107E-09_JPRB, 0.16753934E-09_JPRB, 0.16763629E-09_JPRB, 0.16773388E-09_JPRB, 0.16783182E-09_JPRB, 0.16792795E-09_JPRB, &
  & 0.16802182E-09_JPRB, 0.16811062E-09_JPRB, 0.16819235E-09_JPRB, 0.16826042E-09_JPRB, 0.16830919E-09_JPRB, 0.16833382E-09_JPRB, &
  & 0.16833625E-09_JPRB, 0.16831966E-09_JPRB, 0.16828816E-09_JPRB, 0.16824662E-09_JPRB, 0.16820159E-09_JPRB, 0.16815832E-09_JPRB, &
  & 0.16811881E-09_JPRB, 0.16808258E-09_JPRB, 0.16804846E-09_JPRB, 0.16801674E-09_JPRB, 0.16798904E-09_JPRB, 0.16796917E-09_JPRB, &
  & 0.16796095E-09_JPRB, 0.16796513E-09_JPRB, 0.16797638E-09_JPRB, 0.16798439E-09_JPRB, 0.16797724E-09_JPRB, 0.16794471E-09_JPRB, &
  & 0.16787841E-09_JPRB, 0.16777436E-09_JPRB, 0.16763747E-09_JPRB, 0.16749434E-09_JPRB, 0.16736393E-09_JPRB, 0.16726365E-09_JPRB, &
  & 0.16717744E-09_JPRB, 0.16710226E-09_JPRB, 0.16702874E-09_JPRB, 0.16695444E-09_JPRB, 0.16688098E-09_JPRB, 0.16680941E-09_JPRB, &
  & 0.16673812E-09_JPRB, 0.16666173E-09_JPRB, 0.16656740E-09_JPRB, 0.16638918E-09_JPRB /)

RGHG8(:,51, 2) = (/ &
  & 0.16574916E-09_JPRB, 0.16594971E-09_JPRB, 0.16609261E-09_JPRB, 0.16624570E-09_JPRB, 0.16644797E-09_JPRB, 0.16666686E-09_JPRB, &
  & 0.16685978E-09_JPRB, 0.16698498E-09_JPRB, 0.16706166E-09_JPRB, 0.16710917E-09_JPRB, 0.16714227E-09_JPRB, 0.16716779E-09_JPRB, &
  & 0.16719215E-09_JPRB, 0.16721566E-09_JPRB, 0.16724939E-09_JPRB, 0.16729174E-09_JPRB, 0.16735367E-09_JPRB, 0.16741976E-09_JPRB, &
  & 0.16749042E-09_JPRB, 0.16756668E-09_JPRB, 0.16765120E-09_JPRB, 0.16774414E-09_JPRB, 0.16784306E-09_JPRB, 0.16794537E-09_JPRB, &
  & 0.16804572E-09_JPRB, 0.16814156E-09_JPRB, 0.16822609E-09_JPRB, 0.16829441E-09_JPRB, 0.16833933E-09_JPRB, 0.16835963E-09_JPRB, &
  & 0.16835711E-09_JPRB, 0.16833553E-09_JPRB, 0.16829962E-09_JPRB, 0.16825477E-09_JPRB, 0.16820778E-09_JPRB, 0.16816365E-09_JPRB, &
  & 0.16812411E-09_JPRB, 0.16808849E-09_JPRB, 0.16805603E-09_JPRB, 0.16802768E-09_JPRB, 0.16800655E-09_JPRB, 0.16799846E-09_JPRB, &
  & 0.16800973E-09_JPRB, 0.16804309E-09_JPRB, 0.16809276E-09_JPRB, 0.16814675E-09_JPRB, 0.16818925E-09_JPRB, 0.16820900E-09_JPRB, &
  & 0.16819801E-09_JPRB, 0.16815235E-09_JPRB, 0.16807772E-09_JPRB, 0.16798597E-09_JPRB, 0.16790311E-09_JPRB, 0.16782674E-09_JPRB, &
  & 0.16776419E-09_JPRB, 0.16770188E-09_JPRB, 0.16763813E-09_JPRB, 0.16757118E-09_JPRB, 0.16750133E-09_JPRB, 0.16743207E-09_JPRB, &
  & 0.16736221E-09_JPRB, 0.16728649E-09_JPRB, 0.16719176E-09_JPRB, 0.16701442E-09_JPRB /)

RGHG8(:,52, 2) = (/ &
  & 0.16621139E-09_JPRB, 0.16642188E-09_JPRB, 0.16654969E-09_JPRB, 0.16671778E-09_JPRB, 0.16691350E-09_JPRB, 0.16713028E-09_JPRB, &
  & 0.16728210E-09_JPRB, 0.16736984E-09_JPRB, 0.16741292E-09_JPRB, 0.16743541E-09_JPRB, 0.16744701E-09_JPRB, 0.16745316E-09_JPRB, &
  & 0.16745524E-09_JPRB, 0.16745469E-09_JPRB, 0.16745293E-09_JPRB, 0.16745455E-09_JPRB, 0.16746654E-09_JPRB, 0.16749344E-09_JPRB, &
  & 0.16753489E-09_JPRB, 0.16759261E-09_JPRB, 0.16766574E-09_JPRB, 0.16775445E-09_JPRB, 0.16785554E-09_JPRB, 0.16796306E-09_JPRB, &
  & 0.16807152E-09_JPRB, 0.16817210E-09_JPRB, 0.16826011E-09_JPRB, 0.16832637E-09_JPRB, 0.16836833E-09_JPRB, 0.16838406E-09_JPRB, &
  & 0.16837688E-09_JPRB, 0.16835022E-09_JPRB, 0.16830996E-09_JPRB, 0.16826181E-09_JPRB, 0.16821293E-09_JPRB, 0.16816801E-09_JPRB, &
  & 0.16812830E-09_JPRB, 0.16809333E-09_JPRB, 0.16806245E-09_JPRB, 0.16803753E-09_JPRB, 0.16802311E-09_JPRB, 0.16802715E-09_JPRB, &
  & 0.16805798E-09_JPRB, 0.16811796E-09_JPRB, 0.16820059E-09_JPRB, 0.16828569E-09_JPRB, 0.16836119E-09_JPRB, 0.16841427E-09_JPRB, &
  & 0.16844191E-09_JPRB, 0.16844359E-09_JPRB, 0.16842185E-09_JPRB, 0.16838617E-09_JPRB, 0.16834410E-09_JPRB, 0.16830656E-09_JPRB, &
  & 0.16826719E-09_JPRB, 0.16822801E-09_JPRB, 0.16818366E-09_JPRB, 0.16813201E-09_JPRB, 0.16807671E-09_JPRB, 0.16801868E-09_JPRB, &
  & 0.16795795E-09_JPRB, 0.16789030E-09_JPRB, 0.16780315E-09_JPRB, 0.16763252E-09_JPRB /)

RGHG8(:,53, 2) = (/ &
  & 0.16664685E-09_JPRB, 0.16682797E-09_JPRB, 0.16697649E-09_JPRB, 0.16711997E-09_JPRB, 0.16731172E-09_JPRB, 0.16747395E-09_JPRB, &
  & 0.16757687E-09_JPRB, 0.16762167E-09_JPRB, 0.16764062E-09_JPRB, 0.16764723E-09_JPRB, 0.16764781E-09_JPRB, 0.16764452E-09_JPRB, &
  & 0.16763690E-09_JPRB, 0.16762632E-09_JPRB, 0.16760612E-09_JPRB, 0.16758583E-09_JPRB, 0.16756445E-09_JPRB, 0.16755949E-09_JPRB, &
  & 0.16757669E-09_JPRB, 0.16761761E-09_JPRB, 0.16768173E-09_JPRB, 0.16776694E-09_JPRB, 0.16786972E-09_JPRB, 0.16798329E-09_JPRB, &
  & 0.16809702E-09_JPRB, 0.16820335E-09_JPRB, 0.16829196E-09_JPRB, 0.16835765E-09_JPRB, 0.16839589E-09_JPRB, 0.16840752E-09_JPRB, &
  & 0.16839589E-09_JPRB, 0.16836424E-09_JPRB, 0.16831944E-09_JPRB, 0.16826807E-09_JPRB, 0.16821738E-09_JPRB, 0.16817153E-09_JPRB, &
  & 0.16813183E-09_JPRB, 0.16809747E-09_JPRB, 0.16806838E-09_JPRB, 0.16804697E-09_JPRB, 0.16803951E-09_JPRB, 0.16805593E-09_JPRB, &
  & 0.16810511E-09_JPRB, 0.16818999E-09_JPRB, 0.16829410E-09_JPRB, 0.16840243E-09_JPRB, 0.16849289E-09_JPRB, 0.16856319E-09_JPRB, &
  & 0.16861032E-09_JPRB, 0.16863624E-09_JPRB, 0.16864375E-09_JPRB, 0.16863783E-09_JPRB, 0.16862531E-09_JPRB, 0.16860902E-09_JPRB, &
  & 0.16859222E-09_JPRB, 0.16857207E-09_JPRB, 0.16854751E-09_JPRB, 0.16851814E-09_JPRB, 0.16848331E-09_JPRB, 0.16844592E-09_JPRB, &
  & 0.16840551E-09_JPRB, 0.16835854E-09_JPRB, 0.16829553E-09_JPRB, 0.16816273E-09_JPRB /)

RGHG8(:,54, 2) = (/ &
  & 0.16700756E-09_JPRB, 0.16720815E-09_JPRB, 0.16731924E-09_JPRB, 0.16746324E-09_JPRB, 0.16759948E-09_JPRB, 0.16771150E-09_JPRB, &
  & 0.16776328E-09_JPRB, 0.16778326E-09_JPRB, 0.16778841E-09_JPRB, 0.16778767E-09_JPRB, 0.16778373E-09_JPRB, 0.16777685E-09_JPRB, &
  & 0.16776741E-09_JPRB, 0.16775054E-09_JPRB, 0.16773019E-09_JPRB, 0.16769053E-09_JPRB, 0.16765250E-09_JPRB, 0.16762054E-09_JPRB, &
  & 0.16761631E-09_JPRB, 0.16764325E-09_JPRB, 0.16769949E-09_JPRB, 0.16778259E-09_JPRB, 0.16788725E-09_JPRB, 0.16800450E-09_JPRB, &
  & 0.16812393E-09_JPRB, 0.16823321E-09_JPRB, 0.16832374E-09_JPRB, 0.16838757E-09_JPRB, 0.16842314E-09_JPRB, 0.16843058E-09_JPRB, &
  & 0.16841425E-09_JPRB, 0.16837796E-09_JPRB, 0.16832857E-09_JPRB, 0.16827412E-09_JPRB, 0.16822146E-09_JPRB, 0.16817489E-09_JPRB, &
  & 0.16813514E-09_JPRB, 0.16810159E-09_JPRB, 0.16807442E-09_JPRB, 0.16805694E-09_JPRB, 0.16805676E-09_JPRB, 0.16808492E-09_JPRB, &
  & 0.16815198E-09_JPRB, 0.16825422E-09_JPRB, 0.16837898E-09_JPRB, 0.16849545E-09_JPRB, 0.16859689E-09_JPRB, 0.16867303E-09_JPRB, &
  & 0.16872760E-09_JPRB, 0.16876325E-09_JPRB, 0.16878282E-09_JPRB, 0.16879001E-09_JPRB, 0.16878980E-09_JPRB, 0.16878590E-09_JPRB, &
  & 0.16877943E-09_JPRB, 0.16877094E-09_JPRB, 0.16875949E-09_JPRB, 0.16874403E-09_JPRB, 0.16872587E-09_JPRB, 0.16870545E-09_JPRB, &
  & 0.16868326E-09_JPRB, 0.16865846E-09_JPRB, 0.16862677E-09_JPRB, 0.16856636E-09_JPRB /)

RGHG8(:,55, 2) = (/ &
  & 0.16733730E-09_JPRB, 0.16749788E-09_JPRB, 0.16761698E-09_JPRB, 0.16771232E-09_JPRB, 0.16780788E-09_JPRB, 0.16786693E-09_JPRB, &
  & 0.16789066E-09_JPRB, 0.16789554E-09_JPRB, 0.16789420E-09_JPRB, 0.16789034E-09_JPRB, 0.16788468E-09_JPRB, 0.16787745E-09_JPRB, &
  & 0.16786639E-09_JPRB, 0.16785232E-09_JPRB, 0.16782387E-09_JPRB, 0.16778934E-09_JPRB, 0.16772889E-09_JPRB, 0.16767837E-09_JPRB, &
  & 0.16765500E-09_JPRB, 0.16766959E-09_JPRB, 0.16772009E-09_JPRB, 0.16780133E-09_JPRB, 0.16790765E-09_JPRB, 0.16802811E-09_JPRB, &
  & 0.16815108E-09_JPRB, 0.16826376E-09_JPRB, 0.16835486E-09_JPRB, 0.16841797E-09_JPRB, 0.16845038E-09_JPRB, 0.16845383E-09_JPRB, &
  & 0.16843277E-09_JPRB, 0.16839186E-09_JPRB, 0.16833827E-09_JPRB, 0.16828039E-09_JPRB, 0.16822596E-09_JPRB, 0.16817861E-09_JPRB, &
  & 0.16813888E-09_JPRB, 0.16810631E-09_JPRB, 0.16808142E-09_JPRB, 0.16806823E-09_JPRB, 0.16807532E-09_JPRB, 0.16811508E-09_JPRB, &
  & 0.16819533E-09_JPRB, 0.16831567E-09_JPRB, 0.16844826E-09_JPRB, 0.16857726E-09_JPRB, 0.16867997E-09_JPRB, 0.16875909E-09_JPRB, &
  & 0.16881596E-09_JPRB, 0.16885407E-09_JPRB, 0.16887758E-09_JPRB, 0.16889024E-09_JPRB, 0.16889534E-09_JPRB, 0.16889665E-09_JPRB, &
  & 0.16889561E-09_JPRB, 0.16889279E-09_JPRB, 0.16888788E-09_JPRB, 0.16888083E-09_JPRB, 0.16887133E-09_JPRB, 0.16886043E-09_JPRB, &
  & 0.16884816E-09_JPRB, 0.16883346E-09_JPRB, 0.16881357E-09_JPRB, 0.16876850E-09_JPRB /)

RGHG8(:,56, 2) = (/ &
  & 0.16759390E-09_JPRB, 0.16775387E-09_JPRB, 0.16783079E-09_JPRB, 0.16790026E-09_JPRB, 0.16795310E-09_JPRB, 0.16798031E-09_JPRB, &
  & 0.16798590E-09_JPRB, 0.16798352E-09_JPRB, 0.16797924E-09_JPRB, 0.16797394E-09_JPRB, 0.16796806E-09_JPRB, 0.16796037E-09_JPRB, &
  & 0.16795088E-09_JPRB, 0.16793439E-09_JPRB, 0.16791299E-09_JPRB, 0.16786525E-09_JPRB, 0.16780649E-09_JPRB, 0.16773340E-09_JPRB, &
  & 0.16769364E-09_JPRB, 0.16769798E-09_JPRB, 0.16774346E-09_JPRB, 0.16782394E-09_JPRB, 0.16793077E-09_JPRB, 0.16805411E-09_JPRB, &
  & 0.16817997E-09_JPRB, 0.16829499E-09_JPRB, 0.16838718E-09_JPRB, 0.16844878E-09_JPRB, 0.16847851E-09_JPRB, 0.16847791E-09_JPRB, &
  & 0.16845217E-09_JPRB, 0.16840652E-09_JPRB, 0.16834881E-09_JPRB, 0.16828787E-09_JPRB, 0.16823146E-09_JPRB, 0.16818322E-09_JPRB, &
  & 0.16814376E-09_JPRB, 0.16811233E-09_JPRB, 0.16809001E-09_JPRB, 0.16808140E-09_JPRB, 0.16809584E-09_JPRB, 0.16814504E-09_JPRB, &
  & 0.16823860E-09_JPRB, 0.16836732E-09_JPRB, 0.16851409E-09_JPRB, 0.16864411E-09_JPRB, 0.16875246E-09_JPRB, 0.16883138E-09_JPRB, &
  & 0.16888735E-09_JPRB, 0.16892543E-09_JPRB, 0.16894983E-09_JPRB, 0.16896370E-09_JPRB, 0.16897131E-09_JPRB, 0.16897481E-09_JPRB, &
  & 0.16897626E-09_JPRB, 0.16897619E-09_JPRB, 0.16897472E-09_JPRB, 0.16897161E-09_JPRB, 0.16896706E-09_JPRB, 0.16896136E-09_JPRB, &
  & 0.16895478E-09_JPRB, 0.16894744E-09_JPRB, 0.16893842E-09_JPRB, 0.16892321E-09_JPRB /)

RGHG8(:,57, 2) = (/ &
  & 0.16781526E-09_JPRB, 0.16793603E-09_JPRB, 0.16799692E-09_JPRB, 0.16803765E-09_JPRB, 0.16806249E-09_JPRB, 0.16806966E-09_JPRB, &
  & 0.16806564E-09_JPRB, 0.16805975E-09_JPRB, 0.16805375E-09_JPRB, 0.16804817E-09_JPRB, 0.16804198E-09_JPRB, 0.16803499E-09_JPRB, &
  & 0.16802482E-09_JPRB, 0.16801148E-09_JPRB, 0.16798450E-09_JPRB, 0.16794700E-09_JPRB, 0.16787002E-09_JPRB, 0.16778876E-09_JPRB, &
  & 0.16773387E-09_JPRB, 0.16772947E-09_JPRB, 0.16777102E-09_JPRB, 0.16784989E-09_JPRB, 0.16795829E-09_JPRB, 0.16808271E-09_JPRB, &
  & 0.16821153E-09_JPRB, 0.16832828E-09_JPRB, 0.16842065E-09_JPRB, 0.16848130E-09_JPRB, 0.16850787E-09_JPRB, 0.16850345E-09_JPRB, &
  & 0.16847321E-09_JPRB, 0.16842304E-09_JPRB, 0.16836132E-09_JPRB, 0.16829718E-09_JPRB, 0.16823871E-09_JPRB, 0.16818980E-09_JPRB, &
  & 0.16815047E-09_JPRB, 0.16812049E-09_JPRB, 0.16810092E-09_JPRB, 0.16809705E-09_JPRB, 0.16811831E-09_JPRB, 0.16817671E-09_JPRB, &
  & 0.16827802E-09_JPRB, 0.16841847E-09_JPRB, 0.16856772E-09_JPRB, 0.16870783E-09_JPRB, 0.16881539E-09_JPRB, 0.16889487E-09_JPRB, &
  & 0.16894959E-09_JPRB, 0.16898610E-09_JPRB, 0.16900953E-09_JPRB, 0.16902399E-09_JPRB, 0.16903186E-09_JPRB, 0.16903645E-09_JPRB, &
  & 0.16903889E-09_JPRB, 0.16904009E-09_JPRB, 0.16904017E-09_JPRB, 0.16903914E-09_JPRB, 0.16903687E-09_JPRB, 0.16903361E-09_JPRB, &
  & 0.16902951E-09_JPRB, 0.16902424E-09_JPRB, 0.16901719E-09_JPRB, 0.16900228E-09_JPRB /)

RGHG8(:,58, 2) = (/ &
  & 0.16798754E-09_JPRB, 0.16808455E-09_JPRB, 0.16812274E-09_JPRB, 0.16814375E-09_JPRB, 0.16815248E-09_JPRB, 0.16814794E-09_JPRB, &
  & 0.16813904E-09_JPRB, 0.16813066E-09_JPRB, 0.16812431E-09_JPRB, 0.16811827E-09_JPRB, 0.16811240E-09_JPRB, 0.16810507E-09_JPRB, &
  & 0.16809601E-09_JPRB, 0.16808054E-09_JPRB, 0.16805843E-09_JPRB, 0.16800954E-09_JPRB, 0.16793859E-09_JPRB, 0.16784066E-09_JPRB, &
  & 0.16777647E-09_JPRB, 0.16776529E-09_JPRB, 0.16780312E-09_JPRB, 0.16788125E-09_JPRB, 0.16798940E-09_JPRB, 0.16811631E-09_JPRB, &
  & 0.16824618E-09_JPRB, 0.16836416E-09_JPRB, 0.16845671E-09_JPRB, 0.16851545E-09_JPRB, 0.16853924E-09_JPRB, 0.16853109E-09_JPRB, &
  & 0.16849681E-09_JPRB, 0.16844245E-09_JPRB, 0.16837662E-09_JPRB, 0.16830937E-09_JPRB, 0.16824886E-09_JPRB, 0.16819898E-09_JPRB, &
  & 0.16816019E-09_JPRB, 0.16813155E-09_JPRB, 0.16811494E-09_JPRB, 0.16811577E-09_JPRB, 0.16814369E-09_JPRB, 0.16820910E-09_JPRB, &
  & 0.16831869E-09_JPRB, 0.16846269E-09_JPRB, 0.16862169E-09_JPRB, 0.16876153E-09_JPRB, 0.16887433E-09_JPRB, 0.16895252E-09_JPRB, &
  & 0.16900567E-09_JPRB, 0.16904042E-09_JPRB, 0.16906290E-09_JPRB, 0.16907639E-09_JPRB, 0.16908458E-09_JPRB, 0.16908916E-09_JPRB, &
  & 0.16909202E-09_JPRB, 0.16909370E-09_JPRB, 0.16909443E-09_JPRB, 0.16909424E-09_JPRB, 0.16909305E-09_JPRB, 0.16909092E-09_JPRB, &
  & 0.16908794E-09_JPRB, 0.16908411E-09_JPRB, 0.16907852E-09_JPRB, 0.16906751E-09_JPRB /)

RGHG8(:,59, 2) = (/ &
  & 0.16813442E-09_JPRB, 0.16820413E-09_JPRB, 0.16822536E-09_JPRB, 0.16823451E-09_JPRB, 0.16823298E-09_JPRB, 0.16822216E-09_JPRB, &
  & 0.16821022E-09_JPRB, 0.16820118E-09_JPRB, 0.16819401E-09_JPRB, 0.16818809E-09_JPRB, 0.16818182E-09_JPRB, 0.16817482E-09_JPRB, &
  & 0.16816465E-09_JPRB, 0.16815045E-09_JPRB, 0.16812274E-09_JPRB, 0.16807880E-09_JPRB, 0.16799342E-09_JPRB, 0.16789363E-09_JPRB, &
  & 0.16782206E-09_JPRB, 0.16780616E-09_JPRB, 0.16784114E-09_JPRB, 0.16791776E-09_JPRB, 0.16802690E-09_JPRB, 0.16815417E-09_JPRB, &
  & 0.16828540E-09_JPRB, 0.16840358E-09_JPRB, 0.16849512E-09_JPRB, 0.16855241E-09_JPRB, 0.16857322E-09_JPRB, 0.16856176E-09_JPRB, &
  & 0.16852383E-09_JPRB, 0.16846563E-09_JPRB, 0.16839605E-09_JPRB, 0.16832541E-09_JPRB, 0.16826272E-09_JPRB, 0.16821222E-09_JPRB, &
  & 0.16817363E-09_JPRB, 0.16814657E-09_JPRB, 0.16813281E-09_JPRB, 0.16813820E-09_JPRB, 0.16817198E-09_JPRB, 0.16824415E-09_JPRB, &
  & 0.16835855E-09_JPRB, 0.16850846E-09_JPRB, 0.16866780E-09_JPRB, 0.16881510E-09_JPRB, 0.16892700E-09_JPRB, 0.16900648E-09_JPRB, &
  & 0.16905791E-09_JPRB, 0.16909138E-09_JPRB, 0.16911228E-09_JPRB, 0.16912538E-09_JPRB, 0.16913278E-09_JPRB, 0.16913737E-09_JPRB, &
  & 0.16914013E-09_JPRB, 0.16914185E-09_JPRB, 0.16914271E-09_JPRB, 0.16914276E-09_JPRB, 0.16914187E-09_JPRB, 0.16914016E-09_JPRB, &
  & 0.16913772E-09_JPRB, 0.16913428E-09_JPRB, 0.16912940E-09_JPRB, 0.16911852E-09_JPRB /)

RGHG8(:,60, 2) = (/ &
  & 0.16829355E-09_JPRB, 0.16831159E-09_JPRB, 0.16831719E-09_JPRB, 0.16831699E-09_JPRB, 0.16830953E-09_JPRB, 0.16829656E-09_JPRB, &
  & 0.16828305E-09_JPRB, 0.16827284E-09_JPRB, 0.16826557E-09_JPRB, 0.16825911E-09_JPRB, 0.16825294E-09_JPRB, 0.16824522E-09_JPRB, &
  & 0.16823519E-09_JPRB, 0.16821811E-09_JPRB, 0.16819102E-09_JPRB, 0.16813631E-09_JPRB, 0.16805024E-09_JPRB, 0.16794495E-09_JPRB, &
  & 0.16787176E-09_JPRB, 0.16785311E-09_JPRB, 0.16788566E-09_JPRB, 0.16796148E-09_JPRB, 0.16807032E-09_JPRB, 0.16819833E-09_JPRB, &
  & 0.16832938E-09_JPRB, 0.16844681E-09_JPRB, 0.16853725E-09_JPRB, 0.16859222E-09_JPRB, 0.16861043E-09_JPRB, 0.16859607E-09_JPRB, &
  & 0.16855518E-09_JPRB, 0.16849364E-09_JPRB, 0.16842047E-09_JPRB, 0.16834664E-09_JPRB, 0.16828176E-09_JPRB, 0.16823029E-09_JPRB, &
  & 0.16819207E-09_JPRB, 0.16816640E-09_JPRB, 0.16815543E-09_JPRB, 0.16816495E-09_JPRB, 0.16820423E-09_JPRB, 0.16828193E-09_JPRB, &
  & 0.16840095E-09_JPRB, 0.16855255E-09_JPRB, 0.16871574E-09_JPRB, 0.16886183E-09_JPRB, 0.16897793E-09_JPRB, 0.16905649E-09_JPRB, &
  & 0.16910778E-09_JPRB, 0.16913994E-09_JPRB, 0.16916005E-09_JPRB, 0.16917198E-09_JPRB, 0.16917914E-09_JPRB, 0.16918322E-09_JPRB, &
  & 0.16918573E-09_JPRB, 0.16918719E-09_JPRB, 0.16918777E-09_JPRB, 0.16918761E-09_JPRB, 0.16918662E-09_JPRB, 0.16918492E-09_JPRB, &
  & 0.16918247E-09_JPRB, 0.16917936E-09_JPRB, 0.16917473E-09_JPRB, 0.16916572E-09_JPRB /)

RGHG8(:,61, 2) = (/ &
  & 0.16838198E-09_JPRB, 0.16839619E-09_JPRB, 0.16839777E-09_JPRB, 0.16839463E-09_JPRB, 0.16838655E-09_JPRB, 0.16837226E-09_JPRB, &
  & 0.16835837E-09_JPRB, 0.16834770E-09_JPRB, 0.16833976E-09_JPRB, 0.16833328E-09_JPRB, 0.16832644E-09_JPRB, 0.16831864E-09_JPRB, &
  & 0.16830679E-09_JPRB, 0.16828888E-09_JPRB, 0.16825483E-09_JPRB, 0.16819675E-09_JPRB, 0.16810289E-09_JPRB, 0.16799920E-09_JPRB, &
  & 0.16792687E-09_JPRB, 0.16790688E-09_JPRB, 0.16793784E-09_JPRB, 0.16801294E-09_JPRB, 0.16812134E-09_JPRB, 0.16824894E-09_JPRB, &
  & 0.16837898E-09_JPRB, 0.16849494E-09_JPRB, 0.16858315E-09_JPRB, 0.16863591E-09_JPRB, 0.16865159E-09_JPRB, 0.16863486E-09_JPRB, &
  & 0.16859172E-09_JPRB, 0.16852757E-09_JPRB, 0.16845132E-09_JPRB, 0.16837433E-09_JPRB, 0.16830715E-09_JPRB, 0.16825466E-09_JPRB, &
  & 0.16821658E-09_JPRB, 0.16819209E-09_JPRB, 0.16818354E-09_JPRB, 0.16819687E-09_JPRB, 0.16824092E-09_JPRB, 0.16832351E-09_JPRB, &
  & 0.16844609E-09_JPRB, 0.16859923E-09_JPRB, 0.16876150E-09_JPRB, 0.16890955E-09_JPRB, 0.16902438E-09_JPRB, 0.16910498E-09_JPRB, &
  & 0.16915561E-09_JPRB, 0.16918750E-09_JPRB, 0.16920647E-09_JPRB, 0.16921788E-09_JPRB, 0.16922413E-09_JPRB, 0.16922781E-09_JPRB, &
  & 0.16922982E-09_JPRB, 0.16923080E-09_JPRB, 0.16923093E-09_JPRB, 0.16923027E-09_JPRB, 0.16922883E-09_JPRB, 0.16922677E-09_JPRB, &
  & 0.16922411E-09_JPRB, 0.16922062E-09_JPRB, 0.16921603E-09_JPRB, 0.16920634E-09_JPRB /)

RGHG8(:,62, 2) = (/ &
  & 0.16846760E-09_JPRB, 0.16847643E-09_JPRB, 0.16847612E-09_JPRB, 0.16847228E-09_JPRB, 0.16846372E-09_JPRB, 0.16845100E-09_JPRB, &
  & 0.16843671E-09_JPRB, 0.16842529E-09_JPRB, 0.16841714E-09_JPRB, 0.16841004E-09_JPRB, 0.16840332E-09_JPRB, 0.16839445E-09_JPRB, &
  & 0.16838211E-09_JPRB, 0.16835987E-09_JPRB, 0.16832208E-09_JPRB, 0.16825479E-09_JPRB, 0.16815929E-09_JPRB, 0.16805918E-09_JPRB, &
  & 0.16798904E-09_JPRB, 0.16796883E-09_JPRB, 0.16799888E-09_JPRB, 0.16807319E-09_JPRB, 0.16818083E-09_JPRB, 0.16830688E-09_JPRB, &
  & 0.16843504E-09_JPRB, 0.16854826E-09_JPRB, 0.16863387E-09_JPRB, 0.16868394E-09_JPRB, 0.16869739E-09_JPRB, 0.16867895E-09_JPRB, &
  & 0.16863438E-09_JPRB, 0.16856853E-09_JPRB, 0.16848969E-09_JPRB, 0.16840999E-09_JPRB, 0.16834031E-09_JPRB, 0.16828670E-09_JPRB, &
  & 0.16824828E-09_JPRB, 0.16822467E-09_JPRB, 0.16821811E-09_JPRB, 0.16823470E-09_JPRB, 0.16828296E-09_JPRB, 0.16836975E-09_JPRB, &
  & 0.16849495E-09_JPRB, 0.16864878E-09_JPRB, 0.16880987E-09_JPRB, 0.16895531E-09_JPRB, 0.16907079E-09_JPRB, 0.16915086E-09_JPRB, &
  & 0.16920258E-09_JPRB, 0.16923393E-09_JPRB, 0.16925267E-09_JPRB, 0.16926308E-09_JPRB, 0.16926888E-09_JPRB, 0.16927185E-09_JPRB, &
  & 0.16927330E-09_JPRB, 0.16927368E-09_JPRB, 0.16927312E-09_JPRB, 0.16927174E-09_JPRB, 0.16926965E-09_JPRB, 0.16926702E-09_JPRB, &
  & 0.16926380E-09_JPRB, 0.16926002E-09_JPRB, 0.16925489E-09_JPRB, 0.16924527E-09_JPRB /)

RGHG8(:,63, 2) = (/ &
  & 0.16854673E-09_JPRB, 0.16855486E-09_JPRB, 0.16855430E-09_JPRB, 0.16855053E-09_JPRB, 0.16854329E-09_JPRB, 0.16853119E-09_JPRB, &
  & 0.16851756E-09_JPRB, 0.16850546E-09_JPRB, 0.16849663E-09_JPRB, 0.16848967E-09_JPRB, 0.16848248E-09_JPRB, 0.16847404E-09_JPRB, &
  & 0.16845947E-09_JPRB, 0.16843510E-09_JPRB, 0.16838984E-09_JPRB, 0.16831847E-09_JPRB, 0.16822346E-09_JPRB, 0.16812744E-09_JPRB, &
  & 0.16806007E-09_JPRB, 0.16804030E-09_JPRB, 0.16806986E-09_JPRB, 0.16814340E-09_JPRB, 0.16824930E-09_JPRB, 0.16837330E-09_JPRB, &
  & 0.16849797E-09_JPRB, 0.16860785E-09_JPRB, 0.16868992E-09_JPRB, 0.16873712E-09_JPRB, 0.16874852E-09_JPRB, 0.16872899E-09_JPRB, &
  & 0.16868400E-09_JPRB, 0.16861733E-09_JPRB, 0.16853698E-09_JPRB, 0.16845474E-09_JPRB, 0.16838303E-09_JPRB, 0.16832766E-09_JPRB, &
  & 0.16828880E-09_JPRB, 0.16826544E-09_JPRB, 0.16826039E-09_JPRB, 0.16827972E-09_JPRB, 0.16833136E-09_JPRB, 0.16842150E-09_JPRB, &
  & 0.16854872E-09_JPRB, 0.16870196E-09_JPRB, 0.16886055E-09_JPRB, 0.16900335E-09_JPRB, 0.16911615E-09_JPRB, 0.16919670E-09_JPRB, &
  & 0.16924838E-09_JPRB, 0.16928020E-09_JPRB, 0.16929841E-09_JPRB, 0.16930847E-09_JPRB, 0.16931348E-09_JPRB, 0.16931585E-09_JPRB, &
  & 0.16931662E-09_JPRB, 0.16931620E-09_JPRB, 0.16931476E-09_JPRB, 0.16931249E-09_JPRB, 0.16930957E-09_JPRB, 0.16930617E-09_JPRB, &
  & 0.16930229E-09_JPRB, 0.16929770E-09_JPRB, 0.16929194E-09_JPRB, 0.16928078E-09_JPRB /)

RGHG8(:,64, 2) = (/ &
  & 0.16862522E-09_JPRB, 0.16863347E-09_JPRB, 0.16863333E-09_JPRB, 0.16863033E-09_JPRB, 0.16862386E-09_JPRB, 0.16861333E-09_JPRB, &
  & 0.16859969E-09_JPRB, 0.16858728E-09_JPRB, 0.16857793E-09_JPRB, 0.16857069E-09_JPRB, 0.16856426E-09_JPRB, 0.16855545E-09_JPRB, &
  & 0.16854071E-09_JPRB, 0.16851212E-09_JPRB, 0.16846360E-09_JPRB, 0.16838987E-09_JPRB, 0.16829696E-09_JPRB, 0.16820489E-09_JPRB, &
  & 0.16814058E-09_JPRB, 0.16812189E-09_JPRB, 0.16815134E-09_JPRB, 0.16822345E-09_JPRB, 0.16832721E-09_JPRB, 0.16844727E-09_JPRB, &
  & 0.16856785E-09_JPRB, 0.16867302E-09_JPRB, 0.16875100E-09_JPRB, 0.16879505E-09_JPRB, 0.16880461E-09_JPRB, 0.16878461E-09_JPRB, &
  & 0.16874001E-09_JPRB, 0.16867371E-09_JPRB, 0.16859274E-09_JPRB, 0.16850923E-09_JPRB, 0.16843540E-09_JPRB, 0.16837887E-09_JPRB, &
  & 0.16833886E-09_JPRB, 0.16831549E-09_JPRB, 0.16831136E-09_JPRB, 0.16833268E-09_JPRB, 0.16838703E-09_JPRB, 0.16847945E-09_JPRB, &
  & 0.16860753E-09_JPRB, 0.16875924E-09_JPRB, 0.16891434E-09_JPRB, 0.16905267E-09_JPRB, 0.16916289E-09_JPRB, 0.16924166E-09_JPRB, &
  & 0.16929382E-09_JPRB, 0.16932568E-09_JPRB, 0.16934398E-09_JPRB, 0.16935359E-09_JPRB, 0.16935814E-09_JPRB, 0.16935979E-09_JPRB, &
  & 0.16935976E-09_JPRB, 0.16935839E-09_JPRB, 0.16935593E-09_JPRB, 0.16935264E-09_JPRB, 0.16934874E-09_JPRB, 0.16934440E-09_JPRB, &
  & 0.16933957E-09_JPRB, 0.16933412E-09_JPRB, 0.16932704E-09_JPRB, 0.16931401E-09_JPRB /)

RGHG8(:,65, 2) = (/ &
  & 0.16870211E-09_JPRB, 0.16871229E-09_JPRB, 0.16871321E-09_JPRB, 0.16871116E-09_JPRB, 0.16870587E-09_JPRB, 0.16869611E-09_JPRB, &
  & 0.16868336E-09_JPRB, 0.16866994E-09_JPRB, 0.16866079E-09_JPRB, 0.16865370E-09_JPRB, 0.16864798E-09_JPRB, 0.16864006E-09_JPRB, &
  & 0.16862423E-09_JPRB, 0.16859424E-09_JPRB, 0.16854367E-09_JPRB, 0.16846999E-09_JPRB, 0.16837962E-09_JPRB, 0.16829164E-09_JPRB, &
  & 0.16823079E-09_JPRB, 0.16821380E-09_JPRB, 0.16824300E-09_JPRB, 0.16831329E-09_JPRB, 0.16841327E-09_JPRB, 0.16852861E-09_JPRB, &
  & 0.16864320E-09_JPRB, 0.16874285E-09_JPRB, 0.16881596E-09_JPRB, 0.16885655E-09_JPRB, 0.16886444E-09_JPRB, 0.16884441E-09_JPRB, &
  & 0.16880099E-09_JPRB, 0.16873605E-09_JPRB, 0.16865599E-09_JPRB, 0.16857221E-09_JPRB, 0.16849762E-09_JPRB, 0.16843986E-09_JPRB, &
  & 0.16839921E-09_JPRB, 0.16837541E-09_JPRB, 0.16837182E-09_JPRB, 0.16839452E-09_JPRB, 0.16845056E-09_JPRB, 0.16854430E-09_JPRB, &
  & 0.16867165E-09_JPRB, 0.16882061E-09_JPRB, 0.16897100E-09_JPRB, 0.16910440E-09_JPRB, 0.16921038E-09_JPRB, 0.16928745E-09_JPRB, &
  & 0.16933870E-09_JPRB, 0.16937073E-09_JPRB, 0.16938909E-09_JPRB, 0.16939851E-09_JPRB, 0.16940266E-09_JPRB, 0.16940369E-09_JPRB, &
  & 0.16940284E-09_JPRB, 0.16940048E-09_JPRB, 0.16939686E-09_JPRB, 0.16939253E-09_JPRB, 0.16938764E-09_JPRB, 0.16938229E-09_JPRB, &
  & 0.16937637E-09_JPRB, 0.16936941E-09_JPRB, 0.16936062E-09_JPRB, 0.16934393E-09_JPRB /)

RGHG8(:,66, 2) = (/ &
  & 0.16877821E-09_JPRB, 0.16879143E-09_JPRB, 0.16879390E-09_JPRB, 0.16879317E-09_JPRB, 0.16878891E-09_JPRB, 0.16878021E-09_JPRB, &
  & 0.16876756E-09_JPRB, 0.16875475E-09_JPRB, 0.16874536E-09_JPRB, 0.16873941E-09_JPRB, 0.16873464E-09_JPRB, 0.16872755E-09_JPRB, &
  & 0.16871153E-09_JPRB, 0.16868096E-09_JPRB, 0.16863021E-09_JPRB, 0.16855779E-09_JPRB, 0.16847079E-09_JPRB, 0.16838740E-09_JPRB, &
  & 0.16833065E-09_JPRB, 0.16831539E-09_JPRB, 0.16834413E-09_JPRB, 0.16841133E-09_JPRB, 0.16850653E-09_JPRB, 0.16861532E-09_JPRB, &
  & 0.16872312E-09_JPRB, 0.16881609E-09_JPRB, 0.16888370E-09_JPRB, 0.16892063E-09_JPRB, 0.16892679E-09_JPRB, 0.16890703E-09_JPRB, &
  & 0.16886537E-09_JPRB, 0.16880282E-09_JPRB, 0.16872477E-09_JPRB, 0.16864228E-09_JPRB, 0.16856797E-09_JPRB, 0.16851036E-09_JPRB, &
  & 0.16846932E-09_JPRB, 0.16844545E-09_JPRB, 0.16844215E-09_JPRB, 0.16846564E-09_JPRB, 0.16852253E-09_JPRB, 0.16861613E-09_JPRB, &
  & 0.16874153E-09_JPRB, 0.16888596E-09_JPRB, 0.16903054E-09_JPRB, 0.16915823E-09_JPRB, 0.16925962E-09_JPRB, 0.16933367E-09_JPRB, &
  & 0.16938384E-09_JPRB, 0.16941554E-09_JPRB, 0.16943372E-09_JPRB, 0.16944315E-09_JPRB, 0.16944698E-09_JPRB, 0.16944751E-09_JPRB, &
  & 0.16944593E-09_JPRB, 0.16944257E-09_JPRB, 0.16943796E-09_JPRB, 0.16943258E-09_JPRB, 0.16942675E-09_JPRB, 0.16942044E-09_JPRB, &
  & 0.16941321E-09_JPRB, 0.16940470E-09_JPRB, 0.16939319E-09_JPRB, 0.16937156E-09_JPRB /)

RGHG8(:,67, 2) = (/ &
  & 0.16885501E-09_JPRB, 0.16887164E-09_JPRB, 0.16887569E-09_JPRB, 0.16887639E-09_JPRB, 0.16887339E-09_JPRB, 0.16886553E-09_JPRB, &
  & 0.16885364E-09_JPRB, 0.16884084E-09_JPRB, 0.16883292E-09_JPRB, 0.16882795E-09_JPRB, 0.16882458E-09_JPRB, 0.16881817E-09_JPRB, &
  & 0.16880253E-09_JPRB, 0.16877234E-09_JPRB, 0.16872247E-09_JPRB, 0.16865251E-09_JPRB, 0.16856980E-09_JPRB, 0.16849161E-09_JPRB, &
  & 0.16843889E-09_JPRB, 0.16842526E-09_JPRB, 0.16845264E-09_JPRB, 0.16851592E-09_JPRB, 0.16860488E-09_JPRB, 0.16870629E-09_JPRB, &
  & 0.16880609E-09_JPRB, 0.16889187E-09_JPRB, 0.16895346E-09_JPRB, 0.16898660E-09_JPRB, 0.16899110E-09_JPRB, 0.16897186E-09_JPRB, &
  & 0.16893234E-09_JPRB, 0.16887285E-09_JPRB, 0.16879793E-09_JPRB, 0.16871783E-09_JPRB, 0.16864547E-09_JPRB, 0.16858895E-09_JPRB, &
  & 0.16854859E-09_JPRB, 0.16852504E-09_JPRB, 0.16852214E-09_JPRB, 0.16854598E-09_JPRB, 0.16860294E-09_JPRB, 0.16869516E-09_JPRB, &
  & 0.16881686E-09_JPRB, 0.16895532E-09_JPRB, 0.16909318E-09_JPRB, 0.16921388E-09_JPRB, 0.16931058E-09_JPRB, 0.16938105E-09_JPRB, &
  & 0.16942930E-09_JPRB, 0.16946011E-09_JPRB, 0.16947810E-09_JPRB, 0.16948727E-09_JPRB, 0.16949099E-09_JPRB, 0.16949117E-09_JPRB, &
  & 0.16948910E-09_JPRB, 0.16948506E-09_JPRB, 0.16947951E-09_JPRB, 0.16947341E-09_JPRB, 0.16946676E-09_JPRB, 0.16945959E-09_JPRB, &
  & 0.16945129E-09_JPRB, 0.16944057E-09_JPRB, 0.16942597E-09_JPRB, 0.16939652E-09_JPRB /)

RGHG8(:,68, 2) = (/ &
  & 0.16892877E-09_JPRB, 0.16895091E-09_JPRB, 0.16895774E-09_JPRB, 0.16896048E-09_JPRB, 0.16895908E-09_JPRB, 0.16895237E-09_JPRB, &
  & 0.16894140E-09_JPRB, 0.16892962E-09_JPRB, 0.16892313E-09_JPRB, 0.16891982E-09_JPRB, 0.16891755E-09_JPRB, 0.16891204E-09_JPRB, &
  & 0.16889687E-09_JPRB, 0.16886766E-09_JPRB, 0.16881962E-09_JPRB, 0.16875316E-09_JPRB, 0.16867555E-09_JPRB, 0.16860272E-09_JPRB, &
  & 0.16855387E-09_JPRB, 0.16854115E-09_JPRB, 0.16856648E-09_JPRB, 0.16862473E-09_JPRB, 0.16870676E-09_JPRB, 0.16879995E-09_JPRB, &
  & 0.16889155E-09_JPRB, 0.16896956E-09_JPRB, 0.16902525E-09_JPRB, 0.16905444E-09_JPRB, 0.16905735E-09_JPRB, 0.16903887E-09_JPRB, &
  & 0.16900180E-09_JPRB, 0.16894589E-09_JPRB, 0.16887486E-09_JPRB, 0.16879832E-09_JPRB, 0.16872895E-09_JPRB, 0.16867477E-09_JPRB, &
  & 0.16863577E-09_JPRB, 0.16861318E-09_JPRB, 0.16861082E-09_JPRB, 0.16863488E-09_JPRB, 0.16869106E-09_JPRB, 0.16878079E-09_JPRB, &
  & 0.16889748E-09_JPRB, 0.16902883E-09_JPRB, 0.16915810E-09_JPRB, 0.16927230E-09_JPRB, 0.16936255E-09_JPRB, 0.16942955E-09_JPRB, &
  & 0.16947527E-09_JPRB, 0.16950485E-09_JPRB, 0.16952216E-09_JPRB, 0.16953117E-09_JPRB, 0.16953475E-09_JPRB, 0.16953476E-09_JPRB, &
  & 0.16953253E-09_JPRB, 0.16952803E-09_JPRB, 0.16952204E-09_JPRB, 0.16951537E-09_JPRB, 0.16950835E-09_JPRB, 0.16950064E-09_JPRB, &
  & 0.16949125E-09_JPRB, 0.16947893E-09_JPRB, 0.16946000E-09_JPRB, 0.16942167E-09_JPRB /)

RGHG8(:,69, 2) = (/ &
  & 0.16900228E-09_JPRB, 0.16903134E-09_JPRB, 0.16904102E-09_JPRB, 0.16904622E-09_JPRB, 0.16904672E-09_JPRB, 0.16904142E-09_JPRB, &
  & 0.16903165E-09_JPRB, 0.16902146E-09_JPRB, 0.16901677E-09_JPRB, 0.16901498E-09_JPRB, 0.16901358E-09_JPRB, 0.16900895E-09_JPRB, &
  & 0.16899443E-09_JPRB, 0.16896666E-09_JPRB, 0.16892109E-09_JPRB, 0.16885887E-09_JPRB, 0.16878664E-09_JPRB, 0.16871930E-09_JPRB, &
  & 0.16867367E-09_JPRB, 0.16866136E-09_JPRB, 0.16868386E-09_JPRB, 0.16873666E-09_JPRB, 0.16881112E-09_JPRB, 0.16889601E-09_JPRB, &
  & 0.16897890E-09_JPRB, 0.16904937E-09_JPRB, 0.16909892E-09_JPRB, 0.16912440E-09_JPRB, 0.16912599E-09_JPRB, 0.16910835E-09_JPRB, &
  & 0.16907420E-09_JPRB, 0.16902224E-09_JPRB, 0.16895585E-09_JPRB, 0.16888366E-09_JPRB, 0.16881815E-09_JPRB, 0.16876700E-09_JPRB, &
  & 0.16873020E-09_JPRB, 0.16870901E-09_JPRB, 0.16870741E-09_JPRB, 0.16873140E-09_JPRB, 0.16878632E-09_JPRB, 0.16887242E-09_JPRB, &
  & 0.16898304E-09_JPRB, 0.16910584E-09_JPRB, 0.16922660E-09_JPRB, 0.16933197E-09_JPRB, 0.16941679E-09_JPRB, 0.16947881E-09_JPRB, &
  & 0.16952208E-09_JPRB, 0.16954997E-09_JPRB, 0.16956653E-09_JPRB, 0.16957512E-09_JPRB, 0.16957863E-09_JPRB, 0.16957863E-09_JPRB, &
  & 0.16957641E-09_JPRB, 0.16957183E-09_JPRB, 0.16956572E-09_JPRB, 0.16955910E-09_JPRB, 0.16955180E-09_JPRB, 0.16954395E-09_JPRB, &
  & 0.16953414E-09_JPRB, 0.16952016E-09_JPRB, 0.16949768E-09_JPRB, 0.16944897E-09_JPRB /)

RGHG8(:,70, 2) = (/ &
  & 0.16907571E-09_JPRB, 0.16911272E-09_JPRB, 0.16912641E-09_JPRB, 0.16913437E-09_JPRB, 0.16913702E-09_JPRB, 0.16913325E-09_JPRB, &
  & 0.16912517E-09_JPRB, 0.16911667E-09_JPRB, 0.16911385E-09_JPRB, 0.16911338E-09_JPRB, 0.16911254E-09_JPRB, 0.16910839E-09_JPRB, &
  & 0.16909464E-09_JPRB, 0.16906848E-09_JPRB, 0.16902604E-09_JPRB, 0.16896828E-09_JPRB, 0.16890177E-09_JPRB, 0.16883957E-09_JPRB, &
  & 0.16879705E-09_JPRB, 0.16878463E-09_JPRB, 0.16880403E-09_JPRB, 0.16885082E-09_JPRB, 0.16891757E-09_JPRB, 0.16899362E-09_JPRB, &
  & 0.16906809E-09_JPRB, 0.16913088E-09_JPRB, 0.16917462E-09_JPRB, 0.16919655E-09_JPRB, 0.16919702E-09_JPRB, 0.16918060E-09_JPRB, &
  & 0.16914943E-09_JPRB, 0.16910198E-09_JPRB, 0.16904068E-09_JPRB, 0.16897372E-09_JPRB, 0.16891269E-09_JPRB, 0.16886542E-09_JPRB, &
  & 0.16883116E-09_JPRB, 0.16881174E-09_JPRB, 0.16881095E-09_JPRB, 0.16883470E-09_JPRB, 0.16888764E-09_JPRB, 0.16896931E-09_JPRB, &
  & 0.16907298E-09_JPRB, 0.16918650E-09_JPRB, 0.16929735E-09_JPRB, 0.16939457E-09_JPRB, 0.16947177E-09_JPRB, 0.16952949E-09_JPRB, &
  & 0.16956937E-09_JPRB, 0.16959562E-09_JPRB, 0.16961114E-09_JPRB, 0.16961940E-09_JPRB, 0.16962286E-09_JPRB, 0.16962300E-09_JPRB, &
  & 0.16962107E-09_JPRB, 0.16961675E-09_JPRB, 0.16961095E-09_JPRB, 0.16960452E-09_JPRB, 0.16959745E-09_JPRB, 0.16958970E-09_JPRB, &
  & 0.16957986E-09_JPRB, 0.16956522E-09_JPRB, 0.16954009E-09_JPRB, 0.16948348E-09_JPRB /)

RGHG8(:,71, 2) = (/ &
  & 0.16915072E-09_JPRB, 0.16919761E-09_JPRB, 0.16921484E-09_JPRB, 0.16922569E-09_JPRB, 0.16923035E-09_JPRB, 0.16922824E-09_JPRB, &
  & 0.16922186E-09_JPRB, 0.16921545E-09_JPRB, 0.16921416E-09_JPRB, 0.16921445E-09_JPRB, 0.16921382E-09_JPRB, 0.16920987E-09_JPRB, &
  & 0.16919691E-09_JPRB, 0.16917255E-09_JPRB, 0.16913332E-09_JPRB, 0.16908031E-09_JPRB, 0.16901931E-09_JPRB, 0.16896252E-09_JPRB, &
  & 0.16892282E-09_JPRB, 0.16891027E-09_JPRB, 0.16892629E-09_JPRB, 0.16896695E-09_JPRB, 0.16902560E-09_JPRB, 0.16909298E-09_JPRB, &
  & 0.16915876E-09_JPRB, 0.16921410E-09_JPRB, 0.16925213E-09_JPRB, 0.16927074E-09_JPRB, 0.16927042E-09_JPRB, 0.16925539E-09_JPRB, &
  & 0.16922759E-09_JPRB, 0.16918489E-09_JPRB, 0.16912939E-09_JPRB, 0.16906787E-09_JPRB, 0.16901233E-09_JPRB, 0.16896926E-09_JPRB, &
  & 0.16893813E-09_JPRB, 0.16892070E-09_JPRB, 0.16892071E-09_JPRB, 0.16894394E-09_JPRB, 0.16899425E-09_JPRB, 0.16907084E-09_JPRB, &
  & 0.16916626E-09_JPRB, 0.16927028E-09_JPRB, 0.16937063E-09_JPRB, 0.16945816E-09_JPRB, 0.16952856E-09_JPRB, 0.16958049E-09_JPRB, &
  & 0.16961725E-09_JPRB, 0.16964144E-09_JPRB, 0.16965598E-09_JPRB, 0.16966380E-09_JPRB, 0.16966729E-09_JPRB, 0.16966774E-09_JPRB, &
  & 0.16966628E-09_JPRB, 0.16966255E-09_JPRB, 0.16965741E-09_JPRB, 0.16965150E-09_JPRB, 0.16964481E-09_JPRB, 0.16963757E-09_JPRB, &
  & 0.16962802E-09_JPRB, 0.16961346E-09_JPRB, 0.16958722E-09_JPRB, 0.16952645E-09_JPRB /)

RGHG8(:,72, 2) = (/ &
  & 0.16922949E-09_JPRB, 0.16928625E-09_JPRB, 0.16930729E-09_JPRB, 0.16932039E-09_JPRB, 0.16932655E-09_JPRB, 0.16932583E-09_JPRB, &
  & 0.16932136E-09_JPRB, 0.16931678E-09_JPRB, 0.16931662E-09_JPRB, 0.16931724E-09_JPRB, 0.16931656E-09_JPRB, 0.16931233E-09_JPRB, &
  & 0.16930041E-09_JPRB, 0.16927768E-09_JPRB, 0.16924179E-09_JPRB, 0.16919359E-09_JPRB, 0.16913831E-09_JPRB, 0.16908672E-09_JPRB, &
  & 0.16905026E-09_JPRB, 0.16903767E-09_JPRB, 0.16905027E-09_JPRB, 0.16908458E-09_JPRB, 0.16913521E-09_JPRB, 0.16919360E-09_JPRB, &
  & 0.16925081E-09_JPRB, 0.16929887E-09_JPRB, 0.16933137E-09_JPRB, 0.16934694E-09_JPRB, 0.16934613E-09_JPRB, 0.16933274E-09_JPRB, &
  & 0.16930835E-09_JPRB, 0.16927081E-09_JPRB, 0.16922122E-09_JPRB, 0.16916625E-09_JPRB, 0.16911644E-09_JPRB, 0.16907829E-09_JPRB, &
  & 0.16905044E-09_JPRB, 0.16903523E-09_JPRB, 0.16903605E-09_JPRB, 0.16905845E-09_JPRB, 0.16910562E-09_JPRB, 0.16917565E-09_JPRB, &
  & 0.16926294E-09_JPRB, 0.16935553E-09_JPRB, 0.16944515E-09_JPRB, 0.16952340E-09_JPRB, 0.16958544E-09_JPRB, 0.16963204E-09_JPRB, &
  & 0.16966513E-09_JPRB, 0.16968721E-09_JPRB, 0.16970059E-09_JPRB, 0.16970800E-09_JPRB, 0.16971154E-09_JPRB, 0.16971230E-09_JPRB, &
  & 0.16971147E-09_JPRB, 0.16970847E-09_JPRB, 0.16970418E-09_JPRB, 0.16969902E-09_JPRB, 0.16969298E-09_JPRB, 0.16968633E-09_JPRB, &
  & 0.16967752E-09_JPRB, 0.16966351E-09_JPRB, 0.16963726E-09_JPRB, 0.16957433E-09_JPRB /)

RGHG8(:,73, 2) = (/ &
  & 0.16932111E-09_JPRB, 0.16938180E-09_JPRB, 0.16940375E-09_JPRB, 0.16941745E-09_JPRB, 0.16942422E-09_JPRB, 0.16942459E-09_JPRB, &
  & 0.16942163E-09_JPRB, 0.16941878E-09_JPRB, 0.16941924E-09_JPRB, 0.16941989E-09_JPRB, 0.16941901E-09_JPRB, 0.16941501E-09_JPRB, &
  & 0.16940342E-09_JPRB, 0.16938291E-09_JPRB, 0.16935026E-09_JPRB, 0.16930665E-09_JPRB, 0.16925736E-09_JPRB, 0.16921115E-09_JPRB, &
  & 0.16917837E-09_JPRB, 0.16916595E-09_JPRB, 0.16917524E-09_JPRB, 0.16920337E-09_JPRB, 0.16924588E-09_JPRB, 0.16929556E-09_JPRB, &
  & 0.16934429E-09_JPRB, 0.16938503E-09_JPRB, 0.16941228E-09_JPRB, 0.16942511E-09_JPRB, 0.16942400E-09_JPRB, 0.16941230E-09_JPRB, &
  & 0.16939156E-09_JPRB, 0.16935912E-09_JPRB, 0.16931614E-09_JPRB, 0.16926778E-09_JPRB, 0.16922450E-09_JPRB, 0.16919133E-09_JPRB, &
  & 0.16916733E-09_JPRB, 0.16915443E-09_JPRB, 0.16915602E-09_JPRB, 0.16917726E-09_JPRB, 0.16922032E-09_JPRB, 0.16928363E-09_JPRB, &
  & 0.16936032E-09_JPRB, 0.16944218E-09_JPRB, 0.16952041E-09_JPRB, 0.16958794E-09_JPRB, 0.16964287E-09_JPRB, 0.16968330E-09_JPRB, &
  & 0.16971251E-09_JPRB, 0.16973237E-09_JPRB, 0.16974450E-09_JPRB, 0.16975125E-09_JPRB, 0.16975492E-09_JPRB, 0.16975599E-09_JPRB, &
  & 0.16975568E-09_JPRB, 0.16975345E-09_JPRB, 0.16975013E-09_JPRB, 0.16974568E-09_JPRB, 0.16974046E-09_JPRB, 0.16973459E-09_JPRB, &
  & 0.16972669E-09_JPRB, 0.16971374E-09_JPRB, 0.16968833E-09_JPRB, 0.16962597E-09_JPRB /)

RGHG8(:,74, 2) = (/ &
  & 0.16941597E-09_JPRB, 0.16947972E-09_JPRB, 0.16950111E-09_JPRB, 0.16951482E-09_JPRB, 0.16952141E-09_JPRB, 0.16952234E-09_JPRB, &
  & 0.16952066E-09_JPRB, 0.16951895E-09_JPRB, 0.16951973E-09_JPRB, 0.16952045E-09_JPRB, 0.16951962E-09_JPRB, 0.16951540E-09_JPRB, &
  & 0.16950531E-09_JPRB, 0.16948634E-09_JPRB, 0.16945730E-09_JPRB, 0.16941876E-09_JPRB, 0.16937526E-09_JPRB, 0.16933493E-09_JPRB, &
  & 0.16930615E-09_JPRB, 0.16929430E-09_JPRB, 0.16930056E-09_JPRB, 0.16932272E-09_JPRB, 0.16935742E-09_JPRB, 0.16939858E-09_JPRB, &
  & 0.16943885E-09_JPRB, 0.16947266E-09_JPRB, 0.16949472E-09_JPRB, 0.16950502E-09_JPRB, 0.16950390E-09_JPRB, 0.16949399E-09_JPRB, &
  & 0.16947679E-09_JPRB, 0.16944968E-09_JPRB, 0.16941343E-09_JPRB, 0.16937232E-09_JPRB, 0.16933568E-09_JPRB, 0.16930780E-09_JPRB, &
  & 0.16928775E-09_JPRB, 0.16927726E-09_JPRB, 0.16927953E-09_JPRB, 0.16929913E-09_JPRB, 0.16933768E-09_JPRB, 0.16939242E-09_JPRB, &
  & 0.16945920E-09_JPRB, 0.16952847E-09_JPRB, 0.16959471E-09_JPRB, 0.16965314E-09_JPRB, 0.16969912E-09_JPRB, 0.16973395E-09_JPRB, &
  & 0.16975919E-09_JPRB, 0.16977648E-09_JPRB, 0.16978716E-09_JPRB, 0.16979339E-09_JPRB, 0.16979687E-09_JPRB, 0.16979812E-09_JPRB, &
  & 0.16979823E-09_JPRB, 0.16979665E-09_JPRB, 0.16979419E-09_JPRB, 0.16979056E-09_JPRB, 0.16978616E-09_JPRB, 0.16978119E-09_JPRB, &
  & 0.16977443E-09_JPRB, 0.16976290E-09_JPRB, 0.16973915E-09_JPRB, 0.16967952E-09_JPRB /)

RGHG8(:,75, 2) = (/ &
  & 0.16951289E-09_JPRB, 0.16957680E-09_JPRB, 0.16959750E-09_JPRB, 0.16961006E-09_JPRB, 0.16961620E-09_JPRB, 0.16961740E-09_JPRB, &
  & 0.16961660E-09_JPRB, 0.16961565E-09_JPRB, 0.16961663E-09_JPRB, 0.16961732E-09_JPRB, 0.16961646E-09_JPRB, 0.16961299E-09_JPRB, &
  & 0.16960347E-09_JPRB, 0.16958730E-09_JPRB, 0.16956195E-09_JPRB, 0.16952863E-09_JPRB, 0.16949180E-09_JPRB, 0.16945755E-09_JPRB, &
  & 0.16943318E-09_JPRB, 0.16942228E-09_JPRB, 0.16942599E-09_JPRB, 0.16944275E-09_JPRB, 0.16947012E-09_JPRB, 0.16950297E-09_JPRB, &
  & 0.16953511E-09_JPRB, 0.16956204E-09_JPRB, 0.16957925E-09_JPRB, 0.16958718E-09_JPRB, 0.16958621E-09_JPRB, 0.16957805E-09_JPRB, &
  & 0.16956436E-09_JPRB, 0.16954235E-09_JPRB, 0.16951310E-09_JPRB, 0.16947926E-09_JPRB, 0.16944972E-09_JPRB, 0.16942700E-09_JPRB, &
  & 0.16941114E-09_JPRB, 0.16940305E-09_JPRB, 0.16940570E-09_JPRB, 0.16942325E-09_JPRB, 0.16945619E-09_JPRB, 0.16950245E-09_JPRB, &
  & 0.16955745E-09_JPRB, 0.16961446E-09_JPRB, 0.16966925E-09_JPRB, 0.16971638E-09_JPRB, 0.16975542E-09_JPRB, 0.16978358E-09_JPRB, &
  & 0.16980470E-09_JPRB, 0.16981944E-09_JPRB, 0.16982843E-09_JPRB, 0.16983380E-09_JPRB, 0.16983720E-09_JPRB, 0.16983835E-09_JPRB, &
  & 0.16983871E-09_JPRB, 0.16983760E-09_JPRB, 0.16983602E-09_JPRB, 0.16983315E-09_JPRB, 0.16982964E-09_JPRB, 0.16982558E-09_JPRB, &
  & 0.16982010E-09_JPRB, 0.16981025E-09_JPRB, 0.16978886E-09_JPRB, 0.16973369E-09_JPRB /)

RGHG8(:,76, 2) = (/ &
  & 0.16960980E-09_JPRB, 0.16967237E-09_JPRB, 0.16969079E-09_JPRB, 0.16970217E-09_JPRB, 0.16970739E-09_JPRB, 0.16970861E-09_JPRB, &
  & 0.16970836E-09_JPRB, 0.16970778E-09_JPRB, 0.16970868E-09_JPRB, 0.16970922E-09_JPRB, 0.16970839E-09_JPRB, 0.16970515E-09_JPRB, &
  & 0.16969753E-09_JPRB, 0.16968389E-09_JPRB, 0.16966334E-09_JPRB, 0.16963633E-09_JPRB, 0.16960656E-09_JPRB, 0.16957903E-09_JPRB, &
  & 0.16955937E-09_JPRB, 0.16954992E-09_JPRB, 0.16955161E-09_JPRB, 0.16956363E-09_JPRB, 0.16958399E-09_JPRB, 0.16960883E-09_JPRB, &
  & 0.16963293E-09_JPRB, 0.16965339E-09_JPRB, 0.16966600E-09_JPRB, 0.16967175E-09_JPRB, 0.16967111E-09_JPRB, 0.16966462E-09_JPRB, &
  & 0.16965424E-09_JPRB, 0.16963729E-09_JPRB, 0.16961503E-09_JPRB, 0.16958869E-09_JPRB, 0.16956611E-09_JPRB, 0.16954868E-09_JPRB, &
  & 0.16953686E-09_JPRB, 0.16953108E-09_JPRB, 0.16953387E-09_JPRB, 0.16954868E-09_JPRB, 0.16957563E-09_JPRB, 0.16961214E-09_JPRB, &
  & 0.16965575E-09_JPRB, 0.16969985E-09_JPRB, 0.16974216E-09_JPRB, 0.16977988E-09_JPRB, 0.16981003E-09_JPRB, 0.16983229E-09_JPRB, &
  & 0.16984902E-09_JPRB, 0.16986097E-09_JPRB, 0.16986809E-09_JPRB, 0.16987248E-09_JPRB, 0.16987563E-09_JPRB, 0.16987654E-09_JPRB, &
  & 0.16987702E-09_JPRB, 0.16987622E-09_JPRB, 0.16987547E-09_JPRB, 0.16987338E-09_JPRB, 0.16987067E-09_JPRB, 0.16986756E-09_JPRB, &
  & 0.16986339E-09_JPRB, 0.16985544E-09_JPRB, 0.16983673E-09_JPRB, 0.16978786E-09_JPRB /)

RGHG8(:,77, 2) = (/ &
  & 0.16970657E-09_JPRB, 0.16976387E-09_JPRB, 0.16977994E-09_JPRB, 0.16978934E-09_JPRB, 0.16979353E-09_JPRB, 0.16979453E-09_JPRB, &
  & 0.16979464E-09_JPRB, 0.16979411E-09_JPRB, 0.16979455E-09_JPRB, 0.16979454E-09_JPRB, 0.16979332E-09_JPRB, 0.16979089E-09_JPRB, &
  & 0.16978476E-09_JPRB, 0.16977511E-09_JPRB, 0.16976019E-09_JPRB, 0.16974035E-09_JPRB, 0.16971863E-09_JPRB, 0.16969830E-09_JPRB, &
  & 0.16968375E-09_JPRB, 0.16967627E-09_JPRB, 0.16967665E-09_JPRB, 0.16968453E-09_JPRB, 0.16969852E-09_JPRB, 0.16971589E-09_JPRB, &
  & 0.16973251E-09_JPRB, 0.16974688E-09_JPRB, 0.16975528E-09_JPRB, 0.16975914E-09_JPRB, 0.16975890E-09_JPRB, 0.16975391E-09_JPRB, &
  & 0.16974654E-09_JPRB, 0.16973423E-09_JPRB, 0.16971879E-09_JPRB, 0.16969962E-09_JPRB, 0.16968381E-09_JPRB, 0.16967133E-09_JPRB, &
  & 0.16966339E-09_JPRB, 0.16965966E-09_JPRB, 0.16966212E-09_JPRB, 0.16967382E-09_JPRB, 0.16969373E-09_JPRB, 0.16972038E-09_JPRB, &
  & 0.16975180E-09_JPRB, 0.16978320E-09_JPRB, 0.16981383E-09_JPRB, 0.16984072E-09_JPRB, 0.16986357E-09_JPRB, 0.16987907E-09_JPRB, &
  & 0.16989161E-09_JPRB, 0.16990076E-09_JPRB, 0.16990576E-09_JPRB, 0.16990898E-09_JPRB, 0.16991182E-09_JPRB, 0.16991226E-09_JPRB, &
  & 0.16991270E-09_JPRB, 0.16991211E-09_JPRB, 0.16991226E-09_JPRB, 0.16991072E-09_JPRB, 0.16990884E-09_JPRB, 0.16990653E-09_JPRB, &
  & 0.16990377E-09_JPRB, 0.16989753E-09_JPRB, 0.16988223E-09_JPRB, 0.16984117E-09_JPRB /)

RGHG8(:,78, 2) = (/ &
  & 0.16980130E-09_JPRB, 0.16984750E-09_JPRB, 0.16985828E-09_JPRB, 0.16986568E-09_JPRB, 0.16986854E-09_JPRB, 0.16986937E-09_JPRB, &
  & 0.16986988E-09_JPRB, 0.16986927E-09_JPRB, 0.16986881E-09_JPRB, 0.16986804E-09_JPRB, 0.16986623E-09_JPRB, 0.16986451E-09_JPRB, &
  & 0.16986057E-09_JPRB, 0.16985513E-09_JPRB, 0.16984646E-09_JPRB, 0.16983427E-09_JPRB, 0.16982077E-09_JPRB, 0.16980781E-09_JPRB, &
  & 0.16979883E-09_JPRB, 0.16979394E-09_JPRB, 0.16979386E-09_JPRB, 0.16979874E-09_JPRB, 0.16980725E-09_JPRB, 0.16981810E-09_JPRB, &
  & 0.16982825E-09_JPRB, 0.16983744E-09_JPRB, 0.16984232E-09_JPRB, 0.16984450E-09_JPRB, 0.16984482E-09_JPRB, 0.16984103E-09_JPRB, &
  & 0.16983624E-09_JPRB, 0.16982796E-09_JPRB, 0.16981876E-09_JPRB, 0.16980602E-09_JPRB, 0.16979612E-09_JPRB, 0.16978779E-09_JPRB, &
  & 0.16978310E-09_JPRB, 0.16978080E-09_JPRB, 0.16978244E-09_JPRB, 0.16979017E-09_JPRB, 0.16980270E-09_JPRB, 0.16981916E-09_JPRB, &
  & 0.16983928E-09_JPRB, 0.16985867E-09_JPRB, 0.16987831E-09_JPRB, 0.16989626E-09_JPRB, 0.16991164E-09_JPRB, 0.16992138E-09_JPRB, &
  & 0.16992978E-09_JPRB, 0.16993634E-09_JPRB, 0.16993923E-09_JPRB, 0.16994113E-09_JPRB, 0.16994361E-09_JPRB, 0.16994336E-09_JPRB, &
  & 0.16994363E-09_JPRB, 0.16994307E-09_JPRB, 0.16994395E-09_JPRB, 0.16994278E-09_JPRB, 0.16994152E-09_JPRB, 0.16993995E-09_JPRB, &
  & 0.16993837E-09_JPRB, 0.16993380E-09_JPRB, 0.16992294E-09_JPRB, 0.16989318E-09_JPRB /)

RGHG8(:,79, 2) = (/ &
  & 0.16986239E-09_JPRB, 0.16989400E-09_JPRB, 0.16989989E-09_JPRB, 0.16990517E-09_JPRB, 0.16990731E-09_JPRB, 0.16990789E-09_JPRB, &
  & 0.16990867E-09_JPRB, 0.16990778E-09_JPRB, 0.16990687E-09_JPRB, 0.16990566E-09_JPRB, 0.16990387E-09_JPRB, 0.16990277E-09_JPRB, &
  & 0.16990008E-09_JPRB, 0.16989700E-09_JPRB, 0.16989161E-09_JPRB, 0.16988345E-09_JPRB, 0.16987438E-09_JPRB, 0.16986546E-09_JPRB, &
  & 0.16985968E-09_JPRB, 0.16985632E-09_JPRB, 0.16985617E-09_JPRB, 0.16985961E-09_JPRB, 0.16986530E-09_JPRB, 0.16987284E-09_JPRB, &
  & 0.16987950E-09_JPRB, 0.16988613E-09_JPRB, 0.16988913E-09_JPRB, 0.16989053E-09_JPRB, 0.16989130E-09_JPRB, 0.16988816E-09_JPRB, &
  & 0.16988470E-09_JPRB, 0.16987860E-09_JPRB, 0.16987294E-09_JPRB, 0.16986358E-09_JPRB, 0.16985685E-09_JPRB, 0.16985058E-09_JPRB, &
  & 0.16984751E-09_JPRB, 0.16984590E-09_JPRB, 0.16984680E-09_JPRB, 0.16985224E-09_JPRB, 0.16986047E-09_JPRB, 0.16987137E-09_JPRB, &
  & 0.16988538E-09_JPRB, 0.16989839E-09_JPRB, 0.16991222E-09_JPRB, 0.16992524E-09_JPRB, 0.16993715E-09_JPRB, 0.16994346E-09_JPRB, &
  & 0.16994992E-09_JPRB, 0.16995522E-09_JPRB, 0.16995687E-09_JPRB, 0.16995799E-09_JPRB, 0.16996032E-09_JPRB, 0.16995955E-09_JPRB, &
  & 0.16995963E-09_JPRB, 0.16995903E-09_JPRB, 0.16996046E-09_JPRB, 0.16995939E-09_JPRB, 0.16995839E-09_JPRB, 0.16995713E-09_JPRB, &
  & 0.16995630E-09_JPRB, 0.16995301E-09_JPRB, 0.16994545E-09_JPRB, 0.16992664E-09_JPRB /)

RGHG8(:,80, 2) = (/ &
  & 0.16990270E-09_JPRB, 0.16991644E-09_JPRB, 0.16991797E-09_JPRB, 0.16992230E-09_JPRB, 0.16992392E-09_JPRB, 0.16992437E-09_JPRB, &
  & 0.16992530E-09_JPRB, 0.16992441E-09_JPRB, 0.16992320E-09_JPRB, 0.16992222E-09_JPRB, 0.16992033E-09_JPRB, 0.16991980E-09_JPRB, &
  & 0.16991761E-09_JPRB, 0.16991562E-09_JPRB, 0.16991165E-09_JPRB, 0.16990517E-09_JPRB, 0.16989804E-09_JPRB, 0.16989093E-09_JPRB, &
  & 0.16988673E-09_JPRB, 0.16988409E-09_JPRB, 0.16988395E-09_JPRB, 0.16988681E-09_JPRB, 0.16989134E-09_JPRB, 0.16989739E-09_JPRB, &
  & 0.16990259E-09_JPRB, 0.16990809E-09_JPRB, 0.16991027E-09_JPRB, 0.16991135E-09_JPRB, 0.16991243E-09_JPRB, 0.16990953E-09_JPRB, &
  & 0.16990674E-09_JPRB, 0.16990154E-09_JPRB, 0.16989761E-09_JPRB, 0.16988978E-09_JPRB, 0.16988443E-09_JPRB, 0.16987900E-09_JPRB, &
  & 0.16987664E-09_JPRB, 0.16987528E-09_JPRB, 0.16987579E-09_JPRB, 0.16988015E-09_JPRB, 0.16988638E-09_JPRB, 0.16989471E-09_JPRB, &
  & 0.16990598E-09_JPRB, 0.16991608E-09_JPRB, 0.16992729E-09_JPRB, 0.16993817E-09_JPRB, 0.16994840E-09_JPRB, 0.16995320E-09_JPRB, &
  & 0.16995871E-09_JPRB, 0.16996360E-09_JPRB, 0.16996457E-09_JPRB, 0.16996528E-09_JPRB, 0.16996768E-09_JPRB, 0.16996655E-09_JPRB, &
  & 0.16996655E-09_JPRB, 0.16996585E-09_JPRB, 0.16996760E-09_JPRB, 0.16996655E-09_JPRB, 0.16996561E-09_JPRB, 0.16996449E-09_JPRB, &
  & 0.16996404E-09_JPRB, 0.16996136E-09_JPRB, 0.16995615E-09_JPRB, 0.16994890E-09_JPRB /)

RGHG8(:,81, 2) = (/ &
  & 0.16993031E-09_JPRB, 0.16992589E-09_JPRB, 0.16992557E-09_JPRB, 0.16992951E-09_JPRB, 0.16993097E-09_JPRB, 0.16993142E-09_JPRB, &
  & 0.16993247E-09_JPRB, 0.16993144E-09_JPRB, 0.16993039E-09_JPRB, 0.16992921E-09_JPRB, 0.16992763E-09_JPRB, 0.16992728E-09_JPRB, &
  & 0.16992537E-09_JPRB, 0.16992383E-09_JPRB, 0.16992040E-09_JPRB, 0.16991464E-09_JPRB, 0.16990835E-09_JPRB, 0.16990202E-09_JPRB, &
  & 0.16989851E-09_JPRB, 0.16989624E-09_JPRB, 0.16989608E-09_JPRB, 0.16989866E-09_JPRB, 0.16990268E-09_JPRB, 0.16990812E-09_JPRB, &
  & 0.16991268E-09_JPRB, 0.16991772E-09_JPRB, 0.16991954E-09_JPRB, 0.16992048E-09_JPRB, 0.16992180E-09_JPRB, 0.16991895E-09_JPRB, &
  & 0.16991648E-09_JPRB, 0.16991165E-09_JPRB, 0.16990846E-09_JPRB, 0.16990129E-09_JPRB, 0.16989656E-09_JPRB, 0.16989149E-09_JPRB, &
  & 0.16988944E-09_JPRB, 0.16988819E-09_JPRB, 0.16988852E-09_JPRB, 0.16989242E-09_JPRB, 0.16989779E-09_JPRB, 0.16990498E-09_JPRB, &
  & 0.16991508E-09_JPRB, 0.16992387E-09_JPRB, 0.16993394E-09_JPRB, 0.16994378E-09_JPRB, 0.16995343E-09_JPRB, 0.16995735E-09_JPRB, &
  & 0.16996256E-09_JPRB, 0.16996725E-09_JPRB, 0.16996790E-09_JPRB, 0.16996844E-09_JPRB, 0.16997084E-09_JPRB, 0.16996952E-09_JPRB, &
  & 0.16996946E-09_JPRB, 0.16996875E-09_JPRB, 0.16997069E-09_JPRB, 0.16996961E-09_JPRB, 0.16996873E-09_JPRB, 0.16996760E-09_JPRB, &
  & 0.16996732E-09_JPRB, 0.16996485E-09_JPRB, 0.16996060E-09_JPRB, 0.16996431E-09_JPRB /)

RGHG8(:,82, 2) = (/ &
  & 0.16993254E-09_JPRB, 0.16992910E-09_JPRB, 0.16992893E-09_JPRB, 0.16993301E-09_JPRB, 0.16993439E-09_JPRB, 0.16993477E-09_JPRB, &
  & 0.16993587E-09_JPRB, 0.16993500E-09_JPRB, 0.16993366E-09_JPRB, 0.16993290E-09_JPRB, 0.16993103E-09_JPRB, 0.16993099E-09_JPRB, &
  & 0.16992915E-09_JPRB, 0.16992786E-09_JPRB, 0.16992473E-09_JPRB, 0.16991931E-09_JPRB, 0.16991336E-09_JPRB, 0.16990738E-09_JPRB, &
  & 0.16990431E-09_JPRB, 0.16990211E-09_JPRB, 0.16990197E-09_JPRB, 0.16990448E-09_JPRB, 0.16990820E-09_JPRB, 0.16991333E-09_JPRB, &
  & 0.16991758E-09_JPRB, 0.16992240E-09_JPRB, 0.16992401E-09_JPRB, 0.16992487E-09_JPRB, 0.16992635E-09_JPRB, 0.16992353E-09_JPRB, &
  & 0.16992117E-09_JPRB, 0.16991651E-09_JPRB, 0.16991369E-09_JPRB, 0.16990692E-09_JPRB, 0.16990245E-09_JPRB, 0.16989762E-09_JPRB, &
  & 0.16989567E-09_JPRB, 0.16989453E-09_JPRB, 0.16989479E-09_JPRB, 0.16989846E-09_JPRB, 0.16990340E-09_JPRB, 0.16990997E-09_JPRB, &
  & 0.16991955E-09_JPRB, 0.16992760E-09_JPRB, 0.16993716E-09_JPRB, 0.16994656E-09_JPRB, 0.16995585E-09_JPRB, 0.16995942E-09_JPRB, &
  & 0.16996438E-09_JPRB, 0.16996905E-09_JPRB, 0.16996952E-09_JPRB, 0.16996993E-09_JPRB, 0.16997238E-09_JPRB, 0.16997093E-09_JPRB, &
  & 0.16997087E-09_JPRB, 0.16997015E-09_JPRB, 0.16997218E-09_JPRB, 0.16997108E-09_JPRB, 0.16997023E-09_JPRB, 0.16996909E-09_JPRB, &
  & 0.16996886E-09_JPRB, 0.16996636E-09_JPRB, 0.16996204E-09_JPRB, 0.16996551E-09_JPRB /)

RGHG8(:,83, 2) = (/ &
  & 0.16993409E-09_JPRB, 0.16993093E-09_JPRB, 0.16993079E-09_JPRB, 0.16993495E-09_JPRB, 0.16993632E-09_JPRB, 0.16993670E-09_JPRB, &
  & 0.16993783E-09_JPRB, 0.16993670E-09_JPRB, 0.16993570E-09_JPRB, 0.16993455E-09_JPRB, 0.16993316E-09_JPRB, 0.16993301E-09_JPRB, &
  & 0.16993135E-09_JPRB, 0.16993011E-09_JPRB, 0.16992713E-09_JPRB, 0.16992192E-09_JPRB, 0.16991615E-09_JPRB, 0.16991042E-09_JPRB, &
  & 0.16990749E-09_JPRB, 0.16990544E-09_JPRB, 0.16990528E-09_JPRB, 0.16990762E-09_JPRB, 0.16991127E-09_JPRB, 0.16991622E-09_JPRB, &
  & 0.16992026E-09_JPRB, 0.16992502E-09_JPRB, 0.16992648E-09_JPRB, 0.16992731E-09_JPRB, 0.16992892E-09_JPRB, 0.16992607E-09_JPRB, &
  & 0.16992376E-09_JPRB, 0.16991915E-09_JPRB, 0.16991655E-09_JPRB, 0.16990999E-09_JPRB, 0.16990577E-09_JPRB, 0.16990108E-09_JPRB, &
  & 0.16989922E-09_JPRB, 0.16989811E-09_JPRB, 0.16989832E-09_JPRB, 0.16990183E-09_JPRB, 0.16990648E-09_JPRB, 0.16991270E-09_JPRB, &
  & 0.16992197E-09_JPRB, 0.16992972E-09_JPRB, 0.16993899E-09_JPRB, 0.16994808E-09_JPRB, 0.16995731E-09_JPRB, 0.16996052E-09_JPRB, &
  & 0.16996542E-09_JPRB, 0.16997008E-09_JPRB, 0.16997045E-09_JPRB, 0.16997079E-09_JPRB, 0.16997331E-09_JPRB, 0.16997172E-09_JPRB, &
  & 0.16997163E-09_JPRB, 0.16997088E-09_JPRB, 0.16997304E-09_JPRB, 0.16997193E-09_JPRB, 0.16997108E-09_JPRB, 0.16996991E-09_JPRB, &
  & 0.16996973E-09_JPRB, 0.16996722E-09_JPRB, 0.16996285E-09_JPRB, 0.16996640E-09_JPRB /)

RGHG8(:,84, 2) = (/ &
  & 0.16993519E-09_JPRB, 0.16993214E-09_JPRB, 0.16993194E-09_JPRB, 0.16993615E-09_JPRB, 0.16993749E-09_JPRB, 0.16993783E-09_JPRB, &
  & 0.16993895E-09_JPRB, 0.16993806E-09_JPRB, 0.16993665E-09_JPRB, 0.16993597E-09_JPRB, 0.16993429E-09_JPRB, 0.16993426E-09_JPRB, &
  & 0.16993260E-09_JPRB, 0.16993149E-09_JPRB, 0.16992864E-09_JPRB, 0.16992355E-09_JPRB, 0.16991794E-09_JPRB, 0.16991222E-09_JPRB, &
  & 0.16990959E-09_JPRB, 0.16990742E-09_JPRB, 0.16990720E-09_JPRB, 0.16990960E-09_JPRB, 0.16991306E-09_JPRB, 0.16991800E-09_JPRB, &
  & 0.16992194E-09_JPRB, 0.16992660E-09_JPRB, 0.16992797E-09_JPRB, 0.16992877E-09_JPRB, 0.16993051E-09_JPRB, 0.16992763E-09_JPRB, &
  & 0.16992530E-09_JPRB, 0.16992073E-09_JPRB, 0.16991823E-09_JPRB, 0.16991190E-09_JPRB, 0.16990773E-09_JPRB, 0.16990329E-09_JPRB, &
  & 0.16990140E-09_JPRB, 0.16990034E-09_JPRB, 0.16990054E-09_JPRB, 0.16990397E-09_JPRB, 0.16990834E-09_JPRB, 0.16991436E-09_JPRB, &
  & 0.16992342E-09_JPRB, 0.16993096E-09_JPRB, 0.16994006E-09_JPRB, 0.16994908E-09_JPRB, 0.16995816E-09_JPRB, 0.16996118E-09_JPRB, &
  & 0.16996603E-09_JPRB, 0.16997073E-09_JPRB, 0.16997097E-09_JPRB, 0.16997126E-09_JPRB, 0.16997385E-09_JPRB, 0.16997220E-09_JPRB, &
  & 0.16997209E-09_JPRB, 0.16997133E-09_JPRB, 0.16997356E-09_JPRB, 0.16997244E-09_JPRB, 0.16997159E-09_JPRB, 0.16997038E-09_JPRB, &
  & 0.16997026E-09_JPRB, 0.16996771E-09_JPRB, 0.16996336E-09_JPRB, 0.16996700E-09_JPRB /)

RGHG8(:,85, 2) = (/ &
  & 0.16993590E-09_JPRB, 0.16993294E-09_JPRB, 0.16993268E-09_JPRB, 0.16993695E-09_JPRB, 0.16993824E-09_JPRB, 0.16993869E-09_JPRB, &
  & 0.16993959E-09_JPRB, 0.16993842E-09_JPRB, 0.16993747E-09_JPRB, 0.16993637E-09_JPRB, 0.16993529E-09_JPRB, 0.16993494E-09_JPRB, &
  & 0.16993358E-09_JPRB, 0.16993235E-09_JPRB, 0.16992963E-09_JPRB, 0.16992467E-09_JPRB, 0.16991909E-09_JPRB, 0.16991353E-09_JPRB, &
  & 0.16991086E-09_JPRB, 0.16990877E-09_JPRB, 0.16990850E-09_JPRB, 0.16991074E-09_JPRB, 0.16991422E-09_JPRB, 0.16991911E-09_JPRB, &
  & 0.16992295E-09_JPRB, 0.16992767E-09_JPRB, 0.16992892E-09_JPRB, 0.16992970E-09_JPRB, 0.16993153E-09_JPRB, 0.16992853E-09_JPRB, &
  & 0.16992628E-09_JPRB, 0.16992172E-09_JPRB, 0.16991933E-09_JPRB, 0.16991306E-09_JPRB, 0.16990906E-09_JPRB, 0.16990462E-09_JPRB, &
  & 0.16990281E-09_JPRB, 0.16990176E-09_JPRB, 0.16990198E-09_JPRB, 0.16990527E-09_JPRB, 0.16990963E-09_JPRB, 0.16991526E-09_JPRB, &
  & 0.16992445E-09_JPRB, 0.16993175E-09_JPRB, 0.16994084E-09_JPRB, 0.16994969E-09_JPRB, 0.16995880E-09_JPRB, 0.16996161E-09_JPRB, &
  & 0.16996642E-09_JPRB, 0.16997112E-09_JPRB, 0.16997131E-09_JPRB, 0.16997156E-09_JPRB, 0.16997423E-09_JPRB, 0.16997252E-09_JPRB, &
  & 0.16997238E-09_JPRB, 0.16997161E-09_JPRB, 0.16997392E-09_JPRB, 0.16997280E-09_JPRB, 0.16997195E-09_JPRB, 0.16997072E-09_JPRB, &
  & 0.16997062E-09_JPRB, 0.16996804E-09_JPRB, 0.16996367E-09_JPRB, 0.16996742E-09_JPRB /)

RGHG8(:,86, 2) = (/ &
  & 0.16993637E-09_JPRB, 0.16993347E-09_JPRB, 0.16993308E-09_JPRB, 0.16993747E-09_JPRB, 0.16993876E-09_JPRB, 0.16993901E-09_JPRB, &
  & 0.16993972E-09_JPRB, 0.16993884E-09_JPRB, 0.16993762E-09_JPRB, 0.16993687E-09_JPRB, 0.16993576E-09_JPRB, 0.16993534E-09_JPRB, &
  & 0.16993408E-09_JPRB, 0.16993282E-09_JPRB, 0.16993021E-09_JPRB, 0.16992549E-09_JPRB, 0.16991993E-09_JPRB, 0.16991437E-09_JPRB, &
  & 0.16991179E-09_JPRB, 0.16990957E-09_JPRB, 0.16990924E-09_JPRB, 0.16991150E-09_JPRB, 0.16991490E-09_JPRB, 0.16991980E-09_JPRB, &
  & 0.16992367E-09_JPRB, 0.16992839E-09_JPRB, 0.16992953E-09_JPRB, 0.16993028E-09_JPRB, 0.16993218E-09_JPRB, 0.16992913E-09_JPRB, &
  & 0.16992688E-09_JPRB, 0.16992231E-09_JPRB, 0.16991997E-09_JPRB, 0.16991389E-09_JPRB, 0.16990982E-09_JPRB, 0.16990552E-09_JPRB, &
  & 0.16990363E-09_JPRB, 0.16990259E-09_JPRB, 0.16990273E-09_JPRB, 0.16990620E-09_JPRB, 0.16991027E-09_JPRB, 0.16991608E-09_JPRB, &
  & 0.16992505E-09_JPRB, 0.16993232E-09_JPRB, 0.16994132E-09_JPRB, 0.16995011E-09_JPRB, 0.16995916E-09_JPRB, 0.16996188E-09_JPRB, &
  & 0.16996665E-09_JPRB, 0.16997140E-09_JPRB, 0.16997155E-09_JPRB, 0.16997173E-09_JPRB, 0.16997447E-09_JPRB, 0.16997272E-09_JPRB, &
  & 0.16997256E-09_JPRB, 0.16997177E-09_JPRB, 0.16997415E-09_JPRB, 0.16997304E-09_JPRB, 0.16997219E-09_JPRB, 0.16997093E-09_JPRB, &
  & 0.16997083E-09_JPRB, 0.16996823E-09_JPRB, 0.16996383E-09_JPRB, 0.16996768E-09_JPRB /)

RGHG8(:,87, 2) = (/ &
  & 0.16993663E-09_JPRB, 0.16993376E-09_JPRB, 0.16993333E-09_JPRB, 0.16993784E-09_JPRB, 0.16993901E-09_JPRB, 0.16993938E-09_JPRB, &
  & 0.16993983E-09_JPRB, 0.16993873E-09_JPRB, 0.16993787E-09_JPRB, 0.16993698E-09_JPRB, 0.16993612E-09_JPRB, 0.16993559E-09_JPRB, &
  & 0.16993443E-09_JPRB, 0.16993311E-09_JPRB, 0.16993058E-09_JPRB, 0.16992603E-09_JPRB, 0.16992056E-09_JPRB, 0.16991503E-09_JPRB, &
  & 0.16991231E-09_JPRB, 0.16991007E-09_JPRB, 0.16990968E-09_JPRB, 0.16991189E-09_JPRB, 0.16991530E-09_JPRB, 0.16992027E-09_JPRB, &
  & 0.16992405E-09_JPRB, 0.16992885E-09_JPRB, 0.16992992E-09_JPRB, 0.16993063E-09_JPRB, 0.16993262E-09_JPRB, 0.16992951E-09_JPRB, &
  & 0.16992725E-09_JPRB, 0.16992269E-09_JPRB, 0.16992047E-09_JPRB, 0.16991432E-09_JPRB, 0.16991046E-09_JPRB, 0.16990591E-09_JPRB, &
  & 0.16990413E-09_JPRB, 0.16990304E-09_JPRB, 0.16990315E-09_JPRB, 0.16990659E-09_JPRB, 0.16991089E-09_JPRB, 0.16991630E-09_JPRB, &
  & 0.16992568E-09_JPRB, 0.16993264E-09_JPRB, 0.16994163E-09_JPRB, 0.16995037E-09_JPRB, 0.16995944E-09_JPRB, 0.16996206E-09_JPRB, &
  & 0.16996682E-09_JPRB, 0.16997159E-09_JPRB, 0.16997170E-09_JPRB, 0.16997181E-09_JPRB, 0.16997459E-09_JPRB, 0.16997281E-09_JPRB, &
  & 0.16997269E-09_JPRB, 0.16997186E-09_JPRB, 0.16997427E-09_JPRB, 0.16997316E-09_JPRB, 0.16997231E-09_JPRB, 0.16997105E-09_JPRB, &
  & 0.16997095E-09_JPRB, 0.16996834E-09_JPRB, 0.16996390E-09_JPRB, 0.16996785E-09_JPRB /)

RGHG8(:,88, 2) = (/ &
  & 0.16993675E-09_JPRB, 0.16993398E-09_JPRB, 0.16993348E-09_JPRB, 0.16993794E-09_JPRB, 0.16993924E-09_JPRB, 0.16993941E-09_JPRB, &
  & 0.16993983E-09_JPRB, 0.16993899E-09_JPRB, 0.16993790E-09_JPRB, 0.16993716E-09_JPRB, 0.16993626E-09_JPRB, 0.16993572E-09_JPRB, &
  & 0.16993457E-09_JPRB, 0.16993323E-09_JPRB, 0.16993078E-09_JPRB, 0.16992638E-09_JPRB, 0.16992084E-09_JPRB, 0.16991536E-09_JPRB, &
  & 0.16991268E-09_JPRB, 0.16991035E-09_JPRB, 0.16990992E-09_JPRB, 0.16991214E-09_JPRB, 0.16991553E-09_JPRB, 0.16992055E-09_JPRB, &
  & 0.16992427E-09_JPRB, 0.16992917E-09_JPRB, 0.16993013E-09_JPRB, 0.16993083E-09_JPRB, 0.16993290E-09_JPRB, 0.16992974E-09_JPRB, &
  & 0.16992749E-09_JPRB, 0.16992292E-09_JPRB, 0.16992081E-09_JPRB, 0.16991472E-09_JPRB, 0.16991067E-09_JPRB, 0.16990616E-09_JPRB, &
  & 0.16990433E-09_JPRB, 0.16990326E-09_JPRB, 0.16990322E-09_JPRB, 0.16990698E-09_JPRB, 0.16991106E-09_JPRB, 0.16991666E-09_JPRB, &
  & 0.16992595E-09_JPRB, 0.16993286E-09_JPRB, 0.16994185E-09_JPRB, 0.16995048E-09_JPRB, 0.16995959E-09_JPRB, 0.16996211E-09_JPRB, &
  & 0.16996689E-09_JPRB, 0.16997169E-09_JPRB, 0.16997181E-09_JPRB, 0.16997190E-09_JPRB, 0.16997470E-09_JPRB, 0.16997286E-09_JPRB, &
  & 0.16997276E-09_JPRB, 0.16997191E-09_JPRB, 0.16997437E-09_JPRB, 0.16997329E-09_JPRB, 0.16997241E-09_JPRB, 0.16997108E-09_JPRB, &
  & 0.16997104E-09_JPRB, 0.16996841E-09_JPRB, 0.16996397E-09_JPRB, 0.16996797E-09_JPRB /)

RGHG8(:,89, 2) = (/ &
  & 0.16993673E-09_JPRB, 0.16993411E-09_JPRB, 0.16993358E-09_JPRB, 0.16993812E-09_JPRB, 0.16993933E-09_JPRB, 0.16993970E-09_JPRB, &
  & 0.16994015E-09_JPRB, 0.16993898E-09_JPRB, 0.16993811E-09_JPRB, 0.16993723E-09_JPRB, 0.16993634E-09_JPRB, 0.16993586E-09_JPRB, &
  & 0.16993471E-09_JPRB, 0.16993341E-09_JPRB, 0.16993092E-09_JPRB, 0.16992642E-09_JPRB, 0.16992095E-09_JPRB, 0.16991539E-09_JPRB, &
  & 0.16991283E-09_JPRB, 0.16991050E-09_JPRB, 0.16991003E-09_JPRB, 0.16991222E-09_JPRB, 0.16991561E-09_JPRB, 0.16992070E-09_JPRB, &
  & 0.16992435E-09_JPRB, 0.16992935E-09_JPRB, 0.16993026E-09_JPRB, 0.16993090E-09_JPRB, 0.16993308E-09_JPRB, 0.16992982E-09_JPRB, &
  & 0.16992767E-09_JPRB, 0.16992302E-09_JPRB, 0.16992113E-09_JPRB, 0.16991479E-09_JPRB, 0.16991095E-09_JPRB, 0.16990609E-09_JPRB, &
  & 0.16990442E-09_JPRB, 0.16990334E-09_JPRB, 0.16990323E-09_JPRB, 0.16990706E-09_JPRB, 0.16991128E-09_JPRB, 0.16991666E-09_JPRB, &
  & 0.16992621E-09_JPRB, 0.16993301E-09_JPRB, 0.16994198E-09_JPRB, 0.16995058E-09_JPRB, 0.16995974E-09_JPRB, 0.16996216E-09_JPRB, &
  & 0.16996689E-09_JPRB, 0.16997177E-09_JPRB, 0.16997186E-09_JPRB, 0.16997190E-09_JPRB, 0.16997477E-09_JPRB, 0.16997288E-09_JPRB, &
  & 0.16997283E-09_JPRB, 0.16997195E-09_JPRB, 0.16997441E-09_JPRB, 0.16997331E-09_JPRB, 0.16997247E-09_JPRB, 0.16997109E-09_JPRB, &
  & 0.16997111E-09_JPRB, 0.16996847E-09_JPRB, 0.16996395E-09_JPRB, 0.16996805E-09_JPRB /)

RGHG8(:,90, 2) = (/ &
  & 0.16993659E-09_JPRB, 0.16993418E-09_JPRB, 0.16993348E-09_JPRB, 0.16993817E-09_JPRB, 0.16993942E-09_JPRB, 0.16993963E-09_JPRB, &
  & 0.16994053E-09_JPRB, 0.16993948E-09_JPRB, 0.16993820E-09_JPRB, 0.16993740E-09_JPRB, 0.16993630E-09_JPRB, 0.16993595E-09_JPRB, &
  & 0.16993473E-09_JPRB, 0.16993358E-09_JPRB, 0.16993104E-09_JPRB, 0.16992642E-09_JPRB, 0.16992074E-09_JPRB, 0.16991523E-09_JPRB, &
  & 0.16991286E-09_JPRB, 0.16991045E-09_JPRB, 0.16991000E-09_JPRB, 0.16991224E-09_JPRB, 0.16991561E-09_JPRB, 0.16992079E-09_JPRB, &
  & 0.16992435E-09_JPRB, 0.16992950E-09_JPRB, 0.16993031E-09_JPRB, 0.16993090E-09_JPRB, 0.16993330E-09_JPRB, 0.16992986E-09_JPRB, &
  & 0.16992788E-09_JPRB, 0.16992302E-09_JPRB, 0.16992145E-09_JPRB, 0.16991478E-09_JPRB, 0.16991100E-09_JPRB, 0.16990594E-09_JPRB, &
  & 0.16990440E-09_JPRB, 0.16990337E-09_JPRB, 0.16990315E-09_JPRB, 0.16990720E-09_JPRB, 0.16991125E-09_JPRB, 0.16991662E-09_JPRB, &
  & 0.16992642E-09_JPRB, 0.16993304E-09_JPRB, 0.16994203E-09_JPRB, 0.16995061E-09_JPRB, 0.16995999E-09_JPRB, 0.16996214E-09_JPRB, &
  & 0.16996696E-09_JPRB, 0.16997197E-09_JPRB, 0.16997193E-09_JPRB, 0.16997187E-09_JPRB, 0.16997492E-09_JPRB, 0.16997286E-09_JPRB, &
  & 0.16997287E-09_JPRB, 0.16997187E-09_JPRB, 0.16997455E-09_JPRB, 0.16997335E-09_JPRB, 0.16997251E-09_JPRB, 0.16997104E-09_JPRB, &
  & 0.16997116E-09_JPRB, 0.16996848E-09_JPRB, 0.16996383E-09_JPRB, 0.16996812E-09_JPRB /)

RGHG8(:,91, 2) = (/ &
  & 0.16993634E-09_JPRB, 0.16993433E-09_JPRB, 0.16993294E-09_JPRB, 0.16993842E-09_JPRB, 0.16993951E-09_JPRB, 0.16993953E-09_JPRB, &
  & 0.16994146E-09_JPRB, 0.16993991E-09_JPRB, 0.16993834E-09_JPRB, 0.16993773E-09_JPRB, 0.16993566E-09_JPRB, 0.16993659E-09_JPRB, &
  & 0.16993450E-09_JPRB, 0.16993389E-09_JPRB, 0.16993135E-09_JPRB, 0.16992631E-09_JPRB, 0.16992061E-09_JPRB, 0.16991482E-09_JPRB, &
  & 0.16991282E-09_JPRB, 0.16991034E-09_JPRB, 0.16990982E-09_JPRB, 0.16991220E-09_JPRB, 0.16991551E-09_JPRB, 0.16992091E-09_JPRB, &
  & 0.16992428E-09_JPRB, 0.16992982E-09_JPRB, 0.16993036E-09_JPRB, 0.16993078E-09_JPRB, 0.16993383E-09_JPRB, 0.16992981E-09_JPRB, &
  & 0.16992810E-09_JPRB, 0.16992277E-09_JPRB, 0.16992217E-09_JPRB, 0.16991440E-09_JPRB, 0.16991125E-09_JPRB, 0.16990542E-09_JPRB, &
  & 0.16990431E-09_JPRB, 0.16990329E-09_JPRB, 0.16990286E-09_JPRB, 0.16990720E-09_JPRB, 0.16991122E-09_JPRB, 0.16991634E-09_JPRB, &
  & 0.16992663E-09_JPRB, 0.16993291E-09_JPRB, 0.16994209E-09_JPRB, 0.16995061E-09_JPRB, 0.16996053E-09_JPRB, 0.16996198E-09_JPRB, &
  & 0.16996697E-09_JPRB, 0.16997233E-09_JPRB, 0.16997194E-09_JPRB, 0.16997165E-09_JPRB, 0.16997527E-09_JPRB, 0.16997270E-09_JPRB, &
  & 0.16997295E-09_JPRB, 0.16997168E-09_JPRB, 0.16997484E-09_JPRB, 0.16997333E-09_JPRB, 0.16997255E-09_JPRB, 0.16997095E-09_JPRB, &
  & 0.16997134E-09_JPRB, 0.16996843E-09_JPRB, 0.16996350E-09_JPRB, 0.16996821E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART4',1,ZHOOK_HANDLE)
END SUBROUTINE PART4






SUBROUTINE PART5
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART5',0,ZHOOK_HANDLE)



!-- Month=  3 ------------

RGHG8(:, 1, 3) = (/ &
  & 0.35395218E-10_JPRB, 0.35422207E-10_JPRB, 0.35466900E-10_JPRB, 0.35534152E-10_JPRB, 0.35622328E-10_JPRB, 0.35733569E-10_JPRB, &
  & 0.35869911E-10_JPRB, 0.36029239E-10_JPRB, 0.36207690E-10_JPRB, 0.36405431E-10_JPRB, 0.36615110E-10_JPRB, 0.36832939E-10_JPRB, &
  & 0.37047553E-10_JPRB, 0.37242862E-10_JPRB, 0.37404104E-10_JPRB, 0.37519193E-10_JPRB, 0.37573979E-10_JPRB, 0.37587433E-10_JPRB, &
  & 0.37570717E-10_JPRB, 0.37537397E-10_JPRB, 0.37498667E-10_JPRB, 0.37458120E-10_JPRB, 0.37416140E-10_JPRB, 0.37369538E-10_JPRB, &
  & 0.37303355E-10_JPRB, 0.37167130E-10_JPRB, 0.36998758E-10_JPRB, 0.36889384E-10_JPRB, 0.36838258E-10_JPRB, 0.36830525E-10_JPRB, &
  & 0.36856872E-10_JPRB, 0.36915297E-10_JPRB, 0.37007199E-10_JPRB, 0.37120224E-10_JPRB, 0.37241574E-10_JPRB, 0.37390872E-10_JPRB, &
  & 0.37564896E-10_JPRB, 0.37758865E-10_JPRB, 0.37906813E-10_JPRB, 0.37993012E-10_JPRB, 0.38031689E-10_JPRB, 0.38040633E-10_JPRB, &
  & 0.38028133E-10_JPRB, 0.37997765E-10_JPRB, 0.37951822E-10_JPRB, 0.37891804E-10_JPRB, 0.37817516E-10_JPRB, 0.37728126E-10_JPRB, &
  & 0.37624407E-10_JPRB, 0.37509777E-10_JPRB, 0.37391486E-10_JPRB, 0.37280241E-10_JPRB, 0.37187167E-10_JPRB, 0.37118836E-10_JPRB, &
  & 0.37074680E-10_JPRB, 0.37049488E-10_JPRB, 0.37037200E-10_JPRB, 0.37032977E-10_JPRB, 0.37032301E-10_JPRB, 0.37033349E-10_JPRB, &
  & 0.37035163E-10_JPRB, 0.37037359E-10_JPRB, 0.37039219E-10_JPRB, 0.37040055E-10_JPRB /)

RGHG8(:, 2, 3) = (/ &
  & 0.35467074E-10_JPRB, 0.35537111E-10_JPRB, 0.35606885E-10_JPRB, 0.35693455E-10_JPRB, 0.35802729E-10_JPRB, 0.35938717E-10_JPRB, &
  & 0.36105664E-10_JPRB, 0.36305729E-10_JPRB, 0.36536465E-10_JPRB, 0.36793631E-10_JPRB, 0.37066034E-10_JPRB, 0.37340794E-10_JPRB, &
  & 0.37604305E-10_JPRB, 0.37840904E-10_JPRB, 0.38034399E-10_JPRB, 0.38168350E-10_JPRB, 0.38237288E-10_JPRB, 0.38245147E-10_JPRB, &
  & 0.38207843E-10_JPRB, 0.38144835E-10_JPRB, 0.38066540E-10_JPRB, 0.37978377E-10_JPRB, 0.37885171E-10_JPRB, 0.37783360E-10_JPRB, &
  & 0.37681049E-10_JPRB, 0.37574662E-10_JPRB, 0.37478440E-10_JPRB, 0.37411560E-10_JPRB, 0.37381077E-10_JPRB, 0.37386441E-10_JPRB, &
  & 0.37431391E-10_JPRB, 0.37524355E-10_JPRB, 0.37674128E-10_JPRB, 0.37883831E-10_JPRB, 0.38135512E-10_JPRB, 0.38425034E-10_JPRB, &
  & 0.38736032E-10_JPRB, 0.39044292E-10_JPRB, 0.39291608E-10_JPRB, 0.39447057E-10_JPRB, 0.39509451E-10_JPRB, 0.39495102E-10_JPRB, &
  & 0.39418833E-10_JPRB, 0.39291966E-10_JPRB, 0.39124232E-10_JPRB, 0.38925245E-10_JPRB, 0.38702590E-10_JPRB, 0.38466154E-10_JPRB, &
  & 0.38232174E-10_JPRB, 0.38018318E-10_JPRB, 0.37834472E-10_JPRB, 0.37680171E-10_JPRB, 0.37551719E-10_JPRB, 0.37447601E-10_JPRB, &
  & 0.37366884E-10_JPRB, 0.37307303E-10_JPRB, 0.37265635E-10_JPRB, 0.37237442E-10_JPRB, 0.37219047E-10_JPRB, 0.37207834E-10_JPRB, &
  & 0.37201443E-10_JPRB, 0.37198321E-10_JPRB, 0.37195795E-10_JPRB, 0.37192471E-10_JPRB /)

RGHG8(:, 3, 3) = (/ &
  & 0.35538492E-10_JPRB, 0.35633697E-10_JPRB, 0.35723910E-10_JPRB, 0.35839071E-10_JPRB, 0.35989611E-10_JPRB, 0.36179698E-10_JPRB, &
  & 0.36406409E-10_JPRB, 0.36659387E-10_JPRB, 0.36930271E-10_JPRB, 0.37216962E-10_JPRB, 0.37518273E-10_JPRB, 0.37826183E-10_JPRB, &
  & 0.38128865E-10_JPRB, 0.38410483E-10_JPRB, 0.38653455E-10_JPRB, 0.38841978E-10_JPRB, 0.38962351E-10_JPRB, 0.39012026E-10_JPRB, &
  & 0.39000497E-10_JPRB, 0.38942245E-10_JPRB, 0.38856432E-10_JPRB, 0.38759333E-10_JPRB, 0.38659267E-10_JPRB, 0.38564124E-10_JPRB, &
  & 0.38481197E-10_JPRB, 0.38432351E-10_JPRB, 0.38430221E-10_JPRB, 0.38467080E-10_JPRB, 0.38534634E-10_JPRB, 0.38629072E-10_JPRB, &
  & 0.38749823E-10_JPRB, 0.38909098E-10_JPRB, 0.39128131E-10_JPRB, 0.39415533E-10_JPRB, 0.39766409E-10_JPRB, 0.40155823E-10_JPRB, &
  & 0.40577527E-10_JPRB, 0.40999482E-10_JPRB, 0.41373946E-10_JPRB, 0.41624471E-10_JPRB, 0.41712210E-10_JPRB, 0.41639876E-10_JPRB, &
  & 0.41431907E-10_JPRB, 0.41121433E-10_JPRB, 0.40744762E-10_JPRB, 0.40334090E-10_JPRB, 0.39913739E-10_JPRB, 0.39505007E-10_JPRB, &
  & 0.39128263E-10_JPRB, 0.38790471E-10_JPRB, 0.38489167E-10_JPRB, 0.38226651E-10_JPRB, 0.38009249E-10_JPRB, 0.37838108E-10_JPRB, &
  & 0.37708052E-10_JPRB, 0.37612136E-10_JPRB, 0.37544579E-10_JPRB, 0.37497547E-10_JPRB, 0.37465399E-10_JPRB, 0.37443881E-10_JPRB, &
  & 0.37429108E-10_JPRB, 0.37418357E-10_JPRB, 0.37410474E-10_JPRB, 0.37401793E-10_JPRB /)

RGHG8(:, 4, 3) = (/ &
  & 0.35620246E-10_JPRB, 0.35758684E-10_JPRB, 0.35889066E-10_JPRB, 0.36043554E-10_JPRB, 0.36231431E-10_JPRB, 0.36455835E-10_JPRB, &
  & 0.36718548E-10_JPRB, 0.37016296E-10_JPRB, 0.37335392E-10_JPRB, 0.37668851E-10_JPRB, 0.38010449E-10_JPRB, 0.38355263E-10_JPRB, &
  & 0.38696775E-10_JPRB, 0.39026400E-10_JPRB, 0.39336166E-10_JPRB, 0.39614458E-10_JPRB, 0.39850841E-10_JPRB, 0.40033914E-10_JPRB, &
  & 0.40159695E-10_JPRB, 0.40241314E-10_JPRB, 0.40299809E-10_JPRB, 0.40354907E-10_JPRB, 0.40431061E-10_JPRB, 0.40552475E-10_JPRB, &
  & 0.40727446E-10_JPRB, 0.40946475E-10_JPRB, 0.41183446E-10_JPRB, 0.41421505E-10_JPRB, 0.41649090E-10_JPRB, 0.41849142E-10_JPRB, &
  & 0.42008945E-10_JPRB, 0.42153829E-10_JPRB, 0.42331184E-10_JPRB, 0.42588197E-10_JPRB, 0.42937293E-10_JPRB, 0.43377156E-10_JPRB, &
  & 0.43867861E-10_JPRB, 0.44365619E-10_JPRB, 0.44795237E-10_JPRB, 0.45063526E-10_JPRB, 0.45077858E-10_JPRB, 0.44802280E-10_JPRB, &
  & 0.44279209E-10_JPRB, 0.43599745E-10_JPRB, 0.42861787E-10_JPRB, 0.42136225E-10_JPRB, 0.41457813E-10_JPRB, 0.40843769E-10_JPRB, &
  & 0.40301942E-10_JPRB, 0.39825768E-10_JPRB, 0.39411634E-10_JPRB, 0.39059485E-10_JPRB, 0.38764002E-10_JPRB, 0.38516482E-10_JPRB, &
  & 0.38310702E-10_JPRB, 0.38143780E-10_JPRB, 0.38014168E-10_JPRB, 0.37915008E-10_JPRB, 0.37841990E-10_JPRB, 0.37789966E-10_JPRB, &
  & 0.37754015E-10_JPRB, 0.37729479E-10_JPRB, 0.37710012E-10_JPRB, 0.37684328E-10_JPRB /)

RGHG8(:, 5, 3) = (/ &
  & 0.35742166E-10_JPRB, 0.35945233E-10_JPRB, 0.36111020E-10_JPRB, 0.36299561E-10_JPRB, 0.36529023E-10_JPRB, 0.36802259E-10_JPRB, &
  & 0.37114659E-10_JPRB, 0.37460098E-10_JPRB, 0.37832348E-10_JPRB, 0.38221839E-10_JPRB, 0.38622685E-10_JPRB, 0.39029942E-10_JPRB, &
  & 0.39438990E-10_JPRB, 0.39847424E-10_JPRB, 0.40253009E-10_JPRB, 0.40660059E-10_JPRB, 0.41070404E-10_JPRB, 0.41486946E-10_JPRB, &
  & 0.41913525E-10_JPRB, 0.42356819E-10_JPRB, 0.42832723E-10_JPRB, 0.43363469E-10_JPRB, 0.43965408E-10_JPRB, 0.44628926E-10_JPRB, &
  & 0.45317632E-10_JPRB, 0.45988401E-10_JPRB, 0.46612228E-10_JPRB, 0.47168075E-10_JPRB, 0.47633605E-10_JPRB, 0.47979176E-10_JPRB, &
  & 0.48197963E-10_JPRB, 0.48302678E-10_JPRB, 0.48362189E-10_JPRB, 0.48464670E-10_JPRB, 0.48660770E-10_JPRB, 0.48956599E-10_JPRB, &
  & 0.49316481E-10_JPRB, 0.49665751E-10_JPRB, 0.49900719E-10_JPRB, 0.49890578E-10_JPRB, 0.49517286E-10_JPRB, 0.48755354E-10_JPRB, &
  & 0.47706467E-10_JPRB, 0.46558448E-10_JPRB, 0.45446820E-10_JPRB, 0.44434057E-10_JPRB, 0.43533413E-10_JPRB, 0.42736849E-10_JPRB, &
  & 0.42033550E-10_JPRB, 0.41411576E-10_JPRB, 0.40863771E-10_JPRB, 0.40382919E-10_JPRB, 0.39961288E-10_JPRB, 0.39594755E-10_JPRB, &
  & 0.39280926E-10_JPRB, 0.39016852E-10_JPRB, 0.38799831E-10_JPRB, 0.38625141E-10_JPRB, 0.38488497E-10_JPRB, 0.38385496E-10_JPRB, &
  & 0.38308585E-10_JPRB, 0.38249091E-10_JPRB, 0.38199201E-10_JPRB, 0.38131279E-10_JPRB /)

RGHG8(:, 6, 3) = (/ &
  & 0.35915132E-10_JPRB, 0.36153643E-10_JPRB, 0.36351904E-10_JPRB, 0.36582785E-10_JPRB, 0.36865094E-10_JPRB, 0.37201686E-10_JPRB, &
  & 0.37588477E-10_JPRB, 0.38016451E-10_JPRB, 0.38473849E-10_JPRB, 0.38956734E-10_JPRB, 0.39459751E-10_JPRB, 0.39971877E-10_JPRB, &
  & 0.40486441E-10_JPRB, 0.41000942E-10_JPRB, 0.41521550E-10_JPRB, 0.42057351E-10_JPRB, 0.42625348E-10_JPRB, 0.43244113E-10_JPRB, &
  & 0.43932729E-10_JPRB, 0.44714607E-10_JPRB, 0.45609554E-10_JPRB, 0.46632656E-10_JPRB, 0.47771058E-10_JPRB, 0.48972097E-10_JPRB, &
  & 0.50166506E-10_JPRB, 0.51290305E-10_JPRB, 0.52330251E-10_JPRB, 0.53276147E-10_JPRB, 0.54108541E-10_JPRB, 0.54798745E-10_JPRB, &
  & 0.55320616E-10_JPRB, 0.55654783E-10_JPRB, 0.55831516E-10_JPRB, 0.55921136E-10_JPRB, 0.55975651E-10_JPRB, 0.56013409E-10_JPRB, &
  & 0.56011671E-10_JPRB, 0.55909707E-10_JPRB, 0.55611678E-10_JPRB, 0.54998589E-10_JPRB, 0.53989688E-10_JPRB, 0.52624939E-10_JPRB, &
  & 0.51116444E-10_JPRB, 0.49654097E-10_JPRB, 0.48336050E-10_JPRB, 0.47173512E-10_JPRB, 0.46148481E-10_JPRB, 0.45234014E-10_JPRB, &
  & 0.44409448E-10_JPRB, 0.43659194E-10_JPRB, 0.42974877E-10_JPRB, 0.42350776E-10_JPRB, 0.41785388E-10_JPRB, 0.41278359E-10_JPRB, &
  & 0.40828341E-10_JPRB, 0.40435023E-10_JPRB, 0.40098948E-10_JPRB, 0.39818975E-10_JPRB, 0.39593169E-10_JPRB, 0.39416043E-10_JPRB, &
  & 0.39279031E-10_JPRB, 0.39171364E-10_JPRB, 0.39070965E-10_JPRB, 0.38935820E-10_JPRB /)

RGHG8(:, 7, 3) = (/ &
  & 0.36111246E-10_JPRB, 0.36382897E-10_JPRB, 0.36631500E-10_JPRB, 0.36935153E-10_JPRB, 0.37310738E-10_JPRB, 0.37762085E-10_JPRB, &
  & 0.38282526E-10_JPRB, 0.38861463E-10_JPRB, 0.39485228E-10_JPRB, 0.40142518E-10_JPRB, 0.40820042E-10_JPRB, 0.41500265E-10_JPRB, &
  & 0.42173012E-10_JPRB, 0.42829768E-10_JPRB, 0.43472087E-10_JPRB, 0.44114153E-10_JPRB, 0.44780294E-10_JPRB, 0.45502321E-10_JPRB, &
  & 0.46313387E-10_JPRB, 0.47246523E-10_JPRB, 0.48330537E-10_JPRB, 0.49584194E-10_JPRB, 0.51006397E-10_JPRB, 0.52556733E-10_JPRB, &
  & 0.54128407E-10_JPRB, 0.55665177E-10_JPRB, 0.57108162E-10_JPRB, 0.58457336E-10_JPRB, 0.59684487E-10_JPRB, 0.60756358E-10_JPRB, &
  & 0.61613090E-10_JPRB, 0.62219167E-10_JPRB, 0.62563274E-10_JPRB, 0.62679285E-10_JPRB, 0.62604325E-10_JPRB, 0.62366043E-10_JPRB, &
  & 0.61956551E-10_JPRB, 0.61333875E-10_JPRB, 0.60432041E-10_JPRB, 0.59187572E-10_JPRB, 0.57589815E-10_JPRB, 0.55791385E-10_JPRB, &
  & 0.54013891E-10_JPRB, 0.52414389E-10_JPRB, 0.51031564E-10_JPRB, 0.49844417E-10_JPRB, 0.48812038E-10_JPRB, 0.47881438E-10_JPRB, &
  & 0.47020367E-10_JPRB, 0.46212655E-10_JPRB, 0.45449963E-10_JPRB, 0.44729866E-10_JPRB, 0.44053958E-10_JPRB, 0.43426592E-10_JPRB, &
  & 0.42853554E-10_JPRB, 0.42340589E-10_JPRB, 0.41891119E-10_JPRB, 0.41507266E-10_JPRB, 0.41189441E-10_JPRB, 0.40934773E-10_JPRB, &
  & 0.40734201E-10_JPRB, 0.40568545E-10_JPRB, 0.40420334E-10_JPRB, 0.40195205E-10_JPRB /)

RGHG8(:, 8, 3) = (/ &
  & 0.36350346E-10_JPRB, 0.36741863E-10_JPRB, 0.37104181E-10_JPRB, 0.37532633E-10_JPRB, 0.38058522E-10_JPRB, 0.38688528E-10_JPRB, &
  & 0.39416449E-10_JPRB, 0.40227328E-10_JPRB, 0.41107888E-10_JPRB, 0.42043376E-10_JPRB, 0.43009946E-10_JPRB, 0.43979126E-10_JPRB, &
  & 0.44925761E-10_JPRB, 0.45825212E-10_JPRB, 0.46671354E-10_JPRB, 0.47475565E-10_JPRB, 0.48263879E-10_JPRB, 0.49072663E-10_JPRB, &
  & 0.49945124E-10_JPRB, 0.50926072E-10_JPRB, 0.52055360E-10_JPRB, 0.53364323E-10_JPRB, 0.54866722E-10_JPRB, 0.56520847E-10_JPRB, &
  & 0.58281470E-10_JPRB, 0.60026172E-10_JPRB, 0.61723057E-10_JPRB, 0.63310149E-10_JPRB, 0.64761807E-10_JPRB, 0.66015964E-10_JPRB, &
  & 0.67009079E-10_JPRB, 0.67672208E-10_JPRB, 0.67984077E-10_JPRB, 0.67963718E-10_JPRB, 0.67648664E-10_JPRB, 0.67075956E-10_JPRB, &
  & 0.66254793E-10_JPRB, 0.65169703E-10_JPRB, 0.63782847E-10_JPRB, 0.62073964E-10_JPRB, 0.60097927E-10_JPRB, 0.58026688E-10_JPRB, &
  & 0.56091062E-10_JPRB, 0.54442499E-10_JPRB, 0.53087777E-10_JPRB, 0.51959565E-10_JPRB, 0.50969298E-10_JPRB, 0.50071999E-10_JPRB, &
  & 0.49236726E-10_JPRB, 0.48441872E-10_JPRB, 0.47677081E-10_JPRB, 0.46938942E-10_JPRB, 0.46230922E-10_JPRB, 0.45560344E-10_JPRB, &
  & 0.44935160E-10_JPRB, 0.44363461E-10_JPRB, 0.43851801E-10_JPRB, 0.43406723E-10_JPRB, 0.43032300E-10_JPRB, 0.42727859E-10_JPRB, &
  & 0.42483326E-10_JPRB, 0.42283847E-10_JPRB, 0.42089394E-10_JPRB, 0.41818712E-10_JPRB /)

RGHG8(:, 9, 3) = (/ &
  & 0.36770378E-10_JPRB, 0.37418204E-10_JPRB, 0.37962446E-10_JPRB, 0.38585590E-10_JPRB, 0.39335833E-10_JPRB, 0.40231769E-10_JPRB, &
  & 0.41269859E-10_JPRB, 0.42438327E-10_JPRB, 0.43716839E-10_JPRB, 0.45076071E-10_JPRB, 0.46484261E-10_JPRB, 0.47906963E-10_JPRB, &
  & 0.49304335E-10_JPRB, 0.50630007E-10_JPRB, 0.51867583E-10_JPRB, 0.53016883E-10_JPRB, 0.54089053E-10_JPRB, 0.55112571E-10_JPRB, &
  & 0.56131631E-10_JPRB, 0.57194721E-10_JPRB, 0.58350172E-10_JPRB, 0.59627900E-10_JPRB, 0.61032741E-10_JPRB, 0.62555648E-10_JPRB, &
  & 0.64134351E-10_JPRB, 0.65730789E-10_JPRB, 0.67281410E-10_JPRB, 0.68759505E-10_JPRB, 0.70101015E-10_JPRB, 0.71229897E-10_JPRB, &
  & 0.72050088E-10_JPRB, 0.72486156E-10_JPRB, 0.72496356E-10_JPRB, 0.72100784E-10_JPRB, 0.71354700E-10_JPRB, 0.70317516E-10_JPRB, &
  & 0.69032835E-10_JPRB, 0.67515833E-10_JPRB, 0.65777814E-10_JPRB, 0.63814398E-10_JPRB, 0.61674235E-10_JPRB, 0.59518897E-10_JPRB, &
  & 0.57564117E-10_JPRB, 0.55896079E-10_JPRB, 0.54510729E-10_JPRB, 0.53341619E-10_JPRB, 0.52350246E-10_JPRB, 0.51486142E-10_JPRB, &
  & 0.50698473E-10_JPRB, 0.49957226E-10_JPRB, 0.49244983E-10_JPRB, 0.48554789E-10_JPRB, 0.47886094E-10_JPRB, 0.47243747E-10_JPRB, &
  & 0.46636854E-10_JPRB, 0.46074540E-10_JPRB, 0.45566554E-10_JPRB, 0.45120879E-10_JPRB, 0.44744940E-10_JPRB, 0.44439237E-10_JPRB, &
  & 0.44196532E-10_JPRB, 0.43992032E-10_JPRB, 0.43803464E-10_JPRB, 0.43511330E-10_JPRB /)

RGHG8(:,10, 3) = (/ &
  & 0.37644294E-10_JPRB, 0.38741350E-10_JPRB, 0.39602790E-10_JPRB, 0.40519664E-10_JPRB, 0.41585516E-10_JPRB, 0.42829563E-10_JPRB, &
  & 0.44258881E-10_JPRB, 0.45855757E-10_JPRB, 0.47599147E-10_JPRB, 0.49463409E-10_JPRB, 0.51412694E-10_JPRB, 0.53395052E-10_JPRB, &
  & 0.55355540E-10_JPRB, 0.57250461E-10_JPRB, 0.59048759E-10_JPRB, 0.60732655E-10_JPRB, 0.62293615E-10_JPRB, 0.63734976E-10_JPRB, &
  & 0.65071747E-10_JPRB, 0.66337727E-10_JPRB, 0.67558951E-10_JPRB, 0.68761559E-10_JPRB, 0.69949588E-10_JPRB, 0.71120963E-10_JPRB, &
  & 0.72267962E-10_JPRB, 0.73374667E-10_JPRB, 0.74438206E-10_JPRB, 0.75430370E-10_JPRB, 0.76301652E-10_JPRB, 0.76967016E-10_JPRB, &
  & 0.77314613E-10_JPRB, 0.77241553E-10_JPRB, 0.76696774E-10_JPRB, 0.75705123E-10_JPRB, 0.74346140E-10_JPRB, 0.72725943E-10_JPRB, &
  & 0.70934265E-10_JPRB, 0.69029248E-10_JPRB, 0.67003667E-10_JPRB, 0.64884535E-10_JPRB, 0.62700553E-10_JPRB, 0.60512179E-10_JPRB, &
  & 0.58431898E-10_JPRB, 0.56617516E-10_JPRB, 0.55124107E-10_JPRB, 0.53939124E-10_JPRB, 0.52967804E-10_JPRB, 0.52137322E-10_JPRB, &
  & 0.51402577E-10_JPRB, 0.50730656E-10_JPRB, 0.50097034E-10_JPRB, 0.49488521E-10_JPRB, 0.48899669E-10_JPRB, 0.48333698E-10_JPRB, &
  & 0.47796215E-10_JPRB, 0.47298127E-10_JPRB, 0.46848546E-10_JPRB, 0.46457761E-10_JPRB, 0.46131651E-10_JPRB, 0.45871397E-10_JPRB, &
  & 0.45662099E-10_JPRB, 0.45492717E-10_JPRB, 0.45322159E-10_JPRB, 0.45074423E-10_JPRB /)

RGHG8(:,11, 3) = (/ &
  & 0.39482806E-10_JPRB, 0.41368589E-10_JPRB, 0.42696034E-10_JPRB, 0.44025998E-10_JPRB, 0.45486545E-10_JPRB, 0.47132617E-10_JPRB, &
  & 0.48973697E-10_JPRB, 0.51003528E-10_JPRB, 0.53196104E-10_JPRB, 0.55516154E-10_JPRB, 0.57933394E-10_JPRB, 0.60402565E-10_JPRB, &
  & 0.62886682E-10_JPRB, 0.65332864E-10_JPRB, 0.67703662E-10_JPRB, 0.69966234E-10_JPRB, 0.72087357E-10_JPRB, 0.74034258E-10_JPRB, &
  & 0.75784150E-10_JPRB, 0.77322510E-10_JPRB, 0.78653660E-10_JPRB, 0.79785699E-10_JPRB, 0.80737965E-10_JPRB, 0.81521193E-10_JPRB, &
  & 0.82157899E-10_JPRB, 0.82669614E-10_JPRB, 0.83083582E-10_JPRB, 0.83401716E-10_JPRB, 0.83589149E-10_JPRB, 0.83565266E-10_JPRB, &
  & 0.83221575E-10_JPRB, 0.82454210E-10_JPRB, 0.81196758E-10_JPRB, 0.79464463E-10_JPRB, 0.77351403E-10_JPRB, 0.75051160E-10_JPRB, &
  & 0.72715028E-10_JPRB, 0.70421391E-10_JPRB, 0.68220402E-10_JPRB, 0.66018919E-10_JPRB, 0.63774597E-10_JPRB, 0.61536352E-10_JPRB, &
  & 0.59418519E-10_JPRB, 0.57521463E-10_JPRB, 0.55925327E-10_JPRB, 0.54610434E-10_JPRB, 0.53549283E-10_JPRB, 0.52676436E-10_JPRB, &
  & 0.51931934E-10_JPRB, 0.51270869E-10_JPRB, 0.50666839E-10_JPRB, 0.50101538E-10_JPRB, 0.49566466E-10_JPRB, 0.49060023E-10_JPRB, &
  & 0.48588050E-10_JPRB, 0.48157860E-10_JPRB, 0.47779176E-10_JPRB, 0.47458083E-10_JPRB, 0.47197631E-10_JPRB, 0.46991105E-10_JPRB, &
  & 0.46833058E-10_JPRB, 0.46696667E-10_JPRB, 0.46571642E-10_JPRB, 0.46370588E-10_JPRB /)

RGHG8(:,12, 3) = (/ &
  & 0.43265704E-10_JPRB, 0.46319563E-10_JPRB, 0.48334767E-10_JPRB, 0.50089308E-10_JPRB, 0.51930810E-10_JPRB, 0.53870648E-10_JPRB, &
  & 0.55959810E-10_JPRB, 0.58201784E-10_JPRB, 0.60595681E-10_JPRB, 0.63133720E-10_JPRB, 0.65794585E-10_JPRB, 0.68546266E-10_JPRB, &
  & 0.71346581E-10_JPRB, 0.74163266E-10_JPRB, 0.76953097E-10_JPRB, 0.79663248E-10_JPRB, 0.82237828E-10_JPRB, 0.84624315E-10_JPRB, &
  & 0.86734515E-10_JPRB, 0.88546753E-10_JPRB, 0.90014947E-10_JPRB, 0.91155333E-10_JPRB, 0.91963957E-10_JPRB, 0.92478247E-10_JPRB, &
  & 0.92729310E-10_JPRB, 0.92759266E-10_JPRB, 0.92597360E-10_JPRB, 0.92256112E-10_JPRB, 0.91719493E-10_JPRB, 0.90932858E-10_JPRB, &
  & 0.89817570E-10_JPRB, 0.88298251E-10_JPRB, 0.86333822E-10_JPRB, 0.83939862E-10_JPRB, 0.81249465E-10_JPRB, 0.78415455E-10_JPRB, &
  & 0.75615327E-10_JPRB, 0.73005983E-10_JPRB, 0.70586689E-10_JPRB, 0.68336635E-10_JPRB, 0.66150016E-10_JPRB, 0.63969156E-10_JPRB, &
  & 0.61821701E-10_JPRB, 0.59804488E-10_JPRB, 0.58008209E-10_JPRB, 0.56496096E-10_JPRB, 0.55232117E-10_JPRB, 0.54171084E-10_JPRB, &
  & 0.53258849E-10_JPRB, 0.52456796E-10_JPRB, 0.51737691E-10_JPRB, 0.51082839E-10_JPRB, 0.50481681E-10_JPRB, 0.49933120E-10_JPRB, &
  & 0.49439428E-10_JPRB, 0.49007538E-10_JPRB, 0.48640918E-10_JPRB, 0.48340831E-10_JPRB, 0.48103292E-10_JPRB, 0.47922902E-10_JPRB, &
  & 0.47780068E-10_JPRB, 0.47669334E-10_JPRB, 0.47557139E-10_JPRB, 0.47400431E-10_JPRB /)

RGHG8(:,13, 3) = (/ &
  & 0.50059495E-10_JPRB, 0.54387869E-10_JPRB, 0.56881506E-10_JPRB, 0.58886888E-10_JPRB, 0.60835517E-10_JPRB, 0.62812207E-10_JPRB, &
  & 0.64876521E-10_JPRB, 0.67060912E-10_JPRB, 0.69385407E-10_JPRB, 0.71868317E-10_JPRB, 0.74515803E-10_JPRB, 0.77305842E-10_JPRB, &
  & 0.80205134E-10_JPRB, 0.83157911E-10_JPRB, 0.86125135E-10_JPRB, 0.89049455E-10_JPRB, 0.91846114E-10_JPRB, 0.94455929E-10_JPRB, &
  & 0.96775352E-10_JPRB, 0.98748322E-10_JPRB, 0.10032627E-09_JPRB, 0.10149128E-09_JPRB, 0.10224917E-09_JPRB, 0.10263042E-09_JPRB, &
  & 0.10266859E-09_JPRB, 0.10239747E-09_JPRB, 0.10183632E-09_JPRB, 0.10099376E-09_JPRB, 0.99861258E-10_JPRB, 0.98416303E-10_JPRB, &
  & 0.96624701E-10_JPRB, 0.94456228E-10_JPRB, 0.91918619E-10_JPRB, 0.89065616E-10_JPRB, 0.85993462E-10_JPRB, 0.82931939E-10_JPRB, &
  & 0.80089484E-10_JPRB, 0.77565600E-10_JPRB, 0.75341532E-10_JPRB, 0.73310649E-10_JPRB, 0.71377376E-10_JPRB, 0.69454470E-10_JPRB, &
  & 0.67468628E-10_JPRB, 0.65442457E-10_JPRB, 0.63452882E-10_JPRB, 0.61566148E-10_JPRB, 0.59859603E-10_JPRB, 0.58342782E-10_JPRB, &
  & 0.56993632E-10_JPRB, 0.55780908E-10_JPRB, 0.54679674E-10_JPRB, 0.53676116E-10_JPRB, 0.52762350E-10_JPRB, 0.51938488E-10_JPRB, &
  & 0.51211028E-10_JPRB, 0.50586157E-10_JPRB, 0.50065448E-10_JPRB, 0.49645364E-10_JPRB, 0.49317578E-10_JPRB, 0.49065224E-10_JPRB, &
  & 0.48878464E-10_JPRB, 0.48721704E-10_JPRB, 0.48586371E-10_JPRB, 0.48385403E-10_JPRB /)

RGHG8(:,14, 3) = (/ &
  & 0.59837607E-10_JPRB, 0.64652214E-10_JPRB, 0.67176258E-10_JPRB, 0.69130889E-10_JPRB, 0.70943321E-10_JPRB, 0.72753241E-10_JPRB, &
  & 0.74630552E-10_JPRB, 0.76613590E-10_JPRB, 0.78733922E-10_JPRB, 0.81017436E-10_JPRB, 0.83478814E-10_JPRB, 0.86108079E-10_JPRB, &
  & 0.88888515E-10_JPRB, 0.91773762E-10_JPRB, 0.94710649E-10_JPRB, 0.97628891E-10_JPRB, 0.10044526E-09_JPRB, 0.10308009E-09_JPRB, &
  & 0.10544612E-09_JPRB, 0.10746157E-09_JPRB, 0.10906500E-09_JPRB, 0.11023701E-09_JPRB, 0.11097034E-09_JPRB, 0.11128339E-09_JPRB, &
  & 0.11120055E-09_JPRB, 0.11075590E-09_JPRB, 0.10996185E-09_JPRB, 0.10881727E-09_JPRB, 0.10731882E-09_JPRB, 0.10546918E-09_JPRB, &
  & 0.10327221E-09_JPRB, 0.10075943E-09_JPRB, 0.97984530E-10_JPRB, 0.95032808E-10_JPRB, 0.92057376E-10_JPRB, 0.89266691E-10_JPRB, &
  & 0.86838634E-10_JPRB, 0.84826778E-10_JPRB, 0.83152360E-10_JPRB, 0.81681488E-10_JPRB, 0.80303424E-10_JPRB, 0.78881950E-10_JPRB, &
  & 0.77271502E-10_JPRB, 0.75412079E-10_JPRB, 0.73322799E-10_JPRB, 0.71076534E-10_JPRB, 0.68808625E-10_JPRB, 0.66637966E-10_JPRB, &
  & 0.64619254E-10_JPRB, 0.62755245E-10_JPRB, 0.61028634E-10_JPRB, 0.59421849E-10_JPRB, 0.57926674E-10_JPRB, 0.56549074E-10_JPRB, &
  & 0.55304275E-10_JPRB, 0.54209675E-10_JPRB, 0.53275329E-10_JPRB, 0.52499317E-10_JPRB, 0.51875133E-10_JPRB, 0.51391801E-10_JPRB, &
  & 0.51008402E-10_JPRB, 0.50708156E-10_JPRB, 0.50415668E-10_JPRB, 0.50027357E-10_JPRB /)

RGHG8(:,15, 3) = (/ &
  & 0.70834123E-10_JPRB, 0.75276660E-10_JPRB, 0.77485990E-10_JPRB, 0.79236548E-10_JPRB, 0.80863066E-10_JPRB, 0.82491292E-10_JPRB, &
  & 0.84179122E-10_JPRB, 0.85963708E-10_JPRB, 0.87870780E-10_JPRB, 0.89929605E-10_JPRB, 0.92158718E-10_JPRB, 0.94558111E-10_JPRB, &
  & 0.97103610E-10_JPRB, 0.99767070E-10_JPRB, 0.10251523E-09_JPRB, 0.10527776E-09_JPRB, 0.10797602E-09_JPRB, 0.11051875E-09_JPRB, &
  & 0.11281537E-09_JPRB, 0.11477942E-09_JPRB, 0.11634460E-09_JPRB, 0.11747164E-09_JPRB, 0.11815963E-09_JPRB, 0.11841796E-09_JPRB, &
  & 0.11826523E-09_JPRB, 0.11772419E-09_JPRB, 0.11680527E-09_JPRB, 0.11552079E-09_JPRB, 0.11387356E-09_JPRB, 0.11187733E-09_JPRB, &
  & 0.10957146E-09_JPRB, 0.10701987E-09_JPRB, 0.10433833E-09_JPRB, 0.10164618E-09_JPRB, 0.99102088E-10_JPRB, 0.96895270E-10_JPRB, &
  & 0.95140049E-10_JPRB, 0.93853807E-10_JPRB, 0.92911456E-10_JPRB, 0.92145187E-10_JPRB, 0.91417277E-10_JPRB, 0.90549755E-10_JPRB, &
  & 0.89385763E-10_JPRB, 0.87817802E-10_JPRB, 0.85798542E-10_JPRB, 0.83400446E-10_JPRB, 0.80793004E-10_JPRB, 0.78152596E-10_JPRB, &
  & 0.75596550E-10_JPRB, 0.73171746E-10_JPRB, 0.70873814E-10_JPRB, 0.68679146E-10_JPRB, 0.66571790E-10_JPRB, 0.64557443E-10_JPRB, &
  & 0.62665255E-10_JPRB, 0.60934362E-10_JPRB, 0.59392019E-10_JPRB, 0.58060366E-10_JPRB, 0.56950382E-10_JPRB, 0.56048607E-10_JPRB, &
  & 0.55338852E-10_JPRB, 0.54732281E-10_JPRB, 0.54173541E-10_JPRB, 0.53359359E-10_JPRB /)

RGHG8(:,16, 3) = (/ &
  & 0.80990846E-10_JPRB, 0.84871138E-10_JPRB, 0.86841999E-10_JPRB, 0.88415865E-10_JPRB, 0.89905722E-10_JPRB, 0.91412315E-10_JPRB, &
  & 0.92980908E-10_JPRB, 0.94640899E-10_JPRB, 0.96416972E-10_JPRB, 0.98325313E-10_JPRB, 0.10037242E-09_JPRB, 0.10255078E-09_JPRB, &
  & 0.10484804E-09_JPRB, 0.10723728E-09_JPRB, 0.10970411E-09_JPRB, 0.11220838E-09_JPRB, 0.11469407E-09_JPRB, 0.11706668E-09_JPRB, &
  & 0.11923004E-09_JPRB, 0.12108582E-09_JPRB, 0.12256224E-09_JPRB, 0.12361642E-09_JPRB, 0.12423944E-09_JPRB, 0.12444350E-09_JPRB, &
  & 0.12424661E-09_JPRB, 0.12366547E-09_JPRB, 0.12273235E-09_JPRB, 0.12143019E-09_JPRB, 0.11977706E-09_JPRB, 0.11782413E-09_JPRB, &
  & 0.11563238E-09_JPRB, 0.11326932E-09_JPRB, 0.11087672E-09_JPRB, 0.10861480E-09_JPRB, 0.10664145E-09_JPRB, 0.10510247E-09_JPRB, &
  & 0.10407545E-09_JPRB, 0.10350841E-09_JPRB, 0.10325138E-09_JPRB, 0.10310689E-09_JPRB, 0.10289632E-09_JPRB, 0.10245557E-09_JPRB, &
  & 0.10164464E-09_JPRB, 0.10034209E-09_JPRB, 0.98495836E-10_JPRB, 0.96164264E-10_JPRB, 0.93510831E-10_JPRB, 0.90725476E-10_JPRB, &
  & 0.87951681E-10_JPRB, 0.85259071E-10_JPRB, 0.82653009E-10_JPRB, 0.80108170E-10_JPRB, 0.77597678E-10_JPRB, 0.75124892E-10_JPRB, &
  & 0.72721745E-10_JPRB, 0.70442312E-10_JPRB, 0.68342200E-10_JPRB, 0.66464334E-10_JPRB, 0.64849202E-10_JPRB, 0.63518808E-10_JPRB, &
  & 0.62416454E-10_JPRB, 0.61488648E-10_JPRB, 0.60572526E-10_JPRB, 0.59249765E-10_JPRB /)

RGHG8(:,17, 3) = (/ &
  & 0.89751477E-10_JPRB, 0.93251289E-10_JPRB, 0.95069515E-10_JPRB, 0.96576122E-10_JPRB, 0.98030715E-10_JPRB, 0.99525638E-10_JPRB, &
  & 0.10108706E-09_JPRB, 0.10272721E-09_JPRB, 0.10445231E-09_JPRB, 0.10627618E-09_JPRB, 0.10819211E-09_JPRB, 0.11018649E-09_JPRB, &
  & 0.11225212E-09_JPRB, 0.11438434E-09_JPRB, 0.11655996E-09_JPRB, 0.11877016E-09_JPRB, 0.12097602E-09_JPRB, 0.12310764E-09_JPRB, &
  & 0.12507306E-09_JPRB, 0.12676785E-09_JPRB, 0.12811524E-09_JPRB, 0.12906548E-09_JPRB, 0.12961059E-09_JPRB, 0.12976412E-09_JPRB, &
  & 0.12954555E-09_JPRB, 0.12899037E-09_JPRB, 0.12808013E-09_JPRB, 0.12688092E-09_JPRB, 0.12543791E-09_JPRB, 0.12372653E-09_JPRB, &
  & 0.12181081E-09_JPRB, 0.11981094E-09_JPRB, 0.11785743E-09_JPRB, 0.11610078E-09_JPRB, 0.11469101E-09_JPRB, 0.11375374E-09_JPRB, &
  & 0.11331048E-09_JPRB, 0.11326479E-09_JPRB, 0.11343666E-09_JPRB, 0.11363591E-09_JPRB, 0.11369402E-09_JPRB, 0.11348085E-09_JPRB, &
  & 0.11286543E-09_JPRB, 0.11173946E-09_JPRB, 0.11005615E-09_JPRB, 0.10787007E-09_JPRB, 0.10533236E-09_JPRB, 0.10262301E-09_JPRB, &
  & 0.99879452E-10_JPRB, 0.97170688E-10_JPRB, 0.94510323E-10_JPRB, 0.91871219E-10_JPRB, 0.89225932E-10_JPRB, 0.86568849E-10_JPRB, &
  & 0.83930335E-10_JPRB, 0.81368086E-10_JPRB, 0.78944649E-10_JPRB, 0.76733141E-10_JPRB, 0.74798993E-10_JPRB, 0.73162573E-10_JPRB, &
  & 0.71808712E-10_JPRB, 0.70622459E-10_JPRB, 0.69446525E-10_JPRB, 0.67700963E-10_JPRB /)

RGHG8(:,18, 3) = (/ &
  & 0.97299391E-10_JPRB, 0.10063215E-09_JPRB, 0.10243865E-09_JPRB, 0.10394595E-09_JPRB, 0.10540547E-09_JPRB, 0.10690795E-09_JPRB, &
  & 0.10848162E-09_JPRB, 0.11013143E-09_JPRB, 0.11184850E-09_JPRB, 0.11363390E-09_JPRB, 0.11548169E-09_JPRB, 0.11735110E-09_JPRB, &
  & 0.11924342E-09_JPRB, 0.12116133E-09_JPRB, 0.12308352E-09_JPRB, 0.12501740E-09_JPRB, 0.12693525E-09_JPRB, 0.12878983E-09_JPRB, &
  & 0.13050805E-09_JPRB, 0.13199479E-09_JPRB, 0.13317249E-09_JPRB, 0.13399451E-09_JPRB, 0.13445178E-09_JPRB, 0.13455909E-09_JPRB, &
  & 0.13434651E-09_JPRB, 0.13383704E-09_JPRB, 0.13307778E-09_JPRB, 0.13214015E-09_JPRB, 0.13093439E-09_JPRB, 0.12957359E-09_JPRB, &
  & 0.12811080E-09_JPRB, 0.12663283E-09_JPRB, 0.12523518E-09_JPRB, 0.12404036E-09_JPRB, 0.12317199E-09_JPRB, 0.12270522E-09_JPRB, &
  & 0.12263307E-09_JPRB, 0.12284872E-09_JPRB, 0.12317612E-09_JPRB, 0.12345505E-09_JPRB, 0.12354043E-09_JPRB, 0.12331948E-09_JPRB, &
  & 0.12269481E-09_JPRB, 0.12158730E-09_JPRB, 0.11997031E-09_JPRB, 0.11790009E-09_JPRB, 0.11551142E-09_JPRB, 0.11295434E-09_JPRB, &
  & 0.11035076E-09_JPRB, 0.10776718E-09_JPRB, 0.10520873E-09_JPRB, 0.10265533E-09_JPRB, 0.10007992E-09_JPRB, 0.97476097E-10_JPRB, &
  & 0.94863686E-10_JPRB, 0.92292209E-10_JPRB, 0.89828686E-10_JPRB, 0.87548656E-10_JPRB, 0.85529285E-10_JPRB, 0.83814483E-10_JPRB, &
  & 0.82366787E-10_JPRB, 0.81082238E-10_JPRB, 0.79809014E-10_JPRB, 0.77820445E-10_JPRB /)

RGHG8(:,19, 3) = (/ &
  & 0.10390155E-09_JPRB, 0.10713690E-09_JPRB, 0.10892968E-09_JPRB, 0.11046340E-09_JPRB, 0.11195478E-09_JPRB, 0.11348446E-09_JPRB, &
  & 0.11508134E-09_JPRB, 0.11675563E-09_JPRB, 0.11848930E-09_JPRB, 0.12027135E-09_JPRB, 0.12209482E-09_JPRB, 0.12389789E-09_JPRB, &
  & 0.12566906E-09_JPRB, 0.12742322E-09_JPRB, 0.12914264E-09_JPRB, 0.13083863E-09_JPRB, 0.13249267E-09_JPRB, 0.13407281E-09_JPRB, &
  & 0.13552655E-09_JPRB, 0.13678161E-09_JPRB, 0.13777379E-09_JPRB, 0.13845984E-09_JPRB, 0.13883089E-09_JPRB, 0.13890665E-09_JPRB, &
  & 0.13872040E-09_JPRB, 0.13831944E-09_JPRB, 0.13778359E-09_JPRB, 0.13702686E-09_JPRB, 0.13620886E-09_JPRB, 0.13530155E-09_JPRB, &
  & 0.13437283E-09_JPRB, 0.13348565E-09_JPRB, 0.13268592E-09_JPRB, 0.13206292E-09_JPRB, 0.13168350E-09_JPRB, 0.13156265E-09_JPRB, &
  & 0.13167291E-09_JPRB, 0.13192719E-09_JPRB, 0.13219585E-09_JPRB, 0.13233289E-09_JPRB, 0.13224405E-09_JPRB, 0.13185016E-09_JPRB, &
  & 0.13108438E-09_JPRB, 0.12989308E-09_JPRB, 0.12826518E-09_JPRB, 0.12626028E-09_JPRB, 0.12399258E-09_JPRB, 0.12159293E-09_JPRB, &
  & 0.11916555E-09_JPRB, 0.11674957E-09_JPRB, 0.11435521E-09_JPRB, 0.11196918E-09_JPRB, 0.10957377E-09_JPRB, 0.10716234E-09_JPRB, &
  & 0.10474819E-09_JPRB, 0.10236605E-09_JPRB, 0.10006787E-09_JPRB, 0.97924210E-10_JPRB, 0.96013503E-10_JPRB, 0.94373280E-10_JPRB, &
  & 0.92967231E-10_JPRB, 0.91734509E-10_JPRB, 0.90433640E-10_JPRB, 0.88514807E-10_JPRB /)

RGHG8(:,20, 3) = (/ &
  & 0.10970790E-09_JPRB, 0.11287515E-09_JPRB, 0.11464020E-09_JPRB, 0.11617826E-09_JPRB, 0.11769091E-09_JPRB, 0.11924285E-09_JPRB, &
  & 0.12085843E-09_JPRB, 0.12254675E-09_JPRB, 0.12429235E-09_JPRB, 0.12606739E-09_JPRB, 0.12786817E-09_JPRB, 0.12962939E-09_JPRB, &
  & 0.13131680E-09_JPRB, 0.13294821E-09_JPRB, 0.13451334E-09_JPRB, 0.13601537E-09_JPRB, 0.13744936E-09_JPRB, 0.13879221E-09_JPRB, &
  & 0.14001054E-09_JPRB, 0.14105661E-09_JPRB, 0.14188029E-09_JPRB, 0.14244828E-09_JPRB, 0.14275352E-09_JPRB, 0.14281379E-09_JPRB, &
  & 0.14266852E-09_JPRB, 0.14238363E-09_JPRB, 0.14196189E-09_JPRB, 0.14151405E-09_JPRB, 0.14106089E-09_JPRB, 0.14062923E-09_JPRB, &
  & 0.14023371E-09_JPRB, 0.13989823E-09_JPRB, 0.13964634E-09_JPRB, 0.13951337E-09_JPRB, 0.13950566E-09_JPRB, 0.13962084E-09_JPRB, &
  & 0.13981985E-09_JPRB, 0.14000683E-09_JPRB, 0.14008560E-09_JPRB, 0.13997670E-09_JPRB, 0.13962594E-09_JPRB, 0.13898710E-09_JPRB, &
  & 0.13802355E-09_JPRB, 0.13670320E-09_JPRB, 0.13503504E-09_JPRB, 0.13307322E-09_JPRB, 0.13092330E-09_JPRB, 0.12868519E-09_JPRB, &
  & 0.12642189E-09_JPRB, 0.12417761E-09_JPRB, 0.12196716E-09_JPRB, 0.11978572E-09_JPRB, 0.11762245E-09_JPRB, 0.11547217E-09_JPRB, &
  & 0.11333908E-09_JPRB, 0.11124161E-09_JPRB, 0.10921403E-09_JPRB, 0.10731183E-09_JPRB, 0.10559690E-09_JPRB, 0.10410516E-09_JPRB, &
  & 0.10283360E-09_JPRB, 0.10165548E-09_JPRB, 0.10050116E-09_JPRB, 0.98604777E-10_JPRB /)

RGHG8(:,21, 3) = (/ &
  & 0.11481948E-09_JPRB, 0.11789685E-09_JPRB, 0.11961986E-09_JPRB, 0.12111909E-09_JPRB, 0.12260945E-09_JPRB, 0.12415192E-09_JPRB, &
  & 0.12576408E-09_JPRB, 0.12744712E-09_JPRB, 0.12918337E-09_JPRB, 0.13094231E-09_JPRB, 0.13270221E-09_JPRB, 0.13441855E-09_JPRB, &
  & 0.13604409E-09_JPRB, 0.13758338E-09_JPRB, 0.13903657E-09_JPRB, 0.14039682E-09_JPRB, 0.14166576E-09_JPRB, 0.14283318E-09_JPRB, &
  & 0.14387815E-09_JPRB, 0.14476949E-09_JPRB, 0.14547338E-09_JPRB, 0.14596750E-09_JPRB, 0.14624511E-09_JPRB, 0.14632595E-09_JPRB, &
  & 0.14625301E-09_JPRB, 0.14605316E-09_JPRB, 0.14581450E-09_JPRB, 0.14560700E-09_JPRB, 0.14545190E-09_JPRB, 0.14537635E-09_JPRB, &
  & 0.14540096E-09_JPRB, 0.14549915E-09_JPRB, 0.14567657E-09_JPRB, 0.14589235E-09_JPRB, 0.14613483E-09_JPRB, 0.14636388E-09_JPRB, &
  & 0.14653587E-09_JPRB, 0.14658109E-09_JPRB, 0.14644957E-09_JPRB, 0.14610109E-09_JPRB, 0.14551035E-09_JPRB, 0.14465960E-09_JPRB, &
  & 0.14353234E-09_JPRB, 0.14212120E-09_JPRB, 0.14043963E-09_JPRB, 0.13854475E-09_JPRB, 0.13651082E-09_JPRB, 0.13441188E-09_JPRB, &
  & 0.13231337E-09_JPRB, 0.13025768E-09_JPRB, 0.12825138E-09_JPRB, 0.12629496E-09_JPRB, 0.12438311E-09_JPRB, 0.12250936E-09_JPRB, &
  & 0.12067131E-09_JPRB, 0.11887336E-09_JPRB, 0.11713173E-09_JPRB, 0.11548011E-09_JPRB, 0.11397256E-09_JPRB, 0.11264346E-09_JPRB, &
  & 0.11146570E-09_JPRB, 0.11042175E-09_JPRB, 0.10927990E-09_JPRB, 0.10760041E-09_JPRB /)

RGHG8(:,22, 3) = (/ &
  & 0.11932430E-09_JPRB, 0.12224978E-09_JPRB, 0.12393184E-09_JPRB, 0.12538572E-09_JPRB, 0.12682229E-09_JPRB, 0.12831625E-09_JPRB, &
  & 0.12988766E-09_JPRB, 0.13153177E-09_JPRB, 0.13322800E-09_JPRB, 0.13494246E-09_JPRB, 0.13664675E-09_JPRB, 0.13830391E-09_JPRB, &
  & 0.13987310E-09_JPRB, 0.14134086E-09_JPRB, 0.14270946E-09_JPRB, 0.14397630E-09_JPRB, 0.14514021E-09_JPRB, 0.14619682E-09_JPRB, &
  & 0.14713444E-09_JPRB, 0.14793472E-09_JPRB, 0.14857576E-09_JPRB, 0.14904215E-09_JPRB, 0.14933288E-09_JPRB, 0.14946501E-09_JPRB, &
  & 0.14945874E-09_JPRB, 0.14937954E-09_JPRB, 0.14928810E-09_JPRB, 0.14924058E-09_JPRB, 0.14928102E-09_JPRB, 0.14944405E-09_JPRB, &
  & 0.14971188E-09_JPRB, 0.15007388E-09_JPRB, 0.15048032E-09_JPRB, 0.15087372E-09_JPRB, 0.15122099E-09_JPRB, 0.15146878E-09_JPRB, &
  & 0.15157328E-09_JPRB, 0.15149153E-09_JPRB, 0.15119579E-09_JPRB, 0.15067546E-09_JPRB, 0.14992528E-09_JPRB, 0.14894580E-09_JPRB, &
  & 0.14773767E-09_JPRB, 0.14630544E-09_JPRB, 0.14466889E-09_JPRB, 0.14286836E-09_JPRB, 0.14096502E-09_JPRB, 0.13903056E-09_JPRB, &
  & 0.13712478E-09_JPRB, 0.13526644E-09_JPRB, 0.13346840E-09_JPRB, 0.13173777E-09_JPRB, 0.13006930E-09_JPRB, 0.12845394E-09_JPRB, &
  & 0.12688264E-09_JPRB, 0.12534891E-09_JPRB, 0.12385631E-09_JPRB, 0.12242557E-09_JPRB, 0.12109130E-09_JPRB, 0.11988474E-09_JPRB, &
  & 0.11881718E-09_JPRB, 0.11779820E-09_JPRB, 0.11678447E-09_JPRB, 0.11511202E-09_JPRB /)

RGHG8(:,23, 3) = (/ &
  & 0.12326867E-09_JPRB, 0.12605238E-09_JPRB, 0.12763639E-09_JPRB, 0.12902829E-09_JPRB, 0.13040743E-09_JPRB, 0.13183821E-09_JPRB, &
  & 0.13334517E-09_JPRB, 0.13492403E-09_JPRB, 0.13655180E-09_JPRB, 0.13820013E-09_JPRB, 0.13983455E-09_JPRB, 0.14142440E-09_JPRB, &
  & 0.14293811E-09_JPRB, 0.14435295E-09_JPRB, 0.14566237E-09_JPRB, 0.14686707E-09_JPRB, 0.14796754E-09_JPRB, 0.14896238E-09_JPRB, &
  & 0.14984483E-09_JPRB, 0.15060611E-09_JPRB, 0.15123042E-09_JPRB, 0.15170845E-09_JPRB, 0.15203991E-09_JPRB, 0.15223384E-09_JPRB, &
  & 0.15231694E-09_JPRB, 0.15233524E-09_JPRB, 0.15234666E-09_JPRB, 0.15240695E-09_JPRB, 0.15256790E-09_JPRB, 0.15284056E-09_JPRB, &
  & 0.15323307E-09_JPRB, 0.15369990E-09_JPRB, 0.15417997E-09_JPRB, 0.15461850E-09_JPRB, 0.15496071E-09_JPRB, 0.15515800E-09_JPRB, &
  & 0.15517393E-09_JPRB, 0.15498075E-09_JPRB, 0.15457155E-09_JPRB, 0.15394797E-09_JPRB, 0.15311875E-09_JPRB, 0.15209305E-09_JPRB, &
  & 0.15088350E-09_JPRB, 0.14949850E-09_JPRB, 0.14795350E-09_JPRB, 0.14628183E-09_JPRB, 0.14454231E-09_JPRB, 0.14279894E-09_JPRB, &
  & 0.14108315E-09_JPRB, 0.13941776E-09_JPRB, 0.13782753E-09_JPRB, 0.13631263E-09_JPRB, 0.13486610E-09_JPRB, 0.13347565E-09_JPRB, &
  & 0.13212653E-09_JPRB, 0.13080682E-09_JPRB, 0.12951197E-09_JPRB, 0.12825158E-09_JPRB, 0.12705473E-09_JPRB, 0.12594742E-09_JPRB, &
  & 0.12492429E-09_JPRB, 0.12397802E-09_JPRB, 0.12293529E-09_JPRB, 0.12134965E-09_JPRB /)

RGHG8(:,24, 3) = (/ &
  & 0.12676629E-09_JPRB, 0.12936840E-09_JPRB, 0.13085677E-09_JPRB, 0.13216481E-09_JPRB, 0.13346850E-09_JPRB, 0.13482675E-09_JPRB, &
  & 0.13625824E-09_JPRB, 0.13775701E-09_JPRB, 0.13930135E-09_JPRB, 0.14086464E-09_JPRB, 0.14242145E-09_JPRB, 0.14393996E-09_JPRB, &
  & 0.14539316E-09_JPRB, 0.14676071E-09_JPRB, 0.14803023E-09_JPRB, 0.14919754E-09_JPRB, 0.15026404E-09_JPRB, 0.15123020E-09_JPRB, &
  & 0.15209300E-09_JPRB, 0.15284760E-09_JPRB, 0.15348350E-09_JPRB, 0.15399598E-09_JPRB, 0.15438076E-09_JPRB, 0.15464353E-09_JPRB, &
  & 0.15481080E-09_JPRB, 0.15491224E-09_JPRB, 0.15500154E-09_JPRB, 0.15513303E-09_JPRB, 0.15534671E-09_JPRB, 0.15566581E-09_JPRB, &
  & 0.15608388E-09_JPRB, 0.15655219E-09_JPRB, 0.15701339E-09_JPRB, 0.15741082E-09_JPRB, 0.15768668E-09_JPRB, 0.15779987E-09_JPRB, &
  & 0.15772322E-09_JPRB, 0.15743933E-09_JPRB, 0.15695474E-09_JPRB, 0.15627936E-09_JPRB, 0.15543104E-09_JPRB, 0.15442267E-09_JPRB, &
  & 0.15326866E-09_JPRB, 0.15197800E-09_JPRB, 0.15056065E-09_JPRB, 0.14904747E-09_JPRB, 0.14748759E-09_JPRB, 0.14592069E-09_JPRB, &
  & 0.14438291E-09_JPRB, 0.14291152E-09_JPRB, 0.14151418E-09_JPRB, 0.14019408E-09_JPRB, 0.13894064E-09_JPRB, 0.13773660E-09_JPRB, &
  & 0.13656420E-09_JPRB, 0.13540850E-09_JPRB, 0.13426217E-09_JPRB, 0.13313005E-09_JPRB, 0.13203220E-09_JPRB, 0.13099161E-09_JPRB, &
  & 0.13001923E-09_JPRB, 0.12906730E-09_JPRB, 0.12807135E-09_JPRB, 0.12645396E-09_JPRB /)

RGHG8(:,25, 3) = (/ &
  & 0.12988204E-09_JPRB, 0.13229827E-09_JPRB, 0.13369396E-09_JPRB, 0.13491291E-09_JPRB, 0.13612947E-09_JPRB, 0.13740420E-09_JPRB, &
  & 0.13874976E-09_JPRB, 0.14015922E-09_JPRB, 0.14161217E-09_JPRB, 0.14308627E-09_JPRB, 0.14455966E-09_JPRB, 0.14601016E-09_JPRB, &
  & 0.14741061E-09_JPRB, 0.14873477E-09_JPRB, 0.14996912E-09_JPRB, 0.15110865E-09_JPRB, 0.15215343E-09_JPRB, 0.15310461E-09_JPRB, &
  & 0.15396148E-09_JPRB, 0.15472218E-09_JPRB, 0.15538072E-09_JPRB, 0.15593157E-09_JPRB, 0.15636956E-09_JPRB, 0.15669907E-09_JPRB, &
  & 0.15694007E-09_JPRB, 0.15711471E-09_JPRB, 0.15726963E-09_JPRB, 0.15744643E-09_JPRB, 0.15768456E-09_JPRB, 0.15800533E-09_JPRB, &
  & 0.15839158E-09_JPRB, 0.15881021E-09_JPRB, 0.15920378E-09_JPRB, 0.15951863E-09_JPRB, 0.15970505E-09_JPRB, 0.15972754E-09_JPRB, &
  & 0.15956624E-09_JPRB, 0.15921441E-09_JPRB, 0.15868765E-09_JPRB, 0.15800156E-09_JPRB, 0.15717415E-09_JPRB, 0.15622018E-09_JPRB, &
  & 0.15515356E-09_JPRB, 0.15397905E-09_JPRB, 0.15270374E-09_JPRB, 0.15135036E-09_JPRB, 0.14995241E-09_JPRB, 0.14855218E-09_JPRB, &
  & 0.14719510E-09_JPRB, 0.14589863E-09_JPRB, 0.14467584E-09_JPRB, 0.14352569E-09_JPRB, 0.14243390E-09_JPRB, 0.14138067E-09_JPRB, &
  & 0.14034608E-09_JPRB, 0.13931468E-09_JPRB, 0.13827696E-09_JPRB, 0.13723771E-09_JPRB, 0.13621443E-09_JPRB, 0.13522602E-09_JPRB, &
  & 0.13427830E-09_JPRB, 0.13335608E-09_JPRB, 0.13234261E-09_JPRB, 0.13071726E-09_JPRB /)

RGHG8(:,26, 3) = (/ &
  & 0.13269652E-09_JPRB, 0.13494453E-09_JPRB, 0.13622646E-09_JPRB, 0.13735856E-09_JPRB, 0.13848926E-09_JPRB, 0.13967059E-09_JPRB, &
  & 0.14092720E-09_JPRB, 0.14224177E-09_JPRB, 0.14359762E-09_JPRB, 0.14497814E-09_JPRB, 0.14636695E-09_JPRB, 0.14774261E-09_JPRB, &
  & 0.14908501E-09_JPRB, 0.15037059E-09_JPRB, 0.15157839E-09_JPRB, 0.15269806E-09_JPRB, 0.15372860E-09_JPRB, 0.15467133E-09_JPRB, &
  & 0.15552731E-09_JPRB, 0.15629631E-09_JPRB, 0.15697466E-09_JPRB, 0.15755809E-09_JPRB, 0.15804175E-09_JPRB, 0.15842982E-09_JPRB, &
  & 0.15873378E-09_JPRB, 0.15897386E-09_JPRB, 0.15918168E-09_JPRB, 0.15939289E-09_JPRB, 0.15964234E-09_JPRB, 0.15993709E-09_JPRB, &
  & 0.16027497E-09_JPRB, 0.16061907E-09_JPRB, 0.16092551E-09_JPRB, 0.16114708E-09_JPRB, 0.16124314E-09_JPRB, 0.16118464E-09_JPRB, &
  & 0.16095809E-09_JPRB, 0.16056581E-09_JPRB, 0.16002463E-09_JPRB, 0.15935572E-09_JPRB, 0.15857655E-09_JPRB, 0.15769930E-09_JPRB, &
  & 0.15673253E-09_JPRB, 0.15567887E-09_JPRB, 0.15454023E-09_JPRB, 0.15333344E-09_JPRB, 0.15208797E-09_JPRB, 0.15084956E-09_JPRB, &
  & 0.14964870E-09_JPRB, 0.14850644E-09_JPRB, 0.14743345E-09_JPRB, 0.14642462E-09_JPRB, 0.14546435E-09_JPRB, 0.14453087E-09_JPRB, &
  & 0.14360310E-09_JPRB, 0.14266512E-09_JPRB, 0.14170937E-09_JPRB, 0.14073878E-09_JPRB, 0.13977020E-09_JPRB, 0.13882238E-09_JPRB, &
  & 0.13790334E-09_JPRB, 0.13698945E-09_JPRB, 0.13598542E-09_JPRB, 0.13436754E-09_JPRB /)

RGHG8(:,27, 3) = (/ &
  & 0.13528102E-09_JPRB, 0.13733026E-09_JPRB, 0.13852469E-09_JPRB, 0.13956897E-09_JPRB, 0.14061256E-09_JPRB, 0.14171112E-09_JPRB, &
  & 0.14287013E-09_JPRB, 0.14409142E-09_JPRB, 0.14535065E-09_JPRB, 0.14663849E-09_JPRB, 0.14794402E-09_JPRB, 0.14925285E-09_JPRB, &
  & 0.15054015E-09_JPRB, 0.15177982E-09_JPRB, 0.15295423E-09_JPRB, 0.15405255E-09_JPRB, 0.15507079E-09_JPRB, 0.15600757E-09_JPRB, &
  & 0.15686252E-09_JPRB, 0.15763522E-09_JPRB, 0.15832499E-09_JPRB, 0.15892962E-09_JPRB, 0.15944666E-09_JPRB, 0.15987961E-09_JPRB, &
  & 0.16023553E-09_JPRB, 0.16053074E-09_JPRB, 0.16078457E-09_JPRB, 0.16102461E-09_JPRB, 0.16127076E-09_JPRB, 0.16153583E-09_JPRB, &
  & 0.16181462E-09_JPRB, 0.16208086E-09_JPRB, 0.16230042E-09_JPRB, 0.16243516E-09_JPRB, 0.16245275E-09_JPRB, 0.16233008E-09_JPRB, &
  & 0.16205892E-09_JPRB, 0.16164789E-09_JPRB, 0.16112041E-09_JPRB, 0.16049587E-09_JPRB, 0.15978315E-09_JPRB, 0.15899194E-09_JPRB, &
  & 0.15812837E-09_JPRB, 0.15718951E-09_JPRB, 0.15617939E-09_JPRB, 0.15510544E-09_JPRB, 0.15400005E-09_JPRB, 0.15289969E-09_JPRB, &
  & 0.15183337E-09_JPRB, 0.15082341E-09_JPRB, 0.14987360E-09_JPRB, 0.14897869E-09_JPRB, 0.14812236E-09_JPRB, 0.14728220E-09_JPRB, &
  & 0.14643717E-09_JPRB, 0.14557248E-09_JPRB, 0.14467899E-09_JPRB, 0.14376220E-09_JPRB, 0.14283721E-09_JPRB, 0.14192329E-09_JPRB, &
  & 0.14103081E-09_JPRB, 0.14013900E-09_JPRB, 0.13916421E-09_JPRB, 0.13754312E-09_JPRB /)

RGHG8(:,28, 3) = (/ &
  & 0.13763875E-09_JPRB, 0.13954453E-09_JPRB, 0.14062816E-09_JPRB, 0.14159461E-09_JPRB, 0.14256100E-09_JPRB, 0.14357017E-09_JPRB, &
  & 0.14464401E-09_JPRB, 0.14576852E-09_JPRB, 0.14693416E-09_JPRB, 0.14813042E-09_JPRB, 0.14935289E-09_JPRB, 0.15058715E-09_JPRB, &
  & 0.15181796E-09_JPRB, 0.15302173E-09_JPRB, 0.15417279E-09_JPRB, 0.15525377E-09_JPRB, 0.15625833E-09_JPRB, 0.15718465E-09_JPRB, &
  & 0.15803249E-09_JPRB, 0.15880176E-09_JPRB, 0.15949275E-09_JPRB, 0.16010619E-09_JPRB, 0.16064212E-09_JPRB, 0.16110392E-09_JPRB, &
  & 0.16149623E-09_JPRB, 0.16182974E-09_JPRB, 0.16211690E-09_JPRB, 0.16237531E-09_JPRB, 0.16261559E-09_JPRB, 0.16285061E-09_JPRB, &
  & 0.16307469E-09_JPRB, 0.16327101E-09_JPRB, 0.16341452E-09_JPRB, 0.16347672E-09_JPRB, 0.16343289E-09_JPRB, 0.16326610E-09_JPRB, &
  & 0.16297488E-09_JPRB, 0.16257291E-09_JPRB, 0.16207828E-09_JPRB, 0.16150750E-09_JPRB, 0.16087057E-09_JPRB, 0.16016981E-09_JPRB, &
  & 0.15940609E-09_JPRB, 0.15857698E-09_JPRB, 0.15767870E-09_JPRB, 0.15672609E-09_JPRB, 0.15574200E-09_JPRB, 0.15476012E-09_JPRB, &
  & 0.15380980E-09_JPRB, 0.15290619E-09_JPRB, 0.15205447E-09_JPRB, 0.15124882E-09_JPRB, 0.15047232E-09_JPRB, 0.14970425E-09_JPRB, &
  & 0.14892525E-09_JPRB, 0.14811791E-09_JPRB, 0.14727719E-09_JPRB, 0.14640297E-09_JPRB, 0.14551382E-09_JPRB, 0.14462967E-09_JPRB, &
  & 0.14376156E-09_JPRB, 0.14289762E-09_JPRB, 0.14193544E-09_JPRB, 0.14037517E-09_JPRB /)

RGHG8(:,29, 3) = (/ &
  & 0.13982934E-09_JPRB, 0.14156581E-09_JPRB, 0.14258451E-09_JPRB, 0.14346985E-09_JPRB, 0.14435932E-09_JPRB, 0.14529625E-09_JPRB, &
  & 0.14628061E-09_JPRB, 0.14731780E-09_JPRB, 0.14839313E-09_JPRB, 0.14950308E-09_JPRB, 0.15064672E-09_JPRB, 0.15181720E-09_JPRB, &
  & 0.15299242E-09_JPRB, 0.15415065E-09_JPRB, 0.15527142E-09_JPRB, 0.15633363E-09_JPRB, 0.15732596E-09_JPRB, 0.15824286E-09_JPRB, &
  & 0.15908230E-09_JPRB, 0.15984376E-09_JPRB, 0.16052937E-09_JPRB, 0.16114084E-09_JPRB, 0.16168235E-09_JPRB, 0.16215684E-09_JPRB, &
  & 0.16256925E-09_JPRB, 0.16292391E-09_JPRB, 0.16322976E-09_JPRB, 0.16349455E-09_JPRB, 0.16372594E-09_JPRB, 0.16393216E-09_JPRB, &
  & 0.16410950E-09_JPRB, 0.16424719E-09_JPRB, 0.16432995E-09_JPRB, 0.16433591E-09_JPRB, 0.16424884E-09_JPRB, 0.16405724E-09_JPRB, &
  & 0.16376342E-09_JPRB, 0.16338116E-09_JPRB, 0.16293214E-09_JPRB, 0.16242918E-09_JPRB, 0.16187258E-09_JPRB, 0.16126087E-09_JPRB, &
  & 0.16059312E-09_JPRB, 0.15986165E-09_JPRB, 0.15906855E-09_JPRB, 0.15821941E-09_JPRB, 0.15734082E-09_JPRB, 0.15646065E-09_JPRB, &
  & 0.15560350E-09_JPRB, 0.15478634E-09_JPRB, 0.15401191E-09_JPRB, 0.15327400E-09_JPRB, 0.15255955E-09_JPRB, 0.15184795E-09_JPRB, &
  & 0.15112137E-09_JPRB, 0.15036382E-09_JPRB, 0.14956594E-09_JPRB, 0.14873044E-09_JPRB, 0.14787110E-09_JPRB, 0.14701047E-09_JPRB, &
  & 0.14616448E-09_JPRB, 0.14532289E-09_JPRB, 0.14440676E-09_JPRB, 0.14288074E-09_JPRB /)

RGHG8(:,30, 3) = (/ &
  & 0.14183536E-09_JPRB, 0.14346385E-09_JPRB, 0.14438903E-09_JPRB, 0.14521827E-09_JPRB, 0.14604246E-09_JPRB, 0.14690195E-09_JPRB, &
  & 0.14781266E-09_JPRB, 0.14876624E-09_JPRB, 0.14975628E-09_JPRB, 0.15078480E-09_JPRB, 0.15185095E-09_JPRB, 0.15294900E-09_JPRB, &
  & 0.15406650E-09_JPRB, 0.15518208E-09_JPRB, 0.15627544E-09_JPRB, 0.15732329E-09_JPRB, 0.15830559E-09_JPRB, 0.15921386E-09_JPRB, &
  & 0.16004434E-09_JPRB, 0.16079589E-09_JPRB, 0.16147086E-09_JPRB, 0.16207367E-09_JPRB, 0.16260950E-09_JPRB, 0.16308280E-09_JPRB, &
  & 0.16349862E-09_JPRB, 0.16385676E-09_JPRB, 0.16416722E-09_JPRB, 0.16442719E-09_JPRB, 0.16464537E-09_JPRB, 0.16482479E-09_JPRB, &
  & 0.16496311E-09_JPRB, 0.16505515E-09_JPRB, 0.16509170E-09_JPRB, 0.16505802E-09_JPRB, 0.16494414E-09_JPRB, 0.16474325E-09_JPRB, &
  & 0.16446258E-09_JPRB, 0.16411862E-09_JPRB, 0.16372428E-09_JPRB, 0.16328568E-09_JPRB, 0.16280338E-09_JPRB, 0.16227283E-09_JPRB, &
  & 0.16169041E-09_JPRB, 0.16104892E-09_JPRB, 0.16034413E-09_JPRB, 0.15958793E-09_JPRB, 0.15879911E-09_JPRB, 0.15800303E-09_JPRB, &
  & 0.15722532E-09_JPRB, 0.15647655E-09_JPRB, 0.15576263E-09_JPRB, 0.15507923E-09_JPRB, 0.15441229E-09_JPRB, 0.15374679E-09_JPRB, &
  & 0.15306496E-09_JPRB, 0.15235027E-09_JPRB, 0.15159335E-09_JPRB, 0.15079173E-09_JPRB, 0.14995812E-09_JPRB, 0.14911705E-09_JPRB, &
  & 0.14829135E-09_JPRB, 0.14747499E-09_JPRB, 0.14658035E-09_JPRB, 0.14511893E-09_JPRB /)

RGHG8(:,31, 3) = (/ &
  & 0.14370938E-09_JPRB, 0.14521256E-09_JPRB, 0.14609228E-09_JPRB, 0.14685386E-09_JPRB, 0.14761883E-09_JPRB, 0.14841760E-09_JPRB, &
  & 0.14925411E-09_JPRB, 0.15013361E-09_JPRB, 0.15104673E-09_JPRB, 0.15199778E-09_JPRB, 0.15299341E-09_JPRB, 0.15403281E-09_JPRB, &
  & 0.15510054E-09_JPRB, 0.15617206E-09_JPRB, 0.15722834E-09_JPRB, 0.15825198E-09_JPRB, 0.15922118E-09_JPRB, 0.16011945E-09_JPRB, &
  & 0.16093911E-09_JPRB, 0.16167866E-09_JPRB, 0.16233975E-09_JPRB, 0.16292789E-09_JPRB, 0.16344998E-09_JPRB, 0.16390987E-09_JPRB, &
  & 0.16431535E-09_JPRB, 0.16466187E-09_JPRB, 0.16496401E-09_JPRB, 0.16520926E-09_JPRB, 0.16541099E-09_JPRB, 0.16556523E-09_JPRB, &
  & 0.16567181E-09_JPRB, 0.16573036E-09_JPRB, 0.16573355E-09_JPRB, 0.16567553E-09_JPRB, 0.16554906E-09_JPRB, 0.16535405E-09_JPRB, &
  & 0.16509900E-09_JPRB, 0.16479404E-09_JPRB, 0.16445059E-09_JPRB, 0.16407442E-09_JPRB, 0.16365986E-09_JPRB, 0.16320092E-09_JPRB, &
  & 0.16269169E-09_JPRB, 0.16212419E-09_JPRB, 0.16149834E-09_JPRB, 0.16082027E-09_JPRB, 0.16010809E-09_JPRB, 0.15938645E-09_JPRB, &
  & 0.15867228E-09_JPRB, 0.15798232E-09_JPRB, 0.15731852E-09_JPRB, 0.15667787E-09_JPRB, 0.15605174E-09_JPRB, 0.15542576E-09_JPRB, &
  & 0.15478352E-09_JPRB, 0.15411021E-09_JPRB, 0.15339152E-09_JPRB, 0.15262402E-09_JPRB, 0.15181678E-09_JPRB, 0.15099676E-09_JPRB, &
  & 0.15018779E-09_JPRB, 0.14939509E-09_JPRB, 0.14853632E-09_JPRB, 0.14712054E-09_JPRB /)

RGHG8(:,32, 3) = (/ &
  & 0.14544796E-09_JPRB, 0.14687665E-09_JPRB, 0.14768238E-09_JPRB, 0.14840121E-09_JPRB, 0.14911075E-09_JPRB, 0.14984849E-09_JPRB, &
  & 0.15062537E-09_JPRB, 0.15143460E-09_JPRB, 0.15227672E-09_JPRB, 0.15315695E-09_JPRB, 0.15408103E-09_JPRB, 0.15505106E-09_JPRB, &
  & 0.15606416E-09_JPRB, 0.15709972E-09_JPRB, 0.15812898E-09_JPRB, 0.15912958E-09_JPRB, 0.16008195E-09_JPRB, 0.16096750E-09_JPRB, &
  & 0.16177487E-09_JPRB, 0.16249993E-09_JPRB, 0.16314412E-09_JPRB, 0.16371450E-09_JPRB, 0.16421504E-09_JPRB, 0.16465566E-09_JPRB, &
  & 0.16503757E-09_JPRB, 0.16536419E-09_JPRB, 0.16564619E-09_JPRB, 0.16587137E-09_JPRB, 0.16605249E-09_JPRB, 0.16618382E-09_JPRB, &
  & 0.16626545E-09_JPRB, 0.16629975E-09_JPRB, 0.16628190E-09_JPRB, 0.16621129E-09_JPRB, 0.16608347E-09_JPRB, 0.16590207E-09_JPRB, &
  & 0.16567374E-09_JPRB, 0.16540869E-09_JPRB, 0.16511607E-09_JPRB, 0.16479583E-09_JPRB, 0.16444122E-09_JPRB, 0.16404191E-09_JPRB, &
  & 0.16359046E-09_JPRB, 0.16308287E-09_JPRB, 0.16251948E-09_JPRB, 0.16190774E-09_JPRB, 0.16126277E-09_JPRB, 0.16060135E-09_JPRB, &
  & 0.15994653E-09_JPRB, 0.15930543E-09_JPRB, 0.15868461E-09_JPRB, 0.15808357E-09_JPRB, 0.15749266E-09_JPRB, 0.15690318E-09_JPRB, &
  & 0.15629957E-09_JPRB, 0.15566592E-09_JPRB, 0.15498798E-09_JPRB, 0.15425798E-09_JPRB, 0.15348248E-09_JPRB, 0.15268674E-09_JPRB, &
  & 0.15190549E-09_JPRB, 0.15113762E-09_JPRB, 0.15030666E-09_JPRB, 0.14894094E-09_JPRB /)

RGHG8(:,33, 3) = (/ &
  & 0.14710150E-09_JPRB, 0.14843263E-09_JPRB, 0.14920296E-09_JPRB, 0.14986395E-09_JPRB, 0.15052644E-09_JPRB, 0.15121331E-09_JPRB, &
  & 0.15193116E-09_JPRB, 0.15267801E-09_JPRB, 0.15345342E-09_JPRB, 0.15426527E-09_JPRB, 0.15512426E-09_JPRB, 0.15603428E-09_JPRB, &
  & 0.15698864E-09_JPRB, 0.15797570E-09_JPRB, 0.15897256E-09_JPRB, 0.15995127E-09_JPRB, 0.16088768E-09_JPRB, 0.16175897E-09_JPRB, &
  & 0.16255153E-09_JPRB, 0.16326034E-09_JPRB, 0.16388481E-09_JPRB, 0.16443417E-09_JPRB, 0.16490918E-09_JPRB, 0.16532516E-09_JPRB, &
  & 0.16567778E-09_JPRB, 0.16597813E-09_JPRB, 0.16623287E-09_JPRB, 0.16643434E-09_JPRB, 0.16659261E-09_JPRB, 0.16670297E-09_JPRB, &
  & 0.16676564E-09_JPRB, 0.16678317E-09_JPRB, 0.16675479E-09_JPRB, 0.16668085E-09_JPRB, 0.16656089E-09_JPRB, 0.16639892E-09_JPRB, &
  & 0.16620234E-09_JPRB, 0.16597924E-09_JPRB, 0.16573207E-09_JPRB, 0.16545722E-09_JPRB, 0.16514709E-09_JPRB, 0.16479328E-09_JPRB, &
  & 0.16438757E-09_JPRB, 0.16392550E-09_JPRB, 0.16341029E-09_JPRB, 0.16285033E-09_JPRB, 0.16225864E-09_JPRB, 0.16165433E-09_JPRB, &
  & 0.16104719E-09_JPRB, 0.16045192E-09_JPRB, 0.15987171E-09_JPRB, 0.15930542E-09_JPRB, 0.15874994E-09_JPRB, 0.15819564E-09_JPRB, &
  & 0.15762970E-09_JPRB, 0.15703761E-09_JPRB, 0.15640372E-09_JPRB, 0.15571723E-09_JPRB, 0.15498205E-09_JPRB, 0.15422438E-09_JPRB, &
  & 0.15347386E-09_JPRB, 0.15273857E-09_JPRB, 0.15194165E-09_JPRB, 0.15061991E-09_JPRB /)

RGHG8(:,34, 3) = (/ &
  & 0.14866240E-09_JPRB, 0.14993015E-09_JPRB, 0.15063648E-09_JPRB, 0.15126263E-09_JPRB, 0.15187761E-09_JPRB, 0.15251414E-09_JPRB, &
  & 0.15318120E-09_JPRB, 0.15386867E-09_JPRB, 0.15458151E-09_JPRB, 0.15532683E-09_JPRB, 0.15611767E-09_JPRB, 0.15696430E-09_JPRB, &
  & 0.15786666E-09_JPRB, 0.15881019E-09_JPRB, 0.15977145E-09_JPRB, 0.16072257E-09_JPRB, 0.16163747E-09_JPRB, 0.16249091E-09_JPRB, &
  & 0.16326593E-09_JPRB, 0.16395615E-09_JPRB, 0.16455884E-09_JPRB, 0.16508510E-09_JPRB, 0.16553245E-09_JPRB, 0.16592062E-09_JPRB, &
  & 0.16624156E-09_JPRB, 0.16651161E-09_JPRB, 0.16673585E-09_JPRB, 0.16691072E-09_JPRB, 0.16704557E-09_JPRB, 0.16713675E-09_JPRB, &
  & 0.16718500E-09_JPRB, 0.16719266E-09_JPRB, 0.16716124E-09_JPRB, 0.16709198E-09_JPRB, 0.16698609E-09_JPRB, 0.16684855E-09_JPRB, &
  & 0.16668510E-09_JPRB, 0.16649979E-09_JPRB, 0.16629124E-09_JPRB, 0.16605400E-09_JPRB, 0.16577846E-09_JPRB, 0.16545579E-09_JPRB, &
  & 0.16507970E-09_JPRB, 0.16465010E-09_JPRB, 0.16417073E-09_JPRB, 0.16365251E-09_JPRB, 0.16310811E-09_JPRB, 0.16254759E-09_JPRB, &
  & 0.16198685E-09_JPRB, 0.16143176E-09_JPRB, 0.16088814E-09_JPRB, 0.16035792E-09_JPRB, 0.15983606E-09_JPRB, 0.15931736E-09_JPRB, &
  & 0.15879004E-09_JPRB, 0.15824032E-09_JPRB, 0.15765360E-09_JPRB, 0.15701743E-09_JPRB, 0.15633396E-09_JPRB, 0.15562243E-09_JPRB, &
  & 0.15491658E-09_JPRB, 0.15421882E-09_JPRB, 0.15345560E-09_JPRB, 0.15218403E-09_JPRB /)

RGHG8(:,35, 3) = (/ &
  & 0.15016210E-09_JPRB, 0.15133932E-09_JPRB, 0.15201461E-09_JPRB, 0.15259095E-09_JPRB, 0.15316683E-09_JPRB, 0.15376066E-09_JPRB, &
  & 0.15437512E-09_JPRB, 0.15500748E-09_JPRB, 0.15565942E-09_JPRB, 0.15634069E-09_JPRB, 0.15706594E-09_JPRB, 0.15784726E-09_JPRB, &
  & 0.15868931E-09_JPRB, 0.15958403E-09_JPRB, 0.16050991E-09_JPRB, 0.16143518E-09_JPRB, 0.16232740E-09_JPRB, 0.16316029E-09_JPRB, &
  & 0.16391488E-09_JPRB, 0.16458432E-09_JPRB, 0.16516399E-09_JPRB, 0.16566555E-09_JPRB, 0.16608488E-09_JPRB, 0.16644144E-09_JPRB, &
  & 0.16672914E-09_JPRB, 0.16696512E-09_JPRB, 0.16715558E-09_JPRB, 0.16730159E-09_JPRB, 0.16741228E-09_JPRB, 0.16748580E-09_JPRB, &
  & 0.16752288E-09_JPRB, 0.16752595E-09_JPRB, 0.16749677E-09_JPRB, 0.16743687E-09_JPRB, 0.16734884E-09_JPRB, 0.16723639E-09_JPRB, &
  & 0.16710369E-09_JPRB, 0.16695163E-09_JPRB, 0.16677636E-09_JPRB, 0.16657054E-09_JPRB, 0.16632337E-09_JPRB, 0.16602544E-09_JPRB, &
  & 0.16567320E-09_JPRB, 0.16526593E-09_JPRB, 0.16481505E-09_JPRB, 0.16432973E-09_JPRB, 0.16382148E-09_JPRB, 0.16330204E-09_JPRB, &
  & 0.16277725E-09_JPRB, 0.16225871E-09_JPRB, 0.16174995E-09_JPRB, 0.16125237E-09_JPRB, 0.16076533E-09_JPRB, 0.16028187E-09_JPRB, &
  & 0.15979293E-09_JPRB, 0.15928692E-09_JPRB, 0.15874953E-09_JPRB, 0.15816803E-09_JPRB, 0.15754172E-09_JPRB, 0.15688792E-09_JPRB, &
  & 0.15623192E-09_JPRB, 0.15557758E-09_JPRB, 0.15485667E-09_JPRB, 0.15363727E-09_JPRB /)

RGHG8(:,36, 3) = (/ &
  & 0.15158000E-09_JPRB, 0.15269346E-09_JPRB, 0.15331313E-09_JPRB, 0.15386122E-09_JPRB, 0.15439851E-09_JPRB, 0.15495003E-09_JPRB, &
  & 0.15551810E-09_JPRB, 0.15609601E-09_JPRB, 0.15668836E-09_JPRB, 0.15730575E-09_JPRB, 0.15796525E-09_JPRB, 0.15868337E-09_JPRB, &
  & 0.15946856E-09_JPRB, 0.16031368E-09_JPRB, 0.16119821E-09_JPRB, 0.16209106E-09_JPRB, 0.16295602E-09_JPRB, 0.16376499E-09_JPRB, &
  & 0.16449611E-09_JPRB, 0.16514431E-09_JPRB, 0.16570111E-09_JPRB, 0.16617485E-09_JPRB, 0.16656367E-09_JPRB, 0.16688254E-09_JPRB, &
  & 0.16713178E-09_JPRB, 0.16732774E-09_JPRB, 0.16748181E-09_JPRB, 0.16759712E-09_JPRB, 0.16768419E-09_JPRB, 0.16774175E-09_JPRB, &
  & 0.16777048E-09_JPRB, 0.16777185E-09_JPRB, 0.16774708E-09_JPRB, 0.16769781E-09_JPRB, 0.16762640E-09_JPRB, 0.16753617E-09_JPRB, &
  & 0.16742921E-09_JPRB, 0.16730468E-09_JPRB, 0.16715808E-09_JPRB, 0.16698050E-09_JPRB, 0.16676019E-09_JPRB, 0.16648814E-09_JPRB, &
  & 0.16615806E-09_JPRB, 0.16577614E-09_JPRB, 0.16534932E-09_JPRB, 0.16489397E-09_JPRB, 0.16441860E-09_JPRB, 0.16393045E-09_JPRB, &
  & 0.16343935E-09_JPRB, 0.16295085E-09_JPRB, 0.16247206E-09_JPRB, 0.16200673E-09_JPRB, 0.16155190E-09_JPRB, 0.16110371E-09_JPRB, &
  & 0.16065391E-09_JPRB, 0.16019147E-09_JPRB, 0.15970306E-09_JPRB, 0.15917732E-09_JPRB, 0.15861150E-09_JPRB, 0.15801793E-09_JPRB, &
  & 0.15741820E-09_JPRB, 0.15681353E-09_JPRB, 0.15613748E-09_JPRB, 0.15498348E-09_JPRB /)

RGHG8(:,37, 3) = (/ &
  & 0.15293425E-09_JPRB, 0.15396659E-09_JPRB, 0.15455583E-09_JPRB, 0.15506663E-09_JPRB, 0.15557387E-09_JPRB, 0.15609036E-09_JPRB, &
  & 0.15661170E-09_JPRB, 0.15713794E-09_JPRB, 0.15767215E-09_JPRB, 0.15822708E-09_JPRB, 0.15882082E-09_JPRB, 0.15947184E-09_JPRB, &
  & 0.16019365E-09_JPRB, 0.16098568E-09_JPRB, 0.16182919E-09_JPRB, 0.16268832E-09_JPRB, 0.16352386E-09_JPRB, 0.16430654E-09_JPRB, &
  & 0.16501454E-09_JPRB, 0.16563824E-09_JPRB, 0.16616929E-09_JPRB, 0.16660955E-09_JPRB, 0.16695810E-09_JPRB, 0.16723095E-09_JPRB, &
  & 0.16743419E-09_JPRB, 0.16758922E-09_JPRB, 0.16770711E-09_JPRB, 0.16779597E-09_JPRB, 0.16786343E-09_JPRB, 0.16790892E-09_JPRB, &
  & 0.16793204E-09_JPRB, 0.16793285E-09_JPRB, 0.16791196E-09_JPRB, 0.16787084E-09_JPRB, 0.16781200E-09_JPRB, 0.16773805E-09_JPRB, &
  & 0.16765023E-09_JPRB, 0.16754738E-09_JPRB, 0.16742431E-09_JPRB, 0.16727245E-09_JPRB, 0.16708025E-09_JPRB, 0.16683624E-09_JPRB, &
  & 0.16653699E-09_JPRB, 0.16618172E-09_JPRB, 0.16578609E-09_JPRB, 0.16535961E-09_JPRB, 0.16491462E-09_JPRB, 0.16445656E-09_JPRB, &
  & 0.16399165E-09_JPRB, 0.16352904E-09_JPRB, 0.16307689E-09_JPRB, 0.16263885E-09_JPRB, 0.16221552E-09_JPRB, 0.16180178E-09_JPRB, &
  & 0.16139015E-09_JPRB, 0.16097060E-09_JPRB, 0.16053067E-09_JPRB, 0.16005904E-09_JPRB, 0.15955279E-09_JPRB, 0.15902088E-09_JPRB, &
  & 0.15848003E-09_JPRB, 0.15792838E-09_JPRB, 0.15730517E-09_JPRB, 0.15622600E-09_JPRB /)

RGHG8(:,38, 3) = (/ &
  & 0.15421799E-09_JPRB, 0.15518091E-09_JPRB, 0.15572915E-09_JPRB, 0.15621497E-09_JPRB, 0.15669585E-09_JPRB, 0.15717960E-09_JPRB, &
  & 0.15765969E-09_JPRB, 0.15813556E-09_JPRB, 0.15861279E-09_JPRB, 0.15910573E-09_JPRB, 0.15963461E-09_JPRB, 0.16022046E-09_JPRB, &
  & 0.16087920E-09_JPRB, 0.16161381E-09_JPRB, 0.16240845E-09_JPRB, 0.16322919E-09_JPRB, 0.16403207E-09_JPRB, 0.16478559E-09_JPRB, &
  & 0.16546606E-09_JPRB, 0.16606086E-09_JPRB, 0.16655688E-09_JPRB, 0.16695348E-09_JPRB, 0.16725285E-09_JPRB, 0.16747639E-09_JPRB, &
  & 0.16763667E-09_JPRB, 0.16775696E-09_JPRB, 0.16784839E-09_JPRB, 0.16791846E-09_JPRB, 0.16797337E-09_JPRB, 0.16801140E-09_JPRB, &
  & 0.16803130E-09_JPRB, 0.16803191E-09_JPRB, 0.16801338E-09_JPRB, 0.16797735E-09_JPRB, 0.16792649E-09_JPRB, 0.16786331E-09_JPRB, &
  & 0.16778880E-09_JPRB, 0.16770134E-09_JPRB, 0.16759648E-09_JPRB, 0.16746611E-09_JPRB, 0.16729931E-09_JPRB, 0.16708582E-09_JPRB, &
  & 0.16681767E-09_JPRB, 0.16649844E-09_JPRB, 0.16613438E-09_JPRB, 0.16574138E-09_JPRB, 0.16532606E-09_JPRB, 0.16489567E-09_JPRB, &
  & 0.16445507E-09_JPRB, 0.16401475E-09_JPRB, 0.16358370E-09_JPRB, 0.16317060E-09_JPRB, 0.16277536E-09_JPRB, 0.16239445E-09_JPRB, &
  & 0.16202012E-09_JPRB, 0.16164203E-09_JPRB, 0.16124875E-09_JPRB, 0.16082932E-09_JPRB, 0.16038061E-09_JPRB, 0.15990978E-09_JPRB, &
  & 0.15942835E-09_JPRB, 0.15893428E-09_JPRB, 0.15836785E-09_JPRB, 0.15737718E-09_JPRB /)

RGHG8(:,39, 3) = (/ &
  & 0.15544133E-09_JPRB, 0.15633196E-09_JPRB, 0.15684369E-09_JPRB, 0.15730456E-09_JPRB, 0.15776132E-09_JPRB, 0.15821726E-09_JPRB, &
  & 0.15865917E-09_JPRB, 0.15908723E-09_JPRB, 0.15950939E-09_JPRB, 0.15994239E-09_JPRB, 0.16040627E-09_JPRB, 0.16092441E-09_JPRB, &
  & 0.16151738E-09_JPRB, 0.16219349E-09_JPRB, 0.16293825E-09_JPRB, 0.16371654E-09_JPRB, 0.16448573E-09_JPRB, 0.16520732E-09_JPRB, &
  & 0.16585436E-09_JPRB, 0.16640821E-09_JPRB, 0.16685692E-09_JPRB, 0.16720202E-09_JPRB, 0.16745311E-09_JPRB, 0.16763486E-09_JPRB, &
  & 0.16776340E-09_JPRB, 0.16786067E-09_JPRB, 0.16793518E-09_JPRB, 0.16799445E-09_JPRB, 0.16804214E-09_JPRB, 0.16807605E-09_JPRB, &
  & 0.16809421E-09_JPRB, 0.16809462E-09_JPRB, 0.16807725E-09_JPRB, 0.16804394E-09_JPRB, 0.16799788E-09_JPRB, 0.16794152E-09_JPRB, &
  & 0.16787603E-09_JPRB, 0.16779948E-09_JPRB, 0.16770801E-09_JPRB, 0.16759436E-09_JPRB, 0.16744900E-09_JPRB, 0.16726123E-09_JPRB, &
  & 0.16702499E-09_JPRB, 0.16673807E-09_JPRB, 0.16641007E-09_JPRB, 0.16604977E-09_JPRB, 0.16566684E-09_JPRB, 0.16526407E-09_JPRB, &
  & 0.16484829E-09_JPRB, 0.16442642E-09_JPRB, 0.16401470E-09_JPRB, 0.16362173E-09_JPRB, 0.16325147E-09_JPRB, 0.16290078E-09_JPRB, &
  & 0.16256109E-09_JPRB, 0.16222297E-09_JPRB, 0.16187364E-09_JPRB, 0.16150425E-09_JPRB, 0.16111099E-09_JPRB, 0.16069970E-09_JPRB, &
  & 0.16027933E-09_JPRB, 0.15984325E-09_JPRB, 0.15934068E-09_JPRB, 0.15844766E-09_JPRB /)

RGHG8(:,40, 3) = (/ &
  & 0.15660763E-09_JPRB, 0.15742130E-09_JPRB, 0.15789847E-09_JPRB, 0.15833071E-09_JPRB, 0.15876850E-09_JPRB, 0.15919763E-09_JPRB, &
  & 0.15960454E-09_JPRB, 0.15998729E-09_JPRB, 0.16035792E-09_JPRB, 0.16073166E-09_JPRB, 0.16113341E-09_JPRB, 0.16158633E-09_JPRB, &
  & 0.16211400E-09_JPRB, 0.16272877E-09_JPRB, 0.16342111E-09_JPRB, 0.16415402E-09_JPRB, 0.16488248E-09_JPRB, 0.16556673E-09_JPRB, &
  & 0.16617470E-09_JPRB, 0.16668185E-09_JPRB, 0.16707782E-09_JPRB, 0.16737374E-09_JPRB, 0.16758477E-09_JPRB, 0.16773671E-09_JPRB, &
  & 0.16784438E-09_JPRB, 0.16792738E-09_JPRB, 0.16799195E-09_JPRB, 0.16804497E-09_JPRB, 0.16808867E-09_JPRB, 0.16812034E-09_JPRB, &
  & 0.16813739E-09_JPRB, 0.16813748E-09_JPRB, 0.16812039E-09_JPRB, 0.16808839E-09_JPRB, 0.16804504E-09_JPRB, 0.16799334E-09_JPRB, &
  & 0.16793379E-09_JPRB, 0.16786526E-09_JPRB, 0.16778375E-09_JPRB, 0.16768319E-09_JPRB, 0.16755476E-09_JPRB, 0.16738935E-09_JPRB, &
  & 0.16717927E-09_JPRB, 0.16692374E-09_JPRB, 0.16662782E-09_JPRB, 0.16630120E-09_JPRB, 0.16595017E-09_JPRB, 0.16557773E-09_JPRB, &
  & 0.16518506E-09_JPRB, 0.16478424E-09_JPRB, 0.16438764E-09_JPRB, 0.16401189E-09_JPRB, 0.16366321E-09_JPRB, 0.16333859E-09_JPRB, &
  & 0.16303119E-09_JPRB, 0.16272905E-09_JPRB, 0.16242162E-09_JPRB, 0.16209881E-09_JPRB, 0.16175897E-09_JPRB, 0.16140589E-09_JPRB, &
  & 0.16104491E-09_JPRB, 0.16067027E-09_JPRB, 0.16023176E-09_JPRB, 0.15944800E-09_JPRB /)

RGHG8(:,41, 3) = (/ &
  & 0.15771341E-09_JPRB, 0.15845443E-09_JPRB, 0.15888864E-09_JPRB, 0.15929719E-09_JPRB, 0.15971061E-09_JPRB, 0.16011623E-09_JPRB, &
  & 0.16049051E-09_JPRB, 0.16083204E-09_JPRB, 0.16115240E-09_JPRB, 0.16147231E-09_JPRB, 0.16181299E-09_JPRB, 0.16220233E-09_JPRB, &
  & 0.16266663E-09_JPRB, 0.16322212E-09_JPRB, 0.16386144E-09_JPRB, 0.16455076E-09_JPRB, 0.16523824E-09_JPRB, 0.16588005E-09_JPRB, &
  & 0.16643872E-09_JPRB, 0.16689437E-09_JPRB, 0.16724090E-09_JPRB, 0.16749434E-09_JPRB, 0.16767530E-09_JPRB, 0.16780596E-09_JPRB, &
  & 0.16790024E-09_JPRB, 0.16797419E-09_JPRB, 0.16803270E-09_JPRB, 0.16808219E-09_JPRB, 0.16812352E-09_JPRB, 0.16815389E-09_JPRB, &
  & 0.16817010E-09_JPRB, 0.16816958E-09_JPRB, 0.16815216E-09_JPRB, 0.16812056E-09_JPRB, 0.16807886E-09_JPRB, 0.16802990E-09_JPRB, &
  & 0.16797487E-09_JPRB, 0.16791207E-09_JPRB, 0.16783853E-09_JPRB, 0.16774843E-09_JPRB, 0.16763455E-09_JPRB, 0.16748780E-09_JPRB, &
  & 0.16730162E-09_JPRB, 0.16707283E-09_JPRB, 0.16680668E-09_JPRB, 0.16651136E-09_JPRB, 0.16619137E-09_JPRB, 0.16584800E-09_JPRB, &
  & 0.16548277E-09_JPRB, 0.16510045E-09_JPRB, 0.16472004E-09_JPRB, 0.16435937E-09_JPRB, 0.16402796E-09_JPRB, 0.16372721E-09_JPRB, &
  & 0.16344748E-09_JPRB, 0.16317872E-09_JPRB, 0.16290863E-09_JPRB, 0.16262988E-09_JPRB, 0.16233974E-09_JPRB, 0.16204187E-09_JPRB, &
  & 0.16173911E-09_JPRB, 0.16142253E-09_JPRB, 0.16105106E-09_JPRB, 0.16037791E-09_JPRB /)

RGHG8(:,42, 3) = (/ &
  & 0.15875808E-09_JPRB, 0.15942263E-09_JPRB, 0.15982064E-09_JPRB, 0.16019688E-09_JPRB, 0.16058919E-09_JPRB, 0.16097079E-09_JPRB, &
  & 0.16131380E-09_JPRB, 0.16161698E-09_JPRB, 0.16189271E-09_JPRB, 0.16216170E-09_JPRB, 0.16244794E-09_JPRB, 0.16277840E-09_JPRB, &
  & 0.16318125E-09_JPRB, 0.16367951E-09_JPRB, 0.16426734E-09_JPRB, 0.16491004E-09_JPRB, 0.16555715E-09_JPRB, 0.16615351E-09_JPRB, &
  & 0.16666268E-09_JPRB, 0.16706429E-09_JPRB, 0.16736487E-09_JPRB, 0.16758367E-09_JPRB, 0.16774127E-09_JPRB, 0.16785690E-09_JPRB, &
  & 0.16794213E-09_JPRB, 0.16801013E-09_JPRB, 0.16806496E-09_JPRB, 0.16811230E-09_JPRB, 0.16815230E-09_JPRB, 0.16818172E-09_JPRB, &
  & 0.16819701E-09_JPRB, 0.16819557E-09_JPRB, 0.16817742E-09_JPRB, 0.16814575E-09_JPRB, 0.16810466E-09_JPRB, 0.16805769E-09_JPRB, &
  & 0.16800553E-09_JPRB, 0.16794745E-09_JPRB, 0.16788008E-09_JPRB, 0.16779918E-09_JPRB, 0.16769788E-09_JPRB, 0.16756864E-09_JPRB, &
  & 0.16740404E-09_JPRB, 0.16720071E-09_JPRB, 0.16696164E-09_JPRB, 0.16669405E-09_JPRB, 0.16640385E-09_JPRB, 0.16608967E-09_JPRB, &
  & 0.16575000E-09_JPRB, 0.16539031E-09_JPRB, 0.16502591E-09_JPRB, 0.16467852E-09_JPRB, 0.16436483E-09_JPRB, 0.16408391E-09_JPRB, &
  & 0.16382967E-09_JPRB, 0.16358970E-09_JPRB, 0.16335375E-09_JPRB, 0.16311398E-09_JPRB, 0.16286936E-09_JPRB, 0.16262183E-09_JPRB, &
  & 0.16237203E-09_JPRB, 0.16211102E-09_JPRB, 0.16180143E-09_JPRB, 0.16123729E-09_JPRB /)

RGHG8(:,43, 3) = (/ &
  & 0.15973962E-09_JPRB, 0.16033132E-09_JPRB, 0.16068932E-09_JPRB, 0.16103580E-09_JPRB, 0.16140266E-09_JPRB, 0.16175884E-09_JPRB, &
  & 0.16207542E-09_JPRB, 0.16234272E-09_JPRB, 0.16257945E-09_JPRB, 0.16280438E-09_JPRB, 0.16304223E-09_JPRB, 0.16331869E-09_JPRB, &
  & 0.16366761E-09_JPRB, 0.16410971E-09_JPRB, 0.16465028E-09_JPRB, 0.16524881E-09_JPRB, 0.16584965E-09_JPRB, 0.16639842E-09_JPRB, &
  & 0.16685259E-09_JPRB, 0.16720346E-09_JPRB, 0.16746293E-09_JPRB, 0.16765248E-09_JPRB, 0.16779222E-09_JPRB, 0.16789652E-09_JPRB, &
  & 0.16797561E-09_JPRB, 0.16803975E-09_JPRB, 0.16809237E-09_JPRB, 0.16813867E-09_JPRB, 0.16817775E-09_JPRB, 0.16820641E-09_JPRB, &
  & 0.16822063E-09_JPRB, 0.16821800E-09_JPRB, 0.16819873E-09_JPRB, 0.16816640E-09_JPRB, 0.16812551E-09_JPRB, 0.16807944E-09_JPRB, &
  & 0.16802962E-09_JPRB, 0.16797490E-09_JPRB, 0.16791299E-09_JPRB, 0.16783999E-09_JPRB, 0.16775059E-09_JPRB, 0.16763781E-09_JPRB, &
  & 0.16749492E-09_JPRB, 0.16731647E-09_JPRB, 0.16710366E-09_JPRB, 0.16686319E-09_JPRB, 0.16659975E-09_JPRB, 0.16631324E-09_JPRB, &
  & 0.16600051E-09_JPRB, 0.16566315E-09_JPRB, 0.16531682E-09_JPRB, 0.16498675E-09_JPRB, 0.16468851E-09_JPRB, 0.16442793E-09_JPRB, &
  & 0.16419570E-09_JPRB, 0.16398138E-09_JPRB, 0.16377449E-09_JPRB, 0.16356892E-09_JPRB, 0.16336360E-09_JPRB, 0.16315990E-09_JPRB, &
  & 0.16295650E-09_JPRB, 0.16274362E-09_JPRB, 0.16249006E-09_JPRB, 0.16202499E-09_JPRB /)

RGHG8(:,44, 3) = (/ &
  & 0.16064633E-09_JPRB, 0.16117895E-09_JPRB, 0.16149558E-09_JPRB, 0.16181452E-09_JPRB, 0.16215250E-09_JPRB, 0.16248916E-09_JPRB, &
  & 0.16277595E-09_JPRB, 0.16301721E-09_JPRB, 0.16321851E-09_JPRB, 0.16340763E-09_JPRB, 0.16360358E-09_JPRB, 0.16383589E-09_JPRB, &
  & 0.16413126E-09_JPRB, 0.16452703E-09_JPRB, 0.16501850E-09_JPRB, 0.16557503E-09_JPRB, 0.16612985E-09_JPRB, 0.16662177E-09_JPRB, &
  & 0.16702000E-09_JPRB, 0.16731949E-09_JPRB, 0.16754233E-09_JPRB, 0.16770749E-09_JPRB, 0.16783280E-09_JPRB, 0.16792848E-09_JPRB, &
  & 0.16800361E-09_JPRB, 0.16806520E-09_JPRB, 0.16811694E-09_JPRB, 0.16816284E-09_JPRB, 0.16820161E-09_JPRB, 0.16822937E-09_JPRB, &
  & 0.16824224E-09_JPRB, 0.16823799E-09_JPRB, 0.16821730E-09_JPRB, 0.16818398E-09_JPRB, 0.16814262E-09_JPRB, 0.16809706E-09_JPRB, &
  & 0.16804855E-09_JPRB, 0.16799673E-09_JPRB, 0.16793929E-09_JPRB, 0.16787362E-09_JPRB, 0.16779529E-09_JPRB, 0.16769906E-09_JPRB, &
  & 0.16757824E-09_JPRB, 0.16742638E-09_JPRB, 0.16724136E-09_JPRB, 0.16702770E-09_JPRB, 0.16679116E-09_JPRB, 0.16653118E-09_JPRB, &
  & 0.16624431E-09_JPRB, 0.16593074E-09_JPRB, 0.16560610E-09_JPRB, 0.16529364E-09_JPRB, 0.16501581E-09_JPRB, 0.16477368E-09_JPRB, &
  & 0.16456175E-09_JPRB, 0.16436939E-09_JPRB, 0.16418703E-09_JPRB, 0.16400979E-09_JPRB, 0.16383717E-09_JPRB, 0.16366945E-09_JPRB, &
  & 0.16350404E-09_JPRB, 0.16333172E-09_JPRB, 0.16312528E-09_JPRB, 0.16274512E-09_JPRB /)

RGHG8(:,45, 3) = (/ &
  & 0.16149086E-09_JPRB, 0.16195398E-09_JPRB, 0.16224924E-09_JPRB, 0.16253233E-09_JPRB, 0.16285230E-09_JPRB, 0.16316200E-09_JPRB, &
  & 0.16343335E-09_JPRB, 0.16364482E-09_JPRB, 0.16382223E-09_JPRB, 0.16397959E-09_JPRB, 0.16414384E-09_JPRB, 0.16433563E-09_JPRB, &
  & 0.16459116E-09_JPRB, 0.16493609E-09_JPRB, 0.16538880E-09_JPRB, 0.16589803E-09_JPRB, 0.16639858E-09_JPRB, 0.16682962E-09_JPRB, &
  & 0.16716527E-09_JPRB, 0.16741780E-09_JPRB, 0.16760719E-09_JPRB, 0.16775190E-09_JPRB, 0.16786550E-09_JPRB, 0.16795500E-09_JPRB, &
  & 0.16802743E-09_JPRB, 0.16808779E-09_JPRB, 0.16813970E-09_JPRB, 0.16818585E-09_JPRB, 0.16822442E-09_JPRB, 0.16825132E-09_JPRB, &
  & 0.16826239E-09_JPRB, 0.16825615E-09_JPRB, 0.16823377E-09_JPRB, 0.16819898E-09_JPRB, 0.16815684E-09_JPRB, 0.16811109E-09_JPRB, &
  & 0.16806358E-09_JPRB, 0.16801377E-09_JPRB, 0.16796049E-09_JPRB, 0.16790140E-09_JPRB, 0.16783394E-09_JPRB, 0.16775401E-09_JPRB, &
  & 0.16765650E-09_JPRB, 0.16753388E-09_JPRB, 0.16738107E-09_JPRB, 0.16719834E-09_JPRB, 0.16698995E-09_JPRB, 0.16675691E-09_JPRB, &
  & 0.16649444E-09_JPRB, 0.16620505E-09_JPRB, 0.16590150E-09_JPRB, 0.16561391E-09_JPRB, 0.16535512E-09_JPRB, 0.16513356E-09_JPRB, &
  & 0.16494019E-09_JPRB, 0.16476606E-09_JPRB, 0.16460393E-09_JPRB, 0.16444916E-09_JPRB, 0.16430221E-09_JPRB, 0.16416275E-09_JPRB, &
  & 0.16402738E-09_JPRB, 0.16388667E-09_JPRB, 0.16371823E-09_JPRB, 0.16340698E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART5',1,ZHOOK_HANDLE)
END SUBROUTINE PART5




SUBROUTINE PART6
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART6',0,ZHOOK_HANDLE)



RGHG8(:,46, 3) = (/ &
  & 0.16225221E-09_JPRB, 0.16268270E-09_JPRB, 0.16293857E-09_JPRB, 0.16320965E-09_JPRB, 0.16350123E-09_JPRB, 0.16379886E-09_JPRB, &
  & 0.16404697E-09_JPRB, 0.16424243E-09_JPRB, 0.16439533E-09_JPRB, 0.16453124E-09_JPRB, 0.16466858E-09_JPRB, 0.16483148E-09_JPRB, &
  & 0.16504824E-09_JPRB, 0.16535598E-09_JPRB, 0.16576172E-09_JPRB, 0.16622297E-09_JPRB, 0.16665937E-09_JPRB, 0.16701751E-09_JPRB, &
  & 0.16729343E-09_JPRB, 0.16749979E-09_JPRB, 0.16766055E-09_JPRB, 0.16778784E-09_JPRB, 0.16789214E-09_JPRB, 0.16797697E-09_JPRB, &
  & 0.16804816E-09_JPRB, 0.16810849E-09_JPRB, 0.16816117E-09_JPRB, 0.16820820E-09_JPRB, 0.16824683E-09_JPRB, 0.16827235E-09_JPRB, &
  & 0.16828143E-09_JPRB, 0.16827284E-09_JPRB, 0.16824837E-09_JPRB, 0.16821189E-09_JPRB, 0.16816840E-09_JPRB, 0.16812222E-09_JPRB, &
  & 0.16807501E-09_JPRB, 0.16802720E-09_JPRB, 0.16797735E-09_JPRB, 0.16792462E-09_JPRB, 0.16786733E-09_JPRB, 0.16780395E-09_JPRB, &
  & 0.16773051E-09_JPRB, 0.16764075E-09_JPRB, 0.16752620E-09_JPRB, 0.16738265E-09_JPRB, 0.16720872E-09_JPRB, 0.16700363E-09_JPRB, &
  & 0.16676643E-09_JPRB, 0.16649698E-09_JPRB, 0.16621907E-09_JPRB, 0.16595067E-09_JPRB, 0.16571794E-09_JPRB, 0.16551460E-09_JPRB, &
  & 0.16533849E-09_JPRB, 0.16518069E-09_JPRB, 0.16503408E-09_JPRB, 0.16489710E-09_JPRB, 0.16476943E-09_JPRB, 0.16465129E-09_JPRB, &
  & 0.16453827E-09_JPRB, 0.16442209E-09_JPRB, 0.16428228E-09_JPRB, 0.16402517E-09_JPRB /)

RGHG8(:,47, 3) = (/ &
  & 0.16295756E-09_JPRB, 0.16334575E-09_JPRB, 0.16359300E-09_JPRB, 0.16383850E-09_JPRB, 0.16412013E-09_JPRB, 0.16440017E-09_JPRB, &
  & 0.16463601E-09_JPRB, 0.16481339E-09_JPRB, 0.16495036E-09_JPRB, 0.16506817E-09_JPRB, 0.16518632E-09_JPRB, 0.16532625E-09_JPRB, &
  & 0.16551446E-09_JPRB, 0.16578626E-09_JPRB, 0.16614610E-09_JPRB, 0.16654554E-09_JPRB, 0.16690292E-09_JPRB, 0.16718742E-09_JPRB, &
  & 0.16740194E-09_JPRB, 0.16756914E-09_JPRB, 0.16770406E-09_JPRB, 0.16781695E-09_JPRB, 0.16791357E-09_JPRB, 0.16799565E-09_JPRB, &
  & 0.16806651E-09_JPRB, 0.16812762E-09_JPRB, 0.16818230E-09_JPRB, 0.16823028E-09_JPRB, 0.16826883E-09_JPRB, 0.16829295E-09_JPRB, &
  & 0.16829947E-09_JPRB, 0.16828813E-09_JPRB, 0.16826128E-09_JPRB, 0.16822269E-09_JPRB, 0.16817772E-09_JPRB, 0.16813062E-09_JPRB, &
  & 0.16808381E-09_JPRB, 0.16803731E-09_JPRB, 0.16799090E-09_JPRB, 0.16794391E-09_JPRB, 0.16789674E-09_JPRB, 0.16784937E-09_JPRB, &
  & 0.16780083E-09_JPRB, 0.16774580E-09_JPRB, 0.16767655E-09_JPRB, 0.16758149E-09_JPRB, 0.16745338E-09_JPRB, 0.16728491E-09_JPRB, &
  & 0.16707132E-09_JPRB, 0.16682525E-09_JPRB, 0.16656236E-09_JPRB, 0.16632279E-09_JPRB, 0.16610717E-09_JPRB, 0.16592488E-09_JPRB, &
  & 0.16576403E-09_JPRB, 0.16561920E-09_JPRB, 0.16548579E-09_JPRB, 0.16536150E-09_JPRB, 0.16524834E-09_JPRB, 0.16514555E-09_JPRB, &
  & 0.16504903E-09_JPRB, 0.16495010E-09_JPRB, 0.16483195E-09_JPRB, 0.16461400E-09_JPRB /)

RGHG8(:,48, 3) = (/ &
  & 0.16360449E-09_JPRB, 0.16397152E-09_JPRB, 0.16420440E-09_JPRB, 0.16444304E-09_JPRB, 0.16471363E-09_JPRB, 0.16498455E-09_JPRB, &
  & 0.16520924E-09_JPRB, 0.16537351E-09_JPRB, 0.16549739E-09_JPRB, 0.16560159E-09_JPRB, 0.16570564E-09_JPRB, 0.16582768E-09_JPRB, &
  & 0.16599334E-09_JPRB, 0.16622571E-09_JPRB, 0.16653517E-09_JPRB, 0.16685081E-09_JPRB, 0.16712368E-09_JPRB, 0.16733231E-09_JPRB, &
  & 0.16749499E-09_JPRB, 0.16762630E-09_JPRB, 0.16773971E-09_JPRB, 0.16784028E-09_JPRB, 0.16793113E-09_JPRB, 0.16801158E-09_JPRB, &
  & 0.16808330E-09_JPRB, 0.16814657E-09_JPRB, 0.16820299E-09_JPRB, 0.16825252E-09_JPRB, 0.16829081E-09_JPRB, 0.16831284E-09_JPRB, &
  & 0.16831654E-09_JPRB, 0.16830222E-09_JPRB, 0.16827260E-09_JPRB, 0.16823166E-09_JPRB, 0.16818492E-09_JPRB, 0.16813696E-09_JPRB, &
  & 0.16809013E-09_JPRB, 0.16804511E-09_JPRB, 0.16800160E-09_JPRB, 0.16796031E-09_JPRB, 0.16792262E-09_JPRB, 0.16789108E-09_JPRB, &
  & 0.16786651E-09_JPRB, 0.16784669E-09_JPRB, 0.16782330E-09_JPRB, 0.16778481E-09_JPRB, 0.16771252E-09_JPRB, 0.16759237E-09_JPRB, &
  & 0.16741691E-09_JPRB, 0.16718991E-09_JPRB, 0.16695542E-09_JPRB, 0.16673049E-09_JPRB, 0.16654009E-09_JPRB, 0.16637237E-09_JPRB, &
  & 0.16622519E-09_JPRB, 0.16609128E-09_JPRB, 0.16596674E-09_JPRB, 0.16585197E-09_JPRB, 0.16574847E-09_JPRB, 0.16565632E-09_JPRB, &
  & 0.16557072E-09_JPRB, 0.16548411E-09_JPRB, 0.16538004E-09_JPRB, 0.16518996E-09_JPRB /)

RGHG8(:,49, 3) = (/ &
  & 0.16420441E-09_JPRB, 0.16456517E-09_JPRB, 0.16479118E-09_JPRB, 0.16502981E-09_JPRB, 0.16529701E-09_JPRB, 0.16556612E-09_JPRB, &
  & 0.16578167E-09_JPRB, 0.16593578E-09_JPRB, 0.16604855E-09_JPRB, 0.16614195E-09_JPRB, 0.16623417E-09_JPRB, 0.16633898E-09_JPRB, &
  & 0.16647836E-09_JPRB, 0.16666962E-09_JPRB, 0.16689619E-09_JPRB, 0.16712570E-09_JPRB, 0.16730986E-09_JPRB, 0.16745497E-09_JPRB, &
  & 0.16757198E-09_JPRB, 0.16767422E-09_JPRB, 0.16776887E-09_JPRB, 0.16785930E-09_JPRB, 0.16794564E-09_JPRB, 0.16802597E-09_JPRB, &
  & 0.16809959E-09_JPRB, 0.16816520E-09_JPRB, 0.16822449E-09_JPRB, 0.16827484E-09_JPRB, 0.16831243E-09_JPRB, 0.16833218E-09_JPRB, &
  & 0.16833272E-09_JPRB, 0.16831528E-09_JPRB, 0.16828257E-09_JPRB, 0.16823917E-09_JPRB, 0.16819052E-09_JPRB, 0.16814156E-09_JPRB, &
  & 0.16809480E-09_JPRB, 0.16805088E-09_JPRB, 0.16801022E-09_JPRB, 0.16797413E-09_JPRB, 0.16794575E-09_JPRB, 0.16792930E-09_JPRB, &
  & 0.16792763E-09_JPRB, 0.16793965E-09_JPRB, 0.16795849E-09_JPRB, 0.16796971E-09_JPRB, 0.16795543E-09_JPRB, 0.16789431E-09_JPRB, &
  & 0.16776894E-09_JPRB, 0.16759090E-09_JPRB, 0.16738222E-09_JPRB, 0.16719218E-09_JPRB, 0.16702065E-09_JPRB, 0.16686971E-09_JPRB, &
  & 0.16673342E-09_JPRB, 0.16660742E-09_JPRB, 0.16648881E-09_JPRB, 0.16637909E-09_JPRB, 0.16628117E-09_JPRB, 0.16619492E-09_JPRB, &
  & 0.16611604E-09_JPRB, 0.16603631E-09_JPRB, 0.16594104E-09_JPRB, 0.16576758E-09_JPRB /)

RGHG8(:,50, 3) = (/ &
  & 0.16477116E-09_JPRB, 0.16513090E-09_JPRB, 0.16536136E-09_JPRB, 0.16560457E-09_JPRB, 0.16588110E-09_JPRB, 0.16615256E-09_JPRB, &
  & 0.16636069E-09_JPRB, 0.16650403E-09_JPRB, 0.16660368E-09_JPRB, 0.16668426E-09_JPRB, 0.16675752E-09_JPRB, 0.16684172E-09_JPRB, &
  & 0.16694011E-09_JPRB, 0.16706664E-09_JPRB, 0.16721330E-09_JPRB, 0.16734866E-09_JPRB, 0.16746271E-09_JPRB, 0.16755512E-09_JPRB, &
  & 0.16763663E-09_JPRB, 0.16771461E-09_JPRB, 0.16779340E-09_JPRB, 0.16787494E-09_JPRB, 0.16795830E-09_JPRB, 0.16803957E-09_JPRB, &
  & 0.16811595E-09_JPRB, 0.16818501E-09_JPRB, 0.16824633E-09_JPRB, 0.16829743E-09_JPRB, 0.16833372E-09_JPRB, 0.16835086E-09_JPRB, &
  & 0.16834818E-09_JPRB, 0.16832744E-09_JPRB, 0.16829160E-09_JPRB, 0.16824547E-09_JPRB, 0.16819497E-09_JPRB, 0.16814494E-09_JPRB, &
  & 0.16809809E-09_JPRB, 0.16805521E-09_JPRB, 0.16801704E-09_JPRB, 0.16798603E-09_JPRB, 0.16796661E-09_JPRB, 0.16796477E-09_JPRB, &
  & 0.16798432E-09_JPRB, 0.16802373E-09_JPRB, 0.16807557E-09_JPRB, 0.16812396E-09_JPRB, 0.16815341E-09_JPRB, 0.16814443E-09_JPRB, &
  & 0.16808230E-09_JPRB, 0.16796226E-09_JPRB, 0.16782054E-09_JPRB, 0.16767360E-09_JPRB, 0.16753629E-09_JPRB, 0.16740975E-09_JPRB, &
  & 0.16728774E-09_JPRB, 0.16717021E-09_JPRB, 0.16705734E-09_JPRB, 0.16694991E-09_JPRB, 0.16685411E-09_JPRB, 0.16677035E-09_JPRB, &
  & 0.16669399E-09_JPRB, 0.16661711E-09_JPRB, 0.16652578E-09_JPRB, 0.16635918E-09_JPRB /)

RGHG8(:,51, 3) = (/ &
  & 0.16531626E-09_JPRB, 0.16567110E-09_JPRB, 0.16591836E-09_JPRB, 0.16616793E-09_JPRB, 0.16645980E-09_JPRB, 0.16672759E-09_JPRB, &
  & 0.16692236E-09_JPRB, 0.16704182E-09_JPRB, 0.16712025E-09_JPRB, 0.16717586E-09_JPRB, 0.16722543E-09_JPRB, 0.16727099E-09_JPRB, &
  & 0.16732668E-09_JPRB, 0.16738851E-09_JPRB, 0.16745808E-09_JPRB, 0.16752584E-09_JPRB, 0.16758435E-09_JPRB, 0.16763796E-09_JPRB, &
  & 0.16769169E-09_JPRB, 0.16774959E-09_JPRB, 0.16781501E-09_JPRB, 0.16788904E-09_JPRB, 0.16796997E-09_JPRB, 0.16805328E-09_JPRB, &
  & 0.16813326E-09_JPRB, 0.16820564E-09_JPRB, 0.16826919E-09_JPRB, 0.16832022E-09_JPRB, 0.16835469E-09_JPRB, 0.16836914E-09_JPRB, &
  & 0.16836321E-09_JPRB, 0.16833897E-09_JPRB, 0.16829989E-09_JPRB, 0.16825086E-09_JPRB, 0.16819843E-09_JPRB, 0.16814734E-09_JPRB, &
  & 0.16810038E-09_JPRB, 0.16805836E-09_JPRB, 0.16802258E-09_JPRB, 0.16799638E-09_JPRB, 0.16798582E-09_JPRB, 0.16799825E-09_JPRB, &
  & 0.16803735E-09_JPRB, 0.16810012E-09_JPRB, 0.16817368E-09_JPRB, 0.16824800E-09_JPRB, 0.16830384E-09_JPRB, 0.16833168E-09_JPRB, &
  & 0.16831762E-09_JPRB, 0.16826535E-09_JPRB, 0.16818694E-09_JPRB, 0.16810318E-09_JPRB, 0.16801918E-09_JPRB, 0.16792923E-09_JPRB, &
  & 0.16783830E-09_JPRB, 0.16774267E-09_JPRB, 0.16764173E-09_JPRB, 0.16754348E-09_JPRB, 0.16745182E-09_JPRB, 0.16737065E-09_JPRB, &
  & 0.16729627E-09_JPRB, 0.16722107E-09_JPRB, 0.16713037E-09_JPRB, 0.16696748E-09_JPRB /)

RGHG8(:,52, 3) = (/ &
  & 0.16581622E-09_JPRB, 0.16620680E-09_JPRB, 0.16643771E-09_JPRB, 0.16671217E-09_JPRB, 0.16699184E-09_JPRB, 0.16723870E-09_JPRB, &
  & 0.16738749E-09_JPRB, 0.16747122E-09_JPRB, 0.16751789E-09_JPRB, 0.16754857E-09_JPRB, 0.16756956E-09_JPRB, 0.16758916E-09_JPRB, &
  & 0.16760571E-09_JPRB, 0.16762464E-09_JPRB, 0.16764393E-09_JPRB, 0.16766320E-09_JPRB, 0.16768349E-09_JPRB, 0.16770783E-09_JPRB, &
  & 0.16773954E-09_JPRB, 0.16778141E-09_JPRB, 0.16783508E-09_JPRB, 0.16790261E-09_JPRB, 0.16798220E-09_JPRB, 0.16806780E-09_JPRB, &
  & 0.16815159E-09_JPRB, 0.16822738E-09_JPRB, 0.16829252E-09_JPRB, 0.16834313E-09_JPRB, 0.16837556E-09_JPRB, 0.16838718E-09_JPRB, &
  & 0.16837806E-09_JPRB, 0.16835010E-09_JPRB, 0.16830774E-09_JPRB, 0.16825571E-09_JPRB, 0.16820126E-09_JPRB, 0.16814911E-09_JPRB, &
  & 0.16810195E-09_JPRB, 0.16806079E-09_JPRB, 0.16802724E-09_JPRB, 0.16800583E-09_JPRB, 0.16800410E-09_JPRB, 0.16803048E-09_JPRB, &
  & 0.16808742E-09_JPRB, 0.16816702E-09_JPRB, 0.16825938E-09_JPRB, 0.16834475E-09_JPRB, 0.16841946E-09_JPRB, 0.16846827E-09_JPRB, &
  & 0.16848711E-09_JPRB, 0.16847643E-09_JPRB, 0.16844934E-09_JPRB, 0.16841499E-09_JPRB, 0.16837443E-09_JPRB, 0.16833110E-09_JPRB, &
  & 0.16827834E-09_JPRB, 0.16821713E-09_JPRB, 0.16814844E-09_JPRB, 0.16807225E-09_JPRB, 0.16799875E-09_JPRB, 0.16793074E-09_JPRB, &
  & 0.16786600E-09_JPRB, 0.16779857E-09_JPRB, 0.16771592E-09_JPRB, 0.16755924E-09_JPRB /)

RGHG8(:,53, 3) = (/ &
  & 0.16631460E-09_JPRB, 0.16667109E-09_JPRB, 0.16694203E-09_JPRB, 0.16717851E-09_JPRB, 0.16743512E-09_JPRB, 0.16761405E-09_JPRB, &
  & 0.16771080E-09_JPRB, 0.16775659E-09_JPRB, 0.16777982E-09_JPRB, 0.16779188E-09_JPRB, 0.16779875E-09_JPRB, 0.16780122E-09_JPRB, &
  & 0.16780008E-09_JPRB, 0.16779508E-09_JPRB, 0.16778523E-09_JPRB, 0.16777406E-09_JPRB, 0.16776680E-09_JPRB, 0.16776866E-09_JPRB, &
  & 0.16778272E-09_JPRB, 0.16781075E-09_JPRB, 0.16785515E-09_JPRB, 0.16791719E-09_JPRB, 0.16799566E-09_JPRB, 0.16808377E-09_JPRB, &
  & 0.16817100E-09_JPRB, 0.16824983E-09_JPRB, 0.16831628E-09_JPRB, 0.16836625E-09_JPRB, 0.16839653E-09_JPRB, 0.16840523E-09_JPRB, &
  & 0.16839295E-09_JPRB, 0.16836121E-09_JPRB, 0.16831533E-09_JPRB, 0.16826029E-09_JPRB, 0.16820377E-09_JPRB, 0.16815044E-09_JPRB, &
  & 0.16810321E-09_JPRB, 0.16806284E-09_JPRB, 0.16803171E-09_JPRB, 0.16801514E-09_JPRB, 0.16802199E-09_JPRB, 0.16806119E-09_JPRB, &
  & 0.16813310E-09_JPRB, 0.16822882E-09_JPRB, 0.16832886E-09_JPRB, 0.16842822E-09_JPRB, 0.16850918E-09_JPRB, 0.16857221E-09_JPRB, &
  & 0.16860910E-09_JPRB, 0.16862173E-09_JPRB, 0.16862023E-09_JPRB, 0.16861149E-09_JPRB, 0.16859905E-09_JPRB, 0.16858100E-09_JPRB, &
  & 0.16855861E-09_JPRB, 0.16852902E-09_JPRB, 0.16849072E-09_JPRB, 0.16844752E-09_JPRB, 0.16840172E-09_JPRB, 0.16835736E-09_JPRB, &
  & 0.16831395E-09_JPRB, 0.16826579E-09_JPRB, 0.16820215E-09_JPRB, 0.16807554E-09_JPRB /)

RGHG8(:,54, 3) = (/ &
  & 0.16674244E-09_JPRB, 0.16713869E-09_JPRB, 0.16734779E-09_JPRB, 0.16756935E-09_JPRB, 0.16774880E-09_JPRB, 0.16786519E-09_JPRB, &
  & 0.16791774E-09_JPRB, 0.16794038E-09_JPRB, 0.16794974E-09_JPRB, 0.16795315E-09_JPRB, 0.16795274E-09_JPRB, 0.16794842E-09_JPRB, &
  & 0.16794045E-09_JPRB, 0.16792324E-09_JPRB, 0.16789914E-09_JPRB, 0.16786822E-09_JPRB, 0.16784024E-09_JPRB, 0.16782353E-09_JPRB, &
  & 0.16782233E-09_JPRB, 0.16783903E-09_JPRB, 0.16787532E-09_JPRB, 0.16793353E-09_JPRB, 0.16801151E-09_JPRB, 0.16810138E-09_JPRB, &
  & 0.16819156E-09_JPRB, 0.16827284E-09_JPRB, 0.16834047E-09_JPRB, 0.16838975E-09_JPRB, 0.16841800E-09_JPRB, 0.16842369E-09_JPRB, &
  & 0.16840807E-09_JPRB, 0.16837269E-09_JPRB, 0.16832295E-09_JPRB, 0.16826510E-09_JPRB, 0.16820624E-09_JPRB, 0.16815191E-09_JPRB, &
  & 0.16810445E-09_JPRB, 0.16806523E-09_JPRB, 0.16803667E-09_JPRB, 0.16802504E-09_JPRB, 0.16803994E-09_JPRB, 0.16809033E-09_JPRB, &
  & 0.16817547E-09_JPRB, 0.16828045E-09_JPRB, 0.16839369E-09_JPRB, 0.16849525E-09_JPRB, 0.16858649E-09_JPRB, 0.16865581E-09_JPRB, &
  & 0.16870086E-09_JPRB, 0.16872498E-09_JPRB, 0.16873503E-09_JPRB, 0.16873802E-09_JPRB, 0.16873708E-09_JPRB, 0.16873314E-09_JPRB, &
  & 0.16872537E-09_JPRB, 0.16871353E-09_JPRB, 0.16869714E-09_JPRB, 0.16867592E-09_JPRB, 0.16865322E-09_JPRB, 0.16863083E-09_JPRB, &
  & 0.16860754E-09_JPRB, 0.16858140E-09_JPRB, 0.16854511E-09_JPRB, 0.16846721E-09_JPRB /)

RGHG8(:,55, 3) = (/ &
  & 0.16716763E-09_JPRB, 0.16749706E-09_JPRB, 0.16769867E-09_JPRB, 0.16784639E-09_JPRB, 0.16796467E-09_JPRB, 0.16803114E-09_JPRB, &
  & 0.16805804E-09_JPRB, 0.16806756E-09_JPRB, 0.16807011E-09_JPRB, 0.16806931E-09_JPRB, 0.16806584E-09_JPRB, 0.16805994E-09_JPRB, &
  & 0.16804752E-09_JPRB, 0.16802927E-09_JPRB, 0.16799570E-09_JPRB, 0.16795262E-09_JPRB, 0.16790812E-09_JPRB, 0.16787469E-09_JPRB, &
  & 0.16785968E-09_JPRB, 0.16786630E-09_JPRB, 0.16789670E-09_JPRB, 0.16795207E-09_JPRB, 0.16802987E-09_JPRB, 0.16812098E-09_JPRB, &
  & 0.16821332E-09_JPRB, 0.16829674E-09_JPRB, 0.16836538E-09_JPRB, 0.16841427E-09_JPRB, 0.16844043E-09_JPRB, 0.16844298E-09_JPRB, &
  & 0.16842382E-09_JPRB, 0.16838488E-09_JPRB, 0.16833124E-09_JPRB, 0.16827031E-09_JPRB, 0.16820929E-09_JPRB, 0.16815382E-09_JPRB, &
  & 0.16810640E-09_JPRB, 0.16806841E-09_JPRB, 0.16804284E-09_JPRB, 0.16803620E-09_JPRB, 0.16805835E-09_JPRB, 0.16811803E-09_JPRB, &
  & 0.16821219E-09_JPRB, 0.16832907E-09_JPRB, 0.16844601E-09_JPRB, 0.16855892E-09_JPRB, 0.16865191E-09_JPRB, 0.16872673E-09_JPRB, &
  & 0.16877635E-09_JPRB, 0.16880362E-09_JPRB, 0.16881824E-09_JPRB, 0.16882640E-09_JPRB, 0.16883042E-09_JPRB, 0.16883234E-09_JPRB, &
  & 0.16883200E-09_JPRB, 0.16882928E-09_JPRB, 0.16882373E-09_JPRB, 0.16881577E-09_JPRB, 0.16880622E-09_JPRB, 0.16879609E-09_JPRB, &
  & 0.16878567E-09_JPRB, 0.16877252E-09_JPRB, 0.16875250E-09_JPRB, 0.16869862E-09_JPRB /)

RGHG8(:,56, 3) = (/ &
  & 0.16751961E-09_JPRB, 0.16781188E-09_JPRB, 0.16794585E-09_JPRB, 0.16804380E-09_JPRB, 0.16811483E-09_JPRB, 0.16815019E-09_JPRB, &
  & 0.16816279E-09_JPRB, 0.16816563E-09_JPRB, 0.16816490E-09_JPRB, 0.16816222E-09_JPRB, 0.16815807E-09_JPRB, 0.16815055E-09_JPRB, &
  & 0.16813989E-09_JPRB, 0.16811763E-09_JPRB, 0.16808406E-09_JPRB, 0.16803157E-09_JPRB, 0.16797301E-09_JPRB, 0.16792408E-09_JPRB, &
  & 0.16789617E-09_JPRB, 0.16789409E-09_JPRB, 0.16791969E-09_JPRB, 0.16797341E-09_JPRB, 0.16805078E-09_JPRB, 0.16814299E-09_JPRB, &
  & 0.16823672E-09_JPRB, 0.16832215E-09_JPRB, 0.16839179E-09_JPRB, 0.16843998E-09_JPRB, 0.16846424E-09_JPRB, 0.16846360E-09_JPRB, &
  & 0.16844066E-09_JPRB, 0.16839810E-09_JPRB, 0.16834081E-09_JPRB, 0.16827663E-09_JPRB, 0.16821360E-09_JPRB, 0.16815693E-09_JPRB, &
  & 0.16810958E-09_JPRB, 0.16807317E-09_JPRB, 0.16805074E-09_JPRB, 0.16804916E-09_JPRB, 0.16807784E-09_JPRB, 0.16814426E-09_JPRB, &
  & 0.16824693E-09_JPRB, 0.16836908E-09_JPRB, 0.16849735E-09_JPRB, 0.16861190E-09_JPRB, 0.16871335E-09_JPRB, 0.16878993E-09_JPRB, &
  & 0.16883941E-09_JPRB, 0.16886878E-09_JPRB, 0.16888475E-09_JPRB, 0.16889426E-09_JPRB, 0.16890091E-09_JPRB, 0.16890517E-09_JPRB, &
  & 0.16890825E-09_JPRB, 0.16890984E-09_JPRB, 0.16890986E-09_JPRB, 0.16890833E-09_JPRB, 0.16890569E-09_JPRB, 0.16890260E-09_JPRB, &
  & 0.16889912E-09_JPRB, 0.16889552E-09_JPRB, 0.16889146E-09_JPRB, 0.16888728E-09_JPRB /)

RGHG8(:,57, 3) = (/ &
  & 0.16782439E-09_JPRB, 0.16803688E-09_JPRB, 0.16812671E-09_JPRB, 0.16818834E-09_JPRB, 0.16822581E-09_JPRB, 0.16824474E-09_JPRB, &
  & 0.16824932E-09_JPRB, 0.16824879E-09_JPRB, 0.16824653E-09_JPRB, 0.16824324E-09_JPRB, 0.16823845E-09_JPRB, 0.16823196E-09_JPRB, &
  & 0.16821962E-09_JPRB, 0.16820087E-09_JPRB, 0.16816319E-09_JPRB, 0.16810683E-09_JPRB, 0.16803629E-09_JPRB, 0.16797312E-09_JPRB, &
  & 0.16793350E-09_JPRB, 0.16792391E-09_JPRB, 0.16794580E-09_JPRB, 0.16799789E-09_JPRB, 0.16807521E-09_JPRB, 0.16816738E-09_JPRB, &
  & 0.16826303E-09_JPRB, 0.16834979E-09_JPRB, 0.16842019E-09_JPRB, 0.16846784E-09_JPRB, 0.16848992E-09_JPRB, 0.16848616E-09_JPRB, &
  & 0.16845944E-09_JPRB, 0.16841314E-09_JPRB, 0.16835230E-09_JPRB, 0.16828480E-09_JPRB, 0.16821973E-09_JPRB, 0.16816194E-09_JPRB, &
  & 0.16811494E-09_JPRB, 0.16808017E-09_JPRB, 0.16806112E-09_JPRB, 0.16806442E-09_JPRB, 0.16809870E-09_JPRB, 0.16817119E-09_JPRB, &
  & 0.16827818E-09_JPRB, 0.16840850E-09_JPRB, 0.16853954E-09_JPRB, 0.16866453E-09_JPRB, 0.16876726E-09_JPRB, 0.16884663E-09_JPRB, &
  & 0.16889720E-09_JPRB, 0.16892521E-09_JPRB, 0.16894160E-09_JPRB, 0.16895205E-09_JPRB, 0.16895892E-09_JPRB, 0.16896462E-09_JPRB, &
  & 0.16896887E-09_JPRB, 0.16897231E-09_JPRB, 0.16897478E-09_JPRB, 0.16897617E-09_JPRB, 0.16897650E-09_JPRB, 0.16897601E-09_JPRB, &
  & 0.16897497E-09_JPRB, 0.16897311E-09_JPRB, 0.16897009E-09_JPRB, 0.16896309E-09_JPRB /)

RGHG8(:,58, 3) = (/ &
  & 0.16807485E-09_JPRB, 0.16820667E-09_JPRB, 0.16826415E-09_JPRB, 0.16829635E-09_JPRB, 0.16831855E-09_JPRB, 0.16832644E-09_JPRB, &
  & 0.16832694E-09_JPRB, 0.16832478E-09_JPRB, 0.16832183E-09_JPRB, 0.16831822E-09_JPRB, 0.16831377E-09_JPRB, 0.16830662E-09_JPRB, &
  & 0.16829635E-09_JPRB, 0.16827496E-09_JPRB, 0.16823974E-09_JPRB, 0.16817754E-09_JPRB, 0.16809786E-09_JPRB, 0.16802255E-09_JPRB, &
  & 0.16797330E-09_JPRB, 0.16795738E-09_JPRB, 0.16797586E-09_JPRB, 0.16802648E-09_JPRB, 0.16810299E-09_JPRB, 0.16819625E-09_JPRB, &
  & 0.16829245E-09_JPRB, 0.16838073E-09_JPRB, 0.16845135E-09_JPRB, 0.16849801E-09_JPRB, 0.16851807E-09_JPRB, 0.16851134E-09_JPRB, &
  & 0.16848095E-09_JPRB, 0.16843074E-09_JPRB, 0.16836652E-09_JPRB, 0.16829582E-09_JPRB, 0.16822861E-09_JPRB, 0.16816981E-09_JPRB, &
  & 0.16812327E-09_JPRB, 0.16809035E-09_JPRB, 0.16807457E-09_JPRB, 0.16808240E-09_JPRB, 0.16812186E-09_JPRB, 0.16819869E-09_JPRB, &
  & 0.16831067E-09_JPRB, 0.16844358E-09_JPRB, 0.16858259E-09_JPRB, 0.16870870E-09_JPRB, 0.16881889E-09_JPRB, 0.16889899E-09_JPRB, &
  & 0.16894844E-09_JPRB, 0.16897717E-09_JPRB, 0.16899326E-09_JPRB, 0.16900351E-09_JPRB, 0.16901108E-09_JPRB, 0.16901661E-09_JPRB, &
  & 0.16902145E-09_JPRB, 0.16902546E-09_JPRB, 0.16902875E-09_JPRB, 0.16903132E-09_JPRB, 0.16903287E-09_JPRB, 0.16903345E-09_JPRB, &
  & 0.16903329E-09_JPRB, 0.16903233E-09_JPRB, 0.16903007E-09_JPRB, 0.16902406E-09_JPRB /)

RGHG8(:,59, 3) = (/ &
  & 0.16824378E-09_JPRB, 0.16833673E-09_JPRB, 0.16836874E-09_JPRB, 0.16838950E-09_JPRB, 0.16839942E-09_JPRB, 0.16840238E-09_JPRB, &
  & 0.16840077E-09_JPRB, 0.16839777E-09_JPRB, 0.16839466E-09_JPRB, 0.16839113E-09_JPRB, 0.16838653E-09_JPRB, 0.16838023E-09_JPRB, &
  & 0.16836858E-09_JPRB, 0.16834947E-09_JPRB, 0.16830982E-09_JPRB, 0.16824488E-09_JPRB, 0.16815709E-09_JPRB, 0.16807324E-09_JPRB, &
  & 0.16801649E-09_JPRB, 0.16799563E-09_JPRB, 0.16801102E-09_JPRB, 0.16805989E-09_JPRB, 0.16813614E-09_JPRB, 0.16822924E-09_JPRB, &
  & 0.16832671E-09_JPRB, 0.16841532E-09_JPRB, 0.16848582E-09_JPRB, 0.16853144E-09_JPRB, 0.16854936E-09_JPRB, 0.16853983E-09_JPRB, &
  & 0.16850601E-09_JPRB, 0.16845218E-09_JPRB, 0.16838428E-09_JPRB, 0.16831078E-09_JPRB, 0.16824114E-09_JPRB, 0.16818161E-09_JPRB, &
  & 0.16813564E-09_JPRB, 0.16810446E-09_JPRB, 0.16809182E-09_JPRB, 0.16810381E-09_JPRB, 0.16814770E-09_JPRB, 0.16822889E-09_JPRB, &
  & 0.16834348E-09_JPRB, 0.16848042E-09_JPRB, 0.16862067E-09_JPRB, 0.16875336E-09_JPRB, 0.16886387E-09_JPRB, 0.16894662E-09_JPRB, &
  & 0.16899751E-09_JPRB, 0.16902538E-09_JPRB, 0.16904184E-09_JPRB, 0.16905229E-09_JPRB, 0.16905941E-09_JPRB, 0.16906523E-09_JPRB, &
  & 0.16906981E-09_JPRB, 0.16907381E-09_JPRB, 0.16907722E-09_JPRB, 0.16907996E-09_JPRB, 0.16908179E-09_JPRB, 0.16908272E-09_JPRB, &
  & 0.16908282E-09_JPRB, 0.16908203E-09_JPRB, 0.16907992E-09_JPRB, 0.16907351E-09_JPRB /)

RGHG8(:,60, 3) = (/ &
  & 0.16840176E-09_JPRB, 0.16844326E-09_JPRB, 0.16846180E-09_JPRB, 0.16847106E-09_JPRB, 0.16847616E-09_JPRB, 0.16847609E-09_JPRB, &
  & 0.16847335E-09_JPRB, 0.16847022E-09_JPRB, 0.16846705E-09_JPRB, 0.16846358E-09_JPRB, 0.16845929E-09_JPRB, 0.16845250E-09_JPRB, &
  & 0.16844184E-09_JPRB, 0.16841950E-09_JPRB, 0.16837946E-09_JPRB, 0.16830826E-09_JPRB, 0.16821466E-09_JPRB, 0.16812539E-09_JPRB, &
  & 0.16806426E-09_JPRB, 0.16803928E-09_JPRB, 0.16805192E-09_JPRB, 0.16809934E-09_JPRB, 0.16817490E-09_JPRB, 0.16826822E-09_JPRB, &
  & 0.16836574E-09_JPRB, 0.16845443E-09_JPRB, 0.16852422E-09_JPRB, 0.16856840E-09_JPRB, 0.16858426E-09_JPRB, 0.16857223E-09_JPRB, &
  & 0.16853559E-09_JPRB, 0.16847823E-09_JPRB, 0.16840705E-09_JPRB, 0.16833056E-09_JPRB, 0.16825870E-09_JPRB, 0.16819834E-09_JPRB, &
  & 0.16815285E-09_JPRB, 0.16812342E-09_JPRB, 0.16811361E-09_JPRB, 0.16812925E-09_JPRB, 0.16817722E-09_JPRB, 0.16826171E-09_JPRB, &
  & 0.16837925E-09_JPRB, 0.16851759E-09_JPRB, 0.16866090E-09_JPRB, 0.16879295E-09_JPRB, 0.16890733E-09_JPRB, 0.16899093E-09_JPRB, &
  & 0.16904254E-09_JPRB, 0.16907209E-09_JPRB, 0.16908863E-09_JPRB, 0.16909896E-09_JPRB, 0.16910627E-09_JPRB, 0.16911153E-09_JPRB, &
  & 0.16911592E-09_JPRB, 0.16911952E-09_JPRB, 0.16912252E-09_JPRB, 0.16912501E-09_JPRB, 0.16912666E-09_JPRB, 0.16912742E-09_JPRB, &
  & 0.16912746E-09_JPRB, 0.16912671E-09_JPRB, 0.16912466E-09_JPRB, 0.16911894E-09_JPRB /)

RGHG8(:,61, 3) = (/ &
  & 0.16849531E-09_JPRB, 0.16852988E-09_JPRB, 0.16854157E-09_JPRB, 0.16854812E-09_JPRB, 0.16855037E-09_JPRB, 0.16854934E-09_JPRB, &
  & 0.16854662E-09_JPRB, 0.16854350E-09_JPRB, 0.16854057E-09_JPRB, 0.16853732E-09_JPRB, 0.16853301E-09_JPRB, 0.16852664E-09_JPRB, &
  & 0.16851440E-09_JPRB, 0.16849200E-09_JPRB, 0.16844555E-09_JPRB, 0.16836933E-09_JPRB, 0.16827238E-09_JPRB, 0.16818098E-09_JPRB, &
  & 0.16811694E-09_JPRB, 0.16808904E-09_JPRB, 0.16809956E-09_JPRB, 0.16814575E-09_JPRB, 0.16822045E-09_JPRB, 0.16831361E-09_JPRB, &
  & 0.16841065E-09_JPRB, 0.16849855E-09_JPRB, 0.16856699E-09_JPRB, 0.16860961E-09_JPRB, 0.16862346E-09_JPRB, 0.16860939E-09_JPRB, &
  & 0.16857032E-09_JPRB, 0.16851028E-09_JPRB, 0.16843583E-09_JPRB, 0.16835665E-09_JPRB, 0.16828246E-09_JPRB, 0.16822133E-09_JPRB, &
  & 0.16817613E-09_JPRB, 0.16814816E-09_JPRB, 0.16814085E-09_JPRB, 0.16815965E-09_JPRB, 0.16821090E-09_JPRB, 0.16829838E-09_JPRB, &
  & 0.16841779E-09_JPRB, 0.16855749E-09_JPRB, 0.16870084E-09_JPRB, 0.16883400E-09_JPRB, 0.16894711E-09_JPRB, 0.16903259E-09_JPRB, &
  & 0.16908665E-09_JPRB, 0.16911703E-09_JPRB, 0.16913444E-09_JPRB, 0.16914503E-09_JPRB, 0.16915190E-09_JPRB, 0.16915702E-09_JPRB, &
  & 0.16916082E-09_JPRB, 0.16916391E-09_JPRB, 0.16916635E-09_JPRB, 0.16916823E-09_JPRB, 0.16916940E-09_JPRB, 0.16916984E-09_JPRB, &
  & 0.16916961E-09_JPRB, 0.16916857E-09_JPRB, 0.16916629E-09_JPRB, 0.16915995E-09_JPRB /)

RGHG8(:,62, 3) = (/ &
  & 0.16858531E-09_JPRB, 0.16860981E-09_JPRB, 0.16861891E-09_JPRB, 0.16862303E-09_JPRB, 0.16862456E-09_JPRB, 0.16862359E-09_JPRB, &
  & 0.16862105E-09_JPRB, 0.16861834E-09_JPRB, 0.16861564E-09_JPRB, 0.16861265E-09_JPRB, 0.16860865E-09_JPRB, 0.16860188E-09_JPRB, &
  & 0.16858955E-09_JPRB, 0.16856280E-09_JPRB, 0.16851207E-09_JPRB, 0.16843099E-09_JPRB, 0.16833294E-09_JPRB, 0.16824153E-09_JPRB, &
  & 0.16817578E-09_JPRB, 0.16814600E-09_JPRB, 0.16815493E-09_JPRB, 0.16819984E-09_JPRB, 0.16827391E-09_JPRB, 0.16836599E-09_JPRB, &
  & 0.16846205E-09_JPRB, 0.16854826E-09_JPRB, 0.16861500E-09_JPRB, 0.16865570E-09_JPRB, 0.16866777E-09_JPRB, 0.16865212E-09_JPRB, &
  & 0.16861143E-09_JPRB, 0.16854929E-09_JPRB, 0.16847226E-09_JPRB, 0.16839041E-09_JPRB, 0.16831408E-09_JPRB, 0.16825182E-09_JPRB, &
  & 0.16820675E-09_JPRB, 0.16817989E-09_JPRB, 0.16817461E-09_JPRB, 0.16819601E-09_JPRB, 0.16824991E-09_JPRB, 0.16833952E-09_JPRB, &
  & 0.16846020E-09_JPRB, 0.16860040E-09_JPRB, 0.16874355E-09_JPRB, 0.16887519E-09_JPRB, 0.16898757E-09_JPRB, 0.16907301E-09_JPRB, &
  & 0.16912885E-09_JPRB, 0.16916157E-09_JPRB, 0.16917975E-09_JPRB, 0.16919041E-09_JPRB, 0.16919724E-09_JPRB, 0.16920174E-09_JPRB, &
  & 0.16920504E-09_JPRB, 0.16920750E-09_JPRB, 0.16920922E-09_JPRB, 0.16921042E-09_JPRB, 0.16921099E-09_JPRB, 0.16921095E-09_JPRB, &
  & 0.16921028E-09_JPRB, 0.16920894E-09_JPRB, 0.16920630E-09_JPRB, 0.16919963E-09_JPRB /)

RGHG8(:,63, 3) = (/ &
  & 0.16866401E-09_JPRB, 0.16868648E-09_JPRB, 0.16869409E-09_JPRB, 0.16869796E-09_JPRB, 0.16869940E-09_JPRB, 0.16869883E-09_JPRB, &
  & 0.16869692E-09_JPRB, 0.16869463E-09_JPRB, 0.16869248E-09_JPRB, 0.16868992E-09_JPRB, 0.16868618E-09_JPRB, 0.16867957E-09_JPRB, &
  & 0.16866535E-09_JPRB, 0.16863565E-09_JPRB, 0.16857926E-09_JPRB, 0.16849608E-09_JPRB, 0.16839920E-09_JPRB, 0.16830820E-09_JPRB, &
  & 0.16824202E-09_JPRB, 0.16821115E-09_JPRB, 0.16821898E-09_JPRB, 0.16826300E-09_JPRB, 0.16833585E-09_JPRB, 0.16842670E-09_JPRB, &
  & 0.16852045E-09_JPRB, 0.16860452E-09_JPRB, 0.16866879E-09_JPRB, 0.16870753E-09_JPRB, 0.16871804E-09_JPRB, 0.16870130E-09_JPRB, &
  & 0.16865979E-09_JPRB, 0.16859639E-09_JPRB, 0.16851752E-09_JPRB, 0.16843331E-09_JPRB, 0.16835500E-09_JPRB, 0.16829156E-09_JPRB, &
  & 0.16824625E-09_JPRB, 0.16822005E-09_JPRB, 0.16821622E-09_JPRB, 0.16823949E-09_JPRB, 0.16829529E-09_JPRB, 0.16838626E-09_JPRB, &
  & 0.16850736E-09_JPRB, 0.16864712E-09_JPRB, 0.16878908E-09_JPRB, 0.16891899E-09_JPRB, 0.16902907E-09_JPRB, 0.16911385E-09_JPRB, &
  & 0.16917114E-09_JPRB, 0.16920557E-09_JPRB, 0.16922491E-09_JPRB, 0.16923585E-09_JPRB, 0.16924226E-09_JPRB, 0.16924633E-09_JPRB, &
  & 0.16924893E-09_JPRB, 0.16925067E-09_JPRB, 0.16925161E-09_JPRB, 0.16925208E-09_JPRB, 0.16925203E-09_JPRB, 0.16925142E-09_JPRB, &
  & 0.16925031E-09_JPRB, 0.16924839E-09_JPRB, 0.16924512E-09_JPRB, 0.16923722E-09_JPRB /)

RGHG8(:,64, 3) = (/ &
  & 0.16874012E-09_JPRB, 0.16876109E-09_JPRB, 0.16876876E-09_JPRB, 0.16877269E-09_JPRB, 0.16877467E-09_JPRB, 0.16877486E-09_JPRB, &
  & 0.16877362E-09_JPRB, 0.16877200E-09_JPRB, 0.16877039E-09_JPRB, 0.16876850E-09_JPRB, 0.16876531E-09_JPRB, 0.16875852E-09_JPRB, &
  & 0.16874277E-09_JPRB, 0.16870902E-09_JPRB, 0.16864984E-09_JPRB, 0.16856709E-09_JPRB, 0.16847193E-09_JPRB, 0.16838227E-09_JPRB, &
  & 0.16831621E-09_JPRB, 0.16828491E-09_JPRB, 0.16829213E-09_JPRB, 0.16833522E-09_JPRB, 0.16840680E-09_JPRB, 0.16849522E-09_JPRB, &
  & 0.16858619E-09_JPRB, 0.16866701E-09_JPRB, 0.16872836E-09_JPRB, 0.16876479E-09_JPRB, 0.16877394E-09_JPRB, 0.16875658E-09_JPRB, &
  & 0.16871504E-09_JPRB, 0.16865145E-09_JPRB, 0.16857170E-09_JPRB, 0.16848599E-09_JPRB, 0.16840594E-09_JPRB, 0.16834156E-09_JPRB, &
  & 0.16829570E-09_JPRB, 0.16826972E-09_JPRB, 0.16826673E-09_JPRB, 0.16829114E-09_JPRB, 0.16834804E-09_JPRB, 0.16843936E-09_JPRB, &
  & 0.16855987E-09_JPRB, 0.16869811E-09_JPRB, 0.16883801E-09_JPRB, 0.16896548E-09_JPRB, 0.16907295E-09_JPRB, 0.16915604E-09_JPRB, &
  & 0.16921364E-09_JPRB, 0.16924950E-09_JPRB, 0.16926981E-09_JPRB, 0.16928095E-09_JPRB, 0.16928714E-09_JPRB, 0.16929068E-09_JPRB, &
  & 0.16929268E-09_JPRB, 0.16929366E-09_JPRB, 0.16929377E-09_JPRB, 0.16929350E-09_JPRB, 0.16929280E-09_JPRB, 0.16929165E-09_JPRB, &
  & 0.16928989E-09_JPRB, 0.16928731E-09_JPRB, 0.16928302E-09_JPRB, 0.16927321E-09_JPRB /)

RGHG8(:,65, 3) = (/ &
  & 0.16881141E-09_JPRB, 0.16883409E-09_JPRB, 0.16884250E-09_JPRB, 0.16884733E-09_JPRB, 0.16885010E-09_JPRB, 0.16885127E-09_JPRB, &
  & 0.16885093E-09_JPRB, 0.16884999E-09_JPRB, 0.16884924E-09_JPRB, 0.16884814E-09_JPRB, 0.16884573E-09_JPRB, 0.16883869E-09_JPRB, &
  & 0.16882122E-09_JPRB, 0.16878503E-09_JPRB, 0.16872537E-09_JPRB, 0.16864415E-09_JPRB, 0.16855106E-09_JPRB, 0.16846333E-09_JPRB, &
  & 0.16839841E-09_JPRB, 0.16836760E-09_JPRB, 0.16837454E-09_JPRB, 0.16841664E-09_JPRB, 0.16848606E-09_JPRB, 0.16857128E-09_JPRB, &
  & 0.16865825E-09_JPRB, 0.16873505E-09_JPRB, 0.16879284E-09_JPRB, 0.16882670E-09_JPRB, 0.16883445E-09_JPRB, 0.16881684E-09_JPRB, &
  & 0.16877594E-09_JPRB, 0.16871322E-09_JPRB, 0.16863377E-09_JPRB, 0.16854754E-09_JPRB, 0.16846699E-09_JPRB, 0.16840193E-09_JPRB, &
  & 0.16835573E-09_JPRB, 0.16832968E-09_JPRB, 0.16832705E-09_JPRB, 0.16835190E-09_JPRB, 0.16840894E-09_JPRB, 0.16849971E-09_JPRB, &
  & 0.16861824E-09_JPRB, 0.16875390E-09_JPRB, 0.16889060E-09_JPRB, 0.16901483E-09_JPRB, 0.16911948E-09_JPRB, 0.16920026E-09_JPRB, &
  & 0.16925730E-09_JPRB, 0.16929363E-09_JPRB, 0.16931472E-09_JPRB, 0.16932600E-09_JPRB, 0.16933199E-09_JPRB, 0.16933502E-09_JPRB, &
  & 0.16933638E-09_JPRB, 0.16933660E-09_JPRB, 0.16933585E-09_JPRB, 0.16933487E-09_JPRB, 0.16933360E-09_JPRB, 0.16933185E-09_JPRB, &
  & 0.16932944E-09_JPRB, 0.16932583E-09_JPRB, 0.16932006E-09_JPRB, 0.16930705E-09_JPRB /)

RGHG8(:,66, 3) = (/ &
  & 0.16888019E-09_JPRB, 0.16890564E-09_JPRB, 0.16891587E-09_JPRB, 0.16892199E-09_JPRB, 0.16892600E-09_JPRB, 0.16892820E-09_JPRB, &
  & 0.16892882E-09_JPRB, 0.16892868E-09_JPRB, 0.16892893E-09_JPRB, 0.16892891E-09_JPRB, 0.16892721E-09_JPRB, 0.16892010E-09_JPRB, &
  & 0.16890127E-09_JPRB, 0.16886442E-09_JPRB, 0.16880565E-09_JPRB, 0.16872657E-09_JPRB, 0.16863647E-09_JPRB, 0.16855155E-09_JPRB, &
  & 0.16848881E-09_JPRB, 0.16845897E-09_JPRB, 0.16846585E-09_JPRB, 0.16850640E-09_JPRB, 0.16857285E-09_JPRB, 0.16865362E-09_JPRB, &
  & 0.16873558E-09_JPRB, 0.16880744E-09_JPRB, 0.16886101E-09_JPRB, 0.16889191E-09_JPRB, 0.16889824E-09_JPRB, 0.16888060E-09_JPRB, &
  & 0.16884093E-09_JPRB, 0.16877995E-09_JPRB, 0.16870207E-09_JPRB, 0.16861680E-09_JPRB, 0.16853689E-09_JPRB, 0.16847226E-09_JPRB, &
  & 0.16842613E-09_JPRB, 0.16840021E-09_JPRB, 0.16839764E-09_JPRB, 0.16842239E-09_JPRB, 0.16847877E-09_JPRB, 0.16856765E-09_JPRB, &
  & 0.16868346E-09_JPRB, 0.16881467E-09_JPRB, 0.16894716E-09_JPRB, 0.16906754E-09_JPRB, 0.16916833E-09_JPRB, 0.16924685E-09_JPRB, &
  & 0.16930232E-09_JPRB, 0.16933860E-09_JPRB, 0.16935973E-09_JPRB, 0.16937116E-09_JPRB, 0.16937687E-09_JPRB, 0.16937955E-09_JPRB, &
  & 0.16938029E-09_JPRB, 0.16937979E-09_JPRB, 0.16937832E-09_JPRB, 0.16937671E-09_JPRB, 0.16937500E-09_JPRB, 0.16937272E-09_JPRB, &
  & 0.16936946E-09_JPRB, 0.16936470E-09_JPRB, 0.16935678E-09_JPRB, 0.16933882E-09_JPRB /)

RGHG8(:,67, 3) = (/ &
  & 0.16894790E-09_JPRB, 0.16897719E-09_JPRB, 0.16898924E-09_JPRB, 0.16899709E-09_JPRB, 0.16900251E-09_JPRB, 0.16900603E-09_JPRB, &
  & 0.16900763E-09_JPRB, 0.16900845E-09_JPRB, 0.16900981E-09_JPRB, 0.16901092E-09_JPRB, 0.16900989E-09_JPRB, 0.16900253E-09_JPRB, &
  & 0.16898351E-09_JPRB, 0.16894709E-09_JPRB, 0.16888979E-09_JPRB, 0.16881384E-09_JPRB, 0.16872753E-09_JPRB, 0.16864658E-09_JPRB, &
  & 0.16858662E-09_JPRB, 0.16855826E-09_JPRB, 0.16856477E-09_JPRB, 0.16860319E-09_JPRB, 0.16866558E-09_JPRB, 0.16874090E-09_JPRB, &
  & 0.16881689E-09_JPRB, 0.16888310E-09_JPRB, 0.16893192E-09_JPRB, 0.16895968E-09_JPRB, 0.16896450E-09_JPRB, 0.16894704E-09_JPRB, &
  & 0.16890905E-09_JPRB, 0.16885061E-09_JPRB, 0.16877534E-09_JPRB, 0.16869242E-09_JPRB, 0.16861453E-09_JPRB, 0.16855144E-09_JPRB, &
  & 0.16850625E-09_JPRB, 0.16848091E-09_JPRB, 0.16847845E-09_JPRB, 0.16850277E-09_JPRB, 0.16855767E-09_JPRB, 0.16864400E-09_JPRB, &
  & 0.16875526E-09_JPRB, 0.16888142E-09_JPRB, 0.16900821E-09_JPRB, 0.16912337E-09_JPRB, 0.16922047E-09_JPRB, 0.16929524E-09_JPRB, &
  & 0.16934923E-09_JPRB, 0.16938446E-09_JPRB, 0.16940542E-09_JPRB, 0.16941658E-09_JPRB, 0.16942217E-09_JPRB, 0.16942443E-09_JPRB, &
  & 0.16942470E-09_JPRB, 0.16942364E-09_JPRB, 0.16942148E-09_JPRB, 0.16941946E-09_JPRB, 0.16941744E-09_JPRB, 0.16941466E-09_JPRB, &
  & 0.16941072E-09_JPRB, 0.16940445E-09_JPRB, 0.16939367E-09_JPRB, 0.16936892E-09_JPRB /)

RGHG8(:,68, 3) = (/ &
  & 0.16901389E-09_JPRB, 0.16904778E-09_JPRB, 0.16906276E-09_JPRB, 0.16907264E-09_JPRB, 0.16907992E-09_JPRB, 0.16908488E-09_JPRB, &
  & 0.16908767E-09_JPRB, 0.16908952E-09_JPRB, 0.16909214E-09_JPRB, 0.16909413E-09_JPRB, 0.16909352E-09_JPRB, 0.16908629E-09_JPRB, &
  & 0.16906747E-09_JPRB, 0.16903209E-09_JPRB, 0.16897715E-09_JPRB, 0.16890521E-09_JPRB, 0.16882383E-09_JPRB, 0.16874740E-09_JPRB, &
  & 0.16869088E-09_JPRB, 0.16866387E-09_JPRB, 0.16866973E-09_JPRB, 0.16870513E-09_JPRB, 0.16876260E-09_JPRB, 0.16883170E-09_JPRB, &
  & 0.16890114E-09_JPRB, 0.16896132E-09_JPRB, 0.16900521E-09_JPRB, 0.16902965E-09_JPRB, 0.16903305E-09_JPRB, 0.16901600E-09_JPRB, &
  & 0.16898005E-09_JPRB, 0.16892485E-09_JPRB, 0.16885311E-09_JPRB, 0.16877363E-09_JPRB, 0.16869894E-09_JPRB, 0.16863831E-09_JPRB, &
  & 0.16859500E-09_JPRB, 0.16857073E-09_JPRB, 0.16856865E-09_JPRB, 0.16859239E-09_JPRB, 0.16864549E-09_JPRB, 0.16872802E-09_JPRB, &
  & 0.16883442E-09_JPRB, 0.16895363E-09_JPRB, 0.16907389E-09_JPRB, 0.16918338E-09_JPRB, 0.16927473E-09_JPRB, 0.16934640E-09_JPRB, &
  & 0.16939743E-09_JPRB, 0.16943165E-09_JPRB, 0.16945187E-09_JPRB, 0.16946275E-09_JPRB, 0.16946801E-09_JPRB, 0.16946997E-09_JPRB, &
  & 0.16946985E-09_JPRB, 0.16946836E-09_JPRB, 0.16946569E-09_JPRB, 0.16946339E-09_JPRB, 0.16946125E-09_JPRB, 0.16945828E-09_JPRB, &
  & 0.16945378E-09_JPRB, 0.16944635E-09_JPRB, 0.16943272E-09_JPRB, 0.16939963E-09_JPRB /)

RGHG8(:,69, 3) = (/ &
  & 0.16907906E-09_JPRB, 0.16911951E-09_JPRB, 0.16913712E-09_JPRB, 0.16914965E-09_JPRB, 0.16915880E-09_JPRB, 0.16916543E-09_JPRB, &
  & 0.16916932E-09_JPRB, 0.16917229E-09_JPRB, 0.16917598E-09_JPRB, 0.16917863E-09_JPRB, 0.16917832E-09_JPRB, 0.16917134E-09_JPRB, &
  & 0.16915305E-09_JPRB, 0.16911937E-09_JPRB, 0.16906751E-09_JPRB, 0.16900031E-09_JPRB, 0.16892443E-09_JPRB, 0.16885322E-09_JPRB, &
  & 0.16880010E-09_JPRB, 0.16877444E-09_JPRB, 0.16877903E-09_JPRB, 0.16881076E-09_JPRB, 0.16886277E-09_JPRB, 0.16892521E-09_JPRB, &
  & 0.16898792E-09_JPRB, 0.16904191E-09_JPRB, 0.16908087E-09_JPRB, 0.16910207E-09_JPRB, 0.16910419E-09_JPRB, 0.16908770E-09_JPRB, &
  & 0.16905424E-09_JPRB, 0.16900273E-09_JPRB, 0.16893538E-09_JPRB, 0.16886023E-09_JPRB, 0.16878954E-09_JPRB, 0.16873233E-09_JPRB, &
  & 0.16869151E-09_JPRB, 0.16866886E-09_JPRB, 0.16866741E-09_JPRB, 0.16869055E-09_JPRB, 0.16874135E-09_JPRB, 0.16881993E-09_JPRB, &
  & 0.16891988E-09_JPRB, 0.16903219E-09_JPRB, 0.16914449E-09_JPRB, 0.16924669E-09_JPRB, 0.16933274E-09_JPRB, 0.16939924E-09_JPRB, &
  & 0.16944780E-09_JPRB, 0.16948005E-09_JPRB, 0.16949936E-09_JPRB, 0.16950971E-09_JPRB, 0.16951471E-09_JPRB, 0.16951637E-09_JPRB, &
  & 0.16951600E-09_JPRB, 0.16951428E-09_JPRB, 0.16951143E-09_JPRB, 0.16950902E-09_JPRB, 0.16950692E-09_JPRB, 0.16950394E-09_JPRB, &
  & 0.16949921E-09_JPRB, 0.16949092E-09_JPRB, 0.16947437E-09_JPRB, 0.16943370E-09_JPRB /)

RGHG8(:,70, 3) = (/ &
  & 0.16914457E-09_JPRB, 0.16919155E-09_JPRB, 0.16921357E-09_JPRB, 0.16922853E-09_JPRB, 0.16924001E-09_JPRB, 0.16924803E-09_JPRB, &
  & 0.16925306E-09_JPRB, 0.16925701E-09_JPRB, 0.16926149E-09_JPRB, 0.16926459E-09_JPRB, 0.16926424E-09_JPRB, 0.16925746E-09_JPRB, &
  & 0.16923994E-09_JPRB, 0.16920830E-09_JPRB, 0.16916019E-09_JPRB, 0.16909815E-09_JPRB, 0.16902839E-09_JPRB, 0.16896244E-09_JPRB, &
  & 0.16891304E-09_JPRB, 0.16888836E-09_JPRB, 0.16889144E-09_JPRB, 0.16891909E-09_JPRB, 0.16896523E-09_JPRB, 0.16902085E-09_JPRB, &
  & 0.16907663E-09_JPRB, 0.16912460E-09_JPRB, 0.16915865E-09_JPRB, 0.16917678E-09_JPRB, 0.16917784E-09_JPRB, 0.16916221E-09_JPRB, &
  & 0.16913149E-09_JPRB, 0.16908426E-09_JPRB, 0.16902185E-09_JPRB, 0.16895184E-09_JPRB, 0.16888606E-09_JPRB, 0.16883281E-09_JPRB, &
  & 0.16879510E-09_JPRB, 0.16877444E-09_JPRB, 0.16877374E-09_JPRB, 0.16879621E-09_JPRB, 0.16884452E-09_JPRB, 0.16891818E-09_JPRB, &
  & 0.16901197E-09_JPRB, 0.16911553E-09_JPRB, 0.16921986E-09_JPRB, 0.16931409E-09_JPRB, 0.16939286E-09_JPRB, 0.16945480E-09_JPRB, &
  & 0.16949948E-09_JPRB, 0.16952982E-09_JPRB, 0.16954792E-09_JPRB, 0.16955767E-09_JPRB, 0.16956235E-09_JPRB, 0.16956379E-09_JPRB, &
  & 0.16956345E-09_JPRB, 0.16956174E-09_JPRB, 0.16955895E-09_JPRB, 0.16955667E-09_JPRB, 0.16955479E-09_JPRB, 0.16955196E-09_JPRB, &
  & 0.16954727E-09_JPRB, 0.16953858E-09_JPRB, 0.16952069E-09_JPRB, 0.16947370E-09_JPRB /)

RGHG8(:,71, 3) = (/ &
  & 0.16920977E-09_JPRB, 0.16926710E-09_JPRB, 0.16929252E-09_JPRB, 0.16931065E-09_JPRB, 0.16932371E-09_JPRB, 0.16933313E-09_JPRB, &
  & 0.16933890E-09_JPRB, 0.16934371E-09_JPRB, 0.16934860E-09_JPRB, 0.16935169E-09_JPRB, 0.16935124E-09_JPRB, 0.16934454E-09_JPRB, &
  & 0.16932795E-09_JPRB, 0.16929855E-09_JPRB, 0.16925432E-09_JPRB, 0.16919781E-09_JPRB, 0.16913428E-09_JPRB, 0.16907396E-09_JPRB, &
  & 0.16902831E-09_JPRB, 0.16900466E-09_JPRB, 0.16900605E-09_JPRB, 0.16902940E-09_JPRB, 0.16906944E-09_JPRB, 0.16911822E-09_JPRB, &
  & 0.16916725E-09_JPRB, 0.16920909E-09_JPRB, 0.16923853E-09_JPRB, 0.16925371E-09_JPRB, 0.16925389E-09_JPRB, 0.16923937E-09_JPRB, &
  & 0.16921171E-09_JPRB, 0.16916910E-09_JPRB, 0.16911231E-09_JPRB, 0.16904808E-09_JPRB, 0.16898791E-09_JPRB, 0.16893931E-09_JPRB, &
  & 0.16890507E-09_JPRB, 0.16888661E-09_JPRB, 0.16888674E-09_JPRB, 0.16890842E-09_JPRB, 0.16895374E-09_JPRB, 0.16902241E-09_JPRB, &
  & 0.16910823E-09_JPRB, 0.16920393E-09_JPRB, 0.16929828E-09_JPRB, 0.16938398E-09_JPRB, 0.16945573E-09_JPRB, 0.16951157E-09_JPRB, &
  & 0.16955271E-09_JPRB, 0.16958054E-09_JPRB, 0.16959731E-09_JPRB, 0.16960643E-09_JPRB, 0.16961087E-09_JPRB, 0.16961221E-09_JPRB, &
  & 0.16961199E-09_JPRB, 0.16961056E-09_JPRB, 0.16960817E-09_JPRB, 0.16960620E-09_JPRB, 0.16960466E-09_JPRB, 0.16960214E-09_JPRB, &
  & 0.16959775E-09_JPRB, 0.16958923E-09_JPRB, 0.16957083E-09_JPRB, 0.16952192E-09_JPRB /)

RGHG8(:,72, 3) = (/ &
  & 0.16927804E-09_JPRB, 0.16934520E-09_JPRB, 0.16937568E-09_JPRB, 0.16939575E-09_JPRB, 0.16941018E-09_JPRB, 0.16942014E-09_JPRB, &
  & 0.16942661E-09_JPRB, 0.16943172E-09_JPRB, 0.16943665E-09_JPRB, 0.16943957E-09_JPRB, 0.16943873E-09_JPRB, 0.16943209E-09_JPRB, &
  & 0.16941641E-09_JPRB, 0.16938932E-09_JPRB, 0.16934920E-09_JPRB, 0.16929803E-09_JPRB, 0.16924126E-09_JPRB, 0.16918651E-09_JPRB, &
  & 0.16914498E-09_JPRB, 0.16912255E-09_JPRB, 0.16912231E-09_JPRB, 0.16914126E-09_JPRB, 0.16917520E-09_JPRB, 0.16921706E-09_JPRB, &
  & 0.16925919E-09_JPRB, 0.16929523E-09_JPRB, 0.16932029E-09_JPRB, 0.16933277E-09_JPRB, 0.16933230E-09_JPRB, 0.16931899E-09_JPRB, &
  & 0.16929459E-09_JPRB, 0.16925693E-09_JPRB, 0.16920611E-09_JPRB, 0.16914850E-09_JPRB, 0.16909449E-09_JPRB, 0.16905109E-09_JPRB, &
  & 0.16902070E-09_JPRB, 0.16900466E-09_JPRB, 0.16900568E-09_JPRB, 0.16902628E-09_JPRB, 0.16906833E-09_JPRB, 0.16913070E-09_JPRB, &
  & 0.16920920E-09_JPRB, 0.16929420E-09_JPRB, 0.16937951E-09_JPRB, 0.16945574E-09_JPRB, 0.16951938E-09_JPRB, 0.16956962E-09_JPRB, &
  & 0.16960629E-09_JPRB, 0.16963174E-09_JPRB, 0.16964703E-09_JPRB, 0.16965555E-09_JPRB, 0.16965986E-09_JPRB, 0.16966124E-09_JPRB, &
  & 0.16966131E-09_JPRB, 0.16966036E-09_JPRB, 0.16965850E-09_JPRB, 0.16965701E-09_JPRB, 0.16965582E-09_JPRB, 0.16965365E-09_JPRB, &
  & 0.16964963E-09_JPRB, 0.16964151E-09_JPRB, 0.16962362E-09_JPRB, 0.16957487E-09_JPRB /)

RGHG8(:,73, 3) = (/ &
  & 0.16935982E-09_JPRB, 0.16943173E-09_JPRB, 0.16946318E-09_JPRB, 0.16948358E-09_JPRB, 0.16949793E-09_JPRB, 0.16950798E-09_JPRB, &
  & 0.16951446E-09_JPRB, 0.16951963E-09_JPRB, 0.16952449E-09_JPRB, 0.16952686E-09_JPRB, 0.16952577E-09_JPRB, 0.16951927E-09_JPRB, &
  & 0.16950470E-09_JPRB, 0.16947981E-09_JPRB, 0.16944365E-09_JPRB, 0.16939812E-09_JPRB, 0.16934761E-09_JPRB, 0.16929914E-09_JPRB, &
  & 0.16926190E-09_JPRB, 0.16924107E-09_JPRB, 0.16923937E-09_JPRB, 0.16925410E-09_JPRB, 0.16928188E-09_JPRB, 0.16931709E-09_JPRB, &
  & 0.16935256E-09_JPRB, 0.16938281E-09_JPRB, 0.16940370E-09_JPRB, 0.16941375E-09_JPRB, 0.16941280E-09_JPRB, 0.16940091E-09_JPRB, &
  & 0.16937987E-09_JPRB, 0.16934724E-09_JPRB, 0.16930285E-09_JPRB, 0.16925238E-09_JPRB, 0.16920505E-09_JPRB, 0.16916737E-09_JPRB, &
  & 0.16914112E-09_JPRB, 0.16912756E-09_JPRB, 0.16912939E-09_JPRB, 0.16914878E-09_JPRB, 0.16918669E-09_JPRB, 0.16924299E-09_JPRB, &
  & 0.16931159E-09_JPRB, 0.16938723E-09_JPRB, 0.16946128E-09_JPRB, 0.16952793E-09_JPRB, 0.16958407E-09_JPRB, 0.16962735E-09_JPRB, &
  & 0.16966030E-09_JPRB, 0.16968264E-09_JPRB, 0.16969659E-09_JPRB, 0.16970453E-09_JPRB, 0.16970864E-09_JPRB, 0.16971013E-09_JPRB, &
  & 0.16971054E-09_JPRB, 0.16971011E-09_JPRB, 0.16970887E-09_JPRB, 0.16970776E-09_JPRB, 0.16970694E-09_JPRB, 0.16970511E-09_JPRB, &
  & 0.16970152E-09_JPRB, 0.16969402E-09_JPRB, 0.16967722E-09_JPRB, 0.16963027E-09_JPRB /)

RGHG8(:,74, 3) = (/ &
  & 0.16944582E-09_JPRB, 0.16952098E-09_JPRB, 0.16955189E-09_JPRB, 0.16957155E-09_JPRB, 0.16958483E-09_JPRB, 0.16959414E-09_JPRB, &
  & 0.16960050E-09_JPRB, 0.16960534E-09_JPRB, 0.16960980E-09_JPRB, 0.16961198E-09_JPRB, 0.16961074E-09_JPRB, 0.16960454E-09_JPRB, &
  & 0.16959126E-09_JPRB, 0.16956896E-09_JPRB, 0.16953670E-09_JPRB, 0.16949653E-09_JPRB, 0.16945309E-09_JPRB, 0.16941064E-09_JPRB, &
  & 0.16937829E-09_JPRB, 0.16935933E-09_JPRB, 0.16935649E-09_JPRB, 0.16936731E-09_JPRB, 0.16938932E-09_JPRB, 0.16941805E-09_JPRB, &
  & 0.16944691E-09_JPRB, 0.16947173E-09_JPRB, 0.16948866E-09_JPRB, 0.16949651E-09_JPRB, 0.16949524E-09_JPRB, 0.16948484E-09_JPRB, &
  & 0.16946716E-09_JPRB, 0.16943978E-09_JPRB, 0.16940209E-09_JPRB, 0.16935903E-09_JPRB, 0.16931903E-09_JPRB, 0.16928715E-09_JPRB, &
  & 0.16926532E-09_JPRB, 0.16925432E-09_JPRB, 0.16925678E-09_JPRB, 0.16927444E-09_JPRB, 0.16930818E-09_JPRB, 0.16935683E-09_JPRB, &
  & 0.16941648E-09_JPRB, 0.16948024E-09_JPRB, 0.16954363E-09_JPRB, 0.16960058E-09_JPRB, 0.16964792E-09_JPRB, 0.16968561E-09_JPRB, &
  & 0.16971334E-09_JPRB, 0.16973324E-09_JPRB, 0.16974541E-09_JPRB, 0.16975271E-09_JPRB, 0.16975672E-09_JPRB, 0.16975814E-09_JPRB, &
  & 0.16975885E-09_JPRB, 0.16975893E-09_JPRB, 0.16975824E-09_JPRB, 0.16975744E-09_JPRB, 0.16975686E-09_JPRB, 0.16975540E-09_JPRB, &
  & 0.16975238E-09_JPRB, 0.16974561E-09_JPRB, 0.16973017E-09_JPRB, 0.16968606E-09_JPRB /)

RGHG8(:,75, 3) = (/ &
  & 0.16953504E-09_JPRB, 0.16960980E-09_JPRB, 0.16963977E-09_JPRB, 0.16965677E-09_JPRB, 0.16966872E-09_JPRB, 0.16967698E-09_JPRB, &
  & 0.16968277E-09_JPRB, 0.16968718E-09_JPRB, 0.16969123E-09_JPRB, 0.16969313E-09_JPRB, 0.16969195E-09_JPRB, 0.16968657E-09_JPRB, &
  & 0.16967500E-09_JPRB, 0.16965523E-09_JPRB, 0.16962752E-09_JPRB, 0.16959313E-09_JPRB, 0.16955666E-09_JPRB, 0.16952090E-09_JPRB, &
  & 0.16949345E-09_JPRB, 0.16947682E-09_JPRB, 0.16947332E-09_JPRB, 0.16948072E-09_JPRB, 0.16949747E-09_JPRB, 0.16952018E-09_JPRB, &
  & 0.16954267E-09_JPRB, 0.16956221E-09_JPRB, 0.16957542E-09_JPRB, 0.16958129E-09_JPRB, 0.16957992E-09_JPRB, 0.16957104E-09_JPRB, &
  & 0.16955676E-09_JPRB, 0.16953455E-09_JPRB, 0.16950359E-09_JPRB, 0.16946833E-09_JPRB, 0.16943585E-09_JPRB, 0.16941000E-09_JPRB, &
  & 0.16939271E-09_JPRB, 0.16938410E-09_JPRB, 0.16938698E-09_JPRB, 0.16940264E-09_JPRB, 0.16943123E-09_JPRB, 0.16947252E-09_JPRB, &
  & 0.16952141E-09_JPRB, 0.16957422E-09_JPRB, 0.16962615E-09_JPRB, 0.16967264E-09_JPRB, 0.16971248E-09_JPRB, 0.16974283E-09_JPRB, &
  & 0.16976649E-09_JPRB, 0.16978281E-09_JPRB, 0.16979333E-09_JPRB, 0.16979987E-09_JPRB, 0.16980352E-09_JPRB, 0.16980477E-09_JPRB, &
  & 0.16980561E-09_JPRB, 0.16980611E-09_JPRB, 0.16980591E-09_JPRB, 0.16980532E-09_JPRB, 0.16980496E-09_JPRB, 0.16980396E-09_JPRB, &
  & 0.16980156E-09_JPRB, 0.16979566E-09_JPRB, 0.16978174E-09_JPRB, 0.16974078E-09_JPRB /)

RGHG8(:,76, 3) = (/ &
  & 0.16962534E-09_JPRB, 0.16969767E-09_JPRB, 0.16972394E-09_JPRB, 0.16973840E-09_JPRB, 0.16974819E-09_JPRB, 0.16975520E-09_JPRB, &
  & 0.16976028E-09_JPRB, 0.16976402E-09_JPRB, 0.16976759E-09_JPRB, 0.16976907E-09_JPRB, 0.16976806E-09_JPRB, 0.16976348E-09_JPRB, &
  & 0.16975406E-09_JPRB, 0.16973785E-09_JPRB, 0.16971492E-09_JPRB, 0.16968721E-09_JPRB, 0.16965832E-09_JPRB, 0.16962935E-09_JPRB, &
  & 0.16960727E-09_JPRB, 0.16959326E-09_JPRB, 0.16958976E-09_JPRB, 0.16959446E-09_JPRB, 0.16960638E-09_JPRB, 0.16962345E-09_JPRB, &
  & 0.16963972E-09_JPRB, 0.16965429E-09_JPRB, 0.16966409E-09_JPRB, 0.16966827E-09_JPRB, 0.16966693E-09_JPRB, 0.16965958E-09_JPRB, &
  & 0.16964870E-09_JPRB, 0.16963152E-09_JPRB, 0.16960738E-09_JPRB, 0.16958010E-09_JPRB, 0.16955537E-09_JPRB, 0.16953540E-09_JPRB, &
  & 0.16952255E-09_JPRB, 0.16951635E-09_JPRB, 0.16951940E-09_JPRB, 0.16953243E-09_JPRB, 0.16955563E-09_JPRB, 0.16958840E-09_JPRB, &
  & 0.16962695E-09_JPRB, 0.16966803E-09_JPRB, 0.16970857E-09_JPRB, 0.16974513E-09_JPRB, 0.16977608E-09_JPRB, 0.16980027E-09_JPRB, &
  & 0.16981856E-09_JPRB, 0.16983180E-09_JPRB, 0.16984014E-09_JPRB, 0.16984575E-09_JPRB, 0.16984891E-09_JPRB, 0.16984969E-09_JPRB, &
  & 0.16985059E-09_JPRB, 0.16985138E-09_JPRB, 0.16985161E-09_JPRB, 0.16985122E-09_JPRB, 0.16985099E-09_JPRB, 0.16985036E-09_JPRB, &
  & 0.16984872E-09_JPRB, 0.16984376E-09_JPRB, 0.16983173E-09_JPRB, 0.16979383E-09_JPRB /)

RGHG8(:,77, 3) = (/ &
  & 0.16971695E-09_JPRB, 0.16978115E-09_JPRB, 0.16980393E-09_JPRB, 0.16981437E-09_JPRB, 0.16982216E-09_JPRB, 0.16982765E-09_JPRB, &
  & 0.16983186E-09_JPRB, 0.16983480E-09_JPRB, 0.16983742E-09_JPRB, 0.16983843E-09_JPRB, 0.16983727E-09_JPRB, 0.16983376E-09_JPRB, &
  & 0.16982683E-09_JPRB, 0.16981450E-09_JPRB, 0.16979758E-09_JPRB, 0.16977689E-09_JPRB, 0.16975649E-09_JPRB, 0.16973475E-09_JPRB, &
  & 0.16971834E-09_JPRB, 0.16970751E-09_JPRB, 0.16970486E-09_JPRB, 0.16970750E-09_JPRB, 0.16971527E-09_JPRB, 0.16972732E-09_JPRB, &
  & 0.16973785E-09_JPRB, 0.16974801E-09_JPRB, 0.16975486E-09_JPRB, 0.16975757E-09_JPRB, 0.16975650E-09_JPRB, 0.16975063E-09_JPRB, &
  & 0.16974303E-09_JPRB, 0.16973063E-09_JPRB, 0.16971313E-09_JPRB, 0.16969366E-09_JPRB, 0.16967633E-09_JPRB, 0.16966215E-09_JPRB, &
  & 0.16965343E-09_JPRB, 0.16964943E-09_JPRB, 0.16965226E-09_JPRB, 0.16966231E-09_JPRB, 0.16967930E-09_JPRB, 0.16970328E-09_JPRB, &
  & 0.16973081E-09_JPRB, 0.16976055E-09_JPRB, 0.16978997E-09_JPRB, 0.16981597E-09_JPRB, 0.16983911E-09_JPRB, 0.16985613E-09_JPRB, &
  & 0.16986977E-09_JPRB, 0.16987931E-09_JPRB, 0.16988547E-09_JPRB, 0.16988999E-09_JPRB, 0.16989254E-09_JPRB, 0.16989253E-09_JPRB, &
  & 0.16989329E-09_JPRB, 0.16989429E-09_JPRB, 0.16989492E-09_JPRB, 0.16989450E-09_JPRB, 0.16989431E-09_JPRB, 0.16989407E-09_JPRB, &
  & 0.16989324E-09_JPRB, 0.16988927E-09_JPRB, 0.16987925E-09_JPRB, 0.16984568E-09_JPRB /)

RGHG8(:,78, 3) = (/ &
  & 0.16980720E-09_JPRB, 0.16985738E-09_JPRB, 0.16987338E-09_JPRB, 0.16987999E-09_JPRB, 0.16988554E-09_JPRB, 0.16988966E-09_JPRB, &
  & 0.16989300E-09_JPRB, 0.16989481E-09_JPRB, 0.16989649E-09_JPRB, 0.16989664E-09_JPRB, 0.16989524E-09_JPRB, 0.16989272E-09_JPRB, &
  & 0.16988849E-09_JPRB, 0.16988044E-09_JPRB, 0.16986958E-09_JPRB, 0.16985649E-09_JPRB, 0.16984432E-09_JPRB, 0.16983011E-09_JPRB, &
  & 0.16981969E-09_JPRB, 0.16981259E-09_JPRB, 0.16981162E-09_JPRB, 0.16981323E-09_JPRB, 0.16981783E-09_JPRB, 0.16982581E-09_JPRB, &
  & 0.16983157E-09_JPRB, 0.16983806E-09_JPRB, 0.16984261E-09_JPRB, 0.16984437E-09_JPRB, 0.16984360E-09_JPRB, 0.16983918E-09_JPRB, &
  & 0.16983455E-09_JPRB, 0.16982636E-09_JPRB, 0.16981502E-09_JPRB, 0.16980278E-09_JPRB, 0.16979217E-09_JPRB, 0.16978288E-09_JPRB, &
  & 0.16977758E-09_JPRB, 0.16977514E-09_JPRB, 0.16977730E-09_JPRB, 0.16978383E-09_JPRB, 0.16979421E-09_JPRB, 0.16980921E-09_JPRB, &
  & 0.16982613E-09_JPRB, 0.16984533E-09_JPRB, 0.16986421E-09_JPRB, 0.16988097E-09_JPRB, 0.16989643E-09_JPRB, 0.16990727E-09_JPRB, &
  & 0.16991619E-09_JPRB, 0.16992241E-09_JPRB, 0.16992641E-09_JPRB, 0.16992981E-09_JPRB, 0.16993158E-09_JPRB, 0.16993054E-09_JPRB, &
  & 0.16993106E-09_JPRB, 0.16993205E-09_JPRB, 0.16993291E-09_JPRB, 0.16993228E-09_JPRB, 0.16993194E-09_JPRB, 0.16993203E-09_JPRB, &
  & 0.16993192E-09_JPRB, 0.16992890E-09_JPRB, 0.16992235E-09_JPRB, 0.16989586E-09_JPRB /)

RGHG8(:,79, 3) = (/ &
  & 0.16986573E-09_JPRB, 0.16989972E-09_JPRB, 0.16991052E-09_JPRB, 0.16991369E-09_JPRB, 0.16991823E-09_JPRB, 0.16992158E-09_JPRB, &
  & 0.16992446E-09_JPRB, 0.16992567E-09_JPRB, 0.16992666E-09_JPRB, 0.16992648E-09_JPRB, 0.16992514E-09_JPRB, 0.16992319E-09_JPRB, &
  & 0.16992058E-09_JPRB, 0.16991464E-09_JPRB, 0.16990695E-09_JPRB, 0.16989780E-09_JPRB, 0.16989035E-09_JPRB, 0.16988003E-09_JPRB, &
  & 0.16987294E-09_JPRB, 0.16986798E-09_JPRB, 0.16986830E-09_JPRB, 0.16986951E-09_JPRB, 0.16987257E-09_JPRB, 0.16987863E-09_JPRB, &
  & 0.16988178E-09_JPRB, 0.16988645E-09_JPRB, 0.16988999E-09_JPRB, 0.16989131E-09_JPRB, 0.16989084E-09_JPRB, 0.16988716E-09_JPRB, &
  & 0.16988426E-09_JPRB, 0.16987828E-09_JPRB, 0.16987026E-09_JPRB, 0.16986194E-09_JPRB, 0.16985498E-09_JPRB, 0.16984820E-09_JPRB, &
  & 0.16984462E-09_JPRB, 0.16984285E-09_JPRB, 0.16984449E-09_JPRB, 0.16984875E-09_JPRB, 0.16985528E-09_JPRB, 0.16986519E-09_JPRB, &
  & 0.16987642E-09_JPRB, 0.16988999E-09_JPRB, 0.16990349E-09_JPRB, 0.16991505E-09_JPRB, 0.16992678E-09_JPRB, 0.16993401E-09_JPRB, &
  & 0.16994063E-09_JPRB, 0.16994506E-09_JPRB, 0.16994788E-09_JPRB, 0.16995072E-09_JPRB, 0.16995209E-09_JPRB, 0.16995021E-09_JPRB, &
  & 0.16995053E-09_JPRB, 0.16995148E-09_JPRB, 0.16995257E-09_JPRB, 0.16995172E-09_JPRB, 0.16995122E-09_JPRB, 0.16995146E-09_JPRB, &
  & 0.16995187E-09_JPRB, 0.16994989E-09_JPRB, 0.16994632E-09_JPRB, 0.16992818E-09_JPRB /)

RGHG8(:,80, 3) = (/ &
  & 0.16990458E-09_JPRB, 0.16992016E-09_JPRB, 0.16992671E-09_JPRB, 0.16992818E-09_JPRB, 0.16993215E-09_JPRB, 0.16993520E-09_JPRB, &
  & 0.16993799E-09_JPRB, 0.16993881E-09_JPRB, 0.16993981E-09_JPRB, 0.16993965E-09_JPRB, 0.16993830E-09_JPRB, 0.16993688E-09_JPRB, &
  & 0.16993494E-09_JPRB, 0.16992997E-09_JPRB, 0.16992356E-09_JPRB, 0.16991603E-09_JPRB, 0.16991082E-09_JPRB, 0.16990211E-09_JPRB, &
  & 0.16989660E-09_JPRB, 0.16989254E-09_JPRB, 0.16989361E-09_JPRB, 0.16989468E-09_JPRB, 0.16989711E-09_JPRB, 0.16990234E-09_JPRB, &
  & 0.16990437E-09_JPRB, 0.16990827E-09_JPRB, 0.16991146E-09_JPRB, 0.16991268E-09_JPRB, 0.16991239E-09_JPRB, 0.16990898E-09_JPRB, &
  & 0.16990689E-09_JPRB, 0.16990193E-09_JPRB, 0.16989542E-09_JPRB, 0.16988895E-09_JPRB, 0.16988363E-09_JPRB, 0.16987792E-09_JPRB, &
  & 0.16987503E-09_JPRB, 0.16987350E-09_JPRB, 0.16987478E-09_JPRB, 0.16987804E-09_JPRB, 0.16988269E-09_JPRB, 0.16989031E-09_JPRB, &
  & 0.16989879E-09_JPRB, 0.16990995E-09_JPRB, 0.16992099E-09_JPRB, 0.16993029E-09_JPRB, 0.16994028E-09_JPRB, 0.16994586E-09_JPRB, &
  & 0.16995139E-09_JPRB, 0.16995498E-09_JPRB, 0.16995721E-09_JPRB, 0.16995988E-09_JPRB, 0.16996106E-09_JPRB, 0.16995860E-09_JPRB, &
  & 0.16995880E-09_JPRB, 0.16995977E-09_JPRB, 0.16996100E-09_JPRB, 0.16995999E-09_JPRB, 0.16995938E-09_JPRB, 0.16995973E-09_JPRB, &
  & 0.16996052E-09_JPRB, 0.16995896E-09_JPRB, 0.16995792E-09_JPRB, 0.16994947E-09_JPRB /)

RGHG8(:,81, 3) = (/ &
  & 0.16993137E-09_JPRB, 0.16992872E-09_JPRB, 0.16993354E-09_JPRB, 0.16993421E-09_JPRB, 0.16993805E-09_JPRB, 0.16994105E-09_JPRB, &
  & 0.16994371E-09_JPRB, 0.16994466E-09_JPRB, 0.16994542E-09_JPRB, 0.16994528E-09_JPRB, 0.16994428E-09_JPRB, 0.16994287E-09_JPRB, &
  & 0.16994145E-09_JPRB, 0.16993673E-09_JPRB, 0.16993086E-09_JPRB, 0.16992401E-09_JPRB, 0.16991979E-09_JPRB, 0.16991181E-09_JPRB, &
  & 0.16990688E-09_JPRB, 0.16990327E-09_JPRB, 0.16990470E-09_JPRB, 0.16990571E-09_JPRB, 0.16990782E-09_JPRB, 0.16991278E-09_JPRB, &
  & 0.16991421E-09_JPRB, 0.16991787E-09_JPRB, 0.16992094E-09_JPRB, 0.16992216E-09_JPRB, 0.16992199E-09_JPRB, 0.16991865E-09_JPRB, &
  & 0.16991697E-09_JPRB, 0.16991239E-09_JPRB, 0.16990655E-09_JPRB, 0.16990087E-09_JPRB, 0.16989631E-09_JPRB, 0.16989105E-09_JPRB, &
  & 0.16988848E-09_JPRB, 0.16988705E-09_JPRB, 0.16988820E-09_JPRB, 0.16989099E-09_JPRB, 0.16989481E-09_JPRB, 0.16990133E-09_JPRB, &
  & 0.16990864E-09_JPRB, 0.16991877E-09_JPRB, 0.16992877E-09_JPRB, 0.16993695E-09_JPRB, 0.16994629E-09_JPRB, 0.16995103E-09_JPRB, &
  & 0.16995604E-09_JPRB, 0.16995927E-09_JPRB, 0.16996128E-09_JPRB, 0.16996385E-09_JPRB, 0.16996492E-09_JPRB, 0.16996214E-09_JPRB, &
  & 0.16996227E-09_JPRB, 0.16996328E-09_JPRB, 0.16996460E-09_JPRB, 0.16996350E-09_JPRB, 0.16996281E-09_JPRB, 0.16996321E-09_JPRB, &
  & 0.16996414E-09_JPRB, 0.16996284E-09_JPRB, 0.16996279E-09_JPRB, 0.16996403E-09_JPRB /)

RGHG8(:,82, 3) = (/ &
  & 0.16993351E-09_JPRB, 0.16993155E-09_JPRB, 0.16993655E-09_JPRB, 0.16993708E-09_JPRB, 0.16994092E-09_JPRB, 0.16994373E-09_JPRB, &
  & 0.16994661E-09_JPRB, 0.16994722E-09_JPRB, 0.16994831E-09_JPRB, 0.16994826E-09_JPRB, 0.16994697E-09_JPRB, 0.16994602E-09_JPRB, &
  & 0.16994456E-09_JPRB, 0.16994012E-09_JPRB, 0.16993444E-09_JPRB, 0.16992791E-09_JPRB, 0.16992428E-09_JPRB, 0.16991650E-09_JPRB, &
  & 0.16991196E-09_JPRB, 0.16990849E-09_JPRB, 0.16991018E-09_JPRB, 0.16991109E-09_JPRB, 0.16991304E-09_JPRB, 0.16991784E-09_JPRB, &
  & 0.16991897E-09_JPRB, 0.16992253E-09_JPRB, 0.16992556E-09_JPRB, 0.16992681E-09_JPRB, 0.16992664E-09_JPRB, 0.16992335E-09_JPRB, &
  & 0.16992191E-09_JPRB, 0.16991746E-09_JPRB, 0.16991192E-09_JPRB, 0.16990670E-09_JPRB, 0.16990249E-09_JPRB, 0.16989748E-09_JPRB, &
  & 0.16989507E-09_JPRB, 0.16989377E-09_JPRB, 0.16989479E-09_JPRB, 0.16989736E-09_JPRB, 0.16990073E-09_JPRB, 0.16990676E-09_JPRB, &
  & 0.16991343E-09_JPRB, 0.16992310E-09_JPRB, 0.16993260E-09_JPRB, 0.16994028E-09_JPRB, 0.16994925E-09_JPRB, 0.16995355E-09_JPRB, &
  & 0.16995833E-09_JPRB, 0.16996136E-09_JPRB, 0.16996324E-09_JPRB, 0.16996576E-09_JPRB, 0.16996683E-09_JPRB, 0.16996382E-09_JPRB, &
  & 0.16996390E-09_JPRB, 0.16996497E-09_JPRB, 0.16996633E-09_JPRB, 0.16996515E-09_JPRB, 0.16996442E-09_JPRB, 0.16996485E-09_JPRB, &
  & 0.16996587E-09_JPRB, 0.16996451E-09_JPRB, 0.16996445E-09_JPRB, 0.16996519E-09_JPRB /)

RGHG8(:,83, 3) = (/ &
  & 0.16993501E-09_JPRB, 0.16993318E-09_JPRB, 0.16993823E-09_JPRB, 0.16993860E-09_JPRB, 0.16994246E-09_JPRB, 0.16994553E-09_JPRB, &
  & 0.16994797E-09_JPRB, 0.16994900E-09_JPRB, 0.16994967E-09_JPRB, 0.16994961E-09_JPRB, 0.16994886E-09_JPRB, 0.16994758E-09_JPRB, &
  & 0.16994646E-09_JPRB, 0.16994198E-09_JPRB, 0.16993645E-09_JPRB, 0.16993007E-09_JPRB, 0.16992673E-09_JPRB, 0.16991920E-09_JPRB, &
  & 0.16991476E-09_JPRB, 0.16991140E-09_JPRB, 0.16991326E-09_JPRB, 0.16991411E-09_JPRB, 0.16991594E-09_JPRB, 0.16992074E-09_JPRB, &
  & 0.16992163E-09_JPRB, 0.16992513E-09_JPRB, 0.16992818E-09_JPRB, 0.16992943E-09_JPRB, 0.16992929E-09_JPRB, 0.16992596E-09_JPRB, &
  & 0.16992467E-09_JPRB, 0.16992029E-09_JPRB, 0.16991490E-09_JPRB, 0.16990989E-09_JPRB, 0.16990592E-09_JPRB, 0.16990113E-09_JPRB, &
  & 0.16989879E-09_JPRB, 0.16989757E-09_JPRB, 0.16989858E-09_JPRB, 0.16990095E-09_JPRB, 0.16990415E-09_JPRB, 0.16990966E-09_JPRB, &
  & 0.16991605E-09_JPRB, 0.16992552E-09_JPRB, 0.16993480E-09_JPRB, 0.16994212E-09_JPRB, 0.16995103E-09_JPRB, 0.16995497E-09_JPRB, &
  & 0.16995959E-09_JPRB, 0.16996252E-09_JPRB, 0.16996429E-09_JPRB, 0.16996685E-09_JPRB, 0.16996789E-09_JPRB, 0.16996468E-09_JPRB, &
  & 0.16996475E-09_JPRB, 0.16996589E-09_JPRB, 0.16996730E-09_JPRB, 0.16996606E-09_JPRB, 0.16996529E-09_JPRB, 0.16996579E-09_JPRB, &
  & 0.16996687E-09_JPRB, 0.16996546E-09_JPRB, 0.16996540E-09_JPRB, 0.16996603E-09_JPRB /)

RGHG8(:,84, 3) = (/ &
  & 0.16993602E-09_JPRB, 0.16993418E-09_JPRB, 0.16993927E-09_JPRB, 0.16993956E-09_JPRB, 0.16994348E-09_JPRB, 0.16994622E-09_JPRB, &
  & 0.16994919E-09_JPRB, 0.16994971E-09_JPRB, 0.16995076E-09_JPRB, 0.16995073E-09_JPRB, 0.16994958E-09_JPRB, 0.16994879E-09_JPRB, &
  & 0.16994745E-09_JPRB, 0.16994328E-09_JPRB, 0.16993781E-09_JPRB, 0.16993147E-09_JPRB, 0.16992835E-09_JPRB, 0.16992079E-09_JPRB, &
  & 0.16991655E-09_JPRB, 0.16991319E-09_JPRB, 0.16991514E-09_JPRB, 0.16991596E-09_JPRB, 0.16991775E-09_JPRB, 0.16992252E-09_JPRB, &
  & 0.16992324E-09_JPRB, 0.16992675E-09_JPRB, 0.16992981E-09_JPRB, 0.16993108E-09_JPRB, 0.16993094E-09_JPRB, 0.16992760E-09_JPRB, &
  & 0.16992635E-09_JPRB, 0.16992201E-09_JPRB, 0.16991668E-09_JPRB, 0.16991188E-09_JPRB, 0.16990796E-09_JPRB, 0.16990345E-09_JPRB, &
  & 0.16990115E-09_JPRB, 0.16990000E-09_JPRB, 0.16990094E-09_JPRB, 0.16990329E-09_JPRB, 0.16990614E-09_JPRB, 0.16991157E-09_JPRB, &
  & 0.16991759E-09_JPRB, 0.16992688E-09_JPRB, 0.16993615E-09_JPRB, 0.16994334E-09_JPRB, 0.16995209E-09_JPRB, 0.16995584E-09_JPRB, &
  & 0.16996034E-09_JPRB, 0.16996325E-09_JPRB, 0.16996496E-09_JPRB, 0.16996751E-09_JPRB, 0.16996855E-09_JPRB, 0.16996521E-09_JPRB, &
  & 0.16996525E-09_JPRB, 0.16996642E-09_JPRB, 0.16996791E-09_JPRB, 0.16996662E-09_JPRB, 0.16996585E-09_JPRB, 0.16996635E-09_JPRB, &
  & 0.16996747E-09_JPRB, 0.16996606E-09_JPRB, 0.16996604E-09_JPRB, 0.16996658E-09_JPRB /)

RGHG8(:,85, 3) = (/ &
  & 0.16993669E-09_JPRB, 0.16993487E-09_JPRB, 0.16993992E-09_JPRB, 0.16994016E-09_JPRB, 0.16994404E-09_JPRB, 0.16994733E-09_JPRB, &
  & 0.16994947E-09_JPRB, 0.16995054E-09_JPRB, 0.16995104E-09_JPRB, 0.16995097E-09_JPRB, 0.16995033E-09_JPRB, 0.16994922E-09_JPRB, &
  & 0.16994797E-09_JPRB, 0.16994400E-09_JPRB, 0.16993877E-09_JPRB, 0.16993258E-09_JPRB, 0.16992936E-09_JPRB, 0.16992199E-09_JPRB, &
  & 0.16991772E-09_JPRB, 0.16991433E-09_JPRB, 0.16991639E-09_JPRB, 0.16991716E-09_JPRB, 0.16991883E-09_JPRB, 0.16992370E-09_JPRB, &
  & 0.16992421E-09_JPRB, 0.16992774E-09_JPRB, 0.16993082E-09_JPRB, 0.16993212E-09_JPRB, 0.16993201E-09_JPRB, 0.16992860E-09_JPRB, &
  & 0.16992743E-09_JPRB, 0.16992309E-09_JPRB, 0.16991786E-09_JPRB, 0.16991308E-09_JPRB, 0.16990939E-09_JPRB, 0.16990490E-09_JPRB, &
  & 0.16990268E-09_JPRB, 0.16990158E-09_JPRB, 0.16990258E-09_JPRB, 0.16990470E-09_JPRB, 0.16990773E-09_JPRB, 0.16991260E-09_JPRB, &
  & 0.16991861E-09_JPRB, 0.16992788E-09_JPRB, 0.16993695E-09_JPRB, 0.16994404E-09_JPRB, 0.16995283E-09_JPRB, 0.16995638E-09_JPRB, &
  & 0.16996082E-09_JPRB, 0.16996368E-09_JPRB, 0.16996536E-09_JPRB, 0.16996797E-09_JPRB, 0.16996900E-09_JPRB, 0.16996554E-09_JPRB, &
  & 0.16996556E-09_JPRB, 0.16996675E-09_JPRB, 0.16996825E-09_JPRB, 0.16996698E-09_JPRB, 0.16996617E-09_JPRB, 0.16996669E-09_JPRB, &
  & 0.16996789E-09_JPRB, 0.16996644E-09_JPRB, 0.16996646E-09_JPRB, 0.16996697E-09_JPRB /)

RGHG8(:,86, 3) = (/ &
  & 0.16993712E-09_JPRB, 0.16993522E-09_JPRB, 0.16994038E-09_JPRB, 0.16994052E-09_JPRB, 0.16994472E-09_JPRB, 0.16994733E-09_JPRB, &
  & 0.16995022E-09_JPRB, 0.16995069E-09_JPRB, 0.16995130E-09_JPRB, 0.16995119E-09_JPRB, 0.16995036E-09_JPRB, 0.16994944E-09_JPRB, &
  & 0.16994794E-09_JPRB, 0.16994448E-09_JPRB, 0.16993952E-09_JPRB, 0.16993364E-09_JPRB, 0.16993014E-09_JPRB, 0.16992283E-09_JPRB, &
  & 0.16991858E-09_JPRB, 0.16991507E-09_JPRB, 0.16991715E-09_JPRB, 0.16991787E-09_JPRB, 0.16991952E-09_JPRB, 0.16992448E-09_JPRB, &
  & 0.16992482E-09_JPRB, 0.16992835E-09_JPRB, 0.16993150E-09_JPRB, 0.16993280E-09_JPRB, 0.16993271E-09_JPRB, 0.16992925E-09_JPRB, &
  & 0.16992811E-09_JPRB, 0.16992377E-09_JPRB, 0.16991855E-09_JPRB, 0.16991394E-09_JPRB, 0.16991014E-09_JPRB, 0.16990588E-09_JPRB, &
  & 0.16990358E-09_JPRB, 0.16990251E-09_JPRB, 0.16990345E-09_JPRB, 0.16990578E-09_JPRB, 0.16990839E-09_JPRB, 0.16991357E-09_JPRB, &
  & 0.16991930E-09_JPRB, 0.16992839E-09_JPRB, 0.16993765E-09_JPRB, 0.16994450E-09_JPRB, 0.16995333E-09_JPRB, 0.16995674E-09_JPRB, &
  & 0.16996111E-09_JPRB, 0.16996396E-09_JPRB, 0.16996562E-09_JPRB, 0.16996826E-09_JPRB, 0.16996930E-09_JPRB, 0.16996574E-09_JPRB, &
  & 0.16996572E-09_JPRB, 0.16996697E-09_JPRB, 0.16996853E-09_JPRB, 0.16996721E-09_JPRB, 0.16996637E-09_JPRB, 0.16996692E-09_JPRB, &
  & 0.16996812E-09_JPRB, 0.16996671E-09_JPRB, 0.16996669E-09_JPRB, 0.16996721E-09_JPRB /)

RGHG8(:,87, 3) = (/ &
  & 0.16993737E-09_JPRB, 0.16993548E-09_JPRB, 0.16994063E-09_JPRB, 0.16994092E-09_JPRB, 0.16994475E-09_JPRB, 0.16994835E-09_JPRB, &
  & 0.16995003E-09_JPRB, 0.16995087E-09_JPRB, 0.16995119E-09_JPRB, 0.16995100E-09_JPRB, 0.16995033E-09_JPRB, 0.16994930E-09_JPRB, &
  & 0.16994786E-09_JPRB, 0.16994464E-09_JPRB, 0.16994006E-09_JPRB, 0.16993443E-09_JPRB, 0.16993071E-09_JPRB, 0.16992355E-09_JPRB, &
  & 0.16991909E-09_JPRB, 0.16991553E-09_JPRB, 0.16991765E-09_JPRB, 0.16991840E-09_JPRB, 0.16991990E-09_JPRB, 0.16992499E-09_JPRB, &
  & 0.16992519E-09_JPRB, 0.16992877E-09_JPRB, 0.16993193E-09_JPRB, 0.16993325E-09_JPRB, 0.16993318E-09_JPRB, 0.16992967E-09_JPRB, &
  & 0.16992861E-09_JPRB, 0.16992423E-09_JPRB, 0.16991909E-09_JPRB, 0.16991440E-09_JPRB, 0.16991089E-09_JPRB, 0.16990627E-09_JPRB, &
  & 0.16990408E-09_JPRB, 0.16990291E-09_JPRB, 0.16990399E-09_JPRB, 0.16990617E-09_JPRB, 0.16990906E-09_JPRB, 0.16991389E-09_JPRB, &
  & 0.16991973E-09_JPRB, 0.16992910E-09_JPRB, 0.16993806E-09_JPRB, 0.16994492E-09_JPRB, 0.16995365E-09_JPRB, 0.16995697E-09_JPRB, &
  & 0.16996131E-09_JPRB, 0.16996413E-09_JPRB, 0.16996578E-09_JPRB, 0.16996841E-09_JPRB, 0.16996944E-09_JPRB, 0.16996581E-09_JPRB, &
  & 0.16996581E-09_JPRB, 0.16996712E-09_JPRB, 0.16996871E-09_JPRB, 0.16996732E-09_JPRB, 0.16996644E-09_JPRB, 0.16996701E-09_JPRB, &
  & 0.16996828E-09_JPRB, 0.16996685E-09_JPRB, 0.16996682E-09_JPRB, 0.16996737E-09_JPRB /)

RGHG8(:,88, 3) = (/ &
  & 0.16993751E-09_JPRB, 0.16993572E-09_JPRB, 0.16994073E-09_JPRB, 0.16994096E-09_JPRB, 0.16994539E-09_JPRB, 0.16994783E-09_JPRB, &
  & 0.16995046E-09_JPRB, 0.16995089E-09_JPRB, 0.16995128E-09_JPRB, 0.16995108E-09_JPRB, 0.16995032E-09_JPRB, 0.16994937E-09_JPRB, &
  & 0.16994789E-09_JPRB, 0.16994481E-09_JPRB, 0.16994028E-09_JPRB, 0.16993484E-09_JPRB, 0.16993099E-09_JPRB, 0.16992391E-09_JPRB, &
  & 0.16991948E-09_JPRB, 0.16991580E-09_JPRB, 0.16991794E-09_JPRB, 0.16991868E-09_JPRB, 0.16992013E-09_JPRB, 0.16992534E-09_JPRB, &
  & 0.16992535E-09_JPRB, 0.16992896E-09_JPRB, 0.16993217E-09_JPRB, 0.16993351E-09_JPRB, 0.16993350E-09_JPRB, 0.16992989E-09_JPRB, &
  & 0.16992892E-09_JPRB, 0.16992452E-09_JPRB, 0.16991940E-09_JPRB, 0.16991483E-09_JPRB, 0.16991118E-09_JPRB, 0.16990659E-09_JPRB, &
  & 0.16990424E-09_JPRB, 0.16990299E-09_JPRB, 0.16990412E-09_JPRB, 0.16990656E-09_JPRB, 0.16990905E-09_JPRB, 0.16991436E-09_JPRB, &
  & 0.16992008E-09_JPRB, 0.16992950E-09_JPRB, 0.16993860E-09_JPRB, 0.16994518E-09_JPRB, 0.16995393E-09_JPRB, 0.16995708E-09_JPRB, &
  & 0.16996139E-09_JPRB, 0.16996422E-09_JPRB, 0.16996586E-09_JPRB, 0.16996853E-09_JPRB, 0.16996955E-09_JPRB, 0.16996582E-09_JPRB, &
  & 0.16996582E-09_JPRB, 0.16996719E-09_JPRB, 0.16996882E-09_JPRB, 0.16996739E-09_JPRB, 0.16996651E-09_JPRB, 0.16996708E-09_JPRB, &
  & 0.16996837E-09_JPRB, 0.16996694E-09_JPRB, 0.16996694E-09_JPRB, 0.16996747E-09_JPRB /)

RGHG8(:,89, 3) = (/ &
  & 0.16993758E-09_JPRB, 0.16993601E-09_JPRB, 0.16994074E-09_JPRB, 0.16994113E-09_JPRB, 0.16994492E-09_JPRB, 0.16994856E-09_JPRB, &
  & 0.16995030E-09_JPRB, 0.16995114E-09_JPRB, 0.16995147E-09_JPRB, 0.16995128E-09_JPRB, 0.16995057E-09_JPRB, 0.16994957E-09_JPRB, &
  & 0.16994811E-09_JPRB, 0.16994489E-09_JPRB, 0.16994030E-09_JPRB, 0.16993468E-09_JPRB, 0.16993114E-09_JPRB, 0.16992388E-09_JPRB, &
  & 0.16991952E-09_JPRB, 0.16991586E-09_JPRB, 0.16991808E-09_JPRB, 0.16991882E-09_JPRB, 0.16992024E-09_JPRB, 0.16992555E-09_JPRB, &
  & 0.16992541E-09_JPRB, 0.16992908E-09_JPRB, 0.16993233E-09_JPRB, 0.16993369E-09_JPRB, 0.16993371E-09_JPRB, 0.16993001E-09_JPRB, &
  & 0.16992918E-09_JPRB, 0.16992474E-09_JPRB, 0.16991965E-09_JPRB, 0.16991497E-09_JPRB, 0.16991163E-09_JPRB, 0.16990651E-09_JPRB, &
  & 0.16990434E-09_JPRB, 0.16990295E-09_JPRB, 0.16990422E-09_JPRB, 0.16990660E-09_JPRB, 0.16990913E-09_JPRB, 0.16991449E-09_JPRB, &
  & 0.16992019E-09_JPRB, 0.16992996E-09_JPRB, 0.16993884E-09_JPRB, 0.16994531E-09_JPRB, 0.16995411E-09_JPRB, 0.16995716E-09_JPRB, &
  & 0.16996143E-09_JPRB, 0.16996428E-09_JPRB, 0.16996590E-09_JPRB, 0.16996857E-09_JPRB, 0.16996965E-09_JPRB, 0.16996581E-09_JPRB, &
  & 0.16996586E-09_JPRB, 0.16996729E-09_JPRB, 0.16996889E-09_JPRB, 0.16996744E-09_JPRB, 0.16996654E-09_JPRB, 0.16996710E-09_JPRB, &
  & 0.16996846E-09_JPRB, 0.16996700E-09_JPRB, 0.16996696E-09_JPRB, 0.16996753E-09_JPRB /)

RGHG8(:,90, 3) = (/ &
  & 0.16993759E-09_JPRB, 0.16993622E-09_JPRB, 0.16994062E-09_JPRB, 0.16994085E-09_JPRB, 0.16994509E-09_JPRB, 0.16994779E-09_JPRB, &
  & 0.16995078E-09_JPRB, 0.16995128E-09_JPRB, 0.16995194E-09_JPRB, 0.16995186E-09_JPRB, 0.16995100E-09_JPRB, 0.16995005E-09_JPRB, &
  & 0.16994868E-09_JPRB, 0.16994510E-09_JPRB, 0.16994003E-09_JPRB, 0.16993419E-09_JPRB, 0.16993118E-09_JPRB, 0.16992362E-09_JPRB, &
  & 0.16991945E-09_JPRB, 0.16991569E-09_JPRB, 0.16991816E-09_JPRB, 0.16991884E-09_JPRB, 0.16992016E-09_JPRB, 0.16992578E-09_JPRB, &
  & 0.16992535E-09_JPRB, 0.16992917E-09_JPRB, 0.16993242E-09_JPRB, 0.16993380E-09_JPRB, 0.16993390E-09_JPRB, 0.16992999E-09_JPRB, &
  & 0.16992938E-09_JPRB, 0.16992485E-09_JPRB, 0.16991968E-09_JPRB, 0.16991504E-09_JPRB, 0.16991179E-09_JPRB, 0.16990645E-09_JPRB, &
  & 0.16990430E-09_JPRB, 0.16990286E-09_JPRB, 0.16990417E-09_JPRB, 0.16990671E-09_JPRB, 0.16990895E-09_JPRB, 0.16991460E-09_JPRB, &
  & 0.16992020E-09_JPRB, 0.16993015E-09_JPRB, 0.16993909E-09_JPRB, 0.16994538E-09_JPRB, 0.16995433E-09_JPRB, 0.16995717E-09_JPRB, &
  & 0.16996153E-09_JPRB, 0.16996436E-09_JPRB, 0.16996593E-09_JPRB, 0.16996866E-09_JPRB, 0.16996980E-09_JPRB, 0.16996568E-09_JPRB, &
  & 0.16996582E-09_JPRB, 0.16996729E-09_JPRB, 0.16996902E-09_JPRB, 0.16996747E-09_JPRB, 0.16996650E-09_JPRB, 0.16996708E-09_JPRB, &
  & 0.16996854E-09_JPRB, 0.16996696E-09_JPRB, 0.16996701E-09_JPRB, 0.16996758E-09_JPRB /)

RGHG8(:,91, 3) = (/ &
  & 0.16993761E-09_JPRB, 0.16993634E-09_JPRB, 0.16994052E-09_JPRB, 0.16994046E-09_JPRB, 0.16994484E-09_JPRB, 0.16994772E-09_JPRB, &
  & 0.16995091E-09_JPRB, 0.16995118E-09_JPRB, 0.16995258E-09_JPRB, 0.16995286E-09_JPRB, 0.16995125E-09_JPRB, 0.16995036E-09_JPRB, &
  & 0.16994997E-09_JPRB, 0.16994516E-09_JPRB, 0.16993963E-09_JPRB, 0.16993308E-09_JPRB, 0.16993162E-09_JPRB, 0.16992305E-09_JPRB, &
  & 0.16991934E-09_JPRB, 0.16991523E-09_JPRB, 0.16991830E-09_JPRB, 0.16991883E-09_JPRB, 0.16991990E-09_JPRB, 0.16992617E-09_JPRB, &
  & 0.16992509E-09_JPRB, 0.16992920E-09_JPRB, 0.16993258E-09_JPRB, 0.16993393E-09_JPRB, 0.16993427E-09_JPRB, 0.16992975E-09_JPRB, &
  & 0.16992975E-09_JPRB, 0.16992506E-09_JPRB, 0.16991969E-09_JPRB, 0.16991482E-09_JPRB, 0.16991206E-09_JPRB, 0.16990609E-09_JPRB, &
  & 0.16990420E-09_JPRB, 0.16990268E-09_JPRB, 0.16990413E-09_JPRB, 0.16990674E-09_JPRB, 0.16990874E-09_JPRB, 0.16991462E-09_JPRB, &
  & 0.16991995E-09_JPRB, 0.16993031E-09_JPRB, 0.16993931E-09_JPRB, 0.16994522E-09_JPRB, 0.16995476E-09_JPRB, 0.16995710E-09_JPRB, &
  & 0.16996166E-09_JPRB, 0.16996446E-09_JPRB, 0.16996589E-09_JPRB, 0.16996880E-09_JPRB, 0.16997015E-09_JPRB, 0.16996540E-09_JPRB, &
  & 0.16996575E-09_JPRB, 0.16996732E-09_JPRB, 0.16996927E-09_JPRB, 0.16996743E-09_JPRB, 0.16996639E-09_JPRB, 0.16996707E-09_JPRB, &
  & 0.16996876E-09_JPRB, 0.16996685E-09_JPRB, 0.16996698E-09_JPRB, 0.16996758E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART6',1,ZHOOK_HANDLE)
END SUBROUTINE PART6






SUBROUTINE PART7
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART7',0,ZHOOK_HANDLE)



!-- Month=  4 ------------

RGHG8(:, 1, 4) = (/ &
  & 0.36931729E-10_JPRB, 0.36975527E-10_JPRB, 0.37015547E-10_JPRB, 0.37084232E-10_JPRB, 0.37151896E-10_JPRB, 0.37209416E-10_JPRB, &
  & 0.37251955E-10_JPRB, 0.37280252E-10_JPRB, 0.37297682E-10_JPRB, 0.37305666E-10_JPRB, 0.37302113E-10_JPRB, 0.37287031E-10_JPRB, &
  & 0.37264938E-10_JPRB, 0.37242230E-10_JPRB, 0.37224571E-10_JPRB, 0.37211269E-10_JPRB, 0.37199435E-10_JPRB, 0.37186122E-10_JPRB, &
  & 0.37173160E-10_JPRB, 0.37162051E-10_JPRB, 0.37155137E-10_JPRB, 0.37156903E-10_JPRB, 0.37177154E-10_JPRB, 0.37235433E-10_JPRB, &
  & 0.37421656E-10_JPRB, 0.37797303E-10_JPRB, 0.38236542E-10_JPRB, 0.38690134E-10_JPRB, 0.39148417E-10_JPRB, 0.39590938E-10_JPRB, &
  & 0.39996541E-10_JPRB, 0.40358310E-10_JPRB, 0.40688990E-10_JPRB, 0.40974495E-10_JPRB, 0.41203874E-10_JPRB, 0.41376878E-10_JPRB, &
  & 0.41483990E-10_JPRB, 0.41513203E-10_JPRB, 0.41469383E-10_JPRB, 0.41352040E-10_JPRB, 0.41248806E-10_JPRB, 0.41123813E-10_JPRB, &
  & 0.40984716E-10_JPRB, 0.40824587E-10_JPRB, 0.40639943E-10_JPRB, 0.40425618E-10_JPRB, 0.40178381E-10_JPRB, 0.39890820E-10_JPRB, &
  & 0.39550439E-10_JPRB, 0.39158319E-10_JPRB, 0.38744903E-10_JPRB, 0.38335446E-10_JPRB, 0.37946066E-10_JPRB, 0.37598948E-10_JPRB, &
  & 0.37306779E-10_JPRB, 0.37084415E-10_JPRB, 0.36925976E-10_JPRB, 0.36818406E-10_JPRB, 0.36747726E-10_JPRB, 0.36704712E-10_JPRB, &
  & 0.36670500E-10_JPRB, 0.36636957E-10_JPRB, 0.36603720E-10_JPRB, 0.36567083E-10_JPRB /)

RGHG8(:, 2, 4) = (/ &
  & 0.37084998E-10_JPRB, 0.37226874E-10_JPRB, 0.37320765E-10_JPRB, 0.37413395E-10_JPRB, 0.37489456E-10_JPRB, 0.37538292E-10_JPRB, &
  & 0.37555705E-10_JPRB, 0.37545755E-10_JPRB, 0.37518721E-10_JPRB, 0.37490316E-10_JPRB, 0.37477570E-10_JPRB, 0.37490778E-10_JPRB, &
  & 0.37525635E-10_JPRB, 0.37568622E-10_JPRB, 0.37612167E-10_JPRB, 0.37656472E-10_JPRB, 0.37703493E-10_JPRB, 0.37751621E-10_JPRB, &
  & 0.37800603E-10_JPRB, 0.37851420E-10_JPRB, 0.37908184E-10_JPRB, 0.37979876E-10_JPRB, 0.38080709E-10_JPRB, 0.38233625E-10_JPRB, &
  & 0.38471556E-10_JPRB, 0.38809369E-10_JPRB, 0.39218313E-10_JPRB, 0.39681848E-10_JPRB, 0.40195406E-10_JPRB, 0.40749862E-10_JPRB, &
  & 0.41322737E-10_JPRB, 0.41886460E-10_JPRB, 0.42422892E-10_JPRB, 0.42895191E-10_JPRB, 0.43292432E-10_JPRB, 0.43607382E-10_JPRB, &
  & 0.43836629E-10_JPRB, 0.43966320E-10_JPRB, 0.43971844E-10_JPRB, 0.43854122E-10_JPRB, 0.43657179E-10_JPRB, 0.43399850E-10_JPRB, &
  & 0.43095819E-10_JPRB, 0.42749259E-10_JPRB, 0.42357961E-10_JPRB, 0.41922986E-10_JPRB, 0.41444757E-10_JPRB, 0.40929135E-10_JPRB, &
  & 0.40384515E-10_JPRB, 0.39841960E-10_JPRB, 0.39335132E-10_JPRB, 0.38870913E-10_JPRB, 0.38444622E-10_JPRB, 0.38063785E-10_JPRB, &
  & 0.37737102E-10_JPRB, 0.37481050E-10_JPRB, 0.37291639E-10_JPRB, 0.37158186E-10_JPRB, 0.37065902E-10_JPRB, 0.37001992E-10_JPRB, &
  & 0.36953364E-10_JPRB, 0.36911911E-10_JPRB, 0.36873053E-10_JPRB, 0.36821074E-10_JPRB /)

RGHG8(:, 3, 4) = (/ &
  & 0.37207581E-10_JPRB, 0.37342327E-10_JPRB, 0.37418832E-10_JPRB, 0.37483100E-10_JPRB, 0.37536158E-10_JPRB, 0.37575467E-10_JPRB, &
  & 0.37614408E-10_JPRB, 0.37667539E-10_JPRB, 0.37740151E-10_JPRB, 0.37827214E-10_JPRB, 0.37920139E-10_JPRB, 0.38016312E-10_JPRB, &
  & 0.38119910E-10_JPRB, 0.38236976E-10_JPRB, 0.38369370E-10_JPRB, 0.38515031E-10_JPRB, 0.38672281E-10_JPRB, 0.38835789E-10_JPRB, &
  & 0.39000012E-10_JPRB, 0.39161865E-10_JPRB, 0.39323385E-10_JPRB, 0.39495431E-10_JPRB, 0.39694310E-10_JPRB, 0.39937501E-10_JPRB, &
  & 0.40243538E-10_JPRB, 0.40609370E-10_JPRB, 0.41031879E-10_JPRB, 0.41508227E-10_JPRB, 0.42050585E-10_JPRB, 0.42674312E-10_JPRB, &
  & 0.43374169E-10_JPRB, 0.44103176E-10_JPRB, 0.44784801E-10_JPRB, 0.45377736E-10_JPRB, 0.45855729E-10_JPRB, 0.46229395E-10_JPRB, &
  & 0.46500904E-10_JPRB, 0.46655398E-10_JPRB, 0.46670612E-10_JPRB, 0.46522401E-10_JPRB, 0.46218862E-10_JPRB, 0.45798025E-10_JPRB, &
  & 0.45296086E-10_JPRB, 0.44715311E-10_JPRB, 0.44071614E-10_JPRB, 0.43379442E-10_JPRB, 0.42660972E-10_JPRB, 0.41936822E-10_JPRB, &
  & 0.41228621E-10_JPRB, 0.40569766E-10_JPRB, 0.39969257E-10_JPRB, 0.39428398E-10_JPRB, 0.38952876E-10_JPRB, 0.38547283E-10_JPRB, &
  & 0.38211882E-10_JPRB, 0.37941088E-10_JPRB, 0.37734683E-10_JPRB, 0.37578191E-10_JPRB, 0.37462936E-10_JPRB, 0.37378094E-10_JPRB, &
  & 0.37312257E-10_JPRB, 0.37256743E-10_JPRB, 0.37204101E-10_JPRB, 0.37139406E-10_JPRB /)

RGHG8(:, 4, 4) = (/ &
  & 0.37254141E-10_JPRB, 0.37361631E-10_JPRB, 0.37430219E-10_JPRB, 0.37507549E-10_JPRB, 0.37599011E-10_JPRB, 0.37707549E-10_JPRB, &
  & 0.37830301E-10_JPRB, 0.37958844E-10_JPRB, 0.38094000E-10_JPRB, 0.38243849E-10_JPRB, 0.38414820E-10_JPRB, 0.38607981E-10_JPRB, &
  & 0.38822522E-10_JPRB, 0.39059450E-10_JPRB, 0.39327430E-10_JPRB, 0.39637155E-10_JPRB, 0.39994709E-10_JPRB, 0.40399586E-10_JPRB, &
  & 0.40849043E-10_JPRB, 0.41336740E-10_JPRB, 0.41857472E-10_JPRB, 0.42408743E-10_JPRB, 0.42996440E-10_JPRB, 0.43627539E-10_JPRB, &
  & 0.44289968E-10_JPRB, 0.44972064E-10_JPRB, 0.45657901E-10_JPRB, 0.46357630E-10_JPRB, 0.47067527E-10_JPRB, 0.47759512E-10_JPRB, &
  & 0.48385469E-10_JPRB, 0.48896921E-10_JPRB, 0.49284948E-10_JPRB, 0.49561695E-10_JPRB, 0.49760755E-10_JPRB, 0.49890526E-10_JPRB, &
  & 0.49948035E-10_JPRB, 0.49914774E-10_JPRB, 0.49757483E-10_JPRB, 0.49435026E-10_JPRB, 0.48914980E-10_JPRB, 0.48210613E-10_JPRB, &
  & 0.47375669E-10_JPRB, 0.46470890E-10_JPRB, 0.45524907E-10_JPRB, 0.44565206E-10_JPRB, 0.43620375E-10_JPRB, 0.42744471E-10_JPRB, &
  & 0.41955751E-10_JPRB, 0.41252529E-10_JPRB, 0.40631533E-10_JPRB, 0.40089404E-10_JPRB, 0.39617219E-10_JPRB, 0.39205722E-10_JPRB, &
  & 0.38845080E-10_JPRB, 0.38539269E-10_JPRB, 0.38287182E-10_JPRB, 0.38083436E-10_JPRB, 0.37923255E-10_JPRB, 0.37798063E-10_JPRB, &
  & 0.37701075E-10_JPRB, 0.37622176E-10_JPRB, 0.37553297E-10_JPRB, 0.37467075E-10_JPRB /)

RGHG8(:, 5, 4) = (/ &
  & 0.37224623E-10_JPRB, 0.37286174E-10_JPRB, 0.37359307E-10_JPRB, 0.37465066E-10_JPRB, 0.37604420E-10_JPRB, 0.37767237E-10_JPRB, &
  & 0.37958379E-10_JPRB, 0.38180341E-10_JPRB, 0.38428063E-10_JPRB, 0.38701174E-10_JPRB, 0.39005538E-10_JPRB, 0.39351616E-10_JPRB, &
  & 0.39747053E-10_JPRB, 0.40198480E-10_JPRB, 0.40716857E-10_JPRB, 0.41314400E-10_JPRB, 0.42001756E-10_JPRB, 0.42788446E-10_JPRB, &
  & 0.43681492E-10_JPRB, 0.44681314E-10_JPRB, 0.45776032E-10_JPRB, 0.46947626E-10_JPRB, 0.48162297E-10_JPRB, 0.49369508E-10_JPRB, &
  & 0.50513635E-10_JPRB, 0.51551138E-10_JPRB, 0.52484711E-10_JPRB, 0.53304958E-10_JPRB, 0.53997456E-10_JPRB, 0.54522914E-10_JPRB, &
  & 0.54841832E-10_JPRB, 0.54928229E-10_JPRB, 0.54822456E-10_JPRB, 0.54602919E-10_JPRB, 0.54330870E-10_JPRB, 0.54037656E-10_JPRB, &
  & 0.53719910E-10_JPRB, 0.53346900E-10_JPRB, 0.52868699E-10_JPRB, 0.52239959E-10_JPRB, 0.51425881E-10_JPRB, 0.50451476E-10_JPRB, &
  & 0.49340466E-10_JPRB, 0.48112535E-10_JPRB, 0.46866705E-10_JPRB, 0.45691857E-10_JPRB, 0.44643927E-10_JPRB, 0.43715816E-10_JPRB, &
  & 0.42914824E-10_JPRB, 0.42214957E-10_JPRB, 0.41593576E-10_JPRB, 0.41039540E-10_JPRB, 0.40540925E-10_JPRB, 0.40090951E-10_JPRB, &
  & 0.39687302E-10_JPRB, 0.39331160E-10_JPRB, 0.39023892E-10_JPRB, 0.38763152E-10_JPRB, 0.38545212E-10_JPRB, 0.38369898E-10_JPRB, &
  & 0.38231238E-10_JPRB, 0.38118727E-10_JPRB, 0.38016854E-10_JPRB, 0.37884484E-10_JPRB /)

RGHG8(:, 6, 4) = (/ &
  & 0.37111182E-10_JPRB, 0.37132790E-10_JPRB, 0.37227395E-10_JPRB, 0.37379311E-10_JPRB, 0.37585657E-10_JPRB, 0.37838677E-10_JPRB, &
  & 0.38138531E-10_JPRB, 0.38479477E-10_JPRB, 0.38862649E-10_JPRB, 0.39287976E-10_JPRB, 0.39758134E-10_JPRB, 0.40278003E-10_JPRB, &
  & 0.40855853E-10_JPRB, 0.41501559E-10_JPRB, 0.42228950E-10_JPRB, 0.43056416E-10_JPRB, 0.44005254E-10_JPRB, 0.45086837E-10_JPRB, &
  & 0.46300450E-10_JPRB, 0.47622756E-10_JPRB, 0.49026113E-10_JPRB, 0.50489789E-10_JPRB, 0.51989531E-10_JPRB, 0.53473420E-10_JPRB, &
  & 0.54859874E-10_JPRB, 0.56094886E-10_JPRB, 0.57168020E-10_JPRB, 0.58077022E-10_JPRB, 0.58805891E-10_JPRB, 0.59316767E-10_JPRB, &
  & 0.59568329E-10_JPRB, 0.59534648E-10_JPRB, 0.59252797E-10_JPRB, 0.58799687E-10_JPRB, 0.58253631E-10_JPRB, 0.57664842E-10_JPRB, &
  & 0.57041930E-10_JPRB, 0.56363580E-10_JPRB, 0.55591302E-10_JPRB, 0.54678505E-10_JPRB, 0.53592384E-10_JPRB, 0.52318355E-10_JPRB, &
  & 0.50954563E-10_JPRB, 0.49649840E-10_JPRB, 0.48463643E-10_JPRB, 0.47350974E-10_JPRB, 0.46301487E-10_JPRB, 0.45357981E-10_JPRB, &
  & 0.44532114E-10_JPRB, 0.43804849E-10_JPRB, 0.43148603E-10_JPRB, 0.42542050E-10_JPRB, 0.41975146E-10_JPRB, 0.41449320E-10_JPRB, &
  & 0.40965183E-10_JPRB, 0.40526568E-10_JPRB, 0.40136418E-10_JPRB, 0.39795341E-10_JPRB, 0.39508369E-10_JPRB, 0.39269414E-10_JPRB, &
  & 0.39083358E-10_JPRB, 0.38931049E-10_JPRB, 0.38795127E-10_JPRB, 0.38610629E-10_JPRB /)

RGHG8(:, 7, 4) = (/ &
  & 0.36973400E-10_JPRB, 0.37086386E-10_JPRB, 0.37284946E-10_JPRB, 0.37544454E-10_JPRB, 0.37861016E-10_JPRB, 0.38225905E-10_JPRB, &
  & 0.38639911E-10_JPRB, 0.39099640E-10_JPRB, 0.39600712E-10_JPRB, 0.40147646E-10_JPRB, 0.40743169E-10_JPRB, 0.41388844E-10_JPRB, &
  & 0.42084329E-10_JPRB, 0.42829774E-10_JPRB, 0.43630911E-10_JPRB, 0.44503092E-10_JPRB, 0.45467179E-10_JPRB, 0.46551218E-10_JPRB, &
  & 0.47772931E-10_JPRB, 0.49135744E-10_JPRB, 0.50616081E-10_JPRB, 0.52168832E-10_JPRB, 0.53772826E-10_JPRB, 0.55412303E-10_JPRB, &
  & 0.57009286E-10_JPRB, 0.58481671E-10_JPRB, 0.59781284E-10_JPRB, 0.60894706E-10_JPRB, 0.61787214E-10_JPRB, 0.62421499E-10_JPRB, &
  & 0.62744046E-10_JPRB, 0.62735386E-10_JPRB, 0.62424566E-10_JPRB, 0.61891284E-10_JPRB, 0.61208288E-10_JPRB, 0.60427816E-10_JPRB, &
  & 0.59581041E-10_JPRB, 0.58658599E-10_JPRB, 0.57625030E-10_JPRB, 0.56460017E-10_JPRB, 0.55182199E-10_JPRB, 0.53882503E-10_JPRB, &
  & 0.52591355E-10_JPRB, 0.51301696E-10_JPRB, 0.50041474E-10_JPRB, 0.48915025E-10_JPRB, 0.47971530E-10_JPRB, 0.47143768E-10_JPRB, &
  & 0.46375161E-10_JPRB, 0.45655636E-10_JPRB, 0.44979714E-10_JPRB, 0.44337665E-10_JPRB, 0.43721988E-10_JPRB, 0.43133955E-10_JPRB, &
  & 0.42579457E-10_JPRB, 0.42067523E-10_JPRB, 0.41604914E-10_JPRB, 0.41198708E-10_JPRB, 0.40849879E-10_JPRB, 0.40562918E-10_JPRB, &
  & 0.40338385E-10_JPRB, 0.40159907E-10_JPRB, 0.39997224E-10_JPRB, 0.39772480E-10_JPRB /)

RGHG8(:, 8, 4) = (/ &
  & 0.37007175E-10_JPRB, 0.37397505E-10_JPRB, 0.37760930E-10_JPRB, 0.38153685E-10_JPRB, 0.38596834E-10_JPRB, 0.39092021E-10_JPRB, &
  & 0.39643080E-10_JPRB, 0.40247892E-10_JPRB, 0.40902420E-10_JPRB, 0.41599703E-10_JPRB, 0.42331812E-10_JPRB, 0.43086795E-10_JPRB, &
  & 0.43854163E-10_JPRB, 0.44628006E-10_JPRB, 0.45416809E-10_JPRB, 0.46238013E-10_JPRB, 0.47122490E-10_JPRB, 0.48095063E-10_JPRB, &
  & 0.49184899E-10_JPRB, 0.50414145E-10_JPRB, 0.51807458E-10_JPRB, 0.53366082E-10_JPRB, 0.55043761E-10_JPRB, 0.56789635E-10_JPRB, &
  & 0.58587704E-10_JPRB, 0.60305518E-10_JPRB, 0.61858449E-10_JPRB, 0.63173314E-10_JPRB, 0.64215626E-10_JPRB, 0.64927577E-10_JPRB, &
  & 0.65271233E-10_JPRB, 0.65240507E-10_JPRB, 0.64883224E-10_JPRB, 0.64255254E-10_JPRB, 0.63448434E-10_JPRB, 0.62526755E-10_JPRB, &
  & 0.61498757E-10_JPRB, 0.60370146E-10_JPRB, 0.59158234E-10_JPRB, 0.57880388E-10_JPRB, 0.56528816E-10_JPRB, 0.55088878E-10_JPRB, &
  & 0.53664476E-10_JPRB, 0.52363891E-10_JPRB, 0.51245112E-10_JPRB, 0.50273355E-10_JPRB, 0.49386419E-10_JPRB, 0.48570412E-10_JPRB, &
  & 0.47827423E-10_JPRB, 0.47139584E-10_JPRB, 0.46485853E-10_JPRB, 0.45858463E-10_JPRB, 0.45255497E-10_JPRB, 0.44677304E-10_JPRB, &
  & 0.44128368E-10_JPRB, 0.43616648E-10_JPRB, 0.43149165E-10_JPRB, 0.42732703E-10_JPRB, 0.42376300E-10_JPRB, 0.42081033E-10_JPRB, &
  & 0.41859093E-10_JPRB, 0.41685249E-10_JPRB, 0.41532146E-10_JPRB, 0.41319503E-10_JPRB /)

RGHG8(:, 9, 4) = (/ &
  & 0.37435572E-10_JPRB, 0.38190194E-10_JPRB, 0.38751443E-10_JPRB, 0.39332811E-10_JPRB, 0.39975977E-10_JPRB, 0.40696713E-10_JPRB, &
  & 0.41497691E-10_JPRB, 0.42375038E-10_JPRB, 0.43318744E-10_JPRB, 0.44314753E-10_JPRB, 0.45341595E-10_JPRB, 0.46369311E-10_JPRB, &
  & 0.47362100E-10_JPRB, 0.48295937E-10_JPRB, 0.49171348E-10_JPRB, 0.50010759E-10_JPRB, 0.50847788E-10_JPRB, 0.51728268E-10_JPRB, &
  & 0.52699702E-10_JPRB, 0.53801595E-10_JPRB, 0.55064564E-10_JPRB, 0.56510616E-10_JPRB, 0.58123124E-10_JPRB, 0.59840168E-10_JPRB, &
  & 0.61552458E-10_JPRB, 0.63225508E-10_JPRB, 0.64736050E-10_JPRB, 0.66023062E-10_JPRB, 0.67014130E-10_JPRB, 0.67656353E-10_JPRB, &
  & 0.67899283E-10_JPRB, 0.67734277E-10_JPRB, 0.67200683E-10_JPRB, 0.66389214E-10_JPRB, 0.65388979E-10_JPRB, 0.64255795E-10_JPRB, &
  & 0.63050350E-10_JPRB, 0.61770353E-10_JPRB, 0.60396826E-10_JPRB, 0.58935239E-10_JPRB, 0.57453611E-10_JPRB, 0.56043316E-10_JPRB, &
  & 0.54711360E-10_JPRB, 0.53439052E-10_JPRB, 0.52249129E-10_JPRB, 0.51181760E-10_JPRB, 0.50268012E-10_JPRB, 0.49482633E-10_JPRB, &
  & 0.48775074E-10_JPRB, 0.48121333E-10_JPRB, 0.47507089E-10_JPRB, 0.46921904E-10_JPRB, 0.46364267E-10_JPRB, 0.45835592E-10_JPRB, &
  & 0.45335818E-10_JPRB, 0.44870493E-10_JPRB, 0.44445662E-10_JPRB, 0.44068561E-10_JPRB, 0.43745015E-10_JPRB, 0.43480632E-10_JPRB, &
  & 0.43289265E-10_JPRB, 0.43147298E-10_JPRB, 0.43028477E-10_JPRB, 0.42872050E-10_JPRB /)

RGHG8(:,10, 4) = (/ &
  & 0.38458396E-10_JPRB, 0.39652115E-10_JPRB, 0.40520316E-10_JPRB, 0.41384604E-10_JPRB, 0.42345977E-10_JPRB, 0.43421863E-10_JPRB, &
  & 0.44624679E-10_JPRB, 0.45948498E-10_JPRB, 0.47378101E-10_JPRB, 0.48891328E-10_JPRB, 0.50455876E-10_JPRB, 0.52023344E-10_JPRB, &
  & 0.53536467E-10_JPRB, 0.54950523E-10_JPRB, 0.56243017E-10_JPRB, 0.57413910E-10_JPRB, 0.58482635E-10_JPRB, 0.59484029E-10_JPRB, &
  & 0.60466736E-10_JPRB, 0.61476921E-10_JPRB, 0.62548786E-10_JPRB, 0.63699136E-10_JPRB, 0.64917828E-10_JPRB, 0.66163235E-10_JPRB, &
  & 0.67376132E-10_JPRB, 0.68491934E-10_JPRB, 0.69501495E-10_JPRB, 0.70334551E-10_JPRB, 0.70929373E-10_JPRB, 0.71230646E-10_JPRB, &
  & 0.71194189E-10_JPRB, 0.70800331E-10_JPRB, 0.70072573E-10_JPRB, 0.69050377E-10_JPRB, 0.67796845E-10_JPRB, 0.66393627E-10_JPRB, &
  & 0.64883245E-10_JPRB, 0.63340097E-10_JPRB, 0.61838312E-10_JPRB, 0.60389187E-10_JPRB, 0.58939950E-10_JPRB, 0.57464273E-10_JPRB, &
  & 0.56001710E-10_JPRB, 0.54617311E-10_JPRB, 0.53354834E-10_JPRB, 0.52232222E-10_JPRB, 0.51239925E-10_JPRB, 0.50362360E-10_JPRB, &
  & 0.49595713E-10_JPRB, 0.48916995E-10_JPRB, 0.48295843E-10_JPRB, 0.47722201E-10_JPRB, 0.47193062E-10_JPRB, 0.46707246E-10_JPRB, &
  & 0.46262143E-10_JPRB, 0.45858269E-10_JPRB, 0.45497259E-10_JPRB, 0.45182288E-10_JPRB, 0.44916917E-10_JPRB, 0.44703630E-10_JPRB, &
  & 0.44557219E-10_JPRB, 0.44455509E-10_JPRB, 0.44374983E-10_JPRB, 0.44274449E-10_JPRB /)

RGHG8(:,11, 4) = (/ &
  & 0.40311449E-10_JPRB, 0.42137252E-10_JPRB, 0.43375994E-10_JPRB, 0.44629876E-10_JPRB, 0.45980910E-10_JPRB, 0.47495320E-10_JPRB, &
  & 0.49180222E-10_JPRB, 0.51033153E-10_JPRB, 0.53036377E-10_JPRB, 0.55163134E-10_JPRB, 0.57379684E-10_JPRB, 0.59629475E-10_JPRB, &
  & 0.61841358E-10_JPRB, 0.63941012E-10_JPRB, 0.65884832E-10_JPRB, 0.67650913E-10_JPRB, 0.69228567E-10_JPRB, 0.70619732E-10_JPRB, &
  & 0.71816532E-10_JPRB, 0.72833468E-10_JPRB, 0.73688222E-10_JPRB, 0.74398321E-10_JPRB, 0.74987613E-10_JPRB, 0.75460971E-10_JPRB, &
  & 0.75821779E-10_JPRB, 0.76079185E-10_JPRB, 0.76245274E-10_JPRB, 0.76332260E-10_JPRB, 0.76312227E-10_JPRB, 0.76115218E-10_JPRB, &
  & 0.75672080E-10_JPRB, 0.74965464E-10_JPRB, 0.73983326E-10_JPRB, 0.72735450E-10_JPRB, 0.71295844E-10_JPRB, 0.69711695E-10_JPRB, &
  & 0.68055991E-10_JPRB, 0.66377813E-10_JPRB, 0.64701709E-10_JPRB, 0.63045846E-10_JPRB, 0.61430458E-10_JPRB, 0.59862559E-10_JPRB, &
  & 0.58328571E-10_JPRB, 0.56827203E-10_JPRB, 0.55401021E-10_JPRB, 0.54093778E-10_JPRB, 0.52929855E-10_JPRB, 0.51909501E-10_JPRB, &
  & 0.51005603E-10_JPRB, 0.50198536E-10_JPRB, 0.49476468E-10_JPRB, 0.48831675E-10_JPRB, 0.48256853E-10_JPRB, 0.47747653E-10_JPRB, &
  & 0.47301184E-10_JPRB, 0.46916311E-10_JPRB, 0.46589038E-10_JPRB, 0.46316360E-10_JPRB, 0.46095232E-10_JPRB, 0.45922832E-10_JPRB, &
  & 0.45811306E-10_JPRB, 0.45737112E-10_JPRB, 0.45683377E-10_JPRB, 0.45618991E-10_JPRB /)

RGHG8(:,12, 4) = (/ &
  & 0.43384799E-10_JPRB, 0.45939842E-10_JPRB, 0.47685834E-10_JPRB, 0.49333627E-10_JPRB, 0.51118797E-10_JPRB, 0.53073185E-10_JPRB, &
  & 0.55230556E-10_JPRB, 0.57579802E-10_JPRB, 0.60100702E-10_JPRB, 0.62768256E-10_JPRB, 0.65535355E-10_JPRB, 0.68345121E-10_JPRB, &
  & 0.71127944E-10_JPRB, 0.73811499E-10_JPRB, 0.76313511E-10_JPRB, 0.78594964E-10_JPRB, 0.80618581E-10_JPRB, 0.82353048E-10_JPRB, &
  & 0.83759603E-10_JPRB, 0.84831218E-10_JPRB, 0.85558061E-10_JPRB, 0.85959406E-10_JPRB, 0.86065328E-10_JPRB, 0.85918828E-10_JPRB, &
  & 0.85571585E-10_JPRB, 0.85089720E-10_JPRB, 0.84520342E-10_JPRB, 0.83893462E-10_JPRB, 0.83223234E-10_JPRB, 0.82514863E-10_JPRB, &
  & 0.81704081E-10_JPRB, 0.80717530E-10_JPRB, 0.79557798E-10_JPRB, 0.78207926E-10_JPRB, 0.76671614E-10_JPRB, 0.74997772E-10_JPRB, &
  & 0.73222914E-10_JPRB, 0.71409621E-10_JPRB, 0.69596870E-10_JPRB, 0.67826113E-10_JPRB, 0.66098467E-10_JPRB, 0.64403080E-10_JPRB, &
  & 0.62736510E-10_JPRB, 0.61089744E-10_JPRB, 0.59476736E-10_JPRB, 0.57926577E-10_JPRB, 0.56469215E-10_JPRB, 0.55120526E-10_JPRB, &
  & 0.53900932E-10_JPRB, 0.52810156E-10_JPRB, 0.51840615E-10_JPRB, 0.50985244E-10_JPRB, 0.50234230E-10_JPRB, 0.49579812E-10_JPRB, &
  & 0.49016999E-10_JPRB, 0.48544890E-10_JPRB, 0.48158970E-10_JPRB, 0.47850352E-10_JPRB, 0.47608646E-10_JPRB, 0.47425525E-10_JPRB, &
  & 0.47303869E-10_JPRB, 0.47223080E-10_JPRB, 0.47162874E-10_JPRB, 0.47098478E-10_JPRB /)

RGHG8(:,13, 4) = (/ &
  & 0.48045803E-10_JPRB, 0.51560575E-10_JPRB, 0.53756138E-10_JPRB, 0.55834691E-10_JPRB, 0.57968040E-10_JPRB, 0.60270545E-10_JPRB, &
  & 0.62758160E-10_JPRB, 0.65432396E-10_JPRB, 0.68274580E-10_JPRB, 0.71251623E-10_JPRB, 0.74329154E-10_JPRB, 0.77444384E-10_JPRB, &
  & 0.80523144E-10_JPRB, 0.83504224E-10_JPRB, 0.86300654E-10_JPRB, 0.88848470E-10_JPRB, 0.91089913E-10_JPRB, 0.92991302E-10_JPRB, &
  & 0.94504744E-10_JPRB, 0.95608979E-10_JPRB, 0.96289907E-10_JPRB, 0.96561398E-10_JPRB, 0.96458924E-10_JPRB, 0.96029948E-10_JPRB, &
  & 0.95330514E-10_JPRB, 0.94438200E-10_JPRB, 0.93422672E-10_JPRB, 0.92343098E-10_JPRB, 0.91232272E-10_JPRB, 0.90106672E-10_JPRB, &
  & 0.88972621E-10_JPRB, 0.87774031E-10_JPRB, 0.86473148E-10_JPRB, 0.85131194E-10_JPRB, 0.83668503E-10_JPRB, 0.82057618E-10_JPRB, &
  & 0.80396960E-10_JPRB, 0.78727476E-10_JPRB, 0.77056792E-10_JPRB, 0.75421107E-10_JPRB, 0.73795810E-10_JPRB, 0.72122738E-10_JPRB, &
  & 0.70390908E-10_JPRB, 0.68571600E-10_JPRB, 0.66679925E-10_JPRB, 0.64763472E-10_JPRB, 0.62876336E-10_JPRB, 0.61088024E-10_JPRB, &
  & 0.59429642E-10_JPRB, 0.57920273E-10_JPRB, 0.56556596E-10_JPRB, 0.55329491E-10_JPRB, 0.54228240E-10_JPRB, 0.53248638E-10_JPRB, &
  & 0.52388566E-10_JPRB, 0.51649261E-10_JPRB, 0.51028036E-10_JPRB, 0.50520803E-10_JPRB, 0.50119294E-10_JPRB, 0.49810874E-10_JPRB, &
  & 0.49593725E-10_JPRB, 0.49436410E-10_JPRB, 0.49319826E-10_JPRB, 0.49201577E-10_JPRB /)

RGHG8(:,14, 4) = (/ &
  & 0.54795959E-10_JPRB, 0.59128272E-10_JPRB, 0.61780338E-10_JPRB, 0.64088117E-10_JPRB, 0.66422680E-10_JPRB, 0.68860161E-10_JPRB, &
  & 0.71447549E-10_JPRB, 0.74197593E-10_JPRB, 0.77101728E-10_JPRB, 0.80140825E-10_JPRB, 0.83262286E-10_JPRB, 0.86398451E-10_JPRB, &
  & 0.89476718E-10_JPRB, 0.92437211E-10_JPRB, 0.95231802E-10_JPRB, 0.97792108E-10_JPRB, 0.10005516E-09_JPRB, 0.10197444E-09_JPRB, &
  & 0.10352193E-09_JPRB, 0.10466395E-09_JPRB, 0.10537772E-09_JPRB, 0.10566907E-09_JPRB, 0.10556593E-09_JPRB, 0.10510880E-09_JPRB, &
  & 0.10436058E-09_JPRB, 0.10339518E-09_JPRB, 0.10227163E-09_JPRB, 0.10104098E-09_JPRB, 0.99752616E-10_JPRB, 0.98422159E-10_JPRB, &
  & 0.97054059E-10_JPRB, 0.95664102E-10_JPRB, 0.94224413E-10_JPRB, 0.92735486E-10_JPRB, 0.91336036E-10_JPRB, 0.90043202E-10_JPRB, &
  & 0.88813082E-10_JPRB, 0.87658582E-10_JPRB, 0.86524954E-10_JPRB, 0.85352420E-10_JPRB, 0.84081742E-10_JPRB, 0.82650185E-10_JPRB, &
  & 0.81024923E-10_JPRB, 0.79168533E-10_JPRB, 0.77088981E-10_JPRB, 0.74856649E-10_JPRB, 0.72580886E-10_JPRB, 0.70353737E-10_JPRB, &
  & 0.68254173E-10_JPRB, 0.66306495E-10_JPRB, 0.64506921E-10_JPRB, 0.62841413E-10_JPRB, 0.61299188E-10_JPRB, 0.59878304E-10_JPRB, &
  & 0.58583943E-10_JPRB, 0.57426806E-10_JPRB, 0.56415955E-10_JPRB, 0.55556885E-10_JPRB, 0.54853032E-10_JPRB, 0.54296366E-10_JPRB, &
  & 0.53879273E-10_JPRB, 0.53573541E-10_JPRB, 0.53338028E-10_JPRB, 0.53137817E-10_JPRB /)

RGHG8(:,15, 4) = (/ &
  & 0.63524401E-10_JPRB, 0.68357917E-10_JPRB, 0.71100195E-10_JPRB, 0.73453091E-10_JPRB, 0.75735869E-10_JPRB, 0.78086905E-10_JPRB, &
  & 0.80558442E-10_JPRB, 0.83171629E-10_JPRB, 0.85929437E-10_JPRB, 0.88812721E-10_JPRB, 0.91785447E-10_JPRB, 0.94770095E-10_JPRB, &
  & 0.97675382E-10_JPRB, 0.10044165E-09_JPRB, 0.10303403E-09_JPRB, 0.10543823E-09_JPRB, 0.10760250E-09_JPRB, 0.10947365E-09_JPRB, &
  & 0.11101576E-09_JPRB, 0.11219858E-09_JPRB, 0.11299561E-09_JPRB, 0.11339520E-09_JPRB, 0.11341557E-09_JPRB, 0.11310330E-09_JPRB, &
  & 0.11250865E-09_JPRB, 0.11169216E-09_JPRB, 0.11070402E-09_JPRB, 0.10956484E-09_JPRB, 0.10829685E-09_JPRB, 0.10693461E-09_JPRB, &
  & 0.10548300E-09_JPRB, 0.10397436E-09_JPRB, 0.10248326E-09_JPRB, 0.10106684E-09_JPRB, 0.99786936E-10_JPRB, 0.98722627E-10_JPRB, &
  & 0.97903401E-10_JPRB, 0.97247162E-10_JPRB, 0.96671719E-10_JPRB, 0.96060257E-10_JPRB, 0.95291372E-10_JPRB, 0.94261987E-10_JPRB, &
  & 0.92902824E-10_JPRB, 0.91166387E-10_JPRB, 0.89084289E-10_JPRB, 0.86746631E-10_JPRB, 0.84280326E-10_JPRB, 0.81819412E-10_JPRB, &
  & 0.79450134E-10_JPRB, 0.77212063E-10_JPRB, 0.75104173E-10_JPRB, 0.73110490E-10_JPRB, 0.71213715E-10_JPRB, 0.69409485E-10_JPRB, &
  & 0.67708929E-10_JPRB, 0.66137665E-10_JPRB, 0.64719528E-10_JPRB, 0.63481748E-10_JPRB, 0.62438200E-10_JPRB, 0.61597602E-10_JPRB, &
  & 0.60958058E-10_JPRB, 0.60479718E-10_JPRB, 0.60136417E-10_JPRB, 0.59876416E-10_JPRB /)

RGHG8(:,16, 4) = (/ &
  & 0.73411971E-10_JPRB, 0.78130315E-10_JPRB, 0.80719507E-10_JPRB, 0.82879655E-10_JPRB, 0.84964813E-10_JPRB, 0.87098044E-10_JPRB, &
  & 0.89341229E-10_JPRB, 0.91721609E-10_JPRB, 0.94240990E-10_JPRB, 0.96878061E-10_JPRB, 0.99592459E-10_JPRB, 0.10231851E-09_JPRB, &
  & 0.10499005E-09_JPRB, 0.10752842E-09_JPRB, 0.10989593E-09_JPRB, 0.11208487E-09_JPRB, 0.11409888E-09_JPRB, 0.11589709E-09_JPRB, &
  & 0.11743334E-09_JPRB, 0.11866899E-09_JPRB, 0.11957309E-09_JPRB, 0.12012503E-09_JPRB, 0.12034200E-09_JPRB, 0.12025797E-09_JPRB, &
  & 0.11992282E-09_JPRB, 0.11937729E-09_JPRB, 0.11864806E-09_JPRB, 0.11774311E-09_JPRB, 0.11664483E-09_JPRB, 0.11537906E-09_JPRB, &
  & 0.11396160E-09_JPRB, 0.11243036E-09_JPRB, 0.11090422E-09_JPRB, 0.10951204E-09_JPRB, 0.10835368E-09_JPRB, 0.10751075E-09_JPRB, &
  & 0.10700844E-09_JPRB, 0.10678734E-09_JPRB, 0.10670268E-09_JPRB, 0.10658006E-09_JPRB, 0.10624725E-09_JPRB, 0.10558608E-09_JPRB, &
  & 0.10450974E-09_JPRB, 0.10298381E-09_JPRB, 0.10103863E-09_JPRB, 0.98769257E-10_JPRB, 0.96317544E-10_JPRB, 0.93815428E-10_JPRB, &
  & 0.91369641E-10_JPRB, 0.89025329E-10_JPRB, 0.86784482E-10_JPRB, 0.84628762E-10_JPRB, 0.82537636E-10_JPRB, 0.80506296E-10_JPRB, &
  & 0.78549667E-10_JPRB, 0.76701402E-10_JPRB, 0.75004343E-10_JPRB, 0.73493669E-10_JPRB, 0.72209697E-10_JPRB, 0.71165233E-10_JPRB, &
  & 0.70370987E-10_JPRB, 0.69797758E-10_JPRB, 0.69404218E-10_JPRB, 0.69215043E-10_JPRB /)

RGHG8(:,17, 4) = (/ &
  & 0.83252745E-10_JPRB, 0.87496441E-10_JPRB, 0.89773189E-10_JPRB, 0.91682856E-10_JPRB, 0.93523550E-10_JPRB, 0.95421213E-10_JPRB, &
  & 0.97435122E-10_JPRB, 0.99590017E-10_JPRB, 0.10188457E-09_JPRB, 0.10429762E-09_JPRB, 0.10677219E-09_JPRB, 0.10924057E-09_JPRB, &
  & 0.11164197E-09_JPRB, 0.11393880E-09_JPRB, 0.11609529E-09_JPRB, 0.11809356E-09_JPRB, 0.11994224E-09_JPRB, 0.12164225E-09_JPRB, &
  & 0.12315361E-09_JPRB, 0.12443369E-09_JPRB, 0.12543633E-09_JPRB, 0.12615403E-09_JPRB, 0.12657925E-09_JPRB, 0.12674638E-09_JPRB, &
  & 0.12670609E-09_JPRB, 0.12645529E-09_JPRB, 0.12603686E-09_JPRB, 0.12542972E-09_JPRB, 0.12460286E-09_JPRB, 0.12354041E-09_JPRB, &
  & 0.12227960E-09_JPRB, 0.12086133E-09_JPRB, 0.11940575E-09_JPRB, 0.11806157E-09_JPRB, 0.11698216E-09_JPRB, 0.11627939E-09_JPRB, &
  & 0.11598492E-09_JPRB, 0.11601820E-09_JPRB, 0.11621828E-09_JPRB, 0.11639436E-09_JPRB, 0.11634309E-09_JPRB, 0.11593174E-09_JPRB, &
  & 0.11507231E-09_JPRB, 0.11373400E-09_JPRB, 0.11195386E-09_JPRB, 0.10982914E-09_JPRB, 0.10748857E-09_JPRB, 0.10508002E-09_JPRB, &
  & 0.10269427E-09_JPRB, 0.10037104E-09_JPRB, 0.98122684E-10_JPRB, 0.95938542E-10_JPRB, 0.93800211E-10_JPRB, 0.91701674E-10_JPRB, &
  & 0.89657580E-10_JPRB, 0.87707619E-10_JPRB, 0.85897664E-10_JPRB, 0.84280943E-10_JPRB, 0.82897945E-10_JPRB, 0.81783025E-10_JPRB, &
  & 0.80948845E-10_JPRB, 0.80368948E-10_JPRB, 0.80018443E-10_JPRB, 0.79970329E-10_JPRB /)

RGHG8(:,18, 4) = (/ &
  & 0.92320568E-10_JPRB, 0.95998751E-10_JPRB, 0.98011113E-10_JPRB, 0.99689770E-10_JPRB, 0.10133305E-09_JPRB, 0.10304210E-09_JPRB, &
  & 0.10487154E-09_JPRB, 0.10684663E-09_JPRB, 0.10895927E-09_JPRB, 0.11117871E-09_JPRB, 0.11345199E-09_JPRB, 0.11570514E-09_JPRB, &
  & 0.11787937E-09_JPRB, 0.11993503E-09_JPRB, 0.12187228E-09_JPRB, 0.12368517E-09_JPRB, 0.12537207E-09_JPRB, 0.12694210E-09_JPRB, &
  & 0.12838687E-09_JPRB, 0.12966389E-09_JPRB, 0.13073534E-09_JPRB, 0.13157267E-09_JPRB, 0.13217183E-09_JPRB, 0.13256130E-09_JPRB, &
  & 0.13275595E-09_JPRB, 0.13279354E-09_JPRB, 0.13267792E-09_JPRB, 0.13239181E-09_JPRB, 0.13187999E-09_JPRB, 0.13113570E-09_JPRB, &
  & 0.13014850E-09_JPRB, 0.12898312E-09_JPRB, 0.12775242E-09_JPRB, 0.12659615E-09_JPRB, 0.12565703E-09_JPRB, 0.12505912E-09_JPRB, &
  & 0.12484794E-09_JPRB, 0.12495824E-09_JPRB, 0.12522289E-09_JPRB, 0.12544876E-09_JPRB, 0.12545956E-09_JPRB, 0.12510748E-09_JPRB, &
  & 0.12431431E-09_JPRB, 0.12305935E-09_JPRB, 0.12138456E-09_JPRB, 0.11937831E-09_JPRB, 0.11717527E-09_JPRB, 0.11489132E-09_JPRB, &
  & 0.11261032E-09_JPRB, 0.11037081E-09_JPRB, 0.10819402E-09_JPRB, 0.10607921E-09_JPRB, 0.10400982E-09_JPRB, 0.10198062E-09_JPRB, &
  & 0.10000335E-09_JPRB, 0.98111859E-10_JPRB, 0.96351399E-10_JPRB, 0.94771448E-10_JPRB, 0.93426544E-10_JPRB, 0.92350266E-10_JPRB, &
  & 0.91567302E-10_JPRB, 0.91046573E-10_JPRB, 0.90777760E-10_JPRB, 0.90867668E-10_JPRB /)

RGHG8(:,19, 4) = (/ &
  & 0.10038338E-09_JPRB, 0.10364971E-09_JPRB, 0.10541290E-09_JPRB, 0.10693813E-09_JPRB, 0.10842371E-09_JPRB, 0.10998782E-09_JPRB, &
  & 0.11167427E-09_JPRB, 0.11349891E-09_JPRB, 0.11545624E-09_JPRB, 0.11751879E-09_JPRB, 0.11961987E-09_JPRB, 0.12170295E-09_JPRB, &
  & 0.12370152E-09_JPRB, 0.12557592E-09_JPRB, 0.12732135E-09_JPRB, 0.12895281E-09_JPRB, 0.13048158E-09_JPRB, 0.13191272E-09_JPRB, &
  & 0.13325036E-09_JPRB, 0.13447587E-09_JPRB, 0.13555466E-09_JPRB, 0.13644912E-09_JPRB, 0.13718052E-09_JPRB, 0.13771129E-09_JPRB, &
  & 0.13810682E-09_JPRB, 0.13836474E-09_JPRB, 0.13848392E-09_JPRB, 0.13846113E-09_JPRB, 0.13825942E-09_JPRB, 0.13786253E-09_JPRB, &
  & 0.13725884E-09_JPRB, 0.13648449E-09_JPRB, 0.13561494E-09_JPRB, 0.13476595E-09_JPRB, 0.13406612E-09_JPRB, 0.13359923E-09_JPRB, &
  & 0.13342533E-09_JPRB, 0.13347423E-09_JPRB, 0.13360807E-09_JPRB, 0.13367972E-09_JPRB, 0.13354291E-09_JPRB, 0.13307987E-09_JPRB, &
  & 0.13222147E-09_JPRB, 0.13095142E-09_JPRB, 0.12930436E-09_JPRB, 0.12737275E-09_JPRB, 0.12526388E-09_JPRB, 0.12308832E-09_JPRB, &
  & 0.12091991E-09_JPRB, 0.11881229E-09_JPRB, 0.11677534E-09_JPRB, 0.11479839E-09_JPRB, 0.11287472E-09_JPRB, 0.11100556E-09_JPRB, &
  & 0.10919780E-09_JPRB, 0.10747446E-09_JPRB, 0.10586859E-09_JPRB, 0.10442627E-09_JPRB, 0.10319812E-09_JPRB, 0.10222508E-09_JPRB, &
  & 0.10152426E-09_JPRB, 0.10108569E-09_JPRB, 0.10088026E-09_JPRB, 0.10106364E-09_JPRB /)

RGHG8(:,20, 4) = (/ &
  & 0.10754016E-09_JPRB, 0.11040641E-09_JPRB, 0.11204180E-09_JPRB, 0.11341773E-09_JPRB, 0.11480091E-09_JPRB, 0.11625703E-09_JPRB, &
  & 0.11783552E-09_JPRB, 0.11954854E-09_JPRB, 0.12138882E-09_JPRB, 0.12332244E-09_JPRB, 0.12528806E-09_JPRB, 0.12722176E-09_JPRB, &
  & 0.12907146E-09_JPRB, 0.13079718E-09_JPRB, 0.13239083E-09_JPRB, 0.13386388E-09_JPRB, 0.13523928E-09_JPRB, 0.13653136E-09_JPRB, &
  & 0.13774566E-09_JPRB, 0.13887687E-09_JPRB, 0.13990428E-09_JPRB, 0.14080730E-09_JPRB, 0.14155913E-09_JPRB, 0.14219026E-09_JPRB, &
  & 0.14268635E-09_JPRB, 0.14307069E-09_JPRB, 0.14335752E-09_JPRB, 0.14353495E-09_JPRB, 0.14359833E-09_JPRB, 0.14352196E-09_JPRB, &
  & 0.14330929E-09_JPRB, 0.14296279E-09_JPRB, 0.14252424E-09_JPRB, 0.14205481E-09_JPRB, 0.14164070E-09_JPRB, 0.14134005E-09_JPRB, &
  & 0.14116464E-09_JPRB, 0.14107034E-09_JPRB, 0.14100393E-09_JPRB, 0.14083146E-09_JPRB, 0.14045037E-09_JPRB, 0.13977894E-09_JPRB, &
  & 0.13877233E-09_JPRB, 0.13741874E-09_JPRB, 0.13575943E-09_JPRB, 0.13386722E-09_JPRB, 0.13185461E-09_JPRB, 0.12981140E-09_JPRB, &
  & 0.12780453E-09_JPRB, 0.12586314E-09_JPRB, 0.12398363E-09_JPRB, 0.12216500E-09_JPRB, 0.12041536E-09_JPRB, 0.11873916E-09_JPRB, &
  & 0.11714071E-09_JPRB, 0.11563105E-09_JPRB, 0.11422729E-09_JPRB, 0.11296238E-09_JPRB, 0.11187867E-09_JPRB, 0.11101450E-09_JPRB, &
  & 0.11039863E-09_JPRB, 0.11000226E-09_JPRB, 0.10983183E-09_JPRB, 0.10998254E-09_JPRB /)

RGHG8(:,21, 4) = (/ &
  & 0.11373698E-09_JPRB, 0.11639500E-09_JPRB, 0.11785611E-09_JPRB, 0.11915852E-09_JPRB, 0.12044353E-09_JPRB, 0.12181887E-09_JPRB, &
  & 0.12331587E-09_JPRB, 0.12493731E-09_JPRB, 0.12667442E-09_JPRB, 0.12849898E-09_JPRB, 0.13034347E-09_JPRB, 0.13215501E-09_JPRB, &
  & 0.13387740E-09_JPRB, 0.13548040E-09_JPRB, 0.13695213E-09_JPRB, 0.13830176E-09_JPRB, 0.13954995E-09_JPRB, 0.14071644E-09_JPRB, &
  & 0.14181296E-09_JPRB, 0.14284122E-09_JPRB, 0.14379106E-09_JPRB, 0.14464327E-09_JPRB, 0.14539141E-09_JPRB, 0.14602369E-09_JPRB, &
  & 0.14654755E-09_JPRB, 0.14699091E-09_JPRB, 0.14736615E-09_JPRB, 0.14768303E-09_JPRB, 0.14794015E-09_JPRB, 0.14812131E-09_JPRB, &
  & 0.14822218E-09_JPRB, 0.14822624E-09_JPRB, 0.14815334E-09_JPRB, 0.14801332E-09_JPRB, 0.14784676E-09_JPRB, 0.14767192E-09_JPRB, &
  & 0.14750820E-09_JPRB, 0.14731698E-09_JPRB, 0.14705454E-09_JPRB, 0.14664514E-09_JPRB, 0.14602825E-09_JPRB, 0.14515376E-09_JPRB, &
  & 0.14400101E-09_JPRB, 0.14257283E-09_JPRB, 0.14090619E-09_JPRB, 0.13908187E-09_JPRB, 0.13718775E-09_JPRB, 0.13530249E-09_JPRB, &
  & 0.13346056E-09_JPRB, 0.13167117E-09_JPRB, 0.12994199E-09_JPRB, 0.12828907E-09_JPRB, 0.12672238E-09_JPRB, 0.12524727E-09_JPRB, &
  & 0.12386199E-09_JPRB, 0.12256592E-09_JPRB, 0.12136325E-09_JPRB, 0.12027127E-09_JPRB, 0.11932343E-09_JPRB, 0.11855442E-09_JPRB, &
  & 0.11798401E-09_JPRB, 0.11761535E-09_JPRB, 0.11741604E-09_JPRB, 0.11749977E-09_JPRB /)

RGHG8(:,22, 4) = (/ &
  & 0.11911711E-09_JPRB, 0.12151587E-09_JPRB, 0.12292171E-09_JPRB, 0.12412588E-09_JPRB, 0.12535097E-09_JPRB, 0.12665288E-09_JPRB, &
  & 0.12807226E-09_JPRB, 0.12961057E-09_JPRB, 0.13125281E-09_JPRB, 0.13296934E-09_JPRB, 0.13470865E-09_JPRB, 0.13641055E-09_JPRB, &
  & 0.13803092E-09_JPRB, 0.13953493E-09_JPRB, 0.14091410E-09_JPRB, 0.14217162E-09_JPRB, 0.14332567E-09_JPRB, 0.14439674E-09_JPRB, &
  & 0.14539785E-09_JPRB, 0.14633574E-09_JPRB, 0.14720618E-09_JPRB, 0.14800075E-09_JPRB, 0.14870273E-09_JPRB, 0.14931036E-09_JPRB, &
  & 0.14983058E-09_JPRB, 0.15028209E-09_JPRB, 0.15068802E-09_JPRB, 0.15106937E-09_JPRB, 0.15143553E-09_JPRB, 0.15177649E-09_JPRB, &
  & 0.15208070E-09_JPRB, 0.15232172E-09_JPRB, 0.15249009E-09_JPRB, 0.15257064E-09_JPRB, 0.15257060E-09_JPRB, 0.15248328E-09_JPRB, &
  & 0.15231383E-09_JPRB, 0.15203649E-09_JPRB, 0.15162624E-09_JPRB, 0.15104464E-09_JPRB, 0.15026103E-09_JPRB, 0.14925278E-09_JPRB, &
  & 0.14801771E-09_JPRB, 0.14656976E-09_JPRB, 0.14495169E-09_JPRB, 0.14322465E-09_JPRB, 0.14146254E-09_JPRB, 0.13971956E-09_JPRB, &
  & 0.13802649E-09_JPRB, 0.13639584E-09_JPRB, 0.13483252E-09_JPRB, 0.13335308E-09_JPRB, 0.13196991E-09_JPRB, 0.13068559E-09_JPRB, &
  & 0.12949361E-09_JPRB, 0.12838523E-09_JPRB, 0.12735513E-09_JPRB, 0.12641004E-09_JPRB, 0.12557147E-09_JPRB, 0.12486943E-09_JPRB, &
  & 0.12433408E-09_JPRB, 0.12395016E-09_JPRB, 0.12371916E-09_JPRB, 0.12364189E-09_JPRB /)

RGHG8(:,23, 4) = (/ &
  & 0.12368667E-09_JPRB, 0.12593646E-09_JPRB, 0.12722219E-09_JPRB, 0.12838029E-09_JPRB, 0.12954003E-09_JPRB, 0.13077948E-09_JPRB, &
  & 0.13212667E-09_JPRB, 0.13358215E-09_JPRB, 0.13512969E-09_JPRB, 0.13674444E-09_JPRB, 0.13837848E-09_JPRB, 0.13998425E-09_JPRB, &
  & 0.14151783E-09_JPRB, 0.14294585E-09_JPRB, 0.14425416E-09_JPRB, 0.14544699E-09_JPRB, 0.14653628E-09_JPRB, 0.14754072E-09_JPRB, &
  & 0.14847476E-09_JPRB, 0.14934541E-09_JPRB, 0.15015314E-09_JPRB, 0.15089117E-09_JPRB, 0.15154898E-09_JPRB, 0.15212290E-09_JPRB, &
  & 0.15262046E-09_JPRB, 0.15306070E-09_JPRB, 0.15346908E-09_JPRB, 0.15386445E-09_JPRB, 0.15426831E-09_JPRB, 0.15468406E-09_JPRB, &
  & 0.15508357E-09_JPRB, 0.15544464E-09_JPRB, 0.15572896E-09_JPRB, 0.15591609E-09_JPRB, 0.15598747E-09_JPRB, 0.15592891E-09_JPRB, &
  & 0.15573581E-09_JPRB, 0.15539203E-09_JPRB, 0.15488819E-09_JPRB, 0.15420662E-09_JPRB, 0.15333823E-09_JPRB, 0.15227423E-09_JPRB, &
  & 0.15103076E-09_JPRB, 0.14962580E-09_JPRB, 0.14809634E-09_JPRB, 0.14649211E-09_JPRB, 0.14487536E-09_JPRB, 0.14329547E-09_JPRB, &
  & 0.14177080E-09_JPRB, 0.14030022E-09_JPRB, 0.13889891E-09_JPRB, 0.13758517E-09_JPRB, 0.13636788E-09_JPRB, 0.13524684E-09_JPRB, &
  & 0.13421175E-09_JPRB, 0.13325034E-09_JPRB, 0.13235238E-09_JPRB, 0.13151691E-09_JPRB, 0.13075983E-09_JPRB, 0.13010670E-09_JPRB, &
  & 0.12958076E-09_JPRB, 0.12918924E-09_JPRB, 0.12889664E-09_JPRB, 0.12869254E-09_JPRB /)

RGHG8(:,24, 4) = (/ &
  & 0.12760736E-09_JPRB, 0.12969689E-09_JPRB, 0.13091236E-09_JPRB, 0.13199428E-09_JPRB, 0.13309669E-09_JPRB, 0.13427201E-09_JPRB, &
  & 0.13554600E-09_JPRB, 0.13691780E-09_JPRB, 0.13837211E-09_JPRB, 0.13988515E-09_JPRB, 0.14142222E-09_JPRB, 0.14293990E-09_JPRB, &
  & 0.14439736E-09_JPRB, 0.14576351E-09_JPRB, 0.14702066E-09_JPRB, 0.14816842E-09_JPRB, 0.14921672E-09_JPRB, 0.15018073E-09_JPRB, &
  & 0.15107107E-09_JPRB, 0.15189666E-09_JPRB, 0.15265990E-09_JPRB, 0.15335404E-09_JPRB, 0.15397449E-09_JPRB, 0.15451608E-09_JPRB, &
  & 0.15498873E-09_JPRB, 0.15540823E-09_JPRB, 0.15580030E-09_JPRB, 0.15618949E-09_JPRB, 0.15659579E-09_JPRB, 0.15701812E-09_JPRB, &
  & 0.15743859E-09_JPRB, 0.15783029E-09_JPRB, 0.15814608E-09_JPRB, 0.15835711E-09_JPRB, 0.15843599E-09_JPRB, 0.15836465E-09_JPRB, &
  & 0.15813513E-09_JPRB, 0.15774251E-09_JPRB, 0.15718471E-09_JPRB, 0.15645700E-09_JPRB, 0.15556191E-09_JPRB, 0.15450592E-09_JPRB, &
  & 0.15330927E-09_JPRB, 0.15199229E-09_JPRB, 0.15058715E-09_JPRB, 0.14913638E-09_JPRB, 0.14768790E-09_JPRB, 0.14627252E-09_JPRB, &
  & 0.14489876E-09_JPRB, 0.14358291E-09_JPRB, 0.14233854E-09_JPRB, 0.14117431E-09_JPRB, 0.14009957E-09_JPRB, 0.13911081E-09_JPRB, &
  & 0.13819641E-09_JPRB, 0.13734291E-09_JPRB, 0.13653896E-09_JPRB, 0.13578136E-09_JPRB, 0.13508085E-09_JPRB, 0.13445992E-09_JPRB, &
  & 0.13394511E-09_JPRB, 0.13353384E-09_JPRB, 0.13320992E-09_JPRB, 0.13287706E-09_JPRB /)

RGHG8(:,25, 4) = (/ &
  & 0.13103420E-09_JPRB, 0.13294310E-09_JPRB, 0.13408953E-09_JPRB, 0.13509839E-09_JPRB, 0.13613269E-09_JPRB, 0.13723833E-09_JPRB, &
  & 0.13843249E-09_JPRB, 0.13971914E-09_JPRB, 0.14107886E-09_JPRB, 0.14249381E-09_JPRB, 0.14393833E-09_JPRB, 0.14537618E-09_JPRB, &
  & 0.14677104E-09_JPRB, 0.14808757E-09_JPRB, 0.14930715E-09_JPRB, 0.15042489E-09_JPRB, 0.15144634E-09_JPRB, 0.15238368E-09_JPRB, &
  & 0.15324655E-09_JPRB, 0.15404354E-09_JPRB, 0.15477612E-09_JPRB, 0.15543986E-09_JPRB, 0.15603087E-09_JPRB, 0.15654646E-09_JPRB, &
  & 0.15699549E-09_JPRB, 0.15739232E-09_JPRB, 0.15776168E-09_JPRB, 0.15813008E-09_JPRB, 0.15851150E-09_JPRB, 0.15891266E-09_JPRB, &
  & 0.15931421E-09_JPRB, 0.15968596E-09_JPRB, 0.15998422E-09_JPRB, 0.16017465E-09_JPRB, 0.16022828E-09_JPRB, 0.16012605E-09_JPRB, &
  & 0.15985981E-09_JPRB, 0.15942893E-09_JPRB, 0.15884252E-09_JPRB, 0.15810755E-09_JPRB, 0.15723080E-09_JPRB, 0.15622280E-09_JPRB, &
  & 0.15510856E-09_JPRB, 0.15390693E-09_JPRB, 0.15264491E-09_JPRB, 0.15135261E-09_JPRB, 0.15006014E-09_JPRB, 0.14879177E-09_JPRB, &
  & 0.14757111E-09_JPRB, 0.14640578E-09_JPRB, 0.14529840E-09_JPRB, 0.14426486E-09_JPRB, 0.14330835E-09_JPRB, 0.14242348E-09_JPRB, &
  & 0.14159894E-09_JPRB, 0.14082235E-09_JPRB, 0.14008306E-09_JPRB, 0.13937758E-09_JPRB, 0.13871521E-09_JPRB, 0.13811667E-09_JPRB, &
  & 0.13760609E-09_JPRB, 0.13718780E-09_JPRB, 0.13683012E-09_JPRB, 0.13642631E-09_JPRB /)

RGHG8(:,26, 4) = (/ &
  & 0.13402766E-09_JPRB, 0.13582632E-09_JPRB, 0.13684669E-09_JPRB, 0.13779868E-09_JPRB, 0.13875522E-09_JPRB, 0.13978220E-09_JPRB, &
  & 0.14089863E-09_JPRB, 0.14209386E-09_JPRB, 0.14336157E-09_JPRB, 0.14468463E-09_JPRB, 0.14604121E-09_JPRB, 0.14740495E-09_JPRB, &
  & 0.14873856E-09_JPRB, 0.15001152E-09_JPRB, 0.15120034E-09_JPRB, 0.15229763E-09_JPRB, 0.15330506E-09_JPRB, 0.15422955E-09_JPRB, &
  & 0.15507813E-09_JPRB, 0.15585766E-09_JPRB, 0.15656931E-09_JPRB, 0.15721148E-09_JPRB, 0.15778027E-09_JPRB, 0.15827645E-09_JPRB, &
  & 0.15870574E-09_JPRB, 0.15908327E-09_JPRB, 0.15943166E-09_JPRB, 0.15976910E-09_JPRB, 0.16012036E-09_JPRB, 0.16048236E-09_JPRB, &
  & 0.16084115E-09_JPRB, 0.16116751E-09_JPRB, 0.16142421E-09_JPRB, 0.16157543E-09_JPRB, 0.16159170E-09_JPRB, 0.16145513E-09_JPRB, &
  & 0.16115889E-09_JPRB, 0.16071340E-09_JPRB, 0.16012666E-09_JPRB, 0.15940968E-09_JPRB, 0.15857536E-09_JPRB, 0.15764172E-09_JPRB, &
  & 0.15662707E-09_JPRB, 0.15555122E-09_JPRB, 0.15443055E-09_JPRB, 0.15328558E-09_JPRB, 0.15213697E-09_JPRB, 0.15101598E-09_JPRB, &
  & 0.14993226E-09_JPRB, 0.14888910E-09_JPRB, 0.14790172E-09_JPRB, 0.14697656E-09_JPRB, 0.14611407E-09_JPRB, 0.14530911E-09_JPRB, &
  & 0.14455050E-09_JPRB, 0.14382742E-09_JPRB, 0.14313115E-09_JPRB, 0.14245941E-09_JPRB, 0.14182114E-09_JPRB, 0.14123731E-09_JPRB, &
  & 0.14073154E-09_JPRB, 0.14030646E-09_JPRB, 0.13992840E-09_JPRB, 0.13946075E-09_JPRB /)

RGHG8(:,27, 4) = (/ &
  & 0.13675722E-09_JPRB, 0.13833114E-09_JPRB, 0.13931531E-09_JPRB, 0.14016224E-09_JPRB, 0.14105352E-09_JPRB, 0.14200581E-09_JPRB, &
  & 0.14303439E-09_JPRB, 0.14414703E-09_JPRB, 0.14532317E-09_JPRB, 0.14655585E-09_JPRB, 0.14783233E-09_JPRB, 0.14912548E-09_JPRB, &
  & 0.15040696E-09_JPRB, 0.15164116E-09_JPRB, 0.15280568E-09_JPRB, 0.15388728E-09_JPRB, 0.15488409E-09_JPRB, 0.15579986E-09_JPRB, &
  & 0.15663934E-09_JPRB, 0.15740667E-09_JPRB, 0.15810345E-09_JPRB, 0.15872893E-09_JPRB, 0.15928082E-09_JPRB, 0.15976161E-09_JPRB, &
  & 0.16017519E-09_JPRB, 0.16053699E-09_JPRB, 0.16086338E-09_JPRB, 0.16117614E-09_JPRB, 0.16148982E-09_JPRB, 0.16180263E-09_JPRB, &
  & 0.16210795E-09_JPRB, 0.16238069E-09_JPRB, 0.16258646E-09_JPRB, 0.16269359E-09_JPRB, 0.16267299E-09_JPRB, 0.16251049E-09_JPRB, &
  & 0.16220231E-09_JPRB, 0.16175254E-09_JPRB, 0.16118086E-09_JPRB, 0.16050734E-09_JPRB, 0.15974019E-09_JPRB, 0.15889459E-09_JPRB, &
  & 0.15798945E-09_JPRB, 0.15703717E-09_JPRB, 0.15605113E-09_JPRB, 0.15503886E-09_JPRB, 0.15402483E-09_JPRB, 0.15302651E-09_JPRB, &
  & 0.15205415E-09_JPRB, 0.15112138E-09_JPRB, 0.15023233E-09_JPRB, 0.14939280E-09_JPRB, 0.14860400E-09_JPRB, 0.14785867E-09_JPRB, &
  & 0.14714785E-09_JPRB, 0.14646165E-09_JPRB, 0.14579352E-09_JPRB, 0.14514241E-09_JPRB, 0.14451904E-09_JPRB, 0.14394469E-09_JPRB, &
  & 0.14344324E-09_JPRB, 0.14301538E-09_JPRB, 0.14262913E-09_JPRB, 0.14211611E-09_JPRB /)

RGHG8(:,28, 4) = (/ &
  & 0.13914726E-09_JPRB, 0.14064203E-09_JPRB, 0.14148063E-09_JPRB, 0.14228675E-09_JPRB, 0.14309429E-09_JPRB, 0.14397085E-09_JPRB, &
  & 0.14492851E-09_JPRB, 0.14595342E-09_JPRB, 0.14704617E-09_JPRB, 0.14819647E-09_JPRB, 0.14939316E-09_JPRB, 0.15062039E-09_JPRB, &
  & 0.15184731E-09_JPRB, 0.15304621E-09_JPRB, 0.15419019E-09_JPRB, 0.15526143E-09_JPRB, 0.15625130E-09_JPRB, 0.15715988E-09_JPRB, &
  & 0.15799168E-09_JPRB, 0.15874940E-09_JPRB, 0.15943365E-09_JPRB, 0.16004495E-09_JPRB, 0.16058223E-09_JPRB, 0.16104848E-09_JPRB, &
  & 0.16144805E-09_JPRB, 0.16179355E-09_JPRB, 0.16209850E-09_JPRB, 0.16238544E-09_JPRB, 0.16265922E-09_JPRB, 0.16292526E-09_JPRB, &
  & 0.16317638E-09_JPRB, 0.16339465E-09_JPRB, 0.16354919E-09_JPRB, 0.16361405E-09_JPRB, 0.16356233E-09_JPRB, 0.16338188E-09_JPRB, &
  & 0.16306860E-09_JPRB, 0.16263943E-09_JPRB, 0.16211256E-09_JPRB, 0.16149730E-09_JPRB, 0.16080716E-09_JPRB, 0.16005698E-09_JPRB, &
  & 0.15926005E-09_JPRB, 0.15842656E-09_JPRB, 0.15755862E-09_JPRB, 0.15666847E-09_JPRB, 0.15576571E-09_JPRB, 0.15487088E-09_JPRB, &
  & 0.15399743E-09_JPRB, 0.15315162E-09_JPRB, 0.15233916E-09_JPRB, 0.15156743E-09_JPRB, 0.15083326E-09_JPRB, 0.15013259E-09_JPRB, &
  & 0.14945610E-09_JPRB, 0.14879598E-09_JPRB, 0.14814630E-09_JPRB, 0.14750791E-09_JPRB, 0.14689359E-09_JPRB, 0.14632545E-09_JPRB, &
  & 0.14582836E-09_JPRB, 0.14540337E-09_JPRB, 0.14500766E-09_JPRB, 0.14447851E-09_JPRB /)

RGHG8(:,29, 4) = (/ &
  & 0.14133746E-09_JPRB, 0.14263826E-09_JPRB, 0.14346667E-09_JPRB, 0.14417509E-09_JPRB, 0.14493193E-09_JPRB, 0.14574453E-09_JPRB, &
  & 0.14662351E-09_JPRB, 0.14757714E-09_JPRB, 0.14858878E-09_JPRB, 0.14965948E-09_JPRB, 0.15078566E-09_JPRB, 0.15194859E-09_JPRB, &
  & 0.15312528E-09_JPRB, 0.15428264E-09_JPRB, 0.15539811E-09_JPRB, 0.15645579E-09_JPRB, 0.15744245E-09_JPRB, 0.15834958E-09_JPRB, &
  & 0.15917699E-09_JPRB, 0.15992670E-09_JPRB, 0.16060056E-09_JPRB, 0.16119779E-09_JPRB, 0.16172128E-09_JPRB, 0.16217173E-09_JPRB, &
  & 0.16255763E-09_JPRB, 0.16288561E-09_JPRB, 0.16317173E-09_JPRB, 0.16343142E-09_JPRB, 0.16366770E-09_JPRB, 0.16388829E-09_JPRB, &
  & 0.16408849E-09_JPRB, 0.16425419E-09_JPRB, 0.16436191E-09_JPRB, 0.16438902E-09_JPRB, 0.16431363E-09_JPRB, 0.16412635E-09_JPRB, &
  & 0.16383066E-09_JPRB, 0.16343683E-09_JPRB, 0.16295558E-09_JPRB, 0.16240681E-09_JPRB, 0.16180189E-09_JPRB, 0.16114804E-09_JPRB, &
  & 0.16045751E-09_JPRB, 0.15973189E-09_JPRB, 0.15897472E-09_JPRB, 0.15818574E-09_JPRB, 0.15738130E-09_JPRB, 0.15657194E-09_JPRB, &
  & 0.15577563E-09_JPRB, 0.15499937E-09_JPRB, 0.15424900E-09_JPRB, 0.15352797E-09_JPRB, 0.15283623E-09_JPRB, 0.15216872E-09_JPRB, &
  & 0.15151817E-09_JPRB, 0.15087652E-09_JPRB, 0.15024042E-09_JPRB, 0.14961080E-09_JPRB, 0.14900252E-09_JPRB, 0.14843955E-09_JPRB, &
  & 0.14794667E-09_JPRB, 0.14752438E-09_JPRB, 0.14713369E-09_JPRB, 0.14658733E-09_JPRB /)

RGHG8(:,30, 4) = (/ &
  & 0.14324536E-09_JPRB, 0.14450501E-09_JPRB, 0.14521599E-09_JPRB, 0.14590719E-09_JPRB, 0.14659769E-09_JPRB, 0.14735151E-09_JPRB, &
  & 0.14817342E-09_JPRB, 0.14905245E-09_JPRB, 0.14999305E-09_JPRB, 0.15099176E-09_JPRB, 0.15204719E-09_JPRB, 0.15315059E-09_JPRB, &
  & 0.15427853E-09_JPRB, 0.15540355E-09_JPRB, 0.15649582E-09_JPRB, 0.15753376E-09_JPRB, 0.15850815E-09_JPRB, 0.15940851E-09_JPRB, &
  & 0.16022982E-09_JPRB, 0.16097003E-09_JPRB, 0.16163254E-09_JPRB, 0.16221444E-09_JPRB, 0.16272328E-09_JPRB, 0.16315542E-09_JPRB, &
  & 0.16352726E-09_JPRB, 0.16383501E-09_JPRB, 0.16410293E-09_JPRB, 0.16433516E-09_JPRB, 0.16453783E-09_JPRB, 0.16471718E-09_JPRB, &
  & 0.16487159E-09_JPRB, 0.16499022E-09_JPRB, 0.16505712E-09_JPRB, 0.16505305E-09_JPRB, 0.16496227E-09_JPRB, 0.16477723E-09_JPRB, &
  & 0.16449915E-09_JPRB, 0.16413720E-09_JPRB, 0.16371510E-09_JPRB, 0.16324353E-09_JPRB, 0.16272600E-09_JPRB, 0.16216636E-09_JPRB, &
  & 0.16156987E-09_JPRB, 0.16094302E-09_JPRB, 0.16027640E-09_JPRB, 0.15957846E-09_JPRB, 0.15885475E-09_JPRB, 0.15812066E-09_JPRB, &
  & 0.15738905E-09_JPRB, 0.15666944E-09_JPRB, 0.15596793E-09_JPRB, 0.15528814E-09_JPRB, 0.15462936E-09_JPRB, 0.15398860E-09_JPRB, &
  & 0.15335866E-09_JPRB, 0.15273317E-09_JPRB, 0.15210827E-09_JPRB, 0.15148638E-09_JPRB, 0.15088431E-09_JPRB, 0.15032657E-09_JPRB, &
  & 0.14984074E-09_JPRB, 0.14942390E-09_JPRB, 0.14903269E-09_JPRB, 0.14848536E-09_JPRB /)

RGHG8(:,31, 4) = (/ &
  & 0.14499811E-09_JPRB, 0.14613327E-09_JPRB, 0.14685282E-09_JPRB, 0.14747024E-09_JPRB, 0.14813073E-09_JPRB, 0.14883619E-09_JPRB, &
  & 0.14959668E-09_JPRB, 0.15041697E-09_JPRB, 0.15128881E-09_JPRB, 0.15221942E-09_JPRB, 0.15321221E-09_JPRB, 0.15425640E-09_JPRB, &
  & 0.15533416E-09_JPRB, 0.15641881E-09_JPRB, 0.15748428E-09_JPRB, 0.15850654E-09_JPRB, 0.15946823E-09_JPRB, 0.16035956E-09_JPRB, &
  & 0.16117108E-09_JPRB, 0.16189959E-09_JPRB, 0.16254756E-09_JPRB, 0.16311233E-09_JPRB, 0.16360434E-09_JPRB, 0.16401691E-09_JPRB, &
  & 0.16437209E-09_JPRB, 0.16465926E-09_JPRB, 0.16490777E-09_JPRB, 0.16511363E-09_JPRB, 0.16528721E-09_JPRB, 0.16543041E-09_JPRB, &
  & 0.16554524E-09_JPRB, 0.16562421E-09_JPRB, 0.16565639E-09_JPRB, 0.16562821E-09_JPRB, 0.16552752E-09_JPRB, 0.16534871E-09_JPRB, &
  & 0.16509580E-09_JPRB, 0.16478449E-09_JPRB, 0.16442259E-09_JPRB, 0.16401640E-09_JPRB, 0.16357363E-09_JPRB, 0.16309623E-09_JPRB, &
  & 0.16258651E-09_JPRB, 0.16204003E-09_JPRB, 0.16145495E-09_JPRB, 0.16082868E-09_JPRB, 0.16017560E-09_JPRB, 0.15950577E-09_JPRB, &
  & 0.15883020E-09_JPRB, 0.15815951E-09_JPRB, 0.15750004E-09_JPRB, 0.15685470E-09_JPRB, 0.15622528E-09_JPRB, 0.15560866E-09_JPRB, &
  & 0.15499847E-09_JPRB, 0.15438863E-09_JPRB, 0.15377563E-09_JPRB, 0.15316354E-09_JPRB, 0.15256929E-09_JPRB, 0.15202095E-09_JPRB, &
  & 0.15154164E-09_JPRB, 0.15113279E-09_JPRB, 0.15074791E-09_JPRB, 0.15019901E-09_JPRB /)

RGHG8(:,32, 4) = (/ &
  & 0.14656150E-09_JPRB, 0.14768567E-09_JPRB, 0.14832485E-09_JPRB, 0.14893892E-09_JPRB, 0.14955094E-09_JPRB, 0.15021531E-09_JPRB, &
  & 0.15092926E-09_JPRB, 0.15168981E-09_JPRB, 0.15250076E-09_JPRB, 0.15336758E-09_JPRB, 0.15429628E-09_JPRB, 0.15528369E-09_JPRB, &
  & 0.15631130E-09_JPRB, 0.15735563E-09_JPRB, 0.15839130E-09_JPRB, 0.15939132E-09_JPRB, 0.16033667E-09_JPRB, 0.16121460E-09_JPRB, &
  & 0.16201324E-09_JPRB, 0.16272712E-09_JPRB, 0.16335681E-09_JPRB, 0.16390338E-09_JPRB, 0.16437604E-09_JPRB, 0.16476939E-09_JPRB, &
  & 0.16510439E-09_JPRB, 0.16537358E-09_JPRB, 0.16559948E-09_JPRB, 0.16578340E-09_JPRB, 0.16592989E-09_JPRB, 0.16604333E-09_JPRB, &
  & 0.16612516E-09_JPRB, 0.16617191E-09_JPRB, 0.16617692E-09_JPRB, 0.16613096E-09_JPRB, 0.16602589E-09_JPRB, 0.16585916E-09_JPRB, &
  & 0.16563820E-09_JPRB, 0.16536954E-09_JPRB, 0.16505997E-09_JPRB, 0.16471577E-09_JPRB, 0.16433754E-09_JPRB, 0.16392798E-09_JPRB, &
  & 0.16348563E-09_JPRB, 0.16300680E-09_JPRB, 0.16248576E-09_JPRB, 0.16192533E-09_JPRB, 0.16133207E-09_JPRB, 0.16071809E-09_JPRB, &
  & 0.16009444E-09_JPRB, 0.15946798E-09_JPRB, 0.15884645E-09_JPRB, 0.15823493E-09_JPRB, 0.15763406E-09_JPRB, 0.15704257E-09_JPRB, &
  & 0.15645388E-09_JPRB, 0.15586257E-09_JPRB, 0.15526448E-09_JPRB, 0.15466559E-09_JPRB, 0.15408393E-09_JPRB, 0.15354723E-09_JPRB, &
  & 0.15308138E-09_JPRB, 0.15268113E-09_JPRB, 0.15230220E-09_JPRB, 0.15175597E-09_JPRB /)

RGHG8(:,33, 4) = (/ &
  & 0.14803908E-09_JPRB, 0.14908812E-09_JPRB, 0.14973835E-09_JPRB, 0.15029954E-09_JPRB, 0.15089043E-09_JPRB, 0.15151592E-09_JPRB, &
  & 0.15218174E-09_JPRB, 0.15289173E-09_JPRB, 0.15364333E-09_JPRB, 0.15444818E-09_JPRB, 0.15531634E-09_JPRB, 0.15624553E-09_JPRB, &
  & 0.15722307E-09_JPRB, 0.15822418E-09_JPRB, 0.15922412E-09_JPRB, 0.16019923E-09_JPRB, 0.16112348E-09_JPRB, 0.16198266E-09_JPRB, &
  & 0.16276266E-09_JPRB, 0.16345963E-09_JPRB, 0.16406912E-09_JPRB, 0.16459584E-09_JPRB, 0.16504817E-09_JPRB, 0.16542287E-09_JPRB, &
  & 0.16573679E-09_JPRB, 0.16598839E-09_JPRB, 0.16619262E-09_JPRB, 0.16635585E-09_JPRB, 0.16647923E-09_JPRB, 0.16656775E-09_JPRB, &
  & 0.16662333E-09_JPRB, 0.16664507E-09_JPRB, 0.16662990E-09_JPRB, 0.16657230E-09_JPRB, 0.16646790E-09_JPRB, 0.16631721E-09_JPRB, &
  & 0.16612395E-09_JPRB, 0.16589341E-09_JPRB, 0.16563047E-09_JPRB, 0.16533763E-09_JPRB, 0.16501321E-09_JPRB, 0.16465716E-09_JPRB, &
  & 0.16426727E-09_JPRB, 0.16383910E-09_JPRB, 0.16337121E-09_JPRB, 0.16286314E-09_JPRB, 0.16232274E-09_JPRB, 0.16175998E-09_JPRB, &
  & 0.16118192E-09_JPRB, 0.16059815E-09_JPRB, 0.16001453E-09_JPRB, 0.15943628E-09_JPRB, 0.15886666E-09_JPRB, 0.15830338E-09_JPRB, &
  & 0.15774032E-09_JPRB, 0.15717168E-09_JPRB, 0.15659402E-09_JPRB, 0.15601329E-09_JPRB, 0.15544906E-09_JPRB, 0.15493061E-09_JPRB, &
  & 0.15447874E-09_JPRB, 0.15409093E-09_JPRB, 0.15372024E-09_JPRB, 0.15317851E-09_JPRB /)

RGHG8(:,34, 4) = (/ &
  & 0.14941261E-09_JPRB, 0.15045479E-09_JPRB, 0.15104820E-09_JPRB, 0.15160437E-09_JPRB, 0.15215756E-09_JPRB, 0.15274638E-09_JPRB, &
  & 0.15337266E-09_JPRB, 0.15403075E-09_JPRB, 0.15472700E-09_JPRB, 0.15547237E-09_JPRB, 0.15627807E-09_JPRB, 0.15714800E-09_JPRB, &
  & 0.15807093E-09_JPRB, 0.15902824E-09_JPRB, 0.15999271E-09_JPRB, 0.16093710E-09_JPRB, 0.16183618E-09_JPRB, 0.16267103E-09_JPRB, &
  & 0.16342697E-09_JPRB, 0.16410256E-09_JPRB, 0.16469229E-09_JPRB, 0.16519863E-09_JPRB, 0.16563080E-09_JPRB, 0.16598733E-09_JPRB, &
  & 0.16628038E-09_JPRB, 0.16651429E-09_JPRB, 0.16669810E-09_JPRB, 0.16684154E-09_JPRB, 0.16694512E-09_JPRB, 0.16701326E-09_JPRB, &
  & 0.16704887E-09_JPRB, 0.16705251E-09_JPRB, 0.16702378E-09_JPRB, 0.16696056E-09_JPRB, 0.16686122E-09_JPRB, 0.16672690E-09_JPRB, &
  & 0.16656000E-09_JPRB, 0.16636427E-09_JPRB, 0.16614105E-09_JPRB, 0.16588823E-09_JPRB, 0.16560375E-09_JPRB, 0.16528556E-09_JPRB, &
  & 0.16493325E-09_JPRB, 0.16454375E-09_JPRB, 0.16411546E-09_JPRB, 0.16365116E-09_JPRB, 0.16315639E-09_JPRB, 0.16263739E-09_JPRB, &
  & 0.16210330E-09_JPRB, 0.16155925E-09_JPRB, 0.16101243E-09_JPRB, 0.16047010E-09_JPRB, 0.15993379E-09_JPRB, 0.15940246E-09_JPRB, &
  & 0.15887007E-09_JPRB, 0.15832999E-09_JPRB, 0.15777823E-09_JPRB, 0.15722251E-09_JPRB, 0.15668231E-09_JPRB, 0.15618511E-09_JPRB, &
  & 0.15575304E-09_JPRB, 0.15537885E-09_JPRB, 0.15501724E-09_JPRB, 0.15448351E-09_JPRB /)

RGHG8(:,35, 4) = (/ &
  & 0.15074386E-09_JPRB, 0.15172844E-09_JPRB, 0.15232118E-09_JPRB, 0.15283555E-09_JPRB, 0.15336682E-09_JPRB, 0.15392015E-09_JPRB, &
  & 0.15450245E-09_JPRB, 0.15511360E-09_JPRB, 0.15575527E-09_JPRB, 0.15644167E-09_JPRB, 0.15718732E-09_JPRB, 0.15799781E-09_JPRB, &
  & 0.15886670E-09_JPRB, 0.15977367E-09_JPRB, 0.16069730E-09_JPRB, 0.16160831E-09_JPRB, 0.16247852E-09_JPRB, 0.16328702E-09_JPRB, &
  & 0.16401666E-09_JPRB, 0.16466686E-09_JPRB, 0.16523584E-09_JPRB, 0.16572255E-09_JPRB, 0.16613463E-09_JPRB, 0.16647318E-09_JPRB, &
  & 0.16674542E-09_JPRB, 0.16695988E-09_JPRB, 0.16712406E-09_JPRB, 0.16724779E-09_JPRB, 0.16733370E-09_JPRB, 0.16738549E-09_JPRB, &
  & 0.16740649E-09_JPRB, 0.16739832E-09_JPRB, 0.16736224E-09_JPRB, 0.16729823E-09_JPRB, 0.16720672E-09_JPRB, 0.16708890E-09_JPRB, &
  & 0.16694691E-09_JPRB, 0.16678212E-09_JPRB, 0.16659162E-09_JPRB, 0.16637099E-09_JPRB, 0.16611448E-09_JPRB, 0.16582194E-09_JPRB, &
  & 0.16549402E-09_JPRB, 0.16513083E-09_JPRB, 0.16473375E-09_JPRB, 0.16430478E-09_JPRB, 0.16384866E-09_JPRB, 0.16337041E-09_JPRB, &
  & 0.16287340E-09_JPRB, 0.16236643E-09_JPRB, 0.16185572E-09_JPRB, 0.16134812E-09_JPRB, 0.16084707E-09_JPRB, 0.16035104E-09_JPRB, &
  & 0.15985309E-09_JPRB, 0.15934629E-09_JPRB, 0.15882753E-09_JPRB, 0.15830270E-09_JPRB, 0.15779217E-09_JPRB, 0.15732238E-09_JPRB, &
  & 0.15691165E-09_JPRB, 0.15655330E-09_JPRB, 0.15620429E-09_JPRB, 0.15567987E-09_JPRB /)

RGHG8(:,36, 4) = (/ &
  & 0.15201362E-09_JPRB, 0.15296864E-09_JPRB, 0.15351843E-09_JPRB, 0.15401952E-09_JPRB, 0.15451870E-09_JPRB, 0.15503802E-09_JPRB, &
  & 0.15558116E-09_JPRB, 0.15614328E-09_JPRB, 0.15673231E-09_JPRB, 0.15736168E-09_JPRB, 0.15804578E-09_JPRB, 0.15879478E-09_JPRB, &
  & 0.15960640E-09_JPRB, 0.16046535E-09_JPRB, 0.16134441E-09_JPRB, 0.16221628E-09_JPRB, 0.16305152E-09_JPRB, 0.16383098E-09_JPRB, &
  & 0.16453527E-09_JPRB, 0.16516152E-09_JPRB, 0.16571003E-09_JPRB, 0.16617845E-09_JPRB, 0.16656991E-09_JPRB, 0.16688774E-09_JPRB, &
  & 0.16713687E-09_JPRB, 0.16732785E-09_JPRB, 0.16747033E-09_JPRB, 0.16757357E-09_JPRB, 0.16764282E-09_JPRB, 0.16768140E-09_JPRB, &
  & 0.16769267E-09_JPRB, 0.16767812E-09_JPRB, 0.16763997E-09_JPRB, 0.16757945E-09_JPRB, 0.16749797E-09_JPRB, 0.16739707E-09_JPRB, &
  & 0.16727784E-09_JPRB, 0.16713901E-09_JPRB, 0.16697614E-09_JPRB, 0.16678163E-09_JPRB, 0.16654882E-09_JPRB, 0.16627508E-09_JPRB, &
  & 0.16596431E-09_JPRB, 0.16562070E-09_JPRB, 0.16524747E-09_JPRB, 0.16484861E-09_JPRB, 0.16442478E-09_JPRB, 0.16397839E-09_JPRB, &
  & 0.16351517E-09_JPRB, 0.16303976E-09_JPRB, 0.16256124E-09_JPRB, 0.16208720E-09_JPRB, 0.16162113E-09_JPRB, 0.16116128E-09_JPRB, &
  & 0.16070069E-09_JPRB, 0.16023170E-09_JPRB, 0.15975010E-09_JPRB, 0.15926280E-09_JPRB, 0.15878755E-09_JPRB, 0.15834868E-09_JPRB, &
  & 0.15796346E-09_JPRB, 0.15762405E-09_JPRB, 0.15728836E-09_JPRB, 0.15677999E-09_JPRB /)

RGHG8(:,37, 4) = (/ &
  & 0.15324433E-09_JPRB, 0.15414506E-09_JPRB, 0.15467200E-09_JPRB, 0.15514415E-09_JPRB, 0.15562018E-09_JPRB, 0.15610889E-09_JPRB, &
  & 0.15661196E-09_JPRB, 0.15712778E-09_JPRB, 0.15766422E-09_JPRB, 0.15823647E-09_JPRB, 0.15886092E-09_JPRB, 0.15954857E-09_JPRB, &
  & 0.16030033E-09_JPRB, 0.16110439E-09_JPRB, 0.16193724E-09_JPRB, 0.16276724E-09_JPRB, 0.16356498E-09_JPRB, 0.16431038E-09_JPRB, &
  & 0.16498923E-09_JPRB, 0.16559376E-09_JPRB, 0.16612325E-09_JPRB, 0.16657281E-09_JPRB, 0.16694059E-09_JPRB, 0.16723030E-09_JPRB, &
  & 0.16744930E-09_JPRB, 0.16761119E-09_JPRB, 0.16772812E-09_JPRB, 0.16781049E-09_JPRB, 0.16786440E-09_JPRB, 0.16789267E-09_JPRB, &
  & 0.16789818E-09_JPRB, 0.16788157E-09_JPRB, 0.16784496E-09_JPRB, 0.16779039E-09_JPRB, 0.16772006E-09_JPRB, 0.16763516E-09_JPRB, &
  & 0.16753599E-09_JPRB, 0.16741972E-09_JPRB, 0.16728065E-09_JPRB, 0.16711063E-09_JPRB, 0.16690102E-09_JPRB, 0.16664770E-09_JPRB, &
  & 0.16635450E-09_JPRB, 0.16602798E-09_JPRB, 0.16567608E-09_JPRB, 0.16530072E-09_JPRB, 0.16490423E-09_JPRB, 0.16448705E-09_JPRB, &
  & 0.16405066E-09_JPRB, 0.16360252E-09_JPRB, 0.16315169E-09_JPRB, 0.16270740E-09_JPRB, 0.16227454E-09_JPRB, 0.16185088E-09_JPRB, &
  & 0.16142862E-09_JPRB, 0.16099956E-09_JPRB, 0.16055943E-09_JPRB, 0.16011303E-09_JPRB, 0.15967752E-09_JPRB, 0.15927432E-09_JPRB, &
  & 0.15891780E-09_JPRB, 0.15859974E-09_JPRB, 0.15828219E-09_JPRB, 0.15779289E-09_JPRB /)

RGHG8(:,38, 4) = (/ &
  & 0.15443316E-09_JPRB, 0.15526806E-09_JPRB, 0.15576898E-09_JPRB, 0.15621660E-09_JPRB, 0.15667312E-09_JPRB, 0.15713511E-09_JPRB, &
  & 0.15760122E-09_JPRB, 0.15807222E-09_JPRB, 0.15855711E-09_JPRB, 0.15907212E-09_JPRB, 0.15963551E-09_JPRB, 0.16026035E-09_JPRB, &
  & 0.16095196E-09_JPRB, 0.16170040E-09_JPRB, 0.16248169E-09_JPRB, 0.16326634E-09_JPRB, 0.16402346E-09_JPRB, 0.16473452E-09_JPRB, &
  & 0.16538589E-09_JPRB, 0.16596884E-09_JPRB, 0.16647597E-09_JPRB, 0.16690069E-09_JPRB, 0.16723667E-09_JPRB, 0.16748981E-09_JPRB, &
  & 0.16767328E-09_JPRB, 0.16780380E-09_JPRB, 0.16789663E-09_JPRB, 0.16796102E-09_JPRB, 0.16800313E-09_JPRB, 0.16802443E-09_JPRB, &
  & 0.16802688E-09_JPRB, 0.16801011E-09_JPRB, 0.16797594E-09_JPRB, 0.16792695E-09_JPRB, 0.16786558E-09_JPRB, 0.16779357E-09_JPRB, &
  & 0.16771028E-09_JPRB, 0.16761288E-09_JPRB, 0.16749534E-09_JPRB, 0.16734925E-09_JPRB, 0.16716481E-09_JPRB, 0.16693645E-09_JPRB, &
  & 0.16666522E-09_JPRB, 0.16636013E-09_JPRB, 0.16602882E-09_JPRB, 0.16567839E-09_JPRB, 0.16530763E-09_JPRB, 0.16491512E-09_JPRB, &
  & 0.16450256E-09_JPRB, 0.16407622E-09_JPRB, 0.16364807E-09_JPRB, 0.16322985E-09_JPRB, 0.16282738E-09_JPRB, 0.16243829E-09_JPRB, &
  & 0.16205431E-09_JPRB, 0.16166599E-09_JPRB, 0.16126843E-09_JPRB, 0.16086560E-09_JPRB, 0.16047268E-09_JPRB, 0.16010832E-09_JPRB, &
  & 0.15978377E-09_JPRB, 0.15949116E-09_JPRB, 0.15919406E-09_JPRB, 0.15873043E-09_JPRB /)

RGHG8(:,39, 4) = (/ &
  & 0.15556449E-09_JPRB, 0.15634846E-09_JPRB, 0.15680460E-09_JPRB, 0.15724158E-09_JPRB, 0.15767540E-09_JPRB, 0.15811752E-09_JPRB, &
  & 0.15855128E-09_JPRB, 0.15897841E-09_JPRB, 0.15941196E-09_JPRB, 0.15987119E-09_JPRB, 0.16037316E-09_JPRB, 0.16093500E-09_JPRB, &
  & 0.16156375E-09_JPRB, 0.16225343E-09_JPRB, 0.16298181E-09_JPRB, 0.16371872E-09_JPRB, 0.16443483E-09_JPRB, 0.16510975E-09_JPRB, &
  & 0.16573150E-09_JPRB, 0.16628873E-09_JPRB, 0.16676718E-09_JPRB, 0.16715582E-09_JPRB, 0.16745298E-09_JPRB, 0.16766757E-09_JPRB, &
  & 0.16781802E-09_JPRB, 0.16792326E-09_JPRB, 0.16799780E-09_JPRB, 0.16805007E-09_JPRB, 0.16808466E-09_JPRB, 0.16810188E-09_JPRB, &
  & 0.16810285E-09_JPRB, 0.16808629E-09_JPRB, 0.16805374E-09_JPRB, 0.16800826E-09_JPRB, 0.16795283E-09_JPRB, 0.16788917E-09_JPRB, &
  & 0.16781732E-09_JPRB, 0.16773423E-09_JPRB, 0.16763475E-09_JPRB, 0.16751056E-09_JPRB, 0.16735177E-09_JPRB, 0.16715021E-09_JPRB, &
  & 0.16690610E-09_JPRB, 0.16662527E-09_JPRB, 0.16632004E-09_JPRB, 0.16599447E-09_JPRB, 0.16564955E-09_JPRB, 0.16528157E-09_JPRB, &
  & 0.16488977E-09_JPRB, 0.16448137E-09_JPRB, 0.16407137E-09_JPRB, 0.16367498E-09_JPRB, 0.16329965E-09_JPRB, 0.16294301E-09_JPRB, &
  & 0.16259534E-09_JPRB, 0.16224697E-09_JPRB, 0.16189133E-09_JPRB, 0.16153243E-09_JPRB, 0.16118312E-09_JPRB, 0.16085955E-09_JPRB, &
  & 0.16056975E-09_JPRB, 0.16030473E-09_JPRB, 0.16003174E-09_JPRB, 0.15959872E-09_JPRB /)

RGHG8(:,40, 4) = (/ &
  & 0.15664919E-09_JPRB, 0.15735445E-09_JPRB, 0.15779733E-09_JPRB, 0.15820285E-09_JPRB, 0.15863263E-09_JPRB, 0.15905502E-09_JPRB, &
  & 0.15945864E-09_JPRB, 0.15984519E-09_JPRB, 0.16022952E-09_JPRB, 0.16063076E-09_JPRB, 0.16107279E-09_JPRB, 0.16157155E-09_JPRB, &
  & 0.16213861E-09_JPRB, 0.16276941E-09_JPRB, 0.16344323E-09_JPRB, 0.16413035E-09_JPRB, 0.16480264E-09_JPRB, 0.16544091E-09_JPRB, &
  & 0.16602897E-09_JPRB, 0.16655441E-09_JPRB, 0.16699744E-09_JPRB, 0.16734586E-09_JPRB, 0.16760308E-09_JPRB, 0.16778465E-09_JPRB, &
  & 0.16790989E-09_JPRB, 0.16799732E-09_JPRB, 0.16806001E-09_JPRB, 0.16810463E-09_JPRB, 0.16813478E-09_JPRB, 0.16814977E-09_JPRB, &
  & 0.16814984E-09_JPRB, 0.16813335E-09_JPRB, 0.16810156E-09_JPRB, 0.16805790E-09_JPRB, 0.16800578E-09_JPRB, 0.16794754E-09_JPRB, &
  & 0.16788301E-09_JPRB, 0.16781038E-09_JPRB, 0.16772475E-09_JPRB, 0.16761917E-09_JPRB, 0.16748387E-09_JPRB, 0.16731017E-09_JPRB, &
  & 0.16709437E-09_JPRB, 0.16684278E-09_JPRB, 0.16656397E-09_JPRB, 0.16626635E-09_JPRB, 0.16594720E-09_JPRB, 0.16560187E-09_JPRB, &
  & 0.16522882E-09_JPRB, 0.16483578E-09_JPRB, 0.16444011E-09_JPRB, 0.16406208E-09_JPRB, 0.16371093E-09_JPRB, 0.16338399E-09_JPRB, &
  & 0.16307045E-09_JPRB, 0.16275900E-09_JPRB, 0.16244349E-09_JPRB, 0.16212623E-09_JPRB, 0.16181986E-09_JPRB, 0.16153698E-09_JPRB, &
  & 0.16128260E-09_JPRB, 0.16104706E-09_JPRB, 0.16080007E-09_JPRB, 0.16040122E-09_JPRB /)

RGHG8(:,41, 4) = (/ &
  & 0.15766301E-09_JPRB, 0.15832013E-09_JPRB, 0.15872029E-09_JPRB, 0.15912321E-09_JPRB, 0.15953609E-09_JPRB, 0.15994692E-09_JPRB, &
  & 0.16032420E-09_JPRB, 0.16067109E-09_JPRB, 0.16100600E-09_JPRB, 0.16135342E-09_JPRB, 0.16173395E-09_JPRB, 0.16217074E-09_JPRB, &
  & 0.16267587E-09_JPRB, 0.16324822E-09_JPRB, 0.16386864E-09_JPRB, 0.16450780E-09_JPRB, 0.16513721E-09_JPRB, 0.16573681E-09_JPRB, &
  & 0.16628980E-09_JPRB, 0.16677565E-09_JPRB, 0.16717880E-09_JPRB, 0.16748716E-09_JPRB, 0.16770971E-09_JPRB, 0.16786483E-09_JPRB, &
  & 0.16797180E-09_JPRB, 0.16804705E-09_JPRB, 0.16810175E-09_JPRB, 0.16814163E-09_JPRB, 0.16816903E-09_JPRB, 0.16818272E-09_JPRB, &
  & 0.16818225E-09_JPRB, 0.16816562E-09_JPRB, 0.16813394E-09_JPRB, 0.16809107E-09_JPRB, 0.16804091E-09_JPRB, 0.16798571E-09_JPRB, &
  & 0.16792644E-09_JPRB, 0.16786111E-09_JPRB, 0.16778631E-09_JPRB, 0.16769601E-09_JPRB, 0.16758177E-09_JPRB, 0.16743464E-09_JPRB, &
  & 0.16724952E-09_JPRB, 0.16702732E-09_JPRB, 0.16677820E-09_JPRB, 0.16650682E-09_JPRB, 0.16621282E-09_JPRB, 0.16588998E-09_JPRB, &
  & 0.16553475E-09_JPRB, 0.16515463E-09_JPRB, 0.16477168E-09_JPRB, 0.16440938E-09_JPRB, 0.16408053E-09_JPRB, 0.16378060E-09_JPRB, &
  & 0.16349798E-09_JPRB, 0.16322041E-09_JPRB, 0.16294101E-09_JPRB, 0.16266269E-09_JPRB, 0.16239619E-09_JPRB, 0.16215222E-09_JPRB, &
  & 0.16193209E-09_JPRB, 0.16172559E-09_JPRB, 0.16150474E-09_JPRB, 0.16114211E-09_JPRB /)

RGHG8(:,42, 4) = (/ &
  & 0.15862213E-09_JPRB, 0.15922366E-09_JPRB, 0.15960770E-09_JPRB, 0.15998770E-09_JPRB, 0.16039885E-09_JPRB, 0.16079579E-09_JPRB, &
  & 0.16114668E-09_JPRB, 0.16145635E-09_JPRB, 0.16174538E-09_JPRB, 0.16203838E-09_JPRB, 0.16236162E-09_JPRB, 0.16273698E-09_JPRB, &
  & 0.16318216E-09_JPRB, 0.16369751E-09_JPRB, 0.16426555E-09_JPRB, 0.16485763E-09_JPRB, 0.16544541E-09_JPRB, 0.16600643E-09_JPRB, &
  & 0.16652010E-09_JPRB, 0.16696582E-09_JPRB, 0.16732535E-09_JPRB, 0.16759635E-09_JPRB, 0.16778917E-09_JPRB, 0.16792369E-09_JPRB, &
  & 0.16801707E-09_JPRB, 0.16808359E-09_JPRB, 0.16813294E-09_JPRB, 0.16816952E-09_JPRB, 0.16819521E-09_JPRB, 0.16820810E-09_JPRB, &
  & 0.16820720E-09_JPRB, 0.16819025E-09_JPRB, 0.16815840E-09_JPRB, 0.16811567E-09_JPRB, 0.16806623E-09_JPRB, 0.16801317E-09_JPRB, &
  & 0.16795729E-09_JPRB, 0.16789760E-09_JPRB, 0.16783119E-09_JPRB, 0.16775367E-09_JPRB, 0.16765825E-09_JPRB, 0.16753698E-09_JPRB, &
  & 0.16738262E-09_JPRB, 0.16719398E-09_JPRB, 0.16697423E-09_JPRB, 0.16673125E-09_JPRB, 0.16646184E-09_JPRB, 0.16615967E-09_JPRB, &
  & 0.16582108E-09_JPRB, 0.16545408E-09_JPRB, 0.16508195E-09_JPRB, 0.16473573E-09_JPRB, 0.16442750E-09_JPRB, 0.16415308E-09_JPRB, &
  & 0.16389828E-09_JPRB, 0.16365073E-09_JPRB, 0.16340344E-09_JPRB, 0.16315929E-09_JPRB, 0.16292878E-09_JPRB, 0.16271952E-09_JPRB, &
  & 0.16253082E-09_JPRB, 0.16235151E-09_JPRB, 0.16215625E-09_JPRB, 0.16182879E-09_JPRB /)

RGHG8(:,43, 4) = (/ &
  & 0.15953167E-09_JPRB, 0.16008880E-09_JPRB, 0.16044946E-09_JPRB, 0.16081816E-09_JPRB, 0.16122007E-09_JPRB, 0.16160324E-09_JPRB, &
  & 0.16193072E-09_JPRB, 0.16220364E-09_JPRB, 0.16244980E-09_JPRB, 0.16269358E-09_JPRB, 0.16296106E-09_JPRB, 0.16327797E-09_JPRB, &
  & 0.16366419E-09_JPRB, 0.16412527E-09_JPRB, 0.16464416E-09_JPRB, 0.16519144E-09_JPRB, 0.16573788E-09_JPRB, 0.16625955E-09_JPRB, &
  & 0.16673156E-09_JPRB, 0.16713204E-09_JPRB, 0.16744867E-09_JPRB, 0.16768407E-09_JPRB, 0.16785165E-09_JPRB, 0.16796958E-09_JPRB, &
  & 0.16805249E-09_JPRB, 0.16811273E-09_JPRB, 0.16815811E-09_JPRB, 0.16819260E-09_JPRB, 0.16821708E-09_JPRB, 0.16822944E-09_JPRB, &
  & 0.16822810E-09_JPRB, 0.16821075E-09_JPRB, 0.16817844E-09_JPRB, 0.16813538E-09_JPRB, 0.16808620E-09_JPRB, 0.16803406E-09_JPRB, &
  & 0.16798068E-09_JPRB, 0.16792515E-09_JPRB, 0.16786571E-09_JPRB, 0.16779922E-09_JPRB, 0.16772077E-09_JPRB, 0.16762396E-09_JPRB, &
  & 0.16750183E-09_JPRB, 0.16734833E-09_JPRB, 0.16716416E-09_JPRB, 0.16694945E-09_JPRB, 0.16670552E-09_JPRB, 0.16642432E-09_JPRB, &
  & 0.16610217E-09_JPRB, 0.16574732E-09_JPRB, 0.16538867E-09_JPRB, 0.16505819E-09_JPRB, 0.16477111E-09_JPRB, 0.16452018E-09_JPRB, &
  & 0.16429072E-09_JPRB, 0.16406927E-09_JPRB, 0.16384955E-09_JPRB, 0.16363477E-09_JPRB, 0.16343477E-09_JPRB, 0.16325545E-09_JPRB, &
  & 0.16309402E-09_JPRB, 0.16293905E-09_JPRB, 0.16276709E-09_JPRB, 0.16247333E-09_JPRB /)

RGHG8(:,44, 4) = (/ &
  & 0.16039495E-09_JPRB, 0.16092060E-09_JPRB, 0.16125784E-09_JPRB, 0.16161533E-09_JPRB, 0.16200440E-09_JPRB, 0.16237645E-09_JPRB, &
  & 0.16267654E-09_JPRB, 0.16291886E-09_JPRB, 0.16312462E-09_JPRB, 0.16332496E-09_JPRB, 0.16354251E-09_JPRB, 0.16380489E-09_JPRB, &
  & 0.16413591E-09_JPRB, 0.16454499E-09_JPRB, 0.16501747E-09_JPRB, 0.16552221E-09_JPRB, 0.16602821E-09_JPRB, 0.16650548E-09_JPRB, &
  & 0.16693096E-09_JPRB, 0.16728161E-09_JPRB, 0.16755466E-09_JPRB, 0.16775688E-09_JPRB, 0.16790261E-09_JPRB, 0.16800678E-09_JPRB, &
  & 0.16808163E-09_JPRB, 0.16813712E-09_JPRB, 0.16817982E-09_JPRB, 0.16821279E-09_JPRB, 0.16823659E-09_JPRB, 0.16824854E-09_JPRB, &
  & 0.16824678E-09_JPRB, 0.16822890E-09_JPRB, 0.16819594E-09_JPRB, 0.16815231E-09_JPRB, 0.16810260E-09_JPRB, 0.16805086E-09_JPRB, &
  & 0.16799895E-09_JPRB, 0.16794670E-09_JPRB, 0.16789310E-09_JPRB, 0.16783624E-09_JPRB, 0.16777332E-09_JPRB, 0.16770001E-09_JPRB, &
  & 0.16760976E-09_JPRB, 0.16749604E-09_JPRB, 0.16735049E-09_JPRB, 0.16717280E-09_JPRB, 0.16695639E-09_JPRB, 0.16669720E-09_JPRB, &
  & 0.16639173E-09_JPRB, 0.16605103E-09_JPRB, 0.16570587E-09_JPRB, 0.16539360E-09_JPRB, 0.16512734E-09_JPRB, 0.16489868E-09_JPRB, &
  & 0.16469121E-09_JPRB, 0.16449234E-09_JPRB, 0.16429566E-09_JPRB, 0.16410512E-09_JPRB, 0.16393013E-09_JPRB, 0.16377531E-09_JPRB, &
  & 0.16363649E-09_JPRB, 0.16350243E-09_JPRB, 0.16335139E-09_JPRB, 0.16308901E-09_JPRB /)

RGHG8(:,45, 4) = (/ &
  & 0.16122093E-09_JPRB, 0.16171134E-09_JPRB, 0.16203765E-09_JPRB, 0.16237711E-09_JPRB, 0.16275994E-09_JPRB, 0.16311413E-09_JPRB, &
  & 0.16339347E-09_JPRB, 0.16360349E-09_JPRB, 0.16377777E-09_JPRB, 0.16393933E-09_JPRB, 0.16411572E-09_JPRB, 0.16432918E-09_JPRB, &
  & 0.16460895E-09_JPRB, 0.16496984E-09_JPRB, 0.16539897E-09_JPRB, 0.16586325E-09_JPRB, 0.16632359E-09_JPRB, 0.16675317E-09_JPRB, &
  & 0.16711998E-09_JPRB, 0.16741787E-09_JPRB, 0.16764630E-09_JPRB, 0.16781837E-09_JPRB, 0.16794477E-09_JPRB, 0.16803778E-09_JPRB, &
  & 0.16810614E-09_JPRB, 0.16815824E-09_JPRB, 0.16819909E-09_JPRB, 0.16823126E-09_JPRB, 0.16825470E-09_JPRB, 0.16826632E-09_JPRB, &
  & 0.16826404E-09_JPRB, 0.16824547E-09_JPRB, 0.16821179E-09_JPRB, 0.16816716E-09_JPRB, 0.16811660E-09_JPRB, 0.16806451E-09_JPRB, &
  & 0.16801346E-09_JPRB, 0.16796371E-09_JPRB, 0.16791510E-09_JPRB, 0.16786690E-09_JPRB, 0.16781818E-09_JPRB, 0.16776662E-09_JPRB, &
  & 0.16770810E-09_JPRB, 0.16763378E-09_JPRB, 0.16753572E-09_JPRB, 0.16739954E-09_JPRB, 0.16722058E-09_JPRB, 0.16698794E-09_JPRB, &
  & 0.16670137E-09_JPRB, 0.16637501E-09_JPRB, 0.16604604E-09_JPRB, 0.16575262E-09_JPRB, 0.16550744E-09_JPRB, 0.16529862E-09_JPRB, &
  & 0.16511137E-09_JPRB, 0.16493118E-09_JPRB, 0.16475368E-09_JPRB, 0.16458265E-09_JPRB, 0.16442765E-09_JPRB, 0.16429222E-09_JPRB, &
  & 0.16417176E-09_JPRB, 0.16405488E-09_JPRB, 0.16392238E-09_JPRB, 0.16368878E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART7',1,ZHOOK_HANDLE)
END SUBROUTINE PART7




SUBROUTINE PART8
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART8',0,ZHOOK_HANDLE)



RGHG8(:,46, 4) = (/ &
  & 0.16200262E-09_JPRB, 0.16246875E-09_JPRB, 0.16278083E-09_JPRB, 0.16311220E-09_JPRB, 0.16348273E-09_JPRB, 0.16382382E-09_JPRB, &
  & 0.16407944E-09_JPRB, 0.16426509E-09_JPRB, 0.16441017E-09_JPRB, 0.16454429E-09_JPRB, 0.16468517E-09_JPRB, 0.16486153E-09_JPRB, &
  & 0.16509623E-09_JPRB, 0.16541235E-09_JPRB, 0.16580178E-09_JPRB, 0.16622104E-09_JPRB, 0.16663315E-09_JPRB, 0.16699642E-09_JPRB, &
  & 0.16730094E-09_JPRB, 0.16753925E-09_JPRB, 0.16772628E-09_JPRB, 0.16787016E-09_JPRB, 0.16798024E-09_JPRB, 0.16806377E-09_JPRB, &
  & 0.16812715E-09_JPRB, 0.16817685E-09_JPRB, 0.16821655E-09_JPRB, 0.16824854E-09_JPRB, 0.16827187E-09_JPRB, 0.16828321E-09_JPRB, &
  & 0.16828033E-09_JPRB, 0.16826106E-09_JPRB, 0.16822629E-09_JPRB, 0.16818059E-09_JPRB, 0.16812859E-09_JPRB, 0.16807573E-09_JPRB, &
  & 0.16802490E-09_JPRB, 0.16797716E-09_JPRB, 0.16793290E-09_JPRB, 0.16789257E-09_JPRB, 0.16785673E-09_JPRB, 0.16782531E-09_JPRB, &
  & 0.16779517E-09_JPRB, 0.16776019E-09_JPRB, 0.16770743E-09_JPRB, 0.16762422E-09_JPRB, 0.16749051E-09_JPRB, 0.16729655E-09_JPRB, &
  & 0.16703587E-09_JPRB, 0.16672752E-09_JPRB, 0.16641502E-09_JPRB, 0.16614174E-09_JPRB, 0.16591582E-09_JPRB, 0.16572714E-09_JPRB, &
  & 0.16555583E-09_JPRB, 0.16539266E-09_JPRB, 0.16523051E-09_JPRB, 0.16507531E-09_JPRB, 0.16493587E-09_JPRB, 0.16481573E-09_JPRB, &
  & 0.16470955E-09_JPRB, 0.16460719E-09_JPRB, 0.16449006E-09_JPRB, 0.16428332E-09_JPRB /)

RGHG8(:,47, 4) = (/ &
  & 0.16273341E-09_JPRB, 0.16319186E-09_JPRB, 0.16348886E-09_JPRB, 0.16381788E-09_JPRB, 0.16417728E-09_JPRB, 0.16450533E-09_JPRB, &
  & 0.16474158E-09_JPRB, 0.16490470E-09_JPRB, 0.16503032E-09_JPRB, 0.16514029E-09_JPRB, 0.16525936E-09_JPRB, 0.16540300E-09_JPRB, &
  & 0.16560465E-09_JPRB, 0.16588293E-09_JPRB, 0.16622843E-09_JPRB, 0.16660091E-09_JPRB, 0.16694257E-09_JPRB, 0.16723399E-09_JPRB, &
  & 0.16746358E-09_JPRB, 0.16764762E-09_JPRB, 0.16779447E-09_JPRB, 0.16791422E-09_JPRB, 0.16800997E-09_JPRB, 0.16808593E-09_JPRB, &
  & 0.16814544E-09_JPRB, 0.16819343E-09_JPRB, 0.16823277E-09_JPRB, 0.16826496E-09_JPRB, 0.16828845E-09_JPRB, 0.16829958E-09_JPRB, &
  & 0.16829610E-09_JPRB, 0.16827580E-09_JPRB, 0.16824001E-09_JPRB, 0.16819267E-09_JPRB, 0.16813904E-09_JPRB, 0.16808503E-09_JPRB, &
  & 0.16803406E-09_JPRB, 0.16798790E-09_JPRB, 0.16794754E-09_JPRB, 0.16791432E-09_JPRB, 0.16789024E-09_JPRB, 0.16787642E-09_JPRB, &
  & 0.16787148E-09_JPRB, 0.16786905E-09_JPRB, 0.16785895E-09_JPRB, 0.16782370E-09_JPRB, 0.16774590E-09_JPRB, 0.16760346E-09_JPRB, &
  & 0.16738581E-09_JPRB, 0.16710497E-09_JPRB, 0.16681473E-09_JPRB, 0.16656213E-09_JPRB, 0.16635762E-09_JPRB, 0.16618465E-09_JPRB, &
  & 0.16603047E-09_JPRB, 0.16587981E-09_JPRB, 0.16573112E-09_JPRB, 0.16558803E-09_JPRB, 0.16546089E-09_JPRB, 0.16535234E-09_JPRB, &
  & 0.16525764E-09_JPRB, 0.16516631E-09_JPRB, 0.16506249E-09_JPRB, 0.16487782E-09_JPRB /)

RGHG8(:,48, 4) = (/ &
  & 0.16342810E-09_JPRB, 0.16386535E-09_JPRB, 0.16417447E-09_JPRB, 0.16448967E-09_JPRB, 0.16485298E-09_JPRB, 0.16516627E-09_JPRB, &
  & 0.16538768E-09_JPRB, 0.16553559E-09_JPRB, 0.16564448E-09_JPRB, 0.16574087E-09_JPRB, 0.16583955E-09_JPRB, 0.16596517E-09_JPRB, &
  & 0.16613561E-09_JPRB, 0.16637741E-09_JPRB, 0.16667702E-09_JPRB, 0.16697646E-09_JPRB, 0.16723804E-09_JPRB, 0.16744384E-09_JPRB, &
  & 0.16760723E-09_JPRB, 0.16773941E-09_JPRB, 0.16785300E-09_JPRB, 0.16795124E-09_JPRB, 0.16803520E-09_JPRB, 0.16810496E-09_JPRB, &
  & 0.16816169E-09_JPRB, 0.16820881E-09_JPRB, 0.16824805E-09_JPRB, 0.16828081E-09_JPRB, 0.16830458E-09_JPRB, 0.16831556E-09_JPRB, &
  & 0.16831139E-09_JPRB, 0.16829005E-09_JPRB, 0.16825281E-09_JPRB, 0.16820373E-09_JPRB, 0.16814829E-09_JPRB, 0.16809273E-09_JPRB, &
  & 0.16804151E-09_JPRB, 0.16799664E-09_JPRB, 0.16795976E-09_JPRB, 0.16793304E-09_JPRB, 0.16791947E-09_JPRB, 0.16792114E-09_JPRB, &
  & 0.16793689E-09_JPRB, 0.16796065E-09_JPRB, 0.16798218E-09_JPRB, 0.16798765E-09_JPRB, 0.16795884E-09_JPRB, 0.16787649E-09_JPRB, &
  & 0.16771812E-09_JPRB, 0.16748933E-09_JPRB, 0.16723714E-09_JPRB, 0.16701363E-09_JPRB, 0.16683066E-09_JPRB, 0.16667645E-09_JPRB, &
  & 0.16653470E-09_JPRB, 0.16639692E-09_JPRB, 0.16625772E-09_JPRB, 0.16612448E-09_JPRB, 0.16600629E-09_JPRB, 0.16590684E-09_JPRB, &
  & 0.16582027E-09_JPRB, 0.16573762E-09_JPRB, 0.16564324E-09_JPRB, 0.16547638E-09_JPRB /)

RGHG8(:,49, 4) = (/ &
  & 0.16407345E-09_JPRB, 0.16452217E-09_JPRB, 0.16482241E-09_JPRB, 0.16515392E-09_JPRB, 0.16550949E-09_JPRB, 0.16582079E-09_JPRB, &
  & 0.16603000E-09_JPRB, 0.16616641E-09_JPRB, 0.16626495E-09_JPRB, 0.16634832E-09_JPRB, 0.16643525E-09_JPRB, 0.16653791E-09_JPRB, &
  & 0.16668385E-09_JPRB, 0.16687698E-09_JPRB, 0.16710403E-09_JPRB, 0.16731722E-09_JPRB, 0.16748797E-09_JPRB, 0.16761997E-09_JPRB, &
  & 0.16772539E-09_JPRB, 0.16781732E-09_JPRB, 0.16790219E-09_JPRB, 0.16798282E-09_JPRB, 0.16805667E-09_JPRB, 0.16812170E-09_JPRB, &
  & 0.16817664E-09_JPRB, 0.16822335E-09_JPRB, 0.16826301E-09_JPRB, 0.16829639E-09_JPRB, 0.16832041E-09_JPRB, 0.16833139E-09_JPRB, &
  & 0.16832649E-09_JPRB, 0.16830394E-09_JPRB, 0.16826512E-09_JPRB, 0.16821401E-09_JPRB, 0.16815645E-09_JPRB, 0.16809949E-09_JPRB, &
  & 0.16804770E-09_JPRB, 0.16800383E-09_JPRB, 0.16797003E-09_JPRB, 0.16794921E-09_JPRB, 0.16794527E-09_JPRB, 0.16796067E-09_JPRB, &
  & 0.16799333E-09_JPRB, 0.16803692E-09_JPRB, 0.16808038E-09_JPRB, 0.16811308E-09_JPRB, 0.16812188E-09_JPRB, 0.16808976E-09_JPRB, &
  & 0.16799871E-09_JPRB, 0.16784238E-09_JPRB, 0.16765327E-09_JPRB, 0.16747805E-09_JPRB, 0.16732589E-09_JPRB, 0.16719345E-09_JPRB, &
  & 0.16706732E-09_JPRB, 0.16694046E-09_JPRB, 0.16681055E-09_JPRB, 0.16668453E-09_JPRB, 0.16657345E-09_JPRB, 0.16648015E-09_JPRB, &
  & 0.16639985E-09_JPRB, 0.16632304E-09_JPRB, 0.16623505E-09_JPRB, 0.16608026E-09_JPRB /)

RGHG8(:,50, 4) = (/ &
  & 0.16468205E-09_JPRB, 0.16515014E-09_JPRB, 0.16545738E-09_JPRB, 0.16579799E-09_JPRB, 0.16616086E-09_JPRB, 0.16646533E-09_JPRB, &
  & 0.16666341E-09_JPRB, 0.16678720E-09_JPRB, 0.16687325E-09_JPRB, 0.16694301E-09_JPRB, 0.16701068E-09_JPRB, 0.16709176E-09_JPRB, &
  & 0.16719026E-09_JPRB, 0.16732347E-09_JPRB, 0.16746293E-09_JPRB, 0.16758737E-09_JPRB, 0.16768334E-09_JPRB, 0.16775822E-09_JPRB, &
  & 0.16782165E-09_JPRB, 0.16788214E-09_JPRB, 0.16794457E-09_JPRB, 0.16800972E-09_JPRB, 0.16807533E-09_JPRB, 0.16813673E-09_JPRB, &
  & 0.16819077E-09_JPRB, 0.16823769E-09_JPRB, 0.16827804E-09_JPRB, 0.16831203E-09_JPRB, 0.16833633E-09_JPRB, 0.16834724E-09_JPRB, &
  & 0.16834151E-09_JPRB, 0.16831775E-09_JPRB, 0.16827720E-09_JPRB, 0.16822380E-09_JPRB, 0.16816419E-09_JPRB, 0.16810542E-09_JPRB, &
  & 0.16805306E-09_JPRB, 0.16800981E-09_JPRB, 0.16797869E-09_JPRB, 0.16796328E-09_JPRB, 0.16796840E-09_JPRB, 0.16799633E-09_JPRB, &
  & 0.16804361E-09_JPRB, 0.16810074E-09_JPRB, 0.16815965E-09_JPRB, 0.16820875E-09_JPRB, 0.16824178E-09_JPRB, 0.16824683E-09_JPRB, &
  & 0.16820959E-09_JPRB, 0.16812408E-09_JPRB, 0.16801377E-09_JPRB, 0.16789969E-09_JPRB, 0.16779697E-09_JPRB, 0.16769634E-09_JPRB, &
  & 0.16759646E-09_JPRB, 0.16748819E-09_JPRB, 0.16737270E-09_JPRB, 0.16725678E-09_JPRB, 0.16715324E-09_JPRB, 0.16706628E-09_JPRB, &
  & 0.16699082E-09_JPRB, 0.16691794E-09_JPRB, 0.16683499E-09_JPRB, 0.16668586E-09_JPRB /)

RGHG8(:,51, 4) = (/ &
  & 0.16528449E-09_JPRB, 0.16573411E-09_JPRB, 0.16608526E-09_JPRB, 0.16641494E-09_JPRB, 0.16678581E-09_JPRB, 0.16706708E-09_JPRB, &
  & 0.16723917E-09_JPRB, 0.16733923E-09_JPRB, 0.16740279E-09_JPRB, 0.16745133E-09_JPRB, 0.16749505E-09_JPRB, 0.16753948E-09_JPRB, &
  & 0.16759751E-09_JPRB, 0.16766022E-09_JPRB, 0.16772961E-09_JPRB, 0.16778626E-09_JPRB, 0.16783039E-09_JPRB, 0.16786610E-09_JPRB, &
  & 0.16790017E-09_JPRB, 0.16793748E-09_JPRB, 0.16798150E-09_JPRB, 0.16803406E-09_JPRB, 0.16809201E-09_JPRB, 0.16815081E-09_JPRB, &
  & 0.16820466E-09_JPRB, 0.16825247E-09_JPRB, 0.16829360E-09_JPRB, 0.16832818E-09_JPRB, 0.16835267E-09_JPRB, 0.16836334E-09_JPRB, &
  & 0.16835679E-09_JPRB, 0.16833165E-09_JPRB, 0.16828913E-09_JPRB, 0.16823333E-09_JPRB, 0.16817148E-09_JPRB, 0.16811100E-09_JPRB, &
  & 0.16805775E-09_JPRB, 0.16801485E-09_JPRB, 0.16798600E-09_JPRB, 0.16797568E-09_JPRB, 0.16798955E-09_JPRB, 0.16802926E-09_JPRB, &
  & 0.16808829E-09_JPRB, 0.16815722E-09_JPRB, 0.16822377E-09_JPRB, 0.16828547E-09_JPRB, 0.16833292E-09_JPRB, 0.16836216E-09_JPRB, &
  & 0.16836187E-09_JPRB, 0.16833034E-09_JPRB, 0.16827889E-09_JPRB, 0.16822554E-09_JPRB, 0.16816991E-09_JPRB, 0.16811419E-09_JPRB, &
  & 0.16805077E-09_JPRB, 0.16797731E-09_JPRB, 0.16789027E-09_JPRB, 0.16779733E-09_JPRB, 0.16770982E-09_JPRB, 0.16763349E-09_JPRB, &
  & 0.16756600E-09_JPRB, 0.16749996E-09_JPRB, 0.16742023E-09_JPRB, 0.16728073E-09_JPRB /)

RGHG8(:,52, 4) = (/ &
  & 0.16581300E-09_JPRB, 0.16634399E-09_JPRB, 0.16663924E-09_JPRB, 0.16700637E-09_JPRB, 0.16732385E-09_JPRB, 0.16756004E-09_JPRB, &
  & 0.16768453E-09_JPRB, 0.16774995E-09_JPRB, 0.16778876E-09_JPRB, 0.16781448E-09_JPRB, 0.16783511E-09_JPRB, 0.16785548E-09_JPRB, &
  & 0.16787458E-09_JPRB, 0.16789790E-09_JPRB, 0.16791742E-09_JPRB, 0.16793236E-09_JPRB, 0.16794252E-09_JPRB, 0.16795243E-09_JPRB, &
  & 0.16796572E-09_JPRB, 0.16798576E-09_JPRB, 0.16801535E-09_JPRB, 0.16805626E-09_JPRB, 0.16810803E-09_JPRB, 0.16816451E-09_JPRB, &
  & 0.16821874E-09_JPRB, 0.16826773E-09_JPRB, 0.16830995E-09_JPRB, 0.16834514E-09_JPRB, 0.16836964E-09_JPRB, 0.16837992E-09_JPRB, &
  & 0.16837243E-09_JPRB, 0.16834581E-09_JPRB, 0.16830123E-09_JPRB, 0.16824295E-09_JPRB, 0.16817875E-09_JPRB, 0.16811641E-09_JPRB, &
  & 0.16806209E-09_JPRB, 0.16801933E-09_JPRB, 0.16799251E-09_JPRB, 0.16798701E-09_JPRB, 0.16800906E-09_JPRB, 0.16805958E-09_JPRB, &
  & 0.16812937E-09_JPRB, 0.16820499E-09_JPRB, 0.16828117E-09_JPRB, 0.16834786E-09_JPRB, 0.16840757E-09_JPRB, 0.16845141E-09_JPRB, &
  & 0.16847403E-09_JPRB, 0.16847412E-09_JPRB, 0.16846050E-09_JPRB, 0.16844147E-09_JPRB, 0.16842099E-09_JPRB, 0.16839735E-09_JPRB, &
  & 0.16836882E-09_JPRB, 0.16833157E-09_JPRB, 0.16828267E-09_JPRB, 0.16822407E-09_JPRB, 0.16816452E-09_JPRB, 0.16811012E-09_JPRB, &
  & 0.16805929E-09_JPRB, 0.16800600E-09_JPRB, 0.16794176E-09_JPRB, 0.16781347E-09_JPRB /)

RGHG8(:,53, 4) = (/ &
  & 0.16636714E-09_JPRB, 0.16682088E-09_JPRB, 0.16719126E-09_JPRB, 0.16746729E-09_JPRB, 0.16774521E-09_JPRB, 0.16790500E-09_JPRB, &
  & 0.16798307E-09_JPRB, 0.16802015E-09_JPRB, 0.16803930E-09_JPRB, 0.16805088E-09_JPRB, 0.16805825E-09_JPRB, 0.16806259E-09_JPRB, &
  & 0.16806465E-09_JPRB, 0.16806292E-09_JPRB, 0.16805565E-09_JPRB, 0.16804455E-09_JPRB, 0.16803270E-09_JPRB, 0.16802443E-09_JPRB, &
  & 0.16802250E-09_JPRB, 0.16802915E-09_JPRB, 0.16804680E-09_JPRB, 0.16807847E-09_JPRB, 0.16812385E-09_JPRB, 0.16817857E-09_JPRB, &
  & 0.16823351E-09_JPRB, 0.16828380E-09_JPRB, 0.16832731E-09_JPRB, 0.16836300E-09_JPRB, 0.16838755E-09_JPRB, 0.16839724E-09_JPRB, &
  & 0.16838861E-09_JPRB, 0.16836038E-09_JPRB, 0.16831361E-09_JPRB, 0.16825272E-09_JPRB, 0.16818612E-09_JPRB, 0.16812179E-09_JPRB, &
  & 0.16806634E-09_JPRB, 0.16802365E-09_JPRB, 0.16799881E-09_JPRB, 0.16799780E-09_JPRB, 0.16802738E-09_JPRB, 0.16808682E-09_JPRB, &
  & 0.16816486E-09_JPRB, 0.16824961E-09_JPRB, 0.16832899E-09_JPRB, 0.16840526E-09_JPRB, 0.16847049E-09_JPRB, 0.16852553E-09_JPRB, &
  & 0.16856176E-09_JPRB, 0.16857836E-09_JPRB, 0.16858287E-09_JPRB, 0.16858173E-09_JPRB, 0.16857771E-09_JPRB, 0.16857137E-09_JPRB, &
  & 0.16856203E-09_JPRB, 0.16854747E-09_JPRB, 0.16852601E-09_JPRB, 0.16849741E-09_JPRB, 0.16846619E-09_JPRB, 0.16843547E-09_JPRB, &
  & 0.16840596E-09_JPRB, 0.16837390E-09_JPRB, 0.16832884E-09_JPRB, 0.16823842E-09_JPRB /)

RGHG8(:,54, 4) = (/ &
  & 0.16680009E-09_JPRB, 0.16733027E-09_JPRB, 0.16758009E-09_JPRB, 0.16784822E-09_JPRB, 0.16802831E-09_JPRB, 0.16813329E-09_JPRB, &
  & 0.16817725E-09_JPRB, 0.16819623E-09_JPRB, 0.16820502E-09_JPRB, 0.16820884E-09_JPRB, 0.16820961E-09_JPRB, 0.16820711E-09_JPRB, &
  & 0.16820098E-09_JPRB, 0.16818602E-09_JPRB, 0.16816509E-09_JPRB, 0.16813713E-09_JPRB, 0.16810989E-09_JPRB, 0.16808756E-09_JPRB, &
  & 0.16807325E-09_JPRB, 0.16806881E-09_JPRB, 0.16807679E-09_JPRB, 0.16810019E-09_JPRB, 0.16814095E-09_JPRB, 0.16819354E-09_JPRB, &
  & 0.16824907E-09_JPRB, 0.16830071E-09_JPRB, 0.16834559E-09_JPRB, 0.16838207E-09_JPRB, 0.16840647E-09_JPRB, 0.16841552E-09_JPRB, &
  & 0.16840571E-09_JPRB, 0.16837551E-09_JPRB, 0.16832649E-09_JPRB, 0.16826290E-09_JPRB, 0.16819381E-09_JPRB, 0.16812760E-09_JPRB, &
  & 0.16807085E-09_JPRB, 0.16802844E-09_JPRB, 0.16800562E-09_JPRB, 0.16800886E-09_JPRB, 0.16804430E-09_JPRB, 0.16811107E-09_JPRB, &
  & 0.16819679E-09_JPRB, 0.16828638E-09_JPRB, 0.16837533E-09_JPRB, 0.16845486E-09_JPRB, 0.16852945E-09_JPRB, 0.16859046E-09_JPRB, &
  & 0.16863361E-09_JPRB, 0.16865878E-09_JPRB, 0.16867079E-09_JPRB, 0.16867702E-09_JPRB, 0.16868003E-09_JPRB, 0.16868110E-09_JPRB, &
  & 0.16868024E-09_JPRB, 0.16867693E-09_JPRB, 0.16866977E-09_JPRB, 0.16865867E-09_JPRB, 0.16864514E-09_JPRB, 0.16863175E-09_JPRB, &
  & 0.16861824E-09_JPRB, 0.16860316E-09_JPRB, 0.16858351E-09_JPRB, 0.16854010E-09_JPRB /)

RGHG8(:,55, 4) = (/ &
  & 0.16724899E-09_JPRB, 0.16766771E-09_JPRB, 0.16793138E-09_JPRB, 0.16809751E-09_JPRB, 0.16822613E-09_JPRB, 0.16828697E-09_JPRB, &
  & 0.16831125E-09_JPRB, 0.16832051E-09_JPRB, 0.16832366E-09_JPRB, 0.16832388E-09_JPRB, 0.16832172E-09_JPRB, 0.16831694E-09_JPRB, &
  & 0.16830579E-09_JPRB, 0.16828873E-09_JPRB, 0.16825705E-09_JPRB, 0.16821947E-09_JPRB, 0.16817983E-09_JPRB, 0.16814547E-09_JPRB, &
  & 0.16811993E-09_JPRB, 0.16810565E-09_JPRB, 0.16810542E-09_JPRB, 0.16812275E-09_JPRB, 0.16815919E-09_JPRB, 0.16821039E-09_JPRB, &
  & 0.16826601E-09_JPRB, 0.16831880E-09_JPRB, 0.16836520E-09_JPRB, 0.16840232E-09_JPRB, 0.16842684E-09_JPRB, 0.16843500E-09_JPRB, &
  & 0.16842371E-09_JPRB, 0.16839147E-09_JPRB, 0.16834001E-09_JPRB, 0.16827394E-09_JPRB, 0.16820216E-09_JPRB, 0.16813409E-09_JPRB, &
  & 0.16807626E-09_JPRB, 0.16803421E-09_JPRB, 0.16801363E-09_JPRB, 0.16802068E-09_JPRB, 0.16806101E-09_JPRB, 0.16813265E-09_JPRB, &
  & 0.16822377E-09_JPRB, 0.16832137E-09_JPRB, 0.16841430E-09_JPRB, 0.16850354E-09_JPRB, 0.16858229E-09_JPRB, 0.16864964E-09_JPRB, &
  & 0.16869689E-09_JPRB, 0.16872373E-09_JPRB, 0.16873902E-09_JPRB, 0.16874789E-09_JPRB, 0.16875351E-09_JPRB, 0.16875759E-09_JPRB, &
  & 0.16876026E-09_JPRB, 0.16876181E-09_JPRB, 0.16876153E-09_JPRB, 0.16875917E-09_JPRB, 0.16875512E-09_JPRB, 0.16875018E-09_JPRB, &
  & 0.16874510E-09_JPRB, 0.16873869E-09_JPRB, 0.16872778E-09_JPRB, 0.16869801E-09_JPRB /)

RGHG8(:,56, 4) = (/ &
  & 0.16760386E-09_JPRB, 0.16799628E-09_JPRB, 0.16816017E-09_JPRB, 0.16828636E-09_JPRB, 0.16836366E-09_JPRB, 0.16839996E-09_JPRB, &
  & 0.16841301E-09_JPRB, 0.16841691E-09_JPRB, 0.16841739E-09_JPRB, 0.16841606E-09_JPRB, 0.16841298E-09_JPRB, 0.16840679E-09_JPRB, &
  & 0.16839680E-09_JPRB, 0.16837451E-09_JPRB, 0.16834258E-09_JPRB, 0.16829613E-09_JPRB, 0.16824649E-09_JPRB, 0.16820051E-09_JPRB, &
  & 0.16816415E-09_JPRB, 0.16814063E-09_JPRB, 0.16813342E-09_JPRB, 0.16814597E-09_JPRB, 0.16817972E-09_JPRB, 0.16822928E-09_JPRB, &
  & 0.16828487E-09_JPRB, 0.16833868E-09_JPRB, 0.16838632E-09_JPRB, 0.16842445E-09_JPRB, 0.16844880E-09_JPRB, 0.16845603E-09_JPRB, &
  & 0.16844322E-09_JPRB, 0.16840869E-09_JPRB, 0.16835465E-09_JPRB, 0.16828600E-09_JPRB, 0.16821178E-09_JPRB, 0.16814178E-09_JPRB, &
  & 0.16808305E-09_JPRB, 0.16804166E-09_JPRB, 0.16802336E-09_JPRB, 0.16803392E-09_JPRB, 0.16807786E-09_JPRB, 0.16815346E-09_JPRB, &
  & 0.16824903E-09_JPRB, 0.16835129E-09_JPRB, 0.16845260E-09_JPRB, 0.16854633E-09_JPRB, 0.16863327E-09_JPRB, 0.16870409E-09_JPRB, &
  & 0.16875190E-09_JPRB, 0.16878043E-09_JPRB, 0.16879589E-09_JPRB, 0.16880553E-09_JPRB, 0.16881221E-09_JPRB, 0.16881715E-09_JPRB, &
  & 0.16882140E-09_JPRB, 0.16882493E-09_JPRB, 0.16882773E-09_JPRB, 0.16882951E-09_JPRB, 0.16883003E-09_JPRB, 0.16882976E-09_JPRB, &
  & 0.16882921E-09_JPRB, 0.16882848E-09_JPRB, 0.16882754E-09_JPRB, 0.16882676E-09_JPRB /)

RGHG8(:,57, 4) = (/ &
  & 0.16791678E-09_JPRB, 0.16821619E-09_JPRB, 0.16834242E-09_JPRB, 0.16842144E-09_JPRB, 0.16846899E-09_JPRB, 0.16849058E-09_JPRB, &
  & 0.16849720E-09_JPRB, 0.16849858E-09_JPRB, 0.16849785E-09_JPRB, 0.16849586E-09_JPRB, 0.16849243E-09_JPRB, 0.16848690E-09_JPRB, &
  & 0.16847536E-09_JPRB, 0.16845705E-09_JPRB, 0.16842019E-09_JPRB, 0.16837051E-09_JPRB, 0.16831136E-09_JPRB, 0.16825433E-09_JPRB, &
  & 0.16820702E-09_JPRB, 0.16817503E-09_JPRB, 0.16816204E-09_JPRB, 0.16817116E-09_JPRB, 0.16820269E-09_JPRB, 0.16825097E-09_JPRB, &
  & 0.16830634E-09_JPRB, 0.16836098E-09_JPRB, 0.16841009E-09_JPRB, 0.16844889E-09_JPRB, 0.16847319E-09_JPRB, 0.16847923E-09_JPRB, &
  & 0.16846460E-09_JPRB, 0.16842777E-09_JPRB, 0.16837097E-09_JPRB, 0.16829974E-09_JPRB, 0.16822300E-09_JPRB, 0.16815126E-09_JPRB, &
  & 0.16809204E-09_JPRB, 0.16805142E-09_JPRB, 0.16803547E-09_JPRB, 0.16804917E-09_JPRB, 0.16809634E-09_JPRB, 0.16817460E-09_JPRB, &
  & 0.16827365E-09_JPRB, 0.16838070E-09_JPRB, 0.16848659E-09_JPRB, 0.16858771E-09_JPRB, 0.16867870E-09_JPRB, 0.16875321E-09_JPRB, &
  & 0.16880311E-09_JPRB, 0.16883020E-09_JPRB, 0.16884628E-09_JPRB, 0.16885607E-09_JPRB, 0.16886277E-09_JPRB, 0.16886822E-09_JPRB, &
  & 0.16887272E-09_JPRB, 0.16887705E-09_JPRB, 0.16888094E-09_JPRB, 0.16888436E-09_JPRB, 0.16888671E-09_JPRB, 0.16888815E-09_JPRB, &
  & 0.16888900E-09_JPRB, 0.16888931E-09_JPRB, 0.16888871E-09_JPRB, 0.16888521E-09_JPRB /)

RGHG8(:,58, 4) = (/ &
  & 0.16822728E-09_JPRB, 0.16840274E-09_JPRB, 0.16847967E-09_JPRB, 0.16852644E-09_JPRB, 0.16855664E-09_JPRB, 0.16856877E-09_JPRB, &
  & 0.16857227E-09_JPRB, 0.16857231E-09_JPRB, 0.16857105E-09_JPRB, 0.16856898E-09_JPRB, 0.16856577E-09_JPRB, 0.16856012E-09_JPRB, &
  & 0.16855095E-09_JPRB, 0.16853022E-09_JPRB, 0.16849698E-09_JPRB, 0.16844209E-09_JPRB, 0.16837522E-09_JPRB, 0.16830734E-09_JPRB, &
  & 0.16825026E-09_JPRB, 0.16821045E-09_JPRB, 0.16819278E-09_JPRB, 0.16819919E-09_JPRB, 0.16822893E-09_JPRB, 0.16827605E-09_JPRB, &
  & 0.16833128E-09_JPRB, 0.16838686E-09_JPRB, 0.16843696E-09_JPRB, 0.16847654E-09_JPRB, 0.16850048E-09_JPRB, 0.16850515E-09_JPRB, &
  & 0.16848863E-09_JPRB, 0.16844942E-09_JPRB, 0.16838966E-09_JPRB, 0.16831565E-09_JPRB, 0.16823669E-09_JPRB, 0.16816337E-09_JPRB, &
  & 0.16810384E-09_JPRB, 0.16806444E-09_JPRB, 0.16805063E-09_JPRB, 0.16806712E-09_JPRB, 0.16811684E-09_JPRB, 0.16819765E-09_JPRB, &
  & 0.16829919E-09_JPRB, 0.16840977E-09_JPRB, 0.16851998E-09_JPRB, 0.16862473E-09_JPRB, 0.16872097E-09_JPRB, 0.16879836E-09_JPRB, &
  & 0.16884782E-09_JPRB, 0.16887688E-09_JPRB, 0.16889247E-09_JPRB, 0.16890236E-09_JPRB, 0.16890932E-09_JPRB, 0.16891458E-09_JPRB, &
  & 0.16891930E-09_JPRB, 0.16892360E-09_JPRB, 0.16892773E-09_JPRB, 0.16893155E-09_JPRB, 0.16893448E-09_JPRB, 0.16893627E-09_JPRB, &
  & 0.16893756E-09_JPRB, 0.16893825E-09_JPRB, 0.16893802E-09_JPRB, 0.16893492E-09_JPRB /)

RGHG8(:,59, 4) = (/ &
  & 0.16841337E-09_JPRB, 0.16853596E-09_JPRB, 0.16858320E-09_JPRB, 0.16861521E-09_JPRB, 0.16863269E-09_JPRB, 0.16864057E-09_JPRB, &
  & 0.16864227E-09_JPRB, 0.16864177E-09_JPRB, 0.16864050E-09_JPRB, 0.16863852E-09_JPRB, 0.16863554E-09_JPRB, 0.16863080E-09_JPRB, &
  & 0.16862103E-09_JPRB, 0.16860414E-09_JPRB, 0.16856777E-09_JPRB, 0.16851176E-09_JPRB, 0.16843757E-09_JPRB, 0.16836058E-09_JPRB, &
  & 0.16829452E-09_JPRB, 0.16824873E-09_JPRB, 0.16822693E-09_JPRB, 0.16823100E-09_JPRB, 0.16825902E-09_JPRB, 0.16830523E-09_JPRB, &
  & 0.16836058E-09_JPRB, 0.16841685E-09_JPRB, 0.16846798E-09_JPRB, 0.16850793E-09_JPRB, 0.16853144E-09_JPRB, 0.16853476E-09_JPRB, &
  & 0.16851609E-09_JPRB, 0.16847443E-09_JPRB, 0.16841170E-09_JPRB, 0.16833482E-09_JPRB, 0.16825372E-09_JPRB, 0.16817905E-09_JPRB, &
  & 0.16811971E-09_JPRB, 0.16808137E-09_JPRB, 0.16806959E-09_JPRB, 0.16808839E-09_JPRB, 0.16814022E-09_JPRB, 0.16822288E-09_JPRB, &
  & 0.16832663E-09_JPRB, 0.16843979E-09_JPRB, 0.16855280E-09_JPRB, 0.16866079E-09_JPRB, 0.16875867E-09_JPRB, 0.16883810E-09_JPRB, &
  & 0.16889093E-09_JPRB, 0.16891955E-09_JPRB, 0.16893642E-09_JPRB, 0.16894657E-09_JPRB, 0.16895343E-09_JPRB, 0.16895890E-09_JPRB, &
  & 0.16896334E-09_JPRB, 0.16896753E-09_JPRB, 0.16897136E-09_JPRB, 0.16897490E-09_JPRB, 0.16897755E-09_JPRB, 0.16897936E-09_JPRB, &
  & 0.16898050E-09_JPRB, 0.16898105E-09_JPRB, 0.16898054E-09_JPRB, 0.16897651E-09_JPRB /)

RGHG8(:,60, 4) = (/ &
  & 0.16857465E-09_JPRB, 0.16864168E-09_JPRB, 0.16867288E-09_JPRB, 0.16869156E-09_JPRB, 0.16870405E-09_JPRB, 0.16870896E-09_JPRB, &
  & 0.16871002E-09_JPRB, 0.16870946E-09_JPRB, 0.16870826E-09_JPRB, 0.16870658E-09_JPRB, 0.16870400E-09_JPRB, 0.16869937E-09_JPRB, &
  & 0.16869131E-09_JPRB, 0.16867259E-09_JPRB, 0.16863901E-09_JPRB, 0.16857866E-09_JPRB, 0.16849860E-09_JPRB, 0.16841410E-09_JPRB, &
  & 0.16834173E-09_JPRB, 0.16829062E-09_JPRB, 0.16826554E-09_JPRB, 0.16826732E-09_JPRB, 0.16829395E-09_JPRB, 0.16833934E-09_JPRB, &
  & 0.16839473E-09_JPRB, 0.16845171E-09_JPRB, 0.16850335E-09_JPRB, 0.16854351E-09_JPRB, 0.16856652E-09_JPRB, 0.16856845E-09_JPRB, &
  & 0.16854777E-09_JPRB, 0.16850360E-09_JPRB, 0.16843814E-09_JPRB, 0.16835811E-09_JPRB, 0.16827510E-09_JPRB, 0.16819947E-09_JPRB, &
  & 0.16814039E-09_JPRB, 0.16810331E-09_JPRB, 0.16809318E-09_JPRB, 0.16811369E-09_JPRB, 0.16816709E-09_JPRB, 0.16825102E-09_JPRB, &
  & 0.16835645E-09_JPRB, 0.16847139E-09_JPRB, 0.16858652E-09_JPRB, 0.16869549E-09_JPRB, 0.16879471E-09_JPRB, 0.16887559E-09_JPRB, &
  & 0.16892931E-09_JPRB, 0.16896143E-09_JPRB, 0.16897883E-09_JPRB, 0.16898957E-09_JPRB, 0.16899687E-09_JPRB, 0.16900206E-09_JPRB, &
  & 0.16900648E-09_JPRB, 0.16901021E-09_JPRB, 0.16901350E-09_JPRB, 0.16901638E-09_JPRB, 0.16901854E-09_JPRB, 0.16901981E-09_JPRB, &
  & 0.16902069E-09_JPRB, 0.16902099E-09_JPRB, 0.16902024E-09_JPRB, 0.16901587E-09_JPRB /)

RGHG8(:,61, 4) = (/ &
  & 0.16867371E-09_JPRB, 0.16872623E-09_JPRB, 0.16874797E-09_JPRB, 0.16876278E-09_JPRB, 0.16877155E-09_JPRB, 0.16877574E-09_JPRB, &
  & 0.16877670E-09_JPRB, 0.16877635E-09_JPRB, 0.16877549E-09_JPRB, 0.16877411E-09_JPRB, 0.16877189E-09_JPRB, 0.16876797E-09_JPRB, &
  & 0.16875956E-09_JPRB, 0.16874289E-09_JPRB, 0.16870594E-09_JPRB, 0.16864374E-09_JPRB, 0.16855911E-09_JPRB, 0.16846949E-09_JPRB, &
  & 0.16839216E-09_JPRB, 0.16833723E-09_JPRB, 0.16830919E-09_JPRB, 0.16830894E-09_JPRB, 0.16833429E-09_JPRB, 0.16837913E-09_JPRB, &
  & 0.16843457E-09_JPRB, 0.16849183E-09_JPRB, 0.16854376E-09_JPRB, 0.16858383E-09_JPRB, 0.16860624E-09_JPRB, 0.16860702E-09_JPRB, &
  & 0.16858449E-09_JPRB, 0.16853811E-09_JPRB, 0.16846988E-09_JPRB, 0.16838717E-09_JPRB, 0.16830205E-09_JPRB, 0.16822596E-09_JPRB, &
  & 0.16816715E-09_JPRB, 0.16813111E-09_JPRB, 0.16812234E-09_JPRB, 0.16814411E-09_JPRB, 0.16819832E-09_JPRB, 0.16828307E-09_JPRB, &
  & 0.16838914E-09_JPRB, 0.16850533E-09_JPRB, 0.16862158E-09_JPRB, 0.16873125E-09_JPRB, 0.16882987E-09_JPRB, 0.16891066E-09_JPRB, &
  & 0.16896780E-09_JPRB, 0.16900117E-09_JPRB, 0.16902092E-09_JPRB, 0.16903247E-09_JPRB, 0.16903982E-09_JPRB, 0.16904517E-09_JPRB, &
  & 0.16904914E-09_JPRB, 0.16905238E-09_JPRB, 0.16905494E-09_JPRB, 0.16905702E-09_JPRB, 0.16905841E-09_JPRB, 0.16905916E-09_JPRB, &
  & 0.16905954E-09_JPRB, 0.16905938E-09_JPRB, 0.16905798E-09_JPRB, 0.16905229E-09_JPRB /)

RGHG8(:,62, 4) = (/ &
  & 0.16876217E-09_JPRB, 0.16880118E-09_JPRB, 0.16881888E-09_JPRB, 0.16883020E-09_JPRB, 0.16883810E-09_JPRB, 0.16884200E-09_JPRB, &
  & 0.16884338E-09_JPRB, 0.16884352E-09_JPRB, 0.16884308E-09_JPRB, 0.16884219E-09_JPRB, 0.16884047E-09_JPRB, 0.16883692E-09_JPRB, &
  & 0.16882931E-09_JPRB, 0.16881097E-09_JPRB, 0.16877351E-09_JPRB, 0.16870780E-09_JPRB, 0.16861984E-09_JPRB, 0.16852757E-09_JPRB, &
  & 0.16844698E-09_JPRB, 0.16838902E-09_JPRB, 0.16835856E-09_JPRB, 0.16835675E-09_JPRB, 0.16838116E-09_JPRB, 0.16842538E-09_JPRB, &
  & 0.16848073E-09_JPRB, 0.16853804E-09_JPRB, 0.16858995E-09_JPRB, 0.16862960E-09_JPRB, 0.16865140E-09_JPRB, 0.16865116E-09_JPRB, &
  & 0.16862720E-09_JPRB, 0.16857882E-09_JPRB, 0.16850850E-09_JPRB, 0.16842325E-09_JPRB, 0.16833643E-09_JPRB, 0.16825974E-09_JPRB, &
  & 0.16820127E-09_JPRB, 0.16816609E-09_JPRB, 0.16815824E-09_JPRB, 0.16818061E-09_JPRB, 0.16823513E-09_JPRB, 0.16831972E-09_JPRB, &
  & 0.16842600E-09_JPRB, 0.16854235E-09_JPRB, 0.16865910E-09_JPRB, 0.16876868E-09_JPRB, 0.16886637E-09_JPRB, 0.16894679E-09_JPRB, &
  & 0.16900452E-09_JPRB, 0.16904173E-09_JPRB, 0.16906283E-09_JPRB, 0.16907548E-09_JPRB, 0.16908329E-09_JPRB, 0.16908838E-09_JPRB, &
  & 0.16909196E-09_JPRB, 0.16909452E-09_JPRB, 0.16909608E-09_JPRB, 0.16909722E-09_JPRB, 0.16909782E-09_JPRB, 0.16909790E-09_JPRB, &
  & 0.16909779E-09_JPRB, 0.16909715E-09_JPRB, 0.16909510E-09_JPRB, 0.16908779E-09_JPRB /)

RGHG8(:,63, 4) = (/ &
  & 0.16883719E-09_JPRB, 0.16887083E-09_JPRB, 0.16888593E-09_JPRB, 0.16889647E-09_JPRB, 0.16890385E-09_JPRB, 0.16890839E-09_JPRB, &
  & 0.16891044E-09_JPRB, 0.16891130E-09_JPRB, 0.16891152E-09_JPRB, 0.16891129E-09_JPRB, 0.16891022E-09_JPRB, 0.16890726E-09_JPRB, &
  & 0.16889953E-09_JPRB, 0.16888081E-09_JPRB, 0.16884007E-09_JPRB, 0.16877184E-09_JPRB, 0.16868303E-09_JPRB, 0.16858921E-09_JPRB, &
  & 0.16850689E-09_JPRB, 0.16844670E-09_JPRB, 0.16841450E-09_JPRB, 0.16841162E-09_JPRB, 0.16843536E-09_JPRB, 0.16847913E-09_JPRB, &
  & 0.16853412E-09_JPRB, 0.16859124E-09_JPRB, 0.16864263E-09_JPRB, 0.16868179E-09_JPRB, 0.16870279E-09_JPRB, 0.16870172E-09_JPRB, &
  & 0.16867677E-09_JPRB, 0.16862715E-09_JPRB, 0.16855503E-09_JPRB, 0.16846811E-09_JPRB, 0.16837964E-09_JPRB, 0.16830268E-09_JPRB, &
  & 0.16824427E-09_JPRB, 0.16820967E-09_JPRB, 0.16820222E-09_JPRB, 0.16822470E-09_JPRB, 0.16827877E-09_JPRB, 0.16836262E-09_JPRB, &
  & 0.16846780E-09_JPRB, 0.16858355E-09_JPRB, 0.16869989E-09_JPRB, 0.16880886E-09_JPRB, 0.16890545E-09_JPRB, 0.16898462E-09_JPRB, &
  & 0.16904353E-09_JPRB, 0.16908198E-09_JPRB, 0.16910565E-09_JPRB, 0.16911912E-09_JPRB, 0.16912731E-09_JPRB, 0.16913215E-09_JPRB, &
  & 0.16913521E-09_JPRB, 0.16913684E-09_JPRB, 0.16913737E-09_JPRB, 0.16913754E-09_JPRB, 0.16913733E-09_JPRB, 0.16913676E-09_JPRB, &
  & 0.16913621E-09_JPRB, 0.16913497E-09_JPRB, 0.16913194E-09_JPRB, 0.16912230E-09_JPRB /)

RGHG8(:,64, 4) = (/ &
  & 0.16890524E-09_JPRB, 0.16893614E-09_JPRB, 0.16895077E-09_JPRB, 0.16896105E-09_JPRB, 0.16896905E-09_JPRB, 0.16897429E-09_JPRB, &
  & 0.16897750E-09_JPRB, 0.16897923E-09_JPRB, 0.16898041E-09_JPRB, 0.16898105E-09_JPRB, 0.16898088E-09_JPRB, 0.16897873E-09_JPRB, &
  & 0.16897117E-09_JPRB, 0.16895042E-09_JPRB, 0.16890724E-09_JPRB, 0.16883754E-09_JPRB, 0.16874881E-09_JPRB, 0.16865527E-09_JPRB, &
  & 0.16857211E-09_JPRB, 0.16851059E-09_JPRB, 0.16847743E-09_JPRB, 0.16847400E-09_JPRB, 0.16849729E-09_JPRB, 0.16854060E-09_JPRB, &
  & 0.16859500E-09_JPRB, 0.16865143E-09_JPRB, 0.16870205E-09_JPRB, 0.16874015E-09_JPRB, 0.16876030E-09_JPRB, 0.16875847E-09_JPRB, &
  & 0.16873300E-09_JPRB, 0.16868276E-09_JPRB, 0.16860986E-09_JPRB, 0.16852192E-09_JPRB, 0.16843278E-09_JPRB, 0.16835547E-09_JPRB, &
  & 0.16829724E-09_JPRB, 0.16826288E-09_JPRB, 0.16825540E-09_JPRB, 0.16827735E-09_JPRB, 0.16833032E-09_JPRB, 0.16841245E-09_JPRB, &
  & 0.16851573E-09_JPRB, 0.16862961E-09_JPRB, 0.16874471E-09_JPRB, 0.16885239E-09_JPRB, 0.16894747E-09_JPRB, 0.16902554E-09_JPRB, &
  & 0.16908411E-09_JPRB, 0.16912421E-09_JPRB, 0.16914881E-09_JPRB, 0.16916347E-09_JPRB, 0.16917170E-09_JPRB, 0.16917652E-09_JPRB, &
  & 0.16917885E-09_JPRB, 0.16917963E-09_JPRB, 0.16917898E-09_JPRB, 0.16917823E-09_JPRB, 0.16917728E-09_JPRB, 0.16917613E-09_JPRB, &
  & 0.16917506E-09_JPRB, 0.16917326E-09_JPRB, 0.16916905E-09_JPRB, 0.16915566E-09_JPRB /)

RGHG8(:,65, 4) = (/ &
  & 0.16896569E-09_JPRB, 0.16899801E-09_JPRB, 0.16901325E-09_JPRB, 0.16902457E-09_JPRB, 0.16903336E-09_JPRB, 0.16903987E-09_JPRB, &
  & 0.16904403E-09_JPRB, 0.16904705E-09_JPRB, 0.16904925E-09_JPRB, 0.16905125E-09_JPRB, 0.16905233E-09_JPRB, 0.16905115E-09_JPRB, &
  & 0.16904333E-09_JPRB, 0.16902069E-09_JPRB, 0.16897515E-09_JPRB, 0.16890589E-09_JPRB, 0.16881832E-09_JPRB, 0.16872587E-09_JPRB, &
  & 0.16864291E-09_JPRB, 0.16858120E-09_JPRB, 0.16854761E-09_JPRB, 0.16854407E-09_JPRB, 0.16856716E-09_JPRB, 0.16860971E-09_JPRB, &
  & 0.16866308E-09_JPRB, 0.16871825E-09_JPRB, 0.16876725E-09_JPRB, 0.16880397E-09_JPRB, 0.16882282E-09_JPRB, 0.16882032E-09_JPRB, &
  & 0.16879467E-09_JPRB, 0.16874473E-09_JPRB, 0.16867199E-09_JPRB, 0.16858429E-09_JPRB, 0.16849533E-09_JPRB, 0.16841843E-09_JPRB, &
  & 0.16836056E-09_JPRB, 0.16832638E-09_JPRB, 0.16831853E-09_JPRB, 0.16833943E-09_JPRB, 0.16839069E-09_JPRB, 0.16847029E-09_JPRB, &
  & 0.16857046E-09_JPRB, 0.16868154E-09_JPRB, 0.16879423E-09_JPRB, 0.16889991E-09_JPRB, 0.16899303E-09_JPRB, 0.16906952E-09_JPRB, &
  & 0.16912766E-09_JPRB, 0.16916800E-09_JPRB, 0.16919353E-09_JPRB, 0.16920837E-09_JPRB, 0.16921697E-09_JPRB, 0.16922141E-09_JPRB, &
  & 0.16922333E-09_JPRB, 0.16922318E-09_JPRB, 0.16922141E-09_JPRB, 0.16921986E-09_JPRB, 0.16921826E-09_JPRB, 0.16921642E-09_JPRB, &
  & 0.16921500E-09_JPRB, 0.16921245E-09_JPRB, 0.16920659E-09_JPRB, 0.16918833E-09_JPRB /)

RGHG8(:,66, 4) = (/ &
  & 0.16902074E-09_JPRB, 0.16905650E-09_JPRB, 0.16907423E-09_JPRB, 0.16908699E-09_JPRB, 0.16909731E-09_JPRB, 0.16910498E-09_JPRB, &
  & 0.16911055E-09_JPRB, 0.16911450E-09_JPRB, 0.16911827E-09_JPRB, 0.16912158E-09_JPRB, 0.16912427E-09_JPRB, 0.16912399E-09_JPRB, &
  & 0.16911554E-09_JPRB, 0.16909099E-09_JPRB, 0.16904535E-09_JPRB, 0.16897687E-09_JPRB, 0.16889158E-09_JPRB, 0.16880104E-09_JPRB, &
  & 0.16871952E-09_JPRB, 0.16865831E-09_JPRB, 0.16862527E-09_JPRB, 0.16862177E-09_JPRB, 0.16864440E-09_JPRB, 0.16868598E-09_JPRB, &
  & 0.16873755E-09_JPRB, 0.16879062E-09_JPRB, 0.16883732E-09_JPRB, 0.16887182E-09_JPRB, 0.16888911E-09_JPRB, 0.16888582E-09_JPRB, &
  & 0.16886041E-09_JPRB, 0.16881142E-09_JPRB, 0.16874013E-09_JPRB, 0.16865370E-09_JPRB, 0.16856638E-09_JPRB, 0.16849067E-09_JPRB, &
  & 0.16843396E-09_JPRB, 0.16840013E-09_JPRB, 0.16839193E-09_JPRB, 0.16841147E-09_JPRB, 0.16846038E-09_JPRB, 0.16853663E-09_JPRB, &
  & 0.16863297E-09_JPRB, 0.16873983E-09_JPRB, 0.16884917E-09_JPRB, 0.16895176E-09_JPRB, 0.16904232E-09_JPRB, 0.16911683E-09_JPRB, &
  & 0.16917390E-09_JPRB, 0.16921418E-09_JPRB, 0.16923972E-09_JPRB, 0.16925479E-09_JPRB, 0.16926320E-09_JPRB, 0.16926746E-09_JPRB, &
  & 0.16926885E-09_JPRB, 0.16926788E-09_JPRB, 0.16926516E-09_JPRB, 0.16926284E-09_JPRB, 0.16926063E-09_JPRB, 0.16925822E-09_JPRB, &
  & 0.16925641E-09_JPRB, 0.16925325E-09_JPRB, 0.16924563E-09_JPRB, 0.16922125E-09_JPRB /)

RGHG8(:,67, 4) = (/ &
  & 0.16907170E-09_JPRB, 0.16911414E-09_JPRB, 0.16913421E-09_JPRB, 0.16914943E-09_JPRB, 0.16916142E-09_JPRB, 0.16917052E-09_JPRB, &
  & 0.16917720E-09_JPRB, 0.16918253E-09_JPRB, 0.16918730E-09_JPRB, 0.16919253E-09_JPRB, 0.16919630E-09_JPRB, 0.16919646E-09_JPRB, &
  & 0.16918729E-09_JPRB, 0.16916221E-09_JPRB, 0.16911698E-09_JPRB, 0.16905075E-09_JPRB, 0.16896828E-09_JPRB, 0.16888085E-09_JPRB, &
  & 0.16880161E-09_JPRB, 0.16874227E-09_JPRB, 0.16870999E-09_JPRB, 0.16870669E-09_JPRB, 0.16872861E-09_JPRB, 0.16876826E-09_JPRB, &
  & 0.16881745E-09_JPRB, 0.16886735E-09_JPRB, 0.16891097E-09_JPRB, 0.16894275E-09_JPRB, 0.16895814E-09_JPRB, 0.16895407E-09_JPRB, &
  & 0.16892918E-09_JPRB, 0.16888194E-09_JPRB, 0.16881285E-09_JPRB, 0.16872924E-09_JPRB, 0.16864442E-09_JPRB, 0.16857134E-09_JPRB, &
  & 0.16851640E-09_JPRB, 0.16848356E-09_JPRB, 0.16847519E-09_JPRB, 0.16849333E-09_JPRB, 0.16853949E-09_JPRB, 0.16861187E-09_JPRB, &
  & 0.16870327E-09_JPRB, 0.16880534E-09_JPRB, 0.16890984E-09_JPRB, 0.16900870E-09_JPRB, 0.16909582E-09_JPRB, 0.16916774E-09_JPRB, &
  & 0.16922322E-09_JPRB, 0.16926266E-09_JPRB, 0.16928792E-09_JPRB, 0.16930274E-09_JPRB, 0.16931097E-09_JPRB, 0.16931485E-09_JPRB, &
  & 0.16931574E-09_JPRB, 0.16931408E-09_JPRB, 0.16931051E-09_JPRB, 0.16930761E-09_JPRB, 0.16930489E-09_JPRB, 0.16930174E-09_JPRB, &
  & 0.16929988E-09_JPRB, 0.16929608E-09_JPRB, 0.16928660E-09_JPRB, 0.16925583E-09_JPRB /)

RGHG8(:,68, 4) = (/ &
  & 0.16912219E-09_JPRB, 0.16917034E-09_JPRB, 0.16919501E-09_JPRB, 0.16921232E-09_JPRB, 0.16922637E-09_JPRB, 0.16923692E-09_JPRB, &
  & 0.16924469E-09_JPRB, 0.16925106E-09_JPRB, 0.16925733E-09_JPRB, 0.16926355E-09_JPRB, 0.16926818E-09_JPRB, 0.16926822E-09_JPRB, &
  & 0.16925870E-09_JPRB, 0.16923385E-09_JPRB, 0.16919004E-09_JPRB, 0.16912667E-09_JPRB, 0.16904822E-09_JPRB, 0.16896487E-09_JPRB, &
  & 0.16888915E-09_JPRB, 0.16883209E-09_JPRB, 0.16880132E-09_JPRB, 0.16879791E-09_JPRB, 0.16881832E-09_JPRB, 0.16885555E-09_JPRB, &
  & 0.16890123E-09_JPRB, 0.16894754E-09_JPRB, 0.16898744E-09_JPRB, 0.16901613E-09_JPRB, 0.16902950E-09_JPRB, 0.16902474E-09_JPRB, &
  & 0.16900069E-09_JPRB, 0.16895563E-09_JPRB, 0.16888982E-09_JPRB, 0.16880955E-09_JPRB, 0.16872884E-09_JPRB, 0.16865898E-09_JPRB, &
  & 0.16860691E-09_JPRB, 0.16857550E-09_JPRB, 0.16856752E-09_JPRB, 0.16858429E-09_JPRB, 0.16862763E-09_JPRB, 0.16869552E-09_JPRB, &
  & 0.16878178E-09_JPRB, 0.16887768E-09_JPRB, 0.16897708E-09_JPRB, 0.16907083E-09_JPRB, 0.16915379E-09_JPRB, 0.16922247E-09_JPRB, &
  & 0.16927558E-09_JPRB, 0.16931374E-09_JPRB, 0.16933822E-09_JPRB, 0.16935257E-09_JPRB, 0.16936037E-09_JPRB, 0.16936390E-09_JPRB, &
  & 0.16936433E-09_JPRB, 0.16936208E-09_JPRB, 0.16935793E-09_JPRB, 0.16935452E-09_JPRB, 0.16935137E-09_JPRB, 0.16934770E-09_JPRB, &
  & 0.16934579E-09_JPRB, 0.16934169E-09_JPRB, 0.16933069E-09_JPRB, 0.16929452E-09_JPRB /)

RGHG8(:,69, 4) = (/ &
  & 0.16916921E-09_JPRB, 0.16922899E-09_JPRB, 0.16925630E-09_JPRB, 0.16927708E-09_JPRB, 0.16929265E-09_JPRB, 0.16930443E-09_JPRB, &
  & 0.16931336E-09_JPRB, 0.16932065E-09_JPRB, 0.16932786E-09_JPRB, 0.16933498E-09_JPRB, 0.16933978E-09_JPRB, 0.16933967E-09_JPRB, &
  & 0.16933012E-09_JPRB, 0.16930607E-09_JPRB, 0.16926428E-09_JPRB, 0.16920459E-09_JPRB, 0.16913096E-09_JPRB, 0.16905273E-09_JPRB, &
  & 0.16898133E-09_JPRB, 0.16892746E-09_JPRB, 0.16889799E-09_JPRB, 0.16889423E-09_JPRB, 0.16891269E-09_JPRB, 0.16894651E-09_JPRB, &
  & 0.16898830E-09_JPRB, 0.16903037E-09_JPRB, 0.16906634E-09_JPRB, 0.16909187E-09_JPRB, 0.16910320E-09_JPRB, 0.16909785E-09_JPRB, &
  & 0.16907498E-09_JPRB, 0.16903273E-09_JPRB, 0.16897066E-09_JPRB, 0.16889504E-09_JPRB, 0.16881864E-09_JPRB, 0.16875337E-09_JPRB, &
  & 0.16870438E-09_JPRB, 0.16867516E-09_JPRB, 0.16866776E-09_JPRB, 0.16868355E-09_JPRB, 0.16872392E-09_JPRB, 0.16878741E-09_JPRB, &
  & 0.16886763E-09_JPRB, 0.16895767E-09_JPRB, 0.16905033E-09_JPRB, 0.16913868E-09_JPRB, 0.16921647E-09_JPRB, 0.16928105E-09_JPRB, &
  & 0.16933129E-09_JPRB, 0.16936755E-09_JPRB, 0.16939083E-09_JPRB, 0.16940442E-09_JPRB, 0.16941171E-09_JPRB, 0.16941482E-09_JPRB, &
  & 0.16941486E-09_JPRB, 0.16941221E-09_JPRB, 0.16940768E-09_JPRB, 0.16940403E-09_JPRB, 0.16940069E-09_JPRB, 0.16939658E-09_JPRB, &
  & 0.16939491E-09_JPRB, 0.16939054E-09_JPRB, 0.16937832E-09_JPRB, 0.16933729E-09_JPRB /)

RGHG8(:,70, 4) = (/ &
  & 0.16921810E-09_JPRB, 0.16928668E-09_JPRB, 0.16932114E-09_JPRB, 0.16934355E-09_JPRB, 0.16936108E-09_JPRB, 0.16937370E-09_JPRB, &
  & 0.16938329E-09_JPRB, 0.16939149E-09_JPRB, 0.16939918E-09_JPRB, 0.16940667E-09_JPRB, 0.16941122E-09_JPRB, 0.16941086E-09_JPRB, &
  & 0.16940147E-09_JPRB, 0.16937848E-09_JPRB, 0.16933935E-09_JPRB, 0.16928398E-09_JPRB, 0.16921596E-09_JPRB, 0.16914367E-09_JPRB, &
  & 0.16907742E-09_JPRB, 0.16902699E-09_JPRB, 0.16899898E-09_JPRB, 0.16899451E-09_JPRB, 0.16901036E-09_JPRB, 0.16904045E-09_JPRB, &
  & 0.16907782E-09_JPRB, 0.16911550E-09_JPRB, 0.16914739E-09_JPRB, 0.16916971E-09_JPRB, 0.16917916E-09_JPRB, 0.16917337E-09_JPRB, &
  & 0.16915198E-09_JPRB, 0.16911293E-09_JPRB, 0.16905535E-09_JPRB, 0.16898481E-09_JPRB, 0.16891412E-09_JPRB, 0.16885343E-09_JPRB, &
  & 0.16880838E-09_JPRB, 0.16878160E-09_JPRB, 0.16877512E-09_JPRB, 0.16879002E-09_JPRB, 0.16882769E-09_JPRB, 0.16888624E-09_JPRB, &
  & 0.16896089E-09_JPRB, 0.16904357E-09_JPRB, 0.16913003E-09_JPRB, 0.16921142E-09_JPRB, 0.16928348E-09_JPRB, 0.16934332E-09_JPRB, &
  & 0.16938992E-09_JPRB, 0.16942388E-09_JPRB, 0.16944567E-09_JPRB, 0.16945831E-09_JPRB, 0.16946500E-09_JPRB, 0.16946775E-09_JPRB, &
  & 0.16946756E-09_JPRB, 0.16946473E-09_JPRB, 0.16946021E-09_JPRB, 0.16945657E-09_JPRB, 0.16945327E-09_JPRB, 0.16944914E-09_JPRB, &
  & 0.16944771E-09_JPRB, 0.16944349E-09_JPRB, 0.16943059E-09_JPRB, 0.16938627E-09_JPRB /)

RGHG8(:,71, 4) = (/ &
  & 0.16926875E-09_JPRB, 0.16935138E-09_JPRB, 0.16938854E-09_JPRB, 0.16941365E-09_JPRB, 0.16943161E-09_JPRB, 0.16944479E-09_JPRB, &
  & 0.16945480E-09_JPRB, 0.16946336E-09_JPRB, 0.16947127E-09_JPRB, 0.16947861E-09_JPRB, 0.16948272E-09_JPRB, 0.16948197E-09_JPRB, &
  & 0.16947274E-09_JPRB, 0.16945098E-09_JPRB, 0.16941488E-09_JPRB, 0.16936433E-09_JPRB, 0.16930241E-09_JPRB, 0.16923660E-09_JPRB, &
  & 0.16917606E-09_JPRB, 0.16912953E-09_JPRB, 0.16910305E-09_JPRB, 0.16909767E-09_JPRB, 0.16911067E-09_JPRB, 0.16913655E-09_JPRB, &
  & 0.16916941E-09_JPRB, 0.16920253E-09_JPRB, 0.16923030E-09_JPRB, 0.16924950E-09_JPRB, 0.16925714E-09_JPRB, 0.16925121E-09_JPRB, &
  & 0.16923150E-09_JPRB, 0.16919609E-09_JPRB, 0.16914348E-09_JPRB, 0.16907897E-09_JPRB, 0.16901402E-09_JPRB, 0.16895897E-09_JPRB, &
  & 0.16891799E-09_JPRB, 0.16889412E-09_JPRB, 0.16888874E-09_JPRB, 0.16890295E-09_JPRB, 0.16893760E-09_JPRB, 0.16899157E-09_JPRB, &
  & 0.16905928E-09_JPRB, 0.16913575E-09_JPRB, 0.16921385E-09_JPRB, 0.16928871E-09_JPRB, 0.16935400E-09_JPRB, 0.16940854E-09_JPRB, &
  & 0.16945119E-09_JPRB, 0.16948234E-09_JPRB, 0.16950240E-09_JPRB, 0.16951406E-09_JPRB, 0.16952012E-09_JPRB, 0.16952265E-09_JPRB, &
  & 0.16952240E-09_JPRB, 0.16951968E-09_JPRB, 0.16951544E-09_JPRB, 0.16951215E-09_JPRB, 0.16950924E-09_JPRB, 0.16950534E-09_JPRB, &
  & 0.16950441E-09_JPRB, 0.16950061E-09_JPRB, 0.16948844E-09_JPRB, 0.16944524E-09_JPRB /)

RGHG8(:,72, 4) = (/ &
  & 0.16932955E-09_JPRB, 0.16942024E-09_JPRB, 0.16946103E-09_JPRB, 0.16948645E-09_JPRB, 0.16950466E-09_JPRB, 0.16951766E-09_JPRB, &
  & 0.16952774E-09_JPRB, 0.16953636E-09_JPRB, 0.16954398E-09_JPRB, 0.16955100E-09_JPRB, 0.16955430E-09_JPRB, 0.16955302E-09_JPRB, &
  & 0.16954388E-09_JPRB, 0.16952358E-09_JPRB, 0.16949053E-09_JPRB, 0.16944487E-09_JPRB, 0.16938954E-09_JPRB, 0.16933059E-09_JPRB, &
  & 0.16927620E-09_JPRB, 0.16923392E-09_JPRB, 0.16920916E-09_JPRB, 0.16920298E-09_JPRB, 0.16921291E-09_JPRB, 0.16923454E-09_JPRB, &
  & 0.16926260E-09_JPRB, 0.16929115E-09_JPRB, 0.16931481E-09_JPRB, 0.16933104E-09_JPRB, 0.16933707E-09_JPRB, 0.16933110E-09_JPRB, &
  & 0.16931329E-09_JPRB, 0.16928177E-09_JPRB, 0.16923471E-09_JPRB, 0.16917648E-09_JPRB, 0.16911833E-09_JPRB, 0.16906897E-09_JPRB, &
  & 0.16903279E-09_JPRB, 0.16901194E-09_JPRB, 0.16900778E-09_JPRB, 0.16902128E-09_JPRB, 0.16905301E-09_JPRB, 0.16910141E-09_JPRB, &
  & 0.16916318E-09_JPRB, 0.16923093E-09_JPRB, 0.16930199E-09_JPRB, 0.16936835E-09_JPRB, 0.16942697E-09_JPRB, 0.16947584E-09_JPRB, &
  & 0.16951396E-09_JPRB, 0.16954235E-09_JPRB, 0.16956049E-09_JPRB, 0.16957118E-09_JPRB, 0.16957685E-09_JPRB, 0.16957921E-09_JPRB, &
  & 0.16957918E-09_JPRB, 0.16957680E-09_JPRB, 0.16957315E-09_JPRB, 0.16957041E-09_JPRB, 0.16956804E-09_JPRB, 0.16956467E-09_JPRB, &
  & 0.16956410E-09_JPRB, 0.16956087E-09_JPRB, 0.16954965E-09_JPRB, 0.16950864E-09_JPRB /)

RGHG8(:,73, 4) = (/ &
  & 0.16940348E-09_JPRB, 0.16949631E-09_JPRB, 0.16953705E-09_JPRB, 0.16956135E-09_JPRB, 0.16957878E-09_JPRB, 0.16959137E-09_JPRB, &
  & 0.16960106E-09_JPRB, 0.16960934E-09_JPRB, 0.16961654E-09_JPRB, 0.16962269E-09_JPRB, 0.16962542E-09_JPRB, 0.16962358E-09_JPRB, &
  & 0.16961477E-09_JPRB, 0.16959570E-09_JPRB, 0.16956582E-09_JPRB, 0.16952525E-09_JPRB, 0.16947625E-09_JPRB, 0.16942460E-09_JPRB, &
  & 0.16937664E-09_JPRB, 0.16933900E-09_JPRB, 0.16931623E-09_JPRB, 0.16930941E-09_JPRB, 0.16931635E-09_JPRB, 0.16933369E-09_JPRB, &
  & 0.16935704E-09_JPRB, 0.16938111E-09_JPRB, 0.16940077E-09_JPRB, 0.16941411E-09_JPRB, 0.16941860E-09_JPRB, 0.16941283E-09_JPRB, &
  & 0.16939707E-09_JPRB, 0.16936967E-09_JPRB, 0.16932844E-09_JPRB, 0.16927727E-09_JPRB, 0.16922586E-09_JPRB, 0.16918311E-09_JPRB, &
  & 0.16915172E-09_JPRB, 0.16913410E-09_JPRB, 0.16913121E-09_JPRB, 0.16914391E-09_JPRB, 0.16917232E-09_JPRB, 0.16921563E-09_JPRB, &
  & 0.16926938E-09_JPRB, 0.16932999E-09_JPRB, 0.16939121E-09_JPRB, 0.16945009E-09_JPRB, 0.16950126E-09_JPRB, 0.16954406E-09_JPRB, &
  & 0.16957794E-09_JPRB, 0.16960305E-09_JPRB, 0.16961939E-09_JPRB, 0.16962916E-09_JPRB, 0.16963435E-09_JPRB, 0.16963680E-09_JPRB, &
  & 0.16963710E-09_JPRB, 0.16963525E-09_JPRB, 0.16963234E-09_JPRB, 0.16963021E-09_JPRB, 0.16962841E-09_JPRB, 0.16962558E-09_JPRB, &
  & 0.16962527E-09_JPRB, 0.16962241E-09_JPRB, 0.16961213E-09_JPRB, 0.16957380E-09_JPRB /)

RGHG8(:,74, 4) = (/ &
  & 0.16948265E-09_JPRB, 0.16957563E-09_JPRB, 0.16961368E-09_JPRB, 0.16963643E-09_JPRB, 0.16965229E-09_JPRB, 0.16966395E-09_JPRB, &
  & 0.16967297E-09_JPRB, 0.16968080E-09_JPRB, 0.16968682E-09_JPRB, 0.16969262E-09_JPRB, 0.16969451E-09_JPRB, 0.16969230E-09_JPRB, &
  & 0.16968385E-09_JPRB, 0.16966656E-09_JPRB, 0.16963986E-09_JPRB, 0.16960425E-09_JPRB, 0.16956213E-09_JPRB, 0.16951765E-09_JPRB, &
  & 0.16947657E-09_JPRB, 0.16944367E-09_JPRB, 0.16942332E-09_JPRB, 0.16941612E-09_JPRB, 0.16942030E-09_JPRB, 0.16943361E-09_JPRB, &
  & 0.16945245E-09_JPRB, 0.16947203E-09_JPRB, 0.16948777E-09_JPRB, 0.16949843E-09_JPRB, 0.16950163E-09_JPRB, 0.16949619E-09_JPRB, &
  & 0.16948251E-09_JPRB, 0.16945934E-09_JPRB, 0.16942436E-09_JPRB, 0.16938032E-09_JPRB, 0.16933657E-09_JPRB, 0.16930028E-09_JPRB, &
  & 0.16927418E-09_JPRB, 0.16925980E-09_JPRB, 0.16925800E-09_JPRB, 0.16926965E-09_JPRB, 0.16929470E-09_JPRB, 0.16933183E-09_JPRB, &
  & 0.16937875E-09_JPRB, 0.16942968E-09_JPRB, 0.16948247E-09_JPRB, 0.16953240E-09_JPRB, 0.16957610E-09_JPRB, 0.16961318E-09_JPRB, &
  & 0.16964188E-09_JPRB, 0.16966424E-09_JPRB, 0.16967842E-09_JPRB, 0.16968725E-09_JPRB, 0.16969215E-09_JPRB, 0.16969455E-09_JPRB, &
  & 0.16969527E-09_JPRB, 0.16969401E-09_JPRB, 0.16969173E-09_JPRB, 0.16969028E-09_JPRB, 0.16968907E-09_JPRB, 0.16968668E-09_JPRB, &
  & 0.16968647E-09_JPRB, 0.16968384E-09_JPRB, 0.16967457E-09_JPRB, 0.16963869E-09_JPRB /)

RGHG8(:,75, 4) = (/ &
  & 0.16956611E-09_JPRB, 0.16965390E-09_JPRB, 0.16968964E-09_JPRB, 0.16970911E-09_JPRB, 0.16972317E-09_JPRB, 0.16973362E-09_JPRB, &
  & 0.16974160E-09_JPRB, 0.16974849E-09_JPRB, 0.16975388E-09_JPRB, 0.16975849E-09_JPRB, 0.16975994E-09_JPRB, 0.16975779E-09_JPRB, &
  & 0.16975006E-09_JPRB, 0.16973484E-09_JPRB, 0.16971177E-09_JPRB, 0.16968174E-09_JPRB, 0.16964626E-09_JPRB, 0.16960952E-09_JPRB, &
  & 0.16957512E-09_JPRB, 0.16954753E-09_JPRB, 0.16952965E-09_JPRB, 0.16952263E-09_JPRB, 0.16952455E-09_JPRB, 0.16953415E-09_JPRB, &
  & 0.16954875E-09_JPRB, 0.16956408E-09_JPRB, 0.16957610E-09_JPRB, 0.16958428E-09_JPRB, 0.16958633E-09_JPRB, 0.16958136E-09_JPRB, &
  & 0.16956986E-09_JPRB, 0.16955096E-09_JPRB, 0.16952238E-09_JPRB, 0.16948593E-09_JPRB, 0.16944975E-09_JPRB, 0.16942044E-09_JPRB, &
  & 0.16939944E-09_JPRB, 0.16938827E-09_JPRB, 0.16938741E-09_JPRB, 0.16939780E-09_JPRB, 0.16941896E-09_JPRB, 0.16945038E-09_JPRB, &
  & 0.16948894E-09_JPRB, 0.16953136E-09_JPRB, 0.16957422E-09_JPRB, 0.16961556E-09_JPRB, 0.16965182E-09_JPRB, 0.16968237E-09_JPRB, &
  & 0.16970657E-09_JPRB, 0.16972534E-09_JPRB, 0.16973750E-09_JPRB, 0.16974519E-09_JPRB, 0.16974959E-09_JPRB, 0.16975189E-09_JPRB, &
  & 0.16975298E-09_JPRB, 0.16975218E-09_JPRB, 0.16975055E-09_JPRB, 0.16974963E-09_JPRB, 0.16974894E-09_JPRB, 0.16974690E-09_JPRB, &
  & 0.16974680E-09_JPRB, 0.16974441E-09_JPRB, 0.16973584E-09_JPRB, 0.16970246E-09_JPRB /)

RGHG8(:,76, 4) = (/ &
  & 0.16964963E-09_JPRB, 0.16973170E-09_JPRB, 0.16976220E-09_JPRB, 0.16977841E-09_JPRB, 0.16979013E-09_JPRB, 0.16979888E-09_JPRB, &
  & 0.16980578E-09_JPRB, 0.16981168E-09_JPRB, 0.16981549E-09_JPRB, 0.16981955E-09_JPRB, 0.16982031E-09_JPRB, 0.16981817E-09_JPRB, &
  & 0.16981189E-09_JPRB, 0.16979933E-09_JPRB, 0.16978061E-09_JPRB, 0.16975647E-09_JPRB, 0.16972838E-09_JPRB, 0.16969935E-09_JPRB, &
  & 0.16967203E-09_JPRB, 0.16964960E-09_JPRB, 0.16963497E-09_JPRB, 0.16962869E-09_JPRB, 0.16962894E-09_JPRB, 0.16963536E-09_JPRB, &
  & 0.16964599E-09_JPRB, 0.16965723E-09_JPRB, 0.16966568E-09_JPRB, 0.16967168E-09_JPRB, 0.16967279E-09_JPRB, 0.16966847E-09_JPRB, &
  & 0.16965918E-09_JPRB, 0.16964455E-09_JPRB, 0.16962252E-09_JPRB, 0.16959370E-09_JPRB, 0.16956564E-09_JPRB, 0.16954305E-09_JPRB, &
  & 0.16952732E-09_JPRB, 0.16951918E-09_JPRB, 0.16951900E-09_JPRB, 0.16952778E-09_JPRB, 0.16954492E-09_JPRB, 0.16956983E-09_JPRB, &
  & 0.16960058E-09_JPRB, 0.16963365E-09_JPRB, 0.16966702E-09_JPRB, 0.16969956E-09_JPRB, 0.16972769E-09_JPRB, 0.16975236E-09_JPRB, &
  & 0.16977103E-09_JPRB, 0.16978668E-09_JPRB, 0.16979619E-09_JPRB, 0.16980280E-09_JPRB, 0.16980638E-09_JPRB, 0.16980842E-09_JPRB, &
  & 0.16980979E-09_JPRB, 0.16980935E-09_JPRB, 0.16980815E-09_JPRB, 0.16980777E-09_JPRB, 0.16980761E-09_JPRB, 0.16980592E-09_JPRB, &
  & 0.16980584E-09_JPRB, 0.16980349E-09_JPRB, 0.16979582E-09_JPRB, 0.16976412E-09_JPRB /)

RGHG8(:,77, 4) = (/ &
  & 0.16973438E-09_JPRB, 0.16980525E-09_JPRB, 0.16983090E-09_JPRB, 0.16984278E-09_JPRB, 0.16985176E-09_JPRB, 0.16985903E-09_JPRB, &
  & 0.16986426E-09_JPRB, 0.16986901E-09_JPRB, 0.16987119E-09_JPRB, 0.16987411E-09_JPRB, 0.16987425E-09_JPRB, 0.16987259E-09_JPRB, &
  & 0.16986769E-09_JPRB, 0.16985846E-09_JPRB, 0.16984451E-09_JPRB, 0.16982703E-09_JPRB, 0.16980646E-09_JPRB, 0.16978557E-09_JPRB, &
  & 0.16976530E-09_JPRB, 0.16974869E-09_JPRB, 0.16973768E-09_JPRB, 0.16973306E-09_JPRB, 0.16973228E-09_JPRB, 0.16973606E-09_JPRB, &
  & 0.16974332E-09_JPRB, 0.16975102E-09_JPRB, 0.16975636E-09_JPRB, 0.16976059E-09_JPRB, 0.16976115E-09_JPRB, 0.16975764E-09_JPRB, &
  & 0.16975048E-09_JPRB, 0.16974007E-09_JPRB, 0.16972458E-09_JPRB, 0.16970349E-09_JPRB, 0.16968313E-09_JPRB, 0.16966736E-09_JPRB, &
  & 0.16965648E-09_JPRB, 0.16965106E-09_JPRB, 0.16965138E-09_JPRB, 0.16965832E-09_JPRB, 0.16967101E-09_JPRB, 0.16968930E-09_JPRB, &
  & 0.16971162E-09_JPRB, 0.16973561E-09_JPRB, 0.16975960E-09_JPRB, 0.16978306E-09_JPRB, 0.16980364E-09_JPRB, 0.16982164E-09_JPRB, &
  & 0.16983519E-09_JPRB, 0.16984716E-09_JPRB, 0.16985405E-09_JPRB, 0.16985920E-09_JPRB, 0.16986200E-09_JPRB, 0.16986344E-09_JPRB, &
  & 0.16986504E-09_JPRB, 0.16986476E-09_JPRB, 0.16986382E-09_JPRB, 0.16986385E-09_JPRB, 0.16986421E-09_JPRB, 0.16986283E-09_JPRB, &
  & 0.16986262E-09_JPRB, 0.16986026E-09_JPRB, 0.16985324E-09_JPRB, 0.16982429E-09_JPRB /)

RGHG8(:,78, 4) = (/ &
  & 0.16981751E-09_JPRB, 0.16987260E-09_JPRB, 0.16989035E-09_JPRB, 0.16989792E-09_JPRB, 0.16990429E-09_JPRB, 0.16990973E-09_JPRB, &
  & 0.16991354E-09_JPRB, 0.16991668E-09_JPRB, 0.16991718E-09_JPRB, 0.16991908E-09_JPRB, 0.16991869E-09_JPRB, 0.16991736E-09_JPRB, &
  & 0.16991419E-09_JPRB, 0.16990832E-09_JPRB, 0.16989925E-09_JPRB, 0.16988819E-09_JPRB, 0.16987503E-09_JPRB, 0.16986196E-09_JPRB, &
  & 0.16984872E-09_JPRB, 0.16983785E-09_JPRB, 0.16983104E-09_JPRB, 0.16982897E-09_JPRB, 0.16982815E-09_JPRB, 0.16983034E-09_JPRB, &
  & 0.16983522E-09_JPRB, 0.16984017E-09_JPRB, 0.16984307E-09_JPRB, 0.16984612E-09_JPRB, 0.16984641E-09_JPRB, 0.16984393E-09_JPRB, &
  & 0.16983887E-09_JPRB, 0.16983233E-09_JPRB, 0.16982295E-09_JPRB, 0.16980906E-09_JPRB, 0.16979600E-09_JPRB, 0.16978634E-09_JPRB, &
  & 0.16977959E-09_JPRB, 0.16977621E-09_JPRB, 0.16977651E-09_JPRB, 0.16978140E-09_JPRB, 0.16978947E-09_JPRB, 0.16980120E-09_JPRB, &
  & 0.16981525E-09_JPRB, 0.16983073E-09_JPRB, 0.16984557E-09_JPRB, 0.16986101E-09_JPRB, 0.16987391E-09_JPRB, 0.16988602E-09_JPRB, &
  & 0.16989421E-09_JPRB, 0.16990293E-09_JPRB, 0.16990709E-09_JPRB, 0.16991095E-09_JPRB, 0.16991274E-09_JPRB, 0.16991343E-09_JPRB, &
  & 0.16991505E-09_JPRB, 0.16991468E-09_JPRB, 0.16991386E-09_JPRB, 0.16991410E-09_JPRB, 0.16991480E-09_JPRB, 0.16991378E-09_JPRB, &
  & 0.16991313E-09_JPRB, 0.16991059E-09_JPRB, 0.16990574E-09_JPRB, 0.16988233E-09_JPRB /)

RGHG8(:,79, 4) = (/ &
  & 0.16987145E-09_JPRB, 0.16991009E-09_JPRB, 0.16992228E-09_JPRB, 0.16992643E-09_JPRB, 0.16993137E-09_JPRB, 0.16993611E-09_JPRB, &
  & 0.16993884E-09_JPRB, 0.16994131E-09_JPRB, 0.16994073E-09_JPRB, 0.16994225E-09_JPRB, 0.16994162E-09_JPRB, 0.16994049E-09_JPRB, &
  & 0.16993833E-09_JPRB, 0.16993426E-09_JPRB, 0.16992759E-09_JPRB, 0.16992001E-09_JPRB, 0.16991068E-09_JPRB, 0.16990190E-09_JPRB, &
  & 0.16989229E-09_JPRB, 0.16988468E-09_JPRB, 0.16988028E-09_JPRB, 0.16987986E-09_JPRB, 0.16987914E-09_JPRB, 0.16988065E-09_JPRB, &
  & 0.16988447E-09_JPRB, 0.16988815E-09_JPRB, 0.16988974E-09_JPRB, 0.16989235E-09_JPRB, 0.16989257E-09_JPRB, 0.16989067E-09_JPRB, &
  & 0.16988662E-09_JPRB, 0.16988225E-09_JPRB, 0.16987635E-09_JPRB, 0.16986633E-09_JPRB, 0.16985707E-09_JPRB, 0.16985068E-09_JPRB, &
  & 0.16984598E-09_JPRB, 0.16984353E-09_JPRB, 0.16984360E-09_JPRB, 0.16984711E-09_JPRB, 0.16985255E-09_JPRB, 0.16986045E-09_JPRB, &
  & 0.16987008E-09_JPRB, 0.16988086E-09_JPRB, 0.16989095E-09_JPRB, 0.16990190E-09_JPRB, 0.16991089E-09_JPRB, 0.16991974E-09_JPRB, &
  & 0.16992499E-09_JPRB, 0.16993210E-09_JPRB, 0.16993475E-09_JPRB, 0.16993797E-09_JPRB, 0.16993919E-09_JPRB, 0.16993931E-09_JPRB, &
  & 0.16994105E-09_JPRB, 0.16994052E-09_JPRB, 0.16993956E-09_JPRB, 0.16993994E-09_JPRB, 0.16994089E-09_JPRB, 0.16994003E-09_JPRB, &
  & 0.16993908E-09_JPRB, 0.16993697E-09_JPRB, 0.16993454E-09_JPRB, 0.16991916E-09_JPRB /)

RGHG8(:,80, 4) = (/ &
  & 0.16990706E-09_JPRB, 0.16992834E-09_JPRB, 0.16993627E-09_JPRB, 0.16993873E-09_JPRB, 0.16994296E-09_JPRB, 0.16994740E-09_JPRB, &
  & 0.16994986E-09_JPRB, 0.16995197E-09_JPRB, 0.16995097E-09_JPRB, 0.16995236E-09_JPRB, 0.16995172E-09_JPRB, 0.16995086E-09_JPRB, &
  & 0.16994905E-09_JPRB, 0.16994584E-09_JPRB, 0.16994020E-09_JPRB, 0.16993412E-09_JPRB, 0.16992655E-09_JPRB, 0.16991977E-09_JPRB, &
  & 0.16991181E-09_JPRB, 0.16990555E-09_JPRB, 0.16990230E-09_JPRB, 0.16990276E-09_JPRB, 0.16990201E-09_JPRB, 0.16990323E-09_JPRB, &
  & 0.16990666E-09_JPRB, 0.16990977E-09_JPRB, 0.16991082E-09_JPRB, 0.16991326E-09_JPRB, 0.16991357E-09_JPRB, 0.16991196E-09_JPRB, &
  & 0.16990837E-09_JPRB, 0.16990503E-09_JPRB, 0.16990075E-09_JPRB, 0.16989243E-09_JPRB, 0.16988488E-09_JPRB, 0.16987994E-09_JPRB, &
  & 0.16987611E-09_JPRB, 0.16987396E-09_JPRB, 0.16987384E-09_JPRB, 0.16987668E-09_JPRB, 0.16988079E-09_JPRB, 0.16988698E-09_JPRB, &
  & 0.16989453E-09_JPRB, 0.16990329E-09_JPRB, 0.16991106E-09_JPRB, 0.16992011E-09_JPRB, 0.16992721E-09_JPRB, 0.16993469E-09_JPRB, &
  & 0.16993852E-09_JPRB, 0.16994496E-09_JPRB, 0.16994686E-09_JPRB, 0.16994980E-09_JPRB, 0.16995073E-09_JPRB, 0.16995051E-09_JPRB, &
  & 0.16995233E-09_JPRB, 0.16995165E-09_JPRB, 0.16995058E-09_JPRB, 0.16995101E-09_JPRB, 0.16995218E-09_JPRB, 0.16995133E-09_JPRB, &
  & 0.16995026E-09_JPRB, 0.16994829E-09_JPRB, 0.16994822E-09_JPRB, 0.16994312E-09_JPRB /)

RGHG8(:,81, 4) = (/ &
  & 0.16993139E-09_JPRB, 0.16993602E-09_JPRB, 0.16994220E-09_JPRB, 0.16994389E-09_JPRB, 0.16994789E-09_JPRB, 0.16995230E-09_JPRB, &
  & 0.16995441E-09_JPRB, 0.16995655E-09_JPRB, 0.16995537E-09_JPRB, 0.16995697E-09_JPRB, 0.16995635E-09_JPRB, 0.16995540E-09_JPRB, &
  & 0.16995391E-09_JPRB, 0.16995100E-09_JPRB, 0.16994578E-09_JPRB, 0.16994037E-09_JPRB, 0.16993357E-09_JPRB, 0.16992775E-09_JPRB, &
  & 0.16992044E-09_JPRB, 0.16991478E-09_JPRB, 0.16991200E-09_JPRB, 0.16991289E-09_JPRB, 0.16991207E-09_JPRB, 0.16991311E-09_JPRB, &
  & 0.16991640E-09_JPRB, 0.16991931E-09_JPRB, 0.16992006E-09_JPRB, 0.16992252E-09_JPRB, 0.16992287E-09_JPRB, 0.16992137E-09_JPRB, &
  & 0.16991794E-09_JPRB, 0.16991510E-09_JPRB, 0.16991157E-09_JPRB, 0.16990398E-09_JPRB, 0.16989719E-09_JPRB, 0.16989288E-09_JPRB, &
  & 0.16988939E-09_JPRB, 0.16988741E-09_JPRB, 0.16988716E-09_JPRB, 0.16988964E-09_JPRB, 0.16989321E-09_JPRB, 0.16989855E-09_JPRB, &
  & 0.16990520E-09_JPRB, 0.16991306E-09_JPRB, 0.16991987E-09_JPRB, 0.16992809E-09_JPRB, 0.16993439E-09_JPRB, 0.16994121E-09_JPRB, &
  & 0.16994435E-09_JPRB, 0.16995060E-09_JPRB, 0.16995208E-09_JPRB, 0.16995491E-09_JPRB, 0.16995567E-09_JPRB, 0.16995529E-09_JPRB, &
  & 0.16995721E-09_JPRB, 0.16995642E-09_JPRB, 0.16995526E-09_JPRB, 0.16995573E-09_JPRB, 0.16995699E-09_JPRB, 0.16995612E-09_JPRB, &
  & 0.16995498E-09_JPRB, 0.16995300E-09_JPRB, 0.16995386E-09_JPRB, 0.16995931E-09_JPRB /)

RGHG8(:,82, 4) = (/ &
  & 0.16993333E-09_JPRB, 0.16993859E-09_JPRB, 0.16994482E-09_JPRB, 0.16994633E-09_JPRB, 0.16995029E-09_JPRB, 0.16995461E-09_JPRB, &
  & 0.16995708E-09_JPRB, 0.16995896E-09_JPRB, 0.16995762E-09_JPRB, 0.16995896E-09_JPRB, 0.16995837E-09_JPRB, 0.16995777E-09_JPRB, &
  & 0.16995624E-09_JPRB, 0.16995355E-09_JPRB, 0.16994857E-09_JPRB, 0.16994343E-09_JPRB, 0.16993706E-09_JPRB, 0.16993168E-09_JPRB, &
  & 0.16992474E-09_JPRB, 0.16991929E-09_JPRB, 0.16991676E-09_JPRB, 0.16991789E-09_JPRB, 0.16991697E-09_JPRB, 0.16991790E-09_JPRB, &
  & 0.16992116E-09_JPRB, 0.16992398E-09_JPRB, 0.16992460E-09_JPRB, 0.16992703E-09_JPRB, 0.16992741E-09_JPRB, 0.16992599E-09_JPRB, &
  & 0.16992262E-09_JPRB, 0.16992001E-09_JPRB, 0.16991684E-09_JPRB, 0.16990963E-09_JPRB, 0.16990320E-09_JPRB, 0.16989921E-09_JPRB, &
  & 0.16989592E-09_JPRB, 0.16989399E-09_JPRB, 0.16989368E-09_JPRB, 0.16989604E-09_JPRB, 0.16989925E-09_JPRB, 0.16990430E-09_JPRB, &
  & 0.16991042E-09_JPRB, 0.16991787E-09_JPRB, 0.16992417E-09_JPRB, 0.16993205E-09_JPRB, 0.16993783E-09_JPRB, 0.16994442E-09_JPRB, &
  & 0.16994717E-09_JPRB, 0.16995340E-09_JPRB, 0.16995463E-09_JPRB, 0.16995741E-09_JPRB, 0.16995809E-09_JPRB, 0.16995763E-09_JPRB, &
  & 0.16995959E-09_JPRB, 0.16995876E-09_JPRB, 0.16995752E-09_JPRB, 0.16995799E-09_JPRB, 0.16995934E-09_JPRB, 0.16995846E-09_JPRB, &
  & 0.16995719E-09_JPRB, 0.16995504E-09_JPRB, 0.16995573E-09_JPRB, 0.16996060E-09_JPRB /)

RGHG8(:,83, 4) = (/ &
  & 0.16993465E-09_JPRB, 0.16994010E-09_JPRB, 0.16994629E-09_JPRB, 0.16994772E-09_JPRB, 0.16995151E-09_JPRB, 0.16995609E-09_JPRB, &
  & 0.16995783E-09_JPRB, 0.16995999E-09_JPRB, 0.16995882E-09_JPRB, 0.16996043E-09_JPRB, 0.16995991E-09_JPRB, 0.16995896E-09_JPRB, &
  & 0.16995767E-09_JPRB, 0.16995499E-09_JPRB, 0.16995014E-09_JPRB, 0.16994521E-09_JPRB, 0.16993898E-09_JPRB, 0.16993397E-09_JPRB, &
  & 0.16992711E-09_JPRB, 0.16992187E-09_JPRB, 0.16991941E-09_JPRB, 0.16992076E-09_JPRB, 0.16991973E-09_JPRB, 0.16992062E-09_JPRB, &
  & 0.16992384E-09_JPRB, 0.16992663E-09_JPRB, 0.16992711E-09_JPRB, 0.16992957E-09_JPRB, 0.16992997E-09_JPRB, 0.16992857E-09_JPRB, &
  & 0.16992523E-09_JPRB, 0.16992273E-09_JPRB, 0.16991976E-09_JPRB, 0.16991270E-09_JPRB, 0.16990652E-09_JPRB, 0.16990276E-09_JPRB, &
  & 0.16989958E-09_JPRB, 0.16989776E-09_JPRB, 0.16989753E-09_JPRB, 0.16989968E-09_JPRB, 0.16990280E-09_JPRB, 0.16990739E-09_JPRB, &
  & 0.16991329E-09_JPRB, 0.16992044E-09_JPRB, 0.16992655E-09_JPRB, 0.16993419E-09_JPRB, 0.16993980E-09_JPRB, 0.16994624E-09_JPRB, &
  & 0.16994879E-09_JPRB, 0.16995498E-09_JPRB, 0.16995609E-09_JPRB, 0.16995882E-09_JPRB, 0.16995945E-09_JPRB, 0.16995891E-09_JPRB, &
  & 0.16996096E-09_JPRB, 0.16996005E-09_JPRB, 0.16995877E-09_JPRB, 0.16995927E-09_JPRB, 0.16996068E-09_JPRB, 0.16995980E-09_JPRB, &
  & 0.16995844E-09_JPRB, 0.16995616E-09_JPRB, 0.16995681E-09_JPRB, 0.16996148E-09_JPRB /)

RGHG8(:,84, 4) = (/ &
  & 0.16993554E-09_JPRB, 0.16994105E-09_JPRB, 0.16994722E-09_JPRB, 0.16994856E-09_JPRB, 0.16995251E-09_JPRB, 0.16995670E-09_JPRB, &
  & 0.16995935E-09_JPRB, 0.16996089E-09_JPRB, 0.16995971E-09_JPRB, 0.16996075E-09_JPRB, 0.16996030E-09_JPRB, 0.16995978E-09_JPRB, &
  & 0.16995835E-09_JPRB, 0.16995585E-09_JPRB, 0.16995122E-09_JPRB, 0.16994631E-09_JPRB, 0.16994026E-09_JPRB, 0.16993533E-09_JPRB, &
  & 0.16992868E-09_JPRB, 0.16992341E-09_JPRB, 0.16992102E-09_JPRB, 0.16992258E-09_JPRB, 0.16992140E-09_JPRB, 0.16992222E-09_JPRB, &
  & 0.16992552E-09_JPRB, 0.16992825E-09_JPRB, 0.16992859E-09_JPRB, 0.16993114E-09_JPRB, 0.16993153E-09_JPRB, 0.16993013E-09_JPRB, &
  & 0.16992678E-09_JPRB, 0.16992439E-09_JPRB, 0.16992152E-09_JPRB, 0.16991461E-09_JPRB, 0.16990857E-09_JPRB, 0.16990492E-09_JPRB, &
  & 0.16990186E-09_JPRB, 0.16990014E-09_JPRB, 0.16989998E-09_JPRB, 0.16990208E-09_JPRB, 0.16990495E-09_JPRB, 0.16990939E-09_JPRB, &
  & 0.16991497E-09_JPRB, 0.16992183E-09_JPRB, 0.16992788E-09_JPRB, 0.16993554E-09_JPRB, 0.16994095E-09_JPRB, 0.16994735E-09_JPRB, &
  & 0.16994975E-09_JPRB, 0.16995599E-09_JPRB, 0.16995697E-09_JPRB, 0.16995971E-09_JPRB, 0.16996030E-09_JPRB, 0.16995969E-09_JPRB, &
  & 0.16996181E-09_JPRB, 0.16996086E-09_JPRB, 0.16995953E-09_JPRB, 0.16996007E-09_JPRB, 0.16996152E-09_JPRB, 0.16996064E-09_JPRB, &
  & 0.16995923E-09_JPRB, 0.16995687E-09_JPRB, 0.16995746E-09_JPRB, 0.16996207E-09_JPRB /)

RGHG8(:,85, 4) = (/ &
  & 0.16993612E-09_JPRB, 0.16994169E-09_JPRB, 0.16994783E-09_JPRB, 0.16994910E-09_JPRB, 0.16995289E-09_JPRB, 0.16995763E-09_JPRB, &
  & 0.16995919E-09_JPRB, 0.16996107E-09_JPRB, 0.16996024E-09_JPRB, 0.16996132E-09_JPRB, 0.16996091E-09_JPRB, 0.16995999E-09_JPRB, &
  & 0.16995878E-09_JPRB, 0.16995622E-09_JPRB, 0.16995191E-09_JPRB, 0.16994714E-09_JPRB, 0.16994126E-09_JPRB, 0.16993640E-09_JPRB, &
  & 0.16992967E-09_JPRB, 0.16992444E-09_JPRB, 0.16992209E-09_JPRB, 0.16992374E-09_JPRB, 0.16992251E-09_JPRB, 0.16992326E-09_JPRB, &
  & 0.16992661E-09_JPRB, 0.16992932E-09_JPRB, 0.16992951E-09_JPRB, 0.16993217E-09_JPRB, 0.16993258E-09_JPRB, 0.16993118E-09_JPRB, &
  & 0.16992781E-09_JPRB, 0.16992548E-09_JPRB, 0.16992269E-09_JPRB, 0.16991578E-09_JPRB, 0.16990989E-09_JPRB, 0.16990631E-09_JPRB, &
  & 0.16990333E-09_JPRB, 0.16990173E-09_JPRB, 0.16990162E-09_JPRB, 0.16990359E-09_JPRB, 0.16990651E-09_JPRB, 0.16991067E-09_JPRB, &
  & 0.16991596E-09_JPRB, 0.16992278E-09_JPRB, 0.16992863E-09_JPRB, 0.16993629E-09_JPRB, 0.16994170E-09_JPRB, 0.16994804E-09_JPRB, &
  & 0.16995039E-09_JPRB, 0.16995670E-09_JPRB, 0.16995755E-09_JPRB, 0.16996028E-09_JPRB, 0.16996091E-09_JPRB, 0.16996021E-09_JPRB, &
  & 0.16996236E-09_JPRB, 0.16996141E-09_JPRB, 0.16996002E-09_JPRB, 0.16996059E-09_JPRB, 0.16996210E-09_JPRB, 0.16996121E-09_JPRB, &
  & 0.16995974E-09_JPRB, 0.16995728E-09_JPRB, 0.16995791E-09_JPRB, 0.16996243E-09_JPRB /)

RGHG8(:,86, 4) = (/ &
  & 0.16993645E-09_JPRB, 0.16994207E-09_JPRB, 0.16994822E-09_JPRB, 0.16994943E-09_JPRB, 0.16995361E-09_JPRB, 0.16995771E-09_JPRB, &
  & 0.16996013E-09_JPRB, 0.16996128E-09_JPRB, 0.16996053E-09_JPRB, 0.16996113E-09_JPRB, 0.16996068E-09_JPRB, 0.16996009E-09_JPRB, &
  & 0.16995856E-09_JPRB, 0.16995641E-09_JPRB, 0.16995244E-09_JPRB, 0.16994786E-09_JPRB, 0.16994209E-09_JPRB, 0.16993715E-09_JPRB, &
  & 0.16993047E-09_JPRB, 0.16992514E-09_JPRB, 0.16992276E-09_JPRB, 0.16992452E-09_JPRB, 0.16992314E-09_JPRB, 0.16992388E-09_JPRB, &
  & 0.16992732E-09_JPRB, 0.16993004E-09_JPRB, 0.16993011E-09_JPRB, 0.16993285E-09_JPRB, 0.16993328E-09_JPRB, 0.16993185E-09_JPRB, &
  & 0.16992845E-09_JPRB, 0.16992614E-09_JPRB, 0.16992338E-09_JPRB, 0.16991666E-09_JPRB, 0.16991071E-09_JPRB, 0.16990720E-09_JPRB, &
  & 0.16990423E-09_JPRB, 0.16990262E-09_JPRB, 0.16990254E-09_JPRB, 0.16990459E-09_JPRB, 0.16990737E-09_JPRB, 0.16991153E-09_JPRB, &
  & 0.16991683E-09_JPRB, 0.16992324E-09_JPRB, 0.16992929E-09_JPRB, 0.16993681E-09_JPRB, 0.16994216E-09_JPRB, 0.16994853E-09_JPRB, &
  & 0.16995078E-09_JPRB, 0.16995716E-09_JPRB, 0.16995796E-09_JPRB, 0.16996070E-09_JPRB, 0.16996128E-09_JPRB, 0.16996053E-09_JPRB, &
  & 0.16996272E-09_JPRB, 0.16996178E-09_JPRB, 0.16996032E-09_JPRB, 0.16996089E-09_JPRB, 0.16996249E-09_JPRB, 0.16996164E-09_JPRB, &
  & 0.16996010E-09_JPRB, 0.16995758E-09_JPRB, 0.16995814E-09_JPRB, 0.16996266E-09_JPRB /)

RGHG8(:,87, 4) = (/ &
  & 0.16993672E-09_JPRB, 0.16994238E-09_JPRB, 0.16994840E-09_JPRB, 0.16994972E-09_JPRB, 0.16995354E-09_JPRB, 0.16995844E-09_JPRB, &
  & 0.16995985E-09_JPRB, 0.16996124E-09_JPRB, 0.16996068E-09_JPRB, 0.16996116E-09_JPRB, 0.16996074E-09_JPRB, 0.16995980E-09_JPRB, &
  & 0.16995863E-09_JPRB, 0.16995622E-09_JPRB, 0.16995277E-09_JPRB, 0.16994829E-09_JPRB, 0.16994285E-09_JPRB, 0.16993769E-09_JPRB, &
  & 0.16993107E-09_JPRB, 0.16992567E-09_JPRB, 0.16992317E-09_JPRB, 0.16992502E-09_JPRB, 0.16992358E-09_JPRB, 0.16992424E-09_JPRB, &
  & 0.16992775E-09_JPRB, 0.16993049E-09_JPRB, 0.16993047E-09_JPRB, 0.16993326E-09_JPRB, 0.16993368E-09_JPRB, 0.16993229E-09_JPRB, &
  & 0.16992883E-09_JPRB, 0.16992657E-09_JPRB, 0.16992395E-09_JPRB, 0.16991718E-09_JPRB, 0.16991131E-09_JPRB, 0.16990778E-09_JPRB, &
  & 0.16990473E-09_JPRB, 0.16990299E-09_JPRB, 0.16990284E-09_JPRB, 0.16990491E-09_JPRB, 0.16990781E-09_JPRB, 0.16991203E-09_JPRB, &
  & 0.16991722E-09_JPRB, 0.16992412E-09_JPRB, 0.16992975E-09_JPRB, 0.16993734E-09_JPRB, 0.16994252E-09_JPRB, 0.16994882E-09_JPRB, &
  & 0.16995101E-09_JPRB, 0.16995745E-09_JPRB, 0.16995816E-09_JPRB, 0.16996095E-09_JPRB, 0.16996152E-09_JPRB, 0.16996077E-09_JPRB, &
  & 0.16996296E-09_JPRB, 0.16996196E-09_JPRB, 0.16996049E-09_JPRB, 0.16996110E-09_JPRB, 0.16996268E-09_JPRB, 0.16996186E-09_JPRB, &
  & 0.16996030E-09_JPRB, 0.16995771E-09_JPRB, 0.16995824E-09_JPRB, 0.16996277E-09_JPRB /)

RGHG8(:,88, 4) = (/ &
  & 0.16993712E-09_JPRB, 0.16994267E-09_JPRB, 0.16994842E-09_JPRB, 0.16994978E-09_JPRB, 0.16995418E-09_JPRB, 0.16995814E-09_JPRB, &
  & 0.16996030E-09_JPRB, 0.16996127E-09_JPRB, 0.16996066E-09_JPRB, 0.16996100E-09_JPRB, 0.16996046E-09_JPRB, 0.16995982E-09_JPRB, &
  & 0.16995835E-09_JPRB, 0.16995645E-09_JPRB, 0.16995289E-09_JPRB, 0.16994865E-09_JPRB, 0.16994312E-09_JPRB, 0.16993812E-09_JPRB, &
  & 0.16993144E-09_JPRB, 0.16992596E-09_JPRB, 0.16992344E-09_JPRB, 0.16992535E-09_JPRB, 0.16992381E-09_JPRB, 0.16992445E-09_JPRB, &
  & 0.16992803E-09_JPRB, 0.16993076E-09_JPRB, 0.16993064E-09_JPRB, 0.16993355E-09_JPRB, 0.16993397E-09_JPRB, 0.16993258E-09_JPRB, &
  & 0.16992908E-09_JPRB, 0.16992688E-09_JPRB, 0.16992432E-09_JPRB, 0.16991761E-09_JPRB, 0.16991161E-09_JPRB, 0.16990817E-09_JPRB, &
  & 0.16990494E-09_JPRB, 0.16990306E-09_JPRB, 0.16990273E-09_JPRB, 0.16990501E-09_JPRB, 0.16990782E-09_JPRB, 0.16991220E-09_JPRB, &
  & 0.16991783E-09_JPRB, 0.16992460E-09_JPRB, 0.16993033E-09_JPRB, 0.16993777E-09_JPRB, 0.16994275E-09_JPRB, 0.16994901E-09_JPRB, &
  & 0.16995119E-09_JPRB, 0.16995769E-09_JPRB, 0.16995831E-09_JPRB, 0.16996116E-09_JPRB, 0.16996167E-09_JPRB, 0.16996092E-09_JPRB, &
  & 0.16996313E-09_JPRB, 0.16996207E-09_JPRB, 0.16996059E-09_JPRB, 0.16996121E-09_JPRB, 0.16996286E-09_JPRB, 0.16996204E-09_JPRB, &
  & 0.16996042E-09_JPRB, 0.16995783E-09_JPRB, 0.16995831E-09_JPRB, 0.16996285E-09_JPRB /)

RGHG8(:,89, 4) = (/ &
  & 0.16993769E-09_JPRB, 0.16994307E-09_JPRB, 0.16994828E-09_JPRB, 0.16994979E-09_JPRB, 0.16995368E-09_JPRB, 0.16995857E-09_JPRB, &
  & 0.16996007E-09_JPRB, 0.16996143E-09_JPRB, 0.16996077E-09_JPRB, 0.16996120E-09_JPRB, 0.16996074E-09_JPRB, 0.16995988E-09_JPRB, &
  & 0.16995876E-09_JPRB, 0.16995644E-09_JPRB, 0.16995309E-09_JPRB, 0.16994861E-09_JPRB, 0.16994317E-09_JPRB, 0.16993809E-09_JPRB, &
  & 0.16993146E-09_JPRB, 0.16992600E-09_JPRB, 0.16992351E-09_JPRB, 0.16992553E-09_JPRB, 0.16992394E-09_JPRB, 0.16992452E-09_JPRB, &
  & 0.16992822E-09_JPRB, 0.16993096E-09_JPRB, 0.16993074E-09_JPRB, 0.16993369E-09_JPRB, 0.16993416E-09_JPRB, 0.16993278E-09_JPRB, &
  & 0.16992918E-09_JPRB, 0.16992703E-09_JPRB, 0.16992459E-09_JPRB, 0.16991783E-09_JPRB, 0.16991177E-09_JPRB, 0.16990839E-09_JPRB, &
  & 0.16990505E-09_JPRB, 0.16990305E-09_JPRB, 0.16990254E-09_JPRB, 0.16990491E-09_JPRB, 0.16990775E-09_JPRB, 0.16991236E-09_JPRB, &
  & 0.16991801E-09_JPRB, 0.16992531E-09_JPRB, 0.16993064E-09_JPRB, 0.16993808E-09_JPRB, 0.16994291E-09_JPRB, 0.16994917E-09_JPRB, &
  & 0.16995122E-09_JPRB, 0.16995785E-09_JPRB, 0.16995838E-09_JPRB, 0.16996128E-09_JPRB, 0.16996178E-09_JPRB, 0.16996099E-09_JPRB, &
  & 0.16996324E-09_JPRB, 0.16996216E-09_JPRB, 0.16996062E-09_JPRB, 0.16996128E-09_JPRB, 0.16996297E-09_JPRB, 0.16996213E-09_JPRB, &
  & 0.16996050E-09_JPRB, 0.16995785E-09_JPRB, 0.16995831E-09_JPRB, 0.16996290E-09_JPRB /)

RGHG8(:,90, 4) = (/ &
  & 0.16993824E-09_JPRB, 0.16994342E-09_JPRB, 0.16994797E-09_JPRB, 0.16994955E-09_JPRB, 0.16995376E-09_JPRB, 0.16995827E-09_JPRB, &
  & 0.16996041E-09_JPRB, 0.16996196E-09_JPRB, 0.16996082E-09_JPRB, 0.16996166E-09_JPRB, 0.16996111E-09_JPRB, 0.16996052E-09_JPRB, &
  & 0.16995913E-09_JPRB, 0.16995703E-09_JPRB, 0.16995301E-09_JPRB, 0.16994843E-09_JPRB, 0.16994264E-09_JPRB, 0.16993798E-09_JPRB, &
  & 0.16993124E-09_JPRB, 0.16992587E-09_JPRB, 0.16992341E-09_JPRB, 0.16992570E-09_JPRB, 0.16992391E-09_JPRB, 0.16992449E-09_JPRB, &
  & 0.16992831E-09_JPRB, 0.16993111E-09_JPRB, 0.16993072E-09_JPRB, 0.16993384E-09_JPRB, 0.16993430E-09_JPRB, 0.16993296E-09_JPRB, &
  & 0.16992922E-09_JPRB, 0.16992713E-09_JPRB, 0.16992488E-09_JPRB, 0.16991789E-09_JPRB, 0.16991177E-09_JPRB, 0.16990845E-09_JPRB, &
  & 0.16990506E-09_JPRB, 0.16990298E-09_JPRB, 0.16990230E-09_JPRB, 0.16990487E-09_JPRB, 0.16990762E-09_JPRB, 0.16991235E-09_JPRB, &
  & 0.16991818E-09_JPRB, 0.16992559E-09_JPRB, 0.16993081E-09_JPRB, 0.16993829E-09_JPRB, 0.16994296E-09_JPRB, 0.16994935E-09_JPRB, &
  & 0.16995118E-09_JPRB, 0.16995806E-09_JPRB, 0.16995835E-09_JPRB, 0.16996142E-09_JPRB, 0.16996184E-09_JPRB, 0.16996095E-09_JPRB, &
  & 0.16996334E-09_JPRB, 0.16996218E-09_JPRB, 0.16996057E-09_JPRB, 0.16996132E-09_JPRB, 0.16996310E-09_JPRB, 0.16996220E-09_JPRB, &
  & 0.16996055E-09_JPRB, 0.16995781E-09_JPRB, 0.16995828E-09_JPRB, 0.16996299E-09_JPRB /)

RGHG8(:,91, 4) = (/ &
  & 0.16993840E-09_JPRB, 0.16994370E-09_JPRB, 0.16994745E-09_JPRB, 0.16994926E-09_JPRB, 0.16995340E-09_JPRB, 0.16995846E-09_JPRB, &
  & 0.16995994E-09_JPRB, 0.16996371E-09_JPRB, 0.16995888E-09_JPRB, 0.16996364E-09_JPRB, 0.16996157E-09_JPRB, 0.16996141E-09_JPRB, &
  & 0.16996002E-09_JPRB, 0.16995756E-09_JPRB, 0.16995247E-09_JPRB, 0.16994797E-09_JPRB, 0.16994189E-09_JPRB, 0.16993792E-09_JPRB, &
  & 0.16993090E-09_JPRB, 0.16992557E-09_JPRB, 0.16992308E-09_JPRB, 0.16992598E-09_JPRB, 0.16992377E-09_JPRB, 0.16992430E-09_JPRB, &
  & 0.16992839E-09_JPRB, 0.16993132E-09_JPRB, 0.16993049E-09_JPRB, 0.16993407E-09_JPRB, 0.16993451E-09_JPRB, 0.16993319E-09_JPRB, &
  & 0.16992913E-09_JPRB, 0.16992720E-09_JPRB, 0.16992538E-09_JPRB, 0.16991779E-09_JPRB, 0.16991156E-09_JPRB, 0.16990846E-09_JPRB, &
  & 0.16990495E-09_JPRB, 0.16990287E-09_JPRB, 0.16990204E-09_JPRB, 0.16990487E-09_JPRB, 0.16990746E-09_JPRB, 0.16991228E-09_JPRB, &
  & 0.16991811E-09_JPRB, 0.16992587E-09_JPRB, 0.16993071E-09_JPRB, 0.16993847E-09_JPRB, 0.16994288E-09_JPRB, 0.16994975E-09_JPRB, &
  & 0.16995083E-09_JPRB, 0.16995855E-09_JPRB, 0.16995820E-09_JPRB, 0.16996159E-09_JPRB, 0.16996193E-09_JPRB, 0.16996077E-09_JPRB, &
  & 0.16996364E-09_JPRB, 0.16996222E-09_JPRB, 0.16996043E-09_JPRB, 0.16996127E-09_JPRB, 0.16996328E-09_JPRB, 0.16996225E-09_JPRB, &
  & 0.16996056E-09_JPRB, 0.16995758E-09_JPRB, 0.16995828E-09_JPRB, 0.16996313E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART8',1,ZHOOK_HANDLE)
END SUBROUTINE PART8






SUBROUTINE PART9
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART9',0,ZHOOK_HANDLE)



!-- Month=  5 ------------

RGHG8(:, 1, 5) = (/ &
  & 0.38361946E-10_JPRB, 0.38726224E-10_JPRB, 0.38896129E-10_JPRB, 0.39133630E-10_JPRB, 0.39409139E-10_JPRB, 0.39817344E-10_JPRB, &
  & 0.40275033E-10_JPRB, 0.40740761E-10_JPRB, 0.41200550E-10_JPRB, 0.41651370E-10_JPRB, 0.42091431E-10_JPRB, 0.42517864E-10_JPRB, &
  & 0.42924508E-10_JPRB, 0.43302806E-10_JPRB, 0.43647062E-10_JPRB, 0.43951162E-10_JPRB, 0.44214805E-10_JPRB, 0.44442387E-10_JPRB, &
  & 0.44637995E-10_JPRB, 0.44809496E-10_JPRB, 0.44964379E-10_JPRB, 0.45109354E-10_JPRB, 0.45249842E-10_JPRB, 0.45386656E-10_JPRB, &
  & 0.45514079E-10_JPRB, 0.45624445E-10_JPRB, 0.45708035E-10_JPRB, 0.45764711E-10_JPRB, 0.45798289E-10_JPRB, 0.45803809E-10_JPRB, &
  & 0.45778617E-10_JPRB, 0.45721062E-10_JPRB, 0.45623873E-10_JPRB, 0.45479391E-10_JPRB, 0.45293356E-10_JPRB, 0.45068730E-10_JPRB, &
  & 0.44812744E-10_JPRB, 0.44535518E-10_JPRB, 0.44263544E-10_JPRB, 0.44035119E-10_JPRB, 0.43850153E-10_JPRB, 0.43670338E-10_JPRB, &
  & 0.43487880E-10_JPRB, 0.43286166E-10_JPRB, 0.43057564E-10_JPRB, 0.42783090E-10_JPRB, 0.42434525E-10_JPRB, 0.41965181E-10_JPRB, &
  & 0.41245205E-10_JPRB, 0.40419623E-10_JPRB, 0.39666652E-10_JPRB, 0.38982366E-10_JPRB, 0.38370321E-10_JPRB, 0.37839253E-10_JPRB, &
  & 0.37391739E-10_JPRB, 0.37028328E-10_JPRB, 0.36736704E-10_JPRB, 0.36506114E-10_JPRB, 0.36326501E-10_JPRB, 0.36183983E-10_JPRB, &
  & 0.36068624E-10_JPRB, 0.35970883E-10_JPRB, 0.35884327E-10_JPRB, 0.35795863E-10_JPRB /)

RGHG8(:, 2, 5) = (/ &
  & 0.38486984E-10_JPRB, 0.38830012E-10_JPRB, 0.39082904E-10_JPRB, 0.39387264E-10_JPRB, 0.39763103E-10_JPRB, 0.40256326E-10_JPRB, &
  & 0.40827744E-10_JPRB, 0.41427951E-10_JPRB, 0.42014524E-10_JPRB, 0.42562259E-10_JPRB, 0.43058921E-10_JPRB, 0.43499759E-10_JPRB, &
  & 0.43892865E-10_JPRB, 0.44254184E-10_JPRB, 0.44600986E-10_JPRB, 0.44939392E-10_JPRB, 0.45266249E-10_JPRB, 0.45574280E-10_JPRB, &
  & 0.45856312E-10_JPRB, 0.46111132E-10_JPRB, 0.46341223E-10_JPRB, 0.46548761E-10_JPRB, 0.46742745E-10_JPRB, 0.46930942E-10_JPRB, &
  & 0.47116658E-10_JPRB, 0.47303682E-10_JPRB, 0.47489651E-10_JPRB, 0.47673927E-10_JPRB, 0.47853707E-10_JPRB, 0.48015134E-10_JPRB, &
  & 0.48134389E-10_JPRB, 0.48184227E-10_JPRB, 0.48145689E-10_JPRB, 0.48009666E-10_JPRB, 0.47782483E-10_JPRB, 0.47472009E-10_JPRB, &
  & 0.47089187E-10_JPRB, 0.46649185E-10_JPRB, 0.46196252E-10_JPRB, 0.45767685E-10_JPRB, 0.45389636E-10_JPRB, 0.45040475E-10_JPRB, &
  & 0.44699008E-10_JPRB, 0.44347054E-10_JPRB, 0.43961466E-10_JPRB, 0.43526772E-10_JPRB, 0.43019109E-10_JPRB, 0.42408431E-10_JPRB, &
  & 0.41676978E-10_JPRB, 0.40918845E-10_JPRB, 0.40194438E-10_JPRB, 0.39533966E-10_JPRB, 0.38930414E-10_JPRB, 0.38400880E-10_JPRB, &
  & 0.37948141E-10_JPRB, 0.37593980E-10_JPRB, 0.37316990E-10_JPRB, 0.37102973E-10_JPRB, 0.36931323E-10_JPRB, 0.36788021E-10_JPRB, &
  & 0.36664408E-10_JPRB, 0.36547737E-10_JPRB, 0.36425831E-10_JPRB, 0.36240125E-10_JPRB /)

RGHG8(:, 3, 5) = (/ &
  & 0.38511281E-10_JPRB, 0.38802815E-10_JPRB, 0.39060997E-10_JPRB, 0.39354790E-10_JPRB, 0.39728026E-10_JPRB, 0.40191236E-10_JPRB, &
  & 0.40729711E-10_JPRB, 0.41289631E-10_JPRB, 0.41835702E-10_JPRB, 0.42371304E-10_JPRB, 0.42910363E-10_JPRB, 0.43464631E-10_JPRB, &
  & 0.44019031E-10_JPRB, 0.44544490E-10_JPRB, 0.45030552E-10_JPRB, 0.45495628E-10_JPRB, 0.45966148E-10_JPRB, 0.46448415E-10_JPRB, &
  & 0.46925915E-10_JPRB, 0.47379451E-10_JPRB, 0.47797502E-10_JPRB, 0.48176543E-10_JPRB, 0.48520157E-10_JPRB, 0.48836254E-10_JPRB, &
  & 0.49135765E-10_JPRB, 0.49419368E-10_JPRB, 0.49694616E-10_JPRB, 0.49958433E-10_JPRB, 0.50207848E-10_JPRB, 0.50424380E-10_JPRB, &
  & 0.50569646E-10_JPRB, 0.50600264E-10_JPRB, 0.50493894E-10_JPRB, 0.50253454E-10_JPRB, 0.49907061E-10_JPRB, 0.49482994E-10_JPRB, &
  & 0.48998250E-10_JPRB, 0.48457217E-10_JPRB, 0.47857555E-10_JPRB, 0.47250169E-10_JPRB, 0.46664259E-10_JPRB, 0.46106261E-10_JPRB, &
  & 0.45567730E-10_JPRB, 0.45031017E-10_JPRB, 0.44484475E-10_JPRB, 0.43911749E-10_JPRB, 0.43298101E-10_JPRB, 0.42633216E-10_JPRB, &
  & 0.41951904E-10_JPRB, 0.41275774E-10_JPRB, 0.40648797E-10_JPRB, 0.40062405E-10_JPRB, 0.39524675E-10_JPRB, 0.39031244E-10_JPRB, &
  & 0.38606538E-10_JPRB, 0.38249764E-10_JPRB, 0.37970131E-10_JPRB, 0.37748062E-10_JPRB, 0.37568598E-10_JPRB, 0.37420816E-10_JPRB, &
  & 0.37291493E-10_JPRB, 0.37173827E-10_JPRB, 0.37051362E-10_JPRB, 0.36874045E-10_JPRB /)

RGHG8(:, 4, 5) = (/ &
  & 0.38311163E-10_JPRB, 0.38460794E-10_JPRB, 0.38634075E-10_JPRB, 0.38880572E-10_JPRB, 0.39202482E-10_JPRB, 0.39624463E-10_JPRB, &
  & 0.40124286E-10_JPRB, 0.40673732E-10_JPRB, 0.41253830E-10_JPRB, 0.41848483E-10_JPRB, 0.42456632E-10_JPRB, 0.43082357E-10_JPRB, &
  & 0.43760367E-10_JPRB, 0.44517549E-10_JPRB, 0.45320414E-10_JPRB, 0.46094340E-10_JPRB, 0.46822483E-10_JPRB, 0.47562461E-10_JPRB, &
  & 0.48353360E-10_JPRB, 0.49165092E-10_JPRB, 0.49936711E-10_JPRB, 0.50625108E-10_JPRB, 0.51219581E-10_JPRB, 0.51727206E-10_JPRB, &
  & 0.52154323E-10_JPRB, 0.52517074E-10_JPRB, 0.52823405E-10_JPRB, 0.53076678E-10_JPRB, 0.53264594E-10_JPRB, 0.53356007E-10_JPRB, &
  & 0.53309260E-10_JPRB, 0.53093828E-10_JPRB, 0.52714486E-10_JPRB, 0.52221581E-10_JPRB, 0.51680497E-10_JPRB, 0.51119092E-10_JPRB, &
  & 0.50520699E-10_JPRB, 0.49868568E-10_JPRB, 0.49183168E-10_JPRB, 0.48458137E-10_JPRB, 0.47709246E-10_JPRB, 0.46944629E-10_JPRB, &
  & 0.46173499E-10_JPRB, 0.45410418E-10_JPRB, 0.44664768E-10_JPRB, 0.43943991E-10_JPRB, 0.43255947E-10_JPRB, 0.42608240E-10_JPRB, &
  & 0.41991795E-10_JPRB, 0.41413418E-10_JPRB, 0.40872115E-10_JPRB, 0.40374058E-10_JPRB, 0.39907532E-10_JPRB, 0.39473293E-10_JPRB, &
  & 0.39073130E-10_JPRB, 0.38724374E-10_JPRB, 0.38428292E-10_JPRB, 0.38184476E-10_JPRB, 0.37985559E-10_JPRB, 0.37821309E-10_JPRB, &
  & 0.37684543E-10_JPRB, 0.37566276E-10_JPRB, 0.37457003E-10_JPRB, 0.37308521E-10_JPRB /)

RGHG8(:, 5, 5) = (/ &
  & 0.37974249E-10_JPRB, 0.37991697E-10_JPRB, 0.38104686E-10_JPRB, 0.38291682E-10_JPRB, 0.38565123E-10_JPRB, 0.38925356E-10_JPRB, &
  & 0.39368158E-10_JPRB, 0.39877410E-10_JPRB, 0.40440141E-10_JPRB, 0.41082270E-10_JPRB, 0.41830428E-10_JPRB, 0.42706744E-10_JPRB, &
  & 0.43692883E-10_JPRB, 0.44766420E-10_JPRB, 0.45968746E-10_JPRB, 0.47341076E-10_JPRB, 0.48780528E-10_JPRB, 0.50101992E-10_JPRB, &
  & 0.51230329E-10_JPRB, 0.52218063E-10_JPRB, 0.53118541E-10_JPRB, 0.53936758E-10_JPRB, 0.54657490E-10_JPRB, 0.55269324E-10_JPRB, &
  & 0.55766725E-10_JPRB, 0.56145991E-10_JPRB, 0.56407237E-10_JPRB, 0.56539419E-10_JPRB, 0.56528646E-10_JPRB, 0.56352523E-10_JPRB, &
  & 0.55990674E-10_JPRB, 0.55454447E-10_JPRB, 0.54792462E-10_JPRB, 0.54057224E-10_JPRB, 0.53286917E-10_JPRB, 0.52510277E-10_JPRB, &
  & 0.51764794E-10_JPRB, 0.51056177E-10_JPRB, 0.50341096E-10_JPRB, 0.49589374E-10_JPRB, 0.48788446E-10_JPRB, 0.47949682E-10_JPRB, &
  & 0.47100240E-10_JPRB, 0.46258931E-10_JPRB, 0.45448801E-10_JPRB, 0.44674788E-10_JPRB, 0.43941472E-10_JPRB, 0.43255267E-10_JPRB, &
  & 0.42611800E-10_JPRB, 0.42020654E-10_JPRB, 0.41475590E-10_JPRB, 0.40959826E-10_JPRB, 0.40471765E-10_JPRB, 0.40010193E-10_JPRB, &
  & 0.39582951E-10_JPRB, 0.39186859E-10_JPRB, 0.38828312E-10_JPRB, 0.38520558E-10_JPRB, 0.38259867E-10_JPRB, 0.38046157E-10_JPRB, &
  & 0.37872372E-10_JPRB, 0.37731880E-10_JPRB, 0.37610276E-10_JPRB, 0.37468809E-10_JPRB /)

RGHG8(:, 6, 5) = (/ &
  & 0.37671942E-10_JPRB, 0.37711195E-10_JPRB, 0.37823418E-10_JPRB, 0.37988498E-10_JPRB, 0.38217561E-10_JPRB, 0.38528177E-10_JPRB, &
  & 0.38924093E-10_JPRB, 0.39420092E-10_JPRB, 0.40030753E-10_JPRB, 0.40782985E-10_JPRB, 0.41704366E-10_JPRB, 0.42817597E-10_JPRB, &
  & 0.44139758E-10_JPRB, 0.45631544E-10_JPRB, 0.47166014E-10_JPRB, 0.48617690E-10_JPRB, 0.50005656E-10_JPRB, 0.51384549E-10_JPRB, &
  & 0.52690078E-10_JPRB, 0.53827179E-10_JPRB, 0.54799564E-10_JPRB, 0.55661881E-10_JPRB, 0.56443107E-10_JPRB, 0.57137125E-10_JPRB, &
  & 0.57723465E-10_JPRB, 0.58182514E-10_JPRB, 0.58494272E-10_JPRB, 0.58636894E-10_JPRB, 0.58587052E-10_JPRB, 0.58323686E-10_JPRB, &
  & 0.57845242E-10_JPRB, 0.57169720E-10_JPRB, 0.56334559E-10_JPRB, 0.55411325E-10_JPRB, 0.54505216E-10_JPRB, 0.53671120E-10_JPRB, &
  & 0.52883614E-10_JPRB, 0.52098378E-10_JPRB, 0.51306088E-10_JPRB, 0.50506248E-10_JPRB, 0.49696525E-10_JPRB, 0.48877763E-10_JPRB, &
  & 0.48059008E-10_JPRB, 0.47260317E-10_JPRB, 0.46500706E-10_JPRB, 0.45782600E-10_JPRB, 0.45105641E-10_JPRB, 0.44468793E-10_JPRB, &
  & 0.43851315E-10_JPRB, 0.43248793E-10_JPRB, 0.42667061E-10_JPRB, 0.42094699E-10_JPRB, 0.41527521E-10_JPRB, 0.40977593E-10_JPRB, &
  & 0.40451410E-10_JPRB, 0.39947132E-10_JPRB, 0.39466493E-10_JPRB, 0.39029845E-10_JPRB, 0.38647738E-10_JPRB, 0.38320215E-10_JPRB, &
  & 0.38055462E-10_JPRB, 0.37843784E-10_JPRB, 0.37672841E-10_JPRB, 0.37496523E-10_JPRB /)

RGHG8(:, 7, 5) = (/ &
  & 0.37590129E-10_JPRB, 0.37783936E-10_JPRB, 0.37966900E-10_JPRB, 0.38181833E-10_JPRB, 0.38454639E-10_JPRB, 0.38798388E-10_JPRB, &
  & 0.39238085E-10_JPRB, 0.39777501E-10_JPRB, 0.40439613E-10_JPRB, 0.41255974E-10_JPRB, 0.42253513E-10_JPRB, 0.43433007E-10_JPRB, &
  & 0.44754405E-10_JPRB, 0.46163129E-10_JPRB, 0.47623884E-10_JPRB, 0.49096335E-10_JPRB, 0.50473393E-10_JPRB, 0.51701636E-10_JPRB, &
  & 0.52840690E-10_JPRB, 0.53942698E-10_JPRB, 0.54966968E-10_JPRB, 0.55890920E-10_JPRB, 0.56759278E-10_JPRB, 0.57598475E-10_JPRB, &
  & 0.58370024E-10_JPRB, 0.59026756E-10_JPRB, 0.59521443E-10_JPRB, 0.59803690E-10_JPRB, 0.59838801E-10_JPRB, 0.59618532E-10_JPRB, &
  & 0.59149394E-10_JPRB, 0.58470354E-10_JPRB, 0.57650100E-10_JPRB, 0.56751503E-10_JPRB, 0.55812643E-10_JPRB, 0.54865529E-10_JPRB, &
  & 0.53951527E-10_JPRB, 0.53096898E-10_JPRB, 0.52288923E-10_JPRB, 0.51485496E-10_JPRB, 0.50658193E-10_JPRB, 0.49813834E-10_JPRB, &
  & 0.48987259E-10_JPRB, 0.48201065E-10_JPRB, 0.47461986E-10_JPRB, 0.46771143E-10_JPRB, 0.46110619E-10_JPRB, 0.45475089E-10_JPRB, &
  & 0.44862045E-10_JPRB, 0.44261275E-10_JPRB, 0.43672916E-10_JPRB, 0.43085556E-10_JPRB, 0.42497401E-10_JPRB, 0.41916495E-10_JPRB, &
  & 0.41343231E-10_JPRB, 0.40776788E-10_JPRB, 0.40219283E-10_JPRB, 0.39705635E-10_JPRB, 0.39237048E-10_JPRB, 0.38832090E-10_JPRB, &
  & 0.38489257E-10_JPRB, 0.38209234E-10_JPRB, 0.37962525E-10_JPRB, 0.37661471E-10_JPRB /)

RGHG8(:, 8, 5) = (/ &
  & 0.37805131E-10_JPRB, 0.38169266E-10_JPRB, 0.38434367E-10_JPRB, 0.38714507E-10_JPRB, 0.39043949E-10_JPRB, 0.39448191E-10_JPRB, &
  & 0.39924411E-10_JPRB, 0.40495274E-10_JPRB, 0.41158386E-10_JPRB, 0.41935136E-10_JPRB, 0.42839260E-10_JPRB, 0.43876118E-10_JPRB, &
  & 0.45035385E-10_JPRB, 0.46270269E-10_JPRB, 0.47516921E-10_JPRB, 0.48723990E-10_JPRB, 0.49908449E-10_JPRB, 0.51061818E-10_JPRB, &
  & 0.52139550E-10_JPRB, 0.53143597E-10_JPRB, 0.54158181E-10_JPRB, 0.55210711E-10_JPRB, 0.56252246E-10_JPRB, 0.57305573E-10_JPRB, &
  & 0.58387274E-10_JPRB, 0.59374429E-10_JPRB, 0.60163999E-10_JPRB, 0.60690508E-10_JPRB, 0.60924349E-10_JPRB, 0.60839563E-10_JPRB, &
  & 0.60439515E-10_JPRB, 0.59780902E-10_JPRB, 0.58942691E-10_JPRB, 0.58008248E-10_JPRB, 0.57062008E-10_JPRB, 0.56148159E-10_JPRB, &
  & 0.55266874E-10_JPRB, 0.54391325E-10_JPRB, 0.53501866E-10_JPRB, 0.52600185E-10_JPRB, 0.51701601E-10_JPRB, 0.50823758E-10_JPRB, &
  & 0.49967499E-10_JPRB, 0.49139706E-10_JPRB, 0.48349443E-10_JPRB, 0.47596600E-10_JPRB, 0.46879927E-10_JPRB, 0.46200536E-10_JPRB, &
  & 0.45556225E-10_JPRB, 0.44931805E-10_JPRB, 0.44320540E-10_JPRB, 0.43720916E-10_JPRB, 0.43137837E-10_JPRB, 0.42570312E-10_JPRB, &
  & 0.42011932E-10_JPRB, 0.41464891E-10_JPRB, 0.40934423E-10_JPRB, 0.40454209E-10_JPRB, 0.40032262E-10_JPRB, 0.39669101E-10_JPRB, &
  & 0.39370389E-10_JPRB, 0.39120165E-10_JPRB, 0.38886928E-10_JPRB, 0.38548831E-10_JPRB /)

RGHG8(:, 9, 5) = (/ &
  & 0.38204370E-10_JPRB, 0.38632764E-10_JPRB, 0.38947203E-10_JPRB, 0.39286654E-10_JPRB, 0.39675246E-10_JPRB, 0.40119890E-10_JPRB, &
  & 0.40637070E-10_JPRB, 0.41214879E-10_JPRB, 0.41864408E-10_JPRB, 0.42588391E-10_JPRB, 0.43391866E-10_JPRB, 0.44270903E-10_JPRB, &
  & 0.45213319E-10_JPRB, 0.46205567E-10_JPRB, 0.47228051E-10_JPRB, 0.48259233E-10_JPRB, 0.49265442E-10_JPRB, 0.50255838E-10_JPRB, &
  & 0.51268493E-10_JPRB, 0.52332638E-10_JPRB, 0.53429788E-10_JPRB, 0.54610941E-10_JPRB, 0.55961499E-10_JPRB, 0.57405351E-10_JPRB, &
  & 0.58783353E-10_JPRB, 0.60094499E-10_JPRB, 0.61185584E-10_JPRB, 0.61961380E-10_JPRB, 0.62377263E-10_JPRB, 0.62429444E-10_JPRB, &
  & 0.62155343E-10_JPRB, 0.61613832E-10_JPRB, 0.60882105E-10_JPRB, 0.60044483E-10_JPRB, 0.59157838E-10_JPRB, 0.58247927E-10_JPRB, &
  & 0.57327344E-10_JPRB, 0.56397963E-10_JPRB, 0.55458312E-10_JPRB, 0.54499363E-10_JPRB, 0.53513353E-10_JPRB, 0.52511447E-10_JPRB, &
  & 0.51527591E-10_JPRB, 0.50578337E-10_JPRB, 0.49672731E-10_JPRB, 0.48806528E-10_JPRB, 0.47977275E-10_JPRB, 0.47185623E-10_JPRB, &
  & 0.46433728E-10_JPRB, 0.45708538E-10_JPRB, 0.45013489E-10_JPRB, 0.44359332E-10_JPRB, 0.43750680E-10_JPRB, 0.43176400E-10_JPRB, &
  & 0.42629390E-10_JPRB, 0.42113507E-10_JPRB, 0.41636864E-10_JPRB, 0.41240216E-10_JPRB, 0.40917755E-10_JPRB, 0.40667237E-10_JPRB, &
  & 0.40478603E-10_JPRB, 0.40339069E-10_JPRB, 0.40223588E-10_JPRB, 0.40071620E-10_JPRB /)

RGHG8(:,10, 5) = (/ &
  & 0.38952837E-10_JPRB, 0.39683569E-10_JPRB, 0.40202910E-10_JPRB, 0.40690958E-10_JPRB, 0.41212495E-10_JPRB, 0.41787362E-10_JPRB, &
  & 0.42427718E-10_JPRB, 0.43157686E-10_JPRB, 0.43965932E-10_JPRB, 0.44860528E-10_JPRB, 0.45832442E-10_JPRB, 0.46862611E-10_JPRB, &
  & 0.47921406E-10_JPRB, 0.48970460E-10_JPRB, 0.49977727E-10_JPRB, 0.50921451E-10_JPRB, 0.51814858E-10_JPRB, 0.52678334E-10_JPRB, &
  & 0.53548169E-10_JPRB, 0.54464520E-10_JPRB, 0.55507474E-10_JPRB, 0.56707427E-10_JPRB, 0.58044243E-10_JPRB, 0.59496477E-10_JPRB, &
  & 0.61023547E-10_JPRB, 0.62358868E-10_JPRB, 0.63456573E-10_JPRB, 0.64263636E-10_JPRB, 0.64768454E-10_JPRB, 0.64986391E-10_JPRB, &
  & 0.64935696E-10_JPRB, 0.64641993E-10_JPRB, 0.64160864E-10_JPRB, 0.63539105E-10_JPRB, 0.62811423E-10_JPRB, 0.61992113E-10_JPRB, &
  & 0.61080911E-10_JPRB, 0.60074973E-10_JPRB, 0.58991048E-10_JPRB, 0.57849094E-10_JPRB, 0.56671487E-10_JPRB, 0.55493745E-10_JPRB, &
  & 0.54328878E-10_JPRB, 0.53192513E-10_JPRB, 0.52092382E-10_JPRB, 0.51029979E-10_JPRB, 0.50003411E-10_JPRB, 0.49015063E-10_JPRB, &
  & 0.48058335E-10_JPRB, 0.47140337E-10_JPRB, 0.46281864E-10_JPRB, 0.45498751E-10_JPRB, 0.44788083E-10_JPRB, 0.44145382E-10_JPRB, &
  & 0.43568527E-10_JPRB, 0.43056191E-10_JPRB, 0.42610342E-10_JPRB, 0.42269761E-10_JPRB, 0.42021470E-10_JPRB, 0.41851557E-10_JPRB, &
  & 0.41746020E-10_JPRB, 0.41688111E-10_JPRB, 0.41661782E-10_JPRB, 0.41647411E-10_JPRB /)

RGHG8(:,11, 5) = (/ &
  & 0.40915462E-10_JPRB, 0.42284405E-10_JPRB, 0.43111421E-10_JPRB, 0.43883824E-10_JPRB, 0.44661580E-10_JPRB, 0.45531239E-10_JPRB, &
  & 0.46532105E-10_JPRB, 0.47687711E-10_JPRB, 0.49022095E-10_JPRB, 0.50525771E-10_JPRB, 0.52179913E-10_JPRB, 0.53938080E-10_JPRB, &
  & 0.55732231E-10_JPRB, 0.57479098E-10_JPRB, 0.59082003E-10_JPRB, 0.60465112E-10_JPRB, 0.61582059E-10_JPRB, 0.62444383E-10_JPRB, &
  & 0.63093988E-10_JPRB, 0.63616314E-10_JPRB, 0.64087340E-10_JPRB, 0.64575463E-10_JPRB, 0.65142870E-10_JPRB, 0.65791060E-10_JPRB, &
  & 0.66437113E-10_JPRB, 0.67105731E-10_JPRB, 0.67712447E-10_JPRB, 0.68248462E-10_JPRB, 0.68712577E-10_JPRB, 0.69047948E-10_JPRB, &
  & 0.69248329E-10_JPRB, 0.69353370E-10_JPRB, 0.69338313E-10_JPRB, 0.69139687E-10_JPRB, 0.68745482E-10_JPRB, 0.68122376E-10_JPRB, &
  & 0.67264957E-10_JPRB, 0.66181269E-10_JPRB, 0.64905387E-10_JPRB, 0.63487098E-10_JPRB, 0.61987145E-10_JPRB, 0.60469449E-10_JPRB, &
  & 0.58982423E-10_JPRB, 0.57543838E-10_JPRB, 0.56157259E-10_JPRB, 0.54807051E-10_JPRB, 0.53488526E-10_JPRB, 0.52198253E-10_JPRB, &
  & 0.50957120E-10_JPRB, 0.49788802E-10_JPRB, 0.48715726E-10_JPRB, 0.47742258E-10_JPRB, 0.46872665E-10_JPRB, 0.46111694E-10_JPRB, &
  & 0.45460191E-10_JPRB, 0.44911887E-10_JPRB, 0.44460380E-10_JPRB, 0.44134332E-10_JPRB, 0.43911701E-10_JPRB, 0.43773624E-10_JPRB, &
  & 0.43701091E-10_JPRB, 0.43678196E-10_JPRB, 0.43694857E-10_JPRB, 0.43764166E-10_JPRB /)

RGHG8(:,12, 5) = (/ &
  & 0.45027298E-10_JPRB, 0.46891470E-10_JPRB, 0.48052635E-10_JPRB, 0.49073634E-10_JPRB, 0.50171242E-10_JPRB, 0.51389202E-10_JPRB, &
  & 0.52825782E-10_JPRB, 0.54529603E-10_JPRB, 0.56505300E-10_JPRB, 0.58750019E-10_JPRB, 0.61213770E-10_JPRB, 0.63820477E-10_JPRB, &
  & 0.66461336E-10_JPRB, 0.69014641E-10_JPRB, 0.71342210E-10_JPRB, 0.73318622E-10_JPRB, 0.74851805E-10_JPRB, 0.75905109E-10_JPRB, &
  & 0.76486033E-10_JPRB, 0.76646557E-10_JPRB, 0.76477137E-10_JPRB, 0.76094998E-10_JPRB, 0.75599776E-10_JPRB, 0.75098282E-10_JPRB, &
  & 0.74665857E-10_JPRB, 0.74348597E-10_JPRB, 0.74195511E-10_JPRB, 0.74179524E-10_JPRB, 0.74315616E-10_JPRB, 0.74671262E-10_JPRB, &
  & 0.75154848E-10_JPRB, 0.75677749E-10_JPRB, 0.76155901E-10_JPRB, 0.76533613E-10_JPRB, 0.76629175E-10_JPRB, 0.76349142E-10_JPRB, &
  & 0.75674467E-10_JPRB, 0.74611997E-10_JPRB, 0.73215996E-10_JPRB, 0.71571658E-10_JPRB, 0.69765832E-10_JPRB, 0.67900602E-10_JPRB, &
  & 0.66039244E-10_JPRB, 0.64220858E-10_JPRB, 0.62450614E-10_JPRB, 0.60728263E-10_JPRB, 0.59049945E-10_JPRB, 0.57425925E-10_JPRB, &
  & 0.55871356E-10_JPRB, 0.54399544E-10_JPRB, 0.53025504E-10_JPRB, 0.51766823E-10_JPRB, 0.50641335E-10_JPRB, 0.49664415E-10_JPRB, &
  & 0.48840324E-10_JPRB, 0.48161815E-10_JPRB, 0.47616522E-10_JPRB, 0.47222986E-10_JPRB, 0.46953143E-10_JPRB, 0.46783397E-10_JPRB, &
  & 0.46694485E-10_JPRB, 0.46671625E-10_JPRB, 0.46715180E-10_JPRB, 0.46889673E-10_JPRB /)

RGHG8(:,13, 5) = (/ &
  & 0.51359021E-10_JPRB, 0.53399857E-10_JPRB, 0.54649889E-10_JPRB, 0.55854342E-10_JPRB, 0.57126109E-10_JPRB, 0.58616390E-10_JPRB, &
  & 0.60387223E-10_JPRB, 0.62502455E-10_JPRB, 0.64972236E-10_JPRB, 0.67756328E-10_JPRB, 0.70786842E-10_JPRB, 0.73952323E-10_JPRB, &
  & 0.77106745E-10_JPRB, 0.80103528E-10_JPRB, 0.82790219E-10_JPRB, 0.85030233E-10_JPRB, 0.86719298E-10_JPRB, 0.87819918E-10_JPRB, &
  & 0.88328705E-10_JPRB, 0.88297723E-10_JPRB, 0.87816185E-10_JPRB, 0.87004209E-10_JPRB, 0.86003864E-10_JPRB, 0.84941269E-10_JPRB, &
  & 0.83939272E-10_JPRB, 0.83072722E-10_JPRB, 0.82396361E-10_JPRB, 0.81991629E-10_JPRB, 0.81870725E-10_JPRB, 0.82042852E-10_JPRB, &
  & 0.82579589E-10_JPRB, 0.83302233E-10_JPRB, 0.84153663E-10_JPRB, 0.84805045E-10_JPRB, 0.85227880E-10_JPRB, 0.85313395E-10_JPRB, &
  & 0.84970912E-10_JPRB, 0.84168582E-10_JPRB, 0.82946143E-10_JPRB, 0.81375712E-10_JPRB, 0.79544406E-10_JPRB, 0.77553727E-10_JPRB, &
  & 0.75488629E-10_JPRB, 0.73396032E-10_JPRB, 0.71315023E-10_JPRB, 0.69260687E-10_JPRB, 0.67247763E-10_JPRB, 0.65289975E-10_JPRB, &
  & 0.63401014E-10_JPRB, 0.61600572E-10_JPRB, 0.59909890E-10_JPRB, 0.58345932E-10_JPRB, 0.56926089E-10_JPRB, 0.55666666E-10_JPRB, &
  & 0.54576940E-10_JPRB, 0.53656701E-10_JPRB, 0.52900340E-10_JPRB, 0.52329412E-10_JPRB, 0.51919167E-10_JPRB, 0.51649424E-10_JPRB, &
  & 0.51503871E-10_JPRB, 0.51475588E-10_JPRB, 0.51584171E-10_JPRB, 0.52013636E-10_JPRB /)

RGHG8(:,14, 5) = (/ &
  & 0.59745757E-10_JPRB, 0.61531058E-10_JPRB, 0.62722105E-10_JPRB, 0.63882101E-10_JPRB, 0.65198180E-10_JPRB, 0.66763171E-10_JPRB, &
  & 0.68664033E-10_JPRB, 0.70964429E-10_JPRB, 0.73651835E-10_JPRB, 0.76681043E-10_JPRB, 0.79946501E-10_JPRB, 0.83324438E-10_JPRB, &
  & 0.86645809E-10_JPRB, 0.89732541E-10_JPRB, 0.92454711E-10_JPRB, 0.94686856E-10_JPRB, 0.96347090E-10_JPRB, 0.97408519E-10_JPRB, &
  & 0.97901409E-10_JPRB, 0.97884645E-10_JPRB, 0.97439105E-10_JPRB, 0.96672080E-10_JPRB, 0.95703549E-10_JPRB, 0.94658573E-10_JPRB, &
  & 0.93624511E-10_JPRB, 0.92688759E-10_JPRB, 0.91909716E-10_JPRB, 0.91346576E-10_JPRB, 0.91098698E-10_JPRB, 0.91164687E-10_JPRB, &
  & 0.91559781E-10_JPRB, 0.92265973E-10_JPRB, 0.92951161E-10_JPRB, 0.93683755E-10_JPRB, 0.94186429E-10_JPRB, 0.94383702E-10_JPRB, &
  & 0.94272340E-10_JPRB, 0.93811826E-10_JPRB, 0.92975454E-10_JPRB, 0.91773318E-10_JPRB, 0.90238712E-10_JPRB, 0.88440408E-10_JPRB, &
  & 0.86438433E-10_JPRB, 0.84297597E-10_JPRB, 0.82072717E-10_JPRB, 0.79814370E-10_JPRB, 0.77570818E-10_JPRB, 0.75377704E-10_JPRB, &
  & 0.73274081E-10_JPRB, 0.71278268E-10_JPRB, 0.69399285E-10_JPRB, 0.67638659E-10_JPRB, 0.66004313E-10_JPRB, 0.64508253E-10_JPRB, &
  & 0.63164231E-10_JPRB, 0.61986631E-10_JPRB, 0.60986743E-10_JPRB, 0.60201247E-10_JPRB, 0.59621010E-10_JPRB, 0.59237393E-10_JPRB, &
  & 0.59046504E-10_JPRB, 0.59058293E-10_JPRB, 0.59333434E-10_JPRB, 0.60282286E-10_JPRB /)

RGHG8(:,15, 5) = (/ &
  & 0.69937466E-10_JPRB, 0.71141093E-10_JPRB, 0.71998879E-10_JPRB, 0.72964676E-10_JPRB, 0.74118600E-10_JPRB, 0.75554910E-10_JPRB, &
  & 0.77368889E-10_JPRB, 0.79586629E-10_JPRB, 0.82220335E-10_JPRB, 0.85201346E-10_JPRB, 0.88419091E-10_JPRB, 0.91718806E-10_JPRB, &
  & 0.94942679E-10_JPRB, 0.97916307E-10_JPRB, 0.10050114E-09_JPRB, 0.10264248E-09_JPRB, 0.10428156E-09_JPRB, 0.10540525E-09_JPRB, &
  & 0.10604741E-09_JPRB, 0.10627000E-09_JPRB, 0.10614727E-09_JPRB, 0.10576602E-09_JPRB, 0.10521446E-09_JPRB, 0.10457065E-09_JPRB, &
  & 0.10389967E-09_JPRB, 0.10325059E-09_JPRB, 0.10267674E-09_JPRB, 0.10219917E-09_JPRB, 0.10184810E-09_JPRB, 0.10168727E-09_JPRB, &
  & 0.10164655E-09_JPRB, 0.10173599E-09_JPRB, 0.10200163E-09_JPRB, 0.10230411E-09_JPRB, 0.10266324E-09_JPRB, 0.10296075E-09_JPRB, &
  & 0.10308075E-09_JPRB, 0.10298399E-09_JPRB, 0.10262590E-09_JPRB, 0.10194751E-09_JPRB, 0.10092027E-09_JPRB, 0.99541091E-10_JPRB, &
  & 0.97843351E-10_JPRB, 0.95876494E-10_JPRB, 0.93714973E-10_JPRB, 0.91442104E-10_JPRB, 0.89134061E-10_JPRB, 0.86861823E-10_JPRB, &
  & 0.84668515E-10_JPRB, 0.82581893E-10_JPRB, 0.80609533E-10_JPRB, 0.78743900E-10_JPRB, 0.76981144E-10_JPRB, 0.75329298E-10_JPRB, &
  & 0.73810014E-10_JPRB, 0.72450816E-10_JPRB, 0.71279184E-10_JPRB, 0.70346916E-10_JPRB, 0.69660708E-10_JPRB, 0.69226527E-10_JPRB, &
  & 0.69055414E-10_JPRB, 0.69175693E-10_JPRB, 0.69705484E-10_JPRB, 0.71300403E-10_JPRB /)

RGHG8(:,16, 5) = (/ &
  & 0.80664184E-10_JPRB, 0.81277186E-10_JPRB, 0.81748698E-10_JPRB, 0.82406804E-10_JPRB, 0.83280605E-10_JPRB, 0.84476155E-10_JPRB, &
  & 0.86027969E-10_JPRB, 0.88002654E-10_JPRB, 0.90384582E-10_JPRB, 0.93124938E-10_JPRB, 0.96110064E-10_JPRB, 0.99180303E-10_JPRB, &
  & 0.10217285E-09_JPRB, 0.10494225E-09_JPRB, 0.10736040E-09_JPRB, 0.10937733E-09_JPRB, 0.11101667E-09_JPRB, 0.11228857E-09_JPRB, &
  & 0.11322133E-09_JPRB, 0.11386118E-09_JPRB, 0.11425896E-09_JPRB, 0.11447152E-09_JPRB, 0.11455800E-09_JPRB, 0.11455776E-09_JPRB, &
  & 0.11450441E-09_JPRB, 0.11439026E-09_JPRB, 0.11422484E-09_JPRB, 0.11396559E-09_JPRB, 0.11361251E-09_JPRB, 0.11316575E-09_JPRB, &
  & 0.11266195E-09_JPRB, 0.11215728E-09_JPRB, 0.11170040E-09_JPRB, 0.11135600E-09_JPRB, 0.11116495E-09_JPRB, 0.11117542E-09_JPRB, &
  & 0.11133933E-09_JPRB, 0.11152804E-09_JPRB, 0.11160207E-09_JPRB, 0.11144771E-09_JPRB, 0.11095894E-09_JPRB, 0.11007763E-09_JPRB, &
  & 0.10878977E-09_JPRB, 0.10713296E-09_JPRB, 0.10518178E-09_JPRB, 0.10303430E-09_JPRB, 0.10079169E-09_JPRB, 0.98529622E-10_JPRB, &
  & 0.96321888E-10_JPRB, 0.94203804E-10_JPRB, 0.92187161E-10_JPRB, 0.90263311E-10_JPRB, 0.88427911E-10_JPRB, 0.86693000E-10_JPRB, &
  & 0.85088936E-10_JPRB, 0.83652210E-10_JPRB, 0.82420001E-10_JPRB, 0.81451207E-10_JPRB, 0.80761807E-10_JPRB, 0.80365048E-10_JPRB, &
  & 0.80276563E-10_JPRB, 0.80543093E-10_JPRB, 0.81334293E-10_JPRB, 0.83415913E-10_JPRB /)

RGHG8(:,17, 5) = (/ &
  & 0.90774117E-10_JPRB, 0.90864732E-10_JPRB, 0.91038919E-10_JPRB, 0.91405432E-10_JPRB, 0.92023139E-10_JPRB, 0.92931010E-10_JPRB, &
  & 0.94209425E-10_JPRB, 0.95883308E-10_JPRB, 0.97960903E-10_JPRB, 0.10038257E-09_JPRB, 0.10305611E-09_JPRB, 0.10584439E-09_JPRB, &
  & 0.10857545E-09_JPRB, 0.11113163E-09_JPRB, 0.11342412E-09_JPRB, 0.11538948E-09_JPRB, 0.11704548E-09_JPRB, 0.11845641E-09_JPRB, &
  & 0.11966912E-09_JPRB, 0.12072277E-09_JPRB, 0.12165452E-09_JPRB, 0.12248155E-09_JPRB, 0.12321524E-09_JPRB, 0.12386683E-09_JPRB, &
  & 0.12442676E-09_JPRB, 0.12485418E-09_JPRB, 0.12510515E-09_JPRB, 0.12511091E-09_JPRB, 0.12482962E-09_JPRB, 0.12422831E-09_JPRB, &
  & 0.12336865E-09_JPRB, 0.12234458E-09_JPRB, 0.12128927E-09_JPRB, 0.12036371E-09_JPRB, 0.11968064E-09_JPRB, 0.11932530E-09_JPRB, &
  & 0.11931325E-09_JPRB, 0.11956382E-09_JPRB, 0.11988198E-09_JPRB, 0.12009403E-09_JPRB, 0.12003377E-09_JPRB, 0.11958021E-09_JPRB, &
  & 0.11867891E-09_JPRB, 0.11734848E-09_JPRB, 0.11565671E-09_JPRB, 0.11370119E-09_JPRB, 0.11156964E-09_JPRB, 0.10937144E-09_JPRB, &
  & 0.10719683E-09_JPRB, 0.10510038E-09_JPRB, 0.10308561E-09_JPRB, 0.10114248E-09_JPRB, 0.99280487E-10_JPRB, 0.97525196E-10_JPRB, &
  & 0.95913520E-10_JPRB, 0.94488202E-10_JPRB, 0.93288863E-10_JPRB, 0.92370195E-10_JPRB, 0.91747970E-10_JPRB, 0.91429982E-10_JPRB, &
  & 0.91437198E-10_JPRB, 0.91811621E-10_JPRB, 0.92737498E-10_JPRB, 0.95038505E-10_JPRB /)

RGHG8(:,18, 5) = (/ &
  & 0.99781412E-10_JPRB, 0.99471473E-10_JPRB, 0.99434669E-10_JPRB, 0.99605872E-10_JPRB, 0.10000485E-09_JPRB, 0.10069336E-09_JPRB, &
  & 0.10171219E-09_JPRB, 0.10312054E-09_JPRB, 0.10490718E-09_JPRB, 0.10703186E-09_JPRB, 0.10939807E-09_JPRB, 0.11188651E-09_JPRB, &
  & 0.11437032E-09_JPRB, 0.11671354E-09_JPRB, 0.11886643E-09_JPRB, 0.12080702E-09_JPRB, 0.12252552E-09_JPRB, 0.12405446E-09_JPRB, &
  & 0.12545461E-09_JPRB, 0.12677734E-09_JPRB, 0.12804409E-09_JPRB, 0.12926746E-09_JPRB, 0.13045137E-09_JPRB, 0.13157805E-09_JPRB, &
  & 0.13260305E-09_JPRB, 0.13346195E-09_JPRB, 0.13408163E-09_JPRB, 0.13436539E-09_JPRB, 0.13424854E-09_JPRB, 0.13370179E-09_JPRB, &
  & 0.13276706E-09_JPRB, 0.13154666E-09_JPRB, 0.13019051E-09_JPRB, 0.12888997E-09_JPRB, 0.12785104E-09_JPRB, 0.12720230E-09_JPRB, &
  & 0.12699267E-09_JPRB, 0.12715494E-09_JPRB, 0.12753411E-09_JPRB, 0.12790714E-09_JPRB, 0.12806177E-09_JPRB, 0.12786071E-09_JPRB, &
  & 0.12722132E-09_JPRB, 0.12613650E-09_JPRB, 0.12466145E-09_JPRB, 0.12287782E-09_JPRB, 0.12089502E-09_JPRB, 0.11882219E-09_JPRB, &
  & 0.11674725E-09_JPRB, 0.11470631E-09_JPRB, 0.11271049E-09_JPRB, 0.11077742E-09_JPRB, 0.10893350E-09_JPRB, 0.10721422E-09_JPRB, &
  & 0.10566173E-09_JPRB, 0.10431744E-09_JPRB, 0.10321159E-09_JPRB, 0.10238877E-09_JPRB, 0.10185664E-09_JPRB, 0.10162125E-09_JPRB, &
  & 0.10169145E-09_JPRB, 0.10210644E-09_JPRB, 0.10302294E-09_JPRB, 0.10525082E-09_JPRB /)

RGHG8(:,19, 5) = (/ &
  & 0.10755501E-09_JPRB, 0.10706071E-09_JPRB, 0.10691781E-09_JPRB, 0.10697367E-09_JPRB, 0.10723663E-09_JPRB, 0.10774724E-09_JPRB, &
  & 0.10857302E-09_JPRB, 0.10974702E-09_JPRB, 0.11127903E-09_JPRB, 0.11313252E-09_JPRB, 0.11522962E-09_JPRB, 0.11745366E-09_JPRB, &
  & 0.11969045E-09_JPRB, 0.12184845E-09_JPRB, 0.12384825E-09_JPRB, 0.12568649E-09_JPRB, 0.12738645E-09_JPRB, 0.12896464E-09_JPRB, &
  & 0.13044468E-09_JPRB, 0.13186538E-09_JPRB, 0.13327345E-09_JPRB, 0.13469383E-09_JPRB, 0.13611515E-09_JPRB, 0.13749588E-09_JPRB, &
  & 0.13878231E-09_JPRB, 0.13990303E-09_JPRB, 0.14076916E-09_JPRB, 0.14129579E-09_JPRB, 0.14142021E-09_JPRB, 0.14110994E-09_JPRB, &
  & 0.14038681E-09_JPRB, 0.13931881E-09_JPRB, 0.13802796E-09_JPRB, 0.13669842E-09_JPRB, 0.13555122E-09_JPRB, 0.13475152E-09_JPRB, &
  & 0.13437862E-09_JPRB, 0.13438867E-09_JPRB, 0.13465531E-09_JPRB, 0.13496369E-09_JPRB, 0.13512386E-09_JPRB, 0.13497167E-09_JPRB, &
  & 0.13442149E-09_JPRB, 0.13345508E-09_JPRB, 0.13210941E-09_JPRB, 0.13046612E-09_JPRB, 0.12862579E-09_JPRB, 0.12669132E-09_JPRB, &
  & 0.12471819E-09_JPRB, 0.12272830E-09_JPRB, 0.12077135E-09_JPRB, 0.11889893E-09_JPRB, 0.11714107E-09_JPRB, 0.11553382E-09_JPRB, &
  & 0.11411165E-09_JPRB, 0.11290320E-09_JPRB, 0.11192561E-09_JPRB, 0.11121112E-09_JPRB, 0.11076014E-09_JPRB, 0.11057197E-09_JPRB, &
  & 0.11065120E-09_JPRB, 0.11102393E-09_JPRB, 0.11180606E-09_JPRB, 0.11377965E-09_JPRB /)

RGHG8(:,20, 5) = (/ &
  & 0.11423255E-09_JPRB, 0.11370146E-09_JPRB, 0.11354261E-09_JPRB, 0.11355890E-09_JPRB, 0.11374965E-09_JPRB, 0.11416355E-09_JPRB, &
  & 0.11485241E-09_JPRB, 0.11586203E-09_JPRB, 0.11719278E-09_JPRB, 0.11881822E-09_JPRB, 0.12067666E-09_JPRB, 0.12266937E-09_JPRB, &
  & 0.12469135E-09_JPRB, 0.12665788E-09_JPRB, 0.12851969E-09_JPRB, 0.13024240E-09_JPRB, 0.13184817E-09_JPRB, 0.13337301E-09_JPRB, &
  & 0.13484192E-09_JPRB, 0.13627889E-09_JPRB, 0.13770619E-09_JPRB, 0.13913530E-09_JPRB, 0.14057475E-09_JPRB, 0.14200537E-09_JPRB, &
  & 0.14336611E-09_JPRB, 0.14458383E-09_JPRB, 0.14559652E-09_JPRB, 0.14631392E-09_JPRB, 0.14668521E-09_JPRB, 0.14667963E-09_JPRB, &
  & 0.14630661E-09_JPRB, 0.14559717E-09_JPRB, 0.14464827E-09_JPRB, 0.14358166E-09_JPRB, 0.14256960E-09_JPRB, 0.14177370E-09_JPRB, &
  & 0.14129940E-09_JPRB, 0.14113606E-09_JPRB, 0.14119039E-09_JPRB, 0.14128777E-09_JPRB, 0.14127596E-09_JPRB, 0.14101728E-09_JPRB, &
  & 0.14042160E-09_JPRB, 0.13946418E-09_JPRB, 0.13817646E-09_JPRB, 0.13662023E-09_JPRB, 0.13487883E-09_JPRB, 0.13301273E-09_JPRB, &
  & 0.13108423E-09_JPRB, 0.12916652E-09_JPRB, 0.12732675E-09_JPRB, 0.12559077E-09_JPRB, 0.12398761E-09_JPRB, 0.12254968E-09_JPRB, &
  & 0.12129793E-09_JPRB, 0.12024569E-09_JPRB, 0.11939834E-09_JPRB, 0.11877460E-09_JPRB, 0.11837314E-09_JPRB, 0.11819164E-09_JPRB, &
  & 0.11823213E-09_JPRB, 0.11851185E-09_JPRB, 0.11912110E-09_JPRB, 0.12070471E-09_JPRB /)

RGHG8(:,21, 5) = (/ &
  & 0.11990027E-09_JPRB, 0.11947254E-09_JPRB, 0.11935335E-09_JPRB, 0.11938427E-09_JPRB, 0.11956861E-09_JPRB, 0.11994271E-09_JPRB, &
  & 0.12056223E-09_JPRB, 0.12146012E-09_JPRB, 0.12264945E-09_JPRB, 0.12410800E-09_JPRB, 0.12577711E-09_JPRB, 0.12758193E-09_JPRB, &
  & 0.12942630E-09_JPRB, 0.13123078E-09_JPRB, 0.13294640E-09_JPRB, 0.13455544E-09_JPRB, 0.13605887E-09_JPRB, 0.13748438E-09_JPRB, &
  & 0.13886460E-09_JPRB, 0.14022146E-09_JPRB, 0.14156837E-09_JPRB, 0.14292177E-09_JPRB, 0.14427459E-09_JPRB, 0.14561927E-09_JPRB, &
  & 0.14692007E-09_JPRB, 0.14811727E-09_JPRB, 0.14915102E-09_JPRB, 0.14997432E-09_JPRB, 0.15054313E-09_JPRB, 0.15081965E-09_JPRB, &
  & 0.15079656E-09_JPRB, 0.15048812E-09_JPRB, 0.14995123E-09_JPRB, 0.14925647E-09_JPRB, 0.14853603E-09_JPRB, 0.14790268E-09_JPRB, &
  & 0.14743130E-09_JPRB, 0.14712610E-09_JPRB, 0.14694487E-09_JPRB, 0.14677669E-09_JPRB, 0.14650864E-09_JPRB, 0.14604132E-09_JPRB, &
  & 0.14531235E-09_JPRB, 0.14429413E-09_JPRB, 0.14300071E-09_JPRB, 0.14147659E-09_JPRB, 0.13977654E-09_JPRB, 0.13798124E-09_JPRB, &
  & 0.13617693E-09_JPRB, 0.13442844E-09_JPRB, 0.13275354E-09_JPRB, 0.13117701E-09_JPRB, 0.12973875E-09_JPRB, 0.12846486E-09_JPRB, &
  & 0.12736845E-09_JPRB, 0.12645002E-09_JPRB, 0.12570427E-09_JPRB, 0.12514229E-09_JPRB, 0.12475912E-09_JPRB, 0.12455381E-09_JPRB, &
  & 0.12452679E-09_JPRB, 0.12469172E-09_JPRB, 0.12511163E-09_JPRB, 0.12623345E-09_JPRB /)

RGHG8(:,22, 5) = (/ &
  & 0.12472347E-09_JPRB, 0.12443040E-09_JPRB, 0.12438850E-09_JPRB, 0.12447246E-09_JPRB, 0.12468679E-09_JPRB, 0.12507177E-09_JPRB, &
  & 0.12566742E-09_JPRB, 0.12651583E-09_JPRB, 0.12761976E-09_JPRB, 0.12896487E-09_JPRB, 0.13050663E-09_JPRB, 0.13216861E-09_JPRB, &
  & 0.13387749E-09_JPRB, 0.13555447E-09_JPRB, 0.13714997E-09_JPRB, 0.13864401E-09_JPRB, 0.14004256E-09_JPRB, 0.14136289E-09_JPRB, &
  & 0.14262853E-09_JPRB, 0.14386306E-09_JPRB, 0.14507967E-09_JPRB, 0.14628748E-09_JPRB, 0.14748711E-09_JPRB, 0.14867071E-09_JPRB, &
  & 0.14982661E-09_JPRB, 0.15092361E-09_JPRB, 0.15192610E-09_JPRB, 0.15277879E-09_JPRB, 0.15344752E-09_JPRB, 0.15391516E-09_JPRB, &
  & 0.15416224E-09_JPRB, 0.15418541E-09_JPRB, 0.15400958E-09_JPRB, 0.15366972E-09_JPRB, 0.15324532E-09_JPRB, 0.15279228E-09_JPRB, &
  & 0.15238094E-09_JPRB, 0.15200458E-09_JPRB, 0.15165166E-09_JPRB, 0.15125735E-09_JPRB, 0.15075348E-09_JPRB, 0.15007535E-09_JPRB, &
  & 0.14918694E-09_JPRB, 0.14807225E-09_JPRB, 0.14674402E-09_JPRB, 0.14523491E-09_JPRB, 0.14361395E-09_JPRB, 0.14195903E-09_JPRB, &
  & 0.14032903E-09_JPRB, 0.13874341E-09_JPRB, 0.13722551E-09_JPRB, 0.13581603E-09_JPRB, 0.13454227E-09_JPRB, 0.13342204E-09_JPRB, &
  & 0.13245903E-09_JPRB, 0.13164740E-09_JPRB, 0.13097853E-09_JPRB, 0.13045473E-09_JPRB, 0.13007220E-09_JPRB, 0.12982923E-09_JPRB, &
  & 0.12972839E-09_JPRB, 0.12977783E-09_JPRB, 0.13001897E-09_JPRB, 0.13076189E-09_JPRB /)

RGHG8(:,23, 5) = (/ &
  & 0.12878669E-09_JPRB, 0.12866924E-09_JPRB, 0.12871451E-09_JPRB, 0.12886275E-09_JPRB, 0.12913100E-09_JPRB, 0.12954748E-09_JPRB, &
  & 0.13016142E-09_JPRB, 0.13099714E-09_JPRB, 0.13206254E-09_JPRB, 0.13334067E-09_JPRB, 0.13479061E-09_JPRB, 0.13635527E-09_JPRB, &
  & 0.13795946E-09_JPRB, 0.13953817E-09_JPRB, 0.14103946E-09_JPRB, 0.14244037E-09_JPRB, 0.14374263E-09_JPRB, 0.14496190E-09_JPRB, &
  & 0.14611652E-09_JPRB, 0.14722400E-09_JPRB, 0.14829314E-09_JPRB, 0.14933245E-09_JPRB, 0.15034708E-09_JPRB, 0.15134193E-09_JPRB, &
  & 0.15231223E-09_JPRB, 0.15324933E-09_JPRB, 0.15414069E-09_JPRB, 0.15496804E-09_JPRB, 0.15568548E-09_JPRB, 0.15626359E-09_JPRB, &
  & 0.15668311E-09_JPRB, 0.15692991E-09_JPRB, 0.15700624E-09_JPRB, 0.15692771E-09_JPRB, 0.15672794E-09_JPRB, 0.15643847E-09_JPRB, &
  & 0.15608986E-09_JPRB, 0.15569035E-09_JPRB, 0.15523216E-09_JPRB, 0.15468415E-09_JPRB, 0.15401148E-09_JPRB, 0.15318440E-09_JPRB, &
  & 0.15218406E-09_JPRB, 0.15100644E-09_JPRB, 0.14966860E-09_JPRB, 0.14821286E-09_JPRB, 0.14669743E-09_JPRB, 0.14517650E-09_JPRB, &
  & 0.14368540E-09_JPRB, 0.14225046E-09_JPRB, 0.14089940E-09_JPRB, 0.13965484E-09_JPRB, 0.13853649E-09_JPRB, 0.13755441E-09_JPRB, &
  & 0.13670588E-09_JPRB, 0.13598181E-09_JPRB, 0.13537109E-09_JPRB, 0.13487425E-09_JPRB, 0.13448689E-09_JPRB, 0.13420987E-09_JPRB, &
  & 0.13404550E-09_JPRB, 0.13399833E-09_JPRB, 0.13409313E-09_JPRB, 0.13452450E-09_JPRB /)

RGHG8(:,24, 5) = (/ &
  & 0.13227131E-09_JPRB, 0.13229859E-09_JPRB, 0.13242371E-09_JPRB, 0.13263533E-09_JPRB, 0.13295182E-09_JPRB, 0.13341230E-09_JPRB, &
  & 0.13404972E-09_JPRB, 0.13489303E-09_JPRB, 0.13593984E-09_JPRB, 0.13717544E-09_JPRB, 0.13856358E-09_JPRB, 0.14005105E-09_JPRB, &
  & 0.14157561E-09_JPRB, 0.14307443E-09_JPRB, 0.14449925E-09_JPRB, 0.14582528E-09_JPRB, 0.14704976E-09_JPRB, 0.14818306E-09_JPRB, &
  & 0.14924047E-09_JPRB, 0.15023363E-09_JPRB, 0.15117141E-09_JPRB, 0.15205910E-09_JPRB, 0.15290447E-09_JPRB, 0.15371839E-09_JPRB, &
  & 0.15451032E-09_JPRB, 0.15528719E-09_JPRB, 0.15604973E-09_JPRB, 0.15678624E-09_JPRB, 0.15748051E-09_JPRB, 0.15809573E-09_JPRB, &
  & 0.15859988E-09_JPRB, 0.15896927E-09_JPRB, 0.15919016E-09_JPRB, 0.15926530E-09_JPRB, 0.15920053E-09_JPRB, 0.15901262E-09_JPRB, &
  & 0.15871131E-09_JPRB, 0.15830663E-09_JPRB, 0.15779193E-09_JPRB, 0.15716399E-09_JPRB, 0.15640295E-09_JPRB, 0.15549939E-09_JPRB, &
  & 0.15445104E-09_JPRB, 0.15326478E-09_JPRB, 0.15196440E-09_JPRB, 0.15058461E-09_JPRB, 0.14917385E-09_JPRB, 0.14777884E-09_JPRB, &
  & 0.14643349E-09_JPRB, 0.14515614E-09_JPRB, 0.14396326E-09_JPRB, 0.14287166E-09_JPRB, 0.14189373E-09_JPRB, 0.14103224E-09_JPRB, &
  & 0.14028015E-09_JPRB, 0.13962641E-09_JPRB, 0.13906057E-09_JPRB, 0.13858190E-09_JPRB, 0.13818900E-09_JPRB, 0.13788407E-09_JPRB, &
  & 0.13767124E-09_JPRB, 0.13755277E-09_JPRB, 0.13753571E-09_JPRB, 0.13771261E-09_JPRB /)

RGHG8(:,25, 5) = (/ &
  & 0.13529794E-09_JPRB, 0.13544174E-09_JPRB, 0.13562984E-09_JPRB, 0.13588303E-09_JPRB, 0.13624045E-09_JPRB, 0.13673053E-09_JPRB, &
  & 0.13738807E-09_JPRB, 0.13823473E-09_JPRB, 0.13926672E-09_JPRB, 0.14046518E-09_JPRB, 0.14180020E-09_JPRB, 0.14322091E-09_JPRB, &
  & 0.14467430E-09_JPRB, 0.14610377E-09_JPRB, 0.14746407E-09_JPRB, 0.14872834E-09_JPRB, 0.14989010E-09_JPRB, 0.15095614E-09_JPRB, &
  & 0.15193723E-09_JPRB, 0.15284120E-09_JPRB, 0.15367438E-09_JPRB, 0.15444203E-09_JPRB, 0.15515089E-09_JPRB, 0.15581675E-09_JPRB, &
  & 0.15645379E-09_JPRB, 0.15708151E-09_JPRB, 0.15771484E-09_JPRB, 0.15835455E-09_JPRB, 0.15898420E-09_JPRB, 0.15957841E-09_JPRB, &
  & 0.16010014E-09_JPRB, 0.16051702E-09_JPRB, 0.16080283E-09_JPRB, 0.16095050E-09_JPRB, 0.16095068E-09_JPRB, 0.16080957E-09_JPRB, &
  & 0.16052948E-09_JPRB, 0.16012236E-09_JPRB, 0.15958450E-09_JPRB, 0.15891921E-09_JPRB, 0.15812286E-09_JPRB, 0.15719789E-09_JPRB, &
  & 0.15615136E-09_JPRB, 0.15499732E-09_JPRB, 0.15375957E-09_JPRB, 0.15247519E-09_JPRB, 0.15118778E-09_JPRB, 0.14993234E-09_JPRB, &
  & 0.14873591E-09_JPRB, 0.14761307E-09_JPRB, 0.14657058E-09_JPRB, 0.14561730E-09_JPRB, 0.14476224E-09_JPRB, 0.14400230E-09_JPRB, &
  & 0.14332931E-09_JPRB, 0.14273212E-09_JPRB, 0.14220099E-09_JPRB, 0.14173571E-09_JPRB, 0.14133654E-09_JPRB, 0.14100873E-09_JPRB, &
  & 0.14075778E-09_JPRB, 0.14058461E-09_JPRB, 0.14048882E-09_JPRB, 0.14050683E-09_JPRB /)

RGHG8(:,26, 5) = (/ &
  & 0.13797694E-09_JPRB, 0.13821472E-09_JPRB, 0.13843054E-09_JPRB, 0.13871594E-09_JPRB, 0.13908799E-09_JPRB, 0.13958958E-09_JPRB, &
  & 0.14025277E-09_JPRB, 0.14108867E-09_JPRB, 0.14209629E-09_JPRB, 0.14325463E-09_JPRB, 0.14453012E-09_JPRB, 0.14588719E-09_JPRB, &
  & 0.14727164E-09_JPRB, 0.14863819E-09_JPRB, 0.14994171E-09_JPRB, 0.15115623E-09_JPRB, 0.15227035E-09_JPRB, 0.15328701E-09_JPRB, &
  & 0.15421209E-09_JPRB, 0.15505114E-09_JPRB, 0.15580905E-09_JPRB, 0.15649095E-09_JPRB, 0.15710307E-09_JPRB, 0.15765952E-09_JPRB, &
  & 0.15817875E-09_JPRB, 0.15868427E-09_JPRB, 0.15919893E-09_JPRB, 0.15973350E-09_JPRB, 0.16028338E-09_JPRB, 0.16082354E-09_JPRB, &
  & 0.16131806E-09_JPRB, 0.16173315E-09_JPRB, 0.16203316E-09_JPRB, 0.16220301E-09_JPRB, 0.16222478E-09_JPRB, 0.16209792E-09_JPRB, &
  & 0.16182443E-09_JPRB, 0.16141091E-09_JPRB, 0.16086471E-09_JPRB, 0.16018870E-09_JPRB, 0.15939183E-09_JPRB, 0.15848105E-09_JPRB, &
  & 0.15746987E-09_JPRB, 0.15637740E-09_JPRB, 0.15523155E-09_JPRB, 0.15406434E-09_JPRB, 0.15290719E-09_JPRB, 0.15179585E-09_JPRB, &
  & 0.15074834E-09_JPRB, 0.14976609E-09_JPRB, 0.14885311E-09_JPRB, 0.14802012E-09_JPRB, 0.14726591E-09_JPRB, 0.14658857E-09_JPRB, &
  & 0.14597910E-09_JPRB, 0.14542753E-09_JPRB, 0.14492496E-09_JPRB, 0.14447135E-09_JPRB, 0.14406865E-09_JPRB, 0.14372394E-09_JPRB, &
  & 0.14344381E-09_JPRB, 0.14322830E-09_JPRB, 0.14306736E-09_JPRB, 0.14294296E-09_JPRB /)

RGHG8(:,27, 5) = (/ &
  & 0.14039489E-09_JPRB, 0.14065756E-09_JPRB, 0.14090989E-09_JPRB, 0.14119364E-09_JPRB, 0.14157139E-09_JPRB, 0.14207005E-09_JPRB, &
  & 0.14271706E-09_JPRB, 0.14353449E-09_JPRB, 0.14450489E-09_JPRB, 0.14561112E-09_JPRB, 0.14682780E-09_JPRB, 0.14811366E-09_JPRB, &
  & 0.14943398E-09_JPRB, 0.15074000E-09_JPRB, 0.15199490E-09_JPRB, 0.15316852E-09_JPRB, 0.15424570E-09_JPRB, 0.15522615E-09_JPRB, &
  & 0.15611210E-09_JPRB, 0.15690838E-09_JPRB, 0.15761831E-09_JPRB, 0.15824402E-09_JPRB, 0.15879070E-09_JPRB, 0.15927175E-09_JPRB, &
  & 0.15970546E-09_JPRB, 0.16011634E-09_JPRB, 0.16053256E-09_JPRB, 0.16096867E-09_JPRB, 0.16142844E-09_JPRB, 0.16189913E-09_JPRB, &
  & 0.16234192E-09_JPRB, 0.16272557E-09_JPRB, 0.16301031E-09_JPRB, 0.16317332E-09_JPRB, 0.16319412E-09_JPRB, 0.16306732E-09_JPRB, &
  & 0.16279370E-09_JPRB, 0.16237686E-09_JPRB, 0.16183109E-09_JPRB, 0.16116747E-09_JPRB, 0.16039116E-09_JPRB, 0.15951927E-09_JPRB, &
  & 0.15856894E-09_JPRB, 0.15756428E-09_JPRB, 0.15652613E-09_JPRB, 0.15547959E-09_JPRB, 0.15445738E-09_JPRB, 0.15348220E-09_JPRB, &
  & 0.15256178E-09_JPRB, 0.15170104E-09_JPRB, 0.15090250E-09_JPRB, 0.15016501E-09_JPRB, 0.14949154E-09_JPRB, 0.14887885E-09_JPRB, &
  & 0.14831900E-09_JPRB, 0.14780341E-09_JPRB, 0.14732468E-09_JPRB, 0.14688241E-09_JPRB, 0.14647979E-09_JPRB, 0.14612518E-09_JPRB, &
  & 0.14582627E-09_JPRB, 0.14558266E-09_JPRB, 0.14537847E-09_JPRB, 0.14515843E-09_JPRB /)

RGHG8(:,28, 5) = (/ &
  & 0.14251410E-09_JPRB, 0.14284018E-09_JPRB, 0.14307919E-09_JPRB, 0.14337544E-09_JPRB, 0.14374174E-09_JPRB, 0.14422466E-09_JPRB, &
  & 0.14485790E-09_JPRB, 0.14563928E-09_JPRB, 0.14656855E-09_JPRB, 0.14762049E-09_JPRB, 0.14876915E-09_JPRB, 0.14999070E-09_JPRB, &
  & 0.15124393E-09_JPRB, 0.15249504E-09_JPRB, 0.15370386E-09_JPRB, 0.15484167E-09_JPRB, 0.15589177E-09_JPRB, 0.15684647E-09_JPRB, &
  & 0.15770639E-09_JPRB, 0.15847512E-09_JPRB, 0.15915341E-09_JPRB, 0.15974227E-09_JPRB, 0.16024693E-09_JPRB, 0.16067880E-09_JPRB, &
  & 0.16105377E-09_JPRB, 0.16139678E-09_JPRB, 0.16173238E-09_JPRB, 0.16208405E-09_JPRB, 0.16245980E-09_JPRB, 0.16285141E-09_JPRB, &
  & 0.16323053E-09_JPRB, 0.16356472E-09_JPRB, 0.16381733E-09_JPRB, 0.16395810E-09_JPRB, 0.16396733E-09_JPRB, 0.16383521E-09_JPRB, &
  & 0.16356130E-09_JPRB, 0.16315305E-09_JPRB, 0.16262208E-09_JPRB, 0.16198287E-09_JPRB, 0.16124696E-09_JPRB, 0.16043417E-09_JPRB, &
  & 0.15956504E-09_JPRB, 0.15865889E-09_JPRB, 0.15773272E-09_JPRB, 0.15680987E-09_JPRB, 0.15591184E-09_JPRB, 0.15505444E-09_JPRB, &
  & 0.15424659E-09_JPRB, 0.15348824E-09_JPRB, 0.15277427E-09_JPRB, 0.15211059E-09_JPRB, 0.15149773E-09_JPRB, 0.15093286E-09_JPRB, &
  & 0.15041020E-09_JPRB, 0.14992230E-09_JPRB, 0.14946239E-09_JPRB, 0.14903076E-09_JPRB, 0.14863070E-09_JPRB, 0.14827076E-09_JPRB, &
  & 0.14796030E-09_JPRB, 0.14769798E-09_JPRB, 0.14746468E-09_JPRB, 0.14717928E-09_JPRB /)

RGHG8(:,29, 5) = (/ &
  & 0.14442202E-09_JPRB, 0.14473477E-09_JPRB, 0.14500266E-09_JPRB, 0.14528154E-09_JPRB, 0.14564308E-09_JPRB, 0.14611420E-09_JPRB, &
  & 0.14671780E-09_JPRB, 0.14747305E-09_JPRB, 0.14835505E-09_JPRB, 0.14934982E-09_JPRB, 0.15043804E-09_JPRB, 0.15159096E-09_JPRB, &
  & 0.15278552E-09_JPRB, 0.15398302E-09_JPRB, 0.15515005E-09_JPRB, 0.15625512E-09_JPRB, 0.15727915E-09_JPRB, 0.15821390E-09_JPRB, &
  & 0.15905541E-09_JPRB, 0.15980396E-09_JPRB, 0.16046060E-09_JPRB, 0.16102462E-09_JPRB, 0.16150242E-09_JPRB, 0.16190262E-09_JPRB, &
  & 0.16223894E-09_JPRB, 0.16253476E-09_JPRB, 0.16281063E-09_JPRB, 0.16309240E-09_JPRB, 0.16339274E-09_JPRB, 0.16370734E-09_JPRB, &
  & 0.16401759E-09_JPRB, 0.16429363E-09_JPRB, 0.16450352E-09_JPRB, 0.16461434E-09_JPRB, 0.16460654E-09_JPRB, 0.16446862E-09_JPRB, &
  & 0.16420110E-09_JPRB, 0.16381012E-09_JPRB, 0.16330887E-09_JPRB, 0.16271128E-09_JPRB, 0.16203333E-09_JPRB, 0.16129595E-09_JPRB, &
  & 0.16051982E-09_JPRB, 0.15971760E-09_JPRB, 0.15890771E-09_JPRB, 0.15809840E-09_JPRB, 0.15730822E-09_JPRB, 0.15655163E-09_JPRB, &
  & 0.15583304E-09_JPRB, 0.15514784E-09_JPRB, 0.15449990E-09_JPRB, 0.15389012E-09_JPRB, 0.15331954E-09_JPRB, 0.15278916E-09_JPRB, &
  & 0.15229314E-09_JPRB, 0.15182576E-09_JPRB, 0.15138096E-09_JPRB, 0.15095822E-09_JPRB, 0.15056133E-09_JPRB, 0.15019846E-09_JPRB, &
  & 0.14987928E-09_JPRB, 0.14960246E-09_JPRB, 0.14934563E-09_JPRB, 0.14900368E-09_JPRB /)

RGHG8(:,30, 5) = (/ &
  & 0.14606337E-09_JPRB, 0.14642984E-09_JPRB, 0.14667818E-09_JPRB, 0.14696978E-09_JPRB, 0.14731981E-09_JPRB, 0.14777478E-09_JPRB, &
  & 0.14836403E-09_JPRB, 0.14908108E-09_JPRB, 0.14992155E-09_JPRB, 0.15086331E-09_JPRB, 0.15188899E-09_JPRB, 0.15298378E-09_JPRB, &
  & 0.15411739E-09_JPRB, 0.15526476E-09_JPRB, 0.15639182E-09_JPRB, 0.15746612E-09_JPRB, 0.15846688E-09_JPRB, 0.15938185E-09_JPRB, &
  & 0.16020785E-09_JPRB, 0.16093854E-09_JPRB, 0.16157858E-09_JPRB, 0.16212337E-09_JPRB, 0.16258316E-09_JPRB, 0.16296156E-09_JPRB, &
  & 0.16327303E-09_JPRB, 0.16353603E-09_JPRB, 0.16376855E-09_JPRB, 0.16399597E-09_JPRB, 0.16423218E-09_JPRB, 0.16447749E-09_JPRB, &
  & 0.16472088E-09_JPRB, 0.16493734E-09_JPRB, 0.16510029E-09_JPRB, 0.16517825E-09_JPRB, 0.16515211E-09_JPRB, 0.16501120E-09_JPRB, &
  & 0.16475453E-09_JPRB, 0.16439118E-09_JPRB, 0.16393249E-09_JPRB, 0.16339353E-09_JPRB, 0.16278806E-09_JPRB, 0.16213778E-09_JPRB, &
  & 0.16145774E-09_JPRB, 0.16076131E-09_JPRB, 0.16005242E-09_JPRB, 0.15934738E-09_JPRB, 0.15864680E-09_JPRB, 0.15796846E-09_JPRB, &
  & 0.15731783E-09_JPRB, 0.15669015E-09_JPRB, 0.15608809E-09_JPRB, 0.15551441E-09_JPRB, 0.15497362E-09_JPRB, 0.15446663E-09_JPRB, &
  & 0.15399022E-09_JPRB, 0.15353897E-09_JPRB, 0.15310669E-09_JPRB, 0.15269291E-09_JPRB, 0.15230064E-09_JPRB, 0.15193739E-09_JPRB, &
  & 0.15161379E-09_JPRB, 0.15132770E-09_JPRB, 0.15105543E-09_JPRB, 0.15068022E-09_JPRB /)

RGHG8(:,31, 5) = (/ &
  & 0.14754895E-09_JPRB, 0.14790871E-09_JPRB, 0.14818938E-09_JPRB, 0.14847019E-09_JPRB, 0.14882126E-09_JPRB, 0.14926864E-09_JPRB, &
  & 0.14983180E-09_JPRB, 0.15052186E-09_JPRB, 0.15131699E-09_JPRB, 0.15220536E-09_JPRB, 0.15317643E-09_JPRB, 0.15421042E-09_JPRB, &
  & 0.15529122E-09_JPRB, 0.15638643E-09_JPRB, 0.15747020E-09_JPRB, 0.15851349E-09_JPRB, 0.15949081E-09_JPRB, 0.16038681E-09_JPRB, &
  & 0.16119737E-09_JPRB, 0.16191175E-09_JPRB, 0.16253623E-09_JPRB, 0.16306539E-09_JPRB, 0.16351016E-09_JPRB, 0.16387343E-09_JPRB, &
  & 0.16416755E-09_JPRB, 0.16440807E-09_JPRB, 0.16461127E-09_JPRB, 0.16479700E-09_JPRB, 0.16498239E-09_JPRB, 0.16516725E-09_JPRB, &
  & 0.16534997E-09_JPRB, 0.16551059E-09_JPRB, 0.16562669E-09_JPRB, 0.16567218E-09_JPRB, 0.16562857E-09_JPRB, 0.16548662E-09_JPRB, &
  & 0.16524687E-09_JPRB, 0.16491790E-09_JPRB, 0.16451070E-09_JPRB, 0.16403678E-09_JPRB, 0.16351173E-09_JPRB, 0.16295044E-09_JPRB, &
  & 0.16236645E-09_JPRB, 0.16176648E-09_JPRB, 0.16115512E-09_JPRB, 0.16053117E-09_JPRB, 0.15990834E-09_JPRB, 0.15929183E-09_JPRB, &
  & 0.15869085E-09_JPRB, 0.15810500E-09_JPRB, 0.15753496E-09_JPRB, 0.15698749E-09_JPRB, 0.15646799E-09_JPRB, 0.15597859E-09_JPRB, &
  & 0.15551767E-09_JPRB, 0.15507984E-09_JPRB, 0.15465960E-09_JPRB, 0.15425540E-09_JPRB, 0.15386957E-09_JPRB, 0.15350959E-09_JPRB, &
  & 0.15318453E-09_JPRB, 0.15289414E-09_JPRB, 0.15261309E-09_JPRB, 0.15221707E-09_JPRB /)

RGHG8(:,32, 5) = (/ &
  & 0.14885973E-09_JPRB, 0.14927767E-09_JPRB, 0.14954823E-09_JPRB, 0.14984824E-09_JPRB, 0.15019504E-09_JPRB, 0.15063131E-09_JPRB, &
  & 0.15117863E-09_JPRB, 0.15183109E-09_JPRB, 0.15258234E-09_JPRB, 0.15341961E-09_JPRB, 0.15433176E-09_JPRB, 0.15531082E-09_JPRB, &
  & 0.15633365E-09_JPRB, 0.15738105E-09_JPRB, 0.15842179E-09_JPRB, 0.15942948E-09_JPRB, 0.16038190E-09_JPRB, 0.16125659E-09_JPRB, &
  & 0.16204979E-09_JPRB, 0.16274904E-09_JPRB, 0.16335722E-09_JPRB, 0.16387322E-09_JPRB, 0.16430343E-09_JPRB, 0.16465503E-09_JPRB, &
  & 0.16493573E-09_JPRB, 0.16516018E-09_JPRB, 0.16534246E-09_JPRB, 0.16549864E-09_JPRB, 0.16564340E-09_JPRB, 0.16578028E-09_JPRB, &
  & 0.16591009E-09_JPRB, 0.16602072E-09_JPRB, 0.16609376E-09_JPRB, 0.16610807E-09_JPRB, 0.16604776E-09_JPRB, 0.16590680E-09_JPRB, &
  & 0.16568764E-09_JPRB, 0.16539727E-09_JPRB, 0.16504464E-09_JPRB, 0.16463941E-09_JPRB, 0.16419226E-09_JPRB, 0.16371690E-09_JPRB, &
  & 0.16321830E-09_JPRB, 0.16270434E-09_JPRB, 0.16217083E-09_JPRB, 0.16162056E-09_JPRB, 0.16105862E-09_JPRB, 0.16049426E-09_JPRB, &
  & 0.15993379E-09_JPRB, 0.15937979E-09_JPRB, 0.15883571E-09_JPRB, 0.15830859E-09_JPRB, 0.15780637E-09_JPRB, 0.15733230E-09_JPRB, &
  & 0.15688552E-09_JPRB, 0.15646108E-09_JPRB, 0.15605296E-09_JPRB, 0.15565986E-09_JPRB, 0.15528313E-09_JPRB, 0.15492918E-09_JPRB, &
  & 0.15460745E-09_JPRB, 0.15431639E-09_JPRB, 0.15403102E-09_JPRB, 0.15362125E-09_JPRB /)

RGHG8(:,33, 5) = (/ &
  & 0.15009415E-09_JPRB, 0.15052268E-09_JPRB, 0.15083067E-09_JPRB, 0.15112719E-09_JPRB, 0.15147784E-09_JPRB, 0.15190646E-09_JPRB, &
  & 0.15242727E-09_JPRB, 0.15304591E-09_JPRB, 0.15374950E-09_JPRB, 0.15453103E-09_JPRB, 0.15538772E-09_JPRB, 0.15630594E-09_JPRB, &
  & 0.15727428E-09_JPRB, 0.15826618E-09_JPRB, 0.15926181E-09_JPRB, 0.16023398E-09_JPRB, 0.16115816E-09_JPRB, 0.16201215E-09_JPRB, &
  & 0.16278555E-09_JPRB, 0.16346978E-09_JPRB, 0.16406240E-09_JPRB, 0.16456540E-09_JPRB, 0.16498242E-09_JPRB, 0.16532277E-09_JPRB, &
  & 0.16559235E-09_JPRB, 0.16580391E-09_JPRB, 0.16597015E-09_JPRB, 0.16610435E-09_JPRB, 0.16621871E-09_JPRB, 0.16631796E-09_JPRB, &
  & 0.16640490E-09_JPRB, 0.16647306E-09_JPRB, 0.16650917E-09_JPRB, 0.16649744E-09_JPRB, 0.16642621E-09_JPRB, 0.16629105E-09_JPRB, &
  & 0.16609285E-09_JPRB, 0.16583925E-09_JPRB, 0.16553772E-09_JPRB, 0.16519541E-09_JPRB, 0.16481921E-09_JPRB, 0.16441637E-09_JPRB, &
  & 0.16399371E-09_JPRB, 0.16354758E-09_JPRB, 0.16308090E-09_JPRB, 0.16258767E-09_JPRB, 0.16207782E-09_JPRB, 0.16155842E-09_JPRB, &
  & 0.16103280E-09_JPRB, 0.16050762E-09_JPRB, 0.15998622E-09_JPRB, 0.15947869E-09_JPRB, 0.15899349E-09_JPRB, 0.15853530E-09_JPRB, &
  & 0.15810346E-09_JPRB, 0.15769319E-09_JPRB, 0.15729880E-09_JPRB, 0.15691863E-09_JPRB, 0.15655341E-09_JPRB, 0.15620991E-09_JPRB, &
  & 0.15589462E-09_JPRB, 0.15560755E-09_JPRB, 0.15532237E-09_JPRB, 0.15490670E-09_JPRB /)

RGHG8(:,34, 5) = (/ &
  & 0.15123583E-09_JPRB, 0.15172281E-09_JPRB, 0.15202770E-09_JPRB, 0.15234272E-09_JPRB, 0.15268992E-09_JPRB, 0.15310585E-09_JPRB, &
  & 0.15360389E-09_JPRB, 0.15418218E-09_JPRB, 0.15483667E-09_JPRB, 0.15556362E-09_JPRB, 0.15635862E-09_JPRB, 0.15721849E-09_JPRB, &
  & 0.15812657E-09_JPRB, 0.15906666E-09_JPRB, 0.16001248E-09_JPRB, 0.16094355E-09_JPRB, 0.16183690E-09_JPRB, 0.16266850E-09_JPRB, &
  & 0.16342278E-09_JPRB, 0.16409077E-09_JPRB, 0.16466938E-09_JPRB, 0.16515912E-09_JPRB, 0.16556453E-09_JPRB, 0.16589324E-09_JPRB, &
  & 0.16615270E-09_JPRB, 0.16635276E-09_JPRB, 0.16650575E-09_JPRB, 0.16662220E-09_JPRB, 0.16671328E-09_JPRB, 0.16678370E-09_JPRB, &
  & 0.16683741E-09_JPRB, 0.16687156E-09_JPRB, 0.16687754E-09_JPRB, 0.16684482E-09_JPRB, 0.16676506E-09_JPRB, 0.16663629E-09_JPRB, &
  & 0.16646212E-09_JPRB, 0.16624521E-09_JPRB, 0.16599024E-09_JPRB, 0.16570154E-09_JPRB, 0.16538329E-09_JPRB, 0.16504090E-09_JPRB, &
  & 0.16467468E-09_JPRB, 0.16428633E-09_JPRB, 0.16386968E-09_JPRB, 0.16342630E-09_JPRB, 0.16295931E-09_JPRB, 0.16247700E-09_JPRB, &
  & 0.16198543E-09_JPRB, 0.16148645E-09_JPRB, 0.16098842E-09_JPRB, 0.16050151E-09_JPRB, 0.16003501E-09_JPRB, 0.15959481E-09_JPRB, &
  & 0.15917982E-09_JPRB, 0.15878547E-09_JPRB, 0.15840654E-09_JPRB, 0.15804168E-09_JPRB, 0.15769169E-09_JPRB, 0.15736179E-09_JPRB, &
  & 0.15705831E-09_JPRB, 0.15677931E-09_JPRB, 0.15649920E-09_JPRB, 0.15608548E-09_JPRB /)

RGHG8(:,35, 5) = (/ &
  & 0.15233993E-09_JPRB, 0.15284428E-09_JPRB, 0.15317884E-09_JPRB, 0.15349175E-09_JPRB, 0.15383898E-09_JPRB, 0.15424267E-09_JPRB, &
  & 0.15471244E-09_JPRB, 0.15525213E-09_JPRB, 0.15585686E-09_JPRB, 0.15652626E-09_JPRB, 0.15726230E-09_JPRB, 0.15805872E-09_JPRB, &
  & 0.15890739E-09_JPRB, 0.15978932E-09_JPRB, 0.16068624E-09_JPRB, 0.16157461E-09_JPRB, 0.16243189E-09_JPRB, 0.16323813E-09_JPRB, &
  & 0.16397411E-09_JPRB, 0.16462706E-09_JPRB, 0.16519272E-09_JPRB, 0.16567102E-09_JPRB, 0.16606516E-09_JPRB, 0.16638275E-09_JPRB, &
  & 0.16663144E-09_JPRB, 0.16682022E-09_JPRB, 0.16696095E-09_JPRB, 0.16706250E-09_JPRB, 0.16713513E-09_JPRB, 0.16718324E-09_JPRB, &
  & 0.16721173E-09_JPRB, 0.16722010E-09_JPRB, 0.16720335E-09_JPRB, 0.16715612E-09_JPRB, 0.16707363E-09_JPRB, 0.16695459E-09_JPRB, &
  & 0.16680117E-09_JPRB, 0.16661708E-09_JPRB, 0.16640263E-09_JPRB, 0.16615787E-09_JPRB, 0.16588469E-09_JPRB, 0.16558617E-09_JPRB, &
  & 0.16526469E-09_JPRB, 0.16491614E-09_JPRB, 0.16454159E-09_JPRB, 0.16413652E-09_JPRB, 0.16370671E-09_JPRB, 0.16325891E-09_JPRB, &
  & 0.16279593E-09_JPRB, 0.16232407E-09_JPRB, 0.16184966E-09_JPRB, 0.16138456E-09_JPRB, 0.16093948E-09_JPRB, 0.16051940E-09_JPRB, &
  & 0.16012346E-09_JPRB, 0.15974719E-09_JPRB, 0.15938610E-09_JPRB, 0.15903889E-09_JPRB, 0.15870688E-09_JPRB, 0.15839491E-09_JPRB, &
  & 0.15810726E-09_JPRB, 0.15784110E-09_JPRB, 0.15757129E-09_JPRB, 0.15716710E-09_JPRB /)

RGHG8(:,36, 5) = (/ &
  & 0.15338231E-09_JPRB, 0.15392507E-09_JPRB, 0.15426166E-09_JPRB, 0.15458414E-09_JPRB, 0.15492899E-09_JPRB, 0.15531791E-09_JPRB, &
  & 0.15576235E-09_JPRB, 0.15626241E-09_JPRB, 0.15681773E-09_JPRB, 0.15743112E-09_JPRB, 0.15810561E-09_JPRB, 0.15884051E-09_JPRB, &
  & 0.15962712E-09_JPRB, 0.16045155E-09_JPRB, 0.16129439E-09_JPRB, 0.16213797E-09_JPRB, 0.16295863E-09_JPRB, 0.16373561E-09_JPRB, &
  & 0.16445179E-09_JPRB, 0.16509152E-09_JPRB, 0.16564655E-09_JPRB, 0.16611518E-09_JPRB, 0.16649934E-09_JPRB, 0.16680522E-09_JPRB, &
  & 0.16704128E-09_JPRB, 0.16721709E-09_JPRB, 0.16734417E-09_JPRB, 0.16743155E-09_JPRB, 0.16748847E-09_JPRB, 0.16751976E-09_JPRB, &
  & 0.16752957E-09_JPRB, 0.16752003E-09_JPRB, 0.16748829E-09_JPRB, 0.16743304E-09_JPRB, 0.16735266E-09_JPRB, 0.16724716E-09_JPRB, &
  & 0.16711560E-09_JPRB, 0.16695893E-09_JPRB, 0.16677773E-09_JPRB, 0.16656829E-09_JPRB, 0.16632866E-09_JPRB, 0.16606180E-09_JPRB, &
  & 0.16576894E-09_JPRB, 0.16545162E-09_JPRB, 0.16510636E-09_JPRB, 0.16473413E-09_JPRB, 0.16433582E-09_JPRB, 0.16391662E-09_JPRB, &
  & 0.16348105E-09_JPRB, 0.16303339E-09_JPRB, 0.16258245E-09_JPRB, 0.16214066E-09_JPRB, 0.16171818E-09_JPRB, 0.16132075E-09_JPRB, &
  & 0.16094615E-09_JPRB, 0.16059012E-09_JPRB, 0.16024852E-09_JPRB, 0.15992124E-09_JPRB, 0.15961014E-09_JPRB, 0.15931927E-09_JPRB, &
  & 0.15905166E-09_JPRB, 0.15880282E-09_JPRB, 0.15854799E-09_JPRB, 0.15816155E-09_JPRB /)

RGHG8(:,37, 5) = (/ &
  & 0.15438421E-09_JPRB, 0.15494431E-09_JPRB, 0.15529429E-09_JPRB, 0.15561982E-09_JPRB, 0.15596324E-09_JPRB, 0.15634169E-09_JPRB, &
  & 0.15676108E-09_JPRB, 0.15722318E-09_JPRB, 0.15773015E-09_JPRB, 0.15828772E-09_JPRB, 0.15890192E-09_JPRB, 0.15957366E-09_JPRB, &
  & 0.16029761E-09_JPRB, 0.16106191E-09_JPRB, 0.16184984E-09_JPRB, 0.16264437E-09_JPRB, 0.16342627E-09_JPRB, 0.16417384E-09_JPRB, &
  & 0.16486933E-09_JPRB, 0.16549613E-09_JPRB, 0.16604207E-09_JPRB, 0.16650244E-09_JPRB, 0.16687519E-09_JPRB, 0.16716584E-09_JPRB, &
  & 0.16738372E-09_JPRB, 0.16754115E-09_JPRB, 0.16765062E-09_JPRB, 0.16772286E-09_JPRB, 0.16776530E-09_JPRB, 0.16778437E-09_JPRB, &
  & 0.16778165E-09_JPRB, 0.16776139E-09_JPRB, 0.16772222E-09_JPRB, 0.16766458E-09_JPRB, 0.16758958E-09_JPRB, 0.16749713E-09_JPRB, &
  & 0.16738860E-09_JPRB, 0.16726021E-09_JPRB, 0.16710863E-09_JPRB, 0.16693008E-09_JPRB, 0.16671914E-09_JPRB, 0.16647511E-09_JPRB, &
  & 0.16620330E-09_JPRB, 0.16590596E-09_JPRB, 0.16558470E-09_JPRB, 0.16523707E-09_JPRB, 0.16486534E-09_JPRB, 0.16447178E-09_JPRB, &
  & 0.16405949E-09_JPRB, 0.16363398E-09_JPRB, 0.16320548E-09_JPRB, 0.16278628E-09_JPRB, 0.16238808E-09_JPRB, 0.16201451E-09_JPRB, &
  & 0.16166321E-09_JPRB, 0.16132924E-09_JPRB, 0.16100890E-09_JPRB, 0.16070324E-09_JPRB, 0.16041504E-09_JPRB, 0.16014803E-09_JPRB, &
  & 0.15990348E-09_JPRB, 0.15967525E-09_JPRB, 0.15943968E-09_JPRB, 0.15907745E-09_JPRB /)

RGHG8(:,38, 5) = (/ &
  & 0.15534518E-09_JPRB, 0.15591296E-09_JPRB, 0.15627319E-09_JPRB, 0.15660154E-09_JPRB, 0.15695081E-09_JPRB, 0.15731931E-09_JPRB, &
  & 0.15771666E-09_JPRB, 0.15814298E-09_JPRB, 0.15860234E-09_JPRB, 0.15910467E-09_JPRB, 0.15965930E-09_JPRB, 0.16026835E-09_JPRB, &
  & 0.16092905E-09_JPRB, 0.16163171E-09_JPRB, 0.16236225E-09_JPRB, 0.16310546E-09_JPRB, 0.16384405E-09_JPRB, 0.16456006E-09_JPRB, &
  & 0.16523377E-09_JPRB, 0.16584720E-09_JPRB, 0.16638302E-09_JPRB, 0.16682980E-09_JPRB, 0.16718511E-09_JPRB, 0.16745155E-09_JPRB, &
  & 0.16764284E-09_JPRB, 0.16777546E-09_JPRB, 0.16786400E-09_JPRB, 0.16792019E-09_JPRB, 0.16795051E-09_JPRB, 0.16796070E-09_JPRB, &
  & 0.16795181E-09_JPRB, 0.16792638E-09_JPRB, 0.16788550E-09_JPRB, 0.16783026E-09_JPRB, 0.16776269E-09_JPRB, 0.16768442E-09_JPRB, &
  & 0.16759504E-09_JPRB, 0.16749288E-09_JPRB, 0.16737076E-09_JPRB, 0.16722243E-09_JPRB, 0.16704126E-09_JPRB, 0.16682383E-09_JPRB, &
  & 0.16657291E-09_JPRB, 0.16629384E-09_JPRB, 0.16599114E-09_JPRB, 0.16566513E-09_JPRB, 0.16531568E-09_JPRB, 0.16494373E-09_JPRB, &
  & 0.16455165E-09_JPRB, 0.16414567E-09_JPRB, 0.16373705E-09_JPRB, 0.16334024E-09_JPRB, 0.16296582E-09_JPRB, 0.16261700E-09_JPRB, &
  & 0.16229018E-09_JPRB, 0.16197935E-09_JPRB, 0.16168157E-09_JPRB, 0.16139866E-09_JPRB, 0.16113474E-09_JPRB, 0.16089309E-09_JPRB, &
  & 0.16067345E-09_JPRB, 0.16046808E-09_JPRB, 0.16025421E-09_JPRB, 0.15992120E-09_JPRB /)

RGHG8(:,39, 5) = (/ &
  & 0.15626574E-09_JPRB, 0.15684411E-09_JPRB, 0.15719702E-09_JPRB, 0.15754106E-09_JPRB, 0.15788895E-09_JPRB, 0.15825662E-09_JPRB, &
  & 0.15863397E-09_JPRB, 0.15902515E-09_JPRB, 0.15943834E-09_JPRB, 0.15988703E-09_JPRB, 0.16038190E-09_JPRB, 0.16092958E-09_JPRB, &
  & 0.16152724E-09_JPRB, 0.16216772E-09_JPRB, 0.16283913E-09_JPRB, 0.16352911E-09_JPRB, 0.16422287E-09_JPRB, 0.16490369E-09_JPRB, &
  & 0.16555222E-09_JPRB, 0.16614851E-09_JPRB, 0.16666778E-09_JPRB, 0.16709270E-09_JPRB, 0.16741813E-09_JPRB, 0.16765359E-09_JPRB, &
  & 0.16781473E-09_JPRB, 0.16792252E-09_JPRB, 0.16799249E-09_JPRB, 0.16803550E-09_JPRB, 0.16805762E-09_JPRB, 0.16806186E-09_JPRB, &
  & 0.16805041E-09_JPRB, 0.16802308E-09_JPRB, 0.16798241E-09_JPRB, 0.16792995E-09_JPRB, 0.16786929E-09_JPRB, 0.16780147E-09_JPRB, &
  & 0.16772755E-09_JPRB, 0.16764513E-09_JPRB, 0.16754934E-09_JPRB, 0.16743140E-09_JPRB, 0.16728285E-09_JPRB, 0.16709779E-09_JPRB, &
  & 0.16687561E-09_JPRB, 0.16662130E-09_JPRB, 0.16633867E-09_JPRB, 0.16603280E-09_JPRB, 0.16570326E-09_JPRB, 0.16535061E-09_JPRB, &
  & 0.16497649E-09_JPRB, 0.16458729E-09_JPRB, 0.16419668E-09_JPRB, 0.16382011E-09_JPRB, 0.16346857E-09_JPRB, 0.16314425E-09_JPRB, &
  & 0.16284160E-09_JPRB, 0.16255440E-09_JPRB, 0.16227947E-09_JPRB, 0.16202006E-09_JPRB, 0.16178084E-09_JPRB, 0.16156514E-09_JPRB, &
  & 0.16137069E-09_JPRB, 0.16118884E-09_JPRB, 0.16099758E-09_JPRB, 0.16069690E-09_JPRB /)

RGHG8(:,40, 5) = (/ &
  & 0.15716749E-09_JPRB, 0.15772252E-09_JPRB, 0.15808722E-09_JPRB, 0.15842520E-09_JPRB, 0.15879070E-09_JPRB, 0.15915222E-09_JPRB, &
  & 0.15951301E-09_JPRB, 0.15987096E-09_JPRB, 0.16023946E-09_JPRB, 0.16063434E-09_JPRB, 0.16107207E-09_JPRB, 0.16155861E-09_JPRB, &
  & 0.16209470E-09_JPRB, 0.16267401E-09_JPRB, 0.16328670E-09_JPRB, 0.16392200E-09_JPRB, 0.16456855E-09_JPRB, 0.16521176E-09_JPRB, &
  & 0.16583178E-09_JPRB, 0.16640248E-09_JPRB, 0.16689851E-09_JPRB, 0.16729297E-09_JPRB, 0.16758443E-09_JPRB, 0.16778748E-09_JPRB, &
  & 0.16792286E-09_JPRB, 0.16801115E-09_JPRB, 0.16806781E-09_JPRB, 0.16810195E-09_JPRB, 0.16811880E-09_JPRB, 0.16811996E-09_JPRB, &
  & 0.16810672E-09_JPRB, 0.16807918E-09_JPRB, 0.16803862E-09_JPRB, 0.16798804E-09_JPRB, 0.16793135E-09_JPRB, 0.16787056E-09_JPRB, &
  & 0.16780646E-09_JPRB, 0.16773832E-09_JPRB, 0.16766194E-09_JPRB, 0.16757025E-09_JPRB, 0.16745394E-09_JPRB, 0.16730428E-09_JPRB, &
  & 0.16711731E-09_JPRB, 0.16689354E-09_JPRB, 0.16663809E-09_JPRB, 0.16635371E-09_JPRB, 0.16604421E-09_JPRB, 0.16570921E-09_JPRB, &
  & 0.16535111E-09_JPRB, 0.16497685E-09_JPRB, 0.16460165E-09_JPRB, 0.16424340E-09_JPRB, 0.16391319E-09_JPRB, 0.16361178E-09_JPRB, &
  & 0.16333240E-09_JPRB, 0.16306785E-09_JPRB, 0.16281552E-09_JPRB, 0.16257898E-09_JPRB, 0.16236434E-09_JPRB, 0.16217376E-09_JPRB, &
  & 0.16200383E-09_JPRB, 0.16184463E-09_JPRB, 0.16167612E-09_JPRB, 0.16140760E-09_JPRB /)

RGHG8(:,41, 5) = (/ &
  & 0.15804172E-09_JPRB, 0.15858397E-09_JPRB, 0.15892672E-09_JPRB, 0.15928121E-09_JPRB, 0.15964453E-09_JPRB, 0.16001148E-09_JPRB, &
  & 0.16035397E-09_JPRB, 0.16067979E-09_JPRB, 0.16100402E-09_JPRB, 0.16134805E-09_JPRB, 0.16172833E-09_JPRB, 0.16215626E-09_JPRB, &
  & 0.16263289E-09_JPRB, 0.16315330E-09_JPRB, 0.16370887E-09_JPRB, 0.16429141E-09_JPRB, 0.16489003E-09_JPRB, 0.16549251E-09_JPRB, &
  & 0.16607916E-09_JPRB, 0.16662086E-09_JPRB, 0.16708357E-09_JPRB, 0.16744585E-09_JPRB, 0.16770409E-09_JPRB, 0.16787921E-09_JPRB, &
  & 0.16799412E-09_JPRB, 0.16806825E-09_JPRB, 0.16811563E-09_JPRB, 0.16814400E-09_JPRB, 0.16815736E-09_JPRB, 0.16815706E-09_JPRB, &
  & 0.16814279E-09_JPRB, 0.16811517E-09_JPRB, 0.16807498E-09_JPRB, 0.16802490E-09_JPRB, 0.16797069E-09_JPRB, 0.16791404E-09_JPRB, &
  & 0.16785635E-09_JPRB, 0.16779780E-09_JPRB, 0.16773524E-09_JPRB, 0.16766355E-09_JPRB, 0.16757482E-09_JPRB, 0.16746016E-09_JPRB, &
  & 0.16731148E-09_JPRB, 0.16712418E-09_JPRB, 0.16689973E-09_JPRB, 0.16664164E-09_JPRB, 0.16635238E-09_JPRB, 0.16603505E-09_JPRB, &
  & 0.16569203E-09_JPRB, 0.16533094E-09_JPRB, 0.16496926E-09_JPRB, 0.16462713E-09_JPRB, 0.16431609E-09_JPRB, 0.16403562E-09_JPRB, &
  & 0.16377787E-09_JPRB, 0.16353462E-09_JPRB, 0.16330329E-09_JPRB, 0.16308875E-09_JPRB, 0.16289714E-09_JPRB, 0.16273012E-09_JPRB, &
  & 0.16258275E-09_JPRB, 0.16244470E-09_JPRB, 0.16229691E-09_JPRB, 0.16205944E-09_JPRB /)

RGHG8(:,42, 5) = (/ &
  & 0.15890685E-09_JPRB, 0.15941326E-09_JPRB, 0.15975046E-09_JPRB, 0.16009377E-09_JPRB, 0.16046985E-09_JPRB, 0.16083243E-09_JPRB, &
  & 0.16115824E-09_JPRB, 0.16145228E-09_JPRB, 0.16173500E-09_JPRB, 0.16202875E-09_JPRB, 0.16235435E-09_JPRB, 0.16272508E-09_JPRB, &
  & 0.16314516E-09_JPRB, 0.16361014E-09_JPRB, 0.16411217E-09_JPRB, 0.16464322E-09_JPRB, 0.16519551E-09_JPRB, 0.16575585E-09_JPRB, &
  & 0.16630508E-09_JPRB, 0.16681158E-09_JPRB, 0.16723978E-09_JPRB, 0.16756622E-09_JPRB, 0.16779494E-09_JPRB, 0.16794656E-09_JPRB, &
  & 0.16804522E-09_JPRB, 0.16810885E-09_JPRB, 0.16814952E-09_JPRB, 0.16817406E-09_JPRB, 0.16818522E-09_JPRB, 0.16818390E-09_JPRB, &
  & 0.16816945E-09_JPRB, 0.16814142E-09_JPRB, 0.16810177E-09_JPRB, 0.16805159E-09_JPRB, 0.16799866E-09_JPRB, 0.16794462E-09_JPRB, &
  & 0.16789116E-09_JPRB, 0.16783902E-09_JPRB, 0.16778666E-09_JPRB, 0.16772984E-09_JPRB, 0.16766311E-09_JPRB, 0.16757860E-09_JPRB, &
  & 0.16746753E-09_JPRB, 0.16732131E-09_JPRB, 0.16713381E-09_JPRB, 0.16690681E-09_JPRB, 0.16664206E-09_JPRB, 0.16634311E-09_JPRB, &
  & 0.16601506E-09_JPRB, 0.16566651E-09_JPRB, 0.16531640E-09_JPRB, 0.16498872E-09_JPRB, 0.16469484E-09_JPRB, 0.16443354E-09_JPRB, &
  & 0.16419524E-09_JPRB, 0.16397143E-09_JPRB, 0.16375951E-09_JPRB, 0.16356497E-09_JPRB, 0.16339427E-09_JPRB, 0.16324826E-09_JPRB, &
  & 0.16312067E-09_JPRB, 0.16300106E-09_JPRB, 0.16287194E-09_JPRB, 0.16266187E-09_JPRB /)

RGHG8(:,43, 5) = (/ &
  & 0.15976004E-09_JPRB, 0.16023541E-09_JPRB, 0.16054856E-09_JPRB, 0.16088798E-09_JPRB, 0.16126270E-09_JPRB, 0.16162127E-09_JPRB, &
  & 0.16192885E-09_JPRB, 0.16219161E-09_JPRB, 0.16243466E-09_JPRB, 0.16268226E-09_JPRB, 0.16295594E-09_JPRB, 0.16327206E-09_JPRB, &
  & 0.16363855E-09_JPRB, 0.16405227E-09_JPRB, 0.16450459E-09_JPRB, 0.16498827E-09_JPRB, 0.16549387E-09_JPRB, 0.16601130E-09_JPRB, &
  & 0.16651883E-09_JPRB, 0.16698656E-09_JPRB, 0.16737496E-09_JPRB, 0.16766681E-09_JPRB, 0.16786740E-09_JPRB, 0.16799936E-09_JPRB, &
  & 0.16808477E-09_JPRB, 0.16814031E-09_JPRB, 0.16817606E-09_JPRB, 0.16819776E-09_JPRB, 0.16820760E-09_JPRB, 0.16820570E-09_JPRB, &
  & 0.16819139E-09_JPRB, 0.16816319E-09_JPRB, 0.16812360E-09_JPRB, 0.16807340E-09_JPRB, 0.16802071E-09_JPRB, 0.16796835E-09_JPRB, &
  & 0.16791744E-09_JPRB, 0.16787013E-09_JPRB, 0.16782506E-09_JPRB, 0.16777997E-09_JPRB, 0.16773069E-09_JPRB, 0.16767150E-09_JPRB, &
  & 0.16759433E-09_JPRB, 0.16748868E-09_JPRB, 0.16734515E-09_JPRB, 0.16715623E-09_JPRB, 0.16692192E-09_JPRB, 0.16664574E-09_JPRB, &
  & 0.16633400E-09_JPRB, 0.16599774E-09_JPRB, 0.16565918E-09_JPRB, 0.16534413E-09_JPRB, 0.16506632E-09_JPRB, 0.16482213E-09_JPRB, &
  & 0.16460179E-09_JPRB, 0.16439555E-09_JPRB, 0.16420101E-09_JPRB, 0.16402425E-09_JPRB, 0.16387178E-09_JPRB, 0.16374359E-09_JPRB, &
  & 0.16363259E-09_JPRB, 0.16352858E-09_JPRB, 0.16341500E-09_JPRB, 0.16322843E-09_JPRB /)

RGHG8(:,44, 5) = (/ &
  & 0.16060761E-09_JPRB, 0.16103940E-09_JPRB, 0.16133914E-09_JPRB, 0.16166053E-09_JPRB, 0.16203050E-09_JPRB, 0.16238245E-09_JPRB, &
  & 0.16266868E-09_JPRB, 0.16290255E-09_JPRB, 0.16310948E-09_JPRB, 0.16331508E-09_JPRB, 0.16354104E-09_JPRB, 0.16380711E-09_JPRB, &
  & 0.16412341E-09_JPRB, 0.16448996E-09_JPRB, 0.16489805E-09_JPRB, 0.16533618E-09_JPRB, 0.16579776E-09_JPRB, 0.16626844E-09_JPRB, &
  & 0.16673143E-09_JPRB, 0.16715107E-09_JPRB, 0.16749828E-09_JPRB, 0.16775323E-09_JPRB, 0.16792810E-09_JPRB, 0.16804261E-09_JPRB, &
  & 0.16811715E-09_JPRB, 0.16816618E-09_JPRB, 0.16819827E-09_JPRB, 0.16821801E-09_JPRB, 0.16822709E-09_JPRB, 0.16822496E-09_JPRB, &
  & 0.16821089E-09_JPRB, 0.16818272E-09_JPRB, 0.16814308E-09_JPRB, 0.16809262E-09_JPRB, 0.16803972E-09_JPRB, 0.16798805E-09_JPRB, &
  & 0.16793890E-09_JPRB, 0.16789475E-09_JPRB, 0.16785545E-09_JPRB, 0.16781943E-09_JPRB, 0.16778449E-09_JPRB, 0.16774641E-09_JPRB, &
  & 0.16769844E-09_JPRB, 0.16763124E-09_JPRB, 0.16753215E-09_JPRB, 0.16738963E-09_JPRB, 0.16719569E-09_JPRB, 0.16694957E-09_JPRB, &
  & 0.16665838E-09_JPRB, 0.16633603E-09_JPRB, 0.16600887E-09_JPRB, 0.16570743E-09_JPRB, 0.16544396E-09_JPRB, 0.16521649E-09_JPRB, &
  & 0.16501217E-09_JPRB, 0.16482191E-09_JPRB, 0.16464299E-09_JPRB, 0.16448165E-09_JPRB, 0.16434468E-09_JPRB, 0.16423093E-09_JPRB, &
  & 0.16413373E-09_JPRB, 0.16404204E-09_JPRB, 0.16394168E-09_JPRB, 0.16377405E-09_JPRB /)

RGHG8(:,45, 5) = (/ &
  & 0.16143024E-09_JPRB, 0.16184108E-09_JPRB, 0.16210727E-09_JPRB, 0.16242004E-09_JPRB, 0.16277799E-09_JPRB, 0.16311716E-09_JPRB, &
  & 0.16338426E-09_JPRB, 0.16359072E-09_JPRB, 0.16376629E-09_JPRB, 0.16393571E-09_JPRB, 0.16412149E-09_JPRB, 0.16434118E-09_JPRB, &
  & 0.16461281E-09_JPRB, 0.16493652E-09_JPRB, 0.16530297E-09_JPRB, 0.16570093E-09_JPRB, 0.16611572E-09_JPRB, 0.16653866E-09_JPRB, &
  & 0.16694555E-09_JPRB, 0.16731391E-09_JPRB, 0.16761011E-09_JPRB, 0.16783024E-09_JPRB, 0.16797976E-09_JPRB, 0.16807919E-09_JPRB, &
  & 0.16814458E-09_JPRB, 0.16818837E-09_JPRB, 0.16821773E-09_JPRB, 0.16823622E-09_JPRB, 0.16824497E-09_JPRB, 0.16824300E-09_JPRB, &
  & 0.16822918E-09_JPRB, 0.16820123E-09_JPRB, 0.16816135E-09_JPRB, 0.16811057E-09_JPRB, 0.16805694E-09_JPRB, 0.16800528E-09_JPRB, &
  & 0.16795684E-09_JPRB, 0.16791508E-09_JPRB, 0.16788008E-09_JPRB, 0.16785158E-09_JPRB, 0.16782828E-09_JPRB, 0.16780759E-09_JPRB, &
  & 0.16778429E-09_JPRB, 0.16774976E-09_JPRB, 0.16769286E-09_JPRB, 0.16759866E-09_JPRB, 0.16745358E-09_JPRB, 0.16724963E-09_JPRB, &
  & 0.16698690E-09_JPRB, 0.16668415E-09_JPRB, 0.16637261E-09_JPRB, 0.16608381E-09_JPRB, 0.16583730E-09_JPRB, 0.16562438E-09_JPRB, &
  & 0.16543636E-09_JPRB, 0.16526075E-09_JPRB, 0.16509592E-09_JPRB, 0.16494818E-09_JPRB, 0.16482374E-09_JPRB, 0.16472226E-09_JPRB, &
  & 0.16463546E-09_JPRB, 0.16455437E-09_JPRB, 0.16446410E-09_JPRB, 0.16431267E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART9',1,ZHOOK_HANDLE)
END SUBROUTINE PART9




SUBROUTINE PART10
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART10',0,ZHOOK_HANDLE)



RGHG8(:,46, 5) = (/ &
  & 0.16224652E-09_JPRB, 0.16260703E-09_JPRB, 0.16287376E-09_JPRB, 0.16315629E-09_JPRB, 0.16350776E-09_JPRB, 0.16383458E-09_JPRB, &
  & 0.16408139E-09_JPRB, 0.16426505E-09_JPRB, 0.16441441E-09_JPRB, 0.16455533E-09_JPRB, 0.16470619E-09_JPRB, 0.16488999E-09_JPRB, &
  & 0.16511920E-09_JPRB, 0.16540450E-09_JPRB, 0.16573433E-09_JPRB, 0.16609031E-09_JPRB, 0.16645980E-09_JPRB, 0.16682426E-09_JPRB, &
  & 0.16716961E-09_JPRB, 0.16747000E-09_JPRB, 0.16771655E-09_JPRB, 0.16789775E-09_JPRB, 0.16802501E-09_JPRB, 0.16811053E-09_JPRB, &
  & 0.16816826E-09_JPRB, 0.16820792E-09_JPRB, 0.16823527E-09_JPRB, 0.16825309E-09_JPRB, 0.16826188E-09_JPRB, 0.16826041E-09_JPRB, &
  & 0.16824700E-09_JPRB, 0.16821948E-09_JPRB, 0.16817919E-09_JPRB, 0.16812782E-09_JPRB, 0.16807321E-09_JPRB, 0.16802072E-09_JPRB, &
  & 0.16797247E-09_JPRB, 0.16793203E-09_JPRB, 0.16790067E-09_JPRB, 0.16787818E-09_JPRB, 0.16786467E-09_JPRB, 0.16785823E-09_JPRB, &
  & 0.16785458E-09_JPRB, 0.16784685E-09_JPRB, 0.16782448E-09_JPRB, 0.16777442E-09_JPRB, 0.16768098E-09_JPRB, 0.16752816E-09_JPRB, &
  & 0.16731036E-09_JPRB, 0.16703799E-09_JPRB, 0.16674634E-09_JPRB, 0.16647779E-09_JPRB, 0.16624492E-09_JPRB, 0.16605101E-09_JPRB, &
  & 0.16587674E-09_JPRB, 0.16571591E-09_JPRB, 0.16556398E-09_JPRB, 0.16542812E-09_JPRB, 0.16531493E-09_JPRB, 0.16522299E-09_JPRB, &
  & 0.16514545E-09_JPRB, 0.16507223E-09_JPRB, 0.16499097E-09_JPRB, 0.16485247E-09_JPRB /)

RGHG8(:,47, 5) = (/ &
  & 0.16301946E-09_JPRB, 0.16337662E-09_JPRB, 0.16360539E-09_JPRB, 0.16389258E-09_JPRB, 0.16422273E-09_JPRB, 0.16454020E-09_JPRB, &
  & 0.16477202E-09_JPRB, 0.16493655E-09_JPRB, 0.16506629E-09_JPRB, 0.16518385E-09_JPRB, 0.16531032E-09_JPRB, 0.16546049E-09_JPRB, &
  & 0.16565802E-09_JPRB, 0.16590671E-09_JPRB, 0.16619985E-09_JPRB, 0.16651520E-09_JPRB, 0.16682941E-09_JPRB, 0.16712631E-09_JPRB, &
  & 0.16739254E-09_JPRB, 0.16762404E-09_JPRB, 0.16781226E-09_JPRB, 0.16795910E-09_JPRB, 0.16806419E-09_JPRB, 0.16813792E-09_JPRB, &
  & 0.16818913E-09_JPRB, 0.16822543E-09_JPRB, 0.16825139E-09_JPRB, 0.16826900E-09_JPRB, 0.16827820E-09_JPRB, 0.16827752E-09_JPRB, &
  & 0.16826472E-09_JPRB, 0.16823763E-09_JPRB, 0.16819694E-09_JPRB, 0.16814486E-09_JPRB, 0.16808883E-09_JPRB, 0.16803507E-09_JPRB, &
  & 0.16798619E-09_JPRB, 0.16794671E-09_JPRB, 0.16791799E-09_JPRB, 0.16790075E-09_JPRB, 0.16789538E-09_JPRB, 0.16790053E-09_JPRB, &
  & 0.16791243E-09_JPRB, 0.16792503E-09_JPRB, 0.16792928E-09_JPRB, 0.16791397E-09_JPRB, 0.16786578E-09_JPRB, 0.16776903E-09_JPRB, &
  & 0.16760840E-09_JPRB, 0.16738431E-09_JPRB, 0.16712812E-09_JPRB, 0.16688038E-09_JPRB, 0.16667151E-09_JPRB, 0.16649192E-09_JPRB, &
  & 0.16633543E-09_JPRB, 0.16618719E-09_JPRB, 0.16604762E-09_JPRB, 0.16592250E-09_JPRB, 0.16581871E-09_JPRB, 0.16573522E-09_JPRB, &
  & 0.16566482E-09_JPRB, 0.16559853E-09_JPRB, 0.16552430E-09_JPRB, 0.16539695E-09_JPRB /)

RGHG8(:,48, 5) = (/ &
  & 0.16378160E-09_JPRB, 0.16410585E-09_JPRB, 0.16434579E-09_JPRB, 0.16460726E-09_JPRB, 0.16494339E-09_JPRB, 0.16525131E-09_JPRB, &
  & 0.16547329E-09_JPRB, 0.16562490E-09_JPRB, 0.16573921E-09_JPRB, 0.16584034E-09_JPRB, 0.16594509E-09_JPRB, 0.16607250E-09_JPRB, &
  & 0.16623740E-09_JPRB, 0.16645341E-09_JPRB, 0.16670530E-09_JPRB, 0.16696713E-09_JPRB, 0.16721012E-09_JPRB, 0.16742378E-09_JPRB, &
  & 0.16760583E-09_JPRB, 0.16776383E-09_JPRB, 0.16790061E-09_JPRB, 0.16801241E-09_JPRB, 0.16809878E-09_JPRB, 0.16816190E-09_JPRB, &
  & 0.16820770E-09_JPRB, 0.16824145E-09_JPRB, 0.16826647E-09_JPRB, 0.16828425E-09_JPRB, 0.16829421E-09_JPRB, 0.16829453E-09_JPRB, &
  & 0.16828249E-09_JPRB, 0.16825599E-09_JPRB, 0.16821480E-09_JPRB, 0.16816182E-09_JPRB, 0.16810416E-09_JPRB, 0.16804851E-09_JPRB, &
  & 0.16799877E-09_JPRB, 0.16795951E-09_JPRB, 0.16793299E-09_JPRB, 0.16792004E-09_JPRB, 0.16792154E-09_JPRB, 0.16793629E-09_JPRB, &
  & 0.16796076E-09_JPRB, 0.16798846E-09_JPRB, 0.16801169E-09_JPRB, 0.16802147E-09_JPRB, 0.16800815E-09_JPRB, 0.16795959E-09_JPRB, &
  & 0.16785995E-09_JPRB, 0.16770139E-09_JPRB, 0.16749742E-09_JPRB, 0.16729088E-09_JPRB, 0.16710680E-09_JPRB, 0.16695004E-09_JPRB, &
  & 0.16680755E-09_JPRB, 0.16667343E-09_JPRB, 0.16654420E-09_JPRB, 0.16642848E-09_JPRB, 0.16633298E-09_JPRB, 0.16625659E-09_JPRB, &
  & 0.16619230E-09_JPRB, 0.16613165E-09_JPRB, 0.16606318E-09_JPRB, 0.16594494E-09_JPRB /)

RGHG8(:,49, 5) = (/ &
  & 0.16451399E-09_JPRB, 0.16483929E-09_JPRB, 0.16506833E-09_JPRB, 0.16534110E-09_JPRB, 0.16567341E-09_JPRB, 0.16598484E-09_JPRB, &
  & 0.16620084E-09_JPRB, 0.16634294E-09_JPRB, 0.16644476E-09_JPRB, 0.16653140E-09_JPRB, 0.16661755E-09_JPRB, 0.16672073E-09_JPRB, &
  & 0.16685468E-09_JPRB, 0.16702537E-09_JPRB, 0.16721964E-09_JPRB, 0.16740230E-09_JPRB, 0.16755966E-09_JPRB, 0.16768481E-09_JPRB, &
  & 0.16779170E-09_JPRB, 0.16788659E-09_JPRB, 0.16797741E-09_JPRB, 0.16805982E-09_JPRB, 0.16812886E-09_JPRB, 0.16818311E-09_JPRB, &
  & 0.16822448E-09_JPRB, 0.16825633E-09_JPRB, 0.16828092E-09_JPRB, 0.16829912E-09_JPRB, 0.16831005E-09_JPRB, 0.16831163E-09_JPRB, &
  & 0.16830055E-09_JPRB, 0.16827463E-09_JPRB, 0.16823304E-09_JPRB, 0.16817897E-09_JPRB, 0.16811937E-09_JPRB, 0.16806154E-09_JPRB, &
  & 0.16801044E-09_JPRB, 0.16797111E-09_JPRB, 0.16794609E-09_JPRB, 0.16793676E-09_JPRB, 0.16794421E-09_JPRB, 0.16796736E-09_JPRB, &
  & 0.16800170E-09_JPRB, 0.16804122E-09_JPRB, 0.16807736E-09_JPRB, 0.16810406E-09_JPRB, 0.16811486E-09_JPRB, 0.16810157E-09_JPRB, &
  & 0.16805411E-09_JPRB, 0.16796080E-09_JPRB, 0.16782847E-09_JPRB, 0.16768034E-09_JPRB, 0.16753710E-09_JPRB, 0.16740953E-09_JPRB, &
  & 0.16728735E-09_JPRB, 0.16716746E-09_JPRB, 0.16704935E-09_JPRB, 0.16694235E-09_JPRB, 0.16685406E-09_JPRB, 0.16678395E-09_JPRB, &
  & 0.16672469E-09_JPRB, 0.16666873E-09_JPRB, 0.16660454E-09_JPRB, 0.16649294E-09_JPRB /)

RGHG8(:,50, 5) = (/ &
  & 0.16522288E-09_JPRB, 0.16556669E-09_JPRB, 0.16579474E-09_JPRB, 0.16607890E-09_JPRB, 0.16641358E-09_JPRB, 0.16672037E-09_JPRB, &
  & 0.16692354E-09_JPRB, 0.16704876E-09_JPRB, 0.16713513E-09_JPRB, 0.16720134E-09_JPRB, 0.16726788E-09_JPRB, 0.16733934E-09_JPRB, &
  & 0.16743179E-09_JPRB, 0.16754269E-09_JPRB, 0.16765597E-09_JPRB, 0.16775628E-09_JPRB, 0.16783153E-09_JPRB, 0.16789103E-09_JPRB, &
  & 0.16794004E-09_JPRB, 0.16799082E-09_JPRB, 0.16804425E-09_JPRB, 0.16810141E-09_JPRB, 0.16815560E-09_JPRB, 0.16820215E-09_JPRB, &
  & 0.16824006E-09_JPRB, 0.16827055E-09_JPRB, 0.16829502E-09_JPRB, 0.16831386E-09_JPRB, 0.16832598E-09_JPRB, 0.16832891E-09_JPRB, &
  & 0.16831904E-09_JPRB, 0.16829377E-09_JPRB, 0.16825168E-09_JPRB, 0.16819632E-09_JPRB, 0.16813451E-09_JPRB, 0.16807439E-09_JPRB, &
  & 0.16802165E-09_JPRB, 0.16798174E-09_JPRB, 0.16795769E-09_JPRB, 0.16795129E-09_JPRB, 0.16796414E-09_JPRB, 0.16799469E-09_JPRB, &
  & 0.16803817E-09_JPRB, 0.16808566E-09_JPRB, 0.16813161E-09_JPRB, 0.16816895E-09_JPRB, 0.16819553E-09_JPRB, 0.16820614E-09_JPRB, &
  & 0.16819403E-09_JPRB, 0.16815351E-09_JPRB, 0.16808496E-09_JPRB, 0.16799886E-09_JPRB, 0.16791404E-09_JPRB, 0.16782442E-09_JPRB, &
  & 0.16773674E-09_JPRB, 0.16764119E-09_JPRB, 0.16754237E-09_JPRB, 0.16744842E-09_JPRB, 0.16737066E-09_JPRB, 0.16730733E-09_JPRB, &
  & 0.16725434E-09_JPRB, 0.16720200E-09_JPRB, 0.16714249E-09_JPRB, 0.16703344E-09_JPRB /)

RGHG8(:,51, 5) = (/ &
  & 0.16592790E-09_JPRB, 0.16624947E-09_JPRB, 0.16651408E-09_JPRB, 0.16677423E-09_JPRB, 0.16710583E-09_JPRB, 0.16737260E-09_JPRB, &
  & 0.16753679E-09_JPRB, 0.16763181E-09_JPRB, 0.16769001E-09_JPRB, 0.16773608E-09_JPRB, 0.16777355E-09_JPRB, 0.16781694E-09_JPRB, &
  & 0.16786346E-09_JPRB, 0.16791624E-09_JPRB, 0.16796552E-09_JPRB, 0.16800124E-09_JPRB, 0.16802564E-09_JPRB, 0.16804190E-09_JPRB, &
  & 0.16805773E-09_JPRB, 0.16807651E-09_JPRB, 0.16810400E-09_JPRB, 0.16813934E-09_JPRB, 0.16817980E-09_JPRB, 0.16821966E-09_JPRB, &
  & 0.16825476E-09_JPRB, 0.16828446E-09_JPRB, 0.16830917E-09_JPRB, 0.16832884E-09_JPRB, 0.16834222E-09_JPRB, 0.16834655E-09_JPRB, &
  & 0.16833802E-09_JPRB, 0.16831345E-09_JPRB, 0.16827095E-09_JPRB, 0.16821407E-09_JPRB, 0.16815002E-09_JPRB, 0.16808731E-09_JPRB, &
  & 0.16803268E-09_JPRB, 0.16799177E-09_JPRB, 0.16796814E-09_JPRB, 0.16796423E-09_JPRB, 0.16798195E-09_JPRB, 0.16801976E-09_JPRB, &
  & 0.16807006E-09_JPRB, 0.16812568E-09_JPRB, 0.16817686E-09_JPRB, 0.16822266E-09_JPRB, 0.16825882E-09_JPRB, 0.16828476E-09_JPRB, &
  & 0.16829561E-09_JPRB, 0.16828777E-09_JPRB, 0.16826214E-09_JPRB, 0.16822684E-09_JPRB, 0.16818388E-09_JPRB, 0.16814147E-09_JPRB, &
  & 0.16809133E-09_JPRB, 0.16803500E-09_JPRB, 0.16796906E-09_JPRB, 0.16790289E-09_JPRB, 0.16784285E-09_JPRB, 0.16779425E-09_JPRB, &
  & 0.16774944E-09_JPRB, 0.16770635E-09_JPRB, 0.16765012E-09_JPRB, 0.16755078E-09_JPRB /)

RGHG8(:,52, 5) = (/ &
  & 0.16654404E-09_JPRB, 0.16691681E-09_JPRB, 0.16712154E-09_JPRB, 0.16739425E-09_JPRB, 0.16765143E-09_JPRB, 0.16785728E-09_JPRB, &
  & 0.16796785E-09_JPRB, 0.16802612E-09_JPRB, 0.16806209E-09_JPRB, 0.16808521E-09_JPRB, 0.16810650E-09_JPRB, 0.16812390E-09_JPRB, &
  & 0.16814281E-09_JPRB, 0.16815846E-09_JPRB, 0.16816720E-09_JPRB, 0.16816767E-09_JPRB, 0.16816218E-09_JPRB, 0.16815498E-09_JPRB, &
  & 0.16815005E-09_JPRB, 0.16814990E-09_JPRB, 0.16815740E-09_JPRB, 0.16817528E-09_JPRB, 0.16820317E-09_JPRB, 0.16823623E-09_JPRB, &
  & 0.16826904E-09_JPRB, 0.16829836E-09_JPRB, 0.16832358E-09_JPRB, 0.16834423E-09_JPRB, 0.16835897E-09_JPRB, 0.16836468E-09_JPRB, &
  & 0.16835759E-09_JPRB, 0.16833371E-09_JPRB, 0.16829085E-09_JPRB, 0.16823241E-09_JPRB, 0.16816588E-09_JPRB, 0.16810053E-09_JPRB, &
  & 0.16804372E-09_JPRB, 0.16800153E-09_JPRB, 0.16797794E-09_JPRB, 0.16797609E-09_JPRB, 0.16799830E-09_JPRB, 0.16804208E-09_JPRB, &
  & 0.16809990E-09_JPRB, 0.16815958E-09_JPRB, 0.16821761E-09_JPRB, 0.16826762E-09_JPRB, 0.16831223E-09_JPRB, 0.16834728E-09_JPRB, &
  & 0.16837221E-09_JPRB, 0.16838352E-09_JPRB, 0.16838256E-09_JPRB, 0.16837298E-09_JPRB, 0.16836030E-09_JPRB, 0.16834345E-09_JPRB, &
  & 0.16832465E-09_JPRB, 0.16829990E-09_JPRB, 0.16826911E-09_JPRB, 0.16823384E-09_JPRB, 0.16820143E-09_JPRB, 0.16817089E-09_JPRB, &
  & 0.16814392E-09_JPRB, 0.16811230E-09_JPRB, 0.16807354E-09_JPRB, 0.16798560E-09_JPRB /)

RGHG8(:,53, 5) = (/ &
  & 0.16712789E-09_JPRB, 0.16741636E-09_JPRB, 0.16764976E-09_JPRB, 0.16783369E-09_JPRB, 0.16804283E-09_JPRB, 0.16817461E-09_JPRB, &
  & 0.16824270E-09_JPRB, 0.16827634E-09_JPRB, 0.16829449E-09_JPRB, 0.16830709E-09_JPRB, 0.16831492E-09_JPRB, 0.16832108E-09_JPRB, &
  & 0.16832315E-09_JPRB, 0.16831891E-09_JPRB, 0.16830633E-09_JPRB, 0.16828691E-09_JPRB, 0.16826451E-09_JPRB, 0.16824386E-09_JPRB, &
  & 0.16822552E-09_JPRB, 0.16821294E-09_JPRB, 0.16820666E-09_JPRB, 0.16821025E-09_JPRB, 0.16822607E-09_JPRB, 0.16825270E-09_JPRB, &
  & 0.16828312E-09_JPRB, 0.16831239E-09_JPRB, 0.16833845E-09_JPRB, 0.16836027E-09_JPRB, 0.16837637E-09_JPRB, 0.16838356E-09_JPRB, &
  & 0.16837783E-09_JPRB, 0.16835459E-09_JPRB, 0.16831141E-09_JPRB, 0.16825133E-09_JPRB, 0.16818238E-09_JPRB, 0.16811418E-09_JPRB, &
  & 0.16805500E-09_JPRB, 0.16801124E-09_JPRB, 0.16798757E-09_JPRB, 0.16798751E-09_JPRB, 0.16801342E-09_JPRB, 0.16806287E-09_JPRB, &
  & 0.16812504E-09_JPRB, 0.16819135E-09_JPRB, 0.16825218E-09_JPRB, 0.16830892E-09_JPRB, 0.16835779E-09_JPRB, 0.16840096E-09_JPRB, &
  & 0.16843364E-09_JPRB, 0.16845558E-09_JPRB, 0.16846714E-09_JPRB, 0.16847097E-09_JPRB, 0.16847071E-09_JPRB, 0.16846811E-09_JPRB, &
  & 0.16846327E-09_JPRB, 0.16845583E-09_JPRB, 0.16844470E-09_JPRB, 0.16843131E-09_JPRB, 0.16841686E-09_JPRB, 0.16840424E-09_JPRB, &
  & 0.16839061E-09_JPRB, 0.16837637E-09_JPRB, 0.16835314E-09_JPRB, 0.16830187E-09_JPRB /)

RGHG8(:,54, 5) = (/ &
  & 0.16757820E-09_JPRB, 0.16786253E-09_JPRB, 0.16799978E-09_JPRB, 0.16816348E-09_JPRB, 0.16829542E-09_JPRB, 0.16838234E-09_JPRB, &
  & 0.16842124E-09_JPRB, 0.16843948E-09_JPRB, 0.16844900E-09_JPRB, 0.16845386E-09_JPRB, 0.16845633E-09_JPRB, 0.16845564E-09_JPRB, &
  & 0.16844959E-09_JPRB, 0.16843563E-09_JPRB, 0.16841155E-09_JPRB, 0.16838062E-09_JPRB, 0.16834854E-09_JPRB, 0.16831736E-09_JPRB, &
  & 0.16829121E-09_JPRB, 0.16826823E-09_JPRB, 0.16825186E-09_JPRB, 0.16824406E-09_JPRB, 0.16824965E-09_JPRB, 0.16826940E-09_JPRB, &
  & 0.16829765E-09_JPRB, 0.16832688E-09_JPRB, 0.16835390E-09_JPRB, 0.16837710E-09_JPRB, 0.16839465E-09_JPRB, 0.16840328E-09_JPRB, &
  & 0.16839878E-09_JPRB, 0.16837610E-09_JPRB, 0.16833260E-09_JPRB, 0.16827092E-09_JPRB, 0.16819951E-09_JPRB, 0.16812855E-09_JPRB, &
  & 0.16806677E-09_JPRB, 0.16802139E-09_JPRB, 0.16799757E-09_JPRB, 0.16799909E-09_JPRB, 0.16802816E-09_JPRB, 0.16808127E-09_JPRB, &
  & 0.16814852E-09_JPRB, 0.16821768E-09_JPRB, 0.16828478E-09_JPRB, 0.16834462E-09_JPRB, 0.16840038E-09_JPRB, 0.16844752E-09_JPRB, &
  & 0.16848659E-09_JPRB, 0.16851408E-09_JPRB, 0.16853099E-09_JPRB, 0.16854110E-09_JPRB, 0.16854616E-09_JPRB, 0.16854904E-09_JPRB, &
  & 0.16855028E-09_JPRB, 0.16854995E-09_JPRB, 0.16854770E-09_JPRB, 0.16854410E-09_JPRB, 0.16854010E-09_JPRB, 0.16853585E-09_JPRB, &
  & 0.16853202E-09_JPRB, 0.16852755E-09_JPRB, 0.16852283E-09_JPRB, 0.16851572E-09_JPRB /)

RGHG8(:,55, 5) = (/ &
  & 0.16792816E-09_JPRB, 0.16814157E-09_JPRB, 0.16827800E-09_JPRB, 0.16837823E-09_JPRB, 0.16847149E-09_JPRB, 0.16852320E-09_JPRB, &
  & 0.16854609E-09_JPRB, 0.16855567E-09_JPRB, 0.16855982E-09_JPRB, 0.16856135E-09_JPRB, 0.16856067E-09_JPRB, 0.16855667E-09_JPRB, &
  & 0.16854773E-09_JPRB, 0.16852880E-09_JPRB, 0.16849905E-09_JPRB, 0.16846183E-09_JPRB, 0.16842175E-09_JPRB, 0.16838428E-09_JPRB, &
  & 0.16834883E-09_JPRB, 0.16831883E-09_JPRB, 0.16829332E-09_JPRB, 0.16827614E-09_JPRB, 0.16827309E-09_JPRB, 0.16828736E-09_JPRB, &
  & 0.16831303E-09_JPRB, 0.16834234E-09_JPRB, 0.16837037E-09_JPRB, 0.16839503E-09_JPRB, 0.16841409E-09_JPRB, 0.16842409E-09_JPRB, &
  & 0.16842056E-09_JPRB, 0.16839836E-09_JPRB, 0.16835447E-09_JPRB, 0.16829139E-09_JPRB, 0.16821765E-09_JPRB, 0.16814380E-09_JPRB, &
  & 0.16807955E-09_JPRB, 0.16803252E-09_JPRB, 0.16800862E-09_JPRB, 0.16801152E-09_JPRB, 0.16804294E-09_JPRB, 0.16809895E-09_JPRB, &
  & 0.16816874E-09_JPRB, 0.16824264E-09_JPRB, 0.16831271E-09_JPRB, 0.16837863E-09_JPRB, 0.16843775E-09_JPRB, 0.16849086E-09_JPRB, &
  & 0.16853305E-09_JPRB, 0.16856386E-09_JPRB, 0.16858409E-09_JPRB, 0.16859558E-09_JPRB, 0.16860313E-09_JPRB, 0.16860782E-09_JPRB, &
  & 0.16861122E-09_JPRB, 0.16861357E-09_JPRB, 0.16861483E-09_JPRB, 0.16861548E-09_JPRB, 0.16861547E-09_JPRB, 0.16861509E-09_JPRB, &
  & 0.16861429E-09_JPRB, 0.16861296E-09_JPRB, 0.16861007E-09_JPRB, 0.16860215E-09_JPRB /)

RGHG8(:,56, 5) = (/ &
  & 0.16824758E-09_JPRB, 0.16839255E-09_JPRB, 0.16846655E-09_JPRB, 0.16853832E-09_JPRB, 0.16859665E-09_JPRB, 0.16862844E-09_JPRB, &
  & 0.16864106E-09_JPRB, 0.16864585E-09_JPRB, 0.16864732E-09_JPRB, 0.16864700E-09_JPRB, 0.16864479E-09_JPRB, 0.16864006E-09_JPRB, &
  & 0.16862940E-09_JPRB, 0.16860977E-09_JPRB, 0.16857787E-09_JPRB, 0.16853652E-09_JPRB, 0.16849144E-09_JPRB, 0.16844579E-09_JPRB, &
  & 0.16840393E-09_JPRB, 0.16836485E-09_JPRB, 0.16833138E-09_JPRB, 0.16830676E-09_JPRB, 0.16829679E-09_JPRB, 0.16830634E-09_JPRB, &
  & 0.16833013E-09_JPRB, 0.16835922E-09_JPRB, 0.16838830E-09_JPRB, 0.16841452E-09_JPRB, 0.16843511E-09_JPRB, 0.16844634E-09_JPRB, &
  & 0.16844355E-09_JPRB, 0.16842157E-09_JPRB, 0.16837730E-09_JPRB, 0.16831284E-09_JPRB, 0.16823687E-09_JPRB, 0.16816035E-09_JPRB, &
  & 0.16809364E-09_JPRB, 0.16804522E-09_JPRB, 0.16802129E-09_JPRB, 0.16802544E-09_JPRB, 0.16805864E-09_JPRB, 0.16811653E-09_JPRB, &
  & 0.16818875E-09_JPRB, 0.16826505E-09_JPRB, 0.16833958E-09_JPRB, 0.16840881E-09_JPRB, 0.16847315E-09_JPRB, 0.16852933E-09_JPRB, &
  & 0.16857563E-09_JPRB, 0.16860885E-09_JPRB, 0.16862954E-09_JPRB, 0.16864263E-09_JPRB, 0.16865015E-09_JPRB, 0.16865545E-09_JPRB, &
  & 0.16865939E-09_JPRB, 0.16866253E-09_JPRB, 0.16866501E-09_JPRB, 0.16866733E-09_JPRB, 0.16866900E-09_JPRB, 0.16867027E-09_JPRB, &
  & 0.16867102E-09_JPRB, 0.16867152E-09_JPRB, 0.16867148E-09_JPRB, 0.16867036E-09_JPRB /)

RGHG8(:,57, 5) = (/ &
  & 0.16844998E-09_JPRB, 0.16855488E-09_JPRB, 0.16861079E-09_JPRB, 0.16865752E-09_JPRB, 0.16869270E-09_JPRB, 0.16871225E-09_JPRB, &
  & 0.16871939E-09_JPRB, 0.16872154E-09_JPRB, 0.16872161E-09_JPRB, 0.16872043E-09_JPRB, 0.16871791E-09_JPRB, 0.16871265E-09_JPRB, &
  & 0.16870280E-09_JPRB, 0.16868362E-09_JPRB, 0.16865195E-09_JPRB, 0.16860895E-09_JPRB, 0.16855860E-09_JPRB, 0.16850674E-09_JPRB, &
  & 0.16845550E-09_JPRB, 0.16840863E-09_JPRB, 0.16836732E-09_JPRB, 0.16833543E-09_JPRB, 0.16832113E-09_JPRB, 0.16832755E-09_JPRB, &
  & 0.16834947E-09_JPRB, 0.16837845E-09_JPRB, 0.16840843E-09_JPRB, 0.16843620E-09_JPRB, 0.16845828E-09_JPRB, 0.16847060E-09_JPRB, &
  & 0.16846839E-09_JPRB, 0.16844635E-09_JPRB, 0.16840140E-09_JPRB, 0.16833562E-09_JPRB, 0.16825752E-09_JPRB, 0.16817861E-09_JPRB, &
  & 0.16810978E-09_JPRB, 0.16806004E-09_JPRB, 0.16803622E-09_JPRB, 0.16804144E-09_JPRB, 0.16807612E-09_JPRB, 0.16813526E-09_JPRB, &
  & 0.16820907E-09_JPRB, 0.16828783E-09_JPRB, 0.16836506E-09_JPRB, 0.16843774E-09_JPRB, 0.16850500E-09_JPRB, 0.16856497E-09_JPRB, &
  & 0.16861401E-09_JPRB, 0.16864923E-09_JPRB, 0.16867169E-09_JPRB, 0.16868415E-09_JPRB, 0.16869203E-09_JPRB, 0.16869711E-09_JPRB, &
  & 0.16870094E-09_JPRB, 0.16870411E-09_JPRB, 0.16870672E-09_JPRB, 0.16870930E-09_JPRB, 0.16871159E-09_JPRB, 0.16871322E-09_JPRB, &
  & 0.16871443E-09_JPRB, 0.16871508E-09_JPRB, 0.16871497E-09_JPRB, 0.16871254E-09_JPRB /)

RGHG8(:,58, 5) = (/ &
  & 0.16862807E-09_JPRB, 0.16868934E-09_JPRB, 0.16872273E-09_JPRB, 0.16874993E-09_JPRB, 0.16877330E-09_JPRB, 0.16878451E-09_JPRB, &
  & 0.16878848E-09_JPRB, 0.16878926E-09_JPRB, 0.16878869E-09_JPRB, 0.16878729E-09_JPRB, 0.16878463E-09_JPRB, 0.16877996E-09_JPRB, &
  & 0.16877075E-09_JPRB, 0.16875330E-09_JPRB, 0.16872345E-09_JPRB, 0.16867970E-09_JPRB, 0.16862574E-09_JPRB, 0.16856586E-09_JPRB, &
  & 0.16850668E-09_JPRB, 0.16845045E-09_JPRB, 0.16840138E-09_JPRB, 0.16836474E-09_JPRB, 0.16834689E-09_JPRB, 0.16835121E-09_JPRB, &
  & 0.16837191E-09_JPRB, 0.16840074E-09_JPRB, 0.16843175E-09_JPRB, 0.16846088E-09_JPRB, 0.16848432E-09_JPRB, 0.16849748E-09_JPRB, &
  & 0.16849569E-09_JPRB, 0.16847337E-09_JPRB, 0.16842759E-09_JPRB, 0.16836016E-09_JPRB, 0.16828015E-09_JPRB, 0.16819923E-09_JPRB, &
  & 0.16812871E-09_JPRB, 0.16807809E-09_JPRB, 0.16805432E-09_JPRB, 0.16806022E-09_JPRB, 0.16809573E-09_JPRB, 0.16815598E-09_JPRB, &
  & 0.16823096E-09_JPRB, 0.16831153E-09_JPRB, 0.16839083E-09_JPRB, 0.16846592E-09_JPRB, 0.16853526E-09_JPRB, 0.16859734E-09_JPRB, &
  & 0.16864950E-09_JPRB, 0.16868726E-09_JPRB, 0.16871013E-09_JPRB, 0.16872342E-09_JPRB, 0.16873081E-09_JPRB, 0.16873564E-09_JPRB, &
  & 0.16873916E-09_JPRB, 0.16874190E-09_JPRB, 0.16874412E-09_JPRB, 0.16874657E-09_JPRB, 0.16874871E-09_JPRB, 0.16875043E-09_JPRB, &
  & 0.16875162E-09_JPRB, 0.16875235E-09_JPRB, 0.16875226E-09_JPRB, 0.16874993E-09_JPRB /)

RGHG8(:,59, 5) = (/ &
  & 0.16874524E-09_JPRB, 0.16878862E-09_JPRB, 0.16881056E-09_JPRB, 0.16882930E-09_JPRB, 0.16884258E-09_JPRB, 0.16885010E-09_JPRB, &
  & 0.16885232E-09_JPRB, 0.16885250E-09_JPRB, 0.16885179E-09_JPRB, 0.16885038E-09_JPRB, 0.16884810E-09_JPRB, 0.16884388E-09_JPRB, &
  & 0.16883586E-09_JPRB, 0.16882046E-09_JPRB, 0.16879238E-09_JPRB, 0.16874935E-09_JPRB, 0.16869134E-09_JPRB, 0.16862506E-09_JPRB, &
  & 0.16855610E-09_JPRB, 0.16849196E-09_JPRB, 0.16843636E-09_JPRB, 0.16839531E-09_JPRB, 0.16837548E-09_JPRB, 0.16837826E-09_JPRB, &
  & 0.16839807E-09_JPRB, 0.16842704E-09_JPRB, 0.16845894E-09_JPRB, 0.16848939E-09_JPRB, 0.16851397E-09_JPRB, 0.16852784E-09_JPRB, &
  & 0.16852623E-09_JPRB, 0.16850349E-09_JPRB, 0.16845653E-09_JPRB, 0.16838740E-09_JPRB, 0.16830540E-09_JPRB, 0.16822299E-09_JPRB, &
  & 0.16815133E-09_JPRB, 0.16810009E-09_JPRB, 0.16807637E-09_JPRB, 0.16808252E-09_JPRB, 0.16811842E-09_JPRB, 0.16817911E-09_JPRB, &
  & 0.16825509E-09_JPRB, 0.16833690E-09_JPRB, 0.16841789E-09_JPRB, 0.16849434E-09_JPRB, 0.16856508E-09_JPRB, 0.16862858E-09_JPRB, &
  & 0.16868237E-09_JPRB, 0.16872267E-09_JPRB, 0.16874749E-09_JPRB, 0.16876081E-09_JPRB, 0.16876826E-09_JPRB, 0.16877277E-09_JPRB, &
  & 0.16877577E-09_JPRB, 0.16877796E-09_JPRB, 0.16877952E-09_JPRB, 0.16878143E-09_JPRB, 0.16878331E-09_JPRB, 0.16878479E-09_JPRB, &
  & 0.16878583E-09_JPRB, 0.16878628E-09_JPRB, 0.16878575E-09_JPRB, 0.16878250E-09_JPRB /)

RGHG8(:,60, 5) = (/ &
  & 0.16884530E-09_JPRB, 0.16887217E-09_JPRB, 0.16888635E-09_JPRB, 0.16889759E-09_JPRB, 0.16890706E-09_JPRB, 0.16891177E-09_JPRB, &
  & 0.16891333E-09_JPRB, 0.16891338E-09_JPRB, 0.16891280E-09_JPRB, 0.16891170E-09_JPRB, 0.16890975E-09_JPRB, 0.16890625E-09_JPRB, &
  & 0.16889931E-09_JPRB, 0.16888535E-09_JPRB, 0.16885963E-09_JPRB, 0.16881668E-09_JPRB, 0.16875625E-09_JPRB, 0.16868235E-09_JPRB, &
  & 0.16860624E-09_JPRB, 0.16853428E-09_JPRB, 0.16847351E-09_JPRB, 0.16842938E-09_JPRB, 0.16840764E-09_JPRB, 0.16840919E-09_JPRB, &
  & 0.16842845E-09_JPRB, 0.16845772E-09_JPRB, 0.16849069E-09_JPRB, 0.16852232E-09_JPRB, 0.16854784E-09_JPRB, 0.16856221E-09_JPRB, &
  & 0.16856067E-09_JPRB, 0.16853731E-09_JPRB, 0.16848907E-09_JPRB, 0.16841811E-09_JPRB, 0.16833426E-09_JPRB, 0.16825079E-09_JPRB, &
  & 0.16817836E-09_JPRB, 0.16812711E-09_JPRB, 0.16810321E-09_JPRB, 0.16810933E-09_JPRB, 0.16814504E-09_JPRB, 0.16820574E-09_JPRB, &
  & 0.16828193E-09_JPRB, 0.16836463E-09_JPRB, 0.16844663E-09_JPRB, 0.16852419E-09_JPRB, 0.16859565E-09_JPRB, 0.16865956E-09_JPRB, &
  & 0.16871485E-09_JPRB, 0.16875679E-09_JPRB, 0.16878354E-09_JPRB, 0.16879784E-09_JPRB, 0.16880539E-09_JPRB, 0.16880952E-09_JPRB, &
  & 0.16881202E-09_JPRB, 0.16881337E-09_JPRB, 0.16881394E-09_JPRB, 0.16881520E-09_JPRB, 0.16881667E-09_JPRB, 0.16881792E-09_JPRB, &
  & 0.16881871E-09_JPRB, 0.16881889E-09_JPRB, 0.16881796E-09_JPRB, 0.16881352E-09_JPRB /)

RGHG8(:,61, 5) = (/ &
  & 0.16892018E-09_JPRB, 0.16894146E-09_JPRB, 0.16895216E-09_JPRB, 0.16896079E-09_JPRB, 0.16896740E-09_JPRB, 0.16897136E-09_JPRB, &
  & 0.16897277E-09_JPRB, 0.16897303E-09_JPRB, 0.16897277E-09_JPRB, 0.16897202E-09_JPRB, 0.16897059E-09_JPRB, 0.16896770E-09_JPRB, &
  & 0.16896176E-09_JPRB, 0.16894935E-09_JPRB, 0.16892475E-09_JPRB, 0.16888231E-09_JPRB, 0.16881860E-09_JPRB, 0.16873990E-09_JPRB, &
  & 0.16865671E-09_JPRB, 0.16857953E-09_JPRB, 0.16851437E-09_JPRB, 0.16846752E-09_JPRB, 0.16844418E-09_JPRB, 0.16844469E-09_JPRB, &
  & 0.16846366E-09_JPRB, 0.16849348E-09_JPRB, 0.16852748E-09_JPRB, 0.16856021E-09_JPRB, 0.16858655E-09_JPRB, 0.16860137E-09_JPRB, &
  & 0.16859966E-09_JPRB, 0.16857567E-09_JPRB, 0.16852610E-09_JPRB, 0.16845346E-09_JPRB, 0.16836801E-09_JPRB, 0.16828386E-09_JPRB, &
  & 0.16821133E-09_JPRB, 0.16816008E-09_JPRB, 0.16813607E-09_JPRB, 0.16814175E-09_JPRB, 0.16817675E-09_JPRB, 0.16823666E-09_JPRB, &
  & 0.16831263E-09_JPRB, 0.16839542E-09_JPRB, 0.16847801E-09_JPRB, 0.16855613E-09_JPRB, 0.16862796E-09_JPRB, 0.16869225E-09_JPRB, &
  & 0.16874740E-09_JPRB, 0.16879116E-09_JPRB, 0.16881957E-09_JPRB, 0.16883533E-09_JPRB, 0.16884316E-09_JPRB, 0.16884710E-09_JPRB, &
  & 0.16884882E-09_JPRB, 0.16884910E-09_JPRB, 0.16884830E-09_JPRB, 0.16884874E-09_JPRB, 0.16884985E-09_JPRB, 0.16885091E-09_JPRB, &
  & 0.16885149E-09_JPRB, 0.16885124E-09_JPRB, 0.16884938E-09_JPRB, 0.16884304E-09_JPRB /)

RGHG8(:,62, 5) = (/ &
  & 0.16898805E-09_JPRB, 0.16900512E-09_JPRB, 0.16901361E-09_JPRB, 0.16902037E-09_JPRB, 0.16902617E-09_JPRB, 0.16902983E-09_JPRB, &
  & 0.16903164E-09_JPRB, 0.16903233E-09_JPRB, 0.16903251E-09_JPRB, 0.16903229E-09_JPRB, 0.16903146E-09_JPRB, 0.16902939E-09_JPRB, &
  & 0.16902436E-09_JPRB, 0.16901282E-09_JPRB, 0.16898896E-09_JPRB, 0.16894584E-09_JPRB, 0.16887987E-09_JPRB, 0.16879700E-09_JPRB, &
  & 0.16870975E-09_JPRB, 0.16862818E-09_JPRB, 0.16855967E-09_JPRB, 0.16851057E-09_JPRB, 0.16848581E-09_JPRB, 0.16848557E-09_JPRB, &
  & 0.16850447E-09_JPRB, 0.16853501E-09_JPRB, 0.16857005E-09_JPRB, 0.16860387E-09_JPRB, 0.16863098E-09_JPRB, 0.16864621E-09_JPRB, &
  & 0.16864432E-09_JPRB, 0.16861965E-09_JPRB, 0.16856889E-09_JPRB, 0.16849475E-09_JPRB, 0.16840823E-09_JPRB, 0.16832363E-09_JPRB, &
  & 0.16825139E-09_JPRB, 0.16820031E-09_JPRB, 0.16817604E-09_JPRB, 0.16818096E-09_JPRB, 0.16821472E-09_JPRB, 0.16827334E-09_JPRB, &
  & 0.16834815E-09_JPRB, 0.16843046E-09_JPRB, 0.16851293E-09_JPRB, 0.16859114E-09_JPRB, 0.16866296E-09_JPRB, 0.16872709E-09_JPRB, &
  & 0.16878243E-09_JPRB, 0.16882629E-09_JPRB, 0.16885662E-09_JPRB, 0.16887387E-09_JPRB, 0.16888249E-09_JPRB, 0.16888616E-09_JPRB, &
  & 0.16888699E-09_JPRB, 0.16888571E-09_JPRB, 0.16888300E-09_JPRB, 0.16888262E-09_JPRB, 0.16888350E-09_JPRB, 0.16888453E-09_JPRB, &
  & 0.16888496E-09_JPRB, 0.16888418E-09_JPRB, 0.16888134E-09_JPRB, 0.16887142E-09_JPRB /)

RGHG8(:,63, 5) = (/ &
  & 0.16904984E-09_JPRB, 0.16906448E-09_JPRB, 0.16907203E-09_JPRB, 0.16907820E-09_JPRB, 0.16908364E-09_JPRB, 0.16908772E-09_JPRB, &
  & 0.16909005E-09_JPRB, 0.16909144E-09_JPRB, 0.16909221E-09_JPRB, 0.16909268E-09_JPRB, 0.16909266E-09_JPRB, 0.16909149E-09_JPRB, &
  & 0.16908749E-09_JPRB, 0.16907663E-09_JPRB, 0.16905254E-09_JPRB, 0.16900827E-09_JPRB, 0.16894053E-09_JPRB, 0.16885550E-09_JPRB, &
  & 0.16876564E-09_JPRB, 0.16868108E-09_JPRB, 0.16860988E-09_JPRB, 0.16855908E-09_JPRB, 0.16853331E-09_JPRB, 0.16853269E-09_JPRB, &
  & 0.16855181E-09_JPRB, 0.16858318E-09_JPRB, 0.16861937E-09_JPRB, 0.16865410E-09_JPRB, 0.16868189E-09_JPRB, 0.16869739E-09_JPRB, &
  & 0.16869546E-09_JPRB, 0.16867027E-09_JPRB, 0.16861851E-09_JPRB, 0.16854343E-09_JPRB, 0.16845642E-09_JPRB, 0.16837184E-09_JPRB, &
  & 0.16830019E-09_JPRB, 0.16824926E-09_JPRB, 0.16822463E-09_JPRB, 0.16822843E-09_JPRB, 0.16826046E-09_JPRB, 0.16831701E-09_JPRB, &
  & 0.16839004E-09_JPRB, 0.16847089E-09_JPRB, 0.16855259E-09_JPRB, 0.16863018E-09_JPRB, 0.16870151E-09_JPRB, 0.16876525E-09_JPRB, &
  & 0.16882024E-09_JPRB, 0.16886442E-09_JPRB, 0.16889552E-09_JPRB, 0.16891427E-09_JPRB, 0.16892385E-09_JPRB, 0.16892730E-09_JPRB, &
  & 0.16892711E-09_JPRB, 0.16892408E-09_JPRB, 0.16891881E-09_JPRB, 0.16891771E-09_JPRB, 0.16891866E-09_JPRB, 0.16891991E-09_JPRB, &
  & 0.16892028E-09_JPRB, 0.16891889E-09_JPRB, 0.16891412E-09_JPRB, 0.16889995E-09_JPRB /)

RGHG8(:,64, 5) = (/ &
  & 0.16910653E-09_JPRB, 0.16912062E-09_JPRB, 0.16912788E-09_JPRB, 0.16913398E-09_JPRB, 0.16913976E-09_JPRB, 0.16914442E-09_JPRB, &
  & 0.16914772E-09_JPRB, 0.16914986E-09_JPRB, 0.16915158E-09_JPRB, 0.16915294E-09_JPRB, 0.16915400E-09_JPRB, 0.16915402E-09_JPRB, &
  & 0.16915110E-09_JPRB, 0.16914045E-09_JPRB, 0.16911582E-09_JPRB, 0.16906990E-09_JPRB, 0.16900145E-09_JPRB, 0.16891583E-09_JPRB, &
  & 0.16882476E-09_JPRB, 0.16873813E-09_JPRB, 0.16866528E-09_JPRB, 0.16861330E-09_JPRB, 0.16858723E-09_JPRB, 0.16858659E-09_JPRB, &
  & 0.16860614E-09_JPRB, 0.16863844E-09_JPRB, 0.16867556E-09_JPRB, 0.16871107E-09_JPRB, 0.16873923E-09_JPRB, 0.16875483E-09_JPRB, &
  & 0.16875282E-09_JPRB, 0.16872739E-09_JPRB, 0.16867523E-09_JPRB, 0.16859977E-09_JPRB, 0.16851309E-09_JPRB, 0.16842927E-09_JPRB, &
  & 0.16835851E-09_JPRB, 0.16830784E-09_JPRB, 0.16828264E-09_JPRB, 0.16828509E-09_JPRB, 0.16831493E-09_JPRB, 0.16836881E-09_JPRB, &
  & 0.16843908E-09_JPRB, 0.16851766E-09_JPRB, 0.16859766E-09_JPRB, 0.16867403E-09_JPRB, 0.16874417E-09_JPRB, 0.16880713E-09_JPRB, &
  & 0.16886165E-09_JPRB, 0.16890571E-09_JPRB, 0.16893732E-09_JPRB, 0.16895710E-09_JPRB, 0.16896734E-09_JPRB, 0.16897092E-09_JPRB, &
  & 0.16896977E-09_JPRB, 0.16896452E-09_JPRB, 0.16895668E-09_JPRB, 0.16895481E-09_JPRB, 0.16895599E-09_JPRB, 0.16895763E-09_JPRB, &
  & 0.16895803E-09_JPRB, 0.16895579E-09_JPRB, 0.16894922E-09_JPRB, 0.16892793E-09_JPRB /)

RGHG8(:,65, 5) = (/ &
  & 0.16915849E-09_JPRB, 0.16917352E-09_JPRB, 0.16918136E-09_JPRB, 0.16918802E-09_JPRB, 0.16919446E-09_JPRB, 0.16920015E-09_JPRB, &
  & 0.16920436E-09_JPRB, 0.16920770E-09_JPRB, 0.16921031E-09_JPRB, 0.16921295E-09_JPRB, 0.16921531E-09_JPRB, 0.16921688E-09_JPRB, &
  & 0.16921506E-09_JPRB, 0.16920447E-09_JPRB, 0.16917820E-09_JPRB, 0.16913219E-09_JPRB, 0.16906329E-09_JPRB, 0.16897839E-09_JPRB, &
  & 0.16888699E-09_JPRB, 0.16879967E-09_JPRB, 0.16872582E-09_JPRB, 0.16867376E-09_JPRB, 0.16864778E-09_JPRB, 0.16864754E-09_JPRB, &
  & 0.16866777E-09_JPRB, 0.16870072E-09_JPRB, 0.16873851E-09_JPRB, 0.16877416E-09_JPRB, 0.16880221E-09_JPRB, 0.16881756E-09_JPRB, &
  & 0.16881538E-09_JPRB, 0.16879004E-09_JPRB, 0.16873812E-09_JPRB, 0.16866335E-09_JPRB, 0.16857776E-09_JPRB, 0.16849586E-09_JPRB, &
  & 0.16842637E-09_JPRB, 0.16837629E-09_JPRB, 0.16835058E-09_JPRB, 0.16835137E-09_JPRB, 0.16837864E-09_JPRB, 0.16842926E-09_JPRB, &
  & 0.16849613E-09_JPRB, 0.16857166E-09_JPRB, 0.16864911E-09_JPRB, 0.16872333E-09_JPRB, 0.16879173E-09_JPRB, 0.16885324E-09_JPRB, &
  & 0.16890701E-09_JPRB, 0.16895076E-09_JPRB, 0.16898254E-09_JPRB, 0.16900277E-09_JPRB, 0.16901359E-09_JPRB, 0.16901702E-09_JPRB, &
  & 0.16901487E-09_JPRB, 0.16900809E-09_JPRB, 0.16899725E-09_JPRB, 0.16899486E-09_JPRB, 0.16899634E-09_JPRB, 0.16899848E-09_JPRB, &
  & 0.16899891E-09_JPRB, 0.16899591E-09_JPRB, 0.16898619E-09_JPRB, 0.16895875E-09_JPRB /)

RGHG8(:,66, 5) = (/ &
  & 0.16920723E-09_JPRB, 0.16922405E-09_JPRB, 0.16923304E-09_JPRB, 0.16924059E-09_JPRB, 0.16924800E-09_JPRB, 0.16925475E-09_JPRB, &
  & 0.16926024E-09_JPRB, 0.16926455E-09_JPRB, 0.16926860E-09_JPRB, 0.16927240E-09_JPRB, 0.16927658E-09_JPRB, 0.16927967E-09_JPRB, &
  & 0.16927870E-09_JPRB, 0.16926724E-09_JPRB, 0.16924098E-09_JPRB, 0.16919431E-09_JPRB, 0.16912695E-09_JPRB, 0.16904318E-09_JPRB, &
  & 0.16895287E-09_JPRB, 0.16886566E-09_JPRB, 0.16879226E-09_JPRB, 0.16874045E-09_JPRB, 0.16871526E-09_JPRB, 0.16871572E-09_JPRB, &
  & 0.16873637E-09_JPRB, 0.16876964E-09_JPRB, 0.16880720E-09_JPRB, 0.16884241E-09_JPRB, 0.16886964E-09_JPRB, 0.16888424E-09_JPRB, &
  & 0.16888181E-09_JPRB, 0.16885679E-09_JPRB, 0.16880590E-09_JPRB, 0.16873275E-09_JPRB, 0.16864965E-09_JPRB, 0.16857021E-09_JPRB, &
  & 0.16850314E-09_JPRB, 0.16845408E-09_JPRB, 0.16842813E-09_JPRB, 0.16842730E-09_JPRB, 0.16845175E-09_JPRB, 0.16849869E-09_JPRB, &
  & 0.16856168E-09_JPRB, 0.16863316E-09_JPRB, 0.16870733E-09_JPRB, 0.16877871E-09_JPRB, 0.16884449E-09_JPRB, 0.16890429E-09_JPRB, &
  & 0.16895672E-09_JPRB, 0.16899993E-09_JPRB, 0.16903157E-09_JPRB, 0.16905194E-09_JPRB, 0.16906289E-09_JPRB, 0.16906608E-09_JPRB, &
  & 0.16906324E-09_JPRB, 0.16905466E-09_JPRB, 0.16904179E-09_JPRB, 0.16903863E-09_JPRB, 0.16904032E-09_JPRB, 0.16904290E-09_JPRB, &
  & 0.16904345E-09_JPRB, 0.16903953E-09_JPRB, 0.16902807E-09_JPRB, 0.16899271E-09_JPRB /)

RGHG8(:,67, 5) = (/ &
  & 0.16925328E-09_JPRB, 0.16927316E-09_JPRB, 0.16928341E-09_JPRB, 0.16929234E-09_JPRB, 0.16930096E-09_JPRB, 0.16930878E-09_JPRB, &
  & 0.16931553E-09_JPRB, 0.16932121E-09_JPRB, 0.16932644E-09_JPRB, 0.16933208E-09_JPRB, 0.16933770E-09_JPRB, 0.16934207E-09_JPRB, &
  & 0.16934100E-09_JPRB, 0.16932905E-09_JPRB, 0.16930249E-09_JPRB, 0.16925747E-09_JPRB, 0.16919173E-09_JPRB, 0.16911032E-09_JPRB, &
  & 0.16902192E-09_JPRB, 0.16893648E-09_JPRB, 0.16886423E-09_JPRB, 0.16881392E-09_JPRB, 0.16878970E-09_JPRB, 0.16879075E-09_JPRB, &
  & 0.16881156E-09_JPRB, 0.16884419E-09_JPRB, 0.16888080E-09_JPRB, 0.16891460E-09_JPRB, 0.16894043E-09_JPRB, 0.16895395E-09_JPRB, &
  & 0.16895116E-09_JPRB, 0.16892682E-09_JPRB, 0.16887755E-09_JPRB, 0.16880716E-09_JPRB, 0.16872721E-09_JPRB, 0.16865158E-09_JPRB, &
  & 0.16858730E-09_JPRB, 0.16854017E-09_JPRB, 0.16851438E-09_JPRB, 0.16851222E-09_JPRB, 0.16853398E-09_JPRB, 0.16857704E-09_JPRB, &
  & 0.16863558E-09_JPRB, 0.16870251E-09_JPRB, 0.16877252E-09_JPRB, 0.16884034E-09_JPRB, 0.16890325E-09_JPRB, 0.16896046E-09_JPRB, &
  & 0.16901142E-09_JPRB, 0.16905348E-09_JPRB, 0.16908468E-09_JPRB, 0.16910488E-09_JPRB, 0.16911575E-09_JPRB, 0.16911854E-09_JPRB, &
  & 0.16911490E-09_JPRB, 0.16910515E-09_JPRB, 0.16909034E-09_JPRB, 0.16908668E-09_JPRB, 0.16908849E-09_JPRB, 0.16909142E-09_JPRB, &
  & 0.16909206E-09_JPRB, 0.16908774E-09_JPRB, 0.16907344E-09_JPRB, 0.16903237E-09_JPRB /)

RGHG8(:,68, 5) = (/ &
  & 0.16929685E-09_JPRB, 0.16932036E-09_JPRB, 0.16933321E-09_JPRB, 0.16934371E-09_JPRB, 0.16935371E-09_JPRB, 0.16936330E-09_JPRB, &
  & 0.16937082E-09_JPRB, 0.16937809E-09_JPRB, 0.16938460E-09_JPRB, 0.16939161E-09_JPRB, 0.16939863E-09_JPRB, 0.16940335E-09_JPRB, &
  & 0.16940219E-09_JPRB, 0.16939036E-09_JPRB, 0.16936474E-09_JPRB, 0.16932075E-09_JPRB, 0.16925757E-09_JPRB, 0.16917945E-09_JPRB, &
  & 0.16909439E-09_JPRB, 0.16901179E-09_JPRB, 0.16894211E-09_JPRB, 0.16889350E-09_JPRB, 0.16887054E-09_JPRB, 0.16887194E-09_JPRB, &
  & 0.16889209E-09_JPRB, 0.16892346E-09_JPRB, 0.16895813E-09_JPRB, 0.16898992E-09_JPRB, 0.16901387E-09_JPRB, 0.16902608E-09_JPRB, &
  & 0.16902300E-09_JPRB, 0.16899959E-09_JPRB, 0.16895257E-09_JPRB, 0.16888548E-09_JPRB, 0.16880999E-09_JPRB, 0.16873838E-09_JPRB, &
  & 0.16867803E-09_JPRB, 0.16863325E-09_JPRB, 0.16860825E-09_JPRB, 0.16860513E-09_JPRB, 0.16862431E-09_JPRB, 0.16866357E-09_JPRB, &
  & 0.16871746E-09_JPRB, 0.16877942E-09_JPRB, 0.16884480E-09_JPRB, 0.16890866E-09_JPRB, 0.16896774E-09_JPRB, 0.16902241E-09_JPRB, &
  & 0.16907109E-09_JPRB, 0.16911184E-09_JPRB, 0.16914208E-09_JPRB, 0.16916178E-09_JPRB, 0.16917229E-09_JPRB, 0.16917462E-09_JPRB, &
  & 0.16917032E-09_JPRB, 0.16915951E-09_JPRB, 0.16914342E-09_JPRB, 0.16913933E-09_JPRB, 0.16914126E-09_JPRB, 0.16914446E-09_JPRB, &
  & 0.16914532E-09_JPRB, 0.16914067E-09_JPRB, 0.16912544E-09_JPRB, 0.16907870E-09_JPRB /)

RGHG8(:,69, 5) = (/ &
  & 0.16933766E-09_JPRB, 0.16936789E-09_JPRB, 0.16938309E-09_JPRB, 0.16939589E-09_JPRB, 0.16940777E-09_JPRB, 0.16941785E-09_JPRB, &
  & 0.16942747E-09_JPRB, 0.16943504E-09_JPRB, 0.16944340E-09_JPRB, 0.16945116E-09_JPRB, 0.16945892E-09_JPRB, 0.16946326E-09_JPRB, &
  & 0.16946101E-09_JPRB, 0.16944858E-09_JPRB, 0.16942454E-09_JPRB, 0.16938394E-09_JPRB, 0.16932448E-09_JPRB, 0.16925050E-09_JPRB, &
  & 0.16917001E-09_JPRB, 0.16909164E-09_JPRB, 0.16902532E-09_JPRB, 0.16897915E-09_JPRB, 0.16895710E-09_JPRB, 0.16895831E-09_JPRB, &
  & 0.16897729E-09_JPRB, 0.16900654E-09_JPRB, 0.16903878E-09_JPRB, 0.16906802E-09_JPRB, 0.16908978E-09_JPRB, 0.16910061E-09_JPRB, &
  & 0.16909731E-09_JPRB, 0.16907506E-09_JPRB, 0.16903076E-09_JPRB, 0.16896785E-09_JPRB, 0.16889719E-09_JPRB, 0.16883060E-09_JPRB, &
  & 0.16877431E-09_JPRB, 0.16873253E-09_JPRB, 0.16870877E-09_JPRB, 0.16870516E-09_JPRB, 0.16872212E-09_JPRB, 0.16875767E-09_JPRB, &
  & 0.16880702E-09_JPRB, 0.16886378E-09_JPRB, 0.16892415E-09_JPRB, 0.16898348E-09_JPRB, 0.16903877E-09_JPRB, 0.16908996E-09_JPRB, &
  & 0.16913639E-09_JPRB, 0.16917515E-09_JPRB, 0.16920407E-09_JPRB, 0.16922296E-09_JPRB, 0.16923285E-09_JPRB, 0.16923464E-09_JPRB, &
  & 0.16922977E-09_JPRB, 0.16921829E-09_JPRB, 0.16920129E-09_JPRB, 0.16919709E-09_JPRB, 0.16919918E-09_JPRB, 0.16920264E-09_JPRB, &
  & 0.16920386E-09_JPRB, 0.16919928E-09_JPRB, 0.16918268E-09_JPRB, 0.16913128E-09_JPRB /)

RGHG8(:,70, 5) = (/ &
  & 0.16937803E-09_JPRB, 0.16941508E-09_JPRB, 0.16943479E-09_JPRB, 0.16944976E-09_JPRB, 0.16946293E-09_JPRB, 0.16947474E-09_JPRB, &
  & 0.16948407E-09_JPRB, 0.16949370E-09_JPRB, 0.16950205E-09_JPRB, 0.16951095E-09_JPRB, 0.16951841E-09_JPRB, 0.16952242E-09_JPRB, &
  & 0.16952081E-09_JPRB, 0.16950980E-09_JPRB, 0.16948672E-09_JPRB, 0.16944751E-09_JPRB, 0.16939213E-09_JPRB, 0.16932350E-09_JPRB, &
  & 0.16924853E-09_JPRB, 0.16917551E-09_JPRB, 0.16911336E-09_JPRB, 0.16906972E-09_JPRB, 0.16904861E-09_JPRB, 0.16904915E-09_JPRB, &
  & 0.16906622E-09_JPRB, 0.16909284E-09_JPRB, 0.16912208E-09_JPRB, 0.16914842E-09_JPRB, 0.16916790E-09_JPRB, 0.16917737E-09_JPRB, &
  & 0.16917391E-09_JPRB, 0.16915311E-09_JPRB, 0.16911197E-09_JPRB, 0.16905362E-09_JPRB, 0.16898861E-09_JPRB, 0.16892725E-09_JPRB, &
  & 0.16887562E-09_JPRB, 0.16883719E-09_JPRB, 0.16881511E-09_JPRB, 0.16881146E-09_JPRB, 0.16882654E-09_JPRB, 0.16885870E-09_JPRB, &
  & 0.16890354E-09_JPRB, 0.16895511E-09_JPRB, 0.16901024E-09_JPRB, 0.16906483E-09_JPRB, 0.16911565E-09_JPRB, 0.16916341E-09_JPRB, &
  & 0.16920683E-09_JPRB, 0.16924331E-09_JPRB, 0.16927054E-09_JPRB, 0.16928833E-09_JPRB, 0.16929745E-09_JPRB, 0.16929871E-09_JPRB, &
  & 0.16929344E-09_JPRB, 0.16928163E-09_JPRB, 0.16926441E-09_JPRB, 0.16926033E-09_JPRB, 0.16926270E-09_JPRB, 0.16926656E-09_JPRB, &
  & 0.16926827E-09_JPRB, 0.16926424E-09_JPRB, 0.16924732E-09_JPRB, 0.16919179E-09_JPRB /)

RGHG8(:,71, 5) = (/ &
  & 0.16941849E-09_JPRB, 0.16946664E-09_JPRB, 0.16948903E-09_JPRB, 0.16950642E-09_JPRB, 0.16952070E-09_JPRB, 0.16953250E-09_JPRB, &
  & 0.16954305E-09_JPRB, 0.16955246E-09_JPRB, 0.16956192E-09_JPRB, 0.16957027E-09_JPRB, 0.16957752E-09_JPRB, 0.16958060E-09_JPRB, &
  & 0.16957719E-09_JPRB, 0.16956579E-09_JPRB, 0.16954557E-09_JPRB, 0.16951097E-09_JPRB, 0.16946038E-09_JPRB, 0.16939769E-09_JPRB, &
  & 0.16932940E-09_JPRB, 0.16926230E-09_JPRB, 0.16920512E-09_JPRB, 0.16916432E-09_JPRB, 0.16914393E-09_JPRB, 0.16914342E-09_JPRB, &
  & 0.16915822E-09_JPRB, 0.16918174E-09_JPRB, 0.16920766E-09_JPRB, 0.16923096E-09_JPRB, 0.16924809E-09_JPRB, 0.16925611E-09_JPRB, &
  & 0.16925260E-09_JPRB, 0.16923350E-09_JPRB, 0.16919587E-09_JPRB, 0.16914270E-09_JPRB, 0.16908352E-09_JPRB, 0.16902807E-09_JPRB, &
  & 0.16898129E-09_JPRB, 0.16894665E-09_JPRB, 0.16892671E-09_JPRB, 0.16892328E-09_JPRB, 0.16893680E-09_JPRB, 0.16896581E-09_JPRB, &
  & 0.16900625E-09_JPRB, 0.16905274E-09_JPRB, 0.16910234E-09_JPRB, 0.16915197E-09_JPRB, 0.16919811E-09_JPRB, 0.16924187E-09_JPRB, &
  & 0.16928202E-09_JPRB, 0.16931580E-09_JPRB, 0.16934103E-09_JPRB, 0.16935750E-09_JPRB, 0.16936576E-09_JPRB, 0.16936659E-09_JPRB, &
  & 0.16936125E-09_JPRB, 0.16934959E-09_JPRB, 0.16933296E-09_JPRB, 0.16932922E-09_JPRB, 0.16933202E-09_JPRB, 0.16933638E-09_JPRB, &
  & 0.16933882E-09_JPRB, 0.16933592E-09_JPRB, 0.16932047E-09_JPRB, 0.16926757E-09_JPRB /)

RGHG8(:,72, 5) = (/ &
  & 0.16946616E-09_JPRB, 0.16952055E-09_JPRB, 0.16954813E-09_JPRB, 0.16956603E-09_JPRB, 0.16958088E-09_JPRB, 0.16959256E-09_JPRB, &
  & 0.16960315E-09_JPRB, 0.16961299E-09_JPRB, 0.16962197E-09_JPRB, 0.16963023E-09_JPRB, 0.16963647E-09_JPRB, 0.16963900E-09_JPRB, &
  & 0.16963608E-09_JPRB, 0.16962542E-09_JPRB, 0.16960627E-09_JPRB, 0.16957408E-09_JPRB, 0.16952889E-09_JPRB, 0.16947273E-09_JPRB, &
  & 0.16941142E-09_JPRB, 0.16935130E-09_JPRB, 0.16929937E-09_JPRB, 0.16926187E-09_JPRB, 0.16924230E-09_JPRB, 0.16924055E-09_JPRB, &
  & 0.16925279E-09_JPRB, 0.16927297E-09_JPRB, 0.16929537E-09_JPRB, 0.16931534E-09_JPRB, 0.16933008E-09_JPRB, 0.16933674E-09_JPRB, &
  & 0.16933323E-09_JPRB, 0.16931601E-09_JPRB, 0.16928224E-09_JPRB, 0.16923432E-09_JPRB, 0.16918161E-09_JPRB, 0.16913222E-09_JPRB, &
  & 0.16909088E-09_JPRB, 0.16906014E-09_JPRB, 0.16904271E-09_JPRB, 0.16903985E-09_JPRB, 0.16905199E-09_JPRB, 0.16907792E-09_JPRB, &
  & 0.16911418E-09_JPRB, 0.16915518E-09_JPRB, 0.16919950E-09_JPRB, 0.16924363E-09_JPRB, 0.16928489E-09_JPRB, 0.16932435E-09_JPRB, &
  & 0.16936080E-09_JPRB, 0.16939158E-09_JPRB, 0.16941455E-09_JPRB, 0.16942966E-09_JPRB, 0.16943714E-09_JPRB, 0.16943774E-09_JPRB, &
  & 0.16943265E-09_JPRB, 0.16942191E-09_JPRB, 0.16940647E-09_JPRB, 0.16940356E-09_JPRB, 0.16940677E-09_JPRB, 0.16941151E-09_JPRB, &
  & 0.16941464E-09_JPRB, 0.16941290E-09_JPRB, 0.16939937E-09_JPRB, 0.16934874E-09_JPRB /)

RGHG8(:,73, 5) = (/ &
  & 0.16951981E-09_JPRB, 0.16958328E-09_JPRB, 0.16960977E-09_JPRB, 0.16962878E-09_JPRB, 0.16964261E-09_JPRB, 0.16965424E-09_JPRB, &
  & 0.16966431E-09_JPRB, 0.16967380E-09_JPRB, 0.16968273E-09_JPRB, 0.16968964E-09_JPRB, 0.16969523E-09_JPRB, 0.16969623E-09_JPRB, &
  & 0.16969090E-09_JPRB, 0.16968062E-09_JPRB, 0.16966480E-09_JPRB, 0.16963722E-09_JPRB, 0.16959689E-09_JPRB, 0.16954758E-09_JPRB, &
  & 0.16949388E-09_JPRB, 0.16944085E-09_JPRB, 0.16939497E-09_JPRB, 0.16936105E-09_JPRB, 0.16934248E-09_JPRB, 0.16933958E-09_JPRB, &
  & 0.16934923E-09_JPRB, 0.16936580E-09_JPRB, 0.16938465E-09_JPRB, 0.16940134E-09_JPRB, 0.16941361E-09_JPRB, 0.16941883E-09_JPRB, &
  & 0.16941540E-09_JPRB, 0.16940020E-09_JPRB, 0.16937055E-09_JPRB, 0.16932844E-09_JPRB, 0.16928224E-09_JPRB, 0.16923937E-09_JPRB, &
  & 0.16920346E-09_JPRB, 0.16917706E-09_JPRB, 0.16916220E-09_JPRB, 0.16915999E-09_JPRB, 0.16917090E-09_JPRB, 0.16919374E-09_JPRB, &
  & 0.16922554E-09_JPRB, 0.16926145E-09_JPRB, 0.16929982E-09_JPRB, 0.16933867E-09_JPRB, 0.16937469E-09_JPRB, 0.16940954E-09_JPRB, &
  & 0.16944206E-09_JPRB, 0.16946938E-09_JPRB, 0.16949010E-09_JPRB, 0.16950376E-09_JPRB, 0.16951050E-09_JPRB, 0.16951122E-09_JPRB, &
  & 0.16950681E-09_JPRB, 0.16949714E-09_JPRB, 0.16948402E-09_JPRB, 0.16948187E-09_JPRB, 0.16948529E-09_JPRB, 0.16949042E-09_JPRB, &
  & 0.16949392E-09_JPRB, 0.16949300E-09_JPRB, 0.16948060E-09_JPRB, 0.16943325E-09_JPRB /)

RGHG8(:,74, 5) = (/ &
  & 0.16958221E-09_JPRB, 0.16964541E-09_JPRB, 0.16967464E-09_JPRB, 0.16969143E-09_JPRB, 0.16970497E-09_JPRB, 0.16971521E-09_JPRB, &
  & 0.16972503E-09_JPRB, 0.16973395E-09_JPRB, 0.16974148E-09_JPRB, 0.16974835E-09_JPRB, 0.16975232E-09_JPRB, 0.16975316E-09_JPRB, &
  & 0.16974917E-09_JPRB, 0.16973994E-09_JPRB, 0.16972400E-09_JPRB, 0.16969888E-09_JPRB, 0.16966427E-09_JPRB, 0.16962184E-09_JPRB, &
  & 0.16957566E-09_JPRB, 0.16953036E-09_JPRB, 0.16949063E-09_JPRB, 0.16946070E-09_JPRB, 0.16944350E-09_JPRB, 0.16943971E-09_JPRB, &
  & 0.16944693E-09_JPRB, 0.16945995E-09_JPRB, 0.16947529E-09_JPRB, 0.16948852E-09_JPRB, 0.16949842E-09_JPRB, 0.16950230E-09_JPRB, &
  & 0.16949904E-09_JPRB, 0.16948590E-09_JPRB, 0.16946049E-09_JPRB, 0.16942422E-09_JPRB, 0.16938501E-09_JPRB, 0.16934866E-09_JPRB, &
  & 0.16931860E-09_JPRB, 0.16929654E-09_JPRB, 0.16928441E-09_JPRB, 0.16928285E-09_JPRB, 0.16929241E-09_JPRB, 0.16931206E-09_JPRB, &
  & 0.16933958E-09_JPRB, 0.16936988E-09_JPRB, 0.16940273E-09_JPRB, 0.16943585E-09_JPRB, 0.16946659E-09_JPRB, 0.16949665E-09_JPRB, &
  & 0.16952471E-09_JPRB, 0.16954858E-09_JPRB, 0.16956662E-09_JPRB, 0.16957900E-09_JPRB, 0.16958501E-09_JPRB, 0.16958598E-09_JPRB, &
  & 0.16958251E-09_JPRB, 0.16957465E-09_JPRB, 0.16956324E-09_JPRB, 0.16956221E-09_JPRB, 0.16956607E-09_JPRB, 0.16957093E-09_JPRB, &
  & 0.16957465E-09_JPRB, 0.16957423E-09_JPRB, 0.16956320E-09_JPRB, 0.16951757E-09_JPRB /)

RGHG8(:,75, 5) = (/ &
  & 0.16964476E-09_JPRB, 0.16971123E-09_JPRB, 0.16973736E-09_JPRB, 0.16975334E-09_JPRB, 0.16976487E-09_JPRB, 0.16977436E-09_JPRB, &
  & 0.16978299E-09_JPRB, 0.16979076E-09_JPRB, 0.16979802E-09_JPRB, 0.16980280E-09_JPRB, 0.16980618E-09_JPRB, 0.16980503E-09_JPRB, &
  & 0.16979736E-09_JPRB, 0.16978778E-09_JPRB, 0.16977887E-09_JPRB, 0.16975898E-09_JPRB, 0.16973008E-09_JPRB, 0.16969481E-09_JPRB, &
  & 0.16965655E-09_JPRB, 0.16961890E-09_JPRB, 0.16958564E-09_JPRB, 0.16956000E-09_JPRB, 0.16954456E-09_JPRB, 0.16954040E-09_JPRB, &
  & 0.16954549E-09_JPRB, 0.16955506E-09_JPRB, 0.16956711E-09_JPRB, 0.16957698E-09_JPRB, 0.16958451E-09_JPRB, 0.16958709E-09_JPRB, &
  & 0.16958401E-09_JPRB, 0.16957306E-09_JPRB, 0.16955219E-09_JPRB, 0.16952210E-09_JPRB, 0.16948988E-09_JPRB, 0.16946038E-09_JPRB, &
  & 0.16943595E-09_JPRB, 0.16941831E-09_JPRB, 0.16940890E-09_JPRB, 0.16940797E-09_JPRB, 0.16941608E-09_JPRB, 0.16943243E-09_JPRB, &
  & 0.16945530E-09_JPRB, 0.16948032E-09_JPRB, 0.16950731E-09_JPRB, 0.16953483E-09_JPRB, 0.16956034E-09_JPRB, 0.16958505E-09_JPRB, &
  & 0.16960876E-09_JPRB, 0.16962863E-09_JPRB, 0.16964419E-09_JPRB, 0.16965493E-09_JPRB, 0.16966023E-09_JPRB, 0.16966149E-09_JPRB, &
  & 0.16965902E-09_JPRB, 0.16965263E-09_JPRB, 0.16964347E-09_JPRB, 0.16964335E-09_JPRB, 0.16964703E-09_JPRB, 0.16965201E-09_JPRB, &
  & 0.16965553E-09_JPRB, 0.16965544E-09_JPRB, 0.16964490E-09_JPRB, 0.16960185E-09_JPRB /)

RGHG8(:,76, 5) = (/ &
  & 0.16971247E-09_JPRB, 0.16977411E-09_JPRB, 0.16979891E-09_JPRB, 0.16981180E-09_JPRB, 0.16982182E-09_JPRB, 0.16982932E-09_JPRB, &
  & 0.16983698E-09_JPRB, 0.16984367E-09_JPRB, 0.16984902E-09_JPRB, 0.16985360E-09_JPRB, 0.16985566E-09_JPRB, 0.16985510E-09_JPRB, &
  & 0.16984990E-09_JPRB, 0.16984396E-09_JPRB, 0.16983298E-09_JPRB, 0.16981659E-09_JPRB, 0.16979401E-09_JPRB, 0.16976609E-09_JPRB, &
  & 0.16973559E-09_JPRB, 0.16970590E-09_JPRB, 0.16967931E-09_JPRB, 0.16965830E-09_JPRB, 0.16964527E-09_JPRB, 0.16964122E-09_JPRB, &
  & 0.16964463E-09_JPRB, 0.16965102E-09_JPRB, 0.16965998E-09_JPRB, 0.16966659E-09_JPRB, 0.16967197E-09_JPRB, 0.16967348E-09_JPRB, &
  & 0.16967079E-09_JPRB, 0.16966215E-09_JPRB, 0.16964581E-09_JPRB, 0.16962183E-09_JPRB, 0.16959681E-09_JPRB, 0.16957416E-09_JPRB, &
  & 0.16955559E-09_JPRB, 0.16954221E-09_JPRB, 0.16953548E-09_JPRB, 0.16953504E-09_JPRB, 0.16954164E-09_JPRB, 0.16955445E-09_JPRB, &
  & 0.16957283E-09_JPRB, 0.16959233E-09_JPRB, 0.16961352E-09_JPRB, 0.16963561E-09_JPRB, 0.16965554E-09_JPRB, 0.16967504E-09_JPRB, &
  & 0.16969386E-09_JPRB, 0.16970975E-09_JPRB, 0.16972239E-09_JPRB, 0.16973159E-09_JPRB, 0.16973578E-09_JPRB, 0.16973732E-09_JPRB, &
  & 0.16973581E-09_JPRB, 0.16973122E-09_JPRB, 0.16972372E-09_JPRB, 0.16972437E-09_JPRB, 0.16972808E-09_JPRB, 0.16973226E-09_JPRB, &
  & 0.16973564E-09_JPRB, 0.16973573E-09_JPRB, 0.16972583E-09_JPRB, 0.16968435E-09_JPRB /)

RGHG8(:,77, 5) = (/ &
  & 0.16978040E-09_JPRB, 0.16983558E-09_JPRB, 0.16985660E-09_JPRB, 0.16986650E-09_JPRB, 0.16987400E-09_JPRB, 0.16987967E-09_JPRB, &
  & 0.16988563E-09_JPRB, 0.16989057E-09_JPRB, 0.16989500E-09_JPRB, 0.16989757E-09_JPRB, 0.16989858E-09_JPRB, 0.16989626E-09_JPRB, &
  & 0.16988780E-09_JPRB, 0.16988212E-09_JPRB, 0.16988055E-09_JPRB, 0.16987008E-09_JPRB, 0.16985412E-09_JPRB, 0.16983365E-09_JPRB, &
  & 0.16981112E-09_JPRB, 0.16978942E-09_JPRB, 0.16976973E-09_JPRB, 0.16975393E-09_JPRB, 0.16974390E-09_JPRB, 0.16974074E-09_JPRB, &
  & 0.16974305E-09_JPRB, 0.16974687E-09_JPRB, 0.16975311E-09_JPRB, 0.16975699E-09_JPRB, 0.16976044E-09_JPRB, 0.16976101E-09_JPRB, &
  & 0.16975882E-09_JPRB, 0.16975249E-09_JPRB, 0.16974103E-09_JPRB, 0.16972349E-09_JPRB, 0.16970572E-09_JPRB, 0.16968987E-09_JPRB, &
  & 0.16967676E-09_JPRB, 0.16966739E-09_JPRB, 0.16966313E-09_JPRB, 0.16966308E-09_JPRB, 0.16966800E-09_JPRB, 0.16967729E-09_JPRB, &
  & 0.16969096E-09_JPRB, 0.16970496E-09_JPRB, 0.16972042E-09_JPRB, 0.16973699E-09_JPRB, 0.16975173E-09_JPRB, 0.16976556E-09_JPRB, &
  & 0.16977958E-09_JPRB, 0.16979104E-09_JPRB, 0.16980069E-09_JPRB, 0.16980806E-09_JPRB, 0.16981097E-09_JPRB, 0.16981257E-09_JPRB, &
  & 0.16981186E-09_JPRB, 0.16980893E-09_JPRB, 0.16980356E-09_JPRB, 0.16980457E-09_JPRB, 0.16980732E-09_JPRB, 0.16981082E-09_JPRB, &
  & 0.16981351E-09_JPRB, 0.16981366E-09_JPRB, 0.16980425E-09_JPRB, 0.16976590E-09_JPRB /)

RGHG8(:,78, 5) = (/ &
  & 0.16984900E-09_JPRB, 0.16989125E-09_JPRB, 0.16990694E-09_JPRB, 0.16991336E-09_JPRB, 0.16991861E-09_JPRB, 0.16992184E-09_JPRB, &
  & 0.16992625E-09_JPRB, 0.16992940E-09_JPRB, 0.16993210E-09_JPRB, 0.16993379E-09_JPRB, 0.16993421E-09_JPRB, 0.16993250E-09_JPRB, &
  & 0.16992632E-09_JPRB, 0.16992338E-09_JPRB, 0.16992212E-09_JPRB, 0.16991587E-09_JPRB, 0.16990613E-09_JPRB, 0.16989267E-09_JPRB, &
  & 0.16987739E-09_JPRB, 0.16986344E-09_JPRB, 0.16985062E-09_JPRB, 0.16984018E-09_JPRB, 0.16983384E-09_JPRB, 0.16983238E-09_JPRB, &
  & 0.16983452E-09_JPRB, 0.16983694E-09_JPRB, 0.16984113E-09_JPRB, 0.16984308E-09_JPRB, 0.16984521E-09_JPRB, 0.16984535E-09_JPRB, &
  & 0.16984408E-09_JPRB, 0.16984009E-09_JPRB, 0.16983315E-09_JPRB, 0.16982145E-09_JPRB, 0.16981050E-09_JPRB, 0.16980095E-09_JPRB, &
  & 0.16979287E-09_JPRB, 0.16978682E-09_JPRB, 0.16978453E-09_JPRB, 0.16978463E-09_JPRB, 0.16978791E-09_JPRB, 0.16979368E-09_JPRB, &
  & 0.16980271E-09_JPRB, 0.16981147E-09_JPRB, 0.16982139E-09_JPRB, 0.16983295E-09_JPRB, 0.16984254E-09_JPRB, 0.16985099E-09_JPRB, &
  & 0.16986008E-09_JPRB, 0.16986715E-09_JPRB, 0.16987378E-09_JPRB, 0.16987924E-09_JPRB, 0.16988067E-09_JPRB, 0.16988209E-09_JPRB, &
  & 0.16988205E-09_JPRB, 0.16988067E-09_JPRB, 0.16987733E-09_JPRB, 0.16987806E-09_JPRB, 0.16987954E-09_JPRB, 0.16988158E-09_JPRB, &
  & 0.16988358E-09_JPRB, 0.16988363E-09_JPRB, 0.16987647E-09_JPRB, 0.16984562E-09_JPRB /)

RGHG8(:,79, 5) = (/ &
  & 0.16989340E-09_JPRB, 0.16992242E-09_JPRB, 0.16993397E-09_JPRB, 0.16993776E-09_JPRB, 0.16994178E-09_JPRB, 0.16994370E-09_JPRB, &
  & 0.16994725E-09_JPRB, 0.16994929E-09_JPRB, 0.16995137E-09_JPRB, 0.16995250E-09_JPRB, 0.16995275E-09_JPRB, 0.16995168E-09_JPRB, &
  & 0.16994611E-09_JPRB, 0.16994492E-09_JPRB, 0.16994361E-09_JPRB, 0.16993973E-09_JPRB, 0.16993340E-09_JPRB, 0.16992352E-09_JPRB, &
  & 0.16991208E-09_JPRB, 0.16990223E-09_JPRB, 0.16989306E-09_JPRB, 0.16988561E-09_JPRB, 0.16988130E-09_JPRB, 0.16988103E-09_JPRB, &
  & 0.16988341E-09_JPRB, 0.16988522E-09_JPRB, 0.16988846E-09_JPRB, 0.16988939E-09_JPRB, 0.16989084E-09_JPRB, 0.16989084E-09_JPRB, &
  & 0.16989019E-09_JPRB, 0.16988752E-09_JPRB, 0.16988309E-09_JPRB, 0.16987448E-09_JPRB, 0.16986720E-09_JPRB, 0.16986113E-09_JPRB, &
  & 0.16985556E-09_JPRB, 0.16985116E-09_JPRB, 0.16984966E-09_JPRB, 0.16984958E-09_JPRB, 0.16985174E-09_JPRB, 0.16985539E-09_JPRB, &
  & 0.16986192E-09_JPRB, 0.16986770E-09_JPRB, 0.16987466E-09_JPRB, 0.16988355E-09_JPRB, 0.16989035E-09_JPRB, 0.16989563E-09_JPRB, &
  & 0.16990206E-09_JPRB, 0.16990663E-09_JPRB, 0.16991163E-09_JPRB, 0.16991614E-09_JPRB, 0.16991647E-09_JPRB, 0.16991782E-09_JPRB, &
  & 0.16991800E-09_JPRB, 0.16991747E-09_JPRB, 0.16991521E-09_JPRB, 0.16991572E-09_JPRB, 0.16991633E-09_JPRB, 0.16991766E-09_JPRB, &
  & 0.16991930E-09_JPRB, 0.16992040E-09_JPRB, 0.16991603E-09_JPRB, 0.16989563E-09_JPRB /)

RGHG8(:,80, 5) = (/ &
  & 0.16992284E-09_JPRB, 0.16993740E-09_JPRB, 0.16994586E-09_JPRB, 0.16994836E-09_JPRB, 0.16995176E-09_JPRB, 0.16995302E-09_JPRB, &
  & 0.16995635E-09_JPRB, 0.16995791E-09_JPRB, 0.16995982E-09_JPRB, 0.16996078E-09_JPRB, 0.16996103E-09_JPRB, 0.16996028E-09_JPRB, &
  & 0.16995498E-09_JPRB, 0.16995463E-09_JPRB, 0.16995319E-09_JPRB, 0.16995040E-09_JPRB, 0.16994574E-09_JPRB, 0.16993747E-09_JPRB, &
  & 0.16992763E-09_JPRB, 0.16991972E-09_JPRB, 0.16991220E-09_JPRB, 0.16990591E-09_JPRB, 0.16990254E-09_JPRB, 0.16990288E-09_JPRB, &
  & 0.16990545E-09_JPRB, 0.16990703E-09_JPRB, 0.16990986E-09_JPRB, 0.16991031E-09_JPRB, 0.16991149E-09_JPRB, 0.16991146E-09_JPRB, &
  & 0.16991113E-09_JPRB, 0.16990909E-09_JPRB, 0.16990588E-09_JPRB, 0.16989861E-09_JPRB, 0.16989302E-09_JPRB, 0.16988849E-09_JPRB, &
  & 0.16988402E-09_JPRB, 0.16988021E-09_JPRB, 0.16987904E-09_JPRB, 0.16987874E-09_JPRB, 0.16988028E-09_JPRB, 0.16988291E-09_JPRB, &
  & 0.16988824E-09_JPRB, 0.16989266E-09_JPRB, 0.16989822E-09_JPRB, 0.16990599E-09_JPRB, 0.16991150E-09_JPRB, 0.16991521E-09_JPRB, &
  & 0.16992044E-09_JPRB, 0.16992377E-09_JPRB, 0.16992803E-09_JPRB, 0.16993215E-09_JPRB, 0.16993187E-09_JPRB, 0.16993315E-09_JPRB, &
  & 0.16993343E-09_JPRB, 0.16993330E-09_JPRB, 0.16993142E-09_JPRB, 0.16993179E-09_JPRB, 0.16993201E-09_JPRB, 0.16993294E-09_JPRB, &
  & 0.16993465E-09_JPRB, 0.16993634E-09_JPRB, 0.16993477E-09_JPRB, 0.16992793E-09_JPRB /)

RGHG8(:,81, 5) = (/ &
  & 0.16994291E-09_JPRB, 0.16994366E-09_JPRB, 0.16995094E-09_JPRB, 0.16995286E-09_JPRB, 0.16995608E-09_JPRB, 0.16995705E-09_JPRB, &
  & 0.16996021E-09_JPRB, 0.16996178E-09_JPRB, 0.16996346E-09_JPRB, 0.16996453E-09_JPRB, 0.16996475E-09_JPRB, 0.16996411E-09_JPRB, &
  & 0.16995894E-09_JPRB, 0.16995892E-09_JPRB, 0.16995737E-09_JPRB, 0.16995513E-09_JPRB, 0.16995128E-09_JPRB, 0.16994377E-09_JPRB, &
  & 0.16993457E-09_JPRB, 0.16992759E-09_JPRB, 0.16992070E-09_JPRB, 0.16991489E-09_JPRB, 0.16991188E-09_JPRB, 0.16991246E-09_JPRB, &
  & 0.16991517E-09_JPRB, 0.16991661E-09_JPRB, 0.16991931E-09_JPRB, 0.16991951E-09_JPRB, 0.16992056E-09_JPRB, 0.16992049E-09_JPRB, &
  & 0.16992036E-09_JPRB, 0.16991861E-09_JPRB, 0.16991593E-09_JPRB, 0.16990923E-09_JPRB, 0.16990438E-09_JPRB, 0.16990057E-09_JPRB, &
  & 0.16989656E-09_JPRB, 0.16989304E-09_JPRB, 0.16989196E-09_JPRB, 0.16989153E-09_JPRB, 0.16989277E-09_JPRB, 0.16989486E-09_JPRB, &
  & 0.16989961E-09_JPRB, 0.16990345E-09_JPRB, 0.16990842E-09_JPRB, 0.16991575E-09_JPRB, 0.16992072E-09_JPRB, 0.16992367E-09_JPRB, &
  & 0.16992834E-09_JPRB, 0.16993111E-09_JPRB, 0.16993505E-09_JPRB, 0.16993909E-09_JPRB, 0.16993845E-09_JPRB, 0.16993974E-09_JPRB, &
  & 0.16994005E-09_JPRB, 0.16994005E-09_JPRB, 0.16993833E-09_JPRB, 0.16993862E-09_JPRB, 0.16993862E-09_JPRB, 0.16993941E-09_JPRB, &
  & 0.16994109E-09_JPRB, 0.16994307E-09_JPRB, 0.16994259E-09_JPRB, 0.16994968E-09_JPRB /)

RGHG8(:,82, 5) = (/ &
  & 0.16994449E-09_JPRB, 0.16994572E-09_JPRB, 0.16995319E-09_JPRB, 0.16995498E-09_JPRB, 0.16995813E-09_JPRB, 0.16995888E-09_JPRB, &
  & 0.16996222E-09_JPRB, 0.16996336E-09_JPRB, 0.16996549E-09_JPRB, 0.16996625E-09_JPRB, 0.16996654E-09_JPRB, 0.16996604E-09_JPRB, &
  & 0.16996100E-09_JPRB, 0.16996113E-09_JPRB, 0.16995948E-09_JPRB, 0.16995749E-09_JPRB, 0.16995413E-09_JPRB, 0.16994689E-09_JPRB, &
  & 0.16993808E-09_JPRB, 0.16993146E-09_JPRB, 0.16992495E-09_JPRB, 0.16991930E-09_JPRB, 0.16991639E-09_JPRB, 0.16991715E-09_JPRB, &
  & 0.16991997E-09_JPRB, 0.16992130E-09_JPRB, 0.16992398E-09_JPRB, 0.16992398E-09_JPRB, 0.16992498E-09_JPRB, 0.16992491E-09_JPRB, &
  & 0.16992482E-09_JPRB, 0.16992323E-09_JPRB, 0.16992086E-09_JPRB, 0.16991442E-09_JPRB, 0.16990995E-09_JPRB, 0.16990645E-09_JPRB, &
  & 0.16990268E-09_JPRB, 0.16989932E-09_JPRB, 0.16989826E-09_JPRB, 0.16989780E-09_JPRB, 0.16989886E-09_JPRB, 0.16990076E-09_JPRB, &
  & 0.16990513E-09_JPRB, 0.16990868E-09_JPRB, 0.16991333E-09_JPRB, 0.16992048E-09_JPRB, 0.16992519E-09_JPRB, 0.16992777E-09_JPRB, &
  & 0.16993218E-09_JPRB, 0.16993465E-09_JPRB, 0.16993847E-09_JPRB, 0.16994245E-09_JPRB, 0.16994160E-09_JPRB, 0.16994289E-09_JPRB, &
  & 0.16994324E-09_JPRB, 0.16994331E-09_JPRB, 0.16994169E-09_JPRB, 0.16994195E-09_JPRB, 0.16994182E-09_JPRB, 0.16994248E-09_JPRB, &
  & 0.16994411E-09_JPRB, 0.16994602E-09_JPRB, 0.16994520E-09_JPRB, 0.16995141E-09_JPRB /)

RGHG8(:,83, 5) = (/ &
  & 0.16994559E-09_JPRB, 0.16994692E-09_JPRB, 0.16995445E-09_JPRB, 0.16995616E-09_JPRB, 0.16995934E-09_JPRB, 0.16996013E-09_JPRB, &
  & 0.16996310E-09_JPRB, 0.16996479E-09_JPRB, 0.16996618E-09_JPRB, 0.16996736E-09_JPRB, 0.16996751E-09_JPRB, 0.16996682E-09_JPRB, &
  & 0.16996242E-09_JPRB, 0.16996238E-09_JPRB, 0.16996063E-09_JPRB, 0.16995882E-09_JPRB, 0.16995569E-09_JPRB, 0.16994882E-09_JPRB, &
  & 0.16993998E-09_JPRB, 0.16993378E-09_JPRB, 0.16992734E-09_JPRB, 0.16992176E-09_JPRB, 0.16991888E-09_JPRB, 0.16991972E-09_JPRB, &
  & 0.16992269E-09_JPRB, 0.16992394E-09_JPRB, 0.16992659E-09_JPRB, 0.16992648E-09_JPRB, 0.16992743E-09_JPRB, 0.16992735E-09_JPRB, &
  & 0.16992729E-09_JPRB, 0.16992578E-09_JPRB, 0.16992356E-09_JPRB, 0.16991725E-09_JPRB, 0.16991299E-09_JPRB, 0.16990967E-09_JPRB, &
  & 0.16990603E-09_JPRB, 0.16990286E-09_JPRB, 0.16990181E-09_JPRB, 0.16990137E-09_JPRB, 0.16990229E-09_JPRB, 0.16990401E-09_JPRB, &
  & 0.16990809E-09_JPRB, 0.16991149E-09_JPRB, 0.16991598E-09_JPRB, 0.16992312E-09_JPRB, 0.16992774E-09_JPRB, 0.16993006E-09_JPRB, &
  & 0.16993430E-09_JPRB, 0.16993663E-09_JPRB, 0.16994037E-09_JPRB, 0.16994436E-09_JPRB, 0.16994336E-09_JPRB, 0.16994463E-09_JPRB, &
  & 0.16994499E-09_JPRB, 0.16994517E-09_JPRB, 0.16994355E-09_JPRB, 0.16994378E-09_JPRB, 0.16994359E-09_JPRB, 0.16994420E-09_JPRB, &
  & 0.16994579E-09_JPRB, 0.16994774E-09_JPRB, 0.16994672E-09_JPRB, 0.16995259E-09_JPRB /)

RGHG8(:,84, 5) = (/ &
  & 0.16994631E-09_JPRB, 0.16994767E-09_JPRB, 0.16995529E-09_JPRB, 0.16995690E-09_JPRB, 0.16996005E-09_JPRB, 0.16996064E-09_JPRB, &
  & 0.16996408E-09_JPRB, 0.16996507E-09_JPRB, 0.16996718E-09_JPRB, 0.16996779E-09_JPRB, 0.16996794E-09_JPRB, 0.16996739E-09_JPRB, &
  & 0.16996328E-09_JPRB, 0.16996304E-09_JPRB, 0.16996143E-09_JPRB, 0.16995967E-09_JPRB, 0.16995673E-09_JPRB, 0.16994994E-09_JPRB, &
  & 0.16994135E-09_JPRB, 0.16993514E-09_JPRB, 0.16992888E-09_JPRB, 0.16992327E-09_JPRB, 0.16992041E-09_JPRB, 0.16992135E-09_JPRB, &
  & 0.16992439E-09_JPRB, 0.16992556E-09_JPRB, 0.16992820E-09_JPRB, 0.16992802E-09_JPRB, 0.16992892E-09_JPRB, 0.16992879E-09_JPRB, &
  & 0.16992886E-09_JPRB, 0.16992736E-09_JPRB, 0.16992523E-09_JPRB, 0.16991897E-09_JPRB, 0.16991492E-09_JPRB, 0.16991164E-09_JPRB, &
  & 0.16990810E-09_JPRB, 0.16990513E-09_JPRB, 0.16990410E-09_JPRB, 0.16990370E-09_JPRB, 0.16990451E-09_JPRB, 0.16990612E-09_JPRB, &
  & 0.16990985E-09_JPRB, 0.16991317E-09_JPRB, 0.16991750E-09_JPRB, 0.16992463E-09_JPRB, 0.16992922E-09_JPRB, 0.16993147E-09_JPRB, &
  & 0.16993565E-09_JPRB, 0.16993783E-09_JPRB, 0.16994152E-09_JPRB, 0.16994554E-09_JPRB, 0.16994443E-09_JPRB, 0.16994570E-09_JPRB, &
  & 0.16994607E-09_JPRB, 0.16994628E-09_JPRB, 0.16994468E-09_JPRB, 0.16994493E-09_JPRB, 0.16994470E-09_JPRB, 0.16994522E-09_JPRB, &
  & 0.16994683E-09_JPRB, 0.16994878E-09_JPRB, 0.16994768E-09_JPRB, 0.16995341E-09_JPRB /)

RGHG8(:,85, 5) = (/ &
  & 0.16994674E-09_JPRB, 0.16994814E-09_JPRB, 0.16995583E-09_JPRB, 0.16995741E-09_JPRB, 0.16996059E-09_JPRB, 0.16996152E-09_JPRB, &
  & 0.16996421E-09_JPRB, 0.16996599E-09_JPRB, 0.16996712E-09_JPRB, 0.16996808E-09_JPRB, 0.16996808E-09_JPRB, 0.16996708E-09_JPRB, &
  & 0.16996429E-09_JPRB, 0.16996357E-09_JPRB, 0.16996192E-09_JPRB, 0.16996021E-09_JPRB, 0.16995738E-09_JPRB, 0.16995089E-09_JPRB, &
  & 0.16994223E-09_JPRB, 0.16993618E-09_JPRB, 0.16992982E-09_JPRB, 0.16992420E-09_JPRB, 0.16992135E-09_JPRB, 0.16992234E-09_JPRB, &
  & 0.16992549E-09_JPRB, 0.16992656E-09_JPRB, 0.16992929E-09_JPRB, 0.16992900E-09_JPRB, 0.16992989E-09_JPRB, 0.16992974E-09_JPRB, &
  & 0.16992985E-09_JPRB, 0.16992835E-09_JPRB, 0.16992628E-09_JPRB, 0.16992006E-09_JPRB, 0.16991610E-09_JPRB, 0.16991288E-09_JPRB, &
  & 0.16990946E-09_JPRB, 0.16990653E-09_JPRB, 0.16990556E-09_JPRB, 0.16990520E-09_JPRB, 0.16990598E-09_JPRB, 0.16990750E-09_JPRB, &
  & 0.16991096E-09_JPRB, 0.16991418E-09_JPRB, 0.16991855E-09_JPRB, 0.16992546E-09_JPRB, 0.16993018E-09_JPRB, 0.16993237E-09_JPRB, &
  & 0.16993648E-09_JPRB, 0.16993858E-09_JPRB, 0.16994230E-09_JPRB, 0.16994633E-09_JPRB, 0.16994511E-09_JPRB, 0.16994640E-09_JPRB, &
  & 0.16994678E-09_JPRB, 0.16994704E-09_JPRB, 0.16994547E-09_JPRB, 0.16994567E-09_JPRB, 0.16994538E-09_JPRB, 0.16994592E-09_JPRB, &
  & 0.16994749E-09_JPRB, 0.16994950E-09_JPRB, 0.16994832E-09_JPRB, 0.16995394E-09_JPRB /)

RGHG8(:,86, 5) = (/ &
  & 0.16994700E-09_JPRB, 0.16994847E-09_JPRB, 0.16995616E-09_JPRB, 0.16995767E-09_JPRB, 0.16996096E-09_JPRB, 0.16996166E-09_JPRB, &
  & 0.16996499E-09_JPRB, 0.16996596E-09_JPRB, 0.16996751E-09_JPRB, 0.16996796E-09_JPRB, 0.16996787E-09_JPRB, 0.16996732E-09_JPRB, &
  & 0.16996443E-09_JPRB, 0.16996374E-09_JPRB, 0.16996218E-09_JPRB, 0.16996043E-09_JPRB, 0.16995763E-09_JPRB, 0.16995164E-09_JPRB, &
  & 0.16994309E-09_JPRB, 0.16993691E-09_JPRB, 0.16993054E-09_JPRB, 0.16992482E-09_JPRB, 0.16992195E-09_JPRB, 0.16992299E-09_JPRB, &
  & 0.16992621E-09_JPRB, 0.16992725E-09_JPRB, 0.16992996E-09_JPRB, 0.16992961E-09_JPRB, 0.16993050E-09_JPRB, 0.16993033E-09_JPRB, &
  & 0.16993046E-09_JPRB, 0.16992902E-09_JPRB, 0.16992699E-09_JPRB, 0.16992080E-09_JPRB, 0.16991689E-09_JPRB, 0.16991375E-09_JPRB, &
  & 0.16991025E-09_JPRB, 0.16990742E-09_JPRB, 0.16990644E-09_JPRB, 0.16990606E-09_JPRB, 0.16990681E-09_JPRB, 0.16990831E-09_JPRB, &
  & 0.16991175E-09_JPRB, 0.16991492E-09_JPRB, 0.16991912E-09_JPRB, 0.16992621E-09_JPRB, 0.16993071E-09_JPRB, 0.16993296E-09_JPRB, &
  & 0.16993700E-09_JPRB, 0.16993905E-09_JPRB, 0.16994270E-09_JPRB, 0.16994681E-09_JPRB, 0.16994554E-09_JPRB, 0.16994678E-09_JPRB, &
  & 0.16994718E-09_JPRB, 0.16994749E-09_JPRB, 0.16994593E-09_JPRB, 0.16994615E-09_JPRB, 0.16994585E-09_JPRB, 0.16994633E-09_JPRB, &
  & 0.16994793E-09_JPRB, 0.16994996E-09_JPRB, 0.16994871E-09_JPRB, 0.16995427E-09_JPRB /)

RGHG8(:,87, 5) = (/ &
  & 0.16994722E-09_JPRB, 0.16994878E-09_JPRB, 0.16995629E-09_JPRB, 0.16995796E-09_JPRB, 0.16996114E-09_JPRB, 0.16996246E-09_JPRB, &
  & 0.16996482E-09_JPRB, 0.16996640E-09_JPRB, 0.16996726E-09_JPRB, 0.16996780E-09_JPRB, 0.16996768E-09_JPRB, 0.16996657E-09_JPRB, &
  & 0.16996501E-09_JPRB, 0.16996389E-09_JPRB, 0.16996241E-09_JPRB, 0.16996063E-09_JPRB, 0.16995788E-09_JPRB, 0.16995202E-09_JPRB, &
  & 0.16994389E-09_JPRB, 0.16993748E-09_JPRB, 0.16993101E-09_JPRB, 0.16992520E-09_JPRB, 0.16992231E-09_JPRB, 0.16992341E-09_JPRB, &
  & 0.16992666E-09_JPRB, 0.16992763E-09_JPRB, 0.16993039E-09_JPRB, 0.16993001E-09_JPRB, 0.16993087E-09_JPRB, 0.16993071E-09_JPRB, &
  & 0.16993086E-09_JPRB, 0.16992938E-09_JPRB, 0.16992745E-09_JPRB, 0.16992122E-09_JPRB, 0.16991747E-09_JPRB, 0.16991433E-09_JPRB, &
  & 0.16991095E-09_JPRB, 0.16990780E-09_JPRB, 0.16990687E-09_JPRB, 0.16990642E-09_JPRB, 0.16990717E-09_JPRB, 0.16990864E-09_JPRB, &
  & 0.16991222E-09_JPRB, 0.16991540E-09_JPRB, 0.16991974E-09_JPRB, 0.16992666E-09_JPRB, 0.16993122E-09_JPRB, 0.16993330E-09_JPRB, &
  & 0.16993730E-09_JPRB, 0.16993930E-09_JPRB, 0.16994292E-09_JPRB, 0.16994701E-09_JPRB, 0.16994581E-09_JPRB, 0.16994706E-09_JPRB, &
  & 0.16994743E-09_JPRB, 0.16994776E-09_JPRB, 0.16994624E-09_JPRB, 0.16994643E-09_JPRB, 0.16994610E-09_JPRB, 0.16994660E-09_JPRB, &
  & 0.16994819E-09_JPRB, 0.16995025E-09_JPRB, 0.16994893E-09_JPRB, 0.16995448E-09_JPRB /)

RGHG8(:,88, 5) = (/ &
  & 0.16994740E-09_JPRB, 0.16994928E-09_JPRB, 0.16995626E-09_JPRB, 0.16995798E-09_JPRB, 0.16996136E-09_JPRB, 0.16996227E-09_JPRB, &
  & 0.16996532E-09_JPRB, 0.16996628E-09_JPRB, 0.16996746E-09_JPRB, 0.16996773E-09_JPRB, 0.16996750E-09_JPRB, 0.16996697E-09_JPRB, &
  & 0.16996483E-09_JPRB, 0.16996404E-09_JPRB, 0.16996247E-09_JPRB, 0.16996071E-09_JPRB, 0.16995796E-09_JPRB, 0.16995247E-09_JPRB, &
  & 0.16994414E-09_JPRB, 0.16993784E-09_JPRB, 0.16993126E-09_JPRB, 0.16992543E-09_JPRB, 0.16992251E-09_JPRB, 0.16992360E-09_JPRB, &
  & 0.16992692E-09_JPRB, 0.16992786E-09_JPRB, 0.16993067E-09_JPRB, 0.16993022E-09_JPRB, 0.16993111E-09_JPRB, 0.16993093E-09_JPRB, &
  & 0.16993110E-09_JPRB, 0.16992963E-09_JPRB, 0.16992775E-09_JPRB, 0.16992148E-09_JPRB, 0.16991779E-09_JPRB, 0.16991480E-09_JPRB, &
  & 0.16991128E-09_JPRB, 0.16990800E-09_JPRB, 0.16990701E-09_JPRB, 0.16990641E-09_JPRB, 0.16990717E-09_JPRB, 0.16990861E-09_JPRB, &
  & 0.16991264E-09_JPRB, 0.16991578E-09_JPRB, 0.16991999E-09_JPRB, 0.16992729E-09_JPRB, 0.16993153E-09_JPRB, 0.16993359E-09_JPRB, &
  & 0.16993744E-09_JPRB, 0.16993949E-09_JPRB, 0.16994303E-09_JPRB, 0.16994711E-09_JPRB, 0.16994593E-09_JPRB, 0.16994717E-09_JPRB, &
  & 0.16994761E-09_JPRB, 0.16994794E-09_JPRB, 0.16994643E-09_JPRB, 0.16994664E-09_JPRB, 0.16994622E-09_JPRB, 0.16994675E-09_JPRB, &
  & 0.16994837E-09_JPRB, 0.16995043E-09_JPRB, 0.16994907E-09_JPRB, 0.16995463E-09_JPRB /)

RGHG8(:,89, 5) = (/ &
  & 0.16994776E-09_JPRB, 0.16994983E-09_JPRB, 0.16995609E-09_JPRB, 0.16995803E-09_JPRB, 0.16996128E-09_JPRB, 0.16996254E-09_JPRB, &
  & 0.16996504E-09_JPRB, 0.16996649E-09_JPRB, 0.16996736E-09_JPRB, 0.16996776E-09_JPRB, 0.16996758E-09_JPRB, 0.16996671E-09_JPRB, &
  & 0.16996529E-09_JPRB, 0.16996417E-09_JPRB, 0.16996268E-09_JPRB, 0.16996088E-09_JPRB, 0.16995821E-09_JPRB, 0.16995236E-09_JPRB, &
  & 0.16994410E-09_JPRB, 0.16993781E-09_JPRB, 0.16993137E-09_JPRB, 0.16992545E-09_JPRB, 0.16992258E-09_JPRB, 0.16992371E-09_JPRB, &
  & 0.16992709E-09_JPRB, 0.16992800E-09_JPRB, 0.16993083E-09_JPRB, 0.16993033E-09_JPRB, 0.16993124E-09_JPRB, 0.16993103E-09_JPRB, &
  & 0.16993126E-09_JPRB, 0.16992978E-09_JPRB, 0.16992796E-09_JPRB, 0.16992159E-09_JPRB, 0.16991798E-09_JPRB, 0.16991511E-09_JPRB, &
  & 0.16991160E-09_JPRB, 0.16990802E-09_JPRB, 0.16990710E-09_JPRB, 0.16990630E-09_JPRB, 0.16990710E-09_JPRB, 0.16990839E-09_JPRB, &
  & 0.16991300E-09_JPRB, 0.16991604E-09_JPRB, 0.16992036E-09_JPRB, 0.16992764E-09_JPRB, 0.16993182E-09_JPRB, 0.16993376E-09_JPRB, &
  & 0.16993756E-09_JPRB, 0.16993956E-09_JPRB, 0.16994307E-09_JPRB, 0.16994713E-09_JPRB, 0.16994599E-09_JPRB, 0.16994724E-09_JPRB, &
  & 0.16994767E-09_JPRB, 0.16994800E-09_JPRB, 0.16994653E-09_JPRB, 0.16994674E-09_JPRB, 0.16994628E-09_JPRB, 0.16994686E-09_JPRB, &
  & 0.16994847E-09_JPRB, 0.16995058E-09_JPRB, 0.16994910E-09_JPRB, 0.16995469E-09_JPRB /)

RGHG8(:,90, 5) = (/ &
  & 0.16994813E-09_JPRB, 0.16995041E-09_JPRB, 0.16995570E-09_JPRB, 0.16995781E-09_JPRB, 0.16996130E-09_JPRB, 0.16996191E-09_JPRB, &
  & 0.16996524E-09_JPRB, 0.16996636E-09_JPRB, 0.16996785E-09_JPRB, 0.16996823E-09_JPRB, 0.16996798E-09_JPRB, 0.16996747E-09_JPRB, &
  & 0.16996518E-09_JPRB, 0.16996439E-09_JPRB, 0.16996268E-09_JPRB, 0.16996102E-09_JPRB, 0.16995842E-09_JPRB, 0.16995245E-09_JPRB, &
  & 0.16994353E-09_JPRB, 0.16993772E-09_JPRB, 0.16993132E-09_JPRB, 0.16992541E-09_JPRB, 0.16992252E-09_JPRB, 0.16992373E-09_JPRB, &
  & 0.16992723E-09_JPRB, 0.16992804E-09_JPRB, 0.16993103E-09_JPRB, 0.16993035E-09_JPRB, 0.16993132E-09_JPRB, 0.16993108E-09_JPRB, &
  & 0.16993137E-09_JPRB, 0.16992986E-09_JPRB, 0.16992822E-09_JPRB, 0.16992152E-09_JPRB, 0.16991804E-09_JPRB, 0.16991526E-09_JPRB, &
  & 0.16991175E-09_JPRB, 0.16990798E-09_JPRB, 0.16990714E-09_JPRB, 0.16990617E-09_JPRB, 0.16990702E-09_JPRB, 0.16990807E-09_JPRB, &
  & 0.16991328E-09_JPRB, 0.16991608E-09_JPRB, 0.16992033E-09_JPRB, 0.16992795E-09_JPRB, 0.16993203E-09_JPRB, 0.16993389E-09_JPRB, &
  & 0.16993768E-09_JPRB, 0.16993963E-09_JPRB, 0.16994309E-09_JPRB, 0.16994733E-09_JPRB, 0.16994597E-09_JPRB, 0.16994725E-09_JPRB, &
  & 0.16994771E-09_JPRB, 0.16994810E-09_JPRB, 0.16994652E-09_JPRB, 0.16994679E-09_JPRB, 0.16994629E-09_JPRB, 0.16994686E-09_JPRB, &
  & 0.16994853E-09_JPRB, 0.16995073E-09_JPRB, 0.16994903E-09_JPRB, 0.16995480E-09_JPRB /)

RGHG8(:,91, 5) = (/ &
  & 0.16994831E-09_JPRB, 0.16995072E-09_JPRB, 0.16995502E-09_JPRB, 0.16995771E-09_JPRB, 0.16996156E-09_JPRB, 0.16996128E-09_JPRB, &
  & 0.16996513E-09_JPRB, 0.16996576E-09_JPRB, 0.16996830E-09_JPRB, 0.16996944E-09_JPRB, 0.16996982E-09_JPRB, 0.16996987E-09_JPRB, &
  & 0.16996254E-09_JPRB, 0.16996470E-09_JPRB, 0.16996222E-09_JPRB, 0.16996106E-09_JPRB, 0.16995906E-09_JPRB, 0.16995229E-09_JPRB, &
  & 0.16994275E-09_JPRB, 0.16993758E-09_JPRB, 0.16993124E-09_JPRB, 0.16992517E-09_JPRB, 0.16992222E-09_JPRB, 0.16992359E-09_JPRB, &
  & 0.16992745E-09_JPRB, 0.16992786E-09_JPRB, 0.16993129E-09_JPRB, 0.16993024E-09_JPRB, 0.16993143E-09_JPRB, 0.16993108E-09_JPRB, &
  & 0.16993153E-09_JPRB, 0.16992993E-09_JPRB, 0.16992868E-09_JPRB, 0.16992120E-09_JPRB, 0.16991800E-09_JPRB, 0.16991530E-09_JPRB, &
  & 0.16991178E-09_JPRB, 0.16990774E-09_JPRB, 0.16990719E-09_JPRB, 0.16990599E-09_JPRB, 0.16990702E-09_JPRB, 0.16990769E-09_JPRB, &
  & 0.16991354E-09_JPRB, 0.16991593E-09_JPRB, 0.16992013E-09_JPRB, 0.16992815E-09_JPRB, 0.16993230E-09_JPRB, 0.16993386E-09_JPRB, &
  & 0.16993777E-09_JPRB, 0.16993955E-09_JPRB, 0.16994300E-09_JPRB, 0.16994793E-09_JPRB, 0.16994577E-09_JPRB, 0.16994739E-09_JPRB, &
  & 0.16994774E-09_JPRB, 0.16994826E-09_JPRB, 0.16994643E-09_JPRB, 0.16994686E-09_JPRB, 0.16994622E-09_JPRB, 0.16994682E-09_JPRB, &
  & 0.16994856E-09_JPRB, 0.16995096E-09_JPRB, 0.16994889E-09_JPRB, 0.16995494E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART10',1,ZHOOK_HANDLE)
END SUBROUTINE PART10






SUBROUTINE PART11
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART11',0,ZHOOK_HANDLE)



!-- Month=  6 ------------

RGHG8(:, 1, 6) = (/ &
  & 0.44602627E-10_JPRB, 0.44710277E-10_JPRB, 0.44753153E-10_JPRB, 0.44785557E-10_JPRB, 0.44831402E-10_JPRB, 0.44906575E-10_JPRB, &
  & 0.44985383E-10_JPRB, 0.45053242E-10_JPRB, 0.45107095E-10_JPRB, 0.45149193E-10_JPRB, 0.45181844E-10_JPRB, 0.45206151E-10_JPRB, &
  & 0.45221639E-10_JPRB, 0.45226819E-10_JPRB, 0.45220848E-10_JPRB, 0.45200732E-10_JPRB, 0.45165965E-10_JPRB, 0.45116008E-10_JPRB, &
  & 0.45048864E-10_JPRB, 0.44965816E-10_JPRB, 0.44868245E-10_JPRB, 0.44758315E-10_JPRB, 0.44637363E-10_JPRB, 0.44511068E-10_JPRB, &
  & 0.44386526E-10_JPRB, 0.44270265E-10_JPRB, 0.44165945E-10_JPRB, 0.44067815E-10_JPRB, 0.43968777E-10_JPRB, 0.43863739E-10_JPRB, &
  & 0.43748550E-10_JPRB, 0.43620531E-10_JPRB, 0.43475348E-10_JPRB, 0.43308759E-10_JPRB, 0.43123834E-10_JPRB, 0.42924015E-10_JPRB, &
  & 0.42714016E-10_JPRB, 0.42498085E-10_JPRB, 0.42290033E-10_JPRB, 0.42116224E-10_JPRB, 0.41956751E-10_JPRB, 0.41790470E-10_JPRB, &
  & 0.41604924E-10_JPRB, 0.41381697E-10_JPRB, 0.41093601E-10_JPRB, 0.40690961E-10_JPRB, 0.40100222E-10_JPRB, 0.39323617E-10_JPRB, &
  & 0.38619188E-10_JPRB, 0.38130440E-10_JPRB, 0.37733920E-10_JPRB, 0.37400225E-10_JPRB, 0.37121674E-10_JPRB, 0.36880991E-10_JPRB, &
  & 0.36664977E-10_JPRB, 0.36470438E-10_JPRB, 0.36313057E-10_JPRB, 0.36176236E-10_JPRB, 0.36041524E-10_JPRB, 0.35909650E-10_JPRB, &
  & 0.35771452E-10_JPRB, 0.35627768E-10_JPRB, 0.35481212E-10_JPRB, 0.35322523E-10_JPRB /)

RGHG8(:, 2, 6) = (/ &
  & 0.44818635E-10_JPRB, 0.45056812E-10_JPRB, 0.45189352E-10_JPRB, 0.45299063E-10_JPRB, 0.45421951E-10_JPRB, 0.45574960E-10_JPRB, &
  & 0.45740495E-10_JPRB, 0.45894566E-10_JPRB, 0.46021954E-10_JPRB, 0.46117339E-10_JPRB, 0.46176368E-10_JPRB, 0.46195162E-10_JPRB, &
  & 0.46177711E-10_JPRB, 0.46139193E-10_JPRB, 0.46100370E-10_JPRB, 0.46073759E-10_JPRB, 0.46060024E-10_JPRB, 0.46049952E-10_JPRB, &
  & 0.46030846E-10_JPRB, 0.45994722E-10_JPRB, 0.45938406E-10_JPRB, 0.45864108E-10_JPRB, 0.45777243E-10_JPRB, 0.45688932E-10_JPRB, &
  & 0.45612455E-10_JPRB, 0.45558030E-10_JPRB, 0.45528303E-10_JPRB, 0.45513506E-10_JPRB, 0.45500766E-10_JPRB, 0.45472529E-10_JPRB, &
  & 0.45410342E-10_JPRB, 0.45297998E-10_JPRB, 0.45128241E-10_JPRB, 0.44899834E-10_JPRB, 0.44620353E-10_JPRB, 0.44298166E-10_JPRB, &
  & 0.43946905E-10_JPRB, 0.43584927E-10_JPRB, 0.43243600E-10_JPRB, 0.42944134E-10_JPRB, 0.42680668E-10_JPRB, 0.42430028E-10_JPRB, &
  & 0.42173449E-10_JPRB, 0.41890914E-10_JPRB, 0.41558014E-10_JPRB, 0.41146760E-10_JPRB, 0.40637552E-10_JPRB, 0.40057527E-10_JPRB, &
  & 0.39497846E-10_JPRB, 0.39036475E-10_JPRB, 0.38657501E-10_JPRB, 0.38335991E-10_JPRB, 0.38052013E-10_JPRB, 0.37789240E-10_JPRB, &
  & 0.37543597E-10_JPRB, 0.37319387E-10_JPRB, 0.37127856E-10_JPRB, 0.36963127E-10_JPRB, 0.36806481E-10_JPRB, 0.36649902E-10_JPRB, &
  & 0.36488063E-10_JPRB, 0.36318445E-10_JPRB, 0.36132240E-10_JPRB, 0.35808034E-10_JPRB /)

RGHG8(:, 3, 6) = (/ &
  & 0.45074260E-10_JPRB, 0.45371908E-10_JPRB, 0.45530767E-10_JPRB, 0.45663161E-10_JPRB, 0.45805547E-10_JPRB, 0.45972469E-10_JPRB, &
  & 0.46148720E-10_JPRB, 0.46302323E-10_JPRB, 0.46413567E-10_JPRB, 0.46487380E-10_JPRB, 0.46551075E-10_JPRB, 0.46647887E-10_JPRB, &
  & 0.46809501E-10_JPRB, 0.47030775E-10_JPRB, 0.47276041E-10_JPRB, 0.47506735E-10_JPRB, 0.47702418E-10_JPRB, 0.47855421E-10_JPRB, &
  & 0.47961329E-10_JPRB, 0.48018943E-10_JPRB, 0.48029504E-10_JPRB, 0.47998473E-10_JPRB, 0.47934809E-10_JPRB, 0.47853353E-10_JPRB, &
  & 0.47769524E-10_JPRB, 0.47695254E-10_JPRB, 0.47632003E-10_JPRB, 0.47570045E-10_JPRB, 0.47494432E-10_JPRB, 0.47384568E-10_JPRB, &
  & 0.47219693E-10_JPRB, 0.46988968E-10_JPRB, 0.46697535E-10_JPRB, 0.46356047E-10_JPRB, 0.45979869E-10_JPRB, 0.45578041E-10_JPRB, &
  & 0.45152306E-10_JPRB, 0.44712532E-10_JPRB, 0.44273699E-10_JPRB, 0.43860946E-10_JPRB, 0.43475661E-10_JPRB, 0.43109738E-10_JPRB, &
  & 0.42750397E-10_JPRB, 0.42381820E-10_JPRB, 0.41991688E-10_JPRB, 0.41572586E-10_JPRB, 0.41129395E-10_JPRB, 0.40683294E-10_JPRB, &
  & 0.40266609E-10_JPRB, 0.39894497E-10_JPRB, 0.39563155E-10_JPRB, 0.39255117E-10_JPRB, 0.38958756E-10_JPRB, 0.38663704E-10_JPRB, &
  & 0.38370637E-10_JPRB, 0.38099975E-10_JPRB, 0.37865776E-10_JPRB, 0.37658356E-10_JPRB, 0.37472268E-10_JPRB, 0.37308236E-10_JPRB, &
  & 0.37158745E-10_JPRB, 0.37011560E-10_JPRB, 0.36836059E-10_JPRB, 0.36567353E-10_JPRB /)

RGHG8(:, 4, 6) = (/ &
  & 0.45237022E-10_JPRB, 0.45548541E-10_JPRB, 0.45729961E-10_JPRB, 0.45892637E-10_JPRB, 0.46067723E-10_JPRB, 0.46268531E-10_JPRB, &
  & 0.46479577E-10_JPRB, 0.46683331E-10_JPRB, 0.46886668E-10_JPRB, 0.47119406E-10_JPRB, 0.47408001E-10_JPRB, 0.47746328E-10_JPRB, &
  & 0.48109801E-10_JPRB, 0.48482898E-10_JPRB, 0.48862390E-10_JPRB, 0.49232195E-10_JPRB, 0.49566878E-10_JPRB, 0.49848514E-10_JPRB, &
  & 0.50070420E-10_JPRB, 0.50231666E-10_JPRB, 0.50331243E-10_JPRB, 0.50369913E-10_JPRB, 0.50350731E-10_JPRB, 0.50282369E-10_JPRB, &
  & 0.50175728E-10_JPRB, 0.50041297E-10_JPRB, 0.49884132E-10_JPRB, 0.49697614E-10_JPRB, 0.49468929E-10_JPRB, 0.49179508E-10_JPRB, &
  & 0.48817384E-10_JPRB, 0.48388710E-10_JPRB, 0.47914304E-10_JPRB, 0.47422823E-10_JPRB, 0.46937725E-10_JPRB, 0.46465623E-10_JPRB, &
  & 0.46009654E-10_JPRB, 0.45559598E-10_JPRB, 0.45114700E-10_JPRB, 0.44668637E-10_JPRB, 0.44226199E-10_JPRB, 0.43786651E-10_JPRB, &
  & 0.43346993E-10_JPRB, 0.42909780E-10_JPRB, 0.42471061E-10_JPRB, 0.42034629E-10_JPRB, 0.41610316E-10_JPRB, 0.41212072E-10_JPRB, &
  & 0.40835828E-10_JPRB, 0.40499167E-10_JPRB, 0.40169722E-10_JPRB, 0.39857423E-10_JPRB, 0.39535906E-10_JPRB, 0.39200091E-10_JPRB, &
  & 0.38862899E-10_JPRB, 0.38541014E-10_JPRB, 0.38240688E-10_JPRB, 0.37988647E-10_JPRB, 0.37790205E-10_JPRB, 0.37627176E-10_JPRB, &
  & 0.37486219E-10_JPRB, 0.37360257E-10_JPRB, 0.37243628E-10_JPRB, 0.37068251E-10_JPRB /)

RGHG8(:, 5, 6) = (/ &
  & 0.45271648E-10_JPRB, 0.45531669E-10_JPRB, 0.45717131E-10_JPRB, 0.45920035E-10_JPRB, 0.46161418E-10_JPRB, 0.46446628E-10_JPRB, &
  & 0.46765800E-10_JPRB, 0.47110885E-10_JPRB, 0.47480398E-10_JPRB, 0.47886937E-10_JPRB, 0.48329687E-10_JPRB, 0.48813394E-10_JPRB, &
  & 0.49339401E-10_JPRB, 0.49890831E-10_JPRB, 0.50439854E-10_JPRB, 0.50973593E-10_JPRB, 0.51483932E-10_JPRB, 0.51942905E-10_JPRB, &
  & 0.52318185E-10_JPRB, 0.52597676E-10_JPRB, 0.52784537E-10_JPRB, 0.52886001E-10_JPRB, 0.52906533E-10_JPRB, 0.52849572E-10_JPRB, &
  & 0.52716300E-10_JPRB, 0.52508366E-10_JPRB, 0.52225359E-10_JPRB, 0.51864540E-10_JPRB, 0.51423029E-10_JPRB, 0.50898053E-10_JPRB, &
  & 0.50295754E-10_JPRB, 0.49635438E-10_JPRB, 0.48953439E-10_JPRB, 0.48286750E-10_JPRB, 0.47671055E-10_JPRB, 0.47121914E-10_JPRB, &
  & 0.46622314E-10_JPRB, 0.46160173E-10_JPRB, 0.45715917E-10_JPRB, 0.45278628E-10_JPRB, 0.44840461E-10_JPRB, 0.44400351E-10_JPRB, &
  & 0.43967729E-10_JPRB, 0.43543079E-10_JPRB, 0.43131637E-10_JPRB, 0.42736214E-10_JPRB, 0.42354235E-10_JPRB, 0.41987250E-10_JPRB, &
  & 0.41622927E-10_JPRB, 0.41265748E-10_JPRB, 0.40901251E-10_JPRB, 0.40524740E-10_JPRB, 0.40133296E-10_JPRB, 0.39717375E-10_JPRB, &
  & 0.39297197E-10_JPRB, 0.38861522E-10_JPRB, 0.38460471E-10_JPRB, 0.38134024E-10_JPRB, 0.37866637E-10_JPRB, 0.37649578E-10_JPRB, &
  & 0.37483915E-10_JPRB, 0.37358262E-10_JPRB, 0.37256788E-10_JPRB, 0.37149311E-10_JPRB /)

RGHG8(:, 6, 6) = (/ &
  & 0.45099570E-10_JPRB, 0.45172085E-10_JPRB, 0.45318596E-10_JPRB, 0.45561638E-10_JPRB, 0.45900162E-10_JPRB, 0.46318421E-10_JPRB, &
  & 0.46791938E-10_JPRB, 0.47301607E-10_JPRB, 0.47841234E-10_JPRB, 0.48414491E-10_JPRB, 0.49038818E-10_JPRB, 0.49712699E-10_JPRB, &
  & 0.50423055E-10_JPRB, 0.51154428E-10_JPRB, 0.51886162E-10_JPRB, 0.52572238E-10_JPRB, 0.53175533E-10_JPRB, 0.53687426E-10_JPRB, &
  & 0.54107302E-10_JPRB, 0.54431466E-10_JPRB, 0.54660818E-10_JPRB, 0.54800983E-10_JPRB, 0.54854822E-10_JPRB, 0.54821911E-10_JPRB, &
  & 0.54695744E-10_JPRB, 0.54467271E-10_JPRB, 0.54127102E-10_JPRB, 0.53668257E-10_JPRB, 0.53092131E-10_JPRB, 0.52407301E-10_JPRB, &
  & 0.51629513E-10_JPRB, 0.50793078E-10_JPRB, 0.49947966E-10_JPRB, 0.49148595E-10_JPRB, 0.48436394E-10_JPRB, 0.47815345E-10_JPRB, &
  & 0.47278469E-10_JPRB, 0.46797153E-10_JPRB, 0.46347818E-10_JPRB, 0.45905973E-10_JPRB, 0.45460975E-10_JPRB, 0.45013927E-10_JPRB, &
  & 0.44567419E-10_JPRB, 0.44133575E-10_JPRB, 0.43712197E-10_JPRB, 0.43305057E-10_JPRB, 0.42910647E-10_JPRB, 0.42523082E-10_JPRB, &
  & 0.42131278E-10_JPRB, 0.41736076E-10_JPRB, 0.41331018E-10_JPRB, 0.40904929E-10_JPRB, 0.40461363E-10_JPRB, 0.39997082E-10_JPRB, &
  & 0.39500618E-10_JPRB, 0.38995866E-10_JPRB, 0.38532011E-10_JPRB, 0.38118259E-10_JPRB, 0.37758012E-10_JPRB, 0.37466776E-10_JPRB, &
  & 0.37243202E-10_JPRB, 0.37081699E-10_JPRB, 0.36974177E-10_JPRB, 0.36916237E-10_JPRB /)

RGHG8(:, 7, 6) = (/ &
  & 0.44499224E-10_JPRB, 0.44186314E-10_JPRB, 0.44228225E-10_JPRB, 0.44487775E-10_JPRB, 0.44917806E-10_JPRB, 0.45465836E-10_JPRB, &
  & 0.46104860E-10_JPRB, 0.46799863E-10_JPRB, 0.47545433E-10_JPRB, 0.48342039E-10_JPRB, 0.49194454E-10_JPRB, 0.50095698E-10_JPRB, &
  & 0.51020854E-10_JPRB, 0.51926862E-10_JPRB, 0.52767936E-10_JPRB, 0.53522603E-10_JPRB, 0.54174443E-10_JPRB, 0.54710327E-10_JPRB, &
  & 0.55134487E-10_JPRB, 0.55462208E-10_JPRB, 0.55703560E-10_JPRB, 0.55868355E-10_JPRB, 0.55959869E-10_JPRB, 0.55973840E-10_JPRB, &
  & 0.55899972E-10_JPRB, 0.55724928E-10_JPRB, 0.55430528E-10_JPRB, 0.54998117E-10_JPRB, 0.54421512E-10_JPRB, 0.53706803E-10_JPRB, &
  & 0.52880943E-10_JPRB, 0.51992594E-10_JPRB, 0.51099590E-10_JPRB, 0.50261739E-10_JPRB, 0.49522463E-10_JPRB, 0.48899589E-10_JPRB, &
  & 0.48371022E-10_JPRB, 0.47907477E-10_JPRB, 0.47476183E-10_JPRB, 0.47050801E-10_JPRB, 0.46615312E-10_JPRB, 0.46160908E-10_JPRB, &
  & 0.45691870E-10_JPRB, 0.45208389E-10_JPRB, 0.44716546E-10_JPRB, 0.44220950E-10_JPRB, 0.43722265E-10_JPRB, 0.43217482E-10_JPRB, &
  & 0.42705138E-10_JPRB, 0.42186289E-10_JPRB, 0.41662229E-10_JPRB, 0.41132247E-10_JPRB, 0.40597695E-10_JPRB, 0.40055102E-10_JPRB, &
  & 0.39499765E-10_JPRB, 0.38959211E-10_JPRB, 0.38436636E-10_JPRB, 0.37962126E-10_JPRB, 0.37548274E-10_JPRB, 0.37203577E-10_JPRB, &
  & 0.36930826E-10_JPRB, 0.36724818E-10_JPRB, 0.36572897E-10_JPRB, 0.36461216E-10_JPRB /)

RGHG8(:, 8, 6) = (/ &
  & 0.43170568E-10_JPRB, 0.42409149E-10_JPRB, 0.42347997E-10_JPRB, 0.42605128E-10_JPRB, 0.43079325E-10_JPRB, 0.43732348E-10_JPRB, &
  & 0.44490737E-10_JPRB, 0.45368476E-10_JPRB, 0.46321339E-10_JPRB, 0.47345738E-10_JPRB, 0.48430385E-10_JPRB, 0.49545514E-10_JPRB, &
  & 0.50651053E-10_JPRB, 0.51701591E-10_JPRB, 0.52661212E-10_JPRB, 0.53491964E-10_JPRB, 0.54191183E-10_JPRB, 0.54770539E-10_JPRB, &
  & 0.55241381E-10_JPRB, 0.55624214E-10_JPRB, 0.55940114E-10_JPRB, 0.56192904E-10_JPRB, 0.56395857E-10_JPRB, 0.56554504E-10_JPRB, &
  & 0.56647874E-10_JPRB, 0.56654376E-10_JPRB, 0.56548984E-10_JPRB, 0.56300006E-10_JPRB, 0.55881501E-10_JPRB, 0.55283389E-10_JPRB, &
  & 0.54525759E-10_JPRB, 0.53672303E-10_JPRB, 0.52815460E-10_JPRB, 0.52029707E-10_JPRB, 0.51368521E-10_JPRB, 0.50837883E-10_JPRB, &
  & 0.50417229E-10_JPRB, 0.50067221E-10_JPRB, 0.49743116E-10_JPRB, 0.49400518E-10_JPRB, 0.49009932E-10_JPRB, 0.48557450E-10_JPRB, &
  & 0.48038008E-10_JPRB, 0.47459842E-10_JPRB, 0.46828579E-10_JPRB, 0.46153619E-10_JPRB, 0.45443455E-10_JPRB, 0.44705309E-10_JPRB, &
  & 0.43946690E-10_JPRB, 0.43181059E-10_JPRB, 0.42420518E-10_JPRB, 0.41674955E-10_JPRB, 0.40950087E-10_JPRB, 0.40248437E-10_JPRB, &
  & 0.39582303E-10_JPRB, 0.38958777E-10_JPRB, 0.38388091E-10_JPRB, 0.37901651E-10_JPRB, 0.37496107E-10_JPRB, 0.37165753E-10_JPRB, &
  & 0.36902925E-10_JPRB, 0.36694196E-10_JPRB, 0.36514899E-10_JPRB, 0.36317338E-10_JPRB /)

RGHG8(:, 9, 6) = (/ &
  & 0.41284410E-10_JPRB, 0.40623192E-10_JPRB, 0.40699916E-10_JPRB, 0.41029003E-10_JPRB, 0.41536524E-10_JPRB, 0.42151949E-10_JPRB, &
  & 0.42925920E-10_JPRB, 0.43791658E-10_JPRB, 0.44778698E-10_JPRB, 0.45841303E-10_JPRB, 0.46961688E-10_JPRB, 0.48110960E-10_JPRB, &
  & 0.49251554E-10_JPRB, 0.50345009E-10_JPRB, 0.51357776E-10_JPRB, 0.52271350E-10_JPRB, 0.53065760E-10_JPRB, 0.53749147E-10_JPRB, &
  & 0.54343564E-10_JPRB, 0.54867846E-10_JPRB, 0.55349392E-10_JPRB, 0.55828495E-10_JPRB, 0.56290608E-10_JPRB, 0.56727130E-10_JPRB, &
  & 0.57159628E-10_JPRB, 0.57542287E-10_JPRB, 0.57810458E-10_JPRB, 0.57910485E-10_JPRB, 0.57808366E-10_JPRB, 0.57495390E-10_JPRB, &
  & 0.57003156E-10_JPRB, 0.56401616E-10_JPRB, 0.55778483E-10_JPRB, 0.55215658E-10_JPRB, 0.54759367E-10_JPRB, 0.54420499E-10_JPRB, &
  & 0.54175133E-10_JPRB, 0.53979345E-10_JPRB, 0.53778405E-10_JPRB, 0.53517885E-10_JPRB, 0.53158554E-10_JPRB, 0.52677206E-10_JPRB, &
  & 0.52068169E-10_JPRB, 0.51332581E-10_JPRB, 0.50481602E-10_JPRB, 0.49532003E-10_JPRB, 0.48505318E-10_JPRB, 0.47419967E-10_JPRB, &
  & 0.46298201E-10_JPRB, 0.45162731E-10_JPRB, 0.44042592E-10_JPRB, 0.42961999E-10_JPRB, 0.41945745E-10_JPRB, 0.41011673E-10_JPRB, &
  & 0.40172747E-10_JPRB, 0.39434758E-10_JPRB, 0.38809428E-10_JPRB, 0.38323567E-10_JPRB, 0.37954320E-10_JPRB, 0.37683381E-10_JPRB, &
  & 0.37491170E-10_JPRB, 0.37357097E-10_JPRB, 0.37253745E-10_JPRB, 0.37148562E-10_JPRB /)

RGHG8(:,10, 6) = (/ &
  & 0.40016681E-10_JPRB, 0.40237338E-10_JPRB, 0.40596554E-10_JPRB, 0.41008270E-10_JPRB, 0.41453573E-10_JPRB, 0.41988555E-10_JPRB, &
  & 0.42572782E-10_JPRB, 0.43283412E-10_JPRB, 0.44069064E-10_JPRB, 0.44935243E-10_JPRB, 0.45849064E-10_JPRB, 0.46785978E-10_JPRB, &
  & 0.47730046E-10_JPRB, 0.48661276E-10_JPRB, 0.49565699E-10_JPRB, 0.50435770E-10_JPRB, 0.51266762E-10_JPRB, 0.52055169E-10_JPRB, &
  & 0.52817178E-10_JPRB, 0.53580987E-10_JPRB, 0.54375688E-10_JPRB, 0.55212369E-10_JPRB, 0.56130118E-10_JPRB, 0.57117148E-10_JPRB, &
  & 0.58049576E-10_JPRB, 0.58887679E-10_JPRB, 0.59602587E-10_JPRB, 0.60182428E-10_JPRB, 0.60614791E-10_JPRB, 0.60892819E-10_JPRB, &
  & 0.61017406E-10_JPRB, 0.61017573E-10_JPRB, 0.60947372E-10_JPRB, 0.60863453E-10_JPRB, 0.60802585E-10_JPRB, 0.60767447E-10_JPRB, &
  & 0.60732280E-10_JPRB, 0.60652747E-10_JPRB, 0.60478032E-10_JPRB, 0.60158781E-10_JPRB, 0.59665321E-10_JPRB, 0.58990160E-10_JPRB, &
  & 0.58130771E-10_JPRB, 0.57099242E-10_JPRB, 0.55908712E-10_JPRB, 0.54583050E-10_JPRB, 0.53143163E-10_JPRB, 0.51620305E-10_JPRB, &
  & 0.50042429E-10_JPRB, 0.48457856E-10_JPRB, 0.46911235E-10_JPRB, 0.45442511E-10_JPRB, 0.44082030E-10_JPRB, 0.42857294E-10_JPRB, &
  & 0.41788323E-10_JPRB, 0.40884997E-10_JPRB, 0.40165642E-10_JPRB, 0.39646061E-10_JPRB, 0.39285752E-10_JPRB, 0.39050405E-10_JPRB, &
  & 0.38910847E-10_JPRB, 0.38840972E-10_JPRB, 0.38834887E-10_JPRB, 0.38895089E-10_JPRB /)

RGHG8(:,11, 6) = (/ &
  & 0.40403209E-10_JPRB, 0.41174383E-10_JPRB, 0.41630213E-10_JPRB, 0.42020418E-10_JPRB, 0.42419887E-10_JPRB, 0.42833251E-10_JPRB, &
  & 0.43344585E-10_JPRB, 0.43930481E-10_JPRB, 0.44645038E-10_JPRB, 0.45457596E-10_JPRB, 0.46361956E-10_JPRB, 0.47335014E-10_JPRB, &
  & 0.48348107E-10_JPRB, 0.49374047E-10_JPRB, 0.50373514E-10_JPRB, 0.51315941E-10_JPRB, 0.52183861E-10_JPRB, 0.52989772E-10_JPRB, &
  & 0.53776053E-10_JPRB, 0.54595613E-10_JPRB, 0.55508612E-10_JPRB, 0.56560603E-10_JPRB, 0.57722778E-10_JPRB, 0.58920174E-10_JPRB, &
  & 0.60126008E-10_JPRB, 0.61302269E-10_JPRB, 0.62459996E-10_JPRB, 0.63582146E-10_JPRB, 0.64668153E-10_JPRB, 0.65735598E-10_JPRB, &
  & 0.66780324E-10_JPRB, 0.67770879E-10_JPRB, 0.68661951E-10_JPRB, 0.69402692E-10_JPRB, 0.69967671E-10_JPRB, 0.70334814E-10_JPRB, &
  & 0.70480240E-10_JPRB, 0.70383172E-10_JPRB, 0.70033881E-10_JPRB, 0.69426478E-10_JPRB, 0.68572974E-10_JPRB, 0.67495551E-10_JPRB, &
  & 0.66210371E-10_JPRB, 0.64736105E-10_JPRB, 0.63084274E-10_JPRB, 0.61274145E-10_JPRB, 0.59337334E-10_JPRB, 0.57314518E-10_JPRB, &
  & 0.55264612E-10_JPRB, 0.53239673E-10_JPRB, 0.51292009E-10_JPRB, 0.49458583E-10_JPRB, 0.47782989E-10_JPRB, 0.46299048E-10_JPRB, &
  & 0.45027811E-10_JPRB, 0.43980406E-10_JPRB, 0.43168004E-10_JPRB, 0.42599268E-10_JPRB, 0.42225133E-10_JPRB, 0.42004417E-10_JPRB, &
  & 0.41904046E-10_JPRB, 0.41900421E-10_JPRB, 0.42007144E-10_JPRB, 0.42321036E-10_JPRB /)

RGHG8(:,12, 6) = (/ &
  & 0.43214810E-10_JPRB, 0.44567978E-10_JPRB, 0.45243805E-10_JPRB, 0.45742923E-10_JPRB, 0.46179765E-10_JPRB, 0.46671583E-10_JPRB, &
  & 0.47251654E-10_JPRB, 0.48059633E-10_JPRB, 0.49111316E-10_JPRB, 0.50477209E-10_JPRB, 0.52136399E-10_JPRB, 0.54044096E-10_JPRB, &
  & 0.56104940E-10_JPRB, 0.58173594E-10_JPRB, 0.60087768E-10_JPRB, 0.61688876E-10_JPRB, 0.62861008E-10_JPRB, 0.63578746E-10_JPRB, &
  & 0.63899837E-10_JPRB, 0.63962446E-10_JPRB, 0.63955653E-10_JPRB, 0.64043625E-10_JPRB, 0.64320313E-10_JPRB, 0.64822023E-10_JPRB, &
  & 0.65520381E-10_JPRB, 0.66382289E-10_JPRB, 0.67400384E-10_JPRB, 0.68639372E-10_JPRB, 0.70146493E-10_JPRB, 0.71884693E-10_JPRB, &
  & 0.73830136E-10_JPRB, 0.75871871E-10_JPRB, 0.77786347E-10_JPRB, 0.79432003E-10_JPRB, 0.80711535E-10_JPRB, 0.81538866E-10_JPRB, &
  & 0.81884680E-10_JPRB, 0.81759731E-10_JPRB, 0.81200886E-10_JPRB, 0.80253984E-10_JPRB, 0.78978400E-10_JPRB, 0.77436640E-10_JPRB, &
  & 0.75670921E-10_JPRB, 0.73712446E-10_JPRB, 0.71586230E-10_JPRB, 0.69322451E-10_JPRB, 0.66958550E-10_JPRB, 0.64549241E-10_JPRB, &
  & 0.62138412E-10_JPRB, 0.59777606E-10_JPRB, 0.57516193E-10_JPRB, 0.55404889E-10_JPRB, 0.53489040E-10_JPRB, 0.51802458E-10_JPRB, &
  & 0.50364022E-10_JPRB, 0.49184337E-10_JPRB, 0.48273979E-10_JPRB, 0.47641779E-10_JPRB, 0.47236794E-10_JPRB, 0.47018976E-10_JPRB, &
  & 0.46957764E-10_JPRB, 0.47040167E-10_JPRB, 0.47316942E-10_JPRB, 0.48086746E-10_JPRB /)

RGHG8(:,13, 6) = (/ &
  & 0.50138515E-10_JPRB, 0.51875119E-10_JPRB, 0.52686282E-10_JPRB, 0.53249065E-10_JPRB, 0.53772452E-10_JPRB, 0.54357518E-10_JPRB, &
  & 0.55167121E-10_JPRB, 0.56274985E-10_JPRB, 0.57837984E-10_JPRB, 0.59868735E-10_JPRB, 0.62344158E-10_JPRB, 0.65135293E-10_JPRB, &
  & 0.68049191E-10_JPRB, 0.70869054E-10_JPRB, 0.73363295E-10_JPRB, 0.75336674E-10_JPRB, 0.76639931E-10_JPRB, 0.77235211E-10_JPRB, &
  & 0.77178562E-10_JPRB, 0.76616803E-10_JPRB, 0.75759100E-10_JPRB, 0.74850112E-10_JPRB, 0.74117310E-10_JPRB, 0.73665685E-10_JPRB, &
  & 0.73544171E-10_JPRB, 0.73786317E-10_JPRB, 0.74443778E-10_JPRB, 0.75528292E-10_JPRB, 0.77100618E-10_JPRB, 0.79233460E-10_JPRB, &
  & 0.81778279E-10_JPRB, 0.84472589E-10_JPRB, 0.87099140E-10_JPRB, 0.89381898E-10_JPRB, 0.91108121E-10_JPRB, 0.92258860E-10_JPRB, &
  & 0.92812542E-10_JPRB, 0.92764442E-10_JPRB, 0.92157414E-10_JPRB, 0.91061915E-10_JPRB, 0.89557951E-10_JPRB, 0.87728741E-10_JPRB, &
  & 0.85644790E-10_JPRB, 0.83356252E-10_JPRB, 0.80902604E-10_JPRB, 0.78328240E-10_JPRB, 0.75686263E-10_JPRB, 0.73029069E-10_JPRB, &
  & 0.70418033E-10_JPRB, 0.67915139E-10_JPRB, 0.65569654E-10_JPRB, 0.63411623E-10_JPRB, 0.61464035E-10_JPRB, 0.59745771E-10_JPRB, &
  & 0.58271186E-10_JPRB, 0.57052446E-10_JPRB, 0.56107920E-10_JPRB, 0.55455647E-10_JPRB, 0.55058891E-10_JPRB, 0.54891109E-10_JPRB, &
  & 0.54936160E-10_JPRB, 0.55207026E-10_JPRB, 0.55847191E-10_JPRB, 0.57460592E-10_JPRB /)

RGHG8(:,14, 6) = (/ &
  & 0.60639556E-10_JPRB, 0.61828334E-10_JPRB, 0.62402861E-10_JPRB, 0.62813713E-10_JPRB, 0.63244673E-10_JPRB, 0.63822232E-10_JPRB, &
  & 0.64652894E-10_JPRB, 0.65899078E-10_JPRB, 0.67635023E-10_JPRB, 0.69921485E-10_JPRB, 0.72676240E-10_JPRB, 0.75738513E-10_JPRB, &
  & 0.78871694E-10_JPRB, 0.81813611E-10_JPRB, 0.84336108E-10_JPRB, 0.86247523E-10_JPRB, 0.87423381E-10_JPRB, 0.87845307E-10_JPRB, &
  & 0.87605957E-10_JPRB, 0.86873932E-10_JPRB, 0.85862581E-10_JPRB, 0.84801888E-10_JPRB, 0.83864499E-10_JPRB, 0.83190121E-10_JPRB, &
  & 0.82833088E-10_JPRB, 0.82836918E-10_JPRB, 0.83260530E-10_JPRB, 0.84235077E-10_JPRB, 0.85826818E-10_JPRB, 0.87996048E-10_JPRB, &
  & 0.90588925E-10_JPRB, 0.93420292E-10_JPRB, 0.96156423E-10_JPRB, 0.98561534E-10_JPRB, 0.10054456E-09_JPRB, 0.10188179E-09_JPRB, &
  & 0.10252964E-09_JPRB, 0.10255441E-09_JPRB, 0.10201597E-09_JPRB, 0.10096408E-09_JPRB, 0.99467642E-10_JPRB, 0.97611391E-10_JPRB, &
  & 0.95460993E-10_JPRB, 0.93077254E-10_JPRB, 0.90518038E-10_JPRB, 0.87847757E-10_JPRB, 0.85132672E-10_JPRB, 0.82448333E-10_JPRB, &
  & 0.79872886E-10_JPRB, 0.77457991E-10_JPRB, 0.75230995E-10_JPRB, 0.73201015E-10_JPRB, 0.71376335E-10_JPRB, 0.69764639E-10_JPRB, &
  & 0.68376693E-10_JPRB, 0.67230541E-10_JPRB, 0.66351757E-10_JPRB, 0.65775871E-10_JPRB, 0.65481807E-10_JPRB, 0.65458312E-10_JPRB, &
  & 0.65711964E-10_JPRB, 0.66262454E-10_JPRB, 0.67392238E-10_JPRB, 0.69876209E-10_JPRB /)

RGHG8(:,15, 6) = (/ &
  & 0.72786131E-10_JPRB, 0.72978706E-10_JPRB, 0.73040393E-10_JPRB, 0.73127150E-10_JPRB, 0.73300435E-10_JPRB, 0.73668356E-10_JPRB, &
  & 0.74340624E-10_JPRB, 0.75441625E-10_JPRB, 0.77068921E-10_JPRB, 0.79245603E-10_JPRB, 0.81913518E-10_JPRB, 0.84879208E-10_JPRB, &
  & 0.87901679E-10_JPRB, 0.90715553E-10_JPRB, 0.93080120E-10_JPRB, 0.94860599E-10_JPRB, 0.95994608E-10_JPRB, 0.96501189E-10_JPRB, &
  & 0.96487394E-10_JPRB, 0.96101883E-10_JPRB, 0.95500663E-10_JPRB, 0.94844632E-10_JPRB, 0.94266692E-10_JPRB, 0.93855881E-10_JPRB, &
  & 0.93684803E-10_JPRB, 0.93820327E-10_JPRB, 0.94325076E-10_JPRB, 0.95246214E-10_JPRB, 0.96640987E-10_JPRB, 0.98516306E-10_JPRB, &
  & 0.10087687E-09_JPRB, 0.10335852E-09_JPRB, 0.10573132E-09_JPRB, 0.10777894E-09_JPRB, 0.10930713E-09_JPRB, 0.11039096E-09_JPRB, &
  & 0.11102282E-09_JPRB, 0.11111267E-09_JPRB, 0.11068987E-09_JPRB, 0.10980927E-09_JPRB, 0.10851071E-09_JPRB, 0.10684069E-09_JPRB, &
  & 0.10485538E-09_JPRB, 0.10261234E-09_JPRB, 0.10017871E-09_JPRB, 0.97627184E-10_JPRB, 0.95039948E-10_JPRB, 0.92513074E-10_JPRB, &
  & 0.90114680E-10_JPRB, 0.87882812E-10_JPRB, 0.85829496E-10_JPRB, 0.83959117E-10_JPRB, 0.82276373E-10_JPRB, 0.80788681E-10_JPRB, &
  & 0.79512869E-10_JPRB, 0.78473152E-10_JPRB, 0.77707563E-10_JPRB, 0.77258484E-10_JPRB, 0.77114953E-10_JPRB, 0.77273847E-10_JPRB, &
  & 0.77749945E-10_JPRB, 0.78544657E-10_JPRB, 0.80045366E-10_JPRB, 0.83028140E-10_JPRB /)

RGHG8(:,16, 6) = (/ &
  & 0.84536336E-10_JPRB, 0.84094662E-10_JPRB, 0.83650163E-10_JPRB, 0.83407982E-10_JPRB, 0.83278710E-10_JPRB, 0.83370519E-10_JPRB, &
  & 0.83761477E-10_JPRB, 0.84576783E-10_JPRB, 0.85905297E-10_JPRB, 0.87785154E-10_JPRB, 0.90162718E-10_JPRB, 0.92875589E-10_JPRB, &
  & 0.95690685E-10_JPRB, 0.98384058E-10_JPRB, 0.10073427E-09_JPRB, 0.10258332E-09_JPRB, 0.10392383E-09_JPRB, 0.10481056E-09_JPRB, &
  & 0.10533119E-09_JPRB, 0.10560757E-09_JPRB, 0.10575286E-09_JPRB, 0.10585832E-09_JPRB, 0.10599864E-09_JPRB, 0.10623678E-09_JPRB, &
  & 0.10661859E-09_JPRB, 0.10719296E-09_JPRB, 0.10799638E-09_JPRB, 0.10906595E-09_JPRB, 0.11038104E-09_JPRB, 0.11186324E-09_JPRB, &
  & 0.11330283E-09_JPRB, 0.11470176E-09_JPRB, 0.11597712E-09_JPRB, 0.11704909E-09_JPRB, 0.11789611E-09_JPRB, 0.11843700E-09_JPRB, &
  & 0.11865386E-09_JPRB, 0.11864976E-09_JPRB, 0.11836269E-09_JPRB, 0.11773592E-09_JPRB, 0.11675505E-09_JPRB, 0.11542763E-09_JPRB, &
  & 0.11377524E-09_JPRB, 0.11184546E-09_JPRB, 0.10969607E-09_JPRB, 0.10740826E-09_JPRB, 0.10508502E-09_JPRB, 0.10279907E-09_JPRB, &
  & 0.10060422E-09_JPRB, 0.98532515E-10_JPRB, 0.96609082E-10_JPRB, 0.94843196E-10_JPRB, 0.93245113E-10_JPRB, 0.91831848E-10_JPRB, &
  & 0.90629837E-10_JPRB, 0.89671569E-10_JPRB, 0.88998031E-10_JPRB, 0.88653702E-10_JPRB, 0.88629604E-10_JPRB, 0.88914029E-10_JPRB, &
  & 0.89513119E-10_JPRB, 0.90427235E-10_JPRB, 0.92025255E-10_JPRB, 0.95056928E-10_JPRB /)

RGHG8(:,17, 6) = (/ &
  & 0.95015162E-10_JPRB, 0.94119094E-10_JPRB, 0.93360021E-10_JPRB, 0.92886990E-10_JPRB, 0.92543612E-10_JPRB, 0.92399699E-10_JPRB, &
  & 0.92535452E-10_JPRB, 0.93058332E-10_JPRB, 0.94062251E-10_JPRB, 0.95593096E-10_JPRB, 0.97639070E-10_JPRB, 0.10005795E-09_JPRB, &
  & 0.10265930E-09_JPRB, 0.10524000E-09_JPRB, 0.10765323E-09_JPRB, 0.10976080E-09_JPRB, 0.11149083E-09_JPRB, 0.11289823E-09_JPRB, &
  & 0.11408349E-09_JPRB, 0.11512900E-09_JPRB, 0.11610703E-09_JPRB, 0.11707718E-09_JPRB, 0.11808528E-09_JPRB, 0.11916795E-09_JPRB, &
  & 0.12032900E-09_JPRB, 0.12154894E-09_JPRB, 0.12275095E-09_JPRB, 0.12385376E-09_JPRB, 0.12474850E-09_JPRB, 0.12543939E-09_JPRB, &
  & 0.12586783E-09_JPRB, 0.12607052E-09_JPRB, 0.12608793E-09_JPRB, 0.12598717E-09_JPRB, 0.12584048E-09_JPRB, 0.12572499E-09_JPRB, &
  & 0.12564208E-09_JPRB, 0.12550075E-09_JPRB, 0.12526985E-09_JPRB, 0.12488505E-09_JPRB, 0.12425741E-09_JPRB, 0.12333201E-09_JPRB, &
  & 0.12208819E-09_JPRB, 0.12054802E-09_JPRB, 0.11875734E-09_JPRB, 0.11680559E-09_JPRB, 0.11477326E-09_JPRB, 0.11272118E-09_JPRB, &
  & 0.11069416E-09_JPRB, 0.10873739E-09_JPRB, 0.10688452E-09_JPRB, 0.10515993E-09_JPRB, 0.10358769E-09_JPRB, 0.10219911E-09_JPRB, &
  & 0.10102831E-09_JPRB, 0.10011037E-09_JPRB, 0.99484435E-10_JPRB, 0.99187748E-10_JPRB, 0.99204547E-10_JPRB, 0.99516409E-10_JPRB, &
  & 0.10011084E-09_JPRB, 0.10101001E-09_JPRB, 0.10243957E-09_JPRB, 0.10521092E-09_JPRB /)

RGHG8(:,18, 6) = (/ &
  & 0.10386805E-09_JPRB, 0.10267363E-09_JPRB, 0.10184426E-09_JPRB, 0.10124221E-09_JPRB, 0.10078428E-09_JPRB, 0.10049162E-09_JPRB, &
  & 0.10044408E-09_JPRB, 0.10073990E-09_JPRB, 0.10146514E-09_JPRB, 0.10270301E-09_JPRB, 0.10443717E-09_JPRB, 0.10658278E-09_JPRB, &
  & 0.10899705E-09_JPRB, 0.11150370E-09_JPRB, 0.11394246E-09_JPRB, 0.11622935E-09_JPRB, 0.11831994E-09_JPRB, 0.12019788E-09_JPRB, &
  & 0.12190093E-09_JPRB, 0.12350121E-09_JPRB, 0.12506128E-09_JPRB, 0.12663119E-09_JPRB, 0.12824491E-09_JPRB, 0.12991570E-09_JPRB, &
  & 0.13160227E-09_JPRB, 0.13320531E-09_JPRB, 0.13461579E-09_JPRB, 0.13571613E-09_JPRB, 0.13639935E-09_JPRB, 0.13661837E-09_JPRB, &
  & 0.13639000E-09_JPRB, 0.13580198E-09_JPRB, 0.13495136E-09_JPRB, 0.13399012E-09_JPRB, 0.13305515E-09_JPRB, 0.13229629E-09_JPRB, &
  & 0.13179230E-09_JPRB, 0.13154312E-09_JPRB, 0.13141400E-09_JPRB, 0.13126927E-09_JPRB, 0.13097018E-09_JPRB, 0.13041397E-09_JPRB, &
  & 0.12955532E-09_JPRB, 0.12839209E-09_JPRB, 0.12696547E-09_JPRB, 0.12533868E-09_JPRB, 0.12357426E-09_JPRB, 0.12170867E-09_JPRB, &
  & 0.11981388E-09_JPRB, 0.11794814E-09_JPRB, 0.11614910E-09_JPRB, 0.11444577E-09_JPRB, 0.11287823E-09_JPRB, 0.11149080E-09_JPRB, &
  & 0.11032390E-09_JPRB, 0.10941426E-09_JPRB, 0.10879175E-09_JPRB, 0.10848317E-09_JPRB, 0.10846721E-09_JPRB, 0.10871966E-09_JPRB, &
  & 0.10922067E-09_JPRB, 0.10998255E-09_JPRB, 0.11112433E-09_JPRB, 0.11348171E-09_JPRB /)

RGHG8(:,19, 6) = (/ &
  & 0.11125761E-09_JPRB, 0.10995967E-09_JPRB, 0.10914832E-09_JPRB, 0.10852576E-09_JPRB, 0.10802201E-09_JPRB, 0.10765643E-09_JPRB, &
  & 0.10748977E-09_JPRB, 0.10761489E-09_JPRB, 0.10813412E-09_JPRB, 0.10912639E-09_JPRB, 0.11059656E-09_JPRB, 0.11247887E-09_JPRB, &
  & 0.11466822E-09_JPRB, 0.11704877E-09_JPRB, 0.11949083E-09_JPRB, 0.12186871E-09_JPRB, 0.12411017E-09_JPRB, 0.12619632E-09_JPRB, &
  & 0.12813806E-09_JPRB, 0.12997586E-09_JPRB, 0.13177635E-09_JPRB, 0.13359680E-09_JPRB, 0.13546866E-09_JPRB, 0.13739102E-09_JPRB, &
  & 0.13930168E-09_JPRB, 0.14109125E-09_JPRB, 0.14261532E-09_JPRB, 0.14372592E-09_JPRB, 0.14434048E-09_JPRB, 0.14442472E-09_JPRB, &
  & 0.14401692E-09_JPRB, 0.14317460E-09_JPRB, 0.14200460E-09_JPRB, 0.14068298E-09_JPRB, 0.13939465E-09_JPRB, 0.13830634E-09_JPRB, &
  & 0.13756099E-09_JPRB, 0.13716479E-09_JPRB, 0.13704077E-09_JPRB, 0.13701448E-09_JPRB, 0.13691752E-09_JPRB, 0.13662127E-09_JPRB, &
  & 0.13604587E-09_JPRB, 0.13517350E-09_JPRB, 0.13402883E-09_JPRB, 0.13265500E-09_JPRB, 0.13108836E-09_JPRB, 0.12939437E-09_JPRB, &
  & 0.12764206E-09_JPRB, 0.12588283E-09_JPRB, 0.12414751E-09_JPRB, 0.12247903E-09_JPRB, 0.12093067E-09_JPRB, 0.11955151E-09_JPRB, &
  & 0.11838663E-09_JPRB, 0.11747123E-09_JPRB, 0.11682809E-09_JPRB, 0.11647237E-09_JPRB, 0.11637856E-09_JPRB, 0.11651966E-09_JPRB, &
  & 0.11687243E-09_JPRB, 0.11743796E-09_JPRB, 0.11829875E-09_JPRB, 0.12015025E-09_JPRB /)

RGHG8(:,20, 6) = (/ &
  & 0.11747180E-09_JPRB, 0.11620031E-09_JPRB, 0.11545861E-09_JPRB, 0.11487063E-09_JPRB, 0.11437867E-09_JPRB, 0.11398983E-09_JPRB, &
  & 0.11376024E-09_JPRB, 0.11377742E-09_JPRB, 0.11414970E-09_JPRB, 0.11494822E-09_JPRB, 0.11618823E-09_JPRB, 0.11783148E-09_JPRB, &
  & 0.11979641E-09_JPRB, 0.12197465E-09_JPRB, 0.12426750E-09_JPRB, 0.12657562E-09_JPRB, 0.12880920E-09_JPRB, 0.13091302E-09_JPRB, &
  & 0.13288921E-09_JPRB, 0.13476943E-09_JPRB, 0.13660155E-09_JPRB, 0.13844580E-09_JPRB, 0.14034135E-09_JPRB, 0.14229078E-09_JPRB, &
  & 0.14423869E-09_JPRB, 0.14606003E-09_JPRB, 0.14761312E-09_JPRB, 0.14876246E-09_JPRB, 0.14943667E-09_JPRB, 0.14960938E-09_JPRB, &
  & 0.14930598E-09_JPRB, 0.14856005E-09_JPRB, 0.14745850E-09_JPRB, 0.14614882E-09_JPRB, 0.14481499E-09_JPRB, 0.14365457E-09_JPRB, &
  & 0.14281580E-09_JPRB, 0.14234752E-09_JPRB, 0.14218744E-09_JPRB, 0.14217141E-09_JPRB, 0.14213439E-09_JPRB, 0.14193778E-09_JPRB, &
  & 0.14150273E-09_JPRB, 0.14079830E-09_JPRB, 0.13982450E-09_JPRB, 0.13860507E-09_JPRB, 0.13719115E-09_JPRB, 0.13564962E-09_JPRB, &
  & 0.13403330E-09_JPRB, 0.13237758E-09_JPRB, 0.13072314E-09_JPRB, 0.12913003E-09_JPRB, 0.12764283E-09_JPRB, 0.12631174E-09_JPRB, &
  & 0.12517880E-09_JPRB, 0.12427452E-09_JPRB, 0.12361477E-09_JPRB, 0.12320764E-09_JPRB, 0.12302651E-09_JPRB, 0.12304444E-09_JPRB, &
  & 0.12324099E-09_JPRB, 0.12361312E-09_JPRB, 0.12422192E-09_JPRB, 0.12554063E-09_JPRB /)

RGHG8(:,21, 6) = (/ &
  & 0.12280750E-09_JPRB, 0.12162543E-09_JPRB, 0.12096092E-09_JPRB, 0.12043073E-09_JPRB, 0.11997743E-09_JPRB, 0.11960348E-09_JPRB, &
  & 0.11935473E-09_JPRB, 0.11932318E-09_JPRB, 0.11960075E-09_JPRB, 0.12025088E-09_JPRB, 0.12129732E-09_JPRB, 0.12271767E-09_JPRB, &
  & 0.12444812E-09_JPRB, 0.12640872E-09_JPRB, 0.12850089E-09_JPRB, 0.13063152E-09_JPRB, 0.13272433E-09_JPRB, 0.13472654E-09_JPRB, &
  & 0.13661591E-09_JPRB, 0.13841824E-09_JPRB, 0.14017806E-09_JPRB, 0.14194476E-09_JPRB, 0.14376181E-09_JPRB, 0.14563822E-09_JPRB, &
  & 0.14751461E-09_JPRB, 0.14929810E-09_JPRB, 0.15084270E-09_JPRB, 0.15202563E-09_JPRB, 0.15279249E-09_JPRB, 0.15312687E-09_JPRB, &
  & 0.15303422E-09_JPRB, 0.15253794E-09_JPRB, 0.15170376E-09_JPRB, 0.15063181E-09_JPRB, 0.14949009E-09_JPRB, 0.14844297E-09_JPRB, &
  & 0.14763853E-09_JPRB, 0.14714385E-09_JPRB, 0.14688940E-09_JPRB, 0.14679388E-09_JPRB, 0.14668956E-09_JPRB, 0.14646243E-09_JPRB, &
  & 0.14602483E-09_JPRB, 0.14534797E-09_JPRB, 0.14443269E-09_JPRB, 0.14330710E-09_JPRB, 0.14201537E-09_JPRB, 0.14060279E-09_JPRB, &
  & 0.13909895E-09_JPRB, 0.13754645E-09_JPRB, 0.13600807E-09_JPRB, 0.13451920E-09_JPRB, 0.13312859E-09_JPRB, 0.13188402E-09_JPRB, &
  & 0.13081680E-09_JPRB, 0.12994608E-09_JPRB, 0.12928288E-09_JPRB, 0.12883269E-09_JPRB, 0.12857333E-09_JPRB, 0.12848080E-09_JPRB, &
  & 0.12853456E-09_JPRB, 0.12872910E-09_JPRB, 0.12910231E-09_JPRB, 0.12998658E-09_JPRB /)

RGHG8(:,22, 6) = (/ &
  & 0.12738428E-09_JPRB, 0.12634675E-09_JPRB, 0.12577044E-09_JPRB, 0.12531180E-09_JPRB, 0.12491638E-09_JPRB, 0.12458537E-09_JPRB, &
  & 0.12436541E-09_JPRB, 0.12433056E-09_JPRB, 0.12456407E-09_JPRB, 0.12512709E-09_JPRB, 0.12604047E-09_JPRB, 0.12728539E-09_JPRB, &
  & 0.12881371E-09_JPRB, 0.13055124E-09_JPRB, 0.13242260E-09_JPRB, 0.13434538E-09_JPRB, 0.13624558E-09_JPRB, 0.13807643E-09_JPRB, &
  & 0.13982689E-09_JPRB, 0.14150647E-09_JPRB, 0.14315174E-09_JPRB, 0.14480517E-09_JPRB, 0.14649384E-09_JPRB, 0.14822402E-09_JPRB, &
  & 0.14996693E-09_JPRB, 0.15162670E-09_JPRB, 0.15309884E-09_JPRB, 0.15429598E-09_JPRB, 0.15514509E-09_JPRB, 0.15562816E-09_JPRB, &
  & 0.15575172E-09_JPRB, 0.15553406E-09_JPRB, 0.15501897E-09_JPRB, 0.15428395E-09_JPRB, 0.15344252E-09_JPRB, 0.15263657E-09_JPRB, &
  & 0.15194579E-09_JPRB, 0.15144902E-09_JPRB, 0.15112418E-09_JPRB, 0.15088757E-09_JPRB, 0.15064057E-09_JPRB, 0.15029659E-09_JPRB, &
  & 0.14978987E-09_JPRB, 0.14908094E-09_JPRB, 0.14817070E-09_JPRB, 0.14708487E-09_JPRB, 0.14585685E-09_JPRB, 0.14451298E-09_JPRB, &
  & 0.14309771E-09_JPRB, 0.14166580E-09_JPRB, 0.14024497E-09_JPRB, 0.13887620E-09_JPRB, 0.13760884E-09_JPRB, 0.13647271E-09_JPRB, &
  & 0.13548739E-09_JPRB, 0.13466321E-09_JPRB, 0.13400603E-09_JPRB, 0.13352133E-09_JPRB, 0.13319562E-09_JPRB, 0.13301164E-09_JPRB, &
  & 0.13295254E-09_JPRB, 0.13300876E-09_JPRB, 0.13319924E-09_JPRB, 0.13372575E-09_JPRB /)

RGHG8(:,23, 6) = (/ &
  & 0.13134756E-09_JPRB, 0.13045620E-09_JPRB, 0.12997659E-09_JPRB, 0.12959782E-09_JPRB, 0.12927755E-09_JPRB, 0.12901757E-09_JPRB, &
  & 0.12885559E-09_JPRB, 0.12886049E-09_JPRB, 0.12910363E-09_JPRB, 0.12963600E-09_JPRB, 0.13047652E-09_JPRB, 0.13160967E-09_JPRB, &
  & 0.13299040E-09_JPRB, 0.13455628E-09_JPRB, 0.13623469E-09_JPRB, 0.13795716E-09_JPRB, 0.13966682E-09_JPRB, 0.14132391E-09_JPRB, &
  & 0.14291215E-09_JPRB, 0.14444801E-09_JPRB, 0.14594893E-09_JPRB, 0.14743823E-09_JPRB, 0.14895031E-09_JPRB, 0.15049426E-09_JPRB, &
  & 0.15204007E-09_JPRB, 0.15353832E-09_JPRB, 0.15489490E-09_JPRB, 0.15602378E-09_JPRB, 0.15689849E-09_JPRB, 0.15749024E-09_JPRB, &
  & 0.15779114E-09_JPRB, 0.15781532E-09_JPRB, 0.15759309E-09_JPRB, 0.15718249E-09_JPRB, 0.15664665E-09_JPRB, 0.15609786E-09_JPRB, &
  & 0.15556950E-09_JPRB, 0.15511242E-09_JPRB, 0.15472071E-09_JPRB, 0.15434815E-09_JPRB, 0.15394432E-09_JPRB, 0.15344996E-09_JPRB, &
  & 0.15282740E-09_JPRB, 0.15205684E-09_JPRB, 0.15112918E-09_JPRB, 0.15005217E-09_JPRB, 0.14884684E-09_JPRB, 0.14755976E-09_JPRB, &
  & 0.14624053E-09_JPRB, 0.14491595E-09_JPRB, 0.14362177E-09_JPRB, 0.14239969E-09_JPRB, 0.14126854E-09_JPRB, 0.14024866E-09_JPRB, &
  & 0.13935142E-09_JPRB, 0.13858195E-09_JPRB, 0.13794342E-09_JPRB, 0.13744095E-09_JPRB, 0.13706707E-09_JPRB, 0.13681145E-09_JPRB, &
  & 0.13666263E-09_JPRB, 0.13661004E-09_JPRB, 0.13665780E-09_JPRB, 0.13691606E-09_JPRB /)

RGHG8(:,24, 6) = (/ &
  & 0.13475659E-09_JPRB, 0.13403609E-09_JPRB, 0.13365295E-09_JPRB, 0.13336170E-09_JPRB, 0.13312573E-09_JPRB, 0.13294922E-09_JPRB, &
  & 0.13286838E-09_JPRB, 0.13294378E-09_JPRB, 0.13323707E-09_JPRB, 0.13379053E-09_JPRB, 0.13461593E-09_JPRB, 0.13569561E-09_JPRB, &
  & 0.13698682E-09_JPRB, 0.13843235E-09_JPRB, 0.13996784E-09_JPRB, 0.14153244E-09_JPRB, 0.14307605E-09_JPRB, 0.14457180E-09_JPRB, &
  & 0.14600562E-09_JPRB, 0.14737997E-09_JPRB, 0.14871511E-09_JPRB, 0.15003097E-09_JPRB, 0.15133840E-09_JPRB, 0.15264751E-09_JPRB, &
  & 0.15395110E-09_JPRB, 0.15521608E-09_JPRB, 0.15640453E-09_JPRB, 0.15745447E-09_JPRB, 0.15830405E-09_JPRB, 0.15894287E-09_JPRB, &
  & 0.15936100E-09_JPRB, 0.15956261E-09_JPRB, 0.15956597E-09_JPRB, 0.15940614E-09_JPRB, 0.15912061E-09_JPRB, 0.15876839E-09_JPRB, &
  & 0.15837891E-09_JPRB, 0.15797674E-09_JPRB, 0.15755222E-09_JPRB, 0.15709561E-09_JPRB, 0.15657130E-09_JPRB, 0.15595310E-09_JPRB, &
  & 0.15521934E-09_JPRB, 0.15436100E-09_JPRB, 0.15337964E-09_JPRB, 0.15229074E-09_JPRB, 0.15112517E-09_JPRB, 0.14992048E-09_JPRB, &
  & 0.14870433E-09_JPRB, 0.14751066E-09_JPRB, 0.14637008E-09_JPRB, 0.14529147E-09_JPRB, 0.14429236E-09_JPRB, 0.14338500E-09_JPRB, &
  & 0.14257384E-09_JPRB, 0.14186174E-09_JPRB, 0.14125115E-09_JPRB, 0.14074705E-09_JPRB, 0.14034628E-09_JPRB, 0.14004312E-09_JPRB, &
  & 0.13982938E-09_JPRB, 0.13969498E-09_JPRB, 0.13963260E-09_JPRB, 0.13968104E-09_JPRB /)

RGHG8(:,25, 6) = (/ &
  & 0.13772603E-09_JPRB, 0.13716484E-09_JPRB, 0.13687496E-09_JPRB, 0.13666981E-09_JPRB, 0.13651721E-09_JPRB, 0.13642691E-09_JPRB, &
  & 0.13643392E-09_JPRB, 0.13659415E-09_JPRB, 0.13696022E-09_JPRB, 0.13756335E-09_JPRB, 0.13840820E-09_JPRB, 0.13947329E-09_JPRB, &
  & 0.14071821E-09_JPRB, 0.14208548E-09_JPRB, 0.14351900E-09_JPRB, 0.14496351E-09_JPRB, 0.14637680E-09_JPRB, 0.14773216E-09_JPRB, &
  & 0.14902085E-09_JPRB, 0.15024904E-09_JPRB, 0.15142242E-09_JPRB, 0.15254947E-09_JPRB, 0.15363980E-09_JPRB, 0.15471392E-09_JPRB, &
  & 0.15577099E-09_JPRB, 0.15680282E-09_JPRB, 0.15778515E-09_JPRB, 0.15868679E-09_JPRB, 0.15947708E-09_JPRB, 0.16011925E-09_JPRB, &
  & 0.16060016E-09_JPRB, 0.16091398E-09_JPRB, 0.16106780E-09_JPRB, 0.16107653E-09_JPRB, 0.16096362E-09_JPRB, 0.16075227E-09_JPRB, &
  & 0.16046231E-09_JPRB, 0.16010254E-09_JPRB, 0.15967194E-09_JPRB, 0.15916365E-09_JPRB, 0.15856914E-09_JPRB, 0.15787427E-09_JPRB, &
  & 0.15707410E-09_JPRB, 0.15616768E-09_JPRB, 0.15516637E-09_JPRB, 0.15409232E-09_JPRB, 0.15297644E-09_JPRB, 0.15184802E-09_JPRB, &
  & 0.15074067E-09_JPRB, 0.14967587E-09_JPRB, 0.14866097E-09_JPRB, 0.14771001E-09_JPRB, 0.14683084E-09_JPRB, 0.14602436E-09_JPRB, &
  & 0.14529321E-09_JPRB, 0.14463739E-09_JPRB, 0.14405911E-09_JPRB, 0.14356424E-09_JPRB, 0.14315239E-09_JPRB, 0.14282156E-09_JPRB, &
  & 0.14256646E-09_JPRB, 0.14237683E-09_JPRB, 0.14223803E-09_JPRB, 0.14212846E-09_JPRB /)

RGHG8(:,26, 6) = (/ &
  & 0.14031515E-09_JPRB, 0.13990624E-09_JPRB, 0.13971208E-09_JPRB, 0.13958271E-09_JPRB, 0.13950652E-09_JPRB, 0.13949537E-09_JPRB, &
  & 0.13958537E-09_JPRB, 0.13982628E-09_JPRB, 0.14026427E-09_JPRB, 0.14092047E-09_JPRB, 0.14179151E-09_JPRB, 0.14285610E-09_JPRB, &
  & 0.14406981E-09_JPRB, 0.14538251E-09_JPRB, 0.14673836E-09_JPRB, 0.14808926E-09_JPRB, 0.14939690E-09_JPRB, 0.15063900E-09_JPRB, &
  & 0.15180673E-09_JPRB, 0.15290133E-09_JPRB, 0.15392530E-09_JPRB, 0.15487878E-09_JPRB, 0.15577821E-09_JPRB, 0.15664088E-09_JPRB, &
  & 0.15747179E-09_JPRB, 0.15827700E-09_JPRB, 0.15905655E-09_JPRB, 0.15980334E-09_JPRB, 0.16049476E-09_JPRB, 0.16110659E-09_JPRB, &
  & 0.16160683E-09_JPRB, 0.16197979E-09_JPRB, 0.16221974E-09_JPRB, 0.16232839E-09_JPRB, 0.16231522E-09_JPRB, 0.16218912E-09_JPRB, &
  & 0.16195875E-09_JPRB, 0.16162655E-09_JPRB, 0.16120046E-09_JPRB, 0.16066906E-09_JPRB, 0.16004241E-09_JPRB, 0.15931322E-09_JPRB, &
  & 0.15849022E-09_JPRB, 0.15757833E-09_JPRB, 0.15659438E-09_JPRB, 0.15556083E-09_JPRB, 0.15450623E-09_JPRB, 0.15346630E-09_JPRB, &
  & 0.15246422E-09_JPRB, 0.15151233E-09_JPRB, 0.15061878E-09_JPRB, 0.14978586E-09_JPRB, 0.14901062E-09_JPRB, 0.14829545E-09_JPRB, &
  & 0.14763700E-09_JPRB, 0.14703525E-09_JPRB, 0.14649178E-09_JPRB, 0.14601241E-09_JPRB, 0.14559938E-09_JPRB, 0.14525360E-09_JPRB, &
  & 0.14497242E-09_JPRB, 0.14474662E-09_JPRB, 0.14455634E-09_JPRB, 0.14434533E-09_JPRB /)

RGHG8(:,27, 6) = (/ &
  & 0.14259940E-09_JPRB, 0.14233791E-09_JPRB, 0.14221475E-09_JPRB, 0.14215262E-09_JPRB, 0.14213945E-09_JPRB, 0.14219359E-09_JPRB, &
  & 0.14234997E-09_JPRB, 0.14265855E-09_JPRB, 0.14315234E-09_JPRB, 0.14384814E-09_JPRB, 0.14473826E-09_JPRB, 0.14579428E-09_JPRB, &
  & 0.14697865E-09_JPRB, 0.14823992E-09_JPRB, 0.14953072E-09_JPRB, 0.15080398E-09_JPRB, 0.15202641E-09_JPRB, 0.15317565E-09_JPRB, &
  & 0.15424349E-09_JPRB, 0.15522876E-09_JPRB, 0.15612786E-09_JPRB, 0.15694347E-09_JPRB, 0.15768797E-09_JPRB, 0.15837590E-09_JPRB, &
  & 0.15902110E-09_JPRB, 0.15963571E-09_JPRB, 0.16024092E-09_JPRB, 0.16084134E-09_JPRB, 0.16142658E-09_JPRB, 0.16197464E-09_JPRB, &
  & 0.16245634E-09_JPRB, 0.16284588E-09_JPRB, 0.16312479E-09_JPRB, 0.16328362E-09_JPRB, 0.16332093E-09_JPRB, 0.16323841E-09_JPRB, &
  & 0.16303853E-09_JPRB, 0.16272261E-09_JPRB, 0.16229833E-09_JPRB, 0.16176660E-09_JPRB, 0.16112688E-09_JPRB, 0.16039466E-09_JPRB, &
  & 0.15957470E-09_JPRB, 0.15868454E-09_JPRB, 0.15773975E-09_JPRB, 0.15676707E-09_JPRB, 0.15579646E-09_JPRB, 0.15485606E-09_JPRB, &
  & 0.15396448E-09_JPRB, 0.15312732E-09_JPRB, 0.15234390E-09_JPRB, 0.15161152E-09_JPRB, 0.15092924E-09_JPRB, 0.15029271E-09_JPRB, &
  & 0.14969935E-09_JPRB, 0.14914846E-09_JPRB, 0.14864157E-09_JPRB, 0.14818419E-09_JPRB, 0.14777958E-09_JPRB, 0.14743075E-09_JPRB, &
  & 0.14713748E-09_JPRB, 0.14689139E-09_JPRB, 0.14666988E-09_JPRB, 0.14639284E-09_JPRB /)

RGHG8(:,28, 6) = (/ &
  & 0.14465354E-09_JPRB, 0.14448218E-09_JPRB, 0.14442413E-09_JPRB, 0.14441191E-09_JPRB, 0.14444765E-09_JPRB, 0.14455104E-09_JPRB, &
  & 0.14476030E-09_JPRB, 0.14511335E-09_JPRB, 0.14564752E-09_JPRB, 0.14636659E-09_JPRB, 0.14725748E-09_JPRB, 0.14829724E-09_JPRB, &
  & 0.14944355E-09_JPRB, 0.15065547E-09_JPRB, 0.15188450E-09_JPRB, 0.15309147E-09_JPRB, 0.15424184E-09_JPRB, 0.15531643E-09_JPRB, &
  & 0.15630483E-09_JPRB, 0.15720317E-09_JPRB, 0.15800736E-09_JPRB, 0.15871895E-09_JPRB, 0.15934574E-09_JPRB, 0.15990113E-09_JPRB, &
  & 0.16040233E-09_JPRB, 0.16086850E-09_JPRB, 0.16132766E-09_JPRB, 0.16179638E-09_JPRB, 0.16227640E-09_JPRB, 0.16275396E-09_JPRB, &
  & 0.16319686E-09_JPRB, 0.16357427E-09_JPRB, 0.16386026E-09_JPRB, 0.16403695E-09_JPRB, 0.16409522E-09_JPRB, 0.16403176E-09_JPRB, &
  & 0.16384639E-09_JPRB, 0.16354079E-09_JPRB, 0.16311998E-09_JPRB, 0.16259324E-09_JPRB, 0.16196247E-09_JPRB, 0.16124047E-09_JPRB, &
  & 0.16044675E-09_JPRB, 0.15959586E-09_JPRB, 0.15870977E-09_JPRB, 0.15781566E-09_JPRB, 0.15693924E-09_JPRB, 0.15610584E-09_JPRB, &
  & 0.15532300E-09_JPRB, 0.15459090E-09_JPRB, 0.15390419E-09_JPRB, 0.15326039E-09_JPRB, 0.15265453E-09_JPRB, 0.15208400E-09_JPRB, &
  & 0.15154630E-09_JPRB, 0.15104072E-09_JPRB, 0.15056892E-09_JPRB, 0.15013561E-09_JPRB, 0.14974386E-09_JPRB, 0.14939736E-09_JPRB, &
  & 0.14909698E-09_JPRB, 0.14883414E-09_JPRB, 0.14858105E-09_JPRB, 0.14821644E-09_JPRB /)

RGHG8(:,29, 6) = (/ &
  & 0.14646252E-09_JPRB, 0.14637438E-09_JPRB, 0.14636134E-09_JPRB, 0.14638710E-09_JPRB, 0.14645954E-09_JPRB, 0.14660036E-09_JPRB, &
  & 0.14684264E-09_JPRB, 0.14723302E-09_JPRB, 0.14778848E-09_JPRB, 0.14851523E-09_JPRB, 0.14939856E-09_JPRB, 0.15040943E-09_JPRB, &
  & 0.15151636E-09_JPRB, 0.15267589E-09_JPRB, 0.15384828E-09_JPRB, 0.15499416E-09_JPRB, 0.15608378E-09_JPRB, 0.15709663E-09_JPRB, &
  & 0.15802176E-09_JPRB, 0.15885278E-09_JPRB, 0.15958602E-09_JPRB, 0.16022064E-09_JPRB, 0.16076113E-09_JPRB, 0.16122138E-09_JPRB, &
  & 0.16161836E-09_JPRB, 0.16197436E-09_JPRB, 0.16232236E-09_JPRB, 0.16268249E-09_JPRB, 0.16306628E-09_JPRB, 0.16346700E-09_JPRB, &
  & 0.16386022E-09_JPRB, 0.16420806E-09_JPRB, 0.16448061E-09_JPRB, 0.16465462E-09_JPRB, 0.16471575E-09_JPRB, 0.16465798E-09_JPRB, &
  & 0.16448090E-09_JPRB, 0.16418511E-09_JPRB, 0.16377580E-09_JPRB, 0.16326065E-09_JPRB, 0.16265160E-09_JPRB, 0.16195971E-09_JPRB, &
  & 0.16120683E-09_JPRB, 0.16041120E-09_JPRB, 0.15960176E-09_JPRB, 0.15879452E-09_JPRB, 0.15801643E-09_JPRB, 0.15728240E-09_JPRB, &
  & 0.15659779E-09_JPRB, 0.15595500E-09_JPRB, 0.15534839E-09_JPRB, 0.15477390E-09_JPRB, 0.15422896E-09_JPRB, 0.15371143E-09_JPRB, &
  & 0.15321902E-09_JPRB, 0.15275239E-09_JPRB, 0.15231238E-09_JPRB, 0.15190313E-09_JPRB, 0.15152722E-09_JPRB, 0.15118835E-09_JPRB, &
  & 0.15088888E-09_JPRB, 0.15062160E-09_JPRB, 0.15036171E-09_JPRB, 0.15000071E-09_JPRB /)

RGHG8(:,30, 6) = (/ &
  & 0.14805975E-09_JPRB, 0.14803524E-09_JPRB, 0.14805659E-09_JPRB, 0.14811249E-09_JPRB, 0.14821169E-09_JPRB, 0.14837813E-09_JPRB, &
  & 0.14865019E-09_JPRB, 0.14905774E-09_JPRB, 0.14962759E-09_JPRB, 0.15035320E-09_JPRB, 0.15121739E-09_JPRB, 0.15219846E-09_JPRB, &
  & 0.15326056E-09_JPRB, 0.15436979E-09_JPRB, 0.15548669E-09_JPRB, 0.15657746E-09_JPRB, 0.15761348E-09_JPRB, 0.15857456E-09_JPRB, &
  & 0.15944875E-09_JPRB, 0.16022776E-09_JPRB, 0.16090636E-09_JPRB, 0.16148317E-09_JPRB, 0.16196172E-09_JPRB, 0.16235431E-09_JPRB, &
  & 0.16267859E-09_JPRB, 0.16295729E-09_JPRB, 0.16322262E-09_JPRB, 0.16349921E-09_JPRB, 0.16380389E-09_JPRB, 0.16413265E-09_JPRB, &
  & 0.16446819E-09_JPRB, 0.16477551E-09_JPRB, 0.16502170E-09_JPRB, 0.16518047E-09_JPRB, 0.16523428E-09_JPRB, 0.16517548E-09_JPRB, &
  & 0.16500375E-09_JPRB, 0.16472183E-09_JPRB, 0.16433244E-09_JPRB, 0.16384447E-09_JPRB, 0.16326691E-09_JPRB, 0.16261903E-09_JPRB, &
  & 0.16192500E-09_JPRB, 0.16120054E-09_JPRB, 0.16047030E-09_JPRB, 0.15975007E-09_JPRB, 0.15906172E-09_JPRB, 0.15841811E-09_JPRB, &
  & 0.15781167E-09_JPRB, 0.15723992E-09_JPRB, 0.15669618E-09_JPRB, 0.15617389E-09_JPRB, 0.15567506E-09_JPRB, 0.15519792E-09_JPRB, &
  & 0.15474198E-09_JPRB, 0.15430775E-09_JPRB, 0.15389630E-09_JPRB, 0.15351079E-09_JPRB, 0.15315323E-09_JPRB, 0.15282724E-09_JPRB, &
  & 0.15253533E-09_JPRB, 0.15227128E-09_JPRB, 0.15200979E-09_JPRB, 0.15162537E-09_JPRB /)

RGHG8(:,31, 6) = (/ &
  & 0.14947778E-09_JPRB, 0.14950430E-09_JPRB, 0.14955498E-09_JPRB, 0.14963183E-09_JPRB, 0.14975257E-09_JPRB, 0.14994070E-09_JPRB, &
  & 0.15022746E-09_JPRB, 0.15065170E-09_JPRB, 0.15122231E-09_JPRB, 0.15193674E-09_JPRB, 0.15277940E-09_JPRB, 0.15372341E-09_JPRB, &
  & 0.15474319E-09_JPRB, 0.15580030E-09_JPRB, 0.15686452E-09_JPRB, 0.15790237E-09_JPRB, 0.15888985E-09_JPRB, 0.15980553E-09_JPRB, &
  & 0.16063753E-09_JPRB, 0.16137491E-09_JPRB, 0.16201158E-09_JPRB, 0.16254482E-09_JPRB, 0.16297849E-09_JPRB, 0.16332447E-09_JPRB, &
  & 0.16359906E-09_JPRB, 0.16382633E-09_JPRB, 0.16403427E-09_JPRB, 0.16424836E-09_JPRB, 0.16448806E-09_JPRB, 0.16475360E-09_JPRB, &
  & 0.16503215E-09_JPRB, 0.16529353E-09_JPRB, 0.16550518E-09_JPRB, 0.16563975E-09_JPRB, 0.16568033E-09_JPRB, 0.16561906E-09_JPRB, &
  & 0.16545502E-09_JPRB, 0.16519108E-09_JPRB, 0.16483186E-09_JPRB, 0.16438136E-09_JPRB, 0.16385319E-09_JPRB, 0.16326150E-09_JPRB, &
  & 0.16263363E-09_JPRB, 0.16198677E-09_JPRB, 0.16133600E-09_JPRB, 0.16070194E-09_JPRB, 0.16008773E-09_JPRB, 0.15951455E-09_JPRB, &
  & 0.15897131E-09_JPRB, 0.15845168E-09_JPRB, 0.15795174E-09_JPRB, 0.15746844E-09_JPRB, 0.15700341E-09_JPRB, 0.15655720E-09_JPRB, &
  & 0.15613041E-09_JPRB, 0.15572346E-09_JPRB, 0.15533747E-09_JPRB, 0.15497487E-09_JPRB, 0.15463703E-09_JPRB, 0.15432658E-09_JPRB, &
  & 0.15404567E-09_JPRB, 0.15378791E-09_JPRB, 0.15352818E-09_JPRB, 0.15313679E-09_JPRB /)

RGHG8(:,32, 6) = (/ &
  & 0.15075509E-09_JPRB, 0.15082535E-09_JPRB, 0.15089510E-09_JPRB, 0.15099312E-09_JPRB, 0.15113086E-09_JPRB, 0.15133431E-09_JPRB, &
  & 0.15163681E-09_JPRB, 0.15206250E-09_JPRB, 0.15262755E-09_JPRB, 0.15332402E-09_JPRB, 0.15413525E-09_JPRB, 0.15504223E-09_JPRB, &
  & 0.15601413E-09_JPRB, 0.15702215E-09_JPRB, 0.15803318E-09_JPRB, 0.15902103E-09_JPRB, 0.15996347E-09_JPRB, 0.16083790E-09_JPRB, &
  & 0.16163285E-09_JPRB, 0.16233592E-09_JPRB, 0.16293927E-09_JPRB, 0.16344014E-09_JPRB, 0.16384180E-09_JPRB, 0.16415584E-09_JPRB, &
  & 0.16439844E-09_JPRB, 0.16459098E-09_JPRB, 0.16476151E-09_JPRB, 0.16493040E-09_JPRB, 0.16511954E-09_JPRB, 0.16533101E-09_JPRB, &
  & 0.16555643E-09_JPRB, 0.16577091E-09_JPRB, 0.16594440E-09_JPRB, 0.16605201E-09_JPRB, 0.16607613E-09_JPRB, 0.16601094E-09_JPRB, &
  & 0.16585719E-09_JPRB, 0.16561710E-09_JPRB, 0.16529304E-09_JPRB, 0.16489198E-09_JPRB, 0.16441955E-09_JPRB, 0.16389749E-09_JPRB, &
  & 0.16334226E-09_JPRB, 0.16277271E-09_JPRB, 0.16219695E-09_JPRB, 0.16163193E-09_JPRB, 0.16108528E-09_JPRB, 0.16056040E-09_JPRB, &
  & 0.16006331E-09_JPRB, 0.15958108E-09_JPRB, 0.15911286E-09_JPRB, 0.15865759E-09_JPRB, 0.15821733E-09_JPRB, 0.15779510E-09_JPRB, &
  & 0.15739197E-09_JPRB, 0.15700831E-09_JPRB, 0.15664517E-09_JPRB, 0.15630425E-09_JPRB, 0.15598642E-09_JPRB, 0.15569335E-09_JPRB, &
  & 0.15542627E-09_JPRB, 0.15517894E-09_JPRB, 0.15492661E-09_JPRB, 0.15454889E-09_JPRB /)

RGHG8(:,33, 6) = (/ &
  & 0.15192289E-09_JPRB, 0.15202289E-09_JPRB, 0.15211810E-09_JPRB, 0.15223159E-09_JPRB, 0.15238659E-09_JPRB, 0.15260435E-09_JPRB, &
  & 0.15291224E-09_JPRB, 0.15333798E-09_JPRB, 0.15388726E-09_JPRB, 0.15455620E-09_JPRB, 0.15533289E-09_JPRB, 0.15619483E-09_JPRB, &
  & 0.15711957E-09_JPRB, 0.15807466E-09_JPRB, 0.15903569E-09_JPRB, 0.15997373E-09_JPRB, 0.16087200E-09_JPRB, 0.16170940E-09_JPRB, &
  & 0.16247075E-09_JPRB, 0.16314465E-09_JPRB, 0.16372190E-09_JPRB, 0.16419879E-09_JPRB, 0.16457849E-09_JPRB, 0.16487195E-09_JPRB, &
  & 0.16509427E-09_JPRB, 0.16526543E-09_JPRB, 0.16541130E-09_JPRB, 0.16554882E-09_JPRB, 0.16569848E-09_JPRB, 0.16586474E-09_JPRB, &
  & 0.16604212E-09_JPRB, 0.16621071E-09_JPRB, 0.16634559E-09_JPRB, 0.16642469E-09_JPRB, 0.16643405E-09_JPRB, 0.16636686E-09_JPRB, &
  & 0.16622489E-09_JPRB, 0.16601134E-09_JPRB, 0.16572793E-09_JPRB, 0.16537677E-09_JPRB, 0.16496857E-09_JPRB, 0.16451362E-09_JPRB, &
  & 0.16403356E-09_JPRB, 0.16353527E-09_JPRB, 0.16302959E-09_JPRB, 0.16252318E-09_JPRB, 0.16202706E-09_JPRB, 0.16154318E-09_JPRB, &
  & 0.16107460E-09_JPRB, 0.16062024E-09_JPRB, 0.16017357E-09_JPRB, 0.15973883E-09_JPRB, 0.15931814E-09_JPRB, 0.15891549E-09_JPRB, &
  & 0.15853227E-09_JPRB, 0.15816885E-09_JPRB, 0.15782629E-09_JPRB, 0.15750587E-09_JPRB, 0.15720787E-09_JPRB, 0.15693351E-09_JPRB, &
  & 0.15668208E-09_JPRB, 0.15644784E-09_JPRB, 0.15620712E-09_JPRB, 0.15583893E-09_JPRB /)

RGHG8(:,34, 6) = (/ &
  & 0.15298367E-09_JPRB, 0.15313079E-09_JPRB, 0.15324307E-09_JPRB, 0.15337677E-09_JPRB, 0.15354529E-09_JPRB, 0.15377340E-09_JPRB, &
  & 0.15408683E-09_JPRB, 0.15450272E-09_JPRB, 0.15503110E-09_JPRB, 0.15566783E-09_JPRB, 0.15640171E-09_JPRB, 0.15721741E-09_JPRB, &
  & 0.15808949E-09_JPRB, 0.15899305E-09_JPRB, 0.15990194E-09_JPRB, 0.16079302E-09_JPRB, 0.16164765E-09_JPRB, 0.16244917E-09_JPRB, &
  & 0.16318075E-09_JPRB, 0.16382956E-09_JPRB, 0.16438635E-09_JPRB, 0.16484636E-09_JPRB, 0.16521202E-09_JPRB, 0.16549269E-09_JPRB, &
  & 0.16570334E-09_JPRB, 0.16586152E-09_JPRB, 0.16599036E-09_JPRB, 0.16610657E-09_JPRB, 0.16622485E-09_JPRB, 0.16635393E-09_JPRB, &
  & 0.16648870E-09_JPRB, 0.16661521E-09_JPRB, 0.16671363E-09_JPRB, 0.16676611E-09_JPRB, 0.16676081E-09_JPRB, 0.16669399E-09_JPRB, &
  & 0.16656627E-09_JPRB, 0.16638038E-09_JPRB, 0.16613692E-09_JPRB, 0.16583834E-09_JPRB, 0.16548843E-09_JPRB, 0.16510114E-09_JPRB, &
  & 0.16468613E-09_JPRB, 0.16425367E-09_JPRB, 0.16380569E-09_JPRB, 0.16334920E-09_JPRB, 0.16289334E-09_JPRB, 0.16244009E-09_JPRB, &
  & 0.16199490E-09_JPRB, 0.16155839E-09_JPRB, 0.16112967E-09_JPRB, 0.16071076E-09_JPRB, 0.16030650E-09_JPRB, 0.15992099E-09_JPRB, &
  & 0.15955533E-09_JPRB, 0.15921021E-09_JPRB, 0.15888635E-09_JPRB, 0.15858528E-09_JPRB, 0.15830702E-09_JPRB, 0.15805154E-09_JPRB, &
  & 0.15781801E-09_JPRB, 0.15759989E-09_JPRB, 0.15737404E-09_JPRB, 0.15702861E-09_JPRB /)

RGHG8(:,35, 6) = (/ &
  & 0.15397861E-09_JPRB, 0.15415670E-09_JPRB, 0.15429323E-09_JPRB, 0.15444029E-09_JPRB, 0.15462218E-09_JPRB, 0.15485885E-09_JPRB, &
  & 0.15517052E-09_JPRB, 0.15557551E-09_JPRB, 0.15607801E-09_JPRB, 0.15667738E-09_JPRB, 0.15736693E-09_JPRB, 0.15813101E-09_JPRB, &
  & 0.15895005E-09_JPRB, 0.15979927E-09_JPRB, 0.16065717E-09_JPRB, 0.16150151E-09_JPRB, 0.16231459E-09_JPRB, 0.16308130E-09_JPRB, &
  & 0.16378601E-09_JPRB, 0.16441461E-09_JPRB, 0.16495617E-09_JPRB, 0.16540511E-09_JPRB, 0.16576276E-09_JPRB, 0.16603660E-09_JPRB, &
  & 0.16624016E-09_JPRB, 0.16639078E-09_JPRB, 0.16650767E-09_JPRB, 0.16660738E-09_JPRB, 0.16670164E-09_JPRB, 0.16679833E-09_JPRB, &
  & 0.16689584E-09_JPRB, 0.16698427E-09_JPRB, 0.16704985E-09_JPRB, 0.16707882E-09_JPRB, 0.16706206E-09_JPRB, 0.16699686E-09_JPRB, &
  & 0.16688452E-09_JPRB, 0.16672551E-09_JPRB, 0.16652048E-09_JPRB, 0.16626910E-09_JPRB, 0.16597493E-09_JPRB, 0.16564380E-09_JPRB, &
  & 0.16528771E-09_JPRB, 0.16490828E-09_JPRB, 0.16450952E-09_JPRB, 0.16409381E-09_JPRB, 0.16367002E-09_JPRB, 0.16324239E-09_JPRB, &
  & 0.16281472E-09_JPRB, 0.16239372E-09_JPRB, 0.16197879E-09_JPRB, 0.16157423E-09_JPRB, 0.16118532E-09_JPRB, 0.16081571E-09_JPRB, &
  & 0.16046650E-09_JPRB, 0.16013812E-09_JPRB, 0.15983173E-09_JPRB, 0.15954878E-09_JPRB, 0.15928950E-09_JPRB, 0.15905363E-09_JPRB, &
  & 0.15883901E-09_JPRB, 0.15863877E-09_JPRB, 0.15843160E-09_JPRB, 0.15811137E-09_JPRB /)

RGHG8(:,36, 6) = (/ &
  & 0.15490378E-09_JPRB, 0.15512129E-09_JPRB, 0.15527267E-09_JPRB, 0.15543541E-09_JPRB, 0.15562758E-09_JPRB, 0.15586886E-09_JPRB, &
  & 0.15617814E-09_JPRB, 0.15656666E-09_JPRB, 0.15704116E-09_JPRB, 0.15760206E-09_JPRB, 0.15824393E-09_JPRB, 0.15895565E-09_JPRB, &
  & 0.15971920E-09_JPRB, 0.16051409E-09_JPRB, 0.16131989E-09_JPRB, 0.16211811E-09_JPRB, 0.16289145E-09_JPRB, 0.16362518E-09_JPRB, &
  & 0.16430531E-09_JPRB, 0.16491777E-09_JPRB, 0.16544990E-09_JPRB, 0.16589316E-09_JPRB, 0.16624645E-09_JPRB, 0.16651615E-09_JPRB, &
  & 0.16671503E-09_JPRB, 0.16685907E-09_JPRB, 0.16696589E-09_JPRB, 0.16705091E-09_JPRB, 0.16712448E-09_JPRB, 0.16719370E-09_JPRB, &
  & 0.16725865E-09_JPRB, 0.16731407E-09_JPRB, 0.16735073E-09_JPRB, 0.16735985E-09_JPRB, 0.16733499E-09_JPRB, 0.16727443E-09_JPRB, &
  & 0.16717777E-09_JPRB, 0.16704570E-09_JPRB, 0.16687612E-09_JPRB, 0.16666792E-09_JPRB, 0.16641993E-09_JPRB, 0.16613810E-09_JPRB, &
  & 0.16582720E-09_JPRB, 0.16549244E-09_JPRB, 0.16513252E-09_JPRB, 0.16475118E-09_JPRB, 0.16435439E-09_JPRB, 0.16394680E-09_JPRB, &
  & 0.16353578E-09_JPRB, 0.16312775E-09_JPRB, 0.16272568E-09_JPRB, 0.16233496E-09_JPRB, 0.16196069E-09_JPRB, 0.16160702E-09_JPRB, &
  & 0.16127394E-09_JPRB, 0.16096183E-09_JPRB, 0.16067175E-09_JPRB, 0.16040623E-09_JPRB, 0.16016563E-09_JPRB, 0.15994941E-09_JPRB, &
  & 0.15975463E-09_JPRB, 0.15957410E-09_JPRB, 0.15938695E-09_JPRB, 0.15909797E-09_JPRB /)

RGHG8(:,37, 6) = (/ &
  & 0.15578382E-09_JPRB, 0.15602843E-09_JPRB, 0.15619818E-09_JPRB, 0.15637298E-09_JPRB, 0.15657395E-09_JPRB, 0.15681925E-09_JPRB, &
  & 0.15712133E-09_JPRB, 0.15749176E-09_JPRB, 0.15793584E-09_JPRB, 0.15845586E-09_JPRB, 0.15904948E-09_JPRB, 0.15970729E-09_JPRB, &
  & 0.16041392E-09_JPRB, 0.16115310E-09_JPRB, 0.16190689E-09_JPRB, 0.16265826E-09_JPRB, 0.16339272E-09_JPRB, 0.16409549E-09_JPRB, &
  & 0.16475363E-09_JPRB, 0.16535238E-09_JPRB, 0.16587762E-09_JPRB, 0.16631774E-09_JPRB, 0.16666722E-09_JPRB, 0.16693112E-09_JPRB, &
  & 0.16712062E-09_JPRB, 0.16725403E-09_JPRB, 0.16734783E-09_JPRB, 0.16741737E-09_JPRB, 0.16747212E-09_JPRB, 0.16751828E-09_JPRB, &
  & 0.16755715E-09_JPRB, 0.16758603E-09_JPRB, 0.16760017E-09_JPRB, 0.16759427E-09_JPRB, 0.16756524E-09_JPRB, 0.16751087E-09_JPRB, &
  & 0.16743211E-09_JPRB, 0.16732608E-09_JPRB, 0.16719101E-09_JPRB, 0.16702242E-09_JPRB, 0.16681778E-09_JPRB, 0.16657725E-09_JPRB, &
  & 0.16630577E-09_JPRB, 0.16600520E-09_JPRB, 0.16567767E-09_JPRB, 0.16532492E-09_JPRB, 0.16495119E-09_JPRB, 0.16456181E-09_JPRB, &
  & 0.16416560E-09_JPRB, 0.16377028E-09_JPRB, 0.16338089E-09_JPRB, 0.16300356E-09_JPRB, 0.16264476E-09_JPRB, 0.16230683E-09_JPRB, &
  & 0.16198975E-09_JPRB, 0.16169338E-09_JPRB, 0.16141952E-09_JPRB, 0.16117105E-09_JPRB, 0.16094909E-09_JPRB, 0.16075272E-09_JPRB, &
  & 0.16057834E-09_JPRB, 0.16041786E-09_JPRB, 0.16025221E-09_JPRB, 0.15999506E-09_JPRB /)

RGHG8(:,38, 6) = (/ &
  & 0.15662335E-09_JPRB, 0.15689119E-09_JPRB, 0.15707774E-09_JPRB, 0.15726292E-09_JPRB, 0.15747505E-09_JPRB, 0.15772120E-09_JPRB, &
  & 0.15801496E-09_JPRB, 0.15836428E-09_JPRB, 0.15877530E-09_JPRB, 0.15925287E-09_JPRB, 0.15979693E-09_JPRB, 0.16039953E-09_JPRB, &
  & 0.16104872E-09_JPRB, 0.16173077E-09_JPRB, 0.16243153E-09_JPRB, 0.16313639E-09_JPRB, 0.16383123E-09_JPRB, 0.16450392E-09_JPRB, &
  & 0.16514071E-09_JPRB, 0.16572650E-09_JPRB, 0.16624344E-09_JPRB, 0.16667444E-09_JPRB, 0.16701192E-09_JPRB, 0.16725857E-09_JPRB, &
  & 0.16742926E-09_JPRB, 0.16754337E-09_JPRB, 0.16762038E-09_JPRB, 0.16767376E-09_JPRB, 0.16771284E-09_JPRB, 0.16774218E-09_JPRB, &
  & 0.16776332E-09_JPRB, 0.16777500E-09_JPRB, 0.16777459E-09_JPRB, 0.16775999E-09_JPRB, 0.16772933E-09_JPRB, 0.16768270E-09_JPRB, &
  & 0.16761971E-09_JPRB, 0.16753779E-09_JPRB, 0.16743404E-09_JPRB, 0.16730434E-09_JPRB, 0.16714216E-09_JPRB, 0.16694426E-09_JPRB, &
  & 0.16671139E-09_JPRB, 0.16644527E-09_JPRB, 0.16614744E-09_JPRB, 0.16581973E-09_JPRB, 0.16546700E-09_JPRB, 0.16509519E-09_JPRB, &
  & 0.16471351E-09_JPRB, 0.16433177E-09_JPRB, 0.16395540E-09_JPRB, 0.16359239E-09_JPRB, 0.16324894E-09_JPRB, 0.16292709E-09_JPRB, &
  & 0.16262609E-09_JPRB, 0.16234530E-09_JPRB, 0.16208726E-09_JPRB, 0.16185575E-09_JPRB, 0.16165250E-09_JPRB, 0.16147612E-09_JPRB, &
  & 0.16132204E-09_JPRB, 0.16118139E-09_JPRB, 0.16103661E-09_JPRB, 0.16081136E-09_JPRB /)

RGHG8(:,39, 6) = (/ &
  & 0.15742634E-09_JPRB, 0.15771867E-09_JPRB, 0.15791450E-09_JPRB, 0.15811732E-09_JPRB, 0.15833504E-09_JPRB, 0.15858528E-09_JPRB, &
  & 0.15886838E-09_JPRB, 0.15919407E-09_JPRB, 0.15957033E-09_JPRB, 0.16000401E-09_JPRB, 0.16049657E-09_JPRB, 0.16104390E-09_JPRB, &
  & 0.16163486E-09_JPRB, 0.16225954E-09_JPRB, 0.16290642E-09_JPRB, 0.16356350E-09_JPRB, 0.16421844E-09_JPRB, 0.16485943E-09_JPRB, &
  & 0.16547300E-09_JPRB, 0.16604304E-09_JPRB, 0.16654486E-09_JPRB, 0.16695777E-09_JPRB, 0.16726961E-09_JPRB, 0.16748877E-09_JPRB, &
  & 0.16763345E-09_JPRB, 0.16772668E-09_JPRB, 0.16778712E-09_JPRB, 0.16782775E-09_JPRB, 0.16785583E-09_JPRB, 0.16787496E-09_JPRB, &
  & 0.16788608E-09_JPRB, 0.16788836E-09_JPRB, 0.16788011E-09_JPRB, 0.16786095E-09_JPRB, 0.16783049E-09_JPRB, 0.16778892E-09_JPRB, &
  & 0.16773792E-09_JPRB, 0.16767306E-09_JPRB, 0.16759485E-09_JPRB, 0.16749795E-09_JPRB, 0.16737438E-09_JPRB, 0.16721929E-09_JPRB, &
  & 0.16702970E-09_JPRB, 0.16680334E-09_JPRB, 0.16653912E-09_JPRB, 0.16623984E-09_JPRB, 0.16590958E-09_JPRB, 0.16555621E-09_JPRB, &
  & 0.16519053E-09_JPRB, 0.16482292E-09_JPRB, 0.16446089E-09_JPRB, 0.16411275E-09_JPRB, 0.16378501E-09_JPRB, 0.16347906E-09_JPRB, &
  & 0.16319358E-09_JPRB, 0.16292831E-09_JPRB, 0.16268592E-09_JPRB, 0.16247143E-09_JPRB, 0.16228675E-09_JPRB, 0.16213013E-09_JPRB, &
  & 0.16199546E-09_JPRB, 0.16187392E-09_JPRB, 0.16174852E-09_JPRB, 0.16155353E-09_JPRB /)

RGHG8(:,40, 6) = (/ &
  & 0.15820285E-09_JPRB, 0.15850410E-09_JPRB, 0.15872116E-09_JPRB, 0.15892937E-09_JPRB, 0.15916504E-09_JPRB, 0.15941368E-09_JPRB, &
  & 0.15968669E-09_JPRB, 0.15998858E-09_JPRB, 0.16032886E-09_JPRB, 0.16071661E-09_JPRB, 0.16115775E-09_JPRB, 0.16164879E-09_JPRB, &
  & 0.16218255E-09_JPRB, 0.16275022E-09_JPRB, 0.16334306E-09_JPRB, 0.16395120E-09_JPRB, 0.16456403E-09_JPRB, 0.16517028E-09_JPRB, &
  & 0.16575678E-09_JPRB, 0.16630232E-09_JPRB, 0.16678244E-09_JPRB, 0.16716810E-09_JPRB, 0.16745066E-09_JPRB, 0.16764080E-09_JPRB, &
  & 0.16776198E-09_JPRB, 0.16783783E-09_JPRB, 0.16788615E-09_JPRB, 0.16791796E-09_JPRB, 0.16793927E-09_JPRB, 0.16795264E-09_JPRB, &
  & 0.16795841E-09_JPRB, 0.16795582E-09_JPRB, 0.16794360E-09_JPRB, 0.16792216E-09_JPRB, 0.16789181E-09_JPRB, 0.16785362E-09_JPRB, &
  & 0.16780950E-09_JPRB, 0.16775596E-09_JPRB, 0.16769507E-09_JPRB, 0.16762125E-09_JPRB, 0.16752837E-09_JPRB, 0.16741086E-09_JPRB, &
  & 0.16726337E-09_JPRB, 0.16707963E-09_JPRB, 0.16685553E-09_JPRB, 0.16658930E-09_JPRB, 0.16628607E-09_JPRB, 0.16595457E-09_JPRB, &
  & 0.16560622E-09_JPRB, 0.16525459E-09_JPRB, 0.16490806E-09_JPRB, 0.16457549E-09_JPRB, 0.16426373E-09_JPRB, 0.16397339E-09_JPRB, &
  & 0.16370304E-09_JPRB, 0.16345227E-09_JPRB, 0.16322524E-09_JPRB, 0.16302719E-09_JPRB, 0.16286081E-09_JPRB, 0.16272286E-09_JPRB, &
  & 0.16260658E-09_JPRB, 0.16250212E-09_JPRB, 0.16239499E-09_JPRB, 0.16222670E-09_JPRB /)

RGHG8(:,41, 6) = (/ &
  & 0.15894588E-09_JPRB, 0.15926728E-09_JPRB, 0.15948473E-09_JPRB, 0.15971724E-09_JPRB, 0.15995655E-09_JPRB, 0.16021211E-09_JPRB, &
  & 0.16047344E-09_JPRB, 0.16075115E-09_JPRB, 0.16105559E-09_JPRB, 0.16139877E-09_JPRB, 0.16178739E-09_JPRB, 0.16222337E-09_JPRB, &
  & 0.16270080E-09_JPRB, 0.16321280E-09_JPRB, 0.16375193E-09_JPRB, 0.16431073E-09_JPRB, 0.16487907E-09_JPRB, 0.16544709E-09_JPRB, &
  & 0.16600080E-09_JPRB, 0.16651883E-09_JPRB, 0.16696845E-09_JPRB, 0.16732468E-09_JPRB, 0.16757790E-09_JPRB, 0.16774356E-09_JPRB, &
  & 0.16784633E-09_JPRB, 0.16790948E-09_JPRB, 0.16794932E-09_JPRB, 0.16797536E-09_JPRB, 0.16799247E-09_JPRB, 0.16800247E-09_JPRB, &
  & 0.16800540E-09_JPRB, 0.16800018E-09_JPRB, 0.16798589E-09_JPRB, 0.16796307E-09_JPRB, 0.16793300E-09_JPRB, 0.16789656E-09_JPRB, &
  & 0.16785667E-09_JPRB, 0.16781049E-09_JPRB, 0.16776032E-09_JPRB, 0.16770280E-09_JPRB, 0.16763188E-09_JPRB, 0.16754390E-09_JPRB, &
  & 0.16743235E-09_JPRB, 0.16728914E-09_JPRB, 0.16710633E-09_JPRB, 0.16687832E-09_JPRB, 0.16660656E-09_JPRB, 0.16629972E-09_JPRB, &
  & 0.16597171E-09_JPRB, 0.16563720E-09_JPRB, 0.16530768E-09_JPRB, 0.16499134E-09_JPRB, 0.16469551E-09_JPRB, 0.16442038E-09_JPRB, &
  & 0.16416418E-09_JPRB, 0.16392762E-09_JPRB, 0.16371474E-09_JPRB, 0.16353284E-09_JPRB, 0.16338363E-09_JPRB, 0.16326315E-09_JPRB, &
  & 0.16316332E-09_JPRB, 0.16307446E-09_JPRB, 0.16298260E-09_JPRB, 0.16283834E-09_JPRB /)

RGHG8(:,42, 6) = (/ &
  & 0.15967382E-09_JPRB, 0.15999514E-09_JPRB, 0.16023044E-09_JPRB, 0.16046472E-09_JPRB, 0.16072499E-09_JPRB, 0.16097926E-09_JPRB, &
  & 0.16123153E-09_JPRB, 0.16148652E-09_JPRB, 0.16175700E-09_JPRB, 0.16205588E-09_JPRB, 0.16239445E-09_JPRB, 0.16277660E-09_JPRB, &
  & 0.16319950E-09_JPRB, 0.16365767E-09_JPRB, 0.16414452E-09_JPRB, 0.16465268E-09_JPRB, 0.16517512E-09_JPRB, 0.16570073E-09_JPRB, &
  & 0.16621741E-09_JPRB, 0.16670217E-09_JPRB, 0.16712309E-09_JPRB, 0.16744885E-09_JPRB, 0.16767487E-09_JPRB, 0.16781886E-09_JPRB, &
  & 0.16790669E-09_JPRB, 0.16796026E-09_JPRB, 0.16799401E-09_JPRB, 0.16801598E-09_JPRB, 0.16803040E-09_JPRB, 0.16803843E-09_JPRB, &
  & 0.16803980E-09_JPRB, 0.16803320E-09_JPRB, 0.16801785E-09_JPRB, 0.16799410E-09_JPRB, 0.16796418E-09_JPRB, 0.16792884E-09_JPRB, &
  & 0.16789149E-09_JPRB, 0.16784985E-09_JPRB, 0.16780730E-09_JPRB, 0.16776047E-09_JPRB, 0.16770585E-09_JPRB, 0.16763989E-09_JPRB, &
  & 0.16755669E-09_JPRB, 0.16744832E-09_JPRB, 0.16730473E-09_JPRB, 0.16711674E-09_JPRB, 0.16688084E-09_JPRB, 0.16660320E-09_JPRB, &
  & 0.16629764E-09_JPRB, 0.16598221E-09_JPRB, 0.16567044E-09_JPRB, 0.16537102E-09_JPRB, 0.16509105E-09_JPRB, 0.16483109E-09_JPRB, &
  & 0.16458886E-09_JPRB, 0.16436533E-09_JPRB, 0.16416654E-09_JPRB, 0.16399952E-09_JPRB, 0.16386628E-09_JPRB, 0.16376141E-09_JPRB, &
  & 0.16367602E-09_JPRB, 0.16360019E-09_JPRB, 0.16352175E-09_JPRB, 0.16339699E-09_JPRB /)

RGHG8(:,43, 6) = (/ &
  & 0.16038436E-09_JPRB, 0.16071669E-09_JPRB, 0.16094416E-09_JPRB, 0.16119854E-09_JPRB, 0.16146182E-09_JPRB, 0.16172373E-09_JPRB, &
  & 0.16196591E-09_JPRB, 0.16220009E-09_JPRB, 0.16243881E-09_JPRB, 0.16269723E-09_JPRB, 0.16298768E-09_JPRB, 0.16331834E-09_JPRB, &
  & 0.16368927E-09_JPRB, 0.16409597E-09_JPRB, 0.16453142E-09_JPRB, 0.16499005E-09_JPRB, 0.16546313E-09_JPRB, 0.16594377E-09_JPRB, &
  & 0.16641850E-09_JPRB, 0.16686752E-09_JPRB, 0.16725488E-09_JPRB, 0.16755233E-09_JPRB, 0.16775323E-09_JPRB, 0.16787835E-09_JPRB, &
  & 0.16795354E-09_JPRB, 0.16799938E-09_JPRB, 0.16802849E-09_JPRB, 0.16804767E-09_JPRB, 0.16806029E-09_JPRB, 0.16806717E-09_JPRB, &
  & 0.16806782E-09_JPRB, 0.16806061E-09_JPRB, 0.16804456E-09_JPRB, 0.16802050E-09_JPRB, 0.16799034E-09_JPRB, 0.16795575E-09_JPRB, &
  & 0.16791955E-09_JPRB, 0.16788147E-09_JPRB, 0.16784334E-09_JPRB, 0.16780476E-09_JPRB, 0.16776174E-09_JPRB, 0.16771251E-09_JPRB, &
  & 0.16765196E-09_JPRB, 0.16757229E-09_JPRB, 0.16746410E-09_JPRB, 0.16731615E-09_JPRB, 0.16711962E-09_JPRB, 0.16687524E-09_JPRB, &
  & 0.16659563E-09_JPRB, 0.16630071E-09_JPRB, 0.16600687E-09_JPRB, 0.16572484E-09_JPRB, 0.16546117E-09_JPRB, 0.16521630E-09_JPRB, &
  & 0.16498784E-09_JPRB, 0.16477776E-09_JPRB, 0.16459212E-09_JPRB, 0.16443946E-09_JPRB, 0.16432067E-09_JPRB, 0.16422944E-09_JPRB, &
  & 0.16415605E-09_JPRB, 0.16409127E-09_JPRB, 0.16402328E-09_JPRB, 0.16391420E-09_JPRB /)

RGHG8(:,44, 6) = (/ &
  & 0.16110349E-09_JPRB, 0.16142082E-09_JPRB, 0.16165866E-09_JPRB, 0.16190480E-09_JPRB, 0.16218664E-09_JPRB, 0.16244718E-09_JPRB, &
  & 0.16268362E-09_JPRB, 0.16289858E-09_JPRB, 0.16310928E-09_JPRB, 0.16333018E-09_JPRB, 0.16357721E-09_JPRB, 0.16385955E-09_JPRB, &
  & 0.16418153E-09_JPRB, 0.16453888E-09_JPRB, 0.16492561E-09_JPRB, 0.16533287E-09_JPRB, 0.16575620E-09_JPRB, 0.16618641E-09_JPRB, &
  & 0.16661669E-09_JPRB, 0.16702360E-09_JPRB, 0.16737692E-09_JPRB, 0.16764241E-09_JPRB, 0.16781956E-09_JPRB, 0.16792752E-09_JPRB, &
  & 0.16799204E-09_JPRB, 0.16803151E-09_JPRB, 0.16805700E-09_JPRB, 0.16807414E-09_JPRB, 0.16808564E-09_JPRB, 0.16809201E-09_JPRB, &
  & 0.16809240E-09_JPRB, 0.16808500E-09_JPRB, 0.16806884E-09_JPRB, 0.16804445E-09_JPRB, 0.16801410E-09_JPRB, 0.16797985E-09_JPRB, &
  & 0.16794413E-09_JPRB, 0.16790799E-09_JPRB, 0.16787324E-09_JPRB, 0.16784019E-09_JPRB, 0.16780624E-09_JPRB, 0.16776990E-09_JPRB, &
  & 0.16772711E-09_JPRB, 0.16767140E-09_JPRB, 0.16759436E-09_JPRB, 0.16748396E-09_JPRB, 0.16732946E-09_JPRB, 0.16712318E-09_JPRB, &
  & 0.16687461E-09_JPRB, 0.16660175E-09_JPRB, 0.16632676E-09_JPRB, 0.16606272E-09_JPRB, 0.16581569E-09_JPRB, 0.16558643E-09_JPRB, &
  & 0.16537252E-09_JPRB, 0.16517575E-09_JPRB, 0.16500380E-09_JPRB, 0.16486441E-09_JPRB, 0.16475869E-09_JPRB, 0.16467891E-09_JPRB, &
  & 0.16461574E-09_JPRB, 0.16455937E-09_JPRB, 0.16450005E-09_JPRB, 0.16440237E-09_JPRB /)

RGHG8(:,45, 6) = (/ &
  & 0.16183184E-09_JPRB, 0.16214505E-09_JPRB, 0.16235627E-09_JPRB, 0.16261670E-09_JPRB, 0.16289189E-09_JPRB, 0.16316418E-09_JPRB, &
  & 0.16339119E-09_JPRB, 0.16359142E-09_JPRB, 0.16377626E-09_JPRB, 0.16396573E-09_JPRB, 0.16417243E-09_JPRB, 0.16441178E-09_JPRB, &
  & 0.16468737E-09_JPRB, 0.16499883E-09_JPRB, 0.16533645E-09_JPRB, 0.16569486E-09_JPRB, 0.16606386E-09_JPRB, 0.16644214E-09_JPRB, &
  & 0.16681868E-09_JPRB, 0.16718119E-09_JPRB, 0.16749095E-09_JPRB, 0.16772526E-09_JPRB, 0.16787739E-09_JPRB, 0.16796979E-09_JPRB, &
  & 0.16802479E-09_JPRB, 0.16805901E-09_JPRB, 0.16808162E-09_JPRB, 0.16809734E-09_JPRB, 0.16810819E-09_JPRB, 0.16811448E-09_JPRB, &
  & 0.16811505E-09_JPRB, 0.16810794E-09_JPRB, 0.16809182E-09_JPRB, 0.16806737E-09_JPRB, 0.16803664E-09_JPRB, 0.16800233E-09_JPRB, &
  & 0.16796643E-09_JPRB, 0.16793156E-09_JPRB, 0.16789863E-09_JPRB, 0.16786983E-09_JPRB, 0.16784266E-09_JPRB, 0.16781641E-09_JPRB, &
  & 0.16778799E-09_JPRB, 0.16775181E-09_JPRB, 0.16770077E-09_JPRB, 0.16762494E-09_JPRB, 0.16751084E-09_JPRB, 0.16734907E-09_JPRB, &
  & 0.16713608E-09_JPRB, 0.16689139E-09_JPRB, 0.16663673E-09_JPRB, 0.16639164E-09_JPRB, 0.16616268E-09_JPRB, 0.16594962E-09_JPRB, &
  & 0.16575133E-09_JPRB, 0.16556936E-09_JPRB, 0.16541077E-09_JPRB, 0.16528454E-09_JPRB, 0.16519015E-09_JPRB, 0.16512039E-09_JPRB, &
  & 0.16506491E-09_JPRB, 0.16501568E-09_JPRB, 0.16496231E-09_JPRB, 0.16487378E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART11',1,ZHOOK_HANDLE)
END SUBROUTINE PART11




SUBROUTINE PART12
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART12',0,ZHOOK_HANDLE)



RGHG8(:,46, 6) = (/ &
  & 0.16253830E-09_JPRB, 0.16284364E-09_JPRB, 0.16307537E-09_JPRB, 0.16331342E-09_JPRB, 0.16361207E-09_JPRB, 0.16387824E-09_JPRB, &
  & 0.16410658E-09_JPRB, 0.16429016E-09_JPRB, 0.16445513E-09_JPRB, 0.16461424E-09_JPRB, 0.16478814E-09_JPRB, 0.16498625E-09_JPRB, &
  & 0.16522014E-09_JPRB, 0.16548593E-09_JPRB, 0.16577792E-09_JPRB, 0.16608326E-09_JPRB, 0.16639924E-09_JPRB, 0.16671758E-09_JPRB, &
  & 0.16703822E-09_JPRB, 0.16734029E-09_JPRB, 0.16760492E-09_JPRB, 0.16780052E-09_JPRB, 0.16792939E-09_JPRB, 0.16800659E-09_JPRB, &
  & 0.16805340E-09_JPRB, 0.16808314E-09_JPRB, 0.16810352E-09_JPRB, 0.16811823E-09_JPRB, 0.16812884E-09_JPRB, 0.16813539E-09_JPRB, &
  & 0.16813656E-09_JPRB, 0.16813005E-09_JPRB, 0.16811431E-09_JPRB, 0.16808983E-09_JPRB, 0.16805875E-09_JPRB, 0.16802384E-09_JPRB, &
  & 0.16798751E-09_JPRB, 0.16795268E-09_JPRB, 0.16792120E-09_JPRB, 0.16789498E-09_JPRB, 0.16787308E-09_JPRB, 0.16785490E-09_JPRB, &
  & 0.16783790E-09_JPRB, 0.16781751E-09_JPRB, 0.16778794E-09_JPRB, 0.16774047E-09_JPRB, 0.16766512E-09_JPRB, 0.16754710E-09_JPRB, &
  & 0.16738080E-09_JPRB, 0.16717019E-09_JPRB, 0.16694313E-09_JPRB, 0.16671853E-09_JPRB, 0.16650788E-09_JPRB, 0.16631291E-09_JPRB, &
  & 0.16613144E-09_JPRB, 0.16596452E-09_JPRB, 0.16582014E-09_JPRB, 0.16570567E-09_JPRB, 0.16562163E-09_JPRB, 0.16555959E-09_JPRB, &
  & 0.16551076E-09_JPRB, 0.16546652E-09_JPRB, 0.16541848E-09_JPRB, 0.16533595E-09_JPRB /)

RGHG8(:,47, 6) = (/ &
  & 0.16332799E-09_JPRB, 0.16361064E-09_JPRB, 0.16380504E-09_JPRB, 0.16405874E-09_JPRB, 0.16433996E-09_JPRB, 0.16462634E-09_JPRB, &
  & 0.16484387E-09_JPRB, 0.16501822E-09_JPRB, 0.16516075E-09_JPRB, 0.16529654E-09_JPRB, 0.16543680E-09_JPRB, 0.16560014E-09_JPRB, &
  & 0.16579194E-09_JPRB, 0.16601524E-09_JPRB, 0.16625808E-09_JPRB, 0.16651275E-09_JPRB, 0.16676788E-09_JPRB, 0.16702341E-09_JPRB, &
  & 0.16727211E-09_JPRB, 0.16751009E-09_JPRB, 0.16771481E-09_JPRB, 0.16787288E-09_JPRB, 0.16797606E-09_JPRB, 0.16803962E-09_JPRB, &
  & 0.16807877E-09_JPRB, 0.16810475E-09_JPRB, 0.16812333E-09_JPRB, 0.16813745E-09_JPRB, 0.16814812E-09_JPRB, 0.16815530E-09_JPRB, &
  & 0.16815734E-09_JPRB, 0.16815173E-09_JPRB, 0.16813662E-09_JPRB, 0.16811222E-09_JPRB, 0.16808069E-09_JPRB, 0.16804487E-09_JPRB, &
  & 0.16800758E-09_JPRB, 0.16797234E-09_JPRB, 0.16794141E-09_JPRB, 0.16791700E-09_JPRB, 0.16789901E-09_JPRB, 0.16788707E-09_JPRB, &
  & 0.16787934E-09_JPRB, 0.16787163E-09_JPRB, 0.16785889E-09_JPRB, 0.16783505E-09_JPRB, 0.16779117E-09_JPRB, 0.16771680E-09_JPRB, &
  & 0.16759850E-09_JPRB, 0.16743773E-09_JPRB, 0.16724493E-09_JPRB, 0.16704885E-09_JPRB, 0.16686012E-09_JPRB, 0.16668428E-09_JPRB, &
  & 0.16652005E-09_JPRB, 0.16636902E-09_JPRB, 0.16623698E-09_JPRB, 0.16613344E-09_JPRB, 0.16605753E-09_JPRB, 0.16600196E-09_JPRB, &
  & 0.16595778E-09_JPRB, 0.16591759E-09_JPRB, 0.16587287E-09_JPRB, 0.16579514E-09_JPRB /)

RGHG8(:,48, 6) = (/ &
  & 0.16404311E-09_JPRB, 0.16434884E-09_JPRB, 0.16457599E-09_JPRB, 0.16482157E-09_JPRB, 0.16513316E-09_JPRB, 0.16541565E-09_JPRB, &
  & 0.16563867E-09_JPRB, 0.16579611E-09_JPRB, 0.16592099E-09_JPRB, 0.16602950E-09_JPRB, 0.16614182E-09_JPRB, 0.16626760E-09_JPRB, &
  & 0.16642009E-09_JPRB, 0.16659721E-09_JPRB, 0.16679035E-09_JPRB, 0.16698473E-09_JPRB, 0.16717330E-09_JPRB, 0.16735137E-09_JPRB, &
  & 0.16751983E-09_JPRB, 0.16767990E-09_JPRB, 0.16782456E-09_JPRB, 0.16793983E-09_JPRB, 0.16801947E-09_JPRB, 0.16806952E-09_JPRB, &
  & 0.16810189E-09_JPRB, 0.16812450E-09_JPRB, 0.16814163E-09_JPRB, 0.16815534E-09_JPRB, 0.16816634E-09_JPRB, 0.16817431E-09_JPRB, &
  & 0.16817753E-09_JPRB, 0.16817316E-09_JPRB, 0.16815890E-09_JPRB, 0.16813471E-09_JPRB, 0.16810256E-09_JPRB, 0.16806551E-09_JPRB, &
  & 0.16802704E-09_JPRB, 0.16799083E-09_JPRB, 0.16795995E-09_JPRB, 0.16793655E-09_JPRB, 0.16792123E-09_JPRB, 0.16791428E-09_JPRB, &
  & 0.16791396E-09_JPRB, 0.16791653E-09_JPRB, 0.16791728E-09_JPRB, 0.16791138E-09_JPRB, 0.16789320E-09_JPRB, 0.16785423E-09_JPRB, &
  & 0.16778533E-09_JPRB, 0.16767751E-09_JPRB, 0.16754022E-09_JPRB, 0.16738202E-09_JPRB, 0.16722511E-09_JPRB, 0.16707204E-09_JPRB, &
  & 0.16692633E-09_JPRB, 0.16678880E-09_JPRB, 0.16666735E-09_JPRB, 0.16657112E-09_JPRB, 0.16650120E-09_JPRB, 0.16644991E-09_JPRB, &
  & 0.16640897E-09_JPRB, 0.16637129E-09_JPRB, 0.16632881E-09_JPRB, 0.16625379E-09_JPRB /)

RGHG8(:,49, 6) = (/ &
  & 0.16480951E-09_JPRB, 0.16514641E-09_JPRB, 0.16538074E-09_JPRB, 0.16564969E-09_JPRB, 0.16596514E-09_JPRB, 0.16626694E-09_JPRB, &
  & 0.16647925E-09_JPRB, 0.16662281E-09_JPRB, 0.16672427E-09_JPRB, 0.16680857E-09_JPRB, 0.16688867E-09_JPRB, 0.16698004E-09_JPRB, &
  & 0.16708798E-09_JPRB, 0.16721431E-09_JPRB, 0.16734658E-09_JPRB, 0.16747040E-09_JPRB, 0.16757866E-09_JPRB, 0.16767186E-09_JPRB, &
  & 0.16775897E-09_JPRB, 0.16784238E-09_JPRB, 0.16792866E-09_JPRB, 0.16800368E-09_JPRB, 0.16805962E-09_JPRB, 0.16809726E-09_JPRB, &
  & 0.16812327E-09_JPRB, 0.16814283E-09_JPRB, 0.16815870E-09_JPRB, 0.16817225E-09_JPRB, 0.16818379E-09_JPRB, 0.16819282E-09_JPRB, &
  & 0.16819743E-09_JPRB, 0.16819454E-09_JPRB, 0.16818134E-09_JPRB, 0.16815734E-09_JPRB, 0.16812449E-09_JPRB, 0.16808606E-09_JPRB, &
  & 0.16804608E-09_JPRB, 0.16800877E-09_JPRB, 0.16797735E-09_JPRB, 0.16795428E-09_JPRB, 0.16794080E-09_JPRB, 0.16793758E-09_JPRB, &
  & 0.16794337E-09_JPRB, 0.16795429E-09_JPRB, 0.16796566E-09_JPRB, 0.16797350E-09_JPRB, 0.16797416E-09_JPRB, 0.16796271E-09_JPRB, &
  & 0.16793236E-09_JPRB, 0.16787807E-09_JPRB, 0.16779647E-09_JPRB, 0.16769844E-09_JPRB, 0.16758499E-09_JPRB, 0.16746866E-09_JPRB, &
  & 0.16734843E-09_JPRB, 0.16722704E-09_JPRB, 0.16711450E-09_JPRB, 0.16702381E-09_JPRB, 0.16695675E-09_JPRB, 0.16690800E-09_JPRB, &
  & 0.16686846E-09_JPRB, 0.16683185E-09_JPRB, 0.16678964E-09_JPRB, 0.16671430E-09_JPRB /)

RGHG8(:,50, 6) = (/ &
  & 0.16561419E-09_JPRB, 0.16596019E-09_JPRB, 0.16619320E-09_JPRB, 0.16646570E-09_JPRB, 0.16678092E-09_JPRB, 0.16706882E-09_JPRB, &
  & 0.16726059E-09_JPRB, 0.16737758E-09_JPRB, 0.16745387E-09_JPRB, 0.16751114E-09_JPRB, 0.16756450E-09_JPRB, 0.16761936E-09_JPRB, &
  & 0.16768474E-09_JPRB, 0.16775584E-09_JPRB, 0.16782185E-09_JPRB, 0.16787410E-09_JPRB, 0.16791080E-09_JPRB, 0.16793773E-09_JPRB, &
  & 0.16796055E-09_JPRB, 0.16798976E-09_JPRB, 0.16802432E-09_JPRB, 0.16806442E-09_JPRB, 0.16809799E-09_JPRB, 0.16812357E-09_JPRB, &
  & 0.16814354E-09_JPRB, 0.16816026E-09_JPRB, 0.16817500E-09_JPRB, 0.16818849E-09_JPRB, 0.16820066E-09_JPRB, 0.16821093E-09_JPRB, &
  & 0.16821720E-09_JPRB, 0.16821600E-09_JPRB, 0.16820396E-09_JPRB, 0.16818016E-09_JPRB, 0.16814652E-09_JPRB, 0.16810647E-09_JPRB, &
  & 0.16806506E-09_JPRB, 0.16802623E-09_JPRB, 0.16799413E-09_JPRB, 0.16797080E-09_JPRB, 0.16795831E-09_JPRB, 0.16795793E-09_JPRB, &
  & 0.16796893E-09_JPRB, 0.16798669E-09_JPRB, 0.16800654E-09_JPRB, 0.16802459E-09_JPRB, 0.16803886E-09_JPRB, 0.16804610E-09_JPRB, &
  & 0.16804258E-09_JPRB, 0.16802454E-09_JPRB, 0.16799165E-09_JPRB, 0.16794260E-09_JPRB, 0.16788443E-09_JPRB, 0.16781437E-09_JPRB, &
  & 0.16773445E-09_JPRB, 0.16764640E-09_JPRB, 0.16755483E-09_JPRB, 0.16747548E-09_JPRB, 0.16741636E-09_JPRB, 0.16737046E-09_JPRB, &
  & 0.16733363E-09_JPRB, 0.16729713E-09_JPRB, 0.16725478E-09_JPRB, 0.16717439E-09_JPRB /)

RGHG8(:,51, 6) = (/ &
  & 0.16635443E-09_JPRB, 0.16668480E-09_JPRB, 0.16692321E-09_JPRB, 0.16715973E-09_JPRB, 0.16744542E-09_JPRB, 0.16768356E-09_JPRB, &
  & 0.16783255E-09_JPRB, 0.16791409E-09_JPRB, 0.16796436E-09_JPRB, 0.16800067E-09_JPRB, 0.16803019E-09_JPRB, 0.16806095E-09_JPRB, &
  & 0.16809132E-09_JPRB, 0.16811962E-09_JPRB, 0.16813760E-09_JPRB, 0.16814238E-09_JPRB, 0.16813742E-09_JPRB, 0.16812804E-09_JPRB, &
  & 0.16811796E-09_JPRB, 0.16811257E-09_JPRB, 0.16811416E-09_JPRB, 0.16812300E-09_JPRB, 0.16813584E-09_JPRB, 0.16814924E-09_JPRB, &
  & 0.16816307E-09_JPRB, 0.16817703E-09_JPRB, 0.16819082E-09_JPRB, 0.16820437E-09_JPRB, 0.16821733E-09_JPRB, 0.16822893E-09_JPRB, &
  & 0.16823697E-09_JPRB, 0.16823762E-09_JPRB, 0.16822685E-09_JPRB, 0.16820327E-09_JPRB, 0.16816858E-09_JPRB, 0.16812726E-09_JPRB, &
  & 0.16808371E-09_JPRB, 0.16804387E-09_JPRB, 0.16801047E-09_JPRB, 0.16798661E-09_JPRB, 0.16797454E-09_JPRB, 0.16797644E-09_JPRB, &
  & 0.16799144E-09_JPRB, 0.16801534E-09_JPRB, 0.16804155E-09_JPRB, 0.16806789E-09_JPRB, 0.16809129E-09_JPRB, 0.16811112E-09_JPRB, &
  & 0.16812363E-09_JPRB, 0.16812726E-09_JPRB, 0.16812052E-09_JPRB, 0.16810517E-09_JPRB, 0.16808117E-09_JPRB, 0.16805135E-09_JPRB, &
  & 0.16801452E-09_JPRB, 0.16796742E-09_JPRB, 0.16791560E-09_JPRB, 0.16786691E-09_JPRB, 0.16782520E-09_JPRB, 0.16779360E-09_JPRB, &
  & 0.16776346E-09_JPRB, 0.16773358E-09_JPRB, 0.16769242E-09_JPRB, 0.16761474E-09_JPRB /)

RGHG8(:,52, 6) = (/ &
  & 0.16704238E-09_JPRB, 0.16732352E-09_JPRB, 0.16749455E-09_JPRB, 0.16769593E-09_JPRB, 0.16790916E-09_JPRB, 0.16808988E-09_JPRB, &
  & 0.16818938E-09_JPRB, 0.16824298E-09_JPRB, 0.16827365E-09_JPRB, 0.16829405E-09_JPRB, 0.16831100E-09_JPRB, 0.16832441E-09_JPRB, &
  & 0.16833568E-09_JPRB, 0.16833887E-09_JPRB, 0.16832992E-09_JPRB, 0.16831070E-09_JPRB, 0.16828638E-09_JPRB, 0.16826016E-09_JPRB, &
  & 0.16823734E-09_JPRB, 0.16821286E-09_JPRB, 0.16819567E-09_JPRB, 0.16818118E-09_JPRB, 0.16817439E-09_JPRB, 0.16817497E-09_JPRB, &
  & 0.16818233E-09_JPRB, 0.16819356E-09_JPRB, 0.16820650E-09_JPRB, 0.16822019E-09_JPRB, 0.16823397E-09_JPRB, 0.16824697E-09_JPRB, &
  & 0.16825691E-09_JPRB, 0.16825949E-09_JPRB, 0.16825011E-09_JPRB, 0.16822664E-09_JPRB, 0.16819121E-09_JPRB, 0.16814783E-09_JPRB, &
  & 0.16810320E-09_JPRB, 0.16806126E-09_JPRB, 0.16802684E-09_JPRB, 0.16800199E-09_JPRB, 0.16799001E-09_JPRB, 0.16799359E-09_JPRB, &
  & 0.16801228E-09_JPRB, 0.16804036E-09_JPRB, 0.16807274E-09_JPRB, 0.16810438E-09_JPRB, 0.16813571E-09_JPRB, 0.16816279E-09_JPRB, &
  & 0.16818519E-09_JPRB, 0.16819970E-09_JPRB, 0.16820667E-09_JPRB, 0.16820675E-09_JPRB, 0.16820201E-09_JPRB, 0.16819328E-09_JPRB, &
  & 0.16818058E-09_JPRB, 0.16816451E-09_JPRB, 0.16814411E-09_JPRB, 0.16812349E-09_JPRB, 0.16810676E-09_JPRB, 0.16809046E-09_JPRB, &
  & 0.16807586E-09_JPRB, 0.16805705E-09_JPRB, 0.16803137E-09_JPRB, 0.16796582E-09_JPRB /)

RGHG8(:,53, 6) = (/ &
  & 0.16756084E-09_JPRB, 0.16778075E-09_JPRB, 0.16792927E-09_JPRB, 0.16806814E-09_JPRB, 0.16822735E-09_JPRB, 0.16834806E-09_JPRB, &
  & 0.16841495E-09_JPRB, 0.16844723E-09_JPRB, 0.16846524E-09_JPRB, 0.16847691E-09_JPRB, 0.16848449E-09_JPRB, 0.16848969E-09_JPRB, &
  & 0.16848949E-09_JPRB, 0.16847901E-09_JPRB, 0.16845637E-09_JPRB, 0.16842508E-09_JPRB, 0.16839122E-09_JPRB, 0.16836006E-09_JPRB, &
  & 0.16832660E-09_JPRB, 0.16829940E-09_JPRB, 0.16826592E-09_JPRB, 0.16823895E-09_JPRB, 0.16821394E-09_JPRB, 0.16820124E-09_JPRB, &
  & 0.16820156E-09_JPRB, 0.16821003E-09_JPRB, 0.16822227E-09_JPRB, 0.16823623E-09_JPRB, 0.16825089E-09_JPRB, 0.16826536E-09_JPRB, &
  & 0.16827721E-09_JPRB, 0.16828185E-09_JPRB, 0.16827380E-09_JPRB, 0.16825062E-09_JPRB, 0.16821398E-09_JPRB, 0.16816967E-09_JPRB, &
  & 0.16812261E-09_JPRB, 0.16807944E-09_JPRB, 0.16804320E-09_JPRB, 0.16801727E-09_JPRB, 0.16800525E-09_JPRB, 0.16801029E-09_JPRB, &
  & 0.16803132E-09_JPRB, 0.16806358E-09_JPRB, 0.16809955E-09_JPRB, 0.16813720E-09_JPRB, 0.16817264E-09_JPRB, 0.16820645E-09_JPRB, &
  & 0.16823359E-09_JPRB, 0.16825437E-09_JPRB, 0.16826787E-09_JPRB, 0.16827520E-09_JPRB, 0.16827853E-09_JPRB, 0.16827906E-09_JPRB, &
  & 0.16827761E-09_JPRB, 0.16827409E-09_JPRB, 0.16826901E-09_JPRB, 0.16826378E-09_JPRB, 0.16825843E-09_JPRB, 0.16825395E-09_JPRB, &
  & 0.16824853E-09_JPRB, 0.16824213E-09_JPRB, 0.16823024E-09_JPRB, 0.16819723E-09_JPRB /)

RGHG8(:,54, 6) = (/ &
  & 0.16800107E-09_JPRB, 0.16814997E-09_JPRB, 0.16823945E-09_JPRB, 0.16833913E-09_JPRB, 0.16844327E-09_JPRB, 0.16852399E-09_JPRB, &
  & 0.16856486E-09_JPRB, 0.16858485E-09_JPRB, 0.16859505E-09_JPRB, 0.16860065E-09_JPRB, 0.16860374E-09_JPRB, 0.16860352E-09_JPRB, &
  & 0.16859697E-09_JPRB, 0.16858019E-09_JPRB, 0.16854995E-09_JPRB, 0.16851277E-09_JPRB, 0.16847512E-09_JPRB, 0.16843721E-09_JPRB, &
  & 0.16840535E-09_JPRB, 0.16836660E-09_JPRB, 0.16833356E-09_JPRB, 0.16829094E-09_JPRB, 0.16825415E-09_JPRB, 0.16822822E-09_JPRB, &
  & 0.16822119E-09_JPRB, 0.16822688E-09_JPRB, 0.16823849E-09_JPRB, 0.16825280E-09_JPRB, 0.16826847E-09_JPRB, 0.16828436E-09_JPRB, &
  & 0.16829814E-09_JPRB, 0.16830477E-09_JPRB, 0.16829813E-09_JPRB, 0.16827513E-09_JPRB, 0.16823803E-09_JPRB, 0.16819178E-09_JPRB, &
  & 0.16814333E-09_JPRB, 0.16809784E-09_JPRB, 0.16805994E-09_JPRB, 0.16803291E-09_JPRB, 0.16802071E-09_JPRB, 0.16802680E-09_JPRB, &
  & 0.16805002E-09_JPRB, 0.16808457E-09_JPRB, 0.16812431E-09_JPRB, 0.16816494E-09_JPRB, 0.16820594E-09_JPRB, 0.16824253E-09_JPRB, &
  & 0.16827442E-09_JPRB, 0.16829822E-09_JPRB, 0.16831467E-09_JPRB, 0.16832566E-09_JPRB, 0.16833225E-09_JPRB, 0.16833646E-09_JPRB, &
  & 0.16833931E-09_JPRB, 0.16834095E-09_JPRB, 0.16834170E-09_JPRB, 0.16834220E-09_JPRB, 0.16834237E-09_JPRB, 0.16834228E-09_JPRB, &
  & 0.16834215E-09_JPRB, 0.16834206E-09_JPRB, 0.16834251E-09_JPRB, 0.16834724E-09_JPRB /)

RGHG8(:,55, 6) = (/ &
  & 0.16828380E-09_JPRB, 0.16839791E-09_JPRB, 0.16846607E-09_JPRB, 0.16853133E-09_JPRB, 0.16859836E-09_JPRB, 0.16864884E-09_JPRB, &
  & 0.16867496E-09_JPRB, 0.16868638E-09_JPRB, 0.16869176E-09_JPRB, 0.16869410E-09_JPRB, 0.16869411E-09_JPRB, 0.16869084E-09_JPRB, &
  & 0.16868201E-09_JPRB, 0.16866109E-09_JPRB, 0.16862842E-09_JPRB, 0.16858817E-09_JPRB, 0.16854651E-09_JPRB, 0.16850897E-09_JPRB, &
  & 0.16846820E-09_JPRB, 0.16843334E-09_JPRB, 0.16838680E-09_JPRB, 0.16834252E-09_JPRB, 0.16829203E-09_JPRB, 0.16825528E-09_JPRB, &
  & 0.16824148E-09_JPRB, 0.16824450E-09_JPRB, 0.16825558E-09_JPRB, 0.16827040E-09_JPRB, 0.16828698E-09_JPRB, 0.16830440E-09_JPRB, &
  & 0.16832001E-09_JPRB, 0.16832857E-09_JPRB, 0.16832323E-09_JPRB, 0.16830072E-09_JPRB, 0.16826285E-09_JPRB, 0.16821547E-09_JPRB, &
  & 0.16816484E-09_JPRB, 0.16811723E-09_JPRB, 0.16807745E-09_JPRB, 0.16804914E-09_JPRB, 0.16803701E-09_JPRB, 0.16804402E-09_JPRB, &
  & 0.16806853E-09_JPRB, 0.16810485E-09_JPRB, 0.16814676E-09_JPRB, 0.16819073E-09_JPRB, 0.16823395E-09_JPRB, 0.16827501E-09_JPRB, &
  & 0.16830894E-09_JPRB, 0.16833537E-09_JPRB, 0.16835414E-09_JPRB, 0.16836610E-09_JPRB, 0.16837429E-09_JPRB, 0.16838000E-09_JPRB, &
  & 0.16838410E-09_JPRB, 0.16838761E-09_JPRB, 0.16839019E-09_JPRB, 0.16839243E-09_JPRB, 0.16839428E-09_JPRB, 0.16839548E-09_JPRB, &
  & 0.16839652E-09_JPRB, 0.16839716E-09_JPRB, 0.16839749E-09_JPRB, 0.16839680E-09_JPRB /)

RGHG8(:,56, 6) = (/ &
  & 0.16853517E-09_JPRB, 0.16859503E-09_JPRB, 0.16863408E-09_JPRB, 0.16867341E-09_JPRB, 0.16871571E-09_JPRB, 0.16874607E-09_JPRB, &
  & 0.16876134E-09_JPRB, 0.16876783E-09_JPRB, 0.16877023E-09_JPRB, 0.16877054E-09_JPRB, 0.16876889E-09_JPRB, 0.16876459E-09_JPRB, &
  & 0.16875371E-09_JPRB, 0.16873325E-09_JPRB, 0.16869936E-09_JPRB, 0.16865813E-09_JPRB, 0.16861540E-09_JPRB, 0.16857166E-09_JPRB, &
  & 0.16853281E-09_JPRB, 0.16848600E-09_JPRB, 0.16844212E-09_JPRB, 0.16838449E-09_JPRB, 0.16832759E-09_JPRB, 0.16828229E-09_JPRB, &
  & 0.16826290E-09_JPRB, 0.16826356E-09_JPRB, 0.16827414E-09_JPRB, 0.16828938E-09_JPRB, 0.16830712E-09_JPRB, 0.16832592E-09_JPRB, &
  & 0.16834341E-09_JPRB, 0.16835373E-09_JPRB, 0.16834961E-09_JPRB, 0.16832738E-09_JPRB, 0.16828912E-09_JPRB, 0.16824045E-09_JPRB, &
  & 0.16818792E-09_JPRB, 0.16813814E-09_JPRB, 0.16809620E-09_JPRB, 0.16806689E-09_JPRB, 0.16805458E-09_JPRB, 0.16806227E-09_JPRB, &
  & 0.16808781E-09_JPRB, 0.16812542E-09_JPRB, 0.16816858E-09_JPRB, 0.16821423E-09_JPRB, 0.16826016E-09_JPRB, 0.16830286E-09_JPRB, &
  & 0.16833994E-09_JPRB, 0.16836854E-09_JPRB, 0.16838830E-09_JPRB, 0.16840182E-09_JPRB, 0.16841044E-09_JPRB, 0.16841636E-09_JPRB, &
  & 0.16842108E-09_JPRB, 0.16842464E-09_JPRB, 0.16842759E-09_JPRB, 0.16843041E-09_JPRB, 0.16843245E-09_JPRB, 0.16843424E-09_JPRB, &
  & 0.16843556E-09_JPRB, 0.16843676E-09_JPRB, 0.16843757E-09_JPRB, 0.16843790E-09_JPRB /)

RGHG8(:,57, 6) = (/ &
  & 0.16868563E-09_JPRB, 0.16873099E-09_JPRB, 0.16875698E-09_JPRB, 0.16878329E-09_JPRB, 0.16880711E-09_JPRB, 0.16882568E-09_JPRB, &
  & 0.16883459E-09_JPRB, 0.16883785E-09_JPRB, 0.16883853E-09_JPRB, 0.16883769E-09_JPRB, 0.16883542E-09_JPRB, 0.16883020E-09_JPRB, &
  & 0.16882022E-09_JPRB, 0.16879975E-09_JPRB, 0.16876796E-09_JPRB, 0.16872675E-09_JPRB, 0.16868133E-09_JPRB, 0.16863672E-09_JPRB, &
  & 0.16858814E-09_JPRB, 0.16854265E-09_JPRB, 0.16848492E-09_JPRB, 0.16842497E-09_JPRB, 0.16835933E-09_JPRB, 0.16830858E-09_JPRB, &
  & 0.16828586E-09_JPRB, 0.16828469E-09_JPRB, 0.16829482E-09_JPRB, 0.16831066E-09_JPRB, 0.16832935E-09_JPRB, 0.16834968E-09_JPRB, &
  & 0.16836887E-09_JPRB, 0.16838082E-09_JPRB, 0.16837770E-09_JPRB, 0.16835584E-09_JPRB, 0.16831703E-09_JPRB, 0.16826732E-09_JPRB, &
  & 0.16821311E-09_JPRB, 0.16816099E-09_JPRB, 0.16811733E-09_JPRB, 0.16808664E-09_JPRB, 0.16807432E-09_JPRB, 0.16808255E-09_JPRB, &
  & 0.16810867E-09_JPRB, 0.16814669E-09_JPRB, 0.16819100E-09_JPRB, 0.16823751E-09_JPRB, 0.16828457E-09_JPRB, 0.16832905E-09_JPRB, &
  & 0.16836788E-09_JPRB, 0.16839849E-09_JPRB, 0.16842042E-09_JPRB, 0.16843432E-09_JPRB, 0.16844337E-09_JPRB, 0.16844956E-09_JPRB, &
  & 0.16845383E-09_JPRB, 0.16845730E-09_JPRB, 0.16845994E-09_JPRB, 0.16846240E-09_JPRB, 0.16846463E-09_JPRB, 0.16846621E-09_JPRB, &
  & 0.16846760E-09_JPRB, 0.16846857E-09_JPRB, 0.16846904E-09_JPRB, 0.16846784E-09_JPRB /)

RGHG8(:,58, 6) = (/ &
  & 0.16880934E-09_JPRB, 0.16883739E-09_JPRB, 0.16885453E-09_JPRB, 0.16886936E-09_JPRB, 0.16888463E-09_JPRB, 0.16889486E-09_JPRB, &
  & 0.16889985E-09_JPRB, 0.16890128E-09_JPRB, 0.16890106E-09_JPRB, 0.16889981E-09_JPRB, 0.16889717E-09_JPRB, 0.16889252E-09_JPRB, &
  & 0.16888271E-09_JPRB, 0.16886498E-09_JPRB, 0.16883511E-09_JPRB, 0.16879526E-09_JPRB, 0.16874883E-09_JPRB, 0.16869794E-09_JPRB, &
  & 0.16864761E-09_JPRB, 0.16858916E-09_JPRB, 0.16852963E-09_JPRB, 0.16845857E-09_JPRB, 0.16838830E-09_JPRB, 0.16833561E-09_JPRB, &
  & 0.16831099E-09_JPRB, 0.16830863E-09_JPRB, 0.16831847E-09_JPRB, 0.16833478E-09_JPRB, 0.16835469E-09_JPRB, 0.16837635E-09_JPRB, &
  & 0.16839724E-09_JPRB, 0.16841067E-09_JPRB, 0.16840837E-09_JPRB, 0.16838653E-09_JPRB, 0.16834721E-09_JPRB, 0.16829652E-09_JPRB, &
  & 0.16824070E-09_JPRB, 0.16818698E-09_JPRB, 0.16814122E-09_JPRB, 0.16810967E-09_JPRB, 0.16809691E-09_JPRB, 0.16810532E-09_JPRB, &
  & 0.16813161E-09_JPRB, 0.16817016E-09_JPRB, 0.16821447E-09_JPRB, 0.16826181E-09_JPRB, 0.16830919E-09_JPRB, 0.16835440E-09_JPRB, &
  & 0.16839452E-09_JPRB, 0.16842705E-09_JPRB, 0.16845041E-09_JPRB, 0.16846577E-09_JPRB, 0.16847518E-09_JPRB, 0.16848099E-09_JPRB, &
  & 0.16848503E-09_JPRB, 0.16848772E-09_JPRB, 0.16848971E-09_JPRB, 0.16849203E-09_JPRB, 0.16849391E-09_JPRB, 0.16849558E-09_JPRB, &
  & 0.16849680E-09_JPRB, 0.16849766E-09_JPRB, 0.16849779E-09_JPRB, 0.16849588E-09_JPRB /)

RGHG8(:,59, 6) = (/ &
  & 0.16889762E-09_JPRB, 0.16892074E-09_JPRB, 0.16893245E-09_JPRB, 0.16894286E-09_JPRB, 0.16895138E-09_JPRB, 0.16895778E-09_JPRB, &
  & 0.16896051E-09_JPRB, 0.16896111E-09_JPRB, 0.16896057E-09_JPRB, 0.16895919E-09_JPRB, 0.16895692E-09_JPRB, 0.16895246E-09_JPRB, &
  & 0.16894436E-09_JPRB, 0.16892832E-09_JPRB, 0.16890191E-09_JPRB, 0.16886362E-09_JPRB, 0.16881557E-09_JPRB, 0.16876146E-09_JPRB, &
  & 0.16870105E-09_JPRB, 0.16863894E-09_JPRB, 0.16856667E-09_JPRB, 0.16849080E-09_JPRB, 0.16841759E-09_JPRB, 0.16836409E-09_JPRB, &
  & 0.16833902E-09_JPRB, 0.16833598E-09_JPRB, 0.16834584E-09_JPRB, 0.16836288E-09_JPRB, 0.16838383E-09_JPRB, 0.16840696E-09_JPRB, &
  & 0.16842931E-09_JPRB, 0.16844401E-09_JPRB, 0.16844232E-09_JPRB, 0.16842028E-09_JPRB, 0.16838025E-09_JPRB, 0.16832867E-09_JPRB, &
  & 0.16827179E-09_JPRB, 0.16821630E-09_JPRB, 0.16816938E-09_JPRB, 0.16813646E-09_JPRB, 0.16812336E-09_JPRB, 0.16813155E-09_JPRB, &
  & 0.16815777E-09_JPRB, 0.16819579E-09_JPRB, 0.16824062E-09_JPRB, 0.16828763E-09_JPRB, 0.16833537E-09_JPRB, 0.16838066E-09_JPRB, &
  & 0.16842137E-09_JPRB, 0.16845515E-09_JPRB, 0.16848022E-09_JPRB, 0.16849681E-09_JPRB, 0.16850665E-09_JPRB, 0.16851240E-09_JPRB, &
  & 0.16851559E-09_JPRB, 0.16851737E-09_JPRB, 0.16851848E-09_JPRB, 0.16852035E-09_JPRB, 0.16852231E-09_JPRB, 0.16852383E-09_JPRB, &
  & 0.16852503E-09_JPRB, 0.16852562E-09_JPRB, 0.16852525E-09_JPRB, 0.16852214E-09_JPRB /)

RGHG8(:,60, 6) = (/ &
  & 0.16897575E-09_JPRB, 0.16899208E-09_JPRB, 0.16900054E-09_JPRB, 0.16900706E-09_JPRB, 0.16901296E-09_JPRB, 0.16901677E-09_JPRB, &
  & 0.16901858E-09_JPRB, 0.16901887E-09_JPRB, 0.16901837E-09_JPRB, 0.16901733E-09_JPRB, 0.16901532E-09_JPRB, 0.16901186E-09_JPRB, &
  & 0.16900464E-09_JPRB, 0.16899127E-09_JPRB, 0.16896730E-09_JPRB, 0.16893101E-09_JPRB, 0.16888213E-09_JPRB, 0.16882244E-09_JPRB, &
  & 0.16875668E-09_JPRB, 0.16868301E-09_JPRB, 0.16860541E-09_JPRB, 0.16852347E-09_JPRB, 0.16844857E-09_JPRB, 0.16839592E-09_JPRB, &
  & 0.16837060E-09_JPRB, 0.16836733E-09_JPRB, 0.16837753E-09_JPRB, 0.16839541E-09_JPRB, 0.16841760E-09_JPRB, 0.16844212E-09_JPRB, &
  & 0.16846592E-09_JPRB, 0.16848166E-09_JPRB, 0.16848023E-09_JPRB, 0.16845769E-09_JPRB, 0.16841696E-09_JPRB, 0.16836472E-09_JPRB, &
  & 0.16830677E-09_JPRB, 0.16825057E-09_JPRB, 0.16820209E-09_JPRB, 0.16816847E-09_JPRB, 0.16815452E-09_JPRB, 0.16816218E-09_JPRB, &
  & 0.16818755E-09_JPRB, 0.16822543E-09_JPRB, 0.16826926E-09_JPRB, 0.16831649E-09_JPRB, 0.16836377E-09_JPRB, 0.16840904E-09_JPRB, &
  & 0.16845005E-09_JPRB, 0.16848432E-09_JPRB, 0.16851057E-09_JPRB, 0.16852839E-09_JPRB, 0.16853895E-09_JPRB, 0.16854437E-09_JPRB, &
  & 0.16854675E-09_JPRB, 0.16854715E-09_JPRB, 0.16854704E-09_JPRB, 0.16854880E-09_JPRB, 0.16855074E-09_JPRB, 0.16855245E-09_JPRB, &
  & 0.16855359E-09_JPRB, 0.16855396E-09_JPRB, 0.16855299E-09_JPRB, 0.16854802E-09_JPRB /)

RGHG8(:,61, 6) = (/ &
  & 0.16904025E-09_JPRB, 0.16905444E-09_JPRB, 0.16906117E-09_JPRB, 0.16906634E-09_JPRB, 0.16907044E-09_JPRB, 0.16907345E-09_JPRB, &
  & 0.16907492E-09_JPRB, 0.16907539E-09_JPRB, 0.16907524E-09_JPRB, 0.16907456E-09_JPRB, 0.16907327E-09_JPRB, 0.16907042E-09_JPRB, &
  & 0.16906483E-09_JPRB, 0.16905294E-09_JPRB, 0.16903147E-09_JPRB, 0.16899651E-09_JPRB, 0.16894645E-09_JPRB, 0.16888287E-09_JPRB, &
  & 0.16880930E-09_JPRB, 0.16872986E-09_JPRB, 0.16864475E-09_JPRB, 0.16855942E-09_JPRB, 0.16848430E-09_JPRB, 0.16843166E-09_JPRB, &
  & 0.16840644E-09_JPRB, 0.16840335E-09_JPRB, 0.16841421E-09_JPRB, 0.16843320E-09_JPRB, 0.16845675E-09_JPRB, 0.16848278E-09_JPRB, &
  & 0.16850787E-09_JPRB, 0.16852439E-09_JPRB, 0.16852293E-09_JPRB, 0.16849969E-09_JPRB, 0.16845819E-09_JPRB, 0.16840536E-09_JPRB, &
  & 0.16834721E-09_JPRB, 0.16829006E-09_JPRB, 0.16824110E-09_JPRB, 0.16820628E-09_JPRB, 0.16819149E-09_JPRB, 0.16819814E-09_JPRB, &
  & 0.16822266E-09_JPRB, 0.16825900E-09_JPRB, 0.16830254E-09_JPRB, 0.16834857E-09_JPRB, 0.16839545E-09_JPRB, 0.16844036E-09_JPRB, &
  & 0.16848138E-09_JPRB, 0.16851612E-09_JPRB, 0.16854296E-09_JPRB, 0.16856166E-09_JPRB, 0.16857299E-09_JPRB, 0.16857817E-09_JPRB, &
  & 0.16857947E-09_JPRB, 0.16857815E-09_JPRB, 0.16857638E-09_JPRB, 0.16857801E-09_JPRB, 0.16858046E-09_JPRB, 0.16858248E-09_JPRB, &
  & 0.16858376E-09_JPRB, 0.16858379E-09_JPRB, 0.16858168E-09_JPRB, 0.16857360E-09_JPRB /)

RGHG8(:,62, 6) = (/ &
  & 0.16910044E-09_JPRB, 0.16911235E-09_JPRB, 0.16911800E-09_JPRB, 0.16912224E-09_JPRB, 0.16912588E-09_JPRB, 0.16912853E-09_JPRB, &
  & 0.16913021E-09_JPRB, 0.16913100E-09_JPRB, 0.16913132E-09_JPRB, 0.16913124E-09_JPRB, 0.16913054E-09_JPRB, 0.16912878E-09_JPRB, &
  & 0.16912416E-09_JPRB, 0.16911422E-09_JPRB, 0.16909410E-09_JPRB, 0.16905997E-09_JPRB, 0.16900882E-09_JPRB, 0.16894140E-09_JPRB, &
  & 0.16886320E-09_JPRB, 0.16877771E-09_JPRB, 0.16868842E-09_JPRB, 0.16860069E-09_JPRB, 0.16852472E-09_JPRB, 0.16847244E-09_JPRB, &
  & 0.16844733E-09_JPRB, 0.16844472E-09_JPRB, 0.16845665E-09_JPRB, 0.16847709E-09_JPRB, 0.16850230E-09_JPRB, 0.16852994E-09_JPRB, &
  & 0.16855621E-09_JPRB, 0.16857324E-09_JPRB, 0.16857139E-09_JPRB, 0.16854729E-09_JPRB, 0.16850502E-09_JPRB, 0.16845206E-09_JPRB, &
  & 0.16839381E-09_JPRB, 0.16833658E-09_JPRB, 0.16828686E-09_JPRB, 0.16825144E-09_JPRB, 0.16823543E-09_JPRB, 0.16824078E-09_JPRB, &
  & 0.16826360E-09_JPRB, 0.16829876E-09_JPRB, 0.16834037E-09_JPRB, 0.16838556E-09_JPRB, 0.16843117E-09_JPRB, 0.16847546E-09_JPRB, &
  & 0.16851637E-09_JPRB, 0.16855123E-09_JPRB, 0.16857844E-09_JPRB, 0.16859784E-09_JPRB, 0.16860953E-09_JPRB, 0.16861464E-09_JPRB, &
  & 0.16861493E-09_JPRB, 0.16861150E-09_JPRB, 0.16860752E-09_JPRB, 0.16860935E-09_JPRB, 0.16861246E-09_JPRB, 0.16861521E-09_JPRB, &
  & 0.16861673E-09_JPRB, 0.16861623E-09_JPRB, 0.16861233E-09_JPRB, 0.16859876E-09_JPRB /)

RGHG8(:,63, 6) = (/ &
  & 0.16915434E-09_JPRB, 0.16916604E-09_JPRB, 0.16917168E-09_JPRB, 0.16917595E-09_JPRB, 0.16917956E-09_JPRB, 0.16918253E-09_JPRB, &
  & 0.16918460E-09_JPRB, 0.16918603E-09_JPRB, 0.16918697E-09_JPRB, 0.16918764E-09_JPRB, 0.16918780E-09_JPRB, 0.16918701E-09_JPRB, &
  & 0.16918378E-09_JPRB, 0.16917476E-09_JPRB, 0.16915555E-09_JPRB, 0.16912144E-09_JPRB, 0.16906897E-09_JPRB, 0.16899962E-09_JPRB, &
  & 0.16891821E-09_JPRB, 0.16882921E-09_JPRB, 0.16873672E-09_JPRB, 0.16864701E-09_JPRB, 0.16857091E-09_JPRB, 0.16851887E-09_JPRB, &
  & 0.16849425E-09_JPRB, 0.16849255E-09_JPRB, 0.16850593E-09_JPRB, 0.16852814E-09_JPRB, 0.16855523E-09_JPRB, 0.16858449E-09_JPRB, &
  & 0.16861193E-09_JPRB, 0.16862917E-09_JPRB, 0.16862658E-09_JPRB, 0.16860142E-09_JPRB, 0.16855867E-09_JPRB, 0.16850578E-09_JPRB, &
  & 0.16844813E-09_JPRB, 0.16839084E-09_JPRB, 0.16834110E-09_JPRB, 0.16830477E-09_JPRB, 0.16828756E-09_JPRB, 0.16829113E-09_JPRB, &
  & 0.16831213E-09_JPRB, 0.16834488E-09_JPRB, 0.16838492E-09_JPRB, 0.16842804E-09_JPRB, 0.16847221E-09_JPRB, 0.16851540E-09_JPRB, &
  & 0.16855586E-09_JPRB, 0.16859072E-09_JPRB, 0.16861815E-09_JPRB, 0.16863787E-09_JPRB, 0.16864990E-09_JPRB, 0.16865470E-09_JPRB, &
  & 0.16865405E-09_JPRB, 0.16864875E-09_JPRB, 0.16864200E-09_JPRB, 0.16864382E-09_JPRB, 0.16864798E-09_JPRB, 0.16865165E-09_JPRB, &
  & 0.16865354E-09_JPRB, 0.16865230E-09_JPRB, 0.16864574E-09_JPRB, 0.16862527E-09_JPRB /)

RGHG8(:,64, 6) = (/ &
  & 0.16920479E-09_JPRB, 0.16921696E-09_JPRB, 0.16922290E-09_JPRB, 0.16922751E-09_JPRB, 0.16923156E-09_JPRB, 0.16923503E-09_JPRB, &
  & 0.16923787E-09_JPRB, 0.16924004E-09_JPRB, 0.16924190E-09_JPRB, 0.16924341E-09_JPRB, 0.16924473E-09_JPRB, 0.16924526E-09_JPRB, &
  & 0.16924326E-09_JPRB, 0.16923540E-09_JPRB, 0.16921668E-09_JPRB, 0.16918197E-09_JPRB, 0.16912916E-09_JPRB, 0.16905817E-09_JPRB, &
  & 0.16897500E-09_JPRB, 0.16888373E-09_JPRB, 0.16878920E-09_JPRB, 0.16869851E-09_JPRB, 0.16862266E-09_JPRB, 0.16857142E-09_JPRB, &
  & 0.16854776E-09_JPRB, 0.16854738E-09_JPRB, 0.16856250E-09_JPRB, 0.16858671E-09_JPRB, 0.16861558E-09_JPRB, 0.16864635E-09_JPRB, &
  & 0.16867460E-09_JPRB, 0.16869178E-09_JPRB, 0.16868838E-09_JPRB, 0.16866214E-09_JPRB, 0.16861908E-09_JPRB, 0.16856684E-09_JPRB, &
  & 0.16851012E-09_JPRB, 0.16845353E-09_JPRB, 0.16840382E-09_JPRB, 0.16836690E-09_JPRB, 0.16834831E-09_JPRB, 0.16834995E-09_JPRB, &
  & 0.16836849E-09_JPRB, 0.16839893E-09_JPRB, 0.16843615E-09_JPRB, 0.16847715E-09_JPRB, 0.16851914E-09_JPRB, 0.16856086E-09_JPRB, &
  & 0.16860052E-09_JPRB, 0.16863509E-09_JPRB, 0.16866263E-09_JPRB, 0.16868254E-09_JPRB, 0.16869470E-09_JPRB, 0.16869912E-09_JPRB, &
  & 0.16869764E-09_JPRB, 0.16869038E-09_JPRB, 0.16868132E-09_JPRB, 0.16868290E-09_JPRB, 0.16868773E-09_JPRB, 0.16869241E-09_JPRB, &
  & 0.16869463E-09_JPRB, 0.16869253E-09_JPRB, 0.16868347E-09_JPRB, 0.16865465E-09_JPRB /)

RGHG8(:,65, 6) = (/ &
  & 0.16925170E-09_JPRB, 0.16926519E-09_JPRB, 0.16927196E-09_JPRB, 0.16927726E-09_JPRB, 0.16928195E-09_JPRB, 0.16928617E-09_JPRB, &
  & 0.16928975E-09_JPRB, 0.16929289E-09_JPRB, 0.16929565E-09_JPRB, 0.16929846E-09_JPRB, 0.16930105E-09_JPRB, 0.16930318E-09_JPRB, &
  & 0.16930249E-09_JPRB, 0.16929508E-09_JPRB, 0.16927554E-09_JPRB, 0.16924086E-09_JPRB, 0.16918751E-09_JPRB, 0.16911726E-09_JPRB, &
  & 0.16903366E-09_JPRB, 0.16894128E-09_JPRB, 0.16884580E-09_JPRB, 0.16875526E-09_JPRB, 0.16868026E-09_JPRB, 0.16863062E-09_JPRB, &
  & 0.16860836E-09_JPRB, 0.16860960E-09_JPRB, 0.16862656E-09_JPRB, 0.16865245E-09_JPRB, 0.16868283E-09_JPRB, 0.16871443E-09_JPRB, &
  & 0.16874306E-09_JPRB, 0.16875976E-09_JPRB, 0.16875543E-09_JPRB, 0.16872846E-09_JPRB, 0.16868547E-09_JPRB, 0.16863441E-09_JPRB, &
  & 0.16857928E-09_JPRB, 0.16852394E-09_JPRB, 0.16847479E-09_JPRB, 0.16843750E-09_JPRB, 0.16841772E-09_JPRB, 0.16841735E-09_JPRB, &
  & 0.16843341E-09_JPRB, 0.16846076E-09_JPRB, 0.16849522E-09_JPRB, 0.16853322E-09_JPRB, 0.16857274E-09_JPRB, 0.16861249E-09_JPRB, &
  & 0.16865108E-09_JPRB, 0.16868511E-09_JPRB, 0.16871257E-09_JPRB, 0.16873250E-09_JPRB, 0.16874467E-09_JPRB, 0.16874870E-09_JPRB, &
  & 0.16874628E-09_JPRB, 0.16873740E-09_JPRB, 0.16872627E-09_JPRB, 0.16872738E-09_JPRB, 0.16873274E-09_JPRB, 0.16873798E-09_JPRB, &
  & 0.16874054E-09_JPRB, 0.16873784E-09_JPRB, 0.16872588E-09_JPRB, 0.16869083E-09_JPRB /)

RGHG8(:,66, 6) = (/ &
  & 0.16929569E-09_JPRB, 0.16931120E-09_JPRB, 0.16931911E-09_JPRB, 0.16932541E-09_JPRB, 0.16933101E-09_JPRB, 0.16933607E-09_JPRB, &
  & 0.16934056E-09_JPRB, 0.16934458E-09_JPRB, 0.16934856E-09_JPRB, 0.16935252E-09_JPRB, 0.16935683E-09_JPRB, 0.16936053E-09_JPRB, &
  & 0.16936100E-09_JPRB, 0.16935382E-09_JPRB, 0.16933474E-09_JPRB, 0.16929985E-09_JPRB, 0.16924756E-09_JPRB, 0.16917744E-09_JPRB, &
  & 0.16909407E-09_JPRB, 0.16900183E-09_JPRB, 0.16890689E-09_JPRB, 0.16881728E-09_JPRB, 0.16874445E-09_JPRB, 0.16869663E-09_JPRB, &
  & 0.16867627E-09_JPRB, 0.16867907E-09_JPRB, 0.16869742E-09_JPRB, 0.16872459E-09_JPRB, 0.16875558E-09_JPRB, 0.16878741E-09_JPRB, &
  & 0.16881560E-09_JPRB, 0.16883139E-09_JPRB, 0.16882622E-09_JPRB, 0.16879884E-09_JPRB, 0.16875656E-09_JPRB, 0.16870712E-09_JPRB, &
  & 0.16865424E-09_JPRB, 0.16860097E-09_JPRB, 0.16855289E-09_JPRB, 0.16851591E-09_JPRB, 0.16849520E-09_JPRB, 0.16849305E-09_JPRB, &
  & 0.16850651E-09_JPRB, 0.16853081E-09_JPRB, 0.16856190E-09_JPRB, 0.16859689E-09_JPRB, 0.16863334E-09_JPRB, 0.16867104E-09_JPRB, &
  & 0.16870803E-09_JPRB, 0.16874138E-09_JPRB, 0.16876846E-09_JPRB, 0.16878825E-09_JPRB, 0.16880038E-09_JPRB, 0.16880400E-09_JPRB, &
  & 0.16880070E-09_JPRB, 0.16879029E-09_JPRB, 0.16877746E-09_JPRB, 0.16877813E-09_JPRB, 0.16878363E-09_JPRB, 0.16878929E-09_JPRB, &
  & 0.16879195E-09_JPRB, 0.16878859E-09_JPRB, 0.16877517E-09_JPRB, 0.16873314E-09_JPRB /)

RGHG8(:,67, 6) = (/ &
  & 0.16933713E-09_JPRB, 0.16935534E-09_JPRB, 0.16936481E-09_JPRB, 0.16937234E-09_JPRB, 0.16937915E-09_JPRB, 0.16938514E-09_JPRB, &
  & 0.16939067E-09_JPRB, 0.16939566E-09_JPRB, 0.16940077E-09_JPRB, 0.16940625E-09_JPRB, 0.16941189E-09_JPRB, 0.16941702E-09_JPRB, &
  & 0.16941792E-09_JPRB, 0.16941076E-09_JPRB, 0.16939126E-09_JPRB, 0.16935731E-09_JPRB, 0.16930601E-09_JPRB, 0.16923794E-09_JPRB, &
  & 0.16915618E-09_JPRB, 0.16906548E-09_JPRB, 0.16897220E-09_JPRB, 0.16888528E-09_JPRB, 0.16881488E-09_JPRB, 0.16876969E-09_JPRB, &
  & 0.16875117E-09_JPRB, 0.16875523E-09_JPRB, 0.16877442E-09_JPRB, 0.16880192E-09_JPRB, 0.16883270E-09_JPRB, 0.16886385E-09_JPRB, &
  & 0.16889100E-09_JPRB, 0.16890567E-09_JPRB, 0.16889960E-09_JPRB, 0.16887233E-09_JPRB, 0.16883120E-09_JPRB, 0.16878403E-09_JPRB, &
  & 0.16873385E-09_JPRB, 0.16868336E-09_JPRB, 0.16863708E-09_JPRB, 0.16860077E-09_JPRB, 0.16857986E-09_JPRB, 0.16857621E-09_JPRB, &
  & 0.16858735E-09_JPRB, 0.16860860E-09_JPRB, 0.16863642E-09_JPRB, 0.16866802E-09_JPRB, 0.16870152E-09_JPRB, 0.16873658E-09_JPRB, &
  & 0.16877218E-09_JPRB, 0.16880444E-09_JPRB, 0.16883095E-09_JPRB, 0.16885048E-09_JPRB, 0.16886233E-09_JPRB, 0.16886550E-09_JPRB, &
  & 0.16886142E-09_JPRB, 0.16884971E-09_JPRB, 0.16883540E-09_JPRB, 0.16883553E-09_JPRB, 0.16884108E-09_JPRB, 0.16884689E-09_JPRB, &
  & 0.16884973E-09_JPRB, 0.16884606E-09_JPRB, 0.16883007E-09_JPRB, 0.16878267E-09_JPRB /)

RGHG8(:,68, 6) = (/ &
  & 0.16937436E-09_JPRB, 0.16939736E-09_JPRB, 0.16940900E-09_JPRB, 0.16941845E-09_JPRB, 0.16942653E-09_JPRB, 0.16943402E-09_JPRB, &
  & 0.16944021E-09_JPRB, 0.16944660E-09_JPRB, 0.16945265E-09_JPRB, 0.16945950E-09_JPRB, 0.16946630E-09_JPRB, 0.16947208E-09_JPRB, &
  & 0.16947306E-09_JPRB, 0.16946601E-09_JPRB, 0.16944725E-09_JPRB, 0.16941444E-09_JPRB, 0.16936515E-09_JPRB, 0.16929924E-09_JPRB, &
  & 0.16922011E-09_JPRB, 0.16913221E-09_JPRB, 0.16904222E-09_JPRB, 0.16895860E-09_JPRB, 0.16889184E-09_JPRB, 0.16884910E-09_JPRB, &
  & 0.16883232E-09_JPRB, 0.16883714E-09_JPRB, 0.16885637E-09_JPRB, 0.16888331E-09_JPRB, 0.16891309E-09_JPRB, 0.16894292E-09_JPRB, &
  & 0.16896856E-09_JPRB, 0.16898194E-09_JPRB, 0.16897528E-09_JPRB, 0.16894848E-09_JPRB, 0.16890912E-09_JPRB, 0.16886446E-09_JPRB, &
  & 0.16881749E-09_JPRB, 0.16877010E-09_JPRB, 0.16872619E-09_JPRB, 0.16869135E-09_JPRB, 0.16867054E-09_JPRB, 0.16866603E-09_JPRB, &
  & 0.16867518E-09_JPRB, 0.16869359E-09_JPRB, 0.16871821E-09_JPRB, 0.16874671E-09_JPRB, 0.16877691E-09_JPRB, 0.16880976E-09_JPRB, &
  & 0.16884340E-09_JPRB, 0.16887457E-09_JPRB, 0.16890024E-09_JPRB, 0.16891934E-09_JPRB, 0.16893083E-09_JPRB, 0.16893359E-09_JPRB, &
  & 0.16892877E-09_JPRB, 0.16891594E-09_JPRB, 0.16890048E-09_JPRB, 0.16890013E-09_JPRB, 0.16890556E-09_JPRB, 0.16891155E-09_JPRB, &
  & 0.16891452E-09_JPRB, 0.16891073E-09_JPRB, 0.16889411E-09_JPRB, 0.16884175E-09_JPRB /)

RGHG8(:,69, 6) = (/ &
  & 0.16940976E-09_JPRB, 0.16943838E-09_JPRB, 0.16945315E-09_JPRB, 0.16946439E-09_JPRB, 0.16947448E-09_JPRB, 0.16948265E-09_JPRB, &
  & 0.16949048E-09_JPRB, 0.16949710E-09_JPRB, 0.16950492E-09_JPRB, 0.16951224E-09_JPRB, 0.16951983E-09_JPRB, 0.16952560E-09_JPRB, &
  & 0.16952652E-09_JPRB, 0.16951963E-09_JPRB, 0.16950141E-09_JPRB, 0.16947017E-09_JPRB, 0.16942345E-09_JPRB, 0.16936101E-09_JPRB, &
  & 0.16928571E-09_JPRB, 0.16920207E-09_JPRB, 0.16911662E-09_JPRB, 0.16903767E-09_JPRB, 0.16897456E-09_JPRB, 0.16893459E-09_JPRB, &
  & 0.16891902E-09_JPRB, 0.16892397E-09_JPRB, 0.16894251E-09_JPRB, 0.16896826E-09_JPRB, 0.16899639E-09_JPRB, 0.16902453E-09_JPRB, &
  & 0.16904833E-09_JPRB, 0.16906046E-09_JPRB, 0.16905338E-09_JPRB, 0.16902747E-09_JPRB, 0.16899017E-09_JPRB, 0.16894858E-09_JPRB, &
  & 0.16890500E-09_JPRB, 0.16886115E-09_JPRB, 0.16882001E-09_JPRB, 0.16878704E-09_JPRB, 0.16876697E-09_JPRB, 0.16876200E-09_JPRB, &
  & 0.16876969E-09_JPRB, 0.16878560E-09_JPRB, 0.16880730E-09_JPRB, 0.16883270E-09_JPRB, 0.16886004E-09_JPRB, 0.16889028E-09_JPRB, &
  & 0.16892225E-09_JPRB, 0.16895201E-09_JPRB, 0.16897671E-09_JPRB, 0.16899518E-09_JPRB, 0.16900616E-09_JPRB, 0.16900852E-09_JPRB, &
  & 0.16900312E-09_JPRB, 0.16898948E-09_JPRB, 0.16897322E-09_JPRB, 0.16897256E-09_JPRB, 0.16897783E-09_JPRB, 0.16898391E-09_JPRB, &
  & 0.16898707E-09_JPRB, 0.16898355E-09_JPRB, 0.16896579E-09_JPRB, 0.16890925E-09_JPRB /)

RGHG8(:,70, 6) = (/ &
  & 0.16944454E-09_JPRB, 0.16948017E-09_JPRB, 0.16949797E-09_JPRB, 0.16951167E-09_JPRB, 0.16952290E-09_JPRB, 0.16953265E-09_JPRB, &
  & 0.16954056E-09_JPRB, 0.16954892E-09_JPRB, 0.16955663E-09_JPRB, 0.16956501E-09_JPRB, 0.16957223E-09_JPRB, 0.16957798E-09_JPRB, &
  & 0.16957874E-09_JPRB, 0.16957216E-09_JPRB, 0.16955508E-09_JPRB, 0.16952570E-09_JPRB, 0.16948187E-09_JPRB, 0.16942359E-09_JPRB, &
  & 0.16935325E-09_JPRB, 0.16927519E-09_JPRB, 0.16919527E-09_JPRB, 0.16912158E-09_JPRB, 0.16906285E-09_JPRB, 0.16902524E-09_JPRB, &
  & 0.16901061E-09_JPRB, 0.16901511E-09_JPRB, 0.16903236E-09_JPRB, 0.16905628E-09_JPRB, 0.16908239E-09_JPRB, 0.16910837E-09_JPRB, &
  & 0.16913017E-09_JPRB, 0.16914105E-09_JPRB, 0.16913375E-09_JPRB, 0.16910906E-09_JPRB, 0.16907424E-09_JPRB, 0.16903590E-09_JPRB, &
  & 0.16899608E-09_JPRB, 0.16895599E-09_JPRB, 0.16891805E-09_JPRB, 0.16888747E-09_JPRB, 0.16886864E-09_JPRB, 0.16886380E-09_JPRB, &
  & 0.16887035E-09_JPRB, 0.16888430E-09_JPRB, 0.16890327E-09_JPRB, 0.16892591E-09_JPRB, 0.16895028E-09_JPRB, 0.16897825E-09_JPRB, &
  & 0.16900822E-09_JPRB, 0.16903645E-09_JPRB, 0.16906000E-09_JPRB, 0.16907768E-09_JPRB, 0.16908820E-09_JPRB, 0.16909020E-09_JPRB, &
  & 0.16908443E-09_JPRB, 0.16907052E-09_JPRB, 0.16905406E-09_JPRB, 0.16905323E-09_JPRB, 0.16905832E-09_JPRB, 0.16906453E-09_JPRB, &
  & 0.16906807E-09_JPRB, 0.16906515E-09_JPRB, 0.16904771E-09_JPRB, 0.16898816E-09_JPRB /)

RGHG8(:,71, 6) = (/ &
  & 0.16947994E-09_JPRB, 0.16952427E-09_JPRB, 0.16954493E-09_JPRB, 0.16956073E-09_JPRB, 0.16957308E-09_JPRB, 0.16958350E-09_JPRB, &
  & 0.16959233E-09_JPRB, 0.16960064E-09_JPRB, 0.16960952E-09_JPRB, 0.16961706E-09_JPRB, 0.16962436E-09_JPRB, 0.16962945E-09_JPRB, &
  & 0.16963005E-09_JPRB, 0.16962351E-09_JPRB, 0.16960724E-09_JPRB, 0.16958025E-09_JPRB, 0.16954012E-09_JPRB, 0.16948667E-09_JPRB, &
  & 0.16942209E-09_JPRB, 0.16935056E-09_JPRB, 0.16927736E-09_JPRB, 0.16920980E-09_JPRB, 0.16915548E-09_JPRB, 0.16912054E-09_JPRB, &
  & 0.16910645E-09_JPRB, 0.16911009E-09_JPRB, 0.16912555E-09_JPRB, 0.16914720E-09_JPRB, 0.16917077E-09_JPRB, 0.16919445E-09_JPRB, &
  & 0.16921405E-09_JPRB, 0.16922368E-09_JPRB, 0.16921634E-09_JPRB, 0.16919321E-09_JPRB, 0.16916113E-09_JPRB, 0.16912628E-09_JPRB, &
  & 0.16909038E-09_JPRB, 0.16905438E-09_JPRB, 0.16901999E-09_JPRB, 0.16899221E-09_JPRB, 0.16897503E-09_JPRB, 0.16897068E-09_JPRB, &
  & 0.16897671E-09_JPRB, 0.16898880E-09_JPRB, 0.16900556E-09_JPRB, 0.16902545E-09_JPRB, 0.16904714E-09_JPRB, 0.16907269E-09_JPRB, &
  & 0.16910061E-09_JPRB, 0.16912717E-09_JPRB, 0.16914936E-09_JPRB, 0.16916615E-09_JPRB, 0.16917615E-09_JPRB, 0.16917807E-09_JPRB, &
  & 0.16917227E-09_JPRB, 0.16915870E-09_JPRB, 0.16914294E-09_JPRB, 0.16914213E-09_JPRB, 0.16914702E-09_JPRB, 0.16915326E-09_JPRB, &
  & 0.16915727E-09_JPRB, 0.16915569E-09_JPRB, 0.16914034E-09_JPRB, 0.16908516E-09_JPRB /)

RGHG8(:,72, 6) = (/ &
  & 0.16951925E-09_JPRB, 0.16957039E-09_JPRB, 0.16959588E-09_JPRB, 0.16961230E-09_JPRB, 0.16962590E-09_JPRB, 0.16963610E-09_JPRB, &
  & 0.16964541E-09_JPRB, 0.16965419E-09_JPRB, 0.16966216E-09_JPRB, 0.16967019E-09_JPRB, 0.16967601E-09_JPRB, 0.16968085E-09_JPRB, &
  & 0.16968113E-09_JPRB, 0.16967480E-09_JPRB, 0.16965984E-09_JPRB, 0.16963472E-09_JPRB, 0.16959834E-09_JPRB, 0.16955037E-09_JPRB, &
  & 0.16949224E-09_JPRB, 0.16942799E-09_JPRB, 0.16936205E-09_JPRB, 0.16930111E-09_JPRB, 0.16925189E-09_JPRB, 0.16921956E-09_JPRB, &
  & 0.16920604E-09_JPRB, 0.16920843E-09_JPRB, 0.16922175E-09_JPRB, 0.16924068E-09_JPRB, 0.16926149E-09_JPRB, 0.16928252E-09_JPRB, &
  & 0.16929969E-09_JPRB, 0.16930804E-09_JPRB, 0.16930081E-09_JPRB, 0.16927947E-09_JPRB, 0.16925050E-09_JPRB, 0.16921936E-09_JPRB, &
  & 0.16918750E-09_JPRB, 0.16915577E-09_JPRB, 0.16912531E-09_JPRB, 0.16910068E-09_JPRB, 0.16908559E-09_JPRB, 0.16908205E-09_JPRB, &
  & 0.16908758E-09_JPRB, 0.16909842E-09_JPRB, 0.16911293E-09_JPRB, 0.16913038E-09_JPRB, 0.16914931E-09_JPRB, 0.16917251E-09_JPRB, &
  & 0.16919811E-09_JPRB, 0.16922264E-09_JPRB, 0.16924324E-09_JPRB, 0.16925905E-09_JPRB, 0.16926865E-09_JPRB, 0.16927072E-09_JPRB, &
  & 0.16926548E-09_JPRB, 0.16925292E-09_JPRB, 0.16923879E-09_JPRB, 0.16923826E-09_JPRB, 0.16924294E-09_JPRB, 0.16924896E-09_JPRB, &
  & 0.16925339E-09_JPRB, 0.16925292E-09_JPRB, 0.16924008E-09_JPRB, 0.16918855E-09_JPRB /)

RGHG8(:,73, 6) = (/ &
  & 0.16956690E-09_JPRB, 0.16962565E-09_JPRB, 0.16964949E-09_JPRB, 0.16966777E-09_JPRB, 0.16967996E-09_JPRB, 0.16969094E-09_JPRB, &
  & 0.16969974E-09_JPRB, 0.16970800E-09_JPRB, 0.16971655E-09_JPRB, 0.16972232E-09_JPRB, 0.16972845E-09_JPRB, 0.16973190E-09_JPRB, &
  & 0.16973171E-09_JPRB, 0.16972529E-09_JPRB, 0.16971112E-09_JPRB, 0.16968880E-09_JPRB, 0.16965618E-09_JPRB, 0.16961382E-09_JPRB, &
  & 0.16956242E-09_JPRB, 0.16950613E-09_JPRB, 0.16944812E-09_JPRB, 0.16939446E-09_JPRB, 0.16935066E-09_JPRB, 0.16932127E-09_JPRB, &
  & 0.16930833E-09_JPRB, 0.16930934E-09_JPRB, 0.16932034E-09_JPRB, 0.16933628E-09_JPRB, 0.16935404E-09_JPRB, 0.16937235E-09_JPRB, &
  & 0.16938689E-09_JPRB, 0.16939400E-09_JPRB, 0.16938699E-09_JPRB, 0.16936771E-09_JPRB, 0.16934201E-09_JPRB, 0.16931474E-09_JPRB, &
  & 0.16928707E-09_JPRB, 0.16925977E-09_JPRB, 0.16923342E-09_JPRB, 0.16921221E-09_JPRB, 0.16919925E-09_JPRB, 0.16919667E-09_JPRB, &
  & 0.16920196E-09_JPRB, 0.16921139E-09_JPRB, 0.16922413E-09_JPRB, 0.16923911E-09_JPRB, 0.16925543E-09_JPRB, 0.16927607E-09_JPRB, &
  & 0.16929919E-09_JPRB, 0.16932136E-09_JPRB, 0.16934026E-09_JPRB, 0.16935491E-09_JPRB, 0.16936416E-09_JPRB, 0.16936660E-09_JPRB, &
  & 0.16936214E-09_JPRB, 0.16935134E-09_JPRB, 0.16933947E-09_JPRB, 0.16933936E-09_JPRB, 0.16934362E-09_JPRB, 0.16934934E-09_JPRB, &
  & 0.16935377E-09_JPRB, 0.16935411E-09_JPRB, 0.16934283E-09_JPRB, 0.16929554E-09_JPRB /)

RGHG8(:,74, 6) = (/ &
  & 0.16962284E-09_JPRB, 0.16968067E-09_JPRB, 0.16970730E-09_JPRB, 0.16972317E-09_JPRB, 0.16973567E-09_JPRB, 0.16974526E-09_JPRB, &
  & 0.16975391E-09_JPRB, 0.16976204E-09_JPRB, 0.16976853E-09_JPRB, 0.16977506E-09_JPRB, 0.16977877E-09_JPRB, 0.16978219E-09_JPRB, &
  & 0.16978155E-09_JPRB, 0.16977504E-09_JPRB, 0.16976202E-09_JPRB, 0.16974180E-09_JPRB, 0.16971345E-09_JPRB, 0.16967681E-09_JPRB, &
  & 0.16963275E-09_JPRB, 0.16958453E-09_JPRB, 0.16953473E-09_JPRB, 0.16948870E-09_JPRB, 0.16945070E-09_JPRB, 0.16942457E-09_JPRB, &
  & 0.16941246E-09_JPRB, 0.16941218E-09_JPRB, 0.16942076E-09_JPRB, 0.16943368E-09_JPRB, 0.16944825E-09_JPRB, 0.16946358E-09_JPRB, &
  & 0.16947535E-09_JPRB, 0.16948119E-09_JPRB, 0.16947456E-09_JPRB, 0.16945752E-09_JPRB, 0.16943533E-09_JPRB, 0.16941201E-09_JPRB, &
  & 0.16938854E-09_JPRB, 0.16936573E-09_JPRB, 0.16934376E-09_JPRB, 0.16932612E-09_JPRB, 0.16931545E-09_JPRB, 0.16931384E-09_JPRB, &
  & 0.16931874E-09_JPRB, 0.16932700E-09_JPRB, 0.16933790E-09_JPRB, 0.16935069E-09_JPRB, 0.16936440E-09_JPRB, 0.16938247E-09_JPRB, &
  & 0.16940252E-09_JPRB, 0.16942225E-09_JPRB, 0.16943907E-09_JPRB, 0.16945256E-09_JPRB, 0.16946131E-09_JPRB, 0.16946415E-09_JPRB, &
  & 0.16946099E-09_JPRB, 0.16945204E-09_JPRB, 0.16944222E-09_JPRB, 0.16944271E-09_JPRB, 0.16944685E-09_JPRB, 0.16945195E-09_JPRB, &
  & 0.16945625E-09_JPRB, 0.16945698E-09_JPRB, 0.16944721E-09_JPRB, 0.16940212E-09_JPRB /)

RGHG8(:,75, 6) = (/ &
  & 0.16967851E-09_JPRB, 0.16973990E-09_JPRB, 0.16976313E-09_JPRB, 0.16977872E-09_JPRB, 0.16978892E-09_JPRB, 0.16979818E-09_JPRB, &
  & 0.16980578E-09_JPRB, 0.16981265E-09_JPRB, 0.16981949E-09_JPRB, 0.16982341E-09_JPRB, 0.16982740E-09_JPRB, 0.16982932E-09_JPRB, &
  & 0.16982837E-09_JPRB, 0.16982216E-09_JPRB, 0.16981026E-09_JPRB, 0.16979332E-09_JPRB, 0.16976931E-09_JPRB, 0.16973889E-09_JPRB, &
  & 0.16970220E-09_JPRB, 0.16966244E-09_JPRB, 0.16962115E-09_JPRB, 0.16958303E-09_JPRB, 0.16955115E-09_JPRB, 0.16952854E-09_JPRB, &
  & 0.16951765E-09_JPRB, 0.16951637E-09_JPRB, 0.16952251E-09_JPRB, 0.16953269E-09_JPRB, 0.16954391E-09_JPRB, 0.16955624E-09_JPRB, &
  & 0.16956531E-09_JPRB, 0.16956984E-09_JPRB, 0.16956378E-09_JPRB, 0.16954921E-09_JPRB, 0.16953064E-09_JPRB, 0.16951150E-09_JPRB, &
  & 0.16949225E-09_JPRB, 0.16947402E-09_JPRB, 0.16945639E-09_JPRB, 0.16944235E-09_JPRB, 0.16943393E-09_JPRB, 0.16943322E-09_JPRB, &
  & 0.16943766E-09_JPRB, 0.16944462E-09_JPRB, 0.16945387E-09_JPRB, 0.16946447E-09_JPRB, 0.16947571E-09_JPRB, 0.16949096E-09_JPRB, &
  & 0.16950805E-09_JPRB, 0.16952480E-09_JPRB, 0.16953956E-09_JPRB, 0.16955143E-09_JPRB, 0.16955963E-09_JPRB, 0.16956272E-09_JPRB, &
  & 0.16956062E-09_JPRB, 0.16955345E-09_JPRB, 0.16954552E-09_JPRB, 0.16954663E-09_JPRB, 0.16955043E-09_JPRB, 0.16955529E-09_JPRB, &
  & 0.16955931E-09_JPRB, 0.16956021E-09_JPRB, 0.16955086E-09_JPRB, 0.16950819E-09_JPRB /)

RGHG8(:,76, 6) = (/ &
  & 0.16973936E-09_JPRB, 0.16979647E-09_JPRB, 0.16981816E-09_JPRB, 0.16983098E-09_JPRB, 0.16983963E-09_JPRB, 0.16984714E-09_JPRB, &
  & 0.16985376E-09_JPRB, 0.16985999E-09_JPRB, 0.16986483E-09_JPRB, 0.16986869E-09_JPRB, 0.16987069E-09_JPRB, 0.16987246E-09_JPRB, &
  & 0.16987156E-09_JPRB, 0.16986623E-09_JPRB, 0.16985603E-09_JPRB, 0.16984229E-09_JPRB, 0.16982334E-09_JPRB, 0.16979956E-09_JPRB, &
  & 0.16977045E-09_JPRB, 0.16973929E-09_JPRB, 0.16970665E-09_JPRB, 0.16967656E-09_JPRB, 0.16965113E-09_JPRB, 0.16963253E-09_JPRB, &
  & 0.16962332E-09_JPRB, 0.16962139E-09_JPRB, 0.16962537E-09_JPRB, 0.16963303E-09_JPRB, 0.16964094E-09_JPRB, 0.16965031E-09_JPRB, &
  & 0.16965673E-09_JPRB, 0.16965999E-09_JPRB, 0.16965467E-09_JPRB, 0.16964286E-09_JPRB, 0.16962806E-09_JPRB, 0.16961325E-09_JPRB, &
  & 0.16959821E-09_JPRB, 0.16958443E-09_JPRB, 0.16957123E-09_JPRB, 0.16956080E-09_JPRB, 0.16955468E-09_JPRB, 0.16955479E-09_JPRB, &
  & 0.16955859E-09_JPRB, 0.16956428E-09_JPRB, 0.16957179E-09_JPRB, 0.16958038E-09_JPRB, 0.16958918E-09_JPRB, 0.16960165E-09_JPRB, &
  & 0.16961538E-09_JPRB, 0.16962903E-09_JPRB, 0.16964136E-09_JPRB, 0.16965131E-09_JPRB, 0.16965845E-09_JPRB, 0.16966131E-09_JPRB, &
  & 0.16966022E-09_JPRB, 0.16965480E-09_JPRB, 0.16964825E-09_JPRB, 0.16965007E-09_JPRB, 0.16965380E-09_JPRB, 0.16965812E-09_JPRB, &
  & 0.16966181E-09_JPRB, 0.16966281E-09_JPRB, 0.16965394E-09_JPRB, 0.16961173E-09_JPRB /)

RGHG8(:,77, 6) = (/ &
  & 0.16980077E-09_JPRB, 0.16985194E-09_JPRB, 0.16986981E-09_JPRB, 0.16988003E-09_JPRB, 0.16988588E-09_JPRB, 0.16989196E-09_JPRB, &
  & 0.16989687E-09_JPRB, 0.16990154E-09_JPRB, 0.16990585E-09_JPRB, 0.16990759E-09_JPRB, 0.16990906E-09_JPRB, 0.16991018E-09_JPRB, &
  & 0.16990931E-09_JPRB, 0.16990587E-09_JPRB, 0.16989769E-09_JPRB, 0.16988774E-09_JPRB, 0.16987411E-09_JPRB, 0.16985695E-09_JPRB, &
  & 0.16983566E-09_JPRB, 0.16981305E-09_JPRB, 0.16978909E-09_JPRB, 0.16976739E-09_JPRB, 0.16974874E-09_JPRB, 0.16973470E-09_JPRB, &
  & 0.16972787E-09_JPRB, 0.16972582E-09_JPRB, 0.16972826E-09_JPRB, 0.16973366E-09_JPRB, 0.16973867E-09_JPRB, 0.16974520E-09_JPRB, &
  & 0.16974944E-09_JPRB, 0.16975167E-09_JPRB, 0.16974736E-09_JPRB, 0.16973854E-09_JPRB, 0.16972783E-09_JPRB, 0.16971745E-09_JPRB, &
  & 0.16970654E-09_JPRB, 0.16969706E-09_JPRB, 0.16968804E-09_JPRB, 0.16968101E-09_JPRB, 0.16967694E-09_JPRB, 0.16967776E-09_JPRB, &
  & 0.16968071E-09_JPRB, 0.16968500E-09_JPRB, 0.16969084E-09_JPRB, 0.16969748E-09_JPRB, 0.16970403E-09_JPRB, 0.16971355E-09_JPRB, &
  & 0.16972376E-09_JPRB, 0.16973392E-09_JPRB, 0.16974357E-09_JPRB, 0.16975123E-09_JPRB, 0.16975664E-09_JPRB, 0.16975871E-09_JPRB, &
  & 0.16975821E-09_JPRB, 0.16975449E-09_JPRB, 0.16974958E-09_JPRB, 0.16975210E-09_JPRB, 0.16975524E-09_JPRB, 0.16975898E-09_JPRB, &
  & 0.16976207E-09_JPRB, 0.16976304E-09_JPRB, 0.16975416E-09_JPRB, 0.16971388E-09_JPRB /)

RGHG8(:,78, 6) = (/ &
  & 0.16986305E-09_JPRB, 0.16990251E-09_JPRB, 0.16991496E-09_JPRB, 0.16992220E-09_JPRB, 0.16992539E-09_JPRB, 0.16992956E-09_JPRB, &
  & 0.16993276E-09_JPRB, 0.16993604E-09_JPRB, 0.16993876E-09_JPRB, 0.16993922E-09_JPRB, 0.16993959E-09_JPRB, 0.16994095E-09_JPRB, &
  & 0.16994015E-09_JPRB, 0.16993891E-09_JPRB, 0.16993285E-09_JPRB, 0.16992656E-09_JPRB, 0.16991776E-09_JPRB, 0.16990709E-09_JPRB, &
  & 0.16989264E-09_JPRB, 0.16987825E-09_JPRB, 0.16986246E-09_JPRB, 0.16984882E-09_JPRB, 0.16983709E-09_JPRB, 0.16982790E-09_JPRB, &
  & 0.16982418E-09_JPRB, 0.16982296E-09_JPRB, 0.16982478E-09_JPRB, 0.16982855E-09_JPRB, 0.16983158E-09_JPRB, 0.16983590E-09_JPRB, &
  & 0.16983824E-09_JPRB, 0.16983985E-09_JPRB, 0.16983684E-09_JPRB, 0.16983112E-09_JPRB, 0.16982443E-09_JPRB, 0.16981838E-09_JPRB, &
  & 0.16981130E-09_JPRB, 0.16980570E-09_JPRB, 0.16980031E-09_JPRB, 0.16979612E-09_JPRB, 0.16979398E-09_JPRB, 0.16979528E-09_JPRB, &
  & 0.16979713E-09_JPRB, 0.16979992E-09_JPRB, 0.16980400E-09_JPRB, 0.16980882E-09_JPRB, 0.16981315E-09_JPRB, 0.16981964E-09_JPRB, &
  & 0.16982617E-09_JPRB, 0.16983258E-09_JPRB, 0.16983939E-09_JPRB, 0.16984425E-09_JPRB, 0.16984768E-09_JPRB, 0.16984822E-09_JPRB, &
  & 0.16984802E-09_JPRB, 0.16984594E-09_JPRB, 0.16984274E-09_JPRB, 0.16984547E-09_JPRB, 0.16984766E-09_JPRB, 0.16985038E-09_JPRB, &
  & 0.16985259E-09_JPRB, 0.16985349E-09_JPRB, 0.16984696E-09_JPRB, 0.16981365E-09_JPRB /)

RGHG8(:,79, 6) = (/ &
  & 0.16990349E-09_JPRB, 0.16993092E-09_JPRB, 0.16993922E-09_JPRB, 0.16994435E-09_JPRB, 0.16994582E-09_JPRB, 0.16994921E-09_JPRB, &
  & 0.16995123E-09_JPRB, 0.16995380E-09_JPRB, 0.16995601E-09_JPRB, 0.16995547E-09_JPRB, 0.16995542E-09_JPRB, 0.16995697E-09_JPRB, &
  & 0.16995612E-09_JPRB, 0.16995620E-09_JPRB, 0.16995101E-09_JPRB, 0.16994658E-09_JPRB, 0.16994048E-09_JPRB, 0.16993314E-09_JPRB, &
  & 0.16992248E-09_JPRB, 0.16991238E-09_JPRB, 0.16990093E-09_JPRB, 0.16989180E-09_JPRB, 0.16988383E-09_JPRB, 0.16987731E-09_JPRB, &
  & 0.16987556E-09_JPRB, 0.16987492E-09_JPRB, 0.16987667E-09_JPRB, 0.16987975E-09_JPRB, 0.16988176E-09_JPRB, 0.16988497E-09_JPRB, &
  & 0.16988630E-09_JPRB, 0.16988765E-09_JPRB, 0.16988523E-09_JPRB, 0.16988122E-09_JPRB, 0.16987668E-09_JPRB, 0.16987298E-09_JPRB, &
  & 0.16986774E-09_JPRB, 0.16986405E-09_JPRB, 0.16986049E-09_JPRB, 0.16985771E-09_JPRB, 0.16985641E-09_JPRB, 0.16985789E-09_JPRB, &
  & 0.16985900E-09_JPRB, 0.16986085E-09_JPRB, 0.16986387E-09_JPRB, 0.16986750E-09_JPRB, 0.16987041E-09_JPRB, 0.16987514E-09_JPRB, &
  & 0.16987950E-09_JPRB, 0.16988377E-09_JPRB, 0.16988902E-09_JPRB, 0.16989238E-09_JPRB, 0.16989464E-09_JPRB, 0.16989438E-09_JPRB, &
  & 0.16989432E-09_JPRB, 0.16989304E-09_JPRB, 0.16989050E-09_JPRB, 0.16989334E-09_JPRB, 0.16989461E-09_JPRB, 0.16989672E-09_JPRB, &
  & 0.16989847E-09_JPRB, 0.16990083E-09_JPRB, 0.16989768E-09_JPRB, 0.16987627E-09_JPRB /)

RGHG8(:,80, 6) = (/ &
  & 0.16993035E-09_JPRB, 0.16994471E-09_JPRB, 0.16994987E-09_JPRB, 0.16995406E-09_JPRB, 0.16995461E-09_JPRB, 0.16995767E-09_JPRB, &
  & 0.16995937E-09_JPRB, 0.16996136E-09_JPRB, 0.16996371E-09_JPRB, 0.16996279E-09_JPRB, 0.16996249E-09_JPRB, 0.16996408E-09_JPRB, &
  & 0.16996324E-09_JPRB, 0.16996400E-09_JPRB, 0.16995905E-09_JPRB, 0.16995544E-09_JPRB, 0.16995058E-09_JPRB, 0.16994492E-09_JPRB, &
  & 0.16993587E-09_JPRB, 0.16992785E-09_JPRB, 0.16991833E-09_JPRB, 0.16991124E-09_JPRB, 0.16990498E-09_JPRB, 0.16989954E-09_JPRB, &
  & 0.16989873E-09_JPRB, 0.16989835E-09_JPRB, 0.16990012E-09_JPRB, 0.16990299E-09_JPRB, 0.16990456E-09_JPRB, 0.16990730E-09_JPRB, &
  & 0.16990816E-09_JPRB, 0.16990943E-09_JPRB, 0.16990725E-09_JPRB, 0.16990398E-09_JPRB, 0.16990043E-09_JPRB, 0.16989776E-09_JPRB, &
  & 0.16989328E-09_JPRB, 0.16989039E-09_JPRB, 0.16988760E-09_JPRB, 0.16988533E-09_JPRB, 0.16988434E-09_JPRB, 0.16988584E-09_JPRB, &
  & 0.16988655E-09_JPRB, 0.16988788E-09_JPRB, 0.16989038E-09_JPRB, 0.16989352E-09_JPRB, 0.16989569E-09_JPRB, 0.16989959E-09_JPRB, &
  & 0.16990284E-09_JPRB, 0.16990609E-09_JPRB, 0.16991067E-09_JPRB, 0.16991332E-09_JPRB, 0.16991512E-09_JPRB, 0.16991446E-09_JPRB, &
  & 0.16991450E-09_JPRB, 0.16991353E-09_JPRB, 0.16991110E-09_JPRB, 0.16991381E-09_JPRB, 0.16991453E-09_JPRB, 0.16991630E-09_JPRB, &
  & 0.16991808E-09_JPRB, 0.16992127E-09_JPRB, 0.16992183E-09_JPRB, 0.16991700E-09_JPRB /)

RGHG8(:,81, 6) = (/ &
  & 0.16994882E-09_JPRB, 0.16995054E-09_JPRB, 0.16995440E-09_JPRB, 0.16995817E-09_JPRB, 0.16995833E-09_JPRB, 0.16996135E-09_JPRB, &
  & 0.16996266E-09_JPRB, 0.16996521E-09_JPRB, 0.16996693E-09_JPRB, 0.16996572E-09_JPRB, 0.16996553E-09_JPRB, 0.16996732E-09_JPRB, &
  & 0.16996642E-09_JPRB, 0.16996748E-09_JPRB, 0.16996253E-09_JPRB, 0.16995939E-09_JPRB, 0.16995498E-09_JPRB, 0.16995023E-09_JPRB, &
  & 0.16994180E-09_JPRB, 0.16993484E-09_JPRB, 0.16992611E-09_JPRB, 0.16991995E-09_JPRB, 0.16991440E-09_JPRB, 0.16990935E-09_JPRB, &
  & 0.16990903E-09_JPRB, 0.16990870E-09_JPRB, 0.16991047E-09_JPRB, 0.16991328E-09_JPRB, 0.16991462E-09_JPRB, 0.16991718E-09_JPRB, &
  & 0.16991782E-09_JPRB, 0.16991902E-09_JPRB, 0.16991696E-09_JPRB, 0.16991401E-09_JPRB, 0.16991086E-09_JPRB, 0.16990873E-09_JPRB, &
  & 0.16990448E-09_JPRB, 0.16990194E-09_JPRB, 0.16989944E-09_JPRB, 0.16989743E-09_JPRB, 0.16989657E-09_JPRB, 0.16989803E-09_JPRB, &
  & 0.16989855E-09_JPRB, 0.16989962E-09_JPRB, 0.16990190E-09_JPRB, 0.16990478E-09_JPRB, 0.16990663E-09_JPRB, 0.16991020E-09_JPRB, &
  & 0.16991292E-09_JPRB, 0.16991569E-09_JPRB, 0.16992004E-09_JPRB, 0.16992240E-09_JPRB, 0.16992402E-09_JPRB, 0.16992314E-09_JPRB, &
  & 0.16992331E-09_JPRB, 0.16992244E-09_JPRB, 0.16991998E-09_JPRB, 0.16992255E-09_JPRB, 0.16992294E-09_JPRB, 0.16992459E-09_JPRB, &
  & 0.16992627E-09_JPRB, 0.16992988E-09_JPRB, 0.16993190E-09_JPRB, 0.16994486E-09_JPRB /)

RGHG8(:,82, 6) = (/ &
  & 0.16995026E-09_JPRB, 0.16995247E-09_JPRB, 0.16995641E-09_JPRB, 0.16996016E-09_JPRB, 0.16996016E-09_JPRB, 0.16996302E-09_JPRB, &
  & 0.16996458E-09_JPRB, 0.16996612E-09_JPRB, 0.16996851E-09_JPRB, 0.16996768E-09_JPRB, 0.16996729E-09_JPRB, 0.16996862E-09_JPRB, &
  & 0.16996793E-09_JPRB, 0.16996914E-09_JPRB, 0.16996431E-09_JPRB, 0.16996127E-09_JPRB, 0.16995721E-09_JPRB, 0.16995280E-09_JPRB, &
  & 0.16994486E-09_JPRB, 0.16993834E-09_JPRB, 0.16993001E-09_JPRB, 0.16992432E-09_JPRB, 0.16991915E-09_JPRB, 0.16991411E-09_JPRB, &
  & 0.16991408E-09_JPRB, 0.16991378E-09_JPRB, 0.16991555E-09_JPRB, 0.16991836E-09_JPRB, 0.16991955E-09_JPRB, 0.16992201E-09_JPRB, &
  & 0.16992251E-09_JPRB, 0.16992373E-09_JPRB, 0.16992169E-09_JPRB, 0.16991890E-09_JPRB, 0.16991597E-09_JPRB, 0.16991400E-09_JPRB, &
  & 0.16990992E-09_JPRB, 0.16990753E-09_JPRB, 0.16990520E-09_JPRB, 0.16990331E-09_JPRB, 0.16990255E-09_JPRB, 0.16990395E-09_JPRB, &
  & 0.16990438E-09_JPRB, 0.16990531E-09_JPRB, 0.16990746E-09_JPRB, 0.16991022E-09_JPRB, 0.16991193E-09_JPRB, 0.16991536E-09_JPRB, &
  & 0.16991783E-09_JPRB, 0.16992034E-09_JPRB, 0.16992463E-09_JPRB, 0.16992685E-09_JPRB, 0.16992836E-09_JPRB, 0.16992738E-09_JPRB, &
  & 0.16992759E-09_JPRB, 0.16992679E-09_JPRB, 0.16992428E-09_JPRB, 0.16992678E-09_JPRB, 0.16992696E-09_JPRB, 0.16992849E-09_JPRB, &
  & 0.16993013E-09_JPRB, 0.16993366E-09_JPRB, 0.16993536E-09_JPRB, 0.16994710E-09_JPRB /)

RGHG8(:,83, 6) = (/ &
  & 0.16995128E-09_JPRB, 0.16995361E-09_JPRB, 0.16995755E-09_JPRB, 0.16996132E-09_JPRB, 0.16996113E-09_JPRB, 0.16996414E-09_JPRB, &
  & 0.16996522E-09_JPRB, 0.16996796E-09_JPRB, 0.16996923E-09_JPRB, 0.16996812E-09_JPRB, 0.16996800E-09_JPRB, 0.16996954E-09_JPRB, &
  & 0.16996893E-09_JPRB, 0.16997004E-09_JPRB, 0.16996522E-09_JPRB, 0.16996236E-09_JPRB, 0.16995838E-09_JPRB, 0.16995438E-09_JPRB, &
  & 0.16994647E-09_JPRB, 0.16994045E-09_JPRB, 0.16993215E-09_JPRB, 0.16992685E-09_JPRB, 0.16992176E-09_JPRB, 0.16991675E-09_JPRB, &
  & 0.16991693E-09_JPRB, 0.16991661E-09_JPRB, 0.16991845E-09_JPRB, 0.16992122E-09_JPRB, 0.16992233E-09_JPRB, 0.16992473E-09_JPRB, &
  & 0.16992516E-09_JPRB, 0.16992635E-09_JPRB, 0.16992432E-09_JPRB, 0.16992162E-09_JPRB, 0.16991876E-09_JPRB, 0.16991691E-09_JPRB, &
  & 0.16991289E-09_JPRB, 0.16991059E-09_JPRB, 0.16990839E-09_JPRB, 0.16990662E-09_JPRB, 0.16990589E-09_JPRB, 0.16990719E-09_JPRB, &
  & 0.16990762E-09_JPRB, 0.16990848E-09_JPRB, 0.16991057E-09_JPRB, 0.16991328E-09_JPRB, 0.16991489E-09_JPRB, 0.16991823E-09_JPRB, &
  & 0.16992056E-09_JPRB, 0.16992296E-09_JPRB, 0.16992724E-09_JPRB, 0.16992935E-09_JPRB, 0.16993082E-09_JPRB, 0.16992976E-09_JPRB, &
  & 0.16993000E-09_JPRB, 0.16992922E-09_JPRB, 0.16992664E-09_JPRB, 0.16992913E-09_JPRB, 0.16992918E-09_JPRB, 0.16993067E-09_JPRB, &
  & 0.16993223E-09_JPRB, 0.16993584E-09_JPRB, 0.16993733E-09_JPRB, 0.16994872E-09_JPRB /)

RGHG8(:,84, 6) = (/ &
  & 0.16995196E-09_JPRB, 0.16995431E-09_JPRB, 0.16995823E-09_JPRB, 0.16996200E-09_JPRB, 0.16996182E-09_JPRB, 0.16996463E-09_JPRB, &
  & 0.16996628E-09_JPRB, 0.16996754E-09_JPRB, 0.16996973E-09_JPRB, 0.16996914E-09_JPRB, 0.16996883E-09_JPRB, 0.16996976E-09_JPRB, &
  & 0.16996936E-09_JPRB, 0.16997019E-09_JPRB, 0.16996601E-09_JPRB, 0.16996302E-09_JPRB, 0.16995921E-09_JPRB, 0.16995523E-09_JPRB, &
  & 0.16994765E-09_JPRB, 0.16994164E-09_JPRB, 0.16993358E-09_JPRB, 0.16992840E-09_JPRB, 0.16992349E-09_JPRB, 0.16991833E-09_JPRB, &
  & 0.16991872E-09_JPRB, 0.16991838E-09_JPRB, 0.16992019E-09_JPRB, 0.16992302E-09_JPRB, 0.16992401E-09_JPRB, 0.16992638E-09_JPRB, &
  & 0.16992677E-09_JPRB, 0.16992795E-09_JPRB, 0.16992595E-09_JPRB, 0.16992323E-09_JPRB, 0.16992048E-09_JPRB, 0.16991868E-09_JPRB, &
  & 0.16991471E-09_JPRB, 0.16991245E-09_JPRB, 0.16991034E-09_JPRB, 0.16990867E-09_JPRB, 0.16990803E-09_JPRB, 0.16990923E-09_JPRB, &
  & 0.16990961E-09_JPRB, 0.16991047E-09_JPRB, 0.16991245E-09_JPRB, 0.16991512E-09_JPRB, 0.16991669E-09_JPRB, 0.16991999E-09_JPRB, &
  & 0.16992230E-09_JPRB, 0.16992453E-09_JPRB, 0.16992885E-09_JPRB, 0.16993094E-09_JPRB, 0.16993237E-09_JPRB, 0.16993126E-09_JPRB, &
  & 0.16993151E-09_JPRB, 0.16993072E-09_JPRB, 0.16992810E-09_JPRB, 0.16993057E-09_JPRB, 0.16993053E-09_JPRB, 0.16993199E-09_JPRB, &
  & 0.16993355E-09_JPRB, 0.16993715E-09_JPRB, 0.16993865E-09_JPRB, 0.16994978E-09_JPRB /)

RGHG8(:,85, 6) = (/ &
  & 0.16995241E-09_JPRB, 0.16995476E-09_JPRB, 0.16995869E-09_JPRB, 0.16996247E-09_JPRB, 0.16996213E-09_JPRB, 0.16996529E-09_JPRB, &
  & 0.16996626E-09_JPRB, 0.16996893E-09_JPRB, 0.16996979E-09_JPRB, 0.16996908E-09_JPRB, 0.16996901E-09_JPRB, 0.16997004E-09_JPRB, &
  & 0.16996970E-09_JPRB, 0.16996997E-09_JPRB, 0.16996632E-09_JPRB, 0.16996350E-09_JPRB, 0.16995981E-09_JPRB, 0.16995592E-09_JPRB, &
  & 0.16994850E-09_JPRB, 0.16994266E-09_JPRB, 0.16993446E-09_JPRB, 0.16992947E-09_JPRB, 0.16992456E-09_JPRB, 0.16991936E-09_JPRB, &
  & 0.16991990E-09_JPRB, 0.16991951E-09_JPRB, 0.16992140E-09_JPRB, 0.16992416E-09_JPRB, 0.16992513E-09_JPRB, 0.16992746E-09_JPRB, &
  & 0.16992782E-09_JPRB, 0.16992897E-09_JPRB, 0.16992695E-09_JPRB, 0.16992428E-09_JPRB, 0.16992156E-09_JPRB, 0.16991986E-09_JPRB, &
  & 0.16991587E-09_JPRB, 0.16991362E-09_JPRB, 0.16991161E-09_JPRB, 0.16990999E-09_JPRB, 0.16990939E-09_JPRB, 0.16991049E-09_JPRB, &
  & 0.16991088E-09_JPRB, 0.16991170E-09_JPRB, 0.16991374E-09_JPRB, 0.16991625E-09_JPRB, 0.16991791E-09_JPRB, 0.16992112E-09_JPRB, &
  & 0.16992337E-09_JPRB, 0.16992557E-09_JPRB, 0.16992985E-09_JPRB, 0.16993196E-09_JPRB, 0.16993336E-09_JPRB, 0.16993222E-09_JPRB, &
  & 0.16993253E-09_JPRB, 0.16993174E-09_JPRB, 0.16992903E-09_JPRB, 0.16993153E-09_JPRB, 0.16993142E-09_JPRB, 0.16993282E-09_JPRB, &
  & 0.16993443E-09_JPRB, 0.16993808E-09_JPRB, 0.16993948E-09_JPRB, 0.16995062E-09_JPRB /)

RGHG8(:,86, 6) = (/ &
  & 0.16995269E-09_JPRB, 0.16995505E-09_JPRB, 0.16995898E-09_JPRB, 0.16996285E-09_JPRB, 0.16996270E-09_JPRB, 0.16996521E-09_JPRB, &
  & 0.16996722E-09_JPRB, 0.16996816E-09_JPRB, 0.16996989E-09_JPRB, 0.16996962E-09_JPRB, 0.16996948E-09_JPRB, 0.16996987E-09_JPRB, &
  & 0.16996951E-09_JPRB, 0.16996934E-09_JPRB, 0.16996657E-09_JPRB, 0.16996379E-09_JPRB, 0.16996030E-09_JPRB, 0.16995644E-09_JPRB, &
  & 0.16994926E-09_JPRB, 0.16994338E-09_JPRB, 0.16993516E-09_JPRB, 0.16993014E-09_JPRB, 0.16992532E-09_JPRB, 0.16992002E-09_JPRB, &
  & 0.16992065E-09_JPRB, 0.16992024E-09_JPRB, 0.16992209E-09_JPRB, 0.16992495E-09_JPRB, 0.16992582E-09_JPRB, 0.16992821E-09_JPRB, &
  & 0.16992849E-09_JPRB, 0.16992964E-09_JPRB, 0.16992759E-09_JPRB, 0.16992492E-09_JPRB, 0.16992228E-09_JPRB, 0.16992061E-09_JPRB, &
  & 0.16991653E-09_JPRB, 0.16991435E-09_JPRB, 0.16991233E-09_JPRB, 0.16991078E-09_JPRB, 0.16991020E-09_JPRB, 0.16991132E-09_JPRB, &
  & 0.16991171E-09_JPRB, 0.16991258E-09_JPRB, 0.16991447E-09_JPRB, 0.16991708E-09_JPRB, 0.16991866E-09_JPRB, 0.16992183E-09_JPRB, &
  & 0.16992405E-09_JPRB, 0.16992625E-09_JPRB, 0.16993046E-09_JPRB, 0.16993254E-09_JPRB, 0.16993396E-09_JPRB, 0.16993286E-09_JPRB, &
  & 0.16993314E-09_JPRB, 0.16993237E-09_JPRB, 0.16992963E-09_JPRB, 0.16993215E-09_JPRB, 0.16993194E-09_JPRB, 0.16993337E-09_JPRB, &
  & 0.16993494E-09_JPRB, 0.16993863E-09_JPRB, 0.16994008E-09_JPRB, 0.16995108E-09_JPRB /)

RGHG8(:,87, 6) = (/ &
  & 0.16995289E-09_JPRB, 0.16995526E-09_JPRB, 0.16995910E-09_JPRB, 0.16996296E-09_JPRB, 0.16996263E-09_JPRB, 0.16996604E-09_JPRB, &
  & 0.16996682E-09_JPRB, 0.16996912E-09_JPRB, 0.16996970E-09_JPRB, 0.16996934E-09_JPRB, 0.16996929E-09_JPRB, 0.16996968E-09_JPRB, &
  & 0.16996934E-09_JPRB, 0.16996890E-09_JPRB, 0.16996646E-09_JPRB, 0.16996396E-09_JPRB, 0.16996064E-09_JPRB, 0.16995665E-09_JPRB, &
  & 0.16995005E-09_JPRB, 0.16994385E-09_JPRB, 0.16993572E-09_JPRB, 0.16993060E-09_JPRB, 0.16992577E-09_JPRB, 0.16992041E-09_JPRB, &
  & 0.16992112E-09_JPRB, 0.16992065E-09_JPRB, 0.16992260E-09_JPRB, 0.16992541E-09_JPRB, 0.16992624E-09_JPRB, 0.16992868E-09_JPRB, &
  & 0.16992888E-09_JPRB, 0.16993006E-09_JPRB, 0.16992800E-09_JPRB, 0.16992534E-09_JPRB, 0.16992271E-09_JPRB, 0.16992116E-09_JPRB, &
  & 0.16991696E-09_JPRB, 0.16991480E-09_JPRB, 0.16991278E-09_JPRB, 0.16991114E-09_JPRB, 0.16991059E-09_JPRB, 0.16991183E-09_JPRB, &
  & 0.16991220E-09_JPRB, 0.16991300E-09_JPRB, 0.16991511E-09_JPRB, 0.16991755E-09_JPRB, 0.16991927E-09_JPRB, 0.16992223E-09_JPRB, &
  & 0.16992448E-09_JPRB, 0.16992666E-09_JPRB, 0.16993079E-09_JPRB, 0.16993286E-09_JPRB, 0.16993429E-09_JPRB, 0.16993325E-09_JPRB, &
  & 0.16993354E-09_JPRB, 0.16993273E-09_JPRB, 0.16993001E-09_JPRB, 0.16993253E-09_JPRB, 0.16993228E-09_JPRB, 0.16993372E-09_JPRB, &
  & 0.16993527E-09_JPRB, 0.16993899E-09_JPRB, 0.16994038E-09_JPRB, 0.16995141E-09_JPRB /)

RGHG8(:,88, 6) = (/ &
  & 0.16995312E-09_JPRB, 0.16995555E-09_JPRB, 0.16995920E-09_JPRB, 0.16996307E-09_JPRB, 0.16996327E-09_JPRB, 0.16996554E-09_JPRB, &
  & 0.16996760E-09_JPRB, 0.16996840E-09_JPRB, 0.16996970E-09_JPRB, 0.16996954E-09_JPRB, 0.16996943E-09_JPRB, 0.16996962E-09_JPRB, &
  & 0.16996921E-09_JPRB, 0.16996879E-09_JPRB, 0.16996654E-09_JPRB, 0.16996404E-09_JPRB, 0.16996080E-09_JPRB, 0.16995699E-09_JPRB, &
  & 0.16995019E-09_JPRB, 0.16994427E-09_JPRB, 0.16993590E-09_JPRB, 0.16993089E-09_JPRB, 0.16992605E-09_JPRB, 0.16992066E-09_JPRB, &
  & 0.16992141E-09_JPRB, 0.16992091E-09_JPRB, 0.16992285E-09_JPRB, 0.16992574E-09_JPRB, 0.16992649E-09_JPRB, 0.16992900E-09_JPRB, &
  & 0.16992911E-09_JPRB, 0.16993032E-09_JPRB, 0.16992824E-09_JPRB, 0.16992559E-09_JPRB, 0.16992299E-09_JPRB, 0.16992158E-09_JPRB, &
  & 0.16991719E-09_JPRB, 0.16991512E-09_JPRB, 0.16991306E-09_JPRB, 0.16991124E-09_JPRB, 0.16991063E-09_JPRB, 0.16991220E-09_JPRB, &
  & 0.16991246E-09_JPRB, 0.16991333E-09_JPRB, 0.16991542E-09_JPRB, 0.16991795E-09_JPRB, 0.16991961E-09_JPRB, 0.16992258E-09_JPRB, &
  & 0.16992474E-09_JPRB, 0.16992699E-09_JPRB, 0.16993086E-09_JPRB, 0.16993301E-09_JPRB, 0.16993444E-09_JPRB, 0.16993348E-09_JPRB, &
  & 0.16993378E-09_JPRB, 0.16993296E-09_JPRB, 0.16993021E-09_JPRB, 0.16993276E-09_JPRB, 0.16993246E-09_JPRB, 0.16993390E-09_JPRB, &
  & 0.16993545E-09_JPRB, 0.16993926E-09_JPRB, 0.16994058E-09_JPRB, 0.16995164E-09_JPRB /)

RGHG8(:,89, 6) = (/ &
  & 0.16995344E-09_JPRB, 0.16995588E-09_JPRB, 0.16995921E-09_JPRB, 0.16996290E-09_JPRB, 0.16996281E-09_JPRB, 0.16996619E-09_JPRB, &
  & 0.16996707E-09_JPRB, 0.16996907E-09_JPRB, 0.16996970E-09_JPRB, 0.16996947E-09_JPRB, 0.16996943E-09_JPRB, 0.16996976E-09_JPRB, &
  & 0.16996948E-09_JPRB, 0.16996907E-09_JPRB, 0.16996668E-09_JPRB, 0.16996418E-09_JPRB, 0.16996088E-09_JPRB, 0.16995694E-09_JPRB, &
  & 0.16995035E-09_JPRB, 0.16994411E-09_JPRB, 0.16993601E-09_JPRB, 0.16993093E-09_JPRB, 0.16992621E-09_JPRB, 0.16992074E-09_JPRB, &
  & 0.16992160E-09_JPRB, 0.16992105E-09_JPRB, 0.16992302E-09_JPRB, 0.16992595E-09_JPRB, 0.16992660E-09_JPRB, 0.16992920E-09_JPRB, &
  & 0.16992924E-09_JPRB, 0.16993053E-09_JPRB, 0.16992838E-09_JPRB, 0.16992573E-09_JPRB, 0.16992310E-09_JPRB, 0.16992183E-09_JPRB, &
  & 0.16991729E-09_JPRB, 0.16991532E-09_JPRB, 0.16991317E-09_JPRB, 0.16991124E-09_JPRB, 0.16991052E-09_JPRB, 0.16991243E-09_JPRB, &
  & 0.16991258E-09_JPRB, 0.16991342E-09_JPRB, 0.16991569E-09_JPRB, 0.16991816E-09_JPRB, 0.16991986E-09_JPRB, 0.16992270E-09_JPRB, &
  & 0.16992494E-09_JPRB, 0.16992711E-09_JPRB, 0.16993090E-09_JPRB, 0.16993304E-09_JPRB, 0.16993451E-09_JPRB, 0.16993365E-09_JPRB, &
  & 0.16993391E-09_JPRB, 0.16993307E-09_JPRB, 0.16993028E-09_JPRB, 0.16993291E-09_JPRB, 0.16993255E-09_JPRB, 0.16993400E-09_JPRB, &
  & 0.16993551E-09_JPRB, 0.16993938E-09_JPRB, 0.16994066E-09_JPRB, 0.16995177E-09_JPRB /)

RGHG8(:,90, 6) = (/ &
  & 0.16995372E-09_JPRB, 0.16995619E-09_JPRB, 0.16995899E-09_JPRB, 0.16996290E-09_JPRB, 0.16996286E-09_JPRB, 0.16996569E-09_JPRB, &
  & 0.16996743E-09_JPRB, 0.16996865E-09_JPRB, 0.16997004E-09_JPRB, 0.16996979E-09_JPRB, 0.16996973E-09_JPRB, 0.16997012E-09_JPRB, &
  & 0.16996987E-09_JPRB, 0.16996977E-09_JPRB, 0.16996687E-09_JPRB, 0.16996415E-09_JPRB, 0.16996070E-09_JPRB, 0.16995705E-09_JPRB, &
  & 0.16994971E-09_JPRB, 0.16994407E-09_JPRB, 0.16993570E-09_JPRB, 0.16993096E-09_JPRB, 0.16992625E-09_JPRB, 0.16992066E-09_JPRB, &
  & 0.16992169E-09_JPRB, 0.16992104E-09_JPRB, 0.16992309E-09_JPRB, 0.16992607E-09_JPRB, 0.16992661E-09_JPRB, 0.16992939E-09_JPRB, &
  & 0.16992928E-09_JPRB, 0.16993074E-09_JPRB, 0.16992846E-09_JPRB, 0.16992577E-09_JPRB, 0.16992314E-09_JPRB, 0.16992201E-09_JPRB, &
  & 0.16991729E-09_JPRB, 0.16991536E-09_JPRB, 0.16991324E-09_JPRB, 0.16991114E-09_JPRB, 0.16991031E-09_JPRB, 0.16991265E-09_JPRB, &
  & 0.16991263E-09_JPRB, 0.16991340E-09_JPRB, 0.16991575E-09_JPRB, 0.16991827E-09_JPRB, 0.16991990E-09_JPRB, 0.16992287E-09_JPRB, &
  & 0.16992500E-09_JPRB, 0.16992721E-09_JPRB, 0.16993097E-09_JPRB, 0.16993316E-09_JPRB, 0.16993466E-09_JPRB, 0.16993369E-09_JPRB, &
  & 0.16993400E-09_JPRB, 0.16993318E-09_JPRB, 0.16993018E-09_JPRB, 0.16993304E-09_JPRB, 0.16993257E-09_JPRB, 0.16993405E-09_JPRB, &
  & 0.16993550E-09_JPRB, 0.16993952E-09_JPRB, 0.16994069E-09_JPRB, 0.16995197E-09_JPRB /)

RGHG8(:,91, 6) = (/ &
  & 0.16995361E-09_JPRB, 0.16995622E-09_JPRB, 0.16995805E-09_JPRB, 0.16996361E-09_JPRB, 0.16996216E-09_JPRB, 0.16996578E-09_JPRB, &
  & 0.16996626E-09_JPRB, 0.16996844E-09_JPRB, 0.16997107E-09_JPRB, 0.16997029E-09_JPRB, 0.16996966E-09_JPRB, 0.16997045E-09_JPRB, &
  & 0.16996966E-09_JPRB, 0.16997288E-09_JPRB, 0.16996610E-09_JPRB, 0.16996406E-09_JPRB, 0.16996025E-09_JPRB, 0.16995733E-09_JPRB, &
  & 0.16994900E-09_JPRB, 0.16994398E-09_JPRB, 0.16993533E-09_JPRB, 0.16993093E-09_JPRB, 0.16992634E-09_JPRB, 0.16992026E-09_JPRB, &
  & 0.16992180E-09_JPRB, 0.16992088E-09_JPRB, 0.16992303E-09_JPRB, 0.16992625E-09_JPRB, 0.16992645E-09_JPRB, 0.16992963E-09_JPRB, &
  & 0.16992920E-09_JPRB, 0.16993110E-09_JPRB, 0.16992852E-09_JPRB, 0.16992570E-09_JPRB, 0.16992302E-09_JPRB, 0.16992227E-09_JPRB, &
  & 0.16991709E-09_JPRB, 0.16991543E-09_JPRB, 0.16991328E-09_JPRB, 0.16991106E-09_JPRB, 0.16991002E-09_JPRB, 0.16991290E-09_JPRB, &
  & 0.16991251E-09_JPRB, 0.16991314E-09_JPRB, 0.16991576E-09_JPRB, 0.16991830E-09_JPRB, 0.16991958E-09_JPRB, 0.16992321E-09_JPRB, &
  & 0.16992496E-09_JPRB, 0.16992723E-09_JPRB, 0.16993128E-09_JPRB, 0.16993340E-09_JPRB, 0.16993501E-09_JPRB, 0.16993362E-09_JPRB, &
  & 0.16993415E-09_JPRB, 0.16993332E-09_JPRB, 0.16992982E-09_JPRB, 0.16993328E-09_JPRB, 0.16993247E-09_JPRB, 0.16993411E-09_JPRB, &
  & 0.16993543E-09_JPRB, 0.16993977E-09_JPRB, 0.16994067E-09_JPRB, 0.16995229E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART12',1,ZHOOK_HANDLE)
END SUBROUTINE PART12






SUBROUTINE PART13
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART13',0,ZHOOK_HANDLE)



!-- Month=  7 ------------

RGHG8(:, 1, 7) = (/ &
  & 0.42798199E-10_JPRB, 0.42747722E-10_JPRB, 0.42706366E-10_JPRB, 0.42649981E-10_JPRB, 0.42566201E-10_JPRB, 0.42448798E-10_JPRB, &
  & 0.42320855E-10_JPRB, 0.42197901E-10_JPRB, 0.42088118E-10_JPRB, 0.41993443E-10_JPRB, 0.41912331E-10_JPRB, 0.41841988E-10_JPRB, &
  & 0.41780534E-10_JPRB, 0.41724617E-10_JPRB, 0.41671902E-10_JPRB, 0.41618139E-10_JPRB, 0.41561206E-10_JPRB, 0.41498669E-10_JPRB, &
  & 0.41428284E-10_JPRB, 0.41347061E-10_JPRB, 0.41256592E-10_JPRB, 0.41159992E-10_JPRB, 0.41061831E-10_JPRB, 0.40967583E-10_JPRB, &
  & 0.40880979E-10_JPRB, 0.40803371E-10_JPRB, 0.40737257E-10_JPRB, 0.40681174E-10_JPRB, 0.40628390E-10_JPRB, 0.40571782E-10_JPRB, &
  & 0.40506487E-10_JPRB, 0.40429105E-10_JPRB, 0.40337577E-10_JPRB, 0.40225431E-10_JPRB, 0.40093512E-10_JPRB, 0.39942518E-10_JPRB, &
  & 0.39775305E-10_JPRB, 0.39595788E-10_JPRB, 0.39414409E-10_JPRB, 0.39258284E-10_JPRB, 0.39125446E-10_JPRB, 0.38987855E-10_JPRB, &
  & 0.38837097E-10_JPRB, 0.38659548E-10_JPRB, 0.38443058E-10_JPRB, 0.38155833E-10_JPRB, 0.37788786E-10_JPRB, 0.37465493E-10_JPRB, &
  & 0.37276716E-10_JPRB, 0.37125743E-10_JPRB, 0.36990834E-10_JPRB, 0.36860036E-10_JPRB, 0.36732797E-10_JPRB, 0.36595438E-10_JPRB, &
  & 0.36442977E-10_JPRB, 0.36280721E-10_JPRB, 0.36142381E-10_JPRB, 0.36012877E-10_JPRB, 0.35874075E-10_JPRB, 0.35727761E-10_JPRB, &
  & 0.35578453E-10_JPRB, 0.35423789E-10_JPRB, 0.35259483E-10_JPRB, 0.35096939E-10_JPRB /)

RGHG8(:, 2, 7) = (/ &
  & 0.42869628E-10_JPRB, 0.42850674E-10_JPRB, 0.42826388E-10_JPRB, 0.42789904E-10_JPRB, 0.42736370E-10_JPRB, 0.42665975E-10_JPRB, &
  & 0.42588693E-10_JPRB, 0.42515814E-10_JPRB, 0.42454221E-10_JPRB, 0.42404420E-10_JPRB, 0.42360893E-10_JPRB, 0.42317243E-10_JPRB, &
  & 0.42270645E-10_JPRB, 0.42222094E-10_JPRB, 0.42175652E-10_JPRB, 0.42132520E-10_JPRB, 0.42091462E-10_JPRB, 0.42048476E-10_JPRB, &
  & 0.41999553E-10_JPRB, 0.41941017E-10_JPRB, 0.41873151E-10_JPRB, 0.41798644E-10_JPRB, 0.41723056E-10_JPRB, 0.41653354E-10_JPRB, &
  & 0.41597146E-10_JPRB, 0.41559308E-10_JPRB, 0.41543484E-10_JPRB, 0.41546041E-10_JPRB, 0.41557140E-10_JPRB, 0.41564367E-10_JPRB, &
  & 0.41555662E-10_JPRB, 0.41521165E-10_JPRB, 0.41452536E-10_JPRB, 0.41345941E-10_JPRB, 0.41204245E-10_JPRB, 0.41029898E-10_JPRB, &
  & 0.40827002E-10_JPRB, 0.40602625E-10_JPRB, 0.40372955E-10_JPRB, 0.40158942E-10_JPRB, 0.39967633E-10_JPRB, 0.39783669E-10_JPRB, &
  & 0.39597003E-10_JPRB, 0.39396091E-10_JPRB, 0.39169900E-10_JPRB, 0.38907610E-10_JPRB, 0.38617422E-10_JPRB, 0.38345056E-10_JPRB, &
  & 0.38132789E-10_JPRB, 0.37962036E-10_JPRB, 0.37820091E-10_JPRB, 0.37684515E-10_JPRB, 0.37549713E-10_JPRB, 0.37397981E-10_JPRB, &
  & 0.37231409E-10_JPRB, 0.37044545E-10_JPRB, 0.36861292E-10_JPRB, 0.36678320E-10_JPRB, 0.36485155E-10_JPRB, 0.36291165E-10_JPRB, &
  & 0.36101462E-10_JPRB, 0.35903999E-10_JPRB, 0.35693056E-10_JPRB, 0.35370117E-10_JPRB /)

RGHG8(:, 3, 7) = (/ &
  & 0.43009228E-10_JPRB, 0.43025368E-10_JPRB, 0.43018852E-10_JPRB, 0.42999829E-10_JPRB, 0.42967411E-10_JPRB, 0.42921812E-10_JPRB, &
  & 0.42868670E-10_JPRB, 0.42815623E-10_JPRB, 0.42768240E-10_JPRB, 0.42731783E-10_JPRB, 0.42712944E-10_JPRB, 0.42721670E-10_JPRB, &
  & 0.42763883E-10_JPRB, 0.42834025E-10_JPRB, 0.42918297E-10_JPRB, 0.42999094E-10_JPRB, 0.43062848E-10_JPRB, 0.43100638E-10_JPRB, &
  & 0.43108371E-10_JPRB, 0.43085101E-10_JPRB, 0.43034666E-10_JPRB, 0.42963501E-10_JPRB, 0.42880859E-10_JPRB, 0.42798487E-10_JPRB, &
  & 0.42728029E-10_JPRB, 0.42676293E-10_JPRB, 0.42643989E-10_JPRB, 0.42623807E-10_JPRB, 0.42604566E-10_JPRB, 0.42574180E-10_JPRB, &
  & 0.42520463E-10_JPRB, 0.42433772E-10_JPRB, 0.42312841E-10_JPRB, 0.42158679E-10_JPRB, 0.41978664E-10_JPRB, 0.41779063E-10_JPRB, &
  & 0.41562941E-10_JPRB, 0.41335730E-10_JPRB, 0.41104189E-10_JPRB, 0.40880688E-10_JPRB, 0.40668469E-10_JPRB, 0.40464260E-10_JPRB, &
  & 0.40262075E-10_JPRB, 0.40055115E-10_JPRB, 0.39839146E-10_JPRB, 0.39610426E-10_JPRB, 0.39379444E-10_JPRB, 0.39162434E-10_JPRB, &
  & 0.38974518E-10_JPRB, 0.38811090E-10_JPRB, 0.38661407E-10_JPRB, 0.38510726E-10_JPRB, 0.38353633E-10_JPRB, 0.38178093E-10_JPRB, &
  & 0.37982287E-10_JPRB, 0.37779200E-10_JPRB, 0.37564719E-10_JPRB, 0.37328949E-10_JPRB, 0.37113326E-10_JPRB, 0.36906127E-10_JPRB, &
  & 0.36710197E-10_JPRB, 0.36522448E-10_JPRB, 0.36303245E-10_JPRB, 0.35933194E-10_JPRB /)

RGHG8(:, 4, 7) = (/ &
  & 0.43222245E-10_JPRB, 0.43315327E-10_JPRB, 0.43348720E-10_JPRB, 0.43358369E-10_JPRB, 0.43351246E-10_JPRB, 0.43332792E-10_JPRB, &
  & 0.43312000E-10_JPRB, 0.43301883E-10_JPRB, 0.43317922E-10_JPRB, 0.43375779E-10_JPRB, 0.43476757E-10_JPRB, 0.43613058E-10_JPRB, &
  & 0.43770751E-10_JPRB, 0.43932046E-10_JPRB, 0.44081291E-10_JPRB, 0.44207440E-10_JPRB, 0.44307710E-10_JPRB, 0.44380780E-10_JPRB, &
  & 0.44423923E-10_JPRB, 0.44433478E-10_JPRB, 0.44409573E-10_JPRB, 0.44354683E-10_JPRB, 0.44273564E-10_JPRB, 0.44173356E-10_JPRB, &
  & 0.44063878E-10_JPRB, 0.43954486E-10_JPRB, 0.43852689E-10_JPRB, 0.43757886E-10_JPRB, 0.43662553E-10_JPRB, 0.43554282E-10_JPRB, &
  & 0.43421822E-10_JPRB, 0.43261422E-10_JPRB, 0.43074461E-10_JPRB, 0.42864937E-10_JPRB, 0.42640998E-10_JPRB, 0.42406516E-10_JPRB, &
  & 0.42165806E-10_JPRB, 0.41916057E-10_JPRB, 0.41659530E-10_JPRB, 0.41397816E-10_JPRB, 0.41139973E-10_JPRB, 0.40887592E-10_JPRB, &
  & 0.40645341E-10_JPRB, 0.40414238E-10_JPRB, 0.40191319E-10_JPRB, 0.39975499E-10_JPRB, 0.39768158E-10_JPRB, 0.39571985E-10_JPRB, &
  & 0.39390241E-10_JPRB, 0.39217980E-10_JPRB, 0.39050162E-10_JPRB, 0.38878054E-10_JPRB, 0.38697483E-10_JPRB, 0.38502403E-10_JPRB, &
  & 0.38295214E-10_JPRB, 0.38056006E-10_JPRB, 0.37814654E-10_JPRB, 0.37590511E-10_JPRB, 0.37364167E-10_JPRB, 0.37165326E-10_JPRB, &
  & 0.36975249E-10_JPRB, 0.36793939E-10_JPRB, 0.36621362E-10_JPRB, 0.36369224E-10_JPRB /)

RGHG8(:, 5, 7) = (/ &
  & 0.43511389E-10_JPRB, 0.43725974E-10_JPRB, 0.43821526E-10_JPRB, 0.43876382E-10_JPRB, 0.43911826E-10_JPRB, 0.43944019E-10_JPRB, &
  & 0.43989579E-10_JPRB, 0.44063652E-10_JPRB, 0.44176079E-10_JPRB, 0.44335004E-10_JPRB, 0.44528752E-10_JPRB, 0.44745853E-10_JPRB, &
  & 0.44974031E-10_JPRB, 0.45203424E-10_JPRB, 0.45427086E-10_JPRB, 0.45633646E-10_JPRB, 0.45811802E-10_JPRB, 0.45954737E-10_JPRB, &
  & 0.46061842E-10_JPRB, 0.46132875E-10_JPRB, 0.46167736E-10_JPRB, 0.46164843E-10_JPRB, 0.46121867E-10_JPRB, 0.46035998E-10_JPRB, &
  & 0.45906137E-10_JPRB, 0.45734708E-10_JPRB, 0.45530558E-10_JPRB, 0.45304725E-10_JPRB, 0.45064358E-10_JPRB, 0.44814284E-10_JPRB, &
  & 0.44559550E-10_JPRB, 0.44305899E-10_JPRB, 0.44060346E-10_JPRB, 0.43823698E-10_JPRB, 0.43598146E-10_JPRB, 0.43379498E-10_JPRB, &
  & 0.43156808E-10_JPRB, 0.42924331E-10_JPRB, 0.42674059E-10_JPRB, 0.42401929E-10_JPRB, 0.42105371E-10_JPRB, 0.41790453E-10_JPRB, &
  & 0.41468835E-10_JPRB, 0.41149945E-10_JPRB, 0.40841414E-10_JPRB, 0.40540044E-10_JPRB, 0.40247146E-10_JPRB, 0.39960688E-10_JPRB, &
  & 0.39683000E-10_JPRB, 0.39414590E-10_JPRB, 0.39151179E-10_JPRB, 0.38892032E-10_JPRB, 0.38633874E-10_JPRB, 0.38375983E-10_JPRB, &
  & 0.38118186E-10_JPRB, 0.37868535E-10_JPRB, 0.37626492E-10_JPRB, 0.37380123E-10_JPRB, 0.37163210E-10_JPRB, 0.36970010E-10_JPRB, &
  & 0.36827499E-10_JPRB, 0.36724693E-10_JPRB, 0.36628020E-10_JPRB, 0.36489645E-10_JPRB /)

RGHG8(:, 6, 7) = (/ &
  & 0.43905345E-10_JPRB, 0.44285228E-10_JPRB, 0.44471579E-10_JPRB, 0.44600545E-10_JPRB, 0.44712820E-10_JPRB, 0.44829793E-10_JPRB, &
  & 0.44972699E-10_JPRB, 0.45143202E-10_JPRB, 0.45350775E-10_JPRB, 0.45595774E-10_JPRB, 0.45871102E-10_JPRB, 0.46165731E-10_JPRB, &
  & 0.46470282E-10_JPRB, 0.46772912E-10_JPRB, 0.47063728E-10_JPRB, 0.47335941E-10_JPRB, 0.47587611E-10_JPRB, 0.47813722E-10_JPRB, &
  & 0.48006453E-10_JPRB, 0.48157211E-10_JPRB, 0.48261610E-10_JPRB, 0.48317780E-10_JPRB, 0.48323245E-10_JPRB, 0.48270304E-10_JPRB, &
  & 0.48146480E-10_JPRB, 0.47940443E-10_JPRB, 0.47652417E-10_JPRB, 0.47296615E-10_JPRB, 0.46899051E-10_JPRB, 0.46488716E-10_JPRB, &
  & 0.46092477E-10_JPRB, 0.45738309E-10_JPRB, 0.45448745E-10_JPRB, 0.45234427E-10_JPRB, 0.45088770E-10_JPRB, 0.44988707E-10_JPRB, &
  & 0.44910194E-10_JPRB, 0.44830400E-10_JPRB, 0.44729630E-10_JPRB, 0.44586036E-10_JPRB, 0.44380423E-10_JPRB, 0.44098888E-10_JPRB, &
  & 0.43744262E-10_JPRB, 0.43332476E-10_JPRB, 0.42876726E-10_JPRB, 0.42388117E-10_JPRB, 0.41871555E-10_JPRB, 0.41332864E-10_JPRB, &
  & 0.40782773E-10_JPRB, 0.40232921E-10_JPRB, 0.39694362E-10_JPRB, 0.39180797E-10_JPRB, 0.38696928E-10_JPRB, 0.38250091E-10_JPRB, &
  & 0.37843072E-10_JPRB, 0.37473344E-10_JPRB, 0.37130316E-10_JPRB, 0.36835288E-10_JPRB, 0.36591619E-10_JPRB, 0.36424294E-10_JPRB, &
  & 0.36310781E-10_JPRB, 0.36238689E-10_JPRB, 0.36212373E-10_JPRB, 0.36241090E-10_JPRB /)

RGHG8(:, 7, 7) = (/ &
  & 0.44463086E-10_JPRB, 0.45046480E-10_JPRB, 0.45350577E-10_JPRB, 0.45587478E-10_JPRB, 0.45805953E-10_JPRB, 0.46035016E-10_JPRB, &
  & 0.46282117E-10_JPRB, 0.46553046E-10_JPRB, 0.46845944E-10_JPRB, 0.47168873E-10_JPRB, 0.47511585E-10_JPRB, 0.47863956E-10_JPRB, &
  & 0.48214748E-10_JPRB, 0.48555108E-10_JPRB, 0.48879675E-10_JPRB, 0.49181687E-10_JPRB, 0.49456318E-10_JPRB, 0.49700417E-10_JPRB, &
  & 0.49913670E-10_JPRB, 0.50096222E-10_JPRB, 0.50245280E-10_JPRB, 0.50352264E-10_JPRB, 0.50409520E-10_JPRB, 0.50408740E-10_JPRB, &
  & 0.50335999E-10_JPRB, 0.50172415E-10_JPRB, 0.49904213E-10_JPRB, 0.49531889E-10_JPRB, 0.49073304E-10_JPRB, 0.48564201E-10_JPRB, &
  & 0.48060583E-10_JPRB, 0.47634723E-10_JPRB, 0.47354193E-10_JPRB, 0.47248701E-10_JPRB, 0.47305583E-10_JPRB, 0.47477577E-10_JPRB, &
  & 0.47709871E-10_JPRB, 0.47954564E-10_JPRB, 0.48171057E-10_JPRB, 0.48314571E-10_JPRB, 0.48337348E-10_JPRB, 0.48197418E-10_JPRB, &
  & 0.47877358E-10_JPRB, 0.47388177E-10_JPRB, 0.46757091E-10_JPRB, 0.46002636E-10_JPRB, 0.45144926E-10_JPRB, 0.44200681E-10_JPRB, &
  & 0.43199749E-10_JPRB, 0.42174174E-10_JPRB, 0.41163524E-10_JPRB, 0.40197810E-10_JPRB, 0.39302738E-10_JPRB, 0.38498111E-10_JPRB, &
  & 0.37791274E-10_JPRB, 0.37180568E-10_JPRB, 0.36662093E-10_JPRB, 0.36231348E-10_JPRB, 0.35896619E-10_JPRB, 0.35655867E-10_JPRB, &
  & 0.35496342E-10_JPRB, 0.35408246E-10_JPRB, 0.35384102E-10_JPRB, 0.35470474E-10_JPRB /)

RGHG8(:, 8, 7) = (/ &
  & 0.45238192E-10_JPRB, 0.46017998E-10_JPRB, 0.46434214E-10_JPRB, 0.46776527E-10_JPRB, 0.47095841E-10_JPRB, 0.47428218E-10_JPRB, &
  & 0.47772418E-10_JPRB, 0.48130423E-10_JPRB, 0.48501470E-10_JPRB, 0.48883411E-10_JPRB, 0.49269127E-10_JPRB, 0.49647245E-10_JPRB, &
  & 0.50007727E-10_JPRB, 0.50342178E-10_JPRB, 0.50647344E-10_JPRB, 0.50922731E-10_JPRB, 0.51171963E-10_JPRB, 0.51399635E-10_JPRB, &
  & 0.51608391E-10_JPRB, 0.51796914E-10_JPRB, 0.51970601E-10_JPRB, 0.52132982E-10_JPRB, 0.52272270E-10_JPRB, 0.52373831E-10_JPRB, &
  & 0.52425495E-10_JPRB, 0.52404879E-10_JPRB, 0.52284500E-10_JPRB, 0.52040580E-10_JPRB, 0.51667219E-10_JPRB, 0.51197029E-10_JPRB, &
  & 0.50714672E-10_JPRB, 0.50338025E-10_JPRB, 0.50161819E-10_JPRB, 0.50229668E-10_JPRB, 0.50538709E-10_JPRB, 0.51042340E-10_JPRB, &
  & 0.51666359E-10_JPRB, 0.52335053E-10_JPRB, 0.52978361E-10_JPRB, 0.53514571E-10_JPRB, 0.53857890E-10_JPRB, 0.53931460E-10_JPRB, &
  & 0.53696336E-10_JPRB, 0.53157999E-10_JPRB, 0.52343178E-10_JPRB, 0.51286378E-10_JPRB, 0.50017337E-10_JPRB, 0.48572452E-10_JPRB, &
  & 0.47004504E-10_JPRB, 0.45374367E-10_JPRB, 0.43751006E-10_JPRB, 0.42194762E-10_JPRB, 0.40760294E-10_JPRB, 0.39477956E-10_JPRB, &
  & 0.38363260E-10_JPRB, 0.37411380E-10_JPRB, 0.36616279E-10_JPRB, 0.35964738E-10_JPRB, 0.35465957E-10_JPRB, 0.35108458E-10_JPRB, &
  & 0.34853381E-10_JPRB, 0.34681827E-10_JPRB, 0.34563404E-10_JPRB, 0.34480818E-10_JPRB /)

RGHG8(:, 9, 7) = (/ &
  & 0.46157619E-10_JPRB, 0.46959749E-10_JPRB, 0.47393360E-10_JPRB, 0.47753843E-10_JPRB, 0.48133660E-10_JPRB, 0.48513134E-10_JPRB, &
  & 0.48938173E-10_JPRB, 0.49369852E-10_JPRB, 0.49817993E-10_JPRB, 0.50264969E-10_JPRB, 0.50699538E-10_JPRB, 0.51108597E-10_JPRB, &
  & 0.51482610E-10_JPRB, 0.51815871E-10_JPRB, 0.52108744E-10_JPRB, 0.52365487E-10_JPRB, 0.52594398E-10_JPRB, 0.52805257E-10_JPRB, &
  & 0.53009933E-10_JPRB, 0.53218450E-10_JPRB, 0.53432540E-10_JPRB, 0.53656045E-10_JPRB, 0.53903583E-10_JPRB, 0.54174026E-10_JPRB, &
  & 0.54449743E-10_JPRB, 0.54704748E-10_JPRB, 0.54903658E-10_JPRB, 0.55008574E-10_JPRB, 0.54999148E-10_JPRB, 0.54884871E-10_JPRB, &
  & 0.54720083E-10_JPRB, 0.54602035E-10_JPRB, 0.54639460E-10_JPRB, 0.54915204E-10_JPRB, 0.55468893E-10_JPRB, 0.56276053E-10_JPRB, &
  & 0.57263135E-10_JPRB, 0.58333748E-10_JPRB, 0.59374956E-10_JPRB, 0.60261116E-10_JPRB, 0.60872335E-10_JPRB, 0.61110748E-10_JPRB, &
  & 0.60924869E-10_JPRB, 0.60309167E-10_JPRB, 0.59290371E-10_JPRB, 0.57903869E-10_JPRB, 0.56197293E-10_JPRB, 0.54227164E-10_JPRB, &
  & 0.52068960E-10_JPRB, 0.49813310E-10_JPRB, 0.47556490E-10_JPRB, 0.45384758E-10_JPRB, 0.43371997E-10_JPRB, 0.41566892E-10_JPRB, &
  & 0.40003213E-10_JPRB, 0.38687508E-10_JPRB, 0.37609579E-10_JPRB, 0.36756573E-10_JPRB, 0.36121786E-10_JPRB, 0.35686790E-10_JPRB, &
  & 0.35402410E-10_JPRB, 0.35224063E-10_JPRB, 0.35123588E-10_JPRB, 0.35056721E-10_JPRB /)

RGHG8(:,10, 7) = (/ &
  & 0.46729978E-10_JPRB, 0.47096625E-10_JPRB, 0.47324943E-10_JPRB, 0.47607328E-10_JPRB, 0.47934382E-10_JPRB, 0.48362404E-10_JPRB, &
  & 0.48821620E-10_JPRB, 0.49353993E-10_JPRB, 0.49900133E-10_JPRB, 0.50452378E-10_JPRB, 0.50983322E-10_JPRB, 0.51478741E-10_JPRB, &
  & 0.51930526E-10_JPRB, 0.52335383E-10_JPRB, 0.52696209E-10_JPRB, 0.53017431E-10_JPRB, 0.53308351E-10_JPRB, 0.53582062E-10_JPRB, &
  & 0.53853439E-10_JPRB, 0.54141584E-10_JPRB, 0.54472725E-10_JPRB, 0.54872999E-10_JPRB, 0.55358683E-10_JPRB, 0.55942230E-10_JPRB, &
  & 0.56613755E-10_JPRB, 0.57345743E-10_JPRB, 0.58125900E-10_JPRB, 0.58931075E-10_JPRB, 0.59712429E-10_JPRB, 0.60418510E-10_JPRB, &
  & 0.61030764E-10_JPRB, 0.61582725E-10_JPRB, 0.62157980E-10_JPRB, 0.62844570E-10_JPRB, 0.63697027E-10_JPRB, 0.64719480E-10_JPRB, &
  & 0.65867686E-10_JPRB, 0.67047638E-10_JPRB, 0.68138772E-10_JPRB, 0.69009860E-10_JPRB, 0.69545800E-10_JPRB, 0.69659986E-10_JPRB, &
  & 0.69296152E-10_JPRB, 0.68442162E-10_JPRB, 0.67117471E-10_JPRB, 0.65362750E-10_JPRB, 0.63228200E-10_JPRB, 0.60777730E-10_JPRB, &
  & 0.58106464E-10_JPRB, 0.55328180E-10_JPRB, 0.52554471E-10_JPRB, 0.49887969E-10_JPRB, 0.47415454E-10_JPRB, 0.45198192E-10_JPRB, &
  & 0.43279373E-10_JPRB, 0.41670781E-10_JPRB, 0.40370179E-10_JPRB, 0.39365948E-10_JPRB, 0.38658729E-10_JPRB, 0.38220063E-10_JPRB, &
  & 0.38004384E-10_JPRB, 0.37949876E-10_JPRB, 0.38095298E-10_JPRB, 0.38526085E-10_JPRB /)

RGHG8(:,11, 7) = (/ &
  & 0.45981215E-10_JPRB, 0.45558828E-10_JPRB, 0.45530840E-10_JPRB, 0.45694670E-10_JPRB, 0.46019983E-10_JPRB, 0.46429416E-10_JPRB, &
  & 0.46974469E-10_JPRB, 0.47566496E-10_JPRB, 0.48221951E-10_JPRB, 0.48877530E-10_JPRB, 0.49511489E-10_JPRB, 0.50108303E-10_JPRB, &
  & 0.50666513E-10_JPRB, 0.51194150E-10_JPRB, 0.51704689E-10_JPRB, 0.52206101E-10_JPRB, 0.52706860E-10_JPRB, 0.53212282E-10_JPRB, &
  & 0.53734382E-10_JPRB, 0.54289295E-10_JPRB, 0.54907641E-10_JPRB, 0.55620640E-10_JPRB, 0.56460694E-10_JPRB, 0.57456404E-10_JPRB, &
  & 0.58630149E-10_JPRB, 0.60000019E-10_JPRB, 0.61553256E-10_JPRB, 0.63280561E-10_JPRB, 0.65215028E-10_JPRB, 0.67311073E-10_JPRB, &
  & 0.69437671E-10_JPRB, 0.71440888E-10_JPRB, 0.73235640E-10_JPRB, 0.74820768E-10_JPRB, 0.76218226E-10_JPRB, 0.77439576E-10_JPRB, &
  & 0.78474810E-10_JPRB, 0.79299615E-10_JPRB, 0.79870353E-10_JPRB, 0.80130014E-10_JPRB, 0.80039010E-10_JPRB, 0.79547605E-10_JPRB, &
  & 0.78631074E-10_JPRB, 0.77275693E-10_JPRB, 0.75486485E-10_JPRB, 0.73286814E-10_JPRB, 0.70721755E-10_JPRB, 0.67870730E-10_JPRB, &
  & 0.64841521E-10_JPRB, 0.61735998E-10_JPRB, 0.58668313E-10_JPRB, 0.55737560E-10_JPRB, 0.53030292E-10_JPRB, 0.50610700E-10_JPRB, &
  & 0.48525513E-10_JPRB, 0.46792518E-10_JPRB, 0.45411914E-10_JPRB, 0.44378678E-10_JPRB, 0.43696390E-10_JPRB, 0.43341393E-10_JPRB, &
  & 0.43269853E-10_JPRB, 0.43434131E-10_JPRB, 0.43949965E-10_JPRB, 0.45166808E-10_JPRB /)

RGHG8(:,12, 7) = (/ &
  & 0.44234401E-10_JPRB, 0.43982727E-10_JPRB, 0.44116481E-10_JPRB, 0.44383330E-10_JPRB, 0.44713247E-10_JPRB, 0.45150172E-10_JPRB, &
  & 0.45652798E-10_JPRB, 0.46275490E-10_JPRB, 0.46972995E-10_JPRB, 0.47744017E-10_JPRB, 0.48557536E-10_JPRB, 0.49398072E-10_JPRB, &
  & 0.50258388E-10_JPRB, 0.51127925E-10_JPRB, 0.51999811E-10_JPRB, 0.52850089E-10_JPRB, 0.53654959E-10_JPRB, 0.54399530E-10_JPRB, &
  & 0.55103845E-10_JPRB, 0.55818416E-10_JPRB, 0.56614363E-10_JPRB, 0.57557535E-10_JPRB, 0.58693723E-10_JPRB, 0.60054878E-10_JPRB, &
  & 0.61663626E-10_JPRB, 0.63555196E-10_JPRB, 0.65821439E-10_JPRB, 0.68518885E-10_JPRB, 0.71587715E-10_JPRB, 0.75002567E-10_JPRB, &
  & 0.78635064E-10_JPRB, 0.82172158E-10_JPRB, 0.85302966E-10_JPRB, 0.87890938E-10_JPRB, 0.89896292E-10_JPRB, 0.91317384E-10_JPRB, &
  & 0.92188437E-10_JPRB, 0.92547366E-10_JPRB, 0.92433512E-10_JPRB, 0.91918938E-10_JPRB, 0.91014349E-10_JPRB, 0.89752213E-10_JPRB, &
  & 0.88131509E-10_JPRB, 0.86161245E-10_JPRB, 0.83851801E-10_JPRB, 0.81225748E-10_JPRB, 0.78340882E-10_JPRB, 0.75262421E-10_JPRB, &
  & 0.72070148E-10_JPRB, 0.68881095E-10_JPRB, 0.65797777E-10_JPRB, 0.62900671E-10_JPRB, 0.60255537E-10_JPRB, 0.57910704E-10_JPRB, &
  & 0.55901894E-10_JPRB, 0.54243325E-10_JPRB, 0.52942244E-10_JPRB, 0.52003058E-10_JPRB, 0.51440536E-10_JPRB, 0.51243867E-10_JPRB, &
  & 0.51381781E-10_JPRB, 0.51810327E-10_JPRB, 0.52758204E-10_JPRB, 0.54788840E-10_JPRB /)

RGHG8(:,13, 7) = (/ &
  & 0.44530282E-10_JPRB, 0.45387950E-10_JPRB, 0.45908277E-10_JPRB, 0.46321665E-10_JPRB, 0.46741014E-10_JPRB, 0.47204039E-10_JPRB, &
  & 0.47809423E-10_JPRB, 0.48596786E-10_JPRB, 0.49649371E-10_JPRB, 0.50990236E-10_JPRB, 0.52633918E-10_JPRB, 0.54551027E-10_JPRB, &
  & 0.56654435E-10_JPRB, 0.58806487E-10_JPRB, 0.60815547E-10_JPRB, 0.62493628E-10_JPRB, 0.63706117E-10_JPRB, 0.64391395E-10_JPRB, &
  & 0.64632945E-10_JPRB, 0.64596030E-10_JPRB, 0.64513811E-10_JPRB, 0.64621253E-10_JPRB, 0.65067250E-10_JPRB, 0.65923420E-10_JPRB, &
  & 0.67227723E-10_JPRB, 0.69035153E-10_JPRB, 0.71410156E-10_JPRB, 0.74455088E-10_JPRB, 0.78229048E-10_JPRB, 0.82545512E-10_JPRB, &
  & 0.87128499E-10_JPRB, 0.91583865E-10_JPRB, 0.95547792E-10_JPRB, 0.98787971E-10_JPRB, 0.10120671E-09_JPRB, 0.10280392E-09_JPRB, &
  & 0.10363101E-09_JPRB, 0.10373769E-09_JPRB, 0.10324381E-09_JPRB, 0.10222739E-09_JPRB, 0.10077818E-09_JPRB, 0.98978173E-10_JPRB, &
  & 0.96847516E-10_JPRB, 0.94425995E-10_JPRB, 0.91754895E-10_JPRB, 0.88871882E-10_JPRB, 0.85823605E-10_JPRB, 0.82689827E-10_JPRB, &
  & 0.79587746E-10_JPRB, 0.76599477E-10_JPRB, 0.73787677E-10_JPRB, 0.71205479E-10_JPRB, 0.68891393E-10_JPRB, 0.66869628E-10_JPRB, &
  & 0.65154840E-10_JPRB, 0.63756722E-10_JPRB, 0.62681943E-10_JPRB, 0.61942548E-10_JPRB, 0.61568459E-10_JPRB, 0.61555018E-10_JPRB, &
  & 0.61894927E-10_JPRB, 0.62526123E-10_JPRB, 0.63769816E-10_JPRB, 0.66284665E-10_JPRB /)

RGHG8(:,14, 7) = (/ &
  & 0.50842667E-10_JPRB, 0.52797780E-10_JPRB, 0.53643697E-10_JPRB, 0.54119563E-10_JPRB, 0.54488407E-10_JPRB, 0.54903974E-10_JPRB, &
  & 0.55517181E-10_JPRB, 0.56472851E-10_JPRB, 0.57895421E-10_JPRB, 0.59842693E-10_JPRB, 0.62260794E-10_JPRB, 0.64990451E-10_JPRB, &
  & 0.67799225E-10_JPRB, 0.70444650E-10_JPRB, 0.72712669E-10_JPRB, 0.74446400E-10_JPRB, 0.75547714E-10_JPRB, 0.76027337E-10_JPRB, &
  & 0.75993184E-10_JPRB, 0.75635560E-10_JPRB, 0.75169780E-10_JPRB, 0.74792388E-10_JPRB, 0.74673753E-10_JPRB, 0.74942934E-10_JPRB, &
  & 0.75697469E-10_JPRB, 0.77051754E-10_JPRB, 0.79141367E-10_JPRB, 0.82054225E-10_JPRB, 0.85833111E-10_JPRB, 0.90336780E-10_JPRB, &
  & 0.95146890E-10_JPRB, 0.99877849E-10_JPRB, 0.10411365E-09_JPRB, 0.10759005E-09_JPRB, 0.11017431E-09_JPRB, 0.11183489E-09_JPRB, &
  & 0.11259552E-09_JPRB, 0.11255913E-09_JPRB, 0.11185237E-09_JPRB, 0.11059674E-09_JPRB, 0.10888859E-09_JPRB, 0.10682968E-09_JPRB, &
  & 0.10448646E-09_JPRB, 0.10190163E-09_JPRB, 0.99128782E-10_JPRB, 0.96220698E-10_JPRB, 0.93263834E-10_JPRB, 0.90344808E-10_JPRB, &
  & 0.87530636E-10_JPRB, 0.84891170E-10_JPRB, 0.82485213E-10_JPRB, 0.80337292E-10_JPRB, 0.78454722E-10_JPRB, 0.76835295E-10_JPRB, &
  & 0.75478852E-10_JPRB, 0.74386740E-10_JPRB, 0.73566556E-10_JPRB, 0.73037916E-10_JPRB, 0.72838111E-10_JPRB, 0.72968055E-10_JPRB, &
  & 0.73436916E-10_JPRB, 0.74168546E-10_JPRB, 0.75515948E-10_JPRB, 0.78147287E-10_JPRB /)

RGHG8(:,15, 7) = (/ &
  & 0.63888603E-10_JPRB, 0.65325634E-10_JPRB, 0.65799984E-10_JPRB, 0.65931725E-10_JPRB, 0.65999983E-10_JPRB, 0.66137922E-10_JPRB, &
  & 0.66493880E-10_JPRB, 0.67248408E-10_JPRB, 0.68504563E-10_JPRB, 0.70324108E-10_JPRB, 0.72639700E-10_JPRB, 0.75275591E-10_JPRB, &
  & 0.77993507E-10_JPRB, 0.80538971E-10_JPRB, 0.82687898E-10_JPRB, 0.84293086E-10_JPRB, 0.85311050E-10_JPRB, 0.85783110E-10_JPRB, &
  & 0.85845726E-10_JPRB, 0.85666002E-10_JPRB, 0.85406654E-10_JPRB, 0.85203844E-10_JPRB, 0.85173077E-10_JPRB, 0.85424362E-10_JPRB, &
  & 0.86074342E-10_JPRB, 0.87251727E-10_JPRB, 0.89107957E-10_JPRB, 0.91765387E-10_JPRB, 0.95226514E-10_JPRB, 0.99374370E-10_JPRB, &
  & 0.10390964E-09_JPRB, 0.10835983E-09_JPRB, 0.11233473E-09_JPRB, 0.11557669E-09_JPRB, 0.11790992E-09_JPRB, 0.11930326E-09_JPRB, &
  & 0.11985633E-09_JPRB, 0.11966868E-09_JPRB, 0.11886034E-09_JPRB, 0.11754309E-09_JPRB, 0.11582042E-09_JPRB, 0.11377604E-09_JPRB, &
  & 0.11147254E-09_JPRB, 0.10897024E-09_JPRB, 0.10633035E-09_JPRB, 0.10363358E-09_JPRB, 0.10095050E-09_JPRB, 0.98354408E-10_JPRB, &
  & 0.95921972E-10_JPRB, 0.93708485E-10_JPRB, 0.91733329E-10_JPRB, 0.89993756E-10_JPRB, 0.88479744E-10_JPRB, 0.87180207E-10_JPRB, &
  & 0.86091786E-10_JPRB, 0.85217985E-10_JPRB, 0.84571621E-10_JPRB, 0.84176360E-10_JPRB, 0.84074019E-10_JPRB, 0.84272714E-10_JPRB, &
  & 0.84775735E-10_JPRB, 0.85520403E-10_JPRB, 0.86817199E-10_JPRB, 0.89326831E-10_JPRB /)

RGHG8(:,16, 7) = (/ &
  & 0.78536580E-10_JPRB, 0.78685697E-10_JPRB, 0.78444959E-10_JPRB, 0.78153629E-10_JPRB, 0.77791364E-10_JPRB, 0.77535277E-10_JPRB, &
  & 0.77494178E-10_JPRB, 0.77828369E-10_JPRB, 0.78679653E-10_JPRB, 0.80094431E-10_JPRB, 0.82039153E-10_JPRB, 0.84362892E-10_JPRB, &
  & 0.86843387E-10_JPRB, 0.89259523E-10_JPRB, 0.91413717E-10_JPRB, 0.93155435E-10_JPRB, 0.94443058E-10_JPRB, 0.95338397E-10_JPRB, &
  & 0.95937827E-10_JPRB, 0.96358477E-10_JPRB, 0.96705553E-10_JPRB, 0.97068117E-10_JPRB, 0.97528707E-10_JPRB, 0.98178549E-10_JPRB, &
  & 0.99124597E-10_JPRB, 0.10048683E-09_JPRB, 0.10237383E-09_JPRB, 0.10485257E-09_JPRB, 0.10789321E-09_JPRB, 0.11135648E-09_JPRB, &
  & 0.11495675E-09_JPRB, 0.11835090E-09_JPRB, 0.12130026E-09_JPRB, 0.12357330E-09_JPRB, 0.12511725E-09_JPRB, 0.12595713E-09_JPRB, &
  & 0.12613847E-09_JPRB, 0.12574897E-09_JPRB, 0.12491129E-09_JPRB, 0.12371007E-09_JPRB, 0.12219596E-09_JPRB, 0.12041243E-09_JPRB, &
  & 0.11840942E-09_JPRB, 0.11622685E-09_JPRB, 0.11394308E-09_JPRB, 0.11161350E-09_JPRB, 0.10931130E-09_JPRB, 0.10710859E-09_JPRB, &
  & 0.10506421E-09_JPRB, 0.10319955E-09_JPRB, 0.10151983E-09_JPRB, 0.10001502E-09_JPRB, 0.98678385E-10_JPRB, 0.97508002E-10_JPRB, &
  & 0.96512368E-10_JPRB, 0.95705339E-10_JPRB, 0.95104591E-10_JPRB, 0.94734741E-10_JPRB, 0.94635889E-10_JPRB, 0.94819791E-10_JPRB, &
  & 0.95266739E-10_JPRB, 0.95955265E-10_JPRB, 0.97083681E-10_JPRB, 0.99325353E-10_JPRB /)

RGHG8(:,17, 7) = (/ &
  & 0.91178384E-10_JPRB, 0.90634757E-10_JPRB, 0.89829998E-10_JPRB, 0.89243210E-10_JPRB, 0.88562865E-10_JPRB, 0.87982809E-10_JPRB, &
  & 0.87582372E-10_JPRB, 0.87527693E-10_JPRB, 0.87954775E-10_JPRB, 0.88943672E-10_JPRB, 0.90511348E-10_JPRB, 0.92550072E-10_JPRB, &
  & 0.94896653E-10_JPRB, 0.97347609E-10_JPRB, 0.99729558E-10_JPRB, 0.10191483E-09_JPRB, 0.10382437E-09_JPRB, 0.10545800E-09_JPRB, &
  & 0.10687777E-09_JPRB, 0.10814859E-09_JPRB, 0.10934339E-09_JPRB, 0.11053631E-09_JPRB, 0.11180179E-09_JPRB, 0.11321459E-09_JPRB, &
  & 0.11483881E-09_JPRB, 0.11671687E-09_JPRB, 0.11885885E-09_JPRB, 0.12116691E-09_JPRB, 0.12351546E-09_JPRB, 0.12571585E-09_JPRB, &
  & 0.12770870E-09_JPRB, 0.12936895E-09_JPRB, 0.13063989E-09_JPRB, 0.13147379E-09_JPRB, 0.13187686E-09_JPRB, 0.13187591E-09_JPRB, &
  & 0.13156494E-09_JPRB, 0.13105519E-09_JPRB, 0.13034006E-09_JPRB, 0.12943047E-09_JPRB, 0.12832352E-09_JPRB, 0.12701551E-09_JPRB, &
  & 0.12551239E-09_JPRB, 0.12383559E-09_JPRB, 0.12202561E-09_JPRB, 0.12014420E-09_JPRB, 0.11824283E-09_JPRB, 0.11639020E-09_JPRB, &
  & 0.11461482E-09_JPRB, 0.11293821E-09_JPRB, 0.11137029E-09_JPRB, 0.10991421E-09_JPRB, 0.10857850E-09_JPRB, 0.10737712E-09_JPRB, &
  & 0.10633344E-09_JPRB, 0.10547253E-09_JPRB, 0.10481648E-09_JPRB, 0.10438819E-09_JPRB, 0.10421835E-09_JPRB, 0.10431362E-09_JPRB, &
  & 0.10464552E-09_JPRB, 0.10521357E-09_JPRB, 0.10610500E-09_JPRB, 0.10798288E-09_JPRB /)

RGHG8(:,18, 7) = (/ &
  & 0.10138739E-09_JPRB, 0.10039062E-09_JPRB, 0.99420250E-10_JPRB, 0.98659872E-10_JPRB, 0.97853732E-10_JPRB, 0.97104366E-10_JPRB, &
  & 0.96494840E-10_JPRB, 0.96171487E-10_JPRB, 0.96289594E-10_JPRB, 0.96959690E-10_JPRB, 0.98230452E-10_JPRB, 0.10005709E-09_JPRB, &
  & 0.10233157E-09_JPRB, 0.10491349E-09_JPRB, 0.10763913E-09_JPRB, 0.11035084E-09_JPRB, 0.11293193E-09_JPRB, 0.11531393E-09_JPRB, &
  & 0.11749100E-09_JPRB, 0.11951330E-09_JPRB, 0.12144474E-09_JPRB, 0.12335447E-09_JPRB, 0.12531547E-09_JPRB, 0.12738731E-09_JPRB, &
  & 0.12957144E-09_JPRB, 0.13178199E-09_JPRB, 0.13387103E-09_JPRB, 0.13570564E-09_JPRB, 0.13716525E-09_JPRB, 0.13820589E-09_JPRB, &
  & 0.13878369E-09_JPRB, 0.13897446E-09_JPRB, 0.13881440E-09_JPRB, 0.13838193E-09_JPRB, 0.13777222E-09_JPRB, 0.13711350E-09_JPRB, &
  & 0.13646820E-09_JPRB, 0.13584799E-09_JPRB, 0.13529355E-09_JPRB, 0.13474706E-09_JPRB, 0.13412889E-09_JPRB, 0.13336590E-09_JPRB, &
  & 0.13241959E-09_JPRB, 0.13127528E-09_JPRB, 0.12995513E-09_JPRB, 0.12849510E-09_JPRB, 0.12693911E-09_JPRB, 0.12533684E-09_JPRB, &
  & 0.12371865E-09_JPRB, 0.12211192E-09_JPRB, 0.12054255E-09_JPRB, 0.11903439E-09_JPRB, 0.11761270E-09_JPRB, 0.11631140E-09_JPRB, &
  & 0.11516563E-09_JPRB, 0.11420623E-09_JPRB, 0.11345457E-09_JPRB, 0.11292989E-09_JPRB, 0.11265490E-09_JPRB, 0.11262750E-09_JPRB, &
  & 0.11281788E-09_JPRB, 0.11321623E-09_JPRB, 0.11387288E-09_JPRB, 0.11534741E-09_JPRB /)

RGHG8(:,19, 7) = (/ &
  & 0.10947050E-09_JPRB, 0.10831643E-09_JPRB, 0.10737607E-09_JPRB, 0.10656534E-09_JPRB, 0.10575156E-09_JPRB, 0.10495677E-09_JPRB, &
  & 0.10425996E-09_JPRB, 0.10379672E-09_JPRB, 0.10372389E-09_JPRB, 0.10417735E-09_JPRB, 0.10523638E-09_JPRB, 0.10690340E-09_JPRB, &
  & 0.10911319E-09_JPRB, 0.11175449E-09_JPRB, 0.11468374E-09_JPRB, 0.11773126E-09_JPRB, 0.12071717E-09_JPRB, 0.12351299E-09_JPRB, &
  & 0.12606746E-09_JPRB, 0.12841031E-09_JPRB, 0.13062457E-09_JPRB, 0.13279534E-09_JPRB, 0.13498185E-09_JPRB, 0.13722289E-09_JPRB, &
  & 0.13948488E-09_JPRB, 0.14166042E-09_JPRB, 0.14359228E-09_JPRB, 0.14508764E-09_JPRB, 0.14605367E-09_JPRB, 0.14645699E-09_JPRB, &
  & 0.14635763E-09_JPRB, 0.14581521E-09_JPRB, 0.14493488E-09_JPRB, 0.14383150E-09_JPRB, 0.14263581E-09_JPRB, 0.14154623E-09_JPRB, &
  & 0.14067808E-09_JPRB, 0.14009165E-09_JPRB, 0.13974946E-09_JPRB, 0.13954596E-09_JPRB, 0.13934862E-09_JPRB, 0.13904712E-09_JPRB, &
  & 0.13856008E-09_JPRB, 0.13785063E-09_JPRB, 0.13692139E-09_JPRB, 0.13579438E-09_JPRB, 0.13450734E-09_JPRB, 0.13309655E-09_JPRB, &
  & 0.13159390E-09_JPRB, 0.13003686E-09_JPRB, 0.12846307E-09_JPRB, 0.12690914E-09_JPRB, 0.12541641E-09_JPRB, 0.12403567E-09_JPRB, &
  & 0.12280930E-09_JPRB, 0.12176768E-09_JPRB, 0.12092896E-09_JPRB, 0.12030868E-09_JPRB, 0.11992486E-09_JPRB, 0.11977264E-09_JPRB, &
  & 0.11981882E-09_JPRB, 0.12004606E-09_JPRB, 0.12049477E-09_JPRB, 0.12156641E-09_JPRB /)

RGHG8(:,20, 7) = (/ &
  & 0.11605718E-09_JPRB, 0.11486724E-09_JPRB, 0.11401103E-09_JPRB, 0.11324063E-09_JPRB, 0.11247503E-09_JPRB, 0.11170739E-09_JPRB, &
  & 0.11100677E-09_JPRB, 0.11048757E-09_JPRB, 0.11030359E-09_JPRB, 0.11061144E-09_JPRB, 0.11149651E-09_JPRB, 0.11298852E-09_JPRB, &
  & 0.11505610E-09_JPRB, 0.11760852E-09_JPRB, 0.12051402E-09_JPRB, 0.12358667E-09_JPRB, 0.12663078E-09_JPRB, 0.12948684E-09_JPRB, &
  & 0.13209200E-09_JPRB, 0.13446066E-09_JPRB, 0.13665985E-09_JPRB, 0.13878432E-09_JPRB, 0.14091067E-09_JPRB, 0.14306568E-09_JPRB, &
  & 0.14521553E-09_JPRB, 0.14725222E-09_JPRB, 0.14900549E-09_JPRB, 0.15031774E-09_JPRB, 0.15110138E-09_JPRB, 0.15134639E-09_JPRB, &
  & 0.15109385E-09_JPRB, 0.15039142E-09_JPRB, 0.14933238E-09_JPRB, 0.14805702E-09_JPRB, 0.14670476E-09_JPRB, 0.14550509E-09_JPRB, &
  & 0.14459074E-09_JPRB, 0.14405031E-09_JPRB, 0.14382463E-09_JPRB, 0.14381087E-09_JPRB, 0.14386096E-09_JPRB, 0.14382937E-09_JPRB, &
  & 0.14362277E-09_JPRB, 0.14319343E-09_JPRB, 0.14252613E-09_JPRB, 0.14163133E-09_JPRB, 0.14053794E-09_JPRB, 0.13927723E-09_JPRB, &
  & 0.13788644E-09_JPRB, 0.13640698E-09_JPRB, 0.13487977E-09_JPRB, 0.13334293E-09_JPRB, 0.13185450E-09_JPRB, 0.13046432E-09_JPRB, &
  & 0.12921562E-09_JPRB, 0.12813847E-09_JPRB, 0.12724877E-09_JPRB, 0.12655869E-09_JPRB, 0.12608296E-09_JPRB, 0.12581886E-09_JPRB, &
  & 0.12573850E-09_JPRB, 0.12582119E-09_JPRB, 0.12608461E-09_JPRB, 0.12680436E-09_JPRB /)

RGHG8(:,21, 7) = (/ &
  & 0.12159242E-09_JPRB, 0.12043141E-09_JPRB, 0.11966518E-09_JPRB, 0.11896498E-09_JPRB, 0.11826150E-09_JPRB, 0.11755005E-09_JPRB, &
  & 0.11687071E-09_JPRB, 0.11633558E-09_JPRB, 0.11609010E-09_JPRB, 0.11628136E-09_JPRB, 0.11700563E-09_JPRB, 0.11830432E-09_JPRB, &
  & 0.12015434E-09_JPRB, 0.12248445E-09_JPRB, 0.12516893E-09_JPRB, 0.12804255E-09_JPRB, 0.13091088E-09_JPRB, 0.13361511E-09_JPRB, &
  & 0.13607643E-09_JPRB, 0.13831650E-09_JPRB, 0.14039708E-09_JPRB, 0.14239232E-09_JPRB, 0.14437931E-09_JPRB, 0.14639860E-09_JPRB, &
  & 0.14841769E-09_JPRB, 0.15033595E-09_JPRB, 0.15200445E-09_JPRB, 0.15327074E-09_JPRB, 0.15405635E-09_JPRB, 0.15435300E-09_JPRB, &
  & 0.15418271E-09_JPRB, 0.15358559E-09_JPRB, 0.15263379E-09_JPRB, 0.15144597E-09_JPRB, 0.15018850E-09_JPRB, 0.14906552E-09_JPRB, &
  & 0.14820375E-09_JPRB, 0.14769634E-09_JPRB, 0.14754742E-09_JPRB, 0.14761034E-09_JPRB, 0.14774081E-09_JPRB, 0.14780902E-09_JPRB, &
  & 0.14771398E-09_JPRB, 0.14739945E-09_JPRB, 0.14685382E-09_JPRB, 0.14608874E-09_JPRB, 0.14512255E-09_JPRB, 0.14398398E-09_JPRB, &
  & 0.14270798E-09_JPRB, 0.14133300E-09_JPRB, 0.13989290E-09_JPRB, 0.13843823E-09_JPRB, 0.13701767E-09_JPRB, 0.13568004E-09_JPRB, &
  & 0.13446529E-09_JPRB, 0.13340122E-09_JPRB, 0.13250256E-09_JPRB, 0.13177889E-09_JPRB, 0.13124335E-09_JPRB, 0.13089381E-09_JPRB, &
  & 0.13070975E-09_JPRB, 0.13067265E-09_JPRB, 0.13078735E-09_JPRB, 0.13122892E-09_JPRB /)

RGHG8(:,22, 7) = (/ &
  & 0.12638696E-09_JPRB, 0.12529587E-09_JPRB, 0.12459052E-09_JPRB, 0.12395583E-09_JPRB, 0.12331589E-09_JPRB, 0.12265350E-09_JPRB, &
  & 0.12201055E-09_JPRB, 0.12147418E-09_JPRB, 0.12119153E-09_JPRB, 0.12129067E-09_JPRB, 0.12186585E-09_JPRB, 0.12295776E-09_JPRB, &
  & 0.12455488E-09_JPRB, 0.12659158E-09_JPRB, 0.12896184E-09_JPRB, 0.13151417E-09_JPRB, 0.13408405E-09_JPRB, 0.13653445E-09_JPRB, &
  & 0.13879516E-09_JPRB, 0.14086327E-09_JPRB, 0.14279750E-09_JPRB, 0.14466592E-09_JPRB, 0.14652790E-09_JPRB, 0.14843060E-09_JPRB, &
  & 0.15034626E-09_JPRB, 0.15219745E-09_JPRB, 0.15382838E-09_JPRB, 0.15511378E-09_JPRB, 0.15597806E-09_JPRB, 0.15640000E-09_JPRB, &
  & 0.15639383E-09_JPRB, 0.15600159E-09_JPRB, 0.15527842E-09_JPRB, 0.15433871E-09_JPRB, 0.15331578E-09_JPRB, 0.15236248E-09_JPRB, &
  & 0.15163509E-09_JPRB, 0.15121035E-09_JPRB, 0.15103920E-09_JPRB, 0.15106284E-09_JPRB, 0.15114515E-09_JPRB, 0.15117634E-09_JPRB, &
  & 0.15106712E-09_JPRB, 0.15077142E-09_JPRB, 0.15026511E-09_JPRB, 0.14954737E-09_JPRB, 0.14864035E-09_JPRB, 0.14757563E-09_JPRB, &
  & 0.14638873E-09_JPRB, 0.14510758E-09_JPRB, 0.14377356E-09_JPRB, 0.14242653E-09_JPRB, 0.14110974E-09_JPRB, 0.13986609E-09_JPRB, &
  & 0.13872631E-09_JPRB, 0.13771217E-09_JPRB, 0.13683633E-09_JPRB, 0.13610987E-09_JPRB, 0.13554489E-09_JPRB, 0.13514254E-09_JPRB, &
  & 0.13488521E-09_JPRB, 0.13475607E-09_JPRB, 0.13475031E-09_JPRB, 0.13496927E-09_JPRB /)

RGHG8(:,23, 7) = (/ &
  & 0.13059256E-09_JPRB, 0.12956114E-09_JPRB, 0.12893467E-09_JPRB, 0.12835871E-09_JPRB, 0.12777637E-09_JPRB, 0.12717075E-09_JPRB, &
  & 0.12656542E-09_JPRB, 0.12605236E-09_JPRB, 0.12574994E-09_JPRB, 0.12577912E-09_JPRB, 0.12622722E-09_JPRB, 0.12713368E-09_JPRB, &
  & 0.12848482E-09_JPRB, 0.13022589E-09_JPRB, 0.13226310E-09_JPRB, 0.13447220E-09_JPRB, 0.13671791E-09_JPRB, 0.13888760E-09_JPRB, &
  & 0.14092309E-09_JPRB, 0.14282485E-09_JPRB, 0.14462660E-09_JPRB, 0.14638681E-09_JPRB, 0.14815182E-09_JPRB, 0.14995136E-09_JPRB, &
  & 0.15178066E-09_JPRB, 0.15355760E-09_JPRB, 0.15516316E-09_JPRB, 0.15646762E-09_JPRB, 0.15739561E-09_JPRB, 0.15793743E-09_JPRB, &
  & 0.15810912E-09_JPRB, 0.15794549E-09_JPRB, 0.15749746E-09_JPRB, 0.15686397E-09_JPRB, 0.15613336E-09_JPRB, 0.15544313E-09_JPRB, &
  & 0.15487973E-09_JPRB, 0.15449879E-09_JPRB, 0.15429931E-09_JPRB, 0.15421596E-09_JPRB, 0.15416259E-09_JPRB, 0.15405889E-09_JPRB, &
  & 0.15384147E-09_JPRB, 0.15346502E-09_JPRB, 0.15291587E-09_JPRB, 0.15219738E-09_JPRB, 0.15132079E-09_JPRB, 0.15030965E-09_JPRB, &
  & 0.14919246E-09_JPRB, 0.14800562E-09_JPRB, 0.14678252E-09_JPRB, 0.14555593E-09_JPRB, 0.14436370E-09_JPRB, 0.14323355E-09_JPRB, &
  & 0.14218848E-09_JPRB, 0.14124472E-09_JPRB, 0.14041267E-09_JPRB, 0.13970246E-09_JPRB, 0.13912857E-09_JPRB, 0.13869426E-09_JPRB, &
  & 0.13838899E-09_JPRB, 0.13819640E-09_JPRB, 0.13810428E-09_JPRB, 0.13815743E-09_JPRB /)

RGHG8(:,24, 7) = (/ &
  & 0.13426221E-09_JPRB, 0.13335710E-09_JPRB, 0.13278613E-09_JPRB, 0.13227724E-09_JPRB, 0.13175998E-09_JPRB, 0.13121781E-09_JPRB, &
  & 0.13067611E-09_JPRB, 0.13020446E-09_JPRB, 0.12991254E-09_JPRB, 0.12990851E-09_JPRB, 0.13027010E-09_JPRB, 0.13103203E-09_JPRB, &
  & 0.13218386E-09_JPRB, 0.13367478E-09_JPRB, 0.13542337E-09_JPRB, 0.13732790E-09_JPRB, 0.13927995E-09_JPRB, 0.14119386E-09_JPRB, &
  & 0.14302262E-09_JPRB, 0.14476011E-09_JPRB, 0.14643128E-09_JPRB, 0.14807321E-09_JPRB, 0.14972665E-09_JPRB, 0.15141477E-09_JPRB, &
  & 0.15311907E-09_JPRB, 0.15478115E-09_JPRB, 0.15629667E-09_JPRB, 0.15756832E-09_JPRB, 0.15853857E-09_JPRB, 0.15917870E-09_JPRB, &
  & 0.15950483E-09_JPRB, 0.15955240E-09_JPRB, 0.15937032E-09_JPRB, 0.15902626E-09_JPRB, 0.15859310E-09_JPRB, 0.15815198E-09_JPRB, &
  & 0.15775770E-09_JPRB, 0.15744377E-09_JPRB, 0.15719318E-09_JPRB, 0.15699095E-09_JPRB, 0.15677933E-09_JPRB, 0.15651620E-09_JPRB, &
  & 0.15615592E-09_JPRB, 0.15567202E-09_JPRB, 0.15504527E-09_JPRB, 0.15427874E-09_JPRB, 0.15339355E-09_JPRB, 0.15241197E-09_JPRB, &
  & 0.15136239E-09_JPRB, 0.15027056E-09_JPRB, 0.14916003E-09_JPRB, 0.14806022E-09_JPRB, 0.14699186E-09_JPRB, 0.14597683E-09_JPRB, &
  & 0.14503251E-09_JPRB, 0.14416894E-09_JPRB, 0.14339427E-09_JPRB, 0.14271796E-09_JPRB, 0.14215323E-09_JPRB, 0.14170660E-09_JPRB, &
  & 0.14137110E-09_JPRB, 0.14113330E-09_JPRB, 0.14097508E-09_JPRB, 0.14089213E-09_JPRB /)

RGHG8(:,25, 7) = (/ &
  & 0.13750476E-09_JPRB, 0.13669758E-09_JPRB, 0.13621525E-09_JPRB, 0.13577672E-09_JPRB, 0.13533850E-09_JPRB, 0.13488034E-09_JPRB, &
  & 0.13442161E-09_JPRB, 0.13402320E-09_JPRB, 0.13378011E-09_JPRB, 0.13378781E-09_JPRB, 0.13411548E-09_JPRB, 0.13479293E-09_JPRB, &
  & 0.13581059E-09_JPRB, 0.13712270E-09_JPRB, 0.13865926E-09_JPRB, 0.14033137E-09_JPRB, 0.14205348E-09_JPRB, 0.14375581E-09_JPRB, &
  & 0.14540179E-09_JPRB, 0.14698472E-09_JPRB, 0.14851699E-09_JPRB, 0.15002388E-09_JPRB, 0.15152556E-09_JPRB, 0.15304377E-09_JPRB, &
  & 0.15456453E-09_JPRB, 0.15604228E-09_JPRB, 0.15741301E-09_JPRB, 0.15859485E-09_JPRB, 0.15953487E-09_JPRB, 0.16022324E-09_JPRB, &
  & 0.16066390E-09_JPRB, 0.16088095E-09_JPRB, 0.16091500E-09_JPRB, 0.16080959E-09_JPRB, 0.16061497E-09_JPRB, 0.16036802E-09_JPRB, &
  & 0.16010580E-09_JPRB, 0.15984084E-09_JPRB, 0.15955881E-09_JPRB, 0.15926388E-09_JPRB, 0.15892319E-09_JPRB, 0.15851823E-09_JPRB, &
  & 0.15803069E-09_JPRB, 0.15744589E-09_JPRB, 0.15675955E-09_JPRB, 0.15596865E-09_JPRB, 0.15508317E-09_JPRB, 0.15412686E-09_JPRB, &
  & 0.15312993E-09_JPRB, 0.15211465E-09_JPRB, 0.15110384E-09_JPRB, 0.15011134E-09_JPRB, 0.14915569E-09_JPRB, 0.14825138E-09_JPRB, &
  & 0.14740435E-09_JPRB, 0.14662217E-09_JPRB, 0.14591023E-09_JPRB, 0.14527705E-09_JPRB, 0.14473568E-09_JPRB, 0.14429347E-09_JPRB, &
  & 0.14394685E-09_JPRB, 0.14368388E-09_JPRB, 0.14348255E-09_JPRB, 0.14329610E-09_JPRB /)

RGHG8(:,26, 7) = (/ &
  & 0.14033544E-09_JPRB, 0.13966880E-09_JPRB, 0.13926846E-09_JPRB, 0.13891494E-09_JPRB, 0.13856384E-09_JPRB, 0.13820398E-09_JPRB, &
  & 0.13784787E-09_JPRB, 0.13755118E-09_JPRB, 0.13739268E-09_JPRB, 0.13745520E-09_JPRB, 0.13779794E-09_JPRB, 0.13844838E-09_JPRB, &
  & 0.13939570E-09_JPRB, 0.14060060E-09_JPRB, 0.14199754E-09_JPRB, 0.14351233E-09_JPRB, 0.14506676E-09_JPRB, 0.14660564E-09_JPRB, &
  & 0.14809395E-09_JPRB, 0.14952072E-09_JPRB, 0.15088922E-09_JPRB, 0.15222062E-09_JPRB, 0.15353029E-09_JPRB, 0.15482224E-09_JPRB, &
  & 0.15610481E-09_JPRB, 0.15734611E-09_JPRB, 0.15850840E-09_JPRB, 0.15955284E-09_JPRB, 0.16043709E-09_JPRB, 0.16113016E-09_JPRB, &
  & 0.16163675E-09_JPRB, 0.16197155E-09_JPRB, 0.16215757E-09_JPRB, 0.16222071E-09_JPRB, 0.16218851E-09_JPRB, 0.16207766E-09_JPRB, &
  & 0.16190312E-09_JPRB, 0.16166880E-09_JPRB, 0.16137283E-09_JPRB, 0.16100946E-09_JPRB, 0.16058192E-09_JPRB, 0.16007472E-09_JPRB, &
  & 0.15949336E-09_JPRB, 0.15882604E-09_JPRB, 0.15807934E-09_JPRB, 0.15725804E-09_JPRB, 0.15638238E-09_JPRB, 0.15547325E-09_JPRB, &
  & 0.15454740E-09_JPRB, 0.15362324E-09_JPRB, 0.15271190E-09_JPRB, 0.15182990E-09_JPRB, 0.15098592E-09_JPRB, 0.15018475E-09_JPRB, &
  & 0.14943036E-09_JPRB, 0.14872636E-09_JPRB, 0.14807697E-09_JPRB, 0.14749088E-09_JPRB, 0.14698041E-09_JPRB, 0.14655369E-09_JPRB, &
  & 0.14620939E-09_JPRB, 0.14593748E-09_JPRB, 0.14571450E-09_JPRB, 0.14547638E-09_JPRB /)

RGHG8(:,27, 7) = (/ &
  & 0.14283201E-09_JPRB, 0.14230893E-09_JPRB, 0.14199737E-09_JPRB, 0.14172813E-09_JPRB, 0.14146867E-09_JPRB, 0.14120849E-09_JPRB, &
  & 0.14096570E-09_JPRB, 0.14078262E-09_JPRB, 0.14072901E-09_JPRB, 0.14087324E-09_JPRB, 0.14126529E-09_JPRB, 0.14192569E-09_JPRB, &
  & 0.14284696E-09_JPRB, 0.14399035E-09_JPRB, 0.14529949E-09_JPRB, 0.14670326E-09_JPRB, 0.14813586E-09_JPRB, 0.14954211E-09_JPRB, &
  & 0.15088895E-09_JPRB, 0.15215594E-09_JPRB, 0.15335325E-09_JPRB, 0.15450036E-09_JPRB, 0.15558448E-09_JPRB, 0.15663632E-09_JPRB, &
  & 0.15766302E-09_JPRB, 0.15864771E-09_JPRB, 0.15959047E-09_JPRB, 0.16046638E-09_JPRB, 0.16125082E-09_JPRB, 0.16191959E-09_JPRB, &
  & 0.16245781E-09_JPRB, 0.16286290E-09_JPRB, 0.16314264E-09_JPRB, 0.16330763E-09_JPRB, 0.16336957E-09_JPRB, 0.16333465E-09_JPRB, &
  & 0.16320814E-09_JPRB, 0.16299023E-09_JPRB, 0.16268646E-09_JPRB, 0.16228811E-09_JPRB, 0.16181058E-09_JPRB, 0.16124904E-09_JPRB, &
  & 0.16061405E-09_JPRB, 0.15990674E-09_JPRB, 0.15913505E-09_JPRB, 0.15831242E-09_JPRB, 0.15746041E-09_JPRB, 0.15660120E-09_JPRB, &
  & 0.15575061E-09_JPRB, 0.15491677E-09_JPRB, 0.15410738E-09_JPRB, 0.15332771E-09_JPRB, 0.15258241E-09_JPRB, 0.15187476E-09_JPRB, &
  & 0.15120401E-09_JPRB, 0.15057214E-09_JPRB, 0.14998355E-09_JPRB, 0.14944630E-09_JPRB, 0.14897161E-09_JPRB, 0.14856678E-09_JPRB, &
  & 0.14823154E-09_JPRB, 0.14795647E-09_JPRB, 0.14771637E-09_JPRB, 0.14741969E-09_JPRB /)

RGHG8(:,28, 7) = (/ &
  & 0.14507580E-09_JPRB, 0.14466969E-09_JPRB, 0.14443854E-09_JPRB, 0.14424610E-09_JPRB, 0.14406754E-09_JPRB, 0.14390128E-09_JPRB, &
  & 0.14376159E-09_JPRB, 0.14368984E-09_JPRB, 0.14374210E-09_JPRB, 0.14397475E-09_JPRB, 0.14442599E-09_JPRB, 0.14511370E-09_JPRB, &
  & 0.14602569E-09_JPRB, 0.14712935E-09_JPRB, 0.14837045E-09_JPRB, 0.14968783E-09_JPRB, 0.15101667E-09_JPRB, 0.15231022E-09_JPRB, &
  & 0.15352603E-09_JPRB, 0.15464786E-09_JPRB, 0.15568820E-09_JPRB, 0.15664847E-09_JPRB, 0.15752444E-09_JPRB, 0.15835265E-09_JPRB, &
  & 0.15914074E-09_JPRB, 0.15989690E-09_JPRB, 0.16063234E-09_JPRB, 0.16134348E-09_JPRB, 0.16202008E-09_JPRB, 0.16263708E-09_JPRB, &
  & 0.16316810E-09_JPRB, 0.16360133E-09_JPRB, 0.16392801E-09_JPRB, 0.16414529E-09_JPRB, 0.16425389E-09_JPRB, 0.16425462E-09_JPRB, &
  & 0.16414911E-09_JPRB, 0.16393774E-09_JPRB, 0.16362750E-09_JPRB, 0.16321822E-09_JPRB, 0.16271404E-09_JPRB, 0.16213147E-09_JPRB, &
  & 0.16147403E-09_JPRB, 0.16075727E-09_JPRB, 0.15998898E-09_JPRB, 0.15919245E-09_JPRB, 0.15838854E-09_JPRB, 0.15759606E-09_JPRB, &
  & 0.15682486E-09_JPRB, 0.15607952E-09_JPRB, 0.15536017E-09_JPRB, 0.15467051E-09_JPRB, 0.15401265E-09_JPRB, 0.15338555E-09_JPRB, &
  & 0.15278812E-09_JPRB, 0.15222160E-09_JPRB, 0.15169023E-09_JPRB, 0.15120037E-09_JPRB, 0.15076164E-09_JPRB, 0.15038104E-09_JPRB, &
  & 0.15005944E-09_JPRB, 0.14978850E-09_JPRB, 0.14954270E-09_JPRB, 0.14922967E-09_JPRB /)

RGHG8(:,29, 7) = (/ &
  & 0.14706394E-09_JPRB, 0.14676957E-09_JPRB, 0.14660356E-09_JPRB, 0.14647607E-09_JPRB, 0.14636707E-09_JPRB, 0.14627788E-09_JPRB, &
  & 0.14622720E-09_JPRB, 0.14625089E-09_JPRB, 0.14639619E-09_JPRB, 0.14670787E-09_JPRB, 0.14721550E-09_JPRB, 0.14792731E-09_JPRB, &
  & 0.14883339E-09_JPRB, 0.14989945E-09_JPRB, 0.15107944E-09_JPRB, 0.15231474E-09_JPRB, 0.15355120E-09_JPRB, 0.15473996E-09_JPRB, &
  & 0.15584299E-09_JPRB, 0.15684068E-09_JPRB, 0.15773910E-09_JPRB, 0.15854019E-09_JPRB, 0.15924775E-09_JPRB, 0.15988748E-09_JPRB, &
  & 0.16047892E-09_JPRB, 0.16104289E-09_JPRB, 0.16160022E-09_JPRB, 0.16216471E-09_JPRB, 0.16273101E-09_JPRB, 0.16328335E-09_JPRB, &
  & 0.16379113E-09_JPRB, 0.16422522E-09_JPRB, 0.16456789E-09_JPRB, 0.16480553E-09_JPRB, 0.16493207E-09_JPRB, 0.16494542E-09_JPRB, &
  & 0.16484709E-09_JPRB, 0.16463836E-09_JPRB, 0.16432457E-09_JPRB, 0.16391316E-09_JPRB, 0.16340672E-09_JPRB, 0.16281641E-09_JPRB, &
  & 0.16216213E-09_JPRB, 0.16145164E-09_JPRB, 0.16070946E-09_JPRB, 0.15995566E-09_JPRB, 0.15921282E-09_JPRB, 0.15849584E-09_JPRB, &
  & 0.15780915E-09_JPRB, 0.15714738E-09_JPRB, 0.15651083E-09_JPRB, 0.15590043E-09_JPRB, 0.15531687E-09_JPRB, 0.15475912E-09_JPRB, &
  & 0.15422581E-09_JPRB, 0.15371858E-09_JPRB, 0.15323970E-09_JPRB, 0.15279528E-09_JPRB, 0.15239369E-09_JPRB, 0.15204196E-09_JPRB, &
  & 0.15174162E-09_JPRB, 0.15148509E-09_JPRB, 0.15124917E-09_JPRB, 0.15093006E-09_JPRB /)

RGHG8(:,30, 7) = (/ &
  & 0.14881872E-09_JPRB, 0.14861637E-09_JPRB, 0.14850986E-09_JPRB, 0.14843389E-09_JPRB, 0.14837899E-09_JPRB, 0.14835136E-09_JPRB, &
  & 0.14837043E-09_JPRB, 0.14846969E-09_JPRB, 0.14869013E-09_JPRB, 0.14906543E-09_JPRB, 0.14961479E-09_JPRB, 0.15034421E-09_JPRB, &
  & 0.15123677E-09_JPRB, 0.15226366E-09_JPRB, 0.15338038E-09_JPRB, 0.15453813E-09_JPRB, 0.15568559E-09_JPRB, 0.15678142E-09_JPRB, &
  & 0.15778748E-09_JPRB, 0.15868412E-09_JPRB, 0.15946695E-09_JPRB, 0.16014359E-09_JPRB, 0.16071933E-09_JPRB, 0.16121596E-09_JPRB, &
  & 0.16165737E-09_JPRB, 0.16207306E-09_JPRB, 0.16249364E-09_JPRB, 0.16293575E-09_JPRB, 0.16340632E-09_JPRB, 0.16388661E-09_JPRB, &
  & 0.16435299E-09_JPRB, 0.16476949E-09_JPRB, 0.16510668E-09_JPRB, 0.16534474E-09_JPRB, 0.16547254E-09_JPRB, 0.16548696E-09_JPRB, &
  & 0.16539023E-09_JPRB, 0.16518570E-09_JPRB, 0.16487596E-09_JPRB, 0.16446963E-09_JPRB, 0.16397145E-09_JPRB, 0.16339498E-09_JPRB, &
  & 0.16275480E-09_JPRB, 0.16207269E-09_JPRB, 0.16137107E-09_JPRB, 0.16066912E-09_JPRB, 0.15999482E-09_JPRB, 0.15935159E-09_JPRB, &
  & 0.15874155E-09_JPRB, 0.15815502E-09_JPRB, 0.15758812E-09_JPRB, 0.15704460E-09_JPRB, 0.15652372E-09_JPRB, 0.15602387E-09_JPRB, &
  & 0.15554583E-09_JPRB, 0.15508939E-09_JPRB, 0.15465745E-09_JPRB, 0.15425536E-09_JPRB, 0.15389033E-09_JPRB, 0.15356870E-09_JPRB, &
  & 0.15329130E-09_JPRB, 0.15304999E-09_JPRB, 0.15281841E-09_JPRB, 0.15248196E-09_JPRB /)

RGHG8(:,31, 7) = (/ &
  & 0.15038343E-09_JPRB, 0.15024600E-09_JPRB, 0.15018214E-09_JPRB, 0.15014529E-09_JPRB, 0.15013196E-09_JPRB, 0.15015136E-09_JPRB, &
  & 0.15022371E-09_JPRB, 0.15038211E-09_JPRB, 0.15065822E-09_JPRB, 0.15107862E-09_JPRB, 0.15165658E-09_JPRB, 0.15238935E-09_JPRB, &
  & 0.15326258E-09_JPRB, 0.15424460E-09_JPRB, 0.15529841E-09_JPRB, 0.15638005E-09_JPRB, 0.15744663E-09_JPRB, 0.15845769E-09_JPRB, &
  & 0.15938198E-09_JPRB, 0.16019737E-09_JPRB, 0.16089463E-09_JPRB, 0.16147722E-09_JPRB, 0.16195476E-09_JPRB, 0.16234762E-09_JPRB, &
  & 0.16268226E-09_JPRB, 0.16299233E-09_JPRB, 0.16330938E-09_JPRB, 0.16365526E-09_JPRB, 0.16404077E-09_JPRB, 0.16445566E-09_JPRB, &
  & 0.16487429E-09_JPRB, 0.16525964E-09_JPRB, 0.16557763E-09_JPRB, 0.16580257E-09_JPRB, 0.16592164E-09_JPRB, 0.16593177E-09_JPRB, &
  & 0.16583644E-09_JPRB, 0.16563920E-09_JPRB, 0.16534427E-09_JPRB, 0.16495284E-09_JPRB, 0.16447564E-09_JPRB, 0.16392347E-09_JPRB, &
  & 0.16331679E-09_JPRB, 0.16267319E-09_JPRB, 0.16202041E-09_JPRB, 0.16138034E-09_JPRB, 0.16076962E-09_JPRB, 0.16019450E-09_JPRB, &
  & 0.15964691E-09_JPRB, 0.15912360E-09_JPRB, 0.15861391E-09_JPRB, 0.15812258E-09_JPRB, 0.15765163E-09_JPRB, 0.15719911E-09_JPRB, &
  & 0.15676574E-09_JPRB, 0.15635185E-09_JPRB, 0.15596030E-09_JPRB, 0.15559519E-09_JPRB, 0.15526311E-09_JPRB, 0.15496887E-09_JPRB, &
  & 0.15471294E-09_JPRB, 0.15448710E-09_JPRB, 0.15426815E-09_JPRB, 0.15395595E-09_JPRB /)

RGHG8(:,32, 7) = (/ &
  & 0.15177022E-09_JPRB, 0.15167922E-09_JPRB, 0.15164882E-09_JPRB, 0.15164303E-09_JPRB, 0.15166310E-09_JPRB, 0.15171965E-09_JPRB, &
  & 0.15183516E-09_JPRB, 0.15203651E-09_JPRB, 0.15235307E-09_JPRB, 0.15280238E-09_JPRB, 0.15339180E-09_JPRB, 0.15411775E-09_JPRB, &
  & 0.15496114E-09_JPRB, 0.15589557E-09_JPRB, 0.15688598E-09_JPRB, 0.15789589E-09_JPRB, 0.15888792E-09_JPRB, 0.15982654E-09_JPRB, &
  & 0.16068191E-09_JPRB, 0.16143223E-09_JPRB, 0.16206592E-09_JPRB, 0.16258266E-09_JPRB, 0.16299166E-09_JPRB, 0.16331340E-09_JPRB, &
  & 0.16357611E-09_JPRB, 0.16381346E-09_JPRB, 0.16405698E-09_JPRB, 0.16433116E-09_JPRB, 0.16464724E-09_JPRB, 0.16500104E-09_JPRB, &
  & 0.16536830E-09_JPRB, 0.16571497E-09_JPRB, 0.16600261E-09_JPRB, 0.16620522E-09_JPRB, 0.16630904E-09_JPRB, 0.16631239E-09_JPRB, &
  & 0.16621984E-09_JPRB, 0.16603580E-09_JPRB, 0.16576134E-09_JPRB, 0.16540010E-09_JPRB, 0.16495301E-09_JPRB, 0.16443855E-09_JPRB, &
  & 0.16387523E-09_JPRB, 0.16328543E-09_JPRB, 0.16268732E-09_JPRB, 0.16210530E-09_JPRB, 0.16155213E-09_JPRB, 0.16103235E-09_JPRB, &
  & 0.16053472E-09_JPRB, 0.16005565E-09_JPRB, 0.15959067E-09_JPRB, 0.15913952E-09_JPRB, 0.15870623E-09_JPRB, 0.15829076E-09_JPRB, &
  & 0.15789318E-09_JPRB, 0.15751446E-09_JPRB, 0.15715695E-09_JPRB, 0.15682400E-09_JPRB, 0.15652074E-09_JPRB, 0.15625135E-09_JPRB, &
  & 0.15601584E-09_JPRB, 0.15580665E-09_JPRB, 0.15560028E-09_JPRB, 0.15528967E-09_JPRB /)

RGHG8(:,33, 7) = (/ &
  & 0.15298285E-09_JPRB, 0.15294430E-09_JPRB, 0.15294332E-09_JPRB, 0.15296470E-09_JPRB, 0.15301312E-09_JPRB, 0.15310167E-09_JPRB, &
  & 0.15325005E-09_JPRB, 0.15348554E-09_JPRB, 0.15382745E-09_JPRB, 0.15429018E-09_JPRB, 0.15487828E-09_JPRB, 0.15558352E-09_JPRB, &
  & 0.15639103E-09_JPRB, 0.15727317E-09_JPRB, 0.15820253E-09_JPRB, 0.15914464E-09_JPRB, 0.16007032E-09_JPRB, 0.16094584E-09_JPRB, &
  & 0.16174458E-09_JPRB, 0.16244492E-09_JPRB, 0.16303264E-09_JPRB, 0.16350474E-09_JPRB, 0.16386853E-09_JPRB, 0.16414589E-09_JPRB, &
  & 0.16436423E-09_JPRB, 0.16455454E-09_JPRB, 0.16474914E-09_JPRB, 0.16496944E-09_JPRB, 0.16522948E-09_JPRB, 0.16552747E-09_JPRB, &
  & 0.16584439E-09_JPRB, 0.16614536E-09_JPRB, 0.16639563E-09_JPRB, 0.16656859E-09_JPRB, 0.16665319E-09_JPRB, 0.16664861E-09_JPRB, &
  & 0.16656057E-09_JPRB, 0.16639301E-09_JPRB, 0.16614712E-09_JPRB, 0.16582059E-09_JPRB, 0.16541914E-09_JPRB, 0.16495338E-09_JPRB, &
  & 0.16444264E-09_JPRB, 0.16391258E-09_JPRB, 0.16337362E-09_JPRB, 0.16284715E-09_JPRB, 0.16233775E-09_JPRB, 0.16185915E-09_JPRB, &
  & 0.16139984E-09_JPRB, 0.16095129E-09_JPRB, 0.16051620E-09_JPRB, 0.16009430E-09_JPRB, 0.15968862E-09_JPRB, 0.15930170E-09_JPRB, &
  & 0.15893258E-09_JPRB, 0.15858276E-09_JPRB, 0.15825399E-09_JPRB, 0.15794833E-09_JPRB, 0.15767049E-09_JPRB, 0.15742369E-09_JPRB, &
  & 0.15720721E-09_JPRB, 0.15701358E-09_JPRB, 0.15682117E-09_JPRB, 0.15653107E-09_JPRB /)

RGHG8(:,34, 7) = (/ &
  & 0.15406931E-09_JPRB, 0.15407520E-09_JPRB, 0.15409943E-09_JPRB, 0.15414488E-09_JPRB, 0.15421878E-09_JPRB, 0.15433385E-09_JPRB, &
  & 0.15451039E-09_JPRB, 0.15476787E-09_JPRB, 0.15512415E-09_JPRB, 0.15558786E-09_JPRB, 0.15616092E-09_JPRB, 0.15683757E-09_JPRB, &
  & 0.15760120E-09_JPRB, 0.15843064E-09_JPRB, 0.15929999E-09_JPRB, 0.16018159E-09_JPRB, 0.16104651E-09_JPRB, 0.16186856E-09_JPRB, &
  & 0.16262040E-09_JPRB, 0.16328258E-09_JPRB, 0.16383894E-09_JPRB, 0.16428203E-09_JPRB, 0.16462112E-09_JPRB, 0.16487425E-09_JPRB, &
  & 0.16506929E-09_JPRB, 0.16523177E-09_JPRB, 0.16539504E-09_JPRB, 0.16557732E-09_JPRB, 0.16579225E-09_JPRB, 0.16604029E-09_JPRB, &
  & 0.16630455E-09_JPRB, 0.16655635E-09_JPRB, 0.16676266E-09_JPRB, 0.16690162E-09_JPRB, 0.16696435E-09_JPRB, 0.16695131E-09_JPRB, &
  & 0.16686923E-09_JPRB, 0.16672050E-09_JPRB, 0.16650475E-09_JPRB, 0.16622123E-09_JPRB, 0.16586894E-09_JPRB, 0.16546088E-09_JPRB, &
  & 0.16501478E-09_JPRB, 0.16454213E-09_JPRB, 0.16406380E-09_JPRB, 0.16358444E-09_JPRB, 0.16311461E-09_JPRB, 0.16266005E-09_JPRB, &
  & 0.16222740E-09_JPRB, 0.16179968E-09_JPRB, 0.16138366E-09_JPRB, 0.16098234E-09_JPRB, 0.16059744E-09_JPRB, 0.16023188E-09_JPRB, &
  & 0.15988580E-09_JPRB, 0.15955977E-09_JPRB, 0.15925448E-09_JPRB, 0.15897227E-09_JPRB, 0.15871623E-09_JPRB, 0.15848914E-09_JPRB, &
  & 0.15828963E-09_JPRB, 0.15811068E-09_JPRB, 0.15792984E-09_JPRB, 0.15765472E-09_JPRB /)

RGHG8(:,35, 7) = (/ &
  & 0.15505609E-09_JPRB, 0.15509778E-09_JPRB, 0.15514520E-09_JPRB, 0.15521254E-09_JPRB, 0.15530854E-09_JPRB, 0.15544629E-09_JPRB, &
  & 0.15564211E-09_JPRB, 0.15591405E-09_JPRB, 0.15627341E-09_JPRB, 0.15672709E-09_JPRB, 0.15727751E-09_JPRB, 0.15791715E-09_JPRB, &
  & 0.15863512E-09_JPRB, 0.15941048E-09_JPRB, 0.16022399E-09_JPRB, 0.16104895E-09_JPRB, 0.16186191E-09_JPRB, 0.16263663E-09_JPRB, &
  & 0.16335031E-09_JPRB, 0.16398211E-09_JPRB, 0.16451705E-09_JPRB, 0.16494719E-09_JPRB, 0.16527785E-09_JPRB, 0.16552291E-09_JPRB, &
  & 0.16570824E-09_JPRB, 0.16585948E-09_JPRB, 0.16600300E-09_JPRB, 0.16615746E-09_JPRB, 0.16633425E-09_JPRB, 0.16653481E-09_JPRB, &
  & 0.16674641E-09_JPRB, 0.16694435E-09_JPRB, 0.16710322E-09_JPRB, 0.16720568E-09_JPRB, 0.16724586E-09_JPRB, 0.16722490E-09_JPRB, &
  & 0.16714954E-09_JPRB, 0.16701941E-09_JPRB, 0.16683664E-09_JPRB, 0.16659579E-09_JPRB, 0.16629716E-09_JPRB, 0.16594970E-09_JPRB, &
  & 0.16556492E-09_JPRB, 0.16515633E-09_JPRB, 0.16472956E-09_JPRB, 0.16429574E-09_JPRB, 0.16385547E-09_JPRB, 0.16342230E-09_JPRB, &
  & 0.16300344E-09_JPRB, 0.16259016E-09_JPRB, 0.16218618E-09_JPRB, 0.16179907E-09_JPRB, 0.16142972E-09_JPRB, 0.16108137E-09_JPRB, &
  & 0.16075384E-09_JPRB, 0.16044720E-09_JPRB, 0.16016190E-09_JPRB, 0.15989907E-09_JPRB, 0.15966199E-09_JPRB, 0.15945253E-09_JPRB, &
  & 0.15926897E-09_JPRB, 0.15910374E-09_JPRB, 0.15893742E-09_JPRB, 0.15868061E-09_JPRB /)

RGHG8(:,36, 7) = (/ &
  & 0.15596471E-09_JPRB, 0.15603886E-09_JPRB, 0.15610666E-09_JPRB, 0.15619264E-09_JPRB, 0.15630697E-09_JPRB, 0.15646107E-09_JPRB, &
  & 0.15666951E-09_JPRB, 0.15694571E-09_JPRB, 0.15729924E-09_JPRB, 0.15773620E-09_JPRB, 0.15825667E-09_JPRB, 0.15885712E-09_JPRB, &
  & 0.15952659E-09_JPRB, 0.16025045E-09_JPRB, 0.16100965E-09_JPRB, 0.16178379E-09_JPRB, 0.16254860E-09_JPRB, 0.16328329E-09_JPRB, &
  & 0.16396616E-09_JPRB, 0.16457655E-09_JPRB, 0.16509999E-09_JPRB, 0.16552693E-09_JPRB, 0.16585638E-09_JPRB, 0.16610287E-09_JPRB, &
  & 0.16628650E-09_JPRB, 0.16643245E-09_JPRB, 0.16656330E-09_JPRB, 0.16669473E-09_JPRB, 0.16683734E-09_JPRB, 0.16699220E-09_JPRB, &
  & 0.16715032E-09_JPRB, 0.16729439E-09_JPRB, 0.16740546E-09_JPRB, 0.16747302E-09_JPRB, 0.16749260E-09_JPRB, 0.16746654E-09_JPRB, &
  & 0.16739908E-09_JPRB, 0.16728888E-09_JPRB, 0.16713880E-09_JPRB, 0.16694028E-09_JPRB, 0.16669303E-09_JPRB, 0.16640489E-09_JPRB, &
  & 0.16608039E-09_JPRB, 0.16572602E-09_JPRB, 0.16535047E-09_JPRB, 0.16495257E-09_JPRB, 0.16454013E-09_JPRB, 0.16412563E-09_JPRB, &
  & 0.16371778E-09_JPRB, 0.16331302E-09_JPRB, 0.16291873E-09_JPRB, 0.16254248E-09_JPRB, 0.16218593E-09_JPRB, 0.16185192E-09_JPRB, &
  & 0.16154009E-09_JPRB, 0.16125003E-09_JPRB, 0.16098123E-09_JPRB, 0.16073529E-09_JPRB, 0.16051480E-09_JPRB, 0.16032151E-09_JPRB, &
  & 0.16015288E-09_JPRB, 0.16000165E-09_JPRB, 0.15984783E-09_JPRB, 0.15961055E-09_JPRB /)

RGHG8(:,37, 7) = (/ &
  & 0.15682043E-09_JPRB, 0.15692345E-09_JPRB, 0.15700753E-09_JPRB, 0.15710871E-09_JPRB, 0.15723603E-09_JPRB, 0.15740056E-09_JPRB, &
  & 0.15761316E-09_JPRB, 0.15788547E-09_JPRB, 0.15822610E-09_JPRB, 0.15863968E-09_JPRB, 0.15912797E-09_JPRB, 0.15968650E-09_JPRB, &
  & 0.16030827E-09_JPRB, 0.16098062E-09_JPRB, 0.16168876E-09_JPRB, 0.16241278E-09_JPRB, 0.16313413E-09_JPRB, 0.16383155E-09_JPRB, &
  & 0.16448733E-09_JPRB, 0.16508311E-09_JPRB, 0.16560020E-09_JPRB, 0.16602623E-09_JPRB, 0.16635709E-09_JPRB, 0.16660189E-09_JPRB, &
  & 0.16678116E-09_JPRB, 0.16691805E-09_JPRB, 0.16703322E-09_JPRB, 0.16714202E-09_JPRB, 0.16725227E-09_JPRB, 0.16736601E-09_JPRB, &
  & 0.16747671E-09_JPRB, 0.16757358E-09_JPRB, 0.16764486E-09_JPRB, 0.16768387E-09_JPRB, 0.16768899E-09_JPRB, 0.16766119E-09_JPRB, &
  & 0.16760417E-09_JPRB, 0.16751490E-09_JPRB, 0.16739696E-09_JPRB, 0.16723826E-09_JPRB, 0.16704385E-09_JPRB, 0.16680939E-09_JPRB, &
  & 0.16653863E-09_JPRB, 0.16623686E-09_JPRB, 0.16590350E-09_JPRB, 0.16554155E-09_JPRB, 0.16515699E-09_JPRB, 0.16476150E-09_JPRB, &
  & 0.16436308E-09_JPRB, 0.16396622E-09_JPRB, 0.16358150E-09_JPRB, 0.16321505E-09_JPRB, 0.16287022E-09_JPRB, 0.16254935E-09_JPRB, &
  & 0.16225160E-09_JPRB, 0.16197577E-09_JPRB, 0.16172164E-09_JPRB, 0.16149042E-09_JPRB, 0.16128514E-09_JPRB, 0.16110686E-09_JPRB, &
  & 0.16095270E-09_JPRB, 0.16081454E-09_JPRB, 0.16067463E-09_JPRB, 0.16045724E-09_JPRB /)

RGHG8(:,38, 7) = (/ &
  & 0.15764547E-09_JPRB, 0.15776913E-09_JPRB, 0.15786625E-09_JPRB, 0.15797626E-09_JPRB, 0.15811294E-09_JPRB, 0.15828111E-09_JPRB, &
  & 0.15849135E-09_JPRB, 0.15875354E-09_JPRB, 0.15907485E-09_JPRB, 0.15946146E-09_JPRB, 0.15991471E-09_JPRB, 0.16043150E-09_JPRB, &
  & 0.16100531E-09_JPRB, 0.16162721E-09_JPRB, 0.16228421E-09_JPRB, 0.16296013E-09_JPRB, 0.16363717E-09_JPRB, 0.16429912E-09_JPRB, &
  & 0.16492908E-09_JPRB, 0.16550830E-09_JPRB, 0.16601780E-09_JPRB, 0.16643600E-09_JPRB, 0.16675587E-09_JPRB, 0.16698690E-09_JPRB, &
  & 0.16714924E-09_JPRB, 0.16726832E-09_JPRB, 0.16736479E-09_JPRB, 0.16745155E-09_JPRB, 0.16753569E-09_JPRB, 0.16761834E-09_JPRB, &
  & 0.16769525E-09_JPRB, 0.16775982E-09_JPRB, 0.16780446E-09_JPRB, 0.16782528E-09_JPRB, 0.16782198E-09_JPRB, 0.16779539E-09_JPRB, &
  & 0.16774809E-09_JPRB, 0.16767801E-09_JPRB, 0.16758683E-09_JPRB, 0.16746625E-09_JPRB, 0.16731752E-09_JPRB, 0.16713374E-09_JPRB, &
  & 0.16691637E-09_JPRB, 0.16666390E-09_JPRB, 0.16637534E-09_JPRB, 0.16605065E-09_JPRB, 0.16569579E-09_JPRB, 0.16532062E-09_JPRB, &
  & 0.16493476E-09_JPRB, 0.16454964E-09_JPRB, 0.16417569E-09_JPRB, 0.16382051E-09_JPRB, 0.16348785E-09_JPRB, 0.16318008E-09_JPRB, &
  & 0.16289560E-09_JPRB, 0.16263291E-09_JPRB, 0.16239168E-09_JPRB, 0.16217382E-09_JPRB, 0.16198237E-09_JPRB, 0.16181831E-09_JPRB, &
  & 0.16167795E-09_JPRB, 0.16155292E-09_JPRB, 0.16142633E-09_JPRB, 0.16122904E-09_JPRB /)

RGHG8(:,39, 7) = (/ &
  & 0.15844914E-09_JPRB, 0.15858606E-09_JPRB, 0.15868898E-09_JPRB, 0.15880681E-09_JPRB, 0.15894562E-09_JPRB, 0.15911480E-09_JPRB, &
  & 0.15931841E-09_JPRB, 0.15956517E-09_JPRB, 0.15986382E-09_JPRB, 0.16022052E-09_JPRB, 0.16063684E-09_JPRB, 0.16111157E-09_JPRB, &
  & 0.16163830E-09_JPRB, 0.16220977E-09_JPRB, 0.16281575E-09_JPRB, 0.16344211E-09_JPRB, 0.16407428E-09_JPRB, 0.16469849E-09_JPRB, &
  & 0.16529926E-09_JPRB, 0.16585873E-09_JPRB, 0.16634820E-09_JPRB, 0.16674656E-09_JPRB, 0.16704264E-09_JPRB, 0.16724847E-09_JPRB, &
  & 0.16738898E-09_JPRB, 0.16748961E-09_JPRB, 0.16756953E-09_JPRB, 0.16764011E-09_JPRB, 0.16770640E-09_JPRB, 0.16776938E-09_JPRB, &
  & 0.16782602E-09_JPRB, 0.16787149E-09_JPRB, 0.16790090E-09_JPRB, 0.16791142E-09_JPRB, 0.16790366E-09_JPRB, 0.16787828E-09_JPRB, &
  & 0.16783784E-09_JPRB, 0.16778069E-09_JPRB, 0.16770871E-09_JPRB, 0.16761620E-09_JPRB, 0.16750314E-09_JPRB, 0.16736332E-09_JPRB, &
  & 0.16719551E-09_JPRB, 0.16699352E-09_JPRB, 0.16675317E-09_JPRB, 0.16647118E-09_JPRB, 0.16615098E-09_JPRB, 0.16580100E-09_JPRB, &
  & 0.16543454E-09_JPRB, 0.16506456E-09_JPRB, 0.16470449E-09_JPRB, 0.16436266E-09_JPRB, 0.16404378E-09_JPRB, 0.16374979E-09_JPRB, &
  & 0.16347840E-09_JPRB, 0.16322792E-09_JPRB, 0.16299850E-09_JPRB, 0.16279281E-09_JPRB, 0.16261427E-09_JPRB, 0.16246356E-09_JPRB, &
  & 0.16233612E-09_JPRB, 0.16222346E-09_JPRB, 0.16210928E-09_JPRB, 0.16193241E-09_JPRB /)

RGHG8(:,40, 7) = (/ &
  & 0.15922949E-09_JPRB, 0.15937365E-09_JPRB, 0.15948146E-09_JPRB, 0.15959922E-09_JPRB, 0.15974257E-09_JPRB, 0.15990827E-09_JPRB, &
  & 0.16010283E-09_JPRB, 0.16033339E-09_JPRB, 0.16060692E-09_JPRB, 0.16093114E-09_JPRB, 0.16131035E-09_JPRB, 0.16174234E-09_JPRB, &
  & 0.16222239E-09_JPRB, 0.16274415E-09_JPRB, 0.16329858E-09_JPRB, 0.16387401E-09_JPRB, 0.16445866E-09_JPRB, 0.16504083E-09_JPRB, &
  & 0.16560796E-09_JPRB, 0.16613688E-09_JPRB, 0.16660147E-09_JPRB, 0.16697074E-09_JPRB, 0.16723833E-09_JPRB, 0.16741948E-09_JPRB, &
  & 0.16754062E-09_JPRB, 0.16762688E-09_JPRB, 0.16769518E-09_JPRB, 0.16775467E-09_JPRB, 0.16780957E-09_JPRB, 0.16786043E-09_JPRB, &
  & 0.16790501E-09_JPRB, 0.16793984E-09_JPRB, 0.16796053E-09_JPRB, 0.16796541E-09_JPRB, 0.16795498E-09_JPRB, 0.16793067E-09_JPRB, &
  & 0.16789400E-09_JPRB, 0.16784499E-09_JPRB, 0.16778472E-09_JPRB, 0.16771037E-09_JPRB, 0.16762156E-09_JPRB, 0.16751446E-09_JPRB, &
  & 0.16738631E-09_JPRB, 0.16722967E-09_JPRB, 0.16703779E-09_JPRB, 0.16680231E-09_JPRB, 0.16652221E-09_JPRB, 0.16620480E-09_JPRB, &
  & 0.16586241E-09_JPRB, 0.16551288E-09_JPRB, 0.16517039E-09_JPRB, 0.16484498E-09_JPRB, 0.16454194E-09_JPRB, 0.16426242E-09_JPRB, &
  & 0.16400448E-09_JPRB, 0.16376565E-09_JPRB, 0.16354745E-09_JPRB, 0.16335286E-09_JPRB, 0.16318646E-09_JPRB, 0.16304817E-09_JPRB, &
  & 0.16293283E-09_JPRB, 0.16283122E-09_JPRB, 0.16272902E-09_JPRB, 0.16256962E-09_JPRB /)

RGHG8(:,41, 7) = (/ &
  & 0.15999044E-09_JPRB, 0.16013676E-09_JPRB, 0.16024129E-09_JPRB, 0.16036218E-09_JPRB, 0.16050322E-09_JPRB, 0.16066780E-09_JPRB, &
  & 0.16085380E-09_JPRB, 0.16106649E-09_JPRB, 0.16131489E-09_JPRB, 0.16160696E-09_JPRB, 0.16194734E-09_JPRB, 0.16233691E-09_JPRB, &
  & 0.16277080E-09_JPRB, 0.16324285E-09_JPRB, 0.16374548E-09_JPRB, 0.16426892E-09_JPRB, 0.16480280E-09_JPRB, 0.16533998E-09_JPRB, &
  & 0.16586739E-09_JPRB, 0.16636460E-09_JPRB, 0.16679612E-09_JPRB, 0.16713592E-09_JPRB, 0.16737652E-09_JPRB, 0.16753636E-09_JPRB, &
  & 0.16764240E-09_JPRB, 0.16771794E-09_JPRB, 0.16777779E-09_JPRB, 0.16782975E-09_JPRB, 0.16787691E-09_JPRB, 0.16791996E-09_JPRB, &
  & 0.16795734E-09_JPRB, 0.16798565E-09_JPRB, 0.16800146E-09_JPRB, 0.16800293E-09_JPRB, 0.16799100E-09_JPRB, 0.16796733E-09_JPRB, &
  & 0.16793308E-09_JPRB, 0.16788909E-09_JPRB, 0.16783591E-09_JPRB, 0.16777321E-09_JPRB, 0.16770017E-09_JPRB, 0.16761519E-09_JPRB, &
  & 0.16751647E-09_JPRB, 0.16739504E-09_JPRB, 0.16724548E-09_JPRB, 0.16705455E-09_JPRB, 0.16681823E-09_JPRB, 0.16653630E-09_JPRB, &
  & 0.16622433E-09_JPRB, 0.16589843E-09_JPRB, 0.16557676E-09_JPRB, 0.16527060E-09_JPRB, 0.16498505E-09_JPRB, 0.16472185E-09_JPRB, &
  & 0.16447756E-09_JPRB, 0.16425111E-09_JPRB, 0.16404322E-09_JPRB, 0.16385952E-09_JPRB, 0.16370438E-09_JPRB, 0.16357771E-09_JPRB, &
  & 0.16347319E-09_JPRB, 0.16338178E-09_JPRB, 0.16328928E-09_JPRB, 0.16314607E-09_JPRB /)

RGHG8(:,42, 7) = (/ &
  & 0.16076300E-09_JPRB, 0.16087977E-09_JPRB, 0.16097695E-09_JPRB, 0.16109231E-09_JPRB, 0.16123726E-09_JPRB, 0.16139914E-09_JPRB, &
  & 0.16157695E-09_JPRB, 0.16177432E-09_JPRB, 0.16199808E-09_JPRB, 0.16225769E-09_JPRB, 0.16256033E-09_JPRB, 0.16290731E-09_JPRB, &
  & 0.16329500E-09_JPRB, 0.16371804E-09_JPRB, 0.16416879E-09_JPRB, 0.16463850E-09_JPRB, 0.16512089E-09_JPRB, 0.16560812E-09_JPRB, &
  & 0.16609264E-09_JPRB, 0.16655169E-09_JPRB, 0.16695327E-09_JPRB, 0.16726463E-09_JPRB, 0.16748136E-09_JPRB, 0.16762307E-09_JPRB, &
  & 0.16771677E-09_JPRB, 0.16778391E-09_JPRB, 0.16783734E-09_JPRB, 0.16788346E-09_JPRB, 0.16792512E-09_JPRB, 0.16796289E-09_JPRB, &
  & 0.16799551E-09_JPRB, 0.16802004E-09_JPRB, 0.16803273E-09_JPRB, 0.16803225E-09_JPRB, 0.16801945E-09_JPRB, 0.16799620E-09_JPRB, &
  & 0.16796368E-09_JPRB, 0.16792277E-09_JPRB, 0.16787460E-09_JPRB, 0.16781902E-09_JPRB, 0.16775678E-09_JPRB, 0.16768689E-09_JPRB, &
  & 0.16760843E-09_JPRB, 0.16751386E-09_JPRB, 0.16739786E-09_JPRB, 0.16724647E-09_JPRB, 0.16705123E-09_JPRB, 0.16680869E-09_JPRB, &
  & 0.16652822E-09_JPRB, 0.16622882E-09_JPRB, 0.16592984E-09_JPRB, 0.16564458E-09_JPRB, 0.16537882E-09_JPRB, 0.16513256E-09_JPRB, &
  & 0.16490380E-09_JPRB, 0.16468954E-09_JPRB, 0.16449297E-09_JPRB, 0.16431947E-09_JPRB, 0.16417526E-09_JPRB, 0.16405927E-09_JPRB, &
  & 0.16396461E-09_JPRB, 0.16388178E-09_JPRB, 0.16379788E-09_JPRB, 0.16366705E-09_JPRB /)

RGHG8(:,43, 7) = (/ &
  & 0.16142726E-09_JPRB, 0.16157142E-09_JPRB, 0.16167490E-09_JPRB, 0.16179913E-09_JPRB, 0.16194572E-09_JPRB, 0.16211070E-09_JPRB, &
  & 0.16228228E-09_JPRB, 0.16246524E-09_JPRB, 0.16266621E-09_JPRB, 0.16289538E-09_JPRB, 0.16316073E-09_JPRB, 0.16346563E-09_JPRB, &
  & 0.16380780E-09_JPRB, 0.16418170E-09_JPRB, 0.16458002E-09_JPRB, 0.16499646E-09_JPRB, 0.16542372E-09_JPRB, 0.16586080E-09_JPRB, &
  & 0.16629882E-09_JPRB, 0.16672065E-09_JPRB, 0.16708854E-09_JPRB, 0.16737239E-09_JPRB, 0.16756650E-09_JPRB, 0.16769201E-09_JPRB, &
  & 0.16777510E-09_JPRB, 0.16783513E-09_JPRB, 0.16788326E-09_JPRB, 0.16792484E-09_JPRB, 0.16796230E-09_JPRB, 0.16799637E-09_JPRB, &
  & 0.16802597E-09_JPRB, 0.16804796E-09_JPRB, 0.16805894E-09_JPRB, 0.16805729E-09_JPRB, 0.16804404E-09_JPRB, 0.16802111E-09_JPRB, &
  & 0.16798979E-09_JPRB, 0.16795117E-09_JPRB, 0.16790606E-09_JPRB, 0.16785572E-09_JPRB, 0.16780066E-09_JPRB, 0.16774120E-09_JPRB, &
  & 0.16767754E-09_JPRB, 0.16760293E-09_JPRB, 0.16751293E-09_JPRB, 0.16739454E-09_JPRB, 0.16723774E-09_JPRB, 0.16703314E-09_JPRB, &
  & 0.16678565E-09_JPRB, 0.16651322E-09_JPRB, 0.16623751E-09_JPRB, 0.16597429E-09_JPRB, 0.16572886E-09_JPRB, 0.16550139E-09_JPRB, &
  & 0.16528873E-09_JPRB, 0.16508868E-09_JPRB, 0.16490341E-09_JPRB, 0.16474093E-09_JPRB, 0.16460733E-09_JPRB, 0.16450148E-09_JPRB, &
  & 0.16441569E-09_JPRB, 0.16434032E-09_JPRB, 0.16426313E-09_JPRB, 0.16414177E-09_JPRB /)

RGHG8(:,44, 7) = (/ &
  & 0.16209786E-09_JPRB, 0.16226168E-09_JPRB, 0.16237212E-09_JPRB, 0.16249457E-09_JPRB, 0.16264988E-09_JPRB, 0.16281301E-09_JPRB, &
  & 0.16298164E-09_JPRB, 0.16315085E-09_JPRB, 0.16333133E-09_JPRB, 0.16353142E-09_JPRB, 0.16376106E-09_JPRB, 0.16402492E-09_JPRB, &
  & 0.16432156E-09_JPRB, 0.16464594E-09_JPRB, 0.16499256E-09_JPRB, 0.16535295E-09_JPRB, 0.16572635E-09_JPRB, 0.16610788E-09_JPRB, &
  & 0.16649795E-09_JPRB, 0.16687650E-09_JPRB, 0.16721169E-09_JPRB, 0.16746690E-09_JPRB, 0.16763932E-09_JPRB, 0.16774959E-09_JPRB, &
  & 0.16782301E-09_JPRB, 0.16787678E-09_JPRB, 0.16792034E-09_JPRB, 0.16795822E-09_JPRB, 0.16799256E-09_JPRB, 0.16802407E-09_JPRB, &
  & 0.16805167E-09_JPRB, 0.16807232E-09_JPRB, 0.16808233E-09_JPRB, 0.16808006E-09_JPRB, 0.16806669E-09_JPRB, 0.16804406E-09_JPRB, &
  & 0.16801362E-09_JPRB, 0.16797642E-09_JPRB, 0.16793367E-09_JPRB, 0.16788662E-09_JPRB, 0.16783674E-09_JPRB, 0.16778497E-09_JPRB, &
  & 0.16773168E-09_JPRB, 0.16767286E-09_JPRB, 0.16760271E-09_JPRB, 0.16751239E-09_JPRB, 0.16738957E-09_JPRB, 0.16722163E-09_JPRB, &
  & 0.16700881E-09_JPRB, 0.16676280E-09_JPRB, 0.16651071E-09_JPRB, 0.16626885E-09_JPRB, 0.16604426E-09_JPRB, 0.16583650E-09_JPRB, &
  & 0.16564188E-09_JPRB, 0.16545713E-09_JPRB, 0.16528517E-09_JPRB, 0.16513396E-09_JPRB, 0.16501113E-09_JPRB, 0.16491485E-09_JPRB, &
  & 0.16483684E-09_JPRB, 0.16476782E-09_JPRB, 0.16469603E-09_JPRB, 0.16458163E-09_JPRB /)

RGHG8(:,45, 7) = (/ &
  & 0.16288305E-09_JPRB, 0.16299971E-09_JPRB, 0.16308860E-09_JPRB, 0.16320872E-09_JPRB, 0.16335713E-09_JPRB, 0.16352730E-09_JPRB, &
  & 0.16368684E-09_JPRB, 0.16384613E-09_JPRB, 0.16400546E-09_JPRB, 0.16417893E-09_JPRB, 0.16437388E-09_JPRB, 0.16459736E-09_JPRB, &
  & 0.16484887E-09_JPRB, 0.16512429E-09_JPRB, 0.16541624E-09_JPRB, 0.16572263E-09_JPRB, 0.16603657E-09_JPRB, 0.16636424E-09_JPRB, &
  & 0.16669960E-09_JPRB, 0.16703404E-09_JPRB, 0.16732832E-09_JPRB, 0.16755372E-09_JPRB, 0.16770328E-09_JPRB, 0.16779898E-09_JPRB, &
  & 0.16786333E-09_JPRB, 0.16791145E-09_JPRB, 0.16795100E-09_JPRB, 0.16798593E-09_JPRB, 0.16801793E-09_JPRB, 0.16804770E-09_JPRB, &
  & 0.16807417E-09_JPRB, 0.16809415E-09_JPRB, 0.16810389E-09_JPRB, 0.16810159E-09_JPRB, 0.16808828E-09_JPRB, 0.16806594E-09_JPRB, &
  & 0.16803600E-09_JPRB, 0.16799978E-09_JPRB, 0.16795851E-09_JPRB, 0.16791372E-09_JPRB, 0.16786761E-09_JPRB, 0.16782119E-09_JPRB, &
  & 0.16777615E-09_JPRB, 0.16772890E-09_JPRB, 0.16767497E-09_JPRB, 0.16760744E-09_JPRB, 0.16751392E-09_JPRB, 0.16738322E-09_JPRB, &
  & 0.16720467E-09_JPRB, 0.16698942E-09_JPRB, 0.16676026E-09_JPRB, 0.16653937E-09_JPRB, 0.16633578E-09_JPRB, 0.16614822E-09_JPRB, &
  & 0.16597269E-09_JPRB, 0.16580554E-09_JPRB, 0.16564787E-09_JPRB, 0.16550936E-09_JPRB, 0.16539703E-09_JPRB, 0.16530960E-09_JPRB, &
  & 0.16523863E-09_JPRB, 0.16517501E-09_JPRB, 0.16510768E-09_JPRB, 0.16499782E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART13',1,ZHOOK_HANDLE)
END SUBROUTINE PART13




SUBROUTINE PART14
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART14',0,ZHOOK_HANDLE)



RGHG8(:,46, 7) = (/ &
  & 0.16350761E-09_JPRB, 0.16369477E-09_JPRB, 0.16381259E-09_JPRB, 0.16393638E-09_JPRB, 0.16409991E-09_JPRB, 0.16426323E-09_JPRB, &
  & 0.16442447E-09_JPRB, 0.16456694E-09_JPRB, 0.16470819E-09_JPRB, 0.16485298E-09_JPRB, 0.16501471E-09_JPRB, 0.16519780E-09_JPRB, &
  & 0.16540379E-09_JPRB, 0.16562782E-09_JPRB, 0.16586635E-09_JPRB, 0.16611201E-09_JPRB, 0.16636931E-09_JPRB, 0.16663490E-09_JPRB, &
  & 0.16691562E-09_JPRB, 0.16719329E-09_JPRB, 0.16744460E-09_JPRB, 0.16763416E-09_JPRB, 0.16776090E-09_JPRB, 0.16784189E-09_JPRB, &
  & 0.16789778E-09_JPRB, 0.16794065E-09_JPRB, 0.16797679E-09_JPRB, 0.16800925E-09_JPRB, 0.16803961E-09_JPRB, 0.16806828E-09_JPRB, &
  & 0.16809421E-09_JPRB, 0.16811420E-09_JPRB, 0.16812421E-09_JPRB, 0.16812227E-09_JPRB, 0.16810928E-09_JPRB, 0.16808717E-09_JPRB, &
  & 0.16805748E-09_JPRB, 0.16802190E-09_JPRB, 0.16798127E-09_JPRB, 0.16793834E-09_JPRB, 0.16789431E-09_JPRB, 0.16785240E-09_JPRB, &
  & 0.16781294E-09_JPRB, 0.16777507E-09_JPRB, 0.16773391E-09_JPRB, 0.16768431E-09_JPRB, 0.16761686E-09_JPRB, 0.16751915E-09_JPRB, &
  & 0.16738000E-09_JPRB, 0.16719839E-09_JPRB, 0.16699696E-09_JPRB, 0.16679834E-09_JPRB, 0.16661542E-09_JPRB, 0.16644888E-09_JPRB, &
  & 0.16629344E-09_JPRB, 0.16614411E-09_JPRB, 0.16600277E-09_JPRB, 0.16587665E-09_JPRB, 0.16577473E-09_JPRB, 0.16569518E-09_JPRB, &
  & 0.16563032E-09_JPRB, 0.16557129E-09_JPRB, 0.16550750E-09_JPRB, 0.16540112E-09_JPRB /)

RGHG8(:,47, 7) = (/ &
  & 0.16435867E-09_JPRB, 0.16449994E-09_JPRB, 0.16460151E-09_JPRB, 0.16473209E-09_JPRB, 0.16488988E-09_JPRB, 0.16506591E-09_JPRB, &
  & 0.16521179E-09_JPRB, 0.16534296E-09_JPRB, 0.16545847E-09_JPRB, 0.16557537E-09_JPRB, 0.16570006E-09_JPRB, 0.16584151E-09_JPRB, &
  & 0.16599966E-09_JPRB, 0.16617126E-09_JPRB, 0.16635017E-09_JPRB, 0.16653709E-09_JPRB, 0.16672880E-09_JPRB, 0.16693340E-09_JPRB, &
  & 0.16714630E-09_JPRB, 0.16736459E-09_JPRB, 0.16755974E-09_JPRB, 0.16771176E-09_JPRB, 0.16781315E-09_JPRB, 0.16787979E-09_JPRB, &
  & 0.16792734E-09_JPRB, 0.16796543E-09_JPRB, 0.16799852E-09_JPRB, 0.16802909E-09_JPRB, 0.16805822E-09_JPRB, 0.16808635E-09_JPRB, &
  & 0.16811236E-09_JPRB, 0.16813277E-09_JPRB, 0.16814351E-09_JPRB, 0.16814231E-09_JPRB, 0.16812980E-09_JPRB, 0.16810799E-09_JPRB, &
  & 0.16807838E-09_JPRB, 0.16804286E-09_JPRB, 0.16800300E-09_JPRB, 0.16796048E-09_JPRB, 0.16791868E-09_JPRB, 0.16787906E-09_JPRB, &
  & 0.16784456E-09_JPRB, 0.16781326E-09_JPRB, 0.16778248E-09_JPRB, 0.16774722E-09_JPRB, 0.16770121E-09_JPRB, 0.16763448E-09_JPRB, &
  & 0.16753403E-09_JPRB, 0.16739628E-09_JPRB, 0.16722945E-09_JPRB, 0.16705946E-09_JPRB, 0.16689965E-09_JPRB, 0.16675444E-09_JPRB, &
  & 0.16661877E-09_JPRB, 0.16648834E-09_JPRB, 0.16636162E-09_JPRB, 0.16624786E-09_JPRB, 0.16615456E-09_JPRB, 0.16608158E-09_JPRB, &
  & 0.16602134E-09_JPRB, 0.16596585E-09_JPRB, 0.16590461E-09_JPRB, 0.16580053E-09_JPRB /)

RGHG8(:,48, 7) = (/ &
  & 0.16504442E-09_JPRB, 0.16525549E-09_JPRB, 0.16540237E-09_JPRB, 0.16555647E-09_JPRB, 0.16574644E-09_JPRB, 0.16592200E-09_JPRB, &
  & 0.16607003E-09_JPRB, 0.16617958E-09_JPRB, 0.16627189E-09_JPRB, 0.16635611E-09_JPRB, 0.16644326E-09_JPRB, 0.16653981E-09_JPRB, &
  & 0.16664724E-09_JPRB, 0.16676216E-09_JPRB, 0.16688068E-09_JPRB, 0.16700040E-09_JPRB, 0.16712527E-09_JPRB, 0.16725579E-09_JPRB, &
  & 0.16739680E-09_JPRB, 0.16754063E-09_JPRB, 0.16767704E-09_JPRB, 0.16778597E-09_JPRB, 0.16786196E-09_JPRB, 0.16791374E-09_JPRB, &
  & 0.16795322E-09_JPRB, 0.16798664E-09_JPRB, 0.16801709E-09_JPRB, 0.16804597E-09_JPRB, 0.16807433E-09_JPRB, 0.16810234E-09_JPRB, &
  & 0.16812877E-09_JPRB, 0.16815015E-09_JPRB, 0.16816203E-09_JPRB, 0.16816190E-09_JPRB, 0.16815001E-09_JPRB, 0.16812843E-09_JPRB, &
  & 0.16809856E-09_JPRB, 0.16806320E-09_JPRB, 0.16802314E-09_JPRB, 0.16798168E-09_JPRB, 0.16794027E-09_JPRB, 0.16790308E-09_JPRB, &
  & 0.16787137E-09_JPRB, 0.16784564E-09_JPRB, 0.16782274E-09_JPRB, 0.16779921E-09_JPRB, 0.16777060E-09_JPRB, 0.16772957E-09_JPRB, &
  & 0.16766773E-09_JPRB, 0.16757588E-09_JPRB, 0.16746035E-09_JPRB, 0.16732860E-09_JPRB, 0.16720103E-09_JPRB, 0.16708056E-09_JPRB, &
  & 0.16696564E-09_JPRB, 0.16685173E-09_JPRB, 0.16673851E-09_JPRB, 0.16663314E-09_JPRB, 0.16654597E-09_JPRB, 0.16647671E-09_JPRB, &
  & 0.16641923E-09_JPRB, 0.16636553E-09_JPRB, 0.16630548E-09_JPRB, 0.16620168E-09_JPRB /)

RGHG8(:,49, 7) = (/ &
  & 0.16575638E-09_JPRB, 0.16601578E-09_JPRB, 0.16618766E-09_JPRB, 0.16637337E-09_JPRB, 0.16658094E-09_JPRB, 0.16677852E-09_JPRB, &
  & 0.16691819E-09_JPRB, 0.16701555E-09_JPRB, 0.16708625E-09_JPRB, 0.16714322E-09_JPRB, 0.16719755E-09_JPRB, 0.16725335E-09_JPRB, &
  & 0.16731289E-09_JPRB, 0.16737231E-09_JPRB, 0.16742895E-09_JPRB, 0.16748199E-09_JPRB, 0.16753375E-09_JPRB, 0.16758858E-09_JPRB, &
  & 0.16764888E-09_JPRB, 0.16771824E-09_JPRB, 0.16779271E-09_JPRB, 0.16785863E-09_JPRB, 0.16790810E-09_JPRB, 0.16794505E-09_JPRB, &
  & 0.16797630E-09_JPRB, 0.16800529E-09_JPRB, 0.16803317E-09_JPRB, 0.16806072E-09_JPRB, 0.16808850E-09_JPRB, 0.16811669E-09_JPRB, &
  & 0.16814396E-09_JPRB, 0.16816658E-09_JPRB, 0.16817990E-09_JPRB, 0.16818102E-09_JPRB, 0.16816992E-09_JPRB, 0.16814852E-09_JPRB, &
  & 0.16811832E-09_JPRB, 0.16808289E-09_JPRB, 0.16804287E-09_JPRB, 0.16800139E-09_JPRB, 0.16796080E-09_JPRB, 0.16792427E-09_JPRB, &
  & 0.16789523E-09_JPRB, 0.16787337E-09_JPRB, 0.16785684E-09_JPRB, 0.16784266E-09_JPRB, 0.16782763E-09_JPRB, 0.16780760E-09_JPRB, &
  & 0.16777658E-09_JPRB, 0.16773041E-09_JPRB, 0.16766516E-09_JPRB, 0.16758955E-09_JPRB, 0.16750529E-09_JPRB, 0.16741994E-09_JPRB, &
  & 0.16733293E-09_JPRB, 0.16723820E-09_JPRB, 0.16713837E-09_JPRB, 0.16704084E-09_JPRB, 0.16695655E-09_JPRB, 0.16688917E-09_JPRB, &
  & 0.16683196E-09_JPRB, 0.16677826E-09_JPRB, 0.16671706E-09_JPRB, 0.16660984E-09_JPRB /)

RGHG8(:,50, 7) = (/ &
  & 0.16649214E-09_JPRB, 0.16673068E-09_JPRB, 0.16689392E-09_JPRB, 0.16707491E-09_JPRB, 0.16728323E-09_JPRB, 0.16747226E-09_JPRB, &
  & 0.16760032E-09_JPRB, 0.16768217E-09_JPRB, 0.16773427E-09_JPRB, 0.16777471E-09_JPRB, 0.16780703E-09_JPRB, 0.16783683E-09_JPRB, &
  & 0.16786211E-09_JPRB, 0.16788018E-09_JPRB, 0.16788844E-09_JPRB, 0.16788854E-09_JPRB, 0.16788354E-09_JPRB, 0.16787786E-09_JPRB, &
  & 0.16787710E-09_JPRB, 0.16788537E-09_JPRB, 0.16790475E-09_JPRB, 0.16793028E-09_JPRB, 0.16795326E-09_JPRB, 0.16797472E-09_JPRB, &
  & 0.16799752E-09_JPRB, 0.16802199E-09_JPRB, 0.16804746E-09_JPRB, 0.16807376E-09_JPRB, 0.16810120E-09_JPRB, 0.16812979E-09_JPRB, &
  & 0.16815810E-09_JPRB, 0.16818233E-09_JPRB, 0.16819734E-09_JPRB, 0.16819990E-09_JPRB, 0.16818963E-09_JPRB, 0.16816819E-09_JPRB, &
  & 0.16813792E-09_JPRB, 0.16810202E-09_JPRB, 0.16806197E-09_JPRB, 0.16802053E-09_JPRB, 0.16798003E-09_JPRB, 0.16794413E-09_JPRB, &
  & 0.16791638E-09_JPRB, 0.16789783E-09_JPRB, 0.16788632E-09_JPRB, 0.16787947E-09_JPRB, 0.16787507E-09_JPRB, 0.16787048E-09_JPRB, &
  & 0.16786239E-09_JPRB, 0.16784707E-09_JPRB, 0.16782395E-09_JPRB, 0.16779120E-09_JPRB, 0.16775308E-09_JPRB, 0.16770924E-09_JPRB, &
  & 0.16765678E-09_JPRB, 0.16759666E-09_JPRB, 0.16752279E-09_JPRB, 0.16744393E-09_JPRB, 0.16737205E-09_JPRB, 0.16730972E-09_JPRB, &
  & 0.16725593E-09_JPRB, 0.16720256E-09_JPRB, 0.16713965E-09_JPRB, 0.16702474E-09_JPRB /)

RGHG8(:,51, 7) = (/ &
  & 0.16706690E-09_JPRB, 0.16729619E-09_JPRB, 0.16744688E-09_JPRB, 0.16760147E-09_JPRB, 0.16778345E-09_JPRB, 0.16794055E-09_JPRB, &
  & 0.16804520E-09_JPRB, 0.16810320E-09_JPRB, 0.16814217E-09_JPRB, 0.16816715E-09_JPRB, 0.16818719E-09_JPRB, 0.16820131E-09_JPRB, &
  & 0.16820763E-09_JPRB, 0.16820184E-09_JPRB, 0.16818356E-09_JPRB, 0.16815579E-09_JPRB, 0.16812333E-09_JPRB, 0.16808999E-09_JPRB, &
  & 0.16805712E-09_JPRB, 0.16803173E-09_JPRB, 0.16801165E-09_JPRB, 0.16800207E-09_JPRB, 0.16799892E-09_JPRB, 0.16800387E-09_JPRB, &
  & 0.16801761E-09_JPRB, 0.16803747E-09_JPRB, 0.16806058E-09_JPRB, 0.16808581E-09_JPRB, 0.16811293E-09_JPRB, 0.16814204E-09_JPRB, &
  & 0.16817164E-09_JPRB, 0.16819762E-09_JPRB, 0.16821451E-09_JPRB, 0.16821862E-09_JPRB, 0.16820911E-09_JPRB, 0.16818794E-09_JPRB, &
  & 0.16815704E-09_JPRB, 0.16812129E-09_JPRB, 0.16808055E-09_JPRB, 0.16803940E-09_JPRB, 0.16799857E-09_JPRB, 0.16796281E-09_JPRB, &
  & 0.16793611E-09_JPRB, 0.16791996E-09_JPRB, 0.16791248E-09_JPRB, 0.16791146E-09_JPRB, 0.16791527E-09_JPRB, 0.16792200E-09_JPRB, &
  & 0.16792849E-09_JPRB, 0.16793233E-09_JPRB, 0.16793095E-09_JPRB, 0.16792431E-09_JPRB, 0.16791243E-09_JPRB, 0.16789611E-09_JPRB, &
  & 0.16787594E-09_JPRB, 0.16784713E-09_JPRB, 0.16781154E-09_JPRB, 0.16776834E-09_JPRB, 0.16772347E-09_JPRB, 0.16768308E-09_JPRB, &
  & 0.16764240E-09_JPRB, 0.16759921E-09_JPRB, 0.16754167E-09_JPRB, 0.16742790E-09_JPRB /)

RGHG8(:,52, 7) = (/ &
  & 0.16761269E-09_JPRB, 0.16776343E-09_JPRB, 0.16786662E-09_JPRB, 0.16798481E-09_JPRB, 0.16812085E-09_JPRB, 0.16824304E-09_JPRB, &
  & 0.16831470E-09_JPRB, 0.16835769E-09_JPRB, 0.16838064E-09_JPRB, 0.16839700E-09_JPRB, 0.16840718E-09_JPRB, 0.16841206E-09_JPRB, &
  & 0.16840762E-09_JPRB, 0.16838986E-09_JPRB, 0.16835910E-09_JPRB, 0.16832029E-09_JPRB, 0.16827785E-09_JPRB, 0.16823443E-09_JPRB, &
  & 0.16819440E-09_JPRB, 0.16814912E-09_JPRB, 0.16811226E-09_JPRB, 0.16807343E-09_JPRB, 0.16804640E-09_JPRB, 0.16803339E-09_JPRB, &
  & 0.16803724E-09_JPRB, 0.16805225E-09_JPRB, 0.16807314E-09_JPRB, 0.16809731E-09_JPRB, 0.16812432E-09_JPRB, 0.16815398E-09_JPRB, &
  & 0.16818487E-09_JPRB, 0.16821278E-09_JPRB, 0.16823172E-09_JPRB, 0.16823737E-09_JPRB, 0.16822883E-09_JPRB, 0.16820748E-09_JPRB, &
  & 0.16817697E-09_JPRB, 0.16814015E-09_JPRB, 0.16809970E-09_JPRB, 0.16805776E-09_JPRB, 0.16801685E-09_JPRB, 0.16798092E-09_JPRB, &
  & 0.16795490E-09_JPRB, 0.16794052E-09_JPRB, 0.16793626E-09_JPRB, 0.16793997E-09_JPRB, 0.16795039E-09_JPRB, 0.16796499E-09_JPRB, &
  & 0.16798099E-09_JPRB, 0.16799472E-09_JPRB, 0.16800430E-09_JPRB, 0.16800904E-09_JPRB, 0.16800955E-09_JPRB, 0.16800704E-09_JPRB, &
  & 0.16800145E-09_JPRB, 0.16799340E-09_JPRB, 0.16798049E-09_JPRB, 0.16796431E-09_JPRB, 0.16794706E-09_JPRB, 0.16792837E-09_JPRB, &
  & 0.16790923E-09_JPRB, 0.16788473E-09_JPRB, 0.16784801E-09_JPRB, 0.16775906E-09_JPRB /)

RGHG8(:,53, 7) = (/ &
  & 0.16796295E-09_JPRB, 0.16808942E-09_JPRB, 0.16817167E-09_JPRB, 0.16825699E-09_JPRB, 0.16835627E-09_JPRB, 0.16843962E-09_JPRB, &
  & 0.16849212E-09_JPRB, 0.16851759E-09_JPRB, 0.16853309E-09_JPRB, 0.16854131E-09_JPRB, 0.16854566E-09_JPRB, 0.16854459E-09_JPRB, &
  & 0.16853426E-09_JPRB, 0.16851016E-09_JPRB, 0.16847425E-09_JPRB, 0.16843073E-09_JPRB, 0.16838525E-09_JPRB, 0.16834173E-09_JPRB, &
  & 0.16829395E-09_JPRB, 0.16825172E-09_JPRB, 0.16819554E-09_JPRB, 0.16814661E-09_JPRB, 0.16809501E-09_JPRB, 0.16806398E-09_JPRB, &
  & 0.16805687E-09_JPRB, 0.16806685E-09_JPRB, 0.16808550E-09_JPRB, 0.16810886E-09_JPRB, 0.16813570E-09_JPRB, 0.16816600E-09_JPRB, &
  & 0.16819827E-09_JPRB, 0.16822808E-09_JPRB, 0.16824919E-09_JPRB, 0.16825642E-09_JPRB, 0.16824875E-09_JPRB, 0.16822800E-09_JPRB, &
  & 0.16819679E-09_JPRB, 0.16816006E-09_JPRB, 0.16811869E-09_JPRB, 0.16807648E-09_JPRB, 0.16803488E-09_JPRB, 0.16799875E-09_JPRB, &
  & 0.16797319E-09_JPRB, 0.16796030E-09_JPRB, 0.16795845E-09_JPRB, 0.16796595E-09_JPRB, 0.16798128E-09_JPRB, 0.16800211E-09_JPRB, &
  & 0.16802360E-09_JPRB, 0.16804295E-09_JPRB, 0.16805778E-09_JPRB, 0.16806720E-09_JPRB, 0.16807282E-09_JPRB, 0.16807583E-09_JPRB, &
  & 0.16807687E-09_JPRB, 0.16807630E-09_JPRB, 0.16807396E-09_JPRB, 0.16806981E-09_JPRB, 0.16806431E-09_JPRB, 0.16805876E-09_JPRB, &
  & 0.16805171E-09_JPRB, 0.16804261E-09_JPRB, 0.16802719E-09_JPRB, 0.16798099E-09_JPRB /)

RGHG8(:,54, 7) = (/ &
  & 0.16827043E-09_JPRB, 0.16834711E-09_JPRB, 0.16840013E-09_JPRB, 0.16845776E-09_JPRB, 0.16852389E-09_JPRB, 0.16858095E-09_JPRB, &
  & 0.16861315E-09_JPRB, 0.16863069E-09_JPRB, 0.16863866E-09_JPRB, 0.16864271E-09_JPRB, 0.16864313E-09_JPRB, 0.16863860E-09_JPRB, &
  & 0.16862481E-09_JPRB, 0.16859852E-09_JPRB, 0.16856008E-09_JPRB, 0.16851583E-09_JPRB, 0.16847046E-09_JPRB, 0.16842375E-09_JPRB, &
  & 0.16838168E-09_JPRB, 0.16832771E-09_JPRB, 0.16827868E-09_JPRB, 0.16820872E-09_JPRB, 0.16814579E-09_JPRB, 0.16809552E-09_JPRB, &
  & 0.16807708E-09_JPRB, 0.16808181E-09_JPRB, 0.16809833E-09_JPRB, 0.16812075E-09_JPRB, 0.16814765E-09_JPRB, 0.16817850E-09_JPRB, &
  & 0.16821214E-09_JPRB, 0.16824403E-09_JPRB, 0.16826725E-09_JPRB, 0.16827618E-09_JPRB, 0.16826962E-09_JPRB, 0.16824900E-09_JPRB, &
  & 0.16821802E-09_JPRB, 0.16818032E-09_JPRB, 0.16813850E-09_JPRB, 0.16809530E-09_JPRB, 0.16805289E-09_JPRB, 0.16801681E-09_JPRB, &
  & 0.16799170E-09_JPRB, 0.16797992E-09_JPRB, 0.16797989E-09_JPRB, 0.16799004E-09_JPRB, 0.16800938E-09_JPRB, 0.16803405E-09_JPRB, &
  & 0.16805997E-09_JPRB, 0.16808248E-09_JPRB, 0.16809945E-09_JPRB, 0.16811144E-09_JPRB, 0.16811905E-09_JPRB, 0.16812388E-09_JPRB, &
  & 0.16812754E-09_JPRB, 0.16812970E-09_JPRB, 0.16813104E-09_JPRB, 0.16813134E-09_JPRB, 0.16813104E-09_JPRB, 0.16813048E-09_JPRB, &
  & 0.16812968E-09_JPRB, 0.16812873E-09_JPRB, 0.16812816E-09_JPRB, 0.16813130E-09_JPRB /)

RGHG8(:,55, 7) = (/ &
  & 0.16846929E-09_JPRB, 0.16853061E-09_JPRB, 0.16856871E-09_JPRB, 0.16860849E-09_JPRB, 0.16865030E-09_JPRB, 0.16868594E-09_JPRB, &
  & 0.16870735E-09_JPRB, 0.16871667E-09_JPRB, 0.16872090E-09_JPRB, 0.16872174E-09_JPRB, 0.16871973E-09_JPRB, 0.16871315E-09_JPRB, &
  & 0.16869854E-09_JPRB, 0.16867105E-09_JPRB, 0.16863340E-09_JPRB, 0.16858931E-09_JPRB, 0.16854326E-09_JPRB, 0.16849956E-09_JPRB, &
  & 0.16845000E-09_JPRB, 0.16840476E-09_JPRB, 0.16833918E-09_JPRB, 0.16827410E-09_JPRB, 0.16819136E-09_JPRB, 0.16812760E-09_JPRB, &
  & 0.16809827E-09_JPRB, 0.16809779E-09_JPRB, 0.16811208E-09_JPRB, 0.16813383E-09_JPRB, 0.16816054E-09_JPRB, 0.16819213E-09_JPRB, &
  & 0.16822718E-09_JPRB, 0.16826107E-09_JPRB, 0.16828644E-09_JPRB, 0.16829708E-09_JPRB, 0.16829155E-09_JPRB, 0.16827145E-09_JPRB, &
  & 0.16824027E-09_JPRB, 0.16820190E-09_JPRB, 0.16815908E-09_JPRB, 0.16811470E-09_JPRB, 0.16807170E-09_JPRB, 0.16803528E-09_JPRB, &
  & 0.16801102E-09_JPRB, 0.16800017E-09_JPRB, 0.16800139E-09_JPRB, 0.16801335E-09_JPRB, 0.16803492E-09_JPRB, 0.16806294E-09_JPRB, &
  & 0.16809135E-09_JPRB, 0.16811624E-09_JPRB, 0.16813551E-09_JPRB, 0.16814808E-09_JPRB, 0.16815641E-09_JPRB, 0.16816236E-09_JPRB, &
  & 0.16816626E-09_JPRB, 0.16816963E-09_JPRB, 0.16817180E-09_JPRB, 0.16817338E-09_JPRB, 0.16817453E-09_JPRB, 0.16817539E-09_JPRB, &
  & 0.16817610E-09_JPRB, 0.16817642E-09_JPRB, 0.16817632E-09_JPRB, 0.16817532E-09_JPRB /)

RGHG8(:,56, 7) = (/ &
  & 0.16863713E-09_JPRB, 0.16867407E-09_JPRB, 0.16869889E-09_JPRB, 0.16872298E-09_JPRB, 0.16874965E-09_JPRB, 0.16877108E-09_JPRB, &
  & 0.16878306E-09_JPRB, 0.16878837E-09_JPRB, 0.16878965E-09_JPRB, 0.16878872E-09_JPRB, 0.16878544E-09_JPRB, 0.16877821E-09_JPRB, &
  & 0.16876300E-09_JPRB, 0.16873739E-09_JPRB, 0.16870072E-09_JPRB, 0.16865820E-09_JPRB, 0.16861332E-09_JPRB, 0.16856568E-09_JPRB, &
  & 0.16852066E-09_JPRB, 0.16846285E-09_JPRB, 0.16840566E-09_JPRB, 0.16832233E-09_JPRB, 0.16823604E-09_JPRB, 0.16815889E-09_JPRB, &
  & 0.16812073E-09_JPRB, 0.16811549E-09_JPRB, 0.16812760E-09_JPRB, 0.16814840E-09_JPRB, 0.16817525E-09_JPRB, 0.16820742E-09_JPRB, &
  & 0.16824403E-09_JPRB, 0.16827999E-09_JPRB, 0.16830735E-09_JPRB, 0.16831964E-09_JPRB, 0.16831517E-09_JPRB, 0.16829563E-09_JPRB, &
  & 0.16826418E-09_JPRB, 0.16822510E-09_JPRB, 0.16818108E-09_JPRB, 0.16813537E-09_JPRB, 0.16809142E-09_JPRB, 0.16805543E-09_JPRB, &
  & 0.16803170E-09_JPRB, 0.16802175E-09_JPRB, 0.16802384E-09_JPRB, 0.16803672E-09_JPRB, 0.16805975E-09_JPRB, 0.16808911E-09_JPRB, &
  & 0.16811989E-09_JPRB, 0.16814709E-09_JPRB, 0.16816716E-09_JPRB, 0.16818111E-09_JPRB, 0.16819007E-09_JPRB, 0.16819569E-09_JPRB, &
  & 0.16820019E-09_JPRB, 0.16820315E-09_JPRB, 0.16820545E-09_JPRB, 0.16820711E-09_JPRB, 0.16820845E-09_JPRB, 0.16820983E-09_JPRB, &
  & 0.16821095E-09_JPRB, 0.16821183E-09_JPRB, 0.16821231E-09_JPRB, 0.16821210E-09_JPRB /)

RGHG8(:,57, 7) = (/ &
  & 0.16875129E-09_JPRB, 0.16878150E-09_JPRB, 0.16879861E-09_JPRB, 0.16881510E-09_JPRB, 0.16883023E-09_JPRB, 0.16884286E-09_JPRB, &
  & 0.16884957E-09_JPRB, 0.16885164E-09_JPRB, 0.16885135E-09_JPRB, 0.16884949E-09_JPRB, 0.16884567E-09_JPRB, 0.16883822E-09_JPRB, &
  & 0.16882448E-09_JPRB, 0.16880017E-09_JPRB, 0.16876667E-09_JPRB, 0.16872573E-09_JPRB, 0.16868044E-09_JPRB, 0.16863377E-09_JPRB, &
  & 0.16858034E-09_JPRB, 0.16852685E-09_JPRB, 0.16845320E-09_JPRB, 0.16837225E-09_JPRB, 0.16827288E-09_JPRB, 0.16818903E-09_JPRB, &
  & 0.16814482E-09_JPRB, 0.16813551E-09_JPRB, 0.16814553E-09_JPRB, 0.16816558E-09_JPRB, 0.16819234E-09_JPRB, 0.16822539E-09_JPRB, &
  & 0.16826343E-09_JPRB, 0.16830144E-09_JPRB, 0.16833072E-09_JPRB, 0.16834448E-09_JPRB, 0.16834101E-09_JPRB, 0.16832184E-09_JPRB, &
  & 0.16829059E-09_JPRB, 0.16825037E-09_JPRB, 0.16820510E-09_JPRB, 0.16815793E-09_JPRB, 0.16811336E-09_JPRB, 0.16807739E-09_JPRB, &
  & 0.16805449E-09_JPRB, 0.16804529E-09_JPRB, 0.16804796E-09_JPRB, 0.16806129E-09_JPRB, 0.16808474E-09_JPRB, 0.16811494E-09_JPRB, &
  & 0.16814670E-09_JPRB, 0.16817531E-09_JPRB, 0.16819776E-09_JPRB, 0.16821246E-09_JPRB, 0.16822163E-09_JPRB, 0.16822795E-09_JPRB, &
  & 0.16823173E-09_JPRB, 0.16823457E-09_JPRB, 0.16823615E-09_JPRB, 0.16823729E-09_JPRB, 0.16823837E-09_JPRB, 0.16823948E-09_JPRB, &
  & 0.16824053E-09_JPRB, 0.16824123E-09_JPRB, 0.16824132E-09_JPRB, 0.16823973E-09_JPRB /)

RGHG8(:,58, 7) = (/ &
  & 0.16885000E-09_JPRB, 0.16886936E-09_JPRB, 0.16888077E-09_JPRB, 0.16889044E-09_JPRB, 0.16889991E-09_JPRB, 0.16890672E-09_JPRB, &
  & 0.16891000E-09_JPRB, 0.16891047E-09_JPRB, 0.16890939E-09_JPRB, 0.16890717E-09_JPRB, 0.16890335E-09_JPRB, 0.16889670E-09_JPRB, &
  & 0.16888399E-09_JPRB, 0.16886297E-09_JPRB, 0.16883200E-09_JPRB, 0.16879352E-09_JPRB, 0.16874871E-09_JPRB, 0.16869792E-09_JPRB, &
  & 0.16864432E-09_JPRB, 0.16857769E-09_JPRB, 0.16850524E-09_JPRB, 0.16840954E-09_JPRB, 0.16830656E-09_JPRB, 0.16821880E-09_JPRB, &
  & 0.16817100E-09_JPRB, 0.16815856E-09_JPRB, 0.16816670E-09_JPRB, 0.16818602E-09_JPRB, 0.16821290E-09_JPRB, 0.16824672E-09_JPRB, &
  & 0.16828633E-09_JPRB, 0.16832628E-09_JPRB, 0.16835737E-09_JPRB, 0.16837236E-09_JPRB, 0.16836962E-09_JPRB, 0.16835111E-09_JPRB, &
  & 0.16831957E-09_JPRB, 0.16827874E-09_JPRB, 0.16823194E-09_JPRB, 0.16818336E-09_JPRB, 0.16813809E-09_JPRB, 0.16810248E-09_JPRB, &
  & 0.16808022E-09_JPRB, 0.16807147E-09_JPRB, 0.16807442E-09_JPRB, 0.16808802E-09_JPRB, 0.16811150E-09_JPRB, 0.16814157E-09_JPRB, &
  & 0.16817370E-09_JPRB, 0.16820349E-09_JPRB, 0.16822713E-09_JPRB, 0.16824342E-09_JPRB, 0.16825377E-09_JPRB, 0.16825955E-09_JPRB, &
  & 0.16826338E-09_JPRB, 0.16826521E-09_JPRB, 0.16826586E-09_JPRB, 0.16826623E-09_JPRB, 0.16826678E-09_JPRB, 0.16826766E-09_JPRB, &
  & 0.16826847E-09_JPRB, 0.16826894E-09_JPRB, 0.16826866E-09_JPRB, 0.16826643E-09_JPRB /)

RGHG8(:,59, 7) = (/ &
  & 0.16892371E-09_JPRB, 0.16894083E-09_JPRB, 0.16894947E-09_JPRB, 0.16895632E-09_JPRB, 0.16896182E-09_JPRB, 0.16896580E-09_JPRB, &
  & 0.16896731E-09_JPRB, 0.16896703E-09_JPRB, 0.16896576E-09_JPRB, 0.16896362E-09_JPRB, 0.16896029E-09_JPRB, 0.16895431E-09_JPRB, &
  & 0.16894378E-09_JPRB, 0.16892511E-09_JPRB, 0.16889773E-09_JPRB, 0.16886116E-09_JPRB, 0.16881636E-09_JPRB, 0.16876378E-09_JPRB, &
  & 0.16870164E-09_JPRB, 0.16863280E-09_JPRB, 0.16854557E-09_JPRB, 0.16844609E-09_JPRB, 0.16833807E-09_JPRB, 0.16824928E-09_JPRB, &
  & 0.16820002E-09_JPRB, 0.16818538E-09_JPRB, 0.16819204E-09_JPRB, 0.16821076E-09_JPRB, 0.16823788E-09_JPRB, 0.16827256E-09_JPRB, &
  & 0.16831365E-09_JPRB, 0.16835541E-09_JPRB, 0.16838811E-09_JPRB, 0.16840404E-09_JPRB, 0.16840188E-09_JPRB, 0.16838358E-09_JPRB, &
  & 0.16835221E-09_JPRB, 0.16831042E-09_JPRB, 0.16826252E-09_JPRB, 0.16821251E-09_JPRB, 0.16816674E-09_JPRB, 0.16813143E-09_JPRB, &
  & 0.16810951E-09_JPRB, 0.16810110E-09_JPRB, 0.16810413E-09_JPRB, 0.16811755E-09_JPRB, 0.16814092E-09_JPRB, 0.16817073E-09_JPRB, &
  & 0.16820254E-09_JPRB, 0.16823255E-09_JPRB, 0.16825738E-09_JPRB, 0.16827542E-09_JPRB, 0.16828632E-09_JPRB, 0.16829282E-09_JPRB, &
  & 0.16829574E-09_JPRB, 0.16829652E-09_JPRB, 0.16829571E-09_JPRB, 0.16829496E-09_JPRB, 0.16829486E-09_JPRB, 0.16829543E-09_JPRB, &
  & 0.16829604E-09_JPRB, 0.16829618E-09_JPRB, 0.16829534E-09_JPRB, 0.16829153E-09_JPRB /)

RGHG8(:,60, 7) = (/ &
  & 0.16899122E-09_JPRB, 0.16900475E-09_JPRB, 0.16901119E-09_JPRB, 0.16901586E-09_JPRB, 0.16901962E-09_JPRB, 0.16902200E-09_JPRB, &
  & 0.16902281E-09_JPRB, 0.16902243E-09_JPRB, 0.16902131E-09_JPRB, 0.16901959E-09_JPRB, 0.16901679E-09_JPRB, 0.16901211E-09_JPRB, &
  & 0.16900309E-09_JPRB, 0.16898744E-09_JPRB, 0.16896268E-09_JPRB, 0.16892847E-09_JPRB, 0.16888344E-09_JPRB, 0.16882730E-09_JPRB, &
  & 0.16876078E-09_JPRB, 0.16868021E-09_JPRB, 0.16858817E-09_JPRB, 0.16848040E-09_JPRB, 0.16837072E-09_JPRB, 0.16828292E-09_JPRB, &
  & 0.16823284E-09_JPRB, 0.16821661E-09_JPRB, 0.16822213E-09_JPRB, 0.16824064E-09_JPRB, 0.16826812E-09_JPRB, 0.16830390E-09_JPRB, &
  & 0.16834639E-09_JPRB, 0.16838986E-09_JPRB, 0.16842377E-09_JPRB, 0.16844025E-09_JPRB, 0.16843826E-09_JPRB, 0.16842024E-09_JPRB, &
  & 0.16838864E-09_JPRB, 0.16834656E-09_JPRB, 0.16829740E-09_JPRB, 0.16824650E-09_JPRB, 0.16820020E-09_JPRB, 0.16816498E-09_JPRB, &
  & 0.16814361E-09_JPRB, 0.16813506E-09_JPRB, 0.16813781E-09_JPRB, 0.16815106E-09_JPRB, 0.16817382E-09_JPRB, 0.16820315E-09_JPRB, &
  & 0.16823455E-09_JPRB, 0.16826440E-09_JPRB, 0.16828976E-09_JPRB, 0.16830871E-09_JPRB, 0.16832138E-09_JPRB, 0.16832777E-09_JPRB, &
  & 0.16833039E-09_JPRB, 0.16832960E-09_JPRB, 0.16832673E-09_JPRB, 0.16832451E-09_JPRB, 0.16832379E-09_JPRB, 0.16832422E-09_JPRB, &
  & 0.16832473E-09_JPRB, 0.16832459E-09_JPRB, 0.16832288E-09_JPRB, 0.16831703E-09_JPRB /)

RGHG8(:,61, 7) = (/ &
  & 0.16905036E-09_JPRB, 0.16906247E-09_JPRB, 0.16906811E-09_JPRB, 0.16907195E-09_JPRB, 0.16907481E-09_JPRB, 0.16907672E-09_JPRB, &
  & 0.16907743E-09_JPRB, 0.16907728E-09_JPRB, 0.16907657E-09_JPRB, 0.16907531E-09_JPRB, 0.16907330E-09_JPRB, 0.16906948E-09_JPRB, &
  & 0.16906236E-09_JPRB, 0.16904876E-09_JPRB, 0.16902665E-09_JPRB, 0.16899376E-09_JPRB, 0.16894876E-09_JPRB, 0.16888933E-09_JPRB, &
  & 0.16881628E-09_JPRB, 0.16873035E-09_JPRB, 0.16862953E-09_JPRB, 0.16851801E-09_JPRB, 0.16840834E-09_JPRB, 0.16832095E-09_JPRB, &
  & 0.16827043E-09_JPRB, 0.16825304E-09_JPRB, 0.16825789E-09_JPRB, 0.16827648E-09_JPRB, 0.16830481E-09_JPRB, 0.16834156E-09_JPRB, &
  & 0.16838569E-09_JPRB, 0.16843049E-09_JPRB, 0.16846533E-09_JPRB, 0.16848190E-09_JPRB, 0.16847973E-09_JPRB, 0.16846158E-09_JPRB, &
  & 0.16843019E-09_JPRB, 0.16838751E-09_JPRB, 0.16833790E-09_JPRB, 0.16828608E-09_JPRB, 0.16823939E-09_JPRB, 0.16820451E-09_JPRB, &
  & 0.16818297E-09_JPRB, 0.16817443E-09_JPRB, 0.16817674E-09_JPRB, 0.16818913E-09_JPRB, 0.16821126E-09_JPRB, 0.16823976E-09_JPRB, &
  & 0.16827068E-09_JPRB, 0.16830021E-09_JPRB, 0.16832563E-09_JPRB, 0.16834542E-09_JPRB, 0.16835879E-09_JPRB, 0.16836603E-09_JPRB, &
  & 0.16836814E-09_JPRB, 0.16836556E-09_JPRB, 0.16836001E-09_JPRB, 0.16835594E-09_JPRB, 0.16835450E-09_JPRB, 0.16835507E-09_JPRB, &
  & 0.16835572E-09_JPRB, 0.16835519E-09_JPRB, 0.16835222E-09_JPRB, 0.16834224E-09_JPRB /)

RGHG8(:,62, 7) = (/ &
  & 0.16910670E-09_JPRB, 0.16911755E-09_JPRB, 0.16912245E-09_JPRB, 0.16912591E-09_JPRB, 0.16912857E-09_JPRB, 0.16913045E-09_JPRB, &
  & 0.16913147E-09_JPRB, 0.16913181E-09_JPRB, 0.16913163E-09_JPRB, 0.16913101E-09_JPRB, 0.16912965E-09_JPRB, 0.16912692E-09_JPRB, &
  & 0.16912097E-09_JPRB, 0.16910941E-09_JPRB, 0.16908902E-09_JPRB, 0.16905746E-09_JPRB, 0.16901144E-09_JPRB, 0.16894988E-09_JPRB, &
  & 0.16887214E-09_JPRB, 0.16878021E-09_JPRB, 0.16867521E-09_JPRB, 0.16856147E-09_JPRB, 0.16845117E-09_JPRB, 0.16836479E-09_JPRB, &
  & 0.16831370E-09_JPRB, 0.16829554E-09_JPRB, 0.16830023E-09_JPRB, 0.16831941E-09_JPRB, 0.16834875E-09_JPRB, 0.16838707E-09_JPRB, &
  & 0.16843262E-09_JPRB, 0.16847872E-09_JPRB, 0.16851390E-09_JPRB, 0.16853001E-09_JPRB, 0.16852723E-09_JPRB, 0.16850892E-09_JPRB, &
  & 0.16847745E-09_JPRB, 0.16843488E-09_JPRB, 0.16838463E-09_JPRB, 0.16833250E-09_JPRB, 0.16828548E-09_JPRB, 0.16825047E-09_JPRB, &
  & 0.16822925E-09_JPRB, 0.16822013E-09_JPRB, 0.16822169E-09_JPRB, 0.16823315E-09_JPRB, 0.16825405E-09_JPRB, 0.16828150E-09_JPRB, &
  & 0.16831167E-09_JPRB, 0.16834077E-09_JPRB, 0.16836625E-09_JPRB, 0.16838633E-09_JPRB, 0.16840059E-09_JPRB, 0.16840795E-09_JPRB, &
  & 0.16840994E-09_JPRB, 0.16840569E-09_JPRB, 0.16839695E-09_JPRB, 0.16839052E-09_JPRB, 0.16838832E-09_JPRB, 0.16838941E-09_JPRB, &
  & 0.16839050E-09_JPRB, 0.16838958E-09_JPRB, 0.16838442E-09_JPRB, 0.16836837E-09_JPRB /)

RGHG8(:,63, 7) = (/ &
  & 0.16915808E-09_JPRB, 0.16916929E-09_JPRB, 0.16917459E-09_JPRB, 0.16917828E-09_JPRB, 0.16918114E-09_JPRB, 0.16918339E-09_JPRB, &
  & 0.16918487E-09_JPRB, 0.16918586E-09_JPRB, 0.16918636E-09_JPRB, 0.16918644E-09_JPRB, 0.16918592E-09_JPRB, 0.16918414E-09_JPRB, &
  & 0.16917960E-09_JPRB, 0.16916932E-09_JPRB, 0.16915032E-09_JPRB, 0.16911902E-09_JPRB, 0.16907280E-09_JPRB, 0.16900870E-09_JPRB, &
  & 0.16892868E-09_JPRB, 0.16883349E-09_JPRB, 0.16872570E-09_JPRB, 0.16861011E-09_JPRB, 0.16850084E-09_JPRB, 0.16841478E-09_JPRB, &
  & 0.16836377E-09_JPRB, 0.16834537E-09_JPRB, 0.16835042E-09_JPRB, 0.16837057E-09_JPRB, 0.16840150E-09_JPRB, 0.16844143E-09_JPRB, &
  & 0.16848867E-09_JPRB, 0.16853546E-09_JPRB, 0.16857060E-09_JPRB, 0.16858578E-09_JPRB, 0.16858193E-09_JPRB, 0.16856327E-09_JPRB, &
  & 0.16853186E-09_JPRB, 0.16848931E-09_JPRB, 0.16843907E-09_JPRB, 0.16838658E-09_JPRB, 0.16833943E-09_JPRB, 0.16830455E-09_JPRB, &
  & 0.16828292E-09_JPRB, 0.16827334E-09_JPRB, 0.16827391E-09_JPRB, 0.16828401E-09_JPRB, 0.16830345E-09_JPRB, 0.16832949E-09_JPRB, &
  & 0.16835867E-09_JPRB, 0.16838717E-09_JPRB, 0.16841253E-09_JPRB, 0.16843286E-09_JPRB, 0.16844755E-09_JPRB, 0.16845503E-09_JPRB, &
  & 0.16845671E-09_JPRB, 0.16845086E-09_JPRB, 0.16843911E-09_JPRB, 0.16843010E-09_JPRB, 0.16842693E-09_JPRB, 0.16842866E-09_JPRB, &
  & 0.16843037E-09_JPRB, 0.16842913E-09_JPRB, 0.16842167E-09_JPRB, 0.16839745E-09_JPRB /)

RGHG8(:,64, 7) = (/ &
  & 0.16920720E-09_JPRB, 0.16921925E-09_JPRB, 0.16922502E-09_JPRB, 0.16922923E-09_JPRB, 0.16923264E-09_JPRB, 0.16923540E-09_JPRB, &
  & 0.16923760E-09_JPRB, 0.16923932E-09_JPRB, 0.16924065E-09_JPRB, 0.16924158E-09_JPRB, 0.16924200E-09_JPRB, 0.16924127E-09_JPRB, &
  & 0.16923773E-09_JPRB, 0.16922862E-09_JPRB, 0.16921030E-09_JPRB, 0.16917942E-09_JPRB, 0.16913240E-09_JPRB, 0.16906801E-09_JPRB, &
  & 0.16898613E-09_JPRB, 0.16888937E-09_JPRB, 0.16878013E-09_JPRB, 0.16866478E-09_JPRB, 0.16855625E-09_JPRB, 0.16847167E-09_JPRB, &
  & 0.16842122E-09_JPRB, 0.16840322E-09_JPRB, 0.16840906E-09_JPRB, 0.16843062E-09_JPRB, 0.16846323E-09_JPRB, 0.16850500E-09_JPRB, &
  & 0.16855344E-09_JPRB, 0.16860065E-09_JPRB, 0.16863487E-09_JPRB, 0.16864865E-09_JPRB, 0.16864360E-09_JPRB, 0.16862436E-09_JPRB, &
  & 0.16859311E-09_JPRB, 0.16855103E-09_JPRB, 0.16850100E-09_JPRB, 0.16844869E-09_JPRB, 0.16840161E-09_JPRB, 0.16836672E-09_JPRB, &
  & 0.16834505E-09_JPRB, 0.16833455E-09_JPRB, 0.16833392E-09_JPRB, 0.16834246E-09_JPRB, 0.16836001E-09_JPRB, 0.16838439E-09_JPRB, &
  & 0.16841226E-09_JPRB, 0.16843996E-09_JPRB, 0.16846505E-09_JPRB, 0.16848550E-09_JPRB, 0.16850046E-09_JPRB, 0.16850796E-09_JPRB, &
  & 0.16850914E-09_JPRB, 0.16850187E-09_JPRB, 0.16848742E-09_JPRB, 0.16847594E-09_JPRB, 0.16847163E-09_JPRB, 0.16847378E-09_JPRB, &
  & 0.16847604E-09_JPRB, 0.16847464E-09_JPRB, 0.16846466E-09_JPRB, 0.16843220E-09_JPRB /)

RGHG8(:,65, 7) = (/ &
  & 0.16925386E-09_JPRB, 0.16926721E-09_JPRB, 0.16927386E-09_JPRB, 0.16927879E-09_JPRB, 0.16928284E-09_JPRB, 0.16928633E-09_JPRB, &
  & 0.16928914E-09_JPRB, 0.16929178E-09_JPRB, 0.16929400E-09_JPRB, 0.16929605E-09_JPRB, 0.16929758E-09_JPRB, 0.16929808E-09_JPRB, &
  & 0.16929552E-09_JPRB, 0.16928701E-09_JPRB, 0.16926922E-09_JPRB, 0.16923837E-09_JPRB, 0.16919170E-09_JPRB, 0.16912696E-09_JPRB, &
  & 0.16904531E-09_JPRB, 0.16894822E-09_JPRB, 0.16883894E-09_JPRB, 0.16872444E-09_JPRB, 0.16861815E-09_JPRB, 0.16853567E-09_JPRB, &
  & 0.16848653E-09_JPRB, 0.16846950E-09_JPRB, 0.16847646E-09_JPRB, 0.16849938E-09_JPRB, 0.16853351E-09_JPRB, 0.16857660E-09_JPRB, &
  & 0.16862574E-09_JPRB, 0.16867240E-09_JPRB, 0.16870516E-09_JPRB, 0.16871711E-09_JPRB, 0.16871067E-09_JPRB, 0.16869113E-09_JPRB, &
  & 0.16866020E-09_JPRB, 0.16861895E-09_JPRB, 0.16856985E-09_JPRB, 0.16851816E-09_JPRB, 0.16847167E-09_JPRB, 0.16843722E-09_JPRB, &
  & 0.16841536E-09_JPRB, 0.16840415E-09_JPRB, 0.16840214E-09_JPRB, 0.16840888E-09_JPRB, 0.16842433E-09_JPRB, 0.16844677E-09_JPRB, &
  & 0.16847311E-09_JPRB, 0.16849985E-09_JPRB, 0.16852451E-09_JPRB, 0.16854493E-09_JPRB, 0.16856007E-09_JPRB, 0.16856748E-09_JPRB, &
  & 0.16856812E-09_JPRB, 0.16855946E-09_JPRB, 0.16854269E-09_JPRB, 0.16852893E-09_JPRB, 0.16852345E-09_JPRB, 0.16852569E-09_JPRB, &
  & 0.16852830E-09_JPRB, 0.16852678E-09_JPRB, 0.16851479E-09_JPRB, 0.16847501E-09_JPRB /)

RGHG8(:,66, 7) = (/ &
  & 0.16929765E-09_JPRB, 0.16931329E-09_JPRB, 0.16932108E-09_JPRB, 0.16932708E-09_JPRB, 0.16933208E-09_JPRB, 0.16933629E-09_JPRB, &
  & 0.16933996E-09_JPRB, 0.16934332E-09_JPRB, 0.16934673E-09_JPRB, 0.16934983E-09_JPRB, 0.16935268E-09_JPRB, 0.16935431E-09_JPRB, &
  & 0.16935246E-09_JPRB, 0.16934439E-09_JPRB, 0.16932689E-09_JPRB, 0.16929655E-09_JPRB, 0.16925034E-09_JPRB, 0.16918671E-09_JPRB, &
  & 0.16910563E-09_JPRB, 0.16900925E-09_JPRB, 0.16890153E-09_JPRB, 0.16878962E-09_JPRB, 0.16868665E-09_JPRB, 0.16860704E-09_JPRB, &
  & 0.16855990E-09_JPRB, 0.16854410E-09_JPRB, 0.16855208E-09_JPRB, 0.16857603E-09_JPRB, 0.16861093E-09_JPRB, 0.16865452E-09_JPRB, &
  & 0.16870336E-09_JPRB, 0.16874863E-09_JPRB, 0.16877925E-09_JPRB, 0.16878920E-09_JPRB, 0.16878150E-09_JPRB, 0.16876173E-09_JPRB, &
  & 0.16873158E-09_JPRB, 0.16869164E-09_JPRB, 0.16864407E-09_JPRB, 0.16859397E-09_JPRB, 0.16854865E-09_JPRB, 0.16851524E-09_JPRB, &
  & 0.16849365E-09_JPRB, 0.16848181E-09_JPRB, 0.16847841E-09_JPRB, 0.16848339E-09_JPRB, 0.16849661E-09_JPRB, 0.16851706E-09_JPRB, &
  & 0.16854174E-09_JPRB, 0.16856737E-09_JPRB, 0.16859134E-09_JPRB, 0.16861164E-09_JPRB, 0.16862681E-09_JPRB, 0.16863411E-09_JPRB, &
  & 0.16863433E-09_JPRB, 0.16862435E-09_JPRB, 0.16860559E-09_JPRB, 0.16858975E-09_JPRB, 0.16858305E-09_JPRB, 0.16858524E-09_JPRB, &
  & 0.16858814E-09_JPRB, 0.16858671E-09_JPRB, 0.16857324E-09_JPRB, 0.16852800E-09_JPRB /)

RGHG8(:,67, 7) = (/ &
  & 0.16933890E-09_JPRB, 0.16935747E-09_JPRB, 0.16936713E-09_JPRB, 0.16937440E-09_JPRB, 0.16938062E-09_JPRB, 0.16938584E-09_JPRB, &
  & 0.16939017E-09_JPRB, 0.16939457E-09_JPRB, 0.16939875E-09_JPRB, 0.16940327E-09_JPRB, 0.16940703E-09_JPRB, 0.16940956E-09_JPRB, &
  & 0.16940807E-09_JPRB, 0.16940027E-09_JPRB, 0.16938326E-09_JPRB, 0.16935366E-09_JPRB, 0.16930875E-09_JPRB, 0.16924660E-09_JPRB, &
  & 0.16916749E-09_JPRB, 0.16907344E-09_JPRB, 0.16896852E-09_JPRB, 0.16886036E-09_JPRB, 0.16876150E-09_JPRB, 0.16868565E-09_JPRB, &
  & 0.16864081E-09_JPRB, 0.16862628E-09_JPRB, 0.16863497E-09_JPRB, 0.16865927E-09_JPRB, 0.16869406E-09_JPRB, 0.16873702E-09_JPRB, &
  & 0.16878456E-09_JPRB, 0.16882777E-09_JPRB, 0.16885593E-09_JPRB, 0.16886385E-09_JPRB, 0.16885500E-09_JPRB, 0.16883538E-09_JPRB, &
  & 0.16880630E-09_JPRB, 0.16876822E-09_JPRB, 0.16872287E-09_JPRB, 0.16867487E-09_JPRB, 0.16863175E-09_JPRB, 0.16859969E-09_JPRB, &
  & 0.16857907E-09_JPRB, 0.16856694E-09_JPRB, 0.16856246E-09_JPRB, 0.16856573E-09_JPRB, 0.16857696E-09_JPRB, 0.16859540E-09_JPRB, &
  & 0.16861854E-09_JPRB, 0.16864299E-09_JPRB, 0.16866619E-09_JPRB, 0.16868620E-09_JPRB, 0.16870125E-09_JPRB, 0.16870848E-09_JPRB, &
  & 0.16870817E-09_JPRB, 0.16869710E-09_JPRB, 0.16867668E-09_JPRB, 0.16865910E-09_JPRB, 0.16865137E-09_JPRB, 0.16865341E-09_JPRB, &
  & 0.16865653E-09_JPRB, 0.16865530E-09_JPRB, 0.16864057E-09_JPRB, 0.16858945E-09_JPRB /)

RGHG8(:,68, 7) = (/ &
  & 0.16937542E-09_JPRB, 0.16939969E-09_JPRB, 0.16941173E-09_JPRB, 0.16942110E-09_JPRB, 0.16942876E-09_JPRB, 0.16943517E-09_JPRB, &
  & 0.16944041E-09_JPRB, 0.16944557E-09_JPRB, 0.16945094E-09_JPRB, 0.16945605E-09_JPRB, 0.16946068E-09_JPRB, 0.16946350E-09_JPRB, &
  & 0.16946211E-09_JPRB, 0.16945466E-09_JPRB, 0.16943831E-09_JPRB, 0.16940985E-09_JPRB, 0.16936669E-09_JPRB, 0.16930686E-09_JPRB, &
  & 0.16923053E-09_JPRB, 0.16913981E-09_JPRB, 0.16903931E-09_JPRB, 0.16893625E-09_JPRB, 0.16884266E-09_JPRB, 0.16877083E-09_JPRB, &
  & 0.16872849E-09_JPRB, 0.16871507E-09_JPRB, 0.16872395E-09_JPRB, 0.16874784E-09_JPRB, 0.16878168E-09_JPRB, 0.16882305E-09_JPRB, &
  & 0.16886846E-09_JPRB, 0.16890914E-09_JPRB, 0.16893476E-09_JPRB, 0.16894081E-09_JPRB, 0.16893113E-09_JPRB, 0.16891179E-09_JPRB, &
  & 0.16888413E-09_JPRB, 0.16884825E-09_JPRB, 0.16880546E-09_JPRB, 0.16876035E-09_JPRB, 0.16871964E-09_JPRB, 0.16868994E-09_JPRB, &
  & 0.16867062E-09_JPRB, 0.16865882E-09_JPRB, 0.16865354E-09_JPRB, 0.16865551E-09_JPRB, 0.16866496E-09_JPRB, 0.16868180E-09_JPRB, &
  & 0.16870344E-09_JPRB, 0.16872677E-09_JPRB, 0.16874911E-09_JPRB, 0.16876875E-09_JPRB, 0.16878356E-09_JPRB, 0.16879069E-09_JPRB, &
  & 0.16878997E-09_JPRB, 0.16877807E-09_JPRB, 0.16875654E-09_JPRB, 0.16873763E-09_JPRB, 0.16872899E-09_JPRB, 0.16873095E-09_JPRB, &
  & 0.16873443E-09_JPRB, 0.16873396E-09_JPRB, 0.16871929E-09_JPRB, 0.16866662E-09_JPRB /)

RGHG8(:,69, 7) = (/ &
  & 0.16940940E-09_JPRB, 0.16944057E-09_JPRB, 0.16945642E-09_JPRB, 0.16946783E-09_JPRB, 0.16947725E-09_JPRB, 0.16948479E-09_JPRB, &
  & 0.16949080E-09_JPRB, 0.16949689E-09_JPRB, 0.16950286E-09_JPRB, 0.16950863E-09_JPRB, 0.16951328E-09_JPRB, 0.16951619E-09_JPRB, &
  & 0.16951485E-09_JPRB, 0.16950777E-09_JPRB, 0.16949227E-09_JPRB, 0.16946522E-09_JPRB, 0.16942422E-09_JPRB, 0.16936746E-09_JPRB, &
  & 0.16929515E-09_JPRB, 0.16920938E-09_JPRB, 0.16911438E-09_JPRB, 0.16901745E-09_JPRB, 0.16892954E-09_JPRB, 0.16886226E-09_JPRB, &
  & 0.16882234E-09_JPRB, 0.16880973E-09_JPRB, 0.16881833E-09_JPRB, 0.16884116E-09_JPRB, 0.16887329E-09_JPRB, 0.16891236E-09_JPRB, &
  & 0.16895500E-09_JPRB, 0.16899283E-09_JPRB, 0.16901591E-09_JPRB, 0.16902033E-09_JPRB, 0.16901006E-09_JPRB, 0.16899129E-09_JPRB, &
  & 0.16896530E-09_JPRB, 0.16893190E-09_JPRB, 0.16889216E-09_JPRB, 0.16885009E-09_JPRB, 0.16881255E-09_JPRB, 0.16878532E-09_JPRB, &
  & 0.16876801E-09_JPRB, 0.16875695E-09_JPRB, 0.16875143E-09_JPRB, 0.16875247E-09_JPRB, 0.16876046E-09_JPRB, 0.16877597E-09_JPRB, &
  & 0.16879641E-09_JPRB, 0.16881868E-09_JPRB, 0.16884023E-09_JPRB, 0.16885940E-09_JPRB, 0.16887393E-09_JPRB, 0.16888102E-09_JPRB, &
  & 0.16888001E-09_JPRB, 0.16886768E-09_JPRB, 0.16884562E-09_JPRB, 0.16882598E-09_JPRB, 0.16881684E-09_JPRB, 0.16881890E-09_JPRB, &
  & 0.16882280E-09_JPRB, 0.16882319E-09_JPRB, 0.16880905E-09_JPRB, 0.16875379E-09_JPRB /)

RGHG8(:,70, 7) = (/ &
  & 0.16944110E-09_JPRB, 0.16948234E-09_JPRB, 0.16950158E-09_JPRB, 0.16951562E-09_JPRB, 0.16952646E-09_JPRB, 0.16953498E-09_JPRB, &
  & 0.16954166E-09_JPRB, 0.16954853E-09_JPRB, 0.16955484E-09_JPRB, 0.16956077E-09_JPRB, 0.16956518E-09_JPRB, 0.16956792E-09_JPRB, &
  & 0.16956651E-09_JPRB, 0.16955973E-09_JPRB, 0.16954521E-09_JPRB, 0.16951983E-09_JPRB, 0.16948162E-09_JPRB, 0.16942860E-09_JPRB, &
  & 0.16936112E-09_JPRB, 0.16928117E-09_JPRB, 0.16919306E-09_JPRB, 0.16910319E-09_JPRB, 0.16902185E-09_JPRB, 0.16895912E-09_JPRB, &
  & 0.16892165E-09_JPRB, 0.16890964E-09_JPRB, 0.16891753E-09_JPRB, 0.16893868E-09_JPRB, 0.16896853E-09_JPRB, 0.16900471E-09_JPRB, &
  & 0.16904420E-09_JPRB, 0.16907893E-09_JPRB, 0.16909948E-09_JPRB, 0.16910244E-09_JPRB, 0.16909185E-09_JPRB, 0.16907387E-09_JPRB, &
  & 0.16904973E-09_JPRB, 0.16901910E-09_JPRB, 0.16898263E-09_JPRB, 0.16894401E-09_JPRB, 0.16890983E-09_JPRB, 0.16888554E-09_JPRB, &
  & 0.16887064E-09_JPRB, 0.16886074E-09_JPRB, 0.16885555E-09_JPRB, 0.16885604E-09_JPRB, 0.16886298E-09_JPRB, 0.16887736E-09_JPRB, &
  & 0.16889687E-09_JPRB, 0.16891807E-09_JPRB, 0.16893881E-09_JPRB, 0.16895747E-09_JPRB, 0.16897178E-09_JPRB, 0.16897889E-09_JPRB, &
  & 0.16897786E-09_JPRB, 0.16896573E-09_JPRB, 0.16894393E-09_JPRB, 0.16892451E-09_JPRB, 0.16891537E-09_JPRB, 0.16891757E-09_JPRB, &
  & 0.16892208E-09_JPRB, 0.16892346E-09_JPRB, 0.16891094E-09_JPRB, 0.16885777E-09_JPRB /)

RGHG8(:,71, 7) = (/ &
  & 0.16947441E-09_JPRB, 0.16952544E-09_JPRB, 0.16954917E-09_JPRB, 0.16956508E-09_JPRB, 0.16957689E-09_JPRB, 0.16958634E-09_JPRB, &
  & 0.16959344E-09_JPRB, 0.16960064E-09_JPRB, 0.16960733E-09_JPRB, 0.16961264E-09_JPRB, 0.16961690E-09_JPRB, 0.16961919E-09_JPRB, &
  & 0.16961763E-09_JPRB, 0.16961112E-09_JPRB, 0.16959759E-09_JPRB, 0.16957394E-09_JPRB, 0.16953892E-09_JPRB, 0.16949012E-09_JPRB, &
  & 0.16942850E-09_JPRB, 0.16935561E-09_JPRB, 0.16927497E-09_JPRB, 0.16919305E-09_JPRB, 0.16911848E-09_JPRB, 0.16906089E-09_JPRB, &
  & 0.16902596E-09_JPRB, 0.16901429E-09_JPRB, 0.16902098E-09_JPRB, 0.16904009E-09_JPRB, 0.16906712E-09_JPRB, 0.16909986E-09_JPRB, &
  & 0.16913587E-09_JPRB, 0.16916729E-09_JPRB, 0.16918533E-09_JPRB, 0.16918703E-09_JPRB, 0.16917640E-09_JPRB, 0.16915944E-09_JPRB, &
  & 0.16913734E-09_JPRB, 0.16910968E-09_JPRB, 0.16907679E-09_JPRB, 0.16904202E-09_JPRB, 0.16901139E-09_JPRB, 0.16899041E-09_JPRB, &
  & 0.16897787E-09_JPRB, 0.16896964E-09_JPRB, 0.16896498E-09_JPRB, 0.16896533E-09_JPRB, 0.16897149E-09_JPRB, 0.16898506E-09_JPRB, &
  & 0.16900359E-09_JPRB, 0.16902377E-09_JPRB, 0.16904361E-09_JPRB, 0.16906168E-09_JPRB, 0.16907580E-09_JPRB, 0.16908312E-09_JPRB, &
  & 0.16908241E-09_JPRB, 0.16907106E-09_JPRB, 0.16905058E-09_JPRB, 0.16903223E-09_JPRB, 0.16902371E-09_JPRB, 0.16902602E-09_JPRB, &
  & 0.16903076E-09_JPRB, 0.16903316E-09_JPRB, 0.16902317E-09_JPRB, 0.16897478E-09_JPRB /)

RGHG8(:,72, 7) = (/ &
  & 0.16950999E-09_JPRB, 0.16957290E-09_JPRB, 0.16959967E-09_JPRB, 0.16961677E-09_JPRB, 0.16962970E-09_JPRB, 0.16963904E-09_JPRB, &
  & 0.16964655E-09_JPRB, 0.16965408E-09_JPRB, 0.16965990E-09_JPRB, 0.16966548E-09_JPRB, 0.16966868E-09_JPRB, 0.16967062E-09_JPRB, &
  & 0.16966874E-09_JPRB, 0.16966231E-09_JPRB, 0.16964984E-09_JPRB, 0.16962812E-09_JPRB, 0.16959638E-09_JPRB, 0.16955226E-09_JPRB, &
  & 0.16949683E-09_JPRB, 0.16943126E-09_JPRB, 0.16935932E-09_JPRB, 0.16928567E-09_JPRB, 0.16921899E-09_JPRB, 0.16916681E-09_JPRB, &
  & 0.16913446E-09_JPRB, 0.16912308E-09_JPRB, 0.16912838E-09_JPRB, 0.16914495E-09_JPRB, 0.16916882E-09_JPRB, 0.16919770E-09_JPRB, &
  & 0.16922984E-09_JPRB, 0.16925773E-09_JPRB, 0.16927326E-09_JPRB, 0.16927386E-09_JPRB, 0.16926338E-09_JPRB, 0.16924766E-09_JPRB, &
  & 0.16922780E-09_JPRB, 0.16920328E-09_JPRB, 0.16917423E-09_JPRB, 0.16914338E-09_JPRB, 0.16911675E-09_JPRB, 0.16909886E-09_JPRB, &
  & 0.16908916E-09_JPRB, 0.16908246E-09_JPRB, 0.16907872E-09_JPRB, 0.16907910E-09_JPRB, 0.16908477E-09_JPRB, 0.16909765E-09_JPRB, &
  & 0.16911514E-09_JPRB, 0.16913410E-09_JPRB, 0.16915280E-09_JPRB, 0.16917012E-09_JPRB, 0.16918392E-09_JPRB, 0.16919159E-09_JPRB, &
  & 0.16919154E-09_JPRB, 0.16918150E-09_JPRB, 0.16916332E-09_JPRB, 0.16914704E-09_JPRB, 0.16913945E-09_JPRB, 0.16914152E-09_JPRB, &
  & 0.16914624E-09_JPRB, 0.16914886E-09_JPRB, 0.16914066E-09_JPRB, 0.16909640E-09_JPRB /)

RGHG8(:,73, 7) = (/ &
  & 0.16955951E-09_JPRB, 0.16962645E-09_JPRB, 0.16965371E-09_JPRB, 0.16967142E-09_JPRB, 0.16968363E-09_JPRB, 0.16969338E-09_JPRB, &
  & 0.16970080E-09_JPRB, 0.16970754E-09_JPRB, 0.16971385E-09_JPRB, 0.16971774E-09_JPRB, 0.16972118E-09_JPRB, 0.16972226E-09_JPRB, &
  & 0.16971984E-09_JPRB, 0.16971363E-09_JPRB, 0.16970203E-09_JPRB, 0.16968202E-09_JPRB, 0.16965415E-09_JPRB, 0.16961435E-09_JPRB, &
  & 0.16956572E-09_JPRB, 0.16950839E-09_JPRB, 0.16944487E-09_JPRB, 0.16938073E-09_JPRB, 0.16932189E-09_JPRB, 0.16927570E-09_JPRB, &
  & 0.16924633E-09_JPRB, 0.16923522E-09_JPRB, 0.16923887E-09_JPRB, 0.16925270E-09_JPRB, 0.16927307E-09_JPRB, 0.16929784E-09_JPRB, &
  & 0.16932583E-09_JPRB, 0.16934995E-09_JPRB, 0.16936294E-09_JPRB, 0.16936265E-09_JPRB, 0.16935263E-09_JPRB, 0.16933827E-09_JPRB, &
  & 0.16932084E-09_JPRB, 0.16929962E-09_JPRB, 0.16927462E-09_JPRB, 0.16924810E-09_JPRB, 0.16922529E-09_JPRB, 0.16921060E-09_JPRB, &
  & 0.16920321E-09_JPRB, 0.16919818E-09_JPRB, 0.16919539E-09_JPRB, 0.16919599E-09_JPRB, 0.16920129E-09_JPRB, 0.16921348E-09_JPRB, &
  & 0.16922985E-09_JPRB, 0.16924731E-09_JPRB, 0.16926477E-09_JPRB, 0.16928105E-09_JPRB, 0.16929436E-09_JPRB, 0.16930235E-09_JPRB, &
  & 0.16930300E-09_JPRB, 0.16929473E-09_JPRB, 0.16927916E-09_JPRB, 0.16926538E-09_JPRB, 0.16925897E-09_JPRB, 0.16926067E-09_JPRB, &
  & 0.16926477E-09_JPRB, 0.16926732E-09_JPRB, 0.16926029E-09_JPRB, 0.16921953E-09_JPRB /)

RGHG8(:,74, 7) = (/ &
  & 0.16961449E-09_JPRB, 0.16968309E-09_JPRB, 0.16971011E-09_JPRB, 0.16972627E-09_JPRB, 0.16973850E-09_JPRB, 0.16974738E-09_JPRB, &
  & 0.16975427E-09_JPRB, 0.16976121E-09_JPRB, 0.16976580E-09_JPRB, 0.16977025E-09_JPRB, 0.16977228E-09_JPRB, 0.16977296E-09_JPRB, &
  & 0.16977041E-09_JPRB, 0.16976394E-09_JPRB, 0.16975360E-09_JPRB, 0.16973545E-09_JPRB, 0.16971112E-09_JPRB, 0.16967666E-09_JPRB, &
  & 0.16963472E-09_JPRB, 0.16958540E-09_JPRB, 0.16953144E-09_JPRB, 0.16947642E-09_JPRB, 0.16942620E-09_JPRB, 0.16938623E-09_JPRB, &
  & 0.16936012E-09_JPRB, 0.16934962E-09_JPRB, 0.16935163E-09_JPRB, 0.16936265E-09_JPRB, 0.16937939E-09_JPRB, 0.16939991E-09_JPRB, &
  & 0.16942335E-09_JPRB, 0.16944365E-09_JPRB, 0.16945417E-09_JPRB, 0.16945315E-09_JPRB, 0.16944376E-09_JPRB, 0.16943108E-09_JPRB, &
  & 0.16941612E-09_JPRB, 0.16939833E-09_JPRB, 0.16937754E-09_JPRB, 0.16935536E-09_JPRB, 0.16933645E-09_JPRB, 0.16932469E-09_JPRB, &
  & 0.16931960E-09_JPRB, 0.16931606E-09_JPRB, 0.16931419E-09_JPRB, 0.16931510E-09_JPRB, 0.16932004E-09_JPRB, 0.16933152E-09_JPRB, &
  & 0.16934641E-09_JPRB, 0.16936225E-09_JPRB, 0.16937805E-09_JPRB, 0.16939307E-09_JPRB, 0.16940563E-09_JPRB, 0.16941366E-09_JPRB, &
  & 0.16941507E-09_JPRB, 0.16940845E-09_JPRB, 0.16939569E-09_JPRB, 0.16938426E-09_JPRB, 0.16937896E-09_JPRB, 0.16938037E-09_JPRB, &
  & 0.16938394E-09_JPRB, 0.16938619E-09_JPRB, 0.16937991E-09_JPRB, 0.16934090E-09_JPRB /)

RGHG8(:,75, 7) = (/ &
  & 0.16967316E-09_JPRB, 0.16974104E-09_JPRB, 0.16976548E-09_JPRB, 0.16978056E-09_JPRB, 0.16979121E-09_JPRB, 0.16979945E-09_JPRB, &
  & 0.16980578E-09_JPRB, 0.16981139E-09_JPRB, 0.16981644E-09_JPRB, 0.16981906E-09_JPRB, 0.16982135E-09_JPRB, 0.16982145E-09_JPRB, &
  & 0.16981828E-09_JPRB, 0.16981236E-09_JPRB, 0.16980328E-09_JPRB, 0.16978767E-09_JPRB, 0.16976712E-09_JPRB, 0.16973817E-09_JPRB, &
  & 0.16970329E-09_JPRB, 0.16966277E-09_JPRB, 0.16961788E-09_JPRB, 0.16957263E-09_JPRB, 0.16953083E-09_JPRB, 0.16949742E-09_JPRB, &
  & 0.16947500E-09_JPRB, 0.16946541E-09_JPRB, 0.16946608E-09_JPRB, 0.16947431E-09_JPRB, 0.16948748E-09_JPRB, 0.16950376E-09_JPRB, &
  & 0.16952258E-09_JPRB, 0.16953897E-09_JPRB, 0.16954713E-09_JPRB, 0.16954566E-09_JPRB, 0.16953718E-09_JPRB, 0.16952632E-09_JPRB, &
  & 0.16951388E-09_JPRB, 0.16949958E-09_JPRB, 0.16948309E-09_JPRB, 0.16946539E-09_JPRB, 0.16945040E-09_JPRB, 0.16944128E-09_JPRB, &
  & 0.16943817E-09_JPRB, 0.16943585E-09_JPRB, 0.16943484E-09_JPRB, 0.16943603E-09_JPRB, 0.16944059E-09_JPRB, 0.16945106E-09_JPRB, &
  & 0.16946437E-09_JPRB, 0.16947814E-09_JPRB, 0.16949217E-09_JPRB, 0.16950548E-09_JPRB, 0.16951682E-09_JPRB, 0.16952462E-09_JPRB, &
  & 0.16952656E-09_JPRB, 0.16952155E-09_JPRB, 0.16951113E-09_JPRB, 0.16950186E-09_JPRB, 0.16949767E-09_JPRB, 0.16949900E-09_JPRB, &
  & 0.16950227E-09_JPRB, 0.16950419E-09_JPRB, 0.16949779E-09_JPRB, 0.16946038E-09_JPRB /)

RGHG8(:,76, 7) = (/ &
  & 0.16973468E-09_JPRB, 0.16979802E-09_JPRB, 0.16981937E-09_JPRB, 0.16983179E-09_JPRB, 0.16984117E-09_JPRB, 0.16984801E-09_JPRB, &
  & 0.16985319E-09_JPRB, 0.16985865E-09_JPRB, 0.16986196E-09_JPRB, 0.16986468E-09_JPRB, 0.16986593E-09_JPRB, 0.16986573E-09_JPRB, &
  & 0.16986314E-09_JPRB, 0.16985764E-09_JPRB, 0.16985022E-09_JPRB, 0.16983780E-09_JPRB, 0.16982143E-09_JPRB, 0.16979841E-09_JPRB, &
  & 0.16977100E-09_JPRB, 0.16973918E-09_JPRB, 0.16970385E-09_JPRB, 0.16966817E-09_JPRB, 0.16963499E-09_JPRB, 0.16960842E-09_JPRB, &
  & 0.16959006E-09_JPRB, 0.16958200E-09_JPRB, 0.16958163E-09_JPRB, 0.16958737E-09_JPRB, 0.16959706E-09_JPRB, 0.16960910E-09_JPRB, &
  & 0.16962354E-09_JPRB, 0.16963599E-09_JPRB, 0.16964193E-09_JPRB, 0.16964025E-09_JPRB, 0.16963293E-09_JPRB, 0.16962415E-09_JPRB, &
  & 0.16961441E-09_JPRB, 0.16960364E-09_JPRB, 0.16959142E-09_JPRB, 0.16957810E-09_JPRB, 0.16956694E-09_JPRB, 0.16956031E-09_JPRB, &
  & 0.16955891E-09_JPRB, 0.16955763E-09_JPRB, 0.16955737E-09_JPRB, 0.16955878E-09_JPRB, 0.16956281E-09_JPRB, 0.16957204E-09_JPRB, &
  & 0.16958325E-09_JPRB, 0.16959478E-09_JPRB, 0.16960666E-09_JPRB, 0.16961767E-09_JPRB, 0.16962723E-09_JPRB, 0.16963411E-09_JPRB, &
  & 0.16963640E-09_JPRB, 0.16963292E-09_JPRB, 0.16962476E-09_JPRB, 0.16961749E-09_JPRB, 0.16961456E-09_JPRB, 0.16961610E-09_JPRB, &
  & 0.16961907E-09_JPRB, 0.16962068E-09_JPRB, 0.16961432E-09_JPRB, 0.16957541E-09_JPRB /)

RGHG8(:,77, 7) = (/ &
  & 0.16979765E-09_JPRB, 0.16985330E-09_JPRB, 0.16987013E-09_JPRB, 0.16987978E-09_JPRB, 0.16988701E-09_JPRB, 0.16989243E-09_JPRB, &
  & 0.16989621E-09_JPRB, 0.16990039E-09_JPRB, 0.16990317E-09_JPRB, 0.16990434E-09_JPRB, 0.16990569E-09_JPRB, 0.16990548E-09_JPRB, &
  & 0.16990304E-09_JPRB, 0.16989900E-09_JPRB, 0.16989349E-09_JPRB, 0.16988462E-09_JPRB, 0.16987281E-09_JPRB, 0.16985555E-09_JPRB, &
  & 0.16983578E-09_JPRB, 0.16981282E-09_JPRB, 0.16978695E-09_JPRB, 0.16976104E-09_JPRB, 0.16973661E-09_JPRB, 0.16971724E-09_JPRB, &
  & 0.16970353E-09_JPRB, 0.16969762E-09_JPRB, 0.16969670E-09_JPRB, 0.16970043E-09_JPRB, 0.16970696E-09_JPRB, 0.16971514E-09_JPRB, &
  & 0.16972546E-09_JPRB, 0.16973443E-09_JPRB, 0.16973854E-09_JPRB, 0.16973706E-09_JPRB, 0.16973126E-09_JPRB, 0.16972479E-09_JPRB, &
  & 0.16971777E-09_JPRB, 0.16971047E-09_JPRB, 0.16970246E-09_JPRB, 0.16969343E-09_JPRB, 0.16968588E-09_JPRB, 0.16968132E-09_JPRB, &
  & 0.16968119E-09_JPRB, 0.16968060E-09_JPRB, 0.16968082E-09_JPRB, 0.16968231E-09_JPRB, 0.16968557E-09_JPRB, 0.16969318E-09_JPRB, &
  & 0.16970181E-09_JPRB, 0.16971069E-09_JPRB, 0.16971988E-09_JPRB, 0.16972808E-09_JPRB, 0.16973480E-09_JPRB, 0.16974036E-09_JPRB, &
  & 0.16974243E-09_JPRB, 0.16974050E-09_JPRB, 0.16973481E-09_JPRB, 0.16972991E-09_JPRB, 0.16972848E-09_JPRB, 0.16973009E-09_JPRB, &
  & 0.16973281E-09_JPRB, 0.16973375E-09_JPRB, 0.16972644E-09_JPRB, 0.16968814E-09_JPRB /)

RGHG8(:,78, 7) = (/ &
  & 0.16986117E-09_JPRB, 0.16990392E-09_JPRB, 0.16991447E-09_JPRB, 0.16992098E-09_JPRB, 0.16992627E-09_JPRB, 0.16992988E-09_JPRB, &
  & 0.16993214E-09_JPRB, 0.16993533E-09_JPRB, 0.16993670E-09_JPRB, 0.16993702E-09_JPRB, 0.16993816E-09_JPRB, 0.16993813E-09_JPRB, &
  & 0.16993663E-09_JPRB, 0.16993394E-09_JPRB, 0.16993039E-09_JPRB, 0.16992491E-09_JPRB, 0.16991733E-09_JPRB, 0.16990558E-09_JPRB, &
  & 0.16989259E-09_JPRB, 0.16987800E-09_JPRB, 0.16986088E-09_JPRB, 0.16984426E-09_JPRB, 0.16982842E-09_JPRB, 0.16981640E-09_JPRB, &
  & 0.16980779E-09_JPRB, 0.16980480E-09_JPRB, 0.16980420E-09_JPRB, 0.16980670E-09_JPRB, 0.16981082E-09_JPRB, 0.16981588E-09_JPRB, &
  & 0.16982288E-09_JPRB, 0.16982898E-09_JPRB, 0.16983175E-09_JPRB, 0.16983084E-09_JPRB, 0.16982679E-09_JPRB, 0.16982286E-09_JPRB, &
  & 0.16981855E-09_JPRB, 0.16981445E-09_JPRB, 0.16981008E-09_JPRB, 0.16980474E-09_JPRB, 0.16980028E-09_JPRB, 0.16979743E-09_JPRB, &
  & 0.16979806E-09_JPRB, 0.16979781E-09_JPRB, 0.16979812E-09_JPRB, 0.16979919E-09_JPRB, 0.16980134E-09_JPRB, 0.16980667E-09_JPRB, &
  & 0.16981225E-09_JPRB, 0.16981792E-09_JPRB, 0.16982425E-09_JPRB, 0.16982897E-09_JPRB, 0.16983259E-09_JPRB, 0.16983595E-09_JPRB, &
  & 0.16983755E-09_JPRB, 0.16983701E-09_JPRB, 0.16983388E-09_JPRB, 0.16983168E-09_JPRB, 0.16983188E-09_JPRB, 0.16983320E-09_JPRB, &
  & 0.16983506E-09_JPRB, 0.16983524E-09_JPRB, 0.16982998E-09_JPRB, 0.16979625E-09_JPRB /)

RGHG8(:,79, 7) = (/ &
  & 0.16990274E-09_JPRB, 0.16993264E-09_JPRB, 0.16993822E-09_JPRB, 0.16994239E-09_JPRB, 0.16994665E-09_JPRB, 0.16994946E-09_JPRB, &
  & 0.16995068E-09_JPRB, 0.16995355E-09_JPRB, 0.16995426E-09_JPRB, 0.16995388E-09_JPRB, 0.16995522E-09_JPRB, 0.16995531E-09_JPRB, &
  & 0.16995413E-09_JPRB, 0.16995211E-09_JPRB, 0.16994954E-09_JPRB, 0.16994586E-09_JPRB, 0.16994064E-09_JPRB, 0.16993154E-09_JPRB, &
  & 0.16992242E-09_JPRB, 0.16991220E-09_JPRB, 0.16989979E-09_JPRB, 0.16988819E-09_JPRB, 0.16987690E-09_JPRB, 0.16986906E-09_JPRB, &
  & 0.16986337E-09_JPRB, 0.16986226E-09_JPRB, 0.16986196E-09_JPRB, 0.16986396E-09_JPRB, 0.16986690E-09_JPRB, 0.16987034E-09_JPRB, &
  & 0.16987567E-09_JPRB, 0.16988030E-09_JPRB, 0.16988230E-09_JPRB, 0.16988172E-09_JPRB, 0.16987853E-09_JPRB, 0.16987585E-09_JPRB, &
  & 0.16987285E-09_JPRB, 0.16987040E-09_JPRB, 0.16986790E-09_JPRB, 0.16986440E-09_JPRB, 0.16986142E-09_JPRB, 0.16985917E-09_JPRB, &
  & 0.16986020E-09_JPRB, 0.16985982E-09_JPRB, 0.16985999E-09_JPRB, 0.16986068E-09_JPRB, 0.16986189E-09_JPRB, 0.16986593E-09_JPRB, &
  & 0.16986966E-09_JPRB, 0.16987350E-09_JPRB, 0.16987811E-09_JPRB, 0.16988091E-09_JPRB, 0.16988268E-09_JPRB, 0.16988513E-09_JPRB, &
  & 0.16988642E-09_JPRB, 0.16988656E-09_JPRB, 0.16988456E-09_JPRB, 0.16988362E-09_JPRB, 0.16988473E-09_JPRB, 0.16988558E-09_JPRB, &
  & 0.16988710E-09_JPRB, 0.16988819E-09_JPRB, 0.16988624E-09_JPRB, 0.16986407E-09_JPRB /)

RGHG8(:,80, 7) = (/ &
  & 0.16993064E-09_JPRB, 0.16994671E-09_JPRB, 0.16994856E-09_JPRB, 0.16995164E-09_JPRB, 0.16995545E-09_JPRB, 0.16995787E-09_JPRB, &
  & 0.16995888E-09_JPRB, 0.16996132E-09_JPRB, 0.16996188E-09_JPRB, 0.16996132E-09_JPRB, 0.16996293E-09_JPRB, 0.16996303E-09_JPRB, &
  & 0.16996198E-09_JPRB, 0.16996018E-09_JPRB, 0.16995799E-09_JPRB, 0.16995519E-09_JPRB, 0.16995112E-09_JPRB, 0.16994321E-09_JPRB, &
  & 0.16993579E-09_JPRB, 0.16992777E-09_JPRB, 0.16991739E-09_JPRB, 0.16990806E-09_JPRB, 0.16989875E-09_JPRB, 0.16989281E-09_JPRB, &
  & 0.16988844E-09_JPRB, 0.16988824E-09_JPRB, 0.16988813E-09_JPRB, 0.16988994E-09_JPRB, 0.16989234E-09_JPRB, 0.16989507E-09_JPRB, &
  & 0.16989969E-09_JPRB, 0.16990372E-09_JPRB, 0.16990541E-09_JPRB, 0.16990497E-09_JPRB, 0.16990206E-09_JPRB, 0.16989990E-09_JPRB, &
  & 0.16989742E-09_JPRB, 0.16989568E-09_JPRB, 0.16989402E-09_JPRB, 0.16989127E-09_JPRB, 0.16988887E-09_JPRB, 0.16988680E-09_JPRB, &
  & 0.16988790E-09_JPRB, 0.16988738E-09_JPRB, 0.16988735E-09_JPRB, 0.16988778E-09_JPRB, 0.16988856E-09_JPRB, 0.16989209E-09_JPRB, &
  & 0.16989495E-09_JPRB, 0.16989790E-09_JPRB, 0.16990177E-09_JPRB, 0.16990365E-09_JPRB, 0.16990459E-09_JPRB, 0.16990671E-09_JPRB, &
  & 0.16990791E-09_JPRB, 0.16990827E-09_JPRB, 0.16990649E-09_JPRB, 0.16990588E-09_JPRB, 0.16990731E-09_JPRB, 0.16990781E-09_JPRB, &
  & 0.16990934E-09_JPRB, 0.16991096E-09_JPRB, 0.16991304E-09_JPRB, 0.16990787E-09_JPRB /)

RGHG8(:,81, 7) = (/ &
  & 0.16995003E-09_JPRB, 0.16995273E-09_JPRB, 0.16995289E-09_JPRB, 0.16995548E-09_JPRB, 0.16995914E-09_JPRB, 0.16996146E-09_JPRB, &
  & 0.16996211E-09_JPRB, 0.16996507E-09_JPRB, 0.16996538E-09_JPRB, 0.16996478E-09_JPRB, 0.16996603E-09_JPRB, 0.16996636E-09_JPRB, &
  & 0.16996546E-09_JPRB, 0.16996377E-09_JPRB, 0.16996171E-09_JPRB, 0.16995935E-09_JPRB, 0.16995576E-09_JPRB, 0.16994840E-09_JPRB, &
  & 0.16994181E-09_JPRB, 0.16993482E-09_JPRB, 0.16992530E-09_JPRB, 0.16991697E-09_JPRB, 0.16990841E-09_JPRB, 0.16990334E-09_JPRB, &
  & 0.16989950E-09_JPRB, 0.16989979E-09_JPRB, 0.16989969E-09_JPRB, 0.16990138E-09_JPRB, 0.16990356E-09_JPRB, 0.16990598E-09_JPRB, &
  & 0.16991032E-09_JPRB, 0.16991411E-09_JPRB, 0.16991565E-09_JPRB, 0.16991528E-09_JPRB, 0.16991246E-09_JPRB, 0.16991050E-09_JPRB, &
  & 0.16990817E-09_JPRB, 0.16990680E-09_JPRB, 0.16990545E-09_JPRB, 0.16990308E-09_JPRB, 0.16990087E-09_JPRB, 0.16989884E-09_JPRB, &
  & 0.16989998E-09_JPRB, 0.16989937E-09_JPRB, 0.16989923E-09_JPRB, 0.16989955E-09_JPRB, 0.16990015E-09_JPRB, 0.16990348E-09_JPRB, &
  & 0.16990599E-09_JPRB, 0.16990849E-09_JPRB, 0.16991208E-09_JPRB, 0.16991356E-09_JPRB, 0.16991412E-09_JPRB, 0.16991616E-09_JPRB, &
  & 0.16991730E-09_JPRB, 0.16991773E-09_JPRB, 0.16991597E-09_JPRB, 0.16991542E-09_JPRB, 0.16991697E-09_JPRB, 0.16991723E-09_JPRB, &
  & 0.16991865E-09_JPRB, 0.16992052E-09_JPRB, 0.16992421E-09_JPRB, 0.16993754E-09_JPRB /)

RGHG8(:,82, 7) = (/ &
  & 0.16995158E-09_JPRB, 0.16995477E-09_JPRB, 0.16995474E-09_JPRB, 0.16995730E-09_JPRB, 0.16996099E-09_JPRB, 0.16996320E-09_JPRB, &
  & 0.16996425E-09_JPRB, 0.16996624E-09_JPRB, 0.16996675E-09_JPRB, 0.16996630E-09_JPRB, 0.16996798E-09_JPRB, 0.16996810E-09_JPRB, &
  & 0.16996714E-09_JPRB, 0.16996547E-09_JPRB, 0.16996354E-09_JPRB, 0.16996134E-09_JPRB, 0.16995813E-09_JPRB, 0.16995094E-09_JPRB, &
  & 0.16994484E-09_JPRB, 0.16993838E-09_JPRB, 0.16992924E-09_JPRB, 0.16992147E-09_JPRB, 0.16991317E-09_JPRB, 0.16990853E-09_JPRB, &
  & 0.16990491E-09_JPRB, 0.16990549E-09_JPRB, 0.16990534E-09_JPRB, 0.16990701E-09_JPRB, 0.16990903E-09_JPRB, 0.16991128E-09_JPRB, &
  & 0.16991551E-09_JPRB, 0.16991916E-09_JPRB, 0.16992069E-09_JPRB, 0.16992036E-09_JPRB, 0.16991758E-09_JPRB, 0.16991568E-09_JPRB, &
  & 0.16991344E-09_JPRB, 0.16991222E-09_JPRB, 0.16991104E-09_JPRB, 0.16990880E-09_JPRB, 0.16990676E-09_JPRB, 0.16990476E-09_JPRB, &
  & 0.16990583E-09_JPRB, 0.16990519E-09_JPRB, 0.16990502E-09_JPRB, 0.16990527E-09_JPRB, 0.16990576E-09_JPRB, 0.16990909E-09_JPRB, &
  & 0.16991138E-09_JPRB, 0.16991369E-09_JPRB, 0.16991715E-09_JPRB, 0.16991841E-09_JPRB, 0.16991876E-09_JPRB, 0.16992079E-09_JPRB, &
  & 0.16992192E-09_JPRB, 0.16992238E-09_JPRB, 0.16992056E-09_JPRB, 0.16992002E-09_JPRB, 0.16992165E-09_JPRB, 0.16992174E-09_JPRB, &
  & 0.16992310E-09_JPRB, 0.16992471E-09_JPRB, 0.16992802E-09_JPRB, 0.16993991E-09_JPRB /)

RGHG8(:,83, 7) = (/ &
  & 0.16995266E-09_JPRB, 0.16995598E-09_JPRB, 0.16995580E-09_JPRB, 0.16995831E-09_JPRB, 0.16996193E-09_JPRB, 0.16996418E-09_JPRB, &
  & 0.16996474E-09_JPRB, 0.16996764E-09_JPRB, 0.16996786E-09_JPRB, 0.16996751E-09_JPRB, 0.16996841E-09_JPRB, 0.16996887E-09_JPRB, &
  & 0.16996812E-09_JPRB, 0.16996646E-09_JPRB, 0.16996456E-09_JPRB, 0.16996252E-09_JPRB, 0.16995938E-09_JPRB, 0.16995240E-09_JPRB, &
  & 0.16994652E-09_JPRB, 0.16994049E-09_JPRB, 0.16993153E-09_JPRB, 0.16992402E-09_JPRB, 0.16991583E-09_JPRB, 0.16991150E-09_JPRB, &
  & 0.16990787E-09_JPRB, 0.16990871E-09_JPRB, 0.16990853E-09_JPRB, 0.16991014E-09_JPRB, 0.16991214E-09_JPRB, 0.16991428E-09_JPRB, &
  & 0.16991843E-09_JPRB, 0.16992201E-09_JPRB, 0.16992353E-09_JPRB, 0.16992321E-09_JPRB, 0.16992040E-09_JPRB, 0.16991855E-09_JPRB, &
  & 0.16991636E-09_JPRB, 0.16991522E-09_JPRB, 0.16991415E-09_JPRB, 0.16991202E-09_JPRB, 0.16991000E-09_JPRB, 0.16990807E-09_JPRB, &
  & 0.16990909E-09_JPRB, 0.16990842E-09_JPRB, 0.16990821E-09_JPRB, 0.16990848E-09_JPRB, 0.16990892E-09_JPRB, 0.16991217E-09_JPRB, &
  & 0.16991440E-09_JPRB, 0.16991661E-09_JPRB, 0.16991998E-09_JPRB, 0.16992115E-09_JPRB, 0.16992137E-09_JPRB, 0.16992342E-09_JPRB, &
  & 0.16992453E-09_JPRB, 0.16992502E-09_JPRB, 0.16992313E-09_JPRB, 0.16992258E-09_JPRB, 0.16992426E-09_JPRB, 0.16992426E-09_JPRB, &
  & 0.16992553E-09_JPRB, 0.16992709E-09_JPRB, 0.16993022E-09_JPRB, 0.16994159E-09_JPRB /)

RGHG8(:,84, 7) = (/ &
  & 0.16995344E-09_JPRB, 0.16995678E-09_JPRB, 0.16995642E-09_JPRB, 0.16995891E-09_JPRB, 0.16996263E-09_JPRB, 0.16996479E-09_JPRB, &
  & 0.16996601E-09_JPRB, 0.16996760E-09_JPRB, 0.16996821E-09_JPRB, 0.16996798E-09_JPRB, 0.16996934E-09_JPRB, 0.16996943E-09_JPRB, &
  & 0.16996854E-09_JPRB, 0.16996701E-09_JPRB, 0.16996519E-09_JPRB, 0.16996320E-09_JPRB, 0.16996020E-09_JPRB, 0.16995332E-09_JPRB, &
  & 0.16994765E-09_JPRB, 0.16994177E-09_JPRB, 0.16993291E-09_JPRB, 0.16992566E-09_JPRB, 0.16991750E-09_JPRB, 0.16991329E-09_JPRB, &
  & 0.16990968E-09_JPRB, 0.16991074E-09_JPRB, 0.16991047E-09_JPRB, 0.16991211E-09_JPRB, 0.16991397E-09_JPRB, 0.16991611E-09_JPRB, &
  & 0.16992019E-09_JPRB, 0.16992378E-09_JPRB, 0.16992524E-09_JPRB, 0.16992495E-09_JPRB, 0.16992215E-09_JPRB, 0.16992027E-09_JPRB, &
  & 0.16991816E-09_JPRB, 0.16991705E-09_JPRB, 0.16991605E-09_JPRB, 0.16991397E-09_JPRB, 0.16991204E-09_JPRB, 0.16991011E-09_JPRB, &
  & 0.16991109E-09_JPRB, 0.16991043E-09_JPRB, 0.16991022E-09_JPRB, 0.16991045E-09_JPRB, 0.16991089E-09_JPRB, 0.16991410E-09_JPRB, &
  & 0.16991623E-09_JPRB, 0.16991838E-09_JPRB, 0.16992178E-09_JPRB, 0.16992288E-09_JPRB, 0.16992298E-09_JPRB, 0.16992500E-09_JPRB, &
  & 0.16992617E-09_JPRB, 0.16992666E-09_JPRB, 0.16992474E-09_JPRB, 0.16992419E-09_JPRB, 0.16992589E-09_JPRB, 0.16992582E-09_JPRB, &
  & 0.16992707E-09_JPRB, 0.16992856E-09_JPRB, 0.16993169E-09_JPRB, 0.16994273E-09_JPRB /)

RGHG8(:,85, 7) = (/ &
  & 0.16995397E-09_JPRB, 0.16995731E-09_JPRB, 0.16995681E-09_JPRB, 0.16995930E-09_JPRB, 0.16996300E-09_JPRB, 0.16996526E-09_JPRB, &
  & 0.16996582E-09_JPRB, 0.16996851E-09_JPRB, 0.16996869E-09_JPRB, 0.16996864E-09_JPRB, 0.16996922E-09_JPRB, 0.16996940E-09_JPRB, &
  & 0.16996873E-09_JPRB, 0.16996729E-09_JPRB, 0.16996556E-09_JPRB, 0.16996358E-09_JPRB, 0.16996064E-09_JPRB, 0.16995412E-09_JPRB, &
  & 0.16994854E-09_JPRB, 0.16994271E-09_JPRB, 0.16993387E-09_JPRB, 0.16992674E-09_JPRB, 0.16991854E-09_JPRB, 0.16991458E-09_JPRB, &
  & 0.16991085E-09_JPRB, 0.16991206E-09_JPRB, 0.16991172E-09_JPRB, 0.16991331E-09_JPRB, 0.16991518E-09_JPRB, 0.16991723E-09_JPRB, &
  & 0.16992135E-09_JPRB, 0.16992489E-09_JPRB, 0.16992639E-09_JPRB, 0.16992611E-09_JPRB, 0.16992327E-09_JPRB, 0.16992144E-09_JPRB, &
  & 0.16991927E-09_JPRB, 0.16991825E-09_JPRB, 0.16991725E-09_JPRB, 0.16991523E-09_JPRB, 0.16991332E-09_JPRB, 0.16991140E-09_JPRB, &
  & 0.16991238E-09_JPRB, 0.16991177E-09_JPRB, 0.16991145E-09_JPRB, 0.16991170E-09_JPRB, 0.16991218E-09_JPRB, 0.16991528E-09_JPRB, &
  & 0.16991739E-09_JPRB, 0.16991955E-09_JPRB, 0.16992290E-09_JPRB, 0.16992399E-09_JPRB, 0.16992402E-09_JPRB, 0.16992606E-09_JPRB, &
  & 0.16992724E-09_JPRB, 0.16992777E-09_JPRB, 0.16992578E-09_JPRB, 0.16992520E-09_JPRB, 0.16992696E-09_JPRB, 0.16992685E-09_JPRB, &
  & 0.16992807E-09_JPRB, 0.16992956E-09_JPRB, 0.16993260E-09_JPRB, 0.16994353E-09_JPRB /)

RGHG8(:,86, 7) = (/ &
  & 0.16995427E-09_JPRB, 0.16995763E-09_JPRB, 0.16995701E-09_JPRB, 0.16995955E-09_JPRB, 0.16996349E-09_JPRB, 0.16996538E-09_JPRB, &
  & 0.16996696E-09_JPRB, 0.16996801E-09_JPRB, 0.16996868E-09_JPRB, 0.16996865E-09_JPRB, 0.16996936E-09_JPRB, 0.16996932E-09_JPRB, &
  & 0.16996857E-09_JPRB, 0.16996732E-09_JPRB, 0.16996569E-09_JPRB, 0.16996377E-09_JPRB, 0.16996077E-09_JPRB, 0.16995498E-09_JPRB, &
  & 0.16994929E-09_JPRB, 0.16994349E-09_JPRB, 0.16993457E-09_JPRB, 0.16992746E-09_JPRB, 0.16991926E-09_JPRB, 0.16991532E-09_JPRB, &
  & 0.16991160E-09_JPRB, 0.16991294E-09_JPRB, 0.16991250E-09_JPRB, 0.16991414E-09_JPRB, 0.16991587E-09_JPRB, 0.16991798E-09_JPRB, &
  & 0.16992212E-09_JPRB, 0.16992564E-09_JPRB, 0.16992716E-09_JPRB, 0.16992685E-09_JPRB, 0.16992396E-09_JPRB, 0.16992212E-09_JPRB, &
  & 0.16992001E-09_JPRB, 0.16991901E-09_JPRB, 0.16991808E-09_JPRB, 0.16991605E-09_JPRB, 0.16991411E-09_JPRB, 0.16991214E-09_JPRB, &
  & 0.16991322E-09_JPRB, 0.16991257E-09_JPRB, 0.16991231E-09_JPRB, 0.16991256E-09_JPRB, 0.16991307E-09_JPRB, 0.16991611E-09_JPRB, &
  & 0.16991814E-09_JPRB, 0.16992027E-09_JPRB, 0.16992352E-09_JPRB, 0.16992466E-09_JPRB, 0.16992469E-09_JPRB, 0.16992670E-09_JPRB, &
  & 0.16992797E-09_JPRB, 0.16992849E-09_JPRB, 0.16992646E-09_JPRB, 0.16992587E-09_JPRB, 0.16992764E-09_JPRB, 0.16992752E-09_JPRB, &
  & 0.16992868E-09_JPRB, 0.16993014E-09_JPRB, 0.16993323E-09_JPRB, 0.16994404E-09_JPRB /)

RGHG8(:,87, 7) = (/ &
  & 0.16995452E-09_JPRB, 0.16995778E-09_JPRB, 0.16995719E-09_JPRB, 0.16995982E-09_JPRB, 0.16996328E-09_JPRB, 0.16996593E-09_JPRB, &
  & 0.16996644E-09_JPRB, 0.16996871E-09_JPRB, 0.16996887E-09_JPRB, 0.16996887E-09_JPRB, 0.16996915E-09_JPRB, 0.16996901E-09_JPRB, &
  & 0.16996836E-09_JPRB, 0.16996717E-09_JPRB, 0.16996567E-09_JPRB, 0.16996374E-09_JPRB, 0.16996096E-09_JPRB, 0.16995545E-09_JPRB, &
  & 0.16995003E-09_JPRB, 0.16994395E-09_JPRB, 0.16993519E-09_JPRB, 0.16992793E-09_JPRB, 0.16991972E-09_JPRB, 0.16991587E-09_JPRB, &
  & 0.16991206E-09_JPRB, 0.16991346E-09_JPRB, 0.16991292E-09_JPRB, 0.16991455E-09_JPRB, 0.16991630E-09_JPRB, 0.16991837E-09_JPRB, &
  & 0.16992259E-09_JPRB, 0.16992617E-09_JPRB, 0.16992764E-09_JPRB, 0.16992735E-09_JPRB, 0.16992441E-09_JPRB, 0.16992258E-09_JPRB, &
  & 0.16992042E-09_JPRB, 0.16991947E-09_JPRB, 0.16991862E-09_JPRB, 0.16991655E-09_JPRB, 0.16991464E-09_JPRB, 0.16991251E-09_JPRB, &
  & 0.16991379E-09_JPRB, 0.16991306E-09_JPRB, 0.16991281E-09_JPRB, 0.16991307E-09_JPRB, 0.16991369E-09_JPRB, 0.16991654E-09_JPRB, &
  & 0.16991859E-09_JPRB, 0.16992074E-09_JPRB, 0.16992388E-09_JPRB, 0.16992502E-09_JPRB, 0.16992512E-09_JPRB, 0.16992710E-09_JPRB, &
  & 0.16992843E-09_JPRB, 0.16992899E-09_JPRB, 0.16992688E-09_JPRB, 0.16992627E-09_JPRB, 0.16992806E-09_JPRB, 0.16992792E-09_JPRB, &
  & 0.16992907E-09_JPRB, 0.16993057E-09_JPRB, 0.16993359E-09_JPRB, 0.16994441E-09_JPRB /)

RGHG8(:,88, 7) = (/ &
  & 0.16995477E-09_JPRB, 0.16995788E-09_JPRB, 0.16995741E-09_JPRB, 0.16995975E-09_JPRB, 0.16996393E-09_JPRB, 0.16996561E-09_JPRB, &
  & 0.16996735E-09_JPRB, 0.16996823E-09_JPRB, 0.16996876E-09_JPRB, 0.16996878E-09_JPRB, 0.16996918E-09_JPRB, 0.16996904E-09_JPRB, &
  & 0.16996832E-09_JPRB, 0.16996718E-09_JPRB, 0.16996564E-09_JPRB, 0.16996379E-09_JPRB, 0.16996091E-09_JPRB, 0.16995583E-09_JPRB, &
  & 0.16995025E-09_JPRB, 0.16994439E-09_JPRB, 0.16993534E-09_JPRB, 0.16992828E-09_JPRB, 0.16992001E-09_JPRB, 0.16991614E-09_JPRB, &
  & 0.16991229E-09_JPRB, 0.16991378E-09_JPRB, 0.16991319E-09_JPRB, 0.16991486E-09_JPRB, 0.16991651E-09_JPRB, 0.16991861E-09_JPRB, &
  & 0.16992287E-09_JPRB, 0.16992645E-09_JPRB, 0.16992796E-09_JPRB, 0.16992768E-09_JPRB, 0.16992470E-09_JPRB, 0.16992283E-09_JPRB, &
  & 0.16992066E-09_JPRB, 0.16991977E-09_JPRB, 0.16991902E-09_JPRB, 0.16991693E-09_JPRB, 0.16991492E-09_JPRB, 0.16991261E-09_JPRB, &
  & 0.16991417E-09_JPRB, 0.16991333E-09_JPRB, 0.16991311E-09_JPRB, 0.16991342E-09_JPRB, 0.16991406E-09_JPRB, 0.16991683E-09_JPRB, &
  & 0.16991886E-09_JPRB, 0.16992104E-09_JPRB, 0.16992398E-09_JPRB, 0.16992519E-09_JPRB, 0.16992538E-09_JPRB, 0.16992736E-09_JPRB, &
  & 0.16992867E-09_JPRB, 0.16992925E-09_JPRB, 0.16992711E-09_JPRB, 0.16992653E-09_JPRB, 0.16992835E-09_JPRB, 0.16992814E-09_JPRB, &
  & 0.16992932E-09_JPRB, 0.16993076E-09_JPRB, 0.16993383E-09_JPRB, 0.16994464E-09_JPRB /)

RGHG8(:,89, 7) = (/ &
  & 0.16995508E-09_JPRB, 0.16995785E-09_JPRB, 0.16995758E-09_JPRB, 0.16995988E-09_JPRB, 0.16996340E-09_JPRB, 0.16996607E-09_JPRB, &
  & 0.16996671E-09_JPRB, 0.16996876E-09_JPRB, 0.16996896E-09_JPRB, 0.16996898E-09_JPRB, 0.16996929E-09_JPRB, 0.16996915E-09_JPRB, &
  & 0.16996850E-09_JPRB, 0.16996729E-09_JPRB, 0.16996576E-09_JPRB, 0.16996386E-09_JPRB, 0.16996111E-09_JPRB, 0.16995558E-09_JPRB, &
  & 0.16995026E-09_JPRB, 0.16994428E-09_JPRB, 0.16993545E-09_JPRB, 0.16992832E-09_JPRB, 0.16992011E-09_JPRB, 0.16991629E-09_JPRB, &
  & 0.16991242E-09_JPRB, 0.16991397E-09_JPRB, 0.16991332E-09_JPRB, 0.16991498E-09_JPRB, 0.16991664E-09_JPRB, 0.16991869E-09_JPRB, &
  & 0.16992305E-09_JPRB, 0.16992666E-09_JPRB, 0.16992818E-09_JPRB, 0.16992792E-09_JPRB, 0.16992484E-09_JPRB, 0.16992294E-09_JPRB, &
  & 0.16992076E-09_JPRB, 0.16991994E-09_JPRB, 0.16991927E-09_JPRB, 0.16991711E-09_JPRB, 0.16991508E-09_JPRB, 0.16991257E-09_JPRB, &
  & 0.16991442E-09_JPRB, 0.16991349E-09_JPRB, 0.16991328E-09_JPRB, 0.16991360E-09_JPRB, 0.16991426E-09_JPRB, 0.16991702E-09_JPRB, &
  & 0.16991906E-09_JPRB, 0.16992119E-09_JPRB, 0.16992409E-09_JPRB, 0.16992528E-09_JPRB, 0.16992549E-09_JPRB, 0.16992745E-09_JPRB, &
  & 0.16992881E-09_JPRB, 0.16992942E-09_JPRB, 0.16992725E-09_JPRB, 0.16992666E-09_JPRB, 0.16992852E-09_JPRB, 0.16992828E-09_JPRB, &
  & 0.16992946E-09_JPRB, 0.16993089E-09_JPRB, 0.16993393E-09_JPRB, 0.16994479E-09_JPRB /)

RGHG8(:,90, 7) = (/ &
  & 0.16995527E-09_JPRB, 0.16995777E-09_JPRB, 0.16995758E-09_JPRB, 0.16995967E-09_JPRB, 0.16996364E-09_JPRB, 0.16996571E-09_JPRB, &
  & 0.16996708E-09_JPRB, 0.16996848E-09_JPRB, 0.16996897E-09_JPRB, 0.16996896E-09_JPRB, 0.16996973E-09_JPRB, 0.16996975E-09_JPRB, &
  & 0.16996900E-09_JPRB, 0.16996765E-09_JPRB, 0.16996596E-09_JPRB, 0.16996413E-09_JPRB, 0.16996123E-09_JPRB, 0.16995531E-09_JPRB, &
  & 0.16994982E-09_JPRB, 0.16994428E-09_JPRB, 0.16993518E-09_JPRB, 0.16992836E-09_JPRB, 0.16992004E-09_JPRB, 0.16991634E-09_JPRB, &
  & 0.16991233E-09_JPRB, 0.16991410E-09_JPRB, 0.16991332E-09_JPRB, 0.16991507E-09_JPRB, 0.16991665E-09_JPRB, 0.16991863E-09_JPRB, &
  & 0.16992313E-09_JPRB, 0.16992685E-09_JPRB, 0.16992838E-09_JPRB, 0.16992811E-09_JPRB, 0.16992482E-09_JPRB, 0.16992299E-09_JPRB, &
  & 0.16992077E-09_JPRB, 0.16991999E-09_JPRB, 0.16991941E-09_JPRB, 0.16991714E-09_JPRB, 0.16991514E-09_JPRB, 0.16991236E-09_JPRB, &
  & 0.16991464E-09_JPRB, 0.16991354E-09_JPRB, 0.16991332E-09_JPRB, 0.16991360E-09_JPRB, 0.16991421E-09_JPRB, 0.16991714E-09_JPRB, &
  & 0.16991912E-09_JPRB, 0.16992127E-09_JPRB, 0.16992419E-09_JPRB, 0.16992539E-09_JPRB, 0.16992553E-09_JPRB, 0.16992756E-09_JPRB, &
  & 0.16992895E-09_JPRB, 0.16992957E-09_JPRB, 0.16992728E-09_JPRB, 0.16992661E-09_JPRB, 0.16992860E-09_JPRB, 0.16992829E-09_JPRB, &
  & 0.16992951E-09_JPRB, 0.16993093E-09_JPRB, 0.16993401E-09_JPRB, 0.16994499E-09_JPRB /)

RGHG8(:,91, 7) = (/ &
  & 0.16995501E-09_JPRB, 0.16995760E-09_JPRB, 0.16995717E-09_JPRB, 0.16995946E-09_JPRB, 0.16996354E-09_JPRB, 0.16996579E-09_JPRB, &
  & 0.16996565E-09_JPRB, 0.16996954E-09_JPRB, 0.16996882E-09_JPRB, 0.16996837E-09_JPRB, 0.16997088E-09_JPRB, 0.16997093E-09_JPRB, &
  & 0.16996976E-09_JPRB, 0.16996785E-09_JPRB, 0.16996585E-09_JPRB, 0.16996435E-09_JPRB, 0.16996206E-09_JPRB, 0.16995426E-09_JPRB, &
  & 0.16994936E-09_JPRB, 0.16994434E-09_JPRB, 0.16993494E-09_JPRB, 0.16992846E-09_JPRB, 0.16991974E-09_JPRB, 0.16991637E-09_JPRB, &
  & 0.16991197E-09_JPRB, 0.16991428E-09_JPRB, 0.16991318E-09_JPRB, 0.16991508E-09_JPRB, 0.16991661E-09_JPRB, 0.16991834E-09_JPRB, &
  & 0.16992328E-09_JPRB, 0.16992702E-09_JPRB, 0.16992860E-09_JPRB, 0.16992838E-09_JPRB, 0.16992474E-09_JPRB, 0.16992303E-09_JPRB, &
  & 0.16992069E-09_JPRB, 0.16991999E-09_JPRB, 0.16991956E-09_JPRB, 0.16991716E-09_JPRB, 0.16991526E-09_JPRB, 0.16991190E-09_JPRB, &
  & 0.16991507E-09_JPRB, 0.16991344E-09_JPRB, 0.16991324E-09_JPRB, 0.16991346E-09_JPRB, 0.16991364E-09_JPRB, 0.16991743E-09_JPRB, &
  & 0.16991911E-09_JPRB, 0.16992144E-09_JPRB, 0.16992455E-09_JPRB, 0.16992562E-09_JPRB, 0.16992537E-09_JPRB, 0.16992768E-09_JPRB, &
  & 0.16992908E-09_JPRB, 0.16992981E-09_JPRB, 0.16992717E-09_JPRB, 0.16992648E-09_JPRB, 0.16992879E-09_JPRB, 0.16992824E-09_JPRB, &
  & 0.16992957E-09_JPRB, 0.16993092E-09_JPRB, 0.16993409E-09_JPRB, 0.16994531E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART14',1,ZHOOK_HANDLE)
END SUBROUTINE PART14






SUBROUTINE PART15
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART15',0,ZHOOK_HANDLE)



!-- Month=  8 ------------

RGHG8(:, 1, 8) = (/ &
  & 0.39880110E-10_JPRB, 0.39867450E-10_JPRB, 0.39844787E-10_JPRB, 0.39805367E-10_JPRB, 0.39760927E-10_JPRB, 0.39713653E-10_JPRB, &
  & 0.39666527E-10_JPRB, 0.39622798E-10_JPRB, 0.39584631E-10_JPRB, 0.39553839E-10_JPRB, 0.39530490E-10_JPRB, 0.39512255E-10_JPRB, &
  & 0.39497700E-10_JPRB, 0.39484610E-10_JPRB, 0.39470444E-10_JPRB, 0.39452885E-10_JPRB, 0.39430164E-10_JPRB, 0.39401270E-10_JPRB, &
  & 0.39364043E-10_JPRB, 0.39318382E-10_JPRB, 0.39263807E-10_JPRB, 0.39201687E-10_JPRB, 0.39136409E-10_JPRB, 0.39074660E-10_JPRB, &
  & 0.39023854E-10_JPRB, 0.38989922E-10_JPRB, 0.38974435E-10_JPRB, 0.38971673E-10_JPRB, 0.38970740E-10_JPRB, 0.38962479E-10_JPRB, &
  & 0.38942519E-10_JPRB, 0.38909410E-10_JPRB, 0.38863437E-10_JPRB, 0.38801497E-10_JPRB, 0.38725786E-10_JPRB, 0.38637680E-10_JPRB, &
  & 0.38540171E-10_JPRB, 0.38437198E-10_JPRB, 0.38333118E-10_JPRB, 0.38241493E-10_JPRB, 0.38174883E-10_JPRB, 0.38119417E-10_JPRB, &
  & 0.38061131E-10_JPRB, 0.37997380E-10_JPRB, 0.37915410E-10_JPRB, 0.37814352E-10_JPRB, 0.37660503E-10_JPRB, 0.37447948E-10_JPRB, &
  & 0.37241561E-10_JPRB, 0.37060337E-10_JPRB, 0.36919717E-10_JPRB, 0.36795907E-10_JPRB, 0.36677921E-10_JPRB, 0.36554097E-10_JPRB, &
  & 0.36426240E-10_JPRB, 0.36284382E-10_JPRB, 0.36126213E-10_JPRB, 0.35949004E-10_JPRB, 0.35750094E-10_JPRB, 0.35545678E-10_JPRB, &
  & 0.35361308E-10_JPRB, 0.35197879E-10_JPRB, 0.35049810E-10_JPRB, 0.34946771E-10_JPRB /)

RGHG8(:, 2, 8) = (/ &
  & 0.39999705E-10_JPRB, 0.40014436E-10_JPRB, 0.40020154E-10_JPRB, 0.40020438E-10_JPRB, 0.40016261E-10_JPRB, 0.40009107E-10_JPRB, &
  & 0.40000121E-10_JPRB, 0.39989477E-10_JPRB, 0.39975884E-10_JPRB, 0.39958363E-10_JPRB, 0.39935187E-10_JPRB, 0.39906394E-10_JPRB, &
  & 0.39876075E-10_JPRB, 0.39849114E-10_JPRB, 0.39828300E-10_JPRB, 0.39812927E-10_JPRB, 0.39799677E-10_JPRB, 0.39784370E-10_JPRB, &
  & 0.39761777E-10_JPRB, 0.39730521E-10_JPRB, 0.39690862E-10_JPRB, 0.39645426E-10_JPRB, 0.39598960E-10_JPRB, 0.39557021E-10_JPRB, &
  & 0.39525251E-10_JPRB, 0.39509312E-10_JPRB, 0.39515592E-10_JPRB, 0.39548521E-10_JPRB, 0.39605423E-10_JPRB, 0.39674479E-10_JPRB, &
  & 0.39739247E-10_JPRB, 0.39783062E-10_JPRB, 0.39793207E-10_JPRB, 0.39760747E-10_JPRB, 0.39687427E-10_JPRB, 0.39578344E-10_JPRB, &
  & 0.39441103E-10_JPRB, 0.39283927E-10_JPRB, 0.39119593E-10_JPRB, 0.38965907E-10_JPRB, 0.38838467E-10_JPRB, 0.38730841E-10_JPRB, &
  & 0.38630488E-10_JPRB, 0.38527351E-10_JPRB, 0.38412856E-10_JPRB, 0.38279054E-10_JPRB, 0.38117183E-10_JPRB, 0.37928032E-10_JPRB, &
  & 0.37735169E-10_JPRB, 0.37552413E-10_JPRB, 0.37392603E-10_JPRB, 0.37249540E-10_JPRB, 0.37111307E-10_JPRB, 0.36967603E-10_JPRB, &
  & 0.36819537E-10_JPRB, 0.36657830E-10_JPRB, 0.36473956E-10_JPRB, 0.36277464E-10_JPRB, 0.36072666E-10_JPRB, 0.35870425E-10_JPRB, &
  & 0.35685194E-10_JPRB, 0.35509401E-10_JPRB, 0.35336459E-10_JPRB, 0.35111639E-10_JPRB /)

RGHG8(:, 3, 8) = (/ &
  & 0.40149231E-10_JPRB, 0.40182146E-10_JPRB, 0.40196367E-10_JPRB, 0.40201696E-10_JPRB, 0.40199025E-10_JPRB, 0.40189924E-10_JPRB, &
  & 0.40176057E-10_JPRB, 0.40159695E-10_JPRB, 0.40145397E-10_JPRB, 0.40142958E-10_JPRB, 0.40158273E-10_JPRB, 0.40192079E-10_JPRB, &
  & 0.40240606E-10_JPRB, 0.40297165E-10_JPRB, 0.40355504E-10_JPRB, 0.40410252E-10_JPRB, 0.40456697E-10_JPRB, 0.40490715E-10_JPRB, &
  & 0.40507812E-10_JPRB, 0.40506216E-10_JPRB, 0.40486111E-10_JPRB, 0.40449814E-10_JPRB, 0.40403222E-10_JPRB, 0.40357682E-10_JPRB, &
  & 0.40330198E-10_JPRB, 0.40338573E-10_JPRB, 0.40392290E-10_JPRB, 0.40487842E-10_JPRB, 0.40612059E-10_JPRB, 0.40747909E-10_JPRB, &
  & 0.40877558E-10_JPRB, 0.40980514E-10_JPRB, 0.41036948E-10_JPRB, 0.41031900E-10_JPRB, 0.40965037E-10_JPRB, 0.40842489E-10_JPRB, &
  & 0.40672594E-10_JPRB, 0.40463542E-10_JPRB, 0.40223568E-10_JPRB, 0.39973316E-10_JPRB, 0.39736006E-10_JPRB, 0.39523551E-10_JPRB, &
  & 0.39328030E-10_JPRB, 0.39139410E-10_JPRB, 0.38950031E-10_JPRB, 0.38754562E-10_JPRB, 0.38553105E-10_JPRB, 0.38357081E-10_JPRB, &
  & 0.38172882E-10_JPRB, 0.38010799E-10_JPRB, 0.37865235E-10_JPRB, 0.37732126E-10_JPRB, 0.37602615E-10_JPRB, 0.37465295E-10_JPRB, &
  & 0.37319720E-10_JPRB, 0.37160469E-10_JPRB, 0.36985484E-10_JPRB, 0.36792996E-10_JPRB, 0.36580912E-10_JPRB, 0.36368537E-10_JPRB, &
  & 0.36153549E-10_JPRB, 0.35935737E-10_JPRB, 0.35719143E-10_JPRB, 0.35424646E-10_JPRB /)

RGHG8(:, 4, 8) = (/ &
  & 0.40317551E-10_JPRB, 0.40389955E-10_JPRB, 0.40427502E-10_JPRB, 0.40451417E-10_JPRB, 0.40466425E-10_JPRB, 0.40478471E-10_JPRB, &
  & 0.40495135E-10_JPRB, 0.40523290E-10_JPRB, 0.40567091E-10_JPRB, 0.40630884E-10_JPRB, 0.40710463E-10_JPRB, 0.40802806E-10_JPRB, &
  & 0.40905543E-10_JPRB, 0.41013169E-10_JPRB, 0.41118747E-10_JPRB, 0.41217644E-10_JPRB, 0.41308405E-10_JPRB, 0.41390030E-10_JPRB, &
  & 0.41459391E-10_JPRB, 0.41514073E-10_JPRB, 0.41551585E-10_JPRB, 0.41571083E-10_JPRB, 0.41575320E-10_JPRB, 0.41572478E-10_JPRB, &
  & 0.41576222E-10_JPRB, 0.41604872E-10_JPRB, 0.41673581E-10_JPRB, 0.41786834E-10_JPRB, 0.41937419E-10_JPRB, 0.42112595E-10_JPRB, &
  & 0.42295369E-10_JPRB, 0.42466450E-10_JPRB, 0.42601672E-10_JPRB, 0.42676671E-10_JPRB, 0.42682902E-10_JPRB, 0.42622263E-10_JPRB, &
  & 0.42500302E-10_JPRB, 0.42322063E-10_JPRB, 0.42091490E-10_JPRB, 0.41813410E-10_JPRB, 0.41503793E-10_JPRB, 0.41176888E-10_JPRB, &
  & 0.40843596E-10_JPRB, 0.40503708E-10_JPRB, 0.40157135E-10_JPRB, 0.39805902E-10_JPRB, 0.39456924E-10_JPRB, 0.39122702E-10_JPRB, &
  & 0.38817727E-10_JPRB, 0.38545910E-10_JPRB, 0.38307333E-10_JPRB, 0.38096300E-10_JPRB, 0.37908978E-10_JPRB, 0.37737438E-10_JPRB, &
  & 0.37575918E-10_JPRB, 0.37417361E-10_JPRB, 0.37256337E-10_JPRB, 0.37090307E-10_JPRB, 0.36909944E-10_JPRB, 0.36712491E-10_JPRB, &
  & 0.36521012E-10_JPRB, 0.36342682E-10_JPRB, 0.36157907E-10_JPRB, 0.35845583E-10_JPRB /)

RGHG8(:, 5, 8) = (/ &
  & 0.40519026E-10_JPRB, 0.40672445E-10_JPRB, 0.40755878E-10_JPRB, 0.40817148E-10_JPRB, 0.40867736E-10_JPRB, 0.40918331E-10_JPRB, &
  & 0.40978155E-10_JPRB, 0.41051367E-10_JPRB, 0.41140827E-10_JPRB, 0.41253646E-10_JPRB, 0.41386890E-10_JPRB, 0.41537114E-10_JPRB, &
  & 0.41701951E-10_JPRB, 0.41879611E-10_JPRB, 0.42066413E-10_JPRB, 0.42254429E-10_JPRB, 0.42435298E-10_JPRB, 0.42605201E-10_JPRB, &
  & 0.42764327E-10_JPRB, 0.42914474E-10_JPRB, 0.43054661E-10_JPRB, 0.43182121E-10_JPRB, 0.43293574E-10_JPRB, 0.43387235E-10_JPRB, &
  & 0.43466446E-10_JPRB, 0.43539183E-10_JPRB, 0.43618248E-10_JPRB, 0.43716412E-10_JPRB, 0.43843373E-10_JPRB, 0.44003405E-10_JPRB, &
  & 0.44195765E-10_JPRB, 0.44411884E-10_JPRB, 0.44633880E-10_JPRB, 0.44835514E-10_JPRB, 0.44997787E-10_JPRB, 0.45106835E-10_JPRB, &
  & 0.45160032E-10_JPRB, 0.45156049E-10_JPRB, 0.45091514E-10_JPRB, 0.44954814E-10_JPRB, 0.44732079E-10_JPRB, 0.44418802E-10_JPRB, &
  & 0.44016679E-10_JPRB, 0.43542732E-10_JPRB, 0.43013284E-10_JPRB, 0.42439278E-10_JPRB, 0.41834841E-10_JPRB, 0.41217630E-10_JPRB, &
  & 0.40601800E-10_JPRB, 0.40009798E-10_JPRB, 0.39454291E-10_JPRB, 0.38944646E-10_JPRB, 0.38488240E-10_JPRB, 0.38091079E-10_JPRB, &
  & 0.37755840E-10_JPRB, 0.37474936E-10_JPRB, 0.37243628E-10_JPRB, 0.37045821E-10_JPRB, 0.36871020E-10_JPRB, 0.36731031E-10_JPRB, &
  & 0.36596705E-10_JPRB, 0.36458971E-10_JPRB, 0.36330296E-10_JPRB, 0.36137090E-10_JPRB /)

RGHG8(:, 6, 8) = (/ &
  & 0.40791252E-10_JPRB, 0.41068683E-10_JPRB, 0.41220350E-10_JPRB, 0.41335241E-10_JPRB, 0.41431109E-10_JPRB, 0.41524381E-10_JPRB, &
  & 0.41627316E-10_JPRB, 0.41745791E-10_JPRB, 0.41887264E-10_JPRB, 0.42055803E-10_JPRB, 0.42252625E-10_JPRB, 0.42478354E-10_JPRB, &
  & 0.42731665E-10_JPRB, 0.43006682E-10_JPRB, 0.43296443E-10_JPRB, 0.43596068E-10_JPRB, 0.43899627E-10_JPRB, 0.44197375E-10_JPRB, &
  & 0.44481294E-10_JPRB, 0.44752969E-10_JPRB, 0.45018118E-10_JPRB, 0.45279305E-10_JPRB, 0.45533438E-10_JPRB, 0.45772827E-10_JPRB, &
  & 0.45984615E-10_JPRB, 0.46155905E-10_JPRB, 0.46279564E-10_JPRB, 0.46364752E-10_JPRB, 0.46437260E-10_JPRB, 0.46528829E-10_JPRB, &
  & 0.46663211E-10_JPRB, 0.46860862E-10_JPRB, 0.47138651E-10_JPRB, 0.47492024E-10_JPRB, 0.47894338E-10_JPRB, 0.48305301E-10_JPRB, &
  & 0.48688692E-10_JPRB, 0.49021523E-10_JPRB, 0.49281509E-10_JPRB, 0.49438433E-10_JPRB, 0.49449132E-10_JPRB, 0.49276055E-10_JPRB, &
  & 0.48907850E-10_JPRB, 0.48361620E-10_JPRB, 0.47668210E-10_JPRB, 0.46851235E-10_JPRB, 0.45925905E-10_JPRB, 0.44912893E-10_JPRB, &
  & 0.43840129E-10_JPRB, 0.42745966E-10_JPRB, 0.41669064E-10_JPRB, 0.40647482E-10_JPRB, 0.39708251E-10_JPRB, 0.38877401E-10_JPRB, &
  & 0.38172635E-10_JPRB, 0.37598799E-10_JPRB, 0.37144191E-10_JPRB, 0.36811412E-10_JPRB, 0.36554943E-10_JPRB, 0.36363777E-10_JPRB, &
  & 0.36237027E-10_JPRB, 0.36148931E-10_JPRB, 0.36106011E-10_JPRB, 0.36090533E-10_JPRB /)

RGHG8(:, 7, 8) = (/ &
  & 0.41202722E-10_JPRB, 0.41635990E-10_JPRB, 0.41873588E-10_JPRB, 0.42048053E-10_JPRB, 0.42197149E-10_JPRB, 0.42336867E-10_JPRB, &
  & 0.42484238E-10_JPRB, 0.42650324E-10_JPRB, 0.42843319E-10_JPRB, 0.43070440E-10_JPRB, 0.43335596E-10_JPRB, 0.43640435E-10_JPRB, &
  & 0.43983952E-10_JPRB, 0.44359620E-10_JPRB, 0.44755019E-10_JPRB, 0.45153735E-10_JPRB, 0.45546227E-10_JPRB, 0.45932251E-10_JPRB, &
  & 0.46311732E-10_JPRB, 0.46684226E-10_JPRB, 0.47054246E-10_JPRB, 0.47430299E-10_JPRB, 0.47816241E-10_JPRB, 0.48206918E-10_JPRB, &
  & 0.48585132E-10_JPRB, 0.48922429E-10_JPRB, 0.49188167E-10_JPRB, 0.49368391E-10_JPRB, 0.49478921E-10_JPRB, 0.49554701E-10_JPRB, &
  & 0.49648882E-10_JPRB, 0.49842647E-10_JPRB, 0.50206291E-10_JPRB, 0.50751424E-10_JPRB, 0.51445268E-10_JPRB, 0.52224100E-10_JPRB, &
  & 0.53021927E-10_JPRB, 0.53784532E-10_JPRB, 0.54462594E-10_JPRB, 0.54996320E-10_JPRB, 0.55314114E-10_JPRB, 0.55346817E-10_JPRB, &
  & 0.55068179E-10_JPRB, 0.54497695E-10_JPRB, 0.53669132E-10_JPRB, 0.52606246E-10_JPRB, 0.51330211E-10_JPRB, 0.49865657E-10_JPRB, &
  & 0.48251306E-10_JPRB, 0.46548050E-10_JPRB, 0.44828200E-10_JPRB, 0.43158029E-10_JPRB, 0.41595935E-10_JPRB, 0.40184883E-10_JPRB, &
  & 0.38961282E-10_JPRB, 0.37944026E-10_JPRB, 0.37134608E-10_JPRB, 0.36507259E-10_JPRB, 0.36062531E-10_JPRB, 0.35748720E-10_JPRB, &
  & 0.35533302E-10_JPRB, 0.35418495E-10_JPRB, 0.35415389E-10_JPRB, 0.35563264E-10_JPRB /)

RGHG8(:, 8, 8) = (/ &
  & 0.41844955E-10_JPRB, 0.42457707E-10_JPRB, 0.42779280E-10_JPRB, 0.43022093E-10_JPRB, 0.43225763E-10_JPRB, 0.43416579E-10_JPRB, &
  & 0.43610126E-10_JPRB, 0.43819171E-10_JPRB, 0.44054704E-10_JPRB, 0.44326154E-10_JPRB, 0.44639820E-10_JPRB, 0.44998734E-10_JPRB, &
  & 0.45399032E-10_JPRB, 0.45830294E-10_JPRB, 0.46278082E-10_JPRB, 0.46729624E-10_JPRB, 0.47173068E-10_JPRB, 0.47602429E-10_JPRB, &
  & 0.48024019E-10_JPRB, 0.48452117E-10_JPRB, 0.48899759E-10_JPRB, 0.49384320E-10_JPRB, 0.49924728E-10_JPRB, 0.50525362E-10_JPRB, &
  & 0.51161086E-10_JPRB, 0.51781447E-10_JPRB, 0.52327608E-10_JPRB, 0.52756650E-10_JPRB, 0.53049128E-10_JPRB, 0.53230097E-10_JPRB, &
  & 0.53391361E-10_JPRB, 0.53660298E-10_JPRB, 0.54130093E-10_JPRB, 0.54835161E-10_JPRB, 0.55767332E-10_JPRB, 0.56876726E-10_JPRB, &
  & 0.58077161E-10_JPRB, 0.59278582E-10_JPRB, 0.60395244E-10_JPRB, 0.61328470E-10_JPRB, 0.61970741E-10_JPRB, 0.62236917E-10_JPRB, &
  & 0.62083422E-10_JPRB, 0.61517839E-10_JPRB, 0.60570875E-10_JPRB, 0.59271914E-10_JPRB, 0.57641829E-10_JPRB, 0.55711390E-10_JPRB, &
  & 0.53539291E-10_JPRB, 0.51210008E-10_JPRB, 0.48823296E-10_JPRB, 0.46469988E-10_JPRB, 0.44229100E-10_JPRB, 0.42167558E-10_JPRB, &
  & 0.40334298E-10_JPRB, 0.38763607E-10_JPRB, 0.37463959E-10_JPRB, 0.36439310E-10_JPRB, 0.35654559E-10_JPRB, 0.35094056E-10_JPRB, &
  & 0.34723346E-10_JPRB, 0.34496739E-10_JPRB, 0.34428953E-10_JPRB, 0.34594241E-10_JPRB /)

RGHG8(:, 9, 8) = (/ &
  & 0.42834368E-10_JPRB, 0.43642538E-10_JPRB, 0.44042381E-10_JPRB, 0.44352515E-10_JPRB, 0.44615100E-10_JPRB, 0.44859189E-10_JPRB, &
  & 0.45098592E-10_JPRB, 0.45342397E-10_JPRB, 0.45602466E-10_JPRB, 0.45890014E-10_JPRB, 0.46213512E-10_JPRB, 0.46575917E-10_JPRB, &
  & 0.46976024E-10_JPRB, 0.47405850E-10_JPRB, 0.47853228E-10_JPRB, 0.48304832E-10_JPRB, 0.48754261E-10_JPRB, 0.49202361E-10_JPRB, &
  & 0.49653892E-10_JPRB, 0.50124210E-10_JPRB, 0.50638368E-10_JPRB, 0.51221253E-10_JPRB, 0.51898191E-10_JPRB, 0.52701055E-10_JPRB, &
  & 0.53633698E-10_JPRB, 0.54648560E-10_JPRB, 0.55665802E-10_JPRB, 0.56590056E-10_JPRB, 0.57360672E-10_JPRB, 0.57991424E-10_JPRB, &
  & 0.58546126E-10_JPRB, 0.59111598E-10_JPRB, 0.59786370E-10_JPRB, 0.60655182E-10_JPRB, 0.61757932E-10_JPRB, 0.63071784E-10_JPRB, &
  & 0.64531346E-10_JPRB, 0.66034282E-10_JPRB, 0.67454917E-10_JPRB, 0.68656227E-10_JPRB, 0.69511751E-10_JPRB, 0.69919556E-10_JPRB, &
  & 0.69816382E-10_JPRB, 0.69202241E-10_JPRB, 0.68103294E-10_JPRB, 0.66541772E-10_JPRB, 0.64547007E-10_JPRB, 0.62168520E-10_JPRB, &
  & 0.59486784E-10_JPRB, 0.56611865E-10_JPRB, 0.53655885E-10_JPRB, 0.50723550E-10_JPRB, 0.47901877E-10_JPRB, 0.45263251E-10_JPRB, &
  & 0.42873250E-10_JPRB, 0.40777402E-10_JPRB, 0.38997649E-10_JPRB, 0.37534677E-10_JPRB, 0.36370774E-10_JPRB, 0.35473791E-10_JPRB, &
  & 0.34803303E-10_JPRB, 0.34314631E-10_JPRB, 0.33988735E-10_JPRB, 0.33791650E-10_JPRB /)

RGHG8(:,10, 8) = (/ &
  & 0.44332208E-10_JPRB, 0.45253128E-10_JPRB, 0.45752430E-10_JPRB, 0.46099180E-10_JPRB, 0.46410785E-10_JPRB, 0.46697424E-10_JPRB, &
  & 0.46975104E-10_JPRB, 0.47247872E-10_JPRB, 0.47522410E-10_JPRB, 0.47808785E-10_JPRB, 0.48115092E-10_JPRB, 0.48446254E-10_JPRB, &
  & 0.48803479E-10_JPRB, 0.49183504E-10_JPRB, 0.49580652E-10_JPRB, 0.49989443E-10_JPRB, 0.50405652E-10_JPRB, 0.50830663E-10_JPRB, &
  & 0.51274218E-10_JPRB, 0.51757581E-10_JPRB, 0.52313584E-10_JPRB, 0.52994675E-10_JPRB, 0.53869718E-10_JPRB, 0.54998402E-10_JPRB, &
  & 0.56398306E-10_JPRB, 0.58021775E-10_JPRB, 0.59770723E-10_JPRB, 0.61546095E-10_JPRB, 0.63285960E-10_JPRB, 0.64937618E-10_JPRB, &
  & 0.66438584E-10_JPRB, 0.67766487E-10_JPRB, 0.68983007E-10_JPRB, 0.70190562E-10_JPRB, 0.71479767E-10_JPRB, 0.72877669E-10_JPRB, &
  & 0.74340187E-10_JPRB, 0.75771056E-10_JPRB, 0.77051615E-10_JPRB, 0.78046118E-10_JPRB, 0.78660953E-10_JPRB, 0.78791793E-10_JPRB, &
  & 0.78403346E-10_JPRB, 0.77492443E-10_JPRB, 0.76059888E-10_JPRB, 0.74131923E-10_JPRB, 0.71743229E-10_JPRB, 0.68960726E-10_JPRB, &
  & 0.65878331E-10_JPRB, 0.62615191E-10_JPRB, 0.59298795E-10_JPRB, 0.56024314E-10_JPRB, 0.52873407E-10_JPRB, 0.49917674E-10_JPRB, &
  & 0.47220748E-10_JPRB, 0.44834681E-10_JPRB, 0.42787333E-10_JPRB, 0.41080386E-10_JPRB, 0.39712723E-10_JPRB, 0.38644189E-10_JPRB, &
  & 0.37835401E-10_JPRB, 0.37186164E-10_JPRB, 0.36637561E-10_JPRB, 0.35817703E-10_JPRB /)

RGHG8(:,11, 8) = (/ &
  & 0.46204374E-10_JPRB, 0.47214309E-10_JPRB, 0.47648902E-10_JPRB, 0.48004808E-10_JPRB, 0.48297276E-10_JPRB, 0.48586114E-10_JPRB, &
  & 0.48871959E-10_JPRB, 0.49159454E-10_JPRB, 0.49449091E-10_JPRB, 0.49744171E-10_JPRB, 0.50047820E-10_JPRB, 0.50362579E-10_JPRB, &
  & 0.50689758E-10_JPRB, 0.51029646E-10_JPRB, 0.51381698E-10_JPRB, 0.51745837E-10_JPRB, 0.52124950E-10_JPRB, 0.52527295E-10_JPRB, &
  & 0.52967335E-10_JPRB, 0.53470544E-10_JPRB, 0.54080938E-10_JPRB, 0.54867295E-10_JPRB, 0.55918430E-10_JPRB, 0.57339848E-10_JPRB, &
  & 0.59193137E-10_JPRB, 0.61465263E-10_JPRB, 0.64075689E-10_JPRB, 0.66990261E-10_JPRB, 0.70139922E-10_JPRB, 0.73370650E-10_JPRB, &
  & 0.76482896E-10_JPRB, 0.79299858E-10_JPRB, 0.81730192E-10_JPRB, 0.83779865E-10_JPRB, 0.85487686E-10_JPRB, 0.86905580E-10_JPRB, &
  & 0.88029035E-10_JPRB, 0.88872597E-10_JPRB, 0.89374563E-10_JPRB, 0.89531986E-10_JPRB, 0.89292254E-10_JPRB, 0.88638485E-10_JPRB, &
  & 0.87567731E-10_JPRB, 0.86048328E-10_JPRB, 0.84088077E-10_JPRB, 0.81702083E-10_JPRB, 0.78925394E-10_JPRB, 0.75821252E-10_JPRB, &
  & 0.72494608E-10_JPRB, 0.69077077E-10_JPRB, 0.65670122E-10_JPRB, 0.62360228E-10_JPRB, 0.59215292E-10_JPRB, 0.56293081E-10_JPRB, &
  & 0.53646566E-10_JPRB, 0.51323369E-10_JPRB, 0.49345462E-10_JPRB, 0.47720595E-10_JPRB, 0.46448914E-10_JPRB, 0.45482187E-10_JPRB, &
  & 0.44810069E-10_JPRB, 0.44289291E-10_JPRB, 0.43976902E-10_JPRB, 0.43460024E-10_JPRB /)

RGHG8(:,12, 8) = (/ &
  & 0.47949165E-10_JPRB, 0.48575040E-10_JPRB, 0.48877544E-10_JPRB, 0.49087689E-10_JPRB, 0.49303041E-10_JPRB, 0.49527698E-10_JPRB, &
  & 0.49781141E-10_JPRB, 0.50060900E-10_JPRB, 0.50363470E-10_JPRB, 0.50686060E-10_JPRB, 0.51028931E-10_JPRB, 0.51393098E-10_JPRB, &
  & 0.51782745E-10_JPRB, 0.52200785E-10_JPRB, 0.52649302E-10_JPRB, 0.53128058E-10_JPRB, 0.53635742E-10_JPRB, 0.54174859E-10_JPRB, &
  & 0.54757220E-10_JPRB, 0.55409424E-10_JPRB, 0.56184127E-10_JPRB, 0.57164419E-10_JPRB, 0.58467974E-10_JPRB, 0.60214361E-10_JPRB, &
  & 0.62494912E-10_JPRB, 0.65328118E-10_JPRB, 0.68719259E-10_JPRB, 0.72529441E-10_JPRB, 0.76667069E-10_JPRB, 0.81119028E-10_JPRB, &
  & 0.85664184E-10_JPRB, 0.89889256E-10_JPRB, 0.93491791E-10_JPRB, 0.96366984E-10_JPRB, 0.98511276E-10_JPRB, 0.99994638E-10_JPRB, &
  & 0.10085387E-09_JPRB, 0.10118596E-09_JPRB, 0.10099535E-09_JPRB, 0.10038205E-09_JPRB, 0.99354046E-10_JPRB, 0.97948899E-10_JPRB, &
  & 0.96172639E-10_JPRB, 0.94055139E-10_JPRB, 0.91594676E-10_JPRB, 0.88811021E-10_JPRB, 0.85750074E-10_JPRB, 0.82495337E-10_JPRB, &
  & 0.79155710E-10_JPRB, 0.75829648E-10_JPRB, 0.72615643E-10_JPRB, 0.69578281E-10_JPRB, 0.66758314E-10_JPRB, 0.64189057E-10_JPRB, &
  & 0.61903545E-10_JPRB, 0.59925148E-10_JPRB, 0.58269438E-10_JPRB, 0.56940588E-10_JPRB, 0.55945203E-10_JPRB, 0.55231510E-10_JPRB, &
  & 0.54824430E-10_JPRB, 0.54555263E-10_JPRB, 0.54621092E-10_JPRB, 0.54736268E-10_JPRB /)

RGHG8(:,13, 8) = (/ &
  & 0.48363494E-10_JPRB, 0.48324723E-10_JPRB, 0.48356808E-10_JPRB, 0.48455621E-10_JPRB, 0.48620372E-10_JPRB, 0.48872104E-10_JPRB, &
  & 0.49211694E-10_JPRB, 0.49647030E-10_JPRB, 0.50182920E-10_JPRB, 0.50831273E-10_JPRB, 0.51610015E-10_JPRB, 0.52530778E-10_JPRB, &
  & 0.53590528E-10_JPRB, 0.54755724E-10_JPRB, 0.55973871E-10_JPRB, 0.57158112E-10_JPRB, 0.58245173E-10_JPRB, 0.59177004E-10_JPRB, &
  & 0.59971618E-10_JPRB, 0.60689620E-10_JPRB, 0.61432207E-10_JPRB, 0.62325825E-10_JPRB, 0.63517559E-10_JPRB, 0.65157296E-10_JPRB, &
  & 0.67355024E-10_JPRB, 0.70169828E-10_JPRB, 0.73626112E-10_JPRB, 0.77819175E-10_JPRB, 0.82662384E-10_JPRB, 0.87829716E-10_JPRB, &
  & 0.93060427E-10_JPRB, 0.97977571E-10_JPRB, 0.10220023E-09_JPRB, 0.10554553E-09_JPRB, 0.10799181E-09_JPRB, 0.10958305E-09_JPRB, &
  & 0.11038272E-09_JPRB, 0.11048189E-09_JPRB, 0.10996604E-09_JPRB, 0.10893524E-09_JPRB, 0.10745826E-09_JPRB, 0.10560927E-09_JPRB, &
  & 0.10343181E-09_JPRB, 0.10095334E-09_JPRB, 0.98213312E-10_JPRB, 0.95252771E-10_JPRB, 0.92139366E-10_JPRB, 0.88955981E-10_JPRB, &
  & 0.85805731E-10_JPRB, 0.82800967E-10_JPRB, 0.80002935E-10_JPRB, 0.77447909E-10_JPRB, 0.75149921E-10_JPRB, 0.73114820E-10_JPRB, &
  & 0.71345881E-10_JPRB, 0.69846635E-10_JPRB, 0.68617306E-10_JPRB, 0.67657574E-10_JPRB, 0.66979484E-10_JPRB, 0.66528158E-10_JPRB, &
  & 0.66365365E-10_JPRB, 0.66321171E-10_JPRB, 0.66665465E-10_JPRB, 0.67304634E-10_JPRB /)

RGHG8(:,14, 8) = (/ &
  & 0.47851317E-10_JPRB, 0.47984363E-10_JPRB, 0.48236963E-10_JPRB, 0.48550414E-10_JPRB, 0.48966494E-10_JPRB, 0.49516405E-10_JPRB, &
  & 0.50260577E-10_JPRB, 0.51248124E-10_JPRB, 0.52526587E-10_JPRB, 0.54134287E-10_JPRB, 0.56079349E-10_JPRB, 0.58319662E-10_JPRB, &
  & 0.60732058E-10_JPRB, 0.63116651E-10_JPRB, 0.65269477E-10_JPRB, 0.67055368E-10_JPRB, 0.68432517E-10_JPRB, 0.69440349E-10_JPRB, &
  & 0.70149629E-10_JPRB, 0.70662864E-10_JPRB, 0.71084333E-10_JPRB, 0.71550536E-10_JPRB, 0.72222353E-10_JPRB, 0.73280090E-10_JPRB, &
  & 0.74886437E-10_JPRB, 0.77191996E-10_JPRB, 0.80281608E-10_JPRB, 0.84127177E-10_JPRB, 0.88748099E-10_JPRB, 0.93966203E-10_JPRB, &
  & 0.99317325E-10_JPRB, 0.10440182E-09_JPRB, 0.10884471E-09_JPRB, 0.11242546E-09_JPRB, 0.11505684E-09_JPRB, 0.11673322E-09_JPRB, &
  & 0.11752219E-09_JPRB, 0.11752251E-09_JPRB, 0.11685379E-09_JPRB, 0.11563277E-09_JPRB, 0.11395724E-09_JPRB, 0.11191618E-09_JPRB, &
  & 0.10957653E-09_JPRB, 0.10699321E-09_JPRB, 0.10421769E-09_JPRB, 0.10130963E-09_JPRB, 0.98347684E-10_JPRB, 0.95438282E-10_JPRB, &
  & 0.92683014E-10_JPRB, 0.90148736E-10_JPRB, 0.87874659E-10_JPRB, 0.85867459E-10_JPRB, 0.84115125E-10_JPRB, 0.82600253E-10_JPRB, &
  & 0.81309556E-10_JPRB, 0.80232460E-10_JPRB, 0.79365063E-10_JPRB, 0.78708588E-10_JPRB, 0.78270515E-10_JPRB, 0.78018786E-10_JPRB, &
  & 0.78006823E-10_JPRB, 0.78112392E-10_JPRB, 0.78590606E-10_JPRB, 0.79541693E-10_JPRB /)

RGHG8(:,15, 8) = (/ &
  & 0.51025673E-10_JPRB, 0.52744965E-10_JPRB, 0.53568781E-10_JPRB, 0.54131512E-10_JPRB, 0.54685173E-10_JPRB, 0.55388871E-10_JPRB, &
  & 0.56371085E-10_JPRB, 0.57742942E-10_JPRB, 0.59566310E-10_JPRB, 0.61839929E-10_JPRB, 0.64486388E-10_JPRB, 0.67348190E-10_JPRB, &
  & 0.70234811E-10_JPRB, 0.72952373E-10_JPRB, 0.75334461E-10_JPRB, 0.77277088E-10_JPRB, 0.78768381E-10_JPRB, 0.79862658E-10_JPRB, &
  & 0.80655711E-10_JPRB, 0.81244809E-10_JPRB, 0.81728700E-10_JPRB, 0.82206082E-10_JPRB, 0.82790455E-10_JPRB, 0.83621242E-10_JPRB, &
  & 0.84858218E-10_JPRB, 0.86651249E-10_JPRB, 0.89169352E-10_JPRB, 0.92496684E-10_JPRB, 0.96550629E-10_JPRB, 0.10120110E-09_JPRB, &
  & 0.10612117E-09_JPRB, 0.11088281E-09_JPRB, 0.11512288E-09_JPRB, 0.11859104E-09_JPRB, 0.12112480E-09_JPRB, 0.12272228E-09_JPRB, &
  & 0.12343401E-09_JPRB, 0.12336186E-09_JPRB, 0.12264016E-09_JPRB, 0.12139337E-09_JPRB, 0.11972662E-09_JPRB, 0.11772046E-09_JPRB, &
  & 0.11544727E-09_JPRB, 0.11296671E-09_JPRB, 0.11034652E-09_JPRB, 0.10767184E-09_JPRB, 0.10503393E-09_JPRB, 0.10252351E-09_JPRB, &
  & 0.10021883E-09_JPRB, 0.98168584E-10_JPRB, 0.96382631E-10_JPRB, 0.94841079E-10_JPRB, 0.93513211E-10_JPRB, 0.92370847E-10_JPRB, &
  & 0.91396363E-10_JPRB, 0.90581355E-10_JPRB, 0.89927642E-10_JPRB, 0.89441489E-10_JPRB, 0.89129822E-10_JPRB, 0.88984459E-10_JPRB, &
  & 0.89029749E-10_JPRB, 0.89211423E-10_JPRB, 0.89714208E-10_JPRB, 0.90781299E-10_JPRB /)

RGHG8(:,16, 8) = (/ &
  & 0.63592236E-10_JPRB, 0.65676790E-10_JPRB, 0.66174816E-10_JPRB, 0.66226170E-10_JPRB, 0.66251095E-10_JPRB, 0.66410953E-10_JPRB, &
  & 0.66917145E-10_JPRB, 0.67896265E-10_JPRB, 0.69425965E-10_JPRB, 0.71496656E-10_JPRB, 0.74016897E-10_JPRB, 0.76845405E-10_JPRB, &
  & 0.79774562E-10_JPRB, 0.82594570E-10_JPRB, 0.85142254E-10_JPRB, 0.87326694E-10_JPRB, 0.89130169E-10_JPRB, 0.90587676E-10_JPRB, &
  & 0.91763201E-10_JPRB, 0.92741537E-10_JPRB, 0.93603708E-10_JPRB, 0.94429700E-10_JPRB, 0.95303321E-10_JPRB, 0.96325038E-10_JPRB, &
  & 0.97610676E-10_JPRB, 0.99289681E-10_JPRB, 0.10146556E-09_JPRB, 0.10422015E-09_JPRB, 0.10753835E-09_JPRB, 0.11127019E-09_JPRB, &
  & 0.11519982E-09_JPRB, 0.11900364E-09_JPRB, 0.12238584E-09_JPRB, 0.12512485E-09_JPRB, 0.12711068E-09_JPRB, 0.12831418E-09_JPRB, &
  & 0.12877924E-09_JPRB, 0.12862529E-09_JPRB, 0.12796503E-09_JPRB, 0.12689155E-09_JPRB, 0.12547008E-09_JPRB, 0.12375720E-09_JPRB, &
  & 0.12180011E-09_JPRB, 0.11965313E-09_JPRB, 0.11738772E-09_JPRB, 0.11508634E-09_JPRB, 0.11284073E-09_JPRB, 0.11073376E-09_JPRB, &
  & 0.10882662E-09_JPRB, 0.10714295E-09_JPRB, 0.10567114E-09_JPRB, 0.10438302E-09_JPRB, 0.10324917E-09_JPRB, 0.10225001E-09_JPRB, &
  & 0.10137818E-09_JPRB, 0.10063533E-09_JPRB, 0.10003062E-09_JPRB, 0.99576736E-10_JPRB, 0.99281555E-10_JPRB, 0.99148217E-10_JPRB, &
  & 0.99177319E-10_JPRB, 0.99367188E-10_JPRB, 0.99828180E-10_JPRB, 0.10087419E-09_JPRB /)

RGHG8(:,17, 8) = (/ &
  & 0.80950399E-10_JPRB, 0.81092230E-10_JPRB, 0.80464753E-10_JPRB, 0.79786892E-10_JPRB, 0.79038998E-10_JPRB, 0.78513737E-10_JPRB, &
  & 0.78336629E-10_JPRB, 0.78684684E-10_JPRB, 0.79655345E-10_JPRB, 0.81276055E-10_JPRB, 0.83469044E-10_JPRB, 0.86108426E-10_JPRB, &
  & 0.89030783E-10_JPRB, 0.92039508E-10_JPRB, 0.94948667E-10_JPRB, 0.97618059E-10_JPRB, 0.99986533E-10_JPRB, 0.10205662E-09_JPRB, &
  & 0.10386977E-09_JPRB, 0.10548750E-09_JPRB, 0.10698537E-09_JPRB, 0.10844044E-09_JPRB, 0.10992836E-09_JPRB, 0.11152024E-09_JPRB, &
  & 0.11327386E-09_JPRB, 0.11522101E-09_JPRB, 0.11737605E-09_JPRB, 0.11968687E-09_JPRB, 0.12209848E-09_JPRB, 0.12450473E-09_JPRB, &
  & 0.12682320E-09_JPRB, 0.12892967E-09_JPRB, 0.13074357E-09_JPRB, 0.13215425E-09_JPRB, 0.13310281E-09_JPRB, 0.13359366E-09_JPRB, &
  & 0.13371117E-09_JPRB, 0.13349406E-09_JPRB, 0.13299754E-09_JPRB, 0.13226231E-09_JPRB, 0.13129990E-09_JPRB, 0.13011409E-09_JPRB, &
  & 0.12870774E-09_JPRB, 0.12710583E-09_JPRB, 0.12535446E-09_JPRB, 0.12352244E-09_JPRB, 0.12168999E-09_JPRB, 0.11992508E-09_JPRB, &
  & 0.11827758E-09_JPRB, 0.11676519E-09_JPRB, 0.11537935E-09_JPRB, 0.11410559E-09_JPRB, 0.11293446E-09_JPRB, 0.11186885E-09_JPRB, &
  & 0.11091864E-09_JPRB, 0.11009771E-09_JPRB, 0.10942017E-09_JPRB, 0.10889966E-09_JPRB, 0.10854373E-09_JPRB, 0.10835435E-09_JPRB, &
  & 0.10832719E-09_JPRB, 0.10847055E-09_JPRB, 0.10884629E-09_JPRB, 0.10978075E-09_JPRB /)

RGHG8(:,18, 8) = (/ &
  & 0.95105146E-10_JPRB, 0.94039769E-10_JPRB, 0.92717757E-10_JPRB, 0.91632327E-10_JPRB, 0.90419096E-10_JPRB, 0.89474712E-10_JPRB, &
  & 0.88821742E-10_JPRB, 0.88684289E-10_JPRB, 0.89190606E-10_JPRB, 0.90417167E-10_JPRB, 0.92334328E-10_JPRB, 0.94863575E-10_JPRB, &
  & 0.97853545E-10_JPRB, 0.10111771E-09_JPRB, 0.10445411E-09_JPRB, 0.10767489E-09_JPRB, 0.11064479E-09_JPRB, 0.11331696E-09_JPRB, &
  & 0.11572130E-09_JPRB, 0.11792320E-09_JPRB, 0.11999451E-09_JPRB, 0.12200853E-09_JPRB, 0.12403981E-09_JPRB, 0.12614025E-09_JPRB, &
  & 0.12829296E-09_JPRB, 0.13044710E-09_JPRB, 0.13249452E-09_JPRB, 0.13431496E-09_JPRB, 0.13581349E-09_JPRB, 0.13697583E-09_JPRB, &
  & 0.13780685E-09_JPRB, 0.13835215E-09_JPRB, 0.13864053E-09_JPRB, 0.13871961E-09_JPRB, 0.13864418E-09_JPRB, 0.13846545E-09_JPRB, &
  & 0.13821118E-09_JPRB, 0.13792625E-09_JPRB, 0.13762445E-09_JPRB, 0.13727607E-09_JPRB, 0.13682805E-09_JPRB, 0.13622593E-09_JPRB, &
  & 0.13542681E-09_JPRB, 0.13441563E-09_JPRB, 0.13321143E-09_JPRB, 0.13185408E-09_JPRB, 0.13040080E-09_JPRB, 0.12890450E-09_JPRB, &
  & 0.12741055E-09_JPRB, 0.12594550E-09_JPRB, 0.12451942E-09_JPRB, 0.12314527E-09_JPRB, 0.12184068E-09_JPRB, 0.12062916E-09_JPRB, &
  & 0.11953664E-09_JPRB, 0.11858653E-09_JPRB, 0.11779527E-09_JPRB, 0.11717360E-09_JPRB, 0.11672600E-09_JPRB, 0.11645152E-09_JPRB, &
  & 0.11634577E-09_JPRB, 0.11640762E-09_JPRB, 0.11668977E-09_JPRB, 0.11747835E-09_JPRB /)

RGHG8(:,19, 8) = (/ &
  & 0.10542833E-09_JPRB, 0.10389128E-09_JPRB, 0.10242773E-09_JPRB, 0.10120314E-09_JPRB, 0.99920412E-10_JPRB, 0.98799427E-10_JPRB, &
  & 0.97939948E-10_JPRB, 0.97542731E-10_JPRB, 0.97766968E-10_JPRB, 0.98730621E-10_JPRB, 0.10044405E-09_JPRB, 0.10287152E-09_JPRB, &
  & 0.10588853E-09_JPRB, 0.10930266E-09_JPRB, 0.11288281E-09_JPRB, 0.11640067E-09_JPRB, 0.11968199E-09_JPRB, 0.12263769E-09_JPRB, &
  & 0.12526831E-09_JPRB, 0.12765161E-09_JPRB, 0.12988291E-09_JPRB, 0.13204125E-09_JPRB, 0.13418695E-09_JPRB, 0.13635987E-09_JPRB, &
  & 0.13855177E-09_JPRB, 0.14066812E-09_JPRB, 0.14255798E-09_JPRB, 0.14404755E-09_JPRB, 0.14504417E-09_JPRB, 0.14553377E-09_JPRB, &
  & 0.14558894E-09_JPRB, 0.14528784E-09_JPRB, 0.14474232E-09_JPRB, 0.14404006E-09_JPRB, 0.14332453E-09_JPRB, 0.14268700E-09_JPRB, &
  & 0.14218325E-09_JPRB, 0.14186503E-09_JPRB, 0.14172455E-09_JPRB, 0.14168551E-09_JPRB, 0.14164384E-09_JPRB, 0.14150002E-09_JPRB, &
  & 0.14117950E-09_JPRB, 0.14064336E-09_JPRB, 0.13988254E-09_JPRB, 0.13891457E-09_JPRB, 0.13777268E-09_JPRB, 0.13649702E-09_JPRB, &
  & 0.13512975E-09_JPRB, 0.13370467E-09_JPRB, 0.13225268E-09_JPRB, 0.13080804E-09_JPRB, 0.12940855E-09_JPRB, 0.12809408E-09_JPRB, &
  & 0.12689992E-09_JPRB, 0.12585420E-09_JPRB, 0.12497386E-09_JPRB, 0.12426829E-09_JPRB, 0.12373969E-09_JPRB, 0.12338566E-09_JPRB, &
  & 0.12320064E-09_JPRB, 0.12318277E-09_JPRB, 0.12337550E-09_JPRB, 0.12400088E-09_JPRB /)

RGHG8(:,20, 8) = (/ &
  & 0.11315441E-09_JPRB, 0.11152473E-09_JPRB, 0.11016182E-09_JPRB, 0.10894995E-09_JPRB, 0.10776818E-09_JPRB, 0.10665116E-09_JPRB, &
  & 0.10576251E-09_JPRB, 0.10526611E-09_JPRB, 0.10534153E-09_JPRB, 0.10611763E-09_JPRB, 0.10764511E-09_JPRB, 0.10990824E-09_JPRB, &
  & 0.11279607E-09_JPRB, 0.11612289E-09_JPRB, 0.11965115E-09_JPRB, 0.12313443E-09_JPRB, 0.12638349E-09_JPRB, 0.12930856E-09_JPRB, &
  & 0.13191172E-09_JPRB, 0.13424042E-09_JPRB, 0.13638539E-09_JPRB, 0.13843757E-09_JPRB, 0.14046002E-09_JPRB, 0.14249374E-09_JPRB, &
  & 0.14452775E-09_JPRB, 0.14647449E-09_JPRB, 0.14818044E-09_JPRB, 0.14948509E-09_JPRB, 0.15028834E-09_JPRB, 0.15058514E-09_JPRB, &
  & 0.15042587E-09_JPRB, 0.14988409E-09_JPRB, 0.14907053E-09_JPRB, 0.14809647E-09_JPRB, 0.14710569E-09_JPRB, 0.14625172E-09_JPRB, &
  & 0.14567260E-09_JPRB, 0.14538518E-09_JPRB, 0.14534011E-09_JPRB, 0.14546661E-09_JPRB, 0.14564805E-09_JPRB, 0.14576655E-09_JPRB, &
  & 0.14573308E-09_JPRB, 0.14549227E-09_JPRB, 0.14502131E-09_JPRB, 0.14432097E-09_JPRB, 0.14340976E-09_JPRB, 0.14231574E-09_JPRB, &
  & 0.14107626E-09_JPRB, 0.13972949E-09_JPRB, 0.13831809E-09_JPRB, 0.13688702E-09_JPRB, 0.13548210E-09_JPRB, 0.13415127E-09_JPRB, &
  & 0.13293382E-09_JPRB, 0.13185771E-09_JPRB, 0.13093886E-09_JPRB, 0.13018722E-09_JPRB, 0.12960616E-09_JPRB, 0.12919510E-09_JPRB, &
  & 0.12894791E-09_JPRB, 0.12885963E-09_JPRB, 0.12895850E-09_JPRB, 0.12941881E-09_JPRB /)

RGHG8(:,21, 8) = (/ &
  & 0.11932186E-09_JPRB, 0.11769996E-09_JPRB, 0.11649282E-09_JPRB, 0.11539809E-09_JPRB, 0.11430303E-09_JPRB, 0.11328512E-09_JPRB, &
  & 0.11243146E-09_JPRB, 0.11191884E-09_JPRB, 0.11191024E-09_JPRB, 0.11253554E-09_JPRB, 0.11385815E-09_JPRB, 0.11587505E-09_JPRB, &
  & 0.11849267E-09_JPRB, 0.12153813E-09_JPRB, 0.12479172E-09_JPRB, 0.12802667E-09_JPRB, 0.13106087E-09_JPRB, 0.13379374E-09_JPRB, &
  & 0.13621854E-09_JPRB, 0.13839456E-09_JPRB, 0.14038687E-09_JPRB, 0.14227938E-09_JPRB, 0.14414037E-09_JPRB, 0.14601320E-09_JPRB, &
  & 0.14789271E-09_JPRB, 0.14970433E-09_JPRB, 0.15131074E-09_JPRB, 0.15255747E-09_JPRB, 0.15334956E-09_JPRB, 0.15367357E-09_JPRB, &
  & 0.15355682E-09_JPRB, 0.15306227E-09_JPRB, 0.15228097E-09_JPRB, 0.15133098E-09_JPRB, 0.15035256E-09_JPRB, 0.14950804E-09_JPRB, &
  & 0.14890086E-09_JPRB, 0.14859963E-09_JPRB, 0.14859119E-09_JPRB, 0.14876710E-09_JPRB, 0.14901512E-09_JPRB, 0.14922573E-09_JPRB, &
  & 0.14930920E-09_JPRB, 0.14920508E-09_JPRB, 0.14888499E-09_JPRB, 0.14833840E-09_JPRB, 0.14757273E-09_JPRB, 0.14661217E-09_JPRB, &
  & 0.14549201E-09_JPRB, 0.14425118E-09_JPRB, 0.14292958E-09_JPRB, 0.14157213E-09_JPRB, 0.14023134E-09_JPRB, 0.13895481E-09_JPRB, &
  & 0.13777972E-09_JPRB, 0.13673122E-09_JPRB, 0.13582285E-09_JPRB, 0.13506243E-09_JPRB, 0.13445615E-09_JPRB, 0.13400486E-09_JPRB, &
  & 0.13370791E-09_JPRB, 0.13355869E-09_JPRB, 0.13357510E-09_JPRB, 0.13387136E-09_JPRB /)

RGHG8(:,22, 8) = (/ &
  & 0.12448043E-09_JPRB, 0.12293874E-09_JPRB, 0.12185693E-09_JPRB, 0.12084633E-09_JPRB, 0.11987494E-09_JPRB, 0.11892355E-09_JPRB, &
  & 0.11812290E-09_JPRB, 0.11760704E-09_JPRB, 0.11753561E-09_JPRB, 0.11801915E-09_JPRB, 0.11912840E-09_JPRB, 0.12085749E-09_JPRB, &
  & 0.12312890E-09_JPRB, 0.12579754E-09_JPRB, 0.12867185E-09_JPRB, 0.13155407E-09_JPRB, 0.13428564E-09_JPRB, 0.13677898E-09_JPRB, &
  & 0.13900985E-09_JPRB, 0.14101688E-09_JPRB, 0.14286869E-09_JPRB, 0.14462853E-09_JPRB, 0.14636525E-09_JPRB, 0.14812374E-09_JPRB, &
  & 0.14990954E-09_JPRB, 0.15165635E-09_JPRB, 0.15323526E-09_JPRB, 0.15450098E-09_JPRB, 0.15535973E-09_JPRB, 0.15579042E-09_JPRB, &
  & 0.15581525E-09_JPRB, 0.15548662E-09_JPRB, 0.15487440E-09_JPRB, 0.15409511E-09_JPRB, 0.15327579E-09_JPRB, 0.15254731E-09_JPRB, &
  & 0.15201594E-09_JPRB, 0.15173118E-09_JPRB, 0.15167573E-09_JPRB, 0.15179594E-09_JPRB, 0.15198601E-09_JPRB, 0.15215970E-09_JPRB, &
  & 0.15222645E-09_JPRB, 0.15213641E-09_JPRB, 0.15185618E-09_JPRB, 0.15136882E-09_JPRB, 0.15068011E-09_JPRB, 0.14980962E-09_JPRB, &
  & 0.14878547E-09_JPRB, 0.14764219E-09_JPRB, 0.14642082E-09_JPRB, 0.14516793E-09_JPRB, 0.14392923E-09_JPRB, 0.14274631E-09_JPRB, &
  & 0.14165073E-09_JPRB, 0.14066298E-09_JPRB, 0.13979472E-09_JPRB, 0.13905421E-09_JPRB, 0.13844631E-09_JPRB, 0.13797603E-09_JPRB, &
  & 0.13764272E-09_JPRB, 0.13744342E-09_JPRB, 0.13738684E-09_JPRB, 0.13755262E-09_JPRB /)

RGHG8(:,23, 8) = (/ &
  & 0.12895773E-09_JPRB, 0.12747126E-09_JPRB, 0.12648715E-09_JPRB, 0.12557561E-09_JPRB, 0.12465831E-09_JPRB, 0.12378368E-09_JPRB, &
  & 0.12301325E-09_JPRB, 0.12249278E-09_JPRB, 0.12235850E-09_JPRB, 0.12271203E-09_JPRB, 0.12361259E-09_JPRB, 0.12505558E-09_JPRB, &
  & 0.12697368E-09_JPRB, 0.12924728E-09_JPRB, 0.13172403E-09_JPRB, 0.13424091E-09_JPRB, 0.13666226E-09_JPRB, 0.13890634E-09_JPRB, &
  & 0.14095396E-09_JPRB, 0.14282255E-09_JPRB, 0.14456242E-09_JPRB, 0.14623555E-09_JPRB, 0.14789958E-09_JPRB, 0.14959599E-09_JPRB, &
  & 0.15133472E-09_JPRB, 0.15304365E-09_JPRB, 0.15461236E-09_JPRB, 0.15590654E-09_JPRB, 0.15684766E-09_JPRB, 0.15740945E-09_JPRB, &
  & 0.15760701E-09_JPRB, 0.15748382E-09_JPRB, 0.15710301E-09_JPRB, 0.15656251E-09_JPRB, 0.15595465E-09_JPRB, 0.15540703E-09_JPRB, &
  & 0.15498232E-09_JPRB, 0.15471679E-09_JPRB, 0.15462827E-09_JPRB, 0.15464285E-09_JPRB, 0.15470353E-09_JPRB, 0.15474738E-09_JPRB, &
  & 0.15471403E-09_JPRB, 0.15455164E-09_JPRB, 0.15422906E-09_JPRB, 0.15373416E-09_JPRB, 0.15306234E-09_JPRB, 0.15223131E-09_JPRB, &
  & 0.15127148E-09_JPRB, 0.15021683E-09_JPRB, 0.14910034E-09_JPRB, 0.14795994E-09_JPRB, 0.14683381E-09_JPRB, 0.14575760E-09_JPRB, &
  & 0.14475510E-09_JPRB, 0.14384202E-09_JPRB, 0.14302824E-09_JPRB, 0.14232082E-09_JPRB, 0.14172762E-09_JPRB, 0.14125275E-09_JPRB, &
  & 0.14090011E-09_JPRB, 0.14066449E-09_JPRB, 0.14054249E-09_JPRB, 0.14055745E-09_JPRB /)

RGHG8(:,24, 8) = (/ &
  & 0.13283352E-09_JPRB, 0.13146682E-09_JPRB, 0.13055243E-09_JPRB, 0.12970804E-09_JPRB, 0.12886731E-09_JPRB, 0.12803525E-09_JPRB, &
  & 0.12729773E-09_JPRB, 0.12677269E-09_JPRB, 0.12658180E-09_JPRB, 0.12682085E-09_JPRB, 0.12753776E-09_JPRB, 0.12872463E-09_JPRB, &
  & 0.13032571E-09_JPRB, 0.13224633E-09_JPRB, 0.13436423E-09_JPRB, 0.13655169E-09_JPRB, 0.13869757E-09_JPRB, 0.14072754E-09_JPRB, &
  & 0.14261378E-09_JPRB, 0.14437282E-09_JPRB, 0.14603592E-09_JPRB, 0.14765035E-09_JPRB, 0.14926362E-09_JPRB, 0.15090837E-09_JPRB, &
  & 0.15258678E-09_JPRB, 0.15424734E-09_JPRB, 0.15578111E-09_JPRB, 0.15708412E-09_JPRB, 0.15807558E-09_JPRB, 0.15874085E-09_JPRB, &
  & 0.15909826E-09_JPRB, 0.15918172E-09_JPRB, 0.15904796E-09_JPRB, 0.15876364E-09_JPRB, 0.15840905E-09_JPRB, 0.15805177E-09_JPRB, &
  & 0.15774648E-09_JPRB, 0.15751979E-09_JPRB, 0.15736133E-09_JPRB, 0.15725818E-09_JPRB, 0.15716112E-09_JPRB, 0.15704520E-09_JPRB, &
  & 0.15685851E-09_JPRB, 0.15658011E-09_JPRB, 0.15617159E-09_JPRB, 0.15562281E-09_JPRB, 0.15493688E-09_JPRB, 0.15412947E-09_JPRB, &
  & 0.15322270E-09_JPRB, 0.15224082E-09_JPRB, 0.15121436E-09_JPRB, 0.15017559E-09_JPRB, 0.14915837E-09_JPRB, 0.14818724E-09_JPRB, &
  & 0.14727931E-09_JPRB, 0.14644573E-09_JPRB, 0.14569362E-09_JPRB, 0.14502924E-09_JPRB, 0.14445908E-09_JPRB, 0.14398985E-09_JPRB, &
  & 0.14362563E-09_JPRB, 0.14336388E-09_JPRB, 0.14319633E-09_JPRB, 0.14310995E-09_JPRB /)

RGHG8(:,25, 8) = (/ &
  & 0.13618333E-09_JPRB, 0.13494492E-09_JPRB, 0.13414010E-09_JPRB, 0.13337598E-09_JPRB, 0.13261356E-09_JPRB, 0.13184843E-09_JPRB, &
  & 0.13115739E-09_JPRB, 0.13064164E-09_JPRB, 0.13041650E-09_JPRB, 0.13056811E-09_JPRB, 0.13113788E-09_JPRB, 0.13211882E-09_JPRB, &
  & 0.13346640E-09_JPRB, 0.13510436E-09_JPRB, 0.13693909E-09_JPRB, 0.13886542E-09_JPRB, 0.14079124E-09_JPRB, 0.14264907E-09_JPRB, &
  & 0.14440821E-09_JPRB, 0.14607100E-09_JPRB, 0.14766094E-09_JPRB, 0.14921198E-09_JPRB, 0.15075538E-09_JPRB, 0.15231787E-09_JPRB, &
  & 0.15389200E-09_JPRB, 0.15543412E-09_JPRB, 0.15686907E-09_JPRB, 0.15811136E-09_JPRB, 0.15911980E-09_JPRB, 0.15986462E-09_JPRB, &
  & 0.16035212E-09_JPRB, 0.16061193E-09_JPRB, 0.16068957E-09_JPRB, 0.16063210E-09_JPRB, 0.16049005E-09_JPRB, 0.16030416E-09_JPRB, &
  & 0.16010604E-09_JPRB, 0.15991304E-09_JPRB, 0.15970614E-09_JPRB, 0.15950656E-09_JPRB, 0.15927448E-09_JPRB, 0.15900845E-09_JPRB, &
  & 0.15867525E-09_JPRB, 0.15826819E-09_JPRB, 0.15776433E-09_JPRB, 0.15715308E-09_JPRB, 0.15643369E-09_JPRB, 0.15562666E-09_JPRB, &
  & 0.15475674E-09_JPRB, 0.15384298E-09_JPRB, 0.15290481E-09_JPRB, 0.15196755E-09_JPRB, 0.15105378E-09_JPRB, 0.15018332E-09_JPRB, &
  & 0.14936649E-09_JPRB, 0.14861137E-09_JPRB, 0.14792255E-09_JPRB, 0.14730525E-09_JPRB, 0.14676602E-09_JPRB, 0.14631076E-09_JPRB, &
  & 0.14594491E-09_JPRB, 0.14566466E-09_JPRB, 0.14546006E-09_JPRB, 0.14529646E-09_JPRB /)

RGHG8(:,26, 8) = (/ &
  & 0.13907768E-09_JPRB, 0.13802839E-09_JPRB, 0.13732337E-09_JPRB, 0.13668214E-09_JPRB, 0.13600664E-09_JPRB, 0.13534482E-09_JPRB, &
  & 0.13472387E-09_JPRB, 0.13425125E-09_JPRB, 0.13402533E-09_JPRB, 0.13412726E-09_JPRB, 0.13459606E-09_JPRB, 0.13543172E-09_JPRB, &
  & 0.13659716E-09_JPRB, 0.13803424E-09_JPRB, 0.13966561E-09_JPRB, 0.14140529E-09_JPRB, 0.14316862E-09_JPRB, 0.14489221E-09_JPRB, &
  & 0.14653903E-09_JPRB, 0.14810524E-09_JPRB, 0.14960007E-09_JPRB, 0.15104849E-09_JPRB, 0.15247285E-09_JPRB, 0.15389524E-09_JPRB, &
  & 0.15530725E-09_JPRB, 0.15668172E-09_JPRB, 0.15797447E-09_JPRB, 0.15912618E-09_JPRB, 0.16008686E-09_JPRB, 0.16084585E-09_JPRB, &
  & 0.16140975E-09_JPRB, 0.16179451E-09_JPRB, 0.16202679E-09_JPRB, 0.16213596E-09_JPRB, 0.16215052E-09_JPRB, 0.16209073E-09_JPRB, &
  & 0.16196991E-09_JPRB, 0.16179853E-09_JPRB, 0.16156884E-09_JPRB, 0.16129345E-09_JPRB, 0.16096333E-09_JPRB, 0.16058066E-09_JPRB, &
  & 0.16013853E-09_JPRB, 0.15962905E-09_JPRB, 0.15904446E-09_JPRB, 0.15838211E-09_JPRB, 0.15765056E-09_JPRB, 0.15686244E-09_JPRB, &
  & 0.15603348E-09_JPRB, 0.15517984E-09_JPRB, 0.15431889E-09_JPRB, 0.15346924E-09_JPRB, 0.15264853E-09_JPRB, 0.15186831E-09_JPRB, &
  & 0.15113460E-09_JPRB, 0.15045158E-09_JPRB, 0.14982250E-09_JPRB, 0.14925247E-09_JPRB, 0.14874726E-09_JPRB, 0.14831281E-09_JPRB, &
  & 0.14795372E-09_JPRB, 0.14766678E-09_JPRB, 0.14743747E-09_JPRB, 0.14720575E-09_JPRB /)

RGHG8(:,27, 8) = (/ &
  & 0.14164833E-09_JPRB, 0.14078522E-09_JPRB, 0.14022002E-09_JPRB, 0.13967286E-09_JPRB, 0.13914102E-09_JPRB, 0.13858086E-09_JPRB, &
  & 0.13806860E-09_JPRB, 0.13766914E-09_JPRB, 0.13748080E-09_JPRB, 0.13757580E-09_JPRB, 0.13799495E-09_JPRB, 0.13874125E-09_JPRB, &
  & 0.13979103E-09_JPRB, 0.14109398E-09_JPRB, 0.14258700E-09_JPRB, 0.14419244E-09_JPRB, 0.14583246E-09_JPRB, 0.14743910E-09_JPRB, &
  & 0.14897673E-09_JPRB, 0.15042428E-09_JPRB, 0.15179244E-09_JPRB, 0.15309468E-09_JPRB, 0.15434994E-09_JPRB, 0.15558158E-09_JPRB, &
  & 0.15678217E-09_JPRB, 0.15794403E-09_JPRB, 0.15903774E-09_JPRB, 0.16004086E-09_JPRB, 0.16093495E-09_JPRB, 0.16169004E-09_JPRB, &
  & 0.16229559E-09_JPRB, 0.16275688E-09_JPRB, 0.16308667E-09_JPRB, 0.16329928E-09_JPRB, 0.16340870E-09_JPRB, 0.16342332E-09_JPRB, &
  & 0.16334858E-09_JPRB, 0.16318973E-09_JPRB, 0.16294849E-09_JPRB, 0.16262826E-09_JPRB, 0.16224040E-09_JPRB, 0.16178481E-09_JPRB, &
  & 0.16127177E-09_JPRB, 0.16069546E-09_JPRB, 0.16005819E-09_JPRB, 0.15936012E-09_JPRB, 0.15861910E-09_JPRB, 0.15785317E-09_JPRB, &
  & 0.15707707E-09_JPRB, 0.15629541E-09_JPRB, 0.15551634E-09_JPRB, 0.15475440E-09_JPRB, 0.15402120E-09_JPRB, 0.15332435E-09_JPRB, &
  & 0.15266619E-09_JPRB, 0.15204964E-09_JPRB, 0.15147768E-09_JPRB, 0.15095465E-09_JPRB, 0.15048568E-09_JPRB, 0.15007619E-09_JPRB, &
  & 0.14973035E-09_JPRB, 0.14944437E-09_JPRB, 0.14920193E-09_JPRB, 0.14891718E-09_JPRB /)

RGHG8(:,28, 8) = (/ &
  & 0.14400099E-09_JPRB, 0.14331496E-09_JPRB, 0.14285578E-09_JPRB, 0.14244783E-09_JPRB, 0.14201211E-09_JPRB, 0.14159030E-09_JPRB, &
  & 0.14118702E-09_JPRB, 0.14088693E-09_JPRB, 0.14076605E-09_JPRB, 0.14089210E-09_JPRB, 0.14130262E-09_JPRB, 0.14200774E-09_JPRB, &
  & 0.14298618E-09_JPRB, 0.14419940E-09_JPRB, 0.14558883E-09_JPRB, 0.14708618E-09_JPRB, 0.14861228E-09_JPRB, 0.15010586E-09_JPRB, &
  & 0.15152064E-09_JPRB, 0.15283512E-09_JPRB, 0.15405512E-09_JPRB, 0.15518294E-09_JPRB, 0.15625344E-09_JPRB, 0.15727236E-09_JPRB, &
  & 0.15825107E-09_JPRB, 0.15919267E-09_JPRB, 0.16009470E-09_JPRB, 0.16094784E-09_JPRB, 0.16173973E-09_JPRB, 0.16244625E-09_JPRB, &
  & 0.16305168E-09_JPRB, 0.16354515E-09_JPRB, 0.16392347E-09_JPRB, 0.16418908E-09_JPRB, 0.16434566E-09_JPRB, 0.16439569E-09_JPRB, &
  & 0.16434205E-09_JPRB, 0.16418784E-09_JPRB, 0.16393992E-09_JPRB, 0.16359959E-09_JPRB, 0.16318001E-09_JPRB, 0.16268886E-09_JPRB, &
  & 0.16213617E-09_JPRB, 0.16152732E-09_JPRB, 0.16086675E-09_JPRB, 0.16016688E-09_JPRB, 0.15944440E-09_JPRB, 0.15871882E-09_JPRB, &
  & 0.15799691E-09_JPRB, 0.15728256E-09_JPRB, 0.15657940E-09_JPRB, 0.15589594E-09_JPRB, 0.15524003E-09_JPRB, 0.15461606E-09_JPRB, &
  & 0.15402517E-09_JPRB, 0.15346879E-09_JPRB, 0.15294932E-09_JPRB, 0.15246951E-09_JPRB, 0.15203433E-09_JPRB, 0.15164919E-09_JPRB, &
  & 0.15131900E-09_JPRB, 0.15103976E-09_JPRB, 0.15079281E-09_JPRB, 0.15048787E-09_JPRB /)

RGHG8(:,29, 8) = (/ &
  & 0.14617454E-09_JPRB, 0.14563639E-09_JPRB, 0.14529281E-09_JPRB, 0.14496662E-09_JPRB, 0.14465905E-09_JPRB, 0.14433643E-09_JPRB, &
  & 0.14405226E-09_JPRB, 0.14385430E-09_JPRB, 0.14381635E-09_JPRB, 0.14399527E-09_JPRB, 0.14442608E-09_JPRB, 0.14511592E-09_JPRB, &
  & 0.14605078E-09_JPRB, 0.14719319E-09_JPRB, 0.14849308E-09_JPRB, 0.14988474E-09_JPRB, 0.15129721E-09_JPRB, 0.15266854E-09_JPRB, &
  & 0.15395517E-09_JPRB, 0.15513092E-09_JPRB, 0.15619832E-09_JPRB, 0.15716158E-09_JPRB, 0.15804710E-09_JPRB, 0.15886811E-09_JPRB, &
  & 0.15963986E-09_JPRB, 0.16038249E-09_JPRB, 0.16110283E-09_JPRB, 0.16180766E-09_JPRB, 0.16248956E-09_JPRB, 0.16313381E-09_JPRB, &
  & 0.16371142E-09_JPRB, 0.16420380E-09_JPRB, 0.16459635E-09_JPRB, 0.16488021E-09_JPRB, 0.16505290E-09_JPRB, 0.16511391E-09_JPRB, &
  & 0.16506584E-09_JPRB, 0.16491151E-09_JPRB, 0.16465936E-09_JPRB, 0.16431291E-09_JPRB, 0.16388081E-09_JPRB, 0.16337595E-09_JPRB, &
  & 0.16280874E-09_JPRB, 0.16219014E-09_JPRB, 0.16153093E-09_JPRB, 0.16084814E-09_JPRB, 0.16016172E-09_JPRB, 0.15948601E-09_JPRB, &
  & 0.15882630E-09_JPRB, 0.15817980E-09_JPRB, 0.15754771E-09_JPRB, 0.15693472E-09_JPRB, 0.15634766E-09_JPRB, 0.15578853E-09_JPRB, &
  & 0.15525728E-09_JPRB, 0.15475492E-09_JPRB, 0.15428243E-09_JPRB, 0.15384347E-09_JPRB, 0.15344309E-09_JPRB, 0.15308775E-09_JPRB, &
  & 0.15278061E-09_JPRB, 0.15251669E-09_JPRB, 0.15227559E-09_JPRB, 0.15193982E-09_JPRB /)

RGHG8(:,30, 8) = (/ &
  & 0.14816576E-09_JPRB, 0.14775328E-09_JPRB, 0.14748827E-09_JPRB, 0.14725987E-09_JPRB, 0.14702639E-09_JPRB, 0.14681011E-09_JPRB, &
  & 0.14662292E-09_JPRB, 0.14652367E-09_JPRB, 0.14656949E-09_JPRB, 0.14680912E-09_JPRB, 0.14726943E-09_JPRB, 0.14795806E-09_JPRB, &
  & 0.14885751E-09_JPRB, 0.14993654E-09_JPRB, 0.15114741E-09_JPRB, 0.15243268E-09_JPRB, 0.15372525E-09_JPRB, 0.15497444E-09_JPRB, &
  & 0.15613337E-09_JPRB, 0.15717797E-09_JPRB, 0.15810651E-09_JPRB, 0.15892479E-09_JPRB, 0.15964942E-09_JPRB, 0.16030305E-09_JPRB, &
  & 0.16090640E-09_JPRB, 0.16148179E-09_JPRB, 0.16205065E-09_JPRB, 0.16262393E-09_JPRB, 0.16320209E-09_JPRB, 0.16376943E-09_JPRB, &
  & 0.16430297E-09_JPRB, 0.16477313E-09_JPRB, 0.16515578E-09_JPRB, 0.16543572E-09_JPRB, 0.16560547E-09_JPRB, 0.16566370E-09_JPRB, &
  & 0.16561333E-09_JPRB, 0.16545815E-09_JPRB, 0.16520446E-09_JPRB, 0.16486094E-09_JPRB, 0.16442998E-09_JPRB, 0.16392687E-09_JPRB, &
  & 0.16336382E-09_JPRB, 0.16275571E-09_JPRB, 0.16211885E-09_JPRB, 0.16147021E-09_JPRB, 0.16082885E-09_JPRB, 0.16020719E-09_JPRB, &
  & 0.15960655E-09_JPRB, 0.15902191E-09_JPRB, 0.15845336E-09_JPRB, 0.15790325E-09_JPRB, 0.15737506E-09_JPRB, 0.15687118E-09_JPRB, &
  & 0.15639065E-09_JPRB, 0.15593325E-09_JPRB, 0.15550188E-09_JPRB, 0.15510006E-09_JPRB, 0.15473274E-09_JPRB, 0.15440513E-09_JPRB, &
  & 0.15411945E-09_JPRB, 0.15386983E-09_JPRB, 0.15363204E-09_JPRB, 0.15330329E-09_JPRB /)

RGHG8(:,31, 8) = (/ &
  & 0.14996071E-09_JPRB, 0.14965025E-09_JPRB, 0.14945691E-09_JPRB, 0.14928458E-09_JPRB, 0.14913135E-09_JPRB, 0.14898852E-09_JPRB, &
  & 0.14888982E-09_JPRB, 0.14887683E-09_JPRB, 0.14899913E-09_JPRB, 0.14929505E-09_JPRB, 0.14978582E-09_JPRB, 0.15047123E-09_JPRB, &
  & 0.15133741E-09_JPRB, 0.15235152E-09_JPRB, 0.15347322E-09_JPRB, 0.15464979E-09_JPRB, 0.15582706E-09_JPRB, 0.15695494E-09_JPRB, &
  & 0.15799793E-09_JPRB, 0.15892786E-09_JPRB, 0.15973953E-09_JPRB, 0.16043815E-09_JPRB, 0.16103799E-09_JPRB, 0.16156206E-09_JPRB, &
  & 0.16203536E-09_JPRB, 0.16248350E-09_JPRB, 0.16292986E-09_JPRB, 0.16339310E-09_JPRB, 0.16387769E-09_JPRB, 0.16437128E-09_JPRB, &
  & 0.16485116E-09_JPRB, 0.16528343E-09_JPRB, 0.16564075E-09_JPRB, 0.16590135E-09_JPRB, 0.16605664E-09_JPRB, 0.16610460E-09_JPRB, &
  & 0.16604922E-09_JPRB, 0.16589466E-09_JPRB, 0.16564691E-09_JPRB, 0.16531036E-09_JPRB, 0.16489463E-09_JPRB, 0.16440532E-09_JPRB, &
  & 0.16386105E-09_JPRB, 0.16327877E-09_JPRB, 0.16267471E-09_JPRB, 0.16206847E-09_JPRB, 0.16147721E-09_JPRB, 0.16090988E-09_JPRB, &
  & 0.16036360E-09_JPRB, 0.15983372E-09_JPRB, 0.15931861E-09_JPRB, 0.15882022E-09_JPRB, 0.15833951E-09_JPRB, 0.15788026E-09_JPRB, &
  & 0.15744100E-09_JPRB, 0.15702166E-09_JPRB, 0.15662614E-09_JPRB, 0.15625684E-09_JPRB, 0.15591839E-09_JPRB, 0.15561544E-09_JPRB, &
  & 0.15535048E-09_JPRB, 0.15511775E-09_JPRB, 0.15489582E-09_JPRB, 0.15457047E-09_JPRB /)

RGHG8(:,32, 8) = (/ &
  & 0.15154608E-09_JPRB, 0.15131693E-09_JPRB, 0.15117932E-09_JPRB, 0.15106683E-09_JPRB, 0.15096699E-09_JPRB, 0.15089290E-09_JPRB, &
  & 0.15086606E-09_JPRB, 0.15092660E-09_JPRB, 0.15111451E-09_JPRB, 0.15145792E-09_JPRB, 0.15196880E-09_JPRB, 0.15264684E-09_JPRB, &
  & 0.15347311E-09_JPRB, 0.15442132E-09_JPRB, 0.15545301E-09_JPRB, 0.15652590E-09_JPRB, 0.15759274E-09_JPRB, 0.15861339E-09_JPRB, &
  & 0.15955190E-09_JPRB, 0.16038695E-09_JPRB, 0.16110797E-09_JPRB, 0.16171604E-09_JPRB, 0.16222579E-09_JPRB, 0.16265701E-09_JPRB, &
  & 0.16303749E-09_JPRB, 0.16339315E-09_JPRB, 0.16374993E-09_JPRB, 0.16412652E-09_JPRB, 0.16452917E-09_JPRB, 0.16495180E-09_JPRB, &
  & 0.16537158E-09_JPRB, 0.16575707E-09_JPRB, 0.16607646E-09_JPRB, 0.16630730E-09_JPRB, 0.16644056E-09_JPRB, 0.16647420E-09_JPRB, &
  & 0.16641388E-09_JPRB, 0.16626361E-09_JPRB, 0.16602683E-09_JPRB, 0.16570886E-09_JPRB, 0.16531289E-09_JPRB, 0.16485258E-09_JPRB, &
  & 0.16434053E-09_JPRB, 0.16379341E-09_JPRB, 0.16323347E-09_JPRB, 0.16267392E-09_JPRB, 0.16213167E-09_JPRB, 0.16161039E-09_JPRB, &
  & 0.16111074E-09_JPRB, 0.16062524E-09_JPRB, 0.16015167E-09_JPRB, 0.15969387E-09_JPRB, 0.15925146E-09_JPRB, 0.15882672E-09_JPRB, &
  & 0.15842104E-09_JPRB, 0.15803517E-09_JPRB, 0.15767092E-09_JPRB, 0.15733095E-09_JPRB, 0.15701931E-09_JPRB, 0.15674072E-09_JPRB, &
  & 0.15649748E-09_JPRB, 0.15628332E-09_JPRB, 0.15607393E-09_JPRB, 0.15575903E-09_JPRB /)

RGHG8(:,33, 8) = (/ &
  & 0.15294092E-09_JPRB, 0.15278362E-09_JPRB, 0.15269275E-09_JPRB, 0.15262275E-09_JPRB, 0.15257315E-09_JPRB, 0.15255255E-09_JPRB, &
  & 0.15258583E-09_JPRB, 0.15270762E-09_JPRB, 0.15294703E-09_JPRB, 0.15332388E-09_JPRB, 0.15384562E-09_JPRB, 0.15450470E-09_JPRB, &
  & 0.15528742E-09_JPRB, 0.15616652E-09_JPRB, 0.15711271E-09_JPRB, 0.15808724E-09_JPRB, 0.15905680E-09_JPRB, 0.15998211E-09_JPRB, &
  & 0.16083572E-09_JPRB, 0.16159453E-09_JPRB, 0.16224742E-09_JPRB, 0.16279440E-09_JPRB, 0.16324156E-09_JPRB, 0.16361182E-09_JPRB, &
  & 0.16392998E-09_JPRB, 0.16422258E-09_JPRB, 0.16451362E-09_JPRB, 0.16482232E-09_JPRB, 0.16515755E-09_JPRB, 0.16551426E-09_JPRB, &
  & 0.16587383E-09_JPRB, 0.16620472E-09_JPRB, 0.16647814E-09_JPRB, 0.16667158E-09_JPRB, 0.16677784E-09_JPRB, 0.16679551E-09_JPRB, &
  & 0.16673155E-09_JPRB, 0.16658819E-09_JPRB, 0.16636927E-09_JPRB, 0.16607535E-09_JPRB, 0.16571189E-09_JPRB, 0.16528617E-09_JPRB, &
  & 0.16481681E-09_JPRB, 0.16431934E-09_JPRB, 0.16380217E-09_JPRB, 0.16329299E-09_JPRB, 0.16279229E-09_JPRB, 0.16231272E-09_JPRB, &
  & 0.16184812E-09_JPRB, 0.16139885E-09_JPRB, 0.16095716E-09_JPRB, 0.16052867E-09_JPRB, 0.16011537E-09_JPRB, 0.15971857E-09_JPRB, &
  & 0.15934065E-09_JPRB, 0.15898248E-09_JPRB, 0.15864514E-09_JPRB, 0.15833031E-09_JPRB, 0.15804227E-09_JPRB, 0.15778479E-09_JPRB, &
  & 0.15755995E-09_JPRB, 0.15736043E-09_JPRB, 0.15716395E-09_JPRB, 0.15686567E-09_JPRB /)

RGHG8(:,34, 8) = (/ &
  & 0.15418211E-09_JPRB, 0.15407720E-09_JPRB, 0.15402450E-09_JPRB, 0.15399231E-09_JPRB, 0.15398187E-09_JPRB, 0.15400581E-09_JPRB, &
  & 0.15408798E-09_JPRB, 0.15425596E-09_JPRB, 0.15453307E-09_JPRB, 0.15493093E-09_JPRB, 0.15544932E-09_JPRB, 0.15608385E-09_JPRB, &
  & 0.15681695E-09_JPRB, 0.15762942E-09_JPRB, 0.15849393E-09_JPRB, 0.15938255E-09_JPRB, 0.16026308E-09_JPRB, 0.16111061E-09_JPRB, &
  & 0.16189509E-09_JPRB, 0.16259791E-09_JPRB, 0.16320462E-09_JPRB, 0.16370648E-09_JPRB, 0.16411694E-09_JPRB, 0.16445120E-09_JPRB, &
  & 0.16473224E-09_JPRB, 0.16498382E-09_JPRB, 0.16522969E-09_JPRB, 0.16548693E-09_JPRB, 0.16576442E-09_JPRB, 0.16606036E-09_JPRB, &
  & 0.16635743E-09_JPRB, 0.16663021E-09_JPRB, 0.16685163E-09_JPRB, 0.16700329E-09_JPRB, 0.16708013E-09_JPRB, 0.16708165E-09_JPRB, &
  & 0.16701542E-09_JPRB, 0.16688159E-09_JPRB, 0.16668354E-09_JPRB, 0.16642093E-09_JPRB, 0.16609436E-09_JPRB, 0.16571296E-09_JPRB, &
  & 0.16529234E-09_JPRB, 0.16484734E-09_JPRB, 0.16438292E-09_JPRB, 0.16391287E-09_JPRB, 0.16345408E-09_JPRB, 0.16300632E-09_JPRB, &
  & 0.16256892E-09_JPRB, 0.16214471E-09_JPRB, 0.16172859E-09_JPRB, 0.16132065E-09_JPRB, 0.16092985E-09_JPRB, 0.16055546E-09_JPRB, &
  & 0.16019999E-09_JPRB, 0.15986529E-09_JPRB, 0.15955083E-09_JPRB, 0.15925844E-09_JPRB, 0.15899089E-09_JPRB, 0.15875229E-09_JPRB, &
  & 0.15854418E-09_JPRB, 0.15836017E-09_JPRB, 0.15817800E-09_JPRB, 0.15789370E-09_JPRB /)

RGHG8(:,35, 8) = (/ &
  & 0.15526874E-09_JPRB, 0.15522543E-09_JPRB, 0.15520618E-09_JPRB, 0.15520520E-09_JPRB, 0.15522754E-09_JPRB, 0.15528739E-09_JPRB, &
  & 0.15540588E-09_JPRB, 0.15560772E-09_JPRB, 0.15590847E-09_JPRB, 0.15631298E-09_JPRB, 0.15682165E-09_JPRB, 0.15742294E-09_JPRB, &
  & 0.15810762E-09_JPRB, 0.15885435E-09_JPRB, 0.15964592E-09_JPRB, 0.16045533E-09_JPRB, 0.16126238E-09_JPRB, 0.16204101E-09_JPRB, &
  & 0.16276969E-09_JPRB, 0.16342937E-09_JPRB, 0.16400209E-09_JPRB, 0.16448316E-09_JPRB, 0.16487778E-09_JPRB, 0.16519543E-09_JPRB, &
  & 0.16545731E-09_JPRB, 0.16568463E-09_JPRB, 0.16589830E-09_JPRB, 0.16611479E-09_JPRB, 0.16634251E-09_JPRB, 0.16658028E-09_JPRB, &
  & 0.16681578E-09_JPRB, 0.16702732E-09_JPRB, 0.16719470E-09_JPRB, 0.16730357E-09_JPRB, 0.16735119E-09_JPRB, 0.16733842E-09_JPRB, &
  & 0.16727114E-09_JPRB, 0.16714896E-09_JPRB, 0.16697524E-09_JPRB, 0.16674467E-09_JPRB, 0.16645996E-09_JPRB, 0.16612638E-09_JPRB, &
  & 0.16575757E-09_JPRB, 0.16536775E-09_JPRB, 0.16495147E-09_JPRB, 0.16452180E-09_JPRB, 0.16409629E-09_JPRB, 0.16367606E-09_JPRB, &
  & 0.16325946E-09_JPRB, 0.16285275E-09_JPRB, 0.16245542E-09_JPRB, 0.16206345E-09_JPRB, 0.16168873E-09_JPRB, 0.16133296E-09_JPRB, &
  & 0.16099699E-09_JPRB, 0.16068280E-09_JPRB, 0.16038930E-09_JPRB, 0.16011703E-09_JPRB, 0.15986838E-09_JPRB, 0.15964692E-09_JPRB, &
  & 0.15945410E-09_JPRB, 0.15928295E-09_JPRB, 0.15911207E-09_JPRB, 0.15884351E-09_JPRB /)

RGHG8(:,36, 8) = (/ &
  & 0.15625733E-09_JPRB, 0.15625658E-09_JPRB, 0.15626636E-09_JPRB, 0.15629172E-09_JPRB, 0.15634116E-09_JPRB, 0.15642837E-09_JPRB, &
  & 0.15657373E-09_JPRB, 0.15679660E-09_JPRB, 0.15710799E-09_JPRB, 0.15751120E-09_JPRB, 0.15799956E-09_JPRB, 0.15856724E-09_JPRB, &
  & 0.15920079E-09_JPRB, 0.15988766E-09_JPRB, 0.16060998E-09_JPRB, 0.16135175E-09_JPRB, 0.16209106E-09_JPRB, 0.16281329E-09_JPRB, &
  & 0.16349783E-09_JPRB, 0.16412416E-09_JPRB, 0.16467960E-09_JPRB, 0.16515228E-09_JPRB, 0.16554084E-09_JPRB, 0.16585353E-09_JPRB, &
  & 0.16610453E-09_JPRB, 0.16631521E-09_JPRB, 0.16650388E-09_JPRB, 0.16668505E-09_JPRB, 0.16686710E-09_JPRB, 0.16705028E-09_JPRB, &
  & 0.16722557E-09_JPRB, 0.16737858E-09_JPRB, 0.16749441E-09_JPRB, 0.16756431E-09_JPRB, 0.16758682E-09_JPRB, 0.16756378E-09_JPRB, &
  & 0.16749850E-09_JPRB, 0.16739135E-09_JPRB, 0.16724207E-09_JPRB, 0.16704620E-09_JPRB, 0.16680313E-09_JPRB, 0.16651835E-09_JPRB, &
  & 0.16620251E-09_JPRB, 0.16585859E-09_JPRB, 0.16548815E-09_JPRB, 0.16509824E-09_JPRB, 0.16470293E-09_JPRB, 0.16430454E-09_JPRB, &
  & 0.16390474E-09_JPRB, 0.16351262E-09_JPRB, 0.16312751E-09_JPRB, 0.16274926E-09_JPRB, 0.16238888E-09_JPRB, 0.16204954E-09_JPRB, &
  & 0.16173193E-09_JPRB, 0.16143711E-09_JPRB, 0.16116336E-09_JPRB, 0.16090983E-09_JPRB, 0.16067857E-09_JPRB, 0.16047300E-09_JPRB, &
  & 0.16029414E-09_JPRB, 0.16013536E-09_JPRB, 0.15997569E-09_JPRB, 0.15972144E-09_JPRB /)

RGHG8(:,37, 8) = (/ &
  & 0.15715712E-09_JPRB, 0.15719644E-09_JPRB, 0.15723184E-09_JPRB, 0.15728013E-09_JPRB, 0.15735156E-09_JPRB, 0.15746070E-09_JPRB, &
  & 0.15762440E-09_JPRB, 0.15785817E-09_JPRB, 0.15817092E-09_JPRB, 0.15856153E-09_JPRB, 0.15902640E-09_JPRB, 0.15955469E-09_JPRB, &
  & 0.16013915E-09_JPRB, 0.16076683E-09_JPRB, 0.16142691E-09_JPRB, 0.16210405E-09_JPRB, 0.16278655E-09_JPRB, 0.16345646E-09_JPRB, &
  & 0.16410373E-09_JPRB, 0.16470909E-09_JPRB, 0.16525234E-09_JPRB, 0.16572066E-09_JPRB, 0.16610489E-09_JPRB, 0.16640815E-09_JPRB, &
  & 0.16664629E-09_JPRB, 0.16683648E-09_JPRB, 0.16699872E-09_JPRB, 0.16714669E-09_JPRB, 0.16728774E-09_JPRB, 0.16742316E-09_JPRB, &
  & 0.16754780E-09_JPRB, 0.16765196E-09_JPRB, 0.16772668E-09_JPRB, 0.16776687E-09_JPRB, 0.16777227E-09_JPRB, 0.16774465E-09_JPRB, &
  & 0.16768598E-09_JPRB, 0.16759634E-09_JPRB, 0.16747385E-09_JPRB, 0.16731354E-09_JPRB, 0.16711357E-09_JPRB, 0.16687704E-09_JPRB, &
  & 0.16660731E-09_JPRB, 0.16630683E-09_JPRB, 0.16597937E-09_JPRB, 0.16562794E-09_JPRB, 0.16525993E-09_JPRB, 0.16488064E-09_JPRB, &
  & 0.16449744E-09_JPRB, 0.16411700E-09_JPRB, 0.16374187E-09_JPRB, 0.16337648E-09_JPRB, 0.16303041E-09_JPRB, 0.16270735E-09_JPRB, &
  & 0.16240807E-09_JPRB, 0.16213243E-09_JPRB, 0.16187739E-09_JPRB, 0.16164170E-09_JPRB, 0.16142718E-09_JPRB, 0.16123700E-09_JPRB, &
  & 0.16107160E-09_JPRB, 0.16092415E-09_JPRB, 0.16077531E-09_JPRB, 0.16053563E-09_JPRB /)

RGHG8(:,38, 8) = (/ &
  & 0.15799266E-09_JPRB, 0.15806788E-09_JPRB, 0.15812514E-09_JPRB, 0.15819278E-09_JPRB, 0.15828408E-09_JPRB, 0.15841041E-09_JPRB, &
  & 0.15858619E-09_JPRB, 0.15882359E-09_JPRB, 0.15912768E-09_JPRB, 0.15949952E-09_JPRB, 0.15993329E-09_JPRB, 0.16042101E-09_JPRB, &
  & 0.16095428E-09_JPRB, 0.16152529E-09_JPRB, 0.16212491E-09_JPRB, 0.16274385E-09_JPRB, 0.16337152E-09_JPRB, 0.16399830E-09_JPRB, &
  & 0.16461006E-09_JPRB, 0.16519135E-09_JPRB, 0.16572230E-09_JPRB, 0.16617765E-09_JPRB, 0.16654572E-09_JPRB, 0.16682918E-09_JPRB, &
  & 0.16704128E-09_JPRB, 0.16720583E-09_JPRB, 0.16734075E-09_JPRB, 0.16745928E-09_JPRB, 0.16756826E-09_JPRB, 0.16766899E-09_JPRB, &
  & 0.16775836E-09_JPRB, 0.16783026E-09_JPRB, 0.16787853E-09_JPRB, 0.16790055E-09_JPRB, 0.16789660E-09_JPRB, 0.16786880E-09_JPRB, &
  & 0.16781833E-09_JPRB, 0.16774576E-09_JPRB, 0.16764860E-09_JPRB, 0.16752297E-09_JPRB, 0.16736514E-09_JPRB, 0.16717572E-09_JPRB, &
  & 0.16695072E-09_JPRB, 0.16669592E-09_JPRB, 0.16641029E-09_JPRB, 0.16609497E-09_JPRB, 0.16575448E-09_JPRB, 0.16539678E-09_JPRB, &
  & 0.16502960E-09_JPRB, 0.16466127E-09_JPRB, 0.16429688E-09_JPRB, 0.16394533E-09_JPRB, 0.16361475E-09_JPRB, 0.16330894E-09_JPRB, &
  & 0.16302856E-09_JPRB, 0.16277193E-09_JPRB, 0.16253551E-09_JPRB, 0.16231740E-09_JPRB, 0.16211935E-09_JPRB, 0.16194439E-09_JPRB, &
  & 0.16179239E-09_JPRB, 0.16165640E-09_JPRB, 0.16151777E-09_JPRB, 0.16129327E-09_JPRB /)

RGHG8(:,39, 8) = (/ &
  & 0.15878227E-09_JPRB, 0.15888722E-09_JPRB, 0.15896212E-09_JPRB, 0.15904776E-09_JPRB, 0.15915473E-09_JPRB, 0.15929581E-09_JPRB, &
  & 0.15947972E-09_JPRB, 0.15971327E-09_JPRB, 0.16000279E-09_JPRB, 0.16034879E-09_JPRB, 0.16074710E-09_JPRB, 0.16119112E-09_JPRB, &
  & 0.16167348E-09_JPRB, 0.16218799E-09_JPRB, 0.16272948E-09_JPRB, 0.16329145E-09_JPRB, 0.16386772E-09_JPRB, 0.16445056E-09_JPRB, &
  & 0.16502820E-09_JPRB, 0.16558413E-09_JPRB, 0.16608981E-09_JPRB, 0.16652181E-09_JPRB, 0.16686141E-09_JPRB, 0.16711377E-09_JPRB, &
  & 0.16729888E-09_JPRB, 0.16743823E-09_JPRB, 0.16755089E-09_JPRB, 0.16764791E-09_JPRB, 0.16773515E-09_JPRB, 0.16781385E-09_JPRB, &
  & 0.16788215E-09_JPRB, 0.16793522E-09_JPRB, 0.16796876E-09_JPRB, 0.16798089E-09_JPRB, 0.16797250E-09_JPRB, 0.16794535E-09_JPRB, &
  & 0.16790115E-09_JPRB, 0.16784063E-09_JPRB, 0.16776278E-09_JPRB, 0.16766395E-09_JPRB, 0.16754219E-09_JPRB, 0.16739410E-09_JPRB, &
  & 0.16721513E-09_JPRB, 0.16700796E-09_JPRB, 0.16676625E-09_JPRB, 0.16649009E-09_JPRB, 0.16618208E-09_JPRB, 0.16584821E-09_JPRB, &
  & 0.16549966E-09_JPRB, 0.16514441E-09_JPRB, 0.16479343E-09_JPRB, 0.16445710E-09_JPRB, 0.16414342E-09_JPRB, 0.16385628E-09_JPRB, &
  & 0.16359555E-09_JPRB, 0.16335834E-09_JPRB, 0.16314022E-09_JPRB, 0.16293951E-09_JPRB, 0.16275772E-09_JPRB, 0.16259785E-09_JPRB, &
  & 0.16245912E-09_JPRB, 0.16233463E-09_JPRB, 0.16220691E-09_JPRB, 0.16199890E-09_JPRB /)

RGHG8(:,40, 8) = (/ &
  & 0.15954314E-09_JPRB, 0.15966879E-09_JPRB, 0.15975735E-09_JPRB, 0.15985381E-09_JPRB, 0.15997619E-09_JPRB, 0.16012883E-09_JPRB, &
  & 0.16031559E-09_JPRB, 0.16054282E-09_JPRB, 0.16081189E-09_JPRB, 0.16112719E-09_JPRB, 0.16148741E-09_JPRB, 0.16188595E-09_JPRB, &
  & 0.16231740E-09_JPRB, 0.16277701E-09_JPRB, 0.16326164E-09_JPRB, 0.16376818E-09_JPRB, 0.16429340E-09_JPRB, 0.16483111E-09_JPRB, &
  & 0.16537245E-09_JPRB, 0.16589448E-09_JPRB, 0.16637212E-09_JPRB, 0.16677051E-09_JPRB, 0.16707816E-09_JPRB, 0.16730201E-09_JPRB, &
  & 0.16746275E-09_JPRB, 0.16758328E-09_JPRB, 0.16767970E-09_JPRB, 0.16776204E-09_JPRB, 0.16783511E-09_JPRB, 0.16790033E-09_JPRB, &
  & 0.16795601E-09_JPRB, 0.16799860E-09_JPRB, 0.16802398E-09_JPRB, 0.16803087E-09_JPRB, 0.16802010E-09_JPRB, 0.16799363E-09_JPRB, &
  & 0.16795328E-09_JPRB, 0.16790021E-09_JPRB, 0.16783443E-09_JPRB, 0.16775374E-09_JPRB, 0.16765718E-09_JPRB, 0.16754141E-09_JPRB, &
  & 0.16740181E-09_JPRB, 0.16723888E-09_JPRB, 0.16704267E-09_JPRB, 0.16680951E-09_JPRB, 0.16653820E-09_JPRB, 0.16623344E-09_JPRB, &
  & 0.16590579E-09_JPRB, 0.16556766E-09_JPRB, 0.16523269E-09_JPRB, 0.16491342E-09_JPRB, 0.16461839E-09_JPRB, 0.16435103E-09_JPRB, &
  & 0.16411060E-09_JPRB, 0.16389270E-09_JPRB, 0.16369309E-09_JPRB, 0.16350934E-09_JPRB, 0.16334388E-09_JPRB, 0.16319891E-09_JPRB, &
  & 0.16307350E-09_JPRB, 0.16296041E-09_JPRB, 0.16284377E-09_JPRB, 0.16265253E-09_JPRB /)

RGHG8(:,41, 8) = (/ &
  & 0.16029245E-09_JPRB, 0.16042945E-09_JPRB, 0.16051954E-09_JPRB, 0.16062462E-09_JPRB, 0.16075564E-09_JPRB, 0.16091631E-09_JPRB, &
  & 0.16110593E-09_JPRB, 0.16132021E-09_JPRB, 0.16156711E-09_JPRB, 0.16185005E-09_JPRB, 0.16216978E-09_JPRB, 0.16252322E-09_JPRB, &
  & 0.16290491E-09_JPRB, 0.16331121E-09_JPRB, 0.16374067E-09_JPRB, 0.16419270E-09_JPRB, 0.16466602E-09_JPRB, 0.16515851E-09_JPRB, &
  & 0.16565814E-09_JPRB, 0.16614725E-09_JPRB, 0.16658899E-09_JPRB, 0.16695625E-09_JPRB, 0.16723327E-09_JPRB, 0.16743190E-09_JPRB, &
  & 0.16757389E-09_JPRB, 0.16767979E-09_JPRB, 0.16776452E-09_JPRB, 0.16783648E-09_JPRB, 0.16789994E-09_JPRB, 0.16795618E-09_JPRB, &
  & 0.16800429E-09_JPRB, 0.16804050E-09_JPRB, 0.16806148E-09_JPRB, 0.16806546E-09_JPRB, 0.16805353E-09_JPRB, 0.16802756E-09_JPRB, &
  & 0.16798962E-09_JPRB, 0.16794105E-09_JPRB, 0.16788276E-09_JPRB, 0.16781368E-09_JPRB, 0.16773374E-09_JPRB, 0.16764071E-09_JPRB, &
  & 0.16753091E-09_JPRB, 0.16740402E-09_JPRB, 0.16724841E-09_JPRB, 0.16705815E-09_JPRB, 0.16682686E-09_JPRB, 0.16655398E-09_JPRB, &
  & 0.16625309E-09_JPRB, 0.16593470E-09_JPRB, 0.16561841E-09_JPRB, 0.16531763E-09_JPRB, 0.16504184E-09_JPRB, 0.16479497E-09_JPRB, &
  & 0.16457470E-09_JPRB, 0.16437671E-09_JPRB, 0.16419530E-09_JPRB, 0.16402894E-09_JPRB, 0.16387941E-09_JPRB, 0.16374921E-09_JPRB, &
  & 0.16363658E-09_JPRB, 0.16353449E-09_JPRB, 0.16342828E-09_JPRB, 0.16325392E-09_JPRB /)

RGHG8(:,42, 8) = (/ &
  & 0.16107687E-09_JPRB, 0.16118216E-09_JPRB, 0.16126328E-09_JPRB, 0.16136488E-09_JPRB, 0.16150217E-09_JPRB, 0.16167048E-09_JPRB, &
  & 0.16185489E-09_JPRB, 0.16205813E-09_JPRB, 0.16228022E-09_JPRB, 0.16253013E-09_JPRB, 0.16281056E-09_JPRB, 0.16311977E-09_JPRB, &
  & 0.16345364E-09_JPRB, 0.16380913E-09_JPRB, 0.16418553E-09_JPRB, 0.16458354E-09_JPRB, 0.16500531E-09_JPRB, 0.16544867E-09_JPRB, &
  & 0.16590784E-09_JPRB, 0.16635784E-09_JPRB, 0.16676797E-09_JPRB, 0.16710239E-09_JPRB, 0.16735216E-09_JPRB, 0.16752921E-09_JPRB, &
  & 0.16765529E-09_JPRB, 0.16774973E-09_JPRB, 0.16782525E-09_JPRB, 0.16788936E-09_JPRB, 0.16794575E-09_JPRB, 0.16799596E-09_JPRB, &
  & 0.16803890E-09_JPRB, 0.16807153E-09_JPRB, 0.16808988E-09_JPRB, 0.16809232E-09_JPRB, 0.16807983E-09_JPRB, 0.16805438E-09_JPRB, &
  & 0.16801797E-09_JPRB, 0.16797236E-09_JPRB, 0.16791890E-09_JPRB, 0.16785735E-09_JPRB, 0.16778846E-09_JPRB, 0.16771132E-09_JPRB, &
  & 0.16762285E-09_JPRB, 0.16752300E-09_JPRB, 0.16740122E-09_JPRB, 0.16724905E-09_JPRB, 0.16705665E-09_JPRB, 0.16682011E-09_JPRB, &
  & 0.16654712E-09_JPRB, 0.16625171E-09_JPRB, 0.16595551E-09_JPRB, 0.16567389E-09_JPRB, 0.16541804E-09_JPRB, 0.16519137E-09_JPRB, &
  & 0.16499202E-09_JPRB, 0.16481379E-09_JPRB, 0.16465142E-09_JPRB, 0.16450227E-09_JPRB, 0.16436852E-09_JPRB, 0.16425222E-09_JPRB, &
  & 0.16415153E-09_JPRB, 0.16405963E-09_JPRB, 0.16396320E-09_JPRB, 0.16380393E-09_JPRB /)

RGHG8(:,43, 8) = (/ &
  & 0.16176360E-09_JPRB, 0.16189092E-09_JPRB, 0.16197683E-09_JPRB, 0.16208263E-09_JPRB, 0.16222609E-09_JPRB, 0.16239583E-09_JPRB, &
  & 0.16257905E-09_JPRB, 0.16276581E-09_JPRB, 0.16296475E-09_JPRB, 0.16318291E-09_JPRB, 0.16342561E-09_JPRB, 0.16369264E-09_JPRB, &
  & 0.16398108E-09_JPRB, 0.16428817E-09_JPRB, 0.16461338E-09_JPRB, 0.16495912E-09_JPRB, 0.16532753E-09_JPRB, 0.16572207E-09_JPRB, &
  & 0.16613448E-09_JPRB, 0.16654754E-09_JPRB, 0.16692162E-09_JPRB, 0.16722584E-09_JPRB, 0.16744921E-09_JPRB, 0.16760657E-09_JPRB, &
  & 0.16771901E-09_JPRB, 0.16780358E-09_JPRB, 0.16787161E-09_JPRB, 0.16792943E-09_JPRB, 0.16798055E-09_JPRB, 0.16802632E-09_JPRB, &
  & 0.16806599E-09_JPRB, 0.16809631E-09_JPRB, 0.16811340E-09_JPRB, 0.16811519E-09_JPRB, 0.16810260E-09_JPRB, 0.16807764E-09_JPRB, &
  & 0.16804236E-09_JPRB, 0.16799863E-09_JPRB, 0.16794835E-09_JPRB, 0.16789188E-09_JPRB, 0.16783057E-09_JPRB, 0.16776458E-09_JPRB, &
  & 0.16769186E-09_JPRB, 0.16761212E-09_JPRB, 0.16751706E-09_JPRB, 0.16739689E-09_JPRB, 0.16724135E-09_JPRB, 0.16703969E-09_JPRB, &
  & 0.16679719E-09_JPRB, 0.16652618E-09_JPRB, 0.16625099E-09_JPRB, 0.16598840E-09_JPRB, 0.16575193E-09_JPRB, 0.16554609E-09_JPRB, &
  & 0.16536747E-09_JPRB, 0.16520994E-09_JPRB, 0.16506665E-09_JPRB, 0.16493498E-09_JPRB, 0.16481644E-09_JPRB, 0.16471313E-09_JPRB, &
  & 0.16462320E-09_JPRB, 0.16454035E-09_JPRB, 0.16445252E-09_JPRB, 0.16430669E-09_JPRB /)

RGHG8(:,44, 8) = (/ &
  & 0.16243037E-09_JPRB, 0.16259934E-09_JPRB, 0.16269294E-09_JPRB, 0.16280083E-09_JPRB, 0.16294396E-09_JPRB, 0.16311595E-09_JPRB, &
  & 0.16328935E-09_JPRB, 0.16346115E-09_JPRB, 0.16363677E-09_JPRB, 0.16382497E-09_JPRB, 0.16403190E-09_JPRB, 0.16425918E-09_JPRB, &
  & 0.16450408E-09_JPRB, 0.16476442E-09_JPRB, 0.16504087E-09_JPRB, 0.16533411E-09_JPRB, 0.16565053E-09_JPRB, 0.16599090E-09_JPRB, &
  & 0.16635690E-09_JPRB, 0.16672508E-09_JPRB, 0.16706335E-09_JPRB, 0.16733437E-09_JPRB, 0.16753196E-09_JPRB, 0.16767088E-09_JPRB, &
  & 0.16777071E-09_JPRB, 0.16784669E-09_JPRB, 0.16790833E-09_JPRB, 0.16796109E-09_JPRB, 0.16800809E-09_JPRB, 0.16805075E-09_JPRB, &
  & 0.16808824E-09_JPRB, 0.16811746E-09_JPRB, 0.16813412E-09_JPRB, 0.16813587E-09_JPRB, 0.16812354E-09_JPRB, 0.16809909E-09_JPRB, &
  & 0.16806462E-09_JPRB, 0.16802221E-09_JPRB, 0.16797384E-09_JPRB, 0.16792098E-09_JPRB, 0.16786486E-09_JPRB, 0.16780718E-09_JPRB, &
  & 0.16774614E-09_JPRB, 0.16768190E-09_JPRB, 0.16760786E-09_JPRB, 0.16751474E-09_JPRB, 0.16739171E-09_JPRB, 0.16722512E-09_JPRB, &
  & 0.16701412E-09_JPRB, 0.16676856E-09_JPRB, 0.16651364E-09_JPRB, 0.16626964E-09_JPRB, 0.16605273E-09_JPRB, 0.16586725E-09_JPRB, &
  & 0.16571020E-09_JPRB, 0.16557339E-09_JPRB, 0.16544956E-09_JPRB, 0.16533483E-09_JPRB, 0.16523061E-09_JPRB, 0.16513899E-09_JPRB, &
  & 0.16505861E-09_JPRB, 0.16498382E-09_JPRB, 0.16490356E-09_JPRB, 0.16476955E-09_JPRB /)

RGHG8(:,45, 8) = (/ &
  & 0.16330234E-09_JPRB, 0.16338952E-09_JPRB, 0.16345661E-09_JPRB, 0.16354719E-09_JPRB, 0.16368464E-09_JPRB, 0.16384705E-09_JPRB, &
  & 0.16400853E-09_JPRB, 0.16416296E-09_JPRB, 0.16431428E-09_JPRB, 0.16447374E-09_JPRB, 0.16464655E-09_JPRB, 0.16483484E-09_JPRB, &
  & 0.16503722E-09_JPRB, 0.16525242E-09_JPRB, 0.16547932E-09_JPRB, 0.16572259E-09_JPRB, 0.16598348E-09_JPRB, 0.16627204E-09_JPRB, &
  & 0.16658171E-09_JPRB, 0.16690425E-09_JPRB, 0.16719726E-09_JPRB, 0.16743330E-09_JPRB, 0.16760415E-09_JPRB, 0.16772495E-09_JPRB, &
  & 0.16781332E-09_JPRB, 0.16788161E-09_JPRB, 0.16793772E-09_JPRB, 0.16798639E-09_JPRB, 0.16803031E-09_JPRB, 0.16807084E-09_JPRB, &
  & 0.16810714E-09_JPRB, 0.16813599E-09_JPRB, 0.16815292E-09_JPRB, 0.16815523E-09_JPRB, 0.16814342E-09_JPRB, 0.16811957E-09_JPRB, &
  & 0.16808563E-09_JPRB, 0.16804394E-09_JPRB, 0.16799694E-09_JPRB, 0.16794618E-09_JPRB, 0.16789412E-09_JPRB, 0.16784230E-09_JPRB, &
  & 0.16779063E-09_JPRB, 0.16773805E-09_JPRB, 0.16768080E-09_JPRB, 0.16760979E-09_JPRB, 0.16751553E-09_JPRB, 0.16738316E-09_JPRB, &
  & 0.16720447E-09_JPRB, 0.16698701E-09_JPRB, 0.16675274E-09_JPRB, 0.16652767E-09_JPRB, 0.16633005E-09_JPRB, 0.16616569E-09_JPRB, &
  & 0.16603033E-09_JPRB, 0.16591410E-09_JPRB, 0.16580903E-09_JPRB, 0.16571050E-09_JPRB, 0.16561924E-09_JPRB, 0.16553792E-09_JPRB, &
  & 0.16546567E-09_JPRB, 0.16539786E-09_JPRB, 0.16532450E-09_JPRB, 0.16520116E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART15',1,ZHOOK_HANDLE)
END SUBROUTINE PART15




SUBROUTINE PART16
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART16',0,ZHOOK_HANDLE)



RGHG8(:,46, 8) = (/ &
  & 0.16390662E-09_JPRB, 0.16409576E-09_JPRB, 0.16420193E-09_JPRB, 0.16431523E-09_JPRB, 0.16445485E-09_JPRB, 0.16461182E-09_JPRB, &
  & 0.16475986E-09_JPRB, 0.16489168E-09_JPRB, 0.16501905E-09_JPRB, 0.16514777E-09_JPRB, 0.16528567E-09_JPRB, 0.16543460E-09_JPRB, &
  & 0.16559402E-09_JPRB, 0.16576213E-09_JPRB, 0.16594112E-09_JPRB, 0.16613066E-09_JPRB, 0.16633962E-09_JPRB, 0.16656791E-09_JPRB, &
  & 0.16682428E-09_JPRB, 0.16708550E-09_JPRB, 0.16733012E-09_JPRB, 0.16752481E-09_JPRB, 0.16766782E-09_JPRB, 0.16777107E-09_JPRB, &
  & 0.16784847E-09_JPRB, 0.16790984E-09_JPRB, 0.16796131E-09_JPRB, 0.16800664E-09_JPRB, 0.16804838E-09_JPRB, 0.16808753E-09_JPRB, &
  & 0.16812335E-09_JPRB, 0.16815258E-09_JPRB, 0.16817032E-09_JPRB, 0.16817356E-09_JPRB, 0.16816261E-09_JPRB, 0.16813931E-09_JPRB, &
  & 0.16810582E-09_JPRB, 0.16806452E-09_JPRB, 0.16801793E-09_JPRB, 0.16796904E-09_JPRB, 0.16791941E-09_JPRB, 0.16787252E-09_JPRB, &
  & 0.16782754E-09_JPRB, 0.16778456E-09_JPRB, 0.16773992E-09_JPRB, 0.16768706E-09_JPRB, 0.16761725E-09_JPRB, 0.16751658E-09_JPRB, &
  & 0.16737395E-09_JPRB, 0.16718767E-09_JPRB, 0.16697813E-09_JPRB, 0.16677323E-09_JPRB, 0.16659576E-09_JPRB, 0.16645313E-09_JPRB, &
  & 0.16633825E-09_JPRB, 0.16624177E-09_JPRB, 0.16615376E-09_JPRB, 0.16606969E-09_JPRB, 0.16598989E-09_JPRB, 0.16591711E-09_JPRB, &
  & 0.16585187E-09_JPRB, 0.16579021E-09_JPRB, 0.16572296E-09_JPRB, 0.16560985E-09_JPRB /)

RGHG8(:,47, 8) = (/ &
  & 0.16473843E-09_JPRB, 0.16489794E-09_JPRB, 0.16500751E-09_JPRB, 0.16512838E-09_JPRB, 0.16527804E-09_JPRB, 0.16543192E-09_JPRB, &
  & 0.16556084E-09_JPRB, 0.16567124E-09_JPRB, 0.16576826E-09_JPRB, 0.16586420E-09_JPRB, 0.16596383E-09_JPRB, 0.16607048E-09_JPRB, &
  & 0.16618376E-09_JPRB, 0.16630400E-09_JPRB, 0.16643069E-09_JPRB, 0.16656901E-09_JPRB, 0.16671962E-09_JPRB, 0.16689179E-09_JPRB, &
  & 0.16707870E-09_JPRB, 0.16727786E-09_JPRB, 0.16745999E-09_JPRB, 0.16761105E-09_JPRB, 0.16772475E-09_JPRB, 0.16781031E-09_JPRB, &
  & 0.16787749E-09_JPRB, 0.16793261E-09_JPRB, 0.16798003E-09_JPRB, 0.16802283E-09_JPRB, 0.16806291E-09_JPRB, 0.16810142E-09_JPRB, &
  & 0.16813746E-09_JPRB, 0.16816752E-09_JPRB, 0.16818658E-09_JPRB, 0.16819117E-09_JPRB, 0.16818127E-09_JPRB, 0.16815864E-09_JPRB, &
  & 0.16812536E-09_JPRB, 0.16808403E-09_JPRB, 0.16803792E-09_JPRB, 0.16798955E-09_JPRB, 0.16794240E-09_JPRB, 0.16789843E-09_JPRB, &
  & 0.16785921E-09_JPRB, 0.16782313E-09_JPRB, 0.16778856E-09_JPRB, 0.16774990E-09_JPRB, 0.16770006E-09_JPRB, 0.16762883E-09_JPRB, &
  & 0.16752204E-09_JPRB, 0.16737599E-09_JPRB, 0.16719767E-09_JPRB, 0.16701912E-09_JPRB, 0.16686398E-09_JPRB, 0.16674155E-09_JPRB, &
  & 0.16664667E-09_JPRB, 0.16656670E-09_JPRB, 0.16649364E-09_JPRB, 0.16642177E-09_JPRB, 0.16635102E-09_JPRB, 0.16628512E-09_JPRB, &
  & 0.16622516E-09_JPRB, 0.16616834E-09_JPRB, 0.16610628E-09_JPRB, 0.16600192E-09_JPRB /)

RGHG8(:,48, 8) = (/ &
  & 0.16542093E-09_JPRB, 0.16564120E-09_JPRB, 0.16578795E-09_JPRB, 0.16594222E-09_JPRB, 0.16611729E-09_JPRB, 0.16627824E-09_JPRB, &
  & 0.16640241E-09_JPRB, 0.16649043E-09_JPRB, 0.16656068E-09_JPRB, 0.16662270E-09_JPRB, 0.16668272E-09_JPRB, 0.16674476E-09_JPRB, &
  & 0.16680993E-09_JPRB, 0.16687894E-09_JPRB, 0.16695374E-09_JPRB, 0.16703536E-09_JPRB, 0.16712819E-09_JPRB, 0.16723183E-09_JPRB, &
  & 0.16734852E-09_JPRB, 0.16746954E-09_JPRB, 0.16758876E-09_JPRB, 0.16769186E-09_JPRB, 0.16777593E-09_JPRB, 0.16784427E-09_JPRB, &
  & 0.16790151E-09_JPRB, 0.16795088E-09_JPRB, 0.16799483E-09_JPRB, 0.16803553E-09_JPRB, 0.16807468E-09_JPRB, 0.16811308E-09_JPRB, &
  & 0.16814976E-09_JPRB, 0.16818118E-09_JPRB, 0.16820192E-09_JPRB, 0.16820817E-09_JPRB, 0.16819954E-09_JPRB, 0.16817756E-09_JPRB, &
  & 0.16814440E-09_JPRB, 0.16810305E-09_JPRB, 0.16805664E-09_JPRB, 0.16800915E-09_JPRB, 0.16796287E-09_JPRB, 0.16792172E-09_JPRB, &
  & 0.16788604E-09_JPRB, 0.16785601E-09_JPRB, 0.16782890E-09_JPRB, 0.16780147E-09_JPRB, 0.16776801E-09_JPRB, 0.16772096E-09_JPRB, &
  & 0.16765046E-09_JPRB, 0.16754692E-09_JPRB, 0.16741541E-09_JPRB, 0.16727182E-09_JPRB, 0.16714452E-09_JPRB, 0.16704448E-09_JPRB, &
  & 0.16696602E-09_JPRB, 0.16690017E-09_JPRB, 0.16683831E-09_JPRB, 0.16677551E-09_JPRB, 0.16671134E-09_JPRB, 0.16664961E-09_JPRB, &
  & 0.16659302E-09_JPRB, 0.16653914E-09_JPRB, 0.16648065E-09_JPRB, 0.16638235E-09_JPRB /)

RGHG8(:,49, 8) = (/ &
  & 0.16608699E-09_JPRB, 0.16633783E-09_JPRB, 0.16650446E-09_JPRB, 0.16667953E-09_JPRB, 0.16687604E-09_JPRB, 0.16705538E-09_JPRB, &
  & 0.16717855E-09_JPRB, 0.16725915E-09_JPRB, 0.16731391E-09_JPRB, 0.16735278E-09_JPRB, 0.16738400E-09_JPRB, 0.16740984E-09_JPRB, &
  & 0.16743304E-09_JPRB, 0.16745524E-09_JPRB, 0.16747859E-09_JPRB, 0.16750493E-09_JPRB, 0.16753443E-09_JPRB, 0.16756828E-09_JPRB, &
  & 0.16760783E-09_JPRB, 0.16765575E-09_JPRB, 0.16771071E-09_JPRB, 0.16776815E-09_JPRB, 0.16782276E-09_JPRB, 0.16787396E-09_JPRB, &
  & 0.16792169E-09_JPRB, 0.16796572E-09_JPRB, 0.16800658E-09_JPRB, 0.16804566E-09_JPRB, 0.16808420E-09_JPRB, 0.16812290E-09_JPRB, &
  & 0.16816071E-09_JPRB, 0.16819381E-09_JPRB, 0.16821655E-09_JPRB, 0.16822461E-09_JPRB, 0.16821748E-09_JPRB, 0.16819615E-09_JPRB, &
  & 0.16816319E-09_JPRB, 0.16812152E-09_JPRB, 0.16807507E-09_JPRB, 0.16802756E-09_JPRB, 0.16798235E-09_JPRB, 0.16794252E-09_JPRB, &
  & 0.16791006E-09_JPRB, 0.16788403E-09_JPRB, 0.16786322E-09_JPRB, 0.16784427E-09_JPRB, 0.16782373E-09_JPRB, 0.16779653E-09_JPRB, &
  & 0.16775586E-09_JPRB, 0.16769588E-09_JPRB, 0.16761384E-09_JPRB, 0.16752146E-09_JPRB, 0.16743222E-09_JPRB, 0.16735832E-09_JPRB, &
  & 0.16729745E-09_JPRB, 0.16724444E-09_JPRB, 0.16719176E-09_JPRB, 0.16713565E-09_JPRB, 0.16707577E-09_JPRB, 0.16701611E-09_JPRB, &
  & 0.16696049E-09_JPRB, 0.16690771E-09_JPRB, 0.16685024E-09_JPRB, 0.16675443E-09_JPRB /)

RGHG8(:,50, 8) = (/ &
  & 0.16674401E-09_JPRB, 0.16696307E-09_JPRB, 0.16711196E-09_JPRB, 0.16727779E-09_JPRB, 0.16746866E-09_JPRB, 0.16764301E-09_JPRB, &
  & 0.16776025E-09_JPRB, 0.16783422E-09_JPRB, 0.16787863E-09_JPRB, 0.16790874E-09_JPRB, 0.16792659E-09_JPRB, 0.16793518E-09_JPRB, &
  & 0.16793442E-09_JPRB, 0.16792595E-09_JPRB, 0.16791188E-09_JPRB, 0.16789342E-09_JPRB, 0.16787274E-09_JPRB, 0.16785127E-09_JPRB, &
  & 0.16783268E-09_JPRB, 0.16782203E-09_JPRB, 0.16782449E-09_JPRB, 0.16784012E-09_JPRB, 0.16786650E-09_JPRB, 0.16790069E-09_JPRB, &
  & 0.16793905E-09_JPRB, 0.16797802E-09_JPRB, 0.16801616E-09_JPRB, 0.16805388E-09_JPRB, 0.16809215E-09_JPRB, 0.16813147E-09_JPRB, &
  & 0.16817064E-09_JPRB, 0.16820574E-09_JPRB, 0.16823062E-09_JPRB, 0.16824082E-09_JPRB, 0.16823522E-09_JPRB, 0.16821451E-09_JPRB, &
  & 0.16818177E-09_JPRB, 0.16813992E-09_JPRB, 0.16809323E-09_JPRB, 0.16804563E-09_JPRB, 0.16800081E-09_JPRB, 0.16796203E-09_JPRB, &
  & 0.16793122E-09_JPRB, 0.16790899E-09_JPRB, 0.16789280E-09_JPRB, 0.16788071E-09_JPRB, 0.16787016E-09_JPRB, 0.16785803E-09_JPRB, &
  & 0.16784042E-09_JPRB, 0.16781311E-09_JPRB, 0.16777564E-09_JPRB, 0.16772948E-09_JPRB, 0.16768303E-09_JPRB, 0.16764024E-09_JPRB, &
  & 0.16760246E-09_JPRB, 0.16756535E-09_JPRB, 0.16752674E-09_JPRB, 0.16748186E-09_JPRB, 0.16742971E-09_JPRB, 0.16737503E-09_JPRB, &
  & 0.16732228E-09_JPRB, 0.16727052E-09_JPRB, 0.16721388E-09_JPRB, 0.16711672E-09_JPRB /)

RGHG8(:,51, 8) = (/ &
  & 0.16725078E-09_JPRB, 0.16744812E-09_JPRB, 0.16758117E-09_JPRB, 0.16771998E-09_JPRB, 0.16788744E-09_JPRB, 0.16803464E-09_JPRB, &
  & 0.16813445E-09_JPRB, 0.16819032E-09_JPRB, 0.16822647E-09_JPRB, 0.16824678E-09_JPRB, 0.16825809E-09_JPRB, 0.16825891E-09_JPRB, &
  & 0.16824803E-09_JPRB, 0.16822536E-09_JPRB, 0.16819224E-09_JPRB, 0.16815171E-09_JPRB, 0.16810553E-09_JPRB, 0.16805690E-09_JPRB, &
  & 0.16800741E-09_JPRB, 0.16796300E-09_JPRB, 0.16792794E-09_JPRB, 0.16790898E-09_JPRB, 0.16790848E-09_JPRB, 0.16792555E-09_JPRB, &
  & 0.16795443E-09_JPRB, 0.16798854E-09_JPRB, 0.16802421E-09_JPRB, 0.16806082E-09_JPRB, 0.16809897E-09_JPRB, 0.16813907E-09_JPRB, &
  & 0.16817987E-09_JPRB, 0.16821713E-09_JPRB, 0.16824439E-09_JPRB, 0.16825694E-09_JPRB, 0.16825275E-09_JPRB, 0.16823293E-09_JPRB, &
  & 0.16820034E-09_JPRB, 0.16815843E-09_JPRB, 0.16811141E-09_JPRB, 0.16806401E-09_JPRB, 0.16801882E-09_JPRB, 0.16798044E-09_JPRB, &
  & 0.16795132E-09_JPRB, 0.16793128E-09_JPRB, 0.16791919E-09_JPRB, 0.16791252E-09_JPRB, 0.16790978E-09_JPRB, 0.16790905E-09_JPRB, &
  & 0.16790745E-09_JPRB, 0.16790239E-09_JPRB, 0.16789209E-09_JPRB, 0.16787741E-09_JPRB, 0.16786028E-09_JPRB, 0.16784295E-09_JPRB, &
  & 0.16782570E-09_JPRB, 0.16780806E-09_JPRB, 0.16778706E-09_JPRB, 0.16776064E-09_JPRB, 0.16772714E-09_JPRB, 0.16768736E-09_JPRB, &
  & 0.16764531E-09_JPRB, 0.16760195E-09_JPRB, 0.16754975E-09_JPRB, 0.16745630E-09_JPRB /)

RGHG8(:,52, 8) = (/ &
  & 0.16771529E-09_JPRB, 0.16784943E-09_JPRB, 0.16794004E-09_JPRB, 0.16804930E-09_JPRB, 0.16817636E-09_JPRB, 0.16829516E-09_JPRB, &
  & 0.16836675E-09_JPRB, 0.16840998E-09_JPRB, 0.16843235E-09_JPRB, 0.16844623E-09_JPRB, 0.16845125E-09_JPRB, 0.16844723E-09_JPRB, &
  & 0.16843146E-09_JPRB, 0.16840278E-09_JPRB, 0.16836268E-09_JPRB, 0.16831364E-09_JPRB, 0.16825893E-09_JPRB, 0.16819993E-09_JPRB, &
  & 0.16813970E-09_JPRB, 0.16807752E-09_JPRB, 0.16802110E-09_JPRB, 0.16797516E-09_JPRB, 0.16795000E-09_JPRB, 0.16794946E-09_JPRB, &
  & 0.16796858E-09_JPRB, 0.16799792E-09_JPRB, 0.16803137E-09_JPRB, 0.16806705E-09_JPRB, 0.16810525E-09_JPRB, 0.16814619E-09_JPRB, &
  & 0.16818878E-09_JPRB, 0.16822828E-09_JPRB, 0.16825820E-09_JPRB, 0.16827306E-09_JPRB, 0.16827034E-09_JPRB, 0.16825145E-09_JPRB, &
  & 0.16821927E-09_JPRB, 0.16817711E-09_JPRB, 0.16813032E-09_JPRB, 0.16808223E-09_JPRB, 0.16803706E-09_JPRB, 0.16799867E-09_JPRB, &
  & 0.16797003E-09_JPRB, 0.16795233E-09_JPRB, 0.16794316E-09_JPRB, 0.16794108E-09_JPRB, 0.16794481E-09_JPRB, 0.16795272E-09_JPRB, &
  & 0.16796224E-09_JPRB, 0.16797030E-09_JPRB, 0.16797536E-09_JPRB, 0.16797669E-09_JPRB, 0.16797505E-09_JPRB, 0.16797159E-09_JPRB, &
  & 0.16796704E-09_JPRB, 0.16796130E-09_JPRB, 0.16795385E-09_JPRB, 0.16794319E-09_JPRB, 0.16792748E-09_JPRB, 0.16790691E-09_JPRB, &
  & 0.16788260E-09_JPRB, 0.16785384E-09_JPRB, 0.16781658E-09_JPRB, 0.16773791E-09_JPRB /)

RGHG8(:,53, 8) = (/ &
  & 0.16802273E-09_JPRB, 0.16813338E-09_JPRB, 0.16820903E-09_JPRB, 0.16828762E-09_JPRB, 0.16838539E-09_JPRB, 0.16846924E-09_JPRB, &
  & 0.16852361E-09_JPRB, 0.16855037E-09_JPRB, 0.16856609E-09_JPRB, 0.16857291E-09_JPRB, 0.16857375E-09_JPRB, 0.16856674E-09_JPRB, &
  & 0.16854858E-09_JPRB, 0.16851789E-09_JPRB, 0.16847575E-09_JPRB, 0.16842466E-09_JPRB, 0.16836743E-09_JPRB, 0.16830654E-09_JPRB, &
  & 0.16824062E-09_JPRB, 0.16817325E-09_JPRB, 0.16810231E-09_JPRB, 0.16803817E-09_JPRB, 0.16799122E-09_JPRB, 0.16797323E-09_JPRB, &
  & 0.16798225E-09_JPRB, 0.16800682E-09_JPRB, 0.16803811E-09_JPRB, 0.16807307E-09_JPRB, 0.16811133E-09_JPRB, 0.16815323E-09_JPRB, &
  & 0.16819769E-09_JPRB, 0.16823960E-09_JPRB, 0.16827230E-09_JPRB, 0.16828944E-09_JPRB, 0.16828838E-09_JPRB, 0.16827059E-09_JPRB, &
  & 0.16823851E-09_JPRB, 0.16819655E-09_JPRB, 0.16814934E-09_JPRB, 0.16810130E-09_JPRB, 0.16805544E-09_JPRB, 0.16801677E-09_JPRB, &
  & 0.16798898E-09_JPRB, 0.16797227E-09_JPRB, 0.16796577E-09_JPRB, 0.16796750E-09_JPRB, 0.16797672E-09_JPRB, 0.16799154E-09_JPRB, &
  & 0.16800850E-09_JPRB, 0.16802465E-09_JPRB, 0.16803763E-09_JPRB, 0.16804683E-09_JPRB, 0.16805213E-09_JPRB, 0.16805496E-09_JPRB, &
  & 0.16805604E-09_JPRB, 0.16805599E-09_JPRB, 0.16805476E-09_JPRB, 0.16805191E-09_JPRB, 0.16804658E-09_JPRB, 0.16803797E-09_JPRB, &
  & 0.16802647E-09_JPRB, 0.16801219E-09_JPRB, 0.16799195E-09_JPRB, 0.16794147E-09_JPRB /)

RGHG8(:,54, 8) = (/ &
  & 0.16829341E-09_JPRB, 0.16836682E-09_JPRB, 0.16841524E-09_JPRB, 0.16847211E-09_JPRB, 0.16853818E-09_JPRB, 0.16859844E-09_JPRB, &
  & 0.16863308E-09_JPRB, 0.16865197E-09_JPRB, 0.16866009E-09_JPRB, 0.16866322E-09_JPRB, 0.16866125E-09_JPRB, 0.16865226E-09_JPRB, &
  & 0.16863357E-09_JPRB, 0.16860295E-09_JPRB, 0.16856105E-09_JPRB, 0.16851051E-09_JPRB, 0.16845367E-09_JPRB, 0.16839133E-09_JPRB, &
  & 0.16832546E-09_JPRB, 0.16825186E-09_JPRB, 0.16817492E-09_JPRB, 0.16809623E-09_JPRB, 0.16803137E-09_JPRB, 0.16799713E-09_JPRB, &
  & 0.16799612E-09_JPRB, 0.16801585E-09_JPRB, 0.16804516E-09_JPRB, 0.16807930E-09_JPRB, 0.16811777E-09_JPRB, 0.16816060E-09_JPRB, &
  & 0.16820689E-09_JPRB, 0.16825150E-09_JPRB, 0.16828697E-09_JPRB, 0.16830648E-09_JPRB, 0.16830723E-09_JPRB, 0.16829038E-09_JPRB, &
  & 0.16825864E-09_JPRB, 0.16821664E-09_JPRB, 0.16816945E-09_JPRB, 0.16812064E-09_JPRB, 0.16807443E-09_JPRB, 0.16803567E-09_JPRB, &
  & 0.16800780E-09_JPRB, 0.16799243E-09_JPRB, 0.16798773E-09_JPRB, 0.16799261E-09_JPRB, 0.16800647E-09_JPRB, 0.16802658E-09_JPRB, &
  & 0.16804932E-09_JPRB, 0.16807050E-09_JPRB, 0.16808806E-09_JPRB, 0.16810062E-09_JPRB, 0.16810928E-09_JPRB, 0.16811438E-09_JPRB, &
  & 0.16811780E-09_JPRB, 0.16811992E-09_JPRB, 0.16812118E-09_JPRB, 0.16812154E-09_JPRB, 0.16812060E-09_JPRB, 0.16811796E-09_JPRB, &
  & 0.16811379E-09_JPRB, 0.16810869E-09_JPRB, 0.16810349E-09_JPRB, 0.16809766E-09_JPRB /)

RGHG8(:,55, 8) = (/ &
  & 0.16847826E-09_JPRB, 0.16853605E-09_JPRB, 0.16857341E-09_JPRB, 0.16861236E-09_JPRB, 0.16865649E-09_JPRB, 0.16869543E-09_JPRB, &
  & 0.16871940E-09_JPRB, 0.16872975E-09_JPRB, 0.16873422E-09_JPRB, 0.16873437E-09_JPRB, 0.16873046E-09_JPRB, 0.16872111E-09_JPRB, &
  & 0.16870272E-09_JPRB, 0.16867338E-09_JPRB, 0.16863354E-09_JPRB, 0.16858442E-09_JPRB, 0.16852827E-09_JPRB, 0.16846666E-09_JPRB, &
  & 0.16839750E-09_JPRB, 0.16832244E-09_JPRB, 0.16823734E-09_JPRB, 0.16814850E-09_JPRB, 0.16806963E-09_JPRB, 0.16802108E-09_JPRB, &
  & 0.16801081E-09_JPRB, 0.16802587E-09_JPRB, 0.16805299E-09_JPRB, 0.16808649E-09_JPRB, 0.16812500E-09_JPRB, 0.16816894E-09_JPRB, &
  & 0.16821715E-09_JPRB, 0.16826439E-09_JPRB, 0.16830264E-09_JPRB, 0.16832463E-09_JPRB, 0.16832724E-09_JPRB, 0.16831141E-09_JPRB, &
  & 0.16828001E-09_JPRB, 0.16823798E-09_JPRB, 0.16819041E-09_JPRB, 0.16814118E-09_JPRB, 0.16809427E-09_JPRB, 0.16805528E-09_JPRB, &
  & 0.16802806E-09_JPRB, 0.16801327E-09_JPRB, 0.16800997E-09_JPRB, 0.16801723E-09_JPRB, 0.16803448E-09_JPRB, 0.16805918E-09_JPRB, &
  & 0.16808602E-09_JPRB, 0.16811114E-09_JPRB, 0.16813143E-09_JPRB, 0.16814647E-09_JPRB, 0.16815579E-09_JPRB, 0.16816226E-09_JPRB, &
  & 0.16816620E-09_JPRB, 0.16816905E-09_JPRB, 0.16817106E-09_JPRB, 0.16817245E-09_JPRB, 0.16817298E-09_JPRB, 0.16817234E-09_JPRB, &
  & 0.16817044E-09_JPRB, 0.16816751E-09_JPRB, 0.16816373E-09_JPRB, 0.16815596E-09_JPRB /)

RGHG8(:,56, 8) = (/ &
  & 0.16863821E-09_JPRB, 0.16867410E-09_JPRB, 0.16869797E-09_JPRB, 0.16872245E-09_JPRB, 0.16875078E-09_JPRB, 0.16877504E-09_JPRB, &
  & 0.16878902E-09_JPRB, 0.16879521E-09_JPRB, 0.16879659E-09_JPRB, 0.16879503E-09_JPRB, 0.16879059E-09_JPRB, 0.16878103E-09_JPRB, &
  & 0.16876403E-09_JPRB, 0.16873711E-09_JPRB, 0.16869967E-09_JPRB, 0.16865315E-09_JPRB, 0.16859830E-09_JPRB, 0.16853545E-09_JPRB, &
  & 0.16846527E-09_JPRB, 0.16838415E-09_JPRB, 0.16829332E-09_JPRB, 0.16819522E-09_JPRB, 0.16810411E-09_JPRB, 0.16804531E-09_JPRB, &
  & 0.16802704E-09_JPRB, 0.16803756E-09_JPRB, 0.16806254E-09_JPRB, 0.16809508E-09_JPRB, 0.16813388E-09_JPRB, 0.16817889E-09_JPRB, &
  & 0.16822914E-09_JPRB, 0.16827903E-09_JPRB, 0.16832012E-09_JPRB, 0.16834457E-09_JPRB, 0.16834893E-09_JPRB, 0.16833414E-09_JPRB, &
  & 0.16830309E-09_JPRB, 0.16826103E-09_JPRB, 0.16821300E-09_JPRB, 0.16816287E-09_JPRB, 0.16811555E-09_JPRB, 0.16807666E-09_JPRB, &
  & 0.16804971E-09_JPRB, 0.16803577E-09_JPRB, 0.16803346E-09_JPRB, 0.16804226E-09_JPRB, 0.16806216E-09_JPRB, 0.16808968E-09_JPRB, &
  & 0.16812030E-09_JPRB, 0.16814861E-09_JPRB, 0.16817156E-09_JPRB, 0.16818735E-09_JPRB, 0.16819818E-09_JPRB, 0.16820434E-09_JPRB, &
  & 0.16820861E-09_JPRB, 0.16821140E-09_JPRB, 0.16821343E-09_JPRB, 0.16821490E-09_JPRB, 0.16821573E-09_JPRB, 0.16821566E-09_JPRB, &
  & 0.16821462E-09_JPRB, 0.16821280E-09_JPRB, 0.16821042E-09_JPRB, 0.16820613E-09_JPRB /)

RGHG8(:,57, 8) = (/ &
  & 0.16874807E-09_JPRB, 0.16877745E-09_JPRB, 0.16879437E-09_JPRB, 0.16881122E-09_JPRB, 0.16882756E-09_JPRB, 0.16884227E-09_JPRB, &
  & 0.16885054E-09_JPRB, 0.16885315E-09_JPRB, 0.16885288E-09_JPRB, 0.16885063E-09_JPRB, 0.16884577E-09_JPRB, 0.16883714E-09_JPRB, &
  & 0.16882183E-09_JPRB, 0.16879753E-09_JPRB, 0.16876353E-09_JPRB, 0.16871934E-09_JPRB, 0.16866561E-09_JPRB, 0.16860217E-09_JPRB, &
  & 0.16852759E-09_JPRB, 0.16844184E-09_JPRB, 0.16834294E-09_JPRB, 0.16823543E-09_JPRB, 0.16813660E-09_JPRB, 0.16806966E-09_JPRB, &
  & 0.16804536E-09_JPRB, 0.16805174E-09_JPRB, 0.16807442E-09_JPRB, 0.16810625E-09_JPRB, 0.16814523E-09_JPRB, 0.16819142E-09_JPRB, &
  & 0.16824364E-09_JPRB, 0.16829625E-09_JPRB, 0.16834004E-09_JPRB, 0.16836690E-09_JPRB, 0.16837289E-09_JPRB, 0.16835909E-09_JPRB, &
  & 0.16832861E-09_JPRB, 0.16828633E-09_JPRB, 0.16823762E-09_JPRB, 0.16818694E-09_JPRB, 0.16813895E-09_JPRB, 0.16810021E-09_JPRB, &
  & 0.16807386E-09_JPRB, 0.16806043E-09_JPRB, 0.16805891E-09_JPRB, 0.16806888E-09_JPRB, 0.16809010E-09_JPRB, 0.16811981E-09_JPRB, &
  & 0.16815298E-09_JPRB, 0.16818411E-09_JPRB, 0.16820947E-09_JPRB, 0.16822753E-09_JPRB, 0.16823806E-09_JPRB, 0.16824481E-09_JPRB, &
  & 0.16824867E-09_JPRB, 0.16825120E-09_JPRB, 0.16825286E-09_JPRB, 0.16825388E-09_JPRB, 0.16825430E-09_JPRB, 0.16825390E-09_JPRB, &
  & 0.16825261E-09_JPRB, 0.16825061E-09_JPRB, 0.16824805E-09_JPRB, 0.16824259E-09_JPRB /)

RGHG8(:,58, 8) = (/ &
  & 0.16884333E-09_JPRB, 0.16886276E-09_JPRB, 0.16887426E-09_JPRB, 0.16888400E-09_JPRB, 0.16889415E-09_JPRB, 0.16890220E-09_JPRB, &
  & 0.16890649E-09_JPRB, 0.16890733E-09_JPRB, 0.16890628E-09_JPRB, 0.16890367E-09_JPRB, 0.16889926E-09_JPRB, 0.16889144E-09_JPRB, &
  & 0.16887811E-09_JPRB, 0.16885685E-09_JPRB, 0.16882580E-09_JPRB, 0.16878454E-09_JPRB, 0.16873153E-09_JPRB, 0.16866625E-09_JPRB, &
  & 0.16858777E-09_JPRB, 0.16849443E-09_JPRB, 0.16838753E-09_JPRB, 0.16827253E-09_JPRB, 0.16816704E-09_JPRB, 0.16809540E-09_JPRB, &
  & 0.16806641E-09_JPRB, 0.16806911E-09_JPRB, 0.16808974E-09_JPRB, 0.16812084E-09_JPRB, 0.16816010E-09_JPRB, 0.16820749E-09_JPRB, &
  & 0.16826175E-09_JPRB, 0.16831687E-09_JPRB, 0.16836335E-09_JPRB, 0.16839220E-09_JPRB, 0.16839972E-09_JPRB, 0.16838705E-09_JPRB, &
  & 0.16835693E-09_JPRB, 0.16831461E-09_JPRB, 0.16826530E-09_JPRB, 0.16821362E-09_JPRB, 0.16816543E-09_JPRB, 0.16812679E-09_JPRB, &
  & 0.16810095E-09_JPRB, 0.16808803E-09_JPRB, 0.16808716E-09_JPRB, 0.16809784E-09_JPRB, 0.16812000E-09_JPRB, 0.16815063E-09_JPRB, &
  & 0.16818524E-09_JPRB, 0.16821920E-09_JPRB, 0.16824711E-09_JPRB, 0.16826647E-09_JPRB, 0.16827853E-09_JPRB, 0.16828489E-09_JPRB, &
  & 0.16828855E-09_JPRB, 0.16829058E-09_JPRB, 0.16829160E-09_JPRB, 0.16829195E-09_JPRB, 0.16829158E-09_JPRB, 0.16829038E-09_JPRB, &
  & 0.16828847E-09_JPRB, 0.16828605E-09_JPRB, 0.16828311E-09_JPRB, 0.16827785E-09_JPRB /)

RGHG8(:,59, 8) = (/ &
  & 0.16891653E-09_JPRB, 0.16893273E-09_JPRB, 0.16894089E-09_JPRB, 0.16894758E-09_JPRB, 0.16895324E-09_JPRB, 0.16895785E-09_JPRB, &
  & 0.16895990E-09_JPRB, 0.16895976E-09_JPRB, 0.16895840E-09_JPRB, 0.16895604E-09_JPRB, 0.16895209E-09_JPRB, 0.16894547E-09_JPRB, &
  & 0.16893413E-09_JPRB, 0.16891541E-09_JPRB, 0.16888765E-09_JPRB, 0.16884827E-09_JPRB, 0.16879621E-09_JPRB, 0.16872836E-09_JPRB, &
  & 0.16864445E-09_JPRB, 0.16854407E-09_JPRB, 0.16842890E-09_JPRB, 0.16830765E-09_JPRB, 0.16819829E-09_JPRB, 0.16812375E-09_JPRB, &
  & 0.16809101E-09_JPRB, 0.16809054E-09_JPRB, 0.16810928E-09_JPRB, 0.16813975E-09_JPRB, 0.16817953E-09_JPRB, 0.16822814E-09_JPRB, &
  & 0.16828443E-09_JPRB, 0.16834203E-09_JPRB, 0.16839079E-09_JPRB, 0.16842155E-09_JPRB, 0.16843027E-09_JPRB, 0.16841840E-09_JPRB, &
  & 0.16838901E-09_JPRB, 0.16834650E-09_JPRB, 0.16829654E-09_JPRB, 0.16824434E-09_JPRB, 0.16819554E-09_JPRB, 0.16815725E-09_JPRB, &
  & 0.16813176E-09_JPRB, 0.16811931E-09_JPRB, 0.16811888E-09_JPRB, 0.16813009E-09_JPRB, 0.16815276E-09_JPRB, 0.16818376E-09_JPRB, &
  & 0.16821941E-09_JPRB, 0.16825423E-09_JPRB, 0.16828489E-09_JPRB, 0.16830681E-09_JPRB, 0.16831962E-09_JPRB, 0.16832637E-09_JPRB, &
  & 0.16832963E-09_JPRB, 0.16833095E-09_JPRB, 0.16833110E-09_JPRB, 0.16833043E-09_JPRB, 0.16832891E-09_JPRB, 0.16832652E-09_JPRB, &
  & 0.16832347E-09_JPRB, 0.16831994E-09_JPRB, 0.16831606E-09_JPRB, 0.16830887E-09_JPRB /)

RGHG8(:,60, 8) = (/ &
  & 0.16898292E-09_JPRB, 0.16899486E-09_JPRB, 0.16900066E-09_JPRB, 0.16900488E-09_JPRB, 0.16900853E-09_JPRB, 0.16901111E-09_JPRB, &
  & 0.16901211E-09_JPRB, 0.16901167E-09_JPRB, 0.16901044E-09_JPRB, 0.16900840E-09_JPRB, 0.16900520E-09_JPRB, 0.16899970E-09_JPRB, &
  & 0.16898999E-09_JPRB, 0.16897385E-09_JPRB, 0.16894822E-09_JPRB, 0.16891118E-09_JPRB, 0.16885823E-09_JPRB, 0.16878843E-09_JPRB, &
  & 0.16869853E-09_JPRB, 0.16859121E-09_JPRB, 0.16846997E-09_JPRB, 0.16834401E-09_JPRB, 0.16823271E-09_JPRB, 0.16815577E-09_JPRB, &
  & 0.16812002E-09_JPRB, 0.16811683E-09_JPRB, 0.16813398E-09_JPRB, 0.16816422E-09_JPRB, 0.16820451E-09_JPRB, 0.16825463E-09_JPRB, &
  & 0.16831281E-09_JPRB, 0.16837264E-09_JPRB, 0.16842355E-09_JPRB, 0.16845560E-09_JPRB, 0.16846513E-09_JPRB, 0.16845400E-09_JPRB, &
  & 0.16842498E-09_JPRB, 0.16838264E-09_JPRB, 0.16833228E-09_JPRB, 0.16827936E-09_JPRB, 0.16823058E-09_JPRB, 0.16819234E-09_JPRB, &
  & 0.16816733E-09_JPRB, 0.16815500E-09_JPRB, 0.16815482E-09_JPRB, 0.16816637E-09_JPRB, 0.16818934E-09_JPRB, 0.16822049E-09_JPRB, &
  & 0.16825610E-09_JPRB, 0.16829210E-09_JPRB, 0.16832366E-09_JPRB, 0.16834827E-09_JPRB, 0.16836285E-09_JPRB, 0.16837018E-09_JPRB, &
  & 0.16837298E-09_JPRB, 0.16837345E-09_JPRB, 0.16837244E-09_JPRB, 0.16837035E-09_JPRB, 0.16836729E-09_JPRB, 0.16836325E-09_JPRB, &
  & 0.16835863E-09_JPRB, 0.16835376E-09_JPRB, 0.16834838E-09_JPRB, 0.16833920E-09_JPRB /)

RGHG8(:,61, 8) = (/ &
  & 0.16904089E-09_JPRB, 0.16905109E-09_JPRB, 0.16905577E-09_JPRB, 0.16905896E-09_JPRB, 0.16906138E-09_JPRB, 0.16906310E-09_JPRB, &
  & 0.16906371E-09_JPRB, 0.16906332E-09_JPRB, 0.16906238E-09_JPRB, 0.16906088E-09_JPRB, 0.16905838E-09_JPRB, 0.16905397E-09_JPRB, &
  & 0.16904594E-09_JPRB, 0.16903146E-09_JPRB, 0.16900811E-09_JPRB, 0.16897143E-09_JPRB, 0.16891913E-09_JPRB, 0.16884485E-09_JPRB, &
  & 0.16875149E-09_JPRB, 0.16863860E-09_JPRB, 0.16851291E-09_JPRB, 0.16838450E-09_JPRB, 0.16827174E-09_JPRB, 0.16819283E-09_JPRB, &
  & 0.16815441E-09_JPRB, 0.16814880E-09_JPRB, 0.16816484E-09_JPRB, 0.16819503E-09_JPRB, 0.16823637E-09_JPRB, 0.16828793E-09_JPRB, &
  & 0.16834820E-09_JPRB, 0.16841001E-09_JPRB, 0.16846241E-09_JPRB, 0.16849536E-09_JPRB, 0.16850515E-09_JPRB, 0.16849437E-09_JPRB, &
  & 0.16846584E-09_JPRB, 0.16842361E-09_JPRB, 0.16837312E-09_JPRB, 0.16832000E-09_JPRB, 0.16827094E-09_JPRB, 0.16823308E-09_JPRB, &
  & 0.16820816E-09_JPRB, 0.16819610E-09_JPRB, 0.16819601E-09_JPRB, 0.16820753E-09_JPRB, 0.16823047E-09_JPRB, 0.16826149E-09_JPRB, &
  & 0.16829727E-09_JPRB, 0.16833310E-09_JPRB, 0.16836593E-09_JPRB, 0.16839166E-09_JPRB, 0.16840912E-09_JPRB, 0.16841703E-09_JPRB, &
  & 0.16841982E-09_JPRB, 0.16841922E-09_JPRB, 0.16841653E-09_JPRB, 0.16841267E-09_JPRB, 0.16840759E-09_JPRB, 0.16840149E-09_JPRB, &
  & 0.16839485E-09_JPRB, 0.16838789E-09_JPRB, 0.16838035E-09_JPRB, 0.16836740E-09_JPRB /)

RGHG8(:,62, 8) = (/ &
  & 0.16909592E-09_JPRB, 0.16910456E-09_JPRB, 0.16910838E-09_JPRB, 0.16911095E-09_JPRB, 0.16911297E-09_JPRB, 0.16911443E-09_JPRB, &
  & 0.16911514E-09_JPRB, 0.16911512E-09_JPRB, 0.16911469E-09_JPRB, 0.16911372E-09_JPRB, 0.16911193E-09_JPRB, 0.16910845E-09_JPRB, &
  & 0.16910165E-09_JPRB, 0.16908890E-09_JPRB, 0.16906629E-09_JPRB, 0.16903104E-09_JPRB, 0.16897608E-09_JPRB, 0.16890145E-09_JPRB, &
  & 0.16880344E-09_JPRB, 0.16868829E-09_JPRB, 0.16856000E-09_JPRB, 0.16843039E-09_JPRB, 0.16831637E-09_JPRB, 0.16823608E-09_JPRB, &
  & 0.16819521E-09_JPRB, 0.16818774E-09_JPRB, 0.16820297E-09_JPRB, 0.16823369E-09_JPRB, 0.16827616E-09_JPRB, 0.16832967E-09_JPRB, &
  & 0.16839184E-09_JPRB, 0.16845549E-09_JPRB, 0.16850889E-09_JPRB, 0.16854187E-09_JPRB, 0.16855151E-09_JPRB, 0.16854071E-09_JPRB, &
  & 0.16851240E-09_JPRB, 0.16847052E-09_JPRB, 0.16842013E-09_JPRB, 0.16836692E-09_JPRB, 0.16831804E-09_JPRB, 0.16828013E-09_JPRB, &
  & 0.16825559E-09_JPRB, 0.16824341E-09_JPRB, 0.16824318E-09_JPRB, 0.16825452E-09_JPRB, 0.16827707E-09_JPRB, 0.16830773E-09_JPRB, &
  & 0.16834323E-09_JPRB, 0.16837916E-09_JPRB, 0.16841199E-09_JPRB, 0.16843943E-09_JPRB, 0.16845801E-09_JPRB, 0.16846824E-09_JPRB, &
  & 0.16847096E-09_JPRB, 0.16846910E-09_JPRB, 0.16846446E-09_JPRB, 0.16845823E-09_JPRB, 0.16845081E-09_JPRB, 0.16844219E-09_JPRB, &
  & 0.16843313E-09_JPRB, 0.16842339E-09_JPRB, 0.16841301E-09_JPRB, 0.16839430E-09_JPRB /)

RGHG8(:,63, 8) = (/ &
  & 0.16914697E-09_JPRB, 0.16915551E-09_JPRB, 0.16915934E-09_JPRB, 0.16916189E-09_JPRB, 0.16916388E-09_JPRB, 0.16916546E-09_JPRB, &
  & 0.16916649E-09_JPRB, 0.16916693E-09_JPRB, 0.16916706E-09_JPRB, 0.16916675E-09_JPRB, 0.16916574E-09_JPRB, 0.16916329E-09_JPRB, &
  & 0.16915763E-09_JPRB, 0.16914567E-09_JPRB, 0.16912438E-09_JPRB, 0.16908795E-09_JPRB, 0.16903393E-09_JPRB, 0.16895607E-09_JPRB, &
  & 0.16885818E-09_JPRB, 0.16874119E-09_JPRB, 0.16861215E-09_JPRB, 0.16848165E-09_JPRB, 0.16836790E-09_JPRB, 0.16828618E-09_JPRB, &
  & 0.16824375E-09_JPRB, 0.16823490E-09_JPRB, 0.16824983E-09_JPRB, 0.16828139E-09_JPRB, 0.16832555E-09_JPRB, 0.16838089E-09_JPRB, &
  & 0.16844522E-09_JPRB, 0.16851014E-09_JPRB, 0.16856389E-09_JPRB, 0.16859619E-09_JPRB, 0.16860503E-09_JPRB, 0.16859389E-09_JPRB, &
  & 0.16856577E-09_JPRB, 0.16852436E-09_JPRB, 0.16847428E-09_JPRB, 0.16842133E-09_JPRB, 0.16837255E-09_JPRB, 0.16833496E-09_JPRB, &
  & 0.16831041E-09_JPRB, 0.16829814E-09_JPRB, 0.16829754E-09_JPRB, 0.16830830E-09_JPRB, 0.16833014E-09_JPRB, 0.16836008E-09_JPRB, &
  & 0.16839508E-09_JPRB, 0.16843080E-09_JPRB, 0.16846390E-09_JPRB, 0.16849158E-09_JPRB, 0.16851220E-09_JPRB, 0.16852336E-09_JPRB, &
  & 0.16852697E-09_JPRB, 0.16852418E-09_JPRB, 0.16851692E-09_JPRB, 0.16850826E-09_JPRB, 0.16849817E-09_JPRB, 0.16848720E-09_JPRB, &
  & 0.16847498E-09_JPRB, 0.16846233E-09_JPRB, 0.16844752E-09_JPRB, 0.16842182E-09_JPRB /)

RGHG8(:,64, 8) = (/ &
  & 0.16919607E-09_JPRB, 0.16920505E-09_JPRB, 0.16920912E-09_JPRB, 0.16921189E-09_JPRB, 0.16921414E-09_JPRB, 0.16921597E-09_JPRB, &
  & 0.16921745E-09_JPRB, 0.16921842E-09_JPRB, 0.16921922E-09_JPRB, 0.16921967E-09_JPRB, 0.16921951E-09_JPRB, 0.16921804E-09_JPRB, &
  & 0.16921339E-09_JPRB, 0.16920240E-09_JPRB, 0.16918075E-09_JPRB, 0.16914534E-09_JPRB, 0.16908955E-09_JPRB, 0.16901303E-09_JPRB, &
  & 0.16891438E-09_JPRB, 0.16879786E-09_JPRB, 0.16866877E-09_JPRB, 0.16853952E-09_JPRB, 0.16842586E-09_JPRB, 0.16834439E-09_JPRB, &
  & 0.16830093E-09_JPRB, 0.16829127E-09_JPRB, 0.16830631E-09_JPRB, 0.16833902E-09_JPRB, 0.16838483E-09_JPRB, 0.16844214E-09_JPRB, &
  & 0.16850808E-09_JPRB, 0.16857378E-09_JPRB, 0.16862682E-09_JPRB, 0.16865775E-09_JPRB, 0.16866529E-09_JPRB, 0.16865363E-09_JPRB, &
  & 0.16862579E-09_JPRB, 0.16858508E-09_JPRB, 0.16853574E-09_JPRB, 0.16848328E-09_JPRB, 0.16843499E-09_JPRB, 0.16839760E-09_JPRB, &
  & 0.16837323E-09_JPRB, 0.16836071E-09_JPRB, 0.16835949E-09_JPRB, 0.16836949E-09_JPRB, 0.16839019E-09_JPRB, 0.16841906E-09_JPRB, &
  & 0.16845313E-09_JPRB, 0.16848840E-09_JPRB, 0.16852156E-09_JPRB, 0.16854976E-09_JPRB, 0.16857099E-09_JPRB, 0.16858361E-09_JPRB, &
  & 0.16858777E-09_JPRB, 0.16858402E-09_JPRB, 0.16857464E-09_JPRB, 0.16856336E-09_JPRB, 0.16855124E-09_JPRB, 0.16853732E-09_JPRB, &
  & 0.16852275E-09_JPRB, 0.16850571E-09_JPRB, 0.16848710E-09_JPRB, 0.16845057E-09_JPRB /)

RGHG8(:,65, 8) = (/ &
  & 0.16924304E-09_JPRB, 0.16925301E-09_JPRB, 0.16925769E-09_JPRB, 0.16926095E-09_JPRB, 0.16926360E-09_JPRB, 0.16926595E-09_JPRB, &
  & 0.16926785E-09_JPRB, 0.16926949E-09_JPRB, 0.16927101E-09_JPRB, 0.16927232E-09_JPRB, 0.16927318E-09_JPRB, 0.16927275E-09_JPRB, &
  & 0.16926889E-09_JPRB, 0.16925819E-09_JPRB, 0.16923726E-09_JPRB, 0.16920122E-09_JPRB, 0.16914677E-09_JPRB, 0.16907034E-09_JPRB, &
  & 0.16897331E-09_JPRB, 0.16885777E-09_JPRB, 0.16873068E-09_JPRB, 0.16860277E-09_JPRB, 0.16849167E-09_JPRB, 0.16841076E-09_JPRB, &
  & 0.16836740E-09_JPRB, 0.16835752E-09_JPRB, 0.16837294E-09_JPRB, 0.16840661E-09_JPRB, 0.16845390E-09_JPRB, 0.16851254E-09_JPRB, &
  & 0.16857929E-09_JPRB, 0.16864461E-09_JPRB, 0.16869600E-09_JPRB, 0.16872488E-09_JPRB, 0.16873086E-09_JPRB, 0.16871872E-09_JPRB, &
  & 0.16869139E-09_JPRB, 0.16865179E-09_JPRB, 0.16860377E-09_JPRB, 0.16855252E-09_JPRB, 0.16850511E-09_JPRB, 0.16846841E-09_JPRB, &
  & 0.16844424E-09_JPRB, 0.16843145E-09_JPRB, 0.16842952E-09_JPRB, 0.16843844E-09_JPRB, 0.16845765E-09_JPRB, 0.16848505E-09_JPRB, &
  & 0.16851796E-09_JPRB, 0.16855244E-09_JPRB, 0.16858542E-09_JPRB, 0.16861390E-09_JPRB, 0.16863576E-09_JPRB, 0.16864897E-09_JPRB, &
  & 0.16865359E-09_JPRB, 0.16864919E-09_JPRB, 0.16863771E-09_JPRB, 0.16862457E-09_JPRB, 0.16861013E-09_JPRB, 0.16859428E-09_JPRB, &
  & 0.16857631E-09_JPRB, 0.16855625E-09_JPRB, 0.16853199E-09_JPRB, 0.16848543E-09_JPRB /)

RGHG8(:,66, 8) = (/ &
  & 0.16928803E-09_JPRB, 0.16929982E-09_JPRB, 0.16930540E-09_JPRB, 0.16930940E-09_JPRB, 0.16931270E-09_JPRB, 0.16931553E-09_JPRB, &
  & 0.16931807E-09_JPRB, 0.16932009E-09_JPRB, 0.16932257E-09_JPRB, 0.16932464E-09_JPRB, 0.16932648E-09_JPRB, 0.16932701E-09_JPRB, &
  & 0.16932382E-09_JPRB, 0.16931356E-09_JPRB, 0.16929279E-09_JPRB, 0.16925772E-09_JPRB, 0.16920391E-09_JPRB, 0.16912946E-09_JPRB, &
  & 0.16903433E-09_JPRB, 0.16892145E-09_JPRB, 0.16879687E-09_JPRB, 0.16867317E-09_JPRB, 0.16856465E-09_JPRB, 0.16848611E-09_JPRB, &
  & 0.16844334E-09_JPRB, 0.16843367E-09_JPRB, 0.16844921E-09_JPRB, 0.16848341E-09_JPRB, 0.16853131E-09_JPRB, 0.16859024E-09_JPRB, &
  & 0.16865655E-09_JPRB, 0.16872027E-09_JPRB, 0.16876929E-09_JPRB, 0.16879566E-09_JPRB, 0.16880009E-09_JPRB, 0.16878754E-09_JPRB, &
  & 0.16876109E-09_JPRB, 0.16872319E-09_JPRB, 0.16867720E-09_JPRB, 0.16862789E-09_JPRB, 0.16858215E-09_JPRB, 0.16854665E-09_JPRB, &
  & 0.16852307E-09_JPRB, 0.16851022E-09_JPRB, 0.16850749E-09_JPRB, 0.16851513E-09_JPRB, 0.16853266E-09_JPRB, 0.16855840E-09_JPRB, &
  & 0.16858978E-09_JPRB, 0.16862330E-09_JPRB, 0.16865580E-09_JPRB, 0.16868426E-09_JPRB, 0.16870651E-09_JPRB, 0.16872015E-09_JPRB, &
  & 0.16872490E-09_JPRB, 0.16871983E-09_JPRB, 0.16870687E-09_JPRB, 0.16869196E-09_JPRB, 0.16867589E-09_JPRB, 0.16865770E-09_JPRB, &
  & 0.16863753E-09_JPRB, 0.16861414E-09_JPRB, 0.16858552E-09_JPRB, 0.16852841E-09_JPRB /)

RGHG8(:,67, 8) = (/ &
  & 0.16933110E-09_JPRB, 0.16934548E-09_JPRB, 0.16935243E-09_JPRB, 0.16935744E-09_JPRB, 0.16936158E-09_JPRB, 0.16936519E-09_JPRB, &
  & 0.16936819E-09_JPRB, 0.16937096E-09_JPRB, 0.16937386E-09_JPRB, 0.16937696E-09_JPRB, 0.16937962E-09_JPRB, 0.16938077E-09_JPRB, &
  & 0.16937794E-09_JPRB, 0.16936805E-09_JPRB, 0.16934804E-09_JPRB, 0.16931383E-09_JPRB, 0.16926180E-09_JPRB, 0.16918966E-09_JPRB, &
  & 0.16909771E-09_JPRB, 0.16898842E-09_JPRB, 0.16886878E-09_JPRB, 0.16874922E-09_JPRB, 0.16864572E-09_JPRB, 0.16856977E-09_JPRB, &
  & 0.16852837E-09_JPRB, 0.16851892E-09_JPRB, 0.16853431E-09_JPRB, 0.16856821E-09_JPRB, 0.16861570E-09_JPRB, 0.16867373E-09_JPRB, &
  & 0.16873818E-09_JPRB, 0.16879942E-09_JPRB, 0.16884534E-09_JPRB, 0.16886911E-09_JPRB, 0.16887194E-09_JPRB, 0.16885929E-09_JPRB, &
  & 0.16883409E-09_JPRB, 0.16879835E-09_JPRB, 0.16875497E-09_JPRB, 0.16870837E-09_JPRB, 0.16866514E-09_JPRB, 0.16863154E-09_JPRB, &
  & 0.16860914E-09_JPRB, 0.16859632E-09_JPRB, 0.16859296E-09_JPRB, 0.16859933E-09_JPRB, 0.16861515E-09_JPRB, 0.16863905E-09_JPRB, &
  & 0.16866893E-09_JPRB, 0.16870122E-09_JPRB, 0.16873306E-09_JPRB, 0.16876121E-09_JPRB, 0.16878354E-09_JPRB, 0.16879743E-09_JPRB, &
  & 0.16880214E-09_JPRB, 0.16879657E-09_JPRB, 0.16878243E-09_JPRB, 0.16876629E-09_JPRB, 0.16874868E-09_JPRB, 0.16872881E-09_JPRB, &
  & 0.16870662E-09_JPRB, 0.16868063E-09_JPRB, 0.16864793E-09_JPRB, 0.16857984E-09_JPRB /)

RGHG8(:,68, 8) = (/ &
  & 0.16937138E-09_JPRB, 0.16938995E-09_JPRB, 0.16939902E-09_JPRB, 0.16940545E-09_JPRB, 0.16941069E-09_JPRB, 0.16941508E-09_JPRB, &
  & 0.16941878E-09_JPRB, 0.16942180E-09_JPRB, 0.16942574E-09_JPRB, 0.16942914E-09_JPRB, 0.16943250E-09_JPRB, 0.16943387E-09_JPRB, &
  & 0.16943123E-09_JPRB, 0.16942182E-09_JPRB, 0.16940271E-09_JPRB, 0.16936993E-09_JPRB, 0.16932010E-09_JPRB, 0.16925114E-09_JPRB, &
  & 0.16916329E-09_JPRB, 0.16905918E-09_JPRB, 0.16894498E-09_JPRB, 0.16883206E-09_JPRB, 0.16873346E-09_JPRB, 0.16866136E-09_JPRB, &
  & 0.16862146E-09_JPRB, 0.16861219E-09_JPRB, 0.16862693E-09_JPRB, 0.16865984E-09_JPRB, 0.16870581E-09_JPRB, 0.16876175E-09_JPRB, &
  & 0.16882344E-09_JPRB, 0.16888131E-09_JPRB, 0.16892386E-09_JPRB, 0.16894493E-09_JPRB, 0.16894633E-09_JPRB, 0.16893377E-09_JPRB, &
  & 0.16891014E-09_JPRB, 0.16887680E-09_JPRB, 0.16883642E-09_JPRB, 0.16879306E-09_JPRB, 0.16875285E-09_JPRB, 0.16872191E-09_JPRB, &
  & 0.16870115E-09_JPRB, 0.16868902E-09_JPRB, 0.16868518E-09_JPRB, 0.16869044E-09_JPRB, 0.16870465E-09_JPRB, 0.16872692E-09_JPRB, &
  & 0.16875516E-09_JPRB, 0.16878628E-09_JPRB, 0.16881710E-09_JPRB, 0.16884474E-09_JPRB, 0.16886692E-09_JPRB, 0.16888076E-09_JPRB, &
  & 0.16888545E-09_JPRB, 0.16887952E-09_JPRB, 0.16886478E-09_JPRB, 0.16884780E-09_JPRB, 0.16882927E-09_JPRB, 0.16880827E-09_JPRB, &
  & 0.16878463E-09_JPRB, 0.16875744E-09_JPRB, 0.16872127E-09_JPRB, 0.16864644E-09_JPRB /)

RGHG8(:,69, 8) = (/ &
  & 0.16940846E-09_JPRB, 0.16943372E-09_JPRB, 0.16944557E-09_JPRB, 0.16945398E-09_JPRB, 0.16946047E-09_JPRB, 0.16946577E-09_JPRB, &
  & 0.16946995E-09_JPRB, 0.16947350E-09_JPRB, 0.16947772E-09_JPRB, 0.16948164E-09_JPRB, 0.16948505E-09_JPRB, 0.16948645E-09_JPRB, &
  & 0.16948398E-09_JPRB, 0.16947502E-09_JPRB, 0.16945691E-09_JPRB, 0.16942592E-09_JPRB, 0.16937883E-09_JPRB, 0.16931387E-09_JPRB, &
  & 0.16923124E-09_JPRB, 0.16913332E-09_JPRB, 0.16902653E-09_JPRB, 0.16892029E-09_JPRB, 0.16882810E-09_JPRB, 0.16875995E-09_JPRB, &
  & 0.16872183E-09_JPRB, 0.16871252E-09_JPRB, 0.16872621E-09_JPRB, 0.16875737E-09_JPRB, 0.16880100E-09_JPRB, 0.16885396E-09_JPRB, &
  & 0.16891204E-09_JPRB, 0.16896601E-09_JPRB, 0.16900495E-09_JPRB, 0.16902349E-09_JPRB, 0.16902363E-09_JPRB, 0.16901135E-09_JPRB, &
  & 0.16898935E-09_JPRB, 0.16895869E-09_JPRB, 0.16892157E-09_JPRB, 0.16888174E-09_JPRB, 0.16884506E-09_JPRB, 0.16881706E-09_JPRB, &
  & 0.16879854E-09_JPRB, 0.16878747E-09_JPRB, 0.16878368E-09_JPRB, 0.16878815E-09_JPRB, 0.16880097E-09_JPRB, 0.16882176E-09_JPRB, &
  & 0.16884857E-09_JPRB, 0.16887831E-09_JPRB, 0.16890807E-09_JPRB, 0.16893505E-09_JPRB, 0.16895677E-09_JPRB, 0.16897038E-09_JPRB, &
  & 0.16897500E-09_JPRB, 0.16896912E-09_JPRB, 0.16895429E-09_JPRB, 0.16893707E-09_JPRB, 0.16891825E-09_JPRB, 0.16889701E-09_JPRB, &
  & 0.16887283E-09_JPRB, 0.16884510E-09_JPRB, 0.16880723E-09_JPRB, 0.16872449E-09_JPRB /)

RGHG8(:,70, 8) = (/ &
  & 0.16944302E-09_JPRB, 0.16947693E-09_JPRB, 0.16949314E-09_JPRB, 0.16950358E-09_JPRB, 0.16951152E-09_JPRB, 0.16951753E-09_JPRB, &
  & 0.16952217E-09_JPRB, 0.16952592E-09_JPRB, 0.16953043E-09_JPRB, 0.16953428E-09_JPRB, 0.16953755E-09_JPRB, 0.16953879E-09_JPRB, &
  & 0.16953627E-09_JPRB, 0.16952781E-09_JPRB, 0.16951084E-09_JPRB, 0.16948185E-09_JPRB, 0.16943802E-09_JPRB, 0.16937780E-09_JPRB, &
  & 0.16930132E-09_JPRB, 0.16921092E-09_JPRB, 0.16911207E-09_JPRB, 0.16901409E-09_JPRB, 0.16892850E-09_JPRB, 0.16886488E-09_JPRB, &
  & 0.16882860E-09_JPRB, 0.16881913E-09_JPRB, 0.16883145E-09_JPRB, 0.16886029E-09_JPRB, 0.16890085E-09_JPRB, 0.16895003E-09_JPRB, &
  & 0.16900384E-09_JPRB, 0.16905352E-09_JPRB, 0.16908866E-09_JPRB, 0.16910467E-09_JPRB, 0.16910380E-09_JPRB, 0.16909196E-09_JPRB, &
  & 0.16907174E-09_JPRB, 0.16904385E-09_JPRB, 0.16901013E-09_JPRB, 0.16897400E-09_JPRB, 0.16894111E-09_JPRB, 0.16891641E-09_JPRB, &
  & 0.16890060E-09_JPRB, 0.16889107E-09_JPRB, 0.16888779E-09_JPRB, 0.16889184E-09_JPRB, 0.16890365E-09_JPRB, 0.16892321E-09_JPRB, &
  & 0.16894873E-09_JPRB, 0.16897708E-09_JPRB, 0.16900553E-09_JPRB, 0.16903157E-09_JPRB, 0.16905249E-09_JPRB, 0.16906590E-09_JPRB, &
  & 0.16907052E-09_JPRB, 0.16906514E-09_JPRB, 0.16905080E-09_JPRB, 0.16903424E-09_JPRB, 0.16901595E-09_JPRB, 0.16899551E-09_JPRB, &
  & 0.16897173E-09_JPRB, 0.16894508E-09_JPRB, 0.16890753E-09_JPRB, 0.16882507E-09_JPRB /)

RGHG8(:,71, 8) = (/ &
  & 0.16947668E-09_JPRB, 0.16952242E-09_JPRB, 0.16954252E-09_JPRB, 0.16955531E-09_JPRB, 0.16956417E-09_JPRB, 0.16957080E-09_JPRB, &
  & 0.16957562E-09_JPRB, 0.16957945E-09_JPRB, 0.16958399E-09_JPRB, 0.16958737E-09_JPRB, 0.16959033E-09_JPRB, 0.16959120E-09_JPRB, &
  & 0.16958862E-09_JPRB, 0.16958054E-09_JPRB, 0.16956474E-09_JPRB, 0.16953794E-09_JPRB, 0.16949792E-09_JPRB, 0.16944279E-09_JPRB, &
  & 0.16937338E-09_JPRB, 0.16929115E-09_JPRB, 0.16920146E-09_JPRB, 0.16911207E-09_JPRB, 0.16903397E-09_JPRB, 0.16897526E-09_JPRB, &
  & 0.16894106E-09_JPRB, 0.16893133E-09_JPRB, 0.16894194E-09_JPRB, 0.16896806E-09_JPRB, 0.16900489E-09_JPRB, 0.16904970E-09_JPRB, &
  & 0.16909867E-09_JPRB, 0.16914364E-09_JPRB, 0.16917488E-09_JPRB, 0.16918837E-09_JPRB, 0.16918668E-09_JPRB, 0.16917545E-09_JPRB, &
  & 0.16915716E-09_JPRB, 0.16913218E-09_JPRB, 0.16910200E-09_JPRB, 0.16906979E-09_JPRB, 0.16904070E-09_JPRB, 0.16901966E-09_JPRB, &
  & 0.16900656E-09_JPRB, 0.16899898E-09_JPRB, 0.16899665E-09_JPRB, 0.16900073E-09_JPRB, 0.16901183E-09_JPRB, 0.16903047E-09_JPRB, &
  & 0.16905459E-09_JPRB, 0.16908148E-09_JPRB, 0.16910842E-09_JPRB, 0.16913324E-09_JPRB, 0.16915319E-09_JPRB, 0.16916618E-09_JPRB, &
  & 0.16917102E-09_JPRB, 0.16916642E-09_JPRB, 0.16915344E-09_JPRB, 0.16913818E-09_JPRB, 0.16912133E-09_JPRB, 0.16910245E-09_JPRB, &
  & 0.16908039E-09_JPRB, 0.16905535E-09_JPRB, 0.16902134E-09_JPRB, 0.16894249E-09_JPRB /)

RGHG8(:,72, 8) = (/ &
  & 0.16951394E-09_JPRB, 0.16957080E-09_JPRB, 0.16959520E-09_JPRB, 0.16960924E-09_JPRB, 0.16961885E-09_JPRB, 0.16962562E-09_JPRB, &
  & 0.16963050E-09_JPRB, 0.16963443E-09_JPRB, 0.16963828E-09_JPRB, 0.16964163E-09_JPRB, 0.16964369E-09_JPRB, 0.16964420E-09_JPRB, &
  & 0.16964145E-09_JPRB, 0.16963367E-09_JPRB, 0.16961904E-09_JPRB, 0.16959464E-09_JPRB, 0.16955821E-09_JPRB, 0.16950920E-09_JPRB, &
  & 0.16944673E-09_JPRB, 0.16937354E-09_JPRB, 0.16929347E-09_JPRB, 0.16921357E-09_JPRB, 0.16914355E-09_JPRB, 0.16909031E-09_JPRB, &
  & 0.16905848E-09_JPRB, 0.16904840E-09_JPRB, 0.16905705E-09_JPRB, 0.16908004E-09_JPRB, 0.16911272E-09_JPRB, 0.16915258E-09_JPRB, &
  & 0.16919624E-09_JPRB, 0.16923607E-09_JPRB, 0.16926328E-09_JPRB, 0.16927443E-09_JPRB, 0.16927210E-09_JPRB, 0.16926166E-09_JPRB, &
  & 0.16924540E-09_JPRB, 0.16922339E-09_JPRB, 0.16919689E-09_JPRB, 0.16916855E-09_JPRB, 0.16914364E-09_JPRB, 0.16912602E-09_JPRB, &
  & 0.16911587E-09_JPRB, 0.16911023E-09_JPRB, 0.16910917E-09_JPRB, 0.16911354E-09_JPRB, 0.16912433E-09_JPRB, 0.16914203E-09_JPRB, &
  & 0.16916486E-09_JPRB, 0.16918997E-09_JPRB, 0.16921503E-09_JPRB, 0.16923810E-09_JPRB, 0.16925689E-09_JPRB, 0.16926928E-09_JPRB, &
  & 0.16927436E-09_JPRB, 0.16927110E-09_JPRB, 0.16925991E-09_JPRB, 0.16924667E-09_JPRB, 0.16923184E-09_JPRB, 0.16921531E-09_JPRB, &
  & 0.16919526E-09_JPRB, 0.16917305E-09_JPRB, 0.16914191E-09_JPRB, 0.16906949E-09_JPRB /)

RGHG8(:,73, 8) = (/ &
  & 0.16956347E-09_JPRB, 0.16962567E-09_JPRB, 0.16965085E-09_JPRB, 0.16966528E-09_JPRB, 0.16967465E-09_JPRB, 0.16968145E-09_JPRB, &
  & 0.16968629E-09_JPRB, 0.16968982E-09_JPRB, 0.16969376E-09_JPRB, 0.16969601E-09_JPRB, 0.16969787E-09_JPRB, 0.16969788E-09_JPRB, &
  & 0.16969467E-09_JPRB, 0.16968724E-09_JPRB, 0.16967384E-09_JPRB, 0.16965161E-09_JPRB, 0.16961953E-09_JPRB, 0.16957566E-09_JPRB, &
  & 0.16952145E-09_JPRB, 0.16945706E-09_JPRB, 0.16938724E-09_JPRB, 0.16931739E-09_JPRB, 0.16925601E-09_JPRB, 0.16920874E-09_JPRB, &
  & 0.16917964E-09_JPRB, 0.16916929E-09_JPRB, 0.16917588E-09_JPRB, 0.16919550E-09_JPRB, 0.16922359E-09_JPRB, 0.16925825E-09_JPRB, &
  & 0.16929604E-09_JPRB, 0.16933056E-09_JPRB, 0.16935367E-09_JPRB, 0.16936255E-09_JPRB, 0.16935983E-09_JPRB, 0.16935031E-09_JPRB, &
  & 0.16933614E-09_JPRB, 0.16931723E-09_JPRB, 0.16929455E-09_JPRB, 0.16927038E-09_JPRB, 0.16924948E-09_JPRB, 0.16923526E-09_JPRB, &
  & 0.16922766E-09_JPRB, 0.16922384E-09_JPRB, 0.16922404E-09_JPRB, 0.16922881E-09_JPRB, 0.16923944E-09_JPRB, 0.16925626E-09_JPRB, &
  & 0.16927745E-09_JPRB, 0.16930056E-09_JPRB, 0.16932332E-09_JPRB, 0.16934451E-09_JPRB, 0.16936144E-09_JPRB, 0.16937332E-09_JPRB, &
  & 0.16937837E-09_JPRB, 0.16937630E-09_JPRB, 0.16936737E-09_JPRB, 0.16935643E-09_JPRB, 0.16934409E-09_JPRB, 0.16932993E-09_JPRB, &
  & 0.16931273E-09_JPRB, 0.16929264E-09_JPRB, 0.16926530E-09_JPRB, 0.16919838E-09_JPRB /)

RGHG8(:,74, 8) = (/ &
  & 0.16961905E-09_JPRB, 0.16968275E-09_JPRB, 0.16970808E-09_JPRB, 0.16972140E-09_JPRB, 0.16973056E-09_JPRB, 0.16973689E-09_JPRB, &
  & 0.16974137E-09_JPRB, 0.16974502E-09_JPRB, 0.16974791E-09_JPRB, 0.16975032E-09_JPRB, 0.16975127E-09_JPRB, 0.16975088E-09_JPRB, &
  & 0.16974776E-09_JPRB, 0.16974053E-09_JPRB, 0.16972845E-09_JPRB, 0.16970877E-09_JPRB, 0.16968042E-09_JPRB, 0.16964319E-09_JPRB, &
  & 0.16959603E-09_JPRB, 0.16954127E-09_JPRB, 0.16948182E-09_JPRB, 0.16942228E-09_JPRB, 0.16936998E-09_JPRB, 0.16932913E-09_JPRB, &
  & 0.16930318E-09_JPRB, 0.16929290E-09_JPRB, 0.16929752E-09_JPRB, 0.16931366E-09_JPRB, 0.16933693E-09_JPRB, 0.16936615E-09_JPRB, &
  & 0.16939783E-09_JPRB, 0.16942674E-09_JPRB, 0.16944578E-09_JPRB, 0.16945256E-09_JPRB, 0.16944968E-09_JPRB, 0.16944118E-09_JPRB, &
  & 0.16942921E-09_JPRB, 0.16941337E-09_JPRB, 0.16939458E-09_JPRB, 0.16937447E-09_JPRB, 0.16935763E-09_JPRB, 0.16934663E-09_JPRB, &
  & 0.16934129E-09_JPRB, 0.16933914E-09_JPRB, 0.16934051E-09_JPRB, 0.16934563E-09_JPRB, 0.16935581E-09_JPRB, 0.16937167E-09_JPRB, &
  & 0.16939092E-09_JPRB, 0.16941173E-09_JPRB, 0.16943194E-09_JPRB, 0.16945050E-09_JPRB, 0.16946575E-09_JPRB, 0.16947629E-09_JPRB, &
  & 0.16948133E-09_JPRB, 0.16948035E-09_JPRB, 0.16947344E-09_JPRB, 0.16946479E-09_JPRB, 0.16945510E-09_JPRB, 0.16944342E-09_JPRB, &
  & 0.16942887E-09_JPRB, 0.16941146E-09_JPRB, 0.16938725E-09_JPRB, 0.16932573E-09_JPRB /)

RGHG8(:,75, 8) = (/ &
  & 0.16967736E-09_JPRB, 0.16974103E-09_JPRB, 0.16976413E-09_JPRB, 0.16977648E-09_JPRB, 0.16978459E-09_JPRB, 0.16979035E-09_JPRB, &
  & 0.16979451E-09_JPRB, 0.16979748E-09_JPRB, 0.16980056E-09_JPRB, 0.16980192E-09_JPRB, 0.16980264E-09_JPRB, 0.16980226E-09_JPRB, &
  & 0.16979865E-09_JPRB, 0.16979229E-09_JPRB, 0.16978195E-09_JPRB, 0.16976492E-09_JPRB, 0.16974123E-09_JPRB, 0.16970997E-09_JPRB, &
  & 0.16967111E-09_JPRB, 0.16962562E-09_JPRB, 0.16957680E-09_JPRB, 0.16952761E-09_JPRB, 0.16948444E-09_JPRB, 0.16945015E-09_JPRB, &
  & 0.16942793E-09_JPRB, 0.16941817E-09_JPRB, 0.16942116E-09_JPRB, 0.16943379E-09_JPRB, 0.16945229E-09_JPRB, 0.16947602E-09_JPRB, &
  & 0.16950136E-09_JPRB, 0.16952471E-09_JPRB, 0.16953977E-09_JPRB, 0.16954471E-09_JPRB, 0.16954183E-09_JPRB, 0.16953447E-09_JPRB, &
  & 0.16952484E-09_JPRB, 0.16951213E-09_JPRB, 0.16949728E-09_JPRB, 0.16948128E-09_JPRB, 0.16946843E-09_JPRB, 0.16946024E-09_JPRB, &
  & 0.16945675E-09_JPRB, 0.16945588E-09_JPRB, 0.16945814E-09_JPRB, 0.16946322E-09_JPRB, 0.16947296E-09_JPRB, 0.16948723E-09_JPRB, &
  & 0.16950437E-09_JPRB, 0.16952256E-09_JPRB, 0.16953977E-09_JPRB, 0.16955573E-09_JPRB, 0.16956855E-09_JPRB, 0.16957800E-09_JPRB, &
  & 0.16958243E-09_JPRB, 0.16958218E-09_JPRB, 0.16957699E-09_JPRB, 0.16957054E-09_JPRB, 0.16956321E-09_JPRB, 0.16955404E-09_JPRB, &
  & 0.16954209E-09_JPRB, 0.16952743E-09_JPRB, 0.16950553E-09_JPRB, 0.16944968E-09_JPRB /)

RGHG8(:,76, 8) = (/ &
  & 0.16973851E-09_JPRB, 0.16979755E-09_JPRB, 0.16981877E-09_JPRB, 0.16982882E-09_JPRB, 0.16983595E-09_JPRB, 0.16984072E-09_JPRB, &
  & 0.16984418E-09_JPRB, 0.16984697E-09_JPRB, 0.16984912E-09_JPRB, 0.16985030E-09_JPRB, 0.16985043E-09_JPRB, 0.16984991E-09_JPRB, &
  & 0.16984694E-09_JPRB, 0.16984145E-09_JPRB, 0.16983330E-09_JPRB, 0.16981945E-09_JPRB, 0.16980055E-09_JPRB, 0.16977610E-09_JPRB, &
  & 0.16974534E-09_JPRB, 0.16970959E-09_JPRB, 0.16967133E-09_JPRB, 0.16963242E-09_JPRB, 0.16959847E-09_JPRB, 0.16957113E-09_JPRB, &
  & 0.16955302E-09_JPRB, 0.16954435E-09_JPRB, 0.16954607E-09_JPRB, 0.16955558E-09_JPRB, 0.16956934E-09_JPRB, 0.16958758E-09_JPRB, &
  & 0.16960680E-09_JPRB, 0.16962447E-09_JPRB, 0.16963574E-09_JPRB, 0.16963908E-09_JPRB, 0.16963650E-09_JPRB, 0.16963046E-09_JPRB, &
  & 0.16962319E-09_JPRB, 0.16961356E-09_JPRB, 0.16960262E-09_JPRB, 0.16959058E-09_JPRB, 0.16958163E-09_JPRB, 0.16957606E-09_JPRB, &
  & 0.16957395E-09_JPRB, 0.16957405E-09_JPRB, 0.16957688E-09_JPRB, 0.16958164E-09_JPRB, 0.16959029E-09_JPRB, 0.16960269E-09_JPRB, &
  & 0.16961692E-09_JPRB, 0.16963214E-09_JPRB, 0.16964603E-09_JPRB, 0.16965909E-09_JPRB, 0.16966946E-09_JPRB, 0.16967736E-09_JPRB, &
  & 0.16968113E-09_JPRB, 0.16968135E-09_JPRB, 0.16967748E-09_JPRB, 0.16967293E-09_JPRB, 0.16966797E-09_JPRB, 0.16966098E-09_JPRB, &
  & 0.16965185E-09_JPRB, 0.16963952E-09_JPRB, 0.16962101E-09_JPRB, 0.16956753E-09_JPRB /)

RGHG8(:,77, 8) = (/ &
  & 0.16980017E-09_JPRB, 0.16985267E-09_JPRB, 0.16987006E-09_JPRB, 0.16987789E-09_JPRB, 0.16988350E-09_JPRB, 0.16988720E-09_JPRB, &
  & 0.16988981E-09_JPRB, 0.16989173E-09_JPRB, 0.16989372E-09_JPRB, 0.16989400E-09_JPRB, 0.16989372E-09_JPRB, 0.16989368E-09_JPRB, &
  & 0.16989089E-09_JPRB, 0.16988692E-09_JPRB, 0.16988140E-09_JPRB, 0.16987092E-09_JPRB, 0.16985713E-09_JPRB, 0.16983941E-09_JPRB, &
  & 0.16981717E-09_JPRB, 0.16979099E-09_JPRB, 0.16976329E-09_JPRB, 0.16973462E-09_JPRB, 0.16971005E-09_JPRB, 0.16968990E-09_JPRB, &
  & 0.16967662E-09_JPRB, 0.16966961E-09_JPRB, 0.16967062E-09_JPRB, 0.16967741E-09_JPRB, 0.16968678E-09_JPRB, 0.16969987E-09_JPRB, &
  & 0.16971329E-09_JPRB, 0.16972576E-09_JPRB, 0.16973362E-09_JPRB, 0.16973579E-09_JPRB, 0.16973389E-09_JPRB, 0.16972937E-09_JPRB, &
  & 0.16972451E-09_JPRB, 0.16971780E-09_JPRB, 0.16971059E-09_JPRB, 0.16970229E-09_JPRB, 0.16969698E-09_JPRB, 0.16969352E-09_JPRB, &
  & 0.16969229E-09_JPRB, 0.16969280E-09_JPRB, 0.16969569E-09_JPRB, 0.16969955E-09_JPRB, 0.16970654E-09_JPRB, 0.16971602E-09_JPRB, &
  & 0.16972670E-09_JPRB, 0.16973843E-09_JPRB, 0.16974870E-09_JPRB, 0.16975857E-09_JPRB, 0.16976637E-09_JPRB, 0.16977267E-09_JPRB, &
  & 0.16977564E-09_JPRB, 0.16977625E-09_JPRB, 0.16977354E-09_JPRB, 0.16977077E-09_JPRB, 0.16976788E-09_JPRB, 0.16976306E-09_JPRB, &
  & 0.16975626E-09_JPRB, 0.16974719E-09_JPRB, 0.16973017E-09_JPRB, 0.16968238E-09_JPRB /)

RGHG8(:,78, 8) = (/ &
  & 0.16986273E-09_JPRB, 0.16990274E-09_JPRB, 0.16991503E-09_JPRB, 0.16992001E-09_JPRB, 0.16992432E-09_JPRB, 0.16992675E-09_JPRB, &
  & 0.16992852E-09_JPRB, 0.16992967E-09_JPRB, 0.16993111E-09_JPRB, 0.16993061E-09_JPRB, 0.16993003E-09_JPRB, 0.16993058E-09_JPRB, &
  & 0.16992865E-09_JPRB, 0.16992616E-09_JPRB, 0.16992314E-09_JPRB, 0.16991578E-09_JPRB, 0.16990670E-09_JPRB, 0.16989532E-09_JPRB, &
  & 0.16988075E-09_JPRB, 0.16986362E-09_JPRB, 0.16984589E-09_JPRB, 0.16982678E-09_JPRB, 0.16981153E-09_JPRB, 0.16979865E-09_JPRB, &
  & 0.16979079E-09_JPRB, 0.16978602E-09_JPRB, 0.16978709E-09_JPRB, 0.16979207E-09_JPRB, 0.16979775E-09_JPRB, 0.16980667E-09_JPRB, &
  & 0.16981506E-09_JPRB, 0.16982314E-09_JPRB, 0.16982811E-09_JPRB, 0.16982953E-09_JPRB, 0.16982862E-09_JPRB, 0.16982575E-09_JPRB, &
  & 0.16982328E-09_JPRB, 0.16981912E-09_JPRB, 0.16981518E-09_JPRB, 0.16981001E-09_JPRB, 0.16980775E-09_JPRB, 0.16980584E-09_JPRB, &
  & 0.16980471E-09_JPRB, 0.16980502E-09_JPRB, 0.16980735E-09_JPRB, 0.16980946E-09_JPRB, 0.16981402E-09_JPRB, 0.16981982E-09_JPRB, &
  & 0.16982626E-09_JPRB, 0.16983412E-09_JPRB, 0.16984036E-09_JPRB, 0.16984721E-09_JPRB, 0.16985209E-09_JPRB, 0.16985711E-09_JPRB, &
  & 0.16985914E-09_JPRB, 0.16986025E-09_JPRB, 0.16985860E-09_JPRB, 0.16985727E-09_JPRB, 0.16985620E-09_JPRB, 0.16985305E-09_JPRB, &
  & 0.16984864E-09_JPRB, 0.16984222E-09_JPRB, 0.16983032E-09_JPRB, 0.16979096E-09_JPRB /)

RGHG8(:,79, 8) = (/ &
  & 0.16990352E-09_JPRB, 0.16993103E-09_JPRB, 0.16993916E-09_JPRB, 0.16994196E-09_JPRB, 0.16994559E-09_JPRB, 0.16994736E-09_JPRB, &
  & 0.16994862E-09_JPRB, 0.16994928E-09_JPRB, 0.16995075E-09_JPRB, 0.16994972E-09_JPRB, 0.16994885E-09_JPRB, 0.16994994E-09_JPRB, &
  & 0.16994829E-09_JPRB, 0.16994658E-09_JPRB, 0.16994500E-09_JPRB, 0.16993916E-09_JPRB, 0.16993258E-09_JPRB, 0.16992446E-09_JPRB, &
  & 0.16991424E-09_JPRB, 0.16990173E-09_JPRB, 0.16988938E-09_JPRB, 0.16987543E-09_JPRB, 0.16986527E-09_JPRB, 0.16985652E-09_JPRB, &
  & 0.16985179E-09_JPRB, 0.16984836E-09_JPRB, 0.16984972E-09_JPRB, 0.16985399E-09_JPRB, 0.16985770E-09_JPRB, 0.16986447E-09_JPRB, &
  & 0.16987024E-09_JPRB, 0.16987591E-09_JPRB, 0.16987928E-09_JPRB, 0.16988033E-09_JPRB, 0.16987997E-09_JPRB, 0.16987781E-09_JPRB, &
  & 0.16987654E-09_JPRB, 0.16987363E-09_JPRB, 0.16987134E-09_JPRB, 0.16986763E-09_JPRB, 0.16986694E-09_JPRB, 0.16986562E-09_JPRB, &
  & 0.16986419E-09_JPRB, 0.16986418E-09_JPRB, 0.16986602E-09_JPRB, 0.16986701E-09_JPRB, 0.16987003E-09_JPRB, 0.16987371E-09_JPRB, &
  & 0.16987770E-09_JPRB, 0.16988348E-09_JPRB, 0.16988744E-09_JPRB, 0.16989242E-09_JPRB, 0.16989589E-09_JPRB, 0.16990015E-09_JPRB, &
  & 0.16990168E-09_JPRB, 0.16990304E-09_JPRB, 0.16990181E-09_JPRB, 0.16990123E-09_JPRB, 0.16990122E-09_JPRB, 0.16989887E-09_JPRB, &
  & 0.16989565E-09_JPRB, 0.16989216E-09_JPRB, 0.16988455E-09_JPRB, 0.16985956E-09_JPRB /)

RGHG8(:,80, 8) = (/ &
  & 0.16993093E-09_JPRB, 0.16994475E-09_JPRB, 0.16994978E-09_JPRB, 0.16995147E-09_JPRB, 0.16995480E-09_JPRB, 0.16995622E-09_JPRB, &
  & 0.16995734E-09_JPRB, 0.16995778E-09_JPRB, 0.16995941E-09_JPRB, 0.16995814E-09_JPRB, 0.16995713E-09_JPRB, 0.16995855E-09_JPRB, &
  & 0.16995697E-09_JPRB, 0.16995566E-09_JPRB, 0.16995480E-09_JPRB, 0.16994961E-09_JPRB, 0.16994411E-09_JPRB, 0.16993770E-09_JPRB, &
  & 0.16992928E-09_JPRB, 0.16991902E-09_JPRB, 0.16990910E-09_JPRB, 0.16989726E-09_JPRB, 0.16988952E-09_JPRB, 0.16988252E-09_JPRB, &
  & 0.16987929E-09_JPRB, 0.16987646E-09_JPRB, 0.16987804E-09_JPRB, 0.16988205E-09_JPRB, 0.16988488E-09_JPRB, 0.16989082E-09_JPRB, &
  & 0.16989538E-09_JPRB, 0.16989996E-09_JPRB, 0.16990258E-09_JPRB, 0.16990348E-09_JPRB, 0.16990334E-09_JPRB, 0.16990150E-09_JPRB, &
  & 0.16990072E-09_JPRB, 0.16989825E-09_JPRB, 0.16989665E-09_JPRB, 0.16989356E-09_JPRB, 0.16989353E-09_JPRB, 0.16989235E-09_JPRB, &
  & 0.16989068E-09_JPRB, 0.16989035E-09_JPRB, 0.16989195E-09_JPRB, 0.16989235E-09_JPRB, 0.16989479E-09_JPRB, 0.16989755E-09_JPRB, &
  & 0.16990040E-09_JPRB, 0.16990531E-09_JPRB, 0.16990802E-09_JPRB, 0.16991222E-09_JPRB, 0.16991482E-09_JPRB, 0.16991891E-09_JPRB, &
  & 0.16992005E-09_JPRB, 0.16992145E-09_JPRB, 0.16992022E-09_JPRB, 0.16991991E-09_JPRB, 0.16992040E-09_JPRB, 0.16991833E-09_JPRB, &
  & 0.16991583E-09_JPRB, 0.16991372E-09_JPRB, 0.16991036E-09_JPRB, 0.16990384E-09_JPRB /)

RGHG8(:,81, 8) = (/ &
  & 0.16994997E-09_JPRB, 0.16995057E-09_JPRB, 0.16995425E-09_JPRB, 0.16995547E-09_JPRB, 0.16995873E-09_JPRB, 0.16996010E-09_JPRB, &
  & 0.16996110E-09_JPRB, 0.16996166E-09_JPRB, 0.16996311E-09_JPRB, 0.16996164E-09_JPRB, 0.16996077E-09_JPRB, 0.16996235E-09_JPRB, &
  & 0.16996084E-09_JPRB, 0.16995966E-09_JPRB, 0.16995912E-09_JPRB, 0.16995423E-09_JPRB, 0.16994930E-09_JPRB, 0.16994355E-09_JPRB, &
  & 0.16993612E-09_JPRB, 0.16992670E-09_JPRB, 0.16991791E-09_JPRB, 0.16990691E-09_JPRB, 0.16990026E-09_JPRB, 0.16989402E-09_JPRB, &
  & 0.16989141E-09_JPRB, 0.16988878E-09_JPRB, 0.16989052E-09_JPRB, 0.16989446E-09_JPRB, 0.16989699E-09_JPRB, 0.16990247E-09_JPRB, &
  & 0.16990648E-09_JPRB, 0.16991057E-09_JPRB, 0.16991289E-09_JPRB, 0.16991372E-09_JPRB, 0.16991372E-09_JPRB, 0.16991192E-09_JPRB, &
  & 0.16991135E-09_JPRB, 0.16990906E-09_JPRB, 0.16990777E-09_JPRB, 0.16990490E-09_JPRB, 0.16990517E-09_JPRB, 0.16990406E-09_JPRB, &
  & 0.16990225E-09_JPRB, 0.16990173E-09_JPRB, 0.16990320E-09_JPRB, 0.16990338E-09_JPRB, 0.16990563E-09_JPRB, 0.16990802E-09_JPRB, &
  & 0.16991035E-09_JPRB, 0.16991493E-09_JPRB, 0.16991707E-09_JPRB, 0.16992086E-09_JPRB, 0.16992303E-09_JPRB, 0.16992707E-09_JPRB, &
  & 0.16992795E-09_JPRB, 0.16992940E-09_JPRB, 0.16992806E-09_JPRB, 0.16992781E-09_JPRB, 0.16992854E-09_JPRB, 0.16992661E-09_JPRB, &
  & 0.16992431E-09_JPRB, 0.16992280E-09_JPRB, 0.16992104E-09_JPRB, 0.16993390E-09_JPRB /)

RGHG8(:,82, 8) = (/ &
  & 0.16995147E-09_JPRB, 0.16995252E-09_JPRB, 0.16995623E-09_JPRB, 0.16995735E-09_JPRB, 0.16996064E-09_JPRB, 0.16996193E-09_JPRB, &
  & 0.16996292E-09_JPRB, 0.16996324E-09_JPRB, 0.16996482E-09_JPRB, 0.16996372E-09_JPRB, 0.16996266E-09_JPRB, 0.16996407E-09_JPRB, &
  & 0.16996266E-09_JPRB, 0.16996164E-09_JPRB, 0.16996130E-09_JPRB, 0.16995653E-09_JPRB, 0.16995183E-09_JPRB, 0.16994653E-09_JPRB, &
  & 0.16993949E-09_JPRB, 0.16993057E-09_JPRB, 0.16992237E-09_JPRB, 0.16991165E-09_JPRB, 0.16990556E-09_JPRB, 0.16989959E-09_JPRB, &
  & 0.16989730E-09_JPRB, 0.16989474E-09_JPRB, 0.16989657E-09_JPRB, 0.16990059E-09_JPRB, 0.16990288E-09_JPRB, 0.16990817E-09_JPRB, &
  & 0.16991190E-09_JPRB, 0.16991575E-09_JPRB, 0.16991790E-09_JPRB, 0.16991869E-09_JPRB, 0.16991877E-09_JPRB, 0.16991702E-09_JPRB, &
  & 0.16991655E-09_JPRB, 0.16991432E-09_JPRB, 0.16991319E-09_JPRB, 0.16991046E-09_JPRB, 0.16991084E-09_JPRB, 0.16990977E-09_JPRB, &
  & 0.16990787E-09_JPRB, 0.16990725E-09_JPRB, 0.16990870E-09_JPRB, 0.16990881E-09_JPRB, 0.16991093E-09_JPRB, 0.16991317E-09_JPRB, &
  & 0.16991525E-09_JPRB, 0.16991968E-09_JPRB, 0.16992148E-09_JPRB, 0.16992512E-09_JPRB, 0.16992706E-09_JPRB, 0.16993111E-09_JPRB, &
  & 0.16993185E-09_JPRB, 0.16993328E-09_JPRB, 0.16993179E-09_JPRB, 0.16993160E-09_JPRB, 0.16993250E-09_JPRB, 0.16993061E-09_JPRB, &
  & 0.16992832E-09_JPRB, 0.16992678E-09_JPRB, 0.16992460E-09_JPRB, 0.16993633E-09_JPRB /)

RGHG8(:,83, 8) = (/ &
  & 0.16995251E-09_JPRB, 0.16995366E-09_JPRB, 0.16995734E-09_JPRB, 0.16995839E-09_JPRB, 0.16996171E-09_JPRB, 0.16996304E-09_JPRB, &
  & 0.16996395E-09_JPRB, 0.16996463E-09_JPRB, 0.16996574E-09_JPRB, 0.16996429E-09_JPRB, 0.16996367E-09_JPRB, 0.16996507E-09_JPRB, &
  & 0.16996379E-09_JPRB, 0.16996277E-09_JPRB, 0.16996249E-09_JPRB, 0.16995788E-09_JPRB, 0.16995330E-09_JPRB, 0.16994822E-09_JPRB, &
  & 0.16994145E-09_JPRB, 0.16993275E-09_JPRB, 0.16992492E-09_JPRB, 0.16991429E-09_JPRB, 0.16990864E-09_JPRB, 0.16990270E-09_JPRB, &
  & 0.16990064E-09_JPRB, 0.16989803E-09_JPRB, 0.16990000E-09_JPRB, 0.16990398E-09_JPRB, 0.16990623E-09_JPRB, 0.16991135E-09_JPRB, &
  & 0.16991496E-09_JPRB, 0.16991862E-09_JPRB, 0.16992069E-09_JPRB, 0.16992148E-09_JPRB, 0.16992156E-09_JPRB, 0.16991984E-09_JPRB, &
  & 0.16991943E-09_JPRB, 0.16991722E-09_JPRB, 0.16991615E-09_JPRB, 0.16991357E-09_JPRB, 0.16991403E-09_JPRB, 0.16991297E-09_JPRB, &
  & 0.16991100E-09_JPRB, 0.16991034E-09_JPRB, 0.16991175E-09_JPRB, 0.16991181E-09_JPRB, 0.16991393E-09_JPRB, 0.16991605E-09_JPRB, &
  & 0.16991802E-09_JPRB, 0.16992238E-09_JPRB, 0.16992396E-09_JPRB, 0.16992752E-09_JPRB, 0.16992927E-09_JPRB, 0.16993337E-09_JPRB, &
  & 0.16993397E-09_JPRB, 0.16993543E-09_JPRB, 0.16993389E-09_JPRB, 0.16993366E-09_JPRB, 0.16993471E-09_JPRB, 0.16993286E-09_JPRB, &
  & 0.16993057E-09_JPRB, 0.16992907E-09_JPRB, 0.16992664E-09_JPRB, 0.16993802E-09_JPRB /)

RGHG8(:,84, 8) = (/ &
  & 0.16995325E-09_JPRB, 0.16995441E-09_JPRB, 0.16995808E-09_JPRB, 0.16995902E-09_JPRB, 0.16996239E-09_JPRB, 0.16996364E-09_JPRB, &
  & 0.16996461E-09_JPRB, 0.16996490E-09_JPRB, 0.16996618E-09_JPRB, 0.16996539E-09_JPRB, 0.16996454E-09_JPRB, 0.16996543E-09_JPRB, &
  & 0.16996433E-09_JPRB, 0.16996349E-09_JPRB, 0.16996307E-09_JPRB, 0.16995874E-09_JPRB, 0.16995427E-09_JPRB, 0.16994932E-09_JPRB, &
  & 0.16994273E-09_JPRB, 0.16993412E-09_JPRB, 0.16992645E-09_JPRB, 0.16991594E-09_JPRB, 0.16991047E-09_JPRB, 0.16990460E-09_JPRB, &
  & 0.16990272E-09_JPRB, 0.16989998E-09_JPRB, 0.16990195E-09_JPRB, 0.16990617E-09_JPRB, 0.16990821E-09_JPRB, 0.16991336E-09_JPRB, &
  & 0.16991682E-09_JPRB, 0.16992040E-09_JPRB, 0.16992238E-09_JPRB, 0.16992319E-09_JPRB, 0.16992330E-09_JPRB, 0.16992159E-09_JPRB, &
  & 0.16992119E-09_JPRB, 0.16991894E-09_JPRB, 0.16991798E-09_JPRB, 0.16991547E-09_JPRB, 0.16991597E-09_JPRB, 0.16991494E-09_JPRB, &
  & 0.16991300E-09_JPRB, 0.16991224E-09_JPRB, 0.16991358E-09_JPRB, 0.16991364E-09_JPRB, 0.16991569E-09_JPRB, 0.16991784E-09_JPRB, &
  & 0.16991972E-09_JPRB, 0.16992402E-09_JPRB, 0.16992549E-09_JPRB, 0.16992900E-09_JPRB, 0.16993063E-09_JPRB, 0.16993479E-09_JPRB, &
  & 0.16993536E-09_JPRB, 0.16993679E-09_JPRB, 0.16993515E-09_JPRB, 0.16993494E-09_JPRB, 0.16993609E-09_JPRB, 0.16993422E-09_JPRB, &
  & 0.16993199E-09_JPRB, 0.16993053E-09_JPRB, 0.16992799E-09_JPRB, 0.16993913E-09_JPRB /)

RGHG8(:,85, 8) = (/ &
  & 0.16995370E-09_JPRB, 0.16995493E-09_JPRB, 0.16995855E-09_JPRB, 0.16995945E-09_JPRB, 0.16996285E-09_JPRB, 0.16996420E-09_JPRB, &
  & 0.16996500E-09_JPRB, 0.16996568E-09_JPRB, 0.16996633E-09_JPRB, 0.16996540E-09_JPRB, 0.16996499E-09_JPRB, 0.16996558E-09_JPRB, &
  & 0.16996478E-09_JPRB, 0.16996388E-09_JPRB, 0.16996315E-09_JPRB, 0.16995926E-09_JPRB, 0.16995505E-09_JPRB, 0.16995012E-09_JPRB, &
  & 0.16994364E-09_JPRB, 0.16993505E-09_JPRB, 0.16992763E-09_JPRB, 0.16991694E-09_JPRB, 0.16991175E-09_JPRB, 0.16990583E-09_JPRB, &
  & 0.16990401E-09_JPRB, 0.16990118E-09_JPRB, 0.16990337E-09_JPRB, 0.16990742E-09_JPRB, 0.16990959E-09_JPRB, 0.16991455E-09_JPRB, &
  & 0.16991802E-09_JPRB, 0.16992155E-09_JPRB, 0.16992348E-09_JPRB, 0.16992426E-09_JPRB, 0.16992439E-09_JPRB, 0.16992269E-09_JPRB, &
  & 0.16992230E-09_JPRB, 0.16992009E-09_JPRB, 0.16991913E-09_JPRB, 0.16991668E-09_JPRB, 0.16991723E-09_JPRB, 0.16991626E-09_JPRB, &
  & 0.16991422E-09_JPRB, 0.16991343E-09_JPRB, 0.16991480E-09_JPRB, 0.16991482E-09_JPRB, 0.16991693E-09_JPRB, 0.16991900E-09_JPRB, &
  & 0.16992083E-09_JPRB, 0.16992507E-09_JPRB, 0.16992649E-09_JPRB, 0.16992999E-09_JPRB, 0.16993157E-09_JPRB, 0.16993570E-09_JPRB, &
  & 0.16993623E-09_JPRB, 0.16993766E-09_JPRB, 0.16993595E-09_JPRB, 0.16993576E-09_JPRB, 0.16993697E-09_JPRB, 0.16993511E-09_JPRB, &
  & 0.16993287E-09_JPRB, 0.16993146E-09_JPRB, 0.16992886E-09_JPRB, 0.16993990E-09_JPRB /)

RGHG8(:,86, 8) = (/ &
  & 0.16995402E-09_JPRB, 0.16995524E-09_JPRB, 0.16995884E-09_JPRB, 0.16995971E-09_JPRB, 0.16996324E-09_JPRB, 0.16996433E-09_JPRB, &
  & 0.16996536E-09_JPRB, 0.16996562E-09_JPRB, 0.16996626E-09_JPRB, 0.16996578E-09_JPRB, 0.16996525E-09_JPRB, 0.16996546E-09_JPRB, &
  & 0.16996476E-09_JPRB, 0.16996396E-09_JPRB, 0.16996289E-09_JPRB, 0.16995973E-09_JPRB, 0.16995559E-09_JPRB, 0.16995085E-09_JPRB, &
  & 0.16994441E-09_JPRB, 0.16993593E-09_JPRB, 0.16992831E-09_JPRB, 0.16991772E-09_JPRB, 0.16991253E-09_JPRB, 0.16990659E-09_JPRB, &
  & 0.16990495E-09_JPRB, 0.16990188E-09_JPRB, 0.16990398E-09_JPRB, 0.16990839E-09_JPRB, 0.16991025E-09_JPRB, 0.16991548E-09_JPRB, &
  & 0.16991880E-09_JPRB, 0.16992230E-09_JPRB, 0.16992420E-09_JPRB, 0.16992495E-09_JPRB, 0.16992513E-09_JPRB, 0.16992339E-09_JPRB, &
  & 0.16992308E-09_JPRB, 0.16992077E-09_JPRB, 0.16991991E-09_JPRB, 0.16991740E-09_JPRB, 0.16991808E-09_JPRB, 0.16991707E-09_JPRB, &
  & 0.16991505E-09_JPRB, 0.16991418E-09_JPRB, 0.16991555E-09_JPRB, 0.16991561E-09_JPRB, 0.16991762E-09_JPRB, 0.16991976E-09_JPRB, &
  & 0.16992156E-09_JPRB, 0.16992571E-09_JPRB, 0.16992714E-09_JPRB, 0.16993063E-09_JPRB, 0.16993210E-09_JPRB, 0.16993626E-09_JPRB, &
  & 0.16993679E-09_JPRB, 0.16993824E-09_JPRB, 0.16993644E-09_JPRB, 0.16993627E-09_JPRB, 0.16993759E-09_JPRB, 0.16993570E-09_JPRB, &
  & 0.16993348E-09_JPRB, 0.16993210E-09_JPRB, 0.16992938E-09_JPRB, 0.16994042E-09_JPRB /)

RGHG8(:,87, 8) = (/ &
  & 0.16995420E-09_JPRB, 0.16995548E-09_JPRB, 0.16995903E-09_JPRB, 0.16996002E-09_JPRB, 0.16996322E-09_JPRB, 0.16996474E-09_JPRB, &
  & 0.16996538E-09_JPRB, 0.16996586E-09_JPRB, 0.16996619E-09_JPRB, 0.16996565E-09_JPRB, 0.16996532E-09_JPRB, 0.16996535E-09_JPRB, &
  & 0.16996471E-09_JPRB, 0.16996382E-09_JPRB, 0.16996274E-09_JPRB, 0.16995974E-09_JPRB, 0.16995608E-09_JPRB, 0.16995133E-09_JPRB, &
  & 0.16994509E-09_JPRB, 0.16993652E-09_JPRB, 0.16992897E-09_JPRB, 0.16991815E-09_JPRB, 0.16991307E-09_JPRB, 0.16990709E-09_JPRB, &
  & 0.16990548E-09_JPRB, 0.16990227E-09_JPRB, 0.16990445E-09_JPRB, 0.16990884E-09_JPRB, 0.16991075E-09_JPRB, 0.16991600E-09_JPRB, &
  & 0.16991931E-09_JPRB, 0.16992281E-09_JPRB, 0.16992466E-09_JPRB, 0.16992542E-09_JPRB, 0.16992562E-09_JPRB, 0.16992381E-09_JPRB, &
  & 0.16992356E-09_JPRB, 0.16992122E-09_JPRB, 0.16992042E-09_JPRB, 0.16991777E-09_JPRB, 0.16991865E-09_JPRB, 0.16991766E-09_JPRB, &
  & 0.16991539E-09_JPRB, 0.16991455E-09_JPRB, 0.16991610E-09_JPRB, 0.16991610E-09_JPRB, 0.16991814E-09_JPRB, 0.16992022E-09_JPRB, &
  & 0.16992203E-09_JPRB, 0.16992603E-09_JPRB, 0.16992752E-09_JPRB, 0.16993097E-09_JPRB, 0.16993243E-09_JPRB, 0.16993659E-09_JPRB, &
  & 0.16993712E-09_JPRB, 0.16993856E-09_JPRB, 0.16993676E-09_JPRB, 0.16993654E-09_JPRB, 0.16993794E-09_JPRB, 0.16993609E-09_JPRB, &
  & 0.16993383E-09_JPRB, 0.16993246E-09_JPRB, 0.16992967E-09_JPRB, 0.16994076E-09_JPRB /)

RGHG8(:,88, 8) = (/ &
  & 0.16995437E-09_JPRB, 0.16995579E-09_JPRB, 0.16995906E-09_JPRB, 0.16995999E-09_JPRB, 0.16996357E-09_JPRB, 0.16996458E-09_JPRB, &
  & 0.16996556E-09_JPRB, 0.16996579E-09_JPRB, 0.16996621E-09_JPRB, 0.16996579E-09_JPRB, 0.16996535E-09_JPRB, 0.16996529E-09_JPRB, &
  & 0.16996463E-09_JPRB, 0.16996377E-09_JPRB, 0.16996257E-09_JPRB, 0.16995989E-09_JPRB, 0.16995613E-09_JPRB, 0.16995164E-09_JPRB, &
  & 0.16994532E-09_JPRB, 0.16993694E-09_JPRB, 0.16992918E-09_JPRB, 0.16991851E-09_JPRB, 0.16991339E-09_JPRB, 0.16990734E-09_JPRB, &
  & 0.16990584E-09_JPRB, 0.16990245E-09_JPRB, 0.16990462E-09_JPRB, 0.16990928E-09_JPRB, 0.16991089E-09_JPRB, 0.16991644E-09_JPRB, &
  & 0.16991959E-09_JPRB, 0.16992313E-09_JPRB, 0.16992498E-09_JPRB, 0.16992571E-09_JPRB, 0.16992593E-09_JPRB, 0.16992412E-09_JPRB, &
  & 0.16992391E-09_JPRB, 0.16992147E-09_JPRB, 0.16992077E-09_JPRB, 0.16991790E-09_JPRB, 0.16991906E-09_JPRB, 0.16991805E-09_JPRB, &
  & 0.16991566E-09_JPRB, 0.16991474E-09_JPRB, 0.16991637E-09_JPRB, 0.16991640E-09_JPRB, 0.16991838E-09_JPRB, 0.16992052E-09_JPRB, &
  & 0.16992234E-09_JPRB, 0.16992625E-09_JPRB, 0.16992775E-09_JPRB, 0.16993115E-09_JPRB, 0.16993261E-09_JPRB, 0.16993679E-09_JPRB, &
  & 0.16993733E-09_JPRB, 0.16993881E-09_JPRB, 0.16993695E-09_JPRB, 0.16993675E-09_JPRB, 0.16993816E-09_JPRB, 0.16993630E-09_JPRB, &
  & 0.16993409E-09_JPRB, 0.16993275E-09_JPRB, 0.16992985E-09_JPRB, 0.16994095E-09_JPRB /)

RGHG8(:,89, 8) = (/ &
  & 0.16995462E-09_JPRB, 0.16995605E-09_JPRB, 0.16995903E-09_JPRB, 0.16996012E-09_JPRB, 0.16996334E-09_JPRB, 0.16996485E-09_JPRB, &
  & 0.16996551E-09_JPRB, 0.16996604E-09_JPRB, 0.16996643E-09_JPRB, 0.16996582E-09_JPRB, 0.16996543E-09_JPRB, 0.16996550E-09_JPRB, &
  & 0.16996486E-09_JPRB, 0.16996399E-09_JPRB, 0.16996290E-09_JPRB, 0.16995989E-09_JPRB, 0.16995624E-09_JPRB, 0.16995158E-09_JPRB, &
  & 0.16994536E-09_JPRB, 0.16993681E-09_JPRB, 0.16992940E-09_JPRB, 0.16991851E-09_JPRB, 0.16991353E-09_JPRB, 0.16990746E-09_JPRB, &
  & 0.16990602E-09_JPRB, 0.16990254E-09_JPRB, 0.16990474E-09_JPRB, 0.16990943E-09_JPRB, 0.16991102E-09_JPRB, 0.16991666E-09_JPRB, &
  & 0.16991976E-09_JPRB, 0.16992338E-09_JPRB, 0.16992519E-09_JPRB, 0.16992591E-09_JPRB, 0.16992614E-09_JPRB, 0.16992423E-09_JPRB, &
  & 0.16992410E-09_JPRB, 0.16992158E-09_JPRB, 0.16992099E-09_JPRB, 0.16991789E-09_JPRB, 0.16991934E-09_JPRB, 0.16991833E-09_JPRB, &
  & 0.16991568E-09_JPRB, 0.16991475E-09_JPRB, 0.16991661E-09_JPRB, 0.16991657E-09_JPRB, 0.16991861E-09_JPRB, 0.16992069E-09_JPRB, &
  & 0.16992249E-09_JPRB, 0.16992635E-09_JPRB, 0.16992786E-09_JPRB, 0.16993122E-09_JPRB, 0.16993271E-09_JPRB, 0.16993691E-09_JPRB, &
  & 0.16993741E-09_JPRB, 0.16993897E-09_JPRB, 0.16993704E-09_JPRB, 0.16993681E-09_JPRB, 0.16993833E-09_JPRB, 0.16993640E-09_JPRB, &
  & 0.16993421E-09_JPRB, 0.16993287E-09_JPRB, 0.16992993E-09_JPRB, 0.16994110E-09_JPRB /)

RGHG8(:,90, 8) = (/ &
  & 0.16995481E-09_JPRB, 0.16995635E-09_JPRB, 0.16995882E-09_JPRB, 0.16995991E-09_JPRB, 0.16996352E-09_JPRB, 0.16996460E-09_JPRB, &
  & 0.16996565E-09_JPRB, 0.16996599E-09_JPRB, 0.16996682E-09_JPRB, 0.16996604E-09_JPRB, 0.16996550E-09_JPRB, 0.16996585E-09_JPRB, &
  & 0.16996513E-09_JPRB, 0.16996432E-09_JPRB, 0.16996338E-09_JPRB, 0.16996013E-09_JPRB, 0.16995601E-09_JPRB, 0.16995144E-09_JPRB, &
  & 0.16994510E-09_JPRB, 0.16993658E-09_JPRB, 0.16992935E-09_JPRB, 0.16991838E-09_JPRB, 0.16991360E-09_JPRB, 0.16990739E-09_JPRB, &
  & 0.16990616E-09_JPRB, 0.16990243E-09_JPRB, 0.16990470E-09_JPRB, 0.16990960E-09_JPRB, 0.16991089E-09_JPRB, 0.16991683E-09_JPRB, &
  & 0.16991981E-09_JPRB, 0.16992352E-09_JPRB, 0.16992530E-09_JPRB, 0.16992600E-09_JPRB, 0.16992632E-09_JPRB, 0.16992426E-09_JPRB, &
  & 0.16992423E-09_JPRB, 0.16992158E-09_JPRB, 0.16992119E-09_JPRB, 0.16991776E-09_JPRB, 0.16991952E-09_JPRB, 0.16991848E-09_JPRB, &
  & 0.16991565E-09_JPRB, 0.16991467E-09_JPRB, 0.16991678E-09_JPRB, 0.16991654E-09_JPRB, 0.16991868E-09_JPRB, 0.16992080E-09_JPRB, &
  & 0.16992249E-09_JPRB, 0.16992652E-09_JPRB, 0.16992791E-09_JPRB, 0.16993135E-09_JPRB, 0.16993271E-09_JPRB, 0.16993705E-09_JPRB, &
  & 0.16993748E-09_JPRB, 0.16993912E-09_JPRB, 0.16993701E-09_JPRB, 0.16993681E-09_JPRB, 0.16993848E-09_JPRB, 0.16993651E-09_JPRB, &
  & 0.16993422E-09_JPRB, 0.16993293E-09_JPRB, 0.16992985E-09_JPRB, 0.16994126E-09_JPRB /)

RGHG8(:,91, 8) = (/ &
  & 0.16995476E-09_JPRB, 0.16995658E-09_JPRB, 0.16995849E-09_JPRB, 0.16995963E-09_JPRB, 0.16996363E-09_JPRB, 0.16996458E-09_JPRB, &
  & 0.16996561E-09_JPRB, 0.16996564E-09_JPRB, 0.16996850E-09_JPRB, 0.16996582E-09_JPRB, 0.16996436E-09_JPRB, 0.16996728E-09_JPRB, &
  & 0.16996531E-09_JPRB, 0.16996438E-09_JPRB, 0.16996515E-09_JPRB, 0.16995984E-09_JPRB, 0.16995556E-09_JPRB, 0.16995121E-09_JPRB, &
  & 0.16994496E-09_JPRB, 0.16993613E-09_JPRB, 0.16992956E-09_JPRB, 0.16991791E-09_JPRB, 0.16991371E-09_JPRB, 0.16990710E-09_JPRB, &
  & 0.16990631E-09_JPRB, 0.16990204E-09_JPRB, 0.16990453E-09_JPRB, 0.16990985E-09_JPRB, 0.16991050E-09_JPRB, 0.16991701E-09_JPRB, &
  & 0.16991981E-09_JPRB, 0.16992370E-09_JPRB, 0.16992546E-09_JPRB, 0.16992609E-09_JPRB, 0.16992656E-09_JPRB, 0.16992409E-09_JPRB, &
  & 0.16992444E-09_JPRB, 0.16992142E-09_JPRB, 0.16992141E-09_JPRB, 0.16991739E-09_JPRB, 0.16991977E-09_JPRB, 0.16991870E-09_JPRB, &
  & 0.16991550E-09_JPRB, 0.16991430E-09_JPRB, 0.16991702E-09_JPRB, 0.16991630E-09_JPRB, 0.16991869E-09_JPRB, 0.16992094E-09_JPRB, &
  & 0.16992227E-09_JPRB, 0.16992691E-09_JPRB, 0.16992777E-09_JPRB, 0.16993158E-09_JPRB, 0.16993253E-09_JPRB, 0.16993741E-09_JPRB, &
  & 0.16993747E-09_JPRB, 0.16993937E-09_JPRB, 0.16993690E-09_JPRB, 0.16993670E-09_JPRB, 0.16993874E-09_JPRB, 0.16993654E-09_JPRB, &
  & 0.16993415E-09_JPRB, 0.16993297E-09_JPRB, 0.16992954E-09_JPRB, 0.16994152E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART16',1,ZHOOK_HANDLE)
END SUBROUTINE PART16






SUBROUTINE PART17
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART17',0,ZHOOK_HANDLE)



!-- Month=  9 ------------

RGHG8(:, 1, 9) = (/ &
  & 0.38684542E-10_JPRB, 0.38684521E-10_JPRB, 0.38684878E-10_JPRB, 0.38686769E-10_JPRB, 0.38691144E-10_JPRB, 0.38698600E-10_JPRB, &
  & 0.38710493E-10_JPRB, 0.38726695E-10_JPRB, 0.38746263E-10_JPRB, 0.38767392E-10_JPRB, 0.38789132E-10_JPRB, 0.38809032E-10_JPRB, &
  & 0.38825766E-10_JPRB, 0.38840077E-10_JPRB, 0.38852373E-10_JPRB, 0.38862056E-10_JPRB, 0.38867465E-10_JPRB, 0.38866532E-10_JPRB, &
  & 0.38857070E-10_JPRB, 0.38837343E-10_JPRB, 0.38806326E-10_JPRB, 0.38766147E-10_JPRB, 0.38717553E-10_JPRB, 0.38655905E-10_JPRB, &
  & 0.38581215E-10_JPRB, 0.38494322E-10_JPRB, 0.38399381E-10_JPRB, 0.38302556E-10_JPRB, 0.38249404E-10_JPRB, 0.38265047E-10_JPRB, &
  & 0.38307184E-10_JPRB, 0.38348043E-10_JPRB, 0.38392466E-10_JPRB, 0.38430970E-10_JPRB, 0.38463968E-10_JPRB, 0.38493660E-10_JPRB, &
  & 0.38521734E-10_JPRB, 0.38547377E-10_JPRB, 0.38568888E-10_JPRB, 0.38579206E-10_JPRB, 0.38575334E-10_JPRB, 0.38560873E-10_JPRB, &
  & 0.38535970E-10_JPRB, 0.38498687E-10_JPRB, 0.38446170E-10_JPRB, 0.38375407E-10_JPRB, 0.38282034E-10_JPRB, 0.38161460E-10_JPRB, &
  & 0.38011053E-10_JPRB, 0.37824761E-10_JPRB, 0.37615147E-10_JPRB, 0.37393432E-10_JPRB, 0.37171183E-10_JPRB, 0.36965958E-10_JPRB, &
  & 0.36777061E-10_JPRB, 0.36605139E-10_JPRB, 0.36446738E-10_JPRB, 0.36295220E-10_JPRB, 0.36150152E-10_JPRB, 0.36015985E-10_JPRB, &
  & 0.35899346E-10_JPRB, 0.35804949E-10_JPRB, 0.35746024E-10_JPRB, 0.35729104E-10_JPRB /)

RGHG8(:, 2, 9) = (/ &
  & 0.38900189E-10_JPRB, 0.38932316E-10_JPRB, 0.38957879E-10_JPRB, 0.38982175E-10_JPRB, 0.39004810E-10_JPRB, 0.39024450E-10_JPRB, &
  & 0.39041145E-10_JPRB, 0.39055405E-10_JPRB, 0.39069768E-10_JPRB, 0.39089228E-10_JPRB, 0.39117987E-10_JPRB, 0.39156678E-10_JPRB, &
  & 0.39202818E-10_JPRB, 0.39251706E-10_JPRB, 0.39298870E-10_JPRB, 0.39341030E-10_JPRB, 0.39375857E-10_JPRB, 0.39399463E-10_JPRB, &
  & 0.39406457E-10_JPRB, 0.39392125E-10_JPRB, 0.39352122E-10_JPRB, 0.39282320E-10_JPRB, 0.39182546E-10_JPRB, 0.39062815E-10_JPRB, &
  & 0.38948341E-10_JPRB, 0.38843893E-10_JPRB, 0.38748827E-10_JPRB, 0.38678068E-10_JPRB, 0.38656502E-10_JPRB, 0.38684948E-10_JPRB, &
  & 0.38743519E-10_JPRB, 0.38825953E-10_JPRB, 0.38944487E-10_JPRB, 0.39089565E-10_JPRB, 0.39246557E-10_JPRB, 0.39401104E-10_JPRB, &
  & 0.39547553E-10_JPRB, 0.39683579E-10_JPRB, 0.39806936E-10_JPRB, 0.39900284E-10_JPRB, 0.39945419E-10_JPRB, 0.39937040E-10_JPRB, &
  & 0.39884436E-10_JPRB, 0.39791878E-10_JPRB, 0.39657229E-10_JPRB, 0.39481595E-10_JPRB, 0.39266947E-10_JPRB, 0.39013168E-10_JPRB, &
  & 0.38728905E-10_JPRB, 0.38423712E-10_JPRB, 0.38112444E-10_JPRB, 0.37810730E-10_JPRB, 0.37525948E-10_JPRB, 0.37268209E-10_JPRB, &
  & 0.37037248E-10_JPRB, 0.36833193E-10_JPRB, 0.36656862E-10_JPRB, 0.36505809E-10_JPRB, 0.36378373E-10_JPRB, 0.36269550E-10_JPRB, &
  & 0.36173134E-10_JPRB, 0.36088098E-10_JPRB, 0.36014750E-10_JPRB, 0.35947589E-10_JPRB /)

RGHG8(:, 3, 9) = (/ &
  & 0.39071139E-10_JPRB, 0.39097794E-10_JPRB, 0.39116731E-10_JPRB, 0.39139254E-10_JPRB, 0.39168179E-10_JPRB, 0.39206641E-10_JPRB, &
  & 0.39257448E-10_JPRB, 0.39320928E-10_JPRB, 0.39393967E-10_JPRB, 0.39474576E-10_JPRB, 0.39560660E-10_JPRB, 0.39651858E-10_JPRB, &
  & 0.39747688E-10_JPRB, 0.39845981E-10_JPRB, 0.39943781E-10_JPRB, 0.40034961E-10_JPRB, 0.40110967E-10_JPRB, 0.40166266E-10_JPRB, &
  & 0.40197221E-10_JPRB, 0.40197626E-10_JPRB, 0.40158443E-10_JPRB, 0.40072438E-10_JPRB, 0.39942282E-10_JPRB, 0.39782427E-10_JPRB, &
  & 0.39605114E-10_JPRB, 0.39432423E-10_JPRB, 0.39300709E-10_JPRB, 0.39244927E-10_JPRB, 0.39284298E-10_JPRB, 0.39417102E-10_JPRB, &
  & 0.39626601E-10_JPRB, 0.39894737E-10_JPRB, 0.40198962E-10_JPRB, 0.40514411E-10_JPRB, 0.40813998E-10_JPRB, 0.41088501E-10_JPRB, &
  & 0.41336753E-10_JPRB, 0.41563395E-10_JPRB, 0.41762663E-10_JPRB, 0.41919065E-10_JPRB, 0.41996021E-10_JPRB, 0.41974046E-10_JPRB, &
  & 0.41856352E-10_JPRB, 0.41648934E-10_JPRB, 0.41361612E-10_JPRB, 0.41005470E-10_JPRB, 0.40596984E-10_JPRB, 0.40152142E-10_JPRB, &
  & 0.39690393E-10_JPRB, 0.39237925E-10_JPRB, 0.38810191E-10_JPRB, 0.38414237E-10_JPRB, 0.38064090E-10_JPRB, 0.37756243E-10_JPRB, &
  & 0.37482021E-10_JPRB, 0.37239128E-10_JPRB, 0.37020550E-10_JPRB, 0.36816612E-10_JPRB, 0.36623333E-10_JPRB, 0.36442922E-10_JPRB, &
  & 0.36291387E-10_JPRB, 0.36180090E-10_JPRB, 0.36110195E-10_JPRB, 0.36051235E-10_JPRB /)

RGHG8(:, 4, 9) = (/ &
  & 0.39208241E-10_JPRB, 0.39270524E-10_JPRB, 0.39325862E-10_JPRB, 0.39388520E-10_JPRB, 0.39464980E-10_JPRB, 0.39551751E-10_JPRB, &
  & 0.39648111E-10_JPRB, 0.39751986E-10_JPRB, 0.39866086E-10_JPRB, 0.39995965E-10_JPRB, 0.40138639E-10_JPRB, 0.40288967E-10_JPRB, &
  & 0.40443388E-10_JPRB, 0.40597751E-10_JPRB, 0.40746975E-10_JPRB, 0.40889330E-10_JPRB, 0.41024489E-10_JPRB, 0.41145122E-10_JPRB, &
  & 0.41238880E-10_JPRB, 0.41294853E-10_JPRB, 0.41304113E-10_JPRB, 0.41261758E-10_JPRB, 0.41170033E-10_JPRB, 0.41039304E-10_JPRB, &
  & 0.40893622E-10_JPRB, 0.40765093E-10_JPRB, 0.40696658E-10_JPRB, 0.40721558E-10_JPRB, 0.40853130E-10_JPRB, 0.41086981E-10_JPRB, &
  & 0.41412797E-10_JPRB, 0.41813025E-10_JPRB, 0.42267734E-10_JPRB, 0.42733744E-10_JPRB, 0.43182770E-10_JPRB, 0.43594874E-10_JPRB, &
  & 0.43969297E-10_JPRB, 0.44307339E-10_JPRB, 0.44606017E-10_JPRB, 0.44837960E-10_JPRB, 0.44962201E-10_JPRB, 0.44932984E-10_JPRB, &
  & 0.44734268E-10_JPRB, 0.44380232E-10_JPRB, 0.43894621E-10_JPRB, 0.43312014E-10_JPRB, 0.42668410E-10_JPRB, 0.41996469E-10_JPRB, &
  & 0.41321363E-10_JPRB, 0.40663025E-10_JPRB, 0.40044801E-10_JPRB, 0.39480568E-10_JPRB, 0.38968120E-10_JPRB, 0.38515326E-10_JPRB, &
  & 0.38121454E-10_JPRB, 0.37772105E-10_JPRB, 0.37459431E-10_JPRB, 0.37178004E-10_JPRB, 0.36928065E-10_JPRB, 0.36716265E-10_JPRB, &
  & 0.36544410E-10_JPRB, 0.36403800E-10_JPRB, 0.36279223E-10_JPRB, 0.36152654E-10_JPRB /)

RGHG8(:, 5, 9) = (/ &
  & 0.39350658E-10_JPRB, 0.39471530E-10_JPRB, 0.39567707E-10_JPRB, 0.39678948E-10_JPRB, 0.39809461E-10_JPRB, 0.39960549E-10_JPRB, &
  & 0.40130517E-10_JPRB, 0.40318155E-10_JPRB, 0.40520063E-10_JPRB, 0.40737476E-10_JPRB, 0.40969898E-10_JPRB, 0.41213043E-10_JPRB, &
  & 0.41458222E-10_JPRB, 0.41698065E-10_JPRB, 0.41928842E-10_JPRB, 0.42146099E-10_JPRB, 0.42346401E-10_JPRB, 0.42531825E-10_JPRB, &
  & 0.42703372E-10_JPRB, 0.42856090E-10_JPRB, 0.42981479E-10_JPRB, 0.43071227E-10_JPRB, 0.43118370E-10_JPRB, 0.43122634E-10_JPRB, &
  & 0.43102237E-10_JPRB, 0.43090809E-10_JPRB, 0.43125330E-10_JPRB, 0.43240963E-10_JPRB, 0.43451593E-10_JPRB, 0.43758729E-10_JPRB, &
  & 0.44156748E-10_JPRB, 0.44634602E-10_JPRB, 0.45176377E-10_JPRB, 0.45754706E-10_JPRB, 0.46336910E-10_JPRB, 0.46900990E-10_JPRB, &
  & 0.47429970E-10_JPRB, 0.47912337E-10_JPRB, 0.48332376E-10_JPRB, 0.48658858E-10_JPRB, 0.48835921E-10_JPRB, 0.48809602E-10_JPRB, &
  & 0.48555566E-10_JPRB, 0.48091107E-10_JPRB, 0.47460619E-10_JPRB, 0.46716811E-10_JPRB, 0.45905335E-10_JPRB, 0.45058134E-10_JPRB, &
  & 0.44194017E-10_JPRB, 0.43323227E-10_JPRB, 0.42453627E-10_JPRB, 0.41601347E-10_JPRB, 0.40787342E-10_JPRB, 0.40022277E-10_JPRB, &
  & 0.39325734E-10_JPRB, 0.38710108E-10_JPRB, 0.38179754E-10_JPRB, 0.37735259E-10_JPRB, 0.37377143E-10_JPRB, 0.37088471E-10_JPRB, &
  & 0.36849992E-10_JPRB, 0.36655463E-10_JPRB, 0.36498370E-10_JPRB, 0.36306839E-10_JPRB /)

RGHG8(:, 6, 9) = (/ &
  & 0.39521386E-10_JPRB, 0.39721455E-10_JPRB, 0.39880987E-10_JPRB, 0.40058963E-10_JPRB, 0.40265159E-10_JPRB, 0.40500228E-10_JPRB, &
  & 0.40761419E-10_JPRB, 0.41042524E-10_JPRB, 0.41343762E-10_JPRB, 0.41665383E-10_JPRB, 0.42003255E-10_JPRB, 0.42350772E-10_JPRB, &
  & 0.42701082E-10_JPRB, 0.43044391E-10_JPRB, 0.43371480E-10_JPRB, 0.43680809E-10_JPRB, 0.43975747E-10_JPRB, 0.44257618E-10_JPRB, &
  & 0.44529127E-10_JPRB, 0.44794959E-10_JPRB, 0.45057555E-10_JPRB, 0.45315442E-10_JPRB, 0.45563907E-10_JPRB, 0.45796839E-10_JPRB, &
  & 0.46010820E-10_JPRB, 0.46216076E-10_JPRB, 0.46429936E-10_JPRB, 0.46667097E-10_JPRB, 0.46944993E-10_JPRB, 0.47276408E-10_JPRB, &
  & 0.47671679E-10_JPRB, 0.48139426E-10_JPRB, 0.48686485E-10_JPRB, 0.49310039E-10_JPRB, 0.49995976E-10_JPRB, 0.50714904E-10_JPRB, &
  & 0.51430631E-10_JPRB, 0.52103970E-10_JPRB, 0.52693891E-10_JPRB, 0.53150158E-10_JPRB, 0.53409447E-10_JPRB, 0.53415362E-10_JPRB, &
  & 0.53146390E-10_JPRB, 0.52626986E-10_JPRB, 0.51917512E-10_JPRB, 0.51077004E-10_JPRB, 0.50151060E-10_JPRB, 0.49161113E-10_JPRB, &
  & 0.48113045E-10_JPRB, 0.47007866E-10_JPRB, 0.45851420E-10_JPRB, 0.44654738E-10_JPRB, 0.43441448E-10_JPRB, 0.42254231E-10_JPRB, &
  & 0.41132927E-10_JPRB, 0.40120719E-10_JPRB, 0.39247286E-10_JPRB, 0.38534849E-10_JPRB, 0.37970752E-10_JPRB, 0.37535284E-10_JPRB, &
  & 0.37211220E-10_JPRB, 0.36973181E-10_JPRB, 0.36773327E-10_JPRB, 0.36529425E-10_JPRB /)

RGHG8(:, 7, 9) = (/ &
  & 0.39791961E-10_JPRB, 0.40088207E-10_JPRB, 0.40319331E-10_JPRB, 0.40556045E-10_JPRB, 0.40833274E-10_JPRB, 0.41148980E-10_JPRB, &
  & 0.41500133E-10_JPRB, 0.41878719E-10_JPRB, 0.42280755E-10_JPRB, 0.42702380E-10_JPRB, 0.43141678E-10_JPRB, 0.43588307E-10_JPRB, &
  & 0.44027126E-10_JPRB, 0.44446915E-10_JPRB, 0.44844815E-10_JPRB, 0.45220848E-10_JPRB, 0.45579346E-10_JPRB, 0.45930308E-10_JPRB, &
  & 0.46283824E-10_JPRB, 0.46649035E-10_JPRB, 0.47037867E-10_JPRB, 0.47462718E-10_JPRB, 0.47931464E-10_JPRB, 0.48440078E-10_JPRB, &
  & 0.48964645E-10_JPRB, 0.49473259E-10_JPRB, 0.49944191E-10_JPRB, 0.50380512E-10_JPRB, 0.50796263E-10_JPRB, 0.51213252E-10_JPRB, &
  & 0.51651312E-10_JPRB, 0.52130321E-10_JPRB, 0.52689464E-10_JPRB, 0.53354311E-10_JPRB, 0.54130568E-10_JPRB, 0.54994662E-10_JPRB, &
  & 0.55898716E-10_JPRB, 0.56780764E-10_JPRB, 0.57571406E-10_JPRB, 0.58196538E-10_JPRB, 0.58581792E-10_JPRB, 0.58660111E-10_JPRB, &
  & 0.58410068E-10_JPRB, 0.57863742E-10_JPRB, 0.57079272E-10_JPRB, 0.56122790E-10_JPRB, 0.55038026E-10_JPRB, 0.53843149E-10_JPRB, &
  & 0.52537877E-10_JPRB, 0.51118235E-10_JPRB, 0.49589034E-10_JPRB, 0.47974312E-10_JPRB, 0.46310566E-10_JPRB, 0.44649145E-10_JPRB, &
  & 0.43063251E-10_JPRB, 0.41618795E-10_JPRB, 0.40372105E-10_JPRB, 0.39342325E-10_JPRB, 0.38534797E-10_JPRB, 0.37929503E-10_JPRB, &
  & 0.37501564E-10_JPRB, 0.37202026E-10_JPRB, 0.36987701E-10_JPRB, 0.36752601E-10_JPRB /)

RGHG8(:, 8, 9) = (/ &
  & 0.40235339E-10_JPRB, 0.40647090E-10_JPRB, 0.40927189E-10_JPRB, 0.41215677E-10_JPRB, 0.41537954E-10_JPRB, 0.41908838E-10_JPRB, &
  & 0.42323034E-10_JPRB, 0.42773403E-10_JPRB, 0.43250938E-10_JPRB, 0.43751724E-10_JPRB, 0.44266896E-10_JPRB, 0.44784967E-10_JPRB, &
  & 0.45292707E-10_JPRB, 0.45775786E-10_JPRB, 0.46226210E-10_JPRB, 0.46648903E-10_JPRB, 0.47056165E-10_JPRB, 0.47461521E-10_JPRB, &
  & 0.47880797E-10_JPRB, 0.48333712E-10_JPRB, 0.48842663E-10_JPRB, 0.49434325E-10_JPRB, 0.50132985E-10_JPRB, 0.50948329E-10_JPRB, &
  & 0.51851155E-10_JPRB, 0.52775596E-10_JPRB, 0.53664191E-10_JPRB, 0.54474026E-10_JPRB, 0.55195754E-10_JPRB, 0.55834934E-10_JPRB, &
  & 0.56412160E-10_JPRB, 0.56971365E-10_JPRB, 0.57579101E-10_JPRB, 0.58295639E-10_JPRB, 0.59146771E-10_JPRB, 0.60123045E-10_JPRB, &
  & 0.61175891E-10_JPRB, 0.62230263E-10_JPRB, 0.63197753E-10_JPRB, 0.63984748E-10_JPRB, 0.64497047E-10_JPRB, 0.64664468E-10_JPRB, &
  & 0.64451340E-10_JPRB, 0.63870610E-10_JPRB, 0.62978345E-10_JPRB, 0.61839006E-10_JPRB, 0.60500292E-10_JPRB, 0.58988654E-10_JPRB, &
  & 0.57306864E-10_JPRB, 0.55452892E-10_JPRB, 0.53439468E-10_JPRB, 0.51301061E-10_JPRB, 0.49094662E-10_JPRB, 0.46906017E-10_JPRB, &
  & 0.44819776E-10_JPRB, 0.42933164E-10_JPRB, 0.41298173E-10_JPRB, 0.39953124E-10_JPRB, 0.38898190E-10_JPRB, 0.38117239E-10_JPRB, &
  & 0.37572966E-10_JPRB, 0.37218825E-10_JPRB, 0.36988055E-10_JPRB, 0.36807005E-10_JPRB /)

RGHG8(:, 9, 9) = (/ &
  & 0.40931522E-10_JPRB, 0.41434481E-10_JPRB, 0.41752275E-10_JPRB, 0.42063505E-10_JPRB, 0.42403643E-10_JPRB, 0.42796093E-10_JPRB, &
  & 0.43240977E-10_JPRB, 0.43730488E-10_JPRB, 0.44256456E-10_JPRB, 0.44808733E-10_JPRB, 0.45379825E-10_JPRB, 0.45955389E-10_JPRB, &
  & 0.46517904E-10_JPRB, 0.47054177E-10_JPRB, 0.47560081E-10_JPRB, 0.48039017E-10_JPRB, 0.48502917E-10_JPRB, 0.48970640E-10_JPRB, &
  & 0.49464877E-10_JPRB, 0.50013091E-10_JPRB, 0.50652191E-10_JPRB, 0.51433368E-10_JPRB, 0.52416172E-10_JPRB, 0.53640776E-10_JPRB, &
  & 0.55077408E-10_JPRB, 0.56618116E-10_JPRB, 0.58117341E-10_JPRB, 0.59485881E-10_JPRB, 0.60692416E-10_JPRB, 0.61746969E-10_JPRB, &
  & 0.62674602E-10_JPRB, 0.63519620E-10_JPRB, 0.64353016E-10_JPRB, 0.65231924E-10_JPRB, 0.66199504E-10_JPRB, 0.67258733E-10_JPRB, &
  & 0.68375451E-10_JPRB, 0.69473705E-10_JPRB, 0.70464523E-10_JPRB, 0.71249326E-10_JPRB, 0.71743729E-10_JPRB, 0.71873354E-10_JPRB, &
  & 0.71588929E-10_JPRB, 0.70883820E-10_JPRB, 0.69790618E-10_JPRB, 0.68363572E-10_JPRB, 0.66666568E-10_JPRB, 0.64728535E-10_JPRB, &
  & 0.62568242E-10_JPRB, 0.60200664E-10_JPRB, 0.57644049E-10_JPRB, 0.54944389E-10_JPRB, 0.52174830E-10_JPRB, 0.49429807E-10_JPRB, &
  & 0.46827549E-10_JPRB, 0.44457833E-10_JPRB, 0.42395948E-10_JPRB, 0.40673367E-10_JPRB, 0.39314725E-10_JPRB, 0.38303243E-10_JPRB, &
  & 0.37595333E-10_JPRB, 0.37133005E-10_JPRB, 0.36825543E-10_JPRB, 0.36627198E-10_JPRB /)

RGHG8(:,10, 9) = (/ &
  & 0.41931361E-10_JPRB, 0.42493960E-10_JPRB, 0.42853630E-10_JPRB, 0.43167053E-10_JPRB, 0.43519181E-10_JPRB, 0.43912006E-10_JPRB, &
  & 0.44364568E-10_JPRB, 0.44868449E-10_JPRB, 0.45414523E-10_JPRB, 0.45993959E-10_JPRB, 0.46595158E-10_JPRB, 0.47203106E-10_JPRB, &
  & 0.47802127E-10_JPRB, 0.48376504E-10_JPRB, 0.48919022E-10_JPRB, 0.49434651E-10_JPRB, 0.49938095E-10_JPRB, 0.50450196E-10_JPRB, &
  & 0.50997491E-10_JPRB, 0.51616371E-10_JPRB, 0.52356935E-10_JPRB, 0.53287146E-10_JPRB, 0.54487581E-10_JPRB, 0.56025778E-10_JPRB, &
  & 0.57893829E-10_JPRB, 0.59982144E-10_JPRB, 0.62186603E-10_JPRB, 0.64434721E-10_JPRB, 0.66661274E-10_JPRB, 0.68788197E-10_JPRB, &
  & 0.70747387E-10_JPRB, 0.72504863E-10_JPRB, 0.74051355E-10_JPRB, 0.75419865E-10_JPRB, 0.76655599E-10_JPRB, 0.77794930E-10_JPRB, &
  & 0.78822920E-10_JPRB, 0.79701024E-10_JPRB, 0.80369385E-10_JPRB, 0.80771730E-10_JPRB, 0.80865016E-10_JPRB, 0.80601005E-10_JPRB, &
  & 0.79949325E-10_JPRB, 0.78888715E-10_JPRB, 0.77423415E-10_JPRB, 0.75598763E-10_JPRB, 0.73455880E-10_JPRB, 0.71049291E-10_JPRB, &
  & 0.68411561E-10_JPRB, 0.65567024E-10_JPRB, 0.62552172E-10_JPRB, 0.59415979E-10_JPRB, 0.56230270E-10_JPRB, 0.53095400E-10_JPRB, &
  & 0.50104303E-10_JPRB, 0.47357430E-10_JPRB, 0.44922257E-10_JPRB, 0.42846442E-10_JPRB, 0.41138332E-10_JPRB, 0.39789134E-10_JPRB, &
  & 0.38779781E-10_JPRB, 0.38003989E-10_JPRB, 0.37438445E-10_JPRB, 0.36808067E-10_JPRB /)

RGHG8(:,11, 9) = (/ &
  & 0.43230374E-10_JPRB, 0.43913408E-10_JPRB, 0.44280610E-10_JPRB, 0.44640094E-10_JPRB, 0.44994154E-10_JPRB, 0.45406890E-10_JPRB, &
  & 0.45868975E-10_JPRB, 0.46386530E-10_JPRB, 0.46950745E-10_JPRB, 0.47553291E-10_JPRB, 0.48184342E-10_JPRB, 0.48830322E-10_JPRB, &
  & 0.49473037E-10_JPRB, 0.50097076E-10_JPRB, 0.50695274E-10_JPRB, 0.51269544E-10_JPRB, 0.51832171E-10_JPRB, 0.52406864E-10_JPRB, &
  & 0.53024370E-10_JPRB, 0.53725895E-10_JPRB, 0.54571445E-10_JPRB, 0.55648007E-10_JPRB, 0.57067004E-10_JPRB, 0.58933698E-10_JPRB, &
  & 0.61279225E-10_JPRB, 0.64033494E-10_JPRB, 0.67067740E-10_JPRB, 0.70228198E-10_JPRB, 0.73436174E-10_JPRB, 0.76644538E-10_JPRB, &
  & 0.79743136E-10_JPRB, 0.82567043E-10_JPRB, 0.85013781E-10_JPRB, 0.87049389E-10_JPRB, 0.88683325E-10_JPRB, 0.89943900E-10_JPRB, &
  & 0.90833667E-10_JPRB, 0.91364236E-10_JPRB, 0.91529638E-10_JPRB, 0.91347367E-10_JPRB, 0.90825930E-10_JPRB, 0.89970607E-10_JPRB, &
  & 0.88769284E-10_JPRB, 0.87210315E-10_JPRB, 0.85289831E-10_JPRB, 0.83028834E-10_JPRB, 0.80485917E-10_JPRB, 0.77706834E-10_JPRB, &
  & 0.74742650E-10_JPRB, 0.71643309E-10_JPRB, 0.68450447E-10_JPRB, 0.65213127E-10_JPRB, 0.61995388E-10_JPRB, 0.58872435E-10_JPRB, &
  & 0.55924168E-10_JPRB, 0.53214388E-10_JPRB, 0.50786614E-10_JPRB, 0.48646618E-10_JPRB, 0.46795796E-10_JPRB, 0.45209950E-10_JPRB, &
  & 0.43837788E-10_JPRB, 0.42684047E-10_JPRB, 0.41434585E-10_JPRB, 0.39813718E-10_JPRB /)

RGHG8(:,12, 9) = (/ &
  & 0.44903265E-10_JPRB, 0.45670471E-10_JPRB, 0.46139363E-10_JPRB, 0.46514570E-10_JPRB, 0.46926702E-10_JPRB, 0.47364907E-10_JPRB, &
  & 0.47866034E-10_JPRB, 0.48423057E-10_JPRB, 0.49034936E-10_JPRB, 0.49696254E-10_JPRB, 0.50399792E-10_JPRB, 0.51131530E-10_JPRB, &
  & 0.51873787E-10_JPRB, 0.52605219E-10_JPRB, 0.53314186E-10_JPRB, 0.53991651E-10_JPRB, 0.54652741E-10_JPRB, 0.55320588E-10_JPRB, &
  & 0.56027644E-10_JPRB, 0.56819067E-10_JPRB, 0.57753947E-10_JPRB, 0.58914928E-10_JPRB, 0.60407269E-10_JPRB, 0.62343367E-10_JPRB, &
  & 0.64787460E-10_JPRB, 0.67718622E-10_JPRB, 0.71079226E-10_JPRB, 0.74811213E-10_JPRB, 0.78817987E-10_JPRB, 0.82938489E-10_JPRB, &
  & 0.86961258E-10_JPRB, 0.90684640E-10_JPRB, 0.93928039E-10_JPRB, 0.96599347E-10_JPRB, 0.98664077E-10_JPRB, 0.10013916E-09_JPRB, &
  & 0.10103622E-09_JPRB, 0.10139995E-09_JPRB, 0.10126745E-09_JPRB, 0.10069930E-09_JPRB, 0.99748577E-10_JPRB, 0.98449311E-10_JPRB, &
  & 0.96819268E-10_JPRB, 0.94868238E-10_JPRB, 0.92604889E-10_JPRB, 0.90061368E-10_JPRB, 0.87286019E-10_JPRB, 0.84346786E-10_JPRB, &
  & 0.81316023E-10_JPRB, 0.78254299E-10_JPRB, 0.75216347E-10_JPRB, 0.72238576E-10_JPRB, 0.69371238E-10_JPRB, 0.66671696E-10_JPRB, &
  & 0.64187218E-10_JPRB, 0.61943471E-10_JPRB, 0.59945500E-10_JPRB, 0.58165212E-10_JPRB, 0.56583543E-10_JPRB, 0.55146849E-10_JPRB, &
  & 0.53850143E-10_JPRB, 0.52519149E-10_JPRB, 0.51129576E-10_JPRB, 0.48354949E-10_JPRB /)

RGHG8(:,13, 9) = (/ &
  & 0.46788268E-10_JPRB, 0.47695202E-10_JPRB, 0.48180501E-10_JPRB, 0.48623487E-10_JPRB, 0.49057664E-10_JPRB, 0.49554440E-10_JPRB, &
  & 0.50121164E-10_JPRB, 0.50778722E-10_JPRB, 0.51534079E-10_JPRB, 0.52391584E-10_JPRB, 0.53349908E-10_JPRB, 0.54394531E-10_JPRB, &
  & 0.55500719E-10_JPRB, 0.56628653E-10_JPRB, 0.57750492E-10_JPRB, 0.58837317E-10_JPRB, 0.59862997E-10_JPRB, 0.60837849E-10_JPRB, &
  & 0.61775335E-10_JPRB, 0.62707818E-10_JPRB, 0.63696715E-10_JPRB, 0.64820579E-10_JPRB, 0.66180950E-10_JPRB, 0.67896591E-10_JPRB, &
  & 0.70067875E-10_JPRB, 0.72764260E-10_JPRB, 0.75992171E-10_JPRB, 0.79739423E-10_JPRB, 0.83916880E-10_JPRB, 0.88358987E-10_JPRB, &
  & 0.92846383E-10_JPRB, 0.97077561E-10_JPRB, 0.10081805E-09_JPRB, 0.10391625E-09_JPRB, 0.10631260E-09_JPRB, 0.10799182E-09_JPRB, &
  & 0.10897609E-09_JPRB, 0.10931266E-09_JPRB, 0.10906823E-09_JPRB, 0.10832191E-09_JPRB, 0.10714753E-09_JPRB, 0.10560802E-09_JPRB, &
  & 0.10374544E-09_JPRB, 0.10158937E-09_JPRB, 0.99168944E-10_JPRB, 0.96529548E-10_JPRB, 0.93738663E-10_JPRB, 0.90878825E-10_JPRB, &
  & 0.88030798E-10_JPRB, 0.85265059E-10_JPRB, 0.82621750E-10_JPRB, 0.80129070E-10_JPRB, 0.77815185E-10_JPRB, 0.75709543E-10_JPRB, &
  & 0.73825231E-10_JPRB, 0.72161568E-10_JPRB, 0.70696227E-10_JPRB, 0.69392762E-10_JPRB, 0.68222782E-10_JPRB, 0.67146004E-10_JPRB, &
  & 0.66118389E-10_JPRB, 0.65105109E-10_JPRB, 0.63827728E-10_JPRB, 0.61567342E-10_JPRB /)

RGHG8(:,14, 9) = (/ &
  & 0.48624479E-10_JPRB, 0.49547980E-10_JPRB, 0.50064015E-10_JPRB, 0.50538546E-10_JPRB, 0.51069489E-10_JPRB, 0.51708610E-10_JPRB, &
  & 0.52509951E-10_JPRB, 0.53514197E-10_JPRB, 0.54750472E-10_JPRB, 0.56229417E-10_JPRB, 0.57939060E-10_JPRB, 0.59826040E-10_JPRB, &
  & 0.61806366E-10_JPRB, 0.63762468E-10_JPRB, 0.65594627E-10_JPRB, 0.67253009E-10_JPRB, 0.68734761E-10_JPRB, 0.70049057E-10_JPRB, &
  & 0.71220536E-10_JPRB, 0.72287412E-10_JPRB, 0.73292102E-10_JPRB, 0.74292780E-10_JPRB, 0.75370675E-10_JPRB, 0.76636357E-10_JPRB, &
  & 0.78225017E-10_JPRB, 0.80267556E-10_JPRB, 0.82895163E-10_JPRB, 0.86131935E-10_JPRB, 0.89952518E-10_JPRB, 0.94217772E-10_JPRB, &
  & 0.98626475E-10_JPRB, 0.10290115E-09_JPRB, 0.10676965E-09_JPRB, 0.11005348E-09_JPRB, 0.11262796E-09_JPRB, 0.11444577E-09_JPRB, &
  & 0.11551685E-09_JPRB, 0.11589031E-09_JPRB, 0.11563983E-09_JPRB, 0.11485127E-09_JPRB, 0.11360762E-09_JPRB, 0.11198076E-09_JPRB, &
  & 0.11003672E-09_JPRB, 0.10782152E-09_JPRB, 0.10539176E-09_JPRB, 0.10280900E-09_JPRB, 0.10016019E-09_JPRB, 0.97542564E-10_JPRB, &
  & 0.95038831E-10_JPRB, 0.92699612E-10_JPRB, 0.90546431E-10_JPRB, 0.88585229E-10_JPRB, 0.86819094E-10_JPRB, 0.85244957E-10_JPRB, &
  & 0.83857171E-10_JPRB, 0.82639576E-10_JPRB, 0.81568911E-10_JPRB, 0.80619462E-10_JPRB, 0.79760080E-10_JPRB, 0.78979719E-10_JPRB, &
  & 0.78211389E-10_JPRB, 0.77464077E-10_JPRB, 0.76504025E-10_JPRB, 0.74751511E-10_JPRB /)

RGHG8(:,15, 9) = (/ &
  & 0.50205621E-10_JPRB, 0.51147111E-10_JPRB, 0.51816718E-10_JPRB, 0.52505451E-10_JPRB, 0.53361374E-10_JPRB, 0.54449112E-10_JPRB, &
  & 0.55850005E-10_JPRB, 0.57607079E-10_JPRB, 0.59732858E-10_JPRB, 0.62189615E-10_JPRB, 0.64894638E-10_JPRB, 0.67716971E-10_JPRB, &
  & 0.70516433E-10_JPRB, 0.73171594E-10_JPRB, 0.75592616E-10_JPRB, 0.77728969E-10_JPRB, 0.79587142E-10_JPRB, 0.81190804E-10_JPRB, &
  & 0.82571942E-10_JPRB, 0.83773363E-10_JPRB, 0.84838074E-10_JPRB, 0.85808437E-10_JPRB, 0.86740524E-10_JPRB, 0.87721982E-10_JPRB, &
  & 0.88871306E-10_JPRB, 0.90327246E-10_JPRB, 0.92238085E-10_JPRB, 0.94749389E-10_JPRB, 0.97861545E-10_JPRB, 0.10146896E-09_JPRB, &
  & 0.10537408E-09_JPRB, 0.10926714E-09_JPRB, 0.11289338E-09_JPRB, 0.11603384E-09_JPRB, 0.11854728E-09_JPRB, 0.12035663E-09_JPRB, &
  & 0.12145200E-09_JPRB, 0.12187339E-09_JPRB, 0.12169318E-09_JPRB, 0.12098955E-09_JPRB, 0.11983210E-09_JPRB, 0.11828763E-09_JPRB, &
  & 0.11641815E-09_JPRB, 0.11428715E-09_JPRB, 0.11196508E-09_JPRB, 0.10954806E-09_JPRB, 0.10714234E-09_JPRB, 0.10484744E-09_JPRB, &
  & 0.10273180E-09_JPRB, 0.10082273E-09_JPRB, 0.99115591E-10_JPRB, 0.97590908E-10_JPRB, 0.96225576E-10_JPRB, 0.95004643E-10_JPRB, &
  & 0.93913481E-10_JPRB, 0.92941189E-10_JPRB, 0.92074362E-10_JPRB, 0.91297844E-10_JPRB, 0.90597495E-10_JPRB, 0.89962260E-10_JPRB, &
  & 0.89345725E-10_JPRB, 0.88751728E-10_JPRB, 0.87972150E-10_JPRB, 0.86554826E-10_JPRB /)

RGHG8(:,16, 9) = (/ &
  & 0.51973703E-10_JPRB, 0.53553356E-10_JPRB, 0.54699117E-10_JPRB, 0.55951563E-10_JPRB, 0.57383105E-10_JPRB, 0.59133073E-10_JPRB, &
  & 0.61244843E-10_JPRB, 0.63757263E-10_JPRB, 0.66651420E-10_JPRB, 0.69869367E-10_JPRB, 0.73316554E-10_JPRB, 0.76866680E-10_JPRB, &
  & 0.80357873E-10_JPRB, 0.83628229E-10_JPRB, 0.86579473E-10_JPRB, 0.89171684E-10_JPRB, 0.91411705E-10_JPRB, 0.93346095E-10_JPRB, &
  & 0.95015829E-10_JPRB, 0.96464975E-10_JPRB, 0.97739219E-10_JPRB, 0.98874381E-10_JPRB, 0.99900616E-10_JPRB, 0.10086421E-09_JPRB, &
  & 0.10184664E-09_JPRB, 0.10296484E-09_JPRB, 0.10433643E-09_JPRB, 0.10609046E-09_JPRB, 0.10832706E-09_JPRB, 0.11100110E-09_JPRB, &
  & 0.11396496E-09_JPRB, 0.11703168E-09_JPRB, 0.11996350E-09_JPRB, 0.12254829E-09_JPRB, 0.12465066E-09_JPRB, 0.12619504E-09_JPRB, &
  & 0.12716422E-09_JPRB, 0.12759679E-09_JPRB, 0.12754287E-09_JPRB, 0.12705155E-09_JPRB, 0.12615789E-09_JPRB, 0.12489312E-09_JPRB, &
  & 0.12329612E-09_JPRB, 0.12141985E-09_JPRB, 0.11935294E-09_JPRB, 0.11720494E-09_JPRB, 0.11510143E-09_JPRB, 0.11314313E-09_JPRB, &
  & 0.11138147E-09_JPRB, 0.10981995E-09_JPRB, 0.10842669E-09_JPRB, 0.10716245E-09_JPRB, 0.10599668E-09_JPRB, 0.10491289E-09_JPRB, &
  & 0.10390696E-09_JPRB, 0.10298246E-09_JPRB, 0.10214123E-09_JPRB, 0.10138394E-09_JPRB, 0.10070619E-09_JPRB, 0.10009885E-09_JPRB, &
  & 0.99528032E-10_JPRB, 0.98986139E-10_JPRB, 0.98266714E-10_JPRB, 0.97046968E-10_JPRB /)

RGHG8(:,17, 9) = (/ &
  & 0.55718069E-10_JPRB, 0.58912972E-10_JPRB, 0.60909458E-10_JPRB, 0.62709705E-10_JPRB, 0.64593171E-10_JPRB, 0.66710755E-10_JPRB, &
  & 0.69172945E-10_JPRB, 0.72030409E-10_JPRB, 0.75288768E-10_JPRB, 0.78906173E-10_JPRB, 0.82782267E-10_JPRB, 0.86766962E-10_JPRB, &
  & 0.90702133E-10_JPRB, 0.94423094E-10_JPRB, 0.97804410E-10_JPRB, 0.10079711E-09_JPRB, 0.10340739E-09_JPRB, 0.10568418E-09_JPRB, &
  & 0.10769181E-09_JPRB, 0.10948068E-09_JPRB, 0.11109830E-09_JPRB, 0.11257716E-09_JPRB, 0.11392155E-09_JPRB, 0.11512816E-09_JPRB, &
  & 0.11621496E-09_JPRB, 0.11724607E-09_JPRB, 0.11834053E-09_JPRB, 0.11955020E-09_JPRB, 0.12091848E-09_JPRB, 0.12251972E-09_JPRB, &
  & 0.12431134E-09_JPRB, 0.12618354E-09_JPRB, 0.12799083E-09_JPRB, 0.12959991E-09_JPRB, 0.13093415E-09_JPRB, 0.13194704E-09_JPRB, &
  & 0.13264508E-09_JPRB, 0.13302791E-09_JPRB, 0.13310952E-09_JPRB, 0.13289388E-09_JPRB, 0.13237197E-09_JPRB, 0.13152987E-09_JPRB, &
  & 0.13037005E-09_JPRB, 0.12892218E-09_JPRB, 0.12725915E-09_JPRB, 0.12549091E-09_JPRB, 0.12373982E-09_JPRB, 0.12210243E-09_JPRB, &
  & 0.12062115E-09_JPRB, 0.11928111E-09_JPRB, 0.11804217E-09_JPRB, 0.11686403E-09_JPRB, 0.11572002E-09_JPRB, 0.11460595E-09_JPRB, &
  & 0.11353512E-09_JPRB, 0.11252949E-09_JPRB, 0.11160856E-09_JPRB, 0.11078271E-09_JPRB, 0.11005395E-09_JPRB, 0.10941001E-09_JPRB, &
  & 0.10883282E-09_JPRB, 0.10825866E-09_JPRB, 0.10760959E-09_JPRB, 0.10636606E-09_JPRB /)

RGHG8(:,18, 9) = (/ &
  & 0.64080879E-10_JPRB, 0.69045866E-10_JPRB, 0.71510534E-10_JPRB, 0.73319989E-10_JPRB, 0.75049002E-10_JPRB, 0.76928741E-10_JPRB, &
  & 0.79140965E-10_JPRB, 0.81789450E-10_JPRB, 0.84900635E-10_JPRB, 0.88452287E-10_JPRB, 0.92360300E-10_JPRB, 0.96471525E-10_JPRB, &
  & 0.10058170E-09_JPRB, 0.10450404E-09_JPRB, 0.10809657E-09_JPRB, 0.11128948E-09_JPRB, 0.11408924E-09_JPRB, 0.11654500E-09_JPRB, &
  & 0.11873526E-09_JPRB, 0.12073761E-09_JPRB, 0.12260638E-09_JPRB, 0.12437533E-09_JPRB, 0.12605314E-09_JPRB, 0.12762547E-09_JPRB, &
  & 0.12905446E-09_JPRB, 0.13030269E-09_JPRB, 0.13136653E-09_JPRB, 0.13229939E-09_JPRB, 0.13314566E-09_JPRB, 0.13389703E-09_JPRB, &
  & 0.13458556E-09_JPRB, 0.13521941E-09_JPRB, 0.13583701E-09_JPRB, 0.13643242E-09_JPRB, 0.13694844E-09_JPRB, 0.13737211E-09_JPRB, &
  & 0.13770758E-09_JPRB, 0.13796873E-09_JPRB, 0.13813231E-09_JPRB, 0.13815366E-09_JPRB, 0.13797916E-09_JPRB, 0.13755838E-09_JPRB, &
  & 0.13685975E-09_JPRB, 0.13588576E-09_JPRB, 0.13468317E-09_JPRB, 0.13333554E-09_JPRB, 0.13194426E-09_JPRB, 0.13059233E-09_JPRB, &
  & 0.12931360E-09_JPRB, 0.12809862E-09_JPRB, 0.12691462E-09_JPRB, 0.12573163E-09_JPRB, 0.12453655E-09_JPRB, 0.12334134E-09_JPRB, &
  & 0.12217657E-09_JPRB, 0.12107801E-09_JPRB, 0.12007374E-09_JPRB, 0.11917986E-09_JPRB, 0.11839905E-09_JPRB, 0.11771949E-09_JPRB, &
  & 0.11711590E-09_JPRB, 0.11653739E-09_JPRB, 0.11589311E-09_JPRB, 0.11468208E-09_JPRB /)

RGHG8(:,19, 9) = (/ &
  & 0.77715147E-10_JPRB, 0.82588998E-10_JPRB, 0.84291928E-10_JPRB, 0.85446816E-10_JPRB, 0.86504477E-10_JPRB, 0.87741744E-10_JPRB, &
  & 0.89380697E-10_JPRB, 0.91525024E-10_JPRB, 0.94228209E-10_JPRB, 0.97470740E-10_JPRB, 0.10115722E-09_JPRB, 0.10511905E-09_JPRB, &
  & 0.10914773E-09_JPRB, 0.11301535E-09_JPRB, 0.11656992E-09_JPRB, 0.11973378E-09_JPRB, 0.12250559E-09_JPRB, 0.12494197E-09_JPRB, &
  & 0.12712208E-09_JPRB, 0.12913334E-09_JPRB, 0.13103967E-09_JPRB, 0.13288264E-09_JPRB, 0.13467992E-09_JPRB, 0.13641704E-09_JPRB, &
  & 0.13804022E-09_JPRB, 0.13946756E-09_JPRB, 0.14062668E-09_JPRB, 0.14147623E-09_JPRB, 0.14203078E-09_JPRB, 0.14233811E-09_JPRB, &
  & 0.14245349E-09_JPRB, 0.14242411E-09_JPRB, 0.14232242E-09_JPRB, 0.14220236E-09_JPRB, 0.14213532E-09_JPRB, 0.14213579E-09_JPRB, &
  & 0.14219642E-09_JPRB, 0.14232190E-09_JPRB, 0.14249811E-09_JPRB, 0.14265585E-09_JPRB, 0.14271224E-09_JPRB, 0.14259470E-09_JPRB, &
  & 0.14225168E-09_JPRB, 0.14166363E-09_JPRB, 0.14085008E-09_JPRB, 0.13986262E-09_JPRB, 0.13877492E-09_JPRB, 0.13765176E-09_JPRB, &
  & 0.13652723E-09_JPRB, 0.13540011E-09_JPRB, 0.13425216E-09_JPRB, 0.13306803E-09_JPRB, 0.13185007E-09_JPRB, 0.13062398E-09_JPRB, &
  & 0.12942897E-09_JPRB, 0.12830439E-09_JPRB, 0.12727955E-09_JPRB, 0.12636929E-09_JPRB, 0.12557637E-09_JPRB, 0.12489083E-09_JPRB, &
  & 0.12428360E-09_JPRB, 0.12372066E-09_JPRB, 0.12307549E-09_JPRB, 0.12197751E-09_JPRB /)

RGHG8(:,20, 9) = (/ &
  & 0.92749163E-10_JPRB, 0.95248823E-10_JPRB, 0.96031919E-10_JPRB, 0.96432209E-10_JPRB, 0.96884389E-10_JPRB, 0.97551703E-10_JPRB, &
  & 0.98656694E-10_JPRB, 0.10029892E-09_JPRB, 0.10254176E-09_JPRB, 0.10536317E-09_JPRB, 0.10867796E-09_JPRB, 0.11231373E-09_JPRB, &
  & 0.11604586E-09_JPRB, 0.11966446E-09_JPRB, 0.12299672E-09_JPRB, 0.12596957E-09_JPRB, 0.12858525E-09_JPRB, 0.13089081E-09_JPRB, &
  & 0.13296463E-09_JPRB, 0.13488854E-09_JPRB, 0.13673594E-09_JPRB, 0.13855161E-09_JPRB, 0.14035402E-09_JPRB, 0.14212985E-09_JPRB, &
  & 0.14381656E-09_JPRB, 0.14531257E-09_JPRB, 0.14651885E-09_JPRB, 0.14737259E-09_JPRB, 0.14786646E-09_JPRB, 0.14803973E-09_JPRB, &
  & 0.14794634E-09_JPRB, 0.14764742E-09_JPRB, 0.14722269E-09_JPRB, 0.14673995E-09_JPRB, 0.14630518E-09_JPRB, 0.14600150E-09_JPRB, &
  & 0.14592721E-09_JPRB, 0.14602526E-09_JPRB, 0.14621296E-09_JPRB, 0.14643506E-09_JPRB, 0.14660870E-09_JPRB, 0.14665782E-09_JPRB, &
  & 0.14652490E-09_JPRB, 0.14618246E-09_JPRB, 0.14562988E-09_JPRB, 0.14489331E-09_JPRB, 0.14402213E-09_JPRB, 0.14306754E-09_JPRB, &
  & 0.14206206E-09_JPRB, 0.14101259E-09_JPRB, 0.13991476E-09_JPRB, 0.13876802E-09_JPRB, 0.13758682E-09_JPRB, 0.13640324E-09_JPRB, &
  & 0.13525563E-09_JPRB, 0.13417958E-09_JPRB, 0.13320024E-09_JPRB, 0.13232836E-09_JPRB, 0.13156481E-09_JPRB, 0.13089996E-09_JPRB, &
  & 0.13031948E-09_JPRB, 0.12977103E-09_JPRB, 0.12920678E-09_JPRB, 0.12816904E-09_JPRB /)

RGHG8(:,21, 9) = (/ &
  & 0.10417973E-09_JPRB, 0.10533609E-09_JPRB, 0.10548012E-09_JPRB, 0.10546712E-09_JPRB, 0.10553362E-09_JPRB, 0.10584428E-09_JPRB, &
  & 0.10656070E-09_JPRB, 0.10779189E-09_JPRB, 0.10960731E-09_JPRB, 0.11199788E-09_JPRB, 0.11487460E-09_JPRB, 0.11808600E-09_JPRB, &
  & 0.12142964E-09_JPRB, 0.12468962E-09_JPRB, 0.12772207E-09_JPRB, 0.13044170E-09_JPRB, 0.13284480E-09_JPRB, 0.13498243E-09_JPRB, &
  & 0.13692204E-09_JPRB, 0.13873949E-09_JPRB, 0.14050068E-09_JPRB, 0.14225292E-09_JPRB, 0.14401272E-09_JPRB, 0.14576892E-09_JPRB, &
  & 0.14745014E-09_JPRB, 0.14895889E-09_JPRB, 0.15018828E-09_JPRB, 0.15107615E-09_JPRB, 0.15161265E-09_JPRB, 0.15182222E-09_JPRB, &
  & 0.15174424E-09_JPRB, 0.15143439E-09_JPRB, 0.15096950E-09_JPRB, 0.15043486E-09_JPRB, 0.14994957E-09_JPRB, 0.14960359E-09_JPRB, &
  & 0.14939630E-09_JPRB, 0.14937410E-09_JPRB, 0.14951107E-09_JPRB, 0.14970931E-09_JPRB, 0.14989503E-09_JPRB, 0.14998347E-09_JPRB, &
  & 0.14993286E-09_JPRB, 0.14970740E-09_JPRB, 0.14929259E-09_JPRB, 0.14870118E-09_JPRB, 0.14796388E-09_JPRB, 0.14712181E-09_JPRB, &
  & 0.14620501E-09_JPRB, 0.14522707E-09_JPRB, 0.14419313E-09_JPRB, 0.14311316E-09_JPRB, 0.14200952E-09_JPRB, 0.14091342E-09_JPRB, &
  & 0.13985854E-09_JPRB, 0.13887276E-09_JPRB, 0.13797380E-09_JPRB, 0.13716986E-09_JPRB, 0.13646188E-09_JPRB, 0.13584225E-09_JPRB, &
  & 0.13529305E-09_JPRB, 0.13480028E-09_JPRB, 0.13425125E-09_JPRB, 0.13338204E-09_JPRB /)

RGHG8(:,22, 9) = (/ &
  & 0.11279016E-09_JPRB, 0.11318509E-09_JPRB, 0.11302566E-09_JPRB, 0.11279508E-09_JPRB, 0.11264140E-09_JPRB, 0.11271975E-09_JPRB, &
  & 0.11315569E-09_JPRB, 0.11406610E-09_JPRB, 0.11551481E-09_JPRB, 0.11749329E-09_JPRB, 0.11993842E-09_JPRB, 0.12270811E-09_JPRB, &
  & 0.12562490E-09_JPRB, 0.12850954E-09_JPRB, 0.13121269E-09_JPRB, 0.13366915E-09_JPRB, 0.13586976E-09_JPRB, 0.13784708E-09_JPRB, &
  & 0.13966356E-09_JPRB, 0.14138306E-09_JPRB, 0.14306593E-09_JPRB, 0.14475482E-09_JPRB, 0.14646870E-09_JPRB, 0.14818903E-09_JPRB, &
  & 0.14985828E-09_JPRB, 0.15136528E-09_JPRB, 0.15261971E-09_JPRB, 0.15355750E-09_JPRB, 0.15416984E-09_JPRB, 0.15447657E-09_JPRB, &
  & 0.15450805E-09_JPRB, 0.15430761E-09_JPRB, 0.15393858E-09_JPRB, 0.15347558E-09_JPRB, 0.15302264E-09_JPRB, 0.15266657E-09_JPRB, &
  & 0.15245673E-09_JPRB, 0.15241627E-09_JPRB, 0.15248705E-09_JPRB, 0.15261729E-09_JPRB, 0.15273582E-09_JPRB, 0.15279697E-09_JPRB, &
  & 0.15273724E-09_JPRB, 0.15253039E-09_JPRB, 0.15216413E-09_JPRB, 0.15163615E-09_JPRB, 0.15096978E-09_JPRB, 0.15019815E-09_JPRB, &
  & 0.14934722E-09_JPRB, 0.14843130E-09_JPRB, 0.14746222E-09_JPRB, 0.14645780E-09_JPRB, 0.14544363E-09_JPRB, 0.14444969E-09_JPRB, &
  & 0.14350161E-09_JPRB, 0.14261846E-09_JPRB, 0.14181076E-09_JPRB, 0.14108203E-09_JPRB, 0.14043233E-09_JPRB, 0.13985814E-09_JPRB, &
  & 0.13935537E-09_JPRB, 0.13888732E-09_JPRB, 0.13842177E-09_JPRB, 0.13760350E-09_JPRB /)

RGHG8(:,23, 9) = (/ &
  & 0.11951751E-09_JPRB, 0.11950570E-09_JPRB, 0.11918327E-09_JPRB, 0.11881128E-09_JPRB, 0.11852375E-09_JPRB, 0.11843565E-09_JPRB, &
  & 0.11866566E-09_JPRB, 0.11931860E-09_JPRB, 0.12045301E-09_JPRB, 0.12207321E-09_JPRB, 0.12411688E-09_JPRB, 0.12647486E-09_JPRB, &
  & 0.12899484E-09_JPRB, 0.13151948E-09_JPRB, 0.13393113E-09_JPRB, 0.13615320E-09_JPRB, 0.13817265E-09_JPRB, 0.14001780E-09_JPRB, &
  & 0.14173519E-09_JPRB, 0.14337852E-09_JPRB, 0.14500127E-09_JPRB, 0.14663565E-09_JPRB, 0.14830621E-09_JPRB, 0.14998738E-09_JPRB, &
  & 0.15162080E-09_JPRB, 0.15311004E-09_JPRB, 0.15437004E-09_JPRB, 0.15535567E-09_JPRB, 0.15605890E-09_JPRB, 0.15648359E-09_JPRB, &
  & 0.15665480E-09_JPRB, 0.15660785E-09_JPRB, 0.15639506E-09_JPRB, 0.15608190E-09_JPRB, 0.15574930E-09_JPRB, 0.15546112E-09_JPRB, &
  & 0.15526339E-09_JPRB, 0.15518363E-09_JPRB, 0.15519343E-09_JPRB, 0.15523095E-09_JPRB, 0.15525833E-09_JPRB, 0.15522567E-09_JPRB, &
  & 0.15510582E-09_JPRB, 0.15486298E-09_JPRB, 0.15447865E-09_JPRB, 0.15396198E-09_JPRB, 0.15332156E-09_JPRB, 0.15258506E-09_JPRB, &
  & 0.15177630E-09_JPRB, 0.15091127E-09_JPRB, 0.15000397E-09_JPRB, 0.14907539E-09_JPRB, 0.14815171E-09_JPRB, 0.14725804E-09_JPRB, &
  & 0.14641251E-09_JPRB, 0.14562694E-09_JPRB, 0.14490519E-09_JPRB, 0.14424771E-09_JPRB, 0.14365363E-09_JPRB, 0.14312167E-09_JPRB, &
  & 0.14264635E-09_JPRB, 0.14221976E-09_JPRB, 0.14176768E-09_JPRB, 0.14108670E-09_JPRB /)

RGHG8(:,24, 9) = (/ &
  & 0.12496329E-09_JPRB, 0.12471722E-09_JPRB, 0.12429349E-09_JPRB, 0.12385279E-09_JPRB, 0.12347583E-09_JPRB, 0.12327246E-09_JPRB, &
  & 0.12334697E-09_JPRB, 0.12379293E-09_JPRB, 0.12466748E-09_JPRB, 0.12597766E-09_JPRB, 0.12767877E-09_JPRB, 0.12967716E-09_JPRB, &
  & 0.13185210E-09_JPRB, 0.13407500E-09_JPRB, 0.13623573E-09_JPRB, 0.13827116E-09_JPRB, 0.14015640E-09_JPRB, 0.14190323E-09_JPRB, &
  & 0.14354835E-09_JPRB, 0.14513388E-09_JPRB, 0.14670483E-09_JPRB, 0.14828820E-09_JPRB, 0.14990593E-09_JPRB, 0.15153032E-09_JPRB, &
  & 0.15310651E-09_JPRB, 0.15456335E-09_JPRB, 0.15582213E-09_JPRB, 0.15683153E-09_JPRB, 0.15758361E-09_JPRB, 0.15809873E-09_JPRB, &
  & 0.15839698E-09_JPRB, 0.15850395E-09_JPRB, 0.15845859E-09_JPRB, 0.15831178E-09_JPRB, 0.15811689E-09_JPRB, 0.15791686E-09_JPRB, &
  & 0.15776608E-09_JPRB, 0.15766259E-09_JPRB, 0.15760331E-09_JPRB, 0.15754194E-09_JPRB, 0.15745980E-09_JPRB, 0.15732103E-09_JPRB, &
  & 0.15710483E-09_JPRB, 0.15679863E-09_JPRB, 0.15637557E-09_JPRB, 0.15583732E-09_JPRB, 0.15519951E-09_JPRB, 0.15448565E-09_JPRB, &
  & 0.15371038E-09_JPRB, 0.15288812E-09_JPRB, 0.15203672E-09_JPRB, 0.15117832E-09_JPRB, 0.15033723E-09_JPRB, 0.14953233E-09_JPRB, &
  & 0.14877637E-09_JPRB, 0.14807369E-09_JPRB, 0.14742529E-09_JPRB, 0.14682916E-09_JPRB, 0.14628551E-09_JPRB, 0.14579417E-09_JPRB, &
  & 0.14535394E-09_JPRB, 0.14494746E-09_JPRB, 0.14453824E-09_JPRB, 0.14388052E-09_JPRB /)

RGHG8(:,25, 9) = (/ &
  & 0.12943979E-09_JPRB, 0.12906892E-09_JPRB, 0.12862761E-09_JPRB, 0.12816315E-09_JPRB, 0.12775818E-09_JPRB, 0.12748541E-09_JPRB, &
  & 0.12745033E-09_JPRB, 0.12773538E-09_JPRB, 0.12839961E-09_JPRB, 0.12945389E-09_JPRB, 0.13086875E-09_JPRB, 0.13257059E-09_JPRB, &
  & 0.13446309E-09_JPRB, 0.13644078E-09_JPRB, 0.13841189E-09_JPRB, 0.14030616E-09_JPRB, 0.14209268E-09_JPRB, 0.14377179E-09_JPRB, &
  & 0.14536344E-09_JPRB, 0.14690160E-09_JPRB, 0.14841788E-09_JPRB, 0.14993574E-09_JPRB, 0.15147242E-09_JPRB, 0.15301292E-09_JPRB, &
  & 0.15450420E-09_JPRB, 0.15587449E-09_JPRB, 0.15706739E-09_JPRB, 0.15806069E-09_JPRB, 0.15885003E-09_JPRB, 0.15943626E-09_JPRB, &
  & 0.15983689E-09_JPRB, 0.16007294E-09_JPRB, 0.16017308E-09_JPRB, 0.16017150E-09_JPRB, 0.16010829E-09_JPRB, 0.16001186E-09_JPRB, &
  & 0.15989918E-09_JPRB, 0.15978088E-09_JPRB, 0.15965278E-09_JPRB, 0.15950760E-09_JPRB, 0.15932239E-09_JPRB, 0.15908817E-09_JPRB, &
  & 0.15878003E-09_JPRB, 0.15839816E-09_JPRB, 0.15792632E-09_JPRB, 0.15736379E-09_JPRB, 0.15671794E-09_JPRB, 0.15601266E-09_JPRB, &
  & 0.15526593E-09_JPRB, 0.15448801E-09_JPRB, 0.15369250E-09_JPRB, 0.15290055E-09_JPRB, 0.15213328E-09_JPRB, 0.15140617E-09_JPRB, &
  & 0.15072428E-09_JPRB, 0.15008976E-09_JPRB, 0.14949977E-09_JPRB, 0.14895316E-09_JPRB, 0.14845009E-09_JPRB, 0.14799233E-09_JPRB, &
  & 0.14758032E-09_JPRB, 0.14720365E-09_JPRB, 0.14682139E-09_JPRB, 0.14622377E-09_JPRB /)

RGHG8(:,26, 9) = (/ &
  & 0.13318988E-09_JPRB, 0.13280305E-09_JPRB, 0.13238571E-09_JPRB, 0.13196377E-09_JPRB, 0.13156566E-09_JPRB, 0.13128153E-09_JPRB, &
  & 0.13118190E-09_JPRB, 0.13135419E-09_JPRB, 0.13185630E-09_JPRB, 0.13271029E-09_JPRB, 0.13389397E-09_JPRB, 0.13535875E-09_JPRB, &
  & 0.13702708E-09_JPRB, 0.13881264E-09_JPRB, 0.14063405E-09_JPRB, 0.14242485E-09_JPRB, 0.14413892E-09_JPRB, 0.14576622E-09_JPRB, &
  & 0.14731190E-09_JPRB, 0.14879466E-09_JPRB, 0.15024400E-09_JPRB, 0.15167972E-09_JPRB, 0.15311084E-09_JPRB, 0.15452686E-09_JPRB, &
  & 0.15588854E-09_JPRB, 0.15713776E-09_JPRB, 0.15824392E-09_JPRB, 0.15918841E-09_JPRB, 0.15996153E-09_JPRB, 0.16057822E-09_JPRB, &
  & 0.16104312E-09_JPRB, 0.16137000E-09_JPRB, 0.16157714E-09_JPRB, 0.16168411E-09_JPRB, 0.16171198E-09_JPRB, 0.16167886E-09_JPRB, &
  & 0.16159706E-09_JPRB, 0.16147027E-09_JPRB, 0.16130113E-09_JPRB, 0.16109181E-09_JPRB, 0.16083121E-09_JPRB, 0.16051992E-09_JPRB, &
  & 0.16014590E-09_JPRB, 0.15970619E-09_JPRB, 0.15919335E-09_JPRB, 0.15861060E-09_JPRB, 0.15796849E-09_JPRB, 0.15728184E-09_JPRB, &
  & 0.15656290E-09_JPRB, 0.15582409E-09_JPRB, 0.15508018E-09_JPRB, 0.15434871E-09_JPRB, 0.15364682E-09_JPRB, 0.15298401E-09_JPRB, &
  & 0.15236389E-09_JPRB, 0.15178531E-09_JPRB, 0.15124582E-09_JPRB, 0.15074363E-09_JPRB, 0.15027860E-09_JPRB, 0.14985137E-09_JPRB, &
  & 0.14946298E-09_JPRB, 0.14910857E-09_JPRB, 0.14874417E-09_JPRB, 0.14820280E-09_JPRB /)

RGHG8(:,27, 9) = (/ &
  & 0.13644111E-09_JPRB, 0.13610758E-09_JPRB, 0.13576244E-09_JPRB, 0.13539429E-09_JPRB, 0.13505999E-09_JPRB, 0.13478942E-09_JPRB, &
  & 0.13467248E-09_JPRB, 0.13478062E-09_JPRB, 0.13517346E-09_JPRB, 0.13587609E-09_JPRB, 0.13688597E-09_JPRB, 0.13816409E-09_JPRB, &
  & 0.13965479E-09_JPRB, 0.14128607E-09_JPRB, 0.14298530E-09_JPRB, 0.14468403E-09_JPRB, 0.14633468E-09_JPRB, 0.14790737E-09_JPRB, &
  & 0.14939208E-09_JPRB, 0.15080943E-09_JPRB, 0.15217341E-09_JPRB, 0.15350260E-09_JPRB, 0.15480080E-09_JPRB, 0.15606598E-09_JPRB, &
  & 0.15727065E-09_JPRB, 0.15838139E-09_JPRB, 0.15937821E-09_JPRB, 0.16024371E-09_JPRB, 0.16097557E-09_JPRB, 0.16157768E-09_JPRB, &
  & 0.16206489E-09_JPRB, 0.16244253E-09_JPRB, 0.16271655E-09_JPRB, 0.16289406E-09_JPRB, 0.16298377E-09_JPRB, 0.16299376E-09_JPRB, &
  & 0.16293004E-09_JPRB, 0.16279728E-09_JPRB, 0.16259911E-09_JPRB, 0.16234368E-09_JPRB, 0.16203099E-09_JPRB, 0.16166456E-09_JPRB, &
  & 0.16124432E-09_JPRB, 0.16076523E-09_JPRB, 0.16022655E-09_JPRB, 0.15962982E-09_JPRB, 0.15899164E-09_JPRB, 0.15832709E-09_JPRB, &
  & 0.15764724E-09_JPRB, 0.15695657E-09_JPRB, 0.15626581E-09_JPRB, 0.15559132E-09_JPRB, 0.15494674E-09_JPRB, 0.15434024E-09_JPRB, &
  & 0.15377226E-09_JPRB, 0.15324171E-09_JPRB, 0.15274577E-09_JPRB, 0.15228113E-09_JPRB, 0.15184604E-09_JPRB, 0.15144222E-09_JPRB, &
  & 0.15107385E-09_JPRB, 0.15073004E-09_JPRB, 0.15039170E-09_JPRB, 0.14987693E-09_JPRB /)

RGHG8(:,28, 9) = (/ &
  & 0.13942589E-09_JPRB, 0.13915449E-09_JPRB, 0.13887609E-09_JPRB, 0.13859225E-09_JPRB, 0.13830641E-09_JPRB, 0.13808572E-09_JPRB, &
  & 0.13797788E-09_JPRB, 0.13805994E-09_JPRB, 0.13838720E-09_JPRB, 0.13899183E-09_JPRB, 0.13987338E-09_JPRB, 0.14101166E-09_JPRB, &
  & 0.14236015E-09_JPRB, 0.14386028E-09_JPRB, 0.14544566E-09_JPRB, 0.14705330E-09_JPRB, 0.14862822E-09_JPRB, 0.15012483E-09_JPRB, &
  & 0.15153584E-09_JPRB, 0.15286813E-09_JPRB, 0.15412792E-09_JPRB, 0.15533093E-09_JPRB, 0.15648249E-09_JPRB, 0.15758407E-09_JPRB, &
  & 0.15862166E-09_JPRB, 0.15957358E-09_JPRB, 0.16042918E-09_JPRB, 0.16119082E-09_JPRB, 0.16186234E-09_JPRB, 0.16244528E-09_JPRB, &
  & 0.16293555E-09_JPRB, 0.16333500E-09_JPRB, 0.16364254E-09_JPRB, 0.16385736E-09_JPRB, 0.16398023E-09_JPRB, 0.16401305E-09_JPRB, &
  & 0.16395811E-09_JPRB, 0.16382072E-09_JPRB, 0.16360571E-09_JPRB, 0.16332280E-09_JPRB, 0.16298005E-09_JPRB, 0.16258193E-09_JPRB, &
  & 0.16213474E-09_JPRB, 0.16163740E-09_JPRB, 0.16109011E-09_JPRB, 0.16049875E-09_JPRB, 0.15987701E-09_JPRB, 0.15924029E-09_JPRB, &
  & 0.15859711E-09_JPRB, 0.15795089E-09_JPRB, 0.15730926E-09_JPRB, 0.15668589E-09_JPRB, 0.15609214E-09_JPRB, 0.15553342E-09_JPRB, &
  & 0.15501050E-09_JPRB, 0.15452191E-09_JPRB, 0.15406237E-09_JPRB, 0.15362886E-09_JPRB, 0.15322171E-09_JPRB, 0.15284485E-09_JPRB, &
  & 0.15250216E-09_JPRB, 0.15219467E-09_JPRB, 0.15187801E-09_JPRB, 0.15139863E-09_JPRB /)

RGHG8(:,29, 9) = (/ &
  & 0.14220504E-09_JPRB, 0.14200796E-09_JPRB, 0.14179859E-09_JPRB, 0.14156688E-09_JPRB, 0.14135257E-09_JPRB, 0.14117381E-09_JPRB, &
  & 0.14109472E-09_JPRB, 0.14117618E-09_JPRB, 0.14147274E-09_JPRB, 0.14201429E-09_JPRB, 0.14281072E-09_JPRB, 0.14384285E-09_JPRB, &
  & 0.14507651E-09_JPRB, 0.14645966E-09_JPRB, 0.14793383E-09_JPRB, 0.14943806E-09_JPRB, 0.15091910E-09_JPRB, 0.15231667E-09_JPRB, &
  & 0.15363941E-09_JPRB, 0.15486987E-09_JPRB, 0.15601435E-09_JPRB, 0.15708446E-09_JPRB, 0.15808764E-09_JPRB, 0.15903026E-09_JPRB, &
  & 0.15990566E-09_JPRB, 0.16070378E-09_JPRB, 0.16142972E-09_JPRB, 0.16209029E-09_JPRB, 0.16268631E-09_JPRB, 0.16322359E-09_JPRB, &
  & 0.16369495E-09_JPRB, 0.16409141E-09_JPRB, 0.16440632E-09_JPRB, 0.16463279E-09_JPRB, 0.16476699E-09_JPRB, 0.16480725E-09_JPRB, &
  & 0.16475415E-09_JPRB, 0.16461300E-09_JPRB, 0.16439079E-09_JPRB, 0.16409493E-09_JPRB, 0.16373938E-09_JPRB, 0.16332809E-09_JPRB, &
  & 0.16287251E-09_JPRB, 0.16237232E-09_JPRB, 0.16183190E-09_JPRB, 0.16125599E-09_JPRB, 0.16065811E-09_JPRB, 0.16005200E-09_JPRB, &
  & 0.15944304E-09_JPRB, 0.15883686E-09_JPRB, 0.15824157E-09_JPRB, 0.15766735E-09_JPRB, 0.15712104E-09_JPRB, 0.15660595E-09_JPRB, &
  & 0.15612216E-09_JPRB, 0.15566599E-09_JPRB, 0.15523535E-09_JPRB, 0.15482912E-09_JPRB, 0.15444902E-09_JPRB, 0.15409896E-09_JPRB, &
  & 0.15378195E-09_JPRB, 0.15348667E-09_JPRB, 0.15319364E-09_JPRB, 0.15272045E-09_JPRB /)

RGHG8(:,30, 9) = (/ &
  & 0.14480001E-09_JPRB, 0.14465482E-09_JPRB, 0.14449122E-09_JPRB, 0.14432758E-09_JPRB, 0.14416199E-09_JPRB, 0.14403516E-09_JPRB, &
  & 0.14398945E-09_JPRB, 0.14408429E-09_JPRB, 0.14437025E-09_JPRB, 0.14487830E-09_JPRB, 0.14561352E-09_JPRB, 0.14656590E-09_JPRB, &
  & 0.14770224E-09_JPRB, 0.14897820E-09_JPRB, 0.15033749E-09_JPRB, 0.15173282E-09_JPRB, 0.15309792E-09_JPRB, 0.15439128E-09_JPRB, &
  & 0.15560601E-09_JPRB, 0.15672807E-09_JPRB, 0.15775592E-09_JPRB, 0.15869878E-09_JPRB, 0.15956655E-09_JPRB, 0.16036496E-09_JPRB, &
  & 0.16109544E-09_JPRB, 0.16175990E-09_JPRB, 0.16236847E-09_JPRB, 0.16293170E-09_JPRB, 0.16345429E-09_JPRB, 0.16393646E-09_JPRB, &
  & 0.16437178E-09_JPRB, 0.16474704E-09_JPRB, 0.16505002E-09_JPRB, 0.16527012E-09_JPRB, 0.16540094E-09_JPRB, 0.16543873E-09_JPRB, &
  & 0.16538342E-09_JPRB, 0.16524029E-09_JPRB, 0.16501710E-09_JPRB, 0.16472093E-09_JPRB, 0.16436340E-09_JPRB, 0.16395543E-09_JPRB, &
  & 0.16350239E-09_JPRB, 0.16301427E-09_JPRB, 0.16249013E-09_JPRB, 0.16193880E-09_JPRB, 0.16137090E-09_JPRB, 0.16079829E-09_JPRB, &
  & 0.16022787E-09_JPRB, 0.15966276E-09_JPRB, 0.15910939E-09_JPRB, 0.15857599E-09_JPRB, 0.15806823E-09_JPRB, 0.15758679E-09_JPRB, &
  & 0.15713117E-09_JPRB, 0.15670155E-09_JPRB, 0.15629573E-09_JPRB, 0.15591339E-09_JPRB, 0.15555535E-09_JPRB, 0.15522410E-09_JPRB, &
  & 0.15492171E-09_JPRB, 0.15464967E-09_JPRB, 0.15436973E-09_JPRB, 0.15396102E-09_JPRB /)

RGHG8(:,31, 9) = (/ &
  & 0.14716434E-09_JPRB, 0.14706400E-09_JPRB, 0.14694840E-09_JPRB, 0.14682919E-09_JPRB, 0.14671887E-09_JPRB, 0.14663697E-09_JPRB, &
  & 0.14662714E-09_JPRB, 0.14674451E-09_JPRB, 0.14703368E-09_JPRB, 0.14752052E-09_JPRB, 0.14821376E-09_JPRB, 0.14909854E-09_JPRB, &
  & 0.15014823E-09_JPRB, 0.15132026E-09_JPRB, 0.15256724E-09_JPRB, 0.15384158E-09_JPRB, 0.15509043E-09_JPRB, 0.15627294E-09_JPRB, &
  & 0.15737758E-09_JPRB, 0.15839127E-09_JPRB, 0.15931105E-09_JPRB, 0.16014255E-09_JPRB, 0.16089118E-09_JPRB, 0.16156895E-09_JPRB, &
  & 0.16217896E-09_JPRB, 0.16273290E-09_JPRB, 0.16324356E-09_JPRB, 0.16372022E-09_JPRB, 0.16417102E-09_JPRB, 0.16459503E-09_JPRB, &
  & 0.16498522E-09_JPRB, 0.16532670E-09_JPRB, 0.16560527E-09_JPRB, 0.16580728E-09_JPRB, 0.16592544E-09_JPRB, 0.16595503E-09_JPRB, &
  & 0.16589598E-09_JPRB, 0.16575323E-09_JPRB, 0.16553427E-09_JPRB, 0.16524619E-09_JPRB, 0.16489883E-09_JPRB, 0.16450094E-09_JPRB, &
  & 0.16406596E-09_JPRB, 0.16359483E-09_JPRB, 0.16309648E-09_JPRB, 0.16257340E-09_JPRB, 0.16203744E-09_JPRB, 0.16149986E-09_JPRB, &
  & 0.16096595E-09_JPRB, 0.16043897E-09_JPRB, 0.15992323E-09_JPRB, 0.15942440E-09_JPRB, 0.15894712E-09_JPRB, 0.15849302E-09_JPRB, &
  & 0.15806366E-09_JPRB, 0.15765886E-09_JPRB, 0.15727697E-09_JPRB, 0.15691595E-09_JPRB, 0.15657753E-09_JPRB, 0.15626592E-09_JPRB, &
  & 0.15598597E-09_JPRB, 0.15572953E-09_JPRB, 0.15547529E-09_JPRB, 0.15505748E-09_JPRB /)

RGHG8(:,32, 9) = (/ &
  & 0.14929100E-09_JPRB, 0.14923329E-09_JPRB, 0.14915247E-09_JPRB, 0.14907534E-09_JPRB, 0.14900489E-09_JPRB, 0.14896434E-09_JPRB, &
  & 0.14899271E-09_JPRB, 0.14913527E-09_JPRB, 0.14943341E-09_JPRB, 0.14990960E-09_JPRB, 0.15056462E-09_JPRB, 0.15138894E-09_JPRB, &
  & 0.15235528E-09_JPRB, 0.15342713E-09_JPRB, 0.15456075E-09_JPRB, 0.15571626E-09_JPRB, 0.15684723E-09_JPRB, 0.15792397E-09_JPRB, &
  & 0.15892641E-09_JPRB, 0.15984485E-09_JPRB, 0.16067048E-09_JPRB, 0.16140665E-09_JPRB, 0.16206080E-09_JPRB, 0.16264019E-09_JPRB, &
  & 0.16315650E-09_JPRB, 0.16362212E-09_JPRB, 0.16405066E-09_JPRB, 0.16445413E-09_JPRB, 0.16483931E-09_JPRB, 0.16520614E-09_JPRB, &
  & 0.16554703E-09_JPRB, 0.16584795E-09_JPRB, 0.16609375E-09_JPRB, 0.16627047E-09_JPRB, 0.16637056E-09_JPRB, 0.16638919E-09_JPRB, &
  & 0.16632669E-09_JPRB, 0.16618749E-09_JPRB, 0.16597641E-09_JPRB, 0.16570412E-09_JPRB, 0.16537416E-09_JPRB, 0.16499536E-09_JPRB, &
  & 0.16458163E-09_JPRB, 0.16413812E-09_JPRB, 0.16366689E-09_JPRB, 0.16317583E-09_JPRB, 0.16267390E-09_JPRB, 0.16216939E-09_JPRB, &
  & 0.16166926E-09_JPRB, 0.16117570E-09_JPRB, 0.16069275E-09_JPRB, 0.16022446E-09_JPRB, 0.15977535E-09_JPRB, 0.15934826E-09_JPRB, &
  & 0.15894142E-09_JPRB, 0.15855775E-09_JPRB, 0.15819421E-09_JPRB, 0.15784940E-09_JPRB, 0.15752775E-09_JPRB, 0.15723289E-09_JPRB, &
  & 0.15696663E-09_JPRB, 0.15672529E-09_JPRB, 0.15647460E-09_JPRB, 0.15609429E-09_JPRB /)

RGHG8(:,33, 9) = (/ &
  & 0.15118755E-09_JPRB, 0.15116310E-09_JPRB, 0.15111343E-09_JPRB, 0.15106412E-09_JPRB, 0.15102838E-09_JPRB, 0.15102530E-09_JPRB, &
  & 0.15108649E-09_JPRB, 0.15125634E-09_JPRB, 0.15156590E-09_JPRB, 0.15203010E-09_JPRB, 0.15265121E-09_JPRB, 0.15341459E-09_JPRB, &
  & 0.15429964E-09_JPRB, 0.15527350E-09_JPRB, 0.15630086E-09_JPRB, 0.15734132E-09_JPRB, 0.15836440E-09_JPRB, 0.15933940E-09_JPRB, &
  & 0.16025137E-09_JPRB, 0.16108526E-09_JPRB, 0.16183728E-09_JPRB, 0.16250300E-09_JPRB, 0.16308423E-09_JPRB, 0.16359090E-09_JPRB, &
  & 0.16403556E-09_JPRB, 0.16443225E-09_JPRB, 0.16479511E-09_JPRB, 0.16513568E-09_JPRB, 0.16546219E-09_JPRB, 0.16577383E-09_JPRB, &
  & 0.16606461E-09_JPRB, 0.16632103E-09_JPRB, 0.16652943E-09_JPRB, 0.16667681E-09_JPRB, 0.16675604E-09_JPRB, 0.16676312E-09_JPRB, &
  & 0.16669834E-09_JPRB, 0.16656490E-09_JPRB, 0.16636682E-09_JPRB, 0.16611373E-09_JPRB, 0.16580788E-09_JPRB, 0.16545308E-09_JPRB, &
  & 0.16506602E-09_JPRB, 0.16465075E-09_JPRB, 0.16421230E-09_JPRB, 0.16375162E-09_JPRB, 0.16328118E-09_JPRB, 0.16280964E-09_JPRB, &
  & 0.16234018E-09_JPRB, 0.16187764E-09_JPRB, 0.16142356E-09_JPRB, 0.16098323E-09_JPRB, 0.16055841E-09_JPRB, 0.16015354E-09_JPRB, &
  & 0.15976812E-09_JPRB, 0.15940144E-09_JPRB, 0.15905337E-09_JPRB, 0.15872419E-09_JPRB, 0.15841714E-09_JPRB, 0.15813556E-09_JPRB, &
  & 0.15788339E-09_JPRB, 0.15765346E-09_JPRB, 0.15742407E-09_JPRB, 0.15704781E-09_JPRB /)

RGHG8(:,34, 9) = (/ &
  & 0.15282982E-09_JPRB, 0.15284742E-09_JPRB, 0.15283037E-09_JPRB, 0.15281032E-09_JPRB, 0.15280495E-09_JPRB, 0.15283289E-09_JPRB, &
  & 0.15292656E-09_JPRB, 0.15311882E-09_JPRB, 0.15343626E-09_JPRB, 0.15388943E-09_JPRB, 0.15447227E-09_JPRB, 0.15517704E-09_JPRB, &
  & 0.15598264E-09_JPRB, 0.15686476E-09_JPRB, 0.15779140E-09_JPRB, 0.15873172E-09_JPRB, 0.15965461E-09_JPRB, 0.16054234E-09_JPRB, &
  & 0.16137626E-09_JPRB, 0.16214483E-09_JPRB, 0.16283941E-09_JPRB, 0.16344925E-09_JPRB, 0.16397736E-09_JPRB, 0.16443247E-09_JPRB, &
  & 0.16482554E-09_JPRB, 0.16516914E-09_JPRB, 0.16547873E-09_JPRB, 0.16576632E-09_JPRB, 0.16603934E-09_JPRB, 0.16629924E-09_JPRB, &
  & 0.16654002E-09_JPRB, 0.16675103E-09_JPRB, 0.16692016E-09_JPRB, 0.16703675E-09_JPRB, 0.16709438E-09_JPRB, 0.16709041E-09_JPRB, &
  & 0.16702480E-09_JPRB, 0.16689949E-09_JPRB, 0.16671792E-09_JPRB, 0.16648753E-09_JPRB, 0.16620585E-09_JPRB, 0.16588134E-09_JPRB, &
  & 0.16552232E-09_JPRB, 0.16513611E-09_JPRB, 0.16473022E-09_JPRB, 0.16430153E-09_JPRB, 0.16385861E-09_JPRB, 0.16341797E-09_JPRB, &
  & 0.16297669E-09_JPRB, 0.16254033E-09_JPRB, 0.16211103E-09_JPRB, 0.16169516E-09_JPRB, 0.16129241E-09_JPRB, 0.16090836E-09_JPRB, &
  & 0.16054240E-09_JPRB, 0.16019351E-09_JPRB, 0.15986271E-09_JPRB, 0.15954918E-09_JPRB, 0.15925611E-09_JPRB, 0.15898778E-09_JPRB, &
  & 0.15874750E-09_JPRB, 0.15852963E-09_JPRB, 0.15830259E-09_JPRB, 0.15794335E-09_JPRB /)

RGHG8(:,35, 9) = (/ &
  & 0.15428823E-09_JPRB, 0.15432050E-09_JPRB, 0.15433126E-09_JPRB, 0.15433736E-09_JPRB, 0.15435804E-09_JPRB, 0.15441434E-09_JPRB, &
  & 0.15453180E-09_JPRB, 0.15474243E-09_JPRB, 0.15506398E-09_JPRB, 0.15549934E-09_JPRB, 0.15604658E-09_JPRB, 0.15669227E-09_JPRB, &
  & 0.15742493E-09_JPRB, 0.15822120E-09_JPRB, 0.15905881E-09_JPRB, 0.15990689E-09_JPRB, 0.16074496E-09_JPRB, 0.16155551E-09_JPRB, &
  & 0.16232347E-09_JPRB, 0.16303833E-09_JPRB, 0.16368763E-09_JPRB, 0.16426015E-09_JPRB, 0.16475517E-09_JPRB, 0.16517634E-09_JPRB, &
  & 0.16553245E-09_JPRB, 0.16583629E-09_JPRB, 0.16610223E-09_JPRB, 0.16634344E-09_JPRB, 0.16656843E-09_JPRB, 0.16677898E-09_JPRB, &
  & 0.16697153E-09_JPRB, 0.16713789E-09_JPRB, 0.16726820E-09_JPRB, 0.16735448E-09_JPRB, 0.16739174E-09_JPRB, 0.16737813E-09_JPRB, &
  & 0.16731350E-09_JPRB, 0.16719842E-09_JPRB, 0.16703572E-09_JPRB, 0.16682862E-09_JPRB, 0.16657430E-09_JPRB, 0.16627852E-09_JPRB, &
  & 0.16594831E-09_JPRB, 0.16559371E-09_JPRB, 0.16521756E-09_JPRB, 0.16481774E-09_JPRB, 0.16440188E-09_JPRB, 0.16398809E-09_JPRB, &
  & 0.16357289E-09_JPRB, 0.16315918E-09_JPRB, 0.16275166E-09_JPRB, 0.16235743E-09_JPRB, 0.16197624E-09_JPRB, 0.16161114E-09_JPRB, &
  & 0.16126650E-09_JPRB, 0.16093778E-09_JPRB, 0.16062426E-09_JPRB, 0.16032629E-09_JPRB, 0.16004688E-09_JPRB, 0.15979072E-09_JPRB, &
  & 0.15956114E-09_JPRB, 0.15935089E-09_JPRB, 0.15913647E-09_JPRB, 0.15878332E-09_JPRB /)

RGHG8(:,36, 9) = (/ &
  & 0.15553883E-09_JPRB, 0.15561728E-09_JPRB, 0.15564899E-09_JPRB, 0.15567678E-09_JPRB, 0.15572008E-09_JPRB, 0.15579733E-09_JPRB, &
  & 0.15593507E-09_JPRB, 0.15615638E-09_JPRB, 0.15647472E-09_JPRB, 0.15689236E-09_JPRB, 0.15740000E-09_JPRB, 0.15799215E-09_JPRB, &
  & 0.15865552E-09_JPRB, 0.15937573E-09_JPRB, 0.16013051E-09_JPRB, 0.16090010E-09_JPRB, 0.16166053E-09_JPRB, 0.16240466E-09_JPRB, &
  & 0.16311827E-09_JPRB, 0.16378847E-09_JPRB, 0.16440531E-09_JPRB, 0.16495530E-09_JPRB, 0.16542928E-09_JPRB, 0.16582799E-09_JPRB, &
  & 0.16615603E-09_JPRB, 0.16642643E-09_JPRB, 0.16665516E-09_JPRB, 0.16685535E-09_JPRB, 0.16703605E-09_JPRB, 0.16720113E-09_JPRB, &
  & 0.16734882E-09_JPRB, 0.16747337E-09_JPRB, 0.16756802E-09_JPRB, 0.16762695E-09_JPRB, 0.16764684E-09_JPRB, 0.16762657E-09_JPRB, &
  & 0.16756548E-09_JPRB, 0.16746335E-09_JPRB, 0.16732128E-09_JPRB, 0.16713907E-09_JPRB, 0.16691150E-09_JPRB, 0.16664355E-09_JPRB, &
  & 0.16634431E-09_JPRB, 0.16602067E-09_JPRB, 0.16566913E-09_JPRB, 0.16529557E-09_JPRB, 0.16490773E-09_JPRB, 0.16451655E-09_JPRB, &
  & 0.16412367E-09_JPRB, 0.16372899E-09_JPRB, 0.16334123E-09_JPRB, 0.16296647E-09_JPRB, 0.16260630E-09_JPRB, 0.16226290E-09_JPRB, &
  & 0.16193999E-09_JPRB, 0.16163212E-09_JPRB, 0.16133772E-09_JPRB, 0.16105710E-09_JPRB, 0.16079268E-09_JPRB, 0.16054949E-09_JPRB, &
  & 0.16033057E-09_JPRB, 0.16013048E-09_JPRB, 0.15992041E-09_JPRB, 0.15957671E-09_JPRB /)

RGHG8(:,37, 9) = (/ &
  & 0.15665354E-09_JPRB, 0.15676917E-09_JPRB, 0.15681823E-09_JPRB, 0.15686424E-09_JPRB, 0.15692515E-09_JPRB, 0.15702091E-09_JPRB, &
  & 0.15717191E-09_JPRB, 0.15739884E-09_JPRB, 0.15771061E-09_JPRB, 0.15810385E-09_JPRB, 0.15857426E-09_JPRB, 0.15911228E-09_JPRB, &
  & 0.15971244E-09_JPRB, 0.16036056E-09_JPRB, 0.16104222E-09_JPRB, 0.16173753E-09_JPRB, 0.16243397E-09_JPRB, 0.16311502E-09_JPRB, &
  & 0.16378250E-09_JPRB, 0.16442062E-09_JPRB, 0.16501306E-09_JPRB, 0.16554484E-09_JPRB, 0.16600143E-09_JPRB, 0.16637600E-09_JPRB, &
  & 0.16667542E-09_JPRB, 0.16691254E-09_JPRB, 0.16710533E-09_JPRB, 0.16726802E-09_JPRB, 0.16741007E-09_JPRB, 0.16753596E-09_JPRB, &
  & 0.16764548E-09_JPRB, 0.16773556E-09_JPRB, 0.16780122E-09_JPRB, 0.16783881E-09_JPRB, 0.16784638E-09_JPRB, 0.16782345E-09_JPRB, &
  & 0.16776946E-09_JPRB, 0.16768324E-09_JPRB, 0.16756471E-09_JPRB, 0.16740974E-09_JPRB, 0.16721119E-09_JPRB, 0.16697527E-09_JPRB, &
  & 0.16670756E-09_JPRB, 0.16640837E-09_JPRB, 0.16608191E-09_JPRB, 0.16573472E-09_JPRB, 0.16537226E-09_JPRB, 0.16500118E-09_JPRB, &
  & 0.16462601E-09_JPRB, 0.16424974E-09_JPRB, 0.16387992E-09_JPRB, 0.16352346E-09_JPRB, 0.16318377E-09_JPRB, 0.16286325E-09_JPRB, &
  & 0.16256338E-09_JPRB, 0.16227900E-09_JPRB, 0.16200613E-09_JPRB, 0.16174476E-09_JPRB, 0.16149716E-09_JPRB, 0.16126800E-09_JPRB, &
  & 0.16106051E-09_JPRB, 0.16086832E-09_JPRB, 0.16066633E-09_JPRB, 0.16032994E-09_JPRB /)

RGHG8(:,38, 9) = (/ &
  & 0.15769434E-09_JPRB, 0.15780677E-09_JPRB, 0.15786944E-09_JPRB, 0.15793007E-09_JPRB, 0.15800758E-09_JPRB, 0.15811791E-09_JPRB, &
  & 0.15828001E-09_JPRB, 0.15850803E-09_JPRB, 0.15880672E-09_JPRB, 0.15917408E-09_JPRB, 0.15960366E-09_JPRB, 0.16008983E-09_JPRB, &
  & 0.16062732E-09_JPRB, 0.16120809E-09_JPRB, 0.16181975E-09_JPRB, 0.16244868E-09_JPRB, 0.16308449E-09_JPRB, 0.16371780E-09_JPRB, &
  & 0.16433957E-09_JPRB, 0.16494449E-09_JPRB, 0.16551438E-09_JPRB, 0.16602349E-09_JPRB, 0.16645239E-09_JPRB, 0.16679523E-09_JPRB, &
  & 0.16705753E-09_JPRB, 0.16725886E-09_JPRB, 0.16741777E-09_JPRB, 0.16754871E-09_JPRB, 0.16766055E-09_JPRB, 0.16775767E-09_JPRB, &
  & 0.16784070E-09_JPRB, 0.16790726E-09_JPRB, 0.16795390E-09_JPRB, 0.16797810E-09_JPRB, 0.16797871E-09_JPRB, 0.16795619E-09_JPRB, &
  & 0.16791017E-09_JPRB, 0.16784026E-09_JPRB, 0.16774548E-09_JPRB, 0.16761957E-09_JPRB, 0.16745548E-09_JPRB, 0.16725685E-09_JPRB, &
  & 0.16702137E-09_JPRB, 0.16675179E-09_JPRB, 0.16645343E-09_JPRB, 0.16613214E-09_JPRB, 0.16579133E-09_JPRB, 0.16543976E-09_JPRB, &
  & 0.16508123E-09_JPRB, 0.16472126E-09_JPRB, 0.16436781E-09_JPRB, 0.16402957E-09_JPRB, 0.16371109E-09_JPRB, 0.16341521E-09_JPRB, &
  & 0.16314031E-09_JPRB, 0.16288056E-09_JPRB, 0.16263144E-09_JPRB, 0.16239111E-09_JPRB, 0.16216199E-09_JPRB, 0.16194825E-09_JPRB, &
  & 0.16175294E-09_JPRB, 0.16157042E-09_JPRB, 0.16137573E-09_JPRB, 0.16104770E-09_JPRB /)

RGHG8(:,39, 9) = (/ &
  & 0.15860534E-09_JPRB, 0.15874561E-09_JPRB, 0.15882301E-09_JPRB, 0.15889948E-09_JPRB, 0.15899186E-09_JPRB, 0.15911679E-09_JPRB, &
  & 0.15928753E-09_JPRB, 0.15951231E-09_JPRB, 0.15979484E-09_JPRB, 0.16013196E-09_JPRB, 0.16051918E-09_JPRB, 0.16095279E-09_JPRB, &
  & 0.16142947E-09_JPRB, 0.16194437E-09_JPRB, 0.16248977E-09_JPRB, 0.16305521E-09_JPRB, 0.16363211E-09_JPRB, 0.16421618E-09_JPRB, &
  & 0.16479951E-09_JPRB, 0.16537163E-09_JPRB, 0.16590938E-09_JPRB, 0.16638729E-09_JPRB, 0.16677985E-09_JPRB, 0.16708203E-09_JPRB, &
  & 0.16730788E-09_JPRB, 0.16747698E-09_JPRB, 0.16760884E-09_JPRB, 0.16771655E-09_JPRB, 0.16780796E-09_JPRB, 0.16788682E-09_JPRB, &
  & 0.16795382E-09_JPRB, 0.16800693E-09_JPRB, 0.16804312E-09_JPRB, 0.16806012E-09_JPRB, 0.16805743E-09_JPRB, 0.16803585E-09_JPRB, &
  & 0.16799596E-09_JPRB, 0.16793798E-09_JPRB, 0.16786168E-09_JPRB, 0.16776130E-09_JPRB, 0.16763019E-09_JPRB, 0.16746951E-09_JPRB, &
  & 0.16727211E-09_JPRB, 0.16703934E-09_JPRB, 0.16677486E-09_JPRB, 0.16648112E-09_JPRB, 0.16616443E-09_JPRB, 0.16583269E-09_JPRB, &
  & 0.16549054E-09_JPRB, 0.16514556E-09_JPRB, 0.16480808E-09_JPRB, 0.16448769E-09_JPRB, 0.16419115E-09_JPRB, 0.16392038E-09_JPRB, &
  & 0.16367120E-09_JPRB, 0.16343758E-09_JPRB, 0.16321294E-09_JPRB, 0.16299542E-09_JPRB, 0.16278617E-09_JPRB, 0.16258958E-09_JPRB, &
  & 0.16240788E-09_JPRB, 0.16223597E-09_JPRB, 0.16204936E-09_JPRB, 0.16173315E-09_JPRB /)

RGHG8(:,40, 9) = (/ &
  & 0.15945020E-09_JPRB, 0.15960701E-09_JPRB, 0.15969964E-09_JPRB, 0.15978854E-09_JPRB, 0.15989746E-09_JPRB, 0.16003629E-09_JPRB, &
  & 0.16021272E-09_JPRB, 0.16043303E-09_JPRB, 0.16069550E-09_JPRB, 0.16099989E-09_JPRB, 0.16134422E-09_JPRB, 0.16172527E-09_JPRB, &
  & 0.16214281E-09_JPRB, 0.16259448E-09_JPRB, 0.16307576E-09_JPRB, 0.16358057E-09_JPRB, 0.16410295E-09_JPRB, 0.16463721E-09_JPRB, &
  & 0.16517913E-09_JPRB, 0.16571271E-09_JPRB, 0.16621689E-09_JPRB, 0.16665533E-09_JPRB, 0.16700780E-09_JPRB, 0.16727324E-09_JPRB, &
  & 0.16746743E-09_JPRB, 0.16761199E-09_JPRB, 0.16772432E-09_JPRB, 0.16781621E-09_JPRB, 0.16789428E-09_JPRB, 0.16796205E-09_JPRB, &
  & 0.16801974E-09_JPRB, 0.16806559E-09_JPRB, 0.16809634E-09_JPRB, 0.16810975E-09_JPRB, 0.16810543E-09_JPRB, 0.16808457E-09_JPRB, &
  & 0.16804846E-09_JPRB, 0.16799795E-09_JPRB, 0.16793397E-09_JPRB, 0.16785154E-09_JPRB, 0.16774623E-09_JPRB, 0.16761760E-09_JPRB, &
  & 0.16745730E-09_JPRB, 0.16726485E-09_JPRB, 0.16703892E-09_JPRB, 0.16677787E-09_JPRB, 0.16648931E-09_JPRB, 0.16617945E-09_JPRB, &
  & 0.16585394E-09_JPRB, 0.16552491E-09_JPRB, 0.16520318E-09_JPRB, 0.16490100E-09_JPRB, 0.16462670E-09_JPRB, 0.16438047E-09_JPRB, &
  & 0.16415745E-09_JPRB, 0.16394941E-09_JPRB, 0.16375025E-09_JPRB, 0.16355575E-09_JPRB, 0.16336757E-09_JPRB, 0.16318896E-09_JPRB, &
  & 0.16302269E-09_JPRB, 0.16286265E-09_JPRB, 0.16268774E-09_JPRB, 0.16238459E-09_JPRB /)

RGHG8(:,41, 9) = (/ &
  & 0.16024186E-09_JPRB, 0.16041291E-09_JPRB, 0.16051208E-09_JPRB, 0.16061617E-09_JPRB, 0.16073819E-09_JPRB, 0.16088959E-09_JPRB, &
  & 0.16107261E-09_JPRB, 0.16128336E-09_JPRB, 0.16152517E-09_JPRB, 0.16179673E-09_JPRB, 0.16209770E-09_JPRB, 0.16242839E-09_JPRB, &
  & 0.16278927E-09_JPRB, 0.16318073E-09_JPRB, 0.16360084E-09_JPRB, 0.16404626E-09_JPRB, 0.16451358E-09_JPRB, 0.16500025E-09_JPRB, &
  & 0.16549791E-09_JPRB, 0.16599500E-09_JPRB, 0.16645836E-09_JPRB, 0.16685890E-09_JPRB, 0.16717314E-09_JPRB, 0.16740580E-09_JPRB, &
  & 0.16757511E-09_JPRB, 0.16770091E-09_JPRB, 0.16779919E-09_JPRB, 0.16787988E-09_JPRB, 0.16794914E-09_JPRB, 0.16800959E-09_JPRB, &
  & 0.16806186E-09_JPRB, 0.16810366E-09_JPRB, 0.16813172E-09_JPRB, 0.16814333E-09_JPRB, 0.16813823E-09_JPRB, 0.16811788E-09_JPRB, &
  & 0.16808402E-09_JPRB, 0.16803826E-09_JPRB, 0.16798195E-09_JPRB, 0.16791216E-09_JPRB, 0.16782471E-09_JPRB, 0.16772053E-09_JPRB, &
  & 0.16759125E-09_JPRB, 0.16743563E-09_JPRB, 0.16724809E-09_JPRB, 0.16702505E-09_JPRB, 0.16676750E-09_JPRB, 0.16648184E-09_JPRB, &
  & 0.16617584E-09_JPRB, 0.16586275E-09_JPRB, 0.16555678E-09_JPRB, 0.16527314E-09_JPRB, 0.16502036E-09_JPRB, 0.16479847E-09_JPRB, &
  & 0.16460035E-09_JPRB, 0.16441791E-09_JPRB, 0.16424279E-09_JPRB, 0.16407170E-09_JPRB, 0.16390451E-09_JPRB, 0.16374532E-09_JPRB, &
  & 0.16359535E-09_JPRB, 0.16344975E-09_JPRB, 0.16328680E-09_JPRB, 0.16300342E-09_JPRB /)

RGHG8(:,42, 9) = (/ &
  & 0.16100116E-09_JPRB, 0.16117575E-09_JPRB, 0.16128553E-09_JPRB, 0.16139488E-09_JPRB, 0.16153114E-09_JPRB, 0.16169446E-09_JPRB, &
  & 0.16187739E-09_JPRB, 0.16208036E-09_JPRB, 0.16229942E-09_JPRB, 0.16253862E-09_JPRB, 0.16279891E-09_JPRB, 0.16308177E-09_JPRB, &
  & 0.16338995E-09_JPRB, 0.16372495E-09_JPRB, 0.16408708E-09_JPRB, 0.16447510E-09_JPRB, 0.16488831E-09_JPRB, 0.16532453E-09_JPRB, &
  & 0.16578006E-09_JPRB, 0.16623462E-09_JPRB, 0.16666168E-09_JPRB, 0.16702177E-09_JPRB, 0.16730069E-09_JPRB, 0.16750497E-09_JPRB, &
  & 0.16765342E-09_JPRB, 0.16776459E-09_JPRB, 0.16785195E-09_JPRB, 0.16792448E-09_JPRB, 0.16798724E-09_JPRB, 0.16804297E-09_JPRB, &
  & 0.16809165E-09_JPRB, 0.16813129E-09_JPRB, 0.16815795E-09_JPRB, 0.16816883E-09_JPRB, 0.16816346E-09_JPRB, 0.16814354E-09_JPRB, &
  & 0.16811126E-09_JPRB, 0.16806845E-09_JPRB, 0.16801749E-09_JPRB, 0.16795608E-09_JPRB, 0.16788164E-09_JPRB, 0.16779524E-09_JPRB, &
  & 0.16769033E-09_JPRB, 0.16756500E-09_JPRB, 0.16741374E-09_JPRB, 0.16722661E-09_JPRB, 0.16700340E-09_JPRB, 0.16674437E-09_JPRB, &
  & 0.16645886E-09_JPRB, 0.16616346E-09_JPRB, 0.16587451E-09_JPRB, 0.16560901E-09_JPRB, 0.16537777E-09_JPRB, 0.16517861E-09_JPRB, &
  & 0.16500459E-09_JPRB, 0.16484589E-09_JPRB, 0.16469462E-09_JPRB, 0.16454574E-09_JPRB, 0.16439985E-09_JPRB, 0.16425970E-09_JPRB, &
  & 0.16412732E-09_JPRB, 0.16399677E-09_JPRB, 0.16384999E-09_JPRB, 0.16358977E-09_JPRB /)

RGHG8(:,43, 9) = (/ &
  & 0.16175383E-09_JPRB, 0.16193136E-09_JPRB, 0.16203661E-09_JPRB, 0.16215199E-09_JPRB, 0.16229432E-09_JPRB, 0.16246274E-09_JPRB, &
  & 0.16264723E-09_JPRB, 0.16283679E-09_JPRB, 0.16303481E-09_JPRB, 0.16324317E-09_JPRB, 0.16346530E-09_JPRB, 0.16370441E-09_JPRB, &
  & 0.16396381E-09_JPRB, 0.16424688E-09_JPRB, 0.16455426E-09_JPRB, 0.16488712E-09_JPRB, 0.16524575E-09_JPRB, 0.16563265E-09_JPRB, &
  & 0.16604063E-09_JPRB, 0.16645585E-09_JPRB, 0.16683940E-09_JPRB, 0.16716066E-09_JPRB, 0.16740478E-09_JPRB, 0.16758334E-09_JPRB, &
  & 0.16771401E-09_JPRB, 0.16781293E-09_JPRB, 0.16789174E-09_JPRB, 0.16795779E-09_JPRB, 0.16801582E-09_JPRB, 0.16806803E-09_JPRB, &
  & 0.16811469E-09_JPRB, 0.16815316E-09_JPRB, 0.16817939E-09_JPRB, 0.16819011E-09_JPRB, 0.16818477E-09_JPRB, 0.16816529E-09_JPRB, &
  & 0.16813402E-09_JPRB, 0.16809343E-09_JPRB, 0.16804598E-09_JPRB, 0.16799086E-09_JPRB, 0.16792562E-09_JPRB, 0.16785273E-09_JPRB, &
  & 0.16776666E-09_JPRB, 0.16766635E-09_JPRB, 0.16754531E-09_JPRB, 0.16739349E-09_JPRB, 0.16720385E-09_JPRB, 0.16697342E-09_JPRB, &
  & 0.16671103E-09_JPRB, 0.16643396E-09_JPRB, 0.16616228E-09_JPRB, 0.16591567E-09_JPRB, 0.16570428E-09_JPRB, 0.16552698E-09_JPRB, &
  & 0.16537538E-09_JPRB, 0.16523946E-09_JPRB, 0.16511031E-09_JPRB, 0.16498321E-09_JPRB, 0.16485750E-09_JPRB, 0.16473641E-09_JPRB, &
  & 0.16462125E-09_JPRB, 0.16450745E-09_JPRB, 0.16437782E-09_JPRB, 0.16414720E-09_JPRB /)

RGHG8(:,44, 9) = (/ &
  & 0.16250150E-09_JPRB, 0.16268759E-09_JPRB, 0.16279295E-09_JPRB, 0.16290394E-09_JPRB, 0.16304588E-09_JPRB, 0.16321723E-09_JPRB, &
  & 0.16339384E-09_JPRB, 0.16357124E-09_JPRB, 0.16374724E-09_JPRB, 0.16392675E-09_JPRB, 0.16411372E-09_JPRB, 0.16431220E-09_JPRB, &
  & 0.16452785E-09_JPRB, 0.16476244E-09_JPRB, 0.16501940E-09_JPRB, 0.16529872E-09_JPRB, 0.16560511E-09_JPRB, 0.16593871E-09_JPRB, &
  & 0.16630054E-09_JPRB, 0.16666597E-09_JPRB, 0.16700559E-09_JPRB, 0.16728294E-09_JPRB, 0.16749323E-09_JPRB, 0.16764776E-09_JPRB, &
  & 0.16776262E-09_JPRB, 0.16785121E-09_JPRB, 0.16792277E-09_JPRB, 0.16798371E-09_JPRB, 0.16803810E-09_JPRB, 0.16808803E-09_JPRB, &
  & 0.16813340E-09_JPRB, 0.16817162E-09_JPRB, 0.16819797E-09_JPRB, 0.16820902E-09_JPRB, 0.16820395E-09_JPRB, 0.16818488E-09_JPRB, &
  & 0.16815445E-09_JPRB, 0.16811529E-09_JPRB, 0.16807046E-09_JPRB, 0.16801976E-09_JPRB, 0.16796164E-09_JPRB, 0.16789921E-09_JPRB, &
  & 0.16782831E-09_JPRB, 0.16774818E-09_JPRB, 0.16765374E-09_JPRB, 0.16753332E-09_JPRB, 0.16737739E-09_JPRB, 0.16717802E-09_JPRB, &
  & 0.16693920E-09_JPRB, 0.16668170E-09_JPRB, 0.16642795E-09_JPRB, 0.16619908E-09_JPRB, 0.16600771E-09_JPRB, 0.16585079E-09_JPRB, &
  & 0.16572047E-09_JPRB, 0.16560570E-09_JPRB, 0.16549753E-09_JPRB, 0.16539051E-09_JPRB, 0.16528395E-09_JPRB, 0.16518051E-09_JPRB, &
  & 0.16508207E-09_JPRB, 0.16498460E-09_JPRB, 0.16487400E-09_JPRB, 0.16467676E-09_JPRB /)

RGHG8(:,45, 9) = (/ &
  & 0.16336310E-09_JPRB, 0.16348954E-09_JPRB, 0.16357199E-09_JPRB, 0.16366973E-09_JPRB, 0.16380633E-09_JPRB, 0.16396845E-09_JPRB, &
  & 0.16413690E-09_JPRB, 0.16429748E-09_JPRB, 0.16445120E-09_JPRB, 0.16460273E-09_JPRB, 0.16475639E-09_JPRB, 0.16491851E-09_JPRB, &
  & 0.16509227E-09_JPRB, 0.16528363E-09_JPRB, 0.16549230E-09_JPRB, 0.16572280E-09_JPRB, 0.16597614E-09_JPRB, 0.16626002E-09_JPRB, &
  & 0.16656471E-09_JPRB, 0.16687920E-09_JPRB, 0.16716183E-09_JPRB, 0.16739372E-09_JPRB, 0.16756940E-09_JPRB, 0.16770137E-09_JPRB, &
  & 0.16780215E-09_JPRB, 0.16788167E-09_JPRB, 0.16794727E-09_JPRB, 0.16800414E-09_JPRB, 0.16805579E-09_JPRB, 0.16810420E-09_JPRB, &
  & 0.16814908E-09_JPRB, 0.16818763E-09_JPRB, 0.16821469E-09_JPRB, 0.16822639E-09_JPRB, 0.16822176E-09_JPRB, 0.16820323E-09_JPRB, &
  & 0.16817338E-09_JPRB, 0.16813526E-09_JPRB, 0.16809210E-09_JPRB, 0.16804469E-09_JPRB, 0.16799212E-09_JPRB, 0.16793791E-09_JPRB, &
  & 0.16787936E-09_JPRB, 0.16781600E-09_JPRB, 0.16774360E-09_JPRB, 0.16765163E-09_JPRB, 0.16752920E-09_JPRB, 0.16736215E-09_JPRB, &
  & 0.16715117E-09_JPRB, 0.16691482E-09_JPRB, 0.16667884E-09_JPRB, 0.16646892E-09_JPRB, 0.16629584E-09_JPRB, 0.16615874E-09_JPRB, &
  & 0.16604833E-09_JPRB, 0.16595283E-09_JPRB, 0.16586375E-09_JPRB, 0.16577506E-09_JPRB, 0.16568547E-09_JPRB, 0.16559795E-09_JPRB, &
  & 0.16551449E-09_JPRB, 0.16543278E-09_JPRB, 0.16534056E-09_JPRB, 0.16517764E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART17',1,ZHOOK_HANDLE)
END SUBROUTINE PART17




SUBROUTINE PART18
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART18',0,ZHOOK_HANDLE)



RGHG8(:,46, 9) = (/ &
  & 0.16404542E-09_JPRB, 0.16423138E-09_JPRB, 0.16433606E-09_JPRB, 0.16444450E-09_JPRB, 0.16457793E-09_JPRB, 0.16473578E-09_JPRB, &
  & 0.16488948E-09_JPRB, 0.16503067E-09_JPRB, 0.16516022E-09_JPRB, 0.16528270E-09_JPRB, 0.16540450E-09_JPRB, 0.16553016E-09_JPRB, &
  & 0.16566683E-09_JPRB, 0.16581517E-09_JPRB, 0.16598077E-09_JPRB, 0.16616319E-09_JPRB, 0.16636939E-09_JPRB, 0.16659618E-09_JPRB, &
  & 0.16684576E-09_JPRB, 0.16709004E-09_JPRB, 0.16731334E-09_JPRB, 0.16749395E-09_JPRB, 0.16763582E-09_JPRB, 0.16774646E-09_JPRB, &
  & 0.16783430E-09_JPRB, 0.16790594E-09_JPRB, 0.16796656E-09_JPRB, 0.16802015E-09_JPRB, 0.16806992E-09_JPRB, 0.16811744E-09_JPRB, &
  & 0.16816251E-09_JPRB, 0.16820186E-09_JPRB, 0.16823010E-09_JPRB, 0.16824264E-09_JPRB, 0.16823878E-09_JPRB, 0.16822069E-09_JPRB, &
  & 0.16819131E-09_JPRB, 0.16815367E-09_JPRB, 0.16811165E-09_JPRB, 0.16806666E-09_JPRB, 0.16801843E-09_JPRB, 0.16797100E-09_JPRB, &
  & 0.16792247E-09_JPRB, 0.16787258E-09_JPRB, 0.16781847E-09_JPRB, 0.16775109E-09_JPRB, 0.16765936E-09_JPRB, 0.16752814E-09_JPRB, &
  & 0.16734991E-09_JPRB, 0.16713876E-09_JPRB, 0.16692416E-09_JPRB, 0.16673116E-09_JPRB, 0.16657718E-09_JPRB, 0.16645885E-09_JPRB, &
  & 0.16636598E-09_JPRB, 0.16628807E-09_JPRB, 0.16621518E-09_JPRB, 0.16614216E-09_JPRB, 0.16606738E-09_JPRB, 0.16599323E-09_JPRB, &
  & 0.16592300E-09_JPRB, 0.16585479E-09_JPRB, 0.16577920E-09_JPRB, 0.16564752E-09_JPRB /)

RGHG8(:,47, 9) = (/ &
  & 0.16484711E-09_JPRB, 0.16502064E-09_JPRB, 0.16512841E-09_JPRB, 0.16524060E-09_JPRB, 0.16537871E-09_JPRB, 0.16552788E-09_JPRB, &
  & 0.16566479E-09_JPRB, 0.16578300E-09_JPRB, 0.16588439E-09_JPRB, 0.16597643E-09_JPRB, 0.16606456E-09_JPRB, 0.16615598E-09_JPRB, &
  & 0.16625346E-09_JPRB, 0.16636330E-09_JPRB, 0.16648546E-09_JPRB, 0.16662495E-09_JPRB, 0.16677912E-09_JPRB, 0.16695166E-09_JPRB, &
  & 0.16712742E-09_JPRB, 0.16730133E-09_JPRB, 0.16745423E-09_JPRB, 0.16758547E-09_JPRB, 0.16769372E-09_JPRB, 0.16778431E-09_JPRB, &
  & 0.16786048E-09_JPRB, 0.16792515E-09_JPRB, 0.16798150E-09_JPRB, 0.16803262E-09_JPRB, 0.16808110E-09_JPRB, 0.16812843E-09_JPRB, &
  & 0.16817417E-09_JPRB, 0.16821473E-09_JPRB, 0.16824439E-09_JPRB, 0.16825806E-09_JPRB, 0.16825510E-09_JPRB, 0.16823748E-09_JPRB, &
  & 0.16820839E-09_JPRB, 0.16817106E-09_JPRB, 0.16812959E-09_JPRB, 0.16808621E-09_JPRB, 0.16804171E-09_JPRB, 0.16799956E-09_JPRB, &
  & 0.16795922E-09_JPRB, 0.16792025E-09_JPRB, 0.16788063E-09_JPRB, 0.16783318E-09_JPRB, 0.16776909E-09_JPRB, 0.16767321E-09_JPRB, &
  & 0.16753414E-09_JPRB, 0.16735810E-09_JPRB, 0.16716768E-09_JPRB, 0.16699644E-09_JPRB, 0.16685978E-09_JPRB, 0.16675786E-09_JPRB, &
  & 0.16668106E-09_JPRB, 0.16661675E-09_JPRB, 0.16655753E-09_JPRB, 0.16649711E-09_JPRB, 0.16643395E-09_JPRB, 0.16637081E-09_JPRB, &
  & 0.16631081E-09_JPRB, 0.16625350E-09_JPRB, 0.16619109E-09_JPRB, 0.16608429E-09_JPRB /)

RGHG8(:,48, 9) = (/ &
  & 0.16557644E-09_JPRB, 0.16578050E-09_JPRB, 0.16590757E-09_JPRB, 0.16603680E-09_JPRB, 0.16618434E-09_JPRB, 0.16633284E-09_JPRB, &
  & 0.16645704E-09_JPRB, 0.16655123E-09_JPRB, 0.16662433E-09_JPRB, 0.16668447E-09_JPRB, 0.16673972E-09_JPRB, 0.16679472E-09_JPRB, &
  & 0.16685554E-09_JPRB, 0.16692459E-09_JPRB, 0.16700552E-09_JPRB, 0.16709600E-09_JPRB, 0.16719756E-09_JPRB, 0.16729945E-09_JPRB, &
  & 0.16740120E-09_JPRB, 0.16749527E-09_JPRB, 0.16758447E-09_JPRB, 0.16766695E-09_JPRB, 0.16774442E-09_JPRB, 0.16781630E-09_JPRB, &
  & 0.16788169E-09_JPRB, 0.16794019E-09_JPRB, 0.16799306E-09_JPRB, 0.16804230E-09_JPRB, 0.16809007E-09_JPRB, 0.16813766E-09_JPRB, &
  & 0.16818445E-09_JPRB, 0.16822659E-09_JPRB, 0.16825791E-09_JPRB, 0.16827290E-09_JPRB, 0.16827098E-09_JPRB, 0.16825376E-09_JPRB, &
  & 0.16822492E-09_JPRB, 0.16818757E-09_JPRB, 0.16814627E-09_JPRB, 0.16810414E-09_JPRB, 0.16806237E-09_JPRB, 0.16802464E-09_JPRB, &
  & 0.16799084E-09_JPRB, 0.16796058E-09_JPRB, 0.16793221E-09_JPRB, 0.16790072E-09_JPRB, 0.16785899E-09_JPRB, 0.16779583E-09_JPRB, &
  & 0.16769869E-09_JPRB, 0.16756654E-09_JPRB, 0.16741417E-09_JPRB, 0.16726803E-09_JPRB, 0.16715079E-09_JPRB, 0.16706443E-09_JPRB, &
  & 0.16699958E-09_JPRB, 0.16694650E-09_JPRB, 0.16689700E-09_JPRB, 0.16684601E-09_JPRB, 0.16679140E-09_JPRB, 0.16673579E-09_JPRB, &
  & 0.16668310E-09_JPRB, 0.16663346E-09_JPRB, 0.16658022E-09_JPRB, 0.16649052E-09_JPRB /)

RGHG8(:,49, 9) = (/ &
  & 0.16624578E-09_JPRB, 0.16647440E-09_JPRB, 0.16661794E-09_JPRB, 0.16676162E-09_JPRB, 0.16692400E-09_JPRB, 0.16708204E-09_JPRB, &
  & 0.16720014E-09_JPRB, 0.16727937E-09_JPRB, 0.16733073E-09_JPRB, 0.16736625E-09_JPRB, 0.16739288E-09_JPRB, 0.16741723E-09_JPRB, &
  & 0.16744242E-09_JPRB, 0.16747162E-09_JPRB, 0.16750545E-09_JPRB, 0.16754355E-09_JPRB, 0.16757849E-09_JPRB, 0.16761112E-09_JPRB, &
  & 0.16763853E-09_JPRB, 0.16766610E-09_JPRB, 0.16769866E-09_JPRB, 0.16773964E-09_JPRB, 0.16778881E-09_JPRB, 0.16784349E-09_JPRB, &
  & 0.16789900E-09_JPRB, 0.16795204E-09_JPRB, 0.16800197E-09_JPRB, 0.16804989E-09_JPRB, 0.16809742E-09_JPRB, 0.16814569E-09_JPRB, &
  & 0.16819382E-09_JPRB, 0.16823791E-09_JPRB, 0.16827091E-09_JPRB, 0.16828750E-09_JPRB, 0.16828655E-09_JPRB, 0.16826977E-09_JPRB, &
  & 0.16824105E-09_JPRB, 0.16820356E-09_JPRB, 0.16816229E-09_JPRB, 0.16812085E-09_JPRB, 0.16808133E-09_JPRB, 0.16804694E-09_JPRB, &
  & 0.16801852E-09_JPRB, 0.16799506E-09_JPRB, 0.16797577E-09_JPRB, 0.16795641E-09_JPRB, 0.16793258E-09_JPRB, 0.16789606E-09_JPRB, &
  & 0.16783779E-09_JPRB, 0.16775324E-09_JPRB, 0.16764901E-09_JPRB, 0.16754161E-09_JPRB, 0.16744979E-09_JPRB, 0.16737986E-09_JPRB, &
  & 0.16732601E-09_JPRB, 0.16728180E-09_JPRB, 0.16723933E-09_JPRB, 0.16719469E-09_JPRB, 0.16714563E-09_JPRB, 0.16709450E-09_JPRB, &
  & 0.16704590E-09_JPRB, 0.16700068E-09_JPRB, 0.16695244E-09_JPRB, 0.16687288E-09_JPRB /)

RGHG8(:,50, 9) = (/ &
  & 0.16690090E-09_JPRB, 0.16709914E-09_JPRB, 0.16722390E-09_JPRB, 0.16735884E-09_JPRB, 0.16751601E-09_JPRB, 0.16766941E-09_JPRB, &
  & 0.16777998E-09_JPRB, 0.16784685E-09_JPRB, 0.16788476E-09_JPRB, 0.16790568E-09_JPRB, 0.16791731E-09_JPRB, 0.16792226E-09_JPRB, &
  & 0.16792244E-09_JPRB, 0.16791823E-09_JPRB, 0.16790982E-09_JPRB, 0.16789546E-09_JPRB, 0.16787710E-09_JPRB, 0.16785323E-09_JPRB, &
  & 0.16782851E-09_JPRB, 0.16780774E-09_JPRB, 0.16779783E-09_JPRB, 0.16780413E-09_JPRB, 0.16782831E-09_JPRB, 0.16786694E-09_JPRB, &
  & 0.16791327E-09_JPRB, 0.16796148E-09_JPRB, 0.16800898E-09_JPRB, 0.16805599E-09_JPRB, 0.16810367E-09_JPRB, 0.16815294E-09_JPRB, &
  & 0.16820273E-09_JPRB, 0.16824883E-09_JPRB, 0.16828364E-09_JPRB, 0.16830190E-09_JPRB, 0.16830196E-09_JPRB, 0.16828570E-09_JPRB, &
  & 0.16825707E-09_JPRB, 0.16821944E-09_JPRB, 0.16817794E-09_JPRB, 0.16813696E-09_JPRB, 0.16809891E-09_JPRB, 0.16806732E-09_JPRB, &
  & 0.16804297E-09_JPRB, 0.16802554E-09_JPRB, 0.16801309E-09_JPRB, 0.16800344E-09_JPRB, 0.16799312E-09_JPRB, 0.16797730E-09_JPRB, &
  & 0.16794943E-09_JPRB, 0.16790670E-09_JPRB, 0.16785007E-09_JPRB, 0.16778798E-09_JPRB, 0.16773011E-09_JPRB, 0.16768206E-09_JPRB, &
  & 0.16764379E-09_JPRB, 0.16760893E-09_JPRB, 0.16757534E-09_JPRB, 0.16753766E-09_JPRB, 0.16749399E-09_JPRB, 0.16744717E-09_JPRB, &
  & 0.16740172E-09_JPRB, 0.16735856E-09_JPRB, 0.16731339E-09_JPRB, 0.16723636E-09_JPRB /)

RGHG8(:,51, 9) = (/ &
  & 0.16740265E-09_JPRB, 0.16757321E-09_JPRB, 0.16768384E-09_JPRB, 0.16779508E-09_JPRB, 0.16793297E-09_JPRB, 0.16806520E-09_JPRB, &
  & 0.16815602E-09_JPRB, 0.16820619E-09_JPRB, 0.16823214E-09_JPRB, 0.16824503E-09_JPRB, 0.16824890E-09_JPRB, 0.16824550E-09_JPRB, &
  & 0.16823326E-09_JPRB, 0.16821011E-09_JPRB, 0.16817518E-09_JPRB, 0.16813184E-09_JPRB, 0.16808152E-09_JPRB, 0.16802815E-09_JPRB, &
  & 0.16797347E-09_JPRB, 0.16792354E-09_JPRB, 0.16788379E-09_JPRB, 0.16786242E-09_JPRB, 0.16786414E-09_JPRB, 0.16788758E-09_JPRB, &
  & 0.16792523E-09_JPRB, 0.16796908E-09_JPRB, 0.16801470E-09_JPRB, 0.16806112E-09_JPRB, 0.16810929E-09_JPRB, 0.16815981E-09_JPRB, &
  & 0.16821147E-09_JPRB, 0.16825961E-09_JPRB, 0.16829646E-09_JPRB, 0.16831643E-09_JPRB, 0.16831747E-09_JPRB, 0.16830184E-09_JPRB, &
  & 0.16827323E-09_JPRB, 0.16823540E-09_JPRB, 0.16819372E-09_JPRB, 0.16815282E-09_JPRB, 0.16811579E-09_JPRB, 0.16808611E-09_JPRB, &
  & 0.16806553E-09_JPRB, 0.16805256E-09_JPRB, 0.16804629E-09_JPRB, 0.16804430E-09_JPRB, 0.16804465E-09_JPRB, 0.16804411E-09_JPRB, &
  & 0.16803843E-09_JPRB, 0.16802483E-09_JPRB, 0.16800400E-09_JPRB, 0.16797806E-09_JPRB, 0.16795204E-09_JPRB, 0.16792866E-09_JPRB, &
  & 0.16790745E-09_JPRB, 0.16788818E-09_JPRB, 0.16786667E-09_JPRB, 0.16784138E-09_JPRB, 0.16780975E-09_JPRB, 0.16777232E-09_JPRB, &
  & 0.16773356E-09_JPRB, 0.16769590E-09_JPRB, 0.16765229E-09_JPRB, 0.16757991E-09_JPRB /)

RGHG8(:,52, 9) = (/ &
  & 0.16784978E-09_JPRB, 0.16795346E-09_JPRB, 0.16802257E-09_JPRB, 0.16810960E-09_JPRB, 0.16821453E-09_JPRB, 0.16831973E-09_JPRB, &
  & 0.16838611E-09_JPRB, 0.16842056E-09_JPRB, 0.16843688E-09_JPRB, 0.16844315E-09_JPRB, 0.16844284E-09_JPRB, 0.16843558E-09_JPRB, &
  & 0.16841822E-09_JPRB, 0.16838698E-09_JPRB, 0.16834158E-09_JPRB, 0.16828497E-09_JPRB, 0.16822184E-09_JPRB, 0.16815420E-09_JPRB, &
  & 0.16808593E-09_JPRB, 0.16801811E-09_JPRB, 0.16795922E-09_JPRB, 0.16791586E-09_JPRB, 0.16789752E-09_JPRB, 0.16790638E-09_JPRB, &
  & 0.16793568E-09_JPRB, 0.16797555E-09_JPRB, 0.16801950E-09_JPRB, 0.16806569E-09_JPRB, 0.16811461E-09_JPRB, 0.16816655E-09_JPRB, &
  & 0.16822033E-09_JPRB, 0.16827058E-09_JPRB, 0.16830966E-09_JPRB, 0.16833122E-09_JPRB, 0.16833335E-09_JPRB, 0.16831826E-09_JPRB, &
  & 0.16828973E-09_JPRB, 0.16825170E-09_JPRB, 0.16820986E-09_JPRB, 0.16816885E-09_JPRB, 0.16813234E-09_JPRB, 0.16810439E-09_JPRB, &
  & 0.16808624E-09_JPRB, 0.16807775E-09_JPRB, 0.16807648E-09_JPRB, 0.16808102E-09_JPRB, 0.16809007E-09_JPRB, 0.16810109E-09_JPRB, &
  & 0.16811048E-09_JPRB, 0.16811560E-09_JPRB, 0.16811594E-09_JPRB, 0.16811232E-09_JPRB, 0.16810632E-09_JPRB, 0.16809965E-09_JPRB, &
  & 0.16809282E-09_JPRB, 0.16808524E-09_JPRB, 0.16807641E-09_JPRB, 0.16806434E-09_JPRB, 0.16804716E-09_JPRB, 0.16802493E-09_JPRB, &
  & 0.16799943E-09_JPRB, 0.16797130E-09_JPRB, 0.16793847E-09_JPRB, 0.16787217E-09_JPRB /)

RGHG8(:,53, 9) = (/ &
  & 0.16811615E-09_JPRB, 0.16820370E-09_JPRB, 0.16826611E-09_JPRB, 0.16832752E-09_JPRB, 0.16841126E-09_JPRB, 0.16848697E-09_JPRB, &
  & 0.16853380E-09_JPRB, 0.16855545E-09_JPRB, 0.16856452E-09_JPRB, 0.16856684E-09_JPRB, 0.16856405E-09_JPRB, 0.16855485E-09_JPRB, &
  & 0.16853609E-09_JPRB, 0.16850288E-09_JPRB, 0.16845381E-09_JPRB, 0.16839297E-09_JPRB, 0.16832473E-09_JPRB, 0.16825180E-09_JPRB, &
  & 0.16817472E-09_JPRB, 0.16809867E-09_JPRB, 0.16802493E-09_JPRB, 0.16796479E-09_JPRB, 0.16792900E-09_JPRB, 0.16792416E-09_JPRB, &
  & 0.16794539E-09_JPRB, 0.16798139E-09_JPRB, 0.16802398E-09_JPRB, 0.16807007E-09_JPRB, 0.16811982E-09_JPRB, 0.16817353E-09_JPRB, &
  & 0.16822933E-09_JPRB, 0.16828200E-09_JPRB, 0.16832333E-09_JPRB, 0.16834650E-09_JPRB, 0.16834981E-09_JPRB, 0.16833535E-09_JPRB, &
  & 0.16830676E-09_JPRB, 0.16826866E-09_JPRB, 0.16822654E-09_JPRB, 0.16818538E-09_JPRB, 0.16814913E-09_JPRB, 0.16812200E-09_JPRB, &
  & 0.16810660E-09_JPRB, 0.16810130E-09_JPRB, 0.16810464E-09_JPRB, 0.16811519E-09_JPRB, 0.16813156E-09_JPRB, 0.16815155E-09_JPRB, &
  & 0.16817117E-09_JPRB, 0.16818767E-09_JPRB, 0.16819959E-09_JPRB, 0.16820755E-09_JPRB, 0.16821169E-09_JPRB, 0.16821361E-09_JPRB, &
  & 0.16821397E-09_JPRB, 0.16821319E-09_JPRB, 0.16821111E-09_JPRB, 0.16820711E-09_JPRB, 0.16820018E-09_JPRB, 0.16818950E-09_JPRB, &
  & 0.16817601E-09_JPRB, 0.16816079E-09_JPRB, 0.16813984E-09_JPRB, 0.16809541E-09_JPRB /)

RGHG8(:,54, 9) = (/ &
  & 0.16834870E-09_JPRB, 0.16840912E-09_JPRB, 0.16844624E-09_JPRB, 0.16849511E-09_JPRB, 0.16855087E-09_JPRB, 0.16860645E-09_JPRB, &
  & 0.16863624E-09_JPRB, 0.16864926E-09_JPRB, 0.16865359E-09_JPRB, 0.16865322E-09_JPRB, 0.16864884E-09_JPRB, 0.16863938E-09_JPRB, &
  & 0.16862065E-09_JPRB, 0.16858800E-09_JPRB, 0.16853928E-09_JPRB, 0.16847809E-09_JPRB, 0.16840809E-09_JPRB, 0.16833185E-09_JPRB, &
  & 0.16825159E-09_JPRB, 0.16816627E-09_JPRB, 0.16808349E-09_JPRB, 0.16800934E-09_JPRB, 0.16795833E-09_JPRB, 0.16794142E-09_JPRB, &
  & 0.16795515E-09_JPRB, 0.16798735E-09_JPRB, 0.16802849E-09_JPRB, 0.16807467E-09_JPRB, 0.16812529E-09_JPRB, 0.16818094E-09_JPRB, &
  & 0.16823892E-09_JPRB, 0.16829418E-09_JPRB, 0.16833773E-09_JPRB, 0.16836256E-09_JPRB, 0.16836710E-09_JPRB, 0.16835325E-09_JPRB, &
  & 0.16832474E-09_JPRB, 0.16828640E-09_JPRB, 0.16824403E-09_JPRB, 0.16820263E-09_JPRB, 0.16816648E-09_JPRB, 0.16814042E-09_JPRB, &
  & 0.16812643E-09_JPRB, 0.16812425E-09_JPRB, 0.16813181E-09_JPRB, 0.16814744E-09_JPRB, 0.16817045E-09_JPRB, 0.16819746E-09_JPRB, &
  & 0.16822452E-09_JPRB, 0.16824775E-09_JPRB, 0.16826646E-09_JPRB, 0.16827949E-09_JPRB, 0.16828880E-09_JPRB, 0.16829423E-09_JPRB, &
  & 0.16829776E-09_JPRB, 0.16829985E-09_JPRB, 0.16830085E-09_JPRB, 0.16830064E-09_JPRB, 0.16829871E-09_JPRB, 0.16829471E-09_JPRB, &
  & 0.16828913E-09_JPRB, 0.16828287E-09_JPRB, 0.16827661E-09_JPRB, 0.16826822E-09_JPRB /)

RGHG8(:,55, 9) = (/ &
  & 0.16850690E-09_JPRB, 0.16855307E-09_JPRB, 0.16858678E-09_JPRB, 0.16861799E-09_JPRB, 0.16865995E-09_JPRB, 0.16869453E-09_JPRB, &
  & 0.16871401E-09_JPRB, 0.16872088E-09_JPRB, 0.16872226E-09_JPRB, 0.16872037E-09_JPRB, 0.16871551E-09_JPRB, 0.16870591E-09_JPRB, &
  & 0.16868856E-09_JPRB, 0.16865791E-09_JPRB, 0.16861160E-09_JPRB, 0.16855134E-09_JPRB, 0.16848163E-09_JPRB, 0.16840361E-09_JPRB, &
  & 0.16831767E-09_JPRB, 0.16822772E-09_JPRB, 0.16813417E-09_JPRB, 0.16804849E-09_JPRB, 0.16798599E-09_JPRB, 0.16795861E-09_JPRB, &
  & 0.16796560E-09_JPRB, 0.16799415E-09_JPRB, 0.16803378E-09_JPRB, 0.16807999E-09_JPRB, 0.16813165E-09_JPRB, 0.16818924E-09_JPRB, &
  & 0.16824951E-09_JPRB, 0.16830758E-09_JPRB, 0.16835326E-09_JPRB, 0.16837978E-09_JPRB, 0.16838565E-09_JPRB, 0.16837243E-09_JPRB, &
  & 0.16834389E-09_JPRB, 0.16830538E-09_JPRB, 0.16826276E-09_JPRB, 0.16822091E-09_JPRB, 0.16818504E-09_JPRB, 0.16815953E-09_JPRB, &
  & 0.16814729E-09_JPRB, 0.16814750E-09_JPRB, 0.16815827E-09_JPRB, 0.16817875E-09_JPRB, 0.16820710E-09_JPRB, 0.16824031E-09_JPRB, &
  & 0.16827259E-09_JPRB, 0.16830098E-09_JPRB, 0.16832298E-09_JPRB, 0.16833974E-09_JPRB, 0.16835008E-09_JPRB, 0.16835744E-09_JPRB, &
  & 0.16836191E-09_JPRB, 0.16836506E-09_JPRB, 0.16836718E-09_JPRB, 0.16836840E-09_JPRB, 0.16836843E-09_JPRB, 0.16836696E-09_JPRB, &
  & 0.16836402E-09_JPRB, 0.16836008E-09_JPRB, 0.16835461E-09_JPRB, 0.16834410E-09_JPRB /)

RGHG8(:,56, 9) = (/ &
  & 0.16864221E-09_JPRB, 0.16867505E-09_JPRB, 0.16869478E-09_JPRB, 0.16871869E-09_JPRB, 0.16874381E-09_JPRB, 0.16876661E-09_JPRB, &
  & 0.16877719E-09_JPRB, 0.16878046E-09_JPRB, 0.16878010E-09_JPRB, 0.16877746E-09_JPRB, 0.16877241E-09_JPRB, 0.16876368E-09_JPRB, &
  & 0.16874767E-09_JPRB, 0.16872015E-09_JPRB, 0.16867696E-09_JPRB, 0.16861959E-09_JPRB, 0.16854973E-09_JPRB, 0.16846961E-09_JPRB, &
  & 0.16838017E-09_JPRB, 0.16828094E-09_JPRB, 0.16817946E-09_JPRB, 0.16808401E-09_JPRB, 0.16801105E-09_JPRB, 0.16797644E-09_JPRB, &
  & 0.16797762E-09_JPRB, 0.16800253E-09_JPRB, 0.16804057E-09_JPRB, 0.16808673E-09_JPRB, 0.16813943E-09_JPRB, 0.16819901E-09_JPRB, &
  & 0.16826185E-09_JPRB, 0.16832255E-09_JPRB, 0.16837036E-09_JPRB, 0.16839867E-09_JPRB, 0.16840582E-09_JPRB, 0.16839316E-09_JPRB, &
  & 0.16836472E-09_JPRB, 0.16832603E-09_JPRB, 0.16828290E-09_JPRB, 0.16824098E-09_JPRB, 0.16820506E-09_JPRB, 0.16818055E-09_JPRB, &
  & 0.16816953E-09_JPRB, 0.16817170E-09_JPRB, 0.16818549E-09_JPRB, 0.16820950E-09_JPRB, 0.16824266E-09_JPRB, 0.16828036E-09_JPRB, &
  & 0.16831776E-09_JPRB, 0.16834965E-09_JPRB, 0.16837516E-09_JPRB, 0.16839233E-09_JPRB, 0.16840469E-09_JPRB, 0.16841173E-09_JPRB, &
  & 0.16841670E-09_JPRB, 0.16841997E-09_JPRB, 0.16842228E-09_JPRB, 0.16842386E-09_JPRB, 0.16842452E-09_JPRB, 0.16842402E-09_JPRB, &
  & 0.16842237E-09_JPRB, 0.16841986E-09_JPRB, 0.16841650E-09_JPRB, 0.16840972E-09_JPRB /)

RGHG8(:,57, 9) = (/ &
  & 0.16873947E-09_JPRB, 0.16876528E-09_JPRB, 0.16878232E-09_JPRB, 0.16879739E-09_JPRB, 0.16881409E-09_JPRB, 0.16882679E-09_JPRB, &
  & 0.16883267E-09_JPRB, 0.16883359E-09_JPRB, 0.16883227E-09_JPRB, 0.16882942E-09_JPRB, 0.16882473E-09_JPRB, 0.16881668E-09_JPRB, &
  & 0.16880282E-09_JPRB, 0.16877812E-09_JPRB, 0.16873904E-09_JPRB, 0.16868403E-09_JPRB, 0.16861527E-09_JPRB, 0.16853263E-09_JPRB, &
  & 0.16843668E-09_JPRB, 0.16833124E-09_JPRB, 0.16821974E-09_JPRB, 0.16811531E-09_JPRB, 0.16803640E-09_JPRB, 0.16799534E-09_JPRB, &
  & 0.16799176E-09_JPRB, 0.16801335E-09_JPRB, 0.16804967E-09_JPRB, 0.16809568E-09_JPRB, 0.16814963E-09_JPRB, 0.16821100E-09_JPRB, &
  & 0.16827656E-09_JPRB, 0.16833966E-09_JPRB, 0.16838968E-09_JPRB, 0.16841996E-09_JPRB, 0.16842827E-09_JPRB, 0.16841621E-09_JPRB, &
  & 0.16838780E-09_JPRB, 0.16834890E-09_JPRB, 0.16830555E-09_JPRB, 0.16826300E-09_JPRB, 0.16822750E-09_JPRB, 0.16820371E-09_JPRB, &
  & 0.16819407E-09_JPRB, 0.16819801E-09_JPRB, 0.16821403E-09_JPRB, 0.16824098E-09_JPRB, 0.16827725E-09_JPRB, 0.16831921E-09_JPRB, &
  & 0.16836045E-09_JPRB, 0.16839632E-09_JPRB, 0.16842364E-09_JPRB, 0.16844331E-09_JPRB, 0.16845469E-09_JPRB, 0.16846241E-09_JPRB, &
  & 0.16846693E-09_JPRB, 0.16847002E-09_JPRB, 0.16847217E-09_JPRB, 0.16847350E-09_JPRB, 0.16847404E-09_JPRB, 0.16847357E-09_JPRB, &
  & 0.16847207E-09_JPRB, 0.16846985E-09_JPRB, 0.16846649E-09_JPRB, 0.16845945E-09_JPRB /)

RGHG8(:,58, 9) = (/ &
  & 0.16882261E-09_JPRB, 0.16884280E-09_JPRB, 0.16885385E-09_JPRB, 0.16886431E-09_JPRB, 0.16887397E-09_JPRB, 0.16888116E-09_JPRB, &
  & 0.16888377E-09_JPRB, 0.16888349E-09_JPRB, 0.16888187E-09_JPRB, 0.16887912E-09_JPRB, 0.16887486E-09_JPRB, 0.16886798E-09_JPRB, &
  & 0.16885560E-09_JPRB, 0.16883414E-09_JPRB, 0.16879839E-09_JPRB, 0.16874652E-09_JPRB, 0.16867750E-09_JPRB, 0.16859231E-09_JPRB, &
  & 0.16849112E-09_JPRB, 0.16837627E-09_JPRB, 0.16825721E-09_JPRB, 0.16814683E-09_JPRB, 0.16806190E-09_JPRB, 0.16801681E-09_JPRB, &
  & 0.16800891E-09_JPRB, 0.16802736E-09_JPRB, 0.16806206E-09_JPRB, 0.16810796E-09_JPRB, 0.16816300E-09_JPRB, 0.16822638E-09_JPRB, &
  & 0.16829441E-09_JPRB, 0.16835980E-09_JPRB, 0.16841220E-09_JPRB, 0.16844424E-09_JPRB, 0.16845363E-09_JPRB, 0.16844205E-09_JPRB, &
  & 0.16841378E-09_JPRB, 0.16837474E-09_JPRB, 0.16833088E-09_JPRB, 0.16828827E-09_JPRB, 0.16825277E-09_JPRB, 0.16822985E-09_JPRB, &
  & 0.16822142E-09_JPRB, 0.16822699E-09_JPRB, 0.16824492E-09_JPRB, 0.16827399E-09_JPRB, 0.16831263E-09_JPRB, 0.16835724E-09_JPRB, &
  & 0.16840192E-09_JPRB, 0.16844143E-09_JPRB, 0.16847182E-09_JPRB, 0.16849146E-09_JPRB, 0.16850418E-09_JPRB, 0.16851104E-09_JPRB, &
  & 0.16851540E-09_JPRB, 0.16851809E-09_JPRB, 0.16851971E-09_JPRB, 0.16852064E-09_JPRB, 0.16852070E-09_JPRB, 0.16851985E-09_JPRB, &
  & 0.16851823E-09_JPRB, 0.16851598E-09_JPRB, 0.16851304E-09_JPRB, 0.16850692E-09_JPRB /)

RGHG8(:,59, 9) = (/ &
  & 0.16888985E-09_JPRB, 0.16890636E-09_JPRB, 0.16891524E-09_JPRB, 0.16892207E-09_JPRB, 0.16892797E-09_JPRB, 0.16893183E-09_JPRB, &
  & 0.16893283E-09_JPRB, 0.16893204E-09_JPRB, 0.16893044E-09_JPRB, 0.16892798E-09_JPRB, 0.16892437E-09_JPRB, 0.16891827E-09_JPRB, &
  & 0.16890779E-09_JPRB, 0.16888846E-09_JPRB, 0.16885608E-09_JPRB, 0.16880608E-09_JPRB, 0.16873759E-09_JPRB, 0.16864851E-09_JPRB, &
  & 0.16854132E-09_JPRB, 0.16842006E-09_JPRB, 0.16829446E-09_JPRB, 0.16817878E-09_JPRB, 0.16809089E-09_JPRB, 0.16804158E-09_JPRB, &
  & 0.16802987E-09_JPRB, 0.16804545E-09_JPRB, 0.16807879E-09_JPRB, 0.16812463E-09_JPRB, 0.16818080E-09_JPRB, 0.16824606E-09_JPRB, &
  & 0.16831647E-09_JPRB, 0.16838428E-09_JPRB, 0.16843875E-09_JPRB, 0.16847244E-09_JPRB, 0.16848260E-09_JPRB, 0.16847143E-09_JPRB, &
  & 0.16844331E-09_JPRB, 0.16840412E-09_JPRB, 0.16836010E-09_JPRB, 0.16831707E-09_JPRB, 0.16828185E-09_JPRB, 0.16825955E-09_JPRB, &
  & 0.16825219E-09_JPRB, 0.16825923E-09_JPRB, 0.16827884E-09_JPRB, 0.16830957E-09_JPRB, 0.16834989E-09_JPRB, 0.16839605E-09_JPRB, &
  & 0.16844366E-09_JPRB, 0.16848556E-09_JPRB, 0.16851856E-09_JPRB, 0.16854057E-09_JPRB, 0.16855276E-09_JPRB, 0.16855981E-09_JPRB, &
  & 0.16856369E-09_JPRB, 0.16856580E-09_JPRB, 0.16856688E-09_JPRB, 0.16856705E-09_JPRB, 0.16856631E-09_JPRB, 0.16856475E-09_JPRB, &
  & 0.16856248E-09_JPRB, 0.16855986E-09_JPRB, 0.16855634E-09_JPRB, 0.16854967E-09_JPRB /)

RGHG8(:,60, 9) = (/ &
  & 0.16895078E-09_JPRB, 0.16896404E-09_JPRB, 0.16897034E-09_JPRB, 0.16897503E-09_JPRB, 0.16897865E-09_JPRB, 0.16898077E-09_JPRB, &
  & 0.16898108E-09_JPRB, 0.16898022E-09_JPRB, 0.16897884E-09_JPRB, 0.16897680E-09_JPRB, 0.16897371E-09_JPRB, 0.16896867E-09_JPRB, &
  & 0.16895929E-09_JPRB, 0.16894228E-09_JPRB, 0.16891176E-09_JPRB, 0.16886362E-09_JPRB, 0.16879355E-09_JPRB, 0.16870233E-09_JPRB, &
  & 0.16858941E-09_JPRB, 0.16846319E-09_JPRB, 0.16833301E-09_JPRB, 0.16821482E-09_JPRB, 0.16812343E-09_JPRB, 0.16807075E-09_JPRB, &
  & 0.16805550E-09_JPRB, 0.16806856E-09_JPRB, 0.16810066E-09_JPRB, 0.16814661E-09_JPRB, 0.16820405E-09_JPRB, 0.16827109E-09_JPRB, &
  & 0.16834389E-09_JPRB, 0.16841387E-09_JPRB, 0.16847042E-09_JPRB, 0.16850524E-09_JPRB, 0.16851592E-09_JPRB, 0.16850493E-09_JPRB, &
  & 0.16847697E-09_JPRB, 0.16843776E-09_JPRB, 0.16839347E-09_JPRB, 0.16835044E-09_JPRB, 0.16831525E-09_JPRB, 0.16829352E-09_JPRB, &
  & 0.16828712E-09_JPRB, 0.16829529E-09_JPRB, 0.16831633E-09_JPRB, 0.16834850E-09_JPRB, 0.16838991E-09_JPRB, 0.16843738E-09_JPRB, &
  & 0.16848561E-09_JPRB, 0.16853054E-09_JPRB, 0.16856573E-09_JPRB, 0.16858918E-09_JPRB, 0.16860267E-09_JPRB, 0.16860956E-09_JPRB, &
  & 0.16861298E-09_JPRB, 0.16861457E-09_JPRB, 0.16861482E-09_JPRB, 0.16861401E-09_JPRB, 0.16861218E-09_JPRB, 0.16860949E-09_JPRB, &
  & 0.16860646E-09_JPRB, 0.16860316E-09_JPRB, 0.16859936E-09_JPRB, 0.16859206E-09_JPRB /)

RGHG8(:,61, 9) = (/ &
  & 0.16900492E-09_JPRB, 0.16901630E-09_JPRB, 0.16902157E-09_JPRB, 0.16902514E-09_JPRB, 0.16902771E-09_JPRB, 0.16902914E-09_JPRB, &
  & 0.16902929E-09_JPRB, 0.16902862E-09_JPRB, 0.16902758E-09_JPRB, 0.16902600E-09_JPRB, 0.16902355E-09_JPRB, 0.16901923E-09_JPRB, &
  & 0.16901117E-09_JPRB, 0.16899518E-09_JPRB, 0.16896644E-09_JPRB, 0.16891814E-09_JPRB, 0.16884802E-09_JPRB, 0.16875248E-09_JPRB, &
  & 0.16863767E-09_JPRB, 0.16850757E-09_JPRB, 0.16837555E-09_JPRB, 0.16825480E-09_JPRB, 0.16816125E-09_JPRB, 0.16810527E-09_JPRB, &
  & 0.16808679E-09_JPRB, 0.16809761E-09_JPRB, 0.16812883E-09_JPRB, 0.16817514E-09_JPRB, 0.16823397E-09_JPRB, 0.16830284E-09_JPRB, &
  & 0.16837796E-09_JPRB, 0.16845003E-09_JPRB, 0.16850800E-09_JPRB, 0.16854361E-09_JPRB, 0.16855430E-09_JPRB, 0.16854323E-09_JPRB, &
  & 0.16851534E-09_JPRB, 0.16847618E-09_JPRB, 0.16843194E-09_JPRB, 0.16838886E-09_JPRB, 0.16835389E-09_JPRB, 0.16833258E-09_JPRB, &
  & 0.16832687E-09_JPRB, 0.16833600E-09_JPRB, 0.16835816E-09_JPRB, 0.16839141E-09_JPRB, 0.16843377E-09_JPRB, 0.16848153E-09_JPRB, &
  & 0.16853098E-09_JPRB, 0.16857614E-09_JPRB, 0.16861376E-09_JPRB, 0.16863945E-09_JPRB, 0.16865404E-09_JPRB, 0.16866114E-09_JPRB, &
  & 0.16866433E-09_JPRB, 0.16866508E-09_JPRB, 0.16866422E-09_JPRB, 0.16866211E-09_JPRB, 0.16865870E-09_JPRB, 0.16865473E-09_JPRB, &
  & 0.16865054E-09_JPRB, 0.16864646E-09_JPRB, 0.16864155E-09_JPRB, 0.16863308E-09_JPRB /)

RGHG8(:,62, 9) = (/ &
  & 0.16905671E-09_JPRB, 0.16906665E-09_JPRB, 0.16907103E-09_JPRB, 0.16907398E-09_JPRB, 0.16907609E-09_JPRB, 0.16907731E-09_JPRB, &
  & 0.16907760E-09_JPRB, 0.16907732E-09_JPRB, 0.16907681E-09_JPRB, 0.16907578E-09_JPRB, 0.16907395E-09_JPRB, 0.16907042E-09_JPRB, &
  & 0.16906315E-09_JPRB, 0.16904836E-09_JPRB, 0.16901956E-09_JPRB, 0.16897185E-09_JPRB, 0.16889921E-09_JPRB, 0.16880394E-09_JPRB, &
  & 0.16868623E-09_JPRB, 0.16855581E-09_JPRB, 0.16842217E-09_JPRB, 0.16830046E-09_JPRB, 0.16820485E-09_JPRB, 0.16814630E-09_JPRB, &
  & 0.16812503E-09_JPRB, 0.16813399E-09_JPRB, 0.16816461E-09_JPRB, 0.16821150E-09_JPRB, 0.16827188E-09_JPRB, 0.16834273E-09_JPRB, &
  & 0.16842001E-09_JPRB, 0.16849384E-09_JPRB, 0.16855278E-09_JPRB, 0.16858828E-09_JPRB, 0.16859862E-09_JPRB, 0.16858728E-09_JPRB, &
  & 0.16855940E-09_JPRB, 0.16852032E-09_JPRB, 0.16847632E-09_JPRB, 0.16843328E-09_JPRB, 0.16839849E-09_JPRB, 0.16837748E-09_JPRB, &
  & 0.16837226E-09_JPRB, 0.16838204E-09_JPRB, 0.16840504E-09_JPRB, 0.16843905E-09_JPRB, 0.16848190E-09_JPRB, 0.16853001E-09_JPRB, &
  & 0.16857921E-09_JPRB, 0.16862522E-09_JPRB, 0.16866360E-09_JPRB, 0.16869128E-09_JPRB, 0.16870766E-09_JPRB, 0.16871575E-09_JPRB, &
  & 0.16871861E-09_JPRB, 0.16871847E-09_JPRB, 0.16871624E-09_JPRB, 0.16871214E-09_JPRB, 0.16870681E-09_JPRB, 0.16870097E-09_JPRB, &
  & 0.16869552E-09_JPRB, 0.16869006E-09_JPRB, 0.16868414E-09_JPRB, 0.16867319E-09_JPRB /)

RGHG8(:,63, 9) = (/ &
  & 0.16910531E-09_JPRB, 0.16911504E-09_JPRB, 0.16911939E-09_JPRB, 0.16912227E-09_JPRB, 0.16912434E-09_JPRB, 0.16912569E-09_JPRB, &
  & 0.16912631E-09_JPRB, 0.16912646E-09_JPRB, 0.16912649E-09_JPRB, 0.16912610E-09_JPRB, 0.16912498E-09_JPRB, 0.16912230E-09_JPRB, &
  & 0.16911590E-09_JPRB, 0.16910133E-09_JPRB, 0.16907303E-09_JPRB, 0.16902382E-09_JPRB, 0.16895199E-09_JPRB, 0.16885528E-09_JPRB, &
  & 0.16873869E-09_JPRB, 0.16860784E-09_JPRB, 0.16847437E-09_JPRB, 0.16835210E-09_JPRB, 0.16825580E-09_JPRB, 0.16819521E-09_JPRB, &
  & 0.16817177E-09_JPRB, 0.16817926E-09_JPRB, 0.16820952E-09_JPRB, 0.16825721E-09_JPRB, 0.16831929E-09_JPRB, 0.16839206E-09_JPRB, &
  & 0.16847133E-09_JPRB, 0.16854629E-09_JPRB, 0.16860541E-09_JPRB, 0.16864035E-09_JPRB, 0.16864973E-09_JPRB, 0.16863792E-09_JPRB, &
  & 0.16860995E-09_JPRB, 0.16857123E-09_JPRB, 0.16852741E-09_JPRB, 0.16848474E-09_JPRB, 0.16845011E-09_JPRB, 0.16842930E-09_JPRB, &
  & 0.16842433E-09_JPRB, 0.16843446E-09_JPRB, 0.16845790E-09_JPRB, 0.16849222E-09_JPRB, 0.16853513E-09_JPRB, 0.16858311E-09_JPRB, &
  & 0.16863219E-09_JPRB, 0.16867795E-09_JPRB, 0.16871678E-09_JPRB, 0.16874606E-09_JPRB, 0.16876438E-09_JPRB, 0.16877344E-09_JPRB, &
  & 0.16877658E-09_JPRB, 0.16877549E-09_JPRB, 0.16877130E-09_JPRB, 0.16876504E-09_JPRB, 0.16875701E-09_JPRB, 0.16874913E-09_JPRB, &
  & 0.16874155E-09_JPRB, 0.16873458E-09_JPRB, 0.16872630E-09_JPRB, 0.16871235E-09_JPRB /)

RGHG8(:,64, 9) = (/ &
  & 0.16915253E-09_JPRB, 0.16916257E-09_JPRB, 0.16916704E-09_JPRB, 0.16917007E-09_JPRB, 0.16917234E-09_JPRB, 0.16917395E-09_JPRB, &
  & 0.16917495E-09_JPRB, 0.16917559E-09_JPRB, 0.16917628E-09_JPRB, 0.16917659E-09_JPRB, 0.16917631E-09_JPRB, 0.16917451E-09_JPRB, &
  & 0.16916885E-09_JPRB, 0.16915461E-09_JPRB, 0.16912541E-09_JPRB, 0.16907707E-09_JPRB, 0.16900488E-09_JPRB, 0.16891000E-09_JPRB, &
  & 0.16879428E-09_JPRB, 0.16866468E-09_JPRB, 0.16853217E-09_JPRB, 0.16841083E-09_JPRB, 0.16831446E-09_JPRB, 0.16825309E-09_JPRB, &
  & 0.16822811E-09_JPRB, 0.16823455E-09_JPRB, 0.16826468E-09_JPRB, 0.16831329E-09_JPRB, 0.16837676E-09_JPRB, 0.16845134E-09_JPRB, &
  & 0.16853183E-09_JPRB, 0.16860718E-09_JPRB, 0.16866560E-09_JPRB, 0.16869915E-09_JPRB, 0.16870737E-09_JPRB, 0.16869503E-09_JPRB, &
  & 0.16866716E-09_JPRB, 0.16862889E-09_JPRB, 0.16858574E-09_JPRB, 0.16854346E-09_JPRB, 0.16850919E-09_JPRB, 0.16848846E-09_JPRB, &
  & 0.16848353E-09_JPRB, 0.16849368E-09_JPRB, 0.16851713E-09_JPRB, 0.16855119E-09_JPRB, 0.16859371E-09_JPRB, 0.16864110E-09_JPRB, &
  & 0.16868963E-09_JPRB, 0.16873511E-09_JPRB, 0.16877408E-09_JPRB, 0.16880389E-09_JPRB, 0.16882387E-09_JPRB, 0.16883446E-09_JPRB, &
  & 0.16883796E-09_JPRB, 0.16883596E-09_JPRB, 0.16883005E-09_JPRB, 0.16882117E-09_JPRB, 0.16881066E-09_JPRB, 0.16879997E-09_JPRB, &
  & 0.16879023E-09_JPRB, 0.16878038E-09_JPRB, 0.16876937E-09_JPRB, 0.16874889E-09_JPRB /)

RGHG8(:,65, 9) = (/ &
  & 0.16919841E-09_JPRB, 0.16920930E-09_JPRB, 0.16921428E-09_JPRB, 0.16921771E-09_JPRB, 0.16922030E-09_JPRB, 0.16922225E-09_JPRB, &
  & 0.16922359E-09_JPRB, 0.16922472E-09_JPRB, 0.16922613E-09_JPRB, 0.16922722E-09_JPRB, 0.16922785E-09_JPRB, 0.16922698E-09_JPRB, &
  & 0.16922186E-09_JPRB, 0.16920744E-09_JPRB, 0.16917870E-09_JPRB, 0.16913065E-09_JPRB, 0.16906040E-09_JPRB, 0.16896727E-09_JPRB, &
  & 0.16885381E-09_JPRB, 0.16872652E-09_JPRB, 0.16859623E-09_JPRB, 0.16847682E-09_JPRB, 0.16838206E-09_JPRB, 0.16832058E-09_JPRB, &
  & 0.16829499E-09_JPRB, 0.16830065E-09_JPRB, 0.16833068E-09_JPRB, 0.16837987E-09_JPRB, 0.16844433E-09_JPRB, 0.16851970E-09_JPRB, &
  & 0.16860043E-09_JPRB, 0.16867506E-09_JPRB, 0.16873170E-09_JPRB, 0.16876345E-09_JPRB, 0.16877034E-09_JPRB, 0.16875759E-09_JPRB, &
  & 0.16873017E-09_JPRB, 0.16869289E-09_JPRB, 0.16865075E-09_JPRB, 0.16860954E-09_JPRB, 0.16857575E-09_JPRB, 0.16855518E-09_JPRB, &
  & 0.16855015E-09_JPRB, 0.16856000E-09_JPRB, 0.16858297E-09_JPRB, 0.16861644E-09_JPRB, 0.16865795E-09_JPRB, 0.16870431E-09_JPRB, &
  & 0.16875193E-09_JPRB, 0.16879675E-09_JPRB, 0.16883543E-09_JPRB, 0.16886575E-09_JPRB, 0.16888656E-09_JPRB, 0.16889831E-09_JPRB, &
  & 0.16890242E-09_JPRB, 0.16889981E-09_JPRB, 0.16889207E-09_JPRB, 0.16888141E-09_JPRB, 0.16886825E-09_JPRB, 0.16885526E-09_JPRB, &
  & 0.16884202E-09_JPRB, 0.16882903E-09_JPRB, 0.16881266E-09_JPRB, 0.16878397E-09_JPRB /)

RGHG8(:,66, 9) = (/ &
  & 0.16924205E-09_JPRB, 0.16925512E-09_JPRB, 0.16926111E-09_JPRB, 0.16926527E-09_JPRB, 0.16926842E-09_JPRB, 0.16927072E-09_JPRB, &
  & 0.16927248E-09_JPRB, 0.16927397E-09_JPRB, 0.16927620E-09_JPRB, 0.16927806E-09_JPRB, 0.16927969E-09_JPRB, 0.16927966E-09_JPRB, &
  & 0.16927482E-09_JPRB, 0.16926047E-09_JPRB, 0.16923239E-09_JPRB, 0.16918593E-09_JPRB, 0.16911780E-09_JPRB, 0.16902749E-09_JPRB, &
  & 0.16891742E-09_JPRB, 0.16879353E-09_JPRB, 0.16866690E-09_JPRB, 0.16855109E-09_JPRB, 0.16845852E-09_JPRB, 0.16839841E-09_JPRB, &
  & 0.16837251E-09_JPRB, 0.16837773E-09_JPRB, 0.16840726E-09_JPRB, 0.16845644E-09_JPRB, 0.16852073E-09_JPRB, 0.16859572E-09_JPRB, &
  & 0.16867530E-09_JPRB, 0.16874789E-09_JPRB, 0.16880211E-09_JPRB, 0.16883162E-09_JPRB, 0.16883725E-09_JPRB, 0.16882439E-09_JPRB, &
  & 0.16879786E-09_JPRB, 0.16876214E-09_JPRB, 0.16872184E-09_JPRB, 0.16868217E-09_JPRB, 0.16864950E-09_JPRB, 0.16862933E-09_JPRB, &
  & 0.16862418E-09_JPRB, 0.16863347E-09_JPRB, 0.16865562E-09_JPRB, 0.16868794E-09_JPRB, 0.16872795E-09_JPRB, 0.16877280E-09_JPRB, &
  & 0.16881907E-09_JPRB, 0.16886291E-09_JPRB, 0.16890114E-09_JPRB, 0.16893140E-09_JPRB, 0.16895284E-09_JPRB, 0.16896519E-09_JPRB, &
  & 0.16896969E-09_JPRB, 0.16896659E-09_JPRB, 0.16895768E-09_JPRB, 0.16894555E-09_JPRB, 0.16893077E-09_JPRB, 0.16891510E-09_JPRB, &
  & 0.16889901E-09_JPRB, 0.16888117E-09_JPRB, 0.16885886E-09_JPRB, 0.16881668E-09_JPRB /)

RGHG8(:,67, 9) = (/ &
  & 0.16928402E-09_JPRB, 0.16930031E-09_JPRB, 0.16930790E-09_JPRB, 0.16931311E-09_JPRB, 0.16931703E-09_JPRB, 0.16931989E-09_JPRB, &
  & 0.16932196E-09_JPRB, 0.16932390E-09_JPRB, 0.16932675E-09_JPRB, 0.16932961E-09_JPRB, 0.16933203E-09_JPRB, 0.16933249E-09_JPRB, &
  & 0.16932776E-09_JPRB, 0.16931384E-09_JPRB, 0.16928693E-09_JPRB, 0.16924245E-09_JPRB, 0.16917719E-09_JPRB, 0.16909059E-09_JPRB, &
  & 0.16898487E-09_JPRB, 0.16886612E-09_JPRB, 0.16874452E-09_JPRB, 0.16863318E-09_JPRB, 0.16854450E-09_JPRB, 0.16848598E-09_JPRB, &
  & 0.16846045E-09_JPRB, 0.16846488E-09_JPRB, 0.16849355E-09_JPRB, 0.16854160E-09_JPRB, 0.16860460E-09_JPRB, 0.16867784E-09_JPRB, &
  & 0.16875484E-09_JPRB, 0.16882447E-09_JPRB, 0.16887550E-09_JPRB, 0.16890260E-09_JPRB, 0.16890708E-09_JPRB, 0.16889443E-09_JPRB, &
  & 0.16886928E-09_JPRB, 0.16883571E-09_JPRB, 0.16879781E-09_JPRB, 0.16876051E-09_JPRB, 0.16872947E-09_JPRB, 0.16871021E-09_JPRB, &
  & 0.16870520E-09_JPRB, 0.16871389E-09_JPRB, 0.16873487E-09_JPRB, 0.16876565E-09_JPRB, 0.16880385E-09_JPRB, 0.16884663E-09_JPRB, &
  & 0.16889119E-09_JPRB, 0.16893369E-09_JPRB, 0.16897114E-09_JPRB, 0.16900110E-09_JPRB, 0.16902260E-09_JPRB, 0.16903524E-09_JPRB, &
  & 0.16903989E-09_JPRB, 0.16903645E-09_JPRB, 0.16902671E-09_JPRB, 0.16901380E-09_JPRB, 0.16899759E-09_JPRB, 0.16898051E-09_JPRB, &
  & 0.16896098E-09_JPRB, 0.16893910E-09_JPRB, 0.16890837E-09_JPRB, 0.16885038E-09_JPRB /)

RGHG8(:,68, 9) = (/ &
  & 0.16932428E-09_JPRB, 0.16934543E-09_JPRB, 0.16935514E-09_JPRB, 0.16936177E-09_JPRB, 0.16936666E-09_JPRB, 0.16937013E-09_JPRB, &
  & 0.16937267E-09_JPRB, 0.16937476E-09_JPRB, 0.16937857E-09_JPRB, 0.16938184E-09_JPRB, 0.16938488E-09_JPRB, 0.16938558E-09_JPRB, &
  & 0.16938091E-09_JPRB, 0.16936756E-09_JPRB, 0.16934219E-09_JPRB, 0.16930014E-09_JPRB, 0.16923830E-09_JPRB, 0.16915622E-09_JPRB, &
  & 0.16905626E-09_JPRB, 0.16894372E-09_JPRB, 0.16882852E-09_JPRB, 0.16872322E-09_JPRB, 0.16863856E-09_JPRB, 0.16858256E-09_JPRB, &
  & 0.16855735E-09_JPRB, 0.16856100E-09_JPRB, 0.16858803E-09_JPRB, 0.16863419E-09_JPRB, 0.16869467E-09_JPRB, 0.16876481E-09_JPRB, &
  & 0.16883832E-09_JPRB, 0.16890397E-09_JPRB, 0.16895156E-09_JPRB, 0.16897611E-09_JPRB, 0.16897957E-09_JPRB, 0.16896737E-09_JPRB, &
  & 0.16894391E-09_JPRB, 0.16891286E-09_JPRB, 0.16887784E-09_JPRB, 0.16884333E-09_JPRB, 0.16881468E-09_JPRB, 0.16879685E-09_JPRB, &
  & 0.16879240E-09_JPRB, 0.16880060E-09_JPRB, 0.16882029E-09_JPRB, 0.16884938E-09_JPRB, 0.16888518E-09_JPRB, 0.16892583E-09_JPRB, &
  & 0.16896815E-09_JPRB, 0.16900902E-09_JPRB, 0.16904526E-09_JPRB, 0.16907462E-09_JPRB, 0.16909595E-09_JPRB, 0.16910857E-09_JPRB, &
  & 0.16911329E-09_JPRB, 0.16910962E-09_JPRB, 0.16909943E-09_JPRB, 0.16908597E-09_JPRB, 0.16906915E-09_JPRB, 0.16905077E-09_JPRB, &
  & 0.16902928E-09_JPRB, 0.16900342E-09_JPRB, 0.16896488E-09_JPRB, 0.16889064E-09_JPRB /)

RGHG8(:,69, 9) = (/ &
  & 0.16936272E-09_JPRB, 0.16939086E-09_JPRB, 0.16940344E-09_JPRB, 0.16941196E-09_JPRB, 0.16941792E-09_JPRB, 0.16942206E-09_JPRB, &
  & 0.16942488E-09_JPRB, 0.16942729E-09_JPRB, 0.16943147E-09_JPRB, 0.16943530E-09_JPRB, 0.16943849E-09_JPRB, 0.16943918E-09_JPRB, &
  & 0.16943448E-09_JPRB, 0.16942178E-09_JPRB, 0.16939815E-09_JPRB, 0.16935889E-09_JPRB, 0.16930114E-09_JPRB, 0.16922448E-09_JPRB, &
  & 0.16913115E-09_JPRB, 0.16902617E-09_JPRB, 0.16891873E-09_JPRB, 0.16881981E-09_JPRB, 0.16874027E-09_JPRB, 0.16868683E-09_JPRB, &
  & 0.16866218E-09_JPRB, 0.16866468E-09_JPRB, 0.16868973E-09_JPRB, 0.16873314E-09_JPRB, 0.16879029E-09_JPRB, 0.16885635E-09_JPRB, &
  & 0.16892532E-09_JPRB, 0.16898653E-09_JPRB, 0.16903029E-09_JPRB, 0.16905234E-09_JPRB, 0.16905491E-09_JPRB, 0.16904328E-09_JPRB, &
  & 0.16902170E-09_JPRB, 0.16899336E-09_JPRB, 0.16896146E-09_JPRB, 0.16893015E-09_JPRB, 0.16890414E-09_JPRB, 0.16888831E-09_JPRB, &
  & 0.16888484E-09_JPRB, 0.16889289E-09_JPRB, 0.16891152E-09_JPRB, 0.16893867E-09_JPRB, 0.16897221E-09_JPRB, 0.16901018E-09_JPRB, &
  & 0.16905029E-09_JPRB, 0.16908910E-09_JPRB, 0.16912384E-09_JPRB, 0.16915219E-09_JPRB, 0.16917302E-09_JPRB, 0.16918550E-09_JPRB, &
  & 0.16919016E-09_JPRB, 0.16918648E-09_JPRB, 0.16917620E-09_JPRB, 0.16916268E-09_JPRB, 0.16914549E-09_JPRB, 0.16912663E-09_JPRB, &
  & 0.16910368E-09_JPRB, 0.16907539E-09_JPRB, 0.16902993E-09_JPRB, 0.16893943E-09_JPRB /)

RGHG8(:,70, 9) = (/ &
  & 0.16940029E-09_JPRB, 0.16943702E-09_JPRB, 0.16945362E-09_JPRB, 0.16946410E-09_JPRB, 0.16947141E-09_JPRB, 0.16947602E-09_JPRB, &
  & 0.16947914E-09_JPRB, 0.16948168E-09_JPRB, 0.16948612E-09_JPRB, 0.16948992E-09_JPRB, 0.16949295E-09_JPRB, 0.16949342E-09_JPRB, &
  & 0.16948878E-09_JPRB, 0.16947686E-09_JPRB, 0.16945513E-09_JPRB, 0.16941884E-09_JPRB, 0.16936555E-09_JPRB, 0.16929505E-09_JPRB, &
  & 0.16920923E-09_JPRB, 0.16911283E-09_JPRB, 0.16901364E-09_JPRB, 0.16892240E-09_JPRB, 0.16884812E-09_JPRB, 0.16879784E-09_JPRB, &
  & 0.16877379E-09_JPRB, 0.16877504E-09_JPRB, 0.16879766E-09_JPRB, 0.16883778E-09_JPRB, 0.16889075E-09_JPRB, 0.16895194E-09_JPRB, &
  & 0.16901570E-09_JPRB, 0.16907195E-09_JPRB, 0.16911167E-09_JPRB, 0.16913115E-09_JPRB, 0.16913297E-09_JPRB, 0.16912211E-09_JPRB, &
  & 0.16910255E-09_JPRB, 0.16907693E-09_JPRB, 0.16904828E-09_JPRB, 0.16902030E-09_JPRB, 0.16899732E-09_JPRB, 0.16898377E-09_JPRB, &
  & 0.16898172E-09_JPRB, 0.16898996E-09_JPRB, 0.16900759E-09_JPRB, 0.16903316E-09_JPRB, 0.16906421E-09_JPRB, 0.16909972E-09_JPRB, &
  & 0.16913718E-09_JPRB, 0.16917373E-09_JPRB, 0.16920662E-09_JPRB, 0.16923359E-09_JPRB, 0.16925356E-09_JPRB, 0.16926573E-09_JPRB, &
  & 0.16927047E-09_JPRB, 0.16926718E-09_JPRB, 0.16925733E-09_JPRB, 0.16924429E-09_JPRB, 0.16922724E-09_JPRB, 0.16920844E-09_JPRB, &
  & 0.16918497E-09_JPRB, 0.16915598E-09_JPRB, 0.16910565E-09_JPRB, 0.16900421E-09_JPRB /)

RGHG8(:,71, 9) = (/ &
  & 0.16943896E-09_JPRB, 0.16948640E-09_JPRB, 0.16950630E-09_JPRB, 0.16951902E-09_JPRB, 0.16952720E-09_JPRB, 0.16953230E-09_JPRB, &
  & 0.16953554E-09_JPRB, 0.16953816E-09_JPRB, 0.16954257E-09_JPRB, 0.16954582E-09_JPRB, 0.16954849E-09_JPRB, 0.16954847E-09_JPRB, &
  & 0.16954332E-09_JPRB, 0.16953172E-09_JPRB, 0.16951232E-09_JPRB, 0.16947962E-09_JPRB, 0.16943145E-09_JPRB, 0.16936738E-09_JPRB, &
  & 0.16928992E-09_JPRB, 0.16920244E-09_JPRB, 0.16911275E-09_JPRB, 0.16902929E-09_JPRB, 0.16896128E-09_JPRB, 0.16891447E-09_JPRB, &
  & 0.16889122E-09_JPRB, 0.16889118E-09_JPRB, 0.16891108E-09_JPRB, 0.16894741E-09_JPRB, 0.16899562E-09_JPRB, 0.16905129E-09_JPRB, &
  & 0.16910923E-09_JPRB, 0.16916003E-09_JPRB, 0.16919557E-09_JPRB, 0.16921245E-09_JPRB, 0.16921362E-09_JPRB, 0.16920368E-09_JPRB, &
  & 0.16918617E-09_JPRB, 0.16916341E-09_JPRB, 0.16913805E-09_JPRB, 0.16911349E-09_JPRB, 0.16909359E-09_JPRB, 0.16908250E-09_JPRB, &
  & 0.16908201E-09_JPRB, 0.16909063E-09_JPRB, 0.16910774E-09_JPRB, 0.16913165E-09_JPRB, 0.16916051E-09_JPRB, 0.16919342E-09_JPRB, &
  & 0.16922815E-09_JPRB, 0.16926227E-09_JPRB, 0.16929287E-09_JPRB, 0.16931817E-09_JPRB, 0.16933707E-09_JPRB, 0.16934883E-09_JPRB, &
  & 0.16935371E-09_JPRB, 0.16935110E-09_JPRB, 0.16934232E-09_JPRB, 0.16933017E-09_JPRB, 0.16931410E-09_JPRB, 0.16929610E-09_JPRB, &
  & 0.16927312E-09_JPRB, 0.16924484E-09_JPRB, 0.16919315E-09_JPRB, 0.16908541E-09_JPRB /)

RGHG8(:,72, 9) = (/ &
  & 0.16948297E-09_JPRB, 0.16953916E-09_JPRB, 0.16956242E-09_JPRB, 0.16957635E-09_JPRB, 0.16958540E-09_JPRB, 0.16959058E-09_JPRB, &
  & 0.16959389E-09_JPRB, 0.16959666E-09_JPRB, 0.16960028E-09_JPRB, 0.16960335E-09_JPRB, 0.16960511E-09_JPRB, 0.16960464E-09_JPRB, &
  & 0.16959997E-09_JPRB, 0.16958904E-09_JPRB, 0.16957130E-09_JPRB, 0.16954169E-09_JPRB, 0.16949830E-09_JPRB, 0.16944143E-09_JPRB, &
  & 0.16937217E-09_JPRB, 0.16929477E-09_JPRB, 0.16921434E-09_JPRB, 0.16914006E-09_JPRB, 0.16907854E-09_JPRB, 0.16903580E-09_JPRB, &
  & 0.16901372E-09_JPRB, 0.16901230E-09_JPRB, 0.16902929E-09_JPRB, 0.16906140E-09_JPRB, 0.16910431E-09_JPRB, 0.16915390E-09_JPRB, &
  & 0.16920550E-09_JPRB, 0.16925052E-09_JPRB, 0.16928174E-09_JPRB, 0.16929602E-09_JPRB, 0.16929670E-09_JPRB, 0.16928775E-09_JPRB, &
  & 0.16927239E-09_JPRB, 0.16925247E-09_JPRB, 0.16923053E-09_JPRB, 0.16920937E-09_JPRB, 0.16919260E-09_JPRB, 0.16918403E-09_JPRB, &
  & 0.16918505E-09_JPRB, 0.16919412E-09_JPRB, 0.16921055E-09_JPRB, 0.16923302E-09_JPRB, 0.16925968E-09_JPRB, 0.16928997E-09_JPRB, &
  & 0.16932193E-09_JPRB, 0.16935317E-09_JPRB, 0.16938131E-09_JPRB, 0.16940453E-09_JPRB, 0.16942216E-09_JPRB, 0.16943323E-09_JPRB, &
  & 0.16943841E-09_JPRB, 0.16943695E-09_JPRB, 0.16942941E-09_JPRB, 0.16941916E-09_JPRB, 0.16940428E-09_JPRB, 0.16938820E-09_JPRB, &
  & 0.16936631E-09_JPRB, 0.16934053E-09_JPRB, 0.16928949E-09_JPRB, 0.16918111E-09_JPRB /)

RGHG8(:,73, 9) = (/ &
  & 0.16953842E-09_JPRB, 0.16959759E-09_JPRB, 0.16962140E-09_JPRB, 0.16963581E-09_JPRB, 0.16964480E-09_JPRB, 0.16965003E-09_JPRB, &
  & 0.16965326E-09_JPRB, 0.16965572E-09_JPRB, 0.16965926E-09_JPRB, 0.16966112E-09_JPRB, 0.16966256E-09_JPRB, 0.16966140E-09_JPRB, &
  & 0.16965507E-09_JPRB, 0.16964460E-09_JPRB, 0.16963009E-09_JPRB, 0.16960428E-09_JPRB, 0.16956635E-09_JPRB, 0.16951578E-09_JPRB, &
  & 0.16945598E-09_JPRB, 0.16938786E-09_JPRB, 0.16931825E-09_JPRB, 0.16925283E-09_JPRB, 0.16919878E-09_JPRB, 0.16916059E-09_JPRB, &
  & 0.16914006E-09_JPRB, 0.16913734E-09_JPRB, 0.16915123E-09_JPRB, 0.16917887E-09_JPRB, 0.16921597E-09_JPRB, 0.16925923E-09_JPRB, &
  & 0.16930392E-09_JPRB, 0.16934308E-09_JPRB, 0.16936989E-09_JPRB, 0.16938163E-09_JPRB, 0.16938188E-09_JPRB, 0.16937404E-09_JPRB, &
  & 0.16936086E-09_JPRB, 0.16934391E-09_JPRB, 0.16932539E-09_JPRB, 0.16930762E-09_JPRB, 0.16929391E-09_JPRB, 0.16928753E-09_JPRB, &
  & 0.16928993E-09_JPRB, 0.16929917E-09_JPRB, 0.16931488E-09_JPRB, 0.16933578E-09_JPRB, 0.16936022E-09_JPRB, 0.16938774E-09_JPRB, &
  & 0.16941668E-09_JPRB, 0.16944486E-09_JPRB, 0.16947012E-09_JPRB, 0.16949106E-09_JPRB, 0.16950696E-09_JPRB, 0.16951739E-09_JPRB, &
  & 0.16952256E-09_JPRB, 0.16952219E-09_JPRB, 0.16951655E-09_JPRB, 0.16950803E-09_JPRB, 0.16949545E-09_JPRB, 0.16948132E-09_JPRB, &
  & 0.16946194E-09_JPRB, 0.16943870E-09_JPRB, 0.16939161E-09_JPRB, 0.16928600E-09_JPRB /)

RGHG8(:,74, 9) = (/ &
  & 0.16959886E-09_JPRB, 0.16965843E-09_JPRB, 0.16968177E-09_JPRB, 0.16969545E-09_JPRB, 0.16970433E-09_JPRB, 0.16970902E-09_JPRB, &
  & 0.16971206E-09_JPRB, 0.16971458E-09_JPRB, 0.16971705E-09_JPRB, 0.16971899E-09_JPRB, 0.16971970E-09_JPRB, 0.16971817E-09_JPRB, &
  & 0.16971363E-09_JPRB, 0.16970360E-09_JPRB, 0.16969022E-09_JPRB, 0.16966745E-09_JPRB, 0.16963429E-09_JPRB, 0.16959119E-09_JPRB, &
  & 0.16953960E-09_JPRB, 0.16948222E-09_JPRB, 0.16942259E-09_JPRB, 0.16936719E-09_JPRB, 0.16932057E-09_JPRB, 0.16928743E-09_JPRB, &
  & 0.16926888E-09_JPRB, 0.16926517E-09_JPRB, 0.16927608E-09_JPRB, 0.16929901E-09_JPRB, 0.16933013E-09_JPRB, 0.16936663E-09_JPRB, &
  & 0.16940435E-09_JPRB, 0.16943730E-09_JPRB, 0.16945977E-09_JPRB, 0.16946898E-09_JPRB, 0.16946905E-09_JPRB, 0.16946235E-09_JPRB, &
  & 0.16945141E-09_JPRB, 0.16943734E-09_JPRB, 0.16942232E-09_JPRB, 0.16940786E-09_JPRB, 0.16939708E-09_JPRB, 0.16939269E-09_JPRB, &
  & 0.16939619E-09_JPRB, 0.16940525E-09_JPRB, 0.16941994E-09_JPRB, 0.16943905E-09_JPRB, 0.16946085E-09_JPRB, 0.16948554E-09_JPRB, &
  & 0.16951099E-09_JPRB, 0.16953577E-09_JPRB, 0.16955794E-09_JPRB, 0.16957612E-09_JPRB, 0.16959031E-09_JPRB, 0.16959946E-09_JPRB, &
  & 0.16960461E-09_JPRB, 0.16960515E-09_JPRB, 0.16960107E-09_JPRB, 0.16959485E-09_JPRB, 0.16958426E-09_JPRB, 0.16957295E-09_JPRB, &
  & 0.16955612E-09_JPRB, 0.16953661E-09_JPRB, 0.16949359E-09_JPRB, 0.16939432E-09_JPRB /)

RGHG8(:,75, 9) = (/ &
  & 0.16966197E-09_JPRB, 0.16971971E-09_JPRB, 0.16974142E-09_JPRB, 0.16975434E-09_JPRB, 0.16976229E-09_JPRB, 0.16976645E-09_JPRB, &
  & 0.16976914E-09_JPRB, 0.16977120E-09_JPRB, 0.16977363E-09_JPRB, 0.16977464E-09_JPRB, 0.16977503E-09_JPRB, 0.16977324E-09_JPRB, &
  & 0.16976635E-09_JPRB, 0.16975701E-09_JPRB, 0.16974845E-09_JPRB, 0.16973009E-09_JPRB, 0.16970246E-09_JPRB, 0.16966603E-09_JPRB, &
  & 0.16962398E-09_JPRB, 0.16957635E-09_JPRB, 0.16952754E-09_JPRB, 0.16948175E-09_JPRB, 0.16944293E-09_JPRB, 0.16941512E-09_JPRB, &
  & 0.16939912E-09_JPRB, 0.16939487E-09_JPRB, 0.16940303E-09_JPRB, 0.16942128E-09_JPRB, 0.16944626E-09_JPRB, 0.16947596E-09_JPRB, &
  & 0.16950645E-09_JPRB, 0.16953330E-09_JPRB, 0.16955151E-09_JPRB, 0.16955834E-09_JPRB, 0.16955828E-09_JPRB, 0.16955277E-09_JPRB, &
  & 0.16954403E-09_JPRB, 0.16953294E-09_JPRB, 0.16952140E-09_JPRB, 0.16951013E-09_JPRB, 0.16950209E-09_JPRB, 0.16949937E-09_JPRB, &
  & 0.16950340E-09_JPRB, 0.16951193E-09_JPRB, 0.16952524E-09_JPRB, 0.16954203E-09_JPRB, 0.16956120E-09_JPRB, 0.16958228E-09_JPRB, &
  & 0.16960422E-09_JPRB, 0.16962524E-09_JPRB, 0.16964397E-09_JPRB, 0.16965919E-09_JPRB, 0.16967122E-09_JPRB, 0.16967912E-09_JPRB, &
  & 0.16968367E-09_JPRB, 0.16968474E-09_JPRB, 0.16968216E-09_JPRB, 0.16967761E-09_JPRB, 0.16966957E-09_JPRB, 0.16966062E-09_JPRB, &
  & 0.16964719E-09_JPRB, 0.16963102E-09_JPRB, 0.16959349E-09_JPRB, 0.16950220E-09_JPRB /)

RGHG8(:,76, 9) = (/ &
  & 0.16972630E-09_JPRB, 0.16978002E-09_JPRB, 0.16979976E-09_JPRB, 0.16981090E-09_JPRB, 0.16981819E-09_JPRB, 0.16982132E-09_JPRB, &
  & 0.16982357E-09_JPRB, 0.16982549E-09_JPRB, 0.16982712E-09_JPRB, 0.16982797E-09_JPRB, 0.16982812E-09_JPRB, 0.16982610E-09_JPRB, &
  & 0.16982184E-09_JPRB, 0.16981404E-09_JPRB, 0.16980641E-09_JPRB, 0.16979171E-09_JPRB, 0.16976981E-09_JPRB, 0.16974069E-09_JPRB, &
  & 0.16970787E-09_JPRB, 0.16967054E-09_JPRB, 0.16963222E-09_JPRB, 0.16959600E-09_JPRB, 0.16956508E-09_JPRB, 0.16954296E-09_JPRB, &
  & 0.16953002E-09_JPRB, 0.16952578E-09_JPRB, 0.16953158E-09_JPRB, 0.16954529E-09_JPRB, 0.16956427E-09_JPRB, 0.16958693E-09_JPRB, &
  & 0.16961041E-09_JPRB, 0.16963109E-09_JPRB, 0.16964523E-09_JPRB, 0.16964981E-09_JPRB, 0.16964986E-09_JPRB, 0.16964563E-09_JPRB, &
  & 0.16963909E-09_JPRB, 0.16963074E-09_JPRB, 0.16962259E-09_JPRB, 0.16961442E-09_JPRB, 0.16960898E-09_JPRB, 0.16960755E-09_JPRB, &
  & 0.16961181E-09_JPRB, 0.16961928E-09_JPRB, 0.16963068E-09_JPRB, 0.16964484E-09_JPRB, 0.16966040E-09_JPRB, 0.16967784E-09_JPRB, &
  & 0.16969551E-09_JPRB, 0.16971256E-09_JPRB, 0.16972754E-09_JPRB, 0.16973964E-09_JPRB, 0.16974933E-09_JPRB, 0.16975565E-09_JPRB, &
  & 0.16975944E-09_JPRB, 0.16976071E-09_JPRB, 0.16975915E-09_JPRB, 0.16975611E-09_JPRB, 0.16975024E-09_JPRB, 0.16974376E-09_JPRB, &
  & 0.16973362E-09_JPRB, 0.16972102E-09_JPRB, 0.16968962E-09_JPRB, 0.16960774E-09_JPRB /)

RGHG8(:,77, 9) = (/ &
  & 0.16979101E-09_JPRB, 0.16983882E-09_JPRB, 0.16985530E-09_JPRB, 0.16986472E-09_JPRB, 0.16987087E-09_JPRB, 0.16987291E-09_JPRB, &
  & 0.16987459E-09_JPRB, 0.16987615E-09_JPRB, 0.16987739E-09_JPRB, 0.16987753E-09_JPRB, 0.16987739E-09_JPRB, 0.16987525E-09_JPRB, &
  & 0.16986897E-09_JPRB, 0.16986121E-09_JPRB, 0.16986053E-09_JPRB, 0.16985086E-09_JPRB, 0.16983488E-09_JPRB, 0.16981312E-09_JPRB, &
  & 0.16978990E-09_JPRB, 0.16976279E-09_JPRB, 0.16973470E-09_JPRB, 0.16970840E-09_JPRB, 0.16968528E-09_JPRB, 0.16966935E-09_JPRB, &
  & 0.16965992E-09_JPRB, 0.16965614E-09_JPRB, 0.16966009E-09_JPRB, 0.16966968E-09_JPRB, 0.16968284E-09_JPRB, 0.16969880E-09_JPRB, &
  & 0.16971556E-09_JPRB, 0.16973048E-09_JPRB, 0.16974087E-09_JPRB, 0.16974344E-09_JPRB, 0.16974375E-09_JPRB, 0.16974083E-09_JPRB, &
  & 0.16973643E-09_JPRB, 0.16973073E-09_JPRB, 0.16972573E-09_JPRB, 0.16972029E-09_JPRB, 0.16971706E-09_JPRB, 0.16971627E-09_JPRB, &
  & 0.16972010E-09_JPRB, 0.16972609E-09_JPRB, 0.16973500E-09_JPRB, 0.16974577E-09_JPRB, 0.16975742E-09_JPRB, 0.16977023E-09_JPRB, &
  & 0.16978342E-09_JPRB, 0.16979611E-09_JPRB, 0.16980724E-09_JPRB, 0.16981586E-09_JPRB, 0.16982350E-09_JPRB, 0.16982793E-09_JPRB, &
  & 0.16983087E-09_JPRB, 0.16983213E-09_JPRB, 0.16983130E-09_JPRB, 0.16982935E-09_JPRB, 0.16982546E-09_JPRB, 0.16982109E-09_JPRB, &
  & 0.16981420E-09_JPRB, 0.16980525E-09_JPRB, 0.16977958E-09_JPRB, 0.16971057E-09_JPRB /)

RGHG8(:,78, 9) = (/ &
  & 0.16985631E-09_JPRB, 0.16989285E-09_JPRB, 0.16990453E-09_JPRB, 0.16991156E-09_JPRB, 0.16991689E-09_JPRB, 0.16991762E-09_JPRB, &
  & 0.16991884E-09_JPRB, 0.16992022E-09_JPRB, 0.16992080E-09_JPRB, 0.16992034E-09_JPRB, 0.16992036E-09_JPRB, 0.16991836E-09_JPRB, &
  & 0.16991454E-09_JPRB, 0.16990920E-09_JPRB, 0.16990943E-09_JPRB, 0.16990344E-09_JPRB, 0.16989304E-09_JPRB, 0.16987804E-09_JPRB, &
  & 0.16986390E-09_JPRB, 0.16984626E-09_JPRB, 0.16982819E-09_JPRB, 0.16981105E-09_JPRB, 0.16979604E-09_JPRB, 0.16978624E-09_JPRB, &
  & 0.16978091E-09_JPRB, 0.16977812E-09_JPRB, 0.16978086E-09_JPRB, 0.16978725E-09_JPRB, 0.16979534E-09_JPRB, 0.16980556E-09_JPRB, &
  & 0.16981630E-09_JPRB, 0.16982613E-09_JPRB, 0.16983323E-09_JPRB, 0.16983415E-09_JPRB, 0.16983505E-09_JPRB, 0.16983351E-09_JPRB, &
  & 0.16983098E-09_JPRB, 0.16982733E-09_JPRB, 0.16982485E-09_JPRB, 0.16982155E-09_JPRB, 0.16981982E-09_JPRB, 0.16981905E-09_JPRB, &
  & 0.16982175E-09_JPRB, 0.16982560E-09_JPRB, 0.16983139E-09_JPRB, 0.16983827E-09_JPRB, 0.16984525E-09_JPRB, 0.16985321E-09_JPRB, &
  & 0.16986171E-09_JPRB, 0.16987005E-09_JPRB, 0.16987728E-09_JPRB, 0.16988287E-09_JPRB, 0.16988823E-09_JPRB, 0.16989130E-09_JPRB, &
  & 0.16989310E-09_JPRB, 0.16989433E-09_JPRB, 0.16989392E-09_JPRB, 0.16989266E-09_JPRB, 0.16989035E-09_JPRB, 0.16988744E-09_JPRB, &
  & 0.16988350E-09_JPRB, 0.16987753E-09_JPRB, 0.16986033E-09_JPRB, 0.16980839E-09_JPRB /)

RGHG8(:,79, 9) = (/ &
  & 0.16989898E-09_JPRB, 0.16992310E-09_JPRB, 0.16993063E-09_JPRB, 0.16993594E-09_JPRB, 0.16994095E-09_JPRB, 0.16994073E-09_JPRB, &
  & 0.16994169E-09_JPRB, 0.16994307E-09_JPRB, 0.16994325E-09_JPRB, 0.16994237E-09_JPRB, 0.16994250E-09_JPRB, 0.16994074E-09_JPRB, &
  & 0.16993813E-09_JPRB, 0.16993412E-09_JPRB, 0.16993495E-09_JPRB, 0.16993097E-09_JPRB, 0.16992353E-09_JPRB, 0.16991189E-09_JPRB, &
  & 0.16990281E-09_JPRB, 0.16989032E-09_JPRB, 0.16987749E-09_JPRB, 0.16986568E-09_JPRB, 0.16985480E-09_JPRB, 0.16984880E-09_JPRB, &
  & 0.16984585E-09_JPRB, 0.16984375E-09_JPRB, 0.16984605E-09_JPRB, 0.16985077E-09_JPRB, 0.16985617E-09_JPRB, 0.16986328E-09_JPRB, &
  & 0.16987081E-09_JPRB, 0.16987792E-09_JPRB, 0.16988334E-09_JPRB, 0.16988320E-09_JPRB, 0.16988450E-09_JPRB, 0.16988363E-09_JPRB, &
  & 0.16988201E-09_JPRB, 0.16987921E-09_JPRB, 0.16987800E-09_JPRB, 0.16987557E-09_JPRB, 0.16987449E-09_JPRB, 0.16987338E-09_JPRB, &
  & 0.16987531E-09_JPRB, 0.16987788E-09_JPRB, 0.16988183E-09_JPRB, 0.16988654E-09_JPRB, 0.16989088E-09_JPRB, 0.16989612E-09_JPRB, &
  & 0.16990208E-09_JPRB, 0.16990812E-09_JPRB, 0.16991335E-09_JPRB, 0.16991704E-09_JPRB, 0.16992160E-09_JPRB, 0.16992362E-09_JPRB, &
  & 0.16992495E-09_JPRB, 0.16992618E-09_JPRB, 0.16992600E-09_JPRB, 0.16992495E-09_JPRB, 0.16992345E-09_JPRB, 0.16992124E-09_JPRB, &
  & 0.16991897E-09_JPRB, 0.16991572E-09_JPRB, 0.16990452E-09_JPRB, 0.16987041E-09_JPRB /)

RGHG8(:,80, 9) = (/ &
  & 0.16992781E-09_JPRB, 0.16993768E-09_JPRB, 0.16994189E-09_JPRB, 0.16994639E-09_JPRB, 0.16995140E-09_JPRB, 0.16995065E-09_JPRB, &
  & 0.16995150E-09_JPRB, 0.16995298E-09_JPRB, 0.16995297E-09_JPRB, 0.16995187E-09_JPRB, 0.16995218E-09_JPRB, 0.16995050E-09_JPRB, &
  & 0.16994854E-09_JPRB, 0.16994514E-09_JPRB, 0.16994628E-09_JPRB, 0.16994328E-09_JPRB, 0.16993709E-09_JPRB, 0.16992699E-09_JPRB, &
  & 0.16992029E-09_JPRB, 0.16991007E-09_JPRB, 0.16989975E-09_JPRB, 0.16989012E-09_JPRB, 0.16988130E-09_JPRB, 0.16987695E-09_JPRB, &
  & 0.16987522E-09_JPRB, 0.16987342E-09_JPRB, 0.16987559E-09_JPRB, 0.16987964E-09_JPRB, 0.16988383E-09_JPRB, 0.16988960E-09_JPRB, &
  & 0.16989561E-09_JPRB, 0.16990151E-09_JPRB, 0.16990623E-09_JPRB, 0.16990555E-09_JPRB, 0.16990701E-09_JPRB, 0.16990642E-09_JPRB, &
  & 0.16990510E-09_JPRB, 0.16990261E-09_JPRB, 0.16990193E-09_JPRB, 0.16989986E-09_JPRB, 0.16989891E-09_JPRB, 0.16989757E-09_JPRB, &
  & 0.16989911E-09_JPRB, 0.16990101E-09_JPRB, 0.16990424E-09_JPRB, 0.16990793E-09_JPRB, 0.16991111E-09_JPRB, 0.16991508E-09_JPRB, &
  & 0.16991993E-09_JPRB, 0.16992489E-09_JPRB, 0.16992920E-09_JPRB, 0.16993194E-09_JPRB, 0.16993598E-09_JPRB, 0.16993755E-09_JPRB, &
  & 0.16993854E-09_JPRB, 0.16993978E-09_JPRB, 0.16993965E-09_JPRB, 0.16993865E-09_JPRB, 0.16993749E-09_JPRB, 0.16993552E-09_JPRB, &
  & 0.16993422E-09_JPRB, 0.16993225E-09_JPRB, 0.16992566E-09_JPRB, 0.16991070E-09_JPRB /)

RGHG8(:,81, 9) = (/ &
  & 0.16994803E-09_JPRB, 0.16994377E-09_JPRB, 0.16994661E-09_JPRB, 0.16995080E-09_JPRB, 0.16995594E-09_JPRB, 0.16995490E-09_JPRB, &
  & 0.16995565E-09_JPRB, 0.16995726E-09_JPRB, 0.16995716E-09_JPRB, 0.16995601E-09_JPRB, 0.16995637E-09_JPRB, 0.16995473E-09_JPRB, &
  & 0.16995312E-09_JPRB, 0.16994994E-09_JPRB, 0.16995126E-09_JPRB, 0.16994874E-09_JPRB, 0.16994323E-09_JPRB, 0.16993355E-09_JPRB, &
  & 0.16992810E-09_JPRB, 0.16991888E-09_JPRB, 0.16990949E-09_JPRB, 0.16990098E-09_JPRB, 0.16989285E-09_JPRB, 0.16988932E-09_JPRB, &
  & 0.16988813E-09_JPRB, 0.16988651E-09_JPRB, 0.16988860E-09_JPRB, 0.16989238E-09_JPRB, 0.16989607E-09_JPRB, 0.16990118E-09_JPRB, &
  & 0.16990657E-09_JPRB, 0.16991190E-09_JPRB, 0.16991633E-09_JPRB, 0.16991533E-09_JPRB, 0.16991693E-09_JPRB, 0.16991647E-09_JPRB, &
  & 0.16991529E-09_JPRB, 0.16991288E-09_JPRB, 0.16991239E-09_JPRB, 0.16991047E-09_JPRB, 0.16990956E-09_JPRB, 0.16990813E-09_JPRB, &
  & 0.16990946E-09_JPRB, 0.16991113E-09_JPRB, 0.16991400E-09_JPRB, 0.16991733E-09_JPRB, 0.16991995E-09_JPRB, 0.16992339E-09_JPRB, &
  & 0.16992774E-09_JPRB, 0.16993226E-09_JPRB, 0.16993613E-09_JPRB, 0.16993840E-09_JPRB, 0.16994225E-09_JPRB, 0.16994350E-09_JPRB, &
  & 0.16994431E-09_JPRB, 0.16994556E-09_JPRB, 0.16994545E-09_JPRB, 0.16994446E-09_JPRB, 0.16994342E-09_JPRB, 0.16994157E-09_JPRB, &
  & 0.16994060E-09_JPRB, 0.16993923E-09_JPRB, 0.16993447E-09_JPRB, 0.16993816E-09_JPRB /)

RGHG8(:,82, 9) = (/ &
  & 0.16994967E-09_JPRB, 0.16994572E-09_JPRB, 0.16994862E-09_JPRB, 0.16995291E-09_JPRB, 0.16995813E-09_JPRB, 0.16995695E-09_JPRB, &
  & 0.16995777E-09_JPRB, 0.16995924E-09_JPRB, 0.16995906E-09_JPRB, 0.16995805E-09_JPRB, 0.16995831E-09_JPRB, 0.16995685E-09_JPRB, &
  & 0.16995529E-09_JPRB, 0.16995232E-09_JPRB, 0.16995369E-09_JPRB, 0.16995148E-09_JPRB, 0.16994620E-09_JPRB, 0.16993680E-09_JPRB, &
  & 0.16993196E-09_JPRB, 0.16992324E-09_JPRB, 0.16991440E-09_JPRB, 0.16990630E-09_JPRB, 0.16989848E-09_JPRB, 0.16989538E-09_JPRB, &
  & 0.16989443E-09_JPRB, 0.16989288E-09_JPRB, 0.16989499E-09_JPRB, 0.16989860E-09_JPRB, 0.16990202E-09_JPRB, 0.16990687E-09_JPRB, &
  & 0.16991189E-09_JPRB, 0.16991694E-09_JPRB, 0.16992124E-09_JPRB, 0.16992016E-09_JPRB, 0.16992181E-09_JPRB, 0.16992138E-09_JPRB, &
  & 0.16992024E-09_JPRB, 0.16991791E-09_JPRB, 0.16991755E-09_JPRB, 0.16991569E-09_JPRB, 0.16991479E-09_JPRB, 0.16991326E-09_JPRB, &
  & 0.16991453E-09_JPRB, 0.16991607E-09_JPRB, 0.16991884E-09_JPRB, 0.16992197E-09_JPRB, 0.16992432E-09_JPRB, 0.16992747E-09_JPRB, &
  & 0.16993161E-09_JPRB, 0.16993587E-09_JPRB, 0.16993952E-09_JPRB, 0.16994151E-09_JPRB, 0.16994532E-09_JPRB, 0.16994639E-09_JPRB, &
  & 0.16994710E-09_JPRB, 0.16994833E-09_JPRB, 0.16994821E-09_JPRB, 0.16994722E-09_JPRB, 0.16994625E-09_JPRB, 0.16994445E-09_JPRB, &
  & 0.16994364E-09_JPRB, 0.16994228E-09_JPRB, 0.16993740E-09_JPRB, 0.16994034E-09_JPRB /)

RGHG8(:,83, 9) = (/ &
  & 0.16995079E-09_JPRB, 0.16994686E-09_JPRB, 0.16994978E-09_JPRB, 0.16995402E-09_JPRB, 0.16995938E-09_JPRB, 0.16995810E-09_JPRB, &
  & 0.16995885E-09_JPRB, 0.16996046E-09_JPRB, 0.16996030E-09_JPRB, 0.16995916E-09_JPRB, 0.16995942E-09_JPRB, 0.16995785E-09_JPRB, &
  & 0.16995652E-09_JPRB, 0.16995368E-09_JPRB, 0.16995506E-09_JPRB, 0.16995302E-09_JPRB, 0.16994790E-09_JPRB, 0.16993860E-09_JPRB, &
  & 0.16993416E-09_JPRB, 0.16992573E-09_JPRB, 0.16991708E-09_JPRB, 0.16990929E-09_JPRB, 0.16990165E-09_JPRB, 0.16989875E-09_JPRB, &
  & 0.16989804E-09_JPRB, 0.16989642E-09_JPRB, 0.16989854E-09_JPRB, 0.16990208E-09_JPRB, 0.16990542E-09_JPRB, 0.16991000E-09_JPRB, &
  & 0.16991486E-09_JPRB, 0.16991977E-09_JPRB, 0.16992398E-09_JPRB, 0.16992283E-09_JPRB, 0.16992452E-09_JPRB, 0.16992413E-09_JPRB, &
  & 0.16992299E-09_JPRB, 0.16992070E-09_JPRB, 0.16992037E-09_JPRB, 0.16991859E-09_JPRB, 0.16991770E-09_JPRB, 0.16991615E-09_JPRB, &
  & 0.16991736E-09_JPRB, 0.16991882E-09_JPRB, 0.16992155E-09_JPRB, 0.16992457E-09_JPRB, 0.16992678E-09_JPRB, 0.16992981E-09_JPRB, &
  & 0.16993378E-09_JPRB, 0.16993791E-09_JPRB, 0.16994142E-09_JPRB, 0.16994324E-09_JPRB, 0.16994700E-09_JPRB, 0.16994799E-09_JPRB, &
  & 0.16994861E-09_JPRB, 0.16994987E-09_JPRB, 0.16994975E-09_JPRB, 0.16994876E-09_JPRB, 0.16994783E-09_JPRB, 0.16994603E-09_JPRB, &
  & 0.16994535E-09_JPRB, 0.16994403E-09_JPRB, 0.16993912E-09_JPRB, 0.16994189E-09_JPRB /)

RGHG8(:,84, 9) = (/ &
  & 0.16995162E-09_JPRB, 0.16994757E-09_JPRB, 0.16995039E-09_JPRB, 0.16995473E-09_JPRB, 0.16996014E-09_JPRB, 0.16995882E-09_JPRB, &
  & 0.16995970E-09_JPRB, 0.16996096E-09_JPRB, 0.16996066E-09_JPRB, 0.16995989E-09_JPRB, 0.16995989E-09_JPRB, 0.16995863E-09_JPRB, &
  & 0.16995716E-09_JPRB, 0.16995472E-09_JPRB, 0.16995579E-09_JPRB, 0.16995397E-09_JPRB, 0.16994901E-09_JPRB, 0.16993981E-09_JPRB, &
  & 0.16993557E-09_JPRB, 0.16992727E-09_JPRB, 0.16991876E-09_JPRB, 0.16991118E-09_JPRB, 0.16990351E-09_JPRB, 0.16990086E-09_JPRB, &
  & 0.16990021E-09_JPRB, 0.16989860E-09_JPRB, 0.16990073E-09_JPRB, 0.16990427E-09_JPRB, 0.16990741E-09_JPRB, 0.16991199E-09_JPRB, &
  & 0.16991665E-09_JPRB, 0.16992148E-09_JPRB, 0.16992564E-09_JPRB, 0.16992444E-09_JPRB, 0.16992618E-09_JPRB, 0.16992581E-09_JPRB, &
  & 0.16992466E-09_JPRB, 0.16992240E-09_JPRB, 0.16992210E-09_JPRB, 0.16992036E-09_JPRB, 0.16991947E-09_JPRB, 0.16991790E-09_JPRB, &
  & 0.16991906E-09_JPRB, 0.16992052E-09_JPRB, 0.16992320E-09_JPRB, 0.16992627E-09_JPRB, 0.16992828E-09_JPRB, 0.16993124E-09_JPRB, &
  & 0.16993512E-09_JPRB, 0.16993920E-09_JPRB, 0.16994260E-09_JPRB, 0.16994435E-09_JPRB, 0.16994810E-09_JPRB, 0.16994894E-09_JPRB, &
  & 0.16994955E-09_JPRB, 0.16995083E-09_JPRB, 0.16995069E-09_JPRB, 0.16994968E-09_JPRB, 0.16994881E-09_JPRB, 0.16994696E-09_JPRB, &
  & 0.16994640E-09_JPRB, 0.16994514E-09_JPRB, 0.16994023E-09_JPRB, 0.16994295E-09_JPRB /)

RGHG8(:,85, 9) = (/ &
  & 0.16995216E-09_JPRB, 0.16994804E-09_JPRB, 0.16995085E-09_JPRB, 0.16995519E-09_JPRB, 0.16996067E-09_JPRB, 0.16995935E-09_JPRB, &
  & 0.16996000E-09_JPRB, 0.16996131E-09_JPRB, 0.16996110E-09_JPRB, 0.16996025E-09_JPRB, 0.16996010E-09_JPRB, 0.16995887E-09_JPRB, &
  & 0.16995758E-09_JPRB, 0.16995563E-09_JPRB, 0.16995604E-09_JPRB, 0.16995436E-09_JPRB, 0.16994964E-09_JPRB, 0.16994088E-09_JPRB, &
  & 0.16993655E-09_JPRB, 0.16992832E-09_JPRB, 0.16991995E-09_JPRB, 0.16991233E-09_JPRB, 0.16990480E-09_JPRB, 0.16990216E-09_JPRB, &
  & 0.16990166E-09_JPRB, 0.16989994E-09_JPRB, 0.16990212E-09_JPRB, 0.16990556E-09_JPRB, 0.16990880E-09_JPRB, 0.16991315E-09_JPRB, &
  & 0.16991787E-09_JPRB, 0.16992259E-09_JPRB, 0.16992674E-09_JPRB, 0.16992546E-09_JPRB, 0.16992727E-09_JPRB, 0.16992691E-09_JPRB, &
  & 0.16992574E-09_JPRB, 0.16992345E-09_JPRB, 0.16992321E-09_JPRB, 0.16992152E-09_JPRB, 0.16992063E-09_JPRB, 0.16991904E-09_JPRB, &
  & 0.16992023E-09_JPRB, 0.16992158E-09_JPRB, 0.16992439E-09_JPRB, 0.16992729E-09_JPRB, 0.16992928E-09_JPRB, 0.16993212E-09_JPRB, &
  & 0.16993598E-09_JPRB, 0.16994003E-09_JPRB, 0.16994339E-09_JPRB, 0.16994504E-09_JPRB, 0.16994881E-09_JPRB, 0.16994961E-09_JPRB, &
  & 0.16995015E-09_JPRB, 0.16995147E-09_JPRB, 0.16995130E-09_JPRB, 0.16995030E-09_JPRB, 0.16994943E-09_JPRB, 0.16994763E-09_JPRB, &
  & 0.16994708E-09_JPRB, 0.16994589E-09_JPRB, 0.16994094E-09_JPRB, 0.16994366E-09_JPRB /)

RGHG8(:,86, 9) = (/ &
  & 0.16995262E-09_JPRB, 0.16994831E-09_JPRB, 0.16995105E-09_JPRB, 0.16995544E-09_JPRB, 0.16996096E-09_JPRB, 0.16995978E-09_JPRB, &
  & 0.16996056E-09_JPRB, 0.16996123E-09_JPRB, 0.16996093E-09_JPRB, 0.16996038E-09_JPRB, 0.16995998E-09_JPRB, 0.16995899E-09_JPRB, &
  & 0.16995783E-09_JPRB, 0.16995627E-09_JPRB, 0.16995608E-09_JPRB, 0.16995431E-09_JPRB, 0.16995000E-09_JPRB, 0.16994199E-09_JPRB, &
  & 0.16993724E-09_JPRB, 0.16992924E-09_JPRB, 0.16992072E-09_JPRB, 0.16991326E-09_JPRB, 0.16990551E-09_JPRB, 0.16990301E-09_JPRB, &
  & 0.16990255E-09_JPRB, 0.16990073E-09_JPRB, 0.16990291E-09_JPRB, 0.16990652E-09_JPRB, 0.16990953E-09_JPRB, 0.16991406E-09_JPRB, &
  & 0.16991857E-09_JPRB, 0.16992338E-09_JPRB, 0.16992746E-09_JPRB, 0.16992610E-09_JPRB, 0.16992795E-09_JPRB, 0.16992760E-09_JPRB, &
  & 0.16992643E-09_JPRB, 0.16992413E-09_JPRB, 0.16992396E-09_JPRB, 0.16992226E-09_JPRB, 0.16992133E-09_JPRB, 0.16991965E-09_JPRB, &
  & 0.16992087E-09_JPRB, 0.16992238E-09_JPRB, 0.16992503E-09_JPRB, 0.16992809E-09_JPRB, 0.16992988E-09_JPRB, 0.16993273E-09_JPRB, &
  & 0.16993654E-09_JPRB, 0.16994056E-09_JPRB, 0.16994388E-09_JPRB, 0.16994545E-09_JPRB, 0.16994925E-09_JPRB, 0.16995000E-09_JPRB, &
  & 0.16995054E-09_JPRB, 0.16995186E-09_JPRB, 0.16995166E-09_JPRB, 0.16995066E-09_JPRB, 0.16994982E-09_JPRB, 0.16994793E-09_JPRB, &
  & 0.16994754E-09_JPRB, 0.16994636E-09_JPRB, 0.16994139E-09_JPRB, 0.16994413E-09_JPRB /)

RGHG8(:,87, 9) = (/ &
  & 0.16995280E-09_JPRB, 0.16994844E-09_JPRB, 0.16995123E-09_JPRB, 0.16995585E-09_JPRB, 0.16996110E-09_JPRB, 0.16996000E-09_JPRB, &
  & 0.16996045E-09_JPRB, 0.16996121E-09_JPRB, 0.16996096E-09_JPRB, 0.16996030E-09_JPRB, 0.16995987E-09_JPRB, 0.16995891E-09_JPRB, &
  & 0.16995785E-09_JPRB, 0.16995652E-09_JPRB, 0.16995597E-09_JPRB, 0.16995422E-09_JPRB, 0.16995014E-09_JPRB, 0.16994281E-09_JPRB, &
  & 0.16993795E-09_JPRB, 0.16992974E-09_JPRB, 0.16992137E-09_JPRB, 0.16991371E-09_JPRB, 0.16990599E-09_JPRB, 0.16990348E-09_JPRB, &
  & 0.16990313E-09_JPRB, 0.16990109E-09_JPRB, 0.16990342E-09_JPRB, 0.16990692E-09_JPRB, 0.16991007E-09_JPRB, 0.16991443E-09_JPRB, &
  & 0.16991912E-09_JPRB, 0.16992388E-09_JPRB, 0.16992796E-09_JPRB, 0.16992648E-09_JPRB, 0.16992840E-09_JPRB, 0.16992804E-09_JPRB, &
  & 0.16992692E-09_JPRB, 0.16992449E-09_JPRB, 0.16992445E-09_JPRB, 0.16992267E-09_JPRB, 0.16992177E-09_JPRB, 0.16991995E-09_JPRB, &
  & 0.16992133E-09_JPRB, 0.16992276E-09_JPRB, 0.16992562E-09_JPRB, 0.16992853E-09_JPRB, 0.16993031E-09_JPRB, 0.16993307E-09_JPRB, &
  & 0.16993688E-09_JPRB, 0.16994088E-09_JPRB, 0.16994423E-09_JPRB, 0.16994570E-09_JPRB, 0.16994950E-09_JPRB, 0.16995025E-09_JPRB, &
  & 0.16995075E-09_JPRB, 0.16995205E-09_JPRB, 0.16995189E-09_JPRB, 0.16995091E-09_JPRB, 0.16995005E-09_JPRB, 0.16994817E-09_JPRB, &
  & 0.16994783E-09_JPRB, 0.16994667E-09_JPRB, 0.16994163E-09_JPRB, 0.16994443E-09_JPRB /)

RGHG8(:,88, 9) = (/ &
  & 0.16995298E-09_JPRB, 0.16994861E-09_JPRB, 0.16995133E-09_JPRB, 0.16995570E-09_JPRB, 0.16996121E-09_JPRB, 0.16996018E-09_JPRB, &
  & 0.16996077E-09_JPRB, 0.16996121E-09_JPRB, 0.16996085E-09_JPRB, 0.16996035E-09_JPRB, 0.16995987E-09_JPRB, 0.16995898E-09_JPRB, &
  & 0.16995796E-09_JPRB, 0.16995665E-09_JPRB, 0.16995606E-09_JPRB, 0.16995425E-09_JPRB, 0.16995033E-09_JPRB, 0.16994323E-09_JPRB, &
  & 0.16993817E-09_JPRB, 0.16993024E-09_JPRB, 0.16992159E-09_JPRB, 0.16991412E-09_JPRB, 0.16990621E-09_JPRB, 0.16990379E-09_JPRB, &
  & 0.16990349E-09_JPRB, 0.16990130E-09_JPRB, 0.16990365E-09_JPRB, 0.16990728E-09_JPRB, 0.16991024E-09_JPRB, 0.16991480E-09_JPRB, &
  & 0.16991941E-09_JPRB, 0.16992424E-09_JPRB, 0.16992832E-09_JPRB, 0.16992671E-09_JPRB, 0.16992872E-09_JPRB, 0.16992836E-09_JPRB, &
  & 0.16992723E-09_JPRB, 0.16992471E-09_JPRB, 0.16992482E-09_JPRB, 0.16992296E-09_JPRB, 0.16992208E-09_JPRB, 0.16992005E-09_JPRB, &
  & 0.16992156E-09_JPRB, 0.16992306E-09_JPRB, 0.16992582E-09_JPRB, 0.16992885E-09_JPRB, 0.16993056E-09_JPRB, 0.16993333E-09_JPRB, &
  & 0.16993711E-09_JPRB, 0.16994108E-09_JPRB, 0.16994443E-09_JPRB, 0.16994584E-09_JPRB, 0.16994968E-09_JPRB, 0.16995040E-09_JPRB, &
  & 0.16995089E-09_JPRB, 0.16995219E-09_JPRB, 0.16995201E-09_JPRB, 0.16995103E-09_JPRB, 0.16995021E-09_JPRB, 0.16994826E-09_JPRB, &
  & 0.16994797E-09_JPRB, 0.16994685E-09_JPRB, 0.16994178E-09_JPRB, 0.16994457E-09_JPRB /)

RGHG8(:,89, 9) = (/ &
  & 0.16995287E-09_JPRB, 0.16994883E-09_JPRB, 0.16995146E-09_JPRB, 0.16995592E-09_JPRB, 0.16996135E-09_JPRB, 0.16996013E-09_JPRB, &
  & 0.16996060E-09_JPRB, 0.16996136E-09_JPRB, 0.16996107E-09_JPRB, 0.16996041E-09_JPRB, 0.16996002E-09_JPRB, 0.16995907E-09_JPRB, &
  & 0.16995802E-09_JPRB, 0.16995669E-09_JPRB, 0.16995616E-09_JPRB, 0.16995447E-09_JPRB, 0.16995039E-09_JPRB, 0.16994302E-09_JPRB, &
  & 0.16993829E-09_JPRB, 0.16993010E-09_JPRB, 0.16992178E-09_JPRB, 0.16991419E-09_JPRB, 0.16990635E-09_JPRB, 0.16990392E-09_JPRB, &
  & 0.16990367E-09_JPRB, 0.16990132E-09_JPRB, 0.16990377E-09_JPRB, 0.16990742E-09_JPRB, 0.16991042E-09_JPRB, 0.16991490E-09_JPRB, &
  & 0.16991965E-09_JPRB, 0.16992445E-09_JPRB, 0.16992861E-09_JPRB, 0.16992677E-09_JPRB, 0.16992888E-09_JPRB, 0.16992856E-09_JPRB, &
  & 0.16992743E-09_JPRB, 0.16992480E-09_JPRB, 0.16992506E-09_JPRB, 0.16992308E-09_JPRB, 0.16992224E-09_JPRB, 0.16992002E-09_JPRB, &
  & 0.16992169E-09_JPRB, 0.16992316E-09_JPRB, 0.16992606E-09_JPRB, 0.16992906E-09_JPRB, 0.16993068E-09_JPRB, 0.16993344E-09_JPRB, &
  & 0.16993722E-09_JPRB, 0.16994123E-09_JPRB, 0.16994457E-09_JPRB, 0.16994592E-09_JPRB, 0.16994980E-09_JPRB, 0.16995050E-09_JPRB, &
  & 0.16995097E-09_JPRB, 0.16995227E-09_JPRB, 0.16995207E-09_JPRB, 0.16995107E-09_JPRB, 0.16995029E-09_JPRB, 0.16994828E-09_JPRB, &
  & 0.16994807E-09_JPRB, 0.16994700E-09_JPRB, 0.16994185E-09_JPRB, 0.16994470E-09_JPRB /)

RGHG8(:,90, 9) = (/ &
  & 0.16995290E-09_JPRB, 0.16994901E-09_JPRB, 0.16995125E-09_JPRB, 0.16995565E-09_JPRB, 0.16996159E-09_JPRB, 0.16996003E-09_JPRB, &
  & 0.16996088E-09_JPRB, 0.16996177E-09_JPRB, 0.16996138E-09_JPRB, 0.16996074E-09_JPRB, 0.16996042E-09_JPRB, 0.16995932E-09_JPRB, &
  & 0.16995820E-09_JPRB, 0.16995659E-09_JPRB, 0.16995662E-09_JPRB, 0.16995497E-09_JPRB, 0.16995066E-09_JPRB, 0.16994234E-09_JPRB, &
  & 0.16993809E-09_JPRB, 0.16993000E-09_JPRB, 0.16992162E-09_JPRB, 0.16991428E-09_JPRB, 0.16990624E-09_JPRB, 0.16990398E-09_JPRB, &
  & 0.16990384E-09_JPRB, 0.16990127E-09_JPRB, 0.16990380E-09_JPRB, 0.16990748E-09_JPRB, 0.16991036E-09_JPRB, 0.16991496E-09_JPRB, &
  & 0.16991969E-09_JPRB, 0.16992457E-09_JPRB, 0.16992896E-09_JPRB, 0.16992671E-09_JPRB, 0.16992908E-09_JPRB, 0.16992870E-09_JPRB, &
  & 0.16992760E-09_JPRB, 0.16992475E-09_JPRB, 0.16992524E-09_JPRB, 0.16992312E-09_JPRB, 0.16992234E-09_JPRB, 0.16991990E-09_JPRB, &
  & 0.16992174E-09_JPRB, 0.16992319E-09_JPRB, 0.16992611E-09_JPRB, 0.16992917E-09_JPRB, 0.16993074E-09_JPRB, 0.16993351E-09_JPRB, &
  & 0.16993729E-09_JPRB, 0.16994131E-09_JPRB, 0.16994468E-09_JPRB, 0.16994590E-09_JPRB, 0.16994992E-09_JPRB, 0.16995055E-09_JPRB, &
  & 0.16995097E-09_JPRB, 0.16995234E-09_JPRB, 0.16995215E-09_JPRB, 0.16995111E-09_JPRB, 0.16995032E-09_JPRB, 0.16994828E-09_JPRB, &
  & 0.16994813E-09_JPRB, 0.16994708E-09_JPRB, 0.16994171E-09_JPRB, 0.16994479E-09_JPRB /)

RGHG8(:,91, 9) = (/ &
  & 0.16995323E-09_JPRB, 0.16994890E-09_JPRB, 0.16995053E-09_JPRB, 0.16995549E-09_JPRB, 0.16996243E-09_JPRB, 0.16995960E-09_JPRB, &
  & 0.16996034E-09_JPRB, 0.16996268E-09_JPRB, 0.16996202E-09_JPRB, 0.16996043E-09_JPRB, 0.16996157E-09_JPRB, 0.16995946E-09_JPRB, &
  & 0.16995853E-09_JPRB, 0.16995493E-09_JPRB, 0.16995774E-09_JPRB, 0.16995613E-09_JPRB, 0.16995130E-09_JPRB, 0.16994064E-09_JPRB, &
  & 0.16993836E-09_JPRB, 0.16992971E-09_JPRB, 0.16992145E-09_JPRB, 0.16991429E-09_JPRB, 0.16990588E-09_JPRB, 0.16990384E-09_JPRB, &
  & 0.16990399E-09_JPRB, 0.16990095E-09_JPRB, 0.16990373E-09_JPRB, 0.16990752E-09_JPRB, 0.16991020E-09_JPRB, 0.16991487E-09_JPRB, &
  & 0.16991972E-09_JPRB, 0.16992462E-09_JPRB, 0.16992968E-09_JPRB, 0.16992632E-09_JPRB, 0.16992933E-09_JPRB, 0.16992881E-09_JPRB, &
  & 0.16992777E-09_JPRB, 0.16992451E-09_JPRB, 0.16992545E-09_JPRB, 0.16992306E-09_JPRB, 0.16992251E-09_JPRB, 0.16991958E-09_JPRB, &
  & 0.16992177E-09_JPRB, 0.16992312E-09_JPRB, 0.16992617E-09_JPRB, 0.16992929E-09_JPRB, 0.16993068E-09_JPRB, 0.16993347E-09_JPRB, &
  & 0.16993730E-09_JPRB, 0.16994138E-09_JPRB, 0.16994488E-09_JPRB, 0.16994572E-09_JPRB, 0.16995017E-09_JPRB, 0.16995055E-09_JPRB, &
  & 0.16995096E-09_JPRB, 0.16995250E-09_JPRB, 0.16995222E-09_JPRB, 0.16995109E-09_JPRB, 0.16995039E-09_JPRB, 0.16994815E-09_JPRB, &
  & 0.16994821E-09_JPRB, 0.16994722E-09_JPRB, 0.16994137E-09_JPRB, 0.16994485E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART18',1,ZHOOK_HANDLE)
END SUBROUTINE PART18






SUBROUTINE PART19
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART19',0,ZHOOK_HANDLE)



!-- Month= 10 ------------

RGHG8(:, 1,10) = (/ &
  & 0.38499863E-10_JPRB, 0.38483869E-10_JPRB, 0.38475931E-10_JPRB, 0.38477173E-10_JPRB, 0.38484910E-10_JPRB, 0.38497899E-10_JPRB, &
  & 0.38514799E-10_JPRB, 0.38535855E-10_JPRB, 0.38561522E-10_JPRB, 0.38595058E-10_JPRB, 0.38637461E-10_JPRB, 0.38692077E-10_JPRB, &
  & 0.38756141E-10_JPRB, 0.38826938E-10_JPRB, 0.38903273E-10_JPRB, 0.38987508E-10_JPRB, 0.39077283E-10_JPRB, 0.39168804E-10_JPRB, &
  & 0.39254669E-10_JPRB, 0.39327555E-10_JPRB, 0.39383052E-10_JPRB, 0.39419169E-10_JPRB, 0.39435760E-10_JPRB, 0.39437884E-10_JPRB, &
  & 0.39428412E-10_JPRB, 0.39409545E-10_JPRB, 0.39381314E-10_JPRB, 0.39338605E-10_JPRB, 0.39279711E-10_JPRB, 0.39201271E-10_JPRB, &
  & 0.39099661E-10_JPRB, 0.38973470E-10_JPRB, 0.38819087E-10_JPRB, 0.38634020E-10_JPRB, 0.38413026E-10_JPRB, 0.38169950E-10_JPRB, &
  & 0.37959871E-10_JPRB, 0.37945865E-10_JPRB, 0.38182641E-10_JPRB, 0.38610184E-10_JPRB, 0.39112252E-10_JPRB, 0.39500177E-10_JPRB, &
  & 0.39766770E-10_JPRB, 0.39963335E-10_JPRB, 0.40114134E-10_JPRB, 0.40231124E-10_JPRB, 0.40318904E-10_JPRB, 0.40373357E-10_JPRB, &
  & 0.40385181E-10_JPRB, 0.40347215E-10_JPRB, 0.40253762E-10_JPRB, 0.40108000E-10_JPRB, 0.39917552E-10_JPRB, 0.39697214E-10_JPRB, &
  & 0.39465837E-10_JPRB, 0.39243456E-10_JPRB, 0.39044979E-10_JPRB, 0.38876829E-10_JPRB, 0.38738884E-10_JPRB, 0.38629058E-10_JPRB, &
  & 0.38545132E-10_JPRB, 0.38485416E-10_JPRB, 0.38452904E-10_JPRB, 0.38437257E-10_JPRB /)

RGHG8(:, 2,10) = (/ &
  & 0.39039702E-10_JPRB, 0.38991709E-10_JPRB, 0.38968485E-10_JPRB, 0.38956553E-10_JPRB, 0.38955790E-10_JPRB, 0.38969369E-10_JPRB, &
  & 0.38999415E-10_JPRB, 0.39045666E-10_JPRB, 0.39105337E-10_JPRB, 0.39177495E-10_JPRB, 0.39262073E-10_JPRB, 0.39363263E-10_JPRB, &
  & 0.39483763E-10_JPRB, 0.39623343E-10_JPRB, 0.39773247E-10_JPRB, 0.39919998E-10_JPRB, 0.40060580E-10_JPRB, 0.40195187E-10_JPRB, &
  & 0.40313024E-10_JPRB, 0.40401224E-10_JPRB, 0.40451770E-10_JPRB, 0.40464208E-10_JPRB, 0.40442566E-10_JPRB, 0.40394008E-10_JPRB, &
  & 0.40322690E-10_JPRB, 0.40231908E-10_JPRB, 0.40118998E-10_JPRB, 0.39980096E-10_JPRB, 0.39814631E-10_JPRB, 0.39631808E-10_JPRB, &
  & 0.39440669E-10_JPRB, 0.39248230E-10_JPRB, 0.39050565E-10_JPRB, 0.38849701E-10_JPRB, 0.38661217E-10_JPRB, 0.38520923E-10_JPRB, &
  & 0.38486183E-10_JPRB, 0.38607777E-10_JPRB, 0.38893219E-10_JPRB, 0.39301073E-10_JPRB, 0.39772872E-10_JPRB, 0.40205755E-10_JPRB, &
  & 0.40546795E-10_JPRB, 0.40792543E-10_JPRB, 0.40957189E-10_JPRB, 0.41055295E-10_JPRB, 0.41098458E-10_JPRB, 0.41098226E-10_JPRB, &
  & 0.41063986E-10_JPRB, 0.41005286E-10_JPRB, 0.40924659E-10_JPRB, 0.40808423E-10_JPRB, 0.40635231E-10_JPRB, 0.40398043E-10_JPRB, &
  & 0.40112396E-10_JPRB, 0.39814541E-10_JPRB, 0.39536624E-10_JPRB, 0.39298915E-10_JPRB, 0.39107786E-10_JPRB, 0.38961910E-10_JPRB, &
  & 0.38855894E-10_JPRB, 0.38783692E-10_JPRB, 0.38736729E-10_JPRB, 0.38699786E-10_JPRB /)

RGHG8(:, 3,10) = (/ &
  & 0.39438015E-10_JPRB, 0.39423416E-10_JPRB, 0.39430587E-10_JPRB, 0.39452230E-10_JPRB, 0.39488704E-10_JPRB, 0.39541096E-10_JPRB, &
  & 0.39609430E-10_JPRB, 0.39697752E-10_JPRB, 0.39804039E-10_JPRB, 0.39932758E-10_JPRB, 0.40079107E-10_JPRB, 0.40240040E-10_JPRB, &
  & 0.40409398E-10_JPRB, 0.40587936E-10_JPRB, 0.40778585E-10_JPRB, 0.40968375E-10_JPRB, 0.41145268E-10_JPRB, 0.41301251E-10_JPRB, &
  & 0.41430435E-10_JPRB, 0.41522265E-10_JPRB, 0.41556782E-10_JPRB, 0.41523368E-10_JPRB, 0.41423583E-10_JPRB, 0.41276538E-10_JPRB, &
  & 0.41092331E-10_JPRB, 0.40874297E-10_JPRB, 0.40631182E-10_JPRB, 0.40360156E-10_JPRB, 0.40078520E-10_JPRB, 0.39802467E-10_JPRB, &
  & 0.39546453E-10_JPRB, 0.39307460E-10_JPRB, 0.39082720E-10_JPRB, 0.38906919E-10_JPRB, 0.38838582E-10_JPRB, 0.38923819E-10_JPRB, &
  & 0.39173734E-10_JPRB, 0.39567651E-10_JPRB, 0.40073035E-10_JPRB, 0.40650667E-10_JPRB, 0.41235928E-10_JPRB, 0.41759658E-10_JPRB, &
  & 0.42164734E-10_JPRB, 0.42438813E-10_JPRB, 0.42590795E-10_JPRB, 0.42638556E-10_JPRB, 0.42601044E-10_JPRB, 0.42494751E-10_JPRB, &
  & 0.42333765E-10_JPRB, 0.42127142E-10_JPRB, 0.41872238E-10_JPRB, 0.41564727E-10_JPRB, 0.41212974E-10_JPRB, 0.40839446E-10_JPRB, &
  & 0.40465655E-10_JPRB, 0.40107612E-10_JPRB, 0.39783149E-10_JPRB, 0.39503744E-10_JPRB, 0.39276034E-10_JPRB, 0.39098294E-10_JPRB, &
  & 0.38966823E-10_JPRB, 0.38875580E-10_JPRB, 0.38815638E-10_JPRB, 0.38765803E-10_JPRB /)

RGHG8(:, 4,10) = (/ &
  & 0.39689363E-10_JPRB, 0.39727860E-10_JPRB, 0.39778361E-10_JPRB, 0.39853142E-10_JPRB, 0.39956243E-10_JPRB, 0.40084228E-10_JPRB, &
  & 0.40232019E-10_JPRB, 0.40391940E-10_JPRB, 0.40567338E-10_JPRB, 0.40760926E-10_JPRB, 0.40970078E-10_JPRB, 0.41192928E-10_JPRB, &
  & 0.41420686E-10_JPRB, 0.41641707E-10_JPRB, 0.41847643E-10_JPRB, 0.42041072E-10_JPRB, 0.42226674E-10_JPRB, 0.42396243E-10_JPRB, &
  & 0.42538015E-10_JPRB, 0.42633355E-10_JPRB, 0.42660341E-10_JPRB, 0.42602408E-10_JPRB, 0.42432863E-10_JPRB, 0.42154929E-10_JPRB, &
  & 0.41808747E-10_JPRB, 0.41423337E-10_JPRB, 0.41004134E-10_JPRB, 0.40593813E-10_JPRB, 0.40215907E-10_JPRB, 0.39889432E-10_JPRB, &
  & 0.39605048E-10_JPRB, 0.39380960E-10_JPRB, 0.39263710E-10_JPRB, 0.39299314E-10_JPRB, 0.39518715E-10_JPRB, 0.39924033E-10_JPRB, &
  & 0.40489539E-10_JPRB, 0.41179133E-10_JPRB, 0.41951744E-10_JPRB, 0.42755820E-10_JPRB, 0.43517339E-10_JPRB, 0.44137725E-10_JPRB, &
  & 0.44564942E-10_JPRB, 0.44793804E-10_JPRB, 0.44850970E-10_JPRB, 0.44773813E-10_JPRB, 0.44595053E-10_JPRB, 0.44340621E-10_JPRB, &
  & 0.44027941E-10_JPRB, 0.43664364E-10_JPRB, 0.43248995E-10_JPRB, 0.42786209E-10_JPRB, 0.42284891E-10_JPRB, 0.41749680E-10_JPRB, &
  & 0.41187248E-10_JPRB, 0.40627453E-10_JPRB, 0.40105606E-10_JPRB, 0.39658075E-10_JPRB, 0.39295074E-10_JPRB, 0.39015298E-10_JPRB, &
  & 0.38809751E-10_JPRB, 0.38666490E-10_JPRB, 0.38565498E-10_JPRB, 0.38479525E-10_JPRB /)

RGHG8(:, 5,10) = (/ &
  & 0.39890286E-10_JPRB, 0.40026767E-10_JPRB, 0.40171221E-10_JPRB, 0.40343243E-10_JPRB, 0.40538455E-10_JPRB, 0.40752648E-10_JPRB, &
  & 0.40977124E-10_JPRB, 0.41211354E-10_JPRB, 0.41455842E-10_JPRB, 0.41713903E-10_JPRB, 0.41982872E-10_JPRB, 0.42253173E-10_JPRB, &
  & 0.42515942E-10_JPRB, 0.42769073E-10_JPRB, 0.43008361E-10_JPRB, 0.43227172E-10_JPRB, 0.43421759E-10_JPRB, 0.43599690E-10_JPRB, &
  & 0.43768725E-10_JPRB, 0.43913595E-10_JPRB, 0.43992726E-10_JPRB, 0.43959072E-10_JPRB, 0.43787474E-10_JPRB, 0.43485344E-10_JPRB, &
  & 0.43062207E-10_JPRB, 0.42586500E-10_JPRB, 0.42132145E-10_JPRB, 0.41734373E-10_JPRB, 0.41418428E-10_JPRB, 0.41200581E-10_JPRB, &
  & 0.41102455E-10_JPRB, 0.41135019E-10_JPRB, 0.41305268E-10_JPRB, 0.41630782E-10_JPRB, 0.42116987E-10_JPRB, 0.42757107E-10_JPRB, &
  & 0.43532750E-10_JPRB, 0.44403432E-10_JPRB, 0.45320178E-10_JPRB, 0.46203062E-10_JPRB, 0.46949011E-10_JPRB, 0.47472370E-10_JPRB, &
  & 0.47741727E-10_JPRB, 0.47780564E-10_JPRB, 0.47640725E-10_JPRB, 0.47373692E-10_JPRB, 0.47017230E-10_JPRB, 0.46593854E-10_JPRB, &
  & 0.46113342E-10_JPRB, 0.45577042E-10_JPRB, 0.44984311E-10_JPRB, 0.44336475E-10_JPRB, 0.43632077E-10_JPRB, 0.42872560E-10_JPRB, &
  & 0.42074878E-10_JPRB, 0.41270199E-10_JPRB, 0.40512968E-10_JPRB, 0.39846855E-10_JPRB, 0.39308948E-10_JPRB, 0.38899106E-10_JPRB, &
  & 0.38598007E-10_JPRB, 0.38385316E-10_JPRB, 0.38235869E-10_JPRB, 0.38091648E-10_JPRB /)

RGHG8(:, 6,10) = (/ &
  & 0.40193245E-10_JPRB, 0.40451961E-10_JPRB, 0.40683752E-10_JPRB, 0.40933160E-10_JPRB, 0.41200328E-10_JPRB, 0.41482540E-10_JPRB, &
  & 0.41768582E-10_JPRB, 0.42062520E-10_JPRB, 0.42362974E-10_JPRB, 0.42673275E-10_JPRB, 0.42985261E-10_JPRB, 0.43295312E-10_JPRB, &
  & 0.43593438E-10_JPRB, 0.43869550E-10_JPRB, 0.44122921E-10_JPRB, 0.44362854E-10_JPRB, 0.44597326E-10_JPRB, 0.44828571E-10_JPRB, &
  & 0.45049055E-10_JPRB, 0.45252808E-10_JPRB, 0.45438937E-10_JPRB, 0.45589189E-10_JPRB, 0.45656021E-10_JPRB, 0.45612236E-10_JPRB, &
  & 0.45478111E-10_JPRB, 0.45307334E-10_JPRB, 0.45164369E-10_JPRB, 0.45098026E-10_JPRB, 0.45135735E-10_JPRB, 0.45290938E-10_JPRB, &
  & 0.45564490E-10_JPRB, 0.45938617E-10_JPRB, 0.46376146E-10_JPRB, 0.46859676E-10_JPRB, 0.47388257E-10_JPRB, 0.47956483E-10_JPRB, &
  & 0.48587353E-10_JPRB, 0.49278564E-10_JPRB, 0.49985995E-10_JPRB, 0.50636634E-10_JPRB, 0.51124091E-10_JPRB, 0.51369645E-10_JPRB, &
  & 0.51360229E-10_JPRB, 0.51141636E-10_JPRB, 0.50781310E-10_JPRB, 0.50328450E-10_JPRB, 0.49811294E-10_JPRB, 0.49239484E-10_JPRB, &
  & 0.48611105E-10_JPRB, 0.47919474E-10_JPRB, 0.47154634E-10_JPRB, 0.46308374E-10_JPRB, 0.45376446E-10_JPRB, 0.44368037E-10_JPRB, &
  & 0.43304652E-10_JPRB, 0.42243108E-10_JPRB, 0.41246062E-10_JPRB, 0.40392120E-10_JPRB, 0.39716411E-10_JPRB, 0.39214920E-10_JPRB, &
  & 0.38854336E-10_JPRB, 0.38602128E-10_JPRB, 0.38404523E-10_JPRB, 0.38213932E-10_JPRB /)

RGHG8(:, 7,10) = (/ &
  & 0.40583283E-10_JPRB, 0.40925714E-10_JPRB, 0.41219472E-10_JPRB, 0.41522012E-10_JPRB, 0.41843536E-10_JPRB, 0.42178788E-10_JPRB, &
  & 0.42519582E-10_JPRB, 0.42859653E-10_JPRB, 0.43208059E-10_JPRB, 0.43562050E-10_JPRB, 0.43919930E-10_JPRB, 0.44270875E-10_JPRB, &
  & 0.44606697E-10_JPRB, 0.44924231E-10_JPRB, 0.45220418E-10_JPRB, 0.45496419E-10_JPRB, 0.45763043E-10_JPRB, 0.46043381E-10_JPRB, &
  & 0.46366119E-10_JPRB, 0.46752820E-10_JPRB, 0.47196951E-10_JPRB, 0.47658041E-10_JPRB, 0.48090466E-10_JPRB, 0.48461329E-10_JPRB, &
  & 0.48769971E-10_JPRB, 0.49048390E-10_JPRB, 0.49340285E-10_JPRB, 0.49687865E-10_JPRB, 0.50108351E-10_JPRB, 0.50604514E-10_JPRB, &
  & 0.51165683E-10_JPRB, 0.51763639E-10_JPRB, 0.52331799E-10_JPRB, 0.52842734E-10_JPRB, 0.53313499E-10_JPRB, 0.53739912E-10_JPRB, &
  & 0.54158428E-10_JPRB, 0.54589513E-10_JPRB, 0.55008380E-10_JPRB, 0.55360539E-10_JPRB, 0.55560358E-10_JPRB, 0.55529473E-10_JPRB, &
  & 0.55263124E-10_JPRB, 0.54829058E-10_JPRB, 0.54292265E-10_JPRB, 0.53701123E-10_JPRB, 0.53071800E-10_JPRB, 0.52401430E-10_JPRB, &
  & 0.51676188E-10_JPRB, 0.50874735E-10_JPRB, 0.49973095E-10_JPRB, 0.48953522E-10_JPRB, 0.47812063E-10_JPRB, 0.46562171E-10_JPRB, &
  & 0.45254391E-10_JPRB, 0.43957758E-10_JPRB, 0.42775831E-10_JPRB, 0.41774476E-10_JPRB, 0.40988293E-10_JPRB, 0.40401005E-10_JPRB, &
  & 0.39976876E-10_JPRB, 0.39666253E-10_JPRB, 0.39429533E-10_JPRB, 0.39161452E-10_JPRB /)

RGHG8(:, 8,10) = (/ &
  & 0.41087835E-10_JPRB, 0.41490918E-10_JPRB, 0.41802704E-10_JPRB, 0.42131257E-10_JPRB, 0.42476134E-10_JPRB, 0.42846900E-10_JPRB, &
  & 0.43223126E-10_JPRB, 0.43607624E-10_JPRB, 0.43996938E-10_JPRB, 0.44395855E-10_JPRB, 0.44799039E-10_JPRB, 0.45200611E-10_JPRB, &
  & 0.45591159E-10_JPRB, 0.45963792E-10_JPRB, 0.46317165E-10_JPRB, 0.46658066E-10_JPRB, 0.47000404E-10_JPRB, 0.47362843E-10_JPRB, &
  & 0.47764771E-10_JPRB, 0.48232904E-10_JPRB, 0.48801664E-10_JPRB, 0.49491376E-10_JPRB, 0.50271093E-10_JPRB, 0.51102175E-10_JPRB, &
  & 0.51958868E-10_JPRB, 0.52814465E-10_JPRB, 0.53676522E-10_JPRB, 0.54546895E-10_JPRB, 0.55435177E-10_JPRB, 0.56331294E-10_JPRB, &
  & 0.57210254E-10_JPRB, 0.58033599E-10_JPRB, 0.58752843E-10_JPRB, 0.59341254E-10_JPRB, 0.59807541E-10_JPRB, 0.60152223E-10_JPRB, &
  & 0.60390810E-10_JPRB, 0.60561584E-10_JPRB, 0.60676769E-10_JPRB, 0.60713143E-10_JPRB, 0.60611030E-10_JPRB, 0.60297316E-10_JPRB, &
  & 0.59781541E-10_JPRB, 0.59121451E-10_JPRB, 0.58407626E-10_JPRB, 0.57677335E-10_JPRB, 0.56936070E-10_JPRB, 0.56166568E-10_JPRB, &
  & 0.55339476E-10_JPRB, 0.54419681E-10_JPRB, 0.53374132E-10_JPRB, 0.52180770E-10_JPRB, 0.50835162E-10_JPRB, 0.49367760E-10_JPRB, &
  & 0.47832585E-10_JPRB, 0.46339280E-10_JPRB, 0.44977043E-10_JPRB, 0.43825516E-10_JPRB, 0.42904531E-10_JPRB, 0.42198439E-10_JPRB, &
  & 0.41679396E-10_JPRB, 0.41292532E-10_JPRB, 0.40999062E-10_JPRB, 0.40651055E-10_JPRB /)

RGHG8(:, 9,10) = (/ &
  & 0.41691206E-10_JPRB, 0.42090456E-10_JPRB, 0.42413569E-10_JPRB, 0.42740846E-10_JPRB, 0.43105068E-10_JPRB, 0.43504294E-10_JPRB, &
  & 0.43923212E-10_JPRB, 0.44350704E-10_JPRB, 0.44788184E-10_JPRB, 0.45233758E-10_JPRB, 0.45686420E-10_JPRB, 0.46140328E-10_JPRB, &
  & 0.46584958E-10_JPRB, 0.47012581E-10_JPRB, 0.47423288E-10_JPRB, 0.47824883E-10_JPRB, 0.48232585E-10_JPRB, 0.48674665E-10_JPRB, &
  & 0.49195498E-10_JPRB, 0.49854721E-10_JPRB, 0.50708163E-10_JPRB, 0.51774619E-10_JPRB, 0.53028811E-10_JPRB, 0.54411718E-10_JPRB, &
  & 0.55838899E-10_JPRB, 0.57260537E-10_JPRB, 0.58628789E-10_JPRB, 0.59931830E-10_JPRB, 0.61176827E-10_JPRB, 0.62399710E-10_JPRB, &
  & 0.63655456E-10_JPRB, 0.64879428E-10_JPRB, 0.65942446E-10_JPRB, 0.66771165E-10_JPRB, 0.67329850E-10_JPRB, 0.67628889E-10_JPRB, &
  & 0.67733666E-10_JPRB, 0.67706583E-10_JPRB, 0.67575487E-10_JPRB, 0.67331751E-10_JPRB, 0.66935325E-10_JPRB, 0.66350772E-10_JPRB, &
  & 0.65563763E-10_JPRB, 0.64660804E-10_JPRB, 0.63711814E-10_JPRB, 0.62762885E-10_JPRB, 0.61807386E-10_JPRB, 0.60814097E-10_JPRB, &
  & 0.59745348E-10_JPRB, 0.58563231E-10_JPRB, 0.57230439E-10_JPRB, 0.55724952E-10_JPRB, 0.54053650E-10_JPRB, 0.52257244E-10_JPRB, &
  & 0.50429369E-10_JPRB, 0.48670405E-10_JPRB, 0.47094609E-10_JPRB, 0.45757734E-10_JPRB, 0.44682827E-10_JPRB, 0.43857869E-10_JPRB, &
  & 0.43234319E-10_JPRB, 0.42809298E-10_JPRB, 0.42430975E-10_JPRB, 0.42087289E-10_JPRB /)

RGHG8(:,10,10) = (/ &
  & 0.42443993E-10_JPRB, 0.42875307E-10_JPRB, 0.43186687E-10_JPRB, 0.43523525E-10_JPRB, 0.43896258E-10_JPRB, 0.44323090E-10_JPRB, &
  & 0.44781560E-10_JPRB, 0.45260962E-10_JPRB, 0.45754019E-10_JPRB, 0.46259357E-10_JPRB, 0.46774584E-10_JPRB, 0.47296358E-10_JPRB, &
  & 0.47815849E-10_JPRB, 0.48320285E-10_JPRB, 0.48799277E-10_JPRB, 0.49258750E-10_JPRB, 0.49726001E-10_JPRB, 0.50241568E-10_JPRB, &
  & 0.50849502E-10_JPRB, 0.51603683E-10_JPRB, 0.52563585E-10_JPRB, 0.53770599E-10_JPRB, 0.55218937E-10_JPRB, 0.56856072E-10_JPRB, &
  & 0.58618180E-10_JPRB, 0.60446197E-10_JPRB, 0.62324750E-10_JPRB, 0.64262470E-10_JPRB, 0.66296510E-10_JPRB, 0.68358388E-10_JPRB, &
  & 0.70246642E-10_JPRB, 0.71961902E-10_JPRB, 0.73462667E-10_JPRB, 0.74648995E-10_JPRB, 0.75485299E-10_JPRB, 0.75987723E-10_JPRB, &
  & 0.76196466E-10_JPRB, 0.76148532E-10_JPRB, 0.75895887E-10_JPRB, 0.75468319E-10_JPRB, 0.74874704E-10_JPRB, 0.74078653E-10_JPRB, &
  & 0.73077565E-10_JPRB, 0.71910783E-10_JPRB, 0.70646912E-10_JPRB, 0.69348013E-10_JPRB, 0.68013879E-10_JPRB, 0.66619224E-10_JPRB, &
  & 0.65120694E-10_JPRB, 0.63472727E-10_JPRB, 0.61645425E-10_JPRB, 0.59622335E-10_JPRB, 0.57427559E-10_JPRB, 0.55141114E-10_JPRB, &
  & 0.52874406E-10_JPRB, 0.50771276E-10_JPRB, 0.48925940E-10_JPRB, 0.47393478E-10_JPRB, 0.46175619E-10_JPRB, 0.45243035E-10_JPRB, &
  & 0.44588173E-10_JPRB, 0.44061813E-10_JPRB, 0.43729013E-10_JPRB, 0.43249779E-10_JPRB /)

RGHG8(:,11,10) = (/ &
  & 0.43488071E-10_JPRB, 0.43955502E-10_JPRB, 0.44312130E-10_JPRB, 0.44673577E-10_JPRB, 0.45092239E-10_JPRB, 0.45578780E-10_JPRB, &
  & 0.46120066E-10_JPRB, 0.46701375E-10_JPRB, 0.47312723E-10_JPRB, 0.47947903E-10_JPRB, 0.48602868E-10_JPRB, 0.49274383E-10_JPRB, &
  & 0.49955238E-10_JPRB, 0.50635780E-10_JPRB, 0.51303951E-10_JPRB, 0.51946142E-10_JPRB, 0.52557795E-10_JPRB, 0.53166919E-10_JPRB, &
  & 0.53828580E-10_JPRB, 0.54609754E-10_JPRB, 0.55583385E-10_JPRB, 0.56804134E-10_JPRB, 0.58286306E-10_JPRB, 0.60019531E-10_JPRB, &
  & 0.61942319E-10_JPRB, 0.64012698E-10_JPRB, 0.66219592E-10_JPRB, 0.68509837E-10_JPRB, 0.70840500E-10_JPRB, 0.73218751E-10_JPRB, &
  & 0.75701397E-10_JPRB, 0.78092456E-10_JPRB, 0.80250327E-10_JPRB, 0.82066826E-10_JPRB, 0.83462896E-10_JPRB, 0.84393173E-10_JPRB, &
  & 0.84890484E-10_JPRB, 0.85014933E-10_JPRB, 0.84854984E-10_JPRB, 0.84456185E-10_JPRB, 0.83834467E-10_JPRB, 0.82972663E-10_JPRB, &
  & 0.81847536E-10_JPRB, 0.80477208E-10_JPRB, 0.78909893E-10_JPRB, 0.77216476E-10_JPRB, 0.75425763E-10_JPRB, 0.73531813E-10_JPRB, &
  & 0.71497502E-10_JPRB, 0.69286854E-10_JPRB, 0.66867928E-10_JPRB, 0.64252104E-10_JPRB, 0.61488308E-10_JPRB, 0.58693078E-10_JPRB, &
  & 0.56023009E-10_JPRB, 0.53618311E-10_JPRB, 0.51570050E-10_JPRB, 0.49900147E-10_JPRB, 0.48587530E-10_JPRB, 0.47598637E-10_JPRB, &
  & 0.46837399E-10_JPRB, 0.46344782E-10_JPRB, 0.45834343E-10_JPRB, 0.45394011E-10_JPRB /)

RGHG8(:,12,10) = (/ &
  & 0.44896569E-10_JPRB, 0.45511747E-10_JPRB, 0.45937736E-10_JPRB, 0.46390398E-10_JPRB, 0.46900178E-10_JPRB, 0.47501614E-10_JPRB, &
  & 0.48183527E-10_JPRB, 0.48930630E-10_JPRB, 0.49726150E-10_JPRB, 0.50556930E-10_JPRB, 0.51414789E-10_JPRB, 0.52291012E-10_JPRB, &
  & 0.53177192E-10_JPRB, 0.54056967E-10_JPRB, 0.54924260E-10_JPRB, 0.55792773E-10_JPRB, 0.56659739E-10_JPRB, 0.57529814E-10_JPRB, &
  & 0.58437089E-10_JPRB, 0.59426644E-10_JPRB, 0.60547505E-10_JPRB, 0.61823907E-10_JPRB, 0.63318455E-10_JPRB, 0.64997716E-10_JPRB, &
  & 0.66841990E-10_JPRB, 0.68857184E-10_JPRB, 0.71052310E-10_JPRB, 0.73427542E-10_JPRB, 0.76019906E-10_JPRB, 0.78787324E-10_JPRB, &
  & 0.81553840E-10_JPRB, 0.84308290E-10_JPRB, 0.86911776E-10_JPRB, 0.89215677E-10_JPRB, 0.91061159E-10_JPRB, 0.92380249E-10_JPRB, &
  & 0.93184085E-10_JPRB, 0.93545199E-10_JPRB, 0.93545213E-10_JPRB, 0.93242719E-10_JPRB, 0.92661774E-10_JPRB, 0.91796584E-10_JPRB, &
  & 0.90628387E-10_JPRB, 0.89159929E-10_JPRB, 0.87410898E-10_JPRB, 0.85453297E-10_JPRB, 0.83337892E-10_JPRB, 0.81081267E-10_JPRB, &
  & 0.78680416E-10_JPRB, 0.76107773E-10_JPRB, 0.73367548E-10_JPRB, 0.70471760E-10_JPRB, 0.67499173E-10_JPRB, 0.64574866E-10_JPRB, &
  & 0.61849456E-10_JPRB, 0.59444422E-10_JPRB, 0.57412790E-10_JPRB, 0.55750651E-10_JPRB, 0.54412818E-10_JPRB, 0.53353662E-10_JPRB, &
  & 0.52557160E-10_JPRB, 0.51851672E-10_JPRB, 0.51334884E-10_JPRB, 0.50360226E-10_JPRB /)

RGHG8(:,13,10) = (/ &
  & 0.46852022E-10_JPRB, 0.47701801E-10_JPRB, 0.48326863E-10_JPRB, 0.48959156E-10_JPRB, 0.49690960E-10_JPRB, 0.50556354E-10_JPRB, &
  & 0.51561096E-10_JPRB, 0.52690952E-10_JPRB, 0.53921381E-10_JPRB, 0.55225824E-10_JPRB, 0.56582322E-10_JPRB, 0.57969178E-10_JPRB, &
  & 0.59370245E-10_JPRB, 0.60769750E-10_JPRB, 0.62130689E-10_JPRB, 0.63441669E-10_JPRB, 0.64712229E-10_JPRB, 0.65949676E-10_JPRB, &
  & 0.67173135E-10_JPRB, 0.68405420E-10_JPRB, 0.69652208E-10_JPRB, 0.70926168E-10_JPRB, 0.72241955E-10_JPRB, 0.73580392E-10_JPRB, &
  & 0.74955264E-10_JPRB, 0.76450943E-10_JPRB, 0.78130474E-10_JPRB, 0.80065100E-10_JPRB, 0.82276873E-10_JPRB, 0.84785227E-10_JPRB, &
  & 0.87595084E-10_JPRB, 0.90529542E-10_JPRB, 0.93404381E-10_JPRB, 0.96009901E-10_JPRB, 0.98182198E-10_JPRB, 0.99815683E-10_JPRB, &
  & 0.10089896E-09_JPRB, 0.10147581E-09_JPRB, 0.10162340E-09_JPRB, 0.10140766E-09_JPRB, 0.10086459E-09_JPRB, 0.99998287E-10_JPRB, &
  & 0.98807337E-10_JPRB, 0.97290266E-10_JPRB, 0.95483350E-10_JPRB, 0.93438431E-10_JPRB, 0.91217311E-10_JPRB, 0.88868655E-10_JPRB, &
  & 0.86410566E-10_JPRB, 0.83861987E-10_JPRB, 0.81226803E-10_JPRB, 0.78546662E-10_JPRB, 0.75874064E-10_JPRB, 0.73306985E-10_JPRB, &
  & 0.70940670E-10_JPRB, 0.68845651E-10_JPRB, 0.67038534E-10_JPRB, 0.65506552E-10_JPRB, 0.64202851E-10_JPRB, 0.63123243E-10_JPRB, &
  & 0.62167660E-10_JPRB, 0.61437251E-10_JPRB, 0.60524002E-10_JPRB, 0.59411094E-10_JPRB /)

RGHG8(:,14,10) = (/ &
  & 0.49346735E-10_JPRB, 0.50577275E-10_JPRB, 0.51455527E-10_JPRB, 0.52376777E-10_JPRB, 0.53426617E-10_JPRB, 0.54674279E-10_JPRB, &
  & 0.56132932E-10_JPRB, 0.57788906E-10_JPRB, 0.59604176E-10_JPRB, 0.61530961E-10_JPRB, 0.63524783E-10_JPRB, 0.65544820E-10_JPRB, &
  & 0.67559576E-10_JPRB, 0.69551698E-10_JPRB, 0.71498307E-10_JPRB, 0.73368450E-10_JPRB, 0.75160364E-10_JPRB, 0.76875152E-10_JPRB, &
  & 0.78514133E-10_JPRB, 0.80075738E-10_JPRB, 0.81531747E-10_JPRB, 0.82850157E-10_JPRB, 0.84019000E-10_JPRB, 0.85017632E-10_JPRB, &
  & 0.85872351E-10_JPRB, 0.86697503E-10_JPRB, 0.87617191E-10_JPRB, 0.88751145E-10_JPRB, 0.90281456E-10_JPRB, 0.92293125E-10_JPRB, &
  & 0.94715465E-10_JPRB, 0.97395800E-10_JPRB, 0.10016060E-09_JPRB, 0.10279722E-09_JPRB, 0.10510345E-09_JPRB, 0.10694551E-09_JPRB, &
  & 0.10825036E-09_JPRB, 0.10902376E-09_JPRB, 0.10931574E-09_JPRB, 0.10918658E-09_JPRB, 0.10867623E-09_JPRB, 0.10779953E-09_JPRB, &
  & 0.10657641E-09_JPRB, 0.10503326E-09_JPRB, 0.10321609E-09_JPRB, 0.10119038E-09_JPRB, 0.99029084E-10_JPRB, 0.96787620E-10_JPRB, &
  & 0.94507881E-10_JPRB, 0.92216249E-10_JPRB, 0.89936995E-10_JPRB, 0.87684637E-10_JPRB, 0.85492516E-10_JPRB, 0.83405574E-10_JPRB, &
  & 0.81470018E-10_JPRB, 0.79715061E-10_JPRB, 0.78150222E-10_JPRB, 0.76762582E-10_JPRB, 0.75523705E-10_JPRB, 0.74436859E-10_JPRB, &
  & 0.73448525E-10_JPRB, 0.72569423E-10_JPRB, 0.71638293E-10_JPRB, 0.70102250E-10_JPRB /)

RGHG8(:,15,10) = (/ &
  & 0.52337513E-10_JPRB, 0.54017783E-10_JPRB, 0.55252778E-10_JPRB, 0.56531370E-10_JPRB, 0.58000889E-10_JPRB, 0.59735973E-10_JPRB, &
  & 0.61764489E-10_JPRB, 0.64067633E-10_JPRB, 0.66588665E-10_JPRB, 0.69248968E-10_JPRB, 0.71968639E-10_JPRB, 0.74678735E-10_JPRB, &
  & 0.77336915E-10_JPRB, 0.79919953E-10_JPRB, 0.82418218E-10_JPRB, 0.84808223E-10_JPRB, 0.87076436E-10_JPRB, 0.89221137E-10_JPRB, &
  & 0.91225853E-10_JPRB, 0.93077032E-10_JPRB, 0.94732763E-10_JPRB, 0.96128730E-10_JPRB, 0.97212960E-10_JPRB, 0.97959134E-10_JPRB, &
  & 0.98374558E-10_JPRB, 0.98548343E-10_JPRB, 0.98637799E-10_JPRB, 0.98888828E-10_JPRB, 0.99552873E-10_JPRB, 0.10073451E-09_JPRB, &
  & 0.10243978E-09_JPRB, 0.10463188E-09_JPRB, 0.10712255E-09_JPRB, 0.10965087E-09_JPRB, 0.11197449E-09_JPRB, 0.11392892E-09_JPRB, &
  & 0.11540376E-09_JPRB, 0.11636274E-09_JPRB, 0.11681991E-09_JPRB, 0.11680942E-09_JPRB, 0.11636122E-09_JPRB, 0.11550335E-09_JPRB, &
  & 0.11427746E-09_JPRB, 0.11273633E-09_JPRB, 0.11095372E-09_JPRB, 0.10900975E-09_JPRB, 0.10698347E-09_JPRB, 0.10493835E-09_JPRB, &
  & 0.10292044E-09_JPRB, 0.10095628E-09_JPRB, 0.99042621E-10_JPRB, 0.97178383E-10_JPRB, 0.95367936E-10_JPRB, 0.93630367E-10_JPRB, &
  & 0.91983629E-10_JPRB, 0.90450925E-10_JPRB, 0.89037493E-10_JPRB, 0.87742244E-10_JPRB, 0.86554527E-10_JPRB, 0.85465808E-10_JPRB, &
  & 0.84463235E-10_JPRB, 0.83536761E-10_JPRB, 0.82478205E-10_JPRB, 0.80777510E-10_JPRB /)

RGHG8(:,16,10) = (/ &
  & 0.55816955E-10_JPRB, 0.58036187E-10_JPRB, 0.59677513E-10_JPRB, 0.61388242E-10_JPRB, 0.63336593E-10_JPRB, 0.65616547E-10_JPRB, &
  & 0.68249392E-10_JPRB, 0.71206901E-10_JPRB, 0.74410131E-10_JPRB, 0.77757162E-10_JPRB, 0.81142690E-10_JPRB, 0.84472832E-10_JPRB, &
  & 0.87684485E-10_JPRB, 0.90751517E-10_JPRB, 0.93675172E-10_JPRB, 0.96457203E-10_JPRB, 0.99080327E-10_JPRB, 0.10154109E-09_JPRB, &
  & 0.10382493E-09_JPRB, 0.10590007E-09_JPRB, 0.10772126E-09_JPRB, 0.10920768E-09_JPRB, 0.11027471E-09_JPRB, 0.11087135E-09_JPRB, &
  & 0.11098748E-09_JPRB, 0.11068858E-09_JPRB, 0.11016515E-09_JPRB, 0.10973479E-09_JPRB, 0.10961720E-09_JPRB, 0.11004193E-09_JPRB, &
  & 0.11108172E-09_JPRB, 0.11265316E-09_JPRB, 0.11464635E-09_JPRB, 0.11683254E-09_JPRB, 0.11897308E-09_JPRB, 0.12087194E-09_JPRB, &
  & 0.12239398E-09_JPRB, 0.12346937E-09_JPRB, 0.12407178E-09_JPRB, 0.12420194E-09_JPRB, 0.12387334E-09_JPRB, 0.12310986E-09_JPRB, &
  & 0.12196409E-09_JPRB, 0.12051055E-09_JPRB, 0.11884084E-09_JPRB, 0.11705371E-09_JPRB, 0.11523349E-09_JPRB, 0.11344537E-09_JPRB, &
  & 0.11172357E-09_JPRB, 0.11006580E-09_JPRB, 0.10845223E-09_JPRB, 0.10686223E-09_JPRB, 0.10528528E-09_JPRB, 0.10372708E-09_JPRB, &
  & 0.10220599E-09_JPRB, 0.10074573E-09_JPRB, 0.99366293E-10_JPRB, 0.98077393E-10_JPRB, 0.96881503E-10_JPRB, 0.95775839E-10_JPRB, &
  & 0.94732014E-10_JPRB, 0.93781566E-10_JPRB, 0.92594772E-10_JPRB, 0.90897984E-10_JPRB /)

RGHG8(:,17,10) = (/ &
  & 0.59978189E-10_JPRB, 0.62828215E-10_JPRB, 0.64902438E-10_JPRB, 0.67061141E-10_JPRB, 0.69491371E-10_JPRB, 0.72294053E-10_JPRB, &
  & 0.75480358E-10_JPRB, 0.79002194E-10_JPRB, 0.82763352E-10_JPRB, 0.86640910E-10_JPRB, 0.90506345E-10_JPRB, 0.94252245E-10_JPRB, &
  & 0.97810246E-10_JPRB, 0.10115127E-09_JPRB, 0.10427792E-09_JPRB, 0.10720941E-09_JPRB, 0.10995230E-09_JPRB, 0.11250405E-09_JPRB, &
  & 0.11486175E-09_JPRB, 0.11700463E-09_JPRB, 0.11889442E-09_JPRB, 0.12046196E-09_JPRB, 0.12161541E-09_JPRB, 0.12227884E-09_JPRB, &
  & 0.12242296E-09_JPRB, 0.12208763E-09_JPRB, 0.12142104E-09_JPRB, 0.12065877E-09_JPRB, 0.12009091E-09_JPRB, 0.11999715E-09_JPRB, &
  & 0.12040831E-09_JPRB, 0.12136042E-09_JPRB, 0.12272741E-09_JPRB, 0.12436652E-09_JPRB, 0.12610311E-09_JPRB, 0.12773277E-09_JPRB, &
  & 0.12910817E-09_JPRB, 0.13015326E-09_JPRB, 0.13081156E-09_JPRB, 0.13105612E-09_JPRB, 0.13087713E-09_JPRB, 0.13028330E-09_JPRB, &
  & 0.12932054E-09_JPRB, 0.12806406E-09_JPRB, 0.12661663E-09_JPRB, 0.12508045E-09_JPRB, 0.12354123E-09_JPRB, 0.12205324E-09_JPRB, &
  & 0.12062935E-09_JPRB, 0.11924840E-09_JPRB, 0.11787588E-09_JPRB, 0.11647829E-09_JPRB, 0.11503672E-09_JPRB, 0.11355647E-09_JPRB, &
  & 0.11206029E-09_JPRB, 0.11058559E-09_JPRB, 0.10916533E-09_JPRB, 0.10782444E-09_JPRB, 0.10657467E-09_JPRB, 0.10541832E-09_JPRB, &
  & 0.10435479E-09_JPRB, 0.10330532E-09_JPRB, 0.10217942E-09_JPRB, 0.10020392E-09_JPRB /)

RGHG8(:,18,10) = (/ &
  & 0.65198048E-10_JPRB, 0.68671076E-10_JPRB, 0.71189540E-10_JPRB, 0.73715999E-10_JPRB, 0.76546589E-10_JPRB, 0.79740659E-10_JPRB, &
  & 0.83302705E-10_JPRB, 0.87163235E-10_JPRB, 0.91206515E-10_JPRB, 0.95306416E-10_JPRB, 0.99341223E-10_JPRB, 0.10320301E-09_JPRB, &
  & 0.10682890E-09_JPRB, 0.11019403E-09_JPRB, 0.11330557E-09_JPRB, 0.11618217E-09_JPRB, 0.11884908E-09_JPRB, 0.12132208E-09_JPRB, &
  & 0.12361216E-09_JPRB, 0.12571491E-09_JPRB, 0.12760286E-09_JPRB, 0.12922412E-09_JPRB, 0.13049722E-09_JPRB, 0.13134163E-09_JPRB, &
  & 0.13170570E-09_JPRB, 0.13161108E-09_JPRB, 0.13117575E-09_JPRB, 0.13055691E-09_JPRB, 0.12997768E-09_JPRB, 0.12958595E-09_JPRB, &
  & 0.12955628E-09_JPRB, 0.12994637E-09_JPRB, 0.13071424E-09_JPRB, 0.13173775E-09_JPRB, 0.13291065E-09_JPRB, 0.13411723E-09_JPRB, &
  & 0.13521674E-09_JPRB, 0.13610504E-09_JPRB, 0.13672793E-09_JPRB, 0.13703215E-09_JPRB, 0.13698924E-09_JPRB, 0.13658952E-09_JPRB, &
  & 0.13586075E-09_JPRB, 0.13486852E-09_JPRB, 0.13370323E-09_JPRB, 0.13246342E-09_JPRB, 0.13122500E-09_JPRB, 0.13002595E-09_JPRB, &
  & 0.12886575E-09_JPRB, 0.12771532E-09_JPRB, 0.12653614E-09_JPRB, 0.12528920E-09_JPRB, 0.12395383E-09_JPRB, 0.12253477E-09_JPRB, &
  & 0.12106136E-09_JPRB, 0.11957911E-09_JPRB, 0.11813703E-09_JPRB, 0.11676451E-09_JPRB, 0.11548160E-09_JPRB, 0.11429203E-09_JPRB, &
  & 0.11319190E-09_JPRB, 0.11212774E-09_JPRB, 0.11096114E-09_JPRB, 0.10890461E-09_JPRB /)

RGHG8(:,19,10) = (/ &
  & 0.71674368E-10_JPRB, 0.75814958E-10_JPRB, 0.78573169E-10_JPRB, 0.81370459E-10_JPRB, 0.84368887E-10_JPRB, 0.87720636E-10_JPRB, &
  & 0.91380632E-10_JPRB, 0.95277494E-10_JPRB, 0.99298236E-10_JPRB, 0.10332173E-09_JPRB, 0.10723290E-09_JPRB, 0.11094668E-09_JPRB, &
  & 0.11440933E-09_JPRB, 0.11760437E-09_JPRB, 0.12054135E-09_JPRB, 0.12324368E-09_JPRB, 0.12573548E-09_JPRB, 0.12804374E-09_JPRB, &
  & 0.13019127E-09_JPRB, 0.13219283E-09_JPRB, 0.13403652E-09_JPRB, 0.13568424E-09_JPRB, 0.13706948E-09_JPRB, 0.13811589E-09_JPRB, &
  & 0.13876103E-09_JPRB, 0.13899769E-09_JPRB, 0.13888959E-09_JPRB, 0.13855488E-09_JPRB, 0.13813831E-09_JPRB, 0.13777847E-09_JPRB, &
  & 0.13759199E-09_JPRB, 0.13762709E-09_JPRB, 0.13791347E-09_JPRB, 0.13839341E-09_JPRB, 0.13901220E-09_JPRB, 0.13973847E-09_JPRB, &
  & 0.14050744E-09_JPRB, 0.14119267E-09_JPRB, 0.14172630E-09_JPRB, 0.14204216E-09_JPRB, 0.14209640E-09_JPRB, 0.14186136E-09_JPRB, &
  & 0.14135174E-09_JPRB, 0.14060973E-09_JPRB, 0.13970874E-09_JPRB, 0.13872961E-09_JPRB, 0.13773716E-09_JPRB, 0.13676058E-09_JPRB, &
  & 0.13579471E-09_JPRB, 0.13481442E-09_JPRB, 0.13378311E-09_JPRB, 0.13266674E-09_JPRB, 0.13144602E-09_JPRB, 0.13012476E-09_JPRB, &
  & 0.12873176E-09_JPRB, 0.12731728E-09_JPRB, 0.12592430E-09_JPRB, 0.12458742E-09_JPRB, 0.12332661E-09_JPRB, 0.12215129E-09_JPRB, &
  & 0.12104642E-09_JPRB, 0.12001115E-09_JPRB, 0.11879935E-09_JPRB, 0.11682827E-09_JPRB /)

RGHG8(:,20,10) = (/ &
  & 0.79396864E-10_JPRB, 0.83881790E-10_JPRB, 0.86829377E-10_JPRB, 0.89579198E-10_JPRB, 0.92552077E-10_JPRB, 0.95768879E-10_JPRB, &
  & 0.99242795E-10_JPRB, 0.10289939E-09_JPRB, 0.10663889E-09_JPRB, 0.11035491E-09_JPRB, 0.11395578E-09_JPRB, 0.11736262E-09_JPRB, &
  & 0.12053604E-09_JPRB, 0.12346239E-09_JPRB, 0.12615164E-09_JPRB, 0.12862472E-09_JPRB, 0.13091027E-09_JPRB, 0.13303691E-09_JPRB, &
  & 0.13503258E-09_JPRB, 0.13692258E-09_JPRB, 0.13870881E-09_JPRB, 0.14036404E-09_JPRB, 0.14183212E-09_JPRB, 0.14304258E-09_JPRB, &
  & 0.14393070E-09_JPRB, 0.14446849E-09_JPRB, 0.14468889E-09_JPRB, 0.14467097E-09_JPRB, 0.14450906E-09_JPRB, 0.14428042E-09_JPRB, &
  & 0.14406844E-09_JPRB, 0.14392490E-09_JPRB, 0.14388754E-09_JPRB, 0.14398807E-09_JPRB, 0.14423789E-09_JPRB, 0.14457695E-09_JPRB, &
  & 0.14500826E-09_JPRB, 0.14549290E-09_JPRB, 0.14591038E-09_JPRB, 0.14620101E-09_JPRB, 0.14629831E-09_JPRB, 0.14617890E-09_JPRB, &
  & 0.14582863E-09_JPRB, 0.14527524E-09_JPRB, 0.14457202E-09_JPRB, 0.14378193E-09_JPRB, 0.14295790E-09_JPRB, 0.14212585E-09_JPRB, &
  & 0.14128584E-09_JPRB, 0.14041884E-09_JPRB, 0.13949675E-09_JPRB, 0.13849254E-09_JPRB, 0.13739125E-09_JPRB, 0.13619920E-09_JPRB, &
  & 0.13494307E-09_JPRB, 0.13365896E-09_JPRB, 0.13238571E-09_JPRB, 0.13114806E-09_JPRB, 0.12996793E-09_JPRB, 0.12885518E-09_JPRB, &
  & 0.12782657E-09_JPRB, 0.12678790E-09_JPRB, 0.12573372E-09_JPRB, 0.12366040E-09_JPRB /)

RGHG8(:,21,10) = (/ &
  & 0.87685616E-10_JPRB, 0.92315620E-10_JPRB, 0.95144038E-10_JPRB, 0.97738755E-10_JPRB, 0.10043873E-09_JPRB, 0.10334045E-09_JPRB, &
  & 0.10643412E-09_JPRB, 0.10967902E-09_JPRB, 0.11299352E-09_JPRB, 0.11629572E-09_JPRB, 0.11949911E-09_JPRB, 0.12254404E-09_JPRB, &
  & 0.12539067E-09_JPRB, 0.12802712E-09_JPRB, 0.13046066E-09_JPRB, 0.13271065E-09_JPRB, 0.13480224E-09_JPRB, 0.13676504E-09_JPRB, &
  & 0.13862926E-09_JPRB, 0.14042000E-09_JPRB, 0.14215090E-09_JPRB, 0.14380233E-09_JPRB, 0.14532565E-09_JPRB, 0.14665046E-09_JPRB, &
  & 0.14770403E-09_JPRB, 0.14845698E-09_JPRB, 0.14892818E-09_JPRB, 0.14916408E-09_JPRB, 0.14922091E-09_JPRB, 0.14914875E-09_JPRB, &
  & 0.14899612E-09_JPRB, 0.14880885E-09_JPRB, 0.14863459E-09_JPRB, 0.14852126E-09_JPRB, 0.14852887E-09_JPRB, 0.14866106E-09_JPRB, &
  & 0.14888923E-09_JPRB, 0.14916628E-09_JPRB, 0.14946087E-09_JPRB, 0.14969072E-09_JPRB, 0.14979774E-09_JPRB, 0.14972566E-09_JPRB, &
  & 0.14946748E-09_JPRB, 0.14903244E-09_JPRB, 0.14845508E-09_JPRB, 0.14778297E-09_JPRB, 0.14706016E-09_JPRB, 0.14631339E-09_JPRB, &
  & 0.14554835E-09_JPRB, 0.14475297E-09_JPRB, 0.14390691E-09_JPRB, 0.14299308E-09_JPRB, 0.14200596E-09_JPRB, 0.14095286E-09_JPRB, &
  & 0.13985253E-09_JPRB, 0.13873167E-09_JPRB, 0.13761239E-09_JPRB, 0.13651476E-09_JPRB, 0.13545472E-09_JPRB, 0.13444416E-09_JPRB, &
  & 0.13347243E-09_JPRB, 0.13256254E-09_JPRB, 0.13144076E-09_JPRB, 0.12965687E-09_JPRB /)

RGHG8(:,22,10) = (/ &
  & 0.95904396E-10_JPRB, 0.10026669E-09_JPRB, 0.10294352E-09_JPRB, 0.10520039E-09_JPRB, 0.10757975E-09_JPRB, 0.11006780E-09_JPRB, &
  & 0.11271378E-09_JPRB, 0.11549166E-09_JPRB, 0.11834836E-09_JPRB, 0.12121218E-09_JPRB, 0.12402029E-09_JPRB, 0.12671031E-09_JPRB, &
  & 0.12924931E-09_JPRB, 0.13162006E-09_JPRB, 0.13382574E-09_JPRB, 0.13587884E-09_JPRB, 0.13780525E-09_JPRB, 0.13963193E-09_JPRB, &
  & 0.14139072E-09_JPRB, 0.14310568E-09_JPRB, 0.14478975E-09_JPRB, 0.14642768E-09_JPRB, 0.14797341E-09_JPRB, 0.14935918E-09_JPRB, &
  & 0.15052291E-09_JPRB, 0.15142082E-09_JPRB, 0.15206186E-09_JPRB, 0.15247523E-09_JPRB, 0.15269788E-09_JPRB, 0.15276427E-09_JPRB, &
  & 0.15270192E-09_JPRB, 0.15254709E-09_JPRB, 0.15234355E-09_JPRB, 0.15214054E-09_JPRB, 0.15200634E-09_JPRB, 0.15196686E-09_JPRB, &
  & 0.15205269E-09_JPRB, 0.15224974E-09_JPRB, 0.15246150E-09_JPRB, 0.15263563E-09_JPRB, 0.15271587E-09_JPRB, 0.15265883E-09_JPRB, &
  & 0.15243982E-09_JPRB, 0.15206560E-09_JPRB, 0.15155885E-09_JPRB, 0.15095311E-09_JPRB, 0.15028537E-09_JPRB, 0.14958740E-09_JPRB, &
  & 0.14886468E-09_JPRB, 0.14811254E-09_JPRB, 0.14732003E-09_JPRB, 0.14648069E-09_JPRB, 0.14559534E-09_JPRB, 0.14467280E-09_JPRB, &
  & 0.14372561E-09_JPRB, 0.14276673E-09_JPRB, 0.14180923E-09_JPRB, 0.14086059E-09_JPRB, 0.13993004E-09_JPRB, 0.13902529E-09_JPRB, &
  & 0.13816205E-09_JPRB, 0.13727150E-09_JPRB, 0.13634249E-09_JPRB, 0.13457081E-09_JPRB /)

RGHG8(:,23,10) = (/ &
  & 0.10349117E-09_JPRB, 0.10739937E-09_JPRB, 0.10975672E-09_JPRB, 0.11173824E-09_JPRB, 0.11374012E-09_JPRB, 0.11583458E-09_JPRB, &
  & 0.11805590E-09_JPRB, 0.12039561E-09_JPRB, 0.12282131E-09_JPRB, 0.12528720E-09_JPRB, 0.12773352E-09_JPRB, 0.13011262E-09_JPRB, &
  & 0.13238685E-09_JPRB, 0.13453740E-09_JPRB, 0.13655939E-09_JPRB, 0.13845906E-09_JPRB, 0.14025607E-09_JPRB, 0.14197458E-09_JPRB, &
  & 0.14364873E-09_JPRB, 0.14529669E-09_JPRB, 0.14693158E-09_JPRB, 0.14854604E-09_JPRB, 0.15008735E-09_JPRB, 0.15150006E-09_JPRB, &
  & 0.15271283E-09_JPRB, 0.15369193E-09_JPRB, 0.15443856E-09_JPRB, 0.15496970E-09_JPRB, 0.15531312E-09_JPRB, 0.15549198E-09_JPRB, &
  & 0.15552648E-09_JPRB, 0.15544134E-09_JPRB, 0.15527610E-09_JPRB, 0.15507572E-09_JPRB, 0.15491541E-09_JPRB, 0.15482891E-09_JPRB, &
  & 0.15483231E-09_JPRB, 0.15491620E-09_JPRB, 0.15503150E-09_JPRB, 0.15513674E-09_JPRB, 0.15517104E-09_JPRB, 0.15509709E-09_JPRB, &
  & 0.15488909E-09_JPRB, 0.15453751E-09_JPRB, 0.15405874E-09_JPRB, 0.15348720E-09_JPRB, 0.15285051E-09_JPRB, 0.15217837E-09_JPRB, &
  & 0.15148113E-09_JPRB, 0.15075749E-09_JPRB, 0.15000411E-09_JPRB, 0.14922413E-09_JPRB, 0.14842520E-09_JPRB, 0.14761611E-09_JPRB, &
  & 0.14680199E-09_JPRB, 0.14598681E-09_JPRB, 0.14517151E-09_JPRB, 0.14435760E-09_JPRB, 0.14355016E-09_JPRB, 0.14275421E-09_JPRB, &
  & 0.14196902E-09_JPRB, 0.14119973E-09_JPRB, 0.14027889E-09_JPRB, 0.13870188E-09_JPRB /)

RGHG8(:,24,10) = (/ &
  & 0.11016978E-09_JPRB, 0.11364573E-09_JPRB, 0.11561559E-09_JPRB, 0.11730641E-09_JPRB, 0.11897894E-09_JPRB, 0.12072808E-09_JPRB, &
  & 0.12258165E-09_JPRB, 0.12454915E-09_JPRB, 0.12660935E-09_JPRB, 0.12873165E-09_JPRB, 0.13087426E-09_JPRB, 0.13299145E-09_JPRB, &
  & 0.13504947E-09_JPRB, 0.13702423E-09_JPRB, 0.13890536E-09_JPRB, 0.14068974E-09_JPRB, 0.14239128E-09_JPRB, 0.14402668E-09_JPRB, &
  & 0.14562890E-09_JPRB, 0.14721874E-09_JPRB, 0.14880208E-09_JPRB, 0.15036750E-09_JPRB, 0.15187700E-09_JPRB, 0.15327020E-09_JPRB, &
  & 0.15448673E-09_JPRB, 0.15549433E-09_JPRB, 0.15629391E-09_JPRB, 0.15690042E-09_JPRB, 0.15733029E-09_JPRB, 0.15760067E-09_JPRB, &
  & 0.15772464E-09_JPRB, 0.15772038E-09_JPRB, 0.15762158E-09_JPRB, 0.15747109E-09_JPRB, 0.15731785E-09_JPRB, 0.15720261E-09_JPRB, &
  & 0.15716461E-09_JPRB, 0.15718463E-09_JPRB, 0.15723095E-09_JPRB, 0.15726362E-09_JPRB, 0.15724358E-09_JPRB, 0.15713042E-09_JPRB, &
  & 0.15690721E-09_JPRB, 0.15656033E-09_JPRB, 0.15609336E-09_JPRB, 0.15553507E-09_JPRB, 0.15491398E-09_JPRB, 0.15425651E-09_JPRB, &
  & 0.15357197E-09_JPRB, 0.15286779E-09_JPRB, 0.15214695E-09_JPRB, 0.15141921E-09_JPRB, 0.15069496E-09_JPRB, 0.14997965E-09_JPRB, &
  & 0.14927405E-09_JPRB, 0.14857519E-09_JPRB, 0.14787757E-09_JPRB, 0.14717738E-09_JPRB, 0.14647403E-09_JPRB, 0.14577141E-09_JPRB, &
  & 0.14507642E-09_JPRB, 0.14436095E-09_JPRB, 0.14355291E-09_JPRB, 0.14211292E-09_JPRB /)

RGHG8(:,25,10) = (/ &
  & 0.11598623E-09_JPRB, 0.11898831E-09_JPRB, 0.12068117E-09_JPRB, 0.12209313E-09_JPRB, 0.12348347E-09_JPRB, 0.12494215E-09_JPRB, &
  & 0.12649516E-09_JPRB, 0.12815406E-09_JPRB, 0.12991447E-09_JPRB, 0.13175347E-09_JPRB, 0.13364332E-09_JPRB, 0.13554563E-09_JPRB, &
  & 0.13742776E-09_JPRB, 0.13926435E-09_JPRB, 0.14103689E-09_JPRB, 0.14273738E-09_JPRB, 0.14436710E-09_JPRB, 0.14593854E-09_JPRB, &
  & 0.14747818E-09_JPRB, 0.14900091E-09_JPRB, 0.15051958E-09_JPRB, 0.15201719E-09_JPRB, 0.15346535E-09_JPRB, 0.15480857E-09_JPRB, &
  & 0.15599928E-09_JPRB, 0.15700802E-09_JPRB, 0.15783043E-09_JPRB, 0.15847057E-09_JPRB, 0.15894841E-09_JPRB, 0.15927840E-09_JPRB, &
  & 0.15947277E-09_JPRB, 0.15954445E-09_JPRB, 0.15951877E-09_JPRB, 0.15943122E-09_JPRB, 0.15931673E-09_JPRB, 0.15921463E-09_JPRB, &
  & 0.15914982E-09_JPRB, 0.15911227E-09_JPRB, 0.15909768E-09_JPRB, 0.15906561E-09_JPRB, 0.15898674E-09_JPRB, 0.15882810E-09_JPRB, &
  & 0.15857435E-09_JPRB, 0.15821738E-09_JPRB, 0.15775439E-09_JPRB, 0.15720539E-09_JPRB, 0.15659557E-09_JPRB, 0.15595082E-09_JPRB, &
  & 0.15528306E-09_JPRB, 0.15459878E-09_JPRB, 0.15390660E-09_JPRB, 0.15322209E-09_JPRB, 0.15255675E-09_JPRB, 0.15191426E-09_JPRB, &
  & 0.15129160E-09_JPRB, 0.15068188E-09_JPRB, 0.15007759E-09_JPRB, 0.14946992E-09_JPRB, 0.14885633E-09_JPRB, 0.14823807E-09_JPRB, &
  & 0.14761940E-09_JPRB, 0.14698498E-09_JPRB, 0.14626789E-09_JPRB, 0.14494179E-09_JPRB /)

RGHG8(:,26,10) = (/ &
  & 0.12106049E-09_JPRB, 0.12371756E-09_JPRB, 0.12511778E-09_JPRB, 0.12630400E-09_JPRB, 0.12746773E-09_JPRB, 0.12868392E-09_JPRB, &
  & 0.12999343E-09_JPRB, 0.13140562E-09_JPRB, 0.13291809E-09_JPRB, 0.13452722E-09_JPRB, 0.13620689E-09_JPRB, 0.13793061E-09_JPRB, &
  & 0.13966664E-09_JPRB, 0.14138825E-09_JPRB, 0.14307289E-09_JPRB, 0.14470362E-09_JPRB, 0.14627857E-09_JPRB, 0.14779497E-09_JPRB, &
  & 0.14927175E-09_JPRB, 0.15072435E-09_JPRB, 0.15216245E-09_JPRB, 0.15357705E-09_JPRB, 0.15493939E-09_JPRB, 0.15620721E-09_JPRB, &
  & 0.15734468E-09_JPRB, 0.15831764E-09_JPRB, 0.15912496E-09_JPRB, 0.15977461E-09_JPRB, 0.16027715E-09_JPRB, 0.16064475E-09_JPRB, &
  & 0.16088915E-09_JPRB, 0.16102307E-09_JPRB, 0.16106375E-09_JPRB, 0.16103745E-09_JPRB, 0.16097304E-09_JPRB, 0.16089162E-09_JPRB, &
  & 0.16081086E-09_JPRB, 0.16074084E-09_JPRB, 0.16067002E-09_JPRB, 0.16057872E-09_JPRB, 0.16044553E-09_JPRB, 0.16024594E-09_JPRB, &
  & 0.15996418E-09_JPRB, 0.15959238E-09_JPRB, 0.15912742E-09_JPRB, 0.15858342E-09_JPRB, 0.15798102E-09_JPRB, 0.15734207E-09_JPRB, &
  & 0.15668306E-09_JPRB, 0.15601712E-09_JPRB, 0.15535734E-09_JPRB, 0.15471727E-09_JPRB, 0.15410473E-09_JPRB, 0.15352095E-09_JPRB, &
  & 0.15296187E-09_JPRB, 0.15242023E-09_JPRB, 0.15188542E-09_JPRB, 0.15134918E-09_JPRB, 0.15080757E-09_JPRB, 0.15026159E-09_JPRB, &
  & 0.14971202E-09_JPRB, 0.14915638E-09_JPRB, 0.14849262E-09_JPRB, 0.14737774E-09_JPRB /)

RGHG8(:,27,10) = (/ &
  & 0.12558699E-09_JPRB, 0.12791615E-09_JPRB, 0.12913398E-09_JPRB, 0.13013034E-09_JPRB, 0.13110019E-09_JPRB, 0.13212752E-09_JPRB, &
  & 0.13323555E-09_JPRB, 0.13444461E-09_JPRB, 0.13576062E-09_JPRB, 0.13717484E-09_JPRB, 0.13868043E-09_JPRB, 0.14024984E-09_JPRB, &
  & 0.14185826E-09_JPRB, 0.14347817E-09_JPRB, 0.14508174E-09_JPRB, 0.14665327E-09_JPRB, 0.14816590E-09_JPRB, 0.14962966E-09_JPRB, &
  & 0.15104082E-09_JPRB, 0.15242263E-09_JPRB, 0.15376683E-09_JPRB, 0.15508331E-09_JPRB, 0.15634243E-09_JPRB, 0.15751557E-09_JPRB, &
  & 0.15857220E-09_JPRB, 0.15948505E-09_JPRB, 0.16025524E-09_JPRB, 0.16088607E-09_JPRB, 0.16139058E-09_JPRB, 0.16177731E-09_JPRB, &
  & 0.16205504E-09_JPRB, 0.16223446E-09_JPRB, 0.16232816E-09_JPRB, 0.16235338E-09_JPRB, 0.16232998E-09_JPRB, 0.16227336E-09_JPRB, &
  & 0.16219259E-09_JPRB, 0.16209664E-09_JPRB, 0.16198365E-09_JPRB, 0.16184365E-09_JPRB, 0.16166392E-09_JPRB, 0.16142858E-09_JPRB, &
  & 0.16112395E-09_JPRB, 0.16074052E-09_JPRB, 0.16027570E-09_JPRB, 0.15973732E-09_JPRB, 0.15914646E-09_JPRB, 0.15852543E-09_JPRB, &
  & 0.15788977E-09_JPRB, 0.15724716E-09_JPRB, 0.15661214E-09_JPRB, 0.15600282E-09_JPRB, 0.15542820E-09_JPRB, 0.15488756E-09_JPRB, &
  & 0.15437604E-09_JPRB, 0.15388391E-09_JPRB, 0.15340125E-09_JPRB, 0.15291977E-09_JPRB, 0.15243570E-09_JPRB, 0.15195109E-09_JPRB, &
  & 0.15147050E-09_JPRB, 0.15097118E-09_JPRB, 0.15043045E-09_JPRB, 0.14941322E-09_JPRB /)

RGHG8(:,28,10) = (/ &
  & 0.12968207E-09_JPRB, 0.13177033E-09_JPRB, 0.13281540E-09_JPRB, 0.13366484E-09_JPRB, 0.13449271E-09_JPRB, 0.13535877E-09_JPRB, &
  & 0.13631012E-09_JPRB, 0.13735706E-09_JPRB, 0.13850637E-09_JPRB, 0.13976513E-09_JPRB, 0.14111912E-09_JPRB, 0.14255437E-09_JPRB, &
  & 0.14404619E-09_JPRB, 0.14556750E-09_JPRB, 0.14709413E-09_JPRB, 0.14859389E-09_JPRB, 0.15004169E-09_JPRB, 0.15144569E-09_JPRB, &
  & 0.15278620E-09_JPRB, 0.15408537E-09_JPRB, 0.15533290E-09_JPRB, 0.15654085E-09_JPRB, 0.15768886E-09_JPRB, 0.15875429E-09_JPRB, &
  & 0.15971324E-09_JPRB, 0.16054942E-09_JPRB, 0.16126020E-09_JPRB, 0.16185839E-09_JPRB, 0.16234836E-09_JPRB, 0.16273718E-09_JPRB, &
  & 0.16303169E-09_JPRB, 0.16323980E-09_JPRB, 0.16337039E-09_JPRB, 0.16343359E-09_JPRB, 0.16344152E-09_JPRB, 0.16340368E-09_JPRB, &
  & 0.16332558E-09_JPRB, 0.16321465E-09_JPRB, 0.16307281E-09_JPRB, 0.16289839E-09_JPRB, 0.16268416E-09_JPRB, 0.16242135E-09_JPRB, &
  & 0.16209853E-09_JPRB, 0.16170809E-09_JPRB, 0.16124467E-09_JPRB, 0.16071401E-09_JPRB, 0.16013416E-09_JPRB, 0.15952374E-09_JPRB, &
  & 0.15889864E-09_JPRB, 0.15827306E-09_JPRB, 0.15767004E-09_JPRB, 0.15710030E-09_JPRB, 0.15656489E-09_JPRB, 0.15606370E-09_JPRB, &
  & 0.15559080E-09_JPRB, 0.15513890E-09_JPRB, 0.15469868E-09_JPRB, 0.15426287E-09_JPRB, 0.15382889E-09_JPRB, 0.15339548E-09_JPRB, &
  & 0.15296178E-09_JPRB, 0.15253225E-09_JPRB, 0.15202040E-09_JPRB, 0.15118108E-09_JPRB /)

RGHG8(:,29,10) = (/ &
  & 0.13344664E-09_JPRB, 0.13531133E-09_JPRB, 0.13624074E-09_JPRB, 0.13697715E-09_JPRB, 0.13768042E-09_JPRB, 0.13842952E-09_JPRB, &
  & 0.13924839E-09_JPRB, 0.14016267E-09_JPRB, 0.14118177E-09_JPRB, 0.14230425E-09_JPRB, 0.14353156E-09_JPRB, 0.14484579E-09_JPRB, &
  & 0.14622814E-09_JPRB, 0.14765204E-09_JPRB, 0.14909755E-09_JPRB, 0.15050898E-09_JPRB, 0.15189294E-09_JPRB, 0.15322088E-09_JPRB, &
  & 0.15448423E-09_JPRB, 0.15569265E-09_JPRB, 0.15684273E-09_JPRB, 0.15793931E-09_JPRB, 0.15897335E-09_JPRB, 0.15992825E-09_JPRB, &
  & 0.16078457E-09_JPRB, 0.16153462E-09_JPRB, 0.16218119E-09_JPRB, 0.16273112E-09_JPRB, 0.16319177E-09_JPRB, 0.16356785E-09_JPRB, &
  & 0.16386406E-09_JPRB, 0.16408543E-09_JPRB, 0.16423746E-09_JPRB, 0.16432514E-09_JPRB, 0.16435442E-09_JPRB, 0.16433038E-09_JPRB, &
  & 0.16425533E-09_JPRB, 0.16413615E-09_JPRB, 0.16397669E-09_JPRB, 0.16378066E-09_JPRB, 0.16354422E-09_JPRB, 0.16326378E-09_JPRB, &
  & 0.16293181E-09_JPRB, 0.16253859E-09_JPRB, 0.16208192E-09_JPRB, 0.16156182E-09_JPRB, 0.16099411E-09_JPRB, 0.16039796E-09_JPRB, &
  & 0.15978965E-09_JPRB, 0.15919199E-09_JPRB, 0.15862008E-09_JPRB, 0.15807917E-09_JPRB, 0.15757341E-09_JPRB, 0.15710191E-09_JPRB, &
  & 0.15665973E-09_JPRB, 0.15623962E-09_JPRB, 0.15583257E-09_JPRB, 0.15543236E-09_JPRB, 0.15503333E-09_JPRB, 0.15463666E-09_JPRB, &
  & 0.15424773E-09_JPRB, 0.15384882E-09_JPRB, 0.15342068E-09_JPRB, 0.15265575E-09_JPRB /)

RGHG8(:,30,10) = (/ &
  & 0.13691163E-09_JPRB, 0.13861527E-09_JPRB, 0.13943352E-09_JPRB, 0.14007555E-09_JPRB, 0.14068924E-09_JPRB, 0.14133299E-09_JPRB, &
  & 0.14205076E-09_JPRB, 0.14285720E-09_JPRB, 0.14376184E-09_JPRB, 0.14477441E-09_JPRB, 0.14588736E-09_JPRB, 0.14709231E-09_JPRB, &
  & 0.14836961E-09_JPRB, 0.14969770E-09_JPRB, 0.15104833E-09_JPRB, 0.15237350E-09_JPRB, 0.15367509E-09_JPRB, 0.15492199E-09_JPRB, &
  & 0.15610170E-09_JPRB, 0.15721718E-09_JPRB, 0.15826966E-09_JPRB, 0.15925990E-09_JPRB, 0.16018334E-09_JPRB, 0.16102944E-09_JPRB, &
  & 0.16178507E-09_JPRB, 0.16244792E-09_JPRB, 0.16302330E-09_JPRB, 0.16352020E-09_JPRB, 0.16394390E-09_JPRB, 0.16429719E-09_JPRB, &
  & 0.16458382E-09_JPRB, 0.16480597E-09_JPRB, 0.16496668E-09_JPRB, 0.16506695E-09_JPRB, 0.16510852E-09_JPRB, 0.16509329E-09_JPRB, &
  & 0.16502139E-09_JPRB, 0.16489951E-09_JPRB, 0.16473067E-09_JPRB, 0.16452346E-09_JPRB, 0.16427518E-09_JPRB, 0.16398657E-09_JPRB, &
  & 0.16365194E-09_JPRB, 0.16326351E-09_JPRB, 0.16281589E-09_JPRB, 0.16231062E-09_JPRB, 0.16175938E-09_JPRB, 0.16118112E-09_JPRB, &
  & 0.16059798E-09_JPRB, 0.16002877E-09_JPRB, 0.15948166E-09_JPRB, 0.15896444E-09_JPRB, 0.15848271E-09_JPRB, 0.15803628E-09_JPRB, &
  & 0.15761847E-09_JPRB, 0.15722197E-09_JPRB, 0.15683933E-09_JPRB, 0.15646263E-09_JPRB, 0.15609050E-09_JPRB, 0.15572402E-09_JPRB, &
  & 0.15536344E-09_JPRB, 0.15500884E-09_JPRB, 0.15460105E-09_JPRB, 0.15392936E-09_JPRB /)

RGHG8(:,31,10) = (/ &
  & 0.14012315E-09_JPRB, 0.14165953E-09_JPRB, 0.14239751E-09_JPRB, 0.14296538E-09_JPRB, 0.14349757E-09_JPRB, 0.14406627E-09_JPRB, &
  & 0.14469624E-09_JPRB, 0.14541179E-09_JPRB, 0.14622394E-09_JPRB, 0.14713468E-09_JPRB, 0.14814733E-09_JPRB, 0.14924970E-09_JPRB, &
  & 0.15042470E-09_JPRB, 0.15165458E-09_JPRB, 0.15290545E-09_JPRB, 0.15414159E-09_JPRB, 0.15535231E-09_JPRB, 0.15651114E-09_JPRB, &
  & 0.15760479E-09_JPRB, 0.15863127E-09_JPRB, 0.15959045E-09_JPRB, 0.16048239E-09_JPRB, 0.16130393E-09_JPRB, 0.16204911E-09_JPRB, &
  & 0.16271173E-09_JPRB, 0.16329130E-09_JPRB, 0.16379820E-09_JPRB, 0.16423897E-09_JPRB, 0.16462059E-09_JPRB, 0.16494490E-09_JPRB, &
  & 0.16521366E-09_JPRB, 0.16542756E-09_JPRB, 0.16558691E-09_JPRB, 0.16569045E-09_JPRB, 0.16573694E-09_JPRB, 0.16572599E-09_JPRB, &
  & 0.16565728E-09_JPRB, 0.16553584E-09_JPRB, 0.16536439E-09_JPRB, 0.16515359E-09_JPRB, 0.16490191E-09_JPRB, 0.16461187E-09_JPRB, &
  & 0.16428084E-09_JPRB, 0.16390013E-09_JPRB, 0.16346524E-09_JPRB, 0.16297566E-09_JPRB, 0.16244170E-09_JPRB, 0.16188337E-09_JPRB, &
  & 0.16132290E-09_JPRB, 0.16077527E-09_JPRB, 0.16025130E-09_JPRB, 0.15976205E-09_JPRB, 0.15930959E-09_JPRB, 0.15888796E-09_JPRB, &
  & 0.15849133E-09_JPRB, 0.15811352E-09_JPRB, 0.15774757E-09_JPRB, 0.15738995E-09_JPRB, 0.15703894E-09_JPRB, 0.15669460E-09_JPRB, &
  & 0.15635893E-09_JPRB, 0.15601972E-09_JPRB, 0.15565484E-09_JPRB, 0.15502559E-09_JPRB /)

RGHG8(:,32,10) = (/ &
  & 0.14306582E-09_JPRB, 0.14446151E-09_JPRB, 0.14512007E-09_JPRB, 0.14562219E-09_JPRB, 0.14610017E-09_JPRB, 0.14659984E-09_JPRB, &
  & 0.14716323E-09_JPRB, 0.14780374E-09_JPRB, 0.14853105E-09_JPRB, 0.14935485E-09_JPRB, 0.15027160E-09_JPRB, 0.15127509E-09_JPRB, &
  & 0.15234976E-09_JPRB, 0.15347829E-09_JPRB, 0.15462738E-09_JPRB, 0.15577262E-09_JPRB, 0.15689114E-09_JPRB, 0.15796218E-09_JPRB, &
  & 0.15897149E-09_JPRB, 0.15991575E-09_JPRB, 0.16078908E-09_JPRB, 0.16159225E-09_JPRB, 0.16232431E-09_JPRB, 0.16298099E-09_JPRB, &
  & 0.16356008E-09_JPRB, 0.16406526E-09_JPRB, 0.16450644E-09_JPRB, 0.16489385E-09_JPRB, 0.16523244E-09_JPRB, 0.16552436E-09_JPRB, &
  & 0.16577033E-09_JPRB, 0.16596927E-09_JPRB, 0.16611994E-09_JPRB, 0.16621957E-09_JPRB, 0.16626575E-09_JPRB, 0.16625600E-09_JPRB, &
  & 0.16619008E-09_JPRB, 0.16607102E-09_JPRB, 0.16590215E-09_JPRB, 0.16569303E-09_JPRB, 0.16544394E-09_JPRB, 0.16515792E-09_JPRB, &
  & 0.16483229E-09_JPRB, 0.16446297E-09_JPRB, 0.16404134E-09_JPRB, 0.16356970E-09_JPRB, 0.16305929E-09_JPRB, 0.16252774E-09_JPRB, &
  & 0.16199431E-09_JPRB, 0.16147281E-09_JPRB, 0.16097657E-09_JPRB, 0.16051289E-09_JPRB, 0.16008136E-09_JPRB, 0.15967869E-09_JPRB, &
  & 0.15929885E-09_JPRB, 0.15893545E-09_JPRB, 0.15858534E-09_JPRB, 0.15824345E-09_JPRB, 0.15790744E-09_JPRB, 0.15757841E-09_JPRB, &
  & 0.15725773E-09_JPRB, 0.15694437E-09_JPRB, 0.15659060E-09_JPRB, 0.15600754E-09_JPRB /)

RGHG8(:,33,10) = (/ &
  & 0.14573820E-09_JPRB, 0.14699172E-09_JPRB, 0.14758392E-09_JPRB, 0.14804259E-09_JPRB, 0.14846613E-09_JPRB, 0.14892244E-09_JPRB, &
  & 0.14942850E-09_JPRB, 0.15000559E-09_JPRB, 0.15066293E-09_JPRB, 0.15140350E-09_JPRB, 0.15223146E-09_JPRB, 0.15313870E-09_JPRB, &
  & 0.15411329E-09_JPRB, 0.15513850E-09_JPRB, 0.15618923E-09_JPRB, 0.15723928E-09_JPRB, 0.15826949E-09_JPRB, 0.15925573E-09_JPRB, &
  & 0.16018795E-09_JPRB, 0.16105556E-09_JPRB, 0.16185556E-09_JPRB, 0.16258511E-09_JPRB, 0.16324120E-09_JPRB, 0.16382379E-09_JPRB, &
  & 0.16433187E-09_JPRB, 0.16477211E-09_JPRB, 0.16515547E-09_JPRB, 0.16549158E-09_JPRB, 0.16578781E-09_JPRB, 0.16604569E-09_JPRB, &
  & 0.16626521E-09_JPRB, 0.16644458E-09_JPRB, 0.16658139E-09_JPRB, 0.16667245E-09_JPRB, 0.16671442E-09_JPRB, 0.16670385E-09_JPRB, &
  & 0.16664067E-09_JPRB, 0.16652595E-09_JPRB, 0.16636287E-09_JPRB, 0.16615949E-09_JPRB, 0.16591736E-09_JPRB, 0.16563763E-09_JPRB, &
  & 0.16532069E-09_JPRB, 0.16496267E-09_JPRB, 0.16455597E-09_JPRB, 0.16410456E-09_JPRB, 0.16361908E-09_JPRB, 0.16311476E-09_JPRB, &
  & 0.16260912E-09_JPRB, 0.16211649E-09_JPRB, 0.16164840E-09_JPRB, 0.16120993E-09_JPRB, 0.16080134E-09_JPRB, 0.16041740E-09_JPRB, &
  & 0.16005412E-09_JPRB, 0.15970636E-09_JPRB, 0.15936794E-09_JPRB, 0.15903598E-09_JPRB, 0.15871050E-09_JPRB, 0.15839390E-09_JPRB, &
  & 0.15808943E-09_JPRB, 0.15778612E-09_JPRB, 0.15745795E-09_JPRB, 0.15690038E-09_JPRB /)

RGHG8(:,34,10) = (/ &
  & 0.14812732E-09_JPRB, 0.14925194E-09_JPRB, 0.14979126E-09_JPRB, 0.15020250E-09_JPRB, 0.15059992E-09_JPRB, 0.15101233E-09_JPRB, &
  & 0.15147716E-09_JPRB, 0.15200241E-09_JPRB, 0.15259502E-09_JPRB, 0.15326362E-09_JPRB, 0.15400643E-09_JPRB, 0.15482124E-09_JPRB, &
  & 0.15569838E-09_JPRB, 0.15662342E-09_JPRB, 0.15757647E-09_JPRB, 0.15853623E-09_JPRB, 0.15948071E-09_JPRB, 0.16039033E-09_JPRB, &
  & 0.16125214E-09_JPRB, 0.16205542E-09_JPRB, 0.16279385E-09_JPRB, 0.16346327E-09_JPRB, 0.16405891E-09_JPRB, 0.16458043E-09_JPRB, &
  & 0.16503056E-09_JPRB, 0.16541518E-09_JPRB, 0.16574735E-09_JPRB, 0.16603738E-09_JPRB, 0.16629249E-09_JPRB, 0.16651569E-09_JPRB, &
  & 0.16670657E-09_JPRB, 0.16686311E-09_JPRB, 0.16698248E-09_JPRB, 0.16706168E-09_JPRB, 0.16709686E-09_JPRB, 0.16708473E-09_JPRB, &
  & 0.16702485E-09_JPRB, 0.16691609E-09_JPRB, 0.16676151E-09_JPRB, 0.16656727E-09_JPRB, 0.16633400E-09_JPRB, 0.16606298E-09_JPRB, &
  & 0.16575653E-09_JPRB, 0.16540926E-09_JPRB, 0.16501800E-09_JPRB, 0.16458818E-09_JPRB, 0.16412831E-09_JPRB, 0.16365295E-09_JPRB, &
  & 0.16317800E-09_JPRB, 0.16271456E-09_JPRB, 0.16227325E-09_JPRB, 0.16186048E-09_JPRB, 0.16147382E-09_JPRB, 0.16111089E-09_JPRB, &
  & 0.16076475E-09_JPRB, 0.16042996E-09_JPRB, 0.16010197E-09_JPRB, 0.15978009E-09_JPRB, 0.15946484E-09_JPRB, 0.15915910E-09_JPRB, &
  & 0.15886478E-09_JPRB, 0.15857859E-09_JPRB, 0.15826221E-09_JPRB, 0.15773299E-09_JPRB /)

RGHG8(:,35,10) = (/ &
  & 0.15023648E-09_JPRB, 0.15124824E-09_JPRB, 0.15173611E-09_JPRB, 0.15212435E-09_JPRB, 0.15248522E-09_JPRB, 0.15287510E-09_JPRB, &
  & 0.15330212E-09_JPRB, 0.15378251E-09_JPRB, 0.15432203E-09_JPRB, 0.15492260E-09_JPRB, 0.15558907E-09_JPRB, 0.15631681E-09_JPRB, &
  & 0.15710161E-09_JPRB, 0.15793117E-09_JPRB, 0.15879259E-09_JPRB, 0.15966557E-09_JPRB, 0.16053164E-09_JPRB, 0.16137205E-09_JPRB, &
  & 0.16217358E-09_JPRB, 0.16292348E-09_JPRB, 0.16361323E-09_JPRB, 0.16423476E-09_JPRB, 0.16478414E-09_JPRB, 0.16525906E-09_JPRB, &
  & 0.16566133E-09_JPRB, 0.16599995E-09_JPRB, 0.16628640E-09_JPRB, 0.16653348E-09_JPRB, 0.16674911E-09_JPRB, 0.16693730E-09_JPRB, &
  & 0.16709803E-09_JPRB, 0.16722981E-09_JPRB, 0.16732980E-09_JPRB, 0.16739524E-09_JPRB, 0.16742238E-09_JPRB, 0.16740878E-09_JPRB, &
  & 0.16735306E-09_JPRB, 0.16725245E-09_JPRB, 0.16710924E-09_JPRB, 0.16692650E-09_JPRB, 0.16670382E-09_JPRB, 0.16644419E-09_JPRB, &
  & 0.16614758E-09_JPRB, 0.16581116E-09_JPRB, 0.16543539E-09_JPRB, 0.16502620E-09_JPRB, 0.16459176E-09_JPRB, 0.16414534E-09_JPRB, &
  & 0.16370016E-09_JPRB, 0.16326684E-09_JPRB, 0.16285250E-09_JPRB, 0.16246410E-09_JPRB, 0.16210029E-09_JPRB, 0.16175676E-09_JPRB, &
  & 0.16142702E-09_JPRB, 0.16110784E-09_JPRB, 0.16079352E-09_JPRB, 0.16048270E-09_JPRB, 0.16017715E-09_JPRB, 0.15988069E-09_JPRB, &
  & 0.15959782E-09_JPRB, 0.15932035E-09_JPRB, 0.15901855E-09_JPRB, 0.15851169E-09_JPRB /)

RGHG8(:,36,10) = (/ &
  & 0.15209861E-09_JPRB, 0.15300350E-09_JPRB, 0.15345378E-09_JPRB, 0.15380722E-09_JPRB, 0.15415415E-09_JPRB, 0.15451471E-09_JPRB, &
  & 0.15491457E-09_JPRB, 0.15535701E-09_JPRB, 0.15584672E-09_JPRB, 0.15638983E-09_JPRB, 0.15698516E-09_JPRB, 0.15763374E-09_JPRB, &
  & 0.15833168E-09_JPRB, 0.15907348E-09_JPRB, 0.15984759E-09_JPRB, 0.16064203E-09_JPRB, 0.16143417E-09_JPRB, 0.16221410E-09_JPRB, &
  & 0.16296206E-09_JPRB, 0.16366979E-09_JPRB, 0.16432335E-09_JPRB, 0.16491238E-09_JPRB, 0.16542703E-09_JPRB, 0.16586520E-09_JPRB, &
  & 0.16622771E-09_JPRB, 0.16652388E-09_JPRB, 0.16676885E-09_JPRB, 0.16697538E-09_JPRB, 0.16715324E-09_JPRB, 0.16730684E-09_JPRB, &
  & 0.16743773E-09_JPRB, 0.16754398E-09_JPRB, 0.16762411E-09_JPRB, 0.16767512E-09_JPRB, 0.16769416E-09_JPRB, 0.16767990E-09_JPRB, &
  & 0.16762976E-09_JPRB, 0.16754029E-09_JPRB, 0.16741196E-09_JPRB, 0.16724377E-09_JPRB, 0.16703541E-09_JPRB, 0.16678794E-09_JPRB, &
  & 0.16650156E-09_JPRB, 0.16617560E-09_JPRB, 0.16581433E-09_JPRB, 0.16542537E-09_JPRB, 0.16501597E-09_JPRB, 0.16459711E-09_JPRB, &
  & 0.16418003E-09_JPRB, 0.16377366E-09_JPRB, 0.16338379E-09_JPRB, 0.16301860E-09_JPRB, 0.16267632E-09_JPRB, 0.16235401E-09_JPRB, &
  & 0.16204373E-09_JPRB, 0.16174188E-09_JPRB, 0.16144311E-09_JPRB, 0.16114435E-09_JPRB, 0.16084942E-09_JPRB, 0.16056304E-09_JPRB, &
  & 0.16028913E-09_JPRB, 0.16002330E-09_JPRB, 0.15973362E-09_JPRB, 0.15924496E-09_JPRB /)

RGHG8(:,37,10) = (/ &
  & 0.15375722E-09_JPRB, 0.15455816E-09_JPRB, 0.15496548E-09_JPRB, 0.15529969E-09_JPRB, 0.15562192E-09_JPRB, 0.15596713E-09_JPRB, &
  & 0.15633948E-09_JPRB, 0.15674805E-09_JPRB, 0.15719576E-09_JPRB, 0.15768453E-09_JPRB, 0.15821677E-09_JPRB, 0.15879111E-09_JPRB, &
  & 0.15940911E-09_JPRB, 0.16006822E-09_JPRB, 0.16076294E-09_JPRB, 0.16148287E-09_JPRB, 0.16221208E-09_JPRB, 0.16293292E-09_JPRB, &
  & 0.16363738E-09_JPRB, 0.16430932E-09_JPRB, 0.16493565E-09_JPRB, 0.16549914E-09_JPRB, 0.16598607E-09_JPRB, 0.16638849E-09_JPRB, &
  & 0.16671085E-09_JPRB, 0.16696580E-09_JPRB, 0.16717012E-09_JPRB, 0.16733864E-09_JPRB, 0.16748145E-09_JPRB, 0.16760365E-09_JPRB, &
  & 0.16770652E-09_JPRB, 0.16778998E-09_JPRB, 0.16785194E-09_JPRB, 0.16789024E-09_JPRB, 0.16790264E-09_JPRB, 0.16788906E-09_JPRB, &
  & 0.16784624E-09_JPRB, 0.16777160E-09_JPRB, 0.16766248E-09_JPRB, 0.16751538E-09_JPRB, 0.16732726E-09_JPRB, 0.16709684E-09_JPRB, &
  & 0.16682322E-09_JPRB, 0.16650915E-09_JPRB, 0.16616310E-09_JPRB, 0.16579225E-09_JPRB, 0.16540547E-09_JPRB, 0.16501199E-09_JPRB, &
  & 0.16461951E-09_JPRB, 0.16423646E-09_JPRB, 0.16386952E-09_JPRB, 0.16352480E-09_JPRB, 0.16320437E-09_JPRB, 0.16290296E-09_JPRB, &
  & 0.16261392E-09_JPRB, 0.16233184E-09_JPRB, 0.16205168E-09_JPRB, 0.16176882E-09_JPRB, 0.16148707E-09_JPRB, 0.16121168E-09_JPRB, &
  & 0.16094763E-09_JPRB, 0.16069052E-09_JPRB, 0.16040920E-09_JPRB, 0.15993777E-09_JPRB /)

RGHG8(:,38,10) = (/ &
  & 0.15525613E-09_JPRB, 0.15595369E-09_JPRB, 0.15631868E-09_JPRB, 0.15662563E-09_JPRB, 0.15693358E-09_JPRB, 0.15725850E-09_JPRB, &
  & 0.15760958E-09_JPRB, 0.15798740E-09_JPRB, 0.15839501E-09_JPRB, 0.15883458E-09_JPRB, 0.15930685E-09_JPRB, 0.15981230E-09_JPRB, &
  & 0.16035469E-09_JPRB, 0.16093728E-09_JPRB, 0.16155871E-09_JPRB, 0.16220979E-09_JPRB, 0.16288174E-09_JPRB, 0.16355452E-09_JPRB, &
  & 0.16421660E-09_JPRB, 0.16485471E-09_JPRB, 0.16545301E-09_JPRB, 0.16598743E-09_JPRB, 0.16643807E-09_JPRB, 0.16679899E-09_JPRB, &
  & 0.16707669E-09_JPRB, 0.16728929E-09_JPRB, 0.16745581E-09_JPRB, 0.16759132E-09_JPRB, 0.16770517E-09_JPRB, 0.16780227E-09_JPRB, &
  & 0.16788453E-09_JPRB, 0.16795101E-09_JPRB, 0.16800035E-09_JPRB, 0.16802980E-09_JPRB, 0.16803824E-09_JPRB, 0.16802623E-09_JPRB, &
  & 0.16799111E-09_JPRB, 0.16793147E-09_JPRB, 0.16784392E-09_JPRB, 0.16772286E-09_JPRB, 0.16756306E-09_JPRB, 0.16735828E-09_JPRB, &
  & 0.16710598E-09_JPRB, 0.16681091E-09_JPRB, 0.16648152E-09_JPRB, 0.16612980E-09_JPRB, 0.16576436E-09_JPRB, 0.16539324E-09_JPRB, &
  & 0.16502211E-09_JPRB, 0.16465887E-09_JPRB, 0.16431073E-09_JPRB, 0.16398509E-09_JPRB, 0.16368462E-09_JPRB, 0.16340489E-09_JPRB, &
  & 0.16313917E-09_JPRB, 0.16287981E-09_JPRB, 0.16262185E-09_JPRB, 0.16235843E-09_JPRB, 0.16209259E-09_JPRB, 0.16182976E-09_JPRB, &
  & 0.16157566E-09_JPRB, 0.16132681E-09_JPRB, 0.16105571E-09_JPRB, 0.16059412E-09_JPRB /)

RGHG8(:,39,10) = (/ &
  & 0.15662134E-09_JPRB, 0.15721552E-09_JPRB, 0.15753832E-09_JPRB, 0.15782264E-09_JPRB, 0.15811197E-09_JPRB, 0.15842229E-09_JPRB, &
  & 0.15875218E-09_JPRB, 0.15910147E-09_JPRB, 0.15947114E-09_JPRB, 0.15986346E-09_JPRB, 0.16027853E-09_JPRB, 0.16071877E-09_JPRB, &
  & 0.16119087E-09_JPRB, 0.16170153E-09_JPRB, 0.16225514E-09_JPRB, 0.16284493E-09_JPRB, 0.16345879E-09_JPRB, 0.16408652E-09_JPRB, &
  & 0.16471020E-09_JPRB, 0.16531576E-09_JPRB, 0.16587801E-09_JPRB, 0.16637219E-09_JPRB, 0.16677591E-09_JPRB, 0.16708709E-09_JPRB, &
  & 0.16732021E-09_JPRB, 0.16749518E-09_JPRB, 0.16763152E-09_JPRB, 0.16774246E-09_JPRB, 0.16783627E-09_JPRB, 0.16791733E-09_JPRB, &
  & 0.16798662E-09_JPRB, 0.16804340E-09_JPRB, 0.16808553E-09_JPRB, 0.16811008E-09_JPRB, 0.16811667E-09_JPRB, 0.16810604E-09_JPRB, &
  & 0.16807662E-09_JPRB, 0.16802860E-09_JPRB, 0.16795852E-09_JPRB, 0.16786174E-09_JPRB, 0.16773109E-09_JPRB, 0.16755829E-09_JPRB, &
  & 0.16733818E-09_JPRB, 0.16707166E-09_JPRB, 0.16676731E-09_JPRB, 0.16643693E-09_JPRB, 0.16609264E-09_JPRB, 0.16574191E-09_JPRB, &
  & 0.16539031E-09_JPRB, 0.16504381E-09_JPRB, 0.16471181E-09_JPRB, 0.16440341E-09_JPRB, 0.16412145E-09_JPRB, 0.16386364E-09_JPRB, &
  & 0.16362153E-09_JPRB, 0.16338773E-09_JPRB, 0.16315352E-09_JPRB, 0.16291278E-09_JPRB, 0.16266531E-09_JPRB, 0.16241750E-09_JPRB, &
  & 0.16217448E-09_JPRB, 0.16193566E-09_JPRB, 0.16167055E-09_JPRB, 0.16122197E-09_JPRB /)

RGHG8(:,40,10) = (/ &
  & 0.15786550E-09_JPRB, 0.15836399E-09_JPRB, 0.15864980E-09_JPRB, 0.15890905E-09_JPRB, 0.15918317E-09_JPRB, 0.15947890E-09_JPRB, &
  & 0.15978974E-09_JPRB, 0.16011156E-09_JPRB, 0.16044499E-09_JPRB, 0.16079095E-09_JPRB, 0.16115201E-09_JPRB, 0.16153130E-09_JPRB, &
  & 0.16193795E-09_JPRB, 0.16238297E-09_JPRB, 0.16287280E-09_JPRB, 0.16340575E-09_JPRB, 0.16396998E-09_JPRB, 0.16455010E-09_JPRB, &
  & 0.16513370E-09_JPRB, 0.16569911E-09_JPRB, 0.16622026E-09_JPRB, 0.16666379E-09_JPRB, 0.16701512E-09_JPRB, 0.16727951E-09_JPRB, &
  & 0.16747448E-09_JPRB, 0.16762110E-09_JPRB, 0.16773603E-09_JPRB, 0.16783082E-09_JPRB, 0.16791200E-09_JPRB, 0.16798334E-09_JPRB, &
  & 0.16804540E-09_JPRB, 0.16809684E-09_JPRB, 0.16813544E-09_JPRB, 0.16815732E-09_JPRB, 0.16816309E-09_JPRB, 0.16815324E-09_JPRB, &
  & 0.16812747E-09_JPRB, 0.16808693E-09_JPRB, 0.16802901E-09_JPRB, 0.16795010E-09_JPRB, 0.16784382E-09_JPRB, 0.16770146E-09_JPRB, &
  & 0.16751692E-09_JPRB, 0.16728675E-09_JPRB, 0.16701462E-09_JPRB, 0.16671119E-09_JPRB, 0.16639033E-09_JPRB, 0.16606019E-09_JPRB, &
  & 0.16572595E-09_JPRB, 0.16539532E-09_JPRB, 0.16507717E-09_JPRB, 0.16478330E-09_JPRB, 0.16451979E-09_JPRB, 0.16428287E-09_JPRB, &
  & 0.16406522E-09_JPRB, 0.16385597E-09_JPRB, 0.16364687E-09_JPRB, 0.16342946E-09_JPRB, 0.16320328E-09_JPRB, 0.16297230E-09_JPRB, &
  & 0.16274389E-09_JPRB, 0.16251511E-09_JPRB, 0.16226222E-09_JPRB, 0.16182326E-09_JPRB /)

RGHG8(:,41,10) = (/ &
  & 0.15899269E-09_JPRB, 0.15941627E-09_JPRB, 0.15966609E-09_JPRB, 0.15990453E-09_JPRB, 0.16016427E-09_JPRB, 0.16044696E-09_JPRB, &
  & 0.16074067E-09_JPRB, 0.16103610E-09_JPRB, 0.16133395E-09_JPRB, 0.16163673E-09_JPRB, 0.16194658E-09_JPRB, 0.16226961E-09_JPRB, &
  & 0.16261689E-09_JPRB, 0.16300139E-09_JPRB, 0.16343288E-09_JPRB, 0.16391068E-09_JPRB, 0.16442457E-09_JPRB, 0.16496077E-09_JPRB, &
  & 0.16550113E-09_JPRB, 0.16602415E-09_JPRB, 0.16649468E-09_JPRB, 0.16688569E-09_JPRB, 0.16718676E-09_JPRB, 0.16741057E-09_JPRB, &
  & 0.16757631E-09_JPRB, 0.16770220E-09_JPRB, 0.16780258E-09_JPRB, 0.16788647E-09_JPRB, 0.16795972E-09_JPRB, 0.16802500E-09_JPRB, &
  & 0.16808285E-09_JPRB, 0.16813148E-09_JPRB, 0.16816819E-09_JPRB, 0.16818863E-09_JPRB, 0.16819393E-09_JPRB, 0.16818437E-09_JPRB, &
  & 0.16816090E-09_JPRB, 0.16812518E-09_JPRB, 0.16807541E-09_JPRB, 0.16800943E-09_JPRB, 0.16792140E-09_JPRB, 0.16780462E-09_JPRB, &
  & 0.16765245E-09_JPRB, 0.16745909E-09_JPRB, 0.16722301E-09_JPRB, 0.16695299E-09_JPRB, 0.16665699E-09_JPRB, 0.16634824E-09_JPRB, &
  & 0.16603273E-09_JPRB, 0.16571619E-09_JPRB, 0.16541102E-09_JPRB, 0.16513224E-09_JPRB, 0.16488516E-09_JPRB, 0.16466924E-09_JPRB, &
  & 0.16447385E-09_JPRB, 0.16428905E-09_JPRB, 0.16410358E-09_JPRB, 0.16390991E-09_JPRB, 0.16370522E-09_JPRB, 0.16349408E-09_JPRB, &
  & 0.16328169E-09_JPRB, 0.16306914E-09_JPRB, 0.16282807E-09_JPRB, 0.16240850E-09_JPRB /)

RGHG8(:,42,10) = (/ &
  & 0.16001815E-09_JPRB, 0.16038068E-09_JPRB, 0.16060332E-09_JPRB, 0.16082348E-09_JPRB, 0.16107145E-09_JPRB, 0.16134503E-09_JPRB, &
  & 0.16162202E-09_JPRB, 0.16189321E-09_JPRB, 0.16215773E-09_JPRB, 0.16241930E-09_JPRB, 0.16268262E-09_JPRB, 0.16295450E-09_JPRB, &
  & 0.16324771E-09_JPRB, 0.16357714E-09_JPRB, 0.16395431E-09_JPRB, 0.16438043E-09_JPRB, 0.16484605E-09_JPRB, 0.16533569E-09_JPRB, &
  & 0.16583186E-09_JPRB, 0.16630609E-09_JPRB, 0.16672463E-09_JPRB, 0.16706103E-09_JPRB, 0.16731644E-09_JPRB, 0.16750609E-09_JPRB, &
  & 0.16764840E-09_JPRB, 0.16775886E-09_JPRB, 0.16784867E-09_JPRB, 0.16792509E-09_JPRB, 0.16799295E-09_JPRB, 0.16805447E-09_JPRB, &
  & 0.16810980E-09_JPRB, 0.16815693E-09_JPRB, 0.16819267E-09_JPRB, 0.16821222E-09_JPRB, 0.16821723E-09_JPRB, 0.16820764E-09_JPRB, &
  & 0.16818565E-09_JPRB, 0.16815306E-09_JPRB, 0.16810922E-09_JPRB, 0.16805257E-09_JPRB, 0.16797870E-09_JPRB, 0.16788224E-09_JPRB, &
  & 0.16775757E-09_JPRB, 0.16759766E-09_JPRB, 0.16740011E-09_JPRB, 0.16716264E-09_JPRB, 0.16689668E-09_JPRB, 0.16660977E-09_JPRB, &
  & 0.16631213E-09_JPRB, 0.16601169E-09_JPRB, 0.16572071E-09_JPRB, 0.16545570E-09_JPRB, 0.16522672E-09_JPRB, 0.16503009E-09_JPRB, &
  & 0.16485636E-09_JPRB, 0.16469336E-09_JPRB, 0.16453028E-09_JPRB, 0.16435871E-09_JPRB, 0.16417590E-09_JPRB, 0.16398526E-09_JPRB, &
  & 0.16379362E-09_JPRB, 0.16359880E-09_JPRB, 0.16337892E-09_JPRB, 0.16298567E-09_JPRB /)

RGHG8(:,43,10) = (/ &
  & 0.16095650E-09_JPRB, 0.16127451E-09_JPRB, 0.16147525E-09_JPRB, 0.16168170E-09_JPRB, 0.16192228E-09_JPRB, 0.16218728E-09_JPRB, &
  & 0.16245121E-09_JPRB, 0.16269913E-09_JPRB, 0.16293285E-09_JPRB, 0.16315747E-09_JPRB, 0.16337814E-09_JPRB, 0.16360430E-09_JPRB, &
  & 0.16384909E-09_JPRB, 0.16412781E-09_JPRB, 0.16445406E-09_JPRB, 0.16483070E-09_JPRB, 0.16524791E-09_JPRB, 0.16569135E-09_JPRB, &
  & 0.16613946E-09_JPRB, 0.16656171E-09_JPRB, 0.16692189E-09_JPRB, 0.16720593E-09_JPRB, 0.16741913E-09_JPRB, 0.16757959E-09_JPRB, &
  & 0.16770293E-09_JPRB, 0.16780112E-09_JPRB, 0.16788296E-09_JPRB, 0.16795407E-09_JPRB, 0.16801820E-09_JPRB, 0.16807730E-09_JPRB, &
  & 0.16813119E-09_JPRB, 0.16817764E-09_JPRB, 0.16821297E-09_JPRB, 0.16823189E-09_JPRB, 0.16823652E-09_JPRB, 0.16822679E-09_JPRB, &
  & 0.16820573E-09_JPRB, 0.16817545E-09_JPRB, 0.16813592E-09_JPRB, 0.16808642E-09_JPRB, 0.16802360E-09_JPRB, 0.16794371E-09_JPRB, &
  & 0.16784178E-09_JPRB, 0.16771250E-09_JPRB, 0.16754885E-09_JPRB, 0.16734863E-09_JPRB, 0.16711041E-09_JPRB, 0.16684831E-09_JPRB, &
  & 0.16657058E-09_JPRB, 0.16628678E-09_JPRB, 0.16601179E-09_JPRB, 0.16576371E-09_JPRB, 0.16555197E-09_JPRB, 0.16537442E-09_JPRB, &
  & 0.16522067E-09_JPRB, 0.16507752E-09_JPRB, 0.16493472E-09_JPRB, 0.16478384E-09_JPRB, 0.16462214E-09_JPRB, 0.16445345E-09_JPRB, &
  & 0.16428349E-09_JPRB, 0.16411271E-09_JPRB, 0.16391771E-09_JPRB, 0.16356544E-09_JPRB /)

RGHG8(:,44,10) = (/ &
  & 0.16183030E-09_JPRB, 0.16211565E-09_JPRB, 0.16230052E-09_JPRB, 0.16249667E-09_JPRB, 0.16273038E-09_JPRB, 0.16299144E-09_JPRB, &
  & 0.16324160E-09_JPRB, 0.16346885E-09_JPRB, 0.16367455E-09_JPRB, 0.16386492E-09_JPRB, 0.16404852E-09_JPRB, 0.16423413E-09_JPRB, &
  & 0.16443477E-09_JPRB, 0.16466820E-09_JPRB, 0.16494660E-09_JPRB, 0.16527524E-09_JPRB, 0.16564601E-09_JPRB, 0.16604007E-09_JPRB, &
  & 0.16643534E-09_JPRB, 0.16679634E-09_JPRB, 0.16709664E-09_JPRB, 0.16732771E-09_JPRB, 0.16750337E-09_JPRB, 0.16763831E-09_JPRB, &
  & 0.16774568E-09_JPRB, 0.16783396E-09_JPRB, 0.16790962E-09_JPRB, 0.16797680E-09_JPRB, 0.16803851E-09_JPRB, 0.16809626E-09_JPRB, &
  & 0.16814952E-09_JPRB, 0.16819582E-09_JPRB, 0.16823098E-09_JPRB, 0.16824957E-09_JPRB, 0.16825373E-09_JPRB, 0.16824374E-09_JPRB, &
  & 0.16822324E-09_JPRB, 0.16819451E-09_JPRB, 0.16815835E-09_JPRB, 0.16811443E-09_JPRB, 0.16806054E-09_JPRB, 0.16799413E-09_JPRB, &
  & 0.16791156E-09_JPRB, 0.16780824E-09_JPRB, 0.16767834E-09_JPRB, 0.16751162E-09_JPRB, 0.16730797E-09_JPRB, 0.16707034E-09_JPRB, &
  & 0.16681310E-09_JPRB, 0.16654846E-09_JPRB, 0.16629188E-09_JPRB, 0.16606166E-09_JPRB, 0.16586876E-09_JPRB, 0.16571031E-09_JPRB, &
  & 0.16557428E-09_JPRB, 0.16544957E-09_JPRB, 0.16532499E-09_JPRB, 0.16519315E-09_JPRB, 0.16505193E-09_JPRB, 0.16490473E-09_JPRB, &
  & 0.16475880E-09_JPRB, 0.16461307E-09_JPRB, 0.16444782E-09_JPRB, 0.16414835E-09_JPRB /)

RGHG8(:,45,10) = (/ &
  & 0.16266011E-09_JPRB, 0.16292270E-09_JPRB, 0.16309568E-09_JPRB, 0.16328165E-09_JPRB, 0.16351320E-09_JPRB, 0.16376675E-09_JPRB, &
  & 0.16400634E-09_JPRB, 0.16421273E-09_JPRB, 0.16439150E-09_JPRB, 0.16455234E-09_JPRB, 0.16470210E-09_JPRB, 0.16485174E-09_JPRB, &
  & 0.16501547E-09_JPRB, 0.16520535E-09_JPRB, 0.16544023E-09_JPRB, 0.16572375E-09_JPRB, 0.16604576E-09_JPRB, 0.16638874E-09_JPRB, &
  & 0.16672062E-09_JPRB, 0.16701462E-09_JPRB, 0.16724966E-09_JPRB, 0.16743225E-09_JPRB, 0.16757318E-09_JPRB, 0.16768630E-09_JPRB, &
  & 0.16777993E-09_JPRB, 0.16786002E-09_JPRB, 0.16793071E-09_JPRB, 0.16799524E-09_JPRB, 0.16805542E-09_JPRB, 0.16811268E-09_JPRB, &
  & 0.16816597E-09_JPRB, 0.16821258E-09_JPRB, 0.16824780E-09_JPRB, 0.16826611E-09_JPRB, 0.16826965E-09_JPRB, 0.16825934E-09_JPRB, &
  & 0.16823906E-09_JPRB, 0.16821144E-09_JPRB, 0.16817778E-09_JPRB, 0.16813831E-09_JPRB, 0.16809172E-09_JPRB, 0.16803645E-09_JPRB, &
  & 0.16797017E-09_JPRB, 0.16789002E-09_JPRB, 0.16778903E-09_JPRB, 0.16765922E-09_JPRB, 0.16748951E-09_JPRB, 0.16728212E-09_JPRB, &
  & 0.16704785E-09_JPRB, 0.16680261E-09_JPRB, 0.16656525E-09_JPRB, 0.16635594E-09_JPRB, 0.16618232E-09_JPRB, 0.16604201E-09_JPRB, &
  & 0.16592384E-09_JPRB, 0.16581536E-09_JPRB, 0.16570764E-09_JPRB, 0.16559372E-09_JPRB, 0.16547141E-09_JPRB, 0.16534552E-09_JPRB, &
  & 0.16522225E-09_JPRB, 0.16510150E-09_JPRB, 0.16496667E-09_JPRB, 0.16472246E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART19',1,ZHOOK_HANDLE)
END SUBROUTINE PART19




SUBROUTINE PART20
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART20',0,ZHOOK_HANDLE)



RGHG8(:,46,10) = (/ &
  & 0.16346377E-09_JPRB, 0.16371215E-09_JPRB, 0.16387457E-09_JPRB, 0.16405652E-09_JPRB, 0.16427799E-09_JPRB, 0.16452995E-09_JPRB, &
  & 0.16475281E-09_JPRB, 0.16493870E-09_JPRB, 0.16509248E-09_JPRB, 0.16522374E-09_JPRB, 0.16534421E-09_JPRB, 0.16546332E-09_JPRB, &
  & 0.16559132E-09_JPRB, 0.16574649E-09_JPRB, 0.16593878E-09_JPRB, 0.16617729E-09_JPRB, 0.16645166E-09_JPRB, 0.16673198E-09_JPRB, &
  & 0.16699377E-09_JPRB, 0.16721130E-09_JPRB, 0.16738516E-09_JPRB, 0.16752096E-09_JPRB, 0.16763210E-09_JPRB, 0.16772585E-09_JPRB, &
  & 0.16780770E-09_JPRB, 0.16788085E-09_JPRB, 0.16794771E-09_JPRB, 0.16801033E-09_JPRB, 0.16806992E-09_JPRB, 0.16812739E-09_JPRB, &
  & 0.16818125E-09_JPRB, 0.16822851E-09_JPRB, 0.16826390E-09_JPRB, 0.16828199E-09_JPRB, 0.16828483E-09_JPRB, 0.16827410E-09_JPRB, &
  & 0.16825372E-09_JPRB, 0.16822688E-09_JPRB, 0.16819507E-09_JPRB, 0.16815921E-09_JPRB, 0.16811860E-09_JPRB, 0.16807265E-09_JPRB, &
  & 0.16802013E-09_JPRB, 0.16795909E-09_JPRB, 0.16788512E-09_JPRB, 0.16778845E-09_JPRB, 0.16765782E-09_JPRB, 0.16748607E-09_JPRB, &
  & 0.16727815E-09_JPRB, 0.16705504E-09_JPRB, 0.16683900E-09_JPRB, 0.16664867E-09_JPRB, 0.16649615E-09_JPRB, 0.16637366E-09_JPRB, &
  & 0.16627148E-09_JPRB, 0.16617852E-09_JPRB, 0.16608599E-09_JPRB, 0.16598820E-09_JPRB, 0.16588370E-09_JPRB, 0.16577673E-09_JPRB, &
  & 0.16567393E-09_JPRB, 0.16557528E-09_JPRB, 0.16546635E-09_JPRB, 0.16527310E-09_JPRB /)

RGHG8(:,47,10) = (/ &
  & 0.16425906E-09_JPRB, 0.16449721E-09_JPRB, 0.16465661E-09_JPRB, 0.16482718E-09_JPRB, 0.16504888E-09_JPRB, 0.16528352E-09_JPRB, &
  & 0.16549286E-09_JPRB, 0.16565441E-09_JPRB, 0.16578082E-09_JPRB, 0.16588586E-09_JPRB, 0.16597836E-09_JPRB, 0.16606870E-09_JPRB, &
  & 0.16616872E-09_JPRB, 0.16628748E-09_JPRB, 0.16644278E-09_JPRB, 0.16663612E-09_JPRB, 0.16685167E-09_JPRB, 0.16706293E-09_JPRB, &
  & 0.16724205E-09_JPRB, 0.16738709E-09_JPRB, 0.16750140E-09_JPRB, 0.16759755E-09_JPRB, 0.16768167E-09_JPRB, 0.16775885E-09_JPRB, &
  & 0.16783044E-09_JPRB, 0.16789772E-09_JPRB, 0.16796148E-09_JPRB, 0.16802303E-09_JPRB, 0.16808263E-09_JPRB, 0.16814092E-09_JPRB, &
  & 0.16819583E-09_JPRB, 0.16824399E-09_JPRB, 0.16827958E-09_JPRB, 0.16829747E-09_JPRB, 0.16829946E-09_JPRB, 0.16828824E-09_JPRB, &
  & 0.16826758E-09_JPRB, 0.16824113E-09_JPRB, 0.16821070E-09_JPRB, 0.16817771E-09_JPRB, 0.16814208E-09_JPRB, 0.16810393E-09_JPRB, &
  & 0.16806284E-09_JPRB, 0.16801815E-09_JPRB, 0.16796640E-09_JPRB, 0.16790053E-09_JPRB, 0.16780895E-09_JPRB, 0.16767762E-09_JPRB, &
  & 0.16750763E-09_JPRB, 0.16731042E-09_JPRB, 0.16711568E-09_JPRB, 0.16694762E-09_JPRB, 0.16681206E-09_JPRB, 0.16670688E-09_JPRB, &
  & 0.16661916E-09_JPRB, 0.16653948E-09_JPRB, 0.16646039E-09_JPRB, 0.16637636E-09_JPRB, 0.16628694E-09_JPRB, 0.16619614E-09_JPRB, &
  & 0.16611026E-09_JPRB, 0.16602887E-09_JPRB, 0.16594097E-09_JPRB, 0.16578673E-09_JPRB /)

RGHG8(:,48,10) = (/ &
  & 0.16505283E-09_JPRB, 0.16529109E-09_JPRB, 0.16544398E-09_JPRB, 0.16561427E-09_JPRB, 0.16581866E-09_JPRB, 0.16604590E-09_JPRB, &
  & 0.16622878E-09_JPRB, 0.16636453E-09_JPRB, 0.16646387E-09_JPRB, 0.16654082E-09_JPRB, 0.16660739E-09_JPRB, 0.16667172E-09_JPRB, &
  & 0.16674183E-09_JPRB, 0.16683027E-09_JPRB, 0.16694301E-09_JPRB, 0.16708418E-09_JPRB, 0.16723135E-09_JPRB, 0.16735893E-09_JPRB, &
  & 0.16745944E-09_JPRB, 0.16753632E-09_JPRB, 0.16760156E-09_JPRB, 0.16766244E-09_JPRB, 0.16772392E-09_JPRB, 0.16778641E-09_JPRB, &
  & 0.16784917E-09_JPRB, 0.16791153E-09_JPRB, 0.16797301E-09_JPRB, 0.16803403E-09_JPRB, 0.16809427E-09_JPRB, 0.16815382E-09_JPRB, &
  & 0.16821010E-09_JPRB, 0.16825917E-09_JPRB, 0.16829507E-09_JPRB, 0.16831274E-09_JPRB, 0.16831386E-09_JPRB, 0.16830204E-09_JPRB, &
  & 0.16828088E-09_JPRB, 0.16825456E-09_JPRB, 0.16822507E-09_JPRB, 0.16819440E-09_JPRB, 0.16816290E-09_JPRB, 0.16813129E-09_JPRB, &
  & 0.16809983E-09_JPRB, 0.16806846E-09_JPRB, 0.16803521E-09_JPRB, 0.16799527E-09_JPRB, 0.16793830E-09_JPRB, 0.16785241E-09_JPRB, &
  & 0.16772572E-09_JPRB, 0.16756881E-09_JPRB, 0.16740181E-09_JPRB, 0.16725391E-09_JPRB, 0.16713711E-09_JPRB, 0.16704516E-09_JPRB, &
  & 0.16696942E-09_JPRB, 0.16690062E-09_JPRB, 0.16683195E-09_JPRB, 0.16675916E-09_JPRB, 0.16668138E-09_JPRB, 0.16660331E-09_JPRB, &
  & 0.16652993E-09_JPRB, 0.16646150E-09_JPRB, 0.16638801E-09_JPRB, 0.16626124E-09_JPRB /)

RGHG8(:,49,10) = (/ &
  & 0.16584227E-09_JPRB, 0.16607803E-09_JPRB, 0.16623100E-09_JPRB, 0.16639085E-09_JPRB, 0.16658838E-09_JPRB, 0.16678965E-09_JPRB, &
  & 0.16694873E-09_JPRB, 0.16705412E-09_JPRB, 0.16712470E-09_JPRB, 0.16717563E-09_JPRB, 0.16721635E-09_JPRB, 0.16725477E-09_JPRB, &
  & 0.16729720E-09_JPRB, 0.16734836E-09_JPRB, 0.16741608E-09_JPRB, 0.16748997E-09_JPRB, 0.16755800E-09_JPRB, 0.16760655E-09_JPRB, &
  & 0.16763779E-09_JPRB, 0.16766126E-09_JPRB, 0.16768598E-09_JPRB, 0.16771838E-09_JPRB, 0.16775989E-09_JPRB, 0.16780967E-09_JPRB, &
  & 0.16786476E-09_JPRB, 0.16792309E-09_JPRB, 0.16798297E-09_JPRB, 0.16804408E-09_JPRB, 0.16810534E-09_JPRB, 0.16816641E-09_JPRB, &
  & 0.16822420E-09_JPRB, 0.16827444E-09_JPRB, 0.16831050E-09_JPRB, 0.16832795E-09_JPRB, 0.16832820E-09_JPRB, 0.16831558E-09_JPRB, &
  & 0.16829381E-09_JPRB, 0.16826733E-09_JPRB, 0.16823860E-09_JPRB, 0.16820978E-09_JPRB, 0.16818179E-09_JPRB, 0.16815570E-09_JPRB, &
  & 0.16813229E-09_JPRB, 0.16811189E-09_JPRB, 0.16809371E-09_JPRB, 0.16807422E-09_JPRB, 0.16804681E-09_JPRB, 0.16799982E-09_JPRB, &
  & 0.16792363E-09_JPRB, 0.16781430E-09_JPRB, 0.16769044E-09_JPRB, 0.16757090E-09_JPRB, 0.16747215E-09_JPRB, 0.16739325E-09_JPRB, &
  & 0.16732715E-09_JPRB, 0.16726663E-09_JPRB, 0.16720589E-09_JPRB, 0.16714111E-09_JPRB, 0.16707197E-09_JPRB, 0.16700258E-09_JPRB, &
  & 0.16693802E-09_JPRB, 0.16687805E-09_JPRB, 0.16681360E-09_JPRB, 0.16670414E-09_JPRB /)

RGHG8(:,50,10) = (/ &
  & 0.16658547E-09_JPRB, 0.16681230E-09_JPRB, 0.16695309E-09_JPRB, 0.16709975E-09_JPRB, 0.16727397E-09_JPRB, 0.16744799E-09_JPRB, &
  & 0.16757165E-09_JPRB, 0.16764654E-09_JPRB, 0.16769050E-09_JPRB, 0.16771805E-09_JPRB, 0.16773760E-09_JPRB, 0.16775353E-09_JPRB, &
  & 0.16776883E-09_JPRB, 0.16778580E-09_JPRB, 0.16780134E-09_JPRB, 0.16781260E-09_JPRB, 0.16781138E-09_JPRB, 0.16779853E-09_JPRB, &
  & 0.16778018E-09_JPRB, 0.16776411E-09_JPRB, 0.16775802E-09_JPRB, 0.16776668E-09_JPRB, 0.16779109E-09_JPRB, 0.16782942E-09_JPRB, &
  & 0.16787791E-09_JPRB, 0.16793301E-09_JPRB, 0.16799206E-09_JPRB, 0.16805360E-09_JPRB, 0.16811628E-09_JPRB, 0.16817896E-09_JPRB, &
  & 0.16823849E-09_JPRB, 0.16828970E-09_JPRB, 0.16832605E-09_JPRB, 0.16834323E-09_JPRB, 0.16834270E-09_JPRB, 0.16832916E-09_JPRB, &
  & 0.16830669E-09_JPRB, 0.16827988E-09_JPRB, 0.16825162E-09_JPRB, 0.16822428E-09_JPRB, 0.16819918E-09_JPRB, 0.16817781E-09_JPRB, &
  & 0.16816126E-09_JPRB, 0.16815029E-09_JPRB, 0.16814428E-09_JPRB, 0.16814121E-09_JPRB, 0.16813613E-09_JPRB, 0.16812103E-09_JPRB, &
  & 0.16808627E-09_JPRB, 0.16802952E-09_JPRB, 0.16795415E-09_JPRB, 0.16787628E-09_JPRB, 0.16780438E-09_JPRB, 0.16774322E-09_JPRB, &
  & 0.16768888E-09_JPRB, 0.16763761E-09_JPRB, 0.16758510E-09_JPRB, 0.16752741E-09_JPRB, 0.16746554E-09_JPRB, 0.16740284E-09_JPRB, &
  & 0.16734454E-09_JPRB, 0.16728915E-09_JPRB, 0.16723027E-09_JPRB, 0.16712717E-09_JPRB /)

RGHG8(:,51,10) = (/ &
  & 0.16722781E-09_JPRB, 0.16741734E-09_JPRB, 0.16753234E-09_JPRB, 0.16765143E-09_JPRB, 0.16779006E-09_JPRB, 0.16792372E-09_JPRB, &
  & 0.16801086E-09_JPRB, 0.16805693E-09_JPRB, 0.16808044E-09_JPRB, 0.16809265E-09_JPRB, 0.16809835E-09_JPRB, 0.16809984E-09_JPRB, &
  & 0.16809724E-09_JPRB, 0.16808885E-09_JPRB, 0.16807053E-09_JPRB, 0.16803965E-09_JPRB, 0.16799503E-09_JPRB, 0.16794452E-09_JPRB, &
  & 0.16789370E-09_JPRB, 0.16785033E-09_JPRB, 0.16782054E-09_JPRB, 0.16780946E-09_JPRB, 0.16781868E-09_JPRB, 0.16784663E-09_JPRB, &
  & 0.16788924E-09_JPRB, 0.16794177E-09_JPRB, 0.16800053E-09_JPRB, 0.16806292E-09_JPRB, 0.16812728E-09_JPRB, 0.16819182E-09_JPRB, &
  & 0.16825298E-09_JPRB, 0.16830536E-09_JPRB, 0.16834190E-09_JPRB, 0.16835881E-09_JPRB, 0.16835752E-09_JPRB, 0.16834298E-09_JPRB, &
  & 0.16831969E-09_JPRB, 0.16829246E-09_JPRB, 0.16826449E-09_JPRB, 0.16823820E-09_JPRB, 0.16821551E-09_JPRB, 0.16819812E-09_JPRB, &
  & 0.16818777E-09_JPRB, 0.16818492E-09_JPRB, 0.16818932E-09_JPRB, 0.16819951E-09_JPRB, 0.16821169E-09_JPRB, 0.16821955E-09_JPRB, &
  & 0.16821637E-09_JPRB, 0.16819836E-09_JPRB, 0.16816877E-09_JPRB, 0.16813179E-09_JPRB, 0.16809452E-09_JPRB, 0.16805835E-09_JPRB, &
  & 0.16802418E-09_JPRB, 0.16798887E-09_JPRB, 0.16794963E-09_JPRB, 0.16790502E-09_JPRB, 0.16785355E-09_JPRB, 0.16780055E-09_JPRB, &
  & 0.16774866E-09_JPRB, 0.16769916E-09_JPRB, 0.16764157E-09_JPRB, 0.16754322E-09_JPRB /)

RGHG8(:,52,10) = (/ &
  & 0.16775475E-09_JPRB, 0.16786850E-09_JPRB, 0.16794373E-09_JPRB, 0.16802799E-09_JPRB, 0.16813027E-09_JPRB, 0.16822339E-09_JPRB, &
  & 0.16827822E-09_JPRB, 0.16830408E-09_JPRB, 0.16831501E-09_JPRB, 0.16831844E-09_JPRB, 0.16831722E-09_JPRB, 0.16831186E-09_JPRB, &
  & 0.16830076E-09_JPRB, 0.16828046E-09_JPRB, 0.16824730E-09_JPRB, 0.16819435E-09_JPRB, 0.16812957E-09_JPRB, 0.16805721E-09_JPRB, &
  & 0.16798699E-09_JPRB, 0.16792413E-09_JPRB, 0.16787594E-09_JPRB, 0.16784799E-09_JPRB, 0.16784360E-09_JPRB, 0.16786211E-09_JPRB, &
  & 0.16789946E-09_JPRB, 0.16794999E-09_JPRB, 0.16800866E-09_JPRB, 0.16807228E-09_JPRB, 0.16813846E-09_JPRB, 0.16820489E-09_JPRB, &
  & 0.16826791E-09_JPRB, 0.16832138E-09_JPRB, 0.16835822E-09_JPRB, 0.16837487E-09_JPRB, 0.16837286E-09_JPRB, 0.16835727E-09_JPRB, &
  & 0.16833318E-09_JPRB, 0.16830534E-09_JPRB, 0.16827742E-09_JPRB, 0.16825194E-09_JPRB, 0.16823107E-09_JPRB, 0.16821729E-09_JPRB, &
  & 0.16821239E-09_JPRB, 0.16821697E-09_JPRB, 0.16823087E-09_JPRB, 0.16825190E-09_JPRB, 0.16827754E-09_JPRB, 0.16830193E-09_JPRB, &
  & 0.16831919E-09_JPRB, 0.16832702E-09_JPRB, 0.16832588E-09_JPRB, 0.16831868E-09_JPRB, 0.16830781E-09_JPRB, 0.16829545E-09_JPRB, &
  & 0.16828111E-09_JPRB, 0.16826460E-09_JPRB, 0.16824389E-09_JPRB, 0.16821654E-09_JPRB, 0.16818340E-09_JPRB, 0.16814558E-09_JPRB, &
  & 0.16810775E-09_JPRB, 0.16806770E-09_JPRB, 0.16802104E-09_JPRB, 0.16792755E-09_JPRB /)

RGHG8(:,53,10) = (/ &
  & 0.16805887E-09_JPRB, 0.16815178E-09_JPRB, 0.16821242E-09_JPRB, 0.16827448E-09_JPRB, 0.16834700E-09_JPRB, 0.16840856E-09_JPRB, &
  & 0.16844139E-09_JPRB, 0.16845414E-09_JPRB, 0.16845779E-09_JPRB, 0.16845680E-09_JPRB, 0.16845261E-09_JPRB, 0.16844438E-09_JPRB, &
  & 0.16843053E-09_JPRB, 0.16840705E-09_JPRB, 0.16836638E-09_JPRB, 0.16830859E-09_JPRB, 0.16823173E-09_JPRB, 0.16814897E-09_JPRB, &
  & 0.16806569E-09_JPRB, 0.16798908E-09_JPRB, 0.16792570E-09_JPRB, 0.16788325E-09_JPRB, 0.16786664E-09_JPRB, 0.16787659E-09_JPRB, &
  & 0.16790938E-09_JPRB, 0.16795783E-09_JPRB, 0.16801695E-09_JPRB, 0.16808153E-09_JPRB, 0.16814994E-09_JPRB, 0.16821843E-09_JPRB, &
  & 0.16828330E-09_JPRB, 0.16833798E-09_JPRB, 0.16837513E-09_JPRB, 0.16839162E-09_JPRB, 0.16838891E-09_JPRB, 0.16837233E-09_JPRB, &
  & 0.16834724E-09_JPRB, 0.16831883E-09_JPRB, 0.16829077E-09_JPRB, 0.16826569E-09_JPRB, 0.16824636E-09_JPRB, 0.16823556E-09_JPRB, &
  & 0.16823576E-09_JPRB, 0.16824758E-09_JPRB, 0.16826945E-09_JPRB, 0.16830073E-09_JPRB, 0.16833680E-09_JPRB, 0.16837268E-09_JPRB, &
  & 0.16840293E-09_JPRB, 0.16842508E-09_JPRB, 0.16843954E-09_JPRB, 0.16844762E-09_JPRB, 0.16845110E-09_JPRB, 0.16845147E-09_JPRB, &
  & 0.16844945E-09_JPRB, 0.16844486E-09_JPRB, 0.16843693E-09_JPRB, 0.16842468E-09_JPRB, 0.16840704E-09_JPRB, 0.16838629E-09_JPRB, &
  & 0.16836373E-09_JPRB, 0.16834031E-09_JPRB, 0.16830934E-09_JPRB, 0.16824443E-09_JPRB /)

RGHG8(:,54,10) = (/ &
  & 0.16828722E-09_JPRB, 0.16835619E-09_JPRB, 0.16839695E-09_JPRB, 0.16844257E-09_JPRB, 0.16849117E-09_JPRB, 0.16853059E-09_JPRB, &
  & 0.16854798E-09_JPRB, 0.16855323E-09_JPRB, 0.16855302E-09_JPRB, 0.16854998E-09_JPRB, 0.16854440E-09_JPRB, 0.16853580E-09_JPRB, &
  & 0.16852147E-09_JPRB, 0.16849740E-09_JPRB, 0.16845850E-09_JPRB, 0.16839566E-09_JPRB, 0.16831685E-09_JPRB, 0.16822660E-09_JPRB, &
  & 0.16813452E-09_JPRB, 0.16804666E-09_JPRB, 0.16797072E-09_JPRB, 0.16791557E-09_JPRB, 0.16788845E-09_JPRB, 0.16789110E-09_JPRB, &
  & 0.16791946E-09_JPRB, 0.16796646E-09_JPRB, 0.16802500E-09_JPRB, 0.16809136E-09_JPRB, 0.16816162E-09_JPRB, 0.16823247E-09_JPRB, &
  & 0.16829942E-09_JPRB, 0.16835522E-09_JPRB, 0.16839287E-09_JPRB, 0.16840929E-09_JPRB, 0.16840597E-09_JPRB, 0.16838843E-09_JPRB, &
  & 0.16836242E-09_JPRB, 0.16833328E-09_JPRB, 0.16830483E-09_JPRB, 0.16828004E-09_JPRB, 0.16826182E-09_JPRB, 0.16825379E-09_JPRB, &
  & 0.16825866E-09_JPRB, 0.16827632E-09_JPRB, 0.16830692E-09_JPRB, 0.16834589E-09_JPRB, 0.16839109E-09_JPRB, 0.16843524E-09_JPRB, &
  & 0.16847351E-09_JPRB, 0.16850341E-09_JPRB, 0.16852542E-09_JPRB, 0.16854043E-09_JPRB, 0.16855035E-09_JPRB, 0.16855614E-09_JPRB, &
  & 0.16855958E-09_JPRB, 0.16856068E-09_JPRB, 0.16855942E-09_JPRB, 0.16855506E-09_JPRB, 0.16854743E-09_JPRB, 0.16853730E-09_JPRB, &
  & 0.16852666E-09_JPRB, 0.16851609E-09_JPRB, 0.16850570E-09_JPRB, 0.16849144E-09_JPRB /)

RGHG8(:,55,10) = (/ &
  & 0.16844517E-09_JPRB, 0.16849709E-09_JPRB, 0.16853090E-09_JPRB, 0.16856108E-09_JPRB, 0.16859433E-09_JPRB, 0.16861655E-09_JPRB, &
  & 0.16862503E-09_JPRB, 0.16862584E-09_JPRB, 0.16862367E-09_JPRB, 0.16861970E-09_JPRB, 0.16861409E-09_JPRB, 0.16860548E-09_JPRB, &
  & 0.16859231E-09_JPRB, 0.16857016E-09_JPRB, 0.16853145E-09_JPRB, 0.16847264E-09_JPRB, 0.16838994E-09_JPRB, 0.16829541E-09_JPRB, &
  & 0.16819598E-09_JPRB, 0.16809831E-09_JPRB, 0.16801127E-09_JPRB, 0.16794556E-09_JPRB, 0.16790980E-09_JPRB, 0.16790631E-09_JPRB, &
  & 0.16793088E-09_JPRB, 0.16797566E-09_JPRB, 0.16803434E-09_JPRB, 0.16810162E-09_JPRB, 0.16817418E-09_JPRB, 0.16824740E-09_JPRB, &
  & 0.16831636E-09_JPRB, 0.16837341E-09_JPRB, 0.16841159E-09_JPRB, 0.16842809E-09_JPRB, 0.16842433E-09_JPRB, 0.16840594E-09_JPRB, &
  & 0.16837902E-09_JPRB, 0.16834902E-09_JPRB, 0.16832014E-09_JPRB, 0.16829541E-09_JPRB, 0.16827831E-09_JPRB, 0.16827267E-09_JPRB, &
  & 0.16828133E-09_JPRB, 0.16830543E-09_JPRB, 0.16834166E-09_JPRB, 0.16838921E-09_JPRB, 0.16844118E-09_JPRB, 0.16849191E-09_JPRB, &
  & 0.16853532E-09_JPRB, 0.16856996E-09_JPRB, 0.16859550E-09_JPRB, 0.16861361E-09_JPRB, 0.16862543E-09_JPRB, 0.16863377E-09_JPRB, &
  & 0.16863894E-09_JPRB, 0.16864249E-09_JPRB, 0.16864417E-09_JPRB, 0.16864368E-09_JPRB, 0.16864060E-09_JPRB, 0.16863556E-09_JPRB, &
  & 0.16862944E-09_JPRB, 0.16862273E-09_JPRB, 0.16861430E-09_JPRB, 0.16859876E-09_JPRB /)

RGHG8(:,56,10) = (/ &
  & 0.16856735E-09_JPRB, 0.16860860E-09_JPRB, 0.16862997E-09_JPRB, 0.16865216E-09_JPRB, 0.16867158E-09_JPRB, 0.16868384E-09_JPRB, &
  & 0.16868641E-09_JPRB, 0.16868482E-09_JPRB, 0.16868176E-09_JPRB, 0.16867764E-09_JPRB, 0.16867210E-09_JPRB, 0.16866444E-09_JPRB, &
  & 0.16865223E-09_JPRB, 0.16863219E-09_JPRB, 0.16859777E-09_JPRB, 0.16853893E-09_JPRB, 0.16845746E-09_JPRB, 0.16835824E-09_JPRB, &
  & 0.16825141E-09_JPRB, 0.16814487E-09_JPRB, 0.16804859E-09_JPRB, 0.16797426E-09_JPRB, 0.16793171E-09_JPRB, 0.16792312E-09_JPRB, &
  & 0.16794402E-09_JPRB, 0.16798696E-09_JPRB, 0.16804487E-09_JPRB, 0.16811344E-09_JPRB, 0.16818792E-09_JPRB, 0.16826360E-09_JPRB, &
  & 0.16833458E-09_JPRB, 0.16839284E-09_JPRB, 0.16843184E-09_JPRB, 0.16844848E-09_JPRB, 0.16844437E-09_JPRB, 0.16842532E-09_JPRB, &
  & 0.16839757E-09_JPRB, 0.16836670E-09_JPRB, 0.16833714E-09_JPRB, 0.16831252E-09_JPRB, 0.16829635E-09_JPRB, 0.16829299E-09_JPRB, &
  & 0.16830544E-09_JPRB, 0.16833349E-09_JPRB, 0.16837665E-09_JPRB, 0.16842956E-09_JPRB, 0.16848821E-09_JPRB, 0.16854405E-09_JPRB, &
  & 0.16859211E-09_JPRB, 0.16862930E-09_JPRB, 0.16865702E-09_JPRB, 0.16867585E-09_JPRB, 0.16868884E-09_JPRB, 0.16869695E-09_JPRB, &
  & 0.16870313E-09_JPRB, 0.16870724E-09_JPRB, 0.16871009E-09_JPRB, 0.16871124E-09_JPRB, 0.16871041E-09_JPRB, 0.16870785E-09_JPRB, &
  & 0.16870427E-09_JPRB, 0.16870011E-09_JPRB, 0.16869514E-09_JPRB, 0.16868611E-09_JPRB /)

RGHG8(:,57,10) = (/ &
  & 0.16866081E-09_JPRB, 0.16869207E-09_JPRB, 0.16870975E-09_JPRB, 0.16872322E-09_JPRB, 0.16873480E-09_JPRB, 0.16873984E-09_JPRB, &
  & 0.16873929E-09_JPRB, 0.16873668E-09_JPRB, 0.16873339E-09_JPRB, 0.16872942E-09_JPRB, 0.16872441E-09_JPRB, 0.16871729E-09_JPRB, &
  & 0.16870673E-09_JPRB, 0.16868859E-09_JPRB, 0.16865678E-09_JPRB, 0.16860249E-09_JPRB, 0.16851917E-09_JPRB, 0.16841578E-09_JPRB, &
  & 0.16830205E-09_JPRB, 0.16818782E-09_JPRB, 0.16808362E-09_JPRB, 0.16800310E-09_JPRB, 0.16795536E-09_JPRB, 0.16794240E-09_JPRB, &
  & 0.16795983E-09_JPRB, 0.16800066E-09_JPRB, 0.16805810E-09_JPRB, 0.16812735E-09_JPRB, 0.16820365E-09_JPRB, 0.16828149E-09_JPRB, &
  & 0.16835439E-09_JPRB, 0.16841407E-09_JPRB, 0.16845404E-09_JPRB, 0.16847101E-09_JPRB, 0.16846673E-09_JPRB, 0.16844713E-09_JPRB, &
  & 0.16841860E-09_JPRB, 0.16838678E-09_JPRB, 0.16835662E-09_JPRB, 0.16833182E-09_JPRB, 0.16831671E-09_JPRB, 0.16831546E-09_JPRB, &
  & 0.16833088E-09_JPRB, 0.16836339E-09_JPRB, 0.16841042E-09_JPRB, 0.16846895E-09_JPRB, 0.16853244E-09_JPRB, 0.16859335E-09_JPRB, &
  & 0.16864468E-09_JPRB, 0.16868511E-09_JPRB, 0.16871360E-09_JPRB, 0.16873294E-09_JPRB, 0.16874496E-09_JPRB, 0.16875350E-09_JPRB, &
  & 0.16875897E-09_JPRB, 0.16876328E-09_JPRB, 0.16876628E-09_JPRB, 0.16876789E-09_JPRB, 0.16876786E-09_JPRB, 0.16876635E-09_JPRB, &
  & 0.16876385E-09_JPRB, 0.16876067E-09_JPRB, 0.16875630E-09_JPRB, 0.16874753E-09_JPRB /)

RGHG8(:,58,10) = (/ &
  & 0.16874269E-09_JPRB, 0.16876456E-09_JPRB, 0.16877497E-09_JPRB, 0.16878367E-09_JPRB, 0.16878920E-09_JPRB, 0.16879033E-09_JPRB, &
  & 0.16878826E-09_JPRB, 0.16878525E-09_JPRB, 0.16878211E-09_JPRB, 0.16877849E-09_JPRB, 0.16877391E-09_JPRB, 0.16876775E-09_JPRB, &
  & 0.16875787E-09_JPRB, 0.16874205E-09_JPRB, 0.16871252E-09_JPRB, 0.16866011E-09_JPRB, 0.16857726E-09_JPRB, 0.16846896E-09_JPRB, &
  & 0.16834910E-09_JPRB, 0.16822795E-09_JPRB, 0.16811889E-09_JPRB, 0.16803370E-09_JPRB, 0.16798171E-09_JPRB, 0.16796491E-09_JPRB, &
  & 0.16797916E-09_JPRB, 0.16801791E-09_JPRB, 0.16807469E-09_JPRB, 0.16814436E-09_JPRB, 0.16822217E-09_JPRB, 0.16830184E-09_JPRB, &
  & 0.16837644E-09_JPRB, 0.16843783E-09_JPRB, 0.16847891E-09_JPRB, 0.16849643E-09_JPRB, 0.16849211E-09_JPRB, 0.16847217E-09_JPRB, &
  & 0.16844287E-09_JPRB, 0.16841012E-09_JPRB, 0.16837905E-09_JPRB, 0.16835421E-09_JPRB, 0.16833977E-09_JPRB, 0.16834047E-09_JPRB, &
  & 0.16835884E-09_JPRB, 0.16839449E-09_JPRB, 0.16844548E-09_JPRB, 0.16850760E-09_JPRB, 0.16857507E-09_JPRB, 0.16863995E-09_JPRB, &
  & 0.16869571E-09_JPRB, 0.16873800E-09_JPRB, 0.16876781E-09_JPRB, 0.16878640E-09_JPRB, 0.16879842E-09_JPRB, 0.16880561E-09_JPRB, &
  & 0.16881101E-09_JPRB, 0.16881474E-09_JPRB, 0.16881746E-09_JPRB, 0.16881896E-09_JPRB, 0.16881900E-09_JPRB, 0.16881779E-09_JPRB, &
  & 0.16881574E-09_JPRB, 0.16881313E-09_JPRB, 0.16880966E-09_JPRB, 0.16880279E-09_JPRB /)

RGHG8(:,59,10) = (/ &
  & 0.16880417E-09_JPRB, 0.16882279E-09_JPRB, 0.16883135E-09_JPRB, 0.16883656E-09_JPRB, 0.16883883E-09_JPRB, 0.16883797E-09_JPRB, &
  & 0.16883535E-09_JPRB, 0.16883252E-09_JPRB, 0.16882973E-09_JPRB, 0.16882655E-09_JPRB, 0.16882259E-09_JPRB, 0.16881685E-09_JPRB, &
  & 0.16880834E-09_JPRB, 0.16879281E-09_JPRB, 0.16876582E-09_JPRB, 0.16871426E-09_JPRB, 0.16863039E-09_JPRB, 0.16851859E-09_JPRB, &
  & 0.16839319E-09_JPRB, 0.16826841E-09_JPRB, 0.16815538E-09_JPRB, 0.16806724E-09_JPRB, 0.16801197E-09_JPRB, 0.16799154E-09_JPRB, &
  & 0.16800282E-09_JPRB, 0.16803964E-09_JPRB, 0.16809563E-09_JPRB, 0.16816551E-09_JPRB, 0.16824446E-09_JPRB, 0.16832540E-09_JPRB, &
  & 0.16840179E-09_JPRB, 0.16846485E-09_JPRB, 0.16850728E-09_JPRB, 0.16852535E-09_JPRB, 0.16852121E-09_JPRB, 0.16850102E-09_JPRB, &
  & 0.16847096E-09_JPRB, 0.16843718E-09_JPRB, 0.16840543E-09_JPRB, 0.16838003E-09_JPRB, 0.16836628E-09_JPRB, 0.16836865E-09_JPRB, &
  & 0.16838943E-09_JPRB, 0.16842815E-09_JPRB, 0.16848209E-09_JPRB, 0.16854677E-09_JPRB, 0.16861727E-09_JPRB, 0.16868551E-09_JPRB, &
  & 0.16874437E-09_JPRB, 0.16878973E-09_JPRB, 0.16882014E-09_JPRB, 0.16883883E-09_JPRB, 0.16884949E-09_JPRB, 0.16885657E-09_JPRB, &
  & 0.16886095E-09_JPRB, 0.16886420E-09_JPRB, 0.16886634E-09_JPRB, 0.16886731E-09_JPRB, 0.16886698E-09_JPRB, 0.16886556E-09_JPRB, &
  & 0.16886345E-09_JPRB, 0.16886083E-09_JPRB, 0.16885725E-09_JPRB, 0.16885021E-09_JPRB /)

RGHG8(:,60,10) = (/ &
  & 0.16886183E-09_JPRB, 0.16887694E-09_JPRB, 0.16888271E-09_JPRB, 0.16888585E-09_JPRB, 0.16888635E-09_JPRB, 0.16888473E-09_JPRB, &
  & 0.16888214E-09_JPRB, 0.16887965E-09_JPRB, 0.16887733E-09_JPRB, 0.16887465E-09_JPRB, 0.16887117E-09_JPRB, 0.16886623E-09_JPRB, &
  & 0.16885779E-09_JPRB, 0.16884391E-09_JPRB, 0.16881585E-09_JPRB, 0.16876553E-09_JPRB, 0.16867954E-09_JPRB, 0.16856477E-09_JPRB, &
  & 0.16843724E-09_JPRB, 0.16830957E-09_JPRB, 0.16819511E-09_JPRB, 0.16810481E-09_JPRB, 0.16804672E-09_JPRB, 0.16802329E-09_JPRB, &
  & 0.16803182E-09_JPRB, 0.16806685E-09_JPRB, 0.16812193E-09_JPRB, 0.16819178E-09_JPRB, 0.16827126E-09_JPRB, 0.16835347E-09_JPRB, &
  & 0.16843135E-09_JPRB, 0.16849615E-09_JPRB, 0.16853982E-09_JPRB, 0.16855861E-09_JPRB, 0.16855473E-09_JPRB, 0.16853427E-09_JPRB, &
  & 0.16850343E-09_JPRB, 0.16846881E-09_JPRB, 0.16843610E-09_JPRB, 0.16841024E-09_JPRB, 0.16839675E-09_JPRB, 0.16840038E-09_JPRB, &
  & 0.16842333E-09_JPRB, 0.16846459E-09_JPRB, 0.16852095E-09_JPRB, 0.16858791E-09_JPRB, 0.16865986E-09_JPRB, 0.16873059E-09_JPRB, &
  & 0.16879233E-09_JPRB, 0.16884014E-09_JPRB, 0.16887164E-09_JPRB, 0.16888996E-09_JPRB, 0.16890059E-09_JPRB, 0.16890658E-09_JPRB, &
  & 0.16891058E-09_JPRB, 0.16891305E-09_JPRB, 0.16891441E-09_JPRB, 0.16891459E-09_JPRB, 0.16891352E-09_JPRB, 0.16891158E-09_JPRB, &
  & 0.16890912E-09_JPRB, 0.16890628E-09_JPRB, 0.16890267E-09_JPRB, 0.16889572E-09_JPRB /)

RGHG8(:,61,10) = (/ &
  & 0.16891281E-09_JPRB, 0.16892632E-09_JPRB, 0.16893126E-09_JPRB, 0.16893328E-09_JPRB, 0.16893303E-09_JPRB, 0.16893136E-09_JPRB, &
  & 0.16892920E-09_JPRB, 0.16892721E-09_JPRB, 0.16892546E-09_JPRB, 0.16892332E-09_JPRB, 0.16892042E-09_JPRB, 0.16891583E-09_JPRB, &
  & 0.16890836E-09_JPRB, 0.16889348E-09_JPRB, 0.16886645E-09_JPRB, 0.16881282E-09_JPRB, 0.16872563E-09_JPRB, 0.16861031E-09_JPRB, &
  & 0.16848181E-09_JPRB, 0.16835411E-09_JPRB, 0.16823878E-09_JPRB, 0.16814719E-09_JPRB, 0.16808716E-09_JPRB, 0.16806119E-09_JPRB, &
  & 0.16806730E-09_JPRB, 0.16810052E-09_JPRB, 0.16815460E-09_JPRB, 0.16822424E-09_JPRB, 0.16830398E-09_JPRB, 0.16838700E-09_JPRB, &
  & 0.16846650E-09_JPRB, 0.16853266E-09_JPRB, 0.16857746E-09_JPRB, 0.16859697E-09_JPRB, 0.16859326E-09_JPRB, 0.16857243E-09_JPRB, &
  & 0.16854099E-09_JPRB, 0.16850545E-09_JPRB, 0.16847182E-09_JPRB, 0.16844526E-09_JPRB, 0.16843185E-09_JPRB, 0.16843645E-09_JPRB, &
  & 0.16846104E-09_JPRB, 0.16850438E-09_JPRB, 0.16856289E-09_JPRB, 0.16863123E-09_JPRB, 0.16870469E-09_JPRB, 0.16877609E-09_JPRB, &
  & 0.16884009E-09_JPRB, 0.16888960E-09_JPRB, 0.16892296E-09_JPRB, 0.16894157E-09_JPRB, 0.16895152E-09_JPRB, 0.16895724E-09_JPRB, &
  & 0.16896043E-09_JPRB, 0.16896218E-09_JPRB, 0.16896262E-09_JPRB, 0.16896175E-09_JPRB, 0.16895969E-09_JPRB, 0.16895689E-09_JPRB, &
  & 0.16895377E-09_JPRB, 0.16895035E-09_JPRB, 0.16894611E-09_JPRB, 0.16893836E-09_JPRB /)

RGHG8(:,62,10) = (/ &
  & 0.16896304E-09_JPRB, 0.16897499E-09_JPRB, 0.16897894E-09_JPRB, 0.16898039E-09_JPRB, 0.16897994E-09_JPRB, 0.16897853E-09_JPRB, &
  & 0.16897682E-09_JPRB, 0.16897539E-09_JPRB, 0.16897431E-09_JPRB, 0.16897279E-09_JPRB, 0.16897053E-09_JPRB, 0.16896673E-09_JPRB, &
  & 0.16895922E-09_JPRB, 0.16894491E-09_JPRB, 0.16891505E-09_JPRB, 0.16885959E-09_JPRB, 0.16877123E-09_JPRB, 0.16865645E-09_JPRB, &
  & 0.16852976E-09_JPRB, 0.16840253E-09_JPRB, 0.16828740E-09_JPRB, 0.16819557E-09_JPRB, 0.16813431E-09_JPRB, 0.16810650E-09_JPRB, &
  & 0.16811048E-09_JPRB, 0.16814201E-09_JPRB, 0.16819499E-09_JPRB, 0.16826421E-09_JPRB, 0.16834387E-09_JPRB, 0.16842780E-09_JPRB, &
  & 0.16850828E-09_JPRB, 0.16857560E-09_JPRB, 0.16862123E-09_JPRB, 0.16864118E-09_JPRB, 0.16863751E-09_JPRB, 0.16861637E-09_JPRB, &
  & 0.16858431E-09_JPRB, 0.16854793E-09_JPRB, 0.16851331E-09_JPRB, 0.16848603E-09_JPRB, 0.16847249E-09_JPRB, 0.16847757E-09_JPRB, &
  & 0.16850331E-09_JPRB, 0.16854829E-09_JPRB, 0.16860838E-09_JPRB, 0.16867804E-09_JPRB, 0.16875182E-09_JPRB, 0.16882395E-09_JPRB, &
  & 0.16888785E-09_JPRB, 0.16893985E-09_JPRB, 0.16897403E-09_JPRB, 0.16899374E-09_JPRB, 0.16900387E-09_JPRB, 0.16900900E-09_JPRB, &
  & 0.16901155E-09_JPRB, 0.16901237E-09_JPRB, 0.16901164E-09_JPRB, 0.16900945E-09_JPRB, 0.16900609E-09_JPRB, 0.16900217E-09_JPRB, &
  & 0.16899809E-09_JPRB, 0.16899382E-09_JPRB, 0.16898880E-09_JPRB, 0.16897957E-09_JPRB /)

RGHG8(:,63,10) = (/ &
  & 0.16901061E-09_JPRB, 0.16902260E-09_JPRB, 0.16902652E-09_JPRB, 0.16902785E-09_JPRB, 0.16902746E-09_JPRB, 0.16902632E-09_JPRB, &
  & 0.16902504E-09_JPRB, 0.16902410E-09_JPRB, 0.16902371E-09_JPRB, 0.16902293E-09_JPRB, 0.16902146E-09_JPRB, 0.16901833E-09_JPRB, &
  & 0.16901144E-09_JPRB, 0.16899594E-09_JPRB, 0.16896416E-09_JPRB, 0.16890661E-09_JPRB, 0.16881807E-09_JPRB, 0.16870649E-09_JPRB, &
  & 0.16858190E-09_JPRB, 0.16845632E-09_JPRB, 0.16834226E-09_JPRB, 0.16825098E-09_JPRB, 0.16818963E-09_JPRB, 0.16816061E-09_JPRB, &
  & 0.16816290E-09_JPRB, 0.16819282E-09_JPRB, 0.16824460E-09_JPRB, 0.16831320E-09_JPRB, 0.16839277E-09_JPRB, 0.16847701E-09_JPRB, &
  & 0.16855814E-09_JPRB, 0.16862595E-09_JPRB, 0.16867198E-09_JPRB, 0.16869207E-09_JPRB, 0.16868831E-09_JPRB, 0.16866680E-09_JPRB, &
  & 0.16863425E-09_JPRB, 0.16859712E-09_JPRB, 0.16856155E-09_JPRB, 0.16853344E-09_JPRB, 0.16851950E-09_JPRB, 0.16852476E-09_JPRB, &
  & 0.16855113E-09_JPRB, 0.16859709E-09_JPRB, 0.16865823E-09_JPRB, 0.16872855E-09_JPRB, 0.16880258E-09_JPRB, 0.16887418E-09_JPRB, &
  & 0.16893842E-09_JPRB, 0.16898984E-09_JPRB, 0.16902657E-09_JPRB, 0.16904714E-09_JPRB, 0.16905764E-09_JPRB, 0.16906268E-09_JPRB, &
  & 0.16906451E-09_JPRB, 0.16906425E-09_JPRB, 0.16906210E-09_JPRB, 0.16905827E-09_JPRB, 0.16905322E-09_JPRB, 0.16904772E-09_JPRB, &
  & 0.16904227E-09_JPRB, 0.16903665E-09_JPRB, 0.16902996E-09_JPRB, 0.16901840E-09_JPRB /)

RGHG8(:,64,10) = (/ &
  & 0.16905821E-09_JPRB, 0.16907055E-09_JPRB, 0.16907453E-09_JPRB, 0.16907589E-09_JPRB, 0.16907561E-09_JPRB, 0.16907473E-09_JPRB, &
  & 0.16907370E-09_JPRB, 0.16907317E-09_JPRB, 0.16907352E-09_JPRB, 0.16907356E-09_JPRB, 0.16907309E-09_JPRB, 0.16907098E-09_JPRB, &
  & 0.16906454E-09_JPRB, 0.16904829E-09_JPRB, 0.16901512E-09_JPRB, 0.16895570E-09_JPRB, 0.16886960E-09_JPRB, 0.16876067E-09_JPRB, &
  & 0.16863913E-09_JPRB, 0.16851590E-09_JPRB, 0.16840415E-09_JPRB, 0.16831442E-09_JPRB, 0.16825390E-09_JPRB, 0.16822446E-09_JPRB, &
  & 0.16822549E-09_JPRB, 0.16825397E-09_JPRB, 0.16830444E-09_JPRB, 0.16837218E-09_JPRB, 0.16845117E-09_JPRB, 0.16853520E-09_JPRB, &
  & 0.16861612E-09_JPRB, 0.16868379E-09_JPRB, 0.16872954E-09_JPRB, 0.16874938E-09_JPRB, 0.16874541E-09_JPRB, 0.16872370E-09_JPRB, &
  & 0.16869094E-09_JPRB, 0.16865326E-09_JPRB, 0.16861694E-09_JPRB, 0.16858802E-09_JPRB, 0.16857353E-09_JPRB, 0.16857850E-09_JPRB, &
  & 0.16860491E-09_JPRB, 0.16865123E-09_JPRB, 0.16871271E-09_JPRB, 0.16878308E-09_JPRB, 0.16885676E-09_JPRB, 0.16892773E-09_JPRB, &
  & 0.16899072E-09_JPRB, 0.16904245E-09_JPRB, 0.16907936E-09_JPRB, 0.16910170E-09_JPRB, 0.16911303E-09_JPRB, 0.16911800E-09_JPRB, &
  & 0.16911916E-09_JPRB, 0.16911771E-09_JPRB, 0.16911397E-09_JPRB, 0.16910820E-09_JPRB, 0.16910123E-09_JPRB, 0.16909391E-09_JPRB, &
  & 0.16908658E-09_JPRB, 0.16907897E-09_JPRB, 0.16907011E-09_JPRB, 0.16905413E-09_JPRB /)

RGHG8(:,65,10) = (/ &
  & 0.16910578E-09_JPRB, 0.16911902E-09_JPRB, 0.16912324E-09_JPRB, 0.16912483E-09_JPRB, 0.16912463E-09_JPRB, 0.16912388E-09_JPRB, &
  & 0.16912301E-09_JPRB, 0.16912272E-09_JPRB, 0.16912385E-09_JPRB, 0.16912487E-09_JPRB, 0.16912549E-09_JPRB, 0.16912440E-09_JPRB, &
  & 0.16911814E-09_JPRB, 0.16910126E-09_JPRB, 0.16906625E-09_JPRB, 0.16900827E-09_JPRB, 0.16892461E-09_JPRB, 0.16881969E-09_JPRB, &
  & 0.16870180E-09_JPRB, 0.16858229E-09_JPRB, 0.16847354E-09_JPRB, 0.16838676E-09_JPRB, 0.16832777E-09_JPRB, 0.16829858E-09_JPRB, &
  & 0.16829883E-09_JPRB, 0.16832581E-09_JPRB, 0.16837476E-09_JPRB, 0.16844101E-09_JPRB, 0.16851884E-09_JPRB, 0.16860158E-09_JPRB, &
  & 0.16868143E-09_JPRB, 0.16874797E-09_JPRB, 0.16879267E-09_JPRB, 0.16881194E-09_JPRB, 0.16880781E-09_JPRB, 0.16878633E-09_JPRB, &
  & 0.16875376E-09_JPRB, 0.16871615E-09_JPRB, 0.16867945E-09_JPRB, 0.16865004E-09_JPRB, 0.16863491E-09_JPRB, 0.16863930E-09_JPRB, &
  & 0.16866519E-09_JPRB, 0.16871110E-09_JPRB, 0.16877212E-09_JPRB, 0.16884187E-09_JPRB, 0.16891449E-09_JPRB, 0.16898430E-09_JPRB, &
  & 0.16904614E-09_JPRB, 0.16909668E-09_JPRB, 0.16913401E-09_JPRB, 0.16915737E-09_JPRB, 0.16916954E-09_JPRB, 0.16917490E-09_JPRB, &
  & 0.16917545E-09_JPRB, 0.16917277E-09_JPRB, 0.16916735E-09_JPRB, 0.16915974E-09_JPRB, 0.16915075E-09_JPRB, 0.16914123E-09_JPRB, &
  & 0.16913154E-09_JPRB, 0.16912127E-09_JPRB, 0.16910864E-09_JPRB, 0.16908668E-09_JPRB /)

RGHG8(:,66,10) = (/ &
  & 0.16915175E-09_JPRB, 0.16916743E-09_JPRB, 0.16917273E-09_JPRB, 0.16917477E-09_JPRB, 0.16917479E-09_JPRB, 0.16917423E-09_JPRB, &
  & 0.16917334E-09_JPRB, 0.16917316E-09_JPRB, 0.16917537E-09_JPRB, 0.16917728E-09_JPRB, 0.16917920E-09_JPRB, 0.16917906E-09_JPRB, &
  & 0.16917315E-09_JPRB, 0.16915601E-09_JPRB, 0.16912179E-09_JPRB, 0.16906494E-09_JPRB, 0.16898438E-09_JPRB, 0.16888357E-09_JPRB, &
  & 0.16877050E-09_JPRB, 0.16865555E-09_JPRB, 0.16855149E-09_JPRB, 0.16846809E-09_JPRB, 0.16841153E-09_JPRB, 0.16838309E-09_JPRB, &
  & 0.16838263E-09_JPRB, 0.16840804E-09_JPRB, 0.16845475E-09_JPRB, 0.16851874E-09_JPRB, 0.16859436E-09_JPRB, 0.16867477E-09_JPRB, &
  & 0.16875246E-09_JPRB, 0.16881685E-09_JPRB, 0.16885990E-09_JPRB, 0.16887830E-09_JPRB, 0.16887419E-09_JPRB, 0.16885342E-09_JPRB, &
  & 0.16882176E-09_JPRB, 0.16878494E-09_JPRB, 0.16874875E-09_JPRB, 0.16871925E-09_JPRB, 0.16870372E-09_JPRB, 0.16870728E-09_JPRB, &
  & 0.16873225E-09_JPRB, 0.16877698E-09_JPRB, 0.16883671E-09_JPRB, 0.16890499E-09_JPRB, 0.16897599E-09_JPRB, 0.16904397E-09_JPRB, &
  & 0.16910416E-09_JPRB, 0.16915346E-09_JPRB, 0.16919030E-09_JPRB, 0.16921403E-09_JPRB, 0.16922719E-09_JPRB, 0.16923281E-09_JPRB, &
  & 0.16923292E-09_JPRB, 0.16922921E-09_JPRB, 0.16922246E-09_JPRB, 0.16921319E-09_JPRB, 0.16920243E-09_JPRB, 0.16919079E-09_JPRB, &
  & 0.16917837E-09_JPRB, 0.16916450E-09_JPRB, 0.16914725E-09_JPRB, 0.16911543E-09_JPRB /)

RGHG8(:,67,10) = (/ &
  & 0.16919716E-09_JPRB, 0.16921679E-09_JPRB, 0.16922333E-09_JPRB, 0.16922611E-09_JPRB, 0.16922649E-09_JPRB, 0.16922620E-09_JPRB, &
  & 0.16922545E-09_JPRB, 0.16922534E-09_JPRB, 0.16922828E-09_JPRB, 0.16923155E-09_JPRB, 0.16923438E-09_JPRB, 0.16923493E-09_JPRB, &
  & 0.16922899E-09_JPRB, 0.16921187E-09_JPRB, 0.16917824E-09_JPRB, 0.16912394E-09_JPRB, 0.16904769E-09_JPRB, 0.16895235E-09_JPRB, &
  & 0.16884506E-09_JPRB, 0.16873622E-09_JPRB, 0.16863735E-09_JPRB, 0.16855847E-09_JPRB, 0.16850456E-09_JPRB, 0.16847709E-09_JPRB, &
  & 0.16847591E-09_JPRB, 0.16849923E-09_JPRB, 0.16854318E-09_JPRB, 0.16860401E-09_JPRB, 0.16867628E-09_JPRB, 0.16875329E-09_JPRB, &
  & 0.16882772E-09_JPRB, 0.16888933E-09_JPRB, 0.16893005E-09_JPRB, 0.16894744E-09_JPRB, 0.16894355E-09_JPRB, 0.16892393E-09_JPRB, &
  & 0.16889387E-09_JPRB, 0.16885865E-09_JPRB, 0.16882375E-09_JPRB, 0.16879502E-09_JPRB, 0.16877946E-09_JPRB, 0.16878238E-09_JPRB, &
  & 0.16880604E-09_JPRB, 0.16884906E-09_JPRB, 0.16890667E-09_JPRB, 0.16897256E-09_JPRB, 0.16904116E-09_JPRB, 0.16910671E-09_JPRB, &
  & 0.16916488E-09_JPRB, 0.16921255E-09_JPRB, 0.16924849E-09_JPRB, 0.16927224E-09_JPRB, 0.16928559E-09_JPRB, 0.16929161E-09_JPRB, &
  & 0.16929141E-09_JPRB, 0.16928696E-09_JPRB, 0.16927910E-09_JPRB, 0.16926875E-09_JPRB, 0.16925664E-09_JPRB, 0.16924295E-09_JPRB, &
  & 0.16922790E-09_JPRB, 0.16921008E-09_JPRB, 0.16918635E-09_JPRB, 0.16914238E-09_JPRB /)

RGHG8(:,68,10) = (/ &
  & 0.16924254E-09_JPRB, 0.16926717E-09_JPRB, 0.16927565E-09_JPRB, 0.16927930E-09_JPRB, 0.16928017E-09_JPRB, 0.16928026E-09_JPRB, &
  & 0.16927965E-09_JPRB, 0.16927959E-09_JPRB, 0.16928386E-09_JPRB, 0.16928775E-09_JPRB, 0.16929147E-09_JPRB, 0.16929236E-09_JPRB, &
  & 0.16928675E-09_JPRB, 0.16927075E-09_JPRB, 0.16923871E-09_JPRB, 0.16918711E-09_JPRB, 0.16911512E-09_JPRB, 0.16902571E-09_JPRB, &
  & 0.16892526E-09_JPRB, 0.16882330E-09_JPRB, 0.16873070E-09_JPRB, 0.16865646E-09_JPRB, 0.16860555E-09_JPRB, 0.16857900E-09_JPRB, &
  & 0.16857693E-09_JPRB, 0.16859791E-09_JPRB, 0.16863842E-09_JPRB, 0.16869536E-09_JPRB, 0.16876339E-09_JPRB, 0.16883608E-09_JPRB, &
  & 0.16890656E-09_JPRB, 0.16896452E-09_JPRB, 0.16900273E-09_JPRB, 0.16901899E-09_JPRB, 0.16901544E-09_JPRB, 0.16899729E-09_JPRB, &
  & 0.16896928E-09_JPRB, 0.16893632E-09_JPRB, 0.16890346E-09_JPRB, 0.16887616E-09_JPRB, 0.16886124E-09_JPRB, 0.16886371E-09_JPRB, &
  & 0.16888618E-09_JPRB, 0.16892704E-09_JPRB, 0.16898177E-09_JPRB, 0.16904474E-09_JPRB, 0.16910992E-09_JPRB, 0.16917268E-09_JPRB, &
  & 0.16922805E-09_JPRB, 0.16927375E-09_JPRB, 0.16930851E-09_JPRB, 0.16933170E-09_JPRB, 0.16934504E-09_JPRB, 0.16935113E-09_JPRB, &
  & 0.16935074E-09_JPRB, 0.16934582E-09_JPRB, 0.16933743E-09_JPRB, 0.16932640E-09_JPRB, 0.16931329E-09_JPRB, 0.16929842E-09_JPRB, &
  & 0.16928076E-09_JPRB, 0.16925944E-09_JPRB, 0.16922916E-09_JPRB, 0.16917154E-09_JPRB /)

RGHG8(:,69,10) = (/ &
  & 0.16928849E-09_JPRB, 0.16931964E-09_JPRB, 0.16933019E-09_JPRB, 0.16933498E-09_JPRB, 0.16933642E-09_JPRB, 0.16933703E-09_JPRB, &
  & 0.16933677E-09_JPRB, 0.16933700E-09_JPRB, 0.16934197E-09_JPRB, 0.16934666E-09_JPRB, 0.16935060E-09_JPRB, 0.16935160E-09_JPRB, &
  & 0.16934606E-09_JPRB, 0.16933034E-09_JPRB, 0.16930007E-09_JPRB, 0.16925214E-09_JPRB, 0.16918576E-09_JPRB, 0.16910320E-09_JPRB, &
  & 0.16901038E-09_JPRB, 0.16891594E-09_JPRB, 0.16883005E-09_JPRB, 0.16876084E-09_JPRB, 0.16871293E-09_JPRB, 0.16868741E-09_JPRB, &
  & 0.16868444E-09_JPRB, 0.16870283E-09_JPRB, 0.16873961E-09_JPRB, 0.16879211E-09_JPRB, 0.16885518E-09_JPRB, 0.16892296E-09_JPRB, &
  & 0.16898864E-09_JPRB, 0.16904261E-09_JPRB, 0.16907792E-09_JPRB, 0.16909299E-09_JPRB, 0.16908980E-09_JPRB, 0.16907337E-09_JPRB, &
  & 0.16904772E-09_JPRB, 0.16901738E-09_JPRB, 0.16898700E-09_JPRB, 0.16896169E-09_JPRB, 0.16894788E-09_JPRB, 0.16895049E-09_JPRB, &
  & 0.16897181E-09_JPRB, 0.16901035E-09_JPRB, 0.16906208E-09_JPRB, 0.16912113E-09_JPRB, 0.16918275E-09_JPRB, 0.16924173E-09_JPRB, &
  & 0.16929412E-09_JPRB, 0.16933735E-09_JPRB, 0.16937049E-09_JPRB, 0.16939271E-09_JPRB, 0.16940568E-09_JPRB, 0.16941175E-09_JPRB, &
  & 0.16941128E-09_JPRB, 0.16940634E-09_JPRB, 0.16939768E-09_JPRB, 0.16938631E-09_JPRB, 0.16937295E-09_JPRB, 0.16935678E-09_JPRB, &
  & 0.16933790E-09_JPRB, 0.16931316E-09_JPRB, 0.16927733E-09_JPRB, 0.16920559E-09_JPRB /)

RGHG8(:,70,10) = (/ &
  & 0.16933609E-09_JPRB, 0.16937442E-09_JPRB, 0.16938766E-09_JPRB, 0.16939360E-09_JPRB, 0.16939578E-09_JPRB, 0.16939702E-09_JPRB, &
  & 0.16939723E-09_JPRB, 0.16939783E-09_JPRB, 0.16940334E-09_JPRB, 0.16940817E-09_JPRB, 0.16941197E-09_JPRB, 0.16941284E-09_JPRB, &
  & 0.16940756E-09_JPRB, 0.16939339E-09_JPRB, 0.16936502E-09_JPRB, 0.16932060E-09_JPRB, 0.16925958E-09_JPRB, 0.16918431E-09_JPRB, &
  & 0.16909939E-09_JPRB, 0.16901318E-09_JPRB, 0.16893409E-09_JPRB, 0.16887028E-09_JPRB, 0.16882547E-09_JPRB, 0.16880108E-09_JPRB, &
  & 0.16879720E-09_JPRB, 0.16881299E-09_JPRB, 0.16884581E-09_JPRB, 0.16889347E-09_JPRB, 0.16895123E-09_JPRB, 0.16901337E-09_JPRB, &
  & 0.16907381E-09_JPRB, 0.16912333E-09_JPRB, 0.16915555E-09_JPRB, 0.16916935E-09_JPRB, 0.16916657E-09_JPRB, 0.16915191E-09_JPRB, &
  & 0.16912879E-09_JPRB, 0.16910134E-09_JPRB, 0.16907378E-09_JPRB, 0.16905087E-09_JPRB, 0.16903862E-09_JPRB, 0.16904159E-09_JPRB, &
  & 0.16906207E-09_JPRB, 0.16909837E-09_JPRB, 0.16914663E-09_JPRB, 0.16920176E-09_JPRB, 0.16925891E-09_JPRB, 0.16931398E-09_JPRB, &
  & 0.16936264E-09_JPRB, 0.16940298E-09_JPRB, 0.16943402E-09_JPRB, 0.16945507E-09_JPRB, 0.16946752E-09_JPRB, 0.16947346E-09_JPRB, &
  & 0.16947316E-09_JPRB, 0.16946863E-09_JPRB, 0.16946013E-09_JPRB, 0.16944900E-09_JPRB, 0.16943545E-09_JPRB, 0.16941913E-09_JPRB, &
  & 0.16939893E-09_JPRB, 0.16937289E-09_JPRB, 0.16933198E-09_JPRB, 0.16924936E-09_JPRB /)

RGHG8(:,71,10) = (/ &
  & 0.16938714E-09_JPRB, 0.16943312E-09_JPRB, 0.16944833E-09_JPRB, 0.16945548E-09_JPRB, 0.16945829E-09_JPRB, 0.16946028E-09_JPRB, &
  & 0.16946104E-09_JPRB, 0.16946197E-09_JPRB, 0.16946769E-09_JPRB, 0.16947212E-09_JPRB, 0.16947549E-09_JPRB, 0.16947585E-09_JPRB, &
  & 0.16947037E-09_JPRB, 0.16945656E-09_JPRB, 0.16943066E-09_JPRB, 0.16939064E-09_JPRB, 0.16933577E-09_JPRB, 0.16926788E-09_JPRB, &
  & 0.16919141E-09_JPRB, 0.16911329E-09_JPRB, 0.16904188E-09_JPRB, 0.16898333E-09_JPRB, 0.16894215E-09_JPRB, 0.16891905E-09_JPRB, &
  & 0.16891445E-09_JPRB, 0.16892772E-09_JPRB, 0.16895629E-09_JPRB, 0.16899893E-09_JPRB, 0.16905087E-09_JPRB, 0.16910705E-09_JPRB, &
  & 0.16916182E-09_JPRB, 0.16920657E-09_JPRB, 0.16923557E-09_JPRB, 0.16924798E-09_JPRB, 0.16924560E-09_JPRB, 0.16923282E-09_JPRB, &
  & 0.16921227E-09_JPRB, 0.16918791E-09_JPRB, 0.16916335E-09_JPRB, 0.16914305E-09_JPRB, 0.16913254E-09_JPRB, 0.16913609E-09_JPRB, &
  & 0.16915586E-09_JPRB, 0.16918983E-09_JPRB, 0.16923465E-09_JPRB, 0.16928542E-09_JPRB, 0.16933795E-09_JPRB, 0.16938846E-09_JPRB, &
  & 0.16943311E-09_JPRB, 0.16947023E-09_JPRB, 0.16949891E-09_JPRB, 0.16951850E-09_JPRB, 0.16953021E-09_JPRB, 0.16953608E-09_JPRB, &
  & 0.16953614E-09_JPRB, 0.16953240E-09_JPRB, 0.16952467E-09_JPRB, 0.16951411E-09_JPRB, 0.16950098E-09_JPRB, 0.16948483E-09_JPRB, &
  & 0.16946479E-09_JPRB, 0.16943784E-09_JPRB, 0.16939490E-09_JPRB, 0.16930436E-09_JPRB /)

RGHG8(:,72,10) = (/ &
  & 0.16944386E-09_JPRB, 0.16949536E-09_JPRB, 0.16951235E-09_JPRB, 0.16952016E-09_JPRB, 0.16952356E-09_JPRB, 0.16952613E-09_JPRB, &
  & 0.16952746E-09_JPRB, 0.16952878E-09_JPRB, 0.16953375E-09_JPRB, 0.16953791E-09_JPRB, 0.16954034E-09_JPRB, 0.16954010E-09_JPRB, &
  & 0.16953487E-09_JPRB, 0.16952267E-09_JPRB, 0.16949872E-09_JPRB, 0.16946249E-09_JPRB, 0.16941358E-09_JPRB, 0.16935331E-09_JPRB, &
  & 0.16928524E-09_JPRB, 0.16921593E-09_JPRB, 0.16915186E-09_JPRB, 0.16909954E-09_JPRB, 0.16906197E-09_JPRB, 0.16904061E-09_JPRB, &
  & 0.16903548E-09_JPRB, 0.16904618E-09_JPRB, 0.16907059E-09_JPRB, 0.16910780E-09_JPRB, 0.16915377E-09_JPRB, 0.16920350E-09_JPRB, &
  & 0.16925221E-09_JPRB, 0.16929190E-09_JPRB, 0.16931752E-09_JPRB, 0.16932861E-09_JPRB, 0.16932671E-09_JPRB, 0.16931570E-09_JPRB, &
  & 0.16929780E-09_JPRB, 0.16927666E-09_JPRB, 0.16925535E-09_JPRB, 0.16923776E-09_JPRB, 0.16922917E-09_JPRB, 0.16923335E-09_JPRB, &
  & 0.16925224E-09_JPRB, 0.16928381E-09_JPRB, 0.16932493E-09_JPRB, 0.16937104E-09_JPRB, 0.16941858E-09_JPRB, 0.16946429E-09_JPRB, &
  & 0.16950445E-09_JPRB, 0.16953802E-09_JPRB, 0.16956403E-09_JPRB, 0.16958199E-09_JPRB, 0.16959301E-09_JPRB, 0.16959878E-09_JPRB, &
  & 0.16959947E-09_JPRB, 0.16959692E-09_JPRB, 0.16959012E-09_JPRB, 0.16958060E-09_JPRB, 0.16956875E-09_JPRB, 0.16955307E-09_JPRB, &
  & 0.16953410E-09_JPRB, 0.16950814E-09_JPRB, 0.16946410E-09_JPRB, 0.16937125E-09_JPRB /)

RGHG8(:,73,10) = (/ &
  & 0.16950898E-09_JPRB, 0.16956159E-09_JPRB, 0.16957868E-09_JPRB, 0.16958661E-09_JPRB, 0.16959026E-09_JPRB, 0.16959323E-09_JPRB, &
  & 0.16959484E-09_JPRB, 0.16959623E-09_JPRB, 0.16960085E-09_JPRB, 0.16960383E-09_JPRB, 0.16960577E-09_JPRB, 0.16960501E-09_JPRB, &
  & 0.16959953E-09_JPRB, 0.16958807E-09_JPRB, 0.16956693E-09_JPRB, 0.16953519E-09_JPRB, 0.16949221E-09_JPRB, 0.16943956E-09_JPRB, &
  & 0.16938018E-09_JPRB, 0.16931936E-09_JPRB, 0.16926370E-09_JPRB, 0.16921743E-09_JPRB, 0.16918413E-09_JPRB, 0.16916463E-09_JPRB, &
  & 0.16915921E-09_JPRB, 0.16916750E-09_JPRB, 0.16918759E-09_JPRB, 0.16921946E-09_JPRB, 0.16925905E-09_JPRB, 0.16930220E-09_JPRB, &
  & 0.16934457E-09_JPRB, 0.16937911E-09_JPRB, 0.16940127E-09_JPRB, 0.16941099E-09_JPRB, 0.16940957E-09_JPRB, 0.16940031E-09_JPRB, &
  & 0.16938513E-09_JPRB, 0.16936733E-09_JPRB, 0.16934922E-09_JPRB, 0.16933438E-09_JPRB, 0.16932772E-09_JPRB, 0.16933244E-09_JPRB, &
  & 0.16935031E-09_JPRB, 0.16937912E-09_JPRB, 0.16941604E-09_JPRB, 0.16945725E-09_JPRB, 0.16949944E-09_JPRB, 0.16953994E-09_JPRB, &
  & 0.16957549E-09_JPRB, 0.16960529E-09_JPRB, 0.16962853E-09_JPRB, 0.16964480E-09_JPRB, 0.16965489E-09_JPRB, 0.16966067E-09_JPRB, &
  & 0.16966185E-09_JPRB, 0.16966029E-09_JPRB, 0.16965504E-09_JPRB, 0.16964687E-09_JPRB, 0.16963597E-09_JPRB, 0.16962248E-09_JPRB, &
  & 0.16960448E-09_JPRB, 0.16958068E-09_JPRB, 0.16953902E-09_JPRB, 0.16944607E-09_JPRB /)

RGHG8(:,74,10) = (/ &
  & 0.16957713E-09_JPRB, 0.16962948E-09_JPRB, 0.16964576E-09_JPRB, 0.16965324E-09_JPRB, 0.16965682E-09_JPRB, 0.16965987E-09_JPRB, &
  & 0.16966169E-09_JPRB, 0.16966320E-09_JPRB, 0.16966661E-09_JPRB, 0.16966943E-09_JPRB, 0.16967056E-09_JPRB, 0.16966942E-09_JPRB, &
  & 0.16966456E-09_JPRB, 0.16965471E-09_JPRB, 0.16963572E-09_JPRB, 0.16960806E-09_JPRB, 0.16957115E-09_JPRB, 0.16952621E-09_JPRB, &
  & 0.16947531E-09_JPRB, 0.16942363E-09_JPRB, 0.16937600E-09_JPRB, 0.16933645E-09_JPRB, 0.16930744E-09_JPRB, 0.16929017E-09_JPRB, &
  & 0.16928473E-09_JPRB, 0.16929089E-09_JPRB, 0.16930685E-09_JPRB, 0.16933319E-09_JPRB, 0.16936642E-09_JPRB, 0.16940276E-09_JPRB, &
  & 0.16943863E-09_JPRB, 0.16946780E-09_JPRB, 0.16948649E-09_JPRB, 0.16949488E-09_JPRB, 0.16949393E-09_JPRB, 0.16948634E-09_JPRB, &
  & 0.16947382E-09_JPRB, 0.16945934E-09_JPRB, 0.16944460E-09_JPRB, 0.16943255E-09_JPRB, 0.16942781E-09_JPRB, 0.16943284E-09_JPRB, &
  & 0.16944933E-09_JPRB, 0.16947480E-09_JPRB, 0.16950732E-09_JPRB, 0.16954312E-09_JPRB, 0.16957946E-09_JPRB, 0.16961471E-09_JPRB, &
  & 0.16964521E-09_JPRB, 0.16967111E-09_JPRB, 0.16969140E-09_JPRB, 0.16970576E-09_JPRB, 0.16971516E-09_JPRB, 0.16972040E-09_JPRB, &
  & 0.16972200E-09_JPRB, 0.16972143E-09_JPRB, 0.16971735E-09_JPRB, 0.16971051E-09_JPRB, 0.16970206E-09_JPRB, 0.16968926E-09_JPRB, &
  & 0.16967437E-09_JPRB, 0.16965314E-09_JPRB, 0.16961381E-09_JPRB, 0.16952656E-09_JPRB /)

RGHG8(:,75,10) = (/ &
  & 0.16964702E-09_JPRB, 0.16969695E-09_JPRB, 0.16971230E-09_JPRB, 0.16971896E-09_JPRB, 0.16972217E-09_JPRB, 0.16972511E-09_JPRB, &
  & 0.16972697E-09_JPRB, 0.16972819E-09_JPRB, 0.16973133E-09_JPRB, 0.16973321E-09_JPRB, 0.16973417E-09_JPRB, 0.16973301E-09_JPRB, &
  & 0.16972818E-09_JPRB, 0.16971979E-09_JPRB, 0.16970371E-09_JPRB, 0.16968062E-09_JPRB, 0.16964988E-09_JPRB, 0.16961269E-09_JPRB, &
  & 0.16957066E-09_JPRB, 0.16952777E-09_JPRB, 0.16948849E-09_JPRB, 0.16945577E-09_JPRB, 0.16943132E-09_JPRB, 0.16941651E-09_JPRB, &
  & 0.16941133E-09_JPRB, 0.16941570E-09_JPRB, 0.16942781E-09_JPRB, 0.16944883E-09_JPRB, 0.16947552E-09_JPRB, 0.16950505E-09_JPRB, &
  & 0.16953439E-09_JPRB, 0.16955820E-09_JPRB, 0.16957338E-09_JPRB, 0.16958047E-09_JPRB, 0.16957996E-09_JPRB, 0.16957397E-09_JPRB, &
  & 0.16956411E-09_JPRB, 0.16955298E-09_JPRB, 0.16954145E-09_JPRB, 0.16953201E-09_JPRB, 0.16952910E-09_JPRB, 0.16953418E-09_JPRB, &
  & 0.16954871E-09_JPRB, 0.16957065E-09_JPRB, 0.16959811E-09_JPRB, 0.16962802E-09_JPRB, 0.16965850E-09_JPRB, 0.16968793E-09_JPRB, &
  & 0.16971333E-09_JPRB, 0.16973510E-09_JPRB, 0.16975218E-09_JPRB, 0.16976463E-09_JPRB, 0.16977272E-09_JPRB, 0.16977758E-09_JPRB, &
  & 0.16977904E-09_JPRB, 0.16977912E-09_JPRB, 0.16977626E-09_JPRB, 0.16977120E-09_JPRB, 0.16976372E-09_JPRB, 0.16975432E-09_JPRB, &
  & 0.16974055E-09_JPRB, 0.16972333E-09_JPRB, 0.16968853E-09_JPRB, 0.16960681E-09_JPRB /)

RGHG8(:,76,10) = (/ &
  & 0.16971646E-09_JPRB, 0.16976381E-09_JPRB, 0.16977750E-09_JPRB, 0.16978303E-09_JPRB, 0.16978560E-09_JPRB, 0.16978842E-09_JPRB, &
  & 0.16979022E-09_JPRB, 0.16979132E-09_JPRB, 0.16979362E-09_JPRB, 0.16979543E-09_JPRB, 0.16979587E-09_JPRB, 0.16979453E-09_JPRB, &
  & 0.16979045E-09_JPRB, 0.16978358E-09_JPRB, 0.16977049E-09_JPRB, 0.16975221E-09_JPRB, 0.16972795E-09_JPRB, 0.16969907E-09_JPRB, &
  & 0.16966571E-09_JPRB, 0.16963175E-09_JPRB, 0.16960099E-09_JPRB, 0.16957490E-09_JPRB, 0.16955541E-09_JPRB, 0.16954334E-09_JPRB, &
  & 0.16953883E-09_JPRB, 0.16954174E-09_JPRB, 0.16955029E-09_JPRB, 0.16956619E-09_JPRB, 0.16958647E-09_JPRB, 0.16960910E-09_JPRB, &
  & 0.16963186E-09_JPRB, 0.16965028E-09_JPRB, 0.16966201E-09_JPRB, 0.16966785E-09_JPRB, 0.16966774E-09_JPRB, 0.16966323E-09_JPRB, &
  & 0.16965590E-09_JPRB, 0.16964805E-09_JPRB, 0.16963964E-09_JPRB, 0.16963281E-09_JPRB, 0.16963142E-09_JPRB, 0.16963624E-09_JPRB, &
  & 0.16964855E-09_JPRB, 0.16966624E-09_JPRB, 0.16968821E-09_JPRB, 0.16971204E-09_JPRB, 0.16973586E-09_JPRB, 0.16975964E-09_JPRB, &
  & 0.16977950E-09_JPRB, 0.16979687E-09_JPRB, 0.16981047E-09_JPRB, 0.16982071E-09_JPRB, 0.16982760E-09_JPRB, 0.16983141E-09_JPRB, &
  & 0.16983262E-09_JPRB, 0.16983316E-09_JPRB, 0.16983140E-09_JPRB, 0.16982740E-09_JPRB, 0.16982266E-09_JPRB, 0.16981408E-09_JPRB, &
  & 0.16980416E-09_JPRB, 0.16978971E-09_JPRB, 0.16976028E-09_JPRB, 0.16968774E-09_JPRB /)

RGHG8(:,77,10) = (/ &
  & 0.16978546E-09_JPRB, 0.16982842E-09_JPRB, 0.16984028E-09_JPRB, 0.16984443E-09_JPRB, 0.16984625E-09_JPRB, 0.16984898E-09_JPRB, &
  & 0.16985086E-09_JPRB, 0.16985158E-09_JPRB, 0.16985349E-09_JPRB, 0.16985471E-09_JPRB, 0.16985480E-09_JPRB, 0.16985358E-09_JPRB, &
  & 0.16984986E-09_JPRB, 0.16984480E-09_JPRB, 0.16983477E-09_JPRB, 0.16982162E-09_JPRB, 0.16980424E-09_JPRB, 0.16978370E-09_JPRB, &
  & 0.16975933E-09_JPRB, 0.16973445E-09_JPRB, 0.16971191E-09_JPRB, 0.16969301E-09_JPRB, 0.16967838E-09_JPRB, 0.16966936E-09_JPRB, &
  & 0.16966586E-09_JPRB, 0.16966775E-09_JPRB, 0.16967315E-09_JPRB, 0.16968436E-09_JPRB, 0.16969846E-09_JPRB, 0.16971446E-09_JPRB, &
  & 0.16973094E-09_JPRB, 0.16974411E-09_JPRB, 0.16975246E-09_JPRB, 0.16975708E-09_JPRB, 0.16975739E-09_JPRB, 0.16975421E-09_JPRB, &
  & 0.16974915E-09_JPRB, 0.16974429E-09_JPRB, 0.16973865E-09_JPRB, 0.16973389E-09_JPRB, 0.16973378E-09_JPRB, 0.16973792E-09_JPRB, &
  & 0.16974736E-09_JPRB, 0.16976043E-09_JPRB, 0.16977658E-09_JPRB, 0.16979357E-09_JPRB, 0.16981101E-09_JPRB, 0.16982867E-09_JPRB, &
  & 0.16984285E-09_JPRB, 0.16985582E-09_JPRB, 0.16986564E-09_JPRB, 0.16987353E-09_JPRB, 0.16987892E-09_JPRB, 0.16988155E-09_JPRB, &
  & 0.16988214E-09_JPRB, 0.16988287E-09_JPRB, 0.16988205E-09_JPRB, 0.16987949E-09_JPRB, 0.16987604E-09_JPRB, 0.16987037E-09_JPRB, &
  & 0.16986224E-09_JPRB, 0.16985222E-09_JPRB, 0.16982823E-09_JPRB, 0.16976701E-09_JPRB /)

RGHG8(:,78,10) = (/ &
  & 0.16985315E-09_JPRB, 0.16988776E-09_JPRB, 0.16989622E-09_JPRB, 0.16989875E-09_JPRB, 0.16989984E-09_JPRB, 0.16990259E-09_JPRB, &
  & 0.16990469E-09_JPRB, 0.16990521E-09_JPRB, 0.16990642E-09_JPRB, 0.16990739E-09_JPRB, 0.16990699E-09_JPRB, 0.16990567E-09_JPRB, &
  & 0.16990273E-09_JPRB, 0.16989921E-09_JPRB, 0.16989250E-09_JPRB, 0.16988416E-09_JPRB, 0.16987332E-09_JPRB, 0.16986092E-09_JPRB, &
  & 0.16984512E-09_JPRB, 0.16982883E-09_JPRB, 0.16981470E-09_JPRB, 0.16980256E-09_JPRB, 0.16979310E-09_JPRB, 0.16978728E-09_JPRB, &
  & 0.16978512E-09_JPRB, 0.16978653E-09_JPRB, 0.16978946E-09_JPRB, 0.16979675E-09_JPRB, 0.16980542E-09_JPRB, 0.16981556E-09_JPRB, &
  & 0.16982615E-09_JPRB, 0.16983462E-09_JPRB, 0.16983988E-09_JPRB, 0.16984338E-09_JPRB, 0.16984403E-09_JPRB, 0.16984185E-09_JPRB, &
  & 0.16983859E-09_JPRB, 0.16983617E-09_JPRB, 0.16983270E-09_JPRB, 0.16982953E-09_JPRB, 0.16982990E-09_JPRB, 0.16983276E-09_JPRB, &
  & 0.16983878E-09_JPRB, 0.16984697E-09_JPRB, 0.16985691E-09_JPRB, 0.16986754E-09_JPRB, 0.16987832E-09_JPRB, 0.16989041E-09_JPRB, &
  & 0.16989925E-09_JPRB, 0.16990795E-09_JPRB, 0.16991410E-09_JPRB, 0.16991966E-09_JPRB, 0.16992355E-09_JPRB, 0.16992471E-09_JPRB, &
  & 0.16992453E-09_JPRB, 0.16992514E-09_JPRB, 0.16992523E-09_JPRB, 0.16992335E-09_JPRB, 0.16992195E-09_JPRB, 0.16991734E-09_JPRB, &
  & 0.16991243E-09_JPRB, 0.16990551E-09_JPRB, 0.16988962E-09_JPRB, 0.16984418E-09_JPRB /)

RGHG8(:,79,10) = (/ &
  & 0.16989683E-09_JPRB, 0.16992112E-09_JPRB, 0.16992610E-09_JPRB, 0.16992685E-09_JPRB, 0.16992739E-09_JPRB, 0.16993029E-09_JPRB, &
  & 0.16993269E-09_JPRB, 0.16993290E-09_JPRB, 0.16993371E-09_JPRB, 0.16993457E-09_JPRB, 0.16993393E-09_JPRB, 0.16993271E-09_JPRB, &
  & 0.16993007E-09_JPRB, 0.16992745E-09_JPRB, 0.16992244E-09_JPRB, 0.16991675E-09_JPRB, 0.16990942E-09_JPRB, 0.16990161E-09_JPRB, &
  & 0.16989042E-09_JPRB, 0.16987887E-09_JPRB, 0.16986929E-09_JPRB, 0.16986115E-09_JPRB, 0.16985455E-09_JPRB, 0.16985063E-09_JPRB, &
  & 0.16984937E-09_JPRB, 0.16985066E-09_JPRB, 0.16985230E-09_JPRB, 0.16985753E-09_JPRB, 0.16986326E-09_JPRB, 0.16987020E-09_JPRB, &
  & 0.16987772E-09_JPRB, 0.16988354E-09_JPRB, 0.16988713E-09_JPRB, 0.16989012E-09_JPRB, 0.16989095E-09_JPRB, 0.16988916E-09_JPRB, &
  & 0.16988663E-09_JPRB, 0.16988548E-09_JPRB, 0.16988305E-09_JPRB, 0.16988040E-09_JPRB, 0.16988097E-09_JPRB, 0.16988290E-09_JPRB, &
  & 0.16988712E-09_JPRB, 0.16989253E-09_JPRB, 0.16989925E-09_JPRB, 0.16990616E-09_JPRB, 0.16991347E-09_JPRB, 0.16992270E-09_JPRB, &
  & 0.16992853E-09_JPRB, 0.16993523E-09_JPRB, 0.16993927E-09_JPRB, 0.16994373E-09_JPRB, 0.16994693E-09_JPRB, 0.16994706E-09_JPRB, &
  & 0.16994627E-09_JPRB, 0.16994686E-09_JPRB, 0.16994750E-09_JPRB, 0.16994593E-09_JPRB, 0.16994545E-09_JPRB, 0.16994159E-09_JPRB, &
  & 0.16993797E-09_JPRB, 0.16993379E-09_JPRB, 0.16992348E-09_JPRB, 0.16989346E-09_JPRB /)

RGHG8(:,80,10) = (/ &
  & 0.16992607E-09_JPRB, 0.16993727E-09_JPRB, 0.16993919E-09_JPRB, 0.16993895E-09_JPRB, 0.16993909E-09_JPRB, 0.16994214E-09_JPRB, &
  & 0.16994475E-09_JPRB, 0.16994485E-09_JPRB, 0.16994549E-09_JPRB, 0.16994640E-09_JPRB, 0.16994570E-09_JPRB, 0.16994457E-09_JPRB, &
  & 0.16994206E-09_JPRB, 0.16993991E-09_JPRB, 0.16993565E-09_JPRB, 0.16993117E-09_JPRB, 0.16992546E-09_JPRB, 0.16991980E-09_JPRB, &
  & 0.16991074E-09_JPRB, 0.16990111E-09_JPRB, 0.16989382E-09_JPRB, 0.16988740E-09_JPRB, 0.16988218E-09_JPRB, 0.16987919E-09_JPRB, &
  & 0.16987840E-09_JPRB, 0.16987972E-09_JPRB, 0.16988082E-09_JPRB, 0.16988519E-09_JPRB, 0.16988957E-09_JPRB, 0.16989510E-09_JPRB, &
  & 0.16990111E-09_JPRB, 0.16990576E-09_JPRB, 0.16990855E-09_JPRB, 0.16991138E-09_JPRB, 0.16991231E-09_JPRB, 0.16991057E-09_JPRB, &
  & 0.16990832E-09_JPRB, 0.16990773E-09_JPRB, 0.16990567E-09_JPRB, 0.16990322E-09_JPRB, 0.16990376E-09_JPRB, 0.16990533E-09_JPRB, &
  & 0.16990871E-09_JPRB, 0.16991286E-09_JPRB, 0.16991808E-09_JPRB, 0.16992333E-09_JPRB, 0.16992902E-09_JPRB, 0.16993701E-09_JPRB, &
  & 0.16994142E-09_JPRB, 0.16994715E-09_JPRB, 0.16995025E-09_JPRB, 0.16995423E-09_JPRB, 0.16995717E-09_JPRB, 0.16995670E-09_JPRB, &
  & 0.16995554E-09_JPRB, 0.16995608E-09_JPRB, 0.16995705E-09_JPRB, 0.16995552E-09_JPRB, 0.16995559E-09_JPRB, 0.16995180E-09_JPRB, &
  & 0.16994894E-09_JPRB, 0.16994599E-09_JPRB, 0.16993976E-09_JPRB, 0.16992584E-09_JPRB /)

RGHG8(:,81,10) = (/ &
  & 0.16994631E-09_JPRB, 0.16994416E-09_JPRB, 0.16994474E-09_JPRB, 0.16994406E-09_JPRB, 0.16994403E-09_JPRB, 0.16994720E-09_JPRB, &
  & 0.16994996E-09_JPRB, 0.16994998E-09_JPRB, 0.16995048E-09_JPRB, 0.16995153E-09_JPRB, 0.16995082E-09_JPRB, 0.16994969E-09_JPRB, &
  & 0.16994729E-09_JPRB, 0.16994534E-09_JPRB, 0.16994145E-09_JPRB, 0.16993748E-09_JPRB, 0.16993250E-09_JPRB, 0.16992785E-09_JPRB, &
  & 0.16991962E-09_JPRB, 0.16991099E-09_JPRB, 0.16990452E-09_JPRB, 0.16989897E-09_JPRB, 0.16989432E-09_JPRB, 0.16989177E-09_JPRB, &
  & 0.16989123E-09_JPRB, 0.16989254E-09_JPRB, 0.16989340E-09_JPRB, 0.16989739E-09_JPRB, 0.16990116E-09_JPRB, 0.16990605E-09_JPRB, &
  & 0.16991147E-09_JPRB, 0.16991553E-09_JPRB, 0.16991798E-09_JPRB, 0.16992076E-09_JPRB, 0.16992172E-09_JPRB, 0.16991997E-09_JPRB, &
  & 0.16991786E-09_JPRB, 0.16991746E-09_JPRB, 0.16991558E-09_JPRB, 0.16991322E-09_JPRB, 0.16991381E-09_JPRB, 0.16991518E-09_JPRB, &
  & 0.16991822E-09_JPRB, 0.16992187E-09_JPRB, 0.16992638E-09_JPRB, 0.16993087E-09_JPRB, 0.16993573E-09_JPRB, 0.16994328E-09_JPRB, &
  & 0.16994700E-09_JPRB, 0.16995237E-09_JPRB, 0.16995495E-09_JPRB, 0.16995876E-09_JPRB, 0.16996160E-09_JPRB, 0.16996084E-09_JPRB, &
  & 0.16995946E-09_JPRB, 0.16995999E-09_JPRB, 0.16996111E-09_JPRB, 0.16995957E-09_JPRB, 0.16995987E-09_JPRB, 0.16995617E-09_JPRB, &
  & 0.16995352E-09_JPRB, 0.16995112E-09_JPRB, 0.16994656E-09_JPRB, 0.16994800E-09_JPRB /)

RGHG8(:,82,10) = (/ &
  & 0.16994797E-09_JPRB, 0.16994645E-09_JPRB, 0.16994714E-09_JPRB, 0.16994643E-09_JPRB, 0.16994636E-09_JPRB, 0.16994965E-09_JPRB, &
  & 0.16995251E-09_JPRB, 0.16995252E-09_JPRB, 0.16995301E-09_JPRB, 0.16995400E-09_JPRB, 0.16995326E-09_JPRB, 0.16995223E-09_JPRB, &
  & 0.16994983E-09_JPRB, 0.16994799E-09_JPRB, 0.16994423E-09_JPRB, 0.16994053E-09_JPRB, 0.16993593E-09_JPRB, 0.16993185E-09_JPRB, &
  & 0.16992407E-09_JPRB, 0.16991572E-09_JPRB, 0.16990986E-09_JPRB, 0.16990463E-09_JPRB, 0.16990027E-09_JPRB, 0.16989790E-09_JPRB, &
  & 0.16989748E-09_JPRB, 0.16989886E-09_JPRB, 0.16989961E-09_JPRB, 0.16990334E-09_JPRB, 0.16990688E-09_JPRB, 0.16991143E-09_JPRB, &
  & 0.16991644E-09_JPRB, 0.16992023E-09_JPRB, 0.16992256E-09_JPRB, 0.16992534E-09_JPRB, 0.16992634E-09_JPRB, 0.16992456E-09_JPRB, &
  & 0.16992248E-09_JPRB, 0.16992220E-09_JPRB, 0.16992044E-09_JPRB, 0.16991809E-09_JPRB, 0.16991868E-09_JPRB, 0.16991999E-09_JPRB, &
  & 0.16992291E-09_JPRB, 0.16992630E-09_JPRB, 0.16993054E-09_JPRB, 0.16993457E-09_JPRB, 0.16993905E-09_JPRB, 0.16994633E-09_JPRB, &
  & 0.16994968E-09_JPRB, 0.16995490E-09_JPRB, 0.16995726E-09_JPRB, 0.16996098E-09_JPRB, 0.16996377E-09_JPRB, 0.16996279E-09_JPRB, &
  & 0.16996123E-09_JPRB, 0.16996182E-09_JPRB, 0.16996309E-09_JPRB, 0.16996153E-09_JPRB, 0.16996196E-09_JPRB, 0.16995821E-09_JPRB, &
  & 0.16995572E-09_JPRB, 0.16995333E-09_JPRB, 0.16994878E-09_JPRB, 0.16994978E-09_JPRB /)

RGHG8(:,83,10) = (/ &
  & 0.16994910E-09_JPRB, 0.16994778E-09_JPRB, 0.16994850E-09_JPRB, 0.16994774E-09_JPRB, 0.16994764E-09_JPRB, 0.16995098E-09_JPRB, &
  & 0.16995390E-09_JPRB, 0.16995391E-09_JPRB, 0.16995433E-09_JPRB, 0.16995538E-09_JPRB, 0.16995472E-09_JPRB, 0.16995357E-09_JPRB, &
  & 0.16995128E-09_JPRB, 0.16994943E-09_JPRB, 0.16994578E-09_JPRB, 0.16994232E-09_JPRB, 0.16993790E-09_JPRB, 0.16993415E-09_JPRB, &
  & 0.16992656E-09_JPRB, 0.16991848E-09_JPRB, 0.16991285E-09_JPRB, 0.16990782E-09_JPRB, 0.16990359E-09_JPRB, 0.16990133E-09_JPRB, &
  & 0.16990098E-09_JPRB, 0.16990238E-09_JPRB, 0.16990306E-09_JPRB, 0.16990671E-09_JPRB, 0.16991006E-09_JPRB, 0.16991439E-09_JPRB, &
  & 0.16991922E-09_JPRB, 0.16992285E-09_JPRB, 0.16992509E-09_JPRB, 0.16992789E-09_JPRB, 0.16992890E-09_JPRB, 0.16992709E-09_JPRB, &
  & 0.16992505E-09_JPRB, 0.16992480E-09_JPRB, 0.16992310E-09_JPRB, 0.16992088E-09_JPRB, 0.16992144E-09_JPRB, 0.16992267E-09_JPRB, &
  & 0.16992552E-09_JPRB, 0.16992879E-09_JPRB, 0.16993285E-09_JPRB, 0.16993670E-09_JPRB, 0.16994089E-09_JPRB, 0.16994815E-09_JPRB, &
  & 0.16995122E-09_JPRB, 0.16995634E-09_JPRB, 0.16995849E-09_JPRB, 0.16996220E-09_JPRB, 0.16996499E-09_JPRB, 0.16996390E-09_JPRB, &
  & 0.16996224E-09_JPRB, 0.16996282E-09_JPRB, 0.16996418E-09_JPRB, 0.16996260E-09_JPRB, 0.16996314E-09_JPRB, 0.16995938E-09_JPRB, &
  & 0.16995688E-09_JPRB, 0.16995458E-09_JPRB, 0.16995008E-09_JPRB, 0.16995103E-09_JPRB /)

RGHG8(:,84,10) = (/ &
  & 0.16994989E-09_JPRB, 0.16994864E-09_JPRB, 0.16994937E-09_JPRB, 0.16994851E-09_JPRB, 0.16994842E-09_JPRB, 0.16995184E-09_JPRB, &
  & 0.16995479E-09_JPRB, 0.16995483E-09_JPRB, 0.16995527E-09_JPRB, 0.16995609E-09_JPRB, 0.16995541E-09_JPRB, 0.16995438E-09_JPRB, &
  & 0.16995214E-09_JPRB, 0.16995028E-09_JPRB, 0.16994682E-09_JPRB, 0.16994339E-09_JPRB, 0.16993915E-09_JPRB, 0.16993557E-09_JPRB, &
  & 0.16992815E-09_JPRB, 0.16992015E-09_JPRB, 0.16991472E-09_JPRB, 0.16990984E-09_JPRB, 0.16990562E-09_JPRB, 0.16990342E-09_JPRB, &
  & 0.16990311E-09_JPRB, 0.16990453E-09_JPRB, 0.16990519E-09_JPRB, 0.16990884E-09_JPRB, 0.16991199E-09_JPRB, 0.16991625E-09_JPRB, &
  & 0.16992088E-09_JPRB, 0.16992444E-09_JPRB, 0.16992657E-09_JPRB, 0.16992943E-09_JPRB, 0.16993049E-09_JPRB, 0.16992868E-09_JPRB, &
  & 0.16992663E-09_JPRB, 0.16992639E-09_JPRB, 0.16992477E-09_JPRB, 0.16992258E-09_JPRB, 0.16992309E-09_JPRB, 0.16992434E-09_JPRB, &
  & 0.16992713E-09_JPRB, 0.16993036E-09_JPRB, 0.16993433E-09_JPRB, 0.16993802E-09_JPRB, 0.16994202E-09_JPRB, 0.16994922E-09_JPRB, &
  & 0.16995215E-09_JPRB, 0.16995721E-09_JPRB, 0.16995926E-09_JPRB, 0.16996295E-09_JPRB, 0.16996575E-09_JPRB, 0.16996458E-09_JPRB, &
  & 0.16996284E-09_JPRB, 0.16996339E-09_JPRB, 0.16996482E-09_JPRB, 0.16996322E-09_JPRB, 0.16996389E-09_JPRB, 0.16995999E-09_JPRB, &
  & 0.16995762E-09_JPRB, 0.16995530E-09_JPRB, 0.16995091E-09_JPRB, 0.16995184E-09_JPRB /)

RGHG8(:,85,10) = (/ &
  & 0.16995041E-09_JPRB, 0.16994924E-09_JPRB, 0.16994997E-09_JPRB, 0.16994904E-09_JPRB, 0.16994892E-09_JPRB, 0.16995261E-09_JPRB, &
  & 0.16995524E-09_JPRB, 0.16995549E-09_JPRB, 0.16995577E-09_JPRB, 0.16995635E-09_JPRB, 0.16995580E-09_JPRB, 0.16995469E-09_JPRB, &
  & 0.16995270E-09_JPRB, 0.16995078E-09_JPRB, 0.16994749E-09_JPRB, 0.16994420E-09_JPRB, 0.16994003E-09_JPRB, 0.16993652E-09_JPRB, &
  & 0.16992932E-09_JPRB, 0.16992133E-09_JPRB, 0.16991598E-09_JPRB, 0.16991111E-09_JPRB, 0.16990699E-09_JPRB, 0.16990477E-09_JPRB, &
  & 0.16990447E-09_JPRB, 0.16990595E-09_JPRB, 0.16990653E-09_JPRB, 0.16991014E-09_JPRB, 0.16991328E-09_JPRB, 0.16991734E-09_JPRB, &
  & 0.16992201E-09_JPRB, 0.16992542E-09_JPRB, 0.16992756E-09_JPRB, 0.16993043E-09_JPRB, 0.16993149E-09_JPRB, 0.16992967E-09_JPRB, &
  & 0.16992767E-09_JPRB, 0.16992745E-09_JPRB, 0.16992582E-09_JPRB, 0.16992364E-09_JPRB, 0.16992414E-09_JPRB, 0.16992531E-09_JPRB, &
  & 0.16992827E-09_JPRB, 0.16993139E-09_JPRB, 0.16993534E-09_JPRB, 0.16993891E-09_JPRB, 0.16994281E-09_JPRB, 0.16994994E-09_JPRB, &
  & 0.16995277E-09_JPRB, 0.16995777E-09_JPRB, 0.16995975E-09_JPRB, 0.16996343E-09_JPRB, 0.16996628E-09_JPRB, 0.16996504E-09_JPRB, &
  & 0.16996322E-09_JPRB, 0.16996377E-09_JPRB, 0.16996528E-09_JPRB, 0.16996364E-09_JPRB, 0.16996431E-09_JPRB, 0.16996052E-09_JPRB, &
  & 0.16995803E-09_JPRB, 0.16995585E-09_JPRB, 0.16995137E-09_JPRB, 0.16995241E-09_JPRB /)

RGHG8(:,86,10) = (/ &
  & 0.16995078E-09_JPRB, 0.16994958E-09_JPRB, 0.16995032E-09_JPRB, 0.16994935E-09_JPRB, 0.16994942E-09_JPRB, 0.16995273E-09_JPRB, &
  & 0.16995565E-09_JPRB, 0.16995579E-09_JPRB, 0.16995602E-09_JPRB, 0.16995627E-09_JPRB, 0.16995566E-09_JPRB, 0.16995461E-09_JPRB, &
  & 0.16995283E-09_JPRB, 0.16995091E-09_JPRB, 0.16994804E-09_JPRB, 0.16994475E-09_JPRB, 0.16994081E-09_JPRB, 0.16993722E-09_JPRB, &
  & 0.16993010E-09_JPRB, 0.16992223E-09_JPRB, 0.16991678E-09_JPRB, 0.16991204E-09_JPRB, 0.16990778E-09_JPRB, 0.16990556E-09_JPRB, &
  & 0.16990524E-09_JPRB, 0.16990684E-09_JPRB, 0.16990730E-09_JPRB, 0.16991104E-09_JPRB, 0.16991401E-09_JPRB, 0.16991812E-09_JPRB, &
  & 0.16992269E-09_JPRB, 0.16992605E-09_JPRB, 0.16992813E-09_JPRB, 0.16993107E-09_JPRB, 0.16993215E-09_JPRB, 0.16993033E-09_JPRB, &
  & 0.16992829E-09_JPRB, 0.16992818E-09_JPRB, 0.16992655E-09_JPRB, 0.16992427E-09_JPRB, 0.16992478E-09_JPRB, 0.16992598E-09_JPRB, &
  & 0.16992890E-09_JPRB, 0.16993214E-09_JPRB, 0.16993600E-09_JPRB, 0.16993949E-09_JPRB, 0.16994327E-09_JPRB, 0.16995041E-09_JPRB, &
  & 0.16995318E-09_JPRB, 0.16995814E-09_JPRB, 0.16996005E-09_JPRB, 0.16996375E-09_JPRB, 0.16996662E-09_JPRB, 0.16996531E-09_JPRB, &
  & 0.16996345E-09_JPRB, 0.16996397E-09_JPRB, 0.16996553E-09_JPRB, 0.16996386E-09_JPRB, 0.16996465E-09_JPRB, 0.16996071E-09_JPRB, &
  & 0.16995835E-09_JPRB, 0.16995608E-09_JPRB, 0.16995176E-09_JPRB, 0.16995279E-09_JPRB /)

RGHG8(:,87,10) = (/ &
  & 0.16995094E-09_JPRB, 0.16994978E-09_JPRB, 0.16995050E-09_JPRB, 0.16994947E-09_JPRB, 0.16994951E-09_JPRB, 0.16995366E-09_JPRB, &
  & 0.16995548E-09_JPRB, 0.16995585E-09_JPRB, 0.16995597E-09_JPRB, 0.16995602E-09_JPRB, 0.16995547E-09_JPRB, 0.16995443E-09_JPRB, &
  & 0.16995282E-09_JPRB, 0.16995100E-09_JPRB, 0.16994822E-09_JPRB, 0.16994522E-09_JPRB, 0.16994137E-09_JPRB, 0.16993762E-09_JPRB, &
  & 0.16993086E-09_JPRB, 0.16992281E-09_JPRB, 0.16991746E-09_JPRB, 0.16991257E-09_JPRB, 0.16990834E-09_JPRB, 0.16990605E-09_JPRB, &
  & 0.16990570E-09_JPRB, 0.16990744E-09_JPRB, 0.16990775E-09_JPRB, 0.16991156E-09_JPRB, 0.16991449E-09_JPRB, 0.16991852E-09_JPRB, &
  & 0.16992317E-09_JPRB, 0.16992645E-09_JPRB, 0.16992847E-09_JPRB, 0.16993146E-09_JPRB, 0.16993260E-09_JPRB, 0.16993071E-09_JPRB, &
  & 0.16992871E-09_JPRB, 0.16992864E-09_JPRB, 0.16992699E-09_JPRB, 0.16992456E-09_JPRB, 0.16992519E-09_JPRB, 0.16992635E-09_JPRB, &
  & 0.16992946E-09_JPRB, 0.16993257E-09_JPRB, 0.16993640E-09_JPRB, 0.16993983E-09_JPRB, 0.16994356E-09_JPRB, 0.16995069E-09_JPRB, &
  & 0.16995344E-09_JPRB, 0.16995835E-09_JPRB, 0.16996021E-09_JPRB, 0.16996393E-09_JPRB, 0.16996685E-09_JPRB, 0.16996544E-09_JPRB, &
  & 0.16996354E-09_JPRB, 0.16996410E-09_JPRB, 0.16996568E-09_JPRB, 0.16996399E-09_JPRB, 0.16996481E-09_JPRB, 0.16996093E-09_JPRB, &
  & 0.16995851E-09_JPRB, 0.16995631E-09_JPRB, 0.16995187E-09_JPRB, 0.16995300E-09_JPRB /)

RGHG8(:,88,10) = (/ &
  & 0.16995104E-09_JPRB, 0.16994994E-09_JPRB, 0.16995065E-09_JPRB, 0.16994965E-09_JPRB, 0.16995005E-09_JPRB, 0.16995305E-09_JPRB, &
  & 0.16995580E-09_JPRB, 0.16995597E-09_JPRB, 0.16995608E-09_JPRB, 0.16995608E-09_JPRB, 0.16995542E-09_JPRB, 0.16995443E-09_JPRB, &
  & 0.16995284E-09_JPRB, 0.16995103E-09_JPRB, 0.16994846E-09_JPRB, 0.16994536E-09_JPRB, 0.16994167E-09_JPRB, 0.16993795E-09_JPRB, &
  & 0.16993108E-09_JPRB, 0.16992335E-09_JPRB, 0.16991775E-09_JPRB, 0.16991299E-09_JPRB, 0.16990866E-09_JPRB, 0.16990637E-09_JPRB, &
  & 0.16990596E-09_JPRB, 0.16990782E-09_JPRB, 0.16990792E-09_JPRB, 0.16991196E-09_JPRB, 0.16991474E-09_JPRB, 0.16991882E-09_JPRB, &
  & 0.16992348E-09_JPRB, 0.16992674E-09_JPRB, 0.16992867E-09_JPRB, 0.16993172E-09_JPRB, 0.16993282E-09_JPRB, 0.16993099E-09_JPRB, &
  & 0.16992890E-09_JPRB, 0.16992895E-09_JPRB, 0.16992723E-09_JPRB, 0.16992469E-09_JPRB, 0.16992538E-09_JPRB, 0.16992659E-09_JPRB, &
  & 0.16992971E-09_JPRB, 0.16993287E-09_JPRB, 0.16993668E-09_JPRB, 0.16994002E-09_JPRB, 0.16994373E-09_JPRB, 0.16995085E-09_JPRB, &
  & 0.16995358E-09_JPRB, 0.16995848E-09_JPRB, 0.16996032E-09_JPRB, 0.16996406E-09_JPRB, 0.16996698E-09_JPRB, 0.16996550E-09_JPRB, &
  & 0.16996361E-09_JPRB, 0.16996415E-09_JPRB, 0.16996578E-09_JPRB, 0.16996407E-09_JPRB, 0.16996494E-09_JPRB, 0.16996100E-09_JPRB, &
  & 0.16995859E-09_JPRB, 0.16995635E-09_JPRB, 0.16995198E-09_JPRB, 0.16995315E-09_JPRB /)

RGHG8(:,89,10) = (/ &
  & 0.16995104E-09_JPRB, 0.16995004E-09_JPRB, 0.16995072E-09_JPRB, 0.16994961E-09_JPRB, 0.16994953E-09_JPRB, 0.16995388E-09_JPRB, &
  & 0.16995572E-09_JPRB, 0.16995608E-09_JPRB, 0.16995619E-09_JPRB, 0.16995629E-09_JPRB, 0.16995572E-09_JPRB, 0.16995469E-09_JPRB, &
  & 0.16995302E-09_JPRB, 0.16995119E-09_JPRB, 0.16994843E-09_JPRB, 0.16994546E-09_JPRB, 0.16994164E-09_JPRB, 0.16993801E-09_JPRB, &
  & 0.16993125E-09_JPRB, 0.16992321E-09_JPRB, 0.16991791E-09_JPRB, 0.16991311E-09_JPRB, 0.16990880E-09_JPRB, 0.16990646E-09_JPRB, &
  & 0.16990612E-09_JPRB, 0.16990803E-09_JPRB, 0.16990803E-09_JPRB, 0.16991214E-09_JPRB, 0.16991490E-09_JPRB, 0.16991900E-09_JPRB, &
  & 0.16992369E-09_JPRB, 0.16992689E-09_JPRB, 0.16992875E-09_JPRB, 0.16993192E-09_JPRB, 0.16993307E-09_JPRB, 0.16993115E-09_JPRB, &
  & 0.16992896E-09_JPRB, 0.16992911E-09_JPRB, 0.16992735E-09_JPRB, 0.16992467E-09_JPRB, 0.16992552E-09_JPRB, 0.16992671E-09_JPRB, &
  & 0.16992993E-09_JPRB, 0.16993300E-09_JPRB, 0.16993683E-09_JPRB, 0.16994015E-09_JPRB, 0.16994378E-09_JPRB, 0.16995097E-09_JPRB, &
  & 0.16995359E-09_JPRB, 0.16995852E-09_JPRB, 0.16996035E-09_JPRB, 0.16996414E-09_JPRB, 0.16996711E-09_JPRB, 0.16996556E-09_JPRB, &
  & 0.16996361E-09_JPRB, 0.16996420E-09_JPRB, 0.16996585E-09_JPRB, 0.16996408E-09_JPRB, 0.16996504E-09_JPRB, 0.16996109E-09_JPRB, &
  & 0.16995864E-09_JPRB, 0.16995641E-09_JPRB, 0.16995196E-09_JPRB, 0.16995319E-09_JPRB /)

RGHG8(:,90,10) = (/ &
  & 0.16995108E-09_JPRB, 0.16995007E-09_JPRB, 0.16995076E-09_JPRB, 0.16994961E-09_JPRB, 0.16994949E-09_JPRB, 0.16995311E-09_JPRB, &
  & 0.16995627E-09_JPRB, 0.16995633E-09_JPRB, 0.16995655E-09_JPRB, 0.16995685E-09_JPRB, 0.16995622E-09_JPRB, 0.16995513E-09_JPRB, &
  & 0.16995325E-09_JPRB, 0.16995137E-09_JPRB, 0.16994843E-09_JPRB, 0.16994524E-09_JPRB, 0.16994142E-09_JPRB, 0.16993815E-09_JPRB, &
  & 0.16993099E-09_JPRB, 0.16992309E-09_JPRB, 0.16991780E-09_JPRB, 0.16991314E-09_JPRB, 0.16990877E-09_JPRB, 0.16990648E-09_JPRB, &
  & 0.16990612E-09_JPRB, 0.16990818E-09_JPRB, 0.16990795E-09_JPRB, 0.16991228E-09_JPRB, 0.16991493E-09_JPRB, 0.16991898E-09_JPRB, &
  & 0.16992376E-09_JPRB, 0.16992698E-09_JPRB, 0.16992877E-09_JPRB, 0.16993207E-09_JPRB, 0.16993326E-09_JPRB, 0.16993124E-09_JPRB, &
  & 0.16992892E-09_JPRB, 0.16992927E-09_JPRB, 0.16992746E-09_JPRB, 0.16992457E-09_JPRB, 0.16992559E-09_JPRB, 0.16992673E-09_JPRB, &
  & 0.16993003E-09_JPRB, 0.16993307E-09_JPRB, 0.16993690E-09_JPRB, 0.16994017E-09_JPRB, 0.16994375E-09_JPRB, 0.16995115E-09_JPRB, &
  & 0.16995363E-09_JPRB, 0.16995864E-09_JPRB, 0.16996034E-09_JPRB, 0.16996421E-09_JPRB, 0.16996728E-09_JPRB, 0.16996556E-09_JPRB, &
  & 0.16996353E-09_JPRB, 0.16996418E-09_JPRB, 0.16996596E-09_JPRB, 0.16996406E-09_JPRB, 0.16996518E-09_JPRB, 0.16996103E-09_JPRB, &
  & 0.16995860E-09_JPRB, 0.16995641E-09_JPRB, 0.16995187E-09_JPRB, 0.16995326E-09_JPRB /)

RGHG8(:,91,10) = (/ &
  & 0.16995112E-09_JPRB, 0.16995012E-09_JPRB, 0.16995091E-09_JPRB, 0.16994949E-09_JPRB, 0.16994872E-09_JPRB, 0.16995311E-09_JPRB, &
  & 0.16995681E-09_JPRB, 0.16995623E-09_JPRB, 0.16995635E-09_JPRB, 0.16995810E-09_JPRB, 0.16995706E-09_JPRB, 0.16995615E-09_JPRB, &
  & 0.16995311E-09_JPRB, 0.16995191E-09_JPRB, 0.16994799E-09_JPRB, 0.16994509E-09_JPRB, 0.16994084E-09_JPRB, 0.16993852E-09_JPRB, &
  & 0.16993078E-09_JPRB, 0.16992260E-09_JPRB, 0.16991775E-09_JPRB, 0.16991313E-09_JPRB, 0.16990867E-09_JPRB, 0.16990635E-09_JPRB, &
  & 0.16990598E-09_JPRB, 0.16990832E-09_JPRB, 0.16990766E-09_JPRB, 0.16991239E-09_JPRB, 0.16991480E-09_JPRB, 0.16991888E-09_JPRB, &
  & 0.16992392E-09_JPRB, 0.16992713E-09_JPRB, 0.16992864E-09_JPRB, 0.16993233E-09_JPRB, 0.16993359E-09_JPRB, 0.16993126E-09_JPRB, &
  & 0.16992868E-09_JPRB, 0.16992946E-09_JPRB, 0.16992752E-09_JPRB, 0.16992431E-09_JPRB, 0.16992560E-09_JPRB, 0.16992660E-09_JPRB, &
  & 0.16993006E-09_JPRB, 0.16993301E-09_JPRB, 0.16993697E-09_JPRB, 0.16994016E-09_JPRB, 0.16994352E-09_JPRB, 0.16995148E-09_JPRB, &
  & 0.16995350E-09_JPRB, 0.16995889E-09_JPRB, 0.16996023E-09_JPRB, 0.16996429E-09_JPRB, 0.16996762E-09_JPRB, 0.16996557E-09_JPRB, &
  & 0.16996339E-09_JPRB, 0.16996413E-09_JPRB, 0.16996619E-09_JPRB, 0.16996388E-09_JPRB, 0.16996551E-09_JPRB, 0.16996088E-09_JPRB, &
  & 0.16995853E-09_JPRB, 0.16995642E-09_JPRB, 0.16995157E-09_JPRB, 0.16995327E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART20',1,ZHOOK_HANDLE)
END SUBROUTINE PART20






SUBROUTINE PART21
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART21',0,ZHOOK_HANDLE)



!-- Month= 11 ------------

RGHG8(:, 1,11) = (/ &
  & 0.40303563E-10_JPRB, 0.40328536E-10_JPRB, 0.40144939E-10_JPRB, 0.39979541E-10_JPRB, 0.39836679E-10_JPRB, 0.39712972E-10_JPRB, &
  & 0.39595709E-10_JPRB, 0.39476103E-10_JPRB, 0.39365174E-10_JPRB, 0.39265265E-10_JPRB, 0.39180680E-10_JPRB, 0.39120734E-10_JPRB, &
  & 0.39087438E-10_JPRB, 0.39086095E-10_JPRB, 0.39115856E-10_JPRB, 0.39182740E-10_JPRB, 0.39276124E-10_JPRB, 0.39389946E-10_JPRB, &
  & 0.39511280E-10_JPRB, 0.39627385E-10_JPRB, 0.39726760E-10_JPRB, 0.39807071E-10_JPRB, 0.39868518E-10_JPRB, 0.39914728E-10_JPRB, &
  & 0.39949644E-10_JPRB, 0.39975707E-10_JPRB, 0.39998033E-10_JPRB, 0.40019214E-10_JPRB, 0.40036720E-10_JPRB, 0.40049870E-10_JPRB, &
  & 0.40058248E-10_JPRB, 0.40061347E-10_JPRB, 0.40056188E-10_JPRB, 0.40045946E-10_JPRB, 0.40031829E-10_JPRB, 0.40015560E-10_JPRB, &
  & 0.39997724E-10_JPRB, 0.39977154E-10_JPRB, 0.39950498E-10_JPRB, 0.39919557E-10_JPRB, 0.39885761E-10_JPRB, 0.39850540E-10_JPRB, &
  & 0.39813788E-10_JPRB, 0.39772529E-10_JPRB, 0.39724266E-10_JPRB, 0.39668116E-10_JPRB, 0.39600049E-10_JPRB, 0.39515995E-10_JPRB, &
  & 0.39413008E-10_JPRB, 0.39294245E-10_JPRB, 0.39167249E-10_JPRB, 0.39046256E-10_JPRB, 0.38944657E-10_JPRB, 0.38871580E-10_JPRB, &
  & 0.38826442E-10_JPRB, 0.38802121E-10_JPRB, 0.38790110E-10_JPRB, 0.38783515E-10_JPRB, 0.38780132E-10_JPRB, 0.38779396E-10_JPRB, &
  & 0.38780142E-10_JPRB, 0.38781020E-10_JPRB, 0.38782925E-10_JPRB, 0.38783272E-10_JPRB /)

RGHG8(:, 2,11) = (/ &
  & 0.40651038E-10_JPRB, 0.40580629E-10_JPRB, 0.40379783E-10_JPRB, 0.40279693E-10_JPRB, 0.40183877E-10_JPRB, 0.40102935E-10_JPRB, &
  & 0.40029365E-10_JPRB, 0.39965972E-10_JPRB, 0.39917392E-10_JPRB, 0.39883832E-10_JPRB, 0.39871009E-10_JPRB, 0.39887302E-10_JPRB, &
  & 0.39942234E-10_JPRB, 0.40049984E-10_JPRB, 0.40212854E-10_JPRB, 0.40423168E-10_JPRB, 0.40654827E-10_JPRB, 0.40882981E-10_JPRB, &
  & 0.41084150E-10_JPRB, 0.41243065E-10_JPRB, 0.41352803E-10_JPRB, 0.41418067E-10_JPRB, 0.41447061E-10_JPRB, 0.41449559E-10_JPRB, &
  & 0.41434009E-10_JPRB, 0.41405348E-10_JPRB, 0.41367933E-10_JPRB, 0.41322504E-10_JPRB, 0.41270418E-10_JPRB, 0.41212530E-10_JPRB, &
  & 0.41148591E-10_JPRB, 0.41078713E-10_JPRB, 0.41001962E-10_JPRB, 0.40921905E-10_JPRB, 0.40841351E-10_JPRB, 0.40763115E-10_JPRB, &
  & 0.40687360E-10_JPRB, 0.40614470E-10_JPRB, 0.40541650E-10_JPRB, 0.40469388E-10_JPRB, 0.40396221E-10_JPRB, 0.40321815E-10_JPRB, &
  & 0.40245959E-10_JPRB, 0.40168140E-10_JPRB, 0.40086278E-10_JPRB, 0.40000649E-10_JPRB, 0.39913260E-10_JPRB, 0.39828699E-10_JPRB, &
  & 0.39749513E-10_JPRB, 0.39670732E-10_JPRB, 0.39578847E-10_JPRB, 0.39465802E-10_JPRB, 0.39338661E-10_JPRB, 0.39215881E-10_JPRB, &
  & 0.39112737E-10_JPRB, 0.39035986E-10_JPRB, 0.38984684E-10_JPRB, 0.38954902E-10_JPRB, 0.38939935E-10_JPRB, 0.38932788E-10_JPRB, &
  & 0.38932108E-10_JPRB, 0.38932052E-10_JPRB, 0.38938720E-10_JPRB, 0.38942401E-10_JPRB /)

RGHG8(:, 3,11) = (/ &
  & 0.40830457E-10_JPRB, 0.40708506E-10_JPRB, 0.40622013E-10_JPRB, 0.40562109E-10_JPRB, 0.40525652E-10_JPRB, 0.40503292E-10_JPRB, &
  & 0.40493591E-10_JPRB, 0.40496006E-10_JPRB, 0.40512704E-10_JPRB, 0.40548766E-10_JPRB, 0.40615421E-10_JPRB, 0.40717672E-10_JPRB, &
  & 0.40869190E-10_JPRB, 0.41077242E-10_JPRB, 0.41329280E-10_JPRB, 0.41605032E-10_JPRB, 0.41875965E-10_JPRB, 0.42120828E-10_JPRB, &
  & 0.42325116E-10_JPRB, 0.42478125E-10_JPRB, 0.42575613E-10_JPRB, 0.42623582E-10_JPRB, 0.42631038E-10_JPRB, 0.42608198E-10_JPRB, &
  & 0.42563744E-10_JPRB, 0.42501582E-10_JPRB, 0.42425691E-10_JPRB, 0.42335167E-10_JPRB, 0.42233050E-10_JPRB, 0.42121431E-10_JPRB, &
  & 0.42000528E-10_JPRB, 0.41869362E-10_JPRB, 0.41727136E-10_JPRB, 0.41578341E-10_JPRB, 0.41425925E-10_JPRB, 0.41272392E-10_JPRB, &
  & 0.41121717E-10_JPRB, 0.40975823E-10_JPRB, 0.40834561E-10_JPRB, 0.40699652E-10_JPRB, 0.40574093E-10_JPRB, 0.40458272E-10_JPRB, &
  & 0.40351403E-10_JPRB, 0.40250983E-10_JPRB, 0.40157280E-10_JPRB, 0.40074256E-10_JPRB, 0.40002727E-10_JPRB, 0.39933931E-10_JPRB, &
  & 0.39850241E-10_JPRB, 0.39741925E-10_JPRB, 0.39619419E-10_JPRB, 0.39502263E-10_JPRB, 0.39396909E-10_JPRB, 0.39301652E-10_JPRB, &
  & 0.39220398E-10_JPRB, 0.39160425E-10_JPRB, 0.39124363E-10_JPRB, 0.39107582E-10_JPRB, 0.39107911E-10_JPRB, 0.39123139E-10_JPRB, &
  & 0.39146630E-10_JPRB, 0.39172679E-10_JPRB, 0.39210975E-10_JPRB, 0.39253770E-10_JPRB /)

RGHG8(:, 4,11) = (/ &
  & 0.40964180E-10_JPRB, 0.40883463E-10_JPRB, 0.40858636E-10_JPRB, 0.40851933E-10_JPRB, 0.40860738E-10_JPRB, 0.40882984E-10_JPRB, &
  & 0.40919719E-10_JPRB, 0.40973700E-10_JPRB, 0.41048033E-10_JPRB, 0.41149802E-10_JPRB, 0.41280670E-10_JPRB, 0.41459683E-10_JPRB, &
  & 0.41679438E-10_JPRB, 0.41936669E-10_JPRB, 0.42216796E-10_JPRB, 0.42501273E-10_JPRB, 0.42770149E-10_JPRB, 0.43016861E-10_JPRB, &
  & 0.43230555E-10_JPRB, 0.43397539E-10_JPRB, 0.43505487E-10_JPRB, 0.43552613E-10_JPRB, 0.43543644E-10_JPRB, 0.43489247E-10_JPRB, &
  & 0.43403198E-10_JPRB, 0.43294968E-10_JPRB, 0.43168438E-10_JPRB, 0.43024251E-10_JPRB, 0.42861874E-10_JPRB, 0.42685810E-10_JPRB, &
  & 0.42498963E-10_JPRB, 0.42299782E-10_JPRB, 0.42086189E-10_JPRB, 0.41864130E-10_JPRB, 0.41641173E-10_JPRB, 0.41427306E-10_JPRB, &
  & 0.41231241E-10_JPRB, 0.41059402E-10_JPRB, 0.40910289E-10_JPRB, 0.40777534E-10_JPRB, 0.40651850E-10_JPRB, 0.40530860E-10_JPRB, &
  & 0.40415365E-10_JPRB, 0.40305093E-10_JPRB, 0.40202189E-10_JPRB, 0.40107490E-10_JPRB, 0.40015102E-10_JPRB, 0.39916612E-10_JPRB, &
  & 0.39813583E-10_JPRB, 0.39718194E-10_JPRB, 0.39630757E-10_JPRB, 0.39537915E-10_JPRB, 0.39437467E-10_JPRB, 0.39344143E-10_JPRB, &
  & 0.39271850E-10_JPRB, 0.39230206E-10_JPRB, 0.39224717E-10_JPRB, 0.39254683E-10_JPRB, 0.39312560E-10_JPRB, 0.39390467E-10_JPRB, &
  & 0.39478750E-10_JPRB, 0.39566631E-10_JPRB, 0.39683142E-10_JPRB, 0.39843684E-10_JPRB /)

RGHG8(:, 5,11) = (/ &
  & 0.41073766E-10_JPRB, 0.41048193E-10_JPRB, 0.41061980E-10_JPRB, 0.41095596E-10_JPRB, 0.41145930E-10_JPRB, 0.41211680E-10_JPRB, &
  & 0.41293153E-10_JPRB, 0.41392681E-10_JPRB, 0.41519663E-10_JPRB, 0.41672121E-10_JPRB, 0.41865005E-10_JPRB, 0.42095202E-10_JPRB, &
  & 0.42356049E-10_JPRB, 0.42635159E-10_JPRB, 0.42921888E-10_JPRB, 0.43217933E-10_JPRB, 0.43512253E-10_JPRB, 0.43788962E-10_JPRB, &
  & 0.44038086E-10_JPRB, 0.44249982E-10_JPRB, 0.44415825E-10_JPRB, 0.44525696E-10_JPRB, 0.44571312E-10_JPRB, 0.44549052E-10_JPRB, &
  & 0.44468068E-10_JPRB, 0.44347560E-10_JPRB, 0.44213848E-10_JPRB, 0.44081273E-10_JPRB, 0.43951849E-10_JPRB, 0.43817252E-10_JPRB, &
  & 0.43668305E-10_JPRB, 0.43501196E-10_JPRB, 0.43317065E-10_JPRB, 0.43129389E-10_JPRB, 0.42957804E-10_JPRB, 0.42823155E-10_JPRB, &
  & 0.42740769E-10_JPRB, 0.42706606E-10_JPRB, 0.42690643E-10_JPRB, 0.42646525E-10_JPRB, 0.42530698E-10_JPRB, 0.42327135E-10_JPRB, &
  & 0.42050766E-10_JPRB, 0.41732055E-10_JPRB, 0.41399634E-10_JPRB, 0.41078876E-10_JPRB, 0.40786236E-10_JPRB, 0.40527234E-10_JPRB, &
  & 0.40299312E-10_JPRB, 0.40093890E-10_JPRB, 0.39903525E-10_JPRB, 0.39734219E-10_JPRB, 0.39593207E-10_JPRB, 0.39480919E-10_JPRB, &
  & 0.39403689E-10_JPRB, 0.39376898E-10_JPRB, 0.39413556E-10_JPRB, 0.39508979E-10_JPRB, 0.39650436E-10_JPRB, 0.39813649E-10_JPRB, &
  & 0.39979929E-10_JPRB, 0.40142462E-10_JPRB, 0.40319626E-10_JPRB, 0.40633309E-10_JPRB /)

RGHG8(:, 6,11) = (/ &
  & 0.41193042E-10_JPRB, 0.41218941E-10_JPRB, 0.41266275E-10_JPRB, 0.41329561E-10_JPRB, 0.41408696E-10_JPRB, 0.41504161E-10_JPRB, &
  & 0.41618070E-10_JPRB, 0.41758371E-10_JPRB, 0.41931628E-10_JPRB, 0.42130095E-10_JPRB, 0.42356799E-10_JPRB, 0.42621885E-10_JPRB, &
  & 0.42922676E-10_JPRB, 0.43247062E-10_JPRB, 0.43575792E-10_JPRB, 0.43906819E-10_JPRB, 0.44242762E-10_JPRB, 0.44587271E-10_JPRB, &
  & 0.44921945E-10_JPRB, 0.45225608E-10_JPRB, 0.45489154E-10_JPRB, 0.45715039E-10_JPRB, 0.45903444E-10_JPRB, 0.46058313E-10_JPRB, &
  & 0.46182027E-10_JPRB, 0.46277534E-10_JPRB, 0.46353196E-10_JPRB, 0.46417141E-10_JPRB, 0.46483109E-10_JPRB, 0.46564981E-10_JPRB, &
  & 0.46670154E-10_JPRB, 0.46794568E-10_JPRB, 0.46927323E-10_JPRB, 0.47065251E-10_JPRB, 0.47206163E-10_JPRB, 0.47344819E-10_JPRB, &
  & 0.47472377E-10_JPRB, 0.47564713E-10_JPRB, 0.47569115E-10_JPRB, 0.47421893E-10_JPRB, 0.47090047E-10_JPRB, 0.46591335E-10_JPRB, &
  & 0.45989677E-10_JPRB, 0.45343809E-10_JPRB, 0.44700944E-10_JPRB, 0.44081003E-10_JPRB, 0.43481559E-10_JPRB, 0.42894861E-10_JPRB, &
  & 0.42325709E-10_JPRB, 0.41788253E-10_JPRB, 0.41296917E-10_JPRB, 0.40863150E-10_JPRB, 0.40494337E-10_JPRB, 0.40205735E-10_JPRB, &
  & 0.40013735E-10_JPRB, 0.39932380E-10_JPRB, 0.39965829E-10_JPRB, 0.40093040E-10_JPRB, 0.40280564E-10_JPRB, 0.40494646E-10_JPRB, &
  & 0.40719376E-10_JPRB, 0.40947312E-10_JPRB, 0.41213824E-10_JPRB, 0.41574608E-10_JPRB /)

RGHG8(:, 7,11) = (/ &
  & 0.41319545E-10_JPRB, 0.41382862E-10_JPRB, 0.41451381E-10_JPRB, 0.41538509E-10_JPRB, 0.41642099E-10_JPRB, 0.41762309E-10_JPRB, &
  & 0.41905736E-10_JPRB, 0.42076422E-10_JPRB, 0.42290373E-10_JPRB, 0.42531530E-10_JPRB, 0.42798150E-10_JPRB, 0.43083211E-10_JPRB, &
  & 0.43393428E-10_JPRB, 0.43740730E-10_JPRB, 0.44131122E-10_JPRB, 0.44552424E-10_JPRB, 0.44982244E-10_JPRB, 0.45420293E-10_JPRB, &
  & 0.45870505E-10_JPRB, 0.46330627E-10_JPRB, 0.46788035E-10_JPRB, 0.47232007E-10_JPRB, 0.47652920E-10_JPRB, 0.48043337E-10_JPRB, &
  & 0.48404742E-10_JPRB, 0.48741056E-10_JPRB, 0.49073141E-10_JPRB, 0.49426754E-10_JPRB, 0.49817966E-10_JPRB, 0.50260282E-10_JPRB, &
  & 0.50746945E-10_JPRB, 0.51251788E-10_JPRB, 0.51724278E-10_JPRB, 0.52118448E-10_JPRB, 0.52423274E-10_JPRB, 0.52653527E-10_JPRB, &
  & 0.52807578E-10_JPRB, 0.52850335E-10_JPRB, 0.52720026E-10_JPRB, 0.52355807E-10_JPRB, 0.51739196E-10_JPRB, 0.50958709E-10_JPRB, &
  & 0.50121272E-10_JPRB, 0.49311697E-10_JPRB, 0.48543509E-10_JPRB, 0.47802453E-10_JPRB, 0.47068391E-10_JPRB, 0.46332972E-10_JPRB, &
  & 0.45590254E-10_JPRB, 0.44831791E-10_JPRB, 0.44066788E-10_JPRB, 0.43323310E-10_JPRB, 0.42645582E-10_JPRB, 0.42078497E-10_JPRB, &
  & 0.41663568E-10_JPRB, 0.41424999E-10_JPRB, 0.41360269E-10_JPRB, 0.41431053E-10_JPRB, 0.41592979E-10_JPRB, 0.41800726E-10_JPRB, &
  & 0.42020897E-10_JPRB, 0.42243358E-10_JPRB, 0.42470055E-10_JPRB, 0.42944398E-10_JPRB /)

RGHG8(:, 8,11) = (/ &
  & 0.41648553E-10_JPRB, 0.41668936E-10_JPRB, 0.41751734E-10_JPRB, 0.41855883E-10_JPRB, 0.41977768E-10_JPRB, 0.42119461E-10_JPRB, &
  & 0.42282903E-10_JPRB, 0.42480415E-10_JPRB, 0.42723491E-10_JPRB, 0.43001665E-10_JPRB, 0.43316111E-10_JPRB, 0.43663032E-10_JPRB, &
  & 0.44035300E-10_JPRB, 0.44432874E-10_JPRB, 0.44861590E-10_JPRB, 0.45346921E-10_JPRB, 0.45893428E-10_JPRB, 0.46476739E-10_JPRB, &
  & 0.47070549E-10_JPRB, 0.47669049E-10_JPRB, 0.48279495E-10_JPRB, 0.48909533E-10_JPRB, 0.49562708E-10_JPRB, 0.50232891E-10_JPRB, &
  & 0.50913648E-10_JPRB, 0.51599669E-10_JPRB, 0.52294172E-10_JPRB, 0.53006270E-10_JPRB, 0.53744984E-10_JPRB, 0.54508533E-10_JPRB, &
  & 0.55282810E-10_JPRB, 0.56040100E-10_JPRB, 0.56760544E-10_JPRB, 0.57412144E-10_JPRB, 0.57919395E-10_JPRB, 0.58231905E-10_JPRB, &
  & 0.58340624E-10_JPRB, 0.58223523E-10_JPRB, 0.57837964E-10_JPRB, 0.57141160E-10_JPRB, 0.56182465E-10_JPRB, 0.55081301E-10_JPRB, &
  & 0.54024025E-10_JPRB, 0.53066791E-10_JPRB, 0.52205684E-10_JPRB, 0.51407247E-10_JPRB, 0.50643233E-10_JPRB, 0.49885075E-10_JPRB, &
  & 0.49098805E-10_JPRB, 0.48271109E-10_JPRB, 0.47404164E-10_JPRB, 0.46518740E-10_JPRB, 0.45656898E-10_JPRB, 0.44886674E-10_JPRB, &
  & 0.44271906E-10_JPRB, 0.43857230E-10_JPRB, 0.43642749E-10_JPRB, 0.43591519E-10_JPRB, 0.43654566E-10_JPRB, 0.43784140E-10_JPRB, &
  & 0.43942117E-10_JPRB, 0.44114087E-10_JPRB, 0.44297063E-10_JPRB, 0.44520446E-10_JPRB /)

RGHG8(:, 9,11) = (/ &
  & 0.42231826E-10_JPRB, 0.42298616E-10_JPRB, 0.42392919E-10_JPRB, 0.42510166E-10_JPRB, 0.42653107E-10_JPRB, 0.42821784E-10_JPRB, &
  & 0.43020899E-10_JPRB, 0.43253783E-10_JPRB, 0.43535620E-10_JPRB, 0.43846690E-10_JPRB, 0.44197361E-10_JPRB, 0.44589867E-10_JPRB, &
  & 0.45023266E-10_JPRB, 0.45509953E-10_JPRB, 0.46040321E-10_JPRB, 0.46596685E-10_JPRB, 0.47194387E-10_JPRB, 0.47861506E-10_JPRB, &
  & 0.48593400E-10_JPRB, 0.49377297E-10_JPRB, 0.50197464E-10_JPRB, 0.51059330E-10_JPRB, 0.51951991E-10_JPRB, 0.52869858E-10_JPRB, &
  & 0.53800860E-10_JPRB, 0.54732448E-10_JPRB, 0.55675825E-10_JPRB, 0.56628164E-10_JPRB, 0.57604966E-10_JPRB, 0.58609312E-10_JPRB, &
  & 0.59641729E-10_JPRB, 0.60667249E-10_JPRB, 0.61599392E-10_JPRB, 0.62369290E-10_JPRB, 0.62936753E-10_JPRB, 0.63250696E-10_JPRB, &
  & 0.63298575E-10_JPRB, 0.63080000E-10_JPRB, 0.62565883E-10_JPRB, 0.61750632E-10_JPRB, 0.60655113E-10_JPRB, 0.59417624E-10_JPRB, &
  & 0.58169372E-10_JPRB, 0.57038499E-10_JPRB, 0.56037834E-10_JPRB, 0.55144705E-10_JPRB, 0.54308870E-10_JPRB, 0.53481698E-10_JPRB, &
  & 0.52631101E-10_JPRB, 0.51737250E-10_JPRB, 0.50789744E-10_JPRB, 0.49807235E-10_JPRB, 0.48837014E-10_JPRB, 0.47945335E-10_JPRB, &
  & 0.47204553E-10_JPRB, 0.46658819E-10_JPRB, 0.46315222E-10_JPRB, 0.46142999E-10_JPRB, 0.46100436E-10_JPRB, 0.46141767E-10_JPRB, &
  & 0.46230707E-10_JPRB, 0.46335071E-10_JPRB, 0.46488955E-10_JPRB, 0.46746818E-10_JPRB /)

RGHG8(:,10,11) = (/ &
  & 0.43652235E-10_JPRB, 0.43664197E-10_JPRB, 0.43748474E-10_JPRB, 0.43886030E-10_JPRB, 0.44070393E-10_JPRB, 0.44300345E-10_JPRB, &
  & 0.44574417E-10_JPRB, 0.44896576E-10_JPRB, 0.45274919E-10_JPRB, 0.45684945E-10_JPRB, 0.46134471E-10_JPRB, 0.46636507E-10_JPRB, &
  & 0.47188843E-10_JPRB, 0.47785016E-10_JPRB, 0.48463050E-10_JPRB, 0.49218421E-10_JPRB, 0.50025335E-10_JPRB, 0.50875134E-10_JPRB, &
  & 0.51772284E-10_JPRB, 0.52732759E-10_JPRB, 0.53725153E-10_JPRB, 0.54772548E-10_JPRB, 0.55848694E-10_JPRB, 0.56951534E-10_JPRB, &
  & 0.58043535E-10_JPRB, 0.59117031E-10_JPRB, 0.60172145E-10_JPRB, 0.61214929E-10_JPRB, 0.62276656E-10_JPRB, 0.63364633E-10_JPRB, &
  & 0.64480164E-10_JPRB, 0.65602336E-10_JPRB, 0.66672001E-10_JPRB, 0.67557224E-10_JPRB, 0.68171101E-10_JPRB, 0.68494779E-10_JPRB, &
  & 0.68523506E-10_JPRB, 0.68281818E-10_JPRB, 0.67798225E-10_JPRB, 0.67042649E-10_JPRB, 0.65997173E-10_JPRB, 0.64715178E-10_JPRB, &
  & 0.63385637E-10_JPRB, 0.62116152E-10_JPRB, 0.60962471E-10_JPRB, 0.59891099E-10_JPRB, 0.58865905E-10_JPRB, 0.57844358E-10_JPRB, &
  & 0.56792016E-10_JPRB, 0.55685997E-10_JPRB, 0.54530339E-10_JPRB, 0.53350990E-10_JPRB, 0.52205282E-10_JPRB, 0.51169374E-10_JPRB, &
  & 0.50315096E-10_JPRB, 0.49682335E-10_JPRB, 0.49265928E-10_JPRB, 0.49025620E-10_JPRB, 0.48912367E-10_JPRB, 0.48879636E-10_JPRB, &
  & 0.48890770E-10_JPRB, 0.48924097E-10_JPRB, 0.48955347E-10_JPRB, 0.49014494E-10_JPRB /)

RGHG8(:,11,11) = (/ &
  & 0.46135300E-10_JPRB, 0.46136057E-10_JPRB, 0.46252668E-10_JPRB, 0.46440737E-10_JPRB, 0.46694128E-10_JPRB, 0.47009976E-10_JPRB, &
  & 0.47387476E-10_JPRB, 0.47825313E-10_JPRB, 0.48328216E-10_JPRB, 0.48863372E-10_JPRB, 0.49432854E-10_JPRB, 0.50052785E-10_JPRB, &
  & 0.50756337E-10_JPRB, 0.51549136E-10_JPRB, 0.52426986E-10_JPRB, 0.53424893E-10_JPRB, 0.54538877E-10_JPRB, 0.55749891E-10_JPRB, &
  & 0.57032039E-10_JPRB, 0.58376574E-10_JPRB, 0.59741545E-10_JPRB, 0.61115273E-10_JPRB, 0.62461432E-10_JPRB, 0.63761427E-10_JPRB, &
  & 0.64936216E-10_JPRB, 0.66004410E-10_JPRB, 0.66953998E-10_JPRB, 0.67822879E-10_JPRB, 0.68663637E-10_JPRB, 0.69512403E-10_JPRB, &
  & 0.70417810E-10_JPRB, 0.71354006E-10_JPRB, 0.72299278E-10_JPRB, 0.73182779E-10_JPRB, 0.73870944E-10_JPRB, 0.74286195E-10_JPRB, &
  & 0.74418791E-10_JPRB, 0.74309732E-10_JPRB, 0.74006357E-10_JPRB, 0.73518379E-10_JPRB, 0.72802042E-10_JPRB, 0.71844024E-10_JPRB, &
  & 0.70685589E-10_JPRB, 0.69424272E-10_JPRB, 0.68126484E-10_JPRB, 0.66828286E-10_JPRB, 0.65508640E-10_JPRB, 0.64146841E-10_JPRB, &
  & 0.62716603E-10_JPRB, 0.61222465E-10_JPRB, 0.59675750E-10_JPRB, 0.58135254E-10_JPRB, 0.56670717E-10_JPRB, 0.55378188E-10_JPRB, &
  & 0.54319112E-10_JPRB, 0.53514290E-10_JPRB, 0.52939174E-10_JPRB, 0.52546523E-10_JPRB, 0.52291498E-10_JPRB, 0.52135692E-10_JPRB, &
  & 0.52041267E-10_JPRB, 0.51995699E-10_JPRB, 0.51961477E-10_JPRB, 0.51942027E-10_JPRB /)

RGHG8(:,12,11) = (/ &
  & 0.49891605E-10_JPRB, 0.49888923E-10_JPRB, 0.50066229E-10_JPRB, 0.50349194E-10_JPRB, 0.50725858E-10_JPRB, 0.51196745E-10_JPRB, &
  & 0.51762143E-10_JPRB, 0.52421102E-10_JPRB, 0.53175974E-10_JPRB, 0.53991107E-10_JPRB, 0.54862656E-10_JPRB, 0.55792076E-10_JPRB, &
  & 0.56795173E-10_JPRB, 0.57919298E-10_JPRB, 0.59186059E-10_JPRB, 0.60601711E-10_JPRB, 0.62172226E-10_JPRB, 0.63861187E-10_JPRB, &
  & 0.65626594E-10_JPRB, 0.67421436E-10_JPRB, 0.69183680E-10_JPRB, 0.70834623E-10_JPRB, 0.72360958E-10_JPRB, 0.73700761E-10_JPRB, &
  & 0.74777601E-10_JPRB, 0.75611337E-10_JPRB, 0.76194155E-10_JPRB, 0.76588111E-10_JPRB, 0.76896108E-10_JPRB, 0.77222617E-10_JPRB, &
  & 0.77662966E-10_JPRB, 0.78299901E-10_JPRB, 0.79085953E-10_JPRB, 0.79951434E-10_JPRB, 0.80675550E-10_JPRB, 0.81139886E-10_JPRB, &
  & 0.81404883E-10_JPRB, 0.81522650E-10_JPRB, 0.81485464E-10_JPRB, 0.81302819E-10_JPRB, 0.80994128E-10_JPRB, 0.80510071E-10_JPRB, &
  & 0.79777872E-10_JPRB, 0.78756765E-10_JPRB, 0.77467539E-10_JPRB, 0.75979015E-10_JPRB, 0.74326857E-10_JPRB, 0.72538135E-10_JPRB, &
  & 0.70627018E-10_JPRB, 0.68614676E-10_JPRB, 0.66547552E-10_JPRB, 0.64489469E-10_JPRB, 0.62551755E-10_JPRB, 0.60821272E-10_JPRB, &
  & 0.59371459E-10_JPRB, 0.58216813E-10_JPRB, 0.57335289E-10_JPRB, 0.56679279E-10_JPRB, 0.56204142E-10_JPRB, 0.55867061E-10_JPRB, &
  & 0.55646349E-10_JPRB, 0.55469400E-10_JPRB, 0.55357784E-10_JPRB, 0.55144656E-10_JPRB /)

RGHG8(:,13,11) = (/ &
  & 0.54965602E-10_JPRB, 0.55096927E-10_JPRB, 0.55419908E-10_JPRB, 0.55865378E-10_JPRB, 0.56430402E-10_JPRB, 0.57119909E-10_JPRB, &
  & 0.57936309E-10_JPRB, 0.58876265E-10_JPRB, 0.59934974E-10_JPRB, 0.61070496E-10_JPRB, 0.62276427E-10_JPRB, 0.63564334E-10_JPRB, &
  & 0.64953105E-10_JPRB, 0.66471897E-10_JPRB, 0.68172280E-10_JPRB, 0.70063254E-10_JPRB, 0.72143444E-10_JPRB, 0.74355251E-10_JPRB, &
  & 0.76617983E-10_JPRB, 0.78850280E-10_JPRB, 0.80952078E-10_JPRB, 0.82805943E-10_JPRB, 0.84362330E-10_JPRB, 0.85583929E-10_JPRB, &
  & 0.86384816E-10_JPRB, 0.86788604E-10_JPRB, 0.86831563E-10_JPRB, 0.86612648E-10_JPRB, 0.86280226E-10_JPRB, 0.85969246E-10_JPRB, &
  & 0.85865579E-10_JPRB, 0.86045823E-10_JPRB, 0.86573658E-10_JPRB, 0.87218704E-10_JPRB, 0.87941467E-10_JPRB, 0.88652662E-10_JPRB, &
  & 0.89217987E-10_JPRB, 0.89606017E-10_JPRB, 0.89868821E-10_JPRB, 0.90032780E-10_JPRB, 0.90069327E-10_JPRB, 0.89916956E-10_JPRB, &
  & 0.89491581E-10_JPRB, 0.88710761E-10_JPRB, 0.87538407E-10_JPRB, 0.86007229E-10_JPRB, 0.84171302E-10_JPRB, 0.82080259E-10_JPRB, &
  & 0.79778323E-10_JPRB, 0.77325375E-10_JPRB, 0.74777601E-10_JPRB, 0.72238188E-10_JPRB, 0.69810636E-10_JPRB, 0.67615767E-10_JPRB, &
  & 0.65729443E-10_JPRB, 0.64185601E-10_JPRB, 0.62964266E-10_JPRB, 0.62022769E-10_JPRB, 0.61314023E-10_JPRB, 0.60796056E-10_JPRB, &
  & 0.60412592E-10_JPRB, 0.60155499E-10_JPRB, 0.59881974E-10_JPRB, 0.59585462E-10_JPRB /)

RGHG8(:,14,11) = (/ &
  & 0.60770590E-10_JPRB, 0.61155074E-10_JPRB, 0.61682326E-10_JPRB, 0.62344976E-10_JPRB, 0.63155023E-10_JPRB, 0.64126864E-10_JPRB, &
  & 0.65267673E-10_JPRB, 0.66572921E-10_JPRB, 0.68031969E-10_JPRB, 0.69589355E-10_JPRB, 0.71221189E-10_JPRB, 0.72915146E-10_JPRB, &
  & 0.74693057E-10_JPRB, 0.76595723E-10_JPRB, 0.78678619E-10_JPRB, 0.80974713E-10_JPRB, 0.83459011E-10_JPRB, 0.86066439E-10_JPRB, &
  & 0.88679841E-10_JPRB, 0.91188022E-10_JPRB, 0.93472188E-10_JPRB, 0.95381210E-10_JPRB, 0.96843443E-10_JPRB, 0.97822528E-10_JPRB, &
  & 0.98267339E-10_JPRB, 0.98189915E-10_JPRB, 0.97665043E-10_JPRB, 0.96801796E-10_JPRB, 0.95795816E-10_JPRB, 0.94883573E-10_JPRB, &
  & 0.94226890E-10_JPRB, 0.93997803E-10_JPRB, 0.94146732E-10_JPRB, 0.94821991E-10_JPRB, 0.95797731E-10_JPRB, 0.96776150E-10_JPRB, &
  & 0.97624353E-10_JPRB, 0.98309465E-10_JPRB, 0.98830721E-10_JPRB, 0.99191641E-10_JPRB, 0.99376798E-10_JPRB, 0.99349182E-10_JPRB, &
  & 0.99051628E-10_JPRB, 0.98405686E-10_JPRB, 0.97365380E-10_JPRB, 0.95945391E-10_JPRB, 0.94173530E-10_JPRB, 0.92083022E-10_JPRB, &
  & 0.89724186E-10_JPRB, 0.87154291E-10_JPRB, 0.84451959E-10_JPRB, 0.81707668E-10_JPRB, 0.79043883E-10_JPRB, 0.76569702E-10_JPRB, &
  & 0.74379433E-10_JPRB, 0.72518005E-10_JPRB, 0.70989062E-10_JPRB, 0.69761336E-10_JPRB, 0.68798453E-10_JPRB, 0.68061681E-10_JPRB, &
  & 0.67510046E-10_JPRB, 0.67067067E-10_JPRB, 0.66679731E-10_JPRB, 0.66019142E-10_JPRB /)

RGHG8(:,15,11) = (/ &
  & 0.66954838E-10_JPRB, 0.67691644E-10_JPRB, 0.68467586E-10_JPRB, 0.69381050E-10_JPRB, 0.70466799E-10_JPRB, 0.71748454E-10_JPRB, &
  & 0.73235862E-10_JPRB, 0.74921125E-10_JPRB, 0.76781762E-10_JPRB, 0.78752019E-10_JPRB, 0.80797292E-10_JPRB, 0.82894677E-10_JPRB, &
  & 0.85042223E-10_JPRB, 0.87269296E-10_JPRB, 0.89623572E-10_JPRB, 0.92157781E-10_JPRB, 0.94860834E-10_JPRB, 0.97656709E-10_JPRB, &
  & 0.10041350E-09_JPRB, 0.10300209E-09_JPRB, 0.10529087E-09_JPRB, 0.10713393E-09_JPRB, 0.10842512E-09_JPRB, 0.10913798E-09_JPRB, &
  & 0.10924438E-09_JPRB, 0.10876076E-09_JPRB, 0.10778620E-09_JPRB, 0.10646624E-09_JPRB, 0.10500035E-09_JPRB, 0.10361796E-09_JPRB, &
  & 0.10259087E-09_JPRB, 0.10207606E-09_JPRB, 0.10230266E-09_JPRB, 0.10307161E-09_JPRB, 0.10414130E-09_JPRB, 0.10532441E-09_JPRB, &
  & 0.10642135E-09_JPRB, 0.10732330E-09_JPRB, 0.10799676E-09_JPRB, 0.10844326E-09_JPRB, 0.10866481E-09_JPRB, 0.10864032E-09_JPRB, &
  & 0.10832833E-09_JPRB, 0.10769073E-09_JPRB, 0.10672587E-09_JPRB, 0.10544034E-09_JPRB, 0.10384395E-09_JPRB, 0.10194801E-09_JPRB, &
  & 0.99780989E-10_JPRB, 0.97391484E-10_JPRB, 0.94839830E-10_JPRB, 0.92210475E-10_JPRB, 0.89595775E-10_JPRB, 0.87095081E-10_JPRB, &
  & 0.84793172E-10_JPRB, 0.82749405E-10_JPRB, 0.80985718E-10_JPRB, 0.79503640E-10_JPRB, 0.78289104E-10_JPRB, 0.77316639E-10_JPRB, &
  & 0.76569653E-10_JPRB, 0.75951821E-10_JPRB, 0.75369412E-10_JPRB, 0.74414114E-10_JPRB /)

RGHG8(:,16,11) = (/ &
  & 0.73423448E-10_JPRB, 0.74509683E-10_JPRB, 0.75518647E-10_JPRB, 0.76665702E-10_JPRB, 0.78008447E-10_JPRB, 0.79577553E-10_JPRB, &
  & 0.81383025E-10_JPRB, 0.83414484E-10_JPRB, 0.85638219E-10_JPRB, 0.87968625E-10_JPRB, 0.90346494E-10_JPRB, 0.92735999E-10_JPRB, &
  & 0.95133346E-10_JPRB, 0.97561105E-10_JPRB, 0.10005704E-09_JPRB, 0.10266171E-09_JPRB, 0.10538517E-09_JPRB, 0.10816073E-09_JPRB, &
  & 0.11086165E-09_JPRB, 0.11335618E-09_JPRB, 0.11552154E-09_JPRB, 0.11721862E-09_JPRB, 0.11833873E-09_JPRB, 0.11884295E-09_JPRB, &
  & 0.11872388E-09_JPRB, 0.11800794E-09_JPRB, 0.11679585E-09_JPRB, 0.11526229E-09_JPRB, 0.11361032E-09_JPRB, 0.11213915E-09_JPRB, &
  & 0.11108495E-09_JPRB, 0.11064958E-09_JPRB, 0.11079519E-09_JPRB, 0.11150193E-09_JPRB, 0.11265403E-09_JPRB, 0.11397876E-09_JPRB, &
  & 0.11523831E-09_JPRB, 0.11626959E-09_JPRB, 0.11701640E-09_JPRB, 0.11747965E-09_JPRB, 0.11766606E-09_JPRB, 0.11756295E-09_JPRB, &
  & 0.11716600E-09_JPRB, 0.11649186E-09_JPRB, 0.11555806E-09_JPRB, 0.11437646E-09_JPRB, 0.11295054E-09_JPRB, 0.11128389E-09_JPRB, &
  & 0.10938300E-09_JPRB, 0.10725898E-09_JPRB, 0.10495004E-09_JPRB, 0.10252554E-09_JPRB, 0.10005990E-09_JPRB, 0.97639036E-10_JPRB, &
  & 0.95338952E-10_JPRB, 0.93224331E-10_JPRB, 0.91336175E-10_JPRB, 0.89691400E-10_JPRB, 0.88302456E-10_JPRB, 0.87167953E-10_JPRB, &
  & 0.86244664E-10_JPRB, 0.85531859E-10_JPRB, 0.84758936E-10_JPRB, 0.83690339E-10_JPRB /)

RGHG8(:,17,11) = (/ &
  & 0.80160920E-10_JPRB, 0.81515260E-10_JPRB, 0.82700909E-10_JPRB, 0.84021970E-10_JPRB, 0.85557950E-10_JPRB, 0.87340898E-10_JPRB, &
  & 0.89381384E-10_JPRB, 0.91656009E-10_JPRB, 0.94121169E-10_JPRB, 0.96682364E-10_JPRB, 0.99265304E-10_JPRB, 0.10181585E-09_JPRB, &
  & 0.10432233E-09_JPRB, 0.10680858E-09_JPRB, 0.10931467E-09_JPRB, 0.11187320E-09_JPRB, 0.11449200E-09_JPRB, 0.11712145E-09_JPRB, &
  & 0.11964911E-09_JPRB, 0.12195517E-09_JPRB, 0.12393175E-09_JPRB, 0.12546457E-09_JPRB, 0.12645134E-09_JPRB, 0.12684326E-09_JPRB, &
  & 0.12663914E-09_JPRB, 0.12588051E-09_JPRB, 0.12467652E-09_JPRB, 0.12320349E-09_JPRB, 0.12169188E-09_JPRB, 0.12037774E-09_JPRB, &
  & 0.11941996E-09_JPRB, 0.11899333E-09_JPRB, 0.11920298E-09_JPRB, 0.11997750E-09_JPRB, 0.12113080E-09_JPRB, 0.12244906E-09_JPRB, &
  & 0.12370274E-09_JPRB, 0.12473397E-09_JPRB, 0.12546647E-09_JPRB, 0.12588858E-09_JPRB, 0.12599587E-09_JPRB, 0.12579883E-09_JPRB, &
  & 0.12533066E-09_JPRB, 0.12462949E-09_JPRB, 0.12372764E-09_JPRB, 0.12264474E-09_JPRB, 0.12138698E-09_JPRB, 0.11994808E-09_JPRB, &
  & 0.11830657E-09_JPRB, 0.11645243E-09_JPRB, 0.11440767E-09_JPRB, 0.11221205E-09_JPRB, 0.10992265E-09_JPRB, 0.10761157E-09_JPRB, &
  & 0.10536010E-09_JPRB, 0.10323439E-09_JPRB, 0.10128716E-09_JPRB, 0.99556009E-10_JPRB, 0.98060983E-10_JPRB, 0.96817686E-10_JPRB, &
  & 0.95827235E-10_JPRB, 0.94988351E-10_JPRB, 0.94225558E-10_JPRB, 0.92912712E-10_JPRB /)

RGHG8(:,18,11) = (/ &
  & 0.86834630E-10_JPRB, 0.88402979E-10_JPRB, 0.89692954E-10_JPRB, 0.91114200E-10_JPRB, 0.92754832E-10_JPRB, 0.94657691E-10_JPRB, &
  & 0.96821294E-10_JPRB, 0.99224622E-10_JPRB, 0.10180562E-09_JPRB, 0.10446425E-09_JPRB, 0.10712134E-09_JPRB, 0.10971762E-09_JPRB, &
  & 0.11223646E-09_JPRB, 0.11469602E-09_JPRB, 0.11713124E-09_JPRB, 0.11957466E-09_JPRB, 0.12203230E-09_JPRB, 0.12446638E-09_JPRB, &
  & 0.12678547E-09_JPRB, 0.12888346E-09_JPRB, 0.13066967E-09_JPRB, 0.13205562E-09_JPRB, 0.13295880E-09_JPRB, 0.13332752E-09_JPRB, &
  & 0.13316540E-09_JPRB, 0.13252939E-09_JPRB, 0.13153539E-09_JPRB, 0.13034847E-09_JPRB, 0.12916149E-09_JPRB, 0.12814604E-09_JPRB, &
  & 0.12746466E-09_JPRB, 0.12726992E-09_JPRB, 0.12753403E-09_JPRB, 0.12822148E-09_JPRB, 0.12920637E-09_JPRB, 0.13031964E-09_JPRB, &
  & 0.13140114E-09_JPRB, 0.13229930E-09_JPRB, 0.13294019E-09_JPRB, 0.13326434E-09_JPRB, 0.13328542E-09_JPRB, 0.13301997E-09_JPRB, &
  & 0.13251891E-09_JPRB, 0.13182812E-09_JPRB, 0.13098722E-09_JPRB, 0.13001966E-09_JPRB, 0.12893042E-09_JPRB, 0.12770274E-09_JPRB, &
  & 0.12630549E-09_JPRB, 0.12472175E-09_JPRB, 0.12295141E-09_JPRB, 0.12101080E-09_JPRB, 0.11893982E-09_JPRB, 0.11679946E-09_JPRB, &
  & 0.11465955E-09_JPRB, 0.11259360E-09_JPRB, 0.11066545E-09_JPRB, 0.10891516E-09_JPRB, 0.10738176E-09_JPRB, 0.10608511E-09_JPRB, &
  & 0.10503612E-09_JPRB, 0.10416568E-09_JPRB, 0.10332740E-09_JPRB, 0.10196961E-09_JPRB /)

RGHG8(:,19,11) = (/ &
  & 0.93279467E-10_JPRB, 0.94973668E-10_JPRB, 0.96324615E-10_JPRB, 0.97776995E-10_JPRB, 0.99453619E-10_JPRB, 0.10138643E-09_JPRB, &
  & 0.10358248E-09_JPRB, 0.10599722E-09_JPRB, 0.10857253E-09_JPRB, 0.11120766E-09_JPRB, 0.11382474E-09_JPRB, 0.11636914E-09_JPRB, &
  & 0.11882199E-09_JPRB, 0.12120048E-09_JPRB, 0.12353327E-09_JPRB, 0.12584225E-09_JPRB, 0.12813137E-09_JPRB, 0.13037144E-09_JPRB, &
  & 0.13249317E-09_JPRB, 0.13441061E-09_JPRB, 0.13604413E-09_JPRB, 0.13732707E-09_JPRB, 0.13819620E-09_JPRB, 0.13861444E-09_JPRB, &
  & 0.13858384E-09_JPRB, 0.13816588E-09_JPRB, 0.13747893E-09_JPRB, 0.13666557E-09_JPRB, 0.13588769E-09_JPRB, 0.13526595E-09_JPRB, &
  & 0.13493524E-09_JPRB, 0.13490269E-09_JPRB, 0.13518087E-09_JPRB, 0.13572110E-09_JPRB, 0.13645488E-09_JPRB, 0.13727536E-09_JPRB, &
  & 0.13807028E-09_JPRB, 0.13874604E-09_JPRB, 0.13922061E-09_JPRB, 0.13944000E-09_JPRB, 0.13939244E-09_JPRB, 0.13910373E-09_JPRB, &
  & 0.13860951E-09_JPRB, 0.13796150E-09_JPRB, 0.13719677E-09_JPRB, 0.13633931E-09_JPRB, 0.13539155E-09_JPRB, 0.13433593E-09_JPRB, &
  & 0.13314791E-09_JPRB, 0.13180798E-09_JPRB, 0.13030300E-09_JPRB, 0.12863645E-09_JPRB, 0.12683127E-09_JPRB, 0.12492941E-09_JPRB, &
  & 0.12299031E-09_JPRB, 0.12108298E-09_JPRB, 0.11926597E-09_JPRB, 0.11759158E-09_JPRB, 0.11609518E-09_JPRB, 0.11481420E-09_JPRB, &
  & 0.11373856E-09_JPRB, 0.11287776E-09_JPRB, 0.11196947E-09_JPRB, 0.11064442E-09_JPRB /)

RGHG8(:,20,11) = (/ &
  & 0.99362157E-10_JPRB, 0.10116120E-09_JPRB, 0.10250479E-09_JPRB, 0.10395134E-09_JPRB, 0.10559857E-09_JPRB, 0.10749816E-09_JPRB, &
  & 0.10963395E-09_JPRB, 0.11197421E-09_JPRB, 0.11444613E-09_JPRB, 0.11696279E-09_JPRB, 0.11945871E-09_JPRB, 0.12188556E-09_JPRB, &
  & 0.12422598E-09_JPRB, 0.12648892E-09_JPRB, 0.12870011E-09_JPRB, 0.13087680E-09_JPRB, 0.13301547E-09_JPRB, 0.13509076E-09_JPRB, &
  & 0.13705334E-09_JPRB, 0.13883641E-09_JPRB, 0.14037296E-09_JPRB, 0.14160711E-09_JPRB, 0.14248823E-09_JPRB, 0.14299231E-09_JPRB, &
  & 0.14313489E-09_JPRB, 0.14298164E-09_JPRB, 0.14263751E-09_JPRB, 0.14221913E-09_JPRB, 0.14183681E-09_JPRB, 0.14157230E-09_JPRB, &
  & 0.14145989E-09_JPRB, 0.14153037E-09_JPRB, 0.14176274E-09_JPRB, 0.14212080E-09_JPRB, 0.14258403E-09_JPRB, 0.14309948E-09_JPRB, &
  & 0.14361669E-09_JPRB, 0.14405850E-09_JPRB, 0.14435407E-09_JPRB, 0.14448230E-09_JPRB, 0.14439323E-09_JPRB, 0.14410692E-09_JPRB, &
  & 0.14364673E-09_JPRB, 0.14305380E-09_JPRB, 0.14236216E-09_JPRB, 0.14159438E-09_JPRB, 0.14075509E-09_JPRB, 0.13983373E-09_JPRB, &
  & 0.13881241E-09_JPRB, 0.13767271E-09_JPRB, 0.13640024E-09_JPRB, 0.13499238E-09_JPRB, 0.13345974E-09_JPRB, 0.13182752E-09_JPRB, &
  & 0.13014155E-09_JPRB, 0.12845533E-09_JPRB, 0.12682924E-09_JPRB, 0.12530230E-09_JPRB, 0.12391638E-09_JPRB, 0.12269788E-09_JPRB, &
  & 0.12168991E-09_JPRB, 0.12077339E-09_JPRB, 0.11997502E-09_JPRB, 0.11843933E-09_JPRB /)

RGHG8(:,21,11) = (/ &
  & 0.10498141E-09_JPRB, 0.10680061E-09_JPRB, 0.10815386E-09_JPRB, 0.10955438E-09_JPRB, 0.11114338E-09_JPRB, 0.11294918E-09_JPRB, &
  & 0.11497339E-09_JPRB, 0.11716578E-09_JPRB, 0.11947188E-09_JPRB, 0.12181664E-09_JPRB, 0.12414494E-09_JPRB, 0.12642010E-09_JPRB, &
  & 0.12862629E-09_JPRB, 0.13076826E-09_JPRB, 0.13286264E-09_JPRB, 0.13492168E-09_JPRB, 0.13694088E-09_JPRB, 0.13889241E-09_JPRB, &
  & 0.14073587E-09_JPRB, 0.14242600E-09_JPRB, 0.14391087E-09_JPRB, 0.14513950E-09_JPRB, 0.14607085E-09_JPRB, 0.14668819E-09_JPRB, &
  & 0.14700875E-09_JPRB, 0.14709750E-09_JPRB, 0.14704726E-09_JPRB, 0.14694373E-09_JPRB, 0.14685794E-09_JPRB, 0.14683231E-09_JPRB, &
  & 0.14688105E-09_JPRB, 0.14698805E-09_JPRB, 0.14713752E-09_JPRB, 0.14732607E-09_JPRB, 0.14755108E-09_JPRB, 0.14780753E-09_JPRB, &
  & 0.14809001E-09_JPRB, 0.14833648E-09_JPRB, 0.14851917E-09_JPRB, 0.14856172E-09_JPRB, 0.14846024E-09_JPRB, 0.14818670E-09_JPRB, &
  & 0.14777024E-09_JPRB, 0.14723382E-09_JPRB, 0.14660007E-09_JPRB, 0.14589979E-09_JPRB, 0.14514114E-09_JPRB, 0.14431722E-09_JPRB, &
  & 0.14341897E-09_JPRB, 0.14243251E-09_JPRB, 0.14134680E-09_JPRB, 0.14015805E-09_JPRB, 0.13886910E-09_JPRB, 0.13749583E-09_JPRB, &
  & 0.13606714E-09_JPRB, 0.13462755E-09_JPRB, 0.13321533E-09_JPRB, 0.13187140E-09_JPRB, 0.13062702E-09_JPRB, 0.12951376E-09_JPRB, &
  & 0.12852562E-09_JPRB, 0.12771149E-09_JPRB, 0.12676421E-09_JPRB, 0.12543129E-09_JPRB /)

RGHG8(:,22,11) = (/ &
  & 0.11005378E-09_JPRB, 0.11189547E-09_JPRB, 0.11321545E-09_JPRB, 0.11457160E-09_JPRB, 0.11607071E-09_JPRB, 0.11776197E-09_JPRB, &
  & 0.11962842E-09_JPRB, 0.12164343E-09_JPRB, 0.12375422E-09_JPRB, 0.12590393E-09_JPRB, 0.12805303E-09_JPRB, 0.13017037E-09_JPRB, &
  & 0.13224280E-09_JPRB, 0.13426647E-09_JPRB, 0.13625230E-09_JPRB, 0.13820584E-09_JPRB, 0.14012252E-09_JPRB, 0.14198190E-09_JPRB, &
  & 0.14374715E-09_JPRB, 0.14538083E-09_JPRB, 0.14684404E-09_JPRB, 0.14809520E-09_JPRB, 0.14909436E-09_JPRB, 0.14982446E-09_JPRB, &
  & 0.15030714E-09_JPRB, 0.15059971E-09_JPRB, 0.15077173E-09_JPRB, 0.15088890E-09_JPRB, 0.15099194E-09_JPRB, 0.15110263E-09_JPRB, &
  & 0.15121240E-09_JPRB, 0.15130583E-09_JPRB, 0.15137330E-09_JPRB, 0.15142840E-09_JPRB, 0.15149126E-09_JPRB, 0.15157318E-09_JPRB, &
  & 0.15169124E-09_JPRB, 0.15181056E-09_JPRB, 0.15188009E-09_JPRB, 0.15188154E-09_JPRB, 0.15176432E-09_JPRB, 0.15151519E-09_JPRB, &
  & 0.15113637E-09_JPRB, 0.15064590E-09_JPRB, 0.15006325E-09_JPRB, 0.14940979E-09_JPRB, 0.14870553E-09_JPRB, 0.14795115E-09_JPRB, &
  & 0.14713976E-09_JPRB, 0.14626703E-09_JPRB, 0.14532506E-09_JPRB, 0.14431108E-09_JPRB, 0.14322500E-09_JPRB, 0.14207502E-09_JPRB, &
  & 0.14088097E-09_JPRB, 0.13966657E-09_JPRB, 0.13846239E-09_JPRB, 0.13729404E-09_JPRB, 0.13618885E-09_JPRB, 0.13516989E-09_JPRB, &
  & 0.13427194E-09_JPRB, 0.13340905E-09_JPRB, 0.13261768E-09_JPRB, 0.13110518E-09_JPRB /)

RGHG8(:,23,11) = (/ &
  & 0.11462140E-09_JPRB, 0.11639485E-09_JPRB, 0.11770769E-09_JPRB, 0.11898948E-09_JPRB, 0.12039632E-09_JPRB, 0.12195280E-09_JPRB, &
  & 0.12366014E-09_JPRB, 0.12548715E-09_JPRB, 0.12740159E-09_JPRB, 0.12936265E-09_JPRB, 0.13133857E-09_JPRB, 0.13330499E-09_JPRB, &
  & 0.13525200E-09_JPRB, 0.13717324E-09_JPRB, 0.13906837E-09_JPRB, 0.14093363E-09_JPRB, 0.14276438E-09_JPRB, 0.14454442E-09_JPRB, &
  & 0.14624821E-09_JPRB, 0.14784521E-09_JPRB, 0.14930190E-09_JPRB, 0.15057901E-09_JPRB, 0.15164017E-09_JPRB, 0.15247066E-09_JPRB, &
  & 0.15308398E-09_JPRB, 0.15352335E-09_JPRB, 0.15384306E-09_JPRB, 0.15409149E-09_JPRB, 0.15429412E-09_JPRB, 0.15445860E-09_JPRB, &
  & 0.15457997E-09_JPRB, 0.15464759E-09_JPRB, 0.15466030E-09_JPRB, 0.15463374E-09_JPRB, 0.15460061E-09_JPRB, 0.15457671E-09_JPRB, &
  & 0.15459002E-09_JPRB, 0.15461496E-09_JPRB, 0.15462649E-09_JPRB, 0.15459431E-09_JPRB, 0.15446183E-09_JPRB, 0.15422598E-09_JPRB, &
  & 0.15387976E-09_JPRB, 0.15342339E-09_JPRB, 0.15288001E-09_JPRB, 0.15226548E-09_JPRB, 0.15159925E-09_JPRB, 0.15089285E-09_JPRB, &
  & 0.15014479E-09_JPRB, 0.14935712E-09_JPRB, 0.14852307E-09_JPRB, 0.14764219E-09_JPRB, 0.14671547E-09_JPRB, 0.14574870E-09_JPRB, &
  & 0.14474924E-09_JPRB, 0.14372897E-09_JPRB, 0.14270418E-09_JPRB, 0.14169110E-09_JPRB, 0.14071150E-09_JPRB, 0.13978560E-09_JPRB, &
  & 0.13891971E-09_JPRB, 0.13813863E-09_JPRB, 0.13723080E-09_JPRB, 0.13582768E-09_JPRB /)

RGHG8(:,24,11) = (/ &
  & 0.11867009E-09_JPRB, 0.12040047E-09_JPRB, 0.12165151E-09_JPRB, 0.12286912E-09_JPRB, 0.12417611E-09_JPRB, 0.12560854E-09_JPRB, &
  & 0.12716023E-09_JPRB, 0.12881723E-09_JPRB, 0.13055396E-09_JPRB, 0.13234300E-09_JPRB, 0.13416329E-09_JPRB, 0.13599283E-09_JPRB, &
  & 0.13782216E-09_JPRB, 0.13964410E-09_JPRB, 0.14145646E-09_JPRB, 0.14324809E-09_JPRB, 0.14500570E-09_JPRB, 0.14671341E-09_JPRB, &
  & 0.14835826E-09_JPRB, 0.14991833E-09_JPRB, 0.15136384E-09_JPRB, 0.15265858E-09_JPRB, 0.15376693E-09_JPRB, 0.15466912E-09_JPRB, &
  & 0.15537160E-09_JPRB, 0.15590859E-09_JPRB, 0.15631900E-09_JPRB, 0.15663809E-09_JPRB, 0.15688519E-09_JPRB, 0.15706800E-09_JPRB, &
  & 0.15718449E-09_JPRB, 0.15723170E-09_JPRB, 0.15721660E-09_JPRB, 0.15715129E-09_JPRB, 0.15706886E-09_JPRB, 0.15699547E-09_JPRB, &
  & 0.15694610E-09_JPRB, 0.15691390E-09_JPRB, 0.15688023E-09_JPRB, 0.15681079E-09_JPRB, 0.15667287E-09_JPRB, 0.15644321E-09_JPRB, &
  & 0.15611837E-09_JPRB, 0.15568970E-09_JPRB, 0.15517257E-09_JPRB, 0.15458777E-09_JPRB, 0.15395227E-09_JPRB, 0.15328365E-09_JPRB, &
  & 0.15258203E-09_JPRB, 0.15185367E-09_JPRB, 0.15109843E-09_JPRB, 0.15031874E-09_JPRB, 0.14951548E-09_JPRB, 0.14869125E-09_JPRB, &
  & 0.14784689E-09_JPRB, 0.14698527E-09_JPRB, 0.14611026E-09_JPRB, 0.14523144E-09_JPRB, 0.14436183E-09_JPRB, 0.14351695E-09_JPRB, &
  & 0.14271391E-09_JPRB, 0.14191751E-09_JPRB, 0.14108117E-09_JPRB, 0.13961218E-09_JPRB /)

RGHG8(:,25,11) = (/ &
  & 0.12226732E-09_JPRB, 0.12396817E-09_JPRB, 0.12515780E-09_JPRB, 0.12630157E-09_JPRB, 0.12751744E-09_JPRB, 0.12883392E-09_JPRB, &
  & 0.13025228E-09_JPRB, 0.13175934E-09_JPRB, 0.13334138E-09_JPRB, 0.13498019E-09_JPRB, 0.13666096E-09_JPRB, 0.13836626E-09_JPRB, &
  & 0.14008421E-09_JPRB, 0.14180708E-09_JPRB, 0.14352933E-09_JPRB, 0.14523958E-09_JPRB, 0.14692671E-09_JPRB, 0.14857354E-09_JPRB, &
  & 0.15016186E-09_JPRB, 0.15167732E-09_JPRB, 0.15309853E-09_JPRB, 0.15439169E-09_JPRB, 0.15552086E-09_JPRB, 0.15646412E-09_JPRB, &
  & 0.15722307E-09_JPRB, 0.15781945E-09_JPRB, 0.15828372E-09_JPRB, 0.15864145E-09_JPRB, 0.15890958E-09_JPRB, 0.15909740E-09_JPRB, &
  & 0.15920776E-09_JPRB, 0.15924555E-09_JPRB, 0.15922250E-09_JPRB, 0.15915162E-09_JPRB, 0.15905548E-09_JPRB, 0.15896262E-09_JPRB, &
  & 0.15888514E-09_JPRB, 0.15881781E-09_JPRB, 0.15875239E-09_JPRB, 0.15865395E-09_JPRB, 0.15850241E-09_JPRB, 0.15827181E-09_JPRB, &
  & 0.15795552E-09_JPRB, 0.15754666E-09_JPRB, 0.15705100E-09_JPRB, 0.15648782E-09_JPRB, 0.15587522E-09_JPRB, 0.15523205E-09_JPRB, &
  & 0.15456675E-09_JPRB, 0.15388579E-09_JPRB, 0.15318977E-09_JPRB, 0.15248428E-09_JPRB, 0.15177291E-09_JPRB, 0.15105631E-09_JPRB, &
  & 0.15033128E-09_JPRB, 0.14959348E-09_JPRB, 0.14884233E-09_JPRB, 0.14807930E-09_JPRB, 0.14731322E-09_JPRB, 0.14655534E-09_JPRB, &
  & 0.14581344E-09_JPRB, 0.14507438E-09_JPRB, 0.14425237E-09_JPRB, 0.14278732E-09_JPRB /)

RGHG8(:,26,11) = (/ &
  & 0.12552082E-09_JPRB, 0.12720025E-09_JPRB, 0.12832732E-09_JPRB, 0.12940800E-09_JPRB, 0.13053897E-09_JPRB, 0.13175556E-09_JPRB, &
  & 0.13305734E-09_JPRB, 0.13443703E-09_JPRB, 0.13588489E-09_JPRB, 0.13739235E-09_JPRB, 0.13894720E-09_JPRB, 0.14053764E-09_JPRB, &
  & 0.14215136E-09_JPRB, 0.14377752E-09_JPRB, 0.14540955E-09_JPRB, 0.14703422E-09_JPRB, 0.14863839E-09_JPRB, 0.15020979E-09_JPRB, &
  & 0.15173510E-09_JPRB, 0.15319666E-09_JPRB, 0.15457578E-09_JPRB, 0.15584335E-09_JPRB, 0.15696604E-09_JPRB, 0.15792244E-09_JPRB, &
  & 0.15870845E-09_JPRB, 0.15933872E-09_JPRB, 0.15983551E-09_JPRB, 0.16021760E-09_JPRB, 0.16049936E-09_JPRB, 0.16069177E-09_JPRB, &
  & 0.16080220E-09_JPRB, 0.16084196E-09_JPRB, 0.16082477E-09_JPRB, 0.16076541E-09_JPRB, 0.16067715E-09_JPRB, 0.16058209E-09_JPRB, &
  & 0.16049309E-09_JPRB, 0.16040817E-09_JPRB, 0.16031555E-09_JPRB, 0.16019602E-09_JPRB, 0.16002845E-09_JPRB, 0.15979271E-09_JPRB, &
  & 0.15947953E-09_JPRB, 0.15908229E-09_JPRB, 0.15860338E-09_JPRB, 0.15805710E-09_JPRB, 0.15746264E-09_JPRB, 0.15683875E-09_JPRB, &
  & 0.15619799E-09_JPRB, 0.15554881E-09_JPRB, 0.15489771E-09_JPRB, 0.15425132E-09_JPRB, 0.15361110E-09_JPRB, 0.15297612E-09_JPRB, &
  & 0.15234081E-09_JPRB, 0.15169993E-09_JPRB, 0.15104959E-09_JPRB, 0.15038883E-09_JPRB, 0.14972308E-09_JPRB, 0.14905800E-09_JPRB, &
  & 0.14839903E-09_JPRB, 0.14773831E-09_JPRB, 0.14695527E-09_JPRB, 0.14562962E-09_JPRB /)

RGHG8(:,27,11) = (/ &
  & 0.12854043E-09_JPRB, 0.13020554E-09_JPRB, 0.13128451E-09_JPRB, 0.13229889E-09_JPRB, 0.13335601E-09_JPRB, 0.13448141E-09_JPRB, &
  & 0.13568029E-09_JPRB, 0.13694691E-09_JPRB, 0.13827682E-09_JPRB, 0.13966231E-09_JPRB, 0.14110024E-09_JPRB, 0.14257877E-09_JPRB, &
  & 0.14408558E-09_JPRB, 0.14561764E-09_JPRB, 0.14715885E-09_JPRB, 0.14870202E-09_JPRB, 0.15022335E-09_JPRB, 0.15171464E-09_JPRB, &
  & 0.15316243E-09_JPRB, 0.15455136E-09_JPRB, 0.15586595E-09_JPRB, 0.15708523E-09_JPRB, 0.15817690E-09_JPRB, 0.15912317E-09_JPRB, &
  & 0.15991496E-09_JPRB, 0.16055945E-09_JPRB, 0.16107449E-09_JPRB, 0.16147272E-09_JPRB, 0.16176624E-09_JPRB, 0.16196572E-09_JPRB, &
  & 0.16208208E-09_JPRB, 0.16213078E-09_JPRB, 0.16212665E-09_JPRB, 0.16208433E-09_JPRB, 0.16201437E-09_JPRB, 0.16192779E-09_JPRB, &
  & 0.16183734E-09_JPRB, 0.16174159E-09_JPRB, 0.16162981E-09_JPRB, 0.16149142E-09_JPRB, 0.16130892E-09_JPRB, 0.16106702E-09_JPRB, &
  & 0.16075531E-09_JPRB, 0.16036628E-09_JPRB, 0.15990052E-09_JPRB, 0.15936949E-09_JPRB, 0.15879209E-09_JPRB, 0.15818848E-09_JPRB, &
  & 0.15756975E-09_JPRB, 0.15694630E-09_JPRB, 0.15632765E-09_JPRB, 0.15572243E-09_JPRB, 0.15513418E-09_JPRB, 0.15455995E-09_JPRB, &
  & 0.15399385E-09_JPRB, 0.15342980E-09_JPRB, 0.15286258E-09_JPRB, 0.15229093E-09_JPRB, 0.15171732E-09_JPRB, 0.15114852E-09_JPRB, &
  & 0.15058688E-09_JPRB, 0.15000580E-09_JPRB, 0.14936510E-09_JPRB, 0.14814747E-09_JPRB /)

RGHG8(:,28,11) = (/ &
  & 0.13141610E-09_JPRB, 0.13306531E-09_JPRB, 0.13409776E-09_JPRB, 0.13506096E-09_JPRB, 0.13604315E-09_JPRB, 0.13708529E-09_JPRB, &
  & 0.13818949E-09_JPRB, 0.13935339E-09_JPRB, 0.14057171E-09_JPRB, 0.14184565E-09_JPRB, 0.14316848E-09_JPRB, 0.14453506E-09_JPRB, &
  & 0.14593565E-09_JPRB, 0.14736767E-09_JPRB, 0.14881033E-09_JPRB, 0.15026311E-09_JPRB, 0.15169786E-09_JPRB, 0.15310708E-09_JPRB, &
  & 0.15447318E-09_JPRB, 0.15578247E-09_JPRB, 0.15702341E-09_JPRB, 0.15817961E-09_JPRB, 0.15922530E-09_JPRB, 0.16014334E-09_JPRB, &
  & 0.16092268E-09_JPRB, 0.16156602E-09_JPRB, 0.16208750E-09_JPRB, 0.16249484E-09_JPRB, 0.16279803E-09_JPRB, 0.16300555E-09_JPRB, &
  & 0.16313080E-09_JPRB, 0.16319116E-09_JPRB, 0.16320217E-09_JPRB, 0.16317790E-09_JPRB, 0.16312651E-09_JPRB, 0.16305310E-09_JPRB, &
  & 0.16296550E-09_JPRB, 0.16286414E-09_JPRB, 0.16274017E-09_JPRB, 0.16258682E-09_JPRB, 0.16239177E-09_JPRB, 0.16214313E-09_JPRB, &
  & 0.16183155E-09_JPRB, 0.16144937E-09_JPRB, 0.16099409E-09_JPRB, 0.16047524E-09_JPRB, 0.15990956E-09_JPRB, 0.15931313E-09_JPRB, &
  & 0.15870640E-09_JPRB, 0.15810622E-09_JPRB, 0.15752404E-09_JPRB, 0.15696192E-09_JPRB, 0.15641950E-09_JPRB, 0.15589602E-09_JPRB, &
  & 0.15538595E-09_JPRB, 0.15488305E-09_JPRB, 0.15438338E-09_JPRB, 0.15388534E-09_JPRB, 0.15339219E-09_JPRB, 0.15290634E-09_JPRB, &
  & 0.15242983E-09_JPRB, 0.15195376E-09_JPRB, 0.15138590E-09_JPRB, 0.15040709E-09_JPRB /)

RGHG8(:,29,11) = (/ &
  & 0.13420189E-09_JPRB, 0.13582035E-09_JPRB, 0.13682476E-09_JPRB, 0.13772403E-09_JPRB, 0.13864319E-09_JPRB, 0.13960386E-09_JPRB, &
  & 0.14061996E-09_JPRB, 0.14168622E-09_JPRB, 0.14280296E-09_JPRB, 0.14396638E-09_JPRB, 0.14518059E-09_JPRB, 0.14643564E-09_JPRB, &
  & 0.14773369E-09_JPRB, 0.14905792E-09_JPRB, 0.15040481E-09_JPRB, 0.15176407E-09_JPRB, 0.15311083E-09_JPRB, 0.15443094E-09_JPRB, &
  & 0.15570978E-09_JPRB, 0.15693456E-09_JPRB, 0.15809574E-09_JPRB, 0.15918060E-09_JPRB, 0.16016904E-09_JPRB, 0.16104501E-09_JPRB, &
  & 0.16179839E-09_JPRB, 0.16242653E-09_JPRB, 0.16294180E-09_JPRB, 0.16335004E-09_JPRB, 0.16365799E-09_JPRB, 0.16387236E-09_JPRB, &
  & 0.16400639E-09_JPRB, 0.16407799E-09_JPRB, 0.16410298E-09_JPRB, 0.16409460E-09_JPRB, 0.16405875E-09_JPRB, 0.16399804E-09_JPRB, &
  & 0.16391546E-09_JPRB, 0.16381196E-09_JPRB, 0.16368074E-09_JPRB, 0.16351730E-09_JPRB, 0.16331268E-09_JPRB, 0.16305877E-09_JPRB, &
  & 0.16274701E-09_JPRB, 0.16237053E-09_JPRB, 0.16192615E-09_JPRB, 0.16142014E-09_JPRB, 0.16086603E-09_JPRB, 0.16028633E-09_JPRB, &
  & 0.15970411E-09_JPRB, 0.15913135E-09_JPRB, 0.15857256E-09_JPRB, 0.15803601E-09_JPRB, 0.15752874E-09_JPRB, 0.15704553E-09_JPRB, &
  & 0.15657961E-09_JPRB, 0.15612497E-09_JPRB, 0.15567736E-09_JPRB, 0.15523638E-09_JPRB, 0.15480391E-09_JPRB, 0.15438532E-09_JPRB, &
  & 0.15397926E-09_JPRB, 0.15357024E-09_JPRB, 0.15311660E-09_JPRB, 0.15229189E-09_JPRB /)

RGHG8(:,30,11) = (/ &
  & 0.13689702E-09_JPRB, 0.13850615E-09_JPRB, 0.13945486E-09_JPRB, 0.14031284E-09_JPRB, 0.14116011E-09_JPRB, 0.14204755E-09_JPRB, &
  & 0.14297823E-09_JPRB, 0.14395392E-09_JPRB, 0.14497005E-09_JPRB, 0.14603209E-09_JPRB, 0.14713844E-09_JPRB, 0.14828751E-09_JPRB, &
  & 0.14948186E-09_JPRB, 0.15070215E-09_JPRB, 0.15195310E-09_JPRB, 0.15322162E-09_JPRB, 0.15448104E-09_JPRB, 0.15571361E-09_JPRB, &
  & 0.15690380E-09_JPRB, 0.15804105E-09_JPRB, 0.15911689E-09_JPRB, 0.16012286E-09_JPRB, 0.16104608E-09_JPRB, 0.16187139E-09_JPRB, &
  & 0.16258447E-09_JPRB, 0.16318606E-09_JPRB, 0.16368347E-09_JPRB, 0.16408423E-09_JPRB, 0.16439097E-09_JPRB, 0.16460881E-09_JPRB, &
  & 0.16474944E-09_JPRB, 0.16483002E-09_JPRB, 0.16486616E-09_JPRB, 0.16487008E-09_JPRB, 0.16484586E-09_JPRB, 0.16479509E-09_JPRB, &
  & 0.16471778E-09_JPRB, 0.16461443E-09_JPRB, 0.16447951E-09_JPRB, 0.16431026E-09_JPRB, 0.16409980E-09_JPRB, 0.16384273E-09_JPRB, &
  & 0.16353144E-09_JPRB, 0.16316072E-09_JPRB, 0.16272605E-09_JPRB, 0.16223156E-09_JPRB, 0.16169141E-09_JPRB, 0.16112731E-09_JPRB, &
  & 0.16056166E-09_JPRB, 0.16000501E-09_JPRB, 0.15947298E-09_JPRB, 0.15897407E-09_JPRB, 0.15850352E-09_JPRB, 0.15805560E-09_JPRB, &
  & 0.15762418E-09_JPRB, 0.15720451E-09_JPRB, 0.15679412E-09_JPRB, 0.15639262E-09_JPRB, 0.15600427E-09_JPRB, 0.15563195E-09_JPRB, &
  & 0.15527882E-09_JPRB, 0.15493057E-09_JPRB, 0.15453544E-09_JPRB, 0.15385214E-09_JPRB /)

RGHG8(:,31,11) = (/ &
  & 0.13952949E-09_JPRB, 0.14108091E-09_JPRB, 0.14200675E-09_JPRB, 0.14280054E-09_JPRB, 0.14359114E-09_JPRB, 0.14440470E-09_JPRB, &
  & 0.14525733E-09_JPRB, 0.14614493E-09_JPRB, 0.14706915E-09_JPRB, 0.14803031E-09_JPRB, 0.14903451E-09_JPRB, 0.15008098E-09_JPRB, &
  & 0.15117142E-09_JPRB, 0.15229233E-09_JPRB, 0.15344941E-09_JPRB, 0.15462680E-09_JPRB, 0.15580107E-09_JPRB, 0.15695013E-09_JPRB, &
  & 0.15805636E-09_JPRB, 0.15910619E-09_JPRB, 0.16009670E-09_JPRB, 0.16102385E-09_JPRB, 0.16187762E-09_JPRB, 0.16264368E-09_JPRB, &
  & 0.16330942E-09_JPRB, 0.16387283E-09_JPRB, 0.16434461E-09_JPRB, 0.16472833E-09_JPRB, 0.16502723E-09_JPRB, 0.16524390E-09_JPRB, &
  & 0.16538795E-09_JPRB, 0.16547463E-09_JPRB, 0.16551871E-09_JPRB, 0.16553096E-09_JPRB, 0.16551464E-09_JPRB, 0.16547044E-09_JPRB, &
  & 0.16539788E-09_JPRB, 0.16529551E-09_JPRB, 0.16515990E-09_JPRB, 0.16498816E-09_JPRB, 0.16477535E-09_JPRB, 0.16451732E-09_JPRB, &
  & 0.16420759E-09_JPRB, 0.16384237E-09_JPRB, 0.16341685E-09_JPRB, 0.16293503E-09_JPRB, 0.16241057E-09_JPRB, 0.16186825E-09_JPRB, &
  & 0.16132348E-09_JPRB, 0.16079521E-09_JPRB, 0.16029381E-09_JPRB, 0.15982138E-09_JPRB, 0.15937701E-09_JPRB, 0.15895513E-09_JPRB, &
  & 0.15855033E-09_JPRB, 0.15815733E-09_JPRB, 0.15777268E-09_JPRB, 0.15739852E-09_JPRB, 0.15703944E-09_JPRB, 0.15670200E-09_JPRB, &
  & 0.15638267E-09_JPRB, 0.15607242E-09_JPRB, 0.15572874E-09_JPRB, 0.15513914E-09_JPRB /)

RGHG8(:,32,11) = (/ &
  & 0.14205595E-09_JPRB, 0.14357188E-09_JPRB, 0.14443312E-09_JPRB, 0.14518566E-09_JPRB, 0.14591321E-09_JPRB, 0.14666190E-09_JPRB, &
  & 0.14743931E-09_JPRB, 0.14824660E-09_JPRB, 0.14908093E-09_JPRB, 0.14994828E-09_JPRB, 0.15085191E-09_JPRB, 0.15179814E-09_JPRB, &
  & 0.15278576E-09_JPRB, 0.15381273E-09_JPRB, 0.15487778E-09_JPRB, 0.15596723E-09_JPRB, 0.15705820E-09_JPRB, 0.15812655E-09_JPRB, &
  & 0.15915230E-09_JPRB, 0.16012329E-09_JPRB, 0.16103530E-09_JPRB, 0.16188612E-09_JPRB, 0.16266968E-09_JPRB, 0.16337293E-09_JPRB, &
  & 0.16398506E-09_JPRB, 0.16450628E-09_JPRB, 0.16494328E-09_JPRB, 0.16530338E-09_JPRB, 0.16558768E-09_JPRB, 0.16579836E-09_JPRB, &
  & 0.16594237E-09_JPRB, 0.16603199E-09_JPRB, 0.16608084E-09_JPRB, 0.16609793E-09_JPRB, 0.16608612E-09_JPRB, 0.16604630E-09_JPRB, &
  & 0.16597733E-09_JPRB, 0.16587666E-09_JPRB, 0.16574245E-09_JPRB, 0.16557065E-09_JPRB, 0.16535825E-09_JPRB, 0.16510088E-09_JPRB, &
  & 0.16479394E-09_JPRB, 0.16443415E-09_JPRB, 0.16401781E-09_JPRB, 0.16355037E-09_JPRB, 0.16304817E-09_JPRB, 0.16252730E-09_JPRB, &
  & 0.16200724E-09_JPRB, 0.16150394E-09_JPRB, 0.16102797E-09_JPRB, 0.16058255E-09_JPRB, 0.16016408E-09_JPRB, 0.15976789E-09_JPRB, &
  & 0.15938595E-09_JPRB, 0.15901237E-09_JPRB, 0.15864682E-09_JPRB, 0.15829121E-09_JPRB, 0.15795359E-09_JPRB, 0.15763714E-09_JPRB, &
  & 0.15734525E-09_JPRB, 0.15706213E-09_JPRB, 0.15675436E-09_JPRB, 0.15622860E-09_JPRB /)

RGHG8(:,33,11) = (/ &
  & 0.14448975E-09_JPRB, 0.14592014E-09_JPRB, 0.14674041E-09_JPRB, 0.14743456E-09_JPRB, 0.14810790E-09_JPRB, 0.14879518E-09_JPRB, &
  & 0.14950534E-09_JPRB, 0.15023653E-09_JPRB, 0.15098901E-09_JPRB, 0.15176492E-09_JPRB, 0.15257232E-09_JPRB, 0.15341892E-09_JPRB, &
  & 0.15430730E-09_JPRB, 0.15524160E-09_JPRB, 0.15621932E-09_JPRB, 0.15722502E-09_JPRB, 0.15823950E-09_JPRB, 0.15923571E-09_JPRB, &
  & 0.16018899E-09_JPRB, 0.16108734E-09_JPRB, 0.16192671E-09_JPRB, 0.16270719E-09_JPRB, 0.16342153E-09_JPRB, 0.16406140E-09_JPRB, &
  & 0.16461746E-09_JPRB, 0.16509052E-09_JPRB, 0.16548971E-09_JPRB, 0.16582055E-09_JPRB, 0.16608581E-09_JPRB, 0.16628639E-09_JPRB, &
  & 0.16642671E-09_JPRB, 0.16651655E-09_JPRB, 0.16656723E-09_JPRB, 0.16658630E-09_JPRB, 0.16657693E-09_JPRB, 0.16654043E-09_JPRB, &
  & 0.16647415E-09_JPRB, 0.16637645E-09_JPRB, 0.16624484E-09_JPRB, 0.16607521E-09_JPRB, 0.16586518E-09_JPRB, 0.16560986E-09_JPRB, &
  & 0.16530650E-09_JPRB, 0.16495212E-09_JPRB, 0.16454629E-09_JPRB, 0.16409647E-09_JPRB, 0.16361369E-09_JPRB, 0.16311619E-09_JPRB, &
  & 0.16262128E-09_JPRB, 0.16214656E-09_JPRB, 0.16169863E-09_JPRB, 0.16127949E-09_JPRB, 0.16088714E-09_JPRB, 0.16051258E-09_JPRB, &
  & 0.16014885E-09_JPRB, 0.15979187E-09_JPRB, 0.15944061E-09_JPRB, 0.15909998E-09_JPRB, 0.15877627E-09_JPRB, 0.15847822E-09_JPRB, &
  & 0.15820290E-09_JPRB, 0.15794327E-09_JPRB, 0.15765737E-09_JPRB, 0.15718311E-09_JPRB /)

RGHG8(:,34,11) = (/ &
  & 0.14679813E-09_JPRB, 0.14813294E-09_JPRB, 0.14888829E-09_JPRB, 0.14952965E-09_JPRB, 0.15015188E-09_JPRB, 0.15078175E-09_JPRB, &
  & 0.15143045E-09_JPRB, 0.15209398E-09_JPRB, 0.15276928E-09_JPRB, 0.15346083E-09_JPRB, 0.15417535E-09_JPRB, 0.15492449E-09_JPRB, &
  & 0.15571708E-09_JPRB, 0.15656047E-09_JPRB, 0.15745368E-09_JPRB, 0.15838167E-09_JPRB, 0.15932444E-09_JPRB, 0.16025410E-09_JPRB, &
  & 0.16114551E-09_JPRB, 0.16198375E-09_JPRB, 0.16276315E-09_JPRB, 0.16348128E-09_JPRB, 0.16413315E-09_JPRB, 0.16471174E-09_JPRB, &
  & 0.16521201E-09_JPRB, 0.16563591E-09_JPRB, 0.16599308E-09_JPRB, 0.16629098E-09_JPRB, 0.16653254E-09_JPRB, 0.16671836E-09_JPRB, &
  & 0.16685160E-09_JPRB, 0.16693891E-09_JPRB, 0.16698887E-09_JPRB, 0.16700812E-09_JPRB, 0.16700072E-09_JPRB, 0.16696662E-09_JPRB, &
  & 0.16690352E-09_JPRB, 0.16681048E-09_JPRB, 0.16668272E-09_JPRB, 0.16651751E-09_JPRB, 0.16631110E-09_JPRB, 0.16605918E-09_JPRB, &
  & 0.16575960E-09_JPRB, 0.16541110E-09_JPRB, 0.16501606E-09_JPRB, 0.16458152E-09_JPRB, 0.16412084E-09_JPRB, 0.16364893E-09_JPRB, &
  & 0.16318533E-09_JPRB, 0.16273929E-09_JPRB, 0.16231894E-09_JPRB, 0.16192528E-09_JPRB, 0.16155298E-09_JPRB, 0.16119654E-09_JPRB, &
  & 0.16084906E-09_JPRB, 0.16050643E-09_JPRB, 0.16016917E-09_JPRB, 0.15984031E-09_JPRB, 0.15953019E-09_JPRB, 0.15924492E-09_JPRB, &
  & 0.15898750E-09_JPRB, 0.15874109E-09_JPRB, 0.15847988E-09_JPRB, 0.15803972E-09_JPRB /)

RGHG8(:,35,11) = (/ &
  & 0.14897709E-09_JPRB, 0.15019203E-09_JPRB, 0.15087304E-09_JPRB, 0.15145932E-09_JPRB, 0.15202446E-09_JPRB, 0.15260429E-09_JPRB, &
  & 0.15319666E-09_JPRB, 0.15379817E-09_JPRB, 0.15440489E-09_JPRB, 0.15501722E-09_JPRB, 0.15564511E-09_JPRB, 0.15630111E-09_JPRB, &
  & 0.15700154E-09_JPRB, 0.15775674E-09_JPRB, 0.15856941E-09_JPRB, 0.15942550E-09_JPRB, 0.16030507E-09_JPRB, 0.16117759E-09_JPRB, &
  & 0.16201837E-09_JPRB, 0.16280781E-09_JPRB, 0.16353841E-09_JPRB, 0.16420415E-09_JPRB, 0.16480063E-09_JPRB, 0.16532292E-09_JPRB, &
  & 0.16576865E-09_JPRB, 0.16614296E-09_JPRB, 0.16645627E-09_JPRB, 0.16671758E-09_JPRB, 0.16693118E-09_JPRB, 0.16709857E-09_JPRB, &
  & 0.16722110E-09_JPRB, 0.16730331E-09_JPRB, 0.16735092E-09_JPRB, 0.16737017E-09_JPRB, 0.16736483E-09_JPRB, 0.16733331E-09_JPRB, &
  & 0.16727579E-09_JPRB, 0.16718910E-09_JPRB, 0.16706808E-09_JPRB, 0.16690985E-09_JPRB, 0.16670905E-09_JPRB, 0.16646161E-09_JPRB, &
  & 0.16616651E-09_JPRB, 0.16582367E-09_JPRB, 0.16543870E-09_JPRB, 0.16502059E-09_JPRB, 0.16458088E-09_JPRB, 0.16413669E-09_JPRB, &
  & 0.16369880E-09_JPRB, 0.16328006E-09_JPRB, 0.16288539E-09_JPRB, 0.16251384E-09_JPRB, 0.16216242E-09_JPRB, 0.16182412E-09_JPRB, &
  & 0.16149283E-09_JPRB, 0.16116468E-09_JPRB, 0.16083944E-09_JPRB, 0.16052315E-09_JPRB, 0.16022435E-09_JPRB, 0.15995247E-09_JPRB, &
  & 0.15970518E-09_JPRB, 0.15947640E-09_JPRB, 0.15922785E-09_JPRB, 0.15882257E-09_JPRB /)

RGHG8(:,36,11) = (/ &
  & 0.15103542E-09_JPRB, 0.15209163E-09_JPRB, 0.15269701E-09_JPRB, 0.15321536E-09_JPRB, 0.15373025E-09_JPRB, 0.15425640E-09_JPRB, &
  & 0.15479772E-09_JPRB, 0.15534371E-09_JPRB, 0.15588696E-09_JPRB, 0.15642812E-09_JPRB, 0.15697503E-09_JPRB, 0.15754442E-09_JPRB, &
  & 0.15815689E-09_JPRB, 0.15882871E-09_JPRB, 0.15956500E-09_JPRB, 0.16035662E-09_JPRB, 0.16118046E-09_JPRB, 0.16200796E-09_JPRB, &
  & 0.16280734E-09_JPRB, 0.16355886E-09_JPRB, 0.16424907E-09_JPRB, 0.16487128E-09_JPRB, 0.16541833E-09_JPRB, 0.16588826E-09_JPRB, &
  & 0.16628131E-09_JPRB, 0.16660540E-09_JPRB, 0.16687308E-09_JPRB, 0.16709467E-09_JPRB, 0.16727669E-09_JPRB, 0.16742102E-09_JPRB, &
  & 0.16752971E-09_JPRB, 0.16760460E-09_JPRB, 0.16764920E-09_JPRB, 0.16766934E-09_JPRB, 0.16766616E-09_JPRB, 0.16763942E-09_JPRB, &
  & 0.16759005E-09_JPRB, 0.16751234E-09_JPRB, 0.16740295E-09_JPRB, 0.16725617E-09_JPRB, 0.16706524E-09_JPRB, 0.16682619E-09_JPRB, &
  & 0.16653655E-09_JPRB, 0.16620073E-09_JPRB, 0.16582544E-09_JPRB, 0.16542212E-09_JPRB, 0.16500422E-09_JPRB, 0.16458311E-09_JPRB, &
  & 0.16417168E-09_JPRB, 0.16377759E-09_JPRB, 0.16340540E-09_JPRB, 0.16305467E-09_JPRB, 0.16272007E-09_JPRB, 0.16239871E-09_JPRB, &
  & 0.16208228E-09_JPRB, 0.16176871E-09_JPRB, 0.16145736E-09_JPRB, 0.16115413E-09_JPRB, 0.16086699E-09_JPRB, 0.16060504E-09_JPRB, &
  & 0.16037126E-09_JPRB, 0.16015146E-09_JPRB, 0.15992142E-09_JPRB, 0.15953903E-09_JPRB /)

RGHG8(:,37,11) = (/ &
  & 0.15296708E-09_JPRB, 0.15386002E-09_JPRB, 0.15436850E-09_JPRB, 0.15482166E-09_JPRB, 0.15527638E-09_JPRB, 0.15575347E-09_JPRB, &
  & 0.15624485E-09_JPRB, 0.15673826E-09_JPRB, 0.15722398E-09_JPRB, 0.15769892E-09_JPRB, 0.15817220E-09_JPRB, 0.15866189E-09_JPRB, &
  & 0.15919199E-09_JPRB, 0.15978524E-09_JPRB, 0.16044989E-09_JPRB, 0.16118301E-09_JPRB, 0.16195768E-09_JPRB, 0.16274634E-09_JPRB, &
  & 0.16351566E-09_JPRB, 0.16423884E-09_JPRB, 0.16489728E-09_JPRB, 0.16547999E-09_JPRB, 0.16598001E-09_JPRB, 0.16639531E-09_JPRB, &
  & 0.16673178E-09_JPRB, 0.16700144E-09_JPRB, 0.16721968E-09_JPRB, 0.16739890E-09_JPRB, 0.16754646E-09_JPRB, 0.16766626E-09_JPRB, &
  & 0.16775915E-09_JPRB, 0.16782579E-09_JPRB, 0.16786780E-09_JPRB, 0.16788933E-09_JPRB, 0.16788899E-09_JPRB, 0.16786954E-09_JPRB, &
  & 0.16782936E-09_JPRB, 0.16776511E-09_JPRB, 0.16767243E-09_JPRB, 0.16754392E-09_JPRB, 0.16737234E-09_JPRB, 0.16714896E-09_JPRB, &
  & 0.16687296E-09_JPRB, 0.16654697E-09_JPRB, 0.16618280E-09_JPRB, 0.16579367E-09_JPRB, 0.16539355E-09_JPRB, 0.16499413E-09_JPRB, &
  & 0.16460405E-09_JPRB, 0.16423105E-09_JPRB, 0.16387830E-09_JPRB, 0.16354514E-09_JPRB, 0.16322746E-09_JPRB, 0.16292170E-09_JPRB, &
  & 0.16262221E-09_JPRB, 0.16232576E-09_JPRB, 0.16203067E-09_JPRB, 0.16174161E-09_JPRB, 0.16146662E-09_JPRB, 0.16121551E-09_JPRB, &
  & 0.16098960E-09_JPRB, 0.16078154E-09_JPRB, 0.16055915E-09_JPRB, 0.16019940E-09_JPRB /)

RGHG8(:,38,11) = (/ &
  & 0.15477093E-09_JPRB, 0.15548386E-09_JPRB, 0.15590561E-09_JPRB, 0.15628784E-09_JPRB, 0.15668575E-09_JPRB, 0.15711149E-09_JPRB, &
  & 0.15755397E-09_JPRB, 0.15799705E-09_JPRB, 0.15842753E-09_JPRB, 0.15884172E-09_JPRB, 0.15924814E-09_JPRB, 0.15966603E-09_JPRB, &
  & 0.16012101E-09_JPRB, 0.16064043E-09_JPRB, 0.16123980E-09_JPRB, 0.16191636E-09_JPRB, 0.16265186E-09_JPRB, 0.16340629E-09_JPRB, &
  & 0.16414722E-09_JPRB, 0.16484382E-09_JPRB, 0.16546982E-09_JPRB, 0.16600742E-09_JPRB, 0.16644967E-09_JPRB, 0.16680209E-09_JPRB, &
  & 0.16707688E-09_JPRB, 0.16729190E-09_JPRB, 0.16746393E-09_JPRB, 0.16760547E-09_JPRB, 0.16772428E-09_JPRB, 0.16782327E-09_JPRB, &
  & 0.16790351E-09_JPRB, 0.16796324E-09_JPRB, 0.16800382E-09_JPRB, 0.16802607E-09_JPRB, 0.16802901E-09_JPRB, 0.16801605E-09_JPRB, &
  & 0.16798474E-09_JPRB, 0.16793408E-09_JPRB, 0.16785946E-09_JPRB, 0.16775410E-09_JPRB, 0.16760857E-09_JPRB, 0.16741350E-09_JPRB, &
  & 0.16716219E-09_JPRB, 0.16685749E-09_JPRB, 0.16650870E-09_JPRB, 0.16613513E-09_JPRB, 0.16575227E-09_JPRB, 0.16537101E-09_JPRB, &
  & 0.16499958E-09_JPRB, 0.16464381E-09_JPRB, 0.16430636E-09_JPRB, 0.16398831E-09_JPRB, 0.16368612E-09_JPRB, 0.16339741E-09_JPRB, &
  & 0.16311742E-09_JPRB, 0.16284103E-09_JPRB, 0.16256561E-09_JPRB, 0.16229375E-09_JPRB, 0.16203246E-09_JPRB, 0.16179028E-09_JPRB, &
  & 0.16157241E-09_JPRB, 0.16136921E-09_JPRB, 0.16115731E-09_JPRB, 0.16080938E-09_JPRB /)

RGHG8(:,39,11) = (/ &
  & 0.15641186E-09_JPRB, 0.15697260E-09_JPRB, 0.15730886E-09_JPRB, 0.15762687E-09_JPRB, 0.15797114E-09_JPRB, 0.15834668E-09_JPRB, &
  & 0.15874155E-09_JPRB, 0.15913436E-09_JPRB, 0.15951182E-09_JPRB, 0.15986987E-09_JPRB, 0.16021717E-09_JPRB, 0.16057124E-09_JPRB, &
  & 0.16096102E-09_JPRB, 0.16141145E-09_JPRB, 0.16195008E-09_JPRB, 0.16257477E-09_JPRB, 0.16326716E-09_JPRB, 0.16399096E-09_JPRB, &
  & 0.16470206E-09_JPRB, 0.16536236E-09_JPRB, 0.16594123E-09_JPRB, 0.16641868E-09_JPRB, 0.16679469E-09_JPRB, 0.16708333E-09_JPRB, &
  & 0.16730414E-09_JPRB, 0.16747537E-09_JPRB, 0.16761349E-09_JPRB, 0.16772907E-09_JPRB, 0.16782851E-09_JPRB, 0.16791450E-09_JPRB, &
  & 0.16798650E-09_JPRB, 0.16804211E-09_JPRB, 0.16808219E-09_JPRB, 0.16810442E-09_JPRB, 0.16811023E-09_JPRB, 0.16810117E-09_JPRB, &
  & 0.16807655E-09_JPRB, 0.16803638E-09_JPRB, 0.16797631E-09_JPRB, 0.16789121E-09_JPRB, 0.16777213E-09_JPRB, 0.16760876E-09_JPRB, &
  & 0.16739293E-09_JPRB, 0.16711865E-09_JPRB, 0.16679622E-09_JPRB, 0.16644371E-09_JPRB, 0.16607855E-09_JPRB, 0.16571440E-09_JPRB, &
  & 0.16535881E-09_JPRB, 0.16501694E-09_JPRB, 0.16469259E-09_JPRB, 0.16438792E-09_JPRB, 0.16410114E-09_JPRB, 0.16383087E-09_JPRB, &
  & 0.16357148E-09_JPRB, 0.16331871E-09_JPRB, 0.16306614E-09_JPRB, 0.16281430E-09_JPRB, 0.16256793E-09_JPRB, 0.16233588E-09_JPRB, &
  & 0.16212366E-09_JPRB, 0.16192676E-09_JPRB, 0.16171688E-09_JPRB, 0.16137901E-09_JPRB /)

RGHG8(:,40,11) = (/ &
  & 0.15787138E-09_JPRB, 0.15830511E-09_JPRB, 0.15857614E-09_JPRB, 0.15884211E-09_JPRB, 0.15913768E-09_JPRB, 0.15947076E-09_JPRB, &
  & 0.15981891E-09_JPRB, 0.16016326E-09_JPRB, 0.16049080E-09_JPRB, 0.16079804E-09_JPRB, 0.16109268E-09_JPRB, 0.16139454E-09_JPRB, &
  & 0.16172473E-09_JPRB, 0.16211800E-09_JPRB, 0.16259541E-09_JPRB, 0.16317250E-09_JPRB, 0.16382451E-09_JPRB, 0.16451143E-09_JPRB, &
  & 0.16518335E-09_JPRB, 0.16579578E-09_JPRB, 0.16631198E-09_JPRB, 0.16672116E-09_JPRB, 0.16703219E-09_JPRB, 0.16726717E-09_JPRB, &
  & 0.16744625E-09_JPRB, 0.16758731E-09_JPRB, 0.16770309E-09_JPRB, 0.16780248E-09_JPRB, 0.16789067E-09_JPRB, 0.16796882E-09_JPRB, &
  & 0.16803617E-09_JPRB, 0.16808958E-09_JPRB, 0.16812952E-09_JPRB, 0.16815162E-09_JPRB, 0.16815935E-09_JPRB, 0.16815238E-09_JPRB, &
  & 0.16813248E-09_JPRB, 0.16809898E-09_JPRB, 0.16804949E-09_JPRB, 0.16797955E-09_JPRB, 0.16788183E-09_JPRB, 0.16774743E-09_JPRB, &
  & 0.16756516E-09_JPRB, 0.16732787E-09_JPRB, 0.16703974E-09_JPRB, 0.16671382E-09_JPRB, 0.16637121E-09_JPRB, 0.16602481E-09_JPRB, &
  & 0.16568415E-09_JPRB, 0.16535520E-09_JPRB, 0.16504212E-09_JPRB, 0.16474895E-09_JPRB, 0.16447807E-09_JPRB, 0.16422562E-09_JPRB, &
  & 0.16398990E-09_JPRB, 0.16376080E-09_JPRB, 0.16353355E-09_JPRB, 0.16330302E-09_JPRB, 0.16307426E-09_JPRB, 0.16285358E-09_JPRB, &
  & 0.16264906E-09_JPRB, 0.16245484E-09_JPRB, 0.16225067E-09_JPRB, 0.16191615E-09_JPRB /)

RGHG8(:,41,11) = (/ &
  & 0.15914299E-09_JPRB, 0.15948884E-09_JPRB, 0.15971013E-09_JPRB, 0.15993437E-09_JPRB, 0.16019600E-09_JPRB, 0.16049045E-09_JPRB, &
  & 0.16079930E-09_JPRB, 0.16109908E-09_JPRB, 0.16138071E-09_JPRB, 0.16164250E-09_JPRB, 0.16189364E-09_JPRB, 0.16214745E-09_JPRB, &
  & 0.16243173E-09_JPRB, 0.16276888E-09_JPRB, 0.16319518E-09_JPRB, 0.16371907E-09_JPRB, 0.16432852E-09_JPRB, 0.16497417E-09_JPRB, &
  & 0.16560117E-09_JPRB, 0.16615295E-09_JPRB, 0.16660184E-09_JPRB, 0.16694335E-09_JPRB, 0.16719841E-09_JPRB, 0.16739049E-09_JPRB, &
  & 0.16753957E-09_JPRB, 0.16765948E-09_JPRB, 0.16776075E-09_JPRB, 0.16785019E-09_JPRB, 0.16793114E-09_JPRB, 0.16800498E-09_JPRB, &
  & 0.16806934E-09_JPRB, 0.16812202E-09_JPRB, 0.16816151E-09_JPRB, 0.16818388E-09_JPRB, 0.16819238E-09_JPRB, 0.16818680E-09_JPRB, &
  & 0.16816984E-09_JPRB, 0.16814090E-09_JPRB, 0.16809880E-09_JPRB, 0.16804007E-09_JPRB, 0.16795888E-09_JPRB, 0.16784731E-09_JPRB, &
  & 0.16769487E-09_JPRB, 0.16749375E-09_JPRB, 0.16724144E-09_JPRB, 0.16694880E-09_JPRB, 0.16662999E-09_JPRB, 0.16630415E-09_JPRB, &
  & 0.16597981E-09_JPRB, 0.16566321E-09_JPRB, 0.16536084E-09_JPRB, 0.16508038E-09_JPRB, 0.16482260E-09_JPRB, 0.16459109E-09_JPRB, &
  & 0.16437592E-09_JPRB, 0.16417231E-09_JPRB, 0.16396866E-09_JPRB, 0.16376125E-09_JPRB, 0.16355121E-09_JPRB, 0.16334556E-09_JPRB, &
  & 0.16315017E-09_JPRB, 0.16296417E-09_JPRB, 0.16276268E-09_JPRB, 0.16243469E-09_JPRB /)

RGHG8(:,42,11) = (/ &
  & 0.16025009E-09_JPRB, 0.16053479E-09_JPRB, 0.16072173E-09_JPRB, 0.16091961E-09_JPRB, 0.16115316E-09_JPRB, 0.16142281E-09_JPRB, &
  & 0.16169706E-09_JPRB, 0.16195867E-09_JPRB, 0.16220027E-09_JPRB, 0.16242338E-09_JPRB, 0.16263499E-09_JPRB, 0.16285151E-09_JPRB, &
  & 0.16309018E-09_JPRB, 0.16338331E-09_JPRB, 0.16375597E-09_JPRB, 0.16423245E-09_JPRB, 0.16479407E-09_JPRB, 0.16539323E-09_JPRB, &
  & 0.16596252E-09_JPRB, 0.16645096E-09_JPRB, 0.16682969E-09_JPRB, 0.16711114E-09_JPRB, 0.16731939E-09_JPRB, 0.16747871E-09_JPRB, &
  & 0.16760500E-09_JPRB, 0.16771014E-09_JPRB, 0.16780143E-09_JPRB, 0.16788407E-09_JPRB, 0.16796099E-09_JPRB, 0.16803196E-09_JPRB, &
  & 0.16809451E-09_JPRB, 0.16814723E-09_JPRB, 0.16818601E-09_JPRB, 0.16820884E-09_JPRB, 0.16821737E-09_JPRB, 0.16821275E-09_JPRB, &
  & 0.16819757E-09_JPRB, 0.16817191E-09_JPRB, 0.16813530E-09_JPRB, 0.16808502E-09_JPRB, 0.16801678E-09_JPRB, 0.16792347E-09_JPRB, &
  & 0.16779685E-09_JPRB, 0.16762779E-09_JPRB, 0.16741164E-09_JPRB, 0.16715013E-09_JPRB, 0.16686094E-09_JPRB, 0.16655669E-09_JPRB, &
  & 0.16625012E-09_JPRB, 0.16594821E-09_JPRB, 0.16565833E-09_JPRB, 0.16538816E-09_JPRB, 0.16514731E-09_JPRB, 0.16493264E-09_JPRB, &
  & 0.16474046E-09_JPRB, 0.16455851E-09_JPRB, 0.16437855E-09_JPRB, 0.16419324E-09_JPRB, 0.16400351E-09_JPRB, 0.16381529E-09_JPRB, &
  & 0.16363494E-09_JPRB, 0.16345872E-09_JPRB, 0.16326780E-09_JPRB, 0.16294986E-09_JPRB /)

RGHG8(:,43,11) = (/ &
  & 0.16122381E-09_JPRB, 0.16146834E-09_JPRB, 0.16163304E-09_JPRB, 0.16181043E-09_JPRB, 0.16202990E-09_JPRB, 0.16227839E-09_JPRB, &
  & 0.16252813E-09_JPRB, 0.16275788E-09_JPRB, 0.16296661E-09_JPRB, 0.16315624E-09_JPRB, 0.16333565E-09_JPRB, 0.16351645E-09_JPRB, &
  & 0.16371937E-09_JPRB, 0.16396651E-09_JPRB, 0.16429269E-09_JPRB, 0.16471687E-09_JPRB, 0.16523030E-09_JPRB, 0.16577580E-09_JPRB, &
  & 0.16628501E-09_JPRB, 0.16670103E-09_JPRB, 0.16701440E-09_JPRB, 0.16724257E-09_JPRB, 0.16741238E-09_JPRB, 0.16754527E-09_JPRB, &
  & 0.16765422E-09_JPRB, 0.16774802E-09_JPRB, 0.16783216E-09_JPRB, 0.16791063E-09_JPRB, 0.16798470E-09_JPRB, 0.16805443E-09_JPRB, &
  & 0.16811572E-09_JPRB, 0.16816874E-09_JPRB, 0.16820681E-09_JPRB, 0.16823000E-09_JPRB, 0.16823823E-09_JPRB, 0.16823413E-09_JPRB, &
  & 0.16822004E-09_JPRB, 0.16819676E-09_JPRB, 0.16816429E-09_JPRB, 0.16812081E-09_JPRB, 0.16806287E-09_JPRB, 0.16798501E-09_JPRB, &
  & 0.16788020E-09_JPRB, 0.16773995E-09_JPRB, 0.16755593E-09_JPRB, 0.16732943E-09_JPRB, 0.16706678E-09_JPRB, 0.16678713E-09_JPRB, &
  & 0.16650123E-09_JPRB, 0.16621632E-09_JPRB, 0.16594026E-09_JPRB, 0.16568541E-09_JPRB, 0.16545905E-09_JPRB, 0.16526373E-09_JPRB, &
  & 0.16509097E-09_JPRB, 0.16493001E-09_JPRB, 0.16477075E-09_JPRB, 0.16460663E-09_JPRB, 0.16443792E-09_JPRB, 0.16427035E-09_JPRB, &
  & 0.16410846E-09_JPRB, 0.16394956E-09_JPRB, 0.16377349E-09_JPRB, 0.16347701E-09_JPRB /)

RGHG8(:,44,11) = (/ &
  & 0.16209711E-09_JPRB, 0.16231549E-09_JPRB, 0.16246345E-09_JPRB, 0.16263003E-09_JPRB, 0.16283670E-09_JPRB, 0.16307501E-09_JPRB, &
  & 0.16330418E-09_JPRB, 0.16351040E-09_JPRB, 0.16369191E-09_JPRB, 0.16385411E-09_JPRB, 0.16400475E-09_JPRB, 0.16415617E-09_JPRB, &
  & 0.16432355E-09_JPRB, 0.16453235E-09_JPRB, 0.16481060E-09_JPRB, 0.16518588E-09_JPRB, 0.16564694E-09_JPRB, 0.16613430E-09_JPRB, &
  & 0.16657171E-09_JPRB, 0.16691612E-09_JPRB, 0.16716668E-09_JPRB, 0.16734844E-09_JPRB, 0.16748648E-09_JPRB, 0.16759787E-09_JPRB, &
  & 0.16769280E-09_JPRB, 0.16777774E-09_JPRB, 0.16785673E-09_JPRB, 0.16793227E-09_JPRB, 0.16800515E-09_JPRB, 0.16807425E-09_JPRB, &
  & 0.16813505E-09_JPRB, 0.16818828E-09_JPRB, 0.16822595E-09_JPRB, 0.16824910E-09_JPRB, 0.16825696E-09_JPRB, 0.16825297E-09_JPRB, &
  & 0.16823945E-09_JPRB, 0.16821791E-09_JPRB, 0.16818869E-09_JPRB, 0.16815066E-09_JPRB, 0.16810128E-09_JPRB, 0.16803646E-09_JPRB, &
  & 0.16795050E-09_JPRB, 0.16783558E-09_JPRB, 0.16768392E-09_JPRB, 0.16748845E-09_JPRB, 0.16725710E-09_JPRB, 0.16700163E-09_JPRB, &
  & 0.16673776E-09_JPRB, 0.16647317E-09_JPRB, 0.16621539E-09_JPRB, 0.16597672E-09_JPRB, 0.16576795E-09_JPRB, 0.16559144E-09_JPRB, &
  & 0.16543661E-09_JPRB, 0.16529458E-09_JPRB, 0.16515403E-09_JPRB, 0.16500969E-09_JPRB, 0.16486207E-09_JPRB, 0.16471656E-09_JPRB, &
  & 0.16457691E-09_JPRB, 0.16443913E-09_JPRB, 0.16428500E-09_JPRB, 0.16402182E-09_JPRB /)

RGHG8(:,45,11) = (/ &
  & 0.16289721E-09_JPRB, 0.16309608E-09_JPRB, 0.16323429E-09_JPRB, 0.16338944E-09_JPRB, 0.16359193E-09_JPRB, 0.16381940E-09_JPRB, &
  & 0.16403627E-09_JPRB, 0.16422280E-09_JPRB, 0.16438284E-09_JPRB, 0.16452203E-09_JPRB, 0.16464820E-09_JPRB, 0.16477253E-09_JPRB, &
  & 0.16491056E-09_JPRB, 0.16508177E-09_JPRB, 0.16531619E-09_JPRB, 0.16564267E-09_JPRB, 0.16604773E-09_JPRB, 0.16646909E-09_JPRB, &
  & 0.16682894E-09_JPRB, 0.16709978E-09_JPRB, 0.16729310E-09_JPRB, 0.16743559E-09_JPRB, 0.16754670E-09_JPRB, 0.16764061E-09_JPRB, &
  & 0.16772392E-09_JPRB, 0.16780183E-09_JPRB, 0.16787689E-09_JPRB, 0.16795099E-09_JPRB, 0.16802344E-09_JPRB, 0.16809262E-09_JPRB, &
  & 0.16815352E-09_JPRB, 0.16820682E-09_JPRB, 0.16824422E-09_JPRB, 0.16826711E-09_JPRB, 0.16827449E-09_JPRB, 0.16827024E-09_JPRB, &
  & 0.16825698E-09_JPRB, 0.16823666E-09_JPRB, 0.16820990E-09_JPRB, 0.16817631E-09_JPRB, 0.16813415E-09_JPRB, 0.16808036E-09_JPRB, &
  & 0.16801074E-09_JPRB, 0.16791915E-09_JPRB, 0.16779667E-09_JPRB, 0.16763627E-09_JPRB, 0.16743491E-09_JPRB, 0.16720703E-09_JPRB, &
  & 0.16696670E-09_JPRB, 0.16672325E-09_JPRB, 0.16648580E-09_JPRB, 0.16626768E-09_JPRB, 0.16607887E-09_JPRB, 0.16592018E-09_JPRB, &
  & 0.16578398E-09_JPRB, 0.16565829E-09_JPRB, 0.16553531E-09_JPRB, 0.16540949E-09_JPRB, 0.16528240E-09_JPRB, 0.16515930E-09_JPRB, &
  & 0.16504284E-09_JPRB, 0.16492800E-09_JPRB, 0.16479923E-09_JPRB, 0.16457628E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART21',1,ZHOOK_HANDLE)
END SUBROUTINE PART21




SUBROUTINE PART22
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART22',0,ZHOOK_HANDLE)



RGHG8(:,46,11) = (/ &
  & 0.16364310E-09_JPRB, 0.16382999E-09_JPRB, 0.16395708E-09_JPRB, 0.16410777E-09_JPRB, 0.16429938E-09_JPRB, 0.16452424E-09_JPRB, &
  & 0.16472781E-09_JPRB, 0.16489934E-09_JPRB, 0.16504137E-09_JPRB, 0.16515962E-09_JPRB, 0.16526480E-09_JPRB, 0.16536644E-09_JPRB, &
  & 0.16547749E-09_JPRB, 0.16561684E-09_JPRB, 0.16581297E-09_JPRB, 0.16608724E-09_JPRB, 0.16643566E-09_JPRB, 0.16677729E-09_JPRB, &
  & 0.16705574E-09_JPRB, 0.16725556E-09_JPRB, 0.16739890E-09_JPRB, 0.16750733E-09_JPRB, 0.16759671E-09_JPRB, 0.16767573E-09_JPRB, &
  & 0.16774970E-09_JPRB, 0.16782185E-09_JPRB, 0.16789417E-09_JPRB, 0.16796753E-09_JPRB, 0.16804054E-09_JPRB, 0.16811029E-09_JPRB, &
  & 0.16817170E-09_JPRB, 0.16822495E-09_JPRB, 0.16826225E-09_JPRB, 0.16828453E-09_JPRB, 0.16829130E-09_JPRB, 0.16828651E-09_JPRB, &
  & 0.16827319E-09_JPRB, 0.16825359E-09_JPRB, 0.16822885E-09_JPRB, 0.16819887E-09_JPRB, 0.16816266E-09_JPRB, 0.16811835E-09_JPRB, &
  & 0.16806295E-09_JPRB, 0.16799204E-09_JPRB, 0.16789845E-09_JPRB, 0.16777164E-09_JPRB, 0.16760671E-09_JPRB, 0.16740886E-09_JPRB, &
  & 0.16719261E-09_JPRB, 0.16697195E-09_JPRB, 0.16675752E-09_JPRB, 0.16656031E-09_JPRB, 0.16639387E-09_JPRB, 0.16625416E-09_JPRB, &
  & 0.16613484E-09_JPRB, 0.16602532E-09_JPRB, 0.16591820E-09_JPRB, 0.16580974E-09_JPRB, 0.16570202E-09_JPRB, 0.16560002E-09_JPRB, &
  & 0.16550473E-09_JPRB, 0.16541200E-09_JPRB, 0.16530692E-09_JPRB, 0.16512536E-09_JPRB /)

RGHG8(:,47,11) = (/ &
  & 0.16435092E-09_JPRB, 0.16452503E-09_JPRB, 0.16464773E-09_JPRB, 0.16478621E-09_JPRB, 0.16497720E-09_JPRB, 0.16518928E-09_JPRB, &
  & 0.16538540E-09_JPRB, 0.16554265E-09_JPRB, 0.16566674E-09_JPRB, 0.16576801E-09_JPRB, 0.16585389E-09_JPRB, 0.16593578E-09_JPRB, &
  & 0.16602474E-09_JPRB, 0.16613728E-09_JPRB, 0.16629462E-09_JPRB, 0.16652391E-09_JPRB, 0.16679787E-09_JPRB, 0.16705695E-09_JPRB, &
  & 0.16725031E-09_JPRB, 0.16738738E-09_JPRB, 0.16748693E-09_JPRB, 0.16756761E-09_JPRB, 0.16763832E-09_JPRB, 0.16770535E-09_JPRB, &
  & 0.16777146E-09_JPRB, 0.16783902E-09_JPRB, 0.16790949E-09_JPRB, 0.16798292E-09_JPRB, 0.16805700E-09_JPRB, 0.16812762E-09_JPRB, &
  & 0.16818975E-09_JPRB, 0.16824296E-09_JPRB, 0.16828010E-09_JPRB, 0.16830166E-09_JPRB, 0.16830765E-09_JPRB, 0.16830207E-09_JPRB, &
  & 0.16828842E-09_JPRB, 0.16826927E-09_JPRB, 0.16824599E-09_JPRB, 0.16821898E-09_JPRB, 0.16818791E-09_JPRB, 0.16815159E-09_JPRB, &
  & 0.16810861E-09_JPRB, 0.16805618E-09_JPRB, 0.16798871E-09_JPRB, 0.16789699E-09_JPRB, 0.16777131E-09_JPRB, 0.16760922E-09_JPRB, &
  & 0.16742316E-09_JPRB, 0.16722639E-09_JPRB, 0.16703328E-09_JPRB, 0.16686155E-09_JPRB, 0.16671384E-09_JPRB, 0.16659449E-09_JPRB, &
  & 0.16649040E-09_JPRB, 0.16639583E-09_JPRB, 0.16630317E-09_JPRB, 0.16621013E-09_JPRB, 0.16611965E-09_JPRB, 0.16603541E-09_JPRB, &
  & 0.16595868E-09_JPRB, 0.16588371E-09_JPRB, 0.16579974E-09_JPRB, 0.16565244E-09_JPRB /)

RGHG8(:,48,11) = (/ &
  & 0.16502588E-09_JPRB, 0.16519305E-09_JPRB, 0.16530600E-09_JPRB, 0.16544149E-09_JPRB, 0.16561738E-09_JPRB, 0.16582793E-09_JPRB, &
  & 0.16601123E-09_JPRB, 0.16615487E-09_JPRB, 0.16626435E-09_JPRB, 0.16634771E-09_JPRB, 0.16641762E-09_JPRB, 0.16648216E-09_JPRB, &
  & 0.16655191E-09_JPRB, 0.16663959E-09_JPRB, 0.16676281E-09_JPRB, 0.16693417E-09_JPRB, 0.16713023E-09_JPRB, 0.16729709E-09_JPRB, &
  & 0.16741510E-09_JPRB, 0.16749697E-09_JPRB, 0.16756099E-09_JPRB, 0.16761798E-09_JPRB, 0.16767357E-09_JPRB, 0.16773041E-09_JPRB, &
  & 0.16779027E-09_JPRB, 0.16785440E-09_JPRB, 0.16792381E-09_JPRB, 0.16799773E-09_JPRB, 0.16807332E-09_JPRB, 0.16814500E-09_JPRB, &
  & 0.16820792E-09_JPRB, 0.16826106E-09_JPRB, 0.16829801E-09_JPRB, 0.16831865E-09_JPRB, 0.16832370E-09_JPRB, 0.16831719E-09_JPRB, &
  & 0.16830300E-09_JPRB, 0.16828394E-09_JPRB, 0.16826182E-09_JPRB, 0.16823729E-09_JPRB, 0.16821047E-09_JPRB, 0.16818116E-09_JPRB, &
  & 0.16814891E-09_JPRB, 0.16811266E-09_JPRB, 0.16806885E-09_JPRB, 0.16801030E-09_JPRB, 0.16792580E-09_JPRB, 0.16780843E-09_JPRB, &
  & 0.16765900E-09_JPRB, 0.16749173E-09_JPRB, 0.16732525E-09_JPRB, 0.16717275E-09_JPRB, 0.16704831E-09_JPRB, 0.16694335E-09_JPRB, &
  & 0.16685464E-09_JPRB, 0.16677201E-09_JPRB, 0.16669160E-09_JPRB, 0.16661153E-09_JPRB, 0.16653459E-09_JPRB, 0.16646494E-09_JPRB, &
  & 0.16640175E-09_JPRB, 0.16634114E-09_JPRB, 0.16627216E-09_JPRB, 0.16615204E-09_JPRB /)

RGHG8(:,49,11) = (/ &
  & 0.16567284E-09_JPRB, 0.16583078E-09_JPRB, 0.16593929E-09_JPRB, 0.16606429E-09_JPRB, 0.16623647E-09_JPRB, 0.16643401E-09_JPRB, &
  & 0.16661045E-09_JPRB, 0.16674070E-09_JPRB, 0.16683352E-09_JPRB, 0.16690187E-09_JPRB, 0.16695542E-09_JPRB, 0.16700381E-09_JPRB, &
  & 0.16705477E-09_JPRB, 0.16711556E-09_JPRB, 0.16720000E-09_JPRB, 0.16730377E-09_JPRB, 0.16741532E-09_JPRB, 0.16749757E-09_JPRB, &
  & 0.16755081E-09_JPRB, 0.16758891E-09_JPRB, 0.16762354E-09_JPRB, 0.16766109E-09_JPRB, 0.16770363E-09_JPRB, 0.16775202E-09_JPRB, &
  & 0.16780698E-09_JPRB, 0.16786871E-09_JPRB, 0.16793789E-09_JPRB, 0.16801280E-09_JPRB, 0.16808969E-09_JPRB, 0.16816259E-09_JPRB, &
  & 0.16822622E-09_JPRB, 0.16827938E-09_JPRB, 0.16831606E-09_JPRB, 0.16833571E-09_JPRB, 0.16833968E-09_JPRB, 0.16833204E-09_JPRB, &
  & 0.16831712E-09_JPRB, 0.16829800E-09_JPRB, 0.16827667E-09_JPRB, 0.16825419E-09_JPRB, 0.16823110E-09_JPRB, 0.16820781E-09_JPRB, &
  & 0.16818497E-09_JPRB, 0.16816279E-09_JPRB, 0.16813984E-09_JPRB, 0.16811087E-09_JPRB, 0.16806678E-09_JPRB, 0.16799634E-09_JPRB, &
  & 0.16789516E-09_JPRB, 0.16776884E-09_JPRB, 0.16763245E-09_JPRB, 0.16750756E-09_JPRB, 0.16739944E-09_JPRB, 0.16731114E-09_JPRB, &
  & 0.16723328E-09_JPRB, 0.16716083E-09_JPRB, 0.16708963E-09_JPRB, 0.16701893E-09_JPRB, 0.16695233E-09_JPRB, 0.16689265E-09_JPRB, &
  & 0.16683965E-09_JPRB, 0.16678857E-09_JPRB, 0.16673041E-09_JPRB, 0.16662802E-09_JPRB /)

RGHG8(:,50,11) = (/ &
  & 0.16628475E-09_JPRB, 0.16643487E-09_JPRB, 0.16653626E-09_JPRB, 0.16665486E-09_JPRB, 0.16681675E-09_JPRB, 0.16700810E-09_JPRB, &
  & 0.16716875E-09_JPRB, 0.16728224E-09_JPRB, 0.16735693E-09_JPRB, 0.16740660E-09_JPRB, 0.16744311E-09_JPRB, 0.16747340E-09_JPRB, &
  & 0.16750198E-09_JPRB, 0.16753506E-09_JPRB, 0.16757018E-09_JPRB, 0.16761338E-09_JPRB, 0.16764426E-09_JPRB, 0.16765961E-09_JPRB, &
  & 0.16766255E-09_JPRB, 0.16766628E-09_JPRB, 0.16767744E-09_JPRB, 0.16769848E-09_JPRB, 0.16772982E-09_JPRB, 0.16777109E-09_JPRB, &
  & 0.16782221E-09_JPRB, 0.16788274E-09_JPRB, 0.16795218E-09_JPRB, 0.16802833E-09_JPRB, 0.16810657E-09_JPRB, 0.16818034E-09_JPRB, &
  & 0.16824486E-09_JPRB, 0.16829796E-09_JPRB, 0.16833433E-09_JPRB, 0.16835289E-09_JPRB, 0.16835565E-09_JPRB, 0.16834674E-09_JPRB, &
  & 0.16833097E-09_JPRB, 0.16831160E-09_JPRB, 0.16829088E-09_JPRB, 0.16827008E-09_JPRB, 0.16825014E-09_JPRB, 0.16823218E-09_JPRB, &
  & 0.16821766E-09_JPRB, 0.16820803E-09_JPRB, 0.16820323E-09_JPRB, 0.16819994E-09_JPRB, 0.16819035E-09_JPRB, 0.16816444E-09_JPRB, &
  & 0.16811418E-09_JPRB, 0.16803847E-09_JPRB, 0.16794767E-09_JPRB, 0.16785447E-09_JPRB, 0.16777221E-09_JPRB, 0.16769913E-09_JPRB, &
  & 0.16763305E-09_JPRB, 0.16756996E-09_JPRB, 0.16750626E-09_JPRB, 0.16744285E-09_JPRB, 0.16738347E-09_JPRB, 0.16733093E-09_JPRB, &
  & 0.16728458E-09_JPRB, 0.16723942E-09_JPRB, 0.16718782E-09_JPRB, 0.16709428E-09_JPRB /)

RGHG8(:,51,11) = (/ &
  & 0.16684945E-09_JPRB, 0.16698737E-09_JPRB, 0.16708204E-09_JPRB, 0.16719240E-09_JPRB, 0.16734149E-09_JPRB, 0.16751130E-09_JPRB, &
  & 0.16764816E-09_JPRB, 0.16773159E-09_JPRB, 0.16778051E-09_JPRB, 0.16780941E-09_JPRB, 0.16782728E-09_JPRB, 0.16783930E-09_JPRB, &
  & 0.16784800E-09_JPRB, 0.16785298E-09_JPRB, 0.16785433E-09_JPRB, 0.16784590E-09_JPRB, 0.16782348E-09_JPRB, 0.16778941E-09_JPRB, &
  & 0.16775599E-09_JPRB, 0.16773309E-09_JPRB, 0.16772488E-09_JPRB, 0.16773172E-09_JPRB, 0.16775326E-09_JPRB, 0.16778824E-09_JPRB, &
  & 0.16783665E-09_JPRB, 0.16789663E-09_JPRB, 0.16796717E-09_JPRB, 0.16804441E-09_JPRB, 0.16812371E-09_JPRB, 0.16819848E-09_JPRB, &
  & 0.16826376E-09_JPRB, 0.16831697E-09_JPRB, 0.16835294E-09_JPRB, 0.16837037E-09_JPRB, 0.16837180E-09_JPRB, 0.16836164E-09_JPRB, &
  & 0.16834478E-09_JPRB, 0.16832503E-09_JPRB, 0.16830466E-09_JPRB, 0.16828523E-09_JPRB, 0.16826801E-09_JPRB, 0.16825473E-09_JPRB, &
  & 0.16824782E-09_JPRB, 0.16824971E-09_JPRB, 0.16826111E-09_JPRB, 0.16827940E-09_JPRB, 0.16829763E-09_JPRB, 0.16830694E-09_JPRB, &
  & 0.16829968E-09_JPRB, 0.16827334E-09_JPRB, 0.16823144E-09_JPRB, 0.16818272E-09_JPRB, 0.16813211E-09_JPRB, 0.16808384E-09_JPRB, &
  & 0.16803606E-09_JPRB, 0.16798592E-09_JPRB, 0.16793363E-09_JPRB, 0.16787960E-09_JPRB, 0.16782795E-09_JPRB, 0.16778234E-09_JPRB, &
  & 0.16774127E-09_JPRB, 0.16770108E-09_JPRB, 0.16765214E-09_JPRB, 0.16756388E-09_JPRB /)

RGHG8(:,52,11) = (/ &
  & 0.16734045E-09_JPRB, 0.16746664E-09_JPRB, 0.16754892E-09_JPRB, 0.16764448E-09_JPRB, 0.16777066E-09_JPRB, 0.16790491E-09_JPRB, &
  & 0.16799488E-09_JPRB, 0.16804377E-09_JPRB, 0.16806782E-09_JPRB, 0.16807900E-09_JPRB, 0.16808346E-09_JPRB, 0.16808349E-09_JPRB, &
  & 0.16807961E-09_JPRB, 0.16806971E-09_JPRB, 0.16805195E-09_JPRB, 0.16801532E-09_JPRB, 0.16796210E-09_JPRB, 0.16789589E-09_JPRB, &
  & 0.16783576E-09_JPRB, 0.16779224E-09_JPRB, 0.16776765E-09_JPRB, 0.16776205E-09_JPRB, 0.16777461E-09_JPRB, 0.16780458E-09_JPRB, &
  & 0.16785057E-09_JPRB, 0.16791113E-09_JPRB, 0.16798232E-09_JPRB, 0.16806125E-09_JPRB, 0.16814118E-09_JPRB, 0.16821694E-09_JPRB, &
  & 0.16828315E-09_JPRB, 0.16833647E-09_JPRB, 0.16837204E-09_JPRB, 0.16838833E-09_JPRB, 0.16838828E-09_JPRB, 0.16837680E-09_JPRB, &
  & 0.16835883E-09_JPRB, 0.16833852E-09_JPRB, 0.16831828E-09_JPRB, 0.16829985E-09_JPRB, 0.16828491E-09_JPRB, 0.16827595E-09_JPRB, &
  & 0.16827623E-09_JPRB, 0.16828888E-09_JPRB, 0.16831514E-09_JPRB, 0.16835121E-09_JPRB, 0.16839068E-09_JPRB, 0.16842465E-09_JPRB, &
  & 0.16844698E-09_JPRB, 0.16845508E-09_JPRB, 0.16845074E-09_JPRB, 0.16843749E-09_JPRB, 0.16841939E-09_JPRB, 0.16839741E-09_JPRB, &
  & 0.16837179E-09_JPRB, 0.16834237E-09_JPRB, 0.16830730E-09_JPRB, 0.16826887E-09_JPRB, 0.16823098E-09_JPRB, 0.16819640E-09_JPRB, &
  & 0.16816487E-09_JPRB, 0.16813195E-09_JPRB, 0.16809139E-09_JPRB, 0.16800893E-09_JPRB /)

RGHG8(:,53,11) = (/ &
  & 0.16774207E-09_JPRB, 0.16784395E-09_JPRB, 0.16791384E-09_JPRB, 0.16798812E-09_JPRB, 0.16807991E-09_JPRB, 0.16816423E-09_JPRB, &
  & 0.16821450E-09_JPRB, 0.16823562E-09_JPRB, 0.16824388E-09_JPRB, 0.16824545E-09_JPRB, 0.16824328E-09_JPRB, 0.16823816E-09_JPRB, &
  & 0.16822908E-09_JPRB, 0.16821490E-09_JPRB, 0.16818691E-09_JPRB, 0.16814423E-09_JPRB, 0.16807072E-09_JPRB, 0.16798558E-09_JPRB, &
  & 0.16790609E-09_JPRB, 0.16784514E-09_JPRB, 0.16780680E-09_JPRB, 0.16779025E-09_JPRB, 0.16779517E-09_JPRB, 0.16782034E-09_JPRB, &
  & 0.16786528E-09_JPRB, 0.16792567E-09_JPRB, 0.16799867E-09_JPRB, 0.16807798E-09_JPRB, 0.16815936E-09_JPRB, 0.16823590E-09_JPRB, &
  & 0.16830315E-09_JPRB, 0.16835661E-09_JPRB, 0.16839161E-09_JPRB, 0.16840689E-09_JPRB, 0.16840533E-09_JPRB, 0.16839247E-09_JPRB, &
  & 0.16837332E-09_JPRB, 0.16835236E-09_JPRB, 0.16833201E-09_JPRB, 0.16831433E-09_JPRB, 0.16830135E-09_JPRB, 0.16829622E-09_JPRB, &
  & 0.16830325E-09_JPRB, 0.16832657E-09_JPRB, 0.16836564E-09_JPRB, 0.16841728E-09_JPRB, 0.16847154E-09_JPRB, 0.16852167E-09_JPRB, &
  & 0.16856105E-09_JPRB, 0.16858814E-09_JPRB, 0.16860346E-09_JPRB, 0.16860964E-09_JPRB, 0.16860939E-09_JPRB, 0.16860444E-09_JPRB, &
  & 0.16859546E-09_JPRB, 0.16858173E-09_JPRB, 0.16856375E-09_JPRB, 0.16854192E-09_JPRB, 0.16851937E-09_JPRB, 0.16849853E-09_JPRB, &
  & 0.16847920E-09_JPRB, 0.16845908E-09_JPRB, 0.16843238E-09_JPRB, 0.16837472E-09_JPRB /)

RGHG8(:,54,11) = (/ &
  & 0.16803940E-09_JPRB, 0.16812414E-09_JPRB, 0.16817341E-09_JPRB, 0.16822563E-09_JPRB, 0.16828264E-09_JPRB, 0.16832866E-09_JPRB, &
  & 0.16834897E-09_JPRB, 0.16835527E-09_JPRB, 0.16835563E-09_JPRB, 0.16835294E-09_JPRB, 0.16834827E-09_JPRB, 0.16834152E-09_JPRB, &
  & 0.16833188E-09_JPRB, 0.16831553E-09_JPRB, 0.16829055E-09_JPRB, 0.16823920E-09_JPRB, 0.16816387E-09_JPRB, 0.16806362E-09_JPRB, &
  & 0.16796824E-09_JPRB, 0.16789369E-09_JPRB, 0.16784300E-09_JPRB, 0.16781707E-09_JPRB, 0.16781540E-09_JPRB, 0.16783729E-09_JPRB, &
  & 0.16788027E-09_JPRB, 0.16794173E-09_JPRB, 0.16801473E-09_JPRB, 0.16809595E-09_JPRB, 0.16817786E-09_JPRB, 0.16825580E-09_JPRB, &
  & 0.16832383E-09_JPRB, 0.16837740E-09_JPRB, 0.16841187E-09_JPRB, 0.16842609E-09_JPRB, 0.16842316E-09_JPRB, 0.16840893E-09_JPRB, &
  & 0.16838865E-09_JPRB, 0.16836688E-09_JPRB, 0.16834632E-09_JPRB, 0.16832913E-09_JPRB, 0.16831775E-09_JPRB, 0.16831625E-09_JPRB, &
  & 0.16832996E-09_JPRB, 0.16836234E-09_JPRB, 0.16841444E-09_JPRB, 0.16847684E-09_JPRB, 0.16854318E-09_JPRB, 0.16860269E-09_JPRB, &
  & 0.16865156E-09_JPRB, 0.16868708E-09_JPRB, 0.16871098E-09_JPRB, 0.16872533E-09_JPRB, 0.16873269E-09_JPRB, 0.16873541E-09_JPRB, &
  & 0.16873447E-09_JPRB, 0.16873017E-09_JPRB, 0.16872212E-09_JPRB, 0.16871129E-09_JPRB, 0.16869953E-09_JPRB, 0.16868888E-09_JPRB, &
  & 0.16867931E-09_JPRB, 0.16867041E-09_JPRB, 0.16866125E-09_JPRB, 0.16864828E-09_JPRB /)

RGHG8(:,55,11) = (/ &
  & 0.16825583E-09_JPRB, 0.16831672E-09_JPRB, 0.16835387E-09_JPRB, 0.16838603E-09_JPRB, 0.16841682E-09_JPRB, 0.16843502E-09_JPRB, &
  & 0.16843935E-09_JPRB, 0.16843768E-09_JPRB, 0.16843441E-09_JPRB, 0.16842998E-09_JPRB, 0.16842461E-09_JPRB, 0.16841784E-09_JPRB, &
  & 0.16840826E-09_JPRB, 0.16839427E-09_JPRB, 0.16836754E-09_JPRB, 0.16832420E-09_JPRB, 0.16824099E-09_JPRB, 0.16813315E-09_JPRB, &
  & 0.16802543E-09_JPRB, 0.16793752E-09_JPRB, 0.16787724E-09_JPRB, 0.16784366E-09_JPRB, 0.16783672E-09_JPRB, 0.16785522E-09_JPRB, &
  & 0.16789740E-09_JPRB, 0.16795801E-09_JPRB, 0.16803267E-09_JPRB, 0.16811424E-09_JPRB, 0.16819784E-09_JPRB, 0.16827661E-09_JPRB, &
  & 0.16834550E-09_JPRB, 0.16839909E-09_JPRB, 0.16843300E-09_JPRB, 0.16844633E-09_JPRB, 0.16844214E-09_JPRB, 0.16842654E-09_JPRB, &
  & 0.16840516E-09_JPRB, 0.16838256E-09_JPRB, 0.16836157E-09_JPRB, 0.16834475E-09_JPRB, 0.16833501E-09_JPRB, 0.16833693E-09_JPRB, &
  & 0.16835616E-09_JPRB, 0.16839820E-09_JPRB, 0.16845875E-09_JPRB, 0.16853292E-09_JPRB, 0.16860624E-09_JPRB, 0.16867294E-09_JPRB, &
  & 0.16872612E-09_JPRB, 0.16876597E-09_JPRB, 0.16879272E-09_JPRB, 0.16880966E-09_JPRB, 0.16881996E-09_JPRB, 0.16882573E-09_JPRB, &
  & 0.16882834E-09_JPRB, 0.16882828E-09_JPRB, 0.16882555E-09_JPRB, 0.16882035E-09_JPRB, 0.16881412E-09_JPRB, 0.16880786E-09_JPRB, &
  & 0.16880214E-09_JPRB, 0.16879612E-09_JPRB, 0.16878857E-09_JPRB, 0.16877354E-09_JPRB /)

RGHG8(:,56,11) = (/ &
  & 0.16841067E-09_JPRB, 0.16845778E-09_JPRB, 0.16848094E-09_JPRB, 0.16849885E-09_JPRB, 0.16851075E-09_JPRB, 0.16851195E-09_JPRB, &
  & 0.16850714E-09_JPRB, 0.16850146E-09_JPRB, 0.16849667E-09_JPRB, 0.16849169E-09_JPRB, 0.16848631E-09_JPRB, 0.16847990E-09_JPRB, &
  & 0.16847140E-09_JPRB, 0.16845789E-09_JPRB, 0.16843629E-09_JPRB, 0.16839058E-09_JPRB, 0.16831353E-09_JPRB, 0.16819672E-09_JPRB, &
  & 0.16807655E-09_JPRB, 0.16797948E-09_JPRB, 0.16791038E-09_JPRB, 0.16787097E-09_JPRB, 0.16785991E-09_JPRB, 0.16787582E-09_JPRB, &
  & 0.16791614E-09_JPRB, 0.16797695E-09_JPRB, 0.16805148E-09_JPRB, 0.16813466E-09_JPRB, 0.16821911E-09_JPRB, 0.16829896E-09_JPRB, &
  & 0.16836829E-09_JPRB, 0.16842204E-09_JPRB, 0.16845546E-09_JPRB, 0.16846796E-09_JPRB, 0.16846263E-09_JPRB, 0.16844585E-09_JPRB, &
  & 0.16842337E-09_JPRB, 0.16839982E-09_JPRB, 0.16837845E-09_JPRB, 0.16836192E-09_JPRB, 0.16835364E-09_JPRB, 0.16835870E-09_JPRB, &
  & 0.16838375E-09_JPRB, 0.16843174E-09_JPRB, 0.16850257E-09_JPRB, 0.16858281E-09_JPRB, 0.16866435E-09_JPRB, 0.16873505E-09_JPRB, &
  & 0.16879204E-09_JPRB, 0.16883256E-09_JPRB, 0.16886031E-09_JPRB, 0.16887777E-09_JPRB, 0.16888843E-09_JPRB, 0.16889504E-09_JPRB, &
  & 0.16889908E-09_JPRB, 0.16890087E-09_JPRB, 0.16890059E-09_JPRB, 0.16889837E-09_JPRB, 0.16889500E-09_JPRB, 0.16889154E-09_JPRB, &
  & 0.16888796E-09_JPRB, 0.16888435E-09_JPRB, 0.16887998E-09_JPRB, 0.16887226E-09_JPRB /)

RGHG8(:,57,11) = (/ &
  & 0.16852347E-09_JPRB, 0.16856079E-09_JPRB, 0.16857611E-09_JPRB, 0.16858386E-09_JPRB, 0.16858298E-09_JPRB, 0.16857378E-09_JPRB, &
  & 0.16856369E-09_JPRB, 0.16855639E-09_JPRB, 0.16855087E-09_JPRB, 0.16854587E-09_JPRB, 0.16854070E-09_JPRB, 0.16853473E-09_JPRB, &
  & 0.16852682E-09_JPRB, 0.16851512E-09_JPRB, 0.16849355E-09_JPRB, 0.16845504E-09_JPRB, 0.16837447E-09_JPRB, 0.16825434E-09_JPRB, &
  & 0.16812571E-09_JPRB, 0.16801907E-09_JPRB, 0.16794439E-09_JPRB, 0.16790035E-09_JPRB, 0.16788604E-09_JPRB, 0.16789947E-09_JPRB, &
  & 0.16793826E-09_JPRB, 0.16799824E-09_JPRB, 0.16807342E-09_JPRB, 0.16815710E-09_JPRB, 0.16824254E-09_JPRB, 0.16832305E-09_JPRB, &
  & 0.16839291E-09_JPRB, 0.16844666E-09_JPRB, 0.16847979E-09_JPRB, 0.16849158E-09_JPRB, 0.16848534E-09_JPRB, 0.16846746E-09_JPRB, &
  & 0.16844387E-09_JPRB, 0.16841942E-09_JPRB, 0.16839746E-09_JPRB, 0.16838109E-09_JPRB, 0.16837430E-09_JPRB, 0.16838252E-09_JPRB, &
  & 0.16841165E-09_JPRB, 0.16846664E-09_JPRB, 0.16854231E-09_JPRB, 0.16863097E-09_JPRB, 0.16871703E-09_JPRB, 0.16879295E-09_JPRB, &
  & 0.16885107E-09_JPRB, 0.16889333E-09_JPRB, 0.16892014E-09_JPRB, 0.16893678E-09_JPRB, 0.16894709E-09_JPRB, 0.16895357E-09_JPRB, &
  & 0.16895768E-09_JPRB, 0.16896018E-09_JPRB, 0.16896093E-09_JPRB, 0.16896001E-09_JPRB, 0.16895804E-09_JPRB, 0.16895557E-09_JPRB, &
  & 0.16895305E-09_JPRB, 0.16895005E-09_JPRB, 0.16894611E-09_JPRB, 0.16893788E-09_JPRB /)

RGHG8(:,58,11) = (/ &
  & 0.16863103E-09_JPRB, 0.16864757E-09_JPRB, 0.16865331E-09_JPRB, 0.16865281E-09_JPRB, 0.16864318E-09_JPRB, 0.16862789E-09_JPRB, &
  & 0.16861557E-09_JPRB, 0.16860707E-09_JPRB, 0.16860165E-09_JPRB, 0.16859668E-09_JPRB, 0.16859179E-09_JPRB, 0.16858623E-09_JPRB, &
  & 0.16857885E-09_JPRB, 0.16856755E-09_JPRB, 0.16854826E-09_JPRB, 0.16850824E-09_JPRB, 0.16843238E-09_JPRB, 0.16830665E-09_JPRB, &
  & 0.16817103E-09_JPRB, 0.16805948E-09_JPRB, 0.16798003E-09_JPRB, 0.16793285E-09_JPRB, 0.16791586E-09_JPRB, 0.16792713E-09_JPRB, &
  & 0.16796435E-09_JPRB, 0.16802360E-09_JPRB, 0.16809856E-09_JPRB, 0.16818268E-09_JPRB, 0.16826859E-09_JPRB, 0.16834961E-09_JPRB, &
  & 0.16841963E-09_JPRB, 0.16847379E-09_JPRB, 0.16850661E-09_JPRB, 0.16851789E-09_JPRB, 0.16851086E-09_JPRB, 0.16849203E-09_JPRB, &
  & 0.16846749E-09_JPRB, 0.16844201E-09_JPRB, 0.16841933E-09_JPRB, 0.16840304E-09_JPRB, 0.16839752E-09_JPRB, 0.16840836E-09_JPRB, &
  & 0.16844194E-09_JPRB, 0.16850084E-09_JPRB, 0.16858276E-09_JPRB, 0.16867516E-09_JPRB, 0.16876729E-09_JPRB, 0.16884621E-09_JPRB, &
  & 0.16890794E-09_JPRB, 0.16894904E-09_JPRB, 0.16897542E-09_JPRB, 0.16899096E-09_JPRB, 0.16900019E-09_JPRB, 0.16900605E-09_JPRB, &
  & 0.16900994E-09_JPRB, 0.16901228E-09_JPRB, 0.16901323E-09_JPRB, 0.16901272E-09_JPRB, 0.16901121E-09_JPRB, 0.16900933E-09_JPRB, &
  & 0.16900711E-09_JPRB, 0.16900469E-09_JPRB, 0.16900130E-09_JPRB, 0.16899453E-09_JPRB /)

RGHG8(:,59,11) = (/ &
  & 0.16870119E-09_JPRB, 0.16871539E-09_JPRB, 0.16871715E-09_JPRB, 0.16871174E-09_JPRB, 0.16869819E-09_JPRB, 0.16867932E-09_JPRB, &
  & 0.16866521E-09_JPRB, 0.16865687E-09_JPRB, 0.16865125E-09_JPRB, 0.16864660E-09_JPRB, 0.16864185E-09_JPRB, 0.16863642E-09_JPRB, &
  & 0.16862932E-09_JPRB, 0.16861822E-09_JPRB, 0.16859866E-09_JPRB, 0.16856015E-09_JPRB, 0.16848074E-09_JPRB, 0.16835427E-09_JPRB, &
  & 0.16821557E-09_JPRB, 0.16810087E-09_JPRB, 0.16801895E-09_JPRB, 0.16796928E-09_JPRB, 0.16795031E-09_JPRB, 0.16795977E-09_JPRB, &
  & 0.16799537E-09_JPRB, 0.16805371E-09_JPRB, 0.16812809E-09_JPRB, 0.16821219E-09_JPRB, 0.16829815E-09_JPRB, 0.16837906E-09_JPRB, &
  & 0.16844973E-09_JPRB, 0.16850391E-09_JPRB, 0.16853675E-09_JPRB, 0.16854755E-09_JPRB, 0.16853982E-09_JPRB, 0.16852027E-09_JPRB, &
  & 0.16849476E-09_JPRB, 0.16846824E-09_JPRB, 0.16844472E-09_JPRB, 0.16842827E-09_JPRB, 0.16842372E-09_JPRB, 0.16843708E-09_JPRB, &
  & 0.16847387E-09_JPRB, 0.16853724E-09_JPRB, 0.16862213E-09_JPRB, 0.16871894E-09_JPRB, 0.16881432E-09_JPRB, 0.16889798E-09_JPRB, &
  & 0.16896044E-09_JPRB, 0.16900312E-09_JPRB, 0.16902796E-09_JPRB, 0.16904206E-09_JPRB, 0.16905037E-09_JPRB, 0.16905542E-09_JPRB, &
  & 0.16905863E-09_JPRB, 0.16906057E-09_JPRB, 0.16906117E-09_JPRB, 0.16906052E-09_JPRB, 0.16905904E-09_JPRB, 0.16905712E-09_JPRB, &
  & 0.16905506E-09_JPRB, 0.16905247E-09_JPRB, 0.16904896E-09_JPRB, 0.16904154E-09_JPRB /)

RGHG8(:,60,11) = (/ &
  & 0.16877083E-09_JPRB, 0.16877696E-09_JPRB, 0.16877498E-09_JPRB, 0.16876719E-09_JPRB, 0.16874978E-09_JPRB, 0.16872988E-09_JPRB, &
  & 0.16871540E-09_JPRB, 0.16870644E-09_JPRB, 0.16870134E-09_JPRB, 0.16869678E-09_JPRB, 0.16869234E-09_JPRB, 0.16868712E-09_JPRB, &
  & 0.16867989E-09_JPRB, 0.16866888E-09_JPRB, 0.16864826E-09_JPRB, 0.16860753E-09_JPRB, 0.16852571E-09_JPRB, 0.16839755E-09_JPRB, &
  & 0.16825995E-09_JPRB, 0.16814500E-09_JPRB, 0.16806162E-09_JPRB, 0.16801059E-09_JPRB, 0.16799025E-09_JPRB, 0.16799821E-09_JPRB, &
  & 0.16803242E-09_JPRB, 0.16808954E-09_JPRB, 0.16816312E-09_JPRB, 0.16824657E-09_JPRB, 0.16833197E-09_JPRB, 0.16841292E-09_JPRB, &
  & 0.16848342E-09_JPRB, 0.16853803E-09_JPRB, 0.16857071E-09_JPRB, 0.16858126E-09_JPRB, 0.16857293E-09_JPRB, 0.16855264E-09_JPRB, &
  & 0.16852626E-09_JPRB, 0.16849865E-09_JPRB, 0.16847412E-09_JPRB, 0.16845729E-09_JPRB, 0.16845350E-09_JPRB, 0.16846878E-09_JPRB, &
  & 0.16850885E-09_JPRB, 0.16857518E-09_JPRB, 0.16866319E-09_JPRB, 0.16876198E-09_JPRB, 0.16886048E-09_JPRB, 0.16894632E-09_JPRB, &
  & 0.16901248E-09_JPRB, 0.16905444E-09_JPRB, 0.16907875E-09_JPRB, 0.16909200E-09_JPRB, 0.16909917E-09_JPRB, 0.16910338E-09_JPRB, &
  & 0.16910588E-09_JPRB, 0.16910708E-09_JPRB, 0.16910706E-09_JPRB, 0.16910590E-09_JPRB, 0.16910395E-09_JPRB, 0.16910182E-09_JPRB, &
  & 0.16909936E-09_JPRB, 0.16909669E-09_JPRB, 0.16909299E-09_JPRB, 0.16908563E-09_JPRB /)

RGHG8(:,61,11) = (/ &
  & 0.16882723E-09_JPRB, 0.16883295E-09_JPRB, 0.16882959E-09_JPRB, 0.16881951E-09_JPRB, 0.16880258E-09_JPRB, 0.16878113E-09_JPRB, &
  & 0.16876586E-09_JPRB, 0.16875713E-09_JPRB, 0.16875211E-09_JPRB, 0.16874806E-09_JPRB, 0.16874385E-09_JPRB, 0.16873876E-09_JPRB, &
  & 0.16873167E-09_JPRB, 0.16871951E-09_JPRB, 0.16869785E-09_JPRB, 0.16865252E-09_JPRB, 0.16856687E-09_JPRB, 0.16844018E-09_JPRB, &
  & 0.16830597E-09_JPRB, 0.16819254E-09_JPRB, 0.16810915E-09_JPRB, 0.16805771E-09_JPRB, 0.16803674E-09_JPRB, 0.16804362E-09_JPRB, &
  & 0.16807650E-09_JPRB, 0.16813236E-09_JPRB, 0.16820463E-09_JPRB, 0.16828698E-09_JPRB, 0.16837154E-09_JPRB, 0.16845174E-09_JPRB, &
  & 0.16852243E-09_JPRB, 0.16857679E-09_JPRB, 0.16860953E-09_JPRB, 0.16861965E-09_JPRB, 0.16861082E-09_JPRB, 0.16858989E-09_JPRB, &
  & 0.16856257E-09_JPRB, 0.16853378E-09_JPRB, 0.16850812E-09_JPRB, 0.16849071E-09_JPRB, 0.16848738E-09_JPRB, 0.16850439E-09_JPRB, &
  & 0.16854686E-09_JPRB, 0.16861609E-09_JPRB, 0.16870605E-09_JPRB, 0.16880632E-09_JPRB, 0.16890578E-09_JPRB, 0.16899426E-09_JPRB, &
  & 0.16906126E-09_JPRB, 0.16910498E-09_JPRB, 0.16912895E-09_JPRB, 0.16914109E-09_JPRB, 0.16914756E-09_JPRB, 0.16915093E-09_JPRB, &
  & 0.16915254E-09_JPRB, 0.16915283E-09_JPRB, 0.16915189E-09_JPRB, 0.16914989E-09_JPRB, 0.16914736E-09_JPRB, 0.16914456E-09_JPRB, &
  & 0.16914181E-09_JPRB, 0.16913852E-09_JPRB, 0.16913429E-09_JPRB, 0.16912576E-09_JPRB /)

RGHG8(:,62,11) = (/ &
  & 0.16888652E-09_JPRB, 0.16888874E-09_JPRB, 0.16888371E-09_JPRB, 0.16887342E-09_JPRB, 0.16885496E-09_JPRB, 0.16883392E-09_JPRB, &
  & 0.16881768E-09_JPRB, 0.16880836E-09_JPRB, 0.16880397E-09_JPRB, 0.16880031E-09_JPRB, 0.16879675E-09_JPRB, 0.16879216E-09_JPRB, &
  & 0.16878493E-09_JPRB, 0.16877247E-09_JPRB, 0.16874735E-09_JPRB, 0.16869774E-09_JPRB, 0.16860839E-09_JPRB, 0.16848443E-09_JPRB, &
  & 0.16835580E-09_JPRB, 0.16824497E-09_JPRB, 0.16816276E-09_JPRB, 0.16811180E-09_JPRB, 0.16809083E-09_JPRB, 0.16809709E-09_JPRB, &
  & 0.16812882E-09_JPRB, 0.16818318E-09_JPRB, 0.16825397E-09_JPRB, 0.16833471E-09_JPRB, 0.16841790E-09_JPRB, 0.16849730E-09_JPRB, &
  & 0.16856729E-09_JPRB, 0.16862151E-09_JPRB, 0.16865394E-09_JPRB, 0.16866364E-09_JPRB, 0.16865430E-09_JPRB, 0.16863268E-09_JPRB, &
  & 0.16860441E-09_JPRB, 0.16857440E-09_JPRB, 0.16854743E-09_JPRB, 0.16852923E-09_JPRB, 0.16852610E-09_JPRB, 0.16854435E-09_JPRB, &
  & 0.16858893E-09_JPRB, 0.16866011E-09_JPRB, 0.16875162E-09_JPRB, 0.16885247E-09_JPRB, 0.16895227E-09_JPRB, 0.16904066E-09_JPRB, &
  & 0.16910999E-09_JPRB, 0.16915450E-09_JPRB, 0.16917859E-09_JPRB, 0.16919066E-09_JPRB, 0.16919616E-09_JPRB, 0.16919861E-09_JPRB, &
  & 0.16919924E-09_JPRB, 0.16919846E-09_JPRB, 0.16919641E-09_JPRB, 0.16919335E-09_JPRB, 0.16918980E-09_JPRB, 0.16918640E-09_JPRB, &
  & 0.16918281E-09_JPRB, 0.16917900E-09_JPRB, 0.16917392E-09_JPRB, 0.16916427E-09_JPRB /)

RGHG8(:,63,11) = (/ &
  & 0.16894236E-09_JPRB, 0.16894433E-09_JPRB, 0.16893884E-09_JPRB, 0.16892765E-09_JPRB, 0.16891014E-09_JPRB, 0.16888775E-09_JPRB, &
  & 0.16887047E-09_JPRB, 0.16886027E-09_JPRB, 0.16885632E-09_JPRB, 0.16885354E-09_JPRB, 0.16885085E-09_JPRB, 0.16884719E-09_JPRB, &
  & 0.16884037E-09_JPRB, 0.16882666E-09_JPRB, 0.16879849E-09_JPRB, 0.16874409E-09_JPRB, 0.16865277E-09_JPRB, 0.16853439E-09_JPRB, &
  & 0.16841091E-09_JPRB, 0.16830372E-09_JPRB, 0.16822371E-09_JPRB, 0.16817413E-09_JPRB, 0.16815380E-09_JPRB, 0.16815990E-09_JPRB, &
  & 0.16819068E-09_JPRB, 0.16824349E-09_JPRB, 0.16831232E-09_JPRB, 0.16839119E-09_JPRB, 0.16847262E-09_JPRB, 0.16855056E-09_JPRB, &
  & 0.16861965E-09_JPRB, 0.16867302E-09_JPRB, 0.16870491E-09_JPRB, 0.16871397E-09_JPRB, 0.16870412E-09_JPRB, 0.16868187E-09_JPRB, &
  & 0.16865268E-09_JPRB, 0.16862137E-09_JPRB, 0.16859297E-09_JPRB, 0.16857384E-09_JPRB, 0.16857059E-09_JPRB, 0.16858967E-09_JPRB, &
  & 0.16863561E-09_JPRB, 0.16870819E-09_JPRB, 0.16880052E-09_JPRB, 0.16890138E-09_JPRB, 0.16900026E-09_JPRB, 0.16908844E-09_JPRB, &
  & 0.16915762E-09_JPRB, 0.16920376E-09_JPRB, 0.16922902E-09_JPRB, 0.16924068E-09_JPRB, 0.16924569E-09_JPRB, 0.16924717E-09_JPRB, &
  & 0.16924663E-09_JPRB, 0.16924448E-09_JPRB, 0.16924100E-09_JPRB, 0.16923660E-09_JPRB, 0.16923203E-09_JPRB, 0.16922748E-09_JPRB, &
  & 0.16922315E-09_JPRB, 0.16921820E-09_JPRB, 0.16921201E-09_JPRB, 0.16920020E-09_JPRB /)

RGHG8(:,64,11) = (/ &
  & 0.16899934E-09_JPRB, 0.16900091E-09_JPRB, 0.16899498E-09_JPRB, 0.16898401E-09_JPRB, 0.16896601E-09_JPRB, 0.16894372E-09_JPRB, &
  & 0.16892401E-09_JPRB, 0.16891258E-09_JPRB, 0.16890912E-09_JPRB, 0.16890726E-09_JPRB, 0.16890600E-09_JPRB, 0.16890367E-09_JPRB, &
  & 0.16889763E-09_JPRB, 0.16888280E-09_JPRB, 0.16885200E-09_JPRB, 0.16879391E-09_JPRB, 0.16870449E-09_JPRB, 0.16859045E-09_JPRB, &
  & 0.16847256E-09_JPRB, 0.16836962E-09_JPRB, 0.16829285E-09_JPRB, 0.16824538E-09_JPRB, 0.16822631E-09_JPRB, 0.16823259E-09_JPRB, &
  & 0.16826258E-09_JPRB, 0.16831363E-09_JPRB, 0.16838027E-09_JPRB, 0.16845665E-09_JPRB, 0.16853585E-09_JPRB, 0.16861179E-09_JPRB, &
  & 0.16867931E-09_JPRB, 0.16873139E-09_JPRB, 0.16876223E-09_JPRB, 0.16877055E-09_JPRB, 0.16876026E-09_JPRB, 0.16873761E-09_JPRB, &
  & 0.16870765E-09_JPRB, 0.16867510E-09_JPRB, 0.16864525E-09_JPRB, 0.16862496E-09_JPRB, 0.16862133E-09_JPRB, 0.16864068E-09_JPRB, &
  & 0.16868734E-09_JPRB, 0.16876048E-09_JPRB, 0.16885285E-09_JPRB, 0.16895306E-09_JPRB, 0.16905075E-09_JPRB, 0.16913700E-09_JPRB, &
  & 0.16920600E-09_JPRB, 0.16925274E-09_JPRB, 0.16927909E-09_JPRB, 0.16929150E-09_JPRB, 0.16929591E-09_JPRB, 0.16929641E-09_JPRB, &
  & 0.16929451E-09_JPRB, 0.16929082E-09_JPRB, 0.16928575E-09_JPRB, 0.16927981E-09_JPRB, 0.16927376E-09_JPRB, 0.16926818E-09_JPRB, &
  & 0.16926248E-09_JPRB, 0.16925641E-09_JPRB, 0.16924845E-09_JPRB, 0.16923353E-09_JPRB /)

RGHG8(:,65,11) = (/ &
  & 0.16905652E-09_JPRB, 0.16905849E-09_JPRB, 0.16905263E-09_JPRB, 0.16904139E-09_JPRB, 0.16902398E-09_JPRB, 0.16900054E-09_JPRB, &
  & 0.16897959E-09_JPRB, 0.16896554E-09_JPRB, 0.16896301E-09_JPRB, 0.16896230E-09_JPRB, 0.16896264E-09_JPRB, 0.16896201E-09_JPRB, &
  & 0.16895657E-09_JPRB, 0.16894125E-09_JPRB, 0.16890797E-09_JPRB, 0.16884971E-09_JPRB, 0.16876228E-09_JPRB, 0.16865360E-09_JPRB, &
  & 0.16854150E-09_JPRB, 0.16844359E-09_JPRB, 0.16837066E-09_JPRB, 0.16832602E-09_JPRB, 0.16830853E-09_JPRB, 0.16831526E-09_JPRB, &
  & 0.16834437E-09_JPRB, 0.16839344E-09_JPRB, 0.16845722E-09_JPRB, 0.16853066E-09_JPRB, 0.16860682E-09_JPRB, 0.16868007E-09_JPRB, &
  & 0.16874525E-09_JPRB, 0.16879535E-09_JPRB, 0.16882473E-09_JPRB, 0.16883232E-09_JPRB, 0.16882185E-09_JPRB, 0.16879918E-09_JPRB, &
  & 0.16876887E-09_JPRB, 0.16873555E-09_JPRB, 0.16870456E-09_JPRB, 0.16868318E-09_JPRB, 0.16867889E-09_JPRB, 0.16869808E-09_JPRB, &
  & 0.16874468E-09_JPRB, 0.16881743E-09_JPRB, 0.16890893E-09_JPRB, 0.16900775E-09_JPRB, 0.16910340E-09_JPRB, 0.16918776E-09_JPRB, &
  & 0.16925503E-09_JPRB, 0.16930200E-09_JPRB, 0.16932940E-09_JPRB, 0.16934237E-09_JPRB, 0.16934666E-09_JPRB, 0.16934623E-09_JPRB, &
  & 0.16934289E-09_JPRB, 0.16933766E-09_JPRB, 0.16933085E-09_JPRB, 0.16932332E-09_JPRB, 0.16931592E-09_JPRB, 0.16930868E-09_JPRB, &
  & 0.16930168E-09_JPRB, 0.16929359E-09_JPRB, 0.16928321E-09_JPRB, 0.16926345E-09_JPRB /)

RGHG8(:,66,11) = (/ &
  & 0.16911178E-09_JPRB, 0.16911629E-09_JPRB, 0.16911095E-09_JPRB, 0.16910036E-09_JPRB, 0.16908280E-09_JPRB, 0.16905967E-09_JPRB, &
  & 0.16903601E-09_JPRB, 0.16902080E-09_JPRB, 0.16901906E-09_JPRB, 0.16901974E-09_JPRB, 0.16902178E-09_JPRB, 0.16902252E-09_JPRB, &
  & 0.16901773E-09_JPRB, 0.16900194E-09_JPRB, 0.16896844E-09_JPRB, 0.16891095E-09_JPRB, 0.16882691E-09_JPRB, 0.16872376E-09_JPRB, &
  & 0.16861790E-09_JPRB, 0.16852578E-09_JPRB, 0.16845741E-09_JPRB, 0.16841589E-09_JPRB, 0.16840024E-09_JPRB, 0.16840722E-09_JPRB, &
  & 0.16843518E-09_JPRB, 0.16848162E-09_JPRB, 0.16854197E-09_JPRB, 0.16861151E-09_JPRB, 0.16868393E-09_JPRB, 0.16875366E-09_JPRB, &
  & 0.16881586E-09_JPRB, 0.16886342E-09_JPRB, 0.16889104E-09_JPRB, 0.16889787E-09_JPRB, 0.16888758E-09_JPRB, 0.16886548E-09_JPRB, &
  & 0.16883557E-09_JPRB, 0.16880208E-09_JPRB, 0.16877069E-09_JPRB, 0.16874850E-09_JPRB, 0.16874362E-09_JPRB, 0.16876216E-09_JPRB, &
  & 0.16880804E-09_JPRB, 0.16887948E-09_JPRB, 0.16896903E-09_JPRB, 0.16906546E-09_JPRB, 0.16915848E-09_JPRB, 0.16924011E-09_JPRB, &
  & 0.16930551E-09_JPRB, 0.16935149E-09_JPRB, 0.16937932E-09_JPRB, 0.16939319E-09_JPRB, 0.16939737E-09_JPRB, 0.16939630E-09_JPRB, &
  & 0.16939183E-09_JPRB, 0.16938505E-09_JPRB, 0.16937682E-09_JPRB, 0.16936763E-09_JPRB, 0.16935850E-09_JPRB, 0.16934990E-09_JPRB, &
  & 0.16934079E-09_JPRB, 0.16933062E-09_JPRB, 0.16931670E-09_JPRB, 0.16928989E-09_JPRB /)

RGHG8(:,67,11) = (/ &
  & 0.16916916E-09_JPRB, 0.16917569E-09_JPRB, 0.16917104E-09_JPRB, 0.16916041E-09_JPRB, 0.16914335E-09_JPRB, 0.16911984E-09_JPRB, &
  & 0.16909601E-09_JPRB, 0.16907835E-09_JPRB, 0.16907832E-09_JPRB, 0.16908054E-09_JPRB, 0.16908391E-09_JPRB, 0.16908575E-09_JPRB, &
  & 0.16908140E-09_JPRB, 0.16906601E-09_JPRB, 0.16903297E-09_JPRB, 0.16897737E-09_JPRB, 0.16889755E-09_JPRB, 0.16880067E-09_JPRB, &
  & 0.16870187E-09_JPRB, 0.16861597E-09_JPRB, 0.16855245E-09_JPRB, 0.16851415E-09_JPRB, 0.16850003E-09_JPRB, 0.16850704E-09_JPRB, &
  & 0.16853338E-09_JPRB, 0.16857660E-09_JPRB, 0.16863273E-09_JPRB, 0.16869779E-09_JPRB, 0.16876564E-09_JPRB, 0.16883121E-09_JPRB, &
  & 0.16888983E-09_JPRB, 0.16893445E-09_JPRB, 0.16896004E-09_JPRB, 0.16896617E-09_JPRB, 0.16895638E-09_JPRB, 0.16893545E-09_JPRB, &
  & 0.16890667E-09_JPRB, 0.16887396E-09_JPRB, 0.16884288E-09_JPRB, 0.16882057E-09_JPRB, 0.16881523E-09_JPRB, 0.16883304E-09_JPRB, &
  & 0.16887751E-09_JPRB, 0.16894669E-09_JPRB, 0.16903323E-09_JPRB, 0.16912617E-09_JPRB, 0.16921575E-09_JPRB, 0.16929423E-09_JPRB, &
  & 0.16935718E-09_JPRB, 0.16940173E-09_JPRB, 0.16942939E-09_JPRB, 0.16944342E-09_JPRB, 0.16944782E-09_JPRB, 0.16944646E-09_JPRB, &
  & 0.16944110E-09_JPRB, 0.16943338E-09_JPRB, 0.16942373E-09_JPRB, 0.16941318E-09_JPRB, 0.16940271E-09_JPRB, 0.16939218E-09_JPRB, &
  & 0.16938154E-09_JPRB, 0.16936832E-09_JPRB, 0.16935010E-09_JPRB, 0.16931352E-09_JPRB /)

RGHG8(:,68,11) = (/ &
  & 0.16922479E-09_JPRB, 0.16923546E-09_JPRB, 0.16923203E-09_JPRB, 0.16922222E-09_JPRB, 0.16920548E-09_JPRB, 0.16918250E-09_JPRB, &
  & 0.16915799E-09_JPRB, 0.16914020E-09_JPRB, 0.16914153E-09_JPRB, 0.16914496E-09_JPRB, 0.16914950E-09_JPRB, 0.16915196E-09_JPRB, &
  & 0.16914804E-09_JPRB, 0.16913318E-09_JPRB, 0.16910126E-09_JPRB, 0.16904861E-09_JPRB, 0.16897375E-09_JPRB, 0.16888382E-09_JPRB, &
  & 0.16879238E-09_JPRB, 0.16871310E-09_JPRB, 0.16865431E-09_JPRB, 0.16861905E-09_JPRB, 0.16860621E-09_JPRB, 0.16861276E-09_JPRB, &
  & 0.16863699E-09_JPRB, 0.16867664E-09_JPRB, 0.16872811E-09_JPRB, 0.16878812E-09_JPRB, 0.16885093E-09_JPRB, 0.16891183E-09_JPRB, &
  & 0.16896649E-09_JPRB, 0.16900786E-09_JPRB, 0.16903133E-09_JPRB, 0.16903683E-09_JPRB, 0.16902774E-09_JPRB, 0.16900831E-09_JPRB, &
  & 0.16898132E-09_JPRB, 0.16895017E-09_JPRB, 0.16892024E-09_JPRB, 0.16889844E-09_JPRB, 0.16889311E-09_JPRB, 0.16891014E-09_JPRB, &
  & 0.16895289E-09_JPRB, 0.16901902E-09_JPRB, 0.16910148E-09_JPRB, 0.16919005E-09_JPRB, 0.16927525E-09_JPRB, 0.16934991E-09_JPRB, &
  & 0.16940985E-09_JPRB, 0.16945255E-09_JPRB, 0.16947926E-09_JPRB, 0.16949347E-09_JPRB, 0.16949779E-09_JPRB, 0.16949638E-09_JPRB, &
  & 0.16949077E-09_JPRB, 0.16948232E-09_JPRB, 0.16947194E-09_JPRB, 0.16946031E-09_JPRB, 0.16944847E-09_JPRB, 0.16943709E-09_JPRB, &
  & 0.16942418E-09_JPRB, 0.16940893E-09_JPRB, 0.16938574E-09_JPRB, 0.16933852E-09_JPRB /)

RGHG8(:,69,11) = (/ &
  & 0.16928126E-09_JPRB, 0.16929690E-09_JPRB, 0.16929504E-09_JPRB, 0.16928592E-09_JPRB, 0.16927000E-09_JPRB, 0.16924791E-09_JPRB, &
  & 0.16922408E-09_JPRB, 0.16920640E-09_JPRB, 0.16920920E-09_JPRB, 0.16921371E-09_JPRB, 0.16921878E-09_JPRB, 0.16922155E-09_JPRB, &
  & 0.16921785E-09_JPRB, 0.16920372E-09_JPRB, 0.16917337E-09_JPRB, 0.16912410E-09_JPRB, 0.16905483E-09_JPRB, 0.16897227E-09_JPRB, &
  & 0.16888857E-09_JPRB, 0.16881571E-09_JPRB, 0.16876167E-09_JPRB, 0.16872907E-09_JPRB, 0.16871714E-09_JPRB, 0.16872299E-09_JPRB, &
  & 0.16874492E-09_JPRB, 0.16878068E-09_JPRB, 0.16882723E-09_JPRB, 0.16888196E-09_JPRB, 0.16893949E-09_JPRB, 0.16899544E-09_JPRB, &
  & 0.16904582E-09_JPRB, 0.16908377E-09_JPRB, 0.16910504E-09_JPRB, 0.16910985E-09_JPRB, 0.16910162E-09_JPRB, 0.16908396E-09_JPRB, &
  & 0.16905907E-09_JPRB, 0.16902996E-09_JPRB, 0.16900180E-09_JPRB, 0.16898127E-09_JPRB, 0.16897637E-09_JPRB, 0.16899283E-09_JPRB, &
  & 0.16903354E-09_JPRB, 0.16909615E-09_JPRB, 0.16917386E-09_JPRB, 0.16925704E-09_JPRB, 0.16933709E-09_JPRB, 0.16940727E-09_JPRB, &
  & 0.16946365E-09_JPRB, 0.16950401E-09_JPRB, 0.16952954E-09_JPRB, 0.16954328E-09_JPRB, 0.16954758E-09_JPRB, 0.16954627E-09_JPRB, &
  & 0.16954066E-09_JPRB, 0.16953215E-09_JPRB, 0.16952134E-09_JPRB, 0.16950907E-09_JPRB, 0.16949683E-09_JPRB, 0.16948407E-09_JPRB, &
  & 0.16947074E-09_JPRB, 0.16945292E-09_JPRB, 0.16942599E-09_JPRB, 0.16936760E-09_JPRB /)

RGHG8(:,70,11) = (/ &
  & 0.16933854E-09_JPRB, 0.16935990E-09_JPRB, 0.16936004E-09_JPRB, 0.16935220E-09_JPRB, 0.16933735E-09_JPRB, 0.16931653E-09_JPRB, &
  & 0.16929418E-09_JPRB, 0.16927759E-09_JPRB, 0.16928149E-09_JPRB, 0.16928667E-09_JPRB, 0.16929171E-09_JPRB, 0.16929431E-09_JPRB, &
  & 0.16929064E-09_JPRB, 0.16927726E-09_JPRB, 0.16924878E-09_JPRB, 0.16920336E-09_JPRB, 0.16913992E-09_JPRB, 0.16906478E-09_JPRB, &
  & 0.16898874E-09_JPRB, 0.16892245E-09_JPRB, 0.16887286E-09_JPRB, 0.16884281E-09_JPRB, 0.16883159E-09_JPRB, 0.16883660E-09_JPRB, &
  & 0.16885610E-09_JPRB, 0.16888796E-09_JPRB, 0.16892954E-09_JPRB, 0.16897878E-09_JPRB, 0.16903086E-09_JPRB, 0.16908160E-09_JPRB, &
  & 0.16912759E-09_JPRB, 0.16916196E-09_JPRB, 0.16918100E-09_JPRB, 0.16918518E-09_JPRB, 0.16917785E-09_JPRB, 0.16916203E-09_JPRB, &
  & 0.16913956E-09_JPRB, 0.16911295E-09_JPRB, 0.16908705E-09_JPRB, 0.16906818E-09_JPRB, 0.16906407E-09_JPRB, 0.16907994E-09_JPRB, &
  & 0.16911875E-09_JPRB, 0.16917742E-09_JPRB, 0.16924975E-09_JPRB, 0.16932698E-09_JPRB, 0.16940108E-09_JPRB, 0.16946611E-09_JPRB, &
  & 0.16951837E-09_JPRB, 0.16955587E-09_JPRB, 0.16957979E-09_JPRB, 0.16959303E-09_JPRB, 0.16959723E-09_JPRB, 0.16959617E-09_JPRB, &
  & 0.16959108E-09_JPRB, 0.16958279E-09_JPRB, 0.16957216E-09_JPRB, 0.16955994E-09_JPRB, 0.16954738E-09_JPRB, 0.16953480E-09_JPRB, &
  & 0.16952051E-09_JPRB, 0.16950225E-09_JPRB, 0.16947216E-09_JPRB, 0.16940577E-09_JPRB /)

RGHG8(:,71,11) = (/ &
  & 0.16939836E-09_JPRB, 0.16942550E-09_JPRB, 0.16942754E-09_JPRB, 0.16942099E-09_JPRB, 0.16940746E-09_JPRB, 0.16938856E-09_JPRB, &
  & 0.16936794E-09_JPRB, 0.16935339E-09_JPRB, 0.16935797E-09_JPRB, 0.16936297E-09_JPRB, 0.16936773E-09_JPRB, 0.16936975E-09_JPRB, &
  & 0.16936595E-09_JPRB, 0.16935342E-09_JPRB, 0.16932675E-09_JPRB, 0.16928549E-09_JPRB, 0.16922802E-09_JPRB, 0.16916044E-09_JPRB, &
  & 0.16909196E-09_JPRB, 0.16903197E-09_JPRB, 0.16898706E-09_JPRB, 0.16895936E-09_JPRB, 0.16894881E-09_JPRB, 0.16895289E-09_JPRB, &
  & 0.16896989E-09_JPRB, 0.16899789E-09_JPRB, 0.16903444E-09_JPRB, 0.16907821E-09_JPRB, 0.16912469E-09_JPRB, 0.16917014E-09_JPRB, &
  & 0.16921153E-09_JPRB, 0.16924230E-09_JPRB, 0.16925915E-09_JPRB, 0.16926273E-09_JPRB, 0.16925633E-09_JPRB, 0.16924245E-09_JPRB, &
  & 0.16922254E-09_JPRB, 0.16919857E-09_JPRB, 0.16917528E-09_JPRB, 0.16915845E-09_JPRB, 0.16915536E-09_JPRB, 0.16917082E-09_JPRB, &
  & 0.16920727E-09_JPRB, 0.16926188E-09_JPRB, 0.16932844E-09_JPRB, 0.16939918E-09_JPRB, 0.16946673E-09_JPRB, 0.16952599E-09_JPRB, &
  & 0.16957355E-09_JPRB, 0.16960795E-09_JPRB, 0.16962995E-09_JPRB, 0.16964252E-09_JPRB, 0.16964664E-09_JPRB, 0.16964602E-09_JPRB, &
  & 0.16964169E-09_JPRB, 0.16963413E-09_JPRB, 0.16962422E-09_JPRB, 0.16961256E-09_JPRB, 0.16960043E-09_JPRB, 0.16958812E-09_JPRB, &
  & 0.16957433E-09_JPRB, 0.16955562E-09_JPRB, 0.16952498E-09_JPRB, 0.16945366E-09_JPRB /)

RGHG8(:,72,11) = (/ &
  & 0.16946161E-09_JPRB, 0.16949331E-09_JPRB, 0.16949708E-09_JPRB, 0.16949177E-09_JPRB, 0.16947974E-09_JPRB, 0.16946262E-09_JPRB, &
  & 0.16944486E-09_JPRB, 0.16943247E-09_JPRB, 0.16943683E-09_JPRB, 0.16944171E-09_JPRB, 0.16944543E-09_JPRB, 0.16944682E-09_JPRB, &
  & 0.16944281E-09_JPRB, 0.16943127E-09_JPRB, 0.16940681E-09_JPRB, 0.16936962E-09_JPRB, 0.16931835E-09_JPRB, 0.16925804E-09_JPRB, &
  & 0.16919717E-09_JPRB, 0.16914363E-09_JPRB, 0.16910329E-09_JPRB, 0.16907827E-09_JPRB, 0.16906822E-09_JPRB, 0.16907137E-09_JPRB, &
  & 0.16908591E-09_JPRB, 0.16910992E-09_JPRB, 0.16914159E-09_JPRB, 0.16917973E-09_JPRB, 0.16922051E-09_JPRB, 0.16926052E-09_JPRB, &
  & 0.16929728E-09_JPRB, 0.16932443E-09_JPRB, 0.16933920E-09_JPRB, 0.16934226E-09_JPRB, 0.16933682E-09_JPRB, 0.16932489E-09_JPRB, &
  & 0.16930762E-09_JPRB, 0.16928658E-09_JPRB, 0.16926618E-09_JPRB, 0.16925158E-09_JPRB, 0.16924954E-09_JPRB, 0.16926445E-09_JPRB, &
  & 0.16929853E-09_JPRB, 0.16934851E-09_JPRB, 0.16940879E-09_JPRB, 0.16947269E-09_JPRB, 0.16953314E-09_JPRB, 0.16958610E-09_JPRB, &
  & 0.16962880E-09_JPRB, 0.16965959E-09_JPRB, 0.16967960E-09_JPRB, 0.16969132E-09_JPRB, 0.16969542E-09_JPRB, 0.16969534E-09_JPRB, &
  & 0.16969195E-09_JPRB, 0.16968572E-09_JPRB, 0.16967679E-09_JPRB, 0.16966602E-09_JPRB, 0.16965508E-09_JPRB, 0.16964320E-09_JPRB, &
  & 0.16963024E-09_JPRB, 0.16961257E-09_JPRB, 0.16958149E-09_JPRB, 0.16950932E-09_JPRB /)

RGHG8(:,73,11) = (/ &
  & 0.16952983E-09_JPRB, 0.16956334E-09_JPRB, 0.16956785E-09_JPRB, 0.16956342E-09_JPRB, 0.16955262E-09_JPRB, 0.16953788E-09_JPRB, &
  & 0.16952240E-09_JPRB, 0.16951265E-09_JPRB, 0.16951668E-09_JPRB, 0.16952043E-09_JPRB, 0.16952373E-09_JPRB, 0.16952437E-09_JPRB, &
  & 0.16952026E-09_JPRB, 0.16950980E-09_JPRB, 0.16948806E-09_JPRB, 0.16945473E-09_JPRB, 0.16940946E-09_JPRB, 0.16935672E-09_JPRB, &
  & 0.16930327E-09_JPRB, 0.16925639E-09_JPRB, 0.16922098E-09_JPRB, 0.16919849E-09_JPRB, 0.16918909E-09_JPRB, 0.16919133E-09_JPRB, &
  & 0.16920335E-09_JPRB, 0.16922364E-09_JPRB, 0.16925024E-09_JPRB, 0.16928284E-09_JPRB, 0.16931788E-09_JPRB, 0.16935248E-09_JPRB, &
  & 0.16938459E-09_JPRB, 0.16940813E-09_JPRB, 0.16942088E-09_JPRB, 0.16942345E-09_JPRB, 0.16941905E-09_JPRB, 0.16940913E-09_JPRB, &
  & 0.16939453E-09_JPRB, 0.16937644E-09_JPRB, 0.16935914E-09_JPRB, 0.16934688E-09_JPRB, 0.16934595E-09_JPRB, 0.16936016E-09_JPRB, &
  & 0.16939128E-09_JPRB, 0.16943608E-09_JPRB, 0.16948976E-09_JPRB, 0.16954599E-09_JPRB, 0.16959917E-09_JPRB, 0.16964567E-09_JPRB, &
  & 0.16968306E-09_JPRB, 0.16971048E-09_JPRB, 0.16972823E-09_JPRB, 0.16973904E-09_JPRB, 0.16974314E-09_JPRB, 0.16974354E-09_JPRB, &
  & 0.16974125E-09_JPRB, 0.16973604E-09_JPRB, 0.16972854E-09_JPRB, 0.16971928E-09_JPRB, 0.16970890E-09_JPRB, 0.16969871E-09_JPRB, &
  & 0.16968653E-09_JPRB, 0.16966993E-09_JPRB, 0.16964112E-09_JPRB, 0.16956891E-09_JPRB /)

RGHG8(:,74,11) = (/ &
  & 0.16959875E-09_JPRB, 0.16963328E-09_JPRB, 0.16963833E-09_JPRB, 0.16963467E-09_JPRB, 0.16962534E-09_JPRB, 0.16961256E-09_JPRB, &
  & 0.16959997E-09_JPRB, 0.16959180E-09_JPRB, 0.16959507E-09_JPRB, 0.16959875E-09_JPRB, 0.16960097E-09_JPRB, 0.16960131E-09_JPRB, &
  & 0.16959749E-09_JPRB, 0.16958812E-09_JPRB, 0.16956911E-09_JPRB, 0.16954012E-09_JPRB, 0.16950101E-09_JPRB, 0.16945541E-09_JPRB, &
  & 0.16940972E-09_JPRB, 0.16936945E-09_JPRB, 0.16933928E-09_JPRB, 0.16931956E-09_JPRB, 0.16931084E-09_JPRB, 0.16931220E-09_JPRB, &
  & 0.16932188E-09_JPRB, 0.16933842E-09_JPRB, 0.16936022E-09_JPRB, 0.16938730E-09_JPRB, 0.16941652E-09_JPRB, 0.16944568E-09_JPRB, &
  & 0.16947306E-09_JPRB, 0.16949300E-09_JPRB, 0.16950386E-09_JPRB, 0.16950608E-09_JPRB, 0.16950265E-09_JPRB, 0.16949463E-09_JPRB, &
  & 0.16948273E-09_JPRB, 0.16946780E-09_JPRB, 0.16945370E-09_JPRB, 0.16944381E-09_JPRB, 0.16944386E-09_JPRB, 0.16945699E-09_JPRB, &
  & 0.16948469E-09_JPRB, 0.16952378E-09_JPRB, 0.16956996E-09_JPRB, 0.16961868E-09_JPRB, 0.16966395E-09_JPRB, 0.16970388E-09_JPRB, &
  & 0.16973616E-09_JPRB, 0.16975975E-09_JPRB, 0.16977535E-09_JPRB, 0.16978531E-09_JPRB, 0.16978914E-09_JPRB, 0.16978986E-09_JPRB, &
  & 0.16978829E-09_JPRB, 0.16978446E-09_JPRB, 0.16977812E-09_JPRB, 0.16976989E-09_JPRB, 0.16976166E-09_JPRB, 0.16975180E-09_JPRB, &
  & 0.16974161E-09_JPRB, 0.16972691E-09_JPRB, 0.16969939E-09_JPRB, 0.16963231E-09_JPRB /)

RGHG8(:,75,11) = (/ &
  & 0.16966727E-09_JPRB, 0.16970196E-09_JPRB, 0.16970760E-09_JPRB, 0.16970482E-09_JPRB, 0.16969690E-09_JPRB, 0.16968642E-09_JPRB, &
  & 0.16967563E-09_JPRB, 0.16966913E-09_JPRB, 0.16967233E-09_JPRB, 0.16967502E-09_JPRB, 0.16967708E-09_JPRB, 0.16967716E-09_JPRB, &
  & 0.16967359E-09_JPRB, 0.16966556E-09_JPRB, 0.16964986E-09_JPRB, 0.16962490E-09_JPRB, 0.16959215E-09_JPRB, 0.16955404E-09_JPRB, &
  & 0.16951596E-09_JPRB, 0.16948272E-09_JPRB, 0.16945778E-09_JPRB, 0.16944113E-09_JPRB, 0.16943316E-09_JPRB, 0.16943379E-09_JPRB, &
  & 0.16944118E-09_JPRB, 0.16945431E-09_JPRB, 0.16947137E-09_JPRB, 0.16949306E-09_JPRB, 0.16951654E-09_JPRB, 0.16954031E-09_JPRB, &
  & 0.16956303E-09_JPRB, 0.16957938E-09_JPRB, 0.16958841E-09_JPRB, 0.16959024E-09_JPRB, 0.16958776E-09_JPRB, 0.16958167E-09_JPRB, &
  & 0.16957230E-09_JPRB, 0.16956050E-09_JPRB, 0.16954960E-09_JPRB, 0.16954195E-09_JPRB, 0.16954280E-09_JPRB, 0.16955448E-09_JPRB, &
  & 0.16957809E-09_JPRB, 0.16961081E-09_JPRB, 0.16964953E-09_JPRB, 0.16968968E-09_JPRB, 0.16972741E-09_JPRB, 0.16976055E-09_JPRB, &
  & 0.16978743E-09_JPRB, 0.16980736E-09_JPRB, 0.16982049E-09_JPRB, 0.16982944E-09_JPRB, 0.16983288E-09_JPRB, 0.16983366E-09_JPRB, &
  & 0.16983277E-09_JPRB, 0.16982973E-09_JPRB, 0.16982471E-09_JPRB, 0.16981833E-09_JPRB, 0.16981067E-09_JPRB, 0.16980314E-09_JPRB, &
  & 0.16979389E-09_JPRB, 0.16978145E-09_JPRB, 0.16975751E-09_JPRB, 0.16969436E-09_JPRB /)

RGHG8(:,76,11) = (/ &
  & 0.16973478E-09_JPRB, 0.16976895E-09_JPRB, 0.16977506E-09_JPRB, 0.16977321E-09_JPRB, 0.16976691E-09_JPRB, 0.16975850E-09_JPRB, &
  & 0.16975008E-09_JPRB, 0.16974440E-09_JPRB, 0.16974723E-09_JPRB, 0.16974980E-09_JPRB, 0.16975099E-09_JPRB, 0.16975096E-09_JPRB, &
  & 0.16974799E-09_JPRB, 0.16974135E-09_JPRB, 0.16972893E-09_JPRB, 0.16970897E-09_JPRB, 0.16968277E-09_JPRB, 0.16965232E-09_JPRB, &
  & 0.16962207E-09_JPRB, 0.16959567E-09_JPRB, 0.16957652E-09_JPRB, 0.16956297E-09_JPRB, 0.16955605E-09_JPRB, 0.16955609E-09_JPRB, &
  & 0.16956142E-09_JPRB, 0.16957130E-09_JPRB, 0.16958392E-09_JPRB, 0.16960033E-09_JPRB, 0.16961792E-09_JPRB, 0.16963647E-09_JPRB, &
  & 0.16965447E-09_JPRB, 0.16966724E-09_JPRB, 0.16967450E-09_JPRB, 0.16967594E-09_JPRB, 0.16967436E-09_JPRB, 0.16967007E-09_JPRB, &
  & 0.16966313E-09_JPRB, 0.16965450E-09_JPRB, 0.16964662E-09_JPRB, 0.16964107E-09_JPRB, 0.16964241E-09_JPRB, 0.16965210E-09_JPRB, &
  & 0.16967119E-09_JPRB, 0.16969726E-09_JPRB, 0.16972757E-09_JPRB, 0.16975986E-09_JPRB, 0.16978904E-09_JPRB, 0.16981555E-09_JPRB, &
  & 0.16983683E-09_JPRB, 0.16985277E-09_JPRB, 0.16986318E-09_JPRB, 0.16987110E-09_JPRB, 0.16987386E-09_JPRB, 0.16987443E-09_JPRB, &
  & 0.16987392E-09_JPRB, 0.16987199E-09_JPRB, 0.16986815E-09_JPRB, 0.16986293E-09_JPRB, 0.16985760E-09_JPRB, 0.16985061E-09_JPRB, &
  & 0.16984378E-09_JPRB, 0.16983351E-09_JPRB, 0.16981282E-09_JPRB, 0.16975675E-09_JPRB /)

RGHG8(:,77,11) = (/ &
  & 0.16980066E-09_JPRB, 0.16983306E-09_JPRB, 0.16983961E-09_JPRB, 0.16983874E-09_JPRB, 0.16983398E-09_JPRB, 0.16982812E-09_JPRB, &
  & 0.16982170E-09_JPRB, 0.16981734E-09_JPRB, 0.16981999E-09_JPRB, 0.16982153E-09_JPRB, 0.16982202E-09_JPRB, 0.16982175E-09_JPRB, &
  & 0.16981921E-09_JPRB, 0.16981429E-09_JPRB, 0.16980581E-09_JPRB, 0.16979067E-09_JPRB, 0.16977184E-09_JPRB, 0.16974917E-09_JPRB, &
  & 0.16972697E-09_JPRB, 0.16970768E-09_JPRB, 0.16969440E-09_JPRB, 0.16968436E-09_JPRB, 0.16967849E-09_JPRB, 0.16967824E-09_JPRB, &
  & 0.16968180E-09_JPRB, 0.16968865E-09_JPRB, 0.16969720E-09_JPRB, 0.16970864E-09_JPRB, 0.16972072E-09_JPRB, 0.16973416E-09_JPRB, &
  & 0.16974758E-09_JPRB, 0.16975676E-09_JPRB, 0.16976229E-09_JPRB, 0.16976337E-09_JPRB, 0.16976252E-09_JPRB, 0.16975972E-09_JPRB, &
  & 0.16975489E-09_JPRB, 0.16974902E-09_JPRB, 0.16974394E-09_JPRB, 0.16974015E-09_JPRB, 0.16974155E-09_JPRB, 0.16974880E-09_JPRB, &
  & 0.16976288E-09_JPRB, 0.16978180E-09_JPRB, 0.16980400E-09_JPRB, 0.16982750E-09_JPRB, 0.16984872E-09_JPRB, 0.16986809E-09_JPRB, &
  & 0.16988375E-09_JPRB, 0.16989557E-09_JPRB, 0.16990306E-09_JPRB, 0.16990974E-09_JPRB, 0.16991161E-09_JPRB, 0.16991170E-09_JPRB, &
  & 0.16991154E-09_JPRB, 0.16991042E-09_JPRB, 0.16990780E-09_JPRB, 0.16990442E-09_JPRB, 0.16990015E-09_JPRB, 0.16989526E-09_JPRB, &
  & 0.16988967E-09_JPRB, 0.16988229E-09_JPRB, 0.16986552E-09_JPRB, 0.16981767E-09_JPRB /)

RGHG8(:,78,11) = (/ &
  & 0.16986412E-09_JPRB, 0.16989131E-09_JPRB, 0.16989676E-09_JPRB, 0.16989662E-09_JPRB, 0.16989336E-09_JPRB, 0.16988999E-09_JPRB, &
  & 0.16988638E-09_JPRB, 0.16988339E-09_JPRB, 0.16988520E-09_JPRB, 0.16988580E-09_JPRB, 0.16988518E-09_JPRB, 0.16988465E-09_JPRB, &
  & 0.16988277E-09_JPRB, 0.16987960E-09_JPRB, 0.16987503E-09_JPRB, 0.16986504E-09_JPRB, 0.16985320E-09_JPRB, 0.16983838E-09_JPRB, &
  & 0.16982413E-09_JPRB, 0.16981183E-09_JPRB, 0.16980463E-09_JPRB, 0.16979816E-09_JPRB, 0.16979365E-09_JPRB, 0.16979340E-09_JPRB, &
  & 0.16979562E-09_JPRB, 0.16980002E-09_JPRB, 0.16980518E-09_JPRB, 0.16981233E-09_JPRB, 0.16981934E-09_JPRB, 0.16982812E-09_JPRB, &
  & 0.16983734E-09_JPRB, 0.16984313E-09_JPRB, 0.16984697E-09_JPRB, 0.16984757E-09_JPRB, 0.16984721E-09_JPRB, 0.16984555E-09_JPRB, &
  & 0.16984236E-09_JPRB, 0.16983882E-09_JPRB, 0.16983578E-09_JPRB, 0.16983320E-09_JPRB, 0.16983398E-09_JPRB, 0.16983839E-09_JPRB, &
  & 0.16984722E-09_JPRB, 0.16985927E-09_JPRB, 0.16987328E-09_JPRB, 0.16988896E-09_JPRB, 0.16990213E-09_JPRB, 0.16991508E-09_JPRB, &
  & 0.16992525E-09_JPRB, 0.16993312E-09_JPRB, 0.16993770E-09_JPRB, 0.16994316E-09_JPRB, 0.16994396E-09_JPRB, 0.16994331E-09_JPRB, &
  & 0.16994323E-09_JPRB, 0.16994287E-09_JPRB, 0.16994120E-09_JPRB, 0.16993933E-09_JPRB, 0.16993680E-09_JPRB, 0.16993290E-09_JPRB, &
  & 0.16992924E-09_JPRB, 0.16992419E-09_JPRB, 0.16991303E-09_JPRB, 0.16987729E-09_JPRB /)

RGHG8(:,79,11) = (/ &
  & 0.16990465E-09_JPRB, 0.16992381E-09_JPRB, 0.16992728E-09_JPRB, 0.16992674E-09_JPRB, 0.16992399E-09_JPRB, 0.16992201E-09_JPRB, &
  & 0.16991977E-09_JPRB, 0.16991752E-09_JPRB, 0.16991890E-09_JPRB, 0.16991895E-09_JPRB, 0.16991775E-09_JPRB, 0.16991719E-09_JPRB, &
  & 0.16991575E-09_JPRB, 0.16991361E-09_JPRB, 0.16991142E-09_JPRB, 0.16990387E-09_JPRB, 0.16989594E-09_JPRB, 0.16988522E-09_JPRB, &
  & 0.16987532E-09_JPRB, 0.16986702E-09_JPRB, 0.16986354E-09_JPRB, 0.16985913E-09_JPRB, 0.16985538E-09_JPRB, 0.16985521E-09_JPRB, &
  & 0.16985688E-09_JPRB, 0.16986010E-09_JPRB, 0.16986355E-09_JPRB, 0.16986838E-09_JPRB, 0.16987256E-09_JPRB, 0.16987889E-09_JPRB, &
  & 0.16988597E-09_JPRB, 0.16988989E-09_JPRB, 0.16989292E-09_JPRB, 0.16989321E-09_JPRB, 0.16989304E-09_JPRB, 0.16989189E-09_JPRB, &
  & 0.16988942E-09_JPRB, 0.16988705E-09_JPRB, 0.16988509E-09_JPRB, 0.16988290E-09_JPRB, 0.16988329E-09_JPRB, 0.16988591E-09_JPRB, &
  & 0.16989195E-09_JPRB, 0.16990018E-09_JPRB, 0.16990993E-09_JPRB, 0.16992138E-09_JPRB, 0.16993032E-09_JPRB, 0.16993987E-09_JPRB, &
  & 0.16994715E-09_JPRB, 0.16995300E-09_JPRB, 0.16995591E-09_JPRB, 0.16996082E-09_JPRB, 0.16996095E-09_JPRB, 0.16995969E-09_JPRB, &
  & 0.16995964E-09_JPRB, 0.16995974E-09_JPRB, 0.16995856E-09_JPRB, 0.16995756E-09_JPRB, 0.16995569E-09_JPRB, 0.16995250E-09_JPRB, &
  & 0.16994949E-09_JPRB, 0.16994645E-09_JPRB, 0.16993940E-09_JPRB, 0.16991573E-09_JPRB /)

RGHG8(:,80,11) = (/ &
  & 0.16993124E-09_JPRB, 0.16993942E-09_JPRB, 0.16994059E-09_JPRB, 0.16993974E-09_JPRB, 0.16993709E-09_JPRB, 0.16993570E-09_JPRB, &
  & 0.16993415E-09_JPRB, 0.16993226E-09_JPRB, 0.16993346E-09_JPRB, 0.16993337E-09_JPRB, 0.16993189E-09_JPRB, 0.16993144E-09_JPRB, &
  & 0.16993025E-09_JPRB, 0.16992863E-09_JPRB, 0.16992761E-09_JPRB, 0.16992110E-09_JPRB, 0.16991490E-09_JPRB, 0.16990592E-09_JPRB, &
  & 0.16989798E-09_JPRB, 0.16989146E-09_JPRB, 0.16988995E-09_JPRB, 0.16988651E-09_JPRB, 0.16988311E-09_JPRB, 0.16988305E-09_JPRB, &
  & 0.16988455E-09_JPRB, 0.16988735E-09_JPRB, 0.16989005E-09_JPRB, 0.16989384E-09_JPRB, 0.16989665E-09_JPRB, 0.16990195E-09_JPRB, &
  & 0.16990817E-09_JPRB, 0.16991124E-09_JPRB, 0.16991390E-09_JPRB, 0.16991401E-09_JPRB, 0.16991389E-09_JPRB, 0.16991293E-09_JPRB, &
  & 0.16991071E-09_JPRB, 0.16990881E-09_JPRB, 0.16990734E-09_JPRB, 0.16990524E-09_JPRB, 0.16990528E-09_JPRB, 0.16990713E-09_JPRB, &
  & 0.16991186E-09_JPRB, 0.16991838E-09_JPRB, 0.16992623E-09_JPRB, 0.16993583E-09_JPRB, 0.16994275E-09_JPRB, 0.16995075E-09_JPRB, &
  & 0.16995680E-09_JPRB, 0.16996175E-09_JPRB, 0.16996386E-09_JPRB, 0.16996869E-09_JPRB, 0.16996844E-09_JPRB, 0.16996676E-09_JPRB, &
  & 0.16996671E-09_JPRB, 0.16996701E-09_JPRB, 0.16996603E-09_JPRB, 0.16996543E-09_JPRB, 0.16996390E-09_JPRB, 0.16996080E-09_JPRB, &
  & 0.16995826E-09_JPRB, 0.16995612E-09_JPRB, 0.16995212E-09_JPRB, 0.16994123E-09_JPRB /)

RGHG8(:,81,11) = (/ &
  & 0.16994912E-09_JPRB, 0.16994600E-09_JPRB, 0.16994627E-09_JPRB, 0.16994529E-09_JPRB, 0.16994270E-09_JPRB, 0.16994153E-09_JPRB, &
  & 0.16994034E-09_JPRB, 0.16993858E-09_JPRB, 0.16993965E-09_JPRB, 0.16993953E-09_JPRB, 0.16993805E-09_JPRB, 0.16993763E-09_JPRB, &
  & 0.16993662E-09_JPRB, 0.16993522E-09_JPRB, 0.16993476E-09_JPRB, 0.16992868E-09_JPRB, 0.16992323E-09_JPRB, 0.16991493E-09_JPRB, &
  & 0.16990775E-09_JPRB, 0.16990211E-09_JPRB, 0.16990152E-09_JPRB, 0.16989857E-09_JPRB, 0.16989531E-09_JPRB, 0.16989532E-09_JPRB, &
  & 0.16989675E-09_JPRB, 0.16989934E-09_JPRB, 0.16990170E-09_JPRB, 0.16990506E-09_JPRB, 0.16990727E-09_JPRB, 0.16991210E-09_JPRB, &
  & 0.16991795E-09_JPRB, 0.16992065E-09_JPRB, 0.16992320E-09_JPRB, 0.16992324E-09_JPRB, 0.16992313E-09_JPRB, 0.16992216E-09_JPRB, &
  & 0.16992005E-09_JPRB, 0.16991836E-09_JPRB, 0.16991708E-09_JPRB, 0.16991507E-09_JPRB, 0.16991497E-09_JPRB, 0.16991640E-09_JPRB, &
  & 0.16992054E-09_JPRB, 0.16992632E-09_JPRB, 0.16993332E-09_JPRB, 0.16994220E-09_JPRB, 0.16994813E-09_JPRB, 0.16995549E-09_JPRB, &
  & 0.16996096E-09_JPRB, 0.16996553E-09_JPRB, 0.16996726E-09_JPRB, 0.16997218E-09_JPRB, 0.16997172E-09_JPRB, 0.16996975E-09_JPRB, &
  & 0.16996975E-09_JPRB, 0.16997015E-09_JPRB, 0.16996925E-09_JPRB, 0.16996886E-09_JPRB, 0.16996744E-09_JPRB, 0.16996436E-09_JPRB, &
  & 0.16996191E-09_JPRB, 0.16996018E-09_JPRB, 0.16995748E-09_JPRB, 0.16995882E-09_JPRB /)

RGHG8(:,82,11) = (/ &
  & 0.16995058E-09_JPRB, 0.16994824E-09_JPRB, 0.16994876E-09_JPRB, 0.16994793E-09_JPRB, 0.16994536E-09_JPRB, 0.16994436E-09_JPRB, &
  & 0.16994330E-09_JPRB, 0.16994162E-09_JPRB, 0.16994271E-09_JPRB, 0.16994264E-09_JPRB, 0.16994099E-09_JPRB, 0.16994067E-09_JPRB, &
  & 0.16993970E-09_JPRB, 0.16993842E-09_JPRB, 0.16993830E-09_JPRB, 0.16993237E-09_JPRB, 0.16992734E-09_JPRB, 0.16991927E-09_JPRB, &
  & 0.16991258E-09_JPRB, 0.16990721E-09_JPRB, 0.16990719E-09_JPRB, 0.16990442E-09_JPRB, 0.16990123E-09_JPRB, 0.16990129E-09_JPRB, &
  & 0.16990270E-09_JPRB, 0.16990521E-09_JPRB, 0.16990744E-09_JPRB, 0.16991056E-09_JPRB, 0.16991242E-09_JPRB, 0.16991704E-09_JPRB, &
  & 0.16992276E-09_JPRB, 0.16992525E-09_JPRB, 0.16992777E-09_JPRB, 0.16992774E-09_JPRB, 0.16992763E-09_JPRB, 0.16992670E-09_JPRB, &
  & 0.16992462E-09_JPRB, 0.16992303E-09_JPRB, 0.16992188E-09_JPRB, 0.16991991E-09_JPRB, 0.16991968E-09_JPRB, 0.16992088E-09_JPRB, &
  & 0.16992474E-09_JPRB, 0.16993019E-09_JPRB, 0.16993683E-09_JPRB, 0.16994529E-09_JPRB, 0.16995078E-09_JPRB, 0.16995781E-09_JPRB, &
  & 0.16996297E-09_JPRB, 0.16996737E-09_JPRB, 0.16996893E-09_JPRB, 0.16997391E-09_JPRB, 0.16997330E-09_JPRB, 0.16997119E-09_JPRB, &
  & 0.16997116E-09_JPRB, 0.16997169E-09_JPRB, 0.16997083E-09_JPRB, 0.16997054E-09_JPRB, 0.16996918E-09_JPRB, 0.16996608E-09_JPRB, &
  & 0.16996365E-09_JPRB, 0.16996196E-09_JPRB, 0.16995926E-09_JPRB, 0.16996023E-09_JPRB /)

RGHG8(:,83,11) = (/ &
  & 0.16995157E-09_JPRB, 0.16994951E-09_JPRB, 0.16995023E-09_JPRB, 0.16994943E-09_JPRB, 0.16994686E-09_JPRB, 0.16994592E-09_JPRB, &
  & 0.16994495E-09_JPRB, 0.16994336E-09_JPRB, 0.16994434E-09_JPRB, 0.16994423E-09_JPRB, 0.16994273E-09_JPRB, 0.16994235E-09_JPRB, &
  & 0.16994146E-09_JPRB, 0.16994024E-09_JPRB, 0.16994030E-09_JPRB, 0.16993448E-09_JPRB, 0.16992958E-09_JPRB, 0.16992173E-09_JPRB, &
  & 0.16991515E-09_JPRB, 0.16991011E-09_JPRB, 0.16991039E-09_JPRB, 0.16990777E-09_JPRB, 0.16990451E-09_JPRB, 0.16990460E-09_JPRB, &
  & 0.16990605E-09_JPRB, 0.16990850E-09_JPRB, 0.16991061E-09_JPRB, 0.16991361E-09_JPRB, 0.16991526E-09_JPRB, 0.16991974E-09_JPRB, &
  & 0.16992543E-09_JPRB, 0.16992782E-09_JPRB, 0.16993035E-09_JPRB, 0.16993025E-09_JPRB, 0.16993010E-09_JPRB, 0.16992915E-09_JPRB, &
  & 0.16992714E-09_JPRB, 0.16992562E-09_JPRB, 0.16992452E-09_JPRB, 0.16992266E-09_JPRB, 0.16992233E-09_JPRB, 0.16992338E-09_JPRB, &
  & 0.16992710E-09_JPRB, 0.16993230E-09_JPRB, 0.16993867E-09_JPRB, 0.16994708E-09_JPRB, 0.16995219E-09_JPRB, 0.16995909E-09_JPRB, &
  & 0.16996407E-09_JPRB, 0.16996841E-09_JPRB, 0.16996982E-09_JPRB, 0.16997490E-09_JPRB, 0.16997423E-09_JPRB, 0.16997201E-09_JPRB, &
  & 0.16997197E-09_JPRB, 0.16997251E-09_JPRB, 0.16997173E-09_JPRB, 0.16997148E-09_JPRB, 0.16997018E-09_JPRB, 0.16996707E-09_JPRB, &
  & 0.16996460E-09_JPRB, 0.16996295E-09_JPRB, 0.16996028E-09_JPRB, 0.16996123E-09_JPRB /)

RGHG8(:,84,11) = (/ &
  & 0.16995221E-09_JPRB, 0.16995033E-09_JPRB, 0.16995112E-09_JPRB, 0.16995036E-09_JPRB, 0.16994781E-09_JPRB, 0.16994688E-09_JPRB, &
  & 0.16994595E-09_JPRB, 0.16994449E-09_JPRB, 0.16994534E-09_JPRB, 0.16994518E-09_JPRB, 0.16994374E-09_JPRB, 0.16994338E-09_JPRB, &
  & 0.16994252E-09_JPRB, 0.16994138E-09_JPRB, 0.16994149E-09_JPRB, 0.16993583E-09_JPRB, 0.16993111E-09_JPRB, 0.16992324E-09_JPRB, &
  & 0.16991686E-09_JPRB, 0.16991181E-09_JPRB, 0.16991238E-09_JPRB, 0.16990978E-09_JPRB, 0.16990652E-09_JPRB, 0.16990660E-09_JPRB, &
  & 0.16990803E-09_JPRB, 0.16991054E-09_JPRB, 0.16991257E-09_JPRB, 0.16991547E-09_JPRB, 0.16991697E-09_JPRB, 0.16992140E-09_JPRB, &
  & 0.16992707E-09_JPRB, 0.16992938E-09_JPRB, 0.16993192E-09_JPRB, 0.16993182E-09_JPRB, 0.16993167E-09_JPRB, 0.16993069E-09_JPRB, &
  & 0.16992871E-09_JPRB, 0.16992724E-09_JPRB, 0.16992616E-09_JPRB, 0.16992435E-09_JPRB, 0.16992398E-09_JPRB, 0.16992499E-09_JPRB, &
  & 0.16992846E-09_JPRB, 0.16993365E-09_JPRB, 0.16993984E-09_JPRB, 0.16994815E-09_JPRB, 0.16995309E-09_JPRB, 0.16995985E-09_JPRB, &
  & 0.16996474E-09_JPRB, 0.16996905E-09_JPRB, 0.16997041E-09_JPRB, 0.16997558E-09_JPRB, 0.16997480E-09_JPRB, 0.16997251E-09_JPRB, &
  & 0.16997245E-09_JPRB, 0.16997301E-09_JPRB, 0.16997227E-09_JPRB, 0.16997209E-09_JPRB, 0.16997080E-09_JPRB, 0.16996762E-09_JPRB, &
  & 0.16996519E-09_JPRB, 0.16996357E-09_JPRB, 0.16996093E-09_JPRB, 0.16996191E-09_JPRB /)

RGHG8(:,85,11) = (/ &
  & 0.16995264E-09_JPRB, 0.16995085E-09_JPRB, 0.16995172E-09_JPRB, 0.16995103E-09_JPRB, 0.16994839E-09_JPRB, 0.16994746E-09_JPRB, &
  & 0.16994656E-09_JPRB, 0.16994531E-09_JPRB, 0.16994584E-09_JPRB, 0.16994557E-09_JPRB, 0.16994448E-09_JPRB, 0.16994398E-09_JPRB, &
  & 0.16994323E-09_JPRB, 0.16994217E-09_JPRB, 0.16994202E-09_JPRB, 0.16993679E-09_JPRB, 0.16993204E-09_JPRB, 0.16992430E-09_JPRB, &
  & 0.16991795E-09_JPRB, 0.16991300E-09_JPRB, 0.16991374E-09_JPRB, 0.16991120E-09_JPRB, 0.16990774E-09_JPRB, 0.16990785E-09_JPRB, &
  & 0.16990934E-09_JPRB, 0.16991188E-09_JPRB, 0.16991383E-09_JPRB, 0.16991669E-09_JPRB, 0.16991805E-09_JPRB, 0.16992246E-09_JPRB, &
  & 0.16992813E-09_JPRB, 0.16993042E-09_JPRB, 0.16993297E-09_JPRB, 0.16993282E-09_JPRB, 0.16993264E-09_JPRB, 0.16993164E-09_JPRB, &
  & 0.16992972E-09_JPRB, 0.16992828E-09_JPRB, 0.16992724E-09_JPRB, 0.16992549E-09_JPRB, 0.16992502E-09_JPRB, 0.16992585E-09_JPRB, &
  & 0.16992946E-09_JPRB, 0.16993441E-09_JPRB, 0.16994066E-09_JPRB, 0.16994893E-09_JPRB, 0.16995365E-09_JPRB, 0.16996037E-09_JPRB, &
  & 0.16996514E-09_JPRB, 0.16996946E-09_JPRB, 0.16997076E-09_JPRB, 0.16997603E-09_JPRB, 0.16997523E-09_JPRB, 0.16997283E-09_JPRB, &
  & 0.16997276E-09_JPRB, 0.16997331E-09_JPRB, 0.16997263E-09_JPRB, 0.16997249E-09_JPRB, 0.16997120E-09_JPRB, 0.16996803E-09_JPRB, &
  & 0.16996558E-09_JPRB, 0.16996399E-09_JPRB, 0.16996136E-09_JPRB, 0.16996239E-09_JPRB /)

RGHG8(:,86,11) = (/ &
  & 0.16995286E-09_JPRB, 0.16995119E-09_JPRB, 0.16995216E-09_JPRB, 0.16995144E-09_JPRB, 0.16994868E-09_JPRB, 0.16994781E-09_JPRB, &
  & 0.16994681E-09_JPRB, 0.16994586E-09_JPRB, 0.16994611E-09_JPRB, 0.16994575E-09_JPRB, 0.16994484E-09_JPRB, 0.16994431E-09_JPRB, &
  & 0.16994359E-09_JPRB, 0.16994267E-09_JPRB, 0.16994203E-09_JPRB, 0.16993744E-09_JPRB, 0.16993268E-09_JPRB, 0.16992521E-09_JPRB, &
  & 0.16991880E-09_JPRB, 0.16991379E-09_JPRB, 0.16991464E-09_JPRB, 0.16991210E-09_JPRB, 0.16990846E-09_JPRB, 0.16990860E-09_JPRB, &
  & 0.16991010E-09_JPRB, 0.16991274E-09_JPRB, 0.16991464E-09_JPRB, 0.16991752E-09_JPRB, 0.16991872E-09_JPRB, 0.16992316E-09_JPRB, &
  & 0.16992885E-09_JPRB, 0.16993110E-09_JPRB, 0.16993365E-09_JPRB, 0.16993344E-09_JPRB, 0.16993325E-09_JPRB, 0.16993225E-09_JPRB, &
  & 0.16993033E-09_JPRB, 0.16992893E-09_JPRB, 0.16992796E-09_JPRB, 0.16992611E-09_JPRB, 0.16992560E-09_JPRB, 0.16992646E-09_JPRB, &
  & 0.16992990E-09_JPRB, 0.16993509E-09_JPRB, 0.16994112E-09_JPRB, 0.16994946E-09_JPRB, 0.16995402E-09_JPRB, 0.16996068E-09_JPRB, &
  & 0.16996540E-09_JPRB, 0.16996973E-09_JPRB, 0.16997095E-09_JPRB, 0.16997637E-09_JPRB, 0.16997546E-09_JPRB, 0.16997302E-09_JPRB, &
  & 0.16997298E-09_JPRB, 0.16997351E-09_JPRB, 0.16997287E-09_JPRB, 0.16997276E-09_JPRB, 0.16997148E-09_JPRB, 0.16996829E-09_JPRB, &
  & 0.16996586E-09_JPRB, 0.16996426E-09_JPRB, 0.16996163E-09_JPRB, 0.16996274E-09_JPRB /)

RGHG8(:,87,11) = (/ &
  & 0.16995298E-09_JPRB, 0.16995139E-09_JPRB, 0.16995239E-09_JPRB, 0.16995161E-09_JPRB, 0.16994892E-09_JPRB, 0.16994789E-09_JPRB, &
  & 0.16994708E-09_JPRB, 0.16994611E-09_JPRB, 0.16994617E-09_JPRB, 0.16994575E-09_JPRB, 0.16994504E-09_JPRB, 0.16994452E-09_JPRB, &
  & 0.16994384E-09_JPRB, 0.16994289E-09_JPRB, 0.16994203E-09_JPRB, 0.16993779E-09_JPRB, 0.16993314E-09_JPRB, 0.16992577E-09_JPRB, &
  & 0.16991952E-09_JPRB, 0.16991432E-09_JPRB, 0.16991519E-09_JPRB, 0.16991268E-09_JPRB, 0.16990889E-09_JPRB, 0.16990900E-09_JPRB, &
  & 0.16991057E-09_JPRB, 0.16991328E-09_JPRB, 0.16991512E-09_JPRB, 0.16991802E-09_JPRB, 0.16991908E-09_JPRB, 0.16992352E-09_JPRB, &
  & 0.16992932E-09_JPRB, 0.16993151E-09_JPRB, 0.16993407E-09_JPRB, 0.16993384E-09_JPRB, 0.16993364E-09_JPRB, 0.16993265E-09_JPRB, &
  & 0.16993075E-09_JPRB, 0.16992933E-09_JPRB, 0.16992843E-09_JPRB, 0.16992652E-09_JPRB, 0.16992592E-09_JPRB, 0.16992668E-09_JPRB, &
  & 0.16993038E-09_JPRB, 0.16993539E-09_JPRB, 0.16994149E-09_JPRB, 0.16994979E-09_JPRB, 0.16995422E-09_JPRB, 0.16996086E-09_JPRB, &
  & 0.16996554E-09_JPRB, 0.16996990E-09_JPRB, 0.16997109E-09_JPRB, 0.16997657E-09_JPRB, 0.16997563E-09_JPRB, 0.16997311E-09_JPRB, &
  & 0.16997311E-09_JPRB, 0.16997362E-09_JPRB, 0.16997298E-09_JPRB, 0.16997288E-09_JPRB, 0.16997163E-09_JPRB, 0.16996847E-09_JPRB, &
  & 0.16996603E-09_JPRB, 0.16996440E-09_JPRB, 0.16996177E-09_JPRB, 0.16996296E-09_JPRB /)

RGHG8(:,88,11) = (/ &
  & 0.16995304E-09_JPRB, 0.16995154E-09_JPRB, 0.16995255E-09_JPRB, 0.16995184E-09_JPRB, 0.16994892E-09_JPRB, 0.16994810E-09_JPRB, &
  & 0.16994703E-09_JPRB, 0.16994631E-09_JPRB, 0.16994628E-09_JPRB, 0.16994588E-09_JPRB, 0.16994514E-09_JPRB, 0.16994461E-09_JPRB, &
  & 0.16994392E-09_JPRB, 0.16994298E-09_JPRB, 0.16994202E-09_JPRB, 0.16993804E-09_JPRB, 0.16993335E-09_JPRB, 0.16992624E-09_JPRB, &
  & 0.16991977E-09_JPRB, 0.16991472E-09_JPRB, 0.16991554E-09_JPRB, 0.16991313E-09_JPRB, 0.16990910E-09_JPRB, 0.16990923E-09_JPRB, &
  & 0.16991084E-09_JPRB, 0.16991367E-09_JPRB, 0.16991537E-09_JPRB, 0.16991834E-09_JPRB, 0.16991925E-09_JPRB, 0.16992377E-09_JPRB, &
  & 0.16992964E-09_JPRB, 0.16993179E-09_JPRB, 0.16993433E-09_JPRB, 0.16993411E-09_JPRB, 0.16993390E-09_JPRB, 0.16993293E-09_JPRB, &
  & 0.16993099E-09_JPRB, 0.16992958E-09_JPRB, 0.16992871E-09_JPRB, 0.16992670E-09_JPRB, 0.16992610E-09_JPRB, 0.16992684E-09_JPRB, &
  & 0.16993056E-09_JPRB, 0.16993564E-09_JPRB, 0.16994166E-09_JPRB, 0.16994997E-09_JPRB, 0.16995430E-09_JPRB, 0.16996096E-09_JPRB, &
  & 0.16996560E-09_JPRB, 0.16997000E-09_JPRB, 0.16997118E-09_JPRB, 0.16997675E-09_JPRB, 0.16997571E-09_JPRB, 0.16997315E-09_JPRB, &
  & 0.16997317E-09_JPRB, 0.16997369E-09_JPRB, 0.16997309E-09_JPRB, 0.16997301E-09_JPRB, 0.16997172E-09_JPRB, 0.16996854E-09_JPRB, &
  & 0.16996611E-09_JPRB, 0.16996451E-09_JPRB, 0.16996188E-09_JPRB, 0.16996311E-09_JPRB /)

RGHG8(:,89,11) = (/ &
  & 0.16995305E-09_JPRB, 0.16995162E-09_JPRB, 0.16995266E-09_JPRB, 0.16995190E-09_JPRB, 0.16994912E-09_JPRB, 0.16994813E-09_JPRB, &
  & 0.16994735E-09_JPRB, 0.16994636E-09_JPRB, 0.16994642E-09_JPRB, 0.16994600E-09_JPRB, 0.16994524E-09_JPRB, 0.16994472E-09_JPRB, &
  & 0.16994406E-09_JPRB, 0.16994310E-09_JPRB, 0.16994231E-09_JPRB, 0.16993809E-09_JPRB, 0.16993350E-09_JPRB, 0.16992610E-09_JPRB, &
  & 0.16991988E-09_JPRB, 0.16991461E-09_JPRB, 0.16991571E-09_JPRB, 0.16991329E-09_JPRB, 0.16990918E-09_JPRB, 0.16990934E-09_JPRB, &
  & 0.16991097E-09_JPRB, 0.16991389E-09_JPRB, 0.16991553E-09_JPRB, 0.16991852E-09_JPRB, 0.16991934E-09_JPRB, 0.16992384E-09_JPRB, &
  & 0.16992982E-09_JPRB, 0.16993193E-09_JPRB, 0.16993455E-09_JPRB, 0.16993423E-09_JPRB, 0.16993403E-09_JPRB, 0.16993307E-09_JPRB, &
  & 0.16993111E-09_JPRB, 0.16992965E-09_JPRB, 0.16992888E-09_JPRB, 0.16992679E-09_JPRB, 0.16992618E-09_JPRB, 0.16992689E-09_JPRB, &
  & 0.16993071E-09_JPRB, 0.16993575E-09_JPRB, 0.16994176E-09_JPRB, 0.16995014E-09_JPRB, 0.16995436E-09_JPRB, 0.16996103E-09_JPRB, &
  & 0.16996562E-09_JPRB, 0.16997007E-09_JPRB, 0.16997120E-09_JPRB, 0.16997691E-09_JPRB, 0.16997581E-09_JPRB, 0.16997316E-09_JPRB, &
  & 0.16997322E-09_JPRB, 0.16997372E-09_JPRB, 0.16997315E-09_JPRB, 0.16997304E-09_JPRB, 0.16997179E-09_JPRB, 0.16996859E-09_JPRB, &
  & 0.16996618E-09_JPRB, 0.16996458E-09_JPRB, 0.16996188E-09_JPRB, 0.16996318E-09_JPRB /)

RGHG8(:,90,11) = (/ &
  & 0.16995302E-09_JPRB, 0.16995172E-09_JPRB, 0.16995277E-09_JPRB, 0.16995211E-09_JPRB, 0.16994907E-09_JPRB, 0.16994837E-09_JPRB, &
  & 0.16994736E-09_JPRB, 0.16994640E-09_JPRB, 0.16994671E-09_JPRB, 0.16994631E-09_JPRB, 0.16994535E-09_JPRB, 0.16994484E-09_JPRB, &
  & 0.16994420E-09_JPRB, 0.16994325E-09_JPRB, 0.16994287E-09_JPRB, 0.16993816E-09_JPRB, 0.16993357E-09_JPRB, 0.16992591E-09_JPRB, &
  & 0.16991952E-09_JPRB, 0.16991440E-09_JPRB, 0.16991586E-09_JPRB, 0.16991347E-09_JPRB, 0.16990913E-09_JPRB, 0.16990935E-09_JPRB, &
  & 0.16991102E-09_JPRB, 0.16991403E-09_JPRB, 0.16991558E-09_JPRB, 0.16991865E-09_JPRB, 0.16991925E-09_JPRB, 0.16992387E-09_JPRB, &
  & 0.16993001E-09_JPRB, 0.16993199E-09_JPRB, 0.16993473E-09_JPRB, 0.16993430E-09_JPRB, 0.16993414E-09_JPRB, 0.16993321E-09_JPRB, &
  & 0.16993118E-09_JPRB, 0.16992967E-09_JPRB, 0.16992899E-09_JPRB, 0.16992679E-09_JPRB, 0.16992614E-09_JPRB, 0.16992684E-09_JPRB, &
  & 0.16993071E-09_JPRB, 0.16993579E-09_JPRB, 0.16994171E-09_JPRB, 0.16995028E-09_JPRB, 0.16995434E-09_JPRB, 0.16996114E-09_JPRB, &
  & 0.16996569E-09_JPRB, 0.16997020E-09_JPRB, 0.16997113E-09_JPRB, 0.16997717E-09_JPRB, 0.16997588E-09_JPRB, 0.16997311E-09_JPRB, &
  & 0.16997320E-09_JPRB, 0.16997377E-09_JPRB, 0.16997317E-09_JPRB, 0.16997313E-09_JPRB, 0.16997187E-09_JPRB, 0.16996857E-09_JPRB, &
  & 0.16996615E-09_JPRB, 0.16996460E-09_JPRB, 0.16996185E-09_JPRB, 0.16996327E-09_JPRB /)

RGHG8(:,91,11) = (/ &
  & 0.16995295E-09_JPRB, 0.16995169E-09_JPRB, 0.16995290E-09_JPRB, 0.16995233E-09_JPRB, 0.16994901E-09_JPRB, 0.16994851E-09_JPRB, &
  & 0.16994772E-09_JPRB, 0.16994578E-09_JPRB, 0.16994736E-09_JPRB, 0.16994707E-09_JPRB, 0.16994499E-09_JPRB, 0.16994495E-09_JPRB, &
  & 0.16994432E-09_JPRB, 0.16994282E-09_JPRB, 0.16994443E-09_JPRB, 0.16993776E-09_JPRB, 0.16993391E-09_JPRB, 0.16992535E-09_JPRB, &
  & 0.16991923E-09_JPRB, 0.16991374E-09_JPRB, 0.16991614E-09_JPRB, 0.16991364E-09_JPRB, 0.16990885E-09_JPRB, 0.16990927E-09_JPRB, &
  & 0.16991096E-09_JPRB, 0.16991412E-09_JPRB, 0.16991551E-09_JPRB, 0.16991883E-09_JPRB, 0.16991900E-09_JPRB, 0.16992374E-09_JPRB, &
  & 0.16993033E-09_JPRB, 0.16993197E-09_JPRB, 0.16993504E-09_JPRB, 0.16993432E-09_JPRB, 0.16993422E-09_JPRB, 0.16993336E-09_JPRB, &
  & 0.16993111E-09_JPRB, 0.16992961E-09_JPRB, 0.16992910E-09_JPRB, 0.16992673E-09_JPRB, 0.16992606E-09_JPRB, 0.16992666E-09_JPRB, &
  & 0.16993064E-09_JPRB, 0.16993572E-09_JPRB, 0.16994159E-09_JPRB, 0.16995061E-09_JPRB, 0.16995418E-09_JPRB, 0.16996130E-09_JPRB, &
  & 0.16996572E-09_JPRB, 0.16997044E-09_JPRB, 0.16997080E-09_JPRB, 0.16997767E-09_JPRB, 0.16997598E-09_JPRB, 0.16997291E-09_JPRB, &
  & 0.16997322E-09_JPRB, 0.16997390E-09_JPRB, 0.16997315E-09_JPRB, 0.16997320E-09_JPRB, 0.16997198E-09_JPRB, 0.16996850E-09_JPRB, &
  & 0.16996607E-09_JPRB, 0.16996458E-09_JPRB, 0.16996166E-09_JPRB, 0.16996329E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART22',1,ZHOOK_HANDLE)
END SUBROUTINE PART22






SUBROUTINE PART23
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART23',0,ZHOOK_HANDLE)



!-- Month= 12 ------------

RGHG8(:, 1,12) = (/ &
  & 0.39569348E-10_JPRB, 0.39760771E-10_JPRB, 0.39794102E-10_JPRB, 0.39809229E-10_JPRB, 0.39814232E-10_JPRB, 0.39812247E-10_JPRB, &
  & 0.39805582E-10_JPRB, 0.39796739E-10_JPRB, 0.39789717E-10_JPRB, 0.39783732E-10_JPRB, 0.39780124E-10_JPRB, 0.39779600E-10_JPRB, &
  & 0.39784384E-10_JPRB, 0.39799303E-10_JPRB, 0.39823513E-10_JPRB, 0.39861697E-10_JPRB, 0.39912323E-10_JPRB, 0.39969108E-10_JPRB, &
  & 0.40030070E-10_JPRB, 0.40089179E-10_JPRB, 0.40140797E-10_JPRB, 0.40180564E-10_JPRB, 0.40210703E-10_JPRB, 0.40232821E-10_JPRB, &
  & 0.40249026E-10_JPRB, 0.40261416E-10_JPRB, 0.40270485E-10_JPRB, 0.40280407E-10_JPRB, 0.40290150E-10_JPRB, 0.40299947E-10_JPRB, &
  & 0.40310019E-10_JPRB, 0.40320362E-10_JPRB, 0.40328473E-10_JPRB, 0.40337140E-10_JPRB, 0.40346237E-10_JPRB, 0.40356590E-10_JPRB, &
  & 0.40368955E-10_JPRB, 0.40383346E-10_JPRB, 0.40397598E-10_JPRB, 0.40413593E-10_JPRB, 0.40429153E-10_JPRB, 0.40442441E-10_JPRB, &
  & 0.40450965E-10_JPRB, 0.40450875E-10_JPRB, 0.40441192E-10_JPRB, 0.40418065E-10_JPRB, 0.40377410E-10_JPRB, 0.40315421E-10_JPRB, &
  & 0.40232824E-10_JPRB, 0.40133449E-10_JPRB, 0.40025649E-10_JPRB, 0.39921393E-10_JPRB, 0.39830993E-10_JPRB, 0.39762180E-10_JPRB, &
  & 0.39716553E-10_JPRB, 0.39689786E-10_JPRB, 0.39675076E-10_JPRB, 0.39666832E-10_JPRB, 0.39661843E-10_JPRB, 0.39658499E-10_JPRB, &
  & 0.39656813E-10_JPRB, 0.39656511E-10_JPRB, 0.39658138E-10_JPRB, 0.39660161E-10_JPRB /)

RGHG8(:, 2,12) = (/ &
  & 0.39732068E-10_JPRB, 0.39891857E-10_JPRB, 0.39939354E-10_JPRB, 0.39977067E-10_JPRB, 0.39999691E-10_JPRB, 0.40017049E-10_JPRB, &
  & 0.40029442E-10_JPRB, 0.40039742E-10_JPRB, 0.40050921E-10_JPRB, 0.40066221E-10_JPRB, 0.40088328E-10_JPRB, 0.40121555E-10_JPRB, &
  & 0.40168768E-10_JPRB, 0.40238056E-10_JPRB, 0.40333095E-10_JPRB, 0.40459136E-10_JPRB, 0.40607212E-10_JPRB, 0.40761387E-10_JPRB, &
  & 0.40907819E-10_JPRB, 0.41033101E-10_JPRB, 0.41128798E-10_JPRB, 0.41192383E-10_JPRB, 0.41229593E-10_JPRB, 0.41246676E-10_JPRB, &
  & 0.41249955E-10_JPRB, 0.41244244E-10_JPRB, 0.41232032E-10_JPRB, 0.41217960E-10_JPRB, 0.41204450E-10_JPRB, 0.41192411E-10_JPRB, &
  & 0.41181735E-10_JPRB, 0.41171479E-10_JPRB, 0.41159656E-10_JPRB, 0.41148900E-10_JPRB, 0.41140563E-10_JPRB, 0.41137066E-10_JPRB, &
  & 0.41140504E-10_JPRB, 0.41151572E-10_JPRB, 0.41167677E-10_JPRB, 0.41184375E-10_JPRB, 0.41193493E-10_JPRB, 0.41188400E-10_JPRB, &
  & 0.41166050E-10_JPRB, 0.41125135E-10_JPRB, 0.41067531E-10_JPRB, 0.40996755E-10_JPRB, 0.40920385E-10_JPRB, 0.40848432E-10_JPRB, &
  & 0.40787436E-10_JPRB, 0.40731377E-10_JPRB, 0.40664305E-10_JPRB, 0.40574270E-10_JPRB, 0.40463438E-10_JPRB, 0.40346188E-10_JPRB, &
  & 0.40237091E-10_JPRB, 0.40145245E-10_JPRB, 0.40074454E-10_JPRB, 0.40024893E-10_JPRB, 0.39994126E-10_JPRB, 0.39978493E-10_JPRB, &
  & 0.39972241E-10_JPRB, 0.39971901E-10_JPRB, 0.39976397E-10_JPRB, 0.39984148E-10_JPRB /)

RGHG8(:, 3,12) = (/ &
  & 0.39709562E-10_JPRB, 0.39874500E-10_JPRB, 0.39957947E-10_JPRB, 0.40024924E-10_JPRB, 0.40078312E-10_JPRB, 0.40123203E-10_JPRB, &
  & 0.40162769E-10_JPRB, 0.40200614E-10_JPRB, 0.40239697E-10_JPRB, 0.40282382E-10_JPRB, 0.40338424E-10_JPRB, 0.40412191E-10_JPRB, &
  & 0.40518398E-10_JPRB, 0.40660756E-10_JPRB, 0.40840095E-10_JPRB, 0.41049258E-10_JPRB, 0.41274005E-10_JPRB, 0.41492251E-10_JPRB, &
  & 0.41692608E-10_JPRB, 0.41865636E-10_JPRB, 0.42003540E-10_JPRB, 0.42103029E-10_JPRB, 0.42169136E-10_JPRB, 0.42208823E-10_JPRB, &
  & 0.42229845E-10_JPRB, 0.42238796E-10_JPRB, 0.42239563E-10_JPRB, 0.42237484E-10_JPRB, 0.42234497E-10_JPRB, 0.42230736E-10_JPRB, &
  & 0.42224925E-10_JPRB, 0.42215689E-10_JPRB, 0.42201565E-10_JPRB, 0.42186470E-10_JPRB, 0.42174122E-10_JPRB, 0.42168567E-10_JPRB, &
  & 0.42172099E-10_JPRB, 0.42182733E-10_JPRB, 0.42192354E-10_JPRB, 0.42192180E-10_JPRB, 0.42173411E-10_JPRB, 0.42131899E-10_JPRB, &
  & 0.42068356E-10_JPRB, 0.41983816E-10_JPRB, 0.41881189E-10_JPRB, 0.41762090E-10_JPRB, 0.41628413E-10_JPRB, 0.41480971E-10_JPRB, &
  & 0.41319486E-10_JPRB, 0.41146340E-10_JPRB, 0.40974772E-10_JPRB, 0.40822842E-10_JPRB, 0.40694774E-10_JPRB, 0.40582558E-10_JPRB, &
  & 0.40482610E-10_JPRB, 0.40398788E-10_JPRB, 0.40334021E-10_JPRB, 0.40286718E-10_JPRB, 0.40253377E-10_JPRB, 0.40229160E-10_JPRB, &
  & 0.40213180E-10_JPRB, 0.40201162E-10_JPRB, 0.40194056E-10_JPRB, 0.40186868E-10_JPRB /)

RGHG8(:, 4,12) = (/ &
  & 0.39579534E-10_JPRB, 0.39743622E-10_JPRB, 0.39842889E-10_JPRB, 0.39922409E-10_JPRB, 0.39997353E-10_JPRB, 0.40069455E-10_JPRB, &
  & 0.40140304E-10_JPRB, 0.40211959E-10_JPRB, 0.40291857E-10_JPRB, 0.40385244E-10_JPRB, 0.40492026E-10_JPRB, 0.40629212E-10_JPRB, &
  & 0.40802209E-10_JPRB, 0.41018352E-10_JPRB, 0.41262483E-10_JPRB, 0.41524836E-10_JPRB, 0.41790953E-10_JPRB, 0.42050450E-10_JPRB, &
  & 0.42295823E-10_JPRB, 0.42517656E-10_JPRB, 0.42708864E-10_JPRB, 0.42862911E-10_JPRB, 0.42981674E-10_JPRB, 0.43068542E-10_JPRB, &
  & 0.43129396E-10_JPRB, 0.43171022E-10_JPRB, 0.43198587E-10_JPRB, 0.43218810E-10_JPRB, 0.43233524E-10_JPRB, 0.43242011E-10_JPRB, &
  & 0.43242514E-10_JPRB, 0.43233497E-10_JPRB, 0.43214283E-10_JPRB, 0.43191312E-10_JPRB, 0.43171196E-10_JPRB, 0.43159736E-10_JPRB, &
  & 0.43158515E-10_JPRB, 0.43162023E-10_JPRB, 0.43157138E-10_JPRB, 0.43129250E-10_JPRB, 0.43065100E-10_JPRB, 0.42962692E-10_JPRB, &
  & 0.42828928E-10_JPRB, 0.42672189E-10_JPRB, 0.42501568E-10_JPRB, 0.42325164E-10_JPRB, 0.42148562E-10_JPRB, 0.41971870E-10_JPRB, &
  & 0.41792438E-10_JPRB, 0.41611214E-10_JPRB, 0.41431414E-10_JPRB, 0.41250389E-10_JPRB, 0.41067448E-10_JPRB, 0.40894281E-10_JPRB, &
  & 0.40742014E-10_JPRB, 0.40614019E-10_JPRB, 0.40509141E-10_JPRB, 0.40426152E-10_JPRB, 0.40363671E-10_JPRB, 0.40319484E-10_JPRB, &
  & 0.40293189E-10_JPRB, 0.40275363E-10_JPRB, 0.40272924E-10_JPRB, 0.40278898E-10_JPRB /)

RGHG8(:, 5,12) = (/ &
  & 0.39399279E-10_JPRB, 0.39530976E-10_JPRB, 0.39609628E-10_JPRB, 0.39691306E-10_JPRB, 0.39776182E-10_JPRB, 0.39867297E-10_JPRB, &
  & 0.39967231E-10_JPRB, 0.40080550E-10_JPRB, 0.40213291E-10_JPRB, 0.40372820E-10_JPRB, 0.40569364E-10_JPRB, 0.40794937E-10_JPRB, &
  & 0.41051617E-10_JPRB, 0.41337590E-10_JPRB, 0.41644209E-10_JPRB, 0.41967305E-10_JPRB, 0.42296024E-10_JPRB, 0.42616997E-10_JPRB, &
  & 0.42925944E-10_JPRB, 0.43213454E-10_JPRB, 0.43468576E-10_JPRB, 0.43687005E-10_JPRB, 0.43869509E-10_JPRB, 0.44019878E-10_JPRB, &
  & 0.44143324E-10_JPRB, 0.44246645E-10_JPRB, 0.44334765E-10_JPRB, 0.44413691E-10_JPRB, 0.44483795E-10_JPRB, 0.44542176E-10_JPRB, &
  & 0.44587358E-10_JPRB, 0.44620148E-10_JPRB, 0.44643907E-10_JPRB, 0.44670760E-10_JPRB, 0.44713379E-10_JPRB, 0.44781730E-10_JPRB, &
  & 0.44874705E-10_JPRB, 0.44971946E-10_JPRB, 0.45030913E-10_JPRB, 0.45003733E-10_JPRB, 0.44859262E-10_JPRB, 0.44603297E-10_JPRB, &
  & 0.44272908E-10_JPRB, 0.43907704E-10_JPRB, 0.43544335E-10_JPRB, 0.43208201E-10_JPRB, 0.42908316E-10_JPRB, 0.42634785E-10_JPRB, &
  & 0.42374847E-10_JPRB, 0.42125491E-10_JPRB, 0.41885686E-10_JPRB, 0.41654791E-10_JPRB, 0.41435497E-10_JPRB, 0.41227376E-10_JPRB, &
  & 0.41030387E-10_JPRB, 0.40850247E-10_JPRB, 0.40694406E-10_JPRB, 0.40568035E-10_JPRB, 0.40476400E-10_JPRB, 0.40418190E-10_JPRB, &
  & 0.40391891E-10_JPRB, 0.40390552E-10_JPRB, 0.40418245E-10_JPRB, 0.40477142E-10_JPRB /)

RGHG8(:, 6,12) = (/ &
  & 0.39225154E-10_JPRB, 0.39308341E-10_JPRB, 0.39388000E-10_JPRB, 0.39465063E-10_JPRB, 0.39555009E-10_JPRB, 0.39664314E-10_JPRB, &
  & 0.39799171E-10_JPRB, 0.39963598E-10_JPRB, 0.40165780E-10_JPRB, 0.40398337E-10_JPRB, 0.40669926E-10_JPRB, 0.40984920E-10_JPRB, &
  & 0.41332097E-10_JPRB, 0.41699623E-10_JPRB, 0.42079486E-10_JPRB, 0.42473691E-10_JPRB, 0.42880831E-10_JPRB, 0.43285809E-10_JPRB, &
  & 0.43683328E-10_JPRB, 0.44067187E-10_JPRB, 0.44429387E-10_JPRB, 0.44760928E-10_JPRB, 0.45062159E-10_JPRB, 0.45329424E-10_JPRB, &
  & 0.45563678E-10_JPRB, 0.45769836E-10_JPRB, 0.45955434E-10_JPRB, 0.46131720E-10_JPRB, 0.46304280E-10_JPRB, 0.46473714E-10_JPRB, &
  & 0.46639151E-10_JPRB, 0.46799526E-10_JPRB, 0.46957334E-10_JPRB, 0.47123857E-10_JPRB, 0.47311075E-10_JPRB, 0.47523249E-10_JPRB, &
  & 0.47748541E-10_JPRB, 0.47943406E-10_JPRB, 0.48032661E-10_JPRB, 0.47938185E-10_JPRB, 0.47627475E-10_JPRB, 0.47146596E-10_JPRB, &
  & 0.46579431E-10_JPRB, 0.45996068E-10_JPRB, 0.45436252E-10_JPRB, 0.44911845E-10_JPRB, 0.44413494E-10_JPRB, 0.43929475E-10_JPRB, &
  & 0.43468062E-10_JPRB, 0.43040516E-10_JPRB, 0.42645908E-10_JPRB, 0.42283420E-10_JPRB, 0.41951071E-10_JPRB, 0.41648174E-10_JPRB, &
  & 0.41375948E-10_JPRB, 0.41136702E-10_JPRB, 0.40932986E-10_JPRB, 0.40773596E-10_JPRB, 0.40667622E-10_JPRB, 0.40616836E-10_JPRB, &
  & 0.40612100E-10_JPRB, 0.40640585E-10_JPRB, 0.40697522E-10_JPRB, 0.40827845E-10_JPRB /)

RGHG8(:, 7,12) = (/ &
  & 0.39170080E-10_JPRB, 0.39200424E-10_JPRB, 0.39242304E-10_JPRB, 0.39310426E-10_JPRB, 0.39409725E-10_JPRB, 0.39545055E-10_JPRB, &
  & 0.39723318E-10_JPRB, 0.39954869E-10_JPRB, 0.40248093E-10_JPRB, 0.40593591E-10_JPRB, 0.40974453E-10_JPRB, 0.41388740E-10_JPRB, &
  & 0.41841405E-10_JPRB, 0.42331277E-10_JPRB, 0.42843340E-10_JPRB, 0.43363653E-10_JPRB, 0.43883674E-10_JPRB, 0.44398686E-10_JPRB, &
  & 0.44903119E-10_JPRB, 0.45391597E-10_JPRB, 0.45861336E-10_JPRB, 0.46306917E-10_JPRB, 0.46725911E-10_JPRB, 0.47115471E-10_JPRB, &
  & 0.47471076E-10_JPRB, 0.47796430E-10_JPRB, 0.48100406E-10_JPRB, 0.48399687E-10_JPRB, 0.48705838E-10_JPRB, 0.49024847E-10_JPRB, &
  & 0.49357480E-10_JPRB, 0.49701247E-10_JPRB, 0.50050551E-10_JPRB, 0.50404521E-10_JPRB, 0.50756965E-10_JPRB, 0.51092908E-10_JPRB, &
  & 0.51381885E-10_JPRB, 0.51566324E-10_JPRB, 0.51555989E-10_JPRB, 0.51262872E-10_JPRB, 0.50673809E-10_JPRB, 0.49887990E-10_JPRB, &
  & 0.49050070E-10_JPRB, 0.48253249E-10_JPRB, 0.47528738E-10_JPRB, 0.46863041E-10_JPRB, 0.46228368E-10_JPRB, 0.45615425E-10_JPRB, &
  & 0.45021258E-10_JPRB, 0.44431812E-10_JPRB, 0.43850177E-10_JPRB, 0.43294333E-10_JPRB, 0.42780481E-10_JPRB, 0.42319231E-10_JPRB, &
  & 0.41918188E-10_JPRB, 0.41582637E-10_JPRB, 0.41319229E-10_JPRB, 0.41136119E-10_JPRB, 0.41037354E-10_JPRB, 0.41013783E-10_JPRB, &
  & 0.41042673E-10_JPRB, 0.41113949E-10_JPRB, 0.41226147E-10_JPRB, 0.41448667E-10_JPRB /)

RGHG8(:, 8,12) = (/ &
  & 0.39695754E-10_JPRB, 0.39581956E-10_JPRB, 0.39582830E-10_JPRB, 0.39642928E-10_JPRB, 0.39756892E-10_JPRB, 0.39926729E-10_JPRB, &
  & 0.40157683E-10_JPRB, 0.40458536E-10_JPRB, 0.40849855E-10_JPRB, 0.41317207E-10_JPRB, 0.41855370E-10_JPRB, 0.42449249E-10_JPRB, &
  & 0.43078256E-10_JPRB, 0.43738100E-10_JPRB, 0.44423951E-10_JPRB, 0.45131950E-10_JPRB, 0.45846014E-10_JPRB, 0.46553195E-10_JPRB, &
  & 0.47253170E-10_JPRB, 0.47936585E-10_JPRB, 0.48601227E-10_JPRB, 0.49236660E-10_JPRB, 0.49838040E-10_JPRB, 0.50391368E-10_JPRB, &
  & 0.50892353E-10_JPRB, 0.51336557E-10_JPRB, 0.51737437E-10_JPRB, 0.52119763E-10_JPRB, 0.52505857E-10_JPRB, 0.52909722E-10_JPRB, &
  & 0.53334833E-10_JPRB, 0.53770956E-10_JPRB, 0.54196279E-10_JPRB, 0.54587643E-10_JPRB, 0.54917647E-10_JPRB, 0.55158225E-10_JPRB, &
  & 0.55281533E-10_JPRB, 0.55245416E-10_JPRB, 0.54974372E-10_JPRB, 0.54384310E-10_JPRB, 0.53475044E-10_JPRB, 0.52398370E-10_JPRB, &
  & 0.51344852E-10_JPRB, 0.50403338E-10_JPRB, 0.49571465E-10_JPRB, 0.48810012E-10_JPRB, 0.48094854E-10_JPRB, 0.47407307E-10_JPRB, &
  & 0.46713529E-10_JPRB, 0.46002861E-10_JPRB, 0.45286941E-10_JPRB, 0.44579535E-10_JPRB, 0.43900251E-10_JPRB, 0.43278152E-10_JPRB, &
  & 0.42737369E-10_JPRB, 0.42301700E-10_JPRB, 0.41985308E-10_JPRB, 0.41797801E-10_JPRB, 0.41733068E-10_JPRB, 0.41765640E-10_JPRB, &
  & 0.41862597E-10_JPRB, 0.41995251E-10_JPRB, 0.42148257E-10_JPRB, 0.42404899E-10_JPRB /)

RGHG8(:, 9,12) = (/ &
  & 0.41569897E-10_JPRB, 0.41150527E-10_JPRB, 0.40994631E-10_JPRB, 0.40981021E-10_JPRB, 0.41069995E-10_JPRB, 0.41256252E-10_JPRB, &
  & 0.41540577E-10_JPRB, 0.41928693E-10_JPRB, 0.42435236E-10_JPRB, 0.43039294E-10_JPRB, 0.43731359E-10_JPRB, 0.44507193E-10_JPRB, &
  & 0.45357371E-10_JPRB, 0.46254559E-10_JPRB, 0.47180086E-10_JPRB, 0.48130583E-10_JPRB, 0.49107433E-10_JPRB, 0.50101229E-10_JPRB, &
  & 0.51116299E-10_JPRB, 0.52134283E-10_JPRB, 0.53140204E-10_JPRB, 0.54114144E-10_JPRB, 0.55026345E-10_JPRB, 0.55844201E-10_JPRB, &
  & 0.56544214E-10_JPRB, 0.57120714E-10_JPRB, 0.57588531E-10_JPRB, 0.57989110E-10_JPRB, 0.58358776E-10_JPRB, 0.58720764E-10_JPRB, &
  & 0.59076466E-10_JPRB, 0.59405723E-10_JPRB, 0.59673710E-10_JPRB, 0.59846267E-10_JPRB, 0.59897504E-10_JPRB, 0.59810108E-10_JPRB, &
  & 0.59566872E-10_JPRB, 0.59145952E-10_JPRB, 0.58492391E-10_JPRB, 0.57548216E-10_JPRB, 0.56314800E-10_JPRB, 0.54958683E-10_JPRB, &
  & 0.53687790E-10_JPRB, 0.52579580E-10_JPRB, 0.51614227E-10_JPRB, 0.50761347E-10_JPRB, 0.49983951E-10_JPRB, 0.49224975E-10_JPRB, &
  & 0.48456301E-10_JPRB, 0.47671013E-10_JPRB, 0.46861258E-10_JPRB, 0.46041362E-10_JPRB, 0.45246879E-10_JPRB, 0.44515801E-10_JPRB, &
  & 0.43891626E-10_JPRB, 0.43410595E-10_JPRB, 0.43097432E-10_JPRB, 0.42954709E-10_JPRB, 0.42959272E-10_JPRB, 0.43066484E-10_JPRB, &
  & 0.43228313E-10_JPRB, 0.43400745E-10_JPRB, 0.43606035E-10_JPRB, 0.43876073E-10_JPRB /)

RGHG8(:,10,12) = (/ &
  & 0.45659688E-10_JPRB, 0.44644979E-10_JPRB, 0.44169758E-10_JPRB, 0.43991796E-10_JPRB, 0.43980371E-10_JPRB, 0.44117487E-10_JPRB, &
  & 0.44401680E-10_JPRB, 0.44840374E-10_JPRB, 0.45452128E-10_JPRB, 0.46209498E-10_JPRB, 0.47093798E-10_JPRB, 0.48100531E-10_JPRB, &
  & 0.49214671E-10_JPRB, 0.50429189E-10_JPRB, 0.51723327E-10_JPRB, 0.53086376E-10_JPRB, 0.54507260E-10_JPRB, 0.55964046E-10_JPRB, &
  & 0.57455637E-10_JPRB, 0.58961051E-10_JPRB, 0.60443733E-10_JPRB, 0.61852336E-10_JPRB, 0.63155196E-10_JPRB, 0.64285334E-10_JPRB, &
  & 0.65203218E-10_JPRB, 0.65897343E-10_JPRB, 0.66376425E-10_JPRB, 0.66687232E-10_JPRB, 0.66870454E-10_JPRB, 0.66954643E-10_JPRB, &
  & 0.66945421E-10_JPRB, 0.66823817E-10_JPRB, 0.66560653E-10_JPRB, 0.66136541E-10_JPRB, 0.65554423E-10_JPRB, 0.64853470E-10_JPRB, &
  & 0.64063713E-10_JPRB, 0.63172377E-10_JPRB, 0.62160395E-10_JPRB, 0.60959640E-10_JPRB, 0.59533413E-10_JPRB, 0.57971059E-10_JPRB, &
  & 0.56480827E-10_JPRB, 0.55186414E-10_JPRB, 0.54107316E-10_JPRB, 0.53177039E-10_JPRB, 0.52309289E-10_JPRB, 0.51459559E-10_JPRB, &
  & 0.50604063E-10_JPRB, 0.49715919E-10_JPRB, 0.48800367E-10_JPRB, 0.47886653E-10_JPRB, 0.47012796E-10_JPRB, 0.46232670E-10_JPRB, &
  & 0.45600222E-10_JPRB, 0.45156559E-10_JPRB, 0.44914628E-10_JPRB, 0.44855543E-10_JPRB, 0.44933106E-10_JPRB, 0.45088506E-10_JPRB, &
  & 0.45263605E-10_JPRB, 0.45443687E-10_JPRB, 0.45586038E-10_JPRB, 0.45794386E-10_JPRB /)

RGHG8(:,11,12) = (/ &
  & 0.51970851E-10_JPRB, 0.50297731E-10_JPRB, 0.49474435E-10_JPRB, 0.49088931E-10_JPRB, 0.48936161E-10_JPRB, 0.48983650E-10_JPRB, &
  & 0.49228222E-10_JPRB, 0.49682935E-10_JPRB, 0.50376283E-10_JPRB, 0.51276067E-10_JPRB, 0.52359610E-10_JPRB, 0.53616746E-10_JPRB, &
  & 0.55037180E-10_JPRB, 0.56607687E-10_JPRB, 0.58307144E-10_JPRB, 0.60117994E-10_JPRB, 0.62033177E-10_JPRB, 0.64020622E-10_JPRB, &
  & 0.66049687E-10_JPRB, 0.68080860E-10_JPRB, 0.70069422E-10_JPRB, 0.71929226E-10_JPRB, 0.73591244E-10_JPRB, 0.75010234E-10_JPRB, &
  & 0.76106330E-10_JPRB, 0.76859713E-10_JPRB, 0.77271203E-10_JPRB, 0.77361985E-10_JPRB, 0.77172359E-10_JPRB, 0.76728651E-10_JPRB, &
  & 0.76058528E-10_JPRB, 0.75174554E-10_JPRB, 0.74091726E-10_JPRB, 0.72852446E-10_JPRB, 0.71530865E-10_JPRB, 0.70190583E-10_JPRB, &
  & 0.68901350E-10_JPRB, 0.67658074E-10_JPRB, 0.66366884E-10_JPRB, 0.64999638E-10_JPRB, 0.63534865E-10_JPRB, 0.62024337E-10_JPRB, &
  & 0.60570278E-10_JPRB, 0.59262657E-10_JPRB, 0.58078903E-10_JPRB, 0.56983654E-10_JPRB, 0.55946782E-10_JPRB, 0.54930199E-10_JPRB, &
  & 0.53891721E-10_JPRB, 0.52826216E-10_JPRB, 0.51753747E-10_JPRB, 0.50706783E-10_JPRB, 0.49741052E-10_JPRB, 0.48923813E-10_JPRB, &
  & 0.48305460E-10_JPRB, 0.47910301E-10_JPRB, 0.47722701E-10_JPRB, 0.47698661E-10_JPRB, 0.47781546E-10_JPRB, 0.47914520E-10_JPRB, &
  & 0.48058897E-10_JPRB, 0.48173420E-10_JPRB, 0.48295284E-10_JPRB, 0.48407337E-10_JPRB /)

RGHG8(:,12,12) = (/ &
  & 0.59398771E-10_JPRB, 0.57363579E-10_JPRB, 0.56429313E-10_JPRB, 0.55942074E-10_JPRB, 0.55717583E-10_JPRB, 0.55714579E-10_JPRB, &
  & 0.55932502E-10_JPRB, 0.56392235E-10_JPRB, 0.57138995E-10_JPRB, 0.58156934E-10_JPRB, 0.59427588E-10_JPRB, 0.60930719E-10_JPRB, &
  & 0.62643564E-10_JPRB, 0.64556770E-10_JPRB, 0.66661558E-10_JPRB, 0.68928661E-10_JPRB, 0.71321303E-10_JPRB, 0.73797767E-10_JPRB, &
  & 0.76299071E-10_JPRB, 0.78755467E-10_JPRB, 0.81113824E-10_JPRB, 0.83293081E-10_JPRB, 0.85183957E-10_JPRB, 0.86745590E-10_JPRB, &
  & 0.87908583E-10_JPRB, 0.88604755E-10_JPRB, 0.88833309E-10_JPRB, 0.88577021E-10_JPRB, 0.87870072E-10_JPRB, 0.86747831E-10_JPRB, &
  & 0.85266912E-10_JPRB, 0.83503308E-10_JPRB, 0.81547505E-10_JPRB, 0.79523985E-10_JPRB, 0.77572088E-10_JPRB, 0.75825991E-10_JPRB, &
  & 0.74280040E-10_JPRB, 0.72925430E-10_JPRB, 0.71749530E-10_JPRB, 0.70645337E-10_JPRB, 0.69556472E-10_JPRB, 0.68433238E-10_JPRB, &
  & 0.67260440E-10_JPRB, 0.66042449E-10_JPRB, 0.64811587E-10_JPRB, 0.63562669E-10_JPRB, 0.62270453E-10_JPRB, 0.60920956E-10_JPRB, &
  & 0.59517891E-10_JPRB, 0.58089721E-10_JPRB, 0.56671477E-10_JPRB, 0.55320783E-10_JPRB, 0.54117689E-10_JPRB, 0.53124422E-10_JPRB, &
  & 0.52382862E-10_JPRB, 0.51890593E-10_JPRB, 0.51611666E-10_JPRB, 0.51491610E-10_JPRB, 0.51474831E-10_JPRB, 0.51510150E-10_JPRB, &
  & 0.51554459E-10_JPRB, 0.51586492E-10_JPRB, 0.51582856E-10_JPRB, 0.51466876E-10_JPRB /)

RGHG8(:,13,12) = (/ &
  & 0.67113169E-10_JPRB, 0.65025325E-10_JPRB, 0.64183388E-10_JPRB, 0.63749811E-10_JPRB, 0.63594789E-10_JPRB, 0.63677646E-10_JPRB, &
  & 0.63989383E-10_JPRB, 0.64549886E-10_JPRB, 0.65403717E-10_JPRB, 0.66547906E-10_JPRB, 0.67979268E-10_JPRB, 0.69700329E-10_JPRB, &
  & 0.71686525E-10_JPRB, 0.73903585E-10_JPRB, 0.76320394E-10_JPRB, 0.78911620E-10_JPRB, 0.81631375E-10_JPRB, 0.84417799E-10_JPRB, &
  & 0.87197985E-10_JPRB, 0.89876044E-10_JPRB, 0.92383406E-10_JPRB, 0.94660425E-10_JPRB, 0.96588959E-10_JPRB, 0.98114593E-10_JPRB, &
  & 0.99184112E-10_JPRB, 0.99697778E-10_JPRB, 0.99637493E-10_JPRB, 0.98967834E-10_JPRB, 0.97708980E-10_JPRB, 0.95927974E-10_JPRB, &
  & 0.93734034E-10_JPRB, 0.91258966E-10_JPRB, 0.88688945E-10_JPRB, 0.86223292E-10_JPRB, 0.84069869E-10_JPRB, 0.82289266E-10_JPRB, &
  & 0.80959899E-10_JPRB, 0.79957006E-10_JPRB, 0.79144115E-10_JPRB, 0.78481013E-10_JPRB, 0.77901408E-10_JPRB, 0.77333848E-10_JPRB, &
  & 0.76691778E-10_JPRB, 0.75872253E-10_JPRB, 0.74813128E-10_JPRB, 0.73509386E-10_JPRB, 0.71980630E-10_JPRB, 0.70263059E-10_JPRB, &
  & 0.68385318E-10_JPRB, 0.66408344E-10_JPRB, 0.64407639E-10_JPRB, 0.62493996E-10_JPRB, 0.60765289E-10_JPRB, 0.59314581E-10_JPRB, &
  & 0.58181168E-10_JPRB, 0.57361088E-10_JPRB, 0.56805130E-10_JPRB, 0.56452586E-10_JPRB, 0.56241845E-10_JPRB, 0.56119685E-10_JPRB, &
  & 0.56039347E-10_JPRB, 0.55973316E-10_JPRB, 0.55874638E-10_JPRB, 0.55692725E-10_JPRB /)

RGHG8(:,14,12) = (/ &
  & 0.74477979E-10_JPRB, 0.72696522E-10_JPRB, 0.72051233E-10_JPRB, 0.71824921E-10_JPRB, 0.71886837E-10_JPRB, 0.72186826E-10_JPRB, &
  & 0.72713002E-10_JPRB, 0.73482803E-10_JPRB, 0.74542393E-10_JPRB, 0.75881530E-10_JPRB, 0.77497189E-10_JPRB, 0.79385769E-10_JPRB, &
  & 0.81541780E-10_JPRB, 0.83938918E-10_JPRB, 0.86532059E-10_JPRB, 0.89272492E-10_JPRB, 0.92106323E-10_JPRB, 0.94973793E-10_JPRB, &
  & 0.97796132E-10_JPRB, 0.10046763E-09_JPRB, 0.10291404E-09_JPRB, 0.10508418E-09_JPRB, 0.10686736E-09_JPRB, 0.10821036E-09_JPRB, &
  & 0.10905758E-09_JPRB, 0.10930380E-09_JPRB, 0.10891495E-09_JPRB, 0.10785413E-09_JPRB, 0.10614813E-09_JPRB, 0.10388523E-09_JPRB, &
  & 0.10121683E-09_JPRB, 0.98381997E-10_JPRB, 0.95616209E-10_JPRB, 0.93167037E-10_JPRB, 0.91222981E-10_JPRB, 0.89937169E-10_JPRB, &
  & 0.89069682E-10_JPRB, 0.88527324E-10_JPRB, 0.88229146E-10_JPRB, 0.88062807E-10_JPRB, 0.87944881E-10_JPRB, 0.87788415E-10_JPRB, &
  & 0.87490855E-10_JPRB, 0.86951744E-10_JPRB, 0.86098358E-10_JPRB, 0.84901641E-10_JPRB, 0.83364517E-10_JPRB, 0.81518153E-10_JPRB, &
  & 0.79397766E-10_JPRB, 0.77077345E-10_JPRB, 0.74648253E-10_JPRB, 0.72223769E-10_JPRB, 0.69936071E-10_JPRB, 0.67903641E-10_JPRB, &
  & 0.66202988E-10_JPRB, 0.64851680E-10_JPRB, 0.63819713E-10_JPRB, 0.63050211E-10_JPRB, 0.62487009E-10_JPRB, 0.62076524E-10_JPRB, &
  & 0.61769076E-10_JPRB, 0.61510387E-10_JPRB, 0.61243552E-10_JPRB, 0.60724689E-10_JPRB /)

RGHG8(:,15,12) = (/ &
  & 0.81294776E-10_JPRB, 0.80013808E-10_JPRB, 0.79722076E-10_JPRB, 0.79818173E-10_JPRB, 0.80179856E-10_JPRB, 0.80762994E-10_JPRB, &
  & 0.81554749E-10_JPRB, 0.82571845E-10_JPRB, 0.83854410E-10_JPRB, 0.85402511E-10_JPRB, 0.87205215E-10_JPRB, 0.89246187E-10_JPRB, &
  & 0.91505178E-10_JPRB, 0.93960326E-10_JPRB, 0.96578683E-10_JPRB, 0.99307777E-10_JPRB, 0.10208277E-09_JPRB, 0.10484395E-09_JPRB, &
  & 0.10752049E-09_JPRB, 0.11000684E-09_JPRB, 0.11224233E-09_JPRB, 0.11417314E-09_JPRB, 0.11569468E-09_JPRB, 0.11677062E-09_JPRB, &
  & 0.11733084E-09_JPRB, 0.11728551E-09_JPRB, 0.11659564E-09_JPRB, 0.11523548E-09_JPRB, 0.11324250E-09_JPRB, 0.11075485E-09_JPRB, &
  & 0.10797259E-09_JPRB, 0.10516205E-09_JPRB, 0.10258962E-09_JPRB, 0.10060241E-09_JPRB, 0.99283519E-10_JPRB, 0.98508174E-10_JPRB, &
  & 0.98263404E-10_JPRB, 0.98302061E-10_JPRB, 0.98448624E-10_JPRB, 0.98617808E-10_JPRB, 0.98736172E-10_JPRB, 0.98724015E-10_JPRB, &
  & 0.98511269E-10_JPRB, 0.98038584E-10_JPRB, 0.97261955E-10_JPRB, 0.96155278E-10_JPRB, 0.94701552E-10_JPRB, 0.92893165E-10_JPRB, &
  & 0.90753807E-10_JPRB, 0.88333486E-10_JPRB, 0.85720216E-10_JPRB, 0.83029604E-10_JPRB, 0.80384525E-10_JPRB, 0.77912864E-10_JPRB, &
  & 0.75709647E-10_JPRB, 0.73829359E-10_JPRB, 0.72276338E-10_JPRB, 0.71023992E-10_JPRB, 0.70033215E-10_JPRB, 0.69257378E-10_JPRB, &
  & 0.68669230E-10_JPRB, 0.68162503E-10_JPRB, 0.67695329E-10_JPRB, 0.66840658E-10_JPRB /)

RGHG8(:,16,12) = (/ &
  & 0.87647896E-10_JPRB, 0.87036239E-10_JPRB, 0.87135188E-10_JPRB, 0.87525279E-10_JPRB, 0.88147024E-10_JPRB, 0.88977402E-10_JPRB, &
  & 0.90010499E-10_JPRB, 0.91264094E-10_JPRB, 0.92770021E-10_JPRB, 0.94515097E-10_JPRB, 0.96484425E-10_JPRB, 0.98648770E-10_JPRB, &
  & 0.10097585E-09_JPRB, 0.10343215E-09_JPRB, 0.10598435E-09_JPRB, 0.10859224E-09_JPRB, 0.11119772E-09_JPRB, 0.11374685E-09_JPRB, &
  & 0.11617327E-09_JPRB, 0.11838042E-09_JPRB, 0.12032901E-09_JPRB, 0.12195368E-09_JPRB, 0.12316805E-09_JPRB, 0.12394465E-09_JPRB, &
  & 0.12421050E-09_JPRB, 0.12389847E-09_JPRB, 0.12297915E-09_JPRB, 0.12145192E-09_JPRB, 0.11939595E-09_JPRB, 0.11696301E-09_JPRB, &
  & 0.11440475E-09_JPRB, 0.11198011E-09_JPRB, 0.11003088E-09_JPRB, 0.10862925E-09_JPRB, 0.10794374E-09_JPRB, 0.10791253E-09_JPRB, &
  & 0.10821277E-09_JPRB, 0.10865573E-09_JPRB, 0.10909077E-09_JPRB, 0.10941448E-09_JPRB, 0.10956493E-09_JPRB, 0.10950377E-09_JPRB, &
  & 0.10920365E-09_JPRB, 0.10865336E-09_JPRB, 0.10784600E-09_JPRB, 0.10676320E-09_JPRB, 0.10538116E-09_JPRB, 0.10367682E-09_JPRB, &
  & 0.10164256E-09_JPRB, 0.99307375E-10_JPRB, 0.96737396E-10_JPRB, 0.94019181E-10_JPRB, 0.91258980E-10_JPRB, 0.88571754E-10_JPRB, &
  & 0.86062955E-10_JPRB, 0.83817141E-10_JPRB, 0.81872079E-10_JPRB, 0.80230489E-10_JPRB, 0.78877502E-10_JPRB, 0.77789178E-10_JPRB, &
  & 0.76897905E-10_JPRB, 0.76205070E-10_JPRB, 0.75422696E-10_JPRB, 0.74287840E-10_JPRB /)

RGHG8(:,17,12) = (/ &
  & 0.93515022E-10_JPRB, 0.93556038E-10_JPRB, 0.93955323E-10_JPRB, 0.94601618E-10_JPRB, 0.95468321E-10_JPRB, 0.96534690E-10_JPRB, &
  & 0.97797888E-10_JPRB, 0.99266879E-10_JPRB, 0.10097215E-09_JPRB, 0.10289155E-09_JPRB, 0.10499393E-09_JPRB, 0.10723886E-09_JPRB, &
  & 0.10958624E-09_JPRB, 0.11200074E-09_JPRB, 0.11444611E-09_JPRB, 0.11688772E-09_JPRB, 0.11928099E-09_JPRB, 0.12158183E-09_JPRB, &
  & 0.12372779E-09_JPRB, 0.12563692E-09_JPRB, 0.12727891E-09_JPRB, 0.12858802E-09_JPRB, 0.12949664E-09_JPRB, 0.12997858E-09_JPRB, &
  & 0.12997811E-09_JPRB, 0.12945894E-09_JPRB, 0.12842015E-09_JPRB, 0.12690278E-09_JPRB, 0.12500023E-09_JPRB, 0.12290213E-09_JPRB, &
  & 0.12084755E-09_JPRB, 0.11905964E-09_JPRB, 0.11775043E-09_JPRB, 0.11713411E-09_JPRB, 0.11710657E-09_JPRB, 0.11752918E-09_JPRB, &
  & 0.11821061E-09_JPRB, 0.11890412E-09_JPRB, 0.11944024E-09_JPRB, 0.11974287E-09_JPRB, 0.11978744E-09_JPRB, 0.11956758E-09_JPRB, &
  & 0.11910420E-09_JPRB, 0.11842088E-09_JPRB, 0.11752774E-09_JPRB, 0.11642265E-09_JPRB, 0.11508353E-09_JPRB, 0.11347941E-09_JPRB, &
  & 0.11158990E-09_JPRB, 0.10942543E-09_JPRB, 0.10702846E-09_JPRB, 0.10446136E-09_JPRB, 0.10179733E-09_JPRB, 0.99129920E-10_JPRB, &
  & 0.96564694E-10_JPRB, 0.94188601E-10_JPRB, 0.92064530E-10_JPRB, 0.90215176E-10_JPRB, 0.88642878E-10_JPRB, 0.87337741E-10_JPRB, &
  & 0.86292661E-10_JPRB, 0.85374596E-10_JPRB, 0.84530057E-10_JPRB, 0.82957578E-10_JPRB /)

RGHG8(:,18,12) = (/ &
  & 0.99061245E-10_JPRB, 0.99518289E-10_JPRB, 0.10018894E-09_JPRB, 0.10105952E-09_JPRB, 0.10212586E-09_JPRB, 0.10338176E-09_JPRB, &
  & 0.10481761E-09_JPRB, 0.10645036E-09_JPRB, 0.10828837E-09_JPRB, 0.11031357E-09_JPRB, 0.11248828E-09_JPRB, 0.11476207E-09_JPRB, &
  & 0.11708938E-09_JPRB, 0.11943295E-09_JPRB, 0.12175710E-09_JPRB, 0.12403044E-09_JPRB, 0.12622015E-09_JPRB, 0.12828899E-09_JPRB, &
  & 0.13018066E-09_JPRB, 0.13182683E-09_JPRB, 0.13318978E-09_JPRB, 0.13421812E-09_JPRB, 0.13485851E-09_JPRB, 0.13508709E-09_JPRB, &
  & 0.13488055E-09_JPRB, 0.13423536E-09_JPRB, 0.13318546E-09_JPRB, 0.13181400E-09_JPRB, 0.13026735E-09_JPRB, 0.12871242E-09_JPRB, &
  & 0.12729157E-09_JPRB, 0.12627857E-09_JPRB, 0.12572962E-09_JPRB, 0.12565210E-09_JPRB, 0.12605457E-09_JPRB, 0.12677442E-09_JPRB, &
  & 0.12759195E-09_JPRB, 0.12830083E-09_JPRB, 0.12876124E-09_JPRB, 0.12892923E-09_JPRB, 0.12879484E-09_JPRB, 0.12839460E-09_JPRB, &
  & 0.12777197E-09_JPRB, 0.12696222E-09_JPRB, 0.12599261E-09_JPRB, 0.12486352E-09_JPRB, 0.12355900E-09_JPRB, 0.12204769E-09_JPRB, &
  & 0.12030776E-09_JPRB, 0.11834250E-09_JPRB, 0.11617028E-09_JPRB, 0.11382131E-09_JPRB, 0.11135221E-09_JPRB, 0.10884007E-09_JPRB, &
  & 0.10637309E-09_JPRB, 0.10404642E-09_JPRB, 0.10192373E-09_JPRB, 0.10003812E-09_JPRB, 0.98407046E-10_JPRB, 0.97031695E-10_JPRB, &
  & 0.95907740E-10_JPRB, 0.94960491E-10_JPRB, 0.94010744E-10_JPRB, 0.92386002E-10_JPRB /)

RGHG8(:,19,12) = (/ &
  & 0.10409935E-09_JPRB, 0.10502801E-09_JPRB, 0.10590274E-09_JPRB, 0.10691496E-09_JPRB, 0.10810267E-09_JPRB, 0.10946510E-09_JPRB, &
  & 0.11100772E-09_JPRB, 0.11272456E-09_JPRB, 0.11463032E-09_JPRB, 0.11669619E-09_JPRB, 0.11888188E-09_JPRB, 0.12113686E-09_JPRB, &
  & 0.12341056E-09_JPRB, 0.12566924E-09_JPRB, 0.12787760E-09_JPRB, 0.13000269E-09_JPRB, 0.13201858E-09_JPRB, 0.13389582E-09_JPRB, &
  & 0.13558436E-09_JPRB, 0.13702492E-09_JPRB, 0.13817131E-09_JPRB, 0.13898152E-09_JPRB, 0.13941910E-09_JPRB, 0.13946694E-09_JPRB, &
  & 0.13913609E-09_JPRB, 0.13846288E-09_JPRB, 0.13752680E-09_JPRB, 0.13644819E-09_JPRB, 0.13534819E-09_JPRB, 0.13436983E-09_JPRB, &
  & 0.13368963E-09_JPRB, 0.13331500E-09_JPRB, 0.13332631E-09_JPRB, 0.13368970E-09_JPRB, 0.13430387E-09_JPRB, 0.13505058E-09_JPRB, &
  & 0.13577565E-09_JPRB, 0.13632329E-09_JPRB, 0.13660260E-09_JPRB, 0.13659347E-09_JPRB, 0.13630332E-09_JPRB, 0.13576537E-09_JPRB, &
  & 0.13503657E-09_JPRB, 0.13415635E-09_JPRB, 0.13314887E-09_JPRB, 0.13202386E-09_JPRB, 0.13076781E-09_JPRB, 0.12935675E-09_JPRB, &
  & 0.12777426E-09_JPRB, 0.12601008E-09_JPRB, 0.12406304E-09_JPRB, 0.12196053E-09_JPRB, 0.11974198E-09_JPRB, 0.11746196E-09_JPRB, &
  & 0.11520187E-09_JPRB, 0.11304410E-09_JPRB, 0.11105057E-09_JPRB, 0.10925897E-09_JPRB, 0.10768769E-09_JPRB, 0.10635571E-09_JPRB, &
  & 0.10523879E-09_JPRB, 0.10433845E-09_JPRB, 0.10335914E-09_JPRB, 0.10187667E-09_JPRB /)

RGHG8(:,20,12) = (/ &
  & 0.10890314E-09_JPRB, 0.11005052E-09_JPRB, 0.11102781E-09_JPRB, 0.11211249E-09_JPRB, 0.11335718E-09_JPRB, 0.11477681E-09_JPRB, &
  & 0.11635813E-09_JPRB, 0.11810984E-09_JPRB, 0.12002201E-09_JPRB, 0.12207096E-09_JPRB, 0.12422299E-09_JPRB, 0.12642269E-09_JPRB, &
  & 0.12862192E-09_JPRB, 0.13078329E-09_JPRB, 0.13288369E-09_JPRB, 0.13489011E-09_JPRB, 0.13677107E-09_JPRB, 0.13850085E-09_JPRB, &
  & 0.14004164E-09_JPRB, 0.14133938E-09_JPRB, 0.14234340E-09_JPRB, 0.14301381E-09_JPRB, 0.14332821E-09_JPRB, 0.14328774E-09_JPRB, &
  & 0.14292977E-09_JPRB, 0.14233062E-09_JPRB, 0.14160018E-09_JPRB, 0.14084811E-09_JPRB, 0.14021961E-09_JPRB, 0.13981771E-09_JPRB, &
  & 0.13967080E-09_JPRB, 0.13981517E-09_JPRB, 0.14017976E-09_JPRB, 0.14071069E-09_JPRB, 0.14133204E-09_JPRB, 0.14194734E-09_JPRB, &
  & 0.14248422E-09_JPRB, 0.14284218E-09_JPRB, 0.14294892E-09_JPRB, 0.14276857E-09_JPRB, 0.14236183E-09_JPRB, 0.14174631E-09_JPRB, &
  & 0.14097433E-09_JPRB, 0.14007599E-09_JPRB, 0.13907314E-09_JPRB, 0.13798035E-09_JPRB, 0.13678995E-09_JPRB, 0.13549054E-09_JPRB, &
  & 0.13406143E-09_JPRB, 0.13248810E-09_JPRB, 0.13077299E-09_JPRB, 0.12893397E-09_JPRB, 0.12699292E-09_JPRB, 0.12499446E-09_JPRB, &
  & 0.12300418E-09_JPRB, 0.12108911E-09_JPRB, 0.11930693E-09_JPRB, 0.11768912E-09_JPRB, 0.11626195E-09_JPRB, 0.11503568E-09_JPRB, &
  & 0.11404012E-09_JPRB, 0.11313879E-09_JPRB, 0.11234926E-09_JPRB, 0.11074806E-09_JPRB /)

RGHG8(:,21,12) = (/ &
  & 0.11325936E-09_JPRB, 0.11457370E-09_JPRB, 0.11560238E-09_JPRB, 0.11670956E-09_JPRB, 0.11796644E-09_JPRB, 0.11938407E-09_JPRB, &
  & 0.12096478E-09_JPRB, 0.12268987E-09_JPRB, 0.12456162E-09_JPRB, 0.12655672E-09_JPRB, 0.12863507E-09_JPRB, 0.13075567E-09_JPRB, &
  & 0.13286969E-09_JPRB, 0.13493680E-09_JPRB, 0.13693476E-09_JPRB, 0.13884262E-09_JPRB, 0.14063020E-09_JPRB, 0.14226226E-09_JPRB, &
  & 0.14370509E-09_JPRB, 0.14491537E-09_JPRB, 0.14584621E-09_JPRB, 0.14645946E-09_JPRB, 0.14673922E-09_JPRB, 0.14670358E-09_JPRB, &
  & 0.14640969E-09_JPRB, 0.14595203E-09_JPRB, 0.14544541E-09_JPRB, 0.14501855E-09_JPRB, 0.14478395E-09_JPRB, 0.14478307E-09_JPRB, &
  & 0.14501328E-09_JPRB, 0.14540937E-09_JPRB, 0.14591499E-09_JPRB, 0.14645610E-09_JPRB, 0.14696640E-09_JPRB, 0.14741057E-09_JPRB, &
  & 0.14773477E-09_JPRB, 0.14788371E-09_JPRB, 0.14784818E-09_JPRB, 0.14759452E-09_JPRB, 0.14713782E-09_JPRB, 0.14650822E-09_JPRB, &
  & 0.14574440E-09_JPRB, 0.14487167E-09_JPRB, 0.14391291E-09_JPRB, 0.14287319E-09_JPRB, 0.14176457E-09_JPRB, 0.14057602E-09_JPRB, &
  & 0.13929422E-09_JPRB, 0.13791099E-09_JPRB, 0.13642884E-09_JPRB, 0.13485288E-09_JPRB, 0.13319737E-09_JPRB, 0.13149648E-09_JPRB, &
  & 0.12979448E-09_JPRB, 0.12814771E-09_JPRB, 0.12660073E-09_JPRB, 0.12518733E-09_JPRB, 0.12393037E-09_JPRB, 0.12284940E-09_JPRB, &
  & 0.12192215E-09_JPRB, 0.12117979E-09_JPRB, 0.12029973E-09_JPRB, 0.11902898E-09_JPRB /)

RGHG8(:,22,12) = (/ &
  & 0.11727386E-09_JPRB, 0.11866159E-09_JPRB, 0.11970031E-09_JPRB, 0.12079444E-09_JPRB, 0.12202153E-09_JPRB, 0.12340422E-09_JPRB, &
  & 0.12492948E-09_JPRB, 0.12659568E-09_JPRB, 0.12839019E-09_JPRB, 0.13029498E-09_JPRB, 0.13228568E-09_JPRB, 0.13430959E-09_JPRB, &
  & 0.13633139E-09_JPRB, 0.13831009E-09_JPRB, 0.14021914E-09_JPRB, 0.14203878E-09_JPRB, 0.14374973E-09_JPRB, 0.14532384E-09_JPRB, &
  & 0.14672180E-09_JPRB, 0.14790026E-09_JPRB, 0.14881694E-09_JPRB, 0.14944045E-09_JPRB, 0.14976369E-09_JPRB, 0.14981301E-09_JPRB, &
  & 0.14965476E-09_JPRB, 0.14938827E-09_JPRB, 0.14912466E-09_JPRB, 0.14897585E-09_JPRB, 0.14899743E-09_JPRB, 0.14920927E-09_JPRB, &
  & 0.14956929E-09_JPRB, 0.15003229E-09_JPRB, 0.15052079E-09_JPRB, 0.15096752E-09_JPRB, 0.15134641E-09_JPRB, 0.15163436E-09_JPRB, &
  & 0.15181360E-09_JPRB, 0.15183983E-09_JPRB, 0.15169754E-09_JPRB, 0.15136915E-09_JPRB, 0.15089437E-09_JPRB, 0.15029267E-09_JPRB, &
  & 0.14956401E-09_JPRB, 0.14874596E-09_JPRB, 0.14784308E-09_JPRB, 0.14687714E-09_JPRB, 0.14585620E-09_JPRB, 0.14478183E-09_JPRB, &
  & 0.14364490E-09_JPRB, 0.14244451E-09_JPRB, 0.14117552E-09_JPRB, 0.13983922E-09_JPRB, 0.13844771E-09_JPRB, 0.13702106E-09_JPRB, &
  & 0.13559232E-09_JPRB, 0.13419658E-09_JPRB, 0.13287245E-09_JPRB, 0.13164766E-09_JPRB, 0.13054725E-09_JPRB, 0.12958652E-09_JPRB, &
  & 0.12878512E-09_JPRB, 0.12804210E-09_JPRB, 0.12737704E-09_JPRB, 0.12602352E-09_JPRB /)

RGHG8(:,23,12) = (/ &
  & 0.12098461E-09_JPRB, 0.12235710E-09_JPRB, 0.12337215E-09_JPRB, 0.12442224E-09_JPRB, 0.12559165E-09_JPRB, 0.12690138E-09_JPRB, &
  & 0.12835200E-09_JPRB, 0.12992751E-09_JPRB, 0.13162522E-09_JPRB, 0.13343124E-09_JPRB, 0.13531720E-09_JPRB, 0.13724258E-09_JPRB, &
  & 0.13916779E-09_JPRB, 0.14106233E-09_JPRB, 0.14289969E-09_JPRB, 0.14465720E-09_JPRB, 0.14631060E-09_JPRB, 0.14783653E-09_JPRB, &
  & 0.14920715E-09_JPRB, 0.15038765E-09_JPRB, 0.15133975E-09_JPRB, 0.15203326E-09_JPRB, 0.15246082E-09_JPRB, 0.15265361E-09_JPRB, &
  & 0.15267551E-09_JPRB, 0.15261060E-09_JPRB, 0.15254743E-09_JPRB, 0.15256403E-09_JPRB, 0.15270368E-09_JPRB, 0.15297073E-09_JPRB, &
  & 0.15333758E-09_JPRB, 0.15374288E-09_JPRB, 0.15412276E-09_JPRB, 0.15444686E-09_JPRB, 0.15469503E-09_JPRB, 0.15484844E-09_JPRB, &
  & 0.15489865E-09_JPRB, 0.15483130E-09_JPRB, 0.15464655E-09_JPRB, 0.15432017E-09_JPRB, 0.15386659E-09_JPRB, 0.15330126E-09_JPRB, &
  & 0.15262580E-09_JPRB, 0.15187150E-09_JPRB, 0.15103817E-09_JPRB, 0.15014859E-09_JPRB, 0.14922037E-09_JPRB, 0.14825532E-09_JPRB, &
  & 0.14725374E-09_JPRB, 0.14621002E-09_JPRB, 0.14512322E-09_JPRB, 0.14399400E-09_JPRB, 0.14282772E-09_JPRB, 0.14163810E-09_JPRB, &
  & 0.14044084E-09_JPRB, 0.13926196E-09_JPRB, 0.13812519E-09_JPRB, 0.13705813E-09_JPRB, 0.13608525E-09_JPRB, 0.13522566E-09_JPRB, &
  & 0.13447453E-09_JPRB, 0.13383805E-09_JPRB, 0.13310042E-09_JPRB, 0.13194389E-09_JPRB /)

RGHG8(:,24,12) = (/ &
  & 0.12438360E-09_JPRB, 0.12570589E-09_JPRB, 0.12667586E-09_JPRB, 0.12766420E-09_JPRB, 0.12875707E-09_JPRB, 0.12998190E-09_JPRB, &
  & 0.13133508E-09_JPRB, 0.13281309E-09_JPRB, 0.13440757E-09_JPRB, 0.13610472E-09_JPRB, 0.13788562E-09_JPRB, 0.13970726E-09_JPRB, &
  & 0.14153226E-09_JPRB, 0.14333056E-09_JPRB, 0.14508254E-09_JPRB, 0.14677136E-09_JPRB, 0.14837837E-09_JPRB, 0.14988083E-09_JPRB, &
  & 0.15125250E-09_JPRB, 0.15246035E-09_JPRB, 0.15346971E-09_JPRB, 0.15425458E-09_JPRB, 0.15481212E-09_JPRB, 0.15516939E-09_JPRB, &
  & 0.15537323E-09_JPRB, 0.15548868E-09_JPRB, 0.15557371E-09_JPRB, 0.15568644E-09_JPRB, 0.15586067E-09_JPRB, 0.15609702E-09_JPRB, &
  & 0.15637872E-09_JPRB, 0.15666471E-09_JPRB, 0.15692049E-09_JPRB, 0.15712232E-09_JPRB, 0.15726122E-09_JPRB, 0.15732017E-09_JPRB, &
  & 0.15729765E-09_JPRB, 0.15718594E-09_JPRB, 0.15696819E-09_JPRB, 0.15664460E-09_JPRB, 0.15622553E-09_JPRB, 0.15570299E-09_JPRB, &
  & 0.15509613E-09_JPRB, 0.15440507E-09_JPRB, 0.15364965E-09_JPRB, 0.15283683E-09_JPRB, 0.15199336E-09_JPRB, 0.15112320E-09_JPRB, &
  & 0.15023292E-09_JPRB, 0.14931897E-09_JPRB, 0.14838035E-09_JPRB, 0.14741888E-09_JPRB, 0.14643506E-09_JPRB, 0.14543522E-09_JPRB, &
  & 0.14442833E-09_JPRB, 0.14342490E-09_JPRB, 0.14244551E-09_JPRB, 0.14150744E-09_JPRB, 0.14063586E-09_JPRB, 0.13984928E-09_JPRB, &
  & 0.13915948E-09_JPRB, 0.13852157E-09_JPRB, 0.13788412E-09_JPRB, 0.13671930E-09_JPRB /)

RGHG8(:,25,12) = (/ &
  & 0.12751614E-09_JPRB, 0.12877545E-09_JPRB, 0.12968192E-09_JPRB, 0.13059580E-09_JPRB, 0.13160364E-09_JPRB, 0.13273131E-09_JPRB, &
  & 0.13398602E-09_JPRB, 0.13536008E-09_JPRB, 0.13684762E-09_JPRB, 0.13843768E-09_JPRB, 0.14010740E-09_JPRB, 0.14182455E-09_JPRB, &
  & 0.14355392E-09_JPRB, 0.14526848E-09_JPRB, 0.14694759E-09_JPRB, 0.14857036E-09_JPRB, 0.15012382E-09_JPRB, 0.15158975E-09_JPRB, &
  & 0.15294438E-09_JPRB, 0.15416395E-09_JPRB, 0.15522246E-09_JPRB, 0.15609694E-09_JPRB, 0.15677851E-09_JPRB, 0.15728149E-09_JPRB, &
  & 0.15763797E-09_JPRB, 0.15789103E-09_JPRB, 0.15808478E-09_JPRB, 0.15825410E-09_JPRB, 0.15842019E-09_JPRB, 0.15859694E-09_JPRB, &
  & 0.15877895E-09_JPRB, 0.15895227E-09_JPRB, 0.15909463E-09_JPRB, 0.15919649E-09_JPRB, 0.15925167E-09_JPRB, 0.15924803E-09_JPRB, &
  & 0.15917520E-09_JPRB, 0.15903084E-09_JPRB, 0.15881091E-09_JPRB, 0.15850556E-09_JPRB, 0.15811975E-09_JPRB, 0.15764891E-09_JPRB, &
  & 0.15710273E-09_JPRB, 0.15647875E-09_JPRB, 0.15579116E-09_JPRB, 0.15505067E-09_JPRB, 0.15428006E-09_JPRB, 0.15349089E-09_JPRB, &
  & 0.15268822E-09_JPRB, 0.15187619E-09_JPRB, 0.15105253E-09_JPRB, 0.15022031E-09_JPRB, 0.14937682E-09_JPRB, 0.14852594E-09_JPRB, &
  & 0.14766860E-09_JPRB, 0.14681270E-09_JPRB, 0.14596443E-09_JPRB, 0.14514198E-09_JPRB, 0.14436129E-09_JPRB, 0.14364282E-09_JPRB, &
  & 0.14299695E-09_JPRB, 0.14240135E-09_JPRB, 0.14176642E-09_JPRB, 0.14062639E-09_JPRB /)

RGHG8(:,26,12) = (/ &
  & 0.13043736E-09_JPRB, 0.13162482E-09_JPRB, 0.13245947E-09_JPRB, 0.13329689E-09_JPRB, 0.13421432E-09_JPRB, 0.13524828E-09_JPRB, &
  & 0.13640238E-09_JPRB, 0.13767329E-09_JPRB, 0.13905278E-09_JPRB, 0.14052946E-09_JPRB, 0.14208394E-09_JPRB, 0.14368545E-09_JPRB, &
  & 0.14530510E-09_JPRB, 0.14691853E-09_JPRB, 0.14850880E-09_JPRB, 0.15005999E-09_JPRB, 0.15155235E-09_JPRB, 0.15297162E-09_JPRB, &
  & 0.15430521E-09_JPRB, 0.15553309E-09_JPRB, 0.15663008E-09_JPRB, 0.15757198E-09_JPRB, 0.15834704E-09_JPRB, 0.15896094E-09_JPRB, &
  & 0.15943356E-09_JPRB, 0.15979022E-09_JPRB, 0.16005924E-09_JPRB, 0.16026366E-09_JPRB, 0.16042218E-09_JPRB, 0.16055202E-09_JPRB, &
  & 0.16066026E-09_JPRB, 0.16074565E-09_JPRB, 0.16080134E-09_JPRB, 0.16082928E-09_JPRB, 0.16082354E-09_JPRB, 0.16077584E-09_JPRB, &
  & 0.16067625E-09_JPRB, 0.16052150E-09_JPRB, 0.16030595E-09_JPRB, 0.16002423E-09_JPRB, 0.15967268E-09_JPRB, 0.15924972E-09_JPRB, &
  & 0.15875649E-09_JPRB, 0.15819124E-09_JPRB, 0.15756191E-09_JPRB, 0.15688198E-09_JPRB, 0.15617106E-09_JPRB, 0.15544512E-09_JPRB, &
  & 0.15471212E-09_JPRB, 0.15397709E-09_JPRB, 0.15324035E-09_JPRB, 0.15250509E-09_JPRB, 0.15176928E-09_JPRB, 0.15103375E-09_JPRB, &
  & 0.15029791E-09_JPRB, 0.14956279E-09_JPRB, 0.14883492E-09_JPRB, 0.14811821E-09_JPRB, 0.14743090E-09_JPRB, 0.14678508E-09_JPRB, &
  & 0.14618794E-09_JPRB, 0.14563566E-09_JPRB, 0.14500712E-09_JPRB, 0.14396902E-09_JPRB /)

RGHG8(:,27,12) = (/ &
  & 0.13319958E-09_JPRB, 0.13431432E-09_JPRB, 0.13507623E-09_JPRB, 0.13583422E-09_JPRB, 0.13666966E-09_JPRB, 0.13760962E-09_JPRB, &
  & 0.13866805E-09_JPRB, 0.13983720E-09_JPRB, 0.14110682E-09_JPRB, 0.14246658E-09_JPRB, 0.14389968E-09_JPRB, 0.14538327E-09_JPRB, &
  & 0.14688768E-09_JPRB, 0.14839494E-09_JPRB, 0.14988484E-09_JPRB, 0.15134713E-09_JPRB, 0.15277020E-09_JPRB, 0.15414002E-09_JPRB, &
  & 0.15544047E-09_JPRB, 0.15665268E-09_JPRB, 0.15775534E-09_JPRB, 0.15872836E-09_JPRB, 0.15955905E-09_JPRB, 0.16024598E-09_JPRB, &
  & 0.16079989E-09_JPRB, 0.16123208E-09_JPRB, 0.16156229E-09_JPRB, 0.16180079E-09_JPRB, 0.16196537E-09_JPRB, 0.16207077E-09_JPRB, &
  & 0.16213428E-09_JPRB, 0.16216239E-09_JPRB, 0.16216060E-09_JPRB, 0.16213855E-09_JPRB, 0.16209178E-09_JPRB, 0.16201571E-09_JPRB, &
  & 0.16190176E-09_JPRB, 0.16174291E-09_JPRB, 0.16153796E-09_JPRB, 0.16128100E-09_JPRB, 0.16096401E-09_JPRB, 0.16058430E-09_JPRB, &
  & 0.16013850E-09_JPRB, 0.15962381E-09_JPRB, 0.15904544E-09_JPRB, 0.15841578E-09_JPRB, 0.15775201E-09_JPRB, 0.15707297E-09_JPRB, &
  & 0.15638911E-09_JPRB, 0.15571139E-09_JPRB, 0.15504123E-09_JPRB, 0.15438045E-09_JPRB, 0.15372800E-09_JPRB, 0.15308352E-09_JPRB, &
  & 0.15244653E-09_JPRB, 0.15181605E-09_JPRB, 0.15119075E-09_JPRB, 0.15057697E-09_JPRB, 0.14998011E-09_JPRB, 0.14941491E-09_JPRB, &
  & 0.14889044E-09_JPRB, 0.14837673E-09_JPRB, 0.14784750E-09_JPRB, 0.14682612E-09_JPRB /)

RGHG8(:,28,12) = (/ &
  & 0.13583948E-09_JPRB, 0.13687486E-09_JPRB, 0.13757190E-09_JPRB, 0.13826260E-09_JPRB, 0.13901627E-09_JPRB, 0.13987426E-09_JPRB, &
  & 0.14083949E-09_JPRB, 0.14190639E-09_JPRB, 0.14306344E-09_JPRB, 0.14430315E-09_JPRB, 0.14561112E-09_JPRB, 0.14697363E-09_JPRB, &
  & 0.14835998E-09_JPRB, 0.14975933E-09_JPRB, 0.15115370E-09_JPRB, 0.15252685E-09_JPRB, 0.15386797E-09_JPRB, 0.15516650E-09_JPRB, &
  & 0.15640983E-09_JPRB, 0.15758166E-09_JPRB, 0.15866398E-09_JPRB, 0.15963914E-09_JPRB, 0.16049387E-09_JPRB, 0.16122426E-09_JPRB, &
  & 0.16183052E-09_JPRB, 0.16231699E-09_JPRB, 0.16269593E-09_JPRB, 0.16296937E-09_JPRB, 0.16315159E-09_JPRB, 0.16325435E-09_JPRB, &
  & 0.16329890E-09_JPRB, 0.16329735E-09_JPRB, 0.16326202E-09_JPRB, 0.16320882E-09_JPRB, 0.16313638E-09_JPRB, 0.16304320E-09_JPRB, &
  & 0.16292295E-09_JPRB, 0.16276809E-09_JPRB, 0.16257609E-09_JPRB, 0.16234186E-09_JPRB, 0.16205626E-09_JPRB, 0.16171399E-09_JPRB, &
  & 0.16130926E-09_JPRB, 0.16083797E-09_JPRB, 0.16030227E-09_JPRB, 0.15971244E-09_JPRB, 0.15908548E-09_JPRB, 0.15844068E-09_JPRB, &
  & 0.15779734E-09_JPRB, 0.15716316E-09_JPRB, 0.15654399E-09_JPRB, 0.15594154E-09_JPRB, 0.15535578E-09_JPRB, 0.15478609E-09_JPRB, &
  & 0.15422918E-09_JPRB, 0.15368369E-09_JPRB, 0.15314752E-09_JPRB, 0.15261953E-09_JPRB, 0.15210903E-09_JPRB, 0.15162199E-09_JPRB, &
  & 0.15116462E-09_JPRB, 0.15073302E-09_JPRB, 0.15022665E-09_JPRB, 0.14938063E-09_JPRB /)

RGHG8(:,29,12) = (/ &
  & 0.13837125E-09_JPRB, 0.13933676E-09_JPRB, 0.13997820E-09_JPRB, 0.14060479E-09_JPRB, 0.14129464E-09_JPRB, 0.14207156E-09_JPRB, &
  & 0.14294926E-09_JPRB, 0.14391541E-09_JPRB, 0.14495874E-09_JPRB, 0.14607317E-09_JPRB, 0.14725637E-09_JPRB, 0.14848953E-09_JPRB, &
  & 0.14975633E-09_JPRB, 0.15104239E-09_JPRB, 0.15233129E-09_JPRB, 0.15360992E-09_JPRB, 0.15486612E-09_JPRB, 0.15608957E-09_JPRB, &
  & 0.15726723E-09_JPRB, 0.15838522E-09_JPRB, 0.15943119E-09_JPRB, 0.16038840E-09_JPRB, 0.16124525E-09_JPRB, 0.16199390E-09_JPRB, &
  & 0.16263021E-09_JPRB, 0.16315385E-09_JPRB, 0.16356823E-09_JPRB, 0.16387385E-09_JPRB, 0.16407813E-09_JPRB, 0.16419137E-09_JPRB, &
  & 0.16423403E-09_JPRB, 0.16422215E-09_JPRB, 0.16417080E-09_JPRB, 0.16410015E-09_JPRB, 0.16401318E-09_JPRB, 0.16391109E-09_JPRB, &
  & 0.16378898E-09_JPRB, 0.16364161E-09_JPRB, 0.16346384E-09_JPRB, 0.16325048E-09_JPRB, 0.16299205E-09_JPRB, 0.16268116E-09_JPRB, &
  & 0.16231046E-09_JPRB, 0.16187460E-09_JPRB, 0.16137336E-09_JPRB, 0.16081546E-09_JPRB, 0.16021685E-09_JPRB, 0.15960391E-09_JPRB, &
  & 0.15899247E-09_JPRB, 0.15839638E-09_JPRB, 0.15782044E-09_JPRB, 0.15726712E-09_JPRB, 0.15673635E-09_JPRB, 0.15622514E-09_JPRB, &
  & 0.15573247E-09_JPRB, 0.15525307E-09_JPRB, 0.15478425E-09_JPRB, 0.15432661E-09_JPRB, 0.15388360E-09_JPRB, 0.15346610E-09_JPRB, &
  & 0.15307655E-09_JPRB, 0.15269776E-09_JPRB, 0.15229518E-09_JPRB, 0.15154608E-09_JPRB /)

RGHG8(:,30,12) = (/ &
  & 0.14080710E-09_JPRB, 0.14170984E-09_JPRB, 0.14230203E-09_JPRB, 0.14287993E-09_JPRB, 0.14350514E-09_JPRB, 0.14421396E-09_JPRB, &
  & 0.14500640E-09_JPRB, 0.14587306E-09_JPRB, 0.14680385E-09_JPRB, 0.14779628E-09_JPRB, 0.14885124E-09_JPRB, 0.14995551E-09_JPRB, &
  & 0.15110048E-09_JPRB, 0.15227349E-09_JPRB, 0.15345973E-09_JPRB, 0.15464610E-09_JPRB, 0.15581997E-09_JPRB, 0.15696795E-09_JPRB, &
  & 0.15807741E-09_JPRB, 0.15913505E-09_JPRB, 0.16013127E-09_JPRB, 0.16105621E-09_JPRB, 0.16189673E-09_JPRB, 0.16264413E-09_JPRB, &
  & 0.16329009E-09_JPRB, 0.16383155E-09_JPRB, 0.16426753E-09_JPRB, 0.16459635E-09_JPRB, 0.16482132E-09_JPRB, 0.16494997E-09_JPRB, &
  & 0.16499963E-09_JPRB, 0.16498902E-09_JPRB, 0.16493389E-09_JPRB, 0.16485539E-09_JPRB, 0.16476212E-09_JPRB, 0.16465625E-09_JPRB, &
  & 0.16453566E-09_JPRB, 0.16439636E-09_JPRB, 0.16423260E-09_JPRB, 0.16403781E-09_JPRB, 0.16380189E-09_JPRB, 0.16351620E-09_JPRB, &
  & 0.16317282E-09_JPRB, 0.16276534E-09_JPRB, 0.16229273E-09_JPRB, 0.16176217E-09_JPRB, 0.16119303E-09_JPRB, 0.16060706E-09_JPRB, &
  & 0.16002649E-09_JPRB, 0.15946282E-09_JPRB, 0.15892491E-09_JPRB, 0.15841323E-09_JPRB, 0.15792603E-09_JPRB, 0.15746135E-09_JPRB, &
  & 0.15701497E-09_JPRB, 0.15658431E-09_JPRB, 0.15616522E-09_JPRB, 0.15575749E-09_JPRB, 0.15536836E-09_JPRB, 0.15500377E-09_JPRB, &
  & 0.15466883E-09_JPRB, 0.15435106E-09_JPRB, 0.15399369E-09_JPRB, 0.15337381E-09_JPRB /)

RGHG8(:,31,12) = (/ &
  & 0.14315563E-09_JPRB, 0.14399952E-09_JPRB, 0.14454873E-09_JPRB, 0.14507652E-09_JPRB, 0.14564977E-09_JPRB, 0.14629035E-09_JPRB, &
  & 0.14700385E-09_JPRB, 0.14777757E-09_JPRB, 0.14860092E-09_JPRB, 0.14947471E-09_JPRB, 0.15040480E-09_JPRB, 0.15138185E-09_JPRB, &
  & 0.15240727E-09_JPRB, 0.15346846E-09_JPRB, 0.15455284E-09_JPRB, 0.15564935E-09_JPRB, 0.15674434E-09_JPRB, 0.15782189E-09_JPRB, &
  & 0.15886764E-09_JPRB, 0.15986813E-09_JPRB, 0.16081345E-09_JPRB, 0.16169728E-09_JPRB, 0.16250851E-09_JPRB, 0.16323816E-09_JPRB, &
  & 0.16387491E-09_JPRB, 0.16441394E-09_JPRB, 0.16485494E-09_JPRB, 0.16519551E-09_JPRB, 0.16543501E-09_JPRB, 0.16557765E-09_JPRB, &
  & 0.16563804E-09_JPRB, 0.16563494E-09_JPRB, 0.16558396E-09_JPRB, 0.16550525E-09_JPRB, 0.16541145E-09_JPRB, 0.16530595E-09_JPRB, &
  & 0.16518879E-09_JPRB, 0.16505786E-09_JPRB, 0.16490652E-09_JPRB, 0.16472691E-09_JPRB, 0.16450885E-09_JPRB, 0.16424292E-09_JPRB, &
  & 0.16392024E-09_JPRB, 0.16353541E-09_JPRB, 0.16308691E-09_JPRB, 0.16258278E-09_JPRB, 0.16204069E-09_JPRB, 0.16148441E-09_JPRB, &
  & 0.16093182E-09_JPRB, 0.16040069E-09_JPRB, 0.15989521E-09_JPRB, 0.15941662E-09_JPRB, 0.15896363E-09_JPRB, 0.15853338E-09_JPRB, &
  & 0.15812322E-09_JPRB, 0.15772700E-09_JPRB, 0.15734268E-09_JPRB, 0.15697195E-09_JPRB, 0.15662067E-09_JPRB, 0.15629834E-09_JPRB, &
  & 0.15600399E-09_JPRB, 0.15572675E-09_JPRB, 0.15542513E-09_JPRB, 0.15489378E-09_JPRB /)

RGHG8(:,32,12) = (/ &
  & 0.14541772E-09_JPRB, 0.14619997E-09_JPRB, 0.14670429E-09_JPRB, 0.14718794E-09_JPRB, 0.14770739E-09_JPRB, 0.14828770E-09_JPRB, &
  & 0.14892790E-09_JPRB, 0.14961489E-09_JPRB, 0.15034027E-09_JPRB, 0.15110446E-09_JPRB, 0.15191390E-09_JPRB, 0.15277089E-09_JPRB, &
  & 0.15368101E-09_JPRB, 0.15463868E-09_JPRB, 0.15563312E-09_JPRB, 0.15664975E-09_JPRB, 0.15767350E-09_JPRB, 0.15868552E-09_JPRB, &
  & 0.15966943E-09_JPRB, 0.16061229E-09_JPRB, 0.16150653E-09_JPRB, 0.16234421E-09_JPRB, 0.16311634E-09_JPRB, 0.16381117E-09_JPRB, &
  & 0.16442075E-09_JPRB, 0.16494085E-09_JPRB, 0.16537119E-09_JPRB, 0.16571011E-09_JPRB, 0.16595486E-09_JPRB, 0.16610770E-09_JPRB, &
  & 0.16617890E-09_JPRB, 0.16618618E-09_JPRB, 0.16614458E-09_JPRB, 0.16607160E-09_JPRB, 0.16598181E-09_JPRB, 0.16587981E-09_JPRB, &
  & 0.16576839E-09_JPRB, 0.16564559E-09_JPRB, 0.16550478E-09_JPRB, 0.16533697E-09_JPRB, 0.16513232E-09_JPRB, 0.16488041E-09_JPRB, &
  & 0.16457373E-09_JPRB, 0.16420644E-09_JPRB, 0.16377837E-09_JPRB, 0.16329897E-09_JPRB, 0.16278515E-09_JPRB, 0.16225393E-09_JPRB, &
  & 0.16173127E-09_JPRB, 0.16122786E-09_JPRB, 0.16075238E-09_JPRB, 0.16030402E-09_JPRB, 0.15987975E-09_JPRB, 0.15947815E-09_JPRB, &
  & 0.15909291E-09_JPRB, 0.15872195E-09_JPRB, 0.15836313E-09_JPRB, 0.15801888E-09_JPRB, 0.15769730E-09_JPRB, 0.15740423E-09_JPRB, &
  & 0.15714251E-09_JPRB, 0.15689570E-09_JPRB, 0.15662929E-09_JPRB, 0.15616225E-09_JPRB /)

RGHG8(:,33,12) = (/ &
  & 0.14758340E-09_JPRB, 0.14829864E-09_JPRB, 0.14875516E-09_JPRB, 0.14919302E-09_JPRB, 0.14966287E-09_JPRB, 0.15018625E-09_JPRB, &
  & 0.15076018E-09_JPRB, 0.15137135E-09_JPRB, 0.15200773E-09_JPRB, 0.15267174E-09_JPRB, 0.15336990E-09_JPRB, 0.15411379E-09_JPRB, &
  & 0.15491418E-09_JPRB, 0.15577341E-09_JPRB, 0.15668537E-09_JPRB, 0.15763384E-09_JPRB, 0.15859845E-09_JPRB, 0.15955566E-09_JPRB, &
  & 0.16048518E-09_JPRB, 0.16137620E-09_JPRB, 0.16221964E-09_JPRB, 0.16300766E-09_JPRB, 0.16373136E-09_JPRB, 0.16438224E-09_JPRB, &
  & 0.16495059E-09_JPRB, 0.16543530E-09_JPRB, 0.16583991E-09_JPRB, 0.16616375E-09_JPRB, 0.16640427E-09_JPRB, 0.16656101E-09_JPRB, &
  & 0.16664149E-09_JPRB, 0.16666041E-09_JPRB, 0.16663183E-09_JPRB, 0.16656905E-09_JPRB, 0.16648749E-09_JPRB, 0.16639272E-09_JPRB, &
  & 0.16628909E-09_JPRB, 0.16617453E-09_JPRB, 0.16604235E-09_JPRB, 0.16588406E-09_JPRB, 0.16568866E-09_JPRB, 0.16544653E-09_JPRB, &
  & 0.16515089E-09_JPRB, 0.16479629E-09_JPRB, 0.16438564E-09_JPRB, 0.16392895E-09_JPRB, 0.16343799E-09_JPRB, 0.16293680E-09_JPRB, &
  & 0.16244185E-09_JPRB, 0.16196973E-09_JPRB, 0.16152082E-09_JPRB, 0.16109647E-09_JPRB, 0.16069601E-09_JPRB, 0.16031537E-09_JPRB, &
  & 0.15995186E-09_JPRB, 0.15960082E-09_JPRB, 0.15926212E-09_JPRB, 0.15893895E-09_JPRB, 0.15863844E-09_JPRB, 0.15836901E-09_JPRB, &
  & 0.15812682E-09_JPRB, 0.15790391E-09_JPRB, 0.15765937E-09_JPRB, 0.15724469E-09_JPRB /)

RGHG8(:,34,12) = (/ &
  & 0.14963643E-09_JPRB, 0.15027384E-09_JPRB, 0.15068451E-09_JPRB, 0.15107503E-09_JPRB, 0.15149897E-09_JPRB, 0.15197005E-09_JPRB, &
  & 0.15248627E-09_JPRB, 0.15302928E-09_JPRB, 0.15358802E-09_JPRB, 0.15416149E-09_JPRB, 0.15475864E-09_JPRB, 0.15539779E-09_JPRB, &
  & 0.15609575E-09_JPRB, 0.15686277E-09_JPRB, 0.15769844E-09_JPRB, 0.15858584E-09_JPRB, 0.15949787E-09_JPRB, 0.16040999E-09_JPRB, &
  & 0.16129824E-09_JPRB, 0.16214673E-09_JPRB, 0.16294276E-09_JPRB, 0.16367996E-09_JPRB, 0.16435243E-09_JPRB, 0.16495091E-09_JPRB, &
  & 0.16546819E-09_JPRB, 0.16590664E-09_JPRB, 0.16627287E-09_JPRB, 0.16656969E-09_JPRB, 0.16679601E-09_JPRB, 0.16695031E-09_JPRB, &
  & 0.16703672E-09_JPRB, 0.16706747E-09_JPRB, 0.16705398E-09_JPRB, 0.16700522E-09_JPRB, 0.16693646E-09_JPRB, 0.16685342E-09_JPRB, &
  & 0.16675969E-09_JPRB, 0.16665436E-09_JPRB, 0.16653071E-09_JPRB, 0.16637980E-09_JPRB, 0.16619096E-09_JPRB, 0.16595528E-09_JPRB, &
  & 0.16566563E-09_JPRB, 0.16532045E-09_JPRB, 0.16492327E-09_JPRB, 0.16448384E-09_JPRB, 0.16401853E-09_JPRB, 0.16354329E-09_JPRB, &
  & 0.16307891E-09_JPRB, 0.16263062E-09_JPRB, 0.16220562E-09_JPRB, 0.16180494E-09_JPRB, 0.16142571E-09_JPRB, 0.16106558E-09_JPRB, &
  & 0.16071874E-09_JPRB, 0.16038454E-09_JPRB, 0.16006166E-09_JPRB, 0.15975488E-09_JPRB, 0.15947224E-09_JPRB, 0.15921781E-09_JPRB, &
  & 0.15899407E-09_JPRB, 0.15878358E-09_JPRB, 0.15856150E-09_JPRB, 0.15817569E-09_JPRB /)

RGHG8(:,35,12) = (/ &
  & 0.15155850E-09_JPRB, 0.15212101E-09_JPRB, 0.15247770E-09_JPRB, 0.15282622E-09_JPRB, 0.15320334E-09_JPRB, 0.15362918E-09_JPRB, &
  & 0.15409292E-09_JPRB, 0.15457728E-09_JPRB, 0.15506615E-09_JPRB, 0.15555901E-09_JPRB, 0.15606644E-09_JPRB, 0.15660943E-09_JPRB, &
  & 0.15721320E-09_JPRB, 0.15789504E-09_JPRB, 0.15866113E-09_JPRB, 0.15949519E-09_JPRB, 0.16036744E-09_JPRB, 0.16124287E-09_JPRB, &
  & 0.16209702E-09_JPRB, 0.16290788E-09_JPRB, 0.16366206E-09_JPRB, 0.16435214E-09_JPRB, 0.16497112E-09_JPRB, 0.16551065E-09_JPRB, &
  & 0.16596940E-09_JPRB, 0.16635246E-09_JPRB, 0.16667057E-09_JPRB, 0.16693019E-09_JPRB, 0.16713207E-09_JPRB, 0.16727614E-09_JPRB, &
  & 0.16736346E-09_JPRB, 0.16740477E-09_JPRB, 0.16740649E-09_JPRB, 0.16737475E-09_JPRB, 0.16732368E-09_JPRB, 0.16725576E-09_JPRB, &
  & 0.16717573E-09_JPRB, 0.16708245E-09_JPRB, 0.16696879E-09_JPRB, 0.16682630E-09_JPRB, 0.16664457E-09_JPRB, 0.16641333E-09_JPRB, &
  & 0.16612858E-09_JPRB, 0.16578941E-09_JPRB, 0.16540261E-09_JPRB, 0.16498058E-09_JPRB, 0.16453590E-09_JPRB, 0.16408853E-09_JPRB, &
  & 0.16364692E-09_JPRB, 0.16322453E-09_JPRB, 0.16282270E-09_JPRB, 0.16244145E-09_JPRB, 0.16207988E-09_JPRB, 0.16173382E-09_JPRB, &
  & 0.16140281E-09_JPRB, 0.16108234E-09_JPRB, 0.16077421E-09_JPRB, 0.16048148E-09_JPRB, 0.16021202E-09_JPRB, 0.15997224E-09_JPRB, &
  & 0.15975873E-09_JPRB, 0.15956382E-09_JPRB, 0.15935173E-09_JPRB, 0.15899619E-09_JPRB /)

RGHG8(:,36,12) = (/ &
  & 0.15334554E-09_JPRB, 0.15382495E-09_JPRB, 0.15413737E-09_JPRB, 0.15443979E-09_JPRB, 0.15477775E-09_JPRB, 0.15515936E-09_JPRB, &
  & 0.15557752E-09_JPRB, 0.15600818E-09_JPRB, 0.15643546E-09_JPRB, 0.15685647E-09_JPRB, 0.15728366E-09_JPRB, 0.15774065E-09_JPRB, &
  & 0.15825745E-09_JPRB, 0.15885979E-09_JPRB, 0.15956114E-09_JPRB, 0.16034629E-09_JPRB, 0.16118476E-09_JPRB, 0.16203454E-09_JPRB, &
  & 0.16286138E-09_JPRB, 0.16364331E-09_JPRB, 0.16436193E-09_JPRB, 0.16500781E-09_JPRB, 0.16557050E-09_JPRB, 0.16604695E-09_JPRB, &
  & 0.16643849E-09_JPRB, 0.16675825E-09_JPRB, 0.16701966E-09_JPRB, 0.16723228E-09_JPRB, 0.16740168E-09_JPRB, 0.16752702E-09_JPRB, &
  & 0.16760998E-09_JPRB, 0.16765807E-09_JPRB, 0.16767206E-09_JPRB, 0.16765865E-09_JPRB, 0.16762590E-09_JPRB, 0.16757548E-09_JPRB, &
  & 0.16751284E-09_JPRB, 0.16743457E-09_JPRB, 0.16733562E-09_JPRB, 0.16720744E-09_JPRB, 0.16703794E-09_JPRB, 0.16681791E-09_JPRB, &
  & 0.16654139E-09_JPRB, 0.16620995E-09_JPRB, 0.16583356E-09_JPRB, 0.16542422E-09_JPRB, 0.16500060E-09_JPRB, 0.16457323E-09_JPRB, &
  & 0.16415738E-09_JPRB, 0.16375648E-09_JPRB, 0.16337295E-09_JPRB, 0.16300804E-09_JPRB, 0.16265986E-09_JPRB, 0.16232898E-09_JPRB, &
  & 0.16201092E-09_JPRB, 0.16170487E-09_JPRB, 0.16140939E-09_JPRB, 0.16112968E-09_JPRB, 0.16087237E-09_JPRB, 0.16064272E-09_JPRB, &
  & 0.16044152E-09_JPRB, 0.16025514E-09_JPRB, 0.16005865E-09_JPRB, 0.15972373E-09_JPRB /)

RGHG8(:,37,12) = (/ &
  & 0.15499260E-09_JPRB, 0.15539867E-09_JPRB, 0.15566136E-09_JPRB, 0.15592555E-09_JPRB, 0.15622312E-09_JPRB, 0.15656665E-09_JPRB, &
  & 0.15694165E-09_JPRB, 0.15732422E-09_JPRB, 0.15769548E-09_JPRB, 0.15805268E-09_JPRB, 0.15840990E-09_JPRB, 0.15879030E-09_JPRB, &
  & 0.15922781E-09_JPRB, 0.15975500E-09_JPRB, 0.16039300E-09_JPRB, 0.16113419E-09_JPRB, 0.16193992E-09_JPRB, 0.16276996E-09_JPRB, &
  & 0.16357926E-09_JPRB, 0.16433670E-09_JPRB, 0.16502152E-09_JPRB, 0.16561714E-09_JPRB, 0.16611607E-09_JPRB, 0.16651891E-09_JPRB, &
  & 0.16683797E-09_JPRB, 0.16708947E-09_JPRB, 0.16729179E-09_JPRB, 0.16745708E-09_JPRB, 0.16759170E-09_JPRB, 0.16769709E-09_JPRB, &
  & 0.16777271E-09_JPRB, 0.16782338E-09_JPRB, 0.16784542E-09_JPRB, 0.16784675E-09_JPRB, 0.16782833E-09_JPRB, 0.16779488E-09_JPRB, &
  & 0.16774832E-09_JPRB, 0.16768681E-09_JPRB, 0.16760654E-09_JPRB, 0.16749839E-09_JPRB, 0.16735166E-09_JPRB, 0.16715371E-09_JPRB, &
  & 0.16689718E-09_JPRB, 0.16658180E-09_JPRB, 0.16621692E-09_JPRB, 0.16582256E-09_JPRB, 0.16541427E-09_JPRB, 0.16500877E-09_JPRB, &
  & 0.16461224E-09_JPRB, 0.16422944E-09_JPRB, 0.16386181E-09_JPRB, 0.16350983E-09_JPRB, 0.16317532E-09_JPRB, 0.16285633E-09_JPRB, &
  & 0.16255269E-09_JPRB, 0.16226090E-09_JPRB, 0.16198047E-09_JPRB, 0.16171348E-09_JPRB, 0.16146738E-09_JPRB, 0.16124820E-09_JPRB, &
  & 0.16105552E-09_JPRB, 0.16088031E-09_JPRB, 0.16069371E-09_JPRB, 0.16037964E-09_JPRB /)

RGHG8(:,38,12) = (/ &
  & 0.15649593E-09_JPRB, 0.15683188E-09_JPRB, 0.15705501E-09_JPRB, 0.15728240E-09_JPRB, 0.15754509E-09_JPRB, 0.15785252E-09_JPRB, &
  & 0.15818805E-09_JPRB, 0.15852583E-09_JPRB, 0.15884655E-09_JPRB, 0.15914906E-09_JPRB, 0.15944489E-09_JPRB, 0.15976154E-09_JPRB, &
  & 0.16012686E-09_JPRB, 0.16058520E-09_JPRB, 0.16116081E-09_JPRB, 0.16185965E-09_JPRB, 0.16264078E-09_JPRB, 0.16344916E-09_JPRB, &
  & 0.16423685E-09_JPRB, 0.16496662E-09_JPRB, 0.16560520E-09_JPRB, 0.16613645E-09_JPRB, 0.16655702E-09_JPRB, 0.16688129E-09_JPRB, &
  & 0.16712830E-09_JPRB, 0.16732032E-09_JPRB, 0.16747451E-09_JPRB, 0.16760276E-09_JPRB, 0.16771161E-09_JPRB, 0.16780100E-09_JPRB, &
  & 0.16787169E-09_JPRB, 0.16792154E-09_JPRB, 0.16794965E-09_JPRB, 0.16795898E-09_JPRB, 0.16795065E-09_JPRB, 0.16792896E-09_JPRB, &
  & 0.16789449E-09_JPRB, 0.16784715E-09_JPRB, 0.16778340E-09_JPRB, 0.16769630E-09_JPRB, 0.16757534E-09_JPRB, 0.16740767E-09_JPRB, &
  & 0.16718159E-09_JPRB, 0.16689254E-09_JPRB, 0.16654993E-09_JPRB, 0.16617202E-09_JPRB, 0.16578246E-09_JPRB, 0.16539416E-09_JPRB, &
  & 0.16501553E-09_JPRB, 0.16464918E-09_JPRB, 0.16429466E-09_JPRB, 0.16395471E-09_JPRB, 0.16363078E-09_JPRB, 0.16332517E-09_JPRB, &
  & 0.16303678E-09_JPRB, 0.16276265E-09_JPRB, 0.16249926E-09_JPRB, 0.16224758E-09_JPRB, 0.16201318E-09_JPRB, 0.16180336E-09_JPRB, &
  & 0.16161945E-09_JPRB, 0.16145237E-09_JPRB, 0.16127644E-09_JPRB, 0.16097954E-09_JPRB /)

RGHG8(:,39,12) = (/ &
  & 0.15784796E-09_JPRB, 0.15812569E-09_JPRB, 0.15831372E-09_JPRB, 0.15850947E-09_JPRB, 0.15874352E-09_JPRB, 0.15901770E-09_JPRB, &
  & 0.15931723E-09_JPRB, 0.15961336E-09_JPRB, 0.15989013E-09_JPRB, 0.16014434E-09_JPRB, 0.16039296E-09_JPRB, 0.16065278E-09_JPRB, &
  & 0.16096245E-09_JPRB, 0.16135229E-09_JPRB, 0.16187179E-09_JPRB, 0.16252044E-09_JPRB, 0.16327140E-09_JPRB, 0.16405906E-09_JPRB, &
  & 0.16481949E-09_JPRB, 0.16550183E-09_JPRB, 0.16607651E-09_JPRB, 0.16652779E-09_JPRB, 0.16686903E-09_JPRB, 0.16712313E-09_JPRB, &
  & 0.16731541E-09_JPRB, 0.16746524E-09_JPRB, 0.16758794E-09_JPRB, 0.16769297E-09_JPRB, 0.16778540E-09_JPRB, 0.16786529E-09_JPRB, &
  & 0.16793232E-09_JPRB, 0.16798146E-09_JPRB, 0.16801335E-09_JPRB, 0.16802673E-09_JPRB, 0.16802501E-09_JPRB, 0.16801015E-09_JPRB, &
  & 0.16798404E-09_JPRB, 0.16794660E-09_JPRB, 0.16789509E-09_JPRB, 0.16782441E-09_JPRB, 0.16772532E-09_JPRB, 0.16758536E-09_JPRB, &
  & 0.16739243E-09_JPRB, 0.16713789E-09_JPRB, 0.16682511E-09_JPRB, 0.16647340E-09_JPRB, 0.16610284E-09_JPRB, 0.16573309E-09_JPRB, &
  & 0.16537119E-09_JPRB, 0.16501789E-09_JPRB, 0.16467544E-09_JPRB, 0.16434537E-09_JPRB, 0.16403270E-09_JPRB, 0.16374249E-09_JPRB, &
  & 0.16347163E-09_JPRB, 0.16321887E-09_JPRB, 0.16297542E-09_JPRB, 0.16274189E-09_JPRB, 0.16252090E-09_JPRB, 0.16232168E-09_JPRB, &
  & 0.16214620E-09_JPRB, 0.16198755E-09_JPRB, 0.16182009E-09_JPRB, 0.16153841E-09_JPRB /)

RGHG8(:,40,12) = (/ &
  & 0.15904163E-09_JPRB, 0.15927464E-09_JPRB, 0.15943469E-09_JPRB, 0.15960819E-09_JPRB, 0.15981556E-09_JPRB, 0.16006457E-09_JPRB, &
  & 0.16033044E-09_JPRB, 0.16058999E-09_JPRB, 0.16082731E-09_JPRB, 0.16104502E-09_JPRB, 0.16125110E-09_JPRB, 0.16147299E-09_JPRB, &
  & 0.16172930E-09_JPRB, 0.16206993E-09_JPRB, 0.16252666E-09_JPRB, 0.16313355E-09_JPRB, 0.16384585E-09_JPRB, 0.16459792E-09_JPRB, &
  & 0.16531426E-09_JPRB, 0.16593539E-09_JPRB, 0.16642926E-09_JPRB, 0.16680228E-09_JPRB, 0.16707577E-09_JPRB, 0.16727897E-09_JPRB, &
  & 0.16743347E-09_JPRB, 0.16755684E-09_JPRB, 0.16766023E-09_JPRB, 0.16775147E-09_JPRB, 0.16783414E-09_JPRB, 0.16790865E-09_JPRB, &
  & 0.16797275E-09_JPRB, 0.16802208E-09_JPRB, 0.16805532E-09_JPRB, 0.16807152E-09_JPRB, 0.16807333E-09_JPRB, 0.16806276E-09_JPRB, &
  & 0.16804216E-09_JPRB, 0.16801127E-09_JPRB, 0.16796864E-09_JPRB, 0.16790978E-09_JPRB, 0.16782707E-09_JPRB, 0.16770993E-09_JPRB, &
  & 0.16754628E-09_JPRB, 0.16732603E-09_JPRB, 0.16704867E-09_JPRB, 0.16672498E-09_JPRB, 0.16638024E-09_JPRB, 0.16603008E-09_JPRB, &
  & 0.16568397E-09_JPRB, 0.16534482E-09_JPRB, 0.16501238E-09_JPRB, 0.16469112E-09_JPRB, 0.16439117E-09_JPRB, 0.16411464E-09_JPRB, &
  & 0.16386567E-09_JPRB, 0.16363350E-09_JPRB, 0.16341421E-09_JPRB, 0.16320073E-09_JPRB, 0.16299714E-09_JPRB, 0.16281054E-09_JPRB, &
  & 0.16264565E-09_JPRB, 0.16249539E-09_JPRB, 0.16233766E-09_JPRB, 0.16206911E-09_JPRB /)

RGHG8(:,41,12) = (/ &
  & 0.16008678E-09_JPRB, 0.16028628E-09_JPRB, 0.16042710E-09_JPRB, 0.16058065E-09_JPRB, 0.16077319E-09_JPRB, 0.16099831E-09_JPRB, &
  & 0.16123715E-09_JPRB, 0.16146384E-09_JPRB, 0.16166991E-09_JPRB, 0.16185470E-09_JPRB, 0.16203366E-09_JPRB, 0.16221806E-09_JPRB, &
  & 0.16244267E-09_JPRB, 0.16273076E-09_JPRB, 0.16314106E-09_JPRB, 0.16369106E-09_JPRB, 0.16436288E-09_JPRB, 0.16506765E-09_JPRB, &
  & 0.16572504E-09_JPRB, 0.16627204E-09_JPRB, 0.16669079E-09_JPRB, 0.16699545E-09_JPRB, 0.16721750E-09_JPRB, 0.16738351E-09_JPRB, &
  & 0.16751306E-09_JPRB, 0.16761902E-09_JPRB, 0.16771054E-09_JPRB, 0.16779343E-09_JPRB, 0.16787004E-09_JPRB, 0.16794165E-09_JPRB, &
  & 0.16800317E-09_JPRB, 0.16805296E-09_JPRB, 0.16808645E-09_JPRB, 0.16810445E-09_JPRB, 0.16810812E-09_JPRB, 0.16810038E-09_JPRB, &
  & 0.16808321E-09_JPRB, 0.16805704E-09_JPRB, 0.16802072E-09_JPRB, 0.16797071E-09_JPRB, 0.16790069E-09_JPRB, 0.16780170E-09_JPRB, &
  & 0.16766272E-09_JPRB, 0.16747295E-09_JPRB, 0.16722795E-09_JPRB, 0.16693789E-09_JPRB, 0.16661900E-09_JPRB, 0.16629119E-09_JPRB, &
  & 0.16596306E-09_JPRB, 0.16563653E-09_JPRB, 0.16531330E-09_JPRB, 0.16500246E-09_JPRB, 0.16471055E-09_JPRB, 0.16445326E-09_JPRB, &
  & 0.16422200E-09_JPRB, 0.16401512E-09_JPRB, 0.16381853E-09_JPRB, 0.16362880E-09_JPRB, 0.16344523E-09_JPRB, 0.16327570E-09_JPRB, &
  & 0.16312447E-09_JPRB, 0.16298603E-09_JPRB, 0.16283840E-09_JPRB, 0.16258633E-09_JPRB /)

RGHG8(:,42,12) = (/ &
  & 0.16100166E-09_JPRB, 0.16117890E-09_JPRB, 0.16130537E-09_JPRB, 0.16144913E-09_JPRB, 0.16162682E-09_JPRB, 0.16183796E-09_JPRB, &
  & 0.16205251E-09_JPRB, 0.16225275E-09_JPRB, 0.16243154E-09_JPRB, 0.16259341E-09_JPRB, 0.16274601E-09_JPRB, 0.16290905E-09_JPRB, &
  & 0.16309788E-09_JPRB, 0.16335462E-09_JPRB, 0.16371153E-09_JPRB, 0.16421632E-09_JPRB, 0.16483617E-09_JPRB, 0.16548551E-09_JPRB, &
  & 0.16607085E-09_JPRB, 0.16654125E-09_JPRB, 0.16688823E-09_JPRB, 0.16713794E-09_JPRB, 0.16731994E-09_JPRB, 0.16745917E-09_JPRB, &
  & 0.16757082E-09_JPRB, 0.16766520E-09_JPRB, 0.16774894E-09_JPRB, 0.16782667E-09_JPRB, 0.16789986E-09_JPRB, 0.16796925E-09_JPRB, &
  & 0.16802940E-09_JPRB, 0.16807873E-09_JPRB, 0.16811240E-09_JPRB, 0.16813113E-09_JPRB, 0.16813584E-09_JPRB, 0.16812970E-09_JPRB, &
  & 0.16811484E-09_JPRB, 0.16809208E-09_JPRB, 0.16806055E-09_JPRB, 0.16801739E-09_JPRB, 0.16795748E-09_JPRB, 0.16787319E-09_JPRB, &
  & 0.16775470E-09_JPRB, 0.16759159E-09_JPRB, 0.16737831E-09_JPRB, 0.16711846E-09_JPRB, 0.16682881E-09_JPRB, 0.16652438E-09_JPRB, &
  & 0.16621514E-09_JPRB, 0.16590290E-09_JPRB, 0.16559114E-09_JPRB, 0.16528570E-09_JPRB, 0.16500852E-09_JPRB, 0.16476366E-09_JPRB, &
  & 0.16455570E-09_JPRB, 0.16436998E-09_JPRB, 0.16419849E-09_JPRB, 0.16403215E-09_JPRB, 0.16387197E-09_JPRB, 0.16372306E-09_JPRB, &
  & 0.16358964E-09_JPRB, 0.16346610E-09_JPRB, 0.16333299E-09_JPRB, 0.16310138E-09_JPRB /)

RGHG8(:,43,12) = (/ &
  & 0.16181287E-09_JPRB, 0.16197667E-09_JPRB, 0.16209446E-09_JPRB, 0.16222931E-09_JPRB, 0.16240174E-09_JPRB, 0.16259914E-09_JPRB, &
  & 0.16279592E-09_JPRB, 0.16297398E-09_JPRB, 0.16313240E-09_JPRB, 0.16327392E-09_JPRB, 0.16340937E-09_JPRB, 0.16354940E-09_JPRB, &
  & 0.16371732E-09_JPRB, 0.16393500E-09_JPRB, 0.16425439E-09_JPRB, 0.16470128E-09_JPRB, 0.16526945E-09_JPRB, 0.16585848E-09_JPRB, &
  & 0.16636947E-09_JPRB, 0.16676187E-09_JPRB, 0.16704470E-09_JPRB, 0.16724774E-09_JPRB, 0.16739862E-09_JPRB, 0.16751729E-09_JPRB, &
  & 0.16761573E-09_JPRB, 0.16770202E-09_JPRB, 0.16778058E-09_JPRB, 0.16785519E-09_JPRB, 0.16792684E-09_JPRB, 0.16799438E-09_JPRB, &
  & 0.16805389E-09_JPRB, 0.16810209E-09_JPRB, 0.16813573E-09_JPRB, 0.16815445E-09_JPRB, 0.16815960E-09_JPRB, 0.16815432E-09_JPRB, &
  & 0.16814097E-09_JPRB, 0.16812070E-09_JPRB, 0.16809287E-09_JPRB, 0.16805531E-09_JPRB, 0.16800385E-09_JPRB, 0.16793208E-09_JPRB, &
  & 0.16783165E-09_JPRB, 0.16769258E-09_JPRB, 0.16750737E-09_JPRB, 0.16727768E-09_JPRB, 0.16701521E-09_JPRB, 0.16673596E-09_JPRB, &
  & 0.16644769E-09_JPRB, 0.16615237E-09_JPRB, 0.16585111E-09_JPRB, 0.16555893E-09_JPRB, 0.16529147E-09_JPRB, 0.16506568E-09_JPRB, &
  & 0.16487663E-09_JPRB, 0.16471363E-09_JPRB, 0.16456435E-09_JPRB, 0.16442185E-09_JPRB, 0.16428553E-09_JPRB, 0.16415967E-09_JPRB, &
  & 0.16404696E-09_JPRB, 0.16394176E-09_JPRB, 0.16382642E-09_JPRB, 0.16362275E-09_JPRB /)

RGHG8(:,44,12) = (/ &
  & 0.16254820E-09_JPRB, 0.16270260E-09_JPRB, 0.16281573E-09_JPRB, 0.16294649E-09_JPRB, 0.16311286E-09_JPRB, 0.16330226E-09_JPRB, &
  & 0.16348407E-09_JPRB, 0.16364619E-09_JPRB, 0.16378798E-09_JPRB, 0.16391470E-09_JPRB, 0.16403387E-09_JPRB, 0.16415802E-09_JPRB, &
  & 0.16430134E-09_JPRB, 0.16449309E-09_JPRB, 0.16476545E-09_JPRB, 0.16516735E-09_JPRB, 0.16567270E-09_JPRB, 0.16619073E-09_JPRB, &
  & 0.16662485E-09_JPRB, 0.16694462E-09_JPRB, 0.16717133E-09_JPRB, 0.16733556E-09_JPRB, 0.16746142E-09_JPRB, 0.16756388E-09_JPRB, &
  & 0.16765234E-09_JPRB, 0.16773270E-09_JPRB, 0.16780838E-09_JPRB, 0.16788115E-09_JPRB, 0.16795254E-09_JPRB, 0.16801899E-09_JPRB, &
  & 0.16807764E-09_JPRB, 0.16812479E-09_JPRB, 0.16815778E-09_JPRB, 0.16817611E-09_JPRB, 0.16818112E-09_JPRB, 0.16817608E-09_JPRB, &
  & 0.16816364E-09_JPRB, 0.16814514E-09_JPRB, 0.16812028E-09_JPRB, 0.16808741E-09_JPRB, 0.16804318E-09_JPRB, 0.16798252E-09_JPRB, &
  & 0.16789817E-09_JPRB, 0.16778105E-09_JPRB, 0.16762271E-09_JPRB, 0.16742126E-09_JPRB, 0.16718667E-09_JPRB, 0.16693236E-09_JPRB, &
  & 0.16666638E-09_JPRB, 0.16638955E-09_JPRB, 0.16610581E-09_JPRB, 0.16582626E-09_JPRB, 0.16557591E-09_JPRB, 0.16536884E-09_JPRB, &
  & 0.16519948E-09_JPRB, 0.16505725E-09_JPRB, 0.16492871E-09_JPRB, 0.16480815E-09_JPRB, 0.16469479E-09_JPRB, 0.16459173E-09_JPRB, &
  & 0.16450022E-09_JPRB, 0.16441443E-09_JPRB, 0.16431939E-09_JPRB, 0.16414886E-09_JPRB /)

RGHG8(:,45,12) = (/ &
  & 0.16322628E-09_JPRB, 0.16337899E-09_JPRB, 0.16348745E-09_JPRB, 0.16361566E-09_JPRB, 0.16377766E-09_JPRB, 0.16395985E-09_JPRB, &
  & 0.16413110E-09_JPRB, 0.16428130E-09_JPRB, 0.16441126E-09_JPRB, 0.16452567E-09_JPRB, 0.16463164E-09_JPRB, 0.16473964E-09_JPRB, &
  & 0.16486326E-09_JPRB, 0.16502495E-09_JPRB, 0.16525967E-09_JPRB, 0.16560543E-09_JPRB, 0.16604992E-09_JPRB, 0.16649289E-09_JPRB, &
  & 0.16684422E-09_JPRB, 0.16709678E-09_JPRB, 0.16727505E-09_JPRB, 0.16740756E-09_JPRB, 0.16751260E-09_JPRB, 0.16760261E-09_JPRB, &
  & 0.16768312E-09_JPRB, 0.16775951E-09_JPRB, 0.16783346E-09_JPRB, 0.16790631E-09_JPRB, 0.16797762E-09_JPRB, 0.16804381E-09_JPRB, &
  & 0.16810141E-09_JPRB, 0.16814733E-09_JPRB, 0.16817925E-09_JPRB, 0.16819678E-09_JPRB, 0.16820123E-09_JPRB, 0.16819596E-09_JPRB, &
  & 0.16818391E-09_JPRB, 0.16816668E-09_JPRB, 0.16814417E-09_JPRB, 0.16811522E-09_JPRB, 0.16807733E-09_JPRB, 0.16802647E-09_JPRB, &
  & 0.16795701E-09_JPRB, 0.16786075E-09_JPRB, 0.16772879E-09_JPRB, 0.16755648E-09_JPRB, 0.16734918E-09_JPRB, 0.16712007E-09_JPRB, &
  & 0.16687729E-09_JPRB, 0.16662222E-09_JPRB, 0.16635655E-09_JPRB, 0.16609834E-09_JPRB, 0.16586829E-09_JPRB, 0.16568165E-09_JPRB, &
  & 0.16553341E-09_JPRB, 0.16540926E-09_JPRB, 0.16529997E-09_JPRB, 0.16519848E-09_JPRB, 0.16510546E-09_JPRB, 0.16502291E-09_JPRB, &
  & 0.16495055E-09_JPRB, 0.16488295E-09_JPRB, 0.16480736E-09_JPRB, 0.16467055E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART23',1,ZHOOK_HANDLE)
END SUBROUTINE PART23




SUBROUTINE PART24
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART24',0,ZHOOK_HANDLE)



RGHG8(:,46,12) = (/ &
  & 0.16386584E-09_JPRB, 0.16401490E-09_JPRB, 0.16412341E-09_JPRB, 0.16424730E-09_JPRB, 0.16440628E-09_JPRB, 0.16458096E-09_JPRB, &
  & 0.16474536E-09_JPRB, 0.16488677E-09_JPRB, 0.16500812E-09_JPRB, 0.16511154E-09_JPRB, 0.16520581E-09_JPRB, 0.16529797E-09_JPRB, &
  & 0.16540354E-09_JPRB, 0.16553636E-09_JPRB, 0.16573556E-09_JPRB, 0.16602540E-09_JPRB, 0.16640177E-09_JPRB, 0.16675886E-09_JPRB, &
  & 0.16703287E-09_JPRB, 0.16722340E-09_JPRB, 0.16736081E-09_JPRB, 0.16746689E-09_JPRB, 0.16755565E-09_JPRB, 0.16763496E-09_JPRB, &
  & 0.16771015E-09_JPRB, 0.16778338E-09_JPRB, 0.16785755E-09_JPRB, 0.16793060E-09_JPRB, 0.16800319E-09_JPRB, 0.16806895E-09_JPRB, &
  & 0.16812560E-09_JPRB, 0.16817010E-09_JPRB, 0.16820062E-09_JPRB, 0.16821693E-09_JPRB, 0.16822038E-09_JPRB, 0.16821450E-09_JPRB, &
  & 0.16820248E-09_JPRB, 0.16818597E-09_JPRB, 0.16816530E-09_JPRB, 0.16813970E-09_JPRB, 0.16810731E-09_JPRB, 0.16806542E-09_JPRB, &
  & 0.16800968E-09_JPRB, 0.16793363E-09_JPRB, 0.16782857E-09_JPRB, 0.16768655E-09_JPRB, 0.16750946E-09_JPRB, 0.16730713E-09_JPRB, &
  & 0.16708840E-09_JPRB, 0.16685542E-09_JPRB, 0.16661511E-09_JPRB, 0.16637709E-09_JPRB, 0.16617413E-09_JPRB, 0.16600932E-09_JPRB, &
  & 0.16588063E-09_JPRB, 0.16577469E-09_JPRB, 0.16568129E-09_JPRB, 0.16559690E-09_JPRB, 0.16552071E-09_JPRB, 0.16545484E-09_JPRB, &
  & 0.16539806E-09_JPRB, 0.16534533E-09_JPRB, 0.16528598E-09_JPRB, 0.16517869E-09_JPRB /)

RGHG8(:,47,12) = (/ &
  & 0.16447131E-09_JPRB, 0.16462243E-09_JPRB, 0.16472795E-09_JPRB, 0.16485077E-09_JPRB, 0.16500352E-09_JPRB, 0.16517421E-09_JPRB, &
  & 0.16533136E-09_JPRB, 0.16546842E-09_JPRB, 0.16558058E-09_JPRB, 0.16567503E-09_JPRB, 0.16575591E-09_JPRB, 0.16583540E-09_JPRB, &
  & 0.16591971E-09_JPRB, 0.16603241E-09_JPRB, 0.16618751E-09_JPRB, 0.16642862E-09_JPRB, 0.16672140E-09_JPRB, 0.16699418E-09_JPRB, &
  & 0.16719115E-09_JPRB, 0.16732933E-09_JPRB, 0.16743201E-09_JPRB, 0.16751669E-09_JPRB, 0.16759183E-09_JPRB, 0.16766324E-09_JPRB, &
  & 0.16773399E-09_JPRB, 0.16780605E-09_JPRB, 0.16788060E-09_JPRB, 0.16795586E-09_JPRB, 0.16802867E-09_JPRB, 0.16809497E-09_JPRB, &
  & 0.16815016E-09_JPRB, 0.16819314E-09_JPRB, 0.16822208E-09_JPRB, 0.16823676E-09_JPRB, 0.16823884E-09_JPRB, 0.16823201E-09_JPRB, &
  & 0.16821959E-09_JPRB, 0.16820356E-09_JPRB, 0.16818433E-09_JPRB, 0.16816151E-09_JPRB, 0.16813403E-09_JPRB, 0.16810014E-09_JPRB, &
  & 0.16805729E-09_JPRB, 0.16800081E-09_JPRB, 0.16792287E-09_JPRB, 0.16781503E-09_JPRB, 0.16767192E-09_JPRB, 0.16750028E-09_JPRB, &
  & 0.16730850E-09_JPRB, 0.16710176E-09_JPRB, 0.16688222E-09_JPRB, 0.16667610E-09_JPRB, 0.16649337E-09_JPRB, 0.16635435E-09_JPRB, &
  & 0.16624352E-09_JPRB, 0.16615320E-09_JPRB, 0.16607464E-09_JPRB, 0.16600342E-09_JPRB, 0.16594098E-09_JPRB, 0.16588775E-09_JPRB, &
  & 0.16584284E-09_JPRB, 0.16580110E-09_JPRB, 0.16575447E-09_JPRB, 0.16566891E-09_JPRB /)

RGHG8(:,48,12) = (/ &
  & 0.16504793E-09_JPRB, 0.16519944E-09_JPRB, 0.16530519E-09_JPRB, 0.16542494E-09_JPRB, 0.16557503E-09_JPRB, 0.16573984E-09_JPRB, &
  & 0.16589587E-09_JPRB, 0.16602576E-09_JPRB, 0.16613201E-09_JPRB, 0.16621457E-09_JPRB, 0.16628479E-09_JPRB, 0.16634837E-09_JPRB, &
  & 0.16641857E-09_JPRB, 0.16650289E-09_JPRB, 0.16662716E-09_JPRB, 0.16679992E-09_JPRB, 0.16701207E-09_JPRB, 0.16719481E-09_JPRB, &
  & 0.16732506E-09_JPRB, 0.16741759E-09_JPRB, 0.16749198E-09_JPRB, 0.16755863E-09_JPRB, 0.16762307E-09_JPRB, 0.16768797E-09_JPRB, &
  & 0.16775609E-09_JPRB, 0.16782781E-09_JPRB, 0.16790419E-09_JPRB, 0.16798098E-09_JPRB, 0.16805553E-09_JPRB, 0.16812106E-09_JPRB, &
  & 0.16817539E-09_JPRB, 0.16821655E-09_JPRB, 0.16824360E-09_JPRB, 0.16825641E-09_JPRB, 0.16825678E-09_JPRB, 0.16824869E-09_JPRB, &
  & 0.16823570E-09_JPRB, 0.16821979E-09_JPRB, 0.16820162E-09_JPRB, 0.16818125E-09_JPRB, 0.16815808E-09_JPRB, 0.16813155E-09_JPRB, &
  & 0.16810062E-09_JPRB, 0.16806274E-09_JPRB, 0.16801266E-09_JPRB, 0.16794038E-09_JPRB, 0.16783873E-09_JPRB, 0.16770504E-09_JPRB, &
  & 0.16754577E-09_JPRB, 0.16736619E-09_JPRB, 0.16717769E-09_JPRB, 0.16699180E-09_JPRB, 0.16684046E-09_JPRB, 0.16671893E-09_JPRB, &
  & 0.16662620E-09_JPRB, 0.16654922E-09_JPRB, 0.16648191E-09_JPRB, 0.16642177E-09_JPRB, 0.16636895E-09_JPRB, 0.16632515E-09_JPRB, &
  & 0.16628825E-09_JPRB, 0.16625439E-09_JPRB, 0.16621603E-09_JPRB, 0.16614646E-09_JPRB /)

RGHG8(:,49,12) = (/ &
  & 0.16559476E-09_JPRB, 0.16574617E-09_JPRB, 0.16585275E-09_JPRB, 0.16597132E-09_JPRB, 0.16611962E-09_JPRB, 0.16628425E-09_JPRB, &
  & 0.16643760E-09_JPRB, 0.16656523E-09_JPRB, 0.16666069E-09_JPRB, 0.16673296E-09_JPRB, 0.16678926E-09_JPRB, 0.16683949E-09_JPRB, &
  & 0.16689046E-09_JPRB, 0.16695074E-09_JPRB, 0.16703164E-09_JPRB, 0.16713889E-09_JPRB, 0.16726266E-09_JPRB, 0.16736522E-09_JPRB, &
  & 0.16743698E-09_JPRB, 0.16749239E-09_JPRB, 0.16754285E-09_JPRB, 0.16759474E-09_JPRB, 0.16765012E-09_JPRB, 0.16771048E-09_JPRB, &
  & 0.16777704E-09_JPRB, 0.16784975E-09_JPRB, 0.16792828E-09_JPRB, 0.16800747E-09_JPRB, 0.16808237E-09_JPRB, 0.16814794E-09_JPRB, &
  & 0.16820079E-09_JPRB, 0.16824037E-09_JPRB, 0.16826533E-09_JPRB, 0.16827589E-09_JPRB, 0.16827428E-09_JPRB, 0.16826475E-09_JPRB, &
  & 0.16825093E-09_JPRB, 0.16823493E-09_JPRB, 0.16821762E-09_JPRB, 0.16819933E-09_JPRB, 0.16818008E-09_JPRB, 0.16816026E-09_JPRB, &
  & 0.16814050E-09_JPRB, 0.16812046E-09_JPRB, 0.16809674E-09_JPRB, 0.16806202E-09_JPRB, 0.16800519E-09_JPRB, 0.16791914E-09_JPRB, &
  & 0.16780216E-09_JPRB, 0.16765871E-09_JPRB, 0.16749947E-09_JPRB, 0.16734704E-09_JPRB, 0.16721723E-09_JPRB, 0.16711744E-09_JPRB, &
  & 0.16703824E-09_JPRB, 0.16697255E-09_JPRB, 0.16691414E-09_JPRB, 0.16686143E-09_JPRB, 0.16681560E-09_JPRB, 0.16677749E-09_JPRB, &
  & 0.16674589E-09_JPRB, 0.16671668E-09_JPRB, 0.16668367E-09_JPRB, 0.16662299E-09_JPRB /)

RGHG8(:,50,12) = (/ &
  & 0.16610327E-09_JPRB, 0.16626045E-09_JPRB, 0.16636371E-09_JPRB, 0.16648521E-09_JPRB, 0.16663312E-09_JPRB, 0.16680129E-09_JPRB, &
  & 0.16695435E-09_JPRB, 0.16707286E-09_JPRB, 0.16715525E-09_JPRB, 0.16721061E-09_JPRB, 0.16725082E-09_JPRB, 0.16728358E-09_JPRB, &
  & 0.16731275E-09_JPRB, 0.16734567E-09_JPRB, 0.16738047E-09_JPRB, 0.16742671E-09_JPRB, 0.16747198E-09_JPRB, 0.16750749E-09_JPRB, &
  & 0.16753185E-09_JPRB, 0.16755641E-09_JPRB, 0.16758728E-09_JPRB, 0.16762641E-09_JPRB, 0.16767424E-09_JPRB, 0.16773140E-09_JPRB, &
  & 0.16779761E-09_JPRB, 0.16787238E-09_JPRB, 0.16795322E-09_JPRB, 0.16803445E-09_JPRB, 0.16810994E-09_JPRB, 0.16817497E-09_JPRB, &
  & 0.16822657E-09_JPRB, 0.16826453E-09_JPRB, 0.16828713E-09_JPRB, 0.16829527E-09_JPRB, 0.16829152E-09_JPRB, 0.16828033E-09_JPRB, &
  & 0.16826553E-09_JPRB, 0.16824928E-09_JPRB, 0.16823259E-09_JPRB, 0.16821611E-09_JPRB, 0.16820040E-09_JPRB, 0.16818695E-09_JPRB, &
  & 0.16817778E-09_JPRB, 0.16817446E-09_JPRB, 0.16817589E-09_JPRB, 0.16817582E-09_JPRB, 0.16816416E-09_JPRB, 0.16812948E-09_JPRB, &
  & 0.16806470E-09_JPRB, 0.16796968E-09_JPRB, 0.16785359E-09_JPRB, 0.16773788E-09_JPRB, 0.16763738E-09_JPRB, 0.16755779E-09_JPRB, &
  & 0.16749273E-09_JPRB, 0.16743648E-09_JPRB, 0.16738594E-09_JPRB, 0.16733856E-09_JPRB, 0.16729715E-09_JPRB, 0.16726250E-09_JPRB, &
  & 0.16723345E-09_JPRB, 0.16720629E-09_JPRB, 0.16717505E-09_JPRB, 0.16711707E-09_JPRB /)

RGHG8(:,51,12) = (/ &
  & 0.16657650E-09_JPRB, 0.16672286E-09_JPRB, 0.16683493E-09_JPRB, 0.16695101E-09_JPRB, 0.16710613E-09_JPRB, 0.16727021E-09_JPRB, &
  & 0.16741544E-09_JPRB, 0.16751095E-09_JPRB, 0.16756782E-09_JPRB, 0.16760113E-09_JPRB, 0.16762169E-09_JPRB, 0.16763491E-09_JPRB, &
  & 0.16764468E-09_JPRB, 0.16765025E-09_JPRB, 0.16765350E-09_JPRB, 0.16765075E-09_JPRB, 0.16764173E-09_JPRB, 0.16762591E-09_JPRB, &
  & 0.16761333E-09_JPRB, 0.16761278E-09_JPRB, 0.16762668E-09_JPRB, 0.16765496E-09_JPRB, 0.16769675E-09_JPRB, 0.16775134E-09_JPRB, &
  & 0.16781868E-09_JPRB, 0.16789561E-09_JPRB, 0.16797932E-09_JPRB, 0.16806173E-09_JPRB, 0.16813768E-09_JPRB, 0.16820235E-09_JPRB, &
  & 0.16825266E-09_JPRB, 0.16828888E-09_JPRB, 0.16830917E-09_JPRB, 0.16831460E-09_JPRB, 0.16830859E-09_JPRB, 0.16829561E-09_JPRB, &
  & 0.16827970E-09_JPRB, 0.16826303E-09_JPRB, 0.16824681E-09_JPRB, 0.16823186E-09_JPRB, 0.16821949E-09_JPRB, 0.16821208E-09_JPRB, &
  & 0.16821317E-09_JPRB, 0.16822589E-09_JPRB, 0.16825012E-09_JPRB, 0.16828053E-09_JPRB, 0.16830681E-09_JPRB, 0.16831819E-09_JPRB, &
  & 0.16830584E-09_JPRB, 0.16826690E-09_JPRB, 0.16820753E-09_JPRB, 0.16813914E-09_JPRB, 0.16807690E-09_JPRB, 0.16802185E-09_JPRB, &
  & 0.16797452E-09_JPRB, 0.16793167E-09_JPRB, 0.16788945E-09_JPRB, 0.16784993E-09_JPRB, 0.16781299E-09_JPRB, 0.16778151E-09_JPRB, &
  & 0.16775446E-09_JPRB, 0.16772836E-09_JPRB, 0.16769691E-09_JPRB, 0.16763824E-09_JPRB /)

RGHG8(:,52,12) = (/ &
  & 0.16698497E-09_JPRB, 0.16714438E-09_JPRB, 0.16723971E-09_JPRB, 0.16736548E-09_JPRB, 0.16750507E-09_JPRB, 0.16765896E-09_JPRB, &
  & 0.16776536E-09_JPRB, 0.16782585E-09_JPRB, 0.16785465E-09_JPRB, 0.16786800E-09_JPRB, 0.16787341E-09_JPRB, 0.16787417E-09_JPRB, &
  & 0.16787112E-09_JPRB, 0.16786245E-09_JPRB, 0.16784817E-09_JPRB, 0.16781854E-09_JPRB, 0.16777681E-09_JPRB, 0.16772590E-09_JPRB, &
  & 0.16768449E-09_JPRB, 0.16766318E-09_JPRB, 0.16766269E-09_JPRB, 0.16768156E-09_JPRB, 0.16771806E-09_JPRB, 0.16777182E-09_JPRB, &
  & 0.16784006E-09_JPRB, 0.16792015E-09_JPRB, 0.16800555E-09_JPRB, 0.16808964E-09_JPRB, 0.16816544E-09_JPRB, 0.16822999E-09_JPRB, &
  & 0.16827921E-09_JPRB, 0.16831347E-09_JPRB, 0.16833140E-09_JPRB, 0.16833406E-09_JPRB, 0.16832558E-09_JPRB, 0.16831077E-09_JPRB, &
  & 0.16829366E-09_JPRB, 0.16827648E-09_JPRB, 0.16826052E-09_JPRB, 0.16824694E-09_JPRB, 0.16823766E-09_JPRB, 0.16823619E-09_JPRB, &
  & 0.16824739E-09_JPRB, 0.16827537E-09_JPRB, 0.16832012E-09_JPRB, 0.16837473E-09_JPRB, 0.16842946E-09_JPRB, 0.16847368E-09_JPRB, &
  & 0.16850055E-09_JPRB, 0.16850725E-09_JPRB, 0.16849608E-09_JPRB, 0.16847412E-09_JPRB, 0.16844744E-09_JPRB, 0.16842118E-09_JPRB, &
  & 0.16839513E-09_JPRB, 0.16836851E-09_JPRB, 0.16834192E-09_JPRB, 0.16831317E-09_JPRB, 0.16828622E-09_JPRB, 0.16826202E-09_JPRB, &
  & 0.16824049E-09_JPRB, 0.16821888E-09_JPRB, 0.16819188E-09_JPRB, 0.16813702E-09_JPRB /)

RGHG8(:,53,12) = (/ &
  & 0.16735172E-09_JPRB, 0.16748199E-09_JPRB, 0.16759336E-09_JPRB, 0.16769196E-09_JPRB, 0.16782298E-09_JPRB, 0.16792784E-09_JPRB, &
  & 0.16799413E-09_JPRB, 0.16802131E-09_JPRB, 0.16803171E-09_JPRB, 0.16803406E-09_JPRB, 0.16803234E-09_JPRB, 0.16802784E-09_JPRB, &
  & 0.16801940E-09_JPRB, 0.16800758E-09_JPRB, 0.16798282E-09_JPRB, 0.16794786E-09_JPRB, 0.16788522E-09_JPRB, 0.16781171E-09_JPRB, &
  & 0.16774798E-09_JPRB, 0.16770887E-09_JPRB, 0.16769611E-09_JPRB, 0.16770711E-09_JPRB, 0.16773997E-09_JPRB, 0.16779261E-09_JPRB, &
  & 0.16786315E-09_JPRB, 0.16794502E-09_JPRB, 0.16803285E-09_JPRB, 0.16811758E-09_JPRB, 0.16819379E-09_JPRB, 0.16825785E-09_JPRB, &
  & 0.16830620E-09_JPRB, 0.16833852E-09_JPRB, 0.16835389E-09_JPRB, 0.16835369E-09_JPRB, 0.16834274E-09_JPRB, 0.16832596E-09_JPRB, &
  & 0.16830766E-09_JPRB, 0.16828990E-09_JPRB, 0.16827410E-09_JPRB, 0.16826174E-09_JPRB, 0.16825544E-09_JPRB, 0.16825971E-09_JPRB, &
  & 0.16828067E-09_JPRB, 0.16832331E-09_JPRB, 0.16838515E-09_JPRB, 0.16845918E-09_JPRB, 0.16853224E-09_JPRB, 0.16859654E-09_JPRB, &
  & 0.16864557E-09_JPRB, 0.16867732E-09_JPRB, 0.16869262E-09_JPRB, 0.16869586E-09_JPRB, 0.16869173E-09_JPRB, 0.16868365E-09_JPRB, &
  & 0.16867346E-09_JPRB, 0.16866172E-09_JPRB, 0.16864748E-09_JPRB, 0.16863236E-09_JPRB, 0.16861654E-09_JPRB, 0.16860224E-09_JPRB, &
  & 0.16858964E-09_JPRB, 0.16857701E-09_JPRB, 0.16856098E-09_JPRB, 0.16852494E-09_JPRB /)

RGHG8(:,54,12) = (/ &
  & 0.16763835E-09_JPRB, 0.16778247E-09_JPRB, 0.16785814E-09_JPRB, 0.16795619E-09_JPRB, 0.16803955E-09_JPRB, 0.16810667E-09_JPRB, &
  & 0.16813476E-09_JPRB, 0.16814347E-09_JPRB, 0.16814432E-09_JPRB, 0.16814183E-09_JPRB, 0.16813750E-09_JPRB, 0.16813118E-09_JPRB, &
  & 0.16812285E-09_JPRB, 0.16810797E-09_JPRB, 0.16808777E-09_JPRB, 0.16804338E-09_JPRB, 0.16797855E-09_JPRB, 0.16788770E-09_JPRB, &
  & 0.16780510E-09_JPRB, 0.16775110E-09_JPRB, 0.16772780E-09_JPRB, 0.16773259E-09_JPRB, 0.16776248E-09_JPRB, 0.16781551E-09_JPRB, &
  & 0.16788686E-09_JPRB, 0.16797139E-09_JPRB, 0.16806030E-09_JPRB, 0.16814643E-09_JPRB, 0.16822269E-09_JPRB, 0.16828625E-09_JPRB, &
  & 0.16833365E-09_JPRB, 0.16836409E-09_JPRB, 0.16837687E-09_JPRB, 0.16837380E-09_JPRB, 0.16836035E-09_JPRB, 0.16834158E-09_JPRB, &
  & 0.16832206E-09_JPRB, 0.16830363E-09_JPRB, 0.16828797E-09_JPRB, 0.16827675E-09_JPRB, 0.16827323E-09_JPRB, 0.16828298E-09_JPRB, &
  & 0.16831350E-09_JPRB, 0.16836864E-09_JPRB, 0.16844648E-09_JPRB, 0.16853308E-09_JPRB, 0.16861940E-09_JPRB, 0.16869420E-09_JPRB, &
  & 0.16875366E-09_JPRB, 0.16879577E-09_JPRB, 0.16882208E-09_JPRB, 0.16883545E-09_JPRB, 0.16884090E-09_JPRB, 0.16884157E-09_JPRB, &
  & 0.16883948E-09_JPRB, 0.16883531E-09_JPRB, 0.16882959E-09_JPRB, 0.16882210E-09_JPRB, 0.16881438E-09_JPRB, 0.16880755E-09_JPRB, &
  & 0.16880194E-09_JPRB, 0.16879760E-09_JPRB, 0.16879427E-09_JPRB, 0.16879281E-09_JPRB /)

RGHG8(:,55,12) = (/ &
  & 0.16788877E-09_JPRB, 0.16799782E-09_JPRB, 0.16808009E-09_JPRB, 0.16813866E-09_JPRB, 0.16819476E-09_JPRB, 0.16822235E-09_JPRB, &
  & 0.16822950E-09_JPRB, 0.16822777E-09_JPRB, 0.16822410E-09_JPRB, 0.16821958E-09_JPRB, 0.16821439E-09_JPRB, 0.16820821E-09_JPRB, &
  & 0.16819940E-09_JPRB, 0.16818785E-09_JPRB, 0.16816443E-09_JPRB, 0.16812926E-09_JPRB, 0.16805603E-09_JPRB, 0.16795577E-09_JPRB, &
  & 0.16785801E-09_JPRB, 0.16779073E-09_JPRB, 0.16775907E-09_JPRB, 0.16775899E-09_JPRB, 0.16778699E-09_JPRB, 0.16783974E-09_JPRB, &
  & 0.16791270E-09_JPRB, 0.16799835E-09_JPRB, 0.16808936E-09_JPRB, 0.16817628E-09_JPRB, 0.16825279E-09_JPRB, 0.16831564E-09_JPRB, &
  & 0.16836191E-09_JPRB, 0.16839038E-09_JPRB, 0.16840054E-09_JPRB, 0.16839466E-09_JPRB, 0.16837870E-09_JPRB, 0.16835801E-09_JPRB, &
  & 0.16833712E-09_JPRB, 0.16831816E-09_JPRB, 0.16830261E-09_JPRB, 0.16829249E-09_JPRB, 0.16829174E-09_JPRB, 0.16830681E-09_JPRB, &
  & 0.16834528E-09_JPRB, 0.16841278E-09_JPRB, 0.16850096E-09_JPRB, 0.16860055E-09_JPRB, 0.16869352E-09_JPRB, 0.16877495E-09_JPRB, &
  & 0.16883869E-09_JPRB, 0.16888466E-09_JPRB, 0.16891372E-09_JPRB, 0.16893084E-09_JPRB, 0.16893967E-09_JPRB, 0.16894394E-09_JPRB, &
  & 0.16894543E-09_JPRB, 0.16894501E-09_JPRB, 0.16894294E-09_JPRB, 0.16893965E-09_JPRB, 0.16893550E-09_JPRB, 0.16893137E-09_JPRB, &
  & 0.16892771E-09_JPRB, 0.16892404E-09_JPRB, 0.16891982E-09_JPRB, 0.16891197E-09_JPRB /)

RGHG8(:,56,12) = (/ &
  & 0.16807788E-09_JPRB, 0.16818520E-09_JPRB, 0.16823570E-09_JPRB, 0.16827895E-09_JPRB, 0.16830283E-09_JPRB, 0.16830731E-09_JPRB, &
  & 0.16830122E-09_JPRB, 0.16829380E-09_JPRB, 0.16828791E-09_JPRB, 0.16828258E-09_JPRB, 0.16827721E-09_JPRB, 0.16827105E-09_JPRB, &
  & 0.16826360E-09_JPRB, 0.16825136E-09_JPRB, 0.16823390E-09_JPRB, 0.16819460E-09_JPRB, 0.16812854E-09_JPRB, 0.16801872E-09_JPRB, &
  & 0.16790688E-09_JPRB, 0.16782947E-09_JPRB, 0.16779111E-09_JPRB, 0.16778735E-09_JPRB, 0.16781396E-09_JPRB, 0.16786668E-09_JPRB, &
  & 0.16794019E-09_JPRB, 0.16802772E-09_JPRB, 0.16811993E-09_JPRB, 0.16820786E-09_JPRB, 0.16828451E-09_JPRB, 0.16834642E-09_JPRB, &
  & 0.16839130E-09_JPRB, 0.16841779E-09_JPRB, 0.16842537E-09_JPRB, 0.16841681E-09_JPRB, 0.16839838E-09_JPRB, 0.16837576E-09_JPRB, &
  & 0.16835364E-09_JPRB, 0.16833399E-09_JPRB, 0.16831861E-09_JPRB, 0.16830970E-09_JPRB, 0.16831167E-09_JPRB, 0.16833140E-09_JPRB, &
  & 0.16837776E-09_JPRB, 0.16845302E-09_JPRB, 0.16855356E-09_JPRB, 0.16865878E-09_JPRB, 0.16876033E-09_JPRB, 0.16884465E-09_JPRB, &
  & 0.16891050E-09_JPRB, 0.16895613E-09_JPRB, 0.16898589E-09_JPRB, 0.16900302E-09_JPRB, 0.16901289E-09_JPRB, 0.16901833E-09_JPRB, &
  & 0.16902123E-09_JPRB, 0.16902248E-09_JPRB, 0.16902232E-09_JPRB, 0.16902099E-09_JPRB, 0.16901883E-09_JPRB, 0.16901644E-09_JPRB, &
  & 0.16901405E-09_JPRB, 0.16901175E-09_JPRB, 0.16900911E-09_JPRB, 0.16900467E-09_JPRB /)

RGHG8(:,57,12) = (/ &
  & 0.16823631E-09_JPRB, 0.16832027E-09_JPRB, 0.16836085E-09_JPRB, 0.16838241E-09_JPRB, 0.16838667E-09_JPRB, 0.16837590E-09_JPRB, &
  & 0.16836146E-09_JPRB, 0.16835119E-09_JPRB, 0.16834410E-09_JPRB, 0.16833833E-09_JPRB, 0.16833296E-09_JPRB, 0.16832717E-09_JPRB, &
  & 0.16831965E-09_JPRB, 0.16830967E-09_JPRB, 0.16829052E-09_JPRB, 0.16825921E-09_JPRB, 0.16818824E-09_JPRB, 0.16807586E-09_JPRB, &
  & 0.16795444E-09_JPRB, 0.16786847E-09_JPRB, 0.16782538E-09_JPRB, 0.16781887E-09_JPRB, 0.16784422E-09_JPRB, 0.16789679E-09_JPRB, &
  & 0.16797105E-09_JPRB, 0.16805962E-09_JPRB, 0.16815299E-09_JPRB, 0.16824173E-09_JPRB, 0.16831811E-09_JPRB, 0.16837905E-09_JPRB, &
  & 0.16842253E-09_JPRB, 0.16844695E-09_JPRB, 0.16845207E-09_JPRB, 0.16844089E-09_JPRB, 0.16841997E-09_JPRB, 0.16839562E-09_JPRB, &
  & 0.16837214E-09_JPRB, 0.16835186E-09_JPRB, 0.16833654E-09_JPRB, 0.16832888E-09_JPRB, 0.16833349E-09_JPRB, 0.16835781E-09_JPRB, &
  & 0.16840955E-09_JPRB, 0.16849368E-09_JPRB, 0.16859908E-09_JPRB, 0.16871490E-09_JPRB, 0.16881936E-09_JPRB, 0.16890812E-09_JPRB, &
  & 0.16897359E-09_JPRB, 0.16901897E-09_JPRB, 0.16904653E-09_JPRB, 0.16906312E-09_JPRB, 0.16907259E-09_JPRB, 0.16907820E-09_JPRB, &
  & 0.16908155E-09_JPRB, 0.16908339E-09_JPRB, 0.16908407E-09_JPRB, 0.16908372E-09_JPRB, 0.16908254E-09_JPRB, 0.16908086E-09_JPRB, &
  & 0.16907908E-09_JPRB, 0.16907707E-09_JPRB, 0.16907444E-09_JPRB, 0.16906909E-09_JPRB /)

RGHG8(:,58,12) = (/ &
  & 0.16836375E-09_JPRB, 0.16843249E-09_JPRB, 0.16845822E-09_JPRB, 0.16846603E-09_JPRB, 0.16845716E-09_JPRB, 0.16843651E-09_JPRB, &
  & 0.16841802E-09_JPRB, 0.16840532E-09_JPRB, 0.16839755E-09_JPRB, 0.16839150E-09_JPRB, 0.16838603E-09_JPRB, 0.16838024E-09_JPRB, &
  & 0.16837334E-09_JPRB, 0.16836266E-09_JPRB, 0.16834650E-09_JPRB, 0.16831103E-09_JPRB, 0.16824597E-09_JPRB, 0.16812712E-09_JPRB, &
  & 0.16799991E-09_JPRB, 0.16790933E-09_JPRB, 0.16786264E-09_JPRB, 0.16785418E-09_JPRB, 0.16787885E-09_JPRB, 0.16793110E-09_JPRB, &
  & 0.16800594E-09_JPRB, 0.16809522E-09_JPRB, 0.16818949E-09_JPRB, 0.16827818E-09_JPRB, 0.16835436E-09_JPRB, 0.16841413E-09_JPRB, &
  & 0.16845599E-09_JPRB, 0.16847848E-09_JPRB, 0.16848119E-09_JPRB, 0.16846750E-09_JPRB, 0.16844427E-09_JPRB, 0.16841817E-09_JPRB, &
  & 0.16839341E-09_JPRB, 0.16837239E-09_JPRB, 0.16835711E-09_JPRB, 0.16835057E-09_JPRB, 0.16835774E-09_JPRB, 0.16838585E-09_JPRB, &
  & 0.16844338E-09_JPRB, 0.16853147E-09_JPRB, 0.16864550E-09_JPRB, 0.16876359E-09_JPRB, 0.16887602E-09_JPRB, 0.16896581E-09_JPRB, &
  & 0.16903247E-09_JPRB, 0.16907496E-09_JPRB, 0.16910133E-09_JPRB, 0.16911626E-09_JPRB, 0.16912499E-09_JPRB, 0.16913021E-09_JPRB, &
  & 0.16913340E-09_JPRB, 0.16913534E-09_JPRB, 0.16913623E-09_JPRB, 0.16913618E-09_JPRB, 0.16913536E-09_JPRB, 0.16913408E-09_JPRB, &
  & 0.16913254E-09_JPRB, 0.16913082E-09_JPRB, 0.16912859E-09_JPRB, 0.16912409E-09_JPRB /)

RGHG8(:,59,12) = (/ &
  & 0.16847299E-09_JPRB, 0.16852797E-09_JPRB, 0.16854028E-09_JPRB, 0.16853784E-09_JPRB, 0.16852159E-09_JPRB, 0.16849526E-09_JPRB, &
  & 0.16847299E-09_JPRB, 0.16845927E-09_JPRB, 0.16845075E-09_JPRB, 0.16844448E-09_JPRB, 0.16843893E-09_JPRB, 0.16843316E-09_JPRB, &
  & 0.16842588E-09_JPRB, 0.16841584E-09_JPRB, 0.16839738E-09_JPRB, 0.16836475E-09_JPRB, 0.16829255E-09_JPRB, 0.16817440E-09_JPRB, &
  & 0.16804491E-09_JPRB, 0.16795237E-09_JPRB, 0.16790386E-09_JPRB, 0.16789431E-09_JPRB, 0.16791846E-09_JPRB, 0.16797090E-09_JPRB, &
  & 0.16804579E-09_JPRB, 0.16813567E-09_JPRB, 0.16822972E-09_JPRB, 0.16831848E-09_JPRB, 0.16839360E-09_JPRB, 0.16845220E-09_JPRB, &
  & 0.16849264E-09_JPRB, 0.16851313E-09_JPRB, 0.16851352E-09_JPRB, 0.16849745E-09_JPRB, 0.16847201E-09_JPRB, 0.16844415E-09_JPRB, &
  & 0.16841811E-09_JPRB, 0.16839630E-09_JPRB, 0.16838095E-09_JPRB, 0.16837537E-09_JPRB, 0.16838476E-09_JPRB, 0.16841664E-09_JPRB, &
  & 0.16847791E-09_JPRB, 0.16857167E-09_JPRB, 0.16868743E-09_JPRB, 0.16881292E-09_JPRB, 0.16892671E-09_JPRB, 0.16902105E-09_JPRB, &
  & 0.16908616E-09_JPRB, 0.16912810E-09_JPRB, 0.16915189E-09_JPRB, 0.16916553E-09_JPRB, 0.16917333E-09_JPRB, 0.16917792E-09_JPRB, &
  & 0.16918078E-09_JPRB, 0.16918242E-09_JPRB, 0.16918320E-09_JPRB, 0.16918310E-09_JPRB, 0.16918228E-09_JPRB, 0.16918100E-09_JPRB, &
  & 0.16917953E-09_JPRB, 0.16917778E-09_JPRB, 0.16917537E-09_JPRB, 0.16917044E-09_JPRB /)

RGHG8(:,60,12) = (/ &
  & 0.16860147E-09_JPRB, 0.16861416E-09_JPRB, 0.16861396E-09_JPRB, 0.16860482E-09_JPRB, 0.16858198E-09_JPRB, 0.16855381E-09_JPRB, &
  & 0.16852972E-09_JPRB, 0.16851404E-09_JPRB, 0.16850522E-09_JPRB, 0.16849866E-09_JPRB, 0.16849298E-09_JPRB, 0.16848702E-09_JPRB, &
  & 0.16847965E-09_JPRB, 0.16846843E-09_JPRB, 0.16845000E-09_JPRB, 0.16841174E-09_JPRB, 0.16833837E-09_JPRB, 0.16821708E-09_JPRB, &
  & 0.16809060E-09_JPRB, 0.16799878E-09_JPRB, 0.16794990E-09_JPRB, 0.16794004E-09_JPRB, 0.16796431E-09_JPRB, 0.16801671E-09_JPRB, &
  & 0.16809192E-09_JPRB, 0.16818140E-09_JPRB, 0.16827520E-09_JPRB, 0.16836266E-09_JPRB, 0.16843686E-09_JPRB, 0.16849393E-09_JPRB, &
  & 0.16853277E-09_JPRB, 0.16855146E-09_JPRB, 0.16854965E-09_JPRB, 0.16853127E-09_JPRB, 0.16850382E-09_JPRB, 0.16847437E-09_JPRB, &
  & 0.16844698E-09_JPRB, 0.16842426E-09_JPRB, 0.16840865E-09_JPRB, 0.16840386E-09_JPRB, 0.16841535E-09_JPRB, 0.16845017E-09_JPRB, &
  & 0.16851565E-09_JPRB, 0.16861182E-09_JPRB, 0.16873197E-09_JPRB, 0.16885768E-09_JPRB, 0.16897685E-09_JPRB, 0.16907131E-09_JPRB, &
  & 0.16913823E-09_JPRB, 0.16917774E-09_JPRB, 0.16920043E-09_JPRB, 0.16921271E-09_JPRB, 0.16921947E-09_JPRB, 0.16922343E-09_JPRB, &
  & 0.16922568E-09_JPRB, 0.16922694E-09_JPRB, 0.16922727E-09_JPRB, 0.16922683E-09_JPRB, 0.16922577E-09_JPRB, 0.16922433E-09_JPRB, &
  & 0.16922266E-09_JPRB, 0.16922080E-09_JPRB, 0.16921833E-09_JPRB, 0.16921342E-09_JPRB /)

RGHG8(:,61,12) = (/ &
  & 0.16867424E-09_JPRB, 0.16868387E-09_JPRB, 0.16867985E-09_JPRB, 0.16866614E-09_JPRB, 0.16864432E-09_JPRB, 0.16861344E-09_JPRB, &
  & 0.16858756E-09_JPRB, 0.16857099E-09_JPRB, 0.16856133E-09_JPRB, 0.16855471E-09_JPRB, 0.16854895E-09_JPRB, 0.16854296E-09_JPRB, &
  & 0.16853516E-09_JPRB, 0.16852336E-09_JPRB, 0.16850171E-09_JPRB, 0.16846036E-09_JPRB, 0.16837987E-09_JPRB, 0.16826056E-09_JPRB, &
  & 0.16813900E-09_JPRB, 0.16804982E-09_JPRB, 0.16800182E-09_JPRB, 0.16799243E-09_JPRB, 0.16801704E-09_JPRB, 0.16806992E-09_JPRB, &
  & 0.16814473E-09_JPRB, 0.16823386E-09_JPRB, 0.16832619E-09_JPRB, 0.16841240E-09_JPRB, 0.16848464E-09_JPRB, 0.16854018E-09_JPRB, &
  & 0.16857737E-09_JPRB, 0.16859428E-09_JPRB, 0.16859042E-09_JPRB, 0.16856991E-09_JPRB, 0.16854060E-09_JPRB, 0.16850951E-09_JPRB, &
  & 0.16848076E-09_JPRB, 0.16845692E-09_JPRB, 0.16844090E-09_JPRB, 0.16843665E-09_JPRB, 0.16844978E-09_JPRB, 0.16848753E-09_JPRB, &
  & 0.16855579E-09_JPRB, 0.16865519E-09_JPRB, 0.16877599E-09_JPRB, 0.16890409E-09_JPRB, 0.16902267E-09_JPRB, 0.16912055E-09_JPRB, &
  & 0.16918641E-09_JPRB, 0.16922651E-09_JPRB, 0.16924773E-09_JPRB, 0.16925888E-09_JPRB, 0.16926480E-09_JPRB, 0.16926788E-09_JPRB, &
  & 0.16926949E-09_JPRB, 0.16927010E-09_JPRB, 0.16926988E-09_JPRB, 0.16926895E-09_JPRB, 0.16926741E-09_JPRB, 0.16926552E-09_JPRB, &
  & 0.16926349E-09_JPRB, 0.16926122E-09_JPRB, 0.16925830E-09_JPRB, 0.16925261E-09_JPRB /)

RGHG8(:,62,12) = (/ &
  & 0.16874616E-09_JPRB, 0.16874974E-09_JPRB, 0.16874263E-09_JPRB, 0.16872917E-09_JPRB, 0.16870481E-09_JPRB, 0.16867555E-09_JPRB, &
  & 0.16864782E-09_JPRB, 0.16862875E-09_JPRB, 0.16861901E-09_JPRB, 0.16861221E-09_JPRB, 0.16860698E-09_JPRB, 0.16860122E-09_JPRB, &
  & 0.16859342E-09_JPRB, 0.16858023E-09_JPRB, 0.16855599E-09_JPRB, 0.16850817E-09_JPRB, 0.16842346E-09_JPRB, 0.16830731E-09_JPRB, &
  & 0.16819222E-09_JPRB, 0.16810681E-09_JPRB, 0.16806077E-09_JPRB, 0.16805261E-09_JPRB, 0.16807808E-09_JPRB, 0.16813120E-09_JPRB, &
  & 0.16820577E-09_JPRB, 0.16829362E-09_JPRB, 0.16838428E-09_JPRB, 0.16846810E-09_JPRB, 0.16853839E-09_JPRB, 0.16859181E-09_JPRB, &
  & 0.16862731E-09_JPRB, 0.16864246E-09_JPRB, 0.16863669E-09_JPRB, 0.16861422E-09_JPRB, 0.16858312E-09_JPRB, 0.16855056E-09_JPRB, &
  & 0.16852020E-09_JPRB, 0.16849519E-09_JPRB, 0.16847847E-09_JPRB, 0.16847450E-09_JPRB, 0.16848901E-09_JPRB, 0.16852897E-09_JPRB, &
  & 0.16859986E-09_JPRB, 0.16870108E-09_JPRB, 0.16882287E-09_JPRB, 0.16894990E-09_JPRB, 0.16906913E-09_JPRB, 0.16916596E-09_JPRB, &
  & 0.16923429E-09_JPRB, 0.16927362E-09_JPRB, 0.16929461E-09_JPRB, 0.16930488E-09_JPRB, 0.16930979E-09_JPRB, 0.16931206E-09_JPRB, &
  & 0.16931284E-09_JPRB, 0.16931267E-09_JPRB, 0.16931173E-09_JPRB, 0.16931000E-09_JPRB, 0.16930773E-09_JPRB, 0.16930524E-09_JPRB, &
  & 0.16930260E-09_JPRB, 0.16929982E-09_JPRB, 0.16929638E-09_JPRB, 0.16928983E-09_JPRB /)

RGHG8(:,63,12) = (/ &
  & 0.16881174E-09_JPRB, 0.16881345E-09_JPRB, 0.16880568E-09_JPRB, 0.16879090E-09_JPRB, 0.16876907E-09_JPRB, 0.16873872E-09_JPRB, &
  & 0.16870938E-09_JPRB, 0.16868837E-09_JPRB, 0.16867731E-09_JPRB, 0.16867116E-09_JPRB, 0.16866661E-09_JPRB, 0.16866214E-09_JPRB, &
  & 0.16865460E-09_JPRB, 0.16864057E-09_JPRB, 0.16861233E-09_JPRB, 0.16855925E-09_JPRB, 0.16847247E-09_JPRB, 0.16836130E-09_JPRB, &
  & 0.16825252E-09_JPRB, 0.16817139E-09_JPRB, 0.16812804E-09_JPRB, 0.16812171E-09_JPRB, 0.16814827E-09_JPRB, 0.16820167E-09_JPRB, &
  & 0.16827550E-09_JPRB, 0.16836184E-09_JPRB, 0.16844989E-09_JPRB, 0.16853116E-09_JPRB, 0.16859861E-09_JPRB, 0.16864986E-09_JPRB, &
  & 0.16868343E-09_JPRB, 0.16869686E-09_JPRB, 0.16868933E-09_JPRB, 0.16866512E-09_JPRB, 0.16863246E-09_JPRB, 0.16859839E-09_JPRB, &
  & 0.16856652E-09_JPRB, 0.16854002E-09_JPRB, 0.16852242E-09_JPRB, 0.16851837E-09_JPRB, 0.16853383E-09_JPRB, 0.16857550E-09_JPRB, &
  & 0.16864832E-09_JPRB, 0.16875057E-09_JPRB, 0.16887237E-09_JPRB, 0.16899811E-09_JPRB, 0.16911479E-09_JPRB, 0.16921192E-09_JPRB, &
  & 0.16927977E-09_JPRB, 0.16932075E-09_JPRB, 0.16934146E-09_JPRB, 0.16935101E-09_JPRB, 0.16935503E-09_JPRB, 0.16935633E-09_JPRB, &
  & 0.16935620E-09_JPRB, 0.16935511E-09_JPRB, 0.16935317E-09_JPRB, 0.16935055E-09_JPRB, 0.16934733E-09_JPRB, 0.16934390E-09_JPRB, &
  & 0.16934056E-09_JPRB, 0.16933704E-09_JPRB, 0.16933271E-09_JPRB, 0.16932482E-09_JPRB /)

RGHG8(:,64,12) = (/ &
  & 0.16887708E-09_JPRB, 0.16887716E-09_JPRB, 0.16886875E-09_JPRB, 0.16885493E-09_JPRB, 0.16883307E-09_JPRB, 0.16880403E-09_JPRB, &
  & 0.16877291E-09_JPRB, 0.16874836E-09_JPRB, 0.16873712E-09_JPRB, 0.16873104E-09_JPRB, 0.16872831E-09_JPRB, 0.16872545E-09_JPRB, &
  & 0.16871904E-09_JPRB, 0.16870370E-09_JPRB, 0.16867230E-09_JPRB, 0.16861587E-09_JPRB, 0.16852944E-09_JPRB, 0.16842305E-09_JPRB, &
  & 0.16832037E-09_JPRB, 0.16824415E-09_JPRB, 0.16820433E-09_JPRB, 0.16820020E-09_JPRB, 0.16822792E-09_JPRB, 0.16828137E-09_JPRB, &
  & 0.16835411E-09_JPRB, 0.16843806E-09_JPRB, 0.16852307E-09_JPRB, 0.16860090E-09_JPRB, 0.16866526E-09_JPRB, 0.16871375E-09_JPRB, &
  & 0.16874530E-09_JPRB, 0.16875701E-09_JPRB, 0.16874796E-09_JPRB, 0.16872242E-09_JPRB, 0.16868860E-09_JPRB, 0.16865331E-09_JPRB, &
  & 0.16862005E-09_JPRB, 0.16859207E-09_JPRB, 0.16857334E-09_JPRB, 0.16856885E-09_JPRB, 0.16858476E-09_JPRB, 0.16862757E-09_JPRB, &
  & 0.16870136E-09_JPRB, 0.16880412E-09_JPRB, 0.16892468E-09_JPRB, 0.16904836E-09_JPRB, 0.16916230E-09_JPRB, 0.16925679E-09_JPRB, &
  & 0.16932539E-09_JPRB, 0.16936685E-09_JPRB, 0.16938820E-09_JPRB, 0.16939732E-09_JPRB, 0.16940044E-09_JPRB, 0.16940074E-09_JPRB, &
  & 0.16939952E-09_JPRB, 0.16939725E-09_JPRB, 0.16939419E-09_JPRB, 0.16939028E-09_JPRB, 0.16938595E-09_JPRB, 0.16938154E-09_JPRB, &
  & 0.16937715E-09_JPRB, 0.16937264E-09_JPRB, 0.16936716E-09_JPRB, 0.16935710E-09_JPRB /)

RGHG8(:,65,12) = (/ &
  & 0.16894261E-09_JPRB, 0.16894160E-09_JPRB, 0.16893326E-09_JPRB, 0.16891957E-09_JPRB, 0.16889912E-09_JPRB, 0.16887039E-09_JPRB, &
  & 0.16883769E-09_JPRB, 0.16881060E-09_JPRB, 0.16879850E-09_JPRB, 0.16879355E-09_JPRB, 0.16879255E-09_JPRB, 0.16879186E-09_JPRB, &
  & 0.16878621E-09_JPRB, 0.16877030E-09_JPRB, 0.16873687E-09_JPRB, 0.16867928E-09_JPRB, 0.16859486E-09_JPRB, 0.16849347E-09_JPRB, &
  & 0.16839698E-09_JPRB, 0.16832598E-09_JPRB, 0.16828977E-09_JPRB, 0.16828804E-09_JPRB, 0.16831672E-09_JPRB, 0.16836976E-09_JPRB, &
  & 0.16844064E-09_JPRB, 0.16852150E-09_JPRB, 0.16860253E-09_JPRB, 0.16867632E-09_JPRB, 0.16873689E-09_JPRB, 0.16878236E-09_JPRB, &
  & 0.16881160E-09_JPRB, 0.16882169E-09_JPRB, 0.16881148E-09_JPRB, 0.16878517E-09_JPRB, 0.16875085E-09_JPRB, 0.16871503E-09_JPRB, &
  & 0.16868074E-09_JPRB, 0.16865151E-09_JPRB, 0.16863164E-09_JPRB, 0.16862647E-09_JPRB, 0.16864239E-09_JPRB, 0.16868559E-09_JPRB, &
  & 0.16875978E-09_JPRB, 0.16886145E-09_JPRB, 0.16898039E-09_JPRB, 0.16910082E-09_JPRB, 0.16921134E-09_JPRB, 0.16930297E-09_JPRB, &
  & 0.16937014E-09_JPRB, 0.16941244E-09_JPRB, 0.16943441E-09_JPRB, 0.16944338E-09_JPRB, 0.16944578E-09_JPRB, 0.16944497E-09_JPRB, &
  & 0.16944256E-09_JPRB, 0.16943913E-09_JPRB, 0.16943467E-09_JPRB, 0.16942955E-09_JPRB, 0.16942386E-09_JPRB, 0.16941810E-09_JPRB, &
  & 0.16941254E-09_JPRB, 0.16940663E-09_JPRB, 0.16939940E-09_JPRB, 0.16938613E-09_JPRB /)

RGHG8(:,66,12) = (/ &
  & 0.16900441E-09_JPRB, 0.16900580E-09_JPRB, 0.16899838E-09_JPRB, 0.16898577E-09_JPRB, 0.16896619E-09_JPRB, 0.16893795E-09_JPRB, &
  & 0.16890458E-09_JPRB, 0.16887505E-09_JPRB, 0.16886334E-09_JPRB, 0.16885961E-09_JPRB, 0.16886052E-09_JPRB, 0.16886148E-09_JPRB, &
  & 0.16885662E-09_JPRB, 0.16884058E-09_JPRB, 0.16880652E-09_JPRB, 0.16874978E-09_JPRB, 0.16866814E-09_JPRB, 0.16857210E-09_JPRB, &
  & 0.16848192E-09_JPRB, 0.16841650E-09_JPRB, 0.16838421E-09_JPRB, 0.16838463E-09_JPRB, 0.16841382E-09_JPRB, 0.16846555E-09_JPRB, &
  & 0.16853378E-09_JPRB, 0.16861042E-09_JPRB, 0.16868679E-09_JPRB, 0.16875568E-09_JPRB, 0.16881202E-09_JPRB, 0.16885403E-09_JPRB, &
  & 0.16888090E-09_JPRB, 0.16888939E-09_JPRB, 0.16887834E-09_JPRB, 0.16885189E-09_JPRB, 0.16881797E-09_JPRB, 0.16878249E-09_JPRB, &
  & 0.16874807E-09_JPRB, 0.16871807E-09_JPRB, 0.16869739E-09_JPRB, 0.16869156E-09_JPRB, 0.16870715E-09_JPRB, 0.16875010E-09_JPRB, &
  & 0.16882339E-09_JPRB, 0.16892347E-09_JPRB, 0.16903898E-09_JPRB, 0.16915584E-09_JPRB, 0.16926213E-09_JPRB, 0.16935023E-09_JPRB, &
  & 0.16941526E-09_JPRB, 0.16945725E-09_JPRB, 0.16947978E-09_JPRB, 0.16948899E-09_JPRB, 0.16949091E-09_JPRB, 0.16948914E-09_JPRB, &
  & 0.16948565E-09_JPRB, 0.16948083E-09_JPRB, 0.16947516E-09_JPRB, 0.16946845E-09_JPRB, 0.16946139E-09_JPRB, 0.16945431E-09_JPRB, &
  & 0.16944716E-09_JPRB, 0.16943955E-09_JPRB, 0.16942983E-09_JPRB, 0.16941160E-09_JPRB /)

RGHG8(:,67,12) = (/ &
  & 0.16907023E-09_JPRB, 0.16907228E-09_JPRB, 0.16906557E-09_JPRB, 0.16905351E-09_JPRB, 0.16903473E-09_JPRB, 0.16900732E-09_JPRB, &
  & 0.16897314E-09_JPRB, 0.16894297E-09_JPRB, 0.16893212E-09_JPRB, 0.16893009E-09_JPRB, 0.16893269E-09_JPRB, 0.16893491E-09_JPRB, &
  & 0.16893079E-09_JPRB, 0.16891508E-09_JPRB, 0.16888158E-09_JPRB, 0.16882667E-09_JPRB, 0.16874893E-09_JPRB, 0.16865889E-09_JPRB, &
  & 0.16857526E-09_JPRB, 0.16851531E-09_JPRB, 0.16848653E-09_JPRB, 0.16848861E-09_JPRB, 0.16851749E-09_JPRB, 0.16856715E-09_JPRB, &
  & 0.16863157E-09_JPRB, 0.16870340E-09_JPRB, 0.16877406E-09_JPRB, 0.16883769E-09_JPRB, 0.16888936E-09_JPRB, 0.16892776E-09_JPRB, &
  & 0.16895213E-09_JPRB, 0.16895921E-09_JPRB, 0.16894763E-09_JPRB, 0.16892167E-09_JPRB, 0.16888885E-09_JPRB, 0.16885462E-09_JPRB, &
  & 0.16882085E-09_JPRB, 0.16879098E-09_JPRB, 0.16876996E-09_JPRB, 0.16876378E-09_JPRB, 0.16877891E-09_JPRB, 0.16882107E-09_JPRB, &
  & 0.16889277E-09_JPRB, 0.16898957E-09_JPRB, 0.16910107E-09_JPRB, 0.16921294E-09_JPRB, 0.16931458E-09_JPRB, 0.16939861E-09_JPRB, &
  & 0.16946088E-09_JPRB, 0.16950162E-09_JPRB, 0.16952439E-09_JPRB, 0.16953372E-09_JPRB, 0.16953550E-09_JPRB, 0.16953311E-09_JPRB, &
  & 0.16952854E-09_JPRB, 0.16952273E-09_JPRB, 0.16951558E-09_JPRB, 0.16950776E-09_JPRB, 0.16949936E-09_JPRB, 0.16949070E-09_JPRB, &
  & 0.16948212E-09_JPRB, 0.16947227E-09_JPRB, 0.16945931E-09_JPRB, 0.16943383E-09_JPRB /)

RGHG8(:,68,12) = (/ &
  & 0.16913515E-09_JPRB, 0.16913981E-09_JPRB, 0.16913411E-09_JPRB, 0.16912294E-09_JPRB, 0.16910494E-09_JPRB, 0.16907802E-09_JPRB, &
  & 0.16904486E-09_JPRB, 0.16901439E-09_JPRB, 0.16900539E-09_JPRB, 0.16900520E-09_JPRB, 0.16900925E-09_JPRB, 0.16901242E-09_JPRB, &
  & 0.16900885E-09_JPRB, 0.16899376E-09_JPRB, 0.16896134E-09_JPRB, 0.16890941E-09_JPRB, 0.16883620E-09_JPRB, 0.16875254E-09_JPRB, &
  & 0.16867555E-09_JPRB, 0.16862071E-09_JPRB, 0.16859507E-09_JPRB, 0.16859807E-09_JPRB, 0.16862585E-09_JPRB, 0.16867252E-09_JPRB, &
  & 0.16873264E-09_JPRB, 0.16879878E-09_JPRB, 0.16886362E-09_JPRB, 0.16892163E-09_JPRB, 0.16896851E-09_JPRB, 0.16900319E-09_JPRB, &
  & 0.16902513E-09_JPRB, 0.16903089E-09_JPRB, 0.16901905E-09_JPRB, 0.16899397E-09_JPRB, 0.16896289E-09_JPRB, 0.16893052E-09_JPRB, &
  & 0.16889831E-09_JPRB, 0.16886915E-09_JPRB, 0.16884860E-09_JPRB, 0.16884243E-09_JPRB, 0.16885718E-09_JPRB, 0.16889816E-09_JPRB, &
  & 0.16896737E-09_JPRB, 0.16906021E-09_JPRB, 0.16916611E-09_JPRB, 0.16927230E-09_JPRB, 0.16936845E-09_JPRB, 0.16944791E-09_JPRB, &
  & 0.16950685E-09_JPRB, 0.16954588E-09_JPRB, 0.16956800E-09_JPRB, 0.16957753E-09_JPRB, 0.16957930E-09_JPRB, 0.16957652E-09_JPRB, &
  & 0.16957150E-09_JPRB, 0.16956467E-09_JPRB, 0.16955672E-09_JPRB, 0.16954765E-09_JPRB, 0.16953820E-09_JPRB, 0.16952866E-09_JPRB, &
  & 0.16951840E-09_JPRB, 0.16950671E-09_JPRB, 0.16948996E-09_JPRB, 0.16945607E-09_JPRB /)

RGHG8(:,69,12) = (/ &
  & 0.16920190E-09_JPRB, 0.16920937E-09_JPRB, 0.16920484E-09_JPRB, 0.16919442E-09_JPRB, 0.16917720E-09_JPRB, 0.16915155E-09_JPRB, &
  & 0.16911912E-09_JPRB, 0.16909056E-09_JPRB, 0.16908366E-09_JPRB, 0.16908525E-09_JPRB, 0.16909035E-09_JPRB, 0.16909404E-09_JPRB, &
  & 0.16909094E-09_JPRB, 0.16907667E-09_JPRB, 0.16904562E-09_JPRB, 0.16899723E-09_JPRB, 0.16892915E-09_JPRB, 0.16885214E-09_JPRB, &
  & 0.16878154E-09_JPRB, 0.16873140E-09_JPRB, 0.16870809E-09_JPRB, 0.16871131E-09_JPRB, 0.16873739E-09_JPRB, 0.16878071E-09_JPRB, &
  & 0.16883589E-09_JPRB, 0.16889629E-09_JPRB, 0.16895491E-09_JPRB, 0.16900735E-09_JPRB, 0.16904947E-09_JPRB, 0.16908053E-09_JPRB, &
  & 0.16910012E-09_JPRB, 0.16910470E-09_JPRB, 0.16909285E-09_JPRB, 0.16906902E-09_JPRB, 0.16903999E-09_JPRB, 0.16900997E-09_JPRB, &
  & 0.16897966E-09_JPRB, 0.16895210E-09_JPRB, 0.16893251E-09_JPRB, 0.16892679E-09_JPRB, 0.16894128E-09_JPRB, 0.16898086E-09_JPRB, &
  & 0.16904693E-09_JPRB, 0.16913487E-09_JPRB, 0.16923446E-09_JPRB, 0.16933384E-09_JPRB, 0.16942378E-09_JPRB, 0.16949810E-09_JPRB, &
  & 0.16955326E-09_JPRB, 0.16959006E-09_JPRB, 0.16961131E-09_JPRB, 0.16962057E-09_JPRB, 0.16962247E-09_JPRB, 0.16961960E-09_JPRB, &
  & 0.16961428E-09_JPRB, 0.16960713E-09_JPRB, 0.16959845E-09_JPRB, 0.16958882E-09_JPRB, 0.16957886E-09_JPRB, 0.16956835E-09_JPRB, &
  & 0.16955748E-09_JPRB, 0.16954382E-09_JPRB, 0.16952367E-09_JPRB, 0.16948015E-09_JPRB /)

RGHG8(:,70,12) = (/ &
  & 0.16926885E-09_JPRB, 0.16928053E-09_JPRB, 0.16927758E-09_JPRB, 0.16926831E-09_JPRB, 0.16925221E-09_JPRB, 0.16922763E-09_JPRB, &
  & 0.16919760E-09_JPRB, 0.16917127E-09_JPRB, 0.16916696E-09_JPRB, 0.16917025E-09_JPRB, 0.16917581E-09_JPRB, 0.16917963E-09_JPRB, &
  & 0.16917662E-09_JPRB, 0.16916314E-09_JPRB, 0.16913376E-09_JPRB, 0.16908916E-09_JPRB, 0.16902652E-09_JPRB, 0.16895604E-09_JPRB, &
  & 0.16889162E-09_JPRB, 0.16884576E-09_JPRB, 0.16882437E-09_JPRB, 0.16882734E-09_JPRB, 0.16885129E-09_JPRB, 0.16889078E-09_JPRB, &
  & 0.16894088E-09_JPRB, 0.16899521E-09_JPRB, 0.16904779E-09_JPRB, 0.16909459E-09_JPRB, 0.16913210E-09_JPRB, 0.16915967E-09_JPRB, &
  & 0.16917709E-09_JPRB, 0.16918064E-09_JPRB, 0.16916905E-09_JPRB, 0.16914681E-09_JPRB, 0.16912009E-09_JPRB, 0.16909263E-09_JPRB, &
  & 0.16906476E-09_JPRB, 0.16903914E-09_JPRB, 0.16902101E-09_JPRB, 0.16901602E-09_JPRB, 0.16903035E-09_JPRB, 0.16906820E-09_JPRB, &
  & 0.16913103E-09_JPRB, 0.16921312E-09_JPRB, 0.16930585E-09_JPRB, 0.16939755E-09_JPRB, 0.16948046E-09_JPRB, 0.16954899E-09_JPRB, &
  & 0.16959993E-09_JPRB, 0.16963410E-09_JPRB, 0.16965415E-09_JPRB, 0.16966308E-09_JPRB, 0.16966500E-09_JPRB, 0.16966233E-09_JPRB, &
  & 0.16965719E-09_JPRB, 0.16965009E-09_JPRB, 0.16964137E-09_JPRB, 0.16963154E-09_JPRB, 0.16962139E-09_JPRB, 0.16961085E-09_JPRB, &
  & 0.16959928E-09_JPRB, 0.16958486E-09_JPRB, 0.16956178E-09_JPRB, 0.16951013E-09_JPRB /)

RGHG8(:,71,12) = (/ &
  & 0.16933664E-09_JPRB, 0.16935364E-09_JPRB, 0.16935273E-09_JPRB, 0.16934473E-09_JPRB, 0.16932990E-09_JPRB, 0.16930714E-09_JPRB, &
  & 0.16927958E-09_JPRB, 0.16925705E-09_JPRB, 0.16925505E-09_JPRB, 0.16925923E-09_JPRB, 0.16926495E-09_JPRB, 0.16926818E-09_JPRB, &
  & 0.16926510E-09_JPRB, 0.16925250E-09_JPRB, 0.16922501E-09_JPRB, 0.16918401E-09_JPRB, 0.16912713E-09_JPRB, 0.16906317E-09_JPRB, &
  & 0.16900475E-09_JPRB, 0.16896286E-09_JPRB, 0.16894315E-09_JPRB, 0.16894555E-09_JPRB, 0.16896702E-09_JPRB, 0.16900251E-09_JPRB, &
  & 0.16904712E-09_JPRB, 0.16909554E-09_JPRB, 0.16914195E-09_JPRB, 0.16918329E-09_JPRB, 0.16921624E-09_JPRB, 0.16924048E-09_JPRB, &
  & 0.16925590E-09_JPRB, 0.16925870E-09_JPRB, 0.16924764E-09_JPRB, 0.16922716E-09_JPRB, 0.16920300E-09_JPRB, 0.16917839E-09_JPRB, &
  & 0.16915321E-09_JPRB, 0.16912992E-09_JPRB, 0.16911354E-09_JPRB, 0.16910953E-09_JPRB, 0.16912353E-09_JPRB, 0.16915984E-09_JPRB, &
  & 0.16921821E-09_JPRB, 0.16929477E-09_JPRB, 0.16937927E-09_JPRB, 0.16946293E-09_JPRB, 0.16953813E-09_JPRB, 0.16960035E-09_JPRB, &
  & 0.16964649E-09_JPRB, 0.16967799E-09_JPRB, 0.16969638E-09_JPRB, 0.16970488E-09_JPRB, 0.16970687E-09_JPRB, 0.16970467E-09_JPRB, &
  & 0.16970005E-09_JPRB, 0.16969356E-09_JPRB, 0.16968517E-09_JPRB, 0.16967569E-09_JPRB, 0.16966589E-09_JPRB, 0.16965551E-09_JPRB, &
  & 0.16964412E-09_JPRB, 0.16962934E-09_JPRB, 0.16960498E-09_JPRB, 0.16954824E-09_JPRB /)

RGHG8(:,72,12) = (/ &
  & 0.16940514E-09_JPRB, 0.16942872E-09_JPRB, 0.16943008E-09_JPRB, 0.16942364E-09_JPRB, 0.16941019E-09_JPRB, 0.16938924E-09_JPRB, &
  & 0.16936516E-09_JPRB, 0.16934676E-09_JPRB, 0.16934654E-09_JPRB, 0.16935120E-09_JPRB, 0.16935599E-09_JPRB, 0.16935857E-09_JPRB, &
  & 0.16935534E-09_JPRB, 0.16934334E-09_JPRB, 0.16931821E-09_JPRB, 0.16928081E-09_JPRB, 0.16922984E-09_JPRB, 0.16917229E-09_JPRB, &
  & 0.16911995E-09_JPRB, 0.16908214E-09_JPRB, 0.16906394E-09_JPRB, 0.16906551E-09_JPRB, 0.16908430E-09_JPRB, 0.16911539E-09_JPRB, &
  & 0.16915457E-09_JPRB, 0.16919674E-09_JPRB, 0.16923725E-09_JPRB, 0.16927312E-09_JPRB, 0.16930177E-09_JPRB, 0.16932285E-09_JPRB, &
  & 0.16933641E-09_JPRB, 0.16933858E-09_JPRB, 0.16932834E-09_JPRB, 0.16930994E-09_JPRB, 0.16928847E-09_JPRB, 0.16926696E-09_JPRB, &
  & 0.16924473E-09_JPRB, 0.16922404E-09_JPRB, 0.16920963E-09_JPRB, 0.16920672E-09_JPRB, 0.16922054E-09_JPRB, 0.16925431E-09_JPRB, &
  & 0.16930878E-09_JPRB, 0.16937787E-09_JPRB, 0.16945449E-09_JPRB, 0.16952918E-09_JPRB, 0.16959609E-09_JPRB, 0.16965143E-09_JPRB, &
  & 0.16969290E-09_JPRB, 0.16972093E-09_JPRB, 0.16973799E-09_JPRB, 0.16974587E-09_JPRB, 0.16974806E-09_JPRB, 0.16974636E-09_JPRB, &
  & 0.16974262E-09_JPRB, 0.16973684E-09_JPRB, 0.16972949E-09_JPRB, 0.16972043E-09_JPRB, 0.16971155E-09_JPRB, 0.16970160E-09_JPRB, &
  & 0.16969072E-09_JPRB, 0.16967654E-09_JPRB, 0.16965181E-09_JPRB, 0.16959262E-09_JPRB /)

RGHG8(:,73,12) = (/ &
  & 0.16948137E-09_JPRB, 0.16950746E-09_JPRB, 0.16950973E-09_JPRB, 0.16950416E-09_JPRB, 0.16949211E-09_JPRB, 0.16947334E-09_JPRB, &
  & 0.16945290E-09_JPRB, 0.16943849E-09_JPRB, 0.16943930E-09_JPRB, 0.16944346E-09_JPRB, 0.16944791E-09_JPRB, 0.16944945E-09_JPRB, &
  & 0.16944583E-09_JPRB, 0.16943486E-09_JPRB, 0.16941223E-09_JPRB, 0.16937837E-09_JPRB, 0.16933319E-09_JPRB, 0.16928242E-09_JPRB, &
  & 0.16923625E-09_JPRB, 0.16920264E-09_JPRB, 0.16918598E-09_JPRB, 0.16918668E-09_JPRB, 0.16920254E-09_JPRB, 0.16922930E-09_JPRB, &
  & 0.16926274E-09_JPRB, 0.16929891E-09_JPRB, 0.16933341E-09_JPRB, 0.16936405E-09_JPRB, 0.16938845E-09_JPRB, 0.16940642E-09_JPRB, &
  & 0.16941826E-09_JPRB, 0.16942003E-09_JPRB, 0.16941090E-09_JPRB, 0.16939476E-09_JPRB, 0.16937617E-09_JPRB, 0.16935793E-09_JPRB, &
  & 0.16933875E-09_JPRB, 0.16932092E-09_JPRB, 0.16930865E-09_JPRB, 0.16930697E-09_JPRB, 0.16932016E-09_JPRB, 0.16935156E-09_JPRB, &
  & 0.16940024E-09_JPRB, 0.16946237E-09_JPRB, 0.16952977E-09_JPRB, 0.16959496E-09_JPRB, 0.16965361E-09_JPRB, 0.16970207E-09_JPRB, &
  & 0.16973783E-09_JPRB, 0.16976331E-09_JPRB, 0.16977822E-09_JPRB, 0.16978566E-09_JPRB, 0.16978802E-09_JPRB, 0.16978696E-09_JPRB, &
  & 0.16978390E-09_JPRB, 0.16977933E-09_JPRB, 0.16977261E-09_JPRB, 0.16976484E-09_JPRB, 0.16975660E-09_JPRB, 0.16974772E-09_JPRB, &
  & 0.16973761E-09_JPRB, 0.16972443E-09_JPRB, 0.16970055E-09_JPRB, 0.16964115E-09_JPRB /)

RGHG8(:,74,12) = (/ &
  & 0.16955812E-09_JPRB, 0.16958671E-09_JPRB, 0.16958970E-09_JPRB, 0.16958504E-09_JPRB, 0.16957452E-09_JPRB, 0.16955812E-09_JPRB, &
  & 0.16954101E-09_JPRB, 0.16952960E-09_JPRB, 0.16953092E-09_JPRB, 0.16953519E-09_JPRB, 0.16953836E-09_JPRB, 0.16953948E-09_JPRB, &
  & 0.16953611E-09_JPRB, 0.16952564E-09_JPRB, 0.16950560E-09_JPRB, 0.16947570E-09_JPRB, 0.16943649E-09_JPRB, 0.16939244E-09_JPRB, &
  & 0.16935295E-09_JPRB, 0.16932372E-09_JPRB, 0.16930871E-09_JPRB, 0.16930853E-09_JPRB, 0.16932157E-09_JPRB, 0.16934373E-09_JPRB, &
  & 0.16937159E-09_JPRB, 0.16940156E-09_JPRB, 0.16943029E-09_JPRB, 0.16945574E-09_JPRB, 0.16947613E-09_JPRB, 0.16949113E-09_JPRB, &
  & 0.16950133E-09_JPRB, 0.16950281E-09_JPRB, 0.16949497E-09_JPRB, 0.16948122E-09_JPRB, 0.16946583E-09_JPRB, 0.16945080E-09_JPRB, &
  & 0.16943488E-09_JPRB, 0.16942008E-09_JPRB, 0.16940999E-09_JPRB, 0.16940944E-09_JPRB, 0.16942178E-09_JPRB, 0.16944968E-09_JPRB, &
  & 0.16949268E-09_JPRB, 0.16954640E-09_JPRB, 0.16960412E-09_JPRB, 0.16966026E-09_JPRB, 0.16970982E-09_JPRB, 0.16975112E-09_JPRB, &
  & 0.16978219E-09_JPRB, 0.16980364E-09_JPRB, 0.16981722E-09_JPRB, 0.16982393E-09_JPRB, 0.16982632E-09_JPRB, 0.16982565E-09_JPRB, &
  & 0.16982349E-09_JPRB, 0.16981955E-09_JPRB, 0.16981419E-09_JPRB, 0.16980700E-09_JPRB, 0.16980034E-09_JPRB, 0.16979215E-09_JPRB, &
  & 0.16978324E-09_JPRB, 0.16977182E-09_JPRB, 0.16974923E-09_JPRB, 0.16969198E-09_JPRB /)

RGHG8(:,75,12) = (/ &
  & 0.16963425E-09_JPRB, 0.16966470E-09_JPRB, 0.16966850E-09_JPRB, 0.16966487E-09_JPRB, 0.16965622E-09_JPRB, 0.16964224E-09_JPRB, &
  & 0.16962803E-09_JPRB, 0.16961882E-09_JPRB, 0.16962069E-09_JPRB, 0.16962418E-09_JPRB, 0.16962727E-09_JPRB, 0.16962788E-09_JPRB, &
  & 0.16962440E-09_JPRB, 0.16961561E-09_JPRB, 0.16959792E-09_JPRB, 0.16957220E-09_JPRB, 0.16953915E-09_JPRB, 0.16950237E-09_JPRB, &
  & 0.16946955E-09_JPRB, 0.16944501E-09_JPRB, 0.16943190E-09_JPRB, 0.16943108E-09_JPRB, 0.16944131E-09_JPRB, 0.16945900E-09_JPRB, &
  & 0.16948129E-09_JPRB, 0.16950530E-09_JPRB, 0.16952835E-09_JPRB, 0.16954878E-09_JPRB, 0.16956520E-09_JPRB, 0.16957724E-09_JPRB, &
  & 0.16958582E-09_JPRB, 0.16958709E-09_JPRB, 0.16958075E-09_JPRB, 0.16956939E-09_JPRB, 0.16955735E-09_JPRB, 0.16954539E-09_JPRB, &
  & 0.16953287E-09_JPRB, 0.16952109E-09_JPRB, 0.16951314E-09_JPRB, 0.16951364E-09_JPRB, 0.16952462E-09_JPRB, 0.16954868E-09_JPRB, &
  & 0.16958472E-09_JPRB, 0.16962963E-09_JPRB, 0.16967794E-09_JPRB, 0.16972347E-09_JPRB, 0.16976492E-09_JPRB, 0.16979897E-09_JPRB, &
  & 0.16982424E-09_JPRB, 0.16984279E-09_JPRB, 0.16985416E-09_JPRB, 0.16986022E-09_JPRB, 0.16986261E-09_JPRB, 0.16986224E-09_JPRB, &
  & 0.16986053E-09_JPRB, 0.16985756E-09_JPRB, 0.16985285E-09_JPRB, 0.16984697E-09_JPRB, 0.16984139E-09_JPRB, 0.16983452E-09_JPRB, &
  & 0.16982696E-09_JPRB, 0.16981734E-09_JPRB, 0.16979733E-09_JPRB, 0.16974357E-09_JPRB /)

RGHG8(:,76,12) = (/ &
  & 0.16970883E-09_JPRB, 0.16974086E-09_JPRB, 0.16974522E-09_JPRB, 0.16974266E-09_JPRB, 0.16973628E-09_JPRB, 0.16972480E-09_JPRB, &
  & 0.16971342E-09_JPRB, 0.16970565E-09_JPRB, 0.16970755E-09_JPRB, 0.16971102E-09_JPRB, 0.16971285E-09_JPRB, 0.16971330E-09_JPRB, &
  & 0.16971063E-09_JPRB, 0.16970293E-09_JPRB, 0.16968858E-09_JPRB, 0.16966771E-09_JPRB, 0.16964140E-09_JPRB, 0.16961191E-09_JPRB, &
  & 0.16958621E-09_JPRB, 0.16956644E-09_JPRB, 0.16955549E-09_JPRB, 0.16955430E-09_JPRB, 0.16956196E-09_JPRB, 0.16957533E-09_JPRB, &
  & 0.16959206E-09_JPRB, 0.16961012E-09_JPRB, 0.16962771E-09_JPRB, 0.16964330E-09_JPRB, 0.16965591E-09_JPRB, 0.16966503E-09_JPRB, &
  & 0.16967203E-09_JPRB, 0.16967303E-09_JPRB, 0.16966818E-09_JPRB, 0.16965933E-09_JPRB, 0.16965074E-09_JPRB, 0.16964163E-09_JPRB, &
  & 0.16963266E-09_JPRB, 0.16962361E-09_JPRB, 0.16961764E-09_JPRB, 0.16961899E-09_JPRB, 0.16962813E-09_JPRB, 0.16964753E-09_JPRB, &
  & 0.16967633E-09_JPRB, 0.16971222E-09_JPRB, 0.16974992E-09_JPRB, 0.16978619E-09_JPRB, 0.16981813E-09_JPRB, 0.16984507E-09_JPRB, &
  & 0.16986491E-09_JPRB, 0.16987954E-09_JPRB, 0.16988901E-09_JPRB, 0.16989428E-09_JPRB, 0.16989644E-09_JPRB, 0.16989614E-09_JPRB, &
  & 0.16989493E-09_JPRB, 0.16989259E-09_JPRB, 0.16988892E-09_JPRB, 0.16988390E-09_JPRB, 0.16988014E-09_JPRB, 0.16987435E-09_JPRB, &
  & 0.16986809E-09_JPRB, 0.16986114E-09_JPRB, 0.16984374E-09_JPRB, 0.16979525E-09_JPRB /)

RGHG8(:,77,12) = (/ &
  & 0.16978180E-09_JPRB, 0.16981361E-09_JPRB, 0.16981845E-09_JPRB, 0.16981708E-09_JPRB, 0.16981316E-09_JPRB, 0.16980434E-09_JPRB, &
  & 0.16979589E-09_JPRB, 0.16978961E-09_JPRB, 0.16979142E-09_JPRB, 0.16979355E-09_JPRB, 0.16979448E-09_JPRB, 0.16979457E-09_JPRB, &
  & 0.16979233E-09_JPRB, 0.16978718E-09_JPRB, 0.16977636E-09_JPRB, 0.16976109E-09_JPRB, 0.16974212E-09_JPRB, 0.16972043E-09_JPRB, &
  & 0.16970192E-09_JPRB, 0.16968726E-09_JPRB, 0.16967877E-09_JPRB, 0.16967756E-09_JPRB, 0.16968292E-09_JPRB, 0.16969209E-09_JPRB, &
  & 0.16970365E-09_JPRB, 0.16971613E-09_JPRB, 0.16972863E-09_JPRB, 0.16973961E-09_JPRB, 0.16974858E-09_JPRB, 0.16975477E-09_JPRB, &
  & 0.16976009E-09_JPRB, 0.16976071E-09_JPRB, 0.16975739E-09_JPRB, 0.16975077E-09_JPRB, 0.16974530E-09_JPRB, 0.16973865E-09_JPRB, &
  & 0.16973319E-09_JPRB, 0.16972665E-09_JPRB, 0.16972238E-09_JPRB, 0.16972418E-09_JPRB, 0.16973095E-09_JPRB, 0.16974536E-09_JPRB, &
  & 0.16976628E-09_JPRB, 0.16979287E-09_JPRB, 0.16982060E-09_JPRB, 0.16984626E-09_JPRB, 0.16986965E-09_JPRB, 0.16988903E-09_JPRB, &
  & 0.16990312E-09_JPRB, 0.16991415E-09_JPRB, 0.16992127E-09_JPRB, 0.16992553E-09_JPRB, 0.16992745E-09_JPRB, 0.16992704E-09_JPRB, &
  & 0.16992623E-09_JPRB, 0.16992453E-09_JPRB, 0.16992178E-09_JPRB, 0.16991782E-09_JPRB, 0.16991580E-09_JPRB, 0.16991114E-09_JPRB, &
  & 0.16990644E-09_JPRB, 0.16990198E-09_JPRB, 0.16988820E-09_JPRB, 0.16984630E-09_JPRB /)

RGHG8(:,78,12) = (/ &
  & 0.16985201E-09_JPRB, 0.16987979E-09_JPRB, 0.16988319E-09_JPRB, 0.16988269E-09_JPRB, 0.16988128E-09_JPRB, 0.16987520E-09_JPRB, &
  & 0.16987010E-09_JPRB, 0.16986559E-09_JPRB, 0.16986668E-09_JPRB, 0.16986747E-09_JPRB, 0.16986669E-09_JPRB, 0.16986645E-09_JPRB, &
  & 0.16986519E-09_JPRB, 0.16986254E-09_JPRB, 0.16985582E-09_JPRB, 0.16984648E-09_JPRB, 0.16983502E-09_JPRB, 0.16982092E-09_JPRB, &
  & 0.16980971E-09_JPRB, 0.16980023E-09_JPRB, 0.16979460E-09_JPRB, 0.16979390E-09_JPRB, 0.16979750E-09_JPRB, 0.16980300E-09_JPRB, &
  & 0.16981004E-09_JPRB, 0.16981759E-09_JPRB, 0.16982565E-09_JPRB, 0.16983258E-09_JPRB, 0.16983823E-09_JPRB, 0.16984167E-09_JPRB, &
  & 0.16984536E-09_JPRB, 0.16984546E-09_JPRB, 0.16984329E-09_JPRB, 0.16983859E-09_JPRB, 0.16983583E-09_JPRB, 0.16983120E-09_JPRB, &
  & 0.16982868E-09_JPRB, 0.16982410E-09_JPRB, 0.16982096E-09_JPRB, 0.16982270E-09_JPRB, 0.16982664E-09_JPRB, 0.16983567E-09_JPRB, &
  & 0.16984897E-09_JPRB, 0.16986662E-09_JPRB, 0.16988465E-09_JPRB, 0.16990095E-09_JPRB, 0.16991569E-09_JPRB, 0.16992824E-09_JPRB, &
  & 0.16993686E-09_JPRB, 0.16994432E-09_JPRB, 0.16994914E-09_JPRB, 0.16995236E-09_JPRB, 0.16995381E-09_JPRB, 0.16995315E-09_JPRB, &
  & 0.16995266E-09_JPRB, 0.16995144E-09_JPRB, 0.16994950E-09_JPRB, 0.16994649E-09_JPRB, 0.16994617E-09_JPRB, 0.16994260E-09_JPRB, &
  & 0.16993913E-09_JPRB, 0.16993736E-09_JPRB, 0.16992814E-09_JPRB, 0.16989617E-09_JPRB /)

RGHG8(:,79,12) = (/ &
  & 0.16989696E-09_JPRB, 0.16991666E-09_JPRB, 0.16991750E-09_JPRB, 0.16991650E-09_JPRB, 0.16991653E-09_JPRB, 0.16991161E-09_JPRB, &
  & 0.16990845E-09_JPRB, 0.16990483E-09_JPRB, 0.16990565E-09_JPRB, 0.16990581E-09_JPRB, 0.16990420E-09_JPRB, 0.16990391E-09_JPRB, &
  & 0.16990315E-09_JPRB, 0.16990202E-09_JPRB, 0.16989737E-09_JPRB, 0.16989113E-09_JPRB, 0.16988375E-09_JPRB, 0.16987378E-09_JPRB, &
  & 0.16986677E-09_JPRB, 0.16986028E-09_JPRB, 0.16985621E-09_JPRB, 0.16985596E-09_JPRB, 0.16985884E-09_JPRB, 0.16986251E-09_JPRB, &
  & 0.16986723E-09_JPRB, 0.16987223E-09_JPRB, 0.16987806E-09_JPRB, 0.16988286E-09_JPRB, 0.16988680E-09_JPRB, 0.16988867E-09_JPRB, &
  & 0.16989157E-09_JPRB, 0.16989125E-09_JPRB, 0.16988977E-09_JPRB, 0.16988601E-09_JPRB, 0.16988475E-09_JPRB, 0.16988110E-09_JPRB, &
  & 0.16988023E-09_JPRB, 0.16987652E-09_JPRB, 0.16987380E-09_JPRB, 0.16987552E-09_JPRB, 0.16987774E-09_JPRB, 0.16988383E-09_JPRB, &
  & 0.16989288E-09_JPRB, 0.16990603E-09_JPRB, 0.16991891E-09_JPRB, 0.16993006E-09_JPRB, 0.16994019E-09_JPRB, 0.16994899E-09_JPRB, &
  & 0.16995458E-09_JPRB, 0.16996024E-09_JPRB, 0.16996379E-09_JPRB, 0.16996651E-09_JPRB, 0.16996775E-09_JPRB, 0.16996680E-09_JPRB, &
  & 0.16996643E-09_JPRB, 0.16996540E-09_JPRB, 0.16996385E-09_JPRB, 0.16996120E-09_JPRB, 0.16996196E-09_JPRB, 0.16995871E-09_JPRB, &
  & 0.16995592E-09_JPRB, 0.16995626E-09_JPRB, 0.16995055E-09_JPRB, 0.16992806E-09_JPRB /)

RGHG8(:,80,12) = (/ &
  & 0.16992639E-09_JPRB, 0.16993447E-09_JPRB, 0.16993240E-09_JPRB, 0.16993107E-09_JPRB, 0.16993162E-09_JPRB, 0.16992717E-09_JPRB, &
  & 0.16992478E-09_JPRB, 0.16992172E-09_JPRB, 0.16992263E-09_JPRB, 0.16992271E-09_JPRB, 0.16992073E-09_JPRB, 0.16992054E-09_JPRB, &
  & 0.16992001E-09_JPRB, 0.16991955E-09_JPRB, 0.16991572E-09_JPRB, 0.16991079E-09_JPRB, 0.16990531E-09_JPRB, 0.16989710E-09_JPRB, &
  & 0.16989218E-09_JPRB, 0.16988701E-09_JPRB, 0.16988372E-09_JPRB, 0.16988377E-09_JPRB, 0.16988644E-09_JPRB, 0.16988937E-09_JPRB, &
  & 0.16989304E-09_JPRB, 0.16989693E-09_JPRB, 0.16990184E-09_JPRB, 0.16990573E-09_JPRB, 0.16990891E-09_JPRB, 0.16991009E-09_JPRB, &
  & 0.16991265E-09_JPRB, 0.16991211E-09_JPRB, 0.16991085E-09_JPRB, 0.16990745E-09_JPRB, 0.16990696E-09_JPRB, 0.16990365E-09_JPRB, &
  & 0.16990359E-09_JPRB, 0.16990019E-09_JPRB, 0.16989754E-09_JPRB, 0.16989928E-09_JPRB, 0.16990061E-09_JPRB, 0.16990531E-09_JPRB, &
  & 0.16991250E-09_JPRB, 0.16992363E-09_JPRB, 0.16993434E-09_JPRB, 0.16994302E-09_JPRB, 0.16995111E-09_JPRB, 0.16995814E-09_JPRB, &
  & 0.16996231E-09_JPRB, 0.16996722E-09_JPRB, 0.16997023E-09_JPRB, 0.16997277E-09_JPRB, 0.16997390E-09_JPRB, 0.16997274E-09_JPRB, &
  & 0.16997243E-09_JPRB, 0.16997143E-09_JPRB, 0.16996998E-09_JPRB, 0.16996740E-09_JPRB, 0.16996872E-09_JPRB, 0.16996558E-09_JPRB, &
  & 0.16996306E-09_JPRB, 0.16996457E-09_JPRB, 0.16996145E-09_JPRB, 0.16994903E-09_JPRB /)

RGHG8(:,81,12) = (/ &
  & 0.16994628E-09_JPRB, 0.16994198E-09_JPRB, 0.16993869E-09_JPRB, 0.16993719E-09_JPRB, 0.16993806E-09_JPRB, 0.16993376E-09_JPRB, &
  & 0.16993185E-09_JPRB, 0.16992893E-09_JPRB, 0.16992988E-09_JPRB, 0.16992999E-09_JPRB, 0.16992803E-09_JPRB, 0.16992786E-09_JPRB, &
  & 0.16992745E-09_JPRB, 0.16992728E-09_JPRB, 0.16992377E-09_JPRB, 0.16991938E-09_JPRB, 0.16991468E-09_JPRB, 0.16990724E-09_JPRB, &
  & 0.16990324E-09_JPRB, 0.16989872E-09_JPRB, 0.16989571E-09_JPRB, 0.16989593E-09_JPRB, 0.16989858E-09_JPRB, 0.16990112E-09_JPRB, &
  & 0.16990437E-09_JPRB, 0.16990778E-09_JPRB, 0.16991231E-09_JPRB, 0.16991583E-09_JPRB, 0.16991872E-09_JPRB, 0.16991947E-09_JPRB, &
  & 0.16992198E-09_JPRB, 0.16992130E-09_JPRB, 0.16992016E-09_JPRB, 0.16991684E-09_JPRB, 0.16991673E-09_JPRB, 0.16991354E-09_JPRB, &
  & 0.16991389E-09_JPRB, 0.16991060E-09_JPRB, 0.16990799E-09_JPRB, 0.16990971E-09_JPRB, 0.16991064E-09_JPRB, 0.16991467E-09_JPRB, &
  & 0.16992099E-09_JPRB, 0.16993142E-09_JPRB, 0.16994112E-09_JPRB, 0.16994879E-09_JPRB, 0.16995580E-09_JPRB, 0.16996213E-09_JPRB, &
  & 0.16996562E-09_JPRB, 0.16997022E-09_JPRB, 0.16997301E-09_JPRB, 0.16997551E-09_JPRB, 0.16997660E-09_JPRB, 0.16997531E-09_JPRB, &
  & 0.16997502E-09_JPRB, 0.16997402E-09_JPRB, 0.16997259E-09_JPRB, 0.16997000E-09_JPRB, 0.16997163E-09_JPRB, 0.16996847E-09_JPRB, &
  & 0.16996601E-09_JPRB, 0.16996816E-09_JPRB, 0.16996611E-09_JPRB, 0.16996329E-09_JPRB /)

RGHG8(:,82,12) = (/ &
  & 0.16994789E-09_JPRB, 0.16994450E-09_JPRB, 0.16994142E-09_JPRB, 0.16994006E-09_JPRB, 0.16994114E-09_JPRB, 0.16993695E-09_JPRB, &
  & 0.16993514E-09_JPRB, 0.16993244E-09_JPRB, 0.16993347E-09_JPRB, 0.16993366E-09_JPRB, 0.16993147E-09_JPRB, 0.16993143E-09_JPRB, &
  & 0.16993107E-09_JPRB, 0.16993106E-09_JPRB, 0.16992768E-09_JPRB, 0.16992356E-09_JPRB, 0.16991927E-09_JPRB, 0.16991213E-09_JPRB, &
  & 0.16990873E-09_JPRB, 0.16990435E-09_JPRB, 0.16990158E-09_JPRB, 0.16990188E-09_JPRB, 0.16990448E-09_JPRB, 0.16990688E-09_JPRB, &
  & 0.16990991E-09_JPRB, 0.16991308E-09_JPRB, 0.16991744E-09_JPRB, 0.16992081E-09_JPRB, 0.16992355E-09_JPRB, 0.16992410E-09_JPRB, &
  & 0.16992657E-09_JPRB, 0.16992578E-09_JPRB, 0.16992466E-09_JPRB, 0.16992141E-09_JPRB, 0.16992147E-09_JPRB, 0.16991843E-09_JPRB, &
  & 0.16991886E-09_JPRB, 0.16991569E-09_JPRB, 0.16991314E-09_JPRB, 0.16991480E-09_JPRB, 0.16991553E-09_JPRB, 0.16991925E-09_JPRB, &
  & 0.16992510E-09_JPRB, 0.16993518E-09_JPRB, 0.16994456E-09_JPRB, 0.16995157E-09_JPRB, 0.16995816E-09_JPRB, 0.16996403E-09_JPRB, &
  & 0.16996718E-09_JPRB, 0.16997168E-09_JPRB, 0.16997434E-09_JPRB, 0.16997687E-09_JPRB, 0.16997792E-09_JPRB, 0.16997655E-09_JPRB, &
  & 0.16997623E-09_JPRB, 0.16997523E-09_JPRB, 0.16997384E-09_JPRB, 0.16997123E-09_JPRB, 0.16997305E-09_JPRB, 0.16996984E-09_JPRB, &
  & 0.16996739E-09_JPRB, 0.16996975E-09_JPRB, 0.16996771E-09_JPRB, 0.16996443E-09_JPRB /)

RGHG8(:,83,12) = (/ &
  & 0.16994897E-09_JPRB, 0.16994600E-09_JPRB, 0.16994296E-09_JPRB, 0.16994167E-09_JPRB, 0.16994288E-09_JPRB, 0.16993867E-09_JPRB, &
  & 0.16993705E-09_JPRB, 0.16993436E-09_JPRB, 0.16993539E-09_JPRB, 0.16993557E-09_JPRB, 0.16993357E-09_JPRB, 0.16993344E-09_JPRB, &
  & 0.16993311E-09_JPRB, 0.16993318E-09_JPRB, 0.16992986E-09_JPRB, 0.16992591E-09_JPRB, 0.16992180E-09_JPRB, 0.16991493E-09_JPRB, &
  & 0.16991172E-09_JPRB, 0.16990763E-09_JPRB, 0.16990478E-09_JPRB, 0.16990515E-09_JPRB, 0.16990781E-09_JPRB, 0.16991009E-09_JPRB, &
  & 0.16991303E-09_JPRB, 0.16991603E-09_JPRB, 0.16992033E-09_JPRB, 0.16992358E-09_JPRB, 0.16992624E-09_JPRB, 0.16992664E-09_JPRB, &
  & 0.16992913E-09_JPRB, 0.16992825E-09_JPRB, 0.16992716E-09_JPRB, 0.16992396E-09_JPRB, 0.16992407E-09_JPRB, 0.16992116E-09_JPRB, &
  & 0.16992158E-09_JPRB, 0.16991855E-09_JPRB, 0.16991611E-09_JPRB, 0.16991765E-09_JPRB, 0.16991833E-09_JPRB, 0.16992169E-09_JPRB, &
  & 0.16992743E-09_JPRB, 0.16993720E-09_JPRB, 0.16994645E-09_JPRB, 0.16995323E-09_JPRB, 0.16995944E-09_JPRB, 0.16996513E-09_JPRB, &
  & 0.16996801E-09_JPRB, 0.16997245E-09_JPRB, 0.16997506E-09_JPRB, 0.16997763E-09_JPRB, 0.16997868E-09_JPRB, 0.16997724E-09_JPRB, &
  & 0.16997691E-09_JPRB, 0.16997591E-09_JPRB, 0.16997452E-09_JPRB, 0.16997187E-09_JPRB, 0.16997384E-09_JPRB, 0.16997059E-09_JPRB, &
  & 0.16996811E-09_JPRB, 0.16997065E-09_JPRB, 0.16996865E-09_JPRB, 0.16996519E-09_JPRB /)

RGHG8(:,84,12) = (/ &
  & 0.16994969E-09_JPRB, 0.16994695E-09_JPRB, 0.16994389E-09_JPRB, 0.16994263E-09_JPRB, 0.16994395E-09_JPRB, 0.16993977E-09_JPRB, &
  & 0.16993809E-09_JPRB, 0.16993562E-09_JPRB, 0.16993668E-09_JPRB, 0.16993679E-09_JPRB, 0.16993477E-09_JPRB, 0.16993469E-09_JPRB, &
  & 0.16993440E-09_JPRB, 0.16993444E-09_JPRB, 0.16993124E-09_JPRB, 0.16992735E-09_JPRB, 0.16992341E-09_JPRB, 0.16991658E-09_JPRB, &
  & 0.16991364E-09_JPRB, 0.16990948E-09_JPRB, 0.16990682E-09_JPRB, 0.16990720E-09_JPRB, 0.16990984E-09_JPRB, 0.16991207E-09_JPRB, &
  & 0.16991489E-09_JPRB, 0.16991786E-09_JPRB, 0.16992213E-09_JPRB, 0.16992530E-09_JPRB, 0.16992793E-09_JPRB, 0.16992820E-09_JPRB, &
  & 0.16993071E-09_JPRB, 0.16992976E-09_JPRB, 0.16992867E-09_JPRB, 0.16992548E-09_JPRB, 0.16992562E-09_JPRB, 0.16992283E-09_JPRB, &
  & 0.16992321E-09_JPRB, 0.16992031E-09_JPRB, 0.16991797E-09_JPRB, 0.16991943E-09_JPRB, 0.16991999E-09_JPRB, 0.16992333E-09_JPRB, &
  & 0.16992863E-09_JPRB, 0.16993860E-09_JPRB, 0.16994761E-09_JPRB, 0.16995425E-09_JPRB, 0.16996021E-09_JPRB, 0.16996575E-09_JPRB, &
  & 0.16996851E-09_JPRB, 0.16997291E-09_JPRB, 0.16997552E-09_JPRB, 0.16997809E-09_JPRB, 0.16997913E-09_JPRB, 0.16997767E-09_JPRB, &
  & 0.16997732E-09_JPRB, 0.16997632E-09_JPRB, 0.16997494E-09_JPRB, 0.16997226E-09_JPRB, 0.16997435E-09_JPRB, 0.16997105E-09_JPRB, &
  & 0.16996855E-09_JPRB, 0.16997123E-09_JPRB, 0.16996927E-09_JPRB, 0.16996572E-09_JPRB /)

RGHG8(:,85,12) = (/ &
  & 0.16995017E-09_JPRB, 0.16994760E-09_JPRB, 0.16994449E-09_JPRB, 0.16994323E-09_JPRB, 0.16994464E-09_JPRB, 0.16994038E-09_JPRB, &
  & 0.16993879E-09_JPRB, 0.16993648E-09_JPRB, 0.16993724E-09_JPRB, 0.16993723E-09_JPRB, 0.16993579E-09_JPRB, 0.16993552E-09_JPRB, &
  & 0.16993523E-09_JPRB, 0.16993507E-09_JPRB, 0.16993210E-09_JPRB, 0.16992831E-09_JPRB, 0.16992444E-09_JPRB, 0.16991779E-09_JPRB, &
  & 0.16991486E-09_JPRB, 0.16991088E-09_JPRB, 0.16990803E-09_JPRB, 0.16990845E-09_JPRB, 0.16991115E-09_JPRB, 0.16991332E-09_JPRB, &
  & 0.16991611E-09_JPRB, 0.16991901E-09_JPRB, 0.16992330E-09_JPRB, 0.16992645E-09_JPRB, 0.16992902E-09_JPRB, 0.16992922E-09_JPRB, &
  & 0.16993176E-09_JPRB, 0.16993075E-09_JPRB, 0.16992958E-09_JPRB, 0.16992643E-09_JPRB, 0.16992661E-09_JPRB, 0.16992391E-09_JPRB, &
  & 0.16992428E-09_JPRB, 0.16992148E-09_JPRB, 0.16991912E-09_JPRB, 0.16992054E-09_JPRB, 0.16992113E-09_JPRB, 0.16992419E-09_JPRB, &
  & 0.16992976E-09_JPRB, 0.16993933E-09_JPRB, 0.16994856E-09_JPRB, 0.16995493E-09_JPRB, 0.16996068E-09_JPRB, 0.16996615E-09_JPRB, &
  & 0.16996882E-09_JPRB, 0.16997320E-09_JPRB, 0.16997583E-09_JPRB, 0.16997842E-09_JPRB, 0.16997947E-09_JPRB, 0.16997796E-09_JPRB, &
  & 0.16997762E-09_JPRB, 0.16997657E-09_JPRB, 0.16997520E-09_JPRB, 0.16997248E-09_JPRB, 0.16997467E-09_JPRB, 0.16997134E-09_JPRB, &
  & 0.16996879E-09_JPRB, 0.16997161E-09_JPRB, 0.16996970E-09_JPRB, 0.16996610E-09_JPRB /)

RGHG8(:,86,12) = (/ &
  & 0.16995044E-09_JPRB, 0.16994800E-09_JPRB, 0.16994488E-09_JPRB, 0.16994353E-09_JPRB, 0.16994511E-09_JPRB, 0.16994080E-09_JPRB, &
  & 0.16993912E-09_JPRB, 0.16993718E-09_JPRB, 0.16993762E-09_JPRB, 0.16993748E-09_JPRB, 0.16993637E-09_JPRB, 0.16993604E-09_JPRB, &
  & 0.16993572E-09_JPRB, 0.16993533E-09_JPRB, 0.16993265E-09_JPRB, 0.16992900E-09_JPRB, 0.16992507E-09_JPRB, 0.16991866E-09_JPRB, &
  & 0.16991575E-09_JPRB, 0.16991170E-09_JPRB, 0.16990884E-09_JPRB, 0.16990921E-09_JPRB, 0.16991195E-09_JPRB, 0.16991407E-09_JPRB, &
  & 0.16991686E-09_JPRB, 0.16991973E-09_JPRB, 0.16992413E-09_JPRB, 0.16992724E-09_JPRB, 0.16992975E-09_JPRB, 0.16992982E-09_JPRB, &
  & 0.16993240E-09_JPRB, 0.16993133E-09_JPRB, 0.16993018E-09_JPRB, 0.16992703E-09_JPRB, 0.16992727E-09_JPRB, 0.16992459E-09_JPRB, &
  & 0.16992505E-09_JPRB, 0.16992219E-09_JPRB, 0.16991973E-09_JPRB, 0.16992127E-09_JPRB, 0.16992167E-09_JPRB, 0.16992487E-09_JPRB, &
  & 0.16993007E-09_JPRB, 0.16994020E-09_JPRB, 0.16994908E-09_JPRB, 0.16995540E-09_JPRB, 0.16996100E-09_JPRB, 0.16996643E-09_JPRB, &
  & 0.16996900E-09_JPRB, 0.16997337E-09_JPRB, 0.16997602E-09_JPRB, 0.16997864E-09_JPRB, 0.16997971E-09_JPRB, 0.16997814E-09_JPRB, &
  & 0.16997777E-09_JPRB, 0.16997671E-09_JPRB, 0.16997533E-09_JPRB, 0.16997265E-09_JPRB, 0.16997488E-09_JPRB, 0.16997152E-09_JPRB, &
  & 0.16996896E-09_JPRB, 0.16997188E-09_JPRB, 0.16997001E-09_JPRB, 0.16996636E-09_JPRB /)

RGHG8(:,87,12) = (/ &
  & 0.16995062E-09_JPRB, 0.16994829E-09_JPRB, 0.16994513E-09_JPRB, 0.16994374E-09_JPRB, 0.16994536E-09_JPRB, 0.16994087E-09_JPRB, &
  & 0.16993922E-09_JPRB, 0.16993754E-09_JPRB, 0.16993779E-09_JPRB, 0.16993761E-09_JPRB, 0.16993668E-09_JPRB, 0.16993634E-09_JPRB, &
  & 0.16993594E-09_JPRB, 0.16993541E-09_JPRB, 0.16993290E-09_JPRB, 0.16992943E-09_JPRB, 0.16992555E-09_JPRB, 0.16991923E-09_JPRB, &
  & 0.16991630E-09_JPRB, 0.16991225E-09_JPRB, 0.16990928E-09_JPRB, 0.16990961E-09_JPRB, 0.16991246E-09_JPRB, 0.16991451E-09_JPRB, &
  & 0.16991734E-09_JPRB, 0.16992015E-09_JPRB, 0.16992469E-09_JPRB, 0.16992777E-09_JPRB, 0.16993025E-09_JPRB, 0.16993024E-09_JPRB, &
  & 0.16993282E-09_JPRB, 0.16993171E-09_JPRB, 0.16993051E-09_JPRB, 0.16992735E-09_JPRB, 0.16992767E-09_JPRB, 0.16992494E-09_JPRB, &
  & 0.16992557E-09_JPRB, 0.16992263E-09_JPRB, 0.16991997E-09_JPRB, 0.16992170E-09_JPRB, 0.16992199E-09_JPRB, 0.16992510E-09_JPRB, &
  & 0.16993056E-09_JPRB, 0.16994059E-09_JPRB, 0.16994964E-09_JPRB, 0.16995572E-09_JPRB, 0.16996121E-09_JPRB, 0.16996657E-09_JPRB, &
  & 0.16996908E-09_JPRB, 0.16997342E-09_JPRB, 0.16997613E-09_JPRB, 0.16997881E-09_JPRB, 0.16997986E-09_JPRB, 0.16997825E-09_JPRB, &
  & 0.16997785E-09_JPRB, 0.16997678E-09_JPRB, 0.16997542E-09_JPRB, 0.16997267E-09_JPRB, 0.16997501E-09_JPRB, 0.16997166E-09_JPRB, &
  & 0.16996901E-09_JPRB, 0.16997202E-09_JPRB, 0.16997019E-09_JPRB, 0.16996654E-09_JPRB /)

RGHG8(:,88,12) = (/ &
  & 0.16995066E-09_JPRB, 0.16994842E-09_JPRB, 0.16994528E-09_JPRB, 0.16994384E-09_JPRB, 0.16994552E-09_JPRB, 0.16994103E-09_JPRB, &
  & 0.16993940E-09_JPRB, 0.16993776E-09_JPRB, 0.16993795E-09_JPRB, 0.16993776E-09_JPRB, 0.16993693E-09_JPRB, 0.16993654E-09_JPRB, &
  & 0.16993615E-09_JPRB, 0.16993551E-09_JPRB, 0.16993312E-09_JPRB, 0.16992968E-09_JPRB, 0.16992577E-09_JPRB, 0.16991962E-09_JPRB, &
  & 0.16991661E-09_JPRB, 0.16991257E-09_JPRB, 0.16990950E-09_JPRB, 0.16990986E-09_JPRB, 0.16991276E-09_JPRB, 0.16991482E-09_JPRB, &
  & 0.16991759E-09_JPRB, 0.16992037E-09_JPRB, 0.16992502E-09_JPRB, 0.16992809E-09_JPRB, 0.16993057E-09_JPRB, 0.16993046E-09_JPRB, &
  & 0.16993307E-09_JPRB, 0.16993192E-09_JPRB, 0.16993076E-09_JPRB, 0.16992753E-09_JPRB, 0.16992793E-09_JPRB, 0.16992514E-09_JPRB, &
  & 0.16992598E-09_JPRB, 0.16992288E-09_JPRB, 0.16992002E-09_JPRB, 0.16992199E-09_JPRB, 0.16992212E-09_JPRB, 0.16992530E-09_JPRB, &
  & 0.16993063E-09_JPRB, 0.16994103E-09_JPRB, 0.16994992E-09_JPRB, 0.16995594E-09_JPRB, 0.16996131E-09_JPRB, 0.16996664E-09_JPRB, &
  & 0.16996911E-09_JPRB, 0.16997347E-09_JPRB, 0.16997620E-09_JPRB, 0.16997891E-09_JPRB, 0.16997996E-09_JPRB, 0.16997832E-09_JPRB, &
  & 0.16997792E-09_JPRB, 0.16997682E-09_JPRB, 0.16997546E-09_JPRB, 0.16997270E-09_JPRB, 0.16997509E-09_JPRB, 0.16997169E-09_JPRB, &
  & 0.16996902E-09_JPRB, 0.16997213E-09_JPRB, 0.16997034E-09_JPRB, 0.16996662E-09_JPRB /)

RGHG8(:,89,12) = (/ &
  & 0.16995066E-09_JPRB, 0.16994850E-09_JPRB, 0.16994539E-09_JPRB, 0.16994391E-09_JPRB, 0.16994579E-09_JPRB, 0.16994108E-09_JPRB, &
  & 0.16993948E-09_JPRB, 0.16993780E-09_JPRB, 0.16993809E-09_JPRB, 0.16993792E-09_JPRB, 0.16993695E-09_JPRB, 0.16993662E-09_JPRB, &
  & 0.16993623E-09_JPRB, 0.16993570E-09_JPRB, 0.16993318E-09_JPRB, 0.16992974E-09_JPRB, 0.16992595E-09_JPRB, 0.16991958E-09_JPRB, &
  & 0.16991678E-09_JPRB, 0.16991264E-09_JPRB, 0.16990959E-09_JPRB, 0.16990996E-09_JPRB, 0.16991294E-09_JPRB, 0.16991496E-09_JPRB, &
  & 0.16991772E-09_JPRB, 0.16992045E-09_JPRB, 0.16992523E-09_JPRB, 0.16992831E-09_JPRB, 0.16993078E-09_JPRB, 0.16993054E-09_JPRB, &
  & 0.16993322E-09_JPRB, 0.16993205E-09_JPRB, 0.16993089E-09_JPRB, 0.16992759E-09_JPRB, 0.16992818E-09_JPRB, 0.16992523E-09_JPRB, &
  & 0.16992628E-09_JPRB, 0.16992303E-09_JPRB, 0.16991999E-09_JPRB, 0.16992222E-09_JPRB, 0.16992219E-09_JPRB, 0.16992532E-09_JPRB, &
  & 0.16993074E-09_JPRB, 0.16994121E-09_JPRB, 0.16995017E-09_JPRB, 0.16995606E-09_JPRB, 0.16996138E-09_JPRB, 0.16996671E-09_JPRB, &
  & 0.16996908E-09_JPRB, 0.16997349E-09_JPRB, 0.16997626E-09_JPRB, 0.16997898E-09_JPRB, 0.16998006E-09_JPRB, 0.16997836E-09_JPRB, &
  & 0.16997798E-09_JPRB, 0.16997688E-09_JPRB, 0.16997551E-09_JPRB, 0.16997270E-09_JPRB, 0.16997523E-09_JPRB, 0.16997173E-09_JPRB, &
  & 0.16996902E-09_JPRB, 0.16997227E-09_JPRB, 0.16997041E-09_JPRB, 0.16996665E-09_JPRB /)

RGHG8(:,90,12) = (/ &
  & 0.16995060E-09_JPRB, 0.16994864E-09_JPRB, 0.16994545E-09_JPRB, 0.16994384E-09_JPRB, 0.16994614E-09_JPRB, 0.16994117E-09_JPRB, &
  & 0.16993972E-09_JPRB, 0.16993758E-09_JPRB, 0.16993823E-09_JPRB, 0.16993823E-09_JPRB, 0.16993701E-09_JPRB, 0.16993668E-09_JPRB, &
  & 0.16993641E-09_JPRB, 0.16993612E-09_JPRB, 0.16993329E-09_JPRB, 0.16992968E-09_JPRB, 0.16992602E-09_JPRB, 0.16991936E-09_JPRB, &
  & 0.16991679E-09_JPRB, 0.16991267E-09_JPRB, 0.16990950E-09_JPRB, 0.16990992E-09_JPRB, 0.16991306E-09_JPRB, 0.16991500E-09_JPRB, &
  & 0.16991777E-09_JPRB, 0.16992047E-09_JPRB, 0.16992535E-09_JPRB, 0.16992840E-09_JPRB, 0.16993097E-09_JPRB, 0.16993053E-09_JPRB, &
  & 0.16993344E-09_JPRB, 0.16993214E-09_JPRB, 0.16993104E-09_JPRB, 0.16992743E-09_JPRB, 0.16992835E-09_JPRB, 0.16992512E-09_JPRB, &
  & 0.16992657E-09_JPRB, 0.16992310E-09_JPRB, 0.16991986E-09_JPRB, 0.16992231E-09_JPRB, 0.16992216E-09_JPRB, 0.16992530E-09_JPRB, &
  & 0.16993063E-09_JPRB, 0.16994135E-09_JPRB, 0.16995032E-09_JPRB, 0.16995613E-09_JPRB, 0.16996143E-09_JPRB, 0.16996682E-09_JPRB, &
  & 0.16996907E-09_JPRB, 0.16997358E-09_JPRB, 0.16997628E-09_JPRB, 0.16997909E-09_JPRB, 0.16998017E-09_JPRB, 0.16997835E-09_JPRB, &
  & 0.16997798E-09_JPRB, 0.16997689E-09_JPRB, 0.16997553E-09_JPRB, 0.16997261E-09_JPRB, 0.16997542E-09_JPRB, 0.16997170E-09_JPRB, &
  & 0.16996889E-09_JPRB, 0.16997241E-09_JPRB, 0.16997044E-09_JPRB, 0.16996661E-09_JPRB /)

RGHG8(:,91,12) = (/ &
  & 0.16995053E-09_JPRB, 0.16994901E-09_JPRB, 0.16994538E-09_JPRB, 0.16994357E-09_JPRB, 0.16994681E-09_JPRB, 0.16994102E-09_JPRB, &
  & 0.16994019E-09_JPRB, 0.16993669E-09_JPRB, 0.16993866E-09_JPRB, 0.16993948E-09_JPRB, 0.16993618E-09_JPRB, 0.16993665E-09_JPRB, &
  & 0.16993643E-09_JPRB, 0.16993704E-09_JPRB, 0.16993325E-09_JPRB, 0.16992953E-09_JPRB, 0.16992635E-09_JPRB, 0.16991869E-09_JPRB, &
  & 0.16991690E-09_JPRB, 0.16991257E-09_JPRB, 0.16990923E-09_JPRB, 0.16990978E-09_JPRB, 0.16991318E-09_JPRB, 0.16991497E-09_JPRB, &
  & 0.16991782E-09_JPRB, 0.16992033E-09_JPRB, 0.16992550E-09_JPRB, 0.16992847E-09_JPRB, 0.16993115E-09_JPRB, 0.16993029E-09_JPRB, &
  & 0.16993378E-09_JPRB, 0.16993218E-09_JPRB, 0.16993135E-09_JPRB, 0.16992699E-09_JPRB, 0.16992871E-09_JPRB, 0.16992467E-09_JPRB, &
  & 0.16992710E-09_JPRB, 0.16992301E-09_JPRB, 0.16991940E-09_JPRB, 0.16992252E-09_JPRB, 0.16992194E-09_JPRB, 0.16992516E-09_JPRB, &
  & 0.16993028E-09_JPRB, 0.16994148E-09_JPRB, 0.16995057E-09_JPRB, 0.16995619E-09_JPRB, 0.16996145E-09_JPRB, 0.16996704E-09_JPRB, &
  & 0.16996894E-09_JPRB, 0.16997370E-09_JPRB, 0.16997628E-09_JPRB, 0.16997920E-09_JPRB, 0.16998036E-09_JPRB, 0.16997821E-09_JPRB, &
  & 0.16997805E-09_JPRB, 0.16997692E-09_JPRB, 0.16997563E-09_JPRB, 0.16997224E-09_JPRB, 0.16997584E-09_JPRB, 0.16997162E-09_JPRB, &
  & 0.16996850E-09_JPRB, 0.16997273E-09_JPRB, 0.16997037E-09_JPRB, 0.16996650E-09_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_C22CLIM:PART24',1,ZHOOK_HANDLE)
END SUBROUTINE PART24

END SUBROUTINE SU_C22CLIM
