!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0 
SUBROUTINE SU_CCL4CLIM


!**   CCL4  FROM D.CARIOLLE 2D MODEL* 

!     PURPOSE.
!     --------

!**   INTERFACE.
!     ----------
!        CALL *SU_CCL4CLIM* FROM *SU_GHGCLIM*

!        EXPLICIT ARGUMENTS :
!        --------------------
!     ==== INPUTS ===
!     ==== OUTPUTS ===

!        IMPLICIT ARGUMENTS :   NONE
!        --------------------

!     METHOD.
!     -------

!     EXTERNALS.
!     ----------

!          NONE

!     REFERENCE.
!     ----------

!        SEE RADIATION'S PART OF THE MODEL'S DOCUMENTATION AND
!        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE "I.F.S"

!     AUTHOR.
!     -------
!     J.-J. MORCRETTE  E.C.M.W.F.    20080423

!     MODIFICATIONS.
!     --------------
!        Same history as suecaesu
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     R. Elkhatib 12-10-2005 Split for faster and more robust compilation.

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMCLIM   ,ONLY : RGHG9
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

IMPLICIT NONE

!     -----------------------------------------------------------------

!*       0.1   ARGUMENTS.
!              ----------
! REAL(KIND=JPRB),INTENT(OUT) :: PCLCCL4(64,91,12)

!     ----------------------------------------------------------------- 

!*       0.2   LOCAL ARRAYS.
!              -------------

! REAL(KIND=JPRB),SAVE :: ZGHG8(64,91,12)

LOGICAL,SAVE :: LLFIRSTCALL = .TRUE.

REAL(KIND=JPRB) :: ZHOOK_HANDLE
!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM',0,ZHOOK_HANDLE)

IF(LLFIRSTCALL) THEN

  ALLOCATE(RGHG9(64,91,12))

  CALL PART1
  CALL PART2
  CALL PART3
  CALL PART4
  CALL PART5
  CALL PART6
  CALL PART7
  CALL PART8
  CALL PART9
  CALL PART10
  CALL PART11
  CALL PART12
  CALL PART13
  CALL PART14
  CALL PART15
  CALL PART16
  CALL PART17
  CALL PART18
  CALL PART19
  CALL PART20
  CALL PART21
  CALL PART22
  CALL PART23
  CALL PART24

ENDIF

! PCLCCL4(:,:,:)=ZGHG8(:,:,:)

!     ------------------------------------------------------------------

LLFIRSTCALL = .FALSE.

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM',1,ZHOOK_HANDLE)

!-----------------------------------------------------------------------------

CONTAINS

SUBROUTINE PART1
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART1',0,ZHOOK_HANDLE)



!-- Month=  1 ------------

RGHG9(:, 1, 1) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.28025969E-44_JPRB, 0.28025969E-44_JPRB, 0.42038954E-44_JPRB, &
  & 0.70064923E-44_JPRB, 0.98090893E-44_JPRB, 0.12611686E-43_JPRB, 0.15414283E-43_JPRB, 0.15414283E-43_JPRB, 0.12611686E-43_JPRB, &
  & 0.12611686E-43_JPRB, 0.12611686E-43_JPRB, 0.98090893E-44_JPRB, 0.98090893E-44_JPRB, 0.84077908E-44_JPRB, 0.84077908E-44_JPRB, &
  & 0.70064923E-44_JPRB, 0.70064923E-44_JPRB, 0.56051939E-44_JPRB, 0.42038954E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 2, 1) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, &
  & 0.28025969E-44_JPRB, 0.84077908E-44_JPRB, 0.21019477E-43_JPRB, 0.50446745E-43_JPRB, 0.96689594E-43_JPRB, 0.17656361E-42_JPRB, &
  & 0.26764801E-42_JPRB, 0.40497526E-42_JPRB, 0.56332198E-42_JPRB, 0.65720898E-42_JPRB, 0.60536094E-42_JPRB, 0.53949991E-42_JPRB, &
  & 0.50727004E-42_JPRB, 0.47784278E-42_JPRB, 0.39656747E-42_JPRB, 0.37134409E-42_JPRB, 0.35032462E-42_JPRB, 0.32930514E-42_JPRB, &
  & 0.29847657E-42_JPRB, 0.25083243E-42_JPRB, 0.19337919E-42_JPRB, 0.13732725E-42_JPRB, 0.91084400E-43_JPRB, 0.57453237E-43_JPRB, &
  & 0.35032462E-43_JPRB, 0.19618179E-43_JPRB, 0.98090893E-44_JPRB, 0.56051939E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 3, 1) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.42038954E-44_JPRB, 0.15414283E-43_JPRB, 0.49045446E-43_JPRB, &
  & 0.14993894E-42_JPRB, 0.41618564E-42_JPRB, 0.96129075E-42_JPRB, 0.21762165E-41_JPRB, 0.44323070E-41_JPRB, 0.84750531E-41_JPRB, &
  & 0.12891946E-40_JPRB, 0.19706460E-40_JPRB, 0.27206210E-40_JPRB, 0.31482973E-40_JPRB, 0.29044713E-40_JPRB, 0.26020711E-40_JPRB, &
  & 0.24414823E-40_JPRB, 0.22870592E-40_JPRB, 0.19092692E-40_JPRB, 0.17659163E-40_JPRB, 0.16538124E-40_JPRB, 0.15522183E-40_JPRB, &
  & 0.14011583E-40_JPRB, 0.11805940E-40_JPRB, 0.91574855E-41_JPRB, 0.65580768E-41_JPRB, 0.43860642E-41_JPRB, 0.27647619E-41_JPRB, &
  & 0.16633413E-41_JPRB, 0.96409334E-42_JPRB, 0.54230251E-42_JPRB, 0.29847657E-42_JPRB, 0.15974802E-42_JPRB, 0.85479206E-43_JPRB, &
  & 0.44841551E-43_JPRB, 0.23822074E-43_JPRB, 0.12611686E-43_JPRB, 0.70064923E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 4, 1) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.70064923E-44_JPRB, &
  & 0.21019477E-43_JPRB, 0.58854536E-43_JPRB, 0.16955711E-42_JPRB, 0.48905316E-42_JPRB, 0.13872855E-41_JPRB, 0.41310279E-41_JPRB, &
  & 0.12550029E-40_JPRB, 0.34532198E-40_JPRB, 0.78678705E-40_JPRB, 0.18189975E-39_JPRB, 0.38130032E-39_JPRB, 0.76103539E-39_JPRB, &
  & 0.11597861E-38_JPRB, 0.17847806E-38_JPRB, 0.24570073E-38_JPRB, 0.28215425E-38_JPRB, 0.25936045E-38_JPRB, 0.23176342E-38_JPRB, &
  & 0.21710275E-38_JPRB, 0.20299168E-38_JPRB, 0.16900374E-38_JPRB, 0.15602982E-38_JPRB, 0.14577498E-38_JPRB, 0.13661133E-38_JPRB, &
  & 0.12336065E-38_JPRB, 0.10415950E-38_JPRB, 0.81111359E-39_JPRB, 0.58323724E-39_JPRB, 0.39049003E-39_JPRB, 0.24675325E-39_JPRB, &
  & 0.14891038E-39_JPRB, 0.86893116E-40_JPRB, 0.49428001E-40_JPRB, 0.27622395E-40_JPRB, 0.15202687E-40_JPRB, 0.82704635E-41_JPRB, &
  & 0.44435174E-41_JPRB, 0.23583853E-41_JPRB, 0.12359452E-41_JPRB, 0.64039340E-42_JPRB, 0.32930514E-42_JPRB, 0.16955711E-42_JPRB, &
  & 0.88281803E-43_JPRB, 0.47644148E-43_JPRB, 0.26624671E-43_JPRB, 0.15414283E-43_JPRB, 0.98090893E-44_JPRB, 0.56051939E-44_JPRB, &
  & 0.42038954E-44_JPRB, 0.42038954E-44_JPRB, 0.28025969E-44_JPRB, 0.28025969E-44_JPRB /)

RGHG9(:, 5, 1) = (/ &
  & 0.51848043E-43_JPRB, 0.98090893E-43_JPRB, 0.79874012E-43_JPRB, 0.60255834E-43_JPRB, 0.47644148E-43_JPRB, 0.43440252E-43_JPRB, &
  & 0.49045446E-43_JPRB, 0.70064923E-43_JPRB, 0.11770907E-42_JPRB, 0.23681944E-42_JPRB, 0.55071030E-42_JPRB, 0.15274153E-41_JPRB, &
  & 0.43832616E-41_JPRB, 0.12620094E-40_JPRB, 0.35721900E-40_JPRB, 0.10159694E-39_JPRB, 0.28121678E-39_JPRB, 0.81207208E-39_JPRB, &
  & 0.24006373E-38_JPRB, 0.64694923E-38_JPRB, 0.14344568E-37_JPRB, 0.32919438E-37_JPRB, 0.68739149E-37_JPRB, 0.13859883E-36_JPRB, &
  & 0.20839490E-36_JPRB, 0.31846164E-36_JPRB, 0.43323503E-36_JPRB, 0.49263390E-36_JPRB, 0.44856703E-36_JPRB, 0.39792787E-36_JPRB, &
  & 0.37127419E-36_JPRB, 0.34653808E-36_JPRB, 0.28801486E-36_JPRB, 0.26625157E-36_JPRB, 0.24943202E-36_JPRB, 0.23465350E-36_JPRB, &
  & 0.21319613E-36_JPRB, 0.18160321E-36_JPRB, 0.14296109E-36_JPRB, 0.10403703E-36_JPRB, 0.70671792E-37_JPRB, 0.45352150E-37_JPRB, &
  & 0.27893591E-37_JPRB, 0.16641647E-37_JPRB, 0.97168081E-38_JPRB, 0.55921183E-38_JPRB, 0.31749331E-38_JPRB, 0.17795440E-38_JPRB, &
  & 0.98100982E-39_JPRB, 0.53045172E-39_JPRB, 0.28090709E-39_JPRB, 0.14568740E-39_JPRB, 0.74264615E-40_JPRB, 0.37460912E-40_JPRB, &
  & 0.18925937E-40_JPRB, 0.97488334E-41_JPRB, 0.52338498E-41_JPRB, 0.29917722E-41_JPRB, 0.18595231E-41_JPRB, 0.12709777E-41_JPRB, &
  & 0.94167257E-42_JPRB, 0.73568169E-42_JPRB, 0.56752588E-42_JPRB, 0.37694929E-42_JPRB /)

RGHG9(:, 6, 1) = (/ &
  & 0.15681931E-40_JPRB, 0.38738896E-40_JPRB, 0.34082381E-40_JPRB, 0.27207611E-40_JPRB, 0.22650588E-40_JPRB, 0.21442669E-40_JPRB, &
  & 0.24808588E-40_JPRB, 0.34774623E-40_JPRB, 0.58591091E-40_JPRB, 0.11467946E-39_JPRB, 0.26051680E-39_JPRB, 0.70821484E-39_JPRB, &
  & 0.19662446E-38_JPRB, 0.54614262E-38_JPRB, 0.14831393E-37_JPRB, 0.40397641E-37_JPRB, 0.10682631E-36_JPRB, 0.29407502E-36_JPRB, &
  & 0.82889876E-36_JPRB, 0.21327027E-35_JPRB, 0.45198425E-35_JPRB, 0.99538880E-35_JPRB, 0.20088685E-34_JPRB, 0.39467312E-34_JPRB, &
  & 0.57643212E-34_JPRB, 0.85957198E-34_JPRB, 0.11435644E-33_JPRB, 0.12770710E-33_JPRB, 0.11449225E-33_JPRB, 0.10031035E-33_JPRB, &
  & 0.93028726E-34_JPRB, 0.86720167E-34_JPRB, 0.72142551E-34_JPRB, 0.67147251E-34_JPRB, 0.63438319E-34_JPRB, 0.60378418E-34_JPRB, &
  & 0.55708015E-34_JPRB, 0.48383973E-34_JPRB, 0.39007931E-34_JPRB, 0.29217741E-34_JPRB, 0.20473133E-34_JPRB, 0.13599520E-34_JPRB, &
  & 0.86680963E-35_JPRB, 0.53691526E-35_JPRB, 0.32605296E-35_JPRB, 0.19540387E-35_JPRB, 0.11555196E-35_JPRB, 0.67358368E-36_JPRB, &
  & 0.38476714E-36_JPRB, 0.21440494E-36_JPRB, 0.11627898E-36_JPRB, 0.61412679E-37_JPRB, 0.31767447E-37_JPRB, 0.16250060E-37_JPRB, &
  & 0.83381477E-38_JPRB, 0.43802222E-38_JPRB, 0.24080459E-38_JPRB, 0.14154123E-38_JPRB, 0.90817173E-39_JPRB, 0.63853247E-39_JPRB, &
  & 0.48762944E-39_JPRB, 0.39182827E-39_JPRB, 0.32141583E-39_JPRB, 0.23979860E-39_JPRB /)

RGHG9(:, 7, 1) = (/ &
  & 0.13074728E-37_JPRB, 0.23917278E-37_JPRB, 0.21036784E-37_JPRB, 0.17281129E-37_JPRB, 0.15005339E-37_JPRB, 0.14758419E-37_JPRB, &
  & 0.17445007E-37_JPRB, 0.24613822E-37_JPRB, 0.40414748E-37_JPRB, 0.76381282E-37_JPRB, 0.16404320E-36_JPRB, 0.42119570E-36_JPRB, &
  & 0.11002274E-35_JPRB, 0.28705125E-35_JPRB, 0.73114185E-35_JPRB, 0.18680966E-34_JPRB, 0.46251269E-34_JPRB, 0.11941169E-33_JPRB, &
  & 0.31630326E-33_JPRB, 0.76661379E-33_JPRB, 0.15319811E-32_JPRB, 0.31972811E-32_JPRB, 0.61488625E-32_JPRB, 0.11640120E-31_JPRB, &
  & 0.16375874E-31_JPRB, 0.23681436E-31_JPRB, 0.30692093E-31_JPRB, 0.33502644E-31_JPRB, 0.29471733E-31_JPRB, 0.25504786E-31_JPRB, &
  & 0.23502977E-31_JPRB, 0.21898547E-31_JPRB, 0.18290807E-31_JPRB, 0.17168471E-31_JPRB, 0.16409803E-31_JPRB, 0.15850373E-31_JPRB, &
  & 0.14900417E-31_JPRB, 0.13257554E-31_JPRB, 0.11022658E-31_JPRB, 0.85542972E-32_JPRB, 0.62448622E-32_JPRB, 0.43244604E-32_JPRB, &
  & 0.28765647E-32_JPRB, 0.18600683E-32_JPRB, 0.11793832E-32_JPRB, 0.73812266E-33_JPRB, 0.45554534E-33_JPRB, 0.27673669E-33_JPRB, &
  & 0.16429445E-33_JPRB, 0.94803149E-34_JPRB, 0.53039074E-34_JPRB, 0.28821721E-34_JPRB, 0.15346486E-34_JPRB, 0.81058142E-35_JPRB, &
  & 0.43263957E-35_JPRB, 0.23820400E-35_JPRB, 0.13837850E-35_JPRB, 0.86290229E-36_JPRB, 0.58563039E-36_JPRB, 0.43272088E-36_JPRB, &
  & 0.34239170E-36_JPRB, 0.28370391E-36_JPRB, 0.23764708E-36_JPRB, 0.18484751E-36_JPRB /)

RGHG9(:, 8, 1) = (/ &
  & 0.10590025E-34_JPRB, 0.17002671E-34_JPRB, 0.14266897E-34_JPRB, 0.11771145E-34_JPRB, 0.10336247E-34_JPRB, 0.10258206E-34_JPRB, &
  & 0.12154937E-34_JPRB, 0.16836555E-34_JPRB, 0.26821699E-34_JPRB, 0.48002988E-34_JPRB, 0.96999877E-34_JPRB, 0.23295754E-33_JPRB, &
  & 0.56868548E-33_JPRB, 0.13844673E-32_JPRB, 0.32851467E-32_JPRB, 0.78200445E-32_JPRB, 0.18019185E-31_JPRB, 0.43400201E-31_JPRB, &
  & 0.10790557E-30_JPRB, 0.24642325E-30_JPRB, 0.46323261E-30_JPRB, 0.91519551E-30_JPRB, 0.16752277E-29_JPRB, 0.30511071E-29_JPRB, &
  & 0.41247551E-29_JPRB, 0.57759294E-29_JPRB, 0.72795465E-29_JPRB, 0.77571327E-29_JPRB, 0.66933747E-29_JPRB, 0.57166352E-29_JPRB, &
  & 0.52339095E-29_JPRB, 0.48723097E-29_JPRB, 0.40862174E-29_JPRB, 0.38681144E-29_JPRB, 0.37424295E-29_JPRB, 0.36713220E-29_JPRB, &
  & 0.35206327E-29_JPRB, 0.32135322E-29_JPRB, 0.27588128E-29_JPRB, 0.22272968E-29_JPRB, 0.16966632E-29_JPRB, 0.12292105E-29_JPRB, &
  & 0.85465408E-30_JPRB, 0.57697673E-30_JPRB, 0.38153932E-30_JPRB, 0.24876801E-30_JPRB, 0.15974727E-30_JPRB, 0.10086988E-30_JPRB, &
  & 0.62142850E-31_JPRB, 0.37154244E-31_JPRB, 0.21519430E-31_JPRB, 0.12112416E-31_JPRB, 0.67003854E-32_JPRB, 0.36987709E-32_JPRB, &
  & 0.20764744E-32_JPRB, 0.12124623E-32_JPRB, 0.75014888E-33_JPRB, 0.49733651E-33_JPRB, 0.35656672E-33_JPRB, 0.27555957E-33_JPRB, &
  & 0.22549196E-33_JPRB, 0.19070945E-33_JPRB, 0.16276742E-33_JPRB, 0.12706453E-33_JPRB /)

RGHG9(:, 9, 1) = (/ &
  & 0.77088515E-32_JPRB, 0.11730008E-31_JPRB, 0.96052119E-32_JPRB, 0.77959873E-32_JPRB, 0.67745415E-32_JPRB, 0.66281829E-32_JPRB, &
  & 0.76798477E-32_JPRB, 0.10319604E-31_JPRB, 0.15706672E-31_JPRB, 0.26672508E-31_JPRB, 0.50484949E-31_JPRB, 0.11371685E-30_JPRB, &
  & 0.25937777E-30_JPRB, 0.58877917E-30_JPRB, 0.12990648E-29_JPRB, 0.28763440E-29_JPRB, 0.61481672E-29_JPRB, 0.13794133E-28_JPRB, &
  & 0.32230994E-28_JPRB, 0.69498037E-28_JPRB, 0.12283203E-27_JPRB, 0.22986455E-27_JPRB, 0.39994523E-27_JPRB, 0.70013283E-27_JPRB, &
  & 0.90720246E-27_JPRB, 0.12279653E-26_JPRB, 0.15025515E-26_JPRB, 0.15613206E-26_JPRB, 0.13199773E-26_JPRB, 0.11114217E-26_JPRB, &
  & 0.10088295E-26_JPRB, 0.93662364E-27_JPRB, 0.78744145E-27_JPRB, 0.75164192E-27_JPRB, 0.73679965E-27_JPRB, 0.73581949E-27_JPRB, &
  & 0.72173132E-27_JPRB, 0.67760571E-27_JPRB, 0.60240007E-27_JPRB, 0.50654586E-27_JPRB, 0.40414552E-27_JPRB, 0.30706772E-27_JPRB, &
  & 0.22372163E-27_JPRB, 0.15793997E-27_JPRB, 0.10890436E-27_JPRB, 0.73908549E-28_JPRB, 0.49312013E-28_JPRB, 0.32330183E-28_JPRB, &
  & 0.20672994E-28_JPRB, 0.12836425E-28_JPRB, 0.77356616E-29_JPRB, 0.45429513E-29_JPRB, 0.26353635E-29_JPRB, 0.15318935E-29_JPRB, &
  & 0.91102533E-30_JPRB, 0.56424444E-30_JPRB, 0.37009842E-30_JPRB, 0.25827496E-30_JPRB, 0.19365771E-30_JPRB, 0.15444503E-30_JPRB, &
  & 0.12949212E-30_JPRB, 0.11158153E-30_JPRB, 0.95819946E-31_JPRB, 0.76059592E-31_JPRB /)

RGHG9(:,10, 1) = (/ &
  & 0.48960987E-29_JPRB, 0.73203890E-29_JPRB, 0.58763038E-29_JPRB, 0.46955485E-29_JPRB, 0.39963859E-29_JPRB, 0.38045332E-29_JPRB, &
  & 0.42672499E-29_JPRB, 0.55106427E-29_JPRB, 0.80102240E-29_JPRB, 0.12866819E-28_JPRB, 0.22877565E-28_JPRB, 0.48379992E-28_JPRB, &
  & 0.10322700E-27_JPRB, 0.21855761E-27_JPRB, 0.44833275E-27_JPRB, 0.92272970E-27_JPRB, 0.18283361E-26_JPRB, 0.38159359E-26_JPRB, &
  & 0.83750558E-26_JPRB, 0.17053341E-25_JPRB, 0.28305436E-25_JPRB, 0.50124092E-25_JPRB, 0.82797337E-25_JPRB, 0.13877328E-24_JPRB, &
  & 0.17220610E-24_JPRB, 0.22469465E-24_JPRB, 0.26652122E-24_JPRB, 0.26978321E-24_JPRB, 0.22331005E-24_JPRB, 0.18502766E-24_JPRB, &
  & 0.16619310E-24_JPRB, 0.15358508E-24_JPRB, 0.12932747E-24_JPRB, 0.12443049E-24_JPRB, 0.12374571E-24_JPRB, 0.12612911E-24_JPRB, &
  & 0.12695141E-24_JPRB, 0.12295881E-24_JPRB, 0.11341470E-24_JPRB, 0.99550388E-25_JPRB, 0.83295410E-25_JPRB, 0.66562148E-25_JPRB, &
  & 0.50988493E-25_JPRB, 0.37731790E-25_JPRB, 0.27189795E-25_JPRB, 0.19230885E-25_JPRB, 0.13345248E-25_JPRB, 0.90987625E-26_JPRB, &
  & 0.60526786E-26_JPRB, 0.39178322E-26_JPRB, 0.24691267E-26_JPRB, 0.15222890E-26_JPRB, 0.93044141E-27_JPRB, 0.57164129E-27_JPRB, &
  & 0.35923767E-27_JPRB, 0.23494078E-27_JPRB, 0.16173399E-27_JPRB, 0.11777834E-27_JPRB, 0.90902750E-28_JPRB, 0.74543781E-28_JPRB, &
  & 0.63576055E-28_JPRB, 0.55345262E-28_JPRB, 0.48382261E-28_JPRB, 0.38376625E-28_JPRB /)

RGHG9(:,11, 1) = (/ &
  & 0.26236046E-26_JPRB, 0.38826578E-26_JPRB, 0.30806237E-26_JPRB, 0.24213036E-26_JPRB, 0.20163859E-26_JPRB, 0.18659418E-26_JPRB, &
  & 0.20241179E-26_JPRB, 0.25144225E-26_JPRB, 0.34924282E-26_JPRB, 0.53233436E-26_JPRB, 0.89103403E-26_JPRB, 0.17728355E-25_JPRB, &
  & 0.35450728E-25_JPRB, 0.70120515E-25_JPRB, 0.13391079E-24_JPRB, 0.25647618E-24_JPRB, 0.47151173E-24_JPRB, 0.91539942E-24_JPRB, &
  & 0.18841316E-23_JPRB, 0.36163790E-23_JPRB, 0.56345100E-23_JPRB, 0.94292441E-23_JPRB, 0.14759087E-22_JPRB, 0.23632709E-22_JPRB, &
  & 0.28059296E-22_JPRB, 0.35236684E-22_JPRB, 0.40453491E-22_JPRB, 0.39844159E-22_JPRB, 0.32249656E-22_JPRB, 0.26252805E-22_JPRB, &
  & 0.23297775E-22_JPRB, 0.21408327E-22_JPRB, 0.18045089E-22_JPRB, 0.17503946E-22_JPRB, 0.17676726E-22_JPRB, 0.18421534E-22_JPRB, &
  & 0.19068859E-22_JPRB, 0.19090453E-22_JPRB, 0.18291911E-22_JPRB, 0.16761690E-22_JPRB, 0.14710707E-22_JPRB, 0.12372466E-22_JPRB, &
  & 0.99801759E-23_JPRB, 0.77690430E-23_JPRB, 0.58684002E-23_JPRB, 0.43408089E-23_JPRB, 0.31431027E-23_JPRB, 0.22360832E-23_JPRB, &
  & 0.15532155E-23_JPRB, 0.10521627E-23_JPRB, 0.69628995E-24_JPRB, 0.45182462E-24_JPRB, 0.29143931E-24_JPRB, 0.18875485E-24_JPRB, &
  & 0.12492018E-24_JPRB, 0.85561623E-25_JPRB, 0.61399904E-25_JPRB, 0.46024013E-25_JPRB, 0.36604542E-25_JPRB, 0.30451063E-25_JPRB, &
  & 0.26355676E-25_JPRB, 0.23278065E-25_JPRB, 0.20358996E-25_JPRB, 0.16639317E-25_JPRB /)

RGHG9(:,12, 1) = (/ &
  & 0.11707698E-23_JPRB, 0.17172472E-23_JPRB, 0.13484137E-23_JPRB, 0.10454138E-23_JPRB, 0.85401697E-24_JPRB, 0.77104714E-24_JPRB, &
  & 0.81146823E-24_JPRB, 0.97213864E-24_JPRB, 0.12937070E-23_JPRB, 0.18757523E-23_JPRB, 0.29630091E-23_JPRB, 0.55540730E-23_JPRB, &
  & 0.10422302E-22_JPRB, 0.19283743E-22_JPRB, 0.34338307E-22_JPRB, 0.61259088E-22_JPRB, 0.10465155E-21_JPRB, 0.18904389E-21_JPRB, &
  & 0.36430743E-21_JPRB, 0.65769002E-21_JPRB, 0.96214545E-21_JPRB, 0.15191081E-20_JPRB, 0.22523187E-20_JPRB, 0.34370138E-20_JPRB, &
  & 0.39037913E-20_JPRB, 0.47099349E-20_JPRB, 0.52254227E-20_JPRB, 0.49999122E-20_JPRB, 0.39508565E-20_JPRB, 0.31546136E-20_JPRB, &
  & 0.27627128E-20_JPRB, 0.25229091E-20_JPRB, 0.21290122E-20_JPRB, 0.20830932E-20_JPRB, 0.21379376E-20_JPRB, 0.22807179E-20_JPRB, &
  & 0.24316537E-20_JPRB, 0.25200219E-20_JPRB, 0.25102749E-20_JPRB, 0.24009786E-20_JPRB, 0.22078573E-20_JPRB, 0.19519956E-20_JPRB, &
  & 0.16594677E-20_JPRB, 0.13614436E-20_JPRB, 0.10825875E-20_JPRB, 0.84106754E-21_JPRB, 0.63830878E-21_JPRB, 0.47587700E-21_JPRB, &
  & 0.34646147E-21_JPRB, 0.24640183E-21_JPRB, 0.17151734E-21_JPRB, 0.11722869E-21_JPRB, 0.79637572E-22_JPRB, 0.54229656E-22_JPRB, &
  & 0.37571435E-22_JPRB, 0.26815670E-22_JPRB, 0.19872405E-22_JPRB, 0.15347201E-22_JPRB, 0.12373414E-22_JPRB, 0.10488060E-22_JPRB, &
  & 0.91681130E-23_JPRB, 0.81340079E-23_JPRB, 0.72309042E-23_JPRB, 0.58628923E-23_JPRB /)

RGHG9(:,13, 1) = (/ &
  & 0.43942950E-21_JPRB, 0.63923810E-21_JPRB, 0.49767667E-21_JPRB, 0.38124749E-21_JPRB, 0.30647446E-21_JPRB, 0.27063508E-21_JPRB, &
  & 0.27690414E-21_JPRB, 0.32044439E-21_JPRB, 0.40894708E-21_JPRB, 0.56453497E-21_JPRB, 0.84249406E-21_JPRB, 0.14875581E-20_JPRB, &
  & 0.26201414E-20_JPRB, 0.45366030E-20_JPRB, 0.75356582E-20_JPRB, 0.12528335E-19_JPRB, 0.19903995E-19_JPRB, 0.33460089E-19_JPRB, &
  & 0.60280367E-19_JPRB, 0.10216166E-18_JPRB, 0.14030997E-18_JPRB, 0.20874820E-18_JPRB, 0.29278947E-18_JPRB, 0.42507217E-18_JPRB, &
  & 0.46136262E-18_JPRB, 0.53378544E-18_JPRB, 0.57122689E-18_JPRB, 0.53013814E-18_JPRB, 0.40844858E-18_JPRB, 0.31960845E-18_JPRB, &
  & 0.27614936E-18_JPRB, 0.25068422E-18_JPRB, 0.21196181E-18_JPRB, 0.20931088E-18_JPRB, 0.21841880E-18_JPRB, 0.23861092E-18_JPRB, &
  & 0.26217888E-18_JPRB, 0.28143119E-18_JPRB, 0.29154622E-18_JPRB, 0.29100793E-18_JPRB, 0.28020909E-18_JPRB, 0.26029872E-18_JPRB, &
  & 0.23322497E-18_JPRB, 0.20213833E-18_JPRB, 0.16982183E-18_JPRB, 0.13926157E-18_JPRB, 0.11134179E-18_JPRB, 0.87382830E-19_JPRB, &
  & 0.66931739E-19_JPRB, 0.50098850E-19_JPRB, 0.36725068E-19_JPRB, 0.26415536E-19_JPRB, 0.18867920E-19_JPRB, 0.13460343E-19_JPRB, &
  & 0.97307152E-20_JPRB, 0.72002130E-20_JPRB, 0.55050602E-20_JPRB, 0.43316880E-20_JPRB, 0.35651957E-20_JPRB, 0.30431131E-20_JPRB, &
  & 0.26831867E-20_JPRB, 0.24003844E-20_JPRB, 0.21261979E-20_JPRB, 0.17489474E-20_JPRB /)

RGHG9(:,14, 1) = (/ &
  & 0.13964046E-18_JPRB, 0.20166687E-18_JPRB, 0.15576553E-18_JPRB, 0.11805997E-18_JPRB, 0.93450361E-19_JPRB, 0.80813187E-19_JPRB, &
  & 0.80448989E-19_JPRB, 0.89961107E-19_JPRB, 0.11016164E-18_JPRB, 0.14484456E-18_JPRB, 0.20435971E-18_JPRB, 0.33987528E-18_JPRB, &
  & 0.56199354E-18_JPRB, 0.91070435E-18_JPRB, 0.14119542E-17_JPRB, 0.21882486E-17_JPRB, 0.32354529E-17_JPRB, 0.50625629E-17_JPRB, &
  & 0.85197312E-17_JPRB, 0.13540057E-16_JPRB, 0.17456274E-16_JPRB, 0.24444828E-16_JPRB, 0.32411914E-16_JPRB, 0.44696847E-16_JPRB, &
  & 0.46318190E-16_JPRB, 0.51299204E-16_JPRB, 0.52874278E-16_JPRB, 0.47540661E-16_JPRB, 0.35692003E-16_JPRB, 0.27368759E-16_JPRB, &
  & 0.23344367E-16_JPRB, 0.21087296E-16_JPRB, 0.17877687E-16_JPRB, 0.17825319E-16_JPRB, 0.18908985E-16_JPRB, 0.21138797E-16_JPRB, &
  & 0.23915393E-16_JPRB, 0.26568502E-16_JPRB, 0.28602701E-16_JPRB, 0.29779170E-16_JPRB, 0.30016935E-16_JPRB, 0.29294946E-16_JPRB, &
  & 0.27675233E-16_JPRB, 0.25365841E-16_JPRB, 0.22576543E-16_JPRB, 0.19614944E-16_JPRB, 0.16598825E-16_JPRB, 0.13774451E-16_JPRB, &
  & 0.11143331E-16_JPRB, 0.88031415E-17_JPRB, 0.68050197E-17_JPRB, 0.51523740E-17_JPRB, 0.38651739E-17_JPRB, 0.28844832E-17_JPRB, &
  & 0.21710629E-17_JPRB, 0.16635589E-17_JPRB, 0.13080296E-17_JPRB, 0.10531341E-17_JPRB, 0.87669937E-18_JPRB, 0.75769124E-18_JPRB, &
  & 0.67114964E-18_JPRB, 0.60206506E-18_JPRB, 0.53564877E-18_JPRB, 0.43542426E-18_JPRB /)

RGHG9(:,15, 1) = (/ &
  & 0.37715707E-16_JPRB, 0.54133545E-16_JPRB, 0.41498546E-16_JPRB, 0.31117032E-16_JPRB, 0.24256914E-16_JPRB, 0.20540349E-16_JPRB, &
  & 0.19893345E-16_JPRB, 0.21496939E-16_JPRB, 0.25260172E-16_JPRB, 0.31646220E-16_JPRB, 0.42226660E-16_JPRB, 0.66158018E-16_JPRB, &
  & 0.10271262E-15_JPRB, 0.15582512E-15_JPRB, 0.22555881E-15_JPRB, 0.32598259E-15_JPRB, 0.44871687E-15_JPRB, 0.65351959E-15_JPRB, &
  & 0.10268919E-14_JPRB, 0.15295691E-14_JPRB, 0.18502031E-14_JPRB, 0.24369263E-14_JPRB, 0.30519927E-14_JPRB, 0.39961591E-14_JPRB, &
  & 0.39495685E-14_JPRB, 0.41833111E-14_JPRB, 0.41482566E-14_JPRB, 0.36105029E-14_JPRB, 0.26404012E-14_JPRB, 0.19846988E-14_JPRB, &
  & 0.16720407E-14_JPRB, 0.15034368E-14_JPRB, 0.12784394E-14_JPRB, 0.12870169E-14_JPRB, 0.13878049E-14_JPRB, 0.15874492E-14_JPRB, &
  & 0.18486312E-14_JPRB, 0.21240520E-14_JPRB, 0.23747867E-14_JPRB, 0.25776032E-14_JPRB, 0.27191621E-14_JPRB, 0.27878802E-14_JPRB, &
  & 0.27768573E-14_JPRB, 0.26918330E-14_JPRB, 0.25399206E-14_JPRB, 0.23418494E-14_JPRB, 0.21033509E-14_JPRB, 0.18514658E-14_JPRB, &
  & 0.15870940E-14_JPRB, 0.13268132E-14_JPRB, 0.10833080E-14_JPRB, 0.86414989E-15_JPRB, 0.68059828E-15_JPRB, 0.53104477E-15_JPRB, &
  & 0.41578767E-15_JPRB, 0.32964786E-15_JPRB, 0.26660034E-15_JPRB, 0.21924580E-15_JPRB, 0.18544827E-15_JPRB, 0.16143109E-15_JPRB, &
  & 0.14412432E-15_JPRB, 0.12935699E-15_JPRB, 0.11527360E-15_JPRB, 0.92776895E-16_JPRB /)

RGHG9(:,16, 1) = (/ &
  & 0.62054428E-15_JPRB, 0.46903301E-15_JPRB, 0.36437155E-15_JPRB, 0.30284183E-15_JPRB, 0.27181388E-15_JPRB, 0.26386537E-15_JPRB, &
  & 0.28565342E-15_JPRB, 0.32255121E-15_JPRB, 0.39072169E-15_JPRB, 0.49203498E-15_JPRB, 0.64485756E-15_JPRB, 0.92266018E-15_JPRB, &
  & 0.13731363E-14_JPRB, 0.20067310E-14_JPRB, 0.28780297E-14_JPRB, 0.43341727E-14_JPRB, 0.63638661E-14_JPRB, 0.87242733E-14_JPRB, &
  & 0.12001844E-13_JPRB, 0.15788775E-13_JPRB, 0.21437042E-13_JPRB, 0.25839492E-13_JPRB, 0.29113193E-13_JPRB, 0.32645405E-13_JPRB, &
  & 0.33458489E-13_JPRB, 0.32869896E-13_JPRB, 0.29512424E-13_JPRB, 0.25906343E-13_JPRB, 0.22533972E-13_JPRB, 0.16929666E-13_JPRB, &
  & 0.13761867E-13_JPRB, 0.11198556E-13_JPRB, 0.10484914E-13_JPRB, 0.10721218E-13_JPRB, 0.11980513E-13_JPRB, 0.14115453E-13_JPRB, &
  & 0.16841083E-13_JPRB, 0.19754733E-13_JPRB, 0.22418550E-13_JPRB, 0.24555831E-13_JPRB, 0.25980335E-13_JPRB, 0.26597058E-13_JPRB, &
  & 0.26348302E-13_JPRB, 0.25363963E-13_JPRB, 0.23852792E-13_JPRB, 0.21998161E-13_JPRB, 0.19863234E-13_JPRB, 0.17574572E-13_JPRB, &
  & 0.15194602E-13_JPRB, 0.12822639E-13_JPRB, 0.10577557E-13_JPRB, 0.85471892E-14_JPRB, 0.68152025E-14_JPRB, 0.53850251E-14_JPRB, &
  & 0.42677789E-14_JPRB, 0.34180227E-14_JPRB, 0.27675440E-14_JPRB, 0.22675210E-14_JPRB, 0.19014227E-14_JPRB, 0.16383049E-14_JPRB, &
  & 0.14374413E-14_JPRB, 0.12814264E-14_JPRB, 0.11191911E-14_JPRB, 0.89737720E-15_JPRB /)

RGHG9(:,17, 1) = (/ &
  & 0.23706491E-14_JPRB, 0.19394740E-14_JPRB, 0.18018142E-14_JPRB, 0.17392619E-14_JPRB, 0.18005221E-14_JPRB, 0.20646077E-14_JPRB, &
  & 0.26169523E-14_JPRB, 0.34820997E-14_JPRB, 0.45294752E-14_JPRB, 0.58819755E-14_JPRB, 0.78539131E-14_JPRB, 0.10869158E-13_JPRB, &
  & 0.15124769E-13_JPRB, 0.21124997E-13_JPRB, 0.29128752E-13_JPRB, 0.39955750E-13_JPRB, 0.54440939E-13_JPRB, 0.73183077E-13_JPRB, &
  & 0.95199205E-13_JPRB, 0.11765969E-12_JPRB, 0.14229770E-12_JPRB, 0.16497479E-12_JPRB, 0.18048475E-12_JPRB, 0.18763498E-12_JPRB, &
  & 0.18322571E-12_JPRB, 0.17057501E-12_JPRB, 0.15081347E-12_JPRB, 0.12545820E-12_JPRB, 0.10169058E-12_JPRB, 0.85188136E-13_JPRB, &
  & 0.72258463E-13_JPRB, 0.65151951E-13_JPRB, 0.63476161E-13_JPRB, 0.67593900E-13_JPRB, 0.76987916E-13_JPRB, 0.91262935E-13_JPRB, &
  & 0.10902778E-12_JPRB, 0.12786044E-12_JPRB, 0.14490054E-12_JPRB, 0.15747967E-12_JPRB, 0.16597396E-12_JPRB, 0.16926020E-12_JPRB, &
  & 0.16526217E-12_JPRB, 0.15725168E-12_JPRB, 0.14655004E-12_JPRB, 0.13423937E-12_JPRB, 0.12066319E-12_JPRB, 0.10644253E-12_JPRB, &
  & 0.91955747E-13_JPRB, 0.77727653E-13_JPRB, 0.64368704E-13_JPRB, 0.52412549E-13_JPRB, 0.42151687E-13_JPRB, 0.33714940E-13_JPRB, &
  & 0.27040714E-13_JPRB, 0.21859003E-13_JPRB, 0.17752181E-13_JPRB, 0.14579927E-13_JPRB, 0.12182733E-13_JPRB, 0.10381919E-13_JPRB, &
  & 0.90465321E-14_JPRB, 0.79011742E-14_JPRB, 0.68748082E-14_JPRB, 0.52870755E-14_JPRB /)

RGHG9(:,18, 1) = (/ &
  & 0.20157821E-13_JPRB, 0.18701978E-13_JPRB, 0.17990617E-13_JPRB, 0.17774529E-13_JPRB, 0.18289306E-13_JPRB, 0.20075016E-13_JPRB, &
  & 0.23685706E-13_JPRB, 0.29785189E-13_JPRB, 0.38527256E-13_JPRB, 0.50303057E-13_JPRB, 0.65702848E-13_JPRB, 0.86604579E-13_JPRB, &
  & 0.11444808E-12_JPRB, 0.15055417E-12_JPRB, 0.19750999E-12_JPRB, 0.25615434E-12_JPRB, 0.32606987E-12_JPRB, 0.41018095E-12_JPRB, &
  & 0.50278450E-12_JPRB, 0.59388475E-12_JPRB, 0.67388716E-12_JPRB, 0.73118887E-12_JPRB, 0.75489598E-12_JPRB, 0.74056120E-12_JPRB, &
  & 0.69030697E-12_JPRB, 0.61453647E-12_JPRB, 0.52840360E-12_JPRB, 0.44865468E-12_JPRB, 0.37782890E-12_JPRB, 0.32831008E-12_JPRB, &
  & 0.29872751E-12_JPRB, 0.29006558E-12_JPRB, 0.30021726E-12_JPRB, 0.32905888E-12_JPRB, 0.37638412E-12_JPRB, 0.44086588E-12_JPRB, &
  & 0.51739450E-12_JPRB, 0.59571266E-12_JPRB, 0.66368910E-12_JPRB, 0.71240556E-12_JPRB, 0.73154091E-12_JPRB, 0.72700027E-12_JPRB, &
  & 0.70390845E-12_JPRB, 0.66399533E-12_JPRB, 0.61362048E-12_JPRB, 0.55812191E-12_JPRB, 0.49980338E-12_JPRB, 0.44001548E-12_JPRB, &
  & 0.38067970E-12_JPRB, 0.32327399E-12_JPRB, 0.27004080E-12_JPRB, 0.22257206E-12_JPRB, 0.18183109E-12_JPRB, 0.14799698E-12_JPRB, &
  & 0.12090517E-12_JPRB, 0.99055780E-13_JPRB, 0.81517597E-13_JPRB, 0.67660362E-13_JPRB, 0.56843351E-13_JPRB, 0.48518776E-13_JPRB, &
  & 0.41881612E-13_JPRB, 0.36491226E-13_JPRB, 0.31163386E-13_JPRB, 0.23771431E-13_JPRB /)

RGHG9(:,19, 1) = (/ &
  & 0.80534077E-13_JPRB, 0.85397164E-13_JPRB, 0.89167917E-13_JPRB, 0.94578642E-13_JPRB, 0.10343584E-12_JPRB, 0.11808198E-12_JPRB, &
  & 0.14125970E-12_JPRB, 0.17482028E-12_JPRB, 0.21979772E-12_JPRB, 0.27875217E-12_JPRB, 0.35385662E-12_JPRB, 0.44860586E-12_JPRB, &
  & 0.56765232E-12_JPRB, 0.71279289E-12_JPRB, 0.88768711E-12_JPRB, 0.10946388E-11_JPRB, 0.13252139E-11_JPRB, 0.15697869E-11_JPRB, &
  & 0.18122645E-11_JPRB, 0.20286787E-11_JPRB, 0.21852275E-11_JPRB, 0.22579388E-11_JPRB, 0.22315654E-11_JPRB, 0.21050141E-11_JPRB, &
  & 0.19034164E-11_JPRB, 0.16677455E-11_JPRB, 0.14326322E-11_JPRB, 0.12313718E-11_JPRB, 0.10944215E-11_JPRB, 0.10148132E-11_JPRB, &
  & 0.99676799E-12_JPRB, 0.10309755E-11_JPRB, 0.11104280E-11_JPRB, 0.12349638E-11_JPRB, 0.14015041E-11_JPRB, 0.16028723E-11_JPRB, &
  & 0.18191778E-11_JPRB, 0.20214188E-11_JPRB, 0.21783504E-11_JPRB, 0.22713504E-11_JPRB, 0.22944307E-11_JPRB, 0.22475773E-11_JPRB, &
  & 0.21431047E-11_JPRB, 0.20007232E-11_JPRB, 0.18387258E-11_JPRB, 0.16654234E-11_JPRB, 0.14881435E-11_JPRB, 0.13125473E-11_JPRB, &
  & 0.11403371E-11_JPRB, 0.97743634E-12_JPRB, 0.82758361E-12_JPRB, 0.69442878E-12_JPRB, 0.57952297E-12_JPRB, 0.48315025E-12_JPRB, &
  & 0.40346987E-12_JPRB, 0.33708005E-12_JPRB, 0.28305952E-12_JPRB, 0.23935544E-12_JPRB, 0.20407913E-12_JPRB, 0.17550975E-12_JPRB, &
  & 0.15229594E-12_JPRB, 0.13243462E-12_JPRB, 0.11270222E-12_JPRB, 0.85422785E-13_JPRB /)

RGHG9(:,20, 1) = (/ &
  & 0.26804329E-12_JPRB, 0.29993152E-12_JPRB, 0.32313431E-12_JPRB, 0.35072626E-12_JPRB, 0.38945783E-12_JPRB, 0.44712503E-12_JPRB, &
  & 0.53248633E-12_JPRB, 0.65189867E-12_JPRB, 0.80630191E-12_JPRB, 0.99876140E-12_JPRB, 0.12355133E-11_JPRB, 0.15181035E-11_JPRB, &
  & 0.18535295E-11_JPRB, 0.22397574E-11_JPRB, 0.26733342E-11_JPRB, 0.31527116E-11_JPRB, 0.36572629E-11_JPRB, 0.41533469E-11_JPRB, &
  & 0.45945561E-11_JPRB, 0.49461238E-11_JPRB, 0.51477130E-11_JPRB, 0.51604892E-11_JPRB, 0.49747355E-11_JPRB, 0.46140995E-11_JPRB, &
  & 0.41357191E-11_JPRB, 0.36323618E-11_JPRB, 0.31848307E-11_JPRB, 0.28549138E-11_JPRB, 0.26615312E-11_JPRB, 0.26215089E-11_JPRB, &
  & 0.27157014E-11_JPRB, 0.29221987E-11_JPRB, 0.32121361E-11_JPRB, 0.35758575E-11_JPRB, 0.39968783E-11_JPRB, 0.44436542E-11_JPRB, &
  & 0.48726283E-11_JPRB, 0.52349618E-11_JPRB, 0.54812647E-11_JPRB, 0.55579217E-11_JPRB, 0.54795031E-11_JPRB, 0.52677680E-11_JPRB, &
  & 0.49702261E-11_JPRB, 0.46102323E-11_JPRB, 0.42206768E-11_JPRB, 0.38160495E-11_JPRB, 0.34132198E-11_JPRB, 0.30213358E-11_JPRB, &
  & 0.26457688E-11_JPRB, 0.22958157E-11_JPRB, 0.19761460E-11_JPRB, 0.16930333E-11_JPRB, 0.14475726E-11_JPRB, 0.12366601E-11_JPRB, &
  & 0.10564455E-11_JPRB, 0.90408367E-12_JPRB, 0.77744072E-12_JPRB, 0.67186155E-12_JPRB, 0.58364668E-12_JPRB, 0.50963042E-12_JPRB, &
  & 0.44698053E-12_JPRB, 0.38990203E-12_JPRB, 0.33611739E-12_JPRB, 0.25130142E-12_JPRB /)

RGHG9(:,21, 1) = (/ &
  & 0.64853223E-12_JPRB, 0.76696467E-12_JPRB, 0.85067256E-12_JPRB, 0.94290829E-12_JPRB, 0.10611350E-11_JPRB, 0.12207471E-11_JPRB, &
  & 0.14383508E-11_JPRB, 0.17248719E-11_JPRB, 0.20868060E-11_JPRB, 0.25251279E-11_JPRB, 0.30439969E-11_JPRB, 0.36400410E-11_JPRB, &
  & 0.43142915E-11_JPRB, 0.50579779E-11_JPRB, 0.58512943E-11_JPRB, 0.66744171E-11_JPRB, 0.74986900E-11_JPRB, 0.82686011E-11_JPRB, &
  & 0.89080141E-11_JPRB, 0.93584602E-11_JPRB, 0.95535290E-11_JPRB, 0.94546272E-11_JPRB, 0.90604572E-11_JPRB, 0.84137627E-11_JPRB, &
  & 0.76286989E-11_JPRB, 0.68437855E-11_JPRB, 0.61947335E-11_JPRB, 0.57635823E-11_JPRB, 0.56126805E-11_JPRB, 0.57382406E-11_JPRB, &
  & 0.61101289E-11_JPRB, 0.66723246E-11_JPRB, 0.73430775E-11_JPRB, 0.80981376E-11_JPRB, 0.88635358E-11_JPRB, 0.95853056E-11_JPRB, &
  & 0.10213580E-10_JPRB, 0.10653244E-10_JPRB, 0.10850449E-10_JPRB, 0.10776538E-10_JPRB, 0.10467330E-10_JPRB, 0.99693006E-11_JPRB, &
  & 0.93408926E-11_JPRB, 0.86303404E-11_JPRB, 0.78870192E-11_JPRB, 0.71351527E-11_JPRB, 0.64088513E-11_JPRB, 0.57124513E-11_JPRB, &
  & 0.50560780E-11_JPRB, 0.44496208E-11_JPRB, 0.39016663E-11_JPRB, 0.34152785E-11_JPRB, 0.29881093E-11_JPRB, 0.26142530E-11_JPRB, &
  & 0.22858169E-11_JPRB, 0.20038849E-11_JPRB, 0.17631052E-11_JPRB, 0.15569845E-11_JPRB, 0.13788036E-11_JPRB, 0.12234442E-11_JPRB, &
  & 0.10847780E-11_JPRB, 0.96129224E-12_JPRB, 0.82434135E-12_JPRB, 0.63900382E-12_JPRB /)

RGHG9(:,22, 1) = (/ &
  & 0.14063779E-11_JPRB, 0.16432326E-11_JPRB, 0.18154782E-11_JPRB, 0.20084546E-11_JPRB, 0.22537757E-11_JPRB, 0.25775050E-11_JPRB, &
  & 0.30016859E-11_JPRB, 0.35349471E-11_JPRB, 0.41817032E-11_JPRB, 0.49430499E-11_JPRB, 0.58207324E-11_JPRB, 0.67968079E-11_JPRB, &
  & 0.78610651E-11_JPRB, 0.89972916E-11_JPRB, 0.10174007E-10_JPRB, 0.11351264E-10_JPRB, 0.12472096E-10_JPRB, 0.13473984E-10_JPRB, &
  & 0.14281932E-10_JPRB, 0.14834725E-10_JPRB, 0.15053738E-10_JPRB, 0.14885124E-10_JPRB, 0.14348934E-10_JPRB, 0.13526496E-10_JPRB, &
  & 0.12524846E-10_JPRB, 0.11584592E-10_JPRB, 0.10830437E-10_JPRB, 0.10416707E-10_JPRB, 0.10410955E-10_JPRB, 0.10820092E-10_JPRB, &
  & 0.11575923E-10_JPRB, 0.12570677E-10_JPRB, 0.13686868E-10_JPRB, 0.14832907E-10_JPRB, 0.15910943E-10_JPRB, 0.16831796E-10_JPRB, &
  & 0.17518355E-10_JPRB, 0.17878003E-10_JPRB, 0.17880735E-10_JPRB, 0.17516735E-10_JPRB, 0.16847190E-10_JPRB, 0.15960438E-10_JPRB, &
  & 0.14927838E-10_JPRB, 0.13803571E-10_JPRB, 0.12645681E-10_JPRB, 0.11497029E-10_JPRB, 0.10389079E-10_JPRB, 0.93448894E-11_JPRB, &
  & 0.83720548E-11_JPRB, 0.74825276E-11_JPRB, 0.66834259E-11_JPRB, 0.59734136E-11_JPRB, 0.53388917E-11_JPRB, 0.47667339E-11_JPRB, &
  & 0.42601109E-11_JPRB, 0.38152827E-11_JPRB, 0.34263961E-11_JPRB, 0.30824557E-11_JPRB, 0.27756983E-11_JPRB, 0.24987547E-11_JPRB, &
  & 0.22471797E-11_JPRB, 0.20007572E-11_JPRB, 0.17595965E-11_JPRB, 0.13561412E-11_JPRB /)

RGHG9(:,23, 1) = (/ &
  & 0.25910042E-11_JPRB, 0.30207447E-11_JPRB, 0.33163674E-11_JPRB, 0.36366452E-11_JPRB, 0.40358572E-11_JPRB, 0.45509668E-11_JPRB, &
  & 0.52140211E-11_JPRB, 0.60315897E-11_JPRB, 0.69913372E-11_JPRB, 0.80929222E-11_JPRB, 0.93275665E-11_JPRB, 0.10672948E-10_JPRB, &
  & 0.12102102E-10_JPRB, 0.13580677E-10_JPRB, 0.15072379E-10_JPRB, 0.16543909E-10_JPRB, 0.17942205E-10_JPRB, 0.19191749E-10_JPRB, &
  & 0.20201896E-10_JPRB, 0.20907900E-10_JPRB, 0.21240863E-10_JPRB, 0.21175683E-10_JPRB, 0.20719227E-10_JPRB, 0.19922524E-10_JPRB, &
  & 0.18981377E-10_JPRB, 0.18071841E-10_JPRB, 0.17386722E-10_JPRB, 0.17084700E-10_JPRB, 0.17263723E-10_JPRB, 0.17932999E-10_JPRB, &
  & 0.18984033E-10_JPRB, 0.20289539E-10_JPRB, 0.21696256E-10_JPRB, 0.23068027E-10_JPRB, 0.24274905E-10_JPRB, 0.25210065E-10_JPRB, &
  & 0.25804929E-10_JPRB, 0.25954450E-10_JPRB, 0.25671907E-10_JPRB, 0.24967972E-10_JPRB, 0.23931329E-10_JPRB, 0.22664374E-10_JPRB, &
  & 0.21236839E-10_JPRB, 0.19715965E-10_JPRB, 0.18163309E-10_JPRB, 0.16622257E-10_JPRB, 0.15144146E-10_JPRB, 0.13758134E-10_JPRB, &
  & 0.12478411E-10_JPRB, 0.11319169E-10_JPRB, 0.10276545E-10_JPRB, 0.93463371E-11_JPRB, 0.85033239E-11_JPRB, 0.77389050E-11_JPRB, &
  & 0.70503013E-11_JPRB, 0.64326409E-11_JPRB, 0.58753926E-11_JPRB, 0.53686773E-11_JPRB, 0.49014924E-11_JPRB, 0.44655469E-11_JPRB, &
  & 0.40518760E-11_JPRB, 0.36597825E-11_JPRB, 0.32154618E-11_JPRB, 0.25653785E-11_JPRB /)

RGHG9(:,24, 1) = (/ &
  & 0.42873313E-11_JPRB, 0.49265188E-11_JPRB, 0.53619921E-11_JPRB, 0.58243120E-11_JPRB, 0.63854464E-11_JPRB, 0.70930622E-11_JPRB, &
  & 0.79789855E-11_JPRB, 0.90555471E-11_JPRB, 0.10307340E-10_JPRB, 0.11706939E-10_JPRB, 0.13249664E-10_JPRB, 0.14900588E-10_JPRB, &
  & 0.16632853E-10_JPRB, 0.18410197E-10_JPRB, 0.20187340E-10_JPRB, 0.21910430E-10_JPRB, 0.23524172E-10_JPRB, 0.24971811E-10_JPRB, &
  & 0.26193799E-10_JPRB, 0.27150974E-10_JPRB, 0.27779171E-10_JPRB, 0.28022669E-10_JPRB, 0.27869962E-10_JPRB, 0.27426169E-10_JPRB, &
  & 0.26798267E-10_JPRB, 0.26164697E-10_JPRB, 0.25701970E-10_JPRB, 0.25564783E-10_JPRB, 0.25885431E-10_JPRB, 0.26638244E-10_JPRB, &
  & 0.27755123E-10_JPRB, 0.29107945E-10_JPRB, 0.30504748E-10_JPRB, 0.31826347E-10_JPRB, 0.32925700E-10_JPRB, 0.33702756E-10_JPRB, &
  & 0.34073286E-10_JPRB, 0.33956404E-10_JPRB, 0.33379875E-10_JPRB, 0.32385757E-10_JPRB, 0.31047900E-10_JPRB, 0.29481459E-10_JPRB, &
  & 0.27745816E-10_JPRB, 0.25906485E-10_JPRB, 0.24028647E-10_JPRB, 0.22157649E-10_JPRB, 0.20372358E-10_JPRB, 0.18707478E-10_JPRB, &
  & 0.17179608E-10_JPRB, 0.15799344E-10_JPRB, 0.14551825E-10_JPRB, 0.13435241E-10_JPRB, 0.12413051E-10_JPRB, 0.11480691E-10_JPRB, &
  & 0.10629255E-10_JPRB, 0.98457336E-11_JPRB, 0.91210598E-11_JPRB, 0.84382275E-11_JPRB, 0.77887757E-11_JPRB, 0.71638129E-11_JPRB, &
  & 0.65594544E-11_JPRB, 0.59536781E-11_JPRB, 0.53160957E-11_JPRB, 0.42705943E-11_JPRB /)

RGHG9(:,25, 1) = (/ &
  & 0.64669884E-11_JPRB, 0.73189814E-11_JPRB, 0.78873071E-11_JPRB, 0.84834735E-11_JPRB, 0.91955939E-11_JPRB, 0.10073335E-10_JPRB, &
  & 0.11148363E-10_JPRB, 0.12425832E-10_JPRB, 0.13897510E-10_JPRB, 0.15527059E-10_JPRB, 0.17289245E-10_JPRB, 0.19153205E-10_JPRB, &
  & 0.21081002E-10_JPRB, 0.23035815E-10_JPRB, 0.24978455E-10_JPRB, 0.26882120E-10_JPRB, 0.28712298E-10_JPRB, 0.30424867E-10_JPRB, &
  & 0.31960934E-10_JPRB, 0.33269866E-10_JPRB, 0.34291091E-10_JPRB, 0.34992904E-10_JPRB, 0.35381666E-10_JPRB, 0.35495207E-10_JPRB, &
  & 0.35381850E-10_JPRB, 0.35201852E-10_JPRB, 0.35067931E-10_JPRB, 0.35107271E-10_JPRB, 0.35454202E-10_JPRB, 0.36106083E-10_JPRB, &
  & 0.37045624E-10_JPRB, 0.38139429E-10_JPRB, 0.39273765E-10_JPRB, 0.40314679E-10_JPRB, 0.41128056E-10_JPRB, 0.41624263E-10_JPRB, &
  & 0.41701857E-10_JPRB, 0.41320020E-10_JPRB, 0.40496408E-10_JPRB, 0.39293173E-10_JPRB, 0.37774468E-10_JPRB, 0.36022182E-10_JPRB, &
  & 0.34104129E-10_JPRB, 0.32063029E-10_JPRB, 0.29957530E-10_JPRB, 0.27860637E-10_JPRB, 0.25861292E-10_JPRB, 0.23992948E-10_JPRB, &
  & 0.22279288E-10_JPRB, 0.20729973E-10_JPRB, 0.19331491E-10_JPRB, 0.18064168E-10_JPRB, 0.16909004E-10_JPRB, 0.15848958E-10_JPRB, &
  & 0.14866147E-10_JPRB, 0.13947214E-10_JPRB, 0.13069370E-10_JPRB, 0.12221190E-10_JPRB, 0.11386432E-10_JPRB, 0.10557622E-10_JPRB, &
  & 0.97353904E-11_JPRB, 0.89089881E-11_JPRB, 0.80004779E-11_JPRB, 0.65317370E-11_JPRB /)

RGHG9(:,26, 1) = (/ &
  & 0.90784533E-11_JPRB, 0.10121708E-10_JPRB, 0.10805958E-10_JPRB, 0.11513928E-10_JPRB, 0.12347881E-10_JPRB, 0.13361745E-10_JPRB, &
  & 0.14580595E-10_JPRB, 0.16003476E-10_JPRB, 0.17617682E-10_JPRB, 0.19402778E-10_JPRB, 0.21315243E-10_JPRB, 0.23327285E-10_JPRB, &
  & 0.25402916E-10_JPRB, 0.27513249E-10_JPRB, 0.29619168E-10_JPRB, 0.31695362E-10_JPRB, 0.33707242E-10_JPRB, 0.35614463E-10_JPRB, &
  & 0.37382923E-10_JPRB, 0.39000601E-10_JPRB, 0.40439180E-10_JPRB, 0.41661948E-10_JPRB, 0.42642240E-10_JPRB, 0.43370113E-10_JPRB, &
  & 0.43853244E-10_JPRB, 0.44169654E-10_JPRB, 0.44401732E-10_JPRB, 0.44648556E-10_JPRB, 0.44963745E-10_JPRB, 0.45422173E-10_JPRB, &
  & 0.46021617E-10_JPRB, 0.46717609E-10_JPRB, 0.47443820E-10_JPRB, 0.48071741E-10_JPRB, 0.48516382E-10_JPRB, 0.48675952E-10_JPRB, &
  & 0.48459889E-10_JPRB, 0.47853638E-10_JPRB, 0.46867031E-10_JPRB, 0.45551351E-10_JPRB, 0.43960405E-10_JPRB, 0.42139351E-10_JPRB, &
  & 0.40143500E-10_JPRB, 0.38012725E-10_JPRB, 0.35794038E-10_JPRB, 0.33576267E-10_JPRB, 0.31440163E-10_JPRB, 0.29422537E-10_JPRB, &
  & 0.27579203E-10_JPRB, 0.25909514E-10_JPRB, 0.24404506E-10_JPRB, 0.23037433E-10_JPRB, 0.21792622E-10_JPRB, 0.20648001E-10_JPRB, &
  & 0.19577050E-10_JPRB, 0.18557135E-10_JPRB, 0.17567867E-10_JPRB, 0.16580574E-10_JPRB, 0.15583956E-10_JPRB, 0.14566695E-10_JPRB, &
  & 0.13526836E-10_JPRB, 0.12475009E-10_JPRB, 0.11277269E-10_JPRB, 0.93538857E-11_JPRB /)

RGHG9(:,27, 1) = (/ &
  & 0.12048012E-10_JPRB, 0.13271484E-10_JPRB, 0.14048954E-10_JPRB, 0.14841534E-10_JPRB, 0.15765177E-10_JPRB, 0.16871305E-10_JPRB, &
  & 0.18182223E-10_JPRB, 0.19692166E-10_JPRB, 0.21376775E-10_JPRB, 0.23228433E-10_JPRB, 0.25209732E-10_JPRB, 0.27283037E-10_JPRB, &
  & 0.29424709E-10_JPRB, 0.31599875E-10_JPRB, 0.33784482E-10_JPRB, 0.35952210E-10_JPRB, 0.38083363E-10_JPRB, 0.40163442E-10_JPRB, &
  & 0.42179506E-10_JPRB, 0.44120825E-10_JPRB, 0.45956138E-10_JPRB, 0.47640645E-10_JPRB, 0.49139574E-10_JPRB, 0.50410110E-10_JPRB, &
  & 0.51438350E-10_JPRB, 0.52222258E-10_JPRB, 0.52800646E-10_JPRB, 0.53207841E-10_JPRB, 0.53514658E-10_JPRB, 0.53797813E-10_JPRB, &
  & 0.54094233E-10_JPRB, 0.54391786E-10_JPRB, 0.54697583E-10_JPRB, 0.54901698E-10_JPRB, 0.54973665E-10_JPRB, 0.54811922E-10_JPRB, &
  & 0.54350312E-10_JPRB, 0.53585376E-10_JPRB, 0.52514486E-10_JPRB, 0.51165874E-10_JPRB, 0.49580905E-10_JPRB, 0.47792534E-10_JPRB, &
  & 0.45817610E-10_JPRB, 0.43691425E-10_JPRB, 0.41453112E-10_JPRB, 0.39176946E-10_JPRB, 0.36946005E-10_JPRB, 0.34846223E-10_JPRB, &
  & 0.32923261E-10_JPRB, 0.31182917E-10_JPRB, 0.29604090E-10_JPRB, 0.28178305E-10_JPRB, 0.26880134E-10_JPRB, 0.25685200E-10_JPRB, &
  & 0.24560992E-10_JPRB, 0.23484853E-10_JPRB, 0.22419868E-10_JPRB, 0.21344659E-10_JPRB, 0.20229787E-10_JPRB, 0.19064856E-10_JPRB, &
  & 0.17861296E-10_JPRB, 0.16588725E-10_JPRB, 0.15188611E-10_JPRB, 0.12739144E-10_JPRB /)

RGHG9(:,28, 1) = (/ &
  & 0.15345815E-10_JPRB, 0.16705642E-10_JPRB, 0.17564278E-10_JPRB, 0.18415804E-10_JPRB, 0.19394590E-10_JPRB, 0.20553578E-10_JPRB, &
  & 0.21911323E-10_JPRB, 0.23452735E-10_JPRB, 0.25154477E-10_JPRB, 0.27007067E-10_JPRB, 0.28987481E-10_JPRB, 0.31072412E-10_JPRB, &
  & 0.33221443E-10_JPRB, 0.35420042E-10_JPRB, 0.37641584E-10_JPRB, 0.39870919E-10_JPRB, 0.42098356E-10_JPRB, 0.44314677E-10_JPRB, &
  & 0.46508450E-10_JPRB, 0.48670783E-10_JPRB, 0.50775696E-10_JPRB, 0.52784225E-10_JPRB, 0.54658229E-10_JPRB, 0.56340529E-10_JPRB, &
  & 0.57787657E-10_JPRB, 0.58949116E-10_JPRB, 0.59827990E-10_JPRB, 0.60408650E-10_JPRB, 0.60756386E-10_JPRB, 0.60932648E-10_JPRB, &
  & 0.61002557E-10_JPRB, 0.60986556E-10_JPRB, 0.60937359E-10_JPRB, 0.60784135E-10_JPRB, 0.60531566E-10_JPRB, 0.60104227E-10_JPRB, &
  & 0.59456551E-10_JPRB, 0.58586226E-10_JPRB, 0.57489007E-10_JPRB, 0.56179630E-10_JPRB, 0.54672961E-10_JPRB, 0.52985075E-10_JPRB, &
  & 0.51104895E-10_JPRB, 0.49049466E-10_JPRB, 0.46845854E-10_JPRB, 0.44563988E-10_JPRB, 0.42309066E-10_JPRB, 0.40163411E-10_JPRB, &
  & 0.38192928E-10_JPRB, 0.36402333E-10_JPRB, 0.34785501E-10_JPRB, 0.33332080E-10_JPRB, 0.32006158E-10_JPRB, 0.30787928E-10_JPRB, &
  & 0.29639534E-10_JPRB, 0.28532902E-10_JPRB, 0.27436112E-10_JPRB, 0.26308900E-10_JPRB, 0.25130283E-10_JPRB, 0.23880077E-10_JPRB, &
  & 0.22562056E-10_JPRB, 0.21188818E-10_JPRB, 0.19566388E-10_JPRB, 0.16785639E-10_JPRB /)

RGHG9(:,29, 1) = (/ &
  & 0.18914880E-10_JPRB, 0.20387364E-10_JPRB, 0.21298669E-10_JPRB, 0.22191495E-10_JPRB, 0.23193355E-10_JPRB, 0.24373888E-10_JPRB, &
  & 0.25734682E-10_JPRB, 0.27263957E-10_JPRB, 0.28935913E-10_JPRB, 0.30741271E-10_JPRB, 0.32670290E-10_JPRB, 0.34715963E-10_JPRB, &
  & 0.36846384E-10_JPRB, 0.39034578E-10_JPRB, 0.41266740E-10_JPRB, 0.43531501E-10_JPRB, 0.45817024E-10_JPRB, 0.48111033E-10_JPRB, &
  & 0.50402797E-10_JPRB, 0.52687181E-10_JPRB, 0.54942918E-10_JPRB, 0.57140896E-10_JPRB, 0.59243041E-10_JPRB, 0.61190115E-10_JPRB, &
  & 0.62912647E-10_JPRB, 0.64345251E-10_JPRB, 0.65446565E-10_JPRB, 0.66191455E-10_JPRB, 0.66613277E-10_JPRB, 0.66764677E-10_JPRB, &
  & 0.66716244E-10_JPRB, 0.66504406E-10_JPRB, 0.66203709E-10_JPRB, 0.65790942E-10_JPRB, 0.65289725E-10_JPRB, 0.64668784E-10_JPRB, &
  & 0.63894279E-10_JPRB, 0.62973037E-10_JPRB, 0.61901553E-10_JPRB, 0.60681536E-10_JPRB, 0.59298608E-10_JPRB, 0.57742245E-10_JPRB, &
  & 0.55991690E-10_JPRB, 0.54040945E-10_JPRB, 0.51914573E-10_JPRB, 0.49677467E-10_JPRB, 0.47428686E-10_JPRB, 0.45278382E-10_JPRB, &
  & 0.43281417E-10_JPRB, 0.41470945E-10_JPRB, 0.39842588E-10_JPRB, 0.38377558E-10_JPRB, 0.37047167E-10_JPRB, 0.35817335E-10_JPRB, &
  & 0.34660448E-10_JPRB, 0.33543779E-10_JPRB, 0.32428900E-10_JPRB, 0.31283622E-10_JPRB, 0.30073295E-10_JPRB, 0.28789863E-10_JPRB, &
  & 0.27437993E-10_JPRB, 0.26007295E-10_JPRB, 0.24339983E-10_JPRB, 0.21354085E-10_JPRB /)

RGHG9(:,30, 1) = (/ &
  & 0.22749712E-10_JPRB, 0.24279594E-10_JPRB, 0.25226588E-10_JPRB, 0.26123933E-10_JPRB, 0.27129769E-10_JPRB, 0.28290949E-10_JPRB, &
  & 0.29624525E-10_JPRB, 0.31102506E-10_JPRB, 0.32709491E-10_JPRB, 0.34431642E-10_JPRB, 0.36281318E-10_JPRB, 0.38245226E-10_JPRB, &
  & 0.40312944E-10_JPRB, 0.42468501E-10_JPRB, 0.44689561E-10_JPRB, 0.46959079E-10_JPRB, 0.49263208E-10_JPRB, 0.51589524E-10_JPRB, &
  & 0.53924570E-10_JPRB, 0.56263230E-10_JPRB, 0.58589529E-10_JPRB, 0.60877851E-10_JPRB, 0.63088437E-10_JPRB, 0.65170272E-10_JPRB, &
  & 0.67043655E-10_JPRB, 0.68630844E-10_JPRB, 0.69884147E-10_JPRB, 0.70756817E-10_JPRB, 0.71263814E-10_JPRB, 0.71444399E-10_JPRB, &
  & 0.71362784E-10_JPRB, 0.71059873E-10_JPRB, 0.70611392E-10_JPRB, 0.70039509E-10_JPRB, 0.69378212E-10_JPRB, 0.68635923E-10_JPRB, &
  & 0.67799974E-10_JPRB, 0.66880779E-10_JPRB, 0.65872030E-10_JPRB, 0.64756915E-10_JPRB, 0.63504847E-10_JPRB, 0.62085316E-10_JPRB, &
  & 0.60468269E-10_JPRB, 0.58637553E-10_JPRB, 0.56608409E-10_JPRB, 0.54443023E-10_JPRB, 0.52240698E-10_JPRB, 0.50101326E-10_JPRB, &
  & 0.48117607E-10_JPRB, 0.46311510E-10_JPRB, 0.44690543E-10_JPRB, 0.43230301E-10_JPRB, 0.41896625E-10_JPRB, 0.40666668E-10_JPRB, &
  & 0.39504618E-10_JPRB, 0.38381080E-10_JPRB, 0.37260379E-10_JPRB, 0.36103977E-10_JPRB, 0.34891125E-10_JPRB, 0.33606156E-10_JPRB, &
  & 0.32273434E-10_JPRB, 0.30866313E-10_JPRB, 0.29244451E-10_JPRB, 0.26232136E-10_JPRB /)

RGHG9(:,31, 1) = (/ &
  & 0.26794365E-10_JPRB, 0.28341928E-10_JPRB, 0.29283322E-10_JPRB, 0.30173607E-10_JPRB, 0.31145721E-10_JPRB, 0.32269687E-10_JPRB, &
  & 0.33543879E-10_JPRB, 0.34950848E-10_JPRB, 0.36466528E-10_JPRB, 0.38085687E-10_JPRB, 0.39831402E-10_JPRB, 0.41696306E-10_JPRB, &
  & 0.43677395E-10_JPRB, 0.45765919E-10_JPRB, 0.47949235E-10_JPRB, 0.50204993E-10_JPRB, 0.52514312E-10_JPRB, 0.54853747E-10_JPRB, &
  & 0.57205685E-10_JPRB, 0.59559080E-10_JPRB, 0.61895752E-10_JPRB, 0.64198043E-10_JPRB, 0.66431007E-10_JPRB, 0.68540271E-10_JPRB, &
  & 0.70452283E-10_JPRB, 0.72100582E-10_JPRB, 0.73423337E-10_JPRB, 0.74375464E-10_JPRB, 0.74956853E-10_JPRB, 0.75188328E-10_JPRB, &
  & 0.75126794E-10_JPRB, 0.74809992E-10_JPRB, 0.74300940E-10_JPRB, 0.73659426E-10_JPRB, 0.72920878E-10_JPRB, 0.72128616E-10_JPRB, &
  & 0.71283333E-10_JPRB, 0.70400852E-10_JPRB, 0.69466793E-10_JPRB, 0.68455040E-10_JPRB, 0.67323321E-10_JPRB, 0.66029675E-10_JPRB, &
  & 0.64533545E-10_JPRB, 0.62815399E-10_JPRB, 0.60891465E-10_JPRB, 0.58814925E-10_JPRB, 0.56679227E-10_JPRB, 0.54600949E-10_JPRB, &
  & 0.52644319E-10_JPRB, 0.50869142E-10_JPRB, 0.49266657E-10_JPRB, 0.47814218E-10_JPRB, 0.46488660E-10_JPRB, 0.45255077E-10_JPRB, &
  & 0.44091016E-10_JPRB, 0.42960541E-10_JPRB, 0.41834043E-10_JPRB, 0.40678360E-10_JPRB, 0.39469240E-10_JPRB, 0.38211469E-10_JPRB, &
  & 0.36914305E-10_JPRB, 0.35587859E-10_JPRB, 0.33999945E-10_JPRB, 0.31185471E-10_JPRB /)

RGHG9(:,32, 1) = (/ &
  & 0.30969723E-10_JPRB, 0.32495843E-10_JPRB, 0.33411732E-10_JPRB, 0.34266361E-10_JPRB, 0.35195728E-10_JPRB, 0.36257258E-10_JPRB, &
  & 0.37462360E-10_JPRB, 0.38781239E-10_JPRB, 0.40195361E-10_JPRB, 0.41699900E-10_JPRB, 0.43325336E-10_JPRB, 0.45071967E-10_JPRB, &
  & 0.46954451E-10_JPRB, 0.48973887E-10_JPRB, 0.51114744E-10_JPRB, 0.53352253E-10_JPRB, 0.55658093E-10_JPRB, 0.58000178E-10_JPRB, &
  & 0.60348462E-10_JPRB, 0.62690381E-10_JPRB, 0.65005501E-10_JPRB, 0.67273999E-10_JPRB, 0.69458231E-10_JPRB, 0.71519381E-10_JPRB, &
  & 0.73382786E-10_JPRB, 0.75000006E-10_JPRB, 0.76319041E-10_JPRB, 0.77296176E-10_JPRB, 0.77924604E-10_JPRB, 0.78207274E-10_JPRB, &
  & 0.78194902E-10_JPRB, 0.77911531E-10_JPRB, 0.77413444E-10_JPRB, 0.76773060E-10_JPRB, 0.76029481E-10_JPRB, 0.75244526E-10_JPRB, &
  & 0.74433862E-10_JPRB, 0.73606433E-10_JPRB, 0.72750514E-10_JPRB, 0.71829473E-10_JPRB, 0.70796834E-10_JPRB, 0.69601755E-10_JPRB, &
  & 0.68202458E-10_JPRB, 0.66578951E-10_JPRB, 0.64745702E-10_JPRB, 0.62764571E-10_JPRB, 0.60722177E-10_JPRB, 0.58712230E-10_JPRB, &
  & 0.56824913E-10_JPRB, 0.55092195E-10_JPRB, 0.53520494E-10_JPRB, 0.52088098E-10_JPRB, 0.50769132E-10_JPRB, 0.49540563E-10_JPRB, &
  & 0.48370738E-10_JPRB, 0.47237485E-10_JPRB, 0.46108967E-10_JPRB, 0.44955466E-10_JPRB, 0.43763514E-10_JPRB, 0.42533886E-10_JPRB, &
  & 0.41296921E-10_JPRB, 0.40011043E-10_JPRB, 0.38571559E-10_JPRB, 0.35862473E-10_JPRB /)

RGHG9(:,33, 1) = (/ &
  & 0.35199666E-10_JPRB, 0.36658680E-10_JPRB, 0.37533754E-10_JPRB, 0.38344754E-10_JPRB, 0.39215482E-10_JPRB, 0.40213173E-10_JPRB, &
  & 0.41339855E-10_JPRB, 0.42569826E-10_JPRB, 0.43876614E-10_JPRB, 0.45265045E-10_JPRB, 0.46758604E-10_JPRB, 0.48376626E-10_JPRB, &
  & 0.50143383E-10_JPRB, 0.52073755E-10_JPRB, 0.54166407E-10_JPRB, 0.56389886E-10_JPRB, 0.58701294E-10_JPRB, 0.61053142E-10_JPRB, &
  & 0.63405441E-10_JPRB, 0.65729318E-10_JPRB, 0.68001535E-10_JPRB, 0.70200873E-10_JPRB, 0.72301470E-10_JPRB, 0.74245728E-10_JPRB, &
  & 0.75996757E-10_JPRB, 0.77509783E-10_JPRB, 0.78755849E-10_JPRB, 0.79706887E-10_JPRB, 0.80346022E-10_JPRB, 0.80666383E-10_JPRB, &
  & 0.80712333E-10_JPRB, 0.80491391E-10_JPRB, 0.80057856E-10_JPRB, 0.79473102E-10_JPRB, 0.78781759E-10_JPRB, 0.78049976E-10_JPRB, &
  & 0.77299112E-10_JPRB, 0.76541981E-10_JPRB, 0.75763687E-10_JPRB, 0.74923845E-10_JPRB, 0.73966541E-10_JPRB, 0.72838999E-10_JPRB, &
  & 0.71503317E-10_JPRB, 0.69942926E-10_JPRB, 0.68188719E-10_JPRB, 0.66294435E-10_JPRB, 0.64342733E-10_JPRB, 0.62431095E-10_JPRB, &
  & 0.60617532E-10_JPRB, 0.58949817E-10_JPRB, 0.57421554E-10_JPRB, 0.56016934E-10_JPRB, 0.54716461E-10_JPRB, 0.53490289E-10_JPRB, &
  & 0.52323784E-10_JPRB, 0.51189226E-10_JPRB, 0.50063519E-10_JPRB, 0.48918043E-10_JPRB, 0.47744614E-10_JPRB, 0.46550680E-10_JPRB, &
  & 0.45346973E-10_JPRB, 0.44141711E-10_JPRB, 0.42707539E-10_JPRB, 0.40210557E-10_JPRB /)

RGHG9(:,34, 1) = (/ &
  & 0.39379774E-10_JPRB, 0.40768510E-10_JPRB, 0.41585839E-10_JPRB, 0.42342251E-10_JPRB, 0.43159899E-10_JPRB, 0.44090148E-10_JPRB, &
  & 0.45142421E-10_JPRB, 0.46283508E-10_JPRB, 0.47486692E-10_JPRB, 0.48757959E-10_JPRB, 0.50118396E-10_JPRB, 0.51601844E-10_JPRB, &
  & 0.53249599E-10_JPRB, 0.55089794E-10_JPRB, 0.57125908E-10_JPRB, 0.59330638E-10_JPRB, 0.61647715E-10_JPRB, 0.64015876E-10_JPRB, &
  & 0.66378070E-10_JPRB, 0.68680409E-10_JPRB, 0.70904158E-10_JPRB, 0.73030651E-10_JPRB, 0.75005516E-10_JPRB, 0.76802752E-10_JPRB, &
  & 0.78380344E-10_JPRB, 0.79734518E-10_JPRB, 0.80853199E-10_JPRB, 0.81721879E-10_JPRB, 0.82328998E-10_JPRB, 0.82665388E-10_JPRB, &
  & 0.82761353E-10_JPRB, 0.82618051E-10_JPRB, 0.82284582E-10_JPRB, 0.81796243E-10_JPRB, 0.81203981E-10_JPRB, 0.80565013E-10_JPRB, &
  & 0.79902029E-10_JPRB, 0.79230400E-10_JPRB, 0.78531320E-10_JPRB, 0.77758938E-10_JPRB, 0.76857326E-10_JPRB, 0.75771306E-10_JPRB, &
  & 0.74466197E-10_JPRB, 0.72945733E-10_JPRB, 0.71241207E-10_JPRB, 0.69423668E-10_JPRB, 0.67571428E-10_JPRB, 0.65749226E-10_JPRB, &
  & 0.64029906E-10_JPRB, 0.62427466E-10_JPRB, 0.60949884E-10_JPRB, 0.59581860E-10_JPRB, 0.58297658E-10_JPRB, 0.57086863E-10_JPRB, &
  & 0.55925389E-10_JPRB, 0.54798482E-10_JPRB, 0.53675554E-10_JPRB, 0.52544483E-10_JPRB, 0.51392623E-10_JPRB, 0.50226250E-10_JPRB, &
  & 0.49064794E-10_JPRB, 0.47864848E-10_JPRB, 0.46533648E-10_JPRB, 0.44076999E-10_JPRB /)

RGHG9(:,35, 1) = (/ &
  & 0.43472118E-10_JPRB, 0.44761660E-10_JPRB, 0.45523703E-10_JPRB, 0.46228570E-10_JPRB, 0.46987275E-10_JPRB, 0.47857773E-10_JPRB, &
  & 0.48836046E-10_JPRB, 0.49893024E-10_JPRB, 0.50996072E-10_JPRB, 0.52151634E-10_JPRB, 0.53378621E-10_JPRB, 0.54722046E-10_JPRB, &
  & 0.56239388E-10_JPRB, 0.57978504E-10_JPRB, 0.59955020E-10_JPRB, 0.62141729E-10_JPRB, 0.64468077E-10_JPRB, 0.66858220E-10_JPRB, &
  & 0.69231676E-10_JPRB, 0.71522406E-10_JPRB, 0.73705216E-10_JPRB, 0.75733232E-10_JPRB, 0.77568466E-10_JPRB, 0.79176013E-10_JPRB, &
  & 0.80549407E-10_JPRB, 0.81696157E-10_JPRB, 0.82631221E-10_JPRB, 0.83370075E-10_JPRB, 0.83892358E-10_JPRB, 0.84211305E-10_JPRB, &
  & 0.84330661E-10_JPRB, 0.84264033E-10_JPRB, 0.84034335E-10_JPRB, 0.83667753E-10_JPRB, 0.83206449E-10_JPRB, 0.82687232E-10_JPRB, &
  & 0.82138629E-10_JPRB, 0.81570750E-10_JPRB, 0.80960232E-10_JPRB, 0.80261138E-10_JPRB, 0.79416987E-10_JPRB, 0.78370498E-10_JPRB, &
  & 0.77094858E-10_JPRB, 0.75595377E-10_JPRB, 0.73936038E-10_JPRB, 0.72189768E-10_JPRB, 0.70417422E-10_JPRB, 0.68698158E-10_JPRB, &
  & 0.67055757E-10_JPRB, 0.65525453E-10_JPRB, 0.64098928E-10_JPRB, 0.62761525E-10_JPRB, 0.61502844E-10_JPRB, 0.60305552E-10_JPRB, &
  & 0.59159094E-10_JPRB, 0.58038341E-10_JPRB, 0.56931210E-10_JPRB, 0.55813944E-10_JPRB, 0.54686571E-10_JPRB, 0.53549901E-10_JPRB, &
  & 0.52408786E-10_JPRB, 0.51262862E-10_JPRB, 0.49915901E-10_JPRB, 0.47580041E-10_JPRB /)

RGHG9(:,36, 1) = (/ &
  & 0.47431663E-10_JPRB, 0.48623099E-10_JPRB, 0.49320874E-10_JPRB, 0.49968595E-10_JPRB, 0.50677913E-10_JPRB, 0.51486149E-10_JPRB, &
  & 0.52398717E-10_JPRB, 0.53374465E-10_JPRB, 0.54383852E-10_JPRB, 0.55423350E-10_JPRB, 0.56519258E-10_JPRB, 0.57718819E-10_JPRB, &
  & 0.59095027E-10_JPRB, 0.60716251E-10_JPRB, 0.62616856E-10_JPRB, 0.64768739E-10_JPRB, 0.67103746E-10_JPRB, 0.69522041E-10_JPRB, &
  & 0.71919637E-10_JPRB, 0.74215904E-10_JPRB, 0.76348788E-10_JPRB, 0.78265235E-10_JPRB, 0.79922145E-10_JPRB, 0.81301979E-10_JPRB, &
  & 0.82420695E-10_JPRB, 0.83321398E-10_JPRB, 0.84040677E-10_JPRB, 0.84604476E-10_JPRB, 0.85015529E-10_JPRB, 0.85281067E-10_JPRB, &
  & 0.85398473E-10_JPRB, 0.85381827E-10_JPRB, 0.85233806E-10_JPRB, 0.84979093E-10_JPRB, 0.84639087E-10_JPRB, 0.84242918E-10_JPRB, &
  & 0.83813130E-10_JPRB, 0.83353317E-10_JPRB, 0.82844460E-10_JPRB, 0.82245828E-10_JPRB, 0.81495762E-10_JPRB, 0.80534496E-10_JPRB, &
  & 0.79326150E-10_JPRB, 0.77887231E-10_JPRB, 0.76284562E-10_JPRB, 0.74600777E-10_JPRB, 0.72921578E-10_JPRB, 0.71279635E-10_JPRB, &
  & 0.69723061E-10_JPRB, 0.68251682E-10_JPRB, 0.66866276E-10_JPRB, 0.65562070E-10_JPRB, 0.64324705E-10_JPRB, 0.63149298E-10_JPRB, &
  & 0.62017516E-10_JPRB, 0.60917459E-10_JPRB, 0.59825075E-10_JPRB, 0.58732942E-10_JPRB, 0.57628635E-10_JPRB, 0.56518953E-10_JPRB, &
  & 0.55413351E-10_JPRB, 0.54276705E-10_JPRB, 0.53002627E-10_JPRB, 0.50711258E-10_JPRB /)

RGHG9(:,37, 1) = (/ &
  & 0.51257401E-10_JPRB, 0.52326983E-10_JPRB, 0.52960962E-10_JPRB, 0.53556999E-10_JPRB, 0.54212211E-10_JPRB, 0.54969751E-10_JPRB, &
  & 0.55817791E-10_JPRB, 0.56718859E-10_JPRB, 0.57636798E-10_JPRB, 0.58564410E-10_JPRB, 0.59530145E-10_JPRB, 0.60581179E-10_JPRB, &
  & 0.61810453E-10_JPRB, 0.63294134E-10_JPRB, 0.65104838E-10_JPRB, 0.67219653E-10_JPRB, 0.69550837E-10_JPRB, 0.71988540E-10_JPRB, &
  & 0.74408361E-10_JPRB, 0.76694311E-10_JPRB, 0.78747023E-10_JPRB, 0.80502972E-10_JPRB, 0.81916286E-10_JPRB, 0.83021159E-10_JPRB, &
  & 0.83864374E-10_JPRB, 0.84517345E-10_JPRB, 0.85027554E-10_JPRB, 0.85434701E-10_JPRB, 0.85738167E-10_JPRB, 0.85947222E-10_JPRB, &
  & 0.86053456E-10_JPRB, 0.86058938E-10_JPRB, 0.85965200E-10_JPRB, 0.85784796E-10_JPRB, 0.85533365E-10_JPRB, 0.85232883E-10_JPRB, &
  & 0.84897568E-10_JPRB, 0.84531111E-10_JPRB, 0.84119101E-10_JPRB, 0.83626266E-10_JPRB, 0.82998580E-10_JPRB, 0.82172928E-10_JPRB, &
  & 0.81100765E-10_JPRB, 0.79779697E-10_JPRB, 0.78271611E-10_JPRB, 0.76680870E-10_JPRB, 0.75082079E-10_JPRB, 0.73532361E-10_JPRB, &
  & 0.72042136E-10_JPRB, 0.70625325E-10_JPRB, 0.69281227E-10_JPRB, 0.68002999E-10_JPRB, 0.66790476E-10_JPRB, 0.65635830E-10_JPRB, &
  & 0.64532699E-10_JPRB, 0.63460980E-10_JPRB, 0.62403915E-10_JPRB, 0.61338219E-10_JPRB, 0.60262996E-10_JPRB, 0.59179994E-10_JPRB, &
  & 0.58098658E-10_JPRB, 0.57010750E-10_JPRB, 0.55764754E-10_JPRB, 0.53586299E-10_JPRB /)

RGHG9(:,38, 1) = (/ &
  & 0.54912231E-10_JPRB, 0.55861711E-10_JPRB, 0.56426610E-10_JPRB, 0.56970893E-10_JPRB, 0.57580159E-10_JPRB, 0.58289505E-10_JPRB, &
  & 0.59080255E-10_JPRB, 0.59909494E-10_JPRB, 0.60738678E-10_JPRB, 0.61560104E-10_JPRB, 0.62393306E-10_JPRB, 0.63307803E-10_JPRB, &
  & 0.64372216E-10_JPRB, 0.65712408E-10_JPRB, 0.67395804E-10_JPRB, 0.69450112E-10_JPRB, 0.71770964E-10_JPRB, 0.74214780E-10_JPRB, &
  & 0.76626497E-10_JPRB, 0.78851710E-10_JPRB, 0.80753633E-10_JPRB, 0.82261156E-10_JPRB, 0.83399440E-10_JPRB, 0.84229172E-10_JPRB, &
  & 0.84835819E-10_JPRB, 0.85299171E-10_JPRB, 0.85660208E-10_JPRB, 0.85954487E-10_JPRB, 0.86186010E-10_JPRB, 0.86352168E-10_JPRB, &
  & 0.86448064E-10_JPRB, 0.86463843E-10_JPRB, 0.86401546E-10_JPRB, 0.86265883E-10_JPRB, 0.86071615E-10_JPRB, 0.85833833E-10_JPRB, &
  & 0.85565111E-10_JPRB, 0.85267515E-10_JPRB, 0.84930202E-10_JPRB, 0.84525498E-10_JPRB, 0.84006899E-10_JPRB, 0.83316506E-10_JPRB, &
  & 0.82402835E-10_JPRB, 0.81241625E-10_JPRB, 0.79883329E-10_JPRB, 0.78410618E-10_JPRB, 0.76920241E-10_JPRB, 0.75451902E-10_JPRB, &
  & 0.74033342E-10_JPRB, 0.72669822E-10_JPRB, 0.71359620E-10_JPRB, 0.70111243E-10_JPRB, 0.68925601E-10_JPRB, 0.67808544E-10_JPRB, &
  & 0.66750161E-10_JPRB, 0.65727382E-10_JPRB, 0.64717162E-10_JPRB, 0.63694529E-10_JPRB, 0.62650655E-10_JPRB, 0.61591884E-10_JPRB, &
  & 0.60540378E-10_JPRB, 0.59482932E-10_JPRB, 0.58302890E-10_JPRB, 0.56235318E-10_JPRB /)

RGHG9(:,39, 1) = (/ &
  & 0.58362780E-10_JPRB, 0.59183755E-10_JPRB, 0.59688608E-10_JPRB, 0.60183046E-10_JPRB, 0.60754679E-10_JPRB, 0.61419772E-10_JPRB, &
  & 0.62158237E-10_JPRB, 0.62916901E-10_JPRB, 0.63661451E-10_JPRB, 0.64375991E-10_JPRB, 0.65099308E-10_JPRB, 0.65867797E-10_JPRB, &
  & 0.66794043E-10_JPRB, 0.67962982E-10_JPRB, 0.69514186E-10_JPRB, 0.71467832E-10_JPRB, 0.73748466E-10_JPRB, 0.76170854E-10_JPRB, &
  & 0.78517769E-10_JPRB, 0.80592685E-10_JPRB, 0.82258922E-10_JPRB, 0.83501102E-10_JPRB, 0.84379490E-10_JPRB, 0.85002491E-10_JPRB, &
  & 0.85449758E-10_JPRB, 0.85791055E-10_JPRB, 0.86061804E-10_JPRB, 0.86288164E-10_JPRB, 0.86473939E-10_JPRB, 0.86614119E-10_JPRB, &
  & 0.86701132E-10_JPRB, 0.86723129E-10_JPRB, 0.86678685E-10_JPRB, 0.86570917E-10_JPRB, 0.86412232E-10_JPRB, 0.86216145E-10_JPRB, &
  & 0.85992852E-10_JPRB, 0.85743933E-10_JPRB, 0.85460264E-10_JPRB, 0.85119758E-10_JPRB, 0.84684780E-10_JPRB, 0.84106569E-10_JPRB, &
  & 0.83333285E-10_JPRB, 0.82339850E-10_JPRB, 0.81140157E-10_JPRB, 0.79817646E-10_JPRB, 0.78437853E-10_JPRB, 0.77066575E-10_JPRB, &
  & 0.75722845E-10_JPRB, 0.74410117E-10_JPRB, 0.73141694E-10_JPRB, 0.71925896E-10_JPRB, 0.70779514E-10_JPRB, 0.69712507E-10_JPRB, &
  & 0.68711557E-10_JPRB, 0.67759763E-10_JPRB, 0.66815858E-10_JPRB, 0.65852220E-10_JPRB, 0.64848307E-10_JPRB, 0.63819047E-10_JPRB, &
  & 0.62793881E-10_JPRB, 0.61780234E-10_JPRB, 0.60658381E-10_JPRB, 0.58718641E-10_JPRB /)

RGHG9(:,40, 1) = (/ &
  & 0.61549377E-10_JPRB, 0.62262043E-10_JPRB, 0.62707839E-10_JPRB, 0.63164404E-10_JPRB, 0.63697624E-10_JPRB, 0.64329930E-10_JPRB, &
  & 0.65014862E-10_JPRB, 0.65706135E-10_JPRB, 0.66365052E-10_JPRB, 0.66993286E-10_JPRB, 0.67601924E-10_JPRB, 0.68269036E-10_JPRB, &
  & 0.69042029E-10_JPRB, 0.70072462E-10_JPRB, 0.71460469E-10_JPRB, 0.73305924E-10_JPRB, 0.75504422E-10_JPRB, 0.77839755E-10_JPRB, &
  & 0.80054831E-10_JPRB, 0.81912935E-10_JPRB, 0.83323806E-10_JPRB, 0.84324291E-10_JPRB, 0.85014176E-10_JPRB, 0.85496582E-10_JPRB, &
  & 0.85845761E-10_JPRB, 0.86113859E-10_JPRB, 0.86331872E-10_JPRB, 0.86517613E-10_JPRB, 0.86675354E-10_JPRB, 0.86798950E-10_JPRB, &
  & 0.86879032E-10_JPRB, 0.86904400E-10_JPRB, 0.86870754E-10_JPRB, 0.86780846E-10_JPRB, 0.86645593E-10_JPRB, 0.86477686E-10_JPRB, &
  & 0.86286367E-10_JPRB, 0.86072087E-10_JPRB, 0.85827158E-10_JPRB, 0.85532928E-10_JPRB, 0.85159151E-10_JPRB, 0.84664213E-10_JPRB, &
  & 0.84005636E-10_JPRB, 0.83149564E-10_JPRB, 0.82109541E-10_JPRB, 0.80924649E-10_JPRB, 0.79677695E-10_JPRB, 0.78409244E-10_JPRB, &
  & 0.77142820E-10_JPRB, 0.75894208E-10_JPRB, 0.74669472E-10_JPRB, 0.73491969E-10_JPRB, 0.72392314E-10_JPRB, 0.71380540E-10_JPRB, &
  & 0.70460353E-10_JPRB, 0.69588349E-10_JPRB, 0.68730979E-10_JPRB, 0.67839165E-10_JPRB, 0.66894559E-10_JPRB, 0.65905295E-10_JPRB, &
  & 0.64917696E-10_JPRB, 0.63948097E-10_JPRB, 0.62890644E-10_JPRB, 0.61077518E-10_JPRB /)

RGHG9(:,41, 1) = (/ &
  & 0.64446296E-10_JPRB, 0.65065973E-10_JPRB, 0.65464426E-10_JPRB, 0.65884284E-10_JPRB, 0.66393599E-10_JPRB, 0.66989539E-10_JPRB, &
  & 0.67627258E-10_JPRB, 0.68251037E-10_JPRB, 0.68836464E-10_JPRB, 0.69378350E-10_JPRB, 0.69911348E-10_JPRB, 0.70466952E-10_JPRB, &
  & 0.71144340E-10_JPRB, 0.72017850E-10_JPRB, 0.73261230E-10_JPRB, 0.74956527E-10_JPRB, 0.77049277E-10_JPRB, 0.79262895E-10_JPRB, &
  & 0.81272690E-10_JPRB, 0.82896315E-10_JPRB, 0.84074414E-10_JPRB, 0.84887035E-10_JPRB, 0.85444637E-10_JPRB, 0.85832591E-10_JPRB, &
  & 0.86121436E-10_JPRB, 0.86343613E-10_JPRB, 0.86529374E-10_JPRB, 0.86690571E-10_JPRB, 0.86829599E-10_JPRB, 0.86941933E-10_JPRB, &
  & 0.87016110E-10_JPRB, 0.87042581E-10_JPRB, 0.87015624E-10_JPRB, 0.86937721E-10_JPRB, 0.86818441E-10_JPRB, 0.86670719E-10_JPRB, &
  & 0.86502583E-10_JPRB, 0.86314532E-10_JPRB, 0.86098947E-10_JPRB, 0.85840515E-10_JPRB, 0.85513562E-10_JPRB, 0.85083690E-10_JPRB, &
  & 0.84512349E-10_JPRB, 0.83772302E-10_JPRB, 0.82859213E-10_JPRB, 0.81817955E-10_JPRB, 0.80690593E-10_JPRB, 0.79527857E-10_JPRB, &
  & 0.78352436E-10_JPRB, 0.77168667E-10_JPRB, 0.75991560E-10_JPRB, 0.74859008E-10_JPRB, 0.73802631E-10_JPRB, 0.72864548E-10_JPRB, &
  & 0.72021340E-10_JPRB, 0.71246460E-10_JPRB, 0.70479150E-10_JPRB, 0.69678832E-10_JPRB, 0.68809222E-10_JPRB, 0.67882956E-10_JPRB, &
  & 0.66950778E-10_JPRB, 0.66036357E-10_JPRB, 0.65045691E-10_JPRB, 0.63356743E-10_JPRB /)

RGHG9(:,42, 1) = (/ &
  & 0.67053536E-10_JPRB, 0.67596845E-10_JPRB, 0.67958326E-10_JPRB, 0.68348938E-10_JPRB, 0.68833009E-10_JPRB, 0.69401679E-10_JPRB, &
  & 0.69991873E-10_JPRB, 0.70554923E-10_JPRB, 0.71072911E-10_JPRB, 0.71550675E-10_JPRB, 0.72009260E-10_JPRB, 0.72497397E-10_JPRB, &
  & 0.73067406E-10_JPRB, 0.73841336E-10_JPRB, 0.74932144E-10_JPRB, 0.76486061E-10_JPRB, 0.78431379E-10_JPRB, 0.80475501E-10_JPRB, &
  & 0.82278656E-10_JPRB, 0.83651766E-10_JPRB, 0.84629234E-10_JPRB, 0.85294896E-10_JPRB, 0.85756277E-10_JPRB, 0.86080823E-10_JPRB, &
  & 0.86328299E-10_JPRB, 0.86521151E-10_JPRB, 0.86686443E-10_JPRB, 0.86831056E-10_JPRB, 0.86957934E-10_JPRB, 0.87061039E-10_JPRB, &
  & 0.87129810E-10_JPRB, 0.87155567E-10_JPRB, 0.87132690E-10_JPRB, 0.87062801E-10_JPRB, 0.86955103E-10_JPRB, 0.86822043E-10_JPRB, &
  & 0.86671635E-10_JPRB, 0.86503936E-10_JPRB, 0.86311985E-10_JPRB, 0.86082225E-10_JPRB, 0.85792970E-10_JPRB, 0.85415251E-10_JPRB, &
  & 0.84917427E-10_JPRB, 0.84271048E-10_JPRB, 0.83473659E-10_JPRB, 0.82545033E-10_JPRB, 0.81535903E-10_JPRB, 0.80480039E-10_JPRB, &
  & 0.79394338E-10_JPRB, 0.78284101E-10_JPRB, 0.77166711E-10_JPRB, 0.76072475E-10_JPRB, 0.75076931E-10_JPRB, 0.74202942E-10_JPRB, &
  & 0.73450253E-10_JPRB, 0.72765946E-10_JPRB, 0.72097765E-10_JPRB, 0.71392121E-10_JPRB, 0.70616638E-10_JPRB, 0.69777524E-10_JPRB, &
  & 0.68919537E-10_JPRB, 0.68076114E-10_JPRB, 0.67156704E-10_JPRB, 0.65588202E-10_JPRB /)

RGHG9(:,43, 1) = (/ &
  & 0.69391062E-10_JPRB, 0.69880518E-10_JPRB, 0.70207506E-10_JPRB, 0.70575268E-10_JPRB, 0.71038939E-10_JPRB, 0.71580387E-10_JPRB, &
  & 0.72128817E-10_JPRB, 0.72639159E-10_JPRB, 0.73102920E-10_JPRB, 0.73525019E-10_JPRB, 0.73931347E-10_JPRB, 0.74354085E-10_JPRB, &
  & 0.74857384E-10_JPRB, 0.75516447E-10_JPRB, 0.76494346E-10_JPRB, 0.77890729E-10_JPRB, 0.79677452E-10_JPRB, 0.81516800E-10_JPRB, &
  & 0.83080459E-10_JPRB, 0.84245472E-10_JPRB, 0.85054477E-10_JPRB, 0.85607306E-10_JPRB, 0.85995974E-10_JPRB, 0.86276042E-10_JPRB, &
  & 0.86493909E-10_JPRB, 0.86667527E-10_JPRB, 0.86818601E-10_JPRB, 0.86952938E-10_JPRB, 0.87070087E-10_JPRB, 0.87165969E-10_JPRB, &
  & 0.87229030E-10_JPRB, 0.87252705E-10_JPRB, 0.87231888E-10_JPRB, 0.87167572E-10_JPRB, 0.87068179E-10_JPRB, 0.86946277E-10_JPRB, &
  & 0.86809650E-10_JPRB, 0.86658361E-10_JPRB, 0.86485950E-10_JPRB, 0.86280420E-10_JPRB, 0.86023362E-10_JPRB, 0.85690462E-10_JPRB, &
  & 0.85253464E-10_JPRB, 0.84687590E-10_JPRB, 0.83983862E-10_JPRB, 0.83162616E-10_JPRB, 0.82258311E-10_JPRB, 0.81303166E-10_JPRB, &
  & 0.80311084E-10_JPRB, 0.79282622E-10_JPRB, 0.78223338E-10_JPRB, 0.77192343E-10_JPRB, 0.76251741E-10_JPRB, 0.75458556E-10_JPRB, &
  & 0.74791062E-10_JPRB, 0.74197669E-10_JPRB, 0.73622178E-10_JPRB, 0.73013560E-10_JPRB, 0.72340814E-10_JPRB, 0.71604528E-10_JPRB, &
  & 0.70845010E-10_JPRB, 0.70085299E-10_JPRB, 0.69247968E-10_JPRB, 0.67806365E-10_JPRB /)

RGHG9(:,44, 1) = (/ &
  & 0.71501381E-10_JPRB, 0.71948822E-10_JPRB, 0.72253384E-10_JPRB, 0.72599288E-10_JPRB, 0.73045209E-10_JPRB, 0.73562344E-10_JPRB, &
  & 0.74075107E-10_JPRB, 0.74544731E-10_JPRB, 0.74963896E-10_JPRB, 0.75344619E-10_JPRB, 0.75704873E-10_JPRB, 0.76078893E-10_JPRB, &
  & 0.76514177E-10_JPRB, 0.77098578E-10_JPRB, 0.77943124E-10_JPRB, 0.79213927E-10_JPRB, 0.80822606E-10_JPRB, 0.82444211E-10_JPRB, &
  & 0.83766709E-10_JPRB, 0.84723936E-10_JPRB, 0.85393068E-10_JPRB, 0.85855482E-10_JPRB, 0.86189250E-10_JPRB, 0.86435747E-10_JPRB, &
  & 0.86632368E-10_JPRB, 0.86793170E-10_JPRB, 0.86934772E-10_JPRB, 0.87061455E-10_JPRB, 0.87172332E-10_JPRB, 0.87260837E-10_JPRB, &
  & 0.87318291E-10_JPRB, 0.87338803E-10_JPRB, 0.87318555E-10_JPRB, 0.87257791E-10_JPRB, 0.87164588E-10_JPRB, 0.87051144E-10_JPRB, &
  & 0.86925397E-10_JPRB, 0.86787535E-10_JPRB, 0.86631508E-10_JPRB, 0.86446905E-10_JPRB, 0.86217866E-10_JPRB, 0.85924032E-10_JPRB, &
  & 0.85541720E-10_JPRB, 0.85048066E-10_JPRB, 0.84430934E-10_JPRB, 0.83702309E-10_JPRB, 0.82892034E-10_JPRB, 0.82032901E-10_JPRB, &
  & 0.81132337E-10_JPRB, 0.80186843E-10_JPRB, 0.79209285E-10_JPRB, 0.78242426E-10_JPRB, 0.77383405E-10_JPRB, 0.76672960E-10_JPRB, &
  & 0.76089357E-10_JPRB, 0.75580785E-10_JPRB, 0.75089088E-10_JPRB, 0.74572792E-10_JPRB, 0.74001437E-10_JPRB, 0.73376125E-10_JPRB, &
  & 0.72727248E-10_JPRB, 0.72066068E-10_JPRB, 0.71324266E-10_JPRB, 0.70025145E-10_JPRB /)

RGHG9(:,45, 1) = (/ &
  & 0.73429367E-10_JPRB, 0.73846020E-10_JPRB, 0.74133373E-10_JPRB, 0.74462374E-10_JPRB, 0.74891121E-10_JPRB, 0.75389466E-10_JPRB, &
  & 0.75876125E-10_JPRB, 0.76313851E-10_JPRB, 0.76703158E-10_JPRB, 0.77048631E-10_JPRB, 0.77371214E-10_JPRB, 0.77700700E-10_JPRB, &
  & 0.78077850E-10_JPRB, 0.78580212E-10_JPRB, 0.79323138E-10_JPRB, 0.80427748E-10_JPRB, 0.81849659E-10_JPRB, 0.83234822E-10_JPRB, &
  & 0.84330425E-10_JPRB, 0.85115123E-10_JPRB, 0.85665440E-10_JPRB, 0.86058966E-10_JPRB, 0.86346930E-10_JPRB, 0.86570896E-10_JPRB, &
  & 0.86751099E-10_JPRB, 0.86903193E-10_JPRB, 0.87039029E-10_JPRB, 0.87160959E-10_JPRB, 0.87265584E-10_JPRB, 0.87348330E-10_JPRB, &
  & 0.87399414E-10_JPRB, 0.87416144E-10_JPRB, 0.87395195E-10_JPRB, 0.87336631E-10_JPRB, 0.87247695E-10_JPRB, 0.87140753E-10_JPRB, &
  & 0.87023638E-10_JPRB, 0.86896657E-10_JPRB, 0.86754472E-10_JPRB, 0.86587806E-10_JPRB, 0.86383400E-10_JPRB, 0.86124337E-10_JPRB, &
  & 0.85791263E-10_JPRB, 0.85362675E-10_JPRB, 0.84826278E-10_JPRB, 0.84184319E-10_JPRB, 0.83465790E-10_JPRB, 0.82695184E-10_JPRB, &
  & 0.81884818E-10_JPRB, 0.81029010E-10_JPRB, 0.80131068E-10_JPRB, 0.79261077E-10_JPRB, 0.78488327E-10_JPRB, 0.77871744E-10_JPRB, &
  & 0.77371602E-10_JPRB, 0.76938317E-10_JPRB, 0.76525085E-10_JPRB, 0.76089302E-10_JPRB, 0.75613002E-10_JPRB, 0.75095513E-10_JPRB, &
  & 0.74556659E-10_JPRB, 0.74003151E-10_JPRB, 0.73368714E-10_JPRB, 0.72237535E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART1',1,ZHOOK_HANDLE)
END SUBROUTINE PART1




SUBROUTINE PART2
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART2',0,ZHOOK_HANDLE)



RGHG9(:,46, 1) = (/ &
  & 0.75207077E-10_JPRB, 0.75611899E-10_JPRB, 0.75883015E-10_JPRB, 0.76201823E-10_JPRB, 0.76615977E-10_JPRB, 0.77096461E-10_JPRB, &
  & 0.77566210E-10_JPRB, 0.77986076E-10_JPRB, 0.78350271E-10_JPRB, 0.78667468E-10_JPRB, 0.78956015E-10_JPRB, 0.79238741E-10_JPRB, &
  & 0.79566069E-10_JPRB, 0.79983790E-10_JPRB, 0.80624174E-10_JPRB, 0.81571201E-10_JPRB, 0.82777833E-10_JPRB, 0.83918067E-10_JPRB, &
  & 0.84800097E-10_JPRB, 0.85433417E-10_JPRB, 0.85889101E-10_JPRB, 0.86224680E-10_JPRB, 0.86481350E-10_JPRB, 0.86685263E-10_JPRB, &
  & 0.86854829E-10_JPRB, 0.87002267E-10_JPRB, 0.87133585E-10_JPRB, 0.87252150E-10_JPRB, 0.87352854E-10_JPRB, 0.87428238E-10_JPRB, &
  & 0.87473570E-10_JPRB, 0.87485852E-10_JPRB, 0.87463370E-10_JPRB, 0.87405597E-10_JPRB, 0.87319804E-10_JPRB, 0.87217671E-10_JPRB, &
  & 0.87107321E-10_JPRB, 0.86989235E-10_JPRB, 0.86858458E-10_JPRB, 0.86707218E-10_JPRB, 0.86524211E-10_JPRB, 0.86296283E-10_JPRB, &
  & 0.86007812E-10_JPRB, 0.85641959E-10_JPRB, 0.85183374E-10_JPRB, 0.84629845E-10_JPRB, 0.83998863E-10_JPRB, 0.83317520E-10_JPRB, &
  & 0.82596437E-10_JPRB, 0.81827697E-10_JPRB, 0.81032570E-10_JPRB, 0.80248502E-10_JPRB, 0.79593498E-10_JPRB, 0.79061660E-10_JPRB, &
  & 0.78645403E-10_JPRB, 0.78283713E-10_JPRB, 0.77936040E-10_JPRB, 0.77575758E-10_JPRB, 0.77181178E-10_JPRB, 0.76758752E-10_JPRB, &
  & 0.76323906E-10_JPRB, 0.75873377E-10_JPRB, 0.75349595E-10_JPRB, 0.74405523E-10_JPRB /)

RGHG9(:,47, 1) = (/ &
  & 0.76877706E-10_JPRB, 0.77263806E-10_JPRB, 0.77533084E-10_JPRB, 0.77837195E-10_JPRB, 0.78240088E-10_JPRB, 0.78710954E-10_JPRB, &
  & 0.79167881E-10_JPRB, 0.79577074E-10_JPRB, 0.79921930E-10_JPRB, 0.80212365E-10_JPRB, 0.80462914E-10_JPRB, 0.80708447E-10_JPRB, &
  & 0.80971209E-10_JPRB, 0.81330401E-10_JPRB, 0.81831542E-10_JPRB, 0.82622686E-10_JPRB, 0.83586110E-10_JPRB, 0.84492191E-10_JPRB, &
  & 0.85184935E-10_JPRB, 0.85694021E-10_JPRB, 0.86071553E-10_JPRB, 0.86364339E-10_JPRB, 0.86593399E-10_JPRB, 0.86785676E-10_JPRB, &
  & 0.86947574E-10_JPRB, 0.87091230E-10_JPRB, 0.87221820E-10_JPRB, 0.87337408E-10_JPRB, 0.87432617E-10_JPRB, 0.87502477E-10_JPRB, &
  & 0.87540961E-10_JPRB, 0.87548663E-10_JPRB, 0.87523787E-10_JPRB, 0.87466180E-10_JPRB, 0.87382122E-10_JPRB, 0.87283757E-10_JPRB, &
  & 0.87178716E-10_JPRB, 0.87067575E-10_JPRB, 0.86946325E-10_JPRB, 0.86807853E-10_JPRB, 0.86643387E-10_JPRB, 0.86442624E-10_JPRB, &
  & 0.86194690E-10_JPRB, 0.85886943E-10_JPRB, 0.85505485E-10_JPRB, 0.85043958E-10_JPRB, 0.84506777E-10_JPRB, 0.83921044E-10_JPRB, &
  & 0.83291818E-10_JPRB, 0.82623033E-10_JPRB, 0.81913837E-10_JPRB, 0.81255239E-10_JPRB, 0.80682586E-10_JPRB, 0.80255899E-10_JPRB, &
  & 0.79908774E-10_JPRB, 0.79612122E-10_JPRB, 0.79327225E-10_JPRB, 0.79026931E-10_JPRB, 0.78705278E-10_JPRB, 0.78363663E-10_JPRB, &
  & 0.78016149E-10_JPRB, 0.77657589E-10_JPRB, 0.77240006E-10_JPRB, 0.76476395E-10_JPRB /)

RGHG9(:,48, 1) = (/ &
  & 0.78443849E-10_JPRB, 0.78831268E-10_JPRB, 0.79087376E-10_JPRB, 0.79390050E-10_JPRB, 0.79780987E-10_JPRB, 0.80241494E-10_JPRB, &
  & 0.80698552E-10_JPRB, 0.81095908E-10_JPRB, 0.81424020E-10_JPRB, 0.81681488E-10_JPRB, 0.81898252E-10_JPRB, 0.82094956E-10_JPRB, &
  & 0.82313836E-10_JPRB, 0.82581206E-10_JPRB, 0.82988144E-10_JPRB, 0.83559132E-10_JPRB, 0.84294377E-10_JPRB, 0.84969538E-10_JPRB, &
  & 0.85500711E-10_JPRB, 0.85906254E-10_JPRB, 0.86223154E-10_JPRB, 0.86479407E-10_JPRB, 0.86691966E-10_JPRB, 0.86873148E-10_JPRB, &
  & 0.87031632E-10_JPRB, 0.87175073E-10_JPRB, 0.87303366E-10_JPRB, 0.87416935E-10_JPRB, 0.87507425E-10_JPRB, 0.87569757E-10_JPRB, &
  & 0.87602182E-10_JPRB, 0.87604979E-10_JPRB, 0.87577397E-10_JPRB, 0.87518895E-10_JPRB, 0.87436280E-10_JPRB, 0.87340545E-10_JPRB, &
  & 0.87239591E-10_JPRB, 0.87134161E-10_JPRB, 0.87020349E-10_JPRB, 0.86892667E-10_JPRB, 0.86743675E-10_JPRB, 0.86566615E-10_JPRB, &
  & 0.86354951E-10_JPRB, 0.86101064E-10_JPRB, 0.85797244E-10_JPRB, 0.85430246E-10_JPRB, 0.85003699E-10_JPRB, 0.84520051E-10_JPRB, &
  & 0.83997483E-10_JPRB, 0.83425447E-10_JPRB, 0.82831499E-10_JPRB, 0.82257035E-10_JPRB, 0.81802468E-10_JPRB, 0.81446121E-10_JPRB, &
  & 0.81171007E-10_JPRB, 0.80929867E-10_JPRB, 0.80695672E-10_JPRB, 0.80450813E-10_JPRB, 0.80185969E-10_JPRB, 0.79910384E-10_JPRB, &
  & 0.79633064E-10_JPRB, 0.79350242E-10_JPRB, 0.79018535E-10_JPRB, 0.78415975E-10_JPRB /)

RGHG9(:,49, 1) = (/ &
  & 0.79927814E-10_JPRB, 0.80300502E-10_JPRB, 0.80560794E-10_JPRB, 0.80852630E-10_JPRB, 0.81242089E-10_JPRB, 0.81701895E-10_JPRB, &
  & 0.82156698E-10_JPRB, 0.82548662E-10_JPRB, 0.82846306E-10_JPRB, 0.83069697E-10_JPRB, 0.83242802E-10_JPRB, 0.83396720E-10_JPRB, &
  & 0.83554767E-10_JPRB, 0.83746690E-10_JPRB, 0.84012526E-10_JPRB, 0.84397073E-10_JPRB, 0.84884225E-10_JPRB, 0.85364646E-10_JPRB, &
  & 0.85759816E-10_JPRB, 0.86081489E-10_JPRB, 0.86348761E-10_JPRB, 0.86578106E-10_JPRB, 0.86776628E-10_JPRB, 0.86953091E-10_JPRB, &
  & 0.87110021E-10_JPRB, 0.87253024E-10_JPRB, 0.87381311E-10_JPRB, 0.87491313E-10_JPRB, 0.87575440E-10_JPRB, 0.87631347E-10_JPRB, &
  & 0.87657312E-10_JPRB, 0.87655362E-10_JPRB, 0.87624588E-10_JPRB, 0.87565212E-10_JPRB, 0.87483104E-10_JPRB, 0.87389596E-10_JPRB, &
  & 0.87291924E-10_JPRB, 0.87190831E-10_JPRB, 0.87083236E-10_JPRB, 0.86964075E-10_JPRB, 0.86828184E-10_JPRB, 0.86671260E-10_JPRB, &
  & 0.86491370E-10_JPRB, 0.86287581E-10_JPRB, 0.86056315E-10_JPRB, 0.85791443E-10_JPRB, 0.85480727E-10_JPRB, 0.85124872E-10_JPRB, &
  & 0.84717650E-10_JPRB, 0.84261327E-10_JPRB, 0.83770928E-10_JPRB, 0.83312794E-10_JPRB, 0.82942042E-10_JPRB, 0.82664167E-10_JPRB, &
  & 0.82445287E-10_JPRB, 0.82252143E-10_JPRB, 0.82061580E-10_JPRB, 0.81859360E-10_JPRB, 0.81641374E-10_JPRB, 0.81414944E-10_JPRB, &
  & 0.81191040E-10_JPRB, 0.80962931E-10_JPRB, 0.80698455E-10_JPRB, 0.80215917E-10_JPRB /)

RGHG9(:,50, 1) = (/ &
  & 0.81307246E-10_JPRB, 0.81682952E-10_JPRB, 0.81927992E-10_JPRB, 0.82226524E-10_JPRB, 0.82611161E-10_JPRB, 0.83081549E-10_JPRB, &
  & 0.83534069E-10_JPRB, 0.83899866E-10_JPRB, 0.84153629E-10_JPRB, 0.84322826E-10_JPRB, 0.84444715E-10_JPRB, 0.84545176E-10_JPRB, &
  & 0.84636534E-10_JPRB, 0.84747556E-10_JPRB, 0.84879423E-10_JPRB, 0.85090338E-10_JPRB, 0.85371279E-10_JPRB, 0.85686680E-10_JPRB, &
  & 0.85973582E-10_JPRB, 0.86227456E-10_JPRB, 0.86455891E-10_JPRB, 0.86663024E-10_JPRB, 0.86853094E-10_JPRB, 0.87026067E-10_JPRB, &
  & 0.87184371E-10_JPRB, 0.87327603E-10_JPRB, 0.87454405E-10_JPRB, 0.87559730E-10_JPRB, 0.87637841E-10_JPRB, 0.87686643E-10_JPRB, &
  & 0.87706883E-10_JPRB, 0.87700264E-10_JPRB, 0.87666353E-10_JPRB, 0.87605562E-10_JPRB, 0.87524071E-10_JPRB, 0.87432284E-10_JPRB, &
  & 0.87337221E-10_JPRB, 0.87239729E-10_JPRB, 0.87136895E-10_JPRB, 0.87024818E-10_JPRB, 0.86899522E-10_JPRB, 0.86759849E-10_JPRB, &
  & 0.86608026E-10_JPRB, 0.86449035E-10_JPRB, 0.86286159E-10_JPRB, 0.86116655E-10_JPRB, 0.85927543E-10_JPRB, 0.85705151E-10_JPRB, &
  & 0.85432793E-10_JPRB, 0.85109274E-10_JPRB, 0.84745495E-10_JPRB, 0.84404463E-10_JPRB, 0.84123625E-10_JPRB, 0.83918220E-10_JPRB, &
  & 0.83748036E-10_JPRB, 0.83596852E-10_JPRB, 0.83444883E-10_JPRB, 0.83277253E-10_JPRB, 0.83096460E-10_JPRB, 0.82907819E-10_JPRB, &
  & 0.82720233E-10_JPRB, 0.82531509E-10_JPRB, 0.82308910E-10_JPRB, 0.81906225E-10_JPRB /)

RGHG9(:,51, 1) = (/ &
  & 0.82586299E-10_JPRB, 0.82927949E-10_JPRB, 0.83187929E-10_JPRB, 0.83469009E-10_JPRB, 0.83869939E-10_JPRB, 0.84325685E-10_JPRB, &
  & 0.84757229E-10_JPRB, 0.85049544E-10_JPRB, 0.85223231E-10_JPRB, 0.85323942E-10_JPRB, 0.85387142E-10_JPRB, 0.85430288E-10_JPRB, &
  & 0.85468230E-10_JPRB, 0.85500107E-10_JPRB, 0.85549894E-10_JPRB, 0.85619456E-10_JPRB, 0.85761467E-10_JPRB, 0.85948942E-10_JPRB, &
  & 0.86152523E-10_JPRB, 0.86353320E-10_JPRB, 0.86549212E-10_JPRB, 0.86739928E-10_JPRB, 0.86922899E-10_JPRB, 0.87095574E-10_JPRB, &
  & 0.87254294E-10_JPRB, 0.87398616E-10_JPRB, 0.87521879E-10_JPRB, 0.87622576E-10_JPRB, 0.87693637E-10_JPRB, 0.87736512E-10_JPRB, &
  & 0.87751410E-10_JPRB, 0.87740329E-10_JPRB, 0.87703234E-10_JPRB, 0.87641033E-10_JPRB, 0.87559932E-10_JPRB, 0.87469684E-10_JPRB, &
  & 0.87376939E-10_JPRB, 0.87282348E-10_JPRB, 0.87183497E-10_JPRB, 0.87077012E-10_JPRB, 0.86960689E-10_JPRB, 0.86835719E-10_JPRB, &
  & 0.86708966E-10_JPRB, 0.86589756E-10_JPRB, 0.86487484E-10_JPRB, 0.86398742E-10_JPRB, 0.86313415E-10_JPRB, 0.86208721E-10_JPRB, &
  & 0.86071879E-10_JPRB, 0.85887845E-10_JPRB, 0.85673885E-10_JPRB, 0.85455781E-10_JPRB, 0.85282559E-10_JPRB, 0.85138258E-10_JPRB, &
  & 0.85024168E-10_JPRB, 0.84914888E-10_JPRB, 0.84798640E-10_JPRB, 0.84671367E-10_JPRB, 0.84524367E-10_JPRB, 0.84369650E-10_JPRB, &
  & 0.84215239E-10_JPRB, 0.84053493E-10_JPRB, 0.83862792E-10_JPRB, 0.83508374E-10_JPRB /)

RGHG9(:,52, 1) = (/ &
  & 0.83695349E-10_JPRB, 0.84051530E-10_JPRB, 0.84268578E-10_JPRB, 0.84568796E-10_JPRB, 0.84926184E-10_JPRB, 0.85353814E-10_JPRB, &
  & 0.85669374E-10_JPRB, 0.85854324E-10_JPRB, 0.85941955E-10_JPRB, 0.85984178E-10_JPRB, 0.86004495E-10_JPRB, 0.86014355E-10_JPRB, &
  & 0.86016819E-10_JPRB, 0.86014584E-10_JPRB, 0.86010754E-10_JPRB, 0.86017381E-10_JPRB, 0.86060131E-10_JPRB, 0.86164131E-10_JPRB, &
  & 0.86304477E-10_JPRB, 0.86464114E-10_JPRB, 0.86635234E-10_JPRB, 0.86811905E-10_JPRB, 0.86989513E-10_JPRB, 0.87161306E-10_JPRB, &
  & 0.87321490E-10_JPRB, 0.87463453E-10_JPRB, 0.87584391E-10_JPRB, 0.87678455E-10_JPRB, 0.87744034E-10_JPRB, 0.87781164E-10_JPRB, &
  & 0.87791441E-10_JPRB, 0.87776161E-10_JPRB, 0.87735916E-10_JPRB, 0.87672286E-10_JPRB, 0.87591476E-10_JPRB, 0.87502790E-10_JPRB, &
  & 0.87412029E-10_JPRB, 0.87320089E-10_JPRB, 0.87224533E-10_JPRB, 0.87122892E-10_JPRB, 0.87014139E-10_JPRB, 0.86902541E-10_JPRB, &
  & 0.86797888E-10_JPRB, 0.86714719E-10_JPRB, 0.86660873E-10_JPRB, 0.86634158E-10_JPRB, 0.86617574E-10_JPRB, 0.86594995E-10_JPRB, &
  & 0.86549913E-10_JPRB, 0.86477915E-10_JPRB, 0.86380084E-10_JPRB, 0.86278609E-10_JPRB, 0.86183824E-10_JPRB, 0.86110674E-10_JPRB, &
  & 0.86042229E-10_JPRB, 0.85976531E-10_JPRB, 0.85905325E-10_JPRB, 0.85817381E-10_JPRB, 0.85718162E-10_JPRB, 0.85607868E-10_JPRB, &
  & 0.85493460E-10_JPRB, 0.85373687E-10_JPRB, 0.85222523E-10_JPRB, 0.84930840E-10_JPRB /)

RGHG9(:,53, 1) = (/ &
  & 0.84666135E-10_JPRB, 0.84950005E-10_JPRB, 0.85195399E-10_JPRB, 0.85425785E-10_JPRB, 0.85755930E-10_JPRB, 0.86045580E-10_JPRB, &
  & 0.86243665E-10_JPRB, 0.86329194E-10_JPRB, 0.86363375E-10_JPRB, 0.86375213E-10_JPRB, 0.86376989E-10_JPRB, 0.86373103E-10_JPRB, &
  & 0.86363521E-10_JPRB, 0.86350635E-10_JPRB, 0.86325794E-10_JPRB, 0.86304422E-10_JPRB, 0.86298343E-10_JPRB, 0.86341941E-10_JPRB, &
  & 0.86436656E-10_JPRB, 0.86565352E-10_JPRB, 0.86716190E-10_JPRB, 0.86882147E-10_JPRB, 0.87054565E-10_JPRB, 0.87224672E-10_JPRB, &
  & 0.87383059E-10_JPRB, 0.87523926E-10_JPRB, 0.87639833E-10_JPRB, 0.87729296E-10_JPRB, 0.87789082E-10_JPRB, 0.87821479E-10_JPRB, &
  & 0.87827488E-10_JPRB, 0.87808386E-10_JPRB, 0.87765073E-10_JPRB, 0.87700007E-10_JPRB, 0.87619557E-10_JPRB, 0.87532245E-10_JPRB, &
  & 0.87443532E-10_JPRB, 0.87353964E-10_JPRB, 0.87261545E-10_JPRB, 0.87164186E-10_JPRB, 0.87062677E-10_JPRB, 0.86963020E-10_JPRB, &
  & 0.86879288E-10_JPRB, 0.86825769E-10_JPRB, 0.86810163E-10_JPRB, 0.86823028E-10_JPRB, 0.86846405E-10_JPRB, 0.86864044E-10_JPRB, &
  & 0.86866375E-10_JPRB, 0.86849056E-10_JPRB, 0.86814486E-10_JPRB, 0.86770591E-10_JPRB, 0.86730401E-10_JPRB, 0.86692320E-10_JPRB, &
  & 0.86659291E-10_JPRB, 0.86624541E-10_JPRB, 0.86583685E-10_JPRB, 0.86536125E-10_JPRB, 0.86476465E-10_JPRB, 0.86411642E-10_JPRB, &
  & 0.86344848E-10_JPRB, 0.86272940E-10_JPRB, 0.86184879E-10_JPRB, 0.85994718E-10_JPRB /)

RGHG9(:,54, 1) = (/ &
  & 0.85408070E-10_JPRB, 0.85709093E-10_JPRB, 0.85870769E-10_JPRB, 0.86091301E-10_JPRB, 0.86295714E-10_JPRB, 0.86483154E-10_JPRB, &
  & 0.86573290E-10_JPRB, 0.86607582E-10_JPRB, 0.86616270E-10_JPRB, 0.86615881E-10_JPRB, 0.86611315E-10_JPRB, 0.86603530E-10_JPRB, &
  & 0.86593420E-10_JPRB, 0.86575240E-10_JPRB, 0.86554819E-10_JPRB, 0.86515829E-10_JPRB, 0.86488323E-10_JPRB, 0.86494166E-10_JPRB, &
  & 0.86554625E-10_JPRB, 0.86659097E-10_JPRB, 0.86795099E-10_JPRB, 0.86951349E-10_JPRB, 0.87118236E-10_JPRB, 0.87284895E-10_JPRB, &
  & 0.87441054E-10_JPRB, 0.87578195E-10_JPRB, 0.87690875E-10_JPRB, 0.87774905E-10_JPRB, 0.87830257E-10_JPRB, 0.87858089E-10_JPRB, &
  & 0.87860143E-10_JPRB, 0.87837536E-10_JPRB, 0.87791510E-10_JPRB, 0.87724994E-10_JPRB, 0.87644919E-10_JPRB, 0.87558905E-10_JPRB, &
  & 0.87472217E-10_JPRB, 0.87384940E-10_JPRB, 0.87295615E-10_JPRB, 0.87202738E-10_JPRB, 0.87108105E-10_JPRB, 0.87020495E-10_JPRB, &
  & 0.86954707E-10_JPRB, 0.86926341E-10_JPRB, 0.86937603E-10_JPRB, 0.86973762E-10_JPRB, 0.87016720E-10_JPRB, 0.87051519E-10_JPRB, &
  & 0.87071982E-10_JPRB, 0.87076624E-10_JPRB, 0.87067333E-10_JPRB, 0.87050249E-10_JPRB, 0.87030660E-10_JPRB, 0.87013334E-10_JPRB, &
  & 0.86995591E-10_JPRB, 0.86977009E-10_JPRB, 0.86955651E-10_JPRB, 0.86927687E-10_JPRB, 0.86895505E-10_JPRB, 0.86859610E-10_JPRB, &
  & 0.86824437E-10_JPRB, 0.86791831E-10_JPRB, 0.86759155E-10_JPRB, 0.86715433E-10_JPRB /)

RGHG9(:,55, 1) = (/ &
  & 0.86010164E-10_JPRB, 0.86227185E-10_JPRB, 0.86393906E-10_JPRB, 0.86518875E-10_JPRB, 0.86654857E-10_JPRB, 0.86741690E-10_JPRB, &
  & 0.86779021E-10_JPRB, 0.86786522E-10_JPRB, 0.86784746E-10_JPRB, 0.86779986E-10_JPRB, 0.86773880E-10_JPRB, 0.86766497E-10_JPRB, &
  & 0.86755943E-10_JPRB, 0.86743307E-10_JPRB, 0.86717911E-10_JPRB, 0.86689253E-10_JPRB, 0.86644220E-10_JPRB, 0.86626900E-10_JPRB, &
  & 0.86662143E-10_JPRB, 0.86748546E-10_JPRB, 0.86871670E-10_JPRB, 0.87019565E-10_JPRB, 0.87180485E-10_JPRB, 0.87342390E-10_JPRB, &
  & 0.87494845E-10_JPRB, 0.87628932E-10_JPRB, 0.87737220E-10_JPRB, 0.87817267E-10_JPRB, 0.87867900E-10_JPRB, 0.87891749E-10_JPRB, &
  & 0.87890112E-10_JPRB, 0.87864264E-10_JPRB, 0.87815859E-10_JPRB, 0.87748302E-10_JPRB, 0.87668303E-10_JPRB, 0.87583871E-10_JPRB, &
  & 0.87498772E-10_JPRB, 0.87414187E-10_JPRB, 0.87327902E-10_JPRB, 0.87239764E-10_JPRB, 0.87152570E-10_JPRB, 0.87076020E-10_JPRB, &
  & 0.87026601E-10_JPRB, 0.87017359E-10_JPRB, 0.87046252E-10_JPRB, 0.87096941E-10_JPRB, 0.87147602E-10_JPRB, 0.87188354E-10_JPRB, &
  & 0.87214784E-10_JPRB, 0.87226878E-10_JPRB, 0.87227364E-10_JPRB, 0.87220689E-10_JPRB, 0.87211877E-10_JPRB, 0.87202218E-10_JPRB, &
  & 0.87192857E-10_JPRB, 0.87182359E-10_JPRB, 0.87169272E-10_JPRB, 0.87153437E-10_JPRB, 0.87133079E-10_JPRB, 0.87111054E-10_JPRB, &
  & 0.87088864E-10_JPRB, 0.87066798E-10_JPRB, 0.87042581E-10_JPRB, 0.86999408E-10_JPRB /)

RGHG9(:,56, 1) = (/ &
  & 0.86429468E-10_JPRB, 0.86629433E-10_JPRB, 0.86725169E-10_JPRB, 0.86812710E-10_JPRB, 0.86877144E-10_JPRB, 0.86913685E-10_JPRB, &
  & 0.86920471E-10_JPRB, 0.86916516E-10_JPRB, 0.86910708E-10_JPRB, 0.86904844E-10_JPRB, 0.86898926E-10_JPRB, 0.86892132E-10_JPRB, &
  & 0.86884333E-10_JPRB, 0.86871385E-10_JPRB, 0.86855495E-10_JPRB, 0.86820627E-10_JPRB, 0.86781270E-10_JPRB, 0.86746242E-10_JPRB, &
  & 0.86763124E-10_JPRB, 0.86834449E-10_JPRB, 0.86946991E-10_JPRB, 0.87086699E-10_JPRB, 0.87240846E-10_JPRB, 0.87397894E-10_JPRB, &
  & 0.87546068E-10_JPRB, 0.87676102E-10_JPRB, 0.87780942E-10_JPRB, 0.87856229E-10_JPRB, 0.87903032E-10_JPRB, 0.87923002E-10_JPRB, &
  & 0.87918020E-10_JPRB, 0.87889404E-10_JPRB, 0.87838882E-10_JPRB, 0.87770603E-10_JPRB, 0.87691042E-10_JPRB, 0.87607629E-10_JPRB, &
  & 0.87524835E-10_JPRB, 0.87442283E-10_JPRB, 0.87359751E-10_JPRB, 0.87276505E-10_JPRB, 0.87196819E-10_JPRB, 0.87131184E-10_JPRB, &
  & 0.87095144E-10_JPRB, 0.87100147E-10_JPRB, 0.87141974E-10_JPRB, 0.87198658E-10_JPRB, 0.87253718E-10_JPRB, 0.87295268E-10_JPRB, &
  & 0.87322261E-10_JPRB, 0.87336173E-10_JPRB, 0.87340100E-10_JPRB, 0.87337970E-10_JPRB, 0.87333224E-10_JPRB, 0.87328041E-10_JPRB, &
  & 0.87322219E-10_JPRB, 0.87315606E-10_JPRB, 0.87307647E-10_JPRB, 0.87296857E-10_JPRB, 0.87283979E-10_JPRB, 0.87269122E-10_JPRB, &
  & 0.87254273E-10_JPRB, 0.87239882E-10_JPRB, 0.87224603E-10_JPRB, 0.87200816E-10_JPRB /)

RGHG9(:,57, 1) = (/ &
  & 0.86741794E-10_JPRB, 0.86886963E-10_JPRB, 0.86958010E-10_JPRB, 0.87003030E-10_JPRB, 0.87030383E-10_JPRB, 0.87036656E-10_JPRB, &
  & 0.87029516E-10_JPRB, 0.87021099E-10_JPRB, 0.87013993E-10_JPRB, 0.87008172E-10_JPRB, 0.87002835E-10_JPRB, 0.86997326E-10_JPRB, &
  & 0.86990165E-10_JPRB, 0.86981353E-10_JPRB, 0.86964144E-10_JPRB, 0.86941079E-10_JPRB, 0.86895088E-10_JPRB, 0.86855537E-10_JPRB, &
  & 0.86858964E-10_JPRB, 0.86918583E-10_JPRB, 0.87021189E-10_JPRB, 0.87152716E-10_JPRB, 0.87300542E-10_JPRB, 0.87451664E-10_JPRB, &
  & 0.87595375E-10_JPRB, 0.87721323E-10_JPRB, 0.87821479E-10_JPRB, 0.87893137E-10_JPRB, 0.87935811E-10_JPRB, 0.87952368E-10_JPRB, &
  & 0.87944443E-10_JPRB, 0.87913510E-10_JPRB, 0.87861537E-10_JPRB, 0.87792607E-10_JPRB, 0.87713656E-10_JPRB, 0.87631860E-10_JPRB, &
  & 0.87550522E-10_JPRB, 0.87471010E-10_JPRB, 0.87391747E-10_JPRB, 0.87313885E-10_JPRB, 0.87241797E-10_JPRB, 0.87185967E-10_JPRB, &
  & 0.87161292E-10_JPRB, 0.87177023E-10_JPRB, 0.87225276E-10_JPRB, 0.87287871E-10_JPRB, 0.87342640E-10_JPRB, 0.87383656E-10_JPRB, &
  & 0.87409302E-10_JPRB, 0.87422611E-10_JPRB, 0.87427218E-10_JPRB, 0.87426719E-10_JPRB, 0.87424110E-10_JPRB, 0.87420599E-10_JPRB, &
  & 0.87416803E-10_JPRB, 0.87412327E-10_JPRB, 0.87406526E-10_JPRB, 0.87399289E-10_JPRB, 0.87389748E-10_JPRB, 0.87379132E-10_JPRB, &
  & 0.87367995E-10_JPRB, 0.87356761E-10_JPRB, 0.87344090E-10_JPRB, 0.87321657E-10_JPRB /)

RGHG9(:,58, 1) = (/ &
  & 0.86966864E-10_JPRB, 0.87073258E-10_JPRB, 0.87116536E-10_JPRB, 0.87137318E-10_JPRB, 0.87143445E-10_JPRB, 0.87134737E-10_JPRB, &
  & 0.87122101E-10_JPRB, 0.87111651E-10_JPRB, 0.87104601E-10_JPRB, 0.87099217E-10_JPRB, 0.87094595E-10_JPRB, 0.87089780E-10_JPRB, &
  & 0.87084326E-10_JPRB, 0.87075694E-10_JPRB, 0.87063898E-10_JPRB, 0.87038085E-10_JPRB, 0.87001142E-10_JPRB, 0.86955484E-10_JPRB, &
  & 0.86950933E-10_JPRB, 0.87001156E-10_JPRB, 0.87094887E-10_JPRB, 0.87218732E-10_JPRB, 0.87359502E-10_JPRB, 0.87505128E-10_JPRB, &
  & 0.87643448E-10_JPRB, 0.87764254E-10_JPRB, 0.87860372E-10_JPRB, 0.87927443E-10_JPRB, 0.87966780E-10_JPRB, 0.87980186E-10_JPRB, &
  & 0.87969833E-10_JPRB, 0.87937220E-10_JPRB, 0.87884179E-10_JPRB, 0.87815248E-10_JPRB, 0.87737123E-10_JPRB, 0.87656535E-10_JPRB, &
  & 0.87577563E-10_JPRB, 0.87500444E-10_JPRB, 0.87425081E-10_JPRB, 0.87352452E-10_JPRB, 0.87287573E-10_JPRB, 0.87240902E-10_JPRB, &
  & 0.87225338E-10_JPRB, 0.87248042E-10_JPRB, 0.87302249E-10_JPRB, 0.87365018E-10_JPRB, 0.87421105E-10_JPRB, 0.87459928E-10_JPRB, &
  & 0.87483507E-10_JPRB, 0.87495289E-10_JPRB, 0.87499494E-10_JPRB, 0.87499355E-10_JPRB, 0.87497343E-10_JPRB, 0.87494761E-10_JPRB, &
  & 0.87491757E-10_JPRB, 0.87488211E-10_JPRB, 0.87483881E-10_JPRB, 0.87477962E-10_JPRB, 0.87470794E-10_JPRB, 0.87462246E-10_JPRB, &
  & 0.87453433E-10_JPRB, 0.87444378E-10_JPRB, 0.87434171E-10_JPRB, 0.87416893E-10_JPRB /)

RGHG9(:,59, 1) = (/ &
  & 0.87136069E-10_JPRB, 0.87213563E-10_JPRB, 0.87233915E-10_JPRB, 0.87240541E-10_JPRB, 0.87235046E-10_JPRB, 0.87219912E-10_JPRB, &
  & 0.87204487E-10_JPRB, 0.87194148E-10_JPRB, 0.87187257E-10_JPRB, 0.87182442E-10_JPRB, 0.87178431E-10_JPRB, 0.87174504E-10_JPRB, &
  & 0.87169549E-10_JPRB, 0.87163027E-10_JPRB, 0.87150648E-10_JPRB, 0.87131108E-10_JPRB, 0.87091653E-10_JPRB, 0.87048750E-10_JPRB, &
  & 0.87039792E-10_JPRB, 0.87082758E-10_JPRB, 0.87168488E-10_JPRB, 0.87284756E-10_JPRB, 0.87418836E-10_JPRB, 0.87558058E-10_JPRB, &
  & 0.87690549E-10_JPRB, 0.87806151E-10_JPRB, 0.87896829E-10_JPRB, 0.87960188E-10_JPRB, 0.87995923E-10_JPRB, 0.88006762E-10_JPRB, &
  & 0.87994577E-10_JPRB, 0.87960819E-10_JPRB, 0.87907459E-10_JPRB, 0.87838729E-10_JPRB, 0.87761756E-10_JPRB, 0.87682930E-10_JPRB, &
  & 0.87606013E-10_JPRB, 0.87531697E-10_JPRB, 0.87460018E-10_JPRB, 0.87392420E-10_JPRB, 0.87334563E-10_JPRB, 0.87295698E-10_JPRB, &
  & 0.87287594E-10_JPRB, 0.87315842E-10_JPRB, 0.87371332E-10_JPRB, 0.87436489E-10_JPRB, 0.87490404E-10_JPRB, 0.87528006E-10_JPRB, &
  & 0.87549190E-10_JPRB, 0.87559252E-10_JPRB, 0.87562457E-10_JPRB, 0.87561999E-10_JPRB, 0.87560112E-10_JPRB, 0.87557628E-10_JPRB, &
  & 0.87554949E-10_JPRB, 0.87551862E-10_JPRB, 0.87547927E-10_JPRB, 0.87543091E-10_JPRB, 0.87536769E-10_JPRB, 0.87529692E-10_JPRB, &
  & 0.87522059E-10_JPRB, 0.87514204E-10_JPRB, 0.87505177E-10_JPRB, 0.87488905E-10_JPRB /)

RGHG9(:,60, 1) = (/ &
  & 0.87312754E-10_JPRB, 0.87325272E-10_JPRB, 0.87328908E-10_JPRB, 0.87325688E-10_JPRB, 0.87314246E-10_JPRB, 0.87297364E-10_JPRB, &
  & 0.87281737E-10_JPRB, 0.87271107E-10_JPRB, 0.87264709E-10_JPRB, 0.87260386E-10_JPRB, 0.87257042E-10_JPRB, 0.87253732E-10_JPRB, &
  & 0.87249839E-10_JPRB, 0.87243587E-10_JPRB, 0.87233665E-10_JPRB, 0.87212633E-10_JPRB, 0.87177390E-10_JPRB, 0.87135875E-10_JPRB, &
  & 0.87125980E-10_JPRB, 0.87163575E-10_JPRB, 0.87242241E-10_JPRB, 0.87351328E-10_JPRB, 0.87478455E-10_JPRB, 0.87610967E-10_JPRB, &
  & 0.87737109E-10_JPRB, 0.87846348E-10_JPRB, 0.87932051E-10_JPRB, 0.87990851E-10_JPRB, 0.88023609E-10_JPRB, 0.88032290E-10_JPRB, &
  & 0.88018842E-10_JPRB, 0.87984696E-10_JPRB, 0.87931551E-10_JPRB, 0.87863723E-10_JPRB, 0.87788166E-10_JPRB, 0.87711248E-10_JPRB, &
  & 0.87636461E-10_JPRB, 0.87564948E-10_JPRB, 0.87496649E-10_JPRB, 0.87434088E-10_JPRB, 0.87382296E-10_JPRB, 0.87350550E-10_JPRB, &
  & 0.87348538E-10_JPRB, 0.87380006E-10_JPRB, 0.87437217E-10_JPRB, 0.87500479E-10_JPRB, 0.87554498E-10_JPRB, 0.87589755E-10_JPRB, &
  & 0.87609225E-10_JPRB, 0.87617379E-10_JPRB, 0.87619384E-10_JPRB, 0.87618190E-10_JPRB, 0.87615845E-10_JPRB, 0.87613250E-10_JPRB, &
  & 0.87610461E-10_JPRB, 0.87607310E-10_JPRB, 0.87603660E-10_JPRB, 0.87598880E-10_JPRB, 0.87593252E-10_JPRB, 0.87586591E-10_JPRB, &
  & 0.87579714E-10_JPRB, 0.87572616E-10_JPRB, 0.87564511E-10_JPRB, 0.87550737E-10_JPRB /)

RGHG9(:,61, 1) = (/ &
  & 0.87395341E-10_JPRB, 0.87405458E-10_JPRB, 0.87404847E-10_JPRB, 0.87398574E-10_JPRB, 0.87387056E-10_JPRB, 0.87369917E-10_JPRB, &
  & 0.87354485E-10_JPRB, 0.87344243E-10_JPRB, 0.87338081E-10_JPRB, 0.87334390E-10_JPRB, 0.87331753E-10_JPRB, 0.87329359E-10_JPRB, &
  & 0.87326188E-10_JPRB, 0.87321206E-10_JPRB, 0.87310992E-10_JPRB, 0.87291702E-10_JPRB, 0.87256730E-10_JPRB, 0.87219419E-10_JPRB, &
  & 0.87210385E-10_JPRB, 0.87243907E-10_JPRB, 0.87316362E-10_JPRB, 0.87418600E-10_JPRB, 0.87538483E-10_JPRB, 0.87664001E-10_JPRB, &
  & 0.87782927E-10_JPRB, 0.87885768E-10_JPRB, 0.87965538E-10_JPRB, 0.88020244E-10_JPRB, 0.88049873E-10_JPRB, 0.88056874E-10_JPRB, &
  & 0.88042858E-10_JPRB, 0.88008940E-10_JPRB, 0.87956767E-10_JPRB, 0.87890334E-10_JPRB, 0.87816678E-10_JPRB, 0.87741592E-10_JPRB, &
  & 0.87669309E-10_JPRB, 0.87600094E-10_JPRB, 0.87535389E-10_JPRB, 0.87477081E-10_JPRB, 0.87431069E-10_JPRB, 0.87405354E-10_JPRB, &
  & 0.87408296E-10_JPRB, 0.87442296E-10_JPRB, 0.87498751E-10_JPRB, 0.87561403E-10_JPRB, 0.87613083E-10_JPRB, 0.87647348E-10_JPRB, &
  & 0.87665000E-10_JPRB, 0.87671620E-10_JPRB, 0.87672224E-10_JPRB, 0.87670017E-10_JPRB, 0.87667054E-10_JPRB, 0.87663939E-10_JPRB, &
  & 0.87660816E-10_JPRB, 0.87657458E-10_JPRB, 0.87653426E-10_JPRB, 0.87648722E-10_JPRB, 0.87642865E-10_JPRB, 0.87636454E-10_JPRB, &
  & 0.87629647E-10_JPRB, 0.87622735E-10_JPRB, 0.87614901E-10_JPRB, 0.87601093E-10_JPRB /)

RGHG9(:,62, 1) = (/ &
  & 0.87467658E-10_JPRB, 0.87474153E-10_JPRB, 0.87472210E-10_JPRB, 0.87465854E-10_JPRB, 0.87454197E-10_JPRB, 0.87439105E-10_JPRB, &
  & 0.87424193E-10_JPRB, 0.87413840E-10_JPRB, 0.87408025E-10_JPRB, 0.87404958E-10_JPRB, 0.87403397E-10_JPRB, 0.87402210E-10_JPRB, &
  & 0.87400392E-10_JPRB, 0.87396139E-10_JPRB, 0.87386827E-10_JPRB, 0.87366760E-10_JPRB, 0.87333703E-10_JPRB, 0.87301180E-10_JPRB, &
  & 0.87293534E-10_JPRB, 0.87324009E-10_JPRB, 0.87391004E-10_JPRB, 0.87486456E-10_JPRB, 0.87599185E-10_JPRB, 0.87716910E-10_JPRB, &
  & 0.87828418E-10_JPRB, 0.87924050E-10_JPRB, 0.87998046E-10_JPRB, 0.88048131E-10_JPRB, 0.88075019E-10_JPRB, 0.88080647E-10_JPRB, &
  & 0.88066561E-10_JPRB, 0.88033643E-10_JPRB, 0.87983135E-10_JPRB, 0.87918811E-10_JPRB, 0.87847146E-10_JPRB, 0.87774517E-10_JPRB, &
  & 0.87704073E-10_JPRB, 0.87637682E-10_JPRB, 0.87575794E-10_JPRB, 0.87521775E-10_JPRB, 0.87480648E-10_JPRB, 0.87460192E-10_JPRB, &
  & 0.87467186E-10_JPRB, 0.87502776E-10_JPRB, 0.87558280E-10_JPRB, 0.87618295E-10_JPRB, 0.87668720E-10_JPRB, 0.87701381E-10_JPRB, &
  & 0.87717944E-10_JPRB, 0.87723120E-10_JPRB, 0.87722288E-10_JPRB, 0.87718929E-10_JPRB, 0.87714974E-10_JPRB, 0.87711192E-10_JPRB, &
  & 0.87707459E-10_JPRB, 0.87703483E-10_JPRB, 0.87699133E-10_JPRB, 0.87693797E-10_JPRB, 0.87687746E-10_JPRB, 0.87680904E-10_JPRB, &
  & 0.87673979E-10_JPRB, 0.87666943E-10_JPRB, 0.87659033E-10_JPRB, 0.87645613E-10_JPRB /)

RGHG9(:,63, 1) = (/ &
  & 0.87530719E-10_JPRB, 0.87536769E-10_JPRB, 0.87534688E-10_JPRB, 0.87528575E-10_JPRB, 0.87518756E-10_JPRB, 0.87504878E-10_JPRB, &
  & 0.87491042E-10_JPRB, 0.87480703E-10_JPRB, 0.87474972E-10_JPRB, 0.87472710E-10_JPRB, 0.87472557E-10_JPRB, 0.87473209E-10_JPRB, &
  & 0.87473091E-10_JPRB, 0.87470108E-10_JPRB, 0.87460574E-10_JPRB, 0.87440520E-10_JPRB, 0.87410197E-10_JPRB, 0.87382011E-10_JPRB, &
  & 0.87375995E-10_JPRB, 0.87404084E-10_JPRB, 0.87466069E-10_JPRB, 0.87555088E-10_JPRB, 0.87660004E-10_JPRB, 0.87769944E-10_JPRB, &
  & 0.87873160E-10_JPRB, 0.87961527E-10_JPRB, 0.88029271E-10_JPRB, 0.88074874E-10_JPRB, 0.88098973E-10_JPRB, 0.88103587E-10_JPRB, &
  & 0.88089959E-10_JPRB, 0.88058595E-10_JPRB, 0.88010474E-10_JPRB, 0.87948787E-10_JPRB, 0.87879905E-10_JPRB, 0.87809350E-10_JPRB, &
  & 0.87741536E-10_JPRB, 0.87677136E-10_JPRB, 0.87618392E-10_JPRB, 0.87567932E-10_JPRB, 0.87531246E-10_JPRB, 0.87515238E-10_JPRB, &
  & 0.87525508E-10_JPRB, 0.87561916E-10_JPRB, 0.87615908E-10_JPRB, 0.87673313E-10_JPRB, 0.87721219E-10_JPRB, 0.87752978E-10_JPRB, &
  & 0.87768570E-10_JPRB, 0.87772664E-10_JPRB, 0.87770458E-10_JPRB, 0.87765746E-10_JPRB, 0.87760743E-10_JPRB, 0.87755969E-10_JPRB, &
  & 0.87751403E-10_JPRB, 0.87746740E-10_JPRB, 0.87741446E-10_JPRB, 0.87735548E-10_JPRB, 0.87728616E-10_JPRB, 0.87721275E-10_JPRB, &
  & 0.87713753E-10_JPRB, 0.87706301E-10_JPRB, 0.87697960E-10_JPRB, 0.87683721E-10_JPRB /)

RGHG9(:,64, 1) = (/ &
  & 0.87589311E-10_JPRB, 0.87595271E-10_JPRB, 0.87593710E-10_JPRB, 0.87588603E-10_JPRB, 0.87579853E-10_JPRB, 0.87567981E-10_JPRB, &
  & 0.87554936E-10_JPRB, 0.87544944E-10_JPRB, 0.87539365E-10_JPRB, 0.87538005E-10_JPRB, 0.87539608E-10_JPRB, 0.87542515E-10_JPRB, &
  & 0.87544291E-10_JPRB, 0.87542126E-10_JPRB, 0.87532669E-10_JPRB, 0.87513302E-10_JPRB, 0.87485873E-10_JPRB, 0.87461628E-10_JPRB, &
  & 0.87457215E-10_JPRB, 0.87483541E-10_JPRB, 0.87541030E-10_JPRB, 0.87623353E-10_JPRB, 0.87720733E-10_JPRB, 0.87821861E-10_JPRB, &
  & 0.87916889E-10_JPRB, 0.87997443E-10_JPRB, 0.88058984E-10_JPRB, 0.88099965E-10_JPRB, 0.88121427E-10_JPRB, 0.88125188E-10_JPRB, &
  & 0.88112351E-10_JPRB, 0.88083082E-10_JPRB, 0.88037896E-10_JPRB, 0.87979637E-10_JPRB, 0.87913815E-10_JPRB, 0.87846209E-10_JPRB, &
  & 0.87780540E-10_JPRB, 0.87718714E-10_JPRB, 0.87662579E-10_JPRB, 0.87615554E-10_JPRB, 0.87582670E-10_JPRB, 0.87570326E-10_JPRB, &
  & 0.87583003E-10_JPRB, 0.87619738E-10_JPRB, 0.87671662E-10_JPRB, 0.87725993E-10_JPRB, 0.87771491E-10_JPRB, 0.87801849E-10_JPRB, &
  & 0.87816983E-10_JPRB, 0.87820376E-10_JPRB, 0.87817018E-10_JPRB, 0.87810995E-10_JPRB, 0.87804652E-10_JPRB, 0.87798782E-10_JPRB, &
  & 0.87793169E-10_JPRB, 0.87787382E-10_JPRB, 0.87781254E-10_JPRB, 0.87774135E-10_JPRB, 0.87766377E-10_JPRB, 0.87758030E-10_JPRB, &
  & 0.87749787E-10_JPRB, 0.87741592E-10_JPRB, 0.87732453E-10_JPRB, 0.87716875E-10_JPRB /)

RGHG9(:,65, 1) = (/ &
  & 0.87644822E-10_JPRB, 0.87651150E-10_JPRB, 0.87650193E-10_JPRB, 0.87645946E-10_JPRB, 0.87638619E-10_JPRB, 0.87628085E-10_JPRB, &
  & 0.87616470E-10_JPRB, 0.87606818E-10_JPRB, 0.87602009E-10_JPRB, 0.87601822E-10_JPRB, 0.87605249E-10_JPRB, 0.87610169E-10_JPRB, &
  & 0.87613451E-10_JPRB, 0.87612001E-10_JPRB, 0.87602973E-10_JPRB, 0.87584932E-10_JPRB, 0.87560487E-10_JPRB, 0.87539753E-10_JPRB, &
  & 0.87536950E-10_JPRB, 0.87561812E-10_JPRB, 0.87614957E-10_JPRB, 0.87690813E-10_JPRB, 0.87779811E-10_JPRB, 0.87872307E-10_JPRB, &
  & 0.87958404E-10_JPRB, 0.88031318E-10_JPRB, 0.88086489E-10_JPRB, 0.88123009E-10_JPRB, 0.88141959E-10_JPRB, 0.88145040E-10_JPRB, &
  & 0.88133167E-10_JPRB, 0.88106196E-10_JPRB, 0.88064452E-10_JPRB, 0.88010106E-10_JPRB, 0.87948170E-10_JPRB, 0.87883652E-10_JPRB, &
  & 0.87820889E-10_JPRB, 0.87761506E-10_JPRB, 0.87708202E-10_JPRB, 0.87664327E-10_JPRB, 0.87634788E-10_JPRB, 0.87625379E-10_JPRB, &
  & 0.87639736E-10_JPRB, 0.87675964E-10_JPRB, 0.87725632E-10_JPRB, 0.87776716E-10_JPRB, 0.87819377E-10_JPRB, 0.87848347E-10_JPRB, &
  & 0.87862995E-10_JPRB, 0.87866096E-10_JPRB, 0.87862016E-10_JPRB, 0.87854821E-10_JPRB, 0.87847229E-10_JPRB, 0.87839985E-10_JPRB, &
  & 0.87833088E-10_JPRB, 0.87826191E-10_JPRB, 0.87818607E-10_JPRB, 0.87810495E-10_JPRB, 0.87801461E-10_JPRB, 0.87792135E-10_JPRB, &
  & 0.87782906E-10_JPRB, 0.87773705E-10_JPRB, 0.87763331E-10_JPRB, 0.87745249E-10_JPRB /)

RGHG9(:,66, 1) = (/ &
  & 0.87695448E-10_JPRB, 0.87703775E-10_JPRB, 0.87704038E-10_JPRB, 0.87700992E-10_JPRB, 0.87694900E-10_JPRB, 0.87685886E-10_JPRB, &
  & 0.87675506E-10_JPRB, 0.87667096E-10_JPRB, 0.87663279E-10_JPRB, 0.87664556E-10_JPRB, 0.87669705E-10_JPRB, 0.87676033E-10_JPRB, &
  & 0.87680287E-10_JPRB, 0.87679468E-10_JPRB, 0.87671329E-10_JPRB, 0.87654987E-10_JPRB, 0.87633366E-10_JPRB, 0.87615797E-10_JPRB, &
  & 0.87614527E-10_JPRB, 0.87638036E-10_JPRB, 0.87686927E-10_JPRB, 0.87755921E-10_JPRB, 0.87836724E-10_JPRB, 0.87919907E-10_JPRB, &
  & 0.87997457E-10_JPRB, 0.88062488E-10_JPRB, 0.88111615E-10_JPRB, 0.88143770E-10_JPRB, 0.88160354E-10_JPRB, 0.88162866E-10_JPRB, &
  & 0.88151979E-10_JPRB, 0.88127436E-10_JPRB, 0.88089293E-10_JPRB, 0.88039270E-10_JPRB, 0.87981643E-10_JPRB, 0.87921004E-10_JPRB, &
  & 0.87861426E-10_JPRB, 0.87805041E-10_JPRB, 0.87754755E-10_JPRB, 0.87713913E-10_JPRB, 0.87687434E-10_JPRB, 0.87680349E-10_JPRB, &
  & 0.87695531E-10_JPRB, 0.87730753E-10_JPRB, 0.87777605E-10_JPRB, 0.87825414E-10_JPRB, 0.87865278E-10_JPRB, 0.87892429E-10_JPRB, &
  & 0.87906522E-10_JPRB, 0.87909569E-10_JPRB, 0.87905239E-10_JPRB, 0.87897321E-10_JPRB, 0.87888488E-10_JPRB, 0.87880078E-10_JPRB, &
  & 0.87871863E-10_JPRB, 0.87863432E-10_JPRB, 0.87854765E-10_JPRB, 0.87845127E-10_JPRB, 0.87835073E-10_JPRB, 0.87824650E-10_JPRB, &
  & 0.87814298E-10_JPRB, 0.87803965E-10_JPRB, 0.87791635E-10_JPRB, 0.87770034E-10_JPRB /)

RGHG9(:,67, 1) = (/ &
  & 0.87744936E-10_JPRB, 0.87754706E-10_JPRB, 0.87755928E-10_JPRB, 0.87753894E-10_JPRB, 0.87749072E-10_JPRB, 0.87741509E-10_JPRB, &
  & 0.87732627E-10_JPRB, 0.87725660E-10_JPRB, 0.87723377E-10_JPRB, 0.87726229E-10_JPRB, 0.87732668E-10_JPRB, 0.87739933E-10_JPRB, &
  & 0.87744818E-10_JPRB, 0.87744666E-10_JPRB, 0.87737484E-10_JPRB, 0.87722989E-10_JPRB, 0.87703969E-10_JPRB, 0.87689349E-10_JPRB, &
  & 0.87689286E-10_JPRB, 0.87711227E-10_JPRB, 0.87755664E-10_JPRB, 0.87817878E-10_JPRB, 0.87890133E-10_JPRB, 0.87964538E-10_JPRB, &
  & 0.88033296E-10_JPRB, 0.88091076E-10_JPRB, 0.88134208E-10_JPRB, 0.88162457E-10_JPRB, 0.88176792E-10_JPRB, 0.88178742E-10_JPRB, &
  & 0.88168833E-10_JPRB, 0.88146650E-10_JPRB, 0.88112122E-10_JPRB, 0.88066533E-10_JPRB, 0.88013617E-10_JPRB, 0.87957315E-10_JPRB, &
  & 0.87901457E-10_JPRB, 0.87848576E-10_JPRB, 0.87801474E-10_JPRB, 0.87763893E-10_JPRB, 0.87740169E-10_JPRB, 0.87734965E-10_JPRB, &
  & 0.87750418E-10_JPRB, 0.87783933E-10_JPRB, 0.87827828E-10_JPRB, 0.87872119E-10_JPRB, 0.87909083E-10_JPRB, 0.87934438E-10_JPRB, &
  & 0.87947656E-10_JPRB, 0.87950598E-10_JPRB, 0.87946310E-10_JPRB, 0.87938115E-10_JPRB, 0.87928692E-10_JPRB, 0.87919082E-10_JPRB, &
  & 0.87909666E-10_JPRB, 0.87900166E-10_JPRB, 0.87889952E-10_JPRB, 0.87879468E-10_JPRB, 0.87868282E-10_JPRB, 0.87856930E-10_JPRB, &
  & 0.87845731E-10_JPRB, 0.87833615E-10_JPRB, 0.87819189E-10_JPRB, 0.87791510E-10_JPRB /)

RGHG9(:,68, 1) = (/ &
  & 0.87790927E-10_JPRB, 0.87803036E-10_JPRB, 0.87805679E-10_JPRB, 0.87804847E-10_JPRB, 0.87801266E-10_JPRB, 0.87795167E-10_JPRB, &
  & 0.87788096E-10_JPRB, 0.87782850E-10_JPRB, 0.87782268E-10_JPRB, 0.87786570E-10_JPRB, 0.87793918E-10_JPRB, 0.87801724E-10_JPRB, &
  & 0.87806984E-10_JPRB, 0.87807303E-10_JPRB, 0.87801121E-10_JPRB, 0.87788395E-10_JPRB, 0.87771707E-10_JPRB, 0.87759480E-10_JPRB, &
  & 0.87760112E-10_JPRB, 0.87780234E-10_JPRB, 0.87820223E-10_JPRB, 0.87875658E-10_JPRB, 0.87939864E-10_JPRB, 0.88005492E-10_JPRB, &
  & 0.88066360E-10_JPRB, 0.88116910E-10_JPRB, 0.88154740E-10_JPRB, 0.88179200E-10_JPRB, 0.88191544E-10_JPRB, 0.88192981E-10_JPRB, &
  & 0.88183988E-10_JPRB, 0.88164087E-10_JPRB, 0.88133063E-10_JPRB, 0.88091916E-10_JPRB, 0.88043801E-10_JPRB, 0.87992141E-10_JPRB, &
  & 0.87940481E-10_JPRB, 0.87891354E-10_JPRB, 0.87847903E-10_JPRB, 0.87813493E-10_JPRB, 0.87792565E-10_JPRB, 0.87788846E-10_JPRB, &
  & 0.87804118E-10_JPRB, 0.87835635E-10_JPRB, 0.87876144E-10_JPRB, 0.87916986E-10_JPRB, 0.87950980E-10_JPRB, 0.87974336E-10_JPRB, &
  & 0.87986625E-10_JPRB, 0.87989366E-10_JPRB, 0.87985209E-10_JPRB, 0.87977133E-10_JPRB, 0.87967356E-10_JPRB, 0.87957294E-10_JPRB, &
  & 0.87947018E-10_JPRB, 0.87936394E-10_JPRB, 0.87925542E-10_JPRB, 0.87913968E-10_JPRB, 0.87902248E-10_JPRB, 0.87890376E-10_JPRB, &
  & 0.87878066E-10_JPRB, 0.87864924E-10_JPRB, 0.87846876E-10_JPRB, 0.87813035E-10_JPRB /)

RGHG9(:,69, 1) = (/ &
  & 0.87835170E-10_JPRB, 0.87849991E-10_JPRB, 0.87853932E-10_JPRB, 0.87854321E-10_JPRB, 0.87852031E-10_JPRB, 0.87847500E-10_JPRB, &
  & 0.87842199E-10_JPRB, 0.87838986E-10_JPRB, 0.87840089E-10_JPRB, 0.87845557E-10_JPRB, 0.87853488E-10_JPRB, 0.87861426E-10_JPRB, &
  & 0.87866756E-10_JPRB, 0.87867408E-10_JPRB, 0.87862002E-10_JPRB, 0.87850956E-10_JPRB, 0.87836134E-10_JPRB, 0.87825927E-10_JPRB, &
  & 0.87826760E-10_JPRB, 0.87844787E-10_JPRB, 0.87880224E-10_JPRB, 0.87929219E-10_JPRB, 0.87985619E-10_JPRB, 0.88043378E-10_JPRB, &
  & 0.88096405E-10_JPRB, 0.88140648E-10_JPRB, 0.88173323E-10_JPRB, 0.88194466E-10_JPRB, 0.88204936E-10_JPRB, 0.88205929E-10_JPRB, &
  & 0.88197817E-10_JPRB, 0.88180033E-10_JPRB, 0.88152416E-10_JPRB, 0.88115661E-10_JPRB, 0.88072313E-10_JPRB, 0.88025517E-10_JPRB, &
  & 0.87978222E-10_JPRB, 0.87933223E-10_JPRB, 0.87893449E-10_JPRB, 0.87862516E-10_JPRB, 0.87844169E-10_JPRB, 0.87841789E-10_JPRB, &
  & 0.87856653E-10_JPRB, 0.87885921E-10_JPRB, 0.87923002E-10_JPRB, 0.87960174E-10_JPRB, 0.87991184E-10_JPRB, 0.88012500E-10_JPRB, &
  & 0.88023727E-10_JPRB, 0.88026204E-10_JPRB, 0.88022215E-10_JPRB, 0.88014436E-10_JPRB, 0.88004819E-10_JPRB, 0.87994584E-10_JPRB, &
  & 0.87983960E-10_JPRB, 0.87973004E-10_JPRB, 0.87961465E-10_JPRB, 0.87949696E-10_JPRB, 0.87937671E-10_JPRB, 0.87925459E-10_JPRB, &
  & 0.87912920E-10_JPRB, 0.87898050E-10_JPRB, 0.87877525E-10_JPRB, 0.87834941E-10_JPRB /)

RGHG9(:,70, 1) = (/ &
  & 0.87877400E-10_JPRB, 0.87895476E-10_JPRB, 0.87901172E-10_JPRB, 0.87902817E-10_JPRB, 0.87901825E-10_JPRB, 0.87898855E-10_JPRB, &
  & 0.87895517E-10_JPRB, 0.87894234E-10_JPRB, 0.87896863E-10_JPRB, 0.87903199E-10_JPRB, 0.87911137E-10_JPRB, 0.87918881E-10_JPRB, &
  & 0.87923932E-10_JPRB, 0.87924654E-10_JPRB, 0.87919949E-10_JPRB, 0.87910200E-10_JPRB, 0.87897079E-10_JPRB, 0.87888162E-10_JPRB, &
  & 0.87888849E-10_JPRB, 0.87904670E-10_JPRB, 0.87935798E-10_JPRB, 0.87978562E-10_JPRB, 0.88027877E-10_JPRB, 0.88077948E-10_JPRB, &
  & 0.88124091E-10_JPRB, 0.88162186E-10_JPRB, 0.88190344E-10_JPRB, 0.88208371E-10_JPRB, 0.88217177E-10_JPRB, 0.88217801E-10_JPRB, &
  & 0.88210522E-10_JPRB, 0.88194799E-10_JPRB, 0.88170443E-10_JPRB, 0.88137948E-10_JPRB, 0.88099403E-10_JPRB, 0.88057429E-10_JPRB, &
  & 0.88014727E-10_JPRB, 0.87973961E-10_JPRB, 0.87938129E-10_JPRB, 0.87910582E-10_JPRB, 0.87894809E-10_JPRB, 0.87893616E-10_JPRB, &
  & 0.87907959E-10_JPRB, 0.87934826E-10_JPRB, 0.87968417E-10_JPRB, 0.88001918E-10_JPRB, 0.88029757E-10_JPRB, 0.88048992E-10_JPRB, &
  & 0.88059129E-10_JPRB, 0.88061329E-10_JPRB, 0.88057582E-10_JPRB, 0.88050268E-10_JPRB, 0.88041088E-10_JPRB, 0.88031214E-10_JPRB, &
  & 0.88020813E-10_JPRB, 0.88009863E-10_JPRB, 0.87998477E-10_JPRB, 0.87986715E-10_JPRB, 0.87974850E-10_JPRB, 0.87962790E-10_JPRB, &
  & 0.87950050E-10_JPRB, 0.87934680E-10_JPRB, 0.87911206E-10_JPRB, 0.87861850E-10_JPRB /)

RGHG9(:,71, 1) = (/ &
  & 0.87918763E-10_JPRB, 0.87940655E-10_JPRB, 0.87947920E-10_JPRB, 0.87950827E-10_JPRB, 0.87951049E-10_JPRB, 0.87949592E-10_JPRB, &
  & 0.87948093E-10_JPRB, 0.87948676E-10_JPRB, 0.87952506E-10_JPRB, 0.87959084E-10_JPRB, 0.87966814E-10_JPRB, 0.87973656E-10_JPRB, &
  & 0.87978250E-10_JPRB, 0.87978846E-10_JPRB, 0.87974593E-10_JPRB, 0.87965892E-10_JPRB, 0.87954262E-10_JPRB, 0.87946338E-10_JPRB, &
  & 0.87946747E-10_JPRB, 0.87960347E-10_JPRB, 0.87987201E-10_JPRB, 0.88024220E-10_JPRB, 0.88066568E-10_JPRB, 0.88109811E-10_JPRB, &
  & 0.88149245E-10_JPRB, 0.88181927E-10_JPRB, 0.88205838E-10_JPRB, 0.88221139E-10_JPRB, 0.88228425E-10_JPRB, 0.88228758E-10_JPRB, &
  & 0.88222311E-10_JPRB, 0.88208565E-10_JPRB, 0.88187319E-10_JPRB, 0.88158980E-10_JPRB, 0.88125097E-10_JPRB, 0.88087961E-10_JPRB, &
  & 0.88049956E-10_JPRB, 0.88013555E-10_JPRB, 0.87981740E-10_JPRB, 0.87957593E-10_JPRB, 0.87944270E-10_JPRB, 0.87944187E-10_JPRB, &
  & 0.87957759E-10_JPRB, 0.87982302E-10_JPRB, 0.88012278E-10_JPRB, 0.88042018E-10_JPRB, 0.88066721E-10_JPRB, 0.88083728E-10_JPRB, &
  & 0.88092762E-10_JPRB, 0.88094726E-10_JPRB, 0.88091298E-10_JPRB, 0.88084672E-10_JPRB, 0.88076144E-10_JPRB, 0.88067179E-10_JPRB, &
  & 0.88057346E-10_JPRB, 0.88047188E-10_JPRB, 0.88036120E-10_JPRB, 0.88024997E-10_JPRB, 0.88013499E-10_JPRB, 0.88001995E-10_JPRB, &
  & 0.87989560E-10_JPRB, 0.87974135E-10_JPRB, 0.87949634E-10_JPRB, 0.87895767E-10_JPRB /)

RGHG9(:,72, 1) = (/ &
  & 0.87960153E-10_JPRB, 0.87985723E-10_JPRB, 0.87994625E-10_JPRB, 0.87998539E-10_JPRB, 0.87999816E-10_JPRB, 0.87999649E-10_JPRB, &
  & 0.87999837E-10_JPRB, 0.88001828E-10_JPRB, 0.88006449E-10_JPRB, 0.88012958E-10_JPRB, 0.88019467E-10_JPRB, 0.88025663E-10_JPRB, &
  & 0.88029285E-10_JPRB, 0.88029639E-10_JPRB, 0.88025739E-10_JPRB, 0.88017850E-10_JPRB, 0.88007629E-10_JPRB, 0.88000392E-10_JPRB, &
  & 0.88000496E-10_JPRB, 0.88011994E-10_JPRB, 0.88034864E-10_JPRB, 0.88066249E-10_JPRB, 0.88102338E-10_JPRB, 0.88138954E-10_JPRB, &
  & 0.88172393E-10_JPRB, 0.88199940E-10_JPRB, 0.88220063E-10_JPRB, 0.88232852E-10_JPRB, 0.88238812E-10_JPRB, 0.88238930E-10_JPRB, &
  & 0.88233261E-10_JPRB, 0.88221479E-10_JPRB, 0.88203195E-10_JPRB, 0.88178929E-10_JPRB, 0.88149467E-10_JPRB, 0.88117257E-10_JPRB, &
  & 0.88083943E-10_JPRB, 0.88052045E-10_JPRB, 0.88024220E-10_JPRB, 0.88003480E-10_JPRB, 0.87992467E-10_JPRB, 0.87993293E-10_JPRB, &
  & 0.88006040E-10_JPRB, 0.88027856E-10_JPRB, 0.88054328E-10_JPRB, 0.88080397E-10_JPRB, 0.88101769E-10_JPRB, 0.88116611E-10_JPRB, &
  & 0.88124577E-10_JPRB, 0.88126277E-10_JPRB, 0.88123245E-10_JPRB, 0.88117361E-10_JPRB, 0.88109992E-10_JPRB, 0.88101880E-10_JPRB, &
  & 0.88093421E-10_JPRB, 0.88083887E-10_JPRB, 0.88074138E-10_JPRB, 0.88063383E-10_JPRB, 0.88053079E-10_JPRB, 0.88042046E-10_JPRB, &
  & 0.88030618E-10_JPRB, 0.88015643E-10_JPRB, 0.87991087E-10_JPRB, 0.87934923E-10_JPRB /)

RGHG9(:,73, 1) = (/ &
  & 0.88006408E-10_JPRB, 0.88032179E-10_JPRB, 0.88041366E-10_JPRB, 0.88045682E-10_JPRB, 0.88047611E-10_JPRB, 0.88048450E-10_JPRB, &
  & 0.88049838E-10_JPRB, 0.88052843E-10_JPRB, 0.88057645E-10_JPRB, 0.88063272E-10_JPRB, 0.88069323E-10_JPRB, 0.88073826E-10_JPRB, &
  & 0.88076921E-10_JPRB, 0.88076907E-10_JPRB, 0.88073174E-10_JPRB, 0.88065992E-10_JPRB, 0.88057034E-10_JPRB, 0.88050574E-10_JPRB, &
  & 0.88050414E-10_JPRB, 0.88059872E-10_JPRB, 0.88078871E-10_JPRB, 0.88105086E-10_JPRB, 0.88135124E-10_JPRB, 0.88165780E-10_JPRB, &
  & 0.88193564E-10_JPRB, 0.88216490E-10_JPRB, 0.88233101E-10_JPRB, 0.88243683E-10_JPRB, 0.88248422E-10_JPRB, 0.88248416E-10_JPRB, &
  & 0.88243524E-10_JPRB, 0.88233587E-10_JPRB, 0.88218183E-10_JPRB, 0.88197762E-10_JPRB, 0.88172664E-10_JPRB, 0.88145199E-10_JPRB, &
  & 0.88116653E-10_JPRB, 0.88089230E-10_JPRB, 0.88065437E-10_JPRB, 0.88047972E-10_JPRB, 0.88039132E-10_JPRB, 0.88040679E-10_JPRB, &
  & 0.88052135E-10_JPRB, 0.88071356E-10_JPRB, 0.88094206E-10_JPRB, 0.88116375E-10_JPRB, 0.88134812E-10_JPRB, 0.88147475E-10_JPRB, &
  & 0.88154255E-10_JPRB, 0.88155802E-10_JPRB, 0.88153249E-10_JPRB, 0.88148280E-10_JPRB, 0.88141813E-10_JPRB, 0.88135277E-10_JPRB, &
  & 0.88127547E-10_JPRB, 0.88119810E-10_JPRB, 0.88110505E-10_JPRB, 0.88101554E-10_JPRB, 0.88091624E-10_JPRB, 0.88082243E-10_JPRB, &
  & 0.88071467E-10_JPRB, 0.88057880E-10_JPRB, 0.88033927E-10_JPRB, 0.87977473E-10_JPRB /)

RGHG9(:,74, 1) = (/ &
  & 0.88052100E-10_JPRB, 0.88078024E-10_JPRB, 0.88086927E-10_JPRB, 0.88091395E-10_JPRB, 0.88093588E-10_JPRB, 0.88094990E-10_JPRB, &
  & 0.88097106E-10_JPRB, 0.88100360E-10_JPRB, 0.88104871E-10_JPRB, 0.88110109E-10_JPRB, 0.88114516E-10_JPRB, 0.88118658E-10_JPRB, &
  & 0.88120698E-10_JPRB, 0.88120372E-10_JPRB, 0.88116861E-10_JPRB, 0.88110332E-10_JPRB, 0.88102532E-10_JPRB, 0.88096870E-10_JPRB, &
  & 0.88096475E-10_JPRB, 0.88104128E-10_JPRB, 0.88119519E-10_JPRB, 0.88140807E-10_JPRB, 0.88165371E-10_JPRB, 0.88190441E-10_JPRB, &
  & 0.88213034E-10_JPRB, 0.88231700E-10_JPRB, 0.88245113E-10_JPRB, 0.88253696E-10_JPRB, 0.88257367E-10_JPRB, 0.88257290E-10_JPRB, &
  & 0.88253189E-10_JPRB, 0.88245029E-10_JPRB, 0.88232324E-10_JPRB, 0.88215511E-10_JPRB, 0.88194729E-10_JPRB, 0.88171907E-10_JPRB, &
  & 0.88147989E-10_JPRB, 0.88125118E-10_JPRB, 0.88105169E-10_JPRB, 0.88090923E-10_JPRB, 0.88083998E-10_JPRB, 0.88085976E-10_JPRB, &
  & 0.88096044E-10_JPRB, 0.88112240E-10_JPRB, 0.88131363E-10_JPRB, 0.88150251E-10_JPRB, 0.88165406E-10_JPRB, 0.88176022E-10_JPRB, &
  & 0.88181844E-10_JPRB, 0.88183169E-10_JPRB, 0.88181074E-10_JPRB, 0.88176987E-10_JPRB, 0.88171768E-10_JPRB, 0.88166058E-10_JPRB, &
  & 0.88160021E-10_JPRB, 0.88152902E-10_JPRB, 0.88145630E-10_JPRB, 0.88137136E-10_JPRB, 0.88129309E-10_JPRB, 0.88120525E-10_JPRB, &
  & 0.88111636E-10_JPRB, 0.88099229E-10_JPRB, 0.88076997E-10_JPRB, 0.88022339E-10_JPRB /)

RGHG9(:,75, 1) = (/ &
  & 0.88096835E-10_JPRB, 0.88121822E-10_JPRB, 0.88130538E-10_JPRB, 0.88134722E-10_JPRB, 0.88136901E-10_JPRB, 0.88138483E-10_JPRB, &
  & 0.88140759E-10_JPRB, 0.88143964E-10_JPRB, 0.88148037E-10_JPRB, 0.88152111E-10_JPRB, 0.88156218E-10_JPRB, 0.88158952E-10_JPRB, &
  & 0.88160701E-10_JPRB, 0.88160132E-10_JPRB, 0.88156718E-10_JPRB, 0.88151000E-10_JPRB, 0.88144388E-10_JPRB, 0.88139607E-10_JPRB, &
  & 0.88139038E-10_JPRB, 0.88145019E-10_JPRB, 0.88157086E-10_JPRB, 0.88173864E-10_JPRB, 0.88193293E-10_JPRB, 0.88213215E-10_JPRB, &
  & 0.88231006E-10_JPRB, 0.88245709E-10_JPRB, 0.88256215E-10_JPRB, 0.88263029E-10_JPRB, 0.88265742E-10_JPRB, 0.88265673E-10_JPRB, &
  & 0.88262314E-10_JPRB, 0.88255805E-10_JPRB, 0.88245682E-10_JPRB, 0.88232296E-10_JPRB, 0.88215719E-10_JPRB, 0.88197318E-10_JPRB, &
  & 0.88177979E-10_JPRB, 0.88159570E-10_JPRB, 0.88143416E-10_JPRB, 0.88132168E-10_JPRB, 0.88126929E-10_JPRB, 0.88129101E-10_JPRB, &
  & 0.88137331E-10_JPRB, 0.88150480E-10_JPRB, 0.88166245E-10_JPRB, 0.88181309E-10_JPRB, 0.88193897E-10_JPRB, 0.88202445E-10_JPRB, &
  & 0.88207164E-10_JPRB, 0.88208330E-10_JPRB, 0.88206706E-10_JPRB, 0.88203528E-10_JPRB, 0.88199073E-10_JPRB, 0.88194785E-10_JPRB, &
  & 0.88189456E-10_JPRB, 0.88184085E-10_JPRB, 0.88177542E-10_JPRB, 0.88171220E-10_JPRB, 0.88164268E-10_JPRB, 0.88157454E-10_JPRB, &
  & 0.88149751E-10_JPRB, 0.88139322E-10_JPRB, 0.88119387E-10_JPRB, 0.88068358E-10_JPRB /)

RGHG9(:,76, 1) = (/ &
  & 0.88139419E-10_JPRB, 0.88163754E-10_JPRB, 0.88171484E-10_JPRB, 0.88175300E-10_JPRB, 0.88177160E-10_JPRB, 0.88178569E-10_JPRB, &
  & 0.88180754E-10_JPRB, 0.88183467E-10_JPRB, 0.88186736E-10_JPRB, 0.88190240E-10_JPRB, 0.88192939E-10_JPRB, 0.88195382E-10_JPRB, &
  & 0.88196499E-10_JPRB, 0.88195909E-10_JPRB, 0.88192988E-10_JPRB, 0.88188130E-10_JPRB, 0.88182878E-10_JPRB, 0.88179020E-10_JPRB, &
  & 0.88178298E-10_JPRB, 0.88182836E-10_JPRB, 0.88191822E-10_JPRB, 0.88204485E-10_JPRB, 0.88219126E-10_JPRB, 0.88234260E-10_JPRB, &
  & 0.88247562E-10_JPRB, 0.88258671E-10_JPRB, 0.88266519E-10_JPRB, 0.88271744E-10_JPRB, 0.88273652E-10_JPRB, 0.88273645E-10_JPRB, &
  & 0.88270974E-10_JPRB, 0.88266026E-10_JPRB, 0.88258283E-10_JPRB, 0.88248200E-10_JPRB, 0.88235565E-10_JPRB, 0.88221597E-10_JPRB, &
  & 0.88206532E-10_JPRB, 0.88192516E-10_JPRB, 0.88179908E-10_JPRB, 0.88171567E-10_JPRB, 0.88167758E-10_JPRB, 0.88169833E-10_JPRB, &
  & 0.88176175E-10_JPRB, 0.88186257E-10_JPRB, 0.88198365E-10_JPRB, 0.88210390E-10_JPRB, 0.88219911E-10_JPRB, 0.88226565E-10_JPRB, &
  & 0.88230319E-10_JPRB, 0.88231263E-10_JPRB, 0.88230021E-10_JPRB, 0.88227675E-10_JPRB, 0.88224178E-10_JPRB, 0.88220806E-10_JPRB, &
  & 0.88216746E-10_JPRB, 0.88212333E-10_JPRB, 0.88207545E-10_JPRB, 0.88202501E-10_JPRB, 0.88197505E-10_JPRB, 0.88191933E-10_JPRB, &
  & 0.88186049E-10_JPRB, 0.88177556E-10_JPRB, 0.88160430E-10_JPRB, 0.88114967E-10_JPRB /)

RGHG9(:,77, 1) = (/ &
  & 0.88180532E-10_JPRB, 0.88202612E-10_JPRB, 0.88209433E-10_JPRB, 0.88212597E-10_JPRB, 0.88213999E-10_JPRB, 0.88215026E-10_JPRB, &
  & 0.88216878E-10_JPRB, 0.88218925E-10_JPRB, 0.88221291E-10_JPRB, 0.88223581E-10_JPRB, 0.88225538E-10_JPRB, 0.88226954E-10_JPRB, &
  & 0.88227987E-10_JPRB, 0.88227654E-10_JPRB, 0.88225309E-10_JPRB, 0.88221701E-10_JPRB, 0.88217926E-10_JPRB, 0.88215116E-10_JPRB, &
  & 0.88214290E-10_JPRB, 0.88217544E-10_JPRB, 0.88223817E-10_JPRB, 0.88232630E-10_JPRB, 0.88242837E-10_JPRB, 0.88253571E-10_JPRB, &
  & 0.88262786E-10_JPRB, 0.88270696E-10_JPRB, 0.88276129E-10_JPRB, 0.88279967E-10_JPRB, 0.88281153E-10_JPRB, 0.88281230E-10_JPRB, &
  & 0.88279190E-10_JPRB, 0.88275678E-10_JPRB, 0.88270120E-10_JPRB, 0.88263050E-10_JPRB, 0.88254182E-10_JPRB, 0.88244322E-10_JPRB, &
  & 0.88233490E-10_JPRB, 0.88223553E-10_JPRB, 0.88214366E-10_JPRB, 0.88208670E-10_JPRB, 0.88205998E-10_JPRB, 0.88207830E-10_JPRB, &
  & 0.88212077E-10_JPRB, 0.88219133E-10_JPRB, 0.88228015E-10_JPRB, 0.88236619E-10_JPRB, 0.88243669E-10_JPRB, 0.88248311E-10_JPRB, &
  & 0.88251115E-10_JPRB, 0.88251850E-10_JPRB, 0.88250907E-10_JPRB, 0.88249380E-10_JPRB, 0.88246577E-10_JPRB, 0.88244419E-10_JPRB, &
  & 0.88241234E-10_JPRB, 0.88238215E-10_JPRB, 0.88234670E-10_JPRB, 0.88231422E-10_JPRB, 0.88228001E-10_JPRB, 0.88223977E-10_JPRB, &
  & 0.88219827E-10_JPRB, 0.88213263E-10_JPRB, 0.88199642E-10_JPRB, 0.88160979E-10_JPRB /)

RGHG9(:,78, 1) = (/ &
  & 0.88219328E-10_JPRB, 0.88237244E-10_JPRB, 0.88241851E-10_JPRB, 0.88244301E-10_JPRB, 0.88245175E-10_JPRB, 0.88245772E-10_JPRB, &
  & 0.88247319E-10_JPRB, 0.88248520E-10_JPRB, 0.88249838E-10_JPRB, 0.88251080E-10_JPRB, 0.88251850E-10_JPRB, 0.88252752E-10_JPRB, &
  & 0.88253647E-10_JPRB, 0.88253779E-10_JPRB, 0.88252301E-10_JPRB, 0.88249942E-10_JPRB, 0.88247729E-10_JPRB, 0.88246001E-10_JPRB, &
  & 0.88245224E-10_JPRB, 0.88247534E-10_JPRB, 0.88251434E-10_JPRB, 0.88256978E-10_JPRB, 0.88263313E-10_JPRB, 0.88270252E-10_JPRB, &
  & 0.88276012E-10_JPRB, 0.88281202E-10_JPRB, 0.88284671E-10_JPRB, 0.88287343E-10_JPRB, 0.88287939E-10_JPRB, 0.88288085E-10_JPRB, &
  & 0.88286593E-10_JPRB, 0.88284303E-10_JPRB, 0.88280605E-10_JPRB, 0.88276199E-10_JPRB, 0.88270592E-10_JPRB, 0.88264354E-10_JPRB, &
  & 0.88257249E-10_JPRB, 0.88251018E-10_JPRB, 0.88244689E-10_JPRB, 0.88241282E-10_JPRB, 0.88239395E-10_JPRB, 0.88240762E-10_JPRB, &
  & 0.88243010E-10_JPRB, 0.88247271E-10_JPRB, 0.88253155E-10_JPRB, 0.88259018E-10_JPRB, 0.88263612E-10_JPRB, 0.88266602E-10_JPRB, &
  & 0.88268552E-10_JPRB, 0.88269017E-10_JPRB, 0.88268302E-10_JPRB, 0.88267477E-10_JPRB, 0.88265284E-10_JPRB, 0.88264139E-10_JPRB, &
  & 0.88261877E-10_JPRB, 0.88259976E-10_JPRB, 0.88257693E-10_JPRB, 0.88255882E-10_JPRB, 0.88253946E-10_JPRB, 0.88251323E-10_JPRB, &
  & 0.88248714E-10_JPRB, 0.88244072E-10_JPRB, 0.88234781E-10_JPRB, 0.88206026E-10_JPRB /)

RGHG9(:,79, 1) = (/ &
  & 0.88244363E-10_JPRB, 0.88256492E-10_JPRB, 0.88259060E-10_JPRB, 0.88260690E-10_JPRB, 0.88261225E-10_JPRB, 0.88261572E-10_JPRB, &
  & 0.88263015E-10_JPRB, 0.88263855E-10_JPRB, 0.88264597E-10_JPRB, 0.88265395E-10_JPRB, 0.88265652E-10_JPRB, 0.88266221E-10_JPRB, &
  & 0.88267178E-10_JPRB, 0.88267567E-10_JPRB, 0.88266450E-10_JPRB, 0.88264764E-10_JPRB, 0.88263397E-10_JPRB, 0.88262321E-10_JPRB, &
  & 0.88261544E-10_JPRB, 0.88263438E-10_JPRB, 0.88266151E-10_JPRB, 0.88269940E-10_JPRB, 0.88274221E-10_JPRB, 0.88279196E-10_JPRB, &
  & 0.88283082E-10_JPRB, 0.88286864E-10_JPRB, 0.88289258E-10_JPRB, 0.88291360E-10_JPRB, 0.88291617E-10_JPRB, 0.88291846E-10_JPRB, &
  & 0.88290604E-10_JPRB, 0.88288980E-10_JPRB, 0.88286226E-10_JPRB, 0.88283283E-10_JPRB, 0.88279481E-10_JPRB, 0.88275241E-10_JPRB, &
  & 0.88270093E-10_JPRB, 0.88265853E-10_JPRB, 0.88260968E-10_JPRB, 0.88258734E-10_JPRB, 0.88257179E-10_JPRB, 0.88258310E-10_JPRB, &
  & 0.88259379E-10_JPRB, 0.88262106E-10_JPRB, 0.88266477E-10_JPRB, 0.88270863E-10_JPRB, 0.88274242E-10_JPRB, 0.88276289E-10_JPRB, &
  & 0.88277809E-10_JPRB, 0.88278121E-10_JPRB, 0.88277496E-10_JPRB, 0.88277032E-10_JPRB, 0.88275026E-10_JPRB, 0.88274471E-10_JPRB, &
  & 0.88272570E-10_JPRB, 0.88271244E-10_JPRB, 0.88269558E-10_JPRB, 0.88268566E-10_JPRB, 0.88267400E-10_JPRB, 0.88265471E-10_JPRB, &
  & 0.88263730E-10_JPRB, 0.88260427E-10_JPRB, 0.88254376E-10_JPRB, 0.88234746E-10_JPRB /)

RGHG9(:,80, 1) = (/ &
  & 0.88260899E-10_JPRB, 0.88265791E-10_JPRB, 0.88266547E-10_JPRB, 0.88267782E-10_JPRB, 0.88268115E-10_JPRB, 0.88268309E-10_JPRB, &
  & 0.88269794E-10_JPRB, 0.88270460E-10_JPRB, 0.88271092E-10_JPRB, 0.88271702E-10_JPRB, 0.88271793E-10_JPRB, 0.88272251E-10_JPRB, &
  & 0.88273278E-10_JPRB, 0.88273777E-10_JPRB, 0.88272750E-10_JPRB, 0.88271279E-10_JPRB, 0.88270315E-10_JPRB, 0.88269544E-10_JPRB, &
  & 0.88268753E-10_JPRB, 0.88270558E-10_JPRB, 0.88272709E-10_JPRB, 0.88275755E-10_JPRB, 0.88279078E-10_JPRB, 0.88283166E-10_JPRB, &
  & 0.88286253E-10_JPRB, 0.88289431E-10_JPRB, 0.88291333E-10_JPRB, 0.88293220E-10_JPRB, 0.88293303E-10_JPRB, 0.88293602E-10_JPRB, &
  & 0.88292443E-10_JPRB, 0.88291111E-10_JPRB, 0.88288772E-10_JPRB, 0.88286503E-10_JPRB, 0.88283526E-10_JPRB, 0.88280189E-10_JPRB, &
  & 0.88275921E-10_JPRB, 0.88272598E-10_JPRB, 0.88268282E-10_JPRB, 0.88266609E-10_JPRB, 0.88265166E-10_JPRB, 0.88266193E-10_JPRB, &
  & 0.88266686E-10_JPRB, 0.88268691E-10_JPRB, 0.88272389E-10_JPRB, 0.88276157E-10_JPRB, 0.88278954E-10_JPRB, 0.88280577E-10_JPRB, &
  & 0.88281903E-10_JPRB, 0.88282152E-10_JPRB, 0.88281535E-10_JPRB, 0.88281230E-10_JPRB, 0.88279238E-10_JPRB, 0.88278967E-10_JPRB, &
  & 0.88277170E-10_JPRB, 0.88276081E-10_JPRB, 0.88274638E-10_JPRB, 0.88274027E-10_JPRB, 0.88273187E-10_JPRB, 0.88271543E-10_JPRB, &
  & 0.88270252E-10_JPRB, 0.88267567E-10_JPRB, 0.88263771E-10_JPRB, 0.88253564E-10_JPRB /)

RGHG9(:,81, 1) = (/ &
  & 0.88272230E-10_JPRB, 0.88269718E-10_JPRB, 0.88269697E-10_JPRB, 0.88270773E-10_JPRB, 0.88271029E-10_JPRB, 0.88271189E-10_JPRB, &
  & 0.88272653E-10_JPRB, 0.88273312E-10_JPRB, 0.88273833E-10_JPRB, 0.88274513E-10_JPRB, 0.88274492E-10_JPRB, 0.88274929E-10_JPRB, &
  & 0.88275991E-10_JPRB, 0.88276539E-10_JPRB, 0.88275505E-10_JPRB, 0.88274117E-10_JPRB, 0.88273319E-10_JPRB, 0.88272695E-10_JPRB, &
  & 0.88271897E-10_JPRB, 0.88273638E-10_JPRB, 0.88275609E-10_JPRB, 0.88278246E-10_JPRB, 0.88281202E-10_JPRB, 0.88284914E-10_JPRB, &
  & 0.88287627E-10_JPRB, 0.88290555E-10_JPRB, 0.88292255E-10_JPRB, 0.88294067E-10_JPRB, 0.88294053E-10_JPRB, 0.88294365E-10_JPRB, &
  & 0.88293255E-10_JPRB, 0.88292033E-10_JPRB, 0.88289875E-10_JPRB, 0.88287905E-10_JPRB, 0.88285310E-10_JPRB, 0.88282381E-10_JPRB, &
  & 0.88278516E-10_JPRB, 0.88275567E-10_JPRB, 0.88271508E-10_JPRB, 0.88270100E-10_JPRB, 0.88268719E-10_JPRB, 0.88269697E-10_JPRB, &
  & 0.88269871E-10_JPRB, 0.88271543E-10_JPRB, 0.88274985E-10_JPRB, 0.88278496E-10_JPRB, 0.88281035E-10_JPRB, 0.88282451E-10_JPRB, &
  & 0.88283721E-10_JPRB, 0.88283922E-10_JPRB, 0.88283263E-10_JPRB, 0.88283041E-10_JPRB, 0.88281035E-10_JPRB, 0.88280890E-10_JPRB, &
  & 0.88279120E-10_JPRB, 0.88278142E-10_JPRB, 0.88276775E-10_JPRB, 0.88276331E-10_JPRB, 0.88275692E-10_JPRB, 0.88274152E-10_JPRB, &
  & 0.88273028E-10_JPRB, 0.88270585E-10_JPRB, 0.88267726E-10_JPRB, 0.88266346E-10_JPRB /)

RGHG9(:,82, 1) = (/ &
  & 0.88273146E-10_JPRB, 0.88271043E-10_JPRB, 0.88271085E-10_JPRB, 0.88272209E-10_JPRB, 0.88272445E-10_JPRB, 0.88272535E-10_JPRB, &
  & 0.88274096E-10_JPRB, 0.88274665E-10_JPRB, 0.88275269E-10_JPRB, 0.88275838E-10_JPRB, 0.88275831E-10_JPRB, 0.88276220E-10_JPRB, &
  & 0.88277337E-10_JPRB, 0.88277906E-10_JPRB, 0.88276858E-10_JPRB, 0.88275498E-10_JPRB, 0.88274790E-10_JPRB, 0.88274221E-10_JPRB, &
  & 0.88273389E-10_JPRB, 0.88275186E-10_JPRB, 0.88276969E-10_JPRB, 0.88279509E-10_JPRB, 0.88282208E-10_JPRB, 0.88285768E-10_JPRB, &
  & 0.88288286E-10_JPRB, 0.88291111E-10_JPRB, 0.88292713E-10_JPRB, 0.88294490E-10_JPRB, 0.88294413E-10_JPRB, 0.88294767E-10_JPRB, &
  & 0.88293643E-10_JPRB, 0.88292477E-10_JPRB, 0.88290396E-10_JPRB, 0.88288578E-10_JPRB, 0.88286156E-10_JPRB, 0.88283436E-10_JPRB, &
  & 0.88279800E-10_JPRB, 0.88277011E-10_JPRB, 0.88273146E-10_JPRB, 0.88271834E-10_JPRB, 0.88270474E-10_JPRB, 0.88271432E-10_JPRB, &
  & 0.88271432E-10_JPRB, 0.88272903E-10_JPRB, 0.88276234E-10_JPRB, 0.88279620E-10_JPRB, 0.88282055E-10_JPRB, 0.88283374E-10_JPRB, &
  & 0.88284588E-10_JPRB, 0.88284796E-10_JPRB, 0.88284116E-10_JPRB, 0.88283936E-10_JPRB, 0.88281889E-10_JPRB, 0.88281826E-10_JPRB, &
  & 0.88280050E-10_JPRB, 0.88279134E-10_JPRB, 0.88277795E-10_JPRB, 0.88277448E-10_JPRB, 0.88276900E-10_JPRB, 0.88275443E-10_JPRB, &
  & 0.88274374E-10_JPRB, 0.88271911E-10_JPRB, 0.88269031E-10_JPRB, 0.88267345E-10_JPRB /)

RGHG9(:,83, 1) = (/ &
  & 0.88273777E-10_JPRB, 0.88271813E-10_JPRB, 0.88271862E-10_JPRB, 0.88273007E-10_JPRB, 0.88273236E-10_JPRB, 0.88273326E-10_JPRB, &
  & 0.88274825E-10_JPRB, 0.88275491E-10_JPRB, 0.88275963E-10_JPRB, 0.88276650E-10_JPRB, 0.88276580E-10_JPRB, 0.88277025E-10_JPRB, &
  & 0.88278065E-10_JPRB, 0.88278676E-10_JPRB, 0.88277621E-10_JPRB, 0.88276268E-10_JPRB, 0.88275623E-10_JPRB, 0.88275103E-10_JPRB, &
  & 0.88274256E-10_JPRB, 0.88275984E-10_JPRB, 0.88277795E-10_JPRB, 0.88280126E-10_JPRB, 0.88282777E-10_JPRB, 0.88286205E-10_JPRB, &
  & 0.88288626E-10_JPRB, 0.88291416E-10_JPRB, 0.88292970E-10_JPRB, 0.88294740E-10_JPRB, 0.88294622E-10_JPRB, 0.88294989E-10_JPRB, &
  & 0.88293865E-10_JPRB, 0.88292720E-10_JPRB, 0.88290666E-10_JPRB, 0.88288911E-10_JPRB, 0.88286635E-10_JPRB, 0.88284005E-10_JPRB, &
  & 0.88280529E-10_JPRB, 0.88277857E-10_JPRB, 0.88274076E-10_JPRB, 0.88272820E-10_JPRB, 0.88271487E-10_JPRB, 0.88272403E-10_JPRB, &
  & 0.88272292E-10_JPRB, 0.88273638E-10_JPRB, 0.88276955E-10_JPRB, 0.88280272E-10_JPRB, 0.88282652E-10_JPRB, 0.88283880E-10_JPRB, &
  & 0.88285101E-10_JPRB, 0.88285282E-10_JPRB, 0.88284588E-10_JPRB, 0.88284421E-10_JPRB, 0.88282354E-10_JPRB, 0.88282354E-10_JPRB, &
  & 0.88280550E-10_JPRB, 0.88279675E-10_JPRB, 0.88278364E-10_JPRB, 0.88278065E-10_JPRB, 0.88277573E-10_JPRB, 0.88276143E-10_JPRB, &
  & 0.88275137E-10_JPRB, 0.88272667E-10_JPRB, 0.88269780E-10_JPRB, 0.88268025E-10_JPRB /)

RGHG9(:,84, 1) = (/ &
  & 0.88274235E-10_JPRB, 0.88272313E-10_JPRB, 0.88272355E-10_JPRB, 0.88273507E-10_JPRB, 0.88273722E-10_JPRB, 0.88273749E-10_JPRB, &
  & 0.88275359E-10_JPRB, 0.88275907E-10_JPRB, 0.88276539E-10_JPRB, 0.88277073E-10_JPRB, 0.88277087E-10_JPRB, 0.88277462E-10_JPRB, &
  & 0.88278579E-10_JPRB, 0.88279134E-10_JPRB, 0.88278114E-10_JPRB, 0.88276747E-10_JPRB, 0.88276136E-10_JPRB, 0.88275623E-10_JPRB, &
  & 0.88274769E-10_JPRB, 0.88276580E-10_JPRB, 0.88278204E-10_JPRB, 0.88280584E-10_JPRB, 0.88283068E-10_JPRB, 0.88286496E-10_JPRB, &
  & 0.88288842E-10_JPRB, 0.88291596E-10_JPRB, 0.88293123E-10_JPRB, 0.88294899E-10_JPRB, 0.88294753E-10_JPRB, 0.88295142E-10_JPRB, &
  & 0.88293997E-10_JPRB, 0.88292873E-10_JPRB, 0.88290798E-10_JPRB, 0.88289112E-10_JPRB, 0.88286885E-10_JPRB, 0.88284352E-10_JPRB, &
  & 0.88281001E-10_JPRB, 0.88278329E-10_JPRB, 0.88274714E-10_JPRB, 0.88273437E-10_JPRB, 0.88272133E-10_JPRB, 0.88273014E-10_JPRB, &
  & 0.88272806E-10_JPRB, 0.88274096E-10_JPRB, 0.88277351E-10_JPRB, 0.88280681E-10_JPRB, 0.88283020E-10_JPRB, 0.88284206E-10_JPRB, &
  & 0.88285407E-10_JPRB, 0.88285573E-10_JPRB, 0.88284872E-10_JPRB, 0.88284734E-10_JPRB, 0.88282631E-10_JPRB, 0.88282687E-10_JPRB, &
  & 0.88280841E-10_JPRB, 0.88279994E-10_JPRB, 0.88278683E-10_JPRB, 0.88278440E-10_JPRB, 0.88278003E-10_JPRB, 0.88276594E-10_JPRB, &
  & 0.88275630E-10_JPRB, 0.88273132E-10_JPRB, 0.88270252E-10_JPRB, 0.88268490E-10_JPRB /)

RGHG9(:,85, 1) = (/ &
  & 0.88274534E-10_JPRB, 0.88272639E-10_JPRB, 0.88272653E-10_JPRB, 0.88273833E-10_JPRB, 0.88274055E-10_JPRB, 0.88274124E-10_JPRB, &
  & 0.88275630E-10_JPRB, 0.88276303E-10_JPRB, 0.88276803E-10_JPRB, 0.88277385E-10_JPRB, 0.88277441E-10_JPRB, 0.88277885E-10_JPRB, &
  & 0.88278801E-10_JPRB, 0.88279356E-10_JPRB, 0.88278426E-10_JPRB, 0.88277073E-10_JPRB, 0.88276469E-10_JPRB, 0.88275963E-10_JPRB, &
  & 0.88275109E-10_JPRB, 0.88276837E-10_JPRB, 0.88278558E-10_JPRB, 0.88280765E-10_JPRB, 0.88283290E-10_JPRB, 0.88286663E-10_JPRB, &
  & 0.88288987E-10_JPRB, 0.88291749E-10_JPRB, 0.88293213E-10_JPRB, 0.88295031E-10_JPRB, 0.88294844E-10_JPRB, 0.88295253E-10_JPRB, &
  & 0.88294087E-10_JPRB, 0.88292949E-10_JPRB, 0.88290875E-10_JPRB, 0.88289223E-10_JPRB, 0.88287065E-10_JPRB, 0.88284602E-10_JPRB, &
  & 0.88281320E-10_JPRB, 0.88278732E-10_JPRB, 0.88275068E-10_JPRB, 0.88273881E-10_JPRB, 0.88272535E-10_JPRB, 0.88273423E-10_JPRB, &
  & 0.88273132E-10_JPRB, 0.88274318E-10_JPRB, 0.88277663E-10_JPRB, 0.88280931E-10_JPRB, 0.88283270E-10_JPRB, 0.88284415E-10_JPRB, &
  & 0.88285622E-10_JPRB, 0.88285781E-10_JPRB, 0.88285067E-10_JPRB, 0.88284942E-10_JPRB, 0.88282812E-10_JPRB, 0.88282902E-10_JPRB, &
  & 0.88281028E-10_JPRB, 0.88280196E-10_JPRB, 0.88278891E-10_JPRB, 0.88278683E-10_JPRB, 0.88278287E-10_JPRB, 0.88276893E-10_JPRB, &
  & 0.88275963E-10_JPRB, 0.88273451E-10_JPRB, 0.88270564E-10_JPRB, 0.88268774E-10_JPRB /)

RGHG9(:,86, 1) = (/ &
  & 0.88274749E-10_JPRB, 0.88272854E-10_JPRB, 0.88272861E-10_JPRB, 0.88274055E-10_JPRB, 0.88274270E-10_JPRB, 0.88274332E-10_JPRB, &
  & 0.88275956E-10_JPRB, 0.88276539E-10_JPRB, 0.88277080E-10_JPRB, 0.88277524E-10_JPRB, 0.88277691E-10_JPRB, 0.88278093E-10_JPRB, &
  & 0.88278863E-10_JPRB, 0.88279356E-10_JPRB, 0.88278572E-10_JPRB, 0.88277316E-10_JPRB, 0.88276698E-10_JPRB, 0.88276178E-10_JPRB, &
  & 0.88275311E-10_JPRB, 0.88277080E-10_JPRB, 0.88278662E-10_JPRB, 0.88280945E-10_JPRB, 0.88283353E-10_JPRB, 0.88286801E-10_JPRB, &
  & 0.88289057E-10_JPRB, 0.88291860E-10_JPRB, 0.88293296E-10_JPRB, 0.88295114E-10_JPRB, 0.88294885E-10_JPRB, 0.88295329E-10_JPRB, &
  & 0.88294136E-10_JPRB, 0.88293005E-10_JPRB, 0.88290930E-10_JPRB, 0.88289306E-10_JPRB, 0.88287204E-10_JPRB, 0.88284796E-10_JPRB, &
  & 0.88281556E-10_JPRB, 0.88278961E-10_JPRB, 0.88275283E-10_JPRB, 0.88274062E-10_JPRB, 0.88272709E-10_JPRB, 0.88273708E-10_JPRB, &
  & 0.88273305E-10_JPRB, 0.88274540E-10_JPRB, 0.88277809E-10_JPRB, 0.88281132E-10_JPRB, 0.88283450E-10_JPRB, 0.88284567E-10_JPRB, &
  & 0.88285781E-10_JPRB, 0.88285892E-10_JPRB, 0.88285171E-10_JPRB, 0.88285060E-10_JPRB, 0.88282909E-10_JPRB, 0.88283041E-10_JPRB, &
  & 0.88281132E-10_JPRB, 0.88280314E-10_JPRB, 0.88279009E-10_JPRB, 0.88278829E-10_JPRB, 0.88278475E-10_JPRB, 0.88277094E-10_JPRB, &
  & 0.88276178E-10_JPRB, 0.88273652E-10_JPRB, 0.88270759E-10_JPRB, 0.88268955E-10_JPRB /)

RGHG9(:,87, 1) = (/ &
  & 0.88274853E-10_JPRB, 0.88272979E-10_JPRB, 0.88272958E-10_JPRB, 0.88274194E-10_JPRB, 0.88274429E-10_JPRB, 0.88274638E-10_JPRB, &
  & 0.88276046E-10_JPRB, 0.88276733E-10_JPRB, 0.88277205E-10_JPRB, 0.88277642E-10_JPRB, 0.88277857E-10_JPRB, 0.88278239E-10_JPRB, &
  & 0.88278926E-10_JPRB, 0.88279314E-10_JPRB, 0.88278648E-10_JPRB, 0.88277476E-10_JPRB, 0.88276858E-10_JPRB, 0.88276317E-10_JPRB, &
  & 0.88275443E-10_JPRB, 0.88277177E-10_JPRB, 0.88278780E-10_JPRB, 0.88280966E-10_JPRB, 0.88283381E-10_JPRB, 0.88286871E-10_JPRB, &
  & 0.88289105E-10_JPRB, 0.88291957E-10_JPRB, 0.88293345E-10_JPRB, 0.88295211E-10_JPRB, 0.88294920E-10_JPRB, 0.88295371E-10_JPRB, &
  & 0.88294164E-10_JPRB, 0.88293053E-10_JPRB, 0.88290972E-10_JPRB, 0.88289348E-10_JPRB, 0.88287315E-10_JPRB, 0.88284963E-10_JPRB, &
  & 0.88281688E-10_JPRB, 0.88279203E-10_JPRB, 0.88275283E-10_JPRB, 0.88274242E-10_JPRB, 0.88272736E-10_JPRB, 0.88273895E-10_JPRB, &
  & 0.88273396E-10_JPRB, 0.88274582E-10_JPRB, 0.88277954E-10_JPRB, 0.88281230E-10_JPRB, 0.88283547E-10_JPRB, 0.88284657E-10_JPRB, &
  & 0.88285872E-10_JPRB, 0.88285983E-10_JPRB, 0.88285254E-10_JPRB, 0.88285143E-10_JPRB, 0.88282971E-10_JPRB, 0.88283117E-10_JPRB, &
  & 0.88281195E-10_JPRB, 0.88280369E-10_JPRB, 0.88279092E-10_JPRB, 0.88278912E-10_JPRB, 0.88278579E-10_JPRB, 0.88277240E-10_JPRB, &
  & 0.88276324E-10_JPRB, 0.88273777E-10_JPRB, 0.88270863E-10_JPRB, 0.88269059E-10_JPRB /)

RGHG9(:,88, 1) = (/ &
  & 0.88274915E-10_JPRB, 0.88273076E-10_JPRB, 0.88273049E-10_JPRB, 0.88274284E-10_JPRB, 0.88274527E-10_JPRB, 0.88274651E-10_JPRB, &
  & 0.88276234E-10_JPRB, 0.88276816E-10_JPRB, 0.88277302E-10_JPRB, 0.88277718E-10_JPRB, 0.88277941E-10_JPRB, 0.88278322E-10_JPRB, &
  & 0.88278940E-10_JPRB, 0.88279321E-10_JPRB, 0.88278704E-10_JPRB, 0.88277580E-10_JPRB, 0.88276955E-10_JPRB, 0.88276414E-10_JPRB, &
  & 0.88275519E-10_JPRB, 0.88277233E-10_JPRB, 0.88278836E-10_JPRB, 0.88281021E-10_JPRB, 0.88283394E-10_JPRB, 0.88286947E-10_JPRB, &
  & 0.88289119E-10_JPRB, 0.88292006E-10_JPRB, 0.88293359E-10_JPRB, 0.88295274E-10_JPRB, 0.88294920E-10_JPRB, 0.88295399E-10_JPRB, &
  & 0.88294184E-10_JPRB, 0.88293102E-10_JPRB, 0.88291006E-10_JPRB, 0.88289417E-10_JPRB, 0.88287398E-10_JPRB, 0.88285060E-10_JPRB, &
  & 0.88281764E-10_JPRB, 0.88279307E-10_JPRB, 0.88275248E-10_JPRB, 0.88274318E-10_JPRB, 0.88272702E-10_JPRB, 0.88274034E-10_JPRB, &
  & 0.88273423E-10_JPRB, 0.88274645E-10_JPRB, 0.88278017E-10_JPRB, 0.88281299E-10_JPRB, 0.88283617E-10_JPRB, 0.88284699E-10_JPRB, &
  & 0.88285941E-10_JPRB, 0.88286017E-10_JPRB, 0.88285303E-10_JPRB, 0.88285206E-10_JPRB, 0.88282999E-10_JPRB, 0.88283166E-10_JPRB, &
  & 0.88281216E-10_JPRB, 0.88280397E-10_JPRB, 0.88279120E-10_JPRB, 0.88278974E-10_JPRB, 0.88278662E-10_JPRB, 0.88277309E-10_JPRB, &
  & 0.88276414E-10_JPRB, 0.88273833E-10_JPRB, 0.88270932E-10_JPRB, 0.88269128E-10_JPRB /)

RGHG9(:,89, 1) = (/ &
  & 0.88274894E-10_JPRB, 0.88273167E-10_JPRB, 0.88273076E-10_JPRB, 0.88274332E-10_JPRB, 0.88274568E-10_JPRB, 0.88274679E-10_JPRB, &
  & 0.88276164E-10_JPRB, 0.88276830E-10_JPRB, 0.88277316E-10_JPRB, 0.88277746E-10_JPRB, 0.88277968E-10_JPRB, 0.88278350E-10_JPRB, &
  & 0.88279065E-10_JPRB, 0.88279467E-10_JPRB, 0.88278787E-10_JPRB, 0.88277587E-10_JPRB, 0.88276990E-10_JPRB, 0.88276442E-10_JPRB, &
  & 0.88275512E-10_JPRB, 0.88277302E-10_JPRB, 0.88278843E-10_JPRB, 0.88281028E-10_JPRB, 0.88283388E-10_JPRB, 0.88286968E-10_JPRB, &
  & 0.88289133E-10_JPRB, 0.88292061E-10_JPRB, 0.88293366E-10_JPRB, 0.88295336E-10_JPRB, 0.88294941E-10_JPRB, 0.88295440E-10_JPRB, &
  & 0.88294191E-10_JPRB, 0.88293151E-10_JPRB, 0.88291020E-10_JPRB, 0.88289473E-10_JPRB, 0.88287468E-10_JPRB, 0.88285164E-10_JPRB, &
  & 0.88281778E-10_JPRB, 0.88279418E-10_JPRB, 0.88275165E-10_JPRB, 0.88274374E-10_JPRB, 0.88272667E-10_JPRB, 0.88274131E-10_JPRB, &
  & 0.88273423E-10_JPRB, 0.88274638E-10_JPRB, 0.88278045E-10_JPRB, 0.88281327E-10_JPRB, 0.88283672E-10_JPRB, 0.88284741E-10_JPRB, &
  & 0.88285983E-10_JPRB, 0.88286059E-10_JPRB, 0.88285337E-10_JPRB, 0.88285247E-10_JPRB, 0.88283006E-10_JPRB, 0.88283228E-10_JPRB, &
  & 0.88281257E-10_JPRB, 0.88280432E-10_JPRB, 0.88279120E-10_JPRB, 0.88279009E-10_JPRB, 0.88278725E-10_JPRB, 0.88277358E-10_JPRB, &
  & 0.88276490E-10_JPRB, 0.88273881E-10_JPRB, 0.88270939E-10_JPRB, 0.88269135E-10_JPRB /)

RGHG9(:,90, 1) = (/ &
  & 0.88274804E-10_JPRB, 0.88273201E-10_JPRB, 0.88273062E-10_JPRB, 0.88274367E-10_JPRB, 0.88274540E-10_JPRB, 0.88274429E-10_JPRB, &
  & 0.88276234E-10_JPRB, 0.88276775E-10_JPRB, 0.88277274E-10_JPRB, 0.88277760E-10_JPRB, 0.88277927E-10_JPRB, 0.88278357E-10_JPRB, &
  & 0.88279224E-10_JPRB, 0.88279731E-10_JPRB, 0.88278850E-10_JPRB, 0.88277524E-10_JPRB, 0.88276983E-10_JPRB, 0.88276442E-10_JPRB, &
  & 0.88275401E-10_JPRB, 0.88277323E-10_JPRB, 0.88278850E-10_JPRB, 0.88281042E-10_JPRB, 0.88283374E-10_JPRB, 0.88287017E-10_JPRB, &
  & 0.88289126E-10_JPRB, 0.88292124E-10_JPRB, 0.88293338E-10_JPRB, 0.88295413E-10_JPRB, 0.88294927E-10_JPRB, 0.88295531E-10_JPRB, &
  & 0.88294205E-10_JPRB, 0.88293220E-10_JPRB, 0.88291041E-10_JPRB, 0.88289515E-10_JPRB, 0.88287523E-10_JPRB, 0.88285212E-10_JPRB, &
  & 0.88281736E-10_JPRB, 0.88279467E-10_JPRB, 0.88275054E-10_JPRB, 0.88274416E-10_JPRB, 0.88272605E-10_JPRB, 0.88274214E-10_JPRB, &
  & 0.88273402E-10_JPRB, 0.88274603E-10_JPRB, 0.88278058E-10_JPRB, 0.88281368E-10_JPRB, 0.88283728E-10_JPRB, 0.88284761E-10_JPRB, &
  & 0.88286052E-10_JPRB, 0.88286108E-10_JPRB, 0.88285337E-10_JPRB, 0.88285317E-10_JPRB, 0.88282978E-10_JPRB, 0.88283277E-10_JPRB, &
  & 0.88281223E-10_JPRB, 0.88280439E-10_JPRB, 0.88279113E-10_JPRB, 0.88279051E-10_JPRB, 0.88278773E-10_JPRB, 0.88277372E-10_JPRB, &
  & 0.88276532E-10_JPRB, 0.88273874E-10_JPRB, 0.88270891E-10_JPRB, 0.88269107E-10_JPRB /)

RGHG9(:,91, 1) = (/ &
  & 0.88274645E-10_JPRB, 0.88273298E-10_JPRB, 0.88272945E-10_JPRB, 0.88274464E-10_JPRB, 0.88274589E-10_JPRB, 0.88274089E-10_JPRB, &
  & 0.88276289E-10_JPRB, 0.88276664E-10_JPRB, 0.88277149E-10_JPRB, 0.88278017E-10_JPRB, 0.88277698E-10_JPRB, 0.88278086E-10_JPRB, &
  & 0.88279564E-10_JPRB, 0.88280265E-10_JPRB, 0.88278905E-10_JPRB, 0.88277351E-10_JPRB, 0.88276969E-10_JPRB, 0.88276476E-10_JPRB, &
  & 0.88275137E-10_JPRB, 0.88277365E-10_JPRB, 0.88278822E-10_JPRB, 0.88281028E-10_JPRB, 0.88283290E-10_JPRB, 0.88287114E-10_JPRB, &
  & 0.88289070E-10_JPRB, 0.88292235E-10_JPRB, 0.88293303E-10_JPRB, 0.88295607E-10_JPRB, 0.88294844E-10_JPRB, 0.88295676E-10_JPRB, &
  & 0.88294184E-10_JPRB, 0.88293366E-10_JPRB, 0.88291006E-10_JPRB, 0.88289549E-10_JPRB, 0.88287586E-10_JPRB, 0.88285386E-10_JPRB, &
  & 0.88281493E-10_JPRB, 0.88279585E-10_JPRB, 0.88274756E-10_JPRB, 0.88274471E-10_JPRB, 0.88272369E-10_JPRB, 0.88274374E-10_JPRB, &
  & 0.88273257E-10_JPRB, 0.88274443E-10_JPRB, 0.88278086E-10_JPRB, 0.88281445E-10_JPRB, 0.88283839E-10_JPRB, 0.88284755E-10_JPRB, &
  & 0.88286135E-10_JPRB, 0.88286156E-10_JPRB, 0.88285296E-10_JPRB, 0.88285462E-10_JPRB, 0.88282805E-10_JPRB, 0.88283429E-10_JPRB, &
  & 0.88281146E-10_JPRB, 0.88280473E-10_JPRB, 0.88279037E-10_JPRB, 0.88279058E-10_JPRB, 0.88278843E-10_JPRB, 0.88277323E-10_JPRB, &
  & 0.88276629E-10_JPRB, 0.88273784E-10_JPRB, 0.88270717E-10_JPRB, 0.88269052E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART2',1,ZHOOK_HANDLE)
END SUBROUTINE PART2






SUBROUTINE PART3
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART3',0,ZHOOK_HANDLE)



!-- Month=  2 ------------

RGHG9(:, 1, 2) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.28025969E-44_JPRB, 0.28025969E-44_JPRB, 0.42038954E-44_JPRB, &
  & 0.56051939E-44_JPRB, 0.84077908E-44_JPRB, 0.11210388E-43_JPRB, 0.15414283E-43_JPRB, 0.15414283E-43_JPRB, 0.12611686E-43_JPRB, &
  & 0.14012985E-43_JPRB, 0.11210388E-43_JPRB, 0.98090893E-44_JPRB, 0.84077908E-44_JPRB, 0.70064923E-44_JPRB, 0.70064923E-44_JPRB, &
  & 0.56051939E-44_JPRB, 0.56051939E-44_JPRB, 0.42038954E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 2, 2) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, &
  & 0.28025969E-44_JPRB, 0.84077908E-44_JPRB, 0.21019477E-43_JPRB, 0.46242849E-43_JPRB, 0.86880505E-43_JPRB, 0.14853764E-42_JPRB, &
  & 0.23261555E-42_JPRB, 0.35172591E-42_JPRB, 0.49045446E-42_JPRB, 0.63759080E-42_JPRB, 0.59975574E-42_JPRB, 0.53529601E-42_JPRB, &
  & 0.54370380E-42_JPRB, 0.44000772E-42_JPRB, 0.39937006E-42_JPRB, 0.32790384E-42_JPRB, 0.28866748E-42_JPRB, 0.25783892E-42_JPRB, &
  & 0.22841165E-42_JPRB, 0.19057659E-42_JPRB, 0.14993894E-42_JPRB, 0.10930128E-42_JPRB, 0.75670117E-43_JPRB, 0.50446745E-43_JPRB, &
  & 0.30828566E-43_JPRB, 0.18216880E-43_JPRB, 0.98090893E-44_JPRB, 0.42038954E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 3, 2) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.42038954E-44_JPRB, 0.84077908E-44_JPRB, 0.25223372E-43_JPRB, 0.70064923E-43_JPRB, &
  & 0.16675452E-42_JPRB, 0.43300123E-42_JPRB, 0.93186348E-42_JPRB, 0.21047503E-41_JPRB, 0.40371409E-41_JPRB, 0.70191040E-41_JPRB, &
  & 0.11263637E-40_JPRB, 0.17056605E-40_JPRB, 0.23621688E-40_JPRB, 0.30265244E-40_JPRB, 0.28676172E-40_JPRB, 0.25771280E-40_JPRB, &
  & 0.25872174E-40_JPRB, 0.21118969E-40_JPRB, 0.19022627E-40_JPRB, 0.15648300E-40_JPRB, 0.13711705E-40_JPRB, 0.12283782E-40_JPRB, &
  & 0.10819425E-40_JPRB, 0.90762102E-41_JPRB, 0.71438196E-41_JPRB, 0.52632770E-41_JPRB, 0.36545864E-41_JPRB, 0.24508710E-41_JPRB, &
  & 0.14671595E-41_JPRB, 0.82676609E-42_JPRB, 0.45542200E-42_JPRB, 0.24522723E-42_JPRB, 0.12891946E-42_JPRB, 0.65861028E-43_JPRB, &
  & 0.35032462E-43_JPRB, 0.16815582E-43_JPRB, 0.84077908E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 4, 2) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.42038954E-44_JPRB, 0.11210388E-43_JPRB, &
  & 0.32229865E-43_JPRB, 0.93886997E-43_JPRB, 0.27045060E-42_JPRB, 0.75810247E-42_JPRB, 0.22140516E-41_JPRB, 0.61979431E-41_JPRB, &
  & 0.13997570E-40_JPRB, 0.36126876E-40_JPRB, 0.76452042E-40_JPRB, 0.17956239E-39_JPRB, 0.35336684E-39_JPRB, 0.62767942E-39_JPRB, &
  & 0.10154425E-38_JPRB, 0.15389985E-38_JPRB, 0.21155445E-38_JPRB, 0.26976551E-38_JPRB, 0.25499470E-38_JPRB, 0.22863053E-38_JPRB, &
  & 0.22931843E-38_JPRB, 0.18674670E-38_JPRB, 0.16810215E-38_JPRB, 0.13819633E-38_JPRB, 0.12113805E-38_JPRB, 0.10852146E-38_JPRB, &
  & 0.95830178E-39_JPRB, 0.80721938E-39_JPRB, 0.63896407E-39_JPRB, 0.47194471E-39_JPRB, 0.32746243E-39_JPRB, 0.21933404E-39_JPRB, &
  & 0.13042165E-39_JPRB, 0.73269693E-40_JPRB, 0.40696510E-40_JPRB, 0.22291856E-40_JPRB, 0.11992312E-40_JPRB, 0.63675002E-41_JPRB, &
  & 0.33406955E-41_JPRB, 0.17348075E-41_JPRB, 0.89262712E-42_JPRB, 0.45682330E-42_JPRB, 0.23401684E-42_JPRB, 0.12051167E-42_JPRB, &
  & 0.63058431E-43_JPRB, 0.35032462E-43_JPRB, 0.21019477E-43_JPRB, 0.14012985E-43_JPRB, 0.84077908E-44_JPRB, 0.56051939E-44_JPRB, &
  & 0.42038954E-44_JPRB, 0.42038954E-44_JPRB, 0.28025969E-44_JPRB, 0.28025969E-44_JPRB /)

RGHG9(:, 5, 2) = (/ &
  & 0.21019477E-43_JPRB, 0.26624671E-43_JPRB, 0.28025969E-43_JPRB, 0.29427268E-43_JPRB, 0.35032462E-43_JPRB, 0.44841551E-43_JPRB, &
  & 0.70064923E-43_JPRB, 0.11911037E-42_JPRB, 0.22701035E-42_JPRB, 0.48204667E-42_JPRB, 0.11140323E-41_JPRB, 0.27311307E-41_JPRB, &
  & 0.72867520E-41_JPRB, 0.20435136E-40_JPRB, 0.57635406E-40_JPRB, 0.15776799E-39_JPRB, 0.45047542E-39_JPRB, 0.12240762E-38_JPRB, &
  & 0.26809446E-38_JPRB, 0.67626286E-38_JPRB, 0.13903957E-37_JPRB, 0.32688106E-37_JPRB, 0.64233336E-37_JPRB, 0.11360421E-36_JPRB, &
  & 0.18239375E-36_JPRB, 0.27292160E-36_JPRB, 0.37080523E-36_JPRB, 0.46907823E-36_JPRB, 0.43947061E-36_JPRB, 0.39096644E-36_JPRB, &
  & 0.39189834E-36_JPRB, 0.31772613E-36_JPRB, 0.28634321E-36_JPRB, 0.23608942E-36_JPRB, 0.20772474E-36_JPRB, 0.18722934E-36_JPRB, &
  & 0.16663303E-36_JPRB, 0.14192759E-36_JPRB, 0.11374447E-36_JPRB, 0.85170198E-37_JPRB, 0.59840691E-37_JPRB, 0.40665166E-37_JPRB, &
  & 0.24485734E-37_JPRB, 0.14017173E-37_JPRB, 0.79709836E-38_JPRB, 0.44889643E-38_JPRB, 0.24904787E-38_JPRB, 0.13644107E-38_JPRB, &
  & 0.73684617E-39_JPRB, 0.39194458E-39_JPRB, 0.20522857E-39_JPRB, 0.10607689E-39_JPRB, 0.54427834E-40_JPRB, 0.28003549E-40_JPRB, &
  & 0.14643569E-40_JPRB, 0.79131324E-41_JPRB, 0.44953655E-41_JPRB, 0.27339333E-41_JPRB, 0.18048724E-41_JPRB, 0.12990037E-41_JPRB, &
  & 0.99912581E-42_JPRB, 0.80294402E-42_JPRB, 0.63618950E-42_JPRB, 0.43580382E-42_JPRB /)

RGHG9(:, 6, 2) = (/ &
  & 0.11420582E-40_JPRB, 0.14214772E-40_JPRB, 0.14457196E-40_JPRB, 0.15358231E-40_JPRB, 0.18484528E-40_JPRB, 0.24560558E-40_JPRB, &
  & 0.37449701E-40_JPRB, 0.62146186E-40_JPRB, 0.11506202E-39_JPRB, 0.23671574E-39_JPRB, 0.53068714E-39_JPRB, 0.12577635E-38_JPRB, &
  & 0.32384848E-38_JPRB, 0.87446685E-38_JPRB, 0.23715188E-37_JPRB, 0.62300351E-37_JPRB, 0.16990168E-36_JPRB, 0.44181411E-36_JPRB, &
  & 0.92225223E-36_JPRB, 0.22220330E-35_JPRB, 0.43636802E-35_JPRB, 0.98835700E-35_JPRB, 0.18776875E-34_JPRB, 0.32231501E-34_JPRB, &
  & 0.50276611E-34_JPRB, 0.73369209E-34_JPRB, 0.97389374E-34_JPRB, 0.12136350E-33_JPRB, 0.11190713E-33_JPRB, 0.98290223E-34_JPRB, &
  & 0.98202761E-34_JPRB, 0.79330590E-34_JPRB, 0.71768763E-34_JPRB, 0.59557322E-34_JPRB, 0.52945092E-34_JPRB, 0.48348054E-34_JPRB, &
  & 0.43785661E-34_JPRB, 0.38087317E-34_JPRB, 0.31322347E-34_JPRB, 0.24142438E-34_JPRB, 0.17531518E-34_JPRB, 0.12324031E-34_JPRB, &
  & 0.77014983E-35_JPRB, 0.45836535E-35_JPRB, 0.27160554E-35_JPRB, 0.15946373E-35_JPRB, 0.92250011E-36_JPRB, 0.52641564E-36_JPRB, &
  & 0.29535820E-36_JPRB, 0.16257267E-36_JPRB, 0.87667883E-37_JPRB, 0.46461710E-37_JPRB, 0.24378507E-37_JPRB, 0.12820376E-37_JPRB, &
  & 0.68607208E-38_JPRB, 0.38001351E-38_JPRB, 0.22143571E-38_JPRB, 0.13805761E-38_JPRB, 0.93389536E-39_JPRB, 0.68611777E-39_JPRB, &
  & 0.53992730E-39_JPRB, 0.44380524E-39_JPRB, 0.37037159E-39_JPRB, 0.28433467E-39_JPRB /)

RGHG9(:, 7, 2) = (/ &
  & 0.99716006E-38_JPRB, 0.10637194E-37_JPRB, 0.10776958E-37_JPRB, 0.11624365E-37_JPRB, 0.14008735E-37_JPRB, 0.18474374E-37_JPRB, &
  & 0.27502156E-37_JPRB, 0.44211331E-37_JPRB, 0.78513441E-37_JPRB, 0.15406958E-36_JPRB, 0.32715996E-36_JPRB, 0.73085863E-36_JPRB, &
  & 0.17699195E-35_JPRB, 0.44979412E-35_JPRB, 0.11480466E-34_JPRB, 0.28334393E-34_JPRB, 0.72805069E-34_JPRB, 0.17809222E-33_JPRB, &
  & 0.35015920E-33_JPRB, 0.79413303E-33_JPRB, 0.14749490E-32_JPRB, 0.31698726E-32_JPRB, 0.57511506E-32_JPRB, 0.94773424E-32_JPRB, &
  & 0.14250906E-31_JPRB, 0.20157233E-31_JPRB, 0.26069385E-31_JPRB, 0.31847157E-31_JPRB, 0.28799282E-31_JPRB, 0.24967697E-31_JPRB, &
  & 0.24834293E-31_JPRB, 0.20029564E-31_JPRB, 0.18207752E-31_JPRB, 0.15243868E-31_JPRB, 0.13720886E-31_JPRB, 0.12739613E-31_JPRB, &
  & 0.11778190E-31_JPRB, 0.10514729E-31_JPRB, 0.89203248E-32_JPRB, 0.71329497E-32_JPRB, 0.53979274E-32_JPRB, 0.39709242E-32_JPRB, &
  & 0.25973661E-32_JPRB, 0.16214091E-32_JPRB, 0.10081537E-32_JPRB, 0.62086071E-33_JPRB, 0.37619318E-33_JPRB, 0.22448085E-33_JPRB, &
  & 0.13142160E-33_JPRB, 0.75297840E-34_JPRB, 0.42166354E-34_JPRB, 0.23180506E-34_JPRB, 0.12626768E-34_JPRB, 0.69126156E-35_JPRB, &
  & 0.38660096E-35_JPRB, 0.22447784E-35_JPRB, 0.13729206E-35_JPRB, 0.89793914E-36_JPRB, 0.63454884E-36_JPRB, 0.48398051E-36_JPRB, &
  & 0.39141647E-36_JPRB, 0.32907521E-36_JPRB, 0.27936015E-36_JPRB, 0.22137200E-36_JPRB /)

RGHG9(:, 8, 2) = (/ &
  & 0.77321140E-35_JPRB, 0.78739432E-35_JPRB, 0.78830090E-35_JPRB, 0.84784668E-35_JPRB, 0.10171879E-34_JPRB, 0.13143763E-34_JPRB, &
  & 0.19070318E-34_JPRB, 0.29541625E-34_JPRB, 0.50236272E-34_JPRB, 0.93575371E-34_JPRB, 0.18749270E-33_JPRB, 0.39252190E-33_JPRB, &
  & 0.88851081E-33_JPRB, 0.21106813E-32_JPRB, 0.50384520E-32_JPRB, 0.11608336E-31_JPRB, 0.27964805E-31_JPRB, 0.64374502E-31_JPRB, &
  & 0.11842573E-30_JPRB, 0.25350518E-30_JPRB, 0.44360674E-30_JPRB, 0.90632326E-30_JPRB, 0.15694518E-29_JPRB, 0.24767679E-29_JPRB, &
  & 0.35870426E-29_JPRB, 0.49121140E-29_JPRB, 0.61779458E-29_JPRB, 0.73964602E-29_JPRB, 0.65564952E-29_JPRB, 0.56076102E-29_JPRB, &
  & 0.55503112E-29_JPRB, 0.44695049E-29_JPRB, 0.40832792E-29_JPRB, 0.34465261E-29_JPRB, 0.31434993E-29_JPRB, 0.29687563E-29_JPRB, &
  & 0.28049765E-29_JPRB, 0.25718778E-29_JPRB, 0.22542363E-29_JPRB, 0.18736144E-29_JPRB, 0.14815199E-29_JPRB, 0.11433457E-29_JPRB, &
  & 0.78402920E-30_JPRB, 0.51298968E-30_JPRB, 0.33465285E-30_JPRB, 0.21601825E-30_JPRB, 0.13691380E-30_JPRB, 0.85344446E-31_JPRB, &
  & 0.52122895E-31_JPRB, 0.31128554E-31_JPRB, 0.18167018E-31_JPRB, 0.10419019E-31_JPRB, 0.59344994E-32_JPRB, 0.34076402E-32_JPRB, &
  & 0.20042531E-32_JPRB, 0.12257671E-32_JPRB, 0.78936374E-33_JPRB, 0.54216348E-33_JPRB, 0.40031139E-33_JPRB, 0.31701117E-33_JPRB, &
  & 0.26352120E-33_JPRB, 0.22552355E-33_JPRB, 0.19408674E-33_JPRB, 0.15425341E-33_JPRB /)

RGHG9(:, 9, 2) = (/ &
  & 0.51874176E-32_JPRB, 0.51672748E-32_JPRB, 0.51205202E-32_JPRB, 0.54608273E-32_JPRB, 0.64578368E-32_JPRB, 0.81833002E-32_JPRB, &
  & 0.11543004E-31_JPRB, 0.17272632E-31_JPRB, 0.28137244E-31_JPRB, 0.49881879E-31_JPRB, 0.94464178E-31_JPRB, 0.18560240E-30_JPRB, &
  & 0.39286246E-30_JPRB, 0.87177426E-30_JPRB, 0.19426976E-29_JPRB, 0.41682168E-29_JPRB, 0.94017972E-29_JPRB, 0.20381749E-28_JPRB, &
  & 0.34996564E-28_JPRB, 0.70860789E-28_JPRB, 0.11666837E-27_JPRB, 0.22716529E-27_JPRB, 0.37511853E-27_JPRB, 0.56710625E-27_JPRB, &
  & 0.78923429E-27_JPRB, 0.10454317E-26_JPRB, 0.12777264E-26_JPRB, 0.14964948E-26_JPRB, 0.13001182E-26_JPRB, 0.10964720E-26_JPRB, &
  & 0.10775621E-26_JPRB, 0.86535653E-27_JPRB, 0.79335371E-27_JPRB, 0.67502415E-27_JPRB, 0.62404685E-27_JPRB, 0.60052807E-27_JPRB, &
  & 0.58085383E-27_JPRB, 0.54803747E-27_JPRB, 0.49725908E-27_JPRB, 0.43032001E-27_JPRB, 0.35627022E-27_JPRB, 0.28911073E-27_JPRB, &
  & 0.20800958E-27_JPRB, 0.14261822E-27_JPRB, 0.97649156E-28_JPRB, 0.66051116E-28_JPRB, 0.43778527E-28_JPRB, 0.28506724E-28_JPRB, &
  & 0.18179248E-28_JPRB, 0.11344073E-28_JPRB, 0.69267613E-29_JPRB, 0.41656552E-29_JPRB, 0.24934530E-29_JPRB, 0.15063689E-29_JPRB, &
  & 0.93288887E-30_JPRB, 0.59958581E-30_JPRB, 0.40470098E-30_JPRB, 0.29002394E-30_JPRB, 0.22277515E-30_JPRB, 0.18153832E-30_JPRB, &
  & 0.15444019E-30_JPRB, 0.13425565E-30_JPRB, 0.11644669E-30_JPRB, 0.93264709E-31_JPRB /)

RGHG9(:,10, 2) = (/ &
  & 0.29684509E-29_JPRB, 0.29238882E-29_JPRB, 0.28689281E-29_JPRB, 0.30272004E-29_JPRB, 0.35312354E-29_JPRB, 0.43781297E-29_JPRB, &
  & 0.60172555E-29_JPRB, 0.87032985E-29_JPRB, 0.13613237E-28_JPRB, 0.23013877E-28_JPRB, 0.41285607E-28_JPRB, 0.76309178E-28_JPRB, &
  & 0.15130674E-27_JPRB, 0.31389379E-27_JPRB, 0.65318607E-27_JPRB, 0.13035216E-26_JPRB, 0.27512995E-26_JPRB, 0.56143358E-26_JPRB, &
  & 0.89823832E-26_JPRB, 0.17215361E-25_JPRB, 0.26616931E-25_JPRB, 0.49371291E-25_JPRB, 0.77705474E-25_JPRB, 0.11227206E-24_JPRB, &
  & 0.15009295E-24_JPRB, 0.19198067E-24_JPRB, 0.22780040E-24_JPRB, 0.26064208E-24_JPRB, 0.22201475E-24_JPRB, 0.18445188E-24_JPRB, &
  & 0.17962251E-24_JPRB, 0.14368880E-24_JPRB, 0.13202690E-24_JPRB, 0.11316735E-24_JPRB, 0.10610648E-24_JPRB, 0.10417230E-24_JPRB, &
  & 0.10335744E-24_JPRB, 0.10055893E-24_JPRB, 0.94606387E-25_JPRB, 0.85401687E-25_JPRB, 0.74126708E-25_JPRB, 0.63376845E-25_JPRB, &
  & 0.47924271E-25_JPRB, 0.34499559E-25_JPRB, 0.24824688E-25_JPRB, 0.17626907E-25_JPRB, 0.12228123E-25_JPRB, 0.83297487E-26_JPRB, &
  & 0.55571584E-26_JPRB, 0.36334140E-26_JPRB, 0.23296923E-26_JPRB, 0.14745230E-26_JPRB, 0.92990157E-27_JPRB, 0.59171732E-27_JPRB, &
  & 0.38477601E-27_JPRB, 0.25894740E-27_JPRB, 0.18201679E-27_JPRB, 0.13553542E-27_JPRB, 0.10696605E-27_JPRB, 0.89594640E-28_JPRB, &
  & 0.77404954E-28_JPRB, 0.68131000E-28_JPRB, 0.59734559E-28_JPRB, 0.48095930E-28_JPRB /)

RGHG9(:,11, 2) = (/ &
  & 0.14212882E-26_JPRB, 0.13874769E-26_JPRB, 0.13510934E-26_JPRB, 0.14125816E-26_JPRB, 0.16254633E-26_JPRB, 0.19781538E-26_JPRB, &
  & 0.26525307E-26_JPRB, 0.37188190E-26_JPRB, 0.55983317E-26_JPRB, 0.90479257E-26_JPRB, 0.15425030E-25_JPRB, 0.26904758E-25_JPRB, &
  & 0.50124136E-25_JPRB, 0.97453399E-25_JPRB, 0.18964943E-24_JPRB, 0.35278200E-24_JPRB, 0.69609545E-24_JPRB, 0.13365732E-23_JPRB, &
  & 0.19939254E-23_JPRB, 0.36109209E-23_JPRB, 0.52438345E-23_JPRB, 0.92481162E-23_JPRB, 0.13852031E-22_JPRB, 0.19124013E-22_JPRB, &
  & 0.24530302E-22_JPRB, 0.30275447E-22_JPRB, 0.34843797E-22_JPRB, 0.38892379E-22_JPRB, 0.32468300E-22_JPRB, 0.26548956E-22_JPRB, &
  & 0.25582317E-22_JPRB, 0.20369764E-22_JPRB, 0.18743834E-22_JPRB, 0.16187793E-22_JPRB, 0.15396963E-22_JPRB, 0.15436080E-22_JPRB, &
  & 0.15729178E-22_JPRB, 0.15797970E-22_JPRB, 0.15422429E-22_JPRB, 0.14520672E-22_JPRB, 0.13212761E-22_JPRB, 0.11898280E-22_JPRB, &
  & 0.94728768E-23_JPRB, 0.71725008E-23_JPRB, 0.54391782E-23_JPRB, 0.40610031E-23_JPRB, 0.29549846E-23_JPRB, 0.21093539E-23_JPRB, &
  & 0.14752257E-23_JPRB, 0.10129738E-23_JPRB, 0.68354921E-24_JPRB, 0.45617824E-24_JPRB, 0.30337128E-24_JPRB, 0.20297753E-24_JPRB, &
  & 0.13840733E-24_JPRB, 0.97044954E-25_JPRB, 0.70826539E-25_JPRB, 0.54176551E-25_JPRB, 0.44052797E-25_JPRB, 0.37408253E-25_JPRB, &
  & 0.32855659E-25_JPRB, 0.29194528E-25_JPRB, 0.25779264E-25_JPRB, 0.21029771E-25_JPRB /)

RGHG9(:,12, 2) = (/ &
  & 0.56474666E-24_JPRB, 0.54807758E-24_JPRB, 0.53084472E-24_JPRB, 0.55110099E-24_JPRB, 0.62752564E-24_JPRB, 0.75104158E-24_JPRB, &
  & 0.98537917E-24_JPRB, 0.13415540E-23_JPRB, 0.19480553E-23_JPRB, 0.30169406E-23_JPRB, 0.48980705E-23_JPRB, 0.80845029E-23_JPRB, &
  & 0.14186909E-22_JPRB, 0.25901543E-22_JPRB, 0.47236360E-22_JPRB, 0.82018228E-22_JPRB, 0.15141459E-21_JPRB, 0.27299631E-21_JPRB, &
  & 0.38054625E-21_JPRB, 0.64940958E-21_JPRB, 0.88674044E-21_JPRB, 0.14827745E-20_JPRB, 0.21124192E-20_JPRB, 0.27837447E-20_JPRB, &
  & 0.34237147E-20_JPRB, 0.40715437E-20_JPRB, 0.45382864E-20_JPRB, 0.49327934E-20_JPRB, 0.40309420E-20_JPRB, 0.32397441E-20_JPRB, &
  & 0.30855812E-20_JPRB, 0.24445808E-20_JPRB, 0.22522557E-20_JPRB, 0.19607006E-20_JPRB, 0.18932839E-20_JPRB, 0.19400778E-20_JPRB, &
  & 0.20325815E-20_JPRB, 0.21096626E-20_JPRB, 0.21379321E-20_JPRB, 0.20990778E-20_JPRB, 0.20008784E-20_JPRB, 0.18945926E-20_JPRB, &
  & 0.15898268E-20_JPRB, 0.12691274E-20_JPRB, 0.10160203E-20_JPRB, 0.79994237E-21_JPRB, 0.61167916E-21_JPRB, 0.45861652E-21_JPRB, &
  & 0.33682854E-21_JPRB, 0.24326133E-21_JPRB, 0.17292323E-21_JPRB, 0.12167769E-21_JPRB, 0.85228021E-22_JPRB, 0.59908470E-22_JPRB, &
  & 0.42678120E-22_JPRB, 0.31125252E-22_JPRB, 0.23413827E-22_JPRB, 0.18457203E-22_JPRB, 0.15212492E-22_JPRB, 0.13180088E-22_JPRB, &
  & 0.11659135E-22_JPRB, 0.10453447E-22_JPRB, 0.92926489E-23_JPRB, 0.76076200E-23_JPRB /)

RGHG9(:,13, 2) = (/ &
  & 0.18989968E-21_JPRB, 0.18390069E-21_JPRB, 0.17750991E-21_JPRB, 0.18322986E-21_JPRB, 0.20651704E-21_JPRB, 0.24334218E-21_JPRB, &
  & 0.31226449E-21_JPRB, 0.41313239E-21_JPRB, 0.57869402E-21_JPRB, 0.85890782E-21_JPRB, 0.13284276E-20_JPRB, 0.20760121E-20_JPRB, &
  & 0.34337737E-20_JPRB, 0.58916177E-20_JPRB, 0.10072938E-19_JPRB, 0.16351978E-19_JPRB, 0.28224007E-19_JPRB, 0.47745886E-19_JPRB, &
  & 0.62259487E-19_JPRB, 0.99864494E-19_JPRB, 0.12827993E-18_JPRB, 0.20282571E-18_JPRB, 0.27445832E-18_JPRB, 0.34479607E-18_JPRB, &
  & 0.40591715E-18_JPRB, 0.46422715E-18_JPRB, 0.50007462E-18_JPRB, 0.52818967E-18_JPRB, 0.42191285E-18_JPRB, 0.33293854E-18_JPRB, &
  & 0.31324190E-18_JPRB, 0.24694208E-18_JPRB, 0.22785876E-18_JPRB, 0.20006348E-18_JPRB, 0.19621033E-18_JPRB, 0.20562902E-18_JPRB, &
  & 0.22175247E-18_JPRB, 0.23813235E-18_JPRB, 0.25076464E-18_JPRB, 0.25686884E-18_JPRB, 0.25651396E-18_JPRB, 0.25515229E-18_JPRB, &
  & 0.22585970E-18_JPRB, 0.19055066E-18_JPRB, 0.16142431E-18_JPRB, 0.13430837E-18_JPRB, 0.10828403E-18_JPRB, 0.85487552E-19_JPRB, &
  & 0.66087666E-19_JPRB, 0.50276160E-19_JPRB, 0.37665197E-19_JPRB, 0.27930148E-19_JPRB, 0.20580082E-19_JPRB, 0.15159977E-19_JPRB, &
  & 0.11271506E-19_JPRB, 0.85209119E-20_JPRB, 0.66146903E-20_JPRB, 0.53147594E-20_JPRB, 0.44790578E-20_JPRB, 0.39082236E-20_JPRB, &
  & 0.34973047E-20_JPRB, 0.31481319E-20_JPRB, 0.28081958E-20_JPRB, 0.23008140E-20_JPRB /)

RGHG9(:,14, 2) = (/ &
  & 0.54694604E-19_JPRB, 0.52861387E-19_JPRB, 0.50830187E-19_JPRB, 0.52119804E-19_JPRB, 0.58094613E-19_JPRB, 0.67305586E-19_JPRB, &
  & 0.84426034E-19_JPRB, 0.10844794E-18_JPRB, 0.14650201E-18_JPRB, 0.20834529E-18_JPRB, 0.30694985E-18_JPRB, 0.45432259E-18_JPRB, &
  & 0.70855247E-18_JPRB, 0.11429313E-17_JPRB, 0.18334692E-17_JPRB, 0.27844610E-17_JPRB, 0.44972040E-17_JPRB, 0.71344253E-17_JPRB, &
  & 0.87119721E-17_JPRB, 0.13116782E-16_JPRB, 0.15854604E-16_JPRB, 0.23661592E-16_JPRB, 0.30386288E-16_JPRB, 0.36350336E-16_JPRB, &
  & 0.40909369E-16_JPRB, 0.44908353E-16_JPRB, 0.46668504E-16_JPRB, 0.47813739E-16_JPRB, 0.37285805E-16_JPRB, 0.28868120E-16_JPRB, &
  & 0.26823851E-16_JPRB, 0.21050415E-16_JPRB, 0.19460736E-16_JPRB, 0.17243751E-16_JPRB, 0.17183604E-16_JPRB, 0.18423847E-16_JPRB, &
  & 0.20456193E-16_JPRB, 0.22738992E-16_JPRB, 0.24890948E-16_JPRB, 0.26604451E-16_JPRB, 0.27830138E-16_JPRB, 0.29055966E-16_JPRB, &
  & 0.27138143E-16_JPRB, 0.24231566E-16_JPRB, 0.21746628E-16_JPRB, 0.19167191E-16_JPRB, 0.16341616E-16_JPRB, 0.13631141E-16_JPRB, &
  & 0.11124444E-16_JPRB, 0.89342215E-17_JPRB, 0.70629644E-17_JPRB, 0.55199549E-17_JPRB, 0.42758951E-17_JPRB, 0.32985314E-17_JPRB, &
  & 0.25556591E-17_JPRB, 0.20025646E-17_JPRB, 0.15998711E-17_JPRB, 0.13176768E-17_JPRB, 0.11247824E-17_JPRB, 0.99643624E-18_JPRB, &
  & 0.89559920E-18_JPRB, 0.81128406E-18_JPRB, 0.72423126E-18_JPRB, 0.59096900E-18_JPRB /)

RGHG9(:,15, 2) = (/ &
  & 0.13500469E-16_JPRB, 0.13008722E-16_JPRB, 0.12448303E-16_JPRB, 0.12663388E-16_JPRB, 0.13940483E-16_JPRB, 0.15863390E-16_JPRB, &
  & 0.19436309E-16_JPRB, 0.24230559E-16_JPRB, 0.31564253E-16_JPRB, 0.43009742E-16_JPRB, 0.60368144E-16_JPRB, 0.84641567E-16_JPRB, &
  & 0.12449868E-15_JPRB, 0.18887339E-15_JPRB, 0.28440553E-15_JPRB, 0.40439889E-15_JPRB, 0.61131834E-15_JPRB, 0.90986649E-15_JPRB, &
  & 0.10406962E-14_JPRB, 0.14699660E-14_JPRB, 0.16713599E-14_JPRB, 0.23521675E-14_JPRB, 0.28647561E-14_JPRB, 0.32611353E-14_JPRB, &
  & 0.35044883E-14_JPRB, 0.36885659E-14_JPRB, 0.36925686E-14_JPRB, 0.36656634E-14_JPRB, 0.27883691E-14_JPRB, 0.21172505E-14_JPRB, &
  & 0.19427429E-14_JPRB, 0.15177999E-14_JPRB, 0.14060795E-14_JPRB, 0.12577200E-14_JPRB, 0.12740970E-14_JPRB, 0.13979143E-14_JPRB, &
  & 0.15980184E-14_JPRB, 0.18385943E-14_JPRB, 0.20920793E-14_JPRB, 0.23333015E-14_JPRB, 0.25564528E-14_JPRB, 0.28000603E-14_JPRB, &
  & 0.27573169E-14_JPRB, 0.26060968E-14_JPRB, 0.24786280E-14_JPRB, 0.23163429E-14_JPRB, 0.20935719E-14_JPRB, 0.18502427E-14_JPRB, &
  & 0.15988471E-14_JPRB, 0.13588591E-14_JPRB, 0.11354644E-14_JPRB, 0.93608840E-15_JPRB, 0.76233198E-15_JPRB, 0.61570354E-15_JPRB, &
  & 0.49693279E-15_JPRB, 0.40351403E-15_JPRB, 0.33212702E-15_JPRB, 0.27997787E-15_JPRB, 0.24350802E-15_JPRB, 0.21786785E-15_JPRB, &
  & 0.19783262E-15_JPRB, 0.17960878E-15_JPRB, 0.16095247E-15_JPRB, 0.13035825E-15_JPRB /)

RGHG9(:,16, 2) = (/ &
  & 0.18781029E-15_JPRB, 0.19516802E-15_JPRB, 0.20566414E-15_JPRB, 0.22393614E-15_JPRB, 0.25665961E-15_JPRB, 0.30192624E-15_JPRB, &
  & 0.36502075E-15_JPRB, 0.45207006E-15_JPRB, 0.57523754E-15_JPRB, 0.75099476E-15_JPRB, 0.10024009E-14_JPRB, 0.13453253E-14_JPRB, &
  & 0.18146995E-14_JPRB, 0.26204766E-14_JPRB, 0.36987371E-14_JPRB, 0.47665288E-14_JPRB, 0.68269945E-14_JPRB, 0.95266643E-14_JPRB, &
  & 0.12119535E-13_JPRB, 0.16274938E-13_JPRB, 0.19697184E-13_JPRB, 0.23661708E-13_JPRB, 0.26875383E-13_JPRB, 0.29023977E-13_JPRB, &
  & 0.30095114E-13_JPRB, 0.29652360E-13_JPRB, 0.27393191E-13_JPRB, 0.24883019E-13_JPRB, 0.22837387E-13_JPRB, 0.18939853E-13_JPRB, &
  & 0.14992583E-13_JPRB, 0.12584830E-13_JPRB, 0.11233149E-13_JPRB, 0.10760185E-13_JPRB, 0.11278858E-13_JPRB, 0.12655739E-13_JPRB, &
  & 0.14732270E-13_JPRB, 0.17223507E-13_JPRB, 0.19821098E-13_JPRB, 0.22319726E-13_JPRB, 0.24258094E-13_JPRB, 0.24573828E-13_JPRB, &
  & 0.25246190E-13_JPRB, 0.25738040E-13_JPRB, 0.24994114E-13_JPRB, 0.23055132E-13_JPRB, 0.20715739E-13_JPRB, 0.18334760E-13_JPRB, &
  & 0.15953005E-13_JPRB, 0.13672060E-13_JPRB, 0.11544320E-13_JPRB, 0.96192848E-14_JPRB, 0.79196598E-14_JPRB, 0.64596342E-14_JPRB, &
  & 0.52540268E-14_JPRB, 0.42846874E-14_JPRB, 0.35290192E-14_JPRB, 0.29576696E-14_JPRB, 0.25469936E-14_JPRB, 0.22493674E-14_JPRB, &
  & 0.20106489E-14_JPRB, 0.18132521E-14_JPRB, 0.16041442E-14_JPRB, 0.12942001E-14_JPRB /)

RGHG9(:,17, 2) = (/ &
  & 0.21711328E-14_JPRB, 0.23992818E-14_JPRB, 0.25749636E-14_JPRB, 0.28608275E-14_JPRB, 0.32699732E-14_JPRB, 0.38202922E-14_JPRB, &
  & 0.44902995E-14_JPRB, 0.54742240E-14_JPRB, 0.68533067E-14_JPRB, 0.88168134E-14_JPRB, 0.11232994E-13_JPRB, 0.14321115E-13_JPRB, &
  & 0.18637842E-13_JPRB, 0.25071315E-13_JPRB, 0.32877550E-13_JPRB, 0.42635830E-13_JPRB, 0.56778645E-13_JPRB, 0.72686926E-13_JPRB, &
  & 0.91200220E-13_JPRB, 0.11229531E-12_JPRB, 0.13248772E-12_JPRB, 0.15007651E-12_JPRB, 0.16340808E-12_JPRB, 0.17075194E-12_JPRB, &
  & 0.17043954E-12_JPRB, 0.16323501E-12_JPRB, 0.15059732E-12_JPRB, 0.13119979E-12_JPRB, 0.11070147E-12_JPRB, 0.97673307E-13_JPRB, &
  & 0.83736261E-13_JPRB, 0.74986336E-13_JPRB, 0.69981937E-13_JPRB, 0.69843403E-13_JPRB, 0.74620208E-13_JPRB, 0.84258284E-13_JPRB, &
  & 0.97990843E-13_JPRB, 0.11406661E-12_JPRB, 0.13024079E-12_JPRB, 0.14383904E-12_JPRB, 0.15573457E-12_JPRB, 0.16625121E-12_JPRB, &
  & 0.17006852E-12_JPRB, 0.16550292E-12_JPRB, 0.15518790E-12_JPRB, 0.14303477E-12_JPRB, 0.12912266E-12_JPRB, 0.11463505E-12_JPRB, &
  & 0.10013294E-12_JPRB, 0.86206162E-13_JPRB, 0.73189102E-13_JPRB, 0.61366290E-13_JPRB, 0.50882391E-13_JPRB, 0.41835730E-13_JPRB, &
  & 0.34292908E-13_JPRB, 0.28182438E-13_JPRB, 0.23356319E-13_JPRB, 0.19647107E-13_JPRB, 0.16866535E-13_JPRB, 0.14682259E-13_JPRB, &
  & 0.13016231E-13_JPRB, 0.11553117E-13_JPRB, 0.10147465E-13_JPRB, 0.79893638E-14_JPRB /)

RGHG9(:,18, 2) = (/ &
  & 0.10353163E-13_JPRB, 0.13176323E-13_JPRB, 0.15678375E-13_JPRB, 0.19023964E-13_JPRB, 0.23577608E-13_JPRB, 0.29571218E-13_JPRB, &
  & 0.36608307E-13_JPRB, 0.44602207E-13_JPRB, 0.54024107E-13_JPRB, 0.66955996E-13_JPRB, 0.83277406E-13_JPRB, 0.10263714E-12_JPRB, &
  & 0.12828302E-12_JPRB, 0.16281223E-12_JPRB, 0.20384924E-12_JPRB, 0.25365365E-12_JPRB, 0.31591185E-12_JPRB, 0.38704351E-12_JPRB, &
  & 0.46373766E-12_JPRB, 0.54087973E-12_JPRB, 0.61028971E-12_JPRB, 0.66199579E-12_JPRB, 0.68787163E-12_JPRB, 0.68557811E-12_JPRB, &
  & 0.65813912E-12_JPRB, 0.61028369E-12_JPRB, 0.55033186E-12_JPRB, 0.49502844E-12_JPRB, 0.44278245E-12_JPRB, 0.39028196E-12_JPRB, &
  & 0.35641038E-12_JPRB, 0.33772041E-12_JPRB, 0.33382349E-12_JPRB, 0.34595151E-12_JPRB, 0.37495663E-12_JPRB, 0.42143500E-12_JPRB, &
  & 0.48292604E-12_JPRB, 0.55252536E-12_JPRB, 0.62119683E-12_JPRB, 0.68250429E-12_JPRB, 0.72283477E-12_JPRB, 0.73732578E-12_JPRB, &
  & 0.72759789E-12_JPRB, 0.69839962E-12_JPRB, 0.65600910E-12_JPRB, 0.60235839E-12_JPRB, 0.54285618E-12_JPRB, 0.48217295E-12_JPRB, &
  & 0.42242265E-12_JPRB, 0.36520366E-12_JPRB, 0.31208562E-12_JPRB, 0.26382360E-12_JPRB, 0.22109200E-12_JPRB, 0.18410051E-12_JPRB, &
  & 0.15312542E-12_JPRB, 0.12781869E-12_JPRB, 0.10753911E-12_JPRB, 0.91544380E-13_JPRB, 0.78758031E-13_JPRB, 0.68644932E-13_JPRB, &
  & 0.60400117E-13_JPRB, 0.53482074E-13_JPRB, 0.46467641E-13_JPRB, 0.36240145E-13_JPRB /)

RGHG9(:,19, 2) = (/ &
  & 0.58993053E-13_JPRB, 0.74845681E-13_JPRB, 0.86031280E-13_JPRB, 0.10000692E-12_JPRB, 0.11885317E-12_JPRB, 0.14431406E-12_JPRB, &
  & 0.17793236E-12_JPRB, 0.22040123E-12_JPRB, 0.27045933E-12_JPRB, 0.33116169E-12_JPRB, 0.40568240E-12_JPRB, 0.49230205E-12_JPRB, &
  & 0.59779308E-12_JPRB, 0.72677715E-12_JPRB, 0.87726349E-12_JPRB, 0.10476061E-11_JPRB, 0.12417054E-11_JPRB, 0.14508068E-11_JPRB, &
  & 0.16589180E-11_JPRB, 0.18478699E-11_JPRB, 0.19914073E-11_JPRB, 0.20691884E-11_JPRB, 0.20718234E-11_JPRB, 0.20020656E-11_JPRB, &
  & 0.18722990E-11_JPRB, 0.17132636E-11_JPRB, 0.15500511E-11_JPRB, 0.13968295E-11_JPRB, 0.12765613E-11_JPRB, 0.12074131E-11_JPRB, &
  & 0.11805282E-11_JPRB, 0.11903329E-11_JPRB, 0.12345043E-11_JPRB, 0.13151790E-11_JPRB, 0.14335964E-11_JPRB, 0.15892905E-11_JPRB, &
  & 0.17696197E-11_JPRB, 0.19541725E-11_JPRB, 0.21174082E-11_JPRB, 0.22383946E-11_JPRB, 0.23033780E-11_JPRB, 0.23052497E-11_JPRB, &
  & 0.22464979E-11_JPRB, 0.21339614E-11_JPRB, 0.19822590E-11_JPRB, 0.18075279E-11_JPRB, 0.16252154E-11_JPRB, 0.14433898E-11_JPRB, &
  & 0.12681486E-11_JPRB, 0.11021628E-11_JPRB, 0.94931680E-12_JPRB, 0.81165261E-12_JPRB, 0.68969846E-12_JPRB, 0.58432252E-12_JPRB, &
  & 0.49563191E-12_JPRB, 0.42265713E-12_JPRB, 0.36338391E-12_JPRB, 0.31482456E-12_JPRB, 0.27400188E-12_JPRB, 0.24026029E-12_JPRB, &
  & 0.21250644E-12_JPRB, 0.18802015E-12_JPRB, 0.16306826E-12_JPRB, 0.12712173E-12_JPRB /)

RGHG9(:,20, 2) = (/ &
  & 0.20503500E-12_JPRB, 0.26874656E-12_JPRB, 0.31668472E-12_JPRB, 0.37262912E-12_JPRB, 0.44170239E-12_JPRB, 0.52807883E-12_JPRB, &
  & 0.63515306E-12_JPRB, 0.77033123E-12_JPRB, 0.93591194E-12_JPRB, 0.11312974E-11_JPRB, 0.13619561E-11_JPRB, 0.16242780E-11_JPRB, &
  & 0.19250628E-11_JPRB, 0.22656800E-11_JPRB, 0.26442355E-11_JPRB, 0.30514441E-11_JPRB, 0.34770088E-11_JPRB, 0.39000882E-11_JPRB, &
  & 0.42841733E-11_JPRB, 0.45980242E-11_JPRB, 0.47998246E-11_JPRB, 0.48553761E-11_JPRB, 0.47516674E-11_JPRB, 0.45124156E-11_JPRB, &
  & 0.41843122E-11_JPRB, 0.38168596E-11_JPRB, 0.34822572E-11_JPRB, 0.32310600E-11_JPRB, 0.30957340E-11_JPRB, 0.30695698E-11_JPRB, &
  & 0.31444409E-11_JPRB, 0.33070851E-11_JPRB, 0.35424456E-11_JPRB, 0.38339778E-11_JPRB, 0.41775407E-11_JPRB, 0.45505023E-11_JPRB, &
  & 0.49317620E-11_JPRB, 0.52768089E-11_JPRB, 0.55313974E-11_JPRB, 0.56550446E-11_JPRB, 0.56423785E-11_JPRB, 0.54982204E-11_JPRB, &
  & 0.52451277E-11_JPRB, 0.49074737E-11_JPRB, 0.45220078E-11_JPRB, 0.41115995E-11_JPRB, 0.36976923E-11_JPRB, 0.32921985E-11_JPRB, &
  & 0.29046088E-11_JPRB, 0.25427297E-11_JPRB, 0.22130741E-11_JPRB, 0.19172892E-11_JPRB, 0.16564488E-11_JPRB, 0.14312251E-11_JPRB, &
  & 0.12404700E-11_JPRB, 0.10815741E-11_JPRB, 0.94999074E-12_JPRB, 0.83744117E-12_JPRB, 0.74051393E-12_JPRB, 0.65803157E-12_JPRB, &
  & 0.58717511E-12_JPRB, 0.52172204E-12_JPRB, 0.45656550E-12_JPRB, 0.35446429E-12_JPRB /)

RGHG9(:,21, 2) = (/ &
  & 0.56082038E-12_JPRB, 0.72475825E-12_JPRB, 0.84294757E-12_JPRB, 0.98406493E-12_JPRB, 0.11646908E-11_JPRB, 0.13913422E-11_JPRB, &
  & 0.16653098E-11_JPRB, 0.19864006E-11_JPRB, 0.23687324E-11_JPRB, 0.28128710E-11_JPRB, 0.33202397E-11_JPRB, 0.38832453E-11_JPRB, &
  & 0.45009656E-11_JPRB, 0.51645485E-11_JPRB, 0.58636945E-11_JPRB, 0.65811133E-11_JPRB, 0.72895422E-11_JPRB, 0.79517139E-11_JPRB, &
  & 0.85154375E-11_JPRB, 0.89332977E-11_JPRB, 0.91489680E-11_JPRB, 0.91306919E-11_JPRB, 0.88832266E-11_JPRB, 0.84261244E-11_JPRB, &
  & 0.78553145E-11_JPRB, 0.72698436E-11_JPRB, 0.67698824E-11_JPRB, 0.64507332E-11_JPRB, 0.63515387E-11_JPRB, 0.64898226E-11_JPRB, &
  & 0.68328464E-11_JPRB, 0.73521788E-11_JPRB, 0.79798286E-11_JPRB, 0.86584863E-11_JPRB, 0.93797956E-11_JPRB, 0.10079329E-10_JPRB, &
  & 0.10685194E-10_JPRB, 0.11110029E-10_JPRB, 0.11307771E-10_JPRB, 0.11250625E-10_JPRB, 0.10967886E-10_JPRB, 0.10492474E-10_JPRB, &
  & 0.98788634E-11_JPRB, 0.91695800E-11_JPRB, 0.84093591E-11_JPRB, 0.76328032E-11_JPRB, 0.68658031E-11_JPRB, 0.61295561E-11_JPRB, &
  & 0.54406158E-11_JPRB, 0.48039823E-11_JPRB, 0.42294866E-11_JPRB, 0.37175115E-11_JPRB, 0.32681457E-11_JPRB, 0.28797403E-11_JPRB, &
  & 0.25487494E-11_JPRB, 0.22696250E-11_JPRB, 0.20298565E-11_JPRB, 0.18185497E-11_JPRB, 0.16328252E-11_JPRB, 0.14695721E-11_JPRB, &
  & 0.13228344E-11_JPRB, 0.11881364E-11_JPRB, 0.10392951E-11_JPRB, 0.82566213E-12_JPRB /)

RGHG9(:,22, 2) = (/ &
  & 0.12596122E-11_JPRB, 0.16311683E-11_JPRB, 0.18681725E-11_JPRB, 0.21337021E-11_JPRB, 0.24627566E-11_JPRB, 0.28800664E-11_JPRB, &
  & 0.33961631E-11_JPRB, 0.40005200E-11_JPRB, 0.46876435E-11_JPRB, 0.54656696E-11_JPRB, 0.63305567E-11_JPRB, 0.72683157E-11_JPRB, &
  & 0.82672905E-11_JPRB, 0.93076588E-11_JPRB, 0.10361833E-10_JPRB, 0.11401900E-10_JPRB, 0.12386085E-10_JPRB, 0.13263970E-10_JPRB, &
  & 0.13975936E-10_JPRB, 0.14481383E-10_JPRB, 0.14727351E-10_JPRB, 0.14673684E-10_JPRB, 0.14314214E-10_JPRB, 0.13720657E-10_JPRB, &
  & 0.12967822E-10_JPRB, 0.12224060E-10_JPRB, 0.11628059E-10_JPRB, 0.11304655E-10_JPRB, 0.11333550E-10_JPRB, 0.11741230E-10_JPRB, &
  & 0.12479140E-10_JPRB, 0.13485329E-10_JPRB, 0.14594513E-10_JPRB, 0.15783510E-10_JPRB, 0.16906150E-10_JPRB, 0.17863083E-10_JPRB, &
  & 0.18563984E-10_JPRB, 0.18914002E-10_JPRB, 0.18877431E-10_JPRB, 0.18468328E-10_JPRB, 0.17756843E-10_JPRB, 0.16817455E-10_JPRB, &
  & 0.15731525E-10_JPRB, 0.14552439E-10_JPRB, 0.13338147E-10_JPRB, 0.12123137E-10_JPRB, 0.10944861E-10_JPRB, 0.98297386E-11_JPRB, &
  & 0.87877492E-11_JPRB, 0.78373020E-11_JPRB, 0.69870811E-11_JPRB, 0.62341673E-11_JPRB, 0.55753414E-11_JPRB, 0.50041247E-11_JPRB, &
  & 0.45130796E-11_JPRB, 0.40871516E-11_JPRB, 0.37078973E-11_JPRB, 0.33683121E-11_JPRB, 0.30631730E-11_JPRB, 0.27868224E-11_JPRB, &
  & 0.25338221E-11_JPRB, 0.22845046E-11_JPRB, 0.20280552E-11_JPRB, 0.16114934E-11_JPRB /)

RGHG9(:,23, 2) = (/ &
  & 0.24316827E-11_JPRB, 0.30698959E-11_JPRB, 0.34923442E-11_JPRB, 0.39267227E-11_JPRB, 0.44465009E-11_JPRB, 0.50768907E-11_JPRB, &
  & 0.58414705E-11_JPRB, 0.67488324E-11_JPRB, 0.77714606E-11_JPRB, 0.88992268E-11_JPRB, 0.10126264E-10_JPRB, 0.11429323E-10_JPRB, &
  & 0.12790048E-10_JPRB, 0.14172814E-10_JPRB, 0.15545898E-10_JPRB, 0.16872463E-10_JPRB, 0.18107351E-10_JPRB, 0.19200917E-10_JPRB, &
  & 0.20094751E-10_JPRB, 0.20744800E-10_JPRB, 0.21093004E-10_JPRB, 0.21111408E-10_JPRB, 0.20810268E-10_JPRB, 0.20220539E-10_JPRB, &
  & 0.19469319E-10_JPRB, 0.18719769E-10_JPRB, 0.18131097E-10_JPRB, 0.17872568E-10_JPRB, 0.18058650E-10_JPRB, 0.18728434E-10_JPRB, &
  & 0.19833104E-10_JPRB, 0.21221044E-10_JPRB, 0.22757865E-10_JPRB, 0.24282777E-10_JPRB, 0.25641159E-10_JPRB, 0.26698642E-10_JPRB, &
  & 0.27332431E-10_JPRB, 0.27471810E-10_JPRB, 0.27093624E-10_JPRB, 0.26270836E-10_JPRB, 0.25098115E-10_JPRB, 0.23686945E-10_JPRB, &
  & 0.22132792E-10_JPRB, 0.20496223E-10_JPRB, 0.18834130E-10_JPRB, 0.17190253E-10_JPRB, 0.15606572E-10_JPRB, 0.14110924E-10_JPRB, &
  & 0.12735049E-10_JPRB, 0.11489725E-10_JPRB, 0.10379661E-10_JPRB, 0.94006929E-11_JPRB, 0.85416379E-11_JPRB, 0.77891235E-11_JPRB, &
  & 0.71281045E-11_JPRB, 0.65409215E-11_JPRB, 0.60077247E-11_JPRB, 0.55215294E-11_JPRB, 0.50731507E-11_JPRB, 0.46550168E-11_JPRB, &
  & 0.42569091E-11_JPRB, 0.38708355E-11_JPRB, 0.34356719E-11_JPRB, 0.27822020E-11_JPRB /)

RGHG9(:,24, 2) = (/ &
  & 0.41402203E-11_JPRB, 0.51048783E-11_JPRB, 0.57234482E-11_JPRB, 0.63354296E-11_JPRB, 0.70539807E-11_JPRB, 0.79128050E-11_JPRB, &
  & 0.89173382E-11_JPRB, 0.10079048E-10_JPRB, 0.11397731E-10_JPRB, 0.12832053E-10_JPRB, 0.14370517E-10_JPRB, 0.15985435E-10_JPRB, &
  & 0.17649465E-10_JPRB, 0.19325869E-10_JPRB, 0.20974021E-10_JPRB, 0.22552075E-10_JPRB, 0.24015370E-10_JPRB, 0.25314854E-10_JPRB, &
  & 0.26401379E-10_JPRB, 0.27246936E-10_JPRB, 0.27810939E-10_JPRB, 0.28064731E-10_JPRB, 0.27983602E-10_JPRB, 0.27613909E-10_JPRB, &
  & 0.27062545E-10_JPRB, 0.26475273E-10_JPRB, 0.26021954E-10_JPRB, 0.25879453E-10_JPRB, 0.26186324E-10_JPRB, 0.27007804E-10_JPRB, &
  & 0.28260352E-10_JPRB, 0.29814620E-10_JPRB, 0.31502023E-10_JPRB, 0.33118810E-10_JPRB, 0.34476189E-10_JPRB, 0.35429631E-10_JPRB, &
  & 0.35857848E-10_JPRB, 0.35701837E-10_JPRB, 0.34975169E-10_JPRB, 0.33779694E-10_JPRB, 0.32226888E-10_JPRB, 0.30446642E-10_JPRB, &
  & 0.28524346E-10_JPRB, 0.26516945E-10_JPRB, 0.24483554E-10_JPRB, 0.22478751E-10_JPRB, 0.20548115E-10_JPRB, 0.18748367E-10_JPRB, &
  & 0.17095483E-10_JPRB, 0.15605356E-10_JPRB, 0.14283702E-10_JPRB, 0.13118268E-10_JPRB, 0.12089971E-10_JPRB, 0.11175789E-10_JPRB, &
  & 0.10354858E-10_JPRB, 0.96017439E-11_JPRB, 0.89065838E-11_JPRB, 0.82564632E-11_JPRB, 0.76421820E-11_JPRB, 0.70542292E-11_JPRB, &
  & 0.64844636E-11_JPRB, 0.59077188E-11_JPRB, 0.52879116E-11_JPRB, 0.42938175E-11_JPRB /)

RGHG9(:,25, 2) = (/ &
  & 0.63945533E-11_JPRB, 0.76770916E-11_JPRB, 0.84921705E-11_JPRB, 0.92792675E-11_JPRB, 0.10163698E-10_JPRB, 0.11203637E-10_JPRB, &
  & 0.12422577E-10_JPRB, 0.13786626E-10_JPRB, 0.15308943E-10_JPRB, 0.16971015E-10_JPRB, 0.18733763E-10_JPRB, 0.20573727E-10_JPRB, &
  & 0.22458672E-10_JPRB, 0.24350841E-10_JPRB, 0.26208688E-10_JPRB, 0.27987276E-10_JPRB, 0.29649502E-10_JPRB, 0.31162621E-10_JPRB, &
  & 0.32494070E-10_JPRB, 0.33621189E-10_JPRB, 0.34499945E-10_JPRB, 0.35091516E-10_JPRB, 0.35377153E-10_JPRB, 0.35391527E-10_JPRB, &
  & 0.35203659E-10_JPRB, 0.34916403E-10_JPRB, 0.34708975E-10_JPRB, 0.34707286E-10_JPRB, 0.35090236E-10_JPRB, 0.35897202E-10_JPRB, &
  & 0.37099802E-10_JPRB, 0.38570400E-10_JPRB, 0.40116216E-10_JPRB, 0.41549032E-10_JPRB, 0.42694001E-10_JPRB, 0.43378051E-10_JPRB, &
  & 0.43516094E-10_JPRB, 0.43045949E-10_JPRB, 0.42024977E-10_JPRB, 0.40562890E-10_JPRB, 0.38772395E-10_JPRB, 0.36759852E-10_JPRB, &
  & 0.34601537E-10_JPRB, 0.32352915E-10_JPRB, 0.30065728E-10_JPRB, 0.27794855E-10_JPRB, 0.25614347E-10_JPRB, 0.23578776E-10_JPRB, &
  & 0.21716420E-10_JPRB, 0.20049467E-10_JPRB, 0.18573807E-10_JPRB, 0.17271146E-10_JPRB, 0.16110497E-10_JPRB, 0.15062784E-10_JPRB, &
  & 0.14094093E-10_JPRB, 0.13188249E-10_JPRB, 0.12330123E-10_JPRB, 0.11508214E-10_JPRB, 0.10710491E-10_JPRB, 0.99268415E-11_JPRB, &
  & 0.91499594E-11_JPRB, 0.83664161E-11_JPRB, 0.74943229E-11_JPRB, 0.61370267E-11_JPRB /)

RGHG9(:,26, 2) = (/ &
  & 0.91258633E-11_JPRB, 0.10688592E-10_JPRB, 0.11668449E-10_JPRB, 0.12607759E-10_JPRB, 0.13629315E-10_JPRB, 0.14803648E-10_JPRB, &
  & 0.16161362E-10_JPRB, 0.17678602E-10_JPRB, 0.19331245E-10_JPRB, 0.21134599E-10_JPRB, 0.23043702E-10_JPRB, 0.25032466E-10_JPRB, &
  & 0.27068972E-10_JPRB, 0.29115564E-10_JPRB, 0.31131837E-10_JPRB, 0.33080986E-10_JPRB, 0.34933480E-10_JPRB, 0.36661431E-10_JPRB, &
  & 0.38235300E-10_JPRB, 0.39636693E-10_JPRB, 0.40836685E-10_JPRB, 0.41806517E-10_JPRB, 0.42526357E-10_JPRB, 0.43003691E-10_JPRB, &
  & 0.43256468E-10_JPRB, 0.43354188E-10_JPRB, 0.43423962E-10_JPRB, 0.43601900E-10_JPRB, 0.44006392E-10_JPRB, 0.44704917E-10_JPRB, &
  & 0.45689872E-10_JPRB, 0.46879028E-10_JPRB, 0.48100787E-10_JPRB, 0.49183720E-10_JPRB, 0.49979576E-10_JPRB, 0.50316477E-10_JPRB, &
  & 0.50136877E-10_JPRB, 0.49397347E-10_JPRB, 0.48176726E-10_JPRB, 0.46570699E-10_JPRB, 0.44660088E-10_JPRB, 0.42540971E-10_JPRB, &
  & 0.40274672E-10_JPRB, 0.37896727E-10_JPRB, 0.35455507E-10_JPRB, 0.33024476E-10_JPRB, 0.30683508E-10_JPRB, 0.28491591E-10_JPRB, &
  & 0.26504547E-10_JPRB, 0.24724710E-10_JPRB, 0.23150398E-10_JPRB, 0.21755178E-10_JPRB, 0.20501587E-10_JPRB, 0.19350972E-10_JPRB, &
  & 0.18261705E-10_JPRB, 0.17218274E-10_JPRB, 0.16206174E-10_JPRB, 0.15207984E-10_JPRB, 0.14212996E-10_JPRB, 0.13213739E-10_JPRB, &
  & 0.12206298E-10_JPRB, 0.11176930E-10_JPRB, 0.10046713E-10_JPRB, 0.82603273E-11_JPRB /)

RGHG9(:,27, 2) = (/ &
  & 0.12256492E-10_JPRB, 0.14041003E-10_JPRB, 0.15148671E-10_JPRB, 0.16200820E-10_JPRB, 0.17332408E-10_JPRB, 0.18596879E-10_JPRB, &
  & 0.20031449E-10_JPRB, 0.21629996E-10_JPRB, 0.23357330E-10_JPRB, 0.25214643E-10_JPRB, 0.27207119E-10_JPRB, 0.29274326E-10_JPRB, &
  & 0.31402988E-10_JPRB, 0.33556432E-10_JPRB, 0.35699770E-10_JPRB, 0.37793657E-10_JPRB, 0.39806006E-10_JPRB, 0.41707762E-10_JPRB, &
  & 0.43480924E-10_JPRB, 0.45120688E-10_JPRB, 0.46613047E-10_JPRB, 0.47930576E-10_JPRB, 0.49051391E-10_JPRB, 0.49955231E-10_JPRB, &
  & 0.50642220E-10_JPRB, 0.51136539E-10_JPRB, 0.51506403E-10_JPRB, 0.51857612E-10_JPRB, 0.52278848E-10_JPRB, 0.52845603E-10_JPRB, &
  & 0.53571442E-10_JPRB, 0.54399242E-10_JPRB, 0.55212467E-10_JPRB, 0.55880068E-10_JPRB, 0.56279887E-10_JPRB, 0.56268393E-10_JPRB, &
  & 0.55807838E-10_JPRB, 0.54876801E-10_JPRB, 0.53540394E-10_JPRB, 0.51877769E-10_JPRB, 0.49963995E-10_JPRB, 0.47855338E-10_JPRB, &
  & 0.45586854E-10_JPRB, 0.43184050E-10_JPRB, 0.40694673E-10_JPRB, 0.38186749E-10_JPRB, 0.35747058E-10_JPRB, 0.33477859E-10_JPRB, &
  & 0.31411061E-10_JPRB, 0.29565232E-10_JPRB, 0.27934936E-10_JPRB, 0.26481508E-10_JPRB, 0.25166428E-10_JPRB, 0.23931905E-10_JPRB, &
  & 0.22746961E-10_JPRB, 0.21589589E-10_JPRB, 0.20434786E-10_JPRB, 0.19268961E-10_JPRB, 0.18076105E-10_JPRB, 0.16851753E-10_JPRB, &
  & 0.15603203E-10_JPRB, 0.14325252E-10_JPRB, 0.12914554E-10_JPRB, 0.10691569E-10_JPRB /)

RGHG9(:,28, 2) = (/ &
  & 0.15691547E-10_JPRB, 0.17643245E-10_JPRB, 0.18834996E-10_JPRB, 0.19950687E-10_JPRB, 0.21145273E-10_JPRB, 0.22463148E-10_JPRB, &
  & 0.23934302E-10_JPRB, 0.25557050E-10_JPRB, 0.27310073E-10_JPRB, 0.29177619E-10_JPRB, 0.31172075E-10_JPRB, 0.33282287E-10_JPRB, &
  & 0.35448099E-10_JPRB, 0.37651694E-10_JPRB, 0.39862273E-10_JPRB, 0.42046654E-10_JPRB, 0.44174511E-10_JPRB, 0.46222675E-10_JPRB, &
  & 0.48174069E-10_JPRB, 0.50020071E-10_JPRB, 0.51747922E-10_JPRB, 0.53338875E-10_JPRB, 0.54776239E-10_JPRB, 0.56029448E-10_JPRB, &
  & 0.57082200E-10_JPRB, 0.57918548E-10_JPRB, 0.58571384E-10_JPRB, 0.59086763E-10_JPRB, 0.59538000E-10_JPRB, 0.59989916E-10_JPRB, &
  & 0.60465161E-10_JPRB, 0.60947775E-10_JPRB, 0.61368209E-10_JPRB, 0.61636828E-10_JPRB, 0.61666443E-10_JPRB, 0.61352784E-10_JPRB, &
  & 0.60673438E-10_JPRB, 0.59621745E-10_JPRB, 0.58254568E-10_JPRB, 0.56640102E-10_JPRB, 0.54811967E-10_JPRB, 0.52790050E-10_JPRB, &
  & 0.50594858E-10_JPRB, 0.48246730E-10_JPRB, 0.45773031E-10_JPRB, 0.43256503E-10_JPRB, 0.40797310E-10_JPRB, 0.38482922E-10_JPRB, &
  & 0.36380024E-10_JPRB, 0.34500659E-10_JPRB, 0.32840227E-10_JPRB, 0.31351033E-10_JPRB, 0.29986107E-10_JPRB, 0.28693898E-10_JPRB, &
  & 0.27436295E-10_JPRB, 0.26181751E-10_JPRB, 0.24906995E-10_JPRB, 0.23587120E-10_JPRB, 0.22208541E-10_JPRB, 0.20771154E-10_JPRB, &
  & 0.19295711E-10_JPRB, 0.17782142E-10_JPRB, 0.16135699E-10_JPRB, 0.13469522E-10_JPRB /)

RGHG9(:,29, 2) = (/ &
  & 0.19361858E-10_JPRB, 0.21413786E-10_JPRB, 0.22653313E-10_JPRB, 0.23805435E-10_JPRB, 0.25017636E-10_JPRB, 0.26360608E-10_JPRB, &
  & 0.27831681E-10_JPRB, 0.29440454E-10_JPRB, 0.31166708E-10_JPRB, 0.33014091E-10_JPRB, 0.34960146E-10_JPRB, 0.37036492E-10_JPRB, &
  & 0.39223774E-10_JPRB, 0.41461737E-10_JPRB, 0.43722526E-10_JPRB, 0.45977087E-10_JPRB, 0.48197571E-10_JPRB, 0.50354072E-10_JPRB, &
  & 0.52426483E-10_JPRB, 0.54407805E-10_JPRB, 0.56290590E-10_JPRB, 0.58062190E-10_JPRB, 0.59711833E-10_JPRB, 0.61212438E-10_JPRB, &
  & 0.62529475E-10_JPRB, 0.63624647E-10_JPRB, 0.64491586E-10_JPRB, 0.65147686E-10_JPRB, 0.65636205E-10_JPRB, 0.66007214E-10_JPRB, &
  & 0.66293200E-10_JPRB, 0.66498272E-10_JPRB, 0.66595486E-10_JPRB, 0.66532280E-10_JPRB, 0.66260684E-10_JPRB, 0.65716661E-10_JPRB, &
  & 0.64891981E-10_JPRB, 0.63801561E-10_JPRB, 0.62487820E-10_JPRB, 0.60978479E-10_JPRB, 0.59277964E-10_JPRB, 0.57394544E-10_JPRB, &
  & 0.55327215E-10_JPRB, 0.53080151E-10_JPRB, 0.50688655E-10_JPRB, 0.48219588E-10_JPRB, 0.45773267E-10_JPRB, 0.43463171E-10_JPRB, &
  & 0.41346253E-10_JPRB, 0.39460223E-10_JPRB, 0.37781844E-10_JPRB, 0.36268467E-10_JPRB, 0.34868740E-10_JPRB, 0.33530574E-10_JPRB, &
  & 0.32210984E-10_JPRB, 0.30881388E-10_JPRB, 0.29499056E-10_JPRB, 0.28047571E-10_JPRB, 0.26503804E-10_JPRB, 0.24882509E-10_JPRB, &
  & 0.23214307E-10_JPRB, 0.21543104E-10_JPRB, 0.19679843E-10_JPRB, 0.16711322E-10_JPRB /)

RGHG9(:,30, 2) = (/ &
  & 0.23188489E-10_JPRB, 0.25298751E-10_JPRB, 0.26549506E-10_JPRB, 0.27693920E-10_JPRB, 0.28902809E-10_JPRB, 0.30225503E-10_JPRB, &
  & 0.31677452E-10_JPRB, 0.33247852E-10_JPRB, 0.34923963E-10_JPRB, 0.36713584E-10_JPRB, 0.38614431E-10_JPRB, 0.40618692E-10_JPRB, &
  & 0.42752815E-10_JPRB, 0.44998109E-10_JPRB, 0.47301611E-10_JPRB, 0.49619663E-10_JPRB, 0.51913258E-10_JPRB, 0.54151583E-10_JPRB, &
  & 0.56304537E-10_JPRB, 0.58366617E-10_JPRB, 0.60333884E-10_JPRB, 0.62206483E-10_JPRB, 0.63976595E-10_JPRB, 0.65619774E-10_JPRB, &
  & 0.67095003E-10_JPRB, 0.68344386E-10_JPRB, 0.69352933E-10_JPRB, 0.70103291E-10_JPRB, 0.70624957E-10_JPRB, 0.70948365E-10_JPRB, &
  & 0.71113150E-10_JPRB, 0.71120734E-10_JPRB, 0.70987216E-10_JPRB, 0.70680857E-10_JPRB, 0.70199117E-10_JPRB, 0.69511397E-10_JPRB, &
  & 0.68627867E-10_JPRB, 0.67561234E-10_JPRB, 0.66328186E-10_JPRB, 0.64944175E-10_JPRB, 0.63404004E-10_JPRB, 0.61685483E-10_JPRB, &
  & 0.59772853E-10_JPRB, 0.57660821E-10_JPRB, 0.55377473E-10_JPRB, 0.52993263E-10_JPRB, 0.50610235E-10_JPRB, 0.48325087E-10_JPRB, &
  & 0.46233677E-10_JPRB, 0.44348105E-10_JPRB, 0.42662367E-10_JPRB, 0.41135879E-10_JPRB, 0.39705815E-10_JPRB, 0.38333406E-10_JPRB, &
  & 0.36966485E-10_JPRB, 0.35568243E-10_JPRB, 0.34102401E-10_JPRB, 0.32534878E-10_JPRB, 0.30856661E-10_JPRB, 0.29086407E-10_JPRB, &
  & 0.27306688E-10_JPRB, 0.25514507E-10_JPRB, 0.23613660E-10_JPRB, 0.20381566E-10_JPRB /)

RGHG9(:,31, 2) = (/ &
  & 0.27127602E-10_JPRB, 0.29230403E-10_JPRB, 0.30468388E-10_JPRB, 0.31591285E-10_JPRB, 0.32760000E-10_JPRB, 0.34049506E-10_JPRB, &
  & 0.35460482E-10_JPRB, 0.36977234E-10_JPRB, 0.38591578E-10_JPRB, 0.40297189E-10_JPRB, 0.42121494E-10_JPRB, 0.44075923E-10_JPRB, &
  & 0.46154466E-10_JPRB, 0.48357974E-10_JPRB, 0.50664827E-10_JPRB, 0.53020945E-10_JPRB, 0.55370777E-10_JPRB, 0.57665560E-10_JPRB, &
  & 0.59873162E-10_JPRB, 0.61979949E-10_JPRB, 0.63986969E-10_JPRB, 0.65898446E-10_JPRB, 0.67712475E-10_JPRB, 0.69406071E-10_JPRB, &
  & 0.70939400E-10_JPRB, 0.72250178E-10_JPRB, 0.73321772E-10_JPRB, 0.74114791E-10_JPRB, 0.74654491E-10_JPRB, 0.74955923E-10_JPRB, &
  & 0.75048981E-10_JPRB, 0.74939513E-10_JPRB, 0.74663671E-10_JPRB, 0.74207002E-10_JPRB, 0.73602138E-10_JPRB, 0.72841760E-10_JPRB, &
  & 0.71946463E-10_JPRB, 0.70931323E-10_JPRB, 0.69807715E-10_JPRB, 0.68576513E-10_JPRB, 0.67205908E-10_JPRB, 0.65658950E-10_JPRB, &
  & 0.63903854E-10_JPRB, 0.61929642E-10_JPRB, 0.59774102E-10_JPRB, 0.57497583E-10_JPRB, 0.55196826E-10_JPRB, 0.52987142E-10_JPRB, &
  & 0.50929184E-10_JPRB, 0.49073592E-10_JPRB, 0.47395629E-10_JPRB, 0.45855202E-10_JPRB, 0.44411121E-10_JPRB, 0.43007316E-10_JPRB, &
  & 0.41603498E-10_JPRB, 0.40155934E-10_JPRB, 0.38619927E-10_JPRB, 0.36965674E-10_JPRB, 0.35182069E-10_JPRB, 0.33324239E-10_JPRB, &
  & 0.31473390E-10_JPRB, 0.29701887E-10_JPRB, 0.27742385E-10_JPRB, 0.24520571E-10_JPRB /)

RGHG9(:,32, 2) = (/ &
  & 0.31095192E-10_JPRB, 0.33178071E-10_JPRB, 0.34371585E-10_JPRB, 0.35447700E-10_JPRB, 0.36573487E-10_JPRB, 0.37808291E-10_JPRB, &
  & 0.39166847E-10_JPRB, 0.40617825E-10_JPRB, 0.42156896E-10_JPRB, 0.43773898E-10_JPRB, 0.45498001E-10_JPRB, 0.47361254E-10_JPRB, &
  & 0.49384805E-10_JPRB, 0.51558403E-10_JPRB, 0.53855843E-10_JPRB, 0.56229507E-10_JPRB, 0.58615120E-10_JPRB, 0.60951973E-10_JPRB, &
  & 0.63194519E-10_JPRB, 0.65324399E-10_JPRB, 0.67338669E-10_JPRB, 0.69247046E-10_JPRB, 0.71042526E-10_JPRB, 0.72718623E-10_JPRB, &
  & 0.74218923E-10_JPRB, 0.75517891E-10_JPRB, 0.76577106E-10_JPRB, 0.77369527E-10_JPRB, 0.77905328E-10_JPRB, 0.78197740E-10_JPRB, &
  & 0.78253001E-10_JPRB, 0.78097889E-10_JPRB, 0.77753165E-10_JPRB, 0.77234115E-10_JPRB, 0.76583469E-10_JPRB, 0.75813508E-10_JPRB, &
  & 0.74957686E-10_JPRB, 0.74029338E-10_JPRB, 0.73028368E-10_JPRB, 0.71936422E-10_JPRB, 0.70714323E-10_JPRB, 0.69314526E-10_JPRB, &
  & 0.67696002E-10_JPRB, 0.65850769E-10_JPRB, 0.63808459E-10_JPRB, 0.61647687E-10_JPRB, 0.59458563E-10_JPRB, 0.57328378E-10_JPRB, &
  & 0.55348861E-10_JPRB, 0.53533865E-10_JPRB, 0.51876912E-10_JPRB, 0.50346085E-10_JPRB, 0.48890808E-10_JPRB, 0.47473969E-10_JPRB, &
  & 0.46047249E-10_JPRB, 0.44567499E-10_JPRB, 0.42990375E-10_JPRB, 0.41277658E-10_JPRB, 0.39436458E-10_JPRB, 0.37532012E-10_JPRB, &
  & 0.35697133E-10_JPRB, 0.33930261E-10_JPRB, 0.32080005E-10_JPRB, 0.28853704E-10_JPRB /)

RGHG9(:,33, 2) = (/ &
  & 0.35052655E-10_JPRB, 0.37061156E-10_JPRB, 0.38219081E-10_JPRB, 0.39245423E-10_JPRB, 0.40312014E-10_JPRB, 0.41491775E-10_JPRB, &
  & 0.42787694E-10_JPRB, 0.44169030E-10_JPRB, 0.45622998E-10_JPRB, 0.47144254E-10_JPRB, 0.48768281E-10_JPRB, 0.50531388E-10_JPRB, &
  & 0.52465084E-10_JPRB, 0.54582117E-10_JPRB, 0.56862418E-10_JPRB, 0.59250278E-10_JPRB, 0.61667338E-10_JPRB, 0.64040655E-10_JPRB, &
  & 0.66311068E-10_JPRB, 0.68447560E-10_JPRB, 0.70450076E-10_JPRB, 0.72317902E-10_JPRB, 0.74057600E-10_JPRB, 0.75646975E-10_JPRB, &
  & 0.77063030E-10_JPRB, 0.78281770E-10_JPRB, 0.79270507E-10_JPRB, 0.80023099E-10_JPRB, 0.80533157E-10_JPRB, 0.80816250E-10_JPRB, &
  & 0.80862581E-10_JPRB, 0.80711174E-10_JPRB, 0.80362092E-10_JPRB, 0.79854720E-10_JPRB, 0.79223697E-10_JPRB, 0.78502989E-10_JPRB, &
  & 0.77726200E-10_JPRB, 0.76899188E-10_JPRB, 0.76017040E-10_JPRB, 0.75051354E-10_JPRB, 0.73949361E-10_JPRB, 0.72657033E-10_JPRB, &
  & 0.71141218E-10_JPRB, 0.69389286E-10_JPRB, 0.67451135E-10_JPRB, 0.65397014E-10_JPRB, 0.63313535E-10_JPRB, 0.61298515E-10_JPRB, &
  & 0.59397903E-10_JPRB, 0.57649253E-10_JPRB, 0.56033910E-10_JPRB, 0.54521710E-10_JPRB, 0.53079530E-10_JPRB, 0.51660887E-10_JPRB, &
  & 0.50231878E-10_JPRB, 0.48744148E-10_JPRB, 0.47153365E-10_JPRB, 0.45424473E-10_JPRB, 0.43569627E-10_JPRB, 0.41677363E-10_JPRB, &
  & 0.39866228E-10_JPRB, 0.38186961E-10_JPRB, 0.36357452E-10_JPRB, 0.33285649E-10_JPRB /)

RGHG9(:,34, 2) = (/ &
  & 0.38916429E-10_JPRB, 0.40879026E-10_JPRB, 0.41973966E-10_JPRB, 0.42950546E-10_JPRB, 0.43965838E-10_JPRB, 0.45083270E-10_JPRB, &
  & 0.46313602E-10_JPRB, 0.47622951E-10_JPRB, 0.48984910E-10_JPRB, 0.50402578E-10_JPRB, 0.51915548E-10_JPRB, 0.53571737E-10_JPRB, &
  & 0.55417729E-10_JPRB, 0.57471403E-10_JPRB, 0.59719570E-10_JPRB, 0.62103135E-10_JPRB, 0.64541622E-10_JPRB, 0.66945588E-10_JPRB, &
  & 0.69231981E-10_JPRB, 0.71368626E-10_JPRB, 0.73341520E-10_JPRB, 0.75150858E-10_JPRB, 0.76790560E-10_JPRB, 0.78263701E-10_JPRB, &
  & 0.79539347E-10_JPRB, 0.80630197E-10_JPRB, 0.81504116E-10_JPRB, 0.82176606E-10_JPRB, 0.82639277E-10_JPRB, 0.82901422E-10_JPRB, &
  & 0.82959070E-10_JPRB, 0.82838861E-10_JPRB, 0.82539725E-10_JPRB, 0.82097412E-10_JPRB, 0.81540101E-10_JPRB, 0.80911014E-10_JPRB, &
  & 0.80234222E-10_JPRB, 0.79520196E-10_JPRB, 0.78758895E-10_JPRB, 0.77907382E-10_JPRB, 0.76904774E-10_JPRB, 0.75694465E-10_JPRB, &
  & 0.74237873E-10_JPRB, 0.72554761E-10_JPRB, 0.70688344E-10_JPRB, 0.68725789E-10_JPRB, 0.66754789E-10_JPRB, 0.64837760E-10_JPRB, &
  & 0.63040177E-10_JPRB, 0.61364414E-10_JPRB, 0.59803336E-10_JPRB, 0.58331603E-10_JPRB, 0.56909682E-10_JPRB, 0.55510548E-10_JPRB, &
  & 0.54094874E-10_JPRB, 0.52620651E-10_JPRB, 0.51045123E-10_JPRB, 0.49339727E-10_JPRB, 0.47520279E-10_JPRB, 0.45675769E-10_JPRB, &
  & 0.43936677E-10_JPRB, 0.42292968E-10_JPRB, 0.40574277E-10_JPRB, 0.37554782E-10_JPRB /)

RGHG9(:,35, 2) = (/ &
  & 0.42685640E-10_JPRB, 0.44562135E-10_JPRB, 0.45622190E-10_JPRB, 0.46549445E-10_JPRB, 0.47509201E-10_JPRB, 0.48571820E-10_JPRB, &
  & 0.49733419E-10_JPRB, 0.50964649E-10_JPRB, 0.52230175E-10_JPRB, 0.53541328E-10_JPRB, 0.54935390E-10_JPRB, 0.56469121E-10_JPRB, &
  & 0.58201940E-10_JPRB, 0.60176433E-10_JPRB, 0.62386034E-10_JPRB, 0.64765790E-10_JPRB, 0.67223019E-10_JPRB, 0.69648586E-10_JPRB, &
  & 0.71948801E-10_JPRB, 0.74075850E-10_JPRB, 0.76007187E-10_JPRB, 0.77733674E-10_JPRB, 0.79251140E-10_JPRB, 0.80565714E-10_JPRB, &
  & 0.81664966E-10_JPRB, 0.82581879E-10_JPRB, 0.83295822E-10_JPRB, 0.83853736E-10_JPRB, 0.84237360E-10_JPRB, 0.84462701E-10_JPRB, &
  & 0.84529821E-10_JPRB, 0.84450627E-10_JPRB, 0.84227153E-10_JPRB, 0.83878876E-10_JPRB, 0.83431838E-10_JPRB, 0.82918283E-10_JPRB, &
  & 0.82360889E-10_JPRB, 0.81771555E-10_JPRB, 0.81127577E-10_JPRB, 0.80385566E-10_JPRB, 0.79482851E-10_JPRB, 0.78352283E-10_JPRB, &
  & 0.76968869E-10_JPRB, 0.75331116E-10_JPRB, 0.73529210E-10_JPRB, 0.71645120E-10_JPRB, 0.69761835E-10_JPRB, 0.67956529E-10_JPRB, &
  & 0.66245301E-10_JPRB, 0.64651950E-10_JPRB, 0.63154981E-10_JPRB, 0.61725978E-10_JPRB, 0.60343064E-10_JPRB, 0.58972466E-10_JPRB, &
  & 0.57582748E-10_JPRB, 0.56137948E-10_JPRB, 0.54603926E-10_JPRB, 0.52950391E-10_JPRB, 0.51207125E-10_JPRB, 0.49451155E-10_JPRB, &
  & 0.47786417E-10_JPRB, 0.46236747E-10_JPRB, 0.44548157E-10_JPRB, 0.41674796E-10_JPRB /)

RGHG9(:,36, 2) = (/ &
  & 0.46324947E-10_JPRB, 0.48141494E-10_JPRB, 0.49141108E-10_JPRB, 0.50025352E-10_JPRB, 0.50941917E-10_JPRB, 0.51945559E-10_JPRB, &
  & 0.53041085E-10_JPRB, 0.54190250E-10_JPRB, 0.55357764E-10_JPRB, 0.56553404E-10_JPRB, 0.57822341E-10_JPRB, 0.59227033E-10_JPRB, &
  & 0.60838855E-10_JPRB, 0.62716145E-10_JPRB, 0.64866092E-10_JPRB, 0.67227987E-10_JPRB, 0.69693348E-10_JPRB, 0.72134056E-10_JPRB, &
  & 0.74440502E-10_JPRB, 0.76550113E-10_JPRB, 0.78420000E-10_JPRB, 0.80035874E-10_JPRB, 0.81391296E-10_JPRB, 0.82502970E-10_JPRB, &
  & 0.83383189E-10_JPRB, 0.84085135E-10_JPRB, 0.84622101E-10_JPRB, 0.85035971E-10_JPRB, 0.85328786E-10_JPRB, 0.85505283E-10_JPRB, &
  & 0.85569718E-10_JPRB, 0.85522735E-10_JPRB, 0.85365236E-10_JPRB, 0.85106464E-10_JPRB, 0.84764376E-10_JPRB, 0.84362323E-10_JPRB, &
  & 0.83920787E-10_JPRB, 0.83444585E-10_JPRB, 0.82913620E-10_JPRB, 0.82288218E-10_JPRB, 0.81503235E-10_JPRB, 0.80497428E-10_JPRB, &
  & 0.79213969E-10_JPRB, 0.77681570E-10_JPRB, 0.75951474E-10_JPRB, 0.74150068E-10_JPRB, 0.72365502E-10_JPRB, 0.70645961E-10_JPRB, &
  & 0.69030365E-10_JPRB, 0.67511115E-10_JPRB, 0.66073820E-10_JPRB, 0.64699322E-10_JPRB, 0.63356556E-10_JPRB, 0.62023345E-10_JPRB, &
  & 0.60671024E-10_JPRB, 0.59272198E-10_JPRB, 0.57791563E-10_JPRB, 0.56221298E-10_JPRB, 0.54575067E-10_JPRB, 0.52933991E-10_JPRB, &
  & 0.51379845E-10_JPRB, 0.49900393E-10_JPRB, 0.48317100E-10_JPRB, 0.45538896E-10_JPRB /)

RGHG9(:,37, 2) = (/ &
  & 0.49867839E-10_JPRB, 0.51581048E-10_JPRB, 0.52540416E-10_JPRB, 0.53380148E-10_JPRB, 0.54252235E-10_JPRB, 0.55209240E-10_JPRB, &
  & 0.56238507E-10_JPRB, 0.57303513E-10_JPRB, 0.58369594E-10_JPRB, 0.59447204E-10_JPRB, 0.60582005E-10_JPRB, 0.61840817E-10_JPRB, &
  & 0.63315110E-10_JPRB, 0.65076444E-10_JPRB, 0.67155233E-10_JPRB, 0.69486784E-10_JPRB, 0.71945241E-10_JPRB, 0.74389321E-10_JPRB, &
  & 0.76693152E-10_JPRB, 0.78756716E-10_JPRB, 0.80522485E-10_JPRB, 0.81978944E-10_JPRB, 0.83109387E-10_JPRB, 0.83981565E-10_JPRB, &
  & 0.84628020E-10_JPRB, 0.85124720E-10_JPRB, 0.85497706E-10_JPRB, 0.85791561E-10_JPRB, 0.86004343E-10_JPRB, 0.86140116E-10_JPRB, &
  & 0.86196709E-10_JPRB, 0.86168801E-10_JPRB, 0.86054726E-10_JPRB, 0.85858397E-10_JPRB, 0.85592616E-10_JPRB, 0.85274759E-10_JPRB, &
  & 0.84921029E-10_JPRB, 0.84534497E-10_JPRB, 0.84098922E-10_JPRB, 0.83579588E-10_JPRB, 0.82922287E-10_JPRB, 0.82058325E-10_JPRB, &
  & 0.80943093E-10_JPRB, 0.79547265E-10_JPRB, 0.77954442E-10_JPRB, 0.76257015E-10_JPRB, 0.74568234E-10_JPRB, 0.72946288E-10_JPRB, &
  & 0.71408969E-10_JPRB, 0.69959517E-10_JPRB, 0.68583944E-10_JPRB, 0.67258699E-10_JPRB, 0.65964359E-10_JPRB, 0.64677257E-10_JPRB, &
  & 0.63375326E-10_JPRB, 0.62035106E-10_JPRB, 0.60634019E-10_JPRB, 0.59156062E-10_JPRB, 0.57631351E-10_JPRB, 0.56115227E-10_JPRB, &
  & 0.54675656E-10_JPRB, 0.53303872E-10_JPRB, 0.51809411E-10_JPRB, 0.49199301E-10_JPRB /)

RGHG9(:,38, 2) = (/ &
  & 0.53291090E-10_JPRB, 0.54907183E-10_JPRB, 0.55798609E-10_JPRB, 0.56604641E-10_JPRB, 0.57440847E-10_JPRB, 0.58353627E-10_JPRB, &
  & 0.59321908E-10_JPRB, 0.60301195E-10_JPRB, 0.61264910E-10_JPRB, 0.62220881E-10_JPRB, 0.63216980E-10_JPRB, 0.64329493E-10_JPRB, &
  & 0.65644747E-10_JPRB, 0.67270065E-10_JPRB, 0.69243063E-10_JPRB, 0.71521927E-10_JPRB, 0.73958922E-10_JPRB, 0.76382775E-10_JPRB, &
  & 0.78645812E-10_JPRB, 0.80619490E-10_JPRB, 0.82220675E-10_JPRB, 0.83442593E-10_JPRB, 0.84338432E-10_JPRB, 0.84977067E-10_JPRB, &
  & 0.85436797E-10_JPRB, 0.85780799E-10_JPRB, 0.86043721E-10_JPRB, 0.86254948E-10_JPRB, 0.86416332E-10_JPRB, 0.86524933E-10_JPRB, &
  & 0.86575136E-10_JPRB, 0.86558219E-10_JPRB, 0.86470470E-10_JPRB, 0.86313151E-10_JPRB, 0.86096803E-10_JPRB, 0.85835533E-10_JPRB, &
  & 0.85543406E-10_JPRB, 0.85220934E-10_JPRB, 0.84856108E-10_JPRB, 0.84419902E-10_JPRB, 0.83866310E-10_JPRB, 0.83140168E-10_JPRB, &
  & 0.82181421E-10_JPRB, 0.80970133E-10_JPRB, 0.79532630E-10_JPRB, 0.77979165E-10_JPRB, 0.76404189E-10_JPRB, 0.74875481E-10_JPRB, &
  & 0.73417869E-10_JPRB, 0.72034163E-10_JPRB, 0.70710986E-10_JPRB, 0.69437719E-10_JPRB, 0.68193881E-10_JPRB, 0.66963511E-10_JPRB, &
  & 0.65729679E-10_JPRB, 0.64470269E-10_JPRB, 0.63166063E-10_JPRB, 0.61804908E-10_JPRB, 0.60405986E-10_JPRB, 0.59020511E-10_JPRB, &
  & 0.57698873E-10_JPRB, 0.56434777E-10_JPRB, 0.55044472E-10_JPRB, 0.52624211E-10_JPRB /)

RGHG9(:,39, 2) = (/ &
  & 0.56592127E-10_JPRB, 0.58065521E-10_JPRB, 0.58913777E-10_JPRB, 0.59673919E-10_JPRB, 0.60486949E-10_JPRB, 0.61360104E-10_JPRB, &
  & 0.62269065E-10_JPRB, 0.63163502E-10_JPRB, 0.64021885E-10_JPRB, 0.64857536E-10_JPRB, 0.65723212E-10_JPRB, 0.66680030E-10_JPRB, &
  & 0.67842551E-10_JPRB, 0.69306935E-10_JPRB, 0.71161223E-10_JPRB, 0.73355794E-10_JPRB, 0.75740872E-10_JPRB, 0.78110962E-10_JPRB, &
  & 0.80266079E-10_JPRB, 0.82075464E-10_JPRB, 0.83454403E-10_JPRB, 0.84445888E-10_JPRB, 0.85130882E-10_JPRB, 0.85604343E-10_JPRB, &
  & 0.85941386E-10_JPRB, 0.86192595E-10_JPRB, 0.86389312E-10_JPRB, 0.86552425E-10_JPRB, 0.86682564E-10_JPRB, 0.86774976E-10_JPRB, &
  & 0.86821147E-10_JPRB, 0.86811065E-10_JPRB, 0.86739310E-10_JPRB, 0.86606972E-10_JPRB, 0.86422522E-10_JPRB, 0.86200061E-10_JPRB, &
  & 0.85950268E-10_JPRB, 0.85674308E-10_JPRB, 0.85360476E-10_JPRB, 0.84985081E-10_JPRB, 0.84511127E-10_JPRB, 0.83889666E-10_JPRB, &
  & 0.83072237E-10_JPRB, 0.82023492E-10_JPRB, 0.80761078E-10_JPRB, 0.79357243E-10_JPRB, 0.77907750E-10_JPRB, 0.76479420E-10_JPRB, &
  & 0.75104374E-10_JPRB, 0.73778608E-10_JPRB, 0.72507562E-10_JPRB, 0.71280752E-10_JPRB, 0.70089289E-10_JPRB, 0.68925289E-10_JPRB, &
  & 0.67771892E-10_JPRB, 0.66616476E-10_JPRB, 0.65429662E-10_JPRB, 0.64200950E-10_JPRB, 0.62938321E-10_JPRB, 0.61682867E-10_JPRB, &
  & 0.60482071E-10_JPRB, 0.59317981E-10_JPRB, 0.58054724E-10_JPRB, 0.55821060E-10_JPRB /)

RGHG9(:,40, 2) = (/ &
  & 0.59699037E-10_JPRB, 0.61052073E-10_JPRB, 0.61828667E-10_JPRB, 0.62568131E-10_JPRB, 0.63351248E-10_JPRB, 0.64196023E-10_JPRB, &
  & 0.65044900E-10_JPRB, 0.65852816E-10_JPRB, 0.66609870E-10_JPRB, 0.67334173E-10_JPRB, 0.68070972E-10_JPRB, 0.68897235E-10_JPRB, &
  & 0.69894278E-10_JPRB, 0.71198027E-10_JPRB, 0.72898007E-10_JPRB, 0.74986635E-10_JPRB, 0.77289203E-10_JPRB, 0.79557937E-10_JPRB, &
  & 0.81562271E-10_JPRB, 0.83147454E-10_JPRB, 0.84307727E-10_JPRB, 0.85099518E-10_JPRB, 0.85638358E-10_JPRB, 0.86004148E-10_JPRB, &
  & 0.86267798E-10_JPRB, 0.86464870E-10_JPRB, 0.86624055E-10_JPRB, 0.86758531E-10_JPRB, 0.86870296E-10_JPRB, 0.86952646E-10_JPRB, &
  & 0.86995980E-10_JPRB, 0.86990061E-10_JPRB, 0.86928832E-10_JPRB, 0.86812751E-10_JPRB, 0.86650472E-10_JPRB, 0.86454739E-10_JPRB, &
  & 0.86236220E-10_JPRB, 0.85994156E-10_JPRB, 0.85718682E-10_JPRB, 0.85389515E-10_JPRB, 0.84974958E-10_JPRB, 0.84435167E-10_JPRB, &
  & 0.83726290E-10_JPRB, 0.82813277E-10_JPRB, 0.81703380E-10_JPRB, 0.80448037E-10_JPRB, 0.79133040E-10_JPRB, 0.77816253E-10_JPRB, &
  & 0.76519298E-10_JPRB, 0.75258529E-10_JPRB, 0.74030691E-10_JPRB, 0.72842447E-10_JPRB, 0.71702116E-10_JPRB, 0.70604064E-10_JPRB, &
  & 0.69546494E-10_JPRB, 0.68503342E-10_JPRB, 0.67452335E-10_JPRB, 0.66365281E-10_JPRB, 0.65248806E-10_JPRB, 0.64130479E-10_JPRB, &
  & 0.63047373E-10_JPRB, 0.61999635E-10_JPRB, 0.60834240E-10_JPRB, 0.58812163E-10_JPRB /)

RGHG9(:,41, 2) = (/ &
  & 0.62585652E-10_JPRB, 0.63808313E-10_JPRB, 0.64539811E-10_JPRB, 0.65242742E-10_JPRB, 0.66013389E-10_JPRB, 0.66823672E-10_JPRB, &
  & 0.67612735E-10_JPRB, 0.68339716E-10_JPRB, 0.68998543E-10_JPRB, 0.69622176E-10_JPRB, 0.70251374E-10_JPRB, 0.70950343E-10_JPRB, &
  & 0.71813624E-10_JPRB, 0.72953248E-10_JPRB, 0.74495354E-10_JPRB, 0.76451588E-10_JPRB, 0.78635883E-10_JPRB, 0.80770862E-10_JPRB, &
  & 0.82574121E-10_JPRB, 0.83942249E-10_JPRB, 0.84900038E-10_JPRB, 0.85543746E-10_JPRB, 0.85980265E-10_JPRB, 0.86277326E-10_JPRB, &
  & 0.86496088E-10_JPRB, 0.86660817E-10_JPRB, 0.86797215E-10_JPRB, 0.86915003E-10_JPRB, 0.87014548E-10_JPRB, 0.87090356E-10_JPRB, &
  & 0.87131038E-10_JPRB, 0.87127382E-10_JPRB, 0.87073071E-10_JPRB, 0.86968557E-10_JPRB, 0.86821737E-10_JPRB, 0.86646211E-10_JPRB, &
  & 0.86450708E-10_JPRB, 0.86235234E-10_JPRB, 0.85989958E-10_JPRB, 0.85697012E-10_JPRB, 0.85329951E-10_JPRB, 0.84854158E-10_JPRB, &
  & 0.84231962E-10_JPRB, 0.83432712E-10_JPRB, 0.82451629E-10_JPRB, 0.81336653E-10_JPRB, 0.80146674E-10_JPRB, 0.78938724E-10_JPRB, &
  & 0.77734354E-10_JPRB, 0.76532634E-10_JPRB, 0.75342739E-10_JPRB, 0.74191056E-10_JPRB, 0.73088612E-10_JPRB, 0.72061621E-10_JPRB, &
  & 0.71096296E-10_JPRB, 0.70174602E-10_JPRB, 0.69257988E-10_JPRB, 0.68320516E-10_JPRB, 0.67353699E-10_JPRB, 0.66378077E-10_JPRB, &
  & 0.65425047E-10_JPRB, 0.64481483E-10_JPRB, 0.63440163E-10_JPRB, 0.61602563E-10_JPRB /)

RGHG9(:,42, 2) = (/ &
  & 0.65232091E-10_JPRB, 0.66342182E-10_JPRB, 0.67022679E-10_JPRB, 0.67698479E-10_JPRB, 0.68447595E-10_JPRB, 0.69224577E-10_JPRB, &
  & 0.69954750E-10_JPRB, 0.70602288E-10_JPRB, 0.71178063E-10_JPRB, 0.71712920E-10_JPRB, 0.72250338E-10_JPRB, 0.72848123E-10_JPRB, &
  & 0.73585346E-10_JPRB, 0.74583714E-10_JPRB, 0.75966164E-10_JPRB, 0.77772982E-10_JPRB, 0.79822975E-10_JPRB, 0.81770979E-10_JPRB, &
  & 0.83378388E-10_JPRB, 0.84535233E-10_JPRB, 0.85332123E-10_JPRB, 0.85863608E-10_JPRB, 0.86227511E-10_JPRB, 0.86479546E-10_JPRB, &
  & 0.86668617E-10_JPRB, 0.86813119E-10_JPRB, 0.86935834E-10_JPRB, 0.87042179E-10_JPRB, 0.87134397E-10_JPRB, 0.87204355E-10_JPRB, &
  & 0.87242484E-10_JPRB, 0.87239486E-10_JPRB, 0.87189776E-10_JPRB, 0.87093409E-10_JPRB, 0.86958489E-10_JPRB, 0.86797888E-10_JPRB, &
  & 0.86620752E-10_JPRB, 0.86426317E-10_JPRB, 0.86205758E-10_JPRB, 0.85943412E-10_JPRB, 0.85615612E-10_JPRB, 0.85193366E-10_JPRB, &
  & 0.84643501E-10_JPRB, 0.83935268E-10_JPRB, 0.83066283E-10_JPRB, 0.82067492E-10_JPRB, 0.81002920E-10_JPRB, 0.79907143E-10_JPRB, &
  & 0.78793021E-10_JPRB, 0.77655417E-10_JPRB, 0.76510548E-10_JPRB, 0.75379022E-10_JPRB, 0.74323242E-10_JPRB, 0.73358493E-10_JPRB, &
  & 0.72489556E-10_JPRB, 0.71682382E-10_JPRB, 0.70897704E-10_JPRB, 0.70101341E-10_JPRB, 0.69282274E-10_JPRB, 0.68451772E-10_JPRB, &
  & 0.67627695E-10_JPRB, 0.66802890E-10_JPRB, 0.65866874E-10_JPRB, 0.64218436E-10_JPRB /)

RGHG9(:,43, 2) = (/ &
  & 0.67649226E-10_JPRB, 0.68660772E-10_JPRB, 0.69292863E-10_JPRB, 0.69936459E-10_JPRB, 0.70655995E-10_JPRB, 0.71394217E-10_JPRB, &
  & 0.72067914E-10_JPRB, 0.72647222E-10_JPRB, 0.73153414E-10_JPRB, 0.73615031E-10_JPRB, 0.74078625E-10_JPRB, 0.74591069E-10_JPRB, &
  & 0.75229871E-10_JPRB, 0.76099495E-10_JPRB, 0.77340662E-10_JPRB, 0.78993458E-10_JPRB, 0.80877749E-10_JPRB, 0.82636224E-10_JPRB, &
  & 0.84016967E-10_JPRB, 0.84997231E-10_JPRB, 0.85659660E-10_JPRB, 0.86107135E-10_JPRB, 0.86417762E-10_JPRB, 0.86638752E-10_JPRB, &
  & 0.86807353E-10_JPRB, 0.86939171E-10_JPRB, 0.87052601E-10_JPRB, 0.87152445E-10_JPRB, 0.87238203E-10_JPRB, 0.87303997E-10_JPRB, &
  & 0.87338574E-10_JPRB, 0.87335021E-10_JPRB, 0.87288198E-10_JPRB, 0.87197922E-10_JPRB, 0.87071843E-10_JPRB, 0.86923198E-10_JPRB, &
  & 0.86760557E-10_JPRB, 0.86583525E-10_JPRB, 0.86383942E-10_JPRB, 0.86147492E-10_JPRB, 0.85854150E-10_JPRB, 0.85478208E-10_JPRB, &
  & 0.84990917E-10_JPRB, 0.84364453E-10_JPRB, 0.83590745E-10_JPRB, 0.82701693E-10_JPRB, 0.81744035E-10_JPRB, 0.80755867E-10_JPRB, &
  & 0.79733893E-10_JPRB, 0.78671195E-10_JPRB, 0.77566772E-10_JPRB, 0.76480579E-10_JPRB, 0.75463275E-10_JPRB, 0.74572390E-10_JPRB, &
  & 0.73795338E-10_JPRB, 0.73094850E-10_JPRB, 0.72428126E-10_JPRB, 0.71759841E-10_JPRB, 0.71075992E-10_JPRB, 0.70381742E-10_JPRB, &
  & 0.69685840E-10_JPRB, 0.68971780E-10_JPRB, 0.68150673E-10_JPRB, 0.66678392E-10_JPRB /)

RGHG9(:,44, 2) = (/ &
  & 0.69858203E-10_JPRB, 0.70793316E-10_JPRB, 0.71370139E-10_JPRB, 0.71977091E-10_JPRB, 0.72658629E-10_JPRB, 0.73356175E-10_JPRB, &
  & 0.73977276E-10_JPRB, 0.74507400E-10_JPRB, 0.74954674E-10_JPRB, 0.75362702E-10_JPRB, 0.75763222E-10_JPRB, 0.76207950E-10_JPRB, &
  & 0.76761070E-10_JPRB, 0.77524577E-10_JPRB, 0.78628631E-10_JPRB, 0.80134885E-10_JPRB, 0.81833346E-10_JPRB, 0.83372406E-10_JPRB, &
  & 0.84546939E-10_JPRB, 0.85361704E-10_JPRB, 0.85917946E-10_JPRB, 0.86299204E-10_JPRB, 0.86571028E-10_JPRB, 0.86769009E-10_JPRB, &
  & 0.86923566E-10_JPRB, 0.87047453E-10_JPRB, 0.87155012E-10_JPRB, 0.87250110E-10_JPRB, 0.87332093E-10_JPRB, 0.87392774E-10_JPRB, &
  & 0.87423797E-10_JPRB, 0.87418600E-10_JPRB, 0.87373282E-10_JPRB, 0.87287289E-10_JPRB, 0.87168217E-10_JPRB, 0.87028919E-10_JPRB, &
  & 0.86878171E-10_JPRB, 0.86715697E-10_JPRB, 0.86533752E-10_JPRB, 0.86320097E-10_JPRB, 0.86056787E-10_JPRB, 0.85722394E-10_JPRB, &
  & 0.85291413E-10_JPRB, 0.84737856E-10_JPRB, 0.84051113E-10_JPRB, 0.83256034E-10_JPRB, 0.82401162E-10_JPRB, 0.81511554E-10_JPRB, &
  & 0.80583810E-10_JPRB, 0.79596538E-10_JPRB, 0.78561761E-10_JPRB, 0.77521545E-10_JPRB, 0.76574122E-10_JPRB, 0.75758892E-10_JPRB, &
  & 0.75071921E-10_JPRB, 0.74468820E-10_JPRB, 0.73902655E-10_JPRB, 0.73344289E-10_JPRB, 0.72777388E-10_JPRB, 0.72204139E-10_JPRB, &
  & 0.71624706E-10_JPRB, 0.71020606E-10_JPRB, 0.70305810E-10_JPRB, 0.69008535E-10_JPRB /)

RGHG9(:,45, 2) = (/ &
  & 0.71909902E-10_JPRB, 0.72743055E-10_JPRB, 0.73295869E-10_JPRB, 0.73847588E-10_JPRB, 0.74494293E-10_JPRB, 0.75148013E-10_JPRB, &
  & 0.75738249E-10_JPRB, 0.76222285E-10_JPRB, 0.76635566E-10_JPRB, 0.76995715E-10_JPRB, 0.77349405E-10_JPRB, 0.77735034E-10_JPRB, &
  & 0.78210834E-10_JPRB, 0.78880090E-10_JPRB, 0.79853471E-10_JPRB, 0.81195217E-10_JPRB, 0.82697016E-10_JPRB, 0.84004692E-10_JPRB, &
  & 0.84978177E-10_JPRB, 0.85656010E-10_JPRB, 0.86123358E-10_JPRB, 0.86455489E-10_JPRB, 0.86695505E-10_JPRB, 0.86878824E-10_JPRB, &
  & 0.87023194E-10_JPRB, 0.87141815E-10_JPRB, 0.87246745E-10_JPRB, 0.87338796E-10_JPRB, 0.87416796E-10_JPRB, 0.87473521E-10_JPRB, &
  & 0.87499938E-10_JPRB, 0.87492374E-10_JPRB, 0.87447376E-10_JPRB, 0.87364491E-10_JPRB, 0.87250561E-10_JPRB, 0.87118840E-10_JPRB, &
  & 0.86977953E-10_JPRB, 0.86827392E-10_JPRB, 0.86660769E-10_JPRB, 0.86466445E-10_JPRB, 0.86229829E-10_JPRB, 0.85932636E-10_JPRB, &
  & 0.85554140E-10_JPRB, 0.85069549E-10_JPRB, 0.84466732E-10_JPRB, 0.83762552E-10_JPRB, 0.82999510E-10_JPRB, 0.82204202E-10_JPRB, &
  & 0.81364901E-10_JPRB, 0.80464441E-10_JPRB, 0.79500802E-10_JPRB, 0.78547266E-10_JPRB, 0.77674499E-10_JPRB, 0.76954040E-10_JPRB, &
  & 0.76353320E-10_JPRB, 0.75835928E-10_JPRB, 0.75357741E-10_JPRB, 0.74888651E-10_JPRB, 0.74419776E-10_JPRB, 0.73948576E-10_JPRB, &
  & 0.73471104E-10_JPRB, 0.72965051E-10_JPRB, 0.72356815E-10_JPRB, 0.71228773E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART3',1,ZHOOK_HANDLE)
END SUBROUTINE PART3




SUBROUTINE PART4
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART4',0,ZHOOK_HANDLE)



RGHG9(:,46, 2) = (/ &
  & 0.73789322E-10_JPRB, 0.74588301E-10_JPRB, 0.75069138E-10_JPRB, 0.75602136E-10_JPRB, 0.76196230E-10_JPRB, 0.76823985E-10_JPRB, &
  & 0.77381553E-10_JPRB, 0.77848519E-10_JPRB, 0.78226245E-10_JPRB, 0.78554739E-10_JPRB, 0.78865914E-10_JPRB, 0.79196566E-10_JPRB, &
  & 0.79610971E-10_JPRB, 0.80169711E-10_JPRB, 0.81027664E-10_JPRB, 0.82183524E-10_JPRB, 0.83458428E-10_JPRB, 0.84541416E-10_JPRB, &
  & 0.85333567E-10_JPRB, 0.85892252E-10_JPRB, 0.86290398E-10_JPRB, 0.86581083E-10_JPRB, 0.86800907E-10_JPRB, 0.86971298E-10_JPRB, &
  & 0.87109597E-10_JPRB, 0.87226795E-10_JPRB, 0.87328783E-10_JPRB, 0.87419884E-10_JPRB, 0.87494872E-10_JPRB, 0.87546290E-10_JPRB, &
  & 0.87568224E-10_JPRB, 0.87557572E-10_JPRB, 0.87512039E-10_JPRB, 0.87430778E-10_JPRB, 0.87321039E-10_JPRB, 0.87195390E-10_JPRB, &
  & 0.87062385E-10_JPRB, 0.86922150E-10_JPRB, 0.86767843E-10_JPRB, 0.86590450E-10_JPRB, 0.86376850E-10_JPRB, 0.86113450E-10_JPRB, &
  & 0.85783242E-10_JPRB, 0.85366214E-10_JPRB, 0.84846519E-10_JPRB, 0.84234293E-10_JPRB, 0.83564877E-10_JPRB, 0.82859247E-10_JPRB, &
  & 0.82111901E-10_JPRB, 0.81295283E-10_JPRB, 0.80429302E-10_JPRB, 0.79555924E-10_JPRB, 0.78797399E-10_JPRB, 0.78159229E-10_JPRB, &
  & 0.77650726E-10_JPRB, 0.77209572E-10_JPRB, 0.76804188E-10_JPRB, 0.76411773E-10_JPRB, 0.76021786E-10_JPRB, 0.75634207E-10_JPRB, &
  & 0.75242465E-10_JPRB, 0.74824195E-10_JPRB, 0.74311488E-10_JPRB, 0.73350721E-10_JPRB /)

RGHG9(:,47, 2) = (/ &
  & 0.75571757E-10_JPRB, 0.76285860E-10_JPRB, 0.76761063E-10_JPRB, 0.77237182E-10_JPRB, 0.77808884E-10_JPRB, 0.78406073E-10_JPRB, &
  & 0.78950346E-10_JPRB, 0.79396802E-10_JPRB, 0.79752274E-10_JPRB, 0.80050501E-10_JPRB, 0.80320459E-10_JPRB, 0.80608978E-10_JPRB, &
  & 0.80945459E-10_JPRB, 0.81434547E-10_JPRB, 0.82116994E-10_JPRB, 0.83097029E-10_JPRB, 0.84123618E-10_JPRB, 0.84987503E-10_JPRB, &
  & 0.85622738E-10_JPRB, 0.86083855E-10_JPRB, 0.86424430E-10_JPRB, 0.86685811E-10_JPRB, 0.86887393E-10_JPRB, 0.87051734E-10_JPRB, &
  & 0.87186570E-10_JPRB, 0.87302020E-10_JPRB, 0.87405555E-10_JPRB, 0.87494241E-10_JPRB, 0.87565843E-10_JPRB, 0.87612591E-10_JPRB, &
  & 0.87629140E-10_JPRB, 0.87614957E-10_JPRB, 0.87567925E-10_JPRB, 0.87487753E-10_JPRB, 0.87380825E-10_JPRB, 0.87260144E-10_JPRB, &
  & 0.87133953E-10_JPRB, 0.87001635E-10_JPRB, 0.86858166E-10_JPRB, 0.86694416E-10_JPRB, 0.86501126E-10_JPRB, 0.86267618E-10_JPRB, &
  & 0.85983075E-10_JPRB, 0.85631544E-10_JPRB, 0.85199209E-10_JPRB, 0.84687486E-10_JPRB, 0.84116984E-10_JPRB, 0.83510796E-10_JPRB, &
  & 0.82853786E-10_JPRB, 0.82136353E-10_JPRB, 0.81353549E-10_JPRB, 0.80598542E-10_JPRB, 0.79919495E-10_JPRB, 0.79392021E-10_JPRB, &
  & 0.78954628E-10_JPRB, 0.78586478E-10_JPRB, 0.78245486E-10_JPRB, 0.77914425E-10_JPRB, 0.77590212E-10_JPRB, 0.77270426E-10_JPRB, &
  & 0.76948767E-10_JPRB, 0.76603529E-10_JPRB, 0.76177960E-10_JPRB, 0.75370279E-10_JPRB /)

RGHG9(:,48, 2) = (/ &
  & 0.77234233E-10_JPRB, 0.77914480E-10_JPRB, 0.78341209E-10_JPRB, 0.78802909E-10_JPRB, 0.79340291E-10_JPRB, 0.79920064E-10_JPRB, &
  & 0.80454143E-10_JPRB, 0.80882856E-10_JPRB, 0.81217616E-10_JPRB, 0.81480357E-10_JPRB, 0.81718174E-10_JPRB, 0.81952979E-10_JPRB, &
  & 0.82240145E-10_JPRB, 0.82609086E-10_JPRB, 0.83174204E-10_JPRB, 0.83898062E-10_JPRB, 0.84696715E-10_JPRB, 0.85356958E-10_JPRB, &
  & 0.85858126E-10_JPRB, 0.86238162E-10_JPRB, 0.86534099E-10_JPRB, 0.86770223E-10_JPRB, 0.86962652E-10_JPRB, 0.87121199E-10_JPRB, &
  & 0.87255536E-10_JPRB, 0.87373137E-10_JPRB, 0.87475228E-10_JPRB, 0.87563852E-10_JPRB, 0.87631208E-10_JPRB, 0.87671953E-10_JPRB, &
  & 0.87683354E-10_JPRB, 0.87665257E-10_JPRB, 0.87616359E-10_JPRB, 0.87536124E-10_JPRB, 0.87431715E-10_JPRB, 0.87315134E-10_JPRB, &
  & 0.87194182E-10_JPRB, 0.87068859E-10_JPRB, 0.86933537E-10_JPRB, 0.86781728E-10_JPRB, 0.86605369E-10_JPRB, 0.86398784E-10_JPRB, &
  & 0.86155867E-10_JPRB, 0.85868271E-10_JPRB, 0.85526128E-10_JPRB, 0.85125323E-10_JPRB, 0.84674767E-10_JPRB, 0.84176492E-10_JPRB, &
  & 0.83628805E-10_JPRB, 0.83006144E-10_JPRB, 0.82332752E-10_JPRB, 0.81659596E-10_JPRB, 0.81096102E-10_JPRB, 0.80639828E-10_JPRB, &
  & 0.80282100E-10_JPRB, 0.79971446E-10_JPRB, 0.79684467E-10_JPRB, 0.79405982E-10_JPRB, 0.79132700E-10_JPRB, 0.78866455E-10_JPRB, &
  & 0.78600043E-10_JPRB, 0.78313855E-10_JPRB, 0.77959507E-10_JPRB, 0.77283492E-10_JPRB /)

RGHG9(:,49, 2) = (/ &
  & 0.78805018E-10_JPRB, 0.79440537E-10_JPRB, 0.79850515E-10_JPRB, 0.80286111E-10_JPRB, 0.80806084E-10_JPRB, 0.81376489E-10_JPRB, &
  & 0.81898294E-10_JPRB, 0.82311040E-10_JPRB, 0.82611376E-10_JPRB, 0.82843628E-10_JPRB, 0.83037341E-10_JPRB, 0.83229118E-10_JPRB, &
  & 0.83442267E-10_JPRB, 0.83721668E-10_JPRB, 0.84100421E-10_JPRB, 0.84614024E-10_JPRB, 0.85169011E-10_JPRB, 0.85659917E-10_JPRB, &
  & 0.86050049E-10_JPRB, 0.86363625E-10_JPRB, 0.86622980E-10_JPRB, 0.86841569E-10_JPRB, 0.87026039E-10_JPRB, 0.87184260E-10_JPRB, &
  & 0.87319894E-10_JPRB, 0.87438563E-10_JPRB, 0.87542369E-10_JPRB, 0.87627995E-10_JPRB, 0.87690480E-10_JPRB, 0.87725320E-10_JPRB, &
  & 0.87731336E-10_JPRB, 0.87709229E-10_JPRB, 0.87657950E-10_JPRB, 0.87577674E-10_JPRB, 0.87475027E-10_JPRB, 0.87361930E-10_JPRB, &
  & 0.87245558E-10_JPRB, 0.87125467E-10_JPRB, 0.86997236E-10_JPRB, 0.86854766E-10_JPRB, 0.86693243E-10_JPRB, 0.86510077E-10_JPRB, &
  & 0.86305484E-10_JPRB, 0.86078263E-10_JPRB, 0.85826408E-10_JPRB, 0.85545057E-10_JPRB, 0.85228775E-10_JPRB, 0.84866600E-10_JPRB, &
  & 0.84438206E-10_JPRB, 0.83933201E-10_JPRB, 0.83364232E-10_JPRB, 0.82800738E-10_JPRB, 0.82323655E-10_JPRB, 0.81948615E-10_JPRB, &
  & 0.81650742E-10_JPRB, 0.81391095E-10_JPRB, 0.81147013E-10_JPRB, 0.80907843E-10_JPRB, 0.80673322E-10_JPRB, 0.80445421E-10_JPRB, &
  & 0.80218748E-10_JPRB, 0.79975394E-10_JPRB, 0.79673837E-10_JPRB, 0.79099380E-10_JPRB /)

RGHG9(:,50, 2) = (/ &
  & 0.80276903E-10_JPRB, 0.80879664E-10_JPRB, 0.81264738E-10_JPRB, 0.81689489E-10_JPRB, 0.82201031E-10_JPRB, 0.82770256E-10_JPRB, &
  & 0.83276080E-10_JPRB, 0.83655638E-10_JPRB, 0.83912856E-10_JPRB, 0.84094953E-10_JPRB, 0.84238866E-10_JPRB, 0.84370594E-10_JPRB, &
  & 0.84505590E-10_JPRB, 0.84675128E-10_JPRB, 0.84888221E-10_JPRB, 0.85199590E-10_JPRB, 0.85558165E-10_JPRB, 0.85906504E-10_JPRB, &
  & 0.86207153E-10_JPRB, 0.86467555E-10_JPRB, 0.86697247E-10_JPRB, 0.86901583E-10_JPRB, 0.87083188E-10_JPRB, 0.87241624E-10_JPRB, &
  & 0.87380853E-10_JPRB, 0.87501638E-10_JPRB, 0.87604909E-10_JPRB, 0.87687128E-10_JPRB, 0.87744235E-10_JPRB, 0.87772720E-10_JPRB, &
  & 0.87773649E-10_JPRB, 0.87747663E-10_JPRB, 0.87693963E-10_JPRB, 0.87613201E-10_JPRB, 0.87512317E-10_JPRB, 0.87402238E-10_JPRB, &
  & 0.87289544E-10_JPRB, 0.87173949E-10_JPRB, 0.87051116E-10_JPRB, 0.86916654E-10_JPRB, 0.86767454E-10_JPRB, 0.86605133E-10_JPRB, &
  & 0.86435005E-10_JPRB, 0.86263781E-10_JPRB, 0.86094971E-10_JPRB, 0.85928549E-10_JPRB, 0.85746708E-10_JPRB, 0.85527717E-10_JPRB, &
  & 0.85243007E-10_JPRB, 0.84878465E-10_JPRB, 0.84443501E-10_JPRB, 0.84010666E-10_JPRB, 0.83626911E-10_JPRB, 0.83336268E-10_JPRB, &
  & 0.83088744E-10_JPRB, 0.82874194E-10_JPRB, 0.82665069E-10_JPRB, 0.82454044E-10_JPRB, 0.82245627E-10_JPRB, 0.82042435E-10_JPRB, &
  & 0.81840000E-10_JPRB, 0.81622986E-10_JPRB, 0.81354458E-10_JPRB, 0.80843464E-10_JPRB /)

RGHG9(:,51, 2) = (/ &
  & 0.81651325E-10_JPRB, 0.82198082E-10_JPRB, 0.82583745E-10_JPRB, 0.82985542E-10_JPRB, 0.83503454E-10_JPRB, 0.84051856E-10_JPRB, &
  & 0.84525782E-10_JPRB, 0.84829088E-10_JPRB, 0.85014065E-10_JPRB, 0.85129362E-10_JPRB, 0.85210776E-10_JPRB, 0.85275037E-10_JPRB, &
  & 0.85338861E-10_JPRB, 0.85404329E-10_JPRB, 0.85507684E-10_JPRB, 0.85649432E-10_JPRB, 0.85870921E-10_JPRB, 0.86107739E-10_JPRB, &
  & 0.86339498E-10_JPRB, 0.86556033E-10_JPRB, 0.86761709E-10_JPRB, 0.86955665E-10_JPRB, 0.87134695E-10_JPRB, 0.87296739E-10_JPRB, &
  & 0.87438494E-10_JPRB, 0.87561805E-10_JPRB, 0.87662766E-10_JPRB, 0.87741127E-10_JPRB, 0.87791760E-10_JPRB, 0.87814922E-10_JPRB, &
  & 0.87811036E-10_JPRB, 0.87781261E-10_JPRB, 0.87725112E-10_JPRB, 0.87643913E-10_JPRB, 0.87544576E-10_JPRB, 0.87437210E-10_JPRB, &
  & 0.87327784E-10_JPRB, 0.87215762E-10_JPRB, 0.87097579E-10_JPRB, 0.86969612E-10_JPRB, 0.86831320E-10_JPRB, 0.86687407E-10_JPRB, &
  & 0.86548803E-10_JPRB, 0.86426644E-10_JPRB, 0.86330602E-10_JPRB, 0.86253935E-10_JPRB, 0.86180875E-10_JPRB, 0.86080906E-10_JPRB, &
  & 0.85932872E-10_JPRB, 0.85720861E-10_JPRB, 0.85457676E-10_JPRB, 0.85170877E-10_JPRB, 0.84926954E-10_JPRB, 0.84710045E-10_JPRB, &
  & 0.84536420E-10_JPRB, 0.84366222E-10_JPRB, 0.84194089E-10_JPRB, 0.84014684E-10_JPRB, 0.83828673E-10_JPRB, 0.83644765E-10_JPRB, &
  & 0.83459725E-10_JPRB, 0.83259358E-10_JPRB, 0.83009037E-10_JPRB, 0.82538046E-10_JPRB /)

RGHG9(:,52, 2) = (/ &
  & 0.82861301E-10_JPRB, 0.83410431E-10_JPRB, 0.83738627E-10_JPRB, 0.84154413E-10_JPRB, 0.84624349E-10_JPRB, 0.85132165E-10_JPRB, &
  & 0.85481011E-10_JPRB, 0.85680907E-10_JPRB, 0.85780494E-10_JPRB, 0.85834888E-10_JPRB, 0.85866078E-10_JPRB, 0.85886964E-10_JPRB, &
  & 0.85900967E-10_JPRB, 0.85917135E-10_JPRB, 0.85938784E-10_JPRB, 0.86002330E-10_JPRB, 0.86112693E-10_JPRB, 0.86275188E-10_JPRB, &
  & 0.86452248E-10_JPRB, 0.86636219E-10_JPRB, 0.86821536E-10_JPRB, 0.87006694E-10_JPRB, 0.87184968E-10_JPRB, 0.87348531E-10_JPRB, &
  & 0.87494262E-10_JPRB, 0.87616685E-10_JPRB, 0.87716230E-10_JPRB, 0.87788568E-10_JPRB, 0.87834233E-10_JPRB, 0.87852239E-10_JPRB, &
  & 0.87844149E-10_JPRB, 0.87810717E-10_JPRB, 0.87752181E-10_JPRB, 0.87670503E-10_JPRB, 0.87572595E-10_JPRB, 0.87467859E-10_JPRB, &
  & 0.87361229E-10_JPRB, 0.87252525E-10_JPRB, 0.87138192E-10_JPRB, 0.87016228E-10_JPRB, 0.86887476E-10_JPRB, 0.86760876E-10_JPRB, &
  & 0.86650132E-10_JPRB, 0.86571514E-10_JPRB, 0.86529769E-10_JPRB, 0.86516530E-10_JPRB, 0.86508536E-10_JPRB, 0.86484389E-10_JPRB, &
  & 0.86427671E-10_JPRB, 0.86333191E-10_JPRB, 0.86204245E-10_JPRB, 0.86065190E-10_JPRB, 0.85927432E-10_JPRB, 0.85815410E-10_JPRB, &
  & 0.85704527E-10_JPRB, 0.85598362E-10_JPRB, 0.85481427E-10_JPRB, 0.85347902E-10_JPRB, 0.85206842E-10_JPRB, 0.85060292E-10_JPRB, &
  & 0.84908088E-10_JPRB, 0.84739507E-10_JPRB, 0.84523652E-10_JPRB, 0.84100678E-10_JPRB /)

RGHG9(:,53, 2) = (/ &
  & 0.83951186E-10_JPRB, 0.84399848E-10_JPRB, 0.84757069E-10_JPRB, 0.85088388E-10_JPRB, 0.85517191E-10_JPRB, 0.85871962E-10_JPRB, &
  & 0.86094493E-10_JPRB, 0.86192962E-10_JPRB, 0.86237489E-10_JPRB, 0.86256946E-10_JPRB, 0.86264905E-10_JPRB, 0.86266064E-10_JPRB, &
  & 0.86262150E-10_JPRB, 0.86255815E-10_JPRB, 0.86248619E-10_JPRB, 0.86256724E-10_JPRB, 0.86312839E-10_JPRB, 0.86414778E-10_JPRB, &
  & 0.86553195E-10_JPRB, 0.86710084E-10_JPRB, 0.86880822E-10_JPRB, 0.87058201E-10_JPRB, 0.87234109E-10_JPRB, 0.87399504E-10_JPRB, &
  & 0.87544881E-10_JPRB, 0.87667727E-10_JPRB, 0.87763012E-10_JPRB, 0.87831444E-10_JPRB, 0.87871696E-10_JPRB, 0.87885504E-10_JPRB, &
  & 0.87873639E-10_JPRB, 0.87836780E-10_JPRB, 0.87775828E-10_JPRB, 0.87693630E-10_JPRB, 0.87597193E-10_JPRB, 0.87494685E-10_JPRB, &
  & 0.87390907E-10_JPRB, 0.87285089E-10_JPRB, 0.87174823E-10_JPRB, 0.87058222E-10_JPRB, 0.86939303E-10_JPRB, 0.86828197E-10_JPRB, &
  & 0.86743751E-10_JPRB, 0.86699405E-10_JPRB, 0.86697309E-10_JPRB, 0.86721165E-10_JPRB, 0.86747283E-10_JPRB, 0.86759461E-10_JPRB, &
  & 0.86748997E-10_JPRB, 0.86714476E-10_JPRB, 0.86659985E-10_JPRB, 0.86594426E-10_JPRB, 0.86533392E-10_JPRB, 0.86473204E-10_JPRB, &
  & 0.86419760E-10_JPRB, 0.86361182E-10_JPRB, 0.86294027E-10_JPRB, 0.86216992E-10_JPRB, 0.86128465E-10_JPRB, 0.86035484E-10_JPRB, &
  & 0.85936744E-10_JPRB, 0.85823869E-10_JPRB, 0.85674870E-10_JPRB, 0.85363626E-10_JPRB /)

RGHG9(:,54, 2) = (/ &
  & 0.84806898E-10_JPRB, 0.85269097E-10_JPRB, 0.85518002E-10_JPRB, 0.85825361E-10_JPRB, 0.86109037E-10_JPRB, 0.86340539E-10_JPRB, &
  & 0.86449611E-10_JPRB, 0.86495172E-10_JPRB, 0.86511166E-10_JPRB, 0.86515961E-10_JPRB, 0.86514962E-10_JPRB, 0.86509952E-10_JPRB, &
  & 0.86501792E-10_JPRB, 0.86487414E-10_JPRB, 0.86472718E-10_JPRB, 0.86457876E-10_JPRB, 0.86472086E-10_JPRB, 0.86537333E-10_JPRB, &
  & 0.86644372E-10_JPRB, 0.86782158E-10_JPRB, 0.86939934E-10_JPRB, 0.87111006E-10_JPRB, 0.87283895E-10_JPRB, 0.87447244E-10_JPRB, &
  & 0.87592683E-10_JPRB, 0.87712858E-10_JPRB, 0.87805714E-10_JPRB, 0.87869385E-10_JPRB, 0.87905704E-10_JPRB, 0.87915418E-10_JPRB, &
  & 0.87899930E-10_JPRB, 0.87860046E-10_JPRB, 0.87796818E-10_JPRB, 0.87714218E-10_JPRB, 0.87618912E-10_JPRB, 0.87518756E-10_JPRB, &
  & 0.87417490E-10_JPRB, 0.87314850E-10_JPRB, 0.87208407E-10_JPRB, 0.87098155E-10_JPRB, 0.86988278E-10_JPRB, 0.86893333E-10_JPRB, &
  & 0.86830439E-10_JPRB, 0.86813820E-10_JPRB, 0.86838051E-10_JPRB, 0.86880926E-10_JPRB, 0.86923434E-10_JPRB, 0.86950412E-10_JPRB, &
  & 0.86959336E-10_JPRB, 0.86950516E-10_JPRB, 0.86927673E-10_JPRB, 0.86898162E-10_JPRB, 0.86866514E-10_JPRB, 0.86838647E-10_JPRB, &
  & 0.86809566E-10_JPRB, 0.86779278E-10_JPRB, 0.86743730E-10_JPRB, 0.86699578E-10_JPRB, 0.86650645E-10_JPRB, 0.86598062E-10_JPRB, &
  & 0.86542842E-10_JPRB, 0.86483078E-10_JPRB, 0.86409227E-10_JPRB, 0.86272545E-10_JPRB /)

RGHG9(:,55, 2) = (/ &
  & 0.85535246E-10_JPRB, 0.85879463E-10_JPRB, 0.86122956E-10_JPRB, 0.86311278E-10_JPRB, 0.86498642E-10_JPRB, 0.86618643E-10_JPRB, &
  & 0.86671989E-10_JPRB, 0.86688275E-10_JPRB, 0.86692327E-10_JPRB, 0.86691286E-10_JPRB, 0.86687532E-10_JPRB, 0.86681717E-10_JPRB, &
  & 0.86672267E-10_JPRB, 0.86660429E-10_JPRB, 0.86639008E-10_JPRB, 0.86619850E-10_JPRB, 0.86611197E-10_JPRB, 0.86645399E-10_JPRB, &
  & 0.86729984E-10_JPRB, 0.86851748E-10_JPRB, 0.87000337E-10_JPRB, 0.87164193E-10_JPRB, 0.87333023E-10_JPRB, 0.87493464E-10_JPRB, &
  & 0.87636398E-10_JPRB, 0.87754720E-10_JPRB, 0.87844045E-10_JPRB, 0.87904420E-10_JPRB, 0.87936609E-10_JPRB, 0.87942729E-10_JPRB, &
  & 0.87923842E-10_JPRB, 0.87881126E-10_JPRB, 0.87816095E-10_JPRB, 0.87732877E-10_JPRB, 0.87638931E-10_JPRB, 0.87540808E-10_JPRB, &
  & 0.87442116E-10_JPRB, 0.87342703E-10_JPRB, 0.87240777E-10_JPRB, 0.87136687E-10_JPRB, 0.87037440E-10_JPRB, 0.86956213E-10_JPRB, &
  & 0.86912880E-10_JPRB, 0.86916377E-10_JPRB, 0.86955831E-10_JPRB, 0.87011121E-10_JPRB, 0.87058472E-10_JPRB, 0.87090925E-10_JPRB, &
  & 0.87107002E-10_JPRB, 0.87108473E-10_JPRB, 0.87099501E-10_JPRB, 0.87084617E-10_JPRB, 0.87069199E-10_JPRB, 0.87053323E-10_JPRB, &
  & 0.87038321E-10_JPRB, 0.87021411E-10_JPRB, 0.87000858E-10_JPRB, 0.86976301E-10_JPRB, 0.86947019E-10_JPRB, 0.86916030E-10_JPRB, &
  & 0.86883563E-10_JPRB, 0.86847189E-10_JPRB, 0.86801136E-10_JPRB, 0.86703061E-10_JPRB /)

RGHG9(:,56, 2) = (/ &
  & 0.86060568E-10_JPRB, 0.86368100E-10_JPRB, 0.86513158E-10_JPRB, 0.86640861E-10_JPRB, 0.86742502E-10_JPRB, 0.86802898E-10_JPRB, &
  & 0.86823326E-10_JPRB, 0.86827628E-10_JPRB, 0.86826581E-10_JPRB, 0.86823541E-10_JPRB, 0.86819482E-10_JPRB, 0.86813709E-10_JPRB, &
  & 0.86806354E-10_JPRB, 0.86793725E-10_JPRB, 0.86778543E-10_JPRB, 0.86751099E-10_JPRB, 0.86732933E-10_JPRB, 0.86746499E-10_JPRB, &
  & 0.86812023E-10_JPRB, 0.86921116E-10_JPRB, 0.87060199E-10_JPRB, 0.87218205E-10_JPRB, 0.87380915E-10_JPRB, 0.87538130E-10_JPRB, &
  & 0.87677927E-10_JPRB, 0.87793411E-10_JPRB, 0.87879974E-10_JPRB, 0.87936554E-10_JPRB, 0.87965392E-10_JPRB, 0.87968050E-10_JPRB, &
  & 0.87946046E-10_JPRB, 0.87900701E-10_JPRB, 0.87834129E-10_JPRB, 0.87750869E-10_JPRB, 0.87658034E-10_JPRB, 0.87561840E-10_JPRB, &
  & 0.87466000E-10_JPRB, 0.87369847E-10_JPRB, 0.87272696E-10_JPRB, 0.87175892E-10_JPRB, 0.87086234E-10_JPRB, 0.87019114E-10_JPRB, &
  & 0.86990672E-10_JPRB, 0.87008067E-10_JPRB, 0.87059381E-10_JPRB, 0.87118084E-10_JPRB, 0.87168654E-10_JPRB, 0.87201753E-10_JPRB, &
  & 0.87219398E-10_JPRB, 0.87224616E-10_JPRB, 0.87221452E-10_JPRB, 0.87213924E-10_JPRB, 0.87204771E-10_JPRB, 0.87196111E-10_JPRB, &
  & 0.87186827E-10_JPRB, 0.87176627E-10_JPRB, 0.87164331E-10_JPRB, 0.87148413E-10_JPRB, 0.87130414E-10_JPRB, 0.87110999E-10_JPRB, &
  & 0.87091022E-10_JPRB, 0.87070740E-10_JPRB, 0.87047911E-10_JPRB, 0.87012536E-10_JPRB /)

RGHG9(:,57, 2) = (/ &
  & 0.86468742E-10_JPRB, 0.86680489E-10_JPRB, 0.86784302E-10_JPRB, 0.86856286E-10_JPRB, 0.86907495E-10_JPRB, 0.86933821E-10_JPRB, &
  & 0.86939789E-10_JPRB, 0.86938470E-10_JPRB, 0.86935487E-10_JPRB, 0.86932198E-10_JPRB, 0.86928298E-10_JPRB, 0.86923690E-10_JPRB, &
  & 0.86916835E-10_JPRB, 0.86907884E-10_JPRB, 0.86890731E-10_JPRB, 0.86870053E-10_JPRB, 0.86841569E-10_JPRB, 0.86841263E-10_JPRB, &
  & 0.86892396E-10_JPRB, 0.86990068E-10_JPRB, 0.87120915E-10_JPRB, 0.87271128E-10_JPRB, 0.87429480E-10_JPRB, 0.87581192E-10_JPRB, &
  & 0.87718097E-10_JPRB, 0.87830250E-10_JPRB, 0.87913329E-10_JPRB, 0.87966884E-10_JPRB, 0.87992204E-10_JPRB, 0.87991843E-10_JPRB, &
  & 0.87967113E-10_JPRB, 0.87919588E-10_JPRB, 0.87851892E-10_JPRB, 0.87768723E-10_JPRB, 0.87677060E-10_JPRB, 0.87583198E-10_JPRB, &
  & 0.87489821E-10_JPRB, 0.87397589E-10_JPRB, 0.87305406E-10_JPRB, 0.87215707E-10_JPRB, 0.87136430E-10_JPRB, 0.87080849E-10_JPRB, &
  & 0.87064730E-10_JPRB, 0.87092680E-10_JPRB, 0.87148594E-10_JPRB, 0.87212362E-10_JPRB, 0.87261594E-10_JPRB, 0.87294151E-10_JPRB, &
  & 0.87311269E-10_JPRB, 0.87317348E-10_JPRB, 0.87316473E-10_JPRB, 0.87311935E-10_JPRB, 0.87306433E-10_JPRB, 0.87300438E-10_JPRB, &
  & 0.87294456E-10_JPRB, 0.87287552E-10_JPRB, 0.87278844E-10_JPRB, 0.87268207E-10_JPRB, 0.87255259E-10_JPRB, 0.87241464E-10_JPRB, &
  & 0.87227288E-10_JPRB, 0.87211918E-10_JPRB, 0.87194287E-10_JPRB, 0.87161833E-10_JPRB /)

RGHG9(:,58, 2) = (/ &
  & 0.86756519E-10_JPRB, 0.86905663E-10_JPRB, 0.86967093E-10_JPRB, 0.87004376E-10_JPRB, 0.87029946E-10_JPRB, 0.87038168E-10_JPRB, &
  & 0.87037037E-10_JPRB, 0.87033415E-10_JPRB, 0.87030175E-10_JPRB, 0.87026969E-10_JPRB, 0.87023805E-10_JPRB, 0.87019753E-10_JPRB, &
  & 0.87014645E-10_JPRB, 0.87005861E-10_JPRB, 0.86993669E-10_JPRB, 0.86969425E-10_JPRB, 0.86942953E-10_JPRB, 0.86932614E-10_JPRB, &
  & 0.86971853E-10_JPRB, 0.87059575E-10_JPRB, 0.87181568E-10_JPRB, 0.87325515E-10_JPRB, 0.87476901E-10_JPRB, 0.87624970E-10_JPRB, &
  & 0.87756989E-10_JPRB, 0.87865451E-10_JPRB, 0.87945227E-10_JPRB, 0.87995139E-10_JPRB, 0.88017538E-10_JPRB, 0.88014450E-10_JPRB, &
  & 0.87987603E-10_JPRB, 0.87938545E-10_JPRB, 0.87869934E-10_JPRB, 0.87787243E-10_JPRB, 0.87697009E-10_JPRB, 0.87605159E-10_JPRB, &
  & 0.87515120E-10_JPRB, 0.87426399E-10_JPRB, 0.87339601E-10_JPRB, 0.87257250E-10_JPRB, 0.87187146E-10_JPRB, 0.87142391E-10_JPRB, &
  & 0.87135778E-10_JPRB, 0.87169834E-10_JPRB, 0.87231111E-10_JPRB, 0.87294130E-10_JPRB, 0.87344076E-10_JPRB, 0.87374656E-10_JPRB, &
  & 0.87390324E-10_JPRB, 0.87395938E-10_JPRB, 0.87395591E-10_JPRB, 0.87392385E-10_JPRB, 0.87388027E-10_JPRB, 0.87383691E-10_JPRB, &
  & 0.87378937E-10_JPRB, 0.87373539E-10_JPRB, 0.87366947E-10_JPRB, 0.87358315E-10_JPRB, 0.87348406E-10_JPRB, 0.87337589E-10_JPRB, &
  & 0.87326230E-10_JPRB, 0.87314558E-10_JPRB, 0.87300486E-10_JPRB, 0.87276811E-10_JPRB /)

RGHG9(:,59, 2) = (/ &
  & 0.86970889E-10_JPRB, 0.87067201E-10_JPRB, 0.87099800E-10_JPRB, 0.87119076E-10_JPRB, 0.87127708E-10_JPRB, 0.87127638E-10_JPRB, &
  & 0.87123364E-10_JPRB, 0.87119284E-10_JPRB, 0.87115974E-10_JPRB, 0.87113330E-10_JPRB, 0.87110610E-10_JPRB, 0.87107530E-10_JPRB, &
  & 0.87102922E-10_JPRB, 0.87096302E-10_JPRB, 0.87083354E-10_JPRB, 0.87064016E-10_JPRB, 0.87033811E-10_JPRB, 0.87020037E-10_JPRB, &
  & 0.87051068E-10_JPRB, 0.87129685E-10_JPRB, 0.87243733E-10_JPRB, 0.87379971E-10_JPRB, 0.87526028E-10_JPRB, 0.87667956E-10_JPRB, &
  & 0.87795562E-10_JPRB, 0.87899528E-10_JPRB, 0.87975155E-10_JPRB, 0.88022006E-10_JPRB, 0.88041477E-10_JPRB, 0.88036245E-10_JPRB, &
  & 0.88007858E-10_JPRB, 0.87957884E-10_JPRB, 0.87889161E-10_JPRB, 0.87806963E-10_JPRB, 0.87718270E-10_JPRB, 0.87629112E-10_JPRB, &
  & 0.87541821E-10_JPRB, 0.87457305E-10_JPRB, 0.87375648E-10_JPRB, 0.87300216E-10_JPRB, 0.87238980E-10_JPRB, 0.87203272E-10_JPRB, &
  & 0.87204133E-10_JPRB, 0.87243185E-10_JPRB, 0.87304997E-10_JPRB, 0.87370021E-10_JPRB, 0.87417781E-10_JPRB, 0.87447161E-10_JPRB, &
  & 0.87461011E-10_JPRB, 0.87465632E-10_JPRB, 0.87464966E-10_JPRB, 0.87461829E-10_JPRB, 0.87458020E-10_JPRB, 0.87453919E-10_JPRB, &
  & 0.87449777E-10_JPRB, 0.87445023E-10_JPRB, 0.87439056E-10_JPRB, 0.87431853E-10_JPRB, 0.87423221E-10_JPRB, 0.87414020E-10_JPRB, &
  & 0.87404618E-10_JPRB, 0.87394370E-10_JPRB, 0.87382775E-10_JPRB, 0.87361000E-10_JPRB /)

RGHG9(:,60, 2) = (/ &
  & 0.87170271E-10_JPRB, 0.87195022E-10_JPRB, 0.87206527E-10_JPRB, 0.87211918E-10_JPRB, 0.87212890E-10_JPRB, 0.87208879E-10_JPRB, &
  & 0.87203370E-10_JPRB, 0.87199047E-10_JPRB, 0.87196181E-10_JPRB, 0.87193919E-10_JPRB, 0.87191920E-10_JPRB, 0.87189422E-10_JPRB, &
  & 0.87185988E-10_JPRB, 0.87179666E-10_JPRB, 0.87169147E-10_JPRB, 0.87148191E-10_JPRB, 0.87120172E-10_JPRB, 0.87104365E-10_JPRB, &
  & 0.87129838E-10_JPRB, 0.87200948E-10_JPRB, 0.87306953E-10_JPRB, 0.87436246E-10_JPRB, 0.87575391E-10_JPRB, 0.87711685E-10_JPRB, &
  & 0.87833456E-10_JPRB, 0.87932266E-10_JPRB, 0.88003868E-10_JPRB, 0.88047167E-10_JPRB, 0.88064230E-10_JPRB, 0.88057367E-10_JPRB, &
  & 0.88028175E-10_JPRB, 0.87978062E-10_JPRB, 0.87909707E-10_JPRB, 0.87828578E-10_JPRB, 0.87741744E-10_JPRB, 0.87654974E-10_JPRB, &
  & 0.87571020E-10_JPRB, 0.87490300E-10_JPRB, 0.87413743E-10_JPRB, 0.87344909E-10_JPRB, 0.87291424E-10_JPRB, 0.87263738E-10_JPRB, &
  & 0.87270705E-10_JPRB, 0.87312400E-10_JPRB, 0.87375454E-10_JPRB, 0.87438438E-10_JPRB, 0.87486254E-10_JPRB, 0.87513649E-10_JPRB, &
  & 0.87526063E-10_JPRB, 0.87529414E-10_JPRB, 0.87527874E-10_JPRB, 0.87524384E-10_JPRB, 0.87520172E-10_JPRB, 0.87516119E-10_JPRB, &
  & 0.87511817E-10_JPRB, 0.87507036E-10_JPRB, 0.87501360E-10_JPRB, 0.87494303E-10_JPRB, 0.87486442E-10_JPRB, 0.87478087E-10_JPRB, &
  & 0.87469448E-10_JPRB, 0.87460789E-10_JPRB, 0.87450408E-10_JPRB, 0.87433283E-10_JPRB /)

RGHG9(:,61, 2) = (/ &
  & 0.87267318E-10_JPRB, 0.87285221E-10_JPRB, 0.87290550E-10_JPRB, 0.87291993E-10_JPRB, 0.87290064E-10_JPRB, 0.87284582E-10_JPRB, &
  & 0.87278892E-10_JPRB, 0.87274812E-10_JPRB, 0.87272252E-10_JPRB, 0.87270642E-10_JPRB, 0.87269275E-10_JPRB, 0.87267749E-10_JPRB, &
  & 0.87265029E-10_JPRB, 0.87260033E-10_JPRB, 0.87249111E-10_JPRB, 0.87229536E-10_JPRB, 0.87201538E-10_JPRB, 0.87186688E-10_JPRB, &
  & 0.87208664E-10_JPRB, 0.87273161E-10_JPRB, 0.87371735E-10_JPRB, 0.87493866E-10_JPRB, 0.87625913E-10_JPRB, 0.87755470E-10_JPRB, &
  & 0.87870856E-10_JPRB, 0.87964129E-10_JPRB, 0.88031041E-10_JPRB, 0.88071064E-10_JPRB, 0.88085886E-10_JPRB, 0.88077948E-10_JPRB, &
  & 0.88048673E-10_JPRB, 0.87999205E-10_JPRB, 0.87932064E-10_JPRB, 0.87852454E-10_JPRB, 0.87767717E-10_JPRB, 0.87683534E-10_JPRB, &
  & 0.87602647E-10_JPRB, 0.87525633E-10_JPRB, 0.87453877E-10_JPRB, 0.87390997E-10_JPRB, 0.87344569E-10_JPRB, 0.87323801E-10_JPRB, &
  & 0.87335715E-10_JPRB, 0.87379382E-10_JPRB, 0.87441485E-10_JPRB, 0.87503713E-10_JPRB, 0.87549544E-10_JPRB, 0.87576238E-10_JPRB, &
  & 0.87587174E-10_JPRB, 0.87589214E-10_JPRB, 0.87586577E-10_JPRB, 0.87582080E-10_JPRB, 0.87577376E-10_JPRB, 0.87572630E-10_JPRB, &
  & 0.87567946E-10_JPRB, 0.87562776E-10_JPRB, 0.87556656E-10_JPRB, 0.87549620E-10_JPRB, 0.87541738E-10_JPRB, 0.87533619E-10_JPRB, &
  & 0.87525549E-10_JPRB, 0.87517028E-10_JPRB, 0.87507716E-10_JPRB, 0.87490862E-10_JPRB /)

RGHG9(:,62, 2) = (/ &
  & 0.87350738E-10_JPRB, 0.87362298E-10_JPRB, 0.87365157E-10_JPRB, 0.87364851E-10_JPRB, 0.87361944E-10_JPRB, 0.87356823E-10_JPRB, &
  & 0.87351168E-10_JPRB, 0.87347220E-10_JPRB, 0.87345131E-10_JPRB, 0.87344160E-10_JPRB, 0.87343813E-10_JPRB, 0.87343424E-10_JPRB, &
  & 0.87342099E-10_JPRB, 0.87337734E-10_JPRB, 0.87327590E-10_JPRB, 0.87307245E-10_JPRB, 0.87281210E-10_JPRB, 0.87267964E-10_JPRB, &
  & 0.87287538E-10_JPRB, 0.87346422E-10_JPRB, 0.87438161E-10_JPRB, 0.87552826E-10_JPRB, 0.87677518E-10_JPRB, 0.87799407E-10_JPRB, &
  & 0.87907917E-10_JPRB, 0.87994931E-10_JPRB, 0.88057089E-10_JPRB, 0.88093657E-10_JPRB, 0.88106598E-10_JPRB, 0.88098126E-10_JPRB, &
  & 0.88069455E-10_JPRB, 0.88021514E-10_JPRB, 0.87956253E-10_JPRB, 0.87878961E-10_JPRB, 0.87796430E-10_JPRB, 0.87715044E-10_JPRB, &
  & 0.87636849E-10_JPRB, 0.87563456E-10_JPRB, 0.87495934E-10_JPRB, 0.87438633E-10_JPRB, 0.87398401E-10_JPRB, 0.87383635E-10_JPRB, &
  & 0.87399650E-10_JPRB, 0.87444545E-10_JPRB, 0.87505440E-10_JPRB, 0.87565108E-10_JPRB, 0.87609905E-10_JPRB, 0.87635316E-10_JPRB, &
  & 0.87645440E-10_JPRB, 0.87646237E-10_JPRB, 0.87642317E-10_JPRB, 0.87636801E-10_JPRB, 0.87630958E-10_JPRB, 0.87625497E-10_JPRB, &
  & 0.87619939E-10_JPRB, 0.87613986E-10_JPRB, 0.87607296E-10_JPRB, 0.87599594E-10_JPRB, 0.87591490E-10_JPRB, 0.87583260E-10_JPRB, &
  & 0.87575003E-10_JPRB, 0.87566912E-10_JPRB, 0.87557545E-10_JPRB, 0.87542161E-10_JPRB /)

RGHG9(:,63, 2) = (/ &
  & 0.87422056E-10_JPRB, 0.87431881E-10_JPRB, 0.87433880E-10_JPRB, 0.87433290E-10_JPRB, 0.87430695E-10_JPRB, 0.87425928E-10_JPRB, &
  & 0.87420807E-10_JPRB, 0.87417018E-10_JPRB, 0.87415297E-10_JPRB, 0.87415214E-10_JPRB, 0.87416234E-10_JPRB, 0.87417545E-10_JPRB, &
  & 0.87417865E-10_JPRB, 0.87414652E-10_JPRB, 0.87404001E-10_JPRB, 0.87384155E-10_JPRB, 0.87360376E-10_JPRB, 0.87348920E-10_JPRB, &
  & 0.87366836E-10_JPRB, 0.87420821E-10_JPRB, 0.87505954E-10_JPRB, 0.87613264E-10_JPRB, 0.87729636E-10_JPRB, 0.87843698E-10_JPRB, &
  & 0.87944312E-10_JPRB, 0.88024928E-10_JPRB, 0.88081945E-10_JPRB, 0.88115147E-10_JPRB, 0.88126395E-10_JPRB, 0.88117812E-10_JPRB, &
  & 0.88090438E-10_JPRB, 0.88044697E-10_JPRB, 0.87982309E-10_JPRB, 0.87907771E-10_JPRB, 0.87828328E-10_JPRB, 0.87749259E-10_JPRB, &
  & 0.87674160E-10_JPRB, 0.87603660E-10_JPRB, 0.87540322E-10_JPRB, 0.87487850E-10_JPRB, 0.87453156E-10_JPRB, 0.87443539E-10_JPRB, &
  & 0.87462870E-10_JPRB, 0.87508299E-10_JPRB, 0.87567398E-10_JPRB, 0.87624595E-10_JPRB, 0.87667269E-10_JPRB, 0.87692027E-10_JPRB, &
  & 0.87701416E-10_JPRB, 0.87701249E-10_JPRB, 0.87696198E-10_JPRB, 0.87689328E-10_JPRB, 0.87682459E-10_JPRB, 0.87675728E-10_JPRB, &
  & 0.87669157E-10_JPRB, 0.87662169E-10_JPRB, 0.87654356E-10_JPRB, 0.87645946E-10_JPRB, 0.87637168E-10_JPRB, 0.87628439E-10_JPRB, &
  & 0.87619967E-10_JPRB, 0.87611321E-10_JPRB, 0.87601919E-10_JPRB, 0.87585654E-10_JPRB /)

RGHG9(:,64, 2) = (/ &
  & 0.87487337E-10_JPRB, 0.87496593E-10_JPRB, 0.87498744E-10_JPRB, 0.87498495E-10_JPRB, 0.87496413E-10_JPRB, 0.87492610E-10_JPRB, &
  & 0.87487934E-10_JPRB, 0.87484513E-10_JPRB, 0.87483229E-10_JPRB, 0.87484173E-10_JPRB, 0.87486809E-10_JPRB, 0.87490397E-10_JPRB, &
  & 0.87492395E-10_JPRB, 0.87489668E-10_JPRB, 0.87479170E-10_JPRB, 0.87460220E-10_JPRB, 0.87438931E-10_JPRB, 0.87429189E-10_JPRB, &
  & 0.87445926E-10_JPRB, 0.87495726E-10_JPRB, 0.87574642E-10_JPRB, 0.87673993E-10_JPRB, 0.87782115E-10_JPRB, 0.87887086E-10_JPRB, &
  & 0.87979839E-10_JPRB, 0.88053495E-10_JPRB, 0.88105370E-10_JPRB, 0.88135207E-10_JPRB, 0.88144984E-10_JPRB, 0.88136637E-10_JPRB, &
  & 0.88110956E-10_JPRB, 0.88068094E-10_JPRB, 0.88009162E-10_JPRB, 0.87938525E-10_JPRB, 0.87862093E-10_JPRB, 0.87786403E-10_JPRB, &
  & 0.87713635E-10_JPRB, 0.87646473E-10_JPRB, 0.87586619E-10_JPRB, 0.87538726E-10_JPRB, 0.87508785E-10_JPRB, 0.87503456E-10_JPRB, &
  & 0.87525286E-10_JPRB, 0.87570652E-10_JPRB, 0.87627565E-10_JPRB, 0.87681667E-10_JPRB, 0.87722364E-10_JPRB, 0.87745984E-10_JPRB, &
  & 0.87755039E-10_JPRB, 0.87754276E-10_JPRB, 0.87748239E-10_JPRB, 0.87740273E-10_JPRB, 0.87732016E-10_JPRB, 0.87724134E-10_JPRB, &
  & 0.87716195E-10_JPRB, 0.87707827E-10_JPRB, 0.87698890E-10_JPRB, 0.87689314E-10_JPRB, 0.87679711E-10_JPRB, 0.87670274E-10_JPRB, &
  & 0.87660990E-10_JPRB, 0.87651830E-10_JPRB, 0.87641380E-10_JPRB, 0.87623901E-10_JPRB /)

RGHG9(:,65, 2) = (/ &
  & 0.87547296E-10_JPRB, 0.87557614E-10_JPRB, 0.87560438E-10_JPRB, 0.87560903E-10_JPRB, 0.87559654E-10_JPRB, 0.87556698E-10_JPRB, &
  & 0.87552958E-10_JPRB, 0.87549960E-10_JPRB, 0.87549405E-10_JPRB, 0.87551674E-10_JPRB, 0.87556240E-10_JPRB, 0.87561701E-10_JPRB, &
  & 0.87564962E-10_JPRB, 0.87562714E-10_JPRB, 0.87552715E-10_JPRB, 0.87535285E-10_JPRB, 0.87516397E-10_JPRB, 0.87508348E-10_JPRB, &
  & 0.87524418E-10_JPRB, 0.87570402E-10_JPRB, 0.87643115E-10_JPRB, 0.87734583E-10_JPRB, 0.87833428E-10_JPRB, 0.87929442E-10_JPRB, &
  & 0.88013548E-10_JPRB, 0.88080328E-10_JPRB, 0.88126950E-10_JPRB, 0.88153547E-10_JPRB, 0.88161992E-10_JPRB, 0.88154033E-10_JPRB, &
  & 0.88130336E-10_JPRB, 0.88090688E-10_JPRB, 0.88035940E-10_JPRB, 0.87969590E-10_JPRB, 0.87897314E-10_JPRB, 0.87824734E-10_JPRB, &
  & 0.87755359E-10_JPRB, 0.87691070E-10_JPRB, 0.87634941E-10_JPRB, 0.87591059E-10_JPRB, 0.87565351E-10_JPRB, 0.87563436E-10_JPRB, &
  & 0.87586889E-10_JPRB, 0.87631485E-10_JPRB, 0.87685775E-10_JPRB, 0.87736728E-10_JPRB, 0.87774912E-10_JPRB, 0.87797512E-10_JPRB, &
  & 0.87806158E-10_JPRB, 0.87805131E-10_JPRB, 0.87798491E-10_JPRB, 0.87789567E-10_JPRB, 0.87780241E-10_JPRB, 0.87770916E-10_JPRB, &
  & 0.87761617E-10_JPRB, 0.87751917E-10_JPRB, 0.87741481E-10_JPRB, 0.87730871E-10_JPRB, 0.87720262E-10_JPRB, 0.87709839E-10_JPRB, &
  & 0.87699667E-10_JPRB, 0.87689120E-10_JPRB, 0.87677227E-10_JPRB, 0.87656479E-10_JPRB /)

RGHG9(:,66, 2) = (/ &
  & 0.87603265E-10_JPRB, 0.87615443E-10_JPRB, 0.87619446E-10_JPRB, 0.87620897E-10_JPRB, 0.87620584E-10_JPRB, 0.87618662E-10_JPRB, &
  & 0.87615810E-10_JPRB, 0.87613833E-10_JPRB, 0.87614367E-10_JPRB, 0.87617975E-10_JPRB, 0.87624477E-10_JPRB, 0.87631249E-10_JPRB, &
  & 0.87635260E-10_JPRB, 0.87633560E-10_JPRB, 0.87624491E-10_JPRB, 0.87608767E-10_JPRB, 0.87592239E-10_JPRB, 0.87585952E-10_JPRB, &
  & 0.87601440E-10_JPRB, 0.87643892E-10_JPRB, 0.87710401E-10_JPRB, 0.87793474E-10_JPRB, 0.87883104E-10_JPRB, 0.87969562E-10_JPRB, &
  & 0.88045279E-10_JPRB, 0.88105016E-10_JPRB, 0.88146553E-10_JPRB, 0.88170048E-10_JPRB, 0.88177257E-10_JPRB, 0.88169798E-10_JPRB, &
  & 0.88148135E-10_JPRB, 0.88111865E-10_JPRB, 0.88061516E-10_JPRB, 0.88000107E-10_JPRB, 0.87932286E-10_JPRB, 0.87863966E-10_JPRB, &
  & 0.87797929E-10_JPRB, 0.87737276E-10_JPRB, 0.87684721E-10_JPRB, 0.87644739E-10_JPRB, 0.87622673E-10_JPRB, 0.87623450E-10_JPRB, &
  & 0.87647695E-10_JPRB, 0.87690764E-10_JPRB, 0.87741987E-10_JPRB, 0.87789651E-10_JPRB, 0.87825296E-10_JPRB, 0.87846480E-10_JPRB, &
  & 0.87854737E-10_JPRB, 0.87853572E-10_JPRB, 0.87846751E-10_JPRB, 0.87837217E-10_JPRB, 0.87826982E-10_JPRB, 0.87816650E-10_JPRB, &
  & 0.87806068E-10_JPRB, 0.87794903E-10_JPRB, 0.87783406E-10_JPRB, 0.87771512E-10_JPRB, 0.87759945E-10_JPRB, 0.87748572E-10_JPRB, &
  & 0.87736998E-10_JPRB, 0.87725063E-10_JPRB, 0.87710582E-10_JPRB, 0.87685310E-10_JPRB /)

RGHG9(:,67, 2) = (/ &
  & 0.87656833E-10_JPRB, 0.87671148E-10_JPRB, 0.87676290E-10_JPRB, 0.87678850E-10_JPRB, 0.87679600E-10_JPRB, 0.87678774E-10_JPRB, &
  & 0.87677046E-10_JPRB, 0.87676200E-10_JPRB, 0.87678018E-10_JPRB, 0.87683374E-10_JPRB, 0.87690993E-10_JPRB, 0.87698730E-10_JPRB, &
  & 0.87703247E-10_JPRB, 0.87702200E-10_JPRB, 0.87694164E-10_JPRB, 0.87680252E-10_JPRB, 0.87666020E-10_JPRB, 0.87661267E-10_JPRB, &
  & 0.87676144E-10_JPRB, 0.87714919E-10_JPRB, 0.87775107E-10_JPRB, 0.87849859E-10_JPRB, 0.87930059E-10_JPRB, 0.88007275E-10_JPRB, &
  & 0.88074603E-10_JPRB, 0.88127672E-10_JPRB, 0.88164254E-10_JPRB, 0.88184862E-10_JPRB, 0.88190920E-10_JPRB, 0.88183960E-10_JPRB, &
  & 0.88164281E-10_JPRB, 0.88131363E-10_JPRB, 0.88085580E-10_JPRB, 0.88029216E-10_JPRB, 0.87966572E-10_JPRB, 0.87902741E-10_JPRB, &
  & 0.87840929E-10_JPRB, 0.87784092E-10_JPRB, 0.87735486E-10_JPRB, 0.87699278E-10_JPRB, 0.87680543E-10_JPRB, 0.87683305E-10_JPRB, &
  & 0.87707577E-10_JPRB, 0.87748503E-10_JPRB, 0.87796360E-10_JPRB, 0.87840353E-10_JPRB, 0.87873514E-10_JPRB, 0.87893172E-10_JPRB, &
  & 0.87900846E-10_JPRB, 0.87899618E-10_JPRB, 0.87892707E-10_JPRB, 0.87883076E-10_JPRB, 0.87872397E-10_JPRB, 0.87861274E-10_JPRB, &
  & 0.87849776E-10_JPRB, 0.87837751E-10_JPRB, 0.87824997E-10_JPRB, 0.87812382E-10_JPRB, 0.87799865E-10_JPRB, 0.87787479E-10_JPRB, &
  & 0.87774857E-10_JPRB, 0.87760660E-10_JPRB, 0.87743264E-10_JPRB, 0.87710575E-10_JPRB /)

RGHG9(:,68, 2) = (/ &
  & 0.87705974E-10_JPRB, 0.87723676E-10_JPRB, 0.87730830E-10_JPRB, 0.87734833E-10_JPRB, 0.87736915E-10_JPRB, 0.87737304E-10_JPRB, &
  & 0.87736853E-10_JPRB, 0.87737345E-10_JPRB, 0.87740655E-10_JPRB, 0.87747212E-10_JPRB, 0.87755837E-10_JPRB, 0.87763997E-10_JPRB, &
  & 0.87768834E-10_JPRB, 0.87768348E-10_JPRB, 0.87761395E-10_JPRB, 0.87749231E-10_JPRB, 0.87737088E-10_JPRB, 0.87733529E-10_JPRB, &
  & 0.87747372E-10_JPRB, 0.87782379E-10_JPRB, 0.87836217E-10_JPRB, 0.87902727E-10_JPRB, 0.87973934E-10_JPRB, 0.88042219E-10_JPRB, &
  & 0.88101755E-10_JPRB, 0.88148343E-10_JPRB, 0.88180421E-10_JPRB, 0.88198233E-10_JPRB, 0.88203243E-10_JPRB, 0.88196783E-10_JPRB, &
  & 0.88179013E-10_JPRB, 0.88149377E-10_JPRB, 0.88108083E-10_JPRB, 0.88056902E-10_JPRB, 0.87999552E-10_JPRB, 0.87940800E-10_JPRB, &
  & 0.87883471E-10_JPRB, 0.87830999E-10_JPRB, 0.87786479E-10_JPRB, 0.87754082E-10_JPRB, 0.87738365E-10_JPRB, 0.87742633E-10_JPRB, &
  & 0.87766364E-10_JPRB, 0.87804736E-10_JPRB, 0.87848673E-10_JPRB, 0.87889314E-10_JPRB, 0.87919512E-10_JPRB, 0.87937692E-10_JPRB, &
  & 0.87944707E-10_JPRB, 0.87943375E-10_JPRB, 0.87936644E-10_JPRB, 0.87927041E-10_JPRB, 0.87916334E-10_JPRB, 0.87904947E-10_JPRB, &
  & 0.87893033E-10_JPRB, 0.87880321E-10_JPRB, 0.87867193E-10_JPRB, 0.87853766E-10_JPRB, 0.87840825E-10_JPRB, 0.87827814E-10_JPRB, &
  & 0.87814006E-10_JPRB, 0.87798331E-10_JPRB, 0.87776647E-10_JPRB, 0.87735763E-10_JPRB /)

RGHG9(:,69, 2) = (/ &
  & 0.87752874E-10_JPRB, 0.87774829E-10_JPRB, 0.87783891E-10_JPRB, 0.87789595E-10_JPRB, 0.87793058E-10_JPRB, 0.87794806E-10_JPRB, &
  & 0.87795694E-10_JPRB, 0.87797616E-10_JPRB, 0.87802272E-10_JPRB, 0.87809773E-10_JPRB, 0.87818801E-10_JPRB, 0.87827114E-10_JPRB, &
  & 0.87832033E-10_JPRB, 0.87831999E-10_JPRB, 0.87825969E-10_JPRB, 0.87815429E-10_JPRB, 0.87804909E-10_JPRB, 0.87802134E-10_JPRB, &
  & 0.87814582E-10_JPRB, 0.87845661E-10_JPRB, 0.87893297E-10_JPRB, 0.87952007E-10_JPRB, 0.88014582E-10_JPRB, 0.88074645E-10_JPRB, &
  & 0.88126707E-10_JPRB, 0.88167432E-10_JPRB, 0.88195166E-10_JPRB, 0.88210494E-10_JPRB, 0.88214547E-10_JPRB, 0.88208545E-10_JPRB, &
  & 0.88192668E-10_JPRB, 0.88166162E-10_JPRB, 0.88129344E-10_JPRB, 0.88083305E-10_JPRB, 0.88031388E-10_JPRB, 0.87977819E-10_JPRB, &
  & 0.87925417E-10_JPRB, 0.87877497E-10_JPRB, 0.87837272E-10_JPRB, 0.87808656E-10_JPRB, 0.87795750E-10_JPRB, 0.87801093E-10_JPRB, &
  & 0.87823943E-10_JPRB, 0.87859317E-10_JPRB, 0.87899528E-10_JPRB, 0.87936158E-10_JPRB, 0.87963865E-10_JPRB, 0.87980248E-10_JPRB, &
  & 0.87986660E-10_JPRB, 0.87985265E-10_JPRB, 0.87978756E-10_JPRB, 0.87969534E-10_JPRB, 0.87959084E-10_JPRB, 0.87947843E-10_JPRB, &
  & 0.87935936E-10_JPRB, 0.87923203E-10_JPRB, 0.87909874E-10_JPRB, 0.87896461E-10_JPRB, 0.87883201E-10_JPRB, 0.87870031E-10_JPRB, &
  & 0.87855820E-10_JPRB, 0.87838563E-10_JPRB, 0.87813506E-10_JPRB, 0.87763005E-10_JPRB /)

RGHG9(:,70, 2) = (/ &
  & 0.87798047E-10_JPRB, 0.87824609E-10_JPRB, 0.87836349E-10_JPRB, 0.87843739E-10_JPRB, 0.87848721E-10_JPRB, 0.87851726E-10_JPRB, &
  & 0.87854002E-10_JPRB, 0.87857277E-10_JPRB, 0.87862898E-10_JPRB, 0.87870995E-10_JPRB, 0.87879898E-10_JPRB, 0.87887968E-10_JPRB, &
  & 0.87892693E-10_JPRB, 0.87892874E-10_JPRB, 0.87887676E-10_JPRB, 0.87878357E-10_JPRB, 0.87869191E-10_JPRB, 0.87866749E-10_JPRB, &
  & 0.87877573E-10_JPRB, 0.87904781E-10_JPRB, 0.87946470E-10_JPRB, 0.87997651E-10_JPRB, 0.88052288E-10_JPRB, 0.88104468E-10_JPRB, &
  & 0.88149751E-10_JPRB, 0.88184904E-10_JPRB, 0.88208753E-10_JPRB, 0.88221749E-10_JPRB, 0.88224969E-10_JPRB, 0.88219494E-10_JPRB, &
  & 0.88205360E-10_JPRB, 0.88181983E-10_JPRB, 0.88149460E-10_JPRB, 0.88108597E-10_JPRB, 0.88062002E-10_JPRB, 0.88013978E-10_JPRB, &
  & 0.87966467E-10_JPRB, 0.87923412E-10_JPRB, 0.87887517E-10_JPRB, 0.87862585E-10_JPRB, 0.87852212E-10_JPRB, 0.87858380E-10_JPRB, &
  & 0.87880050E-10_JPRB, 0.87912372E-10_JPRB, 0.87948523E-10_JPRB, 0.87981566E-10_JPRB, 0.88006206E-10_JPRB, 0.88021042E-10_JPRB, &
  & 0.88026732E-10_JPRB, 0.88025399E-10_JPRB, 0.88019314E-10_JPRB, 0.88010640E-10_JPRB, 0.88000836E-10_JPRB, 0.87990087E-10_JPRB, &
  & 0.87978701E-10_JPRB, 0.87966370E-10_JPRB, 0.87953450E-10_JPRB, 0.87940280E-10_JPRB, 0.87927353E-10_JPRB, 0.87914322E-10_JPRB, &
  & 0.87900194E-10_JPRB, 0.87882486E-10_JPRB, 0.87854987E-10_JPRB, 0.87797256E-10_JPRB /)

RGHG9(:,71, 2) = (/ &
  & 0.87842636E-10_JPRB, 0.87874881E-10_JPRB, 0.87888807E-10_JPRB, 0.87897960E-10_JPRB, 0.87904142E-10_JPRB, 0.87908375E-10_JPRB, &
  & 0.87911803E-10_JPRB, 0.87916174E-10_JPRB, 0.87922523E-10_JPRB, 0.87930434E-10_JPRB, 0.87938955E-10_JPRB, 0.87946248E-10_JPRB, &
  & 0.87950605E-10_JPRB, 0.87950806E-10_JPRB, 0.87946178E-10_JPRB, 0.87937893E-10_JPRB, 0.87929657E-10_JPRB, 0.87927401E-10_JPRB, &
  & 0.87936547E-10_JPRB, 0.87959924E-10_JPRB, 0.87995888E-10_JPRB, 0.88040068E-10_JPRB, 0.88087024E-10_JPRB, 0.88132009E-10_JPRB, &
  & 0.88170880E-10_JPRB, 0.88200995E-10_JPRB, 0.88221229E-10_JPRB, 0.88232137E-10_JPRB, 0.88234663E-10_JPRB, 0.88229694E-10_JPRB, &
  & 0.88217357E-10_JPRB, 0.88196957E-10_JPRB, 0.88168688E-10_JPRB, 0.88132633E-10_JPRB, 0.88091666E-10_JPRB, 0.88048985E-10_JPRB, &
  & 0.88006720E-10_JPRB, 0.87968466E-10_JPRB, 0.87936894E-10_JPRB, 0.87915543E-10_JPRB, 0.87907480E-10_JPRB, 0.87914190E-10_JPRB, &
  & 0.87934389E-10_JPRB, 0.87963622E-10_JPRB, 0.87995750E-10_JPRB, 0.88024851E-10_JPRB, 0.88046799E-10_JPRB, 0.88059796E-10_JPRB, &
  & 0.88064910E-10_JPRB, 0.88063709E-10_JPRB, 0.88058158E-10_JPRB, 0.88050352E-10_JPRB, 0.88041345E-10_JPRB, 0.88031672E-10_JPRB, &
  & 0.88021097E-10_JPRB, 0.88009669E-10_JPRB, 0.87997575E-10_JPRB, 0.87985078E-10_JPRB, 0.87972775E-10_JPRB, 0.87960424E-10_JPRB, &
  & 0.87946726E-10_JPRB, 0.87929393E-10_JPRB, 0.87900950E-10_JPRB, 0.87839493E-10_JPRB /)

RGHG9(:,72, 2) = (/ &
  & 0.87888211E-10_JPRB, 0.87925736E-10_JPRB, 0.87942008E-10_JPRB, 0.87952347E-10_JPRB, 0.87959397E-10_JPRB, 0.87964427E-10_JPRB, &
  & 0.87968847E-10_JPRB, 0.87973948E-10_JPRB, 0.87980304E-10_JPRB, 0.87987978E-10_JPRB, 0.87995278E-10_JPRB, 0.88001828E-10_JPRB, &
  & 0.88005464E-10_JPRB, 0.88005492E-10_JPRB, 0.88001245E-10_JPRB, 0.87993751E-10_JPRB, 0.87986340E-10_JPRB, 0.87984064E-10_JPRB, &
  & 0.87991614E-10_JPRB, 0.88011376E-10_JPRB, 0.88041886E-10_JPRB, 0.88079266E-10_JPRB, 0.88119206E-10_JPRB, 0.88157349E-10_JPRB, &
  & 0.88190330E-10_JPRB, 0.88215810E-10_JPRB, 0.88232720E-10_JPRB, 0.88241761E-10_JPRB, 0.88243718E-10_JPRB, 0.88239319E-10_JPRB, &
  & 0.88228654E-10_JPRB, 0.88211237E-10_JPRB, 0.88186854E-10_JPRB, 0.88155830E-10_JPRB, 0.88120143E-10_JPRB, 0.88083138E-10_JPRB, &
  & 0.88045876E-10_JPRB, 0.88012590E-10_JPRB, 0.87985265E-10_JPRB, 0.87967328E-10_JPRB, 0.87961305E-10_JPRB, 0.87968209E-10_JPRB, &
  & 0.87986840E-10_JPRB, 0.88012583E-10_JPRB, 0.88040693E-10_JPRB, 0.88066179E-10_JPRB, 0.88085088E-10_JPRB, 0.88096433E-10_JPRB, &
  & 0.88100964E-10_JPRB, 0.88099958E-10_JPRB, 0.88095149E-10_JPRB, 0.88088196E-10_JPRB, 0.88080571E-10_JPRB, 0.88071814E-10_JPRB, &
  & 0.88062634E-10_JPRB, 0.88052302E-10_JPRB, 0.88041317E-10_JPRB, 0.88029889E-10_JPRB, 0.88018516E-10_JPRB, 0.88007046E-10_JPRB, &
  & 0.87994348E-10_JPRB, 0.87977840E-10_JPRB, 0.87949738E-10_JPRB, 0.87886254E-10_JPRB /)

RGHG9(:,73, 2) = (/ &
  & 0.87939933E-10_JPRB, 0.87979186E-10_JPRB, 0.87995944E-10_JPRB, 0.88006422E-10_JPRB, 0.88013700E-10_JPRB, 0.88019168E-10_JPRB, &
  & 0.88024033E-10_JPRB, 0.88029389E-10_JPRB, 0.88035627E-10_JPRB, 0.88042108E-10_JPRB, 0.88048763E-10_JPRB, 0.88053904E-10_JPRB, &
  & 0.88056909E-10_JPRB, 0.88056652E-10_JPRB, 0.88052621E-10_JPRB, 0.88045737E-10_JPRB, 0.88039055E-10_JPRB, 0.88036772E-10_JPRB, &
  & 0.88042899E-10_JPRB, 0.88059220E-10_JPRB, 0.88084498E-10_JPRB, 0.88115640E-10_JPRB, 0.88148905E-10_JPRB, 0.88180768E-10_JPRB, &
  & 0.88208281E-10_JPRB, 0.88229424E-10_JPRB, 0.88243336E-10_JPRB, 0.88250733E-10_JPRB, 0.88252239E-10_JPRB, 0.88248395E-10_JPRB, &
  & 0.88239430E-10_JPRB, 0.88224712E-10_JPRB, 0.88204236E-10_JPRB, 0.88177923E-10_JPRB, 0.88147580E-10_JPRB, 0.88115917E-10_JPRB, &
  & 0.88084005E-10_JPRB, 0.88055473E-10_JPRB, 0.88032345E-10_JPRB, 0.88017593E-10_JPRB, 0.88013340E-10_JPRB, 0.88020174E-10_JPRB, &
  & 0.88036661E-10_JPRB, 0.88059060E-10_JPRB, 0.88083173E-10_JPRB, 0.88104704E-10_JPRB, 0.88121080E-10_JPRB, 0.88130656E-10_JPRB, &
  & 0.88134597E-10_JPRB, 0.88133875E-10_JPRB, 0.88129781E-10_JPRB, 0.88124050E-10_JPRB, 0.88117375E-10_JPRB, 0.88110241E-10_JPRB, &
  & 0.88102130E-10_JPRB, 0.88093255E-10_JPRB, 0.88083645E-10_JPRB, 0.88073340E-10_JPRB, 0.88063230E-10_JPRB, 0.88052933E-10_JPRB, &
  & 0.88041421E-10_JPRB, 0.88026350E-10_JPRB, 0.87999413E-10_JPRB, 0.87936450E-10_JPRB /)

RGHG9(:,74, 2) = (/ &
  & 0.87992363E-10_JPRB, 0.88032664E-10_JPRB, 0.88048804E-10_JPRB, 0.88059053E-10_JPRB, 0.88065936E-10_JPRB, 0.88071300E-10_JPRB, &
  & 0.88076248E-10_JPRB, 0.88081389E-10_JPRB, 0.88086871E-10_JPRB, 0.88092797E-10_JPRB, 0.88097904E-10_JPRB, 0.88102400E-10_JPRB, &
  & 0.88104510E-10_JPRB, 0.88103934E-10_JPRB, 0.88100104E-10_JPRB, 0.88093866E-10_JPRB, 0.88087822E-10_JPRB, 0.88085567E-10_JPRB, &
  & 0.88090452E-10_JPRB, 0.88103545E-10_JPRB, 0.88123973E-10_JPRB, 0.88149238E-10_JPRB, 0.88176369E-10_JPRB, 0.88202445E-10_JPRB, &
  & 0.88224809E-10_JPRB, 0.88242039E-10_JPRB, 0.88253155E-10_JPRB, 0.88259081E-10_JPRB, 0.88260267E-10_JPRB, 0.88256992E-10_JPRB, &
  & 0.88249602E-10_JPRB, 0.88237508E-10_JPRB, 0.88220757E-10_JPRB, 0.88199038E-10_JPRB, 0.88173767E-10_JPRB, 0.88147455E-10_JPRB, &
  & 0.88120719E-10_JPRB, 0.88097002E-10_JPRB, 0.88077837E-10_JPRB, 0.88066075E-10_JPRB, 0.88063265E-10_JPRB, 0.88069566E-10_JPRB, &
  & 0.88083943E-10_JPRB, 0.88102609E-10_JPRB, 0.88122620E-10_JPRB, 0.88140890E-10_JPRB, 0.88154331E-10_JPRB, 0.88162366E-10_JPRB, &
  & 0.88165766E-10_JPRB, 0.88165295E-10_JPRB, 0.88161992E-10_JPRB, 0.88157162E-10_JPRB, 0.88151965E-10_JPRB, 0.88145755E-10_JPRB, &
  & 0.88139190E-10_JPRB, 0.88131613E-10_JPRB, 0.88123439E-10_JPRB, 0.88114641E-10_JPRB, 0.88105835E-10_JPRB, 0.88096912E-10_JPRB, &
  & 0.88086920E-10_JPRB, 0.88073618E-10_JPRB, 0.88048728E-10_JPRB, 0.87988443E-10_JPRB /)

RGHG9(:,75, 2) = (/ &
  & 0.88044981E-10_JPRB, 0.88084443E-10_JPRB, 0.88099798E-10_JPRB, 0.88108930E-10_JPRB, 0.88115140E-10_JPRB, 0.88120025E-10_JPRB, &
  & 0.88124605E-10_JPRB, 0.88129185E-10_JPRB, 0.88134049E-10_JPRB, 0.88138712E-10_JPRB, 0.88143173E-10_JPRB, 0.88146448E-10_JPRB, &
  & 0.88148017E-10_JPRB, 0.88147212E-10_JPRB, 0.88143631E-10_JPRB, 0.88138052E-10_JPRB, 0.88132800E-10_JPRB, 0.88130669E-10_JPRB, &
  & 0.88134416E-10_JPRB, 0.88144568E-10_JPRB, 0.88160562E-10_JPRB, 0.88180435E-10_JPRB, 0.88201918E-10_JPRB, 0.88222540E-10_JPRB, &
  & 0.88240193E-10_JPRB, 0.88253752E-10_JPRB, 0.88262363E-10_JPRB, 0.88266935E-10_JPRB, 0.88267893E-10_JPRB, 0.88265180E-10_JPRB, &
  & 0.88259303E-10_JPRB, 0.88249623E-10_JPRB, 0.88236474E-10_JPRB, 0.88219002E-10_JPRB, 0.88198872E-10_JPRB, 0.88177458E-10_JPRB, &
  & 0.88156038E-10_JPRB, 0.88136914E-10_JPRB, 0.88121621E-10_JPRB, 0.88112524E-10_JPRB, 0.88110817E-10_JPRB, 0.88116410E-10_JPRB, &
  & 0.88128234E-10_JPRB, 0.88143291E-10_JPRB, 0.88159535E-10_JPRB, 0.88174017E-10_JPRB, 0.88185272E-10_JPRB, 0.88191565E-10_JPRB, &
  & 0.88194424E-10_JPRB, 0.88194216E-10_JPRB, 0.88191558E-10_JPRB, 0.88187783E-10_JPRB, 0.88183578E-10_JPRB, 0.88178673E-10_JPRB, &
  & 0.88173226E-10_JPRB, 0.88167071E-10_JPRB, 0.88160541E-10_JPRB, 0.88153193E-10_JPRB, 0.88145984E-10_JPRB, 0.88138559E-10_JPRB, &
  & 0.88130253E-10_JPRB, 0.88118970E-10_JPRB, 0.88096884E-10_JPRB, 0.88040943E-10_JPRB /)

RGHG9(:,76, 2) = (/ &
  & 0.88096641E-10_JPRB, 0.88134396E-10_JPRB, 0.88147753E-10_JPRB, 0.88155747E-10_JPRB, 0.88160826E-10_JPRB, 0.88164934E-10_JPRB, &
  & 0.88168847E-10_JPRB, 0.88172664E-10_JPRB, 0.88176473E-10_JPRB, 0.88180310E-10_JPRB, 0.88183481E-10_JPRB, 0.88186125E-10_JPRB, &
  & 0.88187069E-10_JPRB, 0.88186243E-10_JPRB, 0.88183211E-10_JPRB, 0.88178548E-10_JPRB, 0.88174218E-10_JPRB, 0.88172310E-10_JPRB, &
  & 0.88175037E-10_JPRB, 0.88182586E-10_JPRB, 0.88194445E-10_JPRB, 0.88209461E-10_JPRB, 0.88225635E-10_JPRB, 0.88241234E-10_JPRB, &
  & 0.88254432E-10_JPRB, 0.88264666E-10_JPRB, 0.88271002E-10_JPRB, 0.88274381E-10_JPRB, 0.88275220E-10_JPRB, 0.88273028E-10_JPRB, &
  & 0.88268552E-10_JPRB, 0.88261155E-10_JPRB, 0.88251365E-10_JPRB, 0.88237959E-10_JPRB, 0.88222638E-10_JPRB, 0.88206137E-10_JPRB, &
  & 0.88189671E-10_JPRB, 0.88175155E-10_JPRB, 0.88163456E-10_JPRB, 0.88156815E-10_JPRB, 0.88155885E-10_JPRB, 0.88160416E-10_JPRB, &
  & 0.88169763E-10_JPRB, 0.88181157E-10_JPRB, 0.88193473E-10_JPRB, 0.88204895E-10_JPRB, 0.88213506E-10_JPRB, 0.88218301E-10_JPRB, &
  & 0.88220611E-10_JPRB, 0.88220632E-10_JPRB, 0.88218557E-10_JPRB, 0.88215629E-10_JPRB, 0.88212632E-10_JPRB, 0.88208683E-10_JPRB, &
  & 0.88204499E-10_JPRB, 0.88199711E-10_JPRB, 0.88194806E-10_JPRB, 0.88189150E-10_JPRB, 0.88183481E-10_JPRB, 0.88177694E-10_JPRB, &
  & 0.88171137E-10_JPRB, 0.88162151E-10_JPRB, 0.88143146E-10_JPRB, 0.88093477E-10_JPRB /)

RGHG9(:,77, 2) = (/ &
  & 0.88147524E-10_JPRB, 0.88181198E-10_JPRB, 0.88192453E-10_JPRB, 0.88198754E-10_JPRB, 0.88202640E-10_JPRB, 0.88205658E-10_JPRB, &
  & 0.88208732E-10_JPRB, 0.88211521E-10_JPRB, 0.88214200E-10_JPRB, 0.88216767E-10_JPRB, 0.88218918E-10_JPRB, 0.88220688E-10_JPRB, &
  & 0.88221264E-10_JPRB, 0.88220736E-10_JPRB, 0.88218592E-10_JPRB, 0.88215123E-10_JPRB, 0.88211931E-10_JPRB, 0.88210411E-10_JPRB, &
  & 0.88212306E-10_JPRB, 0.88217447E-10_JPRB, 0.88225698E-10_JPRB, 0.88236161E-10_JPRB, 0.88247500E-10_JPRB, 0.88258442E-10_JPRB, &
  & 0.88267595E-10_JPRB, 0.88274860E-10_JPRB, 0.88279134E-10_JPRB, 0.88281472E-10_JPRB, 0.88282270E-10_JPRB, 0.88280515E-10_JPRB, &
  & 0.88277358E-10_JPRB, 0.88272001E-10_JPRB, 0.88265346E-10_JPRB, 0.88255701E-10_JPRB, 0.88244911E-10_JPRB, 0.88233025E-10_JPRB, &
  & 0.88221389E-10_JPRB, 0.88211077E-10_JPRB, 0.88202862E-10_JPRB, 0.88198393E-10_JPRB, 0.88197893E-10_JPRB, 0.88201196E-10_JPRB, &
  & 0.88207879E-10_JPRB, 0.88215775E-10_JPRB, 0.88224532E-10_JPRB, 0.88232616E-10_JPRB, 0.88239173E-10_JPRB, 0.88242330E-10_JPRB, &
  & 0.88244148E-10_JPRB, 0.88244377E-10_JPRB, 0.88242816E-10_JPRB, 0.88240686E-10_JPRB, 0.88238798E-10_JPRB, 0.88235808E-10_JPRB, &
  & 0.88232824E-10_JPRB, 0.88229334E-10_JPRB, 0.88226183E-10_JPRB, 0.88222069E-10_JPRB, 0.88218058E-10_JPRB, 0.88213811E-10_JPRB, &
  & 0.88209197E-10_JPRB, 0.88202314E-10_JPRB, 0.88187117E-10_JPRB, 0.88145165E-10_JPRB /)

RGHG9(:,78, 2) = (/ &
  & 0.88196686E-10_JPRB, 0.88223248E-10_JPRB, 0.88230714E-10_JPRB, 0.88235440E-10_JPRB, 0.88237959E-10_JPRB, 0.88239971E-10_JPRB, &
  & 0.88242157E-10_JPRB, 0.88243780E-10_JPRB, 0.88245189E-10_JPRB, 0.88246500E-10_JPRB, 0.88247479E-10_JPRB, 0.88248658E-10_JPRB, &
  & 0.88248991E-10_JPRB, 0.88248998E-10_JPRB, 0.88247951E-10_JPRB, 0.88245869E-10_JPRB, 0.88243961E-10_JPRB, 0.88242962E-10_JPRB, &
  & 0.88244308E-10_JPRB, 0.88247576E-10_JPRB, 0.88252669E-10_JPRB, 0.88259330E-10_JPRB, 0.88266436E-10_JPRB, 0.88273382E-10_JPRB, &
  & 0.88279092E-10_JPRB, 0.88283859E-10_JPRB, 0.88286441E-10_JPRB, 0.88287891E-10_JPRB, 0.88288710E-10_JPRB, 0.88287357E-10_JPRB, &
  & 0.88285310E-10_JPRB, 0.88281688E-10_JPRB, 0.88277788E-10_JPRB, 0.88271362E-10_JPRB, 0.88264500E-10_JPRB, 0.88256666E-10_JPRB, &
  & 0.88249311E-10_JPRB, 0.88242753E-10_JPRB, 0.88237459E-10_JPRB, 0.88234739E-10_JPRB, 0.88234281E-10_JPRB, 0.88236120E-10_JPRB, &
  & 0.88240415E-10_JPRB, 0.88245071E-10_JPRB, 0.88250643E-10_JPRB, 0.88256076E-10_JPRB, 0.88260642E-10_JPRB, 0.88262467E-10_JPRB, &
  & 0.88263834E-10_JPRB, 0.88264319E-10_JPRB, 0.88263119E-10_JPRB, 0.88261669E-10_JPRB, 0.88260774E-10_JPRB, 0.88258588E-10_JPRB, &
  & 0.88256624E-10_JPRB, 0.88254334E-10_JPRB, 0.88252690E-10_JPRB, 0.88249984E-10_JPRB, 0.88247368E-10_JPRB, 0.88244578E-10_JPRB, &
  & 0.88241671E-10_JPRB, 0.88236890E-10_JPRB, 0.88226371E-10_JPRB, 0.88195673E-10_JPRB /)

RGHG9(:,79, 2) = (/ &
  & 0.88228438E-10_JPRB, 0.88246660E-10_JPRB, 0.88251052E-10_JPRB, 0.88254411E-10_JPRB, 0.88256243E-10_JPRB, 0.88257651E-10_JPRB, &
  & 0.88259393E-10_JPRB, 0.88260378E-10_JPRB, 0.88261010E-10_JPRB, 0.88261766E-10_JPRB, 0.88262175E-10_JPRB, 0.88263161E-10_JPRB, &
  & 0.88263438E-10_JPRB, 0.88263785E-10_JPRB, 0.88263348E-10_JPRB, 0.88261981E-10_JPRB, 0.88260781E-10_JPRB, 0.88260121E-10_JPRB, &
  & 0.88261301E-10_JPRB, 0.88263528E-10_JPRB, 0.88267040E-10_JPRB, 0.88271661E-10_JPRB, 0.88276511E-10_JPRB, 0.88281368E-10_JPRB, &
  & 0.88285206E-10_JPRB, 0.88288689E-10_JPRB, 0.88290347E-10_JPRB, 0.88291326E-10_JPRB, 0.88292235E-10_JPRB, 0.88291048E-10_JPRB, &
  & 0.88289577E-10_JPRB, 0.88286878E-10_JPRB, 0.88284553E-10_JPRB, 0.88279814E-10_JPRB, 0.88275103E-10_JPRB, 0.88269357E-10_JPRB, &
  & 0.88264333E-10_JPRB, 0.88259761E-10_JPRB, 0.88255979E-10_JPRB, 0.88254140E-10_JPRB, 0.88253592E-10_JPRB, 0.88254591E-10_JPRB, &
  & 0.88257554E-10_JPRB, 0.88260475E-10_JPRB, 0.88264361E-10_JPRB, 0.88268323E-10_JPRB, 0.88272015E-10_JPRB, 0.88273014E-10_JPRB, &
  & 0.88274207E-10_JPRB, 0.88274887E-10_JPRB, 0.88273819E-10_JPRB, 0.88272660E-10_JPRB, 0.88272327E-10_JPRB, 0.88270433E-10_JPRB, &
  & 0.88268989E-10_JPRB, 0.88267241E-10_JPRB, 0.88266477E-10_JPRB, 0.88264424E-10_JPRB, 0.88262508E-10_JPRB, 0.88260427E-10_JPRB, &
  & 0.88258505E-10_JPRB, 0.88255202E-10_JPRB, 0.88248166E-10_JPRB, 0.88228071E-10_JPRB /)

RGHG9(:,80, 2) = (/ &
  & 0.88249415E-10_JPRB, 0.88257963E-10_JPRB, 0.88259886E-10_JPRB, 0.88262675E-10_JPRB, 0.88264090E-10_JPRB, 0.88265222E-10_JPRB, &
  & 0.88266824E-10_JPRB, 0.88267477E-10_JPRB, 0.88267879E-10_JPRB, 0.88268379E-10_JPRB, 0.88268649E-10_JPRB, 0.88269600E-10_JPRB, &
  & 0.88269857E-10_JPRB, 0.88270363E-10_JPRB, 0.88270183E-10_JPRB, 0.88269107E-10_JPRB, 0.88268212E-10_JPRB, 0.88267699E-10_JPRB, &
  & 0.88268858E-10_JPRB, 0.88270703E-10_JPRB, 0.88273451E-10_JPRB, 0.88277191E-10_JPRB, 0.88281035E-10_JPRB, 0.88284928E-10_JPRB, &
  & 0.88287946E-10_JPRB, 0.88290854E-10_JPRB, 0.88292075E-10_JPRB, 0.88292845E-10_JPRB, 0.88293838E-10_JPRB, 0.88292693E-10_JPRB, &
  & 0.88291513E-10_JPRB, 0.88289182E-10_JPRB, 0.88287627E-10_JPRB, 0.88283658E-10_JPRB, 0.88279897E-10_JPRB, 0.88275082E-10_JPRB, &
  & 0.88271120E-10_JPRB, 0.88267449E-10_JPRB, 0.88264340E-10_JPRB, 0.88262897E-10_JPRB, 0.88262279E-10_JPRB, 0.88262841E-10_JPRB, &
  & 0.88265222E-10_JPRB, 0.88267338E-10_JPRB, 0.88270453E-10_JPRB, 0.88273763E-10_JPRB, 0.88277045E-10_JPRB, 0.88277635E-10_JPRB, &
  & 0.88278738E-10_JPRB, 0.88279564E-10_JPRB, 0.88278489E-10_JPRB, 0.88277420E-10_JPRB, 0.88277385E-10_JPRB, 0.88275567E-10_JPRB, &
  & 0.88274325E-10_JPRB, 0.88272778E-10_JPRB, 0.88272424E-10_JPRB, 0.88270627E-10_JPRB, 0.88268975E-10_JPRB, 0.88267185E-10_JPRB, &
  & 0.88265756E-10_JPRB, 0.88263175E-10_JPRB, 0.88258588E-10_JPRB, 0.88249540E-10_JPRB /)

RGHG9(:,81, 2) = (/ &
  & 0.88263799E-10_JPRB, 0.88262744E-10_JPRB, 0.88263605E-10_JPRB, 0.88266144E-10_JPRB, 0.88267442E-10_JPRB, 0.88268483E-10_JPRB, &
  & 0.88269989E-10_JPRB, 0.88270558E-10_JPRB, 0.88270773E-10_JPRB, 0.88271293E-10_JPRB, 0.88271432E-10_JPRB, 0.88272466E-10_JPRB, &
  & 0.88272695E-10_JPRB, 0.88273271E-10_JPRB, 0.88273180E-10_JPRB, 0.88272230E-10_JPRB, 0.88271467E-10_JPRB, 0.88271002E-10_JPRB, &
  & 0.88272181E-10_JPRB, 0.88273812E-10_JPRB, 0.88276282E-10_JPRB, 0.88279571E-10_JPRB, 0.88282992E-10_JPRB, 0.88286489E-10_JPRB, &
  & 0.88289133E-10_JPRB, 0.88291804E-10_JPRB, 0.88292824E-10_JPRB, 0.88293498E-10_JPRB, 0.88294566E-10_JPRB, 0.88293414E-10_JPRB, &
  & 0.88292360E-10_JPRB, 0.88290188E-10_JPRB, 0.88288966E-10_JPRB, 0.88285310E-10_JPRB, 0.88282000E-10_JPRB, 0.88277594E-10_JPRB, &
  & 0.88274096E-10_JPRB, 0.88270835E-10_JPRB, 0.88268011E-10_JPRB, 0.88266755E-10_JPRB, 0.88266117E-10_JPRB, 0.88266484E-10_JPRB, &
  & 0.88268622E-10_JPRB, 0.88270349E-10_JPRB, 0.88273132E-10_JPRB, 0.88276123E-10_JPRB, 0.88279287E-10_JPRB, 0.88279634E-10_JPRB, &
  & 0.88280702E-10_JPRB, 0.88281597E-10_JPRB, 0.88280508E-10_JPRB, 0.88279474E-10_JPRB, 0.88279564E-10_JPRB, 0.88277760E-10_JPRB, &
  & 0.88276594E-10_JPRB, 0.88275130E-10_JPRB, 0.88274971E-10_JPRB, 0.88273264E-10_JPRB, 0.88271744E-10_JPRB, 0.88270058E-10_JPRB, &
  & 0.88268823E-10_JPRB, 0.88266512E-10_JPRB, 0.88262925E-10_JPRB, 0.88264319E-10_JPRB /)

RGHG9(:,82, 2) = (/ &
  & 0.88264965E-10_JPRB, 0.88264361E-10_JPRB, 0.88265242E-10_JPRB, 0.88267831E-10_JPRB, 0.88269059E-10_JPRB, 0.88270016E-10_JPRB, &
  & 0.88271543E-10_JPRB, 0.88271994E-10_JPRB, 0.88272244E-10_JPRB, 0.88272660E-10_JPRB, 0.88272854E-10_JPRB, 0.88273805E-10_JPRB, &
  & 0.88274076E-10_JPRB, 0.88274700E-10_JPRB, 0.88274665E-10_JPRB, 0.88273770E-10_JPRB, 0.88273042E-10_JPRB, 0.88272611E-10_JPRB, &
  & 0.88273791E-10_JPRB, 0.88275359E-10_JPRB, 0.88277607E-10_JPRB, 0.88280772E-10_JPRB, 0.88283936E-10_JPRB, 0.88287232E-10_JPRB, &
  & 0.88289702E-10_JPRB, 0.88292242E-10_JPRB, 0.88293171E-10_JPRB, 0.88293789E-10_JPRB, 0.88294927E-10_JPRB, 0.88293768E-10_JPRB, &
  & 0.88292748E-10_JPRB, 0.88290639E-10_JPRB, 0.88289591E-10_JPRB, 0.88286115E-10_JPRB, 0.88282971E-10_JPRB, 0.88278836E-10_JPRB, &
  & 0.88275567E-10_JPRB, 0.88272507E-10_JPRB, 0.88269850E-10_JPRB, 0.88268684E-10_JPRB, 0.88268018E-10_JPRB, 0.88268282E-10_JPRB, &
  & 0.88270287E-10_JPRB, 0.88271807E-10_JPRB, 0.88274422E-10_JPRB, 0.88277302E-10_JPRB, 0.88280383E-10_JPRB, 0.88280591E-10_JPRB, &
  & 0.88281646E-10_JPRB, 0.88282603E-10_JPRB, 0.88281493E-10_JPRB, 0.88280459E-10_JPRB, 0.88280626E-10_JPRB, 0.88278801E-10_JPRB, &
  & 0.88277684E-10_JPRB, 0.88276254E-10_JPRB, 0.88276206E-10_JPRB, 0.88274534E-10_JPRB, 0.88273069E-10_JPRB, 0.88271439E-10_JPRB, &
  & 0.88270266E-10_JPRB, 0.88267962E-10_JPRB, 0.88264361E-10_JPRB, 0.88265478E-10_JPRB /)

RGHG9(:,83, 2) = (/ &
  & 0.88265770E-10_JPRB, 0.88265277E-10_JPRB, 0.88266158E-10_JPRB, 0.88268774E-10_JPRB, 0.88269975E-10_JPRB, 0.88270918E-10_JPRB, &
  & 0.88272362E-10_JPRB, 0.88272840E-10_JPRB, 0.88272958E-10_JPRB, 0.88273486E-10_JPRB, 0.88273555E-10_JPRB, 0.88274665E-10_JPRB, &
  & 0.88274860E-10_JPRB, 0.88275498E-10_JPRB, 0.88275484E-10_JPRB, 0.88274638E-10_JPRB, 0.88273930E-10_JPRB, 0.88273507E-10_JPRB, &
  & 0.88274749E-10_JPRB, 0.88276178E-10_JPRB, 0.88278419E-10_JPRB, 0.88281375E-10_JPRB, 0.88284470E-10_JPRB, 0.88287641E-10_JPRB, &
  & 0.88290000E-10_JPRB, 0.88292505E-10_JPRB, 0.88293352E-10_JPRB, 0.88293942E-10_JPRB, 0.88295128E-10_JPRB, 0.88293942E-10_JPRB, &
  & 0.88292949E-10_JPRB, 0.88290868E-10_JPRB, 0.88289903E-10_JPRB, 0.88286517E-10_JPRB, 0.88283526E-10_JPRB, 0.88279523E-10_JPRB, &
  & 0.88276414E-10_JPRB, 0.88273472E-10_JPRB, 0.88270911E-10_JPRB, 0.88269794E-10_JPRB, 0.88269114E-10_JPRB, 0.88269281E-10_JPRB, &
  & 0.88271203E-10_JPRB, 0.88272605E-10_JPRB, 0.88275144E-10_JPRB, 0.88277941E-10_JPRB, 0.88281021E-10_JPRB, 0.88281119E-10_JPRB, &
  & 0.88282180E-10_JPRB, 0.88283172E-10_JPRB, 0.88282041E-10_JPRB, 0.88281001E-10_JPRB, 0.88281236E-10_JPRB, 0.88279377E-10_JPRB, &
  & 0.88278274E-10_JPRB, 0.88276872E-10_JPRB, 0.88276907E-10_JPRB, 0.88275248E-10_JPRB, 0.88273812E-10_JPRB, 0.88272202E-10_JPRB, &
  & 0.88271064E-10_JPRB, 0.88268774E-10_JPRB, 0.88265159E-10_JPRB, 0.88266304E-10_JPRB /)

RGHG9(:,84, 2) = (/ &
  & 0.88266325E-10_JPRB, 0.88265895E-10_JPRB, 0.88266727E-10_JPRB, 0.88269357E-10_JPRB, 0.88270544E-10_JPRB, 0.88271418E-10_JPRB, &
  & 0.88272972E-10_JPRB, 0.88273319E-10_JPRB, 0.88273541E-10_JPRB, 0.88273888E-10_JPRB, 0.88274145E-10_JPRB, 0.88275005E-10_JPRB, &
  & 0.88275331E-10_JPRB, 0.88275956E-10_JPRB, 0.88275991E-10_JPRB, 0.88275179E-10_JPRB, 0.88274492E-10_JPRB, 0.88274082E-10_JPRB, &
  & 0.88275304E-10_JPRB, 0.88276761E-10_JPRB, 0.88278787E-10_JPRB, 0.88281785E-10_JPRB, 0.88284748E-10_JPRB, 0.88287891E-10_JPRB, &
  & 0.88290195E-10_JPRB, 0.88292665E-10_JPRB, 0.88293456E-10_JPRB, 0.88294018E-10_JPRB, 0.88295274E-10_JPRB, 0.88294046E-10_JPRB, &
  & 0.88293053E-10_JPRB, 0.88290972E-10_JPRB, 0.88290049E-10_JPRB, 0.88286760E-10_JPRB, 0.88283783E-10_JPRB, 0.88279974E-10_JPRB, &
  & 0.88276927E-10_JPRB, 0.88274082E-10_JPRB, 0.88271598E-10_JPRB, 0.88270488E-10_JPRB, 0.88269780E-10_JPRB, 0.88269878E-10_JPRB, &
  & 0.88271765E-10_JPRB, 0.88273076E-10_JPRB, 0.88275581E-10_JPRB, 0.88278350E-10_JPRB, 0.88281396E-10_JPRB, 0.88281431E-10_JPRB, &
  & 0.88282492E-10_JPRB, 0.88283540E-10_JPRB, 0.88282361E-10_JPRB, 0.88281327E-10_JPRB, 0.88281611E-10_JPRB, 0.88279738E-10_JPRB, &
  & 0.88278634E-10_JPRB, 0.88277233E-10_JPRB, 0.88277337E-10_JPRB, 0.88275692E-10_JPRB, 0.88274270E-10_JPRB, 0.88272660E-10_JPRB, &
  & 0.88271557E-10_JPRB, 0.88269267E-10_JPRB, 0.88265673E-10_JPRB, 0.88266873E-10_JPRB /)

RGHG9(:,85, 2) = (/ &
  & 0.88266700E-10_JPRB, 0.88266297E-10_JPRB, 0.88267074E-10_JPRB, 0.88269746E-10_JPRB, 0.88270904E-10_JPRB, 0.88271931E-10_JPRB, &
  & 0.88273222E-10_JPRB, 0.88273694E-10_JPRB, 0.88273826E-10_JPRB, 0.88274242E-10_JPRB, 0.88274443E-10_JPRB, 0.88275318E-10_JPRB, &
  & 0.88275623E-10_JPRB, 0.88276227E-10_JPRB, 0.88276296E-10_JPRB, 0.88275533E-10_JPRB, 0.88274846E-10_JPRB, 0.88274422E-10_JPRB, &
  & 0.88275706E-10_JPRB, 0.88277025E-10_JPRB, 0.88279134E-10_JPRB, 0.88281965E-10_JPRB, 0.88284935E-10_JPRB, 0.88288050E-10_JPRB, &
  & 0.88290306E-10_JPRB, 0.88292790E-10_JPRB, 0.88293518E-10_JPRB, 0.88294067E-10_JPRB, 0.88295364E-10_JPRB, 0.88294094E-10_JPRB, &
  & 0.88293123E-10_JPRB, 0.88291055E-10_JPRB, 0.88290153E-10_JPRB, 0.88286878E-10_JPRB, 0.88284026E-10_JPRB, 0.88280216E-10_JPRB, &
  & 0.88277288E-10_JPRB, 0.88274492E-10_JPRB, 0.88272029E-10_JPRB, 0.88270960E-10_JPRB, 0.88270204E-10_JPRB, 0.88270238E-10_JPRB, &
  & 0.88272147E-10_JPRB, 0.88273375E-10_JPRB, 0.88275859E-10_JPRB, 0.88278593E-10_JPRB, 0.88281681E-10_JPRB, 0.88281632E-10_JPRB, &
  & 0.88282687E-10_JPRB, 0.88283755E-10_JPRB, 0.88282569E-10_JPRB, 0.88281521E-10_JPRB, 0.88281861E-10_JPRB, 0.88279981E-10_JPRB, &
  & 0.88278870E-10_JPRB, 0.88277476E-10_JPRB, 0.88277621E-10_JPRB, 0.88275984E-10_JPRB, 0.88274582E-10_JPRB, 0.88272965E-10_JPRB, &
  & 0.88271876E-10_JPRB, 0.88269593E-10_JPRB, 0.88265999E-10_JPRB, 0.88267262E-10_JPRB /)

RGHG9(:,86, 2) = (/ &
  & 0.88266935E-10_JPRB, 0.88266554E-10_JPRB, 0.88267282E-10_JPRB, 0.88269995E-10_JPRB, 0.88271224E-10_JPRB, 0.88272084E-10_JPRB, &
  & 0.88273569E-10_JPRB, 0.88273874E-10_JPRB, 0.88274117E-10_JPRB, 0.88274429E-10_JPRB, 0.88274749E-10_JPRB, 0.88275380E-10_JPRB, &
  & 0.88275762E-10_JPRB, 0.88276310E-10_JPRB, 0.88276435E-10_JPRB, 0.88275783E-10_JPRB, 0.88275103E-10_JPRB, 0.88274693E-10_JPRB, &
  & 0.88275914E-10_JPRB, 0.88277274E-10_JPRB, 0.88279231E-10_JPRB, 0.88282132E-10_JPRB, 0.88285018E-10_JPRB, 0.88288162E-10_JPRB, &
  & 0.88290396E-10_JPRB, 0.88292887E-10_JPRB, 0.88293546E-10_JPRB, 0.88294101E-10_JPRB, 0.88295427E-10_JPRB, 0.88294115E-10_JPRB, &
  & 0.88293151E-10_JPRB, 0.88291069E-10_JPRB, 0.88290202E-10_JPRB, 0.88287017E-10_JPRB, 0.88284116E-10_JPRB, 0.88280480E-10_JPRB, &
  & 0.88277476E-10_JPRB, 0.88274735E-10_JPRB, 0.88272278E-10_JPRB, 0.88271210E-10_JPRB, 0.88270467E-10_JPRB, 0.88270460E-10_JPRB, &
  & 0.88272369E-10_JPRB, 0.88273555E-10_JPRB, 0.88276025E-10_JPRB, 0.88278745E-10_JPRB, 0.88281854E-10_JPRB, 0.88281757E-10_JPRB, &
  & 0.88282805E-10_JPRB, 0.88283908E-10_JPRB, 0.88282714E-10_JPRB, 0.88281646E-10_JPRB, 0.88282028E-10_JPRB, 0.88280119E-10_JPRB, &
  & 0.88279016E-10_JPRB, 0.88277614E-10_JPRB, 0.88277809E-10_JPRB, 0.88276178E-10_JPRB, 0.88274790E-10_JPRB, 0.88273146E-10_JPRB, &
  & 0.88272077E-10_JPRB, 0.88269787E-10_JPRB, 0.88266193E-10_JPRB, 0.88267511E-10_JPRB /)

RGHG9(:,87, 2) = (/ &
  & 0.88267074E-10_JPRB, 0.88266706E-10_JPRB, 0.88267393E-10_JPRB, 0.88270197E-10_JPRB, 0.88271335E-10_JPRB, 0.88272542E-10_JPRB, &
  & 0.88273583E-10_JPRB, 0.88274062E-10_JPRB, 0.88274263E-10_JPRB, 0.88274610E-10_JPRB, 0.88274894E-10_JPRB, 0.88275484E-10_JPRB, &
  & 0.88275838E-10_JPRB, 0.88276324E-10_JPRB, 0.88276476E-10_JPRB, 0.88275921E-10_JPRB, 0.88275262E-10_JPRB, 0.88274853E-10_JPRB, &
  & 0.88276067E-10_JPRB, 0.88277337E-10_JPRB, 0.88279335E-10_JPRB, 0.88282159E-10_JPRB, 0.88285088E-10_JPRB, 0.88288245E-10_JPRB, &
  & 0.88290431E-10_JPRB, 0.88292963E-10_JPRB, 0.88293574E-10_JPRB, 0.88294108E-10_JPRB, 0.88295489E-10_JPRB, 0.88294150E-10_JPRB, &
  & 0.88293171E-10_JPRB, 0.88291104E-10_JPRB, 0.88290299E-10_JPRB, 0.88287079E-10_JPRB, 0.88284345E-10_JPRB, 0.88280515E-10_JPRB, &
  & 0.88277677E-10_JPRB, 0.88274860E-10_JPRB, 0.88272341E-10_JPRB, 0.88271383E-10_JPRB, 0.88270564E-10_JPRB, 0.88270530E-10_JPRB, &
  & 0.88272556E-10_JPRB, 0.88273645E-10_JPRB, 0.88276136E-10_JPRB, 0.88278850E-10_JPRB, 0.88281951E-10_JPRB, 0.88281833E-10_JPRB, &
  & 0.88282881E-10_JPRB, 0.88284012E-10_JPRB, 0.88282798E-10_JPRB, 0.88281722E-10_JPRB, 0.88282125E-10_JPRB, 0.88280189E-10_JPRB, &
  & 0.88279106E-10_JPRB, 0.88277691E-10_JPRB, 0.88277927E-10_JPRB, 0.88276303E-10_JPRB, 0.88274901E-10_JPRB, 0.88273257E-10_JPRB, &
  & 0.88272202E-10_JPRB, 0.88269905E-10_JPRB, 0.88266297E-10_JPRB, 0.88267664E-10_JPRB /)

RGHG9(:,88, 2) = (/ &
  & 0.88267164E-10_JPRB, 0.88266817E-10_JPRB, 0.88267470E-10_JPRB, 0.88270238E-10_JPRB, 0.88271571E-10_JPRB, 0.88272431E-10_JPRB, &
  & 0.88273826E-10_JPRB, 0.88274124E-10_JPRB, 0.88274374E-10_JPRB, 0.88274665E-10_JPRB, 0.88274971E-10_JPRB, 0.88275512E-10_JPRB, &
  & 0.88275873E-10_JPRB, 0.88276352E-10_JPRB, 0.88276511E-10_JPRB, 0.88276018E-10_JPRB, 0.88275345E-10_JPRB, 0.88274936E-10_JPRB, &
  & 0.88276150E-10_JPRB, 0.88277420E-10_JPRB, 0.88279349E-10_JPRB, 0.88282215E-10_JPRB, 0.88285108E-10_JPRB, 0.88288293E-10_JPRB, &
  & 0.88290458E-10_JPRB, 0.88293033E-10_JPRB, 0.88293595E-10_JPRB, 0.88294122E-10_JPRB, 0.88295524E-10_JPRB, 0.88294164E-10_JPRB, &
  & 0.88293199E-10_JPRB, 0.88291117E-10_JPRB, 0.88290382E-10_JPRB, 0.88287225E-10_JPRB, 0.88284394E-10_JPRB, 0.88280647E-10_JPRB, &
  & 0.88277663E-10_JPRB, 0.88274929E-10_JPRB, 0.88272362E-10_JPRB, 0.88271432E-10_JPRB, 0.88270648E-10_JPRB, 0.88270564E-10_JPRB, &
  & 0.88272618E-10_JPRB, 0.88273694E-10_JPRB, 0.88276206E-10_JPRB, 0.88278884E-10_JPRB, 0.88282034E-10_JPRB, 0.88281861E-10_JPRB, &
  & 0.88282916E-10_JPRB, 0.88284061E-10_JPRB, 0.88282853E-10_JPRB, 0.88281764E-10_JPRB, 0.88282187E-10_JPRB, 0.88280223E-10_JPRB, &
  & 0.88279176E-10_JPRB, 0.88277739E-10_JPRB, 0.88277982E-10_JPRB, 0.88276372E-10_JPRB, 0.88274964E-10_JPRB, 0.88273298E-10_JPRB, &
  & 0.88272271E-10_JPRB, 0.88269975E-10_JPRB, 0.88266366E-10_JPRB, 0.88267761E-10_JPRB /)

RGHG9(:,89, 2) = (/ &
  & 0.88267213E-10_JPRB, 0.88266880E-10_JPRB, 0.88267491E-10_JPRB, 0.88270322E-10_JPRB, 0.88271480E-10_JPRB, 0.88272688E-10_JPRB, &
  & 0.88273722E-10_JPRB, 0.88274152E-10_JPRB, 0.88274353E-10_JPRB, 0.88274693E-10_JPRB, 0.88274978E-10_JPRB, 0.88275567E-10_JPRB, &
  & 0.88275942E-10_JPRB, 0.88276442E-10_JPRB, 0.88276594E-10_JPRB, 0.88276060E-10_JPRB, 0.88275373E-10_JPRB, 0.88274950E-10_JPRB, &
  & 0.88276192E-10_JPRB, 0.88277441E-10_JPRB, 0.88279370E-10_JPRB, 0.88282222E-10_JPRB, 0.88285115E-10_JPRB, 0.88288335E-10_JPRB, &
  & 0.88290458E-10_JPRB, 0.88293067E-10_JPRB, 0.88293602E-10_JPRB, 0.88294108E-10_JPRB, 0.88295565E-10_JPRB, 0.88294157E-10_JPRB, &
  & 0.88293227E-10_JPRB, 0.88291117E-10_JPRB, 0.88290514E-10_JPRB, 0.88287253E-10_JPRB, 0.88284546E-10_JPRB, 0.88280577E-10_JPRB, &
  & 0.88277712E-10_JPRB, 0.88274908E-10_JPRB, 0.88272313E-10_JPRB, 0.88271494E-10_JPRB, 0.88270655E-10_JPRB, 0.88270537E-10_JPRB, &
  & 0.88272695E-10_JPRB, 0.88273722E-10_JPRB, 0.88276254E-10_JPRB, 0.88278940E-10_JPRB, 0.88282097E-10_JPRB, 0.88281868E-10_JPRB, &
  & 0.88282923E-10_JPRB, 0.88284102E-10_JPRB, 0.88282888E-10_JPRB, 0.88281771E-10_JPRB, 0.88282236E-10_JPRB, 0.88280251E-10_JPRB, &
  & 0.88279217E-10_JPRB, 0.88277760E-10_JPRB, 0.88278031E-10_JPRB, 0.88276421E-10_JPRB, 0.88275019E-10_JPRB, 0.88273326E-10_JPRB, &
  & 0.88272334E-10_JPRB, 0.88270016E-10_JPRB, 0.88266359E-10_JPRB, 0.88267810E-10_JPRB /)

RGHG9(:,90, 2) = (/ &
  & 0.88267199E-10_JPRB, 0.88266887E-10_JPRB, 0.88267421E-10_JPRB, 0.88270308E-10_JPRB, 0.88271515E-10_JPRB, 0.88272341E-10_JPRB, &
  & 0.88273860E-10_JPRB, 0.88274110E-10_JPRB, 0.88274291E-10_JPRB, 0.88274631E-10_JPRB, 0.88274922E-10_JPRB, 0.88275637E-10_JPRB, &
  & 0.88276012E-10_JPRB, 0.88276601E-10_JPRB, 0.88276726E-10_JPRB, 0.88276081E-10_JPRB, 0.88275331E-10_JPRB, 0.88274874E-10_JPRB, &
  & 0.88276227E-10_JPRB, 0.88277448E-10_JPRB, 0.88279356E-10_JPRB, 0.88282222E-10_JPRB, 0.88285101E-10_JPRB, 0.88288363E-10_JPRB, &
  & 0.88290437E-10_JPRB, 0.88293123E-10_JPRB, 0.88293609E-10_JPRB, 0.88294073E-10_JPRB, 0.88295662E-10_JPRB, 0.88294164E-10_JPRB, &
  & 0.88293303E-10_JPRB, 0.88291097E-10_JPRB, 0.88290673E-10_JPRB, 0.88287294E-10_JPRB, 0.88284616E-10_JPRB, 0.88280515E-10_JPRB, &
  & 0.88277635E-10_JPRB, 0.88274887E-10_JPRB, 0.88272251E-10_JPRB, 0.88271508E-10_JPRB, 0.88270648E-10_JPRB, 0.88270474E-10_JPRB, &
  & 0.88272750E-10_JPRB, 0.88273708E-10_JPRB, 0.88276261E-10_JPRB, 0.88278933E-10_JPRB, 0.88282222E-10_JPRB, 0.88281861E-10_JPRB, &
  & 0.88282943E-10_JPRB, 0.88284199E-10_JPRB, 0.88282916E-10_JPRB, 0.88281750E-10_JPRB, 0.88282312E-10_JPRB, 0.88280244E-10_JPRB, &
  & 0.88279231E-10_JPRB, 0.88277732E-10_JPRB, 0.88278093E-10_JPRB, 0.88276442E-10_JPRB, 0.88275040E-10_JPRB, 0.88273298E-10_JPRB, &
  & 0.88272355E-10_JPRB, 0.88270016E-10_JPRB, 0.88266276E-10_JPRB, 0.88267851E-10_JPRB /)

RGHG9(:,91, 2) = (/ &
  & 0.88267144E-10_JPRB, 0.88266831E-10_JPRB, 0.88267157E-10_JPRB, 0.88270433E-10_JPRB, 0.88271439E-10_JPRB, 0.88272167E-10_JPRB, &
  & 0.88273992E-10_JPRB, 0.88274131E-10_JPRB, 0.88274041E-10_JPRB, 0.88274645E-10_JPRB, 0.88274547E-10_JPRB, 0.88276025E-10_JPRB, &
  & 0.88275998E-10_JPRB, 0.88276844E-10_JPRB, 0.88276941E-10_JPRB, 0.88276074E-10_JPRB, 0.88275283E-10_JPRB, 0.88274700E-10_JPRB, &
  & 0.88276247E-10_JPRB, 0.88277413E-10_JPRB, 0.88279287E-10_JPRB, 0.88282229E-10_JPRB, 0.88285088E-10_JPRB, 0.88288446E-10_JPRB, &
  & 0.88290417E-10_JPRB, 0.88293282E-10_JPRB, 0.88293615E-10_JPRB, 0.88293990E-10_JPRB, 0.88295919E-10_JPRB, 0.88294129E-10_JPRB, &
  & 0.88293400E-10_JPRB, 0.88290937E-10_JPRB, 0.88291083E-10_JPRB, 0.88287183E-10_JPRB, 0.88284866E-10_JPRB, 0.88280272E-10_JPRB, &
  & 0.88277573E-10_JPRB, 0.88274839E-10_JPRB, 0.88272098E-10_JPRB, 0.88271515E-10_JPRB, 0.88270606E-10_JPRB, 0.88270301E-10_JPRB, &
  & 0.88272840E-10_JPRB, 0.88273611E-10_JPRB, 0.88276254E-10_JPRB, 0.88278912E-10_JPRB, 0.88282465E-10_JPRB, 0.88281771E-10_JPRB, &
  & 0.88282943E-10_JPRB, 0.88284380E-10_JPRB, 0.88282902E-10_JPRB, 0.88281632E-10_JPRB, 0.88282492E-10_JPRB, 0.88280161E-10_JPRB, &
  & 0.88279273E-10_JPRB, 0.88277614E-10_JPRB, 0.88278239E-10_JPRB, 0.88276428E-10_JPRB, 0.88275054E-10_JPRB, 0.88273250E-10_JPRB, &
  & 0.88272417E-10_JPRB, 0.88269982E-10_JPRB, 0.88266019E-10_JPRB, 0.88267872E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART4',1,ZHOOK_HANDLE)
END SUBROUTINE PART4






SUBROUTINE PART5
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART5',0,ZHOOK_HANDLE)



!-- Month=  3 ------------

RGHG9(:, 1, 3) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, &
  & 0.42038954E-44_JPRB, 0.70064923E-44_JPRB, 0.84077908E-44_JPRB, 0.12611686E-43_JPRB, 0.14012985E-43_JPRB, 0.14012985E-43_JPRB, &
  & 0.12611686E-43_JPRB, 0.12611686E-43_JPRB, 0.11210388E-43_JPRB, 0.98090893E-44_JPRB, 0.84077908E-44_JPRB, 0.70064923E-44_JPRB, &
  & 0.56051939E-44_JPRB, 0.42038954E-44_JPRB, 0.42038954E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 2, 3) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.28025969E-44_JPRB, &
  & 0.42038954E-44_JPRB, 0.98090893E-44_JPRB, 0.19618179E-43_JPRB, 0.33631163E-43_JPRB, 0.61657132E-43_JPRB, 0.95288296E-43_JPRB, &
  & 0.16255062E-42_JPRB, 0.27325320E-42_JPRB, 0.35592981E-42_JPRB, 0.47924407E-42_JPRB, 0.54090121E-42_JPRB, 0.53809861E-42_JPRB, &
  & 0.52408563E-42_JPRB, 0.48905316E-42_JPRB, 0.43580382E-42_JPRB, 0.38255448E-42_JPRB, 0.32650254E-42_JPRB, 0.27185190E-42_JPRB, &
  & 0.22560905E-42_JPRB, 0.17796490E-42_JPRB, 0.15134023E-42_JPRB, 0.10789998E-42_JPRB, 0.81275311E-43_JPRB, 0.51848043E-43_JPRB, &
  & 0.30828566E-43_JPRB, 0.15414283E-43_JPRB, 0.70064923E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 3, 3) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.42038954E-44_JPRB, 0.12611686E-43_JPRB, 0.29427268E-43_JPRB, 0.79874012E-43_JPRB, &
  & 0.18216880E-42_JPRB, 0.37694929E-42_JPRB, 0.81835830E-42_JPRB, 0.14951855E-41_JPRB, 0.28726619E-41_JPRB, 0.45878512E-41_JPRB, &
  & 0.79621779E-41_JPRB, 0.13127364E-40_JPRB, 0.17164505E-40_JPRB, 0.22717851E-40_JPRB, 0.25646564E-40_JPRB, 0.25675992E-40_JPRB, &
  & 0.25044006E-40_JPRB, 0.23328817E-40_JPRB, 0.20795269E-40_JPRB, 0.18228090E-40_JPRB, 0.15487151E-40_JPRB, 0.12953603E-40_JPRB, &
  & 0.10732545E-40_JPRB, 0.85675388E-41_JPRB, 0.72867520E-41_JPRB, 0.51273511E-41_JPRB, 0.38199396E-41_JPRB, 0.23752009E-41_JPRB, &
  & 0.14335283E-41_JPRB, 0.72026741E-42_JPRB, 0.30828566E-42_JPRB, 0.13592595E-42_JPRB, 0.60255834E-43_JPRB, 0.26624671E-43_JPRB, &
  & 0.12611686E-43_JPRB, 0.70064923E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 4, 3) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.28025969E-44_JPRB, 0.42038954E-44_JPRB, 0.70064923E-44_JPRB, 0.12611686E-43_JPRB, 0.22420775E-43_JPRB, 0.43440252E-43_JPRB, &
  & 0.93886997E-43_JPRB, 0.20879347E-42_JPRB, 0.46663239E-42_JPRB, 0.12009128E-41_JPRB, 0.26316385E-41_JPRB, 0.69728612E-41_JPRB, &
  & 0.15400270E-40_JPRB, 0.31283988E-40_JPRB, 0.69971036E-40_JPRB, 0.12800441E-39_JPRB, 0.25519327E-39_JPRB, 0.40867468E-39_JPRB, &
  & 0.71342067E-39_JPRB, 0.11768119E-38_JPRB, 0.15256497E-38_JPRB, 0.20174018E-38_JPRB, 0.22738982E-38_JPRB, 0.22740229E-38_JPRB, &
  & 0.22155846E-38_JPRB, 0.20611671E-38_JPRB, 0.18365320E-38_JPRB, 0.16083683E-38_JPRB, 0.13684744E-38_JPRB, 0.11454648E-38_JPRB, &
  & 0.95203517E-39_JPRB, 0.76271414E-39_JPRB, 0.65341566E-39_JPRB, 0.46021024E-39_JPRB, 0.34542287E-39_JPRB, 0.21202066E-39_JPRB, &
  & 0.12724771E-39_JPRB, 0.62553963E-40_JPRB, 0.26229505E-40_JPRB, 0.11632179E-40_JPRB, 0.53389471E-41_JPRB, 0.24690879E-41_JPRB, &
  & 0.11672816E-41_JPRB, 0.56332198E-42_JPRB, 0.28025969E-42_JPRB, 0.14433374E-42_JPRB, 0.77071416E-43_JPRB, 0.42038954E-43_JPRB, &
  & 0.25223372E-43_JPRB, 0.15414283E-43_JPRB, 0.11210388E-43_JPRB, 0.84077908E-44_JPRB, 0.70064923E-44_JPRB, 0.56051939E-44_JPRB, &
  & 0.42038954E-44_JPRB, 0.28025969E-44_JPRB, 0.28025969E-44_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 5, 3) = (/ &
  & 0.81275311E-43_JPRB, 0.22841165E-42_JPRB, 0.33631163E-42_JPRB, 0.41058045E-42_JPRB, 0.49886225E-42_JPRB, 0.62077522E-42_JPRB, &
  & 0.81415441E-42_JPRB, 0.11350518E-41_JPRB, 0.17011763E-41_JPRB, 0.27507489E-41_JPRB, 0.49059459E-41_JPRB, 0.95680659E-41_JPRB, &
  & 0.20388893E-40_JPRB, 0.44740657E-40_JPRB, 0.98111912E-40_JPRB, 0.24688777E-39_JPRB, 0.52678733E-39_JPRB, 0.13590199E-38_JPRB, &
  & 0.29318905E-38_JPRB, 0.57834124E-38_JPRB, 0.12898999E-37_JPRB, 0.23135958E-37_JPRB, 0.46477174E-37_JPRB, 0.73035373E-37_JPRB, &
  & 0.12693421E-36_JPRB, 0.20729280E-36_JPRB, 0.26569834E-36_JPRB, 0.34938568E-36_JPRB, 0.39148441E-36_JPRB, 0.38870405E-36_JPRB, &
  & 0.37720636E-36_JPRB, 0.35027177E-36_JPRB, 0.31217932E-36_JPRB, 0.27430301E-36_JPRB, 0.23447360E-36_JPRB, 0.19769976E-36_JPRB, &
  & 0.16573164E-36_JPRB, 0.13427152E-36_JPRB, 0.11672823E-36_JPRB, 0.83181553E-37_JPRB, 0.63564373E-37_JPRB, 0.39287011E-37_JPRB, &
  & 0.23854775E-37_JPRB, 0.11792458E-37_JPRB, 0.50022488E-38_JPRB, 0.22747530E-38_JPRB, 0.10760599E-38_JPRB, 0.51333627E-39_JPRB, &
  & 0.24958527E-39_JPRB, 0.12373746E-39_JPRB, 0.62786579E-40_JPRB, 0.32752549E-40_JPRB, 0.17674578E-40_JPRB, 0.99352061E-41_JPRB, &
  & 0.58602302E-41_JPRB, 0.36601916E-41_JPRB, 0.24354567E-41_JPRB, 0.17362088E-41_JPRB, 0.13228258E-41_JPRB, 0.10705920E-41_JPRB, &
  & 0.90523881E-42_JPRB, 0.77351675E-42_JPRB, 0.62077522E-42_JPRB, 0.38255448E-42_JPRB /)

RGHG9(:, 6, 3) = (/ &
  & 0.73024466E-40_JPRB, 0.14253447E-39_JPRB, 0.18509191E-39_JPRB, 0.22024068E-39_JPRB, 0.26473050E-39_JPRB, 0.32669732E-39_JPRB, &
  & 0.42232193E-39_JPRB, 0.57893525E-39_JPRB, 0.84838813E-39_JPRB, 0.13356392E-38_JPRB, 0.23103516E-38_JPRB, 0.43543122E-38_JPRB, &
  & 0.89585361E-38_JPRB, 0.18930738E-37_JPRB, 0.39887170E-37_JPRB, 0.96375266E-37_JPRB, 0.19680867E-36_JPRB, 0.48546405E-36_JPRB, &
  & 0.10007974E-35_JPRB, 0.18874795E-35_JPRB, 0.40392917E-35_JPRB, 0.69585743E-35_JPRB, 0.13533458E-34_JPRB, 0.20514430E-34_JPRB, &
  & 0.34654348E-34_JPRB, 0.55469305E-34_JPRB, 0.69434500E-34_JPRB, 0.90098669E-34_JPRB, 0.99530783E-34_JPRB, 0.97607908E-34_JPRB, &
  & 0.94092336E-34_JPRB, 0.87188654E-34_JPRB, 0.77892446E-34_JPRB, 0.68873976E-34_JPRB, 0.59513161E-34_JPRB, 0.50914328E-34_JPRB, &
  & 0.43476537E-34_JPRB, 0.36019403E-34_JPRB, 0.32191656E-34_JPRB, 0.23602519E-34_JPRB, 0.18684900E-34_JPRB, 0.11930350E-34_JPRB, &
  & 0.75262303E-35_JPRB, 0.38592569E-35_JPRB, 0.17051163E-35_JPRB, 0.81146347E-36_JPRB, 0.40173397E-36_JPRB, 0.20031972E-36_JPRB, &
  & 0.10172966E-36_JPRB, 0.52557935E-37_JPRB, 0.27743823E-37_JPRB, 0.15025173E-37_JPRB, 0.84018605E-38_JPRB, 0.48854561E-38_JPRB, &
  & 0.29744157E-38_JPRB, 0.19122007E-38_JPRB, 0.13059583E-38_JPRB, 0.95054559E-39_JPRB, 0.73632489E-39_JPRB, 0.60315810E-39_JPRB, &
  & 0.51687735E-39_JPRB, 0.45606800E-39_JPRB, 0.40090168E-39_JPRB, 0.32440200E-39_JPRB /)

RGHG9(:, 7, 3) = (/ &
  & 0.60437980E-37_JPRB, 0.10988088E-36_JPRB, 0.13949242E-36_JPRB, 0.16410503E-36_JPRB, 0.19446182E-36_JPRB, 0.23557013E-36_JPRB, &
  & 0.29729549E-36_JPRB, 0.39542589E-36_JPRB, 0.55864420E-36_JPRB, 0.84187922E-36_JPRB, 0.13850981E-35_JPRB, 0.24702443E-35_JPRB, &
  & 0.47997872E-35_JPRB, 0.95635735E-35_JPRB, 0.18935162E-34_JPRB, 0.43280778E-34_JPRB, 0.83184925E-34_JPRB, 0.19378341E-33_JPRB, &
  & 0.37747034E-33_JPRB, 0.67285811E-33_JPRB, 0.13626236E-32_JPRB, 0.22325709E-32_JPRB, 0.41379128E-32_JPRB, 0.60062358E-32_JPRB, &
  & 0.97547150E-32_JPRB, 0.15214316E-31_JPRB, 0.18493155E-31_JPRB, 0.23561885E-31_JPRB, 0.25572959E-31_JPRB, 0.24733030E-31_JPRB, &
  & 0.23679170E-31_JPRB, 0.21906463E-31_JPRB, 0.19636980E-31_JPRB, 0.17502804E-31_JPRB, 0.15318688E-31_JPRB, 0.13339805E-31_JPRB, &
  & 0.11654418E-31_JPRB, 0.99260558E-32_JPRB, 0.91750758E-32_JPRB, 0.69806688E-32_JPRB, 0.57692502E-32_JPRB, 0.38621087E-32_JPRB, &
  & 0.25617637E-32_JPRB, 0.13815515E-32_JPRB, 0.64198568E-33_JPRB, 0.32274908E-33_JPRB, 0.16899304E-33_JPRB, 0.89105881E-34_JPRB, &
  & 0.47842281E-34_JPRB, 0.26161778E-34_JPRB, 0.14625932E-34_JPRB, 0.83930849E-35_JPRB, 0.49722643E-35_JPRB, 0.30592352E-35_JPRB, &
  & 0.19656644E-35_JPRB, 0.13279737E-35_JPRB, 0.94745031E-36_JPRB, 0.71552461E-36_JPRB, 0.57064425E-36_JPRB, 0.47811115E-36_JPRB, &
  & 0.41707360E-36_JPRB, 0.37276723E-36_JPRB, 0.33648734E-36_JPRB, 0.28721982E-36_JPRB /)

RGHG9(:, 8, 3) = (/ &
  & 0.42863156E-34_JPRB, 0.76860014E-34_JPRB, 0.96768876E-34_JPRB, 0.11263749E-33_JPRB, 0.13162271E-33_JPRB, 0.15647000E-33_JPRB, &
  & 0.19270806E-33_JPRB, 0.24856420E-33_JPRB, 0.33823149E-33_JPRB, 0.48725522E-33_JPRB, 0.76097390E-33_JPRB, 0.12801887E-32_JPRB, &
  & 0.23397936E-32_JPRB, 0.43736324E-32_JPRB, 0.80869926E-32_JPRB, 0.17439202E-31_JPRB, 0.31336669E-31_JPRB, 0.69067487E-31_JPRB, &
  & 0.12702344E-30_JPRB, 0.21356529E-30_JPRB, 0.41027983E-30_JPRB, 0.63807559E-30_JPRB, 0.11293316E-29_JPRB, 0.15641228E-29_JPRB, &
  & 0.24466691E-29_JPRB, 0.36997110E-29_JPRB, 0.43685861E-29_JPRB, 0.54538300E-29_JPRB, 0.58146176E-29_JPRB, 0.55477036E-29_JPRB, &
  & 0.52743762E-29_JPRB, 0.48725159E-29_JPRB, 0.43811833E-29_JPRB, 0.39363352E-29_JPRB, 0.34894894E-29_JPRB, 0.30947054E-29_JPRB, &
  & 0.27681970E-29_JPRB, 0.24270911E-29_JPRB, 0.23233887E-29_JPRB, 0.18371339E-29_JPRB, 0.15895260E-29_JPRB, 0.11171264E-29_JPRB, &
  & 0.78190565E-30_JPRB, 0.44393391E-30_JPRB, 0.21593742E-30_JPRB, 0.11480938E-30_JPRB, 0.63750797E-31_JPRB, 0.35603726E-31_JPRB, &
  & 0.20296397E-31_JPRB, 0.11798435E-31_JPRB, 0.70218015E-32_JPRB, 0.42910312E-32_JPRB, 0.27050726E-32_JPRB, 0.17670171E-32_JPRB, &
  & 0.12007561E-32_JPRB, 0.85366172E-33_JPRB, 0.63695438E-33_JPRB, 0.49957908E-33_JPRB, 0.41080185E-33_JPRB, 0.35247265E-33_JPRB, &
  & 0.31281018E-33_JPRB, 0.28373151E-33_JPRB, 0.25781769E-33_JPRB, 0.22380813E-33_JPRB /)

RGHG9(:, 9, 3) = (/ &
  & 0.25450608E-31_JPRB, 0.45287830E-31_JPRB, 0.56640325E-31_JPRB, 0.65447158E-31_JPRB, 0.75662598E-31_JPRB, 0.88608841E-31_JPRB, &
  & 0.10692023E-30_JPRB, 0.13427754E-30_JPRB, 0.17668297E-30_JPRB, 0.24424360E-30_JPRB, 0.36332769E-30_JPRB, 0.57811978E-30_JPRB, &
  & 0.99568349E-30_JPRB, 0.17474914E-29_JPRB, 0.30142325E-29_JPRB, 0.61342945E-29_JPRB, 0.10271258E-28_JPRB, 0.21464841E-28_JPRB, &
  & 0.37289663E-28_JPRB, 0.59032804E-28_JPRB, 0.10797854E-27_JPRB, 0.15937610E-27_JPRB, 0.26925846E-27_JPRB, 0.35691059E-27_JPRB, &
  & 0.53567141E-27_JPRB, 0.78605738E-27_JPRB, 0.90131682E-27_JPRB, 0.11019796E-26_JPRB, 0.11539249E-26_JPRB, 0.10859063E-26_JPRB, &
  & 0.10244257E-26_JPRB, 0.94380332E-27_JPRB, 0.85079621E-27_JPRB, 0.77015801E-27_JPRB, 0.69180665E-27_JPRB, 0.62519663E-27_JPRB, &
  & 0.57325170E-27_JPRB, 0.51812393E-27_JPRB, 0.51375626E-27_JPRB, 0.42335214E-27_JPRB, 0.38346442E-27_JPRB, 0.28343928E-27_JPRB, &
  & 0.20969256E-27_JPRB, 0.12506086E-27_JPRB, 0.63594490E-28_JPRB, 0.35758281E-28_JPRB, 0.21088128E-28_JPRB, 0.12498469E-28_JPRB, &
  & 0.75761623E-29_JPRB, 0.46896594E-29_JPRB, 0.29732958E-29_JPRB, 0.19337317E-29_JPRB, 0.12944281E-29_JPRB, 0.89441964E-30_JPRB, &
  & 0.63996141E-30_JPRB, 0.47634558E-30_JPRB, 0.36995774E-30_JPRB, 0.30006687E-30_JPRB, 0.25349587E-30_JPRB, 0.22201999E-30_JPRB, &
  & 0.20020538E-30_JPRB, 0.18328991E-30_JPRB, 0.16833713E-30_JPRB, 0.14651901E-30_JPRB /)

RGHG9(:,10, 3) = (/ &
  & 0.12565764E-28_JPRB, 0.22173230E-28_JPRB, 0.27636180E-28_JPRB, 0.31776252E-28_JPRB, 0.36475395E-28_JPRB, 0.42235981E-28_JPRB, &
  & 0.50129071E-28_JPRB, 0.61540515E-28_JPRB, 0.78608708E-28_JPRB, 0.10468496E-27_JPRB, 0.14886740E-27_JPRB, 0.22486987E-27_JPRB, &
  & 0.36595553E-27_JPRB, 0.60452683E-27_JPRB, 0.97462369E-27_JPRB, 0.18715388E-26_JPRB, 0.29199421E-26_JPRB, 0.57828727E-26_JPRB, &
  & 0.94797022E-26_JPRB, 0.14120450E-25_JPRB, 0.24577225E-25_JPRB, 0.34374281E-25_JPRB, 0.55518970E-25_JPRB, 0.70283944E-25_JPRB, &
  & 0.10147520E-24_JPRB, 0.14413530E-24_JPRB, 0.16069178E-24_JPRB, 0.19217384E-24_JPRB, 0.19765361E-24_JPRB, 0.18343672E-24_JPRB, &
  & 0.17155188E-24_JPRB, 0.15750860E-24_JPRB, 0.14220919E-24_JPRB, 0.12967627E-24_JPRB, 0.11802022E-24_JPRB, 0.10875840E-24_JPRB, &
  & 0.10230431E-24_JPRB, 0.95479533E-25_JPRB, 0.98062079E-25_JPRB, 0.84386220E-25_JPRB, 0.80010587E-25_JPRB, 0.62302650E-25_JPRB, &
  & 0.48705674E-25_JPRB, 0.30619735E-25_JPRB, 0.16238708E-25_JPRB, 0.96923557E-26_JPRB, 0.60819077E-26_JPRB, 0.38296978E-26_JPRB, &
  & 0.24717343E-26_JPRB, 0.16297148E-26_JPRB, 0.10998936E-26_JPRB, 0.75975245E-27_JPRB, 0.53823300E-27_JPRB, 0.39185286E-27_JPRB, &
  & 0.29370559E-27_JPRB, 0.22779389E-27_JPRB, 0.18322371E-27_JPRB, 0.15299113E-27_JPRB, 0.13219968E-27_JPRB, 0.11782109E-27_JPRB, &
  & 0.10742853E-27_JPRB, 0.99341844E-28_JPRB, 0.91506336E-28_JPRB, 0.80312741E-28_JPRB /)

RGHG9(:,11, 3) = (/ &
  & 0.51627672E-26_JPRB, 0.90516088E-26_JPRB, 0.11232734E-25_JPRB, 0.12874883E-25_JPRB, 0.14691980E-25_JPRB, 0.16852876E-25_JPRB, &
  & 0.19713139E-25_JPRB, 0.23707363E-25_JPRB, 0.29464885E-25_JPRB, 0.37893836E-25_JPRB, 0.51673307E-25_JPRB, 0.74318074E-25_JPRB, &
  & 0.11466599E-24_JPRB, 0.17884486E-24_JPRB, 0.27050107E-24_JPRB, 0.49037004E-24_JPRB, 0.71535766E-24_JPRB, 0.13385894E-23_JPRB, &
  & 0.20709782E-23_JPRB, 0.29014896E-23_JPRB, 0.47998250E-23_JPRB, 0.63606446E-23_JPRB, 0.98221908E-23_JPRB, 0.11888472E-22_JPRB, &
  & 0.16510840E-22_JPRB, 0.22734956E-22_JPRB, 0.24635697E-22_JPRB, 0.28815647E-22_JPRB, 0.29105433E-22_JPRB, 0.26635106E-22_JPRB, &
  & 0.24680103E-22_JPRB, 0.22563159E-22_JPRB, 0.20394418E-22_JPRB, 0.18723099E-22_JPRB, 0.17261414E-22_JPRB, 0.16217376E-22_JPRB, &
  & 0.15650054E-22_JPRB, 0.15083469E-22_JPRB, 0.16037593E-22_JPRB, 0.14413640E-22_JPRB, 0.14293150E-22_JPRB, 0.11720458E-22_JPRB, &
  & 0.96889514E-23_JPRB, 0.64149534E-23_JPRB, 0.35676952E-23_JPRB, 0.22603845E-23_JPRB, 0.15115244E-23_JPRB, 0.10112602E-23_JPRB, &
  & 0.69473525E-24_JPRB, 0.48744051E-24_JPRB, 0.34959505E-24_JPRB, 0.25587465E-24_JPRB, 0.19133095E-24_JPRB, 0.14624613E-24_JPRB, &
  & 0.11448497E-24_JPRB, 0.92159174E-25_JPRB, 0.76496773E-25_JPRB, 0.65505876E-25_JPRB, 0.57723941E-25_JPRB, 0.52127744E-25_JPRB, &
  & 0.48062876E-25_JPRB, 0.44620820E-25_JPRB, 0.41400203E-25_JPRB, 0.36303450E-25_JPRB /)

RGHG9(:,12, 3) = (/ &
  & 0.17726269E-23_JPRB, 0.30787379E-23_JPRB, 0.38126456E-23_JPRB, 0.43556584E-23_JPRB, 0.49474295E-23_JPRB, 0.56270995E-23_JPRB, &
  & 0.64953667E-23_JPRB, 0.76626130E-23_JPRB, 0.92807663E-23_JPRB, 0.11550378E-22_JPRB, 0.15134604E-22_JPRB, 0.20790009E-22_JPRB, &
  & 0.30488931E-22_JPRB, 0.45028345E-22_JPRB, 0.64140002E-22_JPRB, 0.10969886E-21_JPRB, 0.15024161E-21_JPRB, 0.26480983E-21_JPRB, &
  & 0.38629107E-21_JPRB, 0.50993378E-21_JPRB, 0.79887977E-21_JPRB, 0.10046133E-20_JPRB, 0.14816467E-20_JPRB, 0.17152689E-20_JPRB, &
  & 0.22919947E-20_JPRB, 0.30585233E-20_JPRB, 0.32185119E-20_JPRB, 0.36787880E-20_JPRB, 0.36462957E-20_JPRB, 0.32884911E-20_JPRB, &
  & 0.30178705E-20_JPRB, 0.27467247E-20_JPRB, 0.24855475E-20_JPRB, 0.22980075E-20_JPRB, 0.21470222E-20_JPRB, 0.20568526E-20_JPRB, &
  & 0.20364405E-20_JPRB, 0.20265416E-20_JPRB, 0.22313524E-20_JPRB, 0.20928831E-20_JPRB, 0.21700431E-20_JPRB, 0.18729269E-20_JPRB, &
  & 0.16351554E-20_JPRB, 0.11441311E-20_JPRB, 0.66793956E-21_JPRB, 0.45081969E-21_JPRB, 0.32092548E-21_JPRB, 0.22807796E-21_JPRB, &
  & 0.16656380E-21_JPRB, 0.12411478E-21_JPRB, 0.94369638E-22_JPRB, 0.72998651E-22_JPRB, 0.57447906E-22_JPRB, 0.45990632E-22_JPRB, &
  & 0.37477021E-22_JPRB, 0.31225721E-22_JPRB, 0.26658122E-22_JPRB, 0.23339707E-22_JPRB, 0.20899876E-22_JPRB, 0.19113229E-22_JPRB, &
  & 0.17724054E-22_JPRB, 0.16578385E-22_JPRB, 0.15368479E-22_JPRB, 0.13551086E-22_JPRB /)

RGHG9(:,13, 3) = (/ &
  & 0.51290984E-21_JPRB, 0.88758519E-21_JPRB, 0.10959341E-20_JPRB, 0.12494707E-20_JPRB, 0.14126740E-20_JPRB, 0.15941266E-20_JPRB, &
  & 0.18167429E-20_JPRB, 0.21039436E-20_JPRB, 0.24853558E-20_JPRB, 0.29957751E-20_JPRB, 0.37775440E-20_JPRB, 0.49622961E-20_JPRB, &
  & 0.69278412E-20_JPRB, 0.96998543E-20_JPRB, 0.13032500E-19_JPRB, 0.21015519E-19_JPRB, 0.27055478E-19_JPRB, 0.44817049E-19_JPRB, &
  & 0.61607165E-19_JPRB, 0.76584782E-19_JPRB, 0.11346647E-18_JPRB, 0.13526280E-18_JPRB, 0.19039515E-18_JPRB, 0.21056984E-18_JPRB, &
  & 0.27032929E-18_JPRB, 0.34884719E-18_JPRB, 0.35585054E-18_JPRB, 0.39657236E-18_JPRB, 0.38517477E-18_JPRB, 0.34215579E-18_JPRB, &
  & 0.31096632E-18_JPRB, 0.28191988E-18_JPRB, 0.25560731E-18_JPRB, 0.23821421E-18_JPRB, 0.22570616E-18_JPRB, 0.22067134E-18_JPRB, &
  & 0.22434542E-18_JPRB, 0.23068299E-18_JPRB, 0.26348468E-18_JPRB, 0.25789346E-18_JPRB, 0.27991828E-18_JPRB, 0.25425932E-18_JPRB, &
  & 0.23447104E-18_JPRB, 0.17340629E-18_JPRB, 0.10699892E-18_JPRB, 0.76855251E-19_JPRB, 0.58274654E-19_JPRB, 0.43965593E-19_JPRB, &
  & 0.34092650E-19_JPRB, 0.26934432E-19_JPRB, 0.21667928E-19_JPRB, 0.17677927E-19_JPRB, 0.14614149E-19_JPRB, 0.12225876E-19_JPRB, &
  & 0.10352408E-19_JPRB, 0.89064572E-20_JPRB, 0.78024975E-20_JPRB, 0.69680055E-20_JPRB, 0.63324921E-20_JPRB, 0.58430160E-20_JPRB, &
  & 0.54631612E-20_JPRB, 0.51143842E-20_JPRB, 0.47650365E-20_JPRB, 0.41784100E-20_JPRB /)

RGHG9(:,14, 3) = (/ &
  & 0.12756596E-18_JPRB, 0.21968994E-18_JPRB, 0.27091070E-18_JPRB, 0.30790144E-18_JPRB, 0.34633442E-18_JPRB, 0.38726761E-18_JPRB, &
  & 0.43525293E-18_JPRB, 0.49419689E-18_JPRB, 0.56875238E-18_JPRB, 0.66347490E-18_JPRB, 0.80453339E-18_JPRB, 0.10106563E-17_JPRB, &
  & 0.13431339E-17_JPRB, 0.17832988E-17_JPRB, 0.22617591E-17_JPRB, 0.34369673E-17_JPRB, 0.41624514E-17_JPRB, 0.64779909E-17_JPRB, &
  & 0.83929997E-17_JPRB, 0.98275707E-17_JPRB, 0.13757633E-16_JPRB, 0.15555987E-16_JPRB, 0.20858613E-16_JPRB, 0.22045743E-16_JPRB, &
  & 0.27142885E-16_JPRB, 0.33802256E-16_JPRB, 0.33380645E-16_JPRB, 0.36193132E-16_JPRB, 0.34399599E-16_JPRB, 0.30077058E-16_JPRB, &
  & 0.27067310E-16_JPRB, 0.24453964E-16_JPRB, 0.22232112E-16_JPRB, 0.20901445E-16_JPRB, 0.20101994E-16_JPRB, 0.20072616E-16_JPRB, &
  & 0.20971426E-16_JPRB, 0.22294020E-16_JPRB, 0.26455033E-16_JPRB, 0.27015883E-16_JPRB, 0.30713825E-16_JPRB, 0.29340814E-16_JPRB, &
  & 0.28552031E-16_JPRB, 0.22335357E-16_JPRB, 0.14596699E-16_JPRB, 0.11168531E-16_JPRB, 0.90100135E-17_JPRB, 0.72167555E-17_JPRB, &
  & 0.59388933E-17_JPRB, 0.49713406E-17_JPRB, 0.42288050E-17_JPRB, 0.36371016E-17_JPRB, 0.31570523E-17_JPRB, 0.27593562E-17_JPRB, &
  & 0.24268350E-17_JPRB, 0.21550954E-17_JPRB, 0.19367028E-17_JPRB, 0.17636899E-17_JPRB, 0.16254927E-17_JPRB, 0.15157775E-17_JPRB, &
  & 0.14239726E-17_JPRB, 0.13404342E-17_JPRB, 0.12466197E-17_JPRB, 0.10945806E-17_JPRB /)

RGHG9(:,15, 3) = (/ &
  & 0.27336935E-16_JPRB, 0.46912069E-16_JPRB, 0.57644390E-16_JPRB, 0.65238822E-16_JPRB, 0.72873712E-16_JPRB, 0.80630324E-16_JPRB, &
  & 0.89236721E-16_JPRB, 0.99222081E-16_JPRB, 0.11113279E-15_JPRB, 0.12536387E-15_JPRB, 0.14610594E-15_JPRB, 0.17544166E-15_JPRB, &
  & 0.22188290E-15_JPRB, 0.27938132E-15_JPRB, 0.33454805E-15_JPRB, 0.47937200E-15_JPRB, 0.54609675E-15_JPRB, 0.79944521E-15_JPRB, &
  & 0.97664127E-15_JPRB, 0.10767595E-14_JPRB, 0.14248669E-14_JPRB, 0.15269215E-14_JPRB, 0.19494309E-14_JPRB, 0.19682613E-14_JPRB, &
  & 0.23218700E-14_JPRB, 0.27859797E-14_JPRB, 0.26615656E-14_JPRB, 0.28036981E-14_JPRB, 0.26051023E-14_JPRB, 0.22399968E-14_JPRB, &
  & 0.19953568E-14_JPRB, 0.17963671E-14_JPRB, 0.16381084E-14_JPRB, 0.15546881E-14_JPRB, 0.15188684E-14_JPRB, 0.15501336E-14_JPRB, &
  & 0.16651624E-14_JPRB, 0.18307889E-14_JPRB, 0.22584607E-14_JPRB, 0.24059043E-14_JPRB, 0.28649030E-14_JPRB, 0.28758916E-14_JPRB, &
  & 0.29487705E-14_JPRB, 0.24380245E-14_JPRB, 0.16909275E-14_JPRB, 0.13766924E-14_JPRB, 0.11809400E-14_JPRB, 0.10043648E-14_JPRB, &
  & 0.87714820E-15_JPRB, 0.77818706E-15_JPRB, 0.70024553E-15_JPRB, 0.63525083E-15_JPRB, 0.57932125E-15_JPRB, 0.52931359E-15_JPRB, &
  & 0.48384878E-15_JPRB, 0.44384238E-15_JPRB, 0.40944956E-15_JPRB, 0.38059019E-15_JPRB, 0.35621592E-15_JPRB, 0.33559747E-15_JPRB, &
  & 0.31779485E-15_JPRB, 0.29993561E-15_JPRB, 0.27994849E-15_JPRB, 0.24490626E-15_JPRB /)

RGHG9(:,16, 3) = (/ &
  & 0.31001414E-15_JPRB, 0.51460634E-15_JPRB, 0.64159919E-15_JPRB, 0.73568708E-15_JPRB, 0.83455054E-15_JPRB, 0.94092877E-15_JPRB, &
  & 0.10608701E-14_JPRB, 0.11936305E-14_JPRB, 0.13443543E-14_JPRB, 0.15349258E-14_JPRB, 0.17478485E-14_JPRB, 0.20547732E-14_JPRB, &
  & 0.25821937E-14_JPRB, 0.31772432E-14_JPRB, 0.36428689E-14_JPRB, 0.51391420E-14_JPRB, 0.58941423E-14_JPRB, 0.79091820E-14_JPRB, &
  & 0.97982815E-14_JPRB, 0.11635460E-13_JPRB, 0.13749440E-13_JPRB, 0.15500527E-13_JPRB, 0.16764261E-13_JPRB, 0.18255661E-13_JPRB, &
  & 0.19285011E-13_JPRB, 0.18534555E-13_JPRB, 0.20982785E-13_JPRB, 0.22144731E-13_JPRB, 0.20954687E-13_JPRB, 0.18244997E-13_JPRB, &
  & 0.17667964E-13_JPRB, 0.16138151E-13_JPRB, 0.14890787E-13_JPRB, 0.14183650E-13_JPRB, 0.13913685E-13_JPRB, 0.14173506E-13_JPRB, &
  & 0.14965253E-13_JPRB, 0.16350543E-13_JPRB, 0.18403793E-13_JPRB, 0.20576531E-13_JPRB, 0.22043379E-13_JPRB, 0.20045194E-13_JPRB, &
  & 0.17565781E-13_JPRB, 0.16009643E-13_JPRB, 0.15233661E-13_JPRB, 0.14232346E-13_JPRB, 0.12554314E-13_JPRB, 0.10977344E-13_JPRB, &
  & 0.97163539E-14_JPRB, 0.87066483E-14_JPRB, 0.78877673E-14_JPRB, 0.71894183E-14_JPRB, 0.65601499E-14_JPRB, 0.59794368E-14_JPRB, &
  & 0.54425162E-14_JPRB, 0.49531442E-14_JPRB, 0.45164695E-14_JPRB, 0.41349523E-14_JPRB, 0.38060091E-14_JPRB, 0.35310769E-14_JPRB, &
  & 0.32953237E-14_JPRB, 0.30861736E-14_JPRB, 0.28623623E-14_JPRB, 0.25054500E-14_JPRB /)

RGHG9(:,17, 3) = (/ &
  & 0.22864289E-14_JPRB, 0.37288711E-14_JPRB, 0.46642814E-14_JPRB, 0.54684892E-14_JPRB, 0.62714408E-14_JPRB, 0.72304884E-14_JPRB, &
  & 0.82953121E-14_JPRB, 0.95520608E-14_JPRB, 0.10950198E-13_JPRB, 0.12577078E-13_JPRB, 0.14262619E-13_JPRB, 0.16857285E-13_JPRB, &
  & 0.20665590E-13_JPRB, 0.24163056E-13_JPRB, 0.29461771E-13_JPRB, 0.36592118E-13_JPRB, 0.44368426E-13_JPRB, 0.55621533E-13_JPRB, &
  & 0.67308260E-13_JPRB, 0.79202168E-13_JPRB, 0.90586752E-13_JPRB, 0.10063727E-12_JPRB, 0.10966143E-12_JPRB, 0.11547260E-12_JPRB, &
  & 0.12005475E-12_JPRB, 0.12681190E-12_JPRB, 0.12249148E-12_JPRB, 0.11451090E-12_JPRB, 0.11349871E-12_JPRB, 0.11524138E-12_JPRB, &
  & 0.11156751E-12_JPRB, 0.10464063E-12_JPRB, 0.98602794E-13_JPRB, 0.95217013E-13_JPRB, 0.94277579E-13_JPRB, 0.96187395E-13_JPRB, &
  & 0.10075181E-12_JPRB, 0.10670731E-12_JPRB, 0.11196334E-12_JPRB, 0.11548646E-12_JPRB, 0.12106967E-12_JPRB, 0.12637656E-12_JPRB, &
  & 0.12797646E-12_JPRB, 0.12440739E-12_JPRB, 0.11612266E-12_JPRB, 0.10367655E-12_JPRB, 0.90910000E-13_JPRB, 0.79916108E-13_JPRB, &
  & 0.70750223E-13_JPRB, 0.63284955E-13_JPRB, 0.57031711E-13_JPRB, 0.51617429E-13_JPRB, 0.46766187E-13_JPRB, 0.42326392E-13_JPRB, &
  & 0.38236321E-13_JPRB, 0.34493025E-13_JPRB, 0.31114691E-13_JPRB, 0.28145289E-13_JPRB, 0.25606460E-13_JPRB, 0.23501837E-13_JPRB, &
  & 0.21801451E-13_JPRB, 0.20348318E-13_JPRB, 0.18880315E-13_JPRB, 0.16391319E-13_JPRB /)

RGHG9(:,18, 3) = (/ &
  & 0.12498417E-13_JPRB, 0.20149809E-13_JPRB, 0.25210582E-13_JPRB, 0.29789336E-13_JPRB, 0.34171125E-13_JPRB, 0.39422845E-13_JPRB, &
  & 0.45766240E-13_JPRB, 0.53434623E-13_JPRB, 0.62775130E-13_JPRB, 0.73647543E-13_JPRB, 0.84960135E-13_JPRB, 0.99794955E-13_JPRB, &
  & 0.11919940E-12_JPRB, 0.13890497E-12_JPRB, 0.16574570E-12_JPRB, 0.19807765E-12_JPRB, 0.23531809E-12_JPRB, 0.28043236E-12_JPRB, &
  & 0.32917446E-12_JPRB, 0.37763881E-12_JPRB, 0.42275238E-12_JPRB, 0.45966258E-12_JPRB, 0.48887462E-12_JPRB, 0.50735972E-12_JPRB, &
  & 0.51947845E-12_JPRB, 0.51958373E-12_JPRB, 0.51784288E-12_JPRB, 0.53634788E-12_JPRB, 0.53759585E-12_JPRB, 0.52678603E-12_JPRB, &
  & 0.50968886E-12_JPRB, 0.49128681E-12_JPRB, 0.47686323E-12_JPRB, 0.47146412E-12_JPRB, 0.47453404E-12_JPRB, 0.48795023E-12_JPRB, &
  & 0.51165989E-12_JPRB, 0.54231359E-12_JPRB, 0.57398899E-12_JPRB, 0.60211222E-12_JPRB, 0.61697750E-12_JPRB, 0.61616760E-12_JPRB, &
  & 0.59906735E-12_JPRB, 0.56539598E-12_JPRB, 0.51824869E-12_JPRB, 0.46591436E-12_JPRB, 0.41575142E-12_JPRB, 0.36971091E-12_JPRB, &
  & 0.32983845E-12_JPRB, 0.29557910E-12_JPRB, 0.26618828E-12_JPRB, 0.24050342E-12_JPRB, 0.21756850E-12_JPRB, 0.19664771E-12_JPRB, &
  & 0.17740106E-12_JPRB, 0.15972231E-12_JPRB, 0.14374024E-12_JPRB, 0.12968270E-12_JPRB, 0.11775823E-12_JPRB, 0.10810943E-12_JPRB, &
  & 0.10036777E-12_JPRB, 0.93978224E-13_JPRB, 0.87746393E-13_JPRB, 0.76146602E-13_JPRB /)

RGHG9(:,19, 3) = (/ &
  & 0.52588488E-13_JPRB, 0.83588870E-13_JPRB, 0.10479814E-12_JPRB, 0.12498271E-12_JPRB, 0.14539003E-12_JPRB, 0.16774169E-12_JPRB, &
  & 0.19486439E-12_JPRB, 0.22798278E-12_JPRB, 0.26868525E-12_JPRB, 0.31660316E-12_JPRB, 0.36902000E-12_JPRB, 0.42961489E-12_JPRB, &
  & 0.50270758E-12_JPRB, 0.58150463E-12_JPRB, 0.67312150E-12_JPRB, 0.77793479E-12_JPRB, 0.89737001E-12_JPRB, 0.10292038E-11_JPRB, &
  & 0.11681934E-11_JPRB, 0.13043945E-11_JPRB, 0.14243267E-11_JPRB, 0.15194524E-11_JPRB, 0.15842690E-11_JPRB, 0.16253098E-11_JPRB, &
  & 0.16448578E-11_JPRB, 0.16598210E-11_JPRB, 0.16949295E-11_JPRB, 0.16966272E-11_JPRB, 0.16967686E-11_JPRB, 0.16935990E-11_JPRB, &
  & 0.16934603E-11_JPRB, 0.16945651E-11_JPRB, 0.17035369E-11_JPRB, 0.17303217E-11_JPRB, 0.17695592E-11_JPRB, 0.18259435E-11_JPRB, &
  & 0.18965244E-11_JPRB, 0.19749621E-11_JPRB, 0.20426237E-11_JPRB, 0.20830139E-11_JPRB, 0.20873075E-11_JPRB, 0.20474321E-11_JPRB, &
  & 0.19627134E-11_JPRB, 0.18370368E-11_JPRB, 0.16835633E-11_JPRB, 0.15178743E-11_JPRB, 0.13548816E-11_JPRB, 0.12056805E-11_JPRB, &
  & 0.10756084E-11_JPRB, 0.96397879E-12_JPRB, 0.86860684E-12_JPRB, 0.78531533E-12_JPRB, 0.71139058E-12_JPRB, 0.64443096E-12_JPRB, &
  & 0.58313678E-12_JPRB, 0.52712565E-12_JPRB, 0.47652496E-12_JPRB, 0.43210588E-12_JPRB, 0.39473210E-12_JPRB, 0.36448822E-12_JPRB, &
  & 0.34021630E-12_JPRB, 0.32055039E-12_JPRB, 0.29882422E-12_JPRB, 0.26342551E-12_JPRB /)

RGHG9(:,20, 3) = (/ &
  & 0.17682519E-12_JPRB, 0.27540055E-12_JPRB, 0.34274225E-12_JPRB, 0.40760616E-12_JPRB, 0.47727962E-12_JPRB, 0.55411551E-12_JPRB, &
  & 0.64283556E-12_JPRB, 0.74860756E-12_JPRB, 0.87710769E-12_JPRB, 0.10272409E-11_JPRB, 0.11947642E-11_JPRB, 0.13791720E-11_JPRB, &
  & 0.15861956E-11_JPRB, 0.18079530E-11_JPRB, 0.20440477E-11_JPRB, 0.22978468E-11_JPRB, 0.25705597E-11_JPRB, 0.28560550E-11_JPRB, &
  & 0.31418704E-11_JPRB, 0.34103050E-11_JPRB, 0.36399668E-11_JPRB, 0.38113740E-11_JPRB, 0.39206824E-11_JPRB, 0.39732822E-11_JPRB, &
  & 0.39849925E-11_JPRB, 0.40062415E-11_JPRB, 0.40060845E-11_JPRB, 0.40386379E-11_JPRB, 0.41066287E-11_JPRB, 0.42063306E-11_JPRB, &
  & 0.43351767E-11_JPRB, 0.44674555E-11_JPRB, 0.46190100E-11_JPRB, 0.47871442E-11_JPRB, 0.49488634E-11_JPRB, 0.51147728E-11_JPRB, &
  & 0.52753535E-11_JPRB, 0.53954931E-11_JPRB, 0.54513997E-11_JPRB, 0.54216297E-11_JPRB, 0.53019364E-11_JPRB, 0.50899953E-11_JPRB, &
  & 0.47977846E-11_JPRB, 0.44397775E-11_JPRB, 0.40442042E-11_JPRB, 0.36400253E-11_JPRB, 0.32580462E-11_JPRB, 0.29139091E-11_JPRB, &
  & 0.26135611E-11_JPRB, 0.23532474E-11_JPRB, 0.21284827E-11_JPRB, 0.19316976E-11_JPRB, 0.17575688E-11_JPRB, 0.16009492E-11_JPRB, &
  & 0.14589799E-11_JPRB, 0.13299933E-11_JPRB, 0.12137275E-11_JPRB, 0.11118154E-11_JPRB, 0.10256934E-11_JPRB, 0.95585605E-12_JPRB, &
  & 0.90086738E-12_JPRB, 0.85100004E-12_JPRB, 0.79815169E-12_JPRB, 0.70660844E-12_JPRB /)

RGHG9(:,21, 3) = (/ &
  & 0.48324696E-12_JPRB, 0.73064189E-12_JPRB, 0.89870510E-12_JPRB, 0.10596422E-11_JPRB, 0.12303304E-11_JPRB, 0.14212237E-11_JPRB, &
  & 0.16367346E-11_JPRB, 0.18925729E-11_JPRB, 0.21962560E-11_JPRB, 0.25471003E-11_JPRB, 0.29378344E-11_JPRB, 0.33590765E-11_JPRB, &
  & 0.38072072E-11_JPRB, 0.42746475E-11_JPRB, 0.47506049E-11_JPRB, 0.52296483E-11_JPRB, 0.57113719E-11_JPRB, 0.61893693E-11_JPRB, &
  & 0.66500017E-11_JPRB, 0.70722404E-11_JPRB, 0.74267597E-11_JPRB, 0.76939453E-11_JPRB, 0.78554585E-11_JPRB, 0.79215731E-11_JPRB, &
  & 0.79509906E-11_JPRB, 0.79151755E-11_JPRB, 0.79237051E-11_JPRB, 0.80225262E-11_JPRB, 0.82174805E-11_JPRB, 0.85226782E-11_JPRB, &
  & 0.89104332E-11_JPRB, 0.93450456E-11_JPRB, 0.98180500E-11_JPRB, 0.10269253E-10_JPRB, 0.10676715E-10_JPRB, 0.11008472E-10_JPRB, &
  & 0.11241136E-10_JPRB, 0.11321780E-10_JPRB, 0.11235127E-10_JPRB, 0.10968461E-10_JPRB, 0.10536970E-10_JPRB, 0.99663333E-11_JPRB, &
  & 0.92889073E-11_JPRB, 0.85409345E-11_JPRB, 0.77652667E-11_JPRB, 0.70063877E-11_JPRB, 0.63010157E-11_JPRB, 0.56676751E-11_JPRB, &
  & 0.51116364E-11_JPRB, 0.46281802E-11_JPRB, 0.42082839E-11_JPRB, 0.38408074E-11_JPRB, 0.35170378E-11_JPRB, 0.32282488E-11_JPRB, &
  & 0.29686093E-11_JPRB, 0.27336555E-11_JPRB, 0.25216873E-11_JPRB, 0.23341246E-11_JPRB, 0.21741703E-11_JPRB, 0.20426148E-11_JPRB, &
  & 0.19338405E-11_JPRB, 0.18319101E-11_JPRB, 0.17163273E-11_JPRB, 0.15445899E-11_JPRB /)

RGHG9(:,22, 3) = (/ &
  & 0.11000169E-11_JPRB, 0.15998353E-11_JPRB, 0.19314799E-11_JPRB, 0.22483328E-11_JPRB, 0.25845634E-11_JPRB, 0.29549681E-11_JPRB, &
  & 0.33720487E-11_JPRB, 0.38512318E-11_JPRB, 0.44077146E-11_JPRB, 0.50402803E-11_JPRB, 0.57385845E-11_JPRB, 0.64831768E-11_JPRB, &
  & 0.72504862E-11_JPRB, 0.80270027E-11_JPRB, 0.87986042E-11_JPRB, 0.95530727E-11_JPRB, 0.10283116E-10_JPRB, 0.10980892E-10_JPRB, &
  & 0.11634432E-10_JPRB, 0.12226234E-10_JPRB, 0.12726387E-10_JPRB, 0.13107436E-10_JPRB, 0.13354959E-10_JPRB, 0.13482702E-10_JPRB, &
  & 0.13494568E-10_JPRB, 0.13485575E-10_JPRB, 0.13535034E-10_JPRB, 0.13710838E-10_JPRB, 0.14054967E-10_JPRB, 0.14606861E-10_JPRB, &
  & 0.15307483E-10_JPRB, 0.16131275E-10_JPRB, 0.16982520E-10_JPRB, 0.17788149E-10_JPRB, 0.18465196E-10_JPRB, 0.18943146E-10_JPRB, &
  & 0.19171378E-10_JPRB, 0.19106456E-10_JPRB, 0.18738500E-10_JPRB, 0.18094545E-10_JPRB, 0.17219772E-10_JPRB, 0.16172997E-10_JPRB, &
  & 0.15013277E-10_JPRB, 0.13799123E-10_JPRB, 0.12582782E-10_JPRB, 0.11414995E-10_JPRB, 0.10335028E-10_JPRB, 0.93631925E-11_JPRB, &
  & 0.85054784E-11_JPRB, 0.77527507E-11_JPRB, 0.70953386E-11_JPRB, 0.65218174E-11_JPRB, 0.60182597E-11_JPRB, 0.55712752E-11_JPRB, &
  & 0.51705272E-11_JPRB, 0.48075380E-11_JPRB, 0.44782320E-11_JPRB, 0.41834483E-11_JPRB, 0.39255118E-11_JPRB, 0.37045423E-11_JPRB, &
  & 0.35128829E-11_JPRB, 0.33249193E-11_JPRB, 0.31355424E-11_JPRB, 0.28203065E-11_JPRB /)

RGHG9(:,23, 3) = (/ &
  & 0.21453631E-11_JPRB, 0.29996101E-11_JPRB, 0.35512025E-11_JPRB, 0.40658974E-11_JPRB, 0.46100957E-11_JPRB, 0.52088394E-11_JPRB, &
  & 0.58798405E-11_JPRB, 0.66254359E-11_JPRB, 0.74710906E-11_JPRB, 0.84157473E-11_JPRB, 0.94459987E-11_JPRB, 0.10540308E-10_JPRB, &
  & 0.11661113E-10_JPRB, 0.12775866E-10_JPRB, 0.13860722E-10_JPRB, 0.14900442E-10_JPRB, 0.15886310E-10_JPRB, 0.16812289E-10_JPRB, &
  & 0.17669763E-10_JPRB, 0.18452358E-10_JPRB, 0.19125611E-10_JPRB, 0.19660138E-10_JPRB, 0.20047604E-10_JPRB, 0.20274881E-10_JPRB, &
  & 0.20367281E-10_JPRB, 0.20411192E-10_JPRB, 0.20506177E-10_JPRB, 0.20756737E-10_JPRB, 0.21243809E-10_JPRB, 0.21981948E-10_JPRB, &
  & 0.22971677E-10_JPRB, 0.24111393E-10_JPRB, 0.25267934E-10_JPRB, 0.26338388E-10_JPRB, 0.27169371E-10_JPRB, 0.27672909E-10_JPRB, &
  & 0.27786787E-10_JPRB, 0.27474809E-10_JPRB, 0.26767307E-10_JPRB, 0.25710052E-10_JPRB, 0.24388725E-10_JPRB, 0.22883924E-10_JPRB, &
  & 0.21282144E-10_JPRB, 0.19644328E-10_JPRB, 0.18025284E-10_JPRB, 0.16475607E-10_JPRB, 0.15035037E-10_JPRB, 0.13729642E-10_JPRB, &
  & 0.12565709E-10_JPRB, 0.11540385E-10_JPRB, 0.10646129E-10_JPRB, 0.98641737E-11_JPRB, 0.91770610E-11_JPRB, 0.85662475E-11_JPRB, &
  & 0.80162396E-11_JPRB, 0.75147553E-11_JPRB, 0.70547674E-11_JPRB, 0.66347934E-11_JPRB, 0.62561536E-11_JPRB, 0.59211715E-11_JPRB, &
  & 0.56082070E-11_JPRB, 0.53184909E-11_JPRB, 0.49999874E-11_JPRB, 0.45317890E-11_JPRB /)

RGHG9(:,24, 3) = (/ &
  & 0.36997467E-11_JPRB, 0.49667510E-11_JPRB, 0.57646960E-11_JPRB, 0.64999056E-11_JPRB, 0.72623166E-11_JPRB, 0.80963413E-11_JPRB, &
  & 0.90238745E-11_JPRB, 0.10054079E-10_JPRB, 0.11175465E-10_JPRB, 0.12407429E-10_JPRB, 0.13739721E-10_JPRB, 0.15141919E-10_JPRB, &
  & 0.16575878E-10_JPRB, 0.18003241E-10_JPRB, 0.19388571E-10_JPRB, 0.20708643E-10_JPRB, 0.21954827E-10_JPRB, 0.23122089E-10_JPRB, &
  & 0.24204238E-10_JPRB, 0.25195474E-10_JPRB, 0.26066777E-10_JPRB, 0.26799066E-10_JPRB, 0.27364232E-10_JPRB, 0.27739873E-10_JPRB, &
  & 0.27969878E-10_JPRB, 0.28111987E-10_JPRB, 0.28283612E-10_JPRB, 0.28611958E-10_JPRB, 0.29176873E-10_JPRB, 0.30053071E-10_JPRB, &
  & 0.31193922E-10_JPRB, 0.32486451E-10_JPRB, 0.33778192E-10_JPRB, 0.34924372E-10_JPRB, 0.35738308E-10_JPRB, 0.36123455E-10_JPRB, &
  & 0.36027653E-10_JPRB, 0.35424826E-10_JPRB, 0.34384169E-10_JPRB, 0.32973384E-10_JPRB, 0.31309746E-10_JPRB, 0.29473056E-10_JPRB, &
  & 0.27554025E-10_JPRB, 0.25612524E-10_JPRB, 0.23692267E-10_JPRB, 0.21841645E-10_JPRB, 0.20101733E-10_JPRB, 0.18507237E-10_JPRB, &
  & 0.17077175E-10_JPRB, 0.15811501E-10_JPRB, 0.14699585E-10_JPRB, 0.13726848E-10_JPRB, 0.12868553E-10_JPRB, 0.12100256E-10_JPRB, &
  & 0.11401375E-10_JPRB, 0.10755924E-10_JPRB, 0.10154586E-10_JPRB, 0.95929081E-11_JPRB, 0.90739811E-11_JPRB, 0.85855368E-11_JPRB, &
  & 0.81350369E-11_JPRB, 0.77007740E-11_JPRB, 0.72580136E-11_JPRB, 0.65571654E-11_JPRB /)

RGHG9(:,25, 3) = (/ &
  & 0.57900941E-11_JPRB, 0.74758680E-11_JPRB, 0.85122092E-11_JPRB, 0.94501082E-11_JPRB, 0.10414655E-10_JPRB, 0.11461993E-10_JPRB, &
  & 0.12612147E-10_JPRB, 0.13873184E-10_JPRB, 0.15238921E-10_JPRB, 0.16711452E-10_JPRB, 0.18290600E-10_JPRB, 0.19955851E-10_JPRB, &
  & 0.21662835E-10_JPRB, 0.23359842E-10_JPRB, 0.25008735E-10_JPRB, 0.26583001E-10_JPRB, 0.28069836E-10_JPRB, 0.29463376E-10_JPRB, &
  & 0.30760429E-10_JPRB, 0.31956778E-10_JPRB, 0.33034589E-10_JPRB, 0.33970209E-10_JPRB, 0.34730011E-10_JPRB, 0.35294576E-10_JPRB, &
  & 0.35699919E-10_JPRB, 0.35981065E-10_JPRB, 0.36268627E-10_JPRB, 0.36668550E-10_JPRB, 0.37300042E-10_JPRB, 0.38212954E-10_JPRB, &
  & 0.39359384E-10_JPRB, 0.40642281E-10_JPRB, 0.41882740E-10_JPRB, 0.42919657E-10_JPRB, 0.43570050E-10_JPRB, 0.43733964E-10_JPRB, &
  & 0.43372746E-10_JPRB, 0.42491330E-10_JPRB, 0.41187286E-10_JPRB, 0.39542408E-10_JPRB, 0.37664712E-10_JPRB, 0.35643429E-10_JPRB, &
  & 0.33554149E-10_JPRB, 0.31441270E-10_JPRB, 0.29336512E-10_JPRB, 0.27278277E-10_JPRB, 0.25315380E-10_JPRB, 0.23498122E-10_JPRB, &
  & 0.21852452E-10_JPRB, 0.20387681E-10_JPRB, 0.19099361E-10_JPRB, 0.17964668E-10_JPRB, 0.16954488E-10_JPRB, 0.16038840E-10_JPRB, &
  & 0.15191810E-10_JPRB, 0.14394944E-10_JPRB, 0.13636920E-10_JPRB, 0.12916920E-10_JPRB, 0.12232826E-10_JPRB, 0.11583688E-10_JPRB, &
  & 0.10974836E-10_JPRB, 0.10397800E-10_JPRB, 0.97805930E-11_JPRB, 0.88504187E-11_JPRB /)

RGHG9(:,26, 3) = (/ &
  & 0.83831848E-11_JPRB, 0.10458210E-10_JPRB, 0.11691417E-10_JPRB, 0.12799730E-10_JPRB, 0.13925945E-10_JPRB, 0.15133988E-10_JPRB, &
  & 0.16464699E-10_JPRB, 0.17904582E-10_JPRB, 0.19456669E-10_JPRB, 0.21109264E-10_JPRB, 0.22870690E-10_JPRB, 0.24723999E-10_JPRB, &
  & 0.26640235E-10_JPRB, 0.28562748E-10_JPRB, 0.30438208E-10_JPRB, 0.32232536E-10_JPRB, 0.33931333E-10_JPRB, 0.35528028E-10_JPRB, &
  & 0.37020893E-10_JPRB, 0.38405296E-10_JPRB, 0.39668276E-10_JPRB, 0.40789132E-10_JPRB, 0.41738130E-10_JPRB, 0.42503449E-10_JPRB, &
  & 0.43097390E-10_JPRB, 0.43562431E-10_JPRB, 0.43983820E-10_JPRB, 0.44472283E-10_JPRB, 0.45143916E-10_JPRB, 0.46013065E-10_JPRB, &
  & 0.47078518E-10_JPRB, 0.48210162E-10_JPRB, 0.49258080E-10_JPRB, 0.50062902E-10_JPRB, 0.50460362E-10_JPRB, 0.50362901E-10_JPRB, &
  & 0.49750273E-10_JPRB, 0.48655299E-10_JPRB, 0.47171239E-10_JPRB, 0.45404007E-10_JPRB, 0.43451142E-10_JPRB, 0.41378182E-10_JPRB, &
  & 0.39239192E-10_JPRB, 0.37062332E-10_JPRB, 0.34863848E-10_JPRB, 0.32681101E-10_JPRB, 0.30573509E-10_JPRB, 0.28597260E-10_JPRB, &
  & 0.26794881E-10_JPRB, 0.25181123E-10_JPRB, 0.23747731E-10_JPRB, 0.22476668E-10_JPRB, 0.21333163E-10_JPRB, 0.20281428E-10_JPRB, &
  & 0.19292032E-10_JPRB, 0.18343627E-10_JPRB, 0.17423219E-10_JPRB, 0.16533074E-10_JPRB, 0.15665804E-10_JPRB, 0.14842143E-10_JPRB, &
  & 0.14068914E-10_JPRB, 0.13325680E-10_JPRB, 0.12546417E-10_JPRB, 0.11351509E-10_JPRB /)

RGHG9(:,27, 3) = (/ &
  & 0.11435306E-10_JPRB, 0.13782331E-10_JPRB, 0.15182449E-10_JPRB, 0.16412302E-10_JPRB, 0.17653677E-10_JPRB, 0.18979795E-10_JPRB, &
  & 0.20420691E-10_JPRB, 0.21989266E-10_JPRB, 0.23658566E-10_JPRB, 0.25437430E-10_JPRB, 0.27330018E-10_JPRB, 0.29315952E-10_JPRB, &
  & 0.31372890E-10_JPRB, 0.33450728E-10_JPRB, 0.35501657E-10_JPRB, 0.37484918E-10_JPRB, 0.39377297E-10_JPRB, 0.41160908E-10_JPRB, &
  & 0.42827009E-10_JPRB, 0.44368134E-10_JPRB, 0.45781261E-10_JPRB, 0.47051987E-10_JPRB, 0.48164181E-10_JPRB, 0.49107995E-10_JPRB, &
  & 0.49890855E-10_JPRB, 0.50546269E-10_JPRB, 0.51126478E-10_JPRB, 0.51719368E-10_JPRB, 0.52393388E-10_JPRB, 0.53190206E-10_JPRB, &
  & 0.54090402E-10_JPRB, 0.54995283E-10_JPRB, 0.55776973E-10_JPRB, 0.56297394E-10_JPRB, 0.56418720E-10_JPRB, 0.56070360E-10_JPRB, &
  & 0.55246769E-10_JPRB, 0.54003267E-10_JPRB, 0.52456196E-10_JPRB, 0.50694029E-10_JPRB, 0.48771008E-10_JPRB, 0.46745694E-10_JPRB, &
  & 0.44651043E-10_JPRB, 0.42491854E-10_JPRB, 0.40283998E-10_JPRB, 0.38051638E-10_JPRB, 0.35859989E-10_JPRB, 0.33780298E-10_JPRB, &
  & 0.31862950E-10_JPRB, 0.30129399E-10_JPRB, 0.28580804E-10_JPRB, 0.27191562E-10_JPRB, 0.25927352E-10_JPRB, 0.24746379E-10_JPRB, &
  & 0.23616565E-10_JPRB, 0.22513654E-10_JPRB, 0.21421339E-10_JPRB, 0.20348922E-10_JPRB, 0.19300058E-10_JPRB, 0.18299921E-10_JPRB, &
  & 0.17359112E-10_JPRB, 0.16457351E-10_JPRB, 0.15511150E-10_JPRB, 0.14048568E-10_JPRB /)

RGHG9(:,28, 3) = (/ &
  & 0.14799516E-10_JPRB, 0.17385159E-10_JPRB, 0.18862700E-10_JPRB, 0.20178335E-10_JPRB, 0.21499394E-10_JPRB, 0.22893874E-10_JPRB, &
  & 0.24404825E-10_JPRB, 0.26037908E-10_JPRB, 0.27783376E-10_JPRB, 0.29634906E-10_JPRB, 0.31605066E-10_JPRB, 0.33693850E-10_JPRB, &
  & 0.35872753E-10_JPRB, 0.38091343E-10_JPRB, 0.40288779E-10_JPRB, 0.42414985E-10_JPRB, 0.44443976E-10_JPRB, 0.46358702E-10_JPRB, &
  & 0.48148457E-10_JPRB, 0.49803713E-10_JPRB, 0.51323387E-10_JPRB, 0.52702516E-10_JPRB, 0.53936619E-10_JPRB, 0.55021012E-10_JPRB, &
  & 0.55961569E-10_JPRB, 0.56774977E-10_JPRB, 0.57496310E-10_JPRB, 0.58174781E-10_JPRB, 0.58848308E-10_JPRB, 0.59555028E-10_JPRB, &
  & 0.60272717E-10_JPRB, 0.60932384E-10_JPRB, 0.61434705E-10_JPRB, 0.61674839E-10_JPRB, 0.61544110E-10_JPRB, 0.60993377E-10_JPRB, &
  & 0.60040868E-10_JPRB, 0.58758290E-10_JPRB, 0.57228614E-10_JPRB, 0.55531517E-10_JPRB, 0.53722360E-10_JPRB, 0.51816839E-10_JPRB, &
  & 0.49827666E-10_JPRB, 0.47751515E-10_JPRB, 0.45582177E-10_JPRB, 0.43357630E-10_JPRB, 0.41135911E-10_JPRB, 0.38999016E-10_JPRB, &
  & 0.37004327E-10_JPRB, 0.35184678E-10_JPRB, 0.33538582E-10_JPRB, 0.32044128E-10_JPRB, 0.30666119E-10_JPRB, 0.29360334E-10_JPRB, &
  & 0.28094763E-10_JPRB, 0.26840717E-10_JPRB, 0.25586814E-10_JPRB, 0.24329289E-10_JPRB, 0.23096587E-10_JPRB, 0.21918608E-10_JPRB, &
  & 0.20809519E-10_JPRB, 0.19752212E-10_JPRB, 0.18637146E-10_JPRB, 0.16938317E-10_JPRB /)

RGHG9(:,29, 3) = (/ &
  & 0.18410905E-10_JPRB, 0.21084981E-10_JPRB, 0.22653508E-10_JPRB, 0.24005450E-10_JPRB, 0.25361097E-10_JPRB, 0.26802619E-10_JPRB, &
  & 0.28339175E-10_JPRB, 0.29995596E-10_JPRB, 0.31768768E-10_JPRB, 0.33654950E-10_JPRB, 0.35658986E-10_JPRB, 0.37791631E-10_JPRB, &
  & 0.40025858E-10_JPRB, 0.42329851E-10_JPRB, 0.44643803E-10_JPRB, 0.46900872E-10_JPRB, 0.49057446E-10_JPRB, 0.51087419E-10_JPRB, &
  & 0.52977251E-10_JPRB, 0.54718501E-10_JPRB, 0.56313280E-10_JPRB, 0.57763374E-10_JPRB, 0.59078527E-10_JPRB, 0.60259242E-10_JPRB, &
  & 0.61314204E-10_JPRB, 0.62242995E-10_JPRB, 0.63066177E-10_JPRB, 0.63797460E-10_JPRB, 0.64458237E-10_JPRB, 0.65069262E-10_JPRB, &
  & 0.65612404E-10_JPRB, 0.66041755E-10_JPRB, 0.66293970E-10_JPRB, 0.66291250E-10_JPRB, 0.65960230E-10_JPRB, 0.65273162E-10_JPRB, &
  & 0.64257863E-10_JPRB, 0.62981245E-10_JPRB, 0.61541369E-10_JPRB, 0.59994405E-10_JPRB, 0.58351386E-10_JPRB, 0.56612302E-10_JPRB, &
  & 0.54772516E-10_JPRB, 0.52808834E-10_JPRB, 0.50728866E-10_JPRB, 0.48549980E-10_JPRB, 0.46344283E-10_JPRB, 0.44188535E-10_JPRB, &
  & 0.42148288E-10_JPRB, 0.40264871E-10_JPRB, 0.38537003E-10_JPRB, 0.36948555E-10_JPRB, 0.35467781E-10_JPRB, 0.34047359E-10_JPRB, &
  & 0.32654334E-10_JPRB, 0.31259072E-10_JPRB, 0.29843780E-10_JPRB, 0.28416080E-10_JPRB, 0.27004472E-10_JPRB, 0.25649120E-10_JPRB, &
  & 0.24373109E-10_JPRB, 0.23162122E-10_JPRB, 0.21904787E-10_JPRB, 0.19958311E-10_JPRB /)

RGHG9(:,30, 3) = (/ &
  & 0.22092984E-10_JPRB, 0.24871025E-10_JPRB, 0.26433761E-10_JPRB, 0.27819934E-10_JPRB, 0.29193488E-10_JPRB, 0.30634429E-10_JPRB, &
  & 0.32183183E-10_JPRB, 0.33836510E-10_JPRB, 0.35597223E-10_JPRB, 0.37486802E-10_JPRB, 0.39510669E-10_JPRB, 0.41664810E-10_JPRB, &
  & 0.43930019E-10_JPRB, 0.46272000E-10_JPRB, 0.48652599E-10_JPRB, 0.51003618E-10_JPRB, 0.53258321E-10_JPRB, 0.55380724E-10_JPRB, &
  & 0.57348806E-10_JPRB, 0.59153599E-10_JPRB, 0.60797957E-10_JPRB, 0.62293323E-10_JPRB, 0.63653943E-10_JPRB, 0.64888650E-10_JPRB, &
  & 0.66007734E-10_JPRB, 0.66996866E-10_JPRB, 0.67876448E-10_JPRB, 0.68622150E-10_JPRB, 0.69252902E-10_JPRB, 0.69769607E-10_JPRB, &
  & 0.70158310E-10_JPRB, 0.70395904E-10_JPRB, 0.70444511E-10_JPRB, 0.70256245E-10_JPRB, 0.69786073E-10_JPRB, 0.69023967E-10_JPRB, &
  & 0.68014289E-10_JPRB, 0.66832942E-10_JPRB, 0.65534266E-10_JPRB, 0.64146119E-10_JPRB, 0.62677988E-10_JPRB, 0.61114877E-10_JPRB, &
  & 0.59437046E-10_JPRB, 0.57615544E-10_JPRB, 0.55637269E-10_JPRB, 0.53539232E-10_JPRB, 0.51379557E-10_JPRB, 0.49236209E-10_JPRB, &
  & 0.47185197E-10_JPRB, 0.45257097E-10_JPRB, 0.43467414E-10_JPRB, 0.41803571E-10_JPRB, 0.40229847E-10_JPRB, 0.38710236E-10_JPRB, &
  & 0.37208289E-10_JPRB, 0.35690860E-10_JPRB, 0.34137353E-10_JPRB, 0.32553973E-10_JPRB, 0.30971711E-10_JPRB, 0.29442341E-10_JPRB, &
  & 0.28005317E-10_JPRB, 0.26647389E-10_JPRB, 0.25238242E-10_JPRB, 0.23083814E-10_JPRB /)

RGHG9(:,31, 3) = (/ &
  & 0.25825319E-10_JPRB, 0.28594082E-10_JPRB, 0.30200547E-10_JPRB, 0.31572800E-10_JPRB, 0.32945112E-10_JPRB, 0.34385293E-10_JPRB, &
  & 0.35911742E-10_JPRB, 0.37547604E-10_JPRB, 0.39283281E-10_JPRB, 0.41140692E-10_JPRB, 0.43141477E-10_JPRB, 0.45298567E-10_JPRB, &
  & 0.47595254E-10_JPRB, 0.49967846E-10_JPRB, 0.52375555E-10_JPRB, 0.54775254E-10_JPRB, 0.57096737E-10_JPRB, 0.59284432E-10_JPRB, &
  & 0.61307404E-10_JPRB, 0.63155550E-10_JPRB, 0.64830030E-10_JPRB, 0.66346859E-10_JPRB, 0.67724923E-10_JPRB, 0.68973979E-10_JPRB, &
  & 0.70110598E-10_JPRB, 0.71107183E-10_JPRB, 0.71995770E-10_JPRB, 0.72718241E-10_JPRB, 0.73304661E-10_JPRB, 0.73732298E-10_JPRB, &
  & 0.73994172E-10_JPRB, 0.74086931E-10_JPRB, 0.73985346E-10_JPRB, 0.73675288E-10_JPRB, 0.73128927E-10_JPRB, 0.72361353E-10_JPRB, &
  & 0.71419010E-10_JPRB, 0.70344661E-10_JPRB, 0.69186233E-10_JPRB, 0.67969658E-10_JPRB, 0.66676401E-10_JPRB, 0.65281613E-10_JPRB, &
  & 0.63756805E-10_JPRB, 0.62068232E-10_JPRB, 0.60212307E-10_JPRB, 0.58209541E-10_JPRB, 0.56119335E-10_JPRB, 0.54024452E-10_JPRB, &
  & 0.51981572E-10_JPRB, 0.50042259E-10_JPRB, 0.48215251E-10_JPRB, 0.46492615E-10_JPRB, 0.44851886E-10_JPRB, 0.43256995E-10_JPRB, &
  & 0.41669761E-10_JPRB, 0.40059057E-10_JPRB, 0.38395016E-10_JPRB, 0.36682733E-10_JPRB, 0.34950508E-10_JPRB, 0.33264235E-10_JPRB, &
  & 0.31670666E-10_JPRB, 0.30180011E-10_JPRB, 0.28640821E-10_JPRB, 0.26272838E-10_JPRB /)

RGHG9(:,32, 3) = (/ &
  & 0.29502924E-10_JPRB, 0.32309544E-10_JPRB, 0.33873175E-10_JPRB, 0.35252717E-10_JPRB, 0.36607928E-10_JPRB, 0.38022616E-10_JPRB, &
  & 0.39528443E-10_JPRB, 0.41123382E-10_JPRB, 0.42819703E-10_JPRB, 0.44636808E-10_JPRB, 0.46597441E-10_JPRB, 0.48705914E-10_JPRB, &
  & 0.50976324E-10_JPRB, 0.53371377E-10_JPRB, 0.55811539E-10_JPRB, 0.58238553E-10_JPRB, 0.60597020E-10_JPRB, 0.62825675E-10_JPRB, &
  & 0.64884861E-10_JPRB, 0.66757759E-10_JPRB, 0.68445638E-10_JPRB, 0.69968691E-10_JPRB, 0.71335986E-10_JPRB, 0.72575841E-10_JPRB, &
  & 0.73681866E-10_JPRB, 0.74651750E-10_JPRB, 0.75503978E-10_JPRB, 0.76179806E-10_JPRB, 0.76706523E-10_JPRB, 0.77055182E-10_JPRB, &
  & 0.77221250E-10_JPRB, 0.77212334E-10_JPRB, 0.77016782E-10_JPRB, 0.76641200E-10_JPRB, 0.76072440E-10_JPRB, 0.75337583E-10_JPRB, &
  & 0.74471963E-10_JPRB, 0.73519330E-10_JPRB, 0.72517589E-10_JPRB, 0.71465868E-10_JPRB, 0.70336195E-10_JPRB, 0.69086507E-10_JPRB, &
  & 0.67684136E-10_JPRB, 0.66109923E-10_JPRB, 0.64361280E-10_JPRB, 0.62461043E-10_JPRB, 0.60462524E-10_JPRB, 0.58426736E-10_JPRB, &
  & 0.56432106E-10_JPRB, 0.54503787E-10_JPRB, 0.52664779E-10_JPRB, 0.50917007E-10_JPRB, 0.49233811E-10_JPRB, 0.47594206E-10_JPRB, &
  & 0.45958657E-10_JPRB, 0.44287480E-10_JPRB, 0.42553471E-10_JPRB, 0.40749952E-10_JPRB, 0.38904213E-10_JPRB, 0.37085484E-10_JPRB, &
  & 0.35372337E-10_JPRB, 0.33759454E-10_JPRB, 0.32098567E-10_JPRB, 0.29537334E-10_JPRB /)

RGHG9(:,33, 3) = (/ &
  & 0.33165151E-10_JPRB, 0.35915906E-10_JPRB, 0.37493984E-10_JPRB, 0.38832170E-10_JPRB, 0.40166842E-10_JPRB, 0.41556231E-10_JPRB, &
  & 0.43022950E-10_JPRB, 0.44571277E-10_JPRB, 0.46211493E-10_JPRB, 0.47965916E-10_JPRB, 0.49868994E-10_JPRB, 0.51938370E-10_JPRB, &
  & 0.54155676E-10_JPRB, 0.56510220E-10_JPRB, 0.58949179E-10_JPRB, 0.61393404E-10_JPRB, 0.63774631E-10_JPRB, 0.66025789E-10_JPRB, &
  & 0.68101851E-10_JPRB, 0.69984872E-10_JPRB, 0.71669483E-10_JPRB, 0.73182287E-10_JPRB, 0.74519488E-10_JPRB, 0.75726529E-10_JPRB, &
  & 0.76775829E-10_JPRB, 0.77690458E-10_JPRB, 0.78475844E-10_JPRB, 0.79088174E-10_JPRB, 0.79547334E-10_JPRB, 0.79827846E-10_JPRB, &
  & 0.79927495E-10_JPRB, 0.79856372E-10_JPRB, 0.79618208E-10_JPRB, 0.79225002E-10_JPRB, 0.78680090E-10_JPRB, 0.78010598E-10_JPRB, &
  & 0.77252843E-10_JPRB, 0.76441270E-10_JPRB, 0.75583553E-10_JPRB, 0.74663137E-10_JPRB, 0.73649718E-10_JPRB, 0.72508478E-10_JPRB, &
  & 0.71203314E-10_JPRB, 0.69713631E-10_JPRB, 0.68048310E-10_JPRB, 0.66236315E-10_JPRB, 0.64324213E-10_JPRB, 0.62379588E-10_JPRB, &
  & 0.60439473E-10_JPRB, 0.58554599E-10_JPRB, 0.56737282E-10_JPRB, 0.54988049E-10_JPRB, 0.53299521E-10_JPRB, 0.51646940E-10_JPRB, &
  & 0.49995161E-10_JPRB, 0.48306928E-10_JPRB, 0.46548765E-10_JPRB, 0.44703283E-10_JPRB, 0.42794060E-10_JPRB, 0.40898146E-10_JPRB, &
  & 0.39090814E-10_JPRB, 0.37392353E-10_JPRB, 0.35630800E-10_JPRB, 0.32884029E-10_JPRB /)

RGHG9(:,34, 3) = (/ &
  & 0.36744514E-10_JPRB, 0.39487053E-10_JPRB, 0.40998330E-10_JPRB, 0.42326389E-10_JPRB, 0.43625454E-10_JPRB, 0.44974247E-10_JPRB, &
  & 0.46400765E-10_JPRB, 0.47890913E-10_JPRB, 0.49463825E-10_JPRB, 0.51141865E-10_JPRB, 0.52958003E-10_JPRB, 0.54945833E-10_JPRB, &
  & 0.57113852E-10_JPRB, 0.59429087E-10_JPRB, 0.61837570E-10_JPRB, 0.64268285E-10_JPRB, 0.66646702E-10_JPRB, 0.68898998E-10_JPRB, &
  & 0.70974490E-10_JPRB, 0.72851794E-10_JPRB, 0.74518725E-10_JPRB, 0.76006597E-10_JPRB, 0.77299542E-10_JPRB, 0.78454097E-10_JPRB, &
  & 0.79431378E-10_JPRB, 0.80268750E-10_JPRB, 0.80969259E-10_JPRB, 0.81504241E-10_JPRB, 0.81892937E-10_JPRB, 0.82115419E-10_JPRB, &
  & 0.82172887E-10_JPRB, 0.82075846E-10_JPRB, 0.81835538E-10_JPRB, 0.81467749E-10_JPRB, 0.80981125E-10_JPRB, 0.80405745E-10_JPRB, &
  & 0.79769857E-10_JPRB, 0.79088534E-10_JPRB, 0.78354184E-10_JPRB, 0.77542278E-10_JPRB, 0.76614909E-10_JPRB, 0.75535883E-10_JPRB, &
  & 0.74279367E-10_JPRB, 0.72843759E-10_JPRB, 0.71240291E-10_JPRB, 0.69508163E-10_JPRB, 0.67691977E-10_JPRB, 0.65827795E-10_JPRB, &
  & 0.63971405E-10_JPRB, 0.62144817E-10_JPRB, 0.60369508E-10_JPRB, 0.58654984E-10_JPRB, 0.56987731E-10_JPRB, 0.55355106E-10_JPRB, &
  & 0.53723269E-10_JPRB, 0.52055960E-10_JPRB, 0.50318454E-10_JPRB, 0.48484966E-10_JPRB, 0.46574963E-10_JPRB, 0.44651102E-10_JPRB, &
  & 0.42808493E-10_JPRB, 0.41052557E-10_JPRB, 0.39211599E-10_JPRB, 0.36313317E-10_JPRB /)

RGHG9(:,35, 3) = (/ &
  & 0.40285192E-10_JPRB, 0.42929195E-10_JPRB, 0.44434720E-10_JPRB, 0.45707861E-10_JPRB, 0.46975351E-10_JPRB, 0.48286878E-10_JPRB, &
  & 0.49654492E-10_JPRB, 0.51079783E-10_JPRB, 0.52571829E-10_JPRB, 0.54158730E-10_JPRB, 0.55881105E-10_JPRB, 0.57770101E-10_JPRB, &
  & 0.59843769E-10_JPRB, 0.62090215E-10_JPRB, 0.64457481E-10_JPRB, 0.66864202E-10_JPRB, 0.69223613E-10_JPRB, 0.71460157E-10_JPRB, &
  & 0.73517387E-10_JPRB, 0.75373235E-10_JPRB, 0.77010127E-10_JPRB, 0.78457976E-10_JPRB, 0.79696506E-10_JPRB, 0.80775761E-10_JPRB, &
  & 0.81664613E-10_JPRB, 0.82403119E-10_JPRB, 0.82997748E-10_JPRB, 0.83441129E-10_JPRB, 0.83753407E-10_JPRB, 0.83924083E-10_JPRB, &
  & 0.83955745E-10_JPRB, 0.83859392E-10_JPRB, 0.83646805E-10_JPRB, 0.83331578E-10_JPRB, 0.82927207E-10_JPRB, 0.82456098E-10_JPRB, &
  & 0.81937589E-10_JPRB, 0.81373956E-10_JPRB, 0.80747235E-10_JPRB, 0.80026805E-10_JPRB, 0.79169941E-10_JPRB, 0.78139398E-10_JPRB, &
  & 0.76922677E-10_JPRB, 0.75517086E-10_JPRB, 0.73965938E-10_JPRB, 0.72302234E-10_JPRB, 0.70565685E-10_JPRB, 0.68796094E-10_JPRB, &
  & 0.67013749E-10_JPRB, 0.65259034E-10_JPRB, 0.63545662E-10_JPRB, 0.61880563E-10_JPRB, 0.60265036E-10_JPRB, 0.58679110E-10_JPRB, &
  & 0.57096387E-10_JPRB, 0.55485099E-10_JPRB, 0.53807667E-10_JPRB, 0.52033731E-10_JPRB, 0.50173064E-10_JPRB, 0.48285813E-10_JPRB, &
  & 0.46449341E-10_JPRB, 0.44678580E-10_JPRB, 0.42798293E-10_JPRB, 0.39779992E-10_JPRB /)

RGHG9(:,36, 3) = (/ &
  & 0.43717131E-10_JPRB, 0.46306639E-10_JPRB, 0.47735739E-10_JPRB, 0.48990804E-10_JPRB, 0.50218135E-10_JPRB, 0.51481184E-10_JPRB, &
  & 0.52791431E-10_JPRB, 0.54139304E-10_JPRB, 0.55539556E-10_JPRB, 0.57020357E-10_JPRB, 0.58627478E-10_JPRB, 0.60406374E-10_JPRB, &
  & 0.62382779E-10_JPRB, 0.64543759E-10_JPRB, 0.66842969E-10_JPRB, 0.69200541E-10_JPRB, 0.71519145E-10_JPRB, 0.73721446E-10_JPRB, &
  & 0.75744334E-10_JPRB, 0.77569597E-10_JPRB, 0.79167756E-10_JPRB, 0.80555243E-10_JPRB, 0.81717764E-10_JPRB, 0.82688342E-10_JPRB, &
  & 0.83457241E-10_JPRB, 0.84062417E-10_JPRB, 0.84531958E-10_JPRB, 0.84868605E-10_JPRB, 0.85100954E-10_JPRB, 0.85223120E-10_JPRB, &
  & 0.85239052E-10_JPRB, 0.85156257E-10_JPRB, 0.84982944E-10_JPRB, 0.84730702E-10_JPRB, 0.84408702E-10_JPRB, 0.84034855E-10_JPRB, &
  & 0.83618473E-10_JPRB, 0.83155510E-10_JPRB, 0.82625823E-10_JPRB, 0.81993162E-10_JPRB, 0.81211878E-10_JPRB, 0.80248391E-10_JPRB, &
  & 0.79079333E-10_JPRB, 0.77732751E-10_JPRB, 0.76234026E-10_JPRB, 0.74644818E-10_JPRB, 0.72992987E-10_JPRB, 0.71302110E-10_JPRB, &
  & 0.69604544E-10_JPRB, 0.67919101E-10_JPRB, 0.66270885E-10_JPRB, 0.64674689E-10_JPRB, 0.63123236E-10_JPRB, 0.61606220E-10_JPRB, &
  & 0.60098919E-10_JPRB, 0.58569219E-10_JPRB, 0.56979532E-10_JPRB, 0.55300441E-10_JPRB, 0.53533053E-10_JPRB, 0.51722834E-10_JPRB, &
  & 0.49942859E-10_JPRB, 0.48198650E-10_JPRB, 0.46313064E-10_JPRB, 0.43241202E-10_JPRB /)

RGHG9(:,37, 3) = (/ &
  & 0.47071107E-10_JPRB, 0.49541902E-10_JPRB, 0.50944998E-10_JPRB, 0.52152997E-10_JPRB, 0.53349852E-10_JPRB, 0.54571750E-10_JPRB, &
  & 0.55812799E-10_JPRB, 0.57077315E-10_JPRB, 0.58375596E-10_JPRB, 0.59741781E-10_JPRB, 0.61222874E-10_JPRB, 0.62869071E-10_JPRB, &
  & 0.64719313E-10_JPRB, 0.66776022E-10_JPRB, 0.68996732E-10_JPRB, 0.71290654E-10_JPRB, 0.73554184E-10_JPRB, 0.75707524E-10_JPRB, &
  & 0.77688043E-10_JPRB, 0.79463394E-10_JPRB, 0.81002746E-10_JPRB, 0.82298349E-10_JPRB, 0.83337698E-10_JPRB, 0.84156203E-10_JPRB, &
  & 0.84766028E-10_JPRB, 0.85224980E-10_JPRB, 0.85562717E-10_JPRB, 0.85802948E-10_JPRB, 0.85966026E-10_JPRB, 0.86050764E-10_JPRB, &
  & 0.86057883E-10_JPRB, 0.85990444E-10_JPRB, 0.85852644E-10_JPRB, 0.85652166E-10_JPRB, 0.85396835E-10_JPRB, 0.85098054E-10_JPRB, &
  & 0.84760941E-10_JPRB, 0.84380475E-10_JPRB, 0.83934651E-10_JPRB, 0.83389615E-10_JPRB, 0.82700853E-10_JPRB, 0.81825879E-10_JPRB, &
  & 0.80754896E-10_JPRB, 0.79486147E-10_JPRB, 0.78082561E-10_JPRB, 0.76578424E-10_JPRB, 0.75017201E-10_JPRB, 0.73415024E-10_JPRB, &
  & 0.71790830E-10_JPRB, 0.70174304E-10_JPRB, 0.68594380E-10_JPRB, 0.67065374E-10_JPRB, 0.65591692E-10_JPRB, 0.64158553E-10_JPRB, &
  & 0.62742700E-10_JPRB, 0.61313482E-10_JPRB, 0.59833416E-10_JPRB, 0.58270860E-10_JPRB, 0.56623244E-10_JPRB, 0.54926261E-10_JPRB, &
  & 0.53238754E-10_JPRB, 0.51559979E-10_JPRB, 0.49717650E-10_JPRB, 0.46654552E-10_JPRB /)

RGHG9(:,38, 3) = (/ &
  & 0.50313958E-10_JPRB, 0.52681193E-10_JPRB, 0.54021530E-10_JPRB, 0.55203661E-10_JPRB, 0.56372532E-10_JPRB, 0.57550128E-10_JPRB, &
  & 0.58725608E-10_JPRB, 0.59899571E-10_JPRB, 0.61088093E-10_JPRB, 0.62328510E-10_JPRB, 0.63673906E-10_JPRB, 0.65180451E-10_JPRB, &
  & 0.66893498E-10_JPRB, 0.68825806E-10_JPRB, 0.70940885E-10_JPRB, 0.73152734E-10_JPRB, 0.75344862E-10_JPRB, 0.77432033E-10_JPRB, &
  & 0.79347334E-10_JPRB, 0.81047558E-10_JPRB, 0.82484700E-10_JPRB, 0.83641462E-10_JPRB, 0.84515686E-10_JPRB, 0.85162197E-10_JPRB, &
  & 0.85618679E-10_JPRB, 0.85950289E-10_JPRB, 0.86191047E-10_JPRB, 0.86362251E-10_JPRB, 0.86480864E-10_JPRB, 0.86543245E-10_JPRB, &
  & 0.86547623E-10_JPRB, 0.86492744E-10_JPRB, 0.86380271E-10_JPRB, 0.86216034E-10_JPRB, 0.86006306E-10_JPRB, 0.85760163E-10_JPRB, &
  & 0.85480602E-10_JPRB, 0.85160913E-10_JPRB, 0.84782771E-10_JPRB, 0.84314812E-10_JPRB, 0.83715382E-10_JPRB, 0.82947926E-10_JPRB, &
  & 0.81984870E-10_JPRB, 0.80843644E-10_JPRB, 0.79547952E-10_JPRB, 0.78157689E-10_JPRB, 0.76695171E-10_JPRB, 0.75183346E-10_JPRB, &
  & 0.73635917E-10_JPRB, 0.72086455E-10_JPRB, 0.70566886E-10_JPRB, 0.69108448E-10_JPRB, 0.67713550E-10_JPRB, 0.66371811E-10_JPRB, &
  & 0.65059243E-10_JPRB, 0.63742310E-10_JPRB, 0.62385028E-10_JPRB, 0.60954401E-10_JPRB, 0.59444900E-10_JPRB, 0.57885950E-10_JPRB, &
  & 0.56321059E-10_JPRB, 0.54746555E-10_JPRB, 0.52986029E-10_JPRB, 0.50011172E-10_JPRB /)

RGHG9(:,39, 3) = (/ &
  & 0.53460559E-10_JPRB, 0.55700236E-10_JPRB, 0.56982967E-10_JPRB, 0.58133394E-10_JPRB, 0.59272254E-10_JPRB, 0.60410940E-10_JPRB, &
  & 0.61520129E-10_JPRB, 0.62600675E-10_JPRB, 0.63674725E-10_JPRB, 0.64785413E-10_JPRB, 0.65985536E-10_JPRB, 0.67337975E-10_JPRB, &
  & 0.68899331E-10_JPRB, 0.70695338E-10_JPRB, 0.72693053E-10_JPRB, 0.74803608E-10_JPRB, 0.76915377E-10_JPRB, 0.78921682E-10_JPRB, &
  & 0.80743863E-10_JPRB, 0.82319131E-10_JPRB, 0.83603187E-10_JPRB, 0.84587511E-10_JPRB, 0.85295646E-10_JPRB, 0.85795808E-10_JPRB, &
  & 0.86139033E-10_JPRB, 0.86387161E-10_JPRB, 0.86566559E-10_JPRB, 0.86698190E-10_JPRB, 0.86791782E-10_JPRB, 0.86842977E-10_JPRB, &
  & 0.86847800E-10_JPRB, 0.86802517E-10_JPRB, 0.86707079E-10_JPRB, 0.86566435E-10_JPRB, 0.86387328E-10_JPRB, 0.86176725E-10_JPRB, &
  & 0.85937646E-10_JPRB, 0.85662262E-10_JPRB, 0.85334934E-10_JPRB, 0.84927891E-10_JPRB, 0.84405490E-10_JPRB, 0.83729988E-10_JPRB, &
  & 0.82883124E-10_JPRB, 0.81859526E-10_JPRB, 0.80696332E-10_JPRB, 0.79424536E-10_JPRB, 0.78078086E-10_JPRB, 0.76664140E-10_JPRB, &
  & 0.75202698E-10_JPRB, 0.73715124E-10_JPRB, 0.72257436E-10_JPRB, 0.70861296E-10_JPRB, 0.69543232E-10_JPRB, 0.68294197E-10_JPRB, &
  & 0.67086822E-10_JPRB, 0.65889766E-10_JPRB, 0.64660721E-10_JPRB, 0.63372044E-10_JPRB, 0.62014047E-10_JPRB, 0.60610968E-10_JPRB, &
  & 0.59196842E-10_JPRB, 0.57753601E-10_JPRB, 0.56122485E-10_JPRB, 0.53304108E-10_JPRB /)

RGHG9(:,40, 3) = (/ &
  & 0.56507524E-10_JPRB, 0.58597342E-10_JPRB, 0.59818817E-10_JPRB, 0.60922226E-10_JPRB, 0.62039478E-10_JPRB, 0.63135504E-10_JPRB, &
  & 0.64179287E-10_JPRB, 0.65165179E-10_JPRB, 0.66125661E-10_JPRB, 0.67099999E-10_JPRB, 0.68154121E-10_JPRB, 0.69350116E-10_JPRB, &
  & 0.70752980E-10_JPRB, 0.72398976E-10_JPRB, 0.74267252E-10_JPRB, 0.76261983E-10_JPRB, 0.78264568E-10_JPRB, 0.80165499E-10_JPRB, &
  & 0.81870143E-10_JPRB, 0.83296807E-10_JPRB, 0.84407072E-10_JPRB, 0.85226173E-10_JPRB, 0.85797522E-10_JPRB, 0.86194288E-10_JPRB, &
  & 0.86464044E-10_JPRB, 0.86660901E-10_JPRB, 0.86804799E-10_JPRB, 0.86913719E-10_JPRB, 0.86993759E-10_JPRB, 0.87039605E-10_JPRB, &
  & 0.87045995E-10_JPRB, 0.87007693E-10_JPRB, 0.86923829E-10_JPRB, 0.86799110E-10_JPRB, 0.86640264E-10_JPRB, 0.86455072E-10_JPRB, &
  & 0.86244109E-10_JPRB, 0.86001976E-10_JPRB, 0.85712770E-10_JPRB, 0.85353558E-10_JPRB, 0.84891351E-10_JPRB, 0.84295348E-10_JPRB, &
  & 0.83542534E-10_JPRB, 0.82634961E-10_JPRB, 0.81591268E-10_JPRB, 0.80445345E-10_JPRB, 0.79217626E-10_JPRB, 0.77915362E-10_JPRB, &
  & 0.76539233E-10_JPRB, 0.75128098E-10_JPRB, 0.73723576E-10_JPRB, 0.72385715E-10_JPRB, 0.71139254E-10_JPRB, 0.69975983E-10_JPRB, &
  & 0.68873809E-10_JPRB, 0.67792237E-10_JPRB, 0.66695691E-10_JPRB, 0.65550315E-10_JPRB, 0.64352912E-10_JPRB, 0.63119308E-10_JPRB, &
  & 0.61871355E-10_JPRB, 0.60590720E-10_JPRB, 0.59114547E-10_JPRB, 0.56532296E-10_JPRB /)

RGHG9(:,41, 3) = (/ &
  & 0.59438579E-10_JPRB, 0.61376647E-10_JPRB, 0.62510781E-10_JPRB, 0.63574770E-10_JPRB, 0.64651298E-10_JPRB, 0.65708147E-10_JPRB, &
  & 0.66686323E-10_JPRB, 0.67581496E-10_JPRB, 0.68424752E-10_JPRB, 0.69270381E-10_JPRB, 0.70174720E-10_JPRB, 0.71212897E-10_JPRB, &
  & 0.72456631E-10_JPRB, 0.73952081E-10_JPRB, 0.75683140E-10_JPRB, 0.77562748E-10_JPRB, 0.79450863E-10_JPRB, 0.81225408E-10_JPRB, &
  & 0.82775758E-10_JPRB, 0.84037700E-10_JPRB, 0.84986754E-10_JPRB, 0.85665926E-10_JPRB, 0.86136147E-10_JPRB, 0.86460603E-10_JPRB, &
  & 0.86683438E-10_JPRB, 0.86848168E-10_JPRB, 0.86970278E-10_JPRB, 0.87065931E-10_JPRB, 0.87137964E-10_JPRB, 0.87181110E-10_JPRB, &
  & 0.87189055E-10_JPRB, 0.87155880E-10_JPRB, 0.87080176E-10_JPRB, 0.86966497E-10_JPRB, 0.86822591E-10_JPRB, 0.86654718E-10_JPRB, &
  & 0.86465633E-10_JPRB, 0.86247766E-10_JPRB, 0.85989264E-10_JPRB, 0.85667751E-10_JPRB, 0.85256330E-10_JPRB, 0.84725053E-10_JPRB, &
  & 0.84056553E-10_JPRB, 0.83245667E-10_JPRB, 0.82312865E-10_JPRB, 0.81284542E-10_JPRB, 0.80173250E-10_JPRB, 0.78980551E-10_JPRB, &
  & 0.77707313E-10_JPRB, 0.76366830E-10_JPRB, 0.75023605E-10_JPRB, 0.73741575E-10_JPRB, 0.72556454E-10_JPRB, 0.71476533E-10_JPRB, &
  & 0.70469408E-10_JPRB, 0.69501058E-10_JPRB, 0.68529057E-10_JPRB, 0.67528309E-10_JPRB, 0.66490688E-10_JPRB, 0.65431043E-10_JPRB, &
  & 0.64361003E-10_JPRB, 0.63251064E-10_JPRB, 0.61961568E-10_JPRB, 0.59660554E-10_JPRB /)

RGHG9(:,42, 3) = (/ &
  & 0.62244182E-10_JPRB, 0.64012309E-10_JPRB, 0.65069547E-10_JPRB, 0.66067186E-10_JPRB, 0.67107334E-10_JPRB, 0.68118892E-10_JPRB, &
  & 0.69029976E-10_JPRB, 0.69836664E-10_JPRB, 0.70572027E-10_JPRB, 0.71291154E-10_JPRB, 0.72058158E-10_JPRB, 0.72945580E-10_JPRB, &
  & 0.74030282E-10_JPRB, 0.75376407E-10_JPRB, 0.76969937E-10_JPRB, 0.78720704E-10_JPRB, 0.80492578E-10_JPRB, 0.82129394E-10_JPRB, &
  & 0.83525110E-10_JPRB, 0.84615884E-10_JPRB, 0.85418610E-10_JPRB, 0.85986267E-10_JPRB, 0.86379480E-10_JPRB, 0.86653448E-10_JPRB, &
  & 0.86844545E-10_JPRB, 0.86987854E-10_JPRB, 0.87096143E-10_JPRB, 0.87183163E-10_JPRB, 0.87250249E-10_JPRB, 0.87291674E-10_JPRB, &
  & 0.87300736E-10_JPRB, 0.87271260E-10_JPRB, 0.87201593E-10_JPRB, 0.87096413E-10_JPRB, 0.86962909E-10_JPRB, 0.86808997E-10_JPRB, &
  & 0.86635227E-10_JPRB, 0.86437468E-10_JPRB, 0.86202816E-10_JPRB, 0.85913818E-10_JPRB, 0.85545133E-10_JPRB, 0.85072713E-10_JPRB, &
  & 0.84477494E-10_JPRB, 0.83755905E-10_JPRB, 0.82921267E-10_JPRB, 0.81995924E-10_JPRB, 0.80995856E-10_JPRB, 0.79912334E-10_JPRB, &
  & 0.78735754E-10_JPRB, 0.77482437E-10_JPRB, 0.76203086E-10_JPRB, 0.74974145E-10_JPRB, 0.73856400E-10_JPRB, 0.72849692E-10_JPRB, &
  & 0.71934639E-10_JPRB, 0.71068866E-10_JPRB, 0.70216125E-10_JPRB, 0.69349512E-10_JPRB, 0.68466413E-10_JPRB, 0.67574432E-10_JPRB, &
  & 0.66677296E-10_JPRB, 0.65743369E-10_JPRB, 0.64642465E-10_JPRB, 0.62655450E-10_JPRB /)

RGHG9(:,43, 3) = (/ &
  & 0.64913123E-10_JPRB, 0.66510852E-10_JPRB, 0.67477524E-10_JPRB, 0.68410791E-10_JPRB, 0.69398751E-10_JPRB, 0.70357303E-10_JPRB, &
  & 0.71210073E-10_JPRB, 0.71930344E-10_JPRB, 0.72568479E-10_JPRB, 0.73175230E-10_JPRB, 0.73817064E-10_JPRB, 0.74563446E-10_JPRB, &
  & 0.75505956E-10_JPRB, 0.76701867E-10_JPRB, 0.78166904E-10_JPRB, 0.79792457E-10_JPRB, 0.81426851E-10_JPRB, 0.82918589E-10_JPRB, &
  & 0.84144434E-10_JPRB, 0.85078763E-10_JPRB, 0.85753862E-10_JPRB, 0.86230217E-10_JPRB, 0.86565567E-10_JPRB, 0.86801989E-10_JPRB, &
  & 0.86970889E-10_JPRB, 0.87099467E-10_JPRB, 0.87198408E-10_JPRB, 0.87279933E-10_JPRB, 0.87343376E-10_JPRB, 0.87383545E-10_JPRB, &
  & 0.87393121E-10_JPRB, 0.87366260E-10_JPRB, 0.87301298E-10_JPRB, 0.87202426E-10_JPRB, 0.87077498E-10_JPRB, 0.86933204E-10_JPRB, &
  & 0.86772305E-10_JPRB, 0.86589576E-10_JPRB, 0.86375511E-10_JPRB, 0.86113811E-10_JPRB, 0.85784282E-10_JPRB, 0.85364937E-10_JPRB, &
  & 0.84840197E-10_JPRB, 0.84201653E-10_JPRB, 0.83458448E-10_JPRB, 0.82630680E-10_JPRB, 0.81728208E-10_JPRB, 0.80746451E-10_JPRB, &
  & 0.79670485E-10_JPRB, 0.78503551E-10_JPRB, 0.77296974E-10_JPRB, 0.76138477E-10_JPRB, 0.75083675E-10_JPRB, 0.74155765E-10_JPRB, &
  & 0.73324347E-10_JPRB, 0.72553380E-10_JPRB, 0.71806686E-10_JPRB, 0.71062885E-10_JPRB, 0.70318737E-10_JPRB, 0.69579745E-10_JPRB, &
  & 0.68841738E-10_JPRB, 0.68069807E-10_JPRB, 0.67152311E-10_JPRB, 0.65476860E-10_JPRB /)

RGHG9(:,44, 3) = (/ &
  & 0.67406379E-10_JPRB, 0.68865018E-10_JPRB, 0.69731242E-10_JPRB, 0.70602857E-10_JPRB, 0.71525542E-10_JPRB, 0.72443239E-10_JPRB, &
  & 0.73224676E-10_JPRB, 0.73881373E-10_JPRB, 0.74428477E-10_JPRB, 0.74942087E-10_JPRB, 0.75473239E-10_JPRB, 0.76102152E-10_JPRB, &
  & 0.76900902E-10_JPRB, 0.77970436E-10_JPRB, 0.79298609E-10_JPRB, 0.80802323E-10_JPRB, 0.82298973E-10_JPRB, 0.83618557E-10_JPRB, &
  & 0.84675440E-10_JPRB, 0.85456101E-10_JPRB, 0.86021010E-10_JPRB, 0.86423410E-10_JPRB, 0.86713130E-10_JPRB, 0.86921192E-10_JPRB, &
  & 0.87074542E-10_JPRB, 0.87192434E-10_JPRB, 0.87285429E-10_JPRB, 0.87363117E-10_JPRB, 0.87424172E-10_JPRB, 0.87462919E-10_JPRB, &
  & 0.87472384E-10_JPRB, 0.87447237E-10_JPRB, 0.87385814E-10_JPRB, 0.87292215E-10_JPRB, 0.87173400E-10_JPRB, 0.87037100E-10_JPRB, &
  & 0.86885339E-10_JPRB, 0.86715378E-10_JPRB, 0.86517911E-10_JPRB, 0.86280642E-10_JPRB, 0.85986038E-10_JPRB, 0.85617576E-10_JPRB, &
  & 0.85160524E-10_JPRB, 0.84605330E-10_JPRB, 0.83952512E-10_JPRB, 0.83215330E-10_JPRB, 0.82406859E-10_JPRB, 0.81519708E-10_JPRB, &
  & 0.80538659E-10_JPRB, 0.79463033E-10_JPRB, 0.78343498E-10_JPRB, 0.77258831E-10_JPRB, 0.76287546E-10_JPRB, 0.75435186E-10_JPRB, &
  & 0.74684231E-10_JPRB, 0.73998446E-10_JPRB, 0.73344927E-10_JPRB, 0.72706959E-10_JPRB, 0.72082874E-10_JPRB, 0.71474701E-10_JPRB, &
  & 0.70873404E-10_JPRB, 0.70244970E-10_JPRB, 0.69491274E-10_JPRB, 0.68103738E-10_JPRB /)

RGHG9(:,45, 3) = (/ &
  & 0.69752627E-10_JPRB, 0.71035358E-10_JPRB, 0.71853481E-10_JPRB, 0.72635786E-10_JPRB, 0.73519107E-10_JPRB, 0.74371773E-10_JPRB, &
  & 0.75117586E-10_JPRB, 0.75697178E-10_JPRB, 0.76182019E-10_JPRB, 0.76610759E-10_JPRB, 0.77056792E-10_JPRB, 0.77575994E-10_JPRB, &
  & 0.78265720E-10_JPRB, 0.79194346E-10_JPRB, 0.80410817E-10_JPRB, 0.81775239E-10_JPRB, 0.83109554E-10_JPRB, 0.84248587E-10_JPRB, &
  & 0.85123443E-10_JPRB, 0.85768177E-10_JPRB, 0.86236455E-10_JPRB, 0.86578619E-10_JPRB, 0.86832215E-10_JPRB, 0.87019399E-10_JPRB, &
  & 0.87161153E-10_JPRB, 0.87271843E-10_JPRB, 0.87361306E-10_JPRB, 0.87436565E-10_JPRB, 0.87495608E-10_JPRB, 0.87532974E-10_JPRB, &
  & 0.87541627E-10_JPRB, 0.87517299E-10_JPRB, 0.87458693E-10_JPRB, 0.87368932E-10_JPRB, 0.87255154E-10_JPRB, 0.87124322E-10_JPRB, &
  & 0.86980256E-10_JPRB, 0.86819774E-10_JPRB, 0.86636941E-10_JPRB, 0.86420371E-10_JPRB, 0.86158150E-10_JPRB, 0.85836983E-10_JPRB, &
  & 0.85447267E-10_JPRB, 0.84977171E-10_JPRB, 0.84420651E-10_JPRB, 0.83780288E-10_JPRB, 0.83063459E-10_JPRB, 0.82268074E-10_JPRB, &
  & 0.81375309E-10_JPRB, 0.80391985E-10_JPRB, 0.79358638E-10_JPRB, 0.78375105E-10_JPRB, 0.77484880E-10_JPRB, 0.76717736E-10_JPRB, &
  & 0.76043789E-10_JPRB, 0.75432681E-10_JPRB, 0.74860042E-10_JPRB, 0.74310141E-10_JPRB, 0.73784714E-10_JPRB, 0.73283740E-10_JPRB, &
  & 0.72795006E-10_JPRB, 0.72284442E-10_JPRB, 0.71670780E-10_JPRB, 0.70532843E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART5',1,ZHOOK_HANDLE)
END SUBROUTINE PART5




SUBROUTINE PART6
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART6',0,ZHOOK_HANDLE)



RGHG9(:,46, 3) = (/ &
  & 0.71885296E-10_JPRB, 0.73088827E-10_JPRB, 0.73803672E-10_JPRB, 0.74559123E-10_JPRB, 0.75369655E-10_JPRB, 0.76194100E-10_JPRB, &
  & 0.76879204E-10_JPRB, 0.77416337E-10_JPRB, 0.77834614E-10_JPRB, 0.78204755E-10_JPRB, 0.78576853E-10_JPRB, 0.79015891E-10_JPRB, &
  & 0.79597474E-10_JPRB, 0.80419713E-10_JPRB, 0.81499432E-10_JPRB, 0.82720372E-10_JPRB, 0.83866566E-10_JPRB, 0.84797905E-10_JPRB, &
  & 0.85505242E-10_JPRB, 0.86022481E-10_JPRB, 0.86411225E-10_JPRB, 0.86704213E-10_JPRB, 0.86929630E-10_JPRB, 0.87100688E-10_JPRB, &
  & 0.87234782E-10_JPRB, 0.87340968E-10_JPRB, 0.87428301E-10_JPRB, 0.87502360E-10_JPRB, 0.87559918E-10_JPRB, 0.87595299E-10_JPRB, &
  & 0.87602647E-10_JPRB, 0.87578493E-10_JPRB, 0.87521636E-10_JPRB, 0.87435011E-10_JPRB, 0.87324648E-10_JPRB, 0.87198443E-10_JPRB, &
  & 0.87059498E-10_JPRB, 0.86907578E-10_JPRB, 0.86736063E-10_JPRB, 0.86538429E-10_JPRB, 0.86304526E-10_JPRB, 0.86028455E-10_JPRB, &
  & 0.85703319E-10_JPRB, 0.85321722E-10_JPRB, 0.84870250E-10_JPRB, 0.84340625E-10_JPRB, 0.83728018E-10_JPRB, 0.83022686E-10_JPRB, &
  & 0.82219460E-10_JPRB, 0.81314955E-10_JPRB, 0.80384872E-10_JPRB, 0.79485377E-10_JPRB, 0.78701774E-10_JPRB, 0.78013429E-10_JPRB, &
  & 0.77413700E-10_JPRB, 0.76872585E-10_JPRB, 0.76366399E-10_JPRB, 0.75890044E-10_JPRB, 0.75443179E-10_JPRB, 0.75026992E-10_JPRB, &
  & 0.74626319E-10_JPRB, 0.74211644E-10_JPRB, 0.73710003E-10_JPRB, 0.72781621E-10_JPRB /)

RGHG9(:,47, 3) = (/ &
  & 0.73870937E-10_JPRB, 0.74960767E-10_JPRB, 0.75654427E-10_JPRB, 0.76340392E-10_JPRB, 0.77124231E-10_JPRB, 0.77899569E-10_JPRB, &
  & 0.78549313E-10_JPRB, 0.79034730E-10_JPRB, 0.79407363E-10_JPRB, 0.79726017E-10_JPRB, 0.80043333E-10_JPRB, 0.80416666E-10_JPRB, &
  & 0.80915864E-10_JPRB, 0.81632756E-10_JPRB, 0.82576022E-10_JPRB, 0.83616676E-10_JPRB, 0.84541624E-10_JPRB, 0.85272796E-10_JPRB, &
  & 0.85817152E-10_JPRB, 0.86231307E-10_JPRB, 0.86552016E-10_JPRB, 0.86806125E-10_JPRB, 0.87009129E-10_JPRB, 0.87169369E-10_JPRB, &
  & 0.87298106E-10_JPRB, 0.87401579E-10_JPRB, 0.87488905E-10_JPRB, 0.87561874E-10_JPRB, 0.87617878E-10_JPRB, 0.87651192E-10_JPRB, &
  & 0.87656611E-10_JPRB, 0.87631839E-10_JPRB, 0.87576210E-10_JPRB, 0.87491570E-10_JPRB, 0.87384044E-10_JPRB, 0.87260796E-10_JPRB, &
  & 0.87126736E-10_JPRB, 0.86980735E-10_JPRB, 0.86819871E-10_JPRB, 0.86637607E-10_JPRB, 0.86429967E-10_JPRB, 0.86193844E-10_JPRB, &
  & 0.85930825E-10_JPRB, 0.85635561E-10_JPRB, 0.85298206E-10_JPRB, 0.84896035E-10_JPRB, 0.84408293E-10_JPRB, 0.83813956E-10_JPRB, &
  & 0.83092228E-10_JPRB, 0.82279322E-10_JPRB, 0.81419496E-10_JPRB, 0.80637316E-10_JPRB, 0.79931617E-10_JPRB, 0.79332665E-10_JPRB, &
  & 0.78801278E-10_JPRB, 0.78319878E-10_JPRB, 0.77873513E-10_JPRB, 0.77454765E-10_JPRB, 0.77070815E-10_JPRB, 0.76719707E-10_JPRB, &
  & 0.76387889E-10_JPRB, 0.76045281E-10_JPRB, 0.75633819E-10_JPRB, 0.74868778E-10_JPRB /)

RGHG9(:,48, 3) = (/ &
  & 0.75691654E-10_JPRB, 0.76720255E-10_JPRB, 0.77370672E-10_JPRB, 0.78033614E-10_JPRB, 0.78781134E-10_JPRB, 0.79523804E-10_JPRB, &
  & 0.80135315E-10_JPRB, 0.80578655E-10_JPRB, 0.80910681E-10_JPRB, 0.81188056E-10_JPRB, 0.81462795E-10_JPRB, 0.81782595E-10_JPRB, &
  & 0.82213542E-10_JPRB, 0.82813957E-10_JPRB, 0.83609730E-10_JPRB, 0.84419964E-10_JPRB, 0.85121854E-10_JPRB, 0.85658786E-10_JPRB, &
  & 0.86072934E-10_JPRB, 0.86398194E-10_JPRB, 0.86665695E-10_JPRB, 0.86888691E-10_JPRB, 0.87075028E-10_JPRB, 0.87227760E-10_JPRB, &
  & 0.87353506E-10_JPRB, 0.87456729E-10_JPRB, 0.87543611E-10_JPRB, 0.87616407E-10_JPRB, 0.87670649E-10_JPRB, 0.87701138E-10_JPRB, &
  & 0.87704358E-10_JPRB, 0.87678621E-10_JPRB, 0.87623381E-10_JPRB, 0.87540197E-10_JPRB, 0.87434643E-10_JPRB, 0.87314184E-10_JPRB, &
  & 0.87183455E-10_JPRB, 0.87043303E-10_JPRB, 0.86890467E-10_JPRB, 0.86722379E-10_JPRB, 0.86536660E-10_JPRB, 0.86337049E-10_JPRB, &
  & 0.86128424E-10_JPRB, 0.85914192E-10_JPRB, 0.85684189E-10_JPRB, 0.85418249E-10_JPRB, 0.85074163E-10_JPRB, 0.84612428E-10_JPRB, &
  & 0.84010743E-10_JPRB, 0.83274207E-10_JPRB, 0.82528664E-10_JPRB, 0.81818524E-10_JPRB, 0.81217255E-10_JPRB, 0.80686194E-10_JPRB, &
  & 0.80218276E-10_JPRB, 0.79790334E-10_JPRB, 0.79389960E-10_JPRB, 0.79018708E-10_JPRB, 0.78681700E-10_JPRB, 0.78379914E-10_JPRB, &
  & 0.78098077E-10_JPRB, 0.77810723E-10_JPRB, 0.77464229E-10_JPRB, 0.76825317E-10_JPRB /)

RGHG9(:,49, 3) = (/ &
  & 0.77367064E-10_JPRB, 0.78367438E-10_JPRB, 0.78989836E-10_JPRB, 0.79641370E-10_JPRB, 0.80364486E-10_JPRB, 0.81085486E-10_JPRB, &
  & 0.81657459E-10_JPRB, 0.82062197E-10_JPRB, 0.82355900E-10_JPRB, 0.82597415E-10_JPRB, 0.82833990E-10_JPRB, 0.83100679E-10_JPRB, &
  & 0.83453244E-10_JPRB, 0.83935268E-10_JPRB, 0.84509767E-10_JPRB, 0.85099428E-10_JPRB, 0.85582881E-10_JPRB, 0.85968094E-10_JPRB, &
  & 0.86274744E-10_JPRB, 0.86532795E-10_JPRB, 0.86757143E-10_JPRB, 0.86956262E-10_JPRB, 0.87130206E-10_JPRB, 0.87278955E-10_JPRB, &
  & 0.87403716E-10_JPRB, 0.87507002E-10_JPRB, 0.87594869E-10_JPRB, 0.87666360E-10_JPRB, 0.87718346E-10_JPRB, 0.87745970E-10_JPRB, &
  & 0.87746706E-10_JPRB, 0.87719706E-10_JPRB, 0.87664383E-10_JPRB, 0.87582240E-10_JPRB, 0.87478240E-10_JPRB, 0.87360112E-10_JPRB, &
  & 0.87232679E-10_JPRB, 0.87096948E-10_JPRB, 0.86951495E-10_JPRB, 0.86794724E-10_JPRB, 0.86628454E-10_JPRB, 0.86459478E-10_JPRB, &
  & 0.86298468E-10_JPRB, 0.86150968E-10_JPRB, 0.86013786E-10_JPRB, 0.85859965E-10_JPRB, 0.85655226E-10_JPRB, 0.85345030E-10_JPRB, &
  & 0.84884523E-10_JPRB, 0.84304175E-10_JPRB, 0.83658254E-10_JPRB, 0.83078981E-10_JPRB, 0.82558876E-10_JPRB, 0.82101069E-10_JPRB, &
  & 0.81686741E-10_JPRB, 0.81302111E-10_JPRB, 0.80938464E-10_JPRB, 0.80600457E-10_JPRB, 0.80297241E-10_JPRB, 0.80028942E-10_JPRB, &
  & 0.79782521E-10_JPRB, 0.79531964E-10_JPRB, 0.79231691E-10_JPRB, 0.78680437E-10_JPRB /)

RGHG9(:,50, 3) = (/ &
  & 0.78924881E-10_JPRB, 0.79901308E-10_JPRB, 0.80519182E-10_JPRB, 0.81162591E-10_JPRB, 0.81884728E-10_JPRB, 0.82583537E-10_JPRB, &
  & 0.83112697E-10_JPRB, 0.83472715E-10_JPRB, 0.83720919E-10_JPRB, 0.83920648E-10_JPRB, 0.84101254E-10_JPRB, 0.84308366E-10_JPRB, &
  & 0.84550811E-10_JPRB, 0.84867710E-10_JPRB, 0.85245713E-10_JPRB, 0.85613849E-10_JPRB, 0.85937854E-10_JPRB, 0.86205626E-10_JPRB, &
  & 0.86434887E-10_JPRB, 0.86640951E-10_JPRB, 0.86832055E-10_JPRB, 0.87012154E-10_JPRB, 0.87178119E-10_JPRB, 0.87325099E-10_JPRB, &
  & 0.87450269E-10_JPRB, 0.87555012E-10_JPRB, 0.87642477E-10_JPRB, 0.87712483E-10_JPRB, 0.87761624E-10_JPRB, 0.87786098E-10_JPRB, &
  & 0.87784384E-10_JPRB, 0.87756039E-10_JPRB, 0.87700361E-10_JPRB, 0.87618787E-10_JPRB, 0.87516425E-10_JPRB, 0.87400420E-10_JPRB, &
  & 0.87275902E-10_JPRB, 0.87144209E-10_JPRB, 0.87004598E-10_JPRB, 0.86857604E-10_JPRB, 0.86707551E-10_JPRB, 0.86564832E-10_JPRB, &
  & 0.86443033E-10_JPRB, 0.86349830E-10_JPRB, 0.86277228E-10_JPRB, 0.86206653E-10_JPRB, 0.86098739E-10_JPRB, 0.85916822E-10_JPRB, &
  & 0.85622606E-10_JPRB, 0.85207001E-10_JPRB, 0.84764376E-10_JPRB, 0.84325484E-10_JPRB, 0.83922161E-10_JPRB, 0.83553116E-10_JPRB, &
  & 0.83197976E-10_JPRB, 0.82855653E-10_JPRB, 0.82526312E-10_JPRB, 0.82212140E-10_JPRB, 0.81931226E-10_JPRB, 0.81684964E-10_JPRB, &
  & 0.81459686E-10_JPRB, 0.81232084E-10_JPRB, 0.80961363E-10_JPRB, 0.80463955E-10_JPRB /)

RGHG9(:,51, 3) = (/ &
  & 0.80385282E-10_JPRB, 0.81318070E-10_JPRB, 0.81955324E-10_JPRB, 0.82586236E-10_JPRB, 0.83310740E-10_JPRB, 0.83962816E-10_JPRB, &
  & 0.84429380E-10_JPRB, 0.84712209E-10_JPRB, 0.84897145E-10_JPRB, 0.85029067E-10_JPRB, 0.85147861E-10_JPRB, 0.85259244E-10_JPRB, &
  & 0.85400416E-10_JPRB, 0.85566249E-10_JPRB, 0.85772167E-10_JPRB, 0.85993900E-10_JPRB, 0.86200783E-10_JPRB, 0.86389083E-10_JPRB, &
  & 0.86562993E-10_JPRB, 0.86729526E-10_JPRB, 0.86895394E-10_JPRB, 0.87061046E-10_JPRB, 0.87221154E-10_JPRB, 0.87368279E-10_JPRB, &
  & 0.87494970E-10_JPRB, 0.87600614E-10_JPRB, 0.87687593E-10_JPRB, 0.87755032E-10_JPRB, 0.87800836E-10_JPRB, 0.87822291E-10_JPRB, &
  & 0.87818169E-10_JPRB, 0.87788332E-10_JPRB, 0.87732099E-10_JPRB, 0.87651005E-10_JPRB, 0.87550064E-10_JPRB, 0.87436246E-10_JPRB, &
  & 0.87314489E-10_JPRB, 0.87186300E-10_JPRB, 0.87051838E-10_JPRB, 0.86913032E-10_JPRB, 0.86776773E-10_JPRB, 0.86657098E-10_JPRB, &
  & 0.86568148E-10_JPRB, 0.86514601E-10_JPRB, 0.86487761E-10_JPRB, 0.86464266E-10_JPRB, 0.86419566E-10_JPRB, 0.86321422E-10_JPRB, &
  & 0.86148415E-10_JPRB, 0.85916142E-10_JPRB, 0.85647864E-10_JPRB, 0.85388030E-10_JPRB, 0.85139826E-10_JPRB, 0.84880797E-10_JPRB, &
  & 0.84622642E-10_JPRB, 0.84353302E-10_JPRB, 0.84070445E-10_JPRB, 0.83795873E-10_JPRB, 0.83540133E-10_JPRB, 0.83313759E-10_JPRB, &
  & 0.83106348E-10_JPRB, 0.82896391E-10_JPRB, 0.82643108E-10_JPRB, 0.82186223E-10_JPRB /)

RGHG9(:,52, 3) = (/ &
  & 0.81680329E-10_JPRB, 0.82663945E-10_JPRB, 0.83230388E-10_JPRB, 0.83886384E-10_JPRB, 0.84539348E-10_JPRB, 0.85102481E-10_JPRB, &
  & 0.85436241E-10_JPRB, 0.85623092E-10_JPRB, 0.85728681E-10_JPRB, 0.85800790E-10_JPRB, 0.85853491E-10_JPRB, 0.85908294E-10_JPRB, &
  & 0.85962237E-10_JPRB, 0.86040008E-10_JPRB, 0.86140352E-10_JPRB, 0.86264787E-10_JPRB, 0.86398555E-10_JPRB, 0.86532545E-10_JPRB, &
  & 0.86666736E-10_JPRB, 0.86805736E-10_JPRB, 0.86951522E-10_JPRB, 0.87105885E-10_JPRB, 0.87262600E-10_JPRB, 0.87409836E-10_JPRB, &
  & 0.87538060E-10_JPRB, 0.87644274E-10_JPRB, 0.87729754E-10_JPRB, 0.87794230E-10_JPRB, 0.87836606E-10_JPRB, 0.87855091E-10_JPRB, &
  & 0.87848701E-10_JPRB, 0.87817240E-10_JPRB, 0.87760382E-10_JPRB, 0.87679593E-10_JPRB, 0.87579999E-10_JPRB, 0.87468380E-10_JPRB, &
  & 0.87349197E-10_JPRB, 0.87224450E-10_JPRB, 0.87094491E-10_JPRB, 0.86963131E-10_JPRB, 0.86839737E-10_JPRB, 0.86739754E-10_JPRB, &
  & 0.86677727E-10_JPRB, 0.86654253E-10_JPRB, 0.86655044E-10_JPRB, 0.86660110E-10_JPRB, 0.86648064E-10_JPRB, 0.86601559E-10_JPRB, &
  & 0.86511645E-10_JPRB, 0.86385184E-10_JPRB, 0.86254559E-10_JPRB, 0.86127112E-10_JPRB, 0.85994059E-10_JPRB, 0.85861693E-10_JPRB, &
  & 0.85707642E-10_JPRB, 0.85534413E-10_JPRB, 0.85344086E-10_JPRB, 0.85136037E-10_JPRB, 0.84937488E-10_JPRB, 0.84755210E-10_JPRB, &
  & 0.84582508E-10_JPRB, 0.84403116E-10_JPRB, 0.84184083E-10_JPRB, 0.83768770E-10_JPRB /)

RGHG9(:,53, 3) = (/ &
  & 0.82916236E-10_JPRB, 0.83772364E-10_JPRB, 0.84398863E-10_JPRB, 0.84930236E-10_JPRB, 0.85491419E-10_JPRB, 0.85874412E-10_JPRB, &
  & 0.86079498E-10_JPRB, 0.86178148E-10_JPRB, 0.86231078E-10_JPRB, 0.86262414E-10_JPRB, 0.86285992E-10_JPRB, 0.86303520E-10_JPRB, &
  & 0.86325148E-10_JPRB, 0.86351218E-10_JPRB, 0.86397313E-10_JPRB, 0.86464988E-10_JPRB, 0.86550586E-10_JPRB, 0.86647800E-10_JPRB, &
  & 0.86754964E-10_JPRB, 0.86872377E-10_JPRB, 0.87004737E-10_JPRB, 0.87150440E-10_JPRB, 0.87303595E-10_JPRB, 0.87450887E-10_JPRB, &
  & 0.87579471E-10_JPRB, 0.87685338E-10_JPRB, 0.87768931E-10_JPRB, 0.87830396E-10_JPRB, 0.87869372E-10_JPRB, 0.87885040E-10_JPRB, &
  & 0.87876484E-10_JPRB, 0.87843344E-10_JPRB, 0.87785737E-10_JPRB, 0.87705107E-10_JPRB, 0.87606908E-10_JPRB, 0.87497211E-10_JPRB, &
  & 0.87380853E-10_JPRB, 0.87259221E-10_JPRB, 0.87134154E-10_JPRB, 0.87010066E-10_JPRB, 0.86898433E-10_JPRB, 0.86816332E-10_JPRB, &
  & 0.86776010E-10_JPRB, 0.86773463E-10_JPRB, 0.86791477E-10_JPRB, 0.86812869E-10_JPRB, 0.86819510E-10_JPRB, 0.86801608E-10_JPRB, &
  & 0.86755721E-10_JPRB, 0.86694762E-10_JPRB, 0.86630966E-10_JPRB, 0.86569148E-10_JPRB, 0.86510896E-10_JPRB, 0.86441937E-10_JPRB, &
  & 0.86366803E-10_JPRB, 0.86275417E-10_JPRB, 0.86164034E-10_JPRB, 0.86043048E-10_JPRB, 0.85918633E-10_JPRB, 0.85800672E-10_JPRB, &
  & 0.85687103E-10_JPRB, 0.85562904E-10_JPRB, 0.85400791E-10_JPRB, 0.85081116E-10_JPRB /)

RGHG9(:,54, 3) = (/ &
  & 0.83928295E-10_JPRB, 0.84821955E-10_JPRB, 0.85276806E-10_JPRB, 0.85742601E-10_JPRB, 0.86111604E-10_JPRB, 0.86348415E-10_JPRB, &
  & 0.86456627E-10_JPRB, 0.86506149E-10_JPRB, 0.86530207E-10_JPRB, 0.86544084E-10_JPRB, 0.86551974E-10_JPRB, 0.86557927E-10_JPRB, &
  & 0.86562001E-10_JPRB, 0.86569044E-10_JPRB, 0.86584559E-10_JPRB, 0.86618705E-10_JPRB, 0.86672919E-10_JPRB, 0.86744341E-10_JPRB, &
  & 0.86831341E-10_JPRB, 0.86935015E-10_JPRB, 0.87056147E-10_JPRB, 0.87196021E-10_JPRB, 0.87345783E-10_JPRB, 0.87491125E-10_JPRB, &
  & 0.87618884E-10_JPRB, 0.87723571E-10_JPRB, 0.87805201E-10_JPRB, 0.87863800E-10_JPRB, 0.87899743E-10_JPRB, 0.87912608E-10_JPRB, &
  & 0.87901908E-10_JPRB, 0.87867193E-10_JPRB, 0.87808615E-10_JPRB, 0.87728345E-10_JPRB, 0.87631187E-10_JPRB, 0.87523627E-10_JPRB, &
  & 0.87409718E-10_JPRB, 0.87291889E-10_JPRB, 0.87171638E-10_JPRB, 0.87055592E-10_JPRB, 0.86955450E-10_JPRB, 0.86888566E-10_JPRB, &
  & 0.86864779E-10_JPRB, 0.86876742E-10_JPRB, 0.86906926E-10_JPRB, 0.86936465E-10_JPRB, 0.86953916E-10_JPRB, 0.86952126E-10_JPRB, &
  & 0.86931032E-10_JPRB, 0.86899821E-10_JPRB, 0.86868901E-10_JPRB, 0.86840375E-10_JPRB, 0.86809490E-10_JPRB, 0.86778487E-10_JPRB, &
  & 0.86739060E-10_JPRB, 0.86691841E-10_JPRB, 0.86635185E-10_JPRB, 0.86568260E-10_JPRB, 0.86501160E-10_JPRB, 0.86438322E-10_JPRB, &
  & 0.86375643E-10_JPRB, 0.86307843E-10_JPRB, 0.86217214E-10_JPRB, 0.86028296E-10_JPRB /)

RGHG9(:,55, 3) = (/ &
  & 0.84871700E-10_JPRB, 0.85571501E-10_JPRB, 0.85978655E-10_JPRB, 0.86270643E-10_JPRB, 0.86501861E-10_JPRB, 0.86633707E-10_JPRB, &
  & 0.86690322E-10_JPRB, 0.86714157E-10_JPRB, 0.86725099E-10_JPRB, 0.86730338E-10_JPRB, 0.86732919E-10_JPRB, 0.86733273E-10_JPRB, &
  & 0.86731844E-10_JPRB, 0.86729832E-10_JPRB, 0.86731164E-10_JPRB, 0.86744126E-10_JPRB, 0.86776163E-10_JPRB, 0.86828669E-10_JPRB, &
  & 0.86901139E-10_JPRB, 0.86993711E-10_JPRB, 0.87108362E-10_JPRB, 0.87242685E-10_JPRB, 0.87388499E-10_JPRB, 0.87530518E-10_JPRB, &
  & 0.87656139E-10_JPRB, 0.87759300E-10_JPRB, 0.87838951E-10_JPRB, 0.87895149E-10_JPRB, 0.87928102E-10_JPRB, 0.87938254E-10_JPRB, &
  & 0.87925361E-10_JPRB, 0.87889161E-10_JPRB, 0.87829702E-10_JPRB, 0.87749606E-10_JPRB, 0.87653766E-10_JPRB, 0.87548087E-10_JPRB, &
  & 0.87437044E-10_JPRB, 0.87322871E-10_JPRB, 0.87208601E-10_JPRB, 0.87100570E-10_JPRB, 0.87011773E-10_JPRB, 0.86957379E-10_JPRB, &
  & 0.86945944E-10_JPRB, 0.86968655E-10_JPRB, 0.87005222E-10_JPRB, 0.87042117E-10_JPRB, 0.87064800E-10_JPRB, 0.87071808E-10_JPRB, &
  & 0.87062677E-10_JPRB, 0.87047661E-10_JPRB, 0.87031563E-10_JPRB, 0.87016019E-10_JPRB, 0.87001344E-10_JPRB, 0.86983434E-10_JPRB, &
  & 0.86963825E-10_JPRB, 0.86938901E-10_JPRB, 0.86907731E-10_JPRB, 0.86872703E-10_JPRB, 0.86836781E-10_JPRB, 0.86802857E-10_JPRB, &
  & 0.86771104E-10_JPRB, 0.86734737E-10_JPRB, 0.86684153E-10_JPRB, 0.86558816E-10_JPRB /)

RGHG9(:,56, 3) = (/ &
  & 0.85605210E-10_JPRB, 0.86176441E-10_JPRB, 0.86430023E-10_JPRB, 0.86612877E-10_JPRB, 0.86747914E-10_JPRB, 0.86819461E-10_JPRB, &
  & 0.86849569E-10_JPRB, 0.86861102E-10_JPRB, 0.86865876E-10_JPRB, 0.86867756E-10_JPRB, 0.86867943E-10_JPRB, 0.86866493E-10_JPRB, &
  & 0.86863655E-10_JPRB, 0.86857910E-10_JPRB, 0.86852456E-10_JPRB, 0.86852650E-10_JPRB, 0.86868457E-10_JPRB, 0.86905927E-10_JPRB, &
  & 0.86966850E-10_JPRB, 0.87051574E-10_JPRB, 0.87160237E-10_JPRB, 0.87290231E-10_JPRB, 0.87430840E-10_JPRB, 0.87569063E-10_JPRB, &
  & 0.87691632E-10_JPRB, 0.87793127E-10_JPRB, 0.87870947E-10_JPRB, 0.87924605E-10_JPRB, 0.87954997E-10_JPRB, 0.87962408E-10_JPRB, &
  & 0.87947295E-10_JPRB, 0.87909707E-10_JPRB, 0.87849582E-10_JPRB, 0.87769653E-10_JPRB, 0.87675298E-10_JPRB, 0.87571610E-10_JPRB, &
  & 0.87463460E-10_JPRB, 0.87353673E-10_JPRB, 0.87245336E-10_JPRB, 0.87146165E-10_JPRB, 0.87067478E-10_JPRB, 0.87023708E-10_JPRB, &
  & 0.87021099E-10_JPRB, 0.87050478E-10_JPRB, 0.87093791E-10_JPRB, 0.87133287E-10_JPRB, 0.87160654E-10_JPRB, 0.87171867E-10_JPRB, &
  & 0.87169133E-10_JPRB, 0.87161126E-10_JPRB, 0.87152063E-10_JPRB, 0.87143626E-10_JPRB, 0.87134272E-10_JPRB, 0.87124939E-10_JPRB, &
  & 0.87113122E-10_JPRB, 0.87099043E-10_JPRB, 0.87081856E-10_JPRB, 0.87061455E-10_JPRB, 0.87041332E-10_JPRB, 0.87023833E-10_JPRB, &
  & 0.87007596E-10_JPRB, 0.86992864E-10_JPRB, 0.86977786E-10_JPRB, 0.86961827E-10_JPRB /)

RGHG9(:,57, 3) = (/ &
  & 0.86188244E-10_JPRB, 0.86572416E-10_JPRB, 0.86729769E-10_JPRB, 0.86840299E-10_JPRB, 0.86911742E-10_JPRB, 0.86953660E-10_JPRB, &
  & 0.86969529E-10_JPRB, 0.86975399E-10_JPRB, 0.86977481E-10_JPRB, 0.86977911E-10_JPRB, 0.86977349E-10_JPRB, 0.86975732E-10_JPRB, &
  & 0.86972103E-10_JPRB, 0.86966559E-10_JPRB, 0.86957636E-10_JPRB, 0.86950475E-10_JPRB, 0.86954471E-10_JPRB, 0.86979916E-10_JPRB, &
  & 0.87031216E-10_JPRB, 0.87109021E-10_JPRB, 0.87212654E-10_JPRB, 0.87337214E-10_JPRB, 0.87473258E-10_JPRB, 0.87606304E-10_JPRB, &
  & 0.87726583E-10_JPRB, 0.87825691E-10_JPRB, 0.87901471E-10_JPRB, 0.87952881E-10_JPRB, 0.87980567E-10_JPRB, 0.87985487E-10_JPRB, &
  & 0.87968223E-10_JPRB, 0.87929310E-10_JPRB, 0.87868803E-10_JPRB, 0.87789179E-10_JPRB, 0.87696427E-10_JPRB, 0.87594966E-10_JPRB, &
  & 0.87490182E-10_JPRB, 0.87384815E-10_JPRB, 0.87283077E-10_JPRB, 0.87192142E-10_JPRB, 0.87123093E-10_JPRB, 0.87087657E-10_JPRB, &
  & 0.87091376E-10_JPRB, 0.87126327E-10_JPRB, 0.87172387E-10_JPRB, 0.87216477E-10_JPRB, 0.87245398E-10_JPRB, 0.87259006E-10_JPRB, &
  & 0.87259151E-10_JPRB, 0.87254662E-10_JPRB, 0.87248722E-10_JPRB, 0.87242866E-10_JPRB, 0.87237079E-10_JPRB, 0.87230417E-10_JPRB, &
  & 0.87223131E-10_JPRB, 0.87214111E-10_JPRB, 0.87202835E-10_JPRB, 0.87190047E-10_JPRB, 0.87177210E-10_JPRB, 0.87165414E-10_JPRB, &
  & 0.87155332E-10_JPRB, 0.87144791E-10_JPRB, 0.87132968E-10_JPRB, 0.87113289E-10_JPRB /)

RGHG9(:,58, 3) = (/ &
  & 0.86625471E-10_JPRB, 0.86840618E-10_JPRB, 0.86935667E-10_JPRB, 0.86992094E-10_JPRB, 0.87036600E-10_JPRB, 0.87058673E-10_JPRB, &
  & 0.87068172E-10_JPRB, 0.87071218E-10_JPRB, 0.87072197E-10_JPRB, 0.87072197E-10_JPRB, 0.87071572E-10_JPRB, 0.87069935E-10_JPRB, &
  & 0.87067173E-10_JPRB, 0.87061129E-10_JPRB, 0.87052199E-10_JPRB, 0.87040777E-10_JPRB, 0.87036628E-10_JPRB, 0.87052796E-10_JPRB, &
  & 0.87095713E-10_JPRB, 0.87167093E-10_JPRB, 0.87265070E-10_JPRB, 0.87384537E-10_JPRB, 0.87514752E-10_JPRB, 0.87644364E-10_JPRB, &
  & 0.87760729E-10_JPRB, 0.87857742E-10_JPRB, 0.87931037E-10_JPRB, 0.87979846E-10_JPRB, 0.88005145E-10_JPRB, 0.88007775E-10_JPRB, &
  & 0.87988609E-10_JPRB, 0.87948426E-10_JPRB, 0.87887850E-10_JPRB, 0.87808871E-10_JPRB, 0.87717812E-10_JPRB, 0.87618982E-10_JPRB, &
  & 0.87517701E-10_JPRB, 0.87417358E-10_JPRB, 0.87321830E-10_JPRB, 0.87238952E-10_JPRB, 0.87178112E-10_JPRB, 0.87149968E-10_JPRB, &
  & 0.87158565E-10_JPRB, 0.87196375E-10_JPRB, 0.87246238E-10_JPRB, 0.87291258E-10_JPRB, 0.87322934E-10_JPRB, 0.87337262E-10_JPRB, &
  & 0.87338664E-10_JPRB, 0.87335243E-10_JPRB, 0.87330580E-10_JPRB, 0.87325987E-10_JPRB, 0.87321039E-10_JPRB, 0.87316182E-10_JPRB, &
  & 0.87310395E-10_JPRB, 0.87303734E-10_JPRB, 0.87295664E-10_JPRB, 0.87286144E-10_JPRB, 0.87276547E-10_JPRB, 0.87268193E-10_JPRB, &
  & 0.87260137E-10_JPRB, 0.87252323E-10_JPRB, 0.87242678E-10_JPRB, 0.87225643E-10_JPRB /)

RGHG9(:,59, 3) = (/ &
  & 0.86887469E-10_JPRB, 0.87025040E-10_JPRB, 0.87074695E-10_JPRB, 0.87111318E-10_JPRB, 0.87133842E-10_JPRB, 0.87148261E-10_JPRB, &
  & 0.87153798E-10_JPRB, 0.87155817E-10_JPRB, 0.87156490E-10_JPRB, 0.87156539E-10_JPRB, 0.87156130E-10_JPRB, 0.87155061E-10_JPRB, &
  & 0.87152549E-10_JPRB, 0.87147858E-10_JPRB, 0.87138297E-10_JPRB, 0.87125196E-10_JPRB, 0.87115828E-10_JPRB, 0.87125029E-10_JPRB, &
  & 0.87161001E-10_JPRB, 0.87226129E-10_JPRB, 0.87318382E-10_JPRB, 0.87432069E-10_JPRB, 0.87557531E-10_JPRB, 0.87682125E-10_JPRB, &
  & 0.87795514E-10_JPRB, 0.87889140E-10_JPRB, 0.87959653E-10_JPRB, 0.88005894E-10_JPRB, 0.88028751E-10_JPRB, 0.88029396E-10_JPRB, &
  & 0.88008698E-10_JPRB, 0.87967675E-10_JPRB, 0.87907057E-10_JPRB, 0.87829390E-10_JPRB, 0.87739926E-10_JPRB, 0.87644197E-10_JPRB, &
  & 0.87546907E-10_JPRB, 0.87451255E-10_JPRB, 0.87362124E-10_JPRB, 0.87286275E-10_JPRB, 0.87232971E-10_JPRB, 0.87210857E-10_JPRB, &
  & 0.87223208E-10_JPRB, 0.87263495E-10_JPRB, 0.87314316E-10_JPRB, 0.87361861E-10_JPRB, 0.87394050E-10_JPRB, 0.87409205E-10_JPRB, &
  & 0.87410981E-10_JPRB, 0.87407775E-10_JPRB, 0.87403154E-10_JPRB, 0.87398505E-10_JPRB, 0.87394009E-10_JPRB, 0.87389235E-10_JPRB, &
  & 0.87384273E-10_JPRB, 0.87378521E-10_JPRB, 0.87371610E-10_JPRB, 0.87363852E-10_JPRB, 0.87356122E-10_JPRB, 0.87348892E-10_JPRB, &
  & 0.87342591E-10_JPRB, 0.87335666E-10_JPRB, 0.87327361E-10_JPRB, 0.87311325E-10_JPRB /)

RGHG9(:,60, 3) = (/ &
  & 0.87099841E-10_JPRB, 0.87157420E-10_JPRB, 0.87186230E-10_JPRB, 0.87203862E-10_JPRB, 0.87218954E-10_JPRB, 0.87227246E-10_JPRB, &
  & 0.87231451E-10_JPRB, 0.87233068E-10_JPRB, 0.87233852E-10_JPRB, 0.87234206E-10_JPRB, 0.87234248E-10_JPRB, 0.87233734E-10_JPRB, &
  & 0.87232208E-10_JPRB, 0.87227892E-10_JPRB, 0.87219273E-10_JPRB, 0.87204882E-10_JPRB, 0.87192503E-10_JPRB, 0.87196854E-10_JPRB, &
  & 0.87227059E-10_JPRB, 0.87286442E-10_JPRB, 0.87372810E-10_JPRB, 0.87481015E-10_JPRB, 0.87601031E-10_JPRB, 0.87721101E-10_JPRB, &
  & 0.87830090E-10_JPRB, 0.87920157E-10_JPRB, 0.87987402E-10_JPRB, 0.88030798E-10_JPRB, 0.88051420E-10_JPRB, 0.88050428E-10_JPRB, &
  & 0.88028772E-10_JPRB, 0.87987222E-10_JPRB, 0.87927096E-10_JPRB, 0.87850886E-10_JPRB, 0.87763546E-10_JPRB, 0.87671016E-10_JPRB, &
  & 0.87577667E-10_JPRB, 0.87487059E-10_JPRB, 0.87403577E-10_JPRB, 0.87334404E-10_JPRB, 0.87287469E-10_JPRB, 0.87270711E-10_JPRB, &
  & 0.87286324E-10_JPRB, 0.87327832E-10_JPRB, 0.87379881E-10_JPRB, 0.87427350E-10_JPRB, 0.87461136E-10_JPRB, 0.87476637E-10_JPRB, &
  & 0.87478476E-10_JPRB, 0.87474673E-10_JPRB, 0.87469511E-10_JPRB, 0.87464327E-10_JPRB, 0.87459151E-10_JPRB, 0.87454308E-10_JPRB, &
  & 0.87449104E-10_JPRB, 0.87443497E-10_JPRB, 0.87437071E-10_JPRB, 0.87429897E-10_JPRB, 0.87422791E-10_JPRB, 0.87416664E-10_JPRB, &
  & 0.87410676E-10_JPRB, 0.87404819E-10_JPRB, 0.87397395E-10_JPRB, 0.87383704E-10_JPRB /)

RGHG9(:,61, 3) = (/ &
  & 0.87209948E-10_JPRB, 0.87253718E-10_JPRB, 0.87271107E-10_JPRB, 0.87284180E-10_JPRB, 0.87293159E-10_JPRB, 0.87299876E-10_JPRB, &
  & 0.87303345E-10_JPRB, 0.87305274E-10_JPRB, 0.87306454E-10_JPRB, 0.87307356E-10_JPRB, 0.87308064E-10_JPRB, 0.87308383E-10_JPRB, &
  & 0.87307751E-10_JPRB, 0.87304761E-10_JPRB, 0.87296170E-10_JPRB, 0.87281266E-10_JPRB, 0.87267284E-10_JPRB, 0.87268387E-10_JPRB, &
  & 0.87294054E-10_JPRB, 0.87347997E-10_JPRB, 0.87428821E-10_JPRB, 0.87531607E-10_JPRB, 0.87645780E-10_JPRB, 0.87760792E-10_JPRB, &
  & 0.87864868E-10_JPRB, 0.87950619E-10_JPRB, 0.88014124E-10_JPRB, 0.88054689E-10_JPRB, 0.88073188E-10_JPRB, 0.88070967E-10_JPRB, &
  & 0.88048797E-10_JPRB, 0.88007504E-10_JPRB, 0.87948183E-10_JPRB, 0.87873965E-10_JPRB, 0.87788984E-10_JPRB, 0.87699875E-10_JPRB, &
  & 0.87610440E-10_JPRB, 0.87524536E-10_JPRB, 0.87446529E-10_JPRB, 0.87383108E-10_JPRB, 0.87342002E-10_JPRB, 0.87329845E-10_JPRB, &
  & 0.87348191E-10_JPRB, 0.87390616E-10_JPRB, 0.87442581E-10_JPRB, 0.87490390E-10_JPRB, 0.87524307E-10_JPRB, 0.87540711E-10_JPRB, &
  & 0.87542668E-10_JPRB, 0.87538178E-10_JPRB, 0.87531773E-10_JPRB, 0.87525348E-10_JPRB, 0.87519422E-10_JPRB, 0.87513594E-10_JPRB, &
  & 0.87507987E-10_JPRB, 0.87502006E-10_JPRB, 0.87495344E-10_JPRB, 0.87488322E-10_JPRB, 0.87481654E-10_JPRB, 0.87475555E-10_JPRB, &
  & 0.87470239E-10_JPRB, 0.87464466E-10_JPRB, 0.87457569E-10_JPRB, 0.87444281E-10_JPRB /)

RGHG9(:,62, 3) = (/ &
  & 0.87303900E-10_JPRB, 0.87333085E-10_JPRB, 0.87346332E-10_JPRB, 0.87354811E-10_JPRB, 0.87362215E-10_JPRB, 0.87367530E-10_JPRB, &
  & 0.87371332E-10_JPRB, 0.87373719E-10_JPRB, 0.87375607E-10_JPRB, 0.87377293E-10_JPRB, 0.87378917E-10_JPRB, 0.87380450E-10_JPRB, &
  & 0.87381172E-10_JPRB, 0.87379187E-10_JPRB, 0.87371006E-10_JPRB, 0.87355623E-10_JPRB, 0.87340989E-10_JPRB, 0.87339989E-10_JPRB, &
  & 0.87361854E-10_JPRB, 0.87410988E-10_JPRB, 0.87486685E-10_JPRB, 0.87583579E-10_JPRB, 0.87692152E-10_JPRB, 0.87801044E-10_JPRB, &
  & 0.87899778E-10_JPRB, 0.87980484E-10_JPRB, 0.88040089E-10_JPRB, 0.88077573E-10_JPRB, 0.88094178E-10_JPRB, 0.88091090E-10_JPRB, &
  & 0.88069010E-10_JPRB, 0.88028550E-10_JPRB, 0.87970749E-10_JPRB, 0.87898820E-10_JPRB, 0.87816747E-10_JPRB, 0.87730899E-10_JPRB, &
  & 0.87645446E-10_JPRB, 0.87563908E-10_JPRB, 0.87490876E-10_JPRB, 0.87432749E-10_JPRB, 0.87396729E-10_JPRB, 0.87388596E-10_JPRB, &
  & 0.87409240E-10_JPRB, 0.87452171E-10_JPRB, 0.87503775E-10_JPRB, 0.87550918E-10_JPRB, 0.87585009E-10_JPRB, 0.87602092E-10_JPRB, &
  & 0.87604493E-10_JPRB, 0.87599220E-10_JPRB, 0.87591434E-10_JPRB, 0.87583524E-10_JPRB, 0.87576009E-10_JPRB, 0.87569250E-10_JPRB, &
  & 0.87562617E-10_JPRB, 0.87555893E-10_JPRB, 0.87548795E-10_JPRB, 0.87541474E-10_JPRB, 0.87534646E-10_JPRB, 0.87528873E-10_JPRB, &
  & 0.87523329E-10_JPRB, 0.87517889E-10_JPRB, 0.87511089E-10_JPRB, 0.87498495E-10_JPRB /)

RGHG9(:,63, 3) = (/ &
  & 0.87378452E-10_JPRB, 0.87403147E-10_JPRB, 0.87413368E-10_JPRB, 0.87420737E-10_JPRB, 0.87426642E-10_JPRB, 0.87431951E-10_JPRB, &
  & 0.87436003E-10_JPRB, 0.87439320E-10_JPRB, 0.87442137E-10_JPRB, 0.87444968E-10_JPRB, 0.87447966E-10_JPRB, 0.87451046E-10_JPRB, &
  & 0.87453475E-10_JPRB, 0.87452545E-10_JPRB, 0.87444232E-10_JPRB, 0.87428786E-10_JPRB, 0.87414138E-10_JPRB, 0.87411606E-10_JPRB, &
  & 0.87430514E-10_JPRB, 0.87475520E-10_JPRB, 0.87546172E-10_JPRB, 0.87637446E-10_JPRB, 0.87739482E-10_JPRB, 0.87842213E-10_JPRB, &
  & 0.87934493E-10_JPRB, 0.88009960E-10_JPRB, 0.88065159E-10_JPRB, 0.88099639E-10_JPRB, 0.88114446E-10_JPRB, 0.88110838E-10_JPRB, &
  & 0.88089376E-10_JPRB, 0.88050352E-10_JPRB, 0.87994792E-10_JPRB, 0.87925590E-10_JPRB, 0.87846841E-10_JPRB, 0.87764455E-10_JPRB, &
  & 0.87682812E-10_JPRB, 0.87605451E-10_JPRB, 0.87536950E-10_JPRB, 0.87483576E-10_JPRB, 0.87452073E-10_JPRB, 0.87447431E-10_JPRB, &
  & 0.87469879E-10_JPRB, 0.87512900E-10_JPRB, 0.87563679E-10_JPRB, 0.87609905E-10_JPRB, 0.87643524E-10_JPRB, 0.87661114E-10_JPRB, &
  & 0.87664209E-10_JPRB, 0.87658616E-10_JPRB, 0.87649416E-10_JPRB, 0.87639694E-10_JPRB, 0.87630680E-10_JPRB, 0.87622319E-10_JPRB, &
  & 0.87614541E-10_JPRB, 0.87606845E-10_JPRB, 0.87598845E-10_JPRB, 0.87591080E-10_JPRB, 0.87584114E-10_JPRB, 0.87577945E-10_JPRB, &
  & 0.87572491E-10_JPRB, 0.87566634E-10_JPRB, 0.87559633E-10_JPRB, 0.87546408E-10_JPRB /)

RGHG9(:,64, 3) = (/ &
  & 0.87445010E-10_JPRB, 0.87466367E-10_JPRB, 0.87475777E-10_JPRB, 0.87482244E-10_JPRB, 0.87488017E-10_JPRB, 0.87493207E-10_JPRB, &
  & 0.87498064E-10_JPRB, 0.87502214E-10_JPRB, 0.87506405E-10_JPRB, 0.87510700E-10_JPRB, 0.87515550E-10_JPRB, 0.87520720E-10_JPRB, &
  & 0.87524786E-10_JPRB, 0.87524286E-10_JPRB, 0.87515793E-10_JPRB, 0.87500798E-10_JPRB, 0.87486483E-10_JPRB, 0.87483173E-10_JPRB, &
  & 0.87499695E-10_JPRB, 0.87540988E-10_JPRB, 0.87606825E-10_JPRB, 0.87692117E-10_JPRB, 0.87787715E-10_JPRB, 0.87883222E-10_JPRB, &
  & 0.87968910E-10_JPRB, 0.88038465E-10_JPRB, 0.88089147E-10_JPRB, 0.88120490E-10_JPRB, 0.88133688E-10_JPRB, 0.88129816E-10_JPRB, &
  & 0.88109381E-10_JPRB, 0.88072390E-10_JPRB, 0.88019647E-10_JPRB, 0.87953908E-10_JPRB, 0.87878746E-10_JPRB, 0.87800246E-10_JPRB, &
  & 0.87722350E-10_JPRB, 0.87648992E-10_JPRB, 0.87584731E-10_JPRB, 0.87535652E-10_JPRB, 0.87508112E-10_JPRB, 0.87506356E-10_JPRB, &
  & 0.87530067E-10_JPRB, 0.87572678E-10_JPRB, 0.87622222E-10_JPRB, 0.87667179E-10_JPRB, 0.87700014E-10_JPRB, 0.87717666E-10_JPRB, &
  & 0.87721400E-10_JPRB, 0.87715835E-10_JPRB, 0.87705766E-10_JPRB, 0.87694504E-10_JPRB, 0.87683694E-10_JPRB, 0.87673813E-10_JPRB, &
  & 0.87664639E-10_JPRB, 0.87655591E-10_JPRB, 0.87646751E-10_JPRB, 0.87638272E-10_JPRB, 0.87630805E-10_JPRB, 0.87624422E-10_JPRB, &
  & 0.87618302E-10_JPRB, 0.87612063E-10_JPRB, 0.87604202E-10_JPRB, 0.87589470E-10_JPRB /)

RGHG9(:,65, 3) = (/ &
  & 0.87503435E-10_JPRB, 0.87524814E-10_JPRB, 0.87534091E-10_JPRB, 0.87540829E-10_JPRB, 0.87546657E-10_JPRB, 0.87552382E-10_JPRB, &
  & 0.87557767E-10_JPRB, 0.87563318E-10_JPRB, 0.87568730E-10_JPRB, 0.87575162E-10_JPRB, 0.87582018E-10_JPRB, 0.87589311E-10_JPRB, &
  & 0.87594411E-10_JPRB, 0.87593870E-10_JPRB, 0.87585564E-10_JPRB, 0.87571367E-10_JPRB, 0.87557663E-10_JPRB, 0.87553922E-10_JPRB, &
  & 0.87568709E-10_JPRB, 0.87606783E-10_JPRB, 0.87667977E-10_JPRB, 0.87747205E-10_JPRB, 0.87835635E-10_JPRB, 0.87923668E-10_JPRB, &
  & 0.88002154E-10_JPRB, 0.88065652E-10_JPRB, 0.88111650E-10_JPRB, 0.88139905E-10_JPRB, 0.88151555E-10_JPRB, 0.88147600E-10_JPRB, &
  & 0.88128407E-10_JPRB, 0.88093845E-10_JPRB, 0.88044495E-10_JPRB, 0.87982580E-10_JPRB, 0.87911858E-10_JPRB, 0.87837411E-10_JPRB, &
  & 0.87763678E-10_JPRB, 0.87694255E-10_JPRB, 0.87634122E-10_JPRB, 0.87589068E-10_JPRB, 0.87564941E-10_JPRB, 0.87565538E-10_JPRB, &
  & 0.87589859E-10_JPRB, 0.87631527E-10_JPRB, 0.87679322E-10_JPRB, 0.87722656E-10_JPRB, 0.87754477E-10_JPRB, 0.87771818E-10_JPRB, &
  & 0.87775884E-10_JPRB, 0.87770589E-10_JPRB, 0.87760091E-10_JPRB, 0.87747851E-10_JPRB, 0.87735562E-10_JPRB, 0.87724224E-10_JPRB, &
  & 0.87713434E-10_JPRB, 0.87703261E-10_JPRB, 0.87693172E-10_JPRB, 0.87684061E-10_JPRB, 0.87676047E-10_JPRB, 0.87668928E-10_JPRB, &
  & 0.87662259E-10_JPRB, 0.87654883E-10_JPRB, 0.87645606E-10_JPRB, 0.87627870E-10_JPRB /)

RGHG9(:,66, 3) = (/ &
  & 0.87557003E-10_JPRB, 0.87579444E-10_JPRB, 0.87589699E-10_JPRB, 0.87597027E-10_JPRB, 0.87603605E-10_JPRB, 0.87609912E-10_JPRB, &
  & 0.87616366E-10_JPRB, 0.87622763E-10_JPRB, 0.87630278E-10_JPRB, 0.87638230E-10_JPRB, 0.87647625E-10_JPRB, 0.87656063E-10_JPRB, &
  & 0.87661566E-10_JPRB, 0.87661059E-10_JPRB, 0.87653329E-10_JPRB, 0.87640166E-10_JPRB, 0.87627405E-10_JPRB, 0.87623749E-10_JPRB, &
  & 0.87637252E-10_JPRB, 0.87672397E-10_JPRB, 0.87728810E-10_JPRB, 0.87801696E-10_JPRB, 0.87882639E-10_JPRB, 0.87962686E-10_JPRB, &
  & 0.88033816E-10_JPRB, 0.88091083E-10_JPRB, 0.88132397E-10_JPRB, 0.88157606E-10_JPRB, 0.88167813E-10_JPRB, 0.88163844E-10_JPRB, &
  & 0.88146053E-10_JPRB, 0.88114141E-10_JPRB, 0.88068483E-10_JPRB, 0.88010939E-10_JPRB, 0.87944992E-10_JPRB, 0.87875318E-10_JPRB, &
  & 0.87805929E-10_JPRB, 0.87740822E-10_JPRB, 0.87684873E-10_JPRB, 0.87643733E-10_JPRB, 0.87622611E-10_JPRB, 0.87624935E-10_JPRB, &
  & 0.87649395E-10_JPRB, 0.87689384E-10_JPRB, 0.87735000E-10_JPRB, 0.87776446E-10_JPRB, 0.87806838E-10_JPRB, 0.87823707E-10_JPRB, &
  & 0.87827828E-10_JPRB, 0.87822735E-10_JPRB, 0.87812278E-10_JPRB, 0.87799393E-10_JPRB, 0.87786348E-10_JPRB, 0.87773594E-10_JPRB, &
  & 0.87761749E-10_JPRB, 0.87750099E-10_JPRB, 0.87739302E-10_JPRB, 0.87729296E-10_JPRB, 0.87720636E-10_JPRB, 0.87712879E-10_JPRB, &
  & 0.87705065E-10_JPRB, 0.87696447E-10_JPRB, 0.87684936E-10_JPRB, 0.87662280E-10_JPRB /)

RGHG9(:,67, 3) = (/ &
  & 0.87607643E-10_JPRB, 0.87632124E-10_JPRB, 0.87643337E-10_JPRB, 0.87651789E-10_JPRB, 0.87659283E-10_JPRB, 0.87666638E-10_JPRB, &
  & 0.87673979E-10_JPRB, 0.87681931E-10_JPRB, 0.87690535E-10_JPRB, 0.87700881E-10_JPRB, 0.87711241E-10_JPRB, 0.87720553E-10_JPRB, &
  & 0.87726146E-10_JPRB, 0.87725896E-10_JPRB, 0.87718922E-10_JPRB, 0.87706967E-10_JPRB, 0.87695337E-10_JPRB, 0.87692027E-10_JPRB, &
  & 0.87704510E-10_JPRB, 0.87736762E-10_JPRB, 0.87788415E-10_JPRB, 0.87854647E-10_JPRB, 0.87927804E-10_JPRB, 0.87999746E-10_JPRB, &
  & 0.88063494E-10_JPRB, 0.88114648E-10_JPRB, 0.88151375E-10_JPRB, 0.88173663E-10_JPRB, 0.88182475E-10_JPRB, 0.88178576E-10_JPRB, &
  & 0.88162234E-10_JPRB, 0.88133049E-10_JPRB, 0.88091222E-10_JPRB, 0.88038361E-10_JPRB, 0.87977618E-10_JPRB, 0.87913066E-10_JPRB, &
  & 0.87848506E-10_JPRB, 0.87788096E-10_JPRB, 0.87736561E-10_JPRB, 0.87699299E-10_JPRB, 0.87681022E-10_JPRB, 0.87684568E-10_JPRB, &
  & 0.87708493E-10_JPRB, 0.87746456E-10_JPRB, 0.87789373E-10_JPRB, 0.87828432E-10_JPRB, 0.87857374E-10_JPRB, 0.87873341E-10_JPRB, &
  & 0.87877386E-10_JPRB, 0.87872529E-10_JPRB, 0.87862113E-10_JPRB, 0.87849256E-10_JPRB, 0.87835572E-10_JPRB, 0.87822319E-10_JPRB, &
  & 0.87809288E-10_JPRB, 0.87797034E-10_JPRB, 0.87785210E-10_JPRB, 0.87774718E-10_JPRB, 0.87765378E-10_JPRB, 0.87756802E-10_JPRB, &
  & 0.87748128E-10_JPRB, 0.87737727E-10_JPRB, 0.87723218E-10_JPRB, 0.87693935E-10_JPRB /)

RGHG9(:,68, 3) = (/ &
  & 0.87655445E-10_JPRB, 0.87682479E-10_JPRB, 0.87695601E-10_JPRB, 0.87705336E-10_JPRB, 0.87714183E-10_JPRB, 0.87722676E-10_JPRB, &
  & 0.87731225E-10_JPRB, 0.87740266E-10_JPRB, 0.87750557E-10_JPRB, 0.87761770E-10_JPRB, 0.87773143E-10_JPRB, 0.87782545E-10_JPRB, &
  & 0.87788200E-10_JPRB, 0.87788277E-10_JPRB, 0.87782143E-10_JPRB, 0.87771478E-10_JPRB, 0.87761159E-10_JPRB, 0.87758273E-10_JPRB, &
  & 0.87769736E-10_JPRB, 0.87799074E-10_JPRB, 0.87845703E-10_JPRB, 0.87905218E-10_JPRB, 0.87970541E-10_JPRB, 0.88034559E-10_JPRB, &
  & 0.88091132E-10_JPRB, 0.88136415E-10_JPRB, 0.88168785E-10_JPRB, 0.88188276E-10_JPRB, 0.88195812E-10_JPRB, 0.88192016E-10_JPRB, &
  & 0.88177125E-10_JPRB, 0.88150695E-10_JPRB, 0.88112781E-10_JPRB, 0.88064722E-10_JPRB, 0.88009398E-10_JPRB, 0.87950126E-10_JPRB, &
  & 0.87890854E-10_JPRB, 0.87835357E-10_JPRB, 0.87788506E-10_JPRB, 0.87755234E-10_JPRB, 0.87739593E-10_JPRB, 0.87744048E-10_JPRB, &
  & 0.87767120E-10_JPRB, 0.87802494E-10_JPRB, 0.87842435E-10_JPRB, 0.87878940E-10_JPRB, 0.87905822E-10_JPRB, 0.87920955E-10_JPRB, &
  & 0.87924737E-10_JPRB, 0.87920032E-10_JPRB, 0.87909971E-10_JPRB, 0.87897190E-10_JPRB, 0.87883589E-10_JPRB, 0.87869857E-10_JPRB, &
  & 0.87856562E-10_JPRB, 0.87843607E-10_JPRB, 0.87831464E-10_JPRB, 0.87820383E-10_JPRB, 0.87810662E-10_JPRB, 0.87801613E-10_JPRB, &
  & 0.87792079E-10_JPRB, 0.87780366E-10_JPRB, 0.87762998E-10_JPRB, 0.87725674E-10_JPRB /)

RGHG9(:,69, 3) = (/ &
  & 0.87701332E-10_JPRB, 0.87732377E-10_JPRB, 0.87747087E-10_JPRB, 0.87758634E-10_JPRB, 0.87768792E-10_JPRB, 0.87778625E-10_JPRB, &
  & 0.87788193E-10_JPRB, 0.87798359E-10_JPRB, 0.87809621E-10_JPRB, 0.87821542E-10_JPRB, 0.87833081E-10_JPRB, 0.87842393E-10_JPRB, &
  & 0.87848007E-10_JPRB, 0.87848374E-10_JPRB, 0.87843038E-10_JPRB, 0.87833685E-10_JPRB, 0.87824539E-10_JPRB, 0.87822041E-10_JPRB, &
  & 0.87832325E-10_JPRB, 0.87858540E-10_JPRB, 0.87900173E-10_JPRB, 0.87952895E-10_JPRB, 0.88010675E-10_JPRB, 0.88067040E-10_JPRB, &
  & 0.88116861E-10_JPRB, 0.88156558E-10_JPRB, 0.88184827E-10_JPRB, 0.88201717E-10_JPRB, 0.88208080E-10_JPRB, 0.88204430E-10_JPRB, &
  & 0.88191017E-10_JPRB, 0.88167300E-10_JPRB, 0.88133341E-10_JPRB, 0.88090132E-10_JPRB, 0.88040145E-10_JPRB, 0.87986445E-10_JPRB, &
  & 0.87932508E-10_JPRB, 0.87882292E-10_JPRB, 0.87840270E-10_JPRB, 0.87810981E-10_JPRB, 0.87797936E-10_JPRB, 0.87803077E-10_JPRB, &
  & 0.87824865E-10_JPRB, 0.87857659E-10_JPRB, 0.87894247E-10_JPRB, 0.87927721E-10_JPRB, 0.87952652E-10_JPRB, 0.87966509E-10_JPRB, &
  & 0.87970048E-10_JPRB, 0.87965593E-10_JPRB, 0.87955879E-10_JPRB, 0.87943576E-10_JPRB, 0.87930226E-10_JPRB, 0.87916681E-10_JPRB, &
  & 0.87903261E-10_JPRB, 0.87890313E-10_JPRB, 0.87877990E-10_JPRB, 0.87866880E-10_JPRB, 0.87856951E-10_JPRB, 0.87847729E-10_JPRB, &
  & 0.87837876E-10_JPRB, 0.87825199E-10_JPRB, 0.87804833E-10_JPRB, 0.87760646E-10_JPRB /)

RGHG9(:,70, 3) = (/ &
  & 0.87746498E-10_JPRB, 0.87781324E-10_JPRB, 0.87799011E-10_JPRB, 0.87812084E-10_JPRB, 0.87823929E-10_JPRB, 0.87834684E-10_JPRB, &
  & 0.87845231E-10_JPRB, 0.87856167E-10_JPRB, 0.87867894E-10_JPRB, 0.87880009E-10_JPRB, 0.87891208E-10_JPRB, 0.87900159E-10_JPRB, &
  & 0.87905509E-10_JPRB, 0.87906037E-10_JPRB, 0.87901450E-10_JPRB, 0.87893227E-10_JPRB, 0.87885206E-10_JPRB, 0.87882861E-10_JPRB, &
  & 0.87891867E-10_JPRB, 0.87914870E-10_JPRB, 0.87951403E-10_JPRB, 0.87997595E-10_JPRB, 0.88048062E-10_JPRB, 0.88097307E-10_JPRB, &
  & 0.88140668E-10_JPRB, 0.88175224E-10_JPRB, 0.88199642E-10_JPRB, 0.88214117E-10_JPRB, 0.88219425E-10_JPRB, 0.88215997E-10_JPRB, &
  & 0.88204041E-10_JPRB, 0.88183065E-10_JPRB, 0.88152985E-10_JPRB, 0.88114564E-10_JPRB, 0.88070023E-10_JPRB, 0.88021770E-10_JPRB, &
  & 0.87973427E-10_JPRB, 0.87928498E-10_JPRB, 0.87891354E-10_JPRB, 0.87866020E-10_JPRB, 0.87855383E-10_JPRB, 0.87861010E-10_JPRB, &
  & 0.87881515E-10_JPRB, 0.87911310E-10_JPRB, 0.87944652E-10_JPRB, 0.87974947E-10_JPRB, 0.87997429E-10_JPRB, 0.88010113E-10_JPRB, &
  & 0.88013305E-10_JPRB, 0.88009107E-10_JPRB, 0.88000031E-10_JPRB, 0.87988367E-10_JPRB, 0.87975668E-10_JPRB, 0.87962602E-10_JPRB, &
  & 0.87949627E-10_JPRB, 0.87937047E-10_JPRB, 0.87925056E-10_JPRB, 0.87914211E-10_JPRB, 0.87904531E-10_JPRB, 0.87895441E-10_JPRB, &
  & 0.87885657E-10_JPRB, 0.87872598E-10_JPRB, 0.87851032E-10_JPRB, 0.87801190E-10_JPRB /)

RGHG9(:,71, 3) = (/ &
  & 0.87790532E-10_JPRB, 0.87831832E-10_JPRB, 0.87851615E-10_JPRB, 0.87866818E-10_JPRB, 0.87879620E-10_JPRB, 0.87891375E-10_JPRB, &
  & 0.87902283E-10_JPRB, 0.87913621E-10_JPRB, 0.87925396E-10_JPRB, 0.87937005E-10_JPRB, 0.87947656E-10_JPRB, 0.87955879E-10_JPRB, &
  & 0.87960736E-10_JPRB, 0.87961229E-10_JPRB, 0.87957128E-10_JPRB, 0.87949870E-10_JPRB, 0.87942736E-10_JPRB, 0.87940467E-10_JPRB, &
  & 0.87948121E-10_JPRB, 0.87967911E-10_JPRB, 0.87999469E-10_JPRB, 0.88039347E-10_JPRB, 0.88082854E-10_JPRB, 0.88125340E-10_JPRB, &
  & 0.88162783E-10_JPRB, 0.88192439E-10_JPRB, 0.88213381E-10_JPRB, 0.88225621E-10_JPRB, 0.88229986E-10_JPRB, 0.88226829E-10_JPRB, &
  & 0.88216351E-10_JPRB, 0.88198032E-10_JPRB, 0.88171789E-10_JPRB, 0.88138059E-10_JPRB, 0.88098917E-10_JPRB, 0.88056208E-10_JPRB, &
  & 0.88013402E-10_JPRB, 0.87973760E-10_JPRB, 0.87941425E-10_JPRB, 0.87919887E-10_JPRB, 0.87911477E-10_JPRB, 0.87917444E-10_JPRB, &
  & 0.87936221E-10_JPRB, 0.87963345E-10_JPRB, 0.87992919E-10_JPRB, 0.88019973E-10_JPRB, 0.88040068E-10_JPRB, 0.88051358E-10_JPRB, &
  & 0.88054238E-10_JPRB, 0.88050525E-10_JPRB, 0.88042150E-10_JPRB, 0.88031471E-10_JPRB, 0.88019751E-10_JPRB, 0.88007553E-10_JPRB, &
  & 0.87995486E-10_JPRB, 0.87983620E-10_JPRB, 0.87972456E-10_JPRB, 0.87962193E-10_JPRB, 0.87953082E-10_JPRB, 0.87944471E-10_JPRB, &
  & 0.87935083E-10_JPRB, 0.87922399E-10_JPRB, 0.87900548E-10_JPRB, 0.87849381E-10_JPRB /)

RGHG9(:,72, 3) = (/ &
  & 0.87835982E-10_JPRB, 0.87883173E-10_JPRB, 0.87906279E-10_JPRB, 0.87922641E-10_JPRB, 0.87936318E-10_JPRB, 0.87948142E-10_JPRB, &
  & 0.87959265E-10_JPRB, 0.87970416E-10_JPRB, 0.87981504E-10_JPRB, 0.87992613E-10_JPRB, 0.88002029E-10_JPRB, 0.88009378E-10_JPRB, &
  & 0.88013520E-10_JPRB, 0.88013707E-10_JPRB, 0.88009926E-10_JPRB, 0.88003355E-10_JPRB, 0.87997061E-10_JPRB, 0.87994757E-10_JPRB, &
  & 0.88001058E-10_JPRB, 0.88017704E-10_JPRB, 0.88044509E-10_JPRB, 0.88078239E-10_JPRB, 0.88115217E-10_JPRB, 0.88151375E-10_JPRB, &
  & 0.88183169E-10_JPRB, 0.88208385E-10_JPRB, 0.88226121E-10_JPRB, 0.88236342E-10_JPRB, 0.88239881E-10_JPRB, 0.88236987E-10_JPRB, &
  & 0.88227980E-10_JPRB, 0.88212285E-10_JPRB, 0.88189685E-10_JPRB, 0.88160680E-10_JPRB, 0.88126777E-10_JPRB, 0.88089598E-10_JPRB, &
  & 0.88052309E-10_JPRB, 0.88017892E-10_JPRB, 0.87990247E-10_JPRB, 0.87972282E-10_JPRB, 0.87965801E-10_JPRB, 0.87971817E-10_JPRB, &
  & 0.87988963E-10_JPRB, 0.88012680E-10_JPRB, 0.88038875E-10_JPRB, 0.88062467E-10_JPRB, 0.88080002E-10_JPRB, 0.88089952E-10_JPRB, &
  & 0.88092596E-10_JPRB, 0.88089321E-10_JPRB, 0.88082014E-10_JPRB, 0.88072521E-10_JPRB, 0.88062072E-10_JPRB, 0.88051219E-10_JPRB, &
  & 0.88040242E-10_JPRB, 0.88029702E-10_JPRB, 0.88019411E-10_JPRB, 0.88010203E-10_JPRB, 0.88001779E-10_JPRB, 0.87993855E-10_JPRB, &
  & 0.87985133E-10_JPRB, 0.87973157E-10_JPRB, 0.87952118E-10_JPRB, 0.87901554E-10_JPRB /)

RGHG9(:,73, 3) = (/ &
  & 0.87889716E-10_JPRB, 0.87939454E-10_JPRB, 0.87963067E-10_JPRB, 0.87979499E-10_JPRB, 0.87992891E-10_JPRB, 0.88004458E-10_JPRB, &
  & 0.88015026E-10_JPRB, 0.88025490E-10_JPRB, 0.88035933E-10_JPRB, 0.88045557E-10_JPRB, 0.88054078E-10_JPRB, 0.88060170E-10_JPRB, &
  & 0.88063466E-10_JPRB, 0.88063203E-10_JPRB, 0.88059490E-10_JPRB, 0.88053460E-10_JPRB, 0.88047833E-10_JPRB, 0.88045508E-10_JPRB, &
  & 0.88050595E-10_JPRB, 0.88064257E-10_JPRB, 0.88086483E-10_JPRB, 0.88114467E-10_JPRB, 0.88145213E-10_JPRB, 0.88175509E-10_JPRB, &
  & 0.88202085E-10_JPRB, 0.88223116E-10_JPRB, 0.88237903E-10_JPRB, 0.88246320E-10_JPRB, 0.88249158E-10_JPRB, 0.88246577E-10_JPRB, &
  & 0.88238993E-10_JPRB, 0.88225753E-10_JPRB, 0.88206713E-10_JPRB, 0.88182302E-10_JPRB, 0.88153457E-10_JPRB, 0.88121850E-10_JPRB, &
  & 0.88090008E-10_JPRB, 0.88060635E-10_JPRB, 0.88037487E-10_JPRB, 0.88022797E-10_JPRB, 0.88017982E-10_JPRB, 0.88023921E-10_JPRB, &
  & 0.88038840E-10_JPRB, 0.88059553E-10_JPRB, 0.88081785E-10_JPRB, 0.88102005E-10_JPRB, 0.88117194E-10_JPRB, 0.88125660E-10_JPRB, &
  & 0.88128102E-10_JPRB, 0.88125465E-10_JPRB, 0.88119158E-10_JPRB, 0.88111116E-10_JPRB, 0.88102213E-10_JPRB, 0.88092658E-10_JPRB, &
  & 0.88083353E-10_JPRB, 0.88073937E-10_JPRB, 0.88065173E-10_JPRB, 0.88056784E-10_JPRB, 0.88049394E-10_JPRB, 0.88042226E-10_JPRB, &
  & 0.88034316E-10_JPRB, 0.88023366E-10_JPRB, 0.88003820E-10_JPRB, 0.87955435E-10_JPRB /)

RGHG9(:,74, 3) = (/ &
  & 0.87945644E-10_JPRB, 0.87996957E-10_JPRB, 0.88019987E-10_JPRB, 0.88035745E-10_JPRB, 0.88048034E-10_JPRB, 0.88058602E-10_JPRB, &
  & 0.88068414E-10_JPRB, 0.88077816E-10_JPRB, 0.88086954E-10_JPRB, 0.88095600E-10_JPRB, 0.88102532E-10_JPRB, 0.88107605E-10_JPRB, &
  & 0.88110033E-10_JPRB, 0.88109284E-10_JPRB, 0.88105558E-10_JPRB, 0.88099958E-10_JPRB, 0.88095045E-10_JPRB, 0.88092734E-10_JPRB, &
  & 0.88096648E-10_JPRB, 0.88107577E-10_JPRB, 0.88125479E-10_JPRB, 0.88148155E-10_JPRB, 0.88173129E-10_JPRB, 0.88197977E-10_JPRB, &
  & 0.88219626E-10_JPRB, 0.88236821E-10_JPRB, 0.88248880E-10_JPRB, 0.88255674E-10_JPRB, 0.88257894E-10_JPRB, 0.88255632E-10_JPRB, &
  & 0.88249401E-10_JPRB, 0.88238548E-10_JPRB, 0.88222915E-10_JPRB, 0.88202778E-10_JPRB, 0.88179027E-10_JPRB, 0.88152652E-10_JPRB, &
  & 0.88126305E-10_JPRB, 0.88101831E-10_JPRB, 0.88082854E-10_JPRB, 0.88071203E-10_JPRB, 0.88067706E-10_JPRB, 0.88073215E-10_JPRB, &
  & 0.88086115E-10_JPRB, 0.88103212E-10_JPRB, 0.88121802E-10_JPRB, 0.88138725E-10_JPRB, 0.88151347E-10_JPRB, 0.88158578E-10_JPRB, &
  & 0.88160715E-10_JPRB, 0.88158612E-10_JPRB, 0.88153554E-10_JPRB, 0.88146955E-10_JPRB, 0.88139523E-10_JPRB, 0.88131634E-10_JPRB, &
  & 0.88123620E-10_JPRB, 0.88116008E-10_JPRB, 0.88108312E-10_JPRB, 0.88101262E-10_JPRB, 0.88094712E-10_JPRB, 0.88088495E-10_JPRB, &
  & 0.88081625E-10_JPRB, 0.88071883E-10_JPRB, 0.88054133E-10_JPRB, 0.88009017E-10_JPRB /)

RGHG9(:,75, 3) = (/ &
  & 0.88003195E-10_JPRB, 0.88053689E-10_JPRB, 0.88075845E-10_JPRB, 0.88089432E-10_JPRB, 0.88100402E-10_JPRB, 0.88109638E-10_JPRB, &
  & 0.88118200E-10_JPRB, 0.88126388E-10_JPRB, 0.88134250E-10_JPRB, 0.88141314E-10_JPRB, 0.88147108E-10_JPRB, 0.88151042E-10_JPRB, &
  & 0.88152742E-10_JPRB, 0.88151583E-10_JPRB, 0.88147961E-10_JPRB, 0.88142896E-10_JPRB, 0.88138712E-10_JPRB, 0.88136436E-10_JPRB, &
  & 0.88139329E-10_JPRB, 0.88147649E-10_JPRB, 0.88161749E-10_JPRB, 0.88179457E-10_JPRB, 0.88199205E-10_JPRB, 0.88218981E-10_JPRB, &
  & 0.88236002E-10_JPRB, 0.88249595E-10_JPRB, 0.88259143E-10_JPRB, 0.88264458E-10_JPRB, 0.88266172E-10_JPRB, 0.88264215E-10_JPRB, &
  & 0.88259289E-10_JPRB, 0.88250685E-10_JPRB, 0.88238215E-10_JPRB, 0.88222200E-10_JPRB, 0.88203334E-10_JPRB, 0.88182066E-10_JPRB, &
  & 0.88161034E-10_JPRB, 0.88141286E-10_JPRB, 0.88126270E-10_JPRB, 0.88117263E-10_JPRB, 0.88114814E-10_JPRB, 0.88119789E-10_JPRB, &
  & 0.88130267E-10_JPRB, 0.88144117E-10_JPRB, 0.88158994E-10_JPRB, 0.88172539E-10_JPRB, 0.88183010E-10_JPRB, 0.88188713E-10_JPRB, &
  & 0.88190601E-10_JPRB, 0.88189067E-10_JPRB, 0.88185015E-10_JPRB, 0.88179880E-10_JPRB, 0.88174038E-10_JPRB, 0.88167404E-10_JPRB, &
  & 0.88161131E-10_JPRB, 0.88154824E-10_JPRB, 0.88148808E-10_JPRB, 0.88142771E-10_JPRB, 0.88137379E-10_JPRB, 0.88132217E-10_JPRB, &
  & 0.88126464E-10_JPRB, 0.88118159E-10_JPRB, 0.88102366E-10_JPRB, 0.88060871E-10_JPRB /)

RGHG9(:,76, 3) = (/ &
  & 0.88061072E-10_JPRB, 0.88109506E-10_JPRB, 0.88128706E-10_JPRB, 0.88140259E-10_JPRB, 0.88149141E-10_JPRB, 0.88156836E-10_JPRB, &
  & 0.88164059E-10_JPRB, 0.88170700E-10_JPRB, 0.88177118E-10_JPRB, 0.88182656E-10_JPRB, 0.88187020E-10_JPRB, 0.88189955E-10_JPRB, &
  & 0.88191121E-10_JPRB, 0.88189803E-10_JPRB, 0.88186528E-10_JPRB, 0.88182198E-10_JPRB, 0.88178916E-10_JPRB, 0.88176765E-10_JPRB, &
  & 0.88178721E-10_JPRB, 0.88184814E-10_JPRB, 0.88195395E-10_JPRB, 0.88208767E-10_JPRB, 0.88223533E-10_JPRB, 0.88238632E-10_JPRB, &
  & 0.88251233E-10_JPRB, 0.88261509E-10_JPRB, 0.88268774E-10_JPRB, 0.88272792E-10_JPRB, 0.88274062E-10_JPRB, 0.88272389E-10_JPRB, &
  & 0.88268726E-10_JPRB, 0.88262217E-10_JPRB, 0.88252662E-10_JPRB, 0.88240582E-10_JPRB, 0.88226412E-10_JPRB, 0.88209939E-10_JPRB, &
  & 0.88194001E-10_JPRB, 0.88178902E-10_JPRB, 0.88167529E-10_JPRB, 0.88160937E-10_JPRB, 0.88159244E-10_JPRB, 0.88163365E-10_JPRB, &
  & 0.88171519E-10_JPRB, 0.88182066E-10_JPRB, 0.88193466E-10_JPRB, 0.88203923E-10_JPRB, 0.88211993E-10_JPRB, 0.88216420E-10_JPRB, &
  & 0.88217898E-10_JPRB, 0.88216753E-10_JPRB, 0.88213742E-10_JPRB, 0.88209967E-10_JPRB, 0.88205519E-10_JPRB, 0.88200301E-10_JPRB, &
  & 0.88195382E-10_JPRB, 0.88190767E-10_JPRB, 0.88186125E-10_JPRB, 0.88181455E-10_JPRB, 0.88177125E-10_JPRB, 0.88173122E-10_JPRB, &
  & 0.88168695E-10_JPRB, 0.88161874E-10_JPRB, 0.88148398E-10_JPRB, 0.88110505E-10_JPRB /)

RGHG9(:,77, 3) = (/ &
  & 0.88119560E-10_JPRB, 0.88162214E-10_JPRB, 0.88178596E-10_JPRB, 0.88186972E-10_JPRB, 0.88193862E-10_JPRB, 0.88199718E-10_JPRB, &
  & 0.88205325E-10_JPRB, 0.88210411E-10_JPRB, 0.88214991E-10_JPRB, 0.88218967E-10_JPRB, 0.88221833E-10_JPRB, 0.88223817E-10_JPRB, &
  & 0.88224608E-10_JPRB, 0.88223422E-10_JPRB, 0.88220861E-10_JPRB, 0.88217503E-10_JPRB, 0.88215366E-10_JPRB, 0.88213464E-10_JPRB, &
  & 0.88214734E-10_JPRB, 0.88218766E-10_JPRB, 0.88226475E-10_JPRB, 0.88235752E-10_JPRB, 0.88246077E-10_JPRB, 0.88256832E-10_JPRB, &
  & 0.88265319E-10_JPRB, 0.88272618E-10_JPRB, 0.88277843E-10_JPRB, 0.88280688E-10_JPRB, 0.88281625E-10_JPRB, 0.88280196E-10_JPRB, &
  & 0.88277732E-10_JPRB, 0.88273083E-10_JPRB, 0.88266242E-10_JPRB, 0.88257832E-10_JPRB, 0.88247874E-10_JPRB, 0.88236120E-10_JPRB, &
  & 0.88224830E-10_JPRB, 0.88214193E-10_JPRB, 0.88206234E-10_JPRB, 0.88201724E-10_JPRB, 0.88200544E-10_JPRB, 0.88203597E-10_JPRB, &
  & 0.88209273E-10_JPRB, 0.88216809E-10_JPRB, 0.88224997E-10_JPRB, 0.88232296E-10_JPRB, 0.88238361E-10_JPRB, 0.88241338E-10_JPRB, &
  & 0.88242476E-10_JPRB, 0.88241692E-10_JPRB, 0.88239561E-10_JPRB, 0.88237098E-10_JPRB, 0.88234031E-10_JPRB, 0.88229916E-10_JPRB, &
  & 0.88226475E-10_JPRB, 0.88223331E-10_JPRB, 0.88220257E-10_JPRB, 0.88216788E-10_JPRB, 0.88213631E-10_JPRB, 0.88210821E-10_JPRB, &
  & 0.88207761E-10_JPRB, 0.88202556E-10_JPRB, 0.88191503E-10_JPRB, 0.88158474E-10_JPRB /)

RGHG9(:,78, 3) = (/ &
  & 0.88177035E-10_JPRB, 0.88210196E-10_JPRB, 0.88221534E-10_JPRB, 0.88226940E-10_JPRB, 0.88231637E-10_JPRB, 0.88235766E-10_JPRB, &
  & 0.88239777E-10_JPRB, 0.88242941E-10_JPRB, 0.88245973E-10_JPRB, 0.88248117E-10_JPRB, 0.88249685E-10_JPRB, 0.88250823E-10_JPRB, &
  & 0.88251503E-10_JPRB, 0.88250657E-10_JPRB, 0.88249005E-10_JPRB, 0.88246868E-10_JPRB, 0.88245980E-10_JPRB, 0.88244557E-10_JPRB, &
  & 0.88245397E-10_JPRB, 0.88247944E-10_JPRB, 0.88253217E-10_JPRB, 0.88259150E-10_JPRB, 0.88265568E-10_JPRB, 0.88272632E-10_JPRB, &
  & 0.88277635E-10_JPRB, 0.88282381E-10_JPRB, 0.88285899E-10_JPRB, 0.88287821E-10_JPRB, 0.88288481E-10_JPRB, 0.88287294E-10_JPRB, &
  & 0.88285865E-10_JPRB, 0.88282770E-10_JPRB, 0.88278315E-10_JPRB, 0.88273021E-10_JPRB, 0.88266824E-10_JPRB, 0.88259081E-10_JPRB, &
  & 0.88251913E-10_JPRB, 0.88245120E-10_JPRB, 0.88240158E-10_JPRB, 0.88237306E-10_JPRB, 0.88236300E-10_JPRB, 0.88238084E-10_JPRB, &
  & 0.88241414E-10_JPRB, 0.88246334E-10_JPRB, 0.88251607E-10_JPRB, 0.88256256E-10_JPRB, 0.88260434E-10_JPRB, 0.88262182E-10_JPRB, &
  & 0.88263015E-10_JPRB, 0.88262515E-10_JPRB, 0.88261169E-10_JPRB, 0.88259837E-10_JPRB, 0.88257956E-10_JPRB, 0.88254792E-10_JPRB, &
  & 0.88252572E-10_JPRB, 0.88250754E-10_JPRB, 0.88249033E-10_JPRB, 0.88246660E-10_JPRB, 0.88244495E-10_JPRB, 0.88242816E-10_JPRB, &
  & 0.88241053E-10_JPRB, 0.88237376E-10_JPRB, 0.88230055E-10_JPRB, 0.88204416E-10_JPRB /)

RGHG9(:,79, 3) = (/ &
  & 0.88214325E-10_JPRB, 0.88236848E-10_JPRB, 0.88244523E-10_JPRB, 0.88247493E-10_JPRB, 0.88251170E-10_JPRB, 0.88254341E-10_JPRB, &
  & 0.88257464E-10_JPRB, 0.88259774E-10_JPRB, 0.88261662E-10_JPRB, 0.88263188E-10_JPRB, 0.88264000E-10_JPRB, 0.88264819E-10_JPRB, &
  & 0.88265499E-10_JPRB, 0.88264805E-10_JPRB, 0.88263612E-10_JPRB, 0.88262120E-10_JPRB, 0.88262044E-10_JPRB, 0.88260850E-10_JPRB, &
  & 0.88261551E-10_JPRB, 0.88263279E-10_JPRB, 0.88267484E-10_JPRB, 0.88271612E-10_JPRB, 0.88275984E-10_JPRB, 0.88281153E-10_JPRB, &
  & 0.88284186E-10_JPRB, 0.88287606E-10_JPRB, 0.88290292E-10_JPRB, 0.88291735E-10_JPRB, 0.88292269E-10_JPRB, 0.88291152E-10_JPRB, &
  & 0.88290326E-10_JPRB, 0.88288044E-10_JPRB, 0.88284866E-10_JPRB, 0.88281292E-10_JPRB, 0.88277156E-10_JPRB, 0.88271550E-10_JPRB, &
  & 0.88266568E-10_JPRB, 0.88261808E-10_JPRB, 0.88258435E-10_JPRB, 0.88256367E-10_JPRB, 0.88255341E-10_JPRB, 0.88256361E-10_JPRB, &
  & 0.88258373E-10_JPRB, 0.88261898E-10_JPRB, 0.88265679E-10_JPRB, 0.88268802E-10_JPRB, 0.88272112E-10_JPRB, 0.88273090E-10_JPRB, &
  & 0.88273791E-10_JPRB, 0.88273458E-10_JPRB, 0.88272480E-10_JPRB, 0.88271779E-10_JPRB, 0.88270516E-10_JPRB, 0.88267671E-10_JPRB, &
  & 0.88266061E-10_JPRB, 0.88264895E-10_JPRB, 0.88263938E-10_JPRB, 0.88262044E-10_JPRB, 0.88260357E-10_JPRB, 0.88259226E-10_JPRB, &
  & 0.88258220E-10_JPRB, 0.88255826E-10_JPRB, 0.88251476E-10_JPRB, 0.88234010E-10_JPRB /)

RGHG9(:,80, 3) = (/ &
  & 0.88239069E-10_JPRB, 0.88249720E-10_JPRB, 0.88254529E-10_JPRB, 0.88256361E-10_JPRB, 0.88259476E-10_JPRB, 0.88262272E-10_JPRB, &
  & 0.88265138E-10_JPRB, 0.88266811E-10_JPRB, 0.88268670E-10_JPRB, 0.88269669E-10_JPRB, 0.88270412E-10_JPRB, 0.88271057E-10_JPRB, &
  & 0.88271813E-10_JPRB, 0.88271147E-10_JPRB, 0.88270100E-10_JPRB, 0.88268830E-10_JPRB, 0.88269198E-10_JPRB, 0.88268073E-10_JPRB, &
  & 0.88268726E-10_JPRB, 0.88270107E-10_JPRB, 0.88273867E-10_JPRB, 0.88277212E-10_JPRB, 0.88280661E-10_JPRB, 0.88284977E-10_JPRB, &
  & 0.88287121E-10_JPRB, 0.88289945E-10_JPRB, 0.88292304E-10_JPRB, 0.88293553E-10_JPRB, 0.88294032E-10_JPRB, 0.88292915E-10_JPRB, &
  & 0.88292380E-10_JPRB, 0.88290458E-10_JPRB, 0.88287870E-10_JPRB, 0.88285081E-10_JPRB, 0.88281903E-10_JPRB, 0.88277247E-10_JPRB, &
  & 0.88273236E-10_JPRB, 0.88269392E-10_JPRB, 0.88266713E-10_JPRB, 0.88265013E-10_JPRB, 0.88263938E-10_JPRB, 0.88264569E-10_JPRB, &
  & 0.88265922E-10_JPRB, 0.88268858E-10_JPRB, 0.88271973E-10_JPRB, 0.88274429E-10_JPRB, 0.88277337E-10_JPRB, 0.88277941E-10_JPRB, &
  & 0.88278558E-10_JPRB, 0.88278246E-10_JPRB, 0.88277413E-10_JPRB, 0.88277011E-10_JPRB, 0.88275991E-10_JPRB, 0.88273180E-10_JPRB, &
  & 0.88271813E-10_JPRB, 0.88270960E-10_JPRB, 0.88270322E-10_JPRB, 0.88268587E-10_JPRB, 0.88267074E-10_JPRB, 0.88266207E-10_JPRB, &
  & 0.88265638E-10_JPRB, 0.88263834E-10_JPRB, 0.88261821E-10_JPRB, 0.88253523E-10_JPRB /)

RGHG9(:,81, 3) = (/ &
  & 0.88256139E-10_JPRB, 0.88255132E-10_JPRB, 0.88258754E-10_JPRB, 0.88260038E-10_JPRB, 0.88263008E-10_JPRB, 0.88265693E-10_JPRB, &
  & 0.88268268E-10_JPRB, 0.88270120E-10_JPRB, 0.88271418E-10_JPRB, 0.88272681E-10_JPRB, 0.88273153E-10_JPRB, 0.88273888E-10_JPRB, &
  & 0.88274610E-10_JPRB, 0.88273958E-10_JPRB, 0.88272958E-10_JPRB, 0.88271765E-10_JPRB, 0.88272348E-10_JPRB, 0.88271217E-10_JPRB, &
  & 0.88271862E-10_JPRB, 0.88273069E-10_JPRB, 0.88276685E-10_JPRB, 0.88279668E-10_JPRB, 0.88282687E-10_JPRB, 0.88286670E-10_JPRB, &
  & 0.88288377E-10_JPRB, 0.88290993E-10_JPRB, 0.88293192E-10_JPRB, 0.88294393E-10_JPRB, 0.88294858E-10_JPRB, 0.88293713E-10_JPRB, &
  & 0.88293317E-10_JPRB, 0.88291541E-10_JPRB, 0.88289202E-10_JPRB, 0.88286746E-10_JPRB, 0.88283998E-10_JPRB, 0.88279772E-10_JPRB, &
  & 0.88276206E-10_JPRB, 0.88272771E-10_JPRB, 0.88270412E-10_JPRB, 0.88268858E-10_JPRB, 0.88267747E-10_JPRB, 0.88268198E-10_JPRB, &
  & 0.88269253E-10_JPRB, 0.88271952E-10_JPRB, 0.88274762E-10_JPRB, 0.88276879E-10_JPRB, 0.88279647E-10_JPRB, 0.88280029E-10_JPRB, &
  & 0.88280612E-10_JPRB, 0.88280321E-10_JPRB, 0.88279557E-10_JPRB, 0.88279273E-10_JPRB, 0.88278357E-10_JPRB, 0.88275519E-10_JPRB, &
  & 0.88274249E-10_JPRB, 0.88273520E-10_JPRB, 0.88273049E-10_JPRB, 0.88271356E-10_JPRB, 0.88269905E-10_JPRB, 0.88269163E-10_JPRB, &
  & 0.88268760E-10_JPRB, 0.88267220E-10_JPRB, 0.88266165E-10_JPRB, 0.88266880E-10_JPRB /)

RGHG9(:,82, 3) = (/ &
  & 0.88257485E-10_JPRB, 0.88256916E-10_JPRB, 0.88260607E-10_JPRB, 0.88261801E-10_JPRB, 0.88264729E-10_JPRB, 0.88267220E-10_JPRB, &
  & 0.88270030E-10_JPRB, 0.88271300E-10_JPRB, 0.88273194E-10_JPRB, 0.88273930E-10_JPRB, 0.88274665E-10_JPRB, 0.88275207E-10_JPRB, &
  & 0.88276039E-10_JPRB, 0.88275352E-10_JPRB, 0.88274367E-10_JPRB, 0.88273194E-10_JPRB, 0.88273930E-10_JPRB, 0.88272771E-10_JPRB, &
  & 0.88273382E-10_JPRB, 0.88274527E-10_JPRB, 0.88278093E-10_JPRB, 0.88280862E-10_JPRB, 0.88283700E-10_JPRB, 0.88287495E-10_JPRB, &
  & 0.88288994E-10_JPRB, 0.88291499E-10_JPRB, 0.88293643E-10_JPRB, 0.88294823E-10_JPRB, 0.88295260E-10_JPRB, 0.88294087E-10_JPRB, &
  & 0.88293789E-10_JPRB, 0.88292047E-10_JPRB, 0.88289834E-10_JPRB, 0.88287565E-10_JPRB, 0.88285004E-10_JPRB, 0.88281001E-10_JPRB, &
  & 0.88277663E-10_JPRB, 0.88274471E-10_JPRB, 0.88272264E-10_JPRB, 0.88270780E-10_JPRB, 0.88269642E-10_JPRB, 0.88269995E-10_JPRB, &
  & 0.88270884E-10_JPRB, 0.88273479E-10_JPRB, 0.88276150E-10_JPRB, 0.88278107E-10_JPRB, 0.88280799E-10_JPRB, 0.88281056E-10_JPRB, &
  & 0.88281618E-10_JPRB, 0.88281327E-10_JPRB, 0.88280598E-10_JPRB, 0.88280369E-10_JPRB, 0.88279509E-10_JPRB, 0.88276629E-10_JPRB, &
  & 0.88275387E-10_JPRB, 0.88274756E-10_JPRB, 0.88274360E-10_JPRB, 0.88272674E-10_JPRB, 0.88271244E-10_JPRB, 0.88270571E-10_JPRB, &
  & 0.88270238E-10_JPRB, 0.88268698E-10_JPRB, 0.88267622E-10_JPRB, 0.88267942E-10_JPRB /)

RGHG9(:,83, 3) = (/ &
  & 0.88258435E-10_JPRB, 0.88257943E-10_JPRB, 0.88261648E-10_JPRB, 0.88262744E-10_JPRB, 0.88265659E-10_JPRB, 0.88268337E-10_JPRB, &
  & 0.88270634E-10_JPRB, 0.88272570E-10_JPRB, 0.88273583E-10_JPRB, 0.88274936E-10_JPRB, 0.88275311E-10_JPRB, 0.88276102E-10_JPRB, &
  & 0.88276789E-10_JPRB, 0.88276136E-10_JPRB, 0.88275130E-10_JPRB, 0.88273985E-10_JPRB, 0.88274797E-10_JPRB, 0.88273625E-10_JPRB, &
  & 0.88274256E-10_JPRB, 0.88275304E-10_JPRB, 0.88278863E-10_JPRB, 0.88281535E-10_JPRB, 0.88284234E-10_JPRB, 0.88287988E-10_JPRB, &
  & 0.88289320E-10_JPRB, 0.88291777E-10_JPRB, 0.88293907E-10_JPRB, 0.88295073E-10_JPRB, 0.88295503E-10_JPRB, 0.88294295E-10_JPRB, &
  & 0.88294060E-10_JPRB, 0.88292339E-10_JPRB, 0.88290174E-10_JPRB, 0.88287967E-10_JPRB, 0.88285525E-10_JPRB, 0.88281701E-10_JPRB, &
  & 0.88278496E-10_JPRB, 0.88275456E-10_JPRB, 0.88273326E-10_JPRB, 0.88271918E-10_JPRB, 0.88270752E-10_JPRB, 0.88271002E-10_JPRB, &
  & 0.88271793E-10_JPRB, 0.88274332E-10_JPRB, 0.88276934E-10_JPRB, 0.88278766E-10_JPRB, 0.88281479E-10_JPRB, 0.88281646E-10_JPRB, &
  & 0.88282180E-10_JPRB, 0.88281882E-10_JPRB, 0.88281160E-10_JPRB, 0.88280980E-10_JPRB, 0.88280161E-10_JPRB, 0.88277212E-10_JPRB, &
  & 0.88276005E-10_JPRB, 0.88275436E-10_JPRB, 0.88275082E-10_JPRB, 0.88273402E-10_JPRB, 0.88271987E-10_JPRB, 0.88271349E-10_JPRB, &
  & 0.88271078E-10_JPRB, 0.88269538E-10_JPRB, 0.88268469E-10_JPRB, 0.88268691E-10_JPRB /)

RGHG9(:,84, 3) = (/ &
  & 0.88259081E-10_JPRB, 0.88258588E-10_JPRB, 0.88262293E-10_JPRB, 0.88263327E-10_JPRB, 0.88266276E-10_JPRB, 0.88268684E-10_JPRB, &
  & 0.88271584E-10_JPRB, 0.88272653E-10_JPRB, 0.88274568E-10_JPRB, 0.88275207E-10_JPRB, 0.88275956E-10_JPRB, 0.88276476E-10_JPRB, &
  & 0.88277254E-10_JPRB, 0.88276629E-10_JPRB, 0.88275644E-10_JPRB, 0.88274499E-10_JPRB, 0.88275359E-10_JPRB, 0.88274166E-10_JPRB, &
  & 0.88274776E-10_JPRB, 0.88275796E-10_JPRB, 0.88279342E-10_JPRB, 0.88281951E-10_JPRB, 0.88284595E-10_JPRB, 0.88288293E-10_JPRB, &
  & 0.88289522E-10_JPRB, 0.88291964E-10_JPRB, 0.88294087E-10_JPRB, 0.88295239E-10_JPRB, 0.88295676E-10_JPRB, 0.88294441E-10_JPRB, &
  & 0.88294219E-10_JPRB, 0.88292491E-10_JPRB, 0.88290340E-10_JPRB, 0.88288217E-10_JPRB, 0.88285768E-10_JPRB, 0.88282145E-10_JPRB, &
  & 0.88279023E-10_JPRB, 0.88276081E-10_JPRB, 0.88274055E-10_JPRB, 0.88272598E-10_JPRB, 0.88271501E-10_JPRB, 0.88271668E-10_JPRB, &
  & 0.88272355E-10_JPRB, 0.88274825E-10_JPRB, 0.88277420E-10_JPRB, 0.88279203E-10_JPRB, 0.88281903E-10_JPRB, 0.88282000E-10_JPRB, &
  & 0.88282520E-10_JPRB, 0.88282229E-10_JPRB, 0.88281507E-10_JPRB, 0.88281368E-10_JPRB, 0.88280570E-10_JPRB, 0.88277580E-10_JPRB, &
  & 0.88276379E-10_JPRB, 0.88275838E-10_JPRB, 0.88275540E-10_JPRB, 0.88273860E-10_JPRB, 0.88272445E-10_JPRB, 0.88271834E-10_JPRB, &
  & 0.88271584E-10_JPRB, 0.88270051E-10_JPRB, 0.88269024E-10_JPRB, 0.88269198E-10_JPRB /)

RGHG9(:,85, 3) = (/ &
  & 0.88259511E-10_JPRB, 0.88259011E-10_JPRB, 0.88262703E-10_JPRB, 0.88263709E-10_JPRB, 0.88266609E-10_JPRB, 0.88269510E-10_JPRB, &
  & 0.88271578E-10_JPRB, 0.88273576E-10_JPRB, 0.88274499E-10_JPRB, 0.88275692E-10_JPRB, 0.88276136E-10_JPRB, 0.88276816E-10_JPRB, &
  & 0.88277372E-10_JPRB, 0.88276886E-10_JPRB, 0.88275977E-10_JPRB, 0.88274894E-10_JPRB, 0.88275692E-10_JPRB, 0.88274527E-10_JPRB, &
  & 0.88275151E-10_JPRB, 0.88276088E-10_JPRB, 0.88279668E-10_JPRB, 0.88282229E-10_JPRB, 0.88284775E-10_JPRB, 0.88288522E-10_JPRB, &
  & 0.88289619E-10_JPRB, 0.88292068E-10_JPRB, 0.88294184E-10_JPRB, 0.88295357E-10_JPRB, 0.88295794E-10_JPRB, 0.88294518E-10_JPRB, &
  & 0.88294330E-10_JPRB, 0.88292595E-10_JPRB, 0.88290479E-10_JPRB, 0.88288335E-10_JPRB, 0.88286010E-10_JPRB, 0.88282354E-10_JPRB, &
  & 0.88279356E-10_JPRB, 0.88276511E-10_JPRB, 0.88274471E-10_JPRB, 0.88273139E-10_JPRB, 0.88271987E-10_JPRB, 0.88272098E-10_JPRB, &
  & 0.88272743E-10_JPRB, 0.88275186E-10_JPRB, 0.88277725E-10_JPRB, 0.88279481E-10_JPRB, 0.88282201E-10_JPRB, 0.88282222E-10_JPRB, &
  & 0.88282735E-10_JPRB, 0.88282444E-10_JPRB, 0.88281722E-10_JPRB, 0.88281618E-10_JPRB, 0.88280834E-10_JPRB, 0.88277781E-10_JPRB, &
  & 0.88276601E-10_JPRB, 0.88276095E-10_JPRB, 0.88275831E-10_JPRB, 0.88274152E-10_JPRB, 0.88272722E-10_JPRB, 0.88272119E-10_JPRB, &
  & 0.88271918E-10_JPRB, 0.88270384E-10_JPRB, 0.88269378E-10_JPRB, 0.88269551E-10_JPRB /)

RGHG9(:,86, 3) = (/ &
  & 0.88259774E-10_JPRB, 0.88259247E-10_JPRB, 0.88262987E-10_JPRB, 0.88263945E-10_JPRB, 0.88267130E-10_JPRB, 0.88269447E-10_JPRB, &
  & 0.88272487E-10_JPRB, 0.88273520E-10_JPRB, 0.88275040E-10_JPRB, 0.88275720E-10_JPRB, 0.88276352E-10_JPRB, 0.88276858E-10_JPRB, &
  & 0.88277344E-10_JPRB, 0.88276990E-10_JPRB, 0.88276206E-10_JPRB, 0.88275241E-10_JPRB, 0.88275887E-10_JPRB, 0.88274769E-10_JPRB, &
  & 0.88275359E-10_JPRB, 0.88276275E-10_JPRB, 0.88279842E-10_JPRB, 0.88282368E-10_JPRB, 0.88284907E-10_JPRB, 0.88288682E-10_JPRB, &
  & 0.88289674E-10_JPRB, 0.88292117E-10_JPRB, 0.88294261E-10_JPRB, 0.88295433E-10_JPRB, 0.88295878E-10_JPRB, 0.88294573E-10_JPRB, &
  & 0.88294413E-10_JPRB, 0.88292665E-10_JPRB, 0.88290548E-10_JPRB, 0.88288488E-10_JPRB, 0.88286094E-10_JPRB, 0.88282638E-10_JPRB, &
  & 0.88279543E-10_JPRB, 0.88276719E-10_JPRB, 0.88274804E-10_JPRB, 0.88273354E-10_JPRB, 0.88272285E-10_JPRB, 0.88272369E-10_JPRB, &
  & 0.88272986E-10_JPRB, 0.88275387E-10_JPRB, 0.88277968E-10_JPRB, 0.88279641E-10_JPRB, 0.88282395E-10_JPRB, 0.88282361E-10_JPRB, &
  & 0.88282853E-10_JPRB, 0.88282583E-10_JPRB, 0.88281854E-10_JPRB, 0.88281778E-10_JPRB, 0.88281008E-10_JPRB, 0.88277927E-10_JPRB, &
  & 0.88276726E-10_JPRB, 0.88276261E-10_JPRB, 0.88276039E-10_JPRB, 0.88274325E-10_JPRB, 0.88272896E-10_JPRB, 0.88272320E-10_JPRB, &
  & 0.88272126E-10_JPRB, 0.88270599E-10_JPRB, 0.88269600E-10_JPRB, 0.88269766E-10_JPRB /)

RGHG9(:,87, 3) = (/ &
  & 0.88259934E-10_JPRB, 0.88259407E-10_JPRB, 0.88263140E-10_JPRB, 0.88264215E-10_JPRB, 0.88267123E-10_JPRB, 0.88270433E-10_JPRB, &
  & 0.88272251E-10_JPRB, 0.88274069E-10_JPRB, 0.88274971E-10_JPRB, 0.88275873E-10_JPRB, 0.88276358E-10_JPRB, 0.88276865E-10_JPRB, &
  & 0.88277261E-10_JPRB, 0.88276997E-10_JPRB, 0.88276345E-10_JPRB, 0.88275498E-10_JPRB, 0.88276005E-10_JPRB, 0.88274978E-10_JPRB, &
  & 0.88275505E-10_JPRB, 0.88276352E-10_JPRB, 0.88279953E-10_JPRB, 0.88282479E-10_JPRB, 0.88284956E-10_JPRB, 0.88288793E-10_JPRB, &
  & 0.88289709E-10_JPRB, 0.88292179E-10_JPRB, 0.88294323E-10_JPRB, 0.88295496E-10_JPRB, 0.88295954E-10_JPRB, 0.88294615E-10_JPRB, &
  & 0.88294483E-10_JPRB, 0.88292720E-10_JPRB, 0.88290653E-10_JPRB, 0.88288571E-10_JPRB, 0.88286378E-10_JPRB, 0.88282687E-10_JPRB, &
  & 0.88279738E-10_JPRB, 0.88276844E-10_JPRB, 0.88274846E-10_JPRB, 0.88273562E-10_JPRB, 0.88272348E-10_JPRB, 0.88272473E-10_JPRB, &
  & 0.88273076E-10_JPRB, 0.88275616E-10_JPRB, 0.88278121E-10_JPRB, 0.88279779E-10_JPRB, 0.88282527E-10_JPRB, 0.88282451E-10_JPRB, &
  & 0.88282943E-10_JPRB, 0.88282652E-10_JPRB, 0.88281937E-10_JPRB, 0.88281868E-10_JPRB, 0.88281105E-10_JPRB, 0.88277982E-10_JPRB, &
  & 0.88276796E-10_JPRB, 0.88276352E-10_JPRB, 0.88276143E-10_JPRB, 0.88274409E-10_JPRB, 0.88272979E-10_JPRB, 0.88272424E-10_JPRB, &
  & 0.88272251E-10_JPRB, 0.88270724E-10_JPRB, 0.88269732E-10_JPRB, 0.88269898E-10_JPRB /)

RGHG9(:,88, 3) = (/ &
  & 0.88260038E-10_JPRB, 0.88259573E-10_JPRB, 0.88263216E-10_JPRB, 0.88264215E-10_JPRB, 0.88267657E-10_JPRB, 0.88269905E-10_JPRB, &
  & 0.88272868E-10_JPRB, 0.88273909E-10_JPRB, 0.88275200E-10_JPRB, 0.88275873E-10_JPRB, 0.88276428E-10_JPRB, 0.88276900E-10_JPRB, &
  & 0.88277274E-10_JPRB, 0.88277038E-10_JPRB, 0.88276400E-10_JPRB, 0.88275609E-10_JPRB, 0.88276074E-10_JPRB, 0.88275068E-10_JPRB, &
  & 0.88275581E-10_JPRB, 0.88276435E-10_JPRB, 0.88280015E-10_JPRB, 0.88282548E-10_JPRB, 0.88284983E-10_JPRB, 0.88288883E-10_JPRB, &
  & 0.88289702E-10_JPRB, 0.88292179E-10_JPRB, 0.88294351E-10_JPRB, 0.88295538E-10_JPRB, 0.88296016E-10_JPRB, 0.88294629E-10_JPRB, &
  & 0.88294545E-10_JPRB, 0.88292769E-10_JPRB, 0.88290715E-10_JPRB, 0.88288724E-10_JPRB, 0.88286475E-10_JPRB, 0.88282881E-10_JPRB, &
  & 0.88279759E-10_JPRB, 0.88276837E-10_JPRB, 0.88274950E-10_JPRB, 0.88273569E-10_JPRB, 0.88272334E-10_JPRB, 0.88272514E-10_JPRB, &
  & 0.88273118E-10_JPRB, 0.88275720E-10_JPRB, 0.88278287E-10_JPRB, 0.88279863E-10_JPRB, 0.88282624E-10_JPRB, 0.88282492E-10_JPRB, &
  & 0.88282978E-10_JPRB, 0.88282708E-10_JPRB, 0.88281986E-10_JPRB, 0.88281930E-10_JPRB, 0.88281153E-10_JPRB, 0.88277996E-10_JPRB, &
  & 0.88276830E-10_JPRB, 0.88276407E-10_JPRB, 0.88276227E-10_JPRB, 0.88274485E-10_JPRB, 0.88273042E-10_JPRB, 0.88272480E-10_JPRB, &
  & 0.88272341E-10_JPRB, 0.88270807E-10_JPRB, 0.88269822E-10_JPRB, 0.88269995E-10_JPRB /)

RGHG9(:,89, 3) = (/ &
  & 0.88260101E-10_JPRB, 0.88259761E-10_JPRB, 0.88263202E-10_JPRB, 0.88264299E-10_JPRB, 0.88267185E-10_JPRB, 0.88270509E-10_JPRB, &
  & 0.88272362E-10_JPRB, 0.88274152E-10_JPRB, 0.88275096E-10_JPRB, 0.88275984E-10_JPRB, 0.88276497E-10_JPRB, 0.88276997E-10_JPRB, &
  & 0.88277399E-10_JPRB, 0.88277136E-10_JPRB, 0.88276435E-10_JPRB, 0.88275588E-10_JPRB, 0.88276164E-10_JPRB, 0.88275082E-10_JPRB, &
  & 0.88275623E-10_JPRB, 0.88276421E-10_JPRB, 0.88280071E-10_JPRB, 0.88282583E-10_JPRB, 0.88284977E-10_JPRB, 0.88288953E-10_JPRB, &
  & 0.88289688E-10_JPRB, 0.88292200E-10_JPRB, 0.88294386E-10_JPRB, 0.88295586E-10_JPRB, 0.88296072E-10_JPRB, 0.88294635E-10_JPRB, &
  & 0.88294601E-10_JPRB, 0.88292818E-10_JPRB, 0.88290784E-10_JPRB, 0.88288779E-10_JPRB, 0.88286739E-10_JPRB, 0.88282805E-10_JPRB, &
  & 0.88279828E-10_JPRB, 0.88276809E-10_JPRB, 0.88274922E-10_JPRB, 0.88273652E-10_JPRB, 0.88272244E-10_JPRB, 0.88272514E-10_JPRB, &
  & 0.88273076E-10_JPRB, 0.88275852E-10_JPRB, 0.88278371E-10_JPRB, 0.88279911E-10_JPRB, 0.88282708E-10_JPRB, 0.88282527E-10_JPRB, &
  & 0.88282992E-10_JPRB, 0.88282721E-10_JPRB, 0.88282007E-10_JPRB, 0.88281965E-10_JPRB, 0.88281216E-10_JPRB, 0.88278003E-10_JPRB, &
  & 0.88276858E-10_JPRB, 0.88276469E-10_JPRB, 0.88276289E-10_JPRB, 0.88274520E-10_JPRB, 0.88273083E-10_JPRB, 0.88272500E-10_JPRB, &
  & 0.88272396E-10_JPRB, 0.88270856E-10_JPRB, 0.88269850E-10_JPRB, 0.88270044E-10_JPRB /)

RGHG9(:,90, 3) = (/ &
  & 0.88260121E-10_JPRB, 0.88259899E-10_JPRB, 0.88263098E-10_JPRB, 0.88264097E-10_JPRB, 0.88267282E-10_JPRB, 0.88269662E-10_JPRB, &
  & 0.88272625E-10_JPRB, 0.88273777E-10_JPRB, 0.88275234E-10_JPRB, 0.88276067E-10_JPRB, 0.88276643E-10_JPRB, 0.88277219E-10_JPRB, &
  & 0.88277725E-10_JPRB, 0.88277302E-10_JPRB, 0.88276414E-10_JPRB, 0.88275436E-10_JPRB, 0.88276303E-10_JPRB, 0.88275005E-10_JPRB, &
  & 0.88275616E-10_JPRB, 0.88276358E-10_JPRB, 0.88280112E-10_JPRB, 0.88282603E-10_JPRB, 0.88284935E-10_JPRB, 0.88289064E-10_JPRB, &
  & 0.88289639E-10_JPRB, 0.88292214E-10_JPRB, 0.88294407E-10_JPRB, 0.88295621E-10_JPRB, 0.88296148E-10_JPRB, 0.88294608E-10_JPRB, &
  & 0.88294677E-10_JPRB, 0.88292845E-10_JPRB, 0.88290777E-10_JPRB, 0.88288842E-10_JPRB, 0.88286871E-10_JPRB, 0.88282832E-10_JPRB, &
  & 0.88279807E-10_JPRB, 0.88276754E-10_JPRB, 0.88274915E-10_JPRB, 0.88273652E-10_JPRB, 0.88272153E-10_JPRB, 0.88272507E-10_JPRB, &
  & 0.88273014E-10_JPRB, 0.88275914E-10_JPRB, 0.88278454E-10_JPRB, 0.88279911E-10_JPRB, 0.88282825E-10_JPRB, 0.88282534E-10_JPRB, &
  & 0.88283034E-10_JPRB, 0.88282763E-10_JPRB, 0.88282007E-10_JPRB, 0.88282000E-10_JPRB, 0.88281292E-10_JPRB, 0.88277947E-10_JPRB, &
  & 0.88276830E-10_JPRB, 0.88276469E-10_JPRB, 0.88276345E-10_JPRB, 0.88274527E-10_JPRB, 0.88273062E-10_JPRB, 0.88272493E-10_JPRB, &
  & 0.88272438E-10_JPRB, 0.88270828E-10_JPRB, 0.88269836E-10_JPRB, 0.88270072E-10_JPRB /)

RGHG9(:,91, 3) = (/ &
  & 0.88260135E-10_JPRB, 0.88259969E-10_JPRB, 0.88262939E-10_JPRB, 0.88263868E-10_JPRB, 0.88267026E-10_JPRB, 0.88269468E-10_JPRB, &
  & 0.88272230E-10_JPRB, 0.88273465E-10_JPRB, 0.88275158E-10_JPRB, 0.88276352E-10_JPRB, 0.88276650E-10_JPRB, 0.88277378E-10_JPRB, &
  & 0.88278482E-10_JPRB, 0.88277455E-10_JPRB, 0.88276338E-10_JPRB, 0.88274978E-10_JPRB, 0.88276622E-10_JPRB, 0.88274783E-10_JPRB, &
  & 0.88275616E-10_JPRB, 0.88276150E-10_JPRB, 0.88280203E-10_JPRB, 0.88282624E-10_JPRB, 0.88284838E-10_JPRB, 0.88289293E-10_JPRB, &
  & 0.88289515E-10_JPRB, 0.88292228E-10_JPRB, 0.88294497E-10_JPRB, 0.88295683E-10_JPRB, 0.88296329E-10_JPRB, 0.88294476E-10_JPRB, &
  & 0.88294858E-10_JPRB, 0.88292908E-10_JPRB, 0.88290791E-10_JPRB, 0.88288814E-10_JPRB, 0.88287107E-10_JPRB, 0.88282673E-10_JPRB, &
  & 0.88279779E-10_JPRB, 0.88276636E-10_JPRB, 0.88274880E-10_JPRB, 0.88273694E-10_JPRB, 0.88272015E-10_JPRB, 0.88272487E-10_JPRB, &
  & 0.88272854E-10_JPRB, 0.88275956E-10_JPRB, 0.88278544E-10_JPRB, 0.88279835E-10_JPRB, 0.88283041E-10_JPRB, 0.88282485E-10_JPRB, &
  & 0.88283075E-10_JPRB, 0.88282798E-10_JPRB, 0.88281958E-10_JPRB, 0.88282041E-10_JPRB, 0.88281465E-10_JPRB, 0.88277774E-10_JPRB, &
  & 0.88276782E-10_JPRB, 0.88276469E-10_JPRB, 0.88276463E-10_JPRB, 0.88274499E-10_JPRB, 0.88272979E-10_JPRB, 0.88272466E-10_JPRB, &
  & 0.88272535E-10_JPRB, 0.88270738E-10_JPRB, 0.88269787E-10_JPRB, 0.88270079E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART6',1,ZHOOK_HANDLE)
END SUBROUTINE PART6






SUBROUTINE PART7
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART7',0,ZHOOK_HANDLE)



!-- Month=  4 ------------

RGHG9(:, 1, 4) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.42038954E-44_JPRB, &
  & 0.56051939E-44_JPRB, 0.70064923E-44_JPRB, 0.11210388E-43_JPRB, 0.14012985E-43_JPRB, 0.15414283E-43_JPRB, 0.16815582E-43_JPRB, &
  & 0.15414283E-43_JPRB, 0.15414283E-43_JPRB, 0.15414283E-43_JPRB, 0.12611686E-43_JPRB, 0.98090893E-44_JPRB, 0.70064923E-44_JPRB, &
  & 0.70064923E-44_JPRB, 0.42038954E-44_JPRB, 0.42038954E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 2, 4) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, &
  & 0.70064923E-44_JPRB, 0.15414283E-43_JPRB, 0.28025969E-43_JPRB, 0.49045446E-43_JPRB, 0.79874012E-43_JPRB, 0.12751816E-42_JPRB, &
  & 0.19898438E-42_JPRB, 0.29006878E-42_JPRB, 0.41478435E-42_JPRB, 0.52408563E-42_JPRB, 0.61096613E-42_JPRB, 0.67962976E-42_JPRB, &
  & 0.68103105E-42_JPRB, 0.67122196E-42_JPRB, 0.59555185E-42_JPRB, 0.50026355E-42_JPRB, 0.40637655E-42_JPRB, 0.30828566E-42_JPRB, &
  & 0.26764801E-42_JPRB, 0.18216880E-42_JPRB, 0.14573504E-42_JPRB, 0.98090893E-43_JPRB, 0.49045446E-43_JPRB, 0.26624671E-43_JPRB, &
  & 0.16815582E-43_JPRB, 0.98090893E-44_JPRB, 0.42038954E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 3, 4) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.28025969E-44_JPRB, 0.84077908E-44_JPRB, 0.18216880E-43_JPRB, 0.39236357E-43_JPRB, 0.85479206E-43_JPRB, 0.17796490E-42_JPRB, &
  & 0.36714020E-42_JPRB, 0.69924793E-42_JPRB, 0.12919972E-41_JPRB, 0.22701035E-41_JPRB, 0.38045253E-41_JPRB, 0.61685158E-41_JPRB, &
  & 0.96255192E-41_JPRB, 0.13951328E-40_JPRB, 0.19678434E-40_JPRB, 0.24788970E-40_JPRB, 0.28903182E-40_JPRB, 0.32106550E-40_JPRB, &
  & 0.32389613E-40_JPRB, 0.31910369E-40_JPRB, 0.28358077E-40_JPRB, 0.23809462E-40_JPRB, 0.19358938E-40_JPRB, 0.14758475E-40_JPRB, &
  & 0.12688758E-40_JPRB, 0.87567141E-41_JPRB, 0.69966832E-41_JPRB, 0.47391914E-41_JPRB, 0.23948191E-41_JPRB, 0.12471556E-41_JPRB, &
  & 0.79033233E-42_JPRB, 0.43019863E-42_JPRB, 0.19197789E-42_JPRB, 0.72867520E-43_JPRB, 0.28025969E-43_JPRB, 0.98090893E-44_JPRB, &
  & 0.42038954E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 4, 4) = (/ &
  & 0.00000000E+00_JPRB, 0.28025969E-44_JPRB, 0.56051939E-44_JPRB, 0.84077908E-44_JPRB, 0.11210388E-43_JPRB, 0.12611686E-43_JPRB, &
  & 0.18216880E-43_JPRB, 0.23822074E-43_JPRB, 0.35032462E-43_JPRB, 0.57453237E-43_JPRB, 0.98090893E-43_JPRB, 0.18497140E-42_JPRB, &
  & 0.35873241E-42_JPRB, 0.73428040E-42_JPRB, 0.16339140E-41_JPRB, 0.34009514E-41_JPRB, 0.74633156E-41_JPRB, 0.15269949E-40_JPRB, &
  & 0.31264370E-40_JPRB, 0.59783596E-40_JPRB, 0.11172973E-39_JPRB, 0.19918617E-39_JPRB, 0.33615749E-39_JPRB, 0.55004048E-39_JPRB, &
  & 0.85428339E-39_JPRB, 0.12344136E-38_JPRB, 0.17348453E-38_JPRB, 0.21827718E-38_JPRB, 0.25445366E-38_JPRB, 0.28259664E-38_JPRB, &
  & 0.28485960E-38_JPRB, 0.28055214E-38_JPRB, 0.24906959E-38_JPRB, 0.20952032E-38_JPRB, 0.17048589E-38_JPRB, 0.13039699E-38_JPRB, &
  & 0.11217927E-38_JPRB, 0.77985623E-39_JPRB, 0.62616461E-39_JPRB, 0.42882676E-39_JPRB, 0.21423892E-39_JPRB, 0.10963479E-39_JPRB, &
  & 0.70322762E-40_JPRB, 0.37753783E-40_JPRB, 0.16189201E-40_JPRB, 0.58952626E-41_JPRB, 0.23191490E-41_JPRB, 0.89823232E-42_JPRB, &
  & 0.33210774E-42_JPRB, 0.12891946E-42_JPRB, 0.54650640E-43_JPRB, 0.25223372E-43_JPRB, 0.12611686E-43_JPRB, 0.56051939E-44_JPRB, &
  & 0.28025969E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 5, 4) = (/ &
  & 0.39376487E-42_JPRB, 0.10089349E-41_JPRB, 0.14937842E-41_JPRB, 0.18847464E-41_JPRB, 0.23485762E-41_JPRB, 0.29959761E-41_JPRB, &
  & 0.39348461E-41_JPRB, 0.53851900E-41_JPRB, 0.79229415E-41_JPRB, 0.12580858E-40_JPRB, 0.21302539E-40_JPRB, 0.40165418E-40_JPRB, &
  & 0.76566948E-40_JPRB, 0.15498361E-39_JPRB, 0.33883537E-39_JPRB, 0.68988726E-39_JPRB, 0.14806148E-38_JPRB, 0.29582027E-38_JPRB, &
  & 0.59406227E-38_JPRB, 0.11153040E-37_JPRB, 0.20566265E-37_JPRB, 0.36216267E-37_JPRB, 0.60450228E-37_JPRB, 0.97496383E-37_JPRB, &
  & 0.15000547E-36_JPRB, 0.21407540E-36_JPRB, 0.29951499E-36_JPRB, 0.37477382E-36_JPRB, 0.43426360E-36_JPRB, 0.48022664E-36_JPRB, &
  & 0.48137154E-36_JPRB, 0.47317320E-36_JPRB, 0.42051146E-36_JPRB, 0.35490590E-36_JPRB, 0.29084432E-36_JPRB, 0.22409621E-36_JPRB, &
  & 0.19487678E-36_JPRB, 0.13695668E-36_JPRB, 0.11162531E-36_JPRB, 0.77686047E-37_JPRB, 0.39147122E-37_JPRB, 0.20128247E-37_JPRB, &
  & 0.13258980E-37_JPRB, 0.71607613E-38_JPRB, 0.30667823E-38_JPRB, 0.11144723E-38_JPRB, 0.45190054E-39_JPRB, 0.18091744E-39_JPRB, &
  & 0.69016752E-40_JPRB, 0.27763926E-40_JPRB, 0.12042759E-40_JPRB, 0.56514367E-41_JPRB, 0.28474385E-41_JPRB, 0.15512374E-41_JPRB, &
  & 0.91644920E-42_JPRB, 0.58854536E-42_JPRB, 0.41058045E-42_JPRB, 0.30968696E-42_JPRB, 0.25223372E-42_JPRB, 0.22280646E-42_JPRB, &
  & 0.21439867E-42_JPRB, 0.21439867E-42_JPRB, 0.20318828E-42_JPRB, 0.14293244E-42_JPRB /)

RGHG9(:, 6, 4) = (/ &
  & 0.34109006E-39_JPRB, 0.62617022E-39_JPRB, 0.81972737E-39_JPRB, 0.10110228E-38_JPRB, 0.12451209E-38_JPRB, 0.15681609E-38_JPRB, &
  & 0.20286794E-38_JPRB, 0.27222297E-38_JPRB, 0.39159230E-38_JPRB, 0.60516910E-38_JPRB, 0.99318780E-38_JPRB, 0.18115364E-37_JPRB, &
  & 0.33248710E-37_JPRB, 0.64627112E-37_JPRB, 0.13582101E-36_JPRB, 0.26459452E-36_JPRB, 0.54396245E-36_JPRB, 0.10386627E-35_JPRB, &
  & 0.19961317E-35_JPRB, 0.35869449E-35_JPRB, 0.63475518E-35_JPRB, 0.10757132E-34_JPRB, 0.17317620E-34_JPRB, 0.27060046E-34_JPRB, &
  & 0.40481124E-34_JPRB, 0.56394847E-34_JPRB, 0.77680346E-34_JPRB, 0.95653689E-34_JPRB, 0.10928574E-33_JPRB, 0.11958383E-33_JPRB, &
  & 0.11884584E-33_JPRB, 0.11654096E-33_JPRB, 0.10376608E-33_JPRB, 0.88310109E-34_JPRB, 0.73272518E-34_JPRB, 0.57343588E-34_JPRB, &
  & 0.50993835E-34_JPRB, 0.36547371E-34_JPRB, 0.30701990E-34_JPRB, 0.22000784E-34_JPRB, 0.11399031E-34_JPRB, 0.60727291E-35_JPRB, &
  & 0.41968736E-35_JPRB, 0.23578977E-35_JPRB, 0.10453784E-35_JPRB, 0.39595184E-36_JPRB, 0.16893636E-36_JPRB, 0.71049980E-37_JPRB, &
  & 0.28456384E-37_JPRB, 0.12000325E-37_JPRB, 0.54439773E-38_JPRB, 0.26643644E-38_JPRB, 0.13952925E-38_JPRB, 0.78784783E-39_JPRB, &
  & 0.47965886E-39_JPRB, 0.31660237E-39_JPRB, 0.22621161E-39_JPRB, 0.17434115E-39_JPRB, 0.14468687E-39_JPRB, 0.12920392E-39_JPRB, &
  & 0.12619814E-39_JPRB, 0.13114892E-39_JPRB, 0.14106732E-39_JPRB, 0.14582753E-39_JPRB /)

RGHG9(:, 7, 4) = (/ &
  & 0.27232429E-36_JPRB, 0.46791490E-36_JPRB, 0.60098346E-36_JPRB, 0.73329738E-36_JPRB, 0.89025339E-36_JPRB, 0.10994928E-35_JPRB, &
  & 0.13876537E-35_JPRB, 0.18075697E-35_JPRB, 0.25083151E-35_JPRB, 0.37196866E-35_JPRB, 0.58166810E-35_JPRB, 0.10075858E-34_JPRB, &
  & 0.17445150E-34_JPRB, 0.31890312E-34_JPRB, 0.63235942E-34_JPRB, 0.11583072E-33_JPRB, 0.22473882E-33_JPRB, 0.40477230E-33_JPRB, &
  & 0.73515812E-33_JPRB, 0.12500791E-32_JPRB, 0.20998948E-32_JPRB, 0.33911352E-32_JPRB, 0.52153463E-32_JPRB, 0.78330756E-32_JPRB, &
  & 0.11302457E-31_JPRB, 0.15256203E-31_JPRB, 0.20516065E-31_JPRB, 0.24716029E-31_JPRB, 0.27714442E-31_JPRB, 0.29942439E-31_JPRB, &
  & 0.29508540E-31_JPRB, 0.28879298E-31_JPRB, 0.25814235E-31_JPRB, 0.22180135E-31_JPRB, 0.18686992E-31_JPRB, 0.14898035E-31_JPRB, &
  & 0.13626691E-31_JPRB, 0.99992993E-32_JPRB, 0.87277443E-32_JPRB, 0.64892115E-32_JPRB, 0.34752142E-32_JPRB, 0.19513811E-32_JPRB, &
  & 0.14330359E-32_JPRB, 0.85096663E-33_JPRB, 0.39963979E-33_JPRB, 0.16063972E-33_JPRB, 0.73299311E-34_JPRB, 0.32920839E-34_JPRB, &
  & 0.14016067E-34_JPRB, 0.62928667E-35_JPRB, 0.30401962E-35_JPRB, 0.15830108E-35_JPRB, 0.87979482E-36_JPRB, 0.52543276E-36_JPRB, &
  & 0.33683399E-36_JPRB, 0.23285639E-36_JPRB, 0.17314995E-36_JPRB, 0.13819501E-36_JPRB, 0.11791337E-36_JPRB, 0.10785576E-36_JPRB, &
  & 0.10725916E-36_JPRB, 0.11312413E-36_JPRB, 0.12481129E-36_JPRB, 0.13879638E-36_JPRB /)

RGHG9(:, 8, 4) = (/ &
  & 0.18175199E-33_JPRB, 0.30943993E-33_JPRB, 0.39504747E-33_JPRB, 0.47767361E-33_JPRB, 0.57224130E-33_JPRB, 0.69373053E-33_JPRB, &
  & 0.85507810E-33_JPRB, 0.10815605E-32_JPRB, 0.14494538E-32_JPRB, 0.20626172E-32_JPRB, 0.30727463E-32_JPRB, 0.50510860E-32_JPRB, &
  & 0.82344342E-32_JPRB, 0.14108097E-31_JPRB, 0.26360061E-31_JPRB, 0.45189823E-31_JPRB, 0.82775573E-31_JPRB, 0.14029953E-30_JPRB, &
  & 0.24132398E-30_JPRB, 0.38830505E-30_JPRB, 0.61999968E-30_JPRB, 0.95450113E-30_JPRB, 0.14038553E-29_JPRB, 0.20201057E-29_JPRB, &
  & 0.28122954E-29_JPRB, 0.36642566E-29_JPRB, 0.48001167E-29_JPRB, 0.56445749E-29_JPRB, 0.62113347E-29_JPRB, 0.66233656E-29_JPRB, &
  & 0.64777856E-29_JPRB, 0.63296944E-29_JPRB, 0.56799229E-29_JPRB, 0.49288418E-29_JPRB, 0.42166762E-29_JPRB, 0.34261827E-29_JPRB, &
  & 0.32270965E-29_JPRB, 0.24270343E-29_JPRB, 0.22063905E-29_JPRB, 0.17025520E-29_JPRB, 0.94789419E-30_JPRB, 0.56097741E-30_JPRB, &
  & 0.43876775E-30_JPRB, 0.27626330E-30_JPRB, 0.13765563E-30_JPRB, 0.58891650E-31_JPRB, 0.28834259E-31_JPRB, 0.13839982E-31_JPRB, &
  & 0.62778393E-32_JPRB, 0.30092846E-32_JPRB, 0.15549151E-32_JPRB, 0.86558996E-33_JPRB, 0.51289794E-33_JPRB, 0.32537443E-33_JPRB, &
  & 0.22046938E-33_JPRB, 0.16020169E-33_JPRB, 0.12446836E-33_JPRB, 0.10305716E-33_JPRB, 0.90726651E-34_JPRB, 0.85068230E-34_JPRB, &
  & 0.86264221E-34_JPRB, 0.92290828E-34_JPRB, 0.10281749E-33_JPRB, 0.11586095E-33_JPRB /)

RGHG9(:, 9, 4) = (/ &
  & 0.99265220E-31_JPRB, 0.16846321E-30_JPRB, 0.21397846E-30_JPRB, 0.25718545E-30_JPRB, 0.30503940E-30_JPRB, 0.36446287E-30_JPRB, &
  & 0.44072372E-30_JPRB, 0.54425210E-30_JPRB, 0.70804318E-30_JPRB, 0.97235614E-30_JPRB, 0.13872465E-29_JPRB, 0.21741705E-29_JPRB, &
  & 0.33517324E-29_JPRB, 0.54015609E-29_JPRB, 0.95264695E-29_JPRB, 0.15313283E-28_JPRB, 0.26510098E-28_JPRB, 0.42347847E-28_JPRB, &
  & 0.69109492E-28_JPRB, 0.10539195E-27_JPRB, 0.16022442E-27_JPRB, 0.23538246E-27_JPRB, 0.33052169E-27_JPRB, 0.45661560E-27_JPRB, &
  & 0.61093175E-27_JPRB, 0.76977258E-27_JPRB, 0.97940741E-27_JPRB, 0.11251691E-26_JPRB, 0.12150853E-26_JPRB, 0.12789196E-26_JPRB, &
  & 0.12413780E-26_JPRB, 0.12104729E-26_JPRB, 0.10902461E-26_JPRB, 0.95485893E-27_JPRB, 0.82928656E-27_JPRB, 0.68697035E-27_JPRB, &
  & 0.66585181E-27_JPRB, 0.51468663E-27_JPRB, 0.48692078E-27_JPRB, 0.39099349E-27_JPRB, 0.22681061E-27_JPRB, 0.14192276E-27_JPRB, &
  & 0.11786017E-27_JPRB, 0.78671885E-28_JPRB, 0.41604811E-28_JPRB, 0.18913232E-28_JPRB, 0.99268455E-29_JPRB, 0.50950014E-29_JPRB, &
  & 0.24595250E-29_JPRB, 0.12598553E-29_JPRB, 0.69693320E-30_JPRB, 0.41485255E-30_JPRB, 0.26183201E-30_JPRB, 0.17616487E-30_JPRB, &
  & 0.12592046E-30_JPRB, 0.95974329E-31_JPRB, 0.77718808E-31_JPRB, 0.66648955E-31_JPRB, 0.60357168E-31_JPRB, 0.57901114E-31_JPRB, &
  & 0.59785425E-31_JPRB, 0.64819221E-31_JPRB, 0.72934000E-31_JPRB, 0.82892312E-31_JPRB /)

RGHG9(:,10, 4) = (/ &
  & 0.44162356E-28_JPRB, 0.74515445E-28_JPRB, 0.94518298E-28_JPRB, 0.11307570E-27_JPRB, 0.13326655E-27_JPRB, 0.15755695E-27_JPRB, &
  & 0.18780025E-27_JPRB, 0.22757961E-27_JPRB, 0.28900794E-27_JPRB, 0.38506119E-27_JPRB, 0.52908040E-27_JPRB, 0.79448472E-27_JPRB, &
  & 0.11644648E-26_JPRB, 0.17734390E-26_JPRB, 0.29627717E-26_JPRB, 0.44783179E-26_JPRB, 0.73406905E-26_JPRB, 0.11064733E-25_JPRB, &
  & 0.17142521E-25_JPRB, 0.24788487E-25_JPRB, 0.35856218E-25_JPRB, 0.50221042E-25_JPRB, 0.67363544E-25_JPRB, 0.89067709E-25_JPRB, &
  & 0.11475733E-24_JPRB, 0.13958461E-24_JPRB, 0.17263997E-24_JPRB, 0.19368878E-24_JPRB, 0.20536719E-24_JPRB, 0.21329596E-24_JPRB, &
  & 0.20540283E-24_JPRB, 0.19976588E-24_JPRB, 0.18043946E-24_JPRB, 0.15943503E-24_JPRB, 0.14048450E-24_JPRB, 0.11870350E-24_JPRB, &
  & 0.11826378E-24_JPRB, 0.94219661E-25_JPRB, 0.92665537E-25_JPRB, 0.77449747E-25_JPRB, 0.47088439E-25_JPRB, 0.31139015E-25_JPRB, &
  & 0.27407083E-25_JPRB, 0.19403592E-25_JPRB, 0.10889884E-25_JPRB, 0.52578173E-26_JPRB, 0.29604215E-26_JPRB, 0.16240526E-26_JPRB, &
  & 0.83508833E-27_JPRB, 0.45763129E-27_JPRB, 0.27107813E-27_JPRB, 0.17238800E-27_JPRB, 0.11567995E-27_JPRB, 0.82346054E-28_JPRB, &
  & 0.61916433E-28_JPRB, 0.49352861E-28_JPRB, 0.41531945E-28_JPRB, 0.36765945E-28_JPRB, 0.34156259E-28_JPRB, 0.33421394E-28_JPRB, &
  & 0.35056331E-28_JPRB, 0.38450502E-28_JPRB, 0.43677434E-28_JPRB, 0.49988421E-28_JPRB /)

RGHG9(:,11, 4) = (/ &
  & 0.16217481E-25_JPRB, 0.27388144E-25_JPRB, 0.34586035E-25_JPRB, 0.41282604E-25_JPRB, 0.48339211E-25_JPRB, 0.56617650E-25_JPRB, &
  & 0.66606848E-25_JPRB, 0.79348875E-25_JPRB, 0.98567739E-25_JPRB, 0.12772319E-24_JPRB, 0.16953423E-24_JPRB, 0.24456327E-24_JPRB, &
  & 0.34216004E-24_JPRB, 0.49459173E-24_JPRB, 0.78437189E-24_JPRB, 0.11199470E-23_JPRB, 0.17393600E-23_JPRB, 0.24790471E-23_JPRB, &
  & 0.36438885E-23_JPRB, 0.49970323E-23_JPRB, 0.68742925E-23_JPRB, 0.91732107E-23_JPRB, 0.11749763E-22_JPRB, 0.14899102E-22_JPRB, &
  & 0.18469842E-22_JPRB, 0.21745530E-22_JPRB, 0.26144027E-22_JPRB, 0.28682717E-22_JPRB, 0.29874046E-22_JPRB, 0.30620169E-22_JPRB, &
  & 0.29238659E-22_JPRB, 0.28329951E-22_JPRB, 0.25634594E-22_JPRB, 0.22821031E-22_JPRB, 0.20387477E-22_JPRB, 0.17570441E-22_JPRB, &
  & 0.17974361E-22_JPRB, 0.14779113E-22_JPRB, 0.15092697E-22_JPRB, 0.13135328E-22_JPRB, 0.83765179E-23_JPRB, 0.58564907E-23_JPRB, &
  & 0.54591778E-23_JPRB, 0.40974362E-23_JPRB, 0.24407668E-23_JPRB, 0.12524779E-23_JPRB, 0.75604089E-24_JPRB, 0.44352516E-24_JPRB, &
  & 0.24304410E-24_JPRB, 0.14247841E-24_JPRB, 0.90268663E-25_JPRB, 0.61198640E-25_JPRB, 0.43551023E-25_JPRB, 0.32707162E-25_JPRB, &
  & 0.25791527E-25_JPRB, 0.21429943E-25_JPRB, 0.18676716E-25_JPRB, 0.17011168E-25_JPRB, 0.16159113E-25_JPRB, 0.16080298E-25_JPRB, &
  & 0.17085447E-25_JPRB, 0.18935631E-25_JPRB, 0.21658765E-25_JPRB, 0.24957163E-25_JPRB /)

RGHG9(:,12, 4) = (/ &
  & 0.50145797E-23_JPRB, 0.84079170E-23_JPRB, 0.10614155E-22_JPRB, 0.12597211E-22_JPRB, 0.14662065E-22_JPRB, 0.16999609E-22_JPRB, &
  & 0.19739996E-22_JPRB, 0.23126483E-22_JPRB, 0.28124971E-22_JPRB, 0.35490963E-22_JPRB, 0.45583709E-22_JPRB, 0.63319101E-22_JPRB, &
  & 0.84794242E-22_JPRB, 0.11673617E-21_JPRB, 0.17612316E-21_JPRB, 0.23834404E-21_JPRB, 0.35092269E-21_JPRB, 0.47358948E-21_JPRB, &
  & 0.65967518E-21_JPRB, 0.85811951E-21_JPRB, 0.11212810E-20_JPRB, 0.14255610E-20_JPRB, 0.17445635E-20_JPRB, 0.21211449E-20_JPRB, &
  & 0.25340628E-20_JPRB, 0.28869260E-20_JPRB, 0.33780107E-20_JPRB, 0.36243512E-20_JPRB, 0.37082099E-20_JPRB, 0.37502119E-20_JPRB, &
  & 0.35484336E-20_JPRB, 0.34230337E-20_JPRB, 0.31002235E-20_JPRB, 0.27796716E-20_JPRB, 0.25169299E-20_JPRB, 0.22130821E-20_JPRB, &
  & 0.23239361E-20_JPRB, 0.19728587E-20_JPRB, 0.20918047E-20_JPRB, 0.18957756E-20_JPRB, 0.12672773E-20_JPRB, 0.93677841E-21_JPRB, &
  & 0.92546556E-21_JPRB, 0.73635311E-21_JPRB, 0.46554335E-21_JPRB, 0.25397259E-21_JPRB, 0.16446485E-21_JPRB, 0.10309826E-21_JPRB, &
  & 0.60234800E-22_JPRB, 0.37734991E-22_JPRB, 0.25518008E-22_JPRB, 0.18395102E-22_JPRB, 0.13844126E-22_JPRB, 0.10935768E-22_JPRB, &
  & 0.90140106E-23_JPRB, 0.77789148E-23_JPRB, 0.69944683E-23_JPRB, 0.65299484E-23_JPRB, 0.63197710E-23_JPRB, 0.63749723E-23_JPRB, &
  & 0.68465790E-23_JPRB, 0.76397566E-23_JPRB, 0.88020776E-23_JPRB, 0.10173067E-22_JPRB /)

RGHG9(:,13, 4) = (/ &
  & 0.13030713E-20_JPRB, 0.21858801E-20_JPRB, 0.27421098E-20_JPRB, 0.32448458E-20_JPRB, 0.37502349E-20_JPRB, 0.43083496E-20_JPRB, &
  & 0.49406222E-20_JPRB, 0.56953905E-20_JPRB, 0.67861647E-20_JPRB, 0.83476975E-20_JPRB, 0.10390107E-19_JPRB, 0.13919314E-19_JPRB, &
  & 0.17881612E-19_JPRB, 0.23502061E-19_JPRB, 0.33765616E-19_JPRB, 0.43401976E-19_JPRB, 0.60537536E-19_JPRB, 0.77393228E-19_JPRB, &
  & 0.10200140E-18_JPRB, 0.12576436E-18_JPRB, 0.15595942E-18_JPRB, 0.18867394E-18_JPRB, 0.22053147E-18_JPRB, 0.25696536E-18_JPRB, &
  & 0.29552858E-18_JPRB, 0.32560659E-18_JPRB, 0.37038253E-18_JPRB, 0.38820506E-18_JPRB, 0.38977350E-18_JPRB, 0.38871499E-18_JPRB, &
  & 0.36437603E-18_JPRB, 0.35002055E-18_JPRB, 0.31745235E-18_JPRB, 0.28678238E-18_JPRB, 0.26333010E-18_JPRB, 0.23640752E-18_JPRB, &
  & 0.25497894E-18_JPRB, 0.22359537E-18_JPRB, 0.24640351E-18_JPRB, 0.23272344E-18_JPRB, 0.16295808E-18_JPRB, 0.12740961E-18_JPRB, &
  & 0.13361978E-18_JPRB, 0.11270429E-18_JPRB, 0.75646727E-19_JPRB, 0.43952610E-19_JPRB, 0.30501904E-19_JPRB, 0.20436736E-19_JPRB, &
  & 0.12722258E-19_JPRB, 0.85089921E-20_JPRB, 0.61314900E-20_JPRB, 0.46916533E-20_JPRB, 0.37281899E-20_JPRB, 0.30920540E-20_JPRB, &
  & 0.26586227E-20_JPRB, 0.23771870E-20_JPRB, 0.21994918E-20_JPRB, 0.20993836E-20_JPRB, 0.20652214E-20_JPRB, 0.21073979E-20_JPRB, &
  & 0.22818668E-20_JPRB, 0.25641832E-20_JPRB, 0.29631720E-20_JPRB, 0.34357989E-20_JPRB /)

RGHG9(:,14, 4) = (/ &
  & 0.29053310E-18_JPRB, 0.48334707E-18_JPRB, 0.60557117E-18_JPRB, 0.71302514E-18_JPRB, 0.81981245E-18_JPRB, 0.93357465E-18_JPRB, &
  & 0.10578228E-17_JPRB, 0.11999405E-17_JPRB, 0.14003547E-17_JPRB, 0.16785310E-17_JPRB, 0.20237637E-17_JPRB, 0.26139755E-17_JPRB, &
  & 0.32213699E-17_JPRB, 0.40422302E-17_JPRB, 0.55282759E-17_JPRB, 0.67497119E-17_JPRB, 0.89143046E-17_JPRB, 0.10789897E-16_JPRB, &
  & 0.13448851E-16_JPRB, 0.15709000E-16_JPRB, 0.18476106E-16_JPRB, 0.21270648E-16_JPRB, 0.23731782E-16_JPRB, 0.26496119E-16_JPRB, &
  & 0.29322319E-16_JPRB, 0.31214196E-16_JPRB, 0.34485242E-16_JPRB, 0.35263504E-16_JPRB, 0.34705289E-16_JPRB, 0.34116786E-16_JPRB, &
  & 0.31692601E-16_JPRB, 0.30347553E-16_JPRB, 0.27589779E-16_JPRB, 0.25132338E-16_JPRB, 0.23414469E-16_JPRB, 0.21469747E-16_JPRB, &
  & 0.23791056E-16_JPRB, 0.21555503E-16_JPRB, 0.24705213E-16_JPRB, 0.24327703E-16_JPRB, 0.17829931E-16_JPRB, 0.14749004E-16_JPRB, &
  & 0.16423393E-16_JPRB, 0.14681111E-16_JPRB, 0.10465565E-16_JPRB, 0.64782428E-17_JPRB, 0.48166181E-17_JPRB, 0.34438027E-17_JPRB, &
  & 0.22839197E-17_JPRB, 0.16286509E-17_JPRB, 0.12491758E-17_JPRB, 0.10137196E-17_JPRB, 0.85022390E-18_JPRB, 0.74020500E-18_JPRB, &
  & 0.66382562E-18_JPRB, 0.61487985E-18_JPRB, 0.58533596E-18_JPRB, 0.57111889E-18_JPRB, 0.57100593E-18_JPRB, 0.58927158E-18_JPRB, &
  & 0.64363353E-18_JPRB, 0.72658144E-18_JPRB, 0.84415756E-18_JPRB, 0.97851331E-18_JPRB /)

RGHG9(:,15, 4) = (/ &
  & 0.55226753E-16_JPRB, 0.91684977E-16_JPRB, 0.11432621E-15_JPRB, 0.13422322E-15_JPRB, 0.15345691E-15_JPRB, 0.17332265E-15_JPRB, &
  & 0.19408362E-15_JPRB, 0.21662150E-15_JPRB, 0.24751515E-15_JPRB, 0.28891722E-15_JPRB, 0.33722351E-15_JPRB, 0.41963577E-15_JPRB, &
  & 0.49573768E-15_JPRB, 0.59363065E-15_JPRB, 0.77201976E-15_JPRB, 0.89507899E-15_JPRB, 0.11187348E-14_JPRB, 0.12819276E-14_JPRB, &
  & 0.15110835E-14_JPRB, 0.16715996E-14_JPRB, 0.18647765E-14_JPRB, 0.20423650E-14_JPRB, 0.21753526E-14_JPRB, 0.23267292E-14_JPRB, &
  & 0.24773403E-14_JPRB, 0.25464083E-14_JPRB, 0.27303207E-14_JPRB, 0.27208973E-14_JPRB, 0.26220887E-14_JPRB, 0.25391839E-14_JPRB, &
  & 0.23377616E-14_JPRB, 0.22330539E-14_JPRB, 0.20373014E-14_JPRB, 0.18732898E-14_JPRB, 0.17717404E-14_JPRB, 0.16598349E-14_JPRB, &
  & 0.18896661E-14_JPRB, 0.17691045E-14_JPRB, 0.21086491E-14_JPRB, 0.21648117E-14_JPRB, 0.16607031E-14_JPRB, 0.14532144E-14_JPRB, &
  & 0.17161070E-14_JPRB, 0.16247068E-14_JPRB, 0.12299439E-14_JPRB, 0.81179886E-15_JPRB, 0.64525631E-15_JPRB, 0.49201958E-15_JPRB, &
  & 0.34730717E-15_JPRB, 0.26389918E-15_JPRB, 0.21533084E-15_JPRB, 0.18528499E-15_JPRB, 0.16403892E-15_JPRB, 0.14996051E-15_JPRB, &
  & 0.14035153E-15_JPRB, 0.13478136E-15_JPRB, 0.13213628E-15_JPRB, 0.13194956E-15_JPRB, 0.13424781E-15_JPRB, 0.14029109E-15_JPRB, &
  & 0.15459140E-15_JPRB, 0.17571758E-15_JPRB, 0.20464315E-15_JPRB, 0.23786996E-15_JPRB /)

RGHG9(:,16, 4) = (/ &
  & 0.51527809E-15_JPRB, 0.79608799E-15_JPRB, 0.97316431E-15_JPRB, 0.11292186E-14_JPRB, 0.12865861E-14_JPRB, 0.14562636E-14_JPRB, &
  & 0.16460023E-14_JPRB, 0.18575045E-14_JPRB, 0.21445413E-14_JPRB, 0.25296448E-14_JPRB, 0.29510266E-14_JPRB, 0.36842079E-14_JPRB, &
  & 0.43608238E-14_JPRB, 0.52399686E-14_JPRB, 0.63638204E-14_JPRB, 0.76222301E-14_JPRB, 0.91595856E-14_JPRB, 0.10838206E-13_JPRB, &
  & 0.12701583E-13_JPRB, 0.14366568E-13_JPRB, 0.16477744E-13_JPRB, 0.17674074E-13_JPRB, 0.19787723E-13_JPRB, 0.21457325E-13_JPRB, &
  & 0.23167977E-13_JPRB, 0.25213570E-13_JPRB, 0.27479338E-13_JPRB, 0.27193166E-13_JPRB, 0.26710244E-13_JPRB, 0.24386040E-13_JPRB, &
  & 0.23003533E-13_JPRB, 0.21231367E-13_JPRB, 0.19217229E-13_JPRB, 0.17356444E-13_JPRB, 0.15863775E-13_JPRB, 0.14906113E-13_JPRB, &
  & 0.15031974E-13_JPRB, 0.14591198E-13_JPRB, 0.17238571E-13_JPRB, 0.16107905E-13_JPRB, 0.14354366E-13_JPRB, 0.12824121E-13_JPRB, &
  & 0.11075157E-13_JPRB, 0.88966522E-14_JPRB, 0.73953252E-14_JPRB, 0.64942058E-14_JPRB, 0.57480583E-14_JPRB, 0.47646446E-14_JPRB, &
  & 0.39469457E-14_JPRB, 0.33074189E-14_JPRB, 0.28881496E-14_JPRB, 0.25915913E-14_JPRB, 0.23931984E-14_JPRB, 0.22538496E-14_JPRB, &
  & 0.21515844E-14_JPRB, 0.20820764E-14_JPRB, 0.20384521E-14_JPRB, 0.20220489E-14_JPRB, 0.20403446E-14_JPRB, 0.21154862E-14_JPRB, &
  & 0.22916802E-14_JPRB, 0.25442322E-14_JPRB, 0.28586667E-14_JPRB, 0.32003158E-14_JPRB /)

RGHG9(:,17, 4) = (/ &
  & 0.32400889E-14_JPRB, 0.48196560E-14_JPRB, 0.58056117E-14_JPRB, 0.67029711E-14_JPRB, 0.76299144E-14_JPRB, 0.86667124E-14_JPRB, &
  & 0.98769209E-14_JPRB, 0.11331664E-13_JPRB, 0.13148617E-13_JPRB, 0.15465239E-13_JPRB, 0.18391840E-13_JPRB, 0.22512650E-13_JPRB, &
  & 0.26923874E-13_JPRB, 0.32268123E-13_JPRB, 0.38570601E-13_JPRB, 0.45582041E-13_JPRB, 0.53900156E-13_JPRB, 0.63817502E-13_JPRB, &
  & 0.74890201E-13_JPRB, 0.86922142E-13_JPRB, 0.96614245E-13_JPRB, 0.10918203E-12_JPRB, 0.11995910E-12_JPRB, 0.13101757E-12_JPRB, &
  & 0.14528281E-12_JPRB, 0.15544656E-12_JPRB, 0.16319440E-12_JPRB, 0.16790695E-12_JPRB, 0.16782819E-12_JPRB, 0.16260280E-12_JPRB, &
  & 0.15407373E-12_JPRB, 0.14256104E-12_JPRB, 0.12930182E-12_JPRB, 0.11649128E-12_JPRB, 0.10618375E-12_JPRB, 0.99360421E-13_JPRB, &
  & 0.95892763E-13_JPRB, 0.95186229E-13_JPRB, 0.96036887E-13_JPRB, 0.96682021E-13_JPRB, 0.98539198E-13_JPRB, 0.96481288E-13_JPRB, &
  & 0.90394841E-13_JPRB, 0.81435232E-13_JPRB, 0.71390613E-13_JPRB, 0.61354750E-13_JPRB, 0.50451397E-13_JPRB, 0.41015378E-13_JPRB, &
  & 0.34126063E-13_JPRB, 0.29742163E-13_JPRB, 0.26831066E-13_JPRB, 0.24891002E-13_JPRB, 0.23524117E-13_JPRB, 0.22481964E-13_JPRB, &
  & 0.21548107E-13_JPRB, 0.20738282E-13_JPRB, 0.20045089E-13_JPRB, 0.19536171E-13_JPRB, 0.19293574E-13_JPRB, 0.19448163E-13_JPRB, &
  & 0.20295804E-13_JPRB, 0.21676539E-13_JPRB, 0.23540558E-13_JPRB, 0.26383501E-13_JPRB /)

RGHG9(:,18, 4) = (/ &
  & 0.15959737E-13_JPRB, 0.22861040E-13_JPRB, 0.27245621E-13_JPRB, 0.31219822E-13_JPRB, 0.35418598E-13_JPRB, 0.40224521E-13_JPRB, &
  & 0.45965120E-13_JPRB, 0.53101143E-13_JPRB, 0.61773930E-13_JPRB, 0.72494785E-13_JPRB, 0.86569498E-13_JPRB, 0.10439049E-12_JPRB, &
  & 0.12451756E-12_JPRB, 0.14798209E-12_JPRB, 0.17436679E-12_JPRB, 0.20329379E-12_JPRB, 0.23617707E-12_JPRB, 0.27271693E-12_JPRB, &
  & 0.31612912E-12_JPRB, 0.36369735E-12_JPRB, 0.41384536E-12_JPRB, 0.46265558E-12_JPRB, 0.51022533E-12_JPRB, 0.55844825E-12_JPRB, &
  & 0.60167377E-12_JPRB, 0.64369652E-12_JPRB, 0.69164596E-12_JPRB, 0.72976391E-12_JPRB, 0.75169309E-12_JPRB, 0.74908168E-12_JPRB, &
  & 0.71977640E-12_JPRB, 0.67527272E-12_JPRB, 0.62148675E-12_JPRB, 0.56755501E-12_JPRB, 0.52336477E-12_JPRB, 0.49382460E-12_JPRB, &
  & 0.48047807E-12_JPRB, 0.48051526E-12_JPRB, 0.48704286E-12_JPRB, 0.49298803E-12_JPRB, 0.49080932E-12_JPRB, 0.47585834E-12_JPRB, &
  & 0.44663771E-12_JPRB, 0.40417897E-12_JPRB, 0.35412276E-12_JPRB, 0.30215072E-12_JPRB, 0.25663846E-12_JPRB, 0.22165847E-12_JPRB, &
  & 0.19614020E-12_JPRB, 0.17811353E-12_JPRB, 0.16416434E-12_JPRB, 0.15270830E-12_JPRB, 0.14290389E-12_JPRB, 0.13437870E-12_JPRB, &
  & 0.12669121E-12_JPRB, 0.12010315E-12_JPRB, 0.11464272E-12_JPRB, 0.11048104E-12_JPRB, 0.10786321E-12_JPRB, 0.10723968E-12_JPRB, &
  & 0.10960727E-12_JPRB, 0.11438864E-12_JPRB, 0.12160815E-12_JPRB, 0.13485148E-12_JPRB /)

RGHG9(:,19, 4) = (/ &
  & 0.62871285E-13_JPRB, 0.87720494E-13_JPRB, 0.10298521E-12_JPRB, 0.11730986E-12_JPRB, 0.13238638E-12_JPRB, 0.14991030E-12_JPRB, &
  & 0.17117875E-12_JPRB, 0.19784239E-12_JPRB, 0.23086586E-12_JPRB, 0.26972849E-12_JPRB, 0.31901359E-12_JPRB, 0.37926986E-12_JPRB, &
  & 0.44825542E-12_JPRB, 0.52569949E-12_JPRB, 0.61039590E-12_JPRB, 0.70228664E-12_JPRB, 0.80188818E-12_JPRB, 0.91096965E-12_JPRB, &
  & 0.10329607E-11_JPRB, 0.11727551E-11_JPRB, 0.13200248E-11_JPRB, 0.14707624E-11_JPRB, 0.16289500E-11_JPRB, 0.17754355E-11_JPRB, &
  & 0.19187267E-11_JPRB, 0.20603918E-11_JPRB, 0.21964787E-11_JPRB, 0.23073954E-11_JPRB, 0.23924595E-11_JPRB, 0.24133141E-11_JPRB, &
  & 0.23768658E-11_JPRB, 0.22877293E-11_JPRB, 0.21580951E-11_JPRB, 0.20262346E-11_JPRB, 0.19115751E-11_JPRB, 0.18275492E-11_JPRB, &
  & 0.17845126E-11_JPRB, 0.17711045E-11_JPRB, 0.17697716E-11_JPRB, 0.17644782E-11_JPRB, 0.17363992E-11_JPRB, 0.16698006E-11_JPRB, &
  & 0.15639557E-11_JPRB, 0.14224486E-11_JPRB, 0.12634066E-11_JPRB, 0.11078113E-11_JPRB, 0.97057963E-12_JPRB, 0.85633117E-12_JPRB, &
  & 0.76395915E-12_JPRB, 0.68990359E-12_JPRB, 0.62944794E-12_JPRB, 0.58006686E-12_JPRB, 0.53907302E-12_JPRB, 0.50484925E-12_JPRB, &
  & 0.47543452E-12_JPRB, 0.45076041E-12_JPRB, 0.43030998E-12_JPRB, 0.41419586E-12_JPRB, 0.40297428E-12_JPRB, 0.39787726E-12_JPRB, &
  & 0.40149476E-12_JPRB, 0.41249531E-12_JPRB, 0.43227393E-12_JPRB, 0.47388433E-12_JPRB /)

RGHG9(:,20, 4) = (/ &
  & 0.20349244E-12_JPRB, 0.27412548E-12_JPRB, 0.31969295E-12_JPRB, 0.36095668E-12_JPRB, 0.40561697E-12_JPRB, 0.45706624E-12_JPRB, &
  & 0.51943541E-12_JPRB, 0.59701923E-12_JPRB, 0.69285208E-12_JPRB, 0.80603276E-12_JPRB, 0.94258553E-12_JPRB, 0.11024446E-11_JPRB, &
  & 0.12850551E-11_JPRB, 0.14854604E-11_JPRB, 0.16993064E-11_JPRB, 0.19257246E-11_JPRB, 0.21660018E-11_JPRB, 0.24191248E-11_JPRB, &
  & 0.26897213E-11_JPRB, 0.29851380E-11_JPRB, 0.33047363E-11_JPRB, 0.36360535E-11_JPRB, 0.39654894E-11_JPRB, 0.43003448E-11_JPRB, &
  & 0.46206437E-11_JPRB, 0.49353373E-11_JPRB, 0.52181167E-11_JPRB, 0.54613566E-11_JPRB, 0.56601208E-11_JPRB, 0.57775841E-11_JPRB, &
  & 0.58099046E-11_JPRB, 0.57417339E-11_JPRB, 0.56068913E-11_JPRB, 0.54302968E-11_JPRB, 0.52493140E-11_JPRB, 0.50974047E-11_JPRB, &
  & 0.49897543E-11_JPRB, 0.49054380E-11_JPRB, 0.48358054E-11_JPRB, 0.47308316E-11_JPRB, 0.45669987E-11_JPRB, 0.43272317E-11_JPRB, &
  & 0.40189588E-11_JPRB, 0.36507091E-11_JPRB, 0.32625775E-11_JPRB, 0.28884855E-11_JPRB, 0.25556983E-11_JPRB, 0.22735704E-11_JPRB, &
  & 0.20423160E-11_JPRB, 0.18546028E-11_JPRB, 0.16997085E-11_JPRB, 0.15710765E-11_JPRB, 0.14643435E-11_JPRB, 0.13756348E-11_JPRB, &
  & 0.13003771E-11_JPRB, 0.12372341E-11_JPRB, 0.11841123E-11_JPRB, 0.11407844E-11_JPRB, 0.11083874E-11_JPRB, 0.10896761E-11_JPRB, &
  & 0.10900465E-11_JPRB, 0.11079234E-11_JPRB, 0.11462041E-11_JPRB, 0.12399268E-11_JPRB /)

RGHG9(:,21, 4) = (/ &
  & 0.53904369E-12_JPRB, 0.71303694E-12_JPRB, 0.81862501E-12_JPRB, 0.91949658E-12_JPRB, 0.10259064E-11_JPRB, 0.11493506E-11_JPRB, &
  & 0.12982174E-11_JPRB, 0.14805368E-11_JPRB, 0.17027267E-11_JPRB, 0.19661553E-11_JPRB, 0.22681388E-11_JPRB, 0.26133999E-11_JPRB, &
  & 0.29986662E-11_JPRB, 0.34119938E-11_JPRB, 0.38441255E-11_JPRB, 0.42889841E-11_JPRB, 0.47457515E-11_JPRB, 0.52189390E-11_JPRB, &
  & 0.57119856E-11_JPRB, 0.62280073E-11_JPRB, 0.67681555E-11_JPRB, 0.73098645E-11_JPRB, 0.78677447E-11_JPRB, 0.83873932E-11_JPRB, &
  & 0.88881324E-11_JPRB, 0.93687063E-11_JPRB, 0.98249898E-11_JPRB, 0.10263045E-10_JPRB, 0.10654997E-10_JPRB, 0.10979745E-10_JPRB, &
  & 0.11222159E-10_JPRB, 0.11351353E-10_JPRB, 0.11384809E-10_JPRB, 0.11301607E-10_JPRB, 0.11160210E-10_JPRB, 0.10972425E-10_JPRB, &
  & 0.10774995E-10_JPRB, 0.10543360E-10_JPRB, 0.10260960E-10_JPRB, 0.98833042E-11_JPRB, 0.93935866E-11_JPRB, 0.87869434E-11_JPRB, &
  & 0.80953143E-11_JPRB, 0.73451627E-11_JPRB, 0.65932980E-11_JPRB, 0.58900380E-11_JPRB, 0.52679189E-11_JPRB, 0.47389345E-11_JPRB, &
  & 0.42975150E-11_JPRB, 0.39309988E-11_JPRB, 0.36227800E-11_JPRB, 0.33645784E-11_JPRB, 0.31494083E-11_JPRB, 0.29703256E-11_JPRB, &
  & 0.28187856E-11_JPRB, 0.26906027E-11_JPRB, 0.25812815E-11_JPRB, 0.24894910E-11_JPRB, 0.24171704E-11_JPRB, 0.23693105E-11_JPRB, &
  & 0.23548388E-11_JPRB, 0.23727875E-11_JPRB, 0.24285417E-11_JPRB, 0.25796023E-11_JPRB /)

RGHG9(:,22, 4) = (/ &
  & 0.12109860E-11_JPRB, 0.15526465E-11_JPRB, 0.17721653E-11_JPRB, 0.19708321E-11_JPRB, 0.21859032E-11_JPRB, 0.24309970E-11_JPRB, &
  & 0.27233491E-11_JPRB, 0.30760806E-11_JPRB, 0.34984559E-11_JPRB, 0.39935464E-11_JPRB, 0.45584370E-11_JPRB, 0.51742556E-11_JPRB, &
  & 0.58431398E-11_JPRB, 0.65502838E-11_JPRB, 0.72755461E-11_JPRB, 0.80079008E-11_JPRB, 0.87439084E-11_JPRB, 0.94869590E-11_JPRB, &
  & 0.10237514E-10_JPRB, 0.10998641E-10_JPRB, 0.11766130E-10_JPRB, 0.12532281E-10_JPRB, 0.13265685E-10_JPRB, 0.13954435E-10_JPRB, &
  & 0.14588391E-10_JPRB, 0.15187324E-10_JPRB, 0.15770902E-10_JPRB, 0.16370310E-10_JPRB, 0.16986888E-10_JPRB, 0.17593597E-10_JPRB, &
  & 0.18156306E-10_JPRB, 0.18634814E-10_JPRB, 0.18981317E-10_JPRB, 0.19151606E-10_JPRB, 0.19161587E-10_JPRB, 0.18998844E-10_JPRB, &
  & 0.18695356E-10_JPRB, 0.18231115E-10_JPRB, 0.17604964E-10_JPRB, 0.16795957E-10_JPRB, 0.15820421E-10_JPRB, 0.14705223E-10_JPRB, &
  & 0.13516818E-10_JPRB, 0.12294650E-10_JPRB, 0.11114301E-10_JPRB, 0.10027398E-10_JPRB, 0.90715126E-11_JPRB, 0.82523363E-11_JPRB, &
  & 0.75564980E-11_JPRB, 0.69668715E-11_JPRB, 0.64623073E-11_JPRB, 0.60349516E-11_JPRB, 0.56768154E-11_JPRB, 0.53774871E-11_JPRB, &
  & 0.51231129E-11_JPRB, 0.49054124E-11_JPRB, 0.47168298E-11_JPRB, 0.45542797E-11_JPRB, 0.44200082E-11_JPRB, 0.43217526E-11_JPRB, &
  & 0.42730498E-11_JPRB, 0.42728377E-11_JPRB, 0.43195720E-11_JPRB, 0.44744256E-11_JPRB /)

RGHG9(:,23, 4) = (/ &
  & 0.23269396E-11_JPRB, 0.29302327E-11_JPRB, 0.32978468E-11_JPRB, 0.36439380E-11_JPRB, 0.40087703E-11_JPRB, 0.44233293E-11_JPRB, &
  & 0.49103876E-11_JPRB, 0.54865760E-11_JPRB, 0.61625783E-11_JPRB, 0.69432212E-11_JPRB, 0.78190596E-11_JPRB, 0.87681919E-11_JPRB, &
  & 0.97771799E-11_JPRB, 0.10826848E-10_JPRB, 0.11888561E-10_JPRB, 0.12942560E-10_JPRB, 0.13977952E-10_JPRB, 0.15000536E-10_JPRB, &
  & 0.16014938E-10_JPRB, 0.17014284E-10_JPRB, 0.17995164E-10_JPRB, 0.18940866E-10_JPRB, 0.19827822E-10_JPRB, 0.20633007E-10_JPRB, &
  & 0.21352569E-10_JPRB, 0.22017069E-10_JPRB, 0.22671674E-10_JPRB, 0.23368750E-10_JPRB, 0.24148045E-10_JPRB, 0.25010528E-10_JPRB, &
  & 0.25881214E-10_JPRB, 0.26712268E-10_JPRB, 0.27382869E-10_JPRB, 0.27833472E-10_JPRB, 0.28003388E-10_JPRB, 0.27869212E-10_JPRB, &
  & 0.27440971E-10_JPRB, 0.26705927E-10_JPRB, 0.25697606E-10_JPRB, 0.24425925E-10_JPRB, 0.22954921E-10_JPRB, 0.21329889E-10_JPRB, &
  & 0.19662534E-10_JPRB, 0.17999831E-10_JPRB, 0.16425692E-10_JPRB, 0.14986382E-10_JPRB, 0.13713045E-10_JPRB, 0.12605440E-10_JPRB, &
  & 0.11647430E-10_JPRB, 0.10819281E-10_JPRB, 0.10102410E-10_JPRB, 0.94904536E-11_JPRB, 0.89731139E-11_JPRB, 0.85371345E-11_JPRB, &
  & 0.81638064E-11_JPRB, 0.78401738E-11_JPRB, 0.75544068E-11_JPRB, 0.73018605E-11_JPRB, 0.70859429E-11_JPRB, 0.69172680E-11_JPRB, &
  & 0.68117491E-11_JPRB, 0.67714731E-11_JPRB, 0.67777281E-11_JPRB, 0.68684151E-11_JPRB /)

RGHG9(:,24, 4) = (/ &
  & 0.39715453E-11_JPRB, 0.48800018E-11_JPRB, 0.54410751E-11_JPRB, 0.59546647E-11_JPRB, 0.64988813E-11_JPRB, 0.71091557E-11_JPRB, &
  & 0.78155494E-11_JPRB, 0.86375178E-11_JPRB, 0.95859562E-11_JPRB, 0.10665810E-10_JPRB, 0.11867610E-10_JPRB, 0.13165715E-10_JPRB, &
  & 0.14516054E-10_JPRB, 0.15904448E-10_JPRB, 0.17295844E-10_JPRB, 0.18668638E-10_JPRB, 0.20004415E-10_JPRB, 0.21302978E-10_JPRB, &
  & 0.22557373E-10_JPRB, 0.23765129E-10_JPRB, 0.24923355E-10_JPRB, 0.26008605E-10_JPRB, 0.27007828E-10_JPRB, 0.27887042E-10_JPRB, &
  & 0.28659249E-10_JPRB, 0.29354946E-10_JPRB, 0.30035613E-10_JPRB, 0.30786040E-10_JPRB, 0.31654290E-10_JPRB, 0.32654650E-10_JPRB, &
  & 0.33725904E-10_JPRB, 0.34788384E-10_JPRB, 0.35689108E-10_JPRB, 0.36317272E-10_JPRB, 0.36575444E-10_JPRB, 0.36419666E-10_JPRB, &
  & 0.35842097E-10_JPRB, 0.34860437E-10_JPRB, 0.33522726E-10_JPRB, 0.31868005E-10_JPRB, 0.29996478E-10_JPRB, 0.27990507E-10_JPRB, &
  & 0.25971600E-10_JPRB, 0.23991554E-10_JPRB, 0.22129784E-10_JPRB, 0.20418748E-10_JPRB, 0.18885260E-10_JPRB, 0.17530224E-10_JPRB, &
  & 0.16335735E-10_JPRB, 0.15288602E-10_JPRB, 0.14370467E-10_JPRB, 0.13576018E-10_JPRB, 0.12897171E-10_JPRB, 0.12316937E-10_JPRB, &
  & 0.11813168E-10_JPRB, 0.11369362E-10_JPRB, 0.10971241E-10_JPRB, 0.10611997E-10_JPRB, 0.10295705E-10_JPRB, 0.10036149E-10_JPRB, &
  & 0.98522614E-11_JPRB, 0.97422218E-11_JPRB, 0.96777716E-11_JPRB, 0.96293338E-11_JPRB /)

RGHG9(:,25, 4) = (/ &
  & 0.61647076E-11_JPRB, 0.73913159E-11_JPRB, 0.81534571E-11_JPRB, 0.88406418E-11_JPRB, 0.95644942E-11_JPRB, 0.10370566E-10_JPRB, &
  & 0.11289266E-10_JPRB, 0.12345115E-10_JPRB, 0.13545006E-10_JPRB, 0.14894669E-10_JPRB, 0.16386757E-10_JPRB, 0.17995622E-10_JPRB, &
  & 0.19677142E-10_JPRB, 0.21383832E-10_JPRB, 0.23080829E-10_JPRB, 0.24736820E-10_JPRB, 0.26333257E-10_JPRB, 0.27863895E-10_JPRB, &
  & 0.29321996E-10_JPRB, 0.30706607E-10_JPRB, 0.32008025E-10_JPRB, 0.33204071E-10_JPRB, 0.34281942E-10_JPRB, 0.35211816E-10_JPRB, &
  & 0.36011687E-10_JPRB, 0.36714267E-10_JPRB, 0.37401002E-10_JPRB, 0.38154490E-10_JPRB, 0.39035872E-10_JPRB, 0.40082018E-10_JPRB, &
  & 0.41228607E-10_JPRB, 0.42374142E-10_JPRB, 0.43360759E-10_JPRB, 0.44035598E-10_JPRB, 0.44287896E-10_JPRB, 0.44057921E-10_JPRB, &
  & 0.43329069E-10_JPRB, 0.42126004E-10_JPRB, 0.40540193E-10_JPRB, 0.38647769E-10_JPRB, 0.36546911E-10_JPRB, 0.34326327E-10_JPRB, &
  & 0.32118801E-10_JPRB, 0.29966363E-10_JPRB, 0.27936112E-10_JPRB, 0.26052443E-10_JPRB, 0.24335188E-10_JPRB, 0.22788065E-10_JPRB, &
  & 0.21402095E-10_JPRB, 0.20166004E-10_JPRB, 0.19068108E-10_JPRB, 0.18107958E-10_JPRB, 0.17273053E-10_JPRB, 0.16545924E-10_JPRB, &
  & 0.15902304E-10_JPRB, 0.15324410E-10_JPRB, 0.14796834E-10_JPRB, 0.14312872E-10_JPRB, 0.13878164E-10_JPRB, 0.13509084E-10_JPRB, &
  & 0.13223319E-10_JPRB, 0.13015460E-10_JPRB, 0.12849236E-10_JPRB, 0.12641613E-10_JPRB /)

RGHG9(:,26, 4) = (/ &
  & 0.88557798E-11_JPRB, 0.10422224E-10_JPRB, 0.11332504E-10_JPRB, 0.12189466E-10_JPRB, 0.13067146E-10_JPRB, 0.14039997E-10_JPRB, &
  & 0.15145059E-10_JPRB, 0.16392008E-10_JPRB, 0.17799352E-10_JPRB, 0.19369494E-10_JPRB, 0.21094192E-10_JPRB, 0.22951831E-10_JPRB, &
  & 0.24893424E-10_JPRB, 0.26857724E-10_JPRB, 0.28805097E-10_JPRB, 0.30706684E-10_JPRB, 0.32536539E-10_JPRB, 0.34276765E-10_JPRB, &
  & 0.35915958E-10_JPRB, 0.37449495E-10_JPRB, 0.38865491E-10_JPRB, 0.40150681E-10_JPRB, 0.41287730E-10_JPRB, 0.42261031E-10_JPRB, &
  & 0.43080858E-10_JPRB, 0.43792178E-10_JPRB, 0.44472138E-10_JPRB, 0.45188540E-10_JPRB, 0.46049851E-10_JPRB, 0.47052355E-10_JPRB, &
  & 0.48158443E-10_JPRB, 0.49256786E-10_JPRB, 0.50199355E-10_JPRB, 0.50815817E-10_JPRB, 0.50986115E-10_JPRB, 0.50644235E-10_JPRB, &
  & 0.49775958E-10_JPRB, 0.48449786E-10_JPRB, 0.46737201E-10_JPRB, 0.44729508E-10_JPRB, 0.42536190E-10_JPRB, 0.40266627E-10_JPRB, &
  & 0.38010303E-10_JPRB, 0.35818383E-10_JPRB, 0.33725869E-10_JPRB, 0.31755369E-10_JPRB, 0.29921787E-10_JPRB, 0.28238169E-10_JPRB, &
  & 0.26701348E-10_JPRB, 0.25309407E-10_JPRB, 0.24057582E-10_JPRB, 0.22943182E-10_JPRB, 0.21957415E-10_JPRB, 0.21081612E-10_JPRB, &
  & 0.20290554E-10_JPRB, 0.19566189E-10_JPRB, 0.18893550E-10_JPRB, 0.18267166E-10_JPRB, 0.17695203E-10_JPRB, 0.17198165E-10_JPRB, &
  & 0.16791204E-10_JPRB, 0.16470669E-10_JPRB, 0.16171623E-10_JPRB, 0.15781713E-10_JPRB /)

RGHG9(:,27, 4) = (/ &
  & 0.12048923E-10_JPRB, 0.13792387E-10_JPRB, 0.14894547E-10_JPRB, 0.15845901E-10_JPRB, 0.16857514E-10_JPRB, 0.17962819E-10_JPRB, &
  & 0.19200492E-10_JPRB, 0.20599245E-10_JPRB, 0.22155222E-10_JPRB, 0.23882063E-10_JPRB, 0.25781165E-10_JPRB, 0.27823858E-10_JPRB, &
  & 0.29970020E-10_JPRB, 0.32148065E-10_JPRB, 0.34306138E-10_JPRB, 0.36404969E-10_JPRB, 0.38417033E-10_JPRB, 0.40321916E-10_JPRB, &
  & 0.42106298E-10_JPRB, 0.43758143E-10_JPRB, 0.45268955E-10_JPRB, 0.46624885E-10_JPRB, 0.47814089E-10_JPRB, 0.48826863E-10_JPRB, &
  & 0.49672325E-10_JPRB, 0.50397648E-10_JPRB, 0.51062179E-10_JPRB, 0.51753966E-10_JPRB, 0.52544507E-10_JPRB, 0.53437366E-10_JPRB, &
  & 0.54418910E-10_JPRB, 0.55384058E-10_JPRB, 0.56193262E-10_JPRB, 0.56683901E-10_JPRB, 0.56734631E-10_JPRB, 0.56288307E-10_JPRB, &
  & 0.55342272E-10_JPRB, 0.53931228E-10_JPRB, 0.52172607E-10_JPRB, 0.50187993E-10_JPRB, 0.48047785E-10_JPRB, 0.45844332E-10_JPRB, &
  & 0.43655888E-10_JPRB, 0.41514889E-10_JPRB, 0.39447650E-10_JPRB, 0.37456753E-10_JPRB, 0.35563674E-10_JPRB, 0.33783306E-10_JPRB, &
  & 0.32130312E-10_JPRB, 0.30609563E-10_JPRB, 0.29220265E-10_JPRB, 0.27966541E-10_JPRB, 0.26836528E-10_JPRB, 0.25811579E-10_JPRB, &
  & 0.24868855E-10_JPRB, 0.23989333E-10_JPRB, 0.23160553E-10_JPRB, 0.22377732E-10_JPRB, 0.21652926E-10_JPRB, 0.21011649E-10_JPRB, &
  & 0.20474109E-10_JPRB, 0.20024976E-10_JPRB, 0.19607829E-10_JPRB, 0.19036859E-10_JPRB /)

RGHG9(:,28, 4) = (/ &
  & 0.15499955E-10_JPRB, 0.17511954E-10_JPRB, 0.18635163E-10_JPRB, 0.19713092E-10_JPRB, 0.20798637E-10_JPRB, 0.21993419E-10_JPRB, &
  & 0.23335216E-10_JPRB, 0.24825853E-10_JPRB, 0.26483801E-10_JPRB, 0.28314849E-10_JPRB, 0.30320711E-10_JPRB, 0.32488734E-10_JPRB, &
  & 0.34771068E-10_JPRB, 0.37111692E-10_JPRB, 0.39439219E-10_JPRB, 0.41700646E-10_JPRB, 0.43858431E-10_JPRB, 0.45889008E-10_JPRB, &
  & 0.47784391E-10_JPRB, 0.49529800E-10_JPRB, 0.51115629E-10_JPRB, 0.52528915E-10_JPRB, 0.53763324E-10_JPRB, 0.54810958E-10_JPRB, &
  & 0.55685311E-10_JPRB, 0.56421208E-10_JPRB, 0.57071188E-10_JPRB, 0.57723593E-10_JPRB, 0.58419318E-10_JPRB, 0.59183297E-10_JPRB, &
  & 0.59997285E-10_JPRB, 0.60781859E-10_JPRB, 0.61410640E-10_JPRB, 0.61743360E-10_JPRB, 0.61665589E-10_JPRB, 0.61124605E-10_JPRB, &
  & 0.60112131E-10_JPRB, 0.58723013E-10_JPRB, 0.57057057E-10_JPRB, 0.55177782E-10_JPRB, 0.53173046E-10_JPRB, 0.51121177E-10_JPRB, &
  & 0.49076559E-10_JPRB, 0.47055221E-10_JPRB, 0.45052208E-10_JPRB, 0.43085705E-10_JPRB, 0.41164433E-10_JPRB, 0.39327219E-10_JPRB, &
  & 0.37589161E-10_JPRB, 0.35964627E-10_JPRB, 0.34459248E-10_JPRB, 0.33076382E-10_JPRB, 0.31807262E-10_JPRB, 0.30636400E-10_JPRB, &
  & 0.29541865E-10_JPRB, 0.28505316E-10_JPRB, 0.27516364E-10_JPRB, 0.26573219E-10_JPRB, 0.25693300E-10_JPRB, 0.24905727E-10_JPRB, &
  & 0.24237182E-10_JPRB, 0.23662426E-10_JPRB, 0.23124225E-10_JPRB, 0.22398406E-10_JPRB /)

RGHG9(:,29, 4) = (/ &
  & 0.19223579E-10_JPRB, 0.21248789E-10_JPRB, 0.22533420E-10_JPRB, 0.23617665E-10_JPRB, 0.24779449E-10_JPRB, 0.26040229E-10_JPRB, &
  & 0.27429285E-10_JPRB, 0.28983487E-10_JPRB, 0.30693583E-10_JPRB, 0.32579005E-10_JPRB, 0.34650668E-10_JPRB, 0.36887732E-10_JPRB, &
  & 0.39251130E-10_JPRB, 0.41671767E-10_JPRB, 0.44094357E-10_JPRB, 0.46474904E-10_JPRB, 0.48764166E-10_JPRB, 0.50911407E-10_JPRB, &
  & 0.52901433E-10_JPRB, 0.54722962E-10_JPRB, 0.56370152E-10_JPRB, 0.57827795E-10_JPRB, 0.59100259E-10_JPRB, 0.60175247E-10_JPRB, &
  & 0.61077976E-10_JPRB, 0.61822866E-10_JPRB, 0.62467385E-10_JPRB, 0.63072839E-10_JPRB, 0.63668300E-10_JPRB, 0.64287041E-10_JPRB, &
  & 0.64918758E-10_JPRB, 0.65501590E-10_JPRB, 0.65937672E-10_JPRB, 0.66105121E-10_JPRB, 0.65909410E-10_JPRB, 0.65310125E-10_JPRB, &
  & 0.64332158E-10_JPRB, 0.63030615E-10_JPRB, 0.61465444E-10_JPRB, 0.59746888E-10_JPRB, 0.57940364E-10_JPRB, 0.56089435E-10_JPRB, &
  & 0.54234735E-10_JPRB, 0.52363676E-10_JPRB, 0.50476911E-10_JPRB, 0.48560909E-10_JPRB, 0.46650343E-10_JPRB, 0.44773588E-10_JPRB, &
  & 0.42972639E-10_JPRB, 0.41266240E-10_JPRB, 0.39658159E-10_JPRB, 0.38159670E-10_JPRB, 0.36763589E-10_JPRB, 0.35455076E-10_JPRB, &
  & 0.34215977E-10_JPRB, 0.33026550E-10_JPRB, 0.31880908E-10_JPRB, 0.30777283E-10_JPRB, 0.29742285E-10_JPRB, 0.28808310E-10_JPRB, &
  & 0.28006261E-10_JPRB, 0.27320982E-10_JPRB, 0.26687492E-10_JPRB, 0.25805686E-10_JPRB /)

RGHG9(:,30, 4) = (/ &
  & 0.22903278E-10_JPRB, 0.25120383E-10_JPRB, 0.26348845E-10_JPRB, 0.27530724E-10_JPRB, 0.28705878E-10_JPRB, 0.30000405E-10_JPRB, &
  & 0.31433797E-10_JPRB, 0.33001674E-10_JPRB, 0.34732096E-10_JPRB, 0.36634879E-10_JPRB, 0.38722577E-10_JPRB, 0.40993729E-10_JPRB, &
  & 0.43409540E-10_JPRB, 0.45907420E-10_JPRB, 0.48405918E-10_JPRB, 0.50840599E-10_JPRB, 0.53193543E-10_JPRB, 0.55417049E-10_JPRB, &
  & 0.57476211E-10_JPRB, 0.59351898E-10_JPRB, 0.61043018E-10_JPRB, 0.62529953E-10_JPRB, 0.63830052E-10_JPRB, 0.64918806E-10_JPRB, &
  & 0.65844503E-10_JPRB, 0.66587312E-10_JPRB, 0.67226121E-10_JPRB, 0.67780538E-10_JPRB, 0.68284135E-10_JPRB, 0.68763419E-10_JPRB, &
  & 0.69219172E-10_JPRB, 0.69607153E-10_JPRB, 0.69859528E-10_JPRB, 0.69877271E-10_JPRB, 0.69590347E-10_JPRB, 0.68967825E-10_JPRB, &
  & 0.68018188E-10_JPRB, 0.66790476E-10_JPRB, 0.65403620E-10_JPRB, 0.63911397E-10_JPRB, 0.62340112E-10_JPRB, 0.60714517E-10_JPRB, &
  & 0.59051784E-10_JPRB, 0.57349674E-10_JPRB, 0.55573809E-10_JPRB, 0.53742007E-10_JPRB, 0.51864551E-10_JPRB, 0.49987688E-10_JPRB, &
  & 0.48151958E-10_JPRB, 0.46383040E-10_JPRB, 0.44697107E-10_JPRB, 0.43103479E-10_JPRB, 0.41595359E-10_JPRB, 0.40166273E-10_JPRB, &
  & 0.38796279E-10_JPRB, 0.37469389E-10_JPRB, 0.36178546E-10_JPRB, 0.34926635E-10_JPRB, 0.33745440E-10_JPRB, 0.32678232E-10_JPRB, &
  & 0.31756976E-10_JPRB, 0.30973647E-10_JPRB, 0.30245358E-10_JPRB, 0.29238417E-10_JPRB /)

RGHG9(:,31, 4) = (/ &
  & 0.26625134E-10_JPRB, 0.28801943E-10_JPRB, 0.30166310E-10_JPRB, 0.31316727E-10_JPRB, 0.32540026E-10_JPRB, 0.33852691E-10_JPRB, &
  & 0.35286555E-10_JPRB, 0.36863561E-10_JPRB, 0.38581402E-10_JPRB, 0.40471109E-10_JPRB, 0.42551618E-10_JPRB, 0.44811647E-10_JPRB, &
  & 0.47222525E-10_JPRB, 0.49731354E-10_JPRB, 0.52273075E-10_JPRB, 0.54769401E-10_JPRB, 0.57167972E-10_JPRB, 0.59438128E-10_JPRB, &
  & 0.61538379E-10_JPRB, 0.63447025E-10_JPRB, 0.65160467E-10_JPRB, 0.66660850E-10_JPRB, 0.67973266E-10_JPRB, 0.69063581E-10_JPRB, &
  & 0.69997681E-10_JPRB, 0.70731684E-10_JPRB, 0.71356171E-10_JPRB, 0.71860295E-10_JPRB, 0.72285247E-10_JPRB, 0.72642059E-10_JPRB, &
  & 0.72943124E-10_JPRB, 0.73161567E-10_JPRB, 0.73252612E-10_JPRB, 0.73146059E-10_JPRB, 0.72790295E-10_JPRB, 0.72160312E-10_JPRB, &
  & 0.71277116E-10_JPRB, 0.70217013E-10_JPRB, 0.69017222E-10_JPRB, 0.67715299E-10_JPRB, 0.66352077E-10_JPRB, 0.64937451E-10_JPRB, &
  & 0.63470132E-10_JPRB, 0.61916840E-10_JPRB, 0.60267923E-10_JPRB, 0.58513847E-10_JPRB, 0.56693546E-10_JPRB, 0.54844126E-10_JPRB, &
  & 0.53002054E-10_JPRB, 0.51202011E-10_JPRB, 0.49464554E-10_JPRB, 0.47797134E-10_JPRB, 0.46205078E-10_JPRB, 0.44679677E-10_JPRB, &
  & 0.43203462E-10_JPRB, 0.41761462E-10_JPRB, 0.40346494E-10_JPRB, 0.38966750E-10_JPRB, 0.37656777E-10_JPRB, 0.36472991E-10_JPRB, &
  & 0.35449445E-10_JPRB, 0.34586806E-10_JPRB, 0.33782928E-10_JPRB, 0.32656055E-10_JPRB /)

RGHG9(:,32, 4) = (/ &
  & 0.30182884E-10_JPRB, 0.32508187E-10_JPRB, 0.33801822E-10_JPRB, 0.35029351E-10_JPRB, 0.36242842E-10_JPRB, 0.37562412E-10_JPRB, &
  & 0.38995585E-10_JPRB, 0.40548110E-10_JPRB, 0.42237915E-10_JPRB, 0.44089624E-10_JPRB, 0.46129371E-10_JPRB, 0.48362602E-10_JPRB, &
  & 0.50753606E-10_JPRB, 0.53247171E-10_JPRB, 0.55783052E-10_JPRB, 0.58291566E-10_JPRB, 0.60712803E-10_JPRB, 0.63004685E-10_JPRB, &
  & 0.65123282E-10_JPRB, 0.67044412E-10_JPRB, 0.68757965E-10_JPRB, 0.70258001E-10_JPRB, 0.71565302E-10_JPRB, 0.72649560E-10_JPRB, &
  & 0.73571774E-10_JPRB, 0.74297193E-10_JPRB, 0.74892433E-10_JPRB, 0.75357005E-10_JPRB, 0.75711132E-10_JPRB, 0.75970591E-10_JPRB, &
  & 0.76145978E-10_JPRB, 0.76227941E-10_JPRB, 0.76191622E-10_JPRB, 0.75990866E-10_JPRB, 0.75592838E-10_JPRB, 0.74986885E-10_JPRB, &
  & 0.74207633E-10_JPRB, 0.73284545E-10_JPRB, 0.72250754E-10_JPRB, 0.71139691E-10_JPRB, 0.69959427E-10_JPRB, 0.68718448E-10_JPRB, &
  & 0.67402819E-10_JPRB, 0.65986952E-10_JPRB, 0.64448683E-10_JPRB, 0.62793500E-10_JPRB, 0.61042782E-10_JPRB, 0.59240245E-10_JPRB, &
  & 0.57426237E-10_JPRB, 0.55624984E-10_JPRB, 0.53863410E-10_JPRB, 0.52158430E-10_JPRB, 0.50512806E-10_JPRB, 0.48923365E-10_JPRB, &
  & 0.47372401E-10_JPRB, 0.45846705E-10_JPRB, 0.44336070E-10_JPRB, 0.42855438E-10_JPRB, 0.41447672E-10_JPRB, 0.40168729E-10_JPRB, &
  & 0.39072190E-10_JPRB, 0.38141594E-10_JPRB, 0.37272657E-10_JPRB, 0.36044358E-10_JPRB /)

RGHG9(:,33, 4) = (/ &
  & 0.33721439E-10_JPRB, 0.36004852E-10_JPRB, 0.37402904E-10_JPRB, 0.38586859E-10_JPRB, 0.39825351E-10_JPRB, 0.41137555E-10_JPRB, &
  & 0.42544853E-10_JPRB, 0.44066823E-10_JPRB, 0.45707972E-10_JPRB, 0.47502162E-10_JPRB, 0.49481579E-10_JPRB, 0.51650149E-10_JPRB, &
  & 0.53990184E-10_JPRB, 0.56447968E-10_JPRB, 0.58957512E-10_JPRB, 0.61454800E-10_JPRB, 0.63866364E-10_JPRB, 0.66151896E-10_JPRB, &
  & 0.68261591E-10_JPRB, 0.70178086E-10_JPRB, 0.71876075E-10_JPRB, 0.73360602E-10_JPRB, 0.74649703E-10_JPRB, 0.75719965E-10_JPRB, &
  & 0.76617955E-10_JPRB, 0.77327603E-10_JPRB, 0.77889424E-10_JPRB, 0.78316534E-10_JPRB, 0.78613657E-10_JPRB, 0.78798183E-10_JPRB, &
  & 0.78879882E-10_JPRB, 0.78861521E-10_JPRB, 0.78734200E-10_JPRB, 0.78471889E-10_JPRB, 0.78059573E-10_JPRB, 0.77500402E-10_JPRB, &
  & 0.76809503E-10_JPRB, 0.76009872E-10_JPRB, 0.75126599E-10_JPRB, 0.74174007E-10_JPRB, 0.73147571E-10_JPRB, 0.72043843E-10_JPRB, &
  & 0.70848064E-10_JPRB, 0.69534864E-10_JPRB, 0.68095501E-10_JPRB, 0.66527658E-10_JPRB, 0.64858688E-10_JPRB, 0.63125609E-10_JPRB, &
  & 0.61356600E-10_JPRB, 0.59586024E-10_JPRB, 0.57834605E-10_JPRB, 0.56122725E-10_JPRB, 0.54461144E-10_JPRB, 0.52844777E-10_JPRB, &
  & 0.51256496E-10_JPRB, 0.49682137E-10_JPRB, 0.48112410E-10_JPRB, 0.46564752E-10_JPRB, 0.45087534E-10_JPRB, 0.43750153E-10_JPRB, &
  & 0.42598276E-10_JPRB, 0.41622851E-10_JPRB, 0.40702466E-10_JPRB, 0.39384284E-10_JPRB /)

RGHG9(:,34, 4) = (/ &
  & 0.37125834E-10_JPRB, 0.39502530E-10_JPRB, 0.40830631E-10_JPRB, 0.42061209E-10_JPRB, 0.43274679E-10_JPRB, 0.44566198E-10_JPRB, &
  & 0.45949584E-10_JPRB, 0.47418781E-10_JPRB, 0.48997129E-10_JPRB, 0.50717396E-10_JPRB, 0.52614513E-10_JPRB, 0.54705671E-10_JPRB, &
  & 0.56967674E-10_JPRB, 0.59362446E-10_JPRB, 0.61825725E-10_JPRB, 0.64284182E-10_JPRB, 0.66666346E-10_JPRB, 0.68919939E-10_JPRB, &
  & 0.70995682E-10_JPRB, 0.72884365E-10_JPRB, 0.74558748E-10_JPRB, 0.76016485E-10_JPRB, 0.77277774E-10_JPRB, 0.78326304E-10_JPRB, &
  & 0.79191514E-10_JPRB, 0.79876744E-10_JPRB, 0.80402907E-10_JPRB, 0.80792394E-10_JPRB, 0.81044699E-10_JPRB, 0.81174803E-10_JPRB, &
  & 0.81194114E-10_JPRB, 0.81111291E-10_JPRB, 0.80929805E-10_JPRB, 0.80639155E-10_JPRB, 0.80237865E-10_JPRB, 0.79732082E-10_JPRB, &
  & 0.79129404E-10_JPRB, 0.78446361E-10_JPRB, 0.77690708E-10_JPRB, 0.76856771E-10_JPRB, 0.75937125E-10_JPRB, 0.74922651E-10_JPRB, &
  & 0.73806392E-10_JPRB, 0.72569208E-10_JPRB, 0.71203619E-10_JPRB, 0.69718571E-10_JPRB, 0.68133832E-10_JPRB, 0.66474590E-10_JPRB, &
  & 0.64774519E-10_JPRB, 0.63054471E-10_JPRB, 0.61339163E-10_JPRB, 0.59655794E-10_JPRB, 0.58011752E-10_JPRB, 0.56405162E-10_JPRB, &
  & 0.54819246E-10_JPRB, 0.53236200E-10_JPRB, 0.51645088E-10_JPRB, 0.50069345E-10_JPRB, 0.48561086E-10_JPRB, 0.47191792E-10_JPRB, &
  & 0.46015393E-10_JPRB, 0.45008421E-10_JPRB, 0.44049125E-10_JPRB, 0.42661433E-10_JPRB /)

RGHG9(:,35, 4) = (/ &
  & 0.40510290E-10_JPRB, 0.42828709E-10_JPRB, 0.44210011E-10_JPRB, 0.45390108E-10_JPRB, 0.46601400E-10_JPRB, 0.47862402E-10_JPRB, &
  & 0.49196286E-10_JPRB, 0.50609211E-10_JPRB, 0.52111839E-10_JPRB, 0.53742524E-10_JPRB, 0.55542279E-10_JPRB, 0.57532781E-10_JPRB, &
  & 0.59706483E-10_JPRB, 0.62014782E-10_JPRB, 0.64407903E-10_JPRB, 0.66809884E-10_JPRB, 0.69142178E-10_JPRB, 0.71349184E-10_JPRB, &
  & 0.73376610E-10_JPRB, 0.75216937E-10_JPRB, 0.76855536E-10_JPRB, 0.78280084E-10_JPRB, 0.79504965E-10_JPRB, 0.80522325E-10_JPRB, &
  & 0.81346319E-10_JPRB, 0.81993100E-10_JPRB, 0.82478580E-10_JPRB, 0.82826322E-10_JPRB, 0.83040609E-10_JPRB, 0.83133771E-10_JPRB, &
  & 0.83117957E-10_JPRB, 0.83004048E-10_JPRB, 0.82802640E-10_JPRB, 0.82513142E-10_JPRB, 0.82141328E-10_JPRB, 0.81693707E-10_JPRB, &
  & 0.81177808E-10_JPRB, 0.80599166E-10_JPRB, 0.79946806E-10_JPRB, 0.79204331E-10_JPRB, 0.78350951E-10_JPRB, 0.77385730E-10_JPRB, &
  & 0.76308598E-10_JPRB, 0.75115081E-10_JPRB, 0.73808758E-10_JPRB, 0.72395846E-10_JPRB, 0.70893957E-10_JPRB, 0.69320841E-10_JPRB, &
  & 0.67690464E-10_JPRB, 0.66035080E-10_JPRB, 0.64377378E-10_JPRB, 0.62742672E-10_JPRB, 0.61145256E-10_JPRB, 0.59581624E-10_JPRB, &
  & 0.58031871E-10_JPRB, 0.56476178E-10_JPRB, 0.54906378E-10_JPRB, 0.53341307E-10_JPRB, 0.51838655E-10_JPRB, 0.50472737E-10_JPRB, &
  & 0.49290939E-10_JPRB, 0.48271782E-10_JPRB, 0.47291854E-10_JPRB, 0.45847312E-10_JPRB /)

RGHG9(:,36, 4) = (/ &
  & 0.43795152E-10_JPRB, 0.46115112E-10_JPRB, 0.47431344E-10_JPRB, 0.48620236E-10_JPRB, 0.49795813E-10_JPRB, 0.51018190E-10_JPRB, &
  & 0.52301885E-10_JPRB, 0.53640110E-10_JPRB, 0.55057146E-10_JPRB, 0.56589677E-10_JPRB, 0.58278986E-10_JPRB, 0.60153715E-10_JPRB, &
  & 0.62215177E-10_JPRB, 0.64431259E-10_JPRB, 0.66733986E-10_JPRB, 0.69055525E-10_JPRB, 0.71315502E-10_JPRB, 0.73460189E-10_JPRB, &
  & 0.75433708E-10_JPRB, 0.77222860E-10_JPRB, 0.78819354E-10_JPRB, 0.80206307E-10_JPRB, 0.81383927E-10_JPRB, 0.82351619E-10_JPRB, &
  & 0.83116368E-10_JPRB, 0.83700664E-10_JPRB, 0.84128760E-10_JPRB, 0.84424627E-10_JPRB, 0.84600868E-10_JPRB, 0.84668522E-10_JPRB, &
  & 0.84639774E-10_JPRB, 0.84522979E-10_JPRB, 0.84331132E-10_JPRB, 0.84068377E-10_JPRB, 0.83742811E-10_JPRB, 0.83361401E-10_JPRB, &
  & 0.82928206E-10_JPRB, 0.82436905E-10_JPRB, 0.81870254E-10_JPRB, 0.81199297E-10_JPRB, 0.80399944E-10_JPRB, 0.79464227E-10_JPRB, &
  & 0.78407780E-10_JPRB, 0.77243496E-10_JPRB, 0.75983143E-10_JPRB, 0.74639177E-10_JPRB, 0.73212408E-10_JPRB, 0.71711241E-10_JPRB, &
  & 0.70156186E-10_JPRB, 0.68564827E-10_JPRB, 0.66970166E-10_JPRB, 0.65399526E-10_JPRB, 0.63866981E-10_JPRB, 0.62369068E-10_JPRB, &
  & 0.60884658E-10_JPRB, 0.59390312E-10_JPRB, 0.57874556E-10_JPRB, 0.56359382E-10_JPRB, 0.54898704E-10_JPRB, 0.53564132E-10_JPRB, &
  & 0.52403890E-10_JPRB, 0.51391436E-10_JPRB, 0.50402835E-10_JPRB, 0.48932046E-10_JPRB /)

RGHG9(:,37, 4) = (/ &
  & 0.47027205E-10_JPRB, 0.49265963E-10_JPRB, 0.50564837E-10_JPRB, 0.51714657E-10_JPRB, 0.52867800E-10_JPRB, 0.54051246E-10_JPRB, &
  & 0.55272283E-10_JPRB, 0.56532078E-10_JPRB, 0.57853018E-10_JPRB, 0.59275418E-10_JPRB, 0.60844788E-10_JPRB, 0.62594208E-10_JPRB, &
  & 0.64529611E-10_JPRB, 0.66626628E-10_JPRB, 0.68828498E-10_JPRB, 0.71054468E-10_JPRB, 0.73227036E-10_JPRB, 0.75290718E-10_JPRB, &
  & 0.77204035E-10_JPRB, 0.78940604E-10_JPRB, 0.80491183E-10_JPRB, 0.81829973E-10_JPRB, 0.82939530E-10_JPRB, 0.83820957E-10_JPRB, &
  & 0.84489554E-10_JPRB, 0.84980821E-10_JPRB, 0.85327509E-10_JPRB, 0.85560739E-10_JPRB, 0.85696852E-10_JPRB, 0.85746001E-10_JPRB, &
  & 0.85718092E-10_JPRB, 0.85617333E-10_JPRB, 0.85454366E-10_JPRB, 0.85234549E-10_JPRB, 0.84966423E-10_JPRB, 0.84654277E-10_JPRB, &
  & 0.84297791E-10_JPRB, 0.83885052E-10_JPRB, 0.83393015E-10_JPRB, 0.82792682E-10_JPRB, 0.82052934E-10_JPRB, 0.81162257E-10_JPRB, &
  & 0.80138687E-10_JPRB, 0.79005809E-10_JPRB, 0.77792738E-10_JPRB, 0.76504580E-10_JPRB, 0.75147909E-10_JPRB, 0.73722368E-10_JPRB, &
  & 0.72232560E-10_JPRB, 0.70704775E-10_JPRB, 0.69171904E-10_JPRB, 0.67667261E-10_JPRB, 0.66209656E-10_JPRB, 0.64793428E-10_JPRB, &
  & 0.63393846E-10_JPRB, 0.61985139E-10_JPRB, 0.60554818E-10_JPRB, 0.59118627E-10_JPRB, 0.57731139E-10_JPRB, 0.56458459E-10_JPRB, &
  & 0.55341891E-10_JPRB, 0.54355132E-10_JPRB, 0.53380807E-10_JPRB, 0.51903506E-10_JPRB /)

RGHG9(:,38, 4) = (/ &
  & 0.50185207E-10_JPRB, 0.52308300E-10_JPRB, 0.53568323E-10_JPRB, 0.54686124E-10_JPRB, 0.55819363E-10_JPRB, 0.56965200E-10_JPRB, &
  & 0.58123457E-10_JPRB, 0.59298948E-10_JPRB, 0.60517105E-10_JPRB, 0.61820889E-10_JPRB, 0.63259370E-10_JPRB, 0.64869290E-10_JPRB, &
  & 0.66670142E-10_JPRB, 0.68639566E-10_JPRB, 0.70719201E-10_JPRB, 0.72834766E-10_JPRB, 0.74904728E-10_JPRB, 0.76879662E-10_JPRB, &
  & 0.78721238E-10_JPRB, 0.80398334E-10_JPRB, 0.81881266E-10_JPRB, 0.83140390E-10_JPRB, 0.84143630E-10_JPRB, 0.84899511E-10_JPRB, &
  & 0.85444408E-10_JPRB, 0.85826610E-10_JPRB, 0.86090628E-10_JPRB, 0.86265071E-10_JPRB, 0.86367719E-10_JPRB, 0.86404529E-10_JPRB, &
  & 0.86382519E-10_JPRB, 0.86301577E-10_JPRB, 0.86169280E-10_JPRB, 0.85990937E-10_JPRB, 0.85773624E-10_JPRB, 0.85521597E-10_JPRB, &
  & 0.85230260E-10_JPRB, 0.84887215E-10_JPRB, 0.84468557E-10_JPRB, 0.83943873E-10_JPRB, 0.83280167E-10_JPRB, 0.82462558E-10_JPRB, &
  & 0.81499606E-10_JPRB, 0.80425742E-10_JPRB, 0.79268717E-10_JPRB, 0.78052877E-10_JPRB, 0.76770756E-10_JPRB, 0.75415028E-10_JPRB, &
  & 0.73990265E-10_JPRB, 0.72518304E-10_JPRB, 0.71041152E-10_JPRB, 0.69601422E-10_JPRB, 0.68221380E-10_JPRB, 0.66894205E-10_JPRB, &
  & 0.65593107E-10_JPRB, 0.64287138E-10_JPRB, 0.62961164E-10_JPRB, 0.61628189E-10_JPRB, 0.60338651E-10_JPRB, 0.59151857E-10_JPRB, &
  & 0.58102086E-10_JPRB, 0.57162480E-10_JPRB, 0.56218055E-10_JPRB, 0.54766181E-10_JPRB /)

RGHG9(:,39, 4) = (/ &
  & 0.53226774E-10_JPRB, 0.55255942E-10_JPRB, 0.56428709E-10_JPRB, 0.57541701E-10_JPRB, 0.58641890E-10_JPRB, 0.59761779E-10_JPRB, &
  & 0.60861455E-10_JPRB, 0.61947947E-10_JPRB, 0.63055818E-10_JPRB, 0.64235922E-10_JPRB, 0.65534952E-10_JPRB, 0.66999191E-10_JPRB, &
  & 0.68650516E-10_JPRB, 0.70478422E-10_JPRB, 0.72427286E-10_JPRB, 0.74420844E-10_JPRB, 0.76382678E-10_JPRB, 0.78257401E-10_JPRB, &
  & 0.80012406E-10_JPRB, 0.81609330E-10_JPRB, 0.82995028E-10_JPRB, 0.84127705E-10_JPRB, 0.84994012E-10_JPRB, 0.85614418E-10_JPRB, &
  & 0.86042867E-10_JPRB, 0.86336417E-10_JPRB, 0.86537187E-10_JPRB, 0.86671295E-10_JPRB, 0.86752161E-10_JPRB, 0.86782526E-10_JPRB, &
  & 0.86766400E-10_JPRB, 0.86701125E-10_JPRB, 0.86591512E-10_JPRB, 0.86442867E-10_JPRB, 0.86262206E-10_JPRB, 0.86052179E-10_JPRB, &
  & 0.85810040E-10_JPRB, 0.85522443E-10_JPRB, 0.85168615E-10_JPRB, 0.84718149E-10_JPRB, 0.84138932E-10_JPRB, 0.83407913E-10_JPRB, &
  & 0.82533647E-10_JPRB, 0.81538207E-10_JPRB, 0.80466758E-10_JPRB, 0.79330709E-10_JPRB, 0.78131716E-10_JPRB, 0.76853530E-10_JPRB, &
  & 0.75491537E-10_JPRB, 0.74070049E-10_JPRB, 0.72641643E-10_JPRB, 0.71261552E-10_JPRB, 0.69957401E-10_JPRB, 0.68722375E-10_JPRB, &
  & 0.67524292E-10_JPRB, 0.66330177E-10_JPRB, 0.65118806E-10_JPRB, 0.63903820E-10_JPRB, 0.62728822E-10_JPRB, 0.61647375E-10_JPRB, &
  & 0.60683493E-10_JPRB, 0.59807749E-10_JPRB, 0.58913131E-10_JPRB, 0.57512588E-10_JPRB /)

RGHG9(:,40, 4) = (/ &
  & 0.56171422E-10_JPRB, 0.58028270E-10_JPRB, 0.59184761E-10_JPRB, 0.60237274E-10_JPRB, 0.61347760E-10_JPRB, 0.62436785E-10_JPRB, &
  & 0.63478063E-10_JPRB, 0.64477250E-10_JPRB, 0.65473932E-10_JPRB, 0.66518568E-10_JPRB, 0.67674713E-10_JPRB, 0.68986331E-10_JPRB, &
  & 0.70486249E-10_JPRB, 0.72166217E-10_JPRB, 0.73974854E-10_JPRB, 0.75835734E-10_JPRB, 0.77676650E-10_JPRB, 0.79445284E-10_JPRB, &
  & 0.81093805E-10_JPRB, 0.82583808E-10_JPRB, 0.83846645E-10_JPRB, 0.84838032E-10_JPRB, 0.85564972E-10_JPRB, 0.86070817E-10_JPRB, &
  & 0.86412141E-10_JPRB, 0.86644046E-10_JPRB, 0.86804355E-10_JPRB, 0.86913213E-10_JPRB, 0.86981547E-10_JPRB, 0.87009060E-10_JPRB, &
  & 0.86997631E-10_JPRB, 0.86943092E-10_JPRB, 0.86848743E-10_JPRB, 0.86719687E-10_JPRB, 0.86562535E-10_JPRB, 0.86381388E-10_JPRB, &
  & 0.86172298E-10_JPRB, 0.85926169E-10_JPRB, 0.85623064E-10_JPRB, 0.85237144E-10_JPRB, 0.84736620E-10_JPRB, 0.84098888E-10_JPRB, &
  & 0.83319796E-10_JPRB, 0.82425747E-10_JPRB, 0.81445448E-10_JPRB, 0.80406480E-10_JPRB, 0.79295556E-10_JPRB, 0.78093587E-10_JPRB, &
  & 0.76793030E-10_JPRB, 0.75419435E-10_JPRB, 0.74033578E-10_JPRB, 0.72708312E-10_JPRB, 0.71477470E-10_JPRB, 0.70333274E-10_JPRB, &
  & 0.69238983E-10_JPRB, 0.68155884E-10_JPRB, 0.67063362E-10_JPRB, 0.65969723E-10_JPRB, 0.64918862E-10_JPRB, 0.63952975E-10_JPRB, &
  & 0.63087237E-10_JPRB, 0.62289306E-10_JPRB, 0.61458366E-10_JPRB, 0.60131795E-10_JPRB /)

RGHG9(:,41, 4) = (/ &
  & 0.58950594E-10_JPRB, 0.60704879E-10_JPRB, 0.61766578E-10_JPRB, 0.62828104E-10_JPRB, 0.63911765E-10_JPRB, 0.64987501E-10_JPRB, &
  & 0.65975364E-10_JPRB, 0.66884262E-10_JPRB, 0.67763475E-10_JPRB, 0.68677702E-10_JPRB, 0.69682128E-10_JPRB, 0.70838724E-10_JPRB, &
  & 0.72181573E-10_JPRB, 0.73710593E-10_JPRB, 0.75377697E-10_JPRB, 0.77107015E-10_JPRB, 0.78824433E-10_JPRB, 0.80475723E-10_JPRB, &
  & 0.82011717E-10_JPRB, 0.83367487E-10_JPRB, 0.84493426E-10_JPRB, 0.85348534E-10_JPRB, 0.85957907E-10_JPRB, 0.86374699E-10_JPRB, &
  & 0.86654434E-10_JPRB, 0.86845267E-10_JPRB, 0.86978952E-10_JPRB, 0.87072280E-10_JPRB, 0.87132968E-10_JPRB, 0.87159377E-10_JPRB, &
  & 0.87151571E-10_JPRB, 0.87104768E-10_JPRB, 0.87020655E-10_JPRB, 0.86904824E-10_JPRB, 0.86763902E-10_JPRB, 0.86601441E-10_JPRB, &
  & 0.86416534E-10_JPRB, 0.86199707E-10_JPRB, 0.85935987E-10_JPRB, 0.85602470E-10_JPRB, 0.85172251E-10_JPRB, 0.84621934E-10_JPRB, &
  & 0.83945739E-10_JPRB, 0.83152013E-10_JPRB, 0.82276214E-10_JPRB, 0.81329041E-10_JPRB, 0.80306740E-10_JPRB, 0.79184263E-10_JPRB, &
  & 0.77946226E-10_JPRB, 0.76617122E-10_JPRB, 0.75273940E-10_JPRB, 0.74000028E-10_JPRB, 0.72842204E-10_JPRB, 0.71786181E-10_JPRB, &
  & 0.70791900E-10_JPRB, 0.69816937E-10_JPRB, 0.68837755E-10_JPRB, 0.67865109E-10_JPRB, 0.66936699E-10_JPRB, 0.66089204E-10_JPRB, &
  & 0.65325828E-10_JPRB, 0.64612149E-10_JPRB, 0.63852756E-10_JPRB, 0.62617113E-10_JPRB /)

RGHG9(:,42, 4) = (/ &
  & 0.61600877E-10_JPRB, 0.63226688E-10_JPRB, 0.64258057E-10_JPRB, 0.65272621E-10_JPRB, 0.66366537E-10_JPRB, 0.67419188E-10_JPRB, &
  & 0.68349604E-10_JPRB, 0.69170121E-10_JPRB, 0.69936501E-10_JPRB, 0.70713803E-10_JPRB, 0.71572505E-10_JPRB, 0.72571213E-10_JPRB, &
  & 0.73758458E-10_JPRB, 0.75136800E-10_JPRB, 0.76661920E-10_JPRB, 0.78258955E-10_JPRB, 0.79853506E-10_JPRB, 0.81384816E-10_JPRB, &
  & 0.82792558E-10_JPRB, 0.84015545E-10_JPRB, 0.84997086E-10_JPRB, 0.85729937E-10_JPRB, 0.86242583E-10_JPRB, 0.86592018E-10_JPRB, &
  & 0.86827469E-10_JPRB, 0.86989506E-10_JPRB, 0.87105434E-10_JPRB, 0.87188159E-10_JPRB, 0.87244045E-10_JPRB, 0.87270122E-10_JPRB, &
  & 0.87265216E-10_JPRB, 0.87224040E-10_JPRB, 0.87147671E-10_JPRB, 0.87041332E-10_JPRB, 0.86911443E-10_JPRB, 0.86763048E-10_JPRB, &
  & 0.86594704E-10_JPRB, 0.86400435E-10_JPRB, 0.86166935E-10_JPRB, 0.85876271E-10_JPRB, 0.85506588E-10_JPRB, 0.85038893E-10_JPRB, &
  & 0.84461778E-10_JPRB, 0.83779463E-10_JPRB, 0.83003368E-10_JPRB, 0.82155574E-10_JPRB, 0.81220107E-10_JPRB, 0.80171737E-10_JPRB, &
  & 0.78994929E-10_JPRB, 0.77715459E-10_JPRB, 0.76413445E-10_JPRB, 0.75197806E-10_JPRB, 0.74112702E-10_JPRB, 0.73144914E-10_JPRB, &
  & 0.72245585E-10_JPRB, 0.71371645E-10_JPRB, 0.70498871E-10_JPRB, 0.69637983E-10_JPRB, 0.68826084E-10_JPRB, 0.68090138E-10_JPRB, &
  & 0.67426439E-10_JPRB, 0.66796652E-10_JPRB, 0.66113018E-10_JPRB, 0.64974956E-10_JPRB /)

RGHG9(:,43, 4) = (/ &
  & 0.64130992E-10_JPRB, 0.65651852E-10_JPRB, 0.66630965E-10_JPRB, 0.67625898E-10_JPRB, 0.68706561E-10_JPRB, 0.69733802E-10_JPRB, &
  & 0.70610656E-10_JPRB, 0.71340232E-10_JPRB, 0.71997901E-10_JPRB, 0.72648720E-10_JPRB, 0.73362726E-10_JPRB, 0.74208542E-10_JPRB, &
  & 0.75239592E-10_JPRB, 0.76471558E-10_JPRB, 0.77860260E-10_JPRB, 0.79328738E-10_JPRB, 0.80799728E-10_JPRB, 0.82207338E-10_JPRB, &
  & 0.83481708E-10_JPRB, 0.84559429E-10_JPRB, 0.85405356E-10_JPRB, 0.86026672E-10_JPRB, 0.86460644E-10_JPRB, 0.86757726E-10_JPRB, &
  & 0.86959925E-10_JPRB, 0.87101562E-10_JPRB, 0.87204487E-10_JPRB, 0.87280100E-10_JPRB, 0.87332586E-10_JPRB, 0.87358648E-10_JPRB, &
  & 0.87356046E-10_JPRB, 0.87319429E-10_JPRB, 0.87249041E-10_JPRB, 0.87149982E-10_JPRB, 0.87028662E-10_JPRB, 0.86889849E-10_JPRB, &
  & 0.86734377E-10_JPRB, 0.86556852E-10_JPRB, 0.86347450E-10_JPRB, 0.86092293E-10_JPRB, 0.85775199E-10_JPRB, 0.85382298E-10_JPRB, &
  & 0.84904639E-10_JPRB, 0.84332319E-10_JPRB, 0.83671889E-10_JPRB, 0.82918547E-10_JPRB, 0.82071114E-10_JPRB, 0.81098496E-10_JPRB, &
  & 0.79984609E-10_JPRB, 0.78755370E-10_JPRB, 0.77508791E-10_JPRB, 0.76355360E-10_JPRB, 0.75349740E-10_JPRB, 0.74467793E-10_JPRB, &
  & 0.73659377E-10_JPRB, 0.72877593E-10_JPRB, 0.72100791E-10_JPRB, 0.71340836E-10_JPRB, 0.70632708E-10_JPRB, 0.69997549E-10_JPRB, &
  & 0.69424529E-10_JPRB, 0.68874260E-10_JPRB, 0.68264477E-10_JPRB, 0.67228320E-10_JPRB /)

RGHG9(:,44, 4) = (/ &
  & 0.66544527E-10_JPRB, 0.67990315E-10_JPRB, 0.68913077E-10_JPRB, 0.69885819E-10_JPRB, 0.70940885E-10_JPRB, 0.71946102E-10_JPRB, &
  & 0.72755128E-10_JPRB, 0.73407135E-10_JPRB, 0.73959658E-10_JPRB, 0.74496576E-10_JPRB, 0.75078443E-10_JPRB, 0.75778911E-10_JPRB, &
  & 0.76661490E-10_JPRB, 0.77751527E-10_JPRB, 0.79009972E-10_JPRB, 0.80354445E-10_JPRB, 0.81702971E-10_JPRB, 0.82973829E-10_JPRB, &
  & 0.84103016E-10_JPRB, 0.85028894E-10_JPRB, 0.85743440E-10_JPRB, 0.86265661E-10_JPRB, 0.86634117E-10_JPRB, 0.86889468E-10_JPRB, &
  & 0.87066659E-10_JPRB, 0.87192906E-10_JPRB, 0.87286685E-10_JPRB, 0.87357080E-10_JPRB, 0.87407311E-10_JPRB, 0.87433435E-10_JPRB, &
  & 0.87432672E-10_JPRB, 0.87399761E-10_JPRB, 0.87334355E-10_JPRB, 0.87241332E-10_JPRB, 0.87126181E-10_JPRB, 0.86994814E-10_JPRB, &
  & 0.86848369E-10_JPRB, 0.86683841E-10_JPRB, 0.86493715E-10_JPRB, 0.86268048E-10_JPRB, 0.85996689E-10_JPRB, 0.85672289E-10_JPRB, &
  & 0.85287256E-10_JPRB, 0.84833363E-10_JPRB, 0.84289617E-10_JPRB, 0.83653320E-10_JPRB, 0.82896648E-10_JPRB, 0.82001836E-10_JPRB, &
  & 0.80953286E-10_JPRB, 0.79784873E-10_JPRB, 0.78598524E-10_JPRB, 0.77521010E-10_JPRB, 0.76597936E-10_JPRB, 0.75801941E-10_JPRB, &
  & 0.75076861E-10_JPRB, 0.74379419E-10_JPRB, 0.73687480E-10_JPRB, 0.73015496E-10_JPRB, 0.72396998E-10_JPRB, 0.71848423E-10_JPRB, &
  & 0.71354728E-10_JPRB, 0.70876763E-10_JPRB, 0.70338027E-10_JPRB, 0.69405211E-10_JPRB /)

RGHG9(:,45, 4) = (/ &
  & 0.68860619E-10_JPRB, 0.70215986E-10_JPRB, 0.71113379E-10_JPRB, 0.72041838E-10_JPRB, 0.73084705E-10_JPRB, 0.74045846E-10_JPRB, &
  & 0.74801512E-10_JPRB, 0.75368226E-10_JPRB, 0.75836934E-10_JPRB, 0.76270074E-10_JPRB, 0.76741530E-10_JPRB, 0.77310235E-10_JPRB, &
  & 0.78053418E-10_JPRB, 0.79009736E-10_JPRB, 0.80144419E-10_JPRB, 0.81369765E-10_JPRB, 0.82581691E-10_JPRB, 0.83708339E-10_JPRB, &
  & 0.84665108E-10_JPRB, 0.85437567E-10_JPRB, 0.86024937E-10_JPRB, 0.86461192E-10_JPRB, 0.86774476E-10_JPRB, 0.86997139E-10_JPRB, &
  & 0.87154624E-10_JPRB, 0.87269685E-10_JPRB, 0.87356830E-10_JPRB, 0.87423742E-10_JPRB, 0.87472397E-10_JPRB, 0.87498619E-10_JPRB, &
  & 0.87499293E-10_JPRB, 0.87469317E-10_JPRB, 0.87408338E-10_JPRB, 0.87320012E-10_JPRB, 0.87209920E-10_JPRB, 0.87083535E-10_JPRB, &
  & 0.86943841E-10_JPRB, 0.86788958E-10_JPRB, 0.86614202E-10_JPRB, 0.86413300E-10_JPRB, 0.86181444E-10_JPRB, 0.85916892E-10_JPRB, &
  & 0.85619775E-10_JPRB, 0.85274898E-10_JPRB, 0.84866759E-10_JPRB, 0.84351637E-10_JPRB, 0.83711080E-10_JPRB, 0.82906543E-10_JPRB, &
  & 0.81931732E-10_JPRB, 0.80828469E-10_JPRB, 0.79715984E-10_JPRB, 0.78720509E-10_JPRB, 0.77884720E-10_JPRB, 0.77169209E-10_JPRB, &
  & 0.76524592E-10_JPRB, 0.75901327E-10_JPRB, 0.75284827E-10_JPRB, 0.74688346E-10_JPRB, 0.74145731E-10_JPRB, 0.73669744E-10_JPRB, &
  & 0.73244147E-10_JPRB, 0.72829721E-10_JPRB, 0.72358668E-10_JPRB, 0.71529102E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART7',1,ZHOOK_HANDLE)
END SUBROUTINE PART7




SUBROUTINE PART8
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART8',0,ZHOOK_HANDLE)



RGHG9(:,46, 4) = (/ &
  & 0.71053219E-10_JPRB, 0.72343354E-10_JPRB, 0.73202375E-10_JPRB, 0.74109330E-10_JPRB, 0.75118765E-10_JPRB, 0.76043775E-10_JPRB, &
  & 0.76734327E-10_JPRB, 0.77234164E-10_JPRB, 0.77623179E-10_JPRB, 0.77981351E-10_JPRB, 0.78356127E-10_JPRB, 0.78823129E-10_JPRB, &
  & 0.79442120E-10_JPRB, 0.80272816E-10_JPRB, 0.81292251E-10_JPRB, 0.82385362E-10_JPRB, 0.83455062E-10_JPRB, 0.84392993E-10_JPRB, &
  & 0.85175388E-10_JPRB, 0.85785191E-10_JPRB, 0.86260624E-10_JPRB, 0.86620891E-10_JPRB, 0.86889565E-10_JPRB, 0.87085700E-10_JPRB, &
  & 0.87228405E-10_JPRB, 0.87335264E-10_JPRB, 0.87417656E-10_JPRB, 0.87482466E-10_JPRB, 0.87530178E-10_JPRB, 0.87556448E-10_JPRB, &
  & 0.87558204E-10_JPRB, 0.87530712E-10_JPRB, 0.87473175E-10_JPRB, 0.87389110E-10_JPRB, 0.87282494E-10_JPRB, 0.87159877E-10_JPRB, &
  & 0.87024624E-10_JPRB, 0.86877214E-10_JPRB, 0.86714733E-10_JPRB, 0.86534536E-10_JPRB, 0.86336098E-10_JPRB, 0.86124149E-10_JPRB, &
  & 0.85899982E-10_JPRB, 0.85659341E-10_JPRB, 0.85370787E-10_JPRB, 0.85001978E-10_JPRB, 0.84493225E-10_JPRB, 0.83810098E-10_JPRB, &
  & 0.82929906E-10_JPRB, 0.81905344E-10_JPRB, 0.80871310E-10_JPRB, 0.79964986E-10_JPRB, 0.79212310E-10_JPRB, 0.78580642E-10_JPRB, &
  & 0.78004110E-10_JPRB, 0.77451885E-10_JPRB, 0.76900167E-10_JPRB, 0.76369536E-10_JPRB, 0.75890461E-10_JPRB, 0.75475591E-10_JPRB, &
  & 0.75106595E-10_JPRB, 0.74749013E-10_JPRB, 0.74338431E-10_JPRB, 0.73613365E-10_JPRB /)

RGHG9(:,47, 4) = (/ &
  & 0.73096362E-10_JPRB, 0.74360754E-10_JPRB, 0.75174394E-10_JPRB, 0.76069956E-10_JPRB, 0.77042747E-10_JPRB, 0.77925957E-10_JPRB, &
  & 0.78558951E-10_JPRB, 0.78994145E-10_JPRB, 0.79327767E-10_JPRB, 0.79618534E-10_JPRB, 0.79931839E-10_JPRB, 0.80308149E-10_JPRB, &
  & 0.80833694E-10_JPRB, 0.81555540E-10_JPRB, 0.82447417E-10_JPRB, 0.83404700E-10_JPRB, 0.84279222E-10_JPRB, 0.85023655E-10_JPRB, &
  & 0.85610061E-10_JPRB, 0.86079970E-10_JPRB, 0.86452956E-10_JPRB, 0.86751745E-10_JPRB, 0.86983601E-10_JPRB, 0.87159391E-10_JPRB, &
  & 0.87290876E-10_JPRB, 0.87391670E-10_JPRB, 0.87471204E-10_JPRB, 0.87534757E-10_JPRB, 0.87581893E-10_JPRB, 0.87608358E-10_JPRB, &
  & 0.87610905E-10_JPRB, 0.87585196E-10_JPRB, 0.87530809E-10_JPRB, 0.87449770E-10_JPRB, 0.87346047E-10_JPRB, 0.87225976E-10_JPRB, &
  & 0.87094019E-10_JPRB, 0.86952161E-10_JPRB, 0.86799783E-10_JPRB, 0.86636760E-10_JPRB, 0.86466757E-10_JPRB, 0.86296734E-10_JPRB, &
  & 0.86134877E-10_JPRB, 0.85972653E-10_JPRB, 0.85792498E-10_JPRB, 0.85547854E-10_JPRB, 0.85191507E-10_JPRB, 0.84659987E-10_JPRB, &
  & 0.83917859E-10_JPRB, 0.82999760E-10_JPRB, 0.82062149E-10_JPRB, 0.81246940E-10_JPRB, 0.80584969E-10_JPRB, 0.80022572E-10_JPRB, &
  & 0.79518517E-10_JPRB, 0.79023302E-10_JPRB, 0.78531882E-10_JPRB, 0.78056256E-10_JPRB, 0.77631596E-10_JPRB, 0.77267040E-10_JPRB, &
  & 0.76946616E-10_JPRB, 0.76635698E-10_JPRB, 0.76281037E-10_JPRB, 0.75649181E-10_JPRB /)

RGHG9(:,48, 4) = (/ &
  & 0.75021309E-10_JPRB, 0.76215416E-10_JPRB, 0.77052233E-10_JPRB, 0.77898764E-10_JPRB, 0.78867649E-10_JPRB, 0.79697200E-10_JPRB, &
  & 0.80280116E-10_JPRB, 0.80667403E-10_JPRB, 0.80951232E-10_JPRB, 0.81201323E-10_JPRB, 0.81456258E-10_JPRB, 0.81779451E-10_JPRB, &
  & 0.82215401E-10_JPRB, 0.82831297E-10_JPRB, 0.83591897E-10_JPRB, 0.84352046E-10_JPRB, 0.85019117E-10_JPRB, 0.85548617E-10_JPRB, &
  & 0.85972666E-10_JPRB, 0.86316711E-10_JPRB, 0.86610011E-10_JPRB, 0.86857375E-10_JPRB, 0.87060803E-10_JPRB, 0.87220939E-10_JPRB, &
  & 0.87344382E-10_JPRB, 0.87441200E-10_JPRB, 0.87518659E-10_JPRB, 0.87581692E-10_JPRB, 0.87628585E-10_JPRB, 0.87655154E-10_JPRB, &
  & 0.87658276E-10_JPRB, 0.87634115E-10_JPRB, 0.87581997E-10_JPRB, 0.87503504E-10_JPRB, 0.87402099E-10_JPRB, 0.87283764E-10_JPRB, &
  & 0.87154478E-10_JPRB, 0.87017067E-10_JPRB, 0.86872828E-10_JPRB, 0.86724204E-10_JPRB, 0.86576954E-10_JPRB, 0.86441854E-10_JPRB, &
  & 0.86325024E-10_JPRB, 0.86224361E-10_JPRB, 0.86117377E-10_JPRB, 0.85974242E-10_JPRB, 0.85745411E-10_JPRB, 0.85378274E-10_JPRB, &
  & 0.84811914E-10_JPRB, 0.84061438E-10_JPRB, 0.83263139E-10_JPRB, 0.82562027E-10_JPRB, 0.81988374E-10_JPRB, 0.81503596E-10_JPRB, &
  & 0.81055940E-10_JPRB, 0.80618595E-10_JPRB, 0.80174353E-10_JPRB, 0.79746910E-10_JPRB, 0.79365951E-10_JPRB, 0.79043702E-10_JPRB, &
  & 0.78761067E-10_JPRB, 0.78489729E-10_JPRB, 0.78178526E-10_JPRB, 0.77627745E-10_JPRB /)

RGHG9(:,49, 4) = (/ &
  & 0.76781817E-10_JPRB, 0.77985958E-10_JPRB, 0.78781918E-10_JPRB, 0.79651868E-10_JPRB, 0.80575879E-10_JPRB, 0.81377335E-10_JPRB, &
  & 0.81911582E-10_JPRB, 0.82257853E-10_JPRB, 0.82506744E-10_JPRB, 0.82716750E-10_JPRB, 0.82935055E-10_JPRB, 0.83192113E-10_JPRB, &
  & 0.83556662E-10_JPRB, 0.84039109E-10_JPRB, 0.84611013E-10_JPRB, 0.85156993E-10_JPRB, 0.85606022E-10_JPRB, 0.85963014E-10_JPRB, &
  & 0.86253317E-10_JPRB, 0.86505941E-10_JPRB, 0.86734515E-10_JPRB, 0.86942994E-10_JPRB, 0.87124037E-10_JPRB, 0.87273008E-10_JPRB, &
  & 0.87391150E-10_JPRB, 0.87485241E-10_JPRB, 0.87561694E-10_JPRB, 0.87624290E-10_JPRB, 0.87670836E-10_JPRB, 0.87697648E-10_JPRB, &
  & 0.87701187E-10_JPRB, 0.87678170E-10_JPRB, 0.87627933E-10_JPRB, 0.87551522E-10_JPRB, 0.87451747E-10_JPRB, 0.87335437E-10_JPRB, &
  & 0.87208088E-10_JPRB, 0.87074431E-10_JPRB, 0.86936888E-10_JPRB, 0.86799706E-10_JPRB, 0.86671295E-10_JPRB, 0.86562604E-10_JPRB, &
  & 0.86481294E-10_JPRB, 0.86420600E-10_JPRB, 0.86364575E-10_JPRB, 0.86283931E-10_JPRB, 0.86149317E-10_JPRB, 0.85913492E-10_JPRB, &
  & 0.85531908E-10_JPRB, 0.84995941E-10_JPRB, 0.84395393E-10_JPRB, 0.83856373E-10_JPRB, 0.83392779E-10_JPRB, 0.82990309E-10_JPRB, &
  & 0.82606491E-10_JPRB, 0.82218975E-10_JPRB, 0.81820398E-10_JPRB, 0.81432014E-10_JPRB, 0.81088219E-10_JPRB, 0.80798174E-10_JPRB, &
  & 0.80546569E-10_JPRB, 0.80304687E-10_JPRB, 0.80026798E-10_JPRB, 0.79537689E-10_JPRB /)

RGHG9(:,50, 4) = (/ &
  & 0.78403443E-10_JPRB, 0.79628033E-10_JPRB, 0.80418193E-10_JPRB, 0.81282134E-10_JPRB, 0.82190296E-10_JPRB, 0.82942223E-10_JPRB, &
  & 0.83426155E-10_JPRB, 0.83726366E-10_JPRB, 0.83934609E-10_JPRB, 0.84103599E-10_JPRB, 0.84268051E-10_JPRB, 0.84466233E-10_JPRB, &
  & 0.84708879E-10_JPRB, 0.85044180E-10_JPRB, 0.85408021E-10_JPRB, 0.85751878E-10_JPRB, 0.86034978E-10_JPRB, 0.86267431E-10_JPRB, &
  & 0.86467285E-10_JPRB, 0.86652956E-10_JPRB, 0.86834720E-10_JPRB, 0.87011578E-10_JPRB, 0.87176460E-10_JPRB, 0.87317820E-10_JPRB, &
  & 0.87432922E-10_JPRB, 0.87525598E-10_JPRB, 0.87601496E-10_JPRB, 0.87663460E-10_JPRB, 0.87709617E-10_JPRB, 0.87736450E-10_JPRB, &
  & 0.87740260E-10_JPRB, 0.87718256E-10_JPRB, 0.87669517E-10_JPRB, 0.87594654E-10_JPRB, 0.87496815E-10_JPRB, 0.87381928E-10_JPRB, &
  & 0.87256785E-10_JPRB, 0.87126091E-10_JPRB, 0.86993850E-10_JPRB, 0.86865980E-10_JPRB, 0.86752536E-10_JPRB, 0.86665612E-10_JPRB, &
  & 0.86609872E-10_JPRB, 0.86577745E-10_JPRB, 0.86550891E-10_JPRB, 0.86510410E-10_JPRB, 0.86430953E-10_JPRB, 0.86289087E-10_JPRB, &
  & 0.86050299E-10_JPRB, 0.85710147E-10_JPRB, 0.85341005E-10_JPRB, 0.84984672E-10_JPRB, 0.84674684E-10_JPRB, 0.84375472E-10_JPRB, &
  & 0.84080243E-10_JPRB, 0.83760672E-10_JPRB, 0.83419160E-10_JPRB, 0.83075546E-10_JPRB, 0.82767959E-10_JPRB, 0.82508902E-10_JPRB, &
  & 0.82282660E-10_JPRB, 0.82062995E-10_JPRB, 0.81812751E-10_JPRB, 0.81363132E-10_JPRB /)

RGHG9(:,51, 4) = (/ &
  & 0.79959608E-10_JPRB, 0.81096768E-10_JPRB, 0.81965365E-10_JPRB, 0.82765919E-10_JPRB, 0.83650906E-10_JPRB, 0.84310878E-10_JPRB, &
  & 0.84709385E-10_JPRB, 0.84940256E-10_JPRB, 0.85087631E-10_JPRB, 0.85202047E-10_JPRB, 0.85307497E-10_JPRB, 0.85418034E-10_JPRB, &
  & 0.85569100E-10_JPRB, 0.85743634E-10_JPRB, 0.85958234E-10_JPRB, 0.86158240E-10_JPRB, 0.86335189E-10_JPRB, 0.86488025E-10_JPRB, &
  & 0.86629329E-10_JPRB, 0.86769175E-10_JPRB, 0.86915121E-10_JPRB, 0.87069227E-10_JPRB, 0.87220564E-10_JPRB, 0.87357510E-10_JPRB, &
  & 0.87471266E-10_JPRB, 0.87563706E-10_JPRB, 0.87639007E-10_JPRB, 0.87700222E-10_JPRB, 0.87745665E-10_JPRB, 0.87772227E-10_JPRB, &
  & 0.87776175E-10_JPRB, 0.87754942E-10_JPRB, 0.87707390E-10_JPRB, 0.87633970E-10_JPRB, 0.87537755E-10_JPRB, 0.87424679E-10_JPRB, &
  & 0.87301416E-10_JPRB, 0.87173282E-10_JPRB, 0.87045336E-10_JPRB, 0.86925064E-10_JPRB, 0.86824194E-10_JPRB, 0.86755152E-10_JPRB, &
  & 0.86719541E-10_JPRB, 0.86705795E-10_JPRB, 0.86697947E-10_JPRB, 0.86678970E-10_JPRB, 0.86635636E-10_JPRB, 0.86549254E-10_JPRB, &
  & 0.86405036E-10_JPRB, 0.86214869E-10_JPRB, 0.86007201E-10_JPRB, 0.85824362E-10_JPRB, 0.85648419E-10_JPRB, 0.85479790E-10_JPRB, &
  & 0.85292655E-10_JPRB, 0.85078798E-10_JPRB, 0.84827249E-10_JPRB, 0.84559720E-10_JPRB, 0.84308421E-10_JPRB, 0.84089541E-10_JPRB, &
  & 0.83895099E-10_JPRB, 0.83704335E-10_JPRB, 0.83474276E-10_JPRB, 0.83072556E-10_JPRB /)

RGHG9(:,52, 4) = (/ &
  & 0.81275993E-10_JPRB, 0.82564115E-10_JPRB, 0.83261759E-10_JPRB, 0.84110205E-10_JPRB, 0.84829095E-10_JPRB, 0.85355098E-10_JPRB, &
  & 0.85629781E-10_JPRB, 0.85775116E-10_JPRB, 0.85863823E-10_JPRB, 0.85925857E-10_JPRB, 0.85979737E-10_JPRB, 0.86039426E-10_JPRB, &
  & 0.86104589E-10_JPRB, 0.86203433E-10_JPRB, 0.86313255E-10_JPRB, 0.86433846E-10_JPRB, 0.86545590E-10_JPRB, 0.86650936E-10_JPRB, &
  & 0.86753917E-10_JPRB, 0.86862732E-10_JPRB, 0.86983684E-10_JPRB, 0.87117889E-10_JPRB, 0.87260386E-10_JPRB, 0.87393960E-10_JPRB, &
  & 0.87507480E-10_JPRB, 0.87600038E-10_JPRB, 0.87674902E-10_JPRB, 0.87735152E-10_JPRB, 0.87779513E-10_JPRB, 0.87805554E-10_JPRB, &
  & 0.87809385E-10_JPRB, 0.87788700E-10_JPRB, 0.87742147E-10_JPRB, 0.87670024E-10_JPRB, 0.87575489E-10_JPRB, 0.87464209E-10_JPRB, &
  & 0.87342723E-10_JPRB, 0.87216880E-10_JPRB, 0.87092694E-10_JPRB, 0.86979035E-10_JPRB, 0.86889537E-10_JPRB, 0.86835247E-10_JPRB, &
  & 0.86814826E-10_JPRB, 0.86814160E-10_JPRB, 0.86817754E-10_JPRB, 0.86813015E-10_JPRB, 0.86789395E-10_JPRB, 0.86738963E-10_JPRB, &
  & 0.86653976E-10_JPRB, 0.86546367E-10_JPRB, 0.86446669E-10_JPRB, 0.86356228E-10_JPRB, 0.86277110E-10_JPRB, 0.86195759E-10_JPRB, &
  & 0.86104561E-10_JPRB, 0.85991346E-10_JPRB, 0.85847378E-10_JPRB, 0.85678749E-10_JPRB, 0.85509988E-10_JPRB, 0.85357534E-10_JPRB, &
  & 0.85215189E-10_JPRB, 0.85066371E-10_JPRB, 0.84888166E-10_JPRB, 0.84534837E-10_JPRB /)

RGHG9(:,53, 4) = (/ &
  & 0.82597006E-10_JPRB, 0.83653716E-10_JPRB, 0.84485641E-10_JPRB, 0.85092648E-10_JPRB, 0.85691995E-10_JPRB, 0.86033056E-10_JPRB, &
  & 0.86200339E-10_JPRB, 0.86282467E-10_JPRB, 0.86328333E-10_JPRB, 0.86360447E-10_JPRB, 0.86386925E-10_JPRB, 0.86412114E-10_JPRB, &
  & 0.86447918E-10_JPRB, 0.86490287E-10_JPRB, 0.86554999E-10_JPRB, 0.86625623E-10_JPRB, 0.86700064E-10_JPRB, 0.86774810E-10_JPRB, &
  & 0.86853545E-10_JPRB, 0.86940996E-10_JPRB, 0.87043053E-10_JPRB, 0.87164317E-10_JPRB, 0.87297468E-10_JPRB, 0.87428884E-10_JPRB, &
  & 0.87542404E-10_JPRB, 0.87634872E-10_JPRB, 0.87709277E-10_JPRB, 0.87768348E-10_JPRB, 0.87811661E-10_JPRB, 0.87836759E-10_JPRB, &
  & 0.87840277E-10_JPRB, 0.87819918E-10_JPRB, 0.87774170E-10_JPRB, 0.87703254E-10_JPRB, 0.87610363E-10_JPRB, 0.87500805E-10_JPRB, &
  & 0.87381199E-10_JPRB, 0.87257507E-10_JPRB, 0.87137089E-10_JPRB, 0.87030168E-10_JPRB, 0.86950391E-10_JPRB, 0.86908640E-10_JPRB, &
  & 0.86899779E-10_JPRB, 0.86908487E-10_JPRB, 0.86919763E-10_JPRB, 0.86923913E-10_JPRB, 0.86913865E-10_JPRB, 0.86883681E-10_JPRB, &
  & 0.86832763E-10_JPRB, 0.86776697E-10_JPRB, 0.86725252E-10_JPRB, 0.86685388E-10_JPRB, 0.86649798E-10_JPRB, 0.86614167E-10_JPRB, &
  & 0.86573707E-10_JPRB, 0.86520194E-10_JPRB, 0.86449292E-10_JPRB, 0.86360738E-10_JPRB, 0.86268638E-10_JPRB, 0.86181021E-10_JPRB, &
  & 0.86098066E-10_JPRB, 0.86009477E-10_JPRB, 0.85887672E-10_JPRB, 0.85648759E-10_JPRB /)

RGHG9(:,54, 4) = (/ &
  & 0.83589399E-10_JPRB, 0.84758860E-10_JPRB, 0.85294688E-10_JPRB, 0.85856738E-10_JPRB, 0.86230391E-10_JPRB, 0.86449140E-10_JPRB, &
  & 0.86543453E-10_JPRB, 0.86587695E-10_JPRB, 0.86612259E-10_JPRB, 0.86628191E-10_JPRB, 0.86640750E-10_JPRB, 0.86653816E-10_JPRB, &
  & 0.86667520E-10_JPRB, 0.86692056E-10_JPRB, 0.86724218E-10_JPRB, 0.86768814E-10_JPRB, 0.86818747E-10_JPRB, 0.86873994E-10_JPRB, &
  & 0.86935931E-10_JPRB, 0.87008969E-10_JPRB, 0.87098627E-10_JPRB, 0.87208185E-10_JPRB, 0.87335777E-10_JPRB, 0.87463425E-10_JPRB, &
  & 0.87576044E-10_JPRB, 0.87668109E-10_JPRB, 0.87741939E-10_JPRB, 0.87800156E-10_JPRB, 0.87842032E-10_JPRB, 0.87866235E-10_JPRB, &
  & 0.87869198E-10_JPRB, 0.87848825E-10_JPRB, 0.87803750E-10_JPRB, 0.87733952E-10_JPRB, 0.87642754E-10_JPRB, 0.87535021E-10_JPRB, &
  & 0.87417129E-10_JPRB, 0.87295990E-10_JPRB, 0.87179777E-10_JPRB, 0.87079462E-10_JPRB, 0.87009115E-10_JPRB, 0.86976933E-10_JPRB, &
  & 0.86976759E-10_JPRB, 0.86992198E-10_JPRB, 0.87009948E-10_JPRB, 0.87020197E-10_JPRB, 0.87018226E-10_JPRB, 0.87001156E-10_JPRB, &
  & 0.86971097E-10_JPRB, 0.86939220E-10_JPRB, 0.86914462E-10_JPRB, 0.86895435E-10_JPRB, 0.86879101E-10_JPRB, 0.86863461E-10_JPRB, &
  & 0.86844434E-10_JPRB, 0.86820204E-10_JPRB, 0.86785398E-10_JPRB, 0.86741364E-10_JPRB, 0.86693944E-10_JPRB, 0.86650812E-10_JPRB, &
  & 0.86609234E-10_JPRB, 0.86564915E-10_JPRB, 0.86510452E-10_JPRB, 0.86397570E-10_JPRB /)

RGHG9(:,55, 4) = (/ &
  & 0.84563273E-10_JPRB, 0.85449356E-10_JPRB, 0.85984934E-10_JPRB, 0.86320374E-10_JPRB, 0.86580590E-10_JPRB, 0.86707357E-10_JPRB, &
  & 0.86761889E-10_JPRB, 0.86786682E-10_JPRB, 0.86799679E-10_JPRB, 0.86808144E-10_JPRB, 0.86814667E-10_JPRB, 0.86820238E-10_JPRB, &
  & 0.86827823E-10_JPRB, 0.86837364E-10_JPRB, 0.86856022E-10_JPRB, 0.86881863E-10_JPRB, 0.86915891E-10_JPRB, 0.86957094E-10_JPRB, &
  & 0.87007443E-10_JPRB, 0.87070268E-10_JPRB, 0.87150974E-10_JPRB, 0.87253996E-10_JPRB, 0.87374441E-10_JPRB, 0.87498529E-10_JPRB, &
  & 0.87608677E-10_JPRB, 0.87699792E-10_JPRB, 0.87773205E-10_JPRB, 0.87830243E-10_JPRB, 0.87871176E-10_JPRB, 0.87894129E-10_JPRB, &
  & 0.87896357E-10_JPRB, 0.87875762E-10_JPRB, 0.87831124E-10_JPRB, 0.87762637E-10_JPRB, 0.87672973E-10_JPRB, 0.87567190E-10_JPRB, &
  & 0.87451366E-10_JPRB, 0.87332988E-10_JPRB, 0.87221556E-10_JPRB, 0.87128381E-10_JPRB, 0.87065959E-10_JPRB, 0.87041513E-10_JPRB, &
  & 0.87047529E-10_JPRB, 0.87068783E-10_JPRB, 0.87090932E-10_JPRB, 0.87106489E-10_JPRB, 0.87110069E-10_JPRB, 0.87100605E-10_JPRB, &
  & 0.87081807E-10_JPRB, 0.87064370E-10_JPRB, 0.87050755E-10_JPRB, 0.87041138E-10_JPRB, 0.87033200E-10_JPRB, 0.87025213E-10_JPRB, &
  & 0.87016248E-10_JPRB, 0.87003751E-10_JPRB, 0.86986515E-10_JPRB, 0.86963603E-10_JPRB, 0.86939581E-10_JPRB, 0.86916696E-10_JPRB, &
  & 0.86895949E-10_JPRB, 0.86873397E-10_JPRB, 0.86840792E-10_JPRB, 0.86765845E-10_JPRB /)

RGHG9(:,56, 4) = (/ &
  & 0.85300766E-10_JPRB, 0.86081968E-10_JPRB, 0.86402524E-10_JPRB, 0.86649132E-10_JPRB, 0.86804328E-10_JPRB, 0.86882293E-10_JPRB, &
  & 0.86914878E-10_JPRB, 0.86928978E-10_JPRB, 0.86936604E-10_JPRB, 0.86941308E-10_JPRB, 0.86944701E-10_JPRB, 0.86947755E-10_JPRB, &
  & 0.86950488E-10_JPRB, 0.86955332E-10_JPRB, 0.86963207E-10_JPRB, 0.86978105E-10_JPRB, 0.87000053E-10_JPRB, 0.87030730E-10_JPRB, &
  & 0.87071975E-10_JPRB, 0.87127763E-10_JPRB, 0.87202384E-10_JPRB, 0.87299501E-10_JPRB, 0.87415082E-10_JPRB, 0.87533557E-10_JPRB, &
  & 0.87640659E-10_JPRB, 0.87730476E-10_JPRB, 0.87803070E-10_JPRB, 0.87859497E-10_JPRB, 0.87899028E-10_JPRB, 0.87920851E-10_JPRB, &
  & 0.87922163E-10_JPRB, 0.87901096E-10_JPRB, 0.87856791E-10_JPRB, 0.87789484E-10_JPRB, 0.87701672E-10_JPRB, 0.87597887E-10_JPRB, &
  & 0.87484381E-10_JPRB, 0.87369521E-10_JPRB, 0.87263280E-10_JPRB, 0.87176856E-10_JPRB, 0.87121886E-10_JPRB, 0.87103415E-10_JPRB, &
  & 0.87114024E-10_JPRB, 0.87139247E-10_JPRB, 0.87166052E-10_JPRB, 0.87185210E-10_JPRB, 0.87192878E-10_JPRB, 0.87188139E-10_JPRB, &
  & 0.87176308E-10_JPRB, 0.87165053E-10_JPRB, 0.87157226E-10_JPRB, 0.87151654E-10_JPRB, 0.87146942E-10_JPRB, 0.87142640E-10_JPRB, &
  & 0.87137360E-10_JPRB, 0.87130712E-10_JPRB, 0.87120935E-10_JPRB, 0.87108383E-10_JPRB, 0.87094817E-10_JPRB, 0.87083299E-10_JPRB, &
  & 0.87072849E-10_JPRB, 0.87063141E-10_JPRB, 0.87053552E-10_JPRB, 0.87042033E-10_JPRB /)

RGHG9(:,57, 4) = (/ &
  & 0.85910161E-10_JPRB, 0.86478408E-10_JPRB, 0.86713983E-10_JPRB, 0.86865529E-10_JPRB, 0.86961917E-10_JPRB, 0.87011245E-10_JPRB, &
  & 0.87031181E-10_JPRB, 0.87040382E-10_JPRB, 0.87044975E-10_JPRB, 0.87047904E-10_JPRB, 0.87050020E-10_JPRB, 0.87051533E-10_JPRB, &
  & 0.87052948E-10_JPRB, 0.87054260E-10_JPRB, 0.87057375E-10_JPRB, 0.87064037E-10_JPRB, 0.87077054E-10_JPRB, 0.87098981E-10_JPRB, &
  & 0.87133044E-10_JPRB, 0.87182858E-10_JPRB, 0.87253149E-10_JPRB, 0.87345825E-10_JPRB, 0.87455529E-10_JPRB, 0.87568890E-10_JPRB, &
  & 0.87672446E-10_JPRB, 0.87760618E-10_JPRB, 0.87832568E-10_JPRB, 0.87887850E-10_JPRB, 0.87926270E-10_JPRB, 0.87946636E-10_JPRB, &
  & 0.87946900E-10_JPRB, 0.87925313E-10_JPRB, 0.87881188E-10_JPRB, 0.87815047E-10_JPRB, 0.87729060E-10_JPRB, 0.87627607E-10_JPRB, &
  & 0.87517167E-10_JPRB, 0.87406055E-10_JPRB, 0.87305371E-10_JPRB, 0.87225609E-10_JPRB, 0.87176925E-10_JPRB, 0.87163429E-10_JPRB, &
  & 0.87177550E-10_JPRB, 0.87205888E-10_JPRB, 0.87235767E-10_JPRB, 0.87258506E-10_JPRB, 0.87269046E-10_JPRB, 0.87267374E-10_JPRB, &
  & 0.87258881E-10_JPRB, 0.87251262E-10_JPRB, 0.87245496E-10_JPRB, 0.87241422E-10_JPRB, 0.87238078E-10_JPRB, 0.87234817E-10_JPRB, &
  & 0.87231271E-10_JPRB, 0.87226629E-10_JPRB, 0.87220287E-10_JPRB, 0.87212126E-10_JPRB, 0.87203661E-10_JPRB, 0.87195917E-10_JPRB, &
  & 0.87189311E-10_JPRB, 0.87182539E-10_JPRB, 0.87174032E-10_JPRB, 0.87159370E-10_JPRB /)

RGHG9(:,58, 4) = (/ &
  & 0.86474952E-10_JPRB, 0.86790103E-10_JPRB, 0.86930421E-10_JPRB, 0.87019503E-10_JPRB, 0.87082550E-10_JPRB, 0.87113261E-10_JPRB, &
  & 0.87127243E-10_JPRB, 0.87133196E-10_JPRB, 0.87136562E-10_JPRB, 0.87138616E-10_JPRB, 0.87140101E-10_JPRB, 0.87141259E-10_JPRB, &
  & 0.87141933E-10_JPRB, 0.87142196E-10_JPRB, 0.87142377E-10_JPRB, 0.87144028E-10_JPRB, 0.87150100E-10_JPRB, 0.87164831E-10_JPRB, &
  & 0.87192351E-10_JPRB, 0.87237578E-10_JPRB, 0.87303470E-10_JPRB, 0.87391788E-10_JPRB, 0.87496281E-10_JPRB, 0.87604445E-10_JPRB, &
  & 0.87704621E-10_JPRB, 0.87791135E-10_JPRB, 0.87861815E-10_JPRB, 0.87916077E-10_JPRB, 0.87952985E-10_JPRB, 0.87971824E-10_JPRB, &
  & 0.87970936E-10_JPRB, 0.87948822E-10_JPRB, 0.87904760E-10_JPRB, 0.87839694E-10_JPRB, 0.87755775E-10_JPRB, 0.87656972E-10_JPRB, &
  & 0.87549856E-10_JPRB, 0.87443545E-10_JPRB, 0.87348254E-10_JPRB, 0.87274646E-10_JPRB, 0.87231597E-10_JPRB, 0.87222091E-10_JPRB, &
  & 0.87238938E-10_JPRB, 0.87269532E-10_JPRB, 0.87301846E-10_JPRB, 0.87327007E-10_JPRB, 0.87340156E-10_JPRB, 0.87340593E-10_JPRB, &
  & 0.87334251E-10_JPRB, 0.87327479E-10_JPRB, 0.87322538E-10_JPRB, 0.87318722E-10_JPRB, 0.87315474E-10_JPRB, 0.87312560E-10_JPRB, &
  & 0.87309271E-10_JPRB, 0.87305413E-10_JPRB, 0.87300250E-10_JPRB, 0.87293887E-10_JPRB, 0.87287164E-10_JPRB, 0.87281543E-10_JPRB, &
  & 0.87276165E-10_JPRB, 0.87270746E-10_JPRB, 0.87263988E-10_JPRB, 0.87250270E-10_JPRB /)

RGHG9(:,59, 4) = (/ &
  & 0.86787702E-10_JPRB, 0.86995744E-10_JPRB, 0.87078747E-10_JPRB, 0.87139573E-10_JPRB, 0.87177598E-10_JPRB, 0.87200087E-10_JPRB, &
  & 0.87209781E-10_JPRB, 0.87214638E-10_JPRB, 0.87217247E-10_JPRB, 0.87219065E-10_JPRB, 0.87220481E-10_JPRB, 0.87221549E-10_JPRB, &
  & 0.87222368E-10_JPRB, 0.87222410E-10_JPRB, 0.87221397E-10_JPRB, 0.87219912E-10_JPRB, 0.87220765E-10_JPRB, 0.87229453E-10_JPRB, &
  & 0.87251595E-10_JPRB, 0.87291993E-10_JPRB, 0.87354027E-10_JPRB, 0.87437724E-10_JPRB, 0.87537026E-10_JPRB, 0.87640589E-10_JPRB, &
  & 0.87737664E-10_JPRB, 0.87822034E-10_JPRB, 0.87891319E-10_JPRB, 0.87944034E-10_JPRB, 0.87979367E-10_JPRB, 0.87996603E-10_JPRB, &
  & 0.87994494E-10_JPRB, 0.87971824E-10_JPRB, 0.87927922E-10_JPRB, 0.87863924E-10_JPRB, 0.87782184E-10_JPRB, 0.87686351E-10_JPRB, &
  & 0.87583454E-10_JPRB, 0.87481807E-10_JPRB, 0.87392281E-10_JPRB, 0.87324273E-10_JPRB, 0.87285977E-10_JPRB, 0.87279739E-10_JPRB, &
  & 0.87298752E-10_JPRB, 0.87330948E-10_JPRB, 0.87364886E-10_JPRB, 0.87392059E-10_JPRB, 0.87407206E-10_JPRB, 0.87409559E-10_JPRB, &
  & 0.87404042E-10_JPRB, 0.87397742E-10_JPRB, 0.87392239E-10_JPRB, 0.87387916E-10_JPRB, 0.87384294E-10_JPRB, 0.87380825E-10_JPRB, &
  & 0.87377376E-10_JPRB, 0.87373303E-10_JPRB, 0.87368265E-10_JPRB, 0.87362381E-10_JPRB, 0.87356629E-10_JPRB, 0.87351404E-10_JPRB, &
  & 0.87346866E-10_JPRB, 0.87341884E-10_JPRB, 0.87335111E-10_JPRB, 0.87321671E-10_JPRB /)

RGHG9(:,60, 4) = (/ &
  & 0.87032923E-10_JPRB, 0.87142363E-10_JPRB, 0.87196451E-10_JPRB, 0.87232180E-10_JPRB, 0.87260414E-10_JPRB, 0.87276048E-10_JPRB, &
  & 0.87284291E-10_JPRB, 0.87288281E-10_JPRB, 0.87290834E-10_JPRB, 0.87292666E-10_JPRB, 0.87294227E-10_JPRB, 0.87295698E-10_JPRB, &
  & 0.87296850E-10_JPRB, 0.87297385E-10_JPRB, 0.87296260E-10_JPRB, 0.87292867E-10_JPRB, 0.87289856E-10_JPRB, 0.87293700E-10_JPRB, &
  & 0.87310846E-10_JPRB, 0.87347102E-10_JPRB, 0.87404806E-10_JPRB, 0.87483937E-10_JPRB, 0.87578569E-10_JPRB, 0.87677664E-10_JPRB, &
  & 0.87771380E-10_JPRB, 0.87853474E-10_JPRB, 0.87920678E-10_JPRB, 0.87971602E-10_JPRB, 0.88005249E-10_JPRB, 0.88020917E-10_JPRB, &
  & 0.88017663E-10_JPRB, 0.87994501E-10_JPRB, 0.87951001E-10_JPRB, 0.87888072E-10_JPRB, 0.87808767E-10_JPRB, 0.87716355E-10_JPRB, &
  & 0.87617837E-10_JPRB, 0.87521532E-10_JPRB, 0.87437280E-10_JPRB, 0.87374490E-10_JPRB, 0.87340274E-10_JPRB, 0.87336686E-10_JPRB, &
  & 0.87357357E-10_JPRB, 0.87390664E-10_JPRB, 0.87425761E-10_JPRB, 0.87454197E-10_JPRB, 0.87471148E-10_JPRB, 0.87475291E-10_JPRB, &
  & 0.87470781E-10_JPRB, 0.87463745E-10_JPRB, 0.87457451E-10_JPRB, 0.87452046E-10_JPRB, 0.87447279E-10_JPRB, 0.87443094E-10_JPRB, &
  & 0.87438765E-10_JPRB, 0.87434122E-10_JPRB, 0.87428675E-10_JPRB, 0.87422632E-10_JPRB, 0.87416761E-10_JPRB, 0.87412015E-10_JPRB, &
  & 0.87407380E-10_JPRB, 0.87402634E-10_JPRB, 0.87396312E-10_JPRB, 0.87382969E-10_JPRB /)

RGHG9(:,61, 4) = (/ &
  & 0.87169327E-10_JPRB, 0.87249000E-10_JPRB, 0.87284721E-10_JPRB, 0.87312213E-10_JPRB, 0.87331940E-10_JPRB, 0.87345409E-10_JPRB, &
  & 0.87352459E-10_JPRB, 0.87356601E-10_JPRB, 0.87359238E-10_JPRB, 0.87361417E-10_JPRB, 0.87363443E-10_JPRB, 0.87365420E-10_JPRB, &
  & 0.87367509E-10_JPRB, 0.87368841E-10_JPRB, 0.87368057E-10_JPRB, 0.87363630E-10_JPRB, 0.87357767E-10_JPRB, 0.87357663E-10_JPRB, &
  & 0.87370694E-10_JPRB, 0.87402779E-10_JPRB, 0.87456320E-10_JPRB, 0.87531114E-10_JPRB, 0.87620883E-10_JPRB, 0.87715744E-10_JPRB, &
  & 0.87805964E-10_JPRB, 0.87885074E-10_JPRB, 0.87949863E-10_JPRB, 0.87998636E-10_JPRB, 0.88030479E-10_JPRB, 0.88044710E-10_JPRB, &
  & 0.88040492E-10_JPRB, 0.88017107E-10_JPRB, 0.87974142E-10_JPRB, 0.87912802E-10_JPRB, 0.87835912E-10_JPRB, 0.87747483E-10_JPRB, &
  & 0.87653523E-10_JPRB, 0.87562436E-10_JPRB, 0.87483472E-10_JPRB, 0.87425331E-10_JPRB, 0.87394737E-10_JPRB, 0.87393294E-10_JPRB, &
  & 0.87415096E-10_JPRB, 0.87449138E-10_JPRB, 0.87484887E-10_JPRB, 0.87514281E-10_JPRB, 0.87532585E-10_JPRB, 0.87538497E-10_JPRB, &
  & 0.87534938E-10_JPRB, 0.87527707E-10_JPRB, 0.87519866E-10_JPRB, 0.87512830E-10_JPRB, 0.87506710E-10_JPRB, 0.87500986E-10_JPRB, &
  & 0.87495622E-10_JPRB, 0.87489904E-10_JPRB, 0.87483576E-10_JPRB, 0.87477012E-10_JPRB, 0.87471211E-10_JPRB, 0.87466069E-10_JPRB, &
  & 0.87461607E-10_JPRB, 0.87456570E-10_JPRB, 0.87449707E-10_JPRB, 0.87435732E-10_JPRB /)

RGHG9(:,62, 4) = (/ &
  & 0.87278629E-10_JPRB, 0.87333765E-10_JPRB, 0.87361104E-10_JPRB, 0.87381047E-10_JPRB, 0.87397839E-10_JPRB, 0.87409295E-10_JPRB, &
  & 0.87416532E-10_JPRB, 0.87420834E-10_JPRB, 0.87424068E-10_JPRB, 0.87426774E-10_JPRB, 0.87429494E-10_JPRB, 0.87432485E-10_JPRB, &
  & 0.87435587E-10_JPRB, 0.87438286E-10_JPRB, 0.87438112E-10_JPRB, 0.87432839E-10_JPRB, 0.87424776E-10_JPRB, 0.87421605E-10_JPRB, &
  & 0.87431083E-10_JPRB, 0.87459345E-10_JPRB, 0.87508903E-10_JPRB, 0.87579326E-10_JPRB, 0.87664515E-10_JPRB, 0.87754817E-10_JPRB, &
  & 0.87841123E-10_JPRB, 0.87916896E-10_JPRB, 0.87978860E-10_JPRB, 0.88025164E-10_JPRB, 0.88055133E-10_JPRB, 0.88068004E-10_JPRB, &
  & 0.88063071E-10_JPRB, 0.88039687E-10_JPRB, 0.87997790E-10_JPRB, 0.87938289E-10_JPRB, 0.87864375E-10_JPRB, 0.87779922E-10_JPRB, &
  & 0.87690827E-10_JPRB, 0.87604916E-10_JPRB, 0.87530809E-10_JPRB, 0.87476977E-10_JPRB, 0.87449561E-10_JPRB, 0.87449895E-10_JPRB, &
  & 0.87472439E-10_JPRB, 0.87506724E-10_JPRB, 0.87542772E-10_JPRB, 0.87572762E-10_JPRB, 0.87592052E-10_JPRB, 0.87599497E-10_JPRB, &
  & 0.87597311E-10_JPRB, 0.87589831E-10_JPRB, 0.87580901E-10_JPRB, 0.87571950E-10_JPRB, 0.87563734E-10_JPRB, 0.87556393E-10_JPRB, &
  & 0.87549412E-10_JPRB, 0.87542293E-10_JPRB, 0.87534993E-10_JPRB, 0.87527749E-10_JPRB, 0.87521379E-10_JPRB, 0.87516300E-10_JPRB, &
  & 0.87511304E-10_JPRB, 0.87506030E-10_JPRB, 0.87498661E-10_JPRB, 0.87482972E-10_JPRB /)

RGHG9(:,63, 4) = (/ &
  & 0.87362118E-10_JPRB, 0.87405708E-10_JPRB, 0.87427121E-10_JPRB, 0.87444135E-10_JPRB, 0.87458298E-10_JPRB, 0.87469545E-10_JPRB, &
  & 0.87476887E-10_JPRB, 0.87482105E-10_JPRB, 0.87486005E-10_JPRB, 0.87489710E-10_JPRB, 0.87493499E-10_JPRB, 0.87497773E-10_JPRB, &
  & 0.87502616E-10_JPRB, 0.87506710E-10_JPRB, 0.87506988E-10_JPRB, 0.87500805E-10_JPRB, 0.87491098E-10_JPRB, 0.87485567E-10_JPRB, &
  & 0.87492076E-10_JPRB, 0.87516827E-10_JPRB, 0.87562707E-10_JPRB, 0.87628911E-10_JPRB, 0.87709312E-10_JPRB, 0.87794973E-10_JPRB, &
  & 0.87876921E-10_JPRB, 0.87948940E-10_JPRB, 0.88007560E-10_JPRB, 0.88051282E-10_JPRB, 0.88079148E-10_JPRB, 0.88090743E-10_JPRB, &
  & 0.88085352E-10_JPRB, 0.88062432E-10_JPRB, 0.88021902E-10_JPRB, 0.87964969E-10_JPRB, 0.87894261E-10_JPRB, 0.87814242E-10_JPRB, &
  & 0.87729837E-10_JPRB, 0.87649089E-10_JPRB, 0.87579555E-10_JPRB, 0.87529706E-10_JPRB, 0.87505142E-10_JPRB, 0.87506891E-10_JPRB, &
  & 0.87529657E-10_JPRB, 0.87563741E-10_JPRB, 0.87599664E-10_JPRB, 0.87629910E-10_JPRB, 0.87649929E-10_JPRB, 0.87658540E-10_JPRB, &
  & 0.87657534E-10_JPRB, 0.87650609E-10_JPRB, 0.87640659E-10_JPRB, 0.87630112E-10_JPRB, 0.87619759E-10_JPRB, 0.87610391E-10_JPRB, &
  & 0.87601426E-10_JPRB, 0.87592947E-10_JPRB, 0.87584169E-10_JPRB, 0.87576182E-10_JPRB, 0.87569563E-10_JPRB, 0.87563817E-10_JPRB, &
  & 0.87558655E-10_JPRB, 0.87552562E-10_JPRB, 0.87543972E-10_JPRB, 0.87525980E-10_JPRB /)

RGHG9(:,64, 4) = (/ &
  & 0.87431146E-10_JPRB, 0.87467769E-10_JPRB, 0.87486671E-10_JPRB, 0.87501589E-10_JPRB, 0.87515051E-10_JPRB, 0.87525917E-10_JPRB, &
  & 0.87534320E-10_JPRB, 0.87540239E-10_JPRB, 0.87545519E-10_JPRB, 0.87550356E-10_JPRB, 0.87555810E-10_JPRB, 0.87561985E-10_JPRB, &
  & 0.87568786E-10_JPRB, 0.87574281E-10_JPRB, 0.87574385E-10_JPRB, 0.87567217E-10_JPRB, 0.87556323E-10_JPRB, 0.87549093E-10_JPRB, &
  & 0.87553194E-10_JPRB, 0.87574933E-10_JPRB, 0.87617261E-10_JPRB, 0.87679419E-10_JPRB, 0.87754984E-10_JPRB, 0.87835739E-10_JPRB, &
  & 0.87912920E-10_JPRB, 0.87980685E-10_JPRB, 0.88035773E-10_JPRB, 0.88076449E-10_JPRB, 0.88102227E-10_JPRB, 0.88112552E-10_JPRB, &
  & 0.88106952E-10_JPRB, 0.88084803E-10_JPRB, 0.88046216E-10_JPRB, 0.87992252E-10_JPRB, 0.87925479E-10_JPRB, 0.87849901E-10_JPRB, &
  & 0.87770478E-10_JPRB, 0.87694678E-10_JPRB, 0.87629584E-10_JPRB, 0.87583371E-10_JPRB, 0.87561368E-10_JPRB, 0.87564136E-10_JPRB, &
  & 0.87586716E-10_JPRB, 0.87620043E-10_JPRB, 0.87655425E-10_JPRB, 0.87685560E-10_JPRB, 0.87705974E-10_JPRB, 0.87715384E-10_JPRB, &
  & 0.87715321E-10_JPRB, 0.87708826E-10_JPRB, 0.87698793E-10_JPRB, 0.87686872E-10_JPRB, 0.87674965E-10_JPRB, 0.87663307E-10_JPRB, &
  & 0.87652850E-10_JPRB, 0.87642262E-10_JPRB, 0.87632492E-10_JPRB, 0.87623575E-10_JPRB, 0.87616185E-10_JPRB, 0.87610162E-10_JPRB, &
  & 0.87604070E-10_JPRB, 0.87597207E-10_JPRB, 0.87587042E-10_JPRB, 0.87564671E-10_JPRB /)

RGHG9(:,65, 4) = (/ &
  & 0.87487857E-10_JPRB, 0.87522899E-10_JPRB, 0.87540739E-10_JPRB, 0.87555380E-10_JPRB, 0.87568355E-10_JPRB, 0.87579825E-10_JPRB, &
  & 0.87588638E-10_JPRB, 0.87596236E-10_JPRB, 0.87602536E-10_JPRB, 0.87609482E-10_JPRB, 0.87616789E-10_JPRB, 0.87625462E-10_JPRB, &
  & 0.87634310E-10_JPRB, 0.87640277E-10_JPRB, 0.87639673E-10_JPRB, 0.87631798E-10_JPRB, 0.87620231E-10_JPRB, 0.87611876E-10_JPRB, &
  & 0.87614138E-10_JPRB, 0.87633234E-10_JPRB, 0.87672383E-10_JPRB, 0.87730247E-10_JPRB, 0.87801134E-10_JPRB, 0.87876519E-10_JPRB, &
  & 0.87948634E-10_JPRB, 0.88011751E-10_JPRB, 0.88062752E-10_JPRB, 0.88100340E-10_JPRB, 0.88123807E-10_JPRB, 0.88132952E-10_JPRB, &
  & 0.88127283E-10_JPRB, 0.88106307E-10_JPRB, 0.88070003E-10_JPRB, 0.88019550E-10_JPRB, 0.87957093E-10_JPRB, 0.87886406E-10_JPRB, &
  & 0.87812084E-10_JPRB, 0.87741307E-10_JPRB, 0.87680613E-10_JPRB, 0.87637876E-10_JPRB, 0.87618170E-10_JPRB, 0.87621625E-10_JPRB, &
  & 0.87643524E-10_JPRB, 0.87675645E-10_JPRB, 0.87709978E-10_JPRB, 0.87739642E-10_JPRB, 0.87760119E-10_JPRB, 0.87770034E-10_JPRB, &
  & 0.87770624E-10_JPRB, 0.87764601E-10_JPRB, 0.87754387E-10_JPRB, 0.87742064E-10_JPRB, 0.87728713E-10_JPRB, 0.87715959E-10_JPRB, &
  & 0.87703303E-10_JPRB, 0.87691639E-10_JPRB, 0.87680287E-10_JPRB, 0.87670565E-10_JPRB, 0.87662599E-10_JPRB, 0.87655619E-10_JPRB, &
  & 0.87648985E-10_JPRB, 0.87640700E-10_JPRB, 0.87628196E-10_JPRB, 0.87600663E-10_JPRB /)

RGHG9(:,66, 4) = (/ &
  & 0.87536686E-10_JPRB, 0.87572491E-10_JPRB, 0.87591413E-10_JPRB, 0.87606297E-10_JPRB, 0.87619835E-10_JPRB, 0.87631624E-10_JPRB, &
  & 0.87641755E-10_JPRB, 0.87650040E-10_JPRB, 0.87658665E-10_JPRB, 0.87667040E-10_JPRB, 0.87677275E-10_JPRB, 0.87688003E-10_JPRB, &
  & 0.87698078E-10_JPRB, 0.87703747E-10_JPRB, 0.87702526E-10_JPRB, 0.87694289E-10_JPRB, 0.87682570E-10_JPRB, 0.87673611E-10_JPRB, &
  & 0.87674555E-10_JPRB, 0.87691500E-10_JPRB, 0.87727429E-10_JPRB, 0.87781317E-10_JPRB, 0.87846903E-10_JPRB, 0.87916910E-10_JPRB, &
  & 0.87983405E-10_JPRB, 0.88041546E-10_JPRB, 0.88088280E-10_JPRB, 0.88122447E-10_JPRB, 0.88143631E-10_JPRB, 0.88151576E-10_JPRB, &
  & 0.88145984E-10_JPRB, 0.88126381E-10_JPRB, 0.88092776E-10_JPRB, 0.88046029E-10_JPRB, 0.87988443E-10_JPRB, 0.87922843E-10_JPRB, &
  & 0.87854071E-10_JPRB, 0.87788353E-10_JPRB, 0.87732273E-10_JPRB, 0.87692985E-10_JPRB, 0.87675332E-10_JPRB, 0.87679149E-10_JPRB, &
  & 0.87700056E-10_JPRB, 0.87730434E-10_JPRB, 0.87763324E-10_JPRB, 0.87792051E-10_JPRB, 0.87812327E-10_JPRB, 0.87822478E-10_JPRB, &
  & 0.87823561E-10_JPRB, 0.87817892E-10_JPRB, 0.87807761E-10_JPRB, 0.87795098E-10_JPRB, 0.87781296E-10_JPRB, 0.87767238E-10_JPRB, &
  & 0.87753742E-10_JPRB, 0.87740482E-10_JPRB, 0.87728338E-10_JPRB, 0.87717639E-10_JPRB, 0.87708826E-10_JPRB, 0.87701305E-10_JPRB, &
  & 0.87693533E-10_JPRB, 0.87684124E-10_JPRB, 0.87669164E-10_JPRB, 0.87635219E-10_JPRB /)

RGHG9(:,67, 4) = (/ &
  & 0.87580006E-10_JPRB, 0.87619828E-10_JPRB, 0.87639798E-10_JPRB, 0.87656091E-10_JPRB, 0.87670371E-10_JPRB, 0.87682979E-10_JPRB, &
  & 0.87693824E-10_JPRB, 0.87703844E-10_JPRB, 0.87713441E-10_JPRB, 0.87724716E-10_JPRB, 0.87736415E-10_JPRB, 0.87748933E-10_JPRB, &
  & 0.87759050E-10_JPRB, 0.87764247E-10_JPRB, 0.87762783E-10_JPRB, 0.87754699E-10_JPRB, 0.87743188E-10_JPRB, 0.87734112E-10_JPRB, &
  & 0.87734216E-10_JPRB, 0.87749273E-10_JPRB, 0.87782309E-10_JPRB, 0.87831672E-10_JPRB, 0.87892159E-10_JPRB, 0.87956073E-10_JPRB, &
  & 0.88016941E-10_JPRB, 0.88069704E-10_JPRB, 0.88112004E-10_JPRB, 0.88142750E-10_JPRB, 0.88161603E-10_JPRB, 0.88168452E-10_JPRB, &
  & 0.88163025E-10_JPRB, 0.88144950E-10_JPRB, 0.88114127E-10_JPRB, 0.88071474E-10_JPRB, 0.88018690E-10_JPRB, 0.87958724E-10_JPRB, &
  & 0.87895503E-10_JPRB, 0.87835253E-10_JPRB, 0.87783864E-10_JPRB, 0.87748163E-10_JPRB, 0.87732474E-10_JPRB, 0.87736499E-10_JPRB, &
  & 0.87756087E-10_JPRB, 0.87784460E-10_JPRB, 0.87815401E-10_JPRB, 0.87842913E-10_JPRB, 0.87862648E-10_JPRB, 0.87872834E-10_JPRB, &
  & 0.87874236E-10_JPRB, 0.87868886E-10_JPRB, 0.87858928E-10_JPRB, 0.87846251E-10_JPRB, 0.87832130E-10_JPRB, 0.87817635E-10_JPRB, &
  & 0.87803209E-10_JPRB, 0.87789290E-10_JPRB, 0.87776258E-10_JPRB, 0.87764955E-10_JPRB, 0.87755456E-10_JPRB, 0.87747039E-10_JPRB, &
  & 0.87738754E-10_JPRB, 0.87727908E-10_JPRB, 0.87710450E-10_JPRB, 0.87670600E-10_JPRB /)

RGHG9(:,68, 4) = (/ &
  & 0.87621882E-10_JPRB, 0.87664750E-10_JPRB, 0.87687989E-10_JPRB, 0.87705350E-10_JPRB, 0.87720844E-10_JPRB, 0.87734396E-10_JPRB, &
  & 0.87746081E-10_JPRB, 0.87757163E-10_JPRB, 0.87768737E-10_JPRB, 0.87781067E-10_JPRB, 0.87794563E-10_JPRB, 0.87807164E-10_JPRB, &
  & 0.87817087E-10_JPRB, 0.87822014E-10_JPRB, 0.87820543E-10_JPRB, 0.87812896E-10_JPRB, 0.87802002E-10_JPRB, 0.87793210E-10_JPRB, &
  & 0.87792801E-10_JPRB, 0.87806235E-10_JPRB, 0.87836141E-10_JPRB, 0.87881161E-10_JPRB, 0.87935825E-10_JPRB, 0.87993821E-10_JPRB, &
  & 0.88048596E-10_JPRB, 0.88096141E-10_JPRB, 0.88133993E-10_JPRB, 0.88161339E-10_JPRB, 0.88177951E-10_JPRB, 0.88183780E-10_JPRB, &
  & 0.88178610E-10_JPRB, 0.88162103E-10_JPRB, 0.88134222E-10_JPRB, 0.88095475E-10_JPRB, 0.88047895E-10_JPRB, 0.87993342E-10_JPRB, &
  & 0.87936138E-10_JPRB, 0.87881237E-10_JPRB, 0.87834851E-10_JPRB, 0.87802814E-10_JPRB, 0.87789109E-10_JPRB, 0.87793203E-10_JPRB, &
  & 0.87811397E-10_JPRB, 0.87837404E-10_JPRB, 0.87866346E-10_JPRB, 0.87892214E-10_JPRB, 0.87911123E-10_JPRB, 0.87921115E-10_JPRB, &
  & 0.87922683E-10_JPRB, 0.87917687E-10_JPRB, 0.87908028E-10_JPRB, 0.87895531E-10_JPRB, 0.87881431E-10_JPRB, 0.87866762E-10_JPRB, &
  & 0.87852017E-10_JPRB, 0.87837626E-10_JPRB, 0.87824262E-10_JPRB, 0.87812424E-10_JPRB, 0.87802432E-10_JPRB, 0.87793633E-10_JPRB, &
  & 0.87784578E-10_JPRB, 0.87773067E-10_JPRB, 0.87753617E-10_JPRB, 0.87709132E-10_JPRB /)

RGHG9(:,69, 4) = (/ &
  & 0.87660025E-10_JPRB, 0.87710991E-10_JPRB, 0.87735742E-10_JPRB, 0.87755608E-10_JPRB, 0.87771894E-10_JPRB, 0.87786153E-10_JPRB, &
  & 0.87798824E-10_JPRB, 0.87810752E-10_JPRB, 0.87823464E-10_JPRB, 0.87836946E-10_JPRB, 0.87850636E-10_JPRB, 0.87863168E-10_JPRB, &
  & 0.87872640E-10_JPRB, 0.87877393E-10_JPRB, 0.87876047E-10_JPRB, 0.87869031E-10_JPRB, 0.87858984E-10_JPRB, 0.87850720E-10_JPRB, &
  & 0.87850047E-10_JPRB, 0.87861871E-10_JPRB, 0.87888682E-10_JPRB, 0.87928886E-10_JPRB, 0.87977903E-10_JPRB, 0.88029549E-10_JPRB, &
  & 0.88078524E-10_JPRB, 0.88120795E-10_JPRB, 0.88154331E-10_JPRB, 0.88178430E-10_JPRB, 0.88192925E-10_JPRB, 0.88197796E-10_JPRB, &
  & 0.88192967E-10_JPRB, 0.88178118E-10_JPRB, 0.88153103E-10_JPRB, 0.88118471E-10_JPRB, 0.88075693E-10_JPRB, 0.88027002E-10_JPRB, &
  & 0.87975398E-10_JPRB, 0.87926166E-10_JPRB, 0.87884693E-10_JPRB, 0.87856424E-10_JPRB, 0.87844697E-10_JPRB, 0.87848902E-10_JPRB, &
  & 0.87865513E-10_JPRB, 0.87889390E-10_JPRB, 0.87915911E-10_JPRB, 0.87940003E-10_JPRB, 0.87957766E-10_JPRB, 0.87967335E-10_JPRB, &
  & 0.87968993E-10_JPRB, 0.87964372E-10_JPRB, 0.87955108E-10_JPRB, 0.87943007E-10_JPRB, 0.87929213E-10_JPRB, 0.87914745E-10_JPRB, &
  & 0.87900090E-10_JPRB, 0.87885678E-10_JPRB, 0.87872237E-10_JPRB, 0.87860344E-10_JPRB, 0.87850172E-10_JPRB, 0.87841068E-10_JPRB, &
  & 0.87831971E-10_JPRB, 0.87819842E-10_JPRB, 0.87799087E-10_JPRB, 0.87750696E-10_JPRB /)

RGHG9(:,70, 4) = (/ &
  & 0.87699382E-10_JPRB, 0.87755685E-10_JPRB, 0.87785987E-10_JPRB, 0.87806679E-10_JPRB, 0.87824213E-10_JPRB, 0.87838840E-10_JPRB, &
  & 0.87851865E-10_JPRB, 0.87864729E-10_JPRB, 0.87877879E-10_JPRB, 0.87891694E-10_JPRB, 0.87905107E-10_JPRB, 0.87917063E-10_JPRB, &
  & 0.87925993E-10_JPRB, 0.87930441E-10_JPRB, 0.87929296E-10_JPRB, 0.87923002E-10_JPRB, 0.87913933E-10_JPRB, 0.87906432E-10_JPRB, &
  & 0.87905565E-10_JPRB, 0.87915807E-10_JPRB, 0.87939288E-10_JPRB, 0.87974752E-10_JPRB, 0.88017801E-10_JPRB, 0.88063397E-10_JPRB, &
  & 0.88106522E-10_JPRB, 0.88143777E-10_JPRB, 0.88173184E-10_JPRB, 0.88194195E-10_JPRB, 0.88206713E-10_JPRB, 0.88210730E-10_JPRB, &
  & 0.88206289E-10_JPRB, 0.88193106E-10_JPRB, 0.88170998E-10_JPRB, 0.88140294E-10_JPRB, 0.88102588E-10_JPRB, 0.88059199E-10_JPRB, &
  & 0.88013472E-10_JPRB, 0.87969666E-10_JPRB, 0.87933105E-10_JPRB, 0.87908562E-10_JPRB, 0.87898827E-10_JPRB, 0.87903046E-10_JPRB, &
  & 0.87918256E-10_JPRB, 0.87939753E-10_JPRB, 0.87964025E-10_JPRB, 0.87985959E-10_JPRB, 0.88002411E-10_JPRB, 0.88011362E-10_JPRB, &
  & 0.88013014E-10_JPRB, 0.88008795E-10_JPRB, 0.88000135E-10_JPRB, 0.87988637E-10_JPRB, 0.87975453E-10_JPRB, 0.87961596E-10_JPRB, &
  & 0.87947406E-10_JPRB, 0.87933417E-10_JPRB, 0.87920358E-10_JPRB, 0.87908757E-10_JPRB, 0.87898813E-10_JPRB, 0.87889925E-10_JPRB, &
  & 0.87880904E-10_JPRB, 0.87868962E-10_JPRB, 0.87847618E-10_JPRB, 0.87796902E-10_JPRB /)

RGHG9(:,71, 4) = (/ &
  & 0.87739850E-10_JPRB, 0.87805568E-10_JPRB, 0.87837695E-10_JPRB, 0.87860288E-10_JPRB, 0.87877705E-10_JPRB, 0.87892520E-10_JPRB, &
  & 0.87905683E-10_JPRB, 0.87918617E-10_JPRB, 0.87931981E-10_JPRB, 0.87945345E-10_JPRB, 0.87958120E-10_JPRB, 0.87969201E-10_JPRB, &
  & 0.87977306E-10_JPRB, 0.87981282E-10_JPRB, 0.87980262E-10_JPRB, 0.87974683E-10_JPRB, 0.87966648E-10_JPRB, 0.87959875E-10_JPRB, &
  & 0.87958904E-10_JPRB, 0.87967543E-10_JPRB, 0.87987756E-10_JPRB, 0.88018308E-10_JPRB, 0.88055618E-10_JPRB, 0.88095115E-10_JPRB, &
  & 0.88132737E-10_JPRB, 0.88165135E-10_JPRB, 0.88190628E-10_JPRB, 0.88208760E-10_JPRB, 0.88219425E-10_JPRB, 0.88222721E-10_JPRB, &
  & 0.88218703E-10_JPRB, 0.88207205E-10_JPRB, 0.88187908E-10_JPRB, 0.88161187E-10_JPRB, 0.88128130E-10_JPRB, 0.88090271E-10_JPRB, &
  & 0.88049998E-10_JPRB, 0.88011695E-10_JPRB, 0.87979894E-10_JPRB, 0.87958939E-10_JPRB, 0.87951056E-10_JPRB, 0.87955317E-10_JPRB, &
  & 0.87968861E-10_JPRB, 0.87988374E-10_JPRB, 0.88009877E-10_JPRB, 0.88029792E-10_JPRB, 0.88044634E-10_JPRB, 0.88052843E-10_JPRB, &
  & 0.88054453E-10_JPRB, 0.88050761E-10_JPRB, 0.88042851E-10_JPRB, 0.88032241E-10_JPRB, 0.88020043E-10_JPRB, 0.88007088E-10_JPRB, &
  & 0.87993904E-10_JPRB, 0.87980651E-10_JPRB, 0.87968424E-10_JPRB, 0.87957516E-10_JPRB, 0.87948232E-10_JPRB, 0.87939836E-10_JPRB, &
  & 0.87931426E-10_JPRB, 0.87920143E-10_JPRB, 0.87899903E-10_JPRB, 0.87851004E-10_JPRB /)

RGHG9(:,72, 4) = (/ &
  & 0.87787902E-10_JPRB, 0.87858387E-10_JPRB, 0.87893179E-10_JPRB, 0.87915633E-10_JPRB, 0.87932828E-10_JPRB, 0.87947101E-10_JPRB, &
  & 0.87960007E-10_JPRB, 0.87972754E-10_JPRB, 0.87985404E-10_JPRB, 0.87998234E-10_JPRB, 0.88009711E-10_JPRB, 0.88019633E-10_JPRB, &
  & 0.88026711E-10_JPRB, 0.88029951E-10_JPRB, 0.88028897E-10_JPRB, 0.88023880E-10_JPRB, 0.88016795E-10_JPRB, 0.88010786E-10_JPRB, &
  & 0.88009690E-10_JPRB, 0.88016802E-10_JPRB, 0.88033747E-10_JPRB, 0.88059636E-10_JPRB, 0.88091236E-10_JPRB, 0.88124931E-10_JPRB, &
  & 0.88157176E-10_JPRB, 0.88184987E-10_JPRB, 0.88206789E-10_JPRB, 0.88222235E-10_JPRB, 0.88231242E-10_JPRB, 0.88233879E-10_JPRB, &
  & 0.88230291E-10_JPRB, 0.88220452E-10_JPRB, 0.88203951E-10_JPRB, 0.88180942E-10_JPRB, 0.88152610E-10_JPRB, 0.88119845E-10_JPRB, &
  & 0.88085150E-10_JPRB, 0.88052066E-10_JPRB, 0.88024858E-10_JPRB, 0.88007365E-10_JPRB, 0.88001134E-10_JPRB, 0.88005193E-10_JPRB, &
  & 0.88017350E-10_JPRB, 0.88034323E-10_JPRB, 0.88053453E-10_JPRB, 0.88070863E-10_JPRB, 0.88084089E-10_JPRB, 0.88091472E-10_JPRB, &
  & 0.88093033E-10_JPRB, 0.88089952E-10_JPRB, 0.88082985E-10_JPRB, 0.88073583E-10_JPRB, 0.88062606E-10_JPRB, 0.88051129E-10_JPRB, &
  & 0.88039055E-10_JPRB, 0.88027245E-10_JPRB, 0.88015990E-10_JPRB, 0.88006193E-10_JPRB, 0.87997741E-10_JPRB, 0.87990178E-10_JPRB, &
  & 0.87982496E-10_JPRB, 0.87972248E-10_JPRB, 0.87953589E-10_JPRB, 0.87907640E-10_JPRB /)

RGHG9(:,73, 4) = (/ &
  & 0.87845578E-10_JPRB, 0.87916618E-10_JPRB, 0.87951119E-10_JPRB, 0.87972296E-10_JPRB, 0.87988485E-10_JPRB, 0.88001974E-10_JPRB, &
  & 0.88014158E-10_JPRB, 0.88026017E-10_JPRB, 0.88038077E-10_JPRB, 0.88049255E-10_JPRB, 0.88059747E-10_JPRB, 0.88068122E-10_JPRB, &
  & 0.88073951E-10_JPRB, 0.88076338E-10_JPRB, 0.88075006E-10_JPRB, 0.88070370E-10_JPRB, 0.88064070E-10_JPRB, 0.88058789E-10_JPRB, &
  & 0.88057617E-10_JPRB, 0.88063251E-10_JPRB, 0.88077157E-10_JPRB, 0.88098508E-10_JPRB, 0.88124730E-10_JPRB, 0.88152860E-10_JPRB, &
  & 0.88180005E-10_JPRB, 0.88203500E-10_JPRB, 0.88221777E-10_JPRB, 0.88234718E-10_JPRB, 0.88242171E-10_JPRB, 0.88244252E-10_JPRB, &
  & 0.88241130E-10_JPRB, 0.88232893E-10_JPRB, 0.88219092E-10_JPRB, 0.88199739E-10_JPRB, 0.88175640E-10_JPRB, 0.88148149E-10_JPRB, &
  & 0.88118624E-10_JPRB, 0.88090681E-10_JPRB, 0.88067872E-10_JPRB, 0.88053502E-10_JPRB, 0.88048770E-10_JPRB, 0.88052579E-10_JPRB, &
  & 0.88062981E-10_JPRB, 0.88077878E-10_JPRB, 0.88093935E-10_JPRB, 0.88109145E-10_JPRB, 0.88120546E-10_JPRB, 0.88127075E-10_JPRB, &
  & 0.88128560E-10_JPRB, 0.88126187E-10_JPRB, 0.88120275E-10_JPRB, 0.88112226E-10_JPRB, 0.88102858E-10_JPRB, 0.88092769E-10_JPRB, &
  & 0.88082638E-10_JPRB, 0.88072001E-10_JPRB, 0.88062384E-10_JPRB, 0.88053571E-10_JPRB, 0.88046292E-10_JPRB, 0.88039548E-10_JPRB, &
  & 0.88032706E-10_JPRB, 0.88023533E-10_JPRB, 0.88006644E-10_JPRB, 0.87964296E-10_JPRB /)

RGHG9(:,74, 4) = (/ &
  & 0.87906668E-10_JPRB, 0.87977250E-10_JPRB, 0.88009246E-10_JPRB, 0.88028841E-10_JPRB, 0.88043378E-10_JPRB, 0.88055674E-10_JPRB, &
  & 0.88066741E-10_JPRB, 0.88077774E-10_JPRB, 0.88087870E-10_JPRB, 0.88098376E-10_JPRB, 0.88106751E-10_JPRB, 0.88113843E-10_JPRB, &
  & 0.88118395E-10_JPRB, 0.88119838E-10_JPRB, 0.88118166E-10_JPRB, 0.88113829E-10_JPRB, 0.88108271E-10_JPRB, 0.88103649E-10_JPRB, &
  & 0.88102414E-10_JPRB, 0.88106730E-10_JPRB, 0.88117742E-10_JPRB, 0.88134972E-10_JPRB, 0.88156066E-10_JPRB, 0.88179020E-10_JPRB, &
  & 0.88201384E-10_JPRB, 0.88220736E-10_JPRB, 0.88235717E-10_JPRB, 0.88246327E-10_JPRB, 0.88252364E-10_JPRB, 0.88253967E-10_JPRB, &
  & 0.88251281E-10_JPRB, 0.88244585E-10_JPRB, 0.88233372E-10_JPRB, 0.88217336E-10_JPRB, 0.88197581E-10_JPRB, 0.88174835E-10_JPRB, &
  & 0.88150522E-10_JPRB, 0.88127429E-10_JPRB, 0.88108687E-10_JPRB, 0.88097252E-10_JPRB, 0.88093699E-10_JPRB, 0.88097071E-10_JPRB, &
  & 0.88106036E-10_JPRB, 0.88118297E-10_JPRB, 0.88131752E-10_JPRB, 0.88144457E-10_JPRB, 0.88154102E-10_JPRB, 0.88159750E-10_JPRB, &
  & 0.88161103E-10_JPRB, 0.88159396E-10_JPRB, 0.88154622E-10_JPRB, 0.88148031E-10_JPRB, 0.88140231E-10_JPRB, 0.88132016E-10_JPRB, &
  & 0.88123342E-10_JPRB, 0.88114703E-10_JPRB, 0.88106238E-10_JPRB, 0.88098966E-10_JPRB, 0.88092658E-10_JPRB, 0.88086906E-10_JPRB, &
  & 0.88080924E-10_JPRB, 0.88072778E-10_JPRB, 0.88057908E-10_JPRB, 0.88019030E-10_JPRB /)

RGHG9(:,75, 4) = (/ &
  & 0.87970534E-10_JPRB, 0.88036890E-10_JPRB, 0.88066714E-10_JPRB, 0.88083318E-10_JPRB, 0.88096030E-10_JPRB, 0.88106834E-10_JPRB, &
  & 0.88116521E-10_JPRB, 0.88125965E-10_JPRB, 0.88135027E-10_JPRB, 0.88143090E-10_JPRB, 0.88150501E-10_JPRB, 0.88155802E-10_JPRB, &
  & 0.88159230E-10_JPRB, 0.88159952E-10_JPRB, 0.88158036E-10_JPRB, 0.88154102E-10_JPRB, 0.88149252E-10_JPRB, 0.88145352E-10_JPRB, &
  & 0.88144075E-10_JPRB, 0.88147135E-10_JPRB, 0.88155629E-10_JPRB, 0.88169014E-10_JPRB, 0.88185521E-10_JPRB, 0.88203611E-10_JPRB, &
  & 0.88221451E-10_JPRB, 0.88236904E-10_JPRB, 0.88248721E-10_JPRB, 0.88257172E-10_JPRB, 0.88261898E-10_JPRB, 0.88263057E-10_JPRB, &
  & 0.88260836E-10_JPRB, 0.88255583E-10_JPRB, 0.88246771E-10_JPRB, 0.88233941E-10_JPRB, 0.88218183E-10_JPRB, 0.88200128E-10_JPRB, &
  & 0.88180643E-10_JPRB, 0.88162241E-10_JPRB, 0.88147357E-10_JPRB, 0.88138483E-10_JPRB, 0.88135936E-10_JPRB, 0.88138864E-10_JPRB, &
  & 0.88146171E-10_JPRB, 0.88156135E-10_JPRB, 0.88166759E-10_JPRB, 0.88177153E-10_JPRB, 0.88185050E-10_JPRB, 0.88189740E-10_JPRB, &
  & 0.88190913E-10_JPRB, 0.88189851E-10_JPRB, 0.88186056E-10_JPRB, 0.88180963E-10_JPRB, 0.88174745E-10_JPRB, 0.88168139E-10_JPRB, &
  & 0.88161395E-10_JPRB, 0.88154234E-10_JPRB, 0.88147489E-10_JPRB, 0.88141411E-10_JPRB, 0.88136401E-10_JPRB, 0.88131558E-10_JPRB, &
  & 0.88126478E-10_JPRB, 0.88119553E-10_JPRB, 0.88106328E-10_JPRB, 0.88071196E-10_JPRB /)

RGHG9(:,76, 4) = (/ &
  & 0.88034149E-10_JPRB, 0.88096086E-10_JPRB, 0.88121344E-10_JPRB, 0.88135096E-10_JPRB, 0.88145519E-10_JPRB, 0.88154414E-10_JPRB, &
  & 0.88162630E-10_JPRB, 0.88170519E-10_JPRB, 0.88177250E-10_JPRB, 0.88184168E-10_JPRB, 0.88189261E-10_JPRB, 0.88193459E-10_JPRB, &
  & 0.88195846E-10_JPRB, 0.88196110E-10_JPRB, 0.88194257E-10_JPRB, 0.88190913E-10_JPRB, 0.88186930E-10_JPRB, 0.88183801E-10_JPRB, &
  & 0.88182538E-10_JPRB, 0.88184592E-10_JPRB, 0.88190760E-10_JPRB, 0.88200933E-10_JPRB, 0.88213131E-10_JPRB, 0.88226731E-10_JPRB, &
  & 0.88240311E-10_JPRB, 0.88252038E-10_JPRB, 0.88260871E-10_JPRB, 0.88267331E-10_JPRB, 0.88270884E-10_JPRB, 0.88271689E-10_JPRB, &
  & 0.88269871E-10_JPRB, 0.88265957E-10_JPRB, 0.88259421E-10_JPRB, 0.88249540E-10_JPRB, 0.88237646E-10_JPRB, 0.88223845E-10_JPRB, &
  & 0.88209134E-10_JPRB, 0.88195097E-10_JPRB, 0.88183807E-10_JPRB, 0.88177285E-10_JPRB, 0.88175495E-10_JPRB, 0.88177854E-10_JPRB, &
  & 0.88183655E-10_JPRB, 0.88191253E-10_JPRB, 0.88199288E-10_JPRB, 0.88207386E-10_JPRB, 0.88213437E-10_JPRB, 0.88217274E-10_JPRB, &
  & 0.88218148E-10_JPRB, 0.88217662E-10_JPRB, 0.88214804E-10_JPRB, 0.88211036E-10_JPRB, 0.88206401E-10_JPRB, 0.88201273E-10_JPRB, &
  & 0.88196318E-10_JPRB, 0.88190830E-10_JPRB, 0.88185528E-10_JPRB, 0.88180963E-10_JPRB, 0.88177153E-10_JPRB, 0.88173358E-10_JPRB, &
  & 0.88169250E-10_JPRB, 0.88163414E-10_JPRB, 0.88152222E-10_JPRB, 0.88120122E-10_JPRB /)

RGHG9(:,77, 4) = (/ &
  & 0.88098522E-10_JPRB, 0.88151937E-10_JPRB, 0.88172955E-10_JPRB, 0.88183044E-10_JPRB, 0.88190913E-10_JPRB, 0.88198046E-10_JPRB, &
  & 0.88204152E-10_JPRB, 0.88210300E-10_JPRB, 0.88214928E-10_JPRB, 0.88219688E-10_JPRB, 0.88223290E-10_JPRB, 0.88225996E-10_JPRB, &
  & 0.88227647E-10_JPRB, 0.88227738E-10_JPRB, 0.88226204E-10_JPRB, 0.88223748E-10_JPRB, 0.88220757E-10_JPRB, 0.88218557E-10_JPRB, &
  & 0.88217440E-10_JPRB, 0.88218689E-10_JPRB, 0.88223033E-10_JPRB, 0.88230305E-10_JPRB, 0.88238722E-10_JPRB, 0.88248131E-10_JPRB, &
  & 0.88257790E-10_JPRB, 0.88266075E-10_JPRB, 0.88272126E-10_JPRB, 0.88276851E-10_JPRB, 0.88279363E-10_JPRB, 0.88279842E-10_JPRB, &
  & 0.88278385E-10_JPRB, 0.88275699E-10_JPRB, 0.88271286E-10_JPRB, 0.88264167E-10_JPRB, 0.88255708E-10_JPRB, 0.88246015E-10_JPRB, &
  & 0.88235613E-10_JPRB, 0.88225698E-10_JPRB, 0.88217739E-10_JPRB, 0.88213326E-10_JPRB, 0.88212132E-10_JPRB, 0.88213860E-10_JPRB, &
  & 0.88218037E-10_JPRB, 0.88223477E-10_JPRB, 0.88229091E-10_JPRB, 0.88234933E-10_JPRB, 0.88239284E-10_JPRB, 0.88242157E-10_JPRB, &
  & 0.88242691E-10_JPRB, 0.88242740E-10_JPRB, 0.88240637E-10_JPRB, 0.88238243E-10_JPRB, 0.88234892E-10_JPRB, 0.88231311E-10_JPRB, &
  & 0.88227980E-10_JPRB, 0.88224088E-10_JPRB, 0.88220244E-10_JPRB, 0.88217073E-10_JPRB, 0.88214575E-10_JPRB, 0.88211799E-10_JPRB, &
  & 0.88208676E-10_JPRB, 0.88204048E-10_JPRB, 0.88194715E-10_JPRB, 0.88166724E-10_JPRB /)

RGHG9(:,78, 4) = (/ &
  & 0.88161672E-10_JPRB, 0.88203077E-10_JPRB, 0.88217510E-10_JPRB, 0.88224088E-10_JPRB, 0.88229528E-10_JPRB, 0.88234572E-10_JPRB, &
  & 0.88238944E-10_JPRB, 0.88242885E-10_JPRB, 0.88245397E-10_JPRB, 0.88248339E-10_JPRB, 0.88250324E-10_JPRB, 0.88251940E-10_JPRB, &
  & 0.88252988E-10_JPRB, 0.88253169E-10_JPRB, 0.88252149E-10_JPRB, 0.88250698E-10_JPRB, 0.88248804E-10_JPRB, 0.88247611E-10_JPRB, &
  & 0.88246792E-10_JPRB, 0.88247576E-10_JPRB, 0.88250462E-10_JPRB, 0.88255611E-10_JPRB, 0.88260788E-10_JPRB, 0.88266693E-10_JPRB, &
  & 0.88272993E-10_JPRB, 0.88278364E-10_JPRB, 0.88282014E-10_JPRB, 0.88285261E-10_JPRB, 0.88286933E-10_JPRB, 0.88287176E-10_JPRB, &
  & 0.88286038E-10_JPRB, 0.88284401E-10_JPRB, 0.88281861E-10_JPRB, 0.88277094E-10_JPRB, 0.88271584E-10_JPRB, 0.88265471E-10_JPRB, &
  & 0.88258810E-10_JPRB, 0.88252419E-10_JPRB, 0.88247340E-10_JPRB, 0.88244669E-10_JPRB, 0.88243871E-10_JPRB, 0.88244967E-10_JPRB, &
  & 0.88247576E-10_JPRB, 0.88251115E-10_JPRB, 0.88254487E-10_JPRB, 0.88258401E-10_JPRB, 0.88261051E-10_JPRB, 0.88263126E-10_JPRB, &
  & 0.88263202E-10_JPRB, 0.88263709E-10_JPRB, 0.88262252E-10_JPRB, 0.88260968E-10_JPRB, 0.88258900E-10_JPRB, 0.88256423E-10_JPRB, &
  & 0.88254647E-10_JPRB, 0.88252065E-10_JPRB, 0.88249505E-10_JPRB, 0.88247631E-10_JPRB, 0.88246299E-10_JPRB, 0.88244481E-10_JPRB, &
  & 0.88242205E-10_JPRB, 0.88238673E-10_JPRB, 0.88232435E-10_JPRB, 0.88210682E-10_JPRB /)

RGHG9(:,79, 4) = (/ &
  & 0.88202681E-10_JPRB, 0.88231568E-10_JPRB, 0.88241435E-10_JPRB, 0.88245328E-10_JPRB, 0.88249442E-10_JPRB, 0.88253571E-10_JPRB, &
  & 0.88256714E-10_JPRB, 0.88259754E-10_JPRB, 0.88260885E-10_JPRB, 0.88263133E-10_JPRB, 0.88264243E-10_JPRB, 0.88265353E-10_JPRB, &
  & 0.88266158E-10_JPRB, 0.88266380E-10_JPRB, 0.88265589E-10_JPRB, 0.88264701E-10_JPRB, 0.88263397E-10_JPRB, 0.88262821E-10_JPRB, &
  & 0.88262161E-10_JPRB, 0.88262717E-10_JPRB, 0.88264972E-10_JPRB, 0.88269066E-10_JPRB, 0.88272556E-10_JPRB, 0.88276587E-10_JPRB, &
  & 0.88281139E-10_JPRB, 0.88284990E-10_JPRB, 0.88287336E-10_JPRB, 0.88289868E-10_JPRB, 0.88291069E-10_JPRB, 0.88291194E-10_JPRB, &
  & 0.88290146E-10_JPRB, 0.88289084E-10_JPRB, 0.88287641E-10_JPRB, 0.88284144E-10_JPRB, 0.88280196E-10_JPRB, 0.88276053E-10_JPRB, &
  & 0.88271321E-10_JPRB, 0.88266831E-10_JPRB, 0.88263202E-10_JPRB, 0.88261447E-10_JPRB, 0.88260781E-10_JPRB, 0.88261475E-10_JPRB, &
  & 0.88263237E-10_JPRB, 0.88265721E-10_JPRB, 0.88267893E-10_JPRB, 0.88270717E-10_JPRB, 0.88272500E-10_JPRB, 0.88274131E-10_JPRB, &
  & 0.88273874E-10_JPRB, 0.88274728E-10_JPRB, 0.88273520E-10_JPRB, 0.88272882E-10_JPRB, 0.88271383E-10_JPRB, 0.88269461E-10_JPRB, &
  & 0.88268524E-10_JPRB, 0.88266547E-10_JPRB, 0.88264597E-10_JPRB, 0.88263341E-10_JPRB, 0.88262661E-10_JPRB, 0.88261301E-10_JPRB, &
  & 0.88259434E-10_JPRB, 0.88256860E-10_JPRB, 0.88253162E-10_JPRB, 0.88238708E-10_JPRB /)

RGHG9(:,80, 4) = (/ &
  & 0.88229785E-10_JPRB, 0.88245425E-10_JPRB, 0.88251885E-10_JPRB, 0.88254515E-10_JPRB, 0.88257977E-10_JPRB, 0.88261704E-10_JPRB, &
  & 0.88264507E-10_JPRB, 0.88266922E-10_JPRB, 0.88267754E-10_JPRB, 0.88269496E-10_JPRB, 0.88270474E-10_JPRB, 0.88271307E-10_JPRB, &
  & 0.88272036E-10_JPRB, 0.88272285E-10_JPRB, 0.88271571E-10_JPRB, 0.88270932E-10_JPRB, 0.88269891E-10_JPRB, 0.88269649E-10_JPRB, &
  & 0.88269038E-10_JPRB, 0.88269489E-10_JPRB, 0.88271460E-10_JPRB, 0.88275165E-10_JPRB, 0.88277857E-10_JPRB, 0.88281035E-10_JPRB, &
  & 0.88284838E-10_JPRB, 0.88287974E-10_JPRB, 0.88289730E-10_JPRB, 0.88291957E-10_JPRB, 0.88292998E-10_JPRB, 0.88293046E-10_JPRB, &
  & 0.88292026E-10_JPRB, 0.88291256E-10_JPRB, 0.88290347E-10_JPRB, 0.88287391E-10_JPRB, 0.88284130E-10_JPRB, 0.88280876E-10_JPRB, &
  & 0.88277038E-10_JPRB, 0.88273340E-10_JPRB, 0.88270370E-10_JPRB, 0.88269003E-10_JPRB, 0.88268393E-10_JPRB, 0.88268878E-10_JPRB, &
  & 0.88270224E-10_JPRB, 0.88272264E-10_JPRB, 0.88273847E-10_JPRB, 0.88276206E-10_JPRB, 0.88277566E-10_JPRB, 0.88279023E-10_JPRB, &
  & 0.88278579E-10_JPRB, 0.88279599E-10_JPRB, 0.88278461E-10_JPRB, 0.88278086E-10_JPRB, 0.88276830E-10_JPRB, 0.88275089E-10_JPRB, &
  & 0.88274520E-10_JPRB, 0.88272792E-10_JPRB, 0.88271029E-10_JPRB, 0.88270065E-10_JPRB, 0.88269690E-10_JPRB, 0.88268504E-10_JPRB, &
  & 0.88266845E-10_JPRB, 0.88264680E-10_JPRB, 0.88263057E-10_JPRB, 0.88256999E-10_JPRB /)

RGHG9(:,81, 4) = (/ &
  & 0.88248360E-10_JPRB, 0.88251260E-10_JPRB, 0.88256319E-10_JPRB, 0.88258359E-10_JPRB, 0.88261592E-10_JPRB, 0.88265228E-10_JPRB, &
  & 0.88267643E-10_JPRB, 0.88270183E-10_JPRB, 0.88270530E-10_JPRB, 0.88272556E-10_JPRB, 0.88273180E-10_JPRB, 0.88274041E-10_JPRB, &
  & 0.88274658E-10_JPRB, 0.88274929E-10_JPRB, 0.88274235E-10_JPRB, 0.88273687E-10_JPRB, 0.88272764E-10_JPRB, 0.88272695E-10_JPRB, &
  & 0.88272098E-10_JPRB, 0.88272473E-10_JPRB, 0.88274311E-10_JPRB, 0.88277885E-10_JPRB, 0.88280175E-10_JPRB, 0.88282992E-10_JPRB, &
  & 0.88286461E-10_JPRB, 0.88289327E-10_JPRB, 0.88290777E-10_JPRB, 0.88292901E-10_JPRB, 0.88293872E-10_JPRB, 0.88293872E-10_JPRB, &
  & 0.88292859E-10_JPRB, 0.88292221E-10_JPRB, 0.88291555E-10_JPRB, 0.88288821E-10_JPRB, 0.88285865E-10_JPRB, 0.88283006E-10_JPRB, &
  & 0.88279536E-10_JPRB, 0.88276234E-10_JPRB, 0.88273541E-10_JPRB, 0.88272341E-10_JPRB, 0.88271744E-10_JPRB, 0.88272140E-10_JPRB, &
  & 0.88273298E-10_JPRB, 0.88275144E-10_JPRB, 0.88276469E-10_JPRB, 0.88278621E-10_JPRB, 0.88279786E-10_JPRB, 0.88281153E-10_JPRB, &
  & 0.88280584E-10_JPRB, 0.88281743E-10_JPRB, 0.88280591E-10_JPRB, 0.88280348E-10_JPRB, 0.88279176E-10_JPRB, 0.88277496E-10_JPRB, &
  & 0.88277136E-10_JPRB, 0.88275470E-10_JPRB, 0.88273784E-10_JPRB, 0.88272945E-10_JPRB, 0.88272702E-10_JPRB, 0.88271578E-10_JPRB, &
  & 0.88269975E-10_JPRB, 0.88267942E-10_JPRB, 0.88267144E-10_JPRB, 0.88269399E-10_JPRB /)

RGHG9(:,82, 4) = (/ &
  & 0.88249838E-10_JPRB, 0.88253196E-10_JPRB, 0.88258276E-10_JPRB, 0.88260177E-10_JPRB, 0.88263355E-10_JPRB, 0.88266838E-10_JPRB, &
  & 0.88269579E-10_JPRB, 0.88271571E-10_JPRB, 0.88272237E-10_JPRB, 0.88273638E-10_JPRB, 0.88274617E-10_JPRB, 0.88275269E-10_JPRB, &
  & 0.88275977E-10_JPRB, 0.88276220E-10_JPRB, 0.88275526E-10_JPRB, 0.88275047E-10_JPRB, 0.88274180E-10_JPRB, 0.88274200E-10_JPRB, &
  & 0.88273611E-10_JPRB, 0.88273916E-10_JPRB, 0.88275692E-10_JPRB, 0.88279203E-10_JPRB, 0.88281334E-10_JPRB, 0.88283922E-10_JPRB, &
  & 0.88287287E-10_JPRB, 0.88289986E-10_JPRB, 0.88291305E-10_JPRB, 0.88293352E-10_JPRB, 0.88294275E-10_JPRB, 0.88294289E-10_JPRB, &
  & 0.88293255E-10_JPRB, 0.88292693E-10_JPRB, 0.88292144E-10_JPRB, 0.88289522E-10_JPRB, 0.88286704E-10_JPRB, 0.88284019E-10_JPRB, &
  & 0.88280772E-10_JPRB, 0.88277642E-10_JPRB, 0.88275123E-10_JPRB, 0.88273999E-10_JPRB, 0.88273423E-10_JPRB, 0.88273770E-10_JPRB, &
  & 0.88274818E-10_JPRB, 0.88276560E-10_JPRB, 0.88277746E-10_JPRB, 0.88279828E-10_JPRB, 0.88280855E-10_JPRB, 0.88282201E-10_JPRB, &
  & 0.88281563E-10_JPRB, 0.88282805E-10_JPRB, 0.88281632E-10_JPRB, 0.88281459E-10_JPRB, 0.88280327E-10_JPRB, 0.88278676E-10_JPRB, &
  & 0.88278398E-10_JPRB, 0.88276789E-10_JPRB, 0.88275103E-10_JPRB, 0.88274318E-10_JPRB, 0.88274152E-10_JPRB, 0.88273069E-10_JPRB, &
  & 0.88271439E-10_JPRB, 0.88269364E-10_JPRB, 0.88268497E-10_JPRB, 0.88270377E-10_JPRB /)

RGHG9(:,83, 4) = (/ &
  & 0.88250844E-10_JPRB, 0.88254348E-10_JPRB, 0.88259358E-10_JPRB, 0.88261211E-10_JPRB, 0.88264278E-10_JPRB, 0.88267983E-10_JPRB, &
  & 0.88269982E-10_JPRB, 0.88272646E-10_JPRB, 0.88272750E-10_JPRB, 0.88274860E-10_JPRB, 0.88275304E-10_JPRB, 0.88276143E-10_JPRB, &
  & 0.88276678E-10_JPRB, 0.88276941E-10_JPRB, 0.88276261E-10_JPRB, 0.88275810E-10_JPRB, 0.88274985E-10_JPRB, 0.88275054E-10_JPRB, &
  & 0.88274436E-10_JPRB, 0.88274728E-10_JPRB, 0.88276456E-10_JPRB, 0.88280008E-10_JPRB, 0.88281958E-10_JPRB, 0.88284477E-10_JPRB, &
  & 0.88287738E-10_JPRB, 0.88290389E-10_JPRB, 0.88291589E-10_JPRB, 0.88293622E-10_JPRB, 0.88294531E-10_JPRB, 0.88294524E-10_JPRB, &
  & 0.88293470E-10_JPRB, 0.88292942E-10_JPRB, 0.88292464E-10_JPRB, 0.88289875E-10_JPRB, 0.88287135E-10_JPRB, 0.88284574E-10_JPRB, &
  & 0.88281431E-10_JPRB, 0.88278468E-10_JPRB, 0.88276067E-10_JPRB, 0.88274998E-10_JPRB, 0.88274402E-10_JPRB, 0.88274679E-10_JPRB, &
  & 0.88275671E-10_JPRB, 0.88277337E-10_JPRB, 0.88278454E-10_JPRB, 0.88280494E-10_JPRB, 0.88281465E-10_JPRB, 0.88282805E-10_JPRB, &
  & 0.88282118E-10_JPRB, 0.88283415E-10_JPRB, 0.88282222E-10_JPRB, 0.88282083E-10_JPRB, 0.88280980E-10_JPRB, 0.88279335E-10_JPRB, &
  & 0.88279127E-10_JPRB, 0.88277510E-10_JPRB, 0.88275824E-10_JPRB, 0.88275089E-10_JPRB, 0.88274991E-10_JPRB, 0.88273902E-10_JPRB, &
  & 0.88272278E-10_JPRB, 0.88270155E-10_JPRB, 0.88269281E-10_JPRB, 0.88271057E-10_JPRB /)

RGHG9(:,84, 4) = (/ &
  & 0.88251531E-10_JPRB, 0.88255056E-10_JPRB, 0.88260059E-10_JPRB, 0.88261849E-10_JPRB, 0.88265006E-10_JPRB, 0.88268351E-10_JPRB, &
  & 0.88271265E-10_JPRB, 0.88272910E-10_JPRB, 0.88273722E-10_JPRB, 0.88274860E-10_JPRB, 0.88275873E-10_JPRB, 0.88276449E-10_JPRB, &
  & 0.88277101E-10_JPRB, 0.88277337E-10_JPRB, 0.88276726E-10_JPRB, 0.88276275E-10_JPRB, 0.88275477E-10_JPRB, 0.88275588E-10_JPRB, &
  & 0.88274964E-10_JPRB, 0.88275220E-10_JPRB, 0.88276920E-10_JPRB, 0.88280508E-10_JPRB, 0.88282368E-10_JPRB, 0.88284768E-10_JPRB, &
  & 0.88288057E-10_JPRB, 0.88290625E-10_JPRB, 0.88291742E-10_JPRB, 0.88293803E-10_JPRB, 0.88294691E-10_JPRB, 0.88294663E-10_JPRB, &
  & 0.88293588E-10_JPRB, 0.88293102E-10_JPRB, 0.88292651E-10_JPRB, 0.88290104E-10_JPRB, 0.88287391E-10_JPRB, 0.88284866E-10_JPRB, &
  & 0.88281812E-10_JPRB, 0.88278940E-10_JPRB, 0.88276705E-10_JPRB, 0.88275616E-10_JPRB, 0.88275082E-10_JPRB, 0.88275304E-10_JPRB, &
  & 0.88276220E-10_JPRB, 0.88277774E-10_JPRB, 0.88278863E-10_JPRB, 0.88280896E-10_JPRB, 0.88281819E-10_JPRB, 0.88283172E-10_JPRB, &
  & 0.88282444E-10_JPRB, 0.88283811E-10_JPRB, 0.88282583E-10_JPRB, 0.88282479E-10_JPRB, 0.88281382E-10_JPRB, 0.88279717E-10_JPRB, &
  & 0.88279564E-10_JPRB, 0.88277954E-10_JPRB, 0.88276282E-10_JPRB, 0.88275567E-10_JPRB, 0.88275505E-10_JPRB, 0.88274450E-10_JPRB, &
  & 0.88272785E-10_JPRB, 0.88270655E-10_JPRB, 0.88269780E-10_JPRB, 0.88271522E-10_JPRB /)

RGHG9(:,85, 4) = (/ &
  & 0.88251975E-10_JPRB, 0.88255542E-10_JPRB, 0.88260510E-10_JPRB, 0.88262259E-10_JPRB, 0.88265298E-10_JPRB, 0.88269184E-10_JPRB, &
  & 0.88271043E-10_JPRB, 0.88273576E-10_JPRB, 0.88273833E-10_JPRB, 0.88275567E-10_JPRB, 0.88276053E-10_JPRB, 0.88276816E-10_JPRB, &
  & 0.88277274E-10_JPRB, 0.88277503E-10_JPRB, 0.88277018E-10_JPRB, 0.88276574E-10_JPRB, 0.88275838E-10_JPRB, 0.88275949E-10_JPRB, &
  & 0.88275304E-10_JPRB, 0.88275519E-10_JPRB, 0.88277219E-10_JPRB, 0.88280848E-10_JPRB, 0.88282610E-10_JPRB, 0.88284990E-10_JPRB, &
  & 0.88288259E-10_JPRB, 0.88290819E-10_JPRB, 0.88291825E-10_JPRB, 0.88293928E-10_JPRB, 0.88294823E-10_JPRB, 0.88294774E-10_JPRB, &
  & 0.88293685E-10_JPRB, 0.88293213E-10_JPRB, 0.88292790E-10_JPRB, 0.88290222E-10_JPRB, 0.88287544E-10_JPRB, 0.88285039E-10_JPRB, &
  & 0.88282034E-10_JPRB, 0.88279280E-10_JPRB, 0.88277080E-10_JPRB, 0.88276081E-10_JPRB, 0.88275540E-10_JPRB, 0.88275748E-10_JPRB, &
  & 0.88276567E-10_JPRB, 0.88278079E-10_JPRB, 0.88279127E-10_JPRB, 0.88281132E-10_JPRB, 0.88282041E-10_JPRB, 0.88283415E-10_JPRB, &
  & 0.88282666E-10_JPRB, 0.88284102E-10_JPRB, 0.88282832E-10_JPRB, 0.88282735E-10_JPRB, 0.88281660E-10_JPRB, 0.88279981E-10_JPRB, &
  & 0.88279876E-10_JPRB, 0.88278274E-10_JPRB, 0.88276553E-10_JPRB, 0.88275880E-10_JPRB, 0.88275873E-10_JPRB, 0.88274783E-10_JPRB, &
  & 0.88273132E-10_JPRB, 0.88270946E-10_JPRB, 0.88270093E-10_JPRB, 0.88271807E-10_JPRB /)

RGHG9(:,86, 4) = (/ &
  & 0.88252246E-10_JPRB, 0.88255826E-10_JPRB, 0.88260774E-10_JPRB, 0.88262501E-10_JPRB, 0.88265867E-10_JPRB, 0.88269191E-10_JPRB, &
  & 0.88272084E-10_JPRB, 0.88273583E-10_JPRB, 0.88274443E-10_JPRB, 0.88275429E-10_JPRB, 0.88276310E-10_JPRB, 0.88276816E-10_JPRB, &
  & 0.88277344E-10_JPRB, 0.88277524E-10_JPRB, 0.88277177E-10_JPRB, 0.88276768E-10_JPRB, 0.88276102E-10_JPRB, 0.88276129E-10_JPRB, &
  & 0.88275533E-10_JPRB, 0.88275734E-10_JPRB, 0.88277413E-10_JPRB, 0.88281063E-10_JPRB, 0.88282756E-10_JPRB, 0.88285095E-10_JPRB, &
  & 0.88288390E-10_JPRB, 0.88290937E-10_JPRB, 0.88291888E-10_JPRB, 0.88294025E-10_JPRB, 0.88294913E-10_JPRB, 0.88294844E-10_JPRB, &
  & 0.88293733E-10_JPRB, 0.88293275E-10_JPRB, 0.88292859E-10_JPRB, 0.88290368E-10_JPRB, 0.88287669E-10_JPRB, 0.88285212E-10_JPRB, &
  & 0.88282208E-10_JPRB, 0.88279439E-10_JPRB, 0.88277309E-10_JPRB, 0.88276289E-10_JPRB, 0.88275803E-10_JPRB, 0.88276005E-10_JPRB, &
  & 0.88276816E-10_JPRB, 0.88278232E-10_JPRB, 0.88279314E-10_JPRB, 0.88281306E-10_JPRB, 0.88282187E-10_JPRB, 0.88283561E-10_JPRB, &
  & 0.88282805E-10_JPRB, 0.88284297E-10_JPRB, 0.88283006E-10_JPRB, 0.88282930E-10_JPRB, 0.88281840E-10_JPRB, 0.88280147E-10_JPRB, &
  & 0.88280064E-10_JPRB, 0.88278475E-10_JPRB, 0.88276726E-10_JPRB, 0.88276081E-10_JPRB, 0.88276095E-10_JPRB, 0.88275054E-10_JPRB, &
  & 0.88273361E-10_JPRB, 0.88271161E-10_JPRB, 0.88270273E-10_JPRB, 0.88271973E-10_JPRB /)

RGHG9(:,87, 4) = (/ &
  & 0.88252454E-10_JPRB, 0.88256069E-10_JPRB, 0.88260926E-10_JPRB, 0.88262730E-10_JPRB, 0.88265832E-10_JPRB, 0.88269975E-10_JPRB, &
  & 0.88271862E-10_JPRB, 0.88273999E-10_JPRB, 0.88274513E-10_JPRB, 0.88275810E-10_JPRB, 0.88276331E-10_JPRB, 0.88276962E-10_JPRB, &
  & 0.88277302E-10_JPRB, 0.88277489E-10_JPRB, 0.88277226E-10_JPRB, 0.88276858E-10_JPRB, 0.88276289E-10_JPRB, 0.88276275E-10_JPRB, &
  & 0.88275692E-10_JPRB, 0.88275852E-10_JPRB, 0.88277503E-10_JPRB, 0.88281188E-10_JPRB, 0.88282839E-10_JPRB, 0.88285150E-10_JPRB, &
  & 0.88288481E-10_JPRB, 0.88291020E-10_JPRB, 0.88291922E-10_JPRB, 0.88294087E-10_JPRB, 0.88294975E-10_JPRB, 0.88294913E-10_JPRB, &
  & 0.88293768E-10_JPRB, 0.88293324E-10_JPRB, 0.88292956E-10_JPRB, 0.88290472E-10_JPRB, 0.88287842E-10_JPRB, 0.88285414E-10_JPRB, &
  & 0.88282395E-10_JPRB, 0.88279543E-10_JPRB, 0.88277323E-10_JPRB, 0.88276358E-10_JPRB, 0.88275845E-10_JPRB, 0.88276081E-10_JPRB, &
  & 0.88276900E-10_JPRB, 0.88278447E-10_JPRB, 0.88279439E-10_JPRB, 0.88281459E-10_JPRB, 0.88282291E-10_JPRB, 0.88283658E-10_JPRB, &
  & 0.88282881E-10_JPRB, 0.88284408E-10_JPRB, 0.88283096E-10_JPRB, 0.88283041E-10_JPRB, 0.88281951E-10_JPRB, 0.88280258E-10_JPRB, &
  & 0.88280189E-10_JPRB, 0.88278579E-10_JPRB, 0.88276837E-10_JPRB, 0.88276206E-10_JPRB, 0.88276234E-10_JPRB, 0.88275193E-10_JPRB, &
  & 0.88273500E-10_JPRB, 0.88271258E-10_JPRB, 0.88270370E-10_JPRB, 0.88272077E-10_JPRB /)

RGHG9(:,88, 4) = (/ &
  & 0.88252752E-10_JPRB, 0.88256326E-10_JPRB, 0.88260947E-10_JPRB, 0.88262758E-10_JPRB, 0.88266325E-10_JPRB, 0.88269655E-10_JPRB, &
  & 0.88272424E-10_JPRB, 0.88273930E-10_JPRB, 0.88274762E-10_JPRB, 0.88275706E-10_JPRB, 0.88276442E-10_JPRB, 0.88276886E-10_JPRB, &
  & 0.88277330E-10_JPRB, 0.88277496E-10_JPRB, 0.88277274E-10_JPRB, 0.88276941E-10_JPRB, 0.88276379E-10_JPRB, 0.88276365E-10_JPRB, &
  & 0.88275803E-10_JPRB, 0.88275949E-10_JPRB, 0.88277566E-10_JPRB, 0.88281299E-10_JPRB, 0.88282888E-10_JPRB, 0.88285178E-10_JPRB, &
  & 0.88288536E-10_JPRB, 0.88291076E-10_JPRB, 0.88291915E-10_JPRB, 0.88294143E-10_JPRB, 0.88295017E-10_JPRB, 0.88294962E-10_JPRB, &
  & 0.88293796E-10_JPRB, 0.88293373E-10_JPRB, 0.88293053E-10_JPRB, 0.88290597E-10_JPRB, 0.88287960E-10_JPRB, 0.88285615E-10_JPRB, &
  & 0.88282520E-10_JPRB, 0.88279592E-10_JPRB, 0.88277261E-10_JPRB, 0.88276303E-10_JPRB, 0.88275755E-10_JPRB, 0.88276032E-10_JPRB, &
  & 0.88276976E-10_JPRB, 0.88278579E-10_JPRB, 0.88279550E-10_JPRB, 0.88281590E-10_JPRB, 0.88282354E-10_JPRB, 0.88283721E-10_JPRB, &
  & 0.88282943E-10_JPRB, 0.88284512E-10_JPRB, 0.88283152E-10_JPRB, 0.88283138E-10_JPRB, 0.88282028E-10_JPRB, 0.88280334E-10_JPRB, &
  & 0.88280279E-10_JPRB, 0.88278634E-10_JPRB, 0.88276886E-10_JPRB, 0.88276275E-10_JPRB, 0.88276338E-10_JPRB, 0.88275304E-10_JPRB, &
  & 0.88273562E-10_JPRB, 0.88271314E-10_JPRB, 0.88270419E-10_JPRB, 0.88272147E-10_JPRB /)

RGHG9(:,89, 4) = (/ &
  & 0.88253155E-10_JPRB, 0.88256673E-10_JPRB, 0.88260850E-10_JPRB, 0.88262772E-10_JPRB, 0.88265902E-10_JPRB, 0.88270016E-10_JPRB, &
  & 0.88272001E-10_JPRB, 0.88274110E-10_JPRB, 0.88274672E-10_JPRB, 0.88275914E-10_JPRB, 0.88276442E-10_JPRB, 0.88277011E-10_JPRB, &
  & 0.88277358E-10_JPRB, 0.88277552E-10_JPRB, 0.88277323E-10_JPRB, 0.88276962E-10_JPRB, 0.88276393E-10_JPRB, 0.88276421E-10_JPRB, &
  & 0.88275817E-10_JPRB, 0.88275970E-10_JPRB, 0.88277594E-10_JPRB, 0.88281354E-10_JPRB, 0.88282909E-10_JPRB, 0.88285171E-10_JPRB, &
  & 0.88288599E-10_JPRB, 0.88291138E-10_JPRB, 0.88291922E-10_JPRB, 0.88294164E-10_JPRB, 0.88295073E-10_JPRB, 0.88295024E-10_JPRB, &
  & 0.88293803E-10_JPRB, 0.88293407E-10_JPRB, 0.88293137E-10_JPRB, 0.88290666E-10_JPRB, 0.88288044E-10_JPRB, 0.88285775E-10_JPRB, &
  & 0.88282645E-10_JPRB, 0.88279627E-10_JPRB, 0.88277129E-10_JPRB, 0.88276247E-10_JPRB, 0.88275651E-10_JPRB, 0.88275984E-10_JPRB, &
  & 0.88276962E-10_JPRB, 0.88278759E-10_JPRB, 0.88279627E-10_JPRB, 0.88281688E-10_JPRB, 0.88282395E-10_JPRB, 0.88283776E-10_JPRB, &
  & 0.88282964E-10_JPRB, 0.88284588E-10_JPRB, 0.88283179E-10_JPRB, 0.88283200E-10_JPRB, 0.88282076E-10_JPRB, 0.88280369E-10_JPRB, &
  & 0.88280341E-10_JPRB, 0.88278676E-10_JPRB, 0.88276907E-10_JPRB, 0.88276303E-10_JPRB, 0.88276393E-10_JPRB, 0.88275359E-10_JPRB, &
  & 0.88273618E-10_JPRB, 0.88271342E-10_JPRB, 0.88270426E-10_JPRB, 0.88272174E-10_JPRB /)

RGHG9(:,90, 4) = (/ &
  & 0.88253529E-10_JPRB, 0.88256971E-10_JPRB, 0.88260621E-10_JPRB, 0.88262585E-10_JPRB, 0.88265922E-10_JPRB, 0.88269482E-10_JPRB, &
  & 0.88272084E-10_JPRB, 0.88274013E-10_JPRB, 0.88274610E-10_JPRB, 0.88275928E-10_JPRB, 0.88276671E-10_JPRB, 0.88277108E-10_JPRB, &
  & 0.88277587E-10_JPRB, 0.88277767E-10_JPRB, 0.88277392E-10_JPRB, 0.88276990E-10_JPRB, 0.88276331E-10_JPRB, 0.88276476E-10_JPRB, &
  & 0.88275803E-10_JPRB, 0.88275928E-10_JPRB, 0.88277559E-10_JPRB, 0.88281438E-10_JPRB, 0.88282895E-10_JPRB, 0.88285157E-10_JPRB, &
  & 0.88288626E-10_JPRB, 0.88291201E-10_JPRB, 0.88291902E-10_JPRB, 0.88294233E-10_JPRB, 0.88295121E-10_JPRB, 0.88295073E-10_JPRB, &
  & 0.88293796E-10_JPRB, 0.88293414E-10_JPRB, 0.88293255E-10_JPRB, 0.88290701E-10_JPRB, 0.88288064E-10_JPRB, 0.88285837E-10_JPRB, &
  & 0.88282701E-10_JPRB, 0.88279634E-10_JPRB, 0.88277038E-10_JPRB, 0.88276206E-10_JPRB, 0.88275567E-10_JPRB, 0.88275928E-10_JPRB, &
  & 0.88276969E-10_JPRB, 0.88278863E-10_JPRB, 0.88279634E-10_JPRB, 0.88281757E-10_JPRB, 0.88282395E-10_JPRB, 0.88283852E-10_JPRB, &
  & 0.88282909E-10_JPRB, 0.88284678E-10_JPRB, 0.88283166E-10_JPRB, 0.88283263E-10_JPRB, 0.88282097E-10_JPRB, 0.88280341E-10_JPRB, &
  & 0.88280383E-10_JPRB, 0.88278690E-10_JPRB, 0.88276879E-10_JPRB, 0.88276317E-10_JPRB, 0.88276456E-10_JPRB, 0.88275401E-10_JPRB, &
  & 0.88273645E-10_JPRB, 0.88271314E-10_JPRB, 0.88270391E-10_JPRB, 0.88272230E-10_JPRB /)

RGHG9(:,91, 4) = (/ &
  & 0.88253627E-10_JPRB, 0.88257124E-10_JPRB, 0.88260052E-10_JPRB, 0.88262467E-10_JPRB, 0.88265631E-10_JPRB, 0.88269433E-10_JPRB, &
  & 0.88271376E-10_JPRB, 0.88274520E-10_JPRB, 0.88273097E-10_JPRB, 0.88276518E-10_JPRB, 0.88276934E-10_JPRB, 0.88277143E-10_JPRB, &
  & 0.88278038E-10_JPRB, 0.88278294E-10_JPRB, 0.88277365E-10_JPRB, 0.88276983E-10_JPRB, 0.88276116E-10_JPRB, 0.88276594E-10_JPRB, &
  & 0.88275706E-10_JPRB, 0.88275824E-10_JPRB, 0.88277413E-10_JPRB, 0.88281597E-10_JPRB, 0.88282846E-10_JPRB, 0.88285088E-10_JPRB, &
  & 0.88288703E-10_JPRB, 0.88291333E-10_JPRB, 0.88291784E-10_JPRB, 0.88294330E-10_JPRB, 0.88295218E-10_JPRB, 0.88295191E-10_JPRB, &
  & 0.88293733E-10_JPRB, 0.88293400E-10_JPRB, 0.88293504E-10_JPRB, 0.88290701E-10_JPRB, 0.88288057E-10_JPRB, 0.88285934E-10_JPRB, &
  & 0.88282673E-10_JPRB, 0.88279599E-10_JPRB, 0.88276886E-10_JPRB, 0.88276199E-10_JPRB, 0.88275470E-10_JPRB, 0.88275873E-10_JPRB, &
  & 0.88276900E-10_JPRB, 0.88278974E-10_JPRB, 0.88279571E-10_JPRB, 0.88281868E-10_JPRB, 0.88282354E-10_JPRB, 0.88284012E-10_JPRB, &
  & 0.88282742E-10_JPRB, 0.88284914E-10_JPRB, 0.88283054E-10_JPRB, 0.88283339E-10_JPRB, 0.88282132E-10_JPRB, 0.88280216E-10_JPRB, &
  & 0.88280522E-10_JPRB, 0.88278690E-10_JPRB, 0.88276796E-10_JPRB, 0.88276275E-10_JPRB, 0.88276525E-10_JPRB, 0.88275449E-10_JPRB, &
  & 0.88273631E-10_JPRB, 0.88271161E-10_JPRB, 0.88270315E-10_JPRB, 0.88272285E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART8',1,ZHOOK_HANDLE)
END SUBROUTINE PART8






SUBROUTINE PART9
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART9',0,ZHOOK_HANDLE)



!-- Month=  5 ------------

RGHG9(:, 1, 5) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.28025969E-44_JPRB, 0.42038954E-44_JPRB, 0.56051939E-44_JPRB, &
  & 0.84077908E-44_JPRB, 0.11210388E-43_JPRB, 0.18216880E-43_JPRB, 0.23822074E-43_JPRB, 0.28025969E-43_JPRB, 0.32229865E-43_JPRB, &
  & 0.32229865E-43_JPRB, 0.29427268E-43_JPRB, 0.26624671E-43_JPRB, 0.21019477E-43_JPRB, 0.18216880E-43_JPRB, 0.11210388E-43_JPRB, &
  & 0.84077908E-44_JPRB, 0.56051939E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 2, 5) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.28025969E-44_JPRB, 0.70064923E-44_JPRB, &
  & 0.15414283E-43_JPRB, 0.26624671E-43_JPRB, 0.46242849E-43_JPRB, 0.78472714E-43_JPRB, 0.12891946E-42_JPRB, 0.20879347E-42_JPRB, &
  & 0.32650254E-42_JPRB, 0.49746095E-42_JPRB, 0.69924793E-42_JPRB, 0.91925179E-42_JPRB, 0.11014206E-41_JPRB, 0.12289388E-41_JPRB, &
  & 0.12457543E-41_JPRB, 0.11728868E-41_JPRB, 0.10439674E-41_JPRB, 0.83096999E-42_JPRB, 0.70905702E-42_JPRB, 0.47223758E-42_JPRB, &
  & 0.32650254E-42_JPRB, 0.21299737E-42_JPRB, 0.13872855E-42_JPRB, 0.78472714E-43_JPRB, 0.43440252E-43_JPRB, 0.21019477E-43_JPRB, &
  & 0.11210388E-43_JPRB, 0.56051939E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 3, 5) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.56051939E-44_JPRB, &
  & 0.98090893E-44_JPRB, 0.21019477E-43_JPRB, 0.43440252E-43_JPRB, 0.91084400E-43_JPRB, 0.18216880E-42_JPRB, 0.35592981E-42_JPRB, &
  & 0.67542586E-42_JPRB, 0.12359452E-41_JPRB, 0.21762165E-41_JPRB, 0.37288552E-41_JPRB, 0.62049496E-41_JPRB, 0.10083744E-40_JPRB, &
  & 0.15778621E-40_JPRB, 0.23618886E-40_JPRB, 0.33024401E-40_JPRB, 0.43164197E-40_JPRB, 0.51674282E-40_JPRB, 0.57739102E-40_JPRB, &
  & 0.58888167E-40_JPRB, 0.55632950E-40_JPRB, 0.49498066E-40_JPRB, 0.39621714E-40_JPRB, 0.33507849E-40_JPRB, 0.22604346E-40_JPRB, &
  & 0.15621675E-40_JPRB, 0.10281327E-40_JPRB, 0.66435560E-41_JPRB, 0.37652890E-41_JPRB, 0.20613100E-41_JPRB, 0.99352061E-42_JPRB, &
  & 0.50166485E-42_JPRB, 0.27465450E-42_JPRB, 0.14012985E-42_JPRB, 0.51848043E-43_JPRB, 0.18216880E-43_JPRB, 0.70064923E-44_JPRB, &
  & 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 4, 5) = (/ &
  & 0.70064923E-44_JPRB, 0.23822074E-43_JPRB, 0.35032462E-43_JPRB, 0.37835059E-43_JPRB, 0.39236357E-43_JPRB, 0.43440252E-43_JPRB, &
  & 0.50446745E-43_JPRB, 0.65861028E-43_JPRB, 0.95288296E-43_JPRB, 0.15134023E-42_JPRB, 0.26064151E-42_JPRB, 0.47784278E-42_JPRB, &
  & 0.94027127E-42_JPRB, 0.19057659E-41_JPRB, 0.39152279E-41_JPRB, 0.80266376E-41_JPRB, 0.16032256E-40_JPRB, 0.31198509E-40_JPRB, &
  & 0.59408048E-40_JPRB, 0.10909529E-39_JPRB, 0.19272618E-39_JPRB, 0.33156543E-39_JPRB, 0.55150764E-39_JPRB, 0.89668388E-39_JPRB, &
  & 0.13908966E-38_JPRB, 0.20738391E-38_JPRB, 0.28842128E-38_JPRB, 0.37677819E-38_JPRB, 0.45136216E-38_JPRB, 0.50471758E-38_JPRB, &
  & 0.51502021E-38_JPRB, 0.48678712E-38_JPRB, 0.43324001E-38_JPRB, 0.34734574E-38_JPRB, 0.29412218E-38_JPRB, 0.19871155E-38_JPRB, &
  & 0.13811674E-38_JPRB, 0.91197625E-39_JPRB, 0.59684805E-39_JPRB, 0.34017221E-39_JPRB, 0.18571969E-39_JPRB, 0.87174777E-40_JPRB, &
  & 0.43094132E-40_JPRB, 0.23681944E-40_JPRB, 0.12072186E-40_JPRB, 0.42865720E-41_JPRB, 0.14937842E-41_JPRB, 0.62077522E-42_JPRB, &
  & 0.26064151E-42_JPRB, 0.10649868E-42_JPRB, 0.44841551E-43_JPRB, 0.19618179E-43_JPRB, 0.70064923E-44_JPRB, 0.28025969E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 5, 5) = (/ &
  & 0.52800926E-41_JPRB, 0.78795013E-41_JPRB, 0.88940414E-41_JPRB, 0.90089478E-41_JPRB, 0.92247478E-41_JPRB, 0.99338048E-41_JPRB, &
  & 0.11576127E-40_JPRB, 0.14919625E-40_JPRB, 0.21358591E-40_JPRB, 0.33443389E-40_JPRB, 0.56742779E-40_JPRB, 0.10326028E-39_JPRB, &
  & 0.20032823E-39_JPRB, 0.40073773E-39_JPRB, 0.81049702E-39_JPRB, 0.16346973E-38_JPRB, 0.32048957E-38_JPRB, 0.61203630E-38_JPRB, &
  & 0.11447734E-37_JPRB, 0.20657735E-37_JPRB, 0.35853281E-37_JPRB, 0.60586395E-37_JPRB, 0.99029493E-37_JPRB, 0.15801450E-36_JPRB, &
  & 0.24189689E-36_JPRB, 0.35613895E-36_JPRB, 0.49219355E-36_JPRB, 0.64060415E-36_JPRB, 0.76450943E-36_JPRB, 0.85218318E-36_JPRB, &
  & 0.86611285E-36_JPRB, 0.81674239E-36_JPRB, 0.72781577E-36_JPRB, 0.58492301E-36_JPRB, 0.49942636E-36_JPRB, 0.33934319E-36_JPRB, &
  & 0.23796115E-36_JPRB, 0.15947512E-36_JPRB, 0.10580408E-36_JPRB, 0.61379866E-37_JPRB, 0.34013516E-37_JPRB, 0.15981498E-37_JPRB, &
  & 0.79760731E-38_JPRB, 0.44783159E-38_JPRB, 0.23210393E-38_JPRB, 0.81631381E-39_JPRB, 0.29005477E-39_JPRB, 0.12551290E-39_JPRB, &
  & 0.54799178E-40_JPRB, 0.22853777E-40_JPRB, 0.96115062E-41_JPRB, 0.41478435E-41_JPRB, 0.18553192E-41_JPRB, 0.84218038E-42_JPRB, &
  & 0.39236357E-42_JPRB, 0.18357010E-42_JPRB, 0.95288296E-43_JPRB, 0.70064923E-43_JPRB, 0.72867520E-43_JPRB, 0.89683102E-43_JPRB, &
  & 0.10789998E-42_JPRB, 0.12611686E-42_JPRB, 0.16675452E-42_JPRB, 0.19618179E-42_JPRB /)

RGHG9(:, 6, 5) = (/ &
  & 0.47698098E-38_JPRB, 0.49363065E-38_JPRB, 0.48866360E-38_JPRB, 0.48295317E-38_JPRB, 0.48968823E-38_JPRB, 0.52198088E-38_JPRB, &
  & 0.59944241E-38_JPRB, 0.75751967E-38_JPRB, 0.10592422E-37_JPRB, 0.16115814E-37_JPRB, 0.26514473E-37_JPRB, 0.46618680E-37_JPRB, &
  & 0.87168152E-37_JPRB, 0.16757158E-36_JPRB, 0.32510649E-36_JPRB, 0.62754150E-36_JPRB, 0.11761509E-35_JPRB, 0.21444263E-35_JPRB, &
  & 0.38311861E-35_JPRB, 0.66106175E-35_JPRB, 0.10989987E-34_JPRB, 0.17838480E-34_JPRB, 0.28097168E-34_JPRB, 0.43414978E-34_JPRB, &
  & 0.64556135E-34_JPRB, 0.93035993E-34_JPRB, 0.12622076E-33_JPRB, 0.16206123E-33_JPRB, 0.19098025E-33_JPRB, 0.21081880E-33_JPRB, &
  & 0.21261481E-33_JPRB, 0.19980050E-33_JPRB, 0.17843633E-33_JPRB, 0.14439727E-33_JPRB, 0.12509342E-33_JPRB, 0.86098200E-34_JPRB, &
  & 0.61652819E-34_JPRB, 0.42221823E-34_JPRB, 0.28816951E-34_JPRB, 0.17190963E-34_JPRB, 0.98456620E-35_JPRB, 0.47905922E-35_JPRB, &
  & 0.24956397E-35_JPRB, 0.14723791E-35_JPRB, 0.79953346E-36_JPRB, 0.29187886E-36_JPRB, 0.10886240E-36_JPRB, 0.49771823E-37_JPRB, &
  & 0.22808195E-37_JPRB, 0.99672034E-38_JPRB, 0.43706191E-38_JPRB, 0.19650282E-38_JPRB, 0.91366482E-39_JPRB, 0.42968155E-39_JPRB, &
  & 0.20658222E-39_JPRB, 0.99531427E-40_JPRB, 0.52149322E-40_JPRB, 0.38845395E-40_JPRB, 0.41457415E-40_JPRB, 0.51476699E-40_JPRB, &
  & 0.61361458E-40_JPRB, 0.70303144E-40_JPRB, 0.98490263E-40_JPRB, 0.11598547E-39_JPRB /)

RGHG9(:, 7, 5) = (/ &
  & 0.37357772E-35_JPRB, 0.36153751E-35_JPRB, 0.35149103E-35_JPRB, 0.34437134E-35_JPRB, 0.34540557E-35_JPRB, 0.36243754E-35_JPRB, &
  & 0.40780040E-35_JPRB, 0.50078994E-35_JPRB, 0.67577466E-35_JPRB, 0.98682019E-35_JPRB, 0.15491365E-34_JPRB, 0.25851729E-34_JPRB, &
  & 0.45681559E-34_JPRB, 0.82756932E-34_JPRB, 0.15088540E-33_JPRB, 0.27397104E-33_JPRB, 0.48221800E-33_JPRB, 0.82635894E-33_JPRB, &
  & 0.13905127E-32_JPRB, 0.22666986E-32_JPRB, 0.35724629E-32_JPRB, 0.55278897E-32_JPRB, 0.83345591E-32_JPRB, 0.12407698E-31_JPRB, &
  & 0.17836872E-31_JPRB, 0.24976501E-31_JPRB, 0.33041289E-31_JPRB, 0.41541665E-31_JPRB, 0.48083076E-31_JPRB, 0.52397173E-31_JPRB, &
  & 0.52403221E-31_JPRB, 0.49113929E-31_JPRB, 0.44014396E-31_JPRB, 0.35948087E-31_JPRB, 0.31672258E-31_JPRB, 0.22183903E-31_JPRB, &
  & 0.16280800E-31_JPRB, 0.11460235E-31_JPRB, 0.80863123E-32_JPRB, 0.49829128E-32_JPRB, 0.29793257E-32_JPRB, 0.15146476E-32_JPRB, &
  & 0.83874286E-33_JPRB, 0.52908082E-33_JPRB, 0.30556291E-33_JPRB, 0.11836838E-33_JPRB, 0.47176557E-34_JPRB, 0.23209637E-34_JPRB, &
  & 0.11404782E-34_JPRB, 0.53215725E-35_JPRB, 0.24905683E-35_JPRB, 0.11915567E-35_JPRB, 0.58765709E-36_JPRB, 0.29176422E-36_JPRB, &
  & 0.14741301E-36_JPRB, 0.74203042E-37_JPRB, 0.40395971E-37_JPRB, 0.31023661E-37_JPRB, 0.33799666E-37_JPRB, 0.41947018E-37_JPRB, &
  & 0.49681210E-37_JPRB, 0.56552673E-37_JPRB, 0.81106651E-37_JPRB, 0.11492898E-36_JPRB /)

RGHG9(:, 8, 5) = (/ &
  & 0.24035614E-32_JPRB, 0.23088125E-32_JPRB, 0.22331821E-32_JPRB, 0.21732266E-32_JPRB, 0.21585243E-32_JPRB, 0.22341350E-32_JPRB, &
  & 0.24620720E-32_JPRB, 0.29451533E-32_JPRB, 0.38393794E-32_JPRB, 0.53846560E-32_JPRB, 0.80716833E-32_JPRB, 0.12783663E-31_JPRB, &
  & 0.21341088E-31_JPRB, 0.36365954E-31_JPRB, 0.62317052E-31_JPRB, 0.10621435E-30_JPRB, 0.17565565E-30_JPRB, 0.28278680E-30_JPRB, &
  & 0.44879504E-30_JPRB, 0.69199721E-30_JPRB, 0.10351486E-29_JPRB, 0.15278210E-29_JPRB, 0.22078376E-29_JPRB, 0.31631154E-29_JPRB, &
  & 0.43915664E-29_JPRB, 0.59601919E-29_JPRB, 0.76609709E-29_JPRB, 0.94036659E-29_JPRB, 0.10674409E-28_JPRB, 0.11476944E-28_JPRB, &
  & 0.11391997E-28_JPRB, 0.10657839E-28_JPRB, 0.95917698E-29_JPRB, 0.79121739E-29_JPRB, 0.70903833E-29_JPRB, 0.50582383E-29_JPRB, &
  & 0.38108850E-29_JPRB, 0.27604232E-29_JPRB, 0.20179162E-29_JPRB, 0.12875870E-29_JPRB, 0.80463435E-30_JPRB, 0.42861124E-30_JPRB, &
  & 0.25268238E-30_JPRB, 0.17071178E-30_JPRB, 0.10524790E-30_JPRB, 0.43121303E-31_JPRB, 0.18433928E-31_JPRB, 0.98272973E-32_JPRB, &
  & 0.52002992E-32_JPRB, 0.26059769E-32_JPRB, 0.13076491E-32_JPRB, 0.66938319E-33_JPRB, 0.35188267E-33_JPRB, 0.18524692E-33_JPRB, &
  & 0.98802734E-34_JPRB, 0.52258186E-34_JPRB, 0.29831142E-34_JPRB, 0.23898729E-34_JPRB, 0.26650833E-34_JPRB, 0.33526910E-34_JPRB, &
  & 0.39843889E-34_JPRB, 0.45639771E-34_JPRB, 0.66855696E-34_JPRB, 0.10061309E-33_JPRB /)

RGHG9(:, 9, 5) = (/ &
  & 0.12521350E-29_JPRB, 0.11987292E-29_JPRB, 0.11552177E-29_JPRB, 0.11184979E-29_JPRB, 0.11026797E-29_JPRB, 0.11281896E-29_JPRB, &
  & 0.12242132E-29_JPRB, 0.14310069E-29_JPRB, 0.18129221E-29_JPRB, 0.24562795E-29_JPRB, 0.35369196E-29_JPRB, 0.53488145E-29_JPRB, &
  & 0.84808408E-29_JPRB, 0.13674197E-28_JPRB, 0.22086154E-28_JPRB, 0.35529736E-28_JPRB, 0.55357769E-28_JPRB, 0.84103868E-28_JPRB, &
  & 0.12631954E-27_JPRB, 0.18494385E-27_JPRB, 0.26308504E-27_JPRB, 0.37114707E-27_JPRB, 0.51326645E-27_JPRB, 0.70813858E-27_JPRB, &
  & 0.94656895E-27_JPRB, 0.12428140E-26_JPRB, 0.15492974E-26_JPRB, 0.18539724E-26_JPRB, 0.20633520E-26_JPRB, 0.21885488E-26_JPRB, &
  & 0.21566691E-26_JPRB, 0.20148964E-26_JPRB, 0.18209718E-26_JPRB, 0.15172077E-26_JPRB, 0.13819324E-26_JPRB, 0.10050032E-26_JPRB, &
  & 0.77742030E-27_JPRB, 0.58049281E-27_JPRB, 0.44037866E-27_JPRB, 0.29176960E-27_JPRB, 0.19118039E-27_JPRB, 0.10680254E-27_JPRB, &
  & 0.67004132E-28_JPRB, 0.48439419E-28_JPRB, 0.31830940E-28_JPRB, 0.13772766E-28_JPRB, 0.63118058E-29_JPRB, 0.36489154E-29_JPRB, &
  & 0.20813139E-29_JPRB, 0.11191679E-29_JPRB, 0.60254966E-30_JPRB, 0.33006661E-30_JPRB, 0.18499804E-30_JPRB, 0.10326780E-30_JPRB, &
  & 0.58118086E-31_JPRB, 0.32297083E-31_JPRB, 0.19349322E-31_JPRB, 0.16195982E-31_JPRB, 0.18625247E-31_JPRB, 0.23802839E-31_JPRB, &
  & 0.28669531E-31_JPRB, 0.33333878E-31_JPRB, 0.49269300E-31_JPRB, 0.76015670E-31_JPRB /)

RGHG9(:,10, 5) = (/ &
  & 0.52443125E-27_JPRB, 0.50084261E-27_JPRB, 0.48115951E-27_JPRB, 0.46426592E-27_JPRB, 0.45519556E-27_JPRB, 0.46188268E-27_JPRB, &
  & 0.49461988E-27_JPRB, 0.56839576E-27_JPRB, 0.70305297E-27_JPRB, 0.92568311E-27_JPRB, 0.12884960E-26_JPRB, 0.18725100E-26_JPRB, &
  & 0.28381700E-26_JPRB, 0.43522835E-26_JPRB, 0.66688159E-26_JPRB, 0.10157629E-25_JPRB, 0.14991235E-25_JPRB, 0.21557787E-25_JPRB, &
  & 0.30766204E-25_JPRB, 0.42846388E-25_JPRB, 0.58086232E-25_JPRB, 0.78257393E-25_JPRB, 0.10367374E-24_JPRB, 0.13717349E-24_JPRB, &
  & 0.17654806E-24_JPRB, 0.22364374E-24_JPRB, 0.27032153E-24_JPRB, 0.31522058E-24_JPRB, 0.34402863E-24_JPRB, 0.35993394E-24_JPRB, &
  & 0.35205035E-24_JPRB, 0.32828225E-24_JPRB, 0.29783500E-24_JPRB, 0.25057210E-24_JPRB, 0.23177764E-24_JPRB, 0.17190559E-24_JPRB, &
  & 0.13657131E-24_JPRB, 0.10525682E-24_JPRB, 0.82928430E-25_JPRB, 0.57269385E-25_JPRB, 0.39375555E-25_JPRB, 0.23156862E-25_JPRB, &
  & 0.15443510E-25_JPRB, 0.11928529E-25_JPRB, 0.83533267E-26_JPRB, 0.38227310E-26_JPRB, 0.18783689E-26_JPRB, 0.11773709E-26_JPRB, &
  & 0.72264830E-27_JPRB, 0.41711348E-27_JPRB, 0.24078773E-27_JPRB, 0.14113494E-27_JPRB, 0.84293566E-28_JPRB, 0.49860283E-28_JPRB, &
  & 0.29582188E-28_JPRB, 0.17244577E-28_JPRB, 0.10823847E-28_JPRB, 0.94512552E-29_JPRB, 0.11195539E-28_JPRB, 0.14601757E-28_JPRB, &
  & 0.17856369E-28_JPRB, 0.21068662E-28_JPRB, 0.31335657E-28_JPRB, 0.48829035E-28_JPRB /)

RGHG9(:,11, 5) = (/ &
  & 0.18056659E-24_JPRB, 0.17211754E-24_JPRB, 0.16506444E-24_JPRB, 0.15872980E-24_JPRB, 0.15492943E-24_JPRB, 0.15602575E-24_JPRB, &
  & 0.16526396E-24_JPRB, 0.18677298E-24_JPRB, 0.22612794E-24_JPRB, 0.28991208E-24_JPRB, 0.39100778E-24_JPRB, 0.54770918E-24_JPRB, &
  & 0.79608051E-24_JPRB, 0.11657892E-23_JPRB, 0.16996622E-23_JPRB, 0.24619095E-23_JPRB, 0.34499652E-23_JPRB, 0.47152926E-23_JPRB, &
  & 0.64017348E-23_JPRB, 0.85014956E-23_JPRB, 0.10987397E-22_JPRB, 0.14157843E-22_JPRB, 0.17933618E-22_JPRB, 0.22785681E-22_JPRB, &
  & 0.28187389E-22_JPRB, 0.34482281E-22_JPRB, 0.40435909E-22_JPRB, 0.45995374E-22_JPRB, 0.49259451E-22_JPRB, 0.50835838E-22_JPRB, &
  & 0.49318956E-22_JPRB, 0.45861890E-22_JPRB, 0.41727056E-22_JPRB, 0.35418097E-22_JPRB, 0.33256019E-22_JPRB, 0.25165026E-22_JPRB, &
  & 0.20539180E-22_JPRB, 0.16355862E-22_JPRB, 0.13391065E-22_JPRB, 0.96535859E-23_JPRB, 0.69725293E-23_JPRB, 0.43222257E-23_JPRB, &
  & 0.30654458E-23_JPRB, 0.25259936E-23_JPRB, 0.18846459E-23_JPRB, 0.91428446E-24_JPRB, 0.48247142E-24_JPRB, 0.32684092E-24_JPRB, &
  & 0.21570913E-24_JPRB, 0.13344308E-24_JPRB, 0.82515412E-25_JPRB, 0.51654745E-25_JPRB, 0.32814660E-25_JPRB, 0.20522993E-25_JPRB, &
  & 0.12802299E-25_JPRB, 0.78035862E-26_JPRB, 0.51075184E-26_JPRB, 0.46316212E-26_JPRB, 0.56416570E-26_JPRB, 0.74998085E-26_JPRB, &
  & 0.93115369E-26_JPRB, 0.11122201E-25_JPRB, 0.16647347E-25_JPRB, 0.26082422E-25_JPRB /)

RGHG9(:,12, 5) = (/ &
  & 0.51932632E-22_JPRB, 0.49460493E-22_JPRB, 0.47297402E-22_JPRB, 0.45355204E-22_JPRB, 0.44025557E-22_JPRB, 0.43985770E-22_JPRB, &
  & 0.46037796E-22_JPRB, 0.51182842E-22_JPRB, 0.60603841E-22_JPRB, 0.75667873E-22_JPRB, 0.98956839E-22_JPRB, 0.13379135E-21_JPRB, &
  & 0.18689775E-21_JPRB, 0.26202811E-21_JPRB, 0.36477181E-21_JPRB, 0.50353903E-21_JPRB, 0.67231932E-21_JPRB, 0.87455336E-21_JPRB, &
  & 0.11320584E-20_JPRB, 0.14332226E-20_JPRB, 0.17690261E-20_JPRB, 0.21769285E-20_JPRB, 0.26421756E-20_JPRB, 0.32168985E-20_JPRB, &
  & 0.38323649E-20_JPRB, 0.45279572E-20_JPRB, 0.51581489E-20_JPRB, 0.57287831E-20_JPRB, 0.60232126E-20_JPRB, 0.61305954E-20_JPRB, &
  & 0.58942091E-20_JPRB, 0.54588040E-20_JPRB, 0.49752018E-20_JPRB, 0.42581384E-20_JPRB, 0.40576048E-20_JPRB, 0.31350791E-20_JPRB, &
  & 0.26309164E-20_JPRB, 0.21665698E-20_JPRB, 0.18444003E-20_JPRB, 0.13893411E-20_JPRB, 0.10542263E-20_JPRB, 0.68980739E-21_JPRB, &
  & 0.52010415E-21_JPRB, 0.45700058E-21_JPRB, 0.36303053E-21_JPRB, 0.18717671E-21_JPRB, 0.10603717E-21_JPRB, 0.77539574E-22_JPRB, &
  & 0.54931774E-22_JPRB, 0.36393653E-22_JPRB, 0.24064909E-22_JPRB, 0.16061415E-22_JPRB, 0.10827136E-22_JPRB, 0.71424224E-23_JPRB, &
  & 0.46703622E-23_JPRB, 0.29646483E-23_JPRB, 0.20119168E-23_JPRB, 0.18848106E-23_JPRB, 0.23532474E-23_JPRB, 0.31840850E-23_JPRB, &
  & 0.40033539E-23_JPRB, 0.48264435E-23_JPRB, 0.72773570E-23_JPRB, 0.11467942E-22_JPRB /)

RGHG9(:,13, 5) = (/ &
  & 0.12624823E-19_JPRB, 0.11973350E-19_JPRB, 0.11418207E-19_JPRB, 0.10897729E-19_JPRB, 0.10520982E-19_JPRB, 0.10423700E-19_JPRB, &
  & 0.10782342E-19_JPRB, 0.11792740E-19_JPRB, 0.13669633E-19_JPRB, 0.16631704E-19_JPRB, 0.21106966E-19_JPRB, 0.27579714E-19_JPRB, &
  & 0.37096272E-19_JPRB, 0.49916931E-19_JPRB, 0.66502181E-19_JPRB, 0.87713663E-19_JPRB, 0.11169565E-18_JPRB, 0.13853017E-18_JPRB, &
  & 0.17081495E-18_JPRB, 0.20621290E-18_JPRB, 0.24267812E-18_JPRB, 0.28525553E-18_JPRB, 0.33091366E-18_JPRB, 0.38640075E-18_JPRB, &
  & 0.44283130E-18_JPRB, 0.50565096E-18_JPRB, 0.55965701E-18_JPRB, 0.60690914E-18_JPRB, 0.62615422E-18_JPRB, 0.62823602E-18_JPRB, &
  & 0.59817633E-18_JPRB, 0.55149465E-18_JPRB, 0.50331614E-18_JPRB, 0.43429681E-18_JPRB, 0.42004250E-18_JPRB, 0.33160128E-18_JPRB, &
  & 0.28634242E-18_JPRB, 0.24407373E-18_JPRB, 0.21620486E-18_JPRB, 0.17029178E-18_JPRB, 0.13583933E-18_JPRB, 0.93857832E-19_JPRB, &
  & 0.75284977E-19_JPRB, 0.70517070E-19_JPRB, 0.59657274E-19_JPRB, 0.32720855E-19_JPRB, 0.19916777E-19_JPRB, 0.15700796E-19_JPRB, &
  & 0.11931916E-19_JPRB, 0.84593435E-20_JPRB, 0.59768355E-20_JPRB, 0.42490059E-20_JPRB, 0.30369104E-20_JPRB, 0.21109098E-20_JPRB, &
  & 0.14450997E-20_JPRB, 0.95332293E-21_JPRB, 0.66849108E-21_JPRB, 0.64503316E-21_JPRB, 0.82410504E-21_JPRB, 0.11336689E-20_JPRB, &
  & 0.14408602E-20_JPRB, 0.17483258E-20_JPRB, 0.26589363E-20_JPRB, 0.42144327E-20_JPRB /)

RGHG9(:,14, 5) = (/ &
  & 0.26085327E-17_JPRB, 0.24619927E-17_JPRB, 0.23377406E-17_JPRB, 0.22228990E-17_JPRB, 0.21337686E-17_JPRB, 0.20978560E-17_JPRB, &
  & 0.21462709E-17_JPRB, 0.23117055E-17_JPRB, 0.26257310E-17_JPRB, 0.31158525E-17_JPRB, 0.38392674E-17_JPRB, 0.48489472E-17_JPRB, &
  & 0.62809350E-17_JPRB, 0.81111627E-17_JPRB, 0.10345404E-16_JPRB, 0.13032119E-16_JPRB, 0.15834591E-16_JPRB, 0.18710263E-16_JPRB, &
  & 0.21972946E-16_JPRB, 0.25256852E-16_JPRB, 0.28336098E-16_JPRB, 0.31754812E-16_JPRB, 0.35227356E-16_JPRB, 0.39401958E-16_JPRB, &
  & 0.43465582E-16_JPRB, 0.47975453E-16_JPRB, 0.51587400E-16_JPRB, 0.54611324E-16_JPRB, 0.55249090E-16_JPRB, 0.54625056E-16_JPRB, &
  & 0.51516001E-16_JPRB, 0.47304180E-16_JPRB, 0.43258545E-16_JPRB, 0.37644569E-16_JPRB, 0.36955399E-16_JPRB, 0.29814627E-16_JPRB, &
  & 0.26497467E-16_JPRB, 0.23387645E-16_JPRB, 0.21563004E-16_JPRB, 0.17767914E-16_JPRB, 0.14898865E-16_JPRB, 0.10879355E-16_JPRB, &
  & 0.92834844E-17_JPRB, 0.92697598E-17_JPRB, 0.83508201E-17_JPRB, 0.48778704E-17_JPRB, 0.31904896E-17_JPRB, 0.27083246E-17_JPRB, &
  & 0.22058258E-17_JPRB, 0.16721519E-17_JPRB, 0.12614958E-17_JPRB, 0.95474220E-18_JPRB, 0.72325395E-18_JPRB, 0.52967931E-18_JPRB, &
  & 0.37962650E-18_JPRB, 0.26021104E-18_JPRB, 0.18839583E-18_JPRB, 0.18716050E-18_JPRB, 0.24468799E-18_JPRB, 0.34220126E-18_JPRB, &
  & 0.43949941E-18_JPRB, 0.53608805E-18_JPRB, 0.82288713E-18_JPRB, 0.13109056E-17_JPRB /)

RGHG9(:,15, 5) = (/ &
  & 0.45709630E-15_JPRB, 0.42945515E-15_JPRB, 0.40664707E-15_JPRB, 0.38530086E-15_JPRB, 0.36814860E-15_JPRB, 0.35946908E-15_JPRB, &
  & 0.36403814E-15_JPRB, 0.38638882E-15_JPRB, 0.43039017E-15_JPRB, 0.49838550E-15_JPRB, 0.59637695E-15_JPRB, 0.72804081E-15_JPRB, &
  & 0.90766441E-15_JPRB, 0.11245303E-14_JPRB, 0.13717983E-14_JPRB, 0.16497304E-14_JPRB, 0.19108587E-14_JPRB, 0.21509301E-14_JPRB, &
  & 0.24037522E-14_JPRB, 0.26301279E-14_JPRB, 0.28108098E-14_JPRB, 0.30041434E-14_JPRB, 0.31844756E-14_JPRB, 0.34146926E-14_JPRB, &
  & 0.36248944E-14_JPRB, 0.38683088E-14_JPRB, 0.40395946E-14_JPRB, 0.41725161E-14_JPRB, 0.41360873E-14_JPRB, 0.40287229E-14_JPRB, &
  & 0.37642068E-14_JPRB, 0.34464263E-14_JPRB, 0.31617987E-14_JPRB, 0.27773236E-14_JPRB, 0.27678303E-14_JPRB, 0.22814375E-14_JPRB, &
  & 0.20862375E-14_JPRB, 0.19065221E-14_JPRB, 0.18295511E-14_JPRB, 0.15770977E-14_JPRB, 0.13902952E-14_JPRB, 0.10728227E-14_JPRB, &
  & 0.97415226E-15_JPRB, 0.10366411E-14_JPRB, 0.99420725E-15_JPRB, 0.61883973E-15_JPRB, 0.43478228E-15_JPRB, 0.39698865E-15_JPRB, &
  & 0.34619497E-15_JPRB, 0.28047222E-15_JPRB, 0.22583378E-15_JPRB, 0.18191099E-15_JPRB, 0.14603777E-15_JPRB, 0.11269134E-15_JPRB, &
  & 0.84581878E-16_JPRB, 0.60261133E-16_JPRB, 0.45077446E-16_JPRB, 0.46133325E-16_JPRB, 0.61736023E-16_JPRB, 0.87808921E-16_JPRB, &
  & 0.11396781E-15_JPRB, 0.13983325E-15_JPRB, 0.21628617E-15_JPRB, 0.34631035E-15_JPRB /)

RGHG9(:,16, 5) = (/ &
  & 0.37509588E-14_JPRB, 0.31770444E-14_JPRB, 0.29018468E-14_JPRB, 0.27145665E-14_JPRB, 0.25850563E-14_JPRB, 0.25241671E-14_JPRB, &
  & 0.25568695E-14_JPRB, 0.27106473E-14_JPRB, 0.30076414E-14_JPRB, 0.34705229E-14_JPRB, 0.41045675E-14_JPRB, 0.49509554E-14_JPRB, &
  & 0.60894092E-14_JPRB, 0.74380047E-14_JPRB, 0.90322291E-14_JPRB, 0.10859759E-13_JPRB, 0.12996960E-13_JPRB, 0.15199142E-13_JPRB, &
  & 0.17663388E-13_JPRB, 0.20239842E-13_JPRB, 0.22652114E-13_JPRB, 0.24912748E-13_JPRB, 0.27711737E-13_JPRB, 0.30954799E-13_JPRB, &
  & 0.34619012E-13_JPRB, 0.38169917E-13_JPRB, 0.41153980E-13_JPRB, 0.42791434E-13_JPRB, 0.42622793E-13_JPRB, 0.40712249E-13_JPRB, &
  & 0.37249731E-13_JPRB, 0.33110586E-13_JPRB, 0.28532728E-13_JPRB, 0.24076144E-13_JPRB, 0.20724746E-13_JPRB, 0.18106034E-13_JPRB, &
  & 0.17221650E-13_JPRB, 0.16027002E-13_JPRB, 0.14827115E-13_JPRB, 0.13607733E-13_JPRB, 0.12522843E-13_JPRB, 0.11201636E-13_JPRB, &
  & 0.94286795E-14_JPRB, 0.76815097E-14_JPRB, 0.56680802E-14_JPRB, 0.44479695E-14_JPRB, 0.37834044E-14_JPRB, 0.37379085E-14_JPRB, &
  & 0.33572390E-14_JPRB, 0.27529261E-14_JPRB, 0.21879759E-14_JPRB, 0.18211270E-14_JPRB, 0.14842385E-14_JPRB, 0.11602405E-14_JPRB, &
  & 0.88764219E-15_JPRB, 0.69487333E-15_JPRB, 0.60450608E-15_JPRB, 0.64696832E-15_JPRB, 0.81206372E-15_JPRB, 0.10985658E-14_JPRB, &
  & 0.14961714E-14_JPRB, 0.20725009E-14_JPRB, 0.32225834E-14_JPRB, 0.56996597E-14_JPRB /)

RGHG9(:,17, 5) = (/ &
  & 0.19304184E-13_JPRB, 0.16566177E-13_JPRB, 0.14801863E-13_JPRB, 0.13673999E-13_JPRB, 0.12890393E-13_JPRB, 0.12489683E-13_JPRB, &
  & 0.12559047E-13_JPRB, 0.13213088E-13_JPRB, 0.14560363E-13_JPRB, 0.16727715E-13_JPRB, 0.19765453E-13_JPRB, 0.23779859E-13_JPRB, &
  & 0.29086539E-13_JPRB, 0.35770283E-13_JPRB, 0.43774056E-13_JPRB, 0.52935500E-13_JPRB, 0.63294693E-13_JPRB, 0.75417550E-13_JPRB, &
  & 0.88775992E-13_JPRB, 0.10354765E-12_JPRB, 0.12090742E-12_JPRB, 0.14135558E-12_JPRB, 0.16613127E-12_JPRB, 0.19595325E-12_JPRB, &
  & 0.22613651E-12_JPRB, 0.25428260E-12_JPRB, 0.27685219E-12_JPRB, 0.29159628E-12_JPRB, 0.29015831E-12_JPRB, 0.27781458E-12_JPRB, &
  & 0.25225294E-12_JPRB, 0.21948663E-12_JPRB, 0.18490465E-12_JPRB, 0.15273675E-12_JPRB, 0.12703766E-12_JPRB, 0.10871565E-12_JPRB, &
  & 0.97843269E-13_JPRB, 0.93839738E-13_JPRB, 0.90736480E-13_JPRB, 0.90306845E-13_JPRB, 0.87962840E-13_JPRB, 0.82574443E-13_JPRB, &
  & 0.73786951E-13_JPRB, 0.63464106E-13_JPRB, 0.52181959E-13_JPRB, 0.42133479E-13_JPRB, 0.34836121E-13_JPRB, 0.29748814E-13_JPRB, &
  & 0.24929055E-13_JPRB, 0.19913443E-13_JPRB, 0.15481596E-13_JPRB, 0.11932872E-13_JPRB, 0.92913051E-14_JPRB, 0.75916539E-14_JPRB, &
  & 0.66635680E-14_JPRB, 0.63066503E-14_JPRB, 0.64063770E-14_JPRB, 0.72606724E-14_JPRB, 0.90435209E-14_JPRB, 0.11947237E-13_JPRB, &
  & 0.16113331E-13_JPRB, 0.21735828E-13_JPRB, 0.31399972E-13_JPRB, 0.58029495E-13_JPRB /)

RGHG9(:,18, 5) = (/ &
  & 0.77234782E-13_JPRB, 0.65958090E-13_JPRB, 0.59173152E-13_JPRB, 0.54671084E-13_JPRB, 0.51557879E-13_JPRB, 0.49839429E-13_JPRB, &
  & 0.49905304E-13_JPRB, 0.52204280E-13_JPRB, 0.57132589E-13_JPRB, 0.65201987E-13_JPRB, 0.76646439E-13_JPRB, 0.91434794E-13_JPRB, &
  & 0.11067984E-12_JPRB, 0.13490532E-12_JPRB, 0.16447791E-12_JPRB, 0.19974093E-12_JPRB, 0.24152647E-12_JPRB, 0.29033186E-12_JPRB, &
  & 0.34921781E-12_JPRB, 0.42122425E-12_JPRB, 0.50704840E-12_JPRB, 0.60281787E-12_JPRB, 0.70751440E-12_JPRB, 0.82816675E-12_JPRB, &
  & 0.96003197E-12_JPRB, 0.10899632E-11_JPRB, 0.12058415E-11_JPRB, 0.12817453E-11_JPRB, 0.12933031E-11_JPRB, 0.12442545E-11_JPRB, &
  & 0.11305182E-11_JPRB, 0.98897225E-12_JPRB, 0.83844639E-12_JPRB, 0.69632809E-12_JPRB, 0.58320411E-12_JPRB, 0.50201081E-12_JPRB, &
  & 0.45228998E-12_JPRB, 0.42814461E-12_JPRB, 0.42509212E-12_JPRB, 0.42790394E-12_JPRB, 0.42375269E-12_JPRB, 0.41151791E-12_JPRB, &
  & 0.38555422E-12_JPRB, 0.34694223E-12_JPRB, 0.30127902E-12_JPRB, 0.25438457E-12_JPRB, 0.21021150E-12_JPRB, 0.17079061E-12_JPRB, &
  & 0.13834454E-12_JPRB, 0.11341827E-12_JPRB, 0.94555291E-13_JPRB, 0.80447632E-13_JPRB, 0.70296863E-13_JPRB, 0.63253161E-13_JPRB, &
  & 0.58803338E-13_JPRB, 0.56721524E-13_JPRB, 0.57262720E-13_JPRB, 0.62139909E-13_JPRB, 0.71612712E-13_JPRB, 0.86270638E-13_JPRB, &
  & 0.10680215E-12_JPRB, 0.13454050E-12_JPRB, 0.17601664E-12_JPRB, 0.27113240E-12_JPRB /)

RGHG9(:,19, 5) = (/ &
  & 0.24463949E-12_JPRB, 0.21034377E-12_JPRB, 0.19152627E-12_JPRB, 0.17872742E-12_JPRB, 0.16965009E-12_JPRB, 0.16471264E-12_JPRB, &
  & 0.16504147E-12_JPRB, 0.17202103E-12_JPRB, 0.18698176E-12_JPRB, 0.21123621E-12_JPRB, 0.24545632E-12_JPRB, 0.29000034E-12_JPRB, &
  & 0.34492553E-12_JPRB, 0.41295881E-12_JPRB, 0.49487270E-12_JPRB, 0.59184824E-12_JPRB, 0.70624387E-12_JPRB, 0.84083413E-12_JPRB, &
  & 0.99800615E-12_JPRB, 0.11815026E-11_JPRB, 0.14031649E-11_JPRB, 0.16767641E-11_JPRB, 0.20026947E-11_JPRB, 0.23604044E-11_JPRB, &
  & 0.27489998E-11_JPRB, 0.31351154E-11_JPRB, 0.34725660E-11_JPRB, 0.37106247E-11_JPRB, 0.38051923E-11_JPRB, 0.37230661E-11_JPRB, &
  & 0.34824769E-11_JPRB, 0.31315939E-11_JPRB, 0.27256357E-11_JPRB, 0.23291310E-11_JPRB, 0.19960828E-11_JPRB, 0.17485463E-11_JPRB, &
  & 0.15909559E-11_JPRB, 0.15132885E-11_JPRB, 0.14944011E-11_JPRB, 0.15021159E-11_JPRB, 0.15027410E-11_JPRB, 0.14676875E-11_JPRB, &
  & 0.13896627E-11_JPRB, 0.12748871E-11_JPRB, 0.11372695E-11_JPRB, 0.98947846E-12_JPRB, 0.84524038E-12_JPRB, 0.71533925E-12_JPRB, &
  & 0.60546029E-12_JPRB, 0.51589500E-12_JPRB, 0.44501073E-12_JPRB, 0.39048907E-12_JPRB, 0.34933666E-12_JPRB, 0.31947735E-12_JPRB, &
  & 0.29978385E-12_JPRB, 0.28937304E-12_JPRB, 0.28848983E-12_JPRB, 0.30183505E-12_JPRB, 0.32929456E-12_JPRB, 0.37123164E-12_JPRB, &
  & 0.42907000E-12_JPRB, 0.50643159E-12_JPRB, 0.61471916E-12_JPRB, 0.85407658E-12_JPRB /)

RGHG9(:,20, 5) = (/ &
  & 0.63254496E-12_JPRB, 0.55439637E-12_JPRB, 0.51429813E-12_JPRB, 0.48674747E-12_JPRB, 0.46759059E-12_JPRB, 0.45788362E-12_JPRB, &
  & 0.46089049E-12_JPRB, 0.48024508E-12_JPRB, 0.51945536E-12_JPRB, 0.58163121E-12_JPRB, 0.66828395E-12_JPRB, 0.77942541E-12_JPRB, &
  & 0.91394947E-12_JPRB, 0.10738329E-11_JPRB, 0.12612103E-11_JPRB, 0.14777353E-11_JPRB, 0.17271956E-11_JPRB, 0.20166043E-11_JPRB, &
  & 0.23516454E-11_JPRB, 0.27429949E-11_JPRB, 0.31978632E-11_JPRB, 0.37205928E-11_JPRB, 0.43373399E-11_JPRB, 0.50424799E-11_JPRB, &
  & 0.58002067E-11_JPRB, 0.65671279E-11_JPRB, 0.72780211E-11_JPRB, 0.78116905E-11_JPRB, 0.81045093E-11_JPRB, 0.81137831E-11_JPRB, &
  & 0.78467345E-11_JPRB, 0.73290280E-11_JPRB, 0.66720869E-11_JPRB, 0.59572408E-11_JPRB, 0.52999662E-11_JPRB, 0.47695381E-11_JPRB, &
  & 0.44028613E-11_JPRB, 0.41900480E-11_JPRB, 0.40970257E-11_JPRB, 0.40465626E-11_JPRB, 0.39950647E-11_JPRB, 0.38888281E-11_JPRB, &
  & 0.36958275E-11_JPRB, 0.34232064E-11_JPRB, 0.30985913E-11_JPRB, 0.27453495E-11_JPRB, 0.23967059E-11_JPRB, 0.20762198E-11_JPRB, &
  & 0.18004530E-11_JPRB, 0.15674932E-11_JPRB, 0.13773626E-11_JPRB, 0.12256502E-11_JPRB, 0.11096384E-11_JPRB, 0.10262982E-11_JPRB, &
  & 0.97212668E-12_JPRB, 0.94326023E-12_JPRB, 0.93760004E-12_JPRB, 0.96274475E-12_JPRB, 0.10161962E-11_JPRB, 0.10966568E-11_JPRB, &
  & 0.12048798E-11_JPRB, 0.13489216E-11_JPRB, 0.15548139E-11_JPRB, 0.19866012E-11_JPRB /)

RGHG9(:,21, 5) = (/ &
  & 0.13732085E-11_JPRB, 0.12369436E-11_JPRB, 0.11709496E-11_JPRB, 0.11260123E-11_JPRB, 0.10963726E-11_JPRB, 0.10856552E-11_JPRB, &
  & 0.11006676E-11_JPRB, 0.11493423E-11_JPRB, 0.12398805E-11_JPRB, 0.13783019E-11_JPRB, 0.15672352E-11_JPRB, 0.18068886E-11_JPRB, &
  & 0.20922960E-11_JPRB, 0.24164696E-11_JPRB, 0.27839287E-11_JPRB, 0.31994095E-11_JPRB, 0.36625616E-11_JPRB, 0.41797737E-11_JPRB, &
  & 0.47630177E-11_JPRB, 0.54207177E-11_JPRB, 0.61635965E-11_JPRB, 0.70007593E-11_JPRB, 0.79314506E-11_JPRB, 0.89739717E-11_JPRB, &
  & 0.10081744E-10_JPRB, 0.11193020E-10_JPRB, 0.12244986E-10_JPRB, 0.13153683E-10_JPRB, 0.13802751E-10_JPRB, 0.14118108E-10_JPRB, &
  & 0.14063140E-10_JPRB, 0.13646955E-10_JPRB, 0.12970020E-10_JPRB, 0.12094422E-10_JPRB, 0.11211115E-10_JPRB, 0.10422721E-10_JPRB, &
  & 0.97981727E-11_JPRB, 0.93375325E-11_JPRB, 0.90247436E-11_JPRB, 0.87643989E-11_JPRB, 0.84852741E-11_JPRB, 0.81281371E-11_JPRB, &
  & 0.76673546E-11_JPRB, 0.71019180E-11_JPRB, 0.64671584E-11_JPRB, 0.57976302E-11_JPRB, 0.51402038E-11_JPRB, 0.45363348E-11_JPRB, &
  & 0.40065477E-11_JPRB, 0.35497952E-11_JPRB, 0.31701154E-11_JPRB, 0.28640868E-11_JPRB, 0.26304247E-11_JPRB, 0.24612907E-11_JPRB, &
  & 0.23496216E-11_JPRB, 0.22865152E-11_JPRB, 0.22656373E-11_JPRB, 0.22954165E-11_JPRB, 0.23690915E-11_JPRB, 0.24810928E-11_JPRB, &
  & 0.26287941E-11_JPRB, 0.28198494E-11_JPRB, 0.30951548E-11_JPRB, 0.36298714E-11_JPRB /)

RGHG9(:,22, 5) = (/ &
  & 0.25780213E-11_JPRB, 0.23935617E-11_JPRB, 0.23076035E-11_JPRB, 0.22526037E-11_JPRB, 0.22232504E-11_JPRB, 0.22265063E-11_JPRB, &
  & 0.22755506E-11_JPRB, 0.23858094E-11_JPRB, 0.25710282E-11_JPRB, 0.28418220E-11_JPRB, 0.32035069E-11_JPRB, 0.36527708E-11_JPRB, &
  & 0.41812565E-11_JPRB, 0.47728418E-11_JPRB, 0.54140624E-11_JPRB, 0.61096289E-11_JPRB, 0.68640545E-11_JPRB, 0.76741374E-11_JPRB, &
  & 0.85522431E-11_JPRB, 0.94996849E-11_JPRB, 0.10531322E-10_JPRB, 0.11645718E-10_JPRB, 0.12834509E-10_JPRB, 0.14094722E-10_JPRB, &
  & 0.15418507E-10_JPRB, 0.16775272E-10_JPRB, 0.18102147E-10_JPRB, 0.19303413E-10_JPRB, 0.20305022E-10_JPRB, 0.21039630E-10_JPRB, &
  & 0.21417312E-10_JPRB, 0.21405414E-10_JPRB, 0.21038529E-10_JPRB, 0.20347796E-10_JPRB, 0.19501973E-10_JPRB, 0.18595890E-10_JPRB, &
  & 0.17764125E-10_JPRB, 0.17007029E-10_JPRB, 0.16341893E-10_JPRB, 0.15678923E-10_JPRB, 0.14957854E-10_JPRB, 0.14123704E-10_JPRB, &
  & 0.13181322E-10_JPRB, 0.12152872E-10_JPRB, 0.11086044E-10_JPRB, 0.10009190E-10_JPRB, 0.89845128E-11_JPRB, 0.80512793E-11_JPRB, &
  & 0.72325631E-11_JPRB, 0.65261928E-11_JPRB, 0.59355723E-11_JPRB, 0.54567652E-11_JPRB, 0.50842577E-11_JPRB, 0.48066117E-11_JPRB, &
  & 0.46131441E-11_JPRB, 0.44909740E-11_JPRB, 0.44307713E-11_JPRB, 0.44405469E-11_JPRB, 0.45093473E-11_JPRB, 0.46277522E-11_JPRB, &
  & 0.47888143E-11_JPRB, 0.49957473E-11_JPRB, 0.52869111E-11_JPRB, 0.59240330E-11_JPRB /)

RGHG9(:,23, 5) = (/ &
  & 0.42961620E-11_JPRB, 0.41032438E-11_JPRB, 0.40199497E-11_JPRB, 0.39758626E-11_JPRB, 0.39701042E-11_JPRB, 0.40159031E-11_JPRB, &
  & 0.41359316E-11_JPRB, 0.43527777E-11_JPRB, 0.46892056E-11_JPRB, 0.51606211E-11_JPRB, 0.57732478E-11_JPRB, 0.65234896E-11_JPRB, &
  & 0.73898578E-11_JPRB, 0.83459949E-11_JPRB, 0.93544218E-11_JPRB, 0.10405762E-10_JPRB, 0.11501685E-10_JPRB, 0.12637185E-10_JPRB, &
  & 0.13811991E-10_JPRB, 0.15026539E-10_JPRB, 0.16271455E-10_JPRB, 0.17546724E-10_JPRB, 0.18841116E-10_JPRB, 0.20159782E-10_JPRB, &
  & 0.21502584E-10_JPRB, 0.22877592E-10_JPRB, 0.24296461E-10_JPRB, 0.25723017E-10_JPRB, 0.27045706E-10_JPRB, 0.28200678E-10_JPRB, &
  & 0.29085772E-10_JPRB, 0.29624265E-10_JPRB, 0.29772889E-10_JPRB, 0.29527474E-10_JPRB, 0.28966392E-10_JPRB, 0.28174983E-10_JPRB, &
  & 0.27245107E-10_JPRB, 0.26224392E-10_JPRB, 0.25138093E-10_JPRB, 0.23949235E-10_JPRB, 0.22639175E-10_JPRB, 0.21206635E-10_JPRB, &
  & 0.19684410E-10_JPRB, 0.18113002E-10_JPRB, 0.16555207E-10_JPRB, 0.15055261E-10_JPRB, 0.13667047E-10_JPRB, 0.12421265E-10_JPRB, &
  & 0.11336928E-10_JPRB, 0.10400545E-10_JPRB, 0.96122849E-11_JPRB, 0.89643492E-11_JPRB, 0.84501928E-11_JPRB, 0.80547383E-11_JPRB, &
  & 0.77629231E-11_JPRB, 0.75579404E-11_JPRB, 0.74282195E-11_JPRB, 0.73815017E-11_JPRB, 0.74064227E-11_JPRB, 0.74927625E-11_JPRB, &
  & 0.76318240E-11_JPRB, 0.78221006E-11_JPRB, 0.80898170E-11_JPRB, 0.86770331E-11_JPRB /)

RGHG9(:,24, 5) = (/ &
  & 0.65258641E-11_JPRB, 0.63765408E-11_JPRB, 0.63258400E-11_JPRB, 0.63206983E-11_JPRB, 0.63689960E-11_JPRB, 0.64932829E-11_JPRB, &
  & 0.67239608E-11_JPRB, 0.70956852E-11_JPRB, 0.76352856E-11_JPRB, 0.83632615E-11_JPRB, 0.92867667E-11_JPRB, 0.10395768E-10_JPRB, &
  & 0.11660543E-10_JPRB, 0.13037051E-10_JPRB, 0.14471116E-10_JPRB, 0.15913392E-10_JPRB, 0.17366881E-10_JPRB, 0.18815611E-10_JPRB, &
  & 0.20255660E-10_JPRB, 0.21673413E-10_JPRB, 0.23056824E-10_JPRB, 0.24389641E-10_JPRB, 0.25668049E-10_JPRB, 0.26901561E-10_JPRB, &
  & 0.28121748E-10_JPRB, 0.29376432E-10_JPRB, 0.30713630E-10_JPRB, 0.32149099E-10_JPRB, 0.33662250E-10_JPRB, 0.35141161E-10_JPRB, &
  & 0.36459041E-10_JPRB, 0.37502657E-10_JPRB, 0.38165155E-10_JPRB, 0.38399613E-10_JPRB, 0.38199478E-10_JPRB, 0.37608552E-10_JPRB, &
  & 0.36675989E-10_JPRB, 0.35463823E-10_JPRB, 0.34004674E-10_JPRB, 0.32339874E-10_JPRB, 0.30487817E-10_JPRB, 0.28493074E-10_JPRB, &
  & 0.26435458E-10_JPRB, 0.24380352E-10_JPRB, 0.22406859E-10_JPRB, 0.20549768E-10_JPRB, 0.18858692E-10_JPRB, 0.17356411E-10_JPRB, &
  & 0.16052819E-10_JPRB, 0.14926480E-10_JPRB, 0.13973499E-10_JPRB, 0.13183268E-10_JPRB, 0.12545619E-10_JPRB, 0.12040581E-10_JPRB, &
  & 0.11648451E-10_JPRB, 0.11348296E-10_JPRB, 0.11126239E-10_JPRB, 0.10989041E-10_JPRB, 0.10928216E-10_JPRB, 0.10936384E-10_JPRB, &
  & 0.11007164E-10_JPRB, 0.11140153E-10_JPRB, 0.11350529E-10_JPRB, 0.11772289E-10_JPRB /)

RGHG9(:,25, 5) = (/ &
  & 0.92284323E-11_JPRB, 0.91682842E-11_JPRB, 0.91767783E-11_JPRB, 0.92355880E-11_JPRB, 0.93652690E-11_JPRB, 0.95956932E-11_JPRB, &
  & 0.99684488E-11_JPRB, 0.10525389E-10_JPRB, 0.11298005E-10_JPRB, 0.12306722E-10_JPRB, 0.13558282E-10_JPRB, 0.15033341E-10_JPRB, &
  & 0.16693169E-10_JPRB, 0.18476807E-10_JPRB, 0.20311265E-10_JPRB, 0.22132204E-10_JPRB, 0.23911550E-10_JPRB, 0.25635018E-10_JPRB, &
  & 0.27289185E-10_JPRB, 0.28853081E-10_JPRB, 0.30309148E-10_JPRB, 0.31635344E-10_JPRB, 0.32823202E-10_JPRB, 0.33904810E-10_JPRB, &
  & 0.34929826E-10_JPRB, 0.35985853E-10_JPRB, 0.37163175E-10_JPRB, 0.38513744E-10_JPRB, 0.40031263E-10_JPRB, 0.41654812E-10_JPRB, &
  & 0.43236113E-10_JPRB, 0.44622982E-10_JPRB, 0.45660292E-10_JPRB, 0.46257380E-10_JPRB, 0.46343165E-10_JPRB, 0.45918228E-10_JPRB, &
  & 0.45003036E-10_JPRB, 0.43669408E-10_JPRB, 0.41965119E-10_JPRB, 0.39948465E-10_JPRB, 0.37700117E-10_JPRB, 0.35302677E-10_JPRB, &
  & 0.32864399E-10_JPRB, 0.30470716E-10_JPRB, 0.28199736E-10_JPRB, 0.26093388E-10_JPRB, 0.24198752E-10_JPRB, 0.22526979E-10_JPRB, &
  & 0.21080200E-10_JPRB, 0.19829423E-10_JPRB, 0.18763633E-10_JPRB, 0.17869690E-10_JPRB, 0.17133983E-10_JPRB, 0.16533028E-10_JPRB, &
  & 0.16044050E-10_JPRB, 0.15644428E-10_JPRB, 0.15318294E-10_JPRB, 0.15070469E-10_JPRB, 0.14895880E-10_JPRB, 0.14791701E-10_JPRB, &
  & 0.14755237E-10_JPRB, 0.14787555E-10_JPRB, 0.14903107E-10_JPRB, 0.15228600E-10_JPRB /)

RGHG9(:,26, 5) = (/ &
  & 0.12345886E-10_JPRB, 0.12404902E-10_JPRB, 0.12486627E-10_JPRB, 0.12627648E-10_JPRB, 0.12849759E-10_JPRB, 0.13198581E-10_JPRB, &
  & 0.13724738E-10_JPRB, 0.14470759E-10_JPRB, 0.15472158E-10_JPRB, 0.16746854E-10_JPRB, 0.18291481E-10_JPRB, 0.20089923E-10_JPRB, &
  & 0.22085327E-10_JPRB, 0.24214217E-10_JPRB, 0.26385725E-10_JPRB, 0.28527670E-10_JPRB, 0.30576659E-10_JPRB, 0.32517863E-10_JPRB, &
  & 0.34331531E-10_JPRB, 0.35996282E-10_JPRB, 0.37487145E-10_JPRB, 0.38781079E-10_JPRB, 0.39879211E-10_JPRB, 0.40815708E-10_JPRB, &
  & 0.41655183E-10_JPRB, 0.42498047E-10_JPRB, 0.43466848E-10_JPRB, 0.44649940E-10_JPRB, 0.46081552E-10_JPRB, 0.47690636E-10_JPRB, &
  & 0.49347346E-10_JPRB, 0.50887371E-10_JPRB, 0.52121460E-10_JPRB, 0.52919107E-10_JPRB, 0.53165833E-10_JPRB, 0.52834161E-10_JPRB, &
  & 0.51935154E-10_JPRB, 0.50521188E-10_JPRB, 0.48673551E-10_JPRB, 0.46461231E-10_JPRB, 0.43995693E-10_JPRB, 0.41386485E-10_JPRB, &
  & 0.38745333E-10_JPRB, 0.36176798E-10_JPRB, 0.33761192E-10_JPRB, 0.31546869E-10_JPRB, 0.29557728E-10_JPRB, 0.27808526E-10_JPRB, &
  & 0.26288555E-10_JPRB, 0.24966336E-10_JPRB, 0.23827121E-10_JPRB, 0.22855091E-10_JPRB, 0.22034144E-10_JPRB, 0.21342672E-10_JPRB, &
  & 0.20757470E-10_JPRB, 0.20255547E-10_JPRB, 0.19820290E-10_JPRB, 0.19454880E-10_JPRB, 0.19156902E-10_JPRB, 0.18927786E-10_JPRB, &
  & 0.18768098E-10_JPRB, 0.18677086E-10_JPRB, 0.18651428E-10_JPRB, 0.18728651E-10_JPRB /)

RGHG9(:,27, 5) = (/ &
  & 0.15800449E-10_JPRB, 0.15972021E-10_JPRB, 0.16146312E-10_JPRB, 0.16362618E-10_JPRB, 0.16681377E-10_JPRB, 0.17146499E-10_JPRB, &
  & 0.17811426E-10_JPRB, 0.18733612E-10_JPRB, 0.19931567E-10_JPRB, 0.21421446E-10_JPRB, 0.23202605E-10_JPRB, 0.25238998E-10_JPRB, &
  & 0.27488857E-10_JPRB, 0.29868476E-10_JPRB, 0.32290903E-10_JPRB, 0.34666159E-10_JPRB, 0.36921733E-10_JPRB, 0.39026424E-10_JPRB, &
  & 0.40958726E-10_JPRB, 0.42697561E-10_JPRB, 0.44216596E-10_JPRB, 0.45498112E-10_JPRB, 0.46544602E-10_JPRB, 0.47388322E-10_JPRB, &
  & 0.48092873E-10_JPRB, 0.48765166E-10_JPRB, 0.49541874E-10_JPRB, 0.50515245E-10_JPRB, 0.51756523E-10_JPRB, 0.53243333E-10_JPRB, &
  & 0.54827871E-10_JPRB, 0.56358033E-10_JPRB, 0.57631549E-10_JPRB, 0.58482351E-10_JPRB, 0.58782819E-10_JPRB, 0.58485126E-10_JPRB, &
  & 0.57591459E-10_JPRB, 0.56137837E-10_JPRB, 0.54231290E-10_JPRB, 0.51970997E-10_JPRB, 0.49444750E-10_JPRB, 0.46788226E-10_JPRB, &
  & 0.44116277E-10_JPRB, 0.41540937E-10_JPRB, 0.39124492E-10_JPRB, 0.36903858E-10_JPRB, 0.34908347E-10_JPRB, 0.33143127E-10_JPRB, &
  & 0.31595414E-10_JPRB, 0.30234860E-10_JPRB, 0.29041890E-10_JPRB, 0.28001081E-10_JPRB, 0.27100336E-10_JPRB, 0.26317493E-10_JPRB, &
  & 0.25632604E-10_JPRB, 0.25024963E-10_JPRB, 0.24478921E-10_JPRB, 0.23994477E-10_JPRB, 0.23572762E-10_JPRB, 0.23219357E-10_JPRB, &
  & 0.22938467E-10_JPRB, 0.22729528E-10_JPRB, 0.22576708E-10_JPRB, 0.22441972E-10_JPRB /)

RGHG9(:,28, 5) = (/ &
  & 0.19428592E-10_JPRB, 0.19759793E-10_JPRB, 0.19996801E-10_JPRB, 0.20301302E-10_JPRB, 0.20701224E-10_JPRB, 0.21265181E-10_JPRB, &
  & 0.22060773E-10_JPRB, 0.23117839E-10_JPRB, 0.24472346E-10_JPRB, 0.26122885E-10_JPRB, 0.28058774E-10_JPRB, 0.30261741E-10_JPRB, &
  & 0.32668718E-10_JPRB, 0.35212076E-10_JPRB, 0.37794372E-10_JPRB, 0.40325347E-10_JPRB, 0.42733015E-10_JPRB, 0.44955688E-10_JPRB, &
  & 0.46978071E-10_JPRB, 0.48779522E-10_JPRB, 0.50337682E-10_JPRB, 0.51633576E-10_JPRB, 0.52669029E-10_JPRB, 0.53472747E-10_JPRB, &
  & 0.54103211E-10_JPRB, 0.54664190E-10_JPRB, 0.55275805E-10_JPRB, 0.56054290E-10_JPRB, 0.57077107E-10_JPRB, 0.58347632E-10_JPRB, &
  & 0.59758594E-10_JPRB, 0.61154651E-10_JPRB, 0.62346545E-10_JPRB, 0.63143817E-10_JPRB, 0.63423190E-10_JPRB, 0.63119295E-10_JPRB, &
  & 0.62227341E-10_JPRB, 0.60798172E-10_JPRB, 0.58922749E-10_JPRB, 0.56703021E-10_JPRB, 0.54245899E-10_JPRB, 0.51680726E-10_JPRB, &
  & 0.49119635E-10_JPRB, 0.46652397E-10_JPRB, 0.44330539E-10_JPRB, 0.42187347E-10_JPRB, 0.40238667E-10_JPRB, 0.38496328E-10_JPRB, &
  & 0.36945128E-10_JPRB, 0.35555926E-10_JPRB, 0.34312744E-10_JPRB, 0.33203856E-10_JPRB, 0.32217111E-10_JPRB, 0.31338581E-10_JPRB, &
  & 0.30549667E-10_JPRB, 0.29832223E-10_JPRB, 0.29171839E-10_JPRB, 0.28567865E-10_JPRB, 0.28024204E-10_JPRB, 0.27549126E-10_JPRB, &
  & 0.27152013E-10_JPRB, 0.26829164E-10_JPRB, 0.26548784E-10_JPRB, 0.26215686E-10_JPRB /)

RGHG9(:,29, 5) = (/ &
  & 0.23160848E-10_JPRB, 0.23577557E-10_JPRB, 0.23920400E-10_JPRB, 0.24278066E-10_JPRB, 0.24758647E-10_JPRB, 0.25414528E-10_JPRB, &
  & 0.26300987E-10_JPRB, 0.27477888E-10_JPRB, 0.28938818E-10_JPRB, 0.30691137E-10_JPRB, 0.32727567E-10_JPRB, 0.35012774E-10_JPRB, &
  & 0.37512701E-10_JPRB, 0.40144433E-10_JPRB, 0.42819887E-10_JPRB, 0.45440124E-10_JPRB, 0.47933352E-10_JPRB, 0.50241884E-10_JPRB, &
  & 0.52333932E-10_JPRB, 0.54188334E-10_JPRB, 0.55789512E-10_JPRB, 0.57114549E-10_JPRB, 0.58170972E-10_JPRB, 0.58978010E-10_JPRB, &
  & 0.59586787E-10_JPRB, 0.60089364E-10_JPRB, 0.60584981E-10_JPRB, 0.61193786E-10_JPRB, 0.62004513E-10_JPRB, 0.63027250E-10_JPRB, &
  & 0.64201713E-10_JPRB, 0.65384177E-10_JPRB, 0.66408393E-10_JPRB, 0.67083956E-10_JPRB, 0.67290805E-10_JPRB, 0.66959889E-10_JPRB, &
  & 0.66090529E-10_JPRB, 0.64725184E-10_JPRB, 0.62953226E-10_JPRB, 0.60868977E-10_JPRB, 0.58580800E-10_JPRB, 0.56207632E-10_JPRB, &
  & 0.53851965E-10_JPRB, 0.51574849E-10_JPRB, 0.49419649E-10_JPRB, 0.47395029E-10_JPRB, 0.45524293E-10_JPRB, 0.43816960E-10_JPRB, &
  & 0.42263113E-10_JPRB, 0.40841736E-10_JPRB, 0.39541745E-10_JPRB, 0.38354556E-10_JPRB, 0.37277875E-10_JPRB, 0.36300522E-10_JPRB, &
  & 0.35406574E-10_JPRB, 0.34580762E-10_JPRB, 0.33809115E-10_JPRB, 0.33088362E-10_JPRB, 0.32425312E-10_JPRB, 0.31830802E-10_JPRB, &
  & 0.31317463E-10_JPRB, 0.30879767E-10_JPRB, 0.30474661E-10_JPRB, 0.29913117E-10_JPRB /)

RGHG9(:,30, 5) = (/ &
  & 0.26784507E-10_JPRB, 0.27377637E-10_JPRB, 0.27758821E-10_JPRB, 0.28201736E-10_JPRB, 0.28741998E-10_JPRB, 0.29468265E-10_JPRB, &
  & 0.30446916E-10_JPRB, 0.31693547E-10_JPRB, 0.33229832E-10_JPRB, 0.35041837E-10_JPRB, 0.37118079E-10_JPRB, 0.39444562E-10_JPRB, &
  & 0.41966378E-10_JPRB, 0.44628190E-10_JPRB, 0.47342748E-10_JPRB, 0.50007463E-10_JPRB, 0.52547366E-10_JPRB, 0.54905393E-10_JPRB, &
  & 0.57045198E-10_JPRB, 0.58936453E-10_JPRB, 0.60576925E-10_JPRB, 0.61933826E-10_JPRB, 0.63027313E-10_JPRB, 0.63861097E-10_JPRB, &
  & 0.64483890E-10_JPRB, 0.64966199E-10_JPRB, 0.65391845E-10_JPRB, 0.65870656E-10_JPRB, 0.66491097E-10_JPRB, 0.67276025E-10_JPRB, &
  & 0.68193395E-10_JPRB, 0.69127273E-10_JPRB, 0.69940019E-10_JPRB, 0.70457543E-10_JPRB, 0.70568829E-10_JPRB, 0.70210039E-10_JPRB, &
  & 0.69375082E-10_JPRB, 0.68114084E-10_JPRB, 0.66503372E-10_JPRB, 0.64630842E-10_JPRB, 0.62584139E-10_JPRB, 0.60470767E-10_JPRB, &
  & 0.58367179E-10_JPRB, 0.56322176E-10_JPRB, 0.54346527E-10_JPRB, 0.52462208E-10_JPRB, 0.50666860E-10_JPRB, 0.48992841E-10_JPRB, &
  & 0.47437599E-10_JPRB, 0.45979158E-10_JPRB, 0.44616085E-10_JPRB, 0.43350067E-10_JPRB, 0.42180308E-10_JPRB, 0.41104904E-10_JPRB, &
  & 0.40111914E-10_JPRB, 0.39186751E-10_JPRB, 0.38313602E-10_JPRB, 0.37488779E-10_JPRB, 0.36718684E-10_JPRB, 0.36015083E-10_JPRB, &
  & 0.35396564E-10_JPRB, 0.34855056E-10_JPRB, 0.34341877E-10_JPRB, 0.33607065E-10_JPRB /)

RGHG9(:,31, 5) = (/ &
  & 0.30342315E-10_JPRB, 0.31008099E-10_JPRB, 0.31503675E-10_JPRB, 0.31989394E-10_JPRB, 0.32599111E-10_JPRB, 0.33393243E-10_JPRB, &
  & 0.34422996E-10_JPRB, 0.35730897E-10_JPRB, 0.37299396E-10_JPRB, 0.39127493E-10_JPRB, 0.41212683E-10_JPRB, 0.43526242E-10_JPRB, &
  & 0.46040921E-10_JPRB, 0.48680702E-10_JPRB, 0.51378866E-10_JPRB, 0.54050219E-10_JPRB, 0.56605179E-10_JPRB, 0.58983443E-10_JPRB, &
  & 0.61152396E-10_JPRB, 0.63066205E-10_JPRB, 0.64733663E-10_JPRB, 0.66120762E-10_JPRB, 0.67249338E-10_JPRB, 0.68120148E-10_JPRB, &
  & 0.68772800E-10_JPRB, 0.69262165E-10_JPRB, 0.69659264E-10_JPRB, 0.70046691E-10_JPRB, 0.70514573E-10_JPRB, 0.71084715E-10_JPRB, &
  & 0.71755567E-10_JPRB, 0.72441851E-10_JPRB, 0.73032226E-10_JPRB, 0.73382814E-10_JPRB, 0.73391598E-10_JPRB, 0.73006066E-10_JPRB, &
  & 0.72224504E-10_JPRB, 0.71092979E-10_JPRB, 0.69677625E-10_JPRB, 0.68045916E-10_JPRB, 0.66279086E-10_JPRB, 0.64447885E-10_JPRB, &
  & 0.62616037E-10_JPRB, 0.60808185E-10_JPRB, 0.59031481E-10_JPRB, 0.57272534E-10_JPRB, 0.55564366E-10_JPRB, 0.53920628E-10_JPRB, &
  & 0.52353351E-10_JPRB, 0.50857572E-10_JPRB, 0.49433395E-10_JPRB, 0.48087652E-10_JPRB, 0.46832791E-10_JPRB, 0.45670238E-10_JPRB, &
  & 0.44590661E-10_JPRB, 0.43580424E-10_JPRB, 0.42623113E-10_JPRB, 0.41712456E-10_JPRB, 0.40853720E-10_JPRB, 0.40061125E-10_JPRB, &
  & 0.39353271E-10_JPRB, 0.38725467E-10_JPRB, 0.38116690E-10_JPRB, 0.37240825E-10_JPRB /)

RGHG9(:,32, 5) = (/ &
  & 0.33695872E-10_JPRB, 0.34557315E-10_JPRB, 0.35084470E-10_JPRB, 0.35659243E-10_JPRB, 0.36320263E-10_JPRB, 0.37162249E-10_JPRB, &
  & 0.38242600E-10_JPRB, 0.39566187E-10_JPRB, 0.41139866E-10_JPRB, 0.42955046E-10_JPRB, 0.45003147E-10_JPRB, 0.47279104E-10_JPRB, &
  & 0.49737651E-10_JPRB, 0.52335570E-10_JPRB, 0.54989482E-10_JPRB, 0.57624024E-10_JPRB, 0.60166504E-10_JPRB, 0.62537801E-10_JPRB, &
  & 0.64712520E-10_JPRB, 0.66638577E-10_JPRB, 0.68315784E-10_JPRB, 0.69727182E-10_JPRB, 0.70879844E-10_JPRB, 0.71786771E-10_JPRB, &
  & 0.72470981E-10_JPRB, 0.72979504E-10_JPRB, 0.73369769E-10_JPRB, 0.73704251E-10_JPRB, 0.74054991E-10_JPRB, 0.74452791E-10_JPRB, &
  & 0.74906151E-10_JPRB, 0.75366387E-10_JPRB, 0.75746569E-10_JPRB, 0.75931622E-10_JPRB, 0.75837905E-10_JPRB, 0.75429558E-10_JPRB, &
  & 0.74714505E-10_JPRB, 0.73727621E-10_JPRB, 0.72519796E-10_JPRB, 0.71141551E-10_JPRB, 0.69647489E-10_JPRB, 0.68095911E-10_JPRB, &
  & 0.66515765E-10_JPRB, 0.64930547E-10_JPRB, 0.63323749E-10_JPRB, 0.61700027E-10_JPRB, 0.60071316E-10_JPRB, 0.58465212E-10_JPRB, &
  & 0.56897504E-10_JPRB, 0.55371221E-10_JPRB, 0.53896304E-10_JPRB, 0.52486730E-10_JPRB, 0.51163719E-10_JPRB, 0.49930379E-10_JPRB, &
  & 0.48783533E-10_JPRB, 0.47707789E-10_JPRB, 0.46685419E-10_JPRB, 0.45710061E-10_JPRB, 0.44785058E-10_JPRB, 0.43924336E-10_JPRB, &
  & 0.43148679E-10_JPRB, 0.42451299E-10_JPRB, 0.41764724E-10_JPRB, 0.40769613E-10_JPRB /)

RGHG9(:,33, 5) = (/ &
  & 0.36979635E-10_JPRB, 0.37926943E-10_JPRB, 0.38580059E-10_JPRB, 0.39192316E-10_JPRB, 0.39913479E-10_JPRB, 0.40799128E-10_JPRB, &
  & 0.41891334E-10_JPRB, 0.43216930E-10_JPRB, 0.44762458E-10_JPRB, 0.46527664E-10_JPRB, 0.48519341E-10_JPRB, 0.50716979E-10_JPRB, &
  & 0.53100437E-10_JPRB, 0.55609045E-10_JPRB, 0.58192454E-10_JPRB, 0.60773921E-10_JPRB, 0.63277120E-10_JPRB, 0.65628246E-10_JPRB, &
  & 0.67786700E-10_JPRB, 0.69711965E-10_JPRB, 0.71389020E-10_JPRB, 0.72811347E-10_JPRB, 0.73979267E-10_JPRB, 0.74911022E-10_JPRB, &
  & 0.75621273E-10_JPRB, 0.76149212E-10_JPRB, 0.76540080E-10_JPRB, 0.76844892E-10_JPRB, 0.77115314E-10_JPRB, 0.77382767E-10_JPRB, &
  & 0.77663050E-10_JPRB, 0.77932640E-10_JPRB, 0.78132056E-10_JPRB, 0.78178221E-10_JPRB, 0.78010556E-10_JPRB, 0.77602091E-10_JPRB, &
  & 0.76952000E-10_JPRB, 0.76095963E-10_JPRB, 0.75076292E-10_JPRB, 0.73925997E-10_JPRB, 0.72677225E-10_JPRB, 0.71362562E-10_JPRB, &
  & 0.70009804E-10_JPRB, 0.68603921E-10_JPRB, 0.67154192E-10_JPRB, 0.65640618E-10_JPRB, 0.64094258E-10_JPRB, 0.62538280E-10_JPRB, &
  & 0.60983024E-10_JPRB, 0.59446600E-10_JPRB, 0.57940125E-10_JPRB, 0.56490746E-10_JPRB, 0.55120932E-10_JPRB, 0.53842111E-10_JPRB, &
  & 0.52650655E-10_JPRB, 0.51531109E-10_JPRB, 0.50466110E-10_JPRB, 0.49448085E-10_JPRB, 0.48478332E-10_JPRB, 0.47573674E-10_JPRB, &
  & 0.46749573E-10_JPRB, 0.46003909E-10_JPRB, 0.45260243E-10_JPRB, 0.44173994E-10_JPRB /)

RGHG9(:,34, 5) = (/ &
  & 0.40101152E-10_JPRB, 0.41244830E-10_JPRB, 0.41928693E-10_JPRB, 0.42621639E-10_JPRB, 0.43378041E-10_JPRB, 0.44286453E-10_JPRB, &
  & 0.45384564E-10_JPRB, 0.46679237E-10_JPRB, 0.48173514E-10_JPRB, 0.49869824E-10_JPRB, 0.51768669E-10_JPRB, 0.53873104E-10_JPRB, &
  & 0.56150105E-10_JPRB, 0.58564154E-10_JPRB, 0.61047008E-10_JPRB, 0.63545211E-10_JPRB, 0.65990047E-10_JPRB, 0.68305132E-10_JPRB, &
  & 0.70436795E-10_JPRB, 0.72346733E-10_JPRB, 0.74016959E-10_JPRB, 0.75438399E-10_JPRB, 0.76613646E-10_JPRB, 0.77557037E-10_JPRB, &
  & 0.78285052E-10_JPRB, 0.78826515E-10_JPRB, 0.79219839E-10_JPRB, 0.79503668E-10_JPRB, 0.79720418E-10_JPRB, 0.79894986E-10_JPRB, &
  & 0.80047642E-10_JPRB, 0.80169163E-10_JPRB, 0.80224272E-10_JPRB, 0.80158526E-10_JPRB, 0.79929237E-10_JPRB, 0.79522840E-10_JPRB, &
  & 0.78952206E-10_JPRB, 0.78227723E-10_JPRB, 0.77374059E-10_JPRB, 0.76411148E-10_JPRB, 0.75357935E-10_JPRB, 0.74236929E-10_JPRB, &
  & 0.73049795E-10_JPRB, 0.71800461E-10_JPRB, 0.70470817E-10_JPRB, 0.69065559E-10_JPRB, 0.67596380E-10_JPRB, 0.66091556E-10_JPRB, &
  & 0.64572216E-10_JPRB, 0.63042946E-10_JPRB, 0.61530857E-10_JPRB, 0.60066889E-10_JPRB, 0.58677486E-10_JPRB, 0.57379299E-10_JPRB, &
  & 0.56167297E-10_JPRB, 0.55026823E-10_JPRB, 0.53941036E-10_JPRB, 0.52902755E-10_JPRB, 0.51913699E-10_JPRB, 0.50988162E-10_JPRB, &
  & 0.50142321E-10_JPRB, 0.49367382E-10_JPRB, 0.48589490E-10_JPRB, 0.47443886E-10_JPRB /)

RGHG9(:,35, 5) = (/ &
  & 0.43168937E-10_JPRB, 0.44398547E-10_JPRB, 0.45189217E-10_JPRB, 0.45910210E-10_JPRB, 0.46703981E-10_JPRB, 0.47625584E-10_JPRB, &
  & 0.48704263E-10_JPRB, 0.49957295E-10_JPRB, 0.51381708E-10_JPRB, 0.52986022E-10_JPRB, 0.54783424E-10_JPRB, 0.56767362E-10_JPRB, &
  & 0.58924692E-10_JPRB, 0.61214193E-10_JPRB, 0.63591001E-10_JPRB, 0.65992246E-10_JPRB, 0.68353566E-10_JPRB, 0.70614632E-10_JPRB, &
  & 0.72712961E-10_JPRB, 0.74601311E-10_JPRB, 0.76259034E-10_JPRB, 0.77675269E-10_JPRB, 0.78849031E-10_JPRB, 0.79794518E-10_JPRB, &
  & 0.80528036E-10_JPRB, 0.81073523E-10_JPRB, 0.81465945E-10_JPRB, 0.81733738E-10_JPRB, 0.81913719E-10_JPRB, 0.82024131E-10_JPRB, &
  & 0.82088406E-10_JPRB, 0.82105246E-10_JPRB, 0.82057292E-10_JPRB, 0.81915696E-10_JPRB, 0.81656716E-10_JPRB, 0.81269984E-10_JPRB, &
  & 0.80762355E-10_JPRB, 0.80149568E-10_JPRB, 0.79434771E-10_JPRB, 0.78617793E-10_JPRB, 0.77708694E-10_JPRB, 0.76719964E-10_JPRB, &
  & 0.75659361E-10_JPRB, 0.74513645E-10_JPRB, 0.73289104E-10_JPRB, 0.71970485E-10_JPRB, 0.70578494E-10_JPRB, 0.69136752E-10_JPRB, &
  & 0.67656519E-10_JPRB, 0.66157815E-10_JPRB, 0.64661831E-10_JPRB, 0.63206614E-10_JPRB, 0.61825108E-10_JPRB, 0.60531795E-10_JPRB, &
  & 0.59322845E-10_JPRB, 0.58183576E-10_JPRB, 0.57098604E-10_JPRB, 0.56061357E-10_JPRB, 0.55075330E-10_JPRB, 0.54154257E-10_JPRB, &
  & 0.53309669E-10_JPRB, 0.52530223E-10_JPRB, 0.51742197E-10_JPRB, 0.50567724E-10_JPRB /)

RGHG9(:,36, 5) = (/ &
  & 0.46097615E-10_JPRB, 0.47468949E-10_JPRB, 0.48290198E-10_JPRB, 0.49064176E-10_JPRB, 0.49882654E-10_JPRB, 0.50803133E-10_JPRB, &
  & 0.51858767E-10_JPRB, 0.53054804E-10_JPRB, 0.54397258E-10_JPRB, 0.55899591E-10_JPRB, 0.57576371E-10_JPRB, 0.59433763E-10_JPRB, &
  & 0.61456701E-10_JPRB, 0.63615127E-10_JPRB, 0.65861726E-10_JPRB, 0.68153601E-10_JPRB, 0.70424055E-10_JPRB, 0.72612832E-10_JPRB, &
  & 0.74666218E-10_JPRB, 0.76531240E-10_JPRB, 0.78175591E-10_JPRB, 0.79584145E-10_JPRB, 0.80751676E-10_JPRB, 0.81687559E-10_JPRB, &
  & 0.82410787E-10_JPRB, 0.82945026E-10_JPRB, 0.83323903E-10_JPRB, 0.83573592E-10_JPRB, 0.83725374E-10_JPRB, 0.83795706E-10_JPRB, &
  & 0.83803547E-10_JPRB, 0.83757799E-10_JPRB, 0.83649677E-10_JPRB, 0.83469842E-10_JPRB, 0.83209370E-10_JPRB, 0.82864049E-10_JPRB, &
  & 0.82425324E-10_JPRB, 0.81897315E-10_JPRB, 0.81286561E-10_JPRB, 0.80577676E-10_JPRB, 0.79764285E-10_JPRB, 0.78860286E-10_JPRB, &
  & 0.77871008E-10_JPRB, 0.76804035E-10_JPRB, 0.75649743E-10_JPRB, 0.74410804E-10_JPRB, 0.73091123E-10_JPRB, 0.71708278E-10_JPRB, &
  & 0.70279282E-10_JPRB, 0.68818222E-10_JPRB, 0.67354601E-10_JPRB, 0.65929144E-10_JPRB, 0.64575428E-10_JPRB, 0.63309927E-10_JPRB, &
  & 0.62125742E-10_JPRB, 0.61007990E-10_JPRB, 0.59942336E-10_JPRB, 0.58925614E-10_JPRB, 0.57963578E-10_JPRB, 0.57068350E-10_JPRB, &
  & 0.56248586E-10_JPRB, 0.55488048E-10_JPRB, 0.54712242E-10_JPRB, 0.53543742E-10_JPRB /)

RGHG9(:,37, 5) = (/ &
  & 0.48936938E-10_JPRB, 0.50384374E-10_JPRB, 0.51267116E-10_JPRB, 0.52071621E-10_JPRB, 0.52912945E-10_JPRB, 0.53835738E-10_JPRB, &
  & 0.54859423E-10_JPRB, 0.55992634E-10_JPRB, 0.57244959E-10_JPRB, 0.58636110E-10_JPRB, 0.60186252E-10_JPRB, 0.61903961E-10_JPRB, &
  & 0.63782361E-10_JPRB, 0.65797340E-10_JPRB, 0.67907943E-10_JPRB, 0.70072705E-10_JPRB, 0.72240852E-10_JPRB, 0.74351372E-10_JPRB, &
  & 0.76351196E-10_JPRB, 0.78187047E-10_JPRB, 0.79814780E-10_JPRB, 0.81212245E-10_JPRB, 0.82359217E-10_JPRB, 0.83262938E-10_JPRB, &
  & 0.83944567E-10_JPRB, 0.84437721E-10_JPRB, 0.84778407E-10_JPRB, 0.84998335E-10_JPRB, 0.85121757E-10_JPRB, 0.85169843E-10_JPRB, &
  & 0.85150088E-10_JPRB, 0.85078979E-10_JPRB, 0.84952170E-10_JPRB, 0.84767443E-10_JPRB, 0.84525879E-10_JPRB, 0.84223725E-10_JPRB, &
  & 0.83863395E-10_JPRB, 0.83427182E-10_JPRB, 0.82904433E-10_JPRB, 0.82283048E-10_JPRB, 0.81545624E-10_JPRB, 0.80693827E-10_JPRB, &
  & 0.79750588E-10_JPRB, 0.78727157E-10_JPRB, 0.77630534E-10_JPRB, 0.76451560E-10_JPRB, 0.75197397E-10_JPRB, 0.73875531E-10_JPRB, &
  & 0.72496717E-10_JPRB, 0.71079323E-10_JPRB, 0.69658043E-10_JPRB, 0.68273873E-10_JPRB, 0.66966162E-10_JPRB, 0.65745590E-10_JPRB, &
  & 0.64604141E-10_JPRB, 0.63524991E-10_JPRB, 0.62495356E-10_JPRB, 0.61515383E-10_JPRB, 0.60594571E-10_JPRB, 0.59744459E-10_JPRB, &
  & 0.58968497E-10_JPRB, 0.58246366E-10_JPRB, 0.57504192E-10_JPRB, 0.56370655E-10_JPRB /)

RGHG9(:,38, 5) = (/ &
  & 0.51673520E-10_JPRB, 0.53173532E-10_JPRB, 0.54100478E-10_JPRB, 0.54934404E-10_JPRB, 0.55810953E-10_JPRB, 0.56732195E-10_JPRB, &
  & 0.57724776E-10_JPRB, 0.58791853E-10_JPRB, 0.59947394E-10_JPRB, 0.61220140E-10_JPRB, 0.62637770E-10_JPRB, 0.64211608E-10_JPRB, &
  & 0.65938865E-10_JPRB, 0.67800258E-10_JPRB, 0.69763362E-10_JPRB, 0.71791600E-10_JPRB, 0.73840462E-10_JPRB, 0.75861345E-10_JPRB, &
  & 0.77798913E-10_JPRB, 0.79596850E-10_JPRB, 0.81195994E-10_JPRB, 0.82551695E-10_JPRB, 0.83645792E-10_JPRB, 0.84473123E-10_JPRB, &
  & 0.85071353E-10_JPRB, 0.85487450E-10_JPRB, 0.85766290E-10_JPRB, 0.85942989E-10_JPRB, 0.86038718E-10_JPRB, 0.86072392E-10_JPRB, &
  & 0.86048488E-10_JPRB, 0.85976816E-10_JPRB, 0.85860388E-10_JPRB, 0.85698205E-10_JPRB, 0.85493002E-10_JPRB, 0.85246282E-10_JPRB, &
  & 0.84953267E-10_JPRB, 0.84605663E-10_JPRB, 0.84176111E-10_JPRB, 0.83644272E-10_JPRB, 0.82991107E-10_JPRB, 0.82210974E-10_JPRB, &
  & 0.81319639E-10_JPRB, 0.80339423E-10_JPRB, 0.79288513E-10_JPRB, 0.78166154E-10_JPRB, 0.76971117E-10_JPRB, 0.75705324E-10_JPRB, &
  & 0.74375867E-10_JPRB, 0.73003617E-10_JPRB, 0.71626663E-10_JPRB, 0.70293701E-10_JPRB, 0.69041106E-10_JPRB, 0.67878599E-10_JPRB, &
  & 0.66793793E-10_JPRB, 0.65766483E-10_JPRB, 0.64786169E-10_JPRB, 0.63856066E-10_JPRB, 0.62990405E-10_JPRB, 0.62199322E-10_JPRB, &
  & 0.61482049E-10_JPRB, 0.60813105E-10_JPRB, 0.60119486E-10_JPRB, 0.59047219E-10_JPRB /)

RGHG9(:,39, 5) = (/ &
  & 0.54307801E-10_JPRB, 0.55858276E-10_JPRB, 0.56786013E-10_JPRB, 0.57676437E-10_JPRB, 0.58567928E-10_JPRB, 0.59505824E-10_JPRB, &
  & 0.60466243E-10_JPRB, 0.61462467E-10_JPRB, 0.62518005E-10_JPRB, 0.63669840E-10_JPRB, 0.64948283E-10_JPRB, 0.66374739E-10_JPRB, &
  & 0.67946919E-10_JPRB, 0.69650556E-10_JPRB, 0.71458020E-10_JPRB, 0.73340764E-10_JPRB, 0.75262616E-10_JPRB, 0.77179547E-10_JPRB, &
  & 0.79037367E-10_JPRB, 0.80777995E-10_JPRB, 0.82316945E-10_JPRB, 0.83593035E-10_JPRB, 0.84579885E-10_JPRB, 0.85299524E-10_JPRB, &
  & 0.85794358E-10_JPRB, 0.86127126E-10_JPRB, 0.86345465E-10_JPRB, 0.86482363E-10_JPRB, 0.86557331E-10_JPRB, 0.86581048E-10_JPRB, &
  & 0.86561022E-10_JPRB, 0.86497726E-10_JPRB, 0.86397840E-10_JPRB, 0.86260506E-10_JPRB, 0.86092029E-10_JPRB, 0.85891419E-10_JPRB, &
  & 0.85657224E-10_JPRB, 0.85378565E-10_JPRB, 0.85038018E-10_JPRB, 0.84605017E-10_JPRB, 0.84054930E-10_JPRB, 0.83375390E-10_JPRB, &
  & 0.82571637E-10_JPRB, 0.81665973E-10_JPRB, 0.80673079E-10_JPRB, 0.79609326E-10_JPRB, 0.78471972E-10_JPRB, 0.77261350E-10_JPRB, &
  & 0.75981409E-10_JPRB, 0.74652916E-10_JPRB, 0.73322300E-10_JPRB, 0.72042115E-10_JPRB, 0.70850104E-10_JPRB, 0.69753273E-10_JPRB, &
  & 0.68732631E-10_JPRB, 0.67766910E-10_JPRB, 0.66844634E-10_JPRB, 0.65974580E-10_JPRB, 0.65173034E-10_JPRB, 0.64450958E-10_JPRB, &
  & 0.63800916E-10_JPRB, 0.63194353E-10_JPRB, 0.62558958E-10_JPRB, 0.61566724E-10_JPRB /)

RGHG9(:,40, 5) = (/ &
  & 0.56892310E-10_JPRB, 0.58400312E-10_JPRB, 0.59372132E-10_JPRB, 0.60262219E-10_JPRB, 0.61214249E-10_JPRB, 0.62151645E-10_JPRB, &
  & 0.63084427E-10_JPRB, 0.64008993E-10_JPRB, 0.64962175E-10_JPRB, 0.65986633E-10_JPRB, 0.67127602E-10_JPRB, 0.68403727E-10_JPRB, &
  & 0.69820032E-10_JPRB, 0.71364553E-10_JPRB, 0.73014587E-10_JPRB, 0.74745127E-10_JPRB, 0.76529769E-10_JPRB, 0.78331626E-10_JPRB, &
  & 0.80095583E-10_JPRB, 0.81742751E-10_JPRB, 0.83194403E-10_JPRB, 0.84357146E-10_JPRB, 0.85222128E-10_JPRB, 0.85828150E-10_JPRB, &
  & 0.86234582E-10_JPRB, 0.86501500E-10_JPRB, 0.86675798E-10_JPRB, 0.86785010E-10_JPRB, 0.86846100E-10_JPRB, 0.86865418E-10_JPRB, &
  & 0.86847918E-10_JPRB, 0.86794176E-10_JPRB, 0.86706642E-10_JPRB, 0.86587827E-10_JPRB, 0.86443713E-10_JPRB, 0.86275612E-10_JPRB, &
  & 0.86081073E-10_JPRB, 0.85854164E-10_JPRB, 0.85580466E-10_JPRB, 0.85235985E-10_JPRB, 0.84793089E-10_JPRB, 0.84229665E-10_JPRB, &
  & 0.83541118E-10_JPRB, 0.82734548E-10_JPRB, 0.81830050E-10_JPRB, 0.80835116E-10_JPRB, 0.79761156E-10_JPRB, 0.78605220E-10_JPRB, &
  & 0.77373559E-10_JPRB, 0.76088635E-10_JPRB, 0.74802414E-10_JPRB, 0.73575389E-10_JPRB, 0.72445563E-10_JPRB, 0.71415991E-10_JPRB, &
  & 0.70463080E-10_JPRB, 0.69562106E-10_JPRB, 0.68703737E-10_JPRB, 0.67898118E-10_JPRB, 0.67166876E-10_JPRB, 0.66517562E-10_JPRB, &
  & 0.65938997E-10_JPRB, 0.65397743E-10_JPRB, 0.64826679E-10_JPRB, 0.63922236E-10_JPRB /)

RGHG9(:,41, 5) = (/ &
  & 0.59402330E-10_JPRB, 0.60889273E-10_JPRB, 0.61815039E-10_JPRB, 0.62759409E-10_JPRB, 0.63718898E-10_JPRB, 0.64682697E-10_JPRB, &
  & 0.65578980E-10_JPRB, 0.66430333E-10_JPRB, 0.67277607E-10_JPRB, 0.68177790E-10_JPRB, 0.69175485E-10_JPRB, 0.70303506E-10_JPRB, &
  & 0.71566704E-10_JPRB, 0.72955260E-10_JPRB, 0.74449558E-10_JPRB, 0.76030966E-10_JPRB, 0.77674131E-10_JPRB, 0.79348278E-10_JPRB, &
  & 0.80999846E-10_JPRB, 0.82542410E-10_JPRB, 0.83870612E-10_JPRB, 0.84917809E-10_JPRB, 0.85667196E-10_JPRB, 0.86178308E-10_JPRB, &
  & 0.86515906E-10_JPRB, 0.86735938E-10_JPRB, 0.86879927E-10_JPRB, 0.86971298E-10_JPRB, 0.87023160E-10_JPRB, 0.87040979E-10_JPRB, &
  & 0.87025706E-10_JPRB, 0.86979063E-10_JPRB, 0.86901382E-10_JPRB, 0.86794349E-10_JPRB, 0.86667076E-10_JPRB, 0.86519819E-10_JPRB, &
  & 0.86351953E-10_JPRB, 0.86160509E-10_JPRB, 0.85934537E-10_JPRB, 0.85657009E-10_JPRB, 0.85304902E-10_JPRB, 0.84856205E-10_JPRB, &
  & 0.84293142E-10_JPRB, 0.83606955E-10_JPRB, 0.82804978E-10_JPRB, 0.81897301E-10_JPRB, 0.80890711E-10_JPRB, 0.79793311E-10_JPRB, &
  & 0.78611319E-10_JPRB, 0.77368813E-10_JPRB, 0.76125391E-10_JPRB, 0.74949484E-10_JPRB, 0.73880568E-10_JPRB, 0.72916992E-10_JPRB, &
  & 0.72031534E-10_JPRB, 0.71196410E-10_JPRB, 0.70402004E-10_JPRB, 0.69663379E-10_JPRB, 0.69002658E-10_JPRB, 0.68426161E-10_JPRB, &
  & 0.67917130E-10_JPRB, 0.67440699E-10_JPRB, 0.66932120E-10_JPRB, 0.66118971E-10_JPRB /)

RGHG9(:,42, 5) = (/ &
  & 0.61885219E-10_JPRB, 0.63284607E-10_JPRB, 0.64202851E-10_JPRB, 0.65127036E-10_JPRB, 0.66130545E-10_JPRB, 0.67092394E-10_JPRB, &
  & 0.67953095E-10_JPRB, 0.68728016E-10_JPRB, 0.69472289E-10_JPRB, 0.70246010E-10_JPRB, 0.71104608E-10_JPRB, 0.72084672E-10_JPRB, &
  & 0.73199100E-10_JPRB, 0.74438726E-10_JPRB, 0.75785121E-10_JPRB, 0.77219453E-10_JPRB, 0.78724131E-10_JPRB, 0.80265551E-10_JPRB, &
  & 0.81791483E-10_JPRB, 0.83210404E-10_JPRB, 0.84417064E-10_JPRB, 0.85341338E-10_JPRB, 0.85992775E-10_JPRB, 0.86426963E-10_JPRB, &
  & 0.86711832E-10_JPRB, 0.86898030E-10_JPRB, 0.87020585E-10_JPRB, 0.87099952E-10_JPRB, 0.87145943E-10_JPRB, 0.87162930E-10_JPRB, &
  & 0.87150717E-10_JPRB, 0.87108737E-10_JPRB, 0.87039508E-10_JPRB, 0.86940760E-10_JPRB, 0.86825130E-10_JPRB, 0.86692410E-10_JPRB, &
  & 0.86542995E-10_JPRB, 0.86375664E-10_JPRB, 0.86184268E-10_JPRB, 0.85955319E-10_JPRB, 0.85673593E-10_JPRB, 0.85320646E-10_JPRB, &
  & 0.84877237E-10_JPRB, 0.84323423E-10_JPRB, 0.83642177E-10_JPRB, 0.82837813E-10_JPRB, 0.81913851E-10_JPRB, 0.80879539E-10_JPRB, &
  & 0.79749811E-10_JPRB, 0.78551700E-10_JPRB, 0.77348961E-10_JPRB, 0.76223361E-10_JPRB, 0.75212926E-10_JPRB, 0.74313888E-10_JPRB, &
  & 0.73493218E-10_JPRB, 0.72721780E-10_JPRB, 0.71990247E-10_JPRB, 0.71316127E-10_JPRB, 0.70723115E-10_JPRB, 0.70214598E-10_JPRB, &
  & 0.69769752E-10_JPRB, 0.69352711E-10_JPRB, 0.68903411E-10_JPRB, 0.68175403E-10_JPRB /)

RGHG9(:,43, 5) = (/ &
  & 0.64330985E-10_JPRB, 0.65650485E-10_JPRB, 0.66509277E-10_JPRB, 0.67428764E-10_JPRB, 0.68436048E-10_JPRB, 0.69393991E-10_JPRB, &
  & 0.70212114E-10_JPRB, 0.70908786E-10_JPRB, 0.71552000E-10_JPRB, 0.72206477E-10_JPRB, 0.72930204E-10_JPRB, 0.73766840E-10_JPRB, &
  & 0.74738687E-10_JPRB, 0.75838925E-10_JPRB, 0.77046342E-10_JPRB, 0.78343977E-10_JPRB, 0.79709017E-10_JPRB, 0.81115954E-10_JPRB, &
  & 0.82505600E-10_JPRB, 0.83793861E-10_JPRB, 0.84868577E-10_JPRB, 0.85680858E-10_JPRB, 0.86243263E-10_JPRB, 0.86616020E-10_JPRB, &
  & 0.86859381E-10_JPRB, 0.87020030E-10_JPRB, 0.87127083E-10_JPRB, 0.87197791E-10_JPRB, 0.87240173E-10_JPRB, 0.87256806E-10_JPRB, &
  & 0.87247716E-10_JPRB, 0.87209837E-10_JPRB, 0.87147109E-10_JPRB, 0.87055606E-10_JPRB, 0.86948088E-10_JPRB, 0.86826352E-10_JPRB, &
  & 0.86689503E-10_JPRB, 0.86540095E-10_JPRB, 0.86372832E-10_JPRB, 0.86180771E-10_JPRB, 0.85952689E-10_JPRB, 0.85676861E-10_JPRB, &
  & 0.85337452E-10_JPRB, 0.84909316E-10_JPRB, 0.84367083E-10_JPRB, 0.83686183E-10_JPRB, 0.82863910E-10_JPRB, 0.81908667E-10_JPRB, &
  & 0.80837913E-10_JPRB, 0.79686556E-10_JPRB, 0.78528621E-10_JPRB, 0.77450588E-10_JPRB, 0.76498780E-10_JPRB, 0.75660735E-10_JPRB, &
  & 0.74903000E-10_JPRB, 0.74192388E-10_JPRB, 0.73520523E-10_JPRB, 0.72906903E-10_JPRB, 0.72375592E-10_JPRB, 0.71927519E-10_JPRB, &
  & 0.71538671E-10_JPRB, 0.71174094E-10_JPRB, 0.70776419E-10_JPRB, 0.70125246E-10_JPRB /)

RGHG9(:,44, 5) = (/ &
  & 0.66753235E-10_JPRB, 0.67954309E-10_JPRB, 0.68778282E-10_JPRB, 0.69652527E-10_JPRB, 0.70650992E-10_JPRB, 0.71594689E-10_JPRB, &
  & 0.72358883E-10_JPRB, 0.72980816E-10_JPRB, 0.73529752E-10_JPRB, 0.74074219E-10_JPRB, 0.74671921E-10_JPRB, 0.75375546E-10_JPRB, &
  & 0.76212286E-10_JPRB, 0.77183183E-10_JPRB, 0.78266033E-10_JPRB, 0.79432044E-10_JPRB, 0.80665578E-10_JPRB, 0.81929373E-10_JPRB, &
  & 0.83178152E-10_JPRB, 0.84314666E-10_JPRB, 0.85260486E-10_JPRB, 0.85960516E-10_JPRB, 0.86445642E-10_JPRB, 0.86766233E-10_JPRB, &
  & 0.86976884E-10_JPRB, 0.87117494E-10_JPRB, 0.87213077E-10_JPRB, 0.87277553E-10_JPRB, 0.87317702E-10_JPRB, 0.87334626E-10_JPRB, &
  & 0.87328325E-10_JPRB, 0.87294449E-10_JPRB, 0.87237169E-10_JPRB, 0.87151800E-10_JPRB, 0.87050832E-10_JPRB, 0.86936888E-10_JPRB, &
  & 0.86809643E-10_JPRB, 0.86672398E-10_JPRB, 0.86523719E-10_JPRB, 0.86358573E-10_JPRB, 0.86172534E-10_JPRB, 0.85958254E-10_JPRB, &
  & 0.85704166E-10_JPRB, 0.85390556E-10_JPRB, 0.84983021E-10_JPRB, 0.84446977E-10_JPRB, 0.83755516E-10_JPRB, 0.82902130E-10_JPRB, &
  & 0.81905968E-10_JPRB, 0.80809720E-10_JPRB, 0.79699136E-10_JPRB, 0.78675476E-10_JPRB, 0.77779325E-10_JPRB, 0.77004056E-10_JPRB, &
  & 0.76305642E-10_JPRB, 0.75653497E-10_JPRB, 0.75038122E-10_JPRB, 0.74479693E-10_JPRB, 0.74003324E-10_JPRB, 0.73606295E-10_JPRB, &
  & 0.73266004E-10_JPRB, 0.72944623E-10_JPRB, 0.72592987E-10_JPRB, 0.72007227E-10_JPRB /)

RGHG9(:,45, 5) = (/ &
  & 0.69092967E-10_JPRB, 0.70233687E-10_JPRB, 0.70965130E-10_JPRB, 0.71815380E-10_JPRB, 0.72781461E-10_JPRB, 0.73690928E-10_JPRB, &
  & 0.74403927E-10_JPRB, 0.74952745E-10_JPRB, 0.75418109E-10_JPRB, 0.75866112E-10_JPRB, 0.76356386E-10_JPRB, 0.76935493E-10_JPRB, &
  & 0.77650802E-10_JPRB, 0.78503204E-10_JPRB, 0.79468654E-10_JPRB, 0.80518522E-10_JPRB, 0.81615333E-10_JPRB, 0.82736359E-10_JPRB, &
  & 0.83817855E-10_JPRB, 0.84801222E-10_JPRB, 0.85598535E-10_JPRB, 0.86198576E-10_JPRB, 0.86611690E-10_JPRB, 0.86889253E-10_JPRB, &
  & 0.87073286E-10_JPRB, 0.87198249E-10_JPRB, 0.87285151E-10_JPRB, 0.87345353E-10_JPRB, 0.87384204E-10_JPRB, 0.87402016E-10_JPRB, &
  & 0.87398214E-10_JPRB, 0.87368293E-10_JPRB, 0.87315544E-10_JPRB, 0.87235823E-10_JPRB, 0.87139948E-10_JPRB, 0.87031979E-10_JPRB, &
  & 0.86911152E-10_JPRB, 0.86783268E-10_JPRB, 0.86647495E-10_JPRB, 0.86503735E-10_JPRB, 0.86349483E-10_JPRB, 0.86183088E-10_JPRB, &
  & 0.85998014E-10_JPRB, 0.85776358E-10_JPRB, 0.85491586E-10_JPRB, 0.85100704E-10_JPRB, 0.84561157E-10_JPRB, 0.83845618E-10_JPRB, &
  & 0.82949286E-10_JPRB, 0.81928270E-10_JPRB, 0.80881760E-10_JPRB, 0.79911917E-10_JPRB, 0.79082796E-10_JPRB, 0.78364863E-10_JPRB, &
  & 0.77728907E-10_JPRB, 0.77132814E-10_JPRB, 0.76571006E-10_JPRB, 0.76063822E-10_JPRB, 0.75634422E-10_JPRB, 0.75282627E-10_JPRB, &
  & 0.74980674E-10_JPRB, 0.74698026E-10_JPRB, 0.74383395E-10_JPRB, 0.73857177E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART9',1,ZHOOK_HANDLE)
END SUBROUTINE PART9




SUBROUTINE PART10
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART10',0,ZHOOK_HANDLE)



RGHG9(:,46, 5) = (/ &
  & 0.71394612E-10_JPRB, 0.72389442E-10_JPRB, 0.73117956E-10_JPRB, 0.73882074E-10_JPRB, 0.74825660E-10_JPRB, 0.75697545E-10_JPRB, &
  & 0.76352605E-10_JPRB, 0.76838230E-10_JPRB, 0.77231943E-10_JPRB, 0.77602494E-10_JPRB, 0.77998330E-10_JPRB, 0.78480000E-10_JPRB, &
  & 0.79079715E-10_JPRB, 0.79825521E-10_JPRB, 0.80687582E-10_JPRB, 0.81618171E-10_JPRB, 0.82584939E-10_JPRB, 0.83539682E-10_JPRB, &
  & 0.84446651E-10_JPRB, 0.85241307E-10_JPRB, 0.85902625E-10_JPRB, 0.86397542E-10_JPRB, 0.86751051E-10_JPRB, 0.86990984E-10_JPRB, &
  & 0.87153812E-10_JPRB, 0.87266548E-10_JPRB, 0.87346942E-10_JPRB, 0.87404292E-10_JPRB, 0.87442692E-10_JPRB, 0.87461829E-10_JPRB, &
  & 0.87460421E-10_JPRB, 0.87434358E-10_JPRB, 0.87385585E-10_JPRB, 0.87310728E-10_JPRB, 0.87219246E-10_JPRB, 0.87115322E-10_JPRB, &
  & 0.86999387E-10_JPRB, 0.86877540E-10_JPRB, 0.86752314E-10_JPRB, 0.86624000E-10_JPRB, 0.86495089E-10_JPRB, 0.86365512E-10_JPRB, &
  & 0.86231383E-10_JPRB, 0.86082225E-10_JPRB, 0.85892640E-10_JPRB, 0.85628157E-10_JPRB, 0.85243583E-10_JPRB, 0.84687223E-10_JPRB, &
  & 0.83939730E-10_JPRB, 0.83027862E-10_JPRB, 0.82060074E-10_JPRB, 0.81171014E-10_JPRB, 0.80399278E-10_JPRB, 0.79755182E-10_JPRB, &
  & 0.79174514E-10_JPRB, 0.78636611E-10_JPRB, 0.78126047E-10_JPRB, 0.77665707E-10_JPRB, 0.77279863E-10_JPRB, 0.76964678E-10_JPRB, &
  & 0.76697919E-10_JPRB, 0.76445544E-10_JPRB, 0.76165629E-10_JPRB, 0.75690260E-10_JPRB /)

RGHG9(:,47, 5) = (/ &
  & 0.73546225E-10_JPRB, 0.74519071E-10_JPRB, 0.75136196E-10_JPRB, 0.75903561E-10_JPRB, 0.76779014E-10_JPRB, 0.77615588E-10_JPRB, &
  & 0.78223240E-10_JPRB, 0.78653015E-10_JPRB, 0.78991085E-10_JPRB, 0.79296972E-10_JPRB, 0.79625646E-10_JPRB, 0.80015522E-10_JPRB, &
  & 0.80527779E-10_JPRB, 0.81172263E-10_JPRB, 0.81931871E-10_JPRB, 0.82749196E-10_JPRB, 0.83564461E-10_JPRB, 0.84337058E-10_JPRB, &
  & 0.85034368E-10_JPRB, 0.85649453E-10_JPRB, 0.86160280E-10_JPRB, 0.86568544E-10_JPRB, 0.86866063E-10_JPRB, 0.87076013E-10_JPRB, &
  & 0.87221667E-10_JPRB, 0.87324967E-10_JPRB, 0.87400608E-10_JPRB, 0.87456264E-10_JPRB, 0.87494796E-10_JPRB, 0.87515661E-10_JPRB, &
  & 0.87516626E-10_JPRB, 0.87494192E-10_JPRB, 0.87449020E-10_JPRB, 0.87378417E-10_JPRB, 0.87290605E-10_JPRB, 0.87189631E-10_JPRB, &
  & 0.87076735E-10_JPRB, 0.86959856E-10_JPRB, 0.86841707E-10_JPRB, 0.86726425E-10_JPRB, 0.86616478E-10_JPRB, 0.86514365E-10_JPRB, &
  & 0.86418830E-10_JPRB, 0.86319521E-10_JPRB, 0.86199950E-10_JPRB, 0.86031154E-10_JPRB, 0.85774901E-10_JPRB, 0.85386288E-10_JPRB, &
  & 0.84815530E-10_JPRB, 0.84063714E-10_JPRB, 0.83222769E-10_JPRB, 0.82415574E-10_JPRB, 0.81735570E-10_JPRB, 0.81149969E-10_JPRB, &
  & 0.80638475E-10_JPRB, 0.80152260E-10_JPRB, 0.79692225E-10_JPRB, 0.79276009E-10_JPRB, 0.78928489E-10_JPRB, 0.78647380E-10_JPRB, &
  & 0.78409307E-10_JPRB, 0.78184847E-10_JPRB, 0.77933708E-10_JPRB, 0.77504558E-10_JPRB /)

RGHG9(:,48, 5) = (/ &
  & 0.75625103E-10_JPRB, 0.76491084E-10_JPRB, 0.77124064E-10_JPRB, 0.77808086E-10_JPRB, 0.78680333E-10_JPRB, 0.79473816E-10_JPRB, &
  & 0.80043118E-10_JPRB, 0.80430836E-10_JPRB, 0.80723067E-10_JPRB, 0.80981735E-10_JPRB, 0.81250041E-10_JPRB, 0.81576683E-10_JPRB, &
  & 0.81999588E-10_JPRB, 0.82554213E-10_JPRB, 0.83202431E-10_JPRB, 0.83878682E-10_JPRB, 0.84511440E-10_JPRB, 0.85074163E-10_JPRB, &
  & 0.85562918E-10_JPRB, 0.85996994E-10_JPRB, 0.86383602E-10_JPRB, 0.86707752E-10_JPRB, 0.86961750E-10_JPRB, 0.87146769E-10_JPRB, &
  & 0.87279142E-10_JPRB, 0.87375447E-10_JPRB, 0.87447737E-10_JPRB, 0.87502484E-10_JPRB, 0.87541759E-10_JPRB, 0.87564477E-10_JPRB, &
  & 0.87567877E-10_JPRB, 0.87548982E-10_JPRB, 0.87506877E-10_JPRB, 0.87440125E-10_JPRB, 0.87355415E-10_JPRB, 0.87256306E-10_JPRB, &
  & 0.87146027E-10_JPRB, 0.87032298E-10_JPRB, 0.86920353E-10_JPRB, 0.86814375E-10_JPRB, 0.86719375E-10_JPRB, 0.86638155E-10_JPRB, &
  & 0.86569099E-10_JPRB, 0.86505719E-10_JPRB, 0.86431966E-10_JPRB, 0.86328458E-10_JPRB, 0.86168531E-10_JPRB, 0.85915566E-10_JPRB, &
  & 0.85525836E-10_JPRB, 0.84975409E-10_JPRB, 0.84305098E-10_JPRB, 0.83640872E-10_JPRB, 0.83053016E-10_JPRB, 0.82553228E-10_JPRB, &
  & 0.82098578E-10_JPRB, 0.81669303E-10_JPRB, 0.81253775E-10_JPRB, 0.80878033E-10_JPRB, 0.80565499E-10_JPRB, 0.80314040E-10_JPRB, &
  & 0.80101425E-10_JPRB, 0.79900433E-10_JPRB, 0.79674045E-10_JPRB, 0.79285238E-10_JPRB /)

RGHG9(:,49, 5) = (/ &
  & 0.77568313E-10_JPRB, 0.78410133E-10_JPRB, 0.78996198E-10_JPRB, 0.79686459E-10_JPRB, 0.80521041E-10_JPRB, 0.81296941E-10_JPRB, &
  & 0.81832534E-10_JPRB, 0.82184475E-10_JPRB, 0.82437480E-10_JPRB, 0.82654036E-10_JPRB, 0.82870794E-10_JPRB, 0.83131932E-10_JPRB, &
  & 0.83472680E-10_JPRB, 0.83910247E-10_JPRB, 0.84414184E-10_JPRB, 0.84898727E-10_JPRB, 0.85327460E-10_JPRB, 0.85681913E-10_JPRB, &
  & 0.85995391E-10_JPRB, 0.86282641E-10_JPRB, 0.86563541E-10_JPRB, 0.86822396E-10_JPRB, 0.87038959E-10_JPRB, 0.87205465E-10_JPRB, &
  & 0.87328186E-10_JPRB, 0.87419558E-10_JPRB, 0.87489696E-10_JPRB, 0.87544146E-10_JPRB, 0.87584398E-10_JPRB, 0.87609087E-10_JPRB, &
  & 0.87615026E-10_JPRB, 0.87599317E-10_JPRB, 0.87560119E-10_JPRB, 0.87496808E-10_JPRB, 0.87414610E-10_JPRB, 0.87317063E-10_JPRB, &
  & 0.87208719E-10_JPRB, 0.87097787E-10_JPRB, 0.86990137E-10_JPRB, 0.86891730E-10_JPRB, 0.86807894E-10_JPRB, 0.86741919E-10_JPRB, &
  & 0.86693090E-10_JPRB, 0.86652782E-10_JPRB, 0.86609761E-10_JPRB, 0.86547616E-10_JPRB, 0.86450416E-10_JPRB, 0.86293771E-10_JPRB, &
  & 0.86049640E-10_JPRB, 0.85689476E-10_JPRB, 0.85236485E-10_JPRB, 0.84757493E-10_JPRB, 0.84306118E-10_JPRB, 0.83908186E-10_JPRB, &
  & 0.83528635E-10_JPRB, 0.83155913E-10_JPRB, 0.82787339E-10_JPRB, 0.82449790E-10_JPRB, 0.82169035E-10_JPRB, 0.81944576E-10_JPRB, &
  & 0.81754027E-10_JPRB, 0.81573796E-10_JPRB, 0.81367454E-10_JPRB, 0.81011468E-10_JPRB /)

RGHG9(:,50, 5) = (/ &
  & 0.79381647E-10_JPRB, 0.80237941E-10_JPRB, 0.80796848E-10_JPRB, 0.81486720E-10_JPRB, 0.82291361E-10_JPRB, 0.83023463E-10_JPRB, &
  & 0.83506334E-10_JPRB, 0.83804561E-10_JPRB, 0.84012415E-10_JPRB, 0.84174417E-10_JPRB, 0.84340285E-10_JPRB, 0.84521917E-10_JPRB, &
  & 0.84762065E-10_JPRB, 0.85058675E-10_JPRB, 0.85377150E-10_JPRB, 0.85676868E-10_JPRB, 0.85922817E-10_JPRB, 0.86133489E-10_JPRB, &
  & 0.86317370E-10_JPRB, 0.86509085E-10_JPRB, 0.86706989E-10_JPRB, 0.86913088E-10_JPRB, 0.87101285E-10_JPRB, 0.87254051E-10_JPRB, &
  & 0.87370451E-10_JPRB, 0.87458762E-10_JPRB, 0.87527735E-10_JPRB, 0.87582205E-10_JPRB, 0.87623589E-10_JPRB, 0.87650172E-10_JPRB, &
  & 0.87658700E-10_JPRB, 0.87645849E-10_JPRB, 0.87609406E-10_JPRB, 0.87549225E-10_JPRB, 0.87469039E-10_JPRB, 0.87373025E-10_JPRB, &
  & 0.87266430E-10_JPRB, 0.87157635E-10_JPRB, 0.87053434E-10_JPRB, 0.86960474E-10_JPRB, 0.86885173E-10_JPRB, 0.86831445E-10_JPRB, &
  & 0.86796695E-10_JPRB, 0.86773359E-10_JPRB, 0.86748893E-10_JPRB, 0.86713046E-10_JPRB, 0.86653434E-10_JPRB, 0.86558587E-10_JPRB, &
  & 0.86409102E-10_JPRB, 0.86196571E-10_JPRB, 0.85928487E-10_JPRB, 0.85633473E-10_JPRB, 0.85360885E-10_JPRB, 0.85082802E-10_JPRB, &
  & 0.84815058E-10_JPRB, 0.84525463E-10_JPRB, 0.84225904E-10_JPRB, 0.83938453E-10_JPRB, 0.83698715E-10_JPRB, 0.83502233E-10_JPRB, &
  & 0.83337129E-10_JPRB, 0.83174009E-10_JPRB, 0.82989227E-10_JPRB, 0.82653613E-10_JPRB /)

RGHG9(:,51, 5) = (/ &
  & 0.81111319E-10_JPRB, 0.81875916E-10_JPRB, 0.82495275E-10_JPRB, 0.83097099E-10_JPRB, 0.83858830E-10_JPRB, 0.84468162E-10_JPRB, &
  & 0.84843153E-10_JPRB, 0.85062485E-10_JPRB, 0.85200125E-10_JPRB, 0.85313291E-10_JPRB, 0.85409783E-10_JPRB, 0.85528022E-10_JPRB, &
  & 0.85663990E-10_JPRB, 0.85834589E-10_JPRB, 0.86016999E-10_JPRB, 0.86180597E-10_JPRB, 0.86322081E-10_JPRB, 0.86440251E-10_JPRB, &
  & 0.86558150E-10_JPRB, 0.86678387E-10_JPRB, 0.86824409E-10_JPRB, 0.86986515E-10_JPRB, 0.87151029E-10_JPRB, 0.87294727E-10_JPRB, &
  & 0.87407526E-10_JPRB, 0.87494428E-10_JPRB, 0.87562915E-10_JPRB, 0.87617663E-10_JPRB, 0.87660060E-10_JPRB, 0.87688384E-10_JPRB, &
  & 0.87699278E-10_JPRB, 0.87689106E-10_JPRB, 0.87655425E-10_JPRB, 0.87597832E-10_JPRB, 0.87519665E-10_JPRB, 0.87425005E-10_JPRB, &
  & 0.87320130E-10_JPRB, 0.87213167E-10_JPRB, 0.87111450E-10_JPRB, 0.87022667E-10_JPRB, 0.86954277E-10_JPRB, 0.86909910E-10_JPRB, &
  & 0.86886817E-10_JPRB, 0.86874556E-10_JPRB, 0.86862857E-10_JPRB, 0.86842061E-10_JPRB, 0.86806340E-10_JPRB, 0.86746305E-10_JPRB, &
  & 0.86657161E-10_JPRB, 0.86532920E-10_JPRB, 0.86384261E-10_JPRB, 0.86236247E-10_JPRB, 0.86082821E-10_JPRB, 0.85943613E-10_JPRB, &
  & 0.85787100E-10_JPRB, 0.85616091E-10_JPRB, 0.85418325E-10_JPRB, 0.85219484E-10_JPRB, 0.85038601E-10_JPRB, 0.84891781E-10_JPRB, &
  & 0.84756271E-10_JPRB, 0.84626396E-10_JPRB, 0.84458225E-10_JPRB, 0.84164863E-10_JPRB /)

RGHG9(:,52, 5) = (/ &
  & 0.82559688E-10_JPRB, 0.83403576E-10_JPRB, 0.83859641E-10_JPRB, 0.84462298E-10_JPRB, 0.85029130E-10_JPRB, 0.85483697E-10_JPRB, &
  & 0.85730298E-10_JPRB, 0.85863816E-10_JPRB, 0.85950538E-10_JPRB, 0.86010685E-10_JPRB, 0.86072580E-10_JPRB, 0.86131588E-10_JPRB, &
  & 0.86211316E-10_JPRB, 0.86304172E-10_JPRB, 0.86405008E-10_JPRB, 0.86500036E-10_JPRB, 0.86580965E-10_JPRB, 0.86656612E-10_JPRB, &
  & 0.86728506E-10_JPRB, 0.86815513E-10_JPRB, 0.86917987E-10_JPRB, 0.87048209E-10_JPRB, 0.87193683E-10_JPRB, 0.87329435E-10_JPRB, &
  & 0.87440895E-10_JPRB, 0.87527499E-10_JPRB, 0.87596028E-10_JPRB, 0.87651116E-10_JPRB, 0.87694366E-10_JPRB, 0.87724154E-10_JPRB, &
  & 0.87737206E-10_JPRB, 0.87729532E-10_JPRB, 0.87698383E-10_JPRB, 0.87643268E-10_JPRB, 0.87566884E-10_JPRB, 0.87473834E-10_JPRB, &
  & 0.87370458E-10_JPRB, 0.87264987E-10_JPRB, 0.87165268E-10_JPRB, 0.87079954E-10_JPRB, 0.87017157E-10_JPRB, 0.86981103E-10_JPRB, &
  & 0.86966517E-10_JPRB, 0.86962750E-10_JPRB, 0.86958968E-10_JPRB, 0.86948407E-10_JPRB, 0.86925703E-10_JPRB, 0.86888254E-10_JPRB, &
  & 0.86831396E-10_JPRB, 0.86759225E-10_JPRB, 0.86680788E-10_JPRB, 0.86601497E-10_JPRB, 0.86535362E-10_JPRB, 0.86465987E-10_JPRB, &
  & 0.86398076E-10_JPRB, 0.86315850E-10_JPRB, 0.86218567E-10_JPRB, 0.86108884E-10_JPRB, 0.86009450E-10_JPRB, 0.85916871E-10_JPRB, &
  & 0.85835811E-10_JPRB, 0.85742233E-10_JPRB, 0.85629857E-10_JPRB, 0.85381036E-10_JPRB /)

RGHG9(:,53, 5) = (/ &
  & 0.83869363E-10_JPRB, 0.84493905E-10_JPRB, 0.84989966E-10_JPRB, 0.85380758E-10_JPRB, 0.85827567E-10_JPRB, 0.86113359E-10_JPRB, &
  & 0.86265106E-10_JPRB, 0.86344258E-10_JPRB, 0.86391255E-10_JPRB, 0.86429378E-10_JPRB, 0.86459770E-10_JPRB, 0.86497524E-10_JPRB, &
  & 0.86538721E-10_JPRB, 0.86593108E-10_JPRB, 0.86652518E-10_JPRB, 0.86708959E-10_JPRB, 0.86761182E-10_JPRB, 0.86808657E-10_JPRB, &
  & 0.86861254E-10_JPRB, 0.86919853E-10_JPRB, 0.86999789E-10_JPRB, 0.87104206E-10_JPRB, 0.87230660E-10_JPRB, 0.87361542E-10_JPRB, &
  & 0.87471648E-10_JPRB, 0.87558572E-10_JPRB, 0.87627419E-10_JPRB, 0.87682868E-10_JPRB, 0.87726847E-10_JPRB, 0.87757857E-10_JPRB, &
  & 0.87772768E-10_JPRB, 0.87767293E-10_JPRB, 0.87738511E-10_JPRB, 0.87685685E-10_JPRB, 0.87611314E-10_JPRB, 0.87519769E-10_JPRB, &
  & 0.87417830E-10_JPRB, 0.87313629E-10_JPRB, 0.87215769E-10_JPRB, 0.87133613E-10_JPRB, 0.87076096E-10_JPRB, 0.87046564E-10_JPRB, &
  & 0.87039043E-10_JPRB, 0.87041374E-10_JPRB, 0.87043373E-10_JPRB, 0.87038987E-10_JPRB, 0.87025373E-10_JPRB, 0.86999574E-10_JPRB, &
  & 0.86963263E-10_JPRB, 0.86918903E-10_JPRB, 0.86873661E-10_JPRB, 0.86836260E-10_JPRB, 0.86801635E-10_JPRB, 0.86773158E-10_JPRB, &
  & 0.86742599E-10_JPRB, 0.86707468E-10_JPRB, 0.86663447E-10_JPRB, 0.86614049E-10_JPRB, 0.86563597E-10_JPRB, 0.86521207E-10_JPRB, &
  & 0.86477228E-10_JPRB, 0.86433305E-10_JPRB, 0.86365567E-10_JPRB, 0.86225173E-10_JPRB /)

RGHG9(:,54, 5) = (/ &
  & 0.84839642E-10_JPRB, 0.85421469E-10_JPRB, 0.85701696E-10_JPRB, 0.86038350E-10_JPRB, 0.86315607E-10_JPRB, 0.86504033E-10_JPRB, &
  & 0.86593080E-10_JPRB, 0.86639224E-10_JPRB, 0.86668020E-10_JPRB, 0.86688032E-10_JPRB, 0.86708342E-10_JPRB, 0.86727500E-10_JPRB, &
  & 0.86753861E-10_JPRB, 0.86785384E-10_JPRB, 0.86821925E-10_JPRB, 0.86858354E-10_JPRB, 0.86892042E-10_JPRB, 0.86926383E-10_JPRB, &
  & 0.86962236E-10_JPRB, 0.87008872E-10_JPRB, 0.87069629E-10_JPRB, 0.87155373E-10_JPRB, 0.87269761E-10_JPRB, 0.87391629E-10_JPRB, &
  & 0.87501138E-10_JPRB, 0.87588013E-10_JPRB, 0.87657152E-10_JPRB, 0.87713142E-10_JPRB, 0.87757697E-10_JPRB, 0.87789810E-10_JPRB, &
  & 0.87806179E-10_JPRB, 0.87802557E-10_JPRB, 0.87775912E-10_JPRB, 0.87725362E-10_JPRB, 0.87653051E-10_JPRB, 0.87563290E-10_JPRB, &
  & 0.87462565E-10_JPRB, 0.87359703E-10_JPRB, 0.87263675E-10_JPRB, 0.87184912E-10_JPRB, 0.87132149E-10_JPRB, 0.87108293E-10_JPRB, &
  & 0.87105975E-10_JPRB, 0.87112928E-10_JPRB, 0.87119353E-10_JPRB, 0.87119569E-10_JPRB, 0.87111006E-10_JPRB, 0.87093402E-10_JPRB, &
  & 0.87067395E-10_JPRB, 0.87038439E-10_JPRB, 0.87012307E-10_JPRB, 0.86990158E-10_JPRB, 0.86974317E-10_JPRB, 0.86960064E-10_JPRB, &
  & 0.86946512E-10_JPRB, 0.86930699E-10_JPRB, 0.86910534E-10_JPRB, 0.86886505E-10_JPRB, 0.86864474E-10_JPRB, 0.86843574E-10_JPRB, &
  & 0.86826282E-10_JPRB, 0.86807353E-10_JPRB, 0.86789007E-10_JPRB, 0.86762889E-10_JPRB /)

RGHG9(:,55, 5) = (/ &
  & 0.85553994E-10_JPRB, 0.85973902E-10_JPRB, 0.86241049E-10_JPRB, 0.86443207E-10_JPRB, 0.86638377E-10_JPRB, 0.86752924E-10_JPRB, &
  & 0.86808873E-10_JPRB, 0.86836684E-10_JPRB, 0.86853386E-10_JPRB, 0.86866597E-10_JPRB, 0.86877512E-10_JPRB, 0.86890689E-10_JPRB, &
  & 0.86905483E-10_JPRB, 0.86925619E-10_JPRB, 0.86948851E-10_JPRB, 0.86972443E-10_JPRB, 0.86995820E-10_JPRB, 0.87019364E-10_JPRB, &
  & 0.87047501E-10_JPRB, 0.87082438E-10_JPRB, 0.87132961E-10_JPRB, 0.87207415E-10_JPRB, 0.87306967E-10_JPRB, 0.87424193E-10_JPRB, &
  & 0.87529775E-10_JPRB, 0.87616241E-10_JPRB, 0.87685560E-10_JPRB, 0.87742036E-10_JPRB, 0.87787298E-10_JPRB, 0.87820244E-10_JPRB, &
  & 0.87837682E-10_JPRB, 0.87835510E-10_JPRB, 0.87810759E-10_JPRB, 0.87762506E-10_JPRB, 0.87692478E-10_JPRB, 0.87604493E-10_JPRB, &
  & 0.87505343E-10_JPRB, 0.87403758E-10_JPRB, 0.87309923E-10_JPRB, 0.87234636E-10_JPRB, 0.87186439E-10_JPRB, 0.87167051E-10_JPRB, &
  & 0.87168731E-10_JPRB, 0.87179389E-10_JPRB, 0.87189145E-10_JPRB, 0.87192795E-10_JPRB, 0.87188069E-10_JPRB, 0.87174559E-10_JPRB, &
  & 0.87155290E-10_JPRB, 0.87134543E-10_JPRB, 0.87116564E-10_JPRB, 0.87104088E-10_JPRB, 0.87094429E-10_JPRB, 0.87087206E-10_JPRB, &
  & 0.87080149E-10_JPRB, 0.87071891E-10_JPRB, 0.87061386E-10_JPRB, 0.87049395E-10_JPRB, 0.87036982E-10_JPRB, 0.87026913E-10_JPRB, &
  & 0.87016762E-10_JPRB, 0.87006978E-10_JPRB, 0.86992934E-10_JPRB, 0.86967419E-10_JPRB /)

RGHG9(:,56, 5) = (/ &
  & 0.86173353E-10_JPRB, 0.86444255E-10_JPRB, 0.86586301E-10_JPRB, 0.86729811E-10_JPRB, 0.86853677E-10_JPRB, 0.86927604E-10_JPRB, &
  & 0.86962035E-10_JPRB, 0.86979632E-10_JPRB, 0.86990470E-10_JPRB, 0.86998297E-10_JPRB, 0.87005958E-10_JPRB, 0.87013535E-10_JPRB, &
  & 0.87023576E-10_JPRB, 0.87036045E-10_JPRB, 0.87051033E-10_JPRB, 0.87066694E-10_JPRB, 0.87082230E-10_JPRB, 0.87099349E-10_JPRB, &
  & 0.87119797E-10_JPRB, 0.87148747E-10_JPRB, 0.87191504E-10_JPRB, 0.87255682E-10_JPRB, 0.87349530E-10_JPRB, 0.87456729E-10_JPRB, &
  & 0.87558898E-10_JPRB, 0.87643712E-10_JPRB, 0.87713108E-10_JPRB, 0.87770104E-10_JPRB, 0.87815998E-10_JPRB, 0.87849547E-10_JPRB, &
  & 0.87867616E-10_JPRB, 0.87866499E-10_JPRB, 0.87843420E-10_JPRB, 0.87797332E-10_JPRB, 0.87729685E-10_JPRB, 0.87643795E-10_JPRB, &
  & 0.87546220E-10_JPRB, 0.87446460E-10_JPRB, 0.87355082E-10_JPRB, 0.87283493E-10_JPRB, 0.87239556E-10_JPRB, 0.87223860E-10_JPRB, &
  & 0.87228502E-10_JPRB, 0.87241811E-10_JPRB, 0.87254426E-10_JPRB, 0.87260733E-10_JPRB, 0.87258610E-10_JPRB, 0.87248223E-10_JPRB, &
  & 0.87232277E-10_JPRB, 0.87215721E-10_JPRB, 0.87202759E-10_JPRB, 0.87193322E-10_JPRB, 0.87187244E-10_JPRB, 0.87182379E-10_JPRB, &
  & 0.87177876E-10_JPRB, 0.87172825E-10_JPRB, 0.87166406E-10_JPRB, 0.87158759E-10_JPRB, 0.87151744E-10_JPRB, 0.87145346E-10_JPRB, &
  & 0.87139886E-10_JPRB, 0.87133967E-10_JPRB, 0.87127763E-10_JPRB, 0.87117008E-10_JPRB /)

RGHG9(:,57, 5) = (/ &
  & 0.86543862E-10_JPRB, 0.86732517E-10_JPRB, 0.86836968E-10_JPRB, 0.86930754E-10_JPRB, 0.87007790E-10_JPRB, 0.87056730E-10_JPRB, &
  & 0.87079691E-10_JPRB, 0.87091334E-10_JPRB, 0.87098384E-10_JPRB, 0.87103942E-10_JPRB, 0.87108772E-10_JPRB, 0.87114274E-10_JPRB, &
  & 0.87120658E-10_JPRB, 0.87128964E-10_JPRB, 0.87138755E-10_JPRB, 0.87148858E-10_JPRB, 0.87159044E-10_JPRB, 0.87170340E-10_JPRB, &
  & 0.87185745E-10_JPRB, 0.87208837E-10_JPRB, 0.87245933E-10_JPRB, 0.87306051E-10_JPRB, 0.87390484E-10_JPRB, 0.87492125E-10_JPRB, &
  & 0.87588582E-10_JPRB, 0.87671467E-10_JPRB, 0.87740447E-10_JPRB, 0.87797929E-10_JPRB, 0.87844204E-10_JPRB, 0.87878080E-10_JPRB, &
  & 0.87896503E-10_JPRB, 0.87896017E-10_JPRB, 0.87874250E-10_JPRB, 0.87830215E-10_JPRB, 0.87764893E-10_JPRB, 0.87681355E-10_JPRB, &
  & 0.87585897E-10_JPRB, 0.87488211E-10_JPRB, 0.87399900E-10_JPRB, 0.87332100E-10_JPRB, 0.87291917E-10_JPRB, 0.87279295E-10_JPRB, &
  & 0.87286137E-10_JPRB, 0.87301395E-10_JPRB, 0.87316050E-10_JPRB, 0.87324516E-10_JPRB, 0.87324578E-10_JPRB, 0.87316251E-10_JPRB, &
  & 0.87302561E-10_JPRB, 0.87288225E-10_JPRB, 0.87276700E-10_JPRB, 0.87269289E-10_JPRB, 0.87263988E-10_JPRB, 0.87260060E-10_JPRB, &
  & 0.87256397E-10_JPRB, 0.87252226E-10_JPRB, 0.87247085E-10_JPRB, 0.87241395E-10_JPRB, 0.87235774E-10_JPRB, 0.87231153E-10_JPRB, &
  & 0.87226629E-10_JPRB, 0.87222118E-10_JPRB, 0.87215735E-10_JPRB, 0.87204313E-10_JPRB /)

RGHG9(:,58, 5) = (/ &
  & 0.86847883E-10_JPRB, 0.86956178E-10_JPRB, 0.87019128E-10_JPRB, 0.87074903E-10_JPRB, 0.87128624E-10_JPRB, 0.87159766E-10_JPRB, &
  & 0.87175690E-10_JPRB, 0.87183753E-10_JPRB, 0.87188930E-10_JPRB, 0.87192788E-10_JPRB, 0.87196528E-10_JPRB, 0.87200386E-10_JPRB, &
  & 0.87205125E-10_JPRB, 0.87210954E-10_JPRB, 0.87217567E-10_JPRB, 0.87224075E-10_JPRB, 0.87230029E-10_JPRB, 0.87236773E-10_JPRB, &
  & 0.87247098E-10_JPRB, 0.87265764E-10_JPRB, 0.87298974E-10_JPRB, 0.87353604E-10_JPRB, 0.87433893E-10_JPRB, 0.87527846E-10_JPRB, &
  & 0.87619557E-10_JPRB, 0.87700028E-10_JPRB, 0.87768522E-10_JPRB, 0.87825948E-10_JPRB, 0.87872418E-10_JPRB, 0.87906259E-10_JPRB, &
  & 0.87924695E-10_JPRB, 0.87924570E-10_JPRB, 0.87903802E-10_JPRB, 0.87861468E-10_JPRB, 0.87798498E-10_JPRB, 0.87717521E-10_JPRB, &
  & 0.87624658E-10_JPRB, 0.87529865E-10_JPRB, 0.87444822E-10_JPRB, 0.87380714E-10_JPRB, 0.87343931E-10_JPRB, 0.87333751E-10_JPRB, &
  & 0.87342231E-10_JPRB, 0.87358849E-10_JPRB, 0.87374899E-10_JPRB, 0.87385016E-10_JPRB, 0.87386889E-10_JPRB, 0.87380575E-10_JPRB, &
  & 0.87368432E-10_JPRB, 0.87354984E-10_JPRB, 0.87344243E-10_JPRB, 0.87336589E-10_JPRB, 0.87331475E-10_JPRB, 0.87327402E-10_JPRB, &
  & 0.87323551E-10_JPRB, 0.87319346E-10_JPRB, 0.87314336E-10_JPRB, 0.87308737E-10_JPRB, 0.87303664E-10_JPRB, 0.87299196E-10_JPRB, &
  & 0.87295157E-10_JPRB, 0.87290689E-10_JPRB, 0.87285297E-10_JPRB, 0.87274271E-10_JPRB /)

RGHG9(:,59, 5) = (/ &
  & 0.87037259E-10_JPRB, 0.87111110E-10_JPRB, 0.87151932E-10_JPRB, 0.87191046E-10_JPRB, 0.87223236E-10_JPRB, 0.87246363E-10_JPRB, &
  & 0.87257618E-10_JPRB, 0.87263877E-10_JPRB, 0.87267762E-10_JPRB, 0.87270975E-10_JPRB, 0.87273924E-10_JPRB, 0.87277241E-10_JPRB, &
  & 0.87281134E-10_JPRB, 0.87285748E-10_JPRB, 0.87290772E-10_JPRB, 0.87294949E-10_JPRB, 0.87297787E-10_JPRB, 0.87300424E-10_JPRB, &
  & 0.87306350E-10_JPRB, 0.87320720E-10_JPRB, 0.87350197E-10_JPRB, 0.87401739E-10_JPRB, 0.87476304E-10_JPRB, 0.87564601E-10_JPRB, &
  & 0.87651719E-10_JPRB, 0.87729941E-10_JPRB, 0.87797471E-10_JPRB, 0.87854633E-10_JPRB, 0.87900763E-10_JPRB, 0.87934278E-10_JPRB, &
  & 0.87952486E-10_JPRB, 0.87952430E-10_JPRB, 0.87932356E-10_JPRB, 0.87891520E-10_JPRB, 0.87830701E-10_JPRB, 0.87752611E-10_JPRB, &
  & 0.87662953E-10_JPRB, 0.87571464E-10_JPRB, 0.87490321E-10_JPRB, 0.87429661E-10_JPRB, 0.87395757E-10_JPRB, 0.87387542E-10_JPRB, &
  & 0.87397187E-10_JPRB, 0.87414666E-10_JPRB, 0.87431680E-10_JPRB, 0.87442976E-10_JPRB, 0.87446383E-10_JPRB, 0.87441873E-10_JPRB, &
  & 0.87431409E-10_JPRB, 0.87418572E-10_JPRB, 0.87407345E-10_JPRB, 0.87399289E-10_JPRB, 0.87393370E-10_JPRB, 0.87388582E-10_JPRB, &
  & 0.87384142E-10_JPRB, 0.87379173E-10_JPRB, 0.87373477E-10_JPRB, 0.87367433E-10_JPRB, 0.87361812E-10_JPRB, 0.87357101E-10_JPRB, &
  & 0.87352681E-10_JPRB, 0.87348136E-10_JPRB, 0.87341870E-10_JPRB, 0.87330532E-10_JPRB /)

RGHG9(:,60, 5) = (/ &
  & 0.87186210E-10_JPRB, 0.87231278E-10_JPRB, 0.87257819E-10_JPRB, 0.87281737E-10_JPRB, 0.87305635E-10_JPRB, 0.87321372E-10_JPRB, &
  & 0.87330504E-10_JPRB, 0.87335431E-10_JPRB, 0.87338935E-10_JPRB, 0.87341717E-10_JPRB, 0.87344555E-10_JPRB, 0.87347657E-10_JPRB, &
  & 0.87351383E-10_JPRB, 0.87355803E-10_JPRB, 0.87360154E-10_JPRB, 0.87363138E-10_JPRB, 0.87363575E-10_JPRB, 0.87362589E-10_JPRB, &
  & 0.87364345E-10_JPRB, 0.87374934E-10_JPRB, 0.87401059E-10_JPRB, 0.87448881E-10_JPRB, 0.87518832E-10_JPRB, 0.87601836E-10_JPRB, &
  & 0.87685040E-10_JPRB, 0.87760979E-10_JPRB, 0.87827468E-10_JPRB, 0.87883853E-10_JPRB, 0.87929303E-10_JPRB, 0.87962124E-10_JPRB, &
  & 0.87979846E-10_JPRB, 0.87979679E-10_JPRB, 0.87960146E-10_JPRB, 0.87920629E-10_JPRB, 0.87861933E-10_JPRB, 0.87786951E-10_JPRB, &
  & 0.87700777E-10_JPRB, 0.87613597E-10_JPRB, 0.87536173E-10_JPRB, 0.87479086E-10_JPRB, 0.87447695E-10_JPRB, 0.87440943E-10_JPRB, &
  & 0.87451289E-10_JPRB, 0.87469275E-10_JPRB, 0.87486886E-10_JPRB, 0.87499077E-10_JPRB, 0.87503733E-10_JPRB, 0.87500902E-10_JPRB, &
  & 0.87492014E-10_JPRB, 0.87480120E-10_JPRB, 0.87468435E-10_JPRB, 0.87459193E-10_JPRB, 0.87452066E-10_JPRB, 0.87446231E-10_JPRB, &
  & 0.87440485E-10_JPRB, 0.87434435E-10_JPRB, 0.87427510E-10_JPRB, 0.87420307E-10_JPRB, 0.87413903E-10_JPRB, 0.87408449E-10_JPRB, &
  & 0.87403446E-10_JPRB, 0.87398061E-10_JPRB, 0.87391511E-10_JPRB, 0.87378396E-10_JPRB /)

RGHG9(:,61, 5) = (/ &
  & 0.87289578E-10_JPRB, 0.87322982E-10_JPRB, 0.87342009E-10_JPRB, 0.87359828E-10_JPRB, 0.87376231E-10_JPRB, 0.87389235E-10_JPRB, &
  & 0.87396597E-10_JPRB, 0.87401232E-10_JPRB, 0.87404431E-10_JPRB, 0.87407331E-10_JPRB, 0.87410218E-10_JPRB, 0.87413618E-10_JPRB, &
  & 0.87417761E-10_JPRB, 0.87422541E-10_JPRB, 0.87427135E-10_JPRB, 0.87429522E-10_JPRB, 0.87428051E-10_JPRB, 0.87423846E-10_JPRB, &
  & 0.87421848E-10_JPRB, 0.87428863E-10_JPRB, 0.87451726E-10_JPRB, 0.87495913E-10_JPRB, 0.87561347E-10_JPRB, 0.87639715E-10_JPRB, &
  & 0.87719401E-10_JPRB, 0.87793127E-10_JPRB, 0.87858235E-10_JPRB, 0.87913558E-10_JPRB, 0.87957974E-10_JPRB, 0.87989824E-10_JPRB, &
  & 0.88006775E-10_JPRB, 0.88006366E-10_JPRB, 0.87987291E-10_JPRB, 0.87949134E-10_JPRB, 0.87892638E-10_JPRB, 0.87820973E-10_JPRB, &
  & 0.87738899E-10_JPRB, 0.87655994E-10_JPRB, 0.87582809E-10_JPRB, 0.87529053E-10_JPRB, 0.87499952E-10_JPRB, 0.87494262E-10_JPRB, &
  & 0.87504955E-10_JPRB, 0.87523024E-10_JPRB, 0.87540947E-10_JPRB, 0.87553791E-10_JPRB, 0.87559501E-10_JPRB, 0.87558107E-10_JPRB, &
  & 0.87550939E-10_JPRB, 0.87540100E-10_JPRB, 0.87528450E-10_JPRB, 0.87517937E-10_JPRB, 0.87509403E-10_JPRB, 0.87501825E-10_JPRB, &
  & 0.87494699E-10_JPRB, 0.87486920E-10_JPRB, 0.87478386E-10_JPRB, 0.87469816E-10_JPRB, 0.87462197E-10_JPRB, 0.87455682E-10_JPRB, &
  & 0.87449673E-10_JPRB, 0.87443414E-10_JPRB, 0.87434976E-10_JPRB, 0.87419849E-10_JPRB /)

RGHG9(:,62, 5) = (/ &
  & 0.87374920E-10_JPRB, 0.87400094E-10_JPRB, 0.87414284E-10_JPRB, 0.87427385E-10_JPRB, 0.87440707E-10_JPRB, 0.87451213E-10_JPRB, &
  & 0.87458207E-10_JPRB, 0.87462593E-10_JPRB, 0.87466069E-10_JPRB, 0.87469150E-10_JPRB, 0.87472571E-10_JPRB, 0.87476595E-10_JPRB, &
  & 0.87481612E-10_JPRB, 0.87487448E-10_JPRB, 0.87492687E-10_JPRB, 0.87494761E-10_JPRB, 0.87491528E-10_JPRB, 0.87484450E-10_JPRB, &
  & 0.87479197E-10_JPRB, 0.87482979E-10_JPRB, 0.87502582E-10_JPRB, 0.87543195E-10_JPRB, 0.87604306E-10_JPRB, 0.87678434E-10_JPRB, &
  & 0.87754692E-10_JPRB, 0.87826239E-10_JPRB, 0.87889696E-10_JPRB, 0.87943632E-10_JPRB, 0.87986757E-10_JPRB, 0.88017406E-10_JPRB, &
  & 0.88033421E-10_JPRB, 0.88032664E-10_JPRB, 0.88014054E-10_JPRB, 0.87977334E-10_JPRB, 0.87923321E-10_JPRB, 0.87855084E-10_JPRB, &
  & 0.87777383E-10_JPRB, 0.87699153E-10_JPRB, 0.87630084E-10_JPRB, 0.87579763E-10_JPRB, 0.87552743E-10_JPRB, 0.87547809E-10_JPRB, &
  & 0.87558440E-10_JPRB, 0.87576314E-10_JPRB, 0.87594244E-10_JPRB, 0.87607525E-10_JPRB, 0.87614097E-10_JPRB, 0.87613937E-10_JPRB, &
  & 0.87608164E-10_JPRB, 0.87598775E-10_JPRB, 0.87587444E-10_JPRB, 0.87576259E-10_JPRB, 0.87566066E-10_JPRB, 0.87556788E-10_JPRB, &
  & 0.87547684E-10_JPRB, 0.87537921E-10_JPRB, 0.87527652E-10_JPRB, 0.87517327E-10_JPRB, 0.87508334E-10_JPRB, 0.87500632E-10_JPRB, &
  & 0.87493374E-10_JPRB, 0.87485422E-10_JPRB, 0.87475520E-10_JPRB, 0.87455529E-10_JPRB /)

RGHG9(:,63, 5) = (/ &
  & 0.87446536E-10_JPRB, 0.87466409E-10_JPRB, 0.87477886E-10_JPRB, 0.87488641E-10_JPRB, 0.87499591E-10_JPRB, 0.87509278E-10_JPRB, &
  & 0.87515883E-10_JPRB, 0.87520699E-10_JPRB, 0.87524446E-10_JPRB, 0.87528242E-10_JPRB, 0.87532356E-10_JPRB, 0.87537547E-10_JPRB, &
  & 0.87544028E-10_JPRB, 0.87551362E-10_JPRB, 0.87557517E-10_JPRB, 0.87559140E-10_JPRB, 0.87554165E-10_JPRB, 0.87544624E-10_JPRB, &
  & 0.87536610E-10_JPRB, 0.87537450E-10_JPRB, 0.87553943E-10_JPRB, 0.87590990E-10_JPRB, 0.87648153E-10_JPRB, 0.87718055E-10_JPRB, &
  & 0.87791142E-10_JPRB, 0.87860177E-10_JPRB, 0.87921767E-10_JPRB, 0.87973975E-10_JPRB, 0.88015505E-10_JPRB, 0.88044703E-10_JPRB, &
  & 0.88059698E-10_JPRB, 0.88058588E-10_JPRB, 0.88040492E-10_JPRB, 0.88005450E-10_JPRB, 0.87954241E-10_JPRB, 0.87889696E-10_JPRB, &
  & 0.87816657E-10_JPRB, 0.87743132E-10_JPRB, 0.87678420E-10_JPRB, 0.87631347E-10_JPRB, 0.87606263E-10_JPRB, 0.87601856E-10_JPRB, &
  & 0.87612112E-10_JPRB, 0.87629390E-10_JPRB, 0.87647022E-10_JPRB, 0.87660490E-10_JPRB, 0.87667734E-10_JPRB, 0.87668595E-10_JPRB, &
  & 0.87664112E-10_JPRB, 0.87655889E-10_JPRB, 0.87645412E-10_JPRB, 0.87634039E-10_JPRB, 0.87622534E-10_JPRB, 0.87611626E-10_JPRB, &
  & 0.87600247E-10_JPRB, 0.87588783E-10_JPRB, 0.87576196E-10_JPRB, 0.87564511E-10_JPRB, 0.87554033E-10_JPRB, 0.87544860E-10_JPRB, &
  & 0.87536117E-10_JPRB, 0.87526611E-10_JPRB, 0.87513330E-10_JPRB, 0.87488954E-10_JPRB /)

RGHG9(:,64, 5) = (/ &
  & 0.87507397E-10_JPRB, 0.87524932E-10_JPRB, 0.87534924E-10_JPRB, 0.87544340E-10_JPRB, 0.87554325E-10_JPRB, 0.87563373E-10_JPRB, &
  & 0.87570444E-10_JPRB, 0.87575530E-10_JPRB, 0.87580186E-10_JPRB, 0.87584676E-10_JPRB, 0.87590143E-10_JPRB, 0.87596860E-10_JPRB, &
  & 0.87605381E-10_JPRB, 0.87614603E-10_JPRB, 0.87621348E-10_JPRB, 0.87622125E-10_JPRB, 0.87615491E-10_JPRB, 0.87603973E-10_JPRB, &
  & 0.87593731E-10_JPRB, 0.87591982E-10_JPRB, 0.87605624E-10_JPRB, 0.87639479E-10_JPRB, 0.87692582E-10_JPRB, 0.87758745E-10_JPRB, &
  & 0.87828252E-10_JPRB, 0.87894705E-10_JPRB, 0.87953977E-10_JPRB, 0.88004111E-10_JPRB, 0.88043649E-10_JPRB, 0.88071168E-10_JPRB, &
  & 0.88084998E-10_JPRB, 0.88083596E-10_JPRB, 0.88066256E-10_JPRB, 0.88033081E-10_JPRB, 0.87985050E-10_JPRB, 0.87924543E-10_JPRB, &
  & 0.87856368E-10_JPRB, 0.87787680E-10_JPRB, 0.87727332E-10_JPRB, 0.87683555E-10_JPRB, 0.87660240E-10_JPRB, 0.87656118E-10_JPRB, &
  & 0.87665673E-10_JPRB, 0.87682014E-10_JPRB, 0.87699056E-10_JPRB, 0.87712448E-10_JPRB, 0.87720144E-10_JPRB, 0.87721871E-10_JPRB, &
  & 0.87718485E-10_JPRB, 0.87711338E-10_JPRB, 0.87701651E-10_JPRB, 0.87690404E-10_JPRB, 0.87678476E-10_JPRB, 0.87665743E-10_JPRB, &
  & 0.87653121E-10_JPRB, 0.87639077E-10_JPRB, 0.87625365E-10_JPRB, 0.87611779E-10_JPRB, 0.87599948E-10_JPRB, 0.87589401E-10_JPRB, &
  & 0.87579118E-10_JPRB, 0.87567231E-10_JPRB, 0.87551737E-10_JPRB, 0.87519485E-10_JPRB /)

RGHG9(:,65, 5) = (/ &
  & 0.87559959E-10_JPRB, 0.87577140E-10_JPRB, 0.87586820E-10_JPRB, 0.87595882E-10_JPRB, 0.87605430E-10_JPRB, 0.87614666E-10_JPRB, &
  & 0.87621937E-10_JPRB, 0.87628085E-10_JPRB, 0.87633331E-10_JPRB, 0.87639340E-10_JPRB, 0.87646168E-10_JPRB, 0.87655237E-10_JPRB, &
  & 0.87666166E-10_JPRB, 0.87676748E-10_JPRB, 0.87683583E-10_JPRB, 0.87683236E-10_JPRB, 0.87675207E-10_JPRB, 0.87662287E-10_JPRB, &
  & 0.87650297E-10_JPRB, 0.87646418E-10_JPRB, 0.87657548E-10_JPRB, 0.87688176E-10_JPRB, 0.87737831E-10_JPRB, 0.87799837E-10_JPRB, &
  & 0.87866006E-10_JPRB, 0.87929219E-10_JPRB, 0.87985834E-10_JPRB, 0.88033358E-10_JPRB, 0.88070572E-10_JPRB, 0.88096121E-10_JPRB, &
  & 0.88108701E-10_JPRB, 0.88107091E-10_JPRB, 0.88090708E-10_JPRB, 0.88059740E-10_JPRB, 0.88015074E-10_JPRB, 0.87959126E-10_JPRB, &
  & 0.87895934E-10_JPRB, 0.87832325E-10_JPRB, 0.87776460E-10_JPRB, 0.87735909E-10_JPRB, 0.87714259E-10_JPRB, 0.87710228E-10_JPRB, &
  & 0.87718881E-10_JPRB, 0.87734063E-10_JPRB, 0.87750245E-10_JPRB, 0.87763262E-10_JPRB, 0.87771193E-10_JPRB, 0.87773608E-10_JPRB, &
  & 0.87771172E-10_JPRB, 0.87764983E-10_JPRB, 0.87756052E-10_JPRB, 0.87745158E-10_JPRB, 0.87732793E-10_JPRB, 0.87719526E-10_JPRB, &
  & 0.87704961E-10_JPRB, 0.87690098E-10_JPRB, 0.87674354E-10_JPRB, 0.87659845E-10_JPRB, 0.87646591E-10_JPRB, 0.87634698E-10_JPRB, &
  & 0.87622833E-10_JPRB, 0.87609482E-10_JPRB, 0.87589568E-10_JPRB, 0.87552209E-10_JPRB /)

RGHG9(:,66, 5) = (/ &
  & 0.87607088E-10_JPRB, 0.87624984E-10_JPRB, 0.87635163E-10_JPRB, 0.87644350E-10_JPRB, 0.87654099E-10_JPRB, 0.87663599E-10_JPRB, &
  & 0.87671759E-10_JPRB, 0.87678434E-10_JPRB, 0.87685248E-10_JPRB, 0.87692249E-10_JPRB, 0.87701540E-10_JPRB, 0.87712754E-10_JPRB, &
  & 0.87725702E-10_JPRB, 0.87737054E-10_JPRB, 0.87743167E-10_JPRB, 0.87741953E-10_JPRB, 0.87733126E-10_JPRB, 0.87719297E-10_JPRB, &
  & 0.87706169E-10_JPRB, 0.87700625E-10_JPRB, 0.87709548E-10_JPRB, 0.87737421E-10_JPRB, 0.87783204E-10_JPRB, 0.87841581E-10_JPRB, &
  & 0.87903643E-10_JPRB, 0.87963435E-10_JPRB, 0.88016643E-10_JPRB, 0.88061211E-10_JPRB, 0.88095697E-10_JPRB, 0.88119109E-10_JPRB, &
  & 0.88130413E-10_JPRB, 0.88128650E-10_JPRB, 0.88113412E-10_JPRB, 0.88084831E-10_JPRB, 0.88043933E-10_JPRB, 0.87992579E-10_JPRB, &
  & 0.87934812E-10_JPRB, 0.87876338E-10_JPRB, 0.87825108E-10_JPRB, 0.87787826E-10_JPRB, 0.87767765E-10_JPRB, 0.87763755E-10_JPRB, &
  & 0.87771443E-10_JPRB, 0.87785224E-10_JPRB, 0.87800343E-10_JPRB, 0.87812778E-10_JPRB, 0.87820751E-10_JPRB, 0.87823700E-10_JPRB, &
  & 0.87822111E-10_JPRB, 0.87816830E-10_JPRB, 0.87808628E-10_JPRB, 0.87798137E-10_JPRB, 0.87785806E-10_JPRB, 0.87771880E-10_JPRB, &
  & 0.87756774E-10_JPRB, 0.87740433E-10_JPRB, 0.87724043E-10_JPRB, 0.87708216E-10_JPRB, 0.87694019E-10_JPRB, 0.87680960E-10_JPRB, &
  & 0.87668046E-10_JPRB, 0.87652594E-10_JPRB, 0.87631069E-10_JPRB, 0.87586473E-10_JPRB /)

RGHG9(:,67, 5) = (/ &
  & 0.87650207E-10_JPRB, 0.87670232E-10_JPRB, 0.87681050E-10_JPRB, 0.87691049E-10_JPRB, 0.87701353E-10_JPRB, 0.87711283E-10_JPRB, &
  & 0.87720255E-10_JPRB, 0.87728096E-10_JPRB, 0.87735846E-10_JPRB, 0.87745061E-10_JPRB, 0.87755955E-10_JPRB, 0.87769458E-10_JPRB, &
  & 0.87783288E-10_JPRB, 0.87794043E-10_JPRB, 0.87799740E-10_JPRB, 0.87798178E-10_JPRB, 0.87789040E-10_JPRB, 0.87774912E-10_JPRB, &
  & 0.87761173E-10_JPRB, 0.87754547E-10_JPRB, 0.87761631E-10_JPRB, 0.87786653E-10_JPRB, 0.87829126E-10_JPRB, 0.87883048E-10_JPRB, &
  & 0.87941099E-10_JPRB, 0.87996679E-10_JPRB, 0.88046181E-10_JPRB, 0.88087281E-10_JPRB, 0.88118901E-10_JPRB, 0.88140072E-10_JPRB, &
  & 0.88150084E-10_JPRB, 0.88148273E-10_JPRB, 0.88134278E-10_JPRB, 0.88108333E-10_JPRB, 0.88071113E-10_JPRB, 0.88024726E-10_JPRB, &
  & 0.87972178E-10_JPRB, 0.87919172E-10_JPRB, 0.87872522E-10_JPRB, 0.87838639E-10_JPRB, 0.87820251E-10_JPRB, 0.87816268E-10_JPRB, &
  & 0.87822957E-10_JPRB, 0.87835260E-10_JPRB, 0.87849159E-10_JPRB, 0.87860878E-10_JPRB, 0.87868761E-10_JPRB, 0.87872119E-10_JPRB, &
  & 0.87871280E-10_JPRB, 0.87866853E-10_JPRB, 0.87859414E-10_JPRB, 0.87849408E-10_JPRB, 0.87837237E-10_JPRB, 0.87823193E-10_JPRB, &
  & 0.87807511E-10_JPRB, 0.87790768E-10_JPRB, 0.87773414E-10_JPRB, 0.87757135E-10_JPRB, 0.87742071E-10_JPRB, 0.87728318E-10_JPRB, &
  & 0.87714412E-10_JPRB, 0.87698376E-10_JPRB, 0.87673459E-10_JPRB, 0.87624956E-10_JPRB /)

RGHG9(:,68, 5) = (/ &
  & 0.87690119E-10_JPRB, 0.87712802E-10_JPRB, 0.87725646E-10_JPRB, 0.87736651E-10_JPRB, 0.87747754E-10_JPRB, 0.87758995E-10_JPRB, &
  & 0.87768195E-10_JPRB, 0.87777466E-10_JPRB, 0.87786438E-10_JPRB, 0.87797131E-10_JPRB, 0.87809995E-10_JPRB, 0.87824373E-10_JPRB, &
  & 0.87838056E-10_JPRB, 0.87848617E-10_JPRB, 0.87853912E-10_JPRB, 0.87851976E-10_JPRB, 0.87842858E-10_JPRB, 0.87828973E-10_JPRB, &
  & 0.87815220E-10_JPRB, 0.87807990E-10_JPRB, 0.87813513E-10_JPRB, 0.87835988E-10_JPRB, 0.87874534E-10_JPRB, 0.87924300E-10_JPRB, &
  & 0.87977521E-10_JPRB, 0.88028716E-10_JPRB, 0.88074027E-10_JPRB, 0.88111560E-10_JPRB, 0.88140183E-10_JPRB, 0.88159133E-10_JPRB, &
  & 0.88167952E-10_JPRB, 0.88166148E-10_JPRB, 0.88153478E-10_JPRB, 0.88130066E-10_JPRB, 0.88096773E-10_JPRB, 0.88055022E-10_JPRB, &
  & 0.88007997E-10_JPRB, 0.87960229E-10_JPRB, 0.87918270E-10_JPRB, 0.87887767E-10_JPRB, 0.87871065E-10_JPRB, 0.87867241E-10_JPRB, &
  & 0.87872994E-10_JPRB, 0.87883853E-10_JPRB, 0.87896544E-10_JPRB, 0.87907480E-10_JPRB, 0.87915147E-10_JPRB, 0.87918832E-10_JPRB, &
  & 0.87918645E-10_JPRB, 0.87915036E-10_JPRB, 0.87908347E-10_JPRB, 0.87898910E-10_JPRB, 0.87887080E-10_JPRB, 0.87873132E-10_JPRB, &
  & 0.87857423E-10_JPRB, 0.87840367E-10_JPRB, 0.87822832E-10_JPRB, 0.87806096E-10_JPRB, 0.87790782E-10_JPRB, 0.87776592E-10_JPRB, &
  & 0.87762471E-10_JPRB, 0.87745658E-10_JPRB, 0.87720213E-10_JPRB, 0.87667304E-10_JPRB /)

RGHG9(:,69, 5) = (/ &
  & 0.87726819E-10_JPRB, 0.87755053E-10_JPRB, 0.87769687E-10_JPRB, 0.87782483E-10_JPRB, 0.87795007E-10_JPRB, 0.87806207E-10_JPRB, &
  & 0.87817267E-10_JPRB, 0.87826357E-10_JPRB, 0.87837349E-10_JPRB, 0.87848798E-10_JPRB, 0.87862807E-10_JPRB, 0.87876942E-10_JPRB, &
  & 0.87889716E-10_JPRB, 0.87899195E-10_JPRB, 0.87904545E-10_JPRB, 0.87903317E-10_JPRB, 0.87894844E-10_JPRB, 0.87881535E-10_JPRB, &
  & 0.87868303E-10_JPRB, 0.87860920E-10_JPRB, 0.87865194E-10_JPRB, 0.87884922E-10_JPRB, 0.87919616E-10_JPRB, 0.87964469E-10_JPRB, &
  & 0.88012916E-10_JPRB, 0.88059275E-10_JPRB, 0.88100333E-10_JPRB, 0.88134132E-10_JPRB, 0.88159757E-10_JPRB, 0.88176563E-10_JPRB, &
  & 0.88184252E-10_JPRB, 0.88182517E-10_JPRB, 0.88171172E-10_JPRB, 0.88150383E-10_JPRB, 0.88120809E-10_JPRB, 0.88083860E-10_JPRB, &
  & 0.88041949E-10_JPRB, 0.87999434E-10_JPRB, 0.87962033E-10_JPRB, 0.87934909E-10_JPRB, 0.87919956E-10_JPRB, 0.87916417E-10_JPRB, &
  & 0.87921406E-10_JPRB, 0.87930961E-10_JPRB, 0.87942424E-10_JPRB, 0.87952576E-10_JPRB, 0.87960014E-10_JPRB, 0.87963858E-10_JPRB, &
  & 0.87964261E-10_JPRB, 0.87961381E-10_JPRB, 0.87955435E-10_JPRB, 0.87946678E-10_JPRB, 0.87935353E-10_JPRB, 0.87921795E-10_JPRB, &
  & 0.87906314E-10_JPRB, 0.87889487E-10_JPRB, 0.87871987E-10_JPRB, 0.87855424E-10_JPRB, 0.87840131E-10_JPRB, 0.87826003E-10_JPRB, &
  & 0.87811987E-10_JPRB, 0.87795431E-10_JPRB, 0.87768917E-10_JPRB, 0.87713073E-10_JPRB /)

RGHG9(:,70, 5) = (/ &
  & 0.87762755E-10_JPRB, 0.87796492E-10_JPRB, 0.87814971E-10_JPRB, 0.87829466E-10_JPRB, 0.87842809E-10_JPRB, 0.87855410E-10_JPRB, &
  & 0.87865694E-10_JPRB, 0.87876803E-10_JPRB, 0.87887420E-10_JPRB, 0.87900340E-10_JPRB, 0.87913940E-10_JPRB, 0.87927748E-10_JPRB, &
  & 0.87940211E-10_JPRB, 0.87949696E-10_JPRB, 0.87954505E-10_JPRB, 0.87952735E-10_JPRB, 0.87944894E-10_JPRB, 0.87932654E-10_JPRB, &
  & 0.87920241E-10_JPRB, 0.87913073E-10_JPRB, 0.87916181E-10_JPRB, 0.87933195E-10_JPRB, 0.87963643E-10_JPRB, 0.88003618E-10_JPRB, &
  & 0.88046834E-10_JPRB, 0.88088363E-10_JPRB, 0.88125049E-10_JPRB, 0.88155115E-10_JPRB, 0.88177833E-10_JPRB, 0.88192606E-10_JPRB, &
  & 0.88199240E-10_JPRB, 0.88197595E-10_JPRB, 0.88187596E-10_JPRB, 0.88169347E-10_JPRB, 0.88143486E-10_JPRB, 0.88110998E-10_JPRB, &
  & 0.88074187E-10_JPRB, 0.88036689E-10_JPRB, 0.88003715E-10_JPRB, 0.87979929E-10_JPRB, 0.87966773E-10_JPRB, 0.87963671E-10_JPRB, &
  & 0.87967994E-10_JPRB, 0.87976446E-10_JPRB, 0.87986687E-10_JPRB, 0.87996076E-10_JPRB, 0.88003126E-10_JPRB, 0.88007102E-10_JPRB, &
  & 0.88007976E-10_JPRB, 0.88005783E-10_JPRB, 0.88000586E-10_JPRB, 0.87992585E-10_JPRB, 0.87981969E-10_JPRB, 0.87969063E-10_JPRB, &
  & 0.87954213E-10_JPRB, 0.87937956E-10_JPRB, 0.87921025E-10_JPRB, 0.87905017E-10_JPRB, 0.87890237E-10_JPRB, 0.87876657E-10_JPRB, &
  & 0.87863231E-10_JPRB, 0.87847438E-10_JPRB, 0.87821306E-10_JPRB, 0.87763054E-10_JPRB /)

RGHG9(:,71, 5) = (/ &
  & 0.87798539E-10_JPRB, 0.87841526E-10_JPRB, 0.87862113E-10_JPRB, 0.87878607E-10_JPRB, 0.87892707E-10_JPRB, 0.87904961E-10_JPRB, &
  & 0.87916195E-10_JPRB, 0.87926687E-10_JPRB, 0.87938511E-10_JPRB, 0.87950661E-10_JPRB, 0.87964074E-10_JPRB, 0.87976668E-10_JPRB, &
  & 0.87987305E-10_JPRB, 0.87995528E-10_JPRB, 0.88000697E-10_JPRB, 0.87999982E-10_JPRB, 0.87993043E-10_JPRB, 0.87981969E-10_JPRB, &
  & 0.87970749E-10_JPRB, 0.87963879E-10_JPRB, 0.87966065E-10_JPRB, 0.87980304E-10_JPRB, 0.88006512E-10_JPRB, 0.88041269E-10_JPRB, &
  & 0.88079308E-10_JPRB, 0.88115876E-10_JPRB, 0.88148232E-10_JPRB, 0.88174676E-10_JPRB, 0.88194535E-10_JPRB, 0.88207344E-10_JPRB, &
  & 0.88212999E-10_JPRB, 0.88211535E-10_JPRB, 0.88202848E-10_JPRB, 0.88187076E-10_JPRB, 0.88164684E-10_JPRB, 0.88136658E-10_JPRB, &
  & 0.88104607E-10_JPRB, 0.88072001E-10_JPRB, 0.88043350E-10_JPRB, 0.88022735E-10_JPRB, 0.88011397E-10_JPRB, 0.88008802E-10_JPRB, &
  & 0.88012639E-10_JPRB, 0.88020084E-10_JPRB, 0.88029126E-10_JPRB, 0.88037709E-10_JPRB, 0.88044287E-10_JPRB, 0.88048242E-10_JPRB, &
  & 0.88049491E-10_JPRB, 0.88047888E-10_JPRB, 0.88043461E-10_JPRB, 0.88036328E-10_JPRB, 0.88026621E-10_JPRB, 0.88014707E-10_JPRB, &
  & 0.88000912E-10_JPRB, 0.87985605E-10_JPRB, 0.87969812E-10_JPRB, 0.87954699E-10_JPRB, 0.87941078E-10_JPRB, 0.87928373E-10_JPRB, &
  & 0.87916091E-10_JPRB, 0.87901825E-10_JPRB, 0.87877698E-10_JPRB, 0.87822881E-10_JPRB /)

RGHG9(:,72, 5) = (/ &
  & 0.87840464E-10_JPRB, 0.87888224E-10_JPRB, 0.87913288E-10_JPRB, 0.87930010E-10_JPRB, 0.87944409E-10_JPRB, 0.87956295E-10_JPRB, &
  & 0.87967258E-10_JPRB, 0.87978035E-10_JPRB, 0.87989095E-10_JPRB, 0.88001155E-10_JPRB, 0.88013125E-10_JPRB, 0.88024699E-10_JPRB, &
  & 0.88034580E-10_JPRB, 0.88041970E-10_JPRB, 0.88046195E-10_JPRB, 0.88045127E-10_JPRB, 0.88039104E-10_JPRB, 0.88029313E-10_JPRB, &
  & 0.88019286E-10_JPRB, 0.88013014E-10_JPRB, 0.88014304E-10_JPRB, 0.88025934E-10_JPRB, 0.88047833E-10_JPRB, 0.88077497E-10_JPRB, &
  & 0.88110255E-10_JPRB, 0.88141966E-10_JPRB, 0.88170055E-10_JPRB, 0.88192870E-10_JPRB, 0.88210078E-10_JPRB, 0.88221007E-10_JPRB, &
  & 0.88225760E-10_JPRB, 0.88224476E-10_JPRB, 0.88217086E-10_JPRB, 0.88203576E-10_JPRB, 0.88184592E-10_JPRB, 0.88160687E-10_JPRB, &
  & 0.88133369E-10_JPRB, 0.88105315E-10_JPRB, 0.88080862E-10_JPRB, 0.88063307E-10_JPRB, 0.88053703E-10_JPRB, 0.88051649E-10_JPRB, &
  & 0.88055077E-10_JPRB, 0.88061475E-10_JPRB, 0.88069441E-10_JPRB, 0.88077115E-10_JPRB, 0.88083103E-10_JPRB, 0.88086941E-10_JPRB, &
  & 0.88088377E-10_JPRB, 0.88087281E-10_JPRB, 0.88083651E-10_JPRB, 0.88077504E-10_JPRB, 0.88068969E-10_JPRB, 0.88058325E-10_JPRB, &
  & 0.88045897E-10_JPRB, 0.88032220E-10_JPRB, 0.88017676E-10_JPRB, 0.88004382E-10_JPRB, 0.87991787E-10_JPRB, 0.87980671E-10_JPRB, &
  & 0.87969604E-10_JPRB, 0.87957044E-10_JPRB, 0.87935666E-10_JPRB, 0.87884186E-10_JPRB /)

RGHG9(:,73, 5) = (/ &
  & 0.87887399E-10_JPRB, 0.87942417E-10_JPRB, 0.87966329E-10_JPRB, 0.87983953E-10_JPRB, 0.87997158E-10_JPRB, 0.88008795E-10_JPRB, &
  & 0.88019064E-10_JPRB, 0.88029271E-10_JPRB, 0.88040158E-10_JPRB, 0.88050303E-10_JPRB, 0.88061607E-10_JPRB, 0.88070919E-10_JPRB, &
  & 0.88078295E-10_JPRB, 0.88084318E-10_JPRB, 0.88088745E-10_JPRB, 0.88088183E-10_JPRB, 0.88082749E-10_JPRB, 0.88074187E-10_JPRB, &
  & 0.88065444E-10_JPRB, 0.88059740E-10_JPRB, 0.88060399E-10_JPRB, 0.88069566E-10_JPRB, 0.88087412E-10_JPRB, 0.88112052E-10_JPRB, &
  & 0.88139746E-10_JPRB, 0.88166550E-10_JPRB, 0.88190552E-10_JPRB, 0.88209891E-10_JPRB, 0.88224428E-10_JPRB, 0.88233615E-10_JPRB, &
  & 0.88237535E-10_JPRB, 0.88236446E-10_JPRB, 0.88230319E-10_JPRB, 0.88219015E-10_JPRB, 0.88203146E-10_JPRB, 0.88183259E-10_JPRB, &
  & 0.88160271E-10_JPRB, 0.88136699E-10_JPRB, 0.88116139E-10_JPRB, 0.88101498E-10_JPRB, 0.88093567E-10_JPRB, 0.88091971E-10_JPRB, &
  & 0.88094969E-10_JPRB, 0.88100444E-10_JPRB, 0.88107244E-10_JPRB, 0.88114002E-10_JPRB, 0.88119338E-10_JPRB, 0.88122870E-10_JPRB, &
  & 0.88124404E-10_JPRB, 0.88123703E-10_JPRB, 0.88120823E-10_JPRB, 0.88115813E-10_JPRB, 0.88108493E-10_JPRB, 0.88099396E-10_JPRB, &
  & 0.88088772E-10_JPRB, 0.88076657E-10_JPRB, 0.88064403E-10_JPRB, 0.88052302E-10_JPRB, 0.88041886E-10_JPRB, 0.88031867E-10_JPRB, &
  & 0.88022416E-10_JPRB, 0.88011556E-10_JPRB, 0.87992287E-10_JPRB, 0.87945429E-10_JPRB /)

RGHG9(:,74, 5) = (/ &
  & 0.87941633E-10_JPRB, 0.87995888E-10_JPRB, 0.88022048E-10_JPRB, 0.88037536E-10_JPRB, 0.88050345E-10_JPRB, 0.88060510E-10_JPRB, &
  & 0.88070343E-10_JPRB, 0.88079849E-10_JPRB, 0.88088890E-10_JPRB, 0.88098980E-10_JPRB, 0.88107334E-10_JPRB, 0.88116001E-10_JPRB, &
  & 0.88122357E-10_JPRB, 0.88127526E-10_JPRB, 0.88129781E-10_JPRB, 0.88128560E-10_JPRB, 0.88123772E-10_JPRB, 0.88116361E-10_JPRB, &
  & 0.88108777E-10_JPRB, 0.88103809E-10_JPRB, 0.88103913E-10_JPRB, 0.88110880E-10_JPRB, 0.88124959E-10_JPRB, 0.88144929E-10_JPRB, &
  & 0.88167744E-10_JPRB, 0.88189823E-10_JPRB, 0.88209877E-10_JPRB, 0.88225753E-10_JPRB, 0.88237820E-10_JPRB, 0.88245355E-10_JPRB, &
  & 0.88248513E-10_JPRB, 0.88247618E-10_JPRB, 0.88242656E-10_JPRB, 0.88233351E-10_JPRB, 0.88220500E-10_JPRB, 0.88204243E-10_JPRB, &
  & 0.88185452E-10_JPRB, 0.88166023E-10_JPRB, 0.88149259E-10_JPRB, 0.88137234E-10_JPRB, 0.88130843E-10_JPRB, 0.88129656E-10_JPRB, &
  & 0.88132265E-10_JPRB, 0.88136755E-10_JPRB, 0.88142507E-10_JPRB, 0.88148287E-10_JPRB, 0.88152895E-10_JPRB, 0.88156017E-10_JPRB, &
  & 0.88157523E-10_JPRB, 0.88157120E-10_JPRB, 0.88154983E-10_JPRB, 0.88151007E-10_JPRB, 0.88145061E-10_JPRB, 0.88137588E-10_JPRB, &
  & 0.88128713E-10_JPRB, 0.88118846E-10_JPRB, 0.88108146E-10_JPRB, 0.88098598E-10_JPRB, 0.88089189E-10_JPRB, 0.88081223E-10_JPRB, &
  & 0.88072966E-10_JPRB, 0.88063723E-10_JPRB, 0.88047167E-10_JPRB, 0.88003597E-10_JPRB /)

RGHG9(:,75, 5) = (/ &
  & 0.87995708E-10_JPRB, 0.88052482E-10_JPRB, 0.88075700E-10_JPRB, 0.88090368E-10_JPRB, 0.88101151E-10_JPRB, 0.88110512E-10_JPRB, &
  & 0.88119047E-10_JPRB, 0.88127242E-10_JPRB, 0.88135874E-10_JPRB, 0.88142861E-10_JPRB, 0.88150869E-10_JPRB, 0.88156080E-10_JPRB, &
  & 0.88159306E-10_JPRB, 0.88161985E-10_JPRB, 0.88166530E-10_JPRB, 0.88165870E-10_JPRB, 0.88161839E-10_JPRB, 0.88155594E-10_JPRB, &
  & 0.88149210E-10_JPRB, 0.88144964E-10_JPRB, 0.88144665E-10_JPRB, 0.88149696E-10_JPRB, 0.88160416E-10_JPRB, 0.88176112E-10_JPRB, &
  & 0.88194348E-10_JPRB, 0.88211875E-10_JPRB, 0.88228112E-10_JPRB, 0.88240644E-10_JPRB, 0.88250240E-10_JPRB, 0.88256215E-10_JPRB, &
  & 0.88258623E-10_JPRB, 0.88257929E-10_JPRB, 0.88254140E-10_JPRB, 0.88246750E-10_JPRB, 0.88236640E-10_JPRB, 0.88223873E-10_JPRB, &
  & 0.88208926E-10_JPRB, 0.88193494E-10_JPRB, 0.88180206E-10_JPRB, 0.88170700E-10_JPRB, 0.88165669E-10_JPRB, 0.88164760E-10_JPRB, &
  & 0.88166932E-10_JPRB, 0.88170540E-10_JPRB, 0.88175217E-10_JPRB, 0.88180060E-10_JPRB, 0.88183953E-10_JPRB, 0.88186528E-10_JPRB, &
  & 0.88187929E-10_JPRB, 0.88187735E-10_JPRB, 0.88186243E-10_JPRB, 0.88183363E-10_JPRB, 0.88178589E-10_JPRB, 0.88172775E-10_JPRB, &
  & 0.88165780E-10_JPRB, 0.88157759E-10_JPRB, 0.88149495E-10_JPRB, 0.88141272E-10_JPRB, 0.88134208E-10_JPRB, 0.88127269E-10_JPRB, &
  & 0.88120830E-10_JPRB, 0.88113163E-10_JPRB, 0.88098535E-10_JPRB, 0.88059351E-10_JPRB /)

RGHG9(:,76, 5) = (/ &
  & 0.88053988E-10_JPRB, 0.88106460E-10_JPRB, 0.88128241E-10_JPRB, 0.88140058E-10_JPRB, 0.88149349E-10_JPRB, 0.88156746E-10_JPRB, &
  & 0.88164212E-10_JPRB, 0.88171234E-10_JPRB, 0.88177472E-10_JPRB, 0.88184182E-10_JPRB, 0.88189116E-10_JPRB, 0.88194174E-10_JPRB, &
  & 0.88196631E-10_JPRB, 0.88200017E-10_JPRB, 0.88200953E-10_JPRB, 0.88200031E-10_JPRB, 0.88196853E-10_JPRB, 0.88191815E-10_JPRB, &
  & 0.88186576E-10_JPRB, 0.88183114E-10_JPRB, 0.88182558E-10_JPRB, 0.88185986E-10_JPRB, 0.88193772E-10_JPRB, 0.88205609E-10_JPRB, &
  & 0.88219584E-10_JPRB, 0.88232713E-10_JPRB, 0.88245307E-10_JPRB, 0.88254584E-10_JPRB, 0.88261898E-10_JPRB, 0.88266429E-10_JPRB, &
  & 0.88268233E-10_JPRB, 0.88267761E-10_JPRB, 0.88264999E-10_JPRB, 0.88259254E-10_JPRB, 0.88251698E-10_JPRB, 0.88242157E-10_JPRB, &
  & 0.88230853E-10_JPRB, 0.88219113E-10_JPRB, 0.88209134E-10_JPRB, 0.88201897E-10_JPRB, 0.88198115E-10_JPRB, 0.88197401E-10_JPRB, &
  & 0.88199191E-10_JPRB, 0.88201911E-10_JPRB, 0.88205533E-10_JPRB, 0.88209530E-10_JPRB, 0.88212632E-10_JPRB, 0.88214602E-10_JPRB, &
  & 0.88215817E-10_JPRB, 0.88215768E-10_JPRB, 0.88214873E-10_JPRB, 0.88212937E-10_JPRB, 0.88209301E-10_JPRB, 0.88205020E-10_JPRB, &
  & 0.88199829E-10_JPRB, 0.88193883E-10_JPRB, 0.88187360E-10_JPRB, 0.88181455E-10_JPRB, 0.88175529E-10_JPRB, 0.88170596E-10_JPRB, &
  & 0.88165392E-10_JPRB, 0.88159549E-10_JPRB, 0.88147177E-10_JPRB, 0.88111574E-10_JPRB /)

RGHG9(:,77, 5) = (/ &
  & 0.88112274E-10_JPRB, 0.88159209E-10_JPRB, 0.88177361E-10_JPRB, 0.88186472E-10_JPRB, 0.88193355E-10_JPRB, 0.88199059E-10_JPRB, &
  & 0.88204770E-10_JPRB, 0.88209939E-10_JPRB, 0.88215060E-10_JPRB, 0.88218953E-10_JPRB, 0.88222832E-10_JPRB, 0.88224782E-10_JPRB, &
  & 0.88224379E-10_JPRB, 0.88225670E-10_JPRB, 0.88230118E-10_JPRB, 0.88230138E-10_JPRB, 0.88228078E-10_JPRB, 0.88224303E-10_JPRB, &
  & 0.88220278E-10_JPRB, 0.88217711E-10_JPRB, 0.88217128E-10_JPRB, 0.88219251E-10_JPRB, 0.88224608E-10_JPRB, 0.88233046E-10_JPRB, &
  & 0.88243100E-10_JPRB, 0.88252211E-10_JPRB, 0.88261280E-10_JPRB, 0.88267581E-10_JPRB, 0.88272695E-10_JPRB, 0.88275817E-10_JPRB, &
  & 0.88277052E-10_JPRB, 0.88276754E-10_JPRB, 0.88275047E-10_JPRB, 0.88270904E-10_JPRB, 0.88265721E-10_JPRB, 0.88259143E-10_JPRB, &
  & 0.88251143E-10_JPRB, 0.88242802E-10_JPRB, 0.88235863E-10_JPRB, 0.88230756E-10_JPRB, 0.88228064E-10_JPRB, 0.88227488E-10_JPRB, &
  & 0.88228896E-10_JPRB, 0.88230763E-10_JPRB, 0.88233400E-10_JPRB, 0.88236557E-10_JPRB, 0.88238902E-10_JPRB, 0.88240179E-10_JPRB, &
  & 0.88241178E-10_JPRB, 0.88241130E-10_JPRB, 0.88240720E-10_JPRB, 0.88239707E-10_JPRB, 0.88236973E-10_JPRB, 0.88234191E-10_JPRB, &
  & 0.88230659E-10_JPRB, 0.88226620E-10_JPRB, 0.88222173E-10_JPRB, 0.88217829E-10_JPRB, 0.88213804E-10_JPRB, 0.88210099E-10_JPRB, &
  & 0.88206650E-10_JPRB, 0.88202383E-10_JPRB, 0.88192252E-10_JPRB, 0.88161430E-10_JPRB /)

RGHG9(:,78, 5) = (/ &
  & 0.88171012E-10_JPRB, 0.88207032E-10_JPRB, 0.88220174E-10_JPRB, 0.88226183E-10_JPRB, 0.88230936E-10_JPRB, 0.88234448E-10_JPRB, &
  & 0.88238548E-10_JPRB, 0.88241914E-10_JPRB, 0.88244939E-10_JPRB, 0.88247618E-10_JPRB, 0.88249644E-10_JPRB, 0.88251059E-10_JPRB, &
  & 0.88250296E-10_JPRB, 0.88251649E-10_JPRB, 0.88254411E-10_JPRB, 0.88254744E-10_JPRB, 0.88253724E-10_JPRB, 0.88251184E-10_JPRB, &
  & 0.88248277E-10_JPRB, 0.88246695E-10_JPRB, 0.88246271E-10_JPRB, 0.88247562E-10_JPRB, 0.88251018E-10_JPRB, 0.88256742E-10_JPRB, &
  & 0.88263487E-10_JPRB, 0.88269302E-10_JPRB, 0.88275220E-10_JPRB, 0.88279002E-10_JPRB, 0.88282277E-10_JPRB, 0.88284227E-10_JPRB, &
  & 0.88285129E-10_JPRB, 0.88284963E-10_JPRB, 0.88284088E-10_JPRB, 0.88281209E-10_JPRB, 0.88278052E-10_JPRB, 0.88274027E-10_JPRB, &
  & 0.88268899E-10_JPRB, 0.88263424E-10_JPRB, 0.88259101E-10_JPRB, 0.88255785E-10_JPRB, 0.88254036E-10_JPRB, 0.88253543E-10_JPRB, &
  & 0.88254591E-10_JPRB, 0.88255653E-10_JPRB, 0.88257353E-10_JPRB, 0.88259809E-10_JPRB, 0.88261357E-10_JPRB, 0.88261932E-10_JPRB, &
  & 0.88262647E-10_JPRB, 0.88262488E-10_JPRB, 0.88262425E-10_JPRB, 0.88262148E-10_JPRB, 0.88260170E-10_JPRB, 0.88258602E-10_JPRB, &
  & 0.88256548E-10_JPRB, 0.88254230E-10_JPRB, 0.88251462E-10_JPRB, 0.88248853E-10_JPRB, 0.88246029E-10_JPRB, 0.88243760E-10_JPRB, &
  & 0.88241650E-10_JPRB, 0.88239027E-10_JPRB, 0.88231950E-10_JPRB, 0.88208545E-10_JPRB /)

RGHG9(:,79, 5) = (/ &
  & 0.88209058E-10_JPRB, 0.88233837E-10_JPRB, 0.88243128E-10_JPRB, 0.88246868E-10_JPRB, 0.88250421E-10_JPRB, 0.88252794E-10_JPRB, &
  & 0.88255993E-10_JPRB, 0.88258290E-10_JPRB, 0.88260524E-10_JPRB, 0.88262259E-10_JPRB, 0.88263730E-10_JPRB, 0.88264750E-10_JPRB, &
  & 0.88263709E-10_JPRB, 0.88265159E-10_JPRB, 0.88266970E-10_JPRB, 0.88267539E-10_JPRB, 0.88267171E-10_JPRB, 0.88265256E-10_JPRB, &
  & 0.88262925E-10_JPRB, 0.88261898E-10_JPRB, 0.88261606E-10_JPRB, 0.88262439E-10_JPRB, 0.88264965E-10_JPRB, 0.88269295E-10_JPRB, &
  & 0.88274416E-10_JPRB, 0.88278482E-10_JPRB, 0.88282742E-10_JPRB, 0.88285122E-10_JPRB, 0.88287405E-10_JPRB, 0.88288730E-10_JPRB, &
  & 0.88289487E-10_JPRB, 0.88289424E-10_JPRB, 0.88289036E-10_JPRB, 0.88286774E-10_JPRB, 0.88284748E-10_JPRB, 0.88282145E-10_JPRB, &
  & 0.88278537E-10_JPRB, 0.88274547E-10_JPRB, 0.88271564E-10_JPRB, 0.88269170E-10_JPRB, 0.88267865E-10_JPRB, 0.88267324E-10_JPRB, &
  & 0.88268184E-10_JPRB, 0.88268760E-10_JPRB, 0.88269961E-10_JPRB, 0.88272084E-10_JPRB, 0.88273201E-10_JPRB, 0.88273278E-10_JPRB, &
  & 0.88273819E-10_JPRB, 0.88273527E-10_JPRB, 0.88273652E-10_JPRB, 0.88273798E-10_JPRB, 0.88272077E-10_JPRB, 0.88271147E-10_JPRB, &
  & 0.88269822E-10_JPRB, 0.88268406E-10_JPRB, 0.88266533E-10_JPRB, 0.88264673E-10_JPRB, 0.88262529E-10_JPRB, 0.88260871E-10_JPRB, &
  & 0.88259573E-10_JPRB, 0.88258262E-10_JPRB, 0.88253738E-10_JPRB, 0.88238174E-10_JPRB /)

RGHG9(:,80, 5) = (/ &
  & 0.88234295E-10_JPRB, 0.88246743E-10_JPRB, 0.88253183E-10_JPRB, 0.88255833E-10_JPRB, 0.88258817E-10_JPRB, 0.88260628E-10_JPRB, &
  & 0.88263549E-10_JPRB, 0.88265374E-10_JPRB, 0.88267352E-10_JPRB, 0.88268767E-10_JPRB, 0.88270009E-10_JPRB, 0.88270925E-10_JPRB, &
  & 0.88269704E-10_JPRB, 0.88271251E-10_JPRB, 0.88272563E-10_JPRB, 0.88273278E-10_JPRB, 0.88273264E-10_JPRB, 0.88271619E-10_JPRB, &
  & 0.88269510E-10_JPRB, 0.88268753E-10_JPRB, 0.88268504E-10_JPRB, 0.88269093E-10_JPRB, 0.88271175E-10_JPRB, 0.88274950E-10_JPRB, &
  & 0.88279356E-10_JPRB, 0.88282659E-10_JPRB, 0.88286163E-10_JPRB, 0.88287891E-10_JPRB, 0.88289709E-10_JPRB, 0.88290750E-10_JPRB, &
  & 0.88291457E-10_JPRB, 0.88291464E-10_JPRB, 0.88291319E-10_JPRB, 0.88289320E-10_JPRB, 0.88287808E-10_JPRB, 0.88285879E-10_JPRB, &
  & 0.88282930E-10_JPRB, 0.88279599E-10_JPRB, 0.88277233E-10_JPRB, 0.88275193E-10_JPRB, 0.88274048E-10_JPRB, 0.88273451E-10_JPRB, &
  & 0.88274214E-10_JPRB, 0.88274582E-10_JPRB, 0.88275540E-10_JPRB, 0.88277552E-10_JPRB, 0.88278461E-10_JPRB, 0.88278253E-10_JPRB, &
  & 0.88278718E-10_JPRB, 0.88278315E-10_JPRB, 0.88278516E-10_JPRB, 0.88278877E-10_JPRB, 0.88277205E-10_JPRB, 0.88276539E-10_JPRB, &
  & 0.88275512E-10_JPRB, 0.88274513E-10_JPRB, 0.88272972E-10_JPRB, 0.88271460E-10_JPRB, 0.88269544E-10_JPRB, 0.88268143E-10_JPRB, &
  & 0.88267262E-10_JPRB, 0.88266637E-10_JPRB, 0.88264090E-10_JPRB, 0.88257346E-10_JPRB /)

RGHG9(:,81, 5) = (/ &
  & 0.88251566E-10_JPRB, 0.88252163E-10_JPRB, 0.88257457E-10_JPRB, 0.88259622E-10_JPRB, 0.88262418E-10_JPRB, 0.88264021E-10_JPRB, &
  & 0.88266727E-10_JPRB, 0.88268580E-10_JPRB, 0.88270224E-10_JPRB, 0.88271737E-10_JPRB, 0.88272757E-10_JPRB, 0.88273687E-10_JPRB, &
  & 0.88272376E-10_JPRB, 0.88273951E-10_JPRB, 0.88275012E-10_JPRB, 0.88275803E-10_JPRB, 0.88276012E-10_JPRB, 0.88274485E-10_JPRB, &
  & 0.88272417E-10_JPRB, 0.88271827E-10_JPRB, 0.88271571E-10_JPRB, 0.88272022E-10_JPRB, 0.88273895E-10_JPRB, 0.88277427E-10_JPRB, &
  & 0.88281570E-10_JPRB, 0.88284505E-10_JPRB, 0.88287697E-10_JPRB, 0.88289112E-10_JPRB, 0.88290715E-10_JPRB, 0.88291624E-10_JPRB, &
  & 0.88292318E-10_JPRB, 0.88292339E-10_JPRB, 0.88292332E-10_JPRB, 0.88290431E-10_JPRB, 0.88289161E-10_JPRB, 0.88287530E-10_JPRB, &
  & 0.88284866E-10_JPRB, 0.88281847E-10_JPRB, 0.88279724E-10_JPRB, 0.88277843E-10_JPRB, 0.88276761E-10_JPRB, 0.88276136E-10_JPRB, &
  & 0.88276830E-10_JPRB, 0.88277080E-10_JPRB, 0.88277941E-10_JPRB, 0.88279939E-10_JPRB, 0.88280772E-10_JPRB, 0.88280397E-10_JPRB, &
  & 0.88280813E-10_JPRB, 0.88280348E-10_JPRB, 0.88280598E-10_JPRB, 0.88281084E-10_JPRB, 0.88279391E-10_JPRB, 0.88278850E-10_JPRB, &
  & 0.88277968E-10_JPRB, 0.88277122E-10_JPRB, 0.88275734E-10_JPRB, 0.88274332E-10_JPRB, 0.88272514E-10_JPRB, 0.88271203E-10_JPRB, &
  & 0.88270488E-10_JPRB, 0.88270162E-10_JPRB, 0.88268413E-10_JPRB, 0.88270294E-10_JPRB /)

RGHG9(:,82, 5) = (/ &
  & 0.88252919E-10_JPRB, 0.88253946E-10_JPRB, 0.88259351E-10_JPRB, 0.88261412E-10_JPRB, 0.88264139E-10_JPRB, 0.88265562E-10_JPRB, &
  & 0.88268420E-10_JPRB, 0.88269857E-10_JPRB, 0.88271924E-10_JPRB, 0.88273007E-10_JPRB, 0.88274235E-10_JPRB, 0.88275012E-10_JPRB, &
  & 0.88273736E-10_JPRB, 0.88275325E-10_JPRB, 0.88276234E-10_JPRB, 0.88277080E-10_JPRB, 0.88277399E-10_JPRB, 0.88275921E-10_JPRB, &
  & 0.88273881E-10_JPRB, 0.88273354E-10_JPRB, 0.88273097E-10_JPRB, 0.88273437E-10_JPRB, 0.88275200E-10_JPRB, 0.88278634E-10_JPRB, &
  & 0.88282687E-10_JPRB, 0.88285428E-10_JPRB, 0.88288474E-10_JPRB, 0.88289702E-10_JPRB, 0.88291194E-10_JPRB, 0.88292040E-10_JPRB, &
  & 0.88292734E-10_JPRB, 0.88292783E-10_JPRB, 0.88292831E-10_JPRB, 0.88290965E-10_JPRB, 0.88289806E-10_JPRB, 0.88288314E-10_JPRB, &
  & 0.88285816E-10_JPRB, 0.88282943E-10_JPRB, 0.88280931E-10_JPRB, 0.88279148E-10_JPRB, 0.88278107E-10_JPRB, 0.88277469E-10_JPRB, &
  & 0.88278086E-10_JPRB, 0.88278301E-10_JPRB, 0.88279092E-10_JPRB, 0.88281091E-10_JPRB, 0.88281882E-10_JPRB, 0.88281431E-10_JPRB, &
  & 0.88281826E-10_JPRB, 0.88281327E-10_JPRB, 0.88281611E-10_JPRB, 0.88282152E-10_JPRB, 0.88280425E-10_JPRB, 0.88279960E-10_JPRB, &
  & 0.88279148E-10_JPRB, 0.88278385E-10_JPRB, 0.88277073E-10_JPRB, 0.88275727E-10_JPRB, 0.88273937E-10_JPRB, 0.88272667E-10_JPRB, &
  & 0.88272008E-10_JPRB, 0.88271709E-10_JPRB, 0.88269850E-10_JPRB, 0.88271314E-10_JPRB /)

RGHG9(:,83, 5) = (/ &
  & 0.88253863E-10_JPRB, 0.88254987E-10_JPRB, 0.88260413E-10_JPRB, 0.88262425E-10_JPRB, 0.88265124E-10_JPRB, 0.88266637E-10_JPRB, &
  & 0.88269114E-10_JPRB, 0.88271099E-10_JPRB, 0.88272438E-10_JPRB, 0.88274055E-10_JPRB, 0.88274853E-10_JPRB, 0.88275699E-10_JPRB, &
  & 0.88274624E-10_JPRB, 0.88276032E-10_JPRB, 0.88276900E-10_JPRB, 0.88277774E-10_JPRB, 0.88278183E-10_JPRB, 0.88276789E-10_JPRB, &
  & 0.88274693E-10_JPRB, 0.88274221E-10_JPRB, 0.88273951E-10_JPRB, 0.88274221E-10_JPRB, 0.88275887E-10_JPRB, 0.88279301E-10_JPRB, &
  & 0.88283339E-10_JPRB, 0.88285934E-10_JPRB, 0.88288925E-10_JPRB, 0.88290035E-10_JPRB, 0.88291471E-10_JPRB, 0.88292269E-10_JPRB, &
  & 0.88292963E-10_JPRB, 0.88293005E-10_JPRB, 0.88293095E-10_JPRB, 0.88291242E-10_JPRB, 0.88290153E-10_JPRB, 0.88288717E-10_JPRB, &
  & 0.88286295E-10_JPRB, 0.88283540E-10_JPRB, 0.88281618E-10_JPRB, 0.88279911E-10_JPRB, 0.88278870E-10_JPRB, 0.88278246E-10_JPRB, &
  & 0.88278780E-10_JPRB, 0.88278974E-10_JPRB, 0.88279710E-10_JPRB, 0.88281736E-10_JPRB, 0.88282520E-10_JPRB, 0.88282000E-10_JPRB, &
  & 0.88282381E-10_JPRB, 0.88281875E-10_JPRB, 0.88282173E-10_JPRB, 0.88282770E-10_JPRB, 0.88281008E-10_JPRB, 0.88280563E-10_JPRB, &
  & 0.88279800E-10_JPRB, 0.88279106E-10_JPRB, 0.88277816E-10_JPRB, 0.88276504E-10_JPRB, 0.88274742E-10_JPRB, 0.88273486E-10_JPRB, &
  & 0.88272854E-10_JPRB, 0.88272605E-10_JPRB, 0.88270682E-10_JPRB, 0.88272015E-10_JPRB /)

RGHG9(:,84, 5) = (/ &
  & 0.88254494E-10_JPRB, 0.88255653E-10_JPRB, 0.88261093E-10_JPRB, 0.88263043E-10_JPRB, 0.88265749E-10_JPRB, 0.88267067E-10_JPRB, &
  & 0.88270037E-10_JPRB, 0.88271279E-10_JPRB, 0.88273389E-10_JPRB, 0.88274284E-10_JPRB, 0.88275456E-10_JPRB, 0.88276039E-10_JPRB, &
  & 0.88275186E-10_JPRB, 0.88276483E-10_JPRB, 0.88277274E-10_JPRB, 0.88278197E-10_JPRB, 0.88278655E-10_JPRB, 0.88277295E-10_JPRB, &
  & 0.88275220E-10_JPRB, 0.88274762E-10_JPRB, 0.88274485E-10_JPRB, 0.88274686E-10_JPRB, 0.88276324E-10_JPRB, 0.88279731E-10_JPRB, &
  & 0.88283762E-10_JPRB, 0.88286274E-10_JPRB, 0.88289195E-10_JPRB, 0.88290257E-10_JPRB, 0.88291631E-10_JPRB, 0.88292394E-10_JPRB, &
  & 0.88293116E-10_JPRB, 0.88293158E-10_JPRB, 0.88293262E-10_JPRB, 0.88291409E-10_JPRB, 0.88290368E-10_JPRB, 0.88288932E-10_JPRB, &
  & 0.88286545E-10_JPRB, 0.88283922E-10_JPRB, 0.88282034E-10_JPRB, 0.88280425E-10_JPRB, 0.88279412E-10_JPRB, 0.88278787E-10_JPRB, &
  & 0.88279210E-10_JPRB, 0.88279391E-10_JPRB, 0.88280085E-10_JPRB, 0.88282111E-10_JPRB, 0.88282909E-10_JPRB, 0.88282368E-10_JPRB, &
  & 0.88282749E-10_JPRB, 0.88282201E-10_JPRB, 0.88282506E-10_JPRB, 0.88283159E-10_JPRB, 0.88281348E-10_JPRB, 0.88280938E-10_JPRB, &
  & 0.88280203E-10_JPRB, 0.88279543E-10_JPRB, 0.88278260E-10_JPRB, 0.88277011E-10_JPRB, 0.88275220E-10_JPRB, 0.88273985E-10_JPRB, &
  & 0.88273368E-10_JPRB, 0.88273153E-10_JPRB, 0.88271217E-10_JPRB, 0.88272500E-10_JPRB /)

RGHG9(:,85, 5) = (/ &
  & 0.88254903E-10_JPRB, 0.88256069E-10_JPRB, 0.88261537E-10_JPRB, 0.88263466E-10_JPRB, 0.88266165E-10_JPRB, 0.88267824E-10_JPRB, &
  & 0.88270127E-10_JPRB, 0.88272181E-10_JPRB, 0.88273347E-10_JPRB, 0.88274846E-10_JPRB, 0.88275477E-10_JPRB, 0.88276206E-10_JPRB, &
  & 0.88275748E-10_JPRB, 0.88276789E-10_JPRB, 0.88277545E-10_JPRB, 0.88278385E-10_JPRB, 0.88278884E-10_JPRB, 0.88277663E-10_JPRB, &
  & 0.88275595E-10_JPRB, 0.88275123E-10_JPRB, 0.88274811E-10_JPRB, 0.88274978E-10_JPRB, 0.88276574E-10_JPRB, 0.88279981E-10_JPRB, &
  & 0.88284033E-10_JPRB, 0.88286455E-10_JPRB, 0.88289417E-10_JPRB, 0.88290375E-10_JPRB, 0.88291742E-10_JPRB, 0.88292477E-10_JPRB, &
  & 0.88293206E-10_JPRB, 0.88293241E-10_JPRB, 0.88293366E-10_JPRB, 0.88291513E-10_JPRB, 0.88290500E-10_JPRB, 0.88289057E-10_JPRB, &
  & 0.88286718E-10_JPRB, 0.88284102E-10_JPRB, 0.88282298E-10_JPRB, 0.88280737E-10_JPRB, 0.88279759E-10_JPRB, 0.88279148E-10_JPRB, &
  & 0.88279495E-10_JPRB, 0.88279654E-10_JPRB, 0.88280341E-10_JPRB, 0.88282305E-10_JPRB, 0.88283138E-10_JPRB, 0.88282597E-10_JPRB, &
  & 0.88282971E-10_JPRB, 0.88282409E-10_JPRB, 0.88282735E-10_JPRB, 0.88283422E-10_JPRB, 0.88281583E-10_JPRB, 0.88281188E-10_JPRB, &
  & 0.88280466E-10_JPRB, 0.88279849E-10_JPRB, 0.88278572E-10_JPRB, 0.88277302E-10_JPRB, 0.88275547E-10_JPRB, 0.88274277E-10_JPRB, &
  & 0.88273708E-10_JPRB, 0.88273534E-10_JPRB, 0.88271578E-10_JPRB, 0.88272813E-10_JPRB /)

RGHG9(:,86, 5) = (/ &
  & 0.88255160E-10_JPRB, 0.88256361E-10_JPRB, 0.88261815E-10_JPRB, 0.88263709E-10_JPRB, 0.88266547E-10_JPRB, 0.88267935E-10_JPRB, &
  & 0.88270946E-10_JPRB, 0.88272181E-10_JPRB, 0.88273978E-10_JPRB, 0.88274769E-10_JPRB, 0.88275852E-10_JPRB, 0.88276275E-10_JPRB, &
  & 0.88276116E-10_JPRB, 0.88276900E-10_JPRB, 0.88277607E-10_JPRB, 0.88278405E-10_JPRB, 0.88278884E-10_JPRB, 0.88277885E-10_JPRB, &
  & 0.88275887E-10_JPRB, 0.88275394E-10_JPRB, 0.88275047E-10_JPRB, 0.88275165E-10_JPRB, 0.88276740E-10_JPRB, 0.88280140E-10_JPRB, &
  & 0.88284213E-10_JPRB, 0.88286621E-10_JPRB, 0.88289528E-10_JPRB, 0.88290472E-10_JPRB, 0.88291818E-10_JPRB, 0.88292533E-10_JPRB, &
  & 0.88293262E-10_JPRB, 0.88293303E-10_JPRB, 0.88293442E-10_JPRB, 0.88291582E-10_JPRB, 0.88290611E-10_JPRB, 0.88289209E-10_JPRB, &
  & 0.88286808E-10_JPRB, 0.88284283E-10_JPRB, 0.88282437E-10_JPRB, 0.88280917E-10_JPRB, 0.88279925E-10_JPRB, 0.88279342E-10_JPRB, &
  & 0.88279675E-10_JPRB, 0.88279828E-10_JPRB, 0.88280473E-10_JPRB, 0.88282479E-10_JPRB, 0.88283256E-10_JPRB, 0.88282749E-10_JPRB, &
  & 0.88283117E-10_JPRB, 0.88282541E-10_JPRB, 0.88282867E-10_JPRB, 0.88283582E-10_JPRB, 0.88281708E-10_JPRB, 0.88281313E-10_JPRB, &
  & 0.88280612E-10_JPRB, 0.88280029E-10_JPRB, 0.88278759E-10_JPRB, 0.88277510E-10_JPRB, 0.88275734E-10_JPRB, 0.88274499E-10_JPRB, &
  & 0.88273923E-10_JPRB, 0.88273777E-10_JPRB, 0.88271793E-10_JPRB, 0.88273007E-10_JPRB /)

RGHG9(:,87, 5) = (/ &
  & 0.88255347E-10_JPRB, 0.88256617E-10_JPRB, 0.88261960E-10_JPRB, 0.88263959E-10_JPRB, 0.88266686E-10_JPRB, 0.88268698E-10_JPRB, &
  & 0.88270856E-10_JPRB, 0.88272806E-10_JPRB, 0.88273874E-10_JPRB, 0.88275144E-10_JPRB, 0.88275678E-10_JPRB, 0.88276331E-10_JPRB, &
  & 0.88276317E-10_JPRB, 0.88277094E-10_JPRB, 0.88277677E-10_JPRB, 0.88278385E-10_JPRB, 0.88278815E-10_JPRB, 0.88277947E-10_JPRB, &
  & 0.88276136E-10_JPRB, 0.88275560E-10_JPRB, 0.88275200E-10_JPRB, 0.88275283E-10_JPRB, 0.88276816E-10_JPRB, 0.88280244E-10_JPRB, &
  & 0.88284310E-10_JPRB, 0.88286663E-10_JPRB, 0.88289633E-10_JPRB, 0.88290521E-10_JPRB, 0.88291860E-10_JPRB, 0.88292568E-10_JPRB, &
  & 0.88293317E-10_JPRB, 0.88293331E-10_JPRB, 0.88293504E-10_JPRB, 0.88291624E-10_JPRB, 0.88290736E-10_JPRB, 0.88289376E-10_JPRB, &
  & 0.88287072E-10_JPRB, 0.88284331E-10_JPRB, 0.88282548E-10_JPRB, 0.88280952E-10_JPRB, 0.88279953E-10_JPRB, 0.88279328E-10_JPRB, &
  & 0.88279745E-10_JPRB, 0.88279890E-10_JPRB, 0.88280584E-10_JPRB, 0.88282576E-10_JPRB, 0.88283367E-10_JPRB, 0.88282839E-10_JPRB, &
  & 0.88283186E-10_JPRB, 0.88282617E-10_JPRB, 0.88282937E-10_JPRB, 0.88283658E-10_JPRB, 0.88281805E-10_JPRB, 0.88281410E-10_JPRB, &
  & 0.88280702E-10_JPRB, 0.88280126E-10_JPRB, 0.88278884E-10_JPRB, 0.88277614E-10_JPRB, 0.88275859E-10_JPRB, 0.88274624E-10_JPRB, &
  & 0.88274055E-10_JPRB, 0.88273923E-10_JPRB, 0.88271918E-10_JPRB, 0.88273139E-10_JPRB /)

RGHG9(:,88, 5) = (/ &
  & 0.88255521E-10_JPRB, 0.88256992E-10_JPRB, 0.88261960E-10_JPRB, 0.88263973E-10_JPRB, 0.88266935E-10_JPRB, 0.88268490E-10_JPRB, &
  & 0.88271418E-10_JPRB, 0.88272722E-10_JPRB, 0.88274332E-10_JPRB, 0.88275082E-10_JPRB, 0.88275984E-10_JPRB, 0.88276345E-10_JPRB, &
  & 0.88276463E-10_JPRB, 0.88277038E-10_JPRB, 0.88277677E-10_JPRB, 0.88278357E-10_JPRB, 0.88278815E-10_JPRB, 0.88278058E-10_JPRB, &
  & 0.88276234E-10_JPRB, 0.88275671E-10_JPRB, 0.88275276E-10_JPRB, 0.88275338E-10_JPRB, 0.88276865E-10_JPRB, 0.88280279E-10_JPRB, &
  & 0.88284380E-10_JPRB, 0.88286718E-10_JPRB, 0.88289688E-10_JPRB, 0.88290542E-10_JPRB, 0.88291895E-10_JPRB, 0.88292595E-10_JPRB, &
  & 0.88293345E-10_JPRB, 0.88293352E-10_JPRB, 0.88293560E-10_JPRB, 0.88291659E-10_JPRB, 0.88290826E-10_JPRB, 0.88289584E-10_JPRB, &
  & 0.88287225E-10_JPRB, 0.88284477E-10_JPRB, 0.88282603E-10_JPRB, 0.88280890E-10_JPRB, 0.88279863E-10_JPRB, 0.88279169E-10_JPRB, &
  & 0.88279759E-10_JPRB, 0.88279890E-10_JPRB, 0.88280570E-10_JPRB, 0.88282742E-10_JPRB, 0.88283436E-10_JPRB, 0.88282895E-10_JPRB, &
  & 0.88283214E-10_JPRB, 0.88282666E-10_JPRB, 0.88282978E-10_JPRB, 0.88283686E-10_JPRB, 0.88281854E-10_JPRB, 0.88281445E-10_JPRB, &
  & 0.88280758E-10_JPRB, 0.88280203E-10_JPRB, 0.88278967E-10_JPRB, 0.88277705E-10_JPRB, 0.88275900E-10_JPRB, 0.88274693E-10_JPRB, &
  & 0.88274138E-10_JPRB, 0.88274034E-10_JPRB, 0.88271987E-10_JPRB, 0.88273215E-10_JPRB /)

RGHG9(:,89, 5) = (/ &
  & 0.88255799E-10_JPRB, 0.88257394E-10_JPRB, 0.88261870E-10_JPRB, 0.88263986E-10_JPRB, 0.88266776E-10_JPRB, 0.88268767E-10_JPRB, &
  & 0.88271071E-10_JPRB, 0.88272986E-10_JPRB, 0.88274166E-10_JPRB, 0.88275345E-10_JPRB, 0.88275866E-10_JPRB, 0.88276393E-10_JPRB, &
  & 0.88276421E-10_JPRB, 0.88277136E-10_JPRB, 0.88277712E-10_JPRB, 0.88278454E-10_JPRB, 0.88278954E-10_JPRB, 0.88278107E-10_JPRB, &
  & 0.88276213E-10_JPRB, 0.88275699E-10_JPRB, 0.88275325E-10_JPRB, 0.88275345E-10_JPRB, 0.88276879E-10_JPRB, 0.88280307E-10_JPRB, &
  & 0.88284428E-10_JPRB, 0.88286746E-10_JPRB, 0.88289730E-10_JPRB, 0.88290555E-10_JPRB, 0.88291915E-10_JPRB, 0.88292595E-10_JPRB, &
  & 0.88293366E-10_JPRB, 0.88293373E-10_JPRB, 0.88293602E-10_JPRB, 0.88291659E-10_JPRB, 0.88290882E-10_JPRB, 0.88289723E-10_JPRB, &
  & 0.88287433E-10_JPRB, 0.88284505E-10_JPRB, 0.88282659E-10_JPRB, 0.88280841E-10_JPRB, 0.88279772E-10_JPRB, 0.88278974E-10_JPRB, &
  & 0.88279842E-10_JPRB, 0.88279890E-10_JPRB, 0.88280598E-10_JPRB, 0.88282846E-10_JPRB, 0.88283499E-10_JPRB, 0.88282930E-10_JPRB, &
  & 0.88283242E-10_JPRB, 0.88282701E-10_JPRB, 0.88282992E-10_JPRB, 0.88283700E-10_JPRB, 0.88281861E-10_JPRB, 0.88281465E-10_JPRB, &
  & 0.88280779E-10_JPRB, 0.88280230E-10_JPRB, 0.88279009E-10_JPRB, 0.88277753E-10_JPRB, 0.88275928E-10_JPRB, 0.88274735E-10_JPRB, &
  & 0.88274180E-10_JPRB, 0.88274089E-10_JPRB, 0.88272001E-10_JPRB, 0.88273257E-10_JPRB /)

RGHG9(:,90, 5) = (/ &
  & 0.88256083E-10_JPRB, 0.88257825E-10_JPRB, 0.88261606E-10_JPRB, 0.88263820E-10_JPRB, 0.88266748E-10_JPRB, 0.88268150E-10_JPRB, &
  & 0.88271099E-10_JPRB, 0.88272611E-10_JPRB, 0.88274402E-10_JPRB, 0.88275325E-10_JPRB, 0.88276129E-10_JPRB, 0.88276442E-10_JPRB, &
  & 0.88276358E-10_JPRB, 0.88277059E-10_JPRB, 0.88277753E-10_JPRB, 0.88278634E-10_JPRB, 0.88279238E-10_JPRB, 0.88278260E-10_JPRB, &
  & 0.88276060E-10_JPRB, 0.88275692E-10_JPRB, 0.88275331E-10_JPRB, 0.88275325E-10_JPRB, 0.88276844E-10_JPRB, 0.88280307E-10_JPRB, &
  & 0.88284505E-10_JPRB, 0.88286760E-10_JPRB, 0.88289827E-10_JPRB, 0.88290548E-10_JPRB, 0.88291936E-10_JPRB, 0.88292609E-10_JPRB, &
  & 0.88293393E-10_JPRB, 0.88293380E-10_JPRB, 0.88293706E-10_JPRB, 0.88291617E-10_JPRB, 0.88290916E-10_JPRB, 0.88289813E-10_JPRB, &
  & 0.88287537E-10_JPRB, 0.88284532E-10_JPRB, 0.88282721E-10_JPRB, 0.88280772E-10_JPRB, 0.88279738E-10_JPRB, 0.88278766E-10_JPRB, &
  & 0.88279918E-10_JPRB, 0.88279842E-10_JPRB, 0.88280543E-10_JPRB, 0.88282950E-10_JPRB, 0.88283582E-10_JPRB, 0.88282930E-10_JPRB, &
  & 0.88283277E-10_JPRB, 0.88282687E-10_JPRB, 0.88282992E-10_JPRB, 0.88283790E-10_JPRB, 0.88281854E-10_JPRB, 0.88281472E-10_JPRB, &
  & 0.88280785E-10_JPRB, 0.88280272E-10_JPRB, 0.88279023E-10_JPRB, 0.88277781E-10_JPRB, 0.88275921E-10_JPRB, 0.88274721E-10_JPRB, &
  & 0.88274187E-10_JPRB, 0.88274145E-10_JPRB, 0.88271938E-10_JPRB, 0.88273291E-10_JPRB /)

RGHG9(:,91, 5) = (/ &
  & 0.88256180E-10_JPRB, 0.88257970E-10_JPRB, 0.88260975E-10_JPRB, 0.88263813E-10_JPRB, 0.88266817E-10_JPRB, 0.88267699E-10_JPRB, &
  & 0.88270655E-10_JPRB, 0.88271876E-10_JPRB, 0.88273992E-10_JPRB, 0.88275380E-10_JPRB, 0.88276969E-10_JPRB, 0.88277149E-10_JPRB, &
  & 0.88274978E-10_JPRB, 0.88277489E-10_JPRB, 0.88277878E-10_JPRB, 0.88278954E-10_JPRB, 0.88279807E-10_JPRB, 0.88278378E-10_JPRB, &
  & 0.88275748E-10_JPRB, 0.88275685E-10_JPRB, 0.88275290E-10_JPRB, 0.88275200E-10_JPRB, 0.88276705E-10_JPRB, 0.88280258E-10_JPRB, &
  & 0.88284637E-10_JPRB, 0.88286697E-10_JPRB, 0.88289986E-10_JPRB, 0.88290507E-10_JPRB, 0.88291985E-10_JPRB, 0.88292595E-10_JPRB, &
  & 0.88293470E-10_JPRB, 0.88293366E-10_JPRB, 0.88293914E-10_JPRB, 0.88291485E-10_JPRB, 0.88290951E-10_JPRB, 0.88289917E-10_JPRB, &
  & 0.88287613E-10_JPRB, 0.88284442E-10_JPRB, 0.88282756E-10_JPRB, 0.88280695E-10_JPRB, 0.88279724E-10_JPRB, 0.88278551E-10_JPRB, &
  & 0.88280036E-10_JPRB, 0.88279759E-10_JPRB, 0.88280425E-10_JPRB, 0.88283103E-10_JPRB, 0.88283783E-10_JPRB, 0.88282825E-10_JPRB, &
  & 0.88283360E-10_JPRB, 0.88282576E-10_JPRB, 0.88282937E-10_JPRB, 0.88284033E-10_JPRB, 0.88281708E-10_JPRB, 0.88281500E-10_JPRB, &
  & 0.88280785E-10_JPRB, 0.88280321E-10_JPRB, 0.88279037E-10_JPRB, 0.88277816E-10_JPRB, 0.88275852E-10_JPRB, 0.88274665E-10_JPRB, &
  & 0.88274152E-10_JPRB, 0.88274235E-10_JPRB, 0.88271807E-10_JPRB, 0.88273319E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART10',1,ZHOOK_HANDLE)
END SUBROUTINE PART10






SUBROUTINE PART11
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART11',0,ZHOOK_HANDLE)



!-- Month=  6 ------------

RGHG9(:, 1, 6) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.42038954E-44_JPRB, 0.56051939E-44_JPRB, &
  & 0.98090893E-44_JPRB, 0.15414283E-43_JPRB, 0.22420775E-43_JPRB, 0.32229865E-43_JPRB, 0.42038954E-43_JPRB, 0.50446745E-43_JPRB, &
  & 0.57453237E-43_JPRB, 0.54650640E-43_JPRB, 0.54650640E-43_JPRB, 0.37835059E-43_JPRB, 0.30828566E-43_JPRB, 0.25223372E-43_JPRB, &
  & 0.21019477E-43_JPRB, 0.12611686E-43_JPRB, 0.70064923E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 2, 6) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.28025969E-44_JPRB, 0.42038954E-44_JPRB, 0.84077908E-44_JPRB, &
  & 0.15414283E-43_JPRB, 0.28025969E-43_JPRB, 0.49045446E-43_JPRB, 0.85479206E-43_JPRB, 0.14573504E-42_JPRB, 0.24102334E-42_JPRB, &
  & 0.39096227E-42_JPRB, 0.61096613E-42_JPRB, 0.91224530E-42_JPRB, 0.12639712E-41_JPRB, 0.16535322E-41_JPRB, 0.19688243E-41_JPRB, &
  & 0.22532879E-41_JPRB, 0.21958347E-41_JPRB, 0.21187633E-41_JPRB, 0.15400270E-41_JPRB, 0.11812946E-41_JPRB, 0.96969854E-42_JPRB, &
  & 0.86880505E-42_JPRB, 0.53109212E-42_JPRB, 0.28306229E-42_JPRB, 0.14012985E-42_JPRB, 0.60255834E-43_JPRB, 0.26624671E-43_JPRB, &
  & 0.11210388E-43_JPRB, 0.42038954E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 3, 6) = (/ &
  & 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.56051939E-44_JPRB, &
  & 0.12611686E-43_JPRB, 0.25223372E-43_JPRB, 0.51848043E-43_JPRB, 0.10509738E-42_JPRB, 0.20879347E-42_JPRB, 0.40217266E-42_JPRB, &
  & 0.75109598E-42_JPRB, 0.13592595E-41_JPRB, 0.24004243E-41_JPRB, 0.41520473E-41_JPRB, 0.70303144E-41_JPRB, 0.11639185E-40_JPRB, &
  & 0.18757781E-40_JPRB, 0.29030700E-40_JPRB, 0.42911963E-40_JPRB, 0.59263715E-40_JPRB, 0.77411931E-40_JPRB, 0.92470284E-40_JPRB, &
  & 0.10576721E-39_JPRB, 0.10385303E-39_JPRB, 0.99863535E-40_JPRB, 0.73509315E-40_JPRB, 0.56505959E-40_JPRB, 0.46347947E-40_JPRB, &
  & 0.40815620E-40_JPRB, 0.25526053E-40_JPRB, 0.13921900E-40_JPRB, 0.68719677E-41_JPRB, 0.28726619E-41_JPRB, 0.11967089E-41_JPRB, &
  & 0.48905316E-42_JPRB, 0.20038568E-42_JPRB, 0.84077908E-43_JPRB, 0.35032462E-43_JPRB, 0.12611686E-43_JPRB, 0.42038954E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 4, 6) = (/ &
  & 0.33631163E-43_JPRB, 0.11070258E-42_JPRB, 0.13872855E-42_JPRB, 0.13592595E-42_JPRB, 0.12331426E-42_JPRB, 0.11350518E-42_JPRB, &
  & 0.10789998E-42_JPRB, 0.11210388E-42_JPRB, 0.13312335E-42_JPRB, 0.18637270E-42_JPRB, 0.29847657E-42_JPRB, 0.53949991E-42_JPRB, &
  & 0.10593816E-41_JPRB, 0.21762165E-41_JPRB, 0.45205888E-41_JPRB, 0.92962140E-41_JPRB, 0.18582619E-40_JPRB, 0.35936299E-40_JPRB, &
  & 0.67223090E-40_JPRB, 0.12213437E-39_JPRB, 0.21610545E-39_JPRB, 0.37343903E-39_JPRB, 0.62909333E-39_JPRB, 0.10345716E-38_JPRB, &
  & 0.16505082E-38_JPRB, 0.25367650E-38_JPRB, 0.37279934E-38_JPRB, 0.51420241E-38_JPRB, 0.67228303E-38_JPRB, 0.80416091E-38_JPRB, &
  & 0.92174050E-38_JPRB, 0.90628221E-38_JPRB, 0.87296116E-38_JPRB, 0.64312509E-38_JPRB, 0.49588926E-38_JPRB, 0.40748610E-38_JPRB, &
  & 0.35884801E-38_JPRB, 0.22681865E-38_JPRB, 0.12606319E-38_JPRB, 0.62520613E-39_JPRB, 0.25593736E-39_JPRB, 0.10282168E-39_JPRB, &
  & 0.39998663E-40_JPRB, 0.15917349E-40_JPRB, 0.66169313E-41_JPRB, 0.28992865E-41_JPRB, 0.10775985E-41_JPRB, 0.34191683E-42_JPRB, &
  & 0.10229479E-42_JPRB, 0.32229865E-43_JPRB, 0.14012985E-43_JPRB, 0.56051939E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 5, 6) = (/ &
  & 0.25255602E-40_JPRB, 0.34344424E-40_JPRB, 0.35363168E-40_JPRB, 0.32229865E-40_JPRB, 0.28849933E-40_JPRB, 0.26219696E-40_JPRB, &
  & 0.24877252E-40_JPRB, 0.25691406E-40_JPRB, 0.30185370E-40_JPRB, 0.41408370E-40_JPRB, 0.65265476E-40_JPRB, 0.11638204E-39_JPRB, &
  & 0.22591454E-39_JPRB, 0.45826383E-39_JPRB, 0.93906055E-39_JPRB, 0.19032029E-38_JPRB, 0.37469208E-38_JPRB, 0.71334416E-38_JPRB, &
  & 0.13130807E-37_JPRB, 0.23458671E-37_JPRB, 0.40751612E-37_JPRB, 0.69014028E-37_JPRB, 0.11379144E-36_JPRB, 0.18303189E-36_JPRB, &
  & 0.28657482E-36_JPRB, 0.43348632E-36_JPRB, 0.63108716E-36_JPRB, 0.86587214E-36_JPRB, 0.11298852E-35_JPRB, 0.13492037E-35_JPRB, &
  & 0.15462391E-35_JPRB, 0.15179258E-35_JPRB, 0.14660780E-35_JPRB, 0.10812652E-35_JPRB, 0.83769048E-36_JPRB, 0.69548492E-36_JPRB, &
  & 0.61821818E-36_JPRB, 0.39676217E-36_JPRB, 0.22425251E-36_JPRB, 0.11326387E-36_JPRB, 0.46706690E-37_JPRB, 0.18641712E-37_JPRB, &
  & 0.72433958E-38_JPRB, 0.28971243E-38_JPRB, 0.12341544E-38_JPRB, 0.55987899E-39_JPRB, 0.21354387E-39_JPRB, 0.69145671E-40_JPRB, &
  & 0.21034891E-40_JPRB, 0.68831781E-41_JPRB, 0.29006878E-41_JPRB, 0.13438452E-41_JPRB, 0.65020249E-42_JPRB, 0.32790384E-42_JPRB, &
  & 0.17796490E-42_JPRB, 0.10369609E-42_JPRB, 0.65861028E-43_JPRB, 0.44841551E-43_JPRB, 0.51848043E-43_JPRB, 0.81275311E-43_JPRB, &
  & 0.96689594E-43_JPRB, 0.15694543E-42_JPRB, 0.22420775E-42_JPRB, 0.22280646E-42_JPRB /)

RGHG9(:, 6, 6) = (/ &
  & 0.22870674E-37_JPRB, 0.21563712E-37_JPRB, 0.19475207E-37_JPRB, 0.17295368E-37_JPRB, 0.15316726E-37_JPRB, 0.13787119E-37_JPRB, &
  & 0.12926261E-37_JPRB, 0.13126644E-37_JPRB, 0.15088177E-37_JPRB, 0.20120952E-37_JPRB, 0.30734405E-37_JPRB, 0.52946661E-37_JPRB, &
  & 0.99104356E-37_JPRB, 0.19336408E-36_JPRB, 0.38040796E-36_JPRB, 0.73826851E-36_JPRB, 0.13895169E-35_JPRB, 0.25255095E-35_JPRB, &
  & 0.44369470E-35_JPRB, 0.75724035E-35_JPRB, 0.12590705E-34_JPRB, 0.20461801E-34_JPRB, 0.32468394E-34_JPRB, 0.50431486E-34_JPRB, &
  & 0.76512589E-34_JPRB, 0.11277826E-33_JPRB, 0.16086530E-33_JPRB, 0.21737150E-33_JPRB, 0.28075888E-33_JPRB, 0.33242060E-33_JPRB, &
  & 0.37949384E-33_JPRB, 0.37121033E-33_JPRB, 0.35975309E-33_JPRB, 0.26627183E-33_JPRB, 0.20890449E-33_JPRB, 0.17628725E-33_JPRB, &
  & 0.16037568E-33_JPRB, 0.10483734E-33_JPRB, 0.60732025E-34_JPRB, 0.31528076E-34_JPRB, 0.13298781E-34_JPRB, 0.55119819E-35_JPRB, &
  & 0.22205330E-35_JPRB, 0.93449299E-36_JPRB, 0.42026205E-36_JPRB, 0.20111429E-36_JPRB, 0.80466638E-37_JPRB, 0.27253223E-37_JPRB, &
  & 0.86066084E-38_JPRB, 0.29329345E-38_JPRB, 0.12957681E-38_JPRB, 0.62689049E-39_JPRB, 0.31543649E-39_JPRB, 0.16536723E-39_JPRB, &
  & 0.92921502E-40_JPRB, 0.55508235E-40_JPRB, 0.35969930E-40_JPRB, 0.25006171E-40_JPRB, 0.27405194E-40_JPRB, 0.42229531E-40_JPRB, &
  & 0.48291548E-40_JPRB, 0.74536467E-40_JPRB, 0.10108827E-39_JPRB, 0.75588842E-40_JPRB /)

RGHG9(:, 7, 6) = (/ &
  & 0.17818005E-34_JPRB, 0.15715521E-34_JPRB, 0.13952551E-34_JPRB, 0.12287152E-34_JPRB, 0.10776936E-34_JPRB, 0.95797918E-35_JPRB, &
  & 0.88213526E-35_JPRB, 0.87421366E-35_JPRB, 0.97248919E-35_JPRB, 0.12455726E-34_JPRB, 0.18142274E-34_JPRB, 0.29663916E-34_JPRB, &
  & 0.52496263E-34_JPRB, 0.96648698E-34_JPRB, 0.17890716E-33_JPRB, 0.32646837E-33_JPRB, 0.57663944E-33_JPRB, 0.98321828E-33_JPRB, &
  & 0.16217928E-32_JPRB, 0.26063654E-32_JPRB, 0.41004839E-32_JPRB, 0.63436508E-32_JPRB, 0.96369275E-32_JPRB, 0.14401979E-31_JPRB, &
  & 0.21111560E-31_JPRB, 0.30181129E-31_JPRB, 0.41951095E-31_JPRB, 0.55497727E-31_JPRB, 0.70546859E-31_JPRB, 0.82573476E-31_JPRB, &
  & 0.93644353E-31_JPRB, 0.91357999E-31_JPRB, 0.88807934E-31_JPRB, 0.66258067E-31_JPRB, 0.52658573E-31_JPRB, 0.45356276E-31_JPRB, &
  & 0.42485164E-31_JPRB, 0.28348019E-31_JPRB, 0.16835578E-31_JPRB, 0.89934950E-32_JPRB, 0.39121646E-32_JPRB, 0.16949380E-32_JPRB, &
  & 0.72699821E-33_JPRB, 0.32750253E-33_JPRB, 0.15825544E-33_JPRB, 0.81325578E-34_JPRB, 0.34701687E-34_JPRB, 0.12502246E-34_JPRB, &
  & 0.42016720E-35_JPRB, 0.15291729E-35_JPRB, 0.72770564E-36_JPRB, 0.37648643E-36_JPRB, 0.20123913E-36_JPRB, 0.11151479E-36_JPRB, &
  & 0.65875848E-37_JPRB, 0.41091390E-37_JPRB, 0.27508419E-37_JPRB, 0.19271029E-37_JPRB, 0.20940720E-37_JPRB, 0.31283475E-37_JPRB, &
  & 0.34147710E-37_JPRB, 0.51480589E-37_JPRB, 0.70301205E-37_JPRB, 0.72777871E-37_JPRB /)

RGHG9(:, 8, 6) = (/ &
  & 0.11358468E-31_JPRB, 0.99458834E-32_JPRB, 0.87880398E-32_JPRB, 0.76948110E-32_JPRB, 0.67014757E-32_JPRB, 0.58833250E-32_JPRB, &
  & 0.53351126E-32_JPRB, 0.51662198E-32_JPRB, 0.55722043E-32_JPRB, 0.68621202E-32_JPRB, 0.95415442E-32_JPRB, 0.14805069E-31_JPRB, &
  & 0.24767449E-31_JPRB, 0.42945508E-31_JPRB, 0.74799562E-31_JPRB, 0.12815817E-30_JPRB, 0.21248640E-30_JPRB, 0.33990649E-30_JPRB, &
  & 0.52655715E-30_JPRB, 0.79692103E-30_JPRB, 0.11862536E-29_JPRB, 0.17468233E-29_JPRB, 0.25409587E-29_JPRB, 0.36538194E-29_JPRB, &
  & 0.51733036E-29_JPRB, 0.71669277E-29_JPRB, 0.96884989E-29_JPRB, 0.12521719E-28_JPRB, 0.15634222E-28_JPRB, 0.18080399E-28_JPRB, &
  & 0.20358969E-28_JPRB, 0.19833187E-28_JPRB, 0.19353997E-28_JPRB, 0.14560366E-28_JPRB, 0.11744346E-28_JPRB, 0.10322467E-28_JPRB, &
  & 0.99751315E-29_JPRB, 0.67978865E-29_JPRB, 0.41438779E-29_JPRB, 0.22869861E-29_JPRB, 0.10227116E-29_JPRB, 0.46742832E-30_JPRB, &
  & 0.21274866E-30_JPRB, 0.10286679E-30_JPRB, 0.53518448E-31_JPRB, 0.29574339E-31_JPRB, 0.13476355E-31_JPRB, 0.51730667E-32_JPRB, &
  & 0.18575625E-32_JPRB, 0.72936527E-33_JPRB, 0.37748809E-33_JPRB, 0.21035933E-33_JPRB, 0.12016833E-33_JPRB, 0.70745859E-34_JPRB, &
  & 0.44202953E-34_JPRB, 0.28955155E-34_JPRB, 0.20197815E-34_JPRB, 0.14557167E-34_JPRB, 0.15905938E-34_JPRB, 0.23640844E-34_JPRB, &
  & 0.25367544E-34_JPRB, 0.37903195E-34_JPRB, 0.54031942E-34_JPRB, 0.63761764E-34_JPRB /)

RGHG9(:, 9, 6) = (/ &
  & 0.58403047E-29_JPRB, 0.50963217E-29_JPRB, 0.44879716E-29_JPRB, 0.39161510E-29_JPRB, 0.33841395E-29_JPRB, 0.29539391E-29_JPRB, &
  & 0.26392368E-29_JPRB, 0.25101674E-29_JPRB, 0.26391236E-29_JPRB, 0.31441457E-29_JPRB, 0.42002170E-29_JPRB, 0.62250284E-29_JPRB, &
  & 0.98943635E-29_JPRB, 0.16251882E-28_JPRB, 0.26720033E-28_JPRB, 0.43206544E-28_JPRB, 0.67515605E-28_JPRB, 0.10183439E-27_JPRB, &
  & 0.14884125E-27_JPRB, 0.21299940E-27_JPRB, 0.30070960E-27_JPRB, 0.42195767E-27_JPRB, 0.58733829E-27_JPRB, 0.81174519E-27_JPRB, &
  & 0.11083007E-26_JPRB, 0.14850282E-26_JPRB, 0.19497410E-26_JPRB, 0.24580673E-26_JPRB, 0.30110401E-26_JPRB, 0.34372757E-26_JPRB, &
  & 0.38424976E-26_JPRB, 0.37394326E-26_JPRB, 0.36633576E-26_JPRB, 0.27840269E-26_JPRB, 0.22793949E-26_JPRB, 0.20460099E-26_JPRB, &
  & 0.20367782E-26_JPRB, 0.14223773E-26_JPRB, 0.89412954E-27_JPRB, 0.51131914E-27_JPRB, 0.23723037E-27_JPRB, 0.11409816E-27_JPRB, &
  & 0.55163063E-28_JPRB, 0.28502036E-28_JPRB, 0.15914769E-28_JPRB, 0.94553245E-29_JPRB, 0.45909927E-29_JPRB, 0.18736880E-29_JPRB, &
  & 0.71951389E-30_JPRB, 0.30532495E-30_JPRB, 0.17240836E-30_JPRB, 0.10356840E-30_JPRB, 0.63260851E-31_JPRB, 0.39598208E-31_JPRB, &
  & 0.26159569E-31_JPRB, 0.18025894E-31_JPRB, 0.13140831E-31_JPRB, 0.98221707E-32_JPRB, 0.11027320E-31_JPRB, 0.16534891E-31_JPRB, &
  & 0.17864074E-31_JPRB, 0.26961274E-31_JPRB, 0.39140632E-31_JPRB, 0.48840327E-31_JPRB /)

RGHG9(:,10, 6) = (/ &
  & 0.24053979E-26_JPRB, 0.20943296E-26_JPRB, 0.18398280E-26_JPRB, 0.15981443E-26_JPRB, 0.13798681E-26_JPRB, 0.11916812E-26_JPRB, &
  & 0.10579732E-26_JPRB, 0.99035025E-27_JPRB, 0.10200123E-26_JPRB, 0.11829002E-26_JPRB, 0.15283619E-26_JPRB, 0.21777177E-26_JPRB, &
  & 0.33111774E-26_JPRB, 0.51773565E-26_JPRB, 0.80834099E-26_JPRB, 0.12384917E-25_JPRB, 0.18334511E-25_JPRB, 0.26191338E-25_JPRB, &
  & 0.36289149E-25_JPRB, 0.49288146E-25_JPRB, 0.66185091E-25_JPRB, 0.88554715E-25_JPRB, 0.11790803E-24_JPRB, 0.15628403E-24_JPRB, &
  & 0.20530260E-24_JPRB, 0.26565068E-24_JPRB, 0.33815294E-24_JPRB, 0.41559682E-24_JPRB, 0.49902838E-24_JPRB, 0.56203593E-24_JPRB, &
  & 0.62342307E-24_JPRB, 0.60585829E-24_JPRB, 0.59608687E-24_JPRB, 0.45748223E-24_JPRB, 0.38063919E-24_JPRB, 0.34914639E-24_JPRB, &
  & 0.35732152E-24_JPRB, 0.25665910E-24_JPRB, 0.16696089E-24_JPRB, 0.99403648E-25_JPRB, 0.48065843E-25_JPRB, 0.24404184E-25_JPRB, &
  & 0.12503331E-25_JPRB, 0.68948523E-26_JPRB, 0.41253758E-26_JPRB, 0.26317005E-26_JPRB, 0.13615589E-26_JPRB, 0.59189855E-27_JPRB, &
  & 0.24305260E-27_JPRB, 0.11156260E-27_JPRB, 0.68602064E-28_JPRB, 0.44366980E-28_JPRB, 0.28955541E-28_JPRB, 0.19259042E-28_JPRB, &
  & 0.13450281E-28_JPRB, 0.97353758E-29_JPRB, 0.74167841E-29_JPRB, 0.57657584E-29_JPRB, 0.66829611E-29_JPRB, 0.10227295E-28_JPRB, &
  & 0.11227631E-28_JPRB, 0.17125158E-28_JPRB, 0.25209866E-28_JPRB, 0.32009500E-28_JPRB /)

RGHG9(:,11, 6) = (/ &
  & 0.81124666E-24_JPRB, 0.70484643E-24_JPRB, 0.61770856E-24_JPRB, 0.53599001E-24_JPRB, 0.45937205E-24_JPRB, 0.39659602E-24_JPRB, &
  & 0.34758348E-24_JPRB, 0.32173682E-24_JPRB, 0.32523934E-24_JPRB, 0.36790693E-24_JPRB, 0.46111750E-24_JPRB, 0.63392192E-24_JPRB, &
  & 0.92502569E-24_JPRB, 0.13827122E-23_JPRB, 0.20564766E-23_JPRB, 0.29977669E-23_JPRB, 0.42173703E-23_JPRB, 0.57282322E-23_JPRB, &
  & 0.75483536E-23_JPRB, 0.97633520E-23_JPRB, 0.12498090E-22_JPRB, 0.15973848E-22_JPRB, 0.20337798E-22_JPRB, 0.25846786E-22_JPRB, &
  & 0.32633749E-22_JPRB, 0.40727402E-22_JPRB, 0.50258029E-22_JPRB, 0.60182918E-22_JPRB, 0.70838517E-22_JPRB, 0.78660293E-22_JPRB, &
  & 0.86559934E-22_JPRB, 0.83939521E-22_JPRB, 0.82895839E-22_JPRB, 0.64259940E-22_JPRB, 0.54350756E-22_JPRB, 0.50990019E-22_JPRB, &
  & 0.53624511E-22_JPRB, 0.39715306E-22_JPRB, 0.26805105E-22_JPRB, 0.16644686E-22_JPRB, 0.84285662E-23_JPRB, 0.45173808E-23_JPRB, &
  & 0.24558374E-23_JPRB, 0.14443375E-23_JPRB, 0.92550157E-24_JPRB, 0.63317043E-24_JPRB, 0.34977821E-24_JPRB, 0.16212192E-24_JPRB, &
  & 0.71353782E-25_JPRB, 0.35354675E-25_JPRB, 0.23579512E-25_JPRB, 0.16365661E-25_JPRB, 0.11388598E-25_JPRB, 0.80324591E-26_JPRB, &
  & 0.59143568E-26_JPRB, 0.44849462E-26_JPRB, 0.35583235E-26_JPRB, 0.28690424E-26_JPRB, 0.34296533E-26_JPRB, 0.53577071E-26_JPRB, &
  & 0.59866030E-26_JPRB, 0.92384279E-26_JPRB, 0.13713637E-25_JPRB, 0.17545294E-25_JPRB /)

RGHG9(:,12, 6) = (/ &
  & 0.22740833E-21_JPRB, 0.19752190E-21_JPRB, 0.17276676E-21_JPRB, 0.14927755E-21_JPRB, 0.12781562E-21_JPRB, 0.10910133E-21_JPRB, &
  & 0.95133956E-22_JPRB, 0.86699183E-22_JPRB, 0.86018049E-22_JPRB, 0.94938489E-22_JPRB, 0.11548474E-21_JPRB, 0.15336085E-21_JPRB, &
  & 0.21531263E-21_JPRB, 0.30842003E-21_JPRB, 0.43845944E-21_JPRB, 0.60974813E-21_JPRB, 0.81797798E-21_JPRB, 0.10588648E-20_JPRB, &
  & 0.13308414E-20_JPRB, 0.16427308E-20_JPRB, 0.20089325E-20_JPRB, 0.24542429E-20_JPRB, 0.29922653E-20_JPRB, 0.36448029E-20_JPRB, &
  & 0.44242304E-20_JPRB, 0.53278804E-20_JPRB, 0.63707359E-20_JPRB, 0.74348229E-20_JPRB, 0.85741544E-20_JPRB, 0.93838697E-20_JPRB, &
  & 0.10234807E-19_JPRB, 0.98948928E-20_JPRB, 0.98028657E-20_JPRB, 0.76720630E-20_JPRB, 0.65996516E-20_JPRB, 0.63387771E-20_JPRB, &
  & 0.68559298E-20_JPRB, 0.52447851E-20_JPRB, 0.36785368E-20_JPRB, 0.23859401E-20_JPRB, 0.12672745E-20_JPRB, 0.71790311E-21_JPRB, &
  & 0.41426628E-21_JPRB, 0.25994562E-21_JPRB, 0.17830528E-21_JPRB, 0.13074987E-21_JPRB, 0.77152944E-22_JPRB, 0.38228963E-22_JPRB, &
  & 0.18029190E-22_JPRB, 0.96351668E-23_JPRB, 0.69420959E-23_JPRB, 0.51581406E-23_JPRB, 0.38190161E-23_JPRB, 0.28500272E-23_JPRB, &
  & 0.22065215E-23_JPRB, 0.17471068E-23_JPRB, 0.14379902E-23_JPRB, 0.11968038E-23_JPRB, 0.14687632E-23_JPRB, 0.23370846E-23_JPRB, &
  & 0.26485283E-23_JPRB, 0.41318239E-23_JPRB, 0.61803004E-23_JPRB, 0.79525565E-23_JPRB /)

RGHG9(:,13, 6) = (/ &
  & 0.53855090E-19_JPRB, 0.46672374E-19_JPRB, 0.40705687E-19_JPRB, 0.35055598E-19_JPRB, 0.29770741E-19_JPRB, 0.25311294E-19_JPRB, &
  & 0.21765004E-19_JPRB, 0.19590120E-19_JPRB, 0.19061335E-19_JPRB, 0.20525182E-19_JPRB, 0.24240198E-19_JPRB, 0.31131841E-19_JPRB, &
  & 0.42111222E-19_JPRB, 0.57965328E-19_JPRB, 0.78972684E-19_JPRB, 0.10508494E-18_JPRB, 0.13468672E-18_JPRB, 0.16653495E-18_JPRB, &
  & 0.19983686E-18_JPRB, 0.23556424E-18_JPRB, 0.27511639E-18_JPRB, 0.32128041E-18_JPRB, 0.37459091E-18_JPRB, 0.43753517E-18_JPRB, &
  & 0.51050439E-18_JPRB, 0.59331132E-18_JPRB, 0.68786127E-18_JPRB, 0.78219600E-18_JPRB, 0.88364892E-18_JPRB, 0.95238040E-18_JPRB, &
  & 0.10288574E-17_JPRB, 0.99098822E-18_JPRB, 0.98405386E-18_JPRB, 0.77754812E-18_JPRB, 0.68019724E-18_JPRB, 0.66916259E-18_JPRB, &
  & 0.74488116E-18_JPRB, 0.58928145E-18_JPRB, 0.43007095E-18_JPRB, 0.29161552E-18_JPRB, 0.16269319E-18_JPRB, 0.97445069E-19_JPRB, &
  & 0.59729019E-19_JPRB, 0.39988651E-19_JPRB, 0.29364308E-19_JPRB, 0.23062508E-19_JPRB, 0.14551028E-19_JPRB, 0.77096860E-20_JPRB, &
  & 0.39001626E-20_JPRB, 0.22462291E-20_JPRB, 0.17448951E-20_JPRB, 0.13862810E-20_JPRB, 0.10913274E-20_JPRB, 0.86111976E-21_JPRB, &
  & 0.70034612E-21_JPRB, 0.57824272E-21_JPRB, 0.49273792E-21_JPRB, 0.42201668E-21_JPRB, 0.53002345E-21_JPRB, 0.85725335E-21_JPRB, &
  & 0.98212521E-21_JPRB, 0.15467460E-20_JPRB, 0.23286077E-20_JPRB, 0.30129458E-20_JPRB /)

RGHG9(:,14, 6) = (/ &
  & 0.10852475E-16_JPRB, 0.93566833E-17_JPRB, 0.81274573E-17_JPRB, 0.69645663E-17_JPRB, 0.58887865E-17_JPRB, 0.49557110E-17_JPRB, &
  & 0.42268086E-17_JPRB, 0.37482134E-17_JPRB, 0.35806697E-17_JPRB, 0.37647182E-17_JPRB, 0.43199632E-17_JPRB, 0.53671052E-17_JPRB, &
  & 0.70018812E-17_JPRB, 0.92655238E-17_JPRB, 0.12108872E-16_JPRB, 0.15423166E-16_JPRB, 0.18901231E-16_JPRB, 0.22323002E-16_JPRB, &
  & 0.25577998E-16_JPRB, 0.28777352E-16_JPRB, 0.32076933E-16_JPRB, 0.35747077E-16_JPRB, 0.39851841E-16_JPRB, 0.44583791E-16_JPRB, &
  & 0.50019248E-16_JPRB, 0.56128433E-16_JPRB, 0.63118242E-16_JPRB, 0.69965596E-16_JPRB, 0.77432907E-16_JPRB, 0.82179487E-16_JPRB, &
  & 0.87903663E-16_JPRB, 0.84331910E-16_JPRB, 0.83925487E-16_JPRB, 0.66928937E-16_JPRB, 0.59533936E-16_JPRB, 0.59989017E-16_JPRB, &
  & 0.68736545E-16_JPRB, 0.56277061E-16_JPRB, 0.42763156E-16_JPRB, 0.30341825E-16_JPRB, 0.17786383E-16_JPRB, 0.11271474E-16_JPRB, &
  & 0.73390814E-17_JPRB, 0.52444450E-17_JPRB, 0.41225863E-17_JPRB, 0.34672965E-17_JPRB, 0.23389694E-17_JPRB, 0.13259315E-17_JPRB, &
  & 0.71954596E-18_JPRB, 0.44642426E-18_JPRB, 0.37333342E-18_JPRB, 0.31689150E-18_JPRB, 0.26514359E-18_JPRB, 0.22116108E-18_JPRB, &
  & 0.18892474E-18_JPRB, 0.16264089E-18_JPRB, 0.14344730E-18_JPRB, 0.12635541E-18_JPRB, 0.16230279E-18_JPRB, 0.26671700E-18_JPRB, &
  & 0.30862199E-18_JPRB, 0.49025434E-18_JPRB, 0.74249810E-18_JPRB, 0.96522465E-18_JPRB /)

RGHG9(:,15, 6) = (/ &
  & 0.18435761E-14_JPRB, 0.15820819E-14_JPRB, 0.13692279E-14_JPRB, 0.11694949E-14_JPRB, 0.98287607E-15_JPRB, 0.82253485E-15_JPRB, &
  & 0.69454986E-15_JPRB, 0.60850699E-15_JPRB, 0.57126729E-15_JPRB, 0.58712290E-15_JPRB, 0.65508538E-15_JPRB, 0.78789120E-15_JPRB, &
  & 0.99105544E-15_JPRB, 0.12608452E-14_JPRB, 0.15800004E-14_JPRB, 0.19261527E-14_JPRB, 0.22561902E-14_JPRB, 0.25448603E-14_JPRB, &
  & 0.27834134E-14_JPRB, 0.29880894E-14_JPRB, 0.31773239E-14_JPRB, 0.33791617E-14_JPRB, 0.35990862E-14_JPRB, 0.38577336E-14_JPRB, &
  & 0.41604835E-14_JPRB, 0.45076235E-14_JPRB, 0.49176895E-14_JPRB, 0.53131607E-14_JPRB, 0.57617794E-14_JPRB, 0.60207932E-14_JPRB, &
  & 0.63800635E-14_JPRB, 0.60980710E-14_JPRB, 0.60841610E-14_JPRB, 0.48977203E-14_JPRB, 0.44300899E-14_JPRB, 0.45722059E-14_JPRB, &
  & 0.53919373E-14_JPRB, 0.45692570E-14_JPRB, 0.36172618E-14_JPRB, 0.26849238E-14_JPRB, 0.16548296E-14_JPRB, 0.11090196E-14_JPRB, &
  & 0.76735065E-15_JPRB, 0.58535731E-15_JPRB, 0.49268127E-15_JPRB, 0.44365487E-15_JPRB, 0.31994978E-15_JPRB, 0.19409784E-15_JPRB, &
  & 0.11300764E-15_JPRB, 0.75530173E-16_JPRB, 0.67935020E-16_JPRB, 0.61577125E-16_JPRB, 0.54740027E-16_JPRB, 0.48254567E-16_JPRB, &
  & 0.43291083E-16_JPRB, 0.38861187E-16_JPRB, 0.35487640E-16_JPRB, 0.32161679E-16_JPRB, 0.42273049E-16_JPRB, 0.70602565E-16_JPRB, &
  & 0.82545604E-16_JPRB, 0.13224606E-15_JPRB, 0.20136402E-15_JPRB, 0.26290007E-15_JPRB /)

RGHG9(:,16, 6) = (/ &
  & 0.13103466E-13_JPRB, 0.10536751E-13_JPRB, 0.88565994E-14_JPRB, 0.74979035E-14_JPRB, 0.63405431E-14_JPRB, 0.53524719E-14_JPRB, &
  & 0.45791101E-14_JPRB, 0.40594054E-14_JPRB, 0.38318343E-14_JPRB, 0.39315598E-14_JPRB, 0.43678660E-14_JPRB, 0.51815330E-14_JPRB, &
  & 0.64487778E-14_JPRB, 0.81703002E-14_JPRB, 0.10302272E-13_JPRB, 0.12744893E-13_JPRB, 0.15433914E-13_JPRB, 0.18252315E-13_JPRB, &
  & 0.21074617E-13_JPRB, 0.23910873E-13_JPRB, 0.26862364E-13_JPRB, 0.30086400E-13_JPRB, 0.33660324E-13_JPRB, 0.37705387E-13_JPRB, &
  & 0.42185941E-13_JPRB, 0.47045721E-13_JPRB, 0.51955581E-13_JPRB, 0.56443487E-13_JPRB, 0.59716758E-13_JPRB, 0.61371650E-13_JPRB, &
  & 0.60890210E-13_JPRB, 0.58622168E-13_JPRB, 0.55781467E-13_JPRB, 0.49401313E-13_JPRB, 0.42176576E-13_JPRB, 0.34088143E-13_JPRB, &
  & 0.24123595E-13_JPRB, 0.21819677E-13_JPRB, 0.19081840E-13_JPRB, 0.16950622E-13_JPRB, 0.15306675E-13_JPRB, 0.12920699E-13_JPRB, &
  & 0.10219156E-13_JPRB, 0.78715915E-14_JPRB, 0.60041850E-14_JPRB, 0.44739518E-14_JPRB, 0.31016979E-14_JPRB, 0.20773629E-14_JPRB, &
  & 0.13928836E-14_JPRB, 0.10026449E-14_JPRB, 0.80754591E-15_JPRB, 0.76239742E-15_JPRB, 0.68012839E-15_JPRB, 0.59896352E-15_JPRB, &
  & 0.52960671E-15_JPRB, 0.48312922E-15_JPRB, 0.45730245E-15_JPRB, 0.44614782E-15_JPRB, 0.60258384E-15_JPRB, 0.93915646E-15_JPRB, &
  & 0.13934725E-14_JPRB, 0.20635601E-14_JPRB, 0.31406588E-14_JPRB, 0.50204278E-14_JPRB /)

RGHG9(:,17, 6) = (/ &
  & 0.61745083E-13_JPRB, 0.47992274E-13_JPRB, 0.39879548E-13_JPRB, 0.33554112E-13_JPRB, 0.28273465E-13_JPRB, 0.23909922E-13_JPRB, &
  & 0.20477743E-13_JPRB, 0.18137139E-13_JPRB, 0.17054109E-13_JPRB, 0.17375783E-13_JPRB, 0.19223481E-13_JPRB, 0.22630223E-13_JPRB, &
  & 0.28099036E-13_JPRB, 0.35896663E-13_JPRB, 0.46211062E-13_JPRB, 0.58908655E-13_JPRB, 0.73651290E-13_JPRB, 0.90236507E-13_JPRB, &
  & 0.10842995E-12_JPRB, 0.12843687E-12_JPRB, 0.15070093E-12_JPRB, 0.17645610E-12_JPRB, 0.20649219E-12_JPRB, 0.24257121E-12_JPRB, &
  & 0.28275133E-12_JPRB, 0.32601721E-12_JPRB, 0.36479741E-12_JPRB, 0.39733055E-12_JPRB, 0.41290639E-12_JPRB, 0.41771802E-12_JPRB, &
  & 0.39956322E-12_JPRB, 0.36872523E-12_JPRB, 0.32679209E-12_JPRB, 0.28471108E-12_JPRB, 0.24522737E-12_JPRB, 0.20881585E-12_JPRB, &
  & 0.17798923E-12_JPRB, 0.14510570E-12_JPRB, 0.12438169E-12_JPRB, 0.10635971E-12_JPRB, 0.91390810E-13_JPRB, 0.79767302E-13_JPRB, &
  & 0.67835481E-13_JPRB, 0.55761416E-13_JPRB, 0.43967563E-13_JPRB, 0.33694767E-13_JPRB, 0.25267374E-13_JPRB, 0.19019989E-13_JPRB, &
  & 0.14206258E-13_JPRB, 0.11007529E-13_JPRB, 0.89471269E-14_JPRB, 0.75406998E-14_JPRB, 0.64695923E-14_JPRB, 0.56001643E-14_JPRB, &
  & 0.49615116E-14_JPRB, 0.45651163E-14_JPRB, 0.44697281E-14_JPRB, 0.50829448E-14_JPRB, 0.67855526E-14_JPRB, 0.10142234E-13_JPRB, &
  & 0.15456952E-13_JPRB, 0.22399918E-13_JPRB, 0.38582598E-13_JPRB, 0.61450790E-13_JPRB /)

RGHG9(:,18, 6) = (/ &
  & 0.20781124E-12_JPRB, 0.16221115E-12_JPRB, 0.13600916E-12_JPRB, 0.11551721E-12_JPRB, 0.98593578E-13_JPRB, 0.84221719E-13_JPRB, &
  & 0.72778758E-13_JPRB, 0.64727053E-13_JPRB, 0.60741458E-13_JPRB, 0.61427941E-13_JPRB, 0.67269364E-13_JPRB, 0.78665956E-13_JPRB, &
  & 0.96759555E-13_JPRB, 0.12319903E-12_JPRB, 0.15934808E-12_JPRB, 0.20598005E-12_JPRB, 0.26305488E-12_JPRB, 0.33024297E-12_JPRB, &
  & 0.40729190E-12_JPRB, 0.49546261E-12_JPRB, 0.59703750E-12_JPRB, 0.71716548E-12_JPRB, 0.86173370E-12_JPRB, 0.10382410E-11_JPRB, &
  & 0.12403870E-11_JPRB, 0.14512481E-11_JPRB, 0.16520592E-11_JPRB, 0.18101135E-11_JPRB, 0.18889174E-11_JPRB, 0.18706113E-11_JPRB, &
  & 0.17520730E-11_JPRB, 0.15659620E-11_JPRB, 0.13428919E-11_JPRB, 0.11125258E-11_JPRB, 0.89904831E-12_JPRB, 0.72606927E-12_JPRB, &
  & 0.60227631E-12_JPRB, 0.53073583E-12_JPRB, 0.47604564E-12_JPRB, 0.44508432E-12_JPRB, 0.41596988E-12_JPRB, 0.38001519E-12_JPRB, &
  & 0.34010853E-12_JPRB, 0.29773818E-12_JPRB, 0.25275872E-12_JPRB, 0.21002087E-12_JPRB, 0.17153074E-12_JPRB, 0.13942367E-12_JPRB, &
  & 0.11189990E-12_JPRB, 0.89366259E-13_JPRB, 0.70346906E-13_JPRB, 0.54929439E-13_JPRB, 0.43486163E-13_JPRB, 0.36199047E-13_JPRB, &
  & 0.32659568E-13_JPRB, 0.32407074E-13_JPRB, 0.35220613E-13_JPRB, 0.41448432E-13_JPRB, 0.51495659E-13_JPRB, 0.67014909E-13_JPRB, &
  & 0.90215067E-13_JPRB, 0.12211281E-12_JPRB, 0.16636708E-12_JPRB, 0.28334564E-12_JPRB /)

RGHG9(:,19, 6) = (/ &
  & 0.54784844E-12_JPRB, 0.43544300E-12_JPRB, 0.37189452E-12_JPRB, 0.32288866E-12_JPRB, 0.28063958E-12_JPRB, 0.24436955E-12_JPRB, &
  & 0.21431763E-12_JPRB, 0.19260040E-12_JPRB, 0.18118121E-12_JPRB, 0.18214916E-12_JPRB, 0.19697590E-12_JPRB, 0.22713808E-12_JPRB, &
  & 0.27416139E-12_JPRB, 0.34301362E-12_JPRB, 0.43807294E-12_JPRB, 0.56293024E-12_JPRB, 0.71925338E-12_JPRB, 0.90687391E-12_JPRB, &
  & 0.11258746E-11_JPRB, 0.13802476E-11_JPRB, 0.16775469E-11_JPRB, 0.20309492E-11_JPRB, 0.24583599E-11_JPRB, 0.29721295E-11_JPRB, &
  & 0.35602131E-11_JPRB, 0.41856796E-11_JPRB, 0.47788457E-11_JPRB, 0.52175868E-11_JPRB, 0.54333005E-11_JPRB, 0.53607713E-11_JPRB, &
  & 0.50349412E-11_JPRB, 0.45028100E-11_JPRB, 0.38586443E-11_JPRB, 0.32002961E-11_JPRB, 0.26091373E-11_JPRB, 0.21379678E-11_JPRB, &
  & 0.18046806E-11_JPRB, 0.15940467E-11_JPRB, 0.14895418E-11_JPRB, 0.14296127E-11_JPRB, 0.13919199E-11_JPRB, 0.13506048E-11_JPRB, &
  & 0.12786697E-11_JPRB, 0.11760783E-11_JPRB, 0.10511917E-11_JPRB, 0.91875270E-12_JPRB, 0.78724592E-12_JPRB, 0.66362996E-12_JPRB, &
  & 0.54970714E-12_JPRB, 0.44927736E-12_JPRB, 0.36530214E-12_JPRB, 0.29949681E-12_JPRB, 0.25127234E-12_JPRB, 0.21750947E-12_JPRB, &
  & 0.19659182E-12_JPRB, 0.18866846E-12_JPRB, 0.19501227E-12_JPRB, 0.21686873E-12_JPRB, 0.25190036E-12_JPRB, 0.29962865E-12_JPRB, &
  & 0.36209802E-12_JPRB, 0.44641309E-12_JPRB, 0.56175805E-12_JPRB, 0.81426164E-12_JPRB /)

RGHG9(:,20, 6) = (/ &
  & 0.11900129E-11_JPRB, 0.97450216E-12_JPRB, 0.85397119E-12_JPRB, 0.75859577E-12_JPRB, 0.67514402E-12_JPRB, 0.60073203E-12_JPRB, &
  & 0.53755719E-12_JPRB, 0.48978638E-12_JPRB, 0.46407821E-12_JPRB, 0.46505497E-12_JPRB, 0.49637275E-12_JPRB, 0.56119736E-12_JPRB, &
  & 0.66293423E-12_JPRB, 0.80691991E-12_JPRB, 0.10044518E-11_JPRB, 0.12618373E-11_JPRB, 0.15825325E-11_JPRB, 0.19661237E-11_JPRB, &
  & 0.24117824E-11_JPRB, 0.29257280E-11_JPRB, 0.35275591E-11_JPRB, 0.42346586E-11_JPRB, 0.50668259E-11_JPRB, 0.60620844E-11_JPRB, &
  & 0.72062200E-11_JPRB, 0.84062288E-11_JPRB, 0.95446298E-11_JPRB, 0.10419382E-10_JPRB, 0.10887895E-10_JPRB, 0.10860945E-10_JPRB, &
  & 0.10370628E-10_JPRB, 0.94778872E-11_JPRB, 0.83407864E-11_JPRB, 0.71225209E-11_JPRB, 0.59851395E-11_JPRB, 0.50569154E-11_JPRB, &
  & 0.43858853E-11_JPRB, 0.39693279E-11_JPRB, 0.37597070E-11_JPRB, 0.36756331E-11_JPRB, 0.36322187E-11_JPRB, 0.35656723E-11_JPRB, &
  & 0.34505016E-11_JPRB, 0.32758130E-11_JPRB, 0.30302761E-11_JPRB, 0.27336872E-11_JPRB, 0.24108389E-11_JPRB, 0.20903160E-11_JPRB, &
  & 0.17867578E-11_JPRB, 0.15178343E-11_JPRB, 0.12932095E-11_JPRB, 0.11111209E-11_JPRB, 0.96660689E-12_JPRB, 0.85651375E-12_JPRB, &
  & 0.77941353E-12_JPRB, 0.73646086E-12_JPRB, 0.73105595E-12_JPRB, 0.76722287E-12_JPRB, 0.83789995E-12_JPRB, 0.93608031E-12_JPRB, &
  & 0.10571533E-11_JPRB, 0.12049024E-11_JPRB, 0.14144558E-11_JPRB, 0.18014273E-11_JPRB /)

RGHG9(:,21, 6) = (/ &
  & 0.22629407E-11_JPRB, 0.19052232E-11_JPRB, 0.17104500E-11_JPRB, 0.15530470E-11_JPRB, 0.14131547E-11_JPRB, 0.12855469E-11_JPRB, &
  & 0.11733897E-11_JPRB, 0.10885294E-11_JPRB, 0.10422614E-11_JPRB, 0.10450663E-11_JPRB, 0.11039373E-11_JPRB, 0.12245508E-11_JPRB, &
  & 0.14115511E-11_JPRB, 0.16708230E-11_JPRB, 0.20144973E-11_JPRB, 0.24539424E-11_JPRB, 0.29928809E-11_JPRB, 0.36277160E-11_JPRB, &
  & 0.43557697E-11_JPRB, 0.51825983E-11_JPRB, 0.61230070E-11_JPRB, 0.72266308E-11_JPRB, 0.85234779E-11_JPRB, 0.10034223E-10_JPRB, &
  & 0.11720187E-10_JPRB, 0.13525469E-10_JPRB, 0.15201094E-10_JPRB, 0.16519893E-10_JPRB, 0.17331888E-10_JPRB, 0.17537345E-10_JPRB, &
  & 0.17107673E-10_JPRB, 0.16101519E-10_JPRB, 0.14688428E-10_JPRB, 0.13040923E-10_JPRB, 0.11431901E-10_JPRB, 0.10032357E-10_JPRB, &
  & 0.89825482E-11_JPRB, 0.83050337E-11_JPRB, 0.79298408E-11_JPRB, 0.77584753E-11_JPRB, 0.76512329E-11_JPRB, 0.75245973E-11_JPRB, &
  & 0.72922250E-11_JPRB, 0.69479500E-11_JPRB, 0.64906192E-11_JPRB, 0.59544366E-11_JPRB, 0.53771935E-11_JPRB, 0.47977893E-11_JPRB, &
  & 0.42404578E-11_JPRB, 0.37309340E-11_JPRB, 0.32815519E-11_JPRB, 0.28909908E-11_JPRB, 0.25691040E-11_JPRB, 0.23180535E-11_JPRB, &
  & 0.21356144E-11_JPRB, 0.20197869E-11_JPRB, 0.19722316E-11_JPRB, 0.19980549E-11_JPRB, 0.20854800E-11_JPRB, 0.22224002E-11_JPRB, &
  & 0.23962039E-11_JPRB, 0.26005441E-11_JPRB, 0.28539089E-11_JPRB, 0.33662797E-11_JPRB /)

RGHG9(:,22, 6) = (/ &
  & 0.38318762E-11_JPRB, 0.33339672E-11_JPRB, 0.30571973E-11_JPRB, 0.28323199E-11_JPRB, 0.26293546E-11_JPRB, 0.24412297E-11_JPRB, &
  & 0.22766504E-11_JPRB, 0.21516491E-11_JPRB, 0.20892110E-11_JPRB, 0.21065567E-11_JPRB, 0.22159462E-11_JPRB, 0.24253358E-11_JPRB, &
  & 0.27406894E-11_JPRB, 0.31662440E-11_JPRB, 0.37051165E-11_JPRB, 0.43709186E-11_JPRB, 0.51638615E-11_JPRB, 0.60813104E-11_JPRB, &
  & 0.71174390E-11_JPRB, 0.82728078E-11_JPRB, 0.95736630E-11_JPRB, 0.11056885E-10_JPRB, 0.12736797E-10_JPRB, 0.14644539E-10_JPRB, &
  & 0.16755285E-10_JPRB, 0.18923217E-10_JPRB, 0.21008110E-10_JPRB, 0.22779558E-10_JPRB, 0.23990679E-10_JPRB, 0.24553040E-10_JPRB, &
  & 0.24435544E-10_JPRB, 0.23662553E-10_JPRB, 0.22356290E-10_JPRB, 0.20691629E-10_JPRB, 0.18925951E-10_JPRB, 0.17320345E-10_JPRB, &
  & 0.15985017E-10_JPRB, 0.15033856E-10_JPRB, 0.14420541E-10_JPRB, 0.14010154E-10_JPRB, 0.13668552E-10_JPRB, 0.13307227E-10_JPRB, &
  & 0.12845685E-10_JPRB, 0.12238962E-10_JPRB, 0.11485692E-10_JPRB, 0.10638746E-10_JPRB, 0.97497149E-11_JPRB, 0.88603127E-11_JPRB, &
  & 0.79911642E-11_JPRB, 0.71717033E-11_JPRB, 0.64283552E-11_JPRB, 0.57770043E-11_JPRB, 0.52376289E-11_JPRB, 0.48108973E-11_JPRB, &
  & 0.44920638E-11_JPRB, 0.42742207E-11_JPRB, 0.41538994E-11_JPRB, 0.41329522E-11_JPRB, 0.41939247E-11_JPRB, 0.43215848E-11_JPRB, &
  & 0.45028313E-11_JPRB, 0.47321773E-11_JPRB, 0.50262277E-11_JPRB, 0.55449642E-11_JPRB /)

RGHG9(:,23, 6) = (/ &
  & 0.59510639E-11_JPRB, 0.53171716E-11_JPRB, 0.49691284E-11_JPRB, 0.46830899E-11_JPRB, 0.44258590E-11_JPRB, 0.41891816E-11_JPRB, &
  & 0.39836155E-11_JPRB, 0.38383541E-11_JPRB, 0.37850335E-11_JPRB, 0.38519331E-11_JPRB, 0.40566370E-11_JPRB, 0.44102300E-11_JPRB, &
  & 0.49164015E-11_JPRB, 0.55743773E-11_JPRB, 0.63799842E-11_JPRB, 0.73253157E-11_JPRB, 0.84131486E-11_JPRB, 0.96344391E-11_JPRB, &
  & 0.10981833E-10_JPRB, 0.12463208E-10_JPRB, 0.14068298E-10_JPRB, 0.15828837E-10_JPRB, 0.17788500E-10_JPRB, 0.19944931E-10_JPRB, &
  & 0.22253902E-10_JPRB, 0.24644311E-10_JPRB, 0.26899108E-10_JPRB, 0.28824975E-10_JPRB, 0.30361685E-10_JPRB, 0.31351234E-10_JPRB, &
  & 0.31711758E-10_JPRB, 0.31440253E-10_JPRB, 0.30605751E-10_JPRB, 0.29340658E-10_JPRB, 0.27819221E-10_JPRB, 0.26337672E-10_JPRB, &
  & 0.24972191E-10_JPRB, 0.23825523E-10_JPRB, 0.22897293E-10_JPRB, 0.22085072E-10_JPRB, 0.21316044E-10_JPRB, 0.20499335E-10_JPRB, &
  & 0.19597402E-10_JPRB, 0.18606656E-10_JPRB, 0.17504696E-10_JPRB, 0.16310352E-10_JPRB, 0.15063287E-10_JPRB, 0.13820499E-10_JPRB, &
  & 0.12619575E-10_JPRB, 0.11503438E-10_JPRB, 0.10504469E-10_JPRB, 0.96331424E-11_JPRB, 0.89025298E-11_JPRB, 0.83112631E-11_JPRB, &
  & 0.78516100E-11_JPRB, 0.75160312E-11_JPRB, 0.72997719E-11_JPRB, 0.72020831E-11_JPRB, 0.71994702E-11_JPRB, 0.72708632E-11_JPRB, &
  & 0.73988758E-11_JPRB, 0.75767439E-11_JPRB, 0.78248345E-11_JPRB, 0.83016892E-11_JPRB /)

RGHG9(:,24, 6) = (/ &
  & 0.85610460E-11_JPRB, 0.78478604E-11_JPRB, 0.74484438E-11_JPRB, 0.71272155E-11_JPRB, 0.68419151E-11_JPRB, 0.65851612E-11_JPRB, &
  & 0.63755988E-11_JPRB, 0.62507295E-11_JPRB, 0.62576680E-11_JPRB, 0.64339354E-11_JPRB, 0.68027090E-11_JPRB, 0.73753122E-11_JPRB, &
  & 0.81522133E-11_JPRB, 0.91217988E-11_JPRB, 0.10265719E-10_JPRB, 0.11554018E-10_JPRB, 0.12977450E-10_JPRB, 0.14521569E-10_JPRB, &
  & 0.16167314E-10_JPRB, 0.17908565E-10_JPRB, 0.19752014E-10_JPRB, 0.21701290E-10_JPRB, 0.23748791E-10_JPRB, 0.25902953E-10_JPRB, &
  & 0.28139364E-10_JPRB, 0.30400151E-10_JPRB, 0.32630829E-10_JPRB, 0.34683256E-10_JPRB, 0.36371458E-10_JPRB, 0.37684779E-10_JPRB, &
  & 0.38531157E-10_JPRB, 0.38858378E-10_JPRB, 0.38676770E-10_JPRB, 0.38038555E-10_JPRB, 0.37046390E-10_JPRB, 0.35884771E-10_JPRB, &
  & 0.34649790E-10_JPRB, 0.33427594E-10_JPRB, 0.32210186E-10_JPRB, 0.30987470E-10_JPRB, 0.29696873E-10_JPRB, 0.28324955E-10_JPRB, &
  & 0.26860453E-10_JPRB, 0.25330875E-10_JPRB, 0.23744097E-10_JPRB, 0.22136057E-10_JPRB, 0.20552289E-10_JPRB, 0.19043059E-10_JPRB, &
  & 0.17631929E-10_JPRB, 0.16342757E-10_JPRB, 0.15195841E-10_JPRB, 0.14189488E-10_JPRB, 0.13331719E-10_JPRB, 0.12614404E-10_JPRB, &
  & 0.12029312E-10_JPRB, 0.11571927E-10_JPRB, 0.11240980E-10_JPRB, 0.11038701E-10_JPRB, 0.10942444E-10_JPRB, 0.10929016E-10_JPRB, &
  & 0.10977456E-10_JPRB, 0.11073796E-10_JPRB, 0.11220642E-10_JPRB, 0.11525869E-10_JPRB /)

RGHG9(:,25, 6) = (/ &
  & 0.11604152E-10_JPRB, 0.10855308E-10_JPRB, 0.10442564E-10_JPRB, 0.10122984E-10_JPRB, 0.98458195E-11_JPRB, 0.96106135E-11_JPRB, &
  & 0.94433419E-11_JPRB, 0.93952493E-11_JPRB, 0.95250526E-11_JPRB, 0.98789518E-11_JPRB, 0.10483650E-10_JPRB, 0.11348122E-10_JPRB, &
  & 0.12465091E-10_JPRB, 0.13807389E-10_JPRB, 0.15341456E-10_JPRB, 0.17017981E-10_JPRB, 0.18788977E-10_JPRB, 0.20639705E-10_JPRB, &
  & 0.22543099E-10_JPRB, 0.24487024E-10_JPRB, 0.26451844E-10_JPRB, 0.28424384E-10_JPRB, 0.30391151E-10_JPRB, 0.32370905E-10_JPRB, &
  & 0.34342498E-10_JPRB, 0.36305816E-10_JPRB, 0.38238798E-10_JPRB, 0.40118193E-10_JPRB, 0.41898787E-10_JPRB, 0.43444477E-10_JPRB, &
  & 0.44692500E-10_JPRB, 0.45563692E-10_JPRB, 0.46014997E-10_JPRB, 0.46016680E-10_JPRB, 0.45613489E-10_JPRB, 0.44871738E-10_JPRB, &
  & 0.43861574E-10_JPRB, 0.42631332E-10_JPRB, 0.41211458E-10_JPRB, 0.39604146E-10_JPRB, 0.37841015E-10_JPRB, 0.35945052E-10_JPRB, &
  & 0.33963804E-10_JPRB, 0.31945457E-10_JPRB, 0.29929323E-10_JPRB, 0.27965465E-10_JPRB, 0.26115908E-10_JPRB, 0.24409955E-10_JPRB, &
  & 0.22856446E-10_JPRB, 0.21464094E-10_JPRB, 0.20235241E-10_JPRB, 0.19155153E-10_JPRB, 0.18218604E-10_JPRB, 0.17413225E-10_JPRB, &
  & 0.16728820E-10_JPRB, 0.16160221E-10_JPRB, 0.15708315E-10_JPRB, 0.15379921E-10_JPRB, 0.15159072E-10_JPRB, 0.15027186E-10_JPRB, &
  & 0.14965114E-10_JPRB, 0.14956687E-10_JPRB, 0.14994967E-10_JPRB, 0.15118051E-10_JPRB /)

RGHG9(:,26, 6) = (/ &
  & 0.14930484E-10_JPRB, 0.14236119E-10_JPRB, 0.13869158E-10_JPRB, 0.13582848E-10_JPRB, 0.13351943E-10_JPRB, 0.13177797E-10_JPRB, &
  & 0.13097540E-10_JPRB, 0.13175004E-10_JPRB, 0.13479133E-10_JPRB, 0.14061443E-10_JPRB, 0.14946573E-10_JPRB, 0.16141206E-10_JPRB, &
  & 0.17622355E-10_JPRB, 0.19351522E-10_JPRB, 0.21270936E-10_JPRB, 0.23312980E-10_JPRB, 0.25409314E-10_JPRB, 0.27521260E-10_JPRB, &
  & 0.29617309E-10_JPRB, 0.31673053E-10_JPRB, 0.33658555E-10_JPRB, 0.35542732E-10_JPRB, 0.37326909E-10_JPRB, 0.39022903E-10_JPRB, &
  & 0.40629927E-10_JPRB, 0.42185783E-10_JPRB, 0.43742968E-10_JPRB, 0.45344312E-10_JPRB, 0.46990016E-10_JPRB, 0.48641965E-10_JPRB, &
  & 0.50161129E-10_JPRB, 0.51437219E-10_JPRB, 0.52374726E-10_JPRB, 0.52884735E-10_JPRB, 0.52948236E-10_JPRB, 0.52566975E-10_JPRB, &
  & 0.51763576E-10_JPRB, 0.50562454E-10_JPRB, 0.49033125E-10_JPRB, 0.47164099E-10_JPRB, 0.45065267E-10_JPRB, 0.42790174E-10_JPRB, &
  & 0.40438233E-10_JPRB, 0.38081236E-10_JPRB, 0.35780177E-10_JPRB, 0.33591189E-10_JPRB, 0.31561601E-10_JPRB, 0.29732359E-10_JPRB, &
  & 0.28101105E-10_JPRB, 0.26662821E-10_JPRB, 0.25401185E-10_JPRB, 0.24289465E-10_JPRB, 0.23313535E-10_JPRB, 0.22455494E-10_JPRB, &
  & 0.21700360E-10_JPRB, 0.21043303E-10_JPRB, 0.20485131E-10_JPRB, 0.20034675E-10_JPRB, 0.19683978E-10_JPRB, 0.19421895E-10_JPRB, &
  & 0.19234798E-10_JPRB, 0.19105563E-10_JPRB, 0.19011726E-10_JPRB, 0.18924569E-10_JPRB /)

RGHG9(:,27, 6) = (/ &
  & 0.18485390E-10_JPRB, 0.17928506E-10_JPRB, 0.17614287E-10_JPRB, 0.17396419E-10_JPRB, 0.17234509E-10_JPRB, 0.17147981E-10_JPRB, &
  & 0.17183182E-10_JPRB, 0.17415284E-10_JPRB, 0.17916028E-10_JPRB, 0.18739401E-10_JPRB, 0.19907640E-10_JPRB, 0.21413465E-10_JPRB, &
  & 0.23228319E-10_JPRB, 0.25292199E-10_JPRB, 0.27538251E-10_JPRB, 0.29878076E-10_JPRB, 0.32235475E-10_JPRB, 0.34536915E-10_JPRB, &
  & 0.36754676E-10_JPRB, 0.38855384E-10_JPRB, 0.40797338E-10_JPRB, 0.42552215E-10_JPRB, 0.44113126E-10_JPRB, 0.45492800E-10_JPRB, &
  & 0.46726858E-10_JPRB, 0.47875075E-10_JPRB, 0.49057203E-10_JPRB, 0.50355803E-10_JPRB, 0.51814237E-10_JPRB, 0.53404010E-10_JPRB, &
  & 0.55021664E-10_JPRB, 0.56524632E-10_JPRB, 0.57763093E-10_JPRB, 0.58599819E-10_JPRB, 0.58964542E-10_JPRB, 0.58820768E-10_JPRB, &
  & 0.58161486E-10_JPRB, 0.57002708E-10_JPRB, 0.55414100E-10_JPRB, 0.53435648E-10_JPRB, 0.51135658E-10_JPRB, 0.48659955E-10_JPRB, &
  & 0.46094246E-10_JPRB, 0.43556353E-10_JPRB, 0.41104467E-10_JPRB, 0.38808626E-10_JPRB, 0.36721012E-10_JPRB, 0.34868618E-10_JPRB, &
  & 0.33238443E-10_JPRB, 0.31810353E-10_JPRB, 0.30556398E-10_JPRB, 0.29444499E-10_JPRB, 0.28454303E-10_JPRB, 0.27564196E-10_JPRB, &
  & 0.26760790E-10_JPRB, 0.26038061E-10_JPRB, 0.25397824E-10_JPRB, 0.24849886E-10_JPRB, 0.24393366E-10_JPRB, 0.24023004E-10_JPRB, &
  & 0.23729262E-10_JPRB, 0.23494569E-10_JPRB, 0.23286791E-10_JPRB, 0.23005285E-10_JPRB /)

RGHG9(:,28, 6) = (/ &
  & 0.22247575E-10_JPRB, 0.21782222E-10_JPRB, 0.21563197E-10_JPRB, 0.21415481E-10_JPRB, 0.21337376E-10_JPRB, 0.21349958E-10_JPRB, &
  & 0.21511839E-10_JPRB, 0.21899304E-10_JPRB, 0.22595124E-10_JPRB, 0.23642114E-10_JPRB, 0.25052502E-10_JPRB, 0.26819939E-10_JPRB, &
  & 0.28893771E-10_JPRB, 0.31215492E-10_JPRB, 0.33696372E-10_JPRB, 0.36246926E-10_JPRB, 0.38773540E-10_JPRB, 0.41200952E-10_JPRB, &
  & 0.43483640E-10_JPRB, 0.45581691E-10_JPRB, 0.47454058E-10_JPRB, 0.49068409E-10_JPRB, 0.50418201E-10_JPRB, 0.51525284E-10_JPRB, &
  & 0.52437724E-10_JPRB, 0.53241585E-10_JPRB, 0.54077593E-10_JPRB, 0.55069269E-10_JPRB, 0.56295985E-10_JPRB, 0.57769147E-10_JPRB, &
  & 0.59367754E-10_JPRB, 0.60940475E-10_JPRB, 0.62311788E-10_JPRB, 0.63311273E-10_JPRB, 0.63834181E-10_JPRB, 0.63819172E-10_JPRB, &
  & 0.63247532E-10_JPRB, 0.62135269E-10_JPRB, 0.60537637E-10_JPRB, 0.58529737E-10_JPRB, 0.56186583E-10_JPRB, 0.53634139E-10_JPRB, &
  & 0.51016327E-10_JPRB, 0.48428640E-10_JPRB, 0.45955073E-10_JPRB, 0.43672108E-10_JPRB, 0.41616238E-10_JPRB, 0.39817039E-10_JPRB, &
  & 0.38241965E-10_JPRB, 0.36860587E-10_JPRB, 0.35636698E-10_JPRB, 0.34537640E-10_JPRB, 0.33541184E-10_JPRB, 0.32628455E-10_JPRB, &
  & 0.31785418E-10_JPRB, 0.31008907E-10_JPRB, 0.30300339E-10_JPRB, 0.29667033E-10_JPRB, 0.29108993E-10_JPRB, 0.28625258E-10_JPRB, &
  & 0.28211471E-10_JPRB, 0.27847624E-10_JPRB, 0.27482220E-10_JPRB, 0.26910715E-10_JPRB /)

RGHG9(:,29, 6) = (/ &
  & 0.26031110E-10_JPRB, 0.25705970E-10_JPRB, 0.25560994E-10_JPRB, 0.25492932E-10_JPRB, 0.25497547E-10_JPRB, 0.25608991E-10_JPRB, &
  & 0.25888569E-10_JPRB, 0.26429504E-10_JPRB, 0.27293794E-10_JPRB, 0.28525942E-10_JPRB, 0.30132084E-10_JPRB, 0.32085369E-10_JPRB, &
  & 0.34344111E-10_JPRB, 0.36829831E-10_JPRB, 0.39458357E-10_JPRB, 0.42127985E-10_JPRB, 0.44748698E-10_JPRB, 0.47239185E-10_JPRB, &
  & 0.49536278E-10_JPRB, 0.51605484E-10_JPRB, 0.53401755E-10_JPRB, 0.54899047E-10_JPRB, 0.56084564E-10_JPRB, 0.56985958E-10_JPRB, &
  & 0.57660612E-10_JPRB, 0.58207682E-10_JPRB, 0.58779738E-10_JPRB, 0.59509099E-10_JPRB, 0.60504719E-10_JPRB, 0.61788651E-10_JPRB, &
  & 0.63287278E-10_JPRB, 0.64815917E-10_JPRB, 0.66190525E-10_JPRB, 0.67225524E-10_JPRB, 0.67795172E-10_JPRB, 0.67831539E-10_JPRB, &
  & 0.67314557E-10_JPRB, 0.66255994E-10_JPRB, 0.64707524E-10_JPRB, 0.62734706E-10_JPRB, 0.60446238E-10_JPRB, 0.57956469E-10_JPRB, &
  & 0.55392326E-10_JPRB, 0.52875152E-10_JPRB, 0.50500389E-10_JPRB, 0.48308683E-10_JPRB, 0.46350569E-10_JPRB, 0.44635975E-10_JPRB, &
  & 0.43132435E-10_JPRB, 0.41801215E-10_JPRB, 0.40604270E-10_JPRB, 0.39510943E-10_JPRB, 0.38503291E-10_JPRB, 0.37563869E-10_JPRB, &
  & 0.36682306E-10_JPRB, 0.35856370E-10_JPRB, 0.35085306E-10_JPRB, 0.34376599E-10_JPRB, 0.33733197E-10_JPRB, 0.33157511E-10_JPRB, &
  & 0.32651444E-10_JPRB, 0.32199063E-10_JPRB, 0.31751868E-10_JPRB, 0.31126615E-10_JPRB /)

RGHG9(:,30, 6) = (/ &
  & 0.29750820E-10_JPRB, 0.29554120E-10_JPRB, 0.29495514E-10_JPRB, 0.29500669E-10_JPRB, 0.29583412E-10_JPRB, 0.29784536E-10_JPRB, &
  & 0.30179137E-10_JPRB, 0.30842353E-10_JPRB, 0.31852281E-10_JPRB, 0.33229849E-10_JPRB, 0.34969888E-10_JPRB, 0.37051990E-10_JPRB, &
  & 0.39415186E-10_JPRB, 0.41990411E-10_JPRB, 0.44685082E-10_JPRB, 0.47403699E-10_JPRB, 0.50054145E-10_JPRB, 0.52555134E-10_JPRB, &
  & 0.54842221E-10_JPRB, 0.56868971E-10_JPRB, 0.58595927E-10_JPRB, 0.59997611E-10_JPRB, 0.61064681E-10_JPRB, 0.61826815E-10_JPRB, &
  & 0.62347266E-10_JPRB, 0.62729655E-10_JPRB, 0.63120516E-10_JPRB, 0.63656108E-10_JPRB, 0.64450209E-10_JPRB, 0.65535452E-10_JPRB, &
  & 0.66861683E-10_JPRB, 0.68264908E-10_JPRB, 0.69552392E-10_JPRB, 0.70535910E-10_JPRB, 0.71082154E-10_JPRB, 0.71118340E-10_JPRB, &
  & 0.70631195E-10_JPRB, 0.69640890E-10_JPRB, 0.68185832E-10_JPRB, 0.66329907E-10_JPRB, 0.64161496E-10_JPRB, 0.61814956E-10_JPRB, &
  & 0.59420004E-10_JPRB, 0.57069773E-10_JPRB, 0.54843855E-10_JPRB, 0.52791504E-10_JPRB, 0.50953734E-10_JPRB, 0.49337125E-10_JPRB, &
  & 0.47896007E-10_JPRB, 0.46600508E-10_JPRB, 0.45413766E-10_JPRB, 0.44310312E-10_JPRB, 0.43278114E-10_JPRB, 0.42305052E-10_JPRB, &
  & 0.41383470E-10_JPRB, 0.40511934E-10_JPRB, 0.39690390E-10_JPRB, 0.38924603E-10_JPRB, 0.38218480E-10_JPRB, 0.37576921E-10_JPRB, &
  & 0.37004701E-10_JPRB, 0.36487608E-10_JPRB, 0.35971306E-10_JPRB, 0.35177430E-10_JPRB /)

RGHG9(:,31, 6) = (/ &
  & 0.33341246E-10_JPRB, 0.33283130E-10_JPRB, 0.33297365E-10_JPRB, 0.33369470E-10_JPRB, 0.33524024E-10_JPRB, 0.33808900E-10_JPRB, &
  & 0.34293023E-10_JPRB, 0.35069586E-10_JPRB, 0.36184278E-10_JPRB, 0.37660250E-10_JPRB, 0.39490307E-10_JPRB, 0.41634963E-10_JPRB, &
  & 0.44049035E-10_JPRB, 0.46644646E-10_JPRB, 0.49345292E-10_JPRB, 0.52053483E-10_JPRB, 0.54686485E-10_JPRB, 0.57161376E-10_JPRB, &
  & 0.59417533E-10_JPRB, 0.61396693E-10_JPRB, 0.63064401E-10_JPRB, 0.64393810E-10_JPRB, 0.65383476E-10_JPRB, 0.66065250E-10_JPRB, &
  & 0.66502283E-10_JPRB, 0.66797179E-10_JPRB, 0.67079994E-10_JPRB, 0.67477919E-10_JPRB, 0.68109400E-10_JPRB, 0.69008493E-10_JPRB, &
  & 0.70141545E-10_JPRB, 0.71370798E-10_JPRB, 0.72511462E-10_JPRB, 0.73381426E-10_JPRB, 0.73858031E-10_JPRB, 0.73874989E-10_JPRB, &
  & 0.73416051E-10_JPRB, 0.72504204E-10_JPRB, 0.71182248E-10_JPRB, 0.69489671E-10_JPRB, 0.67523036E-10_JPRB, 0.65380361E-10_JPRB, &
  & 0.63197926E-10_JPRB, 0.61059893E-10_JPRB, 0.59024750E-10_JPRB, 0.57137205E-10_JPRB, 0.55413323E-10_JPRB, 0.53878776E-10_JPRB, &
  & 0.52485266E-10_JPRB, 0.51203940E-10_JPRB, 0.50008532E-10_JPRB, 0.48880067E-10_JPRB, 0.47812830E-10_JPRB, 0.46801577E-10_JPRB, &
  & 0.45841518E-10_JPRB, 0.44931732E-10_JPRB, 0.44071989E-10_JPRB, 0.43266654E-10_JPRB, 0.42518884E-10_JPRB, 0.41833866E-10_JPRB, &
  & 0.41215913E-10_JPRB, 0.40647465E-10_JPRB, 0.40068757E-10_JPRB, 0.39152185E-10_JPRB /)

RGHG9(:,32, 6) = (/ &
  & 0.36800275E-10_JPRB, 0.36856376E-10_JPRB, 0.36935371E-10_JPRB, 0.37073560E-10_JPRB, 0.37293765E-10_JPRB, 0.37650823E-10_JPRB, &
  & 0.38221416E-10_JPRB, 0.39072544E-10_JPRB, 0.40261787E-10_JPRB, 0.41796282E-10_JPRB, 0.43659912E-10_JPRB, 0.45825149E-10_JPRB, &
  & 0.48228983E-10_JPRB, 0.50802817E-10_JPRB, 0.53457454E-10_JPRB, 0.56114370E-10_JPRB, 0.58697026E-10_JPRB, 0.61119429E-10_JPRB, &
  & 0.63326781E-10_JPRB, 0.65257320E-10_JPRB, 0.66875672E-10_JPRB, 0.68158208E-10_JPRB, 0.69105818E-10_JPRB, 0.69752919E-10_JPRB, &
  & 0.70161800E-10_JPRB, 0.70422744E-10_JPRB, 0.70659395E-10_JPRB, 0.70973602E-10_JPRB, 0.71477713E-10_JPRB, 0.72211022E-10_JPRB, &
  & 0.73152234E-10_JPRB, 0.74187094E-10_JPRB, 0.75151642E-10_JPRB, 0.75883626E-10_JPRB, 0.76264731E-10_JPRB, 0.76243664E-10_JPRB, &
  & 0.75815375E-10_JPRB, 0.74998618E-10_JPRB, 0.73824183E-10_JPRB, 0.72337712E-10_JPRB, 0.70596771E-10_JPRB, 0.68714381E-10_JPRB, &
  & 0.66776695E-10_JPRB, 0.64868777E-10_JPRB, 0.63021782E-10_JPRB, 0.61282840E-10_JPRB, 0.59670997E-10_JPRB, 0.58184506E-10_JPRB, &
  & 0.56819344E-10_JPRB, 0.55538286E-10_JPRB, 0.54322172E-10_JPRB, 0.53161267E-10_JPRB, 0.52057404E-10_JPRB, 0.51008579E-10_JPRB, &
  & 0.50015294E-10_JPRB, 0.49075553E-10_JPRB, 0.48189105E-10_JPRB, 0.47358388E-10_JPRB, 0.46585336E-10_JPRB, 0.45873402E-10_JPRB, &
  & 0.45225317E-10_JPRB, 0.44623746E-10_JPRB, 0.44002482E-10_JPRB, 0.43046948E-10_JPRB /)

RGHG9(:,33, 6) = (/ &
  & 0.40096874E-10_JPRB, 0.40254442E-10_JPRB, 0.40408749E-10_JPRB, 0.40605540E-10_JPRB, 0.40891950E-10_JPRB, 0.41317061E-10_JPRB, &
  & 0.41948507E-10_JPRB, 0.42860795E-10_JPRB, 0.44085430E-10_JPRB, 0.45633424E-10_JPRB, 0.47494682E-10_JPRB, 0.49628076E-10_JPRB, &
  & 0.51987022E-10_JPRB, 0.54491817E-10_JPRB, 0.57073915E-10_JPRB, 0.59646128E-10_JPRB, 0.62150694E-10_JPRB, 0.64508121E-10_JPRB, &
  & 0.66655841E-10_JPRB, 0.68539577E-10_JPRB, 0.70120354E-10_JPRB, 0.71376530E-10_JPRB, 0.72310845E-10_JPRB, 0.72957952E-10_JPRB, &
  & 0.73374980E-10_JPRB, 0.73643702E-10_JPRB, 0.73872956E-10_JPRB, 0.74144677E-10_JPRB, 0.74553953E-10_JPRB, 0.75144543E-10_JPRB, &
  & 0.75905178E-10_JPRB, 0.76742022E-10_JPRB, 0.77520462E-10_JPRB, 0.78101095E-10_JPRB, 0.78389663E-10_JPRB, 0.78332910E-10_JPRB, &
  & 0.77934312E-10_JPRB, 0.77215991E-10_JPRB, 0.76202517E-10_JPRB, 0.74917295E-10_JPRB, 0.73427091E-10_JPRB, 0.71793627E-10_JPRB, &
  & 0.70113339E-10_JPRB, 0.68424807E-10_JPRB, 0.66766453E-10_JPRB, 0.65159697E-10_JPRB, 0.63635278E-10_JPRB, 0.62194257E-10_JPRB, &
  & 0.60832762E-10_JPRB, 0.59542746E-10_JPRB, 0.58299823E-10_JPRB, 0.57108398E-10_JPRB, 0.55970336E-10_JPRB, 0.54891449E-10_JPRB, &
  & 0.53873288E-10_JPRB, 0.52913125E-10_JPRB, 0.52011430E-10_JPRB, 0.51168656E-10_JPRB, 0.50385404E-10_JPRB, 0.49664401E-10_JPRB, &
  & 0.49004561E-10_JPRB, 0.48387312E-10_JPRB, 0.47746467E-10_JPRB, 0.46746960E-10_JPRB /)

RGHG9(:,34, 6) = (/ &
  & 0.43190652E-10_JPRB, 0.43488012E-10_JPRB, 0.43707281E-10_JPRB, 0.43972017E-10_JPRB, 0.44316526E-10_JPRB, 0.44799199E-10_JPRB, &
  & 0.45485470E-10_JPRB, 0.46425905E-10_JPRB, 0.47658613E-10_JPRB, 0.49189111E-10_JPRB, 0.51004402E-10_JPRB, 0.53077810E-10_JPRB, &
  & 0.55351290E-10_JPRB, 0.57763742E-10_JPRB, 0.60242700E-10_JPRB, 0.62717054E-10_JPRB, 0.65125197E-10_JPRB, 0.67404617E-10_JPRB, &
  & 0.69491024E-10_JPRB, 0.71331045E-10_JPRB, 0.72885586E-10_JPRB, 0.74133491E-10_JPRB, 0.75077729E-10_JPRB, 0.75748345E-10_JPRB, &
  & 0.76198853E-10_JPRB, 0.76499085E-10_JPRB, 0.76740642E-10_JPRB, 0.76997894E-10_JPRB, 0.77338316E-10_JPRB, 0.77812104E-10_JPRB, &
  & 0.78408793E-10_JPRB, 0.79060584E-10_JPRB, 0.79660070E-10_JPRB, 0.80095708E-10_JPRB, 0.80287284E-10_JPRB, 0.80202754E-10_JPRB, &
  & 0.79839357E-10_JPRB, 0.79217514E-10_JPRB, 0.78354385E-10_JPRB, 0.77271155E-10_JPRB, 0.76001871E-10_JPRB, 0.74613100E-10_JPRB, &
  & 0.73154295E-10_JPRB, 0.71671731E-10_JPRB, 0.70173124E-10_JPRB, 0.68685120E-10_JPRB, 0.67235204E-10_JPRB, 0.65827961E-10_JPRB, &
  & 0.64472483E-10_JPRB, 0.63166278E-10_JPRB, 0.61904301E-10_JPRB, 0.60686726E-10_JPRB, 0.59524899E-10_JPRB, 0.58427596E-10_JPRB, &
  & 0.57394138E-10_JPRB, 0.56424660E-10_JPRB, 0.55517875E-10_JPRB, 0.54674987E-10_JPRB, 0.53896144E-10_JPRB, 0.53181584E-10_JPRB, &
  & 0.52527829E-10_JPRB, 0.51916263E-10_JPRB, 0.51276119E-10_JPRB, 0.50286043E-10_JPRB /)

RGHG9(:,35, 6) = (/ &
  & 0.46139211E-10_JPRB, 0.46545812E-10_JPRB, 0.46844292E-10_JPRB, 0.47163370E-10_JPRB, 0.47563845E-10_JPRB, 0.48096263E-10_JPRB, &
  & 0.48814192E-10_JPRB, 0.49770101E-10_JPRB, 0.50984852E-10_JPRB, 0.52468700E-10_JPRB, 0.54215823E-10_JPRB, 0.56196083E-10_JPRB, &
  & 0.58364771E-10_JPRB, 0.60659686E-10_JPRB, 0.63021498E-10_JPRB, 0.65383574E-10_JPRB, 0.67688605E-10_JPRB, 0.69882655E-10_JPRB, &
  & 0.71908292E-10_JPRB, 0.73712467E-10_JPRB, 0.75252339E-10_JPRB, 0.76508126E-10_JPRB, 0.77479967E-10_JPRB, 0.78190579E-10_JPRB, &
  & 0.78687272E-10_JPRB, 0.79032093E-10_JPRB, 0.79298679E-10_JPRB, 0.79552608E-10_JPRB, 0.79846817E-10_JPRB, 0.80219609E-10_JPRB, &
  & 0.80671012E-10_JPRB, 0.81153258E-10_JPRB, 0.81589985E-10_JPRB, 0.81893430E-10_JPRB, 0.82002821E-10_JPRB, 0.81892826E-10_JPRB, &
  & 0.81566406E-10_JPRB, 0.81033097E-10_JPRB, 0.80307448E-10_JPRB, 0.79397405E-10_JPRB, 0.78330134E-10_JPRB, 0.77138816E-10_JPRB, &
  & 0.75877707E-10_JPRB, 0.74560025E-10_JPRB, 0.73201195E-10_JPRB, 0.71813638E-10_JPRB, 0.70426602E-10_JPRB, 0.69053659E-10_JPRB, &
  & 0.67701768E-10_JPRB, 0.66389748E-10_JPRB, 0.65113338E-10_JPRB, 0.63882448E-10_JPRB, 0.62710531E-10_JPRB, 0.61606484E-10_JPRB, &
  & 0.60570458E-10_JPRB, 0.59601650E-10_JPRB, 0.58700177E-10_JPRB, 0.57867031E-10_JPRB, 0.57103478E-10_JPRB, 0.56408628E-10_JPRB, &
  & 0.55775891E-10_JPRB, 0.55184066E-10_JPRB, 0.54566882E-10_JPRB, 0.53607108E-10_JPRB /)

RGHG9(:,36, 6) = (/ &
  & 0.48918002E-10_JPRB, 0.49453011E-10_JPRB, 0.49808820E-10_JPRB, 0.50186535E-10_JPRB, 0.50633674E-10_JPRB, 0.51202823E-10_JPRB, &
  & 0.51944334E-10_JPRB, 0.52892371E-10_JPRB, 0.54071969E-10_JPRB, 0.55492548E-10_JPRB, 0.57148921E-10_JPRB, 0.59020080E-10_JPRB, &
  & 0.61063550E-10_JPRB, 0.63228790E-10_JPRB, 0.65459395E-10_JPRB, 0.67701449E-10_JPRB, 0.69900738E-10_JPRB, 0.72007414E-10_JPRB, &
  & 0.73973321E-10_JPRB, 0.75749011E-10_JPRB, 0.77290230E-10_JPRB, 0.78568277E-10_JPRB, 0.79576644E-10_JPRB, 0.80332851E-10_JPRB, &
  & 0.80878172E-10_JPRB, 0.81265182E-10_JPRB, 0.81556886E-10_JPRB, 0.81808192E-10_JPRB, 0.82062294E-10_JPRB, 0.82350321E-10_JPRB, &
  & 0.82674902E-10_JPRB, 0.83008905E-10_JPRB, 0.83300040E-10_JPRB, 0.83489368E-10_JPRB, 0.83532271E-10_JPRB, 0.83410848E-10_JPRB, &
  & 0.83122294E-10_JPRB, 0.82675117E-10_JPRB, 0.82070822E-10_JPRB, 0.81311971E-10_JPRB, 0.80405210E-10_JPRB, 0.79381737E-10_JPRB, &
  & 0.78266810E-10_JPRB, 0.77086011E-10_JPRB, 0.75837614E-10_JPRB, 0.74537897E-10_JPRB, 0.73208162E-10_JPRB, 0.71864383E-10_JPRB, &
  & 0.70527015E-10_JPRB, 0.69215078E-10_JPRB, 0.67935997E-10_JPRB, 0.66704968E-10_JPRB, 0.65535521E-10_JPRB, 0.64438573E-10_JPRB, &
  & 0.63411700E-10_JPRB, 0.62454111E-10_JPRB, 0.61566016E-10_JPRB, 0.60752084E-10_JPRB, 0.60013806E-10_JPRB, 0.59349685E-10_JPRB, &
  & 0.58750706E-10_JPRB, 0.58193658E-10_JPRB, 0.57613341E-10_JPRB, 0.56714876E-10_JPRB /)

RGHG9(:,37, 6) = (/ &
  & 0.51576222E-10_JPRB, 0.52207315E-10_JPRB, 0.52628294E-10_JPRB, 0.53053752E-10_JPRB, 0.53542396E-10_JPRB, 0.54142711E-10_JPRB, &
  & 0.54889978E-10_JPRB, 0.55818256E-10_JPRB, 0.56946461E-10_JPRB, 0.58287097E-10_JPRB, 0.59840577E-10_JPRB, 0.61587985E-10_JPRB, &
  & 0.63493322E-10_JPRB, 0.65516453E-10_JPRB, 0.67609203E-10_JPRB, 0.69722346E-10_JPRB, 0.71812792E-10_JPRB, 0.73833203E-10_JPRB, &
  & 0.75742163E-10_JPRB, 0.77492353E-10_JPRB, 0.79037298E-10_JPRB, 0.80340568E-10_JPRB, 0.81379806E-10_JPRB, 0.82167072E-10_JPRB, &
  & 0.82733244E-10_JPRB, 0.83136546E-10_JPRB, 0.83429263E-10_JPRB, 0.83664346E-10_JPRB, 0.83876794E-10_JPRB, 0.84091858E-10_JPRB, &
  & 0.84313737E-10_JPRB, 0.84528134E-10_JPRB, 0.84704847E-10_JPRB, 0.84805531E-10_JPRB, 0.84804136E-10_JPRB, 0.84683614E-10_JPRB, &
  & 0.84445548E-10_JPRB, 0.84083060E-10_JPRB, 0.83596040E-10_JPRB, 0.82974058E-10_JPRB, 0.82215221E-10_JPRB, 0.81329263E-10_JPRB, &
  & 0.80340692E-10_JPRB, 0.79262832E-10_JPRB, 0.78106806E-10_JPRB, 0.76882223E-10_JPRB, 0.75605404E-10_JPRB, 0.74294529E-10_JPRB, &
  & 0.72976652E-10_JPRB, 0.71675173E-10_JPRB, 0.70405230E-10_JPRB, 0.69184179E-10_JPRB, 0.68031678E-10_JPRB, 0.66952777E-10_JPRB, &
  & 0.65945846E-10_JPRB, 0.65008138E-10_JPRB, 0.64142774E-10_JPRB, 0.63356043E-10_JPRB, 0.62652182E-10_JPRB, 0.62028396E-10_JPRB, &
  & 0.61473493E-10_JPRB, 0.60960875E-10_JPRB, 0.60430189E-10_JPRB, 0.59605966E-10_JPRB /)

RGHG9(:,38, 6) = (/ &
  & 0.54120305E-10_JPRB, 0.54835594E-10_JPRB, 0.55314961E-10_JPRB, 0.55782795E-10_JPRB, 0.56315931E-10_JPRB, 0.56935977E-10_JPRB, &
  & 0.57681040E-10_JPRB, 0.58574832E-10_JPRB, 0.59637371E-10_JPRB, 0.60885685E-10_JPRB, 0.62324437E-10_JPRB, 0.63937446E-10_JPRB, &
  & 0.65696372E-10_JPRB, 0.67568028E-10_JPRB, 0.69514630E-10_JPRB, 0.71495712E-10_JPRB, 0.73470577E-10_JPRB, 0.75402955E-10_JPRB, &
  & 0.77252045E-10_JPRB, 0.78971871E-10_JPRB, 0.80507566E-10_JPRB, 0.81803009E-10_JPRB, 0.82830590E-10_JPRB, 0.83591356E-10_JPRB, &
  & 0.84126810E-10_JPRB, 0.84494488E-10_JPRB, 0.84756570E-10_JPRB, 0.84956715E-10_JPRB, 0.85127724E-10_JPRB, 0.85286563E-10_JPRB, &
  & 0.85437817E-10_JPRB, 0.85573715E-10_JPRB, 0.85675689E-10_JPRB, 0.85723276E-10_JPRB, 0.85698400E-10_JPRB, 0.85594018E-10_JPRB, &
  & 0.85406501E-10_JPRB, 0.85127884E-10_JPRB, 0.84752413E-10_JPRB, 0.84268398E-10_JPRB, 0.83659205E-10_JPRB, 0.82920004E-10_JPRB, &
  & 0.82060816E-10_JPRB, 0.81093479E-10_JPRB, 0.80027700E-10_JPRB, 0.78873304E-10_JPRB, 0.77649998E-10_JPRB, 0.76378459E-10_JPRB, &
  & 0.75087873E-10_JPRB, 0.73809174E-10_JPRB, 0.72558300E-10_JPRB, 0.71360230E-10_JPRB, 0.70233597E-10_JPRB, 0.69182875E-10_JPRB, &
  & 0.68204602E-10_JPRB, 0.67294829E-10_JPRB, 0.66459178E-10_JPRB, 0.65707162E-10_JPRB, 0.65045247E-10_JPRB, 0.64469333E-10_JPRB, &
  & 0.63965194E-10_JPRB, 0.63503418E-10_JPRB, 0.63027368E-10_JPRB, 0.62287155E-10_JPRB /)

RGHG9(:,39, 6) = (/ &
  & 0.56557765E-10_JPRB, 0.57355391E-10_JPRB, 0.57872936E-10_JPRB, 0.58399320E-10_JPRB, 0.58960878E-10_JPRB, 0.59605626E-10_JPRB, &
  & 0.60337804E-10_JPRB, 0.61185113E-10_JPRB, 0.62170991E-10_JPRB, 0.63316657E-10_JPRB, 0.64629462E-10_JPRB, 0.66101992E-10_JPRB, &
  & 0.67707770E-10_JPRB, 0.69422926E-10_JPRB, 0.71217712E-10_JPRB, 0.73059558E-10_JPRB, 0.74914693E-10_JPRB, 0.76750238E-10_JPRB, &
  & 0.78527490E-10_JPRB, 0.80201096E-10_JPRB, 0.81692854E-10_JPRB, 0.82937053E-10_JPRB, 0.83889756E-10_JPRB, 0.84572120E-10_JPRB, &
  & 0.85034042E-10_JPRB, 0.85345037E-10_JPRB, 0.85562488E-10_JPRB, 0.85727841E-10_JPRB, 0.85865523E-10_JPRB, 0.85988230E-10_JPRB, &
  & 0.86098351E-10_JPRB, 0.86190520E-10_JPRB, 0.86252235E-10_JPRB, 0.86271913E-10_JPRB, 0.86238863E-10_JPRB, 0.86148297E-10_JPRB, &
  & 0.86003024E-10_JPRB, 0.85786961E-10_JPRB, 0.85505394E-10_JPRB, 0.85141186E-10_JPRB, 0.84671735E-10_JPRB, 0.84086321E-10_JPRB, &
  & 0.83380025E-10_JPRB, 0.82550661E-10_JPRB, 0.81596972E-10_JPRB, 0.80533087E-10_JPRB, 0.79376034E-10_JPRB, 0.78154094E-10_JPRB, &
  & 0.76903234E-10_JPRB, 0.75656405E-10_JPRB, 0.74436894E-10_JPRB, 0.73271243E-10_JPRB, 0.72179443E-10_JPRB, 0.71164248E-10_JPRB, &
  & 0.70220052E-10_JPRB, 0.69344280E-10_JPRB, 0.68543796E-10_JPRB, 0.67832906E-10_JPRB, 0.67218862E-10_JPRB, 0.66696232E-10_JPRB, &
  & 0.66245683E-10_JPRB, 0.65837676E-10_JPRB, 0.65416339E-10_JPRB, 0.64762792E-10_JPRB /)

RGHG9(:,40, 6) = (/ &
  & 0.58911695E-10_JPRB, 0.59747068E-10_JPRB, 0.60330678E-10_JPRB, 0.60882709E-10_JPRB, 0.61502074E-10_JPRB, 0.62154101E-10_JPRB, &
  & 0.62871090E-10_JPRB, 0.63666523E-10_JPRB, 0.64567379E-10_JPRB, 0.65599942E-10_JPRB, 0.66782357E-10_JPRB, 0.68107797E-10_JPRB, &
  & 0.69559546E-10_JPRB, 0.71116300E-10_JPRB, 0.72756259E-10_JPRB, 0.74453298E-10_JPRB, 0.76179694E-10_JPRB, 0.77905328E-10_JPRB, &
  & 0.79594262E-10_JPRB, 0.81183574E-10_JPRB, 0.82601967E-10_JPRB, 0.83755204E-10_JPRB, 0.84614413E-10_JPRB, 0.85205558E-10_JPRB, &
  & 0.85596134E-10_JPRB, 0.85855073E-10_JPRB, 0.86036879E-10_JPRB, 0.86175733E-10_JPRB, 0.86291169E-10_JPRB, 0.86391949E-10_JPRB, &
  & 0.86478963E-10_JPRB, 0.86547838E-10_JPRB, 0.86588646E-10_JPRB, 0.86594114E-10_JPRB, 0.86558052E-10_JPRB, 0.86478241E-10_JPRB, &
  & 0.86358906E-10_JPRB, 0.86185677E-10_JPRB, 0.85968711E-10_JPRB, 0.85689386E-10_JPRB, 0.85331478E-10_JPRB, 0.84881380E-10_JPRB, &
  & 0.84325887E-10_JPRB, 0.83648026E-10_JPRB, 0.82835336E-10_JPRB, 0.81884478E-10_JPRB, 0.80815986E-10_JPRB, 0.79661840E-10_JPRB, &
  & 0.78460773E-10_JPRB, 0.77258151E-10_JPRB, 0.76080156E-10_JPRB, 0.74955125E-10_JPRB, 0.73904979E-10_JPRB, 0.72930037E-10_JPRB, &
  & 0.72024088E-10_JPRB, 0.71184912E-10_JPRB, 0.70424187E-10_JPRB, 0.69757686E-10_JPRB, 0.69195510E-10_JPRB, 0.68727586E-10_JPRB, &
  & 0.68331757E-10_JPRB, 0.67974952E-10_JPRB, 0.67608759E-10_JPRB, 0.67035613E-10_JPRB /)

RGHG9(:,41, 6) = (/ &
  & 0.61159383E-10_JPRB, 0.62059261E-10_JPRB, 0.62652293E-10_JPRB, 0.63277363E-10_JPRB, 0.63915276E-10_JPRB, 0.64594066E-10_JPRB, &
  & 0.65288108E-10_JPRB, 0.66026969E-10_JPRB, 0.66839090E-10_JPRB, 0.67757973E-10_JPRB, 0.68803227E-10_JPRB, 0.69981528E-10_JPRB, &
  & 0.71279212E-10_JPRB, 0.72679633E-10_JPRB, 0.74164397E-10_JPRB, 0.75714414E-10_JPRB, 0.77303858E-10_JPRB, 0.78906964E-10_JPRB, &
  & 0.80486340E-10_JPRB, 0.81980651E-10_JPRB, 0.83291325E-10_JPRB, 0.84344892E-10_JPRB, 0.85108851E-10_JPRB, 0.85624313E-10_JPRB, &
  & 0.85959032E-10_JPRB, 0.86180153E-10_JPRB, 0.86336396E-10_JPRB, 0.86456967E-10_JPRB, 0.86557400E-10_JPRB, 0.86644365E-10_JPRB, &
  & 0.86717966E-10_JPRB, 0.86773394E-10_JPRB, 0.86803155E-10_JPRB, 0.86800789E-10_JPRB, 0.86764415E-10_JPRB, 0.86691418E-10_JPRB, &
  & 0.86589111E-10_JPRB, 0.86444449E-10_JPRB, 0.86268083E-10_JPRB, 0.86048141E-10_JPRB, 0.85768524E-10_JPRB, 0.85422398E-10_JPRB, &
  & 0.84993387E-10_JPRB, 0.84457677E-10_JPRB, 0.83790037E-10_JPRB, 0.82973045E-10_JPRB, 0.82013105E-10_JPRB, 0.80941233E-10_JPRB, &
  & 0.79805523E-10_JPRB, 0.78655416E-10_JPRB, 0.77528435E-10_JPRB, 0.76450984E-10_JPRB, 0.75446926E-10_JPRB, 0.74515470E-10_JPRB, &
  & 0.73649364E-10_JPRB, 0.72850011E-10_JPRB, 0.72129219E-10_JPRB, 0.71510069E-10_JPRB, 0.70999748E-10_JPRB, 0.70585870E-10_JPRB, &
  & 0.70241354E-10_JPRB, 0.69933746E-10_JPRB, 0.69615820E-10_JPRB, 0.69118558E-10_JPRB /)

RGHG9(:,42, 6) = (/ &
  & 0.63349520E-10_JPRB, 0.64254407E-10_JPRB, 0.64901362E-10_JPRB, 0.65537568E-10_JPRB, 0.66238015E-10_JPRB, 0.66919546E-10_JPRB, &
  & 0.67594874E-10_JPRB, 0.68277606E-10_JPRB, 0.69002713E-10_JPRB, 0.69805564E-10_JPRB, 0.70717376E-10_JPRB, 0.71749828E-10_JPRB, &
  & 0.72896834E-10_JPRB, 0.74144871E-10_JPRB, 0.75477950E-10_JPRB, 0.76877359E-10_JPRB, 0.78325728E-10_JPRB, 0.79794435E-10_JPRB, &
  & 0.81251172E-10_JPRB, 0.82631596E-10_JPRB, 0.83844355E-10_JPRB, 0.84797079E-10_JPRB, 0.85475238E-10_JPRB, 0.85924337E-10_JPRB, &
  & 0.86214494E-10_JPRB, 0.86407270E-10_JPRB, 0.86544910E-10_JPRB, 0.86652241E-10_JPRB, 0.86742252E-10_JPRB, 0.86819968E-10_JPRB, &
  & 0.86884985E-10_JPRB, 0.86932628E-10_JPRB, 0.86955852E-10_JPRB, 0.86949281E-10_JPRB, 0.86913365E-10_JPRB, 0.86845683E-10_JPRB, &
  & 0.86754944E-10_JPRB, 0.86628982E-10_JPRB, 0.86481475E-10_JPRB, 0.86299842E-10_JPRB, 0.86077041E-10_JPRB, 0.85806119E-10_JPRB, &
  & 0.85473177E-10_JPRB, 0.85056281E-10_JPRB, 0.84523416E-10_JPRB, 0.83845278E-10_JPRB, 0.83009703E-10_JPRB, 0.82038674E-10_JPRB, &
  & 0.80978918E-10_JPRB, 0.79891579E-10_JPRB, 0.78821893E-10_JPRB, 0.77798296E-10_JPRB, 0.76843976E-10_JPRB, 0.75959183E-10_JPRB, &
  & 0.75135509E-10_JPRB, 0.74375214E-10_JPRB, 0.73697277E-10_JPRB, 0.73124173E-10_JPRB, 0.72664541E-10_JPRB, 0.72300846E-10_JPRB, &
  & 0.72003285E-10_JPRB, 0.71738372E-10_JPRB, 0.71464404E-10_JPRB, 0.71030640E-10_JPRB /)

RGHG9(:,43, 6) = (/ &
  & 0.65471843E-10_JPRB, 0.66408920E-10_JPRB, 0.67037639E-10_JPRB, 0.67731730E-10_JPRB, 0.68444257E-10_JPRB, 0.69149943E-10_JPRB, &
  & 0.69800957E-10_JPRB, 0.70430085E-10_JPRB, 0.71071433E-10_JPRB, 0.71766232E-10_JPRB, 0.72548065E-10_JPRB, 0.73439622E-10_JPRB, &
  & 0.74442161E-10_JPRB, 0.75544293E-10_JPRB, 0.76728686E-10_JPRB, 0.77981351E-10_JPRB, 0.79280540E-10_JPRB, 0.80609470E-10_JPRB, &
  & 0.81931899E-10_JPRB, 0.83193855E-10_JPRB, 0.84295945E-10_JPRB, 0.85159588E-10_JPRB, 0.85762168E-10_JPRB, 0.86156027E-10_JPRB, &
  & 0.86409352E-10_JPRB, 0.86579327E-10_JPRB, 0.86702694E-10_JPRB, 0.86800095E-10_JPRB, 0.86882369E-10_JPRB, 0.86953639E-10_JPRB, &
  & 0.87013168E-10_JPRB, 0.87055751E-10_JPRB, 0.87075208E-10_JPRB, 0.87066666E-10_JPRB, 0.87031285E-10_JPRB, 0.86968432E-10_JPRB, &
  & 0.86884958E-10_JPRB, 0.86774060E-10_JPRB, 0.86644157E-10_JPRB, 0.86492015E-10_JPRB, 0.86308148E-10_JPRB, 0.86092022E-10_JPRB, &
  & 0.85832563E-10_JPRB, 0.85509606E-10_JPRB, 0.85094383E-10_JPRB, 0.84551532E-10_JPRB, 0.83851009E-10_JPRB, 0.82995506E-10_JPRB, &
  & 0.82025893E-10_JPRB, 0.81009380E-10_JPRB, 0.80000534E-10_JPRB, 0.79035237E-10_JPRB, 0.78134388E-10_JPRB, 0.77298848E-10_JPRB, &
  & 0.76519513E-10_JPRB, 0.75802122E-10_JPRB, 0.75166165E-10_JPRB, 0.74639593E-10_JPRB, 0.74227187E-10_JPRB, 0.73908830E-10_JPRB, &
  & 0.73651495E-10_JPRB, 0.73423614E-10_JPRB, 0.73184875E-10_JPRB, 0.72803985E-10_JPRB /)

RGHG9(:,44, 6) = (/ &
  & 0.67594742E-10_JPRB, 0.68487258E-10_JPRB, 0.69144711E-10_JPRB, 0.69817069E-10_JPRB, 0.70580833E-10_JPRB, 0.71283590E-10_JPRB, &
  & 0.71919630E-10_JPRB, 0.72497161E-10_JPRB, 0.73062806E-10_JPRB, 0.73655755E-10_JPRB, 0.74319086E-10_JPRB, 0.75077673E-10_JPRB, &
  & 0.75943758E-10_JPRB, 0.76906412E-10_JPRB, 0.77951021E-10_JPRB, 0.79054423E-10_JPRB, 0.80206432E-10_JPRB, 0.81383539E-10_JPRB, &
  & 0.82568695E-10_JPRB, 0.83698867E-10_JPRB, 0.84694612E-10_JPRB, 0.85462297E-10_JPRB, 0.85996626E-10_JPRB, 0.86342364E-10_JPRB, &
  & 0.86565741E-10_JPRB, 0.86717265E-10_JPRB, 0.86829169E-10_JPRB, 0.86918847E-10_JPRB, 0.86995446E-10_JPRB, 0.87062205E-10_JPRB, &
  & 0.87117952E-10_JPRB, 0.87157614E-10_JPRB, 0.87174767E-10_JPRB, 0.87165497E-10_JPRB, 0.87131094E-10_JPRB, 0.87072204E-10_JPRB, &
  & 0.86994363E-10_JPRB, 0.86893451E-10_JPRB, 0.86777849E-10_JPRB, 0.86644990E-10_JPRB, 0.86490932E-10_JPRB, 0.86315052E-10_JPRB, &
  & 0.86110286E-10_JPRB, 0.85862213E-10_JPRB, 0.85546244E-10_JPRB, 0.85125601E-10_JPRB, 0.84565521E-10_JPRB, 0.83839866E-10_JPRB, &
  & 0.82978430E-10_JPRB, 0.82039819E-10_JPRB, 0.81098045E-10_JPRB, 0.80195468E-10_JPRB, 0.79352004E-10_JPRB, 0.78569914E-10_JPRB, &
  & 0.77839693E-10_JPRB, 0.77166912E-10_JPRB, 0.76576578E-10_JPRB, 0.76094464E-10_JPRB, 0.75726418E-10_JPRB, 0.75446885E-10_JPRB, &
  & 0.75224368E-10_JPRB, 0.75025472E-10_JPRB, 0.74816528E-10_JPRB, 0.74475016E-10_JPRB /)

RGHG9(:,45, 6) = (/ &
  & 0.69713346E-10_JPRB, 0.70586925E-10_JPRB, 0.71168016E-10_JPRB, 0.71876366E-10_JPRB, 0.72619848E-10_JPRB, 0.73351818E-10_JPRB, &
  & 0.73960366E-10_JPRB, 0.74496256E-10_JPRB, 0.74990444E-10_JPRB, 0.75496741E-10_JPRB, 0.76049091E-10_JPRB, 0.76688815E-10_JPRB, &
  & 0.77426184E-10_JPRB, 0.78260447E-10_JPRB, 0.79166750E-10_JPRB, 0.80131402E-10_JPRB, 0.81128021E-10_JPRB, 0.82154297E-10_JPRB, &
  & 0.83181163E-10_JPRB, 0.84179060E-10_JPRB, 0.85047427E-10_JPRB, 0.85727418E-10_JPRB, 0.86193261E-10_JPRB, 0.86497434E-10_JPRB, &
  & 0.86694853E-10_JPRB, 0.86831396E-10_JPRB, 0.86934029E-10_JPRB, 0.87017754E-10_JPRB, 0.87090064E-10_JPRB, 0.87153729E-10_JPRB, &
  & 0.87207103E-10_JPRB, 0.87244940E-10_JPRB, 0.87261039E-10_JPRB, 0.87251886E-10_JPRB, 0.87218698E-10_JPRB, 0.87163186E-10_JPRB, &
  & 0.87089273E-10_JPRB, 0.86996410E-10_JPRB, 0.86889995E-10_JPRB, 0.86772561E-10_JPRB, 0.86639806E-10_JPRB, 0.86493888E-10_JPRB, &
  & 0.86331137E-10_JPRB, 0.86140470E-10_JPRB, 0.85903132E-10_JPRB, 0.85590854E-10_JPRB, 0.85160379E-10_JPRB, 0.84582188E-10_JPRB, &
  & 0.83842724E-10_JPRB, 0.83004242E-10_JPRB, 0.82136110E-10_JPRB, 0.81301937E-10_JPRB, 0.80523282E-10_JPRB, 0.79798786E-10_JPRB, &
  & 0.79123728E-10_JPRB, 0.78502732E-10_JPRB, 0.77958896E-10_JPRB, 0.77522135E-10_JPRB, 0.77192967E-10_JPRB, 0.76948128E-10_JPRB, &
  & 0.76752271E-10_JPRB, 0.76578383E-10_JPRB, 0.76390408E-10_JPRB, 0.76081474E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART11',1,ZHOOK_HANDLE)
END SUBROUTINE PART11




SUBROUTINE PART12
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART12',0,ZHOOK_HANDLE)



RGHG9(:,46, 6) = (/ &
  & 0.71726555E-10_JPRB, 0.72569339E-10_JPRB, 0.73201209E-10_JPRB, 0.73843300E-10_JPRB, 0.74643181E-10_JPRB, 0.75352578E-10_JPRB, &
  & 0.75959350E-10_JPRB, 0.76446585E-10_JPRB, 0.76884200E-10_JPRB, 0.77306370E-10_JPRB, 0.77768056E-10_JPRB, 0.78294440E-10_JPRB, &
  & 0.78917047E-10_JPRB, 0.79626049E-10_JPRB, 0.80407091E-10_JPRB, 0.81226248E-10_JPRB, 0.82076693E-10_JPRB, 0.82936311E-10_JPRB, &
  & 0.83806372E-10_JPRB, 0.84634827E-10_JPRB, 0.85378954E-10_JPRB, 0.85954910E-10_JPRB, 0.86361716E-10_JPRB, 0.86627101E-10_JPRB, &
  & 0.86803495E-10_JPRB, 0.86927431E-10_JPRB, 0.87022736E-10_JPRB, 0.87101729E-10_JPRB, 0.87171013E-10_JPRB, 0.87232561E-10_JPRB, &
  & 0.87284534E-10_JPRB, 0.87321532E-10_JPRB, 0.87337394E-10_JPRB, 0.87328991E-10_JPRB, 0.87297281E-10_JPRB, 0.87244469E-10_JPRB, &
  & 0.87173838E-10_JPRB, 0.87086109E-10_JPRB, 0.86987688E-10_JPRB, 0.86880600E-10_JPRB, 0.86764276E-10_JPRB, 0.86641243E-10_JPRB, &
  & 0.86509223E-10_JPRB, 0.86362174E-10_JPRB, 0.86186683E-10_JPRB, 0.85958407E-10_JPRB, 0.85647781E-10_JPRB, 0.85208278E-10_JPRB, &
  & 0.84622837E-10_JPRB, 0.83902191E-10_JPRB, 0.83133465E-10_JPRB, 0.82375759E-10_JPRB, 0.81665286E-10_JPRB, 0.81007263E-10_JPRB, &
  & 0.80393581E-10_JPRB, 0.79827346E-10_JPRB, 0.79334546E-10_JPRB, 0.78939646E-10_JPRB, 0.78647054E-10_JPRB, 0.78429409E-10_JPRB, &
  & 0.78257109E-10_JPRB, 0.78100797E-10_JPRB, 0.77931918E-10_JPRB, 0.77645383E-10_JPRB /)

RGHG9(:,47, 6) = (/ &
  & 0.73917525E-10_JPRB, 0.74681795E-10_JPRB, 0.75202677E-10_JPRB, 0.75875889E-10_JPRB, 0.76617643E-10_JPRB, 0.77369521E-10_JPRB, &
  & 0.77939266E-10_JPRB, 0.78395811E-10_JPRB, 0.78769297E-10_JPRB, 0.79126011E-10_JPRB, 0.79495494E-10_JPRB, 0.79927287E-10_JPRB, &
  & 0.80436491E-10_JPRB, 0.81032084E-10_JPRB, 0.81683472E-10_JPRB, 0.82369847E-10_JPRB, 0.83059969E-10_JPRB, 0.83753067E-10_JPRB, &
  & 0.84431614E-10_JPRB, 0.85090567E-10_JPRB, 0.85677743E-10_JPRB, 0.86159822E-10_JPRB, 0.86503554E-10_JPRB, 0.86737215E-10_JPRB, &
  & 0.86895074E-10_JPRB, 0.87009122E-10_JPRB, 0.87098419E-10_JPRB, 0.87173962E-10_JPRB, 0.87240992E-10_JPRB, 0.87301298E-10_JPRB, &
  & 0.87352604E-10_JPRB, 0.87389450E-10_JPRB, 0.87405756E-10_JPRB, 0.87398519E-10_JPRB, 0.87368494E-10_JPRB, 0.87317931E-10_JPRB, &
  & 0.87249583E-10_JPRB, 0.87166184E-10_JPRB, 0.87073210E-10_JPRB, 0.86974372E-10_JPRB, 0.86870559E-10_JPRB, 0.86763867E-10_JPRB, &
  & 0.86655509E-10_JPRB, 0.86540608E-10_JPRB, 0.86409768E-10_JPRB, 0.86248807E-10_JPRB, 0.86029989E-10_JPRB, 0.85723935E-10_JPRB, &
  & 0.85289178E-10_JPRB, 0.84732221E-10_JPRB, 0.84082380E-10_JPRB, 0.83427015E-10_JPRB, 0.82798018E-10_JPRB, 0.82211446E-10_JPRB, &
  & 0.81662614E-10_JPRB, 0.81156235E-10_JPRB, 0.80710265E-10_JPRB, 0.80355965E-10_JPRB, 0.80093515E-10_JPRB, 0.79899795E-10_JPRB, &
  & 0.79744766E-10_JPRB, 0.79603740E-10_JPRB, 0.79447803E-10_JPRB, 0.79180572E-10_JPRB /)

RGHG9(:,48, 6) = (/ &
  & 0.75841292E-10_JPRB, 0.76645738E-10_JPRB, 0.77237966E-10_JPRB, 0.77874068E-10_JPRB, 0.78676281E-10_JPRB, 0.79401513E-10_JPRB, &
  & 0.79973334E-10_JPRB, 0.80377954E-10_JPRB, 0.80700356E-10_JPRB, 0.80982360E-10_JPRB, 0.81276423E-10_JPRB, 0.81608539E-10_JPRB, &
  & 0.82015256E-10_JPRB, 0.82492721E-10_JPRB, 0.83019723E-10_JPRB, 0.83555551E-10_JPRB, 0.84079799E-10_JPRB, 0.84577956E-10_JPRB, &
  & 0.85054061E-10_JPRB, 0.85517315E-10_JPRB, 0.85956089E-10_JPRB, 0.86334669E-10_JPRB, 0.86625790E-10_JPRB, 0.86829821E-10_JPRB, &
  & 0.86973095E-10_JPRB, 0.87078914E-10_JPRB, 0.87163658E-10_JPRB, 0.87236440E-10_JPRB, 0.87302054E-10_JPRB, 0.87361632E-10_JPRB, &
  & 0.87412827E-10_JPRB, 0.87450061E-10_JPRB, 0.87467367E-10_JPRB, 0.87461635E-10_JPRB, 0.87433394E-10_JPRB, 0.87384544E-10_JPRB, &
  & 0.87318312E-10_JPRB, 0.87237946E-10_JPRB, 0.87149614E-10_JPRB, 0.87057049E-10_JPRB, 0.86962007E-10_JPRB, 0.86868381E-10_JPRB, &
  & 0.86776593E-10_JPRB, 0.86685256E-10_JPRB, 0.86588292E-10_JPRB, 0.86474120E-10_JPRB, 0.86328125E-10_JPRB, 0.86124455E-10_JPRB, &
  & 0.85839155E-10_JPRB, 0.85446580E-10_JPRB, 0.84975908E-10_JPRB, 0.84450114E-10_JPRB, 0.83933582E-10_JPRB, 0.83431748E-10_JPRB, &
  & 0.82953894E-10_JPRB, 0.82501665E-10_JPRB, 0.82099251E-10_JPRB, 0.81775683E-10_JPRB, 0.81537666E-10_JPRB, 0.81361307E-10_JPRB, &
  & 0.81219594E-10_JPRB, 0.81089031E-10_JPRB, 0.80942864E-10_JPRB, 0.80688733E-10_JPRB /)

RGHG9(:,49, 6) = (/ &
  & 0.77825080E-10_JPRB, 0.78682318E-10_JPRB, 0.79273997E-10_JPRB, 0.79947701E-10_JPRB, 0.80735044E-10_JPRB, 0.81486665E-10_JPRB, &
  & 0.82016387E-10_JPRB, 0.82376529E-10_JPRB, 0.82634025E-10_JPRB, 0.82851184E-10_JPRB, 0.83061349E-10_JPRB, 0.83305862E-10_JPRB, &
  & 0.83601376E-10_JPRB, 0.83956390E-10_JPRB, 0.84339029E-10_JPRB, 0.84709170E-10_JPRB, 0.85042723E-10_JPRB, 0.85338209E-10_JPRB, &
  & 0.85620469E-10_JPRB, 0.85898358E-10_JPRB, 0.86200165E-10_JPRB, 0.86486769E-10_JPRB, 0.86727868E-10_JPRB, 0.86908480E-10_JPRB, &
  & 0.87039639E-10_JPRB, 0.87139185E-10_JPRB, 0.87220307E-10_JPRB, 0.87291153E-10_JPRB, 0.87355734E-10_JPRB, 0.87415075E-10_JPRB, &
  & 0.87466555E-10_JPRB, 0.87504573E-10_JPRB, 0.87523211E-10_JPRB, 0.87519172E-10_JPRB, 0.87492708E-10_JPRB, 0.87445377E-10_JPRB, &
  & 0.87380853E-10_JPRB, 0.87303394E-10_JPRB, 0.87218552E-10_JPRB, 0.87130754E-10_JPRB, 0.87042783E-10_JPRB, 0.86957851E-10_JPRB, &
  & 0.86879060E-10_JPRB, 0.86804924E-10_JPRB, 0.86731740E-10_JPRB, 0.86651956E-10_JPRB, 0.86555582E-10_JPRB, 0.86428462E-10_JPRB, &
  & 0.86253463E-10_JPRB, 0.86020142E-10_JPRB, 0.85720354E-10_JPRB, 0.85384318E-10_JPRB, 0.85010832E-10_JPRB, 0.84634189E-10_JPRB, &
  & 0.84248122E-10_JPRB, 0.83859100E-10_JPRB, 0.83496467E-10_JPRB, 0.83199767E-10_JPRB, 0.82977687E-10_JPRB, 0.82814464E-10_JPRB, &
  & 0.82680966E-10_JPRB, 0.82557204E-10_JPRB, 0.82415665E-10_JPRB, 0.82167079E-10_JPRB /)

RGHG9(:,50, 6) = (/ &
  & 0.79836318E-10_JPRB, 0.80682308E-10_JPRB, 0.81246565E-10_JPRB, 0.81904782E-10_JPRB, 0.82664667E-10_JPRB, 0.83359326E-10_JPRB, &
  & 0.83824170E-10_JPRB, 0.84111225E-10_JPRB, 0.84302391E-10_JPRB, 0.84450551E-10_JPRB, 0.84594116E-10_JPRB, 0.84748833E-10_JPRB, &
  & 0.84944170E-10_JPRB, 0.85172348E-10_JPRB, 0.85407077E-10_JPRB, 0.85616930E-10_JPRB, 0.85789403E-10_JPRB, 0.85934926E-10_JPRB, &
  & 0.86066314E-10_JPRB, 0.86224694E-10_JPRB, 0.86402746E-10_JPRB, 0.86616367E-10_JPRB, 0.86814000E-10_JPRB, 0.86974948E-10_JPRB, &
  & 0.87097121E-10_JPRB, 0.87191879E-10_JPRB, 0.87270330E-10_JPRB, 0.87339629E-10_JPRB, 0.87403543E-10_JPRB, 0.87462836E-10_JPRB, &
  & 0.87514843E-10_JPRB, 0.87553916E-10_JPRB, 0.87574115E-10_JPRB, 0.87571880E-10_JPRB, 0.87547067E-10_JPRB, 0.87501006E-10_JPRB, &
  & 0.87438549E-10_JPRB, 0.87363096E-10_JPRB, 0.87281696E-10_JPRB, 0.87197617E-10_JPRB, 0.87114420E-10_JPRB, 0.87036649E-10_JPRB, &
  & 0.86966843E-10_JPRB, 0.86906274E-10_JPRB, 0.86850034E-10_JPRB, 0.86794183E-10_JPRB, 0.86730394E-10_JPRB, 0.86653032E-10_JPRB, &
  & 0.86551946E-10_JPRB, 0.86422591E-10_JPRB, 0.86265557E-10_JPRB, 0.86076389E-10_JPRB, 0.85872920E-10_JPRB, 0.85642077E-10_JPRB, &
  & 0.85386462E-10_JPRB, 0.85108934E-10_JPRB, 0.84820873E-10_JPRB, 0.84568436E-10_JPRB, 0.84378574E-10_JPRB, 0.84229762E-10_JPRB, &
  & 0.84109511E-10_JPRB, 0.83990294E-10_JPRB, 0.83853334E-10_JPRB, 0.83597587E-10_JPRB /)

RGHG9(:,51, 6) = (/ &
  & 0.81616339E-10_JPRB, 0.82394688E-10_JPRB, 0.82952978E-10_JPRB, 0.83505300E-10_JPRB, 0.84174813E-10_JPRB, 0.84735871E-10_JPRB, &
  & 0.85090830E-10_JPRB, 0.85289276E-10_JPRB, 0.85416181E-10_JPRB, 0.85513152E-10_JPRB, 0.85598507E-10_JPRB, 0.85697657E-10_JPRB, &
  & 0.85811608E-10_JPRB, 0.85947471E-10_JPRB, 0.86079331E-10_JPRB, 0.86188313E-10_JPRB, 0.86270546E-10_JPRB, 0.86333718E-10_JPRB, &
  & 0.86398354E-10_JPRB, 0.86468770E-10_JPRB, 0.86583400E-10_JPRB, 0.86723184E-10_JPRB, 0.86886998E-10_JPRB, 0.87031972E-10_JPRB, &
  & 0.87147373E-10_JPRB, 0.87238806E-10_JPRB, 0.87315342E-10_JPRB, 0.87383475E-10_JPRB, 0.87446841E-10_JPRB, 0.87506141E-10_JPRB, &
  & 0.87558731E-10_JPRB, 0.87598956E-10_JPRB, 0.87620786E-10_JPRB, 0.87620342E-10_JPRB, 0.87597006E-10_JPRB, 0.87552757E-10_JPRB, &
  & 0.87491361E-10_JPRB, 0.87418905E-10_JPRB, 0.87339705E-10_JPRB, 0.87258867E-10_JPRB, 0.87179541E-10_JPRB, 0.87106544E-10_JPRB, &
  & 0.87044989E-10_JPRB, 0.86993593E-10_JPRB, 0.86950946E-10_JPRB, 0.86910069E-10_JPRB, 0.86868679E-10_JPRB, 0.86819919E-10_JPRB, &
  & 0.86762604E-10_JPRB, 0.86692736E-10_JPRB, 0.86610843E-10_JPRB, 0.86521096E-10_JPRB, 0.86418234E-10_JPRB, 0.86307690E-10_JPRB, &
  & 0.86182284E-10_JPRB, 0.86029156E-10_JPRB, 0.85864330E-10_JPRB, 0.85709093E-10_JPRB, 0.85575949E-10_JPRB, 0.85474766E-10_JPRB, &
  & 0.85378378E-10_JPRB, 0.85283641E-10_JPRB, 0.85155293E-10_JPRB, 0.84918364E-10_JPRB /)

RGHG9(:,52, 6) = (/ &
  & 0.83215788E-10_JPRB, 0.83854777E-10_JPRB, 0.84242377E-10_JPRB, 0.84701086E-10_JPRB, 0.85191257E-10_JPRB, 0.85612517E-10_JPRB, &
  & 0.85849390E-10_JPRB, 0.85981805E-10_JPRB, 0.86062324E-10_JPRB, 0.86121138E-10_JPRB, 0.86177745E-10_JPRB, 0.86234339E-10_JPRB, &
  & 0.86308009E-10_JPRB, 0.86388431E-10_JPRB, 0.86465717E-10_JPRB, 0.86524676E-10_JPRB, 0.86565623E-10_JPRB, 0.86596924E-10_JPRB, &
  & 0.86623875E-10_JPRB, 0.86665716E-10_JPRB, 0.86721533E-10_JPRB, 0.86824235E-10_JPRB, 0.86949822E-10_JPRB, 0.87081432E-10_JPRB, &
  & 0.87192274E-10_JPRB, 0.87281481E-10_JPRB, 0.87356657E-10_JPRB, 0.87423860E-10_JPRB, 0.87486678E-10_JPRB, 0.87545915E-10_JPRB, &
  & 0.87598991E-10_JPRB, 0.87640381E-10_JPRB, 0.87663793E-10_JPRB, 0.87665111E-10_JPRB, 0.87643559E-10_JPRB, 0.87600337E-10_JPRB, &
  & 0.87541481E-10_JPRB, 0.87470239E-10_JPRB, 0.87394036E-10_JPRB, 0.87315391E-10_JPRB, 0.87238917E-10_JPRB, 0.87170882E-10_JPRB, &
  & 0.87114684E-10_JPRB, 0.87072190E-10_JPRB, 0.87037863E-10_JPRB, 0.87008956E-10_JPRB, 0.86979729E-10_JPRB, 0.86949607E-10_JPRB, &
  & 0.86914483E-10_JPRB, 0.86875798E-10_JPRB, 0.86833339E-10_JPRB, 0.86786953E-10_JPRB, 0.86740934E-10_JPRB, 0.86691480E-10_JPRB, &
  & 0.86634991E-10_JPRB, 0.86572499E-10_JPRB, 0.86498836E-10_JPRB, 0.86425714E-10_JPRB, 0.86367434E-10_JPRB, 0.86311860E-10_JPRB, &
  & 0.86263267E-10_JPRB, 0.86202719E-10_JPRB, 0.86123726E-10_JPRB, 0.85930790E-10_JPRB /)

RGHG9(:,53, 6) = (/ &
  & 0.84381085E-10_JPRB, 0.84864678E-10_JPRB, 0.85192596E-10_JPRB, 0.85503257E-10_JPRB, 0.85866231E-10_JPRB, 0.86148304E-10_JPRB, &
  & 0.86310563E-10_JPRB, 0.86393732E-10_JPRB, 0.86444935E-10_JPRB, 0.86483910E-10_JPRB, 0.86517030E-10_JPRB, 0.86556755E-10_JPRB, &
  & 0.86600317E-10_JPRB, 0.86653719E-10_JPRB, 0.86701334E-10_JPRB, 0.86736361E-10_JPRB, 0.86759266E-10_JPRB, 0.86774248E-10_JPRB, &
  & 0.86790047E-10_JPRB, 0.86808123E-10_JPRB, 0.86847474E-10_JPRB, 0.86907231E-10_JPRB, 0.87009823E-10_JPRB, 0.87126792E-10_JPRB, &
  & 0.87233179E-10_JPRB, 0.87320970E-10_JPRB, 0.87395133E-10_JPRB, 0.87461607E-10_JPRB, 0.87523835E-10_JPRB, 0.87582899E-10_JPRB, &
  & 0.87636370E-10_JPRB, 0.87678712E-10_JPRB, 0.87703657E-10_JPRB, 0.87706807E-10_JPRB, 0.87686726E-10_JPRB, 0.87645759E-10_JPRB, &
  & 0.87587756E-10_JPRB, 0.87519297E-10_JPRB, 0.87444399E-10_JPRB, 0.87367828E-10_JPRB, 0.87294415E-10_JPRB, 0.87229758E-10_JPRB, &
  & 0.87179743E-10_JPRB, 0.87142911E-10_JPRB, 0.87116175E-10_JPRB, 0.87093902E-10_JPRB, 0.87074008E-10_JPRB, 0.87052886E-10_JPRB, &
  & 0.87031105E-10_JPRB, 0.87007304E-10_JPRB, 0.86982754E-10_JPRB, 0.86959329E-10_JPRB, 0.86935861E-10_JPRB, 0.86912949E-10_JPRB, &
  & 0.86889544E-10_JPRB, 0.86861157E-10_JPRB, 0.86830952E-10_JPRB, 0.86802163E-10_JPRB, 0.86775268E-10_JPRB, 0.86754492E-10_JPRB, &
  & 0.86731469E-10_JPRB, 0.86707246E-10_JPRB, 0.86667604E-10_JPRB, 0.86571784E-10_JPRB /)

RGHG9(:,54, 6) = (/ &
  & 0.85335392E-10_JPRB, 0.85653235E-10_JPRB, 0.85847190E-10_JPRB, 0.86068583E-10_JPRB, 0.86306892E-10_JPRB, 0.86499155E-10_JPRB, &
  & 0.86602510E-10_JPRB, 0.86658361E-10_JPRB, 0.86691855E-10_JPRB, 0.86716107E-10_JPRB, 0.86739844E-10_JPRB, 0.86763208E-10_JPRB, &
  & 0.86794891E-10_JPRB, 0.86828905E-10_JPRB, 0.86861199E-10_JPRB, 0.86883528E-10_JPRB, 0.86896892E-10_JPRB, 0.86905899E-10_JPRB, &
  & 0.86912935E-10_JPRB, 0.86925439E-10_JPRB, 0.86944514E-10_JPRB, 0.86990810E-10_JPRB, 0.87065501E-10_JPRB, 0.87169799E-10_JPRB, &
  & 0.87272037E-10_JPRB, 0.87358086E-10_JPRB, 0.87431458E-10_JPRB, 0.87497148E-10_JPRB, 0.87559029E-10_JPRB, 0.87617733E-10_JPRB, &
  & 0.87671405E-10_JPRB, 0.87714509E-10_JPRB, 0.87740808E-10_JPRB, 0.87745707E-10_JPRB, 0.87727645E-10_JPRB, 0.87688135E-10_JPRB, &
  & 0.87632443E-10_JPRB, 0.87565066E-10_JPRB, 0.87491819E-10_JPRB, 0.87417150E-10_JPRB, 0.87345908E-10_JPRB, 0.87285831E-10_JPRB, &
  & 0.87240187E-10_JPRB, 0.87208858E-10_JPRB, 0.87186952E-10_JPRB, 0.87170320E-10_JPRB, 0.87155116E-10_JPRB, 0.87140385E-10_JPRB, &
  & 0.87124377E-10_JPRB, 0.87108307E-10_JPRB, 0.87092764E-10_JPRB, 0.87077956E-10_JPRB, 0.87065306E-10_JPRB, 0.87053559E-10_JPRB, &
  & 0.87041256E-10_JPRB, 0.87028898E-10_JPRB, 0.87014861E-10_JPRB, 0.87001420E-10_JPRB, 0.86991372E-10_JPRB, 0.86981880E-10_JPRB, &
  & 0.86974400E-10_JPRB, 0.86966628E-10_JPRB, 0.86961077E-10_JPRB, 0.86964477E-10_JPRB /)

RGHG9(:,55, 6) = (/ &
  & 0.85927737E-10_JPRB, 0.86163854E-10_JPRB, 0.86309251E-10_JPRB, 0.86454323E-10_JPRB, 0.86610524E-10_JPRB, 0.86735397E-10_JPRB, &
  & 0.86806368E-10_JPRB, 0.86842700E-10_JPRB, 0.86865057E-10_JPRB, 0.86882113E-10_JPRB, 0.86896754E-10_JPRB, 0.86914448E-10_JPRB, &
  & 0.86934002E-10_JPRB, 0.86958822E-10_JPRB, 0.86980700E-10_JPRB, 0.86995904E-10_JPRB, 0.87004536E-10_JPRB, 0.87009108E-10_JPRB, &
  & 0.87013258E-10_JPRB, 0.87018746E-10_JPRB, 0.87033339E-10_JPRB, 0.87061365E-10_JPRB, 0.87122920E-10_JPRB, 0.87213604E-10_JPRB, &
  & 0.87309687E-10_JPRB, 0.87393759E-10_JPRB, 0.87466007E-10_JPRB, 0.87531350E-10_JPRB, 0.87592489E-10_JPRB, 0.87651150E-10_JPRB, &
  & 0.87704691E-10_JPRB, 0.87748329E-10_JPRB, 0.87775745E-10_JPRB, 0.87782281E-10_JPRB, 0.87766086E-10_JPRB, 0.87728810E-10_JPRB, &
  & 0.87674590E-10_JPRB, 0.87608726E-10_JPRB, 0.87536749E-10_JPRB, 0.87463356E-10_JPRB, 0.87395466E-10_JPRB, 0.87338782E-10_JPRB, &
  & 0.87297815E-10_JPRB, 0.87270684E-10_JPRB, 0.87252754E-10_JPRB, 0.87239597E-10_JPRB, 0.87228155E-10_JPRB, 0.87216234E-10_JPRB, &
  & 0.87203841E-10_JPRB, 0.87191046E-10_JPRB, 0.87178820E-10_JPRB, 0.87168633E-10_JPRB, 0.87159807E-10_JPRB, 0.87152105E-10_JPRB, &
  & 0.87145138E-10_JPRB, 0.87137283E-10_JPRB, 0.87129498E-10_JPRB, 0.87122656E-10_JPRB, 0.87116550E-10_JPRB, 0.87112040E-10_JPRB, &
  & 0.87107259E-10_JPRB, 0.87102582E-10_JPRB, 0.87096441E-10_JPRB, 0.87087906E-10_JPRB /)

RGHG9(:,56, 6) = (/ &
  & 0.86429808E-10_JPRB, 0.86552987E-10_JPRB, 0.86637190E-10_JPRB, 0.86726709E-10_JPRB, 0.86829127E-10_JPRB, 0.86909369E-10_JPRB, &
  & 0.86955866E-10_JPRB, 0.86981346E-10_JPRB, 0.86996799E-10_JPRB, 0.87008165E-10_JPRB, 0.87019197E-10_JPRB, 0.87030341E-10_JPRB, &
  & 0.87045371E-10_JPRB, 0.87061941E-10_JPRB, 0.87077984E-10_JPRB, 0.87088760E-10_JPRB, 0.87094172E-10_JPRB, 0.87096524E-10_JPRB, &
  & 0.87097669E-10_JPRB, 0.87100646E-10_JPRB, 0.87108043E-10_JPRB, 0.87130664E-10_JPRB, 0.87178570E-10_JPRB, 0.87258166E-10_JPRB, &
  & 0.87347879E-10_JPRB, 0.87428842E-10_JPRB, 0.87499938E-10_JPRB, 0.87564331E-10_JPRB, 0.87625462E-10_JPRB, 0.87683472E-10_JPRB, &
  & 0.87737005E-10_JPRB, 0.87780803E-10_JPRB, 0.87808934E-10_JPRB, 0.87816879E-10_JPRB, 0.87802696E-10_JPRB, 0.87767488E-10_JPRB, &
  & 0.87715057E-10_JPRB, 0.87650623E-10_JPRB, 0.87579471E-10_JPRB, 0.87508271E-10_JPRB, 0.87442664E-10_JPRB, 0.87390255E-10_JPRB, &
  & 0.87353125E-10_JPRB, 0.87329421E-10_JPRB, 0.87314579E-10_JPRB, 0.87304136E-10_JPRB, 0.87294887E-10_JPRB, 0.87285144E-10_JPRB, &
  & 0.87274132E-10_JPRB, 0.87262669E-10_JPRB, 0.87252053E-10_JPRB, 0.87242713E-10_JPRB, 0.87235358E-10_JPRB, 0.87229217E-10_JPRB, &
  & 0.87223194E-10_JPRB, 0.87217539E-10_JPRB, 0.87211745E-10_JPRB, 0.87206561E-10_JPRB, 0.87202807E-10_JPRB, 0.87199317E-10_JPRB, &
  & 0.87196327E-10_JPRB, 0.87192732E-10_JPRB, 0.87188833E-10_JPRB, 0.87182116E-10_JPRB /)

RGHG9(:,57, 6) = (/ &
  & 0.86718535E-10_JPRB, 0.86809199E-10_JPRB, 0.86865570E-10_JPRB, 0.86927410E-10_JPRB, 0.86988444E-10_JPRB, 0.87042248E-10_JPRB, &
  & 0.87074223E-10_JPRB, 0.87091799E-10_JPRB, 0.87102756E-10_JPRB, 0.87111249E-10_JPRB, 0.87118708E-10_JPRB, 0.87127548E-10_JPRB, &
  & 0.87137589E-10_JPRB, 0.87150322E-10_JPRB, 0.87161986E-10_JPRB, 0.87169993E-10_JPRB, 0.87173491E-10_JPRB, 0.87173872E-10_JPRB, &
  & 0.87172908E-10_JPRB, 0.87172859E-10_JPRB, 0.87177446E-10_JPRB, 0.87193038E-10_JPRB, 0.87233998E-10_JPRB, 0.87304844E-10_JPRB, &
  & 0.87387104E-10_JPRB, 0.87464355E-10_JPRB, 0.87533654E-10_JPRB, 0.87597658E-10_JPRB, 0.87657902E-10_JPRB, 0.87715772E-10_JPRB, &
  & 0.87768778E-10_JPRB, 0.87812480E-10_JPRB, 0.87840984E-10_JPRB, 0.87850019E-10_JPRB, 0.87837591E-10_JPRB, 0.87804521E-10_JPRB, &
  & 0.87754033E-10_JPRB, 0.87690757E-10_JPRB, 0.87621368E-10_JPRB, 0.87551522E-10_JPRB, 0.87489418E-10_JPRB, 0.87440263E-10_JPRB, &
  & 0.87406707E-10_JPRB, 0.87385953E-10_JPRB, 0.87373345E-10_JPRB, 0.87364872E-10_JPRB, 0.87357330E-10_JPRB, 0.87348892E-10_JPRB, &
  & 0.87338942E-10_JPRB, 0.87327971E-10_JPRB, 0.87317084E-10_JPRB, 0.87307918E-10_JPRB, 0.87300334E-10_JPRB, 0.87293853E-10_JPRB, &
  & 0.87288204E-10_JPRB, 0.87282355E-10_JPRB, 0.87276880E-10_JPRB, 0.87272453E-10_JPRB, 0.87268692E-10_JPRB, 0.87265813E-10_JPRB, &
  & 0.87262718E-10_JPRB, 0.87259422E-10_JPRB, 0.87254662E-10_JPRB, 0.87246085E-10_JPRB /)

RGHG9(:,58, 6) = (/ &
  & 0.86941176E-10_JPRB, 0.86997888E-10_JPRB, 0.87036281E-10_JPRB, 0.87073092E-10_JPRB, 0.87115579E-10_JPRB, 0.87149246E-10_JPRB, &
  & 0.87171589E-10_JPRB, 0.87184246E-10_JPRB, 0.87192489E-10_JPRB, 0.87198644E-10_JPRB, 0.87204716E-10_JPRB, 0.87211023E-10_JPRB, &
  & 0.87219287E-10_JPRB, 0.87228690E-10_JPRB, 0.87238064E-10_JPRB, 0.87244378E-10_JPRB, 0.87246502E-10_JPRB, 0.87245211E-10_JPRB, &
  & 0.87242283E-10_JPRB, 0.87239452E-10_JPRB, 0.87240569E-10_JPRB, 0.87253003E-10_JPRB, 0.87288829E-10_JPRB, 0.87352015E-10_JPRB, &
  & 0.87427718E-10_JPRB, 0.87500972E-10_JPRB, 0.87568501E-10_JPRB, 0.87631249E-10_JPRB, 0.87691181E-10_JPRB, 0.87748156E-10_JPRB, &
  & 0.87800670E-10_JPRB, 0.87843940E-10_JPRB, 0.87872369E-10_JPRB, 0.87882132E-10_JPRB, 0.87871189E-10_JPRB, 0.87840096E-10_JPRB, &
  & 0.87791441E-10_JPRB, 0.87730177E-10_JPRB, 0.87661975E-10_JPRB, 0.87594897E-10_JPRB, 0.87535264E-10_JPRB, 0.87489772E-10_JPRB, &
  & 0.87459179E-10_JPRB, 0.87440624E-10_JPRB, 0.87429897E-10_JPRB, 0.87422798E-10_JPRB, 0.87416477E-10_JPRB, 0.87409080E-10_JPRB, &
  & 0.87399935E-10_JPRB, 0.87389290E-10_JPRB, 0.87378188E-10_JPRB, 0.87367988E-10_JPRB, 0.87359397E-10_JPRB, 0.87352195E-10_JPRB, &
  & 0.87345270E-10_JPRB, 0.87338817E-10_JPRB, 0.87332842E-10_JPRB, 0.87327721E-10_JPRB, 0.87324037E-10_JPRB, 0.87320651E-10_JPRB, &
  & 0.87317528E-10_JPRB, 0.87313740E-10_JPRB, 0.87308924E-10_JPRB, 0.87299140E-10_JPRB /)

RGHG9(:,59, 6) = (/ &
  & 0.87091528E-10_JPRB, 0.87136381E-10_JPRB, 0.87162652E-10_JPRB, 0.87189700E-10_JPRB, 0.87215436E-10_JPRB, 0.87239535E-10_JPRB, &
  & 0.87254974E-10_JPRB, 0.87264723E-10_JPRB, 0.87270927E-10_JPRB, 0.87276117E-10_JPRB, 0.87280787E-10_JPRB, 0.87286400E-10_JPRB, &
  & 0.87292895E-10_JPRB, 0.87301076E-10_JPRB, 0.87309014E-10_JPRB, 0.87314489E-10_JPRB, 0.87315745E-10_JPRB, 0.87312976E-10_JPRB, &
  & 0.87307522E-10_JPRB, 0.87302117E-10_JPRB, 0.87300313E-10_JPRB, 0.87309993E-10_JPRB, 0.87342203E-10_JPRB, 0.87400011E-10_JPRB, &
  & 0.87469566E-10_JPRB, 0.87539101E-10_JPRB, 0.87604465E-10_JPRB, 0.87666326E-10_JPRB, 0.87725140E-10_JPRB, 0.87781428E-10_JPRB, &
  & 0.87832949E-10_JPRB, 0.87875415E-10_JPRB, 0.87903539E-10_JPRB, 0.87913579E-10_JPRB, 0.87903719E-10_JPRB, 0.87874374E-10_JPRB, &
  & 0.87827877E-10_JPRB, 0.87768320E-10_JPRB, 0.87702741E-10_JPRB, 0.87637585E-10_JPRB, 0.87581511E-10_JPRB, 0.87538865E-10_JPRB, &
  & 0.87510714E-10_JPRB, 0.87494179E-10_JPRB, 0.87484645E-10_JPRB, 0.87478622E-10_JPRB, 0.87473105E-10_JPRB, 0.87466520E-10_JPRB, &
  & 0.87458152E-10_JPRB, 0.87448021E-10_JPRB, 0.87436745E-10_JPRB, 0.87425657E-10_JPRB, 0.87415783E-10_JPRB, 0.87406818E-10_JPRB, &
  & 0.87398630E-10_JPRB, 0.87390636E-10_JPRB, 0.87383267E-10_JPRB, 0.87377584E-10_JPRB, 0.87372859E-10_JPRB, 0.87369098E-10_JPRB, &
  & 0.87365212E-10_JPRB, 0.87360924E-10_JPRB, 0.87354922E-10_JPRB, 0.87343834E-10_JPRB /)

RGHG9(:,60, 6) = (/ &
  & 0.87214375E-10_JPRB, 0.87245586E-10_JPRB, 0.87264737E-10_JPRB, 0.87282223E-10_JPRB, 0.87301229E-10_JPRB, 0.87317209E-10_JPRB, &
  & 0.87329234E-10_JPRB, 0.87336582E-10_JPRB, 0.87342029E-10_JPRB, 0.87346269E-10_JPRB, 0.87350752E-10_JPRB, 0.87355512E-10_JPRB, &
  & 0.87361826E-10_JPRB, 0.87369154E-10_JPRB, 0.87376745E-10_JPRB, 0.87381963E-10_JPRB, 0.87382677E-10_JPRB, 0.87378299E-10_JPRB, &
  & 0.87370451E-10_JPRB, 0.87361736E-10_JPRB, 0.87357385E-10_JPRB, 0.87365115E-10_JPRB, 0.87394925E-10_JPRB, 0.87447591E-10_JPRB, &
  & 0.87512365E-10_JPRB, 0.87578438E-10_JPRB, 0.87642033E-10_JPRB, 0.87702498E-10_JPRB, 0.87760375E-10_JPRB, 0.87815484E-10_JPRB, &
  & 0.87865833E-10_JPRB, 0.87907202E-10_JPRB, 0.87934493E-10_JPRB, 0.87944443E-10_JPRB, 0.87935353E-10_JPRB, 0.87907646E-10_JPRB, &
  & 0.87863120E-10_JPRB, 0.87806276E-10_JPRB, 0.87742744E-10_JPRB, 0.87681057E-10_JPRB, 0.87627600E-10_JPRB, 0.87587881E-10_JPRB, &
  & 0.87561958E-10_JPRB, 0.87546609E-10_JPRB, 0.87538185E-10_JPRB, 0.87532800E-10_JPRB, 0.87527943E-10_JPRB, 0.87521906E-10_JPRB, &
  & 0.87514163E-10_JPRB, 0.87504649E-10_JPRB, 0.87493617E-10_JPRB, 0.87482036E-10_JPRB, 0.87470808E-10_JPRB, 0.87460296E-10_JPRB, &
  & 0.87450172E-10_JPRB, 0.87440222E-10_JPRB, 0.87431402E-10_JPRB, 0.87423957E-10_JPRB, 0.87418420E-10_JPRB, 0.87413451E-10_JPRB, &
  & 0.87408719E-10_JPRB, 0.87403210E-10_JPRB, 0.87396063E-10_JPRB, 0.87382150E-10_JPRB /)

RGHG9(:,61, 6) = (/ &
  & 0.87308188E-10_JPRB, 0.87333391E-10_JPRB, 0.87347823E-10_JPRB, 0.87361333E-10_JPRB, 0.87374483E-10_JPRB, 0.87387049E-10_JPRB, &
  & 0.87396111E-10_JPRB, 0.87402710E-10_JPRB, 0.87407338E-10_JPRB, 0.87411640E-10_JPRB, 0.87415741E-10_JPRB, 0.87420904E-10_JPRB, &
  & 0.87426996E-10_JPRB, 0.87434754E-10_JPRB, 0.87442449E-10_JPRB, 0.87447771E-10_JPRB, 0.87447993E-10_JPRB, 0.87441970E-10_JPRB, &
  & 0.87431264E-10_JPRB, 0.87419794E-10_JPRB, 0.87412994E-10_JPRB, 0.87419204E-10_JPRB, 0.87446335E-10_JPRB, 0.87495129E-10_JPRB, &
  & 0.87555622E-10_JPRB, 0.87619016E-10_JPRB, 0.87680772E-10_JPRB, 0.87740072E-10_JPRB, 0.87796742E-10_JPRB, 0.87850588E-10_JPRB, &
  & 0.87899389E-10_JPRB, 0.87939218E-10_JPRB, 0.87965350E-10_JPRB, 0.87974829E-10_JPRB, 0.87966238E-10_JPRB, 0.87939968E-10_JPRB, &
  & 0.87897786E-10_JPRB, 0.87843351E-10_JPRB, 0.87783274E-10_JPRB, 0.87724251E-10_JPRB, 0.87674243E-10_JPRB, 0.87637037E-10_JPRB, &
  & 0.87612737E-10_JPRB, 0.87598637E-10_JPRB, 0.87590719E-10_JPRB, 0.87585855E-10_JPRB, 0.87581387E-10_JPRB, 0.87575835E-10_JPRB, &
  & 0.87568605E-10_JPRB, 0.87559619E-10_JPRB, 0.87549044E-10_JPRB, 0.87537415E-10_JPRB, 0.87525390E-10_JPRB, 0.87513469E-10_JPRB, &
  & 0.87501416E-10_JPRB, 0.87489724E-10_JPRB, 0.87478524E-10_JPRB, 0.87469643E-10_JPRB, 0.87462260E-10_JPRB, 0.87456084E-10_JPRB, &
  & 0.87449846E-10_JPRB, 0.87442775E-10_JPRB, 0.87433227E-10_JPRB, 0.87415492E-10_JPRB /)

RGHG9(:,62, 6) = (/ &
  & 0.87388527E-10_JPRB, 0.87408344E-10_JPRB, 0.87419655E-10_JPRB, 0.87429924E-10_JPRB, 0.87440583E-10_JPRB, 0.87450283E-10_JPRB, &
  & 0.87458311E-10_JPRB, 0.87464022E-10_JPRB, 0.87468817E-10_JPRB, 0.87472966E-10_JPRB, 0.87477699E-10_JPRB, 0.87483021E-10_JPRB, &
  & 0.87490216E-10_JPRB, 0.87498578E-10_JPRB, 0.87507099E-10_JPRB, 0.87512622E-10_JPRB, 0.87512074E-10_JPRB, 0.87504122E-10_JPRB, &
  & 0.87490917E-10_JPRB, 0.87476797E-10_JPRB, 0.87468026E-10_JPRB, 0.87472453E-10_JPRB, 0.87497280E-10_JPRB, 0.87542390E-10_JPRB, &
  & 0.87599636E-10_JPRB, 0.87660511E-10_JPRB, 0.87720754E-10_JPRB, 0.87778861E-10_JPRB, 0.87834344E-10_JPRB, 0.87886719E-10_JPRB, &
  & 0.87933653E-10_JPRB, 0.87971616E-10_JPRB, 0.87996152E-10_JPRB, 0.88004888E-10_JPRB, 0.87996554E-10_JPRB, 0.87971706E-10_JPRB, &
  & 0.87931787E-10_JPRB, 0.87880453E-10_JPRB, 0.87823387E-10_JPRB, 0.87768189E-10_JPRB, 0.87721073E-10_JPRB, 0.87686296E-10_JPRB, &
  & 0.87663640E-10_JPRB, 0.87650144E-10_JPRB, 0.87642726E-10_JPRB, 0.87638029E-10_JPRB, 0.87633831E-10_JPRB, 0.87628647E-10_JPRB, &
  & 0.87621931E-10_JPRB, 0.87613437E-10_JPRB, 0.87603300E-10_JPRB, 0.87591823E-10_JPRB, 0.87579527E-10_JPRB, 0.87566426E-10_JPRB, &
  & 0.87553256E-10_JPRB, 0.87539490E-10_JPRB, 0.87526736E-10_JPRB, 0.87515481E-10_JPRB, 0.87506502E-10_JPRB, 0.87498370E-10_JPRB, &
  & 0.87490348E-10_JPRB, 0.87481022E-10_JPRB, 0.87468602E-10_JPRB, 0.87444461E-10_JPRB /)

RGHG9(:,63, 6) = (/ &
  & 0.87455265E-10_JPRB, 0.87472821E-10_JPRB, 0.87482743E-10_JPRB, 0.87491625E-10_JPRB, 0.87500479E-10_JPRB, 0.87509111E-10_JPRB, &
  & 0.87516230E-10_JPRB, 0.87522094E-10_JPRB, 0.87526889E-10_JPRB, 0.87531801E-10_JPRB, 0.87536936E-10_JPRB, 0.87543660E-10_JPRB, &
  & 0.87551792E-10_JPRB, 0.87561743E-10_JPRB, 0.87570999E-10_JPRB, 0.87576391E-10_JPRB, 0.87574718E-10_JPRB, 0.87565011E-10_JPRB, &
  & 0.87549655E-10_JPRB, 0.87533446E-10_JPRB, 0.87522802E-10_JPRB, 0.87525466E-10_JPRB, 0.87547906E-10_JPRB, 0.87590046E-10_JPRB, &
  & 0.87644295E-10_JPRB, 0.87703095E-10_JPRB, 0.87761937E-10_JPRB, 0.87818787E-10_JPRB, 0.87873021E-10_JPRB, 0.87923606E-10_JPRB, &
  & 0.87968521E-10_JPRB, 0.88004160E-10_JPRB, 0.88026822E-10_JPRB, 0.88034482E-10_JPRB, 0.88026357E-10_JPRB, 0.88002883E-10_JPRB, &
  & 0.87965468E-10_JPRB, 0.87917160E-10_JPRB, 0.87863931E-10_JPRB, 0.87812140E-10_JPRB, 0.87768334E-10_JPRB, 0.87735819E-10_JPRB, &
  & 0.87714315E-10_JPRB, 0.87701540E-10_JPRB, 0.87694199E-10_JPRB, 0.87689619E-10_JPRB, 0.87685553E-10_JPRB, 0.87680668E-10_JPRB, &
  & 0.87674423E-10_JPRB, 0.87666471E-10_JPRB, 0.87656778E-10_JPRB, 0.87645592E-10_JPRB, 0.87633095E-10_JPRB, 0.87619606E-10_JPRB, &
  & 0.87605145E-10_JPRB, 0.87590463E-10_JPRB, 0.87575711E-10_JPRB, 0.87562957E-10_JPRB, 0.87551695E-10_JPRB, 0.87541793E-10_JPRB, &
  & 0.87531656E-10_JPRB, 0.87520033E-10_JPRB, 0.87503726E-10_JPRB, 0.87472980E-10_JPRB /)

RGHG9(:,64, 6) = (/ &
  & 0.87513732E-10_JPRB, 0.87530386E-10_JPRB, 0.87539587E-10_JPRB, 0.87547733E-10_JPRB, 0.87555935E-10_JPRB, 0.87563831E-10_JPRB, &
  & 0.87570937E-10_JPRB, 0.87576835E-10_JPRB, 0.87582414E-10_JPRB, 0.87587854E-10_JPRB, 0.87594480E-10_JPRB, 0.87602384E-10_JPRB, &
  & 0.87612813E-10_JPRB, 0.87624269E-10_JPRB, 0.87634275E-10_JPRB, 0.87639215E-10_JPRB, 0.87636148E-10_JPRB, 0.87624560E-10_JPRB, &
  & 0.87607435E-10_JPRB, 0.87589457E-10_JPRB, 0.87577168E-10_JPRB, 0.87578125E-10_JPRB, 0.87598401E-10_JPRB, 0.87637952E-10_JPRB, &
  & 0.87689564E-10_JPRB, 0.87746442E-10_JPRB, 0.87803771E-10_JPRB, 0.87859338E-10_JPRB, 0.87911817E-10_JPRB, 0.87960444E-10_JPRB, &
  & 0.88002834E-10_JPRB, 0.88036023E-10_JPRB, 0.88056618E-10_JPRB, 0.88063092E-10_JPRB, 0.88055070E-10_JPRB, 0.88033088E-10_JPRB, &
  & 0.87998248E-10_JPRB, 0.87953374E-10_JPRB, 0.87903892E-10_JPRB, 0.87856000E-10_JPRB, 0.87815297E-10_JPRB, 0.87784918E-10_JPRB, &
  & 0.87764643E-10_JPRB, 0.87752187E-10_JPRB, 0.87744950E-10_JPRB, 0.87740273E-10_JPRB, 0.87736256E-10_JPRB, 0.87731634E-10_JPRB, &
  & 0.87725834E-10_JPRB, 0.87718451E-10_JPRB, 0.87709312E-10_JPRB, 0.87698501E-10_JPRB, 0.87686101E-10_JPRB, 0.87672244E-10_JPRB, &
  & 0.87657305E-10_JPRB, 0.87641491E-10_JPRB, 0.87625768E-10_JPRB, 0.87611175E-10_JPRB, 0.87598401E-10_JPRB, 0.87586487E-10_JPRB, &
  & 0.87574628E-10_JPRB, 0.87560556E-10_JPRB, 0.87541419E-10_JPRB, 0.87503067E-10_JPRB /)

RGHG9(:,65, 6) = (/ &
  & 0.87565399E-10_JPRB, 0.87582344E-10_JPRB, 0.87591649E-10_JPRB, 0.87599733E-10_JPRB, 0.87607699E-10_JPRB, 0.87615526E-10_JPRB, &
  & 0.87622611E-10_JPRB, 0.87629154E-10_JPRB, 0.87635246E-10_JPRB, 0.87642144E-10_JPRB, 0.87649915E-10_JPRB, 0.87660310E-10_JPRB, &
  & 0.87672605E-10_JPRB, 0.87685449E-10_JPRB, 0.87695483E-10_JPRB, 0.87699244E-10_JPRB, 0.87694893E-10_JPRB, 0.87682389E-10_JPRB, &
  & 0.87664077E-10_JPRB, 0.87644732E-10_JPRB, 0.87631097E-10_JPRB, 0.87630542E-10_JPRB, 0.87648971E-10_JPRB, 0.87685997E-10_JPRB, &
  & 0.87735333E-10_JPRB, 0.87790053E-10_JPRB, 0.87845758E-10_JPRB, 0.87899472E-10_JPRB, 0.87950001E-10_JPRB, 0.87995979E-10_JPRB, &
  & 0.88035607E-10_JPRB, 0.88066048E-10_JPRB, 0.88084560E-10_JPRB, 0.88089952E-10_JPRB, 0.88082104E-10_JPRB, 0.88061697E-10_JPRB, &
  & 0.88029611E-10_JPRB, 0.87988297E-10_JPRB, 0.87942917E-10_JPRB, 0.87898841E-10_JPRB, 0.87861357E-10_JPRB, 0.87833116E-10_JPRB, &
  & 0.87813923E-10_JPRB, 0.87801891E-10_JPRB, 0.87794598E-10_JPRB, 0.87789803E-10_JPRB, 0.87785765E-10_JPRB, 0.87781407E-10_JPRB, &
  & 0.87776078E-10_JPRB, 0.87769306E-10_JPRB, 0.87760826E-10_JPRB, 0.87750487E-10_JPRB, 0.87738372E-10_JPRB, 0.87724515E-10_JPRB, &
  & 0.87709132E-10_JPRB, 0.87692763E-10_JPRB, 0.87675985E-10_JPRB, 0.87660365E-10_JPRB, 0.87646002E-10_JPRB, 0.87632762E-10_JPRB, &
  & 0.87619210E-10_JPRB, 0.87603966E-10_JPRB, 0.87581283E-10_JPRB, 0.87538463E-10_JPRB /)

RGHG9(:,66, 6) = (/ &
  & 0.87612029E-10_JPRB, 0.87630236E-10_JPRB, 0.87640145E-10_JPRB, 0.87648652E-10_JPRB, 0.87656896E-10_JPRB, 0.87664945E-10_JPRB, &
  & 0.87672432E-10_JPRB, 0.87679433E-10_JPRB, 0.87686705E-10_JPRB, 0.87694560E-10_JPRB, 0.87704642E-10_JPRB, 0.87716834E-10_JPRB, &
  & 0.87731281E-10_JPRB, 0.87744992E-10_JPRB, 0.87754477E-10_JPRB, 0.87757572E-10_JPRB, 0.87752312E-10_JPRB, 0.87738691E-10_JPRB, &
  & 0.87719450E-10_JPRB, 0.87699265E-10_JPRB, 0.87684686E-10_JPRB, 0.87682958E-10_JPRB, 0.87699514E-10_JPRB, 0.87734417E-10_JPRB, &
  & 0.87781143E-10_JPRB, 0.87833643E-10_JPRB, 0.87887031E-10_JPRB, 0.87938573E-10_JPRB, 0.87986382E-10_JPRB, 0.88029459E-10_JPRB, &
  & 0.88065936E-10_JPRB, 0.88093519E-10_JPRB, 0.88110026E-10_JPRB, 0.88114446E-10_JPRB, 0.88106966E-10_JPRB, 0.88088169E-10_JPRB, &
  & 0.88058977E-10_JPRB, 0.88021430E-10_JPRB, 0.87980137E-10_JPRB, 0.87940093E-10_JPRB, 0.87905745E-10_JPRB, 0.87879731E-10_JPRB, &
  & 0.87861655E-10_JPRB, 0.87850088E-10_JPRB, 0.87842858E-10_JPRB, 0.87837973E-10_JPRB, 0.87834004E-10_JPRB, 0.87829889E-10_JPRB, &
  & 0.87825032E-10_JPRB, 0.87818926E-10_JPRB, 0.87811140E-10_JPRB, 0.87801433E-10_JPRB, 0.87789769E-10_JPRB, 0.87776113E-10_JPRB, &
  & 0.87760653E-10_JPRB, 0.87743882E-10_JPRB, 0.87726507E-10_JPRB, 0.87709985E-10_JPRB, 0.87694678E-10_JPRB, 0.87680224E-10_JPRB, &
  & 0.87665847E-10_JPRB, 0.87648958E-10_JPRB, 0.87625338E-10_JPRB, 0.87576876E-10_JPRB /)

RGHG9(:,67, 6) = (/ &
  & 0.87654724E-10_JPRB, 0.87675020E-10_JPRB, 0.87686108E-10_JPRB, 0.87695420E-10_JPRB, 0.87704483E-10_JPRB, 0.87712941E-10_JPRB, &
  & 0.87721122E-10_JPRB, 0.87728796E-10_JPRB, 0.87736998E-10_JPRB, 0.87746581E-10_JPRB, 0.87758120E-10_JPRB, 0.87772470E-10_JPRB, &
  & 0.87787833E-10_JPRB, 0.87801114E-10_JPRB, 0.87810065E-10_JPRB, 0.87812403E-10_JPRB, 0.87806588E-10_JPRB, 0.87792898E-10_JPRB, &
  & 0.87773483E-10_JPRB, 0.87753027E-10_JPRB, 0.87737984E-10_JPRB, 0.87735326E-10_JPRB, 0.87750356E-10_JPRB, 0.87782663E-10_JPRB, &
  & 0.87826919E-10_JPRB, 0.87876567E-10_JPRB, 0.87927200E-10_JPRB, 0.87975849E-10_JPRB, 0.88020535E-10_JPRB, 0.88060330E-10_JPRB, &
  & 0.88093519E-10_JPRB, 0.88118304E-10_JPRB, 0.88132883E-10_JPRB, 0.88136512E-10_JPRB, 0.88129525E-10_JPRB, 0.88112490E-10_JPRB, &
  & 0.88086143E-10_JPRB, 0.88052399E-10_JPRB, 0.88015220E-10_JPRB, 0.87979048E-10_JPRB, 0.87948003E-10_JPRB, 0.87924154E-10_JPRB, &
  & 0.87907438E-10_JPRB, 0.87896433E-10_JPRB, 0.87889418E-10_JPRB, 0.87884582E-10_JPRB, 0.87880744E-10_JPRB, 0.87876977E-10_JPRB, &
  & 0.87872674E-10_JPRB, 0.87867297E-10_JPRB, 0.87860275E-10_JPRB, 0.87851296E-10_JPRB, 0.87840214E-10_JPRB, 0.87826954E-10_JPRB, &
  & 0.87811668E-10_JPRB, 0.87794799E-10_JPRB, 0.87777070E-10_JPRB, 0.87760042E-10_JPRB, 0.87744124E-10_JPRB, 0.87729032E-10_JPRB, &
  & 0.87713829E-10_JPRB, 0.87696753E-10_JPRB, 0.87670524E-10_JPRB, 0.87618975E-10_JPRB /)

RGHG9(:,68, 6) = (/ &
  & 0.87692340E-10_JPRB, 0.87716959E-10_JPRB, 0.87729893E-10_JPRB, 0.87740870E-10_JPRB, 0.87750807E-10_JPRB, 0.87760521E-10_JPRB, &
  & 0.87768903E-10_JPRB, 0.87777841E-10_JPRB, 0.87786785E-10_JPRB, 0.87797915E-10_JPRB, 0.87810946E-10_JPRB, 0.87826212E-10_JPRB, &
  & 0.87841449E-10_JPRB, 0.87854446E-10_JPRB, 0.87862842E-10_JPRB, 0.87864889E-10_JPRB, 0.87858956E-10_JPRB, 0.87845321E-10_JPRB, &
  & 0.87826198E-10_JPRB, 0.87806040E-10_JPRB, 0.87791024E-10_JPRB, 0.87787777E-10_JPRB, 0.87801030E-10_JPRB, 0.87830854E-10_JPRB, &
  & 0.87871967E-10_JPRB, 0.87918381E-10_JPRB, 0.87965718E-10_JPRB, 0.88010946E-10_JPRB, 0.88052225E-10_JPRB, 0.88088550E-10_JPRB, &
  & 0.88118519E-10_JPRB, 0.88140599E-10_JPRB, 0.88153401E-10_JPRB, 0.88156392E-10_JPRB, 0.88150036E-10_JPRB, 0.88134729E-10_JPRB, &
  & 0.88111241E-10_JPRB, 0.88081133E-10_JPRB, 0.88047944E-10_JPRB, 0.88015630E-10_JPRB, 0.87987673E-10_JPRB, 0.87966218E-10_JPRB, &
  & 0.87950876E-10_JPRB, 0.87940662E-10_JPRB, 0.87934042E-10_JPRB, 0.87929442E-10_JPRB, 0.87925910E-10_JPRB, 0.87922558E-10_JPRB, &
  & 0.87918908E-10_JPRB, 0.87914252E-10_JPRB, 0.87908063E-10_JPRB, 0.87899889E-10_JPRB, 0.87889543E-10_JPRB, 0.87876859E-10_JPRB, &
  & 0.87861975E-10_JPRB, 0.87845259E-10_JPRB, 0.87827523E-10_JPRB, 0.87810391E-10_JPRB, 0.87794251E-10_JPRB, 0.87778930E-10_JPRB, &
  & 0.87763630E-10_JPRB, 0.87746130E-10_JPRB, 0.87720026E-10_JPRB, 0.87665396E-10_JPRB /)

RGHG9(:,69, 6) = (/ &
  & 0.87727679E-10_JPRB, 0.87757454E-10_JPRB, 0.87773275E-10_JPRB, 0.87785737E-10_JPRB, 0.87797491E-10_JPRB, 0.87807490E-10_JPRB, &
  & 0.87817434E-10_JPRB, 0.87826135E-10_JPRB, 0.87836995E-10_JPRB, 0.87848423E-10_JPRB, 0.87862606E-10_JPRB, 0.87877657E-10_JPRB, &
  & 0.87892554E-10_JPRB, 0.87904850E-10_JPRB, 0.87912684E-10_JPRB, 0.87914502E-10_JPRB, 0.87908805E-10_JPRB, 0.87895857E-10_JPRB, &
  & 0.87877608E-10_JPRB, 0.87858297E-10_JPRB, 0.87843788E-10_JPRB, 0.87840096E-10_JPRB, 0.87851670E-10_JPRB, 0.87878448E-10_JPRB, &
  & 0.87916174E-10_JPRB, 0.87958890E-10_JPRB, 0.88002453E-10_JPRB, 0.88044017E-10_JPRB, 0.88081584E-10_JPRB, 0.88114523E-10_JPRB, &
  & 0.88141223E-10_JPRB, 0.88160791E-10_JPRB, 0.88171956E-10_JPRB, 0.88174447E-10_JPRB, 0.88168736E-10_JPRB, 0.88155233E-10_JPRB, &
  & 0.88134472E-10_JPRB, 0.88107896E-10_JPRB, 0.88078524E-10_JPRB, 0.88049838E-10_JPRB, 0.88024997E-10_JPRB, 0.88005873E-10_JPRB, &
  & 0.87992093E-10_JPRB, 0.87982836E-10_JPRB, 0.87976744E-10_JPRB, 0.87972588E-10_JPRB, 0.87969437E-10_JPRB, 0.87966648E-10_JPRB, &
  & 0.87963622E-10_JPRB, 0.87959792E-10_JPRB, 0.87954449E-10_JPRB, 0.87947191E-10_JPRB, 0.87937664E-10_JPRB, 0.87925757E-10_JPRB, &
  & 0.87911504E-10_JPRB, 0.87895261E-10_JPRB, 0.87877886E-10_JPRB, 0.87861038E-10_JPRB, 0.87845162E-10_JPRB, 0.87830056E-10_JPRB, &
  & 0.87814929E-10_JPRB, 0.87797970E-10_JPRB, 0.87771367E-10_JPRB, 0.87715141E-10_JPRB /)

RGHG9(:,70, 6) = (/ &
  & 0.87762117E-10_JPRB, 0.87798394E-10_JPRB, 0.87816990E-10_JPRB, 0.87831721E-10_JPRB, 0.87844329E-10_JPRB, 0.87855750E-10_JPRB, &
  & 0.87865368E-10_JPRB, 0.87875818E-10_JPRB, 0.87886101E-10_JPRB, 0.87899001E-10_JPRB, 0.87912448E-10_JPRB, 0.87927304E-10_JPRB, &
  & 0.87941383E-10_JPRB, 0.87953013E-10_JPRB, 0.87960465E-10_JPRB, 0.87962124E-10_JPRB, 0.87956739E-10_JPRB, 0.87944763E-10_JPRB, &
  & 0.87927825E-10_JPRB, 0.87909915E-10_JPRB, 0.87896107E-10_JPRB, 0.87892145E-10_JPRB, 0.87901846E-10_JPRB, 0.87925452E-10_JPRB, &
  & 0.87959265E-10_JPRB, 0.87997949E-10_JPRB, 0.88037487E-10_JPRB, 0.88075061E-10_JPRB, 0.88108951E-10_JPRB, 0.88138413E-10_JPRB, &
  & 0.88162019E-10_JPRB, 0.88179172E-10_JPRB, 0.88188831E-10_JPRB, 0.88190913E-10_JPRB, 0.88185875E-10_JPRB, 0.88174135E-10_JPRB, &
  & 0.88156038E-10_JPRB, 0.88132793E-10_JPRB, 0.88107029E-10_JPRB, 0.88081868E-10_JPRB, 0.88060052E-10_JPRB, 0.88043253E-10_JPRB, &
  & 0.88031152E-10_JPRB, 0.88022957E-10_JPRB, 0.88017565E-10_JPRB, 0.88013943E-10_JPRB, 0.88011279E-10_JPRB, 0.88009038E-10_JPRB, &
  & 0.88006699E-10_JPRB, 0.88003667E-10_JPRB, 0.87999212E-10_JPRB, 0.87992891E-10_JPRB, 0.87984356E-10_JPRB, 0.87973386E-10_JPRB, &
  & 0.87960063E-10_JPRB, 0.87944631E-10_JPRB, 0.87927984E-10_JPRB, 0.87911928E-10_JPRB, 0.87896718E-10_JPRB, 0.87882430E-10_JPRB, &
  & 0.87867956E-10_JPRB, 0.87851879E-10_JPRB, 0.87826350E-10_JPRB, 0.87769569E-10_JPRB /)

RGHG9(:,71, 6) = (/ &
  & 0.87796985E-10_JPRB, 0.87841422E-10_JPRB, 0.87862675E-10_JPRB, 0.87879273E-10_JPRB, 0.87892790E-10_JPRB, 0.87904614E-10_JPRB, &
  & 0.87914953E-10_JPRB, 0.87925014E-10_JPRB, 0.87936568E-10_JPRB, 0.87948079E-10_JPRB, 0.87961728E-10_JPRB, 0.87975238E-10_JPRB, &
  & 0.87988526E-10_JPRB, 0.87999108E-10_JPRB, 0.88005873E-10_JPRB, 0.88007442E-10_JPRB, 0.88002716E-10_JPRB, 0.87991912E-10_JPRB, &
  & 0.87976529E-10_JPRB, 0.87960257E-10_JPRB, 0.87947559E-10_JPRB, 0.87943430E-10_JPRB, 0.87951271E-10_JPRB, 0.87971491E-10_JPRB, &
  & 0.88001197E-10_JPRB, 0.88035600E-10_JPRB, 0.88070835E-10_JPRB, 0.88104378E-10_JPRB, 0.88134437E-10_JPRB, 0.88160562E-10_JPRB, &
  & 0.88181129E-10_JPRB, 0.88196006E-10_JPRB, 0.88204291E-10_JPRB, 0.88206005E-10_JPRB, 0.88201654E-10_JPRB, 0.88191593E-10_JPRB, &
  & 0.88175987E-10_JPRB, 0.88155969E-10_JPRB, 0.88133625E-10_JPRB, 0.88111837E-10_JPRB, 0.88092922E-10_JPRB, 0.88078524E-10_JPRB, &
  & 0.88067997E-10_JPRB, 0.88061010E-10_JPRB, 0.88056354E-10_JPRB, 0.88053322E-10_JPRB, 0.88051129E-10_JPRB, 0.88049470E-10_JPRB, &
  & 0.88047750E-10_JPRB, 0.88045495E-10_JPRB, 0.88041921E-10_JPRB, 0.88036599E-10_JPRB, 0.88029133E-10_JPRB, 0.88019377E-10_JPRB, &
  & 0.88007199E-10_JPRB, 0.87992995E-10_JPRB, 0.87977556E-10_JPRB, 0.87962637E-10_JPRB, 0.87948787E-10_JPRB, 0.87935548E-10_JPRB, &
  & 0.87922364E-10_JPRB, 0.87907771E-10_JPRB, 0.87884665E-10_JPRB, 0.87832817E-10_JPRB /)

RGHG9(:,72, 6) = (/ &
  & 0.87835551E-10_JPRB, 0.87886143E-10_JPRB, 0.87912046E-10_JPRB, 0.87929025E-10_JPRB, 0.87943659E-10_JPRB, 0.87954984E-10_JPRB, &
  & 0.87965649E-10_JPRB, 0.87976029E-10_JPRB, 0.87986188E-10_JPRB, 0.87998456E-10_JPRB, 0.88009509E-10_JPRB, 0.88022728E-10_JPRB, &
  & 0.88034378E-10_JPRB, 0.88044003E-10_JPRB, 0.88049970E-10_JPRB, 0.88051143E-10_JPRB, 0.88046806E-10_JPRB, 0.88037376E-10_JPRB, &
  & 0.88023679E-10_JPRB, 0.88009225E-10_JPRB, 0.87997686E-10_JPRB, 0.87993522E-10_JPRB, 0.87999580E-10_JPRB, 0.88016469E-10_JPRB, &
  & 0.88041893E-10_JPRB, 0.88071793E-10_JPRB, 0.88102713E-10_JPRB, 0.88132002E-10_JPRB, 0.88158328E-10_JPRB, 0.88181136E-10_JPRB, &
  & 0.88198754E-10_JPRB, 0.88211514E-10_JPRB, 0.88218495E-10_JPRB, 0.88219883E-10_JPRB, 0.88216205E-10_JPRB, 0.88207761E-10_JPRB, &
  & 0.88194493E-10_JPRB, 0.88177493E-10_JPRB, 0.88158439E-10_JPRB, 0.88139822E-10_JPRB, 0.88123814E-10_JPRB, 0.88111539E-10_JPRB, &
  & 0.88102733E-10_JPRB, 0.88096815E-10_JPRB, 0.88092963E-10_JPRB, 0.88090479E-10_JPRB, 0.88088752E-10_JPRB, 0.88087593E-10_JPRB, &
  & 0.88086441E-10_JPRB, 0.88084810E-10_JPRB, 0.88082056E-10_JPRB, 0.88077691E-10_JPRB, 0.88071467E-10_JPRB, 0.88062994E-10_JPRB, &
  & 0.88052392E-10_JPRB, 0.88039638E-10_JPRB, 0.88025795E-10_JPRB, 0.88012736E-10_JPRB, 0.88000246E-10_JPRB, 0.87988790E-10_JPRB, &
  & 0.87976938E-10_JPRB, 0.87964018E-10_JPRB, 0.87943833E-10_JPRB, 0.87896537E-10_JPRB /)

RGHG9(:,73, 6) = (/ &
  & 0.87882097E-10_JPRB, 0.87939676E-10_JPRB, 0.87963782E-10_JPRB, 0.87982496E-10_JPRB, 0.87995514E-10_JPRB, 0.88007476E-10_JPRB, &
  & 0.88017357E-10_JPRB, 0.88026933E-10_JPRB, 0.88037737E-10_JPRB, 0.88046570E-10_JPRB, 0.88058560E-10_JPRB, 0.88068414E-10_JPRB, &
  & 0.88079363E-10_JPRB, 0.88087038E-10_JPRB, 0.88092068E-10_JPRB, 0.88092818E-10_JPRB, 0.88088890E-10_JPRB, 0.88080543E-10_JPRB, &
  & 0.88068525E-10_JPRB, 0.88056042E-10_JPRB, 0.88045855E-10_JPRB, 0.88041831E-10_JPRB, 0.88046313E-10_JPRB, 0.88059920E-10_JPRB, &
  & 0.88081174E-10_JPRB, 0.88106557E-10_JPRB, 0.88133049E-10_JPRB, 0.88158134E-10_JPRB, 0.88180657E-10_JPRB, 0.88200315E-10_JPRB, &
  & 0.88215026E-10_JPRB, 0.88225816E-10_JPRB, 0.88231575E-10_JPRB, 0.88232692E-10_JPRB, 0.88229653E-10_JPRB, 0.88222686E-10_JPRB, &
  & 0.88211632E-10_JPRB, 0.88197463E-10_JPRB, 0.88181483E-10_JPRB, 0.88165961E-10_JPRB, 0.88152520E-10_JPRB, 0.88142445E-10_JPRB, &
  & 0.88135096E-10_JPRB, 0.88130288E-10_JPRB, 0.88127144E-10_JPRB, 0.88125215E-10_JPRB, 0.88123883E-10_JPRB, 0.88123134E-10_JPRB, &
  & 0.88122398E-10_JPRB, 0.88121330E-10_JPRB, 0.88119269E-10_JPRB, 0.88115897E-10_JPRB, 0.88110810E-10_JPRB, 0.88103913E-10_JPRB, &
  & 0.88094781E-10_JPRB, 0.88083929E-10_JPRB, 0.88072084E-10_JPRB, 0.88060663E-10_JPRB, 0.88050303E-10_JPRB, 0.88040214E-10_JPRB, &
  & 0.88030153E-10_JPRB, 0.88018870E-10_JPRB, 0.88000968E-10_JPRB, 0.87959064E-10_JPRB /)

RGHG9(:,74, 6) = (/ &
  & 0.87936512E-10_JPRB, 0.87992703E-10_JPRB, 0.88019494E-10_JPRB, 0.88035620E-10_JPRB, 0.88048902E-10_JPRB, 0.88059192E-10_JPRB, &
  & 0.88068774E-10_JPRB, 0.88078086E-10_JPRB, 0.88086163E-10_JPRB, 0.88096204E-10_JPRB, 0.88103642E-10_JPRB, 0.88114023E-10_JPRB, &
  & 0.88122003E-10_JPRB, 0.88128477E-10_JPRB, 0.88132078E-10_JPRB, 0.88132238E-10_JPRB, 0.88128539E-10_JPRB, 0.88121316E-10_JPRB, &
  & 0.88111060E-10_JPRB, 0.88100437E-10_JPRB, 0.88091624E-10_JPRB, 0.88087912E-10_JPRB, 0.88091048E-10_JPRB, 0.88101672E-10_JPRB, &
  & 0.88118929E-10_JPRB, 0.88139808E-10_JPRB, 0.88161901E-10_JPRB, 0.88182836E-10_JPRB, 0.88201661E-10_JPRB, 0.88218148E-10_JPRB, &
  & 0.88230132E-10_JPRB, 0.88239048E-10_JPRB, 0.88243690E-10_JPRB, 0.88244551E-10_JPRB, 0.88242101E-10_JPRB, 0.88236494E-10_JPRB, &
  & 0.88227446E-10_JPRB, 0.88215921E-10_JPRB, 0.88202896E-10_JPRB, 0.88190212E-10_JPRB, 0.88179276E-10_JPRB, 0.88171116E-10_JPRB, &
  & 0.88165232E-10_JPRB, 0.88161332E-10_JPRB, 0.88158904E-10_JPRB, 0.88157467E-10_JPRB, 0.88156489E-10_JPRB, 0.88156066E-10_JPRB, &
  & 0.88155608E-10_JPRB, 0.88154962E-10_JPRB, 0.88153561E-10_JPRB, 0.88151028E-10_JPRB, 0.88147170E-10_JPRB, 0.88141577E-10_JPRB, &
  & 0.88134305E-10_JPRB, 0.88125285E-10_JPRB, 0.88115293E-10_JPRB, 0.88106154E-10_JPRB, 0.88097210E-10_JPRB, 0.88089036E-10_JPRB, &
  & 0.88080432E-10_JPRB, 0.88070794E-10_JPRB, 0.88055591E-10_JPRB, 0.88017510E-10_JPRB /)

RGHG9(:,75, 6) = (/ &
  & 0.87990414E-10_JPRB, 0.88049776E-10_JPRB, 0.88073056E-10_JPRB, 0.88088786E-10_JPRB, 0.88099653E-10_JPRB, 0.88109478E-10_JPRB, &
  & 0.88117805E-10_JPRB, 0.88125549E-10_JPRB, 0.88133952E-10_JPRB, 0.88140086E-10_JPRB, 0.88148509E-10_JPRB, 0.88154789E-10_JPRB, &
  & 0.88162214E-10_JPRB, 0.88166412E-10_JPRB, 0.88168930E-10_JPRB, 0.88168729E-10_JPRB, 0.88165406E-10_JPRB, 0.88159341E-10_JPRB, &
  & 0.88150764E-10_JPRB, 0.88142084E-10_JPRB, 0.88134722E-10_JPRB, 0.88131460E-10_JPRB, 0.88133514E-10_JPRB, 0.88141466E-10_JPRB, &
  & 0.88155025E-10_JPRB, 0.88171616E-10_JPRB, 0.88189289E-10_JPRB, 0.88206373E-10_JPRB, 0.88221395E-10_JPRB, 0.88234808E-10_JPRB, &
  & 0.88244231E-10_JPRB, 0.88251351E-10_JPRB, 0.88254966E-10_JPRB, 0.88255590E-10_JPRB, 0.88253654E-10_JPRB, 0.88249331E-10_JPRB, &
  & 0.88242108E-10_JPRB, 0.88233088E-10_JPRB, 0.88222762E-10_JPRB, 0.88212777E-10_JPRB, 0.88204111E-10_JPRB, 0.88197831E-10_JPRB, &
  & 0.88193182E-10_JPRB, 0.88190150E-10_JPRB, 0.88188332E-10_JPRB, 0.88187360E-10_JPRB, 0.88186652E-10_JPRB, 0.88186514E-10_JPRB, &
  & 0.88186271E-10_JPRB, 0.88185952E-10_JPRB, 0.88185126E-10_JPRB, 0.88183370E-10_JPRB, 0.88180553E-10_JPRB, 0.88176369E-10_JPRB, &
  & 0.88170637E-10_JPRB, 0.88163470E-10_JPRB, 0.88155552E-10_JPRB, 0.88147961E-10_JPRB, 0.88141029E-10_JPRB, 0.88134222E-10_JPRB, &
  & 0.88127346E-10_JPRB, 0.88119442E-10_JPRB, 0.88106147E-10_JPRB, 0.88072521E-10_JPRB /)

RGHG9(:,76, 6) = (/ &
  & 0.88049165E-10_JPRB, 0.88104177E-10_JPRB, 0.88125798E-10_JPRB, 0.88138580E-10_JPRB, 0.88147892E-10_JPRB, 0.88155760E-10_JPRB, &
  & 0.88162956E-10_JPRB, 0.88169853E-10_JPRB, 0.88175675E-10_JPRB, 0.88182031E-10_JPRB, 0.88186597E-10_JPRB, 0.88192911E-10_JPRB, &
  & 0.88197699E-10_JPRB, 0.88201037E-10_JPRB, 0.88202320E-10_JPRB, 0.88201918E-10_JPRB, 0.88199184E-10_JPRB, 0.88194452E-10_JPRB, &
  & 0.88187603E-10_JPRB, 0.88180824E-10_JPRB, 0.88174940E-10_JPRB, 0.88172275E-10_JPRB, 0.88173524E-10_JPRB, 0.88179200E-10_JPRB, &
  & 0.88189421E-10_JPRB, 0.88201890E-10_JPRB, 0.88215324E-10_JPRB, 0.88228667E-10_JPRB, 0.88239985E-10_JPRB, 0.88250372E-10_JPRB, &
  & 0.88257415E-10_JPRB, 0.88262835E-10_JPRB, 0.88265492E-10_JPRB, 0.88265922E-10_JPRB, 0.88264472E-10_JPRB, 0.88261315E-10_JPRB, &
  & 0.88255757E-10_JPRB, 0.88248991E-10_JPRB, 0.88241248E-10_JPRB, 0.88233733E-10_JPRB, 0.88227231E-10_JPRB, 0.88222665E-10_JPRB, &
  & 0.88219154E-10_JPRB, 0.88216871E-10_JPRB, 0.88215643E-10_JPRB, 0.88215046E-10_JPRB, 0.88214588E-10_JPRB, 0.88214630E-10_JPRB, &
  & 0.88214575E-10_JPRB, 0.88214464E-10_JPRB, 0.88214165E-10_JPRB, 0.88213020E-10_JPRB, 0.88211119E-10_JPRB, 0.88208010E-10_JPRB, &
  & 0.88203854E-10_JPRB, 0.88198532E-10_JPRB, 0.88192231E-10_JPRB, 0.88186784E-10_JPRB, 0.88181157E-10_JPRB, 0.88176098E-10_JPRB, &
  & 0.88170742E-10_JPRB, 0.88164649E-10_JPRB, 0.88153679E-10_JPRB, 0.88123155E-10_JPRB /)

RGHG9(:,77, 6) = (/ &
  & 0.88108347E-10_JPRB, 0.88157502E-10_JPRB, 0.88175210E-10_JPRB, 0.88185230E-10_JPRB, 0.88191780E-10_JPRB, 0.88198074E-10_JPRB, &
  & 0.88203417E-10_JPRB, 0.88208489E-10_JPRB, 0.88213575E-10_JPRB, 0.88216913E-10_JPRB, 0.88221118E-10_JPRB, 0.88224733E-10_JPRB, &
  & 0.88228633E-10_JPRB, 0.88230978E-10_JPRB, 0.88231540E-10_JPRB, 0.88231200E-10_JPRB, 0.88229257E-10_JPRB, 0.88225913E-10_JPRB, &
  & 0.88220806E-10_JPRB, 0.88215955E-10_JPRB, 0.88211577E-10_JPRB, 0.88209696E-10_JPRB, 0.88210494E-10_JPRB, 0.88214262E-10_JPRB, &
  & 0.88221597E-10_JPRB, 0.88230263E-10_JPRB, 0.88239825E-10_JPRB, 0.88249463E-10_JPRB, 0.88257353E-10_JPRB, 0.88264798E-10_JPRB, &
  & 0.88269704E-10_JPRB, 0.88273569E-10_JPRB, 0.88275338E-10_JPRB, 0.88275616E-10_JPRB, 0.88274624E-10_JPRB, 0.88272542E-10_JPRB, &
  & 0.88268455E-10_JPRB, 0.88263764E-10_JPRB, 0.88258345E-10_JPRB, 0.88253106E-10_JPRB, 0.88248568E-10_JPRB, 0.88245591E-10_JPRB, &
  & 0.88243080E-10_JPRB, 0.88241470E-10_JPRB, 0.88240734E-10_JPRB, 0.88240505E-10_JPRB, 0.88240214E-10_JPRB, 0.88240450E-10_JPRB, &
  & 0.88240450E-10_JPRB, 0.88240436E-10_JPRB, 0.88240554E-10_JPRB, 0.88239908E-10_JPRB, 0.88238687E-10_JPRB, 0.88236453E-10_JPRB, &
  & 0.88233656E-10_JPRB, 0.88229993E-10_JPRB, 0.88225552E-10_JPRB, 0.88221770E-10_JPRB, 0.88217891E-10_JPRB, 0.88214269E-10_JPRB, &
  & 0.88210578E-10_JPRB, 0.88206387E-10_JPRB, 0.88197442E-10_JPRB, 0.88171005E-10_JPRB /)

RGHG9(:,78, 6) = (/ &
  & 0.88168237E-10_JPRB, 0.88206067E-10_JPRB, 0.88218342E-10_JPRB, 0.88225330E-10_JPRB, 0.88229320E-10_JPRB, 0.88233518E-10_JPRB, &
  & 0.88237084E-10_JPRB, 0.88240512E-10_JPRB, 0.88243524E-10_JPRB, 0.88245605E-10_JPRB, 0.88247583E-10_JPRB, 0.88250671E-10_JPRB, &
  & 0.88252933E-10_JPRB, 0.88255132E-10_JPRB, 0.88255118E-10_JPRB, 0.88255001E-10_JPRB, 0.88253807E-10_JPRB, 0.88251836E-10_JPRB, &
  & 0.88248277E-10_JPRB, 0.88245272E-10_JPRB, 0.88242344E-10_JPRB, 0.88241400E-10_JPRB, 0.88242066E-10_JPRB, 0.88244460E-10_JPRB, &
  & 0.88249491E-10_JPRB, 0.88255056E-10_JPRB, 0.88261308E-10_JPRB, 0.88267657E-10_JPRB, 0.88272632E-10_JPRB, 0.88277524E-10_JPRB, &
  & 0.88280522E-10_JPRB, 0.88283082E-10_JPRB, 0.88284088E-10_JPRB, 0.88284220E-10_JPRB, 0.88283623E-10_JPRB, 0.88282465E-10_JPRB, &
  & 0.88279654E-10_JPRB, 0.88276726E-10_JPRB, 0.88273305E-10_JPRB, 0.88269975E-10_JPRB, 0.88267171E-10_JPRB, 0.88265562E-10_JPRB, &
  & 0.88263868E-10_JPRB, 0.88262800E-10_JPRB, 0.88262439E-10_JPRB, 0.88262474E-10_JPRB, 0.88262266E-10_JPRB, 0.88262578E-10_JPRB, &
  & 0.88262536E-10_JPRB, 0.88262522E-10_JPRB, 0.88262939E-10_JPRB, 0.88262557E-10_JPRB, 0.88261821E-10_JPRB, 0.88260128E-10_JPRB, &
  & 0.88258449E-10_JPRB, 0.88256256E-10_JPRB, 0.88253301E-10_JPRB, 0.88251371E-10_JPRB, 0.88248769E-10_JPRB, 0.88246660E-10_JPRB, &
  & 0.88244467E-10_JPRB, 0.88242087E-10_JPRB, 0.88236120E-10_JPRB, 0.88215893E-10_JPRB /)

RGHG9(:,79, 6) = (/ &
  & 0.88207157E-10_JPRB, 0.88233365E-10_JPRB, 0.88241511E-10_JPRB, 0.88246306E-10_JPRB, 0.88248735E-10_JPRB, 0.88252045E-10_JPRB, &
  & 0.88254466E-10_JPRB, 0.88257041E-10_JPRB, 0.88259289E-10_JPRB, 0.88260226E-10_JPRB, 0.88261551E-10_JPRB, 0.88263993E-10_JPRB, &
  & 0.88265603E-10_JPRB, 0.88267726E-10_JPRB, 0.88267310E-10_JPRB, 0.88267296E-10_JPRB, 0.88266554E-10_JPRB, 0.88265353E-10_JPRB, &
  & 0.88262626E-10_JPRB, 0.88260635E-10_JPRB, 0.88258484E-10_JPRB, 0.88258144E-10_JPRB, 0.88258810E-10_JPRB, 0.88260448E-10_JPRB, &
  & 0.88264396E-10_JPRB, 0.88268337E-10_JPRB, 0.88272889E-10_JPRB, 0.88277510E-10_JPRB, 0.88280896E-10_JPRB, 0.88284435E-10_JPRB, &
  & 0.88286364E-10_JPRB, 0.88288266E-10_JPRB, 0.88288807E-10_JPRB, 0.88288883E-10_JPRB, 0.88288502E-10_JPRB, 0.88287898E-10_JPRB, &
  & 0.88285691E-10_JPRB, 0.88283693E-10_JPRB, 0.88281313E-10_JPRB, 0.88278988E-10_JPRB, 0.88277073E-10_JPRB, 0.88276220E-10_JPRB, &
  & 0.88274943E-10_JPRB, 0.88274103E-10_JPRB, 0.88273930E-10_JPRB, 0.88274062E-10_JPRB, 0.88273854E-10_JPRB, 0.88274173E-10_JPRB, &
  & 0.88274062E-10_JPRB, 0.88273985E-10_JPRB, 0.88274568E-10_JPRB, 0.88274318E-10_JPRB, 0.88273805E-10_JPRB, 0.88272341E-10_JPRB, &
  & 0.88271258E-10_JPRB, 0.88269801E-10_JPRB, 0.88267532E-10_JPRB, 0.88266491E-10_JPRB, 0.88264500E-10_JPRB, 0.88263084E-10_JPRB, &
  & 0.88261690E-10_JPRB, 0.88260857E-10_JPRB, 0.88257339E-10_JPRB, 0.88244190E-10_JPRB /)

RGHG9(:,80, 6) = (/ &
  & 0.88232997E-10_JPRB, 0.88246584E-10_JPRB, 0.88251670E-10_JPRB, 0.88255458E-10_JPRB, 0.88257096E-10_JPRB, 0.88259983E-10_JPRB, &
  & 0.88262120E-10_JPRB, 0.88264084E-10_JPRB, 0.88266373E-10_JPRB, 0.88266706E-10_JPRB, 0.88267824E-10_JPRB, 0.88269905E-10_JPRB, &
  & 0.88271238E-10_JPRB, 0.88273375E-10_JPRB, 0.88272702E-10_JPRB, 0.88272736E-10_JPRB, 0.88272223E-10_JPRB, 0.88271432E-10_JPRB, &
  & 0.88269073E-10_JPRB, 0.88267595E-10_JPRB, 0.88265791E-10_JPRB, 0.88265728E-10_JPRB, 0.88266394E-10_JPRB, 0.88267671E-10_JPRB, &
  & 0.88271147E-10_JPRB, 0.88274360E-10_JPRB, 0.88278149E-10_JPRB, 0.88282021E-10_JPRB, 0.88284692E-10_JPRB, 0.88287606E-10_JPRB, &
  & 0.88289036E-10_JPRB, 0.88290660E-10_JPRB, 0.88290965E-10_JPRB, 0.88290986E-10_JPRB, 0.88290722E-10_JPRB, 0.88290368E-10_JPRB, &
  & 0.88288411E-10_JPRB, 0.88286808E-10_JPRB, 0.88284921E-10_JPRB, 0.88283020E-10_JPRB, 0.88281500E-10_JPRB, 0.88280980E-10_JPRB, &
  & 0.88279876E-10_JPRB, 0.88279134E-10_JPRB, 0.88279009E-10_JPRB, 0.88279224E-10_JPRB, 0.88278967E-10_JPRB, 0.88279287E-10_JPRB, &
  & 0.88279099E-10_JPRB, 0.88278974E-10_JPRB, 0.88279661E-10_JPRB, 0.88279453E-10_JPRB, 0.88279051E-10_JPRB, 0.88277663E-10_JPRB, &
  & 0.88276858E-10_JPRB, 0.88275699E-10_JPRB, 0.88273666E-10_JPRB, 0.88272993E-10_JPRB, 0.88271168E-10_JPRB, 0.88270058E-10_JPRB, &
  & 0.88269073E-10_JPRB, 0.88269003E-10_JPRB, 0.88267470E-10_JPRB, 0.88262682E-10_JPRB /)

RGHG9(:,81, 6) = (/ &
  & 0.88250747E-10_JPRB, 0.88252176E-10_JPRB, 0.88255958E-10_JPRB, 0.88259323E-10_JPRB, 0.88260656E-10_JPRB, 0.88263480E-10_JPRB, &
  & 0.88265201E-10_JPRB, 0.88267643E-10_JPRB, 0.88269170E-10_JPRB, 0.88269669E-10_JPRB, 0.88270349E-10_JPRB, 0.88272716E-10_JPRB, &
  & 0.88273708E-10_JPRB, 0.88275880E-10_JPRB, 0.88275068E-10_JPRB, 0.88275144E-10_JPRB, 0.88274707E-10_JPRB, 0.88274166E-10_JPRB, &
  & 0.88271924E-10_JPRB, 0.88270752E-10_JPRB, 0.88269045E-10_JPRB, 0.88269128E-10_JPRB, 0.88269780E-10_JPRB, 0.88270842E-10_JPRB, &
  & 0.88274180E-10_JPRB, 0.88277038E-10_JPRB, 0.88280515E-10_JPRB, 0.88284047E-10_JPRB, 0.88286378E-10_JPRB, 0.88289015E-10_JPRB, &
  & 0.88290222E-10_JPRB, 0.88291707E-10_JPRB, 0.88291909E-10_JPRB, 0.88291915E-10_JPRB, 0.88291686E-10_JPRB, 0.88291464E-10_JPRB, &
  & 0.88289584E-10_JPRB, 0.88288182E-10_JPRB, 0.88286482E-10_JPRB, 0.88284796E-10_JPRB, 0.88283464E-10_JPRB, 0.88283075E-10_JPRB, &
  & 0.88282041E-10_JPRB, 0.88281313E-10_JPRB, 0.88281223E-10_JPRB, 0.88281445E-10_JPRB, 0.88281174E-10_JPRB, 0.88281514E-10_JPRB, &
  & 0.88281285E-10_JPRB, 0.88281119E-10_JPRB, 0.88281896E-10_JPRB, 0.88281701E-10_JPRB, 0.88281348E-10_JPRB, 0.88279981E-10_JPRB, &
  & 0.88279328E-10_JPRB, 0.88278287E-10_JPRB, 0.88276317E-10_JPRB, 0.88275776E-10_JPRB, 0.88273985E-10_JPRB, 0.88272986E-10_JPRB, &
  & 0.88272153E-10_JPRB, 0.88272431E-10_JPRB, 0.88271730E-10_JPRB, 0.88275394E-10_JPRB /)

RGHG9(:,82, 6) = (/ &
  & 0.88252149E-10_JPRB, 0.88254029E-10_JPRB, 0.88257859E-10_JPRB, 0.88261183E-10_JPRB, 0.88262397E-10_JPRB, 0.88265034E-10_JPRB, &
  & 0.88267081E-10_JPRB, 0.88268573E-10_JPRB, 0.88270932E-10_JPRB, 0.88271015E-10_JPRB, 0.88272091E-10_JPRB, 0.88273729E-10_JPRB, &
  & 0.88274943E-10_JPRB, 0.88277080E-10_JPRB, 0.88276227E-10_JPRB, 0.88276317E-10_JPRB, 0.88275928E-10_JPRB, 0.88275505E-10_JPRB, &
  & 0.88273375E-10_JPRB, 0.88272306E-10_JPRB, 0.88270648E-10_JPRB, 0.88270821E-10_JPRB, 0.88271460E-10_JPRB, 0.88272382E-10_JPRB, &
  & 0.88275651E-10_JPRB, 0.88278405E-10_JPRB, 0.88281674E-10_JPRB, 0.88285088E-10_JPRB, 0.88287211E-10_JPRB, 0.88289716E-10_JPRB, &
  & 0.88290798E-10_JPRB, 0.88292228E-10_JPRB, 0.88292360E-10_JPRB, 0.88292360E-10_JPRB, 0.88292165E-10_JPRB, 0.88291985E-10_JPRB, &
  & 0.88290153E-10_JPRB, 0.88288821E-10_JPRB, 0.88287225E-10_JPRB, 0.88285643E-10_JPRB, 0.88284421E-10_JPRB, 0.88284074E-10_JPRB, &
  & 0.88283103E-10_JPRB, 0.88282374E-10_JPRB, 0.88282277E-10_JPRB, 0.88282520E-10_JPRB, 0.88282257E-10_JPRB, 0.88282617E-10_JPRB, &
  & 0.88282354E-10_JPRB, 0.88282145E-10_JPRB, 0.88282978E-10_JPRB, 0.88282812E-10_JPRB, 0.88282485E-10_JPRB, 0.88281105E-10_JPRB, &
  & 0.88280508E-10_JPRB, 0.88279550E-10_JPRB, 0.88277580E-10_JPRB, 0.88277108E-10_JPRB, 0.88275331E-10_JPRB, 0.88274367E-10_JPRB, &
  & 0.88273604E-10_JPRB, 0.88273958E-10_JPRB, 0.88273187E-10_JPRB, 0.88276414E-10_JPRB /)

RGHG9(:,83, 6) = (/ &
  & 0.88253127E-10_JPRB, 0.88255105E-10_JPRB, 0.88258935E-10_JPRB, 0.88262231E-10_JPRB, 0.88263334E-10_JPRB, 0.88266144E-10_JPRB, &
  & 0.88267622E-10_JPRB, 0.88270224E-10_JPRB, 0.88271376E-10_JPRB, 0.88271959E-10_JPRB, 0.88272500E-10_JPRB, 0.88274665E-10_JPRB, &
  & 0.88275623E-10_JPRB, 0.88277698E-10_JPRB, 0.88276844E-10_JPRB, 0.88276955E-10_JPRB, 0.88276601E-10_JPRB, 0.88276296E-10_JPRB, &
  & 0.88274159E-10_JPRB, 0.88273222E-10_JPRB, 0.88271536E-10_JPRB, 0.88271779E-10_JPRB, 0.88272410E-10_JPRB, 0.88273201E-10_JPRB, &
  & 0.88276567E-10_JPRB, 0.88279127E-10_JPRB, 0.88282409E-10_JPRB, 0.88285664E-10_JPRB, 0.88287710E-10_JPRB, 0.88290118E-10_JPRB, &
  & 0.88291131E-10_JPRB, 0.88292526E-10_JPRB, 0.88292630E-10_JPRB, 0.88292616E-10_JPRB, 0.88292401E-10_JPRB, 0.88292255E-10_JPRB, &
  & 0.88290444E-10_JPRB, 0.88289147E-10_JPRB, 0.88287634E-10_JPRB, 0.88286121E-10_JPRB, 0.88284956E-10_JPRB, 0.88284623E-10_JPRB, &
  & 0.88283686E-10_JPRB, 0.88282971E-10_JPRB, 0.88282895E-10_JPRB, 0.88283145E-10_JPRB, 0.88282860E-10_JPRB, 0.88283235E-10_JPRB, &
  & 0.88282957E-10_JPRB, 0.88282749E-10_JPRB, 0.88283623E-10_JPRB, 0.88283436E-10_JPRB, 0.88283131E-10_JPRB, 0.88281750E-10_JPRB, &
  & 0.88281195E-10_JPRB, 0.88280265E-10_JPRB, 0.88278274E-10_JPRB, 0.88277850E-10_JPRB, 0.88276081E-10_JPRB, 0.88275137E-10_JPRB, &
  & 0.88274409E-10_JPRB, 0.88274825E-10_JPRB, 0.88274013E-10_JPRB, 0.88277149E-10_JPRB /)

RGHG9(:,84, 6) = (/ &
  & 0.88253786E-10_JPRB, 0.88255799E-10_JPRB, 0.88259594E-10_JPRB, 0.88262876E-10_JPRB, 0.88264000E-10_JPRB, 0.88266561E-10_JPRB, &
  & 0.88268726E-10_JPRB, 0.88269968E-10_JPRB, 0.88272264E-10_JPRB, 0.88272410E-10_JPRB, 0.88273472E-10_JPRB, 0.88274804E-10_JPRB, &
  & 0.88276025E-10_JPRB, 0.88277913E-10_JPRB, 0.88277274E-10_JPRB, 0.88277337E-10_JPRB, 0.88277011E-10_JPRB, 0.88276733E-10_JPRB, &
  & 0.88274672E-10_JPRB, 0.88273777E-10_JPRB, 0.88272091E-10_JPRB, 0.88272389E-10_JPRB, 0.88273000E-10_JPRB, 0.88273715E-10_JPRB, &
  & 0.88277052E-10_JPRB, 0.88279661E-10_JPRB, 0.88282770E-10_JPRB, 0.88286087E-10_JPRB, 0.88288002E-10_JPRB, 0.88290375E-10_JPRB, &
  & 0.88291340E-10_JPRB, 0.88292700E-10_JPRB, 0.88292776E-10_JPRB, 0.88292741E-10_JPRB, 0.88292547E-10_JPRB, 0.88292415E-10_JPRB, &
  & 0.88290604E-10_JPRB, 0.88289320E-10_JPRB, 0.88287849E-10_JPRB, 0.88286413E-10_JPRB, 0.88285310E-10_JPRB, 0.88284970E-10_JPRB, &
  & 0.88284081E-10_JPRB, 0.88283367E-10_JPRB, 0.88283277E-10_JPRB, 0.88283506E-10_JPRB, 0.88283228E-10_JPRB, 0.88283603E-10_JPRB, &
  & 0.88283346E-10_JPRB, 0.88283103E-10_JPRB, 0.88284019E-10_JPRB, 0.88283859E-10_JPRB, 0.88283540E-10_JPRB, 0.88282159E-10_JPRB, &
  & 0.88281632E-10_JPRB, 0.88280702E-10_JPRB, 0.88278718E-10_JPRB, 0.88278315E-10_JPRB, 0.88276525E-10_JPRB, 0.88275609E-10_JPRB, &
  & 0.88274901E-10_JPRB, 0.88275359E-10_JPRB, 0.88274568E-10_JPRB, 0.88277656E-10_JPRB /)

RGHG9(:,85, 6) = (/ &
  & 0.88254237E-10_JPRB, 0.88256236E-10_JPRB, 0.88260017E-10_JPRB, 0.88263313E-10_JPRB, 0.88264313E-10_JPRB, 0.88267296E-10_JPRB, &
  & 0.88268608E-10_JPRB, 0.88271279E-10_JPRB, 0.88272167E-10_JPRB, 0.88272972E-10_JPRB, 0.88273500E-10_JPRB, 0.88275345E-10_JPRB, &
  & 0.88276275E-10_JPRB, 0.88277816E-10_JPRB, 0.88277483E-10_JPRB, 0.88277538E-10_JPRB, 0.88277274E-10_JPRB, 0.88277004E-10_JPRB, &
  & 0.88275040E-10_JPRB, 0.88274173E-10_JPRB, 0.88272452E-10_JPRB, 0.88272785E-10_JPRB, 0.88273402E-10_JPRB, 0.88274006E-10_JPRB, &
  & 0.88277469E-10_JPRB, 0.88279897E-10_JPRB, 0.88283138E-10_JPRB, 0.88286309E-10_JPRB, 0.88288217E-10_JPRB, 0.88290542E-10_JPRB, &
  & 0.88291485E-10_JPRB, 0.88292818E-10_JPRB, 0.88292866E-10_JPRB, 0.88292831E-10_JPRB, 0.88292651E-10_JPRB, 0.88292540E-10_JPRB, &
  & 0.88290701E-10_JPRB, 0.88289417E-10_JPRB, 0.88288002E-10_JPRB, 0.88286600E-10_JPRB, 0.88285546E-10_JPRB, 0.88285178E-10_JPRB, &
  & 0.88284290E-10_JPRB, 0.88283630E-10_JPRB, 0.88283533E-10_JPRB, 0.88283741E-10_JPRB, 0.88283478E-10_JPRB, 0.88283839E-10_JPRB, &
  & 0.88283575E-10_JPRB, 0.88283339E-10_JPRB, 0.88284276E-10_JPRB, 0.88284130E-10_JPRB, 0.88283818E-10_JPRB, 0.88282430E-10_JPRB, &
  & 0.88281923E-10_JPRB, 0.88280994E-10_JPRB, 0.88278981E-10_JPRB, 0.88278614E-10_JPRB, 0.88276809E-10_JPRB, 0.88275907E-10_JPRB, &
  & 0.88275220E-10_JPRB, 0.88275720E-10_JPRB, 0.88274929E-10_JPRB, 0.88278031E-10_JPRB /)

RGHG9(:,86, 6) = (/ &
  & 0.88254515E-10_JPRB, 0.88256534E-10_JPRB, 0.88260288E-10_JPRB, 0.88263619E-10_JPRB, 0.88264847E-10_JPRB, 0.88267171E-10_JPRB, &
  & 0.88269739E-10_JPRB, 0.88270731E-10_JPRB, 0.88272861E-10_JPRB, 0.88273167E-10_JPRB, 0.88274325E-10_JPRB, 0.88275262E-10_JPRB, &
  & 0.88276421E-10_JPRB, 0.88277566E-10_JPRB, 0.88277524E-10_JPRB, 0.88277601E-10_JPRB, 0.88277399E-10_JPRB, 0.88277122E-10_JPRB, &
  & 0.88275331E-10_JPRB, 0.88274443E-10_JPRB, 0.88272722E-10_JPRB, 0.88273056E-10_JPRB, 0.88273680E-10_JPRB, 0.88274235E-10_JPRB, &
  & 0.88277642E-10_JPRB, 0.88280140E-10_JPRB, 0.88283242E-10_JPRB, 0.88286517E-10_JPRB, 0.88288335E-10_JPRB, 0.88290673E-10_JPRB, &
  & 0.88291569E-10_JPRB, 0.88292908E-10_JPRB, 0.88292915E-10_JPRB, 0.88292873E-10_JPRB, 0.88292720E-10_JPRB, 0.88292651E-10_JPRB, &
  & 0.88290757E-10_JPRB, 0.88289501E-10_JPRB, 0.88288071E-10_JPRB, 0.88286697E-10_JPRB, 0.88285657E-10_JPRB, 0.88285310E-10_JPRB, &
  & 0.88284463E-10_JPRB, 0.88283769E-10_JPRB, 0.88283700E-10_JPRB, 0.88283887E-10_JPRB, 0.88283637E-10_JPRB, 0.88283984E-10_JPRB, &
  & 0.88283741E-10_JPRB, 0.88283512E-10_JPRB, 0.88284421E-10_JPRB, 0.88284290E-10_JPRB, 0.88283991E-10_JPRB, 0.88282617E-10_JPRB, &
  & 0.88282104E-10_JPRB, 0.88281188E-10_JPRB, 0.88279155E-10_JPRB, 0.88278801E-10_JPRB, 0.88276983E-10_JPRB, 0.88276102E-10_JPRB, &
  & 0.88275415E-10_JPRB, 0.88275942E-10_JPRB, 0.88275151E-10_JPRB, 0.88278232E-10_JPRB /)

RGHG9(:,87, 6) = (/ &
  & 0.88254723E-10_JPRB, 0.88256742E-10_JPRB, 0.88260441E-10_JPRB, 0.88263799E-10_JPRB, 0.88264791E-10_JPRB, 0.88268171E-10_JPRB, &
  & 0.88269267E-10_JPRB, 0.88271911E-10_JPRB, 0.88272653E-10_JPRB, 0.88273625E-10_JPRB, 0.88274152E-10_JPRB, 0.88275595E-10_JPRB, &
  & 0.88276345E-10_JPRB, 0.88277385E-10_JPRB, 0.88277462E-10_JPRB, 0.88277566E-10_JPRB, 0.88277413E-10_JPRB, 0.88277122E-10_JPRB, &
  & 0.88275574E-10_JPRB, 0.88274610E-10_JPRB, 0.88272910E-10_JPRB, 0.88273208E-10_JPRB, 0.88273833E-10_JPRB, 0.88274332E-10_JPRB, &
  & 0.88277809E-10_JPRB, 0.88280196E-10_JPRB, 0.88283408E-10_JPRB, 0.88286621E-10_JPRB, 0.88288425E-10_JPRB, 0.88290784E-10_JPRB, &
  & 0.88291617E-10_JPRB, 0.88292956E-10_JPRB, 0.88292970E-10_JPRB, 0.88292915E-10_JPRB, 0.88292762E-10_JPRB, 0.88292748E-10_JPRB, &
  & 0.88290819E-10_JPRB, 0.88289570E-10_JPRB, 0.88288148E-10_JPRB, 0.88286739E-10_JPRB, 0.88285698E-10_JPRB, 0.88285414E-10_JPRB, &
  & 0.88284484E-10_JPRB, 0.88283818E-10_JPRB, 0.88283776E-10_JPRB, 0.88283963E-10_JPRB, 0.88283755E-10_JPRB, 0.88284047E-10_JPRB, &
  & 0.88283825E-10_JPRB, 0.88283637E-10_JPRB, 0.88284505E-10_JPRB, 0.88284380E-10_JPRB, 0.88284081E-10_JPRB, 0.88282728E-10_JPRB, &
  & 0.88282222E-10_JPRB, 0.88281306E-10_JPRB, 0.88279259E-10_JPRB, 0.88278933E-10_JPRB, 0.88277087E-10_JPRB, 0.88276220E-10_JPRB, &
  & 0.88275540E-10_JPRB, 0.88276095E-10_JPRB, 0.88275290E-10_JPRB, 0.88278398E-10_JPRB /)

RGHG9(:,88, 6) = (/ &
  & 0.88254924E-10_JPRB, 0.88257034E-10_JPRB, 0.88260524E-10_JPRB, 0.88263855E-10_JPRB, 0.88265409E-10_JPRB, 0.88267574E-10_JPRB, &
  & 0.88270342E-10_JPRB, 0.88271300E-10_JPRB, 0.88273160E-10_JPRB, 0.88273555E-10_JPRB, 0.88274617E-10_JPRB, 0.88275415E-10_JPRB, &
  & 0.88276428E-10_JPRB, 0.88277302E-10_JPRB, 0.88277441E-10_JPRB, 0.88277580E-10_JPRB, 0.88277455E-10_JPRB, 0.88277191E-10_JPRB, &
  & 0.88275644E-10_JPRB, 0.88274721E-10_JPRB, 0.88273007E-10_JPRB, 0.88273312E-10_JPRB, 0.88273930E-10_JPRB, 0.88274402E-10_JPRB, &
  & 0.88277871E-10_JPRB, 0.88280265E-10_JPRB, 0.88283443E-10_JPRB, 0.88286711E-10_JPRB, 0.88288481E-10_JPRB, 0.88290875E-10_JPRB, &
  & 0.88291666E-10_JPRB, 0.88293005E-10_JPRB, 0.88292991E-10_JPRB, 0.88292949E-10_JPRB, 0.88292797E-10_JPRB, 0.88292859E-10_JPRB, &
  & 0.88290854E-10_JPRB, 0.88289667E-10_JPRB, 0.88288224E-10_JPRB, 0.88286718E-10_JPRB, 0.88285657E-10_JPRB, 0.88285476E-10_JPRB, &
  & 0.88284505E-10_JPRB, 0.88283783E-10_JPRB, 0.88283811E-10_JPRB, 0.88284019E-10_JPRB, 0.88283818E-10_JPRB, 0.88284102E-10_JPRB, &
  & 0.88283901E-10_JPRB, 0.88283748E-10_JPRB, 0.88284526E-10_JPRB, 0.88284449E-10_JPRB, 0.88284144E-10_JPRB, 0.88282825E-10_JPRB, &
  & 0.88282312E-10_JPRB, 0.88281361E-10_JPRB, 0.88279307E-10_JPRB, 0.88279009E-10_JPRB, 0.88277143E-10_JPRB, 0.88276289E-10_JPRB, &
  & 0.88275616E-10_JPRB, 0.88276192E-10_JPRB, 0.88275359E-10_JPRB, 0.88278489E-10_JPRB /)

RGHG9(:,89, 6) = (/ &
  & 0.88255223E-10_JPRB, 0.88257339E-10_JPRB, 0.88260538E-10_JPRB, 0.88263778E-10_JPRB, 0.88264930E-10_JPRB, 0.88268344E-10_JPRB, &
  & 0.88269614E-10_JPRB, 0.88272029E-10_JPRB, 0.88272889E-10_JPRB, 0.88273763E-10_JPRB, 0.88274339E-10_JPRB, 0.88275588E-10_JPRB, &
  & 0.88276358E-10_JPRB, 0.88277420E-10_JPRB, 0.88277524E-10_JPRB, 0.88277663E-10_JPRB, 0.88277531E-10_JPRB, 0.88277267E-10_JPRB, &
  & 0.88275706E-10_JPRB, 0.88274735E-10_JPRB, 0.88273035E-10_JPRB, 0.88273340E-10_JPRB, 0.88273992E-10_JPRB, 0.88274429E-10_JPRB, &
  & 0.88277947E-10_JPRB, 0.88280300E-10_JPRB, 0.88283499E-10_JPRB, 0.88286781E-10_JPRB, 0.88288495E-10_JPRB, 0.88290930E-10_JPRB, &
  & 0.88291659E-10_JPRB, 0.88293046E-10_JPRB, 0.88293005E-10_JPRB, 0.88292956E-10_JPRB, 0.88292811E-10_JPRB, 0.88292942E-10_JPRB, &
  & 0.88290861E-10_JPRB, 0.88289744E-10_JPRB, 0.88288266E-10_JPRB, 0.88286711E-10_JPRB, 0.88285552E-10_JPRB, 0.88285566E-10_JPRB, &
  & 0.88284463E-10_JPRB, 0.88283769E-10_JPRB, 0.88283839E-10_JPRB, 0.88284054E-10_JPRB, 0.88283852E-10_JPRB, 0.88284102E-10_JPRB, &
  & 0.88283936E-10_JPRB, 0.88283804E-10_JPRB, 0.88284539E-10_JPRB, 0.88284470E-10_JPRB, 0.88284179E-10_JPRB, 0.88282902E-10_JPRB, &
  & 0.88282368E-10_JPRB, 0.88281396E-10_JPRB, 0.88279328E-10_JPRB, 0.88279072E-10_JPRB, 0.88277177E-10_JPRB, 0.88276331E-10_JPRB, &
  & 0.88275623E-10_JPRB, 0.88276240E-10_JPRB, 0.88275394E-10_JPRB, 0.88278544E-10_JPRB /)

RGHG9(:,90, 6) = (/ &
  & 0.88255486E-10_JPRB, 0.88257665E-10_JPRB, 0.88260337E-10_JPRB, 0.88263695E-10_JPRB, 0.88265020E-10_JPRB, 0.88267615E-10_JPRB, &
  & 0.88269989E-10_JPRB, 0.88271349E-10_JPRB, 0.88273111E-10_JPRB, 0.88273527E-10_JPRB, 0.88274485E-10_JPRB, 0.88275401E-10_JPRB, &
  & 0.88276518E-10_JPRB, 0.88277718E-10_JPRB, 0.88277663E-10_JPRB, 0.88277802E-10_JPRB, 0.88277621E-10_JPRB, 0.88277448E-10_JPRB, &
  & 0.88275554E-10_JPRB, 0.88274749E-10_JPRB, 0.88272945E-10_JPRB, 0.88273347E-10_JPRB, 0.88274027E-10_JPRB, 0.88274367E-10_JPRB, &
  & 0.88277975E-10_JPRB, 0.88280293E-10_JPRB, 0.88283519E-10_JPRB, 0.88286843E-10_JPRB, 0.88288488E-10_JPRB, 0.88291020E-10_JPRB, &
  & 0.88291666E-10_JPRB, 0.88293116E-10_JPRB, 0.88293019E-10_JPRB, 0.88292956E-10_JPRB, 0.88292811E-10_JPRB, 0.88293033E-10_JPRB, &
  & 0.88290861E-10_JPRB, 0.88289771E-10_JPRB, 0.88288314E-10_JPRB, 0.88286670E-10_JPRB, 0.88285476E-10_JPRB, 0.88285650E-10_JPRB, &
  & 0.88284463E-10_JPRB, 0.88283707E-10_JPRB, 0.88283839E-10_JPRB, 0.88284081E-10_JPRB, 0.88283852E-10_JPRB, 0.88284130E-10_JPRB, &
  & 0.88283943E-10_JPRB, 0.88283797E-10_JPRB, 0.88284560E-10_JPRB, 0.88284505E-10_JPRB, 0.88284227E-10_JPRB, 0.88282902E-10_JPRB, &
  & 0.88282395E-10_JPRB, 0.88281452E-10_JPRB, 0.88279294E-10_JPRB, 0.88279106E-10_JPRB, 0.88277156E-10_JPRB, 0.88276331E-10_JPRB, &
  & 0.88275588E-10_JPRB, 0.88276303E-10_JPRB, 0.88275373E-10_JPRB, 0.88278600E-10_JPRB /)

RGHG9(:,91, 6) = (/ &
  & 0.88255389E-10_JPRB, 0.88257693E-10_JPRB, 0.88259490E-10_JPRB, 0.88264097E-10_JPRB, 0.88264507E-10_JPRB, 0.88267497E-10_JPRB, &
  & 0.88268802E-10_JPRB, 0.88270835E-10_JPRB, 0.88273264E-10_JPRB, 0.88273069E-10_JPRB, 0.88274374E-10_JPRB, 0.88275075E-10_JPRB, &
  & 0.88276490E-10_JPRB, 0.88279557E-10_JPRB, 0.88277580E-10_JPRB, 0.88278017E-10_JPRB, 0.88277607E-10_JPRB, 0.88277802E-10_JPRB, &
  & 0.88275297E-10_JPRB, 0.88274776E-10_JPRB, 0.88272743E-10_JPRB, 0.88273333E-10_JPRB, 0.88274041E-10_JPRB, 0.88274159E-10_JPRB, &
  & 0.88278072E-10_JPRB, 0.88280237E-10_JPRB, 0.88283519E-10_JPRB, 0.88286954E-10_JPRB, 0.88288411E-10_JPRB, 0.88291173E-10_JPRB, &
  & 0.88291617E-10_JPRB, 0.88293255E-10_JPRB, 0.88293005E-10_JPRB, 0.88292956E-10_JPRB, 0.88292790E-10_JPRB, 0.88293206E-10_JPRB, &
  & 0.88290784E-10_JPRB, 0.88289806E-10_JPRB, 0.88288349E-10_JPRB, 0.88286642E-10_JPRB, 0.88285344E-10_JPRB, 0.88285816E-10_JPRB, &
  & 0.88284428E-10_JPRB, 0.88283582E-10_JPRB, 0.88283811E-10_JPRB, 0.88284158E-10_JPRB, 0.88283741E-10_JPRB, 0.88284220E-10_JPRB, &
  & 0.88283950E-10_JPRB, 0.88283686E-10_JPRB, 0.88284664E-10_JPRB, 0.88284546E-10_JPRB, 0.88284317E-10_JPRB, 0.88282819E-10_JPRB, &
  & 0.88282437E-10_JPRB, 0.88281514E-10_JPRB, 0.88279169E-10_JPRB, 0.88279217E-10_JPRB, 0.88277080E-10_JPRB, 0.88276310E-10_JPRB, &
  & 0.88275505E-10_JPRB, 0.88276386E-10_JPRB, 0.88275297E-10_JPRB, 0.88278683E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART12',1,ZHOOK_HANDLE)
END SUBROUTINE PART12






SUBROUTINE PART13
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART13',0,ZHOOK_HANDLE)



!-- Month=  7 ------------

RGHG9(:, 1, 7) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.42038954E-44_JPRB, 0.56051939E-44_JPRB, &
  & 0.84077908E-44_JPRB, 0.12611686E-43_JPRB, 0.19618179E-43_JPRB, 0.28025969E-43_JPRB, 0.40637655E-43_JPRB, 0.53249342E-43_JPRB, &
  & 0.64459729E-43_JPRB, 0.74268819E-43_JPRB, 0.71466222E-43_JPRB, 0.56051939E-43_JPRB, 0.56051939E-43_JPRB, 0.28025969E-43_JPRB, &
  & 0.19618179E-43_JPRB, 0.98090893E-44_JPRB, 0.70064923E-44_JPRB, 0.42038954E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 2, 7) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.28025969E-44_JPRB, 0.70064923E-44_JPRB, &
  & 0.12611686E-43_JPRB, 0.22420775E-43_JPRB, 0.39236357E-43_JPRB, 0.68663625E-43_JPRB, 0.11630777E-42_JPRB, 0.19478049E-42_JPRB, &
  & 0.31809475E-42_JPRB, 0.50446745E-42_JPRB, 0.77912195E-42_JPRB, 0.11322492E-41_JPRB, 0.15848686E-41_JPRB, 0.21061516E-41_JPRB, &
  & 0.25405541E-41_JPRB, 0.29132995E-41_JPRB, 0.28474385E-41_JPRB, 0.23163464E-41_JPRB, 0.21285724E-41_JPRB, 0.12219323E-41_JPRB, &
  & 0.79733883E-42_JPRB, 0.43159993E-42_JPRB, 0.27885839E-42_JPRB, 0.17656361E-42_JPRB, 0.91084400E-43_JPRB, 0.44841551E-43_JPRB, &
  & 0.22420775E-43_JPRB, 0.11210388E-43_JPRB, 0.42038954E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 3, 7) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.28025969E-44_JPRB, &
  & 0.28025969E-44_JPRB, 0.28025969E-44_JPRB, 0.28025969E-44_JPRB, 0.28025969E-44_JPRB, 0.28025969E-44_JPRB, 0.42038954E-44_JPRB, &
  & 0.84077908E-44_JPRB, 0.15414283E-43_JPRB, 0.35032462E-43_JPRB, 0.74268819E-43_JPRB, 0.15414283E-42_JPRB, 0.30548307E-42_JPRB, &
  & 0.58294016E-42_JPRB, 0.10691907E-41_JPRB, 0.19015620E-41_JPRB, 0.32902488E-41_JPRB, 0.55827731E-41_JPRB, 0.92611816E-41_JPRB, &
  & 0.15153642E-40_JPRB, 0.23903349E-40_JPRB, 0.36866761E-40_JPRB, 0.53379662E-40_JPRB, 0.74634558E-40_JPRB, 0.99063394E-40_JPRB, &
  & 0.11982924E-39_JPRB, 0.13738050E-39_JPRB, 0.13465077E-39_JPRB, 0.11059328E-39_JPRB, 0.10016622E-39_JPRB, 0.58963837E-40_JPRB, &
  & 0.38259652E-40_JPRB, 0.21187633E-40_JPRB, 0.13620621E-40_JPRB, 0.87146751E-41_JPRB, 0.43762551E-41_JPRB, 0.20963425E-41_JPRB, &
  & 0.10033297E-41_JPRB, 0.43440252E-42_JPRB, 0.17095841E-42_JPRB, 0.56051939E-43_JPRB, 0.15414283E-43_JPRB, 0.42038954E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 4, 7) = (/ &
  & 0.30828566E-43_JPRB, 0.89683102E-43_JPRB, 0.11490647E-42_JPRB, 0.11630777E-42_JPRB, 0.10649868E-42_JPRB, 0.95288296E-43_JPRB, &
  & 0.86880505E-43_JPRB, 0.84077908E-43_JPRB, 0.91084400E-43_JPRB, 0.11770907E-42_JPRB, 0.18497140E-42_JPRB, 0.33771293E-42_JPRB, &
  & 0.68523495E-42_JPRB, 0.14587517E-41_JPRB, 0.31557241E-41_JPRB, 0.67346404E-41_JPRB, 0.13961137E-40_JPRB, 0.27842399E-40_JPRB, &
  & 0.53316604E-40_JPRB, 0.97950763E-40_JPRB, 0.17380865E-39_JPRB, 0.29882409E-39_JPRB, 0.50228563E-39_JPRB, 0.82546849E-39_JPRB, &
  & 0.13378757E-38_JPRB, 0.20962416E-38_JPRB, 0.32128214E-38_JPRB, 0.46424051E-38_JPRB, 0.64873126E-38_JPRB, 0.86198086E-38_JPRB, &
  & 0.10455196E-37_JPRB, 0.12007739E-37_JPRB, 0.11795005E-37_JPRB, 0.97036457E-38_JPRB, 0.87870326E-38_JPRB, 0.51928043E-38_JPRB, &
  & 0.33868081E-38_JPRB, 0.19034468E-38_JPRB, 0.12340213E-38_JPRB, 0.79363519E-39_JPRB, 0.39605179E-39_JPRB, 0.18448234E-39_JPRB, &
  & 0.85835136E-40_JPRB, 0.36079232E-40_JPRB, 0.13854638E-40_JPRB, 0.44757473E-41_JPRB, 0.13410426E-41_JPRB, 0.42179084E-42_JPRB, &
  & 0.15974802E-42_JPRB, 0.61657132E-43_JPRB, 0.22420775E-43_JPRB, 0.70064923E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 5, 7) = (/ &
  & 0.17341068E-40_JPRB, 0.27329524E-40_JPRB, 0.29759375E-40_JPRB, 0.27769532E-40_JPRB, 0.24833811E-40_JPRB, 0.22050833E-40_JPRB, &
  & 0.20044173E-40_JPRB, 0.19357537E-40_JPRB, 0.20806480E-40_JPRB, 0.26407470E-40_JPRB, 0.40441474E-40_JPRB, 0.72581655E-40_JPRB, &
  & 0.14481719E-39_JPRB, 0.30508229E-39_JPRB, 0.65306534E-39_JPRB, 0.13801164E-38_JPRB, 0.28308737E-38_JPRB, 0.55810649E-38_JPRB, &
  & 0.10547070E-37_JPRB, 0.19071410E-37_JPRB, 0.33213461E-37_JPRB, 0.55906288E-37_JPRB, 0.91890466E-37_JPRB, 0.14765910E-36_JPRB, &
  & 0.23435930E-36_JPRB, 0.36080108E-36_JPRB, 0.54593328E-36_JPRB, 0.78247690E-36_JPRB, 0.10894702E-35_JPRB, 0.14470309E-35_JPRB, &
  & 0.17541484E-35_JPRB, 0.20188934E-35_JPRB, 0.19870062E-35_JPRB, 0.16378891E-35_JPRB, 0.14917152E-35_JPRB, 0.88738353E-36_JPRB, &
  & 0.58375682E-36_JPRB, 0.33435871E-36_JPRB, 0.22019237E-36_JPRB, 0.14432624E-36_JPRB, 0.72768398E-37_JPRB, 0.33935029E-37_JPRB, &
  & 0.15886559E-37_JPRB, 0.66662234E-38_JPRB, 0.25917197E-38_JPRB, 0.84691256E-39_JPRB, 0.26132114E-39_JPRB, 0.85005567E-40_JPRB, &
  & 0.32955737E-40_JPRB, 0.13039082E-40_JPRB, 0.47475992E-41_JPRB, 0.15932764E-41_JPRB, 0.58574276E-42_JPRB, 0.29147008E-42_JPRB, &
  & 0.14993894E-42_JPRB, 0.85479206E-43_JPRB, 0.77071416E-43_JPRB, 0.77071416E-43_JPRB, 0.91084400E-43_JPRB, 0.11630777E-42_JPRB, &
  & 0.21019477E-42_JPRB, 0.33911423E-42_JPRB, 0.54790770E-42_JPRB, 0.66421547E-42_JPRB /)

RGHG9(:, 6, 7) = (/ &
  & 0.15595209E-37_JPRB, 0.17222115E-37_JPRB, 0.16484973E-37_JPRB, 0.14965167E-37_JPRB, 0.13238280E-37_JPRB, 0.11661970E-37_JPRB, &
  & 0.10482751E-37_JPRB, 0.99753127E-38_JPRB, 0.10483550E-37_JPRB, 0.12906096E-37_JPRB, 0.19089031E-37_JPRB, 0.32977410E-37_JPRB, &
  & 0.63253895E-37_JPRB, 0.12798541E-36_JPRB, 0.26288005E-36_JPRB, 0.53250669E-36_JPRB, 0.10460486E-35_JPRB, 0.19739378E-35_JPRB, &
  & 0.35714566E-35_JPRB, 0.61881692E-35_JPRB, 0.10342485E-34_JPRB, 0.16739812E-34_JPRB, 0.26509917E-34_JPRB, 0.41138887E-34_JPRB, &
  & 0.63211061E-34_JPRB, 0.94613813E-34_JPRB, 0.13982838E-33_JPRB, 0.19704605E-33_JPRB, 0.27120319E-33_JPRB, 0.35760024E-33_JPRB, &
  & 0.43195110E-33_JPRB, 0.49666648E-33_JPRB, 0.49003559E-33_JPRB, 0.40595973E-33_JPRB, 0.37500612E-33_JPRB, 0.22467159E-33_JPRB, &
  & 0.15100682E-33_JPRB, 0.88126524E-34_JPRB, 0.59860925E-34_JPRB, 0.40491857E-34_JPRB, 0.20988024E-34_JPRB, 0.10124041E-34_JPRB, &
  & 0.49253378E-35_JPRB, 0.21604738E-35_JPRB, 0.87702280E-36_JPRB, 0.30068749E-36_JPRB, 0.97403068E-37_JPRB, 0.33276993E-37_JPRB, &
  & 0.13525798E-37_JPRB, 0.55676559E-38_JPRB, 0.20904248E-38_JPRB, 0.72061493E-39_JPRB, 0.27476660E-39_JPRB, 0.14377182E-39_JPRB, &
  & 0.76708479E-40_JPRB, 0.44547278E-40_JPRB, 0.41676018E-40_JPRB, 0.40788996E-40_JPRB, 0.47634339E-40_JPRB, 0.60174559E-40_JPRB, &
  & 0.10564669E-39_JPRB, 0.16140576E-39_JPRB, 0.25004770E-39_JPRB, 0.23739678E-39_JPRB /)

RGHG9(:, 7, 7) = (/ &
  & 0.12408857E-34_JPRB, 0.12794471E-34_JPRB, 0.12024792E-34_JPRB, 0.10830385E-34_JPRB, 0.95031996E-35_JPRB, 0.82680086E-35_JPRB, &
  & 0.73181483E-35_JPRB, 0.68028765E-35_JPRB, 0.69116069E-35_JPRB, 0.81444590E-35_JPRB, 0.11427175E-34_JPRB, 0.18629021E-34_JPRB, &
  & 0.33609946E-34_JPRB, 0.63859609E-34_JPRB, 0.12309308E-33_JPRB, 0.23389048E-33_JPRB, 0.43096621E-33_JPRB, 0.76350792E-33_JPRB, &
  & 0.12999574E-32_JPRB, 0.21275019E-32_JPRB, 0.33756642E-32_JPRB, 0.52137803E-32_JPRB, 0.79186655E-32_JPRB, 0.11830710E-31_JPRB, &
  & 0.17562274E-31_JPRB, 0.25480398E-31_JPRB, 0.36658914E-31_JPRB, 0.50565065E-31_JPRB, 0.68485059E-31_JPRB, 0.89374246E-31_JPRB, &
  & 0.10729642E-30_JPRB, 0.12317506E-30_JPRB, 0.12189571E-30_JPRB, 0.10176708E-30_JPRB, 0.95518485E-31_JPRB, 0.57911969E-31_JPRB, &
  & 0.39813938E-31_JPRB, 0.23651327E-31_JPRB, 0.16656943E-31_JPRB, 0.11725751E-31_JPRB, 0.62642520E-32_JPRB, 0.31594140E-32_JPRB, &
  & 0.16321982E-32_JPRB, 0.75838373E-33_JPRB, 0.32808208E-33_JPRB, 0.11951653E-33_JPRB, 0.41311237E-34_JPRB, 0.15097077E-34_JPRB, &
  & 0.65854524E-35_JPRB, 0.28927606E-35_JPRB, 0.11516840E-35_JPRB, 0.41915003E-36_JPRB, 0.16986325E-36_JPRB, 0.94968777E-37_JPRB, &
  & 0.53336329E-37_JPRB, 0.32375202E-37_JPRB, 0.31331234E-37_JPRB, 0.31078334E-37_JPRB, 0.36196677E-37_JPRB, 0.44546866E-37_JPRB, &
  & 0.75750182E-37_JPRB, 0.11325839E-36_JPRB, 0.17581803E-36_JPRB, 0.22384745E-36_JPRB /)

RGHG9(:, 8, 7) = (/ &
  & 0.81286999E-32_JPRB, 0.83121174E-32_JPRB, 0.77817704E-32_JPRB, 0.69745195E-32_JPRB, 0.60823450E-32_JPRB, 0.52394064E-32_JPRB, &
  & 0.45715247E-32_JPRB, 0.41611218E-32_JPRB, 0.40950958E-32_JPRB, 0.46242126E-32_JPRB, 0.61643196E-32_JPRB, 0.94839068E-32_JPRB, &
  & 0.16076528E-31_JPRB, 0.28624704E-31_JPRB, 0.51638885E-31_JPRB, 0.91790251E-31_JPRB, 0.15828123E-30_JPRB, 0.26269238E-30_JPRB, &
  & 0.42013165E-30_JPRB, 0.64834701E-30_JPRB, 0.97526337E-30_JPRB, 0.14361428E-29_JPRB, 0.20916276E-29_JPRB, 0.30088014E-29_JPRB, &
  & 0.43176671E-29_JPRB, 0.60731884E-29_JPRB, 0.85022698E-29_JPRB, 0.11467037E-28_JPRB, 0.15268093E-28_JPRB, 0.19691586E-28_JPRB, &
  & 0.23502961E-28_JPRB, 0.26940621E-28_JPRB, 0.26767309E-28_JPRB, 0.22541841E-28_JPRB, 0.21528885E-28_JPRB, 0.13207302E-28_JPRB, &
  & 0.93129591E-29_JPRB, 0.56261556E-29_JPRB, 0.41194543E-29_JPRB, 0.30235746E-29_JPRB, 0.16657272E-29_JPRB, 0.88189677E-30_JPRB, &
  & 0.48352455E-30_JPRB, 0.23894742E-30_JPRB, 0.10986365E-30_JPRB, 0.42524269E-31_JPRB, 0.15676426E-31_JPRB, 0.61597300E-32_JPRB, &
  & 0.29091239E-32_JPRB, 0.13753698E-32_JPRB, 0.58509933E-33_JPRB, 0.22678073E-33_JPRB, 0.98340262E-34_JPRB, 0.58941939E-34_JPRB, &
  & 0.35010776E-34_JPRB, 0.22324868E-34_JPRB, 0.22544337E-34_JPRB, 0.22951712E-34_JPRB, 0.27004297E-34_JPRB, 0.33195665E-34_JPRB, &
  & 0.56088082E-34_JPRB, 0.83265643E-34_JPRB, 0.13425862E-33_JPRB, 0.19046900E-33_JPRB /)

RGHG9(:, 9, 7) = (/ &
  & 0.43066619E-29_JPRB, 0.43875618E-29_JPRB, 0.40948035E-29_JPRB, 0.36655480E-29_JPRB, 0.31760902E-29_JPRB, 0.27253744E-29_JPRB, &
  & 0.23495177E-29_JPRB, 0.21055564E-29_JPRB, 0.20198363E-29_JPRB, 0.22024141E-29_JPRB, 0.28107823E-29_JPRB, 0.41103242E-29_JPRB, &
  & 0.65851073E-29_JPRB, 0.11035901E-28_JPRB, 0.18696194E-28_JPRB, 0.31181991E-28_JPRB, 0.50461721E-28_JPRB, 0.78697361E-28_JPRB, &
  & 0.11855908E-27_JPRB, 0.17285515E-27_JPRB, 0.24675794E-27_JPRB, 0.34637566E-27_JPRB, 0.48326050E-27_JPRB, 0.66847247E-27_JPRB, &
  & 0.92616671E-27_JPRB, 0.12607933E-26_JPRB, 0.17161095E-26_JPRB, 0.22597751E-26_JPRB, 0.29537425E-26_JPRB, 0.37624089E-26_JPRB, &
  & 0.44611714E-26_JPRB, 0.51078281E-26_JPRB, 0.50978403E-26_JPRB, 0.43355387E-26_JPRB, 0.42114437E-26_JPRB, 0.26232878E-26_JPRB, &
  & 0.18992866E-26_JPRB, 0.11722172E-26_JPRB, 0.89288558E-27_JPRB, 0.68369333E-27_JPRB, 0.39043675E-27_JPRB, 0.21722720E-27_JPRB, &
  & 0.12647159E-27_JPRB, 0.66213056E-28_JPRB, 0.32366002E-28_JPRB, 0.13258983E-28_JPRB, 0.52057766E-29_JPRB, 0.22012900E-29_JPRB, &
  & 0.11288495E-29_JPRB, 0.57510408E-30_JPRB, 0.26170531E-30_JPRB, 0.10813970E-30_JPRB, 0.50230414E-31_JPRB, 0.32284838E-31_JPRB, &
  & 0.20270277E-31_JPRB, 0.13592434E-31_JPRB, 0.14352501E-31_JPRB, 0.15087561E-31_JPRB, 0.18183002E-31_JPRB, 0.22654042E-31_JPRB, &
  & 0.38633142E-31_JPRB, 0.58044977E-31_JPRB, 0.95139587E-31_JPRB, 0.14150405E-30_JPRB /)

RGHG9(:,10, 7) = (/ &
  & 0.18312863E-26_JPRB, 0.18607769E-26_JPRB, 0.17360654E-26_JPRB, 0.15471097E-26_JPRB, 0.13445170E-26_JPRB, 0.11431609E-26_JPRB, &
  & 0.98249612E-27_JPRB, 0.86851544E-27_JPRB, 0.81750507E-27_JPRB, 0.86700108E-27_JPRB, 0.10674223E-26_JPRB, 0.14946076E-26_JPRB, &
  & 0.22779458E-26_JPRB, 0.36132799E-26_JPRB, 0.57753805E-26_JPRB, 0.90739789E-26_JPRB, 0.13835505E-25_JPRB, 0.20351294E-25_JPRB, &
  & 0.28977154E-25_JPRB, 0.40027024E-25_JPRB, 0.54301012E-25_JPRB, 0.72653941E-25_JPRB, 0.96998664E-25_JPRB, 0.12868960E-24_JPRB, &
  & 0.17171317E-24_JPRB, 0.22580655E-24_JPRB, 0.29822364E-24_JPRB, 0.38290132E-24_JPRB, 0.49086747E-24_JPRB, 0.61696230E-24_JPRB, &
  & 0.72637711E-24_JPRB, 0.83063523E-24_JPRB, 0.83282787E-24_JPRB, 0.71565318E-24_JPRB, 0.70662965E-24_JPRB, 0.44840486E-24_JPRB, &
  & 0.33338374E-24_JPRB, 0.21149045E-24_JPRB, 0.16750363E-24_JPRB, 0.13379108E-24_JPRB, 0.79647822E-25_JPRB, 0.46671168E-25_JPRB, &
  & 0.28797293E-25_JPRB, 0.15997275E-25_JPRB, 0.83043927E-26_JPRB, 0.36053412E-26_JPRB, 0.15086804E-26_JPRB, 0.68682538E-27_JPRB, &
  & 0.38220174E-27_JPRB, 0.20962999E-27_JPRB, 0.10199844E-27_JPRB, 0.44934976E-28_JPRB, 0.22351359E-28_JPRB, 0.15381742E-28_JPRB, &
  & 0.10197989E-28_JPRB, 0.71840399E-29_JPRB, 0.79288775E-29_JPRB, 0.86214796E-29_JPRB, 0.10679883E-28_JPRB, 0.13607923E-28_JPRB, &
  & 0.23564081E-28_JPRB, 0.35811063E-28_JPRB, 0.59532595E-28_JPRB, 0.89936758E-28_JPRB /)

RGHG9(:,11, 7) = (/ &
  & 0.63600412E-24_JPRB, 0.64556960E-24_JPRB, 0.60079459E-24_JPRB, 0.53717020E-24_JPRB, 0.46298621E-24_JPRB, 0.39538631E-24_JPRB, &
  & 0.33586180E-24_JPRB, 0.29471013E-24_JPRB, 0.27268720E-24_JPRB, 0.28240012E-24_JPRB, 0.33692407E-24_JPRB, 0.45385978E-24_JPRB, &
  & 0.66111716E-24_JPRB, 0.99718724E-24_JPRB, 0.15102356E-23_JPRB, 0.22442426E-23_JPRB, 0.32356653E-23_JPRB, 0.45029289E-23_JPRB, &
  & 0.60788375E-23_JPRB, 0.79714181E-23_JPRB, 0.10295413E-22_JPRB, 0.13136045E-22_JPRB, 0.16766279E-22_JPRB, 0.21312191E-22_JPRB, &
  & 0.27335176E-22_JPRB, 0.34655205E-22_JPRB, 0.44375865E-22_JPRB, 0.55492364E-22_JPRB, 0.69729700E-22_JPRB, 0.86448780E-22_JPRB, &
  & 0.10098845E-21_JPRB, 0.11530813E-21_JPRB, 0.11610288E-21_JPRB, 0.10081213E-21_JPRB, 0.10116929E-21_JPRB, 0.65523367E-22_JPRB, &
  & 0.50076360E-22_JPRB, 0.32783724E-22_JPRB, 0.27012162E-22_JPRB, 0.22515332E-22_JPRB, 0.14025234E-22_JPRB, 0.86651235E-23_JPRB, &
  & 0.56693039E-23_JPRB, 0.33421398E-23_JPRB, 0.18462497E-23_JPRB, 0.85143030E-24_JPRB, 0.38053851E-24_JPRB, 0.18651263E-24_JPRB, &
  & 0.11231638E-24_JPRB, 0.66181923E-25_JPRB, 0.34400921E-25_JPRB, 0.16145591E-25_JPRB, 0.85828475E-26_JPRB, 0.62996633E-26_JPRB, &
  & 0.43990890E-26_JPRB, 0.32481155E-26_JPRB, 0.37343500E-26_JPRB, 0.41916240E-26_JPRB, 0.53312075E-26_JPRB, 0.69449789E-26_JPRB, &
  & 0.12214574E-25_JPRB, 0.18780410E-25_JPRB, 0.31468836E-25_JPRB, 0.47925605E-25_JPRB /)

RGHG9(:,12, 7) = (/ &
  & 0.18227223E-21_JPRB, 0.18487509E-21_JPRB, 0.17221386E-21_JPRB, 0.15313324E-21_JPRB, 0.13264373E-21_JPRB, 0.11194507E-21_JPRB, &
  & 0.95062062E-22_JPRB, 0.82279732E-22_JPRB, 0.75028927E-22_JPRB, 0.76006111E-22_JPRB, 0.88093631E-22_JPRB, 0.11450801E-21_JPRB, &
  & 0.16004519E-21_JPRB, 0.23049251E-21_JPRB, 0.33218317E-21_JPRB, 0.46879871E-21_JPRB, 0.64118746E-21_JPRB, 0.84695091E-21_JPRB, &
  & 0.10858043E-20_JPRB, 0.13547099E-20_JPRB, 0.16665948E-20_JPRB, 0.20292219E-20_JPRB, 0.24763142E-20_JPRB, 0.30143380E-20_JPRB, &
  & 0.37139998E-20_JPRB, 0.45398653E-20_JPRB, 0.56290061E-20_JPRB, 0.68544701E-20_JPRB, 0.84348706E-20_JPRB, 0.10307828E-19_JPRB, &
  & 0.11938132E-19_JPRB, 0.13600673E-19_JPRB, 0.13745840E-19_JPRB, 0.12060602E-19_JPRB, 0.12302176E-19_JPRB, 0.81431214E-20_JPRB, &
  & 0.64046656E-20_JPRB, 0.43382352E-20_JPRB, 0.37234489E-20_JPRB, 0.32417386E-20_JPRB, 0.21169529E-20_JPRB, 0.13805424E-20_JPRB, &
  & 0.95767966E-21_JPRB, 0.59981429E-21_JPRB, 0.35282898E-21_JPRB, 0.17327090E-21_JPRB, 0.82853796E-22_JPRB, 0.43711963E-22_JPRB, &
  & 0.28406379E-22_JPRB, 0.17955527E-22_JPRB, 0.99614610E-23_JPRB, 0.49782929E-23_JPRB, 0.28228041E-23_JPRB, 0.22018930E-23_JPRB, &
  & 0.16156906E-23_JPRB, 0.12472738E-23_JPRB, 0.14883616E-23_JPRB, 0.17190476E-23_JPRB, 0.22372324E-23_JPRB, 0.29703690E-23_JPRB, &
  & 0.52900129E-23_JPRB, 0.82103657E-23_JPRB, 0.13844361E-22_JPRB, 0.21209830E-22_JPRB /)

RGHG9(:,13, 7) = (/ &
  & 0.43768320E-19_JPRB, 0.44450650E-19_JPRB, 0.41317410E-19_JPRB, 0.36797139E-19_JPRB, 0.31579824E-19_JPRB, 0.26676990E-19_JPRB, &
  & 0.22345378E-19_JPRB, 0.19163872E-19_JPRB, 0.17178027E-19_JPRB, 0.17033285E-19_JPRB, 0.19208189E-19_JPRB, 0.24155354E-19_JPRB, &
  & 0.32488801E-19_JPRB, 0.44842592E-19_JPRB, 0.61739527E-19_JPRB, 0.83024338E-19_JPRB, 0.10809225E-18_JPRB, 0.13573186E-18_JPRB, &
  & 0.16556206E-18_JPRB, 0.19646978E-18_JPRB, 0.23025924E-18_JPRB, 0.26727604E-18_JPRB, 0.31154202E-18_JPRB, 0.36314586E-18_JPRB, &
  & 0.42962699E-18_JPRB, 0.50634310E-18_JPRB, 0.60812602E-18_JPRB, 0.72087999E-18_JPRB, 0.86846334E-18_JPRB, 0.10450655E-17_JPRB, &
  & 0.11991707E-17_JPRB, 0.13617189E-17_JPRB, 0.13808016E-17_JPRB, 0.12240747E-17_JPRB, 0.12688271E-17_JPRB, 0.85874551E-18_JPRB, &
  & 0.69570429E-18_JPRB, 0.48823762E-18_JPRB, 0.43712525E-18_JPRB, 0.39784089E-18_JPRB, 0.27270578E-18_JPRB, 0.18784171E-18_JPRB, &
  & 0.13815834E-18_JPRB, 0.91949869E-19_JPRB, 0.57613388E-19_JPRB, 0.30169229E-19_JPRB, 0.15448966E-19_JPRB, 0.87714224E-20_JPRB, &
  & 0.61428698E-20_JPRB, 0.41611688E-20_JPRB, 0.24637710E-20_JPRB, 0.13110227E-20_JPRB, 0.79233906E-21_JPRB, 0.65573213E-21_JPRB, &
  & 0.50513896E-21_JPRB, 0.40738166E-21_JPRB, 0.50374693E-21_JPRB, 0.59773594E-21_JPRB, 0.79418709E-21_JPRB, 0.10719683E-20_JPRB, &
  & 0.19283202E-20_JPRB, 0.30154619E-20_JPRB, 0.51081214E-20_JPRB, 0.78630997E-20_JPRB /)

RGHG9(:,14, 7) = (/ &
  & 0.89751024E-17_JPRB, 0.91067473E-17_JPRB, 0.84551433E-17_JPRB, 0.74925375E-17_JPRB, 0.64205999E-17_JPRB, 0.53654206E-17_JPRB, &
  & 0.44634711E-17_JPRB, 0.37698008E-17_JPRB, 0.33223962E-17_JPRB, 0.32222163E-17_JPRB, 0.35354493E-17_JPRB, 0.43028633E-17_JPRB, &
  & 0.55767834E-17_JPRB, 0.73886701E-17_JPRB, 0.97349215E-17_JPRB, 0.12502367E-16_JPRB, 0.15510748E-16_JPRB, 0.18549596E-16_JPRB, &
  & 0.21519975E-16_JPRB, 0.24300402E-16_JPRB, 0.27090352E-16_JPRB, 0.29958894E-16_JPRB, 0.33315741E-16_JPRB, 0.37157578E-16_JPRB, &
  & 0.42200700E-16_JPRB, 0.47965941E-16_JPRB, 0.55812794E-16_JPRB, 0.64446555E-16_JPRB, 0.76019123E-16_JPRB, 0.90088816E-16_JPRB, &
  & 0.10236696E-15_JPRB, 0.11584275E-15_JPRB, 0.11782042E-15_JPRB, 0.10551448E-15_JPRB, 0.11111937E-15_JPRB, 0.76926732E-16_JPRB, &
  & 0.64190413E-16_JPRB, 0.46725639E-16_JPRB, 0.43656687E-16_JPRB, 0.41555953E-16_JPRB, 0.29917349E-16_JPRB, 0.21771225E-16_JPRB, &
  & 0.16976128E-16_JPRB, 0.12004139E-16_JPRB, 0.80123535E-17_JPRB, 0.44753854E-17_JPRB, 0.24555376E-17_JPRB, 0.15004154E-17_JPRB, &
  & 0.11314445E-17_JPRB, 0.82100881E-18_JPRB, 0.51866763E-18_JPRB, 0.29387791E-18_JPRB, 0.18924922E-18_JPRB, 0.16600957E-18_JPRB, &
  & 0.13422768E-18_JPRB, 0.11307723E-18_JPRB, 0.14484243E-18_JPRB, 0.17650934E-18_JPRB, 0.23931069E-18_JPRB, 0.32796729E-18_JPRB, &
  & 0.59593503E-18_JPRB, 0.93808041E-18_JPRB, 0.15958868E-17_JPRB, 0.24656184E-17_JPRB /)

RGHG9(:,15, 7) = (/ &
  & 0.15626486E-14_JPRB, 0.15781160E-14_JPRB, 0.14606508E-14_JPRB, 0.12910209E-14_JPRB, 0.11009150E-14_JPRB, 0.91513037E-15_JPRB, &
  & 0.75382819E-15_JPRB, 0.62873858E-15_JPRB, 0.54473409E-15_JPRB, 0.51686649E-15_JPRB, 0.55180560E-15_JPRB, 0.65019027E-15_JPRB, &
  & 0.81215859E-15_JPRB, 0.10332770E-14_JPRB, 0.13035584E-14_JPRB, 0.15987836E-14_JPRB, 0.18915504E-14_JPRB, 0.21534781E-14_JPRB, &
  & 0.23774398E-14_JPRB, 0.25536493E-14_JPRB, 0.27090197E-14_JPRB, 0.28535430E-14_JPRB, 0.30270448E-14_JPRB, 0.32295971E-14_JPRB, &
  & 0.35195578E-14_JPRB, 0.38565126E-14_JPRB, 0.43474385E-14_JPRB, 0.48890805E-14_JPRB, 0.56486315E-14_JPRB, 0.65943878E-14_JPRB, &
  & 0.74241413E-14_JPRB, 0.83736203E-14_JPRB, 0.85434784E-14_JPRB, 0.77302751E-14_JPRB, 0.82733511E-14_JPRB, 0.58578685E-14_JPRB, &
  & 0.50375209E-14_JPRB, 0.38028302E-14_JPRB, 0.37092606E-14_JPRB, 0.36928663E-14_JPRB, 0.27924792E-14_JPRB, 0.21466104E-14_JPRB, &
  & 0.17741813E-14_JPRB, 0.13330304E-14_JPRB, 0.94776094E-15_JPRB, 0.56488183E-15_JPRB, 0.33218658E-15_JPRB, 0.21854316E-15_JPRB, &
  & 0.17742885E-15_JPRB, 0.13790316E-15_JPRB, 0.92965539E-16_JPRB, 0.56098747E-16_JPRB, 0.38483503E-16_JPRB, 0.35755183E-16_JPRB, &
  & 0.30332561E-16_JPRB, 0.26687126E-16_JPRB, 0.35408260E-16_JPRB, 0.44322064E-16_JPRB, 0.61338142E-16_JPRB, 0.85352678E-16_JPRB, &
  & 0.15679967E-15_JPRB, 0.24846788E-15_JPRB, 0.42473406E-15_JPRB, 0.65819182E-15_JPRB /)

RGHG9(:,16, 7) = (/ &
  & 0.13154467E-13_JPRB, 0.11951211E-13_JPRB, 0.10661885E-13_JPRB, 0.93099839E-14_JPRB, 0.78851898E-14_JPRB, 0.65647031E-14_JPRB, &
  & 0.54157182E-14_JPRB, 0.45385880E-14_JPRB, 0.39631638E-14_JPRB, 0.37475613E-14_JPRB, 0.39716354E-14_JPRB, 0.46653499E-14_JPRB, &
  & 0.58497679E-14_JPRB, 0.75282798E-14_JPRB, 0.96711037E-14_JPRB, 0.12170174E-13_JPRB, 0.14867881E-13_JPRB, 0.17602893E-13_JPRB, &
  & 0.20273961E-13_JPRB, 0.22814179E-13_JPRB, 0.25331081E-13_JPRB, 0.27936312E-13_JPRB, 0.30848737E-13_JPRB, 0.34205413E-13_JPRB, &
  & 0.38279702E-13_JPRB, 0.42928202E-13_JPRB, 0.48332622E-13_JPRB, 0.53989074E-13_JPRB, 0.59855956E-13_JPRB, 0.65340216E-13_JPRB, &
  & 0.69660810E-13_JPRB, 0.73126740E-13_JPRB, 0.75529135E-13_JPRB, 0.75743746E-13_JPRB, 0.74684067E-13_JPRB, 0.72015724E-13_JPRB, &
  & 0.58652600E-13_JPRB, 0.45349626E-13_JPRB, 0.34048068E-13_JPRB, 0.25352760E-13_JPRB, 0.21161361E-13_JPRB, 0.17652422E-13_JPRB, &
  & 0.13882943E-13_JPRB, 0.10326989E-13_JPRB, 0.68513823E-14_JPRB, 0.45771831E-14_JPRB, 0.32540365E-14_JPRB, 0.24830227E-14_JPRB, &
  & 0.20579809E-14_JPRB, 0.16355863E-14_JPRB, 0.11388771E-14_JPRB, 0.75640974E-15_JPRB, 0.53691926E-15_JPRB, 0.42354257E-15_JPRB, &
  & 0.35309879E-15_JPRB, 0.34424915E-15_JPRB, 0.41194193E-15_JPRB, 0.50604686E-15_JPRB, 0.61209502E-15_JPRB, 0.72120451E-15_JPRB, &
  & 0.12067615E-14_JPRB, 0.16508933E-14_JPRB, 0.22093192E-14_JPRB, 0.21080577E-14_JPRB /)

RGHG9(:,17, 7) = (/ &
  & 0.65134699E-13_JPRB, 0.55373058E-13_JPRB, 0.48304161E-13_JPRB, 0.41810136E-13_JPRB, 0.35488309E-13_JPRB, 0.29485393E-13_JPRB, &
  & 0.24423887E-13_JPRB, 0.20520381E-13_JPRB, 0.18050809E-13_JPRB, 0.17116383E-13_JPRB, 0.18097891E-13_JPRB, 0.21293333E-13_JPRB, &
  & 0.27003969E-13_JPRB, 0.35515858E-13_JPRB, 0.47047957E-13_JPRB, 0.61494456E-13_JPRB, 0.78377809E-13_JPRB, 0.96971442E-13_JPRB, &
  & 0.11661418E-12_JPRB, 0.13686770E-12_JPRB, 0.15808963E-12_JPRB, 0.18134818E-12_JPRB, 0.20799436E-12_JPRB, 0.23978595E-12_JPRB, &
  & 0.27740291E-12_JPRB, 0.31971157E-12_JPRB, 0.36382529E-12_JPRB, 0.40402593E-12_JPRB, 0.43336081E-12_JPRB, 0.44859735E-12_JPRB, &
  & 0.45244353E-12_JPRB, 0.43670517E-12_JPRB, 0.40843931E-12_JPRB, 0.36330468E-12_JPRB, 0.30074706E-12_JPRB, 0.24239009E-12_JPRB, &
  & 0.19946165E-12_JPRB, 0.17458176E-12_JPRB, 0.15210402E-12_JPRB, 0.13228837E-12_JPRB, 0.11148820E-12_JPRB, 0.94397004E-13_JPRB, &
  & 0.79202432E-13_JPRB, 0.65337899E-13_JPRB, 0.52313168E-13_JPRB, 0.41347741E-13_JPRB, 0.32834605E-13_JPRB, 0.26419432E-13_JPRB, &
  & 0.20434041E-13_JPRB, 0.15220587E-13_JPRB, 0.10985395E-13_JPRB, 0.82522820E-14_JPRB, 0.65216141E-14_JPRB, 0.53672726E-14_JPRB, &
  & 0.44735757E-14_JPRB, 0.38323675E-14_JPRB, 0.36460631E-14_JPRB, 0.42198343E-14_JPRB, 0.51125439E-14_JPRB, 0.59858747E-14_JPRB, &
  & 0.75999946E-14_JPRB, 0.11345200E-13_JPRB, 0.14381369E-13_JPRB, 0.29035334E-13_JPRB /)

RGHG9(:,18, 7) = (/ &
  & 0.22561597E-12_JPRB, 0.18734568E-12_JPRB, 0.16152348E-12_JPRB, 0.14047659E-12_JPRB, 0.12006764E-12_JPRB, 0.10100448E-12_JPRB, &
  & 0.84386254E-13_JPRB, 0.71437688E-13_JPRB, 0.63162718E-13_JPRB, 0.60214461E-13_JPRB, 0.63498679E-13_JPRB, 0.74556423E-13_JPRB, &
  & 0.94856292E-13_JPRB, 0.12624965E-12_JPRB, 0.17056094E-12_JPRB, 0.22871098E-12_JPRB, 0.30004634E-12_JPRB, 0.38270954E-12_JPRB, &
  & 0.47463200E-12_JPRB, 0.57425288E-12_JPRB, 0.68284289E-12_JPRB, 0.80548166E-12_JPRB, 0.95201505E-12_JPRB, 0.11318401E-11_JPRB, &
  & 0.13431701E-11_JPRB, 0.15645306E-11_JPRB, 0.17775080E-11_JPRB, 0.19564188E-11_JPRB, 0.20668636E-11_JPRB, 0.20849056E-11_JPRB, &
  & 0.19981755E-11_JPRB, 0.18298332E-11_JPRB, 0.16044254E-11_JPRB, 0.13624970E-11_JPRB, 0.11309982E-11_JPRB, 0.93435014E-12_JPRB, &
  & 0.77135184E-12_JPRB, 0.64001847E-12_JPRB, 0.55936397E-12_JPRB, 0.50940410E-12_JPRB, 0.47800755E-12_JPRB, 0.44301084E-12_JPRB, &
  & 0.40226367E-12_JPRB, 0.35861269E-12_JPRB, 0.31309428E-12_JPRB, 0.26767081E-12_JPRB, 0.22488433E-12_JPRB, 0.18537860E-12_JPRB, &
  & 0.14950760E-12_JPRB, 0.11964721E-12_JPRB, 0.95426149E-13_JPRB, 0.77431957E-13_JPRB, 0.64396852E-13_JPRB, 0.53957652E-13_JPRB, &
  & 0.45462877E-13_JPRB, 0.38770179E-13_JPRB, 0.34455030E-13_JPRB, 0.33540055E-13_JPRB, 0.37248206E-13_JPRB, 0.45054096E-13_JPRB, &
  & 0.54810689E-13_JPRB, 0.67289171E-13_JPRB, 0.93167112E-13_JPRB, 0.13501633E-12_JPRB /)

RGHG9(:,19, 7) = (/ &
  & 0.58094182E-12_JPRB, 0.48960651E-12_JPRB, 0.42577297E-12_JPRB, 0.37431576E-12_JPRB, 0.32512209E-12_JPRB, 0.27836774E-12_JPRB, &
  & 0.23641877E-12_JPRB, 0.20282818E-12_JPRB, 0.18072975E-12_JPRB, 0.17301094E-12_JPRB, 0.18167165E-12_JPRB, 0.21053099E-12_JPRB, &
  & 0.26465229E-12_JPRB, 0.35021411E-12_JPRB, 0.47353376E-12_JPRB, 0.63946667E-12_JPRB, 0.84837703E-12_JPRB, 0.10959243E-11_JPRB, &
  & 0.13776078E-11_JPRB, 0.16922848E-11_JPRB, 0.20439408E-11_JPRB, 0.24427966E-11_JPRB, 0.29128228E-11_JPRB, 0.34776958E-11_JPRB, &
  & 0.41241403E-11_JPRB, 0.48115600E-11_JPRB, 0.54700602E-11_JPRB, 0.59608529E-11_JPRB, 0.61901075E-11_JPRB, 0.60930206E-11_JPRB, &
  & 0.57048758E-11_JPRB, 0.50912469E-11_JPRB, 0.43508578E-11_JPRB, 0.35885071E-11_JPRB, 0.28744620E-11_JPRB, 0.23059109E-11_JPRB, &
  & 0.19054942E-11_JPRB, 0.16667179E-11_JPRB, 0.15533616E-11_JPRB, 0.15238900E-11_JPRB, 0.15260265E-11_JPRB, 0.15293887E-11_JPRB, &
  & 0.15038490E-11_JPRB, 0.14331937E-11_JPRB, 0.13242212E-11_JPRB, 0.11906162E-11_JPRB, 0.10450840E-11_JPRB, 0.89664918E-12_JPRB, &
  & 0.75512291E-12_JPRB, 0.62736432E-12_JPRB, 0.51688108E-12_JPRB, 0.42517864E-12_JPRB, 0.35052809E-12_JPRB, 0.29180391E-12_JPRB, &
  & 0.24846035E-12_JPRB, 0.21852462E-12_JPRB, 0.19961253E-12_JPRB, 0.19107493E-12_JPRB, 0.19574521E-12_JPRB, 0.21514709E-12_JPRB, &
  & 0.24720780E-12_JPRB, 0.28776932E-12_JPRB, 0.33715443E-12_JPRB, 0.45898501E-12_JPRB /)

RGHG9(:,20, 7) = (/ &
  & 0.12449318E-11_JPRB, 0.10595136E-11_JPRB, 0.93771919E-12_JPRB, 0.83643455E-12_JPRB, 0.73998940E-12_JPRB, 0.64612877E-12_JPRB, &
  & 0.55967774E-12_JPRB, 0.48721216E-12_JPRB, 0.43786808E-12_JPRB, 0.41908455E-12_JPRB, 0.43655978E-12_JPRB, 0.49529006E-12_JPRB, &
  & 0.60762875E-12_JPRB, 0.78536288E-12_JPRB, 0.10428550E-11_JPRB, 0.13894136E-11_JPRB, 0.18266042E-11_JPRB, 0.23453078E-11_JPRB, &
  & 0.29325006E-11_JPRB, 0.35832086E-11_JPRB, 0.43145617E-11_JPRB, 0.51426988E-11_JPRB, 0.60933055E-11_JPRB, 0.72004286E-11_JPRB, &
  & 0.84625935E-11_JPRB, 0.97921758E-11_JPRB, 0.11011065E-10_JPRB, 0.11903771E-10_JPRB, 0.12295282E-10_JPRB, 0.12106724E-10_JPRB, &
  & 0.11378209E-10_JPRB, 0.10224248E-10_JPRB, 0.88225868E-11_JPRB, 0.73763599E-11_JPRB, 0.60371690E-11_JPRB, 0.49801552E-11_JPRB, &
  & 0.42399504E-11_JPRB, 0.38234763E-11_JPRB, 0.36613846E-11_JPRB, 0.36828912E-11_JPRB, 0.38047699E-11_JPRB, 0.39143836E-11_JPRB, &
  & 0.39561817E-11_JPRB, 0.39088559E-11_JPRB, 0.37597113E-11_JPRB, 0.35143798E-11_JPRB, 0.31986243E-11_JPRB, 0.28412921E-11_JPRB, &
  & 0.24731218E-11_JPRB, 0.21186817E-11_JPRB, 0.17967895E-11_JPRB, 0.15129659E-11_JPRB, 0.12730303E-11_JPRB, 0.10775829E-11_JPRB, &
  & 0.92908992E-12_JPRB, 0.82412641E-12_JPRB, 0.75705761E-12_JPRB, 0.72298710E-12_JPRB, 0.72108866E-12_JPRB, 0.74869955E-12_JPRB, &
  & 0.80154693E-12_JPRB, 0.87995946E-12_JPRB, 0.98974637E-12_JPRB, 0.11917657E-11_JPRB /)

RGHG9(:,21, 7) = (/ &
  & 0.23151106E-11_JPRB, 0.19992040E-11_JPRB, 0.18034931E-11_JPRB, 0.16348806E-11_JPRB, 0.14715430E-11_JPRB, 0.13102190E-11_JPRB, &
  & 0.11551933E-11_JPRB, 0.10216385E-11_JPRB, 0.92599160E-12_JPRB, 0.88476345E-12_JPRB, 0.90896805E-12_JPRB, 0.10078372E-11_JPRB, &
  & 0.11957113E-11_JPRB, 0.14922253E-11_JPRB, 0.19162595E-11_JPRB, 0.24819710E-11_JPRB, 0.31863978E-11_JPRB, 0.40128109E-11_JPRB, &
  & 0.49415190E-11_JPRB, 0.59575253E-11_JPRB, 0.70729533E-11_JPRB, 0.83339958E-11_JPRB, 0.97811204E-11_JPRB, 0.11456713E-10_JPRB, &
  & 0.13337899E-10_JPRB, 0.15297586E-10_JPRB, 0.17103274E-10_JPRB, 0.18440733E-10_JPRB, 0.19082153E-10_JPRB, 0.18954522E-10_JPRB, &
  & 0.18087186E-10_JPRB, 0.16605660E-10_JPRB, 0.14722805E-10_JPRB, 0.12678943E-10_JPRB, 0.10760478E-10_JPRB, 0.92033490E-11_JPRB, &
  & 0.81072701E-11_JPRB, 0.74968894E-11_JPRB, 0.73309232E-11_JPRB, 0.74411501E-11_JPRB, 0.76874930E-11_JPRB, 0.79370772E-11_JPRB, &
  & 0.80836119E-11_JPRB, 0.80527061E-11_JPRB, 0.78329973E-11_JPRB, 0.74536098E-11_JPRB, 0.69467162E-11_JPRB, 0.63418749E-11_JPRB, &
  & 0.56844477E-11_JPRB, 0.50219395E-11_JPRB, 0.43884150E-11_JPRB, 0.38016933E-11_JPRB, 0.32852642E-11_JPRB, 0.28530154E-11_JPRB, &
  & 0.25109572E-11_JPRB, 0.22537959E-11_JPRB, 0.20743368E-11_JPRB, 0.19668108E-11_JPRB, 0.19293321E-11_JPRB, 0.19505311E-11_JPRB, &
  & 0.20130026E-11_JPRB, 0.21086492E-11_JPRB, 0.22530834E-11_JPRB, 0.25561656E-11_JPRB /)

RGHG9(:,22, 7) = (/ &
  & 0.39027627E-11_JPRB, 0.34250120E-11_JPRB, 0.31321844E-11_JPRB, 0.28806315E-11_JPRB, 0.26341772E-11_JPRB, 0.23838230E-11_JPRB, &
  & 0.21390229E-11_JPRB, 0.19187833E-11_JPRB, 0.17564165E-11_JPRB, 0.16770748E-11_JPRB, 0.17004141E-11_JPRB, 0.18407290E-11_JPRB, &
  & 0.21106469E-11_JPRB, 0.25338206E-11_JPRB, 0.31299932E-11_JPRB, 0.39103165E-11_JPRB, 0.48699066E-11_JPRB, 0.59841238E-11_JPRB, &
  & 0.72262266E-11_JPRB, 0.85894772E-11_JPRB, 0.10081839E-10_JPRB, 0.11745759E-10_JPRB, 0.13627676E-10_JPRB, 0.15774066E-10_JPRB, &
  & 0.18150719E-10_JPRB, 0.20638902E-10_JPRB, 0.22902012E-10_JPRB, 0.24651467E-10_JPRB, 0.25664599E-10_JPRB, 0.25815189E-10_JPRB, &
  & 0.25102250E-10_JPRB, 0.23659468E-10_JPRB, 0.21672700E-10_JPRB, 0.19428206E-10_JPRB, 0.17235283E-10_JPRB, 0.15382827E-10_JPRB, &
  & 0.14042391E-10_JPRB, 0.13277077E-10_JPRB, 0.12987746E-10_JPRB, 0.13091151E-10_JPRB, 0.13364966E-10_JPRB, 0.13643342E-10_JPRB, &
  & 0.13773891E-10_JPRB, 0.13709984E-10_JPRB, 0.13409011E-10_JPRB, 0.12866169E-10_JPRB, 0.12126429E-10_JPRB, 0.11235567E-10_JPRB, &
  & 0.10263956E-10_JPRB, 0.92650922E-11_JPRB, 0.82822247E-11_JPRB, 0.73535440E-11_JPRB, 0.65260380E-11_JPRB, 0.58171475E-11_JPRB, &
  & 0.52349327E-11_JPRB, 0.47731845E-11_JPRB, 0.44238693E-11_JPRB, 0.41829942E-11_JPRB, 0.40533397E-11_JPRB, 0.40227522E-11_JPRB, &
  & 0.40664221E-11_JPRB, 0.41666536E-11_JPRB, 0.43229010E-11_JPRB, 0.46485329E-11_JPRB /)

RGHG9(:,23, 7) = (/ &
  & 0.60489092E-11_JPRB, 0.53868125E-11_JPRB, 0.50019871E-11_JPRB, 0.46599617E-11_JPRB, 0.43213736E-11_JPRB, 0.39737554E-11_JPRB, &
  & 0.36228065E-11_JPRB, 0.33043308E-11_JPRB, 0.30602086E-11_JPRB, 0.29324492E-11_JPRB, 0.29499684E-11_JPRB, 0.31330830E-11_JPRB, &
  & 0.34949422E-11_JPRB, 0.40492275E-11_JPRB, 0.48162863E-11_JPRB, 0.58010532E-11_JPRB, 0.69923008E-11_JPRB, 0.83662122E-11_JPRB, &
  & 0.98871380E-11_JPRB, 0.11546936E-10_JPRB, 0.13361244E-10_JPRB, 0.15366233E-10_JPRB, 0.17606212E-10_JPRB, 0.20110844E-10_JPRB, &
  & 0.22860460E-10_JPRB, 0.25685431E-10_JPRB, 0.28325228E-10_JPRB, 0.30439557E-10_JPRB, 0.31788839E-10_JPRB, 0.32312597E-10_JPRB, &
  & 0.32010720E-10_JPRB, 0.30965577E-10_JPRB, 0.29326507E-10_JPRB, 0.27360551E-10_JPRB, 0.25317333E-10_JPRB, 0.23514992E-10_JPRB, &
  & 0.22125123E-10_JPRB, 0.21230922E-10_JPRB, 0.20801682E-10_JPRB, 0.20681980E-10_JPRB, 0.20712716E-10_JPRB, 0.20731090E-10_JPRB, &
  & 0.20623146E-10_JPRB, 0.20289525E-10_JPRB, 0.19722061E-10_JPRB, 0.18943005E-10_JPRB, 0.17968802E-10_JPRB, 0.16829538E-10_JPRB, &
  & 0.15586895E-10_JPRB, 0.14301556E-10_JPRB, 0.13038513E-10_JPRB, 0.11845546E-10_JPRB, 0.10767044E-10_JPRB, 0.98193727E-11_JPRB, &
  & 0.90148340E-11_JPRB, 0.83501140E-11_JPRB, 0.78192158E-11_JPRB, 0.74195849E-11_JPRB, 0.71578412E-11_JPRB, 0.70232670E-11_JPRB, &
  & 0.69916945E-11_JPRB, 0.70444536E-11_JPRB, 0.71842506E-11_JPRB, 0.75260536E-11_JPRB /)

RGHG9(:,24, 7) = (/ &
  & 0.87083544E-11_JPRB, 0.79251397E-11_JPRB, 0.74404111E-11_JPRB, 0.70184349E-11_JPRB, 0.65960553E-11_JPRB, 0.61566312E-11_JPRB, &
  & 0.57115467E-11_JPRB, 0.52992753E-11_JPRB, 0.49813998E-11_JPRB, 0.48142081E-11_JPRB, 0.48392930E-11_JPRB, 0.50831236E-11_JPRB, &
  & 0.55605425E-11_JPRB, 0.62754485E-11_JPRB, 0.72365378E-11_JPRB, 0.84440198E-11_JPRB, 0.98753150E-11_JPRB, 0.11501754E-10_JPRB, &
  & 0.13289410E-10_JPRB, 0.15221746E-10_JPRB, 0.17305574E-10_JPRB, 0.19567303E-10_JPRB, 0.22049907E-10_JPRB, 0.24772941E-10_JPRB, &
  & 0.27679725E-10_JPRB, 0.30627351E-10_JPRB, 0.33365487E-10_JPRB, 0.35659777E-10_JPRB, 0.37359775E-10_JPRB, 0.38333274E-10_JPRB, &
  & 0.38584042E-10_JPRB, 0.38178436E-10_JPRB, 0.37233886E-10_JPRB, 0.35916017E-10_JPRB, 0.34438341E-10_JPRB, 0.33031251E-10_JPRB, &
  & 0.31826864E-10_JPRB, 0.30899675E-10_JPRB, 0.30198601E-10_JPRB, 0.29688463E-10_JPRB, 0.29234996E-10_JPRB, 0.28741155E-10_JPRB, &
  & 0.28123497E-10_JPRB, 0.27348346E-10_JPRB, 0.26371351E-10_JPRB, 0.25207085E-10_JPRB, 0.23913399E-10_JPRB, 0.22518404E-10_JPRB, &
  & 0.21070232E-10_JPRB, 0.19618787E-10_JPRB, 0.18208121E-10_JPRB, 0.16866796E-10_JPRB, 0.15631938E-10_JPRB, 0.14521139E-10_JPRB, &
  & 0.13549170E-10_JPRB, 0.12718740E-10_JPRB, 0.12029707E-10_JPRB, 0.11484451E-10_JPRB, 0.11092134E-10_JPRB, 0.10844702E-10_JPRB, &
  & 0.10717453E-10_JPRB, 0.10690500E-10_JPRB, 0.10749057E-10_JPRB, 0.10969271E-10_JPRB /)

RGHG9(:,25, 7) = (/ &
  & 0.11864305E-10_JPRB, 0.10952383E-10_JPRB, 0.10417583E-10_JPRB, 0.99380426E-11_JPRB, 0.94634908E-11_JPRB, 0.89680320E-11_JPRB, &
  & 0.84636048E-11_JPRB, 0.79974950E-11_JPRB, 0.76452403E-11_JPRB, 0.74802378E-11_JPRB, 0.75572829E-11_JPRB, 0.79107432E-11_JPRB, &
  & 0.85571055E-11_JPRB, 0.94954010E-11_JPRB, 0.10710917E-10_JPRB, 0.12191469E-10_JPRB, 0.13900506E-10_JPRB, 0.15797129E-10_JPRB, &
  & 0.17843040E-10_JPRB, 0.20017692E-10_JPRB, 0.22314921E-10_JPRB, 0.24743865E-10_JPRB, 0.27310560E-10_JPRB, 0.30031859E-10_JPRB, &
  & 0.32857259E-10_JPRB, 0.35670501E-10_JPRB, 0.38328955E-10_JPRB, 0.40641615E-10_JPRB, 0.42476831E-10_JPRB, 0.43827227E-10_JPRB, &
  & 0.44650929E-10_JPRB, 0.44965930E-10_JPRB, 0.44842362E-10_JPRB, 0.44346127E-10_JPRB, 0.43608683E-10_JPRB, 0.42725313E-10_JPRB, &
  & 0.41809410E-10_JPRB, 0.40896123E-10_JPRB, 0.39943847E-10_JPRB, 0.38996875E-10_JPRB, 0.37978620E-10_JPRB, 0.36859949E-10_JPRB, &
  & 0.35639085E-10_JPRB, 0.34320231E-10_JPRB, 0.32920257E-10_JPRB, 0.31433401E-10_JPRB, 0.29867060E-10_JPRB, 0.28240158E-10_JPRB, &
  & 0.26617994E-10_JPRB, 0.25033017E-10_JPRB, 0.23515519E-10_JPRB, 0.22082594E-10_JPRB, 0.20758773E-10_JPRB, 0.19552785E-10_JPRB, &
  & 0.18475853E-10_JPRB, 0.17531136E-10_JPRB, 0.16721404E-10_JPRB, 0.16054347E-10_JPRB, 0.15543771E-10_JPRB, 0.15186484E-10_JPRB, &
  & 0.14961860E-10_JPRB, 0.14845037E-10_JPRB, 0.14813699E-10_JPRB, 0.14898145E-10_JPRB /)

RGHG9(:,26, 7) = (/ &
  & 0.15347865E-10_JPRB, 0.14410138E-10_JPRB, 0.13854747E-10_JPRB, 0.13366753E-10_JPRB, 0.12882922E-10_JPRB, 0.12384049E-10_JPRB, &
  & 0.11878300E-10_JPRB, 0.11424767E-10_JPRB, 0.11106428E-10_JPRB, 0.11012966E-10_JPRB, 0.11211633E-10_JPRB, 0.11745067E-10_JPRB, &
  & 0.12629429E-10_JPRB, 0.13858571E-10_JPRB, 0.15399364E-10_JPRB, 0.17210032E-10_JPRB, 0.19233335E-10_JPRB, 0.21415099E-10_JPRB, &
  & 0.23701867E-10_JPRB, 0.26049928E-10_JPRB, 0.28434862E-10_JPRB, 0.30865369E-10_JPRB, 0.33339147E-10_JPRB, 0.35830817E-10_JPRB, &
  & 0.38342905E-10_JPRB, 0.40796692E-10_JPRB, 0.43130586E-10_JPRB, 0.45294039E-10_JPRB, 0.47223916E-10_JPRB, 0.48832566E-10_JPRB, &
  & 0.50125716E-10_JPRB, 0.51088203E-10_JPRB, 0.51709834E-10_JPRB, 0.51976722E-10_JPRB, 0.51923781E-10_JPRB, 0.51567396E-10_JPRB, &
  & 0.50941227E-10_JPRB, 0.50057205E-10_JPRB, 0.48927640E-10_JPRB, 0.47565434E-10_JPRB, 0.46045959E-10_JPRB, 0.44349160E-10_JPRB, &
  & 0.42572924E-10_JPRB, 0.40725576E-10_JPRB, 0.38866688E-10_JPRB, 0.37012709E-10_JPRB, 0.35204620E-10_JPRB, 0.33452068E-10_JPRB, &
  & 0.31763089E-10_JPRB, 0.30150951E-10_JPRB, 0.28625468E-10_JPRB, 0.27193104E-10_JPRB, 0.25865164E-10_JPRB, 0.24643723E-10_JPRB, &
  & 0.23532910E-10_JPRB, 0.22535784E-10_JPRB, 0.21659178E-10_JPRB, 0.20915981E-10_JPRB, 0.20321734E-10_JPRB, 0.19876874E-10_JPRB, &
  & 0.19566114E-10_JPRB, 0.19366127E-10_JPRB, 0.19242247E-10_JPRB, 0.19171418E-10_JPRB /)

RGHG9(:,27, 7) = (/ &
  & 0.19072008E-10_JPRB, 0.18190224E-10_JPRB, 0.17665841E-10_JPRB, 0.17209576E-10_JPRB, 0.16766586E-10_JPRB, 0.16314618E-10_JPRB, &
  & 0.15875107E-10_JPRB, 0.15502294E-10_JPRB, 0.15294281E-10_JPRB, 0.15346814E-10_JPRB, 0.15736683E-10_JPRB, 0.16509748E-10_JPRB, &
  & 0.17684250E-10_JPRB, 0.19240937E-10_JPRB, 0.21135753E-10_JPRB, 0.23287868E-10_JPRB, 0.25623292E-10_JPRB, 0.28059863E-10_JPRB, &
  & 0.30521585E-10_JPRB, 0.32937673E-10_JPRB, 0.35298073E-10_JPRB, 0.37604732E-10_JPRB, 0.39790692E-10_JPRB, 0.41904636E-10_JPRB, &
  & 0.43951114E-10_JPRB, 0.45906626E-10_JPRB, 0.47815325E-10_JPRB, 0.49687723E-10_JPRB, 0.51528344E-10_JPRB, 0.53309707E-10_JPRB, &
  & 0.54967104E-10_JPRB, 0.56425163E-10_JPRB, 0.57610836E-10_JPRB, 0.58441960E-10_JPRB, 0.58881580E-10_JPRB, 0.58896235E-10_JPRB, &
  & 0.58477903E-10_JPRB, 0.57624613E-10_JPRB, 0.56385369E-10_JPRB, 0.54760918E-10_JPRB, 0.52889085E-10_JPRB, 0.50802099E-10_JPRB, &
  & 0.48621863E-10_JPRB, 0.46411260E-10_JPRB, 0.44231164E-10_JPRB, 0.42128818E-10_JPRB, 0.40143548E-10_JPRB, 0.38292605E-10_JPRB, &
  & 0.36578903E-10_JPRB, 0.34990684E-10_JPRB, 0.33513827E-10_JPRB, 0.32136703E-10_JPRB, 0.30857171E-10_JPRB, 0.29667862E-10_JPRB, &
  & 0.28569216E-10_JPRB, 0.27564622E-10_JPRB, 0.26663586E-10_JPRB, 0.25876915E-10_JPRB, 0.25221523E-10_JPRB, 0.24700861E-10_JPRB, &
  & 0.24306949E-10_JPRB, 0.24020098E-10_JPRB, 0.23783704E-10_JPRB, 0.23465617E-10_JPRB /)

RGHG9(:,28, 7) = (/ &
  & 0.23025134E-10_JPRB, 0.22214041E-10_JPRB, 0.21747788E-10_JPRB, 0.21352725E-10_JPRB, 0.20979116E-10_JPRB, 0.20617404E-10_JPRB, &
  & 0.20284798E-10_JPRB, 0.20050515E-10_JPRB, 0.20008425E-10_JPRB, 0.20259931E-10_JPRB, 0.20881238E-10_JPRB, 0.21921230E-10_JPRB, &
  & 0.23388369E-10_JPRB, 0.25257690E-10_JPRB, 0.27463885E-10_JPRB, 0.29912763E-10_JPRB, 0.32492620E-10_JPRB, 0.35110755E-10_JPRB, &
  & 0.37654144E-10_JPRB, 0.40056489E-10_JPRB, 0.42307668E-10_JPRB, 0.44369515E-10_JPRB, 0.46200582E-10_JPRB, 0.47872546E-10_JPRB, &
  & 0.49409900E-10_JPRB, 0.50869847E-10_JPRB, 0.52343047E-10_JPRB, 0.53898861E-10_JPRB, 0.55600486E-10_JPRB, 0.57420391E-10_JPRB, &
  & 0.59257307E-10_JPRB, 0.61013389E-10_JPRB, 0.62548564E-10_JPRB, 0.63724401E-10_JPRB, 0.64453665E-10_JPRB, 0.64678381E-10_JPRB, &
  & 0.64376587E-10_JPRB, 0.63547105E-10_JPRB, 0.62246819E-10_JPRB, 0.60517966E-10_JPRB, 0.58439489E-10_JPRB, 0.56152315E-10_JPRB, &
  & 0.53738951E-10_JPRB, 0.51330062E-10_JPRB, 0.48979296E-10_JPRB, 0.46770358E-10_JPRB, 0.44738210E-10_JPRB, 0.42884224E-10_JPRB, &
  & 0.41200276E-10_JPRB, 0.39663800E-10_JPRB, 0.38247593E-10_JPRB, 0.36933411E-10_JPRB, 0.35709245E-10_JPRB, 0.34563675E-10_JPRB, &
  & 0.33491872E-10_JPRB, 0.32496016E-10_JPRB, 0.31580200E-10_JPRB, 0.30757463E-10_JPRB, 0.30046202E-10_JPRB, 0.29456642E-10_JPRB, &
  & 0.28986103E-10_JPRB, 0.28611710E-10_JPRB, 0.28276768E-10_JPRB, 0.27810809E-10_JPRB /)

RGHG9(:,29, 7) = (/ &
  & 0.27034899E-10_JPRB, 0.26348392E-10_JPRB, 0.25951581E-10_JPRB, 0.25635449E-10_JPRB, 0.25351691E-10_JPRB, 0.25094869E-10_JPRB, &
  & 0.24897072E-10_JPRB, 0.24824325E-10_JPRB, 0.24974117E-10_JPRB, 0.25442724E-10_JPRB, 0.26302745E-10_JPRB, 0.27591271E-10_JPRB, &
  & 0.29315383E-10_JPRB, 0.31431583E-10_JPRB, 0.33869237E-10_JPRB, 0.36514923E-10_JPRB, 0.39245902E-10_JPRB, 0.41943889E-10_JPRB, &
  & 0.44496868E-10_JPRB, 0.46822282E-10_JPRB, 0.48894125E-10_JPRB, 0.50685088E-10_JPRB, 0.52179216E-10_JPRB, 0.53434410E-10_JPRB, &
  & 0.54517810E-10_JPRB, 0.55534383E-10_JPRB, 0.56604516E-10_JPRB, 0.57863533E-10_JPRB, 0.59366706E-10_JPRB, 0.61132072E-10_JPRB, &
  & 0.63048573E-10_JPRB, 0.64945292E-10_JPRB, 0.66653918E-10_JPRB, 0.67995554E-10_JPRB, 0.68857600E-10_JPRB, 0.69173917E-10_JPRB, &
  & 0.68925490E-10_JPRB, 0.68119274E-10_JPRB, 0.66801717E-10_JPRB, 0.65051652E-10_JPRB, 0.62931077E-10_JPRB, 0.60553562E-10_JPRB, &
  & 0.58072085E-10_JPRB, 0.55575072E-10_JPRB, 0.53184741E-10_JPRB, 0.50970048E-10_JPRB, 0.48970980E-10_JPRB, 0.47188017E-10_JPRB, &
  & 0.45592929E-10_JPRB, 0.44138960E-10_JPRB, 0.42797980E-10_JPRB, 0.41549455E-10_JPRB, 0.40380227E-10_JPRB, 0.39277654E-10_JPRB, &
  & 0.38235741E-10_JPRB, 0.37253013E-10_JPRB, 0.36336035E-10_JPRB, 0.35499680E-10_JPRB, 0.34763803E-10_JPRB, 0.34140215E-10_JPRB, &
  & 0.33635403E-10_JPRB, 0.33219875E-10_JPRB, 0.32834419E-10_JPRB, 0.32252711E-10_JPRB /)

RGHG9(:,30, 7) = (/ &
  & 0.30975340E-10_JPRB, 0.30440133E-10_JPRB, 0.30139786E-10_JPRB, 0.29906896E-10_JPRB, 0.29713405E-10_JPRB, 0.29566721E-10_JPRB, &
  & 0.29502335E-10_JPRB, 0.29593272E-10_JPRB, 0.29933254E-10_JPRB, 0.30609182E-10_JPRB, 0.31679683E-10_JPRB, 0.33178765E-10_JPRB, &
  & 0.35092360E-10_JPRB, 0.37376116E-10_JPRB, 0.39943479E-10_JPRB, 0.42684394E-10_JPRB, 0.45465222E-10_JPRB, 0.48165506E-10_JPRB, &
  & 0.50666416E-10_JPRB, 0.52882955E-10_JPRB, 0.54770324E-10_JPRB, 0.56319265E-10_JPRB, 0.57522286E-10_JPRB, 0.58441203E-10_JPRB, &
  & 0.59168094E-10_JPRB, 0.59837482E-10_JPRB, 0.60606721E-10_JPRB, 0.61607990E-10_JPRB, 0.62936573E-10_JPRB, 0.64572514E-10_JPRB, &
  & 0.66444669E-10_JPRB, 0.68358735E-10_JPRB, 0.70103132E-10_JPRB, 0.71483083E-10_JPRB, 0.72371546E-10_JPRB, 0.72705578E-10_JPRB, &
  & 0.72476677E-10_JPRB, 0.71703851E-10_JPRB, 0.70421016E-10_JPRB, 0.68704958E-10_JPRB, 0.66627467E-10_JPRB, 0.64294736E-10_JPRB, &
  & 0.61831595E-10_JPRB, 0.59381298E-10_JPRB, 0.57043457E-10_JPRB, 0.54892462E-10_JPRB, 0.52987024E-10_JPRB, 0.51297761E-10_JPRB, &
  & 0.49795047E-10_JPRB, 0.48425021E-10_JPRB, 0.47152955E-10_JPRB, 0.45963722E-10_JPRB, 0.44840961E-10_JPRB, 0.43774474E-10_JPRB, &
  & 0.42759234E-10_JPRB, 0.41796039E-10_JPRB, 0.40892501E-10_JPRB, 0.40064653E-10_JPRB, 0.39329640E-10_JPRB, 0.38698638E-10_JPRB, &
  & 0.38168049E-10_JPRB, 0.37713100E-10_JPRB, 0.37246699E-10_JPRB, 0.36502995E-10_JPRB /)

RGHG9(:,31, 7) = (/ &
  & 0.34851570E-10_JPRB, 0.34429938E-10_JPRB, 0.34207370E-10_JPRB, 0.34050089E-10_JPRB, 0.33941273E-10_JPRB, 0.33895171E-10_JPRB, &
  & 0.33955866E-10_JPRB, 0.34198998E-10_JPRB, 0.34707914E-10_JPRB, 0.35559646E-10_JPRB, 0.36802904E-10_JPRB, 0.38451142E-10_JPRB, &
  & 0.40489296E-10_JPRB, 0.42855212E-10_JPRB, 0.45467231E-10_JPRB, 0.48212347E-10_JPRB, 0.50968993E-10_JPRB, 0.53605884E-10_JPRB, &
  & 0.56019842E-10_JPRB, 0.58119974E-10_JPRB, 0.59852755E-10_JPRB, 0.61202689E-10_JPRB, 0.62184403E-10_JPRB, 0.62862875E-10_JPRB, &
  & 0.63346703E-10_JPRB, 0.63784485E-10_JPRB, 0.64337730E-10_JPRB, 0.65137437E-10_JPRB, 0.66283139E-10_JPRB, 0.67782835E-10_JPRB, &
  & 0.69545349E-10_JPRB, 0.71381075E-10_JPRB, 0.73066705E-10_JPRB, 0.74394151E-10_JPRB, 0.75239370E-10_JPRB, 0.75549546E-10_JPRB, &
  & 0.75327793E-10_JPRB, 0.74599320E-10_JPRB, 0.73402853E-10_JPRB, 0.71776855E-10_JPRB, 0.69809422E-10_JPRB, 0.67590114E-10_JPRB, &
  & 0.65253095E-10_JPRB, 0.62908727E-10_JPRB, 0.60688628E-10_JPRB, 0.58662492E-10_JPRB, 0.56863816E-10_JPRB, 0.55274538E-10_JPRB, &
  & 0.53849897E-10_JPRB, 0.52547012E-10_JPRB, 0.51323692E-10_JPRB, 0.50170708E-10_JPRB, 0.49078248E-10_JPRB, 0.48036811E-10_JPRB, &
  & 0.47044105E-10_JPRB, 0.46101255E-10_JPRB, 0.45216785E-10_JPRB, 0.44402478E-10_JPRB, 0.43671542E-10_JPRB, 0.43034114E-10_JPRB, &
  & 0.42482493E-10_JPRB, 0.41992076E-10_JPRB, 0.41493080E-10_JPRB, 0.40747059E-10_JPRB /)

RGHG9(:,32, 7) = (/ &
  & 0.38553653E-10_JPRB, 0.38223674E-10_JPRB, 0.38074745E-10_JPRB, 0.37987606E-10_JPRB, 0.37956988E-10_JPRB, 0.38004652E-10_JPRB, &
  & 0.38180910E-10_JPRB, 0.38554764E-10_JPRB, 0.39207092E-10_JPRB, 0.40196561E-10_JPRB, 0.41558239E-10_JPRB, 0.43300620E-10_JPRB, &
  & 0.45391191E-10_JPRB, 0.47772335E-10_JPRB, 0.50357225E-10_JPRB, 0.53044878E-10_JPRB, 0.55721774E-10_JPRB, 0.58266926E-10_JPRB, &
  & 0.60576676E-10_JPRB, 0.62565765E-10_JPRB, 0.64176428E-10_JPRB, 0.65389673E-10_JPRB, 0.66226413E-10_JPRB, 0.66758175E-10_JPRB, &
  & 0.67101123E-10_JPRB, 0.67405068E-10_JPRB, 0.67820645E-10_JPRB, 0.68480221E-10_JPRB, 0.69473184E-10_JPRB, 0.70818497E-10_JPRB, &
  & 0.72425940E-10_JPRB, 0.74123277E-10_JPRB, 0.75676215E-10_JPRB, 0.76889509E-10_JPRB, 0.77645626E-10_JPRB, 0.77907777E-10_JPRB, &
  & 0.77690458E-10_JPRB, 0.77024512E-10_JPRB, 0.75935383E-10_JPRB, 0.74464448E-10_JPRB, 0.72650684E-10_JPRB, 0.70604043E-10_JPRB, &
  & 0.68442987E-10_JPRB, 0.66284617E-10_JPRB, 0.64217603E-10_JPRB, 0.62321800E-10_JPRB, 0.60634490E-10_JPRB, 0.59127217E-10_JPRB, &
  & 0.57758996E-10_JPRB, 0.56490649E-10_JPRB, 0.55295837E-10_JPRB, 0.54159607E-10_JPRB, 0.53079770E-10_JPRB, 0.52052519E-10_JPRB, &
  & 0.51075148E-10_JPRB, 0.50149739E-10_JPRB, 0.49282661E-10_JPRB, 0.48482666E-10_JPRB, 0.47759942E-10_JPRB, 0.47121612E-10_JPRB, &
  & 0.46565883E-10_JPRB, 0.46061002E-10_JPRB, 0.45547528E-10_JPRB, 0.44731413E-10_JPRB /)

RGHG9(:,33, 7) = (/ &
  & 0.41979944E-10_JPRB, 0.41782171E-10_JPRB, 0.41705837E-10_JPRB, 0.41687459E-10_JPRB, 0.41732350E-10_JPRB, 0.41869005E-10_JPRB, &
  & 0.42146515E-10_JPRB, 0.42636100E-10_JPRB, 0.43397400E-10_JPRB, 0.44480884E-10_JPRB, 0.45913155E-10_JPRB, 0.47686778E-10_JPRB, &
  & 0.49774844E-10_JPRB, 0.52110920E-10_JPRB, 0.54622515E-10_JPRB, 0.57209071E-10_JPRB, 0.59777974E-10_JPRB, 0.62214692E-10_JPRB, &
  & 0.64422315E-10_JPRB, 0.66319533E-10_JPRB, 0.67845798E-10_JPRB, 0.68979870E-10_JPRB, 0.69741657E-10_JPRB, 0.70210539E-10_JPRB, &
  & 0.70499981E-10_JPRB, 0.70746159E-10_JPRB, 0.71096115E-10_JPRB, 0.71659574E-10_JPRB, 0.72523897E-10_JPRB, 0.73710274E-10_JPRB, &
  & 0.75144925E-10_JPRB, 0.76652573E-10_JPRB, 0.78025419E-10_JPRB, 0.79078459E-10_JPRB, 0.79717122E-10_JPRB, 0.79917975E-10_JPRB, &
  & 0.79705610E-10_JPRB, 0.79109712E-10_JPRB, 0.78153962E-10_JPRB, 0.76850019E-10_JPRB, 0.75248703E-10_JPRB, 0.73418563E-10_JPRB, &
  & 0.71468595E-10_JPRB, 0.69523012E-10_JPRB, 0.67637083E-10_JPRB, 0.65881620E-10_JPRB, 0.64271241E-10_JPRB, 0.62824648E-10_JPRB, &
  & 0.61493040E-10_JPRB, 0.60234713E-10_JPRB, 0.59041029E-10_JPRB, 0.57905791E-10_JPRB, 0.56825298E-10_JPRB, 0.55802370E-10_JPRB, &
  & 0.54834654E-10_JPRB, 0.53923050E-10_JPRB, 0.53072373E-10_JPRB, 0.52287143E-10_JPRB, 0.51576920E-10_JPRB, 0.50947496E-10_JPRB, &
  & 0.50393544E-10_JPRB, 0.49887639E-10_JPRB, 0.49369640E-10_JPRB, 0.48558914E-10_JPRB /)

RGHG9(:,34, 7) = (/ &
  & 0.45182750E-10_JPRB, 0.45106009E-10_JPRB, 0.45099351E-10_JPRB, 0.45147552E-10_JPRB, 0.45265305E-10_JPRB, 0.45483419E-10_JPRB, &
  & 0.45853762E-10_JPRB, 0.46431244E-10_JPRB, 0.47271364E-10_JPRB, 0.48408340E-10_JPRB, 0.49859172E-10_JPRB, 0.51619500E-10_JPRB, &
  & 0.53653096E-10_JPRB, 0.55907126E-10_JPRB, 0.58310669E-10_JPRB, 0.60780048E-10_JPRB, 0.63223572E-10_JPRB, 0.65550468E-10_JPRB, &
  & 0.67662848E-10_JPRB, 0.69490767E-10_JPRB, 0.70971132E-10_JPRB, 0.72073403E-10_JPRB, 0.72827543E-10_JPRB, 0.73302364E-10_JPRB, &
  & 0.73608480E-10_JPRB, 0.73858933E-10_JPRB, 0.74193290E-10_JPRB, 0.74702779E-10_JPRB, 0.75462213E-10_JPRB, 0.76493124E-10_JPRB, &
  & 0.77726145E-10_JPRB, 0.79014247E-10_JPRB, 0.80165596E-10_JPRB, 0.81029947E-10_JPRB, 0.81533440E-10_JPRB, 0.81666313E-10_JPRB, &
  & 0.81459686E-10_JPRB, 0.80937361E-10_JPRB, 0.80113562E-10_JPRB, 0.79001368E-10_JPRB, 0.77617621E-10_JPRB, 0.76032257E-10_JPRB, &
  & 0.74337980E-10_JPRB, 0.72598268E-10_JPRB, 0.70904414E-10_JPRB, 0.69273323E-10_JPRB, 0.67739640E-10_JPRB, 0.66311505E-10_JPRB, &
  & 0.64995724E-10_JPRB, 0.63730951E-10_JPRB, 0.62524895E-10_JPRB, 0.61378291E-10_JPRB, 0.60290946E-10_JPRB, 0.59267480E-10_JPRB, &
  & 0.58306124E-10_JPRB, 0.57406732E-10_JPRB, 0.56570949E-10_JPRB, 0.55802786E-10_JPRB, 0.55108161E-10_JPRB, 0.54491613E-10_JPRB, &
  & 0.53944200E-10_JPRB, 0.53444228E-10_JPRB, 0.52926791E-10_JPRB, 0.52117234E-10_JPRB /)

RGHG9(:,35, 7) = (/ &
  & 0.48175887E-10_JPRB, 0.48204583E-10_JPRB, 0.48265874E-10_JPRB, 0.48379030E-10_JPRB, 0.48565100E-10_JPRB, 0.48856984E-10_JPRB, &
  & 0.49299433E-10_JPRB, 0.49944084E-10_JPRB, 0.50828546E-10_JPRB, 0.51980111E-10_JPRB, 0.53414190E-10_JPRB, 0.55118649E-10_JPRB, &
  & 0.57069731E-10_JPRB, 0.59212836E-10_JPRB, 0.61494074E-10_JPRB, 0.63833112E-10_JPRB, 0.66154672E-10_JPRB, 0.68371440E-10_JPRB, &
  & 0.70402309E-10_JPRB, 0.72176154E-10_JPRB, 0.73638887E-10_JPRB, 0.74762148E-10_JPRB, 0.75565991E-10_JPRB, 0.76103734E-10_JPRB, &
  & 0.76474771E-10_JPRB, 0.76782775E-10_JPRB, 0.77135562E-10_JPRB, 0.77616094E-10_JPRB, 0.78282256E-10_JPRB, 0.79151082E-10_JPRB, &
  & 0.80166970E-10_JPRB, 0.81201580E-10_JPRB, 0.82107446E-10_JPRB, 0.82766176E-10_JPRB, 0.83129476E-10_JPRB, 0.83195228E-10_JPRB, &
  & 0.82995971E-10_JPRB, 0.82542466E-10_JPRB, 0.81854863E-10_JPRB, 0.80924191E-10_JPRB, 0.79766249E-10_JPRB, 0.78428819E-10_JPRB, &
  & 0.76973088E-10_JPRB, 0.75464350E-10_JPRB, 0.73935885E-10_JPRB, 0.72431672E-10_JPRB, 0.70955457E-10_JPRB, 0.69547451E-10_JPRB, &
  & 0.68221789E-10_JPRB, 0.66943798E-10_JPRB, 0.65715842E-10_JPRB, 0.64554341E-10_JPRB, 0.63458898E-10_JPRB, 0.62434440E-10_JPRB, &
  & 0.61479044E-10_JPRB, 0.60591726E-10_JPRB, 0.59771472E-10_JPRB, 0.59019845E-10_JPRB, 0.58342879E-10_JPRB, 0.57742689E-10_JPRB, &
  & 0.57210268E-10_JPRB, 0.56723615E-10_JPRB, 0.56224438E-10_JPRB, 0.55435406E-10_JPRB /)

RGHG9(:,36, 7) = (/ &
  & 0.50976851E-10_JPRB, 0.51107132E-10_JPRB, 0.51232948E-10_JPRB, 0.51406171E-10_JPRB, 0.51652609E-10_JPRB, 0.52004054E-10_JPRB, &
  & 0.52500740E-10_JPRB, 0.53182240E-10_JPRB, 0.54080830E-10_JPRB, 0.55219111E-10_JPRB, 0.56603673E-10_JPRB, 0.58231177E-10_JPRB, &
  & 0.60075056E-10_JPRB, 0.62096966E-10_JPRB, 0.64243326E-10_JPRB, 0.66453412E-10_JPRB, 0.68651328E-10_JPRB, 0.70768683E-10_JPRB, &
  & 0.72732813E-10_JPRB, 0.74475717E-10_JPRB, 0.75950753E-10_JPRB, 0.77127867E-10_JPRB, 0.78006365E-10_JPRB, 0.78639303E-10_JPRB, &
  & 0.79099498E-10_JPRB, 0.79479992E-10_JPRB, 0.79866135E-10_JPRB, 0.80321576E-10_JPRB, 0.80893812E-10_JPRB, 0.81591969E-10_JPRB, &
  & 0.82372699E-10_JPRB, 0.83144457E-10_JPRB, 0.83797587E-10_JPRB, 0.84257594E-10_JPRB, 0.84491088E-10_JPRB, 0.84504598E-10_JPRB, &
  & 0.84319308E-10_JPRB, 0.83939390E-10_JPRB, 0.83383030E-10_JPRB, 0.82626739E-10_JPRB, 0.81678712E-10_JPRB, 0.80576615E-10_JPRB, &
  & 0.79350790E-10_JPRB, 0.78036924E-10_JPRB, 0.76676922E-10_JPRB, 0.75273676E-10_JPRB, 0.73859252E-10_JPRB, 0.72473867E-10_JPRB, &
  & 0.71141065E-10_JPRB, 0.69844026E-10_JPRB, 0.68599383E-10_JPRB, 0.67425898E-10_JPRB, 0.66325091E-10_JPRB, 0.65303242E-10_JPRB, &
  & 0.64356916E-10_JPRB, 0.63483239E-10_JPRB, 0.62678425E-10_JPRB, 0.61945803E-10_JPRB, 0.61288918E-10_JPRB, 0.60709306E-10_JPRB, &
  & 0.60197680E-10_JPRB, 0.59732705E-10_JPRB, 0.59252360E-10_JPRB, 0.58499532E-10_JPRB /)

RGHG9(:,37, 7) = (/ &
  & 0.53630687E-10_JPRB, 0.53858903E-10_JPRB, 0.54041244E-10_JPRB, 0.54266754E-10_JPRB, 0.54561355E-10_JPRB, 0.54956002E-10_JPRB, &
  & 0.55482740E-10_JPRB, 0.56175960E-10_JPRB, 0.57062820E-10_JPRB, 0.58161247E-10_JPRB, 0.59479983E-10_JPRB, 0.61011335E-10_JPRB, &
  & 0.62738439E-10_JPRB, 0.64627768E-10_JPRB, 0.66637931E-10_JPRB, 0.68711009E-10_JPRB, 0.70790138E-10_JPRB, 0.72809168E-10_JPRB, &
  & 0.74711702E-10_JPRB, 0.76441041E-10_JPRB, 0.77940501E-10_JPRB, 0.79173806E-10_JPRB, 0.80129028E-10_JPRB, 0.80834159E-10_JPRB, &
  & 0.81358163E-10_JPRB, 0.81777515E-10_JPRB, 0.82164081E-10_JPRB, 0.82575828E-10_JPRB, 0.83043260E-10_JPRB, 0.83574633E-10_JPRB, &
  & 0.84136823E-10_JPRB, 0.84670979E-10_JPRB, 0.85109843E-10_JPRB, 0.85405710E-10_JPRB, 0.85544141E-10_JPRB, 0.85527314E-10_JPRB, &
  & 0.85372660E-10_JPRB, 0.85073698E-10_JPRB, 0.84647393E-10_JPRB, 0.84054326E-10_JPRB, 0.83317610E-10_JPRB, 0.82426996E-10_JPRB, &
  & 0.81405549E-10_JPRB, 0.80282128E-10_JPRB, 0.79063513E-10_JPRB, 0.77768701E-10_JPRB, 0.76425463E-10_JPRB, 0.75074058E-10_JPRB, &
  & 0.73739091E-10_JPRB, 0.72431471E-10_JPRB, 0.71181033E-10_JPRB, 0.70002899E-10_JPRB, 0.68904930E-10_JPRB, 0.67891942E-10_JPRB, &
  & 0.66959174E-10_JPRB, 0.66100889E-10_JPRB, 0.65314650E-10_JPRB, 0.64601977E-10_JPRB, 0.63968046E-10_JPRB, 0.63412990E-10_JPRB, &
  & 0.62927955E-10_JPRB, 0.62488306E-10_JPRB, 0.62037292E-10_JPRB, 0.61328075E-10_JPRB /)

RGHG9(:,38, 7) = (/ &
  & 0.56192950E-10_JPRB, 0.56496627E-10_JPRB, 0.56726662E-10_JPRB, 0.56988827E-10_JPRB, 0.57321304E-10_JPRB, 0.57740677E-10_JPRB, &
  & 0.58277376E-10_JPRB, 0.58960475E-10_JPRB, 0.59812794E-10_JPRB, 0.60854100E-10_JPRB, 0.62091270E-10_JPRB, 0.63518697E-10_JPRB, &
  & 0.65120097E-10_JPRB, 0.66872043E-10_JPRB, 0.68739028E-10_JPRB, 0.70674688E-10_JPRB, 0.72626925E-10_JPRB, 0.74547347E-10_JPRB, &
  & 0.76386016E-10_JPRB, 0.78086863E-10_JPRB, 0.79597010E-10_JPRB, 0.80848071E-10_JPRB, 0.81816214E-10_JPRB, 0.82526999E-10_JPRB, &
  & 0.83040630E-10_JPRB, 0.83438055E-10_JPRB, 0.83788011E-10_JPRB, 0.84135761E-10_JPRB, 0.84507276E-10_JPRB, 0.84904195E-10_JPRB, &
  & 0.85304701E-10_JPRB, 0.85672545E-10_JPRB, 0.85964971E-10_JPRB, 0.86154868E-10_JPRB, 0.86235567E-10_JPRB, 0.86210358E-10_JPRB, &
  & 0.86089282E-10_JPRB, 0.85868083E-10_JPRB, 0.85552766E-10_JPRB, 0.85116046E-10_JPRB, 0.84564231E-10_JPRB, 0.83875087E-10_JPRB, &
  & 0.83059802E-10_JPRB, 0.82120359E-10_JPRB, 0.81060124E-10_JPRB, 0.79887486E-10_JPRB, 0.78630873E-10_JPRB, 0.77327186E-10_JPRB, &
  & 0.76009650E-10_JPRB, 0.74713978E-10_JPRB, 0.73471444E-10_JPRB, 0.72303039E-10_JPRB, 0.71218455E-10_JPRB, 0.70222626E-10_JPRB, &
  & 0.69308725E-10_JPRB, 0.68469723E-10_JPRB, 0.67703003E-10_JPRB, 0.67012083E-10_JPRB, 0.66403480E-10_JPRB, 0.65876873E-10_JPRB, &
  & 0.65421696E-10_JPRB, 0.65012093E-10_JPRB, 0.64593213E-10_JPRB, 0.63935655E-10_JPRB /)

RGHG9(:,39, 7) = (/ &
  & 0.58685237E-10_JPRB, 0.59041931E-10_JPRB, 0.59300377E-10_JPRB, 0.59594538E-10_JPRB, 0.59945250E-10_JPRB, 0.60379576E-10_JPRB, &
  & 0.60911179E-10_JPRB, 0.61565732E-10_JPRB, 0.62368936E-10_JPRB, 0.63339549E-10_JPRB, 0.64484043E-10_JPRB, 0.65800823E-10_JPRB, &
  & 0.67273777E-10_JPRB, 0.68883697E-10_JPRB, 0.70603259E-10_JPRB, 0.72393258E-10_JPRB, 0.74212511E-10_JPRB, 0.76022223E-10_JPRB, &
  & 0.77778749E-10_JPRB, 0.79432370E-10_JPRB, 0.80895297E-10_JPRB, 0.82104754E-10_JPRB, 0.83019799E-10_JPRB, 0.83671667E-10_JPRB, &
  & 0.84134574E-10_JPRB, 0.84486813E-10_JPRB, 0.84790494E-10_JPRB, 0.85084384E-10_JPRB, 0.85384928E-10_JPRB, 0.85693022E-10_JPRB, &
  & 0.85992991E-10_JPRB, 0.86259992E-10_JPRB, 0.86467104E-10_JPRB, 0.86595425E-10_JPRB, 0.86644497E-10_JPRB, 0.86616658E-10_JPRB, &
  & 0.86521609E-10_JPRB, 0.86353716E-10_JPRB, 0.86119251E-10_JPRB, 0.85798417E-10_JPRB, 0.85391721E-10_JPRB, 0.84878278E-10_JPRB, &
  & 0.84257448E-10_JPRB, 0.83511524E-10_JPRB, 0.82630097E-10_JPRB, 0.81608886E-10_JPRB, 0.80466252E-10_JPRB, 0.79236728E-10_JPRB, &
  & 0.77968548E-10_JPRB, 0.76704885E-10_JPRB, 0.75488629E-10_JPRB, 0.74344308E-10_JPRB, 0.73285572E-10_JPRB, 0.72316077E-10_JPRB, &
  & 0.71426726E-10_JPRB, 0.70609872E-10_JPRB, 0.69864552E-10_JPRB, 0.69197023E-10_JPRB, 0.68615620E-10_JPRB, 0.68119906E-10_JPRB, &
  & 0.67696584E-10_JPRB, 0.67318887E-10_JPRB, 0.66933022E-10_JPRB, 0.66332780E-10_JPRB /)

RGHG9(:,40, 7) = (/ &
  & 0.61100854E-10_JPRB, 0.61491062E-10_JPRB, 0.61771949E-10_JPRB, 0.62075851E-10_JPRB, 0.62447963E-10_JPRB, 0.62882914E-10_JPRB, &
  & 0.63399938E-10_JPRB, 0.64019769E-10_JPRB, 0.64762772E-10_JPRB, 0.65651234E-10_JPRB, 0.66698036E-10_JPRB, 0.67898451E-10_JPRB, &
  & 0.69240488E-10_JPRB, 0.70707565E-10_JPRB, 0.72275741E-10_JPRB, 0.73913639E-10_JPRB, 0.75589347E-10_JPRB, 0.77271162E-10_JPRB, &
  & 0.78925221E-10_JPRB, 0.80484730E-10_JPRB, 0.81875222E-10_JPRB, 0.82998476E-10_JPRB, 0.83831712E-10_JPRB, 0.84414795E-10_JPRB, &
  & 0.84824356E-10_JPRB, 0.85136453E-10_JPRB, 0.85404808E-10_JPRB, 0.85658959E-10_JPRB, 0.85911889E-10_JPRB, 0.86162834E-10_JPRB, &
  & 0.86401011E-10_JPRB, 0.86609553E-10_JPRB, 0.86766282E-10_JPRB, 0.86859853E-10_JPRB, 0.86890231E-10_JPRB, 0.86862469E-10_JPRB, &
  & 0.86782234E-10_JPRB, 0.86648459E-10_JPRB, 0.86463975E-10_JPRB, 0.86218033E-10_JPRB, 0.85909856E-10_JPRB, 0.85526572E-10_JPRB, &
  & 0.85060896E-10_JPRB, 0.84489839E-10_JPRB, 0.83791932E-10_JPRB, 0.82942014E-10_JPRB, 0.81940635E-10_JPRB, 0.80819518E-10_JPRB, &
  & 0.79624279E-10_JPRB, 0.78418029E-10_JPRB, 0.77247493E-10_JPRB, 0.76144022E-10_JPRB, 0.75123706E-10_JPRB, 0.74188329E-10_JPRB, &
  & 0.73329613E-10_JPRB, 0.72537872E-10_JPRB, 0.71816358E-10_JPRB, 0.71172963E-10_JPRB, 0.70620350E-10_JPRB, 0.70156395E-10_JPRB, &
  & 0.69765881E-10_JPRB, 0.69418797E-10_JPRB, 0.69067425E-10_JPRB, 0.68518941E-10_JPRB /)

RGHG9(:,41, 7) = (/ &
  & 0.63448156E-10_JPRB, 0.63853360E-10_JPRB, 0.64131853E-10_JPRB, 0.64450278E-10_JPRB, 0.64823445E-10_JPRB, 0.65262323E-10_JPRB, &
  & 0.65762756E-10_JPRB, 0.66340017E-10_JPRB, 0.67019099E-10_JPRB, 0.67822720E-10_JPRB, 0.68764099E-10_JPRB, 0.69846302E-10_JPRB, &
  & 0.71056994E-10_JPRB, 0.72379824E-10_JPRB, 0.73794956E-10_JPRB, 0.75276979E-10_JPRB, 0.76798505E-10_JPRB, 0.78341306E-10_JPRB, &
  & 0.79870756E-10_JPRB, 0.81330179E-10_JPRB, 0.82613381E-10_JPRB, 0.83644779E-10_JPRB, 0.84396760E-10_JPRB, 0.84918343E-10_JPRB, &
  & 0.85285452E-10_JPRB, 0.85566769E-10_JPRB, 0.85808076E-10_JPRB, 0.86033666E-10_JPRB, 0.86252519E-10_JPRB, 0.86465050E-10_JPRB, &
  & 0.86664398E-10_JPRB, 0.86835324E-10_JPRB, 0.86962271E-10_JPRB, 0.87034172E-10_JPRB, 0.87053559E-10_JPRB, 0.87025921E-10_JPRB, &
  & 0.86955693E-10_JPRB, 0.86843630E-10_JPRB, 0.86690301E-10_JPRB, 0.86492730E-10_JPRB, 0.86248335E-10_JPRB, 0.85951898E-10_JPRB, &
  & 0.85599361E-10_JPRB, 0.85163099E-10_JPRB, 0.84624377E-10_JPRB, 0.83940049E-10_JPRB, 0.83097744E-10_JPRB, 0.82100708E-10_JPRB, &
  & 0.81006840E-10_JPRB, 0.79874919E-10_JPRB, 0.78766174E-10_JPRB, 0.77718047E-10_JPRB, 0.76746560E-10_JPRB, 0.75855794E-10_JPRB, &
  & 0.75032515E-10_JPRB, 0.74271637E-10_JPRB, 0.73574445E-10_JPRB, 0.72957952E-10_JPRB, 0.72434295E-10_JPRB, 0.72002564E-10_JPRB, &
  & 0.71642949E-10_JPRB, 0.71325959E-10_JPRB, 0.71003606E-10_JPRB, 0.70505171E-10_JPRB /)

RGHG9(:,42, 7) = (/ &
  & 0.65813945E-10_JPRB, 0.66135541E-10_JPRB, 0.66395542E-10_JPRB, 0.66703552E-10_JPRB, 0.67091749E-10_JPRB, 0.67527928E-10_JPRB, &
  & 0.68010153E-10_JPRB, 0.68548875E-10_JPRB, 0.69162842E-10_JPRB, 0.69878291E-10_JPRB, 0.70715052E-10_JPRB, 0.71677428E-10_JPRB, &
  & 0.72755912E-10_JPRB, 0.73936100E-10_JPRB, 0.75198472E-10_JPRB, 0.76520214E-10_JPRB, 0.77885781E-10_JPRB, 0.79275149E-10_JPRB, &
  & 0.80669485E-10_JPRB, 0.82005569E-10_JPRB, 0.83193577E-10_JPRB, 0.84136628E-10_JPRB, 0.84818125E-10_JPRB, 0.85288110E-10_JPRB, &
  & 0.85620615E-10_JPRB, 0.85877437E-10_JPRB, 0.86097351E-10_JPRB, 0.86299724E-10_JPRB, 0.86493077E-10_JPRB, 0.86678303E-10_JPRB, &
  & 0.86850055E-10_JPRB, 0.86997270E-10_JPRB, 0.87103616E-10_JPRB, 0.87162021E-10_JPRB, 0.87174407E-10_JPRB, 0.87147282E-10_JPRB, &
  & 0.87084562E-10_JPRB, 0.86986904E-10_JPRB, 0.86855932E-10_JPRB, 0.86688948E-10_JPRB, 0.86487935E-10_JPRB, 0.86249966E-10_JPRB, &
  & 0.85973964E-10_JPRB, 0.85637816E-10_JPRB, 0.85223044E-10_JPRB, 0.84684482E-10_JPRB, 0.83991550E-10_JPRB, 0.83135908E-10_JPRB, &
  & 0.82151723E-10_JPRB, 0.81108106E-10_JPRB, 0.80071866E-10_JPRB, 0.79088902E-10_JPRB, 0.78177638E-10_JPRB, 0.77336720E-10_JPRB, &
  & 0.76558253E-10_JPRB, 0.75830620E-10_JPRB, 0.75163542E-10_JPRB, 0.74574034E-10_JPRB, 0.74081019E-10_JPRB, 0.73680347E-10_JPRB, &
  & 0.73350437E-10_JPRB, 0.73059510E-10_JPRB, 0.72763885E-10_JPRB, 0.72304676E-10_JPRB /)

RGHG9(:,43, 7) = (/ &
  & 0.67823712E-10_JPRB, 0.68231039E-10_JPRB, 0.68515055E-10_JPRB, 0.68851917E-10_JPRB, 0.69248912E-10_JPRB, 0.69696568E-10_JPRB, &
  & 0.70164069E-10_JPRB, 0.70664675E-10_JPRB, 0.71216665E-10_JPRB, 0.71847944E-10_JPRB, 0.72580282E-10_JPRB, 0.73423365E-10_JPRB, &
  & 0.74371551E-10_JPRB, 0.75409942E-10_JPRB, 0.76519714E-10_JPRB, 0.77684664E-10_JPRB, 0.78886536E-10_JPRB, 0.80124463E-10_JPRB, &
  & 0.81376003E-10_JPRB, 0.82595368E-10_JPRB, 0.83676975E-10_JPRB, 0.84536815E-10_JPRB, 0.85153176E-10_JPRB, 0.85578454E-10_JPRB, &
  & 0.85881531E-10_JPRB, 0.86117322E-10_JPRB, 0.86318716E-10_JPRB, 0.86502215E-10_JPRB, 0.86675216E-10_JPRB, 0.86839813E-10_JPRB, &
  & 0.86992455E-10_JPRB, 0.87121782E-10_JPRB, 0.87214874E-10_JPRB, 0.87263599E-10_JPRB, 0.87271745E-10_JPRB, 0.87245523E-10_JPRB, &
  & 0.87188638E-10_JPRB, 0.87102159E-10_JPRB, 0.86986439E-10_JPRB, 0.86842172E-10_JPRB, 0.86670587E-10_JPRB, 0.86472496E-10_JPRB, &
  & 0.86250944E-10_JPRB, 0.85986655E-10_JPRB, 0.85665856E-10_JPRB, 0.85246213E-10_JPRB, 0.84692031E-10_JPRB, 0.83973238E-10_JPRB, &
  & 0.83106383E-10_JPRB, 0.82156136E-10_JPRB, 0.81197743E-10_JPRB, 0.80286756E-10_JPRB, 0.79440308E-10_JPRB, 0.78658316E-10_JPRB, &
  & 0.77928899E-10_JPRB, 0.77243684E-10_JPRB, 0.76608865E-10_JPRB, 0.76050978E-10_JPRB, 0.75588889E-10_JPRB, 0.75218956E-10_JPRB, &
  & 0.74916288E-10_JPRB, 0.74648732E-10_JPRB, 0.74374368E-10_JPRB, 0.73945378E-10_JPRB /)

RGHG9(:,44, 7) = (/ &
  & 0.69814092E-10_JPRB, 0.70280837E-10_JPRB, 0.70587480E-10_JPRB, 0.70922941E-10_JPRB, 0.71345548E-10_JPRB, 0.71789574E-10_JPRB, &
  & 0.72249526E-10_JPRB, 0.72712308E-10_JPRB, 0.73207211E-10_JPRB, 0.73756924E-10_JPRB, 0.74388891E-10_JPRB, 0.75116260E-10_JPRB, &
  & 0.75935494E-10_JPRB, 0.76833137E-10_JPRB, 0.77795007E-10_JPRB, 0.78799099E-10_JPRB, 0.79844464E-10_JPRB, 0.80919271E-10_JPRB, &
  & 0.82027114E-10_JPRB, 0.83114682E-10_JPRB, 0.84098242E-10_JPRB, 0.84875267E-10_JPRB, 0.85432321E-10_JPRB, 0.85816888E-10_JPRB, &
  & 0.86093764E-10_JPRB, 0.86310618E-10_JPRB, 0.86495644E-10_JPRB, 0.86662927E-10_JPRB, 0.86819864E-10_JPRB, 0.86968835E-10_JPRB, &
  & 0.87106662E-10_JPRB, 0.87223749E-10_JPRB, 0.87306572E-10_JPRB, 0.87349031E-10_JPRB, 0.87354554E-10_JPRB, 0.87329602E-10_JPRB, &
  & 0.87277727E-10_JPRB, 0.87199629E-10_JPRB, 0.87096233E-10_JPRB, 0.86967884E-10_JPRB, 0.86817852E-10_JPRB, 0.86648924E-10_JPRB, &
  & 0.86464523E-10_JPRB, 0.86254941E-10_JPRB, 0.86003628E-10_JPRB, 0.85681261E-10_JPRB, 0.85247046E-10_JPRB, 0.84658607E-10_JPRB, &
  & 0.83915604E-10_JPRB, 0.83059407E-10_JPRB, 0.82183337E-10_JPRB, 0.81344820E-10_JPRB, 0.80567594E-10_JPRB, 0.79849717E-10_JPRB, &
  & 0.79178039E-10_JPRB, 0.78540847E-10_JPRB, 0.77946968E-10_JPRB, 0.77423297E-10_JPRB, 0.76994307E-10_JPRB, 0.76654183E-10_JPRB, &
  & 0.76376294E-10_JPRB, 0.76129075E-10_JPRB, 0.75871566E-10_JPRB, 0.75464593E-10_JPRB /)

RGHG9(:,45, 7) = (/ &
  & 0.72083881E-10_JPRB, 0.72411785E-10_JPRB, 0.72658428E-10_JPRB, 0.72987796E-10_JPRB, 0.73392216E-10_JPRB, 0.73854936E-10_JPRB, &
  & 0.74289193E-10_JPRB, 0.74723512E-10_JPRB, 0.75158921E-10_JPRB, 0.75633971E-10_JPRB, 0.76169071E-10_JPRB, 0.76783656E-10_JPRB, &
  & 0.77477157E-10_JPRB, 0.78238770E-10_JPRB, 0.79048740E-10_JPRB, 0.79902265E-10_JPRB, 0.80780951E-10_JPRB, 0.81703026E-10_JPRB, &
  & 0.82653280E-10_JPRB, 0.83612700E-10_JPRB, 0.84477710E-10_JPRB, 0.85172355E-10_JPRB, 0.85669173E-10_JPRB, 0.86016631E-10_JPRB, &
  & 0.86269367E-10_JPRB, 0.86469221E-10_JPRB, 0.86639591E-10_JPRB, 0.86793558E-10_JPRB, 0.86937506E-10_JPRB, 0.87074382E-10_JPRB, &
  & 0.87201413E-10_JPRB, 0.87308827E-10_JPRB, 0.87384704E-10_JPRB, 0.87422784E-10_JPRB, 0.87427100E-10_JPRB, 0.87403737E-10_JPRB, &
  & 0.87356018E-10_JPRB, 0.87284825E-10_JPRB, 0.87190859E-10_JPRB, 0.87074750E-10_JPRB, 0.86941197E-10_JPRB, 0.86792545E-10_JPRB, &
  & 0.86636871E-10_JPRB, 0.86465737E-10_JPRB, 0.86268284E-10_JPRB, 0.86021995E-10_JPRB, 0.85687513E-10_JPRB, 0.85227249E-10_JPRB, &
  & 0.84605004E-10_JPRB, 0.83859392E-10_JPRB, 0.83065964E-10_JPRB, 0.82301645E-10_JPRB, 0.81596938E-10_JPRB, 0.80947832E-10_JPRB, &
  & 0.80340297E-10_JPRB, 0.79761107E-10_JPRB, 0.79213622E-10_JPRB, 0.78730467E-10_JPRB, 0.78335151E-10_JPRB, 0.78023359E-10_JPRB, &
  & 0.77768104E-10_JPRB, 0.77537969E-10_JPRB, 0.77294310E-10_JPRB, 0.76901582E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART13',1,ZHOOK_HANDLE)
END SUBROUTINE PART13




SUBROUTINE PART14
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART14',0,ZHOOK_HANDLE)



RGHG9(:,46, 7) = (/ &
  & 0.73834397E-10_JPRB, 0.74352559E-10_JPRB, 0.74678451E-10_JPRB, 0.75018047E-10_JPRB, 0.75462941E-10_JPRB, 0.75905643E-10_JPRB, &
  & 0.76342571E-10_JPRB, 0.76729505E-10_JPRB, 0.77114315E-10_JPRB, 0.77509721E-10_JPRB, 0.77953290E-10_JPRB, 0.78457511E-10_JPRB, &
  & 0.79027673E-10_JPRB, 0.79650994E-10_JPRB, 0.80318217E-10_JPRB, 0.81008658E-10_JPRB, 0.81734709E-10_JPRB, 0.82486497E-10_JPRB, &
  & 0.83285323E-10_JPRB, 0.84085815E-10_JPRB, 0.84833182E-10_JPRB, 0.85432751E-10_JPRB, 0.85873059E-10_JPRB, 0.86184608E-10_JPRB, &
  & 0.86415847E-10_JPRB, 0.86599970E-10_JPRB, 0.86757976E-10_JPRB, 0.86900515E-10_JPRB, 0.87034477E-10_JPRB, 0.87162111E-10_JPRB, &
  & 0.87280697E-10_JPRB, 0.87381276E-10_JPRB, 0.87451942E-10_JPRB, 0.87487496E-10_JPRB, 0.87491604E-10_JPRB, 0.87470017E-10_JPRB, &
  & 0.87425879E-10_JPRB, 0.87360452E-10_JPRB, 0.87273605E-10_JPRB, 0.87168085E-10_JPRB, 0.87045655E-10_JPRB, 0.86914274E-10_JPRB, &
  & 0.86777308E-10_JPRB, 0.86636115E-10_JPRB, 0.86478442E-10_JPRB, 0.86289316E-10_JPRB, 0.86039148E-10_JPRB, 0.85687644E-10_JPRB, &
  & 0.85199688E-10_JPRB, 0.84572675E-10_JPRB, 0.83879764E-10_JPRB, 0.83196880E-10_JPRB, 0.82566794E-10_JPRB, 0.81992239E-10_JPRB, &
  & 0.81455107E-10_JPRB, 0.80937652E-10_JPRB, 0.80445907E-10_JPRB, 0.80004628E-10_JPRB, 0.79644104E-10_JPRB, 0.79358360E-10_JPRB, &
  & 0.79122778E-10_JPRB, 0.78907388E-10_JPRB, 0.78674955E-10_JPRB, 0.78293087E-10_JPRB /)

RGHG9(:,47, 7) = (/ &
  & 0.76130657E-10_JPRB, 0.76516848E-10_JPRB, 0.76794647E-10_JPRB, 0.77149044E-10_JPRB, 0.77574690E-10_JPRB, 0.78048228E-10_JPRB, &
  & 0.78441281E-10_JPRB, 0.78796129E-10_JPRB, 0.79110413E-10_JPRB, 0.79430622E-10_JPRB, 0.79774874E-10_JPRB, 0.80168878E-10_JPRB, &
  & 0.80614057E-10_JPRB, 0.81102416E-10_JPRB, 0.81616276E-10_JPRB, 0.82156754E-10_JPRB, 0.82712219E-10_JPRB, 0.83304356E-10_JPRB, &
  & 0.83921994E-10_JPRB, 0.84563891E-10_JPRB, 0.85162308E-10_JPRB, 0.85667758E-10_JPRB, 0.86047114E-10_JPRB, 0.86326231E-10_JPRB, &
  & 0.86537291E-10_JPRB, 0.86708113E-10_JPRB, 0.86854995E-10_JPRB, 0.86988736E-10_JPRB, 0.87114559E-10_JPRB, 0.87235170E-10_JPRB, &
  & 0.87347726E-10_JPRB, 0.87442956E-10_JPRB, 0.87510277E-10_JPRB, 0.87544555E-10_JPRB, 0.87549260E-10_JPRB, 0.87529595E-10_JPRB, &
  & 0.87488711E-10_JPRB, 0.87427635E-10_JPRB, 0.87347699E-10_JPRB, 0.87249055E-10_JPRB, 0.87137922E-10_JPRB, 0.87016554E-10_JPRB, &
  & 0.86896088E-10_JPRB, 0.86774241E-10_JPRB, 0.86647092E-10_JPRB, 0.86501126E-10_JPRB, 0.86315982E-10_JPRB, 0.86061665E-10_JPRB, &
  & 0.85698622E-10_JPRB, 0.85218638E-10_JPRB, 0.84646831E-10_JPRB, 0.84067434E-10_JPRB, 0.83522071E-10_JPRB, 0.83025441E-10_JPRB, &
  & 0.82559987E-10_JPRB, 0.82110610E-10_JPRB, 0.81672086E-10_JPRB, 0.81275639E-10_JPRB, 0.80946139E-10_JPRB, 0.80683828E-10_JPRB, &
  & 0.80464607E-10_JPRB, 0.80261457E-10_JPRB, 0.80037962E-10_JPRB, 0.79664692E-10_JPRB /)

RGHG9(:,48, 7) = (/ &
  & 0.77928122E-10_JPRB, 0.78478155E-10_JPRB, 0.78863457E-10_JPRB, 0.79268606E-10_JPRB, 0.79769316E-10_JPRB, 0.80234389E-10_JPRB, &
  & 0.80629337E-10_JPRB, 0.80924989E-10_JPRB, 0.81177419E-10_JPRB, 0.81411669E-10_JPRB, 0.81658798E-10_JPRB, 0.81938102E-10_JPRB, &
  & 0.82256438E-10_JPRB, 0.82604978E-10_JPRB, 0.82971865E-10_JPRB, 0.83346552E-10_JPRB, 0.83736726E-10_JPRB, 0.84140715E-10_JPRB, &
  & 0.84574112E-10_JPRB, 0.85024585E-10_JPRB, 0.85474572E-10_JPRB, 0.85874759E-10_JPRB, 0.86197612E-10_JPRB, 0.86444858E-10_JPRB, &
  & 0.86638446E-10_JPRB, 0.86797028E-10_JPRB, 0.86935202E-10_JPRB, 0.87061219E-10_JPRB, 0.87181047E-10_JPRB, 0.87296378E-10_JPRB, &
  & 0.87404202E-10_JPRB, 0.87495920E-10_JPRB, 0.87561014E-10_JPRB, 0.87595070E-10_JPRB, 0.87600927E-10_JPRB, 0.87583274E-10_JPRB, &
  & 0.87545124E-10_JPRB, 0.87488218E-10_JPRB, 0.87412959E-10_JPRB, 0.87322337E-10_JPRB, 0.87217511E-10_JPRB, 0.87106870E-10_JPRB, &
  & 0.86995536E-10_JPRB, 0.86889503E-10_JPRB, 0.86783747E-10_JPRB, 0.86670136E-10_JPRB, 0.86534870E-10_JPRB, 0.86356353E-10_JPRB, &
  & 0.86111639E-10_JPRB, 0.85776705E-10_JPRB, 0.85373937E-10_JPRB, 0.84926136E-10_JPRB, 0.84495459E-10_JPRB, 0.84089388E-10_JPRB, &
  & 0.83701199E-10_JPRB, 0.83315327E-10_JPRB, 0.82930073E-10_JPRB, 0.82568952E-10_JPRB, 0.82265791E-10_JPRB, 0.82019787E-10_JPRB, &
  & 0.81812591E-10_JPRB, 0.81617324E-10_JPRB, 0.81399915E-10_JPRB, 0.81030592E-10_JPRB /)

RGHG9(:,49, 7) = (/ &
  & 0.79725469E-10_JPRB, 0.80384123E-10_JPRB, 0.80821023E-10_JPRB, 0.81294145E-10_JPRB, 0.81826185E-10_JPRB, 0.82337172E-10_JPRB, &
  & 0.82703844E-10_JPRB, 0.82964469E-10_JPRB, 0.83159445E-10_JPRB, 0.83322980E-10_JPRB, 0.83486759E-10_JPRB, 0.83664978E-10_JPRB, &
  & 0.83868197E-10_JPRB, 0.84086155E-10_JPRB, 0.84308199E-10_JPRB, 0.84526511E-10_JPRB, 0.84740492E-10_JPRB, 0.84960233E-10_JPRB, &
  & 0.85194997E-10_JPRB, 0.85460077E-10_JPRB, 0.85760295E-10_JPRB, 0.86059750E-10_JPRB, 0.86326127E-10_JPRB, 0.86545056E-10_JPRB, &
  & 0.86722525E-10_JPRB, 0.86871135E-10_JPRB, 0.87001469E-10_JPRB, 0.87121733E-10_JPRB, 0.87236558E-10_JPRB, 0.87347830E-10_JPRB, &
  & 0.87452393E-10_JPRB, 0.87541439E-10_JPRB, 0.87605437E-10_JPRB, 0.87639937E-10_JPRB, 0.87647375E-10_JPRB, 0.87631749E-10_JPRB, &
  & 0.87596000E-10_JPRB, 0.87542529E-10_JPRB, 0.87472286E-10_JPRB, 0.87387049E-10_JPRB, 0.87289814E-10_JPRB, 0.87184898E-10_JPRB, &
  & 0.87082619E-10_JPRB, 0.86986515E-10_JPRB, 0.86896781E-10_JPRB, 0.86806819E-10_JPRB, 0.86707544E-10_JPRB, 0.86587001E-10_JPRB, &
  & 0.86431078E-10_JPRB, 0.86233520E-10_JPRB, 0.85987030E-10_JPRB, 0.85719203E-10_JPRB, 0.85432675E-10_JPRB, 0.85147764E-10_JPRB, &
  & 0.84859550E-10_JPRB, 0.84546765E-10_JPRB, 0.84216766E-10_JPRB, 0.83892518E-10_JPRB, 0.83608079E-10_JPRB, 0.83375480E-10_JPRB, &
  & 0.83174481E-10_JPRB, 0.82983787E-10_JPRB, 0.82767328E-10_JPRB, 0.82394598E-10_JPRB /)

RGHG9(:,50, 7) = (/ &
  & 0.81547810E-10_JPRB, 0.82133113E-10_JPRB, 0.82534993E-10_JPRB, 0.82983856E-10_JPRB, 0.83504946E-10_JPRB, 0.83984514E-10_JPRB, &
  & 0.84315416E-10_JPRB, 0.84533158E-10_JPRB, 0.84677904E-10_JPRB, 0.84798259E-10_JPRB, 0.84904979E-10_JPRB, 0.85019332E-10_JPRB, &
  & 0.85141512E-10_JPRB, 0.85266093E-10_JPRB, 0.85379148E-10_JPRB, 0.85476404E-10_JPRB, 0.85559546E-10_JPRB, 0.85636435E-10_JPRB, &
  & 0.85723748E-10_JPRB, 0.85847177E-10_JPRB, 0.86012177E-10_JPRB, 0.86224188E-10_JPRB, 0.86437218E-10_JPRB, 0.86629731E-10_JPRB, &
  & 0.86793475E-10_JPRB, 0.86933342E-10_JPRB, 0.87057569E-10_JPRB, 0.87172727E-10_JPRB, 0.87283666E-10_JPRB, 0.87391747E-10_JPRB, &
  & 0.87493665E-10_JPRB, 0.87581012E-10_JPRB, 0.87644544E-10_JPRB, 0.87680030E-10_JPRB, 0.87689273E-10_JPRB, 0.87675436E-10_JPRB, &
  & 0.87642234E-10_JPRB, 0.87591628E-10_JPRB, 0.87525903E-10_JPRB, 0.87445919E-10_JPRB, 0.87354290E-10_JPRB, 0.87255592E-10_JPRB, &
  & 0.87158600E-10_JPRB, 0.87070795E-10_JPRB, 0.86992302E-10_JPRB, 0.86919257E-10_JPRB, 0.86845024E-10_JPRB, 0.86764179E-10_JPRB, &
  & 0.86670539E-10_JPRB, 0.86561397E-10_JPRB, 0.86439911E-10_JPRB, 0.86302548E-10_JPRB, 0.86160676E-10_JPRB, 0.86008763E-10_JPRB, &
  & 0.85834465E-10_JPRB, 0.85638864E-10_JPRB, 0.85400860E-10_JPRB, 0.85146959E-10_JPRB, 0.84912771E-10_JPRB, 0.84705243E-10_JPRB, &
  & 0.84523159E-10_JPRB, 0.84340569E-10_JPRB, 0.84126525E-10_JPRB, 0.83741340E-10_JPRB /)

RGHG9(:,51, 7) = (/ &
  & 0.82928941E-10_JPRB, 0.83480750E-10_JPRB, 0.83844688E-10_JPRB, 0.84221352E-10_JPRB, 0.84670909E-10_JPRB, 0.85065885E-10_JPRB, &
  & 0.85336280E-10_JPRB, 0.85491884E-10_JPRB, 0.85603233E-10_JPRB, 0.85682239E-10_JPRB, 0.85757734E-10_JPRB, 0.85831842E-10_JPRB, &
  & 0.85909189E-10_JPRB, 0.85979932E-10_JPRB, 0.86034846E-10_JPRB, 0.86070880E-10_JPRB, 0.86090989E-10_JPRB, 0.86103485E-10_JPRB, &
  & 0.86120680E-10_JPRB, 0.86156596E-10_JPRB, 0.86240501E-10_JPRB, 0.86367108E-10_JPRB, 0.86534876E-10_JPRB, 0.86702603E-10_JPRB, &
  & 0.86854232E-10_JPRB, 0.86987001E-10_JPRB, 0.87105975E-10_JPRB, 0.87217102E-10_JPRB, 0.87324523E-10_JPRB, 0.87429806E-10_JPRB, &
  & 0.87529636E-10_JPRB, 0.87615692E-10_JPRB, 0.87679308E-10_JPRB, 0.87716098E-10_JPRB, 0.87727201E-10_JPRB, 0.87715439E-10_JPRB, &
  & 0.87684089E-10_JPRB, 0.87637092E-10_JPRB, 0.87574538E-10_JPRB, 0.87499931E-10_JPRB, 0.87412938E-10_JPRB, 0.87319284E-10_JPRB, &
  & 0.87227343E-10_JPRB, 0.87145458E-10_JPRB, 0.87075291E-10_JPRB, 0.87013785E-10_JPRB, 0.86957455E-10_JPRB, 0.86901653E-10_JPRB, &
  & 0.86846051E-10_JPRB, 0.86789104E-10_JPRB, 0.86730130E-10_JPRB, 0.86670796E-10_JPRB, 0.86607485E-10_JPRB, 0.86539449E-10_JPRB, &
  & 0.86465460E-10_JPRB, 0.86367316E-10_JPRB, 0.86251110E-10_JPRB, 0.86112506E-10_JPRB, 0.85968253E-10_JPRB, 0.85836269E-10_JPRB, &
  & 0.85701765E-10_JPRB, 0.85558761E-10_JPRB, 0.85370648E-10_JPRB, 0.85006009E-10_JPRB /)

RGHG9(:,52, 7) = (/ &
  & 0.84218535E-10_JPRB, 0.84573314E-10_JPRB, 0.84818458E-10_JPRB, 0.85103646E-10_JPRB, 0.85438608E-10_JPRB, 0.85747645E-10_JPRB, &
  & 0.85935842E-10_JPRB, 0.86055343E-10_JPRB, 0.86125246E-10_JPRB, 0.86183491E-10_JPRB, 0.86232139E-10_JPRB, 0.86282599E-10_JPRB, &
  & 0.86333322E-10_JPRB, 0.86376351E-10_JPRB, 0.86403967E-10_JPRB, 0.86414688E-10_JPRB, 0.86412807E-10_JPRB, 0.86404217E-10_JPRB, &
  & 0.86396897E-10_JPRB, 0.86399693E-10_JPRB, 0.86425971E-10_JPRB, 0.86503582E-10_JPRB, 0.86621169E-10_JPRB, 0.86766830E-10_JPRB, &
  & 0.86907641E-10_JPRB, 0.87034435E-10_JPRB, 0.87149232E-10_JPRB, 0.87256598E-10_JPRB, 0.87361007E-10_JPRB, 0.87463571E-10_JPRB, &
  & 0.87561347E-10_JPRB, 0.87646501E-10_JPRB, 0.87710512E-10_JPRB, 0.87748878E-10_JPRB, 0.87761867E-10_JPRB, 0.87751958E-10_JPRB, &
  & 0.87723454E-10_JPRB, 0.87678455E-10_JPRB, 0.87620279E-10_JPRB, 0.87549031E-10_JPRB, 0.87466978E-10_JPRB, 0.87377536E-10_JPRB, &
  & 0.87290161E-10_JPRB, 0.87212834E-10_JPRB, 0.87149191E-10_JPRB, 0.87096226E-10_JPRB, 0.87050922E-10_JPRB, 0.87012210E-10_JPRB, &
  & 0.86977647E-10_JPRB, 0.86947435E-10_JPRB, 0.86919819E-10_JPRB, 0.86892576E-10_JPRB, 0.86866507E-10_JPRB, 0.86839917E-10_JPRB, &
  & 0.86807818E-10_JPRB, 0.86772381E-10_JPRB, 0.86723261E-10_JPRB, 0.86666146E-10_JPRB, 0.86606784E-10_JPRB, 0.86542287E-10_JPRB, &
  & 0.86476791E-10_JPRB, 0.86395002E-10_JPRB, 0.86277777E-10_JPRB, 0.86004995E-10_JPRB /)

RGHG9(:,53, 7) = (/ &
  & 0.85025521E-10_JPRB, 0.85317600E-10_JPRB, 0.85510966E-10_JPRB, 0.85716205E-10_JPRB, 0.85962307E-10_JPRB, 0.86176927E-10_JPRB, &
  & 0.86320076E-10_JPRB, 0.86395571E-10_JPRB, 0.86448598E-10_JPRB, 0.86484792E-10_JPRB, 0.86519139E-10_JPRB, 0.86553098E-10_JPRB, &
  & 0.86586849E-10_JPRB, 0.86614681E-10_JPRB, 0.86629093E-10_JPRB, 0.86629925E-10_JPRB, 0.86621016E-10_JPRB, 0.86607568E-10_JPRB, &
  & 0.86592115E-10_JPRB, 0.86582852E-10_JPRB, 0.86587210E-10_JPRB, 0.86619850E-10_JPRB, 0.86705552E-10_JPRB, 0.86825575E-10_JPRB, &
  & 0.86956192E-10_JPRB, 0.87077706E-10_JPRB, 0.87188610E-10_JPRB, 0.87292958E-10_JPRB, 0.87394113E-10_JPRB, 0.87494095E-10_JPRB, &
  & 0.87589908E-10_JPRB, 0.87674187E-10_JPRB, 0.87738955E-10_JPRB, 0.87778805E-10_JPRB, 0.87793967E-10_JPRB, 0.87786355E-10_JPRB, &
  & 0.87759647E-10_JPRB, 0.87717986E-10_JPRB, 0.87662287E-10_JPRB, 0.87595028E-10_JPRB, 0.87516487E-10_JPRB, 0.87431166E-10_JPRB, &
  & 0.87347900E-10_JPRB, 0.87275513E-10_JPRB, 0.87216290E-10_JPRB, 0.87169390E-10_JPRB, 0.87132468E-10_JPRB, 0.87103144E-10_JPRB, &
  & 0.87081051E-10_JPRB, 0.87063676E-10_JPRB, 0.87049354E-10_JPRB, 0.87037259E-10_JPRB, 0.87025900E-10_JPRB, 0.87014479E-10_JPRB, &
  & 0.87003141E-10_JPRB, 0.86987667E-10_JPRB, 0.86969897E-10_JPRB, 0.86947519E-10_JPRB, 0.86922081E-10_JPRB, 0.86897343E-10_JPRB, &
  & 0.86868027E-10_JPRB, 0.86833526E-10_JPRB, 0.86781526E-10_JPRB, 0.86644358E-10_JPRB /)

RGHG9(:,54, 7) = (/ &
  & 0.85717711E-10_JPRB, 0.85892737E-10_JPRB, 0.86017110E-10_JPRB, 0.86157075E-10_JPRB, 0.86324344E-10_JPRB, 0.86476840E-10_JPRB, &
  & 0.86570320E-10_JPRB, 0.86628461E-10_JPRB, 0.86661449E-10_JPRB, 0.86688212E-10_JPRB, 0.86710861E-10_JPRB, 0.86733939E-10_JPRB, &
  & 0.86757705E-10_JPRB, 0.86775878E-10_JPRB, 0.86783830E-10_JPRB, 0.86780860E-10_JPRB, 0.86770452E-10_JPRB, 0.86755443E-10_JPRB, &
  & 0.86740740E-10_JPRB, 0.86724732E-10_JPRB, 0.86717918E-10_JPRB, 0.86731670E-10_JPRB, 0.86782567E-10_JPRB, 0.86882869E-10_JPRB, &
  & 0.87002176E-10_JPRB, 0.87118306E-10_JPRB, 0.87225706E-10_JPRB, 0.87326563E-10_JPRB, 0.87425130E-10_JPRB, 0.87522274E-10_JPRB, &
  & 0.87616109E-10_JPRB, 0.87699806E-10_JPRB, 0.87765080E-10_JPRB, 0.87806817E-10_JPRB, 0.87823984E-10_JPRB, 0.87818509E-10_JPRB, &
  & 0.87794397E-10_JPRB, 0.87754803E-10_JPRB, 0.87702165E-10_JPRB, 0.87637606E-10_JPRB, 0.87562201E-10_JPRB, 0.87481099E-10_JPRB, &
  & 0.87402002E-10_JPRB, 0.87333613E-10_JPRB, 0.87279038E-10_JPRB, 0.87236635E-10_JPRB, 0.87204563E-10_JPRB, 0.87181672E-10_JPRB, &
  & 0.87165414E-10_JPRB, 0.87154131E-10_JPRB, 0.87145957E-10_JPRB, 0.87139268E-10_JPRB, 0.87133814E-10_JPRB, 0.87128985E-10_JPRB, &
  & 0.87123350E-10_JPRB, 0.87117515E-10_JPRB, 0.87109334E-10_JPRB, 0.87099869E-10_JPRB, 0.87090044E-10_JPRB, 0.87079184E-10_JPRB, &
  & 0.87068644E-10_JPRB, 0.87057417E-10_JPRB, 0.87047702E-10_JPRB, 0.87046648E-10_JPRB /)

RGHG9(:,55, 7) = (/ &
  & 0.86153321E-10_JPRB, 0.86290364E-10_JPRB, 0.86379813E-10_JPRB, 0.86478213E-10_JPRB, 0.86587917E-10_JPRB, 0.86688962E-10_JPRB, &
  & 0.86757976E-10_JPRB, 0.86794835E-10_JPRB, 0.86819954E-10_JPRB, 0.86837232E-10_JPRB, 0.86853191E-10_JPRB, 0.86869401E-10_JPRB, &
  & 0.86885332E-10_JPRB, 0.86898176E-10_JPRB, 0.86902624E-10_JPRB, 0.86898475E-10_JPRB, 0.86887914E-10_JPRB, 0.86874487E-10_JPRB, &
  & 0.86857514E-10_JPRB, 0.86843054E-10_JPRB, 0.86828447E-10_JPRB, 0.86827934E-10_JPRB, 0.86860963E-10_JPRB, 0.86939310E-10_JPRB, &
  & 0.87047564E-10_JPRB, 0.87157614E-10_JPRB, 0.87260976E-10_JPRB, 0.87359051E-10_JPRB, 0.87454287E-10_JPRB, 0.87549183E-10_JPRB, &
  & 0.87641103E-10_JPRB, 0.87723967E-10_JPRB, 0.87789900E-10_JPRB, 0.87833171E-10_JPRB, 0.87852420E-10_JPRB, 0.87849235E-10_JPRB, &
  & 0.87827350E-10_JPRB, 0.87790088E-10_JPRB, 0.87739642E-10_JPRB, 0.87677483E-10_JPRB, 0.87605277E-10_JPRB, 0.87527374E-10_JPRB, &
  & 0.87453149E-10_JPRB, 0.87389082E-10_JPRB, 0.87338095E-10_JPRB, 0.87299244E-10_JPRB, 0.87270934E-10_JPRB, 0.87251012E-10_JPRB, &
  & 0.87237856E-10_JPRB, 0.87229043E-10_JPRB, 0.87222771E-10_JPRB, 0.87218364E-10_JPRB, 0.87214874E-10_JPRB, 0.87211696E-10_JPRB, &
  & 0.87208858E-10_JPRB, 0.87205090E-10_JPRB, 0.87200899E-10_JPRB, 0.87195778E-10_JPRB, 0.87190075E-10_JPRB, 0.87184607E-10_JPRB, &
  & 0.87178403E-10_JPRB, 0.87171909E-10_JPRB, 0.87164581E-10_JPRB, 0.87155110E-10_JPRB /)

RGHG9(:,56, 7) = (/ &
  & 0.86506739E-10_JPRB, 0.86589694E-10_JPRB, 0.86649354E-10_JPRB, 0.86711568E-10_JPRB, 0.86786023E-10_JPRB, 0.86853025E-10_JPRB, &
  & 0.86898266E-10_JPRB, 0.86926556E-10_JPRB, 0.86942939E-10_JPRB, 0.86955818E-10_JPRB, 0.86966934E-10_JPRB, 0.86978105E-10_JPRB, &
  & 0.86989874E-10_JPRB, 0.86998811E-10_JPRB, 0.87001725E-10_JPRB, 0.86997631E-10_JPRB, 0.86987972E-10_JPRB, 0.86974247E-10_JPRB, &
  & 0.86959523E-10_JPRB, 0.86940892E-10_JPRB, 0.86925911E-10_JPRB, 0.86916502E-10_JPRB, 0.86933898E-10_JPRB, 0.86997208E-10_JPRB, &
  & 0.87093603E-10_JPRB, 0.87196937E-10_JPRB, 0.87296004E-10_JPRB, 0.87390428E-10_JPRB, 0.87483375E-10_JPRB, 0.87575468E-10_JPRB, &
  & 0.87665736E-10_JPRB, 0.87747760E-10_JPRB, 0.87814013E-10_JPRB, 0.87858554E-10_JPRB, 0.87879710E-10_JPRB, 0.87878774E-10_JPRB, &
  & 0.87859039E-10_JPRB, 0.87823963E-10_JPRB, 0.87775447E-10_JPRB, 0.87715384E-10_JPRB, 0.87645648E-10_JPRB, 0.87572075E-10_JPRB, &
  & 0.87501832E-10_JPRB, 0.87442040E-10_JPRB, 0.87394696E-10_JPRB, 0.87358773E-10_JPRB, 0.87332704E-10_JPRB, 0.87314808E-10_JPRB, &
  & 0.87302679E-10_JPRB, 0.87294408E-10_JPRB, 0.87288662E-10_JPRB, 0.87284333E-10_JPRB, 0.87281037E-10_JPRB, 0.87278386E-10_JPRB, &
  & 0.87275465E-10_JPRB, 0.87272620E-10_JPRB, 0.87268984E-10_JPRB, 0.87265070E-10_JPRB, 0.87261254E-10_JPRB, 0.87257146E-10_JPRB, &
  & 0.87253114E-10_JPRB, 0.87248528E-10_JPRB, 0.87243476E-10_JPRB, 0.87236336E-10_JPRB /)

RGHG9(:,57, 7) = (/ &
  & 0.86737631E-10_JPRB, 0.86803884E-10_JPRB, 0.86845663E-10_JPRB, 0.86890550E-10_JPRB, 0.86936715E-10_JPRB, 0.86982033E-10_JPRB, &
  & 0.87014493E-10_JPRB, 0.87033353E-10_JPRB, 0.87045940E-10_JPRB, 0.87054940E-10_JPRB, 0.87063065E-10_JPRB, 0.87071503E-10_JPRB, &
  & 0.87079940E-10_JPRB, 0.87087018E-10_JPRB, 0.87089363E-10_JPRB, 0.87085866E-10_JPRB, 0.87077026E-10_JPRB, 0.87064467E-10_JPRB, &
  & 0.87047841E-10_JPRB, 0.87030688E-10_JPRB, 0.87010177E-10_JPRB, 0.86996660E-10_JPRB, 0.87004903E-10_JPRB, 0.87055758E-10_JPRB, &
  & 0.87141322E-10_JPRB, 0.87237190E-10_JPRB, 0.87331475E-10_JPRB, 0.87422743E-10_JPRB, 0.87512469E-10_JPRB, 0.87602585E-10_JPRB, &
  & 0.87690744E-10_JPRB, 0.87771866E-10_JPRB, 0.87838035E-10_JPRB, 0.87883513E-10_JPRB, 0.87906175E-10_JPRB, 0.87907306E-10_JPRB, &
  & 0.87889897E-10_JPRB, 0.87856583E-10_JPRB, 0.87809933E-10_JPRB, 0.87751743E-10_JPRB, 0.87684873E-10_JPRB, 0.87614749E-10_JPRB, &
  & 0.87549135E-10_JPRB, 0.87493394E-10_JPRB, 0.87449062E-10_JPRB, 0.87415714E-10_JPRB, 0.87391525E-10_JPRB, 0.87374552E-10_JPRB, &
  & 0.87362853E-10_JPRB, 0.87354485E-10_JPRB, 0.87348032E-10_JPRB, 0.87343147E-10_JPRB, 0.87339296E-10_JPRB, 0.87335736E-10_JPRB, &
  & 0.87332627E-10_JPRB, 0.87328894E-10_JPRB, 0.87325099E-10_JPRB, 0.87321136E-10_JPRB, 0.87317140E-10_JPRB, 0.87313518E-10_JPRB, &
  & 0.87309548E-10_JPRB, 0.87305295E-10_JPRB, 0.87300181E-10_JPRB, 0.87291466E-10_JPRB /)

RGHG9(:,58, 7) = (/ &
  & 0.86925384E-10_JPRB, 0.86968571E-10_JPRB, 0.86997742E-10_JPRB, 0.87026192E-10_JPRB, 0.87058714E-10_JPRB, 0.87088302E-10_JPRB, &
  & 0.87110874E-10_JPRB, 0.87125321E-10_JPRB, 0.87134432E-10_JPRB, 0.87141433E-10_JPRB, 0.87147796E-10_JPRB, 0.87154235E-10_JPRB, &
  & 0.87161327E-10_JPRB, 0.87167287E-10_JPRB, 0.87169931E-10_JPRB, 0.87167482E-10_JPRB, 0.87159766E-10_JPRB, 0.87147005E-10_JPRB, &
  & 0.87130997E-10_JPRB, 0.87109819E-10_JPRB, 0.87088892E-10_JPRB, 0.87069976E-10_JPRB, 0.87072571E-10_JPRB, 0.87114781E-10_JPRB, &
  & 0.87190796E-10_JPRB, 0.87279378E-10_JPRB, 0.87368661E-10_JPRB, 0.87456223E-10_JPRB, 0.87543271E-10_JPRB, 0.87630694E-10_JPRB, &
  & 0.87716980E-10_JPRB, 0.87796825E-10_JPRB, 0.87862585E-10_JPRB, 0.87908382E-10_JPRB, 0.87932314E-10_JPRB, 0.87935229E-10_JPRB, &
  & 0.87919727E-10_JPRB, 0.87888495E-10_JPRB, 0.87843427E-10_JPRB, 0.87787208E-10_JPRB, 0.87723016E-10_JPRB, 0.87656875E-10_JPRB, &
  & 0.87595556E-10_JPRB, 0.87543181E-10_JPRB, 0.87502061E-10_JPRB, 0.87470621E-10_JPRB, 0.87447903E-10_JPRB, 0.87431708E-10_JPRB, &
  & 0.87420134E-10_JPRB, 0.87411391E-10_JPRB, 0.87404292E-10_JPRB, 0.87398311E-10_JPRB, 0.87393107E-10_JPRB, 0.87388749E-10_JPRB, &
  & 0.87383996E-10_JPRB, 0.87379465E-10_JPRB, 0.87374483E-10_JPRB, 0.87369639E-10_JPRB, 0.87365358E-10_JPRB, 0.87361063E-10_JPRB, &
  & 0.87356927E-10_JPRB, 0.87352341E-10_JPRB, 0.87346866E-10_JPRB, 0.87337783E-10_JPRB /)

RGHG9(:,59, 7) = (/ &
  & 0.87057188E-10_JPRB, 0.87093499E-10_JPRB, 0.87115461E-10_JPRB, 0.87136701E-10_JPRB, 0.87157809E-10_JPRB, 0.87179111E-10_JPRB, &
  & 0.87195431E-10_JPRB, 0.87206339E-10_JPRB, 0.87213646E-10_JPRB, 0.87219378E-10_JPRB, 0.87224568E-10_JPRB, 0.87230285E-10_JPRB, &
  & 0.87236413E-10_JPRB, 0.87242380E-10_JPRB, 0.87245759E-10_JPRB, 0.87244642E-10_JPRB, 0.87238071E-10_JPRB, 0.87225685E-10_JPRB, &
  & 0.87207588E-10_JPRB, 0.87185696E-10_JPRB, 0.87159932E-10_JPRB, 0.87138914E-10_JPRB, 0.87137922E-10_JPRB, 0.87174143E-10_JPRB, &
  & 0.87241978E-10_JPRB, 0.87323600E-10_JPRB, 0.87408081E-10_JPRB, 0.87491965E-10_JPRB, 0.87576064E-10_JPRB, 0.87660823E-10_JPRB, &
  & 0.87744895E-10_JPRB, 0.87823041E-10_JPRB, 0.87887933E-10_JPRB, 0.87933660E-10_JPRB, 0.87958182E-10_JPRB, 0.87962512E-10_JPRB, &
  & 0.87948905E-10_JPRB, 0.87919359E-10_JPRB, 0.87876262E-10_JPRB, 0.87822007E-10_JPRB, 0.87760861E-10_JPRB, 0.87698612E-10_JPRB, &
  & 0.87640943E-10_JPRB, 0.87592628E-10_JPRB, 0.87553444E-10_JPRB, 0.87524155E-10_JPRB, 0.87502505E-10_JPRB, 0.87486865E-10_JPRB, &
  & 0.87475346E-10_JPRB, 0.87466361E-10_JPRB, 0.87458693E-10_JPRB, 0.87451678E-10_JPRB, 0.87445488E-10_JPRB, 0.87439125E-10_JPRB, &
  & 0.87433276E-10_JPRB, 0.87426705E-10_JPRB, 0.87420293E-10_JPRB, 0.87414298E-10_JPRB, 0.87408678E-10_JPRB, 0.87403737E-10_JPRB, &
  & 0.87398616E-10_JPRB, 0.87393169E-10_JPRB, 0.87386806E-10_JPRB, 0.87375662E-10_JPRB /)

RGHG9(:,60, 7) = (/ &
  & 0.87168550E-10_JPRB, 0.87196438E-10_JPRB, 0.87212723E-10_JPRB, 0.87227711E-10_JPRB, 0.87243490E-10_JPRB, 0.87258395E-10_JPRB, &
  & 0.87271086E-10_JPRB, 0.87279815E-10_JPRB, 0.87286116E-10_JPRB, 0.87291070E-10_JPRB, 0.87295990E-10_JPRB, 0.87301201E-10_JPRB, &
  & 0.87307481E-10_JPRB, 0.87313767E-10_JPRB, 0.87318333E-10_JPRB, 0.87318736E-10_JPRB, 0.87313309E-10_JPRB, 0.87300792E-10_JPRB, &
  & 0.87281619E-10_JPRB, 0.87255800E-10_JPRB, 0.87228114E-10_JPRB, 0.87204584E-10_JPRB, 0.87201892E-10_JPRB, 0.87233346E-10_JPRB, &
  & 0.87294366E-10_JPRB, 0.87369903E-10_JPRB, 0.87449673E-10_JPRB, 0.87530233E-10_JPRB, 0.87611175E-10_JPRB, 0.87693297E-10_JPRB, &
  & 0.87774704E-10_JPRB, 0.87850935E-10_JPRB, 0.87914363E-10_JPRB, 0.87959300E-10_JPRB, 0.87984044E-10_JPRB, 0.87989289E-10_JPRB, &
  & 0.87977133E-10_JPRB, 0.87949571E-10_JPRB, 0.87908278E-10_JPRB, 0.87856576E-10_JPRB, 0.87798505E-10_JPRB, 0.87739885E-10_JPRB, &
  & 0.87686670E-10_JPRB, 0.87640596E-10_JPRB, 0.87604479E-10_JPRB, 0.87576377E-10_JPRB, 0.87555789E-10_JPRB, 0.87540523E-10_JPRB, &
  & 0.87529005E-10_JPRB, 0.87519852E-10_JPRB, 0.87511838E-10_JPRB, 0.87504379E-10_JPRB, 0.87496822E-10_JPRB, 0.87489550E-10_JPRB, &
  & 0.87481411E-10_JPRB, 0.87473195E-10_JPRB, 0.87464709E-10_JPRB, 0.87456833E-10_JPRB, 0.87450033E-10_JPRB, 0.87443539E-10_JPRB, &
  & 0.87437196E-10_JPRB, 0.87430486E-10_JPRB, 0.87422312E-10_JPRB, 0.87408684E-10_JPRB /)

RGHG9(:,61, 7) = (/ &
  & 0.87258721E-10_JPRB, 0.87281772E-10_JPRB, 0.87295088E-10_JPRB, 0.87306856E-10_JPRB, 0.87318527E-10_JPRB, 0.87330365E-10_JPRB, &
  & 0.87340343E-10_JPRB, 0.87348059E-10_JPRB, 0.87353673E-10_JPRB, 0.87358600E-10_JPRB, 0.87363304E-10_JPRB, 0.87368890E-10_JPRB, &
  & 0.87375378E-10_JPRB, 0.87382677E-10_JPRB, 0.87388562E-10_JPRB, 0.87390484E-10_JPRB, 0.87386078E-10_JPRB, 0.87373241E-10_JPRB, &
  & 0.87351994E-10_JPRB, 0.87324099E-10_JPRB, 0.87293450E-10_JPRB, 0.87269046E-10_JPRB, 0.87264987E-10_JPRB, 0.87292604E-10_JPRB, &
  & 0.87347685E-10_JPRB, 0.87417899E-10_JPRB, 0.87493679E-10_JPRB, 0.87570812E-10_JPRB, 0.87649124E-10_JPRB, 0.87728103E-10_JPRB, &
  & 0.87807005E-10_JPRB, 0.87880550E-10_JPRB, 0.87942029E-10_JPRB, 0.87985619E-10_JPRB, 0.88009836E-10_JPRB, 0.88015595E-10_JPRB, &
  & 0.88004763E-10_JPRB, 0.87978826E-10_JPRB, 0.87939919E-10_JPRB, 0.87890716E-10_JPRB, 0.87836044E-10_JPRB, 0.87781518E-10_JPRB, &
  & 0.87731149E-10_JPRB, 0.87689023E-10_JPRB, 0.87654217E-10_JPRB, 0.87627981E-10_JPRB, 0.87608053E-10_JPRB, 0.87593141E-10_JPRB, &
  & 0.87581623E-10_JPRB, 0.87572262E-10_JPRB, 0.87564060E-10_JPRB, 0.87556185E-10_JPRB, 0.87548260E-10_JPRB, 0.87539545E-10_JPRB, &
  & 0.87530233E-10_JPRB, 0.87519811E-10_JPRB, 0.87509278E-10_JPRB, 0.87499466E-10_JPRB, 0.87490640E-10_JPRB, 0.87482604E-10_JPRB, &
  & 0.87474528E-10_JPRB, 0.87465660E-10_JPRB, 0.87455265E-10_JPRB, 0.87436627E-10_JPRB /)

RGHG9(:,62, 7) = (/ &
  & 0.87337561E-10_JPRB, 0.87356782E-10_JPRB, 0.87367447E-10_JPRB, 0.87376988E-10_JPRB, 0.87386640E-10_JPRB, 0.87396167E-10_JPRB, &
  & 0.87405035E-10_JPRB, 0.87412015E-10_JPRB, 0.87417774E-10_JPRB, 0.87422750E-10_JPRB, 0.87428030E-10_JPRB, 0.87433970E-10_JPRB, &
  & 0.87441533E-10_JPRB, 0.87449929E-10_JPRB, 0.87457340E-10_JPRB, 0.87460574E-10_JPRB, 0.87456709E-10_JPRB, 0.87443372E-10_JPRB, &
  & 0.87420293E-10_JPRB, 0.87390109E-10_JPRB, 0.87358037E-10_JPRB, 0.87332995E-10_JPRB, 0.87327742E-10_JPRB, 0.87351779E-10_JPRB, &
  & 0.87402044E-10_JPRB, 0.87467582E-10_JPRB, 0.87539684E-10_JPRB, 0.87614069E-10_JPRB, 0.87689488E-10_JPRB, 0.87765913E-10_JPRB, &
  & 0.87841553E-10_JPRB, 0.87912295E-10_JPRB, 0.87971005E-10_JPRB, 0.88012590E-10_JPRB, 0.88035773E-10_JPRB, 0.88041574E-10_JPRB, &
  & 0.88031721E-10_JPRB, 0.88007629E-10_JPRB, 0.87970901E-10_JPRB, 0.87924806E-10_JPRB, 0.87873570E-10_JPRB, 0.87822485E-10_JPRB, &
  & 0.87776307E-10_JPRB, 0.87736055E-10_JPRB, 0.87704011E-10_JPRB, 0.87678698E-10_JPRB, 0.87659636E-10_JPRB, 0.87644995E-10_JPRB, &
  & 0.87633525E-10_JPRB, 0.87624033E-10_JPRB, 0.87615672E-10_JPRB, 0.87607616E-10_JPRB, 0.87599240E-10_JPRB, 0.87589949E-10_JPRB, &
  & 0.87579298E-10_JPRB, 0.87567412E-10_JPRB, 0.87554825E-10_JPRB, 0.87542917E-10_JPRB, 0.87532225E-10_JPRB, 0.87522253E-10_JPRB, &
  & 0.87512067E-10_JPRB, 0.87501138E-10_JPRB, 0.87486962E-10_JPRB, 0.87462183E-10_JPRB /)

RGHG9(:,63, 7) = (/ &
  & 0.87404389E-10_JPRB, 0.87422201E-10_JPRB, 0.87432138E-10_JPRB, 0.87440680E-10_JPRB, 0.87449062E-10_JPRB, 0.87457673E-10_JPRB, &
  & 0.87465674E-10_JPRB, 0.87472814E-10_JPRB, 0.87478774E-10_JPRB, 0.87484520E-10_JPRB, 0.87490445E-10_JPRB, 0.87497704E-10_JPRB, &
  & 0.87506447E-10_JPRB, 0.87516487E-10_JPRB, 0.87525188E-10_JPRB, 0.87529282E-10_JPRB, 0.87525480E-10_JPRB, 0.87511158E-10_JPRB, &
  & 0.87486851E-10_JPRB, 0.87455272E-10_JPRB, 0.87422222E-10_JPRB, 0.87396673E-10_JPRB, 0.87390310E-10_JPRB, 0.87411502E-10_JPRB, &
  & 0.87457493E-10_JPRB, 0.87519082E-10_JPRB, 0.87588034E-10_JPRB, 0.87659630E-10_JPRB, 0.87732668E-10_JPRB, 0.87806082E-10_JPRB, &
  & 0.87878677E-10_JPRB, 0.87945665E-10_JPRB, 0.88001217E-10_JPRB, 0.88040158E-10_JPRB, 0.88061787E-10_JPRB, 0.88067262E-10_JPRB, &
  & 0.88058200E-10_JPRB, 0.88035780E-10_JPRB, 0.88001634E-10_JPRB, 0.87958543E-10_JPRB, 0.87910942E-10_JPRB, 0.87863800E-10_JPRB, &
  & 0.87820362E-10_JPRB, 0.87783503E-10_JPRB, 0.87752833E-10_JPRB, 0.87729109E-10_JPRB, 0.87710617E-10_JPRB, 0.87696309E-10_JPRB, &
  & 0.87684929E-10_JPRB, 0.87675429E-10_JPRB, 0.87666999E-10_JPRB, 0.87658866E-10_JPRB, 0.87650234E-10_JPRB, 0.87640416E-10_JPRB, &
  & 0.87628932E-10_JPRB, 0.87615824E-10_JPRB, 0.87601704E-10_JPRB, 0.87587930E-10_JPRB, 0.87575343E-10_JPRB, 0.87563526E-10_JPRB, &
  & 0.87551633E-10_JPRB, 0.87538095E-10_JPRB, 0.87520706E-10_JPRB, 0.87488287E-10_JPRB /)

RGHG9(:,64, 7) = (/ &
  & 0.87464244E-10_JPRB, 0.87481668E-10_JPRB, 0.87491139E-10_JPRB, 0.87499244E-10_JPRB, 0.87507210E-10_JPRB, 0.87515148E-10_JPRB, &
  & 0.87523128E-10_JPRB, 0.87530344E-10_JPRB, 0.87537227E-10_JPRB, 0.87543806E-10_JPRB, 0.87551202E-10_JPRB, 0.87559821E-10_JPRB, &
  & 0.87570583E-10_JPRB, 0.87582087E-10_JPRB, 0.87591850E-10_JPRB, 0.87596201E-10_JPRB, 0.87591934E-10_JPRB, 0.87576932E-10_JPRB, &
  & 0.87551535E-10_JPRB, 0.87519186E-10_JPRB, 0.87485665E-10_JPRB, 0.87459838E-10_JPRB, 0.87452635E-10_JPRB, 0.87471454E-10_JPRB, &
  & 0.87514024E-10_JPRB, 0.87572130E-10_JPRB, 0.87638063E-10_JPRB, 0.87707175E-10_JPRB, 0.87777494E-10_JPRB, 0.87848041E-10_JPRB, &
  & 0.87916868E-10_JPRB, 0.87979950E-10_JPRB, 0.88031499E-10_JPRB, 0.88067456E-10_JPRB, 0.88087176E-10_JPRB, 0.88092054E-10_JPRB, &
  & 0.88083645E-10_JPRB, 0.88062953E-10_JPRB, 0.88031381E-10_JPRB, 0.87991656E-10_JPRB, 0.87947739E-10_JPRB, 0.87904094E-10_JPRB, &
  & 0.87864299E-10_JPRB, 0.87829556E-10_JPRB, 0.87801148E-10_JPRB, 0.87778458E-10_JPRB, 0.87760715E-10_JPRB, 0.87746761E-10_JPRB, &
  & 0.87735562E-10_JPRB, 0.87726174E-10_JPRB, 0.87717826E-10_JPRB, 0.87709701E-10_JPRB, 0.87700985E-10_JPRB, 0.87690862E-10_JPRB, &
  & 0.87678795E-10_JPRB, 0.87664778E-10_JPRB, 0.87649443E-10_JPRB, 0.87634185E-10_JPRB, 0.87619925E-10_JPRB, 0.87606596E-10_JPRB, &
  & 0.87593030E-10_JPRB, 0.87577959E-10_JPRB, 0.87557100E-10_JPRB, 0.87517868E-10_JPRB /)

RGHG9(:,65, 7) = (/ &
  & 0.87518333E-10_JPRB, 0.87536083E-10_JPRB, 0.87545811E-10_JPRB, 0.87553971E-10_JPRB, 0.87561791E-10_JPRB, 0.87569729E-10_JPRB, &
  & 0.87577487E-10_JPRB, 0.87585467E-10_JPRB, 0.87593002E-10_JPRB, 0.87601218E-10_JPRB, 0.87610127E-10_JPRB, 0.87621056E-10_JPRB, &
  & 0.87633553E-10_JPRB, 0.87646501E-10_JPRB, 0.87656618E-10_JPRB, 0.87660726E-10_JPRB, 0.87655952E-10_JPRB, 0.87640291E-10_JPRB, &
  & 0.87614582E-10_JPRB, 0.87581983E-10_JPRB, 0.87548253E-10_JPRB, 0.87522406E-10_JPRB, 0.87514711E-10_JPRB, 0.87531718E-10_JPRB, &
  & 0.87571339E-10_JPRB, 0.87626226E-10_JPRB, 0.87689273E-10_JPRB, 0.87755553E-10_JPRB, 0.87822999E-10_JPRB, 0.87890112E-10_JPRB, &
  & 0.87954928E-10_JPRB, 0.88013395E-10_JPRB, 0.88060725E-10_JPRB, 0.88093317E-10_JPRB, 0.88111039E-10_JPRB, 0.88115307E-10_JPRB, &
  & 0.88107459E-10_JPRB, 0.88088488E-10_JPRB, 0.88059657E-10_JPRB, 0.88023325E-10_JPRB, 0.87983246E-10_JPRB, 0.87943375E-10_JPRB, &
  & 0.87906626E-10_JPRB, 0.87874721E-10_JPRB, 0.87848021E-10_JPRB, 0.87826697E-10_JPRB, 0.87809635E-10_JPRB, 0.87796166E-10_JPRB, &
  & 0.87785224E-10_JPRB, 0.87776085E-10_JPRB, 0.87767946E-10_JPRB, 0.87760008E-10_JPRB, 0.87751383E-10_JPRB, 0.87741141E-10_JPRB, &
  & 0.87728727E-10_JPRB, 0.87714100E-10_JPRB, 0.87697828E-10_JPRB, 0.87681418E-10_JPRB, 0.87665888E-10_JPRB, 0.87651282E-10_JPRB, &
  & 0.87636627E-10_JPRB, 0.87620307E-10_JPRB, 0.87597096E-10_JPRB, 0.87552195E-10_JPRB /)

RGHG9(:,66, 7) = (/ &
  & 0.87567245E-10_JPRB, 0.87586688E-10_JPRB, 0.87597089E-10_JPRB, 0.87605867E-10_JPRB, 0.87614110E-10_JPRB, 0.87622146E-10_JPRB, &
  & 0.87630396E-10_JPRB, 0.87638521E-10_JPRB, 0.87647598E-10_JPRB, 0.87656910E-10_JPRB, 0.87668206E-10_JPRB, 0.87680876E-10_JPRB, &
  & 0.87695226E-10_JPRB, 0.87708632E-10_JPRB, 0.87718645E-10_JPRB, 0.87722392E-10_JPRB, 0.87717236E-10_JPRB, 0.87701443E-10_JPRB, &
  & 0.87675651E-10_JPRB, 0.87643164E-10_JPRB, 0.87609947E-10_JPRB, 0.87584551E-10_JPRB, 0.87576606E-10_JPRB, 0.87592204E-10_JPRB, &
  & 0.87629085E-10_JPRB, 0.87680849E-10_JPRB, 0.87740676E-10_JPRB, 0.87803764E-10_JPRB, 0.87867727E-10_JPRB, 0.87930954E-10_JPRB, &
  & 0.87991260E-10_JPRB, 0.88044877E-10_JPRB, 0.88087745E-10_JPRB, 0.88117035E-10_JPRB, 0.88132751E-10_JPRB, 0.88136394E-10_JPRB, &
  & 0.88129164E-10_JPRB, 0.88111941E-10_JPRB, 0.88085858E-10_JPRB, 0.88053134E-10_JPRB, 0.88016837E-10_JPRB, 0.87980789E-10_JPRB, &
  & 0.87947351E-10_JPRB, 0.87918027E-10_JPRB, 0.87893352E-10_JPRB, 0.87873327E-10_JPRB, 0.87857187E-10_JPRB, 0.87844308E-10_JPRB, &
  & 0.87833817E-10_JPRB, 0.87825032E-10_JPRB, 0.87817212E-10_JPRB, 0.87809593E-10_JPRB, 0.87801211E-10_JPRB, 0.87791073E-10_JPRB, &
  & 0.87778590E-10_JPRB, 0.87763602E-10_JPRB, 0.87746727E-10_JPRB, 0.87729490E-10_JPRB, 0.87713052E-10_JPRB, 0.87697599E-10_JPRB, &
  & 0.87682195E-10_JPRB, 0.87665264E-10_JPRB, 0.87640582E-10_JPRB, 0.87591948E-10_JPRB /)

RGHG9(:,67, 7) = (/ &
  & 0.87612112E-10_JPRB, 0.87634074E-10_JPRB, 0.87646106E-10_JPRB, 0.87655862E-10_JPRB, 0.87665014E-10_JPRB, 0.87673743E-10_JPRB, &
  & 0.87682223E-10_JPRB, 0.87691417E-10_JPRB, 0.87700902E-10_JPRB, 0.87712490E-10_JPRB, 0.87724911E-10_JPRB, 0.87739566E-10_JPRB, &
  & 0.87754311E-10_JPRB, 0.87767744E-10_JPRB, 0.87777494E-10_JPRB, 0.87780942E-10_JPRB, 0.87775689E-10_JPRB, 0.87760091E-10_JPRB, &
  & 0.87734896E-10_JPRB, 0.87703310E-10_JPRB, 0.87670982E-10_JPRB, 0.87646314E-10_JPRB, 0.87638369E-10_JPRB, 0.87652503E-10_JPRB, &
  & 0.87686837E-10_JPRB, 0.87735208E-10_JPRB, 0.87791427E-10_JPRB, 0.87850852E-10_JPRB, 0.87910741E-10_JPRB, 0.87969597E-10_JPRB, &
  & 0.88025073E-10_JPRB, 0.88073812E-10_JPRB, 0.88112302E-10_JPRB, 0.88138385E-10_JPRB, 0.88152236E-10_JPRB, 0.88155358E-10_JPRB, &
  & 0.88148759E-10_JPRB, 0.88133285E-10_JPRB, 0.88109971E-10_JPRB, 0.88080654E-10_JPRB, 0.88048319E-10_JPRB, 0.88015893E-10_JPRB, &
  & 0.87985862E-10_JPRB, 0.87959251E-10_JPRB, 0.87936672E-10_JPRB, 0.87918159E-10_JPRB, 0.87903088E-10_JPRB, 0.87891028E-10_JPRB, &
  & 0.87881154E-10_JPRB, 0.87872910E-10_JPRB, 0.87865555E-10_JPRB, 0.87858380E-10_JPRB, 0.87850373E-10_JPRB, 0.87840547E-10_JPRB, &
  & 0.87828196E-10_JPRB, 0.87813132E-10_JPRB, 0.87796000E-10_JPRB, 0.87778312E-10_JPRB, 0.87761430E-10_JPRB, 0.87745533E-10_JPRB, &
  & 0.87729775E-10_JPRB, 0.87712677E-10_JPRB, 0.87687101E-10_JPRB, 0.87634941E-10_JPRB /)

RGHG9(:,68, 7) = (/ &
  & 0.87651053E-10_JPRB, 0.87678684E-10_JPRB, 0.87692978E-10_JPRB, 0.87704760E-10_JPRB, 0.87715141E-10_JPRB, 0.87724827E-10_JPRB, &
  & 0.87734167E-10_JPRB, 0.87743764E-10_JPRB, 0.87754831E-10_JPRB, 0.87766829E-10_JPRB, 0.87781060E-10_JPRB, 0.87795757E-10_JPRB, &
  & 0.87810634E-10_JPRB, 0.87823686E-10_JPRB, 0.87833137E-10_JPRB, 0.87836419E-10_JPRB, 0.87831339E-10_JPRB, 0.87816358E-10_JPRB, &
  & 0.87792155E-10_JPRB, 0.87761895E-10_JPRB, 0.87731135E-10_JPRB, 0.87707674E-10_JPRB, 0.87699750E-10_JPRB, 0.87712490E-10_JPRB, &
  & 0.87743979E-10_JPRB, 0.87788742E-10_JPRB, 0.87840998E-10_JPRB, 0.87896156E-10_JPRB, 0.87951660E-10_JPRB, 0.88005714E-10_JPRB, &
  & 0.88056257E-10_JPRB, 0.88100173E-10_JPRB, 0.88134521E-10_JPRB, 0.88157641E-10_JPRB, 0.88169819E-10_JPRB, 0.88172455E-10_JPRB, &
  & 0.88166509E-10_JPRB, 0.88152742E-10_JPRB, 0.88132016E-10_JPRB, 0.88106099E-10_JPRB, 0.88077330E-10_JPRB, 0.88048693E-10_JPRB, &
  & 0.88021909E-10_JPRB, 0.87998164E-10_JPRB, 0.87977778E-10_JPRB, 0.87960896E-10_JPRB, 0.87947150E-10_JPRB, 0.87936089E-10_JPRB, &
  & 0.87927082E-10_JPRB, 0.87919533E-10_JPRB, 0.87912788E-10_JPRB, 0.87906175E-10_JPRB, 0.87898702E-10_JPRB, 0.87889342E-10_JPRB, &
  & 0.87877372E-10_JPRB, 0.87862523E-10_JPRB, 0.87845509E-10_JPRB, 0.87827814E-10_JPRB, 0.87810884E-10_JPRB, 0.87795070E-10_JPRB, &
  & 0.87779409E-10_JPRB, 0.87762783E-10_JPRB, 0.87737560E-10_JPRB, 0.87685387E-10_JPRB /)

RGHG9(:,69, 7) = (/ &
  & 0.87686858E-10_JPRB, 0.87721400E-10_JPRB, 0.87739566E-10_JPRB, 0.87753277E-10_JPRB, 0.87765371E-10_JPRB, 0.87776043E-10_JPRB, &
  & 0.87786105E-10_JPRB, 0.87796562E-10_JPRB, 0.87808136E-10_JPRB, 0.87821153E-10_JPRB, 0.87835225E-10_JPRB, 0.87849956E-10_JPRB, &
  & 0.87864285E-10_JPRB, 0.87876886E-10_JPRB, 0.87885990E-10_JPRB, 0.87889161E-10_JPRB, 0.87884408E-10_JPRB, 0.87870350E-10_JPRB, &
  & 0.87847764E-10_JPRB, 0.87819529E-10_JPRB, 0.87790726E-10_JPRB, 0.87768612E-10_JPRB, 0.87760771E-10_JPRB, 0.87771825E-10_JPRB, &
  & 0.87800309E-10_JPRB, 0.87841186E-10_JPRB, 0.87889029E-10_JPRB, 0.87939683E-10_JPRB, 0.87990372E-10_JPRB, 0.88039520E-10_JPRB, &
  & 0.88085095E-10_JPRB, 0.88124369E-10_JPRB, 0.88154761E-10_JPRB, 0.88175134E-10_JPRB, 0.88185764E-10_JPRB, 0.88188019E-10_JPRB, &
  & 0.88182746E-10_JPRB, 0.88170568E-10_JPRB, 0.88152367E-10_JPRB, 0.88129531E-10_JPRB, 0.88104322E-10_JPRB, 0.88079127E-10_JPRB, &
  & 0.88055688E-10_JPRB, 0.88034788E-10_JPRB, 0.88016670E-10_JPRB, 0.88001648E-10_JPRB, 0.87989269E-10_JPRB, 0.87979443E-10_JPRB, &
  & 0.87971415E-10_JPRB, 0.87964754E-10_JPRB, 0.87958758E-10_JPRB, 0.87952860E-10_JPRB, 0.87946046E-10_JPRB, 0.87937359E-10_JPRB, &
  & 0.87926028E-10_JPRB, 0.87911706E-10_JPRB, 0.87895177E-10_JPRB, 0.87877955E-10_JPRB, 0.87861531E-10_JPRB, 0.87846265E-10_JPRB, &
  & 0.87831187E-10_JPRB, 0.87815331E-10_JPRB, 0.87791170E-10_JPRB, 0.87738802E-10_JPRB /)

RGHG9(:,70, 7) = (/ &
  & 0.87720060E-10_JPRB, 0.87764858E-10_JPRB, 0.87786431E-10_JPRB, 0.87802821E-10_JPRB, 0.87816206E-10_JPRB, 0.87827724E-10_JPRB, &
  & 0.87838452E-10_JPRB, 0.87849561E-10_JPRB, 0.87861371E-10_JPRB, 0.87874485E-10_JPRB, 0.87888016E-10_JPRB, 0.87902179E-10_JPRB, &
  & 0.87915758E-10_JPRB, 0.87927672E-10_JPRB, 0.87936311E-10_JPRB, 0.87939357E-10_JPRB, 0.87935173E-10_JPRB, 0.87922322E-10_JPRB, &
  & 0.87901603E-10_JPRB, 0.87875721E-10_JPRB, 0.87849332E-10_JPRB, 0.87828869E-10_JPRB, 0.87821160E-10_JPRB, 0.87830389E-10_JPRB, &
  & 0.87855605E-10_JPRB, 0.87892284E-10_JPRB, 0.87935603E-10_JPRB, 0.87981317E-10_JPRB, 0.88027127E-10_JPRB, 0.88071238E-10_JPRB, &
  & 0.88111927E-10_JPRB, 0.88146698E-10_JPRB, 0.88173371E-10_JPRB, 0.88191163E-10_JPRB, 0.88200371E-10_JPRB, 0.88202272E-10_JPRB, &
  & 0.88197664E-10_JPRB, 0.88187062E-10_JPRB, 0.88171213E-10_JPRB, 0.88151299E-10_JPRB, 0.88129365E-10_JPRB, 0.88107452E-10_JPRB, &
  & 0.88087322E-10_JPRB, 0.88069142E-10_JPRB, 0.88053467E-10_JPRB, 0.88040270E-10_JPRB, 0.88029438E-10_JPRB, 0.88020848E-10_JPRB, &
  & 0.88013985E-10_JPRB, 0.88008253E-10_JPRB, 0.88003133E-10_JPRB, 0.87998053E-10_JPRB, 0.87992051E-10_JPRB, 0.87984217E-10_JPRB, &
  & 0.87973774E-10_JPRB, 0.87960382E-10_JPRB, 0.87944776E-10_JPRB, 0.87928546E-10_JPRB, 0.87913100E-10_JPRB, 0.87898931E-10_JPRB, &
  & 0.87884845E-10_JPRB, 0.87870287E-10_JPRB, 0.87847896E-10_JPRB, 0.87798817E-10_JPRB /)

RGHG9(:,71, 7) = (/ &
  & 0.87754880E-10_JPRB, 0.87809537E-10_JPRB, 0.87835773E-10_JPRB, 0.87853967E-10_JPRB, 0.87868213E-10_JPRB, 0.87880613E-10_JPRB, &
  & 0.87891638E-10_JPRB, 0.87902824E-10_JPRB, 0.87915009E-10_JPRB, 0.87926721E-10_JPRB, 0.87940079E-10_JPRB, 0.87952826E-10_JPRB, &
  & 0.87965586E-10_JPRB, 0.87976570E-10_JPRB, 0.87984578E-10_JPRB, 0.87987402E-10_JPRB, 0.87983801E-10_JPRB, 0.87972248E-10_JPRB, &
  & 0.87953762E-10_JPRB, 0.87930642E-10_JPRB, 0.87906807E-10_JPRB, 0.87888169E-10_JPRB, 0.87880557E-10_JPRB, 0.87887968E-10_JPRB, &
  & 0.87909680E-10_JPRB, 0.87942098E-10_JPRB, 0.87980477E-10_JPRB, 0.88021319E-10_JPRB, 0.88062016E-10_JPRB, 0.88101075E-10_JPRB, &
  & 0.88137019E-10_JPRB, 0.88167411E-10_JPRB, 0.88190566E-10_JPRB, 0.88205915E-10_JPRB, 0.88213797E-10_JPRB, 0.88215435E-10_JPRB, &
  & 0.88211431E-10_JPRB, 0.88202307E-10_JPRB, 0.88188686E-10_JPRB, 0.88171567E-10_JPRB, 0.88152638E-10_JPRB, 0.88134028E-10_JPRB, &
  & 0.88116722E-10_JPRB, 0.88101436E-10_JPRB, 0.88087947E-10_JPRB, 0.88076699E-10_JPRB, 0.88067345E-10_JPRB, 0.88060115E-10_JPRB, &
  & 0.88054369E-10_JPRB, 0.88049630E-10_JPRB, 0.88045404E-10_JPRB, 0.88041179E-10_JPRB, 0.88036141E-10_JPRB, 0.88029341E-10_JPRB, &
  & 0.88020063E-10_JPRB, 0.88007927E-10_JPRB, 0.87993626E-10_JPRB, 0.87978839E-10_JPRB, 0.87964941E-10_JPRB, 0.87952090E-10_JPRB, &
  & 0.87939551E-10_JPRB, 0.87926257E-10_JPRB, 0.87906682E-10_JPRB, 0.87862530E-10_JPRB /)

RGHG9(:,72, 7) = (/ &
  & 0.87792003E-10_JPRB, 0.87858672E-10_JPRB, 0.87888065E-10_JPRB, 0.87907355E-10_JPRB, 0.87922683E-10_JPRB, 0.87934764E-10_JPRB, &
  & 0.87946095E-10_JPRB, 0.87957482E-10_JPRB, 0.87967869E-10_JPRB, 0.87980158E-10_JPRB, 0.87990636E-10_JPRB, 0.88003146E-10_JPRB, &
  & 0.88014096E-10_JPRB, 0.88024046E-10_JPRB, 0.88031228E-10_JPRB, 0.88033671E-10_JPRB, 0.88030541E-10_JPRB, 0.88020258E-10_JPRB, &
  & 0.88003972E-10_JPRB, 0.87983565E-10_JPRB, 0.87962596E-10_JPRB, 0.87945859E-10_JPRB, 0.87938663E-10_JPRB, 0.87944284E-10_JPRB, &
  & 0.87962526E-10_JPRB, 0.87990372E-10_JPRB, 0.88023949E-10_JPRB, 0.88059615E-10_JPRB, 0.88095260E-10_JPRB, 0.88129219E-10_JPRB, &
  & 0.88160521E-10_JPRB, 0.88186729E-10_JPRB, 0.88206518E-10_JPRB, 0.88219591E-10_JPRB, 0.88226232E-10_JPRB, 0.88227606E-10_JPRB, &
  & 0.88224206E-10_JPRB, 0.88216469E-10_JPRB, 0.88204950E-10_JPRB, 0.88190365E-10_JPRB, 0.88174426E-10_JPRB, 0.88158578E-10_JPRB, &
  & 0.88144367E-10_JPRB, 0.88131391E-10_JPRB, 0.88120213E-10_JPRB, 0.88110713E-10_JPRB, 0.88102900E-10_JPRB, 0.88096933E-10_JPRB, &
  & 0.88092325E-10_JPRB, 0.88088481E-10_JPRB, 0.88085109E-10_JPRB, 0.88081750E-10_JPRB, 0.88077642E-10_JPRB, 0.88072015E-10_JPRB, &
  & 0.88064070E-10_JPRB, 0.88053384E-10_JPRB, 0.88040811E-10_JPRB, 0.88027849E-10_JPRB, 0.88015706E-10_JPRB, 0.88004631E-10_JPRB, &
  & 0.87993474E-10_JPRB, 0.87981802E-10_JPRB, 0.87964434E-10_JPRB, 0.87925285E-10_JPRB /)

RGHG9(:,73, 7) = (/ &
  & 0.87843587E-10_JPRB, 0.87914051E-10_JPRB, 0.87943909E-10_JPRB, 0.87963831E-10_JPRB, 0.87978146E-10_JPRB, 0.87990594E-10_JPRB, &
  & 0.88001509E-10_JPRB, 0.88011494E-10_JPRB, 0.88022617E-10_JPRB, 0.88031152E-10_JPRB, 0.88042684E-10_JPRB, 0.88051656E-10_JPRB, &
  & 0.88061947E-10_JPRB, 0.88070100E-10_JPRB, 0.88076241E-10_JPRB, 0.88077975E-10_JPRB, 0.88075339E-10_JPRB, 0.88065971E-10_JPRB, &
  & 0.88051955E-10_JPRB, 0.88034420E-10_JPRB, 0.88016157E-10_JPRB, 0.88001613E-10_JPRB, 0.87994834E-10_JPRB, 0.87998914E-10_JPRB, &
  & 0.88013700E-10_JPRB, 0.88037196E-10_JPRB, 0.88065694E-10_JPRB, 0.88096322E-10_JPRB, 0.88126860E-10_JPRB, 0.88155865E-10_JPRB, &
  & 0.88182572E-10_JPRB, 0.88204735E-10_JPRB, 0.88221340E-10_JPRB, 0.88232290E-10_JPRB, 0.88237785E-10_JPRB, 0.88238875E-10_JPRB, &
  & 0.88236057E-10_JPRB, 0.88229639E-10_JPRB, 0.88220084E-10_JPRB, 0.88207990E-10_JPRB, 0.88194674E-10_JPRB, 0.88181629E-10_JPRB, &
  & 0.88169826E-10_JPRB, 0.88159292E-10_JPRB, 0.88150057E-10_JPRB, 0.88142257E-10_JPRB, 0.88135853E-10_JPRB, 0.88131148E-10_JPRB, &
  & 0.88127533E-10_JPRB, 0.88124549E-10_JPRB, 0.88121975E-10_JPRB, 0.88119401E-10_JPRB, 0.88116216E-10_JPRB, 0.88111740E-10_JPRB, &
  & 0.88105134E-10_JPRB, 0.88096148E-10_JPRB, 0.88085317E-10_JPRB, 0.88074367E-10_JPRB, 0.88064174E-10_JPRB, 0.88054689E-10_JPRB, &
  & 0.88045252E-10_JPRB, 0.88034885E-10_JPRB, 0.88019779E-10_JPRB, 0.87985293E-10_JPRB /)

RGHG9(:,74, 7) = (/ &
  & 0.87900728E-10_JPRB, 0.87972546E-10_JPRB, 0.88002147E-10_JPRB, 0.88020223E-10_JPRB, 0.88034455E-10_JPRB, 0.88045696E-10_JPRB, &
  & 0.88055688E-10_JPRB, 0.88065777E-10_JPRB, 0.88073729E-10_JPRB, 0.88083651E-10_JPRB, 0.88090632E-10_JPRB, 0.88100180E-10_JPRB, &
  & 0.88107341E-10_JPRB, 0.88114210E-10_JPRB, 0.88119054E-10_JPRB, 0.88119963E-10_JPRB, 0.88117513E-10_JPRB, 0.88109318E-10_JPRB, &
  & 0.88097335E-10_JPRB, 0.88082451E-10_JPRB, 0.88067123E-10_JPRB, 0.88054695E-10_JPRB, 0.88048596E-10_JPRB, 0.88051302E-10_JPRB, &
  & 0.88062994E-10_JPRB, 0.88082167E-10_JPRB, 0.88105787E-10_JPRB, 0.88131356E-10_JPRB, 0.88156864E-10_JPRB, 0.88181053E-10_JPRB, &
  & 0.88203223E-10_JPRB, 0.88221569E-10_JPRB, 0.88235225E-10_JPRB, 0.88244134E-10_JPRB, 0.88248540E-10_JPRB, 0.88249401E-10_JPRB, &
  & 0.88247118E-10_JPRB, 0.88241928E-10_JPRB, 0.88234246E-10_JPRB, 0.88224393E-10_JPRB, 0.88213561E-10_JPRB, 0.88202917E-10_JPRB, &
  & 0.88193550E-10_JPRB, 0.88185036E-10_JPRB, 0.88177653E-10_JPRB, 0.88171428E-10_JPRB, 0.88166328E-10_JPRB, 0.88162769E-10_JPRB, &
  & 0.88160090E-10_JPRB, 0.88157801E-10_JPRB, 0.88155941E-10_JPRB, 0.88154054E-10_JPRB, 0.88151715E-10_JPRB, 0.88148336E-10_JPRB, &
  & 0.88143090E-10_JPRB, 0.88135638E-10_JPRB, 0.88126728E-10_JPRB, 0.88117652E-10_JPRB, 0.88109318E-10_JPRB, 0.88101429E-10_JPRB, &
  & 0.88093512E-10_JPRB, 0.88084630E-10_JPRB, 0.88071724E-10_JPRB, 0.88040755E-10_JPRB /)

RGHG9(:,75, 7) = (/ &
  & 0.87961548E-10_JPRB, 0.88032318E-10_JPRB, 0.88059157E-10_JPRB, 0.88075963E-10_JPRB, 0.88088183E-10_JPRB, 0.88098487E-10_JPRB, &
  & 0.88107591E-10_JPRB, 0.88115557E-10_JPRB, 0.88124161E-10_JPRB, 0.88130024E-10_JPRB, 0.88138302E-10_JPRB, 0.88143819E-10_JPRB, &
  & 0.88150355E-10_JPRB, 0.88155039E-10_JPRB, 0.88158772E-10_JPRB, 0.88159084E-10_JPRB, 0.88156760E-10_JPRB, 0.88149807E-10_JPRB, &
  & 0.88139884E-10_JPRB, 0.88127804E-10_JPRB, 0.88115154E-10_JPRB, 0.88104954E-10_JPRB, 0.88099583E-10_JPRB, 0.88101269E-10_JPRB, &
  & 0.88110123E-10_JPRB, 0.88125326E-10_JPRB, 0.88144159E-10_JPRB, 0.88164774E-10_JPRB, 0.88185369E-10_JPRB, 0.88204874E-10_JPRB, &
  & 0.88222651E-10_JPRB, 0.88237362E-10_JPRB, 0.88248207E-10_JPRB, 0.88255271E-10_JPRB, 0.88258657E-10_JPRB, 0.88259317E-10_JPRB, &
  & 0.88257471E-10_JPRB, 0.88253432E-10_JPRB, 0.88247458E-10_JPRB, 0.88239721E-10_JPRB, 0.88231214E-10_JPRB, 0.88222776E-10_JPRB, &
  & 0.88215574E-10_JPRB, 0.88208919E-10_JPRB, 0.88203209E-10_JPRB, 0.88198393E-10_JPRB, 0.88194466E-10_JPRB, 0.88191968E-10_JPRB, &
  & 0.88190066E-10_JPRB, 0.88188415E-10_JPRB, 0.88187180E-10_JPRB, 0.88185889E-10_JPRB, 0.88184238E-10_JPRB, 0.88181858E-10_JPRB, &
  & 0.88177861E-10_JPRB, 0.88171977E-10_JPRB, 0.88164760E-10_JPRB, 0.88157530E-10_JPRB, 0.88150813E-10_JPRB, 0.88144547E-10_JPRB, &
  & 0.88138011E-10_JPRB, 0.88130780E-10_JPRB, 0.88119366E-10_JPRB, 0.88092270E-10_JPRB /)

RGHG9(:,76, 7) = (/ &
  & 0.88025157E-10_JPRB, 0.88090965E-10_JPRB, 0.88114613E-10_JPRB, 0.88128387E-10_JPRB, 0.88138920E-10_JPRB, 0.88147371E-10_JPRB, &
  & 0.88154872E-10_JPRB, 0.88162366E-10_JPRB, 0.88167994E-10_JPRB, 0.88174454E-10_JPRB, 0.88178916E-10_JPRB, 0.88184612E-10_JPRB, &
  & 0.88188595E-10_JPRB, 0.88192093E-10_JPRB, 0.88194667E-10_JPRB, 0.88194757E-10_JPRB, 0.88192773E-10_JPRB, 0.88187138E-10_JPRB, &
  & 0.88179401E-10_JPRB, 0.88169999E-10_JPRB, 0.88160076E-10_JPRB, 0.88152034E-10_JPRB, 0.88147531E-10_JPRB, 0.88148516E-10_JPRB, &
  & 0.88154956E-10_JPRB, 0.88166516E-10_JPRB, 0.88180740E-10_JPRB, 0.88196596E-10_JPRB, 0.88212368E-10_JPRB, 0.88227266E-10_JPRB, &
  & 0.88240977E-10_JPRB, 0.88252204E-10_JPRB, 0.88260475E-10_JPRB, 0.88265797E-10_JPRB, 0.88268226E-10_JPRB, 0.88268684E-10_JPRB, &
  & 0.88267255E-10_JPRB, 0.88264285E-10_JPRB, 0.88259927E-10_JPRB, 0.88254098E-10_JPRB, 0.88247715E-10_JPRB, 0.88241310E-10_JPRB, &
  & 0.88236078E-10_JPRB, 0.88231110E-10_JPRB, 0.88226898E-10_JPRB, 0.88223359E-10_JPRB, 0.88220493E-10_JPRB, 0.88218904E-10_JPRB, &
  & 0.88217669E-10_JPRB, 0.88216566E-10_JPRB, 0.88215907E-10_JPRB, 0.88215019E-10_JPRB, 0.88213888E-10_JPRB, 0.88212340E-10_JPRB, &
  & 0.88209488E-10_JPRB, 0.88205138E-10_JPRB, 0.88199573E-10_JPRB, 0.88193994E-10_JPRB, 0.88189019E-10_JPRB, 0.88184023E-10_JPRB, &
  & 0.88179165E-10_JPRB, 0.88173212E-10_JPRB, 0.88164039E-10_JPRB, 0.88138864E-10_JPRB /)

RGHG9(:,77, 7) = (/ &
  & 0.88090188E-10_JPRB, 0.88147795E-10_JPRB, 0.88166807E-10_JPRB, 0.88177438E-10_JPRB, 0.88185320E-10_JPRB, 0.88191940E-10_JPRB, &
  & 0.88197595E-10_JPRB, 0.88203035E-10_JPRB, 0.88207983E-10_JPRB, 0.88211341E-10_JPRB, 0.88215914E-10_JPRB, 0.88219036E-10_JPRB, &
  & 0.88222207E-10_JPRB, 0.88224456E-10_JPRB, 0.88226232E-10_JPRB, 0.88226329E-10_JPRB, 0.88224879E-10_JPRB, 0.88220542E-10_JPRB, &
  & 0.88214984E-10_JPRB, 0.88208302E-10_JPRB, 0.88201030E-10_JPRB, 0.88195208E-10_JPRB, 0.88191773E-10_JPRB, 0.88192412E-10_JPRB, &
  & 0.88196846E-10_JPRB, 0.88205138E-10_JPRB, 0.88215123E-10_JPRB, 0.88226426E-10_JPRB, 0.88237605E-10_JPRB, 0.88248180E-10_JPRB, &
  & 0.88258019E-10_JPRB, 0.88266117E-10_JPRB, 0.88271987E-10_JPRB, 0.88275748E-10_JPRB, 0.88277281E-10_JPRB, 0.88277566E-10_JPRB, &
  & 0.88276469E-10_JPRB, 0.88274478E-10_JPRB, 0.88271598E-10_JPRB, 0.88267581E-10_JPRB, 0.88263140E-10_JPRB, 0.88258498E-10_JPRB, &
  & 0.88255091E-10_JPRB, 0.88251573E-10_JPRB, 0.88248651E-10_JPRB, 0.88246258E-10_JPRB, 0.88244301E-10_JPRB, 0.88243510E-10_JPRB, &
  & 0.88242760E-10_JPRB, 0.88242136E-10_JPRB, 0.88241872E-10_JPRB, 0.88241262E-10_JPRB, 0.88240359E-10_JPRB, 0.88239478E-10_JPRB, &
  & 0.88237660E-10_JPRB, 0.88234725E-10_JPRB, 0.88230812E-10_JPRB, 0.88226988E-10_JPRB, 0.88223581E-10_JPRB, 0.88220167E-10_JPRB, &
  & 0.88216580E-10_JPRB, 0.88212396E-10_JPRB, 0.88204624E-10_JPRB, 0.88182781E-10_JPRB /)

RGHG9(:,78, 7) = (/ &
  & 0.88155726E-10_JPRB, 0.88199836E-10_JPRB, 0.88212410E-10_JPRB, 0.88219584E-10_JPRB, 0.88225080E-10_JPRB, 0.88229396E-10_JPRB, &
  & 0.88233143E-10_JPRB, 0.88236959E-10_JPRB, 0.88239700E-10_JPRB, 0.88241942E-10_JPRB, 0.88244592E-10_JPRB, 0.88247111E-10_JPRB, &
  & 0.88249096E-10_JPRB, 0.88250650E-10_JPRB, 0.88251823E-10_JPRB, 0.88252045E-10_JPRB, 0.88251170E-10_JPRB, 0.88248020E-10_JPRB, &
  & 0.88244391E-10_JPRB, 0.88240214E-10_JPRB, 0.88235370E-10_JPRB, 0.88231727E-10_JPRB, 0.88229521E-10_JPRB, 0.88230215E-10_JPRB, &
  & 0.88233164E-10_JPRB, 0.88238909E-10_JPRB, 0.88245300E-10_JPRB, 0.88252620E-10_JPRB, 0.88259761E-10_JPRB, 0.88266491E-10_JPRB, &
  & 0.88273028E-10_JPRB, 0.88278405E-10_JPRB, 0.88282236E-10_JPRB, 0.88284657E-10_JPRB, 0.88285428E-10_JPRB, 0.88285601E-10_JPRB, &
  & 0.88284817E-10_JPRB, 0.88283679E-10_JPRB, 0.88282055E-10_JPRB, 0.88279523E-10_JPRB, 0.88276712E-10_JPRB, 0.88273604E-10_JPRB, &
  & 0.88271696E-10_JPRB, 0.88269385E-10_JPRB, 0.88267511E-10_JPRB, 0.88266006E-10_JPRB, 0.88264729E-10_JPRB, 0.88264500E-10_JPRB, &
  & 0.88264077E-10_JPRB, 0.88263695E-10_JPRB, 0.88263750E-10_JPRB, 0.88263188E-10_JPRB, 0.88262356E-10_JPRB, 0.88261877E-10_JPRB, &
  & 0.88260857E-10_JPRB, 0.88259226E-10_JPRB, 0.88256763E-10_JPRB, 0.88254577E-10_JPRB, 0.88252898E-10_JPRB, 0.88250622E-10_JPRB, &
  & 0.88248533E-10_JPRB, 0.88245682E-10_JPRB, 0.88240713E-10_JPRB, 0.88223234E-10_JPRB /)

RGHG9(:,79, 7) = (/ &
  & 0.88198518E-10_JPRB, 0.88229216E-10_JPRB, 0.88236855E-10_JPRB, 0.88241546E-10_JPRB, 0.88245723E-10_JPRB, 0.88249061E-10_JPRB, &
  & 0.88251531E-10_JPRB, 0.88254654E-10_JPRB, 0.88256367E-10_JPRB, 0.88257596E-10_JPRB, 0.88259816E-10_JPRB, 0.88261683E-10_JPRB, &
  & 0.88263154E-10_JPRB, 0.88264257E-10_JPRB, 0.88265104E-10_JPRB, 0.88265423E-10_JPRB, 0.88264882E-10_JPRB, 0.88262300E-10_JPRB, &
  & 0.88259795E-10_JPRB, 0.88256971E-10_JPRB, 0.88253446E-10_JPRB, 0.88251011E-10_JPRB, 0.88249449E-10_JPRB, 0.88250289E-10_JPRB, &
  & 0.88252544E-10_JPRB, 0.88257041E-10_JPRB, 0.88261530E-10_JPRB, 0.88266727E-10_JPRB, 0.88271737E-10_JPRB, 0.88276379E-10_JPRB, &
  & 0.88281167E-10_JPRB, 0.88285129E-10_JPRB, 0.88287849E-10_JPRB, 0.88289542E-10_JPRB, 0.88289848E-10_JPRB, 0.88289945E-10_JPRB, &
  & 0.88289306E-10_JPRB, 0.88288633E-10_JPRB, 0.88287683E-10_JPRB, 0.88285948E-10_JPRB, 0.88283998E-10_JPRB, 0.88281646E-10_JPRB, &
  & 0.88280577E-10_JPRB, 0.88278815E-10_JPRB, 0.88277469E-10_JPRB, 0.88276379E-10_JPRB, 0.88275387E-10_JPRB, 0.88275477E-10_JPRB, &
  & 0.88275165E-10_JPRB, 0.88274901E-10_JPRB, 0.88275082E-10_JPRB, 0.88274492E-10_JPRB, 0.88273618E-10_JPRB, 0.88273402E-10_JPRB, &
  & 0.88272827E-10_JPRB, 0.88271834E-10_JPRB, 0.88270058E-10_JPRB, 0.88268677E-10_JPRB, 0.88267872E-10_JPRB, 0.88266214E-10_JPRB, &
  & 0.88264777E-10_JPRB, 0.88263175E-10_JPRB, 0.88260357E-10_JPRB, 0.88248804E-10_JPRB /)

RGHG9(:,80, 7) = (/ &
  & 0.88227120E-10_JPRB, 0.88243544E-10_JPRB, 0.88247507E-10_JPRB, 0.88251045E-10_JPRB, 0.88254647E-10_JPRB, 0.88257471E-10_JPRB, &
  & 0.88259705E-10_JPRB, 0.88262155E-10_JPRB, 0.88263827E-10_JPRB, 0.88264417E-10_JPRB, 0.88266769E-10_JPRB, 0.88268157E-10_JPRB, &
  & 0.88269440E-10_JPRB, 0.88270301E-10_JPRB, 0.88270988E-10_JPRB, 0.88271376E-10_JPRB, 0.88271036E-10_JPRB, 0.88268698E-10_JPRB, &
  & 0.88266713E-10_JPRB, 0.88264597E-10_JPRB, 0.88261606E-10_JPRB, 0.88259726E-10_JPRB, 0.88258428E-10_JPRB, 0.88259365E-10_JPRB, &
  & 0.88261301E-10_JPRB, 0.88265284E-10_JPRB, 0.88268906E-10_JPRB, 0.88273167E-10_JPRB, 0.88277163E-10_JPRB, 0.88280862E-10_JPRB, &
  & 0.88284886E-10_JPRB, 0.88288224E-10_JPRB, 0.88290451E-10_JPRB, 0.88291825E-10_JPRB, 0.88291867E-10_JPRB, 0.88291915E-10_JPRB, &
  & 0.88291319E-10_JPRB, 0.88290882E-10_JPRB, 0.88290257E-10_JPRB, 0.88288869E-10_JPRB, 0.88287287E-10_JPRB, 0.88285240E-10_JPRB, &
  & 0.88284539E-10_JPRB, 0.88283013E-10_JPRB, 0.88281854E-10_JPRB, 0.88280966E-10_JPRB, 0.88280078E-10_JPRB, 0.88280341E-10_JPRB, &
  & 0.88280078E-10_JPRB, 0.88279828E-10_JPRB, 0.88280092E-10_JPRB, 0.88279460E-10_JPRB, 0.88278551E-10_JPRB, 0.88278482E-10_JPRB, &
  & 0.88278100E-10_JPRB, 0.88277392E-10_JPRB, 0.88275796E-10_JPRB, 0.88274721E-10_JPRB, 0.88274305E-10_JPRB, 0.88272813E-10_JPRB, &
  & 0.88271772E-10_JPRB, 0.88270717E-10_JPRB, 0.88269801E-10_JPRB, 0.88265381E-10_JPRB /)

RGHG9(:,81, 7) = (/ &
  & 0.88246889E-10_JPRB, 0.88249623E-10_JPRB, 0.88251989E-10_JPRB, 0.88255028E-10_JPRB, 0.88258414E-10_JPRB, 0.88261162E-10_JPRB, &
  & 0.88262904E-10_JPRB, 0.88265895E-10_JPRB, 0.88266817E-10_JPRB, 0.88267865E-10_JPRB, 0.88269364E-10_JPRB, 0.88271127E-10_JPRB, &
  & 0.88272153E-10_JPRB, 0.88272951E-10_JPRB, 0.88273569E-10_JPRB, 0.88274006E-10_JPRB, 0.88273777E-10_JPRB, 0.88271543E-10_JPRB, &
  & 0.88269822E-10_JPRB, 0.88268039E-10_JPRB, 0.88265270E-10_JPRB, 0.88263633E-10_JPRB, 0.88262384E-10_JPRB, 0.88263383E-10_JPRB, &
  & 0.88265173E-10_JPRB, 0.88268962E-10_JPRB, 0.88272216E-10_JPRB, 0.88276005E-10_JPRB, 0.88279578E-10_JPRB, 0.88282853E-10_JPRB, &
  & 0.88286552E-10_JPRB, 0.88289626E-10_JPRB, 0.88291638E-10_JPRB, 0.88292852E-10_JPRB, 0.88292769E-10_JPRB, 0.88292783E-10_JPRB, &
  & 0.88292186E-10_JPRB, 0.88291860E-10_JPRB, 0.88291374E-10_JPRB, 0.88290174E-10_JPRB, 0.88288724E-10_JPRB, 0.88286829E-10_JPRB, &
  & 0.88286281E-10_JPRB, 0.88284852E-10_JPRB, 0.88283762E-10_JPRB, 0.88282937E-10_JPRB, 0.88282111E-10_JPRB, 0.88282465E-10_JPRB, &
  & 0.88282236E-10_JPRB, 0.88281979E-10_JPRB, 0.88282298E-10_JPRB, 0.88281646E-10_JPRB, 0.88280695E-10_JPRB, 0.88280702E-10_JPRB, &
  & 0.88280418E-10_JPRB, 0.88279828E-10_JPRB, 0.88278287E-10_JPRB, 0.88277302E-10_JPRB, 0.88277066E-10_JPRB, 0.88275623E-10_JPRB, &
  & 0.88274707E-10_JPRB, 0.88273895E-10_JPRB, 0.88273749E-10_JPRB, 0.88276685E-10_JPRB /)

RGHG9(:,82, 7) = (/ &
  & 0.88248450E-10_JPRB, 0.88251656E-10_JPRB, 0.88253946E-10_JPRB, 0.88256930E-10_JPRB, 0.88260281E-10_JPRB, 0.88262841E-10_JPRB, &
  & 0.88265055E-10_JPRB, 0.88266949E-10_JPRB, 0.88268635E-10_JPRB, 0.88268962E-10_JPRB, 0.88271349E-10_JPRB, 0.88272362E-10_JPRB, &
  & 0.88273541E-10_JPRB, 0.88274242E-10_JPRB, 0.88274811E-10_JPRB, 0.88275290E-10_JPRB, 0.88275151E-10_JPRB, 0.88272945E-10_JPRB, &
  & 0.88271390E-10_JPRB, 0.88269780E-10_JPRB, 0.88267088E-10_JPRB, 0.88265596E-10_JPRB, 0.88264313E-10_JPRB, 0.88265367E-10_JPRB, &
  & 0.88267046E-10_JPRB, 0.88270849E-10_JPRB, 0.88273805E-10_JPRB, 0.88277455E-10_JPRB, 0.88280758E-10_JPRB, 0.88283811E-10_JPRB, &
  & 0.88287350E-10_JPRB, 0.88290299E-10_JPRB, 0.88292214E-10_JPRB, 0.88293373E-10_JPRB, 0.88293213E-10_JPRB, 0.88293220E-10_JPRB, &
  & 0.88292609E-10_JPRB, 0.88292346E-10_JPRB, 0.88291929E-10_JPRB, 0.88290777E-10_JPRB, 0.88289445E-10_JPRB, 0.88287627E-10_JPRB, &
  & 0.88287135E-10_JPRB, 0.88285754E-10_JPRB, 0.88284713E-10_JPRB, 0.88283894E-10_JPRB, 0.88283089E-10_JPRB, 0.88283519E-10_JPRB, &
  & 0.88283290E-10_JPRB, 0.88283034E-10_JPRB, 0.88283381E-10_JPRB, 0.88282714E-10_JPRB, 0.88281736E-10_JPRB, 0.88281805E-10_JPRB, &
  & 0.88281563E-10_JPRB, 0.88281028E-10_JPRB, 0.88279502E-10_JPRB, 0.88278565E-10_JPRB, 0.88278405E-10_JPRB, 0.88276969E-10_JPRB, &
  & 0.88276109E-10_JPRB, 0.88275297E-10_JPRB, 0.88275089E-10_JPRB, 0.88277587E-10_JPRB /)

RGHG9(:,83, 7) = (/ &
  & 0.88249560E-10_JPRB, 0.88252856E-10_JPRB, 0.88255035E-10_JPRB, 0.88257963E-10_JPRB, 0.88261266E-10_JPRB, 0.88263986E-10_JPRB, &
  & 0.88265506E-10_JPRB, 0.88268524E-10_JPRB, 0.88269211E-10_JPRB, 0.88270426E-10_JPRB, 0.88271536E-10_JPRB, 0.88273326E-10_JPRB, &
  & 0.88274221E-10_JPRB, 0.88274950E-10_JPRB, 0.88275526E-10_JPRB, 0.88276012E-10_JPRB, 0.88275887E-10_JPRB, 0.88273715E-10_JPRB, &
  & 0.88272244E-10_JPRB, 0.88270800E-10_JPRB, 0.88268143E-10_JPRB, 0.88266700E-10_JPRB, 0.88265381E-10_JPRB, 0.88266471E-10_JPRB, &
  & 0.88268136E-10_JPRB, 0.88271834E-10_JPRB, 0.88274818E-10_JPRB, 0.88278225E-10_JPRB, 0.88281465E-10_JPRB, 0.88284366E-10_JPRB, &
  & 0.88287821E-10_JPRB, 0.88290694E-10_JPRB, 0.88292554E-10_JPRB, 0.88293678E-10_JPRB, 0.88293470E-10_JPRB, 0.88293442E-10_JPRB, &
  & 0.88292859E-10_JPRB, 0.88292616E-10_JPRB, 0.88292235E-10_JPRB, 0.88291138E-10_JPRB, 0.88289813E-10_JPRB, 0.88288071E-10_JPRB, &
  & 0.88287586E-10_JPRB, 0.88286267E-10_JPRB, 0.88285212E-10_JPRB, 0.88284435E-10_JPRB, 0.88283637E-10_JPRB, 0.88284109E-10_JPRB, &
  & 0.88283887E-10_JPRB, 0.88283623E-10_JPRB, 0.88284005E-10_JPRB, 0.88283332E-10_JPRB, 0.88282319E-10_JPRB, 0.88282430E-10_JPRB, &
  & 0.88282208E-10_JPRB, 0.88281715E-10_JPRB, 0.88280175E-10_JPRB, 0.88279259E-10_JPRB, 0.88279176E-10_JPRB, 0.88277732E-10_JPRB, &
  & 0.88276893E-10_JPRB, 0.88276074E-10_JPRB, 0.88275880E-10_JPRB, 0.88278239E-10_JPRB /)

RGHG9(:,84, 7) = (/ &
  & 0.88250310E-10_JPRB, 0.88253634E-10_JPRB, 0.88255715E-10_JPRB, 0.88258623E-10_JPRB, 0.88261967E-10_JPRB, 0.88264486E-10_JPRB, &
  & 0.88266824E-10_JPRB, 0.88268372E-10_JPRB, 0.88270134E-10_JPRB, 0.88270502E-10_JPRB, 0.88272653E-10_JPRB, 0.88273562E-10_JPRB, &
  & 0.88274665E-10_JPRB, 0.88275345E-10_JPRB, 0.88275900E-10_JPRB, 0.88276400E-10_JPRB, 0.88276324E-10_JPRB, 0.88274214E-10_JPRB, &
  & 0.88272820E-10_JPRB, 0.88271425E-10_JPRB, 0.88268774E-10_JPRB, 0.88267393E-10_JPRB, 0.88266033E-10_JPRB, 0.88267185E-10_JPRB, &
  & 0.88268677E-10_JPRB, 0.88272598E-10_JPRB, 0.88275297E-10_JPRB, 0.88278808E-10_JPRB, 0.88281826E-10_JPRB, 0.88284713E-10_JPRB, &
  & 0.88288092E-10_JPRB, 0.88290930E-10_JPRB, 0.88292755E-10_JPRB, 0.88293865E-10_JPRB, 0.88293615E-10_JPRB, 0.88293574E-10_JPRB, &
  & 0.88293012E-10_JPRB, 0.88292769E-10_JPRB, 0.88292415E-10_JPRB, 0.88291346E-10_JPRB, 0.88290056E-10_JPRB, 0.88288335E-10_JPRB, &
  & 0.88287891E-10_JPRB, 0.88286572E-10_JPRB, 0.88285566E-10_JPRB, 0.88284768E-10_JPRB, 0.88284005E-10_JPRB, 0.88284463E-10_JPRB, &
  & 0.88284227E-10_JPRB, 0.88283991E-10_JPRB, 0.88284401E-10_JPRB, 0.88283728E-10_JPRB, 0.88282673E-10_JPRB, 0.88282798E-10_JPRB, &
  & 0.88282631E-10_JPRB, 0.88282166E-10_JPRB, 0.88280605E-10_JPRB, 0.88279696E-10_JPRB, 0.88279647E-10_JPRB, 0.88278204E-10_JPRB, &
  & 0.88277365E-10_JPRB, 0.88276574E-10_JPRB, 0.88276393E-10_JPRB, 0.88278676E-10_JPRB /)

RGHG9(:,85, 7) = (/ &
  & 0.88250823E-10_JPRB, 0.88254147E-10_JPRB, 0.88256139E-10_JPRB, 0.88259025E-10_JPRB, 0.88262370E-10_JPRB, 0.88265215E-10_JPRB, &
  & 0.88266588E-10_JPRB, 0.88269621E-10_JPRB, 0.88270231E-10_JPRB, 0.88271557E-10_JPRB, 0.88272473E-10_JPRB, 0.88273971E-10_JPRB, &
  & 0.88274832E-10_JPRB, 0.88275540E-10_JPRB, 0.88276102E-10_JPRB, 0.88276567E-10_JPRB, 0.88276497E-10_JPRB, 0.88274582E-10_JPRB, &
  & 0.88273229E-10_JPRB, 0.88271862E-10_JPRB, 0.88269198E-10_JPRB, 0.88267865E-10_JPRB, 0.88266450E-10_JPRB, 0.88267629E-10_JPRB, &
  & 0.88269149E-10_JPRB, 0.88272917E-10_JPRB, 0.88275776E-10_JPRB, 0.88279051E-10_JPRB, 0.88282152E-10_JPRB, 0.88284921E-10_JPRB, &
  & 0.88288300E-10_JPRB, 0.88291097E-10_JPRB, 0.88292915E-10_JPRB, 0.88293997E-10_JPRB, 0.88293726E-10_JPRB, 0.88293671E-10_JPRB, &
  & 0.88293088E-10_JPRB, 0.88292894E-10_JPRB, 0.88292540E-10_JPRB, 0.88291485E-10_JPRB, 0.88290229E-10_JPRB, 0.88288522E-10_JPRB, &
  & 0.88288057E-10_JPRB, 0.88286801E-10_JPRB, 0.88285726E-10_JPRB, 0.88284990E-10_JPRB, 0.88284248E-10_JPRB, 0.88284699E-10_JPRB, &
  & 0.88284456E-10_JPRB, 0.88284248E-10_JPRB, 0.88284650E-10_JPRB, 0.88283991E-10_JPRB, 0.88282916E-10_JPRB, 0.88283061E-10_JPRB, &
  & 0.88282902E-10_JPRB, 0.88282472E-10_JPRB, 0.88280876E-10_JPRB, 0.88279981E-10_JPRB, 0.88279967E-10_JPRB, 0.88278523E-10_JPRB, &
  & 0.88277691E-10_JPRB, 0.88276907E-10_JPRB, 0.88276726E-10_JPRB, 0.88278988E-10_JPRB /)

RGHG9(:,86, 7) = (/ &
  & 0.88251143E-10_JPRB, 0.88254466E-10_JPRB, 0.88256381E-10_JPRB, 0.88259303E-10_JPRB, 0.88262911E-10_JPRB, 0.88265173E-10_JPRB, &
  & 0.88267983E-10_JPRB, 0.88269163E-10_JPRB, 0.88270995E-10_JPRB, 0.88271487E-10_JPRB, 0.88273139E-10_JPRB, 0.88273985E-10_JPRB, &
  & 0.88274922E-10_JPRB, 0.88275574E-10_JPRB, 0.88276116E-10_JPRB, 0.88276518E-10_JPRB, 0.88276442E-10_JPRB, 0.88274887E-10_JPRB, &
  & 0.88273527E-10_JPRB, 0.88272167E-10_JPRB, 0.88269510E-10_JPRB, 0.88268177E-10_JPRB, 0.88266727E-10_JPRB, 0.88267928E-10_JPRB, &
  & 0.88269309E-10_JPRB, 0.88273305E-10_JPRB, 0.88275880E-10_JPRB, 0.88279342E-10_JPRB, 0.88282270E-10_JPRB, 0.88285081E-10_JPRB, &
  & 0.88288446E-10_JPRB, 0.88291222E-10_JPRB, 0.88293033E-10_JPRB, 0.88294094E-10_JPRB, 0.88293789E-10_JPRB, 0.88293740E-10_JPRB, &
  & 0.88293158E-10_JPRB, 0.88292970E-10_JPRB, 0.88292651E-10_JPRB, 0.88291603E-10_JPRB, 0.88290326E-10_JPRB, 0.88288585E-10_JPRB, &
  & 0.88288196E-10_JPRB, 0.88286878E-10_JPRB, 0.88285892E-10_JPRB, 0.88285115E-10_JPRB, 0.88284435E-10_JPRB, 0.88284838E-10_JPRB, &
  & 0.88284616E-10_JPRB, 0.88284408E-10_JPRB, 0.88284768E-10_JPRB, 0.88284158E-10_JPRB, 0.88283082E-10_JPRB, 0.88283221E-10_JPRB, &
  & 0.88283096E-10_JPRB, 0.88282666E-10_JPRB, 0.88281063E-10_JPRB, 0.88280168E-10_JPRB, 0.88280175E-10_JPRB, 0.88278732E-10_JPRB, &
  & 0.88277892E-10_JPRB, 0.88277108E-10_JPRB, 0.88276955E-10_JPRB, 0.88279183E-10_JPRB /)

RGHG9(:,87, 7) = (/ &
  & 0.88251399E-10_JPRB, 0.88254688E-10_JPRB, 0.88256562E-10_JPRB, 0.88259594E-10_JPRB, 0.88262751E-10_JPRB, 0.88266186E-10_JPRB, &
  & 0.88267352E-10_JPRB, 0.88270335E-10_JPRB, 0.88270960E-10_JPRB, 0.88272223E-10_JPRB, 0.88273028E-10_JPRB, 0.88274145E-10_JPRB, &
  & 0.88274887E-10_JPRB, 0.88275526E-10_JPRB, 0.88276025E-10_JPRB, 0.88276400E-10_JPRB, 0.88276345E-10_JPRB, 0.88275005E-10_JPRB, &
  & 0.88273756E-10_JPRB, 0.88272348E-10_JPRB, 0.88269753E-10_JPRB, 0.88268386E-10_JPRB, 0.88266915E-10_JPRB, 0.88268115E-10_JPRB, &
  & 0.88269496E-10_JPRB, 0.88273375E-10_JPRB, 0.88276046E-10_JPRB, 0.88279391E-10_JPRB, 0.88282395E-10_JPRB, 0.88285157E-10_JPRB, &
  & 0.88288557E-10_JPRB, 0.88291340E-10_JPRB, 0.88293109E-10_JPRB, 0.88294171E-10_JPRB, 0.88293824E-10_JPRB, 0.88293761E-10_JPRB, &
  & 0.88293178E-10_JPRB, 0.88293026E-10_JPRB, 0.88292748E-10_JPRB, 0.88291686E-10_JPRB, 0.88290431E-10_JPRB, 0.88288592E-10_JPRB, &
  & 0.88288273E-10_JPRB, 0.88286954E-10_JPRB, 0.88285934E-10_JPRB, 0.88285212E-10_JPRB, 0.88284560E-10_JPRB, 0.88284900E-10_JPRB, &
  & 0.88284699E-10_JPRB, 0.88284532E-10_JPRB, 0.88284852E-10_JPRB, 0.88284255E-10_JPRB, 0.88283214E-10_JPRB, 0.88283332E-10_JPRB, &
  & 0.88283235E-10_JPRB, 0.88282825E-10_JPRB, 0.88281181E-10_JPRB, 0.88280272E-10_JPRB, 0.88280293E-10_JPRB, 0.88278843E-10_JPRB, &
  & 0.88278010E-10_JPRB, 0.88277254E-10_JPRB, 0.88277087E-10_JPRB, 0.88279314E-10_JPRB /)

RGHG9(:,88, 7) = (/ &
  & 0.88251684E-10_JPRB, 0.88254903E-10_JPRB, 0.88256707E-10_JPRB, 0.88259525E-10_JPRB, 0.88263452E-10_JPRB, 0.88265555E-10_JPRB, &
  & 0.88268649E-10_JPRB, 0.88269760E-10_JPRB, 0.88271418E-10_JPRB, 0.88271987E-10_JPRB, 0.88273333E-10_JPRB, 0.88274117E-10_JPRB, &
  & 0.88274929E-10_JPRB, 0.88275526E-10_JPRB, 0.88276005E-10_JPRB, 0.88276352E-10_JPRB, 0.88276289E-10_JPRB, 0.88275103E-10_JPRB, &
  & 0.88273854E-10_JPRB, 0.88272507E-10_JPRB, 0.88269836E-10_JPRB, 0.88268517E-10_JPRB, 0.88267026E-10_JPRB, 0.88268212E-10_JPRB, &
  & 0.88269538E-10_JPRB, 0.88273513E-10_JPRB, 0.88276074E-10_JPRB, 0.88279481E-10_JPRB, 0.88282423E-10_JPRB, 0.88285199E-10_JPRB, &
  & 0.88288613E-10_JPRB, 0.88291388E-10_JPRB, 0.88293178E-10_JPRB, 0.88294240E-10_JPRB, 0.88293872E-10_JPRB, 0.88293789E-10_JPRB, &
  & 0.88293192E-10_JPRB, 0.88293060E-10_JPRB, 0.88292852E-10_JPRB, 0.88291777E-10_JPRB, 0.88290486E-10_JPRB, 0.88288543E-10_JPRB, &
  & 0.88288356E-10_JPRB, 0.88286940E-10_JPRB, 0.88285962E-10_JPRB, 0.88285247E-10_JPRB, 0.88284630E-10_JPRB, 0.88284935E-10_JPRB, &
  & 0.88284741E-10_JPRB, 0.88284602E-10_JPRB, 0.88284879E-10_JPRB, 0.88284303E-10_JPRB, 0.88283297E-10_JPRB, 0.88283408E-10_JPRB, &
  & 0.88283311E-10_JPRB, 0.88282895E-10_JPRB, 0.88281236E-10_JPRB, 0.88280348E-10_JPRB, 0.88280390E-10_JPRB, 0.88278912E-10_JPRB, &
  & 0.88278086E-10_JPRB, 0.88277302E-10_JPRB, 0.88277156E-10_JPRB, 0.88279412E-10_JPRB /)

RGHG9(:,89, 7) = (/ &
  & 0.88252058E-10_JPRB, 0.88255084E-10_JPRB, 0.88256791E-10_JPRB, 0.88259608E-10_JPRB, 0.88262876E-10_JPRB, 0.88266339E-10_JPRB, &
  & 0.88267685E-10_JPRB, 0.88270419E-10_JPRB, 0.88271133E-10_JPRB, 0.88272230E-10_JPRB, 0.88273125E-10_JPRB, 0.88274207E-10_JPRB, &
  & 0.88274978E-10_JPRB, 0.88275609E-10_JPRB, 0.88276095E-10_JPRB, 0.88276490E-10_JPRB, 0.88276442E-10_JPRB, 0.88275089E-10_JPRB, &
  & 0.88273888E-10_JPRB, 0.88272507E-10_JPRB, 0.88269871E-10_JPRB, 0.88268559E-10_JPRB, 0.88267060E-10_JPRB, 0.88268268E-10_JPRB, &
  & 0.88269586E-10_JPRB, 0.88273576E-10_JPRB, 0.88276102E-10_JPRB, 0.88279502E-10_JPRB, 0.88282451E-10_JPRB, 0.88285212E-10_JPRB, &
  & 0.88288668E-10_JPRB, 0.88291444E-10_JPRB, 0.88293234E-10_JPRB, 0.88294323E-10_JPRB, 0.88293900E-10_JPRB, 0.88293789E-10_JPRB, &
  & 0.88293192E-10_JPRB, 0.88293088E-10_JPRB, 0.88292915E-10_JPRB, 0.88291825E-10_JPRB, 0.88290548E-10_JPRB, 0.88288474E-10_JPRB, &
  & 0.88288404E-10_JPRB, 0.88286947E-10_JPRB, 0.88285955E-10_JPRB, 0.88285254E-10_JPRB, 0.88284650E-10_JPRB, 0.88284956E-10_JPRB, &
  & 0.88284782E-10_JPRB, 0.88284643E-10_JPRB, 0.88284900E-10_JPRB, 0.88284338E-10_JPRB, 0.88283360E-10_JPRB, 0.88283443E-10_JPRB, &
  & 0.88283367E-10_JPRB, 0.88282957E-10_JPRB, 0.88281285E-10_JPRB, 0.88280390E-10_JPRB, 0.88280439E-10_JPRB, 0.88278947E-10_JPRB, &
  & 0.88278128E-10_JPRB, 0.88277344E-10_JPRB, 0.88277177E-10_JPRB, 0.88279474E-10_JPRB /)

RGHG9(:,90, 7) = (/ &
  & 0.88252343E-10_JPRB, 0.88255230E-10_JPRB, 0.88256666E-10_JPRB, 0.88259372E-10_JPRB, 0.88263043E-10_JPRB, 0.88265534E-10_JPRB, &
  & 0.88268129E-10_JPRB, 0.88269711E-10_JPRB, 0.88271147E-10_JPRB, 0.88271737E-10_JPRB, 0.88273229E-10_JPRB, 0.88274263E-10_JPRB, &
  & 0.88275179E-10_JPRB, 0.88275817E-10_JPRB, 0.88276331E-10_JPRB, 0.88276768E-10_JPRB, 0.88276733E-10_JPRB, 0.88275096E-10_JPRB, &
  & 0.88273812E-10_JPRB, 0.88272563E-10_JPRB, 0.88269787E-10_JPRB, 0.88268573E-10_JPRB, 0.88267019E-10_JPRB, 0.88268289E-10_JPRB, &
  & 0.88269524E-10_JPRB, 0.88273618E-10_JPRB, 0.88276095E-10_JPRB, 0.88279543E-10_JPRB, 0.88282437E-10_JPRB, 0.88285178E-10_JPRB, &
  & 0.88288696E-10_JPRB, 0.88291513E-10_JPRB, 0.88293296E-10_JPRB, 0.88294400E-10_JPRB, 0.88293886E-10_JPRB, 0.88293803E-10_JPRB, &
  & 0.88293178E-10_JPRB, 0.88293095E-10_JPRB, 0.88292984E-10_JPRB, 0.88291846E-10_JPRB, 0.88290590E-10_JPRB, 0.88288384E-10_JPRB, &
  & 0.88288515E-10_JPRB, 0.88286933E-10_JPRB, 0.88285934E-10_JPRB, 0.88285240E-10_JPRB, 0.88284588E-10_JPRB, 0.88284963E-10_JPRB, &
  & 0.88284782E-10_JPRB, 0.88284630E-10_JPRB, 0.88284928E-10_JPRB, 0.88284373E-10_JPRB, 0.88283353E-10_JPRB, 0.88283478E-10_JPRB, &
  & 0.88283408E-10_JPRB, 0.88283027E-10_JPRB, 0.88281278E-10_JPRB, 0.88280362E-10_JPRB, 0.88280494E-10_JPRB, 0.88278947E-10_JPRB, &
  & 0.88278135E-10_JPRB, 0.88277344E-10_JPRB, 0.88277177E-10_JPRB, 0.88279509E-10_JPRB /)

RGHG9(:,91, 7) = (/ &
  & 0.88252072E-10_JPRB, 0.88255223E-10_JPRB, 0.88255993E-10_JPRB, 0.88259351E-10_JPRB, 0.88262814E-10_JPRB, 0.88265353E-10_JPRB, &
  & 0.88266713E-10_JPRB, 0.88269857E-10_JPRB, 0.88270849E-10_JPRB, 0.88270835E-10_JPRB, 0.88273520E-10_JPRB, 0.88274762E-10_JPRB, &
  & 0.88275588E-10_JPRB, 0.88276067E-10_JPRB, 0.88276497E-10_JPRB, 0.88277191E-10_JPRB, 0.88277434E-10_JPRB, 0.88274756E-10_JPRB, &
  & 0.88273708E-10_JPRB, 0.88272646E-10_JPRB, 0.88269642E-10_JPRB, 0.88268601E-10_JPRB, 0.88266824E-10_JPRB, 0.88268282E-10_JPRB, &
  & 0.88269336E-10_JPRB, 0.88273736E-10_JPRB, 0.88276039E-10_JPRB, 0.88279564E-10_JPRB, 0.88282409E-10_JPRB, 0.88285046E-10_JPRB, &
  & 0.88288814E-10_JPRB, 0.88291569E-10_JPRB, 0.88293393E-10_JPRB, 0.88294566E-10_JPRB, 0.88293858E-10_JPRB, 0.88293858E-10_JPRB, &
  & 0.88293151E-10_JPRB, 0.88293109E-10_JPRB, 0.88293060E-10_JPRB, 0.88291874E-10_JPRB, 0.88290673E-10_JPRB, 0.88288182E-10_JPRB, &
  & 0.88288779E-10_JPRB, 0.88286878E-10_JPRB, 0.88285872E-10_JPRB, 0.88285261E-10_JPRB, 0.88284366E-10_JPRB, 0.88285081E-10_JPRB, &
  & 0.88284810E-10_JPRB, 0.88284595E-10_JPRB, 0.88285067E-10_JPRB, 0.88284428E-10_JPRB, 0.88283179E-10_JPRB, 0.88283499E-10_JPRB, &
  & 0.88283443E-10_JPRB, 0.88283117E-10_JPRB, 0.88281216E-10_JPRB, 0.88280307E-10_JPRB, 0.88280598E-10_JPRB, 0.88278891E-10_JPRB, &
  & 0.88278128E-10_JPRB, 0.88277295E-10_JPRB, 0.88277149E-10_JPRB, 0.88279578E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART14',1,ZHOOK_HANDLE)
END SUBROUTINE PART14






SUBROUTINE PART15
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART15',0,ZHOOK_HANDLE)



!-- Month=  8 ------------

RGHG9(:, 1, 8) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.42038954E-44_JPRB, &
  & 0.56051939E-44_JPRB, 0.98090893E-44_JPRB, 0.14012985E-43_JPRB, 0.19618179E-43_JPRB, 0.26624671E-43_JPRB, 0.35032462E-43_JPRB, &
  & 0.39236357E-43_JPRB, 0.50446745E-43_JPRB, 0.44841551E-43_JPRB, 0.49045446E-43_JPRB, 0.36433760E-43_JPRB, 0.37835059E-43_JPRB, &
  & 0.22420775E-43_JPRB, 0.15414283E-43_JPRB, 0.70064923E-44_JPRB, 0.42038954E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 2, 8) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.42038954E-44_JPRB, &
  & 0.84077908E-44_JPRB, 0.15414283E-43_JPRB, 0.29427268E-43_JPRB, 0.51848043E-43_JPRB, 0.88281803E-43_JPRB, 0.14853764E-42_JPRB, &
  & 0.23822074E-42_JPRB, 0.37134409E-42_JPRB, 0.55631549E-42_JPRB, 0.78052324E-42_JPRB, 0.10635855E-41_JPRB, 0.13746738E-41_JPRB, &
  & 0.15834673E-41_JPRB, 0.19772321E-41_JPRB, 0.18090763E-41_JPRB, 0.18721347E-41_JPRB, 0.14951855E-41_JPRB, 0.14307257E-41_JPRB, &
  & 0.92485699E-42_JPRB, 0.60956483E-42_JPRB, 0.32089735E-42_JPRB, 0.18777399E-42_JPRB, 0.10229479E-42_JPRB, 0.53249342E-43_JPRB, &
  & 0.26624671E-43_JPRB, 0.12611686E-43_JPRB, 0.56051939E-44_JPRB, 0.28025969E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 3, 8) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, &
  & 0.42038954E-44_JPRB, 0.98090893E-44_JPRB, 0.22420775E-43_JPRB, 0.49045446E-43_JPRB, 0.10509738E-42_JPRB, 0.21439867E-42_JPRB, &
  & 0.41898824E-42_JPRB, 0.78472714E-42_JPRB, 0.14195153E-41_JPRB, 0.24915087E-41_JPRB, 0.42487369E-41_JPRB, 0.70541365E-41_JPRB, &
  & 0.11340708E-40_JPRB, 0.17573684E-40_JPRB, 0.26350016E-40_JPRB, 0.36988674E-40_JPRB, 0.50258971E-40_JPRB, 0.64884323E-40_JPRB, &
  & 0.75220300E-40_JPRB, 0.93246604E-40_JPRB, 0.86298966E-40_JPRB, 0.88689581E-40_JPRB, 0.71646989E-40_JPRB, 0.67506152E-40_JPRB, &
  & 0.44395938E-40_JPRB, 0.29299750E-40_JPRB, 0.15808048E-40_JPRB, 0.92667867E-41_JPRB, 0.49774121E-41_JPRB, 0.24915087E-41_JPRB, &
  & 0.12121232E-41_JPRB, 0.55491419E-42_JPRB, 0.23541814E-42_JPRB, 0.91084400E-43_JPRB, 0.33631163E-43_JPRB, 0.11210388E-43_JPRB, &
  & 0.42038954E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 4, 8) = (/ &
  & 0.98090893E-44_JPRB, 0.18216880E-43_JPRB, 0.25223372E-43_JPRB, 0.26624671E-43_JPRB, 0.23822074E-43_JPRB, 0.22420775E-43_JPRB, &
  & 0.21019477E-43_JPRB, 0.22420775E-43_JPRB, 0.28025969E-43_JPRB, 0.44841551E-43_JPRB, 0.82676609E-43_JPRB, 0.17235971E-42_JPRB, &
  & 0.38675838E-42_JPRB, 0.89122582E-42_JPRB, 0.20444945E-41_JPRB, 0.45584239E-41_JPRB, 0.97600438E-41_JPRB, 0.19934872E-40_JPRB, &
  & 0.38838388E-40_JPRB, 0.72417703E-40_JPRB, 0.13002648E-39_JPRB, 0.22611212E-39_JPRB, 0.38132274E-39_JPRB, 0.62842070E-39_JPRB, &
  & 0.10031587E-38_JPRB, 0.15508030E-38_JPRB, 0.23158181E-38_JPRB, 0.32450920E-38_JPRB, 0.43996484E-38_JPRB, 0.56807855E-38_JPRB, &
  & 0.65950613E-38_JPRB, 0.81819113E-38_JPRB, 0.75891354E-38_JPRB, 0.78161500E-38_JPRB, 0.63239647E-38_JPRB, 0.59660632E-38_JPRB, &
  & 0.39377902E-38_JPRB, 0.26051582E-38_JPRB, 0.14235721E-38_JPRB, 0.84053525E-39_JPRB, 0.45235035E-39_JPRB, 0.22168822E-39_JPRB, &
  & 0.10501611E-39_JPRB, 0.46685660E-40_JPRB, 0.19260847E-40_JPRB, 0.73974546E-41_JPRB, 0.27549528E-41_JPRB, 0.95708685E-42_JPRB, &
  & 0.32930514E-42_JPRB, 0.12751816E-42_JPRB, 0.56051939E-43_JPRB, 0.26624671E-43_JPRB, 0.14012985E-43_JPRB, 0.70064923E-44_JPRB, &
  & 0.42038954E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 5, 8) = (/ &
  & 0.30226008E-41_JPRB, 0.57873627E-41_JPRB, 0.66954041E-41_JPRB, 0.63506846E-41_JPRB, 0.56794627E-41_JPRB, 0.50460758E-41_JPRB, &
  & 0.47602109E-41_JPRB, 0.50250563E-41_JPRB, 0.62581989E-41_JPRB, 0.94671724E-41_JPRB, 0.17171511E-40_JPRB, 0.35618204E-40_JPRB, &
  & 0.79924459E-40_JPRB, 0.18474859E-39_JPRB, 0.42443229E-39_JPRB, 0.94456345E-39_JPRB, 0.20089743E-38_JPRB, 0.40544651E-38_JPRB, &
  & 0.77692527E-38_JPRB, 0.14197932E-37_JPRB, 0.24933404E-37_JPRB, 0.42373730E-37_JPRB, 0.69938279E-37_JPRB, 0.11282439E-36_JPRB, &
  & 0.17715067E-36_JPRB, 0.26954319E-36_JPRB, 0.39812943E-36_JPRB, 0.55287260E-36_JPRB, 0.74578584E-36_JPRB, 0.95995034E-36_JPRB, &
  & 0.11131956E-35_JPRB, 0.13829018E-35_JPRB, 0.12837753E-35_JPRB, 0.13301561E-35_JPRB, 0.10786866E-35_JPRB, 0.10308242E-35_JPRB, &
  & 0.68155350E-36_JPRB, 0.45663541E-36_JPRB, 0.25205622E-36_JPRB, 0.15203436E-36_JPRB, 0.82940597E-37_JPRB, 0.41036050E-37_JPRB, &
  & 0.19497290E-37_JPRB, 0.87012465E-38_JPRB, 0.36249321E-38_JPRB, 0.14183929E-38_JPRB, 0.54359030E-39_JPRB, 0.19538164E-39_JPRB, &
  & 0.68910253E-40_JPRB, 0.27001620E-40_JPRB, 0.12278177E-40_JPRB, 0.60970496E-41_JPRB, 0.31683358E-41_JPRB, 0.17404127E-41_JPRB, &
  & 0.10187440E-41_JPRB, 0.64880119E-42_JPRB, 0.45682330E-42_JPRB, 0.35032462E-42_JPRB, 0.31809475E-42_JPRB, 0.36573890E-42_JPRB, &
  & 0.46943499E-42_JPRB, 0.61376873E-42_JPRB, 0.83237129E-42_JPRB, 0.10789998E-41_JPRB /)

RGHG9(:, 6, 8) = (/ &
  & 0.27165124E-38_JPRB, 0.36646113E-38_JPRB, 0.37379146E-38_JPRB, 0.34631774E-38_JPRB, 0.30835096E-38_JPRB, 0.27228336E-38_JPRB, &
  & 0.25307394E-38_JPRB, 0.26092177E-38_JPRB, 0.31442363E-38_JPRB, 0.45642701E-38_JPRB, 0.79223922E-38_JPRB, 0.15737476E-37_JPRB, &
  & 0.33926114E-37_JPRB, 0.75584105E-37_JPRB, 0.16757172E-36_JPRB, 0.35979049E-36_JPRB, 0.73712999E-36_JPRB, 0.14302252E-35_JPRB, &
  & 0.26314224E-35_JPRB, 0.46163401E-35_JPRB, 0.77901296E-35_JPRB, 0.12745450E-34_JPRB, 0.20292069E-34_JPRB, 0.31679490E-34_JPRB, &
  & 0.48219037E-34_JPRB, 0.71471893E-34_JPRB, 0.10313517E-33_JPRB, 0.14076470E-33_JPRB, 0.18733300E-33_JPRB, 0.23916631E-33_JPRB, &
  & 0.27585599E-33_JPRB, 0.34244967E-33_JPRB, 0.31828408E-33_JPRB, 0.33241745E-33_JPRB, 0.27189148E-33_JPRB, 0.26501307E-33_JPRB, &
  & 0.17739572E-33_JPRB, 0.12134947E-33_JPRB, 0.68380429E-34_JPRB, 0.42588686E-34_JPRB, 0.24080401E-34_JPRB, 0.12310270E-34_JPRB, &
  & 0.60906435E-35_JPRB, 0.28329572E-35_JPRB, 0.12331322E-35_JPRB, 0.50646012E-36_JPRB, 0.20408627E-36_JPRB, 0.76962395E-37_JPRB, &
  & 0.28431286E-37_JPRB, 0.11619288E-37_JPRB, 0.55002002E-38_JPRB, 0.28355316E-38_JPRB, 0.15236949E-38_JPRB, 0.86284392E-39_JPRB, &
  & 0.51850846E-39_JPRB, 0.33755458E-39_JPRB, 0.24254795E-39_JPRB, 0.18837795E-39_JPRB, 0.17241296E-39_JPRB, 0.19918617E-39_JPRB, &
  & 0.25548053E-39_JPRB, 0.33388318E-39_JPRB, 0.48456060E-39_JPRB, 0.69167672E-39_JPRB /)

RGHG9(:, 7, 8) = (/ &
  & 0.23013211E-35_JPRB, 0.28635841E-35_JPRB, 0.28639812E-35_JPRB, 0.26526052E-35_JPRB, 0.23541540E-35_JPRB, 0.20527407E-35_JPRB, &
  & 0.18623507E-35_JPRB, 0.18501391E-35_JPRB, 0.21217382E-35_JPRB, 0.29010030E-35_JPRB, 0.47080235E-35_JPRB, 0.87171803E-35_JPRB, &
  & 0.17528245E-34_JPRB, 0.36512180E-34_JPRB, 0.75990854E-34_JPRB, 0.15362777E-33_JPRB, 0.29714573E-33_JPRB, 0.54538043E-33_JPRB, &
  & 0.95118652E-33_JPRB, 0.15860029E-32_JPRB, 0.25522352E-32_JPRB, 0.39969221E-32_JPRB, 0.61132770E-32_JPRB, 0.91960231E-32_JPRB, &
  & 0.13533878E-31_JPRB, 0.19446115E-31_JPRB, 0.27323076E-31_JPRB, 0.36478784E-31_JPRB, 0.47743905E-31_JPRB, 0.60239090E-31_JPRB, &
  & 0.69054580E-31_JPRB, 0.85478658E-31_JPRB, 0.79678228E-31_JPRB, 0.83898882E-31_JPRB, 0.69414187E-31_JPRB, 0.69210551E-31_JPRB, &
  & 0.47076221E-31_JPRB, 0.33089117E-31_JPRB, 0.19045982E-31_JPRB, 0.12361754E-31_JPRB, 0.72659752E-32_JPRB, 0.38968170E-32_JPRB, &
  & 0.20307008E-32_JPRB, 0.99996292E-33_JPRB, 0.46213922E-33_JPRB, 0.20181094E-33_JPRB, 0.86680816E-34_JPRB, 0.34852644E-34_JPRB, &
  & 0.13726987E-34_JPRB, 0.59910536E-35_JPRB, 0.30290335E-35_JPRB, 0.16603173E-35_JPRB, 0.94409356E-36_JPRB, 0.56299141E-36_JPRB, &
  & 0.35446291E-36_JPRB, 0.24032939E-36_JPRB, 0.17878354E-36_JPRB, 0.14276839E-36_JPRB, 0.13345810E-36_JPRB, 0.15588349E-36_JPRB, &
  & 0.19987581E-36_JPRB, 0.26053008E-36_JPRB, 0.38167738E-36_JPRB, 0.61930177E-36_JPRB /)

RGHG9(:, 8, 8) = (/ &
  & 0.16361339E-32_JPRB, 0.20105986E-32_JPRB, 0.20090778E-32_JPRB, 0.18634111E-32_JPRB, 0.16494798E-32_JPRB, 0.14207864E-32_JPRB, &
  & 0.12581547E-32_JPRB, 0.12046692E-32_JPRB, 0.13158537E-32_JPRB, 0.16963954E-32_JPRB, 0.25759691E-32_JPRB, 0.44408369E-32_JPRB, &
  & 0.82910085E-32_JPRB, 0.16046753E-31_JPRB, 0.31093988E-31_JPRB, 0.58761523E-31_JPRB, 0.10671850E-30_JPRB, 0.18464701E-30_JPRB, &
  & 0.30474305E-30_JPRB, 0.48258604E-30_JPRB, 0.74038168E-30_JPRB, 0.11098243E-29_JPRB, 0.16306544E-29_JPRB, 0.23645981E-29_JPRB, &
  & 0.33631326E-29_JPRB, 0.46845914E-29_JPRB, 0.64025066E-29_JPRB, 0.83539581E-29_JPRB, 0.10740536E-28_JPRB, 0.13387700E-28_JPRB, &
  & 0.15250731E-28_JPRB, 0.18831173E-28_JPRB, 0.17619013E-28_JPRB, 0.18711308E-28_JPRB, 0.15679947E-28_JPRB, 0.15988979E-28_JPRB, &
  & 0.11074308E-28_JPRB, 0.80095981E-29_JPRB, 0.47200123E-29_JPRB, 0.31935578E-29_JPRB, 0.19594381E-29_JPRB, 0.10997222E-29_JPRB, &
  & 0.60571418E-30_JPRB, 0.31570221E-30_JPRB, 0.15466741E-30_JPRB, 0.71821488E-31_JPRB, 0.32904849E-31_JPRB, 0.14122595E-31_JPRB, &
  & 0.59567431E-32_JPRB, 0.27983319E-32_JPRB, 0.15231718E-32_JPRB, 0.89401332E-33_JPRB, 0.54094101E-33_JPRB, 0.34151470E-33_JPRB, &
  & 0.22627568E-33_JPRB, 0.16048655E-33_JPRB, 0.12406456E-33_JPRB, 0.10225980E-33_JPRB, 0.97971037E-34_JPRB, 0.11641462E-33_JPRB, &
  & 0.15057790E-33_JPRB, 0.19658986E-33_JPRB, 0.29165647E-33_JPRB, 0.48876376E-33_JPRB /)

RGHG9(:, 9, 8) = (/ &
  & 0.95020343E-30_JPRB, 0.11611511E-29_JPRB, 0.11611044E-29_JPRB, 0.10797135E-29_JPRB, 0.95509612E-30_JPRB, 0.81669793E-30_JPRB, &
  & 0.71017632E-30_JPRB, 0.66035751E-30_JPRB, 0.69291607E-30_JPRB, 0.84990668E-30_JPRB, 0.12185168E-29_JPRB, 0.19698376E-29_JPRB, &
  & 0.34329193E-29_JPRB, 0.61830333E-29_JPRB, 0.11155743E-28_JPRB, 0.19679450E-28_JPRB, 0.33520263E-28_JPRB, 0.54669044E-28_JPRB, &
  & 0.85440090E-28_JPRB, 0.12860397E-27_JPRB, 0.18818948E-27_JPRB, 0.26997443E-27_JPRB, 0.38061932E-27_JPRB, 0.53135319E-27_JPRB, &
  & 0.72929536E-27_JPRB, 0.98296133E-27_JPRB, 0.13054710E-26_JPRB, 0.16623751E-26_JPRB, 0.20978067E-26_JPRB, 0.25818624E-26_JPRB, &
  & 0.29216581E-26_JPRB, 0.36004767E-26_JPRB, 0.33826868E-26_JPRB, 0.36258482E-26_JPRB, 0.30812840E-26_JPRB, 0.32108490E-26_JPRB, &
  & 0.22709678E-26_JPRB, 0.16918626E-26_JPRB, 0.10252929E-26_JPRB, 0.72425794E-27_JPRB, 0.46381449E-27_JPRB, 0.27342986E-27_JPRB, &
  & 0.15885813E-27_JPRB, 0.87569206E-28_JPRB, 0.45453650E-28_JPRB, 0.22394283E-28_JPRB, 0.10939573E-28_JPRB, 0.50105253E-29_JPRB, &
  & 0.22629043E-29_JPRB, 0.11463323E-29_JPRB, 0.67264142E-30_JPRB, 0.42273401E-30_JPRB, 0.27206871E-30_JPRB, 0.18166385E-30_JPRB, &
  & 0.12656390E-30_JPRB, 0.93773687E-31_JPRB, 0.75244939E-31_JPRB, 0.63926751E-31_JPRB, 0.62746249E-31_JPRB, 0.75860422E-31_JPRB, &
  & 0.99185181E-31_JPRB, 0.13050037E-30_JPRB, 0.19511052E-30_JPRB, 0.33242367E-30_JPRB /)

RGHG9(:,10, 8) = (/ &
  & 0.44783168E-27_JPRB, 0.54211895E-27_JPRB, 0.54316131E-27_JPRB, 0.50723987E-27_JPRB, 0.44880620E-27_JPRB, 0.38251345E-27_JPRB, &
  & 0.32879228E-27_JPRB, 0.29931580E-27_JPRB, 0.30443572E-27_JPRB, 0.35861803E-27_JPRB, 0.48956821E-27_JPRB, 0.74793393E-27_JPRB, &
  & 0.12240977E-26_JPRB, 0.20621236E-26_JPRB, 0.34736030E-26_JPRB, 0.57281355E-26_JPRB, 0.91564834E-26_JPRB, 0.14083512E-25_JPRB, &
  & 0.20853597E-25_JPRB, 0.29852004E-25_JPRB, 0.41664246E-25_JPRB, 0.57141830E-25_JPRB, 0.77180265E-25_JPRB, 0.10343924E-24_JPRB, &
  & 0.13663476E-24_JPRB, 0.17786152E-24_JPRB, 0.22909142E-24_JPRB, 0.28438135E-24_JPRB, 0.35195086E-24_JPRB, 0.42742831E-24_JPRB, &
  & 0.48016805E-24_JPRB, 0.59083379E-24_JPRB, 0.55736124E-24_JPRB, 0.60337150E-24_JPRB, 0.52053332E-24_JPRB, 0.55389223E-24_JPRB, &
  & 0.40096168E-24_JPRB, 0.30790964E-24_JPRB, 0.19277602E-24_JPRB, 0.14212388E-24_JPRB, 0.95261616E-25_JPRB, 0.58995450E-25_JPRB, &
  & 0.36212959E-25_JPRB, 0.21130951E-25_JPRB, 0.11623196E-25_JPRB, 0.60848840E-26_JPRB, 0.31716001E-26_JPRB, 0.15500984E-26_JPRB, &
  & 0.74992958E-27_JPRB, 0.40913989E-27_JPRB, 0.25832874E-27_JPRB, 0.17350599E-27_JPRB, 0.11856346E-27_JPRB, 0.83603174E-28_JPRB, &
  & 0.61139314E-28_JPRB, 0.47248869E-28_JPRB, 0.39280560E-28_JPRB, 0.34336945E-28_JPRB, 0.34466846E-28_JPRB, 0.42356625E-28_JPRB, &
  & 0.55967392E-28_JPRB, 0.74114322E-28_JPRB, 0.11165505E-27_JPRB, 0.19199256E-27_JPRB /)

RGHG9(:,11, 8) = (/ &
  & 0.17034808E-24_JPRB, 0.20709295E-24_JPRB, 0.20762254E-24_JPRB, 0.19388554E-24_JPRB, 0.17213198E-24_JPRB, 0.14633063E-24_JPRB, &
  & 0.12487014E-24_JPRB, 0.11197914E-24_JPRB, 0.11117947E-24_JPRB, 0.12663360E-24_JPRB, 0.16562793E-24_JPRB, 0.24051464E-24_JPRB, &
  & 0.37167689E-24_JPRB, 0.58843566E-24_JPRB, 0.92942724E-24_JPRB, 0.14369104E-23_JPRB, 0.21590744E-23_JPRB, 0.31327591E-23_JPRB, &
  & 0.43959128E-23_JPRB, 0.59818549E-23_JPRB, 0.79575082E-23_JPRB, 0.10425265E-22_JPRB, 0.13460064E-22_JPRB, 0.17292268E-22_JPRB, &
  & 0.21942589E-22_JPRB, 0.27538535E-22_JPRB, 0.34392108E-22_JPRB, 0.41594307E-22_JPRB, 0.50475606E-22_JPRB, 0.60489987E-22_JPRB, &
  & 0.67417031E-22_JPRB, 0.82859917E-22_JPRB, 0.78457676E-22_JPRB, 0.85792233E-22_JPRB, 0.75179183E-22_JPRB, 0.81679365E-22_JPRB, &
  & 0.60614305E-22_JPRB, 0.48011955E-22_JPRB, 0.31142670E-22_JPRB, 0.23970514E-22_JPRB, 0.16827236E-22_JPRB, 0.10967013E-22_JPRB, &
  & 0.71150797E-23_JPRB, 0.43994757E-23_JPRB, 0.25701767E-23_JPRB, 0.14318147E-23_JPRB, 0.79683984E-24_JPRB, 0.41599328E-24_JPRB, &
  & 0.21540372E-24_JPRB, 0.12626615E-24_JPRB, 0.85487340E-25_JPRB, 0.61183226E-25_JPRB, 0.44282362E-25_JPRB, 0.32894495E-25_JPRB, &
  & 0.25189054E-25_JPRB, 0.20253045E-25_JPRB, 0.17398423E-25_JPRB, 0.15608303E-25_JPRB, 0.15980496E-25_JPRB, 0.19912068E-25_JPRB, &
  & 0.26531947E-25_JPRB, 0.35316332E-25_JPRB, 0.53458238E-25_JPRB, 0.92439473E-25_JPRB /)

RGHG9(:,12, 8) = (/ &
  & 0.53528800E-22_JPRB, 0.64549484E-22_JPRB, 0.64840895E-22_JPRB, 0.60803449E-22_JPRB, 0.53838899E-22_JPRB, 0.45752778E-22_JPRB, &
  & 0.38825932E-22_JPRB, 0.34436726E-22_JPRB, 0.33550122E-22_JPRB, 0.37149066E-22_JPRB, 0.46800577E-22_JPRB, 0.64916443E-22_JPRB, &
  & 0.95217985E-22_JPRB, 0.14243034E-21_JPRB, 0.21195312E-21_JPRB, 0.30846647E-21_JPRB, 0.43658415E-21_JPRB, 0.59832391E-21_JPRB, &
  & 0.79494819E-21_JPRB, 0.10275258E-20_JPRB, 0.13011183E-20_JPRB, 0.16253353E-20_JPRB, 0.20045945E-20_JPRB, 0.24639566E-20_JPRB, &
  & 0.30014039E-20_JPRB, 0.36315063E-20_JPRB, 0.43936454E-20_JPRB, 0.51781963E-20_JPRB, 0.61594235E-20_JPRB, 0.72807282E-20_JPRB, &
  & 0.80480320E-20_JPRB, 0.98744346E-20_JPRB, 0.93836928E-20_JPRB, 0.10363495E-19_JPRB, 0.92291934E-20_JPRB, 0.10243301E-19_JPRB, &
  & 0.78025944E-20_JPRB, 0.63817404E-20_JPRB, 0.42957097E-20_JPRB, 0.34538216E-20_JPRB, 0.25412505E-20_JPRB, 0.17436844E-20_JPRB, &
  & 0.11962114E-20_JPRB, 0.78447974E-21_JPRB, 0.48723730E-21_JPRB, 0.28929004E-21_JPRB, 0.17202940E-21_JPRB, 0.95962531E-22_JPRB, &
  & 0.53182951E-22_JPRB, 0.33425624E-22_JPRB, 0.24203187E-22_JPRB, 0.18418108E-22_JPRB, 0.14092427E-22_JPRB, 0.11005769E-22_JPRB, &
  & 0.88071185E-23_JPRB, 0.73505964E-23_JPRB, 0.65095106E-23_JPRB, 0.59791050E-23_JPRB, 0.62291187E-23_JPRB, 0.78469753E-23_JPRB, &
  & 0.10522515E-22_JPRB, 0.14042078E-22_JPRB, 0.21301523E-22_JPRB, 0.36932596E-22_JPRB /)

RGHG9(:,13, 8) = (/ &
  & 0.13768793E-19_JPRB, 0.16780368E-19_JPRB, 0.16841665E-19_JPRB, 0.15733930E-19_JPRB, 0.13938913E-19_JPRB, 0.11792593E-19_JPRB, &
  & 0.99593887E-20_JPRB, 0.87539264E-20_JPRB, 0.83967597E-20_JPRB, 0.90767546E-20_JPRB, 0.11064185E-19_JPRB, 0.14733814E-19_JPRB, &
  & 0.20616751E-19_JPRB, 0.29281240E-19_JPRB, 0.41254974E-19_JPRB, 0.56724221E-19_JPRB, 0.75852915E-19_JPRB, 0.98213726E-19_JPRB, &
  & 0.12355243E-18_JPRB, 0.15138871E-18_JPRB, 0.18209947E-18_JPRB, 0.21647791E-18_JPRB, 0.25446769E-18_JPRB, 0.29901974E-18_JPRB, &
  & 0.34936283E-18_JPRB, 0.40728236E-18_JPRB, 0.47732178E-18_JPRB, 0.54786266E-18_JPRB, 0.63828317E-18_JPRB, 0.74347697E-18_JPRB, &
  & 0.81448887E-18_JPRB, 0.99679317E-18_JPRB, 0.95078776E-18_JPRB, 0.10604665E-17_JPRB, 0.96021018E-18_JPRB, 0.10892456E-17_JPRB, &
  & 0.85255955E-18_JPRB, 0.72070168E-18_JPRB, 0.50414720E-18_JPRB, 0.42362016E-18_JPRB, 0.32684359E-18_JPRB, 0.23618785E-18_JPRB, &
  & 0.17135022E-18_JPRB, 0.11919900E-18_JPRB, 0.78756609E-19_JPRB, 0.49879621E-19_JPRB, 0.31699920E-19_JPRB, 0.18907714E-19_JPRB, &
  & 0.11215580E-19_JPRB, 0.75526800E-20_JPRB, 0.58428088E-20_JPRB, 0.47239748E-20_JPRB, 0.38189931E-20_JPRB, 0.31339923E-20_JPRB, &
  & 0.26190439E-20_JPRB, 0.22678332E-20_JPRB, 0.20689607E-20_JPRB, 0.19446206E-20_JPRB, 0.20601006E-20_JPRB, 0.26229469E-20_JPRB, &
  & 0.35350173E-20_JPRB, 0.47285384E-20_JPRB, 0.71765495E-20_JPRB, 0.12443290E-19_JPRB /)

RGHG9(:,14, 8) = (/ &
  & 0.30151319E-17_JPRB, 0.36734371E-17_JPRB, 0.36842939E-17_JPRB, 0.34370111E-17_JPRB, 0.30274306E-17_JPRB, 0.25500512E-17_JPRB, &
  & 0.21402269E-17_JPRB, 0.18642647E-17_JPRB, 0.17624026E-17_JPRB, 0.18634667E-17_JPRB, 0.22037086E-17_JPRB, 0.28259333E-17_JPRB, &
  & 0.37841739E-17_JPRB, 0.51198133E-17_JPRB, 0.68472324E-17_JPRB, 0.89192950E-17_JPRB, 0.11280029E-16_JPRB, 0.13814987E-16_JPRB, &
  & 0.16435000E-16_JPRB, 0.19071069E-16_JPRB, 0.21747280E-16_JPRB, 0.24555020E-16_JPRB, 0.27484647E-16_JPRB, 0.30837452E-16_JPRB, &
  & 0.34549640E-16_JPRB, 0.38807132E-16_JPRB, 0.44045981E-16_JPRB, 0.49235650E-16_JPRB, 0.56165365E-16_JPRB, 0.64437694E-16_JPRB, &
  & 0.69939888E-16_JPRB, 0.85339562E-16_JPRB, 0.81715922E-16_JPRB, 0.92044741E-16_JPRB, 0.84761707E-16_JPRB, 0.98294752E-16_JPRB, &
  & 0.79101072E-16_JPRB, 0.69167102E-16_JPRB, 0.50320017E-16_JPRB, 0.44208681E-16_JPRB, 0.35769288E-16_JPRB, 0.27225760E-16_JPRB, &
  & 0.20881215E-16_JPRB, 0.15405079E-16_JPRB, 0.10827603E-16_JPRB, 0.73152586E-17_JPRB, 0.49698558E-17_JPRB, 0.31697367E-17_JPRB, &
  & 0.20128704E-17_JPRB, 0.14519943E-17_JPRB, 0.11995004E-17_JPRB, 0.10299892E-17_JPRB, 0.87954456E-18_JPRB, 0.75815746E-18_JPRB, &
  & 0.66146382E-18_JPRB, 0.59406245E-18_JPRB, 0.55827205E-18_JPRB, 0.53707054E-18_JPRB, 0.57891212E-18_JPRB, 0.74512161E-18_JPRB, &
  & 0.10110190E-17_JPRB, 0.13555413E-17_JPRB, 0.20597345E-17_JPRB, 0.35710851E-17_JPRB /)

RGHG9(:,15, 8) = (/ &
  & 0.56045894E-15_JPRB, 0.68503763E-15_JPRB, 0.68507072E-15_JPRB, 0.63578499E-15_JPRB, 0.55714577E-15_JPRB, 0.46616887E-15_JPRB, &
  & 0.38849828E-15_JPRB, 0.33510243E-15_JPRB, 0.31213990E-15_JPRB, 0.32297176E-15_JPRB, 0.37099376E-15_JPRB, 0.45884892E-15_JPRB, &
  & 0.58906419E-15_JPRB, 0.76019428E-15_JPRB, 0.96628714E-15_JPRB, 0.11929287E-14_JPRB, 0.14279620E-14_JPRB, 0.16534533E-14_JPRB, &
  & 0.18604827E-14_JPRB, 0.20429649E-14_JPRB, 0.22079853E-14_JPRB, 0.23668419E-14_JPRB, 0.25219197E-14_JPRB, 0.27015754E-14_JPRB, &
  & 0.29018385E-14_JPRB, 0.31394230E-14_JPRB, 0.34500340E-14_JPRB, 0.37546349E-14_JPRB, 0.41935034E-14_JPRB, 0.47395559E-14_JPRB, &
  & 0.50974616E-14_JPRB, 0.62026630E-14_JPRB, 0.59633830E-14_JPRB, 0.67855449E-14_JPRB, 0.63567104E-14_JPRB, 0.75364206E-14_JPRB, &
  & 0.62384908E-14_JPRB, 0.56429814E-14_JPRB, 0.42729030E-14_JPRB, 0.39244133E-14_JPRB, 0.33300412E-14_JPRB, 0.26687768E-14_JPRB, &
  & 0.21637963E-14_JPRB, 0.16928511E-14_JPRB, 0.12657073E-14_JPRB, 0.91250732E-15_JPRB, 0.66286273E-15_JPRB, 0.45221411E-15_JPRB, &
  & 0.30752473E-15_JPRB, 0.23768367E-15_JPRB, 0.20966127E-15_JPRB, 0.19116861E-15_JPRB, 0.17239083E-15_JPRB, 0.15602912E-15_JPRB, &
  & 0.14205566E-15_JPRB, 0.13227685E-15_JPRB, 0.12802924E-15_JPRB, 0.12609774E-15_JPRB, 0.13837065E-15_JPRB, 0.18030896E-15_JPRB, &
  & 0.24640225E-15_JPRB, 0.33183606E-15_JPRB, 0.50506473E-15_JPRB, 0.87612255E-15_JPRB /)

RGHG9(:,16, 8) = (/ &
  & 0.66791767E-14_JPRB, 0.71791726E-14_JPRB, 0.67566844E-14_JPRB, 0.59993023E-14_JPRB, 0.51057799E-14_JPRB, 0.41781277E-14_JPRB, &
  & 0.34169462E-14_JPRB, 0.29070251E-14_JPRB, 0.26877270E-14_JPRB, 0.27793845E-14_JPRB, 0.32062988E-14_JPRB, 0.39961189E-14_JPRB, &
  & 0.51747246E-14_JPRB, 0.67400872E-14_JPRB, 0.86484495E-14_JPRB, 0.10798070E-13_JPRB, 0.13075687E-13_JPRB, 0.15380277E-13_JPRB, &
  & 0.17614275E-13_JPRB, 0.19787147E-13_JPRB, 0.21924982E-13_JPRB, 0.24131594E-13_JPRB, 0.26452915E-13_JPRB, 0.29016980E-13_JPRB, &
  & 0.31833375E-13_JPRB, 0.34890839E-13_JPRB, 0.38179468E-13_JPRB, 0.41217619E-13_JPRB, 0.44122746E-13_JPRB, 0.46231644E-13_JPRB, &
  & 0.47835410E-13_JPRB, 0.49982530E-13_JPRB, 0.49156110E-13_JPRB, 0.50688000E-13_JPRB, 0.54510599E-13_JPRB, 0.51929950E-13_JPRB, &
  & 0.43255960E-13_JPRB, 0.36606179E-13_JPRB, 0.33079882E-13_JPRB, 0.28479182E-13_JPRB, 0.25061093E-13_JPRB, 0.22250254E-13_JPRB, &
  & 0.18683612E-13_JPRB, 0.14928940E-13_JPRB, 0.11301563E-13_JPRB, 0.85489722E-14_JPRB, 0.63175241E-14_JPRB, 0.47097518E-14_JPRB, &
  & 0.36919977E-14_JPRB, 0.30335530E-14_JPRB, 0.26273391E-14_JPRB, 0.23546364E-14_JPRB, 0.20936217E-14_JPRB, 0.18356339E-14_JPRB, &
  & 0.16244790E-14_JPRB, 0.14527084E-14_JPRB, 0.13390547E-14_JPRB, 0.12716160E-14_JPRB, 0.13426245E-14_JPRB, 0.15940672E-14_JPRB, &
  & 0.19550526E-14_JPRB, 0.24227260E-14_JPRB, 0.32695980E-14_JPRB, 0.31783090E-14_JPRB /)

RGHG9(:,17, 8) = (/ &
  & 0.47097736E-13_JPRB, 0.44472482E-13_JPRB, 0.39163764E-13_JPRB, 0.33378489E-13_JPRB, 0.27687544E-13_JPRB, 0.22432968E-13_JPRB, &
  & 0.18171191E-13_JPRB, 0.15328315E-13_JPRB, 0.14133434E-13_JPRB, 0.14690604E-13_JPRB, 0.17155829E-13_JPRB, 0.21744623E-13_JPRB, &
  & 0.28709043E-13_JPRB, 0.38187203E-13_JPRB, 0.50072227E-13_JPRB, 0.63954179E-13_JPRB, 0.79244994E-13_JPRB, 0.95336635E-13_JPRB, &
  & 0.11173896E-12_JPRB, 0.12835935E-12_JPRB, 0.14571844E-12_JPRB, 0.16437929E-12_JPRB, 0.18536228E-12_JPRB, 0.20869622E-12_JPRB, &
  & 0.23481702E-12_JPRB, 0.26166872E-12_JPRB, 0.28871808E-12_JPRB, 0.30953915E-12_JPRB, 0.32407649E-12_JPRB, 0.32547429E-12_JPRB, &
  & 0.31919871E-12_JPRB, 0.30303074E-12_JPRB, 0.28248459E-12_JPRB, 0.25606828E-12_JPRB, 0.22043626E-12_JPRB, 0.18610401E-12_JPRB, &
  & 0.17431840E-12_JPRB, 0.16468961E-12_JPRB, 0.15341644E-12_JPRB, 0.14583323E-12_JPRB, 0.13669781E-12_JPRB, 0.12497807E-12_JPRB, &
  & 0.11221266E-12_JPRB, 0.98825231E-13_JPRB, 0.84425292E-13_JPRB, 0.70596415E-13_JPRB, 0.57884985E-13_JPRB, 0.47438514E-13_JPRB, &
  & 0.38872582E-13_JPRB, 0.31765843E-13_JPRB, 0.25837456E-13_JPRB, 0.21077858E-13_JPRB, 0.17276584E-13_JPRB, 0.14347252E-13_JPRB, &
  & 0.12430242E-13_JPRB, 0.11373742E-13_JPRB, 0.10710899E-13_JPRB, 0.10122467E-13_JPRB, 0.98469003E-14_JPRB, 0.10403836E-13_JPRB, &
  & 0.12083187E-13_JPRB, 0.14003320E-13_JPRB, 0.15916952E-13_JPRB, 0.24258009E-13_JPRB /)

RGHG9(:,18, 8) = (/ &
  & 0.20582766E-12_JPRB, 0.18004530E-12_JPRB, 0.15089374E-12_JPRB, 0.12733458E-12_JPRB, 0.10482664E-12_JPRB, 0.85524002E-13_JPRB, &
  & 0.69569188E-13_JPRB, 0.58890101E-13_JPRB, 0.54462050E-13_JPRB, 0.56805621E-13_JPRB, 0.66717899E-13_JPRB, 0.85313782E-13_JPRB, &
  & 0.11386202E-12_JPRB, 0.15338345E-12_JPRB, 0.20401267E-12_JPRB, 0.26464708E-12_JPRB, 0.33322997E-12_JPRB, 0.40780432E-12_JPRB, &
  & 0.48638128E-12_JPRB, 0.56889758E-12_JPRB, 0.65740030E-12_JPRB, 0.75731934E-12_JPRB, 0.87318228E-12_JPRB, 0.10037602E-11_JPRB, &
  & 0.11405965E-11_JPRB, 0.12827699E-11_JPRB, 0.14126819E-11_JPRB, 0.15096828E-11_JPRB, 0.15477938E-11_JPRB, 0.15261255E-11_JPRB, &
  & 0.14417482E-11_JPRB, 0.13142906E-11_JPRB, 0.11605442E-11_JPRB, 0.10058260E-11_JPRB, 0.86167624E-12_JPRB, 0.74854012E-12_JPRB, &
  & 0.65809982E-12_JPRB, 0.60096898E-12_JPRB, 0.57774808E-12_JPRB, 0.57130483E-12_JPRB, 0.57023651E-12_JPRB, 0.56659202E-12_JPRB, &
  & 0.54896181E-12_JPRB, 0.51470622E-12_JPRB, 0.46809746E-12_JPRB, 0.41524127E-12_JPRB, 0.36115560E-12_JPRB, 0.31055155E-12_JPRB, &
  & 0.26349685E-12_JPRB, 0.22195447E-12_JPRB, 0.18616795E-12_JPRB, 0.15622613E-12_JPRB, 0.13086995E-12_JPRB, 0.10999580E-12_JPRB, &
  & 0.94223810E-13_JPRB, 0.83289000E-13_JPRB, 0.77010813E-13_JPRB, 0.74530687E-13_JPRB, 0.74275059E-13_JPRB, 0.75634269E-13_JPRB, &
  & 0.79669263E-13_JPRB, 0.88936765E-13_JPRB, 0.10583406E-12_JPRB, 0.14291144E-12_JPRB /)

RGHG9(:,19, 8) = (/ &
  & 0.58045501E-12_JPRB, 0.50158792E-12_JPRB, 0.41623454E-12_JPRB, 0.35637891E-12_JPRB, 0.29714190E-12_JPRB, 0.24688774E-12_JPRB, &
  & 0.20540942E-12_JPRB, 0.17650017E-12_JPRB, 0.16434686E-12_JPRB, 0.17114385E-12_JPRB, 0.19970176E-12_JPRB, 0.25369176E-12_JPRB, &
  & 0.33723493E-12_JPRB, 0.45366952E-12_JPRB, 0.60433548E-12_JPRB, 0.78712622E-12_JPRB, 0.99690514E-12_JPRB, 0.12281194E-11_JPRB, &
  & 0.14775308E-11_JPRB, 0.17454198E-11_JPRB, 0.20352196E-11_JPRB, 0.23581157E-11_JPRB, 0.27310162E-11_JPRB, 0.31525282E-11_JPRB, &
  & 0.36205639E-11_JPRB, 0.41019857E-11_JPRB, 0.45277558E-11_JPRB, 0.48135610E-11_JPRB, 0.48882612E-11_JPRB, 0.47360987E-11_JPRB, &
  & 0.43857921E-11_JPRB, 0.38976491E-11_JPRB, 0.33569957E-11_JPRB, 0.28193812E-11_JPRB, 0.23460069E-11_JPRB, 0.19889082E-11_JPRB, &
  & 0.17460805E-11_JPRB, 0.16253118E-11_JPRB, 0.16124113E-11_JPRB, 0.16716319E-11_JPRB, 0.17640132E-11_JPRB, 0.18442105E-11_JPRB, &
  & 0.18819115E-11_JPRB, 0.18671503E-11_JPRB, 0.17966824E-11_JPRB, 0.16772319E-11_JPRB, 0.15251873E-11_JPRB, 0.13582543E-11_JPRB, &
  & 0.11877877E-11_JPRB, 0.10245920E-11_JPRB, 0.87499761E-12_JPRB, 0.74348167E-12_JPRB, 0.63088803E-12_JPRB, 0.53908988E-12_JPRB, &
  & 0.46677316E-12_JPRB, 0.41113638E-12_JPRB, 0.37102358E-12_JPRB, 0.34600700E-12_JPRB, 0.33490767E-12_JPRB, 0.33573174E-12_JPRB, &
  & 0.34630401E-12_JPRB, 0.36797448E-12_JPRB, 0.41537677E-12_JPRB, 0.53291247E-12_JPRB /)

RGHG9(:,20, 8) = (/ &
  & 0.12739380E-11_JPRB, 0.10829290E-11_JPRB, 0.92044699E-12_JPRB, 0.79658036E-12_JPRB, 0.68161422E-12_JPRB, 0.57890221E-12_JPRB, &
  & 0.49468676E-12_JPRB, 0.43388326E-12_JPRB, 0.40619808E-12_JPRB, 0.41967225E-12_JPRB, 0.48108528E-12_JPRB, 0.59844247E-12_JPRB, &
  & 0.78016922E-12_JPRB, 0.10330561E-11_JPRB, 0.13589050E-11_JPRB, 0.17526386E-11_JPRB, 0.22036190E-11_JPRB, 0.26982852E-11_JPRB, &
  & 0.32273348E-11_JPRB, 0.37944448E-11_JPRB, 0.44101216E-11_JPRB, 0.50827910E-11_JPRB, 0.58406639E-11_JPRB, 0.67015551E-11_JPRB, &
  & 0.76540475E-11_JPRB, 0.86323891E-11_JPRB, 0.94956690E-11_JPRB, 0.10080791E-10_JPRB, 0.10242984E-10_JPRB, 0.99610086E-11_JPRB, &
  & 0.92807116E-11_JPRB, 0.83141723E-11_JPRB, 0.72125092E-11_JPRB, 0.61058823E-11_JPRB, 0.51295426E-11_JPRB, 0.43844941E-11_JPRB, &
  & 0.39221846E-11_JPRB, 0.37178372E-11_JPRB, 0.37273474E-11_JPRB, 0.39054758E-11_JPRB, 0.41699829E-11_JPRB, 0.44314361E-11_JPRB, &
  & 0.46323162E-11_JPRB, 0.47221740E-11_JPRB, 0.46776246E-11_JPRB, 0.45080706E-11_JPRB, 0.42349813E-11_JPRB, 0.38893840E-11_JPRB, &
  & 0.34941511E-11_JPRB, 0.30849908E-11_JPRB, 0.26902883E-11_JPRB, 0.23275403E-11_JPRB, 0.20086578E-11_JPRB, 0.17411602E-11_JPRB, &
  & 0.15250928E-11_JPRB, 0.13554313E-11_JPRB, 0.12274206E-11_JPRB, 0.11369718E-11_JPRB, 0.10812876E-11_JPRB, 0.10602765E-11_JPRB, &
  & 0.10741893E-11_JPRB, 0.11258770E-11_JPRB, 0.12252685E-11_JPRB, 0.14618475E-11_JPRB /)

RGHG9(:,21, 8) = (/ &
  & 0.23737433E-11_JPRB, 0.20056283E-11_JPRB, 0.17475985E-11_JPRB, 0.15375847E-11_JPRB, 0.13395448E-11_JPRB, 0.11640450E-11_JPRB, &
  & 0.10148692E-11_JPRB, 0.90736056E-12_JPRB, 0.85306393E-12_JPRB, 0.87098666E-12_JPRB, 0.97341156E-12_JPRB, 0.11735589E-11_JPRB, &
  & 0.14837617E-11_JPRB, 0.19119055E-11_JPRB, 0.24581452E-11_JPRB, 0.31107011E-11_JPRB, 0.38496289E-11_JPRB, 0.46548160E-11_JPRB, &
  & 0.55107221E-11_JPRB, 0.64135485E-11_JPRB, 0.73893825E-11_JPRB, 0.84568385E-11_JPRB, 0.96406407E-11_JPRB, 0.10975642E-10_JPRB, &
  & 0.12447821E-10_JPRB, 0.13957747E-10_JPRB, 0.15308742E-10_JPRB, 0.16262235E-10_JPRB, 0.16636453E-10_JPRB, 0.16381740E-10_JPRB, &
  & 0.15529401E-10_JPRB, 0.14223194E-10_JPRB, 0.12657484E-10_JPRB, 0.11024529E-10_JPRB, 0.95400285E-11_JPRB, 0.83815897E-11_JPRB, &
  & 0.76236691E-11_JPRB, 0.72960561E-11_JPRB, 0.73371430E-11_JPRB, 0.76410076E-11_JPRB, 0.80831704E-11_JPRB, 0.85570943E-11_JPRB, &
  & 0.89467262E-11_JPRB, 0.91656257E-11_JPRB, 0.91873887E-11_JPRB, 0.89997333E-11_JPRB, 0.86073414E-11_JPRB, 0.80558719E-11_JPRB, &
  & 0.73910244E-11_JPRB, 0.66735077E-11_JPRB, 0.59465822E-11_JPRB, 0.52507694E-11_JPRB, 0.46218359E-11_JPRB, 0.40793571E-11_JPRB, &
  & 0.36294431E-11_JPRB, 0.32681045E-11_JPRB, 0.29895936E-11_JPRB, 0.27863859E-11_JPRB, 0.26510153E-11_JPRB, 0.25809888E-11_JPRB, &
  & 0.25805048E-11_JPRB, 0.26530865E-11_JPRB, 0.28275240E-11_JPRB, 0.31720685E-11_JPRB /)

RGHG9(:,22, 8) = (/ &
  & 0.39457972E-11_JPRB, 0.33614912E-11_JPRB, 0.29843860E-11_JPRB, 0.26589677E-11_JPRB, 0.23623373E-11_JPRB, 0.20831737E-11_JPRB, &
  & 0.18455925E-11_JPRB, 0.16686756E-11_JPRB, 0.15749427E-11_JPRB, 0.15872319E-11_JPRB, 0.17266230E-11_JPRB, 0.20101427E-11_JPRB, &
  & 0.24520635E-11_JPRB, 0.30591330E-11_JPRB, 0.38263333E-11_JPRB, 0.47353180E-11_JPRB, 0.57585447E-11_JPRB, 0.68653837E-11_JPRB, &
  & 0.80383799E-11_JPRB, 0.92775457E-11_JPRB, 0.10591537E-10_JPRB, 0.12029481E-10_JPRB, 0.13619009E-10_JPRB, 0.15393114E-10_JPRB, &
  & 0.17343097E-10_JPRB, 0.19350695E-10_JPRB, 0.21176711E-10_JPRB, 0.22551129E-10_JPRB, 0.23253533E-10_JPRB, 0.23215112E-10_JPRB, &
  & 0.22470019E-10_JPRB, 0.21146442E-10_JPRB, 0.19430103E-10_JPRB, 0.17565855E-10_JPRB, 0.15810769E-10_JPRB, 0.14384879E-10_JPRB, &
  & 0.13411813E-10_JPRB, 0.12929924E-10_JPRB, 0.12895718E-10_JPRB, 0.13201456E-10_JPRB, 0.13683859E-10_JPRB, 0.14223691E-10_JPRB, &
  & 0.14647348E-10_JPRB, 0.14902480E-10_JPRB, 0.14916629E-10_JPRB, 0.14653787E-10_JPRB, 0.14133730E-10_JPRB, 0.13398266E-10_JPRB, &
  & 0.12484684E-10_JPRB, 0.11459215E-10_JPRB, 0.10397174E-10_JPRB, 0.93675276E-11_JPRB, 0.84201162E-11_JPRB, 0.75834113E-11_JPRB, &
  & 0.68707791E-11_JPRB, 0.62816796E-11_JPRB, 0.58127587E-11_JPRB, 0.54593443E-11_JPRB, 0.52160342E-11_JPRB, 0.50822324E-11_JPRB, &
  & 0.50622215E-11_JPRB, 0.51398807E-11_JPRB, 0.53437732E-11_JPRB, 0.57792130E-11_JPRB /)

RGHG9(:,23, 8) = (/ &
  & 0.60441227E-11_JPRB, 0.52074430E-11_JPRB, 0.46935619E-11_JPRB, 0.42460215E-11_JPRB, 0.38152806E-11_JPRB, 0.34167215E-11_JPRB, &
  & 0.30619129E-11_JPRB, 0.27927795E-11_JPRB, 0.26421148E-11_JPRB, 0.26336893E-11_JPRB, 0.27981530E-11_JPRB, 0.31535274E-11_JPRB, &
  & 0.37139927E-11_JPRB, 0.44834462E-11_JPRB, 0.54530911E-11_JPRB, 0.65962730E-11_JPRB, 0.78793283E-11_JPRB, 0.92709260E-11_JPRB, &
  & 0.10736897E-10_JPRB, 0.12288581E-10_JPRB, 0.13930771E-10_JPRB, 0.15699875E-10_JPRB, 0.17650029E-10_JPRB, 0.19802595E-10_JPRB, &
  & 0.22149279E-10_JPRB, 0.24542462E-10_JPRB, 0.26749464E-10_JPRB, 0.28496448E-10_JPRB, 0.29607119E-10_JPRB, 0.29985660E-10_JPRB, &
  & 0.29631290E-10_JPRB, 0.28645275E-10_JPRB, 0.27192882E-10_JPRB, 0.25503070E-10_JPRB, 0.23814350E-10_JPRB, 0.22382023E-10_JPRB, &
  & 0.21340787E-10_JPRB, 0.20748172E-10_JPRB, 0.20573609E-10_JPRB, 0.20677370E-10_JPRB, 0.20942852E-10_JPRB, 0.21251544E-10_JPRB, &
  & 0.21502560E-10_JPRB, 0.21553984E-10_JPRB, 0.21371120E-10_JPRB, 0.20936006E-10_JPRB, 0.20218563E-10_JPRB, 0.19253316E-10_JPRB, &
  & 0.18097489E-10_JPRB, 0.16834204E-10_JPRB, 0.15534296E-10_JPRB, 0.14260910E-10_JPRB, 0.13067675E-10_JPRB, 0.11992956E-10_JPRB, &
  & 0.11057866E-10_JPRB, 0.10266029E-10_JPRB, 0.96163659E-11_JPRB, 0.91069851E-11_JPRB, 0.87391015E-11_JPRB, 0.85175599E-11_JPRB, &
  & 0.84522311E-11_JPRB, 0.85208160E-11_JPRB, 0.86693890E-11_JPRB, 0.90215691E-11_JPRB /)

RGHG9(:,24, 8) = (/ &
  & 0.86347891E-11_JPRB, 0.75755522E-11_JPRB, 0.69114926E-11_JPRB, 0.63287422E-11_JPRB, 0.57702896E-11_JPRB, 0.52288156E-11_JPRB, &
  & 0.47444765E-11_JPRB, 0.43658757E-11_JPRB, 0.41411158E-11_JPRB, 0.41044937E-11_JPRB, 0.42879294E-11_JPRB, 0.47087920E-11_JPRB, &
  & 0.53834446E-11_JPRB, 0.63091064E-11_JPRB, 0.74729571E-11_JPRB, 0.88463343E-11_JPRB, 0.10384207E-10_JPRB, 0.12051060E-10_JPRB, &
  & 0.13810406E-10_JPRB, 0.15658492E-10_JPRB, 0.17608394E-10_JPRB, 0.19683803E-10_JPRB, 0.21923350E-10_JPRB, 0.24353882E-10_JPRB, &
  & 0.26951680E-10_JPRB, 0.29594244E-10_JPRB, 0.32063106E-10_JPRB, 0.34141506E-10_JPRB, 0.35617630E-10_JPRB, 0.36446204E-10_JPRB, &
  & 0.36648542E-10_JPRB, 0.36275087E-10_JPRB, 0.35454924E-10_JPRB, 0.34330313E-10_JPRB, 0.33117245E-10_JPRB, 0.31987735E-10_JPRB, &
  & 0.31052088E-10_JPRB, 0.30386544E-10_JPRB, 0.29931013E-10_JPRB, 0.29662408E-10_JPRB, 0.29461444E-10_JPRB, 0.29283315E-10_JPRB, &
  & 0.29035529E-10_JPRB, 0.28686350E-10_JPRB, 0.28131051E-10_JPRB, 0.27356277E-10_JPRB, 0.26371218E-10_JPRB, 0.25201143E-10_JPRB, &
  & 0.23869125E-10_JPRB, 0.22429669E-10_JPRB, 0.20954547E-10_JPRB, 0.19510567E-10_JPRB, 0.18154747E-10_JPRB, 0.16926042E-10_JPRB, &
  & 0.15842751E-10_JPRB, 0.14908068E-10_JPRB, 0.14123492E-10_JPRB, 0.13491812E-10_JPRB, 0.13017927E-10_JPRB, 0.12709044E-10_JPRB, &
  & 0.12563017E-10_JPRB, 0.12545509E-10_JPRB, 0.12604741E-10_JPRB, 0.12811733E-10_JPRB /)

RGHG9(:,25, 8) = (/ &
  & 0.11598493E-10_JPRB, 0.10368274E-10_JPRB, 0.96105693E-11_JPRB, 0.89188049E-11_JPRB, 0.82489215E-11_JPRB, 0.75864228E-11_JPRB, &
  & 0.69831849E-11_JPRB, 0.65010926E-11_JPRB, 0.62078272E-11_JPRB, 0.61519245E-11_JPRB, 0.63608572E-11_JPRB, 0.68628814E-11_JPRB, &
  & 0.76665028E-11_JPRB, 0.87690020E-11_JPRB, 0.10151662E-10_JPRB, 0.11778353E-10_JPRB, 0.13596613E-10_JPRB, 0.15552837E-10_JPRB, &
  & 0.17604983E-10_JPRB, 0.19733522E-10_JPRB, 0.21941740E-10_JPRB, 0.24248980E-10_JPRB, 0.26675176E-10_JPRB, 0.29236835E-10_JPRB, &
  & 0.31898297E-10_JPRB, 0.34565538E-10_JPRB, 0.37070604E-10_JPRB, 0.39248084E-10_JPRB, 0.41056922E-10_JPRB, 0.42390001E-10_JPRB, &
  & 0.43215646E-10_JPRB, 0.43570082E-10_JPRB, 0.43535373E-10_JPRB, 0.43178603E-10_JPRB, 0.42619241E-10_JPRB, 0.41953201E-10_JPRB, &
  & 0.41259492E-10_JPRB, 0.40581691E-10_JPRB, 0.39849887E-10_JPRB, 0.39157025E-10_JPRB, 0.38397844E-10_JPRB, 0.37609537E-10_JPRB, &
  & 0.36733460E-10_JPRB, 0.35800619E-10_JPRB, 0.34767415E-10_JPRB, 0.33602395E-10_JPRB, 0.32278982E-10_JPRB, 0.30837319E-10_JPRB, &
  & 0.29322086E-10_JPRB, 0.27770931E-10_JPRB, 0.26221572E-10_JPRB, 0.24720025E-10_JPRB, 0.23309998E-10_JPRB, 0.22020920E-10_JPRB, &
  & 0.20865570E-10_JPRB, 0.19849214E-10_JPRB, 0.18977335E-10_JPRB, 0.18257746E-10_JPRB, 0.17698386E-10_JPRB, 0.17300189E-10_JPRB, &
  & 0.17064199E-10_JPRB, 0.16920850E-10_JPRB, 0.16864074E-10_JPRB, 0.16919832E-10_JPRB /)

RGHG9(:,26, 8) = (/ &
  & 0.14844327E-10_JPRB, 0.13561366E-10_JPRB, 0.12737128E-10_JPRB, 0.12010368E-10_JPRB, 0.11263780E-10_JPRB, 0.10539880E-10_JPRB, &
  & 0.98569980E-11_JPRB, 0.93100892E-11_JPRB, 0.89794656E-11_JPRB, 0.89310937E-11_JPRB, 0.92033794E-11_JPRB, 0.98213486E-11_JPRB, &
  & 0.10794561E-10_JPRB, 0.12117295E-10_JPRB, 0.13763202E-10_JPRB, 0.15685418E-10_JPRB, 0.17811454E-10_JPRB, 0.20069814E-10_JPRB, &
  & 0.22397514E-10_JPRB, 0.24764395E-10_JPRB, 0.27150402E-10_JPRB, 0.29566613E-10_JPRB, 0.32022579E-10_JPRB, 0.34530906E-10_JPRB, &
  & 0.37066024E-10_JPRB, 0.39579111E-10_JPRB, 0.42014333E-10_JPRB, 0.44261445E-10_JPRB, 0.46201449E-10_JPRB, 0.47835746E-10_JPRB, &
  & 0.49167372E-10_JPRB, 0.50180454E-10_JPRB, 0.50879634E-10_JPRB, 0.51256138E-10_JPRB, 0.51341535E-10_JPRB, 0.51155007E-10_JPRB, &
  & 0.50711879E-10_JPRB, 0.50038532E-10_JPRB, 0.49111271E-10_JPRB, 0.48005738E-10_JPRB, 0.46734252E-10_JPRB, 0.45360125E-10_JPRB, &
  & 0.43920412E-10_JPRB, 0.42436651E-10_JPRB, 0.40919629E-10_JPRB, 0.39369411E-10_JPRB, 0.37794209E-10_JPRB, 0.36189406E-10_JPRB, &
  & 0.34556399E-10_JPRB, 0.32926113E-10_JPRB, 0.31334227E-10_JPRB, 0.29815369E-10_JPRB, 0.28395893E-10_JPRB, 0.27093586E-10_JPRB, &
  & 0.25915404E-10_JPRB, 0.24866846E-10_JPRB, 0.23955093E-10_JPRB, 0.23187905E-10_JPRB, 0.22566341E-10_JPRB, 0.22090314E-10_JPRB, &
  & 0.21737240E-10_JPRB, 0.21472116E-10_JPRB, 0.21272314E-10_JPRB, 0.21085104E-10_JPRB /)

RGHG9(:,27, 8) = (/ &
  & 0.18328157E-10_JPRB, 0.17078587E-10_JPRB, 0.16285657E-10_JPRB, 0.15536891E-10_JPRB, 0.14823656E-10_JPRB, 0.14079513E-10_JPRB, &
  & 0.13397373E-10_JPRB, 0.12846558E-10_JPRB, 0.12535808E-10_JPRB, 0.12545513E-10_JPRB, 0.12927911E-10_JPRB, 0.13704921E-10_JPRB, &
  & 0.14890349E-10_JPRB, 0.16472462E-10_JPRB, 0.18415184E-10_JPRB, 0.20650769E-10_JPRB, 0.23085908E-10_JPRB, 0.25618542E-10_JPRB, &
  & 0.28173564E-10_JPRB, 0.30679997E-10_JPRB, 0.33129013E-10_JPRB, 0.35506344E-10_JPRB, 0.37823168E-10_JPRB, 0.40108604E-10_JPRB, &
  & 0.42346581E-10_JPRB, 0.44539698E-10_JPRB, 0.46659884E-10_JPRB, 0.48720777E-10_JPRB, 0.50742577E-10_JPRB, 0.52652570E-10_JPRB, &
  & 0.54392189E-10_JPRB, 0.55917833E-10_JPRB, 0.57179365E-10_JPRB, 0.58106912E-10_JPRB, 0.58669444E-10_JPRB, 0.58833743E-10_JPRB, &
  & 0.58582653E-10_JPRB, 0.57924804E-10_JPRB, 0.56879189E-10_JPRB, 0.55490036E-10_JPRB, 0.53864489E-10_JPRB, 0.52060654E-10_JPRB, &
  & 0.50192607E-10_JPRB, 0.48288377E-10_JPRB, 0.46395741E-10_JPRB, 0.44517976E-10_JPRB, 0.42693661E-10_JPRB, 0.40942447E-10_JPRB, &
  & 0.39267672E-10_JPRB, 0.37653321E-10_JPRB, 0.36100688E-10_JPRB, 0.34628647E-10_JPRB, 0.33253497E-10_JPRB, 0.31985178E-10_JPRB, &
  & 0.30826303E-10_JPRB, 0.29779960E-10_JPRB, 0.28851102E-10_JPRB, 0.28047120E-10_JPRB, 0.27375142E-10_JPRB, 0.26827544E-10_JPRB, &
  & 0.26377673E-10_JPRB, 0.26013339E-10_JPRB, 0.25697867E-10_JPRB, 0.25300406E-10_JPRB /)

RGHG9(:,28, 8) = (/ &
  & 0.22068460E-10_JPRB, 0.20918302E-10_JPRB, 0.20165822E-10_JPRB, 0.19510334E-10_JPRB, 0.18820737E-10_JPRB, 0.18159559E-10_JPRB, &
  & 0.17527558E-10_JPRB, 0.17046267E-10_JPRB, 0.16819938E-10_JPRB, 0.16943563E-10_JPRB, 0.17477783E-10_JPRB, 0.18453315E-10_JPRB, &
  & 0.19872666E-10_JPRB, 0.21720455E-10_JPRB, 0.23943653E-10_JPRB, 0.26459872E-10_JPRB, 0.29143517E-10_JPRB, 0.31880651E-10_JPRB, &
  & 0.34561364E-10_JPRB, 0.37110356E-10_JPRB, 0.39504316E-10_JPRB, 0.41712307E-10_JPRB, 0.43793337E-10_JPRB, 0.45744204E-10_JPRB, &
  & 0.47601569E-10_JPRB, 0.49406097E-10_JPRB, 0.51214102E-10_JPRB, 0.53075974E-10_JPRB, 0.55016762E-10_JPRB, 0.56998555E-10_JPRB, &
  & 0.58960475E-10_JPRB, 0.60801461E-10_JPRB, 0.62412395E-10_JPRB, 0.63676946E-10_JPRB, 0.64520868E-10_JPRB, 0.64885777E-10_JPRB, &
  & 0.64745639E-10_JPRB, 0.64102126E-10_JPRB, 0.62999474E-10_JPRB, 0.61472896E-10_JPRB, 0.59640612E-10_JPRB, 0.57598815E-10_JPRB, &
  & 0.55459370E-10_JPRB, 0.53300791E-10_JPRB, 0.51173343E-10_JPRB, 0.49127480E-10_JPRB, 0.47192118E-10_JPRB, 0.45391843E-10_JPRB, &
  & 0.43704308E-10_JPRB, 0.42117629E-10_JPRB, 0.40618356E-10_JPRB, 0.39208092E-10_JPRB, 0.37891173E-10_JPRB, 0.36669730E-10_JPRB, &
  & 0.35539828E-10_JPRB, 0.34501832E-10_JPRB, 0.33558826E-10_JPRB, 0.32717565E-10_JPRB, 0.31991264E-10_JPRB, 0.31365729E-10_JPRB, &
  & 0.30838256E-10_JPRB, 0.30393375E-10_JPRB, 0.29987610E-10_JPRB, 0.29456104E-10_JPRB /)

RGHG9(:,29, 8) = (/ &
  & 0.26028728E-10_JPRB, 0.24995020E-10_JPRB, 0.24350836E-10_JPRB, 0.23748125E-10_JPRB, 0.23186016E-10_JPRB, 0.22601506E-10_JPRB, &
  & 0.22087790E-10_JPRB, 0.21723855E-10_JPRB, 0.21633691E-10_JPRB, 0.21913936E-10_JPRB, 0.22631178E-10_JPRB, 0.23812141E-10_JPRB, &
  & 0.25454951E-10_JPRB, 0.27527709E-10_JPRB, 0.29971525E-10_JPRB, 0.32680920E-10_JPRB, 0.35519247E-10_JPRB, 0.38352703E-10_JPRB, &
  & 0.41061980E-10_JPRB, 0.43558504E-10_JPRB, 0.45814123E-10_JPRB, 0.47813632E-10_JPRB, 0.49595987E-10_JPRB, 0.51186659E-10_JPRB, &
  & 0.52645402E-10_JPRB, 0.54073176E-10_JPRB, 0.55550550E-10_JPRB, 0.57168291E-10_JPRB, 0.58959782E-10_JPRB, 0.60930032E-10_JPRB, &
  & 0.62964266E-10_JPRB, 0.64944564E-10_JPRB, 0.66722017E-10_JPRB, 0.68142297E-10_JPRB, 0.69108642E-10_JPRB, 0.69556173E-10_JPRB, &
  & 0.69461784E-10_JPRB, 0.68829296E-10_JPRB, 0.67710754E-10_JPRB, 0.66152306E-10_JPRB, 0.64241557E-10_JPRB, 0.62103850E-10_JPRB, &
  & 0.59841972E-10_JPRB, 0.57560796E-10_JPRB, 0.55328211E-10_JPRB, 0.53214086E-10_JPRB, 0.51260586E-10_JPRB, 0.49478113E-10_JPRB, &
  & 0.47844208E-10_JPRB, 0.46323861E-10_JPRB, 0.44896330E-10_JPRB, 0.43555000E-10_JPRB, 0.42299404E-10_JPRB, 0.41124867E-10_JPRB, &
  & 0.40025289E-10_JPRB, 0.39002017E-10_JPRB, 0.38062744E-10_JPRB, 0.37223065E-10_JPRB, 0.36486935E-10_JPRB, 0.35844713E-10_JPRB, &
  & 0.35295357E-10_JPRB, 0.34817888E-10_JPRB, 0.34356285E-10_JPRB, 0.33633863E-10_JPRB /)

RGHG9(:,30, 8) = (/ &
  & 0.30091915E-10_JPRB, 0.29206422E-10_JPRB, 0.28645589E-10_JPRB, 0.28167158E-10_JPRB, 0.27680726E-10_JPRB, 0.27232867E-10_JPRB, &
  & 0.26844624E-10_JPRB, 0.26632328E-10_JPRB, 0.26706755E-10_JPRB, 0.27164635E-10_JPRB, 0.28065520E-10_JPRB, 0.29436651E-10_JPRB, &
  & 0.31260466E-10_JPRB, 0.33496844E-10_JPRB, 0.36070931E-10_JPRB, 0.38871864E-10_JPRB, 0.41752556E-10_JPRB, 0.44586283E-10_JPRB, &
  & 0.47238716E-10_JPRB, 0.49622542E-10_JPRB, 0.51707187E-10_JPRB, 0.53479384E-10_JPRB, 0.54966792E-10_JPRB, 0.56233452E-10_JPRB, &
  & 0.57360575E-10_JPRB, 0.58462277E-10_JPRB, 0.59656724E-10_JPRB, 0.61039611E-10_JPRB, 0.62664797E-10_JPRB, 0.64515823E-10_JPRB, &
  & 0.66516619E-10_JPRB, 0.68506166E-10_JPRB, 0.70306955E-10_JPRB, 0.71751514E-10_JPRB, 0.72729489E-10_JPRB, 0.73181253E-10_JPRB, &
  & 0.73092983E-10_JPRB, 0.72475609E-10_JPRB, 0.71370819E-10_JPRB, 0.69847690E-10_JPRB, 0.67956793E-10_JPRB, 0.65823541E-10_JPRB, &
  & 0.63559741E-10_JPRB, 0.61270836E-10_JPRB, 0.59052714E-10_JPRB, 0.56966976E-10_JPRB, 0.55057812E-10_JPRB, 0.53333803E-10_JPRB, &
  & 0.51764069E-10_JPRB, 0.50310721E-10_JPRB, 0.48952342E-10_JPRB, 0.47675065E-10_JPRB, 0.46472787E-10_JPRB, 0.45342188E-10_JPRB, &
  & 0.44275646E-10_JPRB, 0.43278790E-10_JPRB, 0.42362391E-10_JPRB, 0.41535893E-10_JPRB, 0.40790524E-10_JPRB, 0.40126433E-10_JPRB, &
  & 0.39540780E-10_JPRB, 0.39010784E-10_JPRB, 0.38472756E-10_JPRB, 0.37682215E-10_JPRB /)

RGHG9(:,31, 8) = (/ &
  & 0.34147869E-10_JPRB, 0.33403492E-10_JPRB, 0.32943925E-10_JPRB, 0.32537494E-10_JPRB, 0.32175717E-10_JPRB, 0.31836783E-10_JPRB, &
  & 0.31595972E-10_JPRB, 0.31544049E-10_JPRB, 0.31791087E-10_JPRB, 0.32423592E-10_JPRB, 0.33494825E-10_JPRB, 0.35014193E-10_JPRB, &
  & 0.36965268E-10_JPRB, 0.39285703E-10_JPRB, 0.41900212E-10_JPRB, 0.44693357E-10_JPRB, 0.47532880E-10_JPRB, 0.50280752E-10_JPRB, &
  & 0.52825556E-10_JPRB, 0.55073487E-10_JPRB, 0.56983470E-10_JPRB, 0.58550352E-10_JPRB, 0.59805431E-10_JPRB, 0.60821195E-10_JPRB, &
  & 0.61698383E-10_JPRB, 0.62558091E-10_JPRB, 0.63521473E-10_JPRB, 0.64694222E-10_JPRB, 0.66141238E-10_JPRB, 0.67849698E-10_JPRB, &
  & 0.69737126E-10_JPRB, 0.71634622E-10_JPRB, 0.73360568E-10_JPRB, 0.74733816E-10_JPRB, 0.75650652E-10_JPRB, 0.76059312E-10_JPRB, &
  & 0.75957754E-10_JPRB, 0.75362119E-10_JPRB, 0.74311585E-10_JPRB, 0.72852231E-10_JPRB, 0.71061899E-10_JPRB, 0.69010103E-10_JPRB, &
  & 0.66825441E-10_JPRB, 0.64619261E-10_JPRB, 0.62477010E-10_JPRB, 0.60473584E-10_JPRB, 0.58650300E-10_JPRB, 0.57010979E-10_JPRB, &
  & 0.55516786E-10_JPRB, 0.54132268E-10_JPRB, 0.52832561E-10_JPRB, 0.51604790E-10_JPRB, 0.50442032E-10_JPRB, 0.49343366E-10_JPRB, &
  & 0.48304857E-10_JPRB, 0.47331861E-10_JPRB, 0.46430908E-10_JPRB, 0.45601120E-10_JPRB, 0.44839351E-10_JPRB, 0.44156158E-10_JPRB, &
  & 0.43554080E-10_JPRB, 0.43014162E-10_JPRB, 0.42479451E-10_JPRB, 0.41634678E-10_JPRB /)

RGHG9(:,32, 8) = (/ &
  & 0.38031574E-10_JPRB, 0.37429664E-10_JPRB, 0.37065649E-10_JPRB, 0.36767023E-10_JPRB, 0.36497017E-10_JPRB, 0.36287362E-10_JPRB, &
  & 0.36187428E-10_JPRB, 0.36295435E-10_JPRB, 0.36708983E-10_JPRB, 0.37499871E-10_JPRB, 0.38703124E-10_JPRB, 0.40326412E-10_JPRB, &
  & 0.42333834E-10_JPRB, 0.44668529E-10_JPRB, 0.47245600E-10_JPRB, 0.49961431E-10_JPRB, 0.52690866E-10_JPRB, 0.55315853E-10_JPRB, &
  & 0.57722625E-10_JPRB, 0.59833097E-10_JPRB, 0.61599094E-10_JPRB, 0.63010291E-10_JPRB, 0.64107490E-10_JPRB, 0.64958802E-10_JPRB, &
  & 0.65675257E-10_JPRB, 0.66375294E-10_JPRB, 0.67181337E-10_JPRB, 0.68190842E-10_JPRB, 0.69464115E-10_JPRB, 0.71001441E-10_JPRB, &
  & 0.72717943E-10_JPRB, 0.74458016E-10_JPRB, 0.76031098E-10_JPRB, 0.77267658E-10_JPRB, 0.78074734E-10_JPRB, 0.78411805E-10_JPRB, &
  & 0.78290083E-10_JPRB, 0.77728386E-10_JPRB, 0.76753839E-10_JPRB, 0.75410587E-10_JPRB, 0.73742575E-10_JPRB, 0.71845224E-10_JPRB, &
  & 0.69808215E-10_JPRB, 0.67731584E-10_JPRB, 0.65725654E-10_JPRB, 0.63836929E-10_JPRB, 0.62115244E-10_JPRB, 0.60551716E-10_JPRB, &
  & 0.59125899E-10_JPRB, 0.57793818E-10_JPRB, 0.56536519E-10_JPRB, 0.55343601E-10_JPRB, 0.54208114E-10_JPRB, 0.53131236E-10_JPRB, &
  & 0.52112134E-10_JPRB, 0.51153613E-10_JPRB, 0.50257826E-10_JPRB, 0.49428621E-10_JPRB, 0.48670106E-10_JPRB, 0.47993800E-10_JPRB, &
  & 0.47400077E-10_JPRB, 0.46865220E-10_JPRB, 0.46314237E-10_JPRB, 0.45430524E-10_JPRB /)

RGHG9(:,33, 8) = (/ &
  & 0.41695616E-10_JPRB, 0.41241094E-10_JPRB, 0.40972101E-10_JPRB, 0.40758112E-10_JPRB, 0.40594424E-10_JPRB, 0.40498951E-10_JPRB, &
  & 0.40536099E-10_JPRB, 0.40794913E-10_JPRB, 0.41354458E-10_JPRB, 0.42270871E-10_JPRB, 0.43569384E-10_JPRB, 0.45237196E-10_JPRB, &
  & 0.47246752E-10_JPRB, 0.49531081E-10_JPRB, 0.52015881E-10_JPRB, 0.54600841E-10_JPRB, 0.57191647E-10_JPRB, 0.59669679E-10_JPRB, &
  & 0.61943554E-10_JPRB, 0.63932179E-10_JPRB, 0.65592039E-10_JPRB, 0.66916334E-10_JPRB, 0.67922785E-10_JPRB, 0.68692517E-10_JPRB, &
  & 0.69328113E-10_JPRB, 0.69941372E-10_JPRB, 0.70644511E-10_JPRB, 0.71526743E-10_JPRB, 0.72646625E-10_JPRB, 0.74003130E-10_JPRB, &
  & 0.75521762E-10_JPRB, 0.77049769E-10_JPRB, 0.78418737E-10_JPRB, 0.79472748E-10_JPRB, 0.80139485E-10_JPRB, 0.80390597E-10_JPRB, &
  & 0.80247815E-10_JPRB, 0.79725650E-10_JPRB, 0.78850731E-10_JPRB, 0.77642261E-10_JPRB, 0.76146298E-10_JPRB, 0.74423023E-10_JPRB, &
  & 0.72577729E-10_JPRB, 0.70694943E-10_JPRB, 0.68826729E-10_JPRB, 0.67079883E-10_JPRB, 0.65449306E-10_JPRB, 0.63960108E-10_JPRB, &
  & 0.62580892E-10_JPRB, 0.61289765E-10_JPRB, 0.60056286E-10_JPRB, 0.58878076E-10_JPRB, 0.57756810E-10_JPRB, 0.56690545E-10_JPRB, &
  & 0.55681466E-10_JPRB, 0.54734078E-10_JPRB, 0.53850181E-10_JPRB, 0.53029209E-10_JPRB, 0.52282085E-10_JPRB, 0.51614657E-10_JPRB, &
  & 0.51025795E-10_JPRB, 0.50490133E-10_JPRB, 0.49939892E-10_JPRB, 0.49064267E-10_JPRB /)

RGHG9(:,34, 8) = (/ &
  & 0.45143621E-10_JPRB, 0.44804577E-10_JPRB, 0.44623690E-10_JPRB, 0.44497919E-10_JPRB, 0.44425980E-10_JPRB, 0.44439952E-10_JPRB, &
  & 0.44601840E-10_JPRB, 0.44988176E-10_JPRB, 0.45666845E-10_JPRB, 0.46674987E-10_JPRB, 0.48018520E-10_JPRB, 0.49690193E-10_JPRB, &
  & 0.51647249E-10_JPRB, 0.53840460E-10_JPRB, 0.56194598E-10_JPRB, 0.58632724E-10_JPRB, 0.61060941E-10_JPRB, 0.63400139E-10_JPRB, &
  & 0.65553785E-10_JPRB, 0.67457068E-10_JPRB, 0.69059633E-10_JPRB, 0.70331081E-10_JPRB, 0.71317625E-10_JPRB, 0.72076824E-10_JPRB, &
  & 0.72701810E-10_JPRB, 0.73288285E-10_JPRB, 0.73937745E-10_JPRB, 0.74727870E-10_JPRB, 0.75705289E-10_JPRB, 0.76875027E-10_JPRB, &
  & 0.78165148E-10_JPRB, 0.79449808E-10_JPRB, 0.80576677E-10_JPRB, 0.81421044E-10_JPRB, 0.81931691E-10_JPRB, 0.82092118E-10_JPRB, &
  & 0.81929651E-10_JPRB, 0.81452144E-10_JPRB, 0.80681690E-10_JPRB, 0.79630073E-10_JPRB, 0.78316562E-10_JPRB, 0.76799810E-10_JPRB, &
  & 0.75164340E-10_JPRB, 0.73488292E-10_JPRB, 0.71801474E-10_JPRB, 0.70163944E-10_JPRB, 0.68636916E-10_JPRB, 0.67202972E-10_JPRB, &
  & 0.65854218E-10_JPRB, 0.64581993E-10_JPRB, 0.63363148E-10_JPRB, 0.62186124E-10_JPRB, 0.61068470E-10_JPRB, 0.60007804E-10_JPRB, &
  & 0.59007819E-10_JPRB, 0.58072810E-10_JPRB, 0.57202722E-10_JPRB, 0.56397227E-10_JPRB, 0.55662919E-10_JPRB, 0.55006978E-10_JPRB, &
  & 0.54429565E-10_JPRB, 0.53909269E-10_JPRB, 0.53375748E-10_JPRB, 0.52500507E-10_JPRB /)

RGHG9(:,35, 8) = (/ &
  & 0.48288387E-10_JPRB, 0.48113864E-10_JPRB, 0.48019012E-10_JPRB, 0.47973649E-10_JPRB, 0.47988502E-10_JPRB, 0.48099337E-10_JPRB, &
  & 0.48364555E-10_JPRB, 0.48854618E-10_JPRB, 0.49618622E-10_JPRB, 0.50676498E-10_JPRB, 0.52034644E-10_JPRB, 0.53664660E-10_JPRB, &
  & 0.55543681E-10_JPRB, 0.57612998E-10_JPRB, 0.59823431E-10_JPRB, 0.62097549E-10_JPRB, 0.64373638E-10_JPRB, 0.66571838E-10_JPRB, &
  & 0.68620838E-10_JPRB, 0.70459930E-10_JPRB, 0.72029965E-10_JPRB, 0.73318997E-10_JPRB, 0.74348167E-10_JPRB, 0.75154896E-10_JPRB, &
  & 0.75819809E-10_JPRB, 0.76424388E-10_JPRB, 0.77049846E-10_JPRB, 0.77764649E-10_JPRB, 0.78607967E-10_JPRB, 0.79580176E-10_JPRB, &
  & 0.80627310E-10_JPRB, 0.81641624E-10_JPRB, 0.82509416E-10_JPRB, 0.83136421E-10_JPRB, 0.83490291E-10_JPRB, 0.83566563E-10_JPRB, &
  & 0.83388366E-10_JPRB, 0.82959938E-10_JPRB, 0.82300708E-10_JPRB, 0.81399838E-10_JPRB, 0.80279235E-10_JPRB, 0.78974619E-10_JPRB, &
  & 0.77555753E-10_JPRB, 0.76092251E-10_JPRB, 0.74574485E-10_JPRB, 0.73057609E-10_JPRB, 0.71613090E-10_JPRB, 0.70231779E-10_JPRB, &
  & 0.68902724E-10_JPRB, 0.67638520E-10_JPRB, 0.66424512E-10_JPRB, 0.65243110E-10_JPRB, 0.64123810E-10_JPRB, 0.63069647E-10_JPRB, &
  & 0.62080799E-10_JPRB, 0.61163415E-10_JPRB, 0.60312276E-10_JPRB, 0.59525579E-10_JPRB, 0.58809374E-10_JPRB, 0.58170600E-10_JPRB, &
  & 0.57610014E-10_JPRB, 0.57103648E-10_JPRB, 0.56579012E-10_JPRB, 0.55726923E-10_JPRB /)

RGHG9(:,36, 8) = (/ &
  & 0.51242975E-10_JPRB, 0.51187103E-10_JPRB, 0.51173722E-10_JPRB, 0.51202678E-10_JPRB, 0.51294705E-10_JPRB, 0.51486825E-10_JPRB, &
  & 0.51835713E-10_JPRB, 0.52398717E-10_JPRB, 0.53213101E-10_JPRB, 0.54293323E-10_JPRB, 0.55625407E-10_JPRB, 0.57195637E-10_JPRB, &
  & 0.58967331E-10_JPRB, 0.60905003E-10_JPRB, 0.62956786E-10_JPRB, 0.65074168E-10_JPRB, 0.67192744E-10_JPRB, 0.69266155E-10_JPRB, &
  & 0.71230501E-10_JPRB, 0.73022213E-10_JPRB, 0.74605155E-10_JPRB, 0.75945514E-10_JPRB, 0.77043025E-10_JPRB, 0.77928490E-10_JPRB, &
  & 0.78649913E-10_JPRB, 0.79283052E-10_JPRB, 0.79892051E-10_JPRB, 0.80531984E-10_JPRB, 0.81236129E-10_JPRB, 0.82006499E-10_JPRB, &
  & 0.82800745E-10_JPRB, 0.83547030E-10_JPRB, 0.84162788E-10_JPRB, 0.84588413E-10_JPRB, 0.84806252E-10_JPRB, 0.84818569E-10_JPRB, &
  & 0.84638851E-10_JPRB, 0.84271708E-10_JPRB, 0.83720461E-10_JPRB, 0.82974266E-10_JPRB, 0.82036912E-10_JPRB, 0.80940199E-10_JPRB, &
  & 0.79736079E-10_JPRB, 0.78447977E-10_JPRB, 0.77091347E-10_JPRB, 0.75701709E-10_JPRB, 0.74335475E-10_JPRB, 0.72995963E-10_JPRB, &
  & 0.71685505E-10_JPRB, 0.70427109E-10_JPRB, 0.69210096E-10_JPRB, 0.68028957E-10_JPRB, 0.66912545E-10_JPRB, 0.65868637E-10_JPRB, &
  & 0.64899273E-10_JPRB, 0.64005440E-10_JPRB, 0.63178858E-10_JPRB, 0.62417238E-10_JPRB, 0.61724265E-10_JPRB, 0.61107765E-10_JPRB, &
  & 0.60566954E-10_JPRB, 0.60079143E-10_JPRB, 0.59573090E-10_JPRB, 0.58743378E-10_JPRB /)

RGHG9(:,37, 8) = (/ &
  & 0.53989972E-10_JPRB, 0.54056169E-10_JPRB, 0.54118571E-10_JPRB, 0.54216093E-10_JPRB, 0.54375737E-10_JPRB, 0.54637146E-10_JPRB, &
  & 0.55048997E-10_JPRB, 0.55658218E-10_JPRB, 0.56494868E-10_JPRB, 0.57560713E-10_JPRB, 0.58848801E-10_JPRB, 0.60329942E-10_JPRB, &
  & 0.61984910E-10_JPRB, 0.63775825E-10_JPRB, 0.65670962E-10_JPRB, 0.67624156E-10_JPRB, 0.69601262E-10_JPRB, 0.71548094E-10_JPRB, &
  & 0.73435959E-10_JPRB, 0.75210137E-10_JPRB, 0.76811488E-10_JPRB, 0.78205602E-10_JPRB, 0.79363953E-10_JPRB, 0.80293154E-10_JPRB, &
  & 0.81043103E-10_JPRB, 0.81664994E-10_JPRB, 0.82227072E-10_JPRB, 0.82776237E-10_JPRB, 0.83339412E-10_JPRB, 0.83919607E-10_JPRB, &
  & 0.84491428E-10_JPRB, 0.85007154E-10_JPRB, 0.85417722E-10_JPRB, 0.85687936E-10_JPRB, 0.85810664E-10_JPRB, 0.85789743E-10_JPRB, &
  & 0.85632591E-10_JPRB, 0.85339888E-10_JPRB, 0.84906304E-10_JPRB, 0.84314791E-10_JPRB, 0.83562546E-10_JPRB, 0.82666728E-10_JPRB, &
  & 0.81648598E-10_JPRB, 0.80525933E-10_JPRB, 0.79323131E-10_JPRB, 0.78060433E-10_JPRB, 0.76770229E-10_JPRB, 0.75471587E-10_JPRB, &
  & 0.74188239E-10_JPRB, 0.72935782E-10_JPRB, 0.71717535E-10_JPRB, 0.70542905E-10_JPRB, 0.69439073E-10_JPRB, 0.68415822E-10_JPRB, &
  & 0.67473721E-10_JPRB, 0.66611286E-10_JPRB, 0.65816859E-10_JPRB, 0.65085992E-10_JPRB, 0.64421919E-10_JPRB, 0.63832016E-10_JPRB, &
  & 0.63315540E-10_JPRB, 0.62848525E-10_JPRB, 0.62363677E-10_JPRB, 0.61564809E-10_JPRB /)

RGHG9(:,38, 8) = (/ &
  & 0.56577271E-10_JPRB, 0.56755739E-10_JPRB, 0.56886870E-10_JPRB, 0.57045511E-10_JPRB, 0.57268003E-10_JPRB, 0.57587216E-10_JPRB, &
  & 0.58045072E-10_JPRB, 0.58678909E-10_JPRB, 0.59507038E-10_JPRB, 0.60535896E-10_JPRB, 0.61751063E-10_JPRB, 0.63131188E-10_JPRB, &
  & 0.64652436E-10_JPRB, 0.66292437E-10_JPRB, 0.68024315E-10_JPRB, 0.69820871E-10_JPRB, 0.71651636E-10_JPRB, 0.73489860E-10_JPRB, &
  & 0.75296054E-10_JPRB, 0.77028967E-10_JPRB, 0.78634217E-10_JPRB, 0.80033216E-10_JPRB, 0.81186793E-10_JPRB, 0.82096413E-10_JPRB, &
  & 0.82795368E-10_JPRB, 0.83359396E-10_JPRB, 0.83844806E-10_JPRB, 0.84296924E-10_JPRB, 0.84738994E-10_JPRB, 0.85173604E-10_JPRB, &
  & 0.85584984E-10_JPRB, 0.85944134E-10_JPRB, 0.86219559E-10_JPRB, 0.86392810E-10_JPRB, 0.86461782E-10_JPRB, 0.86432514E-10_JPRB, &
  & 0.86308495E-10_JPRB, 0.86090551E-10_JPRB, 0.85768739E-10_JPRB, 0.85328300E-10_JPRB, 0.84756063E-10_JPRB, 0.84057011E-10_JPRB, &
  & 0.83221853E-10_JPRB, 0.82277692E-10_JPRB, 0.81229717E-10_JPRB, 0.80091565E-10_JPRB, 0.78885815E-10_JPRB, 0.77644800E-10_JPRB, &
  & 0.76394023E-10_JPRB, 0.75158026E-10_JPRB, 0.73949735E-10_JPRB, 0.72794146E-10_JPRB, 0.71715023E-10_JPRB, 0.70723059E-10_JPRB, &
  & 0.69818949E-10_JPRB, 0.68995809E-10_JPRB, 0.68240108E-10_JPRB, 0.67545414E-10_JPRB, 0.66915425E-10_JPRB, 0.66357683E-10_JPRB, &
  & 0.65869983E-10_JPRB, 0.65428447E-10_JPRB, 0.64966844E-10_JPRB, 0.64206022E-10_JPRB /)

RGHG9(:,39, 8) = (/ &
  & 0.59038399E-10_JPRB, 0.59314678E-10_JPRB, 0.59504228E-10_JPRB, 0.59720465E-10_JPRB, 0.59995016E-10_JPRB, 0.60364727E-10_JPRB, &
  & 0.60856251E-10_JPRB, 0.61491881E-10_JPRB, 0.62291054E-10_JPRB, 0.63258107E-10_JPRB, 0.64382465E-10_JPRB, 0.65645739E-10_JPRB, &
  & 0.67027356E-10_JPRB, 0.68509566E-10_JPRB, 0.70077728E-10_JPRB, 0.71713378E-10_JPRB, 0.73399627E-10_JPRB, 0.75117246E-10_JPRB, &
  & 0.76834955E-10_JPRB, 0.78510004E-10_JPRB, 0.80057197E-10_JPRB, 0.81406132E-10_JPRB, 0.82489522E-10_JPRB, 0.83314765E-10_JPRB, &
  & 0.83939106E-10_JPRB, 0.84426813E-10_JPRB, 0.84839843E-10_JPRB, 0.85214655E-10_JPRB, 0.85569926E-10_JPRB, 0.85908364E-10_JPRB, &
  & 0.86220704E-10_JPRB, 0.86485423E-10_JPRB, 0.86683140E-10_JPRB, 0.86801503E-10_JPRB, 0.86842721E-10_JPRB, 0.86812134E-10_JPRB, &
  & 0.86714524E-10_JPRB, 0.86549851E-10_JPRB, 0.86313019E-10_JPRB, 0.85989223E-10_JPRB, 0.85570592E-10_JPRB, 0.85045068E-10_JPRB, &
  & 0.84399467E-10_JPRB, 0.83645604E-10_JPRB, 0.82767876E-10_JPRB, 0.81773664E-10_JPRB, 0.80679012E-10_JPRB, 0.79511252E-10_JPRB, &
  & 0.78310143E-10_JPRB, 0.77101658E-10_JPRB, 0.75919104E-10_JPRB, 0.74794504E-10_JPRB, 0.73752282E-10_JPRB, 0.72803590E-10_JPRB, &
  & 0.71946477E-10_JPRB, 0.71169695E-10_JPRB, 0.70457785E-10_JPRB, 0.69804280E-10_JPRB, 0.69212906E-10_JPRB, 0.68691469E-10_JPRB, &
  & 0.68236472E-10_JPRB, 0.67823636E-10_JPRB, 0.67390940E-10_JPRB, 0.66676192E-10_JPRB /)

RGHG9(:,40, 8) = (/ &
  & 0.61414894E-10_JPRB, 0.61761804E-10_JPRB, 0.61997282E-10_JPRB, 0.62251239E-10_JPRB, 0.62575889E-10_JPRB, 0.62986109E-10_JPRB, &
  & 0.63494848E-10_JPRB, 0.64121736E-10_JPRB, 0.64872260E-10_JPRB, 0.65759814E-10_JPRB, 0.66781171E-10_JPRB, 0.67918490E-10_JPRB, &
  & 0.69156021E-10_JPRB, 0.70480725E-10_JPRB, 0.71884151E-10_JPRB, 0.73358472E-10_JPRB, 0.74895971E-10_JPRB, 0.76482147E-10_JPRB, &
  & 0.78096023E-10_JPRB, 0.79672657E-10_JPRB, 0.81141149E-10_JPRB, 0.82389817E-10_JPRB, 0.83378235E-10_JPRB, 0.84117859E-10_JPRB, &
  & 0.84666489E-10_JPRB, 0.85093786E-10_JPRB, 0.85450827E-10_JPRB, 0.85769947E-10_JPRB, 0.86066473E-10_JPRB, 0.86343883E-10_JPRB, &
  & 0.86594523E-10_JPRB, 0.86804383E-10_JPRB, 0.86956713E-10_JPRB, 0.87044413E-10_JPRB, 0.87070046E-10_JPRB, 0.87039889E-10_JPRB, &
  & 0.86958392E-10_JPRB, 0.86827087E-10_JPRB, 0.86643297E-10_JPRB, 0.86397840E-10_JPRB, 0.86085389E-10_JPRB, 0.85694243E-10_JPRB, &
  & 0.85209437E-10_JPRB, 0.84633078E-10_JPRB, 0.83934630E-10_JPRB, 0.83104426E-10_JPRB, 0.82143563E-10_JPRB, 0.81075806E-10_JPRB, &
  & 0.79939715E-10_JPRB, 0.78778942E-10_JPRB, 0.77637854E-10_JPRB, 0.76557219E-10_JPRB, 0.75563694E-10_JPRB, 0.74667383E-10_JPRB, &
  & 0.73864602E-10_JPRB, 0.73139321E-10_JPRB, 0.72476594E-10_JPRB, 0.71867498E-10_JPRB, 0.71319020E-10_JPRB, 0.70837156E-10_JPRB, &
  & 0.70418005E-10_JPRB, 0.70036352E-10_JPRB, 0.69635207E-10_JPRB, 0.68970878E-10_JPRB /)

RGHG9(:,41, 8) = (/ &
  & 0.63746952E-10_JPRB, 0.64134718E-10_JPRB, 0.64380619E-10_JPRB, 0.64663795E-10_JPRB, 0.65018678E-10_JPRB, 0.65457958E-10_JPRB, &
  & 0.65981651E-10_JPRB, 0.66578756E-10_JPRB, 0.67272132E-10_JPRB, 0.68072131E-10_JPRB, 0.68981015E-10_JPRB, 0.69990416E-10_JPRB, &
  & 0.71084992E-10_JPRB, 0.72254702E-10_JPRB, 0.73496237E-10_JPRB, 0.74809381E-10_JPRB, 0.76192462E-10_JPRB, 0.77643135E-10_JPRB, &
  & 0.79129779E-10_JPRB, 0.80606133E-10_JPRB, 0.81961708E-10_JPRB, 0.83114474E-10_JPRB, 0.84007877E-10_JPRB, 0.84669445E-10_JPRB, &
  & 0.85158998E-10_JPRB, 0.85538139E-10_JPRB, 0.85853692E-10_JPRB, 0.86132365E-10_JPRB, 0.86387772E-10_JPRB, 0.86623160E-10_JPRB, &
  & 0.86834887E-10_JPRB, 0.87009289E-10_JPRB, 0.87134709E-10_JPRB, 0.87203578E-10_JPRB, 0.87220259E-10_JPRB, 0.87190671E-10_JPRB, &
  & 0.87119596E-10_JPRB, 0.87008956E-10_JPRB, 0.86858638E-10_JPRB, 0.86662906E-10_JPRB, 0.86419927E-10_JPRB, 0.86121471E-10_JPRB, &
  & 0.85755993E-10_JPRB, 0.85322166E-10_JPRB, 0.84782611E-10_JPRB, 0.84117491E-10_JPRB, 0.83307618E-10_JPRB, 0.82355761E-10_JPRB, &
  & 0.81311242E-10_JPRB, 0.80213336E-10_JPRB, 0.79128405E-10_JPRB, 0.78101442E-10_JPRB, 0.77163387E-10_JPRB, 0.76326494E-10_JPRB, &
  & 0.75582061E-10_JPRB, 0.74914325E-10_JPRB, 0.74303660E-10_JPRB, 0.73744025E-10_JPRB, 0.73240476E-10_JPRB, 0.72800529E-10_JPRB, &
  & 0.72417995E-10_JPRB, 0.72068553E-10_JPRB, 0.71698730E-10_JPRB, 0.71087233E-10_JPRB /)

RGHG9(:,42, 8) = (/ &
  & 0.66163595E-10_JPRB, 0.66460393E-10_JPRB, 0.66683145E-10_JPRB, 0.66960992E-10_JPRB, 0.67338017E-10_JPRB, 0.67803811E-10_JPRB, &
  & 0.68317699E-10_JPRB, 0.68887951E-10_JPRB, 0.69514360E-10_JPRB, 0.70222717E-10_JPRB, 0.71020662E-10_JPRB, 0.71903608E-10_JPRB, &
  & 0.72859774E-10_JPRB, 0.73881214E-10_JPRB, 0.74966908E-10_JPRB, 0.76120270E-10_JPRB, 0.77349578E-10_JPRB, 0.78651821E-10_JPRB, &
  & 0.80014627E-10_JPRB, 0.81367926E-10_JPRB, 0.82624643E-10_JPRB, 0.83674678E-10_JPRB, 0.84484725E-10_JPRB, 0.85080103E-10_JPRB, &
  & 0.85519543E-10_JPRB, 0.85860520E-10_JPRB, 0.86142767E-10_JPRB, 0.86390034E-10_JPRB, 0.86614306E-10_JPRB, 0.86820190E-10_JPRB, &
  & 0.87003675E-10_JPRB, 0.87155491E-10_JPRB, 0.87262475E-10_JPRB, 0.87319679E-10_JPRB, 0.87330754E-10_JPRB, 0.87302117E-10_JPRB, &
  & 0.87238258E-10_JPRB, 0.87141724E-10_JPRB, 0.87013390E-10_JPRB, 0.86850374E-10_JPRB, 0.86653094E-10_JPRB, 0.86417921E-10_JPRB, &
  & 0.86135717E-10_JPRB, 0.85805973E-10_JPRB, 0.85395885E-10_JPRB, 0.84876051E-10_JPRB, 0.84213199E-10_JPRB, 0.83396706E-10_JPRB, &
  & 0.82452552E-10_JPRB, 0.81433991E-10_JPRB, 0.80414619E-10_JPRB, 0.79448267E-10_JPRB, 0.78571913E-10_JPRB, 0.77797213E-10_JPRB, &
  & 0.77116966E-10_JPRB, 0.76509549E-10_JPRB, 0.75956505E-10_JPRB, 0.75448391E-10_JPRB, 0.74992165E-10_JPRB, 0.74593810E-10_JPRB, &
  & 0.74247247E-10_JPRB, 0.73928572E-10_JPRB, 0.73589114E-10_JPRB, 0.73026342E-10_JPRB /)

RGHG9(:,43, 8) = (/ &
  & 0.68245437E-10_JPRB, 0.68612907E-10_JPRB, 0.68856039E-10_JPRB, 0.69151393E-10_JPRB, 0.69551434E-10_JPRB, 0.70025853E-10_JPRB, &
  & 0.70540004E-10_JPRB, 0.71066486E-10_JPRB, 0.71629216E-10_JPRB, 0.72248499E-10_JPRB, 0.72939391E-10_JPRB, 0.73701413E-10_JPRB, &
  & 0.74526663E-10_JPRB, 0.75407881E-10_JPRB, 0.76344375E-10_JPRB, 0.77344714E-10_JPRB, 0.78416593E-10_JPRB, 0.79573223E-10_JPRB, &
  & 0.80793941E-10_JPRB, 0.82033678E-10_JPRB, 0.83178506E-10_JPRB, 0.84137024E-10_JPRB, 0.84868071E-10_JPRB, 0.85404343E-10_JPRB, &
  & 0.85801401E-10_JPRB, 0.86109474E-10_JPRB, 0.86364110E-10_JPRB, 0.86585746E-10_JPRB, 0.86785849E-10_JPRB, 0.86968779E-10_JPRB, &
  & 0.87132621E-10_JPRB, 0.87267422E-10_JPRB, 0.87362360E-10_JPRB, 0.87411502E-10_JPRB, 0.87419252E-10_JPRB, 0.87391837E-10_JPRB, &
  & 0.87333640E-10_JPRB, 0.87247140E-10_JPRB, 0.87134362E-10_JPRB, 0.86993877E-10_JPRB, 0.86827941E-10_JPRB, 0.86636268E-10_JPRB, &
  & 0.86413418E-10_JPRB, 0.86158830E-10_JPRB, 0.85847593E-10_JPRB, 0.85447163E-10_JPRB, 0.84922243E-10_JPRB, 0.84236090E-10_JPRB, &
  & 0.83405387E-10_JPRB, 0.82475235E-10_JPRB, 0.81528569E-10_JPRB, 0.80625603E-10_JPRB, 0.79812192E-10_JPRB, 0.79104646E-10_JPRB, &
  & 0.78490651E-10_JPRB, 0.77949189E-10_JPRB, 0.77456395E-10_JPRB, 0.77002897E-10_JPRB, 0.76593724E-10_JPRB, 0.76235782E-10_JPRB, &
  & 0.75922824E-10_JPRB, 0.75632431E-10_JPRB, 0.75320444E-10_JPRB, 0.74801221E-10_JPRB /)

RGHG9(:,44, 8) = (/ &
  & 0.70219351E-10_JPRB, 0.70712276E-10_JPRB, 0.70983067E-10_JPRB, 0.71290626E-10_JPRB, 0.71695039E-10_JPRB, 0.72180012E-10_JPRB, &
  & 0.72669371E-10_JPRB, 0.73155343E-10_JPRB, 0.73653236E-10_JPRB, 0.74188197E-10_JPRB, 0.74777871E-10_JPRB, 0.75426963E-10_JPRB, &
  & 0.76128472E-10_JPRB, 0.76876470E-10_JPRB, 0.77673826E-10_JPRB, 0.78523611E-10_JPRB, 0.79445714E-10_JPRB, 0.80444207E-10_JPRB, &
  & 0.81528284E-10_JPRB, 0.82633268E-10_JPRB, 0.83671334E-10_JPRB, 0.84532298E-10_JPRB, 0.85188988E-10_JPRB, 0.85671525E-10_JPRB, &
  & 0.86030037E-10_JPRB, 0.86309515E-10_JPRB, 0.86540261E-10_JPRB, 0.86740559E-10_JPRB, 0.86921248E-10_JPRB, 0.87086824E-10_JPRB, &
  & 0.87235309E-10_JPRB, 0.87358273E-10_JPRB, 0.87444225E-10_JPRB, 0.87488128E-10_JPRB, 0.87494019E-10_JPRB, 0.87468144E-10_JPRB, &
  & 0.87414583E-10_JPRB, 0.87335923E-10_JPRB, 0.87234199E-10_JPRB, 0.87110333E-10_JPRB, 0.86966365E-10_JPRB, 0.86806430E-10_JPRB, &
  & 0.86625894E-10_JPRB, 0.86426886E-10_JPRB, 0.86190208E-10_JPRB, 0.85886728E-10_JPRB, 0.85479721E-10_JPRB, 0.84923062E-10_JPRB, &
  & 0.84210319E-10_JPRB, 0.83374911E-10_JPRB, 0.82502422E-10_JPRB, 0.81664911E-10_JPRB, 0.80918362E-10_JPRB, 0.80278964E-10_JPRB, &
  & 0.79736537E-10_JPRB, 0.79263263E-10_JPRB, 0.78834148E-10_JPRB, 0.78435758E-10_JPRB, 0.78072611E-10_JPRB, 0.77752159E-10_JPRB, &
  & 0.77469670E-10_JPRB, 0.77205145E-10_JPRB, 0.76917459E-10_JPRB, 0.76437280E-10_JPRB /)

RGHG9(:,45, 8) = (/ &
  & 0.72731030E-10_JPRB, 0.72986964E-10_JPRB, 0.73184091E-10_JPRB, 0.73446388E-10_JPRB, 0.73839233E-10_JPRB, 0.74300462E-10_JPRB, &
  & 0.74758470E-10_JPRB, 0.75196724E-10_JPRB, 0.75627241E-10_JPRB, 0.76082085E-10_JPRB, 0.76576454E-10_JPRB, 0.77116993E-10_JPRB, &
  & 0.77700360E-10_JPRB, 0.78323417E-10_JPRB, 0.78983417E-10_JPRB, 0.79694550E-10_JPRB, 0.80460923E-10_JPRB, 0.81313609E-10_JPRB, &
  & 0.82235593E-10_JPRB, 0.83209210E-10_JPRB, 0.84116519E-10_JPRB, 0.84879437E-10_JPRB, 0.85462207E-10_JPRB, 0.85893875E-10_JPRB, &
  & 0.86218303E-10_JPRB, 0.86472274E-10_JPRB, 0.86682453E-10_JPRB, 0.86865293E-10_JPRB, 0.87030369E-10_JPRB, 0.87182442E-10_JPRB, &
  & 0.87319624E-10_JPRB, 0.87433477E-10_JPRB, 0.87513295E-10_JPRB, 0.87553777E-10_JPRB, 0.87558960E-10_JPRB, 0.87534903E-10_JPRB, &
  & 0.87485269E-10_JPRB, 0.87412654E-10_JPRB, 0.87319624E-10_JPRB, 0.87207484E-10_JPRB, 0.87080600E-10_JPRB, 0.86942800E-10_JPRB, &
  & 0.86794988E-10_JPRB, 0.86635747E-10_JPRB, 0.86455634E-10_JPRB, 0.86227241E-10_JPRB, 0.85919813E-10_JPRB, 0.85484383E-10_JPRB, &
  & 0.84890969E-10_JPRB, 0.84161497E-10_JPRB, 0.83368271E-10_JPRB, 0.82601093E-10_JPRB, 0.81923600E-10_JPRB, 0.81357893E-10_JPRB, &
  & 0.80889927E-10_JPRB, 0.80486964E-10_JPRB, 0.80121423E-10_JPRB, 0.79777282E-10_JPRB, 0.79457177E-10_JPRB, 0.79170698E-10_JPRB, &
  & 0.78915194E-10_JPRB, 0.78673568E-10_JPRB, 0.78408995E-10_JPRB, 0.77964579E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART15',1,ZHOOK_HANDLE)
END SUBROUTINE PART15




SUBROUTINE PART16
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART16',0,ZHOOK_HANDLE)



RGHG9(:,46, 8) = (/ &
  & 0.74422420E-10_JPRB, 0.74956763E-10_JPRB, 0.75262047E-10_JPRB, 0.75588674E-10_JPRB, 0.75989798E-10_JPRB, 0.76438328E-10_JPRB, &
  & 0.76860442E-10_JPRB, 0.77237008E-10_JPRB, 0.77601932E-10_JPRB, 0.77972406E-10_JPRB, 0.78371823E-10_JPRB, 0.78806017E-10_JPRB, &
  & 0.79274212E-10_JPRB, 0.79771273E-10_JPRB, 0.80303826E-10_JPRB, 0.80870644E-10_JPRB, 0.81497781E-10_JPRB, 0.82184592E-10_JPRB, &
  & 0.82959806E-10_JPRB, 0.83761068E-10_JPRB, 0.84535559E-10_JPRB, 0.85186379E-10_JPRB, 0.85695513E-10_JPRB, 0.86080289E-10_JPRB, &
  & 0.86373117E-10_JPRB, 0.86604869E-10_JPRB, 0.86797756E-10_JPRB, 0.86966011E-10_JPRB, 0.87119117E-10_JPRB, 0.87260824E-10_JPRB, &
  & 0.87389374E-10_JPRB, 0.87496760E-10_JPRB, 0.87572144E-10_JPRB, 0.87610703E-10_JPRB, 0.87616109E-10_JPRB, 0.87593953E-10_JPRB, &
  & 0.87547872E-10_JPRB, 0.87480218E-10_JPRB, 0.87393370E-10_JPRB, 0.87291167E-10_JPRB, 0.87175996E-10_JPRB, 0.87056203E-10_JPRB, &
  & 0.86930879E-10_JPRB, 0.86802503E-10_JPRB, 0.86662399E-10_JPRB, 0.86491661E-10_JPRB, 0.86263587E-10_JPRB, 0.85934065E-10_JPRB, &
  & 0.85467057E-10_JPRB, 0.84852826E-10_JPRB, 0.84155419E-10_JPRB, 0.83466567E-10_JPRB, 0.82864618E-10_JPRB, 0.82377521E-10_JPRB, &
  & 0.81982775E-10_JPRB, 0.81649389E-10_JPRB, 0.81343758E-10_JPRB, 0.81050201E-10_JPRB, 0.80770078E-10_JPRB, 0.80513103E-10_JPRB, &
  & 0.80281670E-10_JPRB, 0.80061117E-10_JPRB, 0.79818055E-10_JPRB, 0.79409458E-10_JPRB /)

RGHG9(:,47, 8) = (/ &
  & 0.76678233E-10_JPRB, 0.77124043E-10_JPRB, 0.77433254E-10_JPRB, 0.77776764E-10_JPRB, 0.78202472E-10_JPRB, 0.78641850E-10_JPRB, &
  & 0.79011964E-10_JPRB, 0.79331139E-10_JPRB, 0.79614461E-10_JPRB, 0.79897630E-10_JPRB, 0.80195718E-10_JPRB, 0.80519522E-10_JPRB, &
  & 0.80868409E-10_JPRB, 0.81243200E-10_JPRB, 0.81641395E-10_JPRB, 0.82077525E-10_JPRB, 0.82551591E-10_JPRB, 0.83091214E-10_JPRB, &
  & 0.83678620E-10_JPRB, 0.84314243E-10_JPRB, 0.84921445E-10_JPRB, 0.85459993E-10_JPRB, 0.85895034E-10_JPRB, 0.86234749E-10_JPRB, &
  & 0.86499981E-10_JPRB, 0.86712443E-10_JPRB, 0.86890620E-10_JPRB, 0.87047640E-10_JPRB, 0.87191199E-10_JPRB, 0.87325217E-10_JPRB, &
  & 0.87447605E-10_JPRB, 0.87550071E-10_JPRB, 0.87622666E-10_JPRB, 0.87660379E-10_JPRB, 0.87666645E-10_JPRB, 0.87646619E-10_JPRB, &
  & 0.87603605E-10_JPRB, 0.87539850E-10_JPRB, 0.87458665E-10_JPRB, 0.87362909E-10_JPRB, 0.87258534E-10_JPRB, 0.87150231E-10_JPRB, &
  & 0.87043275E-10_JPRB, 0.86935716E-10_JPRB, 0.86825283E-10_JPRB, 0.86696317E-10_JPRB, 0.86528215E-10_JPRB, 0.86289989E-10_JPRB, &
  & 0.85939270E-10_JPRB, 0.85463164E-10_JPRB, 0.84880977E-10_JPRB, 0.84292476E-10_JPRB, 0.83776194E-10_JPRB, 0.83364995E-10_JPRB, &
  & 0.83043621E-10_JPRB, 0.82770860E-10_JPRB, 0.82520039E-10_JPRB, 0.82271578E-10_JPRB, 0.82025588E-10_JPRB, 0.81795237E-10_JPRB, &
  & 0.81584309E-10_JPRB, 0.81382727E-10_JPRB, 0.81160134E-10_JPRB, 0.80785850E-10_JPRB /)

RGHG9(:,48, 8) = (/ &
  & 0.78489618E-10_JPRB, 0.79078979E-10_JPRB, 0.79475752E-10_JPRB, 0.79896943E-10_JPRB, 0.80380501E-10_JPRB, 0.80831619E-10_JPRB, &
  & 0.81186113E-10_JPRB, 0.81444351E-10_JPRB, 0.81656952E-10_JPRB, 0.81851442E-10_JPRB, 0.82047820E-10_JPRB, 0.82258832E-10_JPRB, &
  & 0.82488280E-10_JPRB, 0.82736609E-10_JPRB, 0.83008100E-10_JPRB, 0.83302587E-10_JPRB, 0.83632434E-10_JPRB, 0.83995123E-10_JPRB, &
  & 0.84401937E-10_JPRB, 0.84834015E-10_JPRB, 0.85281636E-10_JPRB, 0.85700239E-10_JPRB, 0.86064336E-10_JPRB, 0.86363139E-10_JPRB, &
  & 0.86603301E-10_JPRB, 0.86799262E-10_JPRB, 0.86965712E-10_JPRB, 0.87113469E-10_JPRB, 0.87250103E-10_JPRB, 0.87378521E-10_JPRB, &
  & 0.87496226E-10_JPRB, 0.87595459E-10_JPRB, 0.87666138E-10_JPRB, 0.87703886E-10_JPRB, 0.87711463E-10_JPRB, 0.87693644E-10_JPRB, &
  & 0.87653426E-10_JPRB, 0.87593301E-10_JPRB, 0.87516036E-10_JPRB, 0.87426864E-10_JPRB, 0.87329199E-10_JPRB, 0.87231319E-10_JPRB, &
  & 0.87135521E-10_JPRB, 0.87044885E-10_JPRB, 0.86954298E-10_JPRB, 0.86855523E-10_JPRB, 0.86732344E-10_JPRB, 0.86563076E-10_JPRB, &
  & 0.86320756E-10_JPRB, 0.85978932E-10_JPRB, 0.85553058E-10_JPRB, 0.85089949E-10_JPRB, 0.84677099E-10_JPRB, 0.84350263E-10_JPRB, &
  & 0.84092018E-10_JPRB, 0.83873603E-10_JPRB, 0.83667073E-10_JPRB, 0.83455923E-10_JPRB, 0.83238590E-10_JPRB, 0.83028327E-10_JPRB, &
  & 0.82834399E-10_JPRB, 0.82648013E-10_JPRB, 0.82442699E-10_JPRB, 0.82097107E-10_JPRB /)

RGHG9(:,49, 8) = (/ &
  & 0.80206820E-10_JPRB, 0.80863038E-10_JPRB, 0.81300924E-10_JPRB, 0.81764512E-10_JPRB, 0.82290827E-10_JPRB, 0.82778923E-10_JPRB, &
  & 0.83123133E-10_JPRB, 0.83357501E-10_JPRB, 0.83527137E-10_JPRB, 0.83660329E-10_JPRB, 0.83783147E-10_JPRB, 0.83904259E-10_JPRB, &
  & 0.84032406E-10_JPRB, 0.84169539E-10_JPRB, 0.84318191E-10_JPRB, 0.84480763E-10_JPRB, 0.84655220E-10_JPRB, 0.84846387E-10_JPRB, &
  & 0.85060348E-10_JPRB, 0.85310918E-10_JPRB, 0.85600041E-10_JPRB, 0.85910348E-10_JPRB, 0.86207666E-10_JPRB, 0.86468978E-10_JPRB, &
  & 0.86687657E-10_JPRB, 0.86869886E-10_JPRB, 0.87026546E-10_JPRB, 0.87167357E-10_JPRB, 0.87298627E-10_JPRB, 0.87422916E-10_JPRB, &
  & 0.87537505E-10_JPRB, 0.87634205E-10_JPRB, 0.87703886E-10_JPRB, 0.87742098E-10_JPRB, 0.87751383E-10_JPRB, 0.87735832E-10_JPRB, &
  & 0.87698258E-10_JPRB, 0.87641193E-10_JPRB, 0.87568133E-10_JPRB, 0.87483493E-10_JPRB, 0.87392357E-10_JPRB, 0.87300722E-10_JPRB, &
  & 0.87214673E-10_JPRB, 0.87134175E-10_JPRB, 0.87059082E-10_JPRB, 0.86980596E-10_JPRB, 0.86889336E-10_JPRB, 0.86771472E-10_JPRB, &
  & 0.86610448E-10_JPRB, 0.86394648E-10_JPRB, 0.86119889E-10_JPRB, 0.85820989E-10_JPRB, 0.85537535E-10_JPRB, 0.85304028E-10_JPRB, &
  & 0.85111800E-10_JPRB, 0.84943851E-10_JPRB, 0.84776339E-10_JPRB, 0.84596836E-10_JPRB, 0.84403914E-10_JPRB, 0.84210305E-10_JPRB, &
  & 0.84028479E-10_JPRB, 0.83854236E-10_JPRB, 0.83661307E-10_JPRB, 0.83337511E-10_JPRB /)

RGHG9(:,50, 8) = (/ &
  & 0.81876901E-10_JPRB, 0.82435364E-10_JPRB, 0.82817295E-10_JPRB, 0.83246979E-10_JPRB, 0.83747370E-10_JPRB, 0.84212581E-10_JPRB, &
  & 0.84533505E-10_JPRB, 0.84745370E-10_JPRB, 0.84883073E-10_JPRB, 0.84990959E-10_JPRB, 0.85076127E-10_JPRB, 0.85153398E-10_JPRB, &
  & 0.85223377E-10_JPRB, 0.85289220E-10_JPRB, 0.85351226E-10_JPRB, 0.85409353E-10_JPRB, 0.85466065E-10_JPRB, 0.85525607E-10_JPRB, &
  & 0.85600346E-10_JPRB, 0.85711695E-10_JPRB, 0.85875765E-10_JPRB, 0.86090954E-10_JPRB, 0.86328757E-10_JPRB, 0.86556859E-10_JPRB, &
  & 0.86757039E-10_JPRB, 0.86927979E-10_JPRB, 0.87077005E-10_JPRB, 0.87212154E-10_JPRB, 0.87339393E-10_JPRB, 0.87460622E-10_JPRB, &
  & 0.87572713E-10_JPRB, 0.87667741E-10_JPRB, 0.87736790E-10_JPRB, 0.87775939E-10_JPRB, 0.87787132E-10_JPRB, 0.87773760E-10_JPRB, &
  & 0.87738795E-10_JPRB, 0.87684873E-10_JPRB, 0.87615540E-10_JPRB, 0.87535146E-10_JPRB, 0.87448986E-10_JPRB, 0.87362825E-10_JPRB, &
  & 0.87281890E-10_JPRB, 0.87210614E-10_JPRB, 0.87144868E-10_JPRB, 0.87081148E-10_JPRB, 0.87011343E-10_JPRB, 0.86928423E-10_JPRB, &
  & 0.86824763E-10_JPRB, 0.86696192E-10_JPRB, 0.86546124E-10_JPRB, 0.86382977E-10_JPRB, 0.86229829E-10_JPRB, 0.86095298E-10_JPRB, &
  & 0.85979654E-10_JPRB, 0.85867591E-10_JPRB, 0.85751684E-10_JPRB, 0.85616909E-10_JPRB, 0.85459598E-10_JPRB, 0.85293543E-10_JPRB, &
  & 0.85132151E-10_JPRB, 0.84972127E-10_JPRB, 0.84793859E-10_JPRB, 0.84485176E-10_JPRB /)

RGHG9(:,51, 8) = (/ &
  & 0.83134784E-10_JPRB, 0.83629811E-10_JPRB, 0.83966029E-10_JPRB, 0.84321092E-10_JPRB, 0.84755952E-10_JPRB, 0.85146029E-10_JPRB, &
  & 0.85419012E-10_JPRB, 0.85580085E-10_JPRB, 0.85694681E-10_JPRB, 0.85772250E-10_JPRB, 0.85838697E-10_JPRB, 0.85892390E-10_JPRB, &
  & 0.85936397E-10_JPRB, 0.85967782E-10_JPRB, 0.85986683E-10_JPRB, 0.85994836E-10_JPRB, 0.85994274E-10_JPRB, 0.85991679E-10_JPRB, &
  & 0.85997293E-10_JPRB, 0.86028462E-10_JPRB, 0.86108419E-10_JPRB, 0.86246996E-10_JPRB, 0.86432077E-10_JPRB, 0.86630592E-10_JPRB, &
  & 0.86815236E-10_JPRB, 0.86977030E-10_JPRB, 0.87119895E-10_JPRB, 0.87250603E-10_JPRB, 0.87374372E-10_JPRB, 0.87493054E-10_JPRB, &
  & 0.87603147E-10_JPRB, 0.87696864E-10_JPRB, 0.87765725E-10_JPRB, 0.87806137E-10_JPRB, 0.87819287E-10_JPRB, 0.87808198E-10_JPRB, &
  & 0.87775752E-10_JPRB, 0.87725077E-10_JPRB, 0.87659137E-10_JPRB, 0.87583329E-10_JPRB, 0.87500750E-10_JPRB, 0.87418413E-10_JPRB, &
  & 0.87342814E-10_JPRB, 0.87275610E-10_JPRB, 0.87218024E-10_JPRB, 0.87163547E-10_JPRB, 0.87108425E-10_JPRB, 0.87048091E-10_JPRB, &
  & 0.86980881E-10_JPRB, 0.86906593E-10_JPRB, 0.86828031E-10_JPRB, 0.86749989E-10_JPRB, 0.86678983E-10_JPRB, 0.86617456E-10_JPRB, &
  & 0.86561855E-10_JPRB, 0.86508495E-10_JPRB, 0.86447183E-10_JPRB, 0.86371549E-10_JPRB, 0.86276271E-10_JPRB, 0.86163333E-10_JPRB, &
  & 0.86043596E-10_JPRB, 0.85919466E-10_JPRB, 0.85767657E-10_JPRB, 0.85492911E-10_JPRB /)

RGHG9(:,52, 8) = (/ &
  & 0.84271527E-10_JPRB, 0.84603095E-10_JPRB, 0.84829643E-10_JPRB, 0.85107692E-10_JPRB, 0.85437560E-10_JPRB, 0.85754549E-10_JPRB, &
  & 0.85953682E-10_JPRB, 0.86082752E-10_JPRB, 0.86158719E-10_JPRB, 0.86219767E-10_JPRB, 0.86265182E-10_JPRB, 0.86304526E-10_JPRB, &
  & 0.86333232E-10_JPRB, 0.86349067E-10_JPRB, 0.86350961E-10_JPRB, 0.86340324E-10_JPRB, 0.86320937E-10_JPRB, 0.86297185E-10_JPRB, &
  & 0.86277069E-10_JPRB, 0.86271830E-10_JPRB, 0.86300508E-10_JPRB, 0.86383824E-10_JPRB, 0.86523004E-10_JPRB, 0.86694388E-10_JPRB, &
  & 0.86865334E-10_JPRB, 0.87019753E-10_JPRB, 0.87157635E-10_JPRB, 0.87284381E-10_JPRB, 0.87405236E-10_JPRB, 0.87521344E-10_JPRB, &
  & 0.87629681E-10_JPRB, 0.87722316E-10_JPRB, 0.87791455E-10_JPRB, 0.87833317E-10_JPRB, 0.87848381E-10_JPRB, 0.87839583E-10_JPRB, &
  & 0.87809877E-10_JPRB, 0.87762082E-10_JPRB, 0.87700208E-10_JPRB, 0.87627544E-10_JPRB, 0.87549197E-10_JPRB, 0.87470198E-10_JPRB, &
  & 0.87396687E-10_JPRB, 0.87334737E-10_JPRB, 0.87281030E-10_JPRB, 0.87233575E-10_JPRB, 0.87187889E-10_JPRB, 0.87142613E-10_JPRB, &
  & 0.87097128E-10_JPRB, 0.87053295E-10_JPRB, 0.87011905E-10_JPRB, 0.86975246E-10_JPRB, 0.86944035E-10_JPRB, 0.86918840E-10_JPRB, &
  & 0.86896892E-10_JPRB, 0.86874972E-10_JPRB, 0.86850416E-10_JPRB, 0.86818289E-10_JPRB, 0.86773574E-10_JPRB, 0.86716884E-10_JPRB, &
  & 0.86651242E-10_JPRB, 0.86574650E-10_JPRB, 0.86475216E-10_JPRB, 0.86265418E-10_JPRB /)

RGHG9(:,53, 8) = (/ &
  & 0.85008257E-10_JPRB, 0.85277688E-10_JPRB, 0.85465482E-10_JPRB, 0.85665523E-10_JPRB, 0.85921666E-10_JPRB, 0.86149775E-10_JPRB, &
  & 0.86306712E-10_JPRB, 0.86392123E-10_JPRB, 0.86452331E-10_JPRB, 0.86491543E-10_JPRB, 0.86526050E-10_JPRB, 0.86553133E-10_JPRB, &
  & 0.86572895E-10_JPRB, 0.86581131E-10_JPRB, 0.86576579E-10_JPRB, 0.86560620E-10_JPRB, 0.86536271E-10_JPRB, 0.86507683E-10_JPRB, &
  & 0.86478880E-10_JPRB, 0.86458729E-10_JPRB, 0.86460325E-10_JPRB, 0.86504442E-10_JPRB, 0.86605841E-10_JPRB, 0.86752230E-10_JPRB, &
  & 0.86910472E-10_JPRB, 0.87058249E-10_JPRB, 0.87191580E-10_JPRB, 0.87314989E-10_JPRB, 0.87432603E-10_JPRB, 0.87546394E-10_JPRB, &
  & 0.87652954E-10_JPRB, 0.87744811E-10_JPRB, 0.87814561E-10_JPRB, 0.87857846E-10_JPRB, 0.87875041E-10_JPRB, 0.87868622E-10_JPRB, &
  & 0.87841387E-10_JPRB, 0.87796853E-10_JPRB, 0.87738108E-10_JPRB, 0.87669601E-10_JPRB, 0.87594168E-10_JPRB, 0.87517826E-10_JPRB, &
  & 0.87448125E-10_JPRB, 0.87387597E-10_JPRB, 0.87338067E-10_JPRB, 0.87294769E-10_JPRB, 0.87255869E-10_JPRB, 0.87219870E-10_JPRB, &
  & 0.87187951E-10_JPRB, 0.87160210E-10_JPRB, 0.87137381E-10_JPRB, 0.87118993E-10_JPRB, 0.87105566E-10_JPRB, 0.87095067E-10_JPRB, &
  & 0.87086643E-10_JPRB, 0.87078469E-10_JPRB, 0.87068977E-10_JPRB, 0.87055987E-10_JPRB, 0.87037488E-10_JPRB, 0.87011807E-10_JPRB, &
  & 0.86980312E-10_JPRB, 0.86943584E-10_JPRB, 0.86892930E-10_JPRB, 0.86771965E-10_JPRB /)

RGHG9(:,54, 8) = (/ &
  & 0.85644311E-10_JPRB, 0.85822162E-10_JPRB, 0.85942725E-10_JPRB, 0.86089302E-10_JPRB, 0.86266286E-10_JPRB, 0.86436504E-10_JPRB, &
  & 0.86542995E-10_JPRB, 0.86610275E-10_JPRB, 0.86648438E-10_JPRB, 0.86679094E-10_JPRB, 0.86701882E-10_JPRB, 0.86721880E-10_JPRB, &
  & 0.86735619E-10_JPRB, 0.86740073E-10_JPRB, 0.86733565E-10_JPRB, 0.86716981E-10_JPRB, 0.86692847E-10_JPRB, 0.86663662E-10_JPRB, &
  & 0.86633603E-10_JPRB, 0.86606396E-10_JPRB, 0.86593357E-10_JPRB, 0.86612439E-10_JPRB, 0.86684118E-10_JPRB, 0.86807166E-10_JPRB, &
  & 0.86953146E-10_JPRB, 0.87094019E-10_JPRB, 0.87223215E-10_JPRB, 0.87342786E-10_JPRB, 0.87457638E-10_JPRB, 0.87568841E-10_JPRB, &
  & 0.87673688E-10_JPRB, 0.87765177E-10_JPRB, 0.87835468E-10_JPRB, 0.87880411E-10_JPRB, 0.87899757E-10_JPRB, 0.87895663E-10_JPRB, &
  & 0.87871009E-10_JPRB, 0.87829286E-10_JPRB, 0.87774066E-10_JPRB, 0.87708438E-10_JPRB, 0.87636384E-10_JPRB, 0.87563297E-10_JPRB, &
  & 0.87495129E-10_JPRB, 0.87438085E-10_JPRB, 0.87390380E-10_JPRB, 0.87350481E-10_JPRB, 0.87315787E-10_JPRB, 0.87286359E-10_JPRB, &
  & 0.87261913E-10_JPRB, 0.87243102E-10_JPRB, 0.87228877E-10_JPRB, 0.87219079E-10_JPRB, 0.87212217E-10_JPRB, 0.87207817E-10_JPRB, &
  & 0.87204244E-10_JPRB, 0.87200948E-10_JPRB, 0.87196979E-10_JPRB, 0.87191469E-10_JPRB, 0.87183108E-10_JPRB, 0.87171555E-10_JPRB, &
  & 0.87157809E-10_JPRB, 0.87143154E-10_JPRB, 0.87128429E-10_JPRB, 0.87112297E-10_JPRB /)

RGHG9(:,55, 8) = (/ &
  & 0.86068888E-10_JPRB, 0.86206979E-10_JPRB, 0.86300550E-10_JPRB, 0.86403183E-10_JPRB, 0.86525953E-10_JPRB, 0.86642499E-10_JPRB, &
  & 0.86723753E-10_JPRB, 0.86767676E-10_JPRB, 0.86797888E-10_JPRB, 0.86817532E-10_JPRB, 0.86834935E-10_JPRB, 0.86848820E-10_JPRB, &
  & 0.86858812E-10_JPRB, 0.86861546E-10_JPRB, 0.86855120E-10_JPRB, 0.86839730E-10_JPRB, 0.86817047E-10_JPRB, 0.86789451E-10_JPRB, &
  & 0.86758316E-10_JPRB, 0.86728659E-10_JPRB, 0.86706683E-10_JPRB, 0.86709383E-10_JPRB, 0.86758538E-10_JPRB, 0.86862385E-10_JPRB, &
  & 0.86994953E-10_JPRB, 0.87128901E-10_JPRB, 0.87252879E-10_JPRB, 0.87369188E-10_JPRB, 0.87480703E-10_JPRB, 0.87589651E-10_JPRB, &
  & 0.87692978E-10_JPRB, 0.87783940E-10_JPRB, 0.87854897E-10_JPRB, 0.87901519E-10_JPRB, 0.87922995E-10_JPRB, 0.87921177E-10_JPRB, &
  & 0.87899001E-10_JPRB, 0.87860066E-10_JPRB, 0.87807699E-10_JPRB, 0.87745276E-10_JPRB, 0.87675964E-10_JPRB, 0.87605534E-10_JPRB, &
  & 0.87540884E-10_JPRB, 0.87485304E-10_JPRB, 0.87440145E-10_JPRB, 0.87402419E-10_JPRB, 0.87371110E-10_JPRB, 0.87345277E-10_JPRB, &
  & 0.87325543E-10_JPRB, 0.87310992E-10_JPRB, 0.87301055E-10_JPRB, 0.87294436E-10_JPRB, 0.87290598E-10_JPRB, 0.87287962E-10_JPRB, &
  & 0.87286137E-10_JPRB, 0.87284305E-10_JPRB, 0.87282147E-10_JPRB, 0.87279017E-10_JPRB, 0.87274271E-10_JPRB, 0.87267638E-10_JPRB, &
  & 0.87259477E-10_JPRB, 0.87250526E-10_JPRB, 0.87240437E-10_JPRB, 0.87223145E-10_JPRB /)

RGHG9(:,56, 8) = (/ &
  & 0.86425103E-10_JPRB, 0.86512110E-10_JPRB, 0.86573797E-10_JPRB, 0.86641395E-10_JPRB, 0.86725405E-10_JPRB, 0.86805181E-10_JPRB, &
  & 0.86860200E-10_JPRB, 0.86894894E-10_JPRB, 0.86914614E-10_JPRB, 0.86930185E-10_JPRB, 0.86942023E-10_JPRB, 0.86952640E-10_JPRB, &
  & 0.86960168E-10_JPRB, 0.86962298E-10_JPRB, 0.86956886E-10_JPRB, 0.86943591E-10_JPRB, 0.86922997E-10_JPRB, 0.86896379E-10_JPRB, &
  & 0.86865737E-10_JPRB, 0.86833124E-10_JPRB, 0.86805604E-10_JPRB, 0.86797174E-10_JPRB, 0.86830980E-10_JPRB, 0.86917536E-10_JPRB, &
  & 0.87038148E-10_JPRB, 0.87163381E-10_JPRB, 0.87282466E-10_JPRB, 0.87394536E-10_JPRB, 0.87503310E-10_JPRB, 0.87609753E-10_JPRB, &
  & 0.87711574E-10_JPRB, 0.87802002E-10_JPRB, 0.87873583E-10_JPRB, 0.87921670E-10_JPRB, 0.87945151E-10_JPRB, 0.87945554E-10_JPRB, &
  & 0.87925771E-10_JPRB, 0.87889529E-10_JPRB, 0.87839902E-10_JPRB, 0.87779908E-10_JPRB, 0.87713545E-10_JPRB, 0.87646189E-10_JPRB, &
  & 0.87583926E-10_JPRB, 0.87531218E-10_JPRB, 0.87487746E-10_JPRB, 0.87452254E-10_JPRB, 0.87423020E-10_JPRB, 0.87400004E-10_JPRB, &
  & 0.87382518E-10_JPRB, 0.87370118E-10_JPRB, 0.87361687E-10_JPRB, 0.87356483E-10_JPRB, 0.87353097E-10_JPRB, 0.87351092E-10_JPRB, &
  & 0.87349433E-10_JPRB, 0.87347907E-10_JPRB, 0.87346061E-10_JPRB, 0.87343535E-10_JPRB, 0.87339996E-10_JPRB, 0.87335153E-10_JPRB, &
  & 0.87329519E-10_JPRB, 0.87323565E-10_JPRB, 0.87316904E-10_JPRB, 0.87306780E-10_JPRB /)

RGHG9(:,57, 8) = (/ &
  & 0.86662018E-10_JPRB, 0.86732233E-10_JPRB, 0.86776968E-10_JPRB, 0.86826130E-10_JPRB, 0.86879039E-10_JPRB, 0.86934210E-10_JPRB, &
  & 0.86975017E-10_JPRB, 0.86998547E-10_JPRB, 0.87014410E-10_JPRB, 0.87025089E-10_JPRB, 0.87034546E-10_JPRB, 0.87042554E-10_JPRB, &
  & 0.87048778E-10_JPRB, 0.87051019E-10_JPRB, 0.87047161E-10_JPRB, 0.87036059E-10_JPRB, 0.87017588E-10_JPRB, 0.86992274E-10_JPRB, &
  & 0.86960800E-10_JPRB, 0.86926230E-10_JPRB, 0.86893909E-10_JPRB, 0.86877824E-10_JPRB, 0.86900327E-10_JPRB, 0.86974289E-10_JPRB, &
  & 0.87082445E-10_JPRB, 0.87199324E-10_JPRB, 0.87312366E-10_JPRB, 0.87420661E-10_JPRB, 0.87526181E-10_JPRB, 0.87630292E-10_JPRB, &
  & 0.87730358E-10_JPRB, 0.87820133E-10_JPRB, 0.87892013E-10_JPRB, 0.87941418E-10_JPRB, 0.87966544E-10_JPRB, 0.87969090E-10_JPRB, &
  & 0.87951785E-10_JPRB, 0.87917944E-10_JPRB, 0.87870738E-10_JPRB, 0.87813486E-10_JPRB, 0.87749571E-10_JPRB, 0.87685186E-10_JPRB, &
  & 0.87626004E-10_JPRB, 0.87575405E-10_JPRB, 0.87534029E-10_JPRB, 0.87500236E-10_JPRB, 0.87473098E-10_JPRB, 0.87451629E-10_JPRB, &
  & 0.87435545E-10_JPRB, 0.87424019E-10_JPRB, 0.87416019E-10_JPRB, 0.87410586E-10_JPRB, 0.87407234E-10_JPRB, 0.87404702E-10_JPRB, &
  & 0.87402779E-10_JPRB, 0.87400878E-10_JPRB, 0.87398727E-10_JPRB, 0.87396063E-10_JPRB, 0.87392441E-10_JPRB, 0.87388000E-10_JPRB, &
  & 0.87382948E-10_JPRB, 0.87377640E-10_JPRB, 0.87371790E-10_JPRB, 0.87361333E-10_JPRB /)

RGHG9(:,58, 8) = (/ &
  & 0.86857688E-10_JPRB, 0.86905136E-10_JPRB, 0.86937069E-10_JPRB, 0.86968044E-10_JPRB, 0.87005306E-10_JPRB, 0.87041735E-10_JPRB, &
  & 0.87070649E-10_JPRB, 0.87089391E-10_JPRB, 0.87100785E-10_JPRB, 0.87109653E-10_JPRB, 0.87116904E-10_JPRB, 0.87123697E-10_JPRB, &
  & 0.87129373E-10_JPRB, 0.87132190E-10_JPRB, 0.87130095E-10_JPRB, 0.87121380E-10_JPRB, 0.87104914E-10_JPRB, 0.87080343E-10_JPRB, &
  & 0.87048285E-10_JPRB, 0.87010781E-10_JPRB, 0.86974483E-10_JPRB, 0.86953049E-10_JPRB, 0.86968092E-10_JPRB, 0.87031500E-10_JPRB, &
  & 0.87128631E-10_JPRB, 0.87236926E-10_JPRB, 0.87344104E-10_JPRB, 0.87448188E-10_JPRB, 0.87550557E-10_JPRB, 0.87652059E-10_JPRB, &
  & 0.87750224E-10_JPRB, 0.87838882E-10_JPRB, 0.87910922E-10_JPRB, 0.87960902E-10_JPRB, 0.87987589E-10_JPRB, 0.87992086E-10_JPRB, &
  & 0.87977015E-10_JPRB, 0.87945658E-10_JPRB, 0.87900909E-10_JPRB, 0.87845856E-10_JPRB, 0.87784911E-10_JPRB, 0.87723349E-10_JPRB, &
  & 0.87666985E-10_JPRB, 0.87618746E-10_JPRB, 0.87579180E-10_JPRB, 0.87547136E-10_JPRB, 0.87521483E-10_JPRB, 0.87501430E-10_JPRB, &
  & 0.87486296E-10_JPRB, 0.87474958E-10_JPRB, 0.87466728E-10_JPRB, 0.87460809E-10_JPRB, 0.87456355E-10_JPRB, 0.87453184E-10_JPRB, &
  & 0.87450443E-10_JPRB, 0.87447848E-10_JPRB, 0.87445114E-10_JPRB, 0.87441721E-10_JPRB, 0.87437668E-10_JPRB, 0.87432762E-10_JPRB, &
  & 0.87427614E-10_JPRB, 0.87422541E-10_JPRB, 0.87416907E-10_JPRB, 0.87407977E-10_JPRB /)

RGHG9(:,59, 8) = (/ &
  & 0.86999942E-10_JPRB, 0.87038259E-10_JPRB, 0.87061261E-10_JPRB, 0.87084173E-10_JPRB, 0.87108050E-10_JPRB, 0.87134279E-10_JPRB, &
  & 0.87155713E-10_JPRB, 0.87169834E-10_JPRB, 0.87179423E-10_JPRB, 0.87186508E-10_JPRB, 0.87192920E-10_JPRB, 0.87199054E-10_JPRB, &
  & 0.87204702E-10_JPRB, 0.87208504E-10_JPRB, 0.87208296E-10_JPRB, 0.87201774E-10_JPRB, 0.87187327E-10_JPRB, 0.87163145E-10_JPRB, &
  & 0.87129720E-10_JPRB, 0.87089537E-10_JPRB, 0.87049624E-10_JPRB, 0.87024610E-10_JPRB, 0.87034428E-10_JPRB, 0.87089121E-10_JPRB, &
  & 0.87176620E-10_JPRB, 0.87276568E-10_JPRB, 0.87378160E-10_JPRB, 0.87477976E-10_JPRB, 0.87577175E-10_JPRB, 0.87675783E-10_JPRB, &
  & 0.87771707E-10_JPRB, 0.87859026E-10_JPRB, 0.87930371E-10_JPRB, 0.87980873E-10_JPRB, 0.88008371E-10_JPRB, 0.88014568E-10_JPRB, &
  & 0.88001766E-10_JPRB, 0.87972671E-10_JPRB, 0.87930246E-10_JPRB, 0.87877906E-10_JPRB, 0.87819474E-10_JPRB, 0.87761111E-10_JPRB, &
  & 0.87707369E-10_JPRB, 0.87661510E-10_JPRB, 0.87623610E-10_JPRB, 0.87593099E-10_JPRB, 0.87568827E-10_JPRB, 0.87549898E-10_JPRB, &
  & 0.87535333E-10_JPRB, 0.87524453E-10_JPRB, 0.87515828E-10_JPRB, 0.87508917E-10_JPRB, 0.87503435E-10_JPRB, 0.87498953E-10_JPRB, &
  & 0.87495108E-10_JPRB, 0.87491570E-10_JPRB, 0.87487725E-10_JPRB, 0.87483486E-10_JPRB, 0.87478289E-10_JPRB, 0.87472543E-10_JPRB, &
  & 0.87466701E-10_JPRB, 0.87460927E-10_JPRB, 0.87454842E-10_JPRB, 0.87444531E-10_JPRB /)

RGHG9(:,60, 8) = (/ &
  & 0.87119340E-10_JPRB, 0.87147234E-10_JPRB, 0.87164054E-10_JPRB, 0.87179604E-10_JPRB, 0.87197152E-10_JPRB, 0.87215478E-10_JPRB, &
  & 0.87232110E-10_JPRB, 0.87243823E-10_JPRB, 0.87251872E-10_JPRB, 0.87258353E-10_JPRB, 0.87264272E-10_JPRB, 0.87270316E-10_JPRB, &
  & 0.87276505E-10_JPRB, 0.87281467E-10_JPRB, 0.87283195E-10_JPRB, 0.87278934E-10_JPRB, 0.87265840E-10_JPRB, 0.87242054E-10_JPRB, &
  & 0.87206797E-10_JPRB, 0.87163950E-10_JPRB, 0.87121532E-10_JPRB, 0.87094186E-10_JPRB, 0.87099904E-10_JPRB, 0.87147310E-10_JPRB, &
  & 0.87225852E-10_JPRB, 0.87318652E-10_JPRB, 0.87414610E-10_JPRB, 0.87510672E-10_JPRB, 0.87606304E-10_JPRB, 0.87702158E-10_JPRB, &
  & 0.87795382E-10_JPRB, 0.87880737E-10_JPRB, 0.87951244E-10_JPRB, 0.88001155E-10_JPRB, 0.88029251E-10_JPRB, 0.88036661E-10_JPRB, &
  & 0.88025739E-10_JPRB, 0.87998997E-10_JPRB, 0.87959029E-10_JPRB, 0.87909159E-10_JPRB, 0.87853932E-10_JPRB, 0.87798373E-10_JPRB, &
  & 0.87747670E-10_JPRB, 0.87703692E-10_JPRB, 0.87667665E-10_JPRB, 0.87638424E-10_JPRB, 0.87615352E-10_JPRB, 0.87597256E-10_JPRB, &
  & 0.87583427E-10_JPRB, 0.87572671E-10_JPRB, 0.87564157E-10_JPRB, 0.87556525E-10_JPRB, 0.87549856E-10_JPRB, 0.87543806E-10_JPRB, &
  & 0.87538671E-10_JPRB, 0.87533578E-10_JPRB, 0.87528547E-10_JPRB, 0.87522725E-10_JPRB, 0.87516203E-10_JPRB, 0.87509097E-10_JPRB, &
  & 0.87502061E-10_JPRB, 0.87495428E-10_JPRB, 0.87488225E-10_JPRB, 0.87476672E-10_JPRB /)

RGHG9(:,61, 8) = (/ &
  & 0.87214957E-10_JPRB, 0.87237238E-10_JPRB, 0.87250207E-10_JPRB, 0.87262170E-10_JPRB, 0.87274826E-10_JPRB, 0.87289176E-10_JPRB, &
  & 0.87302464E-10_JPRB, 0.87312602E-10_JPRB, 0.87320089E-10_JPRB, 0.87326230E-10_JPRB, 0.87332253E-10_JPRB, 0.87338733E-10_JPRB, &
  & 0.87345735E-10_JPRB, 0.87352306E-10_JPRB, 0.87355942E-10_JPRB, 0.87353541E-10_JPRB, 0.87341856E-10_JPRB, 0.87317223E-10_JPRB, &
  & 0.87280815E-10_JPRB, 0.87235850E-10_JPRB, 0.87191775E-10_JPRB, 0.87162964E-10_JPRB, 0.87165129E-10_JPRB, 0.87205979E-10_JPRB, &
  & 0.87276755E-10_JPRB, 0.87362756E-10_JPRB, 0.87453933E-10_JPRB, 0.87545998E-10_JPRB, 0.87638681E-10_JPRB, 0.87731156E-10_JPRB, &
  & 0.87821722E-10_JPRB, 0.87904649E-10_JPRB, 0.87973288E-10_JPRB, 0.88022381E-10_JPRB, 0.88050164E-10_JPRB, 0.88058373E-10_JPRB, &
  & 0.88049110E-10_JPRB, 0.88024518E-10_JPRB, 0.87987090E-10_JPRB, 0.87940148E-10_JPRB, 0.87887808E-10_JPRB, 0.87835683E-10_JPRB, &
  & 0.87787361E-10_JPRB, 0.87745963E-10_JPRB, 0.87711269E-10_JPRB, 0.87683485E-10_JPRB, 0.87661323E-10_JPRB, 0.87644010E-10_JPRB, &
  & 0.87630611E-10_JPRB, 0.87620258E-10_JPRB, 0.87611751E-10_JPRB, 0.87604209E-10_JPRB, 0.87596402E-10_JPRB, 0.87589325E-10_JPRB, &
  & 0.87582108E-10_JPRB, 0.87575600E-10_JPRB, 0.87568529E-10_JPRB, 0.87560986E-10_JPRB, 0.87552507E-10_JPRB, 0.87543653E-10_JPRB, &
  & 0.87535132E-10_JPRB, 0.87526958E-10_JPRB, 0.87518090E-10_JPRB, 0.87503588E-10_JPRB /)

RGHG9(:,62, 8) = (/ &
  & 0.87297718E-10_JPRB, 0.87315447E-10_JPRB, 0.87325584E-10_JPRB, 0.87334875E-10_JPRB, 0.87345117E-10_JPRB, 0.87356553E-10_JPRB, &
  & 0.87368168E-10_JPRB, 0.87377612E-10_JPRB, 0.87384919E-10_JPRB, 0.87391400E-10_JPRB, 0.87397825E-10_JPRB, 0.87405153E-10_JPRB, &
  & 0.87413583E-10_JPRB, 0.87421792E-10_JPRB, 0.87427419E-10_JPRB, 0.87426538E-10_JPRB, 0.87414964E-10_JPRB, 0.87390400E-10_JPRB, &
  & 0.87352223E-10_JPRB, 0.87306468E-10_JPRB, 0.87261497E-10_JPRB, 0.87231555E-10_JPRB, 0.87230556E-10_JPRB, 0.87265431E-10_JPRB, &
  & 0.87329449E-10_JPRB, 0.87409392E-10_JPRB, 0.87495899E-10_JPRB, 0.87584641E-10_JPRB, 0.87673910E-10_JPRB, 0.87763567E-10_JPRB, &
  & 0.87850789E-10_JPRB, 0.87930913E-10_JPRB, 0.87997151E-10_JPRB, 0.88044370E-10_JPRB, 0.88071390E-10_JPRB, 0.88079849E-10_JPRB, &
  & 0.88071890E-10_JPRB, 0.88049401E-10_JPRB, 0.88014609E-10_JPRB, 0.87970610E-10_JPRB, 0.87921684E-10_JPRB, 0.87872432E-10_JPRB, &
  & 0.87827259E-10_JPRB, 0.87787680E-10_JPRB, 0.87754921E-10_JPRB, 0.87728221E-10_JPRB, 0.87707029E-10_JPRB, 0.87690320E-10_JPRB, &
  & 0.87677358E-10_JPRB, 0.87667207E-10_JPRB, 0.87658977E-10_JPRB, 0.87651393E-10_JPRB, 0.87643837E-10_JPRB, 0.87635142E-10_JPRB, &
  & 0.87626975E-10_JPRB, 0.87617968E-10_JPRB, 0.87609031E-10_JPRB, 0.87599067E-10_JPRB, 0.87588450E-10_JPRB, 0.87577542E-10_JPRB, &
  & 0.87567259E-10_JPRB, 0.87557073E-10_JPRB, 0.87545977E-10_JPRB, 0.87526902E-10_JPRB /)

RGHG9(:,63, 8) = (/ &
  & 0.87368245E-10_JPRB, 0.87383913E-10_JPRB, 0.87392829E-10_JPRB, 0.87400864E-10_JPRB, 0.87409503E-10_JPRB, 0.87419620E-10_JPRB, &
  & 0.87430119E-10_JPRB, 0.87439458E-10_JPRB, 0.87447244E-10_JPRB, 0.87454259E-10_JPRB, 0.87461816E-10_JPRB, 0.87470461E-10_JPRB, &
  & 0.87480599E-10_JPRB, 0.87490973E-10_JPRB, 0.87498009E-10_JPRB, 0.87497905E-10_JPRB, 0.87486615E-10_JPRB, 0.87460879E-10_JPRB, &
  & 0.87422694E-10_JPRB, 0.87376356E-10_JPRB, 0.87331156E-10_JPRB, 0.87300216E-10_JPRB, 0.87296462E-10_JPRB, 0.87326410E-10_JPRB, &
  & 0.87384169E-10_JPRB, 0.87458762E-10_JPRB, 0.87540988E-10_JPRB, 0.87626253E-10_JPRB, 0.87712594E-10_JPRB, 0.87798824E-10_JPRB, &
  & 0.87882840E-10_JPRB, 0.87959341E-10_JPRB, 0.88022450E-10_JPRB, 0.88067165E-10_JPRB, 0.88092804E-10_JPRB, 0.88101089E-10_JPRB, &
  & 0.88094129E-10_JPRB, 0.88073659E-10_JPRB, 0.88041553E-10_JPRB, 0.88000753E-10_JPRB, 0.87955102E-10_JPRB, 0.87909277E-10_JPRB, &
  & 0.87866638E-10_JPRB, 0.87829584E-10_JPRB, 0.87798199E-10_JPRB, 0.87772858E-10_JPRB, 0.87752486E-10_JPRB, 0.87736395E-10_JPRB, &
  & 0.87723800E-10_JPRB, 0.87713906E-10_JPRB, 0.87705843E-10_JPRB, 0.87698543E-10_JPRB, 0.87690806E-10_JPRB, 0.87682320E-10_JPRB, &
  & 0.87672182E-10_JPRB, 0.87661954E-10_JPRB, 0.87650366E-10_JPRB, 0.87638216E-10_JPRB, 0.87625129E-10_JPRB, 0.87612473E-10_JPRB, &
  & 0.87599858E-10_JPRB, 0.87587798E-10_JPRB, 0.87573053E-10_JPRB, 0.87548802E-10_JPRB /)

RGHG9(:,64, 8) = (/ &
  & 0.87431173E-10_JPRB, 0.87446009E-10_JPRB, 0.87454238E-10_JPRB, 0.87461594E-10_JPRB, 0.87469573E-10_JPRB, 0.87478705E-10_JPRB, &
  & 0.87489023E-10_JPRB, 0.87498453E-10_JPRB, 0.87507043E-10_JPRB, 0.87515266E-10_JPRB, 0.87524057E-10_JPRB, 0.87534736E-10_JPRB, &
  & 0.87547095E-10_JPRB, 0.87559106E-10_JPRB, 0.87567315E-10_JPRB, 0.87567363E-10_JPRB, 0.87555449E-10_JPRB, 0.87529893E-10_JPRB, &
  & 0.87491431E-10_JPRB, 0.87445454E-10_JPRB, 0.87400330E-10_JPRB, 0.87368945E-10_JPRB, 0.87363033E-10_JPRB, 0.87388617E-10_JPRB, &
  & 0.87441221E-10_JPRB, 0.87510679E-10_JPRB, 0.87588783E-10_JPRB, 0.87670683E-10_JPRB, 0.87753679E-10_JPRB, 0.87836544E-10_JPRB, &
  & 0.87916667E-10_JPRB, 0.87989199E-10_JPRB, 0.88048312E-10_JPRB, 0.88089987E-10_JPRB, 0.88113787E-10_JPRB, 0.88121635E-10_JPRB, &
  & 0.88115494E-10_JPRB, 0.88096939E-10_JPRB, 0.88067581E-10_JPRB, 0.88030055E-10_JPRB, 0.87987943E-10_JPRB, 0.87945339E-10_JPRB, &
  & 0.87905717E-10_JPRB, 0.87870732E-10_JPRB, 0.87841109E-10_JPRB, 0.87816941E-10_JPRB, 0.87797471E-10_JPRB, 0.87781934E-10_JPRB, &
  & 0.87769729E-10_JPRB, 0.87760139E-10_JPRB, 0.87752298E-10_JPRB, 0.87745193E-10_JPRB, 0.87737678E-10_JPRB, 0.87728755E-10_JPRB, &
  & 0.87718430E-10_JPRB, 0.87706245E-10_JPRB, 0.87693040E-10_JPRB, 0.87678476E-10_JPRB, 0.87663744E-10_JPRB, 0.87648770E-10_JPRB, &
  & 0.87634747E-10_JPRB, 0.87619641E-10_JPRB, 0.87602009E-10_JPRB, 0.87569736E-10_JPRB /)

RGHG9(:,65, 8) = (/ &
  & 0.87488010E-10_JPRB, 0.87502977E-10_JPRB, 0.87511276E-10_JPRB, 0.87518562E-10_JPRB, 0.87526264E-10_JPRB, 0.87535312E-10_JPRB, &
  & 0.87545131E-10_JPRB, 0.87555567E-10_JPRB, 0.87564865E-10_JPRB, 0.87574621E-10_JPRB, 0.87585356E-10_JPRB, 0.87598061E-10_JPRB, &
  & 0.87612535E-10_JPRB, 0.87625983E-10_JPRB, 0.87634303E-10_JPRB, 0.87634122E-10_JPRB, 0.87622166E-10_JPRB, 0.87596527E-10_JPRB, &
  & 0.87558759E-10_JPRB, 0.87513399E-10_JPRB, 0.87469088E-10_JPRB, 0.87437550E-10_JPRB, 0.87430133E-10_JPRB, 0.87452344E-10_JPRB, &
  & 0.87500153E-10_JPRB, 0.87564941E-10_JPRB, 0.87638855E-10_JPRB, 0.87716952E-10_JPRB, 0.87796381E-10_JPRB, 0.87875318E-10_JPRB, &
  & 0.87951112E-10_JPRB, 0.88018974E-10_JPRB, 0.88073632E-10_JPRB, 0.88111858E-10_JPRB, 0.88133639E-10_JPRB, 0.88140883E-10_JPRB, &
  & 0.88135457E-10_JPRB, 0.88118762E-10_JPRB, 0.88092207E-10_JPRB, 0.88058102E-10_JPRB, 0.88019592E-10_JPRB, 0.87980477E-10_JPRB, &
  & 0.87943743E-10_JPRB, 0.87911088E-10_JPRB, 0.87883180E-10_JPRB, 0.87860302E-10_JPRB, 0.87841630E-10_JPRB, 0.87826760E-10_JPRB, &
  & 0.87814998E-10_JPRB, 0.87805749E-10_JPRB, 0.87798192E-10_JPRB, 0.87791344E-10_JPRB, 0.87783975E-10_JPRB, 0.87775121E-10_JPRB, &
  & 0.87764164E-10_JPRB, 0.87751209E-10_JPRB, 0.87736332E-10_JPRB, 0.87720345E-10_JPRB, 0.87703726E-10_JPRB, 0.87687635E-10_JPRB, &
  & 0.87671280E-10_JPRB, 0.87654557E-10_JPRB, 0.87632471E-10_JPRB, 0.87593557E-10_JPRB /)

RGHG9(:,66, 8) = (/ &
  & 0.87540079E-10_JPRB, 0.87556372E-10_JPRB, 0.87565233E-10_JPRB, 0.87572942E-10_JPRB, 0.87580963E-10_JPRB, 0.87589935E-10_JPRB, &
  & 0.87600462E-10_JPRB, 0.87610669E-10_JPRB, 0.87622007E-10_JPRB, 0.87632804E-10_JPRB, 0.87645675E-10_JPRB, 0.87660525E-10_JPRB, &
  & 0.87676359E-10_JPRB, 0.87690154E-10_JPRB, 0.87698432E-10_JPRB, 0.87698057E-10_JPRB, 0.87686088E-10_JPRB, 0.87661108E-10_JPRB, &
  & 0.87624290E-10_JPRB, 0.87580262E-10_JPRB, 0.87537061E-10_JPRB, 0.87506266E-10_JPRB, 0.87497863E-10_JPRB, 0.87517174E-10_JPRB, &
  & 0.87560764E-10_JPRB, 0.87620945E-10_JPRB, 0.87690313E-10_JPRB, 0.87764206E-10_JPRB, 0.87839416E-10_JPRB, 0.87913829E-10_JPRB, &
  & 0.87984751E-10_JPRB, 0.88047451E-10_JPRB, 0.88097460E-10_JPRB, 0.88132127E-10_JPRB, 0.88151833E-10_JPRB, 0.88158404E-10_JPRB, &
  & 0.88153637E-10_JPRB, 0.88138781E-10_JPRB, 0.88115022E-10_JPRB, 0.88084359E-10_JPRB, 0.88049609E-10_JPRB, 0.88014082E-10_JPRB, &
  & 0.87980373E-10_JPRB, 0.87950203E-10_JPRB, 0.87924099E-10_JPRB, 0.87902512E-10_JPRB, 0.87884831E-10_JPRB, 0.87870634E-10_JPRB, &
  & 0.87859421E-10_JPRB, 0.87850602E-10_JPRB, 0.87843420E-10_JPRB, 0.87836925E-10_JPRB, 0.87829792E-10_JPRB, 0.87820980E-10_JPRB, &
  & 0.87809850E-10_JPRB, 0.87796215E-10_JPRB, 0.87780436E-10_JPRB, 0.87763193E-10_JPRB, 0.87745547E-10_JPRB, 0.87728047E-10_JPRB, &
  & 0.87710492E-10_JPRB, 0.87691916E-10_JPRB, 0.87666742E-10_JPRB, 0.87621001E-10_JPRB /)

RGHG9(:,67, 8) = (/ &
  & 0.87588284E-10_JPRB, 0.87606922E-10_JPRB, 0.87617039E-10_JPRB, 0.87625671E-10_JPRB, 0.87634414E-10_JPRB, 0.87644107E-10_JPRB, &
  & 0.87654523E-10_JPRB, 0.87666506E-10_JPRB, 0.87677712E-10_JPRB, 0.87691153E-10_JPRB, 0.87705107E-10_JPRB, 0.87721351E-10_JPRB, &
  & 0.87737664E-10_JPRB, 0.87751272E-10_JPRB, 0.87759355E-10_JPRB, 0.87758939E-10_JPRB, 0.87747372E-10_JPRB, 0.87723329E-10_JPRB, &
  & 0.87688037E-10_JPRB, 0.87645828E-10_JPRB, 0.87604660E-10_JPRB, 0.87574781E-10_JPRB, 0.87566024E-10_JPRB, 0.87582816E-10_JPRB, &
  & 0.87622382E-10_JPRB, 0.87677782E-10_JPRB, 0.87742376E-10_JPRB, 0.87811418E-10_JPRB, 0.87881785E-10_JPRB, 0.87951188E-10_JPRB, &
  & 0.88016663E-10_JPRB, 0.88074145E-10_JPRB, 0.88119415E-10_JPRB, 0.88150640E-10_JPRB, 0.88168320E-10_JPRB, 0.88174246E-10_JPRB, &
  & 0.88170089E-10_JPRB, 0.88156954E-10_JPRB, 0.88135915E-10_JPRB, 0.88108659E-10_JPRB, 0.88077684E-10_JPRB, 0.88045737E-10_JPRB, &
  & 0.88015296E-10_JPRB, 0.87987569E-10_JPRB, 0.87963498E-10_JPRB, 0.87943326E-10_JPRB, 0.87926687E-10_JPRB, 0.87913385E-10_JPRB, &
  & 0.87902831E-10_JPRB, 0.87894594E-10_JPRB, 0.87887926E-10_JPRB, 0.87881834E-10_JPRB, 0.87875061E-10_JPRB, 0.87866471E-10_JPRB, &
  & 0.87855334E-10_JPRB, 0.87841429E-10_JPRB, 0.87825074E-10_JPRB, 0.87807213E-10_JPRB, 0.87788707E-10_JPRB, 0.87770478E-10_JPRB, &
  & 0.87751896E-10_JPRB, 0.87732169E-10_JPRB, 0.87704476E-10_JPRB, 0.87651934E-10_JPRB /)

RGHG9(:,68, 8) = (/ &
  & 0.87632165E-10_JPRB, 0.87655036E-10_JPRB, 0.87667339E-10_JPRB, 0.87677511E-10_JPRB, 0.87687496E-10_JPRB, 0.87697946E-10_JPRB, &
  & 0.87709423E-10_JPRB, 0.87721122E-10_JPRB, 0.87734701E-10_JPRB, 0.87748024E-10_JPRB, 0.87763755E-10_JPRB, 0.87780047E-10_JPRB, &
  & 0.87796048E-10_JPRB, 0.87809288E-10_JPRB, 0.87817163E-10_JPRB, 0.87816865E-10_JPRB, 0.87805929E-10_JPRB, 0.87783211E-10_JPRB, &
  & 0.87749912E-10_JPRB, 0.87710214E-10_JPRB, 0.87671335E-10_JPRB, 0.87643136E-10_JPRB, 0.87634108E-10_JPRB, 0.87648645E-10_JPRB, &
  & 0.87684179E-10_JPRB, 0.87734778E-10_JPRB, 0.87794133E-10_JPRB, 0.87857950E-10_JPRB, 0.87922981E-10_JPRB, 0.87986882E-10_JPRB, &
  & 0.88046834E-10_JPRB, 0.88098959E-10_JPRB, 0.88139669E-10_JPRB, 0.88167522E-10_JPRB, 0.88183273E-10_JPRB, 0.88188581E-10_JPRB, &
  & 0.88185029E-10_JPRB, 0.88173482E-10_JPRB, 0.88154956E-10_JPRB, 0.88130975E-10_JPRB, 0.88103594E-10_JPRB, 0.88075339E-10_JPRB, &
  & 0.88048048E-10_JPRB, 0.88023068E-10_JPRB, 0.88001030E-10_JPRB, 0.87982434E-10_JPRB, 0.87967113E-10_JPRB, 0.87954768E-10_JPRB, &
  & 0.87945110E-10_JPRB, 0.87937588E-10_JPRB, 0.87931516E-10_JPRB, 0.87925937E-10_JPRB, 0.87919630E-10_JPRB, 0.87911414E-10_JPRB, &
  & 0.87900548E-10_JPRB, 0.87886705E-10_JPRB, 0.87870267E-10_JPRB, 0.87852191E-10_JPRB, 0.87833386E-10_JPRB, 0.87814915E-10_JPRB, &
  & 0.87795743E-10_JPRB, 0.87775856E-10_JPRB, 0.87746324E-10_JPRB, 0.87690036E-10_JPRB /)

RGHG9(:,69, 8) = (/ &
  & 0.87671814E-10_JPRB, 0.87701707E-10_JPRB, 0.87716959E-10_JPRB, 0.87729421E-10_JPRB, 0.87740884E-10_JPRB, 0.87752444E-10_JPRB, &
  & 0.87764289E-10_JPRB, 0.87777098E-10_JPRB, 0.87790435E-10_JPRB, 0.87805131E-10_JPRB, 0.87820487E-10_JPRB, 0.87836564E-10_JPRB, &
  & 0.87851913E-10_JPRB, 0.87864563E-10_JPRB, 0.87872133E-10_JPRB, 0.87871987E-10_JPRB, 0.87861884E-10_JPRB, 0.87840873E-10_JPRB, &
  & 0.87810086E-10_JPRB, 0.87773330E-10_JPRB, 0.87737449E-10_JPRB, 0.87710929E-10_JPRB, 0.87701936E-10_JPRB, 0.87714155E-10_JPRB, &
  & 0.87745727E-10_JPRB, 0.87791274E-10_JPRB, 0.87845252E-10_JPRB, 0.87903476E-10_JPRB, 0.87962818E-10_JPRB, 0.88021028E-10_JPRB, &
  & 0.88075283E-10_JPRB, 0.88122107E-10_JPRB, 0.88158390E-10_JPRB, 0.88183100E-10_JPRB, 0.88197026E-10_JPRB, 0.88201745E-10_JPRB, &
  & 0.88198691E-10_JPRB, 0.88188651E-10_JPRB, 0.88172497E-10_JPRB, 0.88151521E-10_JPRB, 0.88127602E-10_JPRB, 0.88102754E-10_JPRB, &
  & 0.88078683E-10_JPRB, 0.88056479E-10_JPRB, 0.88036710E-10_JPRB, 0.88019883E-10_JPRB, 0.88005922E-10_JPRB, 0.87994820E-10_JPRB, &
  & 0.87986139E-10_JPRB, 0.87979471E-10_JPRB, 0.87974142E-10_JPRB, 0.87969194E-10_JPRB, 0.87963470E-10_JPRB, 0.87955775E-10_JPRB, &
  & 0.87945436E-10_JPRB, 0.87932057E-10_JPRB, 0.87915994E-10_JPRB, 0.87898251E-10_JPRB, 0.87879620E-10_JPRB, 0.87861531E-10_JPRB, &
  & 0.87842456E-10_JPRB, 0.87822707E-10_JPRB, 0.87792960E-10_JPRB, 0.87732530E-10_JPRB /)

RGHG9(:,70, 8) = (/ &
  & 0.87708410E-10_JPRB, 0.87747330E-10_JPRB, 0.87767335E-10_JPRB, 0.87782157E-10_JPRB, 0.87795424E-10_JPRB, 0.87807761E-10_JPRB, &
  & 0.87820147E-10_JPRB, 0.87833039E-10_JPRB, 0.87846667E-10_JPRB, 0.87860996E-10_JPRB, 0.87875804E-10_JPRB, 0.87891083E-10_JPRB, &
  & 0.87905475E-10_JPRB, 0.87917347E-10_JPRB, 0.87924529E-10_JPRB, 0.87924515E-10_JPRB, 0.87915411E-10_JPRB, 0.87896371E-10_JPRB, &
  & 0.87868449E-10_JPRB, 0.87835135E-10_JPRB, 0.87802383E-10_JPRB, 0.87777979E-10_JPRB, 0.87769007E-10_JPRB, 0.87779020E-10_JPRB, &
  & 0.87806519E-10_JPRB, 0.87847001E-10_JPRB, 0.87895441E-10_JPRB, 0.87947885E-10_JPRB, 0.88001370E-10_JPRB, 0.88053682E-10_JPRB, &
  & 0.88102234E-10_JPRB, 0.88143867E-10_JPRB, 0.88175842E-10_JPRB, 0.88197540E-10_JPRB, 0.88209738E-10_JPRB, 0.88213881E-10_JPRB, &
  & 0.88211265E-10_JPRB, 0.88202619E-10_JPRB, 0.88188651E-10_JPRB, 0.88170457E-10_JPRB, 0.88149765E-10_JPRB, 0.88128158E-10_JPRB, &
  & 0.88107327E-10_JPRB, 0.88087843E-10_JPRB, 0.88070523E-10_JPRB, 0.88055549E-10_JPRB, 0.88043163E-10_JPRB, 0.88033358E-10_JPRB, &
  & 0.88025857E-10_JPRB, 0.88020154E-10_JPRB, 0.88015609E-10_JPRB, 0.88011390E-10_JPRB, 0.88006283E-10_JPRB, 0.87999372E-10_JPRB, &
  & 0.87989754E-10_JPRB, 0.87977257E-10_JPRB, 0.87961985E-10_JPRB, 0.87945172E-10_JPRB, 0.87927339E-10_JPRB, 0.87910235E-10_JPRB, &
  & 0.87891895E-10_JPRB, 0.87873236E-10_JPRB, 0.87844530E-10_JPRB, 0.87785196E-10_JPRB /)

RGHG9(:,71, 8) = (/ &
  & 0.87743930E-10_JPRB, 0.87795292E-10_JPRB, 0.87819446E-10_JPRB, 0.87837057E-10_JPRB, 0.87851379E-10_JPRB, 0.87864438E-10_JPRB, &
  & 0.87876942E-10_JPRB, 0.87889487E-10_JPRB, 0.87903032E-10_JPRB, 0.87915841E-10_JPRB, 0.87930163E-10_JPRB, 0.87943874E-10_JPRB, &
  & 0.87957218E-10_JPRB, 0.87968077E-10_JPRB, 0.87974655E-10_JPRB, 0.87974718E-10_JPRB, 0.87966676E-10_JPRB, 0.87949689E-10_JPRB, &
  & 0.87924924E-10_JPRB, 0.87895191E-10_JPRB, 0.87865916E-10_JPRB, 0.87843656E-10_JPRB, 0.87834948E-10_JPRB, 0.87842796E-10_JPRB, &
  & 0.87866291E-10_JPRB, 0.87901665E-10_JPRB, 0.87944471E-10_JPRB, 0.87991114E-10_JPRB, 0.88038563E-10_JPRB, 0.88084963E-10_JPRB, &
  & 0.88127797E-10_JPRB, 0.88164337E-10_JPRB, 0.88192190E-10_JPRB, 0.88210973E-10_JPRB, 0.88221555E-10_JPRB, 0.88225156E-10_JPRB, &
  & 0.88222950E-10_JPRB, 0.88215560E-10_JPRB, 0.88203611E-10_JPRB, 0.88188040E-10_JPRB, 0.88170249E-10_JPRB, 0.88151875E-10_JPRB, &
  & 0.88133868E-10_JPRB, 0.88117319E-10_JPRB, 0.88102338E-10_JPRB, 0.88089397E-10_JPRB, 0.88078635E-10_JPRB, 0.88070266E-10_JPRB, &
  & 0.88063938E-10_JPRB, 0.88059220E-10_JPRB, 0.88055535E-10_JPRB, 0.88052045E-10_JPRB, 0.88047687E-10_JPRB, 0.88041588E-10_JPRB, &
  & 0.88033095E-10_JPRB, 0.88021708E-10_JPRB, 0.88007768E-10_JPRB, 0.87992322E-10_JPRB, 0.87975863E-10_JPRB, 0.87960153E-10_JPRB, &
  & 0.87943423E-10_JPRB, 0.87925986E-10_JPRB, 0.87900437E-10_JPRB, 0.87844267E-10_JPRB /)

RGHG9(:,72, 8) = (/ &
  & 0.87783447E-10_JPRB, 0.87846272E-10_JPRB, 0.87875075E-10_JPRB, 0.87894081E-10_JPRB, 0.87909333E-10_JPRB, 0.87922392E-10_JPRB, &
  & 0.87934625E-10_JPRB, 0.87947094E-10_JPRB, 0.87958467E-10_JPRB, 0.87971505E-10_JPRB, 0.87982809E-10_JPRB, 0.87995958E-10_JPRB, &
  & 0.88007462E-10_JPRB, 0.88017163E-10_JPRB, 0.88022964E-10_JPRB, 0.88022922E-10_JPRB, 0.88015727E-10_JPRB, 0.88000982E-10_JPRB, &
  & 0.87979166E-10_JPRB, 0.87953221E-10_JPRB, 0.87927450E-10_JPRB, 0.87907605E-10_JPRB, 0.87899320E-10_JPRB, 0.87905197E-10_JPRB, &
  & 0.87924765E-10_JPRB, 0.87954997E-10_JPRB, 0.87992252E-10_JPRB, 0.88033018E-10_JPRB, 0.88074464E-10_JPRB, 0.88114890E-10_JPRB, &
  & 0.88152152E-10_JPRB, 0.88183613E-10_JPRB, 0.88207504E-10_JPRB, 0.88223553E-10_JPRB, 0.88232581E-10_JPRB, 0.88235662E-10_JPRB, &
  & 0.88233837E-10_JPRB, 0.88227606E-10_JPRB, 0.88217537E-10_JPRB, 0.88204305E-10_JPRB, 0.88189393E-10_JPRB, 0.88173774E-10_JPRB, &
  & 0.88158751E-10_JPRB, 0.88144672E-10_JPRB, 0.88132196E-10_JPRB, 0.88121191E-10_JPRB, 0.88112184E-10_JPRB, 0.88105218E-10_JPRB, &
  & 0.88100097E-10_JPRB, 0.88096364E-10_JPRB, 0.88093408E-10_JPRB, 0.88090632E-10_JPRB, 0.88086954E-10_JPRB, 0.88081924E-10_JPRB, &
  & 0.88074492E-10_JPRB, 0.88064722E-10_JPRB, 0.88052364E-10_JPRB, 0.88038646E-10_JPRB, 0.88024012E-10_JPRB, 0.88010106E-10_JPRB, &
  & 0.87995104E-10_JPRB, 0.87979735E-10_JPRB, 0.87956711E-10_JPRB, 0.87906037E-10_JPRB /)

RGHG9(:,73, 8) = (/ &
  & 0.87836113E-10_JPRB, 0.87904295E-10_JPRB, 0.87933771E-10_JPRB, 0.87953318E-10_JPRB, 0.87968112E-10_JPRB, 0.87980956E-10_JPRB, &
  & 0.87992849E-10_JPRB, 0.88003459E-10_JPRB, 0.88015234E-10_JPRB, 0.88024373E-10_JPRB, 0.88036307E-10_JPRB, 0.88046043E-10_JPRB, &
  & 0.88056541E-10_JPRB, 0.88064576E-10_JPRB, 0.88069385E-10_JPRB, 0.88069045E-10_JPRB, 0.88062703E-10_JPRB, 0.88049658E-10_JPRB, &
  & 0.88031055E-10_JPRB, 0.88008628E-10_JPRB, 0.87986500E-10_JPRB, 0.87969201E-10_JPRB, 0.87961582E-10_JPRB, 0.87965697E-10_JPRB, &
  & 0.87981511E-10_JPRB, 0.88006775E-10_JPRB, 0.88038465E-10_JPRB, 0.88073486E-10_JPRB, 0.88108881E-10_JPRB, 0.88143527E-10_JPRB, &
  & 0.88175189E-10_JPRB, 0.88201849E-10_JPRB, 0.88221888E-10_JPRB, 0.88235336E-10_JPRB, 0.88242920E-10_JPRB, 0.88245501E-10_JPRB, &
  & 0.88244002E-10_JPRB, 0.88238833E-10_JPRB, 0.88230513E-10_JPRB, 0.88219515E-10_JPRB, 0.88207171E-10_JPRB, 0.88194278E-10_JPRB, &
  & 0.88181740E-10_JPRB, 0.88170193E-10_JPRB, 0.88159910E-10_JPRB, 0.88150862E-10_JPRB, 0.88143499E-10_JPRB, 0.88137983E-10_JPRB, &
  & 0.88133945E-10_JPRB, 0.88131086E-10_JPRB, 0.88128831E-10_JPRB, 0.88126659E-10_JPRB, 0.88123744E-10_JPRB, 0.88119539E-10_JPRB, &
  & 0.88113503E-10_JPRB, 0.88105162E-10_JPRB, 0.88094684E-10_JPRB, 0.88082937E-10_JPRB, 0.88070384E-10_JPRB, 0.88058325E-10_JPRB, &
  & 0.88045522E-10_JPRB, 0.88031790E-10_JPRB, 0.88011945E-10_JPRB, 0.87966245E-10_JPRB /)

RGHG9(:,74, 8) = (/ &
  & 0.87895233E-10_JPRB, 0.87964643E-10_JPRB, 0.87994174E-10_JPRB, 0.88012229E-10_JPRB, 0.88026517E-10_JPRB, 0.88038382E-10_JPRB, &
  & 0.88048957E-10_JPRB, 0.88059449E-10_JPRB, 0.88067886E-10_JPRB, 0.88078086E-10_JPRB, 0.88085456E-10_JPRB, 0.88095475E-10_JPRB, &
  & 0.88103060E-10_JPRB, 0.88109735E-10_JPRB, 0.88113454E-10_JPRB, 0.88112698E-10_JPRB, 0.88106925E-10_JPRB, 0.88095933E-10_JPRB, &
  & 0.88079946E-10_JPRB, 0.88061163E-10_JPRB, 0.88042587E-10_JPRB, 0.88027884E-10_JPRB, 0.88021118E-10_JPRB, 0.88023797E-10_JPRB, &
  & 0.88036238E-10_JPRB, 0.88056687E-10_JPRB, 0.88083027E-10_JPRB, 0.88112316E-10_JPRB, 0.88141799E-10_JPRB, 0.88170818E-10_JPRB, &
  & 0.88197026E-10_JPRB, 0.88218974E-10_JPRB, 0.88235454E-10_JPRB, 0.88246424E-10_JPRB, 0.88252662E-10_JPRB, 0.88254730E-10_JPRB, &
  & 0.88253543E-10_JPRB, 0.88249345E-10_JPRB, 0.88242628E-10_JPRB, 0.88233670E-10_JPRB, 0.88223748E-10_JPRB, 0.88213312E-10_JPRB, &
  & 0.88203105E-10_JPRB, 0.88193806E-10_JPRB, 0.88185674E-10_JPRB, 0.88178381E-10_JPRB, 0.88172636E-10_JPRB, 0.88168375E-10_JPRB, &
  & 0.88165350E-10_JPRB, 0.88163282E-10_JPRB, 0.88161589E-10_JPRB, 0.88159965E-10_JPRB, 0.88157634E-10_JPRB, 0.88154428E-10_JPRB, &
  & 0.88149404E-10_JPRB, 0.88142764E-10_JPRB, 0.88134042E-10_JPRB, 0.88124258E-10_JPRB, 0.88113974E-10_JPRB, 0.88103851E-10_JPRB, &
  & 0.88093047E-10_JPRB, 0.88081341E-10_JPRB, 0.88064174E-10_JPRB, 0.88023318E-10_JPRB /)

RGHG9(:,75, 8) = (/ &
  & 0.87957162E-10_JPRB, 0.88026218E-10_JPRB, 0.88052982E-10_JPRB, 0.88069704E-10_JPRB, 0.88082132E-10_JPRB, 0.88092783E-10_JPRB, &
  & 0.88102386E-10_JPRB, 0.88110574E-10_JPRB, 0.88119442E-10_JPRB, 0.88125597E-10_JPRB, 0.88133903E-10_JPRB, 0.88140023E-10_JPRB, &
  & 0.88146726E-10_JPRB, 0.88151555E-10_JPRB, 0.88154303E-10_JPRB, 0.88153262E-10_JPRB, 0.88148273E-10_JPRB, 0.88139079E-10_JPRB, &
  & 0.88126020E-10_JPRB, 0.88110588E-10_JPRB, 0.88095517E-10_JPRB, 0.88083360E-10_JPRB, 0.88077566E-10_JPRB, 0.88079127E-10_JPRB, &
  & 0.88088578E-10_JPRB, 0.88104642E-10_JPRB, 0.88125784E-10_JPRB, 0.88149404E-10_JPRB, 0.88173219E-10_JPRB, 0.88196749E-10_JPRB, &
  & 0.88217635E-10_JPRB, 0.88235169E-10_JPRB, 0.88248200E-10_JPRB, 0.88256916E-10_JPRB, 0.88261870E-10_JPRB, 0.88263452E-10_JPRB, &
  & 0.88262578E-10_JPRB, 0.88259261E-10_JPRB, 0.88254036E-10_JPRB, 0.88246951E-10_JPRB, 0.88239339E-10_JPRB, 0.88231103E-10_JPRB, &
  & 0.88223061E-10_JPRB, 0.88215754E-10_JPRB, 0.88209565E-10_JPRB, 0.88203916E-10_JPRB, 0.88199587E-10_JPRB, 0.88196526E-10_JPRB, &
  & 0.88194348E-10_JPRB, 0.88192995E-10_JPRB, 0.88191753E-10_JPRB, 0.88190608E-10_JPRB, 0.88188845E-10_JPRB, 0.88186417E-10_JPRB, &
  & 0.88182552E-10_JPRB, 0.88177229E-10_JPRB, 0.88170291E-10_JPRB, 0.88162512E-10_JPRB, 0.88154296E-10_JPRB, 0.88146192E-10_JPRB, &
  & 0.88137352E-10_JPRB, 0.88127734E-10_JPRB, 0.88112649E-10_JPRB, 0.88076997E-10_JPRB /)

RGHG9(:,76, 8) = (/ &
  & 0.88022069E-10_JPRB, 0.88085844E-10_JPRB, 0.88110179E-10_JPRB, 0.88123751E-10_JPRB, 0.88134444E-10_JPRB, 0.88143159E-10_JPRB, &
  & 0.88151042E-10_JPRB, 0.88158522E-10_JPRB, 0.88164448E-10_JPRB, 0.88170971E-10_JPRB, 0.88175398E-10_JPRB, 0.88181566E-10_JPRB, &
  & 0.88185709E-10_JPRB, 0.88189386E-10_JPRB, 0.88191413E-10_JPRB, 0.88190254E-10_JPRB, 0.88186181E-10_JPRB, 0.88179047E-10_JPRB, &
  & 0.88168785E-10_JPRB, 0.88156732E-10_JPRB, 0.88145019E-10_JPRB, 0.88135318E-10_JPRB, 0.88130662E-10_JPRB, 0.88131460E-10_JPRB, &
  & 0.88138441E-10_JPRB, 0.88150411E-10_JPRB, 0.88166564E-10_JPRB, 0.88184793E-10_JPRB, 0.88203084E-10_JPRB, 0.88221180E-10_JPRB, &
  & 0.88237147E-10_JPRB, 0.88250386E-10_JPRB, 0.88260288E-10_JPRB, 0.88266859E-10_JPRB, 0.88270641E-10_JPRB, 0.88271772E-10_JPRB, &
  & 0.88271161E-10_JPRB, 0.88268649E-10_JPRB, 0.88264826E-10_JPRB, 0.88259434E-10_JPRB, 0.88253946E-10_JPRB, 0.88247798E-10_JPRB, &
  & 0.88241602E-10_JPRB, 0.88236182E-10_JPRB, 0.88231748E-10_JPRB, 0.88227543E-10_JPRB, 0.88224553E-10_JPRB, 0.88222422E-10_JPRB, &
  & 0.88220979E-10_JPRB, 0.88220209E-10_JPRB, 0.88219348E-10_JPRB, 0.88218627E-10_JPRB, 0.88217350E-10_JPRB, 0.88215726E-10_JPRB, &
  & 0.88212770E-10_JPRB, 0.88208850E-10_JPRB, 0.88203479E-10_JPRB, 0.88197574E-10_JPRB, 0.88191530E-10_JPRB, 0.88185223E-10_JPRB, &
  & 0.88178499E-10_JPRB, 0.88170665E-10_JPRB, 0.88158467E-10_JPRB, 0.88126083E-10_JPRB /)

RGHG9(:,77, 8) = (/ &
  & 0.88087440E-10_JPRB, 0.88143999E-10_JPRB, 0.88163733E-10_JPRB, 0.88174329E-10_JPRB, 0.88182336E-10_JPRB, 0.88189067E-10_JPRB, &
  & 0.88195062E-10_JPRB, 0.88200350E-10_JPRB, 0.88205700E-10_JPRB, 0.88209107E-10_JPRB, 0.88213284E-10_JPRB, 0.88216920E-10_JPRB, &
  & 0.88220084E-10_JPRB, 0.88222533E-10_JPRB, 0.88224129E-10_JPRB, 0.88223054E-10_JPRB, 0.88220029E-10_JPRB, 0.88214901E-10_JPRB, &
  & 0.88207525E-10_JPRB, 0.88198726E-10_JPRB, 0.88190295E-10_JPRB, 0.88183072E-10_JPRB, 0.88179727E-10_JPRB, 0.88180130E-10_JPRB, &
  & 0.88185084E-10_JPRB, 0.88193369E-10_JPRB, 0.88204888E-10_JPRB, 0.88218030E-10_JPRB, 0.88231006E-10_JPRB, 0.88244016E-10_JPRB, &
  & 0.88255306E-10_JPRB, 0.88264680E-10_JPRB, 0.88271626E-10_JPRB, 0.88276289E-10_JPRB, 0.88279023E-10_JPRB, 0.88279710E-10_JPRB, &
  & 0.88279384E-10_JPRB, 0.88277573E-10_JPRB, 0.88275033E-10_JPRB, 0.88271182E-10_JPRB, 0.88267671E-10_JPRB, 0.88263348E-10_JPRB, &
  & 0.88258872E-10_JPRB, 0.88255014E-10_JPRB, 0.88252149E-10_JPRB, 0.88249207E-10_JPRB, 0.88247284E-10_JPRB, 0.88245938E-10_JPRB, &
  & 0.88244946E-10_JPRB, 0.88244682E-10_JPRB, 0.88244044E-10_JPRB, 0.88243718E-10_JPRB, 0.88242830E-10_JPRB, 0.88241969E-10_JPRB, &
  & 0.88239915E-10_JPRB, 0.88237286E-10_JPRB, 0.88233434E-10_JPRB, 0.88229396E-10_JPRB, 0.88225302E-10_JPRB, 0.88220924E-10_JPRB, &
  & 0.88215983E-10_JPRB, 0.88210453E-10_JPRB, 0.88199982E-10_JPRB, 0.88172976E-10_JPRB /)

RGHG9(:,78, 8) = (/ &
  & 0.88153748E-10_JPRB, 0.88196839E-10_JPRB, 0.88210696E-10_JPRB, 0.88217628E-10_JPRB, 0.88223290E-10_JPRB, 0.88227675E-10_JPRB, &
  & 0.88231769E-10_JPRB, 0.88235336E-10_JPRB, 0.88238583E-10_JPRB, 0.88240894E-10_JPRB, 0.88242837E-10_JPRB, 0.88245952E-10_JPRB, &
  & 0.88247756E-10_JPRB, 0.88249442E-10_JPRB, 0.88250775E-10_JPRB, 0.88249796E-10_JPRB, 0.88247777E-10_JPRB, 0.88244516E-10_JPRB, &
  & 0.88239679E-10_JPRB, 0.88233899E-10_JPRB, 0.88228563E-10_JPRB, 0.88223644E-10_JPRB, 0.88221860E-10_JPRB, 0.88222200E-10_JPRB, &
  & 0.88225746E-10_JPRB, 0.88230916E-10_JPRB, 0.88238507E-10_JPRB, 0.88247291E-10_JPRB, 0.88255438E-10_JPRB, 0.88264125E-10_JPRB, &
  & 0.88271286E-10_JPRB, 0.88277337E-10_JPRB, 0.88281750E-10_JPRB, 0.88284755E-10_JPRB, 0.88286621E-10_JPRB, 0.88286940E-10_JPRB, &
  & 0.88286885E-10_JPRB, 0.88285643E-10_JPRB, 0.88284172E-10_JPRB, 0.88281618E-10_JPRB, 0.88279800E-10_JPRB, 0.88277059E-10_JPRB, &
  & 0.88273930E-10_JPRB, 0.88271390E-10_JPRB, 0.88269753E-10_JPRB, 0.88267740E-10_JPRB, 0.88266630E-10_JPRB, 0.88265749E-10_JPRB, &
  & 0.88265013E-10_JPRB, 0.88265062E-10_JPRB, 0.88264479E-10_JPRB, 0.88264410E-10_JPRB, 0.88263799E-10_JPRB, 0.88263626E-10_JPRB, &
  & 0.88262335E-10_JPRB, 0.88260912E-10_JPRB, 0.88258428E-10_JPRB, 0.88256007E-10_JPRB, 0.88253828E-10_JPRB, 0.88251004E-10_JPRB, &
  & 0.88247853E-10_JPRB, 0.88244113E-10_JPRB, 0.88237050E-10_JPRB, 0.88216191E-10_JPRB /)

RGHG9(:,79, 8) = (/ &
  & 0.88196908E-10_JPRB, 0.88226690E-10_JPRB, 0.88235870E-10_JPRB, 0.88240248E-10_JPRB, 0.88244592E-10_JPRB, 0.88247860E-10_JPRB, &
  & 0.88250844E-10_JPRB, 0.88253377E-10_JPRB, 0.88256000E-10_JPRB, 0.88257124E-10_JPRB, 0.88258456E-10_JPRB, 0.88260947E-10_JPRB, &
  & 0.88262189E-10_JPRB, 0.88263466E-10_JPRB, 0.88264708E-10_JPRB, 0.88263730E-10_JPRB, 0.88262238E-10_JPRB, 0.88259955E-10_JPRB, &
  & 0.88256596E-10_JPRB, 0.88252364E-10_JPRB, 0.88248728E-10_JPRB, 0.88245057E-10_JPRB, 0.88244155E-10_JPRB, 0.88244585E-10_JPRB, &
  & 0.88247472E-10_JPRB, 0.88251004E-10_JPRB, 0.88256590E-10_JPRB, 0.88263091E-10_JPRB, 0.88268649E-10_JPRB, 0.88275026E-10_JPRB, &
  & 0.88279981E-10_JPRB, 0.88284213E-10_JPRB, 0.88287246E-10_JPRB, 0.88289369E-10_JPRB, 0.88290777E-10_JPRB, 0.88290854E-10_JPRB, &
  & 0.88290958E-10_JPRB, 0.88289973E-10_JPRB, 0.88289126E-10_JPRB, 0.88287225E-10_JPRB, 0.88286350E-10_JPRB, 0.88284421E-10_JPRB, &
  & 0.88281923E-10_JPRB, 0.88279987E-10_JPRB, 0.88279016E-10_JPRB, 0.88277434E-10_JPRB, 0.88276705E-10_JPRB, 0.88276039E-10_JPRB, &
  & 0.88275359E-10_JPRB, 0.88275609E-10_JPRB, 0.88274950E-10_JPRB, 0.88274998E-10_JPRB, 0.88274485E-10_JPRB, 0.88274714E-10_JPRB, &
  & 0.88273749E-10_JPRB, 0.88272979E-10_JPRB, 0.88271120E-10_JPRB, 0.88269558E-10_JPRB, 0.88268379E-10_JPRB, 0.88266366E-10_JPRB, &
  & 0.88264090E-10_JPRB, 0.88261870E-10_JPRB, 0.88257068E-10_JPRB, 0.88243697E-10_JPRB /)

RGHG9(:,80, 8) = (/ &
  & 0.88225816E-10_JPRB, 0.88241157E-10_JPRB, 0.88246924E-10_JPRB, 0.88250046E-10_JPRB, 0.88253786E-10_JPRB, 0.88256520E-10_JPRB, &
  & 0.88259157E-10_JPRB, 0.88261162E-10_JPRB, 0.88263681E-10_JPRB, 0.88264292E-10_JPRB, 0.88265326E-10_JPRB, 0.88267609E-10_JPRB, &
  & 0.88268573E-10_JPRB, 0.88269683E-10_JPRB, 0.88270946E-10_JPRB, 0.88269961E-10_JPRB, 0.88268698E-10_JPRB, 0.88266942E-10_JPRB, &
  & 0.88264208E-10_JPRB, 0.88260711E-10_JPRB, 0.88257873E-10_JPRB, 0.88254667E-10_JPRB, 0.88254237E-10_JPRB, 0.88254661E-10_JPRB, &
  & 0.88257276E-10_JPRB, 0.88260066E-10_JPRB, 0.88264770E-10_JPRB, 0.88270273E-10_JPRB, 0.88274638E-10_JPRB, 0.88280015E-10_JPRB, &
  & 0.88283943E-10_JPRB, 0.88287350E-10_JPRB, 0.88289751E-10_JPRB, 0.88291464E-10_JPRB, 0.88292665E-10_JPRB, 0.88292644E-10_JPRB, &
  & 0.88292818E-10_JPRB, 0.88291943E-10_JPRB, 0.88291367E-10_JPRB, 0.88289757E-10_JPRB, 0.88289327E-10_JPRB, 0.88287738E-10_JPRB, &
  & 0.88285476E-10_JPRB, 0.88283797E-10_JPRB, 0.88283110E-10_JPRB, 0.88281694E-10_JPRB, 0.88281167E-10_JPRB, 0.88280605E-10_JPRB, &
  & 0.88279939E-10_JPRB, 0.88280293E-10_JPRB, 0.88279543E-10_JPRB, 0.88279627E-10_JPRB, 0.88279106E-10_JPRB, 0.88279564E-10_JPRB, &
  & 0.88278676E-10_JPRB, 0.88278169E-10_JPRB, 0.88276504E-10_JPRB, 0.88275311E-10_JPRB, 0.88274610E-10_JPRB, 0.88272903E-10_JPRB, &
  & 0.88271085E-10_JPRB, 0.88269538E-10_JPRB, 0.88266623E-10_JPRB, 0.88261495E-10_JPRB /)

RGHG9(:,81, 8) = (/ &
  & 0.88245772E-10_JPRB, 0.88247278E-10_JPRB, 0.88251573E-10_JPRB, 0.88254168E-10_JPRB, 0.88257728E-10_JPRB, 0.88260330E-10_JPRB, &
  & 0.88262668E-10_JPRB, 0.88264826E-10_JPRB, 0.88266804E-10_JPRB, 0.88267511E-10_JPRB, 0.88268184E-10_JPRB, 0.88270613E-10_JPRB, &
  & 0.88271369E-10_JPRB, 0.88272417E-10_JPRB, 0.88273694E-10_JPRB, 0.88272709E-10_JPRB, 0.88271591E-10_JPRB, 0.88270051E-10_JPRB, &
  & 0.88267650E-10_JPRB, 0.88264424E-10_JPRB, 0.88261946E-10_JPRB, 0.88258893E-10_JPRB, 0.88258706E-10_JPRB, 0.88259108E-10_JPRB, &
  & 0.88261620E-10_JPRB, 0.88264049E-10_JPRB, 0.88268400E-10_JPRB, 0.88273465E-10_JPRB, 0.88277330E-10_JPRB, 0.88282215E-10_JPRB, &
  & 0.88285684E-10_JPRB, 0.88288758E-10_JPRB, 0.88290875E-10_JPRB, 0.88292401E-10_JPRB, 0.88293539E-10_JPRB, 0.88293428E-10_JPRB, &
  & 0.88293636E-10_JPRB, 0.88292811E-10_JPRB, 0.88292353E-10_JPRB, 0.88290868E-10_JPRB, 0.88290660E-10_JPRB, 0.88289237E-10_JPRB, &
  & 0.88287065E-10_JPRB, 0.88285462E-10_JPRB, 0.88284886E-10_JPRB, 0.88283533E-10_JPRB, 0.88283131E-10_JPRB, 0.88282610E-10_JPRB, &
  & 0.88281930E-10_JPRB, 0.88282361E-10_JPRB, 0.88281563E-10_JPRB, 0.88281653E-10_JPRB, 0.88281091E-10_JPRB, 0.88281688E-10_JPRB, &
  & 0.88280813E-10_JPRB, 0.88280418E-10_JPRB, 0.88278787E-10_JPRB, 0.88277739E-10_JPRB, 0.88277261E-10_JPRB, 0.88275692E-10_JPRB, &
  & 0.88274027E-10_JPRB, 0.88272785E-10_JPRB, 0.88270571E-10_JPRB, 0.88273618E-10_JPRB /)

RGHG9(:,82, 8) = (/ &
  & 0.88247326E-10_JPRB, 0.88249304E-10_JPRB, 0.88253627E-10_JPRB, 0.88256139E-10_JPRB, 0.88259663E-10_JPRB, 0.88262106E-10_JPRB, &
  & 0.88264576E-10_JPRB, 0.88266144E-10_JPRB, 0.88268629E-10_JPRB, 0.88268934E-10_JPRB, 0.88269926E-10_JPRB, 0.88271834E-10_JPRB, &
  & 0.88272743E-10_JPRB, 0.88273763E-10_JPRB, 0.88275061E-10_JPRB, 0.88274062E-10_JPRB, 0.88273007E-10_JPRB, 0.88271626E-10_JPRB, &
  & 0.88269378E-10_JPRB, 0.88266297E-10_JPRB, 0.88264007E-10_JPRB, 0.88260975E-10_JPRB, 0.88260912E-10_JPRB, 0.88261259E-10_JPRB, &
  & 0.88263730E-10_JPRB, 0.88265992E-10_JPRB, 0.88270141E-10_JPRB, 0.88275103E-10_JPRB, 0.88278641E-10_JPRB, 0.88283311E-10_JPRB, &
  & 0.88286531E-10_JPRB, 0.88289417E-10_JPRB, 0.88291402E-10_JPRB, 0.88292852E-10_JPRB, 0.88293955E-10_JPRB, 0.88293824E-10_JPRB, &
  & 0.88294046E-10_JPRB, 0.88293220E-10_JPRB, 0.88292831E-10_JPRB, 0.88291423E-10_JPRB, 0.88291305E-10_JPRB, 0.88289945E-10_JPRB, &
  & 0.88287828E-10_JPRB, 0.88286253E-10_JPRB, 0.88285761E-10_JPRB, 0.88284463E-10_JPRB, 0.88284102E-10_JPRB, 0.88283589E-10_JPRB, &
  & 0.88282923E-10_JPRB, 0.88283394E-10_JPRB, 0.88282527E-10_JPRB, 0.88282659E-10_JPRB, 0.88282069E-10_JPRB, 0.88282763E-10_JPRB, &
  & 0.88281861E-10_JPRB, 0.88281514E-10_JPRB, 0.88279876E-10_JPRB, 0.88278891E-10_JPRB, 0.88278558E-10_JPRB, 0.88277038E-10_JPRB, &
  & 0.88275429E-10_JPRB, 0.88274214E-10_JPRB, 0.88271883E-10_JPRB, 0.88274589E-10_JPRB /)

RGHG9(:,83, 8) = (/ &
  & 0.88248429E-10_JPRB, 0.88250497E-10_JPRB, 0.88254778E-10_JPRB, 0.88257221E-10_JPRB, 0.88260711E-10_JPRB, 0.88263244E-10_JPRB, &
  & 0.88265388E-10_JPRB, 0.88267622E-10_JPRB, 0.88269142E-10_JPRB, 0.88269919E-10_JPRB, 0.88270447E-10_JPRB, 0.88272806E-10_JPRB, &
  & 0.88273479E-10_JPRB, 0.88274513E-10_JPRB, 0.88275803E-10_JPRB, 0.88274839E-10_JPRB, 0.88273805E-10_JPRB, 0.88272514E-10_JPRB, &
  & 0.88270349E-10_JPRB, 0.88267345E-10_JPRB, 0.88265187E-10_JPRB, 0.88262113E-10_JPRB, 0.88262155E-10_JPRB, 0.88262425E-10_JPRB, &
  & 0.88264916E-10_JPRB, 0.88267019E-10_JPRB, 0.88271224E-10_JPRB, 0.88275956E-10_JPRB, 0.88279439E-10_JPRB, 0.88283908E-10_JPRB, &
  & 0.88287024E-10_JPRB, 0.88289792E-10_JPRB, 0.88291700E-10_JPRB, 0.88293116E-10_JPRB, 0.88294178E-10_JPRB, 0.88294039E-10_JPRB, &
  & 0.88294268E-10_JPRB, 0.88293442E-10_JPRB, 0.88293074E-10_JPRB, 0.88291742E-10_JPRB, 0.88291659E-10_JPRB, 0.88290375E-10_JPRB, &
  & 0.88288266E-10_JPRB, 0.88286725E-10_JPRB, 0.88286232E-10_JPRB, 0.88284956E-10_JPRB, 0.88284643E-10_JPRB, 0.88284151E-10_JPRB, &
  & 0.88283478E-10_JPRB, 0.88283984E-10_JPRB, 0.88283075E-10_JPRB, 0.88283235E-10_JPRB, 0.88282610E-10_JPRB, 0.88283353E-10_JPRB, &
  & 0.88282437E-10_JPRB, 0.88282145E-10_JPRB, 0.88280480E-10_JPRB, 0.88279509E-10_JPRB, 0.88279287E-10_JPRB, 0.88277816E-10_JPRB, &
  & 0.88276220E-10_JPRB, 0.88275026E-10_JPRB, 0.88272625E-10_JPRB, 0.88275255E-10_JPRB /)

RGHG9(:,84, 8) = (/ &
  & 0.88249193E-10_JPRB, 0.88251267E-10_JPRB, 0.88255528E-10_JPRB, 0.88257880E-10_JPRB, 0.88261412E-10_JPRB, 0.88263820E-10_JPRB, &
  & 0.88266339E-10_JPRB, 0.88267720E-10_JPRB, 0.88270030E-10_JPRB, 0.88270370E-10_JPRB, 0.88271432E-10_JPRB, 0.88272945E-10_JPRB, &
  & 0.88273965E-10_JPRB, 0.88274950E-10_JPRB, 0.88276157E-10_JPRB, 0.88275304E-10_JPRB, 0.88274332E-10_JPRB, 0.88273069E-10_JPRB, &
  & 0.88270974E-10_JPRB, 0.88268004E-10_JPRB, 0.88265895E-10_JPRB, 0.88262807E-10_JPRB, 0.88262911E-10_JPRB, 0.88263133E-10_JPRB, &
  & 0.88265645E-10_JPRB, 0.88267699E-10_JPRB, 0.88271709E-10_JPRB, 0.88276643E-10_JPRB, 0.88279849E-10_JPRB, 0.88284331E-10_JPRB, &
  & 0.88287322E-10_JPRB, 0.88290028E-10_JPRB, 0.88291888E-10_JPRB, 0.88293262E-10_JPRB, 0.88294330E-10_JPRB, 0.88294164E-10_JPRB, &
  & 0.88294413E-10_JPRB, 0.88293567E-10_JPRB, 0.88293248E-10_JPRB, 0.88291929E-10_JPRB, 0.88291888E-10_JPRB, 0.88290611E-10_JPRB, &
  & 0.88288599E-10_JPRB, 0.88286989E-10_JPRB, 0.88286531E-10_JPRB, 0.88285254E-10_JPRB, 0.88284963E-10_JPRB, 0.88284512E-10_JPRB, &
  & 0.88283825E-10_JPRB, 0.88284338E-10_JPRB, 0.88283415E-10_JPRB, 0.88283575E-10_JPRB, 0.88282923E-10_JPRB, 0.88283728E-10_JPRB, &
  & 0.88282812E-10_JPRB, 0.88282527E-10_JPRB, 0.88280841E-10_JPRB, 0.88279890E-10_JPRB, 0.88279752E-10_JPRB, 0.88278274E-10_JPRB, &
  & 0.88276705E-10_JPRB, 0.88275554E-10_JPRB, 0.88273132E-10_JPRB, 0.88275727E-10_JPRB /)

RGHG9(:,85, 8) = (/ &
  & 0.88249692E-10_JPRB, 0.88251781E-10_JPRB, 0.88255986E-10_JPRB, 0.88258338E-10_JPRB, 0.88261863E-10_JPRB, 0.88264562E-10_JPRB, &
  & 0.88266540E-10_JPRB, 0.88268823E-10_JPRB, 0.88270037E-10_JPRB, 0.88270960E-10_JPRB, 0.88271612E-10_JPRB, 0.88273354E-10_JPRB, &
  & 0.88274194E-10_JPRB, 0.88275193E-10_JPRB, 0.88276150E-10_JPRB, 0.88275533E-10_JPRB, 0.88274658E-10_JPRB, 0.88273430E-10_JPRB, &
  & 0.88271418E-10_JPRB, 0.88268448E-10_JPRB, 0.88266415E-10_JPRB, 0.88263244E-10_JPRB, 0.88263410E-10_JPRB, 0.88263584E-10_JPRB, &
  & 0.88266124E-10_JPRB, 0.88267990E-10_JPRB, 0.88272237E-10_JPRB, 0.88276907E-10_JPRB, 0.88280272E-10_JPRB, 0.88284546E-10_JPRB, &
  & 0.88287544E-10_JPRB, 0.88290181E-10_JPRB, 0.88291992E-10_JPRB, 0.88293352E-10_JPRB, 0.88294420E-10_JPRB, 0.88294254E-10_JPRB, &
  & 0.88294490E-10_JPRB, 0.88293650E-10_JPRB, 0.88293317E-10_JPRB, 0.88292040E-10_JPRB, 0.88292033E-10_JPRB, 0.88290833E-10_JPRB, &
  & 0.88288724E-10_JPRB, 0.88287197E-10_JPRB, 0.88286690E-10_JPRB, 0.88285476E-10_JPRB, 0.88285185E-10_JPRB, 0.88284748E-10_JPRB, &
  & 0.88284054E-10_JPRB, 0.88284581E-10_JPRB, 0.88283651E-10_JPRB, 0.88283818E-10_JPRB, 0.88283145E-10_JPRB, 0.88283970E-10_JPRB, &
  & 0.88283048E-10_JPRB, 0.88282784E-10_JPRB, 0.88281091E-10_JPRB, 0.88280147E-10_JPRB, 0.88280050E-10_JPRB, 0.88278593E-10_JPRB, &
  & 0.88277025E-10_JPRB, 0.88275887E-10_JPRB, 0.88273444E-10_JPRB, 0.88276032E-10_JPRB /)

RGHG9(:,86, 8) = (/ &
  & 0.88250018E-10_JPRB, 0.88252093E-10_JPRB, 0.88256291E-10_JPRB, 0.88258623E-10_JPRB, 0.88262404E-10_JPRB, 0.88264673E-10_JPRB, &
  & 0.88267504E-10_JPRB, 0.88268746E-10_JPRB, 0.88270627E-10_JPRB, 0.88271196E-10_JPRB, 0.88272174E-10_JPRB, 0.88273340E-10_JPRB, &
  & 0.88274305E-10_JPRB, 0.88275137E-10_JPRB, 0.88275942E-10_JPRB, 0.88275595E-10_JPRB, 0.88274818E-10_JPRB, 0.88273694E-10_JPRB, &
  & 0.88271723E-10_JPRB, 0.88268830E-10_JPRB, 0.88266734E-10_JPRB, 0.88263556E-10_JPRB, 0.88263723E-10_JPRB, 0.88263855E-10_JPRB, &
  & 0.88266408E-10_JPRB, 0.88268240E-10_JPRB, 0.88272278E-10_JPRB, 0.88277281E-10_JPRB, 0.88280341E-10_JPRB, 0.88284817E-10_JPRB, &
  & 0.88287676E-10_JPRB, 0.88290299E-10_JPRB, 0.88292082E-10_JPRB, 0.88293428E-10_JPRB, 0.88294497E-10_JPRB, 0.88294309E-10_JPRB, &
  & 0.88294566E-10_JPRB, 0.88293692E-10_JPRB, 0.88293414E-10_JPRB, 0.88292103E-10_JPRB, 0.88292158E-10_JPRB, 0.88290930E-10_JPRB, &
  & 0.88288876E-10_JPRB, 0.88287225E-10_JPRB, 0.88286829E-10_JPRB, 0.88285580E-10_JPRB, 0.88285310E-10_JPRB, 0.88284893E-10_JPRB, &
  & 0.88284213E-10_JPRB, 0.88284713E-10_JPRB, 0.88283804E-10_JPRB, 0.88283977E-10_JPRB, 0.88283283E-10_JPRB, 0.88284123E-10_JPRB, &
  & 0.88283200E-10_JPRB, 0.88282943E-10_JPRB, 0.88281223E-10_JPRB, 0.88280300E-10_JPRB, 0.88280244E-10_JPRB, 0.88278787E-10_JPRB, &
  & 0.88277247E-10_JPRB, 0.88276136E-10_JPRB, 0.88273638E-10_JPRB, 0.88276254E-10_JPRB /)

RGHG9(:,87, 8) = (/ &
  & 0.88250240E-10_JPRB, 0.88252350E-10_JPRB, 0.88256499E-10_JPRB, 0.88258956E-10_JPRB, 0.88262384E-10_JPRB, 0.88265617E-10_JPRB, &
  & 0.88267338E-10_JPRB, 0.88269531E-10_JPRB, 0.88270613E-10_JPRB, 0.88271557E-10_JPRB, 0.88272299E-10_JPRB, 0.88273486E-10_JPRB, &
  & 0.88274284E-10_JPRB, 0.88275082E-10_JPRB, 0.88275727E-10_JPRB, 0.88275505E-10_JPRB, 0.88274887E-10_JPRB, 0.88273826E-10_JPRB, &
  & 0.88271973E-10_JPRB, 0.88269080E-10_JPRB, 0.88266998E-10_JPRB, 0.88263744E-10_JPRB, 0.88263917E-10_JPRB, 0.88264014E-10_JPRB, &
  & 0.88266609E-10_JPRB, 0.88268268E-10_JPRB, 0.88272473E-10_JPRB, 0.88277323E-10_JPRB, 0.88280536E-10_JPRB, 0.88284949E-10_JPRB, &
  & 0.88287801E-10_JPRB, 0.88290403E-10_JPRB, 0.88292158E-10_JPRB, 0.88293498E-10_JPRB, 0.88294566E-10_JPRB, 0.88294351E-10_JPRB, &
  & 0.88294649E-10_JPRB, 0.88293740E-10_JPRB, 0.88293511E-10_JPRB, 0.88292131E-10_JPRB, 0.88292290E-10_JPRB, 0.88291069E-10_JPRB, &
  & 0.88288821E-10_JPRB, 0.88287266E-10_JPRB, 0.88286850E-10_JPRB, 0.88285664E-10_JPRB, 0.88285372E-10_JPRB, 0.88284977E-10_JPRB, &
  & 0.88284324E-10_JPRB, 0.88284775E-10_JPRB, 0.88283901E-10_JPRB, 0.88284074E-10_JPRB, 0.88283374E-10_JPRB, 0.88284213E-10_JPRB, &
  & 0.88283297E-10_JPRB, 0.88283048E-10_JPRB, 0.88281306E-10_JPRB, 0.88280376E-10_JPRB, 0.88280369E-10_JPRB, 0.88278926E-10_JPRB, &
  & 0.88277365E-10_JPRB, 0.88276261E-10_JPRB, 0.88273742E-10_JPRB, 0.88276379E-10_JPRB /)

RGHG9(:,88, 8) = (/ &
  & 0.88250462E-10_JPRB, 0.88252676E-10_JPRB, 0.88256555E-10_JPRB, 0.88258921E-10_JPRB, 0.88262939E-10_JPRB, 0.88265124E-10_JPRB, &
  & 0.88268060E-10_JPRB, 0.88269281E-10_JPRB, 0.88270925E-10_JPRB, 0.88271584E-10_JPRB, 0.88272473E-10_JPRB, 0.88273486E-10_JPRB, &
  & 0.88274311E-10_JPRB, 0.88275026E-10_JPRB, 0.88275665E-10_JPRB, 0.88275491E-10_JPRB, 0.88274887E-10_JPRB, 0.88273902E-10_JPRB, &
  & 0.88272056E-10_JPRB, 0.88269239E-10_JPRB, 0.88267095E-10_JPRB, 0.88263868E-10_JPRB, 0.88264063E-10_JPRB, 0.88264097E-10_JPRB, &
  & 0.88266706E-10_JPRB, 0.88268302E-10_JPRB, 0.88272424E-10_JPRB, 0.88277503E-10_JPRB, 0.88280494E-10_JPRB, 0.88285115E-10_JPRB, &
  & 0.88287877E-10_JPRB, 0.88290479E-10_JPRB, 0.88292214E-10_JPRB, 0.88293539E-10_JPRB, 0.88294622E-10_JPRB, 0.88294386E-10_JPRB, &
  & 0.88294698E-10_JPRB, 0.88293754E-10_JPRB, 0.88293588E-10_JPRB, 0.88292110E-10_JPRB, 0.88292429E-10_JPRB, 0.88291173E-10_JPRB, &
  & 0.88288869E-10_JPRB, 0.88287183E-10_JPRB, 0.88286913E-10_JPRB, 0.88285677E-10_JPRB, 0.88285414E-10_JPRB, 0.88285032E-10_JPRB, &
  & 0.88284401E-10_JPRB, 0.88284817E-10_JPRB, 0.88283977E-10_JPRB, 0.88284137E-10_JPRB, 0.88283429E-10_JPRB, 0.88284269E-10_JPRB, &
  & 0.88283360E-10_JPRB, 0.88283110E-10_JPRB, 0.88281361E-10_JPRB, 0.88280425E-10_JPRB, 0.88280459E-10_JPRB, 0.88278995E-10_JPRB, &
  & 0.88277455E-10_JPRB, 0.88276372E-10_JPRB, 0.88273798E-10_JPRB, 0.88276456E-10_JPRB /)

RGHG9(:,89, 8) = (/ &
  & 0.88250761E-10_JPRB, 0.88252974E-10_JPRB, 0.88256541E-10_JPRB, 0.88258970E-10_JPRB, 0.88262439E-10_JPRB, 0.88265645E-10_JPRB, &
  & 0.88267414E-10_JPRB, 0.88269586E-10_JPRB, 0.88270766E-10_JPRB, 0.88271640E-10_JPRB, 0.88272424E-10_JPRB, 0.88273611E-10_JPRB, &
  & 0.88274429E-10_JPRB, 0.88275220E-10_JPRB, 0.88275859E-10_JPRB, 0.88275623E-10_JPRB, 0.88274998E-10_JPRB, 0.88273951E-10_JPRB, &
  & 0.88272112E-10_JPRB, 0.88269211E-10_JPRB, 0.88267199E-10_JPRB, 0.88263875E-10_JPRB, 0.88264111E-10_JPRB, 0.88264125E-10_JPRB, &
  & 0.88266762E-10_JPRB, 0.88268295E-10_JPRB, 0.88272466E-10_JPRB, 0.88277538E-10_JPRB, 0.88280550E-10_JPRB, 0.88285185E-10_JPRB, &
  & 0.88287926E-10_JPRB, 0.88290562E-10_JPRB, 0.88292276E-10_JPRB, 0.88293602E-10_JPRB, 0.88294670E-10_JPRB, 0.88294386E-10_JPRB, &
  & 0.88294753E-10_JPRB, 0.88293740E-10_JPRB, 0.88293643E-10_JPRB, 0.88292040E-10_JPRB, 0.88292540E-10_JPRB, 0.88291277E-10_JPRB, &
  & 0.88288800E-10_JPRB, 0.88287141E-10_JPRB, 0.88286933E-10_JPRB, 0.88285705E-10_JPRB, 0.88285441E-10_JPRB, 0.88285053E-10_JPRB, &
  & 0.88284415E-10_JPRB, 0.88284838E-10_JPRB, 0.88284005E-10_JPRB, 0.88284158E-10_JPRB, 0.88283450E-10_JPRB, 0.88284303E-10_JPRB, &
  & 0.88283374E-10_JPRB, 0.88283166E-10_JPRB, 0.88281375E-10_JPRB, 0.88280432E-10_JPRB, 0.88280515E-10_JPRB, 0.88279037E-10_JPRB, &
  & 0.88277503E-10_JPRB, 0.88276435E-10_JPRB, 0.88273819E-10_JPRB, 0.88276511E-10_JPRB /)

RGHG9(:,90, 8) = (/ &
  & 0.88251011E-10_JPRB, 0.88253321E-10_JPRB, 0.88256291E-10_JPRB, 0.88258734E-10_JPRB, 0.88262536E-10_JPRB, 0.88264805E-10_JPRB, &
  & 0.88267560E-10_JPRB, 0.88268962E-10_JPRB, 0.88270863E-10_JPRB, 0.88271460E-10_JPRB, 0.88272348E-10_JPRB, 0.88273694E-10_JPRB, &
  & 0.88274596E-10_JPRB, 0.88275443E-10_JPRB, 0.88276289E-10_JPRB, 0.88275887E-10_JPRB, 0.88275096E-10_JPRB, 0.88274027E-10_JPRB, &
  & 0.88272084E-10_JPRB, 0.88269135E-10_JPRB, 0.88267192E-10_JPRB, 0.88263799E-10_JPRB, 0.88264125E-10_JPRB, 0.88264070E-10_JPRB, &
  & 0.88266824E-10_JPRB, 0.88268233E-10_JPRB, 0.88272431E-10_JPRB, 0.88277607E-10_JPRB, 0.88280466E-10_JPRB, 0.88285282E-10_JPRB, &
  & 0.88287939E-10_JPRB, 0.88290604E-10_JPRB, 0.88292304E-10_JPRB, 0.88293636E-10_JPRB, 0.88294774E-10_JPRB, 0.88294386E-10_JPRB, &
  & 0.88294788E-10_JPRB, 0.88293733E-10_JPRB, 0.88293720E-10_JPRB, 0.88291971E-10_JPRB, 0.88292637E-10_JPRB, 0.88291374E-10_JPRB, &
  & 0.88288793E-10_JPRB, 0.88287058E-10_JPRB, 0.88286989E-10_JPRB, 0.88285670E-10_JPRB, 0.88285462E-10_JPRB, 0.88285074E-10_JPRB, &
  & 0.88284401E-10_JPRB, 0.88284872E-10_JPRB, 0.88283991E-10_JPRB, 0.88284192E-10_JPRB, 0.88283429E-10_JPRB, 0.88284366E-10_JPRB, &
  & 0.88283388E-10_JPRB, 0.88283221E-10_JPRB, 0.88281361E-10_JPRB, 0.88280425E-10_JPRB, 0.88280584E-10_JPRB, 0.88279065E-10_JPRB, &
  & 0.88277489E-10_JPRB, 0.88276449E-10_JPRB, 0.88273756E-10_JPRB, 0.88276539E-10_JPRB /)

RGHG9(:,91, 8) = (/ &
  & 0.88250914E-10_JPRB, 0.88253502E-10_JPRB, 0.88255660E-10_JPRB, 0.88258630E-10_JPRB, 0.88262425E-10_JPRB, 0.88264639E-10_JPRB, &
  & 0.88266901E-10_JPRB, 0.88268497E-10_JPRB, 0.88271300E-10_JPRB, 0.88271029E-10_JPRB, 0.88271453E-10_JPRB, 0.88274298E-10_JPRB, &
  & 0.88274679E-10_JPRB, 0.88275651E-10_JPRB, 0.88277434E-10_JPRB, 0.88276032E-10_JPRB, 0.88275082E-10_JPRB, 0.88274096E-10_JPRB, &
  & 0.88272091E-10_JPRB, 0.88268941E-10_JPRB, 0.88267275E-10_JPRB, 0.88263515E-10_JPRB, 0.88264139E-10_JPRB, 0.88263889E-10_JPRB, &
  & 0.88266901E-10_JPRB, 0.88268039E-10_JPRB, 0.88272369E-10_JPRB, 0.88277753E-10_JPRB, 0.88280286E-10_JPRB, 0.88285393E-10_JPRB, &
  & 0.88287995E-10_JPRB, 0.88290680E-10_JPRB, 0.88292360E-10_JPRB, 0.88293692E-10_JPRB, 0.88294913E-10_JPRB, 0.88294344E-10_JPRB, &
  & 0.88294906E-10_JPRB, 0.88293657E-10_JPRB, 0.88293851E-10_JPRB, 0.88291804E-10_JPRB, 0.88292811E-10_JPRB, 0.88291506E-10_JPRB, &
  & 0.88288717E-10_JPRB, 0.88286892E-10_JPRB, 0.88287100E-10_JPRB, 0.88285594E-10_JPRB, 0.88285497E-10_JPRB, 0.88285101E-10_JPRB, &
  & 0.88284283E-10_JPRB, 0.88284997E-10_JPRB, 0.88283915E-10_JPRB, 0.88284290E-10_JPRB, 0.88283277E-10_JPRB, 0.88284519E-10_JPRB, &
  & 0.88283353E-10_JPRB, 0.88283332E-10_JPRB, 0.88281285E-10_JPRB, 0.88280355E-10_JPRB, 0.88280695E-10_JPRB, 0.88279065E-10_JPRB, &
  & 0.88277441E-10_JPRB, 0.88276490E-10_JPRB, 0.88273562E-10_JPRB, 0.88276608E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART16',1,ZHOOK_HANDLE)
END SUBROUTINE PART16






SUBROUTINE PART17
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART17',0,ZHOOK_HANDLE)



!-- Month=  9 ------------

RGHG9(:, 1, 9) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.42038954E-44_JPRB, &
  & 0.56051939E-44_JPRB, 0.70064923E-44_JPRB, 0.98090893E-44_JPRB, 0.12611686E-43_JPRB, 0.15414283E-43_JPRB, 0.19618179E-43_JPRB, &
  & 0.21019477E-43_JPRB, 0.22420775E-43_JPRB, 0.21019477E-43_JPRB, 0.19618179E-43_JPRB, 0.18216880E-43_JPRB, 0.16815582E-43_JPRB, &
  & 0.11210388E-43_JPRB, 0.70064923E-44_JPRB, 0.56051939E-44_JPRB, 0.42038954E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 2, 9) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, &
  & 0.56051939E-44_JPRB, 0.11210388E-43_JPRB, 0.21019477E-43_JPRB, 0.40637655E-43_JPRB, 0.68663625E-43_JPRB, 0.11350518E-42_JPRB, &
  & 0.18076750E-42_JPRB, 0.27605580E-42_JPRB, 0.39096227E-42_JPRB, 0.51707913E-42_JPRB, 0.64459729E-42_JPRB, 0.74128689E-42_JPRB, &
  & 0.81695700E-42_JPRB, 0.84638427E-42_JPRB, 0.88421933E-42_JPRB, 0.79874012E-42_JPRB, 0.73428040E-42_JPRB, 0.63478820E-42_JPRB, &
  & 0.44701421E-42_JPRB, 0.31389086E-42_JPRB, 0.24522723E-42_JPRB, 0.16114932E-42_JPRB, 0.89683102E-43_JPRB, 0.49045446E-43_JPRB, &
  & 0.28025969E-43_JPRB, 0.14012985E-43_JPRB, 0.70064923E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 3, 9) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.14012985E-44_JPRB, 0.56051939E-44_JPRB, 0.14012985E-43_JPRB, 0.29427268E-43_JPRB, 0.61657132E-43_JPRB, 0.12751816E-42_JPRB, &
  & 0.26204281E-42_JPRB, 0.52688822E-42_JPRB, 0.10257505E-41_JPRB, 0.18791412E-41_JPRB, 0.32243878E-41_JPRB, 0.53473549E-41_JPRB, &
  & 0.86039726E-41_JPRB, 0.13131568E-40_JPRB, 0.18614849E-40_JPRB, 0.24566163E-40_JPRB, 0.30524484E-40_JPRB, 0.35115138E-40_JPRB, &
  & 0.38794948E-40_JPRB, 0.40336376E-40_JPRB, 0.42010928E-40_JPRB, 0.38108312E-40_JPRB, 0.34963798E-40_JPRB, 0.30064859E-40_JPRB, &
  & 0.21411841E-40_JPRB, 0.15103195E-40_JPRB, 0.11765302E-40_JPRB, 0.78318571E-41_JPRB, 0.43916694E-41_JPRB, 0.23976217E-41_JPRB, &
  & 0.12962011E-41_JPRB, 0.65580768E-42_JPRB, 0.30828566E-42_JPRB, 0.14012985E-42_JPRB, 0.61657132E-43_JPRB, 0.26624671E-43_JPRB, &
  & 0.11210388E-43_JPRB, 0.42038954E-44_JPRB, 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 4, 9) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, &
  & 0.28025969E-44_JPRB, 0.42038954E-44_JPRB, 0.98090893E-44_JPRB, 0.21019477E-43_JPRB, 0.46242849E-43_JPRB, 0.10930128E-42_JPRB, &
  & 0.25503632E-42_JPRB, 0.58013756E-42_JPRB, 0.12877933E-41_JPRB, 0.27717684E-41_JPRB, 0.57929679E-41_JPRB, 0.11850781E-40_JPRB, &
  & 0.23878126E-40_JPRB, 0.47440960E-40_JPRB, 0.91804668E-40_JPRB, 0.16755606E-39_JPRB, 0.28636795E-39_JPRB, 0.47534146E-39_JPRB, &
  & 0.76391506E-39_JPRB, 0.11665011E-38_JPRB, 0.16493283E-38_JPRB, 0.21670913E-38_JPRB, 0.26870655E-38_JPRB, 0.30897006E-38_JPRB, &
  & 0.34171658E-38_JPRB, 0.35606896E-38_JPRB, 0.37153635E-38_JPRB, 0.33787968E-38_JPRB, 0.31071860E-38_JPRB, 0.26792813E-38_JPRB, &
  & 0.19025121E-38_JPRB, 0.13416424E-38_JPRB, 0.10500112E-38_JPRB, 0.70427299E-39_JPRB, 0.39366818E-39_JPRB, 0.21447574E-39_JPRB, &
  & 0.11418340E-39_JPRB, 0.56648892E-40_JPRB, 0.26036125E-40_JPRB, 0.11634981E-40_JPRB, 0.51147394E-41_JPRB, 0.22182555E-41_JPRB, &
  & 0.96689594E-42_JPRB, 0.43159993E-42_JPRB, 0.20038568E-42_JPRB, 0.99492191E-43_JPRB, 0.53249342E-43_JPRB, 0.30828566E-43_JPRB, &
  & 0.21019477E-43_JPRB, 0.14012985E-43_JPRB, 0.11210388E-43_JPRB, 0.84077908E-44_JPRB, 0.70064923E-44_JPRB, 0.70064923E-44_JPRB, &
  & 0.70064923E-44_JPRB, 0.56051939E-44_JPRB, 0.42038954E-44_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 5, 9) = (/ &
  & 0.21019477E-43_JPRB, 0.54650640E-43_JPRB, 0.86880505E-43_JPRB, 0.11770907E-42_JPRB, 0.16255062E-42_JPRB, 0.24943113E-42_JPRB, &
  & 0.43440252E-42_JPRB, 0.85899596E-42_JPRB, 0.18567205E-41_JPRB, 0.42389279E-41_JPRB, 0.99772451E-41_JPRB, 0.23614682E-40_JPRB, &
  & 0.55237784E-40_JPRB, 0.12577775E-39_JPRB, 0.27676485E-39_JPRB, 0.58709221E-39_JPRB, 0.12033020E-38_JPRB, 0.24073425E-38_JPRB, &
  & 0.47379849E-38_JPRB, 0.91946941E-38_JPRB, 0.17392116E-37_JPRB, 0.31113705E-37_JPRB, 0.52299732E-37_JPRB, 0.85376250E-37_JPRB, &
  & 0.13563522E-36_JPRB, 0.20447673E-36_JPRB, 0.28600674E-36_JPRB, 0.37248168E-36_JPRB, 0.45863898E-36_JPRB, 0.52539208E-36_JPRB, &
  & 0.58036505E-36_JPRB, 0.60507301E-36_JPRB, 0.63332691E-36_JPRB, 0.57801584E-36_JPRB, 0.53567147E-36_JPRB, 0.46664311E-36_JPRB, &
  & 0.33133249E-36_JPRB, 0.23449093E-36_JPRB, 0.18715940E-36_JPRB, 0.12663939E-36_JPRB, 0.71498799E-37_JPRB, 0.39388025E-37_JPRB, &
  & 0.21262042E-37_JPRB, 0.10623632E-37_JPRB, 0.49204339E-38_JPRB, 0.22344741E-38_JPRB, 0.10056474E-38_JPRB, 0.44833844E-39_JPRB, &
  & 0.20109053E-39_JPRB, 0.92007856E-40_JPRB, 0.43615415E-40_JPRB, 0.21849046E-40_JPRB, 0.11772308E-40_JPRB, 0.68859807E-41_JPRB, &
  & 0.44084850E-41_JPRB, 0.30884618E-41_JPRB, 0.23822074E-41_JPRB, 0.20038568E-41_JPRB, 0.17670374E-41_JPRB, 0.16815582E-41_JPRB, &
  & 0.16269075E-41_JPRB, 0.16255062E-41_JPRB, 0.13662660E-41_JPRB, 0.84638427E-42_JPRB /)

RGHG9(:, 6, 9) = (/ &
  & 0.16716089E-40_JPRB, 0.35305715E-40_JPRB, 0.49621380E-40_JPRB, 0.65258469E-40_JPRB, 0.88828310E-40_JPRB, 0.13283048E-39_JPRB, &
  & 0.22441515E-39_JPRB, 0.42597652E-39_JPRB, 0.88563604E-39_JPRB, 0.19568769E-38_JPRB, 0.44760948E-38_JPRB, 0.10330148E-37_JPRB, &
  & 0.23558504E-37_JPRB, 0.52154440E-37_JPRB, 0.11112121E-36_JPRB, 0.22730613E-36_JPRB, 0.44781616E-36_JPRB, 0.85961988E-36_JPRB, &
  & 0.16215359E-35_JPRB, 0.30157762E-35_JPRB, 0.54730752E-35_JPRB, 0.94186958E-35_JPRB, 0.15271927E-34_JPRB, 0.24134285E-34_JPRB, &
  & 0.37175161E-34_JPRB, 0.54598808E-34_JPRB, 0.74648919E-34_JPRB, 0.95399069E-34_JPRB, 0.11580875E-33_JPRB, 0.13143100E-33_JPRB, &
  & 0.14441837E-33_JPRB, 0.15048598E-33_JPRB, 0.15799647E-33_JPRB, 0.14520999E-33_JPRB, 0.13619583E-33_JPRB, 0.12068911E-33_JPRB, &
  & 0.86758021E-34_JPRB, 0.62485480E-34_JPRB, 0.51496020E-34_JPRB, 0.35745004E-34_JPRB, 0.20716016E-34_JPRB, 0.11826407E-34_JPRB, &
  & 0.66389911E-35_JPRB, 0.34426398E-35_JPRB, 0.16586095E-35_JPRB, 0.78651659E-36_JPRB, 0.37077853E-36_JPRB, 0.17331037E-36_JPRB, &
  & 0.81492210E-37_JPRB, 0.39008797E-37_JPRB, 0.19291380E-37_JPRB, 0.10042483E-37_JPRB, 0.55999152E-38_JPRB, 0.33773395E-38_JPRB, &
  & 0.22179752E-38_JPRB, 0.15879136E-38_JPRB, 0.12457880E-38_JPRB, 0.10621394E-38_JPRB, 0.94581621E-39_JPRB, 0.90671017E-39_JPRB, &
  & 0.88396009E-39_JPRB, 0.90833147E-39_JPRB, 0.86575582E-39_JPRB, 0.76220967E-39_JPRB /)

RGHG9(:, 7, 9) = (/ &
  & 0.16190995E-37_JPRB, 0.30445193E-37_JPRB, 0.41394738E-37_JPRB, 0.53352987E-37_JPRB, 0.71186730E-37_JPRB, 0.10242644E-36_JPRB, &
  & 0.16354290E-36_JPRB, 0.28985184E-36_JPRB, 0.56150940E-36_JPRB, 0.11593959E-35_JPRB, 0.24960927E-35_JPRB, 0.54545514E-35_JPRB, &
  & 0.11830922E-34_JPRB, 0.24951394E-34_JPRB, 0.50623072E-34_JPRB, 0.98466157E-34_JPRB, 0.18421039E-33_JPRB, 0.33551768E-33_JPRB, &
  & 0.60078120E-33_JPRB, 0.10614345E-32_JPRB, 0.18339416E-32_JPRB, 0.30118186E-32_JPRB, 0.46737791E-32_JPRB, 0.70904100E-32_JPRB, &
  & 0.10525197E-31_JPRB, 0.14961954E-31_JPRB, 0.19882605E-31_JPRB, 0.24829465E-31_JPRB, 0.29602601E-31_JPRB, 0.33175483E-31_JPRB, &
  & 0.36205361E-31_JPRB, 0.37666980E-31_JPRB, 0.39680187E-31_JPRB, 0.36766216E-31_JPRB, 0.34952014E-31_JPRB, 0.31561759E-31_JPRB, &
  & 0.23149858E-31_JPRB, 0.17112534E-31_JPRB, 0.14623449E-31_JPRB, 0.10507221E-31_JPRB, 0.63137807E-32_JPRB, 0.37772931E-32_JPRB, &
  & 0.22256217E-32_JPRB, 0.12148003E-32_JPRB, 0.61590293E-33_JPRB, 0.30881506E-33_JPRB, 0.15430561E-33_JPRB, 0.76572953E-34_JPRB, &
  & 0.38282393E-34_JPRB, 0.19514968E-34_JPRB, 0.10279672E-34_JPRB, 0.56940763E-35_JPRB, 0.33680744E-35_JPRB, 0.21419003E-35_JPRB, &
  & 0.14738467E-35_JPRB, 0.10961867E-35_JPRB, 0.88777365E-36_JPRB, 0.77580457E-36_JPRB, 0.70431117E-36_JPRB, 0.68516903E-36_JPRB, &
  & 0.67537752E-36_JPRB, 0.70059470E-36_JPRB, 0.68256629E-36_JPRB, 0.64399691E-36_JPRB /)

RGHG9(:, 8, 9) = (/ &
  & 0.13766155E-34_JPRB, 0.24989124E-34_JPRB, 0.33072752E-34_JPRB, 0.41875586E-34_JPRB, 0.54190709E-34_JPRB, 0.74762072E-34_JPRB, &
  & 0.11263549E-33_JPRB, 0.18647868E-33_JPRB, 0.33533534E-33_JPRB, 0.64362347E-33_JPRB, 0.12915549E-32_JPRB, 0.26442701E-32_JPRB, &
  & 0.53995988E-32_JPRB, 0.10758037E-31_JPRB, 0.20660788E-31_JPRB, 0.38064135E-31_JPRB, 0.67438340E-31_JPRB, 0.11640385E-30_JPRB, &
  & 0.19772509E-30_JPRB, 0.33212744E-30_JPRB, 0.54662199E-30_JPRB, 0.85693689E-30_JPRB, 0.12714090E-29_JPRB, 0.18490165E-29_JPRB, &
  & 0.26426326E-29_JPRB, 0.36293619E-29_JPRB, 0.46846948E-29_JPRB, 0.57089202E-29_JPRB, 0.66806590E-29_JPRB, 0.73907577E-29_JPRB, &
  & 0.80075713E-29_JPRB, 0.83198737E-29_JPRB, 0.87965142E-29_JPRB, 0.82208139E-29_JPRB, 0.79232916E-29_JPRB, 0.72895094E-29_JPRB, &
  & 0.54692664E-29_JPRB, 0.41602073E-29_JPRB, 0.36847234E-29_JPRB, 0.27470912E-29_JPRB, 0.17201680E-29_JPRB, 0.10780320E-29_JPRB, &
  & 0.66963503E-30_JPRB, 0.38453817E-30_JPRB, 0.20542055E-30_JPRB, 0.10889903E-30_JPRB, 0.57655118E-31_JPRB, 0.30373399E-31_JPRB, &
  & 0.16170510E-31_JPRB, 0.88002525E-32_JPRB, 0.49586543E-32_JPRB, 0.29370937E-32_JPRB, 0.18511676E-32_JPRB, 0.12470595E-32_JPRB, &
  & 0.90123811E-33_JPRB, 0.69878566E-33_JPRB, 0.58500152E-33_JPRB, 0.52500659E-33_JPRB, 0.48634458E-33_JPRB, 0.48055711E-33_JPRB, &
  & 0.47896449E-33_JPRB, 0.50086841E-33_JPRB, 0.49087423E-33_JPRB, 0.46788679E-33_JPRB /)

RGHG9(:, 9, 9) = (/ &
  & 0.98453742E-32_JPRB, 0.17215795E-31_JPRB, 0.22391663E-31_JPRB, 0.27813096E-31_JPRB, 0.35077930E-31_JPRB, 0.46684738E-31_JPRB, &
  & 0.67103236E-31_JPRB, 0.10483308E-30_JPRB, 0.17687421E-30_JPRB, 0.31701696E-30_JPRB, 0.59391241E-30_JPRB, 0.11364054E-29_JPRB, &
  & 0.21749820E-29_JPRB, 0.40750744E-29_JPRB, 0.73814034E-29_JPRB, 0.12851142E-28_JPRB, 0.21537535E-28_JPRB, 0.35213998E-28_JPRB, &
  & 0.56785713E-28_JPRB, 0.90779454E-28_JPRB, 0.14258787E-27_JPRB, 0.21343839E-27_JPRB, 0.30245808E-27_JPRB, 0.42128114E-27_JPRB, &
  & 0.57848551E-27_JPRB, 0.76716713E-27_JPRB, 0.96036054E-27_JPRB, 0.11417739E-26_JPRB, 0.13110859E-26_JPRB, 0.14314128E-26_JPRB, &
  & 0.15400076E-26_JPRB, 0.15979066E-26_JPRB, 0.16963772E-26_JPRB, 0.15997122E-26_JPRB, 0.15637724E-26_JPRB, 0.14659886E-26_JPRB, &
  & 0.11260582E-26_JPRB, 0.88241401E-27_JPRB, 0.80963177E-27_JPRB, 0.62736205E-27_JPRB, 0.40993265E-27_JPRB, 0.27009427E-27_JPRB, &
  & 0.17674985E-27_JPRB, 0.10706642E-27_JPRB, 0.60313951E-28_JPRB, 0.33779854E-28_JPRB, 0.18950657E-28_JPRB, 0.10589045E-28_JPRB, &
  & 0.59963423E-29_JPRB, 0.34817676E-29_JPRB, 0.20954503E-29_JPRB, 0.13242566E-29_JPRB, 0.88704318E-30_JPRB, 0.63053216E-30_JPRB, &
  & 0.47734484E-30_JPRB, 0.38429158E-30_JPRB, 0.33170154E-30_JPRB, 0.30470631E-30_JPRB, 0.28711795E-30_JPRB, 0.28723599E-30_JPRB, &
  & 0.28859259E-30_JPRB, 0.30342156E-30_JPRB, 0.29845228E-30_JPRB, 0.28593463E-30_JPRB /)

RGHG9(:,10, 9) = (/ &
  & 0.57426322E-29_JPRB, 0.96962892E-29_JPRB, 0.12502644E-28_JPRB, 0.15242047E-28_JPRB, 0.18906942E-28_JPRB, 0.24445362E-28_JPRB, &
  & 0.33867635E-28_JPRB, 0.50523901E-28_JPRB, 0.80710295E-28_JPRB, 0.13623236E-27_JPRB, 0.23935217E-27_JPRB, 0.42861330E-27_JPRB, &
  & 0.76812625E-27_JPRB, 0.13501205E-26_JPRB, 0.23008864E-26_JPRB, 0.37778895E-26_JPRB, 0.59792783E-26_JPRB, 0.92504511E-26_JPRB, &
  & 0.14151775E-25_JPRB, 0.21533370E-25_JPRB, 0.32275221E-25_JPRB, 0.46104871E-25_JPRB, 0.62308474E-25_JPRB, 0.82940638E-25_JPRB, &
  & 0.10929432E-24_JPRB, 0.13970676E-24_JPRB, 0.16952074E-24_JPRB, 0.19648053E-24_JPRB, 0.22129866E-24_JPRB, 0.23839140E-24_JPRB, &
  & 0.25461765E-24_JPRB, 0.26384456E-24_JPRB, 0.28129809E-24_JPRB, 0.26775228E-24_JPRB, 0.26558629E-24_JPRB, 0.25376723E-24_JPRB, &
  & 0.19969155E-24_JPRB, 0.16131622E-24_JPRB, 0.15332537E-24_JPRB, 0.12354501E-24_JPRB, 0.84435320E-25_JPRB, 0.58487325E-25_JPRB, &
  & 0.40410546E-25_JPRB, 0.25874705E-25_JPRB, 0.15393520E-25_JPRB, 0.91386408E-26_JPRB, 0.54342471E-26_JPRB, 0.32226503E-26_JPRB, &
  & 0.19410679E-26_JPRB, 0.12005340E-26_JPRB, 0.76985857E-27_JPRB, 0.51724859E-27_JPRB, 0.36651458E-27_JPRB, 0.27381726E-27_JPRB, &
  & 0.21613804E-27_JPRB, 0.18008484E-27_JPRB, 0.15964500E-27_JPRB, 0.14959979E-27_JPRB, 0.14289469E-27_JPRB, 0.14421697E-27_JPRB, &
  & 0.14556648E-27_JPRB, 0.15351672E-27_JPRB, 0.15130830E-27_JPRB, 0.14535026E-27_JPRB /)

RGHG9(:,11, 9) = (/ &
  & 0.26568612E-26_JPRB, 0.44914759E-26_JPRB, 0.56729811E-26_JPRB, 0.69067299E-26_JPRB, 0.84024425E-26_JPRB, 0.10672878E-25_JPRB, &
  & 0.14346603E-25_JPRB, 0.20602215E-25_JPRB, 0.31421005E-25_JPRB, 0.50263536E-25_JPRB, 0.83216962E-25_JPRB, 0.13991544E-24_JPRB, &
  & 0.23502363E-24_JPRB, 0.38747440E-24_JPRB, 0.62063188E-24_JPRB, 0.95978064E-24_JPRB, 0.14325150E-23_JPRB, 0.20937921E-23_JPRB, &
  & 0.30343817E-23_JPRB, 0.43885160E-23_JPRB, 0.62694113E-23_JPRB, 0.85359010E-23_JPRB, 0.10989575E-22_JPRB, 0.13972298E-22_JPRB, &
  & 0.17657539E-22_JPRB, 0.21760136E-22_JPRB, 0.25597665E-22_JPRB, 0.28931638E-22_JPRB, 0.31973927E-22_JPRB, 0.33991442E-22_JPRB, &
  & 0.36052698E-22_JPRB, 0.37313004E-22_JPRB, 0.39953621E-22_JPRB, 0.38389316E-22_JPRB, 0.38642449E-22_JPRB, 0.37644550E-22_JPRB, &
  & 0.30347081E-22_JPRB, 0.25283068E-22_JPRB, 0.24894988E-22_JPRB, 0.20858380E-22_JPRB, 0.14904058E-22_JPRB, 0.10858065E-22_JPRB, &
  & 0.79179681E-23_JPRB, 0.53615172E-23_JPRB, 0.33811529E-23_JPRB, 0.21288546E-23_JPRB, 0.13450884E-23_JPRB, 0.84724647E-24_JPRB, &
  & 0.54249895E-24_JPRB, 0.35687311E-24_JPRB, 0.24305921E-24_JPRB, 0.17290584E-24_JPRB, 0.12908819E-24_JPRB, 0.10092768E-24_JPRB, &
  & 0.82807937E-25_JPRB, 0.71182925E-25_JPRB, 0.64649234E-25_JPRB, 0.61642343E-25_JPRB, 0.59558228E-25_JPRB, 0.60505601E-25_JPRB, &
  & 0.61285433E-25_JPRB, 0.64650190E-25_JPRB, 0.63783724E-25_JPRB, 0.61587462E-25_JPRB /)

RGHG9(:,12, 9) = (/ &
  & 0.10061730E-23_JPRB, 0.16591210E-23_JPRB, 0.21198138E-23_JPRB, 0.25415310E-23_JPRB, 0.30839638E-23_JPRB, 0.38444111E-23_JPRB, &
  & 0.50574543E-23_JPRB, 0.70361320E-23_JPRB, 0.10310830E-22_JPRB, 0.15725060E-22_JPRB, 0.24664990E-22_JPRB, 0.39084082E-22_JPRB, &
  & 0.61725778E-22_JPRB, 0.95596323E-22_JPRB, 0.14398309E-21_JPRB, 0.20965159E-21_JPRB, 0.29481643E-21_JPRB, 0.40654468E-21_JPRB, &
  & 0.55706858E-21_JPRB, 0.76403504E-21_JPRB, 0.10378493E-20_JPRB, 0.13443915E-20_JPRB, 0.16479944E-20_JPRB, 0.20006761E-20_JPRB, &
  & 0.24247901E-20_JPRB, 0.28812211E-20_JPRB, 0.32867662E-20_JPRB, 0.36234974E-20_JPRB, 0.39295587E-20_JPRB, 0.41238084E-20_JPRB, &
  & 0.43436021E-20_JPRB, 0.44898790E-20_JPRB, 0.48274842E-20_JPRB, 0.46824009E-20_JPRB, 0.47835629E-20_JPRB, 0.47523744E-20_JPRB, &
  & 0.39274491E-20_JPRB, 0.33750629E-20_JPRB, 0.34447832E-20_JPRB, 0.30003683E-20_JPRB, 0.22405088E-20_JPRB, 0.17152628E-20_JPRB, &
  & 0.13193429E-20_JPRB, 0.94527064E-21_JPRB, 0.63213699E-21_JPRB, 0.42327345E-21_JPRB, 0.28446963E-21_JPRB, 0.19060177E-21_JPRB, &
  & 0.12980912E-21_JPRB, 0.90711097E-22_JPRB, 0.65480535E-22_JPRB, 0.49178441E-22_JPRB, 0.38556719E-22_JPRB, 0.31462537E-22_JPRB, &
  & 0.26761172E-22_JPRB, 0.23683507E-22_JPRB, 0.21992410E-22_JPRB, 0.21298315E-22_JPRB, 0.20781600E-22_JPRB, 0.21220333E-22_JPRB, &
  & 0.21522606E-22_JPRB, 0.22734323E-22_JPRB, 0.22442419E-22_JPRB, 0.21717208E-22_JPRB /)

RGHG9(:,13, 9) = (/ &
  & 0.29967495E-21_JPRB, 0.50855240E-21_JPRB, 0.64241449E-21_JPRB, 0.77542013E-21_JPRB, 0.93049125E-21_JPRB, 0.11507278E-20_JPRB, &
  & 0.14856251E-20_JPRB, 0.20148696E-20_JPRB, 0.28540211E-20_JPRB, 0.41741359E-20_JPRB, 0.62341162E-20_JPRB, 0.93552916E-20_JPRB, &
  & 0.13938496E-19_JPRB, 0.20326994E-19_JPRB, 0.28818507E-19_JPRB, 0.39510330E-19_JPRB, 0.52310188E-19_JPRB, 0.67960681E-19_JPRB, &
  & 0.87871099E-19_JPRB, 0.11397432E-18_JPRB, 0.14675647E-18_JPRB, 0.18048844E-18_JPRB, 0.21049075E-18_JPRB, 0.24384716E-18_JPRB, &
  & 0.28323825E-18_JPRB, 0.32432529E-18_JPRB, 0.35857059E-18_JPRB, 0.38526681E-18_JPRB, 0.40962235E-18_JPRB, 0.42395170E-18_JPRB, &
  & 0.44311461E-18_JPRB, 0.45721188E-18_JPRB, 0.49346897E-18_JPRB, 0.48323809E-18_JPRB, 0.50119819E-18_JPRB, 0.50811348E-18_JPRB, &
  & 0.43076746E-18_JPRB, 0.38223654E-18_JPRB, 0.40473363E-18_JPRB, 0.36668449E-18_JPRB, 0.28604981E-18_JPRB, 0.23012511E-18_JPRB, &
  & 0.18663732E-18_JPRB, 0.14143459E-18_JPRB, 0.10040140E-18_JPRB, 0.71544079E-19_JPRB, 0.51233826E-19_JPRB, 0.36575704E-19_JPRB, &
  & 0.26518984E-19_JPRB, 0.19693768E-19_JPRB, 0.15058503E-19_JPRB, 0.11928258E-19_JPRB, 0.98095615E-20_JPRB, 0.83446966E-20_JPRB, &
  & 0.73503197E-20_JPRB, 0.66910208E-20_JPRB, 0.63473022E-20_JPRB, 0.62390558E-20_JPRB, 0.61448707E-20_JPRB, 0.63045929E-20_JPRB, &
  & 0.64062186E-20_JPRB, 0.67639976E-20_JPRB, 0.66737764E-20_JPRB, 0.64781191E-20_JPRB /)

RGHG9(:,14, 9) = (/ &
  & 0.74695340E-19_JPRB, 0.12774816E-18_JPRB, 0.16328775E-18_JPRB, 0.19622554E-18_JPRB, 0.23536277E-18_JPRB, 0.28827617E-18_JPRB, &
  & 0.36702593E-18_JPRB, 0.48701841E-18_JPRB, 0.66957086E-18_JPRB, 0.94285107E-18_JPRB, 0.13460404E-17_JPRB, 0.19187583E-17_JPRB, &
  & 0.27036692E-17_JPRB, 0.37175308E-17_JPRB, 0.49625464E-17_JPRB, 0.64026182E-17_JPRB, 0.79724255E-17_JPRB, 0.97444258E-17_JPRB, &
  & 0.11866540E-16_JPRB, 0.14524216E-16_JPRB, 0.17687223E-16_JPRB, 0.20627380E-16_JPRB, 0.22883801E-16_JPRB, 0.25295345E-16_JPRB, &
  & 0.28158879E-16_JPRB, 0.31071389E-16_JPRB, 0.33289447E-16_JPRB, 0.34842532E-16_JPRB, 0.36289462E-16_JPRB, 0.37008438E-16_JPRB, &
  & 0.38348735E-16_JPRB, 0.39475428E-16_JPRB, 0.42756546E-16_JPRB, 0.42278908E-16_JPRB, 0.44529085E-16_JPRB, 0.46082053E-16_JPRB, &
  & 0.40108883E-16_JPRB, 0.36773320E-16_JPRB, 0.40411482E-16_JPRB, 0.38092511E-16_JPRB, 0.31049872E-16_JPRB, 0.26237765E-16_JPRB, &
  & 0.22432389E-16_JPRB, 0.17972467E-16_JPRB, 0.13539057E-16_JPRB, 0.10271214E-16_JPRB, 0.78420097E-17_JPRB, 0.59688882E-17_JPRB, &
  & 0.46097708E-17_JPRB, 0.36379788E-17_JPRB, 0.29462062E-17_JPRB, 0.24605571E-17_JPRB, 0.21220777E-17_JPRB, 0.18815141E-17_JPRB, &
  & 0.17163077E-17_JPRB, 0.16071969E-17_JPRB, 0.15580044E-17_JPRB, 0.15552447E-17_JPRB, 0.15476140E-17_JPRB, 0.15972040E-17_JPRB, &
  & 0.16273726E-17_JPRB, 0.17210741E-17_JPRB, 0.16993236E-17_JPRB, 0.16532575E-17_JPRB /)

RGHG9(:,15, 9) = (/ &
  & 0.15489440E-16_JPRB, 0.27047734E-16_JPRB, 0.34756154E-16_JPRB, 0.41838924E-16_JPRB, 0.50048477E-16_JPRB, 0.60884768E-16_JPRB, &
  & 0.76553647E-16_JPRB, 0.99605648E-16_JPRB, 0.13324199E-15_JPRB, 0.18110134E-15_JPRB, 0.24772596E-15_JPRB, 0.33612853E-15_JPRB, &
  & 0.44847790E-15_JPRB, 0.58172132E-15_JPRB, 0.73093247E-15_JPRB, 0.88665397E-15_JPRB, 0.10372076E-14_JPRB, 0.11912697E-14_JPRB, &
  & 0.13647022E-14_JPRB, 0.15742071E-14_JPRB, 0.18114098E-14_JPRB, 0.20028274E-14_JPRB, 0.21140947E-14_JPRB, 0.22304817E-14_JPRB, &
  & 0.23803726E-14_JPRB, 0.25318511E-14_JPRB, 0.26286219E-14_JPRB, 0.26797465E-14_JPRB, 0.27331225E-14_JPRB, 0.27450305E-14_JPRB, &
  & 0.28185553E-14_JPRB, 0.28932907E-14_JPRB, 0.31448673E-14_JPRB, 0.31407454E-14_JPRB, 0.33601812E-14_JPRB, 0.35502344E-14_JPRB, &
  & 0.31733081E-14_JPRB, 0.30073699E-14_JPRB, 0.34299723E-14_JPRB, 0.33647632E-14_JPRB, 0.28659023E-14_JPRB, 0.25441439E-14_JPRB, &
  & 0.22930440E-14_JPRB, 0.19425214E-14_JPRB, 0.15526022E-14_JPRB, 0.12543015E-14_JPRB, 0.10212031E-14_JPRB, 0.82884519E-15_JPRB, &
  & 0.68182637E-15_JPRB, 0.57177037E-15_JPRB, 0.49033266E-15_JPRB, 0.43174540E-15_JPRB, 0.39044513E-15_JPRB, 0.36083784E-15_JPRB, &
  & 0.34086821E-15_JPRB, 0.32840531E-15_JPRB, 0.32542103E-15_JPRB, 0.33006028E-15_JPRB, 0.33213411E-15_JPRB, 0.34515375E-15_JPRB, &
  & 0.35308023E-15_JPRB, 0.37432871E-15_JPRB, 0.37027214E-15_JPRB, 0.36152084E-15_JPRB /)

RGHG9(:,16, 9) = (/ &
  & 0.21720699E-15_JPRB, 0.36074614E-15_JPRB, 0.44336627E-15_JPRB, 0.51918122E-15_JPRB, 0.60422820E-15_JPRB, 0.71981220E-15_JPRB, &
  & 0.88796740E-15_JPRB, 0.11374959E-14_JPRB, 0.15017969E-14_JPRB, 0.20187813E-14_JPRB, 0.27319540E-14_JPRB, 0.36720369E-14_JPRB, &
  & 0.48514574E-14_JPRB, 0.62486802E-14_JPRB, 0.78073322E-14_JPRB, 0.94639982E-14_JPRB, 0.11137760E-13_JPRB, 0.12721068E-13_JPRB, &
  & 0.14391618E-13_JPRB, 0.16373970E-13_JPRB, 0.18268351E-13_JPRB, 0.19864293E-13_JPRB, 0.21413435E-13_JPRB, 0.22762135E-13_JPRB, &
  & 0.24112145E-13_JPRB, 0.25372520E-13_JPRB, 0.26277076E-13_JPRB, 0.26513160E-13_JPRB, 0.26302413E-13_JPRB, 0.25810431E-13_JPRB, &
  & 0.25393800E-13_JPRB, 0.25375076E-13_JPRB, 0.25463323E-13_JPRB, 0.24593251E-13_JPRB, 0.25171846E-13_JPRB, 0.25045238E-13_JPRB, &
  & 0.24326315E-13_JPRB, 0.24401888E-13_JPRB, 0.23570674E-13_JPRB, 0.23275852E-13_JPRB, 0.23588218E-13_JPRB, 0.22897388E-13_JPRB, &
  & 0.20688756E-13_JPRB, 0.18107548E-13_JPRB, 0.15728904E-13_JPRB, 0.13562129E-13_JPRB, 0.11542892E-13_JPRB, 0.97921185E-14_JPRB, &
  & 0.83959507E-14_JPRB, 0.72985416E-14_JPRB, 0.64296098E-14_JPRB, 0.57453978E-14_JPRB, 0.51851893E-14_JPRB, 0.47162672E-14_JPRB, &
  & 0.43323694E-14_JPRB, 0.40331016E-14_JPRB, 0.38230802E-14_JPRB, 0.37018643E-14_JPRB, 0.36387536E-14_JPRB, 0.36416318E-14_JPRB, &
  & 0.36203366E-14_JPRB, 0.37049628E-14_JPRB, 0.36149562E-14_JPRB, 0.34793147E-14_JPRB /)

RGHG9(:,17, 9) = (/ &
  & 0.19655840E-14_JPRB, 0.30436560E-14_JPRB, 0.35687641E-14_JPRB, 0.39944685E-14_JPRB, 0.44862477E-14_JPRB, 0.51806026E-14_JPRB, &
  & 0.62497564E-14_JPRB, 0.78847663E-14_JPRB, 0.10316583E-13_JPRB, 0.13801214E-13_JPRB, 0.18623673E-13_JPRB, 0.24979188E-13_JPRB, &
  & 0.32947769E-13_JPRB, 0.42381751E-13_JPRB, 0.53000573E-13_JPRB, 0.64345515E-13_JPRB, 0.76076488E-13_JPRB, 0.87713460E-13_JPRB, &
  & 0.98645864E-13_JPRB, 0.11125551E-12_JPRB, 0.12750033E-12_JPRB, 0.14466388E-12_JPRB, 0.15858946E-12_JPRB, 0.16821170E-12_JPRB, &
  & 0.17479263E-12_JPRB, 0.17976397E-12_JPRB, 0.18438004E-12_JPRB, 0.18503515E-12_JPRB, 0.18089580E-12_JPRB, 0.17477578E-12_JPRB, &
  & 0.16699230E-12_JPRB, 0.15852730E-12_JPRB, 0.14852976E-12_JPRB, 0.13952046E-12_JPRB, 0.13182505E-12_JPRB, 0.12679449E-12_JPRB, &
  & 0.12761156E-12_JPRB, 0.13153724E-12_JPRB, 0.13843064E-12_JPRB, 0.14532050E-12_JPRB, 0.14881171E-12_JPRB, 0.14733902E-12_JPRB, &
  & 0.14168983E-12_JPRB, 0.13208327E-12_JPRB, 0.11895336E-12_JPRB, 0.10455738E-12_JPRB, 0.91072495E-13_JPRB, 0.79605674E-13_JPRB, &
  & 0.70228383E-13_JPRB, 0.62597808E-13_JPRB, 0.56199240E-13_JPRB, 0.50563733E-13_JPRB, 0.45455769E-13_JPRB, 0.40847324E-13_JPRB, &
  & 0.36750947E-13_JPRB, 0.33301046E-13_JPRB, 0.30696379E-13_JPRB, 0.29062924E-13_JPRB, 0.28254234E-13_JPRB, 0.27831712E-13_JPRB, &
  & 0.27294305E-13_JPRB, 0.26612454E-13_JPRB, 0.26048609E-13_JPRB, 0.21934780E-13_JPRB /)

RGHG9(:,18, 9) = (/ &
  & 0.13423112E-13_JPRB, 0.19067181E-13_JPRB, 0.20969446E-13_JPRB, 0.22237129E-13_JPRB, 0.23750446E-13_JPRB, 0.26263757E-13_JPRB, &
  & 0.30579594E-13_JPRB, 0.37598502E-13_JPRB, 0.48354658E-13_JPRB, 0.64011710E-13_JPRB, 0.85797180E-13_JPRB, 0.11459049E-12_JPRB, &
  & 0.15062501E-12_JPRB, 0.19337296E-12_JPRB, 0.24158540E-12_JPRB, 0.29378358E-12_JPRB, 0.34850990E-12_JPRB, 0.40472500E-12_JPRB, &
  & 0.46142062E-12_JPRB, 0.51852262E-12_JPRB, 0.58438194E-12_JPRB, 0.65748839E-12_JPRB, 0.72997619E-12_JPRB, 0.79749949E-12_JPRB, &
  & 0.85271016E-12_JPRB, 0.89093034E-12_JPRB, 0.90591765E-12_JPRB, 0.90211719E-12_JPRB, 0.88049490E-12_JPRB, 0.83874373E-12_JPRB, &
  & 0.78220427E-12_JPRB, 0.71226065E-12_JPRB, 0.64633580E-12_JPRB, 0.59100213E-12_JPRB, 0.54247665E-12_JPRB, 0.51564157E-12_JPRB, &
  & 0.51178197E-12_JPRB, 0.52771508E-12_JPRB, 0.55810527E-12_JPRB, 0.59492071E-12_JPRB, 0.62714997E-12_JPRB, 0.64650802E-12_JPRB, &
  & 0.64515261E-12_JPRB, 0.62030562E-12_JPRB, 0.57833393E-12_JPRB, 0.52845098E-12_JPRB, 0.47828104E-12_JPRB, 0.43215664E-12_JPRB, &
  & 0.39130515E-12_JPRB, 0.35525725E-12_JPRB, 0.32244525E-12_JPRB, 0.29140245E-12_JPRB, 0.26184279E-12_JPRB, 0.23413457E-12_JPRB, &
  & 0.20931136E-12_JPRB, 0.18797740E-12_JPRB, 0.17027067E-12_JPRB, 0.15637926E-12_JPRB, 0.14707609E-12_JPRB, 0.14225554E-12_JPRB, &
  & 0.13949149E-12_JPRB, 0.13378266E-12_JPRB, 0.12407803E-12_JPRB, 0.10454870E-12_JPRB /)

RGHG9(:,19, 9) = (/ &
  & 0.68817842E-13_JPRB, 0.89044996E-13_JPRB, 0.92951532E-13_JPRB, 0.93208861E-13_JPRB, 0.94571059E-13_JPRB, 0.99356470E-13_JPRB, &
  & 0.11051145E-12_JPRB, 0.13085320E-12_JPRB, 0.16351972E-12_JPRB, 0.21200160E-12_JPRB, 0.27978379E-12_JPRB, 0.36913560E-12_JPRB, &
  & 0.48058335E-12_JPRB, 0.61194263E-12_JPRB, 0.75990809E-12_JPRB, 0.92041717E-12_JPRB, 0.10905467E-11_JPRB, 0.12692521E-11_JPRB, &
  & 0.14567700E-11_JPRB, 0.16526702E-11_JPRB, 0.18546139E-11_JPRB, 0.20718455E-11_JPRB, 0.23010565E-11_JPRB, 0.25322394E-11_JPRB, &
  & 0.27440897E-11_JPRB, 0.29105748E-11_JPRB, 0.30017124E-11_JPRB, 0.30071082E-11_JPRB, 0.29245699E-11_JPRB, 0.27730520E-11_JPRB, &
  & 0.25718605E-11_JPRB, 0.23239429E-11_JPRB, 0.20824831E-11_JPRB, 0.18604263E-11_JPRB, 0.16995788E-11_JPRB, 0.16050560E-11_JPRB, &
  & 0.15630663E-11_JPRB, 0.15880155E-11_JPRB, 0.16758138E-11_JPRB, 0.17972340E-11_JPRB, 0.19223225E-11_JPRB, 0.20215390E-11_JPRB, &
  & 0.20657367E-11_JPRB, 0.20485161E-11_JPRB, 0.19776589E-11_JPRB, 0.18689017E-11_JPRB, 0.17409088E-11_JPRB, 0.16096582E-11_JPRB, &
  & 0.14832027E-11_JPRB, 0.13620965E-11_JPRB, 0.12435706E-11_JPRB, 0.11263206E-11_JPRB, 0.10119151E-11_JPRB, 0.90442313E-12_JPRB, &
  & 0.80823076E-12_JPRB, 0.72633035E-12_JPRB, 0.66056161E-12_JPRB, 0.61032830E-12_JPRB, 0.57409112E-12_JPRB, 0.54789821E-12_JPRB, &
  & 0.52376587E-12_JPRB, 0.50163329E-12_JPRB, 0.47075825E-12_JPRB, 0.40644362E-12_JPRB /)

RGHG9(:,20, 9) = (/ &
  & 0.26518512E-12_JPRB, 0.30559230E-12_JPRB, 0.30610155E-12_JPRB, 0.29584982E-12_JPRB, 0.28826475E-12_JPRB, 0.29012461E-12_JPRB, &
  & 0.30891620E-12_JPRB, 0.35109017E-12_JPRB, 0.42351395E-12_JPRB, 0.53312693E-12_JPRB, 0.68689520E-12_JPRB, 0.88843890E-12_JPRB, &
  & 0.11366233E-11_JPRB, 0.14256046E-11_JPRB, 0.17457239E-11_JPRB, 0.20887508E-11_JPRB, 0.24477334E-11_JPRB, 0.28228314E-11_JPRB, &
  & 0.32171470E-11_JPRB, 0.36391762E-11_JPRB, 0.40913219E-11_JPRB, 0.45819433E-11_JPRB, 0.51111242E-11_JPRB, 0.56656147E-11_JPRB, &
  & 0.62009807E-11_JPRB, 0.66529837E-11_JPRB, 0.69501427E-11_JPRB, 0.70484734E-11_JPRB, 0.69336060E-11_JPRB, 0.66350462E-11_JPRB, &
  & 0.61913005E-11_JPRB, 0.56442490E-11_JPRB, 0.50788154E-11_JPRB, 0.45469769E-11_JPRB, 0.41172573E-11_JPRB, 0.38319343E-11_JPRB, &
  & 0.37378204E-11_JPRB, 0.38049854E-11_JPRB, 0.39888639E-11_JPRB, 0.42545824E-11_JPRB, 0.45362290E-11_JPRB, 0.47742201E-11_JPRB, &
  & 0.49168187E-11_JPRB, 0.49540727E-11_JPRB, 0.48796947E-11_JPRB, 0.47104837E-11_JPRB, 0.44781093E-11_JPRB, 0.42116900E-11_JPRB, &
  & 0.39282327E-11_JPRB, 0.36343177E-11_JPRB, 0.33346837E-11_JPRB, 0.30349358E-11_JPRB, 0.27439379E-11_JPRB, 0.24724443E-11_JPRB, &
  & 0.22299367E-11_JPRB, 0.20237566E-11_JPRB, 0.18591845E-11_JPRB, 0.17372803E-11_JPRB, 0.16470192E-11_JPRB, 0.15738523E-11_JPRB, &
  & 0.15031226E-11_JPRB, 0.14282535E-11_JPRB, 0.13472986E-11_JPRB, 0.11902029E-11_JPRB /)

RGHG9(:,21, 9) = (/ &
  & 0.73678569E-12_JPRB, 0.78674036E-12_JPRB, 0.76599653E-12_JPRB, 0.72776458E-12_JPRB, 0.69447893E-12_JPRB, 0.67982458E-12_JPRB, &
  & 0.70002944E-12_JPRB, 0.76673585E-12_JPRB, 0.89154064E-12_JPRB, 0.10863148E-11_JPRB, 0.13603376E-11_JPRB, 0.17178208E-11_JPRB, &
  & 0.21546324E-11_JPRB, 0.26564603E-11_JPRB, 0.32070186E-11_JPRB, 0.37895915E-11_JPRB, 0.43961653E-11_JPRB, 0.50251786E-11_JPRB, &
  & 0.56869093E-11_JPRB, 0.63971840E-11_JPRB, 0.71732295E-11_JPRB, 0.80268344E-11_JPRB, 0.89568986E-11_JPRB, 0.99462574E-11_JPRB, &
  & 0.10916799E-10_JPRB, 0.11766812E-10_JPRB, 0.12381079E-10_JPRB, 0.12691345E-10_JPRB, 0.12668836E-10_JPRB, 0.12324962E-10_JPRB, &
  & 0.11699849E-10_JPRB, 0.10869384E-10_JPRB, 0.99652049E-11_JPRB, 0.90840200E-11_JPRB, 0.83612145E-11_JPRB, 0.78733253E-11_JPRB, &
  & 0.76397283E-11_JPRB, 0.76811682E-11_JPRB, 0.79481473E-11_JPRB, 0.83417908E-11_JPRB, 0.87712606E-11_JPRB, 0.91198542E-11_JPRB, &
  & 0.93733623E-11_JPRB, 0.94639817E-11_JPRB, 0.93805293E-11_JPRB, 0.91472142E-11_JPRB, 0.87871481E-11_JPRB, 0.83374228E-11_JPRB, &
  & 0.78332098E-11_JPRB, 0.72978767E-11_JPRB, 0.67469537E-11_JPRB, 0.61964591E-11_JPRB, 0.56660818E-11_JPRB, 0.51751090E-11_JPRB, &
  & 0.47401354E-11_JPRB, 0.43716619E-11_JPRB, 0.40738931E-11_JPRB, 0.38454309E-11_JPRB, 0.36687233E-11_JPRB, 0.35155654E-11_JPRB, &
  & 0.33783970E-11_JPRB, 0.32449271E-11_JPRB, 0.30715172E-11_JPRB, 0.27754370E-11_JPRB /)

RGHG9(:,22, 9) = (/ &
  & 0.16137704E-11_JPRB, 0.16303788E-11_JPRB, 0.15630345E-11_JPRB, 0.14794145E-11_JPRB, 0.13948618E-11_JPRB, 0.13432736E-11_JPRB, &
  & 0.13496947E-11_JPRB, 0.14331142E-11_JPRB, 0.16112224E-11_JPRB, 0.18988652E-11_JPRB, 0.23091190E-11_JPRB, 0.28437294E-11_JPRB, &
  & 0.34934291E-11_JPRB, 0.42371419E-11_JPRB, 0.50470756E-11_JPRB, 0.59007404E-11_JPRB, 0.67850075E-11_JPRB, 0.77015078E-11_JPRB, &
  & 0.86618672E-11_JPRB, 0.96905201E-11_JPRB, 0.10815392E-10_JPRB, 0.12057402E-10_JPRB, 0.13417800E-10_JPRB, 0.14864558E-10_JPRB, &
  & 0.16311843E-10_JPRB, 0.17617114E-10_JPRB, 0.18640733E-10_JPRB, 0.19260100E-10_JPRB, 0.19439110E-10_JPRB, 0.19199916E-10_JPRB, &
  & 0.18581884E-10_JPRB, 0.17659067E-10_JPRB, 0.16582671E-10_JPRB, 0.15474537E-10_JPRB, 0.14517132E-10_JPRB, 0.13848667E-10_JPRB, &
  & 0.13512642E-10_JPRB, 0.13513944E-10_JPRB, 0.13770707E-10_JPRB, 0.14173653E-10_JPRB, 0.14610368E-10_JPRB, 0.15015909E-10_JPRB, &
  & 0.15244615E-10_JPRB, 0.15297905E-10_JPRB, 0.15159762E-10_JPRB, 0.14807544E-10_JPRB, 0.14277562E-10_JPRB, 0.13621647E-10_JPRB, &
  & 0.12878487E-10_JPRB, 0.12079296E-10_JPRB, 0.11254288E-10_JPRB, 0.10435838E-10_JPRB, 0.96578310E-11_JPRB, 0.89487064E-11_JPRB, &
  & 0.83295107E-11_JPRB, 0.78107208E-11_JPRB, 0.73945754E-11_JPRB, 0.70565546E-11_JPRB, 0.67550323E-11_JPRB, 0.64882114E-11_JPRB, &
  & 0.62507837E-11_JPRB, 0.60217456E-11_JPRB, 0.57777745E-11_JPRB, 0.52738413E-11_JPRB /)

RGHG9(:,23, 9) = (/ &
  & 0.29808009E-11_JPRB, 0.29154470E-11_JPRB, 0.27767554E-11_JPRB, 0.26126564E-11_JPRB, 0.24570803E-11_JPRB, 0.23459121E-11_JPRB, &
  & 0.23165623E-11_JPRB, 0.23990458E-11_JPRB, 0.26177762E-11_JPRB, 0.29931101E-11_JPRB, 0.35367815E-11_JPRB, 0.42504260E-11_JPRB, &
  & 0.51190423E-11_JPRB, 0.61121338E-11_JPRB, 0.71950688E-11_JPRB, 0.83353905E-11_JPRB, 0.95153399E-11_JPRB, 0.10732610E-10_JPRB, &
  & 0.12007862E-10_JPRB, 0.13362469E-10_JPRB, 0.14835452E-10_JPRB, 0.16443761E-10_JPRB, 0.18205359E-10_JPRB, 0.20059555E-10_JPRB, &
  & 0.21922995E-10_JPRB, 0.23601971E-10_JPRB, 0.24967136E-10_JPRB, 0.25932655E-10_JPRB, 0.26467479E-10_JPRB, 0.26532773E-10_JPRB, &
  & 0.26155581E-10_JPRB, 0.25404966E-10_JPRB, 0.24428798E-10_JPRB, 0.23372658E-10_JPRB, 0.22405772E-10_JPRB, 0.21668252E-10_JPRB, &
  & 0.21249195E-10_JPRB, 0.21159447E-10_JPRB, 0.21311081E-10_JPRB, 0.21579970E-10_JPRB, 0.21859889E-10_JPRB, 0.22079774E-10_JPRB, &
  & 0.22177355E-10_JPRB, 0.22055319E-10_JPRB, 0.21710727E-10_JPRB, 0.21173698E-10_JPRB, 0.20433547E-10_JPRB, 0.19535229E-10_JPRB, &
  & 0.18536566E-10_JPRB, 0.17484276E-10_JPRB, 0.16414850E-10_JPRB, 0.15369001E-10_JPRB, 0.14390002E-10_JPRB, 0.13510628E-10_JPRB, &
  & 0.12749462E-10_JPRB, 0.12110462E-10_JPRB, 0.11584110E-10_JPRB, 0.11138618E-10_JPRB, 0.10735480E-10_JPRB, 0.10369018E-10_JPRB, &
  & 0.10028072E-10_JPRB, 0.96997167E-11_JPRB, 0.93171850E-11_JPRB, 0.86957863E-11_JPRB /)

RGHG9(:,24, 9) = (/ &
  & 0.48493917E-11_JPRB, 0.46767716E-11_JPRB, 0.44366386E-11_JPRB, 0.41835454E-11_JPRB, 0.39405805E-11_JPRB, 0.37483562E-11_JPRB, &
  & 0.36635126E-11_JPRB, 0.37253685E-11_JPRB, 0.39688790E-11_JPRB, 0.44184318E-11_JPRB, 0.50881461E-11_JPRB, 0.59754428E-11_JPRB, &
  & 0.70616217E-11_JPRB, 0.83107670E-11_JPRB, 0.96768366E-11_JPRB, 0.11121363E-10_JPRB, 0.12612887E-10_JPRB, 0.14148952E-10_JPRB, &
  & 0.15741226E-10_JPRB, 0.17413213E-10_JPRB, 0.19202341E-10_JPRB, 0.21129236E-10_JPRB, 0.23210817E-10_JPRB, 0.25374352E-10_JPRB, &
  & 0.27519906E-10_JPRB, 0.29535045E-10_JPRB, 0.31262930E-10_JPRB, 0.32558789E-10_JPRB, 0.33388962E-10_JPRB, 0.33795463E-10_JPRB, &
  & 0.33801809E-10_JPRB, 0.33442395E-10_JPRB, 0.32829961E-10_JPRB, 0.32085744E-10_JPRB, 0.31335837E-10_JPRB, 0.30689354E-10_JPRB, &
  & 0.30267767E-10_JPRB, 0.30047295E-10_JPRB, 0.29975935E-10_JPRB, 0.29964552E-10_JPRB, 0.29916129E-10_JPRB, 0.29787568E-10_JPRB, &
  & 0.29537789E-10_JPRB, 0.29154536E-10_JPRB, 0.28552922E-10_JPRB, 0.27739533E-10_JPRB, 0.26752029E-10_JPRB, 0.25637827E-10_JPRB, &
  & 0.24422483E-10_JPRB, 0.23150922E-10_JPRB, 0.21879241E-10_JPRB, 0.20658485E-10_JPRB, 0.19534766E-10_JPRB, 0.18536716E-10_JPRB, &
  & 0.17672733E-10_JPRB, 0.16935647E-10_JPRB, 0.16312391E-10_JPRB, 0.15748984E-10_JPRB, 0.15240963E-10_JPRB, 0.14779750E-10_JPRB, &
  & 0.14356138E-10_JPRB, 0.13943025E-10_JPRB, 0.13487735E-10_JPRB, 0.12656500E-10_JPRB /)

RGHG9(:,25, 9) = (/ &
  & 0.71776708E-11_JPRB, 0.68843741E-11_JPRB, 0.65576928E-11_JPRB, 0.62115092E-11_JPRB, 0.58860685E-11_JPRB, 0.56138228E-11_JPRB, &
  & 0.54657806E-11_JPRB, 0.54988618E-11_JPRB, 0.57585499E-11_JPRB, 0.62745182E-11_JPRB, 0.70629288E-11_JPRB, 0.81205528E-11_JPRB, &
  & 0.94257492E-11_JPRB, 0.10937177E-10_JPRB, 0.12599862E-10_JPRB, 0.14365297E-10_JPRB, 0.16186106E-10_JPRB, 0.18045588E-10_JPRB, &
  & 0.19951480E-10_JPRB, 0.21918498E-10_JPRB, 0.23971750E-10_JPRB, 0.26133058E-10_JPRB, 0.28411006E-10_JPRB, 0.30761265E-10_JPRB, &
  & 0.33072996E-10_JPRB, 0.35208239E-10_JPRB, 0.37054602E-10_JPRB, 0.38576423E-10_JPRB, 0.39762051E-10_JPRB, 0.40576844E-10_JPRB, &
  & 0.41039172E-10_JPRB, 0.41175126E-10_JPRB, 0.41061748E-10_JPRB, 0.40768618E-10_JPRB, 0.40396655E-10_JPRB, 0.40007112E-10_JPRB, &
  & 0.39625067E-10_JPRB, 0.39263703E-10_JPRB, 0.38901167E-10_JPRB, 0.38525946E-10_JPRB, 0.38072327E-10_JPRB, 0.37538382E-10_JPRB, &
  & 0.36872751E-10_JPRB, 0.36107211E-10_JPRB, 0.35196662E-10_JPRB, 0.34122809E-10_JPRB, 0.32881635E-10_JPRB, 0.31533016E-10_JPRB, &
  & 0.30131616E-10_JPRB, 0.28711627E-10_JPRB, 0.27312309E-10_JPRB, 0.25985976E-10_JPRB, 0.24776332E-10_JPRB, 0.23705839E-10_JPRB, &
  & 0.22776002E-10_JPRB, 0.21977734E-10_JPRB, 0.21266947E-10_JPRB, 0.20623402E-10_JPRB, 0.20034346E-10_JPRB, 0.19489906E-10_JPRB, &
  & 0.18980994E-10_JPRB, 0.18485873E-10_JPRB, 0.17935625E-10_JPRB, 0.16979897E-10_JPRB /)

RGHG9(:,26, 9) = (/ &
  & 0.98939103E-11_JPRB, 0.95251385E-11_JPRB, 0.91349480E-11_JPRB, 0.87421233E-11_JPRB, 0.83537561E-11_JPRB, 0.80373347E-11_JPRB, &
  & 0.78395242E-11_JPRB, 0.78496931E-11_JPRB, 0.81230560E-11_JPRB, 0.87018439E-11_JPRB, 0.96037336E-11_JPRB, 0.10829237E-10_JPRB, &
  & 0.12352010E-10_JPRB, 0.14128055E-10_JPRB, 0.16093710E-10_JPRB, 0.18183436E-10_JPRB, 0.20335707E-10_JPRB, 0.22516159E-10_JPRB, &
  & 0.24709257E-10_JPRB, 0.26915498E-10_JPRB, 0.29167540E-10_JPRB, 0.31476807E-10_JPRB, 0.33838890E-10_JPRB, 0.36221089E-10_JPRB, &
  & 0.38540643E-10_JPRB, 0.40678429E-10_JPRB, 0.42588755E-10_JPRB, 0.44246298E-10_JPRB, 0.45623196E-10_JPRB, 0.46759329E-10_JPRB, &
  & 0.47628963E-10_JPRB, 0.48234375E-10_JPRB, 0.48612711E-10_JPRB, 0.48776184E-10_JPRB, 0.48750833E-10_JPRB, 0.48567796E-10_JPRB, &
  & 0.48244613E-10_JPRB, 0.47774163E-10_JPRB, 0.47173068E-10_JPRB, 0.46465467E-10_JPRB, 0.45634430E-10_JPRB, 0.44716723E-10_JPRB, &
  & 0.43696803E-10_JPRB, 0.42588405E-10_JPRB, 0.41372787E-10_JPRB, 0.40050893E-10_JPRB, 0.38629960E-10_JPRB, 0.37130989E-10_JPRB, &
  & 0.35587790E-10_JPRB, 0.34046967E-10_JPRB, 0.32558164E-10_JPRB, 0.31162840E-10_JPRB, 0.29897411E-10_JPRB, 0.28781644E-10_JPRB, &
  & 0.27812039E-10_JPRB, 0.26962675E-10_JPRB, 0.26194005E-10_JPRB, 0.25491690E-10_JPRB, 0.24843416E-10_JPRB, 0.24240492E-10_JPRB, &
  & 0.23675312E-10_JPRB, 0.23129320E-10_JPRB, 0.22513134E-10_JPRB, 0.21474439E-10_JPRB /)

RGHG9(:,27, 9) = (/ &
  & 0.12970528E-10_JPRB, 0.12595025E-10_JPRB, 0.12207355E-10_JPRB, 0.11793649E-10_JPRB, 0.11405147E-10_JPRB, 0.11062906E-10_JPRB, &
  & 0.10855432E-10_JPRB, 0.10864547E-10_JPRB, 0.11168594E-10_JPRB, 0.11815827E-10_JPRB, 0.12833601E-10_JPRB, 0.14219884E-10_JPRB, &
  & 0.15951138E-10_JPRB, 0.17977012E-10_JPRB, 0.20227301E-10_JPRB, 0.22618137E-10_JPRB, 0.25076070E-10_JPRB, 0.27535361E-10_JPRB, &
  & 0.29949071E-10_JPRB, 0.32341220E-10_JPRB, 0.34704236E-10_JPRB, 0.37056563E-10_JPRB, 0.39386147E-10_JPRB, 0.41680354E-10_JPRB, &
  & 0.43883237E-10_JPRB, 0.45942146E-10_JPRB, 0.47841620E-10_JPRB, 0.49539747E-10_JPRB, 0.51039485E-10_JPRB, 0.52341041E-10_JPRB, &
  & 0.53486420E-10_JPRB, 0.54452758E-10_JPRB, 0.55225106E-10_JPRB, 0.55763050E-10_JPRB, 0.56039499E-10_JPRB, 0.56043219E-10_JPRB, &
  & 0.55769285E-10_JPRB, 0.55220203E-10_JPRB, 0.54424451E-10_JPRB, 0.53442306E-10_JPRB, 0.52306166E-10_JPRB, 0.51070030E-10_JPRB, &
  & 0.49763780E-10_JPRB, 0.48384071E-10_JPRB, 0.46930369E-10_JPRB, 0.45392932E-10_JPRB, 0.43806871E-10_JPRB, 0.42200868E-10_JPRB, &
  & 0.40604103E-10_JPRB, 0.39029249E-10_JPRB, 0.37510162E-10_JPRB, 0.36091335E-10_JPRB, 0.34807025E-10_JPRB, 0.33665220E-10_JPRB, &
  & 0.32655774E-10_JPRB, 0.31734955E-10_JPRB, 0.30885055E-10_JPRB, 0.30089584E-10_JPRB, 0.29339836E-10_JPRB, 0.28635132E-10_JPRB, &
  & 0.27976343E-10_JPRB, 0.27337519E-10_JPRB, 0.26680705E-10_JPRB, 0.25661251E-10_JPRB /)

RGHG9(:,28, 9) = (/ &
  & 0.16519369E-10_JPRB, 0.16157343E-10_JPRB, 0.15791346E-10_JPRB, 0.15414886E-10_JPRB, 0.15030737E-10_JPRB, 0.14718889E-10_JPRB, &
  & 0.14531636E-10_JPRB, 0.14572168E-10_JPRB, 0.14925538E-10_JPRB, 0.15652221E-10_JPRB, 0.16780657E-10_JPRB, 0.18317408E-10_JPRB, &
  & 0.20232191E-10_JPRB, 0.22472239E-10_JPRB, 0.24956153E-10_JPRB, 0.27594902E-10_JPRB, 0.30292383E-10_JPRB, 0.32942565E-10_JPRB, &
  & 0.35519039E-10_JPRB, 0.38007097E-10_JPRB, 0.40396003E-10_JPRB, 0.42698255E-10_JPRB, 0.44909645E-10_JPRB, 0.47030303E-10_JPRB, &
  & 0.49039748E-10_JPRB, 0.50913922E-10_JPRB, 0.52639018E-10_JPRB, 0.54250986E-10_JPRB, 0.55785376E-10_JPRB, 0.57247058E-10_JPRB, &
  & 0.58599160E-10_JPRB, 0.59816249E-10_JPRB, 0.60856528E-10_JPRB, 0.61647715E-10_JPRB, 0.62128705E-10_JPRB, 0.62259885E-10_JPRB, &
  & 0.62023012E-10_JPRB, 0.61428376E-10_JPRB, 0.60511228E-10_JPRB, 0.59348214E-10_JPRB, 0.58012463E-10_JPRB, 0.56561443E-10_JPRB, &
  & 0.55054704E-10_JPRB, 0.53496617E-10_JPRB, 0.51890554E-10_JPRB, 0.50237488E-10_JPRB, 0.48564631E-10_JPRB, 0.46905334E-10_JPRB, &
  & 0.45280456E-10_JPRB, 0.43699527E-10_JPRB, 0.42181328E-10_JPRB, 0.40760759E-10_JPRB, 0.39461913E-10_JPRB, 0.38292914E-10_JPRB, &
  & 0.37236096E-10_JPRB, 0.36264249E-10_JPRB, 0.35365620E-10_JPRB, 0.34532099E-10_JPRB, 0.33762083E-10_JPRB, 0.33052922E-10_JPRB, &
  & 0.32399673E-10_JPRB, 0.31795608E-10_JPRB, 0.31134522E-10_JPRB, 0.29984727E-10_JPRB /)

RGHG9(:,29, 9) = (/ &
  & 0.20481361E-10_JPRB, 0.20188660E-10_JPRB, 0.19871384E-10_JPRB, 0.19516454E-10_JPRB, 0.19190614E-10_JPRB, 0.18912262E-10_JPRB, &
  & 0.18775767E-10_JPRB, 0.18867569E-10_JPRB, 0.19289332E-10_JPRB, 0.20101172E-10_JPRB, 0.21342577E-10_JPRB, 0.23008598E-10_JPRB, &
  & 0.25072498E-10_JPRB, 0.27472559E-10_JPRB, 0.30122804E-10_JPRB, 0.32923862E-10_JPRB, 0.35767084E-10_JPRB, 0.38514802E-10_JPRB, &
  & 0.41174522E-10_JPRB, 0.43678020E-10_JPRB, 0.46020937E-10_JPRB, 0.48209603E-10_JPRB, 0.50252275E-10_JPRB, 0.52164325E-10_JPRB, &
  & 0.53945966E-10_JPRB, 0.55595327E-10_JPRB, 0.57153712E-10_JPRB, 0.58666558E-10_JPRB, 0.60147311E-10_JPRB, 0.61629604E-10_JPRB, &
  & 0.63076357E-10_JPRB, 0.64421732E-10_JPRB, 0.65603370E-10_JPRB, 0.66527672E-10_JPRB, 0.67115806E-10_JPRB, 0.67313960E-10_JPRB, &
  & 0.67098452E-10_JPRB, 0.66484401E-10_JPRB, 0.65516190E-10_JPRB, 0.64261214E-10_JPRB, 0.62824558E-10_JPRB, 0.61258901E-10_JPRB, &
  & 0.59643110E-10_JPRB, 0.57988149E-10_JPRB, 0.56304295E-10_JPRB, 0.54596886E-10_JPRB, 0.52887601E-10_JPRB, 0.51207878E-10_JPRB, &
  & 0.49565109E-10_JPRB, 0.47977115E-10_JPRB, 0.46469054E-10_JPRB, 0.45066392E-10_JPRB, 0.43781617E-10_JPRB, 0.42612150E-10_JPRB, &
  & 0.41539890E-10_JPRB, 0.40555715E-10_JPRB, 0.39651334E-10_JPRB, 0.38818525E-10_JPRB, 0.38044314E-10_JPRB, 0.37320258E-10_JPRB, &
  & 0.36642991E-10_JPRB, 0.35975157E-10_JPRB, 0.35255888E-10_JPRB, 0.34013146E-10_JPRB /)

RGHG9(:,30, 9) = (/ &
  & 0.24784773E-10_JPRB, 0.24542875E-10_JPRB, 0.24263933E-10_JPRB, 0.23982445E-10_JPRB, 0.23701046E-10_JPRB, 0.23488045E-10_JPRB, &
  & 0.23412591E-10_JPRB, 0.23574961E-10_JPRB, 0.24074713E-10_JPRB, 0.24978204E-10_JPRB, 0.26313554E-10_JPRB, 0.28085022E-10_JPRB, &
  & 0.30252897E-10_JPRB, 0.32751933E-10_JPRB, 0.35484969E-10_JPRB, 0.38365085E-10_JPRB, 0.41243783E-10_JPRB, 0.44022005E-10_JPRB, &
  & 0.46667427E-10_JPRB, 0.49126113E-10_JPRB, 0.51373975E-10_JPRB, 0.53420639E-10_JPRB, 0.55285356E-10_JPRB, 0.56986037E-10_JPRB, &
  & 0.58545932E-10_JPRB, 0.59991415E-10_JPRB, 0.61376161E-10_JPRB, 0.62752657E-10_JPRB, 0.64153002E-10_JPRB, 0.65586730E-10_JPRB, &
  & 0.67026287E-10_JPRB, 0.68394922E-10_JPRB, 0.69610907E-10_JPRB, 0.70570425E-10_JPRB, 0.71188618E-10_JPRB, 0.71406311E-10_JPRB, &
  & 0.71200143E-10_JPRB, 0.70588431E-10_JPRB, 0.69618797E-10_JPRB, 0.68352379E-10_JPRB, 0.66883714E-10_JPRB, 0.65296268E-10_JPRB, &
  & 0.63636582E-10_JPRB, 0.61959826E-10_JPRB, 0.60256661E-10_JPRB, 0.58545599E-10_JPRB, 0.56847797E-10_JPRB, 0.55186071E-10_JPRB, &
  & 0.53575283E-10_JPRB, 0.52021148E-10_JPRB, 0.50540391E-10_JPRB, 0.49156412E-10_JPRB, 0.47879971E-10_JPRB, 0.46705771E-10_JPRB, &
  & 0.45620931E-10_JPRB, 0.44619634E-10_JPRB, 0.43687252E-10_JPRB, 0.42807577E-10_JPRB, 0.41972519E-10_JPRB, 0.41190013E-10_JPRB, &
  & 0.40465877E-10_JPRB, 0.39799049E-10_JPRB, 0.39092236E-10_JPRB, 0.38000950E-10_JPRB /)

RGHG9(:,31, 9) = (/ &
  & 0.29217344E-10_JPRB, 0.29032179E-10_JPRB, 0.28816192E-10_JPRB, 0.28591844E-10_JPRB, 0.28387209E-10_JPRB, 0.28240998E-10_JPRB, &
  & 0.28237889E-10_JPRB, 0.28483139E-10_JPRB, 0.29063326E-10_JPRB, 0.30046878E-10_JPRB, 0.31465216E-10_JPRB, 0.33304647E-10_JPRB, &
  & 0.35527404E-10_JPRB, 0.38057068E-10_JPRB, 0.40802112E-10_JPRB, 0.43661318E-10_JPRB, 0.46509685E-10_JPRB, 0.49242842E-10_JPRB, &
  & 0.51817980E-10_JPRB, 0.54183824E-10_JPRB, 0.56318668E-10_JPRB, 0.58228020E-10_JPRB, 0.59921554E-10_JPRB, 0.61439374E-10_JPRB, &
  & 0.62807259E-10_JPRB, 0.64078430E-10_JPRB, 0.65311152E-10_JPRB, 0.66549516E-10_JPRB, 0.67835695E-10_JPRB, 0.69175138E-10_JPRB, &
  & 0.70540199E-10_JPRB, 0.71851851E-10_JPRB, 0.73023559E-10_JPRB, 0.73946564E-10_JPRB, 0.74539479E-10_JPRB, 0.74744530E-10_JPRB, &
  & 0.74541547E-10_JPRB, 0.73948674E-10_JPRB, 0.73012645E-10_JPRB, 0.71790150E-10_JPRB, 0.70358525E-10_JPRB, 0.68794047E-10_JPRB, &
  & 0.67172164E-10_JPRB, 0.65508488E-10_JPRB, 0.63837213E-10_JPRB, 0.62157314E-10_JPRB, 0.60495185E-10_JPRB, 0.58878416E-10_JPRB, &
  & 0.57315781E-10_JPRB, 0.55813482E-10_JPRB, 0.54380212E-10_JPRB, 0.53026576E-10_JPRB, 0.51761220E-10_JPRB, 0.50579457E-10_JPRB, &
  & 0.49476413E-10_JPRB, 0.48446067E-10_JPRB, 0.47475156E-10_JPRB, 0.46560446E-10_JPRB, 0.45712083E-10_JPRB, 0.44939233E-10_JPRB, &
  & 0.44241957E-10_JPRB, 0.43585243E-10_JPRB, 0.42894611E-10_JPRB, 0.41660859E-10_JPRB /)

RGHG9(:,32, 9) = (/ &
  & 0.33638248E-10_JPRB, 0.33527060E-10_JPRB, 0.33362920E-10_JPRB, 0.33205775E-10_JPRB, 0.33064534E-10_JPRB, 0.32991578E-10_JPRB, &
  & 0.33070033E-10_JPRB, 0.33396692E-10_JPRB, 0.34059727E-10_JPRB, 0.35117569E-10_JPRB, 0.36585755E-10_JPRB, 0.38455100E-10_JPRB, &
  & 0.40675963E-10_JPRB, 0.43175609E-10_JPRB, 0.45859705E-10_JPRB, 0.48634260E-10_JPRB, 0.51384928E-10_JPRB, 0.54029066E-10_JPRB, &
  & 0.56504849E-10_JPRB, 0.58772029E-10_JPRB, 0.60794661E-10_JPRB, 0.62576111E-10_JPRB, 0.64137758E-10_JPRB, 0.65505844E-10_JPRB, &
  & 0.66727651E-10_JPRB, 0.67857171E-10_JPRB, 0.68952254E-10_JPRB, 0.70062477E-10_JPRB, 0.71223479E-10_JPRB, 0.72442941E-10_JPRB, &
  & 0.73690193E-10_JPRB, 0.74891968E-10_JPRB, 0.75962993E-10_JPRB, 0.76800712E-10_JPRB, 0.77331440E-10_JPRB, 0.77503649E-10_JPRB, &
  & 0.77301728E-10_JPRB, 0.76742598E-10_JPRB, 0.75860498E-10_JPRB, 0.74722908E-10_JPRB, 0.73372072E-10_JPRB, 0.71876616E-10_JPRB, &
  & 0.70318057E-10_JPRB, 0.68723707E-10_JPRB, 0.67103531E-10_JPRB, 0.65481884E-10_JPRB, 0.63881733E-10_JPRB, 0.62318019E-10_JPRB, &
  & 0.60807949E-10_JPRB, 0.59351794E-10_JPRB, 0.57957493E-10_JPRB, 0.56631526E-10_JPRB, 0.55381307E-10_JPRB, 0.54200072E-10_JPRB, &
  & 0.53084811E-10_JPRB, 0.52036063E-10_JPRB, 0.51050018E-10_JPRB, 0.50131808E-10_JPRB, 0.49282980E-10_JPRB, 0.48501172E-10_JPRB, &
  & 0.47781334E-10_JPRB, 0.47107852E-10_JPRB, 0.46380167E-10_JPRB, 0.45236027E-10_JPRB /)

RGHG9(:,33, 9) = (/ &
  & 0.37955552E-10_JPRB, 0.37904992E-10_JPRB, 0.37791811E-10_JPRB, 0.37682409E-10_JPRB, 0.37606127E-10_JPRB, 0.37608715E-10_JPRB, &
  & 0.37764531E-10_JPRB, 0.38176615E-10_JPRB, 0.38917553E-10_JPRB, 0.40023825E-10_JPRB, 0.41515801E-10_JPRB, 0.43366078E-10_JPRB, &
  & 0.45535388E-10_JPRB, 0.47950255E-10_JPRB, 0.50528311E-10_JPRB, 0.53167581E-10_JPRB, 0.55788960E-10_JPRB, 0.58305832E-10_JPRB, &
  & 0.60670066E-10_JPRB, 0.62829089E-10_JPRB, 0.64767053E-10_JPRB, 0.66467262E-10_JPRB, 0.67934040E-10_JPRB, 0.69201124E-10_JPRB, &
  & 0.70319542E-10_JPRB, 0.71340739E-10_JPRB, 0.72322155E-10_JPRB, 0.73311225E-10_JPRB, 0.74344225E-10_JPRB, 0.75425347E-10_JPRB, &
  & 0.76528367E-10_JPRB, 0.77584904E-10_JPRB, 0.78519115E-10_JPRB, 0.79240850E-10_JPRB, 0.79686618E-10_JPRB, 0.79814988E-10_JPRB, &
  & 0.79614128E-10_JPRB, 0.79096431E-10_JPRB, 0.78289708E-10_JPRB, 0.77251677E-10_JPRB, 0.76014417E-10_JPRB, 0.74617264E-10_JPRB, &
  & 0.73148890E-10_JPRB, 0.71637855E-10_JPRB, 0.70102708E-10_JPRB, 0.68546335E-10_JPRB, 0.67010078E-10_JPRB, 0.65512457E-10_JPRB, &
  & 0.64056434E-10_JPRB, 0.62651058E-10_JPRB, 0.61295628E-10_JPRB, 0.59997236E-10_JPRB, 0.58759379E-10_JPRB, 0.57583341E-10_JPRB, &
  & 0.56469961E-10_JPRB, 0.55419599E-10_JPRB, 0.54432785E-10_JPRB, 0.53505353E-10_JPRB, 0.52638210E-10_JPRB, 0.51840452E-10_JPRB, &
  & 0.51121787E-10_JPRB, 0.50457843E-10_JPRB, 0.49775101E-10_JPRB, 0.48583037E-10_JPRB /)

RGHG9(:,34, 9) = (/ &
  & 0.41966975E-10_JPRB, 0.42018125E-10_JPRB, 0.41975302E-10_JPRB, 0.41927500E-10_JPRB, 0.41916342E-10_JPRB, 0.41989259E-10_JPRB, &
  & 0.42226965E-10_JPRB, 0.42711907E-10_JPRB, 0.43510598E-10_JPRB, 0.44650280E-10_JPRB, 0.46126800E-10_JPRB, 0.47926437E-10_JPRB, &
  & 0.50002634E-10_JPRB, 0.52297514E-10_JPRB, 0.54731889E-10_JPRB, 0.57224170E-10_JPRB, 0.59690926E-10_JPRB, 0.62079071E-10_JPRB, &
  & 0.64332192E-10_JPRB, 0.66410821E-10_JPRB, 0.68286578E-10_JPRB, 0.69923824E-10_JPRB, 0.71333953E-10_JPRB, 0.72545969E-10_JPRB, &
  & 0.73600133E-10_JPRB, 0.74542539E-10_JPRB, 0.75429017E-10_JPRB, 0.76307655E-10_JPRB, 0.77209732E-10_JPRB, 0.78144310E-10_JPRB, &
  & 0.79085238E-10_JPRB, 0.79976727E-10_JPRB, 0.80753224E-10_JPRB, 0.81342245E-10_JPRB, 0.81691820E-10_JPRB, 0.81771749E-10_JPRB, &
  & 0.81572533E-10_JPRB, 0.81101743E-10_JPRB, 0.80381229E-10_JPRB, 0.79455609E-10_JPRB, 0.78332479E-10_JPRB, 0.77061871E-10_JPRB, &
  & 0.75696824E-10_JPRB, 0.74278299E-10_JPRB, 0.72838395E-10_JPRB, 0.71364040E-10_JPRB, 0.69886243E-10_JPRB, 0.68458419E-10_JPRB, &
  & 0.67059081E-10_JPRB, 0.65698676E-10_JPRB, 0.64380723E-10_JPRB, 0.63114021E-10_JPRB, 0.61896363E-10_JPRB, 0.60736007E-10_JPRB, &
  & 0.59637302E-10_JPRB, 0.58596239E-10_JPRB, 0.57609788E-10_JPRB, 0.56678540E-10_JPRB, 0.55811918E-10_JPRB, 0.55022199E-10_JPRB, &
  & 0.54310802E-10_JPRB, 0.53652551E-10_JPRB, 0.52939871E-10_JPRB, 0.51775993E-10_JPRB /)

RGHG9(:,35, 9) = (/ &
  & 0.45767324E-10_JPRB, 0.45849328E-10_JPRB, 0.45873215E-10_JPRB, 0.45886694E-10_JPRB, 0.45937872E-10_JPRB, 0.46081552E-10_JPRB, &
  & 0.46385194E-10_JPRB, 0.46932951E-10_JPRB, 0.47772473E-10_JPRB, 0.48912846E-10_JPRB, 0.50355706E-10_JPRB, 0.52070792E-10_JPRB, &
  & 0.54033021E-10_JPRB, 0.56182590E-10_JPRB, 0.58462603E-10_JPRB, 0.60789401E-10_JPRB, 0.63105902E-10_JPRB, 0.65361744E-10_JPRB, &
  & 0.67509581E-10_JPRB, 0.69517482E-10_JPRB, 0.71345568E-10_JPRB, 0.72960575E-10_JPRB, 0.74360074E-10_JPRB, 0.75555756E-10_JPRB, &
  & 0.76576225E-10_JPRB, 0.77465034E-10_JPRB, 0.78271861E-10_JPRB, 0.79044701E-10_JPRB, 0.79816848E-10_JPRB, 0.80596606E-10_JPRB, &
  & 0.81366691E-10_JPRB, 0.82082924E-10_JPRB, 0.82693540E-10_JPRB, 0.83144810E-10_JPRB, 0.83397234E-10_JPRB, 0.83430221E-10_JPRB, &
  & 0.83235717E-10_JPRB, 0.82816268E-10_JPRB, 0.82187729E-10_JPRB, 0.81373644E-10_JPRB, 0.80374547E-10_JPRB, 0.79225765E-10_JPRB, &
  & 0.77971948E-10_JPRB, 0.76662031E-10_JPRB, 0.75312478E-10_JPRB, 0.73918781E-10_JPRB, 0.72507389E-10_JPRB, 0.71143286E-10_JPRB, &
  & 0.69801782E-10_JPRB, 0.68483337E-10_JPRB, 0.67202285E-10_JPRB, 0.65969334E-10_JPRB, 0.64780382E-10_JPRB, 0.63644409E-10_JPRB, &
  & 0.62572544E-10_JPRB, 0.61552152E-10_JPRB, 0.60582393E-10_JPRB, 0.59665946E-10_JPRB, 0.58810699E-10_JPRB, 0.58025900E-10_JPRB, &
  & 0.57316700E-10_JPRB, 0.56657543E-10_JPRB, 0.55971124E-10_JPRB, 0.54795467E-10_JPRB /)

RGHG9(:,36, 9) = (/ &
  & 0.49190874E-10_JPRB, 0.49398860E-10_JPRB, 0.49478855E-10_JPRB, 0.49547991E-10_JPRB, 0.49658187E-10_JPRB, 0.49858957E-10_JPRB, &
  & 0.50222802E-10_JPRB, 0.50813125E-10_JPRB, 0.51668499E-10_JPRB, 0.52796833E-10_JPRB, 0.54175577E-10_JPRB, 0.55795795E-10_JPRB, &
  & 0.57624062E-10_JPRB, 0.59623265E-10_JPRB, 0.61733910E-10_JPRB, 0.63902092E-10_JPRB, 0.66059401E-10_JPRB, 0.68186991E-10_JPRB, &
  & 0.70241528E-10_JPRB, 0.72185015E-10_JPRB, 0.73988836E-10_JPRB, 0.75612100E-10_JPRB, 0.77024623E-10_JPRB, 0.78225836E-10_JPRB, &
  & 0.79226556E-10_JPRB, 0.80067265E-10_JPRB, 0.80799589E-10_JPRB, 0.81469310E-10_JPRB, 0.82109416E-10_JPRB, 0.82734118E-10_JPRB, &
  & 0.83333146E-10_JPRB, 0.83875275E-10_JPRB, 0.84325824E-10_JPRB, 0.84646436E-10_JPRB, 0.84811803E-10_JPRB, 0.84808188E-10_JPRB, &
  & 0.84627444E-10_JPRB, 0.84267870E-10_JPRB, 0.83735907E-10_JPRB, 0.83036904E-10_JPRB, 0.82158183E-10_JPRB, 0.81128652E-10_JPRB, &
  & 0.79996156E-10_JPRB, 0.78796830E-10_JPRB, 0.77525306E-10_JPRB, 0.76208817E-10_JPRB, 0.74877236E-10_JPRB, 0.73567742E-10_JPRB, &
  & 0.72277850E-10_JPRB, 0.70997125E-10_JPRB, 0.69752017E-10_JPRB, 0.68554100E-10_JPRB, 0.67402903E-10_JPRB, 0.66305537E-10_JPRB, &
  & 0.65273238E-10_JPRB, 0.64291648E-10_JPRB, 0.63355300E-10_JPRB, 0.62465644E-10_JPRB, 0.61628987E-10_JPRB, 0.60859061E-10_JPRB, &
  & 0.60163138E-10_JPRB, 0.59519736E-10_JPRB, 0.58827776E-10_JPRB, 0.57664002E-10_JPRB /)

RGHG9(:,37, 9) = (/ &
  & 0.52357906E-10_JPRB, 0.52680579E-10_JPRB, 0.52812445E-10_JPRB, 0.52933061E-10_JPRB, 0.53093443E-10_JPRB, 0.53348603E-10_JPRB, &
  & 0.53756166E-10_JPRB, 0.54374408E-10_JPRB, 0.55230528E-10_JPRB, 0.56317090E-10_JPRB, 0.57624284E-10_JPRB, 0.59128924E-10_JPRB, &
  & 0.60818427E-10_JPRB, 0.62654722E-10_JPRB, 0.64599347E-10_JPRB, 0.66597186E-10_JPRB, 0.68613497E-10_JPRB, 0.70600185E-10_JPRB, &
  & 0.72567161E-10_JPRB, 0.74468411E-10_JPRB, 0.76255953E-10_JPRB, 0.77884706E-10_JPRB, 0.79304820E-10_JPRB, 0.80486354E-10_JPRB, &
  & 0.81445295E-10_JPRB, 0.82217531E-10_JPRB, 0.82860677E-10_JPRB, 0.83422401E-10_JPRB, 0.83935789E-10_JPRB, 0.84416196E-10_JPRB, &
  & 0.84860285E-10_JPRB, 0.85250501E-10_JPRB, 0.85563882E-10_JPRB, 0.85777919E-10_JPRB, 0.85877770E-10_JPRB, 0.85855399E-10_JPRB, &
  & 0.85704326E-10_JPRB, 0.85417631E-10_JPRB, 0.84994109E-10_JPRB, 0.84420401E-10_JPRB, 0.83672992E-10_JPRB, 0.82780977E-10_JPRB, &
  & 0.81775919E-10_JPRB, 0.80668035E-10_JPRB, 0.79482261E-10_JPRB, 0.78250031E-10_JPRB, 0.76994418E-10_JPRB, 0.75737180E-10_JPRB, &
  & 0.74488533E-10_JPRB, 0.73250128E-10_JPRB, 0.72043004E-10_JPRB, 0.70882029E-10_JPRB, 0.69774561E-10_JPRB, 0.68729411E-10_JPRB, &
  & 0.67750756E-10_JPRB, 0.66822527E-10_JPRB, 0.65934175E-10_JPRB, 0.65084688E-10_JPRB, 0.64281108E-10_JPRB, 0.63537932E-10_JPRB, &
  & 0.62861799E-10_JPRB, 0.62227896E-10_JPRB, 0.61550140E-10_JPRB, 0.60394155E-10_JPRB /)

RGHG9(:,38, 9) = (/ &
  & 0.55410131E-10_JPRB, 0.55732845E-10_JPRB, 0.55906897E-10_JPRB, 0.56071817E-10_JPRB, 0.56282132E-10_JPRB, 0.56583172E-10_JPRB, &
  & 0.57029274E-10_JPRB, 0.57661823E-10_JPRB, 0.58496409E-10_JPRB, 0.59528986E-10_JPRB, 0.60742703E-10_JPRB, 0.62124000E-10_JPRB, &
  & 0.63660070E-10_JPRB, 0.65330109E-10_JPRB, 0.67100131E-10_JPRB, 0.68932873E-10_JPRB, 0.70800900E-10_JPRB, 0.72679127E-10_JPRB, &
  & 0.74542192E-10_JPRB, 0.76379320E-10_JPRB, 0.78138662E-10_JPRB, 0.79737036E-10_JPRB, 0.81106441E-10_JPRB, 0.82218260E-10_JPRB, &
  & 0.83080258E-10_JPRB, 0.83752269E-10_JPRB, 0.84293038E-10_JPRB, 0.84751178E-10_JPRB, 0.85156354E-10_JPRB, 0.85523692E-10_JPRB, &
  & 0.85853276E-10_JPRB, 0.86134051E-10_JPRB, 0.86353036E-10_JPRB, 0.86496303E-10_JPRB, 0.86556352E-10_JPRB, 0.86530630E-10_JPRB, &
  & 0.86413834E-10_JPRB, 0.86201019E-10_JPRB, 0.85885722E-10_JPRB, 0.85444700E-10_JPRB, 0.84852590E-10_JPRB, 0.84122792E-10_JPRB, &
  & 0.83255146E-10_JPRB, 0.82267131E-10_JPRB, 0.81185947E-10_JPRB, 0.80043500E-10_JPRB, 0.78856567E-10_JPRB, 0.77655972E-10_JPRB, &
  & 0.76450422E-10_JPRB, 0.75252672E-10_JPRB, 0.74083344E-10_JPRB, 0.72964933E-10_JPRB, 0.71910991E-10_JPRB, 0.70930033E-10_JPRB, &
  & 0.70017402E-10_JPRB, 0.69154932E-10_JPRB, 0.68328419E-10_JPRB, 0.67532188E-10_JPRB, 0.66773378E-10_JPRB, 0.66065528E-10_JPRB, &
  & 0.65415395E-10_JPRB, 0.64802379E-10_JPRB, 0.64139236E-10_JPRB, 0.62999557E-10_JPRB /)

RGHG9(:,39, 9) = (/ &
  & 0.58149621E-10_JPRB, 0.58559969E-10_JPRB, 0.58780342E-10_JPRB, 0.58994330E-10_JPRB, 0.59251201E-10_JPRB, 0.59599242E-10_JPRB, &
  & 0.60077408E-10_JPRB, 0.60710749E-10_JPRB, 0.61511060E-10_JPRB, 0.62470924E-10_JPRB, 0.63578559E-10_JPRB, 0.64824084E-10_JPRB, &
  & 0.66200712E-10_JPRB, 0.67695800E-10_JPRB, 0.69289241E-10_JPRB, 0.70952764E-10_JPRB, 0.72663292E-10_JPRB, 0.74412990E-10_JPRB, &
  & 0.76181596E-10_JPRB, 0.77941424E-10_JPRB, 0.79622135E-10_JPRB, 0.81142135E-10_JPRB, 0.82410925E-10_JPRB, 0.83401806E-10_JPRB, &
  & 0.84151956E-10_JPRB, 0.84720439E-10_JPRB, 0.85170974E-10_JPRB, 0.85546854E-10_JPRB, 0.85874252E-10_JPRB, 0.86165575E-10_JPRB, &
  & 0.86422362E-10_JPRB, 0.86637031E-10_JPRB, 0.86800254E-10_JPRB, 0.86902957E-10_JPRB, 0.86941822E-10_JPRB, 0.86916564E-10_JPRB, &
  & 0.86825713E-10_JPRB, 0.86666098E-10_JPRB, 0.86433492E-10_JPRB, 0.86106136E-10_JPRB, 0.85659133E-10_JPRB, 0.85094154E-10_JPRB, &
  & 0.84391050E-10_JPRB, 0.83556419E-10_JPRB, 0.82611341E-10_JPRB, 0.81573248E-10_JPRB, 0.80471206E-10_JPRB, 0.79334574E-10_JPRB, &
  & 0.78177555E-10_JPRB, 0.77020688E-10_JPRB, 0.75892827E-10_JPRB, 0.74821947E-10_JPRB, 0.73828735E-10_JPRB, 0.72919754E-10_JPRB, &
  & 0.72081840E-10_JPRB, 0.71295352E-10_JPRB, 0.70539075E-10_JPRB, 0.69807271E-10_JPRB, 0.69102508E-10_JPRB, 0.68440260E-10_JPRB, &
  & 0.67825835E-10_JPRB, 0.67239846E-10_JPRB, 0.66595729E-10_JPRB, 0.65487733E-10_JPRB /)

RGHG9(:,40, 9) = (/ &
  & 0.60728339E-10_JPRB, 0.61193113E-10_JPRB, 0.61461863E-10_JPRB, 0.61715980E-10_JPRB, 0.62024781E-10_JPRB, 0.62418237E-10_JPRB, &
  & 0.62919482E-10_JPRB, 0.63547993E-10_JPRB, 0.64299635E-10_JPRB, 0.65174685E-10_JPRB, 0.66168071E-10_JPRB, 0.67271314E-10_JPRB, &
  & 0.68485460E-10_JPRB, 0.69805238E-10_JPRB, 0.71219738E-10_JPRB, 0.72713446E-10_JPRB, 0.74272033E-10_JPRB, 0.75881565E-10_JPRB, &
  & 0.77534569E-10_JPRB, 0.79184374E-10_JPRB, 0.80769336E-10_JPRB, 0.82169389E-10_JPRB, 0.83313655E-10_JPRB, 0.84188101E-10_JPRB, &
  & 0.84834750E-10_JPRB, 0.85321125E-10_JPRB, 0.85703493E-10_JPRB, 0.86020989E-10_JPRB, 0.86295394E-10_JPRB, 0.86538464E-10_JPRB, &
  & 0.86750634E-10_JPRB, 0.86926563E-10_JPRB, 0.87057986E-10_JPRB, 0.87138088E-10_JPRB, 0.87165136E-10_JPRB, 0.87140795E-10_JPRB, &
  & 0.87065549E-10_JPRB, 0.86938720E-10_JPRB, 0.86759440E-10_JPRB, 0.86509799E-10_JPRB, 0.86172743E-10_JPRB, 0.85743537E-10_JPRB, &
  & 0.85196565E-10_JPRB, 0.84529668E-10_JPRB, 0.83742208E-10_JPRB, 0.82834822E-10_JPRB, 0.81839119E-10_JPRB, 0.80780271E-10_JPRB, &
  & 0.79678021E-10_JPRB, 0.78570220E-10_JPRB, 0.77488557E-10_JPRB, 0.76471010E-10_JPRB, 0.75544786E-10_JPRB, 0.74710661E-10_JPRB, &
  & 0.73953288E-10_JPRB, 0.73245500E-10_JPRB, 0.72567230E-10_JPRB, 0.71904149E-10_JPRB, 0.71262454E-10_JPRB, 0.70652907E-10_JPRB, &
  & 0.70082794E-10_JPRB, 0.69530215E-10_JPRB, 0.68920682E-10_JPRB, 0.67851350E-10_JPRB /)

RGHG9(:,41, 9) = (/ &
  & 0.63162364E-10_JPRB, 0.63674427E-10_JPRB, 0.63965840E-10_JPRB, 0.64267765E-10_JPRB, 0.64618796E-10_JPRB, 0.65053664E-10_JPRB, &
  & 0.65579542E-10_JPRB, 0.66186667E-10_JPRB, 0.66884706E-10_JPRB, 0.67670917E-10_JPRB, 0.68544607E-10_JPRB, 0.69507351E-10_JPRB, &
  & 0.70561730E-10_JPRB, 0.71710138E-10_JPRB, 0.72949140E-10_JPRB, 0.74271249E-10_JPRB, 0.75669547E-10_JPRB, 0.77140072E-10_JPRB, &
  & 0.78661154E-10_JPRB, 0.80201845E-10_JPRB, 0.81658930E-10_JPRB, 0.82940488E-10_JPRB, 0.83962934E-10_JPRB, 0.84731444E-10_JPRB, &
  & 0.85296145E-10_JPRB, 0.85718599E-10_JPRB, 0.86050889E-10_JPRB, 0.86326030E-10_JPRB, 0.86564277E-10_JPRB, 0.86774324E-10_JPRB, &
  & 0.86958350E-10_JPRB, 0.87110062E-10_JPRB, 0.87222514E-10_JPRB, 0.87288989E-10_JPRB, 0.87309208E-10_JPRB, 0.87285457E-10_JPRB, &
  & 0.87219808E-10_JPRB, 0.87113476E-10_JPRB, 0.86967204E-10_JPRB, 0.86769814E-10_JPRB, 0.86506441E-10_JPRB, 0.86176871E-10_JPRB, &
  & 0.85755923E-10_JPRB, 0.85237942E-10_JPRB, 0.84605850E-10_JPRB, 0.83850336E-10_JPRB, 0.82975730E-10_JPRB, 0.82008865E-10_JPRB, &
  & 0.80977017E-10_JPRB, 0.79923228E-10_JPRB, 0.78892184E-10_JPRB, 0.77933292E-10_JPRB, 0.77075027E-10_JPRB, 0.76318812E-10_JPRB, &
  & 0.75641361E-10_JPRB, 0.75015757E-10_JPRB, 0.74414301E-10_JPRB, 0.73825487E-10_JPRB, 0.73249504E-10_JPRB, 0.72699909E-10_JPRB, &
  & 0.72179901E-10_JPRB, 0.71672196E-10_JPRB, 0.71099356E-10_JPRB, 0.70094604E-10_JPRB /)

RGHG9(:,42, 9) = (/ &
  & 0.65498044E-10_JPRB, 0.66022562E-10_JPRB, 0.66347580E-10_JPRB, 0.66667616E-10_JPRB, 0.67063674E-10_JPRB, 0.67537073E-10_JPRB, &
  & 0.68066969E-10_JPRB, 0.68655956E-10_JPRB, 0.69292433E-10_JPRB, 0.69988813E-10_JPRB, 0.70747977E-10_JPRB, 0.71574954E-10_JPRB, &
  & 0.72478530E-10_JPRB, 0.73464443E-10_JPRB, 0.74535454E-10_JPRB, 0.75689802E-10_JPRB, 0.76928644E-10_JPRB, 0.78248560E-10_JPRB, &
  & 0.79642237E-10_JPRB, 0.81050375E-10_JPRB, 0.82394390E-10_JPRB, 0.83547794E-10_JPRB, 0.84458857E-10_JPRB, 0.85136356E-10_JPRB, &
  & 0.85632404E-10_JPRB, 0.86004842E-10_JPRB, 0.86298010E-10_JPRB, 0.86541704E-10_JPRB, 0.86752508E-10_JPRB, 0.86939810E-10_JPRB, &
  & 0.87103755E-10_JPRB, 0.87239750E-10_JPRB, 0.87339566E-10_JPRB, 0.87397527E-10_JPRB, 0.87413347E-10_JPRB, 0.87390192E-10_JPRB, &
  & 0.87331177E-10_JPRB, 0.87238120E-10_JPRB, 0.87114337E-10_JPRB, 0.86951134E-10_JPRB, 0.86739151E-10_JPRB, 0.86479206E-10_JPRB, &
  & 0.86152738E-10_JPRB, 0.85752405E-10_JPRB, 0.85261520E-10_JPRB, 0.84646790E-10_JPRB, 0.83906861E-10_JPRB, 0.83044224E-10_JPRB, &
  & 0.82090959E-10_JPRB, 0.81101466E-10_JPRB, 0.80129361E-10_JPRB, 0.79231635E-10_JPRB, 0.78445236E-10_JPRB, 0.77764309E-10_JPRB, &
  & 0.77166745E-10_JPRB, 0.76619697E-10_JPRB, 0.76096775E-10_JPRB, 0.75580604E-10_JPRB, 0.75073968E-10_JPRB, 0.74585900E-10_JPRB, &
  & 0.74122569E-10_JPRB, 0.73663513E-10_JPRB, 0.73144275E-10_JPRB, 0.72217565E-10_JPRB /)

RGHG9(:,43, 9) = (/ &
  & 0.67794867E-10_JPRB, 0.68326435E-10_JPRB, 0.68638768E-10_JPRB, 0.68978434E-10_JPRB, 0.69394913E-10_JPRB, 0.69886388E-10_JPRB, &
  & 0.70424368E-10_JPRB, 0.70977405E-10_JPRB, 0.71555893E-10_JPRB, 0.72165655E-10_JPRB, 0.72816489E-10_JPRB, 0.73518691E-10_JPRB, &
  & 0.74282407E-10_JPRB, 0.75118932E-10_JPRB, 0.76031417E-10_JPRB, 0.77025261E-10_JPRB, 0.78103572E-10_JPRB, 0.79276710E-10_JPRB, &
  & 0.80526127E-10_JPRB, 0.81813986E-10_JPRB, 0.83022242E-10_JPRB, 0.84056123E-10_JPRB, 0.84859203E-10_JPRB, 0.85455643E-10_JPRB, &
  & 0.85894084E-10_JPRB, 0.86224805E-10_JPRB, 0.86486866E-10_JPRB, 0.86705157E-10_JPRB, 0.86895421E-10_JPRB, 0.87064869E-10_JPRB, &
  & 0.87214791E-10_JPRB, 0.87339261E-10_JPRB, 0.87430625E-10_JPRB, 0.87482632E-10_JPRB, 0.87495643E-10_JPRB, 0.87473244E-10_JPRB, &
  & 0.87419016E-10_JPRB, 0.87335812E-10_JPRB, 0.87227225E-10_JPRB, 0.87088801E-10_JPRB, 0.86912311E-10_JPRB, 0.86702777E-10_JPRB, &
  & 0.86445899E-10_JPRB, 0.86137777E-10_JPRB, 0.85759157E-10_JPRB, 0.85277577E-10_JPRB, 0.84667238E-10_JPRB, 0.83917151E-10_JPRB, &
  & 0.83054737E-10_JPRB, 0.82135770E-10_JPRB, 0.81227289E-10_JPRB, 0.80396384E-10_JPRB, 0.79678361E-10_JPRB, 0.79072117E-10_JPRB, &
  & 0.78550673E-10_JPRB, 0.78080986E-10_JPRB, 0.77632810E-10_JPRB, 0.77189810E-10_JPRB, 0.76750585E-10_JPRB, 0.76325772E-10_JPRB, &
  & 0.75919632E-10_JPRB, 0.75516739E-10_JPRB, 0.75055684E-10_JPRB, 0.74232183E-10_JPRB /)

RGHG9(:,44, 9) = (/ &
  & 0.70038045E-10_JPRB, 0.70590866E-10_JPRB, 0.70903720E-10_JPRB, 0.71232104E-10_JPRB, 0.71649860E-10_JPRB, 0.72152763E-10_JPRB, &
  & 0.72670564E-10_JPRB, 0.73190926E-10_JPRB, 0.73707991E-10_JPRB, 0.74236256E-10_JPRB, 0.74787739E-10_JPRB, 0.75374651E-10_JPRB, &
  & 0.76014202E-10_JPRB, 0.76712740E-10_JPRB, 0.77481438E-10_JPRB, 0.78321655E-10_JPRB, 0.79248885E-10_JPRB, 0.80265475E-10_JPRB, &
  & 0.81378057E-10_JPRB, 0.82515023E-10_JPRB, 0.83591370E-10_JPRB, 0.84493079E-10_JPRB, 0.85194664E-10_JPRB, 0.85717433E-10_JPRB, &
  & 0.86105525E-10_JPRB, 0.86401303E-10_JPRB, 0.86637253E-10_JPRB, 0.86835247E-10_JPRB, 0.87008845E-10_JPRB, 0.87164942E-10_JPRB, &
  & 0.87303935E-10_JPRB, 0.87420259E-10_JPRB, 0.87505309E-10_JPRB, 0.87553291E-10_JPRB, 0.87564463E-10_JPRB, 0.87542973E-10_JPRB, &
  & 0.87492791E-10_JPRB, 0.87416754E-10_JPRB, 0.87319638E-10_JPRB, 0.87198797E-10_JPRB, 0.87048625E-10_JPRB, 0.86876145E-10_JPRB, &
  & 0.86671857E-10_JPRB, 0.86433694E-10_JPRB, 0.86147894E-10_JPRB, 0.85778586E-10_JPRB, 0.85292648E-10_JPRB, 0.84661819E-10_JPRB, &
  & 0.83893337E-10_JPRB, 0.83052620E-10_JPRB, 0.82213750E-10_JPRB, 0.81448723E-10_JPRB, 0.80802517E-10_JPRB, 0.80268209E-10_JPRB, &
  & 0.79820817E-10_JPRB, 0.79424425E-10_JPRB, 0.79048754E-10_JPRB, 0.78674844E-10_JPRB, 0.78301067E-10_JPRB, 0.77936380E-10_JPRB, &
  & 0.77587825E-10_JPRB, 0.77241040E-10_JPRB, 0.76846411E-10_JPRB, 0.76140767E-10_JPRB /)

RGHG9(:,45, 9) = (/ &
  & 0.72558515E-10_JPRB, 0.72932382E-10_JPRB, 0.73178005E-10_JPRB, 0.73468918E-10_JPRB, 0.73873817E-10_JPRB, 0.74352753E-10_JPRB, &
  & 0.74849918E-10_JPRB, 0.75324351E-10_JPRB, 0.75779612E-10_JPRB, 0.76229585E-10_JPRB, 0.76687656E-10_JPRB, 0.77173039E-10_JPRB, &
  & 0.77695572E-10_JPRB, 0.78274123E-10_JPRB, 0.78908151E-10_JPRB, 0.79611900E-10_JPRB, 0.80388723E-10_JPRB, 0.81263593E-10_JPRB, &
  & 0.82209149E-10_JPRB, 0.83197713E-10_JPRB, 0.84107103E-10_JPRB, 0.84877848E-10_JPRB, 0.85478950E-10_JPRB, 0.85934967E-10_JPRB, &
  & 0.86279324E-10_JPRB, 0.86545174E-10_JPRB, 0.86759502E-10_JPRB, 0.86940906E-10_JPRB, 0.87101326E-10_JPRB, 0.87246960E-10_JPRB, &
  & 0.87377786E-10_JPRB, 0.87487961E-10_JPRB, 0.87568508E-10_JPRB, 0.87613611E-10_JPRB, 0.87623735E-10_JPRB, 0.87603438E-10_JPRB, &
  & 0.87556531E-10_JPRB, 0.87486317E-10_JPRB, 0.87397430E-10_JPRB, 0.87289793E-10_JPRB, 0.87159460E-10_JPRB, 0.87014694E-10_JPRB, &
  & 0.86850520E-10_JPRB, 0.86666375E-10_JPRB, 0.86452012E-10_JPRB, 0.86176843E-10_JPRB, 0.85805925E-10_JPRB, 0.85292190E-10_JPRB, &
  & 0.84631462E-10_JPRB, 0.83876968E-10_JPRB, 0.83110935E-10_JPRB, 0.82419647E-10_JPRB, 0.81842130E-10_JPRB, 0.81379806E-10_JPRB, &
  & 0.81003759E-10_JPRB, 0.80675966E-10_JPRB, 0.80367650E-10_JPRB, 0.80058418E-10_JPRB, 0.79744406E-10_JPRB, 0.79435861E-10_JPRB, &
  & 0.79139903E-10_JPRB, 0.78848844E-10_JPRB, 0.78519566E-10_JPRB, 0.77937524E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART17',1,ZHOOK_HANDLE)
END SUBROUTINE PART17




SUBROUTINE PART18
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART18',0,ZHOOK_HANDLE)



RGHG9(:,46, 9) = (/ &
  & 0.74505055E-10_JPRB, 0.75039266E-10_JPRB, 0.75345057E-10_JPRB, 0.75665460E-10_JPRB, 0.76062184E-10_JPRB, 0.76531642E-10_JPRB, &
  & 0.76989408E-10_JPRB, 0.77411105E-10_JPRB, 0.77800238E-10_JPRB, 0.78170394E-10_JPRB, 0.78541160E-10_JPRB, 0.78926511E-10_JPRB, &
  & 0.79349097E-10_JPRB, 0.79811040E-10_JPRB, 0.80329569E-10_JPRB, 0.80902215E-10_JPRB, 0.81550100E-10_JPRB, 0.82264223E-10_JPRB, &
  & 0.83054952E-10_JPRB, 0.83843113E-10_JPRB, 0.84586831E-10_JPRB, 0.85214134E-10_JPRB, 0.85721368E-10_JPRB, 0.86116753E-10_JPRB, &
  & 0.86422647E-10_JPRB, 0.86663163E-10_JPRB, 0.86859617E-10_JPRB, 0.87027517E-10_JPRB, 0.87177675E-10_JPRB, 0.87315211E-10_JPRB, &
  & 0.87439958E-10_JPRB, 0.87545485E-10_JPRB, 0.87622784E-10_JPRB, 0.87665895E-10_JPRB, 0.87675638E-10_JPRB, 0.87656597E-10_JPRB, &
  & 0.87612674E-10_JPRB, 0.87546789E-10_JPRB, 0.87464244E-10_JPRB, 0.87366503E-10_JPRB, 0.87251179E-10_JPRB, 0.87127826E-10_JPRB, &
  & 0.86993926E-10_JPRB, 0.86850027E-10_JPRB, 0.86690106E-10_JPRB, 0.86489219E-10_JPRB, 0.86214348E-10_JPRB, 0.85819483E-10_JPRB, &
  & 0.85276800E-10_JPRB, 0.84622011E-10_JPRB, 0.83943866E-10_JPRB, 0.83323029E-10_JPRB, 0.82819987E-10_JPRB, 0.82428259E-10_JPRB, &
  & 0.82117015E-10_JPRB, 0.81853059E-10_JPRB, 0.81603856E-10_JPRB, 0.81351738E-10_JPRB, 0.81091675E-10_JPRB, 0.80831883E-10_JPRB, &
  & 0.80583970E-10_JPRB, 0.80342191E-10_JPRB, 0.80073767E-10_JPRB, 0.79606717E-10_JPRB /)

RGHG9(:,47, 9) = (/ &
  & 0.76721907E-10_JPRB, 0.77213964E-10_JPRB, 0.77523932E-10_JPRB, 0.77851781E-10_JPRB, 0.78260391E-10_JPRB, 0.78706021E-10_JPRB, &
  & 0.79119135E-10_JPRB, 0.79479361E-10_JPRB, 0.79792215E-10_JPRB, 0.80080019E-10_JPRB, 0.80359795E-10_JPRB, 0.80654310E-10_JPRB, &
  & 0.80972833E-10_JPRB, 0.81335411E-10_JPRB, 0.81740115E-10_JPRB, 0.82201239E-10_JPRB, 0.82709020E-10_JPRB, 0.83276983E-10_JPRB, &
  & 0.83863444E-10_JPRB, 0.84461070E-10_JPRB, 0.85012872E-10_JPRB, 0.85509072E-10_JPRB, 0.85926620E-10_JPRB, 0.86268062E-10_JPRB, &
  & 0.86540844E-10_JPRB, 0.86760044E-10_JPRB, 0.86941732E-10_JPRB, 0.87099092E-10_JPRB, 0.87241159E-10_JPRB, 0.87372685E-10_JPRB, &
  & 0.87492784E-10_JPRB, 0.87594959E-10_JPRB, 0.87669774E-10_JPRB, 0.87711588E-10_JPRB, 0.87721434E-10_JPRB, 0.87703761E-10_JPRB, &
  & 0.87662287E-10_JPRB, 0.87600052E-10_JPRB, 0.87522191E-10_JPRB, 0.87431715E-10_JPRB, 0.87328443E-10_JPRB, 0.87220807E-10_JPRB, &
  & 0.87109785E-10_JPRB, 0.86995584E-10_JPRB, 0.86874820E-10_JPRB, 0.86728430E-10_JPRB, 0.86531671E-10_JPRB, 0.86241944E-10_JPRB, &
  & 0.85825624E-10_JPRB, 0.85295881E-10_JPRB, 0.84714444E-10_JPRB, 0.84182002E-10_JPRB, 0.83749743E-10_JPRB, 0.83422443E-10_JPRB, &
  & 0.83172240E-10_JPRB, 0.82960250E-10_JPRB, 0.82762713E-10_JPRB, 0.82558731E-10_JPRB, 0.82343590E-10_JPRB, 0.82126334E-10_JPRB, &
  & 0.81918521E-10_JPRB, 0.81718916E-10_JPRB, 0.81501195E-10_JPRB, 0.81128999E-10_JPRB /)

RGHG9(:,48, 9) = (/ &
  & 0.78698645E-10_JPRB, 0.79257115E-10_JPRB, 0.79610180E-10_JPRB, 0.79976352E-10_JPRB, 0.80404197E-10_JPRB, 0.80845053E-10_JPRB, &
  & 0.81223146E-10_JPRB, 0.81518181E-10_JPRB, 0.81755172E-10_JPRB, 0.81957413E-10_JPRB, 0.82150092E-10_JPRB, 0.82348545E-10_JPRB, &
  & 0.82573615E-10_JPRB, 0.82831950E-10_JPRB, 0.83133944E-10_JPRB, 0.83469065E-10_JPRB, 0.83841725E-10_JPRB, 0.84222143E-10_JPRB, &
  & 0.84615218E-10_JPRB, 0.85001436E-10_JPRB, 0.85389251E-10_JPRB, 0.85759594E-10_JPRB, 0.86099843E-10_JPRB, 0.86393726E-10_JPRB, &
  & 0.86638266E-10_JPRB, 0.86839716E-10_JPRB, 0.87009719E-10_JPRB, 0.87158669E-10_JPRB, 0.87294699E-10_JPRB, 0.87421660E-10_JPRB, &
  & 0.87538386E-10_JPRB, 0.87637800E-10_JPRB, 0.87710866E-10_JPRB, 0.87751799E-10_JPRB, 0.87762117E-10_JPRB, 0.87745769E-10_JPRB, &
  & 0.87706571E-10_JPRB, 0.87647251E-10_JPRB, 0.87572935E-10_JPRB, 0.87488274E-10_JPRB, 0.87393842E-10_JPRB, 0.87298335E-10_JPRB, &
  & 0.87203932E-10_JPRB, 0.87111304E-10_JPRB, 0.87017824E-10_JPRB, 0.86910638E-10_JPRB, 0.86770202E-10_JPRB, 0.86567878E-10_JPRB, &
  & 0.86271892E-10_JPRB, 0.85879991E-10_JPRB, 0.85430267E-10_JPRB, 0.84994796E-10_JPRB, 0.84640440E-10_JPRB, 0.84375645E-10_JPRB, &
  & 0.84174057E-10_JPRB, 0.84006732E-10_JPRB, 0.83848734E-10_JPRB, 0.83683643E-10_JPRB, 0.83504911E-10_JPRB, 0.83320857E-10_JPRB, &
  & 0.83144915E-10_JPRB, 0.82978062E-10_JPRB, 0.82798789E-10_JPRB, 0.82497280E-10_JPRB /)

RGHG9(:,49, 9) = (/ &
  & 0.80463303E-10_JPRB, 0.81076555E-10_JPRB, 0.81465432E-10_JPRB, 0.81861441E-10_JPRB, 0.82320088E-10_JPRB, 0.82779061E-10_JPRB, &
  & 0.83136109E-10_JPRB, 0.83388289E-10_JPRB, 0.83564961E-10_JPRB, 0.83700283E-10_JPRB, 0.83815808E-10_JPRB, 0.83934498E-10_JPRB, &
  & 0.84068252E-10_JPRB, 0.84228451E-10_JPRB, 0.84413719E-10_JPRB, 0.84619742E-10_JPRB, 0.84823981E-10_JPRB, 0.85030968E-10_JPRB, &
  & 0.85235395E-10_JPRB, 0.85455629E-10_JPRB, 0.85701501E-10_JPRB, 0.85971438E-10_JPRB, 0.86244054E-10_JPRB, 0.86497962E-10_JPRB, &
  & 0.86718847E-10_JPRB, 0.86906066E-10_JPRB, 0.87066715E-10_JPRB, 0.87209351E-10_JPRB, 0.87340774E-10_JPRB, 0.87464300E-10_JPRB, &
  & 0.87578243E-10_JPRB, 0.87675610E-10_JPRB, 0.87747018E-10_JPRB, 0.87787527E-10_JPRB, 0.87798470E-10_JPRB, 0.87783482E-10_JPRB, &
  & 0.87746317E-10_JPRB, 0.87689536E-10_JPRB, 0.87618392E-10_JPRB, 0.87537838E-10_JPRB, 0.87450547E-10_JPRB, 0.87363609E-10_JPRB, &
  & 0.87281647E-10_JPRB, 0.87203827E-10_JPRB, 0.87129949E-10_JPRB, 0.87048833E-10_JPRB, 0.86948532E-10_JPRB, 0.86809560E-10_JPRB, &
  & 0.86613237E-10_JPRB, 0.86353570E-10_JPRB, 0.86048654E-10_JPRB, 0.85739998E-10_JPRB, 0.85476577E-10_JPRB, 0.85274718E-10_JPRB, &
  & 0.85118010E-10_JPRB, 0.84987878E-10_JPRB, 0.84861305E-10_JPRB, 0.84726337E-10_JPRB, 0.84576193E-10_JPRB, 0.84417570E-10_JPRB, &
  & 0.84265372E-10_JPRB, 0.84122535E-10_JPRB, 0.83969644E-10_JPRB, 0.83717630E-10_JPRB /)

RGHG9(:,50, 9) = (/ &
  & 0.82167675E-10_JPRB, 0.82688086E-10_JPRB, 0.83019369E-10_JPRB, 0.83384494E-10_JPRB, 0.83820312E-10_JPRB, 0.84259294E-10_JPRB, &
  & 0.84589398E-10_JPRB, 0.84802984E-10_JPRB, 0.84938896E-10_JPRB, 0.85030531E-10_JPRB, 0.85103681E-10_JPRB, 0.85168719E-10_JPRB, &
  & 0.85238004E-10_JPRB, 0.85315879E-10_JPRB, 0.85399569E-10_JPRB, 0.85479478E-10_JPRB, 0.85556499E-10_JPRB, 0.85627609E-10_JPRB, &
  & 0.85707268E-10_JPRB, 0.85812017E-10_JPRB, 0.85957054E-10_JPRB, 0.86146694E-10_JPRB, 0.86364603E-10_JPRB, 0.86584635E-10_JPRB, &
  & 0.86786259E-10_JPRB, 0.86962201E-10_JPRB, 0.87115690E-10_JPRB, 0.87253448E-10_JPRB, 0.87381345E-10_JPRB, 0.87502158E-10_JPRB, &
  & 0.87613833E-10_JPRB, 0.87709187E-10_JPRB, 0.87779242E-10_JPRB, 0.87819536E-10_JPRB, 0.87831194E-10_JPRB, 0.87817600E-10_JPRB, &
  & 0.87782392E-10_JPRB, 0.87728103E-10_JPRB, 0.87659588E-10_JPRB, 0.87582643E-10_JPRB, 0.87500410E-10_JPRB, 0.87420113E-10_JPRB, &
  & 0.87346012E-10_JPRB, 0.87280225E-10_JPRB, 0.87218392E-10_JPRB, 0.87155873E-10_JPRB, 0.87081828E-10_JPRB, 0.86986543E-10_JPRB, &
  & 0.86860283E-10_JPRB, 0.86704366E-10_JPRB, 0.86525107E-10_JPRB, 0.86343870E-10_JPRB, 0.86181964E-10_JPRB, 0.86050563E-10_JPRB, &
  & 0.85946680E-10_JPRB, 0.85852075E-10_JPRB, 0.85760385E-10_JPRB, 0.85656399E-10_JPRB, 0.85534468E-10_JPRB, 0.85401929E-10_JPRB, &
  & 0.85271873E-10_JPRB, 0.85147230E-10_JPRB, 0.85016244E-10_JPRB, 0.84792680E-10_JPRB /)

RGHG9(:,51, 9) = (/ &
  & 0.83446083E-10_JPRB, 0.83888035E-10_JPRB, 0.84179039E-10_JPRB, 0.84477807E-10_JPRB, 0.84858530E-10_JPRB, 0.85236554E-10_JPRB, &
  & 0.85509953E-10_JPRB, 0.85674065E-10_JPRB, 0.85772708E-10_JPRB, 0.85838767E-10_JPRB, 0.85885320E-10_JPRB, 0.85925080E-10_JPRB, &
  & 0.85959802E-10_JPRB, 0.85989854E-10_JPRB, 0.86011968E-10_JPRB, 0.86025465E-10_JPRB, 0.86030273E-10_JPRB, 0.86034832E-10_JPRB, &
  & 0.86048182E-10_JPRB, 0.86085215E-10_JPRB, 0.86164187E-10_JPRB, 0.86293472E-10_JPRB, 0.86466001E-10_JPRB, 0.86657966E-10_JPRB, &
  & 0.86843817E-10_JPRB, 0.87010781E-10_JPRB, 0.87158863E-10_JPRB, 0.87292777E-10_JPRB, 0.87417851E-10_JPRB, 0.87536332E-10_JPRB, &
  & 0.87645877E-10_JPRB, 0.87739351E-10_JPRB, 0.87808212E-10_JPRB, 0.87848465E-10_JPRB, 0.87860878E-10_JPRB, 0.87848763E-10_JPRB, &
  & 0.87815442E-10_JPRB, 0.87763616E-10_JPRB, 0.87697849E-10_JPRB, 0.87623825E-10_JPRB, 0.87545499E-10_JPRB, 0.87469448E-10_JPRB, &
  & 0.87402356E-10_JPRB, 0.87342737E-10_JPRB, 0.87291403E-10_JPRB, 0.87240146E-10_JPRB, 0.87184059E-10_JPRB, 0.87117237E-10_JPRB, &
  & 0.87037100E-10_JPRB, 0.86946471E-10_JPRB, 0.86852317E-10_JPRB, 0.86759655E-10_JPRB, 0.86679601E-10_JPRB, 0.86613668E-10_JPRB, &
  & 0.86557213E-10_JPRB, 0.86507426E-10_JPRB, 0.86452651E-10_JPRB, 0.86388445E-10_JPRB, 0.86307995E-10_JPRB, 0.86212093E-10_JPRB, &
  & 0.86112284E-10_JPRB, 0.86014786E-10_JPRB, 0.85901973E-10_JPRB, 0.85714345E-10_JPRB /)

RGHG9(:,52, 9) = (/ &
  & 0.84571281E-10_JPRB, 0.84838851E-10_JPRB, 0.85020581E-10_JPRB, 0.85255226E-10_JPRB, 0.85547534E-10_JPRB, 0.85853422E-10_JPRB, &
  & 0.86059562E-10_JPRB, 0.86178890E-10_JPRB, 0.86248578E-10_JPRB, 0.86292085E-10_JPRB, 0.86324732E-10_JPRB, 0.86348782E-10_JPRB, &
  & 0.86366754E-10_JPRB, 0.86375566E-10_JPRB, 0.86372298E-10_JPRB, 0.86357164E-10_JPRB, 0.86335009E-10_JPRB, 0.86311042E-10_JPRB, &
  & 0.86294416E-10_JPRB, 0.86296484E-10_JPRB, 0.86332719E-10_JPRB, 0.86418407E-10_JPRB, 0.86554403E-10_JPRB, 0.86721852E-10_JPRB, &
  & 0.86894353E-10_JPRB, 0.87054204E-10_JPRB, 0.87197652E-10_JPRB, 0.87328464E-10_JPRB, 0.87451102E-10_JPRB, 0.87567384E-10_JPRB, &
  & 0.87674978E-10_JPRB, 0.87766586E-10_JPRB, 0.87834538E-10_JPRB, 0.87874770E-10_JPRB, 0.87888037E-10_JPRB, 0.87877365E-10_JPRB, &
  & 0.87846008E-10_JPRB, 0.87796569E-10_JPRB, 0.87733668E-10_JPRB, 0.87662363E-10_JPRB, 0.87587070E-10_JPRB, 0.87515009E-10_JPRB, &
  & 0.87450588E-10_JPRB, 0.87398352E-10_JPRB, 0.87351723E-10_JPRB, 0.87309458E-10_JPRB, 0.87265133E-10_JPRB, 0.87216748E-10_JPRB, &
  & 0.87164803E-10_JPRB, 0.87112900E-10_JPRB, 0.87063620E-10_JPRB, 0.87021015E-10_JPRB, 0.86985003E-10_JPRB, 0.86957150E-10_JPRB, &
  & 0.86934127E-10_JPRB, 0.86911867E-10_JPRB, 0.86888122E-10_JPRB, 0.86857521E-10_JPRB, 0.86815478E-10_JPRB, 0.86762361E-10_JPRB, &
  & 0.86702492E-10_JPRB, 0.86637281E-10_JPRB, 0.86562486E-10_JPRB, 0.86412814E-10_JPRB /)

RGHG9(:,53, 9) = (/ &
  & 0.85230351E-10_JPRB, 0.85453492E-10_JPRB, 0.85617402E-10_JPRB, 0.85784282E-10_JPRB, 0.86021988E-10_JPRB, 0.86249445E-10_JPRB, &
  & 0.86403440E-10_JPRB, 0.86486387E-10_JPRB, 0.86533662E-10_JPRB, 0.86564589E-10_JPRB, 0.86585614E-10_JPRB, 0.86601740E-10_JPRB, &
  & 0.86611329E-10_JPRB, 0.86611385E-10_JPRB, 0.86598645E-10_JPRB, 0.86574345E-10_JPRB, 0.86542641E-10_JPRB, 0.86508814E-10_JPRB, &
  & 0.86478713E-10_JPRB, 0.86462525E-10_JPRB, 0.86473273E-10_JPRB, 0.86527396E-10_JPRB, 0.86633319E-10_JPRB, 0.86780541E-10_JPRB, &
  & 0.86940719E-10_JPRB, 0.87093714E-10_JPRB, 0.87233248E-10_JPRB, 0.87361077E-10_JPRB, 0.87481328E-10_JPRB, 0.87595743E-10_JPRB, &
  & 0.87701228E-10_JPRB, 0.87791378E-10_JPRB, 0.87858505E-10_JPRB, 0.87898806E-10_JPRB, 0.87913031E-10_JPRB, 0.87903899E-10_JPRB, &
  & 0.87874361E-10_JPRB, 0.87827454E-10_JPRB, 0.87767293E-10_JPRB, 0.87698800E-10_JPRB, 0.87626295E-10_JPRB, 0.87556219E-10_JPRB, &
  & 0.87496677E-10_JPRB, 0.87445891E-10_JPRB, 0.87405527E-10_JPRB, 0.87368071E-10_JPRB, 0.87332114E-10_JPRB, 0.87295907E-10_JPRB, &
  & 0.87261240E-10_JPRB, 0.87230084E-10_JPRB, 0.87204494E-10_JPRB, 0.87183691E-10_JPRB, 0.87168980E-10_JPRB, 0.87157587E-10_JPRB, &
  & 0.87148649E-10_JPRB, 0.87140191E-10_JPRB, 0.87130289E-10_JPRB, 0.87116994E-10_JPRB, 0.87097995E-10_JPRB, 0.87071780E-10_JPRB, &
  & 0.87040944E-10_JPRB, 0.87008060E-10_JPRB, 0.86965220E-10_JPRB, 0.86878497E-10_JPRB /)

RGHG9(:,54, 9) = (/ &
  & 0.85796190E-10_JPRB, 0.85951399E-10_JPRB, 0.86050299E-10_JPRB, 0.86186579E-10_JPRB, 0.86350274E-10_JPRB, 0.86526154E-10_JPRB, &
  & 0.86633076E-10_JPRB, 0.86691834E-10_JPRB, 0.86724447E-10_JPRB, 0.86744931E-10_JPRB, 0.86759919E-10_JPRB, 0.86770244E-10_JPRB, &
  & 0.86775684E-10_JPRB, 0.86772464E-10_JPRB, 0.86757351E-10_JPRB, 0.86731095E-10_JPRB, 0.86697149E-10_JPRB, 0.86659790E-10_JPRB, &
  & 0.86624402E-10_JPRB, 0.86597549E-10_JPRB, 0.86592053E-10_JPRB, 0.86624187E-10_JPRB, 0.86707884E-10_JPRB, 0.86835775E-10_JPRB, &
  & 0.86985009E-10_JPRB, 0.87130983E-10_JPRB, 0.87266062E-10_JPRB, 0.87391108E-10_JPRB, 0.87509049E-10_JPRB, 0.87621604E-10_JPRB, &
  & 0.87725223E-10_JPRB, 0.87814096E-10_JPRB, 0.87880495E-10_JPRB, 0.87920934E-10_JPRB, 0.87936186E-10_JPRB, 0.87928595E-10_JPRB, &
  & 0.87901020E-10_JPRB, 0.87856410E-10_JPRB, 0.87798893E-10_JPRB, 0.87733140E-10_JPRB, 0.87663252E-10_JPRB, 0.87596458E-10_JPRB, &
  & 0.87537678E-10_JPRB, 0.87491771E-10_JPRB, 0.87452955E-10_JPRB, 0.87420349E-10_JPRB, 0.87389859E-10_JPRB, 0.87361819E-10_JPRB, &
  & 0.87337262E-10_JPRB, 0.87317820E-10_JPRB, 0.87303054E-10_JPRB, 0.87293180E-10_JPRB, 0.87286192E-10_JPRB, 0.87281862E-10_JPRB, &
  & 0.87278282E-10_JPRB, 0.87274840E-10_JPRB, 0.87270621E-10_JPRB, 0.87264557E-10_JPRB, 0.87255425E-10_JPRB, 0.87242880E-10_JPRB, &
  & 0.87228606E-10_JPRB, 0.87214166E-10_JPRB, 0.87200941E-10_JPRB, 0.87184961E-10_JPRB /)

RGHG9(:,55, 9) = (/ &
  & 0.86174901E-10_JPRB, 0.86292300E-10_JPRB, 0.86383463E-10_JPRB, 0.86473245E-10_JPRB, 0.86602996E-10_JPRB, 0.86721269E-10_JPRB, &
  & 0.86800740E-10_JPRB, 0.86840646E-10_JPRB, 0.86863503E-10_JPRB, 0.86878060E-10_JPRB, 0.86888177E-10_JPRB, 0.86895498E-10_JPRB, &
  & 0.86898697E-10_JPRB, 0.86894741E-10_JPRB, 0.86880253E-10_JPRB, 0.86854912E-10_JPRB, 0.86821675E-10_JPRB, 0.86783601E-10_JPRB, &
  & 0.86744396E-10_JPRB, 0.86711680E-10_JPRB, 0.86695089E-10_JPRB, 0.86712068E-10_JPRB, 0.86777488E-10_JPRB, 0.86891418E-10_JPRB, &
  & 0.87028086E-10_JPRB, 0.87166822E-10_JPRB, 0.87297128E-10_JPRB, 0.87419058E-10_JPRB, 0.87534868E-10_JPRB, 0.87645523E-10_JPRB, &
  & 0.87747504E-10_JPRB, 0.87835239E-10_JPRB, 0.87900839E-10_JPRB, 0.87941543E-10_JPRB, 0.87957905E-10_JPRB, 0.87951882E-10_JPRB, &
  & 0.87926125E-10_JPRB, 0.87883811E-10_JPRB, 0.87828911E-10_JPRB, 0.87765510E-10_JPRB, 0.87698564E-10_JPRB, 0.87633845E-10_JPRB, &
  & 0.87578798E-10_JPRB, 0.87533501E-10_JPRB, 0.87498335E-10_JPRB, 0.87468109E-10_JPRB, 0.87441873E-10_JPRB, 0.87418961E-10_JPRB, &
  & 0.87400739E-10_JPRB, 0.87387209E-10_JPRB, 0.87378271E-10_JPRB, 0.87372394E-10_JPRB, 0.87369202E-10_JPRB, 0.87366996E-10_JPRB, &
  & 0.87365420E-10_JPRB, 0.87363700E-10_JPRB, 0.87361431E-10_JPRB, 0.87358037E-10_JPRB, 0.87352715E-10_JPRB, 0.87345318E-10_JPRB, &
  & 0.87336541E-10_JPRB, 0.87327499E-10_JPRB, 0.87317042E-10_JPRB, 0.87300167E-10_JPRB /)

RGHG9(:,56, 9) = (/ &
  & 0.86489704E-10_JPRB, 0.86575705E-10_JPRB, 0.86631327E-10_JPRB, 0.86704269E-10_JPRB, 0.86788084E-10_JPRB, 0.86875541E-10_JPRB, &
  & 0.86928208E-10_JPRB, 0.86957538E-10_JPRB, 0.86973470E-10_JPRB, 0.86983851E-10_JPRB, 0.86991359E-10_JPRB, 0.86996590E-10_JPRB, &
  & 0.86998880E-10_JPRB, 0.86995480E-10_JPRB, 0.86982845E-10_JPRB, 0.86960120E-10_JPRB, 0.86928256E-10_JPRB, 0.86890141E-10_JPRB, &
  & 0.86849160E-10_JPRB, 0.86810684E-10_JPRB, 0.86786446E-10_JPRB, 0.86792427E-10_JPRB, 0.86846016E-10_JPRB, 0.86945368E-10_JPRB, &
  & 0.87072002E-10_JPRB, 0.87202121E-10_JPRB, 0.87327347E-10_JPRB, 0.87446023E-10_JPRB, 0.87559487E-10_JPRB, 0.87668345E-10_JPRB, &
  & 0.87768737E-10_JPRB, 0.87855126E-10_JPRB, 0.87920018E-10_JPRB, 0.87961062E-10_JPRB, 0.87978479E-10_JPRB, 0.87973968E-10_JPRB, &
  & 0.87950147E-10_JPRB, 0.87910061E-10_JPRB, 0.87857312E-10_JPRB, 0.87796645E-10_JPRB, 0.87732092E-10_JPRB, 0.87670565E-10_JPRB, &
  & 0.87617219E-10_JPRB, 0.87574996E-10_JPRB, 0.87541113E-10_JPRB, 0.87513642E-10_JPRB, 0.87490126E-10_JPRB, 0.87470857E-10_JPRB, &
  & 0.87456029E-10_JPRB, 0.87445863E-10_JPRB, 0.87439278E-10_JPRB, 0.87435587E-10_JPRB, 0.87433283E-10_JPRB, 0.87431999E-10_JPRB, &
  & 0.87430840E-10_JPRB, 0.87429591E-10_JPRB, 0.87427919E-10_JPRB, 0.87425345E-10_JPRB, 0.87421612E-10_JPRB, 0.87416394E-10_JPRB, &
  & 0.87410475E-10_JPRB, 0.87404264E-10_JPRB, 0.87397756E-10_JPRB, 0.87386896E-10_JPRB /)

RGHG9(:,57, 9) = (/ &
  & 0.86710583E-10_JPRB, 0.86777377E-10_JPRB, 0.86826962E-10_JPRB, 0.86875965E-10_JPRB, 0.86937853E-10_JPRB, 0.86994786E-10_JPRB, &
  & 0.87033804E-10_JPRB, 0.87054058E-10_JPRB, 0.87065993E-10_JPRB, 0.87073765E-10_JPRB, 0.87079441E-10_JPRB, 0.87083729E-10_JPRB, &
  & 0.87085783E-10_JPRB, 0.87083445E-10_JPRB, 0.87073390E-10_JPRB, 0.87053406E-10_JPRB, 0.87023840E-10_JPRB, 0.86985877E-10_JPRB, &
  & 0.86942335E-10_JPRB, 0.86900147E-10_JPRB, 0.86869449E-10_JPRB, 0.86867992E-10_JPRB, 0.86911284E-10_JPRB, 0.87000677E-10_JPRB, &
  & 0.87115717E-10_JPRB, 0.87238120E-10_JPRB, 0.87357760E-10_JPRB, 0.87472855E-10_JPRB, 0.87584030E-10_JPRB, 0.87690688E-10_JPRB, &
  & 0.87789526E-10_JPRB, 0.87874284E-10_JPRB, 0.87938469E-10_JPRB, 0.87979929E-10_JPRB, 0.87998331E-10_JPRB, 0.87995292E-10_JPRB, &
  & 0.87973309E-10_JPRB, 0.87935388E-10_JPRB, 0.87885144E-10_JPRB, 0.87826420E-10_JPRB, 0.87764802E-10_JPRB, 0.87705822E-10_JPRB, &
  & 0.87655321E-10_JPRB, 0.87614707E-10_JPRB, 0.87583045E-10_JPRB, 0.87557385E-10_JPRB, 0.87536242E-10_JPRB, 0.87519138E-10_JPRB, &
  & 0.87506460E-10_JPRB, 0.87497801E-10_JPRB, 0.87492395E-10_JPRB, 0.87488988E-10_JPRB, 0.87487094E-10_JPRB, 0.87485630E-10_JPRB, &
  & 0.87484436E-10_JPRB, 0.87483104E-10_JPRB, 0.87481342E-10_JPRB, 0.87478996E-10_JPRB, 0.87475499E-10_JPRB, 0.87471169E-10_JPRB, &
  & 0.87466263E-10_JPRB, 0.87461344E-10_JPRB, 0.87455612E-10_JPRB, 0.87445849E-10_JPRB /)

RGHG9(:,58, 9) = (/ &
  & 0.86890412E-10_JPRB, 0.86943855E-10_JPRB, 0.86977675E-10_JPRB, 0.87014854E-10_JPRB, 0.87055765E-10_JPRB, 0.87095997E-10_JPRB, &
  & 0.87122823E-10_JPRB, 0.87138331E-10_JPRB, 0.87147338E-10_JPRB, 0.87153514E-10_JPRB, 0.87158336E-10_JPRB, 0.87162097E-10_JPRB, &
  & 0.87164463E-10_JPRB, 0.87163492E-10_JPRB, 0.87155977E-10_JPRB, 0.87139143E-10_JPRB, 0.87111443E-10_JPRB, 0.87073786E-10_JPRB, &
  & 0.87028551E-10_JPRB, 0.86982040E-10_JPRB, 0.86946852E-10_JPRB, 0.86939837E-10_JPRB, 0.86976114E-10_JPRB, 0.87055002E-10_JPRB, &
  & 0.87160702E-10_JPRB, 0.87275118E-10_JPRB, 0.87389249E-10_JPRB, 0.87500646E-10_JPRB, 0.87608996E-10_JPRB, 0.87713566E-10_JPRB, &
  & 0.87810245E-10_JPRB, 0.87893234E-10_JPRB, 0.87956836E-10_JPRB, 0.87998435E-10_JPRB, 0.88017697E-10_JPRB, 0.88016046E-10_JPRB, &
  & 0.87995930E-10_JPRB, 0.87960222E-10_JPRB, 0.87912080E-10_JPRB, 0.87856070E-10_JPRB, 0.87796756E-10_JPRB, 0.87740627E-10_JPRB, &
  & 0.87692457E-10_JPRB, 0.87653981E-10_JPRB, 0.87623950E-10_JPRB, 0.87600115E-10_JPRB, 0.87580720E-10_JPRB, 0.87565302E-10_JPRB, &
  & 0.87553874E-10_JPRB, 0.87545859E-10_JPRB, 0.87540517E-10_JPRB, 0.87537075E-10_JPRB, 0.87534549E-10_JPRB, 0.87532773E-10_JPRB, &
  & 0.87531121E-10_JPRB, 0.87529366E-10_JPRB, 0.87527346E-10_JPRB, 0.87524578E-10_JPRB, 0.87521129E-10_JPRB, 0.87516827E-10_JPRB, &
  & 0.87512469E-10_JPRB, 0.87508119E-10_JPRB, 0.87503567E-10_JPRB, 0.87495740E-10_JPRB /)

RGHG9(:,59, 9) = (/ &
  & 0.87028759E-10_JPRB, 0.87071225E-10_JPRB, 0.87098953E-10_JPRB, 0.87125231E-10_JPRB, 0.87154152E-10_JPRB, 0.87181998E-10_JPRB, &
  & 0.87202079E-10_JPRB, 0.87213986E-10_JPRB, 0.87221404E-10_JPRB, 0.87226726E-10_JPRB, 0.87231042E-10_JPRB, 0.87234886E-10_JPRB, &
  & 0.87237759E-10_JPRB, 0.87238265E-10_JPRB, 0.87233318E-10_JPRB, 0.87219176E-10_JPRB, 0.87193669E-10_JPRB, 0.87155838E-10_JPRB, &
  & 0.87108737E-10_JPRB, 0.87059505E-10_JPRB, 0.87020897E-10_JPRB, 0.87009885E-10_JPRB, 0.87039487E-10_JPRB, 0.87109917E-10_JPRB, &
  & 0.87206541E-10_JPRB, 0.87313573E-10_JPRB, 0.87422479E-10_JPRB, 0.87529976E-10_JPRB, 0.87635288E-10_JPRB, 0.87737269E-10_JPRB, &
  & 0.87831534E-10_JPRB, 0.87912774E-10_JPRB, 0.87975377E-10_JPRB, 0.88017010E-10_JPRB, 0.88036800E-10_JPRB, 0.88036384E-10_JPRB, &
  & 0.88018086E-10_JPRB, 0.87984516E-10_JPRB, 0.87938906E-10_JPRB, 0.87885137E-10_JPRB, 0.87828675E-10_JPRB, 0.87775107E-10_JPRB, &
  & 0.87729268E-10_JPRB, 0.87692700E-10_JPRB, 0.87664299E-10_JPRB, 0.87642019E-10_JPRB, 0.87624137E-10_JPRB, 0.87610044E-10_JPRB, &
  & 0.87599310E-10_JPRB, 0.87591642E-10_JPRB, 0.87585980E-10_JPRB, 0.87581727E-10_JPRB, 0.87578611E-10_JPRB, 0.87575981E-10_JPRB, &
  & 0.87573664E-10_JPRB, 0.87571353E-10_JPRB, 0.87568577E-10_JPRB, 0.87565365E-10_JPRB, 0.87561222E-10_JPRB, 0.87556740E-10_JPRB, &
  & 0.87552257E-10_JPRB, 0.87548108E-10_JPRB, 0.87543514E-10_JPRB, 0.87536048E-10_JPRB /)

RGHG9(:,60, 9) = (/ &
  & 0.87144410E-10_JPRB, 0.87178043E-10_JPRB, 0.87198124E-10_JPRB, 0.87217483E-10_JPRB, 0.87238050E-10_JPRB, 0.87258215E-10_JPRB, &
  & 0.87273813E-10_JPRB, 0.87283701E-10_JPRB, 0.87290238E-10_JPRB, 0.87295164E-10_JPRB, 0.87299543E-10_JPRB, 0.87303650E-10_JPRB, &
  & 0.87307508E-10_JPRB, 0.87309590E-10_JPRB, 0.87306967E-10_JPRB, 0.87295435E-10_JPRB, 0.87271149E-10_JPRB, 0.87233699E-10_JPRB, &
  & 0.87184870E-10_JPRB, 0.87133863E-10_JPRB, 0.87093020E-10_JPRB, 0.87078837E-10_JPRB, 0.87102742E-10_JPRB, 0.87165053E-10_JPRB, &
  & 0.87253468E-10_JPRB, 0.87353881E-10_JPRB, 0.87457569E-10_JPRB, 0.87561125E-10_JPRB, 0.87663293E-10_JPRB, 0.87762311E-10_JPRB, &
  & 0.87854030E-10_JPRB, 0.87933112E-10_JPRB, 0.87994695E-10_JPRB, 0.88035683E-10_JPRB, 0.88055785E-10_JPRB, 0.88056354E-10_JPRB, &
  & 0.88039784E-10_JPRB, 0.88008413E-10_JPRB, 0.87965177E-10_JPRB, 0.87914225E-10_JPRB, 0.87860365E-10_JPRB, 0.87809517E-10_JPRB, &
  & 0.87765940E-10_JPRB, 0.87731163E-10_JPRB, 0.87704261E-10_JPRB, 0.87683354E-10_JPRB, 0.87666784E-10_JPRB, 0.87653614E-10_JPRB, &
  & 0.87643649E-10_JPRB, 0.87635940E-10_JPRB, 0.87629945E-10_JPRB, 0.87624956E-10_JPRB, 0.87620716E-10_JPRB, 0.87617164E-10_JPRB, &
  & 0.87613972E-10_JPRB, 0.87610655E-10_JPRB, 0.87607172E-10_JPRB, 0.87602828E-10_JPRB, 0.87597964E-10_JPRB, 0.87592739E-10_JPRB, &
  & 0.87588041E-10_JPRB, 0.87583704E-10_JPRB, 0.87579353E-10_JPRB, 0.87571984E-10_JPRB /)

RGHG9(:,61, 9) = (/ &
  & 0.87238772E-10_JPRB, 0.87265695E-10_JPRB, 0.87281793E-10_JPRB, 0.87296406E-10_JPRB, 0.87311727E-10_JPRB, 0.87327381E-10_JPRB, &
  & 0.87340163E-10_JPRB, 0.87349024E-10_JPRB, 0.87355269E-10_JPRB, 0.87360279E-10_JPRB, 0.87364983E-10_JPRB, 0.87369889E-10_JPRB, &
  & 0.87374843E-10_JPRB, 0.87378799E-10_JPRB, 0.87378410E-10_JPRB, 0.87368709E-10_JPRB, 0.87345770E-10_JPRB, 0.87307529E-10_JPRB, &
  & 0.87258575E-10_JPRB, 0.87206388E-10_JPRB, 0.87164449E-10_JPRB, 0.87147456E-10_JPRB, 0.87166011E-10_JPRB, 0.87221050E-10_JPRB, &
  & 0.87301985E-10_JPRB, 0.87395986E-10_JPRB, 0.87494796E-10_JPRB, 0.87594522E-10_JPRB, 0.87693346E-10_JPRB, 0.87789158E-10_JPRB, &
  & 0.87878108E-10_JPRB, 0.87954893E-10_JPRB, 0.88014665E-10_JPRB, 0.88054779E-10_JPRB, 0.88074652E-10_JPRB, 0.88075977E-10_JPRB, &
  & 0.88060982E-10_JPRB, 0.88031790E-10_JPRB, 0.87991177E-10_JPRB, 0.87943000E-10_JPRB, 0.87892083E-10_JPRB, 0.87843913E-10_JPRB, &
  & 0.87802564E-10_JPRB, 0.87769528E-10_JPRB, 0.87744020E-10_JPRB, 0.87724307E-10_JPRB, 0.87708799E-10_JPRB, 0.87696538E-10_JPRB, &
  & 0.87686969E-10_JPRB, 0.87679565E-10_JPRB, 0.87673258E-10_JPRB, 0.87667540E-10_JPRB, 0.87662322E-10_JPRB, 0.87657638E-10_JPRB, &
  & 0.87653107E-10_JPRB, 0.87648791E-10_JPRB, 0.87643781E-10_JPRB, 0.87638286E-10_JPRB, 0.87631971E-10_JPRB, 0.87625941E-10_JPRB, &
  & 0.87620577E-10_JPRB, 0.87615991E-10_JPRB, 0.87611085E-10_JPRB, 0.87603487E-10_JPRB /)

RGHG9(:,62, 9) = (/ &
  & 0.87320276E-10_JPRB, 0.87342189E-10_JPRB, 0.87354735E-10_JPRB, 0.87366239E-10_JPRB, 0.87378382E-10_JPRB, 0.87391011E-10_JPRB, &
  & 0.87402335E-10_JPRB, 0.87410870E-10_JPRB, 0.87417261E-10_JPRB, 0.87422840E-10_JPRB, 0.87428259E-10_JPRB, 0.87434282E-10_JPRB, &
  & 0.87440950E-10_JPRB, 0.87446869E-10_JPRB, 0.87448479E-10_JPRB, 0.87440249E-10_JPRB, 0.87417275E-10_JPRB, 0.87379708E-10_JPRB, &
  & 0.87330178E-10_JPRB, 0.87278296E-10_JPRB, 0.87235497E-10_JPRB, 0.87216213E-10_JPRB, 0.87230050E-10_JPRB, 0.87278351E-10_JPRB, &
  & 0.87352348E-10_JPRB, 0.87440388E-10_JPRB, 0.87534500E-10_JPRB, 0.87630278E-10_JPRB, 0.87725743E-10_JPRB, 0.87818239E-10_JPRB, &
  & 0.87904101E-10_JPRB, 0.87978125E-10_JPRB, 0.88035745E-10_JPRB, 0.88074194E-10_JPRB, 0.88093546E-10_JPRB, 0.88095337E-10_JPRB, &
  & 0.88081792E-10_JPRB, 0.88054723E-10_JPRB, 0.88016816E-10_JPRB, 0.87971574E-10_JPRB, 0.87923696E-10_JPRB, 0.87878302E-10_JPRB, &
  & 0.87839201E-10_JPRB, 0.87807886E-10_JPRB, 0.87783697E-10_JPRB, 0.87765045E-10_JPRB, 0.87750439E-10_JPRB, 0.87738837E-10_JPRB, &
  & 0.87729740E-10_JPRB, 0.87722427E-10_JPRB, 0.87716140E-10_JPRB, 0.87710110E-10_JPRB, 0.87704122E-10_JPRB, 0.87698154E-10_JPRB, &
  & 0.87692548E-10_JPRB, 0.87686372E-10_JPRB, 0.87679961E-10_JPRB, 0.87672376E-10_JPRB, 0.87664528E-10_JPRB, 0.87657118E-10_JPRB, &
  & 0.87651088E-10_JPRB, 0.87645689E-10_JPRB, 0.87640409E-10_JPRB, 0.87631513E-10_JPRB /)

RGHG9(:,63, 9) = (/ &
  & 0.87389901E-10_JPRB, 0.87409018E-10_JPRB, 0.87419932E-10_JPRB, 0.87429640E-10_JPRB, 0.87439792E-10_JPRB, 0.87450831E-10_JPRB, &
  & 0.87461323E-10_JPRB, 0.87469948E-10_JPRB, 0.87477067E-10_JPRB, 0.87483382E-10_JPRB, 0.87490154E-10_JPRB, 0.87497704E-10_JPRB, &
  & 0.87506474E-10_JPRB, 0.87514704E-10_JPRB, 0.87517785E-10_JPRB, 0.87509937E-10_JPRB, 0.87487455E-10_JPRB, 0.87449728E-10_JPRB, &
  & 0.87401246E-10_JPRB, 0.87349683E-10_JPRB, 0.87306738E-10_JPRB, 0.87285568E-10_JPRB, 0.87295324E-10_JPRB, 0.87337707E-10_JPRB, &
  & 0.87405146E-10_JPRB, 0.87487587E-10_JPRB, 0.87576946E-10_JPRB, 0.87668782E-10_JPRB, 0.87760736E-10_JPRB, 0.87849637E-10_JPRB, &
  & 0.87932134E-10_JPRB, 0.88002827E-10_JPRB, 0.88057589E-10_JPRB, 0.88094074E-10_JPRB, 0.88112420E-10_JPRB, 0.88114453E-10_JPRB, &
  & 0.88102164E-10_JPRB, 0.88077302E-10_JPRB, 0.88042074E-10_JPRB, 0.87999982E-10_JPRB, 0.87955226E-10_JPRB, 0.87912712E-10_JPRB, &
  & 0.87875852E-10_JPRB, 0.87846244E-10_JPRB, 0.87823297E-10_JPRB, 0.87805645E-10_JPRB, 0.87791802E-10_JPRB, 0.87780769E-10_JPRB, &
  & 0.87771977E-10_JPRB, 0.87764879E-10_JPRB, 0.87758696E-10_JPRB, 0.87752632E-10_JPRB, 0.87746289E-10_JPRB, 0.87739600E-10_JPRB, &
  & 0.87732294E-10_JPRB, 0.87724862E-10_JPRB, 0.87716029E-10_JPRB, 0.87706453E-10_JPRB, 0.87696295E-10_JPRB, 0.87687496E-10_JPRB, &
  & 0.87680058E-10_JPRB, 0.87673854E-10_JPRB, 0.87667151E-10_JPRB, 0.87656792E-10_JPRB /)

RGHG9(:,64, 9) = (/ &
  & 0.87451948E-10_JPRB, 0.87469698E-10_JPRB, 0.87479524E-10_JPRB, 0.87488204E-10_JPRB, 0.87497329E-10_JPRB, 0.87507265E-10_JPRB, &
  & 0.87517549E-10_JPRB, 0.87526625E-10_JPRB, 0.87534605E-10_JPRB, 0.87542390E-10_JPRB, 0.87550578E-10_JPRB, 0.87560473E-10_JPRB, &
  & 0.87571610E-10_JPRB, 0.87581629E-10_JPRB, 0.87585467E-10_JPRB, 0.87577778E-10_JPRB, 0.87555262E-10_JPRB, 0.87518603E-10_JPRB, &
  & 0.87471135E-10_JPRB, 0.87420557E-10_JPRB, 0.87377883E-10_JPRB, 0.87355498E-10_JPRB, 0.87361951E-10_JPRB, 0.87399005E-10_JPRB, &
  & 0.87460636E-10_JPRB, 0.87537484E-10_JPRB, 0.87622139E-10_JPRB, 0.87709846E-10_JPRB, 0.87797859E-10_JPRB, 0.87883013E-10_JPRB, &
  & 0.87961458E-10_JPRB, 0.88028362E-10_JPRB, 0.88079773E-10_JPRB, 0.88113752E-10_JPRB, 0.88130864E-10_JPRB, 0.88132959E-10_JPRB, &
  & 0.88121878E-10_JPRB, 0.88099139E-10_JPRB, 0.88066790E-10_JPRB, 0.88027849E-10_JPRB, 0.87986417E-10_JPRB, 0.87946768E-10_JPRB, &
  & 0.87912233E-10_JPRB, 0.87884325E-10_JPRB, 0.87862571E-10_JPRB, 0.87845772E-10_JPRB, 0.87832623E-10_JPRB, 0.87822090E-10_JPRB, &
  & 0.87813604E-10_JPRB, 0.87806706E-10_JPRB, 0.87800649E-10_JPRB, 0.87794751E-10_JPRB, 0.87788304E-10_JPRB, 0.87781046E-10_JPRB, &
  & 0.87773025E-10_JPRB, 0.87763567E-10_JPRB, 0.87753083E-10_JPRB, 0.87740926E-10_JPRB, 0.87728824E-10_JPRB, 0.87717875E-10_JPRB, &
  & 0.87709097E-10_JPRB, 0.87701013E-10_JPRB, 0.87692797E-10_JPRB, 0.87678725E-10_JPRB /)

RGHG9(:,65, 9) = (/ &
  & 0.87508181E-10_JPRB, 0.87525528E-10_JPRB, 0.87535125E-10_JPRB, 0.87543459E-10_JPRB, 0.87552049E-10_JPRB, 0.87561645E-10_JPRB, &
  & 0.87571631E-10_JPRB, 0.87581609E-10_JPRB, 0.87590685E-10_JPRB, 0.87600004E-10_JPRB, 0.87610419E-10_JPRB, 0.87622451E-10_JPRB, &
  & 0.87635878E-10_JPRB, 0.87646938E-10_JPRB, 0.87650741E-10_JPRB, 0.87643011E-10_JPRB, 0.87621285E-10_JPRB, 0.87585779E-10_JPRB, &
  & 0.87539857E-10_JPRB, 0.87490765E-10_JPRB, 0.87448951E-10_JPRB, 0.87425976E-10_JPRB, 0.87429841E-10_JPRB, 0.87462461E-10_JPRB, &
  & 0.87518513E-10_JPRB, 0.87589970E-10_JPRB, 0.87669670E-10_JPRB, 0.87752798E-10_JPRB, 0.87836523E-10_JPRB, 0.87917264E-10_JPRB, &
  & 0.87991198E-10_JPRB, 0.88053786E-10_JPRB, 0.88101353E-10_JPRB, 0.88132654E-10_JPRB, 0.88148384E-10_JPRB, 0.88150431E-10_JPRB, &
  & 0.88140460E-10_JPRB, 0.88119893E-10_JPRB, 0.88090445E-10_JPRB, 0.88054938E-10_JPRB, 0.88016816E-10_JPRB, 0.87980193E-10_JPRB, &
  & 0.87948024E-10_JPRB, 0.87921795E-10_JPRB, 0.87901200E-10_JPRB, 0.87885262E-10_JPRB, 0.87872716E-10_JPRB, 0.87862648E-10_JPRB, &
  & 0.87854501E-10_JPRB, 0.87847819E-10_JPRB, 0.87841949E-10_JPRB, 0.87836169E-10_JPRB, 0.87829855E-10_JPRB, 0.87822360E-10_JPRB, &
  & 0.87813486E-10_JPRB, 0.87803056E-10_JPRB, 0.87790622E-10_JPRB, 0.87776841E-10_JPRB, 0.87762506E-10_JPRB, 0.87749863E-10_JPRB, &
  & 0.87738643E-10_JPRB, 0.87728665E-10_JPRB, 0.87717174E-10_JPRB, 0.87698682E-10_JPRB /)

RGHG9(:,66, 9) = (/ &
  & 0.87558544E-10_JPRB, 0.87577473E-10_JPRB, 0.87587625E-10_JPRB, 0.87596291E-10_JPRB, 0.87605020E-10_JPRB, 0.87614464E-10_JPRB, &
  & 0.87624970E-10_JPRB, 0.87635205E-10_JPRB, 0.87646099E-10_JPRB, 0.87656937E-10_JPRB, 0.87669517E-10_JPRB, 0.87683812E-10_JPRB, &
  & 0.87698328E-10_JPRB, 0.87709465E-10_JPRB, 0.87713163E-10_JPRB, 0.87705794E-10_JPRB, 0.87685054E-10_JPRB, 0.87651171E-10_JPRB, &
  & 0.87607310E-10_JPRB, 0.87560181E-10_JPRB, 0.87519839E-10_JPRB, 0.87496996E-10_JPRB, 0.87498939E-10_JPRB, 0.87527631E-10_JPRB, &
  & 0.87578549E-10_JPRB, 0.87644517E-10_JPRB, 0.87718825E-10_JPRB, 0.87796957E-10_JPRB, 0.87875637E-10_JPRB, 0.87951403E-10_JPRB, &
  & 0.88020327E-10_JPRB, 0.88078156E-10_JPRB, 0.88121802E-10_JPRB, 0.88150265E-10_JPRB, 0.88164587E-10_JPRB, 0.88166544E-10_JPRB, &
  & 0.88157676E-10_JPRB, 0.88139253E-10_JPRB, 0.88112802E-10_JPRB, 0.88080709E-10_JPRB, 0.88046161E-10_JPRB, 0.88012611E-10_JPRB, &
  & 0.87982892E-10_JPRB, 0.87958391E-10_JPRB, 0.87938982E-10_JPRB, 0.87923863E-10_JPRB, 0.87911928E-10_JPRB, 0.87902310E-10_JPRB, &
  & 0.87894539E-10_JPRB, 0.87888134E-10_JPRB, 0.87882542E-10_JPRB, 0.87876949E-10_JPRB, 0.87870704E-10_JPRB, 0.87863133E-10_JPRB, &
  & 0.87853821E-10_JPRB, 0.87842462E-10_JPRB, 0.87829029E-10_JPRB, 0.87813867E-10_JPRB, 0.87798241E-10_JPRB, 0.87783412E-10_JPRB, &
  & 0.87770277E-10_JPRB, 0.87757163E-10_JPRB, 0.87742244E-10_JPRB, 0.87716397E-10_JPRB /)

RGHG9(:,67, 9) = (/ &
  & 0.87604757E-10_JPRB, 0.87626587E-10_JPRB, 0.87638230E-10_JPRB, 0.87647757E-10_JPRB, 0.87657090E-10_JPRB, 0.87666999E-10_JPRB, &
  & 0.87677532E-10_JPRB, 0.87689259E-10_JPRB, 0.87700652E-10_JPRB, 0.87713913E-10_JPRB, 0.87727922E-10_JPRB, 0.87743465E-10_JPRB, &
  & 0.87758266E-10_JPRB, 0.87769042E-10_JPRB, 0.87772740E-10_JPRB, 0.87765940E-10_JPRB, 0.87746498E-10_JPRB, 0.87714627E-10_JPRB, &
  & 0.87673237E-10_JPRB, 0.87628807E-10_JPRB, 0.87590490E-10_JPRB, 0.87568244E-10_JPRB, 0.87568827E-10_JPRB, 0.87594015E-10_JPRB, &
  & 0.87639888E-10_JPRB, 0.87700139E-10_JPRB, 0.87768841E-10_JPRB, 0.87841262E-10_JPRB, 0.87914419E-10_JPRB, 0.87984717E-10_JPRB, &
  & 0.88048208E-10_JPRB, 0.88101200E-10_JPRB, 0.88140766E-10_JPRB, 0.88166474E-10_JPRB, 0.88179394E-10_JPRB, 0.88181247E-10_JPRB, &
  & 0.88173420E-10_JPRB, 0.88157093E-10_JPRB, 0.88133577E-10_JPRB, 0.88104975E-10_JPRB, 0.88073958E-10_JPRB, 0.88043607E-10_JPRB, &
  & 0.88016518E-10_JPRB, 0.87993807E-10_JPRB, 0.87975689E-10_JPRB, 0.87961437E-10_JPRB, 0.87950106E-10_JPRB, 0.87941016E-10_JPRB, &
  & 0.87933626E-10_JPRB, 0.87927603E-10_JPRB, 0.87922329E-10_JPRB, 0.87917021E-10_JPRB, 0.87910942E-10_JPRB, 0.87903337E-10_JPRB, &
  & 0.87893796E-10_JPRB, 0.87881931E-10_JPRB, 0.87867782E-10_JPRB, 0.87851983E-10_JPRB, 0.87835239E-10_JPRB, 0.87819273E-10_JPRB, &
  & 0.87803743E-10_JPRB, 0.87788110E-10_JPRB, 0.87768258E-10_JPRB, 0.87734049E-10_JPRB /)

RGHG9(:,68, 9) = (/ &
  & 0.87647389E-10_JPRB, 0.87674014E-10_JPRB, 0.87687774E-10_JPRB, 0.87698765E-10_JPRB, 0.87709062E-10_JPRB, 0.87719547E-10_JPRB, &
  & 0.87730927E-10_JPRB, 0.87742737E-10_JPRB, 0.87756219E-10_JPRB, 0.87769889E-10_JPRB, 0.87785397E-10_JPRB, 0.87801072E-10_JPRB, &
  & 0.87815394E-10_JPRB, 0.87825795E-10_JPRB, 0.87829570E-10_JPRB, 0.87823471E-10_JPRB, 0.87805520E-10_JPRB, 0.87775946E-10_JPRB, &
  & 0.87737588E-10_JPRB, 0.87696239E-10_JPRB, 0.87660448E-10_JPRB, 0.87639306E-10_JPRB, 0.87638702E-10_JPRB, 0.87660643E-10_JPRB, &
  & 0.87701499E-10_JPRB, 0.87756094E-10_JPRB, 0.87818676E-10_JPRB, 0.87885199E-10_JPRB, 0.87952347E-10_JPRB, 0.88016774E-10_JPRB, &
  & 0.88074770E-10_JPRB, 0.88122724E-10_JPRB, 0.88158369E-10_JPRB, 0.88181358E-10_JPRB, 0.88192932E-10_JPRB, 0.88194681E-10_JPRB, &
  & 0.88187832E-10_JPRB, 0.88173482E-10_JPRB, 0.88152770E-10_JPRB, 0.88127491E-10_JPRB, 0.88100000E-10_JPRB, 0.88072931E-10_JPRB, &
  & 0.88048513E-10_JPRB, 0.88027842E-10_JPRB, 0.88011091E-10_JPRB, 0.87997762E-10_JPRB, 0.87987173E-10_JPRB, 0.87978590E-10_JPRB, &
  & 0.87971741E-10_JPRB, 0.87966141E-10_JPRB, 0.87961277E-10_JPRB, 0.87956323E-10_JPRB, 0.87950508E-10_JPRB, 0.87943056E-10_JPRB, &
  & 0.87933480E-10_JPRB, 0.87921434E-10_JPRB, 0.87907008E-10_JPRB, 0.87890827E-10_JPRB, 0.87873687E-10_JPRB, 0.87856694E-10_JPRB, &
  & 0.87839847E-10_JPRB, 0.87821778E-10_JPRB, 0.87797498E-10_JPRB, 0.87754699E-10_JPRB /)

RGHG9(:,69, 9) = (/ &
  & 0.87686781E-10_JPRB, 0.87720518E-10_JPRB, 0.87737227E-10_JPRB, 0.87750224E-10_JPRB, 0.87761687E-10_JPRB, 0.87773053E-10_JPRB, &
  & 0.87784717E-10_JPRB, 0.87797554E-10_JPRB, 0.87811078E-10_JPRB, 0.87825948E-10_JPRB, 0.87841269E-10_JPRB, 0.87856583E-10_JPRB, &
  & 0.87870163E-10_JPRB, 0.87879995E-10_JPRB, 0.87883818E-10_JPRB, 0.87878448E-10_JPRB, 0.87862169E-10_JPRB, 0.87835184E-10_JPRB, &
  & 0.87800135E-10_JPRB, 0.87762311E-10_JPRB, 0.87729442E-10_JPRB, 0.87709402E-10_JPRB, 0.87707945E-10_JPRB, 0.87726680E-10_JPRB, &
  & 0.87762769E-10_JPRB, 0.87811494E-10_JPRB, 0.87868053E-10_JPRB, 0.87928290E-10_JPRB, 0.87989289E-10_JPRB, 0.88047666E-10_JPRB, &
  & 0.88099972E-10_JPRB, 0.88142993E-10_JPRB, 0.88174759E-10_JPRB, 0.88195166E-10_JPRB, 0.88205443E-10_JPRB, 0.88207018E-10_JPRB, &
  & 0.88201092E-10_JPRB, 0.88188588E-10_JPRB, 0.88170492E-10_JPRB, 0.88148391E-10_JPRB, 0.88124244E-10_JPRB, 0.88100409E-10_JPRB, &
  & 0.88078780E-10_JPRB, 0.88060260E-10_JPRB, 0.88045043E-10_JPRB, 0.88032859E-10_JPRB, 0.88023054E-10_JPRB, 0.88015199E-10_JPRB, &
  & 0.88008933E-10_JPRB, 0.88003896E-10_JPRB, 0.87999504E-10_JPRB, 0.87994959E-10_JPRB, 0.87989518E-10_JPRB, 0.87982399E-10_JPRB, &
  & 0.87973004E-10_JPRB, 0.87961124E-10_JPRB, 0.87946803E-10_JPRB, 0.87930684E-10_JPRB, 0.87913385E-10_JPRB, 0.87896114E-10_JPRB, &
  & 0.87878274E-10_JPRB, 0.87858797E-10_JPRB, 0.87830770E-10_JPRB, 0.87779367E-10_JPRB /)

RGHG9(:,70, 9) = (/ &
  & 0.87724508E-10_JPRB, 0.87766835E-10_JPRB, 0.87787819E-10_JPRB, 0.87802765E-10_JPRB, 0.87815755E-10_JPRB, 0.87827627E-10_JPRB, &
  & 0.87839812E-10_JPRB, 0.87852732E-10_JPRB, 0.87866457E-10_JPRB, 0.87881036E-10_JPRB, 0.87895698E-10_JPRB, 0.87910131E-10_JPRB, &
  & 0.87922787E-10_JPRB, 0.87931940E-10_JPRB, 0.87935714E-10_JPRB, 0.87931017E-10_JPRB, 0.87916431E-10_JPRB, 0.87892214E-10_JPRB, &
  & 0.87860684E-10_JPRB, 0.87826642E-10_JPRB, 0.87796687E-10_JPRB, 0.87778139E-10_JPRB, 0.87775828E-10_JPRB, 0.87791649E-10_JPRB, &
  & 0.87822957E-10_JPRB, 0.87866041E-10_JPRB, 0.87916459E-10_JPRB, 0.87970436E-10_JPRB, 0.88025101E-10_JPRB, 0.88077316E-10_JPRB, &
  & 0.88123953E-10_JPRB, 0.88162096E-10_JPRB, 0.88190101E-10_JPRB, 0.88207996E-10_JPRB, 0.88217031E-10_JPRB, 0.88218446E-10_JPRB, &
  & 0.88213367E-10_JPRB, 0.88202549E-10_JPRB, 0.88186895E-10_JPRB, 0.88167744E-10_JPRB, 0.88146782E-10_JPRB, 0.88126048E-10_JPRB, &
  & 0.88107216E-10_JPRB, 0.88090930E-10_JPRB, 0.88077476E-10_JPRB, 0.88066554E-10_JPRB, 0.88057721E-10_JPRB, 0.88050706E-10_JPRB, &
  & 0.88045168E-10_JPRB, 0.88040755E-10_JPRB, 0.88036918E-10_JPRB, 0.88032859E-10_JPRB, 0.88027877E-10_JPRB, 0.88021278E-10_JPRB, &
  & 0.88012347E-10_JPRB, 0.88001072E-10_JPRB, 0.87987236E-10_JPRB, 0.87971651E-10_JPRB, 0.87954623E-10_JPRB, 0.87937518E-10_JPRB, &
  & 0.87919415E-10_JPRB, 0.87899514E-10_JPRB, 0.87869087E-10_JPRB, 0.87811869E-10_JPRB /)

RGHG9(:,71, 9) = (/ &
  & 0.87762811E-10_JPRB, 0.87815866E-10_JPRB, 0.87840062E-10_JPRB, 0.87857374E-10_JPRB, 0.87871127E-10_JPRB, 0.87883693E-10_JPRB, &
  & 0.87895885E-10_JPRB, 0.87908431E-10_JPRB, 0.87922045E-10_JPRB, 0.87934923E-10_JPRB, 0.87949065E-10_JPRB, 0.87961818E-10_JPRB, &
  & 0.87973122E-10_JPRB, 0.87981213E-10_JPRB, 0.87984932E-10_JPRB, 0.87981074E-10_JPRB, 0.87968258E-10_JPRB, 0.87946796E-10_JPRB, &
  & 0.87918950E-10_JPRB, 0.87888627E-10_JPRB, 0.87861919E-10_JPRB, 0.87844794E-10_JPRB, 0.87841970E-10_JPRB, 0.87855015E-10_JPRB, &
  & 0.87881834E-10_JPRB, 0.87919311E-10_JPRB, 0.87963734E-10_JPRB, 0.88011431E-10_JPRB, 0.88059789E-10_JPRB, 0.88105800E-10_JPRB, &
  & 0.88146816E-10_JPRB, 0.88180137E-10_JPRB, 0.88204534E-10_JPRB, 0.88219987E-10_JPRB, 0.88227828E-10_JPRB, 0.88229091E-10_JPRB, &
  & 0.88224747E-10_JPRB, 0.88215525E-10_JPRB, 0.88202112E-10_JPRB, 0.88185702E-10_JPRB, 0.88167709E-10_JPRB, 0.88149953E-10_JPRB, &
  & 0.88133757E-10_JPRB, 0.88119789E-10_JPRB, 0.88108160E-10_JPRB, 0.88098667E-10_JPRB, 0.88090993E-10_JPRB, 0.88084914E-10_JPRB, &
  & 0.88080189E-10_JPRB, 0.88076491E-10_JPRB, 0.88073250E-10_JPRB, 0.88069725E-10_JPRB, 0.88065361E-10_JPRB, 0.88059379E-10_JPRB, &
  & 0.88051288E-10_JPRB, 0.88040887E-10_JPRB, 0.88028078E-10_JPRB, 0.88013381E-10_JPRB, 0.87997221E-10_JPRB, 0.87980796E-10_JPRB, &
  & 0.87963165E-10_JPRB, 0.87943652E-10_JPRB, 0.87912899E-10_JPRB, 0.87852309E-10_JPRB /)

RGHG9(:,72, 9) = (/ &
  & 0.87806276E-10_JPRB, 0.87867699E-10_JPRB, 0.87895247E-10_JPRB, 0.87913524E-10_JPRB, 0.87928137E-10_JPRB, 0.87940530E-10_JPRB, &
  & 0.87952451E-10_JPRB, 0.87964823E-10_JPRB, 0.87976043E-10_JPRB, 0.87989158E-10_JPRB, 0.88000170E-10_JPRB, 0.88012313E-10_JPRB, &
  & 0.88022138E-10_JPRB, 0.88029223E-10_JPRB, 0.88032442E-10_JPRB, 0.88028869E-10_JPRB, 0.88017559E-10_JPRB, 0.87998900E-10_JPRB, &
  & 0.87974517E-10_JPRB, 0.87948156E-10_JPRB, 0.87924494E-10_JPRB, 0.87909208E-10_JPRB, 0.87906016E-10_JPRB, 0.87916577E-10_JPRB, &
  & 0.87939045E-10_JPRB, 0.87971096E-10_JPRB, 0.88009634E-10_JPRB, 0.88051136E-10_JPRB, 0.88093206E-10_JPRB, 0.88133063E-10_JPRB, &
  & 0.88168563E-10_JPRB, 0.88197213E-10_JPRB, 0.88218134E-10_JPRB, 0.88231256E-10_JPRB, 0.88237952E-10_JPRB, 0.88239048E-10_JPRB, &
  & 0.88235398E-10_JPRB, 0.88227606E-10_JPRB, 0.88216309E-10_JPRB, 0.88202404E-10_JPRB, 0.88187187E-10_JPRB, 0.88172192E-10_JPRB, &
  & 0.88158578E-10_JPRB, 0.88146782E-10_JPRB, 0.88136998E-10_JPRB, 0.88129004E-10_JPRB, 0.88122509E-10_JPRB, 0.88117492E-10_JPRB, &
  & 0.88113648E-10_JPRB, 0.88110699E-10_JPRB, 0.88108049E-10_JPRB, 0.88105107E-10_JPRB, 0.88101380E-10_JPRB, 0.88096239E-10_JPRB, &
  & 0.88089036E-10_JPRB, 0.88080120E-10_JPRB, 0.88068379E-10_JPRB, 0.88055369E-10_JPRB, 0.88040256E-10_JPRB, 0.88025316E-10_JPRB, &
  & 0.88008587E-10_JPRB, 0.87990504E-10_JPRB, 0.87960521E-10_JPRB, 0.87899771E-10_JPRB /)

RGHG9(:,73, 9) = (/ &
  & 0.87860816E-10_JPRB, 0.87924702E-10_JPRB, 0.87952499E-10_JPRB, 0.87971040E-10_JPRB, 0.87985168E-10_JPRB, 0.87997401E-10_JPRB, &
  & 0.88008691E-10_JPRB, 0.88019106E-10_JPRB, 0.88030673E-10_JPRB, 0.88039617E-10_JPRB, 0.88051275E-10_JPRB, 0.88060011E-10_JPRB, &
  & 0.88068199E-10_JPRB, 0.88073770E-10_JPRB, 0.88077101E-10_JPRB, 0.88074145E-10_JPRB, 0.88064341E-10_JPRB, 0.88047999E-10_JPRB, &
  & 0.88027322E-10_JPRB, 0.88004527E-10_JPRB, 0.87984328E-10_JPRB, 0.87970804E-10_JPRB, 0.87967529E-10_JPRB, 0.87975863E-10_JPRB, &
  & 0.87994306E-10_JPRB, 0.88021090E-10_JPRB, 0.88053863E-10_JPRB, 0.88089327E-10_JPRB, 0.88125118E-10_JPRB, 0.88159133E-10_JPRB, &
  & 0.88189095E-10_JPRB, 0.88213346E-10_JPRB, 0.88230916E-10_JPRB, 0.88241810E-10_JPRB, 0.88247437E-10_JPRB, 0.88248353E-10_JPRB, &
  & 0.88245335E-10_JPRB, 0.88238888E-10_JPRB, 0.88229535E-10_JPRB, 0.88217968E-10_JPRB, 0.88205332E-10_JPRB, 0.88192856E-10_JPRB, &
  & 0.88181643E-10_JPRB, 0.88171935E-10_JPRB, 0.88163907E-10_JPRB, 0.88157384E-10_JPRB, 0.88152083E-10_JPRB, 0.88148093E-10_JPRB, &
  & 0.88145102E-10_JPRB, 0.88142847E-10_JPRB, 0.88140807E-10_JPRB, 0.88138399E-10_JPRB, 0.88135381E-10_JPRB, 0.88130954E-10_JPRB, &
  & 0.88125104E-10_JPRB, 0.88117305E-10_JPRB, 0.88107535E-10_JPRB, 0.88095913E-10_JPRB, 0.88082812E-10_JPRB, 0.88069302E-10_JPRB, &
  & 0.88054487E-10_JPRB, 0.88037903E-10_JPRB, 0.88010509E-10_JPRB, 0.87951514E-10_JPRB /)

RGHG9(:,74, 9) = (/ &
  & 0.87919803E-10_JPRB, 0.87983419E-10_JPRB, 0.88010307E-10_JPRB, 0.88027634E-10_JPRB, 0.88041276E-10_JPRB, 0.88052281E-10_JPRB, &
  & 0.88062335E-10_JPRB, 0.88072327E-10_JPRB, 0.88080432E-10_JPRB, 0.88090382E-10_JPRB, 0.88097626E-10_JPRB, 0.88106585E-10_JPRB, &
  & 0.88113010E-10_JPRB, 0.88117465E-10_JPRB, 0.88119692E-10_JPRB, 0.88116764E-10_JPRB, 0.88108153E-10_JPRB, 0.88094317E-10_JPRB, &
  & 0.88076782E-10_JPRB, 0.88057880E-10_JPRB, 0.88040783E-10_JPRB, 0.88029341E-10_JPRB, 0.88026107E-10_JPRB, 0.88032498E-10_JPRB, &
  & 0.88047250E-10_JPRB, 0.88069059E-10_JPRB, 0.88096329E-10_JPRB, 0.88125784E-10_JPRB, 0.88155545E-10_JPRB, 0.88183835E-10_JPRB, &
  & 0.88208572E-10_JPRB, 0.88228473E-10_JPRB, 0.88242975E-10_JPRB, 0.88251739E-10_JPRB, 0.88256416E-10_JPRB, 0.88257159E-10_JPRB, &
  & 0.88254723E-10_JPRB, 0.88249456E-10_JPRB, 0.88241955E-10_JPRB, 0.88232519E-10_JPRB, 0.88222221E-10_JPRB, 0.88212090E-10_JPRB, &
  & 0.88203084E-10_JPRB, 0.88195312E-10_JPRB, 0.88188935E-10_JPRB, 0.88183780E-10_JPRB, 0.88179637E-10_JPRB, 0.88176556E-10_JPRB, &
  & 0.88174364E-10_JPRB, 0.88172726E-10_JPRB, 0.88171186E-10_JPRB, 0.88169277E-10_JPRB, 0.88166870E-10_JPRB, 0.88163324E-10_JPRB, &
  & 0.88158404E-10_JPRB, 0.88152305E-10_JPRB, 0.88143950E-10_JPRB, 0.88134569E-10_JPRB, 0.88123120E-10_JPRB, 0.88111879E-10_JPRB, &
  & 0.88098882E-10_JPRB, 0.88084692E-10_JPRB, 0.88059858E-10_JPRB, 0.88004756E-10_JPRB /)

RGHG9(:,75, 9) = (/ &
  & 0.87980734E-10_JPRB, 0.88041803E-10_JPRB, 0.88066415E-10_JPRB, 0.88082382E-10_JPRB, 0.88094247E-10_JPRB, 0.88104073E-10_JPRB, &
  & 0.88112878E-10_JPRB, 0.88120677E-10_JPRB, 0.88128893E-10_JPRB, 0.88134930E-10_JPRB, 0.88142819E-10_JPRB, 0.88148135E-10_JPRB, &
  & 0.88152652E-10_JPRB, 0.88155358E-10_JPRB, 0.88158481E-10_JPRB, 0.88156246E-10_JPRB, 0.88149030E-10_JPRB, 0.88137372E-10_JPRB, &
  & 0.88123300E-10_JPRB, 0.88107799E-10_JPRB, 0.88093977E-10_JPRB, 0.88084484E-10_JPRB, 0.88081473E-10_JPRB, 0.88086254E-10_JPRB, &
  & 0.88097710E-10_JPRB, 0.88114953E-10_JPRB, 0.88136831E-10_JPRB, 0.88160493E-10_JPRB, 0.88184411E-10_JPRB, 0.88207164E-10_JPRB, &
  & 0.88226891E-10_JPRB, 0.88242733E-10_JPRB, 0.88254321E-10_JPRB, 0.88261114E-10_JPRB, 0.88264861E-10_JPRB, 0.88265457E-10_JPRB, &
  & 0.88263542E-10_JPRB, 0.88259393E-10_JPRB, 0.88253599E-10_JPRB, 0.88246133E-10_JPRB, 0.88238063E-10_JPRB, 0.88230014E-10_JPRB, &
  & 0.88223082E-10_JPRB, 0.88217017E-10_JPRB, 0.88212215E-10_JPRB, 0.88208309E-10_JPRB, 0.88205158E-10_JPRB, 0.88202938E-10_JPRB, &
  & 0.88201405E-10_JPRB, 0.88200336E-10_JPRB, 0.88199226E-10_JPRB, 0.88197713E-10_JPRB, 0.88195895E-10_JPRB, 0.88193029E-10_JPRB, &
  & 0.88189220E-10_JPRB, 0.88184286E-10_JPRB, 0.88177854E-10_JPRB, 0.88170124E-10_JPRB, 0.88161048E-10_JPRB, 0.88151708E-10_JPRB, &
  & 0.88141230E-10_JPRB, 0.88129282E-10_JPRB, 0.88107806E-10_JPRB, 0.88057575E-10_JPRB /)

RGHG9(:,76, 9) = (/ &
  & 0.88042150E-10_JPRB, 0.88098404E-10_JPRB, 0.88120372E-10_JPRB, 0.88133702E-10_JPRB, 0.88144013E-10_JPRB, 0.88151812E-10_JPRB, &
  & 0.88159050E-10_JPRB, 0.88165933E-10_JPRB, 0.88171456E-10_JPRB, 0.88177562E-10_JPRB, 0.88182121E-10_JPRB, 0.88187124E-10_JPRB, &
  & 0.88190455E-10_JPRB, 0.88192495E-10_JPRB, 0.88194306E-10_JPRB, 0.88192426E-10_JPRB, 0.88186666E-10_JPRB, 0.88177327E-10_JPRB, &
  & 0.88166516E-10_JPRB, 0.88154505E-10_JPRB, 0.88143708E-10_JPRB, 0.88136158E-10_JPRB, 0.88133487E-10_JPRB, 0.88136963E-10_JPRB, &
  & 0.88145602E-10_JPRB, 0.88158550E-10_JPRB, 0.88175335E-10_JPRB, 0.88193369E-10_JPRB, 0.88211764E-10_JPRB, 0.88229035E-10_JPRB, &
  & 0.88244155E-10_JPRB, 0.88256166E-10_JPRB, 0.88265076E-10_JPRB, 0.88269982E-10_JPRB, 0.88272958E-10_JPRB, 0.88273416E-10_JPRB, &
  & 0.88271980E-10_JPRB, 0.88268809E-10_JPRB, 0.88264604E-10_JPRB, 0.88258970E-10_JPRB, 0.88252933E-10_JPRB, 0.88246827E-10_JPRB, &
  & 0.88241713E-10_JPRB, 0.88237279E-10_JPRB, 0.88233837E-10_JPRB, 0.88231034E-10_JPRB, 0.88228778E-10_JPRB, 0.88227231E-10_JPRB, &
  & 0.88226246E-10_JPRB, 0.88225607E-10_JPRB, 0.88224872E-10_JPRB, 0.88223699E-10_JPRB, 0.88222450E-10_JPRB, 0.88220223E-10_JPRB, &
  & 0.88217322E-10_JPRB, 0.88213666E-10_JPRB, 0.88208767E-10_JPRB, 0.88202959E-10_JPRB, 0.88195978E-10_JPRB, 0.88188845E-10_JPRB, &
  & 0.88180803E-10_JPRB, 0.88171366E-10_JPRB, 0.88153602E-10_JPRB, 0.88109048E-10_JPRB /)

RGHG9(:,77, 9) = (/ &
  & 0.88103254E-10_JPRB, 0.88152895E-10_JPRB, 0.88170853E-10_JPRB, 0.88181608E-10_JPRB, 0.88189546E-10_JPRB, 0.88195382E-10_JPRB, &
  & 0.88200829E-10_JPRB, 0.88205915E-10_JPRB, 0.88210529E-10_JPRB, 0.88213957E-10_JPRB, 0.88217995E-10_JPRB, 0.88220486E-10_JPRB, &
  & 0.88221541E-10_JPRB, 0.88221715E-10_JPRB, 0.88225573E-10_JPRB, 0.88224657E-10_JPRB, 0.88220480E-10_JPRB, 0.88213423E-10_JPRB, &
  & 0.88205929E-10_JPRB, 0.88197255E-10_JPRB, 0.88189359E-10_JPRB, 0.88183842E-10_JPRB, 0.88181636E-10_JPRB, 0.88184182E-10_JPRB, &
  & 0.88190386E-10_JPRB, 0.88199413E-10_JPRB, 0.88211355E-10_JPRB, 0.88224185E-10_JPRB, 0.88237237E-10_JPRB, 0.88249422E-10_JPRB, &
  & 0.88260205E-10_JPRB, 0.88268774E-10_JPRB, 0.88275207E-10_JPRB, 0.88278371E-10_JPRB, 0.88280633E-10_JPRB, 0.88280966E-10_JPRB, &
  & 0.88279974E-10_JPRB, 0.88277691E-10_JPRB, 0.88274957E-10_JPRB, 0.88270974E-10_JPRB, 0.88266824E-10_JPRB, 0.88262370E-10_JPRB, &
  & 0.88258970E-10_JPRB, 0.88255944E-10_JPRB, 0.88253689E-10_JPRB, 0.88251857E-10_JPRB, 0.88250234E-10_JPRB, 0.88249200E-10_JPRB, &
  & 0.88248617E-10_JPRB, 0.88248311E-10_JPRB, 0.88247867E-10_JPRB, 0.88246993E-10_JPRB, 0.88246292E-10_JPRB, 0.88244703E-10_JPRB, &
  & 0.88242601E-10_JPRB, 0.88240165E-10_JPRB, 0.88236730E-10_JPRB, 0.88232657E-10_JPRB, 0.88227786E-10_JPRB, 0.88222755E-10_JPRB, &
  & 0.88217197E-10_JPRB, 0.88210425E-10_JPRB, 0.88196138E-10_JPRB, 0.88159126E-10_JPRB /)

RGHG9(:,78, 9) = (/ &
  & 0.88164413E-10_JPRB, 0.88202383E-10_JPRB, 0.88215033E-10_JPRB, 0.88222554E-10_JPRB, 0.88228480E-10_JPRB, 0.88231977E-10_JPRB, &
  & 0.88235738E-10_JPRB, 0.88239395E-10_JPRB, 0.88242080E-10_JPRB, 0.88244363E-10_JPRB, 0.88246618E-10_JPRB, 0.88248200E-10_JPRB, &
  & 0.88248846E-10_JPRB, 0.88248839E-10_JPRB, 0.88251642E-10_JPRB, 0.88251219E-10_JPRB, 0.88248492E-10_JPRB, 0.88243468E-10_JPRB, &
  & 0.88239090E-10_JPRB, 0.88233434E-10_JPRB, 0.88228341E-10_JPRB, 0.88224768E-10_JPRB, 0.88223255E-10_JPRB, 0.88225191E-10_JPRB, &
  & 0.88229528E-10_JPRB, 0.88235134E-10_JPRB, 0.88242913E-10_JPRB, 0.88251288E-10_JPRB, 0.88259518E-10_JPRB, 0.88267366E-10_JPRB, &
  & 0.88274305E-10_JPRB, 0.88279946E-10_JPRB, 0.88284290E-10_JPRB, 0.88285913E-10_JPRB, 0.88287669E-10_JPRB, 0.88287939E-10_JPRB, &
  & 0.88287294E-10_JPRB, 0.88285684E-10_JPRB, 0.88284179E-10_JPRB, 0.88281604E-10_JPRB, 0.88279037E-10_JPRB, 0.88275984E-10_JPRB, &
  & 0.88273923E-10_JPRB, 0.88272015E-10_JPRB, 0.88270669E-10_JPRB, 0.88269538E-10_JPRB, 0.88268337E-10_JPRB, 0.88267574E-10_JPRB, &
  & 0.88267241E-10_JPRB, 0.88267144E-10_JPRB, 0.88266894E-10_JPRB, 0.88266242E-10_JPRB, 0.88266061E-10_JPRB, 0.88265006E-10_JPRB, &
  & 0.88263688E-10_JPRB, 0.88262279E-10_JPRB, 0.88260191E-10_JPRB, 0.88257568E-10_JPRB, 0.88254612E-10_JPRB, 0.88251371E-10_JPRB, &
  & 0.88248103E-10_JPRB, 0.88243683E-10_JPRB, 0.88234184E-10_JPRB, 0.88206706E-10_JPRB /)

RGHG9(:,79, 9) = (/ &
  & 0.88204354E-10_JPRB, 0.88230243E-10_JPRB, 0.88238535E-10_JPRB, 0.88243919E-10_JPRB, 0.88248769E-10_JPRB, 0.88250983E-10_JPRB, &
  & 0.88253772E-10_JPRB, 0.88256694E-10_JPRB, 0.88258553E-10_JPRB, 0.88259774E-10_JPRB, 0.88261592E-10_JPRB, 0.88262460E-10_JPRB, &
  & 0.88263022E-10_JPRB, 0.88262911E-10_JPRB, 0.88265277E-10_JPRB, 0.88265117E-10_JPRB, 0.88263161E-10_JPRB, 0.88259129E-10_JPRB, &
  & 0.88256527E-10_JPRB, 0.88252523E-10_JPRB, 0.88248915E-10_JPRB, 0.88246528E-10_JPRB, 0.88245383E-10_JPRB, 0.88247153E-10_JPRB, &
  & 0.88250574E-10_JPRB, 0.88254362E-10_JPRB, 0.88259969E-10_JPRB, 0.88265922E-10_JPRB, 0.88271578E-10_JPRB, 0.88277066E-10_JPRB, &
  & 0.88281944E-10_JPRB, 0.88285990E-10_JPRB, 0.88289265E-10_JPRB, 0.88289993E-10_JPRB, 0.88291520E-10_JPRB, 0.88291742E-10_JPRB, &
  & 0.88291298E-10_JPRB, 0.88289993E-10_JPRB, 0.88289161E-10_JPRB, 0.88287294E-10_JPRB, 0.88285552E-10_JPRB, 0.88283166E-10_JPRB, &
  & 0.88281812E-10_JPRB, 0.88280466E-10_JPRB, 0.88279571E-10_JPRB, 0.88278780E-10_JPRB, 0.88277725E-10_JPRB, 0.88277052E-10_JPRB, &
  & 0.88276851E-10_JPRB, 0.88276851E-10_JPRB, 0.88276671E-10_JPRB, 0.88276074E-10_JPRB, 0.88276227E-10_JPRB, 0.88275422E-10_JPRB, &
  & 0.88274429E-10_JPRB, 0.88273631E-10_JPRB, 0.88272195E-10_JPRB, 0.88270308E-10_JPRB, 0.88268282E-10_JPRB, 0.88265943E-10_JPRB, &
  & 0.88263924E-10_JPRB, 0.88261266E-10_JPRB, 0.88254980E-10_JPRB, 0.88236897E-10_JPRB /)

RGHG9(:,80, 9) = (/ &
  & 0.88231276E-10_JPRB, 0.88243690E-10_JPRB, 0.88248769E-10_JPRB, 0.88253134E-10_JPRB, 0.88257568E-10_JPRB, 0.88259150E-10_JPRB, &
  & 0.88261544E-10_JPRB, 0.88264174E-10_JPRB, 0.88265673E-10_JPRB, 0.88266505E-10_JPRB, 0.88268087E-10_JPRB, 0.88268698E-10_JPRB, &
  & 0.88269267E-10_JPRB, 0.88269128E-10_JPRB, 0.88271321E-10_JPRB, 0.88271349E-10_JPRB, 0.88269725E-10_JPRB, 0.88266103E-10_JPRB, &
  & 0.88264368E-10_JPRB, 0.88261093E-10_JPRB, 0.88258199E-10_JPRB, 0.88256298E-10_JPRB, 0.88255334E-10_JPRB, 0.88257048E-10_JPRB, &
  & 0.88260114E-10_JPRB, 0.88263077E-10_JPRB, 0.88267685E-10_JPRB, 0.88272598E-10_JPRB, 0.88277052E-10_JPRB, 0.88281514E-10_JPRB, &
  & 0.88285400E-10_JPRB, 0.88288744E-10_JPRB, 0.88291555E-10_JPRB, 0.88291832E-10_JPRB, 0.88293289E-10_JPRB, 0.88293504E-10_JPRB, &
  & 0.88293123E-10_JPRB, 0.88291922E-10_JPRB, 0.88291416E-10_JPRB, 0.88289875E-10_JPRB, 0.88288495E-10_JPRB, 0.88286378E-10_JPRB, &
  & 0.88285337E-10_JPRB, 0.88284234E-10_JPRB, 0.88283568E-10_JPRB, 0.88282923E-10_JPRB, 0.88281896E-10_JPRB, 0.88281257E-10_JPRB, &
  & 0.88281105E-10_JPRB, 0.88281146E-10_JPRB, 0.88281014E-10_JPRB, 0.88280341E-10_JPRB, 0.88280640E-10_JPRB, 0.88279870E-10_JPRB, &
  & 0.88279009E-10_JPRB, 0.88278454E-10_JPRB, 0.88277309E-10_JPRB, 0.88275685E-10_JPRB, 0.88274103E-10_JPRB, 0.88272119E-10_JPRB, &
  & 0.88270724E-10_JPRB, 0.88268885E-10_JPRB, 0.88264958E-10_JPRB, 0.88256541E-10_JPRB /)

RGHG9(:,81, 9) = (/ &
  & 0.88250053E-10_JPRB, 0.88249338E-10_JPRB, 0.88253072E-10_JPRB, 0.88256999E-10_JPRB, 0.88261357E-10_JPRB, 0.88262640E-10_JPRB, &
  & 0.88264854E-10_JPRB, 0.88267477E-10_JPRB, 0.88268684E-10_JPRB, 0.88269468E-10_JPRB, 0.88270849E-10_JPRB, 0.88271411E-10_JPRB, &
  & 0.88271987E-10_JPRB, 0.88271834E-10_JPRB, 0.88273958E-10_JPRB, 0.88274103E-10_JPRB, 0.88272660E-10_JPRB, 0.88269128E-10_JPRB, &
  & 0.88267865E-10_JPRB, 0.88264909E-10_JPRB, 0.88262300E-10_JPRB, 0.88260628E-10_JPRB, 0.88259691E-10_JPRB, 0.88261412E-10_JPRB, &
  & 0.88264313E-10_JPRB, 0.88266922E-10_JPRB, 0.88271113E-10_JPRB, 0.88275554E-10_JPRB, 0.88279495E-10_JPRB, 0.88283450E-10_JPRB, &
  & 0.88286933E-10_JPRB, 0.88289959E-10_JPRB, 0.88292568E-10_JPRB, 0.88292616E-10_JPRB, 0.88294060E-10_JPRB, 0.88294289E-10_JPRB, &
  & 0.88293942E-10_JPRB, 0.88292790E-10_JPRB, 0.88292401E-10_JPRB, 0.88291013E-10_JPRB, 0.88289764E-10_JPRB, 0.88287787E-10_JPRB, &
  & 0.88286871E-10_JPRB, 0.88285879E-10_JPRB, 0.88285303E-10_JPRB, 0.88284748E-10_JPRB, 0.88283741E-10_JPRB, 0.88283082E-10_JPRB, &
  & 0.88282978E-10_JPRB, 0.88283020E-10_JPRB, 0.88282909E-10_JPRB, 0.88282187E-10_JPRB, 0.88282555E-10_JPRB, 0.88281778E-10_JPRB, &
  & 0.88280966E-10_JPRB, 0.88280508E-10_JPRB, 0.88279467E-10_JPRB, 0.88277961E-10_JPRB, 0.88276553E-10_JPRB, 0.88274721E-10_JPRB, &
  & 0.88273569E-10_JPRB, 0.88272119E-10_JPRB, 0.88269142E-10_JPRB, 0.88269933E-10_JPRB /)

RGHG9(:,82, 9) = (/ &
  & 0.88251566E-10_JPRB, 0.88251184E-10_JPRB, 0.88254917E-10_JPRB, 0.88258852E-10_JPRB, 0.88263175E-10_JPRB, 0.88264340E-10_JPRB, &
  & 0.88266588E-10_JPRB, 0.88268892E-10_JPRB, 0.88270238E-10_JPRB, 0.88270766E-10_JPRB, 0.88272271E-10_JPRB, 0.88272695E-10_JPRB, &
  & 0.88273305E-10_JPRB, 0.88273146E-10_JPRB, 0.88275262E-10_JPRB, 0.88275470E-10_JPRB, 0.88274096E-10_JPRB, 0.88270620E-10_JPRB, &
  & 0.88269607E-10_JPRB, 0.88266797E-10_JPRB, 0.88264326E-10_JPRB, 0.88262751E-10_JPRB, 0.88261815E-10_JPRB, 0.88263521E-10_JPRB, &
  & 0.88266380E-10_JPRB, 0.88268795E-10_JPRB, 0.88272806E-10_JPRB, 0.88277011E-10_JPRB, 0.88280674E-10_JPRB, 0.88284421E-10_JPRB, &
  & 0.88287662E-10_JPRB, 0.88290535E-10_JPRB, 0.88293067E-10_JPRB, 0.88293026E-10_JPRB, 0.88294462E-10_JPRB, 0.88294677E-10_JPRB, &
  & 0.88294330E-10_JPRB, 0.88293206E-10_JPRB, 0.88292901E-10_JPRB, 0.88291569E-10_JPRB, 0.88290403E-10_JPRB, 0.88288488E-10_JPRB, &
  & 0.88287641E-10_JPRB, 0.88286690E-10_JPRB, 0.88286191E-10_JPRB, 0.88285657E-10_JPRB, 0.88284650E-10_JPRB, 0.88283998E-10_JPRB, &
  & 0.88283887E-10_JPRB, 0.88283957E-10_JPRB, 0.88283852E-10_JPRB, 0.88283082E-10_JPRB, 0.88283499E-10_JPRB, 0.88282708E-10_JPRB, &
  & 0.88281896E-10_JPRB, 0.88281493E-10_JPRB, 0.88280494E-10_JPRB, 0.88279037E-10_JPRB, 0.88277732E-10_JPRB, 0.88275963E-10_JPRB, &
  & 0.88274936E-10_JPRB, 0.88273520E-10_JPRB, 0.88270495E-10_JPRB, 0.88270981E-10_JPRB /)

RGHG9(:,83, 9) = (/ &
  & 0.88252620E-10_JPRB, 0.88252232E-10_JPRB, 0.88255972E-10_JPRB, 0.88259851E-10_JPRB, 0.88264215E-10_JPRB, 0.88265346E-10_JPRB, &
  & 0.88267380E-10_JPRB, 0.88269989E-10_JPRB, 0.88270939E-10_JPRB, 0.88271758E-10_JPRB, 0.88272854E-10_JPRB, 0.88273437E-10_JPRB, &
  & 0.88273999E-10_JPRB, 0.88273909E-10_JPRB, 0.88275970E-10_JPRB, 0.88276254E-10_JPRB, 0.88274915E-10_JPRB, 0.88271467E-10_JPRB, &
  & 0.88270606E-10_JPRB, 0.88267886E-10_JPRB, 0.88265444E-10_JPRB, 0.88263938E-10_JPRB, 0.88262966E-10_JPRB, 0.88264743E-10_JPRB, &
  & 0.88267546E-10_JPRB, 0.88269878E-10_JPRB, 0.88273777E-10_JPRB, 0.88277836E-10_JPRB, 0.88281382E-10_JPRB, 0.88284921E-10_JPRB, &
  & 0.88288071E-10_JPRB, 0.88290861E-10_JPRB, 0.88293338E-10_JPRB, 0.88293248E-10_JPRB, 0.88294670E-10_JPRB, 0.88294906E-10_JPRB, &
  & 0.88294538E-10_JPRB, 0.88293442E-10_JPRB, 0.88293158E-10_JPRB, 0.88291902E-10_JPRB, 0.88290764E-10_JPRB, 0.88288890E-10_JPRB, &
  & 0.88288064E-10_JPRB, 0.88287155E-10_JPRB, 0.88286690E-10_JPRB, 0.88286184E-10_JPRB, 0.88285143E-10_JPRB, 0.88284512E-10_JPRB, &
  & 0.88284428E-10_JPRB, 0.88284477E-10_JPRB, 0.88284366E-10_JPRB, 0.88283575E-10_JPRB, 0.88284019E-10_JPRB, 0.88283207E-10_JPRB, &
  & 0.88282395E-10_JPRB, 0.88282028E-10_JPRB, 0.88281049E-10_JPRB, 0.88279641E-10_JPRB, 0.88278364E-10_JPRB, 0.88276657E-10_JPRB, &
  & 0.88275692E-10_JPRB, 0.88274332E-10_JPRB, 0.88271314E-10_JPRB, 0.88271737E-10_JPRB /)

RGHG9(:,84, 9) = (/ &
  & 0.88253356E-10_JPRB, 0.88252947E-10_JPRB, 0.88256569E-10_JPRB, 0.88260496E-10_JPRB, 0.88264888E-10_JPRB, 0.88265922E-10_JPRB, &
  & 0.88268240E-10_JPRB, 0.88270259E-10_JPRB, 0.88271571E-10_JPRB, 0.88272084E-10_JPRB, 0.88273402E-10_JPRB, 0.88273833E-10_JPRB, &
  & 0.88274422E-10_JPRB, 0.88274450E-10_JPRB, 0.88276324E-10_JPRB, 0.88276698E-10_JPRB, 0.88275422E-10_JPRB, 0.88272001E-10_JPRB, &
  & 0.88271231E-10_JPRB, 0.88268545E-10_JPRB, 0.88266144E-10_JPRB, 0.88264673E-10_JPRB, 0.88263660E-10_JPRB, 0.88265423E-10_JPRB, &
  & 0.88268302E-10_JPRB, 0.88270516E-10_JPRB, 0.88274367E-10_JPRB, 0.88278405E-10_JPRB, 0.88281757E-10_JPRB, 0.88285282E-10_JPRB, &
  & 0.88288293E-10_JPRB, 0.88291055E-10_JPRB, 0.88293491E-10_JPRB, 0.88293352E-10_JPRB, 0.88294816E-10_JPRB, 0.88295038E-10_JPRB, &
  & 0.88294677E-10_JPRB, 0.88293574E-10_JPRB, 0.88293317E-10_JPRB, 0.88292096E-10_JPRB, 0.88290979E-10_JPRB, 0.88289112E-10_JPRB, &
  & 0.88288335E-10_JPRB, 0.88287412E-10_JPRB, 0.88286989E-10_JPRB, 0.88286503E-10_JPRB, 0.88285435E-10_JPRB, 0.88284824E-10_JPRB, &
  & 0.88284734E-10_JPRB, 0.88284817E-10_JPRB, 0.88284692E-10_JPRB, 0.88283887E-10_JPRB, 0.88284359E-10_JPRB, 0.88283519E-10_JPRB, &
  & 0.88282701E-10_JPRB, 0.88282368E-10_JPRB, 0.88281403E-10_JPRB, 0.88279981E-10_JPRB, 0.88278773E-10_JPRB, 0.88277038E-10_JPRB, &
  & 0.88276178E-10_JPRB, 0.88274839E-10_JPRB, 0.88271841E-10_JPRB, 0.88272251E-10_JPRB /)

RGHG9(:,85, 9) = (/ &
  & 0.88253856E-10_JPRB, 0.88253356E-10_JPRB, 0.88256992E-10_JPRB, 0.88260899E-10_JPRB, 0.88265319E-10_JPRB, 0.88266561E-10_JPRB, &
  & 0.88268434E-10_JPRB, 0.88270946E-10_JPRB, 0.88271793E-10_JPRB, 0.88272639E-10_JPRB, 0.88273513E-10_JPRB, 0.88274110E-10_JPRB, &
  & 0.88274651E-10_JPRB, 0.88274901E-10_JPRB, 0.88276407E-10_JPRB, 0.88276816E-10_JPRB, 0.88275671E-10_JPRB, 0.88272473E-10_JPRB, &
  & 0.88271654E-10_JPRB, 0.88268996E-10_JPRB, 0.88266637E-10_JPRB, 0.88265145E-10_JPRB, 0.88264084E-10_JPRB, 0.88265922E-10_JPRB, &
  & 0.88268740E-10_JPRB, 0.88270918E-10_JPRB, 0.88274790E-10_JPRB, 0.88278676E-10_JPRB, 0.88282104E-10_JPRB, 0.88285441E-10_JPRB, &
  & 0.88288495E-10_JPRB, 0.88291180E-10_JPRB, 0.88293615E-10_JPRB, 0.88293449E-10_JPRB, 0.88294899E-10_JPRB, 0.88295135E-10_JPRB, &
  & 0.88294767E-10_JPRB, 0.88293657E-10_JPRB, 0.88293428E-10_JPRB, 0.88292221E-10_JPRB, 0.88291117E-10_JPRB, 0.88289293E-10_JPRB, &
  & 0.88288502E-10_JPRB, 0.88287613E-10_JPRB, 0.88287190E-10_JPRB, 0.88286725E-10_JPRB, 0.88285636E-10_JPRB, 0.88285025E-10_JPRB, &
  & 0.88284935E-10_JPRB, 0.88285039E-10_JPRB, 0.88284907E-10_JPRB, 0.88284081E-10_JPRB, 0.88284567E-10_JPRB, 0.88283714E-10_JPRB, &
  & 0.88282895E-10_JPRB, 0.88282610E-10_JPRB, 0.88281632E-10_JPRB, 0.88280237E-10_JPRB, 0.88279009E-10_JPRB, 0.88277351E-10_JPRB, &
  & 0.88276476E-10_JPRB, 0.88275200E-10_JPRB, 0.88272181E-10_JPRB, 0.88272598E-10_JPRB /)

RGHG9(:,86, 9) = (/ &
  & 0.88254203E-10_JPRB, 0.88253647E-10_JPRB, 0.88257207E-10_JPRB, 0.88261162E-10_JPRB, 0.88265763E-10_JPRB, 0.88266831E-10_JPRB, &
  & 0.88269392E-10_JPRB, 0.88270918E-10_JPRB, 0.88272174E-10_JPRB, 0.88272792E-10_JPRB, 0.88273708E-10_JPRB, 0.88274235E-10_JPRB, &
  & 0.88274783E-10_JPRB, 0.88275179E-10_JPRB, 0.88276289E-10_JPRB, 0.88276657E-10_JPRB, 0.88275706E-10_JPRB, 0.88272910E-10_JPRB, &
  & 0.88271911E-10_JPRB, 0.88269357E-10_JPRB, 0.88266942E-10_JPRB, 0.88265471E-10_JPRB, 0.88264340E-10_JPRB, 0.88266131E-10_JPRB, &
  & 0.88269059E-10_JPRB, 0.88271127E-10_JPRB, 0.88274950E-10_JPRB, 0.88278988E-10_JPRB, 0.88282215E-10_JPRB, 0.88285677E-10_JPRB, &
  & 0.88288599E-10_JPRB, 0.88291319E-10_JPRB, 0.88293720E-10_JPRB, 0.88293498E-10_JPRB, 0.88294989E-10_JPRB, 0.88295211E-10_JPRB, &
  & 0.88294837E-10_JPRB, 0.88293720E-10_JPRB, 0.88293532E-10_JPRB, 0.88292325E-10_JPRB, 0.88291215E-10_JPRB, 0.88289334E-10_JPRB, &
  & 0.88288606E-10_JPRB, 0.88287704E-10_JPRB, 0.88287329E-10_JPRB, 0.88286864E-10_JPRB, 0.88285775E-10_JPRB, 0.88285150E-10_JPRB, &
  & 0.88285067E-10_JPRB, 0.88285164E-10_JPRB, 0.88285039E-10_JPRB, 0.88284192E-10_JPRB, 0.88284706E-10_JPRB, 0.88283839E-10_JPRB, &
  & 0.88283020E-10_JPRB, 0.88282749E-10_JPRB, 0.88281771E-10_JPRB, 0.88280362E-10_JPRB, 0.88279190E-10_JPRB, 0.88277448E-10_JPRB, &
  & 0.88276692E-10_JPRB, 0.88275408E-10_JPRB, 0.88272403E-10_JPRB, 0.88272827E-10_JPRB /)

RGHG9(:,87, 9) = (/ &
  & 0.88254397E-10_JPRB, 0.88253765E-10_JPRB, 0.88257401E-10_JPRB, 0.88261523E-10_JPRB, 0.88265832E-10_JPRB, 0.88267615E-10_JPRB, &
  & 0.88269225E-10_JPRB, 0.88271460E-10_JPRB, 0.88272251E-10_JPRB, 0.88273042E-10_JPRB, 0.88273749E-10_JPRB, 0.88274305E-10_JPRB, &
  & 0.88274832E-10_JPRB, 0.88275248E-10_JPRB, 0.88276164E-10_JPRB, 0.88276469E-10_JPRB, 0.88275651E-10_JPRB, 0.88273222E-10_JPRB, &
  & 0.88272147E-10_JPRB, 0.88269565E-10_JPRB, 0.88267178E-10_JPRB, 0.88265638E-10_JPRB, 0.88264465E-10_JPRB, 0.88266297E-10_JPRB, &
  & 0.88269184E-10_JPRB, 0.88271168E-10_JPRB, 0.88275130E-10_JPRB, 0.88279037E-10_JPRB, 0.88282423E-10_JPRB, 0.88285733E-10_JPRB, &
  & 0.88288737E-10_JPRB, 0.88291409E-10_JPRB, 0.88293803E-10_JPRB, 0.88293518E-10_JPRB, 0.88295031E-10_JPRB, 0.88295274E-10_JPRB, &
  & 0.88294906E-10_JPRB, 0.88293726E-10_JPRB, 0.88293622E-10_JPRB, 0.88292394E-10_JPRB, 0.88291298E-10_JPRB, 0.88289334E-10_JPRB, &
  & 0.88288640E-10_JPRB, 0.88287773E-10_JPRB, 0.88287391E-10_JPRB, 0.88286975E-10_JPRB, 0.88285851E-10_JPRB, 0.88285233E-10_JPRB, &
  & 0.88285157E-10_JPRB, 0.88285254E-10_JPRB, 0.88285143E-10_JPRB, 0.88284255E-10_JPRB, 0.88284796E-10_JPRB, 0.88283915E-10_JPRB, &
  & 0.88283096E-10_JPRB, 0.88282812E-10_JPRB, 0.88281868E-10_JPRB, 0.88280480E-10_JPRB, 0.88279273E-10_JPRB, 0.88277559E-10_JPRB, &
  & 0.88276803E-10_JPRB, 0.88275554E-10_JPRB, 0.88272507E-10_JPRB, 0.88272972E-10_JPRB /)

RGHG9(:,88, 9) = (/ &
  & 0.88254556E-10_JPRB, 0.88253960E-10_JPRB, 0.88257457E-10_JPRB, 0.88261440E-10_JPRB, 0.88266255E-10_JPRB, 0.88267359E-10_JPRB, &
  & 0.88269968E-10_JPRB, 0.88271307E-10_JPRB, 0.88272459E-10_JPRB, 0.88273083E-10_JPRB, 0.88273847E-10_JPRB, 0.88274367E-10_JPRB, &
  & 0.88274887E-10_JPRB, 0.88275318E-10_JPRB, 0.88276143E-10_JPRB, 0.88276442E-10_JPRB, 0.88275671E-10_JPRB, 0.88273354E-10_JPRB, &
  & 0.88272237E-10_JPRB, 0.88269753E-10_JPRB, 0.88267282E-10_JPRB, 0.88265784E-10_JPRB, 0.88264535E-10_JPRB, 0.88266366E-10_JPRB, &
  & 0.88269302E-10_JPRB, 0.88271182E-10_JPRB, 0.88275123E-10_JPRB, 0.88279190E-10_JPRB, 0.88282430E-10_JPRB, 0.88285865E-10_JPRB, &
  & 0.88288793E-10_JPRB, 0.88291499E-10_JPRB, 0.88293886E-10_JPRB, 0.88293525E-10_JPRB, 0.88295093E-10_JPRB, 0.88295322E-10_JPRB, &
  & 0.88294955E-10_JPRB, 0.88293733E-10_JPRB, 0.88293713E-10_JPRB, 0.88292471E-10_JPRB, 0.88291381E-10_JPRB, 0.88289293E-10_JPRB, &
  & 0.88288682E-10_JPRB, 0.88287766E-10_JPRB, 0.88287433E-10_JPRB, 0.88287030E-10_JPRB, 0.88285906E-10_JPRB, 0.88285275E-10_JPRB, &
  & 0.88285206E-10_JPRB, 0.88285310E-10_JPRB, 0.88285206E-10_JPRB, 0.88284283E-10_JPRB, 0.88284845E-10_JPRB, 0.88283970E-10_JPRB, &
  & 0.88283138E-10_JPRB, 0.88282860E-10_JPRB, 0.88281910E-10_JPRB, 0.88280522E-10_JPRB, 0.88279342E-10_JPRB, 0.88277580E-10_JPRB, &
  & 0.88276879E-10_JPRB, 0.88275644E-10_JPRB, 0.88272584E-10_JPRB, 0.88273042E-10_JPRB /)

RGHG9(:,89, 9) = (/ &
  & 0.88254626E-10_JPRB, 0.88254154E-10_JPRB, 0.88257540E-10_JPRB, 0.88261551E-10_JPRB, 0.88265978E-10_JPRB, 0.88267685E-10_JPRB, &
  & 0.88269315E-10_JPRB, 0.88271543E-10_JPRB, 0.88272348E-10_JPRB, 0.88273125E-10_JPRB, 0.88273867E-10_JPRB, 0.88274402E-10_JPRB, &
  & 0.88274929E-10_JPRB, 0.88275345E-10_JPRB, 0.88276275E-10_JPRB, 0.88276594E-10_JPRB, 0.88275776E-10_JPRB, 0.88273312E-10_JPRB, &
  & 0.88272306E-10_JPRB, 0.88269718E-10_JPRB, 0.88267338E-10_JPRB, 0.88265804E-10_JPRB, 0.88264548E-10_JPRB, 0.88266387E-10_JPRB, &
  & 0.88269336E-10_JPRB, 0.88271154E-10_JPRB, 0.88275172E-10_JPRB, 0.88279196E-10_JPRB, 0.88282492E-10_JPRB, 0.88285872E-10_JPRB, &
  & 0.88288869E-10_JPRB, 0.88291548E-10_JPRB, 0.88293983E-10_JPRB, 0.88293511E-10_JPRB, 0.88295135E-10_JPRB, 0.88295378E-10_JPRB, &
  & 0.88294996E-10_JPRB, 0.88293720E-10_JPRB, 0.88293789E-10_JPRB, 0.88292477E-10_JPRB, 0.88291430E-10_JPRB, 0.88289237E-10_JPRB, &
  & 0.88288696E-10_JPRB, 0.88287794E-10_JPRB, 0.88287481E-10_JPRB, 0.88287072E-10_JPRB, 0.88285920E-10_JPRB, 0.88285310E-10_JPRB, &
  & 0.88285226E-10_JPRB, 0.88285358E-10_JPRB, 0.88285254E-10_JPRB, 0.88284297E-10_JPRB, 0.88284893E-10_JPRB, 0.88284019E-10_JPRB, &
  & 0.88283166E-10_JPRB, 0.88282902E-10_JPRB, 0.88281930E-10_JPRB, 0.88280543E-10_JPRB, 0.88279370E-10_JPRB, 0.88277594E-10_JPRB, &
  & 0.88276914E-10_JPRB, 0.88275692E-10_JPRB, 0.88272591E-10_JPRB, 0.88273097E-10_JPRB /)

RGHG9(:,90, 9) = (/ &
  & 0.88254674E-10_JPRB, 0.88254376E-10_JPRB, 0.88257304E-10_JPRB, 0.88261301E-10_JPRB, 0.88266117E-10_JPRB, 0.88266963E-10_JPRB, &
  & 0.88269531E-10_JPRB, 0.88271224E-10_JPRB, 0.88272389E-10_JPRB, 0.88273042E-10_JPRB, 0.88273965E-10_JPRB, 0.88274478E-10_JPRB, &
  & 0.88275026E-10_JPRB, 0.88275394E-10_JPRB, 0.88276608E-10_JPRB, 0.88277025E-10_JPRB, 0.88276053E-10_JPRB, 0.88273062E-10_JPRB, &
  & 0.88272306E-10_JPRB, 0.88269683E-10_JPRB, 0.88267289E-10_JPRB, 0.88265846E-10_JPRB, 0.88264486E-10_JPRB, 0.88266394E-10_JPRB, &
  & 0.88269392E-10_JPRB, 0.88271120E-10_JPRB, 0.88275179E-10_JPRB, 0.88279245E-10_JPRB, 0.88282472E-10_JPRB, 0.88285913E-10_JPRB, &
  & 0.88288897E-10_JPRB, 0.88291596E-10_JPRB, 0.88294122E-10_JPRB, 0.88293463E-10_JPRB, 0.88295218E-10_JPRB, 0.88295427E-10_JPRB, &
  & 0.88295073E-10_JPRB, 0.88293699E-10_JPRB, 0.88293872E-10_JPRB, 0.88292498E-10_JPRB, 0.88291485E-10_JPRB, 0.88289175E-10_JPRB, &
  & 0.88288703E-10_JPRB, 0.88287773E-10_JPRB, 0.88287488E-10_JPRB, 0.88287107E-10_JPRB, 0.88285934E-10_JPRB, 0.88285317E-10_JPRB, &
  & 0.88285240E-10_JPRB, 0.88285379E-10_JPRB, 0.88285296E-10_JPRB, 0.88284269E-10_JPRB, 0.88284935E-10_JPRB, 0.88284012E-10_JPRB, &
  & 0.88283152E-10_JPRB, 0.88282930E-10_JPRB, 0.88281965E-10_JPRB, 0.88280550E-10_JPRB, 0.88279377E-10_JPRB, 0.88277566E-10_JPRB, &
  & 0.88276934E-10_JPRB, 0.88275713E-10_JPRB, 0.88272521E-10_JPRB, 0.88273139E-10_JPRB /)

RGHG9(:,91, 9) = (/ &
  & 0.88254716E-10_JPRB, 0.88254432E-10_JPRB, 0.88256638E-10_JPRB, 0.88261218E-10_JPRB, 0.88266332E-10_JPRB, 0.88266568E-10_JPRB, &
  & 0.88268629E-10_JPRB, 0.88271467E-10_JPRB, 0.88272313E-10_JPRB, 0.88272625E-10_JPRB, 0.88274346E-10_JPRB, 0.88274436E-10_JPRB, &
  & 0.88275248E-10_JPRB, 0.88274658E-10_JPRB, 0.88277420E-10_JPRB, 0.88277843E-10_JPRB, 0.88276587E-10_JPRB, 0.88272334E-10_JPRB, &
  & 0.88272493E-10_JPRB, 0.88269572E-10_JPRB, 0.88267192E-10_JPRB, 0.88265818E-10_JPRB, 0.88264271E-10_JPRB, 0.88266304E-10_JPRB, &
  & 0.88269475E-10_JPRB, 0.88270960E-10_JPRB, 0.88275172E-10_JPRB, 0.88279280E-10_JPRB, 0.88282423E-10_JPRB, 0.88285892E-10_JPRB, &
  & 0.88288946E-10_JPRB, 0.88291596E-10_JPRB, 0.88294469E-10_JPRB, 0.88293241E-10_JPRB, 0.88295357E-10_JPRB, 0.88295496E-10_JPRB, &
  & 0.88295149E-10_JPRB, 0.88293574E-10_JPRB, 0.88293983E-10_JPRB, 0.88292484E-10_JPRB, 0.88291582E-10_JPRB, 0.88289029E-10_JPRB, &
  & 0.88288737E-10_JPRB, 0.88287738E-10_JPRB, 0.88287516E-10_JPRB, 0.88287162E-10_JPRB, 0.88285879E-10_JPRB, 0.88285268E-10_JPRB, &
  & 0.88285226E-10_JPRB, 0.88285400E-10_JPRB, 0.88285358E-10_JPRB, 0.88284158E-10_JPRB, 0.88285046E-10_JPRB, 0.88283998E-10_JPRB, &
  & 0.88283124E-10_JPRB, 0.88282978E-10_JPRB, 0.88282007E-10_JPRB, 0.88280529E-10_JPRB, 0.88279405E-10_JPRB, 0.88277476E-10_JPRB, &
  & 0.88276969E-10_JPRB, 0.88275762E-10_JPRB, 0.88272320E-10_JPRB, 0.88273146E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART18',1,ZHOOK_HANDLE)
END SUBROUTINE PART18






SUBROUTINE PART19
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART19',0,ZHOOK_HANDLE)



!-- Month= 10 ------------

RGHG9(:, 1,10) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.42038954E-44_JPRB, &
  & 0.56051939E-44_JPRB, 0.84077908E-44_JPRB, 0.84077908E-44_JPRB, 0.98090893E-44_JPRB, 0.98090893E-44_JPRB, 0.98090893E-44_JPRB, &
  & 0.98090893E-44_JPRB, 0.84077908E-44_JPRB, 0.84077908E-44_JPRB, 0.84077908E-44_JPRB, 0.84077908E-44_JPRB, 0.84077908E-44_JPRB, &
  & 0.70064923E-44_JPRB, 0.70064923E-44_JPRB, 0.56051939E-44_JPRB, 0.42038954E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 2,10) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, &
  & 0.84077908E-44_JPRB, 0.18216880E-43_JPRB, 0.29427268E-43_JPRB, 0.49045446E-43_JPRB, 0.82676609E-43_JPRB, 0.14153114E-42_JPRB, &
  & 0.22140516E-42_JPRB, 0.29987787E-42_JPRB, 0.33911423E-42_JPRB, 0.38815967E-42_JPRB, 0.39937006E-42_JPRB, 0.39376487E-42_JPRB, &
  & 0.37835059E-42_JPRB, 0.34892332E-42_JPRB, 0.33911423E-42_JPRB, 0.33350903E-42_JPRB, 0.31809475E-42_JPRB, 0.31108826E-42_JPRB, &
  & 0.29147008E-42_JPRB, 0.24943113E-42_JPRB, 0.19758308E-42_JPRB, 0.14293244E-42_JPRB, 0.95288296E-43_JPRB, 0.58854536E-43_JPRB, &
  & 0.36433760E-43_JPRB, 0.21019477E-43_JPRB, 0.12611686E-43_JPRB, 0.70064923E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 3,10) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.84077908E-44_JPRB, 0.22420775E-43_JPRB, 0.57453237E-43_JPRB, 0.14293244E-42_JPRB, &
  & 0.36153500E-42_JPRB, 0.76370766E-42_JPRB, 0.13312335E-41_JPRB, 0.22532879E-41_JPRB, 0.38619786E-41_JPRB, 0.67780807E-41_JPRB, &
  & 0.10648467E-40_JPRB, 0.14454394E-40_JPRB, 0.16197609E-40_JPRB, 0.18448094E-40_JPRB, 0.18963772E-40_JPRB, 0.18694723E-40_JPRB, &
  & 0.18076750E-40_JPRB, 0.16688063E-40_JPRB, 0.16151366E-40_JPRB, 0.15840278E-40_JPRB, 0.15124214E-40_JPRB, 0.14688411E-40_JPRB, &
  & 0.13707502E-40_JPRB, 0.11703645E-40_JPRB, 0.93592724E-41_JPRB, 0.68593560E-41_JPRB, 0.46158771E-41_JPRB, 0.28614515E-41_JPRB, &
  & 0.17278010E-41_JPRB, 0.99772451E-42_JPRB, 0.55351289E-42_JPRB, 0.29427268E-42_JPRB, 0.15414283E-42_JPRB, 0.78472714E-43_JPRB, &
  & 0.39236357E-43_JPRB, 0.19618179E-43_JPRB, 0.98090893E-44_JPRB, 0.56051939E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 4,10) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.42038954E-44_JPRB, 0.98090893E-44_JPRB, 0.25223372E-43_JPRB, 0.61657132E-43_JPRB, &
  & 0.15274153E-42_JPRB, 0.37554799E-42_JPRB, 0.91644920E-42_JPRB, 0.22014399E-41_JPRB, 0.52688822E-41_JPRB, 0.12939590E-40_JPRB, &
  & 0.32162602E-40_JPRB, 0.67863483E-40_JPRB, 0.11740359E-39_JPRB, 0.19786334E-39_JPRB, 0.33959768E-39_JPRB, 0.60618210E-39_JPRB, &
  & 0.95865350E-39_JPRB, 0.12966369E-38_JPRB, 0.14439806E-38_JPRB, 0.16358968E-38_JPRB, 0.16794170E-38_JPRB, 0.16543309E-38_JPRB, &
  & 0.15982930E-38_JPRB, 0.14750096E-38_JPRB, 0.14269184E-38_JPRB, 0.13998930E-38_JPRB, 0.13359587E-38_JPRB, 0.12987248E-38_JPRB, &
  & 0.12137235E-38_JPRB, 0.10361845E-38_JPRB, 0.82957990E-39_JPRB, 0.61022344E-39_JPRB, 0.41162161E-39_JPRB, 0.25612793E-39_JPRB, &
  & 0.15450997E-39_JPRB, 0.89020288E-40_JPRB, 0.49336916E-40_JPRB, 0.26296767E-40_JPRB, 0.13888269E-40_JPRB, 0.71984702E-41_JPRB, &
  & 0.36798098E-41_JPRB, 0.18707334E-41_JPRB, 0.95988945E-42_JPRB, 0.50586875E-42_JPRB, 0.28025969E-42_JPRB, 0.16675452E-42_JPRB, &
  & 0.10789998E-42_JPRB, 0.75670117E-43_JPRB, 0.58854536E-43_JPRB, 0.47644148E-43_JPRB, 0.39236357E-43_JPRB, 0.33631163E-43_JPRB, &
  & 0.29427268E-43_JPRB, 0.23822074E-43_JPRB, 0.16815582E-43_JPRB, 0.70064923E-44_JPRB /)

RGHG9(:, 5,10) = (/ &
  & 0.56051939E-44_JPRB, 0.11210388E-43_JPRB, 0.16815582E-43_JPRB, 0.26624671E-43_JPRB, 0.44841551E-43_JPRB, 0.85479206E-43_JPRB, &
  & 0.18357010E-42_JPRB, 0.40917915E-42_JPRB, 0.95568555E-42_JPRB, 0.22995308E-41_JPRB, 0.56626471E-41_JPRB, 0.14019991E-40_JPRB, &
  & 0.34520988E-40_JPRB, 0.83934975E-40_JPRB, 0.20085091E-39_JPRB, 0.46989882E-39_JPRB, 0.10923220E-38_JPRB, 0.25978112E-38_JPRB, &
  & 0.62799667E-38_JPRB, 0.12999556E-37_JPRB, 0.22074740E-37_JPRB, 0.36520052E-37_JPRB, 0.61837810E-37_JPRB, 0.10962598E-36_JPRB, &
  & 0.17181009E-36_JPRB, 0.22959062E-36_JPRB, 0.25218695E-36_JPRB, 0.28301960E-36_JPRB, 0.28836036E-36_JPRB, 0.28247738E-36_JPRB, &
  & 0.27201344E-36_JPRB, 0.25050871E-36_JPRB, 0.24265391E-36_JPRB, 0.23886318E-36_JPRB, 0.22890677E-36_JPRB, 0.22434167E-36_JPRB, &
  & 0.21171658E-36_JPRB, 0.18204642E-36_JPRB, 0.14698375E-36_JPRB, 0.10903463E-36_JPRB, 0.74377369E-37_JPRB, 0.46705065E-37_JPRB, &
  & 0.28555621E-37_JPRB, 0.16673460E-37_JPRB, 0.93742215E-38_JPRB, 0.50855027E-38_JPRB, 0.27443800E-38_JPRB, 0.14566371E-38_JPRB, &
  & 0.76284026E-39_JPRB, 0.39691919E-39_JPRB, 0.20746364E-39_JPRB, 0.11063392E-39_JPRB, 0.61665540E-40_JPRB, 0.36849946E-40_JPRB, &
  & 0.24008447E-40_JPRB, 0.17055204E-40_JPRB, 0.13109147E-40_JPRB, 0.10697512E-40_JPRB, 0.90327699E-41_JPRB, 0.78640870E-41_JPRB, &
  & 0.69644534E-41_JPRB, 0.61012535E-41_JPRB, 0.48232693E-41_JPRB, 0.27129138E-41_JPRB /)

RGHG9(:, 6,10) = (/ &
  & 0.29609437E-41_JPRB, 0.60494055E-41_JPRB, 0.93844958E-41_JPRB, 0.14842553E-40_JPRB, 0.25682998E-40_JPRB, 0.49238825E-40_JPRB, &
  & 0.10087527E-39_JPRB, 0.21808828E-39_JPRB, 0.48959827E-39_JPRB, 0.11391898E-38_JPRB, 0.27063656E-38_JPRB, 0.64907963E-38_JPRB, &
  & 0.15456527E-37_JPRB, 0.36262897E-37_JPRB, 0.83491812E-37_JPRB, 0.18724550E-36_JPRB, 0.41588395E-36_JPRB, 0.94329260E-36_JPRB, &
  & 0.21727611E-35_JPRB, 0.43076914E-35_JPRB, 0.70221022E-35_JPRB, 0.11159108E-34_JPRB, 0.18172386E-34_JPRB, 0.31204221E-34_JPRB, &
  & 0.47495117E-34_JPRB, 0.61806242E-34_JPRB, 0.66306152E-34_JPRB, 0.72924295E-34_JPRB, 0.73127240E-34_JPRB, 0.70785251E-34_JPRB, &
  & 0.67645160E-34_JPRB, 0.62106923E-34_JPRB, 0.60290830E-34_JPRB, 0.59784007E-34_JPRB, 0.57877026E-34_JPRB, 0.57630947E-34_JPRB, &
  & 0.55503158E-34_JPRB, 0.48685130E-34_JPRB, 0.40274491E-34_JPRB, 0.30637868E-34_JPRB, 0.21484756E-34_JPRB, 0.13848242E-34_JPRB, &
  & 0.87561422E-35_JPRB, 0.52722270E-35_JPRB, 0.30690361E-35_JPRB, 0.17257791E-35_JPRB, 0.96988884E-36_JPRB, 0.53713263E-36_JPRB, &
  & 0.29384895E-36_JPRB, 0.15984109E-36_JPRB, 0.87371408E-37_JPRB, 0.48710771E-37_JPRB, 0.28338414E-37_JPRB, 0.17625343E-37_JPRB, &
  & 0.11867831E-37_JPRB, 0.86651785E-38_JPRB, 0.67895461E-38_JPRB, 0.56246243E-38_JPRB, 0.48012409E-38_JPRB, 0.42133668E-38_JPRB, &
  & 0.37643445E-38_JPRB, 0.33914898E-38_JPRB, 0.29608652E-38_JPRB, 0.22135751E-38_JPRB /)

RGHG9(:, 7,10) = (/ &
  & 0.29082534E-38_JPRB, 0.53363533E-38_JPRB, 0.81033797E-38_JPRB, 0.12614936E-37_JPRB, 0.21337284E-37_JPRB, 0.39156973E-37_JPRB, &
  & 0.76537207E-37_JPRB, 0.15565900E-36_JPRB, 0.33006879E-36_JPRB, 0.72003253E-36_JPRB, 0.16107636E-35_JPRB, 0.36401596E-35_JPRB, &
  & 0.82027903E-35_JPRB, 0.18268669E-34_JPRB, 0.39957754E-34_JPRB, 0.84995772E-34_JPRB, 0.17873132E-33_JPRB, 0.38321802E-33_JPRB, &
  & 0.83434541E-33_JPRB, 0.15642182E-32_JPRB, 0.24170072E-32_JPRB, 0.36379765E-32_JPRB, 0.56341183E-32_JPRB, 0.92499026E-32_JPRB, &
  & 0.13552915E-31_JPRB, 0.17074727E-31_JPRB, 0.17766814E-31_JPRB, 0.19063956E-31_JPRB, 0.18728683E-31_JPRB, 0.17852535E-31_JPRB, &
  & 0.16899415E-31_JPRB, 0.15460374E-31_JPRB, 0.15051540E-31_JPRB, 0.15054242E-31_JPRB, 0.14772341E-31_JPRB, 0.14989532E-31_JPRB, &
  & 0.14785452E-31_JPRB, 0.13333885E-31_JPRB, 0.11394161E-31_JPRB, 0.89910169E-32_JPRB, 0.65403051E-32_JPRB, 0.43904236E-32_JPRB, &
  & 0.28875819E-32_JPRB, 0.18166220E-32_JPRB, 0.11021079E-32_JPRB, 0.64768917E-33_JPRB, 0.38239176E-33_JPRB, 0.22305667E-33_JPRB, &
  & 0.12897708E-33_JPRB, 0.74486853E-34_JPRB, 0.43443869E-34_JPRB, 0.25943043E-34_JPRB, 0.16188951E-34_JPRB, 0.10741967E-34_JPRB, &
  & 0.76537417E-35_JPRB, 0.58361307E-35_JPRB, 0.47318713E-35_JPRB, 0.40191511E-35_JPRB, 0.34962408E-35_JPRB, 0.31099481E-35_JPRB, &
  & 0.28064872E-35_JPRB, 0.25456326E-35_JPRB, 0.22713867E-35_JPRB, 0.17956654E-35_JPRB /)

RGHG9(:, 8,10) = (/ &
  & 0.25552294E-35_JPRB, 0.45579313E-35_JPRB, 0.67327573E-35_JPRB, 0.10235841E-34_JPRB, 0.16597115E-34_JPRB, 0.29136866E-34_JPRB, &
  & 0.53798904E-34_JPRB, 0.10373115E-33_JPRB, 0.20615857E-33_JPRB, 0.42173486E-33_JPRB, 0.88048072E-33_JPRB, 0.18610526E-32_JPRB, &
  & 0.39364683E-32_JPRB, 0.82705218E-32_JPRB, 0.17130561E-31_JPRB, 0.34510128E-31_JPRB, 0.68672827E-31_JPRB, 0.13940138E-30_JPRB, &
  & 0.28748473E-30_JPRB, 0.50992874E-30_JPRB, 0.74427718E-30_JPRB, 0.10593884E-29_JPRB, 0.15556488E-29_JPRB, 0.24376255E-29_JPRB, &
  & 0.34337924E-29_JPRB, 0.41779962E-29_JPRB, 0.42102123E-29_JPRB, 0.44017776E-29_JPRB, 0.42321765E-29_JPRB, 0.39704155E-29_JPRB, &
  & 0.37218517E-29_JPRB, 0.33927859E-29_JPRB, 0.33130513E-29_JPRB, 0.33433700E-29_JPRB, 0.33276334E-29_JPRB, 0.34415307E-29_JPRB, &
  & 0.34769709E-29_JPRB, 0.32279812E-29_JPRB, 0.28568660E-29_JPRB, 0.23435346E-29_JPRB, 0.17839144E-29_JPRB, 0.12462013E-29_JPRB, &
  & 0.86226084E-30_JPRB, 0.56547447E-30_JPRB, 0.35871762E-30_JPRB, 0.21986907E-30_JPRB, 0.13626074E-30_JPRB, 0.83648254E-31_JPRB, &
  & 0.51130231E-31_JPRB, 0.31415627E-31_JPRB, 0.19621355E-31_JPRB, 0.12595944E-31_JPRB, 0.84393823E-32_JPRB, 0.59806934E-32_JPRB, &
  & 0.44975516E-32_JPRB, 0.35838766E-32_JPRB, 0.30034103E-32_JPRB, 0.26165854E-32_JPRB, 0.23196199E-32_JPRB, 0.20907989E-32_JPRB, &
  & 0.19040481E-32_JPRB, 0.17376501E-32_JPRB, 0.15605512E-32_JPRB, 0.12473967E-32_JPRB /)

RGHG9(:, 9,10) = (/ &
  & 0.19452878E-32_JPRB, 0.33501122E-32_JPRB, 0.48650141E-32_JPRB, 0.71315060E-32_JPRB, 0.11144176E-31_JPRB, 0.18655001E-31_JPRB, &
  & 0.32917092E-31_JPRB, 0.60120124E-31_JPRB, 0.11307000E-30_JPRB, 0.21714270E-30_JPRB, 0.42413830E-30_JPRB, 0.83716789E-30_JPRB, &
  & 0.16562633E-29_JPRB, 0.32698288E-29_JPRB, 0.63957109E-29_JPRB, 0.12185980E-28_JPRB, 0.22946392E-28_JPRB, 0.44169614E-28_JPRB, &
  & 0.86616629E-28_JPRB, 0.14552950E-27_JPRB, 0.20062643E-27_JPRB, 0.26968287E-27_JPRB, 0.37534579E-27_JPRB, 0.56127718E-27_JPRB, &
  & 0.75835576E-27_JPRB, 0.89039805E-27_JPRB, 0.86829964E-27_JPRB, 0.88416699E-27_JPRB, 0.83206780E-27_JPRB, 0.76847672E-27_JPRB, &
  & 0.71357520E-27_JPRB, 0.64826840E-27_JPRB, 0.63499148E-27_JPRB, 0.64647748E-27_JPRB, 0.65268557E-27_JPRB, 0.68788830E-27_JPRB, &
  & 0.71152317E-27_JPRB, 0.68036740E-27_JPRB, 0.62347023E-27_JPRB, 0.53317006E-27_JPRB, 0.42437255E-27_JPRB, 0.31196892E-27_JPRB, &
  & 0.22649702E-27_JPRB, 0.15610971E-27_JPRB, 0.10350592E-27_JPRB, 0.66164336E-28_JPRB, 0.43030800E-28_JPRB, 0.27764498E-28_JPRB, &
  & 0.17923204E-28_JPRB, 0.11707117E-28_JPRB, 0.78134925E-29_JPRB, 0.53662863E-29_JPRB, 0.38348824E-29_JPRB, 0.28735956E-29_JPRB, &
  & 0.22651742E-29_JPRB, 0.18714615E-29_JPRB, 0.16134873E-29_JPRB, 0.14352169E-29_JPRB, 0.12916508E-29_JPRB, 0.11766287E-29_JPRB, &
  & 0.10771202E-29_JPRB, 0.99099111E-30_JPRB, 0.88664774E-30_JPRB, 0.72494721E-30_JPRB /)

RGHG9(:,10,10) = (/ &
  & 0.12350192E-29_JPRB, 0.21014706E-29_JPRB, 0.29593228E-29_JPRB, 0.42328133E-29_JPRB, 0.63607448E-29_JPRB, 0.10236368E-28_JPRB, &
  & 0.17266443E-28_JPRB, 0.30105601E-28_JPRB, 0.53701457E-28_JPRB, 0.97345816E-28_JPRB, 0.17846360E-27_JPRB, 0.32942757E-27_JPRB, &
  & 0.60890066E-27_JPRB, 0.11261128E-26_JPRB, 0.20733722E-26_JPRB, 0.37263632E-26_JPRB, 0.66278460E-26_JPRB, 0.12094335E-25_JPRB, &
  & 0.22578444E-25_JPRB, 0.35953491E-25_JPRB, 0.46757333E-25_JPRB, 0.59319296E-25_JPRB, 0.78185662E-25_JPRB, 0.11141000E-24_JPRB, &
  & 0.14429218E-24_JPRB, 0.16322918E-24_JPRB, 0.15403187E-24_JPRB, 0.15270529E-24_JPRB, 0.14070276E-24_JPRB, 0.12797893E-24_JPRB, &
  & 0.11777126E-24_JPRB, 0.10666100E-24_JPRB, 0.10481719E-24_JPRB, 0.10766669E-24_JPRB, 0.11027796E-24_JPRB, 0.11850017E-24_JPRB, &
  & 0.12549982E-24_JPRB, 0.12360938E-24_JPRB, 0.11730391E-24_JPRB, 0.10449264E-24_JPRB, 0.87227783E-25_JPRB, 0.67400362E-25_JPRB, &
  & 0.51711392E-25_JPRB, 0.37501317E-25_JPRB, 0.26116818E-25_JPRB, 0.17456173E-25_JPRB, 0.11936005E-25_JPRB, 0.81008820E-26_JPRB, &
  & 0.55218511E-26_JPRB, 0.38267115E-26_JPRB, 0.27182537E-26_JPRB, 0.19832855E-26_JPRB, 0.14976131E-26_JPRB, 0.11771940E-26_JPRB, &
  & 0.96414903E-27_JPRB, 0.82126063E-27_JPRB, 0.72430234E-27_JPRB, 0.65498889E-27_JPRB, 0.59621326E-27_JPRB, 0.54658316E-27_JPRB, &
  & 0.50401240E-27_JPRB, 0.46143760E-27_JPRB, 0.42048458E-27_JPRB, 0.33717997E-27_JPRB /)

RGHG9(:,11,10) = (/ &
  & 0.65799252E-27_JPRB, 0.10854647E-26_JPRB, 0.15112444E-26_JPRB, 0.20972275E-26_JPRB, 0.30585844E-26_JPRB, 0.47404870E-26_JPRB, &
  & 0.76820215E-26_JPRB, 0.12809064E-25_JPRB, 0.21762793E-25_JPRB, 0.37380686E-25_JPRB, 0.64592658E-25_JPRB, 0.11188141E-24_JPRB, &
  & 0.19349774E-24_JPRB, 0.33503361E-24_JPRB, 0.57952030E-24_JPRB, 0.98020553E-24_JPRB, 0.16432385E-23_JPRB, 0.28380770E-23_JPRB, &
  & 0.50395172E-23_JPRB, 0.75973482E-23_JPRB, 0.93186088E-23_JPRB, 0.11156961E-22_JPRB, 0.13920782E-22_JPRB, 0.18898212E-22_JPRB, &
  & 0.23452361E-22_JPRB, 0.25568099E-22_JPRB, 0.23355161E-22_JPRB, 0.22546101E-22_JPRB, 0.20347698E-22_JPRB, 0.18241375E-22_JPRB, &
  & 0.16645729E-22_JPRB, 0.15041017E-22_JPRB, 0.14836427E-22_JPRB, 0.15381925E-22_JPRB, 0.15990223E-22_JPRB, 0.17522579E-22_JPRB, &
  & 0.19010406E-22_JPRB, 0.19281004E-22_JPRB, 0.18931463E-22_JPRB, 0.17546583E-22_JPRB, 0.15320408E-22_JPRB, 0.12456444E-22_JPRB, &
  & 0.10079055E-22_JPRB, 0.77164828E-23_JPRB, 0.56667456E-23_JPRB, 0.39767259E-23_JPRB, 0.28682740E-23_JPRB, 0.20515698E-23_JPRB, &
  & 0.14767052E-23_JPRB, 0.10839445E-23_JPRB, 0.81538852E-24_JPRB, 0.62820243E-24_JPRB, 0.49806321E-24_JPRB, 0.40803557E-24_JPRB, &
  & 0.34581007E-24_JPRB, 0.30250600E-24_JPRB, 0.27225039E-24_JPRB, 0.24977449E-24_JPRB, 0.22961017E-24_JPRB, 0.21196552E-24_JPRB, &
  & 0.19526667E-24_JPRB, 0.18089156E-24_JPRB, 0.16165312E-24_JPRB, 0.13481270E-24_JPRB /)

RGHG9(:,12,10) = (/ &
  & 0.28260668E-24_JPRB, 0.46489871E-24_JPRB, 0.63255778E-24_JPRB, 0.86354858E-24_JPRB, 0.12236461E-23_JPRB, 0.18376430E-23_JPRB, &
  & 0.28706416E-23_JPRB, 0.45943109E-23_JPRB, 0.74592825E-23_JPRB, 0.12187493E-22_JPRB, 0.19933338E-22_JPRB, 0.32528509E-22_JPRB, &
  & 0.52792897E-22_JPRB, 0.85678890E-22_JPRB, 0.13915373E-21_JPRB, 0.22113362E-21_JPRB, 0.34863648E-21_JPRB, 0.56862225E-21_JPRB, &
  & 0.95800076E-21_JPRB, 0.13649335E-20_JPRB, 0.15792930E-20_JPRB, 0.17847581E-20_JPRB, 0.21086039E-20_JPRB, 0.27245455E-20_JPRB, &
  & 0.32409453E-20_JPRB, 0.34058402E-20_JPRB, 0.30117452E-20_JPRB, 0.28305270E-20_JPRB, 0.25025849E-20_JPRB, 0.22114211E-20_JPRB, &
  & 0.20022105E-20_JPRB, 0.18055269E-20_JPRB, 0.17880795E-20_JPRB, 0.18716052E-20_JPRB, 0.19747184E-20_JPRB, 0.22086054E-20_JPRB, &
  & 0.24555977E-20_JPRB, 0.25645951E-20_JPRB, 0.26041934E-20_JPRB, 0.25075740E-20_JPRB, 0.22856230E-20_JPRB, 0.19506444E-20_JPRB, &
  & 0.16624610E-20_JPRB, 0.13448171E-20_JPRB, 0.10436612E-20_JPRB, 0.77313251E-21_JPRB, 0.58996365E-21_JPRB, 0.44563235E-21_JPRB, &
  & 0.33898403E-21_JPRB, 0.26291588E-21_JPRB, 0.20871216E-21_JPRB, 0.16893670E-21_JPRB, 0.13999211E-21_JPRB, 0.11911583E-21_JPRB, &
  & 0.10414572E-21_JPRB, 0.93398910E-22_JPRB, 0.85672181E-22_JPRB, 0.79705256E-22_JPRB, 0.73979546E-22_JPRB, 0.68624979E-22_JPRB, &
  & 0.63682848E-22_JPRB, 0.58439365E-22_JPRB, 0.53406230E-22_JPRB, 0.42896536E-22_JPRB /)

RGHG9(:,13,10) = (/ &
  & 0.10080973E-21_JPRB, 0.16332574E-21_JPRB, 0.22119554E-21_JPRB, 0.29619720E-21_JPRB, 0.41129971E-21_JPRB, 0.60109040E-21_JPRB, &
  & 0.90925708E-21_JPRB, 0.14016494E-20_JPRB, 0.21811789E-20_JPRB, 0.33993912E-20_JPRB, 0.52770944E-20_JPRB, 0.81341411E-20_JPRB, &
  & 0.12413895E-19_JPRB, 0.18898961E-19_JPRB, 0.28801107E-19_JPRB, 0.42922744E-19_JPRB, 0.63476948E-19_JPRB, 0.97465270E-19_JPRB, &
  & 0.15531877E-18_JPRB, 0.20881606E-18_JPRB, 0.22789868E-18_JPRB, 0.24312446E-18_JPRB, 0.27180157E-18_JPRB, 0.33407354E-18_JPRB, &
  & 0.38073503E-18_JPRB, 0.38556936E-18_JPRB, 0.32991597E-18_JPRB, 0.30163294E-18_JPRB, 0.26103520E-18_JPRB, 0.22727033E-18_JPRB, &
  & 0.20403110E-18_JPRB, 0.18360076E-18_JPRB, 0.18251514E-18_JPRB, 0.19285837E-18_JPRB, 0.20656166E-18_JPRB, 0.23583881E-18_JPRB, &
  & 0.26903357E-18_JPRB, 0.28944117E-18_JPRB, 0.30412228E-18_JPRB, 0.30418440E-18_JPRB, 0.28919969E-18_JPRB, 0.25873762E-18_JPRB, &
  & 0.23216220E-18_JPRB, 0.19837802E-18_JPRB, 0.16307504E-18_JPRB, 0.12801964E-18_JPRB, 0.10359975E-18_JPRB, 0.82872802E-19_JPRB, &
  & 0.66653063E-19_JPRB, 0.54578857E-19_JPRB, 0.45586292E-19_JPRB, 0.38664180E-19_JPRB, 0.33391133E-19_JPRB, 0.29439662E-19_JPRB, &
  & 0.26510693E-19_JPRB, 0.24345265E-19_JPRB, 0.22745124E-19_JPRB, 0.21453650E-19_JPRB, 0.20101555E-19_JPRB, 0.18769470E-19_JPRB, &
  & 0.17404111E-19_JPRB, 0.16121868E-19_JPRB, 0.14444620E-19_JPRB, 0.11923057E-19_JPRB /)

RGHG9(:,14,10) = (/ &
  & 0.29743857E-19_JPRB, 0.48475282E-19_JPRB, 0.64919112E-19_JPRB, 0.86069913E-19_JPRB, 0.11731172E-18_JPRB, 0.16762464E-18_JPRB, &
  & 0.24635359E-18_JPRB, 0.36665569E-18_JPRB, 0.54766434E-18_JPRB, 0.81481954E-18_JPRB, 0.12011291E-17_JPRB, 0.17495544E-17_JPRB, &
  & 0.25112143E-17_JPRB, 0.35853511E-17_JPRB, 0.51208047E-17_JPRB, 0.71431926E-17_JPRB, 0.98835560E-17_JPRB, 0.14243617E-16_JPRB, &
  & 0.21416647E-16_JPRB, 0.27147955E-16_JPRB, 0.27956008E-16_JPRB, 0.28154892E-16_JPRB, 0.29793395E-16_JPRB, 0.34826719E-16_JPRB, &
  & 0.38038509E-16_JPRB, 0.37123833E-16_JPRB, 0.30736539E-16_JPRB, 0.27326730E-16_JPRB, 0.23138998E-16_JPRB, 0.19835773E-16_JPRB, &
  & 0.17651296E-16_JPRB, 0.15845670E-16_JPRB, 0.15810336E-16_JPRB, 0.16865235E-16_JPRB, 0.18332706E-16_JPRB, 0.21367005E-16_JPRB, &
  & 0.25009399E-16_JPRB, 0.27725915E-16_JPRB, 0.30156715E-16_JPRB, 0.31338101E-16_JPRB, 0.31073907E-16_JPRB, 0.29122697E-16_JPRB, &
  & 0.27500404E-16_JPRB, 0.24822679E-16_JPRB, 0.21618554E-16_JPRB, 0.18022538E-16_JPRB, 0.15494443E-16_JPRB, 0.13145207E-16_JPRB, &
  & 0.11192607E-16_JPRB, 0.96743016E-17_JPRB, 0.84993188E-17_JPRB, 0.75482481E-17_JPRB, 0.67928701E-17_JPRB, 0.62057927E-17_JPRB, &
  & 0.57572722E-17_JPRB, 0.54154994E-17_JPRB, 0.51553941E-17_JPRB, 0.49318361E-17_JPRB, 0.46665130E-17_JPRB, 0.43826601E-17_JPRB, &
  & 0.40824622E-17_JPRB, 0.37640519E-17_JPRB, 0.34066594E-17_JPRB, 0.27357377E-17_JPRB /)

RGHG9(:,15,10) = (/ &
  & 0.74674284E-17_JPRB, 0.12155978E-16_JPRB, 0.16227896E-16_JPRB, 0.21273156E-16_JPRB, 0.28572215E-16_JPRB, 0.40001965E-16_JPRB, &
  & 0.57240515E-16_JPRB, 0.82360018E-16_JPRB, 0.11813370E-15_JPRB, 0.16773764E-15_JPRB, 0.23463429E-15_JPRB, 0.32269277E-15_JPRB, &
  & 0.43530053E-15_JPRB, 0.58233616E-15_JPRB, 0.77860518E-15_JPRB, 0.10150763E-14_JPRB, 0.13114735E-14_JPRB, 0.17698080E-14_JPRB, &
  & 0.25066331E-14_JPRB, 0.29961313E-14_JPRB, 0.29111832E-14_JPRB, 0.27680973E-14_JPRB, 0.27728894E-14_JPRB, 0.30850778E-14_JPRB, &
  & 0.32299893E-14_JPRB, 0.30383932E-14_JPRB, 0.24355814E-14_JPRB, 0.21057392E-14_JPRB, 0.17446939E-14_JPRB, 0.14724336E-14_JPRB, &
  & 0.12980424E-14_JPRB, 0.11621191E-14_JPRB, 0.11635288E-14_JPRB, 0.12528325E-14_JPRB, 0.13819593E-14_JPRB, 0.16436193E-14_JPRB, &
  & 0.19736137E-14_JPRB, 0.22543966E-14_JPRB, 0.25393988E-14_JPRB, 0.27428161E-14_JPRB, 0.28376180E-14_JPRB, 0.27858380E-14_JPRB, &
  & 0.27691144E-14_JPRB, 0.26396903E-14_JPRB, 0.24358004E-14_JPRB, 0.21571903E-14_JPRB, 0.19708155E-14_JPRB, 0.17746549E-14_JPRB, &
  & 0.16003531E-14_JPRB, 0.14607648E-14_JPRB, 0.13501506E-14_JPRB, 0.12562093E-14_JPRB, 0.11785683E-14_JPRB, 0.11164401E-14_JPRB, &
  & 0.10676995E-14_JPRB, 0.10292867E-14_JPRB, 0.99871622E-15_JPRB, 0.96915265E-15_JPRB, 0.92621136E-15_JPRB, 0.87533624E-15_JPRB, &
  & 0.81800513E-15_JPRB, 0.75557149E-15_JPRB, 0.68093540E-15_JPRB, 0.54684463E-15_JPRB /)

RGHG9(:,16,10) = (/ &
  & 0.10340417E-15_JPRB, 0.16860189E-15_JPRB, 0.22427672E-15_JPRB, 0.29208902E-15_JPRB, 0.38612087E-15_JPRB, 0.52657280E-15_JPRB, &
  & 0.73000476E-15_JPRB, 0.10160052E-14_JPRB, 0.14082626E-14_JPRB, 0.19326742E-14_JPRB, 0.26099601E-14_JPRB, 0.34641640E-14_JPRB, &
  & 0.45036928E-14_JPRB, 0.57584417E-14_JPRB, 0.72761528E-14_JPRB, 0.91357111E-14_JPRB, 0.10803920E-13_JPRB, 0.12914722E-13_JPRB, &
  & 0.16226285E-13_JPRB, 0.21529938E-13_JPRB, 0.23710377E-13_JPRB, 0.25158730E-13_JPRB, 0.26864981E-13_JPRB, 0.27591863E-13_JPRB, &
  & 0.26081301E-13_JPRB, 0.23583498E-13_JPRB, 0.21010264E-13_JPRB, 0.18062954E-13_JPRB, 0.15219131E-13_JPRB, 0.13133790E-13_JPRB, &
  & 0.11702826E-13_JPRB, 0.10739620E-13_JPRB, 0.10758496E-13_JPRB, 0.11513839E-13_JPRB, 0.12632090E-13_JPRB, 0.14499124E-13_JPRB, &
  & 0.16941299E-13_JPRB, 0.19723054E-13_JPRB, 0.22258660E-13_JPRB, 0.24289229E-13_JPRB, 0.25513601E-13_JPRB, 0.25957785E-13_JPRB, &
  & 0.25546100E-13_JPRB, 0.24102007E-13_JPRB, 0.22347897E-13_JPRB, 0.20504022E-13_JPRB, 0.18727382E-13_JPRB, 0.17221749E-13_JPRB, &
  & 0.15826236E-13_JPRB, 0.14603319E-13_JPRB, 0.13552276E-13_JPRB, 0.12594566E-13_JPRB, 0.11690696E-13_JPRB, 0.10870456E-13_JPRB, &
  & 0.10116543E-13_JPRB, 0.94363045E-14_JPRB, 0.88345113E-14_JPRB, 0.82528063E-14_JPRB, 0.76427317E-14_JPRB, 0.70513087E-14_JPRB, &
  & 0.64707519E-14_JPRB, 0.59404919E-14_JPRB, 0.52910684E-14_JPRB, 0.42943906E-14_JPRB /)

RGHG9(:,17,10) = (/ &
  & 0.93199374E-15_JPRB, 0.15152879E-14_JPRB, 0.20126331E-14_JPRB, 0.26135329E-14_JPRB, 0.34257335E-14_JPRB, 0.45947929E-14_JPRB, &
  & 0.62415452E-14_JPRB, 0.85028293E-14_JPRB, 0.11539000E-13_JPRB, 0.15520464E-13_JPRB, 0.20589599E-13_JPRB, 0.26883667E-13_JPRB, &
  & 0.34510585E-13_JPRB, 0.43616234E-13_JPRB, 0.54427125E-13_JPRB, 0.67049692E-13_JPRB, 0.82288370E-13_JPRB, 0.96316564E-13_JPRB, &
  & 0.10927022E-12_JPRB, 0.12766321E-12_JPRB, 0.14884737E-12_JPRB, 0.16469802E-12_JPRB, 0.17361628E-12_JPRB, 0.17381570E-12_JPRB, &
  & 0.16660028E-12_JPRB, 0.15350935E-12_JPRB, 0.13576989E-12_JPRB, 0.11692895E-12_JPRB, 0.98556390E-13_JPRB, 0.86414410E-13_JPRB, &
  & 0.77424890E-13_JPRB, 0.72086278E-13_JPRB, 0.71074487E-13_JPRB, 0.74277607E-13_JPRB, 0.82546695E-13_JPRB, 0.93399721E-13_JPRB, &
  & 0.10622195E-12_JPRB, 0.12116248E-12_JPRB, 0.13615175E-12_JPRB, 0.14908945E-12_JPRB, 0.15787004E-12_JPRB, 0.16097075E-12_JPRB, &
  & 0.15817953E-12_JPRB, 0.15107583E-12_JPRB, 0.14147510E-12_JPRB, 0.13095371E-12_JPRB, 0.12097175E-12_JPRB, 0.11201943E-12_JPRB, &
  & 0.10405973E-12_JPRB, 0.96938462E-13_JPRB, 0.90278228E-13_JPRB, 0.83712917E-13_JPRB, 0.77157620E-13_JPRB, 0.70671862E-13_JPRB, &
  & 0.64419905E-13_JPRB, 0.58668795E-13_JPRB, 0.53452333E-13_JPRB, 0.48302942E-13_JPRB, 0.43515267E-13_JPRB, 0.39241512E-13_JPRB, &
  & 0.35506347E-13_JPRB, 0.32088393E-13_JPRB, 0.28548029E-13_JPRB, 0.22604457E-13_JPRB /)

RGHG9(:,18,10) = (/ &
  & 0.58080041E-14_JPRB, 0.91741664E-14_JPRB, 0.12073687E-13_JPRB, 0.15479022E-13_JPRB, 0.20035202E-13_JPRB, 0.26358317E-13_JPRB, &
  & 0.35012330E-13_JPRB, 0.46568476E-13_JPRB, 0.61634603E-13_JPRB, 0.80821065E-13_JPRB, 0.10455788E-12_JPRB, 0.13327791E-12_JPRB, &
  & 0.16714536E-12_JPRB, 0.20667186E-12_JPRB, 0.25208503E-12_JPRB, 0.30397288E-12_JPRB, 0.36196323E-12_JPRB, 0.43093215E-12_JPRB, &
  & 0.50230745E-12_JPRB, 0.56966552E-12_JPRB, 0.63752627E-12_JPRB, 0.69607064E-12_JPRB, 0.73147971E-12_JPRB, 0.74096198E-12_JPRB, &
  & 0.72323430E-12_JPRB, 0.67698982E-12_JPRB, 0.61251178E-12_JPRB, 0.54277345E-12_JPRB, 0.47626735E-12_JPRB, 0.42105355E-12_JPRB, &
  & 0.38237244E-12_JPRB, 0.35898639E-12_JPRB, 0.34887853E-12_JPRB, 0.35453655E-12_JPRB, 0.37012930E-12_JPRB, 0.40515958E-12_JPRB, &
  & 0.45802067E-12_JPRB, 0.51956654E-12_JPRB, 0.58226552E-12_JPRB, 0.63703827E-12_JPRB, 0.67505669E-12_JPRB, 0.68999488E-12_JPRB, &
  & 0.68272644E-12_JPRB, 0.65891579E-12_JPRB, 0.62440651E-12_JPRB, 0.58603383E-12_JPRB, 0.54830457E-12_JPRB, 0.51325177E-12_JPRB, &
  & 0.48094964E-12_JPRB, 0.45027347E-12_JPRB, 0.41967712E-12_JPRB, 0.38820352E-12_JPRB, 0.35590405E-12_JPRB, 0.32343439E-12_JPRB, &
  & 0.29230917E-12_JPRB, 0.26287463E-12_JPRB, 0.23552124E-12_JPRB, 0.21012033E-12_JPRB, 0.18764791E-12_JPRB, 0.16817746E-12_JPRB, &
  & 0.15125260E-12_JPRB, 0.13592120E-12_JPRB, 0.11993862E-12_JPRB, 0.94690924E-13_JPRB /)

RGHG9(:,19,10) = (/ &
  & 0.25575414E-13_JPRB, 0.39218334E-13_JPRB, 0.50321096E-13_JPRB, 0.63678649E-13_JPRB, 0.80886964E-13_JPRB, 0.10440748E-12_JPRB, &
  & 0.13578436E-12_JPRB, 0.17669416E-12_JPRB, 0.22868507E-12_JPRB, 0.29316092E-12_JPRB, 0.37076969E-12_JPRB, 0.46222368E-12_JPRB, &
  & 0.56736744E-12_JPRB, 0.68707236E-12_JPRB, 0.82095393E-12_JPRB, 0.96928292E-12_JPRB, 0.11312002E-11_JPRB, 0.13072723E-11_JPRB, &
  & 0.15005735E-11_JPRB, 0.16985864E-11_JPRB, 0.18891043E-11_JPRB, 0.20604646E-11_JPRB, 0.21877786E-11_JPRB, 0.22486587E-11_JPRB, &
  & 0.22274322E-11_JPRB, 0.21353761E-11_JPRB, 0.19990715E-11_JPRB, 0.18423214E-11_JPRB, 0.16790801E-11_JPRB, 0.15310796E-11_JPRB, &
  & 0.14142395E-11_JPRB, 0.13279009E-11_JPRB, 0.12817099E-11_JPRB, 0.12676750E-11_JPRB, 0.12984637E-11_JPRB, 0.13789507E-11_JPRB, &
  & 0.14924585E-11_JPRB, 0.16383492E-11_JPRB, 0.18025725E-11_JPRB, 0.19521572E-11_JPRB, 0.20674541E-11_JPRB, 0.21184053E-11_JPRB, &
  & 0.21196558E-11_JPRB, 0.20679281E-11_JPRB, 0.19829680E-11_JPRB, 0.18828459E-11_JPRB, 0.17799927E-11_JPRB, 0.16799701E-11_JPRB, &
  & 0.15828566E-11_JPRB, 0.14867972E-11_JPRB, 0.13890679E-11_JPRB, 0.12878714E-11_JPRB, 0.11830534E-11_JPRB, 0.10768849E-11_JPRB, &
  & 0.97182516E-12_JPRB, 0.87304740E-12_JPRB, 0.77904301E-12_JPRB, 0.69453433E-12_JPRB, 0.62064150E-12_JPRB, 0.55673857E-12_JPRB, &
  & 0.50049570E-12_JPRB, 0.45072745E-12_JPRB, 0.39637017E-12_JPRB, 0.31669971E-12_JPRB /)

RGHG9(:,20,10) = (/ &
  & 0.84622942E-13_JPRB, 0.12318082E-12_JPRB, 0.15533056E-12_JPRB, 0.19167509E-12_JPRB, 0.23906343E-12_JPRB, 0.30153489E-12_JPRB, &
  & 0.38337083E-12_JPRB, 0.48783351E-12_JPRB, 0.61770689E-12_JPRB, 0.77482671E-12_JPRB, 0.95964718E-12_JPRB, 0.11720826E-11_JPRB, &
  & 0.14106920E-11_JPRB, 0.16762376E-11_JPRB, 0.19679909E-11_JPRB, 0.22844946E-11_JPRB, 0.26242081E-11_JPRB, 0.29908749E-11_JPRB, &
  & 0.33805896E-11_JPRB, 0.37924208E-11_JPRB, 0.42053782E-11_JPRB, 0.45912111E-11_JPRB, 0.49024543E-11_JPRB, 0.51169511E-11_JPRB, &
  & 0.52050577E-11_JPRB, 0.51547859E-11_JPRB, 0.49881874E-11_JPRB, 0.47531380E-11_JPRB, 0.44950163E-11_JPRB, 0.42236210E-11_JPRB, &
  & 0.39655041E-11_JPRB, 0.37375229E-11_JPRB, 0.35679723E-11_JPRB, 0.34557758E-11_JPRB, 0.34394293E-11_JPRB, 0.35151749E-11_JPRB, &
  & 0.36995394E-11_JPRB, 0.39813309E-11_JPRB, 0.42979643E-11_JPRB, 0.46030194E-11_JPRB, 0.48374642E-11_JPRB, 0.49871721E-11_JPRB, &
  & 0.50073166E-11_JPRB, 0.49242737E-11_JPRB, 0.47671602E-11_JPRB, 0.45662397E-11_JPRB, 0.43474573E-11_JPRB, 0.41230912E-11_JPRB, &
  & 0.38993626E-11_JPRB, 0.36762811E-11_JPRB, 0.34500220E-11_JPRB, 0.32156025E-11_JPRB, 0.29744629E-11_JPRB, 0.27305582E-11_JPRB, &
  & 0.24910293E-11_JPRB, 0.22555243E-11_JPRB, 0.20311255E-11_JPRB, 0.18243228E-11_JPRB, 0.16391550E-11_JPRB, 0.14762140E-11_JPRB, &
  & 0.13354610E-11_JPRB, 0.12016644E-11_JPRB, 0.10748277E-11_JPRB, 0.84982618E-12_JPRB /)

RGHG9(:,21,10) = (/ &
  & 0.21882501E-12_JPRB, 0.30839955E-12_JPRB, 0.37761396E-12_JPRB, 0.45745406E-12_JPRB, 0.55637369E-12_JPRB, 0.68582987E-12_JPRB, &
  & 0.85152913E-12_JPRB, 0.10593253E-11_JPRB, 0.13130479E-11_JPRB, 0.16151217E-11_JPRB, 0.19638089E-11_JPRB, 0.23576555E-11_JPRB, &
  & 0.27921819E-11_JPRB, 0.32665810E-11_JPRB, 0.37788665E-11_JPRB, 0.43286126E-11_JPRB, 0.49121063E-11_JPRB, 0.55325753E-11_JPRB, &
  & 0.61931489E-11_JPRB, 0.68878896E-11_JPRB, 0.76047250E-11_JPRB, 0.83059167E-11_JPRB, 0.89445066E-11_JPRB, 0.94514578E-11_JPRB, &
  & 0.97670578E-11_JPRB, 0.98823779E-11_JPRB, 0.98289727E-11_JPRB, 0.96462664E-11_JPRB, 0.93689483E-11_JPRB, 0.90310884E-11_JPRB, &
  & 0.86352531E-11_JPRB, 0.82102415E-11_JPRB, 0.78192132E-11_JPRB, 0.75124984E-11_JPRB, 0.73604517E-11_JPRB, 0.73880693E-11_JPRB, &
  & 0.75978286E-11_JPRB, 0.79629818E-11_JPRB, 0.84304196E-11_JPRB, 0.89043295E-11_JPRB, 0.92937932E-11_JPRB, 0.95171631E-11_JPRB, &
  & 0.95743413E-11_JPRB, 0.94550964E-11_JPRB, 0.92000036E-11_JPRB, 0.88536782E-11_JPRB, 0.84610123E-11_JPRB, 0.80510685E-11_JPRB, &
  & 0.76378973E-11_JPRB, 0.72240369E-11_JPRB, 0.68037733E-11_JPRB, 0.63778076E-11_JPRB, 0.59494280E-11_JPRB, 0.55231804E-11_JPRB, &
  & 0.50988675E-11_JPRB, 0.46774646E-11_JPRB, 0.42729869E-11_JPRB, 0.38942903E-11_JPRB, 0.35457358E-11_JPRB, 0.32285502E-11_JPRB, &
  & 0.29368027E-11_JPRB, 0.26777504E-11_JPRB, 0.23770486E-11_JPRB, 0.19516285E-11_JPRB /)

RGHG9(:,22,10) = (/ &
  & 0.47747727E-12_JPRB, 0.64359000E-12_JPRB, 0.77666270E-12_JPRB, 0.91576681E-12_JPRB, 0.10904689E-11_JPRB, 0.13112309E-11_JPRB, &
  & 0.15893961E-11_JPRB, 0.19332168E-11_JPRB, 0.23480757E-11_JPRB, 0.28350388E-11_JPRB, 0.33920069E-11_JPRB, 0.40127099E-11_JPRB, &
  & 0.46899476E-11_JPRB, 0.54184565E-11_JPRB, 0.61946160E-11_JPRB, 0.70146718E-11_JPRB, 0.78799276E-11_JPRB, 0.87952944E-11_JPRB, &
  & 0.97642406E-11_JPRB, 0.10788599E-10_JPRB, 0.11865776E-10_JPRB, 0.12952630E-10_JPRB, 0.13982085E-10_JPRB, 0.14884847E-10_JPRB, &
  & 0.15594076E-10_JPRB, 0.16052992E-10_JPRB, 0.16273283E-10_JPRB, 0.16278482E-10_JPRB, 0.16101126E-10_JPRB, 0.15769969E-10_JPRB, &
  & 0.15304379E-10_JPRB, 0.14732425E-10_JPRB, 0.14108104E-10_JPRB, 0.13552316E-10_JPRB, 0.13185858E-10_JPRB, 0.13050750E-10_JPRB, &
  & 0.13203932E-10_JPRB, 0.13612659E-10_JPRB, 0.14163573E-10_JPRB, 0.14738691E-10_JPRB, 0.15226771E-10_JPRB, 0.15516935E-10_JPRB, &
  & 0.15560496E-10_JPRB, 0.15383131E-10_JPRB, 0.15017092E-10_JPRB, 0.14495332E-10_JPRB, 0.13881485E-10_JPRB, 0.13239930E-10_JPRB, &
  & 0.12581630E-10_JPRB, 0.11923520E-10_JPRB, 0.11272964E-10_JPRB, 0.10631059E-10_JPRB, 0.99971966E-11_JPRB, 0.93768136E-11_JPRB, &
  & 0.87527008E-11_JPRB, 0.81396565E-11_JPRB, 0.75486492E-11_JPRB, 0.69848667E-11_JPRB, 0.64522801E-11_JPRB, 0.59524568E-11_JPRB, &
  & 0.54911817E-11_JPRB, 0.50290219E-11_JPRB, 0.45711187E-11_JPRB, 0.37397902E-11_JPRB /)

RGHG9(:,23,10) = (/ &
  & 0.91785076E-12_JPRB, 0.11911387E-11_JPRB, 0.14039239E-11_JPRB, 0.16228361E-11_JPRB, 0.18865846E-11_JPRB, 0.22160130E-11_JPRB, &
  & 0.26245440E-11_JPRB, 0.31229650E-11_JPRB, 0.37184886E-11_JPRB, 0.44137346E-11_JPRB, 0.52025198E-11_JPRB, 0.60774935E-11_JPRB, &
  & 0.70254367E-11_JPRB, 0.80368845E-11_JPRB, 0.91032364E-11_JPRB, 0.10216761E-10_JPRB, 0.11379240E-10_JPRB, 0.12597733E-10_JPRB, &
  & 0.13892882E-10_JPRB, 0.15255238E-10_JPRB, 0.16687369E-10_JPRB, 0.18172347E-10_JPRB, 0.19620913E-10_JPRB, 0.20966165E-10_JPRB, &
  & 0.22103576E-10_JPRB, 0.22974180E-10_JPRB, 0.23558757E-10_JPRB, 0.23863951E-10_JPRB, 0.23906970E-10_JPRB, 0.23704351E-10_JPRB, &
  & 0.23270158E-10_JPRB, 0.22635720E-10_JPRB, 0.21889988E-10_JPRB, 0.21146678E-10_JPRB, 0.20589299E-10_JPRB, 0.20294497E-10_JPRB, &
  & 0.20319899E-10_JPRB, 0.20648502E-10_JPRB, 0.21162221E-10_JPRB, 0.21731750E-10_JPRB, 0.22206235E-10_JPRB, 0.22498715E-10_JPRB, &
  & 0.22511184E-10_JPRB, 0.22224143E-10_JPRB, 0.21686663E-10_JPRB, 0.20971034E-10_JPRB, 0.20125009E-10_JPRB, 0.19224801E-10_JPRB, &
  & 0.18309831E-10_JPRB, 0.17401074E-10_JPRB, 0.16507887E-10_JPRB, 0.15647643E-10_JPRB, 0.14815350E-10_JPRB, 0.14008723E-10_JPRB, &
  & 0.13220286E-10_JPRB, 0.12452527E-10_JPRB, 0.11704982E-10_JPRB, 0.10976053E-10_JPRB, 0.10269510E-10_JPRB, 0.95890761E-11_JPRB, &
  & 0.89321658E-11_JPRB, 0.83045897E-11_JPRB, 0.75612789E-11_JPRB, 0.63898695E-11_JPRB /)

RGHG9(:,24,10) = (/ &
  & 0.16010323E-11_JPRB, 0.20175519E-11_JPRB, 0.23268440E-11_JPRB, 0.26324533E-11_JPRB, 0.29949058E-11_JPRB, 0.34388560E-11_JPRB, &
  & 0.39826727E-11_JPRB, 0.46411590E-11_JPRB, 0.54222312E-11_JPRB, 0.63293823E-11_JPRB, 0.73575356E-11_JPRB, 0.84945913E-11_JPRB, &
  & 0.97239760E-11_JPRB, 0.11030710E-10_JPRB, 0.12400048E-10_JPRB, 0.13815346E-10_JPRB, 0.15277569E-10_JPRB, 0.16794807E-10_JPRB, &
  & 0.18388707E-10_JPRB, 0.20072230E-10_JPRB, 0.21838979E-10_JPRB, 0.23667370E-10_JPRB, 0.25490575E-10_JPRB, 0.27217530E-10_JPRB, &
  & 0.28732941E-10_JPRB, 0.29966495E-10_JPRB, 0.30898215E-10_JPRB, 0.31535587E-10_JPRB, 0.31870624E-10_JPRB, 0.31900742E-10_JPRB, &
  & 0.31626559E-10_JPRB, 0.31076461E-10_JPRB, 0.30339342E-10_JPRB, 0.29569416E-10_JPRB, 0.28899879E-10_JPRB, 0.28467503E-10_JPRB, &
  & 0.28364497E-10_JPRB, 0.28541607E-10_JPRB, 0.28915637E-10_JPRB, 0.29353707E-10_JPRB, 0.29707931E-10_JPRB, 0.29875255E-10_JPRB, &
  & 0.29782839E-10_JPRB, 0.29380338E-10_JPRB, 0.28669303E-10_JPRB, 0.27735585E-10_JPRB, 0.26655950E-10_JPRB, 0.25507818E-10_JPRB, &
  & 0.24333740E-10_JPRB, 0.23180039E-10_JPRB, 0.22067622E-10_JPRB, 0.21015361E-10_JPRB, 0.20024996E-10_JPRB, 0.19078154E-10_JPRB, &
  & 0.18174068E-10_JPRB, 0.17303218E-10_JPRB, 0.16451300E-10_JPRB, 0.15607170E-10_JPRB, 0.14767349E-10_JPRB, 0.13935927E-10_JPRB, &
  & 0.13120630E-10_JPRB, 0.12284888E-10_JPRB, 0.11364963E-10_JPRB, 0.97359117E-11_JPRB /)

RGHG9(:,25,10) = (/ &
  & 0.25993845E-11_JPRB, 0.32046698E-11_JPRB, 0.36113840E-11_JPRB, 0.40118100E-11_JPRB, 0.44709271E-11_JPRB, 0.50283631E-11_JPRB, &
  & 0.57042010E-11_JPRB, 0.65150884E-11_JPRB, 0.74740223E-11_JPRB, 0.85839417E-11_JPRB, 0.98415182E-11_JPRB, 0.11233801E-10_JPRB, &
  & 0.12738329E-10_JPRB, 0.14336856E-10_JPRB, 0.16006295E-10_JPRB, 0.17722945E-10_JPRB, 0.19476516E-10_JPRB, 0.21274415E-10_JPRB, &
  & 0.23139426E-10_JPRB, 0.25082434E-10_JPRB, 0.27116948E-10_JPRB, 0.29211553E-10_JPRB, 0.31314500E-10_JPRB, 0.33326189E-10_JPRB, &
  & 0.35149481E-10_JPRB, 0.36708941E-10_JPRB, 0.37963535E-10_JPRB, 0.38876111E-10_JPRB, 0.39459734E-10_JPRB, 0.39720865E-10_JPRB, &
  & 0.39663304E-10_JPRB, 0.39306329E-10_JPRB, 0.38720634E-10_JPRB, 0.38051593E-10_JPRB, 0.37409287E-10_JPRB, 0.36923263E-10_JPRB, &
  & 0.36681776E-10_JPRB, 0.36668311E-10_JPRB, 0.36842841E-10_JPRB, 0.37063890E-10_JPRB, 0.37212677E-10_JPRB, 0.37170770E-10_JPRB, &
  & 0.36890119E-10_JPRB, 0.36328093E-10_JPRB, 0.35460308E-10_JPRB, 0.34345780E-10_JPRB, 0.33065394E-10_JPRB, 0.31713444E-10_JPRB, &
  & 0.30344598E-10_JPRB, 0.28997003E-10_JPRB, 0.27696019E-10_JPRB, 0.26480613E-10_JPRB, 0.25341437E-10_JPRB, 0.24283965E-10_JPRB, &
  & 0.23294956E-10_JPRB, 0.22350835E-10_JPRB, 0.21427932E-10_JPRB, 0.20508401E-10_JPRB, 0.19585594E-10_JPRB, 0.18658719E-10_JPRB, &
  & 0.17728610E-10_JPRB, 0.16769492E-10_JPRB, 0.15664497E-10_JPRB, 0.13695854E-10_JPRB /)

RGHG9(:,26,10) = (/ &
  & 0.39977453E-11_JPRB, 0.48420868E-11_JPRB, 0.53554227E-11_JPRB, 0.58448767E-11_JPRB, 0.63974295E-11_JPRB, 0.70556451E-11_JPRB, &
  & 0.78514912E-11_JPRB, 0.88020372E-11_JPRB, 0.99186449E-11_JPRB, 0.11213316E-10_JPRB, 0.12678746E-10_JPRB, 0.14304834E-10_JPRB, &
  & 0.16065460E-10_JPRB, 0.17937568E-10_JPRB, 0.19888889E-10_JPRB, 0.21885962E-10_JPRB, 0.23920744E-10_JPRB, 0.25970739E-10_JPRB, &
  & 0.28060528E-10_JPRB, 0.30209796E-10_JPRB, 0.32428147E-10_JPRB, 0.34702012E-10_JPRB, 0.36970201E-10_JPRB, 0.39158957E-10_JPRB, &
  & 0.41182967E-10_JPRB, 0.42935218E-10_JPRB, 0.44385367E-10_JPRB, 0.45519366E-10_JPRB, 0.46327324E-10_JPRB, 0.46811291E-10_JPRB, &
  & 0.46985183E-10_JPRB, 0.46873977E-10_JPRB, 0.46523105E-10_JPRB, 0.46044335E-10_JPRB, 0.45544981E-10_JPRB, 0.45088617E-10_JPRB, &
  & 0.44744510E-10_JPRB, 0.44558447E-10_JPRB, 0.44482099E-10_JPRB, 0.44434335E-10_JPRB, 0.44331885E-10_JPRB, 0.44066230E-10_JPRB, &
  & 0.43580889E-10_JPRB, 0.42834528E-10_JPRB, 0.41803460E-10_JPRB, 0.40527463E-10_JPRB, 0.39074799E-10_JPRB, 0.37529736E-10_JPRB, &
  & 0.35968041E-10_JPRB, 0.34453190E-10_JPRB, 0.33027334E-10_JPRB, 0.31707845E-10_JPRB, 0.30489389E-10_JPRB, 0.29369882E-10_JPRB, &
  & 0.28327760E-10_JPRB, 0.27334445E-10_JPRB, 0.26364523E-10_JPRB, 0.25398876E-10_JPRB, 0.24429302E-10_JPRB, 0.23453857E-10_JPRB, &
  & 0.22466041E-10_JPRB, 0.21450310E-10_JPRB, 0.20224069E-10_JPRB, 0.18120514E-10_JPRB /)

RGHG9(:,27,10) = (/ &
  & 0.58830458E-11_JPRB, 0.69970882E-11_JPRB, 0.76325448E-11_JPRB, 0.82116570E-11_JPRB, 0.88437712E-11_JPRB, 0.95968285E-11_JPRB, &
  & 0.10494038E-10_JPRB, 0.11561791E-10_JPRB, 0.12816827E-10_JPRB, 0.14263826E-10_JPRB, 0.15908422E-10_JPRB, 0.17734722E-10_JPRB, &
  & 0.19717970E-10_JPRB, 0.21828978E-10_JPRB, 0.24027719E-10_JPRB, 0.26289344E-10_JPRB, 0.28543152E-10_JPRB, 0.30821228E-10_JPRB, &
  & 0.33090097E-10_JPRB, 0.35398091E-10_JPRB, 0.37717239E-10_JPRB, 0.40076817E-10_JPRB, 0.42408022E-10_JPRB, 0.44659745E-10_JPRB, &
  & 0.46747349E-10_JPRB, 0.48587041E-10_JPRB, 0.50146484E-10_JPRB, 0.51403382E-10_JPRB, 0.52368124E-10_JPRB, 0.53044662E-10_JPRB, &
  & 0.53440655E-10_JPRB, 0.53577538E-10_JPRB, 0.53486472E-10_JPRB, 0.53237713E-10_JPRB, 0.52903619E-10_JPRB, 0.52536420E-10_JPRB, &
  & 0.52155218E-10_JPRB, 0.51817481E-10_JPRB, 0.51513797E-10_JPRB, 0.51202338E-10_JPRB, 0.50840353E-10_JPRB, 0.50349801E-10_JPRB, &
  & 0.49672225E-10_JPRB, 0.48759913E-10_JPRB, 0.47588728E-10_JPRB, 0.46181354E-10_JPRB, 0.44613185E-10_JPRB, 0.42972400E-10_JPRB, &
  & 0.41330901E-10_JPRB, 0.39717368E-10_JPRB, 0.38176233E-10_JPRB, 0.36743157E-10_JPRB, 0.35443457E-10_JPRB, 0.34259984E-10_JPRB, &
  & 0.33168916E-10_JPRB, 0.32143160E-10_JPRB, 0.31153566E-10_JPRB, 0.30176119E-10_JPRB, 0.29193127E-10_JPRB, 0.28197059E-10_JPRB, &
  & 0.27189704E-10_JPRB, 0.26119620E-10_JPRB, 0.24931163E-10_JPRB, 0.22680574E-10_JPRB /)

RGHG9(:,28,10) = (/ &
  & 0.83267473E-11_JPRB, 0.97308359E-11_JPRB, 0.10495474E-10_JPRB, 0.11157833E-10_JPRB, 0.11867528E-10_JPRB, 0.12690092E-10_JPRB, &
  & 0.13672238E-10_JPRB, 0.14833808E-10_JPRB, 0.16191317E-10_JPRB, 0.17764795E-10_JPRB, 0.19547336E-10_JPRB, 0.21533150E-10_JPRB, &
  & 0.23695381E-10_JPRB, 0.25998311E-10_JPRB, 0.28408919E-10_JPRB, 0.30861196E-10_JPRB, 0.33304557E-10_JPRB, 0.35754118E-10_JPRB, &
  & 0.38155250E-10_JPRB, 0.40551930E-10_JPRB, 0.42918488E-10_JPRB, 0.45284214E-10_JPRB, 0.47600614E-10_JPRB, 0.49818909E-10_JPRB, &
  & 0.51874970E-10_JPRB, 0.53704249E-10_JPRB, 0.55266850E-10_JPRB, 0.56587696E-10_JPRB, 0.57651973E-10_JPRB, 0.58467717E-10_JPRB, &
  & 0.59043347E-10_JPRB, 0.59393941E-10_JPRB, 0.59535640E-10_JPRB, 0.59504367E-10_JPRB, 0.59334926E-10_JPRB, 0.59056093E-10_JPRB, &
  & 0.58675072E-10_JPRB, 0.58236971E-10_JPRB, 0.57757729E-10_JPRB, 0.57232358E-10_JPRB, 0.56644796E-10_JPRB, 0.55951476E-10_JPRB, &
  & 0.55099200E-10_JPRB, 0.54045313E-10_JPRB, 0.52758735E-10_JPRB, 0.51252023E-10_JPRB, 0.49593090E-10_JPRB, 0.47855615E-10_JPRB, &
  & 0.46104447E-10_JPRB, 0.44394748E-10_JPRB, 0.42805832E-10_JPRB, 0.41353816E-10_JPRB, 0.40029535E-10_JPRB, 0.38823340E-10_JPRB, &
  & 0.37714953E-10_JPRB, 0.36675930E-10_JPRB, 0.35674991E-10_JPRB, 0.34684984E-10_JPRB, 0.33691206E-10_JPRB, 0.32689417E-10_JPRB, &
  & 0.31678982E-10_JPRB, 0.30665519E-10_JPRB, 0.29423585E-10_JPRB, 0.27307932E-10_JPRB /)

RGHG9(:,29,10) = (/ &
  & 0.11361564E-10_JPRB, 0.13040563E-10_JPRB, 0.13930163E-10_JPRB, 0.14672635E-10_JPRB, 0.15438905E-10_JPRB, 0.16322613E-10_JPRB, &
  & 0.17359208E-10_JPRB, 0.18586268E-10_JPRB, 0.20024593E-10_JPRB, 0.21680857E-10_JPRB, 0.23567199E-10_JPRB, 0.25667449E-10_JPRB, &
  & 0.27957379E-10_JPRB, 0.30400613E-10_JPRB, 0.32966820E-10_JPRB, 0.35536143E-10_JPRB, 0.38133677E-10_JPRB, 0.40683065E-10_JPRB, &
  & 0.43164160E-10_JPRB, 0.45592870E-10_JPRB, 0.47960136E-10_JPRB, 0.50274840E-10_JPRB, 0.52515162E-10_JPRB, 0.54642579E-10_JPRB, &
  & 0.56601307E-10_JPRB, 0.58351185E-10_JPRB, 0.59879324E-10_JPRB, 0.61188207E-10_JPRB, 0.62285115E-10_JPRB, 0.63178560E-10_JPRB, &
  & 0.63876335E-10_JPRB, 0.64384810E-10_JPRB, 0.64707274E-10_JPRB, 0.64852894E-10_JPRB, 0.64826047E-10_JPRB, 0.64633278E-10_JPRB, &
  & 0.64269076E-10_JPRB, 0.63770912E-10_JPRB, 0.63173182E-10_JPRB, 0.62495578E-10_JPRB, 0.61736977E-10_JPRB, 0.60883687E-10_JPRB, &
  & 0.59897809E-10_JPRB, 0.58731721E-10_JPRB, 0.57367007E-10_JPRB, 0.55796111E-10_JPRB, 0.54077902E-10_JPRB, 0.52285447E-10_JPRB, &
  & 0.50484242E-10_JPRB, 0.48764544E-10_JPRB, 0.47161754E-10_JPRB, 0.45685563E-10_JPRB, 0.44340143E-10_JPRB, 0.43116861E-10_JPRB, &
  & 0.41990463E-10_JPRB, 0.40932254E-10_JPRB, 0.39912323E-10_JPRB, 0.38909622E-10_JPRB, 0.37914560E-10_JPRB, 0.36932551E-10_JPRB, &
  & 0.35965675E-10_JPRB, 0.34943468E-10_JPRB, 0.33791935E-10_JPRB, 0.31664928E-10_JPRB /)

RGHG9(:,30,10) = (/ &
  & 0.14948511E-10_JPRB, 0.16890950E-10_JPRB, 0.17876804E-10_JPRB, 0.18681313E-10_JPRB, 0.19495114E-10_JPRB, 0.20405573E-10_JPRB, &
  & 0.21481518E-10_JPRB, 0.22748057E-10_JPRB, 0.24225826E-10_JPRB, 0.25939346E-10_JPRB, 0.27883409E-10_JPRB, 0.30053543E-10_JPRB, &
  & 0.32419761E-10_JPRB, 0.34951410E-10_JPRB, 0.37593512E-10_JPRB, 0.40243756E-10_JPRB, 0.42910363E-10_JPRB, 0.45513565E-10_JPRB, &
  & 0.48021670E-10_JPRB, 0.50438244E-10_JPRB, 0.52762211E-10_JPRB, 0.54994651E-10_JPRB, 0.57120638E-10_JPRB, 0.59117419E-10_JPRB, &
  & 0.60941335E-10_JPRB, 0.62572121E-10_JPRB, 0.64011477E-10_JPRB, 0.65268888E-10_JPRB, 0.66355185E-10_JPRB, 0.67276150E-10_JPRB, &
  & 0.68041565E-10_JPRB, 0.68649843E-10_JPRB, 0.69094050E-10_JPRB, 0.69364278E-10_JPRB, 0.69443611E-10_JPRB, 0.69322645E-10_JPRB, &
  & 0.68987878E-10_JPRB, 0.68469536E-10_JPRB, 0.67801043E-10_JPRB, 0.67028959E-10_JPRB, 0.66155907E-10_JPRB, 0.65192601E-10_JPRB, &
  & 0.64113416E-10_JPRB, 0.62877994E-10_JPRB, 0.61462363E-10_JPRB, 0.59865196E-10_JPRB, 0.58128502E-10_JPRB, 0.56327963E-10_JPRB, &
  & 0.54544688E-10_JPRB, 0.52842279E-10_JPRB, 0.51231932E-10_JPRB, 0.49735494E-10_JPRB, 0.48368531E-10_JPRB, 0.47124197E-10_JPRB, &
  & 0.45978318E-10_JPRB, 0.44904608E-10_JPRB, 0.43879969E-10_JPRB, 0.42885123E-10_JPRB, 0.41910343E-10_JPRB, 0.40942780E-10_JPRB, &
  & 0.39963099E-10_JPRB, 0.38964876E-10_JPRB, 0.37788637E-10_JPRB, 0.35789639E-10_JPRB /)

RGHG9(:,31,10) = (/ &
  & 0.19023944E-10_JPRB, 0.21148016E-10_JPRB, 0.22218186E-10_JPRB, 0.23070969E-10_JPRB, 0.23896642E-10_JPRB, 0.24830957E-10_JPRB, &
  & 0.25915659E-10_JPRB, 0.27194077E-10_JPRB, 0.28691185E-10_JPRB, 0.30416697E-10_JPRB, 0.32383742E-10_JPRB, 0.34576512E-10_JPRB, &
  & 0.36966492E-10_JPRB, 0.39526687E-10_JPRB, 0.42183361E-10_JPRB, 0.44862204E-10_JPRB, 0.47534959E-10_JPRB, 0.50136416E-10_JPRB, &
  & 0.52628728E-10_JPRB, 0.55003578E-10_JPRB, 0.57258379E-10_JPRB, 0.59388758E-10_JPRB, 0.61384592E-10_JPRB, 0.63233377E-10_JPRB, &
  & 0.64910917E-10_JPRB, 0.66404757E-10_JPRB, 0.67733610E-10_JPRB, 0.68907768E-10_JPRB, 0.69945147E-10_JPRB, 0.70853913E-10_JPRB, &
  & 0.71639375E-10_JPRB, 0.72295676E-10_JPRB, 0.72805817E-10_JPRB, 0.73149563E-10_JPRB, 0.73296598E-10_JPRB, 0.73226245E-10_JPRB, &
  & 0.72923979E-10_JPRB, 0.72410404E-10_JPRB, 0.71714648E-10_JPRB, 0.70895588E-10_JPRB, 0.69960995E-10_JPRB, 0.68930667E-10_JPRB, &
  & 0.67798434E-10_JPRB, 0.66523134E-10_JPRB, 0.65085458E-10_JPRB, 0.63482115E-10_JPRB, 0.61746976E-10_JPRB, 0.59954229E-10_JPRB, &
  & 0.58180828E-10_JPRB, 0.56476282E-10_JPRB, 0.54868679E-10_JPRB, 0.53394976E-10_JPRB, 0.52057279E-10_JPRB, 0.50831755E-10_JPRB, &
  & 0.49693978E-10_JPRB, 0.48621975E-10_JPRB, 0.47594904E-10_JPRB, 0.46593337E-10_JPRB, 0.45601016E-10_JPRB, 0.44615929E-10_JPRB, &
  & 0.43647481E-10_JPRB, 0.42661669E-10_JPRB, 0.41574782E-10_JPRB, 0.39580901E-10_JPRB /)

RGHG9(:,32,10) = (/ &
  & 0.23426585E-10_JPRB, 0.25682807E-10_JPRB, 0.26792740E-10_JPRB, 0.27665009E-10_JPRB, 0.28517648E-10_JPRB, 0.29445658E-10_JPRB, &
  & 0.30530630E-10_JPRB, 0.31801901E-10_JPRB, 0.33282328E-10_JPRB, 0.34995888E-10_JPRB, 0.36940086E-10_JPRB, 0.39108106E-10_JPRB, &
  & 0.41472159E-10_JPRB, 0.44000296E-10_JPRB, 0.46619292E-10_JPRB, 0.49273721E-10_JPRB, 0.51907416E-10_JPRB, 0.54467136E-10_JPRB, &
  & 0.56911646E-10_JPRB, 0.59229212E-10_JPRB, 0.61398706E-10_JPRB, 0.63419540E-10_JPRB, 0.65287754E-10_JPRB, 0.66991530E-10_JPRB, &
  & 0.68520668E-10_JPRB, 0.69876008E-10_JPRB, 0.71079684E-10_JPRB, 0.72157787E-10_JPRB, 0.73125610E-10_JPRB, 0.73992631E-10_JPRB, &
  & 0.74761794E-10_JPRB, 0.75421849E-10_JPRB, 0.75951433E-10_JPRB, 0.76323586E-10_JPRB, 0.76504185E-10_JPRB, 0.76464522E-10_JPRB, &
  & 0.76191768E-10_JPRB, 0.75697185E-10_JPRB, 0.75006834E-10_JPRB, 0.74176540E-10_JPRB, 0.73221151E-10_JPRB, 0.72163407E-10_JPRB, &
  & 0.71001816E-10_JPRB, 0.69717593E-10_JPRB, 0.68277016E-10_JPRB, 0.66689820E-10_JPRB, 0.64995377E-10_JPRB, 0.63253972E-10_JPRB, &
  & 0.61533549E-10_JPRB, 0.59871316E-10_JPRB, 0.58310794E-10_JPRB, 0.56873214E-10_JPRB, 0.55552146E-10_JPRB, 0.54332559E-10_JPRB, &
  & 0.53192239E-10_JPRB, 0.52109449E-10_JPRB, 0.51066637E-10_JPRB, 0.50046495E-10_JPRB, 0.49047839E-10_JPRB, 0.48077410E-10_JPRB, &
  & 0.47129006E-10_JPRB, 0.46178540E-10_JPRB, 0.45046206E-10_JPRB, 0.43136428E-10_JPRB /)

RGHG9(:,33,10) = (/ &
  & 0.28001998E-10_JPRB, 0.30301549E-10_JPRB, 0.31428804E-10_JPRB, 0.32325625E-10_JPRB, 0.33172590E-10_JPRB, 0.34109583E-10_JPRB, &
  & 0.35179110E-10_JPRB, 0.36428863E-10_JPRB, 0.37880872E-10_JPRB, 0.39543948E-10_JPRB, 0.41432482E-10_JPRB, 0.43532247E-10_JPRB, &
  & 0.45820962E-10_JPRB, 0.48263685E-10_JPRB, 0.50805124E-10_JPRB, 0.53381424E-10_JPRB, 0.55944666E-10_JPRB, 0.58430594E-10_JPRB, &
  & 0.60811314E-10_JPRB, 0.63052341E-10_JPRB, 0.65142579E-10_JPRB, 0.67069614E-10_JPRB, 0.68821462E-10_JPRB, 0.70398069E-10_JPRB, &
  & 0.71792253E-10_JPRB, 0.73018050E-10_JPRB, 0.74102821E-10_JPRB, 0.75074481E-10_JPRB, 0.75957449E-10_JPRB, 0.76760119E-10_JPRB, &
  & 0.77482402E-10_JPRB, 0.78111129E-10_JPRB, 0.78621748E-10_JPRB, 0.78987358E-10_JPRB, 0.79172939E-10_JPRB, 0.79147772E-10_JPRB, &
  & 0.78900303E-10_JPRB, 0.78433614E-10_JPRB, 0.77769180E-10_JPRB, 0.76954901E-10_JPRB, 0.76009719E-10_JPRB, 0.74949436E-10_JPRB, &
  & 0.73786879E-10_JPRB, 0.72508298E-10_JPRB, 0.71085957E-10_JPRB, 0.69536363E-10_JPRB, 0.67897715E-10_JPRB, 0.66221056E-10_JPRB, &
  & 0.64563223E-10_JPRB, 0.62966722E-10_JPRB, 0.61468039E-10_JPRB, 0.60077367E-10_JPRB, 0.58790396E-10_JPRB, 0.57587209E-10_JPRB, &
  & 0.56452260E-10_JPRB, 0.55366982E-10_JPRB, 0.54317120E-10_JPRB, 0.53297377E-10_JPRB, 0.52304557E-10_JPRB, 0.51335818E-10_JPRB, &
  & 0.50387725E-10_JPRB, 0.49420100E-10_JPRB, 0.48357526E-10_JPRB, 0.46463423E-10_JPRB /)

RGHG9(:,34,10) = (/ &
  & 0.32570630E-10_JPRB, 0.34859091E-10_JPRB, 0.35993795E-10_JPRB, 0.36879777E-10_JPRB, 0.37751250E-10_JPRB, 0.38669859E-10_JPRB, &
  & 0.39729706E-10_JPRB, 0.40950601E-10_JPRB, 0.42350169E-10_JPRB, 0.43950191E-10_JPRB, 0.45749290E-10_JPRB, 0.47746057E-10_JPRB, &
  & 0.49920890E-10_JPRB, 0.52242221E-10_JPRB, 0.54664832E-10_JPRB, 0.57135102E-10_JPRB, 0.59597251E-10_JPRB, 0.61997719E-10_JPRB, &
  & 0.64300426E-10_JPRB, 0.66471190E-10_JPRB, 0.68489027E-10_JPRB, 0.70336986E-10_JPRB, 0.71996395E-10_JPRB, 0.73465865E-10_JPRB, &
  & 0.74748492E-10_JPRB, 0.75858007E-10_JPRB, 0.76831201E-10_JPRB, 0.77699444E-10_JPRB, 0.78487689E-10_JPRB, 0.79208522E-10_JPRB, &
  & 0.79860216E-10_JPRB, 0.80429323E-10_JPRB, 0.80892015E-10_JPRB, 0.81224173E-10_JPRB, 0.81393045E-10_JPRB, 0.81370535E-10_JPRB, &
  & 0.81145819E-10_JPRB, 0.80712471E-10_JPRB, 0.80088519E-10_JPRB, 0.79310690E-10_JPRB, 0.78393250E-10_JPRB, 0.77352860E-10_JPRB, &
  & 0.76209379E-10_JPRB, 0.74946861E-10_JPRB, 0.73556168E-10_JPRB, 0.72060136E-10_JPRB, 0.70490065E-10_JPRB, 0.68892815E-10_JPRB, &
  & 0.67318935E-10_JPRB, 0.65797437E-10_JPRB, 0.64359240E-10_JPRB, 0.63021685E-10_JPRB, 0.61773670E-10_JPRB, 0.60604577E-10_JPRB, &
  & 0.59492765E-10_JPRB, 0.58422406E-10_JPRB, 0.57381939E-10_JPRB, 0.56361429E-10_JPRB, 0.55358551E-10_JPRB, 0.54382814E-10_JPRB, &
  & 0.53439218E-10_JPRB, 0.52513625E-10_JPRB, 0.51456419E-10_JPRB, 0.49621664E-10_JPRB /)

RGHG9(:,35,10) = (/ &
  & 0.36993499E-10_JPRB, 0.39236409E-10_JPRB, 0.40347725E-10_JPRB, 0.41251266E-10_JPRB, 0.42104473E-10_JPRB, 0.43034867E-10_JPRB, &
  & 0.44071115E-10_JPRB, 0.45253495E-10_JPRB, 0.46598239E-10_JPRB, 0.48110928E-10_JPRB, 0.49806742E-10_JPRB, 0.51675761E-10_JPRB, &
  & 0.53710942E-10_JPRB, 0.55883999E-10_JPRB, 0.58165806E-10_JPRB, 0.60504296E-10_JPRB, 0.62851856E-10_JPRB, 0.65157026E-10_JPRB, &
  & 0.67383259E-10_JPRB, 0.69490212E-10_JPRB, 0.71450436E-10_JPRB, 0.73236299E-10_JPRB, 0.74829989E-10_JPRB, 0.76222390E-10_JPRB, &
  & 0.77413666E-10_JPRB, 0.78426918E-10_JPRB, 0.79295626E-10_JPRB, 0.80059251E-10_JPRB, 0.80745383E-10_JPRB, 0.81369293E-10_JPRB, &
  & 0.81930795E-10_JPRB, 0.82419377E-10_JPRB, 0.82813242E-10_JPRB, 0.83093199E-10_JPRB, 0.83230922E-10_JPRB, 0.83204610E-10_JPRB, &
  & 0.83001842E-10_JPRB, 0.82609100E-10_JPRB, 0.82038612E-10_JPRB, 0.81311416E-10_JPRB, 0.80435665E-10_JPRB, 0.79434057E-10_JPRB, &
  & 0.78316909E-10_JPRB, 0.77080113E-10_JPRB, 0.75730623E-10_JPRB, 0.74294404E-10_JPRB, 0.72800210E-10_JPRB, 0.71290890E-10_JPRB, &
  & 0.69803489E-10_JPRB, 0.68367777E-10_JPRB, 0.67001377E-10_JPRB, 0.65724426E-10_JPRB, 0.64529743E-10_JPRB, 0.63400812E-10_JPRB, &
  & 0.62320545E-10_JPRB, 0.61274576E-10_JPRB, 0.60245663E-10_JPRB, 0.59228032E-10_JPRB, 0.58231468E-10_JPRB, 0.57269078E-10_JPRB, &
  & 0.56345168E-10_JPRB, 0.55420588E-10_JPRB, 0.54387671E-10_JPRB, 0.52600955E-10_JPRB /)

RGHG9(:,36,10) = (/ &
  & 0.41214053E-10_JPRB, 0.43363906E-10_JPRB, 0.44460720E-10_JPRB, 0.45336415E-10_JPRB, 0.46205467E-10_JPRB, 0.47116096E-10_JPRB, &
  & 0.48135364E-10_JPRB, 0.49276111E-10_JPRB, 0.50551497E-10_JPRB, 0.51978102E-10_JPRB, 0.53554480E-10_JPRB, 0.55285033E-10_JPRB, &
  & 0.57162514E-10_JPRB, 0.59175428E-10_JPRB, 0.61296287E-10_JPRB, 0.63495702E-10_JPRB, 0.65712304E-10_JPRB, 0.67922279E-10_JPRB, &
  & 0.70067119E-10_JPRB, 0.72123342E-10_JPRB, 0.74046831E-10_JPRB, 0.75802399E-10_JPRB, 0.77353457E-10_JPRB, 0.78689014E-10_JPRB, &
  & 0.79804344E-10_JPRB, 0.80722581E-10_JPRB, 0.81489669E-10_JPRB, 0.82145638E-10_JPRB, 0.82723280E-10_JPRB, 0.83239533E-10_JPRB, &
  & 0.83699311E-10_JPRB, 0.84092053E-10_JPRB, 0.84404615E-10_JPRB, 0.84621546E-10_JPRB, 0.84721126E-10_JPRB, 0.84689721E-10_JPRB, &
  & 0.84512064E-10_JPRB, 0.84170920E-10_JPRB, 0.83669287E-10_JPRB, 0.83008551E-10_JPRB, 0.82194758E-10_JPRB, 0.81241396E-10_JPRB, &
  & 0.80159268E-10_JPRB, 0.78954079E-10_JPRB, 0.77649449E-10_JPRB, 0.76277484E-10_JPRB, 0.74863338E-10_JPRB, 0.73440309E-10_JPRB, &
  & 0.72039541E-10_JPRB, 0.70684791E-10_JPRB, 0.69387815E-10_JPRB, 0.68173134E-10_JPRB, 0.67034475E-10_JPRB, 0.65958669E-10_JPRB, &
  & 0.64921991E-10_JPRB, 0.63911369E-10_JPRB, 0.62912758E-10_JPRB, 0.61918859E-10_JPRB, 0.60939934E-10_JPRB, 0.59987557E-10_JPRB, &
  & 0.59069152E-10_JPRB, 0.58167773E-10_JPRB, 0.57166660E-10_JPRB, 0.55421338E-10_JPRB /)

RGHG9(:,37,10) = (/ &
  & 0.45230063E-10_JPRB, 0.47247910E-10_JPRB, 0.48294563E-10_JPRB, 0.49165051E-10_JPRB, 0.50011755E-10_JPRB, 0.50923009E-10_JPRB, &
  & 0.51910934E-10_JPRB, 0.53004157E-10_JPRB, 0.54211781E-10_JPRB, 0.55539261E-10_JPRB, 0.56994492E-10_JPRB, 0.58574826E-10_JPRB, &
  & 0.60287303E-10_JPRB, 0.62127602E-10_JPRB, 0.64083544E-10_JPRB, 0.66130344E-10_JPRB, 0.68224572E-10_JPRB, 0.70319639E-10_JPRB, &
  & 0.72394923E-10_JPRB, 0.74402352E-10_JPRB, 0.76301375E-10_JPRB, 0.78034919E-10_JPRB, 0.79551699E-10_JPRB, 0.80818796E-10_JPRB, &
  & 0.81841603E-10_JPRB, 0.82654397E-10_JPRB, 0.83308777E-10_JPRB, 0.83852494E-10_JPRB, 0.84319107E-10_JPRB, 0.84727128E-10_JPRB, &
  & 0.85081026E-10_JPRB, 0.85378878E-10_JPRB, 0.85609596E-10_JPRB, 0.85764541E-10_JPRB, 0.85828934E-10_JPRB, 0.85796377E-10_JPRB, &
  & 0.85650202E-10_JPRB, 0.85375956E-10_JPRB, 0.84963217E-10_JPRB, 0.84399709E-10_JPRB, 0.83677766E-10_JPRB, 0.82799378E-10_JPRB, &
  & 0.81769855E-10_JPRB, 0.80608631E-10_JPRB, 0.79357201E-10_JPRB, 0.78046021E-10_JPRB, 0.76706842E-10_JPRB, 0.75367240E-10_JPRB, &
  & 0.74045159E-10_JPRB, 0.72762490E-10_JPRB, 0.71534112E-10_JPRB, 0.70378307E-10_JPRB, 0.69300496E-10_JPRB, 0.68281526E-10_JPRB, &
  & 0.67302053E-10_JPRB, 0.66345589E-10_JPRB, 0.65396064E-10_JPRB, 0.64439121E-10_JPRB, 0.63485051E-10_JPRB, 0.62552741E-10_JPRB, &
  & 0.61656603E-10_JPRB, 0.60773886E-10_JPRB, 0.59785871E-10_JPRB, 0.58088166E-10_JPRB /)

RGHG9(:,38,10) = (/ &
  & 0.49072212E-10_JPRB, 0.50917336E-10_JPRB, 0.51898270E-10_JPRB, 0.52729918E-10_JPRB, 0.53569243E-10_JPRB, 0.54457727E-10_JPRB, &
  & 0.55420418E-10_JPRB, 0.56462036E-10_JPRB, 0.57592778E-10_JPRB, 0.58818984E-10_JPRB, 0.60143321E-10_JPRB, 0.61568681E-10_JPRB, &
  & 0.63107193E-10_JPRB, 0.64771050E-10_JPRB, 0.66559432E-10_JPRB, 0.68449045E-10_JPRB, 0.70419892E-10_JPRB, 0.72415782E-10_JPRB, &
  & 0.74406301E-10_JPRB, 0.76353424E-10_JPRB, 0.78208447E-10_JPRB, 0.79890067E-10_JPRB, 0.81325176E-10_JPRB, 0.82485095E-10_JPRB, &
  & 0.83380920E-10_JPRB, 0.84066636E-10_JPRB, 0.84602617E-10_JPRB, 0.85037651E-10_JPRB, 0.85403351E-10_JPRB, 0.85717107E-10_JPRB, &
  & 0.85986010E-10_JPRB, 0.86207208E-10_JPRB, 0.86376073E-10_JPRB, 0.86484556E-10_JPRB, 0.86525370E-10_JPRB, 0.86496137E-10_JPRB, &
  & 0.86383040E-10_JPRB, 0.86176372E-10_JPRB, 0.85861443E-10_JPRB, 0.85416660E-10_JPRB, 0.84823357E-10_JPRB, 0.84061501E-10_JPRB, &
  & 0.83127318E-10_JPRB, 0.82047119E-10_JPRB, 0.80861318E-10_JPRB, 0.79620338E-10_JPRB, 0.78356051E-10_JPRB, 0.77092943E-10_JPRB, &
  & 0.75842256E-10_JPRB, 0.74623190E-10_JPRB, 0.73453826E-10_JPRB, 0.72354983E-10_JPRB, 0.71336527E-10_JPRB, 0.70383213E-10_JPRB, &
  & 0.69473857E-10_JPRB, 0.68585249E-10_JPRB, 0.67699228E-10_JPRB, 0.66795340E-10_JPRB, 0.65884617E-10_JPRB, 0.64984455E-10_JPRB, &
  & 0.64110300E-10_JPRB, 0.63243785E-10_JPRB, 0.62284733E-10_JPRB, 0.60612189E-10_JPRB /)

RGHG9(:,39,10) = (/ &
  & 0.52743466E-10_JPRB, 0.54380823E-10_JPRB, 0.55278764E-10_JPRB, 0.56074118E-10_JPRB, 0.56886329E-10_JPRB, 0.57758468E-10_JPRB, &
  & 0.58686958E-10_JPRB, 0.59673516E-10_JPRB, 0.60722059E-10_JPRB, 0.61839617E-10_JPRB, 0.63027389E-10_JPRB, 0.64292752E-10_JPRB, &
  & 0.65656890E-10_JPRB, 0.67141105E-10_JPRB, 0.68761351E-10_JPRB, 0.70500973E-10_JPRB, 0.72328171E-10_JPRB, 0.74219256E-10_JPRB, &
  & 0.76123198E-10_JPRB, 0.77999149E-10_JPRB, 0.79766735E-10_JPRB, 0.81342211E-10_JPRB, 0.82641879E-10_JPRB, 0.83649560E-10_JPRB, &
  & 0.84403616E-10_JPRB, 0.84965854E-10_JPRB, 0.85399257E-10_JPRB, 0.85747555E-10_JPRB, 0.86038870E-10_JPRB, 0.86287873E-10_JPRB, &
  & 0.86499821E-10_JPRB, 0.86673571E-10_JPRB, 0.86804154E-10_JPRB, 0.86885062E-10_JPRB, 0.86913102E-10_JPRB, 0.86887636E-10_JPRB, &
  & 0.86798985E-10_JPRB, 0.86643352E-10_JPRB, 0.86405813E-10_JPRB, 0.86068180E-10_JPRB, 0.85604059E-10_JPRB, 0.84984263E-10_JPRB, &
  & 0.84192750E-10_JPRB, 0.83238264E-10_JPRB, 0.82158384E-10_JPRB, 0.81002947E-10_JPRB, 0.79818749E-10_JPRB, 0.78629506E-10_JPRB, &
  & 0.77447146E-10_JPRB, 0.76284756E-10_JPRB, 0.75168073E-10_JPRB, 0.74124616E-10_JPRB, 0.73164481E-10_JPRB, 0.72280473E-10_JPRB, &
  & 0.71446307E-10_JPRB, 0.70638134E-10_JPRB, 0.69826464E-10_JPRB, 0.68993249E-10_JPRB, 0.68136975E-10_JPRB, 0.67278218E-10_JPRB, &
  & 0.66433095E-10_JPRB, 0.65595362E-10_JPRB, 0.64650979E-10_JPRB, 0.63018570E-10_JPRB /)

RGHG9(:,40,10) = (/ &
  & 0.56223127E-10_JPRB, 0.57641315E-10_JPRB, 0.58459258E-10_JPRB, 0.59203177E-10_JPRB, 0.59990596E-10_JPRB, 0.60839937E-10_JPRB, &
  & 0.61733132E-10_JPRB, 0.62659163E-10_JPRB, 0.63621414E-10_JPRB, 0.64623494E-10_JPRB, 0.65673099E-10_JPRB, 0.66779915E-10_JPRB, &
  & 0.67971746E-10_JPRB, 0.69282823E-10_JPRB, 0.70734654E-10_JPRB, 0.72325888E-10_JPRB, 0.74025619E-10_JPRB, 0.75791533E-10_JPRB, &
  & 0.77590739E-10_JPRB, 0.79357701E-10_JPRB, 0.81009380E-10_JPRB, 0.82431388E-10_JPRB, 0.83567257E-10_JPRB, 0.84424072E-10_JPRB, &
  & 0.85052056E-10_JPRB, 0.85517711E-10_JPRB, 0.85875834E-10_JPRB, 0.86164742E-10_JPRB, 0.86406916E-10_JPRB, 0.86614965E-10_JPRB, &
  & 0.86792601E-10_JPRB, 0.86938075E-10_JPRB, 0.87047036E-10_JPRB, 0.87111977E-10_JPRB, 0.87133280E-10_JPRB, 0.87110014E-10_JPRB, &
  & 0.87036905E-10_JPRB, 0.86913338E-10_JPRB, 0.86728111E-10_JPRB, 0.86466556E-10_JPRB, 0.86105789E-10_JPRB, 0.85615293E-10_JPRB, &
  & 0.84975339E-10_JPRB, 0.84176263E-10_JPRB, 0.83233836E-10_JPRB, 0.82191046E-10_JPRB, 0.81101278E-10_JPRB, 0.79990833E-10_JPRB, &
  & 0.78873547E-10_JPRB, 0.77768500E-10_JPRB, 0.76699910E-10_JPRB, 0.75705199E-10_JPRB, 0.74805960E-10_JPRB, 0.73990945E-10_JPRB, &
  & 0.73237937E-10_JPRB, 0.72511011E-10_JPRB, 0.71782580E-10_JPRB, 0.71024193E-10_JPRB, 0.70234964E-10_JPRB, 0.69428768E-10_JPRB, &
  & 0.68628811E-10_JPRB, 0.67820249E-10_JPRB, 0.66914314E-10_JPRB, 0.65313213E-10_JPRB /)

RGHG9(:,41,10) = (/ &
  & 0.59472781E-10_JPRB, 0.60707529E-10_JPRB, 0.61437834E-10_JPRB, 0.62135436E-10_JPRB, 0.62895009E-10_JPRB, 0.63720508E-10_JPRB, &
  & 0.64577815E-10_JPRB, 0.65440653E-10_JPRB, 0.66312247E-10_JPRB, 0.67200565E-10_JPRB, 0.68112460E-10_JPRB, 0.69066211E-10_JPRB, &
  & 0.70095492E-10_JPRB, 0.71240118E-10_JPRB, 0.72531335E-10_JPRB, 0.73970427E-10_JPRB, 0.75530956E-10_JPRB, 0.77175821E-10_JPRB, &
  & 0.78852785E-10_JPRB, 0.80496151E-10_JPRB, 0.81992871E-10_JPRB, 0.83251135E-10_JPRB, 0.84226744E-10_JPRB, 0.84951234E-10_JPRB, &
  & 0.85481670E-10_JPRB, 0.85876015E-10_JPRB, 0.86181791E-10_JPRB, 0.86429940E-10_JPRB, 0.86639730E-10_JPRB, 0.86821016E-10_JPRB, &
  & 0.86976995E-10_JPRB, 0.87105045E-10_JPRB, 0.87200663E-10_JPRB, 0.87255821E-10_JPRB, 0.87273022E-10_JPRB, 0.87250693E-10_JPRB, &
  & 0.87187375E-10_JPRB, 0.87084291E-10_JPRB, 0.86932968E-10_JPRB, 0.86724114E-10_JPRB, 0.86437503E-10_JPRB, 0.86050334E-10_JPRB, &
  & 0.85541768E-10_JPRB, 0.84893072E-10_JPRB, 0.84100206E-10_JPRB, 0.83196422E-10_JPRB, 0.82209080E-10_JPRB, 0.81185253E-10_JPRB, &
  & 0.80140991E-10_JPRB, 0.79090741E-10_JPRB, 0.78070543E-10_JPRB, 0.77129254E-10_JPRB, 0.76286699E-10_JPRB, 0.75543516E-10_JPRB, &
  & 0.74866557E-10_JPRB, 0.74222802E-10_JPRB, 0.73573966E-10_JPRB, 0.72895377E-10_JPRB, 0.72177653E-10_JPRB, 0.71436364E-10_JPRB, &
  & 0.70687324E-10_JPRB, 0.69932442E-10_JPRB, 0.69066128E-10_JPRB, 0.67534041E-10_JPRB /)

RGHG9(:,42,10) = (/ &
  & 0.62493913E-10_JPRB, 0.63568255E-10_JPRB, 0.64229337E-10_JPRB, 0.64882336E-10_JPRB, 0.65616859E-10_JPRB, 0.66425455E-10_JPRB, &
  & 0.67243350E-10_JPRB, 0.68044480E-10_JPRB, 0.68827118E-10_JPRB, 0.69602740E-10_JPRB, 0.70385323E-10_JPRB, 0.71195792E-10_JPRB, &
  & 0.72072584E-10_JPRB, 0.73061536E-10_JPRB, 0.74199272E-10_JPRB, 0.75492279E-10_JPRB, 0.76915592E-10_JPRB, 0.78425946E-10_JPRB, &
  & 0.79972494E-10_JPRB, 0.81467916E-10_JPRB, 0.82804312E-10_JPRB, 0.83891040E-10_JPRB, 0.84721508E-10_JPRB, 0.85335627E-10_JPRB, &
  & 0.85788085E-10_JPRB, 0.86129423E-10_JPRB, 0.86396931E-10_JPRB, 0.86616291E-10_JPRB, 0.86803224E-10_JPRB, 0.86966226E-10_JPRB, &
  & 0.87107349E-10_JPRB, 0.87223700E-10_JPRB, 0.87310346E-10_JPRB, 0.87358780E-10_JPRB, 0.87373060E-10_JPRB, 0.87350932E-10_JPRB, &
  & 0.87294255E-10_JPRB, 0.87204612E-10_JPRB, 0.87077082E-10_JPRB, 0.86904817E-10_JPRB, 0.86672960E-10_JPRB, 0.86363999E-10_JPRB, &
  & 0.85961044E-10_JPRB, 0.85442362E-10_JPRB, 0.84801541E-10_JPRB, 0.84029943E-10_JPRB, 0.83165759E-10_JPRB, 0.82231902E-10_JPRB, &
  & 0.81261123E-10_JPRB, 0.80274710E-10_JPRB, 0.79309469E-10_JPRB, 0.78419750E-10_JPRB, 0.77641851E-10_JPRB, 0.76966766E-10_JPRB, &
  & 0.76365372E-10_JPRB, 0.75797375E-10_JPRB, 0.75226471E-10_JPRB, 0.74624050E-10_JPRB, 0.73980759E-10_JPRB, 0.73308699E-10_JPRB, &
  & 0.72630693E-10_JPRB, 0.71936734E-10_JPRB, 0.71144562E-10_JPRB, 0.69708808E-10_JPRB /)

RGHG9(:,43,10) = (/ &
  & 0.65294443E-10_JPRB, 0.66246286E-10_JPRB, 0.66847437E-10_JPRB, 0.67464999E-10_JPRB, 0.68183632E-10_JPRB, 0.68973507E-10_JPRB, &
  & 0.69759629E-10_JPRB, 0.70498454E-10_JPRB, 0.71195945E-10_JPRB, 0.71867928E-10_JPRB, 0.72529607E-10_JPRB, 0.73209570E-10_JPRB, &
  & 0.73947674E-10_JPRB, 0.74791062E-10_JPRB, 0.75782540E-10_JPRB, 0.76933286E-10_JPRB, 0.78216641E-10_JPRB, 0.79591708E-10_JPRB, &
  & 0.80994642E-10_JPRB, 0.82331676E-10_JPRB, 0.83488536E-10_JPRB, 0.84413261E-10_JPRB, 0.85111224E-10_JPRB, 0.85632230E-10_JPRB, &
  & 0.86022342E-10_JPRB, 0.86321769E-10_JPRB, 0.86560314E-10_JPRB, 0.86758295E-10_JPRB, 0.86928527E-10_JPRB, 0.87078143E-10_JPRB, &
  & 0.87208622E-10_JPRB, 0.87316460E-10_JPRB, 0.87396534E-10_JPRB, 0.87439903E-10_JPRB, 0.87451719E-10_JPRB, 0.87429550E-10_JPRB, &
  & 0.87377452E-10_JPRB, 0.87297523E-10_JPRB, 0.87187063E-10_JPRB, 0.87041943E-10_JPRB, 0.86850860E-10_JPRB, 0.86602218E-10_JPRB, &
  & 0.86281801E-10_JPRB, 0.85874807E-10_JPRB, 0.85360531E-10_JPRB, 0.84731999E-10_JPRB, 0.83980059E-10_JPRB, 0.83148342E-10_JPRB, &
  & 0.82259241E-10_JPRB, 0.81340920E-10_JPRB, 0.80438864E-10_JPRB, 0.79613552E-10_JPRB, 0.78899387E-10_JPRB, 0.78293309E-10_JPRB, &
  & 0.77763289E-10_JPRB, 0.77266069E-10_JPRB, 0.76766864E-10_JPRB, 0.76237266E-10_JPRB, 0.75668125E-10_JPRB, 0.75072809E-10_JPRB, &
  & 0.74470492E-10_JPRB, 0.73861181E-10_JPRB, 0.73158979E-10_JPRB, 0.71875519E-10_JPRB /)

RGHG9(:,44,10) = (/ &
  & 0.67913633E-10_JPRB, 0.68769844E-10_JPRB, 0.69325136E-10_JPRB, 0.69914116E-10_JPRB, 0.70615208E-10_JPRB, 0.71397221E-10_JPRB, &
  & 0.72146789E-10_JPRB, 0.72828674E-10_JPRB, 0.73447352E-10_JPRB, 0.74021574E-10_JPRB, 0.74577088E-10_JPRB, 0.75140109E-10_JPRB, &
  & 0.75750718E-10_JPRB, 0.76463558E-10_JPRB, 0.77317271E-10_JPRB, 0.78329884E-10_JPRB, 0.79478785E-10_JPRB, 0.80708683E-10_JPRB, &
  & 0.81953590E-10_JPRB, 0.83105946E-10_JPRB, 0.84082345E-10_JPRB, 0.84846130E-10_JPRB, 0.85429046E-10_JPRB, 0.85870283E-10_JPRB, &
  & 0.86209116E-10_JPRB, 0.86474994E-10_JPRB, 0.86690988E-10_JPRB, 0.86872516E-10_JPRB, 0.87030355E-10_JPRB, 0.87170042E-10_JPRB, &
  & 0.87292507E-10_JPRB, 0.87393898E-10_JPRB, 0.87468685E-10_JPRB, 0.87508091E-10_JPRB, 0.87517597E-10_JPRB, 0.87495310E-10_JPRB, &
  & 0.87446550E-10_JPRB, 0.87373754E-10_JPRB, 0.87276249E-10_JPRB, 0.87151508E-10_JPRB, 0.86991941E-10_JPRB, 0.86789728E-10_JPRB, &
  & 0.86535321E-10_JPRB, 0.86216784E-10_JPRB, 0.85819532E-10_JPRB, 0.85311633E-10_JPRB, 0.84689887E-10_JPRB, 0.83956384E-10_JPRB, &
  & 0.83152062E-10_JPRB, 0.82311713E-10_JPRB, 0.81483140E-10_JPRB, 0.80727286E-10_JPRB, 0.80084356E-10_JPRB, 0.79548867E-10_JPRB, &
  & 0.79084218E-10_JPRB, 0.78654153E-10_JPRB, 0.78221277E-10_JPRB, 0.77760721E-10_JPRB, 0.77265278E-10_JPRB, 0.76746838E-10_JPRB, &
  & 0.76230508E-10_JPRB, 0.75711701E-10_JPRB, 0.75118294E-10_JPRB, 0.74032634E-10_JPRB /)

RGHG9(:,45,10) = (/ &
  & 0.70389757E-10_JPRB, 0.71174552E-10_JPRB, 0.71692735E-10_JPRB, 0.72250865E-10_JPRB, 0.72946087E-10_JPRB, 0.73707464E-10_JPRB, &
  & 0.74428491E-10_JPRB, 0.75051534E-10_JPRB, 0.75593490E-10_JPRB, 0.76083209E-10_JPRB, 0.76540871E-10_JPRB, 0.77000094E-10_JPRB, &
  & 0.77504357E-10_JPRB, 0.78091408E-10_JPRB, 0.78820346E-10_JPRB, 0.79703931E-10_JPRB, 0.80711979E-10_JPRB, 0.81792871E-10_JPRB, &
  & 0.82850754E-10_JPRB, 0.83806295E-10_JPRB, 0.84590154E-10_JPRB, 0.85211505E-10_JPRB, 0.85690711E-10_JPRB, 0.86065773E-10_JPRB, &
  & 0.86361696E-10_JPRB, 0.86600428E-10_JPRB, 0.86798346E-10_JPRB, 0.86967544E-10_JPRB, 0.87115995E-10_JPRB, 0.87248320E-10_JPRB, &
  & 0.87364747E-10_JPRB, 0.87461045E-10_JPRB, 0.87531399E-10_JPRB, 0.87567502E-10_JPRB, 0.87574781E-10_JPRB, 0.87552424E-10_JPRB, &
  & 0.87506023E-10_JPRB, 0.87438688E-10_JPRB, 0.87350974E-10_JPRB, 0.87241880E-10_JPRB, 0.87106759E-10_JPRB, 0.86940559E-10_JPRB, &
  & 0.86737971E-10_JPRB, 0.86492716E-10_JPRB, 0.86187599E-10_JPRB, 0.85800859E-10_JPRB, 0.85296728E-10_JPRB, 0.84675988E-10_JPRB, &
  & 0.83963225E-10_JPRB, 0.83202958E-10_JPRB, 0.82452496E-10_JPRB, 0.81778320E-10_JPRB, 0.81209664E-10_JPRB, 0.80743252E-10_JPRB, &
  & 0.80345737E-10_JPRB, 0.79976831E-10_JPRB, 0.79607217E-10_JPRB, 0.79213282E-10_JPRB, 0.78788018E-10_JPRB, 0.78348293E-10_JPRB, &
  & 0.77915230E-10_JPRB, 0.77488460E-10_JPRB, 0.77008393E-10_JPRB, 0.76130879E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART19',1,ZHOOK_HANDLE)
END SUBROUTINE PART19




SUBROUTINE PART20
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART20',0,ZHOOK_HANDLE)



RGHG9(:,46,10) = (/ &
  & 0.72759444E-10_JPRB, 0.73494488E-10_JPRB, 0.73977283E-10_JPRB, 0.74520862E-10_JPRB, 0.75184657E-10_JPRB, 0.75941552E-10_JPRB, &
  & 0.76614402E-10_JPRB, 0.77179152E-10_JPRB, 0.77649692E-10_JPRB, 0.78054146E-10_JPRB, 0.78427799E-10_JPRB, 0.78799321E-10_JPRB, &
  & 0.79200368E-10_JPRB, 0.79688714E-10_JPRB, 0.80296055E-10_JPRB, 0.81051658E-10_JPRB, 0.81924488E-10_JPRB, 0.82824227E-10_JPRB, &
  & 0.83681465E-10_JPRB, 0.84417431E-10_JPRB, 0.85028158E-10_JPRB, 0.85515421E-10_JPRB, 0.85909516E-10_JPRB, 0.86227768E-10_JPRB, &
  & 0.86488407E-10_JPRB, 0.86704741E-10_JPRB, 0.86888538E-10_JPRB, 0.87048098E-10_JPRB, 0.87189755E-10_JPRB, 0.87316702E-10_JPRB, &
  & 0.87428439E-10_JPRB, 0.87520560E-10_JPRB, 0.87587070E-10_JPRB, 0.87620321E-10_JPRB, 0.87625483E-10_JPRB, 0.87603057E-10_JPRB, &
  & 0.87558329E-10_JPRB, 0.87495164E-10_JPRB, 0.87414881E-10_JPRB, 0.87317896E-10_JPRB, 0.87201579E-10_JPRB, 0.87063627E-10_JPRB, &
  & 0.86901659E-10_JPRB, 0.86712082E-10_JPRB, 0.86485721E-10_JPRB, 0.86197022E-10_JPRB, 0.85814175E-10_JPRB, 0.85312757E-10_JPRB, &
  & 0.84698804E-10_JPRB, 0.84027257E-10_JPRB, 0.83363275E-10_JPRB, 0.82766564E-10_JPRB, 0.82279981E-10_JPRB, 0.81882917E-10_JPRB, &
  & 0.81547311E-10_JPRB, 0.81238148E-10_JPRB, 0.80927182E-10_JPRB, 0.80595419E-10_JPRB, 0.80238448E-10_JPRB, 0.79871082E-10_JPRB, &
  & 0.79515797E-10_JPRB, 0.79172481E-10_JPRB, 0.78790759E-10_JPRB, 0.78107874E-10_JPRB /)

RGHG9(:,47,10) = (/ &
  & 0.75062387E-10_JPRB, 0.75756457E-10_JPRB, 0.76224714E-10_JPRB, 0.76730060E-10_JPRB, 0.77391517E-10_JPRB, 0.78095794E-10_JPRB, &
  & 0.78729682E-10_JPRB, 0.79224141E-10_JPRB, 0.79615987E-10_JPRB, 0.79945398E-10_JPRB, 0.80238496E-10_JPRB, 0.80527265E-10_JPRB, &
  & 0.80849237E-10_JPRB, 0.81233430E-10_JPRB, 0.81737145E-10_JPRB, 0.82366600E-10_JPRB, 0.83073402E-10_JPRB, 0.83781364E-10_JPRB, &
  & 0.84407432E-10_JPRB, 0.84945231E-10_JPRB, 0.85391486E-10_JPRB, 0.85771265E-10_JPRB, 0.86091016E-10_JPRB, 0.86363409E-10_JPRB, &
  & 0.86594773E-10_JPRB, 0.86792976E-10_JPRB, 0.86965393E-10_JPRB, 0.87117862E-10_JPRB, 0.87254468E-10_JPRB, 0.87377411E-10_JPRB, &
  & 0.87485429E-10_JPRB, 0.87574101E-10_JPRB, 0.87637030E-10_JPRB, 0.87667831E-10_JPRB, 0.87670982E-10_JPRB, 0.87648430E-10_JPRB, &
  & 0.87604923E-10_JPRB, 0.87544846E-10_JPRB, 0.87470212E-10_JPRB, 0.87382476E-10_JPRB, 0.87280780E-10_JPRB, 0.87164484E-10_JPRB, &
  & 0.87033561E-10_JPRB, 0.86887469E-10_JPRB, 0.86719500E-10_JPRB, 0.86512769E-10_JPRB, 0.86237781E-10_JPRB, 0.85856065E-10_JPRB, &
  & 0.85365923E-10_JPRB, 0.84792118E-10_JPRB, 0.84214975E-10_JPRB, 0.83707263E-10_JPRB, 0.83290444E-10_JPRB, 0.82961499E-10_JPRB, &
  & 0.82683319E-10_JPRB, 0.82427301E-10_JPRB, 0.82170326E-10_JPRB, 0.81894401E-10_JPRB, 0.81598298E-10_JPRB, 0.81295498E-10_JPRB, &
  & 0.81007284E-10_JPRB, 0.80732088E-10_JPRB, 0.80432792E-10_JPRB, 0.79903036E-10_JPRB /)

RGHG9(:,48,10) = (/ &
  & 0.77310561E-10_JPRB, 0.77992210E-10_JPRB, 0.78434294E-10_JPRB, 0.78933075E-10_JPRB, 0.79538695E-10_JPRB, 0.80219248E-10_JPRB, &
  & 0.80775032E-10_JPRB, 0.81195030E-10_JPRB, 0.81508800E-10_JPRB, 0.81756851E-10_JPRB, 0.81975676E-10_JPRB, 0.82190546E-10_JPRB, &
  & 0.82427197E-10_JPRB, 0.82727269E-10_JPRB, 0.83112059E-10_JPRB, 0.83597435E-10_JPRB, 0.84119614E-10_JPRB, 0.84600542E-10_JPRB, &
  & 0.85018811E-10_JPRB, 0.85375117E-10_JPRB, 0.85694174E-10_JPRB, 0.85981472E-10_JPRB, 0.86243124E-10_JPRB, 0.86477284E-10_JPRB, &
  & 0.86685062E-10_JPRB, 0.86868818E-10_JPRB, 0.87032513E-10_JPRB, 0.87179486E-10_JPRB, 0.87312373E-10_JPRB, 0.87432228E-10_JPRB, &
  & 0.87537193E-10_JPRB, 0.87622513E-10_JPRB, 0.87682327E-10_JPRB, 0.87710852E-10_JPRB, 0.87712178E-10_JPRB, 0.87689460E-10_JPRB, &
  & 0.87646765E-10_JPRB, 0.87589005E-10_JPRB, 0.87518645E-10_JPRB, 0.87438001E-10_JPRB, 0.87347476E-10_JPRB, 0.87247765E-10_JPRB, &
  & 0.87140364E-10_JPRB, 0.87026143E-10_JPRB, 0.86901861E-10_JPRB, 0.86756796E-10_JPRB, 0.86566337E-10_JPRB, 0.86303124E-10_JPRB, &
  & 0.85937327E-10_JPRB, 0.85492648E-10_JPRB, 0.85018118E-10_JPRB, 0.84591931E-10_JPRB, 0.84250149E-10_JPRB, 0.83976937E-10_JPRB, &
  & 0.83748890E-10_JPRB, 0.83538766E-10_JPRB, 0.83326637E-10_JPRB, 0.83098965E-10_JPRB, 0.82853460E-10_JPRB, 0.82605020E-10_JPRB, &
  & 0.82369868E-10_JPRB, 0.82149024E-10_JPRB, 0.81910236E-10_JPRB, 0.81494193E-10_JPRB /)

RGHG9(:,49,10) = (/ &
  & 0.79495285E-10_JPRB, 0.80156076E-10_JPRB, 0.80590735E-10_JPRB, 0.81052332E-10_JPRB, 0.81632548E-10_JPRB, 0.82232991E-10_JPRB, &
  & 0.82718048E-10_JPRB, 0.83048679E-10_JPRB, 0.83278384E-10_JPRB, 0.83451378E-10_JPRB, 0.83595797E-10_JPRB, 0.83736948E-10_JPRB, &
  & 0.83896570E-10_JPRB, 0.84092469E-10_JPRB, 0.84355856E-10_JPRB, 0.84662062E-10_JPRB, 0.84976595E-10_JPRB, 0.85255372E-10_JPRB, &
  & 0.85496651E-10_JPRB, 0.85720070E-10_JPRB, 0.85937771E-10_JPRB, 0.86156075E-10_JPRB, 0.86369710E-10_JPRB, 0.86573755E-10_JPRB, &
  & 0.86762819E-10_JPRB, 0.86935459E-10_JPRB, 0.87092437E-10_JPRB, 0.87235372E-10_JPRB, 0.87365205E-10_JPRB, 0.87482431E-10_JPRB, &
  & 0.87584474E-10_JPRB, 0.87666874E-10_JPRB, 0.87723551E-10_JPRB, 0.87750085E-10_JPRB, 0.87749800E-10_JPRB, 0.87726715E-10_JPRB, &
  & 0.87684728E-10_JPRB, 0.87628640E-10_JPRB, 0.87561694E-10_JPRB, 0.87486463E-10_JPRB, 0.87404473E-10_JPRB, 0.87317216E-10_JPRB, &
  & 0.87227336E-10_JPRB, 0.87136243E-10_JPRB, 0.87043539E-10_JPRB, 0.86940934E-10_JPRB, 0.86814875E-10_JPRB, 0.86640993E-10_JPRB, &
  & 0.86401671E-10_JPRB, 0.86089608E-10_JPRB, 0.85747361E-10_JPRB, 0.85420372E-10_JPRB, 0.85148694E-10_JPRB, 0.84929459E-10_JPRB, &
  & 0.84743733E-10_JPRB, 0.84571461E-10_JPRB, 0.84396344E-10_JPRB, 0.84207204E-10_JPRB, 0.84003318E-10_JPRB, 0.83796949E-10_JPRB, &
  & 0.83603603E-10_JPRB, 0.83422755E-10_JPRB, 0.83226988E-10_JPRB, 0.82891458E-10_JPRB /)

RGHG9(:,50,10) = (/ &
  & 0.81507759E-10_JPRB, 0.82131801E-10_JPRB, 0.82525500E-10_JPRB, 0.82943978E-10_JPRB, 0.83451621E-10_JPRB, 0.83969304E-10_JPRB, &
  & 0.84348223E-10_JPRB, 0.84588725E-10_JPRB, 0.84740409E-10_JPRB, 0.84844652E-10_JPRB, 0.84928412E-10_JPRB, 0.85005766E-10_JPRB, &
  & 0.85089817E-10_JPRB, 0.85194789E-10_JPRB, 0.85319238E-10_JPRB, 0.85467348E-10_JPRB, 0.85608055E-10_JPRB, 0.85736737E-10_JPRB, &
  & 0.85859028E-10_JPRB, 0.85988737E-10_JPRB, 0.86135321E-10_JPRB, 0.86299891E-10_JPRB, 0.86476555E-10_JPRB, 0.86656300E-10_JPRB, &
  & 0.86830952E-10_JPRB, 0.86995182E-10_JPRB, 0.87147380E-10_JPRB, 0.87286949E-10_JPRB, 0.87414312E-10_JPRB, 0.87528804E-10_JPRB, &
  & 0.87628224E-10_JPRB, 0.87707515E-10_JPRB, 0.87761388E-10_JPRB, 0.87786015E-10_JPRB, 0.87784412E-10_JPRB, 0.87760917E-10_JPRB, &
  & 0.87719547E-10_JPRB, 0.87664834E-10_JPRB, 0.87600593E-10_JPRB, 0.87529650E-10_JPRB, 0.87453954E-10_JPRB, 0.87375995E-10_JPRB, &
  & 0.87298689E-10_JPRB, 0.87225019E-10_JPRB, 0.87153625E-10_JPRB, 0.87081294E-10_JPRB, 0.86997194E-10_JPRB, 0.86888607E-10_JPRB, &
  & 0.86742093E-10_JPRB, 0.86557421E-10_JPRB, 0.86343696E-10_JPRB, 0.86134641E-10_JPRB, 0.85947069E-10_JPRB, 0.85788612E-10_JPRB, &
  & 0.85647447E-10_JPRB, 0.85513208E-10_JPRB, 0.85374159E-10_JPRB, 0.85219561E-10_JPRB, 0.85052215E-10_JPRB, 0.84881289E-10_JPRB, &
  & 0.84721632E-10_JPRB, 0.84569240E-10_JPRB, 0.84406426E-10_JPRB, 0.84118698E-10_JPRB /)

RGHG9(:,51,10) = (/ &
  & 0.83213957E-10_JPRB, 0.83728087E-10_JPRB, 0.84047005E-10_JPRB, 0.84385533E-10_JPRB, 0.84789904E-10_JPRB, 0.85189973E-10_JPRB, &
  & 0.85462699E-10_JPRB, 0.85618276E-10_JPRB, 0.85708704E-10_JPRB, 0.85767851E-10_JPRB, 0.85810234E-10_JPRB, 0.85846719E-10_JPRB, &
  & 0.85881927E-10_JPRB, 0.85918446E-10_JPRB, 0.85960503E-10_JPRB, 0.86001171E-10_JPRB, 0.86041285E-10_JPRB, 0.86081406E-10_JPRB, &
  & 0.86131047E-10_JPRB, 0.86200116E-10_JPRB, 0.86296442E-10_JPRB, 0.86420801E-10_JPRB, 0.86568107E-10_JPRB, 0.86728617E-10_JPRB, &
  & 0.86891924E-10_JPRB, 0.87049812E-10_JPRB, 0.87198311E-10_JPRB, 0.87335188E-10_JPRB, 0.87460046E-10_JPRB, 0.87572116E-10_JPRB, &
  & 0.87668636E-10_JPRB, 0.87745144E-10_JPRB, 0.87796277E-10_JPRB, 0.87819203E-10_JPRB, 0.87816497E-10_JPRB, 0.87792627E-10_JPRB, &
  & 0.87751764E-10_JPRB, 0.87698460E-10_JPRB, 0.87636495E-10_JPRB, 0.87568806E-10_JPRB, 0.87497933E-10_JPRB, 0.87426469E-10_JPRB, &
  & 0.87358995E-10_JPRB, 0.87296920E-10_JPRB, 0.87242047E-10_JPRB, 0.87189311E-10_JPRB, 0.87133863E-10_JPRB, 0.87067437E-10_JPRB, &
  & 0.86984614E-10_JPRB, 0.86884930E-10_JPRB, 0.86776253E-10_JPRB, 0.86666327E-10_JPRB, 0.86566004E-10_JPRB, 0.86473918E-10_JPRB, &
  & 0.86389250E-10_JPRB, 0.86302493E-10_JPRB, 0.86206257E-10_JPRB, 0.86096394E-10_JPRB, 0.85969350E-10_JPRB, 0.85838531E-10_JPRB, &
  & 0.85710508E-10_JPRB, 0.85588550E-10_JPRB, 0.85446955E-10_JPRB, 0.85203476E-10_JPRB /)

RGHG9(:,52,10) = (/ &
  & 0.84587518E-10_JPRB, 0.84896944E-10_JPRB, 0.85107192E-10_JPRB, 0.85349144E-10_JPRB, 0.85651992E-10_JPRB, 0.85937639E-10_JPRB, &
  & 0.86117544E-10_JPRB, 0.86213897E-10_JPRB, 0.86266945E-10_JPRB, 0.86298350E-10_JPRB, 0.86320118E-10_JPRB, 0.86335335E-10_JPRB, &
  & 0.86346305E-10_JPRB, 0.86352897E-10_JPRB, 0.86353175E-10_JPRB, 0.86346499E-10_JPRB, 0.86336931E-10_JPRB, 0.86331317E-10_JPRB, &
  & 0.86339290E-10_JPRB, 0.86369946E-10_JPRB, 0.86430675E-10_JPRB, 0.86524926E-10_JPRB, 0.86648855E-10_JPRB, 0.86793933E-10_JPRB, &
  & 0.86947782E-10_JPRB, 0.87100792E-10_JPRB, 0.87245704E-10_JPRB, 0.87380297E-10_JPRB, 0.87502769E-10_JPRB, 0.87612313E-10_JPRB, &
  & 0.87706273E-10_JPRB, 0.87779964E-10_JPRB, 0.87828626E-10_JPRB, 0.87849970E-10_JPRB, 0.87846418E-10_JPRB, 0.87822249E-10_JPRB, &
  & 0.87782004E-10_JPRB, 0.87729969E-10_JPRB, 0.87670080E-10_JPRB, 0.87605187E-10_JPRB, 0.87537678E-10_JPRB, 0.87471440E-10_JPRB, &
  & 0.87410135E-10_JPRB, 0.87358301E-10_JPRB, 0.87313809E-10_JPRB, 0.87276075E-10_JPRB, 0.87239369E-10_JPRB, 0.87199942E-10_JPRB, &
  & 0.87155519E-10_JPRB, 0.87107196E-10_JPRB, 0.87057361E-10_JPRB, 0.87009983E-10_JPRB, 0.86966045E-10_JPRB, 0.86926549E-10_JPRB, &
  & 0.86886415E-10_JPRB, 0.86843838E-10_JPRB, 0.86792934E-10_JPRB, 0.86727965E-10_JPRB, 0.86651193E-10_JPRB, 0.86565380E-10_JPRB, &
  & 0.86481038E-10_JPRB, 0.86393136E-10_JPRB, 0.86292265E-10_JPRB, 0.86090815E-10_JPRB /)

RGHG9(:,53,10) = (/ &
  & 0.85365971E-10_JPRB, 0.85615265E-10_JPRB, 0.85784713E-10_JPRB, 0.85965214E-10_JPRB, 0.86186211E-10_JPRB, 0.86384004E-10_JPRB, &
  & 0.86502007E-10_JPRB, 0.86560079E-10_JPRB, 0.86590277E-10_JPRB, 0.86608082E-10_JPRB, 0.86618462E-10_JPRB, 0.86624395E-10_JPRB, &
  & 0.86625380E-10_JPRB, 0.86619871E-10_JPRB, 0.86604446E-10_JPRB, 0.86579653E-10_JPRB, 0.86547894E-10_JPRB, 0.86520013E-10_JPRB, &
  & 0.86504331E-10_JPRB, 0.86510125E-10_JPRB, 0.86545937E-10_JPRB, 0.86617054E-10_JPRB, 0.86722768E-10_JPRB, 0.86854579E-10_JPRB, &
  & 0.87000795E-10_JPRB, 0.87148004E-10_JPRB, 0.87290397E-10_JPRB, 0.87421917E-10_JPRB, 0.87542522E-10_JPRB, 0.87649707E-10_JPRB, &
  & 0.87741141E-10_JPRB, 0.87812271E-10_JPRB, 0.87858616E-10_JPRB, 0.87878614E-10_JPRB, 0.87874402E-10_JPRB, 0.87850192E-10_JPRB, &
  & 0.87810446E-10_JPRB, 0.87759786E-10_JPRB, 0.87701839E-10_JPRB, 0.87639167E-10_JPRB, 0.87574649E-10_JPRB, 0.87511678E-10_JPRB, &
  & 0.87456653E-10_JPRB, 0.87410489E-10_JPRB, 0.87375863E-10_JPRB, 0.87347705E-10_JPRB, 0.87324238E-10_JPRB, 0.87301805E-10_JPRB, &
  & 0.87279475E-10_JPRB, 0.87257479E-10_JPRB, 0.87236926E-10_JPRB, 0.87218247E-10_JPRB, 0.87201843E-10_JPRB, 0.87185904E-10_JPRB, &
  & 0.87170271E-10_JPRB, 0.87151231E-10_JPRB, 0.87126868E-10_JPRB, 0.87094720E-10_JPRB, 0.87052879E-10_JPRB, 0.87007020E-10_JPRB, &
  & 0.86959689E-10_JPRB, 0.86912672E-10_JPRB, 0.86852942E-10_JPRB, 0.86731282E-10_JPRB /)

RGHG9(:,54,10) = (/ &
  & 0.85935342E-10_JPRB, 0.86121200E-10_JPRB, 0.86236754E-10_JPRB, 0.86373506E-10_JPRB, 0.86529409E-10_JPRB, 0.86667409E-10_JPRB, &
  & 0.86741198E-10_JPRB, 0.86777155E-10_JPRB, 0.86795057E-10_JPRB, 0.86804557E-10_JPRB, 0.86809775E-10_JPRB, 0.86811267E-10_JPRB, &
  & 0.86808519E-10_JPRB, 0.86799179E-10_JPRB, 0.86780319E-10_JPRB, 0.86747935E-10_JPRB, 0.86708737E-10_JPRB, 0.86669415E-10_JPRB, &
  & 0.86639973E-10_JPRB, 0.86629398E-10_JPRB, 0.86647252E-10_JPRB, 0.86701181E-10_JPRB, 0.86792178E-10_JPRB, 0.86913296E-10_JPRB, &
  & 0.87050867E-10_JPRB, 0.87193676E-10_JPRB, 0.87331184E-10_JPRB, 0.87461045E-10_JPRB, 0.87579180E-10_JPRB, 0.87684443E-10_JPRB, &
  & 0.87773580E-10_JPRB, 0.87842150E-10_JPRB, 0.87886511E-10_JPRB, 0.87905350E-10_JPRB, 0.87900735E-10_JPRB, 0.87876671E-10_JPRB, &
  & 0.87837668E-10_JPRB, 0.87788193E-10_JPRB, 0.87731905E-10_JPRB, 0.87671433E-10_JPRB, 0.87609163E-10_JPRB, 0.87549974E-10_JPRB, &
  & 0.87498099E-10_JPRB, 0.87458950E-10_JPRB, 0.87429716E-10_JPRB, 0.87409829E-10_JPRB, 0.87394994E-10_JPRB, 0.87383156E-10_JPRB, &
  & 0.87372956E-10_JPRB, 0.87364165E-10_JPRB, 0.87356580E-10_JPRB, 0.87350155E-10_JPRB, 0.87344298E-10_JPRB, 0.87338782E-10_JPRB, &
  & 0.87332058E-10_JPRB, 0.87323856E-10_JPRB, 0.87312060E-10_JPRB, 0.87295171E-10_JPRB, 0.87273730E-10_JPRB, 0.87249583E-10_JPRB, &
  & 0.87226837E-10_JPRB, 0.87205743E-10_JPRB, 0.87186321E-10_JPRB, 0.87161833E-10_JPRB /)

RGHG9(:,55,10) = (/ &
  & 0.86320645E-10_JPRB, 0.86458139E-10_JPRB, 0.86555360E-10_JPRB, 0.86650145E-10_JPRB, 0.86766323E-10_JPRB, 0.86856078E-10_JPRB, &
  & 0.86905164E-10_JPRB, 0.86926882E-10_JPRB, 0.86937534E-10_JPRB, 0.86943057E-10_JPRB, 0.86945451E-10_JPRB, 0.86945215E-10_JPRB, &
  & 0.86941523E-10_JPRB, 0.86932087E-10_JPRB, 0.86912560E-10_JPRB, 0.86881287E-10_JPRB, 0.86838245E-10_JPRB, 0.86793531E-10_JPRB, &
  & 0.86755554E-10_JPRB, 0.86733690E-10_JPRB, 0.86738651E-10_JPRB, 0.86779625E-10_JPRB, 0.86859131E-10_JPRB, 0.86970264E-10_JPRB, &
  & 0.87100334E-10_JPRB, 0.87236170E-10_JPRB, 0.87370625E-10_JPRB, 0.87497072E-10_JPRB, 0.87613597E-10_JPRB, 0.87716841E-10_JPRB, &
  & 0.87803667E-10_JPRB, 0.87869968E-10_JPRB, 0.87912455E-10_JPRB, 0.87930406E-10_JPRB, 0.87925660E-10_JPRB, 0.87901984E-10_JPRB, &
  & 0.87863820E-10_JPRB, 0.87815533E-10_JPRB, 0.87760792E-10_JPRB, 0.87702040E-10_JPRB, 0.87642428E-10_JPRB, 0.87585710E-10_JPRB, &
  & 0.87538712E-10_JPRB, 0.87502817E-10_JPRB, 0.87479669E-10_JPRB, 0.87464876E-10_JPRB, 0.87456223E-10_JPRB, 0.87450852E-10_JPRB, &
  & 0.87447292E-10_JPRB, 0.87444801E-10_JPRB, 0.87442983E-10_JPRB, 0.87441415E-10_JPRB, 0.87439875E-10_JPRB, 0.87437821E-10_JPRB, &
  & 0.87435205E-10_JPRB, 0.87431028E-10_JPRB, 0.87424769E-10_JPRB, 0.87415457E-10_JPRB, 0.87402779E-10_JPRB, 0.87388916E-10_JPRB, &
  & 0.87375329E-10_JPRB, 0.87362437E-10_JPRB, 0.87348045E-10_JPRB, 0.87324370E-10_JPRB /)

RGHG9(:,56,10) = (/ &
  & 0.86604876E-10_JPRB, 0.86715163E-10_JPRB, 0.86779077E-10_JPRB, 0.86854642E-10_JPRB, 0.86932704E-10_JPRB, 0.86996244E-10_JPRB, &
  & 0.87026608E-10_JPRB, 0.87040618E-10_JPRB, 0.87047078E-10_JPRB, 0.87050228E-10_JPRB, 0.87051366E-10_JPRB, 0.87050561E-10_JPRB, &
  & 0.87046911E-10_JPRB, 0.87038515E-10_JPRB, 0.87021682E-10_JPRB, 0.86991123E-10_JPRB, 0.86948983E-10_JPRB, 0.86901035E-10_JPRB, &
  & 0.86857146E-10_JPRB, 0.86827316E-10_JPRB, 0.86822952E-10_JPRB, 0.86854329E-10_JPRB, 0.86924468E-10_JPRB, 0.87026490E-10_JPRB, &
  & 0.87148407E-10_JPRB, 0.87278365E-10_JPRB, 0.87407762E-10_JPRB, 0.87531780E-10_JPRB, 0.87646043E-10_JPRB, 0.87747268E-10_JPRB, &
  & 0.87831846E-10_JPRB, 0.87895871E-10_JPRB, 0.87936866E-10_JPRB, 0.87954158E-10_JPRB, 0.87949474E-10_JPRB, 0.87926458E-10_JPRB, &
  & 0.87889307E-10_JPRB, 0.87842192E-10_JPRB, 0.87788686E-10_JPRB, 0.87731905E-10_JPRB, 0.87674236E-10_JPRB, 0.87621153E-10_JPRB, &
  & 0.87576883E-10_JPRB, 0.87545714E-10_JPRB, 0.87525875E-10_JPRB, 0.87515439E-10_JPRB, 0.87510825E-10_JPRB, 0.87509430E-10_JPRB, &
  & 0.87509479E-10_JPRB, 0.87510013E-10_JPRB, 0.87510589E-10_JPRB, 0.87510880E-10_JPRB, 0.87510763E-10_JPRB, 0.87510145E-10_JPRB, &
  & 0.87508764E-10_JPRB, 0.87506502E-10_JPRB, 0.87502644E-10_JPRB, 0.87496593E-10_JPRB, 0.87488648E-10_JPRB, 0.87479787E-10_JPRB, &
  & 0.87471246E-10_JPRB, 0.87463078E-10_JPRB, 0.87454613E-10_JPRB, 0.87441006E-10_JPRB /)

RGHG9(:,57,10) = (/ &
  & 0.86814944E-10_JPRB, 0.86896768E-10_JPRB, 0.86952015E-10_JPRB, 0.87003460E-10_JPRB, 0.87061788E-10_JPRB, 0.87103130E-10_JPRB, &
  & 0.87124079E-10_JPRB, 0.87133051E-10_JPRB, 0.87137367E-10_JPRB, 0.87139421E-10_JPRB, 0.87140038E-10_JPRB, 0.87139213E-10_JPRB, &
  & 0.87136270E-10_JPRB, 0.87129262E-10_JPRB, 0.87114746E-10_JPRB, 0.87088017E-10_JPRB, 0.87046322E-10_JPRB, 0.86996792E-10_JPRB, &
  & 0.86948872E-10_JPRB, 0.86913463E-10_JPRB, 0.86902457E-10_JPRB, 0.86926459E-10_JPRB, 0.86988403E-10_JPRB, 0.87082383E-10_JPRB, &
  & 0.87196209E-10_JPRB, 0.87319804E-10_JPRB, 0.87444801E-10_JPRB, 0.87565365E-10_JPRB, 0.87677213E-10_JPRB, 0.87776120E-10_JPRB, &
  & 0.87858304E-10_JPRB, 0.87920331E-10_JPRB, 0.87960070E-10_JPRB, 0.87976917E-10_JPRB, 0.87972567E-10_JPRB, 0.87950418E-10_JPRB, &
  & 0.87914419E-10_JPRB, 0.87868511E-10_JPRB, 0.87816476E-10_JPRB, 0.87760972E-10_JPRB, 0.87706002E-10_JPRB, 0.87655376E-10_JPRB, &
  & 0.87614971E-10_JPRB, 0.87586605E-10_JPRB, 0.87570201E-10_JPRB, 0.87562610E-10_JPRB, 0.87560806E-10_JPRB, 0.87561874E-10_JPRB, &
  & 0.87563859E-10_JPRB, 0.87565774E-10_JPRB, 0.87567120E-10_JPRB, 0.87567856E-10_JPRB, 0.87568022E-10_JPRB, 0.87567648E-10_JPRB, &
  & 0.87566759E-10_JPRB, 0.87565025E-10_JPRB, 0.87562180E-10_JPRB, 0.87557836E-10_JPRB, 0.87551980E-10_JPRB, 0.87545679E-10_JPRB, &
  & 0.87539601E-10_JPRB, 0.87533689E-10_JPRB, 0.87526951E-10_JPRB, 0.87515252E-10_JPRB /)

RGHG9(:,58,10) = (/ &
  & 0.86985932E-10_JPRB, 0.87046287E-10_JPRB, 0.87082411E-10_JPRB, 0.87122705E-10_JPRB, 0.87162999E-10_JPRB, 0.87192482E-10_JPRB, &
  & 0.87206575E-10_JPRB, 0.87213056E-10_JPRB, 0.87216151E-10_JPRB, 0.87217747E-10_JPRB, 0.87218323E-10_JPRB, 0.87217837E-10_JPRB, &
  & 0.87215582E-10_JPRB, 0.87210281E-10_JPRB, 0.87198151E-10_JPRB, 0.87174212E-10_JPRB, 0.87134730E-10_JPRB, 0.87084145E-10_JPRB, &
  & 0.87033616E-10_JPRB, 0.86994349E-10_JPRB, 0.86978841E-10_JPRB, 0.86996979E-10_JPRB, 0.87051831E-10_JPRB, 0.87137665E-10_JPRB, &
  & 0.87244469E-10_JPRB, 0.87361687E-10_JPRB, 0.87481980E-10_JPRB, 0.87598734E-10_JPRB, 0.87707612E-10_JPRB, 0.87803778E-10_JPRB, &
  & 0.87883464E-10_JPRB, 0.87943743E-10_JPRB, 0.87982392E-10_JPRB, 0.87999039E-10_JPRB, 0.87995208E-10_JPRB, 0.87974128E-10_JPRB, &
  & 0.87939447E-10_JPRB, 0.87894907E-10_JPRB, 0.87844051E-10_JPRB, 0.87790546E-10_JPRB, 0.87737255E-10_JPRB, 0.87689744E-10_JPRB, &
  & 0.87652094E-10_JPRB, 0.87626788E-10_JPRB, 0.87612834E-10_JPRB, 0.87607491E-10_JPRB, 0.87607553E-10_JPRB, 0.87610148E-10_JPRB, &
  & 0.87613167E-10_JPRB, 0.87615484E-10_JPRB, 0.87616830E-10_JPRB, 0.87617288E-10_JPRB, 0.87617164E-10_JPRB, 0.87616595E-10_JPRB, &
  & 0.87615533E-10_JPRB, 0.87613930E-10_JPRB, 0.87611390E-10_JPRB, 0.87607574E-10_JPRB, 0.87602835E-10_JPRB, 0.87597818E-10_JPRB, &
  & 0.87593037E-10_JPRB, 0.87588457E-10_JPRB, 0.87583454E-10_JPRB, 0.87574864E-10_JPRB /)

RGHG9(:,59,10) = (/ &
  & 0.87107654E-10_JPRB, 0.87156796E-10_JPRB, 0.87188312E-10_JPRB, 0.87217719E-10_JPRB, 0.87247556E-10_JPRB, 0.87268914E-10_JPRB, &
  & 0.87279642E-10_JPRB, 0.87284728E-10_JPRB, 0.87287441E-10_JPRB, 0.87289016E-10_JPRB, 0.87289849E-10_JPRB, 0.87289891E-10_JPRB, &
  & 0.87288621E-10_JPRB, 0.87284457E-10_JPRB, 0.87274854E-10_JPRB, 0.87253427E-10_JPRB, 0.87215769E-10_JPRB, 0.87165261E-10_JPRB, &
  & 0.87113108E-10_JPRB, 0.87071982E-10_JPRB, 0.87053240E-10_JPRB, 0.87066507E-10_JPRB, 0.87114677E-10_JPRB, 0.87193482E-10_JPRB, &
  & 0.87293200E-10_JPRB, 0.87404466E-10_JPRB, 0.87519818E-10_JPRB, 0.87632353E-10_JPRB, 0.87737734E-10_JPRB, 0.87830555E-10_JPRB, &
  & 0.87907910E-10_JPRB, 0.87966349E-10_JPRB, 0.88004139E-10_JPRB, 0.88020688E-10_JPRB, 0.88017552E-10_JPRB, 0.87997692E-10_JPRB, &
  & 0.87964469E-10_JPRB, 0.87921337E-10_JPRB, 0.87872168E-10_JPRB, 0.87819960E-10_JPRB, 0.87769077E-10_JPRB, 0.87723807E-10_JPRB, &
  & 0.87689009E-10_JPRB, 0.87666180E-10_JPRB, 0.87654328E-10_JPRB, 0.87650637E-10_JPRB, 0.87651976E-10_JPRB, 0.87655501E-10_JPRB, &
  & 0.87658970E-10_JPRB, 0.87661226E-10_JPRB, 0.87662086E-10_JPRB, 0.87661919E-10_JPRB, 0.87661239E-10_JPRB, 0.87660185E-10_JPRB, &
  & 0.87658839E-10_JPRB, 0.87656910E-10_JPRB, 0.87654210E-10_JPRB, 0.87650553E-10_JPRB, 0.87646099E-10_JPRB, 0.87641616E-10_JPRB, &
  & 0.87637460E-10_JPRB, 0.87633456E-10_JPRB, 0.87628918E-10_JPRB, 0.87621105E-10_JPRB /)

RGHG9(:,60,10) = (/ &
  & 0.87211655E-10_JPRB, 0.87252233E-10_JPRB, 0.87275458E-10_JPRB, 0.87298543E-10_JPRB, 0.87321136E-10_JPRB, 0.87337415E-10_JPRB, &
  & 0.87346255E-10_JPRB, 0.87350814E-10_JPRB, 0.87353527E-10_JPRB, 0.87355380E-10_JPRB, 0.87356733E-10_JPRB, 0.87357482E-10_JPRB, &
  & 0.87357191E-10_JPRB, 0.87354679E-10_JPRB, 0.87346443E-10_JPRB, 0.87327631E-10_JPRB, 0.87291327E-10_JPRB, 0.87241381E-10_JPRB, &
  & 0.87189395E-10_JPRB, 0.87147282E-10_JPRB, 0.87126445E-10_JPRB, 0.87135535E-10_JPRB, 0.87177821E-10_JPRB, 0.87249791E-10_JPRB, &
  & 0.87342973E-10_JPRB, 0.87448424E-10_JPRB, 0.87558516E-10_JPRB, 0.87666541E-10_JPRB, 0.87767640E-10_JPRB, 0.87857242E-10_JPRB, &
  & 0.87931835E-10_JPRB, 0.87988609E-10_JPRB, 0.88025441E-10_JPRB, 0.88041949E-10_JPRB, 0.88039596E-10_JPRB, 0.88021070E-10_JPRB, &
  & 0.87989324E-10_JPRB, 0.87947927E-10_JPRB, 0.87900257E-10_JPRB, 0.87849998E-10_JPRB, 0.87800885E-10_JPRB, 0.87758113E-10_JPRB, &
  & 0.87725660E-10_JPRB, 0.87705024E-10_JPRB, 0.87694942E-10_JPRB, 0.87692506E-10_JPRB, 0.87694699E-10_JPRB, 0.87698737E-10_JPRB, &
  & 0.87702373E-10_JPRB, 0.87704288E-10_JPRB, 0.87704413E-10_JPRB, 0.87703421E-10_JPRB, 0.87701971E-10_JPRB, 0.87700382E-10_JPRB, &
  & 0.87698425E-10_JPRB, 0.87696066E-10_JPRB, 0.87692950E-10_JPRB, 0.87688926E-10_JPRB, 0.87684415E-10_JPRB, 0.87680044E-10_JPRB, &
  & 0.87676061E-10_JPRB, 0.87672328E-10_JPRB, 0.87668275E-10_JPRB, 0.87661281E-10_JPRB /)

RGHG9(:,61,10) = (/ &
  & 0.87297024E-10_JPRB, 0.87330893E-10_JPRB, 0.87350946E-10_JPRB, 0.87369029E-10_JPRB, 0.87386556E-10_JPRB, 0.87400254E-10_JPRB, &
  & 0.87408164E-10_JPRB, 0.87412765E-10_JPRB, 0.87415825E-10_JPRB, 0.87418218E-10_JPRB, 0.87420265E-10_JPRB, 0.87422042E-10_JPRB, &
  & 0.87423013E-10_JPRB, 0.87421875E-10_JPRB, 0.87415700E-10_JPRB, 0.87397735E-10_JPRB, 0.87362881E-10_JPRB, 0.87314350E-10_JPRB, &
  & 0.87263190E-10_JPRB, 0.87221334E-10_JPRB, 0.87198963E-10_JPRB, 0.87204598E-10_JPRB, 0.87241506E-10_JPRB, 0.87307196E-10_JPRB, &
  & 0.87394078E-10_JPRB, 0.87493554E-10_JPRB, 0.87598324E-10_JPRB, 0.87701450E-10_JPRB, 0.87798116E-10_JPRB, 0.87883936E-10_JPRB, &
  & 0.87955941E-10_JPRB, 0.88010675E-10_JPRB, 0.88046501E-10_JPRB, 0.88062960E-10_JPRB, 0.88061371E-10_JPRB, 0.88044086E-10_JPRB, &
  & 0.88014027E-10_JPRB, 0.87974364E-10_JPRB, 0.87928588E-10_JPRB, 0.87880037E-10_JPRB, 0.87833109E-10_JPRB, 0.87792489E-10_JPRB, &
  & 0.87762249E-10_JPRB, 0.87743493E-10_JPRB, 0.87734861E-10_JPRB, 0.87733432E-10_JPRB, 0.87736221E-10_JPRB, 0.87740488E-10_JPRB, &
  & 0.87744145E-10_JPRB, 0.87745686E-10_JPRB, 0.87745020E-10_JPRB, 0.87743084E-10_JPRB, 0.87740801E-10_JPRB, 0.87738330E-10_JPRB, &
  & 0.87735763E-10_JPRB, 0.87732668E-10_JPRB, 0.87728852E-10_JPRB, 0.87724286E-10_JPRB, 0.87719339E-10_JPRB, 0.87714683E-10_JPRB, &
  & 0.87710575E-10_JPRB, 0.87706759E-10_JPRB, 0.87702560E-10_JPRB, 0.87695587E-10_JPRB /)

RGHG9(:,62,10) = (/ &
  & 0.87372720E-10_JPRB, 0.87401697E-10_JPRB, 0.87417795E-10_JPRB, 0.87432638E-10_JPRB, 0.87447175E-10_JPRB, 0.87458846E-10_JPRB, &
  & 0.87466617E-10_JPRB, 0.87471523E-10_JPRB, 0.87475180E-10_JPRB, 0.87478344E-10_JPRB, 0.87481439E-10_JPRB, 0.87484485E-10_JPRB, &
  & 0.87487177E-10_JPRB, 0.87487836E-10_JPRB, 0.87482799E-10_JPRB, 0.87465757E-10_JPRB, 0.87431874E-10_JPRB, 0.87385037E-10_JPRB, &
  & 0.87335791E-10_JPRB, 0.87294505E-10_JPRB, 0.87271239E-10_JPRB, 0.87274070E-10_JPRB, 0.87306301E-10_JPRB, 0.87366094E-10_JPRB, &
  & 0.87446689E-10_JPRB, 0.87540350E-10_JPRB, 0.87639493E-10_JPRB, 0.87737539E-10_JPRB, 0.87829362E-10_JPRB, 0.87911553E-10_JPRB, &
  & 0.87980345E-10_JPRB, 0.88032956E-10_JPRB, 0.88067539E-10_JPRB, 0.88083742E-10_JPRB, 0.88082784E-10_JPRB, 0.88066832E-10_JPRB, &
  & 0.88038445E-10_JPRB, 0.88000704E-10_JPRB, 0.87956871E-10_JPRB, 0.87910366E-10_JPRB, 0.87865541E-10_JPRB, 0.87827100E-10_JPRB, &
  & 0.87798831E-10_JPRB, 0.87781740E-10_JPRB, 0.87774295E-10_JPRB, 0.87773643E-10_JPRB, 0.87776800E-10_JPRB, 0.87781150E-10_JPRB, &
  & 0.87784661E-10_JPRB, 0.87785959E-10_JPRB, 0.87784689E-10_JPRB, 0.87781810E-10_JPRB, 0.87778521E-10_JPRB, 0.87775225E-10_JPRB, &
  & 0.87771665E-10_JPRB, 0.87767682E-10_JPRB, 0.87762950E-10_JPRB, 0.87757433E-10_JPRB, 0.87751778E-10_JPRB, 0.87746636E-10_JPRB, &
  & 0.87742119E-10_JPRB, 0.87737970E-10_JPRB, 0.87733557E-10_JPRB, 0.87726035E-10_JPRB /)

RGHG9(:,63,10) = (/ &
  & 0.87438196E-10_JPRB, 0.87464314E-10_JPRB, 0.87478760E-10_JPRB, 0.87491500E-10_JPRB, 0.87503838E-10_JPRB, 0.87514648E-10_JPRB, &
  & 0.87522281E-10_JPRB, 0.87527825E-10_JPRB, 0.87532245E-10_JPRB, 0.87536423E-10_JPRB, 0.87540836E-10_JPRB, 0.87545665E-10_JPRB, &
  & 0.87550335E-10_JPRB, 0.87552854E-10_JPRB, 0.87548739E-10_JPRB, 0.87531961E-10_JPRB, 0.87499070E-10_JPRB, 0.87454828E-10_JPRB, &
  & 0.87407588E-10_JPRB, 0.87367349E-10_JPRB, 0.87343702E-10_JPRB, 0.87344347E-10_JPRB, 0.87372554E-10_JPRB, 0.87426850E-10_JPRB, &
  & 0.87501423E-10_JPRB, 0.87589033E-10_JPRB, 0.87682479E-10_JPRB, 0.87775114E-10_JPRB, 0.87862086E-10_JPRB, 0.87940065E-10_JPRB, &
  & 0.88005492E-10_JPRB, 0.88055487E-10_JPRB, 0.88088557E-10_JPRB, 0.88104288E-10_JPRB, 0.88103851E-10_JPRB, 0.88089140E-10_JPRB, &
  & 0.88062557E-10_JPRB, 0.88026871E-10_JPRB, 0.87985147E-10_JPRB, 0.87940842E-10_JPRB, 0.87898237E-10_JPRB, 0.87861961E-10_JPRB, &
  & 0.87835524E-10_JPRB, 0.87819856E-10_JPRB, 0.87813368E-10_JPRB, 0.87813284E-10_JPRB, 0.87816671E-10_JPRB, 0.87820945E-10_JPRB, &
  & 0.87824303E-10_JPRB, 0.87825393E-10_JPRB, 0.87823748E-10_JPRB, 0.87820209E-10_JPRB, 0.87815991E-10_JPRB, 0.87811605E-10_JPRB, &
  & 0.87807046E-10_JPRB, 0.87801905E-10_JPRB, 0.87795909E-10_JPRB, 0.87789290E-10_JPRB, 0.87782615E-10_JPRB, 0.87776592E-10_JPRB, &
  & 0.87771401E-10_JPRB, 0.87766600E-10_JPRB, 0.87761333E-10_JPRB, 0.87752729E-10_JPRB /)

RGHG9(:,64,10) = (/ &
  & 0.87497627E-10_JPRB, 0.87522156E-10_JPRB, 0.87535409E-10_JPRB, 0.87546775E-10_JPRB, 0.87557968E-10_JPRB, 0.87567863E-10_JPRB, &
  & 0.87575870E-10_JPRB, 0.87581865E-10_JPRB, 0.87587368E-10_JPRB, 0.87592746E-10_JPRB, 0.87598873E-10_JPRB, 0.87605860E-10_JPRB, &
  & 0.87612848E-10_JPRB, 0.87617004E-10_JPRB, 0.87613361E-10_JPRB, 0.87596506E-10_JPRB, 0.87565385E-10_JPRB, 0.87523405E-10_JPRB, &
  & 0.87478448E-10_JPRB, 0.87439590E-10_JPRB, 0.87416178E-10_JPRB, 0.87415304E-10_JPRB, 0.87440069E-10_JPRB, 0.87489349E-10_JPRB, &
  & 0.87558009E-10_JPRB, 0.87639652E-10_JPRB, 0.87727103E-10_JPRB, 0.87814110E-10_JPRB, 0.87895892E-10_JPRB, 0.87969382E-10_JPRB, &
  & 0.88030902E-10_JPRB, 0.88078031E-10_JPRB, 0.88109200E-10_JPRB, 0.88124216E-10_JPRB, 0.88124168E-10_JPRB, 0.88110685E-10_JPRB, &
  & 0.88086018E-10_JPRB, 0.88052510E-10_JPRB, 0.88013152E-10_JPRB, 0.87971193E-10_JPRB, 0.87930975E-10_JPRB, 0.87896815E-10_JPRB, &
  & 0.87872071E-10_JPRB, 0.87857624E-10_JPRB, 0.87851879E-10_JPRB, 0.87852170E-10_JPRB, 0.87855626E-10_JPRB, 0.87859768E-10_JPRB, &
  & 0.87862884E-10_JPRB, 0.87863827E-10_JPRB, 0.87862134E-10_JPRB, 0.87858193E-10_JPRB, 0.87853162E-10_JPRB, 0.87847819E-10_JPRB, &
  & 0.87842025E-10_JPRB, 0.87835586E-10_JPRB, 0.87828286E-10_JPRB, 0.87820230E-10_JPRB, 0.87812355E-10_JPRB, 0.87805332E-10_JPRB, &
  & 0.87799122E-10_JPRB, 0.87793259E-10_JPRB, 0.87786875E-10_JPRB, 0.87775870E-10_JPRB /)

RGHG9(:,65,10) = (/ &
  & 0.87552285E-10_JPRB, 0.87576321E-10_JPRB, 0.87588888E-10_JPRB, 0.87599747E-10_JPRB, 0.87610003E-10_JPRB, 0.87619675E-10_JPRB, &
  & 0.87627516E-10_JPRB, 0.87634601E-10_JPRB, 0.87640867E-10_JPRB, 0.87648014E-10_JPRB, 0.87655952E-10_JPRB, 0.87665250E-10_JPRB, &
  & 0.87674187E-10_JPRB, 0.87678975E-10_JPRB, 0.87675180E-10_JPRB, 0.87659199E-10_JPRB, 0.87629952E-10_JPRB, 0.87590726E-10_JPRB, &
  & 0.87548233E-10_JPRB, 0.87511290E-10_JPRB, 0.87488530E-10_JPRB, 0.87486726E-10_JPRB, 0.87508632E-10_JPRB, 0.87553201E-10_JPRB, &
  & 0.87616268E-10_JPRB, 0.87691673E-10_JPRB, 0.87772921E-10_JPRB, 0.87853898E-10_JPRB, 0.87930246E-10_JPRB, 0.87998747E-10_JPRB, &
  & 0.88056083E-10_JPRB, 0.88099930E-10_JPRB, 0.88128935E-10_JPRB, 0.88143028E-10_JPRB, 0.88143243E-10_JPRB, 0.88131072E-10_JPRB, &
  & 0.88108368E-10_JPRB, 0.88077295E-10_JPRB, 0.88040499E-10_JPRB, 0.88001231E-10_JPRB, 0.87963491E-10_JPRB, 0.87931488E-10_JPRB, &
  & 0.87908354E-10_JPRB, 0.87894907E-10_JPRB, 0.87889696E-10_JPRB, 0.87890181E-10_JPRB, 0.87893560E-10_JPRB, 0.87897495E-10_JPRB, &
  & 0.87900381E-10_JPRB, 0.87901166E-10_JPRB, 0.87899493E-10_JPRB, 0.87895462E-10_JPRB, 0.87890029E-10_JPRB, 0.87883728E-10_JPRB, &
  & 0.87876893E-10_JPRB, 0.87869143E-10_JPRB, 0.87860358E-10_JPRB, 0.87851018E-10_JPRB, 0.87841873E-10_JPRB, 0.87833574E-10_JPRB, &
  & 0.87826080E-10_JPRB, 0.87818794E-10_JPRB, 0.87810328E-10_JPRB, 0.87796090E-10_JPRB /)

RGHG9(:,66,10) = (/ &
  & 0.87601343E-10_JPRB, 0.87626774E-10_JPRB, 0.87640117E-10_JPRB, 0.87650873E-10_JPRB, 0.87661059E-10_JPRB, 0.87670274E-10_JPRB, &
  & 0.87678753E-10_JPRB, 0.87685928E-10_JPRB, 0.87694060E-10_JPRB, 0.87702220E-10_JPRB, 0.87712657E-10_JPRB, 0.87723696E-10_JPRB, &
  & 0.87733751E-10_JPRB, 0.87738955E-10_JPRB, 0.87735513E-10_JPRB, 0.87720428E-10_JPRB, 0.87693144E-10_JPRB, 0.87656549E-10_JPRB, &
  & 0.87616914E-10_JPRB, 0.87582233E-10_JPRB, 0.87560723E-10_JPRB, 0.87558363E-10_JPRB, 0.87577681E-10_JPRB, 0.87618003E-10_JPRB, &
  & 0.87675374E-10_JPRB, 0.87744485E-10_JPRB, 0.87819099E-10_JPRB, 0.87893692E-10_JPRB, 0.87964254E-10_JPRB, 0.88027426E-10_JPRB, &
  & 0.88080321E-10_JPRB, 0.88120657E-10_JPRB, 0.88147309E-10_JPRB, 0.88160347E-10_JPRB, 0.88160736E-10_JPRB, 0.88149876E-10_JPRB, &
  & 0.88129254E-10_JPRB, 0.88100797E-10_JPRB, 0.88066915E-10_JPRB, 0.88030534E-10_JPRB, 0.87995493E-10_JPRB, 0.87965690E-10_JPRB, &
  & 0.87944138E-10_JPRB, 0.87931572E-10_JPRB, 0.87926749E-10_JPRB, 0.87927256E-10_JPRB, 0.87930468E-10_JPRB, 0.87934118E-10_JPRB, &
  & 0.87936755E-10_JPRB, 0.87937380E-10_JPRB, 0.87935735E-10_JPRB, 0.87931815E-10_JPRB, 0.87926097E-10_JPRB, 0.87919325E-10_JPRB, &
  & 0.87911456E-10_JPRB, 0.87902595E-10_JPRB, 0.87892707E-10_JPRB, 0.87882132E-10_JPRB, 0.87871856E-10_JPRB, 0.87862342E-10_JPRB, &
  & 0.87853343E-10_JPRB, 0.87844072E-10_JPRB, 0.87833109E-10_JPRB, 0.87813423E-10_JPRB /)

RGHG9(:,67,10) = (/ &
  & 0.87646675E-10_JPRB, 0.87675450E-10_JPRB, 0.87689751E-10_JPRB, 0.87701242E-10_JPRB, 0.87711477E-10_JPRB, 0.87720928E-10_JPRB, &
  & 0.87729220E-10_JPRB, 0.87737782E-10_JPRB, 0.87746123E-10_JPRB, 0.87756871E-10_JPRB, 0.87768182E-10_JPRB, 0.87780685E-10_JPRB, &
  & 0.87790879E-10_JPRB, 0.87795951E-10_JPRB, 0.87792808E-10_JPRB, 0.87779048E-10_JPRB, 0.87754207E-10_JPRB, 0.87720713E-10_JPRB, &
  & 0.87684186E-10_JPRB, 0.87652212E-10_JPRB, 0.87632165E-10_JPRB, 0.87629515E-10_JPRB, 0.87646577E-10_JPRB, 0.87682632E-10_JPRB, &
  & 0.87734479E-10_JPRB, 0.87796964E-10_JPRB, 0.87864799E-10_JPRB, 0.87932758E-10_JPRB, 0.87997241E-10_JPRB, 0.88054952E-10_JPRB, &
  & 0.88103212E-10_JPRB, 0.88140009E-10_JPRB, 0.88164184E-10_JPRB, 0.88176105E-10_JPRB, 0.88176640E-10_JPRB, 0.88167015E-10_JPRB, &
  & 0.88148544E-10_JPRB, 0.88122773E-10_JPRB, 0.88092020E-10_JPRB, 0.88058782E-10_JPRB, 0.88026621E-10_JPRB, 0.87999191E-10_JPRB, &
  & 0.87979221E-10_JPRB, 0.87967557E-10_JPRB, 0.87962970E-10_JPRB, 0.87963366E-10_JPRB, 0.87966301E-10_JPRB, 0.87969645E-10_JPRB, &
  & 0.87971998E-10_JPRB, 0.87972518E-10_JPRB, 0.87970881E-10_JPRB, 0.87967050E-10_JPRB, 0.87961347E-10_JPRB, 0.87954186E-10_JPRB, &
  & 0.87945748E-10_JPRB, 0.87936089E-10_JPRB, 0.87925278E-10_JPRB, 0.87913919E-10_JPRB, 0.87902768E-10_JPRB, 0.87892041E-10_JPRB, &
  & 0.87881626E-10_JPRB, 0.87870225E-10_JPRB, 0.87855681E-10_JPRB, 0.87829355E-10_JPRB /)

RGHG9(:,68,10) = (/ &
  & 0.87689619E-10_JPRB, 0.87722649E-10_JPRB, 0.87738934E-10_JPRB, 0.87751251E-10_JPRB, 0.87761985E-10_JPRB, 0.87771512E-10_JPRB, &
  & 0.87780401E-10_JPRB, 0.87789012E-10_JPRB, 0.87799268E-10_JPRB, 0.87810259E-10_JPRB, 0.87823228E-10_JPRB, 0.87835697E-10_JPRB, &
  & 0.87845932E-10_JPRB, 0.87851254E-10_JPRB, 0.87848610E-10_JPRB, 0.87836058E-10_JPRB, 0.87813354E-10_JPRB, 0.87782920E-10_JPRB, &
  & 0.87749724E-10_JPRB, 0.87720595E-10_JPRB, 0.87702165E-10_JPRB, 0.87699313E-10_JPRB, 0.87714121E-10_JPRB, 0.87746185E-10_JPRB, &
  & 0.87792371E-10_JPRB, 0.87848409E-10_JPRB, 0.87909305E-10_JPRB, 0.87970617E-10_JPRB, 0.88028945E-10_JPRB, 0.88081091E-10_JPRB, &
  & 0.88124778E-10_JPRB, 0.88157905E-10_JPRB, 0.88179693E-10_JPRB, 0.88190462E-10_JPRB, 0.88191093E-10_JPRB, 0.88182663E-10_JPRB, &
  & 0.88166252E-10_JPRB, 0.88143250E-10_JPRB, 0.88115598E-10_JPRB, 0.88085643E-10_JPRB, 0.88056507E-10_JPRB, 0.88031561E-10_JPRB, &
  & 0.88013347E-10_JPRB, 0.88002577E-10_JPRB, 0.87998275E-10_JPRB, 0.87998539E-10_JPRB, 0.88001106E-10_JPRB, 0.88004132E-10_JPRB, &
  & 0.88006206E-10_JPRB, 0.88006595E-10_JPRB, 0.88005013E-10_JPRB, 0.88001287E-10_JPRB, 0.87995652E-10_JPRB, 0.87988380E-10_JPRB, &
  & 0.87979610E-10_JPRB, 0.87969479E-10_JPRB, 0.87958252E-10_JPRB, 0.87946400E-10_JPRB, 0.87934576E-10_JPRB, 0.87923224E-10_JPRB, &
  & 0.87911387E-10_JPRB, 0.87898154E-10_JPRB, 0.87880057E-10_JPRB, 0.87846355E-10_JPRB /)

RGHG9(:,69,10) = (/ &
  & 0.87731086E-10_JPRB, 0.87769930E-10_JPRB, 0.87788193E-10_JPRB, 0.87801745E-10_JPRB, 0.87812937E-10_JPRB, 0.87822798E-10_JPRB, &
  & 0.87831908E-10_JPRB, 0.87841318E-10_JPRB, 0.87851809E-10_JPRB, 0.87863966E-10_JPRB, 0.87876741E-10_JPRB, 0.87889078E-10_JPRB, &
  & 0.87898813E-10_JPRB, 0.87903712E-10_JPRB, 0.87901436E-10_JPRB, 0.87890348E-10_JPRB, 0.87870183E-10_JPRB, 0.87842934E-10_JPRB, &
  & 0.87813125E-10_JPRB, 0.87786792E-10_JPRB, 0.87769986E-10_JPRB, 0.87766933E-10_JPRB, 0.87779652E-10_JPRB, 0.87807726E-10_JPRB, &
  & 0.87848576E-10_JPRB, 0.87898210E-10_JPRB, 0.87952402E-10_JPRB, 0.88007136E-10_JPRB, 0.88059282E-10_JPRB, 0.88106022E-10_JPRB, &
  & 0.88145047E-10_JPRB, 0.88174620E-10_JPRB, 0.88194001E-10_JPRB, 0.88203625E-10_JPRB, 0.88204284E-10_JPRB, 0.88196998E-10_JPRB, &
  & 0.88182558E-10_JPRB, 0.88162193E-10_JPRB, 0.88137636E-10_JPRB, 0.88110928E-10_JPRB, 0.88084894E-10_JPRB, 0.88062599E-10_JPRB, &
  & 0.88046237E-10_JPRB, 0.88036509E-10_JPRB, 0.88032574E-10_JPRB, 0.88032713E-10_JPRB, 0.88034996E-10_JPRB, 0.88037681E-10_JPRB, &
  & 0.88039534E-10_JPRB, 0.88039860E-10_JPRB, 0.88038306E-10_JPRB, 0.88034725E-10_JPRB, 0.88029216E-10_JPRB, 0.88022048E-10_JPRB, &
  & 0.88013243E-10_JPRB, 0.88003042E-10_JPRB, 0.87991711E-10_JPRB, 0.87979631E-10_JPRB, 0.87967689E-10_JPRB, 0.87955608E-10_JPRB, &
  & 0.87943243E-10_JPRB, 0.87928206E-10_JPRB, 0.87907140E-10_JPRB, 0.87865867E-10_JPRB /)

RGHG9(:,70,10) = (/ &
  & 0.87772720E-10_JPRB, 0.87817559E-10_JPRB, 0.87838493E-10_JPRB, 0.87852982E-10_JPRB, 0.87864785E-10_JPRB, 0.87874916E-10_JPRB, &
  & 0.87884262E-10_JPRB, 0.87894025E-10_JPRB, 0.87904822E-10_JPRB, 0.87916840E-10_JPRB, 0.87929171E-10_JPRB, 0.87940780E-10_JPRB, &
  & 0.87949870E-10_JPRB, 0.87954762E-10_JPRB, 0.87952708E-10_JPRB, 0.87942729E-10_JPRB, 0.87924723E-10_JPRB, 0.87900548E-10_JPRB, &
  & 0.87873916E-10_JPRB, 0.87850387E-10_JPRB, 0.87835073E-10_JPRB, 0.87831867E-10_JPRB, 0.87842580E-10_JPRB, 0.87866978E-10_JPRB, &
  & 0.87902643E-10_JPRB, 0.87946178E-10_JPRB, 0.87993869E-10_JPRB, 0.88042205E-10_JPRB, 0.88088384E-10_JPRB, 0.88129670E-10_JPRB, &
  & 0.88164157E-10_JPRB, 0.88190205E-10_JPRB, 0.88207254E-10_JPRB, 0.88215775E-10_JPRB, 0.88216399E-10_JPRB, 0.88210161E-10_JPRB, &
  & 0.88197602E-10_JPRB, 0.88179783E-10_JPRB, 0.88158182E-10_JPRB, 0.88134673E-10_JPRB, 0.88111740E-10_JPRB, 0.88092103E-10_JPRB, &
  & 0.88077726E-10_JPRB, 0.88069184E-10_JPRB, 0.88065714E-10_JPRB, 0.88065860E-10_JPRB, 0.88067872E-10_JPRB, 0.88070301E-10_JPRB, &
  & 0.88071966E-10_JPRB, 0.88072209E-10_JPRB, 0.88070704E-10_JPRB, 0.88067359E-10_JPRB, 0.88062127E-10_JPRB, 0.88055258E-10_JPRB, &
  & 0.88046737E-10_JPRB, 0.88036869E-10_JPRB, 0.88025739E-10_JPRB, 0.88013909E-10_JPRB, 0.88001946E-10_JPRB, 0.87989935E-10_JPRB, &
  & 0.87976904E-10_JPRB, 0.87961326E-10_JPRB, 0.87937581E-10_JPRB, 0.87890570E-10_JPRB /)

RGHG9(:,71,10) = (/ &
  & 0.87816261E-10_JPRB, 0.87867366E-10_JPRB, 0.87889834E-10_JPRB, 0.87905364E-10_JPRB, 0.87917382E-10_JPRB, 0.87927693E-10_JPRB, &
  & 0.87937262E-10_JPRB, 0.87946816E-10_JPRB, 0.87957662E-10_JPRB, 0.87968667E-10_JPRB, 0.87980276E-10_JPRB, 0.87990559E-10_JPRB, &
  & 0.87998608E-10_JPRB, 0.88002675E-10_JPRB, 0.88000919E-10_JPRB, 0.87992301E-10_JPRB, 0.87976557E-10_JPRB, 0.87955282E-10_JPRB, &
  & 0.87931787E-10_JPRB, 0.87910845E-10_JPRB, 0.87897134E-10_JPRB, 0.87893810E-10_JPRB, 0.87902706E-10_JPRB, 0.87923648E-10_JPRB, &
  & 0.87954401E-10_JPRB, 0.87992183E-10_JPRB, 0.88033539E-10_JPRB, 0.88075797E-10_JPRB, 0.88116112E-10_JPRB, 0.88152152E-10_JPRB, &
  & 0.88182205E-10_JPRB, 0.88204818E-10_JPRB, 0.88219647E-10_JPRB, 0.88227058E-10_JPRB, 0.88227640E-10_JPRB, 0.88222346E-10_JPRB, &
  & 0.88211535E-10_JPRB, 0.88196159E-10_JPRB, 0.88177382E-10_JPRB, 0.88156947E-10_JPRB, 0.88137005E-10_JPRB, 0.88119990E-10_JPRB, &
  & 0.88107625E-10_JPRB, 0.88100298E-10_JPRB, 0.88097425E-10_JPRB, 0.88097654E-10_JPRB, 0.88099535E-10_JPRB, 0.88101762E-10_JPRB, &
  & 0.88103275E-10_JPRB, 0.88103511E-10_JPRB, 0.88102109E-10_JPRB, 0.88099056E-10_JPRB, 0.88094247E-10_JPRB, 0.88087884E-10_JPRB, &
  & 0.88080078E-10_JPRB, 0.88070794E-10_JPRB, 0.88060413E-10_JPRB, 0.88049075E-10_JPRB, 0.88037515E-10_JPRB, 0.88025767E-10_JPRB, &
  & 0.88012972E-10_JPRB, 0.87997047E-10_JPRB, 0.87972393E-10_JPRB, 0.87921219E-10_JPRB /)

RGHG9(:,72,10) = (/ &
  & 0.87864008E-10_JPRB, 0.87918894E-10_JPRB, 0.87942639E-10_JPRB, 0.87958266E-10_JPRB, 0.87970325E-10_JPRB, 0.87980546E-10_JPRB, &
  & 0.87989803E-10_JPRB, 0.87999295E-10_JPRB, 0.88008767E-10_JPRB, 0.88019488E-10_JPRB, 0.88028987E-10_JPRB, 0.88038320E-10_JPRB, &
  & 0.88045141E-10_JPRB, 0.88048943E-10_JPRB, 0.88047028E-10_JPRB, 0.88039284E-10_JPRB, 0.88025524E-10_JPRB, 0.88007032E-10_JPRB, &
  & 0.87986479E-10_JPRB, 0.87968174E-10_JPRB, 0.87955976E-10_JPRB, 0.87952715E-10_JPRB, 0.87959980E-10_JPRB, 0.87977639E-10_JPRB, &
  & 0.88003840E-10_JPRB, 0.88036002E-10_JPRB, 0.88071467E-10_JPRB, 0.88107750E-10_JPRB, 0.88142507E-10_JPRB, 0.88173427E-10_JPRB, &
  & 0.88199198E-10_JPRB, 0.88218502E-10_JPRB, 0.88231152E-10_JPRB, 0.88237556E-10_JPRB, 0.88238084E-10_JPRB, 0.88233615E-10_JPRB, &
  & 0.88224449E-10_JPRB, 0.88211369E-10_JPRB, 0.88195340E-10_JPRB, 0.88177778E-10_JPRB, 0.88160770E-10_JPRB, 0.88146296E-10_JPRB, &
  & 0.88135881E-10_JPRB, 0.88129795E-10_JPRB, 0.88127519E-10_JPRB, 0.88127873E-10_JPRB, 0.88129629E-10_JPRB, 0.88131752E-10_JPRB, &
  & 0.88133112E-10_JPRB, 0.88133389E-10_JPRB, 0.88132168E-10_JPRB, 0.88129504E-10_JPRB, 0.88125215E-10_JPRB, 0.88119755E-10_JPRB, &
  & 0.88112601E-10_JPRB, 0.88104662E-10_JPRB, 0.88095010E-10_JPRB, 0.88084567E-10_JPRB, 0.88074027E-10_JPRB, 0.88062710E-10_JPRB, &
  & 0.88050699E-10_JPRB, 0.88035468E-10_JPRB, 0.88010370E-10_JPRB, 0.87958148E-10_JPRB /)

RGHG9(:,73,10) = (/ &
  & 0.87918006E-10_JPRB, 0.87972615E-10_JPRB, 0.87995840E-10_JPRB, 0.88010904E-10_JPRB, 0.88022367E-10_JPRB, 0.88032123E-10_JPRB, &
  & 0.88040950E-10_JPRB, 0.88049221E-10_JPRB, 0.88058484E-10_JPRB, 0.88066637E-10_JPRB, 0.88075873E-10_JPRB, 0.88083013E-10_JPRB, &
  & 0.88088876E-10_JPRB, 0.88091652E-10_JPRB, 0.88089959E-10_JPRB, 0.88083263E-10_JPRB, 0.88071356E-10_JPRB, 0.88055473E-10_JPRB, &
  & 0.88037827E-10_JPRB, 0.88021992E-10_JPRB, 0.88011515E-10_JPRB, 0.88008420E-10_JPRB, 0.88014193E-10_JPRB, 0.88028841E-10_JPRB, &
  & 0.88050650E-10_JPRB, 0.88077656E-10_JPRB, 0.88107383E-10_JPRB, 0.88138101E-10_JPRB, 0.88167390E-10_JPRB, 0.88193480E-10_JPRB, &
  & 0.88215137E-10_JPRB, 0.88231318E-10_JPRB, 0.88241900E-10_JPRB, 0.88247326E-10_JPRB, 0.88247840E-10_JPRB, 0.88244093E-10_JPRB, &
  & 0.88236453E-10_JPRB, 0.88225580E-10_JPRB, 0.88212083E-10_JPRB, 0.88197283E-10_JPRB, 0.88183044E-10_JPRB, 0.88170977E-10_JPRB, &
  & 0.88162443E-10_JPRB, 0.88157488E-10_JPRB, 0.88155774E-10_JPRB, 0.88156253E-10_JPRB, 0.88157905E-10_JPRB, 0.88159896E-10_JPRB, &
  & 0.88161131E-10_JPRB, 0.88161478E-10_JPRB, 0.88160521E-10_JPRB, 0.88158300E-10_JPRB, 0.88154761E-10_JPRB, 0.88149966E-10_JPRB, &
  & 0.88144200E-10_JPRB, 0.88137005E-10_JPRB, 0.88128872E-10_JPRB, 0.88119644E-10_JPRB, 0.88109832E-10_JPRB, 0.88100145E-10_JPRB, &
  & 0.88088759E-10_JPRB, 0.88074867E-10_JPRB, 0.88051302E-10_JPRB, 0.87999177E-10_JPRB /)

RGHG9(:,74,10) = (/ &
  & 0.87973490E-10_JPRB, 0.88026461E-10_JPRB, 0.88048006E-10_JPRB, 0.88061836E-10_JPRB, 0.88072320E-10_JPRB, 0.88081202E-10_JPRB, &
  & 0.88089043E-10_JPRB, 0.88096759E-10_JPRB, 0.88103788E-10_JPRB, 0.88111969E-10_JPRB, 0.88118408E-10_JPRB, 0.88125118E-10_JPRB, &
  & 0.88129497E-10_JPRB, 0.88132016E-10_JPRB, 0.88130045E-10_JPRB, 0.88124133E-10_JPRB, 0.88114002E-10_JPRB, 0.88100659E-10_JPRB, &
  & 0.88085761E-10_JPRB, 0.88072487E-10_JPRB, 0.88063612E-10_JPRB, 0.88060823E-10_JPRB, 0.88065263E-10_JPRB, 0.88077080E-10_JPRB, &
  & 0.88094886E-10_JPRB, 0.88116958E-10_JPRB, 0.88141383E-10_JPRB, 0.88166710E-10_JPRB, 0.88190878E-10_JPRB, 0.88212299E-10_JPRB, &
  & 0.88230097E-10_JPRB, 0.88243308E-10_JPRB, 0.88251940E-10_JPRB, 0.88256472E-10_JPRB, 0.88256930E-10_JPRB, 0.88253849E-10_JPRB, &
  & 0.88247597E-10_JPRB, 0.88238791E-10_JPRB, 0.88227745E-10_JPRB, 0.88215553E-10_JPRB, 0.88203937E-10_JPRB, 0.88194153E-10_JPRB, &
  & 0.88187325E-10_JPRB, 0.88183419E-10_JPRB, 0.88182191E-10_JPRB, 0.88182711E-10_JPRB, 0.88184182E-10_JPRB, 0.88186049E-10_JPRB, &
  & 0.88187152E-10_JPRB, 0.88187582E-10_JPRB, 0.88186868E-10_JPRB, 0.88185154E-10_JPRB, 0.88182295E-10_JPRB, 0.88178569E-10_JPRB, &
  & 0.88173399E-10_JPRB, 0.88167917E-10_JPRB, 0.88160826E-10_JPRB, 0.88152777E-10_JPRB, 0.88144977E-10_JPRB, 0.88135790E-10_JPRB, &
  & 0.88126423E-10_JPRB, 0.88114037E-10_JPRB, 0.88091937E-10_JPRB, 0.88043149E-10_JPRB /)

RGHG9(:,75,10) = (/ &
  & 0.88029403E-10_JPRB, 0.88078517E-10_JPRB, 0.88098182E-10_JPRB, 0.88110227E-10_JPRB, 0.88119269E-10_JPRB, 0.88127020E-10_JPRB, &
  & 0.88133958E-10_JPRB, 0.88140044E-10_JPRB, 0.88146726E-10_JPRB, 0.88152319E-10_JPRB, 0.88158661E-10_JPRB, 0.88163227E-10_JPRB, &
  & 0.88166856E-10_JPRB, 0.88168556E-10_JPRB, 0.88166800E-10_JPRB, 0.88161832E-10_JPRB, 0.88153457E-10_JPRB, 0.88142577E-10_JPRB, &
  & 0.88130427E-10_JPRB, 0.88119519E-10_JPRB, 0.88112302E-10_JPRB, 0.88109874E-10_JPRB, 0.88113176E-10_JPRB, 0.88122398E-10_JPRB, &
  & 0.88136470E-10_JPRB, 0.88154040E-10_JPRB, 0.88173413E-10_JPRB, 0.88193654E-10_JPRB, 0.88212888E-10_JPRB, 0.88229916E-10_JPRB, &
  & 0.88244086E-10_JPRB, 0.88254529E-10_JPRB, 0.88261322E-10_JPRB, 0.88265062E-10_JPRB, 0.88265492E-10_JPRB, 0.88263001E-10_JPRB, &
  & 0.88258033E-10_JPRB, 0.88251184E-10_JPRB, 0.88242427E-10_JPRB, 0.88232664E-10_JPRB, 0.88223567E-10_JPRB, 0.88215858E-10_JPRB, &
  & 0.88210640E-10_JPRB, 0.88207670E-10_JPRB, 0.88206824E-10_JPRB, 0.88207303E-10_JPRB, 0.88208552E-10_JPRB, 0.88210265E-10_JPRB, &
  & 0.88211188E-10_JPRB, 0.88211674E-10_JPRB, 0.88211174E-10_JPRB, 0.88209953E-10_JPRB, 0.88207809E-10_JPRB, 0.88204666E-10_JPRB, &
  & 0.88200759E-10_JPRB, 0.88196117E-10_JPRB, 0.88190559E-10_JPRB, 0.88184321E-10_JPRB, 0.88177209E-10_JPRB, 0.88170478E-10_JPRB, &
  & 0.88161832E-10_JPRB, 0.88151812E-10_JPRB, 0.88132376E-10_JPRB, 0.88086809E-10_JPRB /)

RGHG9(:,76,10) = (/ &
  & 0.88083728E-10_JPRB, 0.88128803E-10_JPRB, 0.88145685E-10_JPRB, 0.88155573E-10_JPRB, 0.88162901E-10_JPRB, 0.88169402E-10_JPRB, &
  & 0.88175030E-10_JPRB, 0.88180289E-10_JPRB, 0.88185008E-10_JPRB, 0.88190288E-10_JPRB, 0.88194334E-10_JPRB, 0.88198268E-10_JPRB, &
  & 0.88200572E-10_JPRB, 0.88201869E-10_JPRB, 0.88200197E-10_JPRB, 0.88196277E-10_JPRB, 0.88189726E-10_JPRB, 0.88181462E-10_JPRB, &
  & 0.88171866E-10_JPRB, 0.88163268E-10_JPRB, 0.88157669E-10_JPRB, 0.88155677E-10_JPRB, 0.88157974E-10_JPRB, 0.88164920E-10_JPRB, &
  & 0.88175564E-10_JPRB, 0.88188894E-10_JPRB, 0.88203556E-10_JPRB, 0.88218939E-10_JPRB, 0.88233573E-10_JPRB, 0.88246396E-10_JPRB, &
  & 0.88257207E-10_JPRB, 0.88265069E-10_JPRB, 0.88270176E-10_JPRB, 0.88273173E-10_JPRB, 0.88273583E-10_JPRB, 0.88271626E-10_JPRB, &
  & 0.88267831E-10_JPRB, 0.88262821E-10_JPRB, 0.88256166E-10_JPRB, 0.88248749E-10_JPRB, 0.88241955E-10_JPRB, 0.88236279E-10_JPRB, &
  & 0.88232463E-10_JPRB, 0.88230312E-10_JPRB, 0.88229743E-10_JPRB, 0.88230118E-10_JPRB, 0.88231061E-10_JPRB, 0.88232595E-10_JPRB, &
  & 0.88233268E-10_JPRB, 0.88233774E-10_JPRB, 0.88233421E-10_JPRB, 0.88232678E-10_JPRB, 0.88231145E-10_JPRB, 0.88228758E-10_JPRB, &
  & 0.88225441E-10_JPRB, 0.88222152E-10_JPRB, 0.88218030E-10_JPRB, 0.88212881E-10_JPRB, 0.88208142E-10_JPRB, 0.88202022E-10_JPRB, &
  & 0.88195819E-10_JPRB, 0.88187423E-10_JPRB, 0.88171095E-10_JPRB, 0.88130753E-10_JPRB /)

RGHG9(:,77,10) = (/ &
  & 0.88136762E-10_JPRB, 0.88176175E-10_JPRB, 0.88190046E-10_JPRB, 0.88197477E-10_JPRB, 0.88202855E-10_JPRB, 0.88207969E-10_JPRB, &
  & 0.88212555E-10_JPRB, 0.88216254E-10_JPRB, 0.88220119E-10_JPRB, 0.88223533E-10_JPRB, 0.88226731E-10_JPRB, 0.88229070E-10_JPRB, &
  & 0.88230541E-10_JPRB, 0.88231346E-10_JPRB, 0.88229868E-10_JPRB, 0.88227092E-10_JPRB, 0.88222492E-10_JPRB, 0.88216781E-10_JPRB, &
  & 0.88209787E-10_JPRB, 0.88203458E-10_JPRB, 0.88199420E-10_JPRB, 0.88197942E-10_JPRB, 0.88199441E-10_JPRB, 0.88204291E-10_JPRB, &
  & 0.88211834E-10_JPRB, 0.88221333E-10_JPRB, 0.88231547E-10_JPRB, 0.88242448E-10_JPRB, 0.88252773E-10_JPRB, 0.88261731E-10_JPRB, &
  & 0.88269440E-10_JPRB, 0.88274957E-10_JPRB, 0.88278503E-10_JPRB, 0.88280841E-10_JPRB, 0.88281257E-10_JPRB, 0.88279759E-10_JPRB, &
  & 0.88276997E-10_JPRB, 0.88273687E-10_JPRB, 0.88269010E-10_JPRB, 0.88263660E-10_JPRB, 0.88259081E-10_JPRB, 0.88255181E-10_JPRB, &
  & 0.88252669E-10_JPRB, 0.88251184E-10_JPRB, 0.88250789E-10_JPRB, 0.88250941E-10_JPRB, 0.88251538E-10_JPRB, 0.88252884E-10_JPRB, &
  & 0.88253245E-10_JPRB, 0.88253779E-10_JPRB, 0.88253502E-10_JPRB, 0.88253196E-10_JPRB, 0.88252274E-10_JPRB, 0.88250358E-10_JPRB, &
  & 0.88247881E-10_JPRB, 0.88245578E-10_JPRB, 0.88242802E-10_JPRB, 0.88239416E-10_JPRB, 0.88235752E-10_JPRB, 0.88231755E-10_JPRB, &
  & 0.88226704E-10_JPRB, 0.88220903E-10_JPRB, 0.88207677E-10_JPRB, 0.88173718E-10_JPRB /)

RGHG9(:,78,10) = (/ &
  & 0.88188019E-10_JPRB, 0.88218793E-10_JPRB, 0.88228445E-10_JPRB, 0.88233226E-10_JPRB, 0.88236710E-10_JPRB, 0.88240568E-10_JPRB, &
  & 0.88243995E-10_JPRB, 0.88246570E-10_JPRB, 0.88248915E-10_JPRB, 0.88251365E-10_JPRB, 0.88253023E-10_JPRB, 0.88254376E-10_JPRB, &
  & 0.88254973E-10_JPRB, 0.88255417E-10_JPRB, 0.88254341E-10_JPRB, 0.88252620E-10_JPRB, 0.88249838E-10_JPRB, 0.88246598E-10_JPRB, &
  & 0.88242025E-10_JPRB, 0.88237820E-10_JPRB, 0.88235357E-10_JPRB, 0.88234489E-10_JPRB, 0.88235412E-10_JPRB, 0.88238541E-10_JPRB, &
  & 0.88243433E-10_JPRB, 0.88249644E-10_JPRB, 0.88255944E-10_JPRB, 0.88263064E-10_JPRB, 0.88269551E-10_JPRB, 0.88275276E-10_JPRB, &
  & 0.88280244E-10_JPRB, 0.88283769E-10_JPRB, 0.88285976E-10_JPRB, 0.88287731E-10_JPRB, 0.88288168E-10_JPRB, 0.88287024E-10_JPRB, &
  & 0.88285129E-10_JPRB, 0.88283277E-10_JPRB, 0.88280286E-10_JPRB, 0.88276719E-10_JPRB, 0.88273999E-10_JPRB, 0.88271612E-10_JPRB, &
  & 0.88270072E-10_JPRB, 0.88269073E-10_JPRB, 0.88268705E-10_JPRB, 0.88268608E-10_JPRB, 0.88268795E-10_JPRB, 0.88269982E-10_JPRB, &
  & 0.88270002E-10_JPRB, 0.88270537E-10_JPRB, 0.88270259E-10_JPRB, 0.88270329E-10_JPRB, 0.88269947E-10_JPRB, 0.88268455E-10_JPRB, &
  & 0.88266533E-10_JPRB, 0.88265159E-10_JPRB, 0.88263757E-10_JPRB, 0.88261398E-10_JPRB, 0.88259573E-10_JPRB, 0.88256430E-10_JPRB, &
  & 0.88253405E-10_JPRB, 0.88249401E-10_JPRB, 0.88240672E-10_JPRB, 0.88215539E-10_JPRB /)

RGHG9(:,79,10) = (/ &
  & 0.88221187E-10_JPRB, 0.88242809E-10_JPRB, 0.88248971E-10_JPRB, 0.88251795E-10_JPRB, 0.88254154E-10_JPRB, 0.88257408E-10_JPRB, &
  & 0.88260399E-10_JPRB, 0.88262161E-10_JPRB, 0.88263813E-10_JPRB, 0.88265631E-10_JPRB, 0.88266665E-10_JPRB, 0.88267456E-10_JPRB, &
  & 0.88267636E-10_JPRB, 0.88267893E-10_JPRB, 0.88267019E-10_JPRB, 0.88265929E-10_JPRB, 0.88264125E-10_JPRB, 0.88262328E-10_JPRB, &
  & 0.88259060E-10_JPRB, 0.88256014E-10_JPRB, 0.88254501E-10_JPRB, 0.88254043E-10_JPRB, 0.88254709E-10_JPRB, 0.88256957E-10_JPRB, &
  & 0.88260468E-10_JPRB, 0.88264965E-10_JPRB, 0.88269142E-10_JPRB, 0.88274214E-10_JPRB, 0.88278614E-10_JPRB, 0.88282562E-10_JPRB, &
  & 0.88286101E-10_JPRB, 0.88288502E-10_JPRB, 0.88289979E-10_JPRB, 0.88291492E-10_JPRB, 0.88291957E-10_JPRB, 0.88290965E-10_JPRB, &
  & 0.88289473E-10_JPRB, 0.88288425E-10_JPRB, 0.88286350E-10_JPRB, 0.88283686E-10_JPRB, 0.88281958E-10_JPRB, 0.88280334E-10_JPRB, &
  & 0.88279335E-10_JPRB, 0.88278565E-10_JPRB, 0.88278204E-10_JPRB, 0.88277843E-10_JPRB, 0.88277774E-10_JPRB, 0.88278926E-10_JPRB, &
  & 0.88278697E-10_JPRB, 0.88279314E-10_JPRB, 0.88278981E-10_JPRB, 0.88279280E-10_JPRB, 0.88279224E-10_JPRB, 0.88277816E-10_JPRB, &
  & 0.88276116E-10_JPRB, 0.88275214E-10_JPRB, 0.88274540E-10_JPRB, 0.88272785E-10_JPRB, 0.88271709E-10_JPRB, 0.88269218E-10_JPRB, &
  & 0.88266977E-10_JPRB, 0.88264548E-10_JPRB, 0.88258886E-10_JPRB, 0.88242233E-10_JPRB /)

RGHG9(:,80,10) = (/ &
  & 0.88243433E-10_JPRB, 0.88254445E-10_JPRB, 0.88257984E-10_JPRB, 0.88259802E-10_JPRB, 0.88261586E-10_JPRB, 0.88264632E-10_JPRB, &
  & 0.88267456E-10_JPRB, 0.88268878E-10_JPRB, 0.88270273E-10_JPRB, 0.88271827E-10_JPRB, 0.88272625E-10_JPRB, 0.88273201E-10_JPRB, &
  & 0.88273187E-10_JPRB, 0.88273389E-10_JPRB, 0.88272611E-10_JPRB, 0.88271807E-10_JPRB, 0.88270488E-10_JPRB, 0.88269385E-10_JPRB, &
  & 0.88266727E-10_JPRB, 0.88264146E-10_JPRB, 0.88263105E-10_JPRB, 0.88262848E-10_JPRB, 0.88263410E-10_JPRB, 0.88265277E-10_JPRB, &
  & 0.88268191E-10_JPRB, 0.88271924E-10_JPRB, 0.88275144E-10_JPRB, 0.88279307E-10_JPRB, 0.88282742E-10_JPRB, 0.88285892E-10_JPRB, &
  & 0.88288744E-10_JPRB, 0.88290625E-10_JPRB, 0.88291770E-10_JPRB, 0.88293206E-10_JPRB, 0.88293713E-10_JPRB, 0.88292755E-10_JPRB, &
  & 0.88291423E-10_JPRB, 0.88290784E-10_JPRB, 0.88289098E-10_JPRB, 0.88286808E-10_JPRB, 0.88285532E-10_JPRB, 0.88284269E-10_JPRB, &
  & 0.88283519E-10_JPRB, 0.88282839E-10_JPRB, 0.88282451E-10_JPRB, 0.88281979E-10_JPRB, 0.88281743E-10_JPRB, 0.88282909E-10_JPRB, &
  & 0.88282506E-10_JPRB, 0.88283152E-10_JPRB, 0.88282770E-10_JPRB, 0.88283186E-10_JPRB, 0.88283297E-10_JPRB, 0.88281861E-10_JPRB, &
  & 0.88280189E-10_JPRB, 0.88279495E-10_JPRB, 0.88279169E-10_JPRB, 0.88277594E-10_JPRB, 0.88276976E-10_JPRB, 0.88274589E-10_JPRB, &
  & 0.88272820E-10_JPRB, 0.88271085E-10_JPRB, 0.88267622E-10_JPRB, 0.88259788E-10_JPRB /)

RGHG9(:,81,10) = (/ &
  & 0.88258824E-10_JPRB, 0.88259407E-10_JPRB, 0.88261801E-10_JPRB, 0.88263168E-10_JPRB, 0.88264729E-10_JPRB, 0.88267713E-10_JPRB, &
  & 0.88270488E-10_JPRB, 0.88271807E-10_JPRB, 0.88272965E-10_JPRB, 0.88274568E-10_JPRB, 0.88275172E-10_JPRB, 0.88275692E-10_JPRB, &
  & 0.88275595E-10_JPRB, 0.88275796E-10_JPRB, 0.88275054E-10_JPRB, 0.88274367E-10_JPRB, 0.88273264E-10_JPRB, 0.88272528E-10_JPRB, &
  & 0.88270093E-10_JPRB, 0.88267740E-10_JPRB, 0.88266894E-10_JPRB, 0.88266734E-10_JPRB, 0.88267262E-10_JPRB, 0.88268969E-10_JPRB, &
  & 0.88271626E-10_JPRB, 0.88275012E-10_JPRB, 0.88277802E-10_JPRB, 0.88281570E-10_JPRB, 0.88284553E-10_JPRB, 0.88287350E-10_JPRB, &
  & 0.88289917E-10_JPRB, 0.88291562E-10_JPRB, 0.88292540E-10_JPRB, 0.88293962E-10_JPRB, 0.88294476E-10_JPRB, 0.88293532E-10_JPRB, &
  & 0.88292283E-10_JPRB, 0.88291804E-10_JPRB, 0.88290306E-10_JPRB, 0.88288203E-10_JPRB, 0.88287128E-10_JPRB, 0.88286017E-10_JPRB, &
  & 0.88285393E-10_JPRB, 0.88284741E-10_JPRB, 0.88284338E-10_JPRB, 0.88283797E-10_JPRB, 0.88283450E-10_JPRB, 0.88284657E-10_JPRB, &
  & 0.88284158E-10_JPRB, 0.88284845E-10_JPRB, 0.88284401E-10_JPRB, 0.88284879E-10_JPRB, 0.88285067E-10_JPRB, 0.88283589E-10_JPRB, &
  & 0.88281910E-10_JPRB, 0.88281299E-10_JPRB, 0.88281146E-10_JPRB, 0.88279641E-10_JPRB, 0.88279183E-10_JPRB, 0.88276879E-10_JPRB, &
  & 0.88275262E-10_JPRB, 0.88273833E-10_JPRB, 0.88271279E-10_JPRB, 0.88271793E-10_JPRB /)

RGHG9(:,82,10) = (/ &
  & 0.88260073E-10_JPRB, 0.88261051E-10_JPRB, 0.88263445E-10_JPRB, 0.88264736E-10_JPRB, 0.88266221E-10_JPRB, 0.88269225E-10_JPRB, &
  & 0.88272001E-10_JPRB, 0.88273187E-10_JPRB, 0.88274402E-10_JPRB, 0.88275803E-10_JPRB, 0.88276449E-10_JPRB, 0.88276893E-10_JPRB, &
  & 0.88276775E-10_JPRB, 0.88276955E-10_JPRB, 0.88276220E-10_JPRB, 0.88275616E-10_JPRB, 0.88274631E-10_JPRB, 0.88274089E-10_JPRB, &
  & 0.88271779E-10_JPRB, 0.88269475E-10_JPRB, 0.88268781E-10_JPRB, 0.88268649E-10_JPRB, 0.88269142E-10_JPRB, 0.88270759E-10_JPRB, &
  & 0.88273305E-10_JPRB, 0.88276525E-10_JPRB, 0.88279134E-10_JPRB, 0.88282666E-10_JPRB, 0.88285455E-10_JPRB, 0.88288071E-10_JPRB, &
  & 0.88290444E-10_JPRB, 0.88291992E-10_JPRB, 0.88292922E-10_JPRB, 0.88294330E-10_JPRB, 0.88294871E-10_JPRB, 0.88293907E-10_JPRB, &
  & 0.88292693E-10_JPRB, 0.88292283E-10_JPRB, 0.88290888E-10_JPRB, 0.88288876E-10_JPRB, 0.88287919E-10_JPRB, 0.88286892E-10_JPRB, &
  & 0.88286337E-10_JPRB, 0.88285705E-10_JPRB, 0.88285282E-10_JPRB, 0.88284671E-10_JPRB, 0.88284283E-10_JPRB, 0.88285525E-10_JPRB, &
  & 0.88284956E-10_JPRB, 0.88285664E-10_JPRB, 0.88285178E-10_JPRB, 0.88285705E-10_JPRB, 0.88285927E-10_JPRB, 0.88284401E-10_JPRB, &
  & 0.88282687E-10_JPRB, 0.88282152E-10_JPRB, 0.88282111E-10_JPRB, 0.88280619E-10_JPRB, 0.88280272E-10_JPRB, 0.88277961E-10_JPRB, &
  & 0.88276428E-10_JPRB, 0.88275026E-10_JPRB, 0.88272487E-10_JPRB, 0.88272743E-10_JPRB /)

RGHG9(:,83,10) = (/ &
  & 0.88260954E-10_JPRB, 0.88262009E-10_JPRB, 0.88264396E-10_JPRB, 0.88265603E-10_JPRB, 0.88267060E-10_JPRB, 0.88270058E-10_JPRB, &
  & 0.88272820E-10_JPRB, 0.88274055E-10_JPRB, 0.88275082E-10_JPRB, 0.88276594E-10_JPRB, 0.88277115E-10_JPRB, 0.88277559E-10_JPRB, &
  & 0.88277434E-10_JPRB, 0.88277587E-10_JPRB, 0.88276886E-10_JPRB, 0.88276331E-10_JPRB, 0.88275415E-10_JPRB, 0.88274991E-10_JPRB, &
  & 0.88272722E-10_JPRB, 0.88270481E-10_JPRB, 0.88269836E-10_JPRB, 0.88269732E-10_JPRB, 0.88270197E-10_JPRB, 0.88271779E-10_JPRB, &
  & 0.88274235E-10_JPRB, 0.88277406E-10_JPRB, 0.88279863E-10_JPRB, 0.88283304E-10_JPRB, 0.88285976E-10_JPRB, 0.88288460E-10_JPRB, &
  & 0.88290750E-10_JPRB, 0.88292221E-10_JPRB, 0.88293109E-10_JPRB, 0.88294545E-10_JPRB, 0.88295100E-10_JPRB, 0.88294122E-10_JPRB, &
  & 0.88292929E-10_JPRB, 0.88292547E-10_JPRB, 0.88291208E-10_JPRB, 0.88289299E-10_JPRB, 0.88288370E-10_JPRB, 0.88287405E-10_JPRB, &
  & 0.88286878E-10_JPRB, 0.88286253E-10_JPRB, 0.88285830E-10_JPRB, 0.88285192E-10_JPRB, 0.88284734E-10_JPRB, 0.88286031E-10_JPRB, &
  & 0.88285400E-10_JPRB, 0.88286128E-10_JPRB, 0.88285601E-10_JPRB, 0.88286156E-10_JPRB, 0.88286427E-10_JPRB, 0.88284872E-10_JPRB, &
  & 0.88283131E-10_JPRB, 0.88282617E-10_JPRB, 0.88282638E-10_JPRB, 0.88281160E-10_JPRB, 0.88280883E-10_JPRB, 0.88278579E-10_JPRB, &
  & 0.88277045E-10_JPRB, 0.88275685E-10_JPRB, 0.88273180E-10_JPRB, 0.88273423E-10_JPRB /)

RGHG9(:,84,10) = (/ &
  & 0.88261544E-10_JPRB, 0.88262647E-10_JPRB, 0.88264979E-10_JPRB, 0.88266137E-10_JPRB, 0.88267560E-10_JPRB, 0.88270599E-10_JPRB, &
  & 0.88273416E-10_JPRB, 0.88274534E-10_JPRB, 0.88275692E-10_JPRB, 0.88276934E-10_JPRB, 0.88277538E-10_JPRB, 0.88277920E-10_JPRB, &
  & 0.88277816E-10_JPRB, 0.88277941E-10_JPRB, 0.88277281E-10_JPRB, 0.88276754E-10_JPRB, 0.88275894E-10_JPRB, 0.88275533E-10_JPRB, &
  & 0.88273319E-10_JPRB, 0.88271078E-10_JPRB, 0.88270488E-10_JPRB, 0.88270405E-10_JPRB, 0.88270849E-10_JPRB, 0.88272376E-10_JPRB, &
  & 0.88274832E-10_JPRB, 0.88277927E-10_JPRB, 0.88280334E-10_JPRB, 0.88283728E-10_JPRB, 0.88286260E-10_JPRB, 0.88288710E-10_JPRB, &
  & 0.88290916E-10_JPRB, 0.88292360E-10_JPRB, 0.88293206E-10_JPRB, 0.88294663E-10_JPRB, 0.88295225E-10_JPRB, 0.88294254E-10_JPRB, &
  & 0.88293067E-10_JPRB, 0.88292700E-10_JPRB, 0.88291416E-10_JPRB, 0.88289535E-10_JPRB, 0.88288654E-10_JPRB, 0.88287717E-10_JPRB, &
  & 0.88287232E-10_JPRB, 0.88286600E-10_JPRB, 0.88286163E-10_JPRB, 0.88285497E-10_JPRB, 0.88285018E-10_JPRB, 0.88286337E-10_JPRB, &
  & 0.88285677E-10_JPRB, 0.88286413E-10_JPRB, 0.88285865E-10_JPRB, 0.88286441E-10_JPRB, 0.88286753E-10_JPRB, 0.88285164E-10_JPRB, &
  & 0.88283388E-10_JPRB, 0.88282881E-10_JPRB, 0.88282943E-10_JPRB, 0.88281472E-10_JPRB, 0.88281278E-10_JPRB, 0.88278905E-10_JPRB, &
  & 0.88277448E-10_JPRB, 0.88276067E-10_JPRB, 0.88273638E-10_JPRB, 0.88273874E-10_JPRB /)

RGHG9(:,85,10) = (/ &
  & 0.88261953E-10_JPRB, 0.88263029E-10_JPRB, 0.88265388E-10_JPRB, 0.88266477E-10_JPRB, 0.88267893E-10_JPRB, 0.88271161E-10_JPRB, &
  & 0.88273708E-10_JPRB, 0.88275082E-10_JPRB, 0.88275984E-10_JPRB, 0.88277205E-10_JPRB, 0.88277732E-10_JPRB, 0.88278093E-10_JPRB, &
  & 0.88278052E-10_JPRB, 0.88278079E-10_JPRB, 0.88277538E-10_JPRB, 0.88277045E-10_JPRB, 0.88276220E-10_JPRB, 0.88275880E-10_JPRB, &
  & 0.88273749E-10_JPRB, 0.88271508E-10_JPRB, 0.88270925E-10_JPRB, 0.88270835E-10_JPRB, 0.88271251E-10_JPRB, 0.88272792E-10_JPRB, &
  & 0.88275193E-10_JPRB, 0.88278308E-10_JPRB, 0.88280647E-10_JPRB, 0.88283991E-10_JPRB, 0.88286489E-10_JPRB, 0.88288821E-10_JPRB, &
  & 0.88291041E-10_JPRB, 0.88292436E-10_JPRB, 0.88293275E-10_JPRB, 0.88294760E-10_JPRB, 0.88295329E-10_JPRB, 0.88294330E-10_JPRB, &
  & 0.88293178E-10_JPRB, 0.88292818E-10_JPRB, 0.88291548E-10_JPRB, 0.88289723E-10_JPRB, 0.88288821E-10_JPRB, 0.88287912E-10_JPRB, &
  & 0.88287475E-10_JPRB, 0.88286836E-10_JPRB, 0.88286392E-10_JPRB, 0.88285705E-10_JPRB, 0.88285192E-10_JPRB, 0.88286531E-10_JPRB, &
  & 0.88285858E-10_JPRB, 0.88286600E-10_JPRB, 0.88286031E-10_JPRB, 0.88286628E-10_JPRB, 0.88286961E-10_JPRB, 0.88285344E-10_JPRB, &
  & 0.88283540E-10_JPRB, 0.88283054E-10_JPRB, 0.88283172E-10_JPRB, 0.88281694E-10_JPRB, 0.88281500E-10_JPRB, 0.88279203E-10_JPRB, &
  & 0.88277670E-10_JPRB, 0.88276372E-10_JPRB, 0.88273888E-10_JPRB, 0.88274187E-10_JPRB /)

RGHG9(:,86,10) = (/ &
  & 0.88262182E-10_JPRB, 0.88263306E-10_JPRB, 0.88265610E-10_JPRB, 0.88266706E-10_JPRB, 0.88268337E-10_JPRB, 0.88271279E-10_JPRB, &
  & 0.88274311E-10_JPRB, 0.88275290E-10_JPRB, 0.88276386E-10_JPRB, 0.88277247E-10_JPRB, 0.88277781E-10_JPRB, 0.88278079E-10_JPRB, &
  & 0.88278093E-10_JPRB, 0.88278093E-10_JPRB, 0.88277670E-10_JPRB, 0.88277191E-10_JPRB, 0.88276476E-10_JPRB, 0.88276088E-10_JPRB, &
  & 0.88274034E-10_JPRB, 0.88271820E-10_JPRB, 0.88271203E-10_JPRB, 0.88271120E-10_JPRB, 0.88271480E-10_JPRB, 0.88272958E-10_JPRB, &
  & 0.88275394E-10_JPRB, 0.88278551E-10_JPRB, 0.88280792E-10_JPRB, 0.88284227E-10_JPRB, 0.88286614E-10_JPRB, 0.88288966E-10_JPRB, &
  & 0.88291124E-10_JPRB, 0.88292484E-10_JPRB, 0.88293310E-10_JPRB, 0.88294816E-10_JPRB, 0.88295392E-10_JPRB, 0.88294400E-10_JPRB, &
  & 0.88293220E-10_JPRB, 0.88292929E-10_JPRB, 0.88291666E-10_JPRB, 0.88289785E-10_JPRB, 0.88288939E-10_JPRB, 0.88288016E-10_JPRB, &
  & 0.88287641E-10_JPRB, 0.88286989E-10_JPRB, 0.88286538E-10_JPRB, 0.88285830E-10_JPRB, 0.88285303E-10_JPRB, 0.88286684E-10_JPRB, &
  & 0.88285983E-10_JPRB, 0.88286725E-10_JPRB, 0.88286128E-10_JPRB, 0.88286739E-10_JPRB, 0.88287107E-10_JPRB, 0.88285462E-10_JPRB, &
  & 0.88283617E-10_JPRB, 0.88283117E-10_JPRB, 0.88283290E-10_JPRB, 0.88281805E-10_JPRB, 0.88281674E-10_JPRB, 0.88279294E-10_JPRB, &
  & 0.88277836E-10_JPRB, 0.88276490E-10_JPRB, 0.88274076E-10_JPRB, 0.88274395E-10_JPRB /)

RGHG9(:,87,10) = (/ &
  & 0.88262328E-10_JPRB, 0.88263424E-10_JPRB, 0.88265763E-10_JPRB, 0.88266866E-10_JPRB, 0.88268365E-10_JPRB, 0.88272195E-10_JPRB, &
  & 0.88274166E-10_JPRB, 0.88275678E-10_JPRB, 0.88276435E-10_JPRB, 0.88277316E-10_JPRB, 0.88277760E-10_JPRB, 0.88278045E-10_JPRB, &
  & 0.88278079E-10_JPRB, 0.88278072E-10_JPRB, 0.88277705E-10_JPRB, 0.88277295E-10_JPRB, 0.88276629E-10_JPRB, 0.88276178E-10_JPRB, &
  & 0.88274284E-10_JPRB, 0.88272036E-10_JPRB, 0.88271397E-10_JPRB, 0.88271265E-10_JPRB, 0.88271598E-10_JPRB, 0.88273083E-10_JPRB, &
  & 0.88275484E-10_JPRB, 0.88278711E-10_JPRB, 0.88280924E-10_JPRB, 0.88284338E-10_JPRB, 0.88286725E-10_JPRB, 0.88289015E-10_JPRB, &
  & 0.88291201E-10_JPRB, 0.88292526E-10_JPRB, 0.88293324E-10_JPRB, 0.88294851E-10_JPRB, 0.88295454E-10_JPRB, 0.88294441E-10_JPRB, &
  & 0.88293275E-10_JPRB, 0.88293019E-10_JPRB, 0.88291756E-10_JPRB, 0.88289806E-10_JPRB, 0.88289001E-10_JPRB, 0.88288085E-10_JPRB, &
  & 0.88287738E-10_JPRB, 0.88287079E-10_JPRB, 0.88286614E-10_JPRB, 0.88285892E-10_JPRB, 0.88285365E-10_JPRB, 0.88286760E-10_JPRB, &
  & 0.88286066E-10_JPRB, 0.88286788E-10_JPRB, 0.88286184E-10_JPRB, 0.88286808E-10_JPRB, 0.88287197E-10_JPRB, 0.88285504E-10_JPRB, &
  & 0.88283665E-10_JPRB, 0.88283179E-10_JPRB, 0.88283360E-10_JPRB, 0.88281861E-10_JPRB, 0.88281750E-10_JPRB, 0.88279425E-10_JPRB, &
  & 0.88277906E-10_JPRB, 0.88276601E-10_JPRB, 0.88274138E-10_JPRB, 0.88274506E-10_JPRB /)

RGHG9(:,88,10) = (/ &
  & 0.88262397E-10_JPRB, 0.88263556E-10_JPRB, 0.88265832E-10_JPRB, 0.88266915E-10_JPRB, 0.88268885E-10_JPRB, 0.88271647E-10_JPRB, &
  & 0.88274735E-10_JPRB, 0.88275637E-10_JPRB, 0.88276636E-10_JPRB, 0.88277330E-10_JPRB, 0.88277788E-10_JPRB, 0.88278045E-10_JPRB, &
  & 0.88278079E-10_JPRB, 0.88278072E-10_JPRB, 0.88277753E-10_JPRB, 0.88277337E-10_JPRB, 0.88276712E-10_JPRB, 0.88276261E-10_JPRB, &
  & 0.88274360E-10_JPRB, 0.88272195E-10_JPRB, 0.88271508E-10_JPRB, 0.88271383E-10_JPRB, 0.88271682E-10_JPRB, 0.88273139E-10_JPRB, &
  & 0.88275533E-10_JPRB, 0.88278843E-10_JPRB, 0.88280938E-10_JPRB, 0.88284512E-10_JPRB, 0.88286774E-10_JPRB, 0.88289077E-10_JPRB, &
  & 0.88291249E-10_JPRB, 0.88292554E-10_JPRB, 0.88293324E-10_JPRB, 0.88294892E-10_JPRB, 0.88295468E-10_JPRB, 0.88294476E-10_JPRB, &
  & 0.88293275E-10_JPRB, 0.88293095E-10_JPRB, 0.88291804E-10_JPRB, 0.88289806E-10_JPRB, 0.88289029E-10_JPRB, 0.88288106E-10_JPRB, &
  & 0.88287801E-10_JPRB, 0.88287128E-10_JPRB, 0.88286684E-10_JPRB, 0.88285927E-10_JPRB, 0.88285400E-10_JPRB, 0.88286795E-10_JPRB, &
  & 0.88286101E-10_JPRB, 0.88286815E-10_JPRB, 0.88286219E-10_JPRB, 0.88286857E-10_JPRB, 0.88287259E-10_JPRB, 0.88285532E-10_JPRB, &
  & 0.88283686E-10_JPRB, 0.88283207E-10_JPRB, 0.88283415E-10_JPRB, 0.88281896E-10_JPRB, 0.88281819E-10_JPRB, 0.88279453E-10_JPRB, &
  & 0.88277954E-10_JPRB, 0.88276629E-10_JPRB, 0.88274200E-10_JPRB, 0.88274589E-10_JPRB /)

RGHG9(:,89,10) = (/ &
  & 0.88262467E-10_JPRB, 0.88263619E-10_JPRB, 0.88265867E-10_JPRB, 0.88266901E-10_JPRB, 0.88268351E-10_JPRB, 0.88272320E-10_JPRB, &
  & 0.88274277E-10_JPRB, 0.88275789E-10_JPRB, 0.88276546E-10_JPRB, 0.88277441E-10_JPRB, 0.88277885E-10_JPRB, 0.88278163E-10_JPRB, &
  & 0.88278163E-10_JPRB, 0.88278156E-10_JPRB, 0.88277795E-10_JPRB, 0.88277399E-10_JPRB, 0.88276754E-10_JPRB, 0.88276338E-10_JPRB, &
  & 0.88274436E-10_JPRB, 0.88272167E-10_JPRB, 0.88271557E-10_JPRB, 0.88271432E-10_JPRB, 0.88271702E-10_JPRB, 0.88273160E-10_JPRB, &
  & 0.88275560E-10_JPRB, 0.88278905E-10_JPRB, 0.88280966E-10_JPRB, 0.88284553E-10_JPRB, 0.88286822E-10_JPRB, 0.88289119E-10_JPRB, &
  & 0.88291305E-10_JPRB, 0.88292582E-10_JPRB, 0.88293310E-10_JPRB, 0.88294934E-10_JPRB, 0.88295538E-10_JPRB, 0.88294511E-10_JPRB, &
  & 0.88293262E-10_JPRB, 0.88293137E-10_JPRB, 0.88291839E-10_JPRB, 0.88289764E-10_JPRB, 0.88289064E-10_JPRB, 0.88288127E-10_JPRB, &
  & 0.88287856E-10_JPRB, 0.88287148E-10_JPRB, 0.88286718E-10_JPRB, 0.88285962E-10_JPRB, 0.88285407E-10_JPRB, 0.88286829E-10_JPRB, &
  & 0.88286101E-10_JPRB, 0.88286829E-10_JPRB, 0.88286212E-10_JPRB, 0.88286885E-10_JPRB, 0.88287308E-10_JPRB, 0.88285559E-10_JPRB, &
  & 0.88283686E-10_JPRB, 0.88283221E-10_JPRB, 0.88283443E-10_JPRB, 0.88281916E-10_JPRB, 0.88281875E-10_JPRB, 0.88279495E-10_JPRB, &
  & 0.88277982E-10_JPRB, 0.88276650E-10_JPRB, 0.88274173E-10_JPRB, 0.88274617E-10_JPRB /)

RGHG9(:,90,10) = (/ &
  & 0.88262508E-10_JPRB, 0.88263695E-10_JPRB, 0.88265818E-10_JPRB, 0.88266817E-10_JPRB, 0.88268365E-10_JPRB, 0.88271446E-10_JPRB, &
  & 0.88274610E-10_JPRB, 0.88275540E-10_JPRB, 0.88276622E-10_JPRB, 0.88277538E-10_JPRB, 0.88278065E-10_JPRB, 0.88278357E-10_JPRB, &
  & 0.88278294E-10_JPRB, 0.88278322E-10_JPRB, 0.88277864E-10_JPRB, 0.88277413E-10_JPRB, 0.88276733E-10_JPRB, 0.88276483E-10_JPRB, &
  & 0.88274381E-10_JPRB, 0.88272105E-10_JPRB, 0.88271536E-10_JPRB, 0.88271432E-10_JPRB, 0.88271682E-10_JPRB, 0.88273132E-10_JPRB, &
  & 0.88275533E-10_JPRB, 0.88278974E-10_JPRB, 0.88280924E-10_JPRB, 0.88284630E-10_JPRB, 0.88286836E-10_JPRB, 0.88289126E-10_JPRB, &
  & 0.88291333E-10_JPRB, 0.88292595E-10_JPRB, 0.88293275E-10_JPRB, 0.88294975E-10_JPRB, 0.88295635E-10_JPRB, 0.88294531E-10_JPRB, &
  & 0.88293227E-10_JPRB, 0.88293206E-10_JPRB, 0.88291874E-10_JPRB, 0.88289709E-10_JPRB, 0.88289084E-10_JPRB, 0.88288113E-10_JPRB, &
  & 0.88287877E-10_JPRB, 0.88287169E-10_JPRB, 0.88286746E-10_JPRB, 0.88285948E-10_JPRB, 0.88285372E-10_JPRB, 0.88286906E-10_JPRB, &
  & 0.88286073E-10_JPRB, 0.88286871E-10_JPRB, 0.88286191E-10_JPRB, 0.88286913E-10_JPRB, 0.88287391E-10_JPRB, 0.88285552E-10_JPRB, &
  & 0.88283637E-10_JPRB, 0.88283221E-10_JPRB, 0.88283499E-10_JPRB, 0.88281889E-10_JPRB, 0.88281930E-10_JPRB, 0.88279460E-10_JPRB, &
  & 0.88277954E-10_JPRB, 0.88276657E-10_JPRB, 0.88274131E-10_JPRB, 0.88274638E-10_JPRB /)

RGHG9(:,91,10) = (/ &
  & 0.88262467E-10_JPRB, 0.88263730E-10_JPRB, 0.88265707E-10_JPRB, 0.88266734E-10_JPRB, 0.88267817E-10_JPRB, 0.88271307E-10_JPRB, &
  & 0.88274436E-10_JPRB, 0.88275331E-10_JPRB, 0.88276164E-10_JPRB, 0.88277968E-10_JPRB, 0.88278329E-10_JPRB, 0.88278808E-10_JPRB, &
  & 0.88278253E-10_JPRB, 0.88278697E-10_JPRB, 0.88277774E-10_JPRB, 0.88277462E-10_JPRB, 0.88276553E-10_JPRB, 0.88276782E-10_JPRB, &
  & 0.88274318E-10_JPRB, 0.88271890E-10_JPRB, 0.88271501E-10_JPRB, 0.88271411E-10_JPRB, 0.88271605E-10_JPRB, 0.88273056E-10_JPRB, &
  & 0.88275477E-10_JPRB, 0.88279065E-10_JPRB, 0.88280806E-10_JPRB, 0.88284720E-10_JPRB, 0.88286822E-10_JPRB, 0.88289119E-10_JPRB, &
  & 0.88291430E-10_JPRB, 0.88292658E-10_JPRB, 0.88293192E-10_JPRB, 0.88295100E-10_JPRB, 0.88295801E-10_JPRB, 0.88294552E-10_JPRB, &
  & 0.88293116E-10_JPRB, 0.88293310E-10_JPRB, 0.88291915E-10_JPRB, 0.88289598E-10_JPRB, 0.88289105E-10_JPRB, 0.88288071E-10_JPRB, &
  & 0.88287919E-10_JPRB, 0.88287148E-10_JPRB, 0.88286767E-10_JPRB, 0.88285927E-10_JPRB, 0.88285240E-10_JPRB, 0.88287044E-10_JPRB, &
  & 0.88285976E-10_JPRB, 0.88286968E-10_JPRB, 0.88286094E-10_JPRB, 0.88286933E-10_JPRB, 0.88287544E-10_JPRB, 0.88285559E-10_JPRB, &
  & 0.88283554E-10_JPRB, 0.88283172E-10_JPRB, 0.88283603E-10_JPRB, 0.88281792E-10_JPRB, 0.88282090E-10_JPRB, 0.88279363E-10_JPRB, &
  & 0.88277913E-10_JPRB, 0.88276650E-10_JPRB, 0.88273971E-10_JPRB, 0.88274638E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART20',1,ZHOOK_HANDLE)
END SUBROUTINE PART20






SUBROUTINE PART21
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART21',0,ZHOOK_HANDLE)



!-- Month= 11 ------------

RGHG9(:, 1,11) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, &
  & 0.56051939E-44_JPRB, 0.70064923E-44_JPRB, 0.84077908E-44_JPRB, 0.98090893E-44_JPRB, 0.11210388E-43_JPRB, 0.98090893E-44_JPRB, &
  & 0.84077908E-44_JPRB, 0.84077908E-44_JPRB, 0.84077908E-44_JPRB, 0.84077908E-44_JPRB, 0.84077908E-44_JPRB, 0.70064923E-44_JPRB, &
  & 0.70064923E-44_JPRB, 0.56051939E-44_JPRB, 0.42038954E-44_JPRB, 0.28025969E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 2,11) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, &
  & 0.42038954E-44_JPRB, 0.98090893E-44_JPRB, 0.18216880E-43_JPRB, 0.32229865E-43_JPRB, 0.64459729E-43_JPRB, 0.14012985E-42_JPRB, &
  & 0.23401684E-42_JPRB, 0.28306229E-42_JPRB, 0.31529215E-42_JPRB, 0.37835059E-42_JPRB, 0.43159993E-42_JPRB, 0.40217266E-42_JPRB, &
  & 0.36573890E-42_JPRB, 0.35032462E-42_JPRB, 0.32510124E-42_JPRB, 0.31248956E-42_JPRB, 0.30688436E-42_JPRB, 0.29287138E-42_JPRB, &
  & 0.26764801E-42_JPRB, 0.22701035E-42_JPRB, 0.17656361E-42_JPRB, 0.13032076E-42_JPRB, 0.91084400E-43_JPRB, 0.60255834E-43_JPRB, &
  & 0.39236357E-43_JPRB, 0.23822074E-43_JPRB, 0.14012985E-43_JPRB, 0.84077908E-44_JPRB, 0.42038954E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 3,11) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.42038954E-44_JPRB, 0.12611686E-43_JPRB, 0.35032462E-43_JPRB, 0.74268819E-43_JPRB, &
  & 0.20879347E-42_JPRB, 0.44421161E-42_JPRB, 0.82536480E-42_JPRB, 0.14839751E-41_JPRB, 0.29777592E-41_JPRB, 0.67318378E-41_JPRB, &
  & 0.11417780E-40_JPRB, 0.13687883E-40_JPRB, 0.15125616E-40_JPRB, 0.18094967E-40_JPRB, 0.20449148E-40_JPRB, 0.19201993E-40_JPRB, &
  & 0.17464383E-40_JPRB, 0.16713287E-40_JPRB, 0.15515177E-40_JPRB, 0.14876184E-40_JPRB, 0.14496433E-40_JPRB, 0.13749541E-40_JPRB, &
  & 0.12522003E-40_JPRB, 0.10621842E-40_JPRB, 0.83068973E-41_JPRB, 0.61699171E-41_JPRB, 0.43103941E-41_JPRB, 0.28810696E-41_JPRB, &
  & 0.18749373E-41_JPRB, 0.11546699E-41_JPRB, 0.70345183E-42_JPRB, 0.41478435E-42_JPRB, 0.23962204E-42_JPRB, 0.13452465E-42_JPRB, &
  & 0.72867520E-43_JPRB, 0.37835059E-43_JPRB, 0.21019477E-43_JPRB, 0.98090893E-44_JPRB, 0.56051939E-44_JPRB, 0.28025969E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 4,11) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.56051939E-44_JPRB, 0.15414283E-43_JPRB, &
  & 0.44841551E-43_JPRB, 0.11911037E-42_JPRB, 0.35733111E-42_JPRB, 0.11672816E-41_JPRB, 0.30996722E-41_JPRB, 0.65146366E-41_JPRB, &
  & 0.18334589E-40_JPRB, 0.38916861E-40_JPRB, 0.71079463E-40_JPRB, 0.12460766E-39_JPRB, 0.25101459E-39_JPRB, 0.60287083E-39_JPRB, &
  & 0.10410078E-38_JPRB, 0.12310757E-38_JPRB, 0.13511096E-38_JPRB, 0.16083375E-38_JPRB, 0.18129201E-38_JPRB, 0.16998031E-38_JPRB, &
  & 0.15423574E-38_JPRB, 0.14738115E-38_JPRB, 0.13653201E-38_JPRB, 0.13076889E-38_JPRB, 0.12735014E-38_JPRB, 0.12078702E-38_JPRB, &
  & 0.11008068E-38_JPRB, 0.93546902E-39_JPRB, 0.73381937E-39_JPRB, 0.54850605E-39_JPRB, 0.38522816E-39_JPRB, 0.25930608E-39_JPRB, &
  & 0.16977992E-39_JPRB, 0.10535102E-39_JPRB, 0.64898336E-40_JPRB, 0.38684245E-40_JPRB, 0.22614155E-40_JPRB, 0.12823282E-40_JPRB, &
  & 0.70919715E-41_JPRB, 0.37891110E-41_JPRB, 0.19828373E-41_JPRB, 0.10243492E-41_JPRB, 0.52688822E-42_JPRB, 0.27745710E-42_JPRB, &
  & 0.15274153E-42_JPRB, 0.88281803E-43_JPRB, 0.56051939E-43_JPRB, 0.39236357E-43_JPRB, 0.29427268E-43_JPRB, 0.23822074E-43_JPRB, &
  & 0.19618179E-43_JPRB, 0.15414283E-43_JPRB, 0.11210388E-43_JPRB, 0.56051939E-44_JPRB /)

RGHG9(:, 5,11) = (/ &
  & 0.29427268E-43_JPRB, 0.32229865E-43_JPRB, 0.33631163E-43_JPRB, 0.35032462E-43_JPRB, 0.39236357E-43_JPRB, 0.49045446E-43_JPRB, &
  & 0.72867520E-43_JPRB, 0.12891946E-42_JPRB, 0.26344411E-42_JPRB, 0.59134795E-42_JPRB, 0.14419361E-41_JPRB, 0.37204474E-41_JPRB, &
  & 0.97488334E-41_JPRB, 0.25982876E-40_JPRB, 0.76435226E-40_JPRB, 0.24267407E-39_JPRB, 0.63004341E-39_JPRB, 0.12858889E-38_JPRB, &
  & 0.35705477E-38_JPRB, 0.74462016E-38_JPRB, 0.13302791E-37_JPRB, 0.22605915E-37_JPRB, 0.44788582E-37_JPRB, 0.10918395E-36_JPRB, &
  & 0.18785377E-36_JPRB, 0.21841275E-36_JPRB, 0.23632233E-36_JPRB, 0.27862511E-36_JPRB, 0.31179581E-36_JPRB, 0.29021710E-36_JPRB, &
  & 0.26169419E-36_JPRB, 0.24966560E-36_JPRB, 0.23101930E-36_JPRB, 0.22165708E-36_JPRB, 0.21697786E-36_JPRB, 0.20705817E-36_JPRB, &
  & 0.19038240E-36_JPRB, 0.16323659E-36_JPRB, 0.12926528E-36_JPRB, 0.97775813E-37_JPRB, 0.69582479E-37_JPRB, 0.47514427E-37_JPRB, &
  & 0.31621841E-37_JPRB, 0.19983950E-37_JPRB, 0.12566252E-37_JPRB, 0.76632613E-38_JPRB, 0.45871729E-38_JPRB, 0.26622611E-38_JPRB, &
  & 0.15027819E-38_JPRB, 0.81570284E-39_JPRB, 0.43072692E-39_JPRB, 0.22249677E-39_JPRB, 0.11404608E-39_JPRB, 0.59455693E-40_JPRB, &
  & 0.32556367E-40_JPRB, 0.19133329E-40_JPRB, 0.12285184E-40_JPRB, 0.86390050E-41_JPRB, 0.66183326E-41_JPRB, 0.54356367E-41_JPRB, &
  & 0.46873434E-41_JPRB, 0.40903902E-41_JPRB, 0.33126696E-41_JPRB, 0.20402906E-41_JPRB /)

RGHG9(:, 6,11) = (/ &
  & 0.11365932E-40_JPRB, 0.15202687E-40_JPRB, 0.16461053E-40_JPRB, 0.17769866E-40_JPRB, 0.20313223E-40_JPRB, 0.25963258E-40_JPRB, &
  & 0.38556727E-40_JPRB, 0.67295957E-40_JPRB, 0.13549435E-39_JPRB, 0.29894180E-39_JPRB, 0.70788414E-39_JPRB, 0.17786009E-38_JPRB, &
  & 0.44879134E-38_JPRB, 0.11438228E-37_JPRB, 0.32100138E-37_JPRB, 0.97215272E-37_JPRB, 0.24086854E-36_JPRB, 0.46932566E-36_JPRB, &
  & 0.12432351E-35_JPRB, 0.24813730E-35_JPRB, 0.42384872E-35_JPRB, 0.68838819E-35_JPRB, 0.13040828E-34_JPRB, 0.31023311E-34_JPRB, &
  & 0.52000070E-34_JPRB, 0.58835352E-34_JPRB, 0.62098571E-34_JPRB, 0.71743543E-34_JPRB, 0.79092896E-34_JPRB, 0.72636471E-34_JPRB, &
  & 0.64879746E-34_JPRB, 0.61746440E-34_JPRB, 0.57185367E-34_JPRB, 0.55227468E-34_JPRB, 0.54644301E-34_JPRB, 0.52917874E-34_JPRB, &
  & 0.49592809E-34_JPRB, 0.43462891E-34_JPRB, 0.35222850E-34_JPRB, 0.27365006E-34_JPRB, 0.20031290E-34_JPRB, 0.14074084E-34_JPRB, &
  & 0.96830874E-35_JPRB, 0.63156232E-35_JPRB, 0.41196428E-35_JPRB, 0.26075005E-35_JPRB, 0.16223273E-35_JPRB, 0.97825242E-36_JPRB, &
  & 0.57308399E-36_JPRB, 0.32194260E-36_JPRB, 0.17559218E-36_JPRB, 0.93667756E-37_JPRB, 0.49667174E-37_JPRB, 0.26935560E-37_JPRB, &
  & 0.15395232E-37_JPRB, 0.94383729E-38_JPRB, 0.62587637E-38_JPRB, 0.45068926E-38_JPRB, 0.35009901E-38_JPRB, 0.28994028E-38_JPRB, &
  & 0.25243299E-38_JPRB, 0.22631601E-38_JPRB, 0.20131334E-38_JPRB, 0.16006346E-38_JPRB /)

RGHG9(:, 7,11) = (/ &
  & 0.10649525E-37_JPRB, 0.10935540E-37_JPRB, 0.11655928E-37_JPRB, 0.12738689E-37_JPRB, 0.14919614E-37_JPRB, 0.19384516E-37_JPRB, &
  & 0.29024916E-37_JPRB, 0.50038328E-37_JPRB, 0.98137965E-37_JPRB, 0.20702093E-36_JPRB, 0.46526768E-36_JPRB, 0.10965415E-35_JPRB, &
  & 0.25875105E-35_JPRB, 0.61615936E-35_JPRB, 0.16155339E-34_JPRB, 0.45847270E-34_JPRB, 0.10663258E-33_JPRB, 0.19435447E-33_JPRB, &
  & 0.48266496E-33_JPRB, 0.90667780E-33_JPRB, 0.14601650E-32_JPRB, 0.22336815E-32_JPRB, 0.40017817E-32_JPRB, 0.91414170E-32_JPRB, &
  & 0.14842842E-31_JPRB, 0.16231076E-31_JPRB, 0.16589558E-31_JPRB, 0.18708260E-31_JPRB, 0.20231163E-31_JPRB, 0.18274816E-31_JPRB, &
  & 0.16160921E-31_JPRB, 0.15337821E-31_JPRB, 0.14244238E-31_JPRB, 0.13873409E-31_JPRB, 0.13914413E-31_JPRB, 0.13719950E-31_JPRB, &
  & 0.13163682E-31_JPRB, 0.11869554E-31_JPRB, 0.99201445E-32_JPRB, 0.79963870E-32_JPRB, 0.60592829E-32_JPRB, 0.44323983E-32_JPRB, &
  & 0.31708868E-32_JPRB, 0.21523695E-32_JPRB, 0.14662775E-32_JPRB, 0.96971369E-33_JPRB, 0.63172573E-33_JPRB, 0.39906692E-33_JPRB, &
  & 0.24537822E-33_JPRB, 0.14463431E-33_JPRB, 0.83097578E-34_JPRB, 0.46906527E-34_JPRB, 0.26539164E-34_JPRB, 0.15450467E-34_JPRB, &
  & 0.94976163E-35_JPRB, 0.62006280E-35_JPRB, 0.43210646E-35_JPRB, 0.32197776E-35_JPRB, 0.25570410E-35_JPRB, 0.21474305E-35_JPRB, &
  & 0.18864988E-35_JPRB, 0.17020504E-35_JPRB, 0.15436286E-35_JPRB, 0.12951318E-35_JPRB /)

RGHG9(:, 8,11) = (/ &
  & 0.91567875E-35_JPRB, 0.84425936E-35_JPRB, 0.86601519E-35_JPRB, 0.94324145E-35_JPRB, 0.11017304E-34_JPRB, 0.14296125E-34_JPRB, &
  & 0.21128600E-34_JPRB, 0.35684415E-34_JPRB, 0.67247076E-34_JPRB, 0.13499152E-33_JPRB, 0.28476153E-33_JPRB, 0.62652223E-33_JPRB, &
  & 0.13754671E-32_JPRB, 0.30422753E-32_JPRB, 0.74141507E-32_JPRB, 0.19683812E-31_JPRB, 0.42826592E-31_JPRB, 0.72494664E-31_JPRB, &
  & 0.16871052E-30_JPRB, 0.29767610E-30_JPRB, 0.45044224E-30_JPRB, 0.64701226E-30_JPRB, 0.10905060E-29_JPRB, 0.23973754E-29_JPRB, &
  & 0.37639389E-29_JPRB, 0.39663549E-29_JPRB, 0.39166678E-29_JPRB, 0.43058351E-29_JPRB, 0.45626856E-29_JPRB, 0.40524797E-29_JPRB, &
  & 0.35482754E-29_JPRB, 0.33573025E-29_JPRB, 0.31272852E-29_JPRB, 0.30727477E-29_JPRB, 0.31240342E-29_JPRB, 0.31377589E-29_JPRB, &
  & 0.30834148E-29_JPRB, 0.28633489E-29_JPRB, 0.24786495E-29_JPRB, 0.20763289E-29_JPRB, 0.16426892E-29_JPRB, 0.12505264E-29_JPRB, &
  & 0.93751665E-30_JPRB, 0.66064960E-30_JPRB, 0.47101965E-30_JPRB, 0.32494315E-30_JPRB, 0.22153801E-30_JPRB, 0.14657572E-30_JPRB, &
  & 0.94766768E-31_JPRB, 0.58840087E-31_JPRB, 0.35838096E-31_JPRB, 0.21600163E-31_JPRB, 0.13107319E-31_JPRB, 0.82101367E-32_JPRB, &
  & 0.53989148E-32_JPRB, 0.37313666E-32_JPRB, 0.27163705E-32_JPRB, 0.20899570E-32_JPRB, 0.16972237E-32_JPRB, 0.14460016E-32_JPRB, &
  & 0.12825778E-32_JPRB, 0.11640812E-32_JPRB, 0.10628410E-32_JPRB, 0.89950242E-33_JPRB /)

RGHG9(:, 9,11) = (/ &
  & 0.69384876E-32_JPRB, 0.60974222E-32_JPRB, 0.61176664E-32_JPRB, 0.65339398E-32_JPRB, 0.75000051E-32_JPRB, 0.94994755E-32_JPRB, &
  & 0.13669809E-31_JPRB, 0.22249141E-31_JPRB, 0.40230219E-31_JPRB, 0.76561522E-31_JPRB, 0.15217919E-30_JPRB, 0.31305441E-30_JPRB, &
  & 0.64070432E-30_JPRB, 0.13158753E-29_JPRB, 0.29788125E-29_JPRB, 0.74042843E-29_JPRB, 0.15081638E-28_JPRB, 0.23632349E-28_JPRB, &
  & 0.51704213E-28_JPRB, 0.85755016E-28_JPRB, 0.12191052E-27_JPRB, 0.16416722E-27_JPRB, 0.26022592E-27_JPRB, 0.55028826E-27_JPRB, &
  & 0.83298589E-27_JPRB, 0.84441830E-27_JPRB, 0.80502124E-27_JPRB, 0.86183584E-27_JPRB, 0.89430210E-27_JPRB, 0.78126908E-27_JPRB, &
  & 0.67729978E-27_JPRB, 0.63842252E-27_JPRB, 0.59614923E-27_JPRB, 0.59071199E-27_JPRB, 0.60883951E-27_JPRB, 0.62317932E-27_JPRB, &
  & 0.62732681E-27_JPRB, 0.60058199E-27_JPRB, 0.53899133E-27_JPRB, 0.47139875E-27_JPRB, 0.38949025E-27_JPRB, 0.31139673E-27_JPRB, &
  & 0.24444490E-27_JPRB, 0.17956620E-27_JPRB, 0.13396532E-27_JPRB, 0.96369394E-28_JPRB, 0.68716982E-28_JPRB, 0.47589314E-28_JPRB, &
  & 0.32380507E-28_JPRB, 0.21195192E-28_JPRB, 0.13713781E-28_JPRB, 0.88154297E-29_JPRB, 0.57155063E-29_JPRB, 0.38091814E-29_JPRB, &
  & 0.26472934E-29_JPRB, 0.19124561E-29_JPRB, 0.14414317E-29_JPRB, 0.11378997E-29_JPRB, 0.94097223E-30_JPRB, 0.81214190E-30_JPRB, &
  & 0.72480775E-30_JPRB, 0.66446328E-30_JPRB, 0.60457616E-30_JPRB, 0.52261496E-30_JPRB /)

RGHG9(:,10,11) = (/ &
  & 0.45233696E-29_JPRB, 0.39045040E-29_JPRB, 0.38469578E-29_JPRB, 0.40312068E-29_JPRB, 0.45068728E-29_JPRB, 0.55251688E-29_JPRB, &
  & 0.76443319E-29_JPRB, 0.11943389E-28_JPRB, 0.20616234E-28_JPRB, 0.37300171E-28_JPRB, 0.69951280E-28_JPRB, 0.13515509E-27_JPRB, &
  & 0.25836885E-27_JPRB, 0.49341199E-27_JPRB, 0.10377898E-26_JPRB, 0.24152976E-26_JPRB, 0.46081244E-26_JPRB, 0.66767515E-26_JPRB, &
  & 0.13742872E-25_JPRB, 0.21423049E-25_JPRB, 0.28601505E-25_JPRB, 0.36092525E-25_JPRB, 0.53800684E-25_JPRB, 0.10910447E-24_JPRB, &
  & 0.15875112E-24_JPRB, 0.15467848E-24_JPRB, 0.14236509E-24_JPRB, 0.14823994E-24_JPRB, 0.15056755E-24_JPRB, 0.12946300E-24_JPRB, &
  & 0.11110948E-24_JPRB, 0.10429920E-24_JPRB, 0.97599843E-25_JPRB, 0.97532328E-25_JPRB, 0.10196416E-24_JPRB, 0.10645621E-24_JPRB, &
  & 0.10985101E-24_JPRB, 0.10842465E-24_JPRB, 0.10104797E-24_JPRB, 0.92168992E-25_JPRB, 0.79930616E-25_JPRB, 0.67060973E-25_JPRB, &
  & 0.55513726E-25_JPRB, 0.42511535E-25_JPRB, 0.33344035E-25_JPRB, 0.25027202E-25_JPRB, 0.18700712E-25_JPRB, 0.13566560E-25_JPRB, &
  & 0.97233732E-26_JPRB, 0.67062914E-26_JPRB, 0.46012793E-26_JPRB, 0.31388787E-26_JPRB, 0.21547385E-26_JPRB, 0.15126709E-26_JPRB, &
  & 0.10983795E-26_JPRB, 0.82222677E-27_JPRB, 0.63707957E-27_JPRB, 0.51346183E-27_JPRB, 0.43086698E-27_JPRB, 0.37517103E-27_JPRB, &
  & 0.33846363E-27_JPRB, 0.30895836E-27_JPRB, 0.28649871E-27_JPRB, 0.24354027E-27_JPRB /)

RGHG9(:,11,11) = (/ &
  & 0.24731134E-26_JPRB, 0.21140030E-26_JPRB, 0.20558081E-26_JPRB, 0.21140669E-26_JPRB, 0.23025635E-26_JPRB, 0.27270596E-26_JPRB, &
  & 0.36243779E-26_JPRB, 0.54179660E-26_JPRB, 0.89391915E-26_JPRB, 0.15388285E-25_JPRB, 0.27339882E-25_JPRB, 0.49784944E-25_JPRB, &
  & 0.89232957E-25_JPRB, 0.15890107E-24_JPRB, 0.31109124E-24_JPRB, 0.67787222E-24_JPRB, 0.12115739E-23_JPRB, 0.16265050E-23_JPRB, &
  & 0.31428163E-23_JPRB, 0.46020236E-23_JPRB, 0.57693074E-23_JPRB, 0.68281394E-23_JPRB, 0.95684544E-23_JPRB, 0.18564696E-22_JPRB, &
  & 0.25905877E-22_JPRB, 0.24265854E-22_JPRB, 0.21563757E-22_JPRB, 0.21816759E-22_JPRB, 0.21677637E-22_JPRB, 0.18344793E-22_JPRB, &
  & 0.15584633E-22_JPRB, 0.14570248E-22_JPRB, 0.13667903E-22_JPRB, 0.13782501E-22_JPRB, 0.14628977E-22_JPRB, 0.15591964E-22_JPRB, &
  & 0.16502380E-22_JPRB, 0.16790387E-22_JPRB, 0.16230864E-22_JPRB, 0.15430116E-22_JPRB, 0.14011732E-22_JPRB, 0.12364192E-22_JPRB, &
  & 0.10781423E-22_JPRB, 0.86566046E-23_JPRB, 0.71552934E-23_JPRB, 0.56233855E-23_JPRB, 0.44150541E-23_JPRB, 0.33618649E-23_JPRB, &
  & 0.25390699E-23_JPRB, 0.18441241E-23_JPRB, 0.13361106E-23_JPRB, 0.96228162E-24_JPRB, 0.69429709E-24_JPRB, 0.50966070E-24_JPRB, &
  & 0.38430488E-24_JPRB, 0.29662903E-24_JPRB, 0.23539883E-24_JPRB, 0.19312018E-24_JPRB, 0.16410104E-24_JPRB, 0.14431912E-24_JPRB, &
  & 0.13013339E-24_JPRB, 0.12058636E-24_JPRB, 0.10991062E-24_JPRB, 0.96850087E-25_JPRB /)

RGHG9(:,12,11) = (/ &
  & 0.11219478E-23_JPRB, 0.95103000E-24_JPRB, 0.91414405E-24_JPRB, 0.92451875E-24_JPRB, 0.98350543E-24_JPRB, 0.11284744E-23_JPRB, &
  & 0.14425845E-23_JPRB, 0.20658654E-23_JPRB, 0.32607177E-23_JPRB, 0.53525707E-23_JPRB, 0.90321734E-23_JPRB, 0.15559002E-22_JPRB, &
  & 0.26230755E-22_JPRB, 0.43677935E-22_JPRB, 0.79759801E-22_JPRB, 0.16265592E-21_JPRB, 0.27227038E-21_JPRB, 0.33972874E-21_JPRB, &
  & 0.61421104E-21_JPRB, 0.84434431E-21_JPRB, 0.99423212E-21_JPRB, 0.11045161E-20_JPRB, 0.14564806E-20_JPRB, 0.26944362E-20_JPRB, &
  & 0.36041790E-20_JPRB, 0.32464395E-20_JPRB, 0.27846621E-20_JPRB, 0.27345052E-20_JPRB, 0.26553978E-20_JPRB, 0.22100963E-20_JPRB, &
  & 0.18577564E-20_JPRB, 0.17299818E-20_JPRB, 0.16277534E-20_JPRB, 0.16576551E-20_JPRB, 0.17880539E-20_JPRB, 0.19474190E-20_JPRB, &
  & 0.21150713E-20_JPRB, 0.22179441E-20_JPRB, 0.22215119E-20_JPRB, 0.21963780E-20_JPRB, 0.20854621E-20_JPRB, 0.19312195E-20_JPRB, &
  & 0.17733411E-20_JPRB, 0.14976006E-20_JPRB, 0.13076352E-20_JPRB, 0.10800739E-20_JPRB, 0.89375815E-21_JPRB, 0.71557318E-21_JPRB, &
  & 0.56971085E-21_JPRB, 0.43485875E-21_JPRB, 0.33191485E-21_JPRB, 0.25092830E-21_JPRB, 0.18951213E-21_JPRB, 0.14478748E-21_JPRB, &
  & 0.11299716E-21_JPRB, 0.89688373E-22_JPRB, 0.72763280E-22_JPRB, 0.60682892E-22_JPRB, 0.52159180E-22_JPRB, 0.46133261E-22_JPRB, &
  & 0.42042500E-22_JPRB, 0.38595768E-22_JPRB, 0.35973187E-22_JPRB, 0.30715284E-22_JPRB /)

RGHG9(:,13,11) = (/ &
  & 0.42744821E-21_JPRB, 0.35944693E-21_JPRB, 0.34186425E-21_JPRB, 0.34061555E-21_JPRB, 0.35473462E-21_JPRB, 0.39532049E-21_JPRB, &
  & 0.48711113E-21_JPRB, 0.66895475E-21_JPRB, 0.10106653E-20_JPRB, 0.15827386E-20_JPRB, 0.25384618E-20_JPRB, 0.41426998E-20_JPRB, &
  & 0.65774632E-20_JPRB, 0.10250753E-19_JPRB, 0.17471250E-19_JPRB, 0.33316838E-19_JPRB, 0.52183303E-19_JPRB, 0.60648553E-19_JPRB, &
  & 0.10228409E-18_JPRB, 0.13193270E-18_JPRB, 0.14588871E-18_JPRB, 0.15224263E-18_JPRB, 0.18879046E-18_JPRB, 0.33261098E-18_JPRB, &
  & 0.42614417E-18_JPRB, 0.36914176E-18_JPRB, 0.30543401E-18_JPRB, 0.29081240E-18_JPRB, 0.27574032E-18_JPRB, 0.22561439E-18_JPRB, &
  & 0.18761309E-18_JPRB, 0.17407608E-18_JPRB, 0.16436216E-18_JPRB, 0.16910385E-18_JPRB, 0.18543692E-18_JPRB, 0.20641477E-18_JPRB, &
  & 0.23016544E-18_JPRB, 0.24875273E-18_JPRB, 0.25798093E-18_JPRB, 0.26511459E-18_JPRB, 0.26287360E-18_JPRB, 0.25532832E-18_JPRB, &
  & 0.24659386E-18_JPRB, 0.21978615E-18_JPRB, 0.20288052E-18_JPRB, 0.17688547E-18_JPRB, 0.15460439E-18_JPRB, 0.13046970E-18_JPRB, &
  & 0.10945740E-18_JPRB, 0.87815801E-19_JPRB, 0.70370103E-19_JPRB, 0.55737355E-19_JPRB, 0.43899212E-19_JPRB, 0.34836227E-19_JPRB, &
  & 0.28078387E-19_JPRB, 0.22890579E-19_JPRB, 0.18960363E-19_JPRB, 0.16057059E-19_JPRB, 0.13946579E-19_JPRB, 0.12433786E-19_JPRB, &
  & 0.11318854E-19_JPRB, 0.10512958E-19_JPRB, 0.96341669E-20_JPRB, 0.84341799E-20_JPRB /)

RGHG9(:,14,11) = (/ &
  & 0.13825258E-18_JPRB, 0.11530840E-18_JPRB, 0.10855779E-18_JPRB, 0.10664062E-18_JPRB, 0.10886546E-18_JPRB, 0.11803911E-18_JPRB, &
  & 0.14044071E-18_JPRB, 0.18510045E-18_JPRB, 0.26767141E-18_JPRB, 0.39949799E-18_JPRB, 0.60845829E-18_JPRB, 0.94008818E-18_JPRB, &
  & 0.14051257E-17_JPRB, 0.20488691E-17_JPRB, 0.32585020E-17_JPRB, 0.58067558E-17_JPRB, 0.85070985E-17_JPRB, 0.92210356E-17_JPRB, &
  & 0.14484201E-16_JPRB, 0.17525722E-16_JPRB, 0.18202154E-16_JPRB, 0.17847308E-16_JPRB, 0.20828282E-16_JPRB, 0.34880076E-16_JPRB, &
  & 0.42812496E-16_JPRB, 0.35665053E-16_JPRB, 0.28456247E-16_JPRB, 0.26253781E-16_JPRB, 0.24300363E-16_JPRB, 0.19549423E-16_JPRB, &
  & 0.16091877E-16_JPRB, 0.14882951E-16_JPRB, 0.14105188E-16_JPRB, 0.14656423E-16_JPRB, 0.16327472E-16_JPRB, 0.18561379E-16_JPRB, &
  & 0.21243216E-16_JPRB, 0.23662390E-16_JPRB, 0.25397988E-16_JPRB, 0.27131701E-16_JPRB, 0.28086196E-16_JPRB, 0.28605603E-16_JPRB, &
  & 0.29043221E-16_JPRB, 0.27366005E-16_JPRB, 0.26707945E-16_JPRB, 0.24654993E-16_JPRB, 0.22801346E-16_JPRB, 0.20325527E-16_JPRB, &
  & 0.17985970E-16_JPRB, 0.15174117E-16_JPRB, 0.12769005E-16_JPRB, 0.10582210E-16_JPRB, 0.86914770E-17_JPRB, 0.71575541E-17_JPRB, &
  & 0.59570801E-17_JPRB, 0.49847173E-17_JPRB, 0.42141477E-17_JPRB, 0.36224075E-17_JPRB, 0.31785282E-17_JPRB, 0.28502956E-17_JPRB, &
  & 0.26098655E-17_JPRB, 0.24140724E-17_JPRB, 0.22352753E-17_JPRB, 0.19133339E-17_JPRB /)

RGHG9(:,15,11) = (/ &
  & 0.38137606E-16_JPRB, 0.31548086E-16_JPRB, 0.29404520E-16_JPRB, 0.28486462E-16_JPRB, 0.28523765E-16_JPRB, 0.30124998E-16_JPRB, &
  & 0.34653005E-16_JPRB, 0.43866682E-16_JPRB, 0.60679998E-16_JPRB, 0.86208538E-16_JPRB, 0.12444236E-15_JPRB, 0.18173155E-15_JPRB, &
  & 0.25540089E-15_JPRB, 0.34811720E-15_JPRB, 0.51637029E-15_JPRB, 0.85997783E-15_JPRB, 0.11788040E-14_JPRB, 0.11923599E-14_JPRB, &
  & 0.17437211E-14_JPRB, 0.19795302E-14_JPRB, 0.19311174E-14_JPRB, 0.17792672E-14_JPRB, 0.19528722E-14_JPRB, 0.31089809E-14_JPRB, &
  & 0.36543331E-14_JPRB, 0.29274200E-14_JPRB, 0.22520023E-14_JPRB, 0.20134666E-14_JPRB, 0.18198075E-14_JPRB, 0.14406704E-14_JPRB, &
  & 0.11742526E-14_JPRB, 0.10826555E-14_JPRB, 0.10293986E-14_JPRB, 0.10792949E-14_JPRB, 0.12201271E-14_JPRB, 0.14157347E-14_JPRB, &
  & 0.16629570E-14_JPRB, 0.19096739E-14_JPRB, 0.21218675E-14_JPRB, 0.23572328E-14_JPRB, 0.25479297E-14_JPRB, 0.27213892E-14_JPRB, &
  & 0.29048237E-14_JPRB, 0.28934984E-14_JPRB, 0.29856607E-14_JPRB, 0.29209429E-14_JPRB, 0.28605393E-14_JPRB, 0.26980075E-14_JPRB, &
  & 0.25208514E-14_JPRB, 0.22402251E-14_JPRB, 0.19805305E-14_JPRB, 0.17185872E-14_JPRB, 0.14718868E-14_JPRB, 0.12580842E-14_JPRB, &
  & 0.10809225E-14_JPRB, 0.92842868E-15_JPRB, 0.80100189E-15_JPRB, 0.69893956E-15_JPRB, 0.61967956E-15_JPRB, 0.55910040E-15_JPRB, &
  & 0.51387265E-15_JPRB, 0.47616921E-15_JPRB, 0.43984129E-15_JPRB, 0.37606243E-15_JPRB /)

RGHG9(:,16,11) = (/ &
  & 0.39850968E-15_JPRB, 0.39600498E-15_JPRB, 0.40689538E-15_JPRB, 0.42646717E-15_JPRB, 0.45687369E-15_JPRB, 0.50330931E-15_JPRB, &
  & 0.57503314E-15_JPRB, 0.68852635E-15_JPRB, 0.87534688E-15_JPRB, 0.11348898E-14_JPRB, 0.14879384E-14_JPRB, 0.19603476E-14_JPRB, &
  & 0.25630842E-14_JPRB, 0.32161968E-14_JPRB, 0.39312718E-14_JPRB, 0.48590570E-14_JPRB, 0.64305522E-14_JPRB, 0.88413587E-14_JPRB, &
  & 0.11909413E-13_JPRB, 0.16223539E-13_JPRB, 0.20962305E-13_JPRB, 0.23633014E-13_JPRB, 0.24526439E-13_JPRB, 0.23957146E-13_JPRB, &
  & 0.23041936E-13_JPRB, 0.22647838E-13_JPRB, 0.21585696E-13_JPRB, 0.17585837E-13_JPRB, 0.14232562E-13_JPRB, 0.11857309E-13_JPRB, &
  & 0.10305127E-13_JPRB, 0.95441157E-14_JPRB, 0.95250278E-14_JPRB, 0.10219371E-13_JPRB, 0.11611524E-13_JPRB, 0.13530386E-13_JPRB, &
  & 0.15776837E-13_JPRB, 0.18041077E-13_JPRB, 0.20236512E-13_JPRB, 0.22154536E-13_JPRB, 0.23667620E-13_JPRB, 0.24716525E-13_JPRB, &
  & 0.25171163E-13_JPRB, 0.25484784E-13_JPRB, 0.25359629E-13_JPRB, 0.24948110E-13_JPRB, 0.24152755E-13_JPRB, 0.22815639E-13_JPRB, &
  & 0.21175481E-13_JPRB, 0.19236428E-13_JPRB, 0.17130982E-13_JPRB, 0.15039097E-13_JPRB, 0.13027412E-13_JPRB, 0.11214212E-13_JPRB, &
  & 0.96399803E-14_JPRB, 0.82220641E-14_JPRB, 0.70247945E-14_JPRB, 0.60530652E-14_JPRB, 0.52901138E-14_JPRB, 0.47088145E-14_JPRB, &
  & 0.42629915E-14_JPRB, 0.39318079E-14_JPRB, 0.35876152E-14_JPRB, 0.30937224E-14_JPRB /)

RGHG9(:,17,11) = (/ &
  & 0.34915374E-14_JPRB, 0.37586045E-14_JPRB, 0.40128504E-14_JPRB, 0.43394264E-14_JPRB, 0.47947892E-14_JPRB, 0.54483971E-14_JPRB, &
  & 0.63992166E-14_JPRB, 0.77812428E-14_JPRB, 0.98079351E-14_JPRB, 0.12392420E-13_JPRB, 0.15691297E-13_JPRB, 0.19968522E-13_JPRB, &
  & 0.25476998E-13_JPRB, 0.32258254E-13_JPRB, 0.40421781E-13_JPRB, 0.51038238E-13_JPRB, 0.64249624E-13_JPRB, 0.80263155E-13_JPRB, &
  & 0.98988397E-13_JPRB, 0.11914155E-12_JPRB, 0.13757431E-12_JPRB, 0.14986581E-12_JPRB, 0.15716642E-12_JPRB, 0.15595567E-12_JPRB, &
  & 0.14735004E-12_JPRB, 0.12971664E-12_JPRB, 0.11051465E-12_JPRB, 0.95301845E-13_JPRB, 0.81639766E-13_JPRB, 0.71725381E-13_JPRB, &
  & 0.65301883E-13_JPRB, 0.62830268E-13_JPRB, 0.64209231E-13_JPRB, 0.69257873E-13_JPRB, 0.77703801E-13_JPRB, 0.90290473E-13_JPRB, &
  & 0.10357845E-12_JPRB, 0.11779453E-12_JPRB, 0.13000125E-12_JPRB, 0.13971460E-12_JPRB, 0.14652532E-12_JPRB, 0.14994568E-12_JPRB, &
  & 0.15062706E-12_JPRB, 0.14857023E-12_JPRB, 0.14445412E-12_JPRB, 0.13919643E-12_JPRB, 0.13276282E-12_JPRB, 0.12535764E-12_JPRB, &
  & 0.11659979E-12_JPRB, 0.10664787E-12_JPRB, 0.95799081E-13_JPRB, 0.84689403E-13_JPRB, 0.73849347E-13_JPRB, 0.63829198E-13_JPRB, &
  & 0.54625785E-13_JPRB, 0.46349592E-13_JPRB, 0.39314848E-13_JPRB, 0.33577653E-13_JPRB, 0.29045027E-13_JPRB, 0.25577295E-13_JPRB, &
  & 0.23020141E-13_JPRB, 0.20981631E-13_JPRB, 0.19239967E-13_JPRB, 0.16290058E-13_JPRB /)

RGHG9(:,18,11) = (/ &
  & 0.21767054E-13_JPRB, 0.24177646E-13_JPRB, 0.26161146E-13_JPRB, 0.28562334E-13_JPRB, 0.31788767E-13_JPRB, 0.36279319E-13_JPRB, &
  & 0.42574078E-13_JPRB, 0.51407534E-13_JPRB, 0.63776248E-13_JPRB, 0.79313699E-13_JPRB, 0.98272383E-13_JPRB, 0.12116425E-12_JPRB, &
  & 0.14894368E-12_JPRB, 0.18333000E-12_JPRB, 0.22381443E-12_JPRB, 0.27193276E-12_JPRB, 0.33098269E-12_JPRB, 0.39903302E-12_JPRB, &
  & 0.47295354E-12_JPRB, 0.54607420E-12_JPRB, 0.60947514E-12_JPRB, 0.65033493E-12_JPRB, 0.66050030E-12_JPRB, 0.63586685E-12_JPRB, &
  & 0.59200008E-12_JPRB, 0.53438227E-12_JPRB, 0.47188252E-12_JPRB, 0.41146961E-12_JPRB, 0.36418587E-12_JPRB, 0.33309230E-12_JPRB, &
  & 0.31487822E-12_JPRB, 0.31151899E-12_JPRB, 0.32122110E-12_JPRB, 0.34432133E-12_JPRB, 0.37934142E-12_JPRB, 0.42583382E-12_JPRB, &
  & 0.47886451E-12_JPRB, 0.53141692E-12_JPRB, 0.57844457E-12_JPRB, 0.61163910E-12_JPRB, 0.63142525E-12_JPRB, 0.63576385E-12_JPRB, &
  & 0.62875237E-12_JPRB, 0.61110063E-12_JPRB, 0.58870666E-12_JPRB, 0.56191488E-12_JPRB, 0.53324511E-12_JPRB, 0.50174795E-12_JPRB, &
  & 0.46715626E-12_JPRB, 0.42956917E-12_JPRB, 0.38939793E-12_JPRB, 0.34793083E-12_JPRB, 0.30700141E-12_JPRB, 0.26747146E-12_JPRB, &
  & 0.22938769E-12_JPRB, 0.19503401E-12_JPRB, 0.16563278E-12_JPRB, 0.14137541E-12_JPRB, 0.12207508E-12_JPRB, 0.10718428E-12_JPRB, &
  & 0.96075688E-13_JPRB, 0.87547265E-13_JPRB, 0.79849457E-13_JPRB, 0.68133250E-13_JPRB /)

RGHG9(:,19,11) = (/ &
  & 0.89952751E-13_JPRB, 0.10303689E-12_JPRB, 0.11326222E-12_JPRB, 0.12478980E-12_JPRB, 0.13950332E-12_JPRB, 0.15904387E-12_JPRB, &
  & 0.18548527E-12_JPRB, 0.22108687E-12_JPRB, 0.26890900E-12_JPRB, 0.32791819E-12_JPRB, 0.39865436E-12_JPRB, 0.48137167E-12_JPRB, &
  & 0.57689362E-12_JPRB, 0.68951968E-12_JPRB, 0.82135909E-12_JPRB, 0.97254344E-12_JPRB, 0.11426542E-11_JPRB, 0.13354409E-11_JPRB, &
  & 0.15339148E-11_JPRB, 0.17181072E-11_JPRB, 0.18637123E-11_JPRB, 0.19548950E-11_JPRB, 0.19680182E-11_JPRB, 0.19064821E-11_JPRB, &
  & 0.17839546E-11_JPRB, 0.16251583E-11_JPRB, 0.14735075E-11_JPRB, 0.13386825E-11_JPRB, 0.12404688E-11_JPRB, 0.11816215E-11_JPRB, &
  & 0.11587283E-11_JPRB, 0.11672653E-11_JPRB, 0.12040686E-11_JPRB, 0.12695872E-11_JPRB, 0.13621045E-11_JPRB, 0.14797681E-11_JPRB, &
  & 0.16069719E-11_JPRB, 0.17441577E-11_JPRB, 0.18598482E-11_JPRB, 0.19384316E-11_JPRB, 0.19774375E-11_JPRB, 0.19716076E-11_JPRB, &
  & 0.19294421E-11_JPRB, 0.18637192E-11_JPRB, 0.17808691E-11_JPRB, 0.16929429E-11_JPRB, 0.16018383E-11_JPRB, 0.15080133E-11_JPRB, &
  & 0.14100884E-11_JPRB, 0.13066056E-11_JPRB, 0.11979148E-11_JPRB, 0.10858746E-11_JPRB, 0.97052672E-12_JPRB, 0.85389671E-12_JPRB, &
  & 0.74038058E-12_JPRB, 0.63657190E-12_JPRB, 0.54613134E-12_JPRB, 0.47034924E-12_JPRB, 0.40889633E-12_JPRB, 0.36083406E-12_JPRB, &
  & 0.32376052E-12_JPRB, 0.29619726E-12_JPRB, 0.26917954E-12_JPRB, 0.23228554E-12_JPRB /)

RGHG9(:,20,11) = (/ &
  & 0.26814597E-12_JPRB, 0.31250005E-12_JPRB, 0.34570263E-12_JPRB, 0.38289090E-12_JPRB, 0.42883861E-12_JPRB, 0.48832309E-12_JPRB, &
  & 0.56561960E-12_JPRB, 0.66592109E-12_JPRB, 0.79433714E-12_JPRB, 0.94894340E-12_JPRB, 0.11310992E-11_JPRB, 0.13404047E-11_JPRB, &
  & 0.15758301E-11_JPRB, 0.18432315E-11_JPRB, 0.21457731E-11_JPRB, 0.24871789E-11_JPRB, 0.28584192E-11_JPRB, 0.32528789E-11_JPRB, &
  & 0.36539044E-11_JPRB, 0.40204094E-11_JPRB, 0.43041070E-11_JPRB, 0.44817214E-11_JPRB, 0.45178930E-11_JPRB, 0.44163241E-11_JPRB, &
  & 0.42107923E-11_JPRB, 0.39543902E-11_JPRB, 0.37033358E-11_JPRB, 0.34949812E-11_JPRB, 0.33699701E-11_JPRB, 0.33114633E-11_JPRB, &
  & 0.33113486E-11_JPRB, 0.33575081E-11_JPRB, 0.34364165E-11_JPRB, 0.35436881E-11_JPRB, 0.36944033E-11_JPRB, 0.38723794E-11_JPRB, &
  & 0.40915561E-11_JPRB, 0.43191544E-11_JPRB, 0.45087809E-11_JPRB, 0.46625178E-11_JPRB, 0.47111963E-11_JPRB, 0.46863416E-11_JPRB, &
  & 0.45768502E-11_JPRB, 0.44221419E-11_JPRB, 0.42297316E-11_JPRB, 0.40218159E-11_JPRB, 0.38122235E-11_JPRB, 0.35992064E-11_JPRB, &
  & 0.33805651E-11_JPRB, 0.31550810E-11_JPRB, 0.29219717E-11_JPRB, 0.26796703E-11_JPRB, 0.24259041E-11_JPRB, 0.21619050E-11_JPRB, &
  & 0.19036038E-11_JPRB, 0.16630279E-11_JPRB, 0.14497044E-11_JPRB, 0.12665397E-11_JPRB, 0.11146278E-11_JPRB, 0.99215568E-12_JPRB, &
  & 0.89859901E-12_JPRB, 0.81961158E-12_JPRB, 0.75537276E-12_JPRB, 0.64111303E-12_JPRB /)

RGHG9(:,21,11) = (/ &
  & 0.62842098E-12_JPRB, 0.73383427E-12_JPRB, 0.81422445E-12_JPRB, 0.90140200E-12_JPRB, 0.10082287E-11_JPRB, 0.11426058E-11_JPRB, &
  & 0.13132333E-11_JPRB, 0.15266440E-11_JPRB, 0.17905417E-11_JPRB, 0.21003331E-11_JPRB, 0.24578430E-11_JPRB, 0.28628033E-11_JPRB, &
  & 0.33110303E-11_JPRB, 0.38060635E-11_JPRB, 0.43542275E-11_JPRB, 0.49569454E-11_JPRB, 0.56044084E-11_JPRB, 0.62763579E-11_JPRB, &
  & 0.69369740E-11_JPRB, 0.75454695E-11_JPRB, 0.80402776E-11_JPRB, 0.83756786E-11_JPRB, 0.85169458E-11_JPRB, 0.84664610E-11_JPRB, &
  & 0.82657275E-11_JPRB, 0.79907574E-11_JPRB, 0.77338110E-11_JPRB, 0.75481878E-11_JPRB, 0.74493033E-11_JPRB, 0.74430948E-11_JPRB, &
  & 0.75051796E-11_JPRB, 0.75933383E-11_JPRB, 0.76826618E-11_JPRB, 0.77754235E-11_JPRB, 0.79054376E-11_JPRB, 0.80784919E-11_JPRB, &
  & 0.83206471E-11_JPRB, 0.85939658E-11_JPRB, 0.88572517E-11_JPRB, 0.90467503E-11_JPRB, 0.91365734E-11_JPRB, 0.90548055E-11_JPRB, &
  & 0.88607212E-11_JPRB, 0.85788009E-11_JPRB, 0.82147631E-11_JPRB, 0.78358448E-11_JPRB, 0.74481766E-11_JPRB, 0.70498650E-11_JPRB, &
  & 0.66526142E-11_JPRB, 0.62504238E-11_JPRB, 0.58390623E-11_JPRB, 0.54081115E-11_JPRB, 0.49488855E-11_JPRB, 0.44782268E-11_JPRB, &
  & 0.40132316E-11_JPRB, 0.35730214E-11_JPRB, 0.31716025E-11_JPRB, 0.28184300E-11_JPRB, 0.25168671E-11_JPRB, 0.22674330E-11_JPRB, &
  & 0.20618986E-11_JPRB, 0.19041426E-11_JPRB, 0.17313385E-11_JPRB, 0.15119581E-11_JPRB /)

RGHG9(:,22,11) = (/ &
  & 0.12234963E-11_JPRB, 0.14302919E-11_JPRB, 0.15817810E-11_JPRB, 0.17476639E-11_JPRB, 0.19453603E-11_JPRB, 0.21900788E-11_JPRB, &
  & 0.24916861E-11_JPRB, 0.28604298E-11_JPRB, 0.33033303E-11_JPRB, 0.38140316E-11_JPRB, 0.43936864E-11_JPRB, 0.50419352E-11_JPRB, &
  & 0.57540457E-11_JPRB, 0.65264244E-11_JPRB, 0.73606139E-11_JPRB, 0.82613742E-11_JPRB, 0.92149240E-11_JPRB, 0.10203069E-10_JPRB, &
  & 0.11178919E-10_JPRB, 0.12089827E-10_JPRB, 0.12876982E-10_JPRB, 0.13495566E-10_JPRB, 0.13888866E-10_JPRB, 0.14042679E-10_JPRB, &
  & 0.14011475E-10_JPRB, 0.13887782E-10_JPRB, 0.13771428E-10_JPRB, 0.13723303E-10_JPRB, 0.13748688E-10_JPRB, 0.13839083E-10_JPRB, &
  & 0.13945552E-10_JPRB, 0.14009544E-10_JPRB, 0.14009498E-10_JPRB, 0.13987536E-10_JPRB, 0.13986562E-10_JPRB, 0.14049121E-10_JPRB, &
  & 0.14226379E-10_JPRB, 0.14479327E-10_JPRB, 0.14746718E-10_JPRB, 0.14963060E-10_JPRB, 0.15044469E-10_JPRB, 0.14940372E-10_JPRB, &
  & 0.14637402E-10_JPRB, 0.14213150E-10_JPRB, 0.13663038E-10_JPRB, 0.13047675E-10_JPRB, 0.12429641E-10_JPRB, 0.11801853E-10_JPRB, &
  & 0.11173523E-10_JPRB, 0.10547977E-10_JPRB, 0.99161955E-11_JPRB, 0.92614128E-11_JPRB, 0.85790351E-11_JPRB, 0.78810587E-11_JPRB, &
  & 0.71869255E-11_JPRB, 0.65167819E-11_JPRB, 0.58915416E-11_JPRB, 0.53243078E-11_JPRB, 0.48237872E-11_JPRB, 0.43935029E-11_JPRB, &
  & 0.40387255E-11_JPRB, 0.37164529E-11_JPRB, 0.34412456E-11_JPRB, 0.29378375E-11_JPRB /)

RGHG9(:,23,11) = (/ &
  & 0.20839723E-11_JPRB, 0.24204670E-11_JPRB, 0.26719354E-11_JPRB, 0.29379030E-11_JPRB, 0.32519994E-11_JPRB, 0.36308289E-11_JPRB, &
  & 0.40890785E-11_JPRB, 0.46352778E-11_JPRB, 0.52782531E-11_JPRB, 0.60109378E-11_JPRB, 0.68333329E-11_JPRB, 0.77433841E-11_JPRB, &
  & 0.87385602E-11_JPRB, 0.98118293E-11_JPRB, 0.10955837E-10_JPRB, 0.12163742E-10_JPRB, 0.13427957E-10_JPRB, 0.14734585E-10_JPRB, &
  & 0.16042910E-10_JPRB, 0.17304949E-10_JPRB, 0.18461455E-10_JPRB, 0.19459601E-10_JPRB, 0.20240731E-10_JPRB, 0.20784704E-10_JPRB, &
  & 0.21111241E-10_JPRB, 0.21287657E-10_JPRB, 0.21420435E-10_JPRB, 0.21565659E-10_JPRB, 0.21724582E-10_JPRB, 0.21866300E-10_JPRB, &
  & 0.21953597E-10_JPRB, 0.21933986E-10_JPRB, 0.21794493E-10_JPRB, 0.21589173E-10_JPRB, 0.21405679E-10_JPRB, 0.21294300E-10_JPRB, &
  & 0.21341432E-10_JPRB, 0.21507464E-10_JPRB, 0.21732564E-10_JPRB, 0.21924986E-10_JPRB, 0.21964227E-10_JPRB, 0.21820218E-10_JPRB, &
  & 0.21433919E-10_JPRB, 0.20852649E-10_JPRB, 0.20122924E-10_JPRB, 0.19288370E-10_JPRB, 0.18408171E-10_JPRB, 0.17522383E-10_JPRB, &
  & 0.16643225E-10_JPRB, 0.15786386E-10_JPRB, 0.14919737E-10_JPRB, 0.14030326E-10_JPRB, 0.13125754E-10_JPRB, 0.12214927E-10_JPRB, &
  & 0.11309021E-10_JPRB, 0.10423831E-10_JPRB, 0.95788134E-11_JPRB, 0.87889505E-11_JPRB, 0.80689925E-11_JPRB, 0.74272342E-11_JPRB, &
  & 0.68590710E-11_JPRB, 0.63757020E-11_JPRB, 0.58333724E-11_JPRB, 0.50816569E-11_JPRB /)

RGHG9(:,24,11) = (/ &
  & 0.32047748E-11_JPRB, 0.37068400E-11_JPRB, 0.40714706E-11_JPRB, 0.44566659E-11_JPRB, 0.49008323E-11_JPRB, 0.54279042E-11_JPRB, &
  & 0.60510286E-11_JPRB, 0.67813043E-11_JPRB, 0.76256709E-11_JPRB, 0.85786760E-11_JPRB, 0.96408550E-11_JPRB, 0.10805848E-10_JPRB, &
  & 0.12071883E-10_JPRB, 0.13433690E-10_JPRB, 0.14879200E-10_JPRB, 0.16397396E-10_JPRB, 0.17963703E-10_JPRB, 0.19566666E-10_JPRB, &
  & 0.21193887E-10_JPRB, 0.22810033E-10_JPRB, 0.24364259E-10_JPRB, 0.25807589E-10_JPRB, 0.27068656E-10_JPRB, 0.28089866E-10_JPRB, &
  & 0.28859422E-10_JPRB, 0.29422159E-10_JPRB, 0.29850258E-10_JPRB, 0.30187769E-10_JPRB, 0.30443727E-10_JPRB, 0.30600130E-10_JPRB, &
  & 0.30626245E-10_JPRB, 0.30486981E-10_JPRB, 0.30198684E-10_JPRB, 0.29814626E-10_JPRB, 0.29442133E-10_JPRB, 0.29176050E-10_JPRB, &
  & 0.29068145E-10_JPRB, 0.29112299E-10_JPRB, 0.29245883E-10_JPRB, 0.29363338E-10_JPRB, 0.29350227E-10_JPRB, 0.29130552E-10_JPRB, &
  & 0.28665542E-10_JPRB, 0.27947882E-10_JPRB, 0.27031682E-10_JPRB, 0.25992458E-10_JPRB, 0.24882485E-10_JPRB, 0.23767124E-10_JPRB, &
  & 0.22645941E-10_JPRB, 0.21545845E-10_JPRB, 0.20442431E-10_JPRB, 0.19349371E-10_JPRB, 0.18261352E-10_JPRB, 0.17179962E-10_JPRB, &
  & 0.16108195E-10_JPRB, 0.15053370E-10_JPRB, 0.14026087E-10_JPRB, 0.13040000E-10_JPRB, 0.12110379E-10_JPRB, 0.11251841E-10_JPRB, &
  & 0.10476662E-10_JPRB, 0.97383421E-11_JPRB, 0.90134384E-11_JPRB, 0.77697831E-11_JPRB /)

RGHG9(:,25,11) = (/ &
  & 0.45901716E-11_JPRB, 0.52685903E-11_JPRB, 0.57618051E-11_JPRB, 0.62717383E-11_JPRB, 0.68531530E-11_JPRB, 0.75302568E-11_JPRB, &
  & 0.83181205E-11_JPRB, 0.92254546E-11_JPRB, 0.10260038E-10_JPRB, 0.11418138E-10_JPRB, 0.12700145E-10_JPRB, 0.14098471E-10_JPRB, &
  & 0.15606896E-10_JPRB, 0.17217863E-10_JPRB, 0.18921583E-10_JPRB, 0.20704306E-10_JPRB, 0.22549037E-10_JPRB, 0.24443478E-10_JPRB, &
  & 0.26364595E-10_JPRB, 0.28301979E-10_JPRB, 0.30227678E-10_JPRB, 0.32091600E-10_JPRB, 0.33807429E-10_JPRB, 0.35296929E-10_JPRB, &
  & 0.36513303E-10_JPRB, 0.37456222E-10_JPRB, 0.38172583E-10_JPRB, 0.38686873E-10_JPRB, 0.39011846E-10_JPRB, 0.39150752E-10_JPRB, &
  & 0.39094082E-10_JPRB, 0.38845534E-10_JPRB, 0.38445296E-10_JPRB, 0.37962689E-10_JPRB, 0.37473309E-10_JPRB, 0.37091826E-10_JPRB, &
  & 0.36867280E-10_JPRB, 0.36787986E-10_JPRB, 0.36807179E-10_JPRB, 0.36812293E-10_JPRB, 0.36705940E-10_JPRB, 0.36388042E-10_JPRB, &
  & 0.35826290E-10_JPRB, 0.34995278E-10_JPRB, 0.33927781E-10_JPRB, 0.32700762E-10_JPRB, 0.31381630E-10_JPRB, 0.30046278E-10_JPRB, &
  & 0.28717044E-10_JPRB, 0.27418750E-10_JPRB, 0.26130336E-10_JPRB, 0.24867379E-10_JPRB, 0.23633036E-10_JPRB, 0.22427222E-10_JPRB, &
  & 0.21243394E-10_JPRB, 0.20073929E-10_JPRB, 0.18921351E-10_JPRB, 0.17792039E-10_JPRB, 0.16703203E-10_JPRB, 0.15670213E-10_JPRB, &
  & 0.14698090E-10_JPRB, 0.13772239E-10_JPRB, 0.12758083E-10_JPRB, 0.11098423E-10_JPRB /)

RGHG9(:,26,11) = (/ &
  & 0.62357107E-11_JPRB, 0.71094962E-11_JPRB, 0.77358059E-11_JPRB, 0.83764705E-11_JPRB, 0.90941213E-11_JPRB, 0.99183526E-11_JPRB, &
  & 0.10862520E-10_JPRB, 0.11934974E-10_JPRB, 0.13141935E-10_JPRB, 0.14483860E-10_JPRB, 0.15958856E-10_JPRB, 0.17561522E-10_JPRB, &
  & 0.19281908E-10_JPRB, 0.21105973E-10_JPRB, 0.23023465E-10_JPRB, 0.25021606E-10_JPRB, 0.27079936E-10_JPRB, 0.29199393E-10_JPRB, &
  & 0.31372387E-10_JPRB, 0.33583178E-10_JPRB, 0.35810487E-10_JPRB, 0.38010310E-10_JPRB, 0.40087166E-10_JPRB, 0.41950908E-10_JPRB, &
  & 0.43523893E-10_JPRB, 0.44781744E-10_JPRB, 0.45741820E-10_JPRB, 0.46411083E-10_JPRB, 0.46803617E-10_JPRB, 0.46940188E-10_JPRB, &
  & 0.46838373E-10_JPRB, 0.46538592E-10_JPRB, 0.46096439E-10_JPRB, 0.45596207E-10_JPRB, 0.45080689E-10_JPRB, 0.44639164E-10_JPRB, &
  & 0.44338172E-10_JPRB, 0.44160297E-10_JPRB, 0.44047994E-10_JPRB, 0.43932191E-10_JPRB, 0.43706237E-10_JPRB, 0.43278010E-10_JPRB, &
  & 0.42609690E-10_JPRB, 0.41673213E-10_JPRB, 0.40486399E-10_JPRB, 0.39113629E-10_JPRB, 0.37630003E-10_JPRB, 0.36108973E-10_JPRB, &
  & 0.34599965E-10_JPRB, 0.33110435E-10_JPRB, 0.31667537E-10_JPRB, 0.30285552E-10_JPRB, 0.28958851E-10_JPRB, 0.27678283E-10_JPRB, &
  & 0.26427837E-10_JPRB, 0.25194565E-10_JPRB, 0.23973202E-10_JPRB, 0.22768318E-10_JPRB, 0.21591770E-10_JPRB, 0.20454312E-10_JPRB, &
  & 0.19363611E-10_JPRB, 0.18293858E-10_JPRB, 0.17082261E-10_JPRB, 0.15077843E-10_JPRB /)

RGHG9(:,27,11) = (/ &
  & 0.81696698E-11_JPRB, 0.92636541E-11_JPRB, 0.10029489E-10_JPRB, 0.10796863E-10_JPRB, 0.11646390E-10_JPRB, 0.12606968E-10_JPRB, &
  & 0.13693209E-10_JPRB, 0.14911447E-10_JPRB, 0.16268180E-10_JPRB, 0.17761917E-10_JPRB, 0.19396935E-10_JPRB, 0.21166123E-10_JPRB, &
  & 0.23049271E-10_JPRB, 0.25056568E-10_JPRB, 0.27149274E-10_JPRB, 0.29332720E-10_JPRB, 0.31566118E-10_JPRB, 0.33861389E-10_JPRB, &
  & 0.36210340E-10_JPRB, 0.38603131E-10_JPRB, 0.41021297E-10_JPRB, 0.43436456E-10_JPRB, 0.45741043E-10_JPRB, 0.47850838E-10_JPRB, &
  & 0.49670022E-10_JPRB, 0.51150823E-10_JPRB, 0.52297635E-10_JPRB, 0.53100954E-10_JPRB, 0.53574156E-10_JPRB, 0.53744530E-10_JPRB, &
  & 0.53652489E-10_JPRB, 0.53364362E-10_JPRB, 0.52945870E-10_JPRB, 0.52482352E-10_JPRB, 0.52012589E-10_JPRB, 0.51574165E-10_JPRB, &
  & 0.51231675E-10_JPRB, 0.50976279E-10_JPRB, 0.50743808E-10_JPRB, 0.50496485E-10_JPRB, 0.50142741E-10_JPRB, 0.49604182E-10_JPRB, &
  & 0.48835252E-10_JPRB, 0.47805045E-10_JPRB, 0.46522054E-10_JPRB, 0.45040357E-10_JPRB, 0.43441830E-10_JPRB, 0.41797722E-10_JPRB, &
  & 0.40152028E-10_JPRB, 0.38528486E-10_JPRB, 0.36964182E-10_JPRB, 0.35481465E-10_JPRB, 0.34083788E-10_JPRB, 0.32753807E-10_JPRB, &
  & 0.31469986E-10_JPRB, 0.30213169E-10_JPRB, 0.28974188E-10_JPRB, 0.27751390E-10_JPRB, 0.26551632E-10_JPRB, 0.25388457E-10_JPRB, &
  & 0.24262320E-10_JPRB, 0.23125092E-10_JPRB, 0.21878548E-10_JPRB, 0.19607526E-10_JPRB /)

RGHG9(:,28,11) = (/ &
  & 0.10437581E-10_JPRB, 0.11776076E-10_JPRB, 0.12679487E-10_JPRB, 0.13574669E-10_JPRB, 0.14541470E-10_JPRB, 0.15623329E-10_JPRB, &
  & 0.16830886E-10_JPRB, 0.18170378E-10_JPRB, 0.19643833E-10_JPRB, 0.21257648E-10_JPRB, 0.23009017E-10_JPRB, 0.24895645E-10_JPRB, &
  & 0.26905417E-10_JPRB, 0.29039129E-10_JPRB, 0.31255783E-10_JPRB, 0.33569959E-10_JPRB, 0.35933218E-10_JPRB, 0.38356679E-10_JPRB, &
  & 0.40823046E-10_JPRB, 0.43321100E-10_JPRB, 0.45841306E-10_JPRB, 0.48354702E-10_JPRB, 0.50771685E-10_JPRB, 0.53002203E-10_JPRB, &
  & 0.54956505E-10_JPRB, 0.56571959E-10_JPRB, 0.57847997E-10_JPRB, 0.58763203E-10_JPRB, 0.59327071E-10_JPRB, 0.59563139E-10_JPRB, &
  & 0.59527397E-10_JPRB, 0.59299246E-10_JPRB, 0.58950470E-10_JPRB, 0.58561565E-10_JPRB, 0.58166239E-10_JPRB, 0.57772027E-10_JPRB, &
  & 0.57417016E-10_JPRB, 0.57106021E-10_JPRB, 0.56777395E-10_JPRB, 0.56408919E-10_JPRB, 0.55931933E-10_JPRB, 0.55283590E-10_JPRB, &
  & 0.54420878E-10_JPRB, 0.53310942E-10_JPRB, 0.51950340E-10_JPRB, 0.50385661E-10_JPRB, 0.48685684E-10_JPRB, 0.46916193E-10_JPRB, &
  & 0.45139122E-10_JPRB, 0.43429607E-10_JPRB, 0.41826098E-10_JPRB, 0.40322114E-10_JPRB, 0.38904841E-10_JPRB, 0.37562651E-10_JPRB, &
  & 0.36274397E-10_JPRB, 0.35020632E-10_JPRB, 0.33791712E-10_JPRB, 0.32583786E-10_JPRB, 0.31404462E-10_JPRB, 0.30258993E-10_JPRB, &
  & 0.29151914E-10_JPRB, 0.28052456E-10_JPRB, 0.26762091E-10_JPRB, 0.24563516E-10_JPRB /)

RGHG9(:,29,11) = (/ &
  & 0.13076719E-10_JPRB, 0.14664684E-10_JPRB, 0.15722921E-10_JPRB, 0.16724691E-10_JPRB, 0.17798811E-10_JPRB, 0.18977118E-10_JPRB, &
  & 0.20280999E-10_JPRB, 0.21710331E-10_JPRB, 0.23271021E-10_JPRB, 0.24961137E-10_JPRB, 0.26791422E-10_JPRB, 0.28749059E-10_JPRB, &
  & 0.30845309E-10_JPRB, 0.33045070E-10_JPRB, 0.35350094E-10_JPRB, 0.37748235E-10_JPRB, 0.40197817E-10_JPRB, 0.42690344E-10_JPRB, &
  & 0.45213933E-10_JPRB, 0.47754523E-10_JPRB, 0.50301589E-10_JPRB, 0.52827832E-10_JPRB, 0.55261698E-10_JPRB, 0.57514930E-10_JPRB, &
  & 0.59513457E-10_JPRB, 0.61186008E-10_JPRB, 0.62531653E-10_JPRB, 0.63529050E-10_JPRB, 0.64177920E-10_JPRB, 0.64497324E-10_JPRB, &
  & 0.64544661E-10_JPRB, 0.64403316E-10_JPRB, 0.64146112E-10_JPRB, 0.63847518E-10_JPRB, 0.63532256E-10_JPRB, 0.63195685E-10_JPRB, &
  & 0.62849032E-10_JPRB, 0.62501525E-10_JPRB, 0.62101664E-10_JPRB, 0.61633261E-10_JPRB, 0.61049020E-10_JPRB, 0.60302652E-10_JPRB, &
  & 0.59356971E-10_JPRB, 0.58181990E-10_JPRB, 0.56769488E-10_JPRB, 0.55153892E-10_JPRB, 0.53393262E-10_JPRB, 0.51570487E-10_JPRB, &
  & 0.49771475E-10_JPRB, 0.48040662E-10_JPRB, 0.46386013E-10_JPRB, 0.44831076E-10_JPRB, 0.43394524E-10_JPRB, 0.42051033E-10_JPRB, &
  & 0.40771417E-10_JPRB, 0.39535090E-10_JPRB, 0.38329211E-10_JPRB, 0.37151057E-10_JPRB, 0.36005025E-10_JPRB, 0.34906286E-10_JPRB, &
  & 0.33846204E-10_JPRB, 0.32782280E-10_JPRB, 0.31594061E-10_JPRB, 0.29445831E-10_JPRB /)

RGHG9(:,30,11) = (/ &
  & 0.16081901E-10_JPRB, 0.17955764E-10_JPRB, 0.19129814E-10_JPRB, 0.20242967E-10_JPRB, 0.21393857E-10_JPRB, 0.22649528E-10_JPRB, &
  & 0.24019214E-10_JPRB, 0.25509329E-10_JPRB, 0.27116545E-10_JPRB, 0.28851473E-10_JPRB, 0.30714879E-10_JPRB, 0.32708090E-10_JPRB, &
  & 0.34840769E-10_JPRB, 0.37071929E-10_JPRB, 0.39422320E-10_JPRB, 0.41871055E-10_JPRB, 0.44367635E-10_JPRB, 0.46892868E-10_JPRB, &
  & 0.49425970E-10_JPRB, 0.51955780E-10_JPRB, 0.54464978E-10_JPRB, 0.56935304E-10_JPRB, 0.59312298E-10_JPRB, 0.61521691E-10_JPRB, &
  & 0.63485175E-10_JPRB, 0.65152876E-10_JPRB, 0.66515807E-10_JPRB, 0.67561630E-10_JPRB, 0.68279583E-10_JPRB, 0.68682275E-10_JPRB, &
  & 0.68820512E-10_JPRB, 0.68772502E-10_JPRB, 0.68610007E-10_JPRB, 0.68399827E-10_JPRB, 0.68157029E-10_JPRB, 0.67873721E-10_JPRB, &
  & 0.67544713E-10_JPRB, 0.67174981E-10_JPRB, 0.66724147E-10_JPRB, 0.66180873E-10_JPRB, 0.65513032E-10_JPRB, 0.64688491E-10_JPRB, &
  & 0.63675835E-10_JPRB, 0.62453570E-10_JPRB, 0.61007865E-10_JPRB, 0.59362196E-10_JPRB, 0.57576274E-10_JPRB, 0.55725220E-10_JPRB, &
  & 0.53894920E-10_JPRB, 0.52123743E-10_JPRB, 0.50468959E-10_JPRB, 0.48955312E-10_JPRB, 0.47553302E-10_JPRB, 0.46233538E-10_JPRB, &
  & 0.44972113E-10_JPRB, 0.43752477E-10_JPRB, 0.42564577E-10_JPRB, 0.41406836E-10_JPRB, 0.40293748E-10_JPRB, 0.39229706E-10_JPRB, &
  & 0.38218536E-10_JPRB, 0.37214183E-10_JPRB, 0.36068749E-10_JPRB, 0.34079659E-10_JPRB /)

RGHG9(:,31,11) = (/ &
  & 0.19483325E-10_JPRB, 0.21577462E-10_JPRB, 0.22891244E-10_JPRB, 0.24068266E-10_JPRB, 0.25287371E-10_JPRB, 0.26588677E-10_JPRB, &
  & 0.27999289E-10_JPRB, 0.29514953E-10_JPRB, 0.31140455E-10_JPRB, 0.32877430E-10_JPRB, 0.34739267E-10_JPRB, 0.36729217E-10_JPRB, &
  & 0.38852116E-10_JPRB, 0.41083095E-10_JPRB, 0.43441400E-10_JPRB, 0.45899409E-10_JPRB, 0.48410786E-10_JPRB, 0.50940047E-10_JPRB, &
  & 0.53455736E-10_JPRB, 0.55931336E-10_JPRB, 0.58361968E-10_JPRB, 0.60735535E-10_JPRB, 0.63011582E-10_JPRB, 0.65124107E-10_JPRB, &
  & 0.67007219E-10_JPRB, 0.68616127E-10_JPRB, 0.69957304E-10_JPRB, 0.71013431E-10_JPRB, 0.71775405E-10_JPRB, 0.72247305E-10_JPRB, &
  & 0.72468871E-10_JPRB, 0.72507916E-10_JPRB, 0.72430902E-10_JPRB, 0.72295517E-10_JPRB, 0.72111123E-10_JPRB, 0.71867318E-10_JPRB, &
  & 0.71556962E-10_JPRB, 0.71173449E-10_JPRB, 0.70689968E-10_JPRB, 0.70095173E-10_JPRB, 0.69368178E-10_JPRB, 0.68486994E-10_JPRB, &
  & 0.67425773E-10_JPRB, 0.66170236E-10_JPRB, 0.64705977E-10_JPRB, 0.63053902E-10_JPRB, 0.61270808E-10_JPRB, 0.59439405E-10_JPRB, &
  & 0.57624145E-10_JPRB, 0.55897766E-10_JPRB, 0.54290711E-10_JPRB, 0.52799355E-10_JPRB, 0.51411785E-10_JPRB, 0.50106301E-10_JPRB, &
  & 0.48860756E-10_JPRB, 0.47654859E-10_JPRB, 0.46477822E-10_JPRB, 0.45337581E-10_JPRB, 0.44243720E-10_JPRB, 0.43212326E-10_JPRB, &
  & 0.42233099E-10_JPRB, 0.41276312E-10_JPRB, 0.40199750E-10_JPRB, 0.38321228E-10_JPRB /)

RGHG9(:,32,11) = (/ &
  & 0.23185207E-10_JPRB, 0.25512413E-10_JPRB, 0.26892117E-10_JPRB, 0.28143283E-10_JPRB, 0.29396017E-10_JPRB, 0.30726074E-10_JPRB, &
  & 0.32148680E-10_JPRB, 0.33666334E-10_JPRB, 0.35274231E-10_JPRB, 0.36984363E-10_JPRB, 0.38805008E-10_JPRB, 0.40753234E-10_JPRB, &
  & 0.42826621E-10_JPRB, 0.45027808E-10_JPRB, 0.47357597E-10_JPRB, 0.49793454E-10_JPRB, 0.52285683E-10_JPRB, 0.54788424E-10_JPRB, &
  & 0.57259340E-10_JPRB, 0.59670345E-10_JPRB, 0.62008294E-10_JPRB, 0.64264941E-10_JPRB, 0.66414610E-10_JPRB, 0.68401645E-10_JPRB, &
  & 0.70171632E-10_JPRB, 0.71696572E-10_JPRB, 0.72976999E-10_JPRB, 0.74011616E-10_JPRB, 0.74788023E-10_JPRB, 0.75306927E-10_JPRB, &
  & 0.75595120E-10_JPRB, 0.75705539E-10_JPRB, 0.75697650E-10_JPRB, 0.75619150E-10_JPRB, 0.75475522E-10_JPRB, 0.75259840E-10_JPRB, &
  & 0.74964070E-10_JPRB, 0.74573313E-10_JPRB, 0.74071888E-10_JPRB, 0.73445063E-10_JPRB, 0.72681146E-10_JPRB, 0.71761673E-10_JPRB, &
  & 0.70669560E-10_JPRB, 0.69394872E-10_JPRB, 0.67927303E-10_JPRB, 0.66291792E-10_JPRB, 0.64550490E-10_JPRB, 0.62761941E-10_JPRB, &
  & 0.61000455E-10_JPRB, 0.59320437E-10_JPRB, 0.57751991E-10_JPRB, 0.56300901E-10_JPRB, 0.54950305E-10_JPRB, 0.53679821E-10_JPRB, &
  & 0.52458551E-10_JPRB, 0.51266588E-10_JPRB, 0.50102700E-10_JPRB, 0.48969294E-10_JPRB, 0.47889734E-10_JPRB, 0.46877086E-10_JPRB, &
  & 0.45939030E-10_JPRB, 0.45015786E-10_JPRB, 0.43991498E-10_JPRB, 0.42212938E-10_JPRB /)

RGHG9(:,33,11) = (/ &
  & 0.27174599E-10_JPRB, 0.29619099E-10_JPRB, 0.31080086E-10_JPRB, 0.32355573E-10_JPRB, 0.33629852E-10_JPRB, 0.34967647E-10_JPRB, &
  & 0.36384930E-10_JPRB, 0.37878353E-10_JPRB, 0.39447723E-10_JPRB, 0.41097094E-10_JPRB, 0.42845383E-10_JPRB, 0.44711970E-10_JPRB, &
  & 0.46704796E-10_JPRB, 0.48839096E-10_JPRB, 0.51114328E-10_JPRB, 0.53500645E-10_JPRB, 0.55957398E-10_JPRB, 0.58423981E-10_JPRB, &
  & 0.60839174E-10_JPRB, 0.63171281E-10_JPRB, 0.65406000E-10_JPRB, 0.67542597E-10_JPRB, 0.69552288E-10_JPRB, 0.71399067E-10_JPRB, &
  & 0.73038416E-10_JPRB, 0.74451792E-10_JPRB, 0.75652748E-10_JPRB, 0.76639591E-10_JPRB, 0.77406408E-10_JPRB, 0.77948585E-10_JPRB, &
  & 0.78281451E-10_JPRB, 0.78444855E-10_JPRB, 0.78487328E-10_JPRB, 0.78447457E-10_JPRB, 0.78330592E-10_JPRB, 0.78135748E-10_JPRB, &
  & 0.77849727E-10_JPRB, 0.77459539E-10_JPRB, 0.76950925E-10_JPRB, 0.76308911E-10_JPRB, 0.75525836E-10_JPRB, 0.74584318E-10_JPRB, &
  & 0.73476107E-10_JPRB, 0.72194035E-10_JPRB, 0.70739734E-10_JPRB, 0.69145314E-10_JPRB, 0.67449858E-10_JPRB, 0.65722712E-10_JPRB, &
  & 0.64024522E-10_JPRB, 0.62414490E-10_JPRB, 0.60913476E-10_JPRB, 0.59522255E-10_JPRB, 0.58227631E-10_JPRB, 0.56995148E-10_JPRB, &
  & 0.55798647E-10_JPRB, 0.54623570E-10_JPRB, 0.53464438E-10_JPRB, 0.52338633E-10_JPRB, 0.51269579E-10_JPRB, 0.50283156E-10_JPRB, &
  & 0.49361570E-10_JPRB, 0.48478763E-10_JPRB, 0.47491910E-10_JPRB, 0.45810876E-10_JPRB /)

RGHG9(:,34,11) = (/ &
  & 0.31340795E-10_JPRB, 0.33854957E-10_JPRB, 0.35325198E-10_JPRB, 0.36606981E-10_JPRB, 0.37884772E-10_JPRB, 0.39210024E-10_JPRB, &
  & 0.40605474E-10_JPRB, 0.42060855E-10_JPRB, 0.43568329E-10_JPRB, 0.45136929E-10_JPRB, 0.46783084E-10_JPRB, 0.48535381E-10_JPRB, &
  & 0.50418131E-10_JPRB, 0.52453614E-10_JPRB, 0.54645680E-10_JPRB, 0.56963281E-10_JPRB, 0.59362792E-10_JPRB, 0.61775453E-10_JPRB, &
  & 0.64136099E-10_JPRB, 0.66401377E-10_JPRB, 0.68551227E-10_JPRB, 0.70576420E-10_JPRB, 0.72456166E-10_JPRB, 0.74161163E-10_JPRB, &
  & 0.75664308E-10_JPRB, 0.76956642E-10_JPRB, 0.78057255E-10_JPRB, 0.78974431E-10_JPRB, 0.79705090E-10_JPRB, 0.80243340E-10_JPRB, &
  & 0.80597230E-10_JPRB, 0.80792616E-10_JPRB, 0.80866591E-10_JPRB, 0.80849751E-10_JPRB, 0.80752544E-10_JPRB, 0.80572708E-10_JPRB, &
  & 0.80297269E-10_JPRB, 0.79916837E-10_JPRB, 0.79410527E-10_JPRB, 0.78768811E-10_JPRB, 0.77979609E-10_JPRB, 0.77029251E-10_JPRB, &
  & 0.75914192E-10_JPRB, 0.74634389E-10_JPRB, 0.73202486E-10_JPRB, 0.71649242E-10_JPRB, 0.70021440E-10_JPRB, 0.68373897E-10_JPRB, &
  & 0.66774627E-10_JPRB, 0.65252304E-10_JPRB, 0.63829282E-10_JPRB, 0.62502489E-10_JPRB, 0.61249110E-10_JPRB, 0.60047696E-10_JPRB, &
  & 0.58874121E-10_JPRB, 0.57714958E-10_JPRB, 0.56573999E-10_JPRB, 0.55462968E-10_JPRB, 0.54413637E-10_JPRB, 0.53439607E-10_JPRB, &
  & 0.52552396E-10_JPRB, 0.51695814E-10_JPRB, 0.50764982E-10_JPRB, 0.49158965E-10_JPRB /)

RGHG9(:,35,11) = (/ &
  & 0.35629933E-10_JPRB, 0.38108079E-10_JPRB, 0.39543792E-10_JPRB, 0.40806372E-10_JPRB, 0.42050717E-10_JPRB, 0.43355489E-10_JPRB, &
  & 0.44713670E-10_JPRB, 0.46116066E-10_JPRB, 0.47551695E-10_JPRB, 0.49019996E-10_JPRB, 0.50545644E-10_JPRB, 0.52160158E-10_JPRB, &
  & 0.53907441E-10_JPRB, 0.55817902E-10_JPRB, 0.57905018E-10_JPRB, 0.60138811E-10_JPRB, 0.62473554E-10_JPRB, 0.64830884E-10_JPRB, &
  & 0.67144540E-10_JPRB, 0.69355743E-10_JPRB, 0.71438001E-10_JPRB, 0.73371476E-10_JPRB, 0.75136133E-10_JPRB, 0.76710062E-10_JPRB, &
  & 0.78077080E-10_JPRB, 0.79241176E-10_JPRB, 0.80227242E-10_JPRB, 0.81052658E-10_JPRB, 0.81720436E-10_JPRB, 0.82228169E-10_JPRB, &
  & 0.82576876E-10_JPRB, 0.82783343E-10_JPRB, 0.82872605E-10_JPRB, 0.82870780E-10_JPRB, 0.82790323E-10_JPRB, 0.82624421E-10_JPRB, &
  & 0.82368730E-10_JPRB, 0.82007977E-10_JPRB, 0.81519784E-10_JPRB, 0.80894166E-10_JPRB, 0.80113138E-10_JPRB, 0.79164821E-10_JPRB, &
  & 0.78051600E-10_JPRB, 0.76778854E-10_JPRB, 0.75373388E-10_JPRB, 0.73871569E-10_JPRB, 0.72313176E-10_JPRB, 0.70758607E-10_JPRB, &
  & 0.69242806E-10_JPRB, 0.67805053E-10_JPRB, 0.66456833E-10_JPRB, 0.65189056E-10_JPRB, 0.63989265E-10_JPRB, 0.62831206E-10_JPRB, &
  & 0.61694823E-10_JPRB, 0.60567620E-10_JPRB, 0.59449952E-10_JPRB, 0.58358957E-10_JPRB, 0.57323580E-10_JPRB, 0.56377271E-10_JPRB, &
  & 0.55512060E-10_JPRB, 0.54697726E-10_JPRB, 0.53795621E-10_JPRB, 0.52284614E-10_JPRB /)

RGHG9(:,36,11) = (/ &
  & 0.39995084E-10_JPRB, 0.42314950E-10_JPRB, 0.43676771E-10_JPRB, 0.44867027E-10_JPRB, 0.46072868E-10_JPRB, 0.47326598E-10_JPRB, &
  & 0.48637618E-10_JPRB, 0.49978618E-10_JPRB, 0.51329156E-10_JPRB, 0.52689738E-10_JPRB, 0.54080178E-10_JPRB, 0.55543806E-10_JPRB, &
  & 0.57136511E-10_JPRB, 0.58905103E-10_JPRB, 0.60869879E-10_JPRB, 0.63013407E-10_JPRB, 0.65279768E-10_JPRB, 0.67593861E-10_JPRB, &
  & 0.69866342E-10_JPRB, 0.72038708E-10_JPRB, 0.74066489E-10_JPRB, 0.75926210E-10_JPRB, 0.77588054E-10_JPRB, 0.79038678E-10_JPRB, &
  & 0.80270103E-10_JPRB, 0.81297094E-10_JPRB, 0.82154082E-10_JPRB, 0.82864764E-10_JPRB, 0.83442808E-10_JPRB, 0.83888514E-10_JPRB, &
  & 0.84205677E-10_JPRB, 0.84402429E-10_JPRB, 0.84494162E-10_JPRB, 0.84505049E-10_JPRB, 0.84439546E-10_JPRB, 0.84295113E-10_JPRB, &
  & 0.84071444E-10_JPRB, 0.83744692E-10_JPRB, 0.83299159E-10_JPRB, 0.82714349E-10_JPRB, 0.81964657E-10_JPRB, 0.81040848E-10_JPRB, &
  & 0.79938771E-10_JPRB, 0.78683851E-10_JPRB, 0.77307903E-10_JPRB, 0.75855003E-10_JPRB, 0.74372460E-10_JPRB, 0.72899041E-10_JPRB, &
  & 0.71474673E-10_JPRB, 0.70118994E-10_JPRB, 0.68841828E-10_JPRB, 0.67636188E-10_JPRB, 0.66482424E-10_JPRB, 0.65370216E-10_JPRB, &
  & 0.64271921E-10_JPRB, 0.63179580E-10_JPRB, 0.62092234E-10_JPRB, 0.61028745E-10_JPRB, 0.60022189E-10_JPRB, 0.59099947E-10_JPRB, &
  & 0.58267030E-10_JPRB, 0.57473415E-10_JPRB, 0.56626717E-10_JPRB, 0.55182969E-10_JPRB /)

RGHG9(:,37,11) = (/ &
  & 0.44381828E-10_JPRB, 0.46468968E-10_JPRB, 0.47685314E-10_JPRB, 0.48786256E-10_JPRB, 0.49907967E-10_JPRB, 0.51102848E-10_JPRB, &
  & 0.52349850E-10_JPRB, 0.53616830E-10_JPRB, 0.54876336E-10_JPRB, 0.56119342E-10_JPRB, 0.57369803E-10_JPRB, 0.58675703E-10_JPRB, &
  & 0.60103499E-10_JPRB, 0.61718929E-10_JPRB, 0.63549929E-10_JPRB, 0.65597666E-10_JPRB, 0.67791238E-10_JPRB, 0.70061165E-10_JPRB, &
  & 0.72311136E-10_JPRB, 0.74460792E-10_JPRB, 0.76449409E-10_JPRB, 0.78238492E-10_JPRB, 0.79796343E-10_JPRB, 0.81106261E-10_JPRB, &
  & 0.82177778E-10_JPRB, 0.83041435E-10_JPRB, 0.83742034E-10_JPRB, 0.84313737E-10_JPRB, 0.84775950E-10_JPRB, 0.85137682E-10_JPRB, &
  & 0.85401519E-10_JPRB, 0.85572147E-10_JPRB, 0.85659028E-10_JPRB, 0.85679033E-10_JPRB, 0.85629885E-10_JPRB, 0.85516989E-10_JPRB, &
  & 0.85332727E-10_JPRB, 0.85061853E-10_JPRB, 0.84685987E-10_JPRB, 0.84176582E-10_JPRB, 0.83506611E-10_JPRB, 0.82644974E-10_JPRB, &
  & 0.81596313E-10_JPRB, 0.80377212E-10_JPRB, 0.79040531E-10_JPRB, 0.77637681E-10_JPRB, 0.76220093E-10_JPRB, 0.74825465E-10_JPRB, &
  & 0.73476766E-10_JPRB, 0.72193550E-10_JPRB, 0.70980666E-10_JPRB, 0.69831294E-10_JPRB, 0.68729668E-10_JPRB, 0.67663410E-10_JPRB, &
  & 0.66613833E-10_JPRB, 0.65569397E-10_JPRB, 0.64528619E-10_JPRB, 0.63507220E-10_JPRB, 0.62533673E-10_JPRB, 0.61637195E-10_JPRB, &
  & 0.60824429E-10_JPRB, 0.60068166E-10_JPRB, 0.59241924E-10_JPRB, 0.57871246E-10_JPRB /)

RGHG9(:,38,11) = (/ &
  & 0.48731810E-10_JPRB, 0.50498220E-10_JPRB, 0.51559999E-10_JPRB, 0.52535726E-10_JPRB, 0.53563376E-10_JPRB, 0.54676191E-10_JPRB, &
  & 0.55845141E-10_JPRB, 0.57026536E-10_JPRB, 0.58183292E-10_JPRB, 0.59304867E-10_JPRB, 0.60414153E-10_JPRB, 0.61563810E-10_JPRB, &
  & 0.62825904E-10_JPRB, 0.64280817E-10_JPRB, 0.65976606E-10_JPRB, 0.67914306E-10_JPRB, 0.70049834E-10_JPRB, 0.72271612E-10_JPRB, &
  & 0.74488443E-10_JPRB, 0.76607075E-10_JPRB, 0.78540882E-10_JPRB, 0.80225923E-10_JPRB, 0.81627961E-10_JPRB, 0.82752742E-10_JPRB, &
  & 0.83631421E-10_JPRB, 0.84315548E-10_JPRB, 0.84857871E-10_JPRB, 0.85295382E-10_JPRB, 0.85650764E-10_JPRB, 0.85932580E-10_JPRB, &
  & 0.86145265E-10_JPRB, 0.86287699E-10_JPRB, 0.86367136E-10_JPRB, 0.86390992E-10_JPRB, 0.86357095E-10_JPRB, 0.86272552E-10_JPRB, &
  & 0.86128445E-10_JPRB, 0.85916489E-10_JPRB, 0.85618700E-10_JPRB, 0.85209104E-10_JPRB, 0.84650724E-10_JPRB, 0.83911385E-10_JPRB, &
  & 0.82968493E-10_JPRB, 0.81840493E-10_JPRB, 0.80566949E-10_JPRB, 0.79226195E-10_JPRB, 0.77875498E-10_JPRB, 0.76549427E-10_JPRB, &
  & 0.75269881E-10_JPRB, 0.74048684E-10_JPRB, 0.72888924E-10_JPRB, 0.71789748E-10_JPRB, 0.70737916E-10_JPRB, 0.69726371E-10_JPRB, &
  & 0.68739951E-10_JPRB, 0.67761581E-10_JPRB, 0.66785577E-10_JPRB, 0.65817657E-10_JPRB, 0.64883370E-10_JPRB, 0.64014634E-10_JPRB, &
  & 0.63227062E-10_JPRB, 0.62481985E-10_JPRB, 0.61690833E-10_JPRB, 0.60360487E-10_JPRB /)

RGHG9(:,39,11) = (/ &
  & 0.52906717E-10_JPRB, 0.54366366E-10_JPRB, 0.55254086E-10_JPRB, 0.56102036E-10_JPRB, 0.57027574E-10_JPRB, 0.58046290E-10_JPRB, &
  & 0.59125947E-10_JPRB, 0.60207506E-10_JPRB, 0.61252933E-10_JPRB, 0.62250725E-10_JPRB, 0.63225022E-10_JPRB, 0.64224778E-10_JPRB, &
  & 0.65333135E-10_JPRB, 0.66624269E-10_JPRB, 0.68182536E-10_JPRB, 0.70008568E-10_JPRB, 0.72056902E-10_JPRB, 0.74228609E-10_JPRB, &
  & 0.76393947E-10_JPRB, 0.78435092E-10_JPRB, 0.80249737E-10_JPRB, 0.81763769E-10_JPRB, 0.82964566E-10_JPRB, 0.83886897E-10_JPRB, &
  & 0.84587184E-10_JPRB, 0.85121687E-10_JPRB, 0.85542740E-10_JPRB, 0.85883689E-10_JPRB, 0.86163729E-10_JPRB, 0.86391588E-10_JPRB, &
  & 0.86568024E-10_JPRB, 0.86690238E-10_JPRB, 0.86763728E-10_JPRB, 0.86787348E-10_JPRB, 0.86764859E-10_JPRB, 0.86698801E-10_JPRB, &
  & 0.86584871E-10_JPRB, 0.86418650E-10_JPRB, 0.86184081E-10_JPRB, 0.85860527E-10_JPRB, 0.85415328E-10_JPRB, 0.84811075E-10_JPRB, &
  & 0.84020679E-10_JPRB, 0.83023921E-10_JPRB, 0.81864279E-10_JPRB, 0.80613710E-10_JPRB, 0.79336454E-10_JPRB, 0.78079945E-10_JPRB, &
  & 0.76863321E-10_JPRB, 0.75695950E-10_JPRB, 0.74584602E-10_JPRB, 0.73532909E-10_JPRB, 0.72534811E-10_JPRB, 0.71586390E-10_JPRB, &
  & 0.70670796E-10_JPRB, 0.69773402E-10_JPRB, 0.68873462E-10_JPRB, 0.67973183E-10_JPRB, 0.67090333E-10_JPRB, 0.66254946E-10_JPRB, &
  & 0.65483355E-10_JPRB, 0.64759149E-10_JPRB, 0.63974527E-10_JPRB, 0.62680694E-10_JPRB /)

RGHG9(:,40,11) = (/ &
  & 0.56794035E-10_JPRB, 0.57973359E-10_JPRB, 0.58717503E-10_JPRB, 0.59453054E-10_JPRB, 0.60275743E-10_JPRB, 0.61208552E-10_JPRB, &
  & 0.62189184E-10_JPRB, 0.63163579E-10_JPRB, 0.64094091E-10_JPRB, 0.64971292E-10_JPRB, 0.65816894E-10_JPRB, 0.66687940E-10_JPRB, &
  & 0.67646305E-10_JPRB, 0.68795365E-10_JPRB, 0.70201081E-10_JPRB, 0.71916938E-10_JPRB, 0.73875801E-10_JPRB, 0.75965172E-10_JPRB, &
  & 0.78036494E-10_JPRB, 0.79950185E-10_JPRB, 0.81581304E-10_JPRB, 0.82886017E-10_JPRB, 0.83880208E-10_JPRB, 0.84627222E-10_JPRB, &
  & 0.85187295E-10_JPRB, 0.85616528E-10_JPRB, 0.85956742E-10_JPRB, 0.86235671E-10_JPRB, 0.86469575E-10_JPRB, 0.86663267E-10_JPRB, &
  & 0.86817026E-10_JPRB, 0.86926251E-10_JPRB, 0.86995161E-10_JPRB, 0.87017650E-10_JPRB, 0.87002010E-10_JPRB, 0.86946859E-10_JPRB, &
  & 0.86853573E-10_JPRB, 0.86717258E-10_JPRB, 0.86527563E-10_JPRB, 0.86267396E-10_JPRB, 0.85910806E-10_JPRB, 0.85426478E-10_JPRB, &
  & 0.84775340E-10_JPRB, 0.83934103E-10_JPRB, 0.82921572E-10_JPRB, 0.81785724E-10_JPRB, 0.80606181E-10_JPRB, 0.79425445E-10_JPRB, &
  & 0.78271806E-10_JPRB, 0.77157739E-10_JPRB, 0.76091591E-10_JPRB, 0.75083904E-10_JPRB, 0.74143545E-10_JPRB, 0.73258850E-10_JPRB, &
  & 0.72426662E-10_JPRB, 0.71612535E-10_JPRB, 0.70802045E-10_JPRB, 0.69977940E-10_JPRB, 0.69155806E-10_JPRB, 0.68358749E-10_JPRB, &
  & 0.67615247E-10_JPRB, 0.66901332E-10_JPRB, 0.66137193E-10_JPRB, 0.64858105E-10_JPRB /)

RGHG9(:,41,11) = (/ &
  & 0.60312449E-10_JPRB, 0.61286538E-10_JPRB, 0.61914751E-10_JPRB, 0.62554947E-10_JPRB, 0.63304861E-10_JPRB, 0.64151941E-10_JPRB, &
  & 0.65043568E-10_JPRB, 0.65911422E-10_JPRB, 0.66728602E-10_JPRB, 0.67491172E-10_JPRB, 0.68225835E-10_JPRB, 0.68971398E-10_JPRB, &
  & 0.69810581E-10_JPRB, 0.70811426E-10_JPRB, 0.72085157E-10_JPRB, 0.73662736E-10_JPRB, 0.75515705E-10_JPRB, 0.77500811E-10_JPRB, &
  & 0.79451536E-10_JPRB, 0.81187154E-10_JPRB, 0.82613201E-10_JPRB, 0.83704703E-10_JPRB, 0.84518913E-10_JPRB, 0.85124983E-10_JPRB, &
  & 0.85583998E-10_JPRB, 0.85939506E-10_JPRB, 0.86226380E-10_JPRB, 0.86465876E-10_JPRB, 0.86669401E-10_JPRB, 0.86841881E-10_JPRB, &
  & 0.86979944E-10_JPRB, 0.87081280E-10_JPRB, 0.87145464E-10_JPRB, 0.87167482E-10_JPRB, 0.87155103E-10_JPRB, 0.87107023E-10_JPRB, &
  & 0.87027080E-10_JPRB, 0.86911256E-10_JPRB, 0.86752570E-10_JPRB, 0.86538207E-10_JPRB, 0.86247925E-10_JPRB, 0.85854143E-10_JPRB, &
  & 0.85321958E-10_JPRB, 0.84627590E-10_JPRB, 0.83762761E-10_JPRB, 0.82768140E-10_JPRB, 0.81691313E-10_JPRB, 0.80599985E-10_JPRB, &
  & 0.79516851E-10_JPRB, 0.78456852E-10_JPRB, 0.77436113E-10_JPRB, 0.76478851E-10_JPRB, 0.75588605E-10_JPRB, 0.74780418E-10_JPRB, &
  & 0.74022677E-10_JPRB, 0.73300893E-10_JPRB, 0.72575897E-10_JPRB, 0.71834302E-10_JPRB, 0.71079823E-10_JPRB, 0.70338041E-10_JPRB, &
  & 0.69627776E-10_JPRB, 0.68943247E-10_JPRB, 0.68191910E-10_JPRB, 0.66942590E-10_JPRB /)

RGHG9(:,42,11) = (/ &
  & 0.63469494E-10_JPRB, 0.64294403E-10_JPRB, 0.64839398E-10_JPRB, 0.65418587E-10_JPRB, 0.66104025E-10_JPRB, 0.66897154E-10_JPRB, &
  & 0.67705383E-10_JPRB, 0.68477522E-10_JPRB, 0.69191111E-10_JPRB, 0.69851958E-10_JPRB, 0.70480753E-10_JPRB, 0.71126424E-10_JPRB, &
  & 0.71840978E-10_JPRB, 0.72722585E-10_JPRB, 0.73849406E-10_JPRB, 0.75300266E-10_JPRB, 0.77024241E-10_JPRB, 0.78881332E-10_JPRB, &
  & 0.80663712E-10_JPRB, 0.82209080E-10_JPRB, 0.83417120E-10_JPRB, 0.84319447E-10_JPRB, 0.84983763E-10_JPRB, 0.85482788E-10_JPRB, &
  & 0.85865766E-10_JPRB, 0.86169571E-10_JPRB, 0.86419497E-10_JPRB, 0.86631438E-10_JPRB, 0.86815402E-10_JPRB, 0.86972582E-10_JPRB, &
  & 0.87099439E-10_JPRB, 0.87195473E-10_JPRB, 0.87254842E-10_JPRB, 0.87276755E-10_JPRB, 0.87265327E-10_JPRB, 0.87222292E-10_JPRB, &
  & 0.87151231E-10_JPRB, 0.87049944E-10_JPRB, 0.86914073E-10_JPRB, 0.86733502E-10_JPRB, 0.86493319E-10_JPRB, 0.86169384E-10_JPRB, &
  & 0.85735877E-10_JPRB, 0.85164945E-10_JPRB, 0.84443473E-10_JPRB, 0.83576618E-10_JPRB, 0.82624949E-10_JPRB, 0.81625852E-10_JPRB, &
  & 0.80619497E-10_JPRB, 0.79622996E-10_JPRB, 0.78655887E-10_JPRB, 0.77742368E-10_JPRB, 0.76917139E-10_JPRB, 0.76172665E-10_JPRB, &
  & 0.75499683E-10_JPRB, 0.74857717E-10_JPRB, 0.74218992E-10_JPRB, 0.73558618E-10_JPRB, 0.72879557E-10_JPRB, 0.72201828E-10_JPRB, &
  & 0.71547476E-10_JPRB, 0.70901965E-10_JPRB, 0.70192130E-10_JPRB, 0.68988530E-10_JPRB /)

RGHG9(:,43,11) = (/ &
  & 0.66309298E-10_JPRB, 0.67032539E-10_JPRB, 0.67522488E-10_JPRB, 0.68052119E-10_JPRB, 0.68708733E-10_JPRB, 0.69452943E-10_JPRB, &
  & 0.70201678E-10_JPRB, 0.70890682E-10_JPRB, 0.71516210E-10_JPRB, 0.72085671E-10_JPRB, 0.72625905E-10_JPRB, 0.73171892E-10_JPRB, &
  & 0.73786866E-10_JPRB, 0.74538632E-10_JPRB, 0.75535134E-10_JPRB, 0.76838584E-10_JPRB, 0.78427480E-10_JPRB, 0.80129639E-10_JPRB, &
  & 0.81733592E-10_JPRB, 0.83057020E-10_JPRB, 0.84063354E-10_JPRB, 0.84798522E-10_JPRB, 0.85341248E-10_JPRB, 0.85755146E-10_JPRB, &
  & 0.86080906E-10_JPRB, 0.86345549E-10_JPRB, 0.86568488E-10_JPRB, 0.86761626E-10_JPRB, 0.86930761E-10_JPRB, 0.87077588E-10_JPRB, &
  & 0.87195383E-10_JPRB, 0.87287177E-10_JPRB, 0.87342085E-10_JPRB, 0.87363568E-10_JPRB, 0.87352181E-10_JPRB, 0.87312546E-10_JPRB, &
  & 0.87247667E-10_JPRB, 0.87157372E-10_JPRB, 0.87038605E-10_JPRB, 0.86884527E-10_JPRB, 0.86682800E-10_JPRB, 0.86415534E-10_JPRB, &
  & 0.86061269E-10_JPRB, 0.85595746E-10_JPRB, 0.84994969E-10_JPRB, 0.84265032E-10_JPRB, 0.83421929E-10_JPRB, 0.82525362E-10_JPRB, &
  & 0.81604806E-10_JPRB, 0.80679831E-10_JPRB, 0.79771946E-10_JPRB, 0.78920780E-10_JPRB, 0.78153643E-10_JPRB, 0.77482520E-10_JPRB, &
  & 0.76882500E-10_JPRB, 0.76318736E-10_JPRB, 0.75757720E-10_JPRB, 0.75176407E-10_JPRB, 0.74575339E-10_JPRB, 0.73974896E-10_JPRB, &
  & 0.73390710E-10_JPRB, 0.72811625E-10_JPRB, 0.72162019E-10_JPRB, 0.71049611E-10_JPRB /)

RGHG9(:,44,11) = (/ &
  & 0.68893571E-10_JPRB, 0.69548478E-10_JPRB, 0.69995211E-10_JPRB, 0.70499731E-10_JPRB, 0.71127146E-10_JPRB, 0.71851330E-10_JPRB, &
  & 0.72548009E-10_JPRB, 0.73174591E-10_JPRB, 0.73725255E-10_JPRB, 0.74218187E-10_JPRB, 0.74677174E-10_JPRB, 0.75139651E-10_JPRB, &
  & 0.75652269E-10_JPRB, 0.76293777E-10_JPRB, 0.77152014E-10_JPRB, 0.78315097E-10_JPRB, 0.79752233E-10_JPRB, 0.81282772E-10_JPRB, &
  & 0.82669739E-10_JPRB, 0.83775931E-10_JPRB, 0.84590175E-10_JPRB, 0.85182424E-10_JPRB, 0.85626450E-10_JPRB, 0.85972382E-10_JPRB, &
  & 0.86252866E-10_JPRB, 0.86487296E-10_JPRB, 0.86690266E-10_JPRB, 0.86869158E-10_JPRB, 0.87028218E-10_JPRB, 0.87166711E-10_JPRB, &
  & 0.87277498E-10_JPRB, 0.87365094E-10_JPRB, 0.87416269E-10_JPRB, 0.87436593E-10_JPRB, 0.87424984E-10_JPRB, 0.87387500E-10_JPRB, &
  & 0.87327118E-10_JPRB, 0.87245114E-10_JPRB, 0.87139823E-10_JPRB, 0.87006506E-10_JPRB, 0.86835802E-10_JPRB, 0.86614209E-10_JPRB, &
  & 0.86325003E-10_JPRB, 0.85946694E-10_JPRB, 0.85459792E-10_JPRB, 0.84843577E-10_JPRB, 0.84120932E-10_JPRB, 0.83321280E-10_JPRB, &
  & 0.82489786E-10_JPRB, 0.81646495E-10_JPRB, 0.80812558E-10_JPRB, 0.80027457E-10_JPRB, 0.79329814E-10_JPRB, 0.78731313E-10_JPRB, &
  & 0.78200391E-10_JPRB, 0.77708714E-10_JPRB, 0.77218787E-10_JPRB, 0.76712262E-10_JPRB, 0.76191366E-10_JPRB, 0.75674481E-10_JPRB, &
  & 0.75174575E-10_JPRB, 0.74677223E-10_JPRB, 0.74114444E-10_JPRB, 0.73139314E-10_JPRB /)

RGHG9(:,45,11) = (/ &
  & 0.71278150E-10_JPRB, 0.71879183E-10_JPRB, 0.72299888E-10_JPRB, 0.72774509E-10_JPRB, 0.73395803E-10_JPRB, 0.74094744E-10_JPRB, &
  & 0.74761503E-10_JPRB, 0.75334690E-10_JPRB, 0.75825110E-10_JPRB, 0.76252456E-10_JPRB, 0.76640840E-10_JPRB, 0.77024560E-10_JPRB, &
  & 0.77451642E-10_JPRB, 0.77982815E-10_JPRB, 0.78712245E-10_JPRB, 0.79731950E-10_JPRB, 0.81003454E-10_JPRB, 0.82337054E-10_JPRB, &
  & 0.83492165E-10_JPRB, 0.84378365E-10_JPRB, 0.85021594E-10_JPRB, 0.85495930E-10_JPRB, 0.85858216E-10_JPRB, 0.86150573E-10_JPRB, &
  & 0.86394517E-10_JPRB, 0.86605410E-10_JPRB, 0.86792712E-10_JPRB, 0.86961827E-10_JPRB, 0.87113108E-10_JPRB, 0.87245176E-10_JPRB, &
  & 0.87350301E-10_JPRB, 0.87433553E-10_JPRB, 0.87481529E-10_JPRB, 0.87500202E-10_JPRB, 0.87488183E-10_JPRB, 0.87451900E-10_JPRB, &
  & 0.87394827E-10_JPRB, 0.87319221E-10_JPRB, 0.87224492E-10_JPRB, 0.87107731E-10_JPRB, 0.86962083E-10_JPRB, 0.86777335E-10_JPRB, &
  & 0.86541524E-10_JPRB, 0.86238461E-10_JPRB, 0.85846073E-10_JPRB, 0.85347750E-10_JPRB, 0.84732041E-10_JPRB, 0.84036285E-10_JPRB, &
  & 0.83295752E-10_JPRB, 0.82535631E-10_JPRB, 0.81782144E-10_JPRB, 0.81077881E-10_JPRB, 0.80458161E-10_JPRB, 0.79929528E-10_JPRB, &
  & 0.79470416E-10_JPRB, 0.79042481E-10_JPRB, 0.78620402E-10_JPRB, 0.78185687E-10_JPRB, 0.77743430E-10_JPRB, 0.77312101E-10_JPRB, &
  & 0.76901027E-10_JPRB, 0.76492361E-10_JPRB, 0.76029419E-10_JPRB, 0.75217478E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART21',1,ZHOOK_HANDLE)
END SUBROUTINE PART21




SUBROUTINE PART22
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART22',0,ZHOOK_HANDLE)



RGHG9(:,46,11) = (/ &
  & 0.73500504E-10_JPRB, 0.74066253E-10_JPRB, 0.74454713E-10_JPRB, 0.74918335E-10_JPRB, 0.75510639E-10_JPRB, 0.76207568E-10_JPRB, &
  & 0.76839105E-10_JPRB, 0.77371005E-10_JPRB, 0.77810050E-10_JPRB, 0.78176549E-10_JPRB, 0.78503405E-10_JPRB, 0.78820159E-10_JPRB, &
  & 0.79167090E-10_JPRB, 0.79603373E-10_JPRB, 0.80218672E-10_JPRB, 0.81081510E-10_JPRB, 0.82184037E-10_JPRB, 0.83280806E-10_JPRB, &
  & 0.84198093E-10_JPRB, 0.84877515E-10_JPRB, 0.85376331E-10_JPRB, 0.85751385E-10_JPRB, 0.86050431E-10_JPRB, 0.86298725E-10_JPRB, &
  & 0.86514074E-10_JPRB, 0.86706087E-10_JPRB, 0.86881655E-10_JPRB, 0.87043150E-10_JPRB, 0.87189082E-10_JPRB, 0.87315800E-10_JPRB, &
  & 0.87416144E-10_JPRB, 0.87494914E-10_JPRB, 0.87540135E-10_JPRB, 0.87556733E-10_JPRB, 0.87544173E-10_JPRB, 0.87508466E-10_JPRB, &
  & 0.87453815E-10_JPRB, 0.87382969E-10_JPRB, 0.87296663E-10_JPRB, 0.87193093E-10_JPRB, 0.87067374E-10_JPRB, 0.86912748E-10_JPRB, &
  & 0.86720214E-10_JPRB, 0.86478817E-10_JPRB, 0.86172583E-10_JPRB, 0.85776462E-10_JPRB, 0.85277667E-10_JPRB, 0.84685668E-10_JPRB, &
  & 0.84034397E-10_JPRB, 0.83360562E-10_JPRB, 0.82694962E-10_JPRB, 0.82072127E-10_JPRB, 0.81538221E-10_JPRB, 0.81083626E-10_JPRB, &
  & 0.80690989E-10_JPRB, 0.80326530E-10_JPRB, 0.79967262E-10_JPRB, 0.79600750E-10_JPRB, 0.79234008E-10_JPRB, 0.78884163E-10_JPRB, &
  & 0.78554968E-10_JPRB, 0.78232060E-10_JPRB, 0.77862820E-10_JPRB, 0.77217691E-10_JPRB /)

RGHG9(:,47,11) = (/ &
  & 0.75594690E-10_JPRB, 0.76119638E-10_JPRB, 0.76494089E-10_JPRB, 0.76920983E-10_JPRB, 0.77513496E-10_JPRB, 0.78174342E-10_JPRB, &
  & 0.78786679E-10_JPRB, 0.79277543E-10_JPRB, 0.79663498E-10_JPRB, 0.79979523E-10_JPRB, 0.80248516E-10_JPRB, 0.80505935E-10_JPRB, &
  & 0.80786301E-10_JPRB, 0.81141496E-10_JPRB, 0.81638585E-10_JPRB, 0.82366093E-10_JPRB, 0.83246909E-10_JPRB, 0.84106902E-10_JPRB, &
  & 0.84782903E-10_JPRB, 0.85287791E-10_JPRB, 0.85664420E-10_JPRB, 0.85962772E-10_JPRB, 0.86209567E-10_JPRB, 0.86424312E-10_JPRB, &
  & 0.86616631E-10_JPRB, 0.86793933E-10_JPRB, 0.86960467E-10_JPRB, 0.87116446E-10_JPRB, 0.87258138E-10_JPRB, 0.87380179E-10_JPRB, &
  & 0.87476304E-10_JPRB, 0.87550592E-10_JPRB, 0.87593197E-10_JPRB, 0.87607643E-10_JPRB, 0.87594335E-10_JPRB, 0.87558787E-10_JPRB, &
  & 0.87505746E-10_JPRB, 0.87438688E-10_JPRB, 0.87358849E-10_JPRB, 0.87265750E-10_JPRB, 0.87156088E-10_JPRB, 0.87025054E-10_JPRB, &
  & 0.86867687E-10_JPRB, 0.86676763E-10_JPRB, 0.86440952E-10_JPRB, 0.86140921E-10_JPRB, 0.85754827E-10_JPRB, 0.85273386E-10_JPRB, &
  & 0.84723867E-10_JPRB, 0.84137350E-10_JPRB, 0.83553185E-10_JPRB, 0.83025607E-10_JPRB, 0.82565482E-10_JPRB, 0.82188922E-10_JPRB, &
  & 0.81856889E-10_JPRB, 0.81552216E-10_JPRB, 0.81251207E-10_JPRB, 0.80946756E-10_JPRB, 0.80648405E-10_JPRB, 0.80368531E-10_JPRB, &
  & 0.80111702E-10_JPRB, 0.79858863E-10_JPRB, 0.79573431E-10_JPRB, 0.79067794E-10_JPRB /)

RGHG9(:,48,11) = (/ &
  & 0.77566335E-10_JPRB, 0.78065984E-10_JPRB, 0.78409064E-10_JPRB, 0.78825453E-10_JPRB, 0.79371010E-10_JPRB, 0.80027811E-10_JPRB, &
  & 0.80601317E-10_JPRB, 0.81050597E-10_JPRB, 0.81391768E-10_JPRB, 0.81652823E-10_JPRB, 0.81872883E-10_JPRB, 0.82077081E-10_JPRB, &
  & 0.82298390E-10_JPRB, 0.82576931E-10_JPRB, 0.82970367E-10_JPRB, 0.83523514E-10_JPRB, 0.84182945E-10_JPRB, 0.84786130E-10_JPRB, &
  & 0.85259896E-10_JPRB, 0.85616764E-10_JPRB, 0.85900093E-10_JPRB, 0.86136209E-10_JPRB, 0.86343571E-10_JPRB, 0.86531469E-10_JPRB, &
  & 0.86706350E-10_JPRB, 0.86872606E-10_JPRB, 0.87032256E-10_JPRB, 0.87183601E-10_JPRB, 0.87321830E-10_JPRB, 0.87439486E-10_JPRB, &
  & 0.87531579E-10_JPRB, 0.87601509E-10_JPRB, 0.87641595E-10_JPRB, 0.87653843E-10_JPRB, 0.87639583E-10_JPRB, 0.87603917E-10_JPRB, &
  & 0.87552063E-10_JPRB, 0.87487712E-10_JPRB, 0.87413146E-10_JPRB, 0.87328249E-10_JPRB, 0.87231146E-10_JPRB, 0.87119034E-10_JPRB, &
  & 0.86988985E-10_JPRB, 0.86838023E-10_JPRB, 0.86659478E-10_JPRB, 0.86440792E-10_JPRB, 0.86158962E-10_JPRB, 0.85800020E-10_JPRB, &
  & 0.85360781E-10_JPRB, 0.84873046E-10_JPRB, 0.84384201E-10_JPRB, 0.83931632E-10_JPRB, 0.83558521E-10_JPRB, 0.83240498E-10_JPRB, &
  & 0.82969215E-10_JPRB, 0.82714349E-10_JPRB, 0.82464369E-10_JPRB, 0.82213583E-10_JPRB, 0.81970986E-10_JPRB, 0.81749829E-10_JPRB, &
  & 0.81547845E-10_JPRB, 0.81352682E-10_JPRB, 0.81129131E-10_JPRB, 0.80736251E-10_JPRB /)

RGHG9(:,49,11) = (/ &
  & 0.79424411E-10_JPRB, 0.79890448E-10_JPRB, 0.80216583E-10_JPRB, 0.80597896E-10_JPRB, 0.81128444E-10_JPRB, 0.81740933E-10_JPRB, &
  & 0.82289564E-10_JPRB, 0.82694102E-10_JPRB, 0.82981275E-10_JPRB, 0.83194590E-10_JPRB, 0.83363497E-10_JPRB, 0.83517596E-10_JPRB, &
  & 0.83681229E-10_JPRB, 0.83878529E-10_JPRB, 0.84156411E-10_JPRB, 0.84518018E-10_JPRB, 0.84944898E-10_JPRB, 0.85327134E-10_JPRB, &
  & 0.85634021E-10_JPRB, 0.85881600E-10_JPRB, 0.86091467E-10_JPRB, 0.86280739E-10_JPRB, 0.86456800E-10_JPRB, 0.86624513E-10_JPRB, &
  & 0.86786578E-10_JPRB, 0.86944535E-10_JPRB, 0.87099182E-10_JPRB, 0.87246640E-10_JPRB, 0.87380873E-10_JPRB, 0.87494428E-10_JPRB, &
  & 0.87582573E-10_JPRB, 0.87648347E-10_JPRB, 0.87685872E-10_JPRB, 0.87696066E-10_JPRB, 0.87680675E-10_JPRB, 0.87644780E-10_JPRB, &
  & 0.87593634E-10_JPRB, 0.87531579E-10_JPRB, 0.87460983E-10_JPRB, 0.87382671E-10_JPRB, 0.87295435E-10_JPRB, 0.87197805E-10_JPRB, &
  & 0.87089114E-10_JPRB, 0.86968641E-10_JPRB, 0.86834755E-10_JPRB, 0.86679434E-10_JPRB, 0.86489274E-10_JPRB, 0.86242999E-10_JPRB, &
  & 0.85931227E-10_JPRB, 0.85563841E-10_JPRB, 0.85174631E-10_JPRB, 0.84818867E-10_JPRB, 0.84509927E-10_JPRB, 0.84255991E-10_JPRB, &
  & 0.84030637E-10_JPRB, 0.83819562E-10_JPRB, 0.83610854E-10_JPRB, 0.83402257E-10_JPRB, 0.83204561E-10_JPRB, 0.83026350E-10_JPRB, &
  & 0.82867158E-10_JPRB, 0.82712795E-10_JPRB, 0.82536311E-10_JPRB, 0.82223228E-10_JPRB /)

RGHG9(:,50,11) = (/ &
  & 0.81146923E-10_JPRB, 0.81582401E-10_JPRB, 0.81882529E-10_JPRB, 0.82239153E-10_JPRB, 0.82731100E-10_JPRB, 0.83315729E-10_JPRB, &
  & 0.83806760E-10_JPRB, 0.84153254E-10_JPRB, 0.84380933E-10_JPRB, 0.84535282E-10_JPRB, 0.84651904E-10_JPRB, 0.84751789E-10_JPRB, &
  & 0.84849801E-10_JPRB, 0.84968269E-10_JPRB, 0.85107976E-10_JPRB, 0.85307518E-10_JPRB, 0.85524858E-10_JPRB, 0.85740456E-10_JPRB, &
  & 0.85926800E-10_JPRB, 0.86092716E-10_JPRB, 0.86249369E-10_JPRB, 0.86402059E-10_JPRB, 0.86554097E-10_JPRB, 0.86706808E-10_JPRB, &
  & 0.86859533E-10_JPRB, 0.87012175E-10_JPRB, 0.87162610E-10_JPRB, 0.87306197E-10_JPRB, 0.87436287E-10_JPRB, 0.87545235E-10_JPRB, &
  & 0.87629820E-10_JPRB, 0.87691680E-10_JPRB, 0.87726625E-10_JPRB, 0.87734840E-10_JPRB, 0.87718333E-10_JPRB, 0.87682007E-10_JPRB, &
  & 0.87631485E-10_JPRB, 0.87571131E-10_JPRB, 0.87503879E-10_JPRB, 0.87430660E-10_JPRB, 0.87350988E-10_JPRB, 0.87264564E-10_JPRB, &
  & 0.87171867E-10_JPRB, 0.87074764E-10_JPRB, 0.86973997E-10_JPRB, 0.86867541E-10_JPRB, 0.86745736E-10_JPRB, 0.86595113E-10_JPRB, &
  & 0.86402260E-10_JPRB, 0.86164874E-10_JPRB, 0.85904041E-10_JPRB, 0.85646844E-10_JPRB, 0.85422967E-10_JPRB, 0.85224987E-10_JPRB, &
  & 0.85045818E-10_JPRB, 0.84874177E-10_JPRB, 0.84700191E-10_JPRB, 0.84526448E-10_JPRB, 0.84363239E-10_JPRB, 0.84218146E-10_JPRB, &
  & 0.84089777E-10_JPRB, 0.83964349E-10_JPRB, 0.83820763E-10_JPRB, 0.83558938E-10_JPRB /)

RGHG9(:,51,11) = (/ &
  & 0.82701485E-10_JPRB, 0.83093629E-10_JPRB, 0.83368444E-10_JPRB, 0.83693712E-10_JPRB, 0.84137794E-10_JPRB, 0.84646012E-10_JPRB, &
  & 0.85056621E-10_JPRB, 0.85307914E-10_JPRB, 0.85456899E-10_JPRB, 0.85549581E-10_JPRB, 0.85612309E-10_JPRB, 0.85660652E-10_JPRB, &
  & 0.85704693E-10_JPRB, 0.85746424E-10_JPRB, 0.85801456E-10_JPRB, 0.85864274E-10_JPRB, 0.85954105E-10_JPRB, 0.86052339E-10_JPRB, &
  & 0.86156242E-10_JPRB, 0.86265425E-10_JPRB, 0.86381277E-10_JPRB, 0.86506073E-10_JPRB, 0.86640028E-10_JPRB, 0.86780853E-10_JPRB, &
  & 0.86927639E-10_JPRB, 0.87076055E-10_JPRB, 0.87223458E-10_JPRB, 0.87362603E-10_JPRB, 0.87487934E-10_JPRB, 0.87592565E-10_JPRB, &
  & 0.87673563E-10_JPRB, 0.87731988E-10_JPRB, 0.87764358E-10_JPRB, 0.87770680E-10_JPRB, 0.87753096E-10_JPRB, 0.87716376E-10_JPRB, &
  & 0.87666235E-10_JPRB, 0.87607463E-10_JPRB, 0.87542841E-10_JPRB, 0.87473653E-10_JPRB, 0.87399851E-10_JPRB, 0.87321643E-10_JPRB, &
  & 0.87241270E-10_JPRB, 0.87161597E-10_JPRB, 0.87086408E-10_JPRB, 0.87014972E-10_JPRB, 0.86943008E-10_JPRB, 0.86860692E-10_JPRB, &
  & 0.86758684E-10_JPRB, 0.86633922E-10_JPRB, 0.86492612E-10_JPRB, 0.86350267E-10_JPRB, 0.86212745E-10_JPRB, 0.86085930E-10_JPRB, &
  & 0.85962765E-10_JPRB, 0.85834603E-10_JPRB, 0.85701640E-10_JPRB, 0.85564923E-10_JPRB, 0.85434548E-10_JPRB, 0.85319606E-10_JPRB, &
  & 0.85216320E-10_JPRB, 0.85115540E-10_JPRB, 0.84993214E-10_JPRB, 0.84771967E-10_JPRB /)

RGHG9(:,52,11) = (/ &
  & 0.84020048E-10_JPRB, 0.84370441E-10_JPRB, 0.84603789E-10_JPRB, 0.84879298E-10_JPRB, 0.85248399E-10_JPRB, 0.85646212E-10_JPRB, &
  & 0.85917239E-10_JPRB, 0.86068666E-10_JPRB, 0.86147034E-10_JPRB, 0.86190083E-10_JPRB, 0.86215979E-10_JPRB, 0.86232313E-10_JPRB, &
  & 0.86242416E-10_JPRB, 0.86248557E-10_JPRB, 0.86250083E-10_JPRB, 0.86252061E-10_JPRB, 0.86262490E-10_JPRB, 0.86291752E-10_JPRB, &
  & 0.86340754E-10_JPRB, 0.86408596E-10_JPRB, 0.86494957E-10_JPRB, 0.86598381E-10_JPRB, 0.86716981E-10_JPRB, 0.86850298E-10_JPRB, &
  & 0.86991400E-10_JPRB, 0.87137589E-10_JPRB, 0.87280586E-10_JPRB, 0.87416033E-10_JPRB, 0.87536020E-10_JPRB, 0.87636502E-10_JPRB, &
  & 0.87714273E-10_JPRB, 0.87769493E-10_JPRB, 0.87799483E-10_JPRB, 0.87803993E-10_JPRB, 0.87785341E-10_JPRB, 0.87748322E-10_JPRB, &
  & 0.87698598E-10_JPRB, 0.87641110E-10_JPRB, 0.87578805E-10_JPRB, 0.87512844E-10_JPRB, 0.87443330E-10_JPRB, 0.87371645E-10_JPRB, &
  & 0.87300230E-10_JPRB, 0.87234733E-10_JPRB, 0.87178438E-10_JPRB, 0.87133530E-10_JPRB, 0.87095171E-10_JPRB, 0.87057084E-10_JPRB, &
  & 0.87012723E-10_JPRB, 0.86959807E-10_JPRB, 0.86900001E-10_JPRB, 0.86836906E-10_JPRB, 0.86774816E-10_JPRB, 0.86710805E-10_JPRB, &
  & 0.86642277E-10_JPRB, 0.86567670E-10_JPRB, 0.86481697E-10_JPRB, 0.86389798E-10_JPRB, 0.86300876E-10_JPRB, 0.86220753E-10_JPRB, &
  & 0.86148616E-10_JPRB, 0.86074252E-10_JPRB, 0.85983824E-10_JPRB, 0.85800700E-10_JPRB /)

RGHG9(:,53,11) = (/ &
  & 0.85068286E-10_JPRB, 0.85343371E-10_JPRB, 0.85536772E-10_JPRB, 0.85747992E-10_JPRB, 0.86016749E-10_JPRB, 0.86273821E-10_JPRB, &
  & 0.86435532E-10_JPRB, 0.86510452E-10_JPRB, 0.86545895E-10_JPRB, 0.86563007E-10_JPRB, 0.86570820E-10_JPRB, 0.86572971E-10_JPRB, &
  & 0.86570154E-10_JPRB, 0.86562035E-10_JPRB, 0.86544251E-10_JPRB, 0.86520263E-10_JPRB, 0.86492320E-10_JPRB, 0.86480184E-10_JPRB, &
  & 0.86492737E-10_JPRB, 0.86531900E-10_JPRB, 0.86595321E-10_JPRB, 0.86681655E-10_JPRB, 0.86790138E-10_JPRB, 0.86914843E-10_JPRB, &
  & 0.87053427E-10_JPRB, 0.87194883E-10_JPRB, 0.87335486E-10_JPRB, 0.87465174E-10_JPRB, 0.87581241E-10_JPRB, 0.87677483E-10_JPRB, &
  & 0.87752215E-10_JPRB, 0.87804514E-10_JPRB, 0.87832172E-10_JPRB, 0.87835093E-10_JPRB, 0.87815505E-10_JPRB, 0.87778271E-10_JPRB, &
  & 0.87728963E-10_JPRB, 0.87672744E-10_JPRB, 0.87612334E-10_JPRB, 0.87548954E-10_JPRB, 0.87483118E-10_JPRB, 0.87415901E-10_JPRB, &
  & 0.87352466E-10_JPRB, 0.87297294E-10_JPRB, 0.87257035E-10_JPRB, 0.87230591E-10_JPRB, 0.87214860E-10_JPRB, 0.87203023E-10_JPRB, &
  & 0.87190061E-10_JPRB, 0.87173366E-10_JPRB, 0.87153118E-10_JPRB, 0.87130275E-10_JPRB, 0.87104865E-10_JPRB, 0.87076985E-10_JPRB, &
  & 0.87044996E-10_JPRB, 0.87005139E-10_JPRB, 0.86958635E-10_JPRB, 0.86906080E-10_JPRB, 0.86854468E-10_JPRB, 0.86808366E-10_JPRB, &
  & 0.86766830E-10_JPRB, 0.86724877E-10_JPRB, 0.86670851E-10_JPRB, 0.86556741E-10_JPRB /)

RGHG9(:,54,11) = (/ &
  & 0.85815917E-10_JPRB, 0.86036935E-10_JPRB, 0.86170598E-10_JPRB, 0.86319299E-10_JPRB, 0.86494825E-10_JPRB, 0.86651956E-10_JPRB, &
  & 0.86733717E-10_JPRB, 0.86769758E-10_JPRB, 0.86784135E-10_JPRB, 0.86789520E-10_JPRB, 0.86790179E-10_JPRB, 0.86787445E-10_JPRB, &
  & 0.86781159E-10_JPRB, 0.86768717E-10_JPRB, 0.86749309E-10_JPRB, 0.86713067E-10_JPRB, 0.86670927E-10_JPRB, 0.86634047E-10_JPRB, &
  & 0.86622251E-10_JPRB, 0.86640015E-10_JPRB, 0.86686755E-10_JPRB, 0.86760508E-10_JPRB, 0.86858430E-10_JPRB, 0.86978848E-10_JPRB, &
  & 0.87111124E-10_JPRB, 0.87250623E-10_JPRB, 0.87385391E-10_JPRB, 0.87512129E-10_JPRB, 0.87623166E-10_JPRB, 0.87716064E-10_JPRB, &
  & 0.87787624E-10_JPRB, 0.87837113E-10_JPRB, 0.87862682E-10_JPRB, 0.87864237E-10_JPRB, 0.87843899E-10_JPRB, 0.87806616E-10_JPRB, &
  & 0.87757843E-10_JPRB, 0.87702651E-10_JPRB, 0.87644010E-10_JPRB, 0.87582872E-10_JPRB, 0.87519665E-10_JPRB, 0.87457160E-10_JPRB, &
  & 0.87399102E-10_JPRB, 0.87354152E-10_JPRB, 0.87325092E-10_JPRB, 0.87312782E-10_JPRB, 0.87311214E-10_JPRB, 0.87314100E-10_JPRB, &
  & 0.87316598E-10_JPRB, 0.87316217E-10_JPRB, 0.87312338E-10_JPRB, 0.87305330E-10_JPRB, 0.87295851E-10_JPRB, 0.87283639E-10_JPRB, &
  & 0.87267804E-10_JPRB, 0.87248118E-10_JPRB, 0.87222354E-10_JPRB, 0.87193489E-10_JPRB, 0.87165219E-10_JPRB, 0.87141253E-10_JPRB, &
  & 0.87120713E-10_JPRB, 0.87102381E-10_JPRB, 0.87084222E-10_JPRB, 0.87059818E-10_JPRB /)

RGHG9(:,55,11) = (/ &
  & 0.86334689E-10_JPRB, 0.86487123E-10_JPRB, 0.86586127E-10_JPRB, 0.86682231E-10_JPRB, 0.86792365E-10_JPRB, 0.86879615E-10_JPRB, &
  & 0.86922067E-10_JPRB, 0.86937055E-10_JPRB, 0.86941829E-10_JPRB, 0.86942245E-10_JPRB, 0.86940309E-10_JPRB, 0.86936333E-10_JPRB, &
  & 0.86929491E-10_JPRB, 0.86918625E-10_JPRB, 0.86897656E-10_JPRB, 0.86865876E-10_JPRB, 0.86814139E-10_JPRB, 0.86764089E-10_JPRB, &
  & 0.86735563E-10_JPRB, 0.86738040E-10_JPRB, 0.86771826E-10_JPRB, 0.86835317E-10_JPRB, 0.86926487E-10_JPRB, 0.87039223E-10_JPRB, &
  & 0.87168203E-10_JPRB, 0.87301562E-10_JPRB, 0.87433866E-10_JPRB, 0.87555407E-10_JPRB, 0.87663238E-10_JPRB, 0.87752292E-10_JPRB, &
  & 0.87820883E-10_JPRB, 0.87867609E-10_JPRB, 0.87891222E-10_JPRB, 0.87891680E-10_JPRB, 0.87871002E-10_JPRB, 0.87833726E-10_JPRB, &
  & 0.87785584E-10_JPRB, 0.87731475E-10_JPRB, 0.87674153E-10_JPRB, 0.87614922E-10_JPRB, 0.87554755E-10_JPRB, 0.87495358E-10_JPRB, &
  & 0.87443934E-10_JPRB, 0.87405659E-10_JPRB, 0.87386626E-10_JPRB, 0.87383718E-10_JPRB, 0.87391080E-10_JPRB, 0.87402099E-10_JPRB, &
  & 0.87411800E-10_JPRB, 0.87418218E-10_JPRB, 0.87420730E-10_JPRB, 0.87419946E-10_JPRB, 0.87416546E-10_JPRB, 0.87410981E-10_JPRB, &
  & 0.87403154E-10_JPRB, 0.87391844E-10_JPRB, 0.87377494E-10_JPRB, 0.87360313E-10_JPRB, 0.87343785E-10_JPRB, 0.87329144E-10_JPRB, &
  & 0.87316883E-10_JPRB, 0.87304886E-10_JPRB, 0.87291070E-10_JPRB, 0.87265771E-10_JPRB /)

RGHG9(:,56,11) = (/ &
  & 0.86683015E-10_JPRB, 0.86794842E-10_JPRB, 0.86857278E-10_JPRB, 0.86918563E-10_JPRB, 0.86984968E-10_JPRB, 0.87033172E-10_JPRB, &
  & 0.87052171E-10_JPRB, 0.87057667E-10_JPRB, 0.87058111E-10_JPRB, 0.87056640E-10_JPRB, 0.87054003E-10_JPRB, 0.87050089E-10_JPRB, &
  & 0.87044219E-10_JPRB, 0.87034269E-10_JPRB, 0.87018184E-10_JPRB, 0.86985669E-10_JPRB, 0.86937110E-10_JPRB, 0.86877908E-10_JPRB, &
  & 0.86837260E-10_JPRB, 0.86828621E-10_JPRB, 0.86853025E-10_JPRB, 0.86908571E-10_JPRB, 0.86992281E-10_JPRB, 0.87099626E-10_JPRB, &
  & 0.87222056E-10_JPRB, 0.87351883E-10_JPRB, 0.87478857E-10_JPRB, 0.87597408E-10_JPRB, 0.87701089E-10_JPRB, 0.87786764E-10_JPRB, &
  & 0.87852108E-10_JPRB, 0.87896385E-10_JPRB, 0.87918235E-10_JPRB, 0.87917874E-10_JPRB, 0.87897037E-10_JPRB, 0.87860226E-10_JPRB, &
  & 0.87812729E-10_JPRB, 0.87759536E-10_JPRB, 0.87703574E-10_JPRB, 0.87646182E-10_JPRB, 0.87588159E-10_JPRB, 0.87533231E-10_JPRB, &
  & 0.87486053E-10_JPRB, 0.87455057E-10_JPRB, 0.87442588E-10_JPRB, 0.87446411E-10_JPRB, 0.87459616E-10_JPRB, 0.87474902E-10_JPRB, &
  & 0.87488086E-10_JPRB, 0.87496899E-10_JPRB, 0.87501645E-10_JPRB, 0.87503005E-10_JPRB, 0.87502047E-10_JPRB, 0.87499299E-10_JPRB, &
  & 0.87494734E-10_JPRB, 0.87488274E-10_JPRB, 0.87479080E-10_JPRB, 0.87468394E-10_JPRB, 0.87457666E-10_JPRB, 0.87448750E-10_JPRB, &
  & 0.87440721E-10_JPRB, 0.87433387E-10_JPRB, 0.87425289E-10_JPRB, 0.87412154E-10_JPRB /)

RGHG9(:,57,11) = (/ &
  & 0.86917279E-10_JPRB, 0.87000213E-10_JPRB, 0.87043532E-10_JPRB, 0.87082522E-10_JPRB, 0.87120325E-10_JPRB, 0.87145020E-10_JPRB, &
  & 0.87152854E-10_JPRB, 0.87153562E-10_JPRB, 0.87152216E-10_JPRB, 0.87150197E-10_JPRB, 0.87147588E-10_JPRB, 0.87144153E-10_JPRB, &
  & 0.87139150E-10_JPRB, 0.87131302E-10_JPRB, 0.87116529E-10_JPRB, 0.87090807E-10_JPRB, 0.87041478E-10_JPRB, 0.86979500E-10_JPRB, &
  & 0.86931219E-10_JPRB, 0.86914406E-10_JPRB, 0.86931497E-10_JPRB, 0.86980471E-10_JPRB, 0.87057840E-10_JPRB, 0.87158676E-10_JPRB, &
  & 0.87275714E-10_JPRB, 0.87400087E-10_JPRB, 0.87523350E-10_JPRB, 0.87637522E-10_JPRB, 0.87737470E-10_JPRB, 0.87819446E-10_JPRB, &
  & 0.87881848E-10_JPRB, 0.87923682E-10_JPRB, 0.87944117E-10_JPRB, 0.87943187E-10_JPRB, 0.87922572E-10_JPRB, 0.87886358E-10_JPRB, &
  & 0.87839756E-10_JPRB, 0.87787631E-10_JPRB, 0.87732814E-10_JPRB, 0.87676907E-10_JPRB, 0.87621702E-10_JPRB, 0.87569708E-10_JPRB, &
  & 0.87527971E-10_JPRB, 0.87501707E-10_JPRB, 0.87494706E-10_JPRB, 0.87503255E-10_JPRB, 0.87519894E-10_JPRB, 0.87537901E-10_JPRB, &
  & 0.87552215E-10_JPRB, 0.87561930E-10_JPRB, 0.87566940E-10_JPRB, 0.87568744E-10_JPRB, 0.87568508E-10_JPRB, 0.87566870E-10_JPRB, &
  & 0.87563991E-10_JPRB, 0.87559432E-10_JPRB, 0.87553312E-10_JPRB, 0.87545769E-10_JPRB, 0.87538470E-10_JPRB, 0.87531801E-10_JPRB, &
  & 0.87526209E-10_JPRB, 0.87520463E-10_JPRB, 0.87513774E-10_JPRB, 0.87501409E-10_JPRB /)

RGHG9(:,58,11) = (/ &
  & 0.87118320E-10_JPRB, 0.87157524E-10_JPRB, 0.87181165E-10_JPRB, 0.87201919E-10_JPRB, 0.87223388E-10_JPRB, 0.87234643E-10_JPRB, &
  & 0.87236551E-10_JPRB, 0.87235316E-10_JPRB, 0.87233526E-10_JPRB, 0.87231528E-10_JPRB, 0.87229300E-10_JPRB, 0.87226476E-10_JPRB, &
  & 0.87222396E-10_JPRB, 0.87215721E-10_JPRB, 0.87203904E-10_JPRB, 0.87179458E-10_JPRB, 0.87135577E-10_JPRB, 0.87071676E-10_JPRB, &
  & 0.87018850E-10_JPRB, 0.86996903E-10_JPRB, 0.87008512E-10_JPRB, 0.87051595E-10_JPRB, 0.87123059E-10_JPRB, 0.87217657E-10_JPRB, &
  & 0.87328908E-10_JPRB, 0.87448243E-10_JPRB, 0.87566711E-10_JPRB, 0.87676630E-10_JPRB, 0.87772442E-10_JPRB, 0.87850852E-10_JPRB, &
  & 0.87910138E-10_JPRB, 0.87950015E-10_JPRB, 0.87969174E-10_JPRB, 0.87967966E-10_JPRB, 0.87947788E-10_JPRB, 0.87912497E-10_JPRB, &
  & 0.87867061E-10_JPRB, 0.87815949E-10_JPRB, 0.87762353E-10_JPRB, 0.87708105E-10_JPRB, 0.87654842E-10_JPRB, 0.87606651E-10_JPRB, &
  & 0.87568577E-10_JPRB, 0.87547067E-10_JPRB, 0.87543882E-10_JPRB, 0.87555373E-10_JPRB, 0.87574586E-10_JPRB, 0.87593800E-10_JPRB, &
  & 0.87608948E-10_JPRB, 0.87618079E-10_JPRB, 0.87622701E-10_JPRB, 0.87624200E-10_JPRB, 0.87623950E-10_JPRB, 0.87622597E-10_JPRB, &
  & 0.87620231E-10_JPRB, 0.87616803E-10_JPRB, 0.87611918E-10_JPRB, 0.87606145E-10_JPRB, 0.87600253E-10_JPRB, 0.87595292E-10_JPRB, &
  & 0.87590574E-10_JPRB, 0.87586112E-10_JPRB, 0.87580693E-10_JPRB, 0.87571048E-10_JPRB /)

RGHG9(:,59,11) = (/ &
  & 0.87236524E-10_JPRB, 0.87268484E-10_JPRB, 0.87283486E-10_JPRB, 0.87296670E-10_JPRB, 0.87306794E-10_JPRB, 0.87311096E-10_JPRB, &
  & 0.87310326E-10_JPRB, 0.87308577E-10_JPRB, 0.87306801E-10_JPRB, 0.87305219E-10_JPRB, 0.87303470E-10_JPRB, 0.87301257E-10_JPRB, &
  & 0.87298023E-10_JPRB, 0.87292465E-10_JPRB, 0.87282001E-10_JPRB, 0.87260831E-10_JPRB, 0.87218129E-10_JPRB, 0.87156275E-10_JPRB, &
  & 0.87102145E-10_JPRB, 0.87077102E-10_JPRB, 0.87084409E-10_JPRB, 0.87122511E-10_JPRB, 0.87188222E-10_JPRB, 0.87277123E-10_JPRB, &
  & 0.87382400E-10_JPRB, 0.87496371E-10_JPRB, 0.87609690E-10_JPRB, 0.87714974E-10_JPRB, 0.87806387E-10_JPRB, 0.87880932E-10_JPRB, &
  & 0.87937643E-10_JPRB, 0.87975426E-10_JPRB, 0.87993661E-10_JPRB, 0.87992350E-10_JPRB, 0.87972837E-10_JPRB, 0.87938781E-10_JPRB, &
  & 0.87894608E-10_JPRB, 0.87844801E-10_JPRB, 0.87792384E-10_JPRB, 0.87739517E-10_JPRB, 0.87688627E-10_JPRB, 0.87643073E-10_JPRB, &
  & 0.87609010E-10_JPRB, 0.87591011E-10_JPRB, 0.87590754E-10_JPRB, 0.87604375E-10_JPRB, 0.87624845E-10_JPRB, 0.87645134E-10_JPRB, &
  & 0.87659921E-10_JPRB, 0.87668664E-10_JPRB, 0.87672321E-10_JPRB, 0.87673133E-10_JPRB, 0.87672480E-10_JPRB, 0.87670968E-10_JPRB, &
  & 0.87668720E-10_JPRB, 0.87665472E-10_JPRB, 0.87661226E-10_JPRB, 0.87656146E-10_JPRB, 0.87651233E-10_JPRB, 0.87646654E-10_JPRB, &
  & 0.87642754E-10_JPRB, 0.87638563E-10_JPRB, 0.87633581E-10_JPRB, 0.87624144E-10_JPRB /)

RGHG9(:,60,11) = (/ &
  & 0.87339802E-10_JPRB, 0.87358440E-10_JPRB, 0.87367863E-10_JPRB, 0.87374254E-10_JPRB, 0.87379069E-10_JPRB, 0.87379548E-10_JPRB, &
  & 0.87377758E-10_JPRB, 0.87375933E-10_JPRB, 0.87374663E-10_JPRB, 0.87373588E-10_JPRB, 0.87372512E-10_JPRB, 0.87371055E-10_JPRB, &
  & 0.87368612E-10_JPRB, 0.87364199E-10_JPRB, 0.87354818E-10_JPRB, 0.87334903E-10_JPRB, 0.87294283E-10_JPRB, 0.87234615E-10_JPRB, &
  & 0.87181935E-10_JPRB, 0.87155602E-10_JPRB, 0.87159620E-10_JPRB, 0.87193322E-10_JPRB, 0.87253989E-10_JPRB, 0.87337061E-10_JPRB, &
  & 0.87436641E-10_JPRB, 0.87544770E-10_JPRB, 0.87652774E-10_JPRB, 0.87752833E-10_JPRB, 0.87839541E-10_JPRB, 0.87910478E-10_JPRB, &
  & 0.87964150E-10_JPRB, 0.88000281E-10_JPRB, 0.88017607E-10_JPRB, 0.88016414E-10_JPRB, 0.87997776E-10_JPRB, 0.87965045E-10_JPRB, &
  & 0.87922433E-10_JPRB, 0.87873958E-10_JPRB, 0.87822812E-10_JPRB, 0.87771498E-10_JPRB, 0.87722392E-10_JPRB, 0.87679836E-10_JPRB, &
  & 0.87648833E-10_JPRB, 0.87634039E-10_JPRB, 0.87636037E-10_JPRB, 0.87650845E-10_JPRB, 0.87672106E-10_JPRB, 0.87692555E-10_JPRB, &
  & 0.87707473E-10_JPRB, 0.87715148E-10_JPRB, 0.87717833E-10_JPRB, 0.87717833E-10_JPRB, 0.87716612E-10_JPRB, 0.87714676E-10_JPRB, &
  & 0.87712101E-10_JPRB, 0.87708785E-10_JPRB, 0.87704517E-10_JPRB, 0.87699681E-10_JPRB, 0.87694858E-10_JPRB, 0.87690771E-10_JPRB, &
  & 0.87686809E-10_JPRB, 0.87683007E-10_JPRB, 0.87678260E-10_JPRB, 0.87669670E-10_JPRB /)

RGHG9(:,61,11) = (/ &
  & 0.87415908E-10_JPRB, 0.87432686E-10_JPRB, 0.87438910E-10_JPRB, 0.87442692E-10_JPRB, 0.87444017E-10_JPRB, 0.87442636E-10_JPRB, &
  & 0.87440472E-10_JPRB, 0.87439028E-10_JPRB, 0.87438279E-10_JPRB, 0.87437960E-10_JPRB, 0.87437738E-10_JPRB, 0.87437210E-10_JPRB, &
  & 0.87435836E-10_JPRB, 0.87432284E-10_JPRB, 0.87424117E-10_JPRB, 0.87404403E-10_JPRB, 0.87365025E-10_JPRB, 0.87309021E-10_JPRB, &
  & 0.87259193E-10_JPRB, 0.87232749E-10_JPRB, 0.87234463E-10_JPRB, 0.87264494E-10_JPRB, 0.87320373E-10_JPRB, 0.87398019E-10_JPRB, &
  & 0.87491625E-10_JPRB, 0.87593932E-10_JPRB, 0.87696017E-10_JPRB, 0.87790636E-10_JPRB, 0.87872508E-10_JPRB, 0.87939371E-10_JPRB, &
  & 0.87990407E-10_JPRB, 0.88024560E-10_JPRB, 0.88041185E-10_JPRB, 0.88040172E-10_JPRB, 0.88022534E-10_JPRB, 0.87991309E-10_JPRB, &
  & 0.87950293E-10_JPRB, 0.87903289E-10_JPRB, 0.87853523E-10_JPRB, 0.87803598E-10_JPRB, 0.87756635E-10_JPRB, 0.87716459E-10_JPRB, &
  & 0.87688516E-10_JPRB, 0.87676338E-10_JPRB, 0.87680065E-10_JPRB, 0.87695649E-10_JPRB, 0.87716959E-10_JPRB, 0.87737567E-10_JPRB, &
  & 0.87751945E-10_JPRB, 0.87759008E-10_JPRB, 0.87760674E-10_JPRB, 0.87759744E-10_JPRB, 0.87757718E-10_JPRB, 0.87755185E-10_JPRB, &
  & 0.87752090E-10_JPRB, 0.87748253E-10_JPRB, 0.87743673E-10_JPRB, 0.87738636E-10_JPRB, 0.87733890E-10_JPRB, 0.87729490E-10_JPRB, &
  & 0.87725716E-10_JPRB, 0.87721663E-10_JPRB, 0.87716875E-10_JPRB, 0.87707917E-10_JPRB /)

RGHG9(:,62,11) = (/ &
  & 0.87487240E-10_JPRB, 0.87499043E-10_JPRB, 0.87503213E-10_JPRB, 0.87504809E-10_JPRB, 0.87504413E-10_JPRB, 0.87502131E-10_JPRB, &
  & 0.87499792E-10_JPRB, 0.87498619E-10_JPRB, 0.87498515E-10_JPRB, 0.87499084E-10_JPRB, 0.87499966E-10_JPRB, 0.87500784E-10_JPRB, &
  & 0.87500805E-10_JPRB, 0.87498654E-10_JPRB, 0.87490945E-10_JPRB, 0.87471475E-10_JPRB, 0.87433033E-10_JPRB, 0.87380929E-10_JPRB, &
  & 0.87334848E-10_JPRB, 0.87309077E-10_JPRB, 0.87309264E-10_JPRB, 0.87336194E-10_JPRB, 0.87387729E-10_JPRB, 0.87460011E-10_JPRB, &
  & 0.87547719E-10_JPRB, 0.87643802E-10_JPRB, 0.87739878E-10_JPRB, 0.87828654E-10_JPRB, 0.87905468E-10_JPRB, 0.87968376E-10_JPRB, &
  & 0.88016303E-10_JPRB, 0.88048652E-10_JPRB, 0.88064479E-10_JPRB, 0.88063667E-10_JPRB, 0.88047084E-10_JPRB, 0.88017427E-10_JPRB, &
  & 0.87978132E-10_JPRB, 0.87932765E-10_JPRB, 0.87884373E-10_JPRB, 0.87836058E-10_JPRB, 0.87790934E-10_JPRB, 0.87753353E-10_JPRB, &
  & 0.87727978E-10_JPRB, 0.87718062E-10_JPRB, 0.87723169E-10_JPRB, 0.87739142E-10_JPRB, 0.87760244E-10_JPRB, 0.87780339E-10_JPRB, &
  & 0.87794619E-10_JPRB, 0.87801051E-10_JPRB, 0.87801794E-10_JPRB, 0.87799809E-10_JPRB, 0.87796923E-10_JPRB, 0.87793467E-10_JPRB, &
  & 0.87789581E-10_JPRB, 0.87785057E-10_JPRB, 0.87779867E-10_JPRB, 0.87774399E-10_JPRB, 0.87769188E-10_JPRB, 0.87764768E-10_JPRB, &
  & 0.87760528E-10_JPRB, 0.87756399E-10_JPRB, 0.87751265E-10_JPRB, 0.87742022E-10_JPRB /)

RGHG9(:,63,11) = (/ &
  & 0.87548704E-10_JPRB, 0.87559515E-10_JPRB, 0.87562547E-10_JPRB, 0.87563179E-10_JPRB, 0.87561867E-10_JPRB, 0.87558891E-10_JPRB, &
  & 0.87556393E-10_JPRB, 0.87555400E-10_JPRB, 0.87555893E-10_JPRB, 0.87557434E-10_JPRB, 0.87559834E-10_JPRB, 0.87562443E-10_JPRB, &
  & 0.87564352E-10_JPRB, 0.87563623E-10_JPRB, 0.87556393E-10_JPRB, 0.87536561E-10_JPRB, 0.87499383E-10_JPRB, 0.87452039E-10_JPRB, &
  & 0.87409510E-10_JPRB, 0.87384953E-10_JPRB, 0.87384308E-10_JPRB, 0.87408664E-10_JPRB, 0.87456160E-10_JPRB, 0.87523239E-10_JPRB, &
  & 0.87605014E-10_JPRB, 0.87694782E-10_JPRB, 0.87784391E-10_JPRB, 0.87867234E-10_JPRB, 0.87938823E-10_JPRB, 0.87997429E-10_JPRB, &
  & 0.88042240E-10_JPRB, 0.88072494E-10_JPRB, 0.88087447E-10_JPRB, 0.88086788E-10_JPRB, 0.88071321E-10_JPRB, 0.88043371E-10_JPRB, &
  & 0.88005929E-10_JPRB, 0.87962262E-10_JPRB, 0.87915474E-10_JPRB, 0.87868768E-10_JPRB, 0.87825712E-10_JPRB, 0.87790428E-10_JPRB, &
  & 0.87767446E-10_JPRB, 0.87759404E-10_JPRB, 0.87765538E-10_JPRB, 0.87781657E-10_JPRB, 0.87802224E-10_JPRB, 0.87821792E-10_JPRB, &
  & 0.87835628E-10_JPRB, 0.87841838E-10_JPRB, 0.87841914E-10_JPRB, 0.87839014E-10_JPRB, 0.87834920E-10_JPRB, 0.87830479E-10_JPRB, &
  & 0.87825525E-10_JPRB, 0.87819987E-10_JPRB, 0.87813923E-10_JPRB, 0.87807775E-10_JPRB, 0.87802182E-10_JPRB, 0.87797110E-10_JPRB, &
  & 0.87792648E-10_JPRB, 0.87787867E-10_JPRB, 0.87782198E-10_JPRB, 0.87771811E-10_JPRB /)

RGHG9(:,64,11) = (/ &
  & 0.87605860E-10_JPRB, 0.87615831E-10_JPRB, 0.87618496E-10_JPRB, 0.87618676E-10_JPRB, 0.87616941E-10_JPRB, 0.87613770E-10_JPRB, &
  & 0.87610919E-10_JPRB, 0.87609933E-10_JPRB, 0.87610905E-10_JPRB, 0.87613528E-10_JPRB, 0.87617545E-10_JPRB, 0.87622465E-10_JPRB, &
  & 0.87626496E-10_JPRB, 0.87627100E-10_JPRB, 0.87620092E-10_JPRB, 0.87600066E-10_JPRB, 0.87565510E-10_JPRB, 0.87522066E-10_JPRB, &
  & 0.87483104E-10_JPRB, 0.87460164E-10_JPRB, 0.87459227E-10_JPRB, 0.87481508E-10_JPRB, 0.87525244E-10_JPRB, 0.87587305E-10_JPRB, &
  & 0.87663071E-10_JPRB, 0.87746241E-10_JPRB, 0.87829334E-10_JPRB, 0.87905870E-10_JPRB, 0.87972102E-10_JPRB, 0.88026281E-10_JPRB, &
  & 0.88067720E-10_JPRB, 0.88095774E-10_JPRB, 0.88109679E-10_JPRB, 0.88109152E-10_JPRB, 0.88094851E-10_JPRB, 0.88068726E-10_JPRB, &
  & 0.88033310E-10_JPRB, 0.87991572E-10_JPRB, 0.87946511E-10_JPRB, 0.87901644E-10_JPRB, 0.87860587E-10_JPRB, 0.87827558E-10_JPRB, &
  & 0.87806679E-10_JPRB, 0.87800177E-10_JPRB, 0.87807026E-10_JPRB, 0.87823054E-10_JPRB, 0.87843011E-10_JPRB, 0.87861676E-10_JPRB, &
  & 0.87875138E-10_JPRB, 0.87881244E-10_JPRB, 0.87881036E-10_JPRB, 0.87877233E-10_JPRB, 0.87872161E-10_JPRB, 0.87866381E-10_JPRB, &
  & 0.87860226E-10_JPRB, 0.87853502E-10_JPRB, 0.87846459E-10_JPRB, 0.87839486E-10_JPRB, 0.87833074E-10_JPRB, 0.87827565E-10_JPRB, &
  & 0.87822270E-10_JPRB, 0.87816934E-10_JPRB, 0.87810204E-10_JPRB, 0.87797998E-10_JPRB /)

RGHG9(:,65,11) = (/ &
  & 0.87659047E-10_JPRB, 0.87669233E-10_JPRB, 0.87671793E-10_JPRB, 0.87671953E-10_JPRB, 0.87670204E-10_JPRB, 0.87666908E-10_JPRB, &
  & 0.87664001E-10_JPRB, 0.87662960E-10_JPRB, 0.87664383E-10_JPRB, 0.87668206E-10_JPRB, 0.87674028E-10_JPRB, 0.87681029E-10_JPRB, &
  & 0.87687010E-10_JPRB, 0.87688488E-10_JPRB, 0.87681487E-10_JPRB, 0.87662454E-10_JPRB, 0.87630403E-10_JPRB, 0.87591046E-10_JPRB, &
  & 0.87555581E-10_JPRB, 0.87534577E-10_JPRB, 0.87533744E-10_JPRB, 0.87554221E-10_JPRB, 0.87594466E-10_JPRB, 0.87651511E-10_JPRB, &
  & 0.87721205E-10_JPRB, 0.87797616E-10_JPRB, 0.87873812E-10_JPRB, 0.87944041E-10_JPRB, 0.88004624E-10_JPRB, 0.88054217E-10_JPRB, &
  & 0.88092159E-10_JPRB, 0.88117839E-10_JPRB, 0.88130586E-10_JPRB, 0.88130177E-10_JPRB, 0.88117097E-10_JPRB, 0.88092915E-10_JPRB, &
  & 0.88059740E-10_JPRB, 0.88020265E-10_JPRB, 0.87977327E-10_JPRB, 0.87934500E-10_JPRB, 0.87895566E-10_JPRB, 0.87864688E-10_JPRB, &
  & 0.87845675E-10_JPRB, 0.87840353E-10_JPRB, 0.87847590E-10_JPRB, 0.87863328E-10_JPRB, 0.87882493E-10_JPRB, 0.87900257E-10_JPRB, &
  & 0.87913066E-10_JPRB, 0.87919123E-10_JPRB, 0.87918901E-10_JPRB, 0.87914682E-10_JPRB, 0.87908500E-10_JPRB, 0.87901617E-10_JPRB, &
  & 0.87894060E-10_JPRB, 0.87886164E-10_JPRB, 0.87877969E-10_JPRB, 0.87870100E-10_JPRB, 0.87862995E-10_JPRB, 0.87856479E-10_JPRB, &
  & 0.87850498E-10_JPRB, 0.87843899E-10_JPRB, 0.87835697E-10_JPRB, 0.87820459E-10_JPRB /)

RGHG9(:,66,11) = (/ &
  & 0.87707078E-10_JPRB, 0.87719193E-10_JPRB, 0.87722704E-10_JPRB, 0.87723336E-10_JPRB, 0.87721885E-10_JPRB, 0.87718915E-10_JPRB, &
  & 0.87715959E-10_JPRB, 0.87715071E-10_JPRB, 0.87717250E-10_JPRB, 0.87722045E-10_JPRB, 0.87729712E-10_JPRB, 0.87738358E-10_JPRB, &
  & 0.87745422E-10_JPRB, 0.87747511E-10_JPRB, 0.87741064E-10_JPRB, 0.87723391E-10_JPRB, 0.87694192E-10_JPRB, 0.87658616E-10_JPRB, &
  & 0.87626649E-10_JPRB, 0.87607831E-10_JPRB, 0.87607331E-10_JPRB, 0.87626212E-10_JPRB, 0.87663009E-10_JPRB, 0.87715044E-10_JPRB, &
  & 0.87778479E-10_JPRB, 0.87847896E-10_JPRB, 0.87917125E-10_JPRB, 0.87980713E-10_JPRB, 0.88035655E-10_JPRB, 0.88080591E-10_JPRB, &
  & 0.88114994E-10_JPRB, 0.88138233E-10_JPRB, 0.88149793E-10_JPRB, 0.88149453E-10_JPRB, 0.88137615E-10_JPRB, 0.88115501E-10_JPRB, &
  & 0.88084831E-10_JPRB, 0.88047916E-10_JPRB, 0.88007532E-10_JPRB, 0.87967099E-10_JPRB, 0.87930510E-10_JPRB, 0.87901741E-10_JPRB, &
  & 0.87884408E-10_JPRB, 0.87879995E-10_JPRB, 0.87887302E-10_JPRB, 0.87902449E-10_JPRB, 0.87920685E-10_JPRB, 0.87937414E-10_JPRB, &
  & 0.87949543E-10_JPRB, 0.87955324E-10_JPRB, 0.87955206E-10_JPRB, 0.87950786E-10_JPRB, 0.87944110E-10_JPRB, 0.87936061E-10_JPRB, &
  & 0.87927492E-10_JPRB, 0.87918312E-10_JPRB, 0.87909249E-10_JPRB, 0.87900437E-10_JPRB, 0.87892318E-10_JPRB, 0.87885074E-10_JPRB, &
  & 0.87877761E-10_JPRB, 0.87869899E-10_JPRB, 0.87859414E-10_JPRB, 0.87839680E-10_JPRB /)

RGHG9(:,67,11) = (/ &
  & 0.87753887E-10_JPRB, 0.87767953E-10_JPRB, 0.87772095E-10_JPRB, 0.87773316E-10_JPRB, 0.87772338E-10_JPRB, 0.87769784E-10_JPRB, &
  & 0.87767280E-10_JPRB, 0.87766766E-10_JPRB, 0.87769535E-10_JPRB, 0.87775870E-10_JPRB, 0.87784467E-10_JPRB, 0.87794209E-10_JPRB, &
  & 0.87801856E-10_JPRB, 0.87804410E-10_JPRB, 0.87798657E-10_JPRB, 0.87782566E-10_JPRB, 0.87756233E-10_JPRB, 0.87724480E-10_JPRB, &
  & 0.87696045E-10_JPRB, 0.87679378E-10_JPRB, 0.87679225E-10_JPRB, 0.87696503E-10_JPRB, 0.87729837E-10_JPRB, 0.87776758E-10_JPRB, &
  & 0.87833942E-10_JPRB, 0.87896260E-10_JPRB, 0.87958404E-10_JPRB, 0.88015546E-10_JPRB, 0.88064805E-10_JPRB, 0.88105113E-10_JPRB, &
  & 0.88136040E-10_JPRB, 0.88156871E-10_JPRB, 0.88167210E-10_JPRB, 0.88166911E-10_JPRB, 0.88156302E-10_JPRB, 0.88136325E-10_JPRB, &
  & 0.88108312E-10_JPRB, 0.88074256E-10_JPRB, 0.88036800E-10_JPRB, 0.87999129E-10_JPRB, 0.87965080E-10_JPRB, 0.87938538E-10_JPRB, &
  & 0.87922732E-10_JPRB, 0.87919005E-10_JPRB, 0.87926104E-10_JPRB, 0.87940440E-10_JPRB, 0.87957593E-10_JPRB, 0.87973219E-10_JPRB, &
  & 0.87984564E-10_JPRB, 0.87989997E-10_JPRB, 0.87989852E-10_JPRB, 0.87985536E-10_JPRB, 0.87978402E-10_JPRB, 0.87969992E-10_JPRB, &
  & 0.87960417E-10_JPRB, 0.87950563E-10_JPRB, 0.87940502E-10_JPRB, 0.87930913E-10_JPRB, 0.87922086E-10_JPRB, 0.87913635E-10_JPRB, &
  & 0.87905461E-10_JPRB, 0.87895663E-10_JPRB, 0.87882451E-10_JPRB, 0.87856486E-10_JPRB /)

RGHG9(:,68,11) = (/ &
  & 0.87797096E-10_JPRB, 0.87814298E-10_JPRB, 0.87820057E-10_JPRB, 0.87822138E-10_JPRB, 0.87821861E-10_JPRB, 0.87819980E-10_JPRB, &
  & 0.87818072E-10_JPRB, 0.87818190E-10_JPRB, 0.87821972E-10_JPRB, 0.87828932E-10_JPRB, 0.87838521E-10_JPRB, 0.87848513E-10_JPRB, &
  & 0.87856326E-10_JPRB, 0.87859164E-10_JPRB, 0.87854099E-10_JPRB, 0.87839735E-10_JPRB, 0.87816254E-10_JPRB, 0.87788145E-10_JPRB, &
  & 0.87762998E-10_JPRB, 0.87748378E-10_JPRB, 0.87748454E-10_JPRB, 0.87764032E-10_JPRB, 0.87793869E-10_JPRB, 0.87835773E-10_JPRB, &
  & 0.87886642E-10_JPRB, 0.87942098E-10_JPRB, 0.87997387E-10_JPRB, 0.88048180E-10_JPRB, 0.88091992E-10_JPRB, 0.88127824E-10_JPRB, &
  & 0.88155344E-10_JPRB, 0.88173836E-10_JPRB, 0.88182982E-10_JPRB, 0.88182725E-10_JPRB, 0.88173309E-10_JPRB, 0.88155414E-10_JPRB, &
  & 0.88130142E-10_JPRB, 0.88099125E-10_JPRB, 0.88064833E-10_JPRB, 0.88030160E-10_JPRB, 0.87998955E-10_JPRB, 0.87974718E-10_JPRB, &
  & 0.87960479E-10_JPRB, 0.87957308E-10_JPRB, 0.87964025E-10_JPRB, 0.87977396E-10_JPRB, 0.87993259E-10_JPRB, 0.88007740E-10_JPRB, &
  & 0.88018218E-10_JPRB, 0.88023228E-10_JPRB, 0.88023019E-10_JPRB, 0.88018710E-10_JPRB, 0.88011695E-10_JPRB, 0.88002862E-10_JPRB, &
  & 0.87993113E-10_JPRB, 0.87982607E-10_JPRB, 0.87972143E-10_JPRB, 0.87961985E-10_JPRB, 0.87952340E-10_JPRB, 0.87943507E-10_JPRB, &
  & 0.87933896E-10_JPRB, 0.87922898E-10_JPRB, 0.87906481E-10_JPRB, 0.87873965E-10_JPRB /)

RGHG9(:,69,11) = (/ &
  & 0.87838854E-10_JPRB, 0.87860039E-10_JPRB, 0.87867193E-10_JPRB, 0.87870308E-10_JPRB, 0.87870849E-10_JPRB, 0.87869829E-10_JPRB, &
  & 0.87868782E-10_JPRB, 0.87869712E-10_JPRB, 0.87874215E-10_JPRB, 0.87881889E-10_JPRB, 0.87891562E-10_JPRB, 0.87901436E-10_JPRB, &
  & 0.87909006E-10_JPRB, 0.87911900E-10_JPRB, 0.87907397E-10_JPRB, 0.87894650E-10_JPRB, 0.87873882E-10_JPRB, 0.87849172E-10_JPRB, &
  & 0.87827079E-10_JPRB, 0.87814193E-10_JPRB, 0.87814332E-10_JPRB, 0.87828141E-10_JPRB, 0.87854529E-10_JPRB, 0.87891527E-10_JPRB, &
  & 0.87936429E-10_JPRB, 0.87985244E-10_JPRB, 0.88033955E-10_JPRB, 0.88078780E-10_JPRB, 0.88117347E-10_JPRB, 0.88148912E-10_JPRB, &
  & 0.88173156E-10_JPRB, 0.88189407E-10_JPRB, 0.88197429E-10_JPRB, 0.88197151E-10_JPRB, 0.88188845E-10_JPRB, 0.88173011E-10_JPRB, &
  & 0.88150424E-10_JPRB, 0.88122482E-10_JPRB, 0.88091479E-10_JPRB, 0.88060080E-10_JPRB, 0.88031825E-10_JPRB, 0.88010016E-10_JPRB, &
  & 0.87997366E-10_JPRB, 0.87994750E-10_JPRB, 0.88001072E-10_JPRB, 0.88013333E-10_JPRB, 0.88027891E-10_JPRB, 0.88041151E-10_JPRB, &
  & 0.88050685E-10_JPRB, 0.88055209E-10_JPRB, 0.88054883E-10_JPRB, 0.88050740E-10_JPRB, 0.88043753E-10_JPRB, 0.88035156E-10_JPRB, &
  & 0.88025302E-10_JPRB, 0.88014825E-10_JPRB, 0.88004097E-10_JPRB, 0.87993640E-10_JPRB, 0.87983933E-10_JPRB, 0.87974288E-10_JPRB, &
  & 0.87964573E-10_JPRB, 0.87952000E-10_JPRB, 0.87933202E-10_JPRB, 0.87893935E-10_JPRB /)

RGHG9(:,70,11) = (/ &
  & 0.87879877E-10_JPRB, 0.87904982E-10_JPRB, 0.87914037E-10_JPRB, 0.87918200E-10_JPRB, 0.87919644E-10_JPRB, 0.87919581E-10_JPRB, &
  & 0.87919498E-10_JPRB, 0.87921309E-10_JPRB, 0.87926361E-10_JPRB, 0.87934222E-10_JPRB, 0.87943500E-10_JPRB, 0.87952763E-10_JPRB, &
  & 0.87959723E-10_JPRB, 0.87962436E-10_JPRB, 0.87958384E-10_JPRB, 0.87947143E-10_JPRB, 0.87928810E-10_JPRB, 0.87907098E-10_JPRB, &
  & 0.87887704E-10_JPRB, 0.87876366E-10_JPRB, 0.87876442E-10_JPRB, 0.87888453E-10_JPRB, 0.87911595E-10_JPRB, 0.87943944E-10_JPRB, &
  & 0.87983093E-10_JPRB, 0.88025684E-10_JPRB, 0.88068254E-10_JPRB, 0.88107334E-10_JPRB, 0.88141029E-10_JPRB, 0.88168500E-10_JPRB, &
  & 0.88189643E-10_JPRB, 0.88203743E-10_JPRB, 0.88210675E-10_JPRB, 0.88210383E-10_JPRB, 0.88203153E-10_JPRB, 0.88189255E-10_JPRB, &
  & 0.88169333E-10_JPRB, 0.88144464E-10_JPRB, 0.88116792E-10_JPRB, 0.88088703E-10_JPRB, 0.88063473E-10_JPRB, 0.88044148E-10_JPRB, &
  & 0.88033164E-10_JPRB, 0.88031180E-10_JPRB, 0.88037085E-10_JPRB, 0.88048319E-10_JPRB, 0.88061461E-10_JPRB, 0.88073451E-10_JPRB, &
  & 0.88081993E-10_JPRB, 0.88086004E-10_JPRB, 0.88085525E-10_JPRB, 0.88081577E-10_JPRB, 0.88074950E-10_JPRB, 0.88066686E-10_JPRB, &
  & 0.88057284E-10_JPRB, 0.88047104E-10_JPRB, 0.88036585E-10_JPRB, 0.88026336E-10_JPRB, 0.88016539E-10_JPRB, 0.88007206E-10_JPRB, &
  & 0.87996978E-10_JPRB, 0.87984307E-10_JPRB, 0.87963539E-10_JPRB, 0.87919581E-10_JPRB /)

RGHG9(:,71,11) = (/ &
  & 0.87921379E-10_JPRB, 0.87950348E-10_JPRB, 0.87960715E-10_JPRB, 0.87965871E-10_JPRB, 0.87968147E-10_JPRB, 0.87968993E-10_JPRB, &
  & 0.87969895E-10_JPRB, 0.87972407E-10_JPRB, 0.87977917E-10_JPRB, 0.87985209E-10_JPRB, 0.87993952E-10_JPRB, 0.88002050E-10_JPRB, &
  & 0.88008177E-10_JPRB, 0.88010571E-10_JPRB, 0.88006720E-10_JPRB, 0.87996867E-10_JPRB, 0.87980741E-10_JPRB, 0.87961784E-10_JPRB, &
  & 0.87944776E-10_JPRB, 0.87934750E-10_JPRB, 0.87934715E-10_JPRB, 0.87945082E-10_JPRB, 0.87965010E-10_JPRB, 0.87993057E-10_JPRB, &
  & 0.88026746E-10_JPRB, 0.88063522E-10_JPRB, 0.88100242E-10_JPRB, 0.88134007E-10_JPRB, 0.88163046E-10_JPRB, 0.88186701E-10_JPRB, &
  & 0.88204902E-10_JPRB, 0.88216996E-10_JPRB, 0.88222908E-10_JPRB, 0.88222596E-10_JPRB, 0.88216372E-10_JPRB, 0.88204347E-10_JPRB, &
  & 0.88186972E-10_JPRB, 0.88165114E-10_JPRB, 0.88140766E-10_JPRB, 0.88115973E-10_JPRB, 0.88093817E-10_JPRB, 0.88076949E-10_JPRB, &
  & 0.88067650E-10_JPRB, 0.88066304E-10_JPRB, 0.88071883E-10_JPRB, 0.88082069E-10_JPRB, 0.88093817E-10_JPRB, 0.88104475E-10_JPRB, &
  & 0.88111997E-10_JPRB, 0.88115515E-10_JPRB, 0.88114939E-10_JPRB, 0.88111324E-10_JPRB, 0.88105183E-10_JPRB, 0.88097599E-10_JPRB, &
  & 0.88088987E-10_JPRB, 0.88079426E-10_JPRB, 0.88069572E-10_JPRB, 0.88059844E-10_JPRB, 0.88050484E-10_JPRB, 0.88041463E-10_JPRB, &
  & 0.88031679E-10_JPRB, 0.88018891E-10_JPRB, 0.87997921E-10_JPRB, 0.87951084E-10_JPRB /)

RGHG9(:,72,11) = (/ &
  & 0.87964344E-10_JPRB, 0.87995708E-10_JPRB, 0.88007199E-10_JPRB, 0.88012937E-10_JPRB, 0.88015817E-10_JPRB, 0.88017468E-10_JPRB, &
  & 0.88019127E-10_JPRB, 0.88022284E-10_JPRB, 0.88027446E-10_JPRB, 0.88034566E-10_JPRB, 0.88041678E-10_JPRB, 0.88048902E-10_JPRB, &
  & 0.88053898E-10_JPRB, 0.88055910E-10_JPRB, 0.88052357E-10_JPRB, 0.88043628E-10_JPRB, 0.88029598E-10_JPRB, 0.88013034E-10_JPRB, &
  & 0.87998227E-10_JPRB, 0.87989407E-10_JPRB, 0.87989331E-10_JPRB, 0.87998060E-10_JPRB, 0.88015081E-10_JPRB, 0.88038847E-10_JPRB, &
  & 0.88067567E-10_JPRB, 0.88098744E-10_JPRB, 0.88130156E-10_JPRB, 0.88158841E-10_JPRB, 0.88183572E-10_JPRB, 0.88203569E-10_JPRB, &
  & 0.88219029E-10_JPRB, 0.88229236E-10_JPRB, 0.88234253E-10_JPRB, 0.88233934E-10_JPRB, 0.88228633E-10_JPRB, 0.88218363E-10_JPRB, &
  & 0.88203465E-10_JPRB, 0.88184508E-10_JPRB, 0.88163456E-10_JPRB, 0.88141938E-10_JPRB, 0.88122780E-10_JPRB, 0.88108389E-10_JPRB, &
  & 0.88100666E-10_JPRB, 0.88099937E-10_JPRB, 0.88105148E-10_JPRB, 0.88114342E-10_JPRB, 0.88124660E-10_JPRB, 0.88133979E-10_JPRB, &
  & 0.88140543E-10_JPRB, 0.88143583E-10_JPRB, 0.88142951E-10_JPRB, 0.88139766E-10_JPRB, 0.88134361E-10_JPRB, 0.88127700E-10_JPRB, &
  & 0.88120004E-10_JPRB, 0.88111678E-10_JPRB, 0.88102595E-10_JPRB, 0.88093588E-10_JPRB, 0.88085206E-10_JPRB, 0.88076581E-10_JPRB, &
  & 0.88067470E-10_JPRB, 0.88055514E-10_JPRB, 0.88034448E-10_JPRB, 0.87987180E-10_JPRB /)

RGHG9(:,73,11) = (/ &
  & 0.88009613E-10_JPRB, 0.88041338E-10_JPRB, 0.88052808E-10_JPRB, 0.88058658E-10_JPRB, 0.88061815E-10_JPRB, 0.88063945E-10_JPRB, &
  & 0.88066152E-10_JPRB, 0.88069337E-10_JPRB, 0.88074562E-10_JPRB, 0.88080140E-10_JPRB, 0.88086843E-10_JPRB, 0.88092353E-10_JPRB, &
  & 0.88096565E-10_JPRB, 0.88098140E-10_JPRB, 0.88094934E-10_JPRB, 0.88087190E-10_JPRB, 0.88075006E-10_JPRB, 0.88060781E-10_JPRB, &
  & 0.88048013E-10_JPRB, 0.88040429E-10_JPRB, 0.88040297E-10_JPRB, 0.88047555E-10_JPRB, 0.88061662E-10_JPRB, 0.88081625E-10_JPRB, &
  & 0.88105453E-10_JPRB, 0.88131641E-10_JPRB, 0.88157870E-10_JPRB, 0.88181906E-10_JPRB, 0.88202536E-10_JPRB, 0.88219189E-10_JPRB, &
  & 0.88232137E-10_JPRB, 0.88240609E-10_JPRB, 0.88244773E-10_JPRB, 0.88244433E-10_JPRB, 0.88240026E-10_JPRB, 0.88231443E-10_JPRB, &
  & 0.88218884E-10_JPRB, 0.88202737E-10_JPRB, 0.88184939E-10_JPRB, 0.88166564E-10_JPRB, 0.88150355E-10_JPRB, 0.88138309E-10_JPRB, &
  & 0.88132106E-10_JPRB, 0.88131842E-10_JPRB, 0.88136623E-10_JPRB, 0.88144707E-10_JPRB, 0.88153637E-10_JPRB, 0.88161665E-10_JPRB, &
  & 0.88167307E-10_JPRB, 0.88169944E-10_JPRB, 0.88169402E-10_JPRB, 0.88166779E-10_JPRB, 0.88162172E-10_JPRB, 0.88156468E-10_JPRB, &
  & 0.88150126E-10_JPRB, 0.88142674E-10_JPRB, 0.88134826E-10_JPRB, 0.88127020E-10_JPRB, 0.88119095E-10_JPRB, 0.88111761E-10_JPRB, &
  & 0.88103247E-10_JPRB, 0.88092138E-10_JPRB, 0.88072799E-10_JPRB, 0.88025469E-10_JPRB /)

RGHG9(:,74,11) = (/ &
  & 0.88054411E-10_JPRB, 0.88085608E-10_JPRB, 0.88096662E-10_JPRB, 0.88102234E-10_JPRB, 0.88105329E-10_JPRB, 0.88107646E-10_JPRB, &
  & 0.88109964E-10_JPRB, 0.88113246E-10_JPRB, 0.88117444E-10_JPRB, 0.88122940E-10_JPRB, 0.88127720E-10_JPRB, 0.88132730E-10_JPRB, &
  & 0.88135867E-10_JPRB, 0.88137053E-10_JPRB, 0.88134250E-10_JPRB, 0.88127512E-10_JPRB, 0.88117132E-10_JPRB, 0.88105002E-10_JPRB, &
  & 0.88094247E-10_JPRB, 0.88087787E-10_JPRB, 0.88087738E-10_JPRB, 0.88093588E-10_JPRB, 0.88105023E-10_JPRB, 0.88121302E-10_JPRB, &
  & 0.88140766E-10_JPRB, 0.88162158E-10_JPRB, 0.88183606E-10_JPRB, 0.88203313E-10_JPRB, 0.88220098E-10_JPRB, 0.88233650E-10_JPRB, &
  & 0.88244266E-10_JPRB, 0.88251115E-10_JPRB, 0.88254543E-10_JPRB, 0.88254237E-10_JPRB, 0.88250643E-10_JPRB, 0.88243607E-10_JPRB, &
  & 0.88233275E-10_JPRB, 0.88219869E-10_JPRB, 0.88205200E-10_JPRB, 0.88189900E-10_JPRB, 0.88176480E-10_JPRB, 0.88166710E-10_JPRB, &
  & 0.88161839E-10_JPRB, 0.88161915E-10_JPRB, 0.88166113E-10_JPRB, 0.88173108E-10_JPRB, 0.88180574E-10_JPRB, 0.88187388E-10_JPRB, &
  & 0.88192210E-10_JPRB, 0.88194507E-10_JPRB, 0.88194098E-10_JPRB, 0.88192106E-10_JPRB, 0.88188318E-10_JPRB, 0.88183634E-10_JPRB, &
  & 0.88178152E-10_JPRB, 0.88172233E-10_JPRB, 0.88165433E-10_JPRB, 0.88158446E-10_JPRB, 0.88152194E-10_JPRB, 0.88145144E-10_JPRB, &
  & 0.88138073E-10_JPRB, 0.88128317E-10_JPRB, 0.88109998E-10_JPRB, 0.88066006E-10_JPRB /)

RGHG9(:,75,11) = (/ &
  & 0.88098057E-10_JPRB, 0.88127880E-10_JPRB, 0.88138226E-10_JPRB, 0.88143229E-10_JPRB, 0.88146011E-10_JPRB, 0.88148197E-10_JPRB, &
  & 0.88150473E-10_JPRB, 0.88153207E-10_JPRB, 0.88157266E-10_JPRB, 0.88161201E-10_JPRB, 0.88165739E-10_JPRB, 0.88169291E-10_JPRB, &
  & 0.88171873E-10_JPRB, 0.88172684E-10_JPRB, 0.88170408E-10_JPRB, 0.88164531E-10_JPRB, 0.88155920E-10_JPRB, 0.88145866E-10_JPRB, &
  & 0.88137019E-10_JPRB, 0.88131759E-10_JPRB, 0.88131807E-10_JPRB, 0.88136359E-10_JPRB, 0.88145304E-10_JPRB, 0.88158175E-10_JPRB, &
  & 0.88173552E-10_JPRB, 0.88190608E-10_JPRB, 0.88207469E-10_JPRB, 0.88223123E-10_JPRB, 0.88236335E-10_JPRB, 0.88247042E-10_JPRB, &
  & 0.88255556E-10_JPRB, 0.88260926E-10_JPRB, 0.88263702E-10_JPRB, 0.88263397E-10_JPRB, 0.88260566E-10_JPRB, 0.88255001E-10_JPRB, &
  & 0.88246743E-10_JPRB, 0.88235981E-10_JPRB, 0.88224338E-10_JPRB, 0.88211966E-10_JPRB, 0.88201293E-10_JPRB, 0.88193557E-10_JPRB, &
  & 0.88189872E-10_JPRB, 0.88190101E-10_JPRB, 0.88193661E-10_JPRB, 0.88199420E-10_JPRB, 0.88205533E-10_JPRB, 0.88211161E-10_JPRB, &
  & 0.88215164E-10_JPRB, 0.88217184E-10_JPRB, 0.88216913E-10_JPRB, 0.88215595E-10_JPRB, 0.88212521E-10_JPRB, 0.88208607E-10_JPRB, &
  & 0.88204437E-10_JPRB, 0.88199358E-10_JPRB, 0.88193876E-10_JPRB, 0.88188436E-10_JPRB, 0.88182642E-10_JPRB, 0.88177354E-10_JPRB, &
  & 0.88170957E-10_JPRB, 0.88162748E-10_JPRB, 0.88146962E-10_JPRB, 0.88105523E-10_JPRB /)

RGHG9(:,76,11) = (/ &
  & 0.88140176E-10_JPRB, 0.88167973E-10_JPRB, 0.88177229E-10_JPRB, 0.88181483E-10_JPRB, 0.88183724E-10_JPRB, 0.88185674E-10_JPRB, &
  & 0.88187582E-10_JPRB, 0.88190011E-10_JPRB, 0.88193008E-10_JPRB, 0.88196596E-10_JPRB, 0.88199531E-10_JPRB, 0.88202591E-10_JPRB, &
  & 0.88204367E-10_JPRB, 0.88204888E-10_JPRB, 0.88203174E-10_JPRB, 0.88198421E-10_JPRB, 0.88191593E-10_JPRB, 0.88183572E-10_JPRB, &
  & 0.88176563E-10_JPRB, 0.88172407E-10_JPRB, 0.88172691E-10_JPRB, 0.88176140E-10_JPRB, 0.88182676E-10_JPRB, 0.88192460E-10_JPRB, &
  & 0.88204000E-10_JPRB, 0.88217052E-10_JPRB, 0.88229653E-10_JPRB, 0.88241525E-10_JPRB, 0.88251344E-10_JPRB, 0.88259511E-10_JPRB, &
  & 0.88266082E-10_JPRB, 0.88270113E-10_JPRB, 0.88272285E-10_JPRB, 0.88271973E-10_JPRB, 0.88269871E-10_JPRB, 0.88265693E-10_JPRB, &
  & 0.88259344E-10_JPRB, 0.88251191E-10_JPRB, 0.88242365E-10_JPRB, 0.88232879E-10_JPRB, 0.88224733E-10_JPRB, 0.88218891E-10_JPRB, &
  & 0.88216191E-10_JPRB, 0.88216490E-10_JPRB, 0.88219279E-10_JPRB, 0.88223935E-10_JPRB, 0.88228536E-10_JPRB, 0.88233053E-10_JPRB, &
  & 0.88236217E-10_JPRB, 0.88237917E-10_JPRB, 0.88237744E-10_JPRB, 0.88237057E-10_JPRB, 0.88234642E-10_JPRB, 0.88231561E-10_JPRB, &
  & 0.88228154E-10_JPRB, 0.88224560E-10_JPRB, 0.88220237E-10_JPRB, 0.88215803E-10_JPRB, 0.88211806E-10_JPRB, 0.88206956E-10_JPRB, &
  & 0.88202251E-10_JPRB, 0.88195513E-10_JPRB, 0.88181962E-10_JPRB, 0.88145199E-10_JPRB /)

RGHG9(:,77,11) = (/ &
  & 0.88180470E-10_JPRB, 0.88205290E-10_JPRB, 0.88213284E-10_JPRB, 0.88216635E-10_JPRB, 0.88218217E-10_JPRB, 0.88219772E-10_JPRB, &
  & 0.88221402E-10_JPRB, 0.88223089E-10_JPRB, 0.88225538E-10_JPRB, 0.88227786E-10_JPRB, 0.88229958E-10_JPRB, 0.88231880E-10_JPRB, &
  & 0.88233115E-10_JPRB, 0.88233448E-10_JPRB, 0.88232477E-10_JPRB, 0.88228785E-10_JPRB, 0.88223928E-10_JPRB, 0.88217898E-10_JPRB, &
  & 0.88212770E-10_JPRB, 0.88209717E-10_JPRB, 0.88210356E-10_JPRB, 0.88212736E-10_JPRB, 0.88217100E-10_JPRB, 0.88223963E-10_JPRB, &
  & 0.88232109E-10_JPRB, 0.88241393E-10_JPRB, 0.88250157E-10_JPRB, 0.88258484E-10_JPRB, 0.88265222E-10_JPRB, 0.88271050E-10_JPRB, &
  & 0.88275928E-10_JPRB, 0.88278697E-10_JPRB, 0.88280362E-10_JPRB, 0.88280099E-10_JPRB, 0.88278662E-10_JPRB, 0.88275699E-10_JPRB, &
  & 0.88271120E-10_JPRB, 0.88265374E-10_JPRB, 0.88259219E-10_JPRB, 0.88252405E-10_JPRB, 0.88246653E-10_JPRB, 0.88242469E-10_JPRB, &
  & 0.88240630E-10_JPRB, 0.88240852E-10_JPRB, 0.88242878E-10_JPRB, 0.88246334E-10_JPRB, 0.88249533E-10_JPRB, 0.88252891E-10_JPRB, &
  & 0.88255230E-10_JPRB, 0.88256596E-10_JPRB, 0.88256409E-10_JPRB, 0.88256402E-10_JPRB, 0.88254543E-10_JPRB, 0.88252045E-10_JPRB, &
  & 0.88249776E-10_JPRB, 0.88247208E-10_JPRB, 0.88244197E-10_JPRB, 0.88241296E-10_JPRB, 0.88238097E-10_JPRB, 0.88234801E-10_JPRB, &
  & 0.88230992E-10_JPRB, 0.88226156E-10_JPRB, 0.88215248E-10_JPRB, 0.88183925E-10_JPRB /)

RGHG9(:,78,11) = (/ &
  & 0.88218544E-10_JPRB, 0.88238285E-10_JPRB, 0.88244127E-10_JPRB, 0.88246507E-10_JPRB, 0.88247382E-10_JPRB, 0.88248610E-10_JPRB, &
  & 0.88249852E-10_JPRB, 0.88251004E-10_JPRB, 0.88252496E-10_JPRB, 0.88253835E-10_JPRB, 0.88254737E-10_JPRB, 0.88255930E-10_JPRB, &
  & 0.88256610E-10_JPRB, 0.88256853E-10_JPRB, 0.88256694E-10_JPRB, 0.88254112E-10_JPRB, 0.88251101E-10_JPRB, 0.88247042E-10_JPRB, &
  & 0.88243718E-10_JPRB, 0.88241810E-10_JPRB, 0.88242871E-10_JPRB, 0.88244419E-10_JPRB, 0.88246847E-10_JPRB, 0.88251240E-10_JPRB, &
  & 0.88256492E-10_JPRB, 0.88262501E-10_JPRB, 0.88268025E-10_JPRB, 0.88273340E-10_JPRB, 0.88277351E-10_JPRB, 0.88281202E-10_JPRB, &
  & 0.88284650E-10_JPRB, 0.88286364E-10_JPRB, 0.88287565E-10_JPRB, 0.88287322E-10_JPRB, 0.88286441E-10_JPRB, 0.88284539E-10_JPRB, &
  & 0.88281486E-10_JPRB, 0.88277864E-10_JPRB, 0.88274020E-10_JPRB, 0.88269544E-10_JPRB, 0.88265791E-10_JPRB, 0.88263008E-10_JPRB, &
  & 0.88261766E-10_JPRB, 0.88261884E-10_JPRB, 0.88263098E-10_JPRB, 0.88265506E-10_JPRB, 0.88267331E-10_JPRB, 0.88269669E-10_JPRB, &
  & 0.88271224E-10_JPRB, 0.88272237E-10_JPRB, 0.88272001E-10_JPRB, 0.88272563E-10_JPRB, 0.88271161E-10_JPRB, 0.88269198E-10_JPRB, &
  & 0.88267699E-10_JPRB, 0.88266297E-10_JPRB, 0.88264382E-10_JPRB, 0.88262661E-10_JPRB, 0.88260760E-10_JPRB, 0.88258185E-10_JPRB, &
  & 0.88255729E-10_JPRB, 0.88252426E-10_JPRB, 0.88245168E-10_JPRB, 0.88221833E-10_JPRB /)

RGHG9(:,79,11) = (/ &
  & 0.88242857E-10_JPRB, 0.88256735E-10_JPRB, 0.88260621E-10_JPRB, 0.88262050E-10_JPRB, 0.88262467E-10_JPRB, 0.88263521E-10_JPRB, &
  & 0.88264618E-10_JPRB, 0.88265409E-10_JPRB, 0.88266450E-10_JPRB, 0.88267248E-10_JPRB, 0.88267539E-10_JPRB, 0.88268330E-10_JPRB, &
  & 0.88268795E-10_JPRB, 0.88269038E-10_JPRB, 0.88269433E-10_JPRB, 0.88267352E-10_JPRB, 0.88265395E-10_JPRB, 0.88262335E-10_JPRB, &
  & 0.88260010E-10_JPRB, 0.88258761E-10_JPRB, 0.88260309E-10_JPRB, 0.88261440E-10_JPRB, 0.88262800E-10_JPRB, 0.88265881E-10_JPRB, &
  & 0.88269614E-10_JPRB, 0.88273902E-10_JPRB, 0.88277725E-10_JPRB, 0.88281403E-10_JPRB, 0.88283852E-10_JPRB, 0.88286663E-10_JPRB, &
  & 0.88289411E-10_JPRB, 0.88290535E-10_JPRB, 0.88291534E-10_JPRB, 0.88291305E-10_JPRB, 0.88290701E-10_JPRB, 0.88289334E-10_JPRB, &
  & 0.88287058E-10_JPRB, 0.88284588E-10_JPRB, 0.88282007E-10_JPRB, 0.88278711E-10_JPRB, 0.88276018E-10_JPRB, 0.88273902E-10_JPRB, &
  & 0.88272979E-10_JPRB, 0.88272986E-10_JPRB, 0.88273777E-10_JPRB, 0.88275665E-10_JPRB, 0.88276685E-10_JPRB, 0.88278530E-10_JPRB, &
  & 0.88279668E-10_JPRB, 0.88280515E-10_JPRB, 0.88280182E-10_JPRB, 0.88281139E-10_JPRB, 0.88279925E-10_JPRB, 0.88278093E-10_JPRB, &
  & 0.88277059E-10_JPRB, 0.88276220E-10_JPRB, 0.88274860E-10_JPRB, 0.88273826E-10_JPRB, 0.88272417E-10_JPRB, 0.88270391E-10_JPRB, &
  & 0.88268420E-10_JPRB, 0.88266394E-10_JPRB, 0.88261787E-10_JPRB, 0.88246258E-10_JPRB /)

RGHG9(:,80,11) = (/ &
  & 0.88258859E-10_JPRB, 0.88265610E-10_JPRB, 0.88267837E-10_JPRB, 0.88268795E-10_JPRB, 0.88268927E-10_JPRB, 0.88269926E-10_JPRB, &
  & 0.88270988E-10_JPRB, 0.88271591E-10_JPRB, 0.88272507E-10_JPRB, 0.88273056E-10_JPRB, 0.88273104E-10_JPRB, 0.88273756E-10_JPRB, &
  & 0.88274145E-10_JPRB, 0.88274402E-10_JPRB, 0.88275116E-10_JPRB, 0.88273229E-10_JPRB, 0.88271737E-10_JPRB, 0.88269080E-10_JPRB, &
  & 0.88267206E-10_JPRB, 0.88266297E-10_JPRB, 0.88268157E-10_JPRB, 0.88269121E-10_JPRB, 0.88269975E-10_JPRB, 0.88272480E-10_JPRB, &
  & 0.88275574E-10_JPRB, 0.88279106E-10_JPRB, 0.88282132E-10_JPRB, 0.88285039E-10_JPRB, 0.88286767E-10_JPRB, 0.88289147E-10_JPRB, &
  & 0.88291617E-10_JPRB, 0.88292471E-10_JPRB, 0.88293380E-10_JPRB, 0.88293144E-10_JPRB, 0.88292679E-10_JPRB, 0.88291555E-10_JPRB, &
  & 0.88289584E-10_JPRB, 0.88287641E-10_JPRB, 0.88285629E-10_JPRB, 0.88282853E-10_JPRB, 0.88280591E-10_JPRB, 0.88278759E-10_JPRB, &
  & 0.88277975E-10_JPRB, 0.88277941E-10_JPRB, 0.88278523E-10_JPRB, 0.88280175E-10_JPRB, 0.88280813E-10_JPRB, 0.88282423E-10_JPRB, &
  & 0.88283374E-10_JPRB, 0.88284179E-10_JPRB, 0.88283755E-10_JPRB, 0.88284956E-10_JPRB, 0.88283762E-10_JPRB, 0.88281923E-10_JPRB, &
  & 0.88281077E-10_JPRB, 0.88280501E-10_JPRB, 0.88279370E-10_JPRB, 0.88278627E-10_JPRB, 0.88277469E-10_JPRB, 0.88275540E-10_JPRB, &
  & 0.88273909E-10_JPRB, 0.88272466E-10_JPRB, 0.88269822E-10_JPRB, 0.88262439E-10_JPRB /)

RGHG9(:,81,11) = (/ &
  & 0.88269669E-10_JPRB, 0.88269364E-10_JPRB, 0.88270904E-10_JPRB, 0.88271682E-10_JPRB, 0.88271696E-10_JPRB, 0.88272667E-10_JPRB, &
  & 0.88273708E-10_JPRB, 0.88274277E-10_JPRB, 0.88275040E-10_JPRB, 0.88275602E-10_JPRB, 0.88275498E-10_JPRB, 0.88276116E-10_JPRB, &
  & 0.88276483E-10_JPRB, 0.88276747E-10_JPRB, 0.88277628E-10_JPRB, 0.88275817E-10_JPRB, 0.88274534E-10_JPRB, 0.88272015E-10_JPRB, &
  & 0.88270301E-10_JPRB, 0.88269544E-10_JPRB, 0.88271640E-10_JPRB, 0.88272500E-10_JPRB, 0.88273167E-10_JPRB, 0.88275401E-10_JPRB, &
  & 0.88278204E-10_JPRB, 0.88281396E-10_JPRB, 0.88284074E-10_JPRB, 0.88286670E-10_JPRB, 0.88288044E-10_JPRB, 0.88290208E-10_JPRB, &
  & 0.88292589E-10_JPRB, 0.88293310E-10_JPRB, 0.88294226E-10_JPRB, 0.88293976E-10_JPRB, 0.88293567E-10_JPRB, 0.88292505E-10_JPRB, &
  & 0.88290708E-10_JPRB, 0.88288987E-10_JPRB, 0.88287239E-10_JPRB, 0.88284692E-10_JPRB, 0.88282603E-10_JPRB, 0.88280896E-10_JPRB, &
  & 0.88280154E-10_JPRB, 0.88280078E-10_JPRB, 0.88280584E-10_JPRB, 0.88282187E-10_JPRB, 0.88282597E-10_JPRB, 0.88284109E-10_JPRB, &
  & 0.88284977E-10_JPRB, 0.88285754E-10_JPRB, 0.88285289E-10_JPRB, 0.88286649E-10_JPRB, 0.88285448E-10_JPRB, 0.88283547E-10_JPRB, &
  & 0.88282798E-10_JPRB, 0.88282340E-10_JPRB, 0.88281313E-10_JPRB, 0.88280702E-10_JPRB, 0.88279647E-10_JPRB, 0.88277760E-10_JPRB, &
  & 0.88276192E-10_JPRB, 0.88275012E-10_JPRB, 0.88273194E-10_JPRB, 0.88273590E-10_JPRB /)

RGHG9(:,82,11) = (/ &
  & 0.88270544E-10_JPRB, 0.88270620E-10_JPRB, 0.88272264E-10_JPRB, 0.88273042E-10_JPRB, 0.88273021E-10_JPRB, 0.88273985E-10_JPRB, &
  & 0.88275047E-10_JPRB, 0.88275533E-10_JPRB, 0.88276345E-10_JPRB, 0.88276816E-10_JPRB, 0.88276692E-10_JPRB, 0.88277267E-10_JPRB, &
  & 0.88277635E-10_JPRB, 0.88277899E-10_JPRB, 0.88278884E-10_JPRB, 0.88277073E-10_JPRB, 0.88275900E-10_JPRB, 0.88273430E-10_JPRB, &
  & 0.88271820E-10_JPRB, 0.88271133E-10_JPRB, 0.88273305E-10_JPRB, 0.88274180E-10_JPRB, 0.88274700E-10_JPRB, 0.88276830E-10_JPRB, &
  & 0.88279495E-10_JPRB, 0.88282520E-10_JPRB, 0.88285032E-10_JPRB, 0.88287447E-10_JPRB, 0.88288640E-10_JPRB, 0.88290736E-10_JPRB, &
  & 0.88293074E-10_JPRB, 0.88293733E-10_JPRB, 0.88294663E-10_JPRB, 0.88294386E-10_JPRB, 0.88293983E-10_JPRB, 0.88292984E-10_JPRB, &
  & 0.88291249E-10_JPRB, 0.88289653E-10_JPRB, 0.88288044E-10_JPRB, 0.88285622E-10_JPRB, 0.88283630E-10_JPRB, 0.88281937E-10_JPRB, &
  & 0.88281230E-10_JPRB, 0.88281132E-10_JPRB, 0.88281604E-10_JPRB, 0.88283159E-10_JPRB, 0.88283464E-10_JPRB, 0.88284935E-10_JPRB, &
  & 0.88285754E-10_JPRB, 0.88286524E-10_JPRB, 0.88286017E-10_JPRB, 0.88287488E-10_JPRB, 0.88286260E-10_JPRB, 0.88284331E-10_JPRB, &
  & 0.88283610E-10_JPRB, 0.88283235E-10_JPRB, 0.88282263E-10_JPRB, 0.88281736E-10_JPRB, 0.88280709E-10_JPRB, 0.88278836E-10_JPRB, &
  & 0.88277281E-10_JPRB, 0.88276123E-10_JPRB, 0.88274305E-10_JPRB, 0.88274485E-10_JPRB /)

RGHG9(:,83,11) = (/ &
  & 0.88271133E-10_JPRB, 0.88271349E-10_JPRB, 0.88273042E-10_JPRB, 0.88273812E-10_JPRB, 0.88273763E-10_JPRB, 0.88274728E-10_JPRB, &
  & 0.88275769E-10_JPRB, 0.88276275E-10_JPRB, 0.88276997E-10_JPRB, 0.88277483E-10_JPRB, 0.88277337E-10_JPRB, 0.88277906E-10_JPRB, &
  & 0.88278253E-10_JPRB, 0.88278537E-10_JPRB, 0.88279599E-10_JPRB, 0.88277802E-10_JPRB, 0.88276671E-10_JPRB, 0.88274221E-10_JPRB, &
  & 0.88272632E-10_JPRB, 0.88271973E-10_JPRB, 0.88274305E-10_JPRB, 0.88275123E-10_JPRB, 0.88275560E-10_JPRB, 0.88277621E-10_JPRB, &
  & 0.88280223E-10_JPRB, 0.88283159E-10_JPRB, 0.88285573E-10_JPRB, 0.88287905E-10_JPRB, 0.88288973E-10_JPRB, 0.88291000E-10_JPRB, &
  & 0.88293345E-10_JPRB, 0.88293976E-10_JPRB, 0.88294920E-10_JPRB, 0.88294622E-10_JPRB, 0.88294219E-10_JPRB, 0.88293220E-10_JPRB, &
  & 0.88291555E-10_JPRB, 0.88290000E-10_JPRB, 0.88288467E-10_JPRB, 0.88286184E-10_JPRB, 0.88284172E-10_JPRB, 0.88282541E-10_JPRB, &
  & 0.88281812E-10_JPRB, 0.88281708E-10_JPRB, 0.88282139E-10_JPRB, 0.88283714E-10_JPRB, 0.88283922E-10_JPRB, 0.88285386E-10_JPRB, &
  & 0.88286177E-10_JPRB, 0.88286961E-10_JPRB, 0.88286420E-10_JPRB, 0.88287974E-10_JPRB, 0.88286725E-10_JPRB, 0.88284768E-10_JPRB, &
  & 0.88284068E-10_JPRB, 0.88283721E-10_JPRB, 0.88282805E-10_JPRB, 0.88282312E-10_JPRB, 0.88281306E-10_JPRB, 0.88279425E-10_JPRB, &
  & 0.88277885E-10_JPRB, 0.88276747E-10_JPRB, 0.88274957E-10_JPRB, 0.88275109E-10_JPRB /)

RGHG9(:,84,11) = (/ &
  & 0.88271529E-10_JPRB, 0.88271813E-10_JPRB, 0.88273520E-10_JPRB, 0.88274291E-10_JPRB, 0.88274228E-10_JPRB, 0.88275220E-10_JPRB, &
  & 0.88276247E-10_JPRB, 0.88276740E-10_JPRB, 0.88277469E-10_JPRB, 0.88277871E-10_JPRB, 0.88277774E-10_JPRB, 0.88278267E-10_JPRB, &
  & 0.88278648E-10_JPRB, 0.88278926E-10_JPRB, 0.88279994E-10_JPRB, 0.88278267E-10_JPRB, 0.88277177E-10_JPRB, 0.88274714E-10_JPRB, &
  & 0.88273173E-10_JPRB, 0.88272507E-10_JPRB, 0.88274874E-10_JPRB, 0.88275706E-10_JPRB, 0.88276067E-10_JPRB, 0.88278100E-10_JPRB, &
  & 0.88280661E-10_JPRB, 0.88283589E-10_JPRB, 0.88285920E-10_JPRB, 0.88288182E-10_JPRB, 0.88289168E-10_JPRB, 0.88291152E-10_JPRB, &
  & 0.88293511E-10_JPRB, 0.88294115E-10_JPRB, 0.88295080E-10_JPRB, 0.88294774E-10_JPRB, 0.88294372E-10_JPRB, 0.88293373E-10_JPRB, &
  & 0.88291735E-10_JPRB, 0.88290236E-10_JPRB, 0.88288751E-10_JPRB, 0.88286496E-10_JPRB, 0.88284602E-10_JPRB, 0.88282916E-10_JPRB, &
  & 0.88282201E-10_JPRB, 0.88282069E-10_JPRB, 0.88282465E-10_JPRB, 0.88284061E-10_JPRB, 0.88284213E-10_JPRB, 0.88285650E-10_JPRB, &
  & 0.88286427E-10_JPRB, 0.88287225E-10_JPRB, 0.88286684E-10_JPRB, 0.88288300E-10_JPRB, 0.88287030E-10_JPRB, 0.88285046E-10_JPRB, &
  & 0.88284338E-10_JPRB, 0.88284005E-10_JPRB, 0.88283131E-10_JPRB, 0.88282673E-10_JPRB, 0.88281694E-10_JPRB, 0.88279793E-10_JPRB, &
  & 0.88278260E-10_JPRB, 0.88277143E-10_JPRB, 0.88275373E-10_JPRB, 0.88275547E-10_JPRB /)

RGHG9(:,85,11) = (/ &
  & 0.88271772E-10_JPRB, 0.88272112E-10_JPRB, 0.88273840E-10_JPRB, 0.88274624E-10_JPRB, 0.88274527E-10_JPRB, 0.88275554E-10_JPRB, &
  & 0.88276567E-10_JPRB, 0.88277108E-10_JPRB, 0.88277705E-10_JPRB, 0.88278086E-10_JPRB, 0.88278086E-10_JPRB, 0.88278516E-10_JPRB, &
  & 0.88278870E-10_JPRB, 0.88279210E-10_JPRB, 0.88280105E-10_JPRB, 0.88278579E-10_JPRB, 0.88277483E-10_JPRB, 0.88275054E-10_JPRB, &
  & 0.88273513E-10_JPRB, 0.88272827E-10_JPRB, 0.88275311E-10_JPRB, 0.88276095E-10_JPRB, 0.88276358E-10_JPRB, 0.88278385E-10_JPRB, &
  & 0.88280952E-10_JPRB, 0.88283866E-10_JPRB, 0.88286156E-10_JPRB, 0.88288370E-10_JPRB, 0.88289279E-10_JPRB, 0.88291270E-10_JPRB, &
  & 0.88293615E-10_JPRB, 0.88294219E-10_JPRB, 0.88295177E-10_JPRB, 0.88294871E-10_JPRB, 0.88294455E-10_JPRB, 0.88293456E-10_JPRB, &
  & 0.88291867E-10_JPRB, 0.88290403E-10_JPRB, 0.88288925E-10_JPRB, 0.88286781E-10_JPRB, 0.88284775E-10_JPRB, 0.88283152E-10_JPRB, &
  & 0.88282402E-10_JPRB, 0.88282277E-10_JPRB, 0.88282694E-10_JPRB, 0.88284310E-10_JPRB, 0.88284380E-10_JPRB, 0.88285830E-10_JPRB, &
  & 0.88286586E-10_JPRB, 0.88287398E-10_JPRB, 0.88286843E-10_JPRB, 0.88288522E-10_JPRB, 0.88287246E-10_JPRB, 0.88285233E-10_JPRB, &
  & 0.88284519E-10_JPRB, 0.88284192E-10_JPRB, 0.88283346E-10_JPRB, 0.88282923E-10_JPRB, 0.88281951E-10_JPRB, 0.88280029E-10_JPRB, &
  & 0.88278496E-10_JPRB, 0.88277399E-10_JPRB, 0.88275637E-10_JPRB, 0.88275859E-10_JPRB /)

RGHG9(:,86,11) = (/ &
  & 0.88271918E-10_JPRB, 0.88272292E-10_JPRB, 0.88274069E-10_JPRB, 0.88274853E-10_JPRB, 0.88274756E-10_JPRB, 0.88275762E-10_JPRB, &
  & 0.88276858E-10_JPRB, 0.88277344E-10_JPRB, 0.88277927E-10_JPRB, 0.88278218E-10_JPRB, 0.88278315E-10_JPRB, 0.88278648E-10_JPRB, &
  & 0.88278995E-10_JPRB, 0.88279328E-10_JPRB, 0.88279987E-10_JPRB, 0.88278766E-10_JPRB, 0.88277670E-10_JPRB, 0.88275352E-10_JPRB, &
  & 0.88273777E-10_JPRB, 0.88273056E-10_JPRB, 0.88275560E-10_JPRB, 0.88276358E-10_JPRB, 0.88276504E-10_JPRB, 0.88278530E-10_JPRB, &
  & 0.88281105E-10_JPRB, 0.88284068E-10_JPRB, 0.88286316E-10_JPRB, 0.88288536E-10_JPRB, 0.88289355E-10_JPRB, 0.88291340E-10_JPRB, &
  & 0.88293713E-10_JPRB, 0.88294295E-10_JPRB, 0.88295260E-10_JPRB, 0.88294920E-10_JPRB, 0.88294504E-10_JPRB, 0.88293532E-10_JPRB, &
  & 0.88291957E-10_JPRB, 0.88290514E-10_JPRB, 0.88289112E-10_JPRB, 0.88286878E-10_JPRB, 0.88284949E-10_JPRB, 0.88283214E-10_JPRB, &
  & 0.88282534E-10_JPRB, 0.88282409E-10_JPRB, 0.88282805E-10_JPRB, 0.88284463E-10_JPRB, 0.88284498E-10_JPRB, 0.88285934E-10_JPRB, &
  & 0.88286670E-10_JPRB, 0.88287516E-10_JPRB, 0.88286940E-10_JPRB, 0.88288696E-10_JPRB, 0.88287384E-10_JPRB, 0.88285337E-10_JPRB, &
  & 0.88284643E-10_JPRB, 0.88284310E-10_JPRB, 0.88283492E-10_JPRB, 0.88283068E-10_JPRB, 0.88282111E-10_JPRB, 0.88280196E-10_JPRB, &
  & 0.88278662E-10_JPRB, 0.88277566E-10_JPRB, 0.88275803E-10_JPRB, 0.88276067E-10_JPRB /)

RGHG9(:,87,11) = (/ &
  & 0.88272001E-10_JPRB, 0.88272410E-10_JPRB, 0.88274180E-10_JPRB, 0.88274978E-10_JPRB, 0.88274874E-10_JPRB, 0.88276095E-10_JPRB, &
  & 0.88276955E-10_JPRB, 0.88277580E-10_JPRB, 0.88278024E-10_JPRB, 0.88278315E-10_JPRB, 0.88278461E-10_JPRB, 0.88278773E-10_JPRB, &
  & 0.88279078E-10_JPRB, 0.88279398E-10_JPRB, 0.88279883E-10_JPRB, 0.88278856E-10_JPRB, 0.88277781E-10_JPRB, 0.88275533E-10_JPRB, &
  & 0.88273978E-10_JPRB, 0.88273229E-10_JPRB, 0.88275699E-10_JPRB, 0.88276511E-10_JPRB, 0.88276574E-10_JPRB, 0.88278600E-10_JPRB, &
  & 0.88281216E-10_JPRB, 0.88284220E-10_JPRB, 0.88286441E-10_JPRB, 0.88288647E-10_JPRB, 0.88289383E-10_JPRB, 0.88291367E-10_JPRB, &
  & 0.88293789E-10_JPRB, 0.88294351E-10_JPRB, 0.88295329E-10_JPRB, 0.88294982E-10_JPRB, 0.88294559E-10_JPRB, 0.88293588E-10_JPRB, &
  & 0.88292020E-10_JPRB, 0.88290597E-10_JPRB, 0.88289230E-10_JPRB, 0.88287010E-10_JPRB, 0.88284963E-10_JPRB, 0.88283256E-10_JPRB, &
  & 0.88282590E-10_JPRB, 0.88282479E-10_JPRB, 0.88282881E-10_JPRB, 0.88284560E-10_JPRB, 0.88284546E-10_JPRB, 0.88286004E-10_JPRB, &
  & 0.88286718E-10_JPRB, 0.88287593E-10_JPRB, 0.88287010E-10_JPRB, 0.88288807E-10_JPRB, 0.88287475E-10_JPRB, 0.88285379E-10_JPRB, &
  & 0.88284720E-10_JPRB, 0.88284380E-10_JPRB, 0.88283554E-10_JPRB, 0.88283152E-10_JPRB, 0.88282194E-10_JPRB, 0.88280300E-10_JPRB, &
  & 0.88278766E-10_JPRB, 0.88277663E-10_JPRB, 0.88275894E-10_JPRB, 0.88276199E-10_JPRB /)

RGHG9(:,88,11) = (/ &
  & 0.88272056E-10_JPRB, 0.88272480E-10_JPRB, 0.88274263E-10_JPRB, 0.88275061E-10_JPRB, 0.88275019E-10_JPRB, 0.88276025E-10_JPRB, &
  & 0.88277156E-10_JPRB, 0.88277621E-10_JPRB, 0.88278121E-10_JPRB, 0.88278378E-10_JPRB, 0.88278516E-10_JPRB, 0.88278801E-10_JPRB, &
  & 0.88279106E-10_JPRB, 0.88279391E-10_JPRB, 0.88279849E-10_JPRB, 0.88278919E-10_JPRB, 0.88277836E-10_JPRB, 0.88275685E-10_JPRB, &
  & 0.88274069E-10_JPRB, 0.88273298E-10_JPRB, 0.88275817E-10_JPRB, 0.88276629E-10_JPRB, 0.88276580E-10_JPRB, 0.88278614E-10_JPRB, &
  & 0.88281250E-10_JPRB, 0.88284338E-10_JPRB, 0.88286496E-10_JPRB, 0.88288737E-10_JPRB, 0.88289390E-10_JPRB, 0.88291402E-10_JPRB, &
  & 0.88293851E-10_JPRB, 0.88294393E-10_JPRB, 0.88295371E-10_JPRB, 0.88295010E-10_JPRB, 0.88294587E-10_JPRB, 0.88293650E-10_JPRB, &
  & 0.88292068E-10_JPRB, 0.88290653E-10_JPRB, 0.88289334E-10_JPRB, 0.88287044E-10_JPRB, 0.88284997E-10_JPRB, 0.88283228E-10_JPRB, &
  & 0.88282624E-10_JPRB, 0.88282499E-10_JPRB, 0.88282902E-10_JPRB, 0.88284623E-10_JPRB, 0.88284560E-10_JPRB, 0.88286031E-10_JPRB, &
  & 0.88286739E-10_JPRB, 0.88287620E-10_JPRB, 0.88287037E-10_JPRB, 0.88288897E-10_JPRB, 0.88287523E-10_JPRB, 0.88285414E-10_JPRB, &
  & 0.88284748E-10_JPRB, 0.88284421E-10_JPRB, 0.88283617E-10_JPRB, 0.88283214E-10_JPRB, 0.88282257E-10_JPRB, 0.88280348E-10_JPRB, &
  & 0.88278815E-10_JPRB, 0.88277725E-10_JPRB, 0.88275963E-10_JPRB, 0.88276289E-10_JPRB /)

RGHG9(:,89,11) = (/ &
  & 0.88272105E-10_JPRB, 0.88272542E-10_JPRB, 0.88274311E-10_JPRB, 0.88275096E-10_JPRB, 0.88274943E-10_JPRB, 0.88276199E-10_JPRB, &
  & 0.88277052E-10_JPRB, 0.88277677E-10_JPRB, 0.88278114E-10_JPRB, 0.88278398E-10_JPRB, 0.88278523E-10_JPRB, 0.88278829E-10_JPRB, &
  & 0.88279148E-10_JPRB, 0.88279467E-10_JPRB, 0.88279994E-10_JPRB, 0.88278967E-10_JPRB, 0.88277913E-10_JPRB, 0.88275644E-10_JPRB, &
  & 0.88274089E-10_JPRB, 0.88273285E-10_JPRB, 0.88275845E-10_JPRB, 0.88276705E-10_JPRB, 0.88276587E-10_JPRB, 0.88278621E-10_JPRB, &
  & 0.88281271E-10_JPRB, 0.88284408E-10_JPRB, 0.88286545E-10_JPRB, 0.88288800E-10_JPRB, 0.88289383E-10_JPRB, 0.88291402E-10_JPRB, &
  & 0.88293900E-10_JPRB, 0.88294413E-10_JPRB, 0.88295440E-10_JPRB, 0.88295038E-10_JPRB, 0.88294629E-10_JPRB, 0.88293685E-10_JPRB, &
  & 0.88292096E-10_JPRB, 0.88290653E-10_JPRB, 0.88289376E-10_JPRB, 0.88287065E-10_JPRB, 0.88284997E-10_JPRB, 0.88283221E-10_JPRB, &
  & 0.88282645E-10_JPRB, 0.88282513E-10_JPRB, 0.88282916E-10_JPRB, 0.88284685E-10_JPRB, 0.88284581E-10_JPRB, 0.88286059E-10_JPRB, &
  & 0.88286732E-10_JPRB, 0.88287648E-10_JPRB, 0.88287044E-10_JPRB, 0.88288966E-10_JPRB, 0.88287558E-10_JPRB, 0.88285421E-10_JPRB, &
  & 0.88284775E-10_JPRB, 0.88284449E-10_JPRB, 0.88283637E-10_JPRB, 0.88283249E-10_JPRB, 0.88282291E-10_JPRB, 0.88280390E-10_JPRB, &
  & 0.88278856E-10_JPRB, 0.88277760E-10_JPRB, 0.88275956E-10_JPRB, 0.88276338E-10_JPRB /)

RGHG9(:,90,11) = (/ &
  & 0.88272140E-10_JPRB, 0.88272570E-10_JPRB, 0.88274332E-10_JPRB, 0.88275130E-10_JPRB, 0.88274887E-10_JPRB, 0.88275963E-10_JPRB, &
  & 0.88277108E-10_JPRB, 0.88277580E-10_JPRB, 0.88278163E-10_JPRB, 0.88278440E-10_JPRB, 0.88278510E-10_JPRB, 0.88278856E-10_JPRB, &
  & 0.88279231E-10_JPRB, 0.88279550E-10_JPRB, 0.88280334E-10_JPRB, 0.88279037E-10_JPRB, 0.88277989E-10_JPRB, 0.88275554E-10_JPRB, &
  & 0.88273958E-10_JPRB, 0.88273146E-10_JPRB, 0.88275956E-10_JPRB, 0.88276775E-10_JPRB, 0.88276539E-10_JPRB, 0.88278621E-10_JPRB, &
  & 0.88281278E-10_JPRB, 0.88284477E-10_JPRB, 0.88286552E-10_JPRB, 0.88288848E-10_JPRB, 0.88289327E-10_JPRB, 0.88291388E-10_JPRB, &
  & 0.88293969E-10_JPRB, 0.88294407E-10_JPRB, 0.88295510E-10_JPRB, 0.88295066E-10_JPRB, 0.88294656E-10_JPRB, 0.88293740E-10_JPRB, &
  & 0.88292110E-10_JPRB, 0.88290646E-10_JPRB, 0.88289417E-10_JPRB, 0.88287058E-10_JPRB, 0.88284983E-10_JPRB, 0.88283186E-10_JPRB, &
  & 0.88282631E-10_JPRB, 0.88282513E-10_JPRB, 0.88282881E-10_JPRB, 0.88284748E-10_JPRB, 0.88284553E-10_JPRB, 0.88286087E-10_JPRB, &
  & 0.88286746E-10_JPRB, 0.88287710E-10_JPRB, 0.88286989E-10_JPRB, 0.88289084E-10_JPRB, 0.88287586E-10_JPRB, 0.88285393E-10_JPRB, &
  & 0.88284775E-10_JPRB, 0.88284463E-10_JPRB, 0.88283644E-10_JPRB, 0.88283290E-10_JPRB, 0.88282340E-10_JPRB, 0.88280376E-10_JPRB, &
  & 0.88278850E-10_JPRB, 0.88277774E-10_JPRB, 0.88275942E-10_JPRB, 0.88276386E-10_JPRB /)

RGHG9(:,91,11) = (/ &
  & 0.88272147E-10_JPRB, 0.88272438E-10_JPRB, 0.88274318E-10_JPRB, 0.88275214E-10_JPRB, 0.88274707E-10_JPRB, 0.88275894E-10_JPRB, &
  & 0.88277018E-10_JPRB, 0.88277420E-10_JPRB, 0.88278253E-10_JPRB, 0.88278621E-10_JPRB, 0.88278183E-10_JPRB, 0.88278863E-10_JPRB, &
  & 0.88279328E-10_JPRB, 0.88279412E-10_JPRB, 0.88281216E-10_JPRB, 0.88278877E-10_JPRB, 0.88278190E-10_JPRB, 0.88275331E-10_JPRB, &
  & 0.88273833E-10_JPRB, 0.88272840E-10_JPRB, 0.88276102E-10_JPRB, 0.88276865E-10_JPRB, 0.88276407E-10_JPRB, 0.88278572E-10_JPRB, &
  & 0.88281243E-10_JPRB, 0.88284546E-10_JPRB, 0.88286552E-10_JPRB, 0.88288973E-10_JPRB, 0.88289223E-10_JPRB, 0.88291340E-10_JPRB, &
  & 0.88294129E-10_JPRB, 0.88294372E-10_JPRB, 0.88295649E-10_JPRB, 0.88295073E-10_JPRB, 0.88294712E-10_JPRB, 0.88293831E-10_JPRB, &
  & 0.88292075E-10_JPRB, 0.88290604E-10_JPRB, 0.88289480E-10_JPRB, 0.88287037E-10_JPRB, 0.88284956E-10_JPRB, 0.88283103E-10_JPRB, &
  & 0.88282603E-10_JPRB, 0.88282465E-10_JPRB, 0.88282798E-10_JPRB, 0.88284879E-10_JPRB, 0.88284449E-10_JPRB, 0.88286142E-10_JPRB, &
  & 0.88286739E-10_JPRB, 0.88287821E-10_JPRB, 0.88286801E-10_JPRB, 0.88289327E-10_JPRB, 0.88287634E-10_JPRB, 0.88285282E-10_JPRB, &
  & 0.88284761E-10_JPRB, 0.88284512E-10_JPRB, 0.88283617E-10_JPRB, 0.88283325E-10_JPRB, 0.88282388E-10_JPRB, 0.88280321E-10_JPRB, &
  & 0.88278801E-10_JPRB, 0.88277774E-10_JPRB, 0.88275831E-10_JPRB, 0.88276379E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART22',1,ZHOOK_HANDLE)
END SUBROUTINE PART22






SUBROUTINE PART23
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART23',0,ZHOOK_HANDLE)



!-- Month= 12 ------------

RGHG9(:, 1,12) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.42038954E-44_JPRB, &
  & 0.56051939E-44_JPRB, 0.70064923E-44_JPRB, 0.12611686E-43_JPRB, 0.11210388E-43_JPRB, 0.11210388E-43_JPRB, 0.11210388E-43_JPRB, &
  & 0.14012985E-43_JPRB, 0.98090893E-44_JPRB, 0.11210388E-43_JPRB, 0.98090893E-44_JPRB, 0.98090893E-44_JPRB, 0.84077908E-44_JPRB, &
  & 0.70064923E-44_JPRB, 0.70064923E-44_JPRB, 0.42038954E-44_JPRB, 0.28025969E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.14012985E-44_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 2,12) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.28025969E-44_JPRB, 0.84077908E-44_JPRB, 0.18216880E-43_JPRB, 0.39236357E-43_JPRB, 0.84077908E-43_JPRB, 0.14573504E-42_JPRB, &
  & 0.21159607E-42_JPRB, 0.30828566E-42_JPRB, 0.49605966E-42_JPRB, 0.44421161E-42_JPRB, 0.46803369E-42_JPRB, 0.47363888E-42_JPRB, &
  & 0.52268433E-42_JPRB, 0.43159993E-42_JPRB, 0.41898824E-42_JPRB, 0.38115318E-42_JPRB, 0.36013371E-42_JPRB, 0.33631163E-42_JPRB, &
  & 0.29847657E-42_JPRB, 0.24522723E-42_JPRB, 0.18497140E-42_JPRB, 0.13172206E-42_JPRB, 0.88281803E-43_JPRB, 0.56051939E-43_JPRB, &
  & 0.35032462E-43_JPRB, 0.21019477E-43_JPRB, 0.12611686E-43_JPRB, 0.70064923E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 3,12) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.42038954E-44_JPRB, 0.14012985E-43_JPRB, 0.42038954E-43_JPRB, &
  & 0.12891946E-42_JPRB, 0.34752202E-42_JPRB, 0.82256220E-42_JPRB, 0.17376101E-41_JPRB, 0.38353539E-41_JPRB, 0.69238157E-41_JPRB, &
  & 0.10170624E-40_JPRB, 0.14912618E-40_JPRB, 0.23879527E-40_JPRB, 0.21369802E-40_JPRB, 0.22462814E-40_JPRB, 0.22744475E-40_JPRB, &
  & 0.24845022E-40_JPRB, 0.20746224E-40_JPRB, 0.19960095E-40_JPRB, 0.18174841E-40_JPRB, 0.17066414E-40_JPRB, 0.15796838E-40_JPRB, &
  & 0.13917696E-40_JPRB, 0.11458418E-40_JPRB, 0.87553128E-41_JPRB, 0.62581989E-41_JPRB, 0.42305201E-41_JPRB, 0.27283281E-41_JPRB, &
  & 0.16913672E-41_JPRB, 0.10173427E-41_JPRB, 0.59415055E-42_JPRB, 0.33771293E-42_JPRB, 0.18917529E-42_JPRB, 0.10229479E-42_JPRB, &
  & 0.54650640E-43_JPRB, 0.28025969E-43_JPRB, 0.14012985E-43_JPRB, 0.70064923E-44_JPRB, 0.28025969E-44_JPRB, 0.14012985E-44_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB /)

RGHG9(:, 4,12) = (/ &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, &
  & 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.00000000E+00_JPRB, 0.14012985E-44_JPRB, 0.28025969E-44_JPRB, 0.56051939E-44_JPRB, &
  & 0.19618179E-43_JPRB, 0.57453237E-43_JPRB, 0.15694543E-42_JPRB, 0.50166485E-42_JPRB, 0.12611686E-41_JPRB, 0.35480877E-41_JPRB, &
  & 0.10613435E-40_JPRB, 0.28652350E-40_JPRB, 0.68157756E-40_JPRB, 0.14351819E-39_JPRB, 0.33494116E-39_JPRB, 0.62209524E-39_JPRB, &
  & 0.91150962E-39_JPRB, 0.13374987E-38_JPRB, 0.21574517E-38_JPRB, 0.19046449E-38_JPRB, 0.19964509E-38_JPRB, 0.20175279E-38_JPRB, &
  & 0.22027809E-38_JPRB, 0.18320548E-38_JPRB, 0.17598949E-38_JPRB, 0.15988872E-38_JPRB, 0.14981408E-38_JPRB, 0.13853279E-38_JPRB, &
  & 0.12202059E-38_JPRB, 0.10062794E-38_JPRB, 0.77149047E-39_JPRB, 0.55491699E-39_JPRB, 0.37686941E-39_JPRB, 0.24510111E-39_JPRB, &
  & 0.15297135E-39_JPRB, 0.93015389E-40_JPRB, 0.55041602E-40_JPRB, 0.31882343E-40_JPRB, 0.18089362E-40_JPRB, 0.99898568E-41_JPRB, &
  & 0.54258277E-41_JPRB, 0.28782670E-41_JPRB, 0.15049946E-41_JPRB, 0.77631935E-42_JPRB, 0.39796876E-42_JPRB, 0.20458958E-42_JPRB, &
  & 0.10649868E-42_JPRB, 0.57453237E-43_JPRB, 0.33631163E-43_JPRB, 0.22420775E-43_JPRB, 0.15414283E-43_JPRB, 0.11210388E-43_JPRB, &
  & 0.98090893E-44_JPRB, 0.70064923E-44_JPRB, 0.56051939E-44_JPRB, 0.28025969E-44_JPRB /)

RGHG9(:, 5,12) = (/ &
  & 0.22701035E-42_JPRB, 0.13732725E-42_JPRB, 0.74268819E-43_JPRB, 0.50446745E-43_JPRB, 0.47644148E-43_JPRB, 0.51848043E-43_JPRB, &
  & 0.63058431E-43_JPRB, 0.92485699E-43_JPRB, 0.16114932E-42_JPRB, 0.31669345E-42_JPRB, 0.66141288E-42_JPRB, 0.15035933E-41_JPRB, &
  & 0.43958733E-41_JPRB, 0.12695764E-40_JPRB, 0.33307463E-40_JPRB, 0.10372271E-39_JPRB, 0.25311374E-39_JPRB, 0.69027402E-39_JPRB, &
  & 0.20177395E-38_JPRB, 0.53520913E-38_JPRB, 0.12508167E-37_JPRB, 0.25756735E-37_JPRB, 0.60845999E-37_JPRB, 0.11318555E-36_JPRB, &
  & 0.16332641E-36_JPRB, 0.23689814E-36_JPRB, 0.37985699E-36_JPRB, 0.33034766E-36_JPRB, 0.34353478E-36_JPRB, 0.34452526E-36_JPRB, &
  & 0.37628420E-36_JPRB, 0.31017609E-36_JPRB, 0.29863995E-36_JPRB, 0.27115701E-36_JPRB, 0.25499977E-36_JPRB, 0.23688164E-36_JPRB, &
  & 0.21006733E-36_JPRB, 0.17459780E-36_JPRB, 0.13525239E-36_JPRB, 0.98414301E-37_JPRB, 0.67892210E-37_JPRB, 0.44857957E-37_JPRB, &
  & 0.28579213E-37_JPRB, 0.17776679E-37_JPRB, 0.10795367E-37_JPRB, 0.64296604E-38_JPRB, 0.37508920E-38_JPRB, 0.21252415E-38_JPRB, &
  & 0.11775573E-38_JPRB, 0.63260078E-39_JPRB, 0.33187512E-39_JPRB, 0.17026897E-39_JPRB, 0.86097179E-40_JPRB, 0.43370187E-40_JPRB, &
  & 0.22216186E-40_JPRB, 0.11845176E-40_JPRB, 0.68061066E-41_JPRB, 0.43244071E-41_JPRB, 0.30618371E-41_JPRB, 0.23780035E-41_JPRB, &
  & 0.19674230E-41_JPRB, 0.16619400E-41_JPRB, 0.13088128E-41_JPRB, 0.77351675E-42_JPRB /)

RGHG9(:, 6,12) = (/ &
  & 0.53233927E-40_JPRB, 0.47122865E-40_JPRB, 0.27975523E-40_JPRB, 0.20854124E-40_JPRB, 0.21423051E-40_JPRB, 0.23953796E-40_JPRB, &
  & 0.30162949E-40_JPRB, 0.44992891E-40_JPRB, 0.78520358E-40_JPRB, 0.15418347E-39_JPRB, 0.31498387E-39_JPRB, 0.69568023E-39_JPRB, &
  & 0.19873537E-38_JPRB, 0.55389040E-38_JPRB, 0.13895996E-37_JPRB, 0.41425006E-37_JPRB, 0.96358271E-37_JPRB, 0.25000931E-36_JPRB, &
  & 0.69750512E-36_JPRB, 0.17662088E-35_JPRB, 0.39520990E-35_JPRB, 0.77727864E-35_JPRB, 0.17818273E-34_JPRB, 0.32201325E-34_JPRB, &
  & 0.45050488E-34_JPRB, 0.63569133E-34_JPRB, 0.10005816E-33_JPRB, 0.85142749E-34_JPRB, 0.87137801E-34_JPRB, 0.86289166E-34_JPRB, &
  & 0.93876775E-34_JPRB, 0.76879139E-34_JPRB, 0.74275774E-34_JPRB, 0.67798846E-34_JPRB, 0.64335805E-34_JPRB, 0.60550598E-34_JPRB, &
  & 0.54563859E-34_JPRB, 0.46276871E-34_JPRB, 0.36679071E-34_JPRB, 0.27420432E-34_JPRB, 0.19467657E-34_JPRB, 0.13290047E-34_JPRB, &
  & 0.87606916E-35_JPRB, 0.56549701E-35_JPRB, 0.35701910E-35_JPRB, 0.22131695E-35_JPRB, 0.13436115E-35_JPRB, 0.79062093E-36_JPRB, &
  & 0.45327005E-36_JPRB, 0.25057391E-36_JPRB, 0.13457579E-36_JPRB, 0.70468071E-37_JPRB, 0.36374872E-37_JPRB, 0.18793835E-37_JPRB, &
  & 0.99479607E-38_JPRB, 0.55219904E-38_JPRB, 0.33069635E-38_JPRB, 0.21809585E-38_JPRB, 0.15856211E-38_JPRB, 0.12517281E-38_JPRB, &
  & 0.10520865E-38_JPRB, 0.91393527E-39_JPRB, 0.78884696E-39_JPRB, 0.59389551E-39_JPRB /)

RGHG9(:, 7,12) = (/ &
  & 0.50471677E-37_JPRB, 0.27799298E-37_JPRB, 0.15869335E-37_JPRB, 0.12065393E-37_JPRB, 0.13179122E-37_JPRB, 0.15583275E-37_JPRB, &
  & 0.20450791E-37_JPRB, 0.31453327E-37_JPRB, 0.54224191E-37_JPRB, 0.10423795E-36_JPRB, 0.20248498E-36_JPRB, 0.42048779E-36_JPRB, &
  & 0.11311697E-35_JPRB, 0.29638041E-35_JPRB, 0.69488462E-35_JPRB, 0.19449157E-34_JPRB, 0.42243462E-34_JPRB, 0.10247072E-33_JPRB, &
  & 0.26802454E-33_JPRB, 0.63839656E-33_JPRB, 0.13455781E-32_JPRB, 0.24988595E-32_JPRB, 0.54647167E-32_JPRB, 0.94993961E-32_JPRB, &
  & 0.12767920E-31_JPRB, 0.17401980E-31_JPRB, 0.26828496E-31_JPRB, 0.22188321E-31_JPRB, 0.22287385E-31_JPRB, 0.21763764E-31_JPRB, &
  & 0.23533701E-31_JPRB, 0.19210126E-31_JPRB, 0.18642300E-31_JPRB, 0.17147293E-31_JPRB, 0.16470793E-31_JPRB, 0.15746473E-31_JPRB, &
  & 0.14484056E-31_JPRB, 0.12600618E-31_JPRB, 0.10299435E-31_JPRB, 0.79673920E-32_JPRB, 0.58728388E-32_JPRB, 0.41679992E-32_JPRB, &
  & 0.28613755E-32_JPRB, 0.19264993E-32_JPRB, 0.12696345E-32_JPRB, 0.82229981E-33_JPRB, 0.52163673E-33_JPRB, 0.32029753E-33_JPRB, &
  & 0.19154117E-33_JPRB, 0.11015695E-33_JPRB, 0.61569071E-34_JPRB, 0.33603590E-34_JPRB, 0.18215167E-34_JPRB, 0.99785695E-35_JPRB, &
  & 0.56675925E-35_JPRB, 0.33882929E-35_JPRB, 0.21777290E-35_JPRB, 0.15193930E-35_JPRB, 0.11479074E-35_JPRB, 0.92873040E-36_JPRB, &
  & 0.79165265E-36_JPRB, 0.69464907E-36_JPRB, 0.61213380E-36_JPRB, 0.48572202E-36_JPRB /)

RGHG9(:, 8,12) = (/ &
  & 0.44190759E-34_JPRB, 0.19666813E-34_JPRB, 0.10287816E-34_JPRB, 0.77932542E-35_JPRB, 0.87275591E-35_JPRB, 0.10592094E-34_JPRB, &
  & 0.14161717E-34_JPRB, 0.21637585E-34_JPRB, 0.36588860E-34_JPRB, 0.66994563E-34_JPRB, 0.12280383E-33_JPRB, 0.23717066E-33_JPRB, &
  & 0.59637792E-33_JPRB, 0.14605519E-32_JPRB, 0.31745092E-32_JPRB, 0.83160509E-32_JPRB, 0.16747590E-31_JPRB, 0.37737953E-31_JPRB, &
  & 0.92410272E-31_JPRB, 0.20663728E-30_JPRB, 0.41002329E-30_JPRB, 0.71545467E-30_JPRB, 0.14948763E-29_JPRB, 0.24922906E-29_JPRB, &
  & 0.32099313E-29_JPRB, 0.42128002E-29_JPRB, 0.63617980E-29_JPRB, 0.51001529E-29_JPRB, 0.50243939E-29_JPRB, 0.48370562E-29_JPRB, &
  & 0.51926840E-29_JPRB, 0.42299158E-29_JPRB, 0.41193734E-29_JPRB, 0.38206034E-29_JPRB, 0.37154356E-29_JPRB, 0.36106759E-29_JPRB, &
  & 0.33932106E-29_JPRB, 0.30342735E-29_JPRB, 0.25643900E-29_JPRB, 0.20609215E-29_JPRB, 0.15823057E-29_JPRB, 0.11715574E-29_JPRB, &
  & 0.83868691E-30_JPRB, 0.58896988E-30_JPRB, 0.40461193E-30_JPRB, 0.27317917E-30_JPRB, 0.18070471E-30_JPRB, 0.11560914E-30_JPRB, &
  & 0.72205469E-31_JPRB, 0.43391499E-31_JPRB, 0.25440260E-31_JPRB, 0.14652223E-31_JPRB, 0.84428816E-32_JPRB, 0.49603812E-32_JPRB, &
  & 0.30349854E-32_JPRB, 0.19507066E-32_JPRB, 0.13346814E-32_JPRB, 0.97796621E-33_JPRB, 0.76505213E-33_JPRB, 0.63295595E-33_JPRB, &
  & 0.54728597E-33_JPRB, 0.48477502E-33_JPRB, 0.43004184E-33_JPRB, 0.34441112E-33_JPRB /)

RGHG9(:, 9,12) = (/ &
  & 0.34129282E-31_JPRB, 0.13833350E-31_JPRB, 0.69345402E-32_JPRB, 0.51310663E-32_JPRB, 0.57467410E-32_JPRB, 0.69223995E-32_JPRB, &
  & 0.90885454E-32_JPRB, 0.13526070E-31_JPRB, 0.21889572E-31_JPRB, 0.38157414E-31_JPRB, 0.65692231E-31_JPRB, 0.11778885E-30_JPRB, &
  & 0.27717470E-30_JPRB, 0.63418823E-30_JPRB, 0.12743568E-29_JPRB, 0.31276211E-29_JPRB, 0.58222408E-29_JPRB, 0.12169881E-28_JPRB, &
  & 0.27925987E-28_JPRB, 0.58734056E-28_JPRB, 0.10975338E-27_JPRB, 0.17993903E-27_JPRB, 0.35859222E-27_JPRB, 0.57287735E-27_JPRB, &
  & 0.70506755E-27_JPRB, 0.88965811E-27_JPRB, 0.13106536E-26_JPRB, 0.10192587E-26_JPRB, 0.98358061E-27_JPRB, 0.93255618E-27_JPRB, &
  & 0.99214185E-27_JPRB, 0.80545337E-27_JPRB, 0.78603244E-27_JPRB, 0.73489043E-27_JPRB, 0.72419193E-27_JPRB, 0.71678115E-27_JPRB, &
  & 0.68984880E-27_JPRB, 0.63564321E-27_JPRB, 0.55684167E-27_JPRB, 0.46648132E-27_JPRB, 0.37438099E-27_JPRB, 0.29022739E-27_JPRB, &
  & 0.21708851E-27_JPRB, 0.15922592E-27_JPRB, 0.11395044E-27_JPRB, 0.80124295E-28_JPRB, 0.55214474E-28_JPRB, 0.36778723E-28_JPRB, &
  & 0.24035145E-28_JPRB, 0.15139219E-28_JPRB, 0.93677541E-29_JPRB, 0.57207639E-29_JPRB, 0.35174571E-29_JPRB, 0.22083217E-29_JPRB, &
  & 0.14433692E-29_JPRB, 0.98274600E-30_JPRB, 0.70579620E-30_JPRB, 0.53665615E-30_JPRB, 0.43102232E-30_JPRB, 0.36305108E-30_JPRB, &
  & 0.31733403E-30_JPRB, 0.28410920E-30_JPRB, 0.25203941E-30_JPRB, 0.20563393E-30_JPRB /)

RGHG9(:,10,12) = (/ &
  & 0.22628350E-28_JPRB, 0.89257757E-29_JPRB, 0.43614666E-29_JPRB, 0.31667728E-29_JPRB, 0.34837391E-29_JPRB, 0.40880575E-29_JPRB, &
  & 0.51860554E-29_JPRB, 0.74043407E-29_JPRB, 0.11430118E-28_JPRB, 0.18910887E-28_JPRB, 0.30598775E-28_JPRB, 0.50979679E-28_JPRB, &
  & 0.11226166E-27_JPRB, 0.24008968E-27_JPRB, 0.44562711E-27_JPRB, 0.10249667E-26_JPRB, 0.17627908E-26_JPRB, 0.34145563E-26_JPRB, &
  & 0.73423406E-26_JPRB, 0.14519205E-25_JPRB, 0.25553297E-25_JPRB, 0.39288580E-25_JPRB, 0.74629397E-25_JPRB, 0.11376385E-24_JPRB, &
  & 0.13371766E-24_JPRB, 0.16190552E-24_JPRB, 0.23166503E-24_JPRB, 0.17507910E-24_JPRB, 0.16521082E-24_JPRB, 0.15408331E-24_JPRB, &
  & 0.16222146E-24_JPRB, 0.13109454E-24_JPRB, 0.12808617E-24_JPRB, 0.12071906E-24_JPRB, 0.12070394E-24_JPRB, 0.12194450E-24_JPRB, &
  & 0.12049074E-24_JPRB, 0.11461870E-24_JPRB, 0.10429826E-24_JPRB, 0.91197627E-25_JPRB, 0.76750946E-25_JPRB, 0.62453508E-25_JPRB, &
  & 0.49001346E-25_JPRB, 0.37614315E-25_JPRB, 0.28099792E-25_JPRB, 0.20603554E-25_JPRB, 0.14812315E-25_JPRB, 0.10287551E-25_JPRB, &
  & 0.70529272E-26_JPRB, 0.46681322E-26_JPRB, 0.30538735E-26_JPRB, 0.19779532E-26_JPRB, 0.12915051E-26_JPRB, 0.85983999E-27_JPRB, &
  & 0.59309345E-27_JPRB, 0.42299628E-27_JPRB, 0.31540774E-27_JPRB, 0.24681028E-27_JPRB, 0.20231687E-27_JPRB, 0.17277554E-27_JPRB, &
  & 0.15289600E-27_JPRB, 0.13685368E-27_JPRB, 0.12381267E-27_JPRB, 0.99763171E-28_JPRB /)

RGHG9(:,11,12) = (/ &
  & 0.12617438E-25_JPRB, 0.49213253E-26_JPRB, 0.23748846E-26_JPRB, 0.16931351E-26_JPRB, 0.18201956E-26_JPRB, 0.20740309E-26_JPRB, &
  & 0.25364904E-26_JPRB, 0.34717926E-26_JPRB, 0.51123094E-26_JPRB, 0.80386005E-26_JPRB, 0.12262555E-25_JPRB, 0.19021982E-25_JPRB, &
  & 0.39251445E-25_JPRB, 0.78529735E-25_JPRB, 0.13482715E-24_JPRB, 0.29057184E-24_JPRB, 0.46239654E-24_JPRB, 0.83029957E-24_JPRB, &
  & 0.16707727E-23_JPRB, 0.31024493E-23_JPRB, 0.51357953E-23_JPRB, 0.74114145E-23_JPRB, 0.13363207E-22_JPRB, 0.19413512E-22_JPRB, &
  & 0.21778511E-22_JPRB, 0.25285788E-22_JPRB, 0.35021966E-22_JPRB, 0.25734717E-22_JPRB, 0.23702167E-22_JPRB, 0.21712918E-22_JPRB, &
  & 0.22594694E-22_JPRB, 0.18164090E-22_JPRB, 0.17769442E-22_JPRB, 0.16891614E-22_JPRB, 0.17156895E-22_JPRB, 0.17719460E-22_JPRB, &
  & 0.17999045E-22_JPRB, 0.17695834E-22_JPRB, 0.16727196E-22_JPRB, 0.15275660E-22_JPRB, 0.13473487E-22_JPRB, 0.11531103E-22_JPRB, &
  & 0.95049708E-23_JPRB, 0.76665715E-23_JPRB, 0.59960682E-23_JPRB, 0.46005532E-23_JPRB, 0.34624458E-23_JPRB, 0.25141938E-23_JPRB, &
  & 0.18131333E-23_JPRB, 0.12625365E-23_JPRB, 0.87254909E-24_JPRB, 0.59723703E-24_JPRB, 0.41173629E-24_JPRB, 0.28838694E-24_JPRB, &
  & 0.20821200E-24_JPRB, 0.15432170E-24_JPRB, 0.11870445E-24_JPRB, 0.95120084E-25_JPRB, 0.79334040E-25_JPRB, 0.68629111E-25_JPRB, &
  & 0.60952835E-25_JPRB, 0.55458136E-25_JPRB, 0.49458614E-25_JPRB, 0.41566690E-25_JPRB /)

RGHG9(:,12,12) = (/ &
  & 0.58601491E-23_JPRB, 0.22651853E-23_JPRB, 0.10817414E-23_JPRB, 0.75863067E-24_JPRB, 0.79799739E-24_JPRB, 0.88560217E-24_JPRB, &
  & 0.10480718E-23_JPRB, 0.13797495E-23_JPRB, 0.19432060E-23_JPRB, 0.29097474E-23_JPRB, 0.41936788E-23_JPRB, 0.60789136E-23_JPRB, &
  & 0.11755197E-22_JPRB, 0.22014740E-22_JPRB, 0.35043549E-22_JPRB, 0.70680101E-22_JPRB, 0.10430990E-21_JPRB, 0.17374794E-21_JPRB, &
  & 0.32667414E-21_JPRB, 0.56870050E-21_JPRB, 0.88468845E-21_JPRB, 0.11985714E-20_JPRB, 0.20474726E-20_JPRB, 0.28305454E-20_JPRB, &
  & 0.30313324E-20_JPRB, 0.33721274E-20_JPRB, 0.45119168E-20_JPRB, 0.32213196E-20_JPRB, 0.28901297E-20_JPRB, 0.25962715E-20_JPRB, &
  & 0.26674380E-20_JPRB, 0.21328836E-20_JPRB, 0.20899928E-20_JPRB, 0.20056583E-20_JPRB, 0.20714893E-20_JPRB, 0.21891892E-20_JPRB, &
  & 0.22880115E-20_JPRB, 0.23257839E-20_JPRB, 0.22839775E-20_JPRB, 0.21755472E-20_JPRB, 0.20101785E-20_JPRB, 0.18066109E-20_JPRB, &
  & 0.15676295E-20_JPRB, 0.13309092E-20_JPRB, 0.10945329E-20_JPRB, 0.88248549E-21_JPRB, 0.69781217E-21_JPRB, 0.53155694E-21_JPRB, &
  & 0.40390057E-21_JPRB, 0.29579633E-21_JPRB, 0.21558069E-21_JPRB, 0.15531206E-21_JPRB, 0.11250400E-21_JPRB, 0.82414918E-22_JPRB, &
  & 0.61943813E-22_JPRB, 0.47463542E-22_JPRB, 0.37514227E-22_JPRB, 0.30686740E-22_JPRB, 0.25982084E-22_JPRB, 0.22680931E-22_JPRB, &
  & 0.20392283E-22_JPRB, 0.18437172E-22_JPRB, 0.16847026E-22_JPRB, 0.13775449E-22_JPRB /)

RGHG9(:,13,12) = (/ &
  & 0.22802623E-20_JPRB, 0.87372770E-21_JPRB, 0.41321057E-21_JPRB, 0.28575839E-21_JPRB, 0.29488567E-21_JPRB, 0.31974948E-21_JPRB, &
  & 0.36740511E-21_JPRB, 0.46650977E-21_JPRB, 0.62954796E-21_JPRB, 0.89830219E-21_JPRB, 0.12246095E-20_JPRB, 0.16622053E-20_JPRB, &
  & 0.30098707E-20_JPRB, 0.52750350E-20_JPRB, 0.77948985E-20_JPRB, 0.14690408E-19_JPRB, 0.20134142E-19_JPRB, 0.31118741E-19_JPRB, &
  & 0.54588854E-19_JPRB, 0.88976885E-19_JPRB, 0.12993826E-18_JPRB, 0.16533958E-18_JPRB, 0.26698172E-18_JPRB, 0.35102715E-18_JPRB, &
  & 0.35880109E-18_JPRB, 0.38207746E-18_JPRB, 0.49302839E-18_JPRB, 0.34178987E-18_JPRB, 0.29835378E-18_JPRB, 0.26268459E-18_JPRB, &
  & 0.26648001E-18_JPRB, 0.21208664E-18_JPRB, 0.20835706E-18_JPRB, 0.20198129E-18_JPRB, 0.21217289E-18_JPRB, 0.22946768E-18_JPRB, &
  & 0.24670690E-18_JPRB, 0.25918981E-18_JPRB, 0.26424044E-18_JPRB, 0.26238903E-18_JPRB, 0.25368650E-18_JPRB, 0.23941037E-18_JPRB, &
  & 0.21876371E-18_JPRB, 0.19596013E-18_JPRB, 0.17010481E-18_JPRB, 0.14470565E-18_JPRB, 0.12069472E-18_JPRB, 0.96762910E-19_JPRB, &
  & 0.77538534E-19_JPRB, 0.59742965E-19_JPRB, 0.45819176E-19_JPRB, 0.34667052E-19_JPRB, 0.26288701E-19_JPRB, 0.20082018E-19_JPRB, &
  & 0.15654295E-19_JPRB, 0.12366464E-19_JPRB, 0.10012890E-19_JPRB, 0.83439792E-20_JPRB, 0.71579234E-20_JPRB, 0.63119119E-20_JPRB, &
  & 0.56833039E-20_JPRB, 0.52017754E-20_JPRB, 0.46861939E-20_JPRB, 0.39376612E-20_JPRB /)

RGHG9(:,14,12) = (/ &
  & 0.74849449E-18_JPRB, 0.28437066E-18_JPRB, 0.13329228E-18_JPRB, 0.91009048E-19_JPRB, 0.92302067E-19_JPRB, 0.97922817E-19_JPRB, &
  & 0.10941498E-18_JPRB, 0.13412252E-18_JPRB, 0.17360806E-18_JPRB, 0.23605690E-18_JPRB, 0.30463374E-18_JPRB, 0.38764832E-18_JPRB, &
  & 0.65702139E-18_JPRB, 0.10772261E-17_JPRB, 0.14792961E-17_JPRB, 0.26020077E-17_JPRB, 0.33156592E-17_JPRB, 0.47560879E-17_JPRB, &
  & 0.77779967E-17_JPRB, 0.11861290E-16_JPRB, 0.16250479E-16_JPRB, 0.19418366E-16_JPRB, 0.29605069E-16_JPRB, 0.36996000E-16_JPRB, &
  & 0.36081089E-16_JPRB, 0.36747528E-16_JPRB, 0.45665799E-16_JPRB, 0.30727854E-16_JPRB, 0.26092651E-16_JPRB, 0.22527806E-16_JPRB, &
  & 0.22587464E-16_JPRB, 0.17916011E-16_JPRB, 0.17659006E-16_JPRB, 0.17291314E-16_JPRB, 0.18461771E-16_JPRB, 0.20409338E-16_JPRB, &
  & 0.22549334E-16_JPRB, 0.24459129E-16_JPRB, 0.25861019E-16_JPRB, 0.26750450E-16_JPRB, 0.27056180E-16_JPRB, 0.26806331E-16_JPRB, &
  & 0.25812575E-16_JPRB, 0.24421723E-16_JPRB, 0.22433413E-16_JPRB, 0.20203407E-16_JPRB, 0.17823860E-16_JPRB, 0.15096825E-16_JPRB, &
  & 0.12775232E-16_JPRB, 0.10367591E-16_JPRB, 0.83697145E-17_JPRB, 0.66449387E-17_JPRB, 0.52725890E-17_JPRB, 0.41934988E-17_JPRB, &
  & 0.33866925E-17_JPRB, 0.27532624E-17_JPRB, 0.22808792E-17_JPRB, 0.19333107E-17_JPRB, 0.16788344E-17_JPRB, 0.14915648E-17_JPRB, &
  & 0.13515421E-17_JPRB, 0.12347445E-17_JPRB, 0.11220242E-17_JPRB, 0.92620344E-18_JPRB /)

RGHG9(:,15,12) = (/ &
  & 0.20836828E-15_JPRB, 0.78565178E-16_JPRB, 0.36502938E-16_JPRB, 0.24618318E-16_JPRB, 0.24553425E-16_JPRB, 0.25490386E-16_JPRB, &
  & 0.27694182E-16_JPRB, 0.32783342E-16_JPRB, 0.40691608E-16_JPRB, 0.52736639E-16_JPRB, 0.64431129E-16_JPRB, 0.76938451E-16_JPRB, &
  & 0.12202582E-15_JPRB, 0.18717972E-15_JPRB, 0.23908498E-15_JPRB, 0.39228105E-15_JPRB, 0.46511950E-15_JPRB, 0.61927913E-15_JPRB, &
  & 0.94376866E-15_JPRB, 0.13460469E-14_JPRB, 0.17294460E-14_JPRB, 0.19396938E-14_JPRB, 0.27905579E-14_JPRB, 0.33135344E-14_JPRB, &
  & 0.30815624E-14_JPRB, 0.29991319E-14_JPRB, 0.35863587E-14_JPRB, 0.23424690E-14_JPRB, 0.19352113E-14_JPRB, 0.16398149E-14_JPRB, &
  & 0.16263673E-14_JPRB, 0.12861552E-14_JPRB, 0.12716792E-14_JPRB, 0.12567791E-14_JPRB, 0.13628076E-14_JPRB, 0.15398415E-14_JPRB, &
  & 0.17483662E-14_JPRB, 0.19578923E-14_JPRB, 0.21461750E-14_JPRB, 0.23113145E-14_JPRB, 0.24445468E-14_JPRB, 0.25424456E-14_JPRB, &
  & 0.25798392E-14_JPRB, 0.25785059E-14_JPRB, 0.25083919E-14_JPRB, 0.23942913E-14_JPRB, 0.22386312E-14_JPRB, 0.20083890E-14_JPRB, &
  & 0.17979570E-14_JPRB, 0.15399526E-14_JPRB, 0.13094289E-14_JPRB, 0.10916014E-14_JPRB, 0.90592440E-15_JPRB, 0.74998309E-15_JPRB, &
  & 0.62686563E-15_JPRB, 0.52411355E-15_JPRB, 0.44382864E-15_JPRB, 0.38242391E-15_JPRB, 0.33589539E-15_JPRB, 0.30045722E-15_JPRB, &
  & 0.27365972E-15_JPRB, 0.25004262E-15_JPRB, 0.22748290E-15_JPRB, 0.18644602E-15_JPRB /)

RGHG9(:,16,12) = (/ &
  & 0.11171487E-14_JPRB, 0.33355620E-15_JPRB, 0.23325186E-15_JPRB, 0.19440198E-15_JPRB, 0.17524168E-15_JPRB, 0.17910480E-15_JPRB, &
  & 0.21764913E-15_JPRB, 0.31476350E-15_JPRB, 0.48226181E-15_JPRB, 0.66824309E-15_JPRB, 0.79355955E-15_JPRB, 0.96068338E-15_JPRB, &
  & 0.13557131E-14_JPRB, 0.20880880E-14_JPRB, 0.27178333E-14_JPRB, 0.39590290E-14_JPRB, 0.59454200E-14_JPRB, 0.79438655E-14_JPRB, &
  & 0.10282687E-13_JPRB, 0.14280391E-13_JPRB, 0.18863529E-13_JPRB, 0.20436625E-13_JPRB, 0.24088201E-13_JPRB, 0.26902922E-13_JPRB, &
  & 0.27569069E-13_JPRB, 0.26542797E-13_JPRB, 0.24484068E-13_JPRB, 0.22636571E-13_JPRB, 0.18353244E-13_JPRB, 0.15415159E-13_JPRB, &
  & 0.12538332E-13_JPRB, 0.11291015E-13_JPRB, 0.10855359E-13_JPRB, 0.11383545E-13_JPRB, 0.12728981E-13_JPRB, 0.14678923E-13_JPRB, &
  & 0.16907860E-13_JPRB, 0.19060093E-13_JPRB, 0.20871332E-13_JPRB, 0.22271224E-13_JPRB, 0.23191837E-13_JPRB, 0.23594138E-13_JPRB, &
  & 0.23460842E-13_JPRB, 0.22861169E-13_JPRB, 0.21910918E-13_JPRB, 0.20674333E-13_JPRB, 0.19189562E-13_JPRB, 0.17468249E-13_JPRB, &
  & 0.15584522E-13_JPRB, 0.13656772E-13_JPRB, 0.11777910E-13_JPRB, 0.99914270E-14_JPRB, 0.84239502E-14_JPRB, 0.70692404E-14_JPRB, &
  & 0.59178118E-14_JPRB, 0.49459359E-14_JPRB, 0.41670832E-14_JPRB, 0.35584290E-14_JPRB, 0.30902909E-14_JPRB, 0.27351818E-14_JPRB, &
  & 0.24562909E-14_JPRB, 0.22447400E-14_JPRB, 0.20101945E-14_JPRB, 0.16829586E-14_JPRB /)

RGHG9(:,17,12) = (/ &
  & 0.36553741E-14_JPRB, 0.38218995E-14_JPRB, 0.34093409E-14_JPRB, 0.30470102E-14_JPRB, 0.28302189E-14_JPRB, 0.27724185E-14_JPRB, &
  & 0.29156450E-14_JPRB, 0.33580803E-14_JPRB, 0.43366198E-14_JPRB, 0.61027784E-14_JPRB, 0.84753592E-14_JPRB, 0.11229832E-13_JPRB, &
  & 0.14970221E-13_JPRB, 0.20648358E-13_JPRB, 0.28572149E-13_JPRB, 0.39238422E-13_JPRB, 0.53252846E-13_JPRB, 0.67965429E-13_JPRB, &
  & 0.85632016E-13_JPRB, 0.10718516E-12_JPRB, 0.12693152E-12_JPRB, 0.14198844E-12_JPRB, 0.15293123E-12_JPRB, 0.15635927E-12_JPRB, &
  & 0.15064427E-12_JPRB, 0.14009887E-12_JPRB, 0.12362000E-12_JPRB, 0.10561425E-12_JPRB, 0.91776271E-13_JPRB, 0.78575703E-13_JPRB, &
  & 0.70866266E-13_JPRB, 0.67672071E-13_JPRB, 0.69057444E-13_JPRB, 0.75128299E-13_JPRB, 0.85391546E-13_JPRB, 0.98857215E-13_JPRB, &
  & 0.11360034E-12_JPRB, 0.12734844E-12_JPRB, 0.13779547E-12_JPRB, 0.14464635E-12_JPRB, 0.14728125E-12_JPRB, 0.14660644E-12_JPRB, &
  & 0.14264753E-12_JPRB, 0.13612538E-12_JPRB, 0.12811329E-12_JPRB, 0.11905040E-12_JPRB, 0.10915167E-12_JPRB, 0.98626294E-13_JPRB, &
  & 0.87926723E-13_JPRB, 0.77214968E-13_JPRB, 0.66814941E-13_JPRB, 0.57159952E-13_JPRB, 0.48568947E-13_JPRB, 0.41065001E-13_JPRB, &
  & 0.34373796E-13_JPRB, 0.28712035E-13_JPRB, 0.24120125E-13_JPRB, 0.20488582E-13_JPRB, 0.17665506E-13_JPRB, 0.15499920E-13_JPRB, &
  & 0.13880498E-13_JPRB, 0.12529472E-13_JPRB, 0.11355257E-13_JPRB, 0.92862306E-14_JPRB /)

RGHG9(:,18,12) = (/ &
  & 0.33539466E-13_JPRB, 0.29074403E-13_JPRB, 0.27510773E-13_JPRB, 0.26850457E-13_JPRB, 0.26826477E-13_JPRB, 0.27550482E-13_JPRB, &
  & 0.29343491E-13_JPRB, 0.32953752E-13_JPRB, 0.39711723E-13_JPRB, 0.50766171E-13_JPRB, 0.66808972E-13_JPRB, 0.87976081E-13_JPRB, &
  & 0.11498277E-12_JPRB, 0.14984848E-12_JPRB, 0.19338394E-12_JPRB, 0.24921271E-12_JPRB, 0.31740506E-12_JPRB, 0.39004084E-12_JPRB, &
  & 0.46482978E-12_JPRB, 0.54157444E-12_JPRB, 0.60385703E-12_JPRB, 0.64129306E-12_JPRB, 0.65234233E-12_JPRB, 0.63486261E-12_JPRB, &
  & 0.59080670E-12_JPRB, 0.52953226E-12_JPRB, 0.46373577E-12_JPRB, 0.40362928E-12_JPRB, 0.35535913E-12_JPRB, 0.32497136E-12_JPRB, &
  & 0.31185858E-12_JPRB, 0.31592166E-12_JPRB, 0.33581758E-12_JPRB, 0.37181898E-12_JPRB, 0.42191172E-12_JPRB, 0.48193329E-12_JPRB, &
  & 0.54372929E-12_JPRB, 0.59932636E-12_JPRB, 0.63752839E-12_JPRB, 0.65471250E-12_JPRB, 0.65304018E-12_JPRB, 0.63611849E-12_JPRB, &
  & 0.60731227E-12_JPRB, 0.56944564E-12_JPRB, 0.52864950E-12_JPRB, 0.48619507E-12_JPRB, 0.44323806E-12_JPRB, 0.39964272E-12_JPRB, &
  & 0.35637601E-12_JPRB, 0.31392049E-12_JPRB, 0.27389717E-12_JPRB, 0.23702400E-12_JPRB, 0.20356473E-12_JPRB, 0.17317503E-12_JPRB, &
  & 0.14588795E-12_JPRB, 0.12261261E-12_JPRB, 0.10348747E-12_JPRB, 0.88154615E-13_JPRB, 0.76113981E-13_JPRB, 0.66812305E-13_JPRB, &
  & 0.59753248E-13_JPRB, 0.54207944E-13_JPRB, 0.48957522E-13_JPRB, 0.40832528E-13_JPRB /)

RGHG9(:,19,12) = (/ &
  & 0.10740001E-12_JPRB, 0.10995566E-12_JPRB, 0.11390545E-12_JPRB, 0.11984497E-12_JPRB, 0.12860390E-12_JPRB, 0.14116486E-12_JPRB, &
  & 0.15906140E-12_JPRB, 0.18466207E-12_JPRB, 0.22163570E-12_JPRB, 0.27273661E-12_JPRB, 0.34167111E-12_JPRB, 0.43071628E-12_JPRB, &
  & 0.54034522E-12_JPRB, 0.67511025E-12_JPRB, 0.83418320E-12_JPRB, 0.10183046E-11_JPRB, 0.12267102E-11_JPRB, 0.14474335E-11_JPRB, &
  & 0.16555319E-11_JPRB, 0.18347173E-11_JPRB, 0.19600365E-11_JPRB, 0.20049691E-11_JPRB, 0.19665452E-11_JPRB, 0.18514097E-11_JPRB, &
  & 0.16862223E-11_JPRB, 0.14992705E-11_JPRB, 0.13209205E-11_JPRB, 0.11870120E-11_JPRB, 0.10975981E-11_JPRB, 0.10659197E-11_JPRB, &
  & 0.10821158E-11_JPRB, 0.11425617E-11_JPRB, 0.12413246E-11_JPRB, 0.13761948E-11_JPRB, 0.15373398E-11_JPRB, 0.17126246E-11_JPRB, &
  & 0.18803676E-11_JPRB, 0.20154707E-11_JPRB, 0.20952472E-11_JPRB, 0.21208144E-11_JPRB, 0.20818026E-11_JPRB, 0.19999646E-11_JPRB, &
  & 0.18834602E-11_JPRB, 0.17515084E-11_JPRB, 0.16135876E-11_JPRB, 0.14767755E-11_JPRB, 0.13417739E-11_JPRB, 0.12099082E-11_JPRB, &
  & 0.10830982E-11_JPRB, 0.96298848E-12_JPRB, 0.85101847E-12_JPRB, 0.74701812E-12_JPRB, 0.65099385E-12_JPRB, 0.56010838E-12_JPRB, &
  & 0.47804642E-12_JPRB, 0.40705791E-12_JPRB, 0.34780363E-12_JPRB, 0.29956661E-12_JPRB, 0.26107212E-12_JPRB, 0.23111900E-12_JPRB, &
  & 0.20787412E-12_JPRB, 0.19027870E-12_JPRB, 0.17249345E-12_JPRB, 0.14716359E-12_JPRB /)

RGHG9(:,20,12) = (/ &
  & 0.32304620E-12_JPRB, 0.34912278E-12_JPRB, 0.37114447E-12_JPRB, 0.39791976E-12_JPRB, 0.43370711E-12_JPRB, 0.48262148E-12_JPRB, &
  & 0.54909218E-12_JPRB, 0.64060497E-12_JPRB, 0.76531712E-12_JPRB, 0.92620952E-12_JPRB, 0.11289235E-11_JPRB, 0.13788927E-11_JPRB, &
  & 0.16757347E-11_JPRB, 0.20196149E-11_JPRB, 0.24095205E-11_JPRB, 0.28365255E-11_JPRB, 0.32809020E-11_JPRB, 0.37223410E-11_JPRB, &
  & 0.41303011E-11_JPRB, 0.44493927E-11_JPRB, 0.46336637E-11_JPRB, 0.46494241E-11_JPRB, 0.45008099E-11_JPRB, 0.42105386E-11_JPRB, &
  & 0.38351770E-11_JPRB, 0.34550006E-11_JPRB, 0.31277071E-11_JPRB, 0.29044252E-11_JPRB, 0.28219699E-11_JPRB, 0.28534920E-11_JPRB, &
  & 0.29956864E-11_JPRB, 0.32248162E-11_JPRB, 0.35153035E-11_JPRB, 0.38524587E-11_JPRB, 0.42067114E-11_JPRB, 0.45475464E-11_JPRB, &
  & 0.48587037E-11_JPRB, 0.50802513E-11_JPRB, 0.51829682E-11_JPRB, 0.51471839E-11_JPRB, 0.50068569E-11_JPRB, 0.47710178E-11_JPRB, &
  & 0.44756343E-11_JPRB, 0.41541258E-11_JPRB, 0.38180618E-11_JPRB, 0.34946440E-11_JPRB, 0.31813170E-11_JPRB, 0.28848686E-11_JPRB, &
  & 0.26040465E-11_JPRB, 0.23436114E-11_JPRB, 0.21010394E-11_JPRB, 0.18743392E-11_JPRB, 0.16547881E-11_JPRB, 0.14465429E-11_JPRB, &
  & 0.12561943E-11_JPRB, 0.10886979E-11_JPRB, 0.94631919E-12_JPRB, 0.82806104E-12_JPRB, 0.73219002E-12_JPRB, 0.65598547E-12_JPRB, &
  & 0.59823999E-12_JPRB, 0.54915144E-12_JPRB, 0.50862960E-12_JPRB, 0.43247770E-12_JPRB /)

RGHG9(:,21,12) = (/ &
  & 0.77120645E-12_JPRB, 0.86353543E-12_JPRB, 0.93339106E-12_JPRB, 0.10113570E-11_JPRB, 0.11083573E-11_JPRB, 0.12333177E-11_JPRB, &
  & 0.13973456E-11_JPRB, 0.16130488E-11_JPRB, 0.18973512E-11_JPRB, 0.22540370E-11_JPRB, 0.26841149E-11_JPRB, 0.31924704E-11_JPRB, &
  & 0.37775122E-11_JPRB, 0.44270516E-11_JPRB, 0.51304551E-11_JPRB, 0.58779093E-11_JPRB, 0.66314116E-11_JPRB, 0.73374857E-11_JPRB, &
  & 0.79599079E-11_JPRB, 0.84334805E-11_JPRB, 0.86905570E-11_JPRB, 0.86839789E-11_JPRB, 0.84264054E-11_JPRB, 0.79677922E-11_JPRB, &
  & 0.73993736E-11_JPRB, 0.68374919E-11_JPRB, 0.63951552E-11_JPRB, 0.61575363E-11_JPRB, 0.61351714E-11_JPRB, 0.63480232E-11_JPRB, &
  & 0.67369812E-11_JPRB, 0.72494103E-11_JPRB, 0.78199044E-11_JPRB, 0.84027499E-11_JPRB, 0.89460141E-11_JPRB, 0.94238038E-11_JPRB, &
  & 0.98062496E-11_JPRB, 0.10034200E-10_JPRB, 0.10089212E-10_JPRB, 0.99414348E-11_JPRB, 0.96214764E-11_JPRB, 0.91575853E-11_JPRB, &
  & 0.86077655E-11_JPRB, 0.80072936E-11_JPRB, 0.74059717E-11_JPRB, 0.67988557E-11_JPRB, 0.62294154E-11_JPRB, 0.56966476E-11_JPRB, &
  & 0.51979974E-11_JPRB, 0.47382584E-11_JPRB, 0.43061765E-11_JPRB, 0.38912055E-11_JPRB, 0.34869085E-11_JPRB, 0.31008490E-11_JPRB, &
  & 0.27432889E-11_JPRB, 0.24229525E-11_JPRB, 0.21444131E-11_JPRB, 0.19085378E-11_JPRB, 0.17135513E-11_JPRB, 0.15568213E-11_JPRB, &
  & 0.14304118E-11_JPRB, 0.13351383E-11_JPRB, 0.12284319E-11_JPRB, 0.10882390E-11_JPRB /)

RGHG9(:,22,12) = (/ &
  & 0.15383613E-11_JPRB, 0.17476621E-11_JPRB, 0.18997226E-11_JPRB, 0.20643580E-11_JPRB, 0.22631634E-11_JPRB, 0.25119045E-11_JPRB, &
  & 0.28235903E-11_JPRB, 0.32172303E-11_JPRB, 0.37155530E-11_JPRB, 0.43253864E-11_JPRB, 0.50460061E-11_JPRB, 0.58672121E-11_JPRB, &
  & 0.67882349E-11_JPRB, 0.77846939E-11_JPRB, 0.88274475E-11_JPRB, 0.98965064E-11_JPRB, 0.10956041E-10_JPRB, 0.11953522E-10_JPRB, &
  & 0.12829928E-10_JPRB, 0.13503120E-10_JPRB, 0.13900375E-10_JPRB, 0.13970618E-10_JPRB, 0.13734071E-10_JPRB, 0.13234700E-10_JPRB, &
  & 0.12611381E-10_JPRB, 0.12002708E-10_JPRB, 0.11553140E-10_JPRB, 0.11374942E-10_JPRB, 0.11535163E-10_JPRB, 0.11978515E-10_JPRB, &
  & 0.12635482E-10_JPRB, 0.13423163E-10_JPRB, 0.14226969E-10_JPRB, 0.14960300E-10_JPRB, 0.15595709E-10_JPRB, 0.16099374E-10_JPRB, &
  & 0.16454659E-10_JPRB, 0.16599180E-10_JPRB, 0.16518908E-10_JPRB, 0.16182946E-10_JPRB, 0.15653505E-10_JPRB, 0.14953564E-10_JPRB, &
  & 0.14119322E-10_JPRB, 0.13219574E-10_JPRB, 0.12294793E-10_JPRB, 0.11389661E-10_JPRB, 0.10518716E-10_JPRB, 0.97155261E-11_JPRB, &
  & 0.89608581E-11_JPRB, 0.82595224E-11_JPRB, 0.75970870E-11_JPRB, 0.69464092E-11_JPRB, 0.63152808E-11_JPRB, 0.57100934E-11_JPRB, &
  & 0.51428813E-11_JPRB, 0.46231838E-11_JPRB, 0.41612070E-11_JPRB, 0.37605253E-11_JPRB, 0.34222518E-11_JPRB, 0.31437309E-11_JPRB, &
  & 0.29241162E-11_JPRB, 0.27297260E-11_JPRB, 0.25667305E-11_JPRB, 0.22488534E-11_JPRB /)

RGHG9(:,23,12) = (/ &
  & 0.27010256E-11_JPRB, 0.30616657E-11_JPRB, 0.33208002E-11_JPRB, 0.35968472E-11_JPRB, 0.39243166E-11_JPRB, 0.43244674E-11_JPRB, &
  & 0.48166562E-11_JPRB, 0.54177045E-11_JPRB, 0.61515905E-11_JPRB, 0.70294135E-11_JPRB, 0.80481533E-11_JPRB, 0.91861414E-11_JPRB, &
  & 0.10428762E-10_JPRB, 0.11757960E-10_JPRB, 0.13132687E-10_JPRB, 0.14523015E-10_JPRB, 0.15877858E-10_JPRB, 0.17145851E-10_JPRB, &
  & 0.18287781E-10_JPRB, 0.19233988E-10_JPRB, 0.19908642E-10_JPRB, 0.20249176E-10_JPRB, 0.20252789E-10_JPRB, 0.19979790E-10_JPRB, &
  & 0.19549052E-10_JPRB, 0.19102855E-10_JPRB, 0.18788908E-10_JPRB, 0.18760989E-10_JPRB, 0.19051424E-10_JPRB, 0.19630412E-10_JPRB, &
  & 0.20429072E-10_JPRB, 0.21313952E-10_JPRB, 0.22129590E-10_JPRB, 0.22845597E-10_JPRB, 0.23421744E-10_JPRB, 0.23819334E-10_JPRB, &
  & 0.24032011E-10_JPRB, 0.24032153E-10_JPRB, 0.23802828E-10_JPRB, 0.23308692E-10_JPRB, 0.22580706E-10_JPRB, 0.21660295E-10_JPRB, &
  & 0.20575605E-10_JPRB, 0.19405011E-10_JPRB, 0.18173426E-10_JPRB, 0.16973938E-10_JPRB, 0.15818659E-10_JPRB, 0.14748040E-10_JPRB, &
  & 0.13743829E-10_JPRB, 0.12796131E-10_JPRB, 0.11883678E-10_JPRB, 0.10993298E-10_JPRB, 0.10128899E-10_JPRB, 0.92977839E-11_JPRB, &
  & 0.85054195E-11_JPRB, 0.77659103E-11_JPRB, 0.70912013E-11_JPRB, 0.64916167E-11_JPRB, 0.59737618E-11_JPRB, 0.55389183E-11_JPRB, &
  & 0.51759109E-11_JPRB, 0.48846725E-11_JPRB, 0.45584396E-11_JPRB, 0.40993897E-11_JPRB /)

RGHG9(:,24,12) = (/ &
  & 0.42834152E-11_JPRB, 0.48146266E-11_JPRB, 0.51910351E-11_JPRB, 0.55873578E-11_JPRB, 0.60500190E-11_JPRB, 0.66078120E-11_JPRB, &
  & 0.72798954E-11_JPRB, 0.80873658E-11_JPRB, 0.90501807E-11_JPRB, 0.10171397E-10_JPRB, 0.11455950E-10_JPRB, 0.12871492E-10_JPRB, &
  & 0.14387266E-10_JPRB, 0.15976387E-10_JPRB, 0.17607700E-10_JPRB, 0.19257497E-10_JPRB, 0.20886575E-10_JPRB, 0.22453265E-10_JPRB, &
  & 0.23925896E-10_JPRB, 0.25239399E-10_JPRB, 0.26316574E-10_JPRB, 0.27094625E-10_JPRB, 0.27572325E-10_JPRB, 0.27776706E-10_JPRB, &
  & 0.27775154E-10_JPRB, 0.27693898E-10_JPRB, 0.27632879E-10_JPRB, 0.27739123E-10_JPRB, 0.28075698E-10_JPRB, 0.28614623E-10_JPRB, &
  & 0.29299816E-10_JPRB, 0.30000918E-10_JPRB, 0.30644102E-10_JPRB, 0.31170996E-10_JPRB, 0.31566451E-10_JPRB, 0.31785467E-10_JPRB, &
  & 0.31820498E-10_JPRB, 0.31667599E-10_JPRB, 0.31278421E-10_JPRB, 0.30656006E-10_JPRB, 0.29810501E-10_JPRB, 0.28735903E-10_JPRB, &
  & 0.27497917E-10_JPRB, 0.26124655E-10_JPRB, 0.24686286E-10_JPRB, 0.23236819E-10_JPRB, 0.21831413E-10_JPRB, 0.20499978E-10_JPRB, &
  & 0.19255495E-10_JPRB, 0.18069869E-10_JPRB, 0.16923761E-10_JPRB, 0.15816350E-10_JPRB, 0.14741191E-10_JPRB, 0.13701883E-10_JPRB, &
  & 0.12701892E-10_JPRB, 0.11751124E-10_JPRB, 0.10866398E-10_JPRB, 0.10058471E-10_JPRB, 0.93424903E-11_JPRB, 0.87255021E-11_JPRB, &
  & 0.82092284E-11_JPRB, 0.77473757E-11_JPRB, 0.73159812E-11_JPRB, 0.65412935E-11_JPRB /)

RGHG9(:,25,12) = (/ &
  & 0.62654409E-11_JPRB, 0.69672801E-11_JPRB, 0.74581313E-11_JPRB, 0.79665077E-11_JPRB, 0.85536916E-11_JPRB, 0.92514781E-11_JPRB, &
  & 0.10084887E-10_JPRB, 0.11071409E-10_JPRB, 0.12228820E-10_JPRB, 0.13558626E-10_JPRB, 0.15055722E-10_JPRB, 0.16696488E-10_JPRB, &
  & 0.18442123E-10_JPRB, 0.20262016E-10_JPRB, 0.22120765E-10_JPRB, 0.23994088E-10_JPRB, 0.25863225E-10_JPRB, 0.27698347E-10_JPRB, &
  & 0.29471717E-10_JPRB, 0.31146079E-10_JPRB, 0.32672552E-10_JPRB, 0.33989547E-10_JPRB, 0.35058515E-10_JPRB, 0.35852203E-10_JPRB, &
  & 0.36391661E-10_JPRB, 0.36743993E-10_JPRB, 0.36999820E-10_JPRB, 0.37251251E-10_JPRB, 0.37535544E-10_JPRB, 0.37884466E-10_JPRB, &
  & 0.38276271E-10_JPRB, 0.38673405E-10_JPRB, 0.39004012E-10_JPRB, 0.39252629E-10_JPRB, 0.39408816E-10_JPRB, 0.39437422E-10_JPRB, &
  & 0.39301166E-10_JPRB, 0.39000168E-10_JPRB, 0.38510337E-10_JPRB, 0.37800801E-10_JPRB, 0.36878219E-10_JPRB, 0.35741753E-10_JPRB, &
  & 0.34428085E-10_JPRB, 0.32949851E-10_JPRB, 0.31375135E-10_JPRB, 0.29750574E-10_JPRB, 0.28153455E-10_JPRB, 0.26614880E-10_JPRB, &
  & 0.25150965E-10_JPRB, 0.23748652E-10_JPRB, 0.22401581E-10_JPRB, 0.21110672E-10_JPRB, 0.19859635E-10_JPRB, 0.18651618E-10_JPRB, &
  & 0.17482816E-10_JPRB, 0.16362750E-10_JPRB, 0.15297544E-10_JPRB, 0.14306919E-10_JPRB, 0.13405901E-10_JPRB, 0.12610103E-10_JPRB, &
  & 0.11919516E-10_JPRB, 0.11311329E-10_JPRB, 0.10670498E-10_JPRB, 0.96213419E-11_JPRB /)

RGHG9(:,26,12) = (/ &
  & 0.86307775E-11_JPRB, 0.94807773E-11_JPRB, 0.10068420E-10_JPRB, 0.10671549E-10_JPRB, 0.11359217E-10_JPRB, 0.12174145E-10_JPRB, &
  & 0.13137842E-10_JPRB, 0.14267967E-10_JPRB, 0.15576509E-10_JPRB, 0.17062237E-10_JPRB, 0.18713720E-10_JPRB, 0.20506220E-10_JPRB, &
  & 0.22408207E-10_JPRB, 0.24387135E-10_JPRB, 0.26412846E-10_JPRB, 0.28469296E-10_JPRB, 0.30522512E-10_JPRB, 0.32565353E-10_JPRB, &
  & 0.34612493E-10_JPRB, 0.36644566E-10_JPRB, 0.38610611E-10_JPRB, 0.40435748E-10_JPRB, 0.42058371E-10_JPRB, 0.43415098E-10_JPRB, &
  & 0.44485970E-10_JPRB, 0.45274475E-10_JPRB, 0.45820618E-10_JPRB, 0.46186648E-10_JPRB, 0.46417890E-10_JPRB, 0.46572721E-10_JPRB, &
  & 0.46678578E-10_JPRB, 0.46738252E-10_JPRB, 0.46732462E-10_JPRB, 0.46694044E-10_JPRB, 0.46607721E-10_JPRB, 0.46451027E-10_JPRB, &
  & 0.46179408E-10_JPRB, 0.45772931E-10_JPRB, 0.45217441E-10_JPRB, 0.44482158E-10_JPRB, 0.43539901E-10_JPRB, 0.42396399E-10_JPRB, &
  & 0.41060173E-10_JPRB, 0.39538536E-10_JPRB, 0.37879914E-10_JPRB, 0.36138724E-10_JPRB, 0.34397821E-10_JPRB, 0.32701748E-10_JPRB, &
  & 0.31072055E-10_JPRB, 0.29506165E-10_JPRB, 0.28001108E-10_JPRB, 0.26565292E-10_JPRB, 0.25186013E-10_JPRB, 0.23858634E-10_JPRB, &
  & 0.22576115E-10_JPRB, 0.21338546E-10_JPRB, 0.20156498E-10_JPRB, 0.19033958E-10_JPRB, 0.17996655E-10_JPRB, 0.17056741E-10_JPRB, &
  & 0.16219373E-10_JPRB, 0.15461800E-10_JPRB, 0.14645242E-10_JPRB, 0.13308746E-10_JPRB /)

RGHG9(:,27,12) = (/ &
  & 0.11346249E-10_JPRB, 0.12316140E-10_JPRB, 0.12983209E-10_JPRB, 0.13659539E-10_JPRB, 0.14429838E-10_JPRB, 0.15332324E-10_JPRB, &
  & 0.16397267E-10_JPRB, 0.17634812E-10_JPRB, 0.19050114E-10_JPRB, 0.20641336E-10_JPRB, 0.22391181E-10_JPRB, 0.24281393E-10_JPRB, &
  & 0.26271495E-10_JPRB, 0.28344396E-10_JPRB, 0.30462584E-10_JPRB, 0.32624493E-10_JPRB, 0.34825108E-10_JPRB, 0.37064522E-10_JPRB, &
  & 0.39346314E-10_JPRB, 0.41651453E-10_JPRB, 0.43937125E-10_JPRB, 0.46134985E-10_JPRB, 0.48174464E-10_JPRB, 0.49968311E-10_JPRB, &
  & 0.51466605E-10_JPRB, 0.52622968E-10_JPRB, 0.53449856E-10_JPRB, 0.53955434E-10_JPRB, 0.54194392E-10_JPRB, 0.54217738E-10_JPRB, &
  & 0.54105567E-10_JPRB, 0.53890233E-10_JPRB, 0.53608638E-10_JPRB, 0.53328869E-10_JPRB, 0.53038580E-10_JPRB, 0.52727402E-10_JPRB, &
  & 0.52354981E-10_JPRB, 0.51877305E-10_JPRB, 0.51288092E-10_JPRB, 0.50559709E-10_JPRB, 0.49642887E-10_JPRB, 0.48532265E-10_JPRB, &
  & 0.47218146E-10_JPRB, 0.45700319E-10_JPRB, 0.44013224E-10_JPRB, 0.42213996E-10_JPRB, 0.40373926E-10_JPRB, 0.38559551E-10_JPRB, &
  & 0.36784392E-10_JPRB, 0.35089570E-10_JPRB, 0.33477287E-10_JPRB, 0.31945530E-10_JPRB, 0.30483414E-10_JPRB, 0.29085500E-10_JPRB, &
  & 0.27743714E-10_JPRB, 0.26453522E-10_JPRB, 0.25212030E-10_JPRB, 0.24030399E-10_JPRB, 0.22917265E-10_JPRB, 0.21895347E-10_JPRB, &
  & 0.20971417E-10_JPRB, 0.20095264E-10_JPRB, 0.19192294E-10_JPRB, 0.17541055E-10_JPRB /)

RGHG9(:,28,12) = (/ &
  & 0.14386206E-10_JPRB, 0.15459630E-10_JPRB, 0.16186939E-10_JPRB, 0.16921716E-10_JPRB, 0.17746681E-10_JPRB, 0.18717959E-10_JPRB, &
  & 0.19852911E-10_JPRB, 0.21159605E-10_JPRB, 0.22637121E-10_JPRB, 0.24283950E-10_JPRB, 0.26086531E-10_JPRB, 0.28031622E-10_JPRB, &
  & 0.30070869E-10_JPRB, 0.32200929E-10_JPRB, 0.34394970E-10_JPRB, 0.36639358E-10_JPRB, 0.38931768E-10_JPRB, 0.41275022E-10_JPRB, &
  & 0.43680157E-10_JPRB, 0.46134811E-10_JPRB, 0.48602650E-10_JPRB, 0.51021944E-10_JPRB, 0.53317597E-10_JPRB, 0.55401309E-10_JPRB, &
  & 0.57192348E-10_JPRB, 0.58627478E-10_JPRB, 0.59688768E-10_JPRB, 0.60353583E-10_JPRB, 0.60663391E-10_JPRB, 0.60655841E-10_JPRB, &
  & 0.60435143E-10_JPRB, 0.60056314E-10_JPRB, 0.59590922E-10_JPRB, 0.59138437E-10_JPRB, 0.58699760E-10_JPRB, 0.58275031E-10_JPRB, &
  & 0.57833037E-10_JPRB, 0.57322834E-10_JPRB, 0.56725930E-10_JPRB, 0.56020168E-10_JPRB, 0.55149017E-10_JPRB, 0.54092213E-10_JPRB, &
  & 0.52828273E-10_JPRB, 0.51347312E-10_JPRB, 0.49669643E-10_JPRB, 0.47847136E-10_JPRB, 0.45943967E-10_JPRB, 0.44033343E-10_JPRB, &
  & 0.42169639E-10_JPRB, 0.40384685E-10_JPRB, 0.38695422E-10_JPRB, 0.37104101E-10_JPRB, 0.35602240E-10_JPRB, 0.34179541E-10_JPRB, &
  & 0.32820892E-10_JPRB, 0.31521095E-10_JPRB, 0.30274974E-10_JPRB, 0.29078703E-10_JPRB, 0.27950973E-10_JPRB, 0.26901625E-10_JPRB, &
  & 0.25939598E-10_JPRB, 0.25041099E-10_JPRB, 0.24018716E-10_JPRB, 0.22319009E-10_JPRB /)

RGHG9(:,29,12) = (/ &
  & 0.17725576E-10_JPRB, 0.18881131E-10_JPRB, 0.19658213E-10_JPRB, 0.20433630E-10_JPRB, 0.21307513E-10_JPRB, 0.22319670E-10_JPRB, &
  & 0.23498299E-10_JPRB, 0.24838961E-10_JPRB, 0.26336090E-10_JPRB, 0.27987612E-10_JPRB, 0.29798216E-10_JPRB, 0.31739375E-10_JPRB, &
  & 0.33792049E-10_JPRB, 0.35938197E-10_JPRB, 0.38153262E-10_JPRB, 0.40428751E-10_JPRB, 0.42759386E-10_JPRB, 0.45151174E-10_JPRB, &
  & 0.47613274E-10_JPRB, 0.50133071E-10_JPRB, 0.52683136E-10_JPRB, 0.55201468E-10_JPRB, 0.57622327E-10_JPRB, 0.59858209E-10_JPRB, &
  & 0.61823949E-10_JPRB, 0.63449482E-10_JPRB, 0.64686624E-10_JPRB, 0.65509487E-10_JPRB, 0.65926702E-10_JPRB, 0.65967898E-10_JPRB, &
  & 0.65732877E-10_JPRB, 0.65294894E-10_JPRB, 0.64736161E-10_JPRB, 0.64179044E-10_JPRB, 0.63645832E-10_JPRB, 0.63147314E-10_JPRB, &
  & 0.62659128E-10_JPRB, 0.62139058E-10_JPRB, 0.61554206E-10_JPRB, 0.60879912E-10_JPRB, 0.60059825E-10_JPRB, 0.59061520E-10_JPRB, &
  & 0.57855210E-10_JPRB, 0.56422762E-10_JPRB, 0.54772759E-10_JPRB, 0.52944722E-10_JPRB, 0.51006709E-10_JPRB, 0.49045552E-10_JPRB, &
  & 0.47127083E-10_JPRB, 0.45301644E-10_JPRB, 0.43583789E-10_JPRB, 0.41974733E-10_JPRB, 0.40466228E-10_JPRB, 0.39042391E-10_JPRB, &
  & 0.37695860E-10_JPRB, 0.36410010E-10_JPRB, 0.35177351E-10_JPRB, 0.33997697E-10_JPRB, 0.32879054E-10_JPRB, 0.31844891E-10_JPRB, &
  & 0.30893819E-10_JPRB, 0.29984876E-10_JPRB, 0.29011536E-10_JPRB, 0.27238514E-10_JPRB /)

RGHG9(:,30,12) = (/ &
  & 0.21315297E-10_JPRB, 0.22551724E-10_JPRB, 0.23372328E-10_JPRB, 0.24184977E-10_JPRB, 0.25082662E-10_JPRB, 0.26123947E-10_JPRB, &
  & 0.27317504E-10_JPRB, 0.28657764E-10_JPRB, 0.30136511E-10_JPRB, 0.31755380E-10_JPRB, 0.33523889E-10_JPRB, 0.35418751E-10_JPRB, &
  & 0.37437033E-10_JPRB, 0.39562079E-10_JPRB, 0.41771440E-10_JPRB, 0.44055634E-10_JPRB, 0.46405966E-10_JPRB, 0.48815292E-10_JPRB, &
  & 0.51285226E-10_JPRB, 0.53801470E-10_JPRB, 0.56345952E-10_JPRB, 0.58871186E-10_JPRB, 0.61314141E-10_JPRB, 0.63597370E-10_JPRB, &
  & 0.65636573E-10_JPRB, 0.67361616E-10_JPRB, 0.68716116E-10_JPRB, 0.69667022E-10_JPRB, 0.70200054E-10_JPRB, 0.70331817E-10_JPRB, &
  & 0.70145702E-10_JPRB, 0.69723109E-10_JPRB, 0.69145065E-10_JPRB, 0.68541131E-10_JPRB, 0.67960464E-10_JPRB, 0.67417766E-10_JPRB, &
  & 0.66901533E-10_JPRB, 0.66379693E-10_JPRB, 0.65816019E-10_JPRB, 0.65176552E-10_JPRB, 0.64404357E-10_JPRB, 0.63459141E-10_JPRB, &
  & 0.62306757E-10_JPRB, 0.60922323E-10_JPRB, 0.59308516E-10_JPRB, 0.57498541E-10_JPRB, 0.55567717E-10_JPRB, 0.53595690E-10_JPRB, &
  & 0.51670345E-10_JPRB, 0.49835681E-10_JPRB, 0.48121371E-10_JPRB, 0.46522158E-10_JPRB, 0.45025594E-10_JPRB, 0.43619174E-10_JPRB, &
  & 0.42287868E-10_JPRB, 0.41022116E-10_JPRB, 0.39809052E-10_JPRB, 0.38647023E-10_JPRB, 0.37554869E-10_JPRB, 0.36545343E-10_JPRB, &
  & 0.35629319E-10_JPRB, 0.34759785E-10_JPRB, 0.33791803E-10_JPRB, 0.32105957E-10_JPRB /)

RGHG9(:,31,12) = (/ &
  & 0.25135888E-10_JPRB, 0.26436159E-10_JPRB, 0.27289483E-10_JPRB, 0.28120950E-10_JPRB, 0.29039073E-10_JPRB, 0.30084775E-10_JPRB, &
  & 0.31273172E-10_JPRB, 0.32589435E-10_JPRB, 0.34021209E-10_JPRB, 0.35574859E-10_JPRB, 0.37266256E-10_JPRB, 0.39080541E-10_JPRB, &
  & 0.41032167E-10_JPRB, 0.43103382E-10_JPRB, 0.45275752E-10_JPRB, 0.47542279E-10_JPRB, 0.49887601E-10_JPRB, 0.52293156E-10_JPRB, &
  & 0.54750562E-10_JPRB, 0.57237715E-10_JPRB, 0.59733732E-10_JPRB, 0.62205838E-10_JPRB, 0.64602802E-10_JPRB, 0.66857513E-10_JPRB, &
  & 0.68887736E-10_JPRB, 0.70628996E-10_JPRB, 0.72035516E-10_JPRB, 0.73070619E-10_JPRB, 0.73703162E-10_JPRB, 0.73934997E-10_JPRB, &
  & 0.73829956E-10_JPRB, 0.73468072E-10_JPRB, 0.72924070E-10_JPRB, 0.72321260E-10_JPRB, 0.71730136E-10_JPRB, 0.71169355E-10_JPRB, &
  & 0.70639522E-10_JPRB, 0.70121742E-10_JPRB, 0.69578190E-10_JPRB, 0.68966624E-10_JPRB, 0.68231344E-10_JPRB, 0.67328344E-10_JPRB, &
  & 0.66218392E-10_JPRB, 0.64878727E-10_JPRB, 0.63306888E-10_JPRB, 0.61537435E-10_JPRB, 0.59637711E-10_JPRB, 0.57699935E-10_JPRB, &
  & 0.55798074E-10_JPRB, 0.53995385E-10_JPRB, 0.52305417E-10_JPRB, 0.50727190E-10_JPRB, 0.49252120E-10_JPRB, 0.47866773E-10_JPRB, &
  & 0.46561085E-10_JPRB, 0.45312483E-10_JPRB, 0.44115087E-10_JPRB, 0.42973413E-10_JPRB, 0.41903713E-10_JPRB, 0.40932098E-10_JPRB, &
  & 0.40048784E-10_JPRB, 0.39220165E-10_JPRB, 0.38305994E-10_JPRB, 0.36695650E-10_JPRB /)

RGHG9(:,32,12) = (/ &
  & 0.29152875E-10_JPRB, 0.30493139E-10_JPRB, 0.31356688E-10_JPRB, 0.32194761E-10_JPRB, 0.33110448E-10_JPRB, 0.34149409E-10_JPRB, &
  & 0.35314772E-10_JPRB, 0.36586977E-10_JPRB, 0.37954445E-10_JPRB, 0.39422389E-10_JPRB, 0.41007142E-10_JPRB, 0.42718443E-10_JPRB, &
  & 0.44576134E-10_JPRB, 0.46577145E-10_JPRB, 0.48706469E-10_JPRB, 0.50946351E-10_JPRB, 0.53275603E-10_JPRB, 0.55663155E-10_JPRB, &
  & 0.58088562E-10_JPRB, 0.60523413E-10_JPRB, 0.62950339E-10_JPRB, 0.65337263E-10_JPRB, 0.67643925E-10_JPRB, 0.69804343E-10_JPRB, &
  & 0.71758766E-10_JPRB, 0.73454506E-10_JPRB, 0.74852118E-10_JPRB, 0.75919597E-10_JPRB, 0.76618184E-10_JPRB, 0.76940079E-10_JPRB, &
  & 0.76926056E-10_JPRB, 0.76648320E-10_JPRB, 0.76173540E-10_JPRB, 0.75610400E-10_JPRB, 0.75037809E-10_JPRB, 0.74480533E-10_JPRB, &
  & 0.73953357E-10_JPRB, 0.73444549E-10_JPRB, 0.72915576E-10_JPRB, 0.72319914E-10_JPRB, 0.71606963E-10_JPRB, 0.70727729E-10_JPRB, &
  & 0.69647663E-10_JPRB, 0.68342221E-10_JPRB, 0.66812597E-10_JPRB, 0.65097788E-10_JPRB, 0.63258357E-10_JPRB, 0.61366939E-10_JPRB, &
  & 0.59522220E-10_JPRB, 0.57763558E-10_JPRB, 0.56120979E-10_JPRB, 0.54587657E-10_JPRB, 0.53148624E-10_JPRB, 0.51795859E-10_JPRB, &
  & 0.50506488E-10_JPRB, 0.49274342E-10_JPRB, 0.48092644E-10_JPRB, 0.46968710E-10_JPRB, 0.45927113E-10_JPRB, 0.44982799E-10_JPRB, &
  & 0.44142256E-10_JPRB, 0.43343020E-10_JPRB, 0.42475679E-10_JPRB, 0.40934620E-10_JPRB /)

RGHG9(:,33,12) = (/ &
  & 0.33307464E-10_JPRB, 0.34645207E-10_JPRB, 0.35501442E-10_JPRB, 0.36331042E-10_JPRB, 0.37231156E-10_JPRB, 0.38247506E-10_JPRB, &
  & 0.39377258E-10_JPRB, 0.40597560E-10_JPRB, 0.41887337E-10_JPRB, 0.43254535E-10_JPRB, 0.44715846E-10_JPRB, 0.46302039E-10_JPRB, &
  & 0.48042573E-10_JPRB, 0.49952431E-10_JPRB, 0.52026290E-10_JPRB, 0.54240772E-10_JPRB, 0.56559368E-10_JPRB, 0.58933108E-10_JPRB, &
  & 0.61322940E-10_JPRB, 0.63703126E-10_JPRB, 0.66050110E-10_JPRB, 0.68333117E-10_JPRB, 0.70517051E-10_JPRB, 0.72553089E-10_JPRB, &
  & 0.74384034E-10_JPRB, 0.75975282E-10_JPRB, 0.77307667E-10_JPRB, 0.78355114E-10_JPRB, 0.79081956E-10_JPRB, 0.79469265E-10_JPRB, &
  & 0.79541589E-10_JPRB, 0.79356910E-10_JPRB, 0.78973481E-10_JPRB, 0.78477655E-10_JPRB, 0.77949258E-10_JPRB, 0.77417364E-10_JPRB, &
  & 0.76909507E-10_JPRB, 0.76414368E-10_JPRB, 0.75893736E-10_JPRB, 0.75305873E-10_JPRB, 0.74598869E-10_JPRB, 0.73727566E-10_JPRB, &
  & 0.72660850E-10_JPRB, 0.71376849E-10_JPRB, 0.69887339E-10_JPRB, 0.68230165E-10_JPRB, 0.66450630E-10_JPRB, 0.64642569E-10_JPRB, &
  & 0.62869390E-10_JPRB, 0.61191871E-10_JPRB, 0.59607728E-10_JPRB, 0.58117362E-10_JPRB, 0.56716548E-10_JPRB, 0.55390449E-10_JPRB, &
  & 0.54129781E-10_JPRB, 0.52918850E-10_JPRB, 0.51756967E-10_JPRB, 0.50654342E-10_JPRB, 0.49634089E-10_JPRB, 0.48722599E-10_JPRB, &
  & 0.47901537E-10_JPRB, 0.47142158E-10_JPRB, 0.46294645E-10_JPRB, 0.44835850E-10_JPRB /)

RGHG9(:,34,12) = (/ &
  & 0.37526569E-10_JPRB, 0.38816776E-10_JPRB, 0.39650002E-10_JPRB, 0.40447895E-10_JPRB, 0.41323327E-10_JPRB, 0.42306547E-10_JPRB, &
  & 0.43396231E-10_JPRB, 0.44555928E-10_JPRB, 0.45763827E-10_JPRB, 0.47020478E-10_JPRB, 0.48348485E-10_JPRB, 0.49793621E-10_JPRB, &
  & 0.51400505E-10_JPRB, 0.53201953E-10_JPRB, 0.55207373E-10_JPRB, 0.57387789E-10_JPRB, 0.59686138E-10_JPRB, 0.62049789E-10_JPRB, &
  & 0.64423661E-10_JPRB, 0.66763976E-10_JPRB, 0.69033092E-10_JPRB, 0.71206076E-10_JPRB, 0.73258580E-10_JPRB, 0.75145043E-10_JPRB, &
  & 0.76821514E-10_JPRB, 0.78270980E-10_JPRB, 0.79490657E-10_JPRB, 0.80469936E-10_JPRB, 0.81181853E-10_JPRB, 0.81604140E-10_JPRB, &
  & 0.81746221E-10_JPRB, 0.81653774E-10_JPRB, 0.81372797E-10_JPRB, 0.80965991E-10_JPRB, 0.80505824E-10_JPRB, 0.80026111E-10_JPRB, &
  & 0.79552955E-10_JPRB, 0.79077758E-10_JPRB, 0.78567305E-10_JPRB, 0.77980955E-10_JPRB, 0.77269073E-10_JPRB, 0.76392101E-10_JPRB, &
  & 0.75320174E-10_JPRB, 0.74047136E-10_JPRB, 0.72586409E-10_JPRB, 0.70976308E-10_JPRB, 0.69276980E-10_JPRB, 0.67550028E-10_JPRB, &
  & 0.65873078E-10_JPRB, 0.64262755E-10_JPRB, 0.62741021E-10_JPRB, 0.61309270E-10_JPRB, 0.59957019E-10_JPRB, 0.58674357E-10_JPRB, &
  & 0.57440778E-10_JPRB, 0.56254931E-10_JPRB, 0.55113050E-10_JPRB, 0.54032404E-10_JPRB, 0.53040045E-10_JPRB, 0.52147401E-10_JPRB, &
  & 0.51360447E-10_JPRB, 0.50612094E-10_JPRB, 0.49810021E-10_JPRB, 0.48387690E-10_JPRB /)

RGHG9(:,35,12) = (/ &
  & 0.41729432E-10_JPRB, 0.42947340E-10_JPRB, 0.43724472E-10_JPRB, 0.44487199E-10_JPRB, 0.45319002E-10_JPRB, 0.46266779E-10_JPRB, &
  & 0.47308157E-10_JPRB, 0.48406154E-10_JPRB, 0.49525883E-10_JPRB, 0.50667328E-10_JPRB, 0.51858573E-10_JPRB, 0.53151906E-10_JPRB, &
  & 0.54614289E-10_JPRB, 0.56295427E-10_JPRB, 0.58222462E-10_JPRB, 0.60366476E-10_JPRB, 0.62660606E-10_JPRB, 0.65018331E-10_JPRB, &
  & 0.67380324E-10_JPRB, 0.69683544E-10_JPRB, 0.71886073E-10_JPRB, 0.73959006E-10_JPRB, 0.75874300E-10_JPRB, 0.77591523E-10_JPRB, &
  & 0.79089547E-10_JPRB, 0.80364299E-10_JPRB, 0.81431355E-10_JPRB, 0.82297294E-10_JPRB, 0.82945581E-10_JPRB, 0.83361498E-10_JPRB, &
  & 0.83544512E-10_JPRB, 0.83531647E-10_JPRB, 0.83351798E-10_JPRB, 0.83047763E-10_JPRB, 0.82681272E-10_JPRB, 0.82276463E-10_JPRB, &
  & 0.81858402E-10_JPRB, 0.81420252E-10_JPRB, 0.80931643E-10_JPRB, 0.80354036E-10_JPRB, 0.79641939E-10_JPRB, 0.78753878E-10_JPRB, &
  & 0.77673666E-10_JPRB, 0.76400788E-10_JPRB, 0.74962127E-10_JPRB, 0.73403700E-10_JPRB, 0.71772130E-10_JPRB, 0.70141691E-10_JPRB, &
  & 0.68541076E-10_JPRB, 0.67015060E-10_JPRB, 0.65566046E-10_JPRB, 0.64190778E-10_JPRB, 0.62884781E-10_JPRB, 0.61632158E-10_JPRB, &
  & 0.60433589E-10_JPRB, 0.59274398E-10_JPRB, 0.58162357E-10_JPRB, 0.57108138E-10_JPRB, 0.56138445E-10_JPRB, 0.55275499E-10_JPRB, &
  & 0.54502784E-10_JPRB, 0.53790396E-10_JPRB, 0.52999962E-10_JPRB, 0.51645143E-10_JPRB /)

RGHG9(:,36,12) = (/ &
  & 0.45859996E-10_JPRB, 0.46965171E-10_JPRB, 0.47688010E-10_JPRB, 0.48390115E-10_JPRB, 0.49179914E-10_JPRB, 0.50078323E-10_JPRB, &
  & 0.51070433E-10_JPRB, 0.52099873E-10_JPRB, 0.53129445E-10_JPRB, 0.54153917E-10_JPRB, 0.55205986E-10_JPRB, 0.56345928E-10_JPRB, &
  & 0.57654360E-10_JPRB, 0.59203871E-10_JPRB, 0.61041255E-10_JPRB, 0.63138286E-10_JPRB, 0.65425665E-10_JPRB, 0.67793084E-10_JPRB, &
  & 0.70150538E-10_JPRB, 0.72434128E-10_JPRB, 0.74584741E-10_JPRB, 0.76564796E-10_JPRB, 0.78333409E-10_JPRB, 0.79866253E-10_JPRB, &
  & 0.81151939E-10_JPRB, 0.82217316E-10_JPRB, 0.83091672E-10_JPRB, 0.83795595E-10_JPRB, 0.84335046E-10_JPRB, 0.84696493E-10_JPRB, &
  & 0.84884003E-10_JPRB, 0.84923679E-10_JPRB, 0.84825251E-10_JPRB, 0.84624627E-10_JPRB, 0.84357937E-10_JPRB, 0.84042190E-10_JPRB, &
  & 0.83700165E-10_JPRB, 0.83320364E-10_JPRB, 0.82880987E-10_JPRB, 0.82345228E-10_JPRB, 0.81663232E-10_JPRB, 0.80798833E-10_JPRB, &
  & 0.79731277E-10_JPRB, 0.78470230E-10_JPRB, 0.77057909E-10_JPRB, 0.75538083E-10_JPRB, 0.73981252E-10_JPRB, 0.72423408E-10_JPRB, &
  & 0.70915565E-10_JPRB, 0.69465926E-10_JPRB, 0.68078626E-10_JPRB, 0.66754331E-10_JPRB, 0.65486491E-10_JPRB, 0.64277791E-10_JPRB, &
  & 0.63114111E-10_JPRB, 0.61993834E-10_JPRB, 0.60912372E-10_JPRB, 0.59888983E-10_JPRB, 0.58947763E-10_JPRB, 0.58106107E-10_JPRB, &
  & 0.57364551E-10_JPRB, 0.56668999E-10_JPRB, 0.55921497E-10_JPRB, 0.54614934E-10_JPRB /)

RGHG9(:,37,12) = (/ &
  & 0.49859925E-10_JPRB, 0.50846310E-10_JPRB, 0.51489243E-10_JPRB, 0.52136392E-10_JPRB, 0.52868890E-10_JPRB, 0.53719210E-10_JPRB, &
  & 0.54652779E-10_JPRB, 0.55610960E-10_JPRB, 0.56547194E-10_JPRB, 0.57455381E-10_JPRB, 0.58372987E-10_JPRB, 0.59361190E-10_JPRB, &
  & 0.60512567E-10_JPRB, 0.61919844E-10_JPRB, 0.63650002E-10_JPRB, 0.65694693E-10_JPRB, 0.67958826E-10_JPRB, 0.70339581E-10_JPRB, &
  & 0.72711059E-10_JPRB, 0.74979606E-10_JPRB, 0.77075790E-10_JPRB, 0.78936017E-10_JPRB, 0.80524649E-10_JPRB, 0.81828350E-10_JPRB, &
  & 0.82873604E-10_JPRB, 0.83701268E-10_JPRB, 0.84362295E-10_JPRB, 0.84891254E-10_JPRB, 0.85300364E-10_JPRB, 0.85589168E-10_JPRB, &
  & 0.85756326E-10_JPRB, 0.85818741E-10_JPRB, 0.85773763E-10_JPRB, 0.85652201E-10_JPRB, 0.85466342E-10_JPRB, 0.85235756E-10_JPRB, &
  & 0.84969455E-10_JPRB, 0.84662423E-10_JPRB, 0.84297180E-10_JPRB, 0.83838249E-10_JPRB, 0.83241983E-10_JPRB, 0.82458908E-10_JPRB, &
  & 0.81463294E-10_JPRB, 0.80258376E-10_JPRB, 0.78883351E-10_JPRB, 0.77417538E-10_JPRB, 0.75917925E-10_JPRB, 0.74442709E-10_JPRB, &
  & 0.73008516E-10_JPRB, 0.71626413E-10_JPRB, 0.70296435E-10_JPRB, 0.69017347E-10_JPRB, 0.67796435E-10_JPRB, 0.66626545E-10_JPRB, &
  & 0.65508932E-10_JPRB, 0.64432501E-10_JPRB, 0.63397045E-10_JPRB, 0.62411347E-10_JPRB, 0.61501727E-10_JPRB, 0.60688669E-10_JPRB, &
  & 0.59969647E-10_JPRB, 0.59307351E-10_JPRB, 0.58586941E-10_JPRB, 0.57342686E-10_JPRB /)

RGHG9(:,38,12) = (/ &
  & 0.53673246E-10_JPRB, 0.54530637E-10_JPRB, 0.55102065E-10_JPRB, 0.55686421E-10_JPRB, 0.56363601E-10_JPRB, 0.57159118E-10_JPRB, &
  & 0.58031215E-10_JPRB, 0.58913055E-10_JPRB, 0.59754840E-10_JPRB, 0.60554263E-10_JPRB, 0.61343028E-10_JPRB, 0.62195485E-10_JPRB, &
  & 0.63189606E-10_JPRB, 0.64452547E-10_JPRB, 0.66059533E-10_JPRB, 0.68042239E-10_JPRB, 0.70295068E-10_JPRB, 0.72668344E-10_JPRB, &
  & 0.75027332E-10_JPRB, 0.77257707E-10_JPRB, 0.79245312E-10_JPRB, 0.80924399E-10_JPRB, 0.82269573E-10_JPRB, 0.83314168E-10_JPRB, &
  & 0.84110025E-10_JPRB, 0.84723624E-10_JPRB, 0.85205870E-10_JPRB, 0.85592831E-10_JPRB, 0.85901168E-10_JPRB, 0.86127633E-10_JPRB, &
  & 0.86275397E-10_JPRB, 0.86342142E-10_JPRB, 0.86330033E-10_JPRB, 0.86254497E-10_JPRB, 0.86124108E-10_JPRB, 0.85953529E-10_JPRB, &
  & 0.85747125E-10_JPRB, 0.85503452E-10_JPRB, 0.85208521E-10_JPRB, 0.84836117E-10_JPRB, 0.84344212E-10_JPRB, 0.83684656E-10_JPRB, &
  & 0.82813124E-10_JPRB, 0.81714802E-10_JPRB, 0.80430398E-10_JPRB, 0.79031032E-10_JPRB, 0.77607427E-10_JPRB, 0.76202079E-10_JPRB, &
  & 0.74840280E-10_JPRB, 0.73524180E-10_JPRB, 0.72246258E-10_JPRB, 0.71014389E-10_JPRB, 0.69832418E-10_JPRB, 0.68709843E-10_JPRB, &
  & 0.67645507E-10_JPRB, 0.66631207E-10_JPRB, 0.65655412E-10_JPRB, 0.64721235E-10_JPRB, 0.63849613E-10_JPRB, 0.63065941E-10_JPRB, &
  & 0.62374959E-10_JPRB, 0.61737553E-10_JPRB, 0.61052580E-10_JPRB, 0.59865203E-10_JPRB /)

RGHG9(:,39,12) = (/ &
  & 0.57237833E-10_JPRB, 0.57976193E-10_JPRB, 0.58479499E-10_JPRB, 0.59004107E-10_JPRB, 0.59632042E-10_JPRB, 0.60370063E-10_JPRB, &
  & 0.61178562E-10_JPRB, 0.61980483E-10_JPRB, 0.62732937E-10_JPRB, 0.63427756E-10_JPRB, 0.64112250E-10_JPRB, 0.64833638E-10_JPRB, &
  & 0.65700966E-10_JPRB, 0.66804479E-10_JPRB, 0.68291504E-10_JPRB, 0.70171667E-10_JPRB, 0.72382288E-10_JPRB, 0.74739777E-10_JPRB, &
  & 0.77055758E-10_JPRB, 0.79168810E-10_JPRB, 0.80974560E-10_JPRB, 0.82405430E-10_JPRB, 0.83492262E-10_JPRB, 0.84298901E-10_JPRB, &
  & 0.84902543E-10_JPRB, 0.85362405E-10_JPRB, 0.85726079E-10_JPRB, 0.86022835E-10_JPRB, 0.86265717E-10_JPRB, 0.86453428E-10_JPRB, &
  & 0.86585905E-10_JPRB, 0.86652761E-10_JPRB, 0.86659666E-10_JPRB, 0.86609150E-10_JPRB, 0.86513796E-10_JPRB, 0.86380798E-10_JPRB, &
  & 0.86215840E-10_JPRB, 0.86017887E-10_JPRB, 0.85776219E-10_JPRB, 0.85471609E-10_JPRB, 0.85069278E-10_JPRB, 0.84522639E-10_JPRB, &
  & 0.83787401E-10_JPRB, 0.82833677E-10_JPRB, 0.81675305E-10_JPRB, 0.80388876E-10_JPRB, 0.79047116E-10_JPRB, 0.77722134E-10_JPRB, &
  & 0.76431660E-10_JPRB, 0.75171827E-10_JPRB, 0.73945024E-10_JPRB, 0.72754247E-10_JPRB, 0.71617288E-10_JPRB, 0.70554305E-10_JPRB, &
  & 0.69556368E-10_JPRB, 0.68621706E-10_JPRB, 0.67718928E-10_JPRB, 0.66850393E-10_JPRB, 0.66027475E-10_JPRB, 0.65281502E-10_JPRB, &
  & 0.64619379E-10_JPRB, 0.64012358E-10_JPRB, 0.63357430E-10_JPRB, 0.62226169E-10_JPRB /)

RGHG9(:,40,12) = (/ &
  & 0.60491251E-10_JPRB, 0.61134292E-10_JPRB, 0.61577729E-10_JPRB, 0.62059934E-10_JPRB, 0.62636785E-10_JPRB, 0.63330327E-10_JPRB, &
  & 0.64072185E-10_JPRB, 0.64797813E-10_JPRB, 0.65462767E-10_JPRB, 0.66075444E-10_JPRB, 0.66658817E-10_JPRB, 0.67291214E-10_JPRB, &
  & 0.68027126E-10_JPRB, 0.69012990E-10_JPRB, 0.70347728E-10_JPRB, 0.72141432E-10_JPRB, 0.74272359E-10_JPRB, 0.76554194E-10_JPRB, &
  & 0.78760623E-10_JPRB, 0.80699808E-10_JPRB, 0.82255674E-10_JPRB, 0.83435918E-10_JPRB, 0.84298651E-10_JPRB, 0.84931687E-10_JPRB, &
  & 0.85402366E-10_JPRB, 0.85765589E-10_JPRB, 0.86056155E-10_JPRB, 0.86298302E-10_JPRB, 0.86501417E-10_JPRB, 0.86665501E-10_JPRB, &
  & 0.86785787E-10_JPRB, 0.86853615E-10_JPRB, 0.86869151E-10_JPRB, 0.86834748E-10_JPRB, 0.86759926E-10_JPRB, 0.86651152E-10_JPRB, &
  & 0.86514212E-10_JPRB, 0.86347540E-10_JPRB, 0.86144480E-10_JPRB, 0.85888789E-10_JPRB, 0.85552204E-10_JPRB, 0.85096825E-10_JPRB, &
  & 0.84480152E-10_JPRB, 0.83667212E-10_JPRB, 0.82658151E-10_JPRB, 0.81491945E-10_JPRB, 0.80264184E-10_JPRB, 0.79025703E-10_JPRB, &
  & 0.77806477E-10_JPRB, 0.76610045E-10_JPRB, 0.75429989E-10_JPRB, 0.74280165E-10_JPRB, 0.73196282E-10_JPRB, 0.72188283E-10_JPRB, &
  & 0.71274445E-10_JPRB, 0.70418241E-10_JPRB, 0.69606848E-10_JPRB, 0.68814433E-10_JPRB, 0.68057247E-10_JPRB, 0.67358494E-10_JPRB, &
  & 0.66736616E-10_JPRB, 0.66161514E-10_JPRB, 0.65544202E-10_JPRB, 0.64466148E-10_JPRB /)

RGHG9(:,41,12) = (/ &
  & 0.63421081E-10_JPRB, 0.63988301E-10_JPRB, 0.64391659E-10_JPRB, 0.64832043E-10_JPRB, 0.65384365E-10_JPRB, 0.66030542E-10_JPRB, &
  & 0.66716348E-10_JPRB, 0.67367792E-10_JPRB, 0.67960401E-10_JPRB, 0.68493197E-10_JPRB, 0.69011657E-10_JPRB, 0.69548679E-10_JPRB, &
  & 0.70206903E-10_JPRB, 0.71056702E-10_JPRB, 0.72275672E-10_JPRB, 0.73924658E-10_JPRB, 0.75961210E-10_JPRB, 0.78122550E-10_JPRB, &
  & 0.80163223E-10_JPRB, 0.81877782E-10_JPRB, 0.83198476E-10_JPRB, 0.84157625E-10_JPRB, 0.84850509E-10_JPRB, 0.85357291E-10_JPRB, &
  & 0.85740255E-10_JPRB, 0.86039828E-10_JPRB, 0.86284521E-10_JPRB, 0.86492348E-10_JPRB, 0.86669665E-10_JPRB, 0.86818830E-10_JPRB, &
  & 0.86928881E-10_JPRB, 0.86997326E-10_JPRB, 0.87016803E-10_JPRB, 0.86992705E-10_JPRB, 0.86930629E-10_JPRB, 0.86838238E-10_JPRB, &
  & 0.86720388E-10_JPRB, 0.86576593E-10_JPRB, 0.86401358E-10_JPRB, 0.86181916E-10_JPRB, 0.85895541E-10_JPRB, 0.85510918E-10_JPRB, &
  & 0.84990820E-10_JPRB, 0.84299581E-10_JPRB, 0.83422595E-10_JPRB, 0.82399199E-10_JPRB, 0.81282939E-10_JPRB, 0.80143892E-10_JPRB, &
  & 0.79005497E-10_JPRB, 0.77868739E-10_JPRB, 0.76734535E-10_JPRB, 0.75632563E-10_JPRB, 0.74586809E-10_JPRB, 0.73655700E-10_JPRB, &
  & 0.72812499E-10_JPRB, 0.72054002E-10_JPRB, 0.71330553E-10_JPRB, 0.70629211E-10_JPRB, 0.69948068E-10_JPRB, 0.69315942E-10_JPRB, &
  & 0.68746724E-10_JPRB, 0.68218153E-10_JPRB, 0.67642801E-10_JPRB, 0.66635350E-10_JPRB /)

RGHG9(:,42,12) = (/ &
  & 0.66046030E-10_JPRB, 0.66563845E-10_JPRB, 0.66935429E-10_JPRB, 0.67358973E-10_JPRB, 0.67882838E-10_JPRB, 0.68504584E-10_JPRB, &
  & 0.69136093E-10_JPRB, 0.69725087E-10_JPRB, 0.70250583E-10_JPRB, 0.70727112E-10_JPRB, 0.71177869E-10_JPRB, 0.71661448E-10_JPRB, &
  & 0.72224060E-10_JPRB, 0.72993306E-10_JPRB, 0.74069043E-10_JPRB, 0.75601823E-10_JPRB, 0.77499812E-10_JPRB, 0.79506852E-10_JPRB, &
  & 0.81333183E-10_JPRB, 0.82811966E-10_JPRB, 0.83905854E-10_JPRB, 0.84688603E-10_JPRB, 0.85249897E-10_JPRB, 0.85666758E-10_JPRB, &
  & 0.85987044E-10_JPRB, 0.86243783E-10_JPRB, 0.86457376E-10_JPRB, 0.86642221E-10_JPRB, 0.86802607E-10_JPRB, 0.86939900E-10_JPRB, &
  & 0.87042859E-10_JPRB, 0.87109410E-10_JPRB, 0.87131420E-10_JPRB, 0.87113400E-10_JPRB, 0.87059832E-10_JPRB, 0.86978758E-10_JPRB, &
  & 0.86874667E-10_JPRB, 0.86748025E-10_JPRB, 0.86594273E-10_JPRB, 0.86402940E-10_JPRB, 0.86155721E-10_JPRB, 0.85826547E-10_JPRB, &
  & 0.85383582E-10_JPRB, 0.84794401E-10_JPRB, 0.84043633E-10_JPRB, 0.83143881E-10_JPRB, 0.82151591E-10_JPRB, 0.81113234E-10_JPRB, &
  & 0.80058973E-10_JPRB, 0.78988628E-10_JPRB, 0.77909082E-10_JPRB, 0.76838966E-10_JPRB, 0.75856189E-10_JPRB, 0.74978850E-10_JPRB, &
  & 0.74227444E-10_JPRB, 0.73552026E-10_JPRB, 0.72925270E-10_JPRB, 0.72314585E-10_JPRB, 0.71724307E-10_JPRB, 0.71172027E-10_JPRB, &
  & 0.70672197E-10_JPRB, 0.70203496E-10_JPRB, 0.69688248E-10_JPRB, 0.68770371E-10_JPRB /)

RGHG9(:,43,12) = (/ &
  & 0.68417105E-10_JPRB, 0.68905728E-10_JPRB, 0.69260327E-10_JPRB, 0.69667105E-10_JPRB, 0.70187529E-10_JPRB, 0.70782144E-10_JPRB, &
  & 0.71374129E-10_JPRB, 0.71908791E-10_JPRB, 0.72383079E-10_JPRB, 0.72806913E-10_JPRB, 0.73213449E-10_JPRB, 0.73635029E-10_JPRB, &
  & 0.74142435E-10_JPRB, 0.74802907E-10_JPRB, 0.75776406E-10_JPRB, 0.77146546E-10_JPRB, 0.78900775E-10_JPRB, 0.80732990E-10_JPRB, &
  & 0.82334445E-10_JPRB, 0.83570949E-10_JPRB, 0.84463235E-10_JPRB, 0.85097131E-10_JPRB, 0.85557353E-10_JPRB, 0.85905810E-10_JPRB, &
  & 0.86180299E-10_JPRB, 0.86406327E-10_JPRB, 0.86597993E-10_JPRB, 0.86766677E-10_JPRB, 0.86915801E-10_JPRB, 0.87042575E-10_JPRB, &
  & 0.87140337E-10_JPRB, 0.87203286E-10_JPRB, 0.87226684E-10_JPRB, 0.87212099E-10_JPRB, 0.87164435E-10_JPRB, 0.87091258E-10_JPRB, &
  & 0.86997493E-10_JPRB, 0.86884090E-10_JPRB, 0.86747477E-10_JPRB, 0.86579001E-10_JPRB, 0.86363854E-10_JPRB, 0.86080698E-10_JPRB, &
  & 0.85703368E-10_JPRB, 0.85202671E-10_JPRB, 0.84558048E-10_JPRB, 0.83777263E-10_JPRB, 0.82895711E-10_JPRB, 0.81962596E-10_JPRB, &
  & 0.80997507E-10_JPRB, 0.80001478E-10_JPRB, 0.78973612E-10_JPRB, 0.77963871E-10_JPRB, 0.77027454E-10_JPRB, 0.76228350E-10_JPRB, &
  & 0.75553064E-10_JPRB, 0.74966727E-10_JPRB, 0.74426854E-10_JPRB, 0.73909219E-10_JPRB, 0.73411117E-10_JPRB, 0.72948217E-10_JPRB, &
  & 0.72530017E-10_JPRB, 0.72134139E-10_JPRB, 0.71692645E-10_JPRB, 0.70895859E-10_JPRB /)

RGHG9(:,44,12) = (/ &
  & 0.70595953E-10_JPRB, 0.71065105E-10_JPRB, 0.71412015E-10_JPRB, 0.71814429E-10_JPRB, 0.72326985E-10_JPRB, 0.72909623E-10_JPRB, &
  & 0.73467128E-10_JPRB, 0.73962593E-10_JPRB, 0.74394060E-10_JPRB, 0.74779294E-10_JPRB, 0.75141740E-10_JPRB, 0.75520125E-10_JPRB, &
  & 0.75958087E-10_JPRB, 0.76545874E-10_JPRB, 0.77383801E-10_JPRB, 0.78625759E-10_JPRB, 0.80195170E-10_JPRB, 0.81813341E-10_JPRB, &
  & 0.83180379E-10_JPRB, 0.84193222E-10_JPRB, 0.84910884E-10_JPRB, 0.85423196E-10_JPRB, 0.85803559E-10_JPRB, 0.86098906E-10_JPRB, &
  & 0.86338908E-10_JPRB, 0.86541808E-10_JPRB, 0.86718563E-10_JPRB, 0.86875042E-10_JPRB, 0.87016436E-10_JPRB, 0.87134494E-10_JPRB, &
  & 0.87226795E-10_JPRB, 0.87285984E-10_JPRB, 0.87309292E-10_JPRB, 0.87296677E-10_JPRB, 0.87252941E-10_JPRB, 0.87185384E-10_JPRB, &
  & 0.87099390E-10_JPRB, 0.86996438E-10_JPRB, 0.86873765E-10_JPRB, 0.86724475E-10_JPRB, 0.86536375E-10_JPRB, 0.86292626E-10_JPRB, &
  & 0.85971175E-10_JPRB, 0.85546695E-10_JPRB, 0.84998099E-10_JPRB, 0.84322993E-10_JPRB, 0.83550333E-10_JPRB, 0.82716257E-10_JPRB, &
  & 0.81841478E-10_JPRB, 0.80923435E-10_JPRB, 0.79970489E-10_JPRB, 0.79019208E-10_JPRB, 0.78155947E-10_JPRB, 0.77434038E-10_JPRB, &
  & 0.76837967E-10_JPRB, 0.76333759E-10_JPRB, 0.75875556E-10_JPRB, 0.75443228E-10_JPRB, 0.75034402E-10_JPRB, 0.74660486E-10_JPRB, &
  & 0.74325199E-10_JPRB, 0.74006967E-10_JPRB, 0.73648740E-10_JPRB, 0.72993514E-10_JPRB /)

RGHG9(:,45,12) = (/ &
  & 0.72623074E-10_JPRB, 0.73092858E-10_JPRB, 0.73430692E-10_JPRB, 0.73832489E-10_JPRB, 0.74340797E-10_JPRB, 0.74911438E-10_JPRB, &
  & 0.75446011E-10_JPRB, 0.75912429E-10_JPRB, 0.76313240E-10_JPRB, 0.76665035E-10_JPRB, 0.76990886E-10_JPRB, 0.77323217E-10_JPRB, &
  & 0.77704204E-10_JPRB, 0.78203527E-10_JPRB, 0.78930126E-10_JPRB, 0.80003573E-10_JPRB, 0.81389645E-10_JPRB, 0.82779825E-10_JPRB, &
  & 0.83894891E-10_JPRB, 0.84704292E-10_JPRB, 0.85274232E-10_JPRB, 0.85689088E-10_JPRB, 0.86004828E-10_JPRB, 0.86259895E-10_JPRB, &
  & 0.86472586E-10_JPRB, 0.86658777E-10_JPRB, 0.86824159E-10_JPRB, 0.86973137E-10_JPRB, 0.87107530E-10_JPRB, 0.87218857E-10_JPRB, &
  & 0.87305337E-10_JPRB, 0.87360549E-10_JPRB, 0.87382671E-10_JPRB, 0.87370944E-10_JPRB, 0.87329685E-10_JPRB, 0.87266049E-10_JPRB, &
  & 0.87185870E-10_JPRB, 0.87091147E-10_JPRB, 0.86979923E-10_JPRB, 0.86846627E-10_JPRB, 0.86681815E-10_JPRB, 0.86471566E-10_JPRB, &
  & 0.86199284E-10_JPRB, 0.85843117E-10_JPRB, 0.85382382E-10_JPRB, 0.84808147E-10_JPRB, 0.84134658E-10_JPRB, 0.83395894E-10_JPRB, &
  & 0.82610543E-10_JPRB, 0.81778410E-10_JPRB, 0.80901050E-10_JPRB, 0.80037421E-10_JPRB, 0.79258496E-10_JPRB, 0.78619722E-10_JPRB, &
  & 0.78107729E-10_JPRB, 0.77675984E-10_JPRB, 0.77293706E-10_JPRB, 0.76936860E-10_JPRB, 0.76607734E-10_JPRB, 0.76313497E-10_JPRB, &
  & 0.76053261E-10_JPRB, 0.75807499E-10_JPRB, 0.75528889E-10_JPRB, 0.75016146E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART23',1,ZHOOK_HANDLE)
END SUBROUTINE PART23




SUBROUTINE PART24
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART24',0,ZHOOK_HANDLE)



RGHG9(:,46,12) = (/ &
  & 0.74543108E-10_JPRB, 0.75006029E-10_JPRB, 0.75348200E-10_JPRB, 0.75741829E-10_JPRB, 0.76248861E-10_JPRB, 0.76805090E-10_JPRB, &
  & 0.77326152E-10_JPRB, 0.77770838E-10_JPRB, 0.78148758E-10_JPRB, 0.78469217E-10_JPRB, 0.78760984E-10_JPRB, 0.79046152E-10_JPRB, &
  & 0.79373064E-10_JPRB, 0.79784714E-10_JPRB, 0.80402823E-10_JPRB, 0.81303748E-10_JPRB, 0.82480106E-10_JPRB, 0.83610341E-10_JPRB, &
  & 0.84495785E-10_JPRB, 0.85121805E-10_JPRB, 0.85571279E-10_JPRB, 0.85907260E-10_JPRB, 0.86173860E-10_JPRB, 0.86395384E-10_JPRB, &
  & 0.86588896E-10_JPRB, 0.86761195E-10_JPRB, 0.86920152E-10_JPRB, 0.87062170E-10_JPRB, 0.87192267E-10_JPRB, 0.87296823E-10_JPRB, &
  & 0.87377550E-10_JPRB, 0.87428648E-10_JPRB, 0.87448777E-10_JPRB, 0.87437099E-10_JPRB, 0.87397194E-10_JPRB, 0.87336222E-10_JPRB, &
  & 0.87260331E-10_JPRB, 0.87171957E-10_JPRB, 0.87070059E-10_JPRB, 0.86950294E-10_JPRB, 0.86804966E-10_JPRB, 0.86624194E-10_JPRB, &
  & 0.86394447E-10_JPRB, 0.86099614E-10_JPRB, 0.85720937E-10_JPRB, 0.85242341E-10_JPRB, 0.84669612E-10_JPRB, 0.84024662E-10_JPRB, &
  & 0.83327206E-10_JPRB, 0.82578722E-10_JPRB, 0.81798790E-10_JPRB, 0.81018220E-10_JPRB, 0.80345564E-10_JPRB, 0.79794310E-10_JPRB, &
  & 0.79360581E-10_JPRB, 0.79001174E-10_JPRB, 0.78682755E-10_JPRB, 0.78393403E-10_JPRB, 0.78130509E-10_JPRB, 0.77902004E-10_JPRB, &
  & 0.77703316E-10_JPRB, 0.77517048E-10_JPRB, 0.77304947E-10_JPRB, 0.76916203E-10_JPRB /)

RGHG9(:,47,12) = (/ &
  & 0.76358732E-10_JPRB, 0.76829695E-10_JPRB, 0.77164858E-10_JPRB, 0.77559348E-10_JPRB, 0.78052079E-10_JPRB, 0.78601937E-10_JPRB, &
  & 0.79105000E-10_JPRB, 0.79539202E-10_JPRB, 0.79889553E-10_JPRB, 0.80182673E-10_JPRB, 0.80433098E-10_JPRB, 0.80679061E-10_JPRB, &
  & 0.80939935E-10_JPRB, 0.81288663E-10_JPRB, 0.81768488E-10_JPRB, 0.82516854E-10_JPRB, 0.83437784E-10_JPRB, 0.84321015E-10_JPRB, &
  & 0.84984943E-10_JPRB, 0.85462817E-10_JPRB, 0.85813905E-10_JPRB, 0.86088914E-10_JPRB, 0.86315739E-10_JPRB, 0.86512963E-10_JPRB, &
  & 0.86690585E-10_JPRB, 0.86854163E-10_JPRB, 0.87007158E-10_JPRB, 0.87146262E-10_JPRB, 0.87270011E-10_JPRB, 0.87369827E-10_JPRB, &
  & 0.87444170E-10_JPRB, 0.87491112E-10_JPRB, 0.87508806E-10_JPRB, 0.87496441E-10_JPRB, 0.87457062E-10_JPRB, 0.87397825E-10_JPRB, &
  & 0.87324960E-10_JPRB, 0.87241617E-10_JPRB, 0.87147192E-10_JPRB, 0.87038474E-10_JPRB, 0.86909868E-10_JPRB, 0.86753445E-10_JPRB, &
  & 0.86560904E-10_JPRB, 0.86320527E-10_JPRB, 0.86017062E-10_JPRB, 0.85635603E-10_JPRB, 0.85164834E-10_JPRB, 0.84618250E-10_JPRB, &
  & 0.84012464E-10_JPRB, 0.83357446E-10_JPRB, 0.82657867E-10_JPRB, 0.81996833E-10_JPRB, 0.81406472E-10_JPRB, 0.80954514E-10_JPRB, &
  & 0.80591971E-10_JPRB, 0.80295146E-10_JPRB, 0.80035957E-10_JPRB, 0.79799868E-10_JPRB, 0.79591909E-10_JPRB, 0.79413837E-10_JPRB, &
  & 0.79262472E-10_JPRB, 0.79120786E-10_JPRB, 0.78961171E-10_JPRB, 0.78664956E-10_JPRB /)

RGHG9(:,48,12) = (/ &
  & 0.78078100E-10_JPRB, 0.78550097E-10_JPRB, 0.78886772E-10_JPRB, 0.79272970E-10_JPRB, 0.79759435E-10_JPRB, 0.80292259E-10_JPRB, &
  & 0.80792296E-10_JPRB, 0.81202781E-10_JPRB, 0.81532510E-10_JPRB, 0.81786501E-10_JPRB, 0.82001808E-10_JPRB, 0.82196722E-10_JPRB, &
  & 0.82411938E-10_JPRB, 0.82670482E-10_JPRB, 0.83052606E-10_JPRB, 0.83589850E-10_JPRB, 0.84273720E-10_JPRB, 0.84902120E-10_JPRB, &
  & 0.85384255E-10_JPRB, 0.85738382E-10_JPRB, 0.86013766E-10_JPRB, 0.86240140E-10_JPRB, 0.86437545E-10_JPRB, 0.86615368E-10_JPRB, &
  & 0.86782248E-10_JPRB, 0.86939247E-10_JPRB, 0.87089086E-10_JPRB, 0.87223860E-10_JPRB, 0.87343674E-10_JPRB, 0.87437092E-10_JPRB, &
  & 0.87506023E-10_JPRB, 0.87548538E-10_JPRB, 0.87563505E-10_JPRB, 0.87549863E-10_JPRB, 0.87510513E-10_JPRB, 0.87452171E-10_JPRB, &
  & 0.87381602E-10_JPRB, 0.87302034E-10_JPRB, 0.87213577E-10_JPRB, 0.87113997E-10_JPRB, 0.86998832E-10_JPRB, 0.86863274E-10_JPRB, &
  & 0.86701868E-10_JPRB, 0.86508259E-10_JPRB, 0.86274300E-10_JPRB, 0.85983415E-10_JPRB, 0.85623300E-10_JPRB, 0.85186400E-10_JPRB, &
  & 0.84681977E-10_JPRB, 0.84119198E-10_JPRB, 0.83529940E-10_JPRB, 0.82948606E-10_JPRB, 0.82474194E-10_JPRB, 0.82092382E-10_JPRB, &
  & 0.81800261E-10_JPRB, 0.81557205E-10_JPRB, 0.81344299E-10_JPRB, 0.81153598E-10_JPRB, 0.80985760E-10_JPRB, 0.80846010E-10_JPRB, &
  & 0.80727813E-10_JPRB, 0.80619046E-10_JPRB, 0.80494979E-10_JPRB, 0.80268146E-10_JPRB /)

RGHG9(:,49,12) = (/ &
  & 0.79691531E-10_JPRB, 0.80159657E-10_JPRB, 0.80496859E-10_JPRB, 0.80877062E-10_JPRB, 0.81354340E-10_JPRB, 0.81881377E-10_JPRB, &
  & 0.82365982E-10_JPRB, 0.82761936E-10_JPRB, 0.83051545E-10_JPRB, 0.83268580E-10_JPRB, 0.83437618E-10_JPRB, 0.83588914E-10_JPRB, &
  & 0.83743165E-10_JPRB, 0.83926859E-10_JPRB, 0.84176957E-10_JPRB, 0.84523402E-10_JPRB, 0.84957666E-10_JPRB, 0.85372709E-10_JPRB, &
  & 0.85703229E-10_JPRB, 0.85963583E-10_JPRB, 0.86178807E-10_JPRB, 0.86368350E-10_JPRB, 0.86542537E-10_JPRB, 0.86707044E-10_JPRB, &
  & 0.86866028E-10_JPRB, 0.87019128E-10_JPRB, 0.87166031E-10_JPRB, 0.87297808E-10_JPRB, 0.87411460E-10_JPRB, 0.87499952E-10_JPRB, &
  & 0.87563186E-10_JPRB, 0.87601426E-10_JPRB, 0.87613486E-10_JPRB, 0.87598241E-10_JPRB, 0.87558356E-10_JPRB, 0.87500632E-10_JPRB, &
  & 0.87431604E-10_JPRB, 0.87354998E-10_JPRB, 0.87271315E-10_JPRB, 0.87178917E-10_JPRB, 0.87074889E-10_JPRB, 0.86956005E-10_JPRB, &
  & 0.86820467E-10_JPRB, 0.86666799E-10_JPRB, 0.86491141E-10_JPRB, 0.86285923E-10_JPRB, 0.86033076E-10_JPRB, 0.85718189E-10_JPRB, &
  & 0.85332533E-10_JPRB, 0.84882198E-10_JPRB, 0.84392528E-10_JPRB, 0.83928829E-10_JPRB, 0.83535880E-10_JPRB, 0.83234926E-10_JPRB, &
  & 0.82996457E-10_JPRB, 0.82798886E-10_JPRB, 0.82623533E-10_JPRB, 0.82465521E-10_JPRB, 0.82328089E-10_JPRB, 0.82213833E-10_JPRB, &
  & 0.82119062E-10_JPRB, 0.82031305E-10_JPRB, 0.81932128E-10_JPRB, 0.81749184E-10_JPRB /)

RGHG9(:,50,12) = (/ &
  & 0.81167698E-10_JPRB, 0.81646669E-10_JPRB, 0.81968439E-10_JPRB, 0.82351119E-10_JPRB, 0.82816649E-10_JPRB, 0.83340029E-10_JPRB, &
  & 0.83807322E-10_JPRB, 0.84161102E-10_JPRB, 0.84401153E-10_JPRB, 0.84561663E-10_JPRB, 0.84679375E-10_JPRB, 0.84777123E-10_JPRB, &
  & 0.84866641E-10_JPRB, 0.84971682E-10_JPRB, 0.85092128E-10_JPRB, 0.85272317E-10_JPRB, 0.85499129E-10_JPRB, 0.85744259E-10_JPRB, &
  & 0.85960551E-10_JPRB, 0.86147603E-10_JPRB, 0.86318050E-10_JPRB, 0.86478581E-10_JPRB, 0.86635137E-10_JPRB, 0.86790415E-10_JPRB, &
  & 0.86944188E-10_JPRB, 0.87095199E-10_JPRB, 0.87238917E-10_JPRB, 0.87366891E-10_JPRB, 0.87474923E-10_JPRB, 0.87557857E-10_JPRB, &
  & 0.87616185E-10_JPRB, 0.87650290E-10_JPRB, 0.87659276E-10_JPRB, 0.87642116E-10_JPRB, 0.87601586E-10_JPRB, 0.87544076E-10_JPRB, &
  & 0.87476283E-10_JPRB, 0.87401975E-10_JPRB, 0.87322004E-10_JPRB, 0.87235393E-10_JPRB, 0.87140031E-10_JPRB, 0.87034768E-10_JPRB, &
  & 0.86920367E-10_JPRB, 0.86799005E-10_JPRB, 0.86672926E-10_JPRB, 0.86537943E-10_JPRB, 0.86382110E-10_JPRB, 0.86185413E-10_JPRB, &
  & 0.85930617E-10_JPRB, 0.85613849E-10_JPRB, 0.85255164E-10_JPRB, 0.84910010E-10_JPRB, 0.84615606E-10_JPRB, 0.84385443E-10_JPRB, &
  & 0.84198912E-10_JPRB, 0.84038741E-10_JPRB, 0.83895772E-10_JPRB, 0.83762497E-10_JPRB, 0.83646638E-10_JPRB, 0.83550195E-10_JPRB, &
  & 0.83469717E-10_JPRB, 0.83394860E-10_JPRB, 0.83309221E-10_JPRB, 0.83150313E-10_JPRB /)

RGHG9(:,51,12) = (/ &
  & 0.82514960E-10_JPRB, 0.82951021E-10_JPRB, 0.83291193E-10_JPRB, 0.83645570E-10_JPRB, 0.84115666E-10_JPRB, 0.84604476E-10_JPRB, &
  & 0.85026861E-10_JPRB, 0.85298442E-10_JPRB, 0.85457627E-10_JPRB, 0.85552010E-10_JPRB, 0.85613315E-10_JPRB, 0.85656454E-10_JPRB, &
  & 0.85694313E-10_JPRB, 0.85725718E-10_JPRB, 0.85767629E-10_JPRB, 0.85819303E-10_JPRB, 0.85913221E-10_JPRB, 0.86035942E-10_JPRB, &
  & 0.86168725E-10_JPRB, 0.86302646E-10_JPRB, 0.86437232E-10_JPRB, 0.86575719E-10_JPRB, 0.86719590E-10_JPRB, 0.86867423E-10_JPRB, &
  & 0.87018726E-10_JPRB, 0.87167093E-10_JPRB, 0.87308258E-10_JPRB, 0.87431118E-10_JPRB, 0.87533675E-10_JPRB, 0.87611564E-10_JPRB, &
  & 0.87665222E-10_JPRB, 0.87695476E-10_JPRB, 0.87701346E-10_JPRB, 0.87682167E-10_JPRB, 0.87640832E-10_JPRB, 0.87583413E-10_JPRB, &
  & 0.87516598E-10_JPRB, 0.87444163E-10_JPRB, 0.87367183E-10_JPRB, 0.87285040E-10_JPRB, 0.87196667E-10_JPRB, 0.87102242E-10_JPRB, &
  & 0.87005035E-10_JPRB, 0.86910430E-10_JPRB, 0.86823743E-10_JPRB, 0.86744181E-10_JPRB, 0.86662649E-10_JPRB, 0.86562445E-10_JPRB, &
  & 0.86426720E-10_JPRB, 0.86247696E-10_JPRB, 0.86039537E-10_JPRB, 0.85826311E-10_JPRB, 0.85643354E-10_JPRB, 0.85487124E-10_JPRB, &
  & 0.85356090E-10_JPRB, 0.85239343E-10_JPRB, 0.85126295E-10_JPRB, 0.85021948E-10_JPRB, 0.84925719E-10_JPRB, 0.84844687E-10_JPRB, &
  & 0.84775888E-10_JPRB, 0.84710280E-10_JPRB, 0.84632287E-10_JPRB, 0.84487570E-10_JPRB /)

RGHG9(:,52,12) = (/ &
  & 0.83645771E-10_JPRB, 0.84106888E-10_JPRB, 0.84386276E-10_JPRB, 0.84754946E-10_JPRB, 0.85159789E-10_JPRB, 0.85597383E-10_JPRB, &
  & 0.85894569E-10_JPRB, 0.86061991E-10_JPRB, 0.86142309E-10_JPRB, 0.86182984E-10_JPRB, 0.86204321E-10_JPRB, 0.86216118E-10_JPRB, &
  & 0.86220600E-10_JPRB, 0.86220031E-10_JPRB, 0.86214653E-10_JPRB, 0.86209061E-10_JPRB, 0.86220635E-10_JPRB, 0.86266633E-10_JPRB, &
  & 0.86341045E-10_JPRB, 0.86434401E-10_JPRB, 0.86542981E-10_JPRB, 0.86664301E-10_JPRB, 0.86797278E-10_JPRB, 0.86941301E-10_JPRB, &
  & 0.87089072E-10_JPRB, 0.87236031E-10_JPRB, 0.87372352E-10_JPRB, 0.87491146E-10_JPRB, 0.87587881E-10_JPRB, 0.87661337E-10_JPRB, &
  & 0.87710728E-10_JPRB, 0.87737304E-10_JPRB, 0.87740169E-10_JPRB, 0.87718929E-10_JPRB, 0.87676644E-10_JPRB, 0.87619335E-10_JPRB, &
  & 0.87553347E-10_JPRB, 0.87482507E-10_JPRB, 0.87407977E-10_JPRB, 0.87329532E-10_JPRB, 0.87246654E-10_JPRB, 0.87161223E-10_JPRB, &
  & 0.87078178E-10_JPRB, 0.87005736E-10_JPRB, 0.86949919E-10_JPRB, 0.86911194E-10_JPRB, 0.86880142E-10_JPRB, 0.86843990E-10_JPRB, &
  & 0.86790679E-10_JPRB, 0.86715142E-10_JPRB, 0.86621141E-10_JPRB, 0.86524260E-10_JPRB, 0.86430939E-10_JPRB, 0.86349594E-10_JPRB, &
  & 0.86274550E-10_JPRB, 0.86201636E-10_JPRB, 0.86131435E-10_JPRB, 0.86058008E-10_JPRB, 0.85991075E-10_JPRB, 0.85932483E-10_JPRB, &
  & 0.85881538E-10_JPRB, 0.85831592E-10_JPRB, 0.85770675E-10_JPRB, 0.85648662E-10_JPRB /)

RGHG9(:,53,12) = (/ &
  & 0.84630414E-10_JPRB, 0.84993582E-10_JPRB, 0.85306609E-10_JPRB, 0.85583748E-10_JPRB, 0.85948963E-10_JPRB, 0.86240182E-10_JPRB, &
  & 0.86424923E-10_JPRB, 0.86503561E-10_JPRB, 0.86536792E-10_JPRB, 0.86549830E-10_JPRB, 0.86553716E-10_JPRB, 0.86552113E-10_JPRB, &
  & 0.86545202E-10_JPRB, 0.86533905E-10_JPRB, 0.86510743E-10_JPRB, 0.86483397E-10_JPRB, 0.86454642E-10_JPRB, 0.86452602E-10_JPRB, &
  & 0.86486172E-10_JPRB, 0.86550475E-10_JPRB, 0.86638419E-10_JPRB, 0.86746527E-10_JPRB, 0.86872627E-10_JPRB, 0.87010961E-10_JPRB, &
  & 0.87157226E-10_JPRB, 0.87299862E-10_JPRB, 0.87432818E-10_JPRB, 0.87546255E-10_JPRB, 0.87638410E-10_JPRB, 0.87707487E-10_JPRB, &
  & 0.87753006E-10_JPRB, 0.87776078E-10_JPRB, 0.87776071E-10_JPRB, 0.87752819E-10_JPRB, 0.87709638E-10_JPRB, 0.87652316E-10_JPRB, &
  & 0.87587104E-10_JPRB, 0.87517764E-10_JPRB, 0.87445426E-10_JPRB, 0.87370049E-10_JPRB, 0.87292090E-10_JPRB, 0.87213931E-10_JPRB, &
  & 0.87143306E-10_JPRB, 0.87088670E-10_JPRB, 0.87057306E-10_JPRB, 0.87046384E-10_JPRB, 0.87046773E-10_JPRB, 0.87046800E-10_JPRB, &
  & 0.87037634E-10_JPRB, 0.87015582E-10_JPRB, 0.86982685E-10_JPRB, 0.86943341E-10_JPRB, 0.86904373E-10_JPRB, 0.86865896E-10_JPRB, &
  & 0.86828669E-10_JPRB, 0.86791602E-10_JPRB, 0.86750870E-10_JPRB, 0.86710583E-10_JPRB, 0.86670747E-10_JPRB, 0.86636379E-10_JPRB, &
  & 0.86607332E-10_JPRB, 0.86579424E-10_JPRB, 0.86545632E-10_JPRB, 0.86472593E-10_JPRB /)

RGHG9(:,54,12) = (/ &
  & 0.85366610E-10_JPRB, 0.85748901E-10_JPRB, 0.85952294E-10_JPRB, 0.86217235E-10_JPRB, 0.86446801E-10_JPRB, 0.86638606E-10_JPRB, &
  & 0.86726390E-10_JPRB, 0.86760529E-10_JPRB, 0.86771007E-10_JPRB, 0.86772742E-10_JPRB, 0.86770327E-10_JPRB, 0.86764804E-10_JPRB, &
  & 0.86756498E-10_JPRB, 0.86741087E-10_JPRB, 0.86720763E-10_JPRB, 0.86681426E-10_JPRB, 0.86638766E-10_JPRB, 0.86607332E-10_JPRB, &
  & 0.86612273E-10_JPRB, 0.86654316E-10_JPRB, 0.86727174E-10_JPRB, 0.86825248E-10_JPRB, 0.86944160E-10_JPRB, 0.87079371E-10_JPRB, &
  & 0.87220731E-10_JPRB, 0.87360688E-10_JPRB, 0.87488440E-10_JPRB, 0.87598005E-10_JPRB, 0.87685435E-10_JPRB, 0.87750467E-10_JPRB, &
  & 0.87792350E-10_JPRB, 0.87812153E-10_JPRB, 0.87809399E-10_JPRB, 0.87784377E-10_JPRB, 0.87740308E-10_JPRB, 0.87682951E-10_JPRB, &
  & 0.87618593E-10_JPRB, 0.87550557E-10_JPRB, 0.87480329E-10_JPRB, 0.87407935E-10_JPRB, 0.87334071E-10_JPRB, 0.87263044E-10_JPRB, &
  & 0.87202370E-10_JPRB, 0.87163207E-10_JPRB, 0.87149614E-10_JPRB, 0.87157427E-10_JPRB, 0.87175940E-10_JPRB, 0.87194162E-10_JPRB, &
  & 0.87205250E-10_JPRB, 0.87206305E-10_JPRB, 0.87198096E-10_JPRB, 0.87184211E-10_JPRB, 0.87167273E-10_JPRB, 0.87149690E-10_JPRB, &
  & 0.87131379E-10_JPRB, 0.87111374E-10_JPRB, 0.87090453E-10_JPRB, 0.87067131E-10_JPRB, 0.87045454E-10_JPRB, 0.87027580E-10_JPRB, &
  & 0.87013619E-10_JPRB, 0.87003127E-10_JPRB, 0.86995258E-10_JPRB, 0.86991470E-10_JPRB /)

RGHG9(:,55,12) = (/ &
  & 0.85976788E-10_JPRB, 0.86250652E-10_JPRB, 0.86459874E-10_JPRB, 0.86614750E-10_JPRB, 0.86776773E-10_JPRB, 0.86872919E-10_JPRB, &
  & 0.86914462E-10_JPRB, 0.86925050E-10_JPRB, 0.86925897E-10_JPRB, 0.86923357E-10_JPRB, 0.86919139E-10_JPRB, 0.86913449E-10_JPRB, &
  & 0.86904858E-10_JPRB, 0.86893423E-10_JPRB, 0.86870858E-10_JPRB, 0.86839903E-10_JPRB, 0.86787383E-10_JPRB, 0.86739914E-10_JPRB, &
  & 0.86724537E-10_JPRB, 0.86750225E-10_JPRB, 0.86811065E-10_JPRB, 0.86901028E-10_JPRB, 0.87014340E-10_JPRB, 0.87144056E-10_JPRB, &
  & 0.87282091E-10_JPRB, 0.87417046E-10_JPRB, 0.87541321E-10_JPRB, 0.87646487E-10_JPRB, 0.87729733E-10_JPRB, 0.87790754E-10_JPRB, &
  & 0.87829174E-10_JPRB, 0.87845904E-10_JPRB, 0.87840644E-10_JPRB, 0.87813999E-10_JPRB, 0.87769292E-10_JPRB, 0.87712018E-10_JPRB, &
  & 0.87648271E-10_JPRB, 0.87581789E-10_JPRB, 0.87513399E-10_JPRB, 0.87443927E-10_JPRB, 0.87374469E-10_JPRB, 0.87309313E-10_JPRB, &
  & 0.87258367E-10_JPRB, 0.87230695E-10_JPRB, 0.87230438E-10_JPRB, 0.87250734E-10_JPRB, 0.87279003E-10_JPRB, 0.87306148E-10_JPRB, &
  & 0.87325668E-10_JPRB, 0.87335826E-10_JPRB, 0.87337443E-10_JPRB, 0.87333321E-10_JPRB, 0.87326299E-10_JPRB, 0.87317702E-10_JPRB, &
  & 0.87308001E-10_JPRB, 0.87297267E-10_JPRB, 0.87284485E-10_JPRB, 0.87270954E-10_JPRB, 0.87257333E-10_JPRB, 0.87245461E-10_JPRB, &
  & 0.87235996E-10_JPRB, 0.87227503E-10_JPRB, 0.87218593E-10_JPRB, 0.87203827E-10_JPRB /)

RGHG9(:,56,12) = (/ &
  & 0.86407694E-10_JPRB, 0.86655350E-10_JPRB, 0.86777821E-10_JPRB, 0.86894762E-10_JPRB, 0.86980617E-10_JPRB, 0.87030709E-10_JPRB, &
  & 0.87044122E-10_JPRB, 0.87044344E-10_JPRB, 0.87041138E-10_JPRB, 0.87037197E-10_JPRB, 0.87032784E-10_JPRB, 0.87027455E-10_JPRB, &
  & 0.87020807E-10_JPRB, 0.87009816E-10_JPRB, 0.86994412E-10_JPRB, 0.86962014E-10_JPRB, 0.86915218E-10_JPRB, 0.86857341E-10_JPRB, &
  & 0.86827254E-10_JPRB, 0.86840465E-10_JPRB, 0.86892174E-10_JPRB, 0.86974761E-10_JPRB, 0.87082425E-10_JPRB, 0.87207165E-10_JPRB, &
  & 0.87340024E-10_JPRB, 0.87471391E-10_JPRB, 0.87591261E-10_JPRB, 0.87692485E-10_JPRB, 0.87771748E-10_JPRB, 0.87828786E-10_JPRB, &
  & 0.87863848E-10_JPRB, 0.87877768E-10_JPRB, 0.87870357E-10_JPRB, 0.87842365E-10_JPRB, 0.87797186E-10_JPRB, 0.87740107E-10_JPRB, &
  & 0.87677254E-10_JPRB, 0.87611869E-10_JPRB, 0.87545769E-10_JPRB, 0.87479003E-10_JPRB, 0.87413743E-10_JPRB, 0.87354936E-10_JPRB, &
  & 0.87311415E-10_JPRB, 0.87293429E-10_JPRB, 0.87302748E-10_JPRB, 0.87330296E-10_JPRB, 0.87365074E-10_JPRB, 0.87395938E-10_JPRB, &
  & 0.87418739E-10_JPRB, 0.87431756E-10_JPRB, 0.87436947E-10_JPRB, 0.87436822E-10_JPRB, 0.87433838E-10_JPRB, 0.87429397E-10_JPRB, &
  & 0.87423943E-10_JPRB, 0.87417282E-10_JPRB, 0.87409621E-10_JPRB, 0.87400559E-10_JPRB, 0.87391469E-10_JPRB, 0.87383614E-10_JPRB, &
  & 0.87376911E-10_JPRB, 0.87371159E-10_JPRB, 0.87365330E-10_JPRB, 0.87356587E-10_JPRB /)

RGHG9(:,57,12) = (/ &
  & 0.86737166E-10_JPRB, 0.86916585E-10_JPRB, 0.87010538E-10_JPRB, 0.87076693E-10_JPRB, 0.87124058E-10_JPRB, 0.87143619E-10_JPRB, &
  & 0.87144215E-10_JPRB, 0.87139768E-10_JPRB, 0.87135084E-10_JPRB, 0.87130872E-10_JPRB, 0.87126820E-10_JPRB, 0.87122365E-10_JPRB, &
  & 0.87116474E-10_JPRB, 0.87108570E-10_JPRB, 0.87093541E-10_JPRB, 0.87070073E-10_JPRB, 0.87022493E-10_JPRB, 0.86962597E-10_JPRB, &
  & 0.86923170E-10_JPRB, 0.86927229E-10_JPRB, 0.86971090E-10_JPRB, 0.87047522E-10_JPRB, 0.87149003E-10_JPRB, 0.87268588E-10_JPRB, &
  & 0.87396701E-10_JPRB, 0.87523398E-10_JPRB, 0.87639167E-10_JPRB, 0.87736519E-10_JPRB, 0.87811619E-10_JPRB, 0.87864903E-10_JPRB, &
  & 0.87896822E-10_JPRB, 0.87908153E-10_JPRB, 0.87898952E-10_JPRB, 0.87869982E-10_JPRB, 0.87824518E-10_JPRB, 0.87768022E-10_JPRB, &
  & 0.87705933E-10_JPRB, 0.87642171E-10_JPRB, 0.87577737E-10_JPRB, 0.87514128E-10_JPRB, 0.87452989E-10_JPRB, 0.87399539E-10_JPRB, &
  & 0.87363242E-10_JPRB, 0.87352230E-10_JPRB, 0.87367710E-10_JPRB, 0.87401343E-10_JPRB, 0.87438688E-10_JPRB, 0.87471877E-10_JPRB, &
  & 0.87495060E-10_JPRB, 0.87508722E-10_JPRB, 0.87514551E-10_JPRB, 0.87515779E-10_JPRB, 0.87514510E-10_JPRB, 0.87511942E-10_JPRB, &
  & 0.87508459E-10_JPRB, 0.87504178E-10_JPRB, 0.87498730E-10_JPRB, 0.87492569E-10_JPRB, 0.87486046E-10_JPRB, 0.87479954E-10_JPRB, &
  & 0.87474875E-10_JPRB, 0.87470045E-10_JPRB, 0.87464688E-10_JPRB, 0.87455342E-10_JPRB /)

RGHG9(:,58,12) = (/ &
  & 0.86979042E-10_JPRB, 0.87109930E-10_JPRB, 0.87170125E-10_JPRB, 0.87207838E-10_JPRB, 0.87230792E-10_JPRB, 0.87234539E-10_JPRB, &
  & 0.87228801E-10_JPRB, 0.87222181E-10_JPRB, 0.87217185E-10_JPRB, 0.87213195E-10_JPRB, 0.87209601E-10_JPRB, 0.87205784E-10_JPRB, &
  & 0.87201163E-10_JPRB, 0.87193905E-10_JPRB, 0.87182900E-10_JPRB, 0.87159349E-10_JPRB, 0.87119291E-10_JPRB, 0.87057687E-10_JPRB, &
  & 0.87013598E-10_JPRB, 0.87011398E-10_JPRB, 0.87048924E-10_JPRB, 0.87119083E-10_JPRB, 0.87215395E-10_JPRB, 0.87329123E-10_JPRB, &
  & 0.87452351E-10_JPRB, 0.87574170E-10_JPRB, 0.87685664E-10_JPRB, 0.87778416E-10_JPRB, 0.87849804E-10_JPRB, 0.87899452E-10_JPRB, &
  & 0.87928338E-10_JPRB, 0.87937463E-10_JPRB, 0.87926832E-10_JPRB, 0.87897231E-10_JPRB, 0.87851865E-10_JPRB, 0.87796111E-10_JPRB, &
  & 0.87735208E-10_JPRB, 0.87672737E-10_JPRB, 0.87610461E-10_JPRB, 0.87549482E-10_JPRB, 0.87492291E-10_JPRB, 0.87444260E-10_JPRB, &
  & 0.87413479E-10_JPRB, 0.87408032E-10_JPRB, 0.87428460E-10_JPRB, 0.87464307E-10_JPRB, 0.87504781E-10_JPRB, 0.87538019E-10_JPRB, &
  & 0.87561160E-10_JPRB, 0.87573677E-10_JPRB, 0.87579256E-10_JPRB, 0.87580602E-10_JPRB, 0.87579860E-10_JPRB, 0.87578028E-10_JPRB, &
  & 0.87575502E-10_JPRB, 0.87572199E-10_JPRB, 0.87568230E-10_JPRB, 0.87563318E-10_JPRB, 0.87558127E-10_JPRB, 0.87553347E-10_JPRB, &
  & 0.87548996E-10_JPRB, 0.87545013E-10_JPRB, 0.87540607E-10_JPRB, 0.87532995E-10_JPRB /)

RGHG9(:,59,12) = (/ &
  & 0.87160605E-10_JPRB, 0.87256438E-10_JPRB, 0.87289308E-10_JPRB, 0.87309965E-10_JPRB, 0.87317154E-10_JPRB, 0.87312768E-10_JPRB, &
  & 0.87303859E-10_JPRB, 0.87296850E-10_JPRB, 0.87291868E-10_JPRB, 0.87288302E-10_JPRB, 0.87285269E-10_JPRB, 0.87282154E-10_JPRB, &
  & 0.87278185E-10_JPRB, 0.87272509E-10_JPRB, 0.87261809E-10_JPRB, 0.87242866E-10_JPRB, 0.87202676E-10_JPRB, 0.87144889E-10_JPRB, &
  & 0.87099633E-10_JPRB, 0.87093492E-10_JPRB, 0.87125786E-10_JPRB, 0.87190796E-10_JPRB, 0.87281175E-10_JPRB, 0.87389929E-10_JPRB, &
  & 0.87507397E-10_JPRB, 0.87624311E-10_JPRB, 0.87730483E-10_JPRB, 0.87819058E-10_JPRB, 0.87886212E-10_JPRB, 0.87932481E-10_JPRB, &
  & 0.87958772E-10_JPRB, 0.87965961E-10_JPRB, 0.87954179E-10_JPRB, 0.87924362E-10_JPRB, 0.87879468E-10_JPRB, 0.87824727E-10_JPRB, &
  & 0.87765184E-10_JPRB, 0.87704254E-10_JPRB, 0.87643809E-10_JPRB, 0.87585557E-10_JPRB, 0.87532120E-10_JPRB, 0.87488503E-10_JPRB, &
  & 0.87462981E-10_JPRB, 0.87461802E-10_JPRB, 0.87484651E-10_JPRB, 0.87523280E-10_JPRB, 0.87563817E-10_JPRB, 0.87597866E-10_JPRB, &
  & 0.87619537E-10_JPRB, 0.87631132E-10_JPRB, 0.87635676E-10_JPRB, 0.87636634E-10_JPRB, 0.87635843E-10_JPRB, 0.87634205E-10_JPRB, &
  & 0.87631964E-10_JPRB, 0.87629209E-10_JPRB, 0.87625691E-10_JPRB, 0.87621639E-10_JPRB, 0.87617177E-10_JPRB, 0.87612848E-10_JPRB, &
  & 0.87609066E-10_JPRB, 0.87605367E-10_JPRB, 0.87601121E-10_JPRB, 0.87593578E-10_JPRB /)

RGHG9(:,60,12) = (/ &
  & 0.87343757E-10_JPRB, 0.87371818E-10_JPRB, 0.87386286E-10_JPRB, 0.87392628E-10_JPRB, 0.87391747E-10_JPRB, 0.87383434E-10_JPRB, &
  & 0.87373470E-10_JPRB, 0.87366073E-10_JPRB, 0.87361549E-10_JPRB, 0.87358468E-10_JPRB, 0.87356067E-10_JPRB, 0.87353638E-10_JPRB, &
  & 0.87350557E-10_JPRB, 0.87345506E-10_JPRB, 0.87336610E-10_JPRB, 0.87317348E-10_JPRB, 0.87280565E-10_JPRB, 0.87225102E-10_JPRB, &
  & 0.87182025E-10_JPRB, 0.87173962E-10_JPRB, 0.87202280E-10_JPRB, 0.87262267E-10_JPRB, 0.87347685E-10_JPRB, 0.87450484E-10_JPRB, &
  & 0.87562686E-10_JPRB, 0.87673584E-10_JPRB, 0.87774663E-10_JPRB, 0.87857950E-10_JPRB, 0.87921302E-10_JPRB, 0.87964219E-10_JPRB, &
  & 0.87988082E-10_JPRB, 0.87993716E-10_JPRB, 0.87981192E-10_JPRB, 0.87951417E-10_JPRB, 0.87907390E-10_JPRB, 0.87854043E-10_JPRB, &
  & 0.87795896E-10_JPRB, 0.87736624E-10_JPRB, 0.87678032E-10_JPRB, 0.87622340E-10_JPRB, 0.87572158E-10_JPRB, 0.87532953E-10_JPRB, &
  & 0.87511581E-10_JPRB, 0.87513767E-10_JPRB, 0.87538803E-10_JPRB, 0.87577383E-10_JPRB, 0.87619037E-10_JPRB, 0.87652031E-10_JPRB, &
  & 0.87673160E-10_JPRB, 0.87683125E-10_JPRB, 0.87686691E-10_JPRB, 0.87686969E-10_JPRB, 0.87685789E-10_JPRB, 0.87683930E-10_JPRB, &
  & 0.87681654E-10_JPRB, 0.87678864E-10_JPRB, 0.87675617E-10_JPRB, 0.87671662E-10_JPRB, 0.87667477E-10_JPRB, 0.87663495E-10_JPRB, &
  & 0.87659796E-10_JPRB, 0.87656313E-10_JPRB, 0.87652371E-10_JPRB, 0.87645412E-10_JPRB /)

RGHG9(:,61,12) = (/ &
  & 0.87434421E-10_JPRB, 0.87456056E-10_JPRB, 0.87462426E-10_JPRB, 0.87463752E-10_JPRB, 0.87459318E-10_JPRB, 0.87448965E-10_JPRB, &
  & 0.87438577E-10_JPRB, 0.87431493E-10_JPRB, 0.87427190E-10_JPRB, 0.87424790E-10_JPRB, 0.87423180E-10_JPRB, 0.87421695E-10_JPRB, &
  & 0.87419558E-10_JPRB, 0.87415616E-10_JPRB, 0.87407082E-10_JPRB, 0.87388978E-10_JPRB, 0.87352431E-10_JPRB, 0.87301583E-10_JPRB, &
  & 0.87261906E-10_JPRB, 0.87253232E-10_JPRB, 0.87278469E-10_JPRB, 0.87334188E-10_JPRB, 0.87414277E-10_JPRB, 0.87511803E-10_JPRB, &
  & 0.87617705E-10_JPRB, 0.87722843E-10_JPRB, 0.87817698E-10_JPRB, 0.87896072E-10_JPRB, 0.87954970E-10_JPRB, 0.87994806E-10_JPRB, &
  & 0.88016490E-10_JPRB, 0.88020841E-10_JPRB, 0.88007920E-10_JPRB, 0.87978617E-10_JPRB, 0.87935763E-10_JPRB, 0.87883908E-10_JPRB, &
  & 0.87827509E-10_JPRB, 0.87769729E-10_JPRB, 0.87713066E-10_JPRB, 0.87659636E-10_JPRB, 0.87612750E-10_JPRB, 0.87577195E-10_JPRB, &
  & 0.87559654E-10_JPRB, 0.87564594E-10_JPRB, 0.87590477E-10_JPRB, 0.87629334E-10_JPRB, 0.87669837E-10_JPRB, 0.87702935E-10_JPRB, &
  & 0.87722628E-10_JPRB, 0.87731683E-10_JPRB, 0.87734063E-10_JPRB, 0.87733459E-10_JPRB, 0.87731641E-10_JPRB, 0.87729345E-10_JPRB, &
  & 0.87726673E-10_JPRB, 0.87723724E-10_JPRB, 0.87720178E-10_JPRB, 0.87716265E-10_JPRB, 0.87712018E-10_JPRB, 0.87707910E-10_JPRB, &
  & 0.87704240E-10_JPRB, 0.87700638E-10_JPRB, 0.87696510E-10_JPRB, 0.87689266E-10_JPRB /)

RGHG9(:,62,12) = (/ &
  & 0.87513115E-10_JPRB, 0.87526521E-10_JPRB, 0.87529539E-10_JPRB, 0.87527999E-10_JPRB, 0.87521393E-10_JPRB, 0.87511220E-10_JPRB, &
  & 0.87500632E-10_JPRB, 0.87493221E-10_JPRB, 0.87489405E-10_JPRB, 0.87487698E-10_JPRB, 0.87487260E-10_JPRB, 0.87487143E-10_JPRB, &
  & 0.87486407E-10_JPRB, 0.87483562E-10_JPRB, 0.87475825E-10_JPRB, 0.87457257E-10_JPRB, 0.87421910E-10_JPRB, 0.87375690E-10_JPRB, &
  & 0.87340017E-10_JPRB, 0.87331684E-10_JPRB, 0.87354651E-10_JPRB, 0.87406464E-10_JPRB, 0.87481668E-10_JPRB, 0.87573337E-10_JPRB, &
  & 0.87673181E-10_JPRB, 0.87771679E-10_JPRB, 0.87860469E-10_JPRB, 0.87933091E-10_JPRB, 0.87987825E-10_JPRB, 0.88024407E-10_JPRB, &
  & 0.88044107E-10_JPRB, 0.88047437E-10_JPRB, 0.88034441E-10_JPRB, 0.88005922E-10_JPRB, 0.87964511E-10_JPRB, 0.87914509E-10_JPRB, &
  & 0.87859685E-10_JPRB, 0.87803730E-10_JPRB, 0.87748732E-10_JPRB, 0.87697703E-10_JPRB, 0.87653614E-10_JPRB, 0.87621570E-10_JPRB, &
  & 0.87607234E-10_JPRB, 0.87614346E-10_JPRB, 0.87640867E-10_JPRB, 0.87678767E-10_JPRB, 0.87718485E-10_JPRB, 0.87750293E-10_JPRB, &
  & 0.87769778E-10_JPRB, 0.87777653E-10_JPRB, 0.87778972E-10_JPRB, 0.87777341E-10_JPRB, 0.87774704E-10_JPRB, 0.87771672E-10_JPRB, &
  & 0.87768501E-10_JPRB, 0.87764962E-10_JPRB, 0.87761153E-10_JPRB, 0.87756746E-10_JPRB, 0.87752194E-10_JPRB, 0.87747878E-10_JPRB, &
  & 0.87743882E-10_JPRB, 0.87740065E-10_JPRB, 0.87735749E-10_JPRB, 0.87728116E-10_JPRB /)

RGHG9(:,63,12) = (/ &
  & 0.87579180E-10_JPRB, 0.87589450E-10_JPRB, 0.87590338E-10_JPRB, 0.87587451E-10_JPRB, 0.87580998E-10_JPRB, 0.87570583E-10_JPRB, &
  & 0.87560015E-10_JPRB, 0.87552521E-10_JPRB, 0.87548593E-10_JPRB, 0.87547747E-10_JPRB, 0.87548815E-10_JPRB, 0.87550606E-10_JPRB, &
  & 0.87551827E-10_JPRB, 0.87550404E-10_JPRB, 0.87542883E-10_JPRB, 0.87524037E-10_JPRB, 0.87490369E-10_JPRB, 0.87449020E-10_JPRB, &
  & 0.87417261E-10_JPRB, 0.87409691E-10_JPRB, 0.87430965E-10_JPRB, 0.87479225E-10_JPRB, 0.87549593E-10_JPRB, 0.87635399E-10_JPRB, &
  & 0.87728623E-10_JPRB, 0.87820452E-10_JPRB, 0.87902463E-10_JPRB, 0.87969534E-10_JPRB, 0.88019626E-10_JPRB, 0.88053162E-10_JPRB, &
  & 0.88070912E-10_JPRB, 0.88073430E-10_JPRB, 0.88060649E-10_JPRB, 0.88033282E-10_JPRB, 0.87993654E-10_JPRB, 0.87945574E-10_JPRB, &
  & 0.87892707E-10_JPRB, 0.87838362E-10_JPRB, 0.87785341E-10_JPRB, 0.87736388E-10_JPRB, 0.87695073E-10_JPRB, 0.87666055E-10_JPRB, &
  & 0.87654516E-10_JPRB, 0.87663314E-10_JPRB, 0.87690029E-10_JPRB, 0.87726854E-10_JPRB, 0.87764782E-10_JPRB, 0.87795868E-10_JPRB, &
  & 0.87814575E-10_JPRB, 0.87822014E-10_JPRB, 0.87822291E-10_JPRB, 0.87819536E-10_JPRB, 0.87815810E-10_JPRB, 0.87811952E-10_JPRB, &
  & 0.87807928E-10_JPRB, 0.87803799E-10_JPRB, 0.87799185E-10_JPRB, 0.87794320E-10_JPRB, 0.87789206E-10_JPRB, 0.87784335E-10_JPRB, &
  & 0.87779978E-10_JPRB, 0.87775717E-10_JPRB, 0.87770846E-10_JPRB, 0.87762402E-10_JPRB /)

RGHG9(:,64,12) = (/ &
  & 0.87638855E-10_JPRB, 0.87646765E-10_JPRB, 0.87646931E-10_JPRB, 0.87643857E-10_JPRB, 0.87637342E-10_JPRB, 0.87627780E-10_JPRB, &
  & 0.87617337E-10_JPRB, 0.87609364E-10_JPRB, 0.87605666E-10_JPRB, 0.87605576E-10_JPRB, 0.87608254E-10_JPRB, 0.87612494E-10_JPRB, &
  & 0.87615727E-10_JPRB, 0.87615533E-10_JPRB, 0.87608150E-10_JPRB, 0.87589533E-10_JPRB, 0.87558231E-10_JPRB, 0.87521240E-10_JPRB, &
  & 0.87493124E-10_JPRB, 0.87486768E-10_JPRB, 0.87506835E-10_JPRB, 0.87551917E-10_JPRB, 0.87617386E-10_JPRB, 0.87697169E-10_JPRB, &
  & 0.87783572E-10_JPRB, 0.87868199E-10_JPRB, 0.87943451E-10_JPRB, 0.88004597E-10_JPRB, 0.88050178E-10_JPRB, 0.88080494E-10_JPRB, &
  & 0.88096426E-10_JPRB, 0.88098286E-10_JPRB, 0.88085969E-10_JPRB, 0.88060059E-10_JPRB, 0.88022527E-10_JPRB, 0.87976702E-10_JPRB, &
  & 0.87925944E-10_JPRB, 0.87873563E-10_JPRB, 0.87822437E-10_JPRB, 0.87775676E-10_JPRB, 0.87736859E-10_JPRB, 0.87710512E-10_JPRB, &
  & 0.87701332E-10_JPRB, 0.87711366E-10_JPRB, 0.87737824E-10_JPRB, 0.87773379E-10_JPRB, 0.87809537E-10_JPRB, 0.87839111E-10_JPRB, &
  & 0.87857603E-10_JPRB, 0.87864702E-10_JPRB, 0.87864237E-10_JPRB, 0.87860337E-10_JPRB, 0.87855515E-10_JPRB, 0.87850505E-10_JPRB, &
  & 0.87845578E-10_JPRB, 0.87840374E-10_JPRB, 0.87835045E-10_JPRB, 0.87829230E-10_JPRB, 0.87823415E-10_JPRB, 0.87817947E-10_JPRB, &
  & 0.87812882E-10_JPRB, 0.87807983E-10_JPRB, 0.87802328E-10_JPRB, 0.87792371E-10_JPRB /)

RGHG9(:,65,12) = (/ &
  & 0.87694262E-10_JPRB, 0.87700618E-10_JPRB, 0.87700402E-10_JPRB, 0.87697398E-10_JPRB, 0.87691583E-10_JPRB, 0.87682750E-10_JPRB, &
  & 0.87672709E-10_JPRB, 0.87664855E-10_JPRB, 0.87661281E-10_JPRB, 0.87662114E-10_JPRB, 0.87666652E-10_JPRB, 0.87672772E-10_JPRB, &
  & 0.87677809E-10_JPRB, 0.87678503E-10_JPRB, 0.87671446E-10_JPRB, 0.87653787E-10_JPRB, 0.87625233E-10_JPRB, 0.87592308E-10_JPRB, &
  & 0.87567703E-10_JPRB, 0.87562693E-10_JPRB, 0.87581754E-10_JPRB, 0.87623700E-10_JPRB, 0.87684277E-10_JPRB, 0.87757787E-10_JPRB, &
  & 0.87837043E-10_JPRB, 0.87914287E-10_JPRB, 0.87982503E-10_JPRB, 0.88037751E-10_JPRB, 0.88078725E-10_JPRB, 0.88105925E-10_JPRB, &
  & 0.88120032E-10_JPRB, 0.88121350E-10_JPRB, 0.88109735E-10_JPRB, 0.88085518E-10_JPRB, 0.88050373E-10_JPRB, 0.88007247E-10_JPRB, &
  & 0.87958946E-10_JPRB, 0.87908840E-10_JPRB, 0.87859900E-10_JPRB, 0.87815324E-10_JPRB, 0.87778868E-10_JPRB, 0.87754928E-10_JPRB, &
  & 0.87747608E-10_JPRB, 0.87758391E-10_JPRB, 0.87784398E-10_JPRB, 0.87818378E-10_JPRB, 0.87852642E-10_JPRB, 0.87880668E-10_JPRB, &
  & 0.87898501E-10_JPRB, 0.87905613E-10_JPRB, 0.87904760E-10_JPRB, 0.87899958E-10_JPRB, 0.87893873E-10_JPRB, 0.87887746E-10_JPRB, &
  & 0.87881556E-10_JPRB, 0.87875457E-10_JPRB, 0.87868934E-10_JPRB, 0.87862335E-10_JPRB, 0.87855598E-10_JPRB, 0.87849214E-10_JPRB, &
  & 0.87843358E-10_JPRB, 0.87837460E-10_JPRB, 0.87830521E-10_JPRB, 0.87818169E-10_JPRB /)

RGHG9(:,66,12) = (/ &
  & 0.87742626E-10_JPRB, 0.87750335E-10_JPRB, 0.87750890E-10_JPRB, 0.87748586E-10_JPRB, 0.87743569E-10_JPRB, 0.87735680E-10_JPRB, &
  & 0.87726486E-10_JPRB, 0.87718999E-10_JPRB, 0.87716119E-10_JPRB, 0.87718124E-10_JPRB, 0.87724050E-10_JPRB, 0.87731725E-10_JPRB, &
  & 0.87737775E-10_JPRB, 0.87739177E-10_JPRB, 0.87732738E-10_JPRB, 0.87716619E-10_JPRB, 0.87690834E-10_JPRB, 0.87661690E-10_JPRB, &
  & 0.87640388E-10_JPRB, 0.87636821E-10_JPRB, 0.87654960E-10_JPRB, 0.87693783E-10_JPRB, 0.87749336E-10_JPRB, 0.87816227E-10_JPRB, &
  & 0.87888211E-10_JPRB, 0.87957752E-10_JPRB, 0.88019085E-10_JPRB, 0.88068379E-10_JPRB, 0.88104884E-10_JPRB, 0.88128997E-10_JPRB, &
  & 0.88141390E-10_JPRB, 0.88142244E-10_JPRB, 0.88131377E-10_JPRB, 0.88109062E-10_JPRB, 0.88076643E-10_JPRB, 0.88036467E-10_JPRB, &
  & 0.87991191E-10_JPRB, 0.87943687E-10_JPRB, 0.87897314E-10_JPRB, 0.87855126E-10_JPRB, 0.87821070E-10_JPRB, 0.87799212E-10_JPRB, &
  & 0.87793377E-10_JPRB, 0.87804555E-10_JPRB, 0.87829612E-10_JPRB, 0.87861926E-10_JPRB, 0.87894150E-10_JPRB, 0.87920497E-10_JPRB, &
  & 0.87937456E-10_JPRB, 0.87944471E-10_JPRB, 0.87943604E-10_JPRB, 0.87938240E-10_JPRB, 0.87931287E-10_JPRB, 0.87923890E-10_JPRB, &
  & 0.87916681E-10_JPRB, 0.87909229E-10_JPRB, 0.87901873E-10_JPRB, 0.87894081E-10_JPRB, 0.87886441E-10_JPRB, 0.87879190E-10_JPRB, &
  & 0.87872196E-10_JPRB, 0.87865062E-10_JPRB, 0.87856257E-10_JPRB, 0.87840124E-10_JPRB /)

RGHG9(:,67,12) = (/ &
  & 0.87790636E-10_JPRB, 0.87798623E-10_JPRB, 0.87799615E-10_JPRB, 0.87797922E-10_JPRB, 0.87793751E-10_JPRB, 0.87786986E-10_JPRB, &
  & 0.87778687E-10_JPRB, 0.87772192E-10_JPRB, 0.87770333E-10_JPRB, 0.87773531E-10_JPRB, 0.87780616E-10_JPRB, 0.87789109E-10_JPRB, &
  & 0.87795785E-10_JPRB, 0.87797727E-10_JPRB, 0.87792093E-10_JPRB, 0.87777681E-10_JPRB, 0.87754651E-10_JPRB, 0.87729157E-10_JPRB, &
  & 0.87710846E-10_JPRB, 0.87708465E-10_JPRB, 0.87725542E-10_JPRB, 0.87761069E-10_JPRB, 0.87811383E-10_JPRB, 0.87871689E-10_JPRB, &
  & 0.87936144E-10_JPRB, 0.87998317E-10_JPRB, 0.88052690E-10_JPRB, 0.88096377E-10_JPRB, 0.88128539E-10_JPRB, 0.88149703E-10_JPRB, &
  & 0.88160472E-10_JPRB, 0.88160951E-10_JPRB, 0.88150903E-10_JPRB, 0.88130551E-10_JPRB, 0.88100936E-10_JPRB, 0.88064112E-10_JPRB, &
  & 0.88022041E-10_JPRB, 0.87977715E-10_JPRB, 0.87934132E-10_JPRB, 0.87894747E-10_JPRB, 0.87863106E-10_JPRB, 0.87843330E-10_JPRB, &
  & 0.87838604E-10_JPRB, 0.87849755E-10_JPRB, 0.87873632E-10_JPRB, 0.87904004E-10_JPRB, 0.87934139E-10_JPRB, 0.87958696E-10_JPRB, &
  & 0.87974586E-10_JPRB, 0.87981296E-10_JPRB, 0.87980505E-10_JPRB, 0.87975079E-10_JPRB, 0.87967425E-10_JPRB, 0.87959313E-10_JPRB, &
  & 0.87950869E-10_JPRB, 0.87942625E-10_JPRB, 0.87934007E-10_JPRB, 0.87925528E-10_JPRB, 0.87916993E-10_JPRB, 0.87908653E-10_JPRB, &
  & 0.87900687E-10_JPRB, 0.87891874E-10_JPRB, 0.87880606E-10_JPRB, 0.87858852E-10_JPRB /)

RGHG9(:,68,12) = (/ &
  & 0.87835059E-10_JPRB, 0.87844530E-10_JPRB, 0.87846452E-10_JPRB, 0.87845564E-10_JPRB, 0.87842303E-10_JPRB, 0.87836613E-10_JPRB, &
  & 0.87829764E-10_JPRB, 0.87824470E-10_JPRB, 0.87823887E-10_JPRB, 0.87828238E-10_JPRB, 0.87836051E-10_JPRB, 0.87844933E-10_JPRB, &
  & 0.87851823E-10_JPRB, 0.87854092E-10_JPRB, 0.87849172E-10_JPRB, 0.87836537E-10_JPRB, 0.87816129E-10_JPRB, 0.87793849E-10_JPRB, &
  & 0.87778181E-10_JPRB, 0.87776682E-10_JPRB, 0.87792482E-10_JPRB, 0.87824595E-10_JPRB, 0.87869691E-10_JPRB, 0.87923363E-10_JPRB, &
  & 0.87980692E-10_JPRB, 0.88035523E-10_JPRB, 0.88083513E-10_JPRB, 0.88121795E-10_JPRB, 0.88149918E-10_JPRB, 0.88168334E-10_JPRB, &
  & 0.88177597E-10_JPRB, 0.88177743E-10_JPRB, 0.88168542E-10_JPRB, 0.88150147E-10_JPRB, 0.88123411E-10_JPRB, 0.88089896E-10_JPRB, &
  & 0.88051441E-10_JPRB, 0.88010377E-10_JPRB, 0.87970145E-10_JPRB, 0.87933667E-10_JPRB, 0.87904732E-10_JPRB, 0.87886892E-10_JPRB, &
  & 0.87883215E-10_JPRB, 0.87894088E-10_JPRB, 0.87916480E-10_JPRB, 0.87944707E-10_JPRB, 0.87972615E-10_JPRB, 0.87995299E-10_JPRB, &
  & 0.88009995E-10_JPRB, 0.88016219E-10_JPRB, 0.88015456E-10_JPRB, 0.88010065E-10_JPRB, 0.88002369E-10_JPRB, 0.87993599E-10_JPRB, &
  & 0.87984675E-10_JPRB, 0.87975419E-10_JPRB, 0.87966315E-10_JPRB, 0.87956975E-10_JPRB, 0.87947788E-10_JPRB, 0.87938948E-10_JPRB, &
  & 0.87929775E-10_JPRB, 0.87919678E-10_JPRB, 0.87905502E-10_JPRB, 0.87877365E-10_JPRB /)

RGHG9(:,69,12) = (/ &
  & 0.87877990E-10_JPRB, 0.87889182E-10_JPRB, 0.87891999E-10_JPRB, 0.87891944E-10_JPRB, 0.87889633E-10_JPRB, 0.87885234E-10_JPRB, &
  & 0.87879787E-10_JPRB, 0.87876109E-10_JPRB, 0.87876914E-10_JPRB, 0.87882118E-10_JPRB, 0.87890348E-10_JPRB, 0.87899139E-10_JPRB, &
  & 0.87905905E-10_JPRB, 0.87908313E-10_JPRB, 0.87903906E-10_JPRB, 0.87892936E-10_JPRB, 0.87874895E-10_JPRB, 0.87855487E-10_JPRB, &
  & 0.87841984E-10_JPRB, 0.87840950E-10_JPRB, 0.87855209E-10_JPRB, 0.87883867E-10_JPRB, 0.87923863E-10_JPRB, 0.87971297E-10_JPRB, &
  & 0.88021708E-10_JPRB, 0.88069808E-10_JPRB, 0.88111629E-10_JPRB, 0.88144991E-10_JPRB, 0.88169354E-10_JPRB, 0.88185237E-10_JPRB, &
  & 0.88193099E-10_JPRB, 0.88192953E-10_JPRB, 0.88184585E-10_JPRB, 0.88168126E-10_JPRB, 0.88144179E-10_JPRB, 0.88114134E-10_JPRB, &
  & 0.88079148E-10_JPRB, 0.88041796E-10_JPRB, 0.88004951E-10_JPRB, 0.87971769E-10_JPRB, 0.87945588E-10_JPRB, 0.87929788E-10_JPRB, &
  & 0.87926978E-10_JPRB, 0.87937505E-10_JPRB, 0.87958273E-10_JPRB, 0.87984231E-10_JPRB, 0.88009766E-10_JPRB, 0.88030513E-10_JPRB, &
  & 0.88043905E-10_JPRB, 0.88049568E-10_JPRB, 0.88048749E-10_JPRB, 0.88043559E-10_JPRB, 0.88035905E-10_JPRB, 0.88027155E-10_JPRB, &
  & 0.88017864E-10_JPRB, 0.88008378E-10_JPRB, 0.87998692E-10_JPRB, 0.87989130E-10_JPRB, 0.87979728E-10_JPRB, 0.87970270E-10_JPRB, &
  & 0.87960791E-10_JPRB, 0.87949252E-10_JPRB, 0.87932502E-10_JPRB, 0.87897106E-10_JPRB /)

RGHG9(:,70,12) = (/ &
  & 0.87918908E-10_JPRB, 0.87932453E-10_JPRB, 0.87936519E-10_JPRB, 0.87937428E-10_JPRB, 0.87936144E-10_JPRB, 0.87932966E-10_JPRB, &
  & 0.87929199E-10_JPRB, 0.87927166E-10_JPRB, 0.87929233E-10_JPRB, 0.87935173E-10_JPRB, 0.87943208E-10_JPRB, 0.87951590E-10_JPRB, &
  & 0.87957842E-10_JPRB, 0.87960111E-10_JPRB, 0.87956052E-10_JPRB, 0.87946497E-10_JPRB, 0.87930586E-10_JPRB, 0.87913551E-10_JPRB, &
  & 0.87901797E-10_JPRB, 0.87900985E-10_JPRB, 0.87913600E-10_JPRB, 0.87938851E-10_JPRB, 0.87974031E-10_JPRB, 0.88015470E-10_JPRB, &
  & 0.88059476E-10_JPRB, 0.88101172E-10_JPRB, 0.88137400E-10_JPRB, 0.88166127E-10_JPRB, 0.88187076E-10_JPRB, 0.88200620E-10_JPRB, &
  & 0.88207219E-10_JPRB, 0.88206845E-10_JPRB, 0.88199330E-10_JPRB, 0.88184779E-10_JPRB, 0.88163594E-10_JPRB, 0.88136838E-10_JPRB, &
  & 0.88105509E-10_JPRB, 0.88071800E-10_JPRB, 0.88038618E-10_JPRB, 0.88008774E-10_JPRB, 0.87985431E-10_JPRB, 0.87971692E-10_JPRB, &
  & 0.87969840E-10_JPRB, 0.87979880E-10_JPRB, 0.87999059E-10_JPRB, 0.88022582E-10_JPRB, 0.88045668E-10_JPRB, 0.88064354E-10_JPRB, &
  & 0.88076380E-10_JPRB, 0.88081424E-10_JPRB, 0.88080543E-10_JPRB, 0.88075595E-10_JPRB, 0.88068310E-10_JPRB, 0.88059816E-10_JPRB, &
  & 0.88050782E-10_JPRB, 0.88041338E-10_JPRB, 0.88031783E-10_JPRB, 0.88022187E-10_JPRB, 0.88012819E-10_JPRB, 0.88003535E-10_JPRB, &
  & 0.87993626E-10_JPRB, 0.87981657E-10_JPRB, 0.87962707E-10_JPRB, 0.87921309E-10_JPRB /)

RGHG9(:,71,12) = (/ &
  & 0.87958460E-10_JPRB, 0.87974961E-10_JPRB, 0.87980311E-10_JPRB, 0.87982233E-10_JPRB, 0.87981969E-10_JPRB, 0.87980054E-10_JPRB, &
  & 0.87977861E-10_JPRB, 0.87977473E-10_JPRB, 0.87980651E-10_JPRB, 0.87986653E-10_JPRB, 0.87994417E-10_JPRB, 0.88001689E-10_JPRB, &
  & 0.88007227E-10_JPRB, 0.88009218E-10_JPRB, 0.88005381E-10_JPRB, 0.87996894E-10_JPRB, 0.87982920E-10_JPRB, 0.87967959E-10_JPRB, &
  & 0.87957669E-10_JPRB, 0.87956864E-10_JPRB, 0.87967800E-10_JPRB, 0.87989817E-10_JPRB, 0.88020306E-10_JPRB, 0.88056257E-10_JPRB, &
  & 0.88094101E-10_JPRB, 0.88129962E-10_JPRB, 0.88160944E-10_JPRB, 0.88185487E-10_JPRB, 0.88203257E-10_JPRB, 0.88214665E-10_JPRB, &
  & 0.88220140E-10_JPRB, 0.88219619E-10_JPRB, 0.88212972E-10_JPRB, 0.88200246E-10_JPRB, 0.88181691E-10_JPRB, 0.88158272E-10_JPRB, &
  & 0.88130517E-10_JPRB, 0.88100555E-10_JPRB, 0.88071057E-10_JPRB, 0.88044599E-10_JPRB, 0.88024185E-10_JPRB, 0.88012431E-10_JPRB, &
  & 0.88011459E-10_JPRB, 0.88021139E-10_JPRB, 0.88038514E-10_JPRB, 0.88059657E-10_JPRB, 0.88080182E-10_JPRB, 0.88096780E-10_JPRB, &
  & 0.88107355E-10_JPRB, 0.88111803E-10_JPRB, 0.88110852E-10_JPRB, 0.88106279E-10_JPRB, 0.88099521E-10_JPRB, 0.88091770E-10_JPRB, &
  & 0.88083311E-10_JPRB, 0.88074520E-10_JPRB, 0.88065305E-10_JPRB, 0.88056160E-10_JPRB, 0.88047195E-10_JPRB, 0.88038181E-10_JPRB, &
  & 0.88028543E-10_JPRB, 0.88016434E-10_JPRB, 0.87996596E-10_JPRB, 0.87951604E-10_JPRB /)

RGHG9(:,72,12) = (/ &
  & 0.87997096E-10_JPRB, 0.88016816E-10_JPRB, 0.88023616E-10_JPRB, 0.88026413E-10_JPRB, 0.88027072E-10_JPRB, 0.88026225E-10_JPRB, &
  & 0.88025504E-10_JPRB, 0.88026440E-10_JPRB, 0.88030222E-10_JPRB, 0.88036300E-10_JPRB, 0.88042698E-10_JPRB, 0.88049228E-10_JPRB, &
  & 0.88053620E-10_JPRB, 0.88055133E-10_JPRB, 0.88051635E-10_JPRB, 0.88043961E-10_JPRB, 0.88031818E-10_JPRB, 0.88018662E-10_JPRB, &
  & 0.88009697E-10_JPRB, 0.88008857E-10_JPRB, 0.88018183E-10_JPRB, 0.88036946E-10_JPRB, 0.88063168E-10_JPRB, 0.88093720E-10_JPRB, &
  & 0.88125958E-10_JPRB, 0.88156267E-10_JPRB, 0.88182524E-10_JPRB, 0.88203153E-10_JPRB, 0.88218065E-10_JPRB, 0.88227543E-10_JPRB, &
  & 0.88232040E-10_JPRB, 0.88231408E-10_JPRB, 0.88225593E-10_JPRB, 0.88214672E-10_JPRB, 0.88198650E-10_JPRB, 0.88178492E-10_JPRB, &
  & 0.88154282E-10_JPRB, 0.88128088E-10_JPRB, 0.88102269E-10_JPRB, 0.88079301E-10_JPRB, 0.88061655E-10_JPRB, 0.88051962E-10_JPRB, &
  & 0.88051774E-10_JPRB, 0.88060829E-10_JPRB, 0.88076532E-10_JPRB, 0.88095149E-10_JPRB, 0.88113065E-10_JPRB, 0.88127498E-10_JPRB, &
  & 0.88136720E-10_JPRB, 0.88140537E-10_JPRB, 0.88139621E-10_JPRB, 0.88135568E-10_JPRB, 0.88129684E-10_JPRB, 0.88122662E-10_JPRB, &
  & 0.88115348E-10_JPRB, 0.88107216E-10_JPRB, 0.88099035E-10_JPRB, 0.88090334E-10_JPRB, 0.88082236E-10_JPRB, 0.88073687E-10_JPRB, &
  & 0.88064583E-10_JPRB, 0.88053051E-10_JPRB, 0.88033081E-10_JPRB, 0.87986458E-10_JPRB /)

RGHG9(:,73,12) = (/ &
  & 0.88038785E-10_JPRB, 0.88059365E-10_JPRB, 0.88066457E-10_JPRB, 0.88069670E-10_JPRB, 0.88070898E-10_JPRB, 0.88070919E-10_JPRB, &
  & 0.88071245E-10_JPRB, 0.88073063E-10_JPRB, 0.88077164E-10_JPRB, 0.88082278E-10_JPRB, 0.88088321E-10_JPRB, 0.88093102E-10_JPRB, &
  & 0.88096794E-10_JPRB, 0.88097744E-10_JPRB, 0.88094532E-10_JPRB, 0.88087600E-10_JPRB, 0.88077073E-10_JPRB, 0.88065701E-10_JPRB, &
  & 0.88058005E-10_JPRB, 0.88057117E-10_JPRB, 0.88064799E-10_JPRB, 0.88080612E-10_JPRB, 0.88102539E-10_JPRB, 0.88128289E-10_JPRB, &
  & 0.88155122E-10_JPRB, 0.88180428E-10_JPRB, 0.88202230E-10_JPRB, 0.88219335E-10_JPRB, 0.88231616E-10_JPRB, 0.88239319E-10_JPRB, &
  & 0.88242962E-10_JPRB, 0.88242295E-10_JPRB, 0.88237327E-10_JPRB, 0.88228126E-10_JPRB, 0.88214526E-10_JPRB, 0.88197574E-10_JPRB, &
  & 0.88176792E-10_JPRB, 0.88154387E-10_JPRB, 0.88132251E-10_JPRB, 0.88112684E-10_JPRB, 0.88097862E-10_JPRB, 0.88089980E-10_JPRB, &
  & 0.88090417E-10_JPRB, 0.88098813E-10_JPRB, 0.88112573E-10_JPRB, 0.88128588E-10_JPRB, 0.88143999E-10_JPRB, 0.88156371E-10_JPRB, &
  & 0.88164108E-10_JPRB, 0.88167529E-10_JPRB, 0.88166759E-10_JPRB, 0.88163324E-10_JPRB, 0.88158224E-10_JPRB, 0.88152485E-10_JPRB, &
  & 0.88145914E-10_JPRB, 0.88139190E-10_JPRB, 0.88131571E-10_JPRB, 0.88124112E-10_JPRB, 0.88116570E-10_JPRB, 0.88109020E-10_JPRB, &
  & 0.88100638E-10_JPRB, 0.88089980E-10_JPRB, 0.88070794E-10_JPRB, 0.88024241E-10_JPRB /)

RGHG9(:,74,12) = (/ &
  & 0.88079675E-10_JPRB, 0.88100797E-10_JPRB, 0.88107924E-10_JPRB, 0.88111220E-10_JPRB, 0.88112788E-10_JPRB, 0.88113260E-10_JPRB, &
  & 0.88114217E-10_JPRB, 0.88116396E-10_JPRB, 0.88120150E-10_JPRB, 0.88125125E-10_JPRB, 0.88129427E-10_JPRB, 0.88133834E-10_JPRB, &
  & 0.88136359E-10_JPRB, 0.88136887E-10_JPRB, 0.88133952E-10_JPRB, 0.88127790E-10_JPRB, 0.88118818E-10_JPRB, 0.88109096E-10_JPRB, &
  & 0.88102685E-10_JPRB, 0.88101811E-10_JPRB, 0.88107965E-10_JPRB, 0.88120865E-10_JPRB, 0.88138941E-10_JPRB, 0.88160000E-10_JPRB, &
  & 0.88181955E-10_JPRB, 0.88202487E-10_JPRB, 0.88220271E-10_JPRB, 0.88234128E-10_JPRB, 0.88244044E-10_JPRB, 0.88250164E-10_JPRB, &
  & 0.88253072E-10_JPRB, 0.88252405E-10_JPRB, 0.88248263E-10_JPRB, 0.88240651E-10_JPRB, 0.88229493E-10_JPRB, 0.88215532E-10_JPRB, &
  & 0.88198129E-10_JPRB, 0.88179505E-10_JPRB, 0.88160937E-10_JPRB, 0.88144769E-10_JPRB, 0.88132522E-10_JPRB, 0.88126381E-10_JPRB, &
  & 0.88127186E-10_JPRB, 0.88134638E-10_JPRB, 0.88146358E-10_JPRB, 0.88159938E-10_JPRB, 0.88172726E-10_JPRB, 0.88183086E-10_JPRB, &
  & 0.88189664E-10_JPRB, 0.88192564E-10_JPRB, 0.88192023E-10_JPRB, 0.88189255E-10_JPRB, 0.88185195E-10_JPRB, 0.88180171E-10_JPRB, &
  & 0.88174988E-10_JPRB, 0.88168937E-10_JPRB, 0.88162783E-10_JPRB, 0.88155892E-10_JPRB, 0.88149772E-10_JPRB, 0.88142896E-10_JPRB, &
  & 0.88135554E-10_JPRB, 0.88126319E-10_JPRB, 0.88108278E-10_JPRB, 0.88063550E-10_JPRB /)

RGHG9(:,75,12) = (/ &
  & 0.88119304E-10_JPRB, 0.88140384E-10_JPRB, 0.88147337E-10_JPRB, 0.88150431E-10_JPRB, 0.88152138E-10_JPRB, 0.88152756E-10_JPRB, &
  & 0.88153922E-10_JPRB, 0.88156003E-10_JPRB, 0.88159618E-10_JPRB, 0.88163345E-10_JPRB, 0.88167453E-10_JPRB, 0.88170374E-10_JPRB, &
  & 0.88172546E-10_JPRB, 0.88172747E-10_JPRB, 0.88169985E-10_JPRB, 0.88164649E-10_JPRB, 0.88157183E-10_JPRB, 0.88149162E-10_JPRB, &
  & 0.88143978E-10_JPRB, 0.88143125E-10_JPRB, 0.88147906E-10_JPRB, 0.88158113E-10_JPRB, 0.88172483E-10_JPRB, 0.88189275E-10_JPRB, &
  & 0.88206602E-10_JPRB, 0.88222811E-10_JPRB, 0.88236841E-10_JPRB, 0.88247736E-10_JPRB, 0.88255514E-10_JPRB, 0.88260184E-10_JPRB, &
  & 0.88262467E-10_JPRB, 0.88261835E-10_JPRB, 0.88258505E-10_JPRB, 0.88252350E-10_JPRB, 0.88243607E-10_JPRB, 0.88232380E-10_JPRB, &
  & 0.88218433E-10_JPRB, 0.88203382E-10_JPRB, 0.88188346E-10_JPRB, 0.88175453E-10_JPRB, 0.88165725E-10_JPRB, 0.88161006E-10_JPRB, &
  & 0.88161950E-10_JPRB, 0.88168320E-10_JPRB, 0.88178076E-10_JPRB, 0.88188887E-10_JPRB, 0.88199399E-10_JPRB, 0.88207788E-10_JPRB, &
  & 0.88213034E-10_JPRB, 0.88215622E-10_JPRB, 0.88215338E-10_JPRB, 0.88213291E-10_JPRB, 0.88209953E-10_JPRB, 0.88206040E-10_JPRB, &
  & 0.88201564E-10_JPRB, 0.88196846E-10_JPRB, 0.88191440E-10_JPRB, 0.88185931E-10_JPRB, 0.88180727E-10_JPRB, 0.88175058E-10_JPRB, &
  & 0.88168861E-10_JPRB, 0.88161062E-10_JPRB, 0.88145144E-10_JPRB, 0.88103275E-10_JPRB /)

RGHG9(:,76,12) = (/ &
  & 0.88157197E-10_JPRB, 0.88178007E-10_JPRB, 0.88184279E-10_JPRB, 0.88187027E-10_JPRB, 0.88188713E-10_JPRB, 0.88189213E-10_JPRB, &
  & 0.88190330E-10_JPRB, 0.88192120E-10_JPRB, 0.88194937E-10_JPRB, 0.88198358E-10_JPRB, 0.88200912E-10_JPRB, 0.88203576E-10_JPRB, &
  & 0.88204964E-10_JPRB, 0.88205068E-10_JPRB, 0.88202709E-10_JPRB, 0.88198338E-10_JPRB, 0.88192488E-10_JPRB, 0.88186070E-10_JPRB, &
  & 0.88182149E-10_JPRB, 0.88181358E-10_JPRB, 0.88184821E-10_JPRB, 0.88192606E-10_JPRB, 0.88203542E-10_JPRB, 0.88216316E-10_JPRB, &
  & 0.88229327E-10_JPRB, 0.88241463E-10_JPRB, 0.88252107E-10_JPRB, 0.88260281E-10_JPRB, 0.88266131E-10_JPRB, 0.88269489E-10_JPRB, &
  & 0.88271286E-10_JPRB, 0.88270689E-10_JPRB, 0.88268129E-10_JPRB, 0.88263348E-10_JPRB, 0.88256916E-10_JPRB, 0.88248228E-10_JPRB, &
  & 0.88237764E-10_JPRB, 0.88226072E-10_JPRB, 0.88214387E-10_JPRB, 0.88204763E-10_JPRB, 0.88197269E-10_JPRB, 0.88193806E-10_JPRB, &
  & 0.88194702E-10_JPRB, 0.88199933E-10_JPRB, 0.88207511E-10_JPRB, 0.88215955E-10_JPRB, 0.88223914E-10_JPRB, 0.88230430E-10_JPRB, &
  & 0.88234441E-10_JPRB, 0.88236585E-10_JPRB, 0.88236536E-10_JPRB, 0.88235141E-10_JPRB, 0.88232727E-10_JPRB, 0.88229493E-10_JPRB, &
  & 0.88226107E-10_JPRB, 0.88222277E-10_JPRB, 0.88218141E-10_JPRB, 0.88213555E-10_JPRB, 0.88209856E-10_JPRB, 0.88205214E-10_JPRB, &
  & 0.88200135E-10_JPRB, 0.88194382E-10_JPRB, 0.88180574E-10_JPRB, 0.88142979E-10_JPRB /)

RGHG9(:,77,12) = (/ &
  & 0.88193522E-10_JPRB, 0.88212909E-10_JPRB, 0.88218370E-10_JPRB, 0.88220597E-10_JPRB, 0.88222214E-10_JPRB, 0.88222409E-10_JPRB, &
  & 0.88223338E-10_JPRB, 0.88224553E-10_JPRB, 0.88226822E-10_JPRB, 0.88228966E-10_JPRB, 0.88230832E-10_JPRB, 0.88232407E-10_JPRB, &
  & 0.88233545E-10_JPRB, 0.88233712E-10_JPRB, 0.88231873E-10_JPRB, 0.88228681E-10_JPRB, 0.88224567E-10_JPRB, 0.88219820E-10_JPRB, &
  & 0.88217163E-10_JPRB, 0.88216462E-10_JPRB, 0.88218780E-10_JPRB, 0.88224275E-10_JPRB, 0.88232116E-10_JPRB, 0.88241081E-10_JPRB, &
  & 0.88250171E-10_JPRB, 0.88258588E-10_JPRB, 0.88266158E-10_JPRB, 0.88271904E-10_JPRB, 0.88276018E-10_JPRB, 0.88278197E-10_JPRB, &
  & 0.88279564E-10_JPRB, 0.88279009E-10_JPRB, 0.88277205E-10_JPRB, 0.88273638E-10_JPRB, 0.88269371E-10_JPRB, 0.88262980E-10_JPRB, &
  & 0.88255930E-10_JPRB, 0.88247396E-10_JPRB, 0.88238937E-10_JPRB, 0.88232303E-10_JPRB, 0.88226919E-10_JPRB, 0.88224476E-10_JPRB, &
  & 0.88225149E-10_JPRB, 0.88229229E-10_JPRB, 0.88234788E-10_JPRB, 0.88240616E-10_JPRB, 0.88246320E-10_JPRB, 0.88250948E-10_JPRB, &
  & 0.88253654E-10_JPRB, 0.88255389E-10_JPRB, 0.88255493E-10_JPRB, 0.88254730E-10_JPRB, 0.88253058E-10_JPRB, 0.88250678E-10_JPRB, &
  & 0.88248173E-10_JPRB, 0.88245411E-10_JPRB, 0.88242344E-10_JPRB, 0.88238909E-10_JPRB, 0.88236626E-10_JPRB, 0.88233032E-10_JPRB, &
  & 0.88229271E-10_JPRB, 0.88225358E-10_JPRB, 0.88214450E-10_JPRB, 0.88182135E-10_JPRB /)

RGHG9(:,78,12) = (/ &
  & 0.88227724E-10_JPRB, 0.88243822E-10_JPRB, 0.88247423E-10_JPRB, 0.88249012E-10_JPRB, 0.88250587E-10_JPRB, 0.88250407E-10_JPRB, &
  & 0.88251184E-10_JPRB, 0.88251823E-10_JPRB, 0.88253224E-10_JPRB, 0.88254473E-10_JPRB, 0.88255042E-10_JPRB, 0.88256118E-10_JPRB, &
  & 0.88256819E-10_JPRB, 0.88257276E-10_JPRB, 0.88256090E-10_JPRB, 0.88254168E-10_JPRB, 0.88251795E-10_JPRB, 0.88248596E-10_JPRB, &
  & 0.88247201E-10_JPRB, 0.88246702E-10_JPRB, 0.88248076E-10_JPRB, 0.88251656E-10_JPRB, 0.88256832E-10_JPRB, 0.88262446E-10_JPRB, &
  & 0.88268164E-10_JPRB, 0.88273416E-10_JPRB, 0.88278398E-10_JPRB, 0.88282118E-10_JPRB, 0.88284768E-10_JPRB, 0.88285927E-10_JPRB, &
  & 0.88286982E-10_JPRB, 0.88286448E-10_JPRB, 0.88285268E-10_JPRB, 0.88282735E-10_JPRB, 0.88280334E-10_JPRB, 0.88276012E-10_JPRB, &
  & 0.88271952E-10_JPRB, 0.88266248E-10_JPRB, 0.88260572E-10_JPRB, 0.88256610E-10_JPRB, 0.88252912E-10_JPRB, 0.88251267E-10_JPRB, &
  & 0.88251628E-10_JPRB, 0.88254570E-10_JPRB, 0.88258248E-10_JPRB, 0.88261808E-10_JPRB, 0.88265312E-10_JPRB, 0.88268261E-10_JPRB, &
  & 0.88269766E-10_JPRB, 0.88271071E-10_JPRB, 0.88271258E-10_JPRB, 0.88271009E-10_JPRB, 0.88270058E-10_JPRB, 0.88268282E-10_JPRB, &
  & 0.88266672E-10_JPRB, 0.88264840E-10_JPRB, 0.88262765E-10_JPRB, 0.88260350E-10_JPRB, 0.88259400E-10_JPRB, 0.88256777E-10_JPRB, &
  & 0.88254133E-10_JPRB, 0.88252149E-10_JPRB, 0.88244828E-10_JPRB, 0.88220382E-10_JPRB /)

RGHG9(:,79,12) = (/ &
  & 0.88249671E-10_JPRB, 0.88261086E-10_JPRB, 0.88262848E-10_JPRB, 0.88263681E-10_JPRB, 0.88265298E-10_JPRB, 0.88264854E-10_JPRB, &
  & 0.88265555E-10_JPRB, 0.88265867E-10_JPRB, 0.88266922E-10_JPRB, 0.88267699E-10_JPRB, 0.88267664E-10_JPRB, 0.88268386E-10_JPRB, &
  & 0.88268982E-10_JPRB, 0.88269614E-10_JPRB, 0.88268726E-10_JPRB, 0.88267470E-10_JPRB, 0.88266068E-10_JPRB, 0.88263723E-10_JPRB, &
  & 0.88263154E-10_JPRB, 0.88262800E-10_JPRB, 0.88263674E-10_JPRB, 0.88266276E-10_JPRB, 0.88270086E-10_JPRB, 0.88273958E-10_JPRB, &
  & 0.88277871E-10_JPRB, 0.88281431E-10_JPRB, 0.88285060E-10_JPRB, 0.88287697E-10_JPRB, 0.88289570E-10_JPRB, 0.88290111E-10_JPRB, &
  & 0.88291013E-10_JPRB, 0.88290444E-10_JPRB, 0.88289626E-10_JPRB, 0.88287606E-10_JPRB, 0.88286281E-10_JPRB, 0.88283020E-10_JPRB, &
  & 0.88280647E-10_JPRB, 0.88276393E-10_JPRB, 0.88272174E-10_JPRB, 0.88269669E-10_JPRB, 0.88266811E-10_JPRB, 0.88265541E-10_JPRB, &
  & 0.88265686E-10_JPRB, 0.88268122E-10_JPRB, 0.88270814E-10_JPRB, 0.88273104E-10_JPRB, 0.88275387E-10_JPRB, 0.88277441E-10_JPRB, &
  & 0.88278225E-10_JPRB, 0.88279335E-10_JPRB, 0.88279543E-10_JPRB, 0.88279599E-10_JPRB, 0.88279002E-10_JPRB, 0.88277496E-10_JPRB, &
  & 0.88276338E-10_JPRB, 0.88274936E-10_JPRB, 0.88273375E-10_JPRB, 0.88271383E-10_JPRB, 0.88271203E-10_JPRB, 0.88268962E-10_JPRB, &
  & 0.88266915E-10_JPRB, 0.88266415E-10_JPRB, 0.88261842E-10_JPRB, 0.88244863E-10_JPRB /)

RGHG9(:,80,12) = (/ &
  & 0.88264049E-10_JPRB, 0.88269426E-10_JPRB, 0.88269551E-10_JPRB, 0.88269989E-10_JPRB, 0.88271626E-10_JPRB, 0.88271022E-10_JPRB, &
  & 0.88271737E-10_JPRB, 0.88271876E-10_JPRB, 0.88272910E-10_JPRB, 0.88273527E-10_JPRB, 0.88273222E-10_JPRB, 0.88273854E-10_JPRB, &
  & 0.88274367E-10_JPRB, 0.88275089E-10_JPRB, 0.88274305E-10_JPRB, 0.88273333E-10_JPRB, 0.88272410E-10_JPRB, 0.88270398E-10_JPRB, &
  & 0.88270266E-10_JPRB, 0.88269982E-10_JPRB, 0.88270648E-10_JPRB, 0.88272854E-10_JPRB, 0.88276095E-10_JPRB, 0.88279169E-10_JPRB, &
  & 0.88282250E-10_JPRB, 0.88285053E-10_JPRB, 0.88288106E-10_JPRB, 0.88290257E-10_JPRB, 0.88291791E-10_JPRB, 0.88292040E-10_JPRB, &
  & 0.88292887E-10_JPRB, 0.88292283E-10_JPRB, 0.88291582E-10_JPRB, 0.88289778E-10_JPRB, 0.88288973E-10_JPRB, 0.88286177E-10_JPRB, &
  & 0.88284609E-10_JPRB, 0.88280994E-10_JPRB, 0.88277378E-10_JPRB, 0.88275567E-10_JPRB, 0.88273035E-10_JPRB, 0.88271904E-10_JPRB, &
  & 0.88271973E-10_JPRB, 0.88274200E-10_JPRB, 0.88276483E-10_JPRB, 0.88278149E-10_JPRB, 0.88279897E-10_JPRB, 0.88281500E-10_JPRB, &
  & 0.88281910E-10_JPRB, 0.88282964E-10_JPRB, 0.88283179E-10_JPRB, 0.88283374E-10_JPRB, 0.88282937E-10_JPRB, 0.88281500E-10_JPRB, &
  & 0.88280522E-10_JPRB, 0.88279280E-10_JPRB, 0.88277899E-10_JPRB, 0.88276060E-10_JPRB, 0.88276261E-10_JPRB, 0.88274166E-10_JPRB, &
  & 0.88272376E-10_JPRB, 0.88272660E-10_JPRB, 0.88270086E-10_JPRB, 0.88260968E-10_JPRB /)

RGHG9(:,81,12) = (/ &
  & 0.88273763E-10_JPRB, 0.88272958E-10_JPRB, 0.88272396E-10_JPRB, 0.88272653E-10_JPRB, 0.88274332E-10_JPRB, 0.88273652E-10_JPRB, &
  & 0.88274360E-10_JPRB, 0.88274485E-10_JPRB, 0.88275429E-10_JPRB, 0.88276060E-10_JPRB, 0.88275651E-10_JPRB, 0.88276261E-10_JPRB, &
  & 0.88276740E-10_JPRB, 0.88277510E-10_JPRB, 0.88276754E-10_JPRB, 0.88275873E-10_JPRB, 0.88275158E-10_JPRB, 0.88273291E-10_JPRB, &
  & 0.88273389E-10_JPRB, 0.88273139E-10_JPRB, 0.88273701E-10_JPRB, 0.88275720E-10_JPRB, 0.88278745E-10_JPRB, 0.88281459E-10_JPRB, &
  & 0.88284186E-10_JPRB, 0.88286649E-10_JPRB, 0.88289445E-10_JPRB, 0.88291402E-10_JPRB, 0.88292797E-10_JPRB, 0.88292873E-10_JPRB, &
  & 0.88293733E-10_JPRB, 0.88293088E-10_JPRB, 0.88292443E-10_JPRB, 0.88290694E-10_JPRB, 0.88290160E-10_JPRB, 0.88287544E-10_JPRB, &
  & 0.88286364E-10_JPRB, 0.88283020E-10_JPRB, 0.88279682E-10_JPRB, 0.88278176E-10_JPRB, 0.88275776E-10_JPRB, 0.88274679E-10_JPRB, &
  & 0.88274679E-10_JPRB, 0.88276900E-10_JPRB, 0.88279002E-10_JPRB, 0.88280397E-10_JPRB, 0.88281826E-10_JPRB, 0.88283249E-10_JPRB, &
  & 0.88283499E-10_JPRB, 0.88284512E-10_JPRB, 0.88284748E-10_JPRB, 0.88285025E-10_JPRB, 0.88284664E-10_JPRB, 0.88283235E-10_JPRB, &
  & 0.88282333E-10_JPRB, 0.88281146E-10_JPRB, 0.88279828E-10_JPRB, 0.88278038E-10_JPRB, 0.88278433E-10_JPRB, 0.88276358E-10_JPRB, &
  & 0.88274645E-10_JPRB, 0.88275352E-10_JPRB, 0.88273583E-10_JPRB, 0.88271945E-10_JPRB /)

RGHG9(:,82,12) = (/ &
  & 0.88274534E-10_JPRB, 0.88274131E-10_JPRB, 0.88273618E-10_JPRB, 0.88273909E-10_JPRB, 0.88275637E-10_JPRB, 0.88274915E-10_JPRB, &
  & 0.88275637E-10_JPRB, 0.88275692E-10_JPRB, 0.88276719E-10_JPRB, 0.88277309E-10_JPRB, 0.88276823E-10_JPRB, 0.88277420E-10_JPRB, &
  & 0.88277892E-10_JPRB, 0.88278704E-10_JPRB, 0.88277954E-10_JPRB, 0.88277129E-10_JPRB, 0.88276518E-10_JPRB, 0.88274700E-10_JPRB, &
  & 0.88274922E-10_JPRB, 0.88274679E-10_JPRB, 0.88275158E-10_JPRB, 0.88277156E-10_JPRB, 0.88280022E-10_JPRB, 0.88282576E-10_JPRB, &
  & 0.88285129E-10_JPRB, 0.88287433E-10_JPRB, 0.88290111E-10_JPRB, 0.88291992E-10_JPRB, 0.88293303E-10_JPRB, 0.88293296E-10_JPRB, &
  & 0.88294164E-10_JPRB, 0.88293477E-10_JPRB, 0.88292845E-10_JPRB, 0.88291131E-10_JPRB, 0.88290694E-10_JPRB, 0.88288224E-10_JPRB, &
  & 0.88287183E-10_JPRB, 0.88284012E-10_JPRB, 0.88280834E-10_JPRB, 0.88279425E-10_JPRB, 0.88277149E-10_JPRB, 0.88276046E-10_JPRB, &
  & 0.88276012E-10_JPRB, 0.88278211E-10_JPRB, 0.88280272E-10_JPRB, 0.88281479E-10_JPRB, 0.88282784E-10_JPRB, 0.88284081E-10_JPRB, &
  & 0.88284241E-10_JPRB, 0.88285268E-10_JPRB, 0.88285504E-10_JPRB, 0.88285844E-10_JPRB, 0.88285511E-10_JPRB, 0.88284068E-10_JPRB, &
  & 0.88283186E-10_JPRB, 0.88282041E-10_JPRB, 0.88280758E-10_JPRB, 0.88278961E-10_JPRB, 0.88279474E-10_JPRB, 0.88277399E-10_JPRB, &
  & 0.88275713E-10_JPRB, 0.88276525E-10_JPRB, 0.88274776E-10_JPRB, 0.88272813E-10_JPRB /)

RGHG9(:,83,12) = (/ &
  & 0.88275082E-10_JPRB, 0.88274839E-10_JPRB, 0.88274305E-10_JPRB, 0.88274603E-10_JPRB, 0.88276358E-10_JPRB, 0.88275609E-10_JPRB, &
  & 0.88276317E-10_JPRB, 0.88276400E-10_JPRB, 0.88277351E-10_JPRB, 0.88277996E-10_JPRB, 0.88277510E-10_JPRB, 0.88278093E-10_JPRB, &
  & 0.88278537E-10_JPRB, 0.88279356E-10_JPRB, 0.88278607E-10_JPRB, 0.88277816E-10_JPRB, 0.88277254E-10_JPRB, 0.88275491E-10_JPRB, &
  & 0.88275789E-10_JPRB, 0.88275540E-10_JPRB, 0.88276012E-10_JPRB, 0.88277885E-10_JPRB, 0.88280772E-10_JPRB, 0.88283207E-10_JPRB, &
  & 0.88285670E-10_JPRB, 0.88287863E-10_JPRB, 0.88290500E-10_JPRB, 0.88292311E-10_JPRB, 0.88293609E-10_JPRB, 0.88293518E-10_JPRB, &
  & 0.88294407E-10_JPRB, 0.88293685E-10_JPRB, 0.88293067E-10_JPRB, 0.88291360E-10_JPRB, 0.88290979E-10_JPRB, 0.88288613E-10_JPRB, &
  & 0.88287606E-10_JPRB, 0.88284574E-10_JPRB, 0.88281507E-10_JPRB, 0.88280175E-10_JPRB, 0.88277927E-10_JPRB, 0.88276837E-10_JPRB, &
  & 0.88276768E-10_JPRB, 0.88278933E-10_JPRB, 0.88280994E-10_JPRB, 0.88282125E-10_JPRB, 0.88283304E-10_JPRB, 0.88284553E-10_JPRB, &
  & 0.88284637E-10_JPRB, 0.88285684E-10_JPRB, 0.88285920E-10_JPRB, 0.88286309E-10_JPRB, 0.88285990E-10_JPRB, 0.88284539E-10_JPRB, &
  & 0.88283665E-10_JPRB, 0.88282520E-10_JPRB, 0.88281264E-10_JPRB, 0.88279467E-10_JPRB, 0.88280057E-10_JPRB, 0.88277975E-10_JPRB, &
  & 0.88276282E-10_JPRB, 0.88277191E-10_JPRB, 0.88275463E-10_JPRB, 0.88273402E-10_JPRB /)

RGHG9(:,84,12) = (/ &
  & 0.88275429E-10_JPRB, 0.88275290E-10_JPRB, 0.88274735E-10_JPRB, 0.88275026E-10_JPRB, 0.88276823E-10_JPRB, 0.88276039E-10_JPRB, &
  & 0.88276754E-10_JPRB, 0.88276823E-10_JPRB, 0.88277871E-10_JPRB, 0.88278392E-10_JPRB, 0.88277968E-10_JPRB, 0.88278468E-10_JPRB, &
  & 0.88278961E-10_JPRB, 0.88279724E-10_JPRB, 0.88279023E-10_JPRB, 0.88278246E-10_JPRB, 0.88277718E-10_JPRB, 0.88275963E-10_JPRB, &
  & 0.88276324E-10_JPRB, 0.88276088E-10_JPRB, 0.88276490E-10_JPRB, 0.88278426E-10_JPRB, 0.88281216E-10_JPRB, 0.88283610E-10_JPRB, &
  & 0.88285997E-10_JPRB, 0.88288155E-10_JPRB, 0.88290764E-10_JPRB, 0.88292526E-10_JPRB, 0.88293810E-10_JPRB, 0.88293650E-10_JPRB, &
  & 0.88294559E-10_JPRB, 0.88293803E-10_JPRB, 0.88293185E-10_JPRB, 0.88291478E-10_JPRB, 0.88291104E-10_JPRB, 0.88288835E-10_JPRB, &
  & 0.88287856E-10_JPRB, 0.88284893E-10_JPRB, 0.88281944E-10_JPRB, 0.88280591E-10_JPRB, 0.88278454E-10_JPRB, 0.88277309E-10_JPRB, &
  & 0.88277205E-10_JPRB, 0.88279418E-10_JPRB, 0.88281438E-10_JPRB, 0.88282520E-10_JPRB, 0.88283623E-10_JPRB, 0.88284838E-10_JPRB, &
  & 0.88284866E-10_JPRB, 0.88285920E-10_JPRB, 0.88286170E-10_JPRB, 0.88286586E-10_JPRB, 0.88286281E-10_JPRB, 0.88284831E-10_JPRB, &
  & 0.88283950E-10_JPRB, 0.88282832E-10_JPRB, 0.88281576E-10_JPRB, 0.88279765E-10_JPRB, 0.88280432E-10_JPRB, 0.88278329E-10_JPRB, &
  & 0.88276608E-10_JPRB, 0.88277607E-10_JPRB, 0.88275914E-10_JPRB, 0.88273819E-10_JPRB /)

RGHG9(:,85,12) = (/ &
  & 0.88275678E-10_JPRB, 0.88275595E-10_JPRB, 0.88274998E-10_JPRB, 0.88275276E-10_JPRB, 0.88277129E-10_JPRB, 0.88276324E-10_JPRB, &
  & 0.88277038E-10_JPRB, 0.88277198E-10_JPRB, 0.88278065E-10_JPRB, 0.88278565E-10_JPRB, 0.88278329E-10_JPRB, 0.88278773E-10_JPRB, &
  & 0.88279217E-10_JPRB, 0.88279876E-10_JPRB, 0.88279273E-10_JPRB, 0.88278537E-10_JPRB, 0.88278024E-10_JPRB, 0.88276303E-10_JPRB, &
  & 0.88276678E-10_JPRB, 0.88276428E-10_JPRB, 0.88276816E-10_JPRB, 0.88278655E-10_JPRB, 0.88281535E-10_JPRB, 0.88283852E-10_JPRB, &
  & 0.88286212E-10_JPRB, 0.88288328E-10_JPRB, 0.88290958E-10_JPRB, 0.88292693E-10_JPRB, 0.88293942E-10_JPRB, 0.88293754E-10_JPRB, &
  & 0.88294684E-10_JPRB, 0.88293886E-10_JPRB, 0.88293241E-10_JPRB, 0.88291548E-10_JPRB, 0.88291208E-10_JPRB, 0.88288980E-10_JPRB, &
  & 0.88288016E-10_JPRB, 0.88285171E-10_JPRB, 0.88282208E-10_JPRB, 0.88280924E-10_JPRB, 0.88278718E-10_JPRB, 0.88277635E-10_JPRB, &
  & 0.88277531E-10_JPRB, 0.88279696E-10_JPRB, 0.88281778E-10_JPRB, 0.88282784E-10_JPRB, 0.88283818E-10_JPRB, 0.88285011E-10_JPRB, &
  & 0.88285018E-10_JPRB, 0.88286073E-10_JPRB, 0.88286350E-10_JPRB, 0.88286788E-10_JPRB, 0.88286489E-10_JPRB, 0.88285018E-10_JPRB, &
  & 0.88284144E-10_JPRB, 0.88283020E-10_JPRB, 0.88281764E-10_JPRB, 0.88279953E-10_JPRB, 0.88280674E-10_JPRB, 0.88278551E-10_JPRB, &
  & 0.88276830E-10_JPRB, 0.88277899E-10_JPRB, 0.88276234E-10_JPRB, 0.88274103E-10_JPRB /)

RGHG9(:,86,12) = (/ &
  & 0.88275803E-10_JPRB, 0.88275789E-10_JPRB, 0.88275165E-10_JPRB, 0.88275408E-10_JPRB, 0.88277344E-10_JPRB, 0.88276539E-10_JPRB, &
  & 0.88277261E-10_JPRB, 0.88277496E-10_JPRB, 0.88278246E-10_JPRB, 0.88278662E-10_JPRB, 0.88278579E-10_JPRB, 0.88278933E-10_JPRB, &
  & 0.88279335E-10_JPRB, 0.88279883E-10_JPRB, 0.88279418E-10_JPRB, 0.88278732E-10_JPRB, 0.88278183E-10_JPRB, 0.88276567E-10_JPRB, &
  & 0.88276914E-10_JPRB, 0.88276657E-10_JPRB, 0.88276955E-10_JPRB, 0.88278836E-10_JPRB, 0.88281667E-10_JPRB, 0.88284005E-10_JPRB, &
  & 0.88286344E-10_JPRB, 0.88288439E-10_JPRB, 0.88291111E-10_JPRB, 0.88292831E-10_JPRB, 0.88294053E-10_JPRB, 0.88293803E-10_JPRB, &
  & 0.88294747E-10_JPRB, 0.88293935E-10_JPRB, 0.88293296E-10_JPRB, 0.88291596E-10_JPRB, 0.88291284E-10_JPRB, 0.88289091E-10_JPRB, &
  & 0.88288210E-10_JPRB, 0.88285323E-10_JPRB, 0.88282361E-10_JPRB, 0.88281091E-10_JPRB, 0.88278912E-10_JPRB, 0.88277753E-10_JPRB, &
  & 0.88277642E-10_JPRB, 0.88279981E-10_JPRB, 0.88281993E-10_JPRB, 0.88282964E-10_JPRB, 0.88283936E-10_JPRB, 0.88285129E-10_JPRB, &
  & 0.88285101E-10_JPRB, 0.88286149E-10_JPRB, 0.88286455E-10_JPRB, 0.88286919E-10_JPRB, 0.88286635E-10_JPRB, 0.88285136E-10_JPRB, &
  & 0.88284262E-10_JPRB, 0.88283117E-10_JPRB, 0.88281868E-10_JPRB, 0.88280057E-10_JPRB, 0.88280827E-10_JPRB, 0.88278697E-10_JPRB, &
  & 0.88276948E-10_JPRB, 0.88278072E-10_JPRB, 0.88276442E-10_JPRB, 0.88274298E-10_JPRB /)

RGHG9(:,87,12) = (/ &
  & 0.88275894E-10_JPRB, 0.88275921E-10_JPRB, 0.88275269E-10_JPRB, 0.88275498E-10_JPRB, 0.88277483E-10_JPRB, 0.88276671E-10_JPRB, &
  & 0.88277385E-10_JPRB, 0.88277677E-10_JPRB, 0.88278364E-10_JPRB, 0.88278732E-10_JPRB, 0.88278732E-10_JPRB, 0.88279037E-10_JPRB, &
  & 0.88279405E-10_JPRB, 0.88279814E-10_JPRB, 0.88279446E-10_JPRB, 0.88278836E-10_JPRB, 0.88278287E-10_JPRB, 0.88276733E-10_JPRB, &
  & 0.88277052E-10_JPRB, 0.88276789E-10_JPRB, 0.88277045E-10_JPRB, 0.88278870E-10_JPRB, 0.88281785E-10_JPRB, 0.88284081E-10_JPRB, &
  & 0.88286448E-10_JPRB, 0.88288502E-10_JPRB, 0.88291242E-10_JPRB, 0.88292929E-10_JPRB, 0.88294136E-10_JPRB, 0.88293844E-10_JPRB, &
  & 0.88294788E-10_JPRB, 0.88293962E-10_JPRB, 0.88293296E-10_JPRB, 0.88291596E-10_JPRB, 0.88291346E-10_JPRB, 0.88289140E-10_JPRB, &
  & 0.88288370E-10_JPRB, 0.88285469E-10_JPRB, 0.88282388E-10_JPRB, 0.88281264E-10_JPRB, 0.88278919E-10_JPRB, 0.88277802E-10_JPRB, &
  & 0.88277691E-10_JPRB, 0.88280099E-10_JPRB, 0.88282173E-10_JPRB, 0.88283082E-10_JPRB, 0.88284012E-10_JPRB, 0.88285192E-10_JPRB, &
  & 0.88285143E-10_JPRB, 0.88286198E-10_JPRB, 0.88286524E-10_JPRB, 0.88287010E-10_JPRB, 0.88286718E-10_JPRB, 0.88285212E-10_JPRB, &
  & 0.88284338E-10_JPRB, 0.88283172E-10_JPRB, 0.88281937E-10_JPRB, 0.88280105E-10_JPRB, 0.88280910E-10_JPRB, 0.88278787E-10_JPRB, &
  & 0.88277011E-10_JPRB, 0.88278190E-10_JPRB, 0.88276574E-10_JPRB, 0.88274416E-10_JPRB /)

RGHG9(:,88,12) = (/ &
  & 0.88275928E-10_JPRB, 0.88275984E-10_JPRB, 0.88275331E-10_JPRB, 0.88275519E-10_JPRB, 0.88277573E-10_JPRB, 0.88276761E-10_JPRB, &
  & 0.88277483E-10_JPRB, 0.88277802E-10_JPRB, 0.88278419E-10_JPRB, 0.88278808E-10_JPRB, 0.88278829E-10_JPRB, 0.88279134E-10_JPRB, &
  & 0.88279453E-10_JPRB, 0.88279842E-10_JPRB, 0.88279509E-10_JPRB, 0.88278905E-10_JPRB, 0.88278343E-10_JPRB, 0.88276837E-10_JPRB, &
  & 0.88277143E-10_JPRB, 0.88276851E-10_JPRB, 0.88277066E-10_JPRB, 0.88278905E-10_JPRB, 0.88281847E-10_JPRB, 0.88284130E-10_JPRB, &
  & 0.88286482E-10_JPRB, 0.88288522E-10_JPRB, 0.88291326E-10_JPRB, 0.88293005E-10_JPRB, 0.88294205E-10_JPRB, 0.88293851E-10_JPRB, &
  & 0.88294823E-10_JPRB, 0.88293969E-10_JPRB, 0.88293331E-10_JPRB, 0.88291603E-10_JPRB, 0.88291416E-10_JPRB, 0.88289195E-10_JPRB, &
  & 0.88288508E-10_JPRB, 0.88285552E-10_JPRB, 0.88282381E-10_JPRB, 0.88281354E-10_JPRB, 0.88278954E-10_JPRB, 0.88277795E-10_JPRB, &
  & 0.88277684E-10_JPRB, 0.88280230E-10_JPRB, 0.88282284E-10_JPRB, 0.88283172E-10_JPRB, 0.88284054E-10_JPRB, 0.88285212E-10_JPRB, &
  & 0.88285150E-10_JPRB, 0.88286212E-10_JPRB, 0.88286559E-10_JPRB, 0.88287072E-10_JPRB, 0.88286781E-10_JPRB, 0.88285261E-10_JPRB, &
  & 0.88284380E-10_JPRB, 0.88283207E-10_JPRB, 0.88281993E-10_JPRB, 0.88280133E-10_JPRB, 0.88280980E-10_JPRB, 0.88278829E-10_JPRB, &
  & 0.88277038E-10_JPRB, 0.88278274E-10_JPRB, 0.88276678E-10_JPRB, 0.88274492E-10_JPRB /)

RGHG9(:,89,12) = (/ &
  & 0.88275949E-10_JPRB, 0.88276012E-10_JPRB, 0.88275373E-10_JPRB, 0.88275540E-10_JPRB, 0.88277642E-10_JPRB, 0.88276719E-10_JPRB, &
  & 0.88277496E-10_JPRB, 0.88277760E-10_JPRB, 0.88278468E-10_JPRB, 0.88278850E-10_JPRB, 0.88278843E-10_JPRB, 0.88279134E-10_JPRB, &
  & 0.88279516E-10_JPRB, 0.88279925E-10_JPRB, 0.88279536E-10_JPRB, 0.88278940E-10_JPRB, 0.88278419E-10_JPRB, 0.88276830E-10_JPRB, &
  & 0.88277184E-10_JPRB, 0.88276893E-10_JPRB, 0.88277052E-10_JPRB, 0.88278919E-10_JPRB, 0.88281896E-10_JPRB, 0.88284158E-10_JPRB, &
  & 0.88286517E-10_JPRB, 0.88288529E-10_JPRB, 0.88291381E-10_JPRB, 0.88293067E-10_JPRB, 0.88294275E-10_JPRB, 0.88293851E-10_JPRB, &
  & 0.88294851E-10_JPRB, 0.88293990E-10_JPRB, 0.88293359E-10_JPRB, 0.88291589E-10_JPRB, 0.88291485E-10_JPRB, 0.88289188E-10_JPRB, &
  & 0.88288626E-10_JPRB, 0.88285587E-10_JPRB, 0.88282326E-10_JPRB, 0.88281452E-10_JPRB, 0.88278954E-10_JPRB, 0.88277781E-10_JPRB, &
  & 0.88277670E-10_JPRB, 0.88280300E-10_JPRB, 0.88282368E-10_JPRB, 0.88283214E-10_JPRB, 0.88284074E-10_JPRB, 0.88285247E-10_JPRB, &
  & 0.88285129E-10_JPRB, 0.88286226E-10_JPRB, 0.88286586E-10_JPRB, 0.88287114E-10_JPRB, 0.88286829E-10_JPRB, 0.88285289E-10_JPRB, &
  & 0.88284415E-10_JPRB, 0.88283242E-10_JPRB, 0.88282014E-10_JPRB, 0.88280147E-10_JPRB, 0.88281056E-10_JPRB, 0.88278856E-10_JPRB, &
  & 0.88277045E-10_JPRB, 0.88278343E-10_JPRB, 0.88276719E-10_JPRB, 0.88274513E-10_JPRB /)

RGHG9(:,90,12) = (/ &
  & 0.88275963E-10_JPRB, 0.88276032E-10_JPRB, 0.88275380E-10_JPRB, 0.88275463E-10_JPRB, 0.88277760E-10_JPRB, 0.88276622E-10_JPRB, &
  & 0.88277469E-10_JPRB, 0.88277635E-10_JPRB, 0.88278440E-10_JPRB, 0.88278926E-10_JPRB, 0.88278773E-10_JPRB, 0.88279162E-10_JPRB, &
  & 0.88279578E-10_JPRB, 0.88280154E-10_JPRB, 0.88279599E-10_JPRB, 0.88278912E-10_JPRB, 0.88278482E-10_JPRB, 0.88276705E-10_JPRB, &
  & 0.88277233E-10_JPRB, 0.88276879E-10_JPRB, 0.88277018E-10_JPRB, 0.88278891E-10_JPRB, 0.88281930E-10_JPRB, 0.88284172E-10_JPRB, &
  & 0.88286545E-10_JPRB, 0.88288515E-10_JPRB, 0.88291430E-10_JPRB, 0.88293109E-10_JPRB, 0.88294344E-10_JPRB, 0.88293817E-10_JPRB, &
  & 0.88294927E-10_JPRB, 0.88294011E-10_JPRB, 0.88293421E-10_JPRB, 0.88291520E-10_JPRB, 0.88291596E-10_JPRB, 0.88289140E-10_JPRB, &
  & 0.88288758E-10_JPRB, 0.88285615E-10_JPRB, 0.88282250E-10_JPRB, 0.88281493E-10_JPRB, 0.88278912E-10_JPRB, 0.88277753E-10_JPRB, &
  & 0.88277607E-10_JPRB, 0.88280341E-10_JPRB, 0.88282430E-10_JPRB, 0.88283249E-10_JPRB, 0.88284088E-10_JPRB, 0.88285303E-10_JPRB, &
  & 0.88285115E-10_JPRB, 0.88286253E-10_JPRB, 0.88286600E-10_JPRB, 0.88287155E-10_JPRB, 0.88286878E-10_JPRB, 0.88285282E-10_JPRB, &
  & 0.88284415E-10_JPRB, 0.88283249E-10_JPRB, 0.88282028E-10_JPRB, 0.88280092E-10_JPRB, 0.88281160E-10_JPRB, 0.88278850E-10_JPRB, &
  & 0.88276976E-10_JPRB, 0.88278426E-10_JPRB, 0.88276733E-10_JPRB, 0.88274492E-10_JPRB /)

RGHG9(:,91,12) = (/ &
  & 0.88275984E-10_JPRB, 0.88276095E-10_JPRB, 0.88275325E-10_JPRB, 0.88275297E-10_JPRB, 0.88278024E-10_JPRB, 0.88276400E-10_JPRB, &
  & 0.88277545E-10_JPRB, 0.88277233E-10_JPRB, 0.88278516E-10_JPRB, 0.88279412E-10_JPRB, 0.88278301E-10_JPRB, 0.88279120E-10_JPRB, &
  & 0.88279606E-10_JPRB, 0.88280654E-10_JPRB, 0.88279599E-10_JPRB, 0.88278843E-10_JPRB, 0.88278655E-10_JPRB, 0.88276393E-10_JPRB, &
  & 0.88277309E-10_JPRB, 0.88276858E-10_JPRB, 0.88276893E-10_JPRB, 0.88278829E-10_JPRB, 0.88282000E-10_JPRB, 0.88284172E-10_JPRB, &
  & 0.88286572E-10_JPRB, 0.88288439E-10_JPRB, 0.88291534E-10_JPRB, 0.88293144E-10_JPRB, 0.88294455E-10_JPRB, 0.88293713E-10_JPRB, &
  & 0.88295093E-10_JPRB, 0.88293997E-10_JPRB, 0.88293574E-10_JPRB, 0.88291326E-10_JPRB, 0.88291818E-10_JPRB, 0.88288973E-10_JPRB, &
  & 0.88289029E-10_JPRB, 0.88285552E-10_JPRB, 0.88282014E-10_JPRB, 0.88281625E-10_JPRB, 0.88278815E-10_JPRB, 0.88277663E-10_JPRB, &
  & 0.88277413E-10_JPRB, 0.88280390E-10_JPRB, 0.88282527E-10_JPRB, 0.88283242E-10_JPRB, 0.88284068E-10_JPRB, 0.88285393E-10_JPRB, &
  & 0.88285025E-10_JPRB, 0.88286316E-10_JPRB, 0.88286579E-10_JPRB, 0.88287218E-10_JPRB, 0.88286961E-10_JPRB, 0.88285219E-10_JPRB, &
  & 0.88284435E-10_JPRB, 0.88283249E-10_JPRB, 0.88282083E-10_JPRB, 0.88279890E-10_JPRB, 0.88281375E-10_JPRB, 0.88278794E-10_JPRB, &
  & 0.88276761E-10_JPRB, 0.88278586E-10_JPRB, 0.88276657E-10_JPRB, 0.88274422E-10_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CCL4CLIM:PART24',1,ZHOOK_HANDLE)
END SUBROUTINE PART24

END SUBROUTINE SU_CCL4CLIM
