!option! -Nv -NO
#ifdef RS6K
@PROCESS NOOPTIMIZE
#endif
!pgi$r opt=0 
SUBROUTINE SU_CH4CLIM


!**   METHANE CLIMATOLOGY FROM D.CARIOLLE 2D MODEL* 

!     PURPOSE.
!     --------

!**   INTERFACE.
!     ----------
!        CALL *SU_CH4CLIM* FROM *SUECRAD*

!        EXPLICIT ARGUMENTS :
!        --------------------
!     ==== INPUTS ===
!     ==== OUTPUTS ===

!        IMPLICIT ARGUMENTS :   NONE
!        --------------------

!     METHOD.
!     -------

!     EXTERNALS.
!     ----------

!          NONE

!     REFERENCE.
!     ----------

!        SEE RADIATION'S PART OF THE MODEL'S DOCUMENTATION AND
!        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE "I.F.S"

!     AUTHOR.
!     -------
!     J.-J. MORCRETTE  E.C.M.W.F.    20080423

!     MODIFICATIONS.
!     --------------
!        Same history as suecaesu
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     R. Elkhatib 12-10-2005 Split for faster and more robust compilation.

!-----------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE YOMCLIM   ,ONLY : RGHG2

IMPLICIT NONE

!     -----------------------------------------------------------------

!*       0.1   ARGUMENTS.
!              ----------
! REAL(KIND=JPRB),INTENT(OUT) :: PCLCH4(64,91,12)
!     ----------------------------------------------------------------- 

!*       0.2   LOCAL ARRAYS.
!              -------------

! REAL(KIND=JPRB),SAVE :: ZGHG2(64,91,12)

LOGICAL,SAVE :: LLFIRSTCALL = .TRUE.

REAL(KIND=JPRB) :: ZHOOK_HANDLE
!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM',0,ZHOOK_HANDLE)

IF(LLFIRSTCALL) THEN

  ALLOCATE(RGHG2(64,91,12))

  CALL PART1
  CALL PART2
  CALL PART3
  CALL PART4
  CALL PART5
  CALL PART6
  CALL PART7
  CALL PART8
  CALL PART9
  CALL PART10
  CALL PART11
  CALL PART12
  CALL PART13
  CALL PART14
  CALL PART15
  CALL PART16
  CALL PART17
  CALL PART18
  CALL PART19
  CALL PART20
  CALL PART21
  CALL PART22
  CALL PART23
  CALL PART24

ENDIF

! PCLCH4(:,:,:)=ZGHG2(:,:,:)

!     ------------------------------------------------------------------

LLFIRSTCALL = .FALSE.

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM',1,ZHOOK_HANDLE)

!-----------------------------------------------------------------------------

CONTAINS

SUBROUTINE PART1
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART1',0,ZHOOK_HANDLE)



!-- Month=  1 ------------

RGHG2(:, 1, 1) = (/ &
  & 0.25049442E-07_JPRB, 0.24200402E-07_JPRB, 0.22429996E-07_JPRB, 0.20710667E-07_JPRB, 0.19042018E-07_JPRB, 0.17480163E-07_JPRB, &
  & 0.16215791E-07_JPRB, 0.15006695E-07_JPRB, 0.14063124E-07_JPRB, 0.13371063E-07_JPRB, 0.12923400E-07_JPRB, 0.12722078E-07_JPRB, &
  & 0.12757321E-07_JPRB, 0.13002696E-07_JPRB, 0.13414473E-07_JPRB, 0.13925783E-07_JPRB, 0.14471668E-07_JPRB, 0.14965947E-07_JPRB, &
  & 0.15322849E-07_JPRB, 0.15477585E-07_JPRB, 0.15412782E-07_JPRB, 0.15168917E-07_JPRB, 0.14810371E-07_JPRB, 0.14387286E-07_JPRB, &
  & 0.13927213E-07_JPRB, 0.13411588E-07_JPRB, 0.12793739E-07_JPRB, 0.12042052E-07_JPRB, 0.11273245E-07_JPRB, 0.10531941E-07_JPRB, &
  & 0.98480317E-08_JPRB, 0.92349737E-08_JPRB, 0.87032959E-08_JPRB, 0.82571772E-08_JPRB, 0.79057907E-08_JPRB, 0.76617210E-08_JPRB, &
  & 0.75399127E-08_JPRB, 0.75595317E-08_JPRB, 0.77406304E-08_JPRB, 0.80339575E-08_JPRB, 0.83424752E-08_JPRB, 0.85849425E-08_JPRB, &
  & 0.87122913E-08_JPRB, 0.86930081E-08_JPRB, 0.84821652E-08_JPRB, 0.80636990E-08_JPRB, 0.74836510E-08_JPRB, 0.68314372E-08_JPRB, &
  & 0.62119998E-08_JPRB, 0.57088663E-08_JPRB, 0.53646927E-08_JPRB, 0.51850595E-08_JPRB, 0.51506417E-08_JPRB, 0.52233520E-08_JPRB, &
  & 0.53540177E-08_JPRB, 0.54975584E-08_JPRB, 0.56262035E-08_JPRB, 0.57306346E-08_JPRB, 0.58155072E-08_JPRB, 0.58843663E-08_JPRB, &
  & 0.59436056E-08_JPRB, 0.59947349E-08_JPRB, 0.60347989E-08_JPRB, 0.60719429E-08_JPRB /)

RGHG2(:, 2, 1) = (/ &
  & 0.28120109E-07_JPRB, 0.28398480E-07_JPRB, 0.28276027E-07_JPRB, 0.27938665E-07_JPRB, 0.27504900E-07_JPRB, 0.27026115E-07_JPRB, &
  & 0.26556151E-07_JPRB, 0.26128632E-07_JPRB, 0.25792382E-07_JPRB, 0.25578480E-07_JPRB, 0.25549930E-07_JPRB, 0.25743139E-07_JPRB, &
  & 0.26167893E-07_JPRB, 0.26835050E-07_JPRB, 0.27690483E-07_JPRB, 0.28660576E-07_JPRB, 0.29637905E-07_JPRB, 0.30499336E-07_JPRB, &
  & 0.31111355E-07_JPRB, 0.31377578E-07_JPRB, 0.31277416E-07_JPRB, 0.30868527E-07_JPRB, 0.30244010E-07_JPRB, 0.29483507E-07_JPRB, &
  & 0.28638382E-07_JPRB, 0.27746173E-07_JPRB, 0.26771763E-07_JPRB, 0.25718562E-07_JPRB, 0.24647564E-07_JPRB, 0.23618087E-07_JPRB, &
  & 0.22656796E-07_JPRB, 0.21767868E-07_JPRB, 0.20952635E-07_JPRB, 0.20214189E-07_JPRB, 0.19566158E-07_JPRB, 0.19027823E-07_JPRB, &
  & 0.18626183E-07_JPRB, 0.18404570E-07_JPRB, 0.18407244E-07_JPRB, 0.18613925E-07_JPRB, 0.18916300E-07_JPRB, 0.19168500E-07_JPRB, &
  & 0.19250596E-07_JPRB, 0.19105091E-07_JPRB, 0.18736610E-07_JPRB, 0.18194768E-07_JPRB, 0.17564007E-07_JPRB, 0.16908952E-07_JPRB, &
  & 0.16205922E-07_JPRB, 0.15345950E-07_JPRB, 0.14251269E-07_JPRB, 0.12993908E-07_JPRB, 0.11765967E-07_JPRB, 0.10735892E-07_JPRB, &
  & 0.99617470E-08_JPRB, 0.94256727E-08_JPRB, 0.90854400E-08_JPRB, 0.88945047E-08_JPRB, 0.88098115E-08_JPRB, 0.87993133E-08_JPRB, &
  & 0.88391525E-08_JPRB, 0.89091658E-08_JPRB, 0.89987449E-08_JPRB, 0.91537800E-08_JPRB /)

RGHG2(:, 3, 1) = (/ &
  & 0.28123051E-07_JPRB, 0.28938702E-07_JPRB, 0.29397718E-07_JPRB, 0.29729367E-07_JPRB, 0.29991654E-07_JPRB, 0.30221699E-07_JPRB, &
  & 0.30455794E-07_JPRB, 0.30689289E-07_JPRB, 0.30946218E-07_JPRB, 0.31270865E-07_JPRB, 0.31692529E-07_JPRB, 0.32306257E-07_JPRB, &
  & 0.33144033E-07_JPRB, 0.34190464E-07_JPRB, 0.35440959E-07_JPRB, 0.36803677E-07_JPRB, 0.38176868E-07_JPRB, 0.39418545E-07_JPRB, &
  & 0.40410047E-07_JPRB, 0.41073527E-07_JPRB, 0.41385803E-07_JPRB, 0.41384553E-07_JPRB, 0.41144148E-07_JPRB, 0.40735507E-07_JPRB, &
  & 0.40209482E-07_JPRB, 0.39581263E-07_JPRB, 0.38850359E-07_JPRB, 0.38011795E-07_JPRB, 0.37109903E-07_JPRB, 0.36183536E-07_JPRB, &
  & 0.35244572E-07_JPRB, 0.34296100E-07_JPRB, 0.33351633E-07_JPRB, 0.32457827E-07_JPRB, 0.31712673E-07_JPRB, 0.31243541E-07_JPRB, &
  & 0.31151856E-07_JPRB, 0.31468506E-07_JPRB, 0.32129382E-07_JPRB, 0.32960777E-07_JPRB, 0.33705103E-07_JPRB, 0.34112922E-07_JPRB, &
  & 0.34013759E-07_JPRB, 0.33349554E-07_JPRB, 0.32153636E-07_JPRB, 0.30504236E-07_JPRB, 0.28506825E-07_JPRB, 0.26292527E-07_JPRB, &
  & 0.24002656E-07_JPRB, 0.21801775E-07_JPRB, 0.19876683E-07_JPRB, 0.18329562E-07_JPRB, 0.17081950E-07_JPRB, 0.16000328E-07_JPRB, &
  & 0.15068707E-07_JPRB, 0.14343982E-07_JPRB, 0.13843673E-07_JPRB, 0.13537470E-07_JPRB, 0.13380861E-07_JPRB, 0.13331887E-07_JPRB, &
  & 0.13359342E-07_JPRB, 0.13443896E-07_JPRB, 0.13572778E-07_JPRB, 0.13838140E-07_JPRB /)

RGHG2(:, 4, 1) = (/ &
  & 0.27502779E-07_JPRB, 0.28386715E-07_JPRB, 0.28930572E-07_JPRB, 0.29424330E-07_JPRB, 0.29905664E-07_JPRB, 0.30393622E-07_JPRB, &
  & 0.30923960E-07_JPRB, 0.31496366E-07_JPRB, 0.32146193E-07_JPRB, 0.32905970E-07_JPRB, 0.33820232E-07_JPRB, 0.34957122E-07_JPRB, &
  & 0.36362238E-07_JPRB, 0.38004501E-07_JPRB, 0.39766046E-07_JPRB, 0.41564935E-07_JPRB, 0.43299231E-07_JPRB, 0.44883826E-07_JPRB, &
  & 0.46219132E-07_JPRB, 0.47249394E-07_JPRB, 0.47972364E-07_JPRB, 0.48412634E-07_JPRB, 0.48631026E-07_JPRB, 0.48689014E-07_JPRB, &
  & 0.48634138E-07_JPRB, 0.48497171E-07_JPRB, 0.48283475E-07_JPRB, 0.47983907E-07_JPRB, 0.47587758E-07_JPRB, 0.47091071E-07_JPRB, &
  & 0.46504169E-07_JPRB, 0.45846509E-07_JPRB, 0.45156483E-07_JPRB, 0.44509864E-07_JPRB, 0.44014236E-07_JPRB, 0.43783078E-07_JPRB, &
  & 0.43892740E-07_JPRB, 0.44347320E-07_JPRB, 0.45052793E-07_JPRB, 0.45805955E-07_JPRB, 0.46337032E-07_JPRB, 0.46409451E-07_JPRB, &
  & 0.45918014E-07_JPRB, 0.44890644E-07_JPRB, 0.43412236E-07_JPRB, 0.41574040E-07_JPRB, 0.39454882E-07_JPRB, 0.37123531E-07_JPRB, &
  & 0.34653873E-07_JPRB, 0.32135294E-07_JPRB, 0.29636428E-07_JPRB, 0.27177190E-07_JPRB, 0.24828978E-07_JPRB, 0.22772507E-07_JPRB, &
  & 0.21134946E-07_JPRB, 0.19913163E-07_JPRB, 0.19059051E-07_JPRB, 0.18521181E-07_JPRB, 0.18234648E-07_JPRB, 0.18132601E-07_JPRB, &
  & 0.18157117E-07_JPRB, 0.18261760E-07_JPRB, 0.18445498E-07_JPRB, 0.18802618E-07_JPRB /)

RGHG2(:, 5, 1) = (/ &
  & 0.26696764E-07_JPRB, 0.27425063E-07_JPRB, 0.27946950E-07_JPRB, 0.28464418E-07_JPRB, 0.29022800E-07_JPRB, 0.29675347E-07_JPRB, &
  & 0.30450561E-07_JPRB, 0.31359217E-07_JPRB, 0.32432400E-07_JPRB, 0.33767520E-07_JPRB, 0.35412214E-07_JPRB, 0.37323368E-07_JPRB, &
  & 0.39436451E-07_JPRB, 0.41682501E-07_JPRB, 0.44012225E-07_JPRB, 0.46310014E-07_JPRB, 0.48484011E-07_JPRB, 0.50461210E-07_JPRB, &
  & 0.52190913E-07_JPRB, 0.53643380E-07_JPRB, 0.54814823E-07_JPRB, 0.55735914E-07_JPRB, 0.56431784E-07_JPRB, 0.56962051E-07_JPRB, &
  & 0.57364044E-07_JPRB, 0.57662369E-07_JPRB, 0.57864540E-07_JPRB, 0.57941907E-07_JPRB, 0.57858525E-07_JPRB, 0.57596168E-07_JPRB, &
  & 0.57164829E-07_JPRB, 0.56606815E-07_JPRB, 0.55995155E-07_JPRB, 0.55430494E-07_JPRB, 0.55028430E-07_JPRB, 0.54885206E-07_JPRB, &
  & 0.55054372E-07_JPRB, 0.55514914E-07_JPRB, 0.56145041E-07_JPRB, 0.56693793E-07_JPRB, 0.56821413E-07_JPRB, 0.56290567E-07_JPRB, &
  & 0.55115585E-07_JPRB, 0.53479226E-07_JPRB, 0.51570318E-07_JPRB, 0.49526811E-07_JPRB, 0.47416737E-07_JPRB, 0.45248193E-07_JPRB, &
  & 0.43000799E-07_JPRB, 0.40654367E-07_JPRB, 0.38202355E-07_JPRB, 0.35693283E-07_JPRB, 0.33239665E-07_JPRB, 0.30928398E-07_JPRB, &
  & 0.28829310E-07_JPRB, 0.27061823E-07_JPRB, 0.25724656E-07_JPRB, 0.24824335E-07_JPRB, 0.24297012E-07_JPRB, 0.24052566E-07_JPRB, &
  & 0.23996167E-07_JPRB, 0.24066285E-07_JPRB, 0.24240123E-07_JPRB, 0.24645741E-07_JPRB /)

RGHG2(:, 6, 1) = (/ &
  & 0.26197279E-07_JPRB, 0.26664434E-07_JPRB, 0.27137155E-07_JPRB, 0.27722363E-07_JPRB, 0.28456395E-07_JPRB, 0.29390682E-07_JPRB, &
  & 0.30589490E-07_JPRB, 0.32055219E-07_JPRB, 0.33851908E-07_JPRB, 0.35962380E-07_JPRB, 0.38439136E-07_JPRB, 0.41253998E-07_JPRB, &
  & 0.44300005E-07_JPRB, 0.47412016E-07_JPRB, 0.50479407E-07_JPRB, 0.53477205E-07_JPRB, 0.56357770E-07_JPRB, 0.59050176E-07_JPRB, &
  & 0.61530066E-07_JPRB, 0.63817353E-07_JPRB, 0.65934017E-07_JPRB, 0.67902207E-07_JPRB, 0.69722873E-07_JPRB, 0.71373691E-07_JPRB, &
  & 0.72869035E-07_JPRB, 0.74191128E-07_JPRB, 0.75324635E-07_JPRB, 0.76231522E-07_JPRB, 0.76825614E-07_JPRB, 0.77058516E-07_JPRB, &
  & 0.76922369E-07_JPRB, 0.76480958E-07_JPRB, 0.75852839E-07_JPRB, 0.75201832E-07_JPRB, 0.74687676E-07_JPRB, 0.74417102E-07_JPRB, &
  & 0.74423859E-07_JPRB, 0.74625056E-07_JPRB, 0.74776082E-07_JPRB, 0.74451158E-07_JPRB, 0.73205918E-07_JPRB, 0.70963722E-07_JPRB, &
  & 0.68072453E-07_JPRB, 0.64969505E-07_JPRB, 0.61934202E-07_JPRB, 0.59073592E-07_JPRB, 0.56390572E-07_JPRB, 0.53828483E-07_JPRB, &
  & 0.51311694E-07_JPRB, 0.48787143E-07_JPRB, 0.46238839E-07_JPRB, 0.43686327E-07_JPRB, 0.41157524E-07_JPRB, 0.38717673E-07_JPRB, &
  & 0.36493716E-07_JPRB, 0.34605399E-07_JPRB, 0.33118383E-07_JPRB, 0.32054203E-07_JPRB, 0.31379333E-07_JPRB, 0.31010288E-07_JPRB, &
  & 0.30852426E-07_JPRB, 0.30839736E-07_JPRB, 0.30919264E-07_JPRB, 0.31159907E-07_JPRB /)

RGHG2(:, 7, 1) = (/ &
  & 0.26248987E-07_JPRB, 0.26909031E-07_JPRB, 0.27577311E-07_JPRB, 0.28415350E-07_JPRB, 0.29480276E-07_JPRB, 0.30845651E-07_JPRB, &
  & 0.32612729E-07_JPRB, 0.34831821E-07_JPRB, 0.37527833E-07_JPRB, 0.40777032E-07_JPRB, 0.44485052E-07_JPRB, 0.48529202E-07_JPRB, &
  & 0.52789066E-07_JPRB, 0.57221705E-07_JPRB, 0.61678264E-07_JPRB, 0.66004056E-07_JPRB, 0.70158805E-07_JPRB, 0.74158642E-07_JPRB, &
  & 0.77999701E-07_JPRB, 0.81741206E-07_JPRB, 0.85435673E-07_JPRB, 0.89117421E-07_JPRB, 0.92776574E-07_JPRB, 0.96321124E-07_JPRB, &
  & 0.99690482E-07_JPRB, 0.10285346E-06_JPRB, 0.10579674E-06_JPRB, 0.10849396E-06_JPRB, 0.11090788E-06_JPRB, 0.11293861E-06_JPRB, &
  & 0.11452159E-06_JPRB, 0.11559708E-06_JPRB, 0.11613359E-06_JPRB, 0.11614748E-06_JPRB, 0.11568353E-06_JPRB, 0.11478663E-06_JPRB, &
  & 0.11346400E-06_JPRB, 0.11162068E-06_JPRB, 0.10899145E-06_JPRB, 0.10514933E-06_JPRB, 0.99889803E-07_JPRB, 0.93616038E-07_JPRB, &
  & 0.87221977E-07_JPRB, 0.81397289E-07_JPRB, 0.76384438E-07_JPRB, 0.72117103E-07_JPRB, 0.68393248E-07_JPRB, 0.64986892E-07_JPRB, &
  & 0.61738916E-07_JPRB, 0.58574400E-07_JPRB, 0.55462998E-07_JPRB, 0.52406786E-07_JPRB, 0.49455565E-07_JPRB, 0.46703285E-07_JPRB, &
  & 0.44242476E-07_JPRB, 0.42149914E-07_JPRB, 0.40501838E-07_JPRB, 0.39315026E-07_JPRB, 0.38533365E-07_JPRB, 0.38066744E-07_JPRB, &
  & 0.37810644E-07_JPRB, 0.37698449E-07_JPRB, 0.37675594E-07_JPRB, 0.37791160E-07_JPRB /)

RGHG2(:, 8, 1) = (/ &
  & 0.28855261E-07_JPRB, 0.29556196E-07_JPRB, 0.30572597E-07_JPRB, 0.31834965E-07_JPRB, 0.33486927E-07_JPRB, 0.35609421E-07_JPRB, &
  & 0.38343039E-07_JPRB, 0.41673790E-07_JPRB, 0.45666596E-07_JPRB, 0.50333135E-07_JPRB, 0.55778500E-07_JPRB, 0.61863147E-07_JPRB, &
  & 0.68373176E-07_JPRB, 0.75049748E-07_JPRB, 0.81805986E-07_JPRB, 0.88559887E-07_JPRB, 0.95189826E-07_JPRB, 0.10168130E-06_JPRB, &
  & 0.10807558E-06_JPRB, 0.11445113E-06_JPRB, 0.12087018E-06_JPRB, 0.12731005E-06_JPRB, 0.13374432E-06_JPRB, 0.14001607E-06_JPRB, &
  & 0.14600056E-06_JPRB, 0.15164419E-06_JPRB, 0.15704055E-06_JPRB, 0.16227619E-06_JPRB, 0.16736104E-06_JPRB, 0.17221271E-06_JPRB, &
  & 0.17654646E-06_JPRB, 0.17997066E-06_JPRB, 0.18200461E-06_JPRB, 0.18223791E-06_JPRB, 0.18042591E-06_JPRB, 0.17655856E-06_JPRB, &
  & 0.17091980E-06_JPRB, 0.16376003E-06_JPRB, 0.15508439E-06_JPRB, 0.14475904E-06_JPRB, 0.13283740E-06_JPRB, 0.12042464E-06_JPRB, &
  & 0.10918377E-06_JPRB, 0.10000535E-06_JPRB, 0.92806232E-07_JPRB, 0.87043688E-07_JPRB, 0.82168398E-07_JPRB, 0.77806718E-07_JPRB, &
  & 0.73757050E-07_JPRB, 0.69873188E-07_JPRB, 0.66054703E-07_JPRB, 0.62307691E-07_JPRB, 0.58712612E-07_JPRB, 0.55373171E-07_JPRB, &
  & 0.52390167E-07_JPRB, 0.49877734E-07_JPRB, 0.47894442E-07_JPRB, 0.46443478E-07_JPRB, 0.45459053E-07_JPRB, 0.44836312E-07_JPRB, &
  & 0.44449216E-07_JPRB, 0.44205994E-07_JPRB, 0.44037272E-07_JPRB, 0.43916842E-07_JPRB /)

RGHG2(:, 9, 1) = (/ &
  & 0.37539131E-07_JPRB, 0.39030002E-07_JPRB, 0.40403602E-07_JPRB, 0.42058705E-07_JPRB, 0.44292399E-07_JPRB, 0.47267111E-07_JPRB, &
  & 0.51166730E-07_JPRB, 0.56015317E-07_JPRB, 0.61773832E-07_JPRB, 0.68557355E-07_JPRB, 0.76344271E-07_JPRB, 0.85134999E-07_JPRB, &
  & 0.94813295E-07_JPRB, 0.10515059E-06_JPRB, 0.11577129E-06_JPRB, 0.12650577E-06_JPRB, 0.13726425E-06_JPRB, 0.14796731E-06_JPRB, &
  & 0.15858319E-06_JPRB, 0.16910387E-06_JPRB, 0.17959091E-06_JPRB, 0.18992777E-06_JPRB, 0.19991214E-06_JPRB, 0.20938728E-06_JPRB, &
  & 0.21816700E-06_JPRB, 0.22623449E-06_JPRB, 0.23381368E-06_JPRB, 0.24112012E-06_JPRB, 0.24822816E-06_JPRB, 0.25488606E-06_JPRB, &
  & 0.26049071E-06_JPRB, 0.26413363E-06_JPRB, 0.26479651E-06_JPRB, 0.26169064E-06_JPRB, 0.25454767E-06_JPRB, 0.24392375E-06_JPRB, &
  & 0.23078050E-06_JPRB, 0.21606739E-06_JPRB, 0.20011764E-06_JPRB, 0.18269445E-06_JPRB, 0.16403104E-06_JPRB, 0.14571795E-06_JPRB, &
  & 0.12997673E-06_JPRB, 0.11775293E-06_JPRB, 0.10846378E-06_JPRB, 0.10119329E-06_JPRB, 0.95237446E-07_JPRB, 0.90130619E-07_JPRB, &
  & 0.85485411E-07_JPRB, 0.81009091E-07_JPRB, 0.76601729E-07_JPRB, 0.72279143E-07_JPRB, 0.68100547E-07_JPRB, 0.64172127E-07_JPRB, &
  & 0.60638179E-07_JPRB, 0.57612226E-07_JPRB, 0.55196264E-07_JPRB, 0.53417232E-07_JPRB, 0.52217889E-07_JPRB, 0.51433997E-07_JPRB, &
  & 0.50934958E-07_JPRB, 0.50606104E-07_JPRB, 0.50359258E-07_JPRB, 0.50065562E-07_JPRB /)

RGHG2(:,10, 1) = (/ &
  & 0.65498512E-07_JPRB, 0.65981816E-07_JPRB, 0.66132081E-07_JPRB, 0.67399128E-07_JPRB, 0.69282308E-07_JPRB, 0.72418608E-07_JPRB, &
  & 0.77032908E-07_JPRB, 0.83136989E-07_JPRB, 0.90727184E-07_JPRB, 0.99900156E-07_JPRB, 0.11074056E-06_JPRB, 0.12313834E-06_JPRB, &
  & 0.13685954E-06_JPRB, 0.15173615E-06_JPRB, 0.16758240E-06_JPRB, 0.18401555E-06_JPRB, 0.20073465E-06_JPRB, 0.21752261E-06_JPRB, &
  & 0.23421393E-06_JPRB, 0.25059350E-06_JPRB, 0.26645424E-06_JPRB, 0.28161790E-06_JPRB, 0.29575759E-06_JPRB, 0.30843935E-06_JPRB, &
  & 0.31968858E-06_JPRB, 0.32939769E-06_JPRB, 0.33786540E-06_JPRB, 0.34533065E-06_JPRB, 0.35173207E-06_JPRB, 0.35664237E-06_JPRB, &
  & 0.35910020E-06_JPRB, 0.35788656E-06_JPRB, 0.35177266E-06_JPRB, 0.33998614E-06_JPRB, 0.32288358E-06_JPRB, 0.30209404E-06_JPRB, &
  & 0.27983060E-06_JPRB, 0.25737467E-06_JPRB, 0.23499899E-06_JPRB, 0.21231216E-06_JPRB, 0.18936198E-06_JPRB, 0.16733929E-06_JPRB, &
  & 0.14813050E-06_JPRB, 0.13288634E-06_JPRB, 0.12150380E-06_JPRB, 0.11301887E-06_JPRB, 0.10641131E-06_JPRB, 0.10082864E-06_JPRB, &
  & 0.95717880E-07_JPRB, 0.90838256E-07_JPRB, 0.86066507E-07_JPRB, 0.81341142E-07_JPRB, 0.76718450E-07_JPRB, 0.72339368E-07_JPRB, &
  & 0.68345685E-07_JPRB, 0.64919718E-07_JPRB, 0.62188946E-07_JPRB, 0.60218426E-07_JPRB, 0.58875131E-07_JPRB, 0.58026238E-07_JPRB, &
  & 0.57456209E-07_JPRB, 0.57040012E-07_JPRB, 0.56702916E-07_JPRB, 0.56273652E-07_JPRB /)

RGHG2(:,11, 1) = (/ &
  & 0.12735242E-06_JPRB, 0.12230853E-06_JPRB, 0.11817541E-06_JPRB, 0.11714945E-06_JPRB, 0.11685609E-06_JPRB, 0.11861994E-06_JPRB, &
  & 0.12263891E-06_JPRB, 0.12898472E-06_JPRB, 0.13760638E-06_JPRB, 0.14863633E-06_JPRB, 0.16220670E-06_JPRB, 0.17833187E-06_JPRB, &
  & 0.19682693E-06_JPRB, 0.21726581E-06_JPRB, 0.23924167E-06_JPRB, 0.26246468E-06_JPRB, 0.28639172E-06_JPRB, 0.31048987E-06_JPRB, &
  & 0.33428722E-06_JPRB, 0.35740618E-06_JPRB, 0.37931693E-06_JPRB, 0.39949759E-06_JPRB, 0.41771324E-06_JPRB, 0.43340009E-06_JPRB, &
  & 0.44639069E-06_JPRB, 0.45669134E-06_JPRB, 0.46421405E-06_JPRB, 0.46914181E-06_JPRB, 0.47112161E-06_JPRB, 0.46967386E-06_JPRB, &
  & 0.46380842E-06_JPRB, 0.45243030E-06_JPRB, 0.43457882E-06_JPRB, 0.41013897E-06_JPRB, 0.38044476E-06_JPRB, 0.34840599E-06_JPRB, &
  & 0.31720998E-06_JPRB, 0.28834279E-06_JPRB, 0.26142084E-06_JPRB, 0.23606546E-06_JPRB, 0.21151445E-06_JPRB, 0.18757842E-06_JPRB, &
  & 0.16601906E-06_JPRB, 0.14880452E-06_JPRB, 0.13594503E-06_JPRB, 0.12628236E-06_JPRB, 0.11858512E-06_JPRB, 0.11204570E-06_JPRB, &
  & 0.10620049E-06_JPRB, 0.10070025E-06_JPRB, 0.95324850E-07_JPRB, 0.90053270E-07_JPRB, 0.84953520E-07_JPRB, 0.80130889E-07_JPRB, &
  & 0.75783404E-07_JPRB, 0.72102267E-07_JPRB, 0.69250063E-07_JPRB, 0.67206386E-07_JPRB, 0.65892081E-07_JPRB, 0.65019350E-07_JPRB, &
  & 0.64444059E-07_JPRB, 0.64021748E-07_JPRB, 0.63623148E-07_JPRB, 0.63100281E-07_JPRB /)

RGHG2(:,12, 1) = (/ &
  & 0.21590408E-06_JPRB, 0.20270346E-06_JPRB, 0.19392459E-06_JPRB, 0.18938194E-06_JPRB, 0.18660435E-06_JPRB, 0.18640955E-06_JPRB, &
  & 0.18934828E-06_JPRB, 0.19546924E-06_JPRB, 0.20473260E-06_JPRB, 0.21727915E-06_JPRB, 0.23324687E-06_JPRB, 0.25265413E-06_JPRB, &
  & 0.27537928E-06_JPRB, 0.30115220E-06_JPRB, 0.32936009E-06_JPRB, 0.35925925E-06_JPRB, 0.39017789E-06_JPRB, 0.42128249E-06_JPRB, &
  & 0.45174238E-06_JPRB, 0.48086184E-06_JPRB, 0.50808342E-06_JPRB, 0.53255297E-06_JPRB, 0.55394037E-06_JPRB, 0.57180586E-06_JPRB, &
  & 0.58554912E-06_JPRB, 0.59513502E-06_JPRB, 0.59991464E-06_JPRB, 0.59989071E-06_JPRB, 0.59446631E-06_JPRB, 0.58329516E-06_JPRB, &
  & 0.56572861E-06_JPRB, 0.54134341E-06_JPRB, 0.50993958E-06_JPRB, 0.47233831E-06_JPRB, 0.43098549E-06_JPRB, 0.38986769E-06_JPRB, &
  & 0.35224667E-06_JPRB, 0.31945473E-06_JPRB, 0.29089406E-06_JPRB, 0.26493370E-06_JPRB, 0.24038792E-06_JPRB, 0.21733699E-06_JPRB, &
  & 0.19636974E-06_JPRB, 0.17825000E-06_JPRB, 0.16345969E-06_JPRB, 0.15152054E-06_JPRB, 0.14164459E-06_JPRB, 0.13304702E-06_JPRB, &
  & 0.12512538E-06_JPRB, 0.11756903E-06_JPRB, 0.11030643E-06_JPRB, 0.10335243E-06_JPRB, 0.96788710E-07_JPRB, 0.90824649E-07_JPRB, &
  & 0.85656822E-07_JPRB, 0.81473608E-07_JPRB, 0.78329862E-07_JPRB, 0.76194581E-07_JPRB, 0.74776565E-07_JPRB, 0.73896189E-07_JPRB, &
  & 0.73284824E-07_JPRB, 0.72805122E-07_JPRB, 0.72371542E-07_JPRB, 0.71640180E-07_JPRB /)

RGHG2(:,13, 1) = (/ &
  & 0.31234370E-06_JPRB, 0.29368022E-06_JPRB, 0.28351377E-06_JPRB, 0.27688296E-06_JPRB, 0.27309122E-06_JPRB, 0.27227415E-06_JPRB, &
  & 0.27506732E-06_JPRB, 0.28152215E-06_JPRB, 0.29156311E-06_JPRB, 0.30544990E-06_JPRB, 0.32341134E-06_JPRB, 0.34552528E-06_JPRB, &
  & 0.37159452E-06_JPRB, 0.40125246E-06_JPRB, 0.43397037E-06_JPRB, 0.46888377E-06_JPRB, 0.50490502E-06_JPRB, 0.54099689E-06_JPRB, &
  & 0.57611635E-06_JPRB, 0.60930057E-06_JPRB, 0.63978615E-06_JPRB, 0.66677228E-06_JPRB, 0.68970513E-06_JPRB, 0.70812700E-06_JPRB, &
  & 0.72121827E-06_JPRB, 0.72857654E-06_JPRB, 0.72926031E-06_JPRB, 0.72293443E-06_JPRB, 0.70898977E-06_JPRB, 0.68733794E-06_JPRB, &
  & 0.65792807E-06_JPRB, 0.62113486E-06_JPRB, 0.57803925E-06_JPRB, 0.53053901E-06_JPRB, 0.48220795E-06_JPRB, 0.43727496E-06_JPRB, &
  & 0.39861663E-06_JPRB, 0.36666290E-06_JPRB, 0.34008519E-06_JPRB, 0.31711980E-06_JPRB, 0.29640117E-06_JPRB, 0.27708677E-06_JPRB, &
  & 0.25888679E-06_JPRB, 0.24182958E-06_JPRB, 0.22597476E-06_JPRB, 0.21122806E-06_JPRB, 0.19729484E-06_JPRB, 0.18388077E-06_JPRB, &
  & 0.17082871E-06_JPRB, 0.15806916E-06_JPRB, 0.14566390E-06_JPRB, 0.13388437E-06_JPRB, 0.12310248E-06_JPRB, 0.11366833E-06_JPRB, &
  & 0.10585088E-06_JPRB, 0.99767639E-07_JPRB, 0.95363177E-07_JPRB, 0.92345104E-07_JPRB, 0.90429992E-07_JPRB, 0.89141317E-07_JPRB, &
  & 0.88243311E-07_JPRB, 0.87499544E-07_JPRB, 0.86683414E-07_JPRB, 0.85351516E-07_JPRB /)

RGHG2(:,14, 1) = (/ &
  & 0.40679507E-06_JPRB, 0.38682023E-06_JPRB, 0.37781382E-06_JPRB, 0.37247790E-06_JPRB, 0.36991267E-06_JPRB, 0.37033686E-06_JPRB, &
  & 0.37439406E-06_JPRB, 0.38211729E-06_JPRB, 0.39347839E-06_JPRB, 0.40878629E-06_JPRB, 0.42839426E-06_JPRB, 0.45240961E-06_JPRB, &
  & 0.48067562E-06_JPRB, 0.51271456E-06_JPRB, 0.54784795E-06_JPRB, 0.58520192E-06_JPRB, 0.62366883E-06_JPRB, 0.66199948E-06_JPRB, &
  & 0.69905695E-06_JPRB, 0.73376492E-06_JPRB, 0.76518808E-06_JPRB, 0.79247167E-06_JPRB, 0.81505095E-06_JPRB, 0.83216020E-06_JPRB, &
  & 0.84309323E-06_JPRB, 0.84691061E-06_JPRB, 0.84270630E-06_JPRB, 0.82986145E-06_JPRB, 0.80794592E-06_JPRB, 0.77716658E-06_JPRB, &
  & 0.73832535E-06_JPRB, 0.69303968E-06_JPRB, 0.64353372E-06_JPRB, 0.59320274E-06_JPRB, 0.54565930E-06_JPRB, 0.50443623E-06_JPRB, &
  & 0.47170425E-06_JPRB, 0.44649920E-06_JPRB, 0.42697343E-06_JPRB, 0.41112904E-06_JPRB, 0.39727811E-06_JPRB, 0.38411810E-06_JPRB, &
  & 0.37066161E-06_JPRB, 0.35624151E-06_JPRB, 0.34049827E-06_JPRB, 0.32341418E-06_JPRB, 0.30508068E-06_JPRB, 0.28554669E-06_JPRB, &
  & 0.26493396E-06_JPRB, 0.24355722E-06_JPRB, 0.22203454E-06_JPRB, 0.20121010E-06_JPRB, 0.18192306E-06_JPRB, 0.16499396E-06_JPRB, &
  & 0.15093678E-06_JPRB, 0.13990891E-06_JPRB, 0.13171734E-06_JPRB, 0.12595315E-06_JPRB, 0.12199689E-06_JPRB, 0.11933160E-06_JPRB, &
  & 0.11731581E-06_JPRB, 0.11560803E-06_JPRB, 0.11377770E-06_JPRB, 0.11057787E-06_JPRB /)

RGHG2(:,15, 1) = (/ &
  & 0.49438324E-06_JPRB, 0.47950704E-06_JPRB, 0.47345924E-06_JPRB, 0.47059652E-06_JPRB, 0.47051270E-06_JPRB, 0.47352128E-06_JPRB, &
  & 0.48024469E-06_JPRB, 0.49060264E-06_JPRB, 0.50445385E-06_JPRB, 0.52198078E-06_JPRB, 0.54342615E-06_JPRB, 0.56884687E-06_JPRB, &
  & 0.59809645E-06_JPRB, 0.63079540E-06_JPRB, 0.66631156E-06_JPRB, 0.70378292E-06_JPRB, 0.74214279E-06_JPRB, 0.78019968E-06_JPRB, &
  & 0.81675125E-06_JPRB, 0.85066335E-06_JPRB, 0.88092412E-06_JPRB, 0.90662047E-06_JPRB, 0.92708427E-06_JPRB, 0.94142740E-06_JPRB, &
  & 0.94885877E-06_JPRB, 0.94828272E-06_JPRB, 0.93882682E-06_JPRB, 0.91982599E-06_JPRB, 0.89129355E-06_JPRB, 0.85410738E-06_JPRB, &
  & 0.80977253E-06_JPRB, 0.76106232E-06_JPRB, 0.71147326E-06_JPRB, 0.66457250E-06_JPRB, 0.62460356E-06_JPRB, 0.59424201E-06_JPRB, &
  & 0.57333705E-06_JPRB, 0.55993843E-06_JPRB, 0.55095876E-06_JPRB, 0.54411737E-06_JPRB, 0.53758441E-06_JPRB, 0.52988349E-06_JPRB, &
  & 0.52009386E-06_JPRB, 0.50771405E-06_JPRB, 0.49249945E-06_JPRB, 0.47443302E-06_JPRB, 0.45350635E-06_JPRB, 0.42971681E-06_JPRB, &
  & 0.40320197E-06_JPRB, 0.37437880E-06_JPRB, 0.34400617E-06_JPRB, 0.31342054E-06_JPRB, 0.28395934E-06_JPRB, 0.25715576E-06_JPRB, &
  & 0.23392937E-06_JPRB, 0.21483162E-06_JPRB, 0.19978978E-06_JPRB, 0.18847328E-06_JPRB, 0.18024124E-06_JPRB, 0.17423744E-06_JPRB, &
  & 0.16976307E-06_JPRB, 0.16576281E-06_JPRB, 0.16169618E-06_JPRB, 0.15446084E-06_JPRB /)

RGHG2(:,16, 1) = (/ &
  & 0.57578899E-06_JPRB, 0.56718272E-06_JPRB, 0.56501551E-06_JPRB, 0.56596224E-06_JPRB, 0.56984499E-06_JPRB, 0.57694780E-06_JPRB, &
  & 0.58766983E-06_JPRB, 0.60181696E-06_JPRB, 0.61898754E-06_JPRB, 0.63924682E-06_JPRB, 0.66269644E-06_JPRB, 0.68932064E-06_JPRB, &
  & 0.71898455E-06_JPRB, 0.75136734E-06_JPRB, 0.78596906E-06_JPRB, 0.82204372E-06_JPRB, 0.85863365E-06_JPRB, 0.89464459E-06_JPRB, &
  & 0.92889445E-06_JPRB, 0.96031715E-06_JPRB, 0.98779242E-06_JPRB, 0.10104426E-05_JPRB, 0.10273935E-05_JPRB, 0.10377928E-05_JPRB, &
  & 0.10407794E-05_JPRB, 0.10353317E-05_JPRB, 0.10207003E-05_JPRB, 0.99662395E-06_JPRB, 0.96356894E-06_JPRB, 0.92302923E-06_JPRB, &
  & 0.87787038E-06_JPRB, 0.83132448E-06_JPRB, 0.78709741E-06_JPRB, 0.74981938E-06_JPRB, 0.72218808E-06_JPRB, 0.70561759E-06_JPRB, &
  & 0.69840792E-06_JPRB, 0.69708557E-06_JPRB, 0.69820010E-06_JPRB, 0.69897862E-06_JPRB, 0.69749240E-06_JPRB, 0.69287813E-06_JPRB, &
  & 0.68473895E-06_JPRB, 0.67294462E-06_JPRB, 0.65759161E-06_JPRB, 0.63882595E-06_JPRB, 0.61660336E-06_JPRB, 0.59073363E-06_JPRB, &
  & 0.56114879E-06_JPRB, 0.52810356E-06_JPRB, 0.49245091E-06_JPRB, 0.45546028E-06_JPRB, 0.41876345E-06_JPRB, 0.38392560E-06_JPRB, &
  & 0.35243227E-06_JPRB, 0.32519202E-06_JPRB, 0.30254114E-06_JPRB, 0.28426419E-06_JPRB, 0.27007815E-06_JPRB, 0.25926607E-06_JPRB, &
  & 0.25047819E-06_JPRB, 0.24315983E-06_JPRB, 0.23484988E-06_JPRB, 0.22199025E-06_JPRB /)

RGHG2(:,17, 1) = (/ &
  & 0.65157252E-06_JPRB, 0.65076955E-06_JPRB, 0.65330511E-06_JPRB, 0.65838208E-06_JPRB, 0.66635187E-06_JPRB, 0.67754081E-06_JPRB, &
  & 0.69234909E-06_JPRB, 0.71032980E-06_JPRB, 0.73102558E-06_JPRB, 0.75424521E-06_JPRB, 0.77992348E-06_JPRB, 0.80787703E-06_JPRB, &
  & 0.83792014E-06_JPRB, 0.86981100E-06_JPRB, 0.90308799E-06_JPRB, 0.93715425E-06_JPRB, 0.97120801E-06_JPRB, 0.10042148E-05_JPRB, &
  & 0.10351973E-05_JPRB, 0.10630567E-05_JPRB, 0.10866554E-05_JPRB, 0.11051820E-05_JPRB, 0.11176561E-05_JPRB, 0.11233105E-05_JPRB, &
  & 0.11213587E-05_JPRB, 0.11110781E-05_JPRB, 0.10921776E-05_JPRB, 0.10648507E-05_JPRB, 0.10304339E-05_JPRB, 0.99105398E-06_JPRB, &
  & 0.94979680E-06_JPRB, 0.91017540E-06_JPRB, 0.87634248E-06_JPRB, 0.85117375E-06_JPRB, 0.83704919E-06_JPRB, 0.83331810E-06_JPRB, &
  & 0.83779781E-06_JPRB, 0.84612043E-06_JPRB, 0.85425251E-06_JPRB, 0.85943918E-06_JPRB, 0.86051085E-06_JPRB, 0.85684474E-06_JPRB, &
  & 0.84843384E-06_JPRB, 0.83576430E-06_JPRB, 0.81939902E-06_JPRB, 0.79960421E-06_JPRB, 0.77633911E-06_JPRB, 0.74932404E-06_JPRB, &
  & 0.71831863E-06_JPRB, 0.68349817E-06_JPRB, 0.64554786E-06_JPRB, 0.60569482E-06_JPRB, 0.56534265E-06_JPRB, 0.52619816E-06_JPRB, &
  & 0.48975966E-06_JPRB, 0.45721458E-06_JPRB, 0.42904048E-06_JPRB, 0.40525873E-06_JPRB, 0.38560503E-06_JPRB, 0.36953807E-06_JPRB, &
  & 0.35656544E-06_JPRB, 0.34438690E-06_JPRB, 0.33223535E-06_JPRB, 0.31047261E-06_JPRB /)

RGHG2(:,18, 1) = (/ &
  & 0.72277874E-06_JPRB, 0.72853248E-06_JPRB, 0.73508278E-06_JPRB, 0.74382740E-06_JPRB, 0.75547791E-06_JPRB, 0.77051146E-06_JPRB, &
  & 0.78910040E-06_JPRB, 0.81081276E-06_JPRB, 0.83487771E-06_JPRB, 0.86098271E-06_JPRB, 0.88889777E-06_JPRB, 0.91828110E-06_JPRB, &
  & 0.94884018E-06_JPRB, 0.98036651E-06_JPRB, 0.10124235E-05_JPRB, 0.10445032E-05_JPRB, 0.10759876E-05_JPRB, 0.11058280E-05_JPRB, &
  & 0.11332176E-05_JPRB, 0.11571605E-05_JPRB, 0.11764763E-05_JPRB, 0.11903876E-05_JPRB, 0.11980339E-05_JPRB, 0.11987588E-05_JPRB, &
  & 0.11920831E-05_JPRB, 0.11778272E-05_JPRB, 0.11562574E-05_JPRB, 0.11284887E-05_JPRB, 0.10961211E-05_JPRB, 0.10622832E-05_JPRB, &
  & 0.10292947E-05_JPRB, 0.10008182E-05_JPRB, 0.97952670E-06_JPRB, 0.96733061E-06_JPRB, 0.96453471E-06_JPRB, 0.97071211E-06_JPRB, &
  & 0.98235739E-06_JPRB, 0.99550255E-06_JPRB, 0.10063270E-05_JPRB, 0.10126874E-05_JPRB, 0.10133676E-05_JPRB, 0.10083176E-05_JPRB, &
  & 0.99831186E-06_JPRB, 0.98412693E-06_JPRB, 0.96643339E-06_JPRB, 0.94559323E-06_JPRB, 0.92155494E-06_JPRB, 0.89398264E-06_JPRB, &
  & 0.86262406E-06_JPRB, 0.82756310E-06_JPRB, 0.78940883E-06_JPRB, 0.74914215E-06_JPRB, 0.70805532E-06_JPRB, 0.66758804E-06_JPRB, &
  & 0.62935078E-06_JPRB, 0.59453413E-06_JPRB, 0.56364422E-06_JPRB, 0.53661057E-06_JPRB, 0.51325867E-06_JPRB, 0.49345931E-06_JPRB, &
  & 0.47609683E-06_JPRB, 0.46047845E-06_JPRB, 0.44315314E-06_JPRB, 0.41446589E-06_JPRB /)

RGHG2(:,19, 1) = (/ &
  & 0.78963177E-06_JPRB, 0.80048648E-06_JPRB, 0.81022239E-06_JPRB, 0.82187989E-06_JPRB, 0.83649007E-06_JPRB, 0.85452996E-06_JPRB, &
  & 0.87618946E-06_JPRB, 0.90080408E-06_JPRB, 0.92758921E-06_JPRB, 0.95602240E-06_JPRB, 0.98570808E-06_JPRB, 0.10162764E-05_JPRB, &
  & 0.10473000E-05_JPRB, 0.10785230E-05_JPRB, 0.11095715E-05_JPRB, 0.11398741E-05_JPRB, 0.11690178E-05_JPRB, 0.11960414E-05_JPRB, &
  & 0.12200396E-05_JPRB, 0.12402134E-05_JPRB, 0.12555090E-05_JPRB, 0.12650983E-05_JPRB, 0.12683465E-05_JPRB, 0.12648126E-05_JPRB, &
  & 0.12544690E-05_JPRB, 0.12377519E-05_JPRB, 0.12157244E-05_JPRB, 0.11901043E-05_JPRB, 0.11636118E-05_JPRB, 0.11380351E-05_JPRB, &
  & 0.11169104E-05_JPRB, 0.11012839E-05_JPRB, 0.10925799E-05_JPRB, 0.10913631E-05_JPRB, 0.10972157E-05_JPRB, 0.11084035E-05_JPRB, &
  & 0.11224407E-05_JPRB, 0.11356767E-05_JPRB, 0.11451206E-05_JPRB, 0.11491844E-05_JPRB, 0.11475770E-05_JPRB, 0.11404715E-05_JPRB, &
  & 0.11285123E-05_JPRB, 0.11126372E-05_JPRB, 0.10936661E-05_JPRB, 0.10719142E-05_JPRB, 0.10473274E-05_JPRB, 0.10196386E-05_JPRB, &
  & 0.98865905E-06_JPRB, 0.95448502E-06_JPRB, 0.91760660E-06_JPRB, 0.87886792E-06_JPRB, 0.83927239E-06_JPRB, 0.80014229E-06_JPRB, &
  & 0.76287415E-06_JPRB, 0.72854351E-06_JPRB, 0.69751036E-06_JPRB, 0.66966163E-06_JPRB, 0.64476035E-06_JPRB, 0.62247489E-06_JPRB, &
  & 0.60244884E-06_JPRB, 0.58343647E-06_JPRB, 0.56200776E-06_JPRB, 0.52710453E-06_JPRB /)

RGHG2(:,20, 1) = (/ &
  & 0.85183552E-06_JPRB, 0.86723816E-06_JPRB, 0.87936377E-06_JPRB, 0.89302017E-06_JPRB, 0.90954131E-06_JPRB, 0.92949278E-06_JPRB, &
  & 0.95295633E-06_JPRB, 0.97938812E-06_JPRB, 0.10078627E-05_JPRB, 0.10377197E-05_JPRB, 0.10685435E-05_JPRB, 0.10997446E-05_JPRB, &
  & 0.11309585E-05_JPRB, 0.11617876E-05_JPRB, 0.11919439E-05_JPRB, 0.12208079E-05_JPRB, 0.12478987E-05_JPRB, 0.12725704E-05_JPRB, &
  & 0.12938433E-05_JPRB, 0.13109192E-05_JPRB, 0.13229338E-05_JPRB, 0.13291553E-05_JPRB, 0.13291158E-05_JPRB, 0.13227150E-05_JPRB, &
  & 0.13103854E-05_JPRB, 0.12932453E-05_JPRB, 0.12731263E-05_JPRB, 0.12523024E-05_JPRB, 0.12328958E-05_JPRB, 0.12180018E-05_JPRB, &
  & 0.12081407E-05_JPRB, 0.12043332E-05_JPRB, 0.12063094E-05_JPRB, 0.12129792E-05_JPRB, 0.12235946E-05_JPRB, 0.12364708E-05_JPRB, &
  & 0.12492693E-05_JPRB, 0.12597301E-05_JPRB, 0.12659652E-05_JPRB, 0.12665748E-05_JPRB, 0.12615767E-05_JPRB, 0.12515868E-05_JPRB, &
  & 0.12376499E-05_JPRB, 0.12204143E-05_JPRB, 0.12004712E-05_JPRB, 0.11780430E-05_JPRB, 0.11532477E-05_JPRB, 0.11259066E-05_JPRB, &
  & 0.10959576E-05_JPRB, 0.10635200E-05_JPRB, 0.10290282E-05_JPRB, 0.99314275E-06_JPRB, 0.95669725E-06_JPRB, 0.92077391E-06_JPRB, &
  & 0.88650080E-06_JPRB, 0.85466024E-06_JPRB, 0.82550883E-06_JPRB, 0.79875451E-06_JPRB, 0.77413665E-06_JPRB, 0.75139673E-06_JPRB, &
  & 0.73017372E-06_JPRB, 0.70867873E-06_JPRB, 0.68583932E-06_JPRB, 0.64300150E-06_JPRB /)

RGHG2(:,21, 1) = (/ &
  & 0.90637764E-06_JPRB, 0.92631092E-06_JPRB, 0.94063853E-06_JPRB, 0.95588734E-06_JPRB, 0.97375766E-06_JPRB, 0.99488875E-06_JPRB, &
  & 0.10194153E-05_JPRB, 0.10467065E-05_JPRB, 0.10759553E-05_JPRB, 0.11065067E-05_JPRB, 0.11376993E-05_JPRB, 0.11690599E-05_JPRB, &
  & 0.12000806E-05_JPRB, 0.12304010E-05_JPRB, 0.12596496E-05_JPRB, 0.12873384E-05_JPRB, 0.13128905E-05_JPRB, 0.13357051E-05_JPRB, &
  & 0.13550011E-05_JPRB, 0.13699448E-05_JPRB, 0.13797832E-05_JPRB, 0.13839452E-05_JPRB, 0.13821674E-05_JPRB, 0.13746555E-05_JPRB, &
  & 0.13623203E-05_JPRB, 0.13467485E-05_JPRB, 0.13301144E-05_JPRB, 0.13147529E-05_JPRB, 0.13035171E-05_JPRB, 0.12973522E-05_JPRB, &
  & 0.12970847E-05_JPRB, 0.13018849E-05_JPRB, 0.13105064E-05_JPRB, 0.13217089E-05_JPRB, 0.13339146E-05_JPRB, 0.13457191E-05_JPRB, &
  & 0.13557806E-05_JPRB, 0.13624506E-05_JPRB, 0.13644956E-05_JPRB, 0.13615459E-05_JPRB, 0.13538915E-05_JPRB, 0.13420915E-05_JPRB, &
  & 0.13268429E-05_JPRB, 0.13087102E-05_JPRB, 0.12882597E-05_JPRB, 0.12656274E-05_JPRB, 0.12411966E-05_JPRB, 0.12148073E-05_JPRB, &
  & 0.11865535E-05_JPRB, 0.11565575E-05_JPRB, 0.11252262E-05_JPRB, 0.10930852E-05_JPRB, 0.10608119E-05_JPRB, 0.10292335E-05_JPRB, &
  & 0.99904832E-06_JPRB, 0.97081067E-06_JPRB, 0.94455277E-06_JPRB, 0.92006417E-06_JPRB, 0.89697562E-06_JPRB, 0.87497244E-06_JPRB, &
  & 0.85341520E-06_JPRB, 0.83214991E-06_JPRB, 0.80556885E-06_JPRB, 0.76255492E-06_JPRB /)

RGHG2(:,22, 1) = (/ &
  & 0.96204030E-06_JPRB, 0.98182090E-06_JPRB, 0.99647707E-06_JPRB, 0.10121946E-05_JPRB, 0.10304950E-05_JPRB, 0.10520157E-05_JPRB, &
  & 0.10767615E-05_JPRB, 0.11041983E-05_JPRB, 0.11335004E-05_JPRB, 0.11639316E-05_JPRB, 0.11950096E-05_JPRB, 0.12259958E-05_JPRB, &
  & 0.12565048E-05_JPRB, 0.12861315E-05_JPRB, 0.13145386E-05_JPRB, 0.13412608E-05_JPRB, 0.13657019E-05_JPRB, 0.13872682E-05_JPRB, &
  & 0.14053127E-05_JPRB, 0.14191430E-05_JPRB, 0.14280826E-05_JPRB, 0.14316449E-05_JPRB, 0.14297948E-05_JPRB, 0.14230206E-05_JPRB, &
  & 0.14124146E-05_JPRB, 0.13999606E-05_JPRB, 0.13876539E-05_JPRB, 0.13780962E-05_JPRB, 0.13728885E-05_JPRB, 0.13733389E-05_JPRB, &
  & 0.13788958E-05_JPRB, 0.13882629E-05_JPRB, 0.13998402E-05_JPRB, 0.14121072E-05_JPRB, 0.14236880E-05_JPRB, 0.14334845E-05_JPRB, &
  & 0.14404754E-05_JPRB, 0.14436596E-05_JPRB, 0.14425345E-05_JPRB, 0.14369391E-05_JPRB, 0.14272935E-05_JPRB, 0.14142131E-05_JPRB, &
  & 0.13983487E-05_JPRB, 0.13800623E-05_JPRB, 0.13597264E-05_JPRB, 0.13376085E-05_JPRB, 0.13140691E-05_JPRB, 0.12892328E-05_JPRB, &
  & 0.12631552E-05_JPRB, 0.12361038E-05_JPRB, 0.12083934E-05_JPRB, 0.11804811E-05_JPRB, 0.11528434E-05_JPRB, 0.11258976E-05_JPRB, &
  & 0.11001055E-05_JPRB, 0.10757107E-05_JPRB, 0.10527300E-05_JPRB, 0.10308163E-05_JPRB, 0.10096879E-05_JPRB, 0.98899886E-06_JPRB, &
  & 0.96848726E-06_JPRB, 0.94639859E-06_JPRB, 0.92199087E-06_JPRB, 0.87489872E-06_JPRB /)

RGHG2(:,23, 1) = (/ &
  & 0.10108498E-05_JPRB, 0.10323442E-05_JPRB, 0.10472488E-05_JPRB, 0.10628798E-05_JPRB, 0.10810036E-05_JPRB, 0.11021887E-05_JPRB, &
  & 0.11265405E-05_JPRB, 0.11534687E-05_JPRB, 0.11821977E-05_JPRB, 0.12120845E-05_JPRB, 0.12424537E-05_JPRB, 0.12727727E-05_JPRB, &
  & 0.13025153E-05_JPRB, 0.13312927E-05_JPRB, 0.13587672E-05_JPRB, 0.13845971E-05_JPRB, 0.14083175E-05_JPRB, 0.14293366E-05_JPRB, &
  & 0.14469996E-05_JPRB, 0.14606717E-05_JPRB, 0.14698264E-05_JPRB, 0.14741986E-05_JPRB, 0.14738525E-05_JPRB, 0.14693379E-05_JPRB, &
  & 0.14620304E-05_JPRB, 0.14534784E-05_JPRB, 0.14456506E-05_JPRB, 0.14404900E-05_JPRB, 0.14396176E-05_JPRB, 0.14434022E-05_JPRB, &
  & 0.14511568E-05_JPRB, 0.14614569E-05_JPRB, 0.14729570E-05_JPRB, 0.14841044E-05_JPRB, 0.14937440E-05_JPRB, 0.15010035E-05_JPRB, &
  & 0.15052387E-05_JPRB, 0.15056905E-05_JPRB, 0.15022904E-05_JPRB, 0.14950408E-05_JPRB, 0.14844748E-05_JPRB, 0.14710884E-05_JPRB, &
  & 0.14553107E-05_JPRB, 0.14374727E-05_JPRB, 0.14178358E-05_JPRB, 0.13967551E-05_JPRB, 0.13746583E-05_JPRB, 0.13517711E-05_JPRB, &
  & 0.13282244E-05_JPRB, 0.13043290E-05_JPRB, 0.12803736E-05_JPRB, 0.12566718E-05_JPRB, 0.12334360E-05_JPRB, 0.12109173E-05_JPRB, &
  & 0.11892546E-05_JPRB, 0.11685502E-05_JPRB, 0.11486237E-05_JPRB, 0.11292721E-05_JPRB, 0.11101587E-05_JPRB, 0.10909642E-05_JPRB, &
  & 0.10712580E-05_JPRB, 0.10507466E-05_JPRB, 0.10251293E-05_JPRB, 0.98036583E-06_JPRB /)

RGHG2(:,24, 1) = (/ &
  & 0.10577099E-05_JPRB, 0.10788926E-05_JPRB, 0.10936288E-05_JPRB, 0.11089529E-05_JPRB, 0.11265312E-05_JPRB, 0.11470357E-05_JPRB, &
  & 0.11704732E-05_JPRB, 0.11964211E-05_JPRB, 0.12241702E-05_JPRB, 0.12529943E-05_JPRB, 0.12823847E-05_JPRB, 0.13116703E-05_JPRB, &
  & 0.13404556E-05_JPRB, 0.13683745E-05_JPRB, 0.13951123E-05_JPRB, 0.14202271E-05_JPRB, 0.14433097E-05_JPRB, 0.14639240E-05_JPRB, &
  & 0.14815917E-05_JPRB, 0.14958339E-05_JPRB, 0.15062113E-05_JPRB, 0.15124492E-05_JPRB, 0.15146456E-05_JPRB, 0.15135672E-05_JPRB, &
  & 0.15101471E-05_JPRB, 0.15057374E-05_JPRB, 0.15018659E-05_JPRB, 0.14999906E-05_JPRB, 0.15012200E-05_JPRB, 0.15057292E-05_JPRB, &
  & 0.15129920E-05_JPRB, 0.15220575E-05_JPRB, 0.15315147E-05_JPRB, 0.15402953E-05_JPRB, 0.15473729E-05_JPRB, 0.15521343E-05_JPRB, &
  & 0.15539927E-05_JPRB, 0.15524796E-05_JPRB, 0.15476663E-05_JPRB, 0.15397034E-05_JPRB, 0.15289368E-05_JPRB, 0.15158529E-05_JPRB, &
  & 0.15007211E-05_JPRB, 0.14837799E-05_JPRB, 0.14652908E-05_JPRB, 0.14456231E-05_JPRB, 0.14252632E-05_JPRB, 0.14045356E-05_JPRB, &
  & 0.13836247E-05_JPRB, 0.13628392E-05_JPRB, 0.13423776E-05_JPRB, 0.13224378E-05_JPRB, 0.13031269E-05_JPRB, 0.12844678E-05_JPRB, &
  & 0.12664482E-05_JPRB, 0.12489315E-05_JPRB, 0.12318051E-05_JPRB, 0.12147145E-05_JPRB, 0.11974231E-05_JPRB, 0.11796404E-05_JPRB, &
  & 0.11610967E-05_JPRB, 0.11409670E-05_JPRB, 0.11170837E-05_JPRB, 0.10730554E-05_JPRB /)

RGHG2(:,25, 1) = (/ &
  & 0.11014355E-05_JPRB, 0.11223050E-05_JPRB, 0.11366516E-05_JPRB, 0.11514040E-05_JPRB, 0.11682602E-05_JPRB, 0.11878035E-05_JPRB, &
  & 0.12101009E-05_JPRB, 0.12347248E-05_JPRB, 0.12610672E-05_JPRB, 0.12885420E-05_JPRB, 0.13165369E-05_JPRB, 0.13445197E-05_JPRB, &
  & 0.13720247E-05_JPRB, 0.13987039E-05_JPRB, 0.14243328E-05_JPRB, 0.14486756E-05_JPRB, 0.14713896E-05_JPRB, 0.14920838E-05_JPRB, &
  & 0.15103111E-05_JPRB, 0.15255926E-05_JPRB, 0.15375485E-05_JPRB, 0.15460594E-05_JPRB, 0.15513361E-05_JPRB, 0.15538768E-05_JPRB, &
  & 0.15543143E-05_JPRB, 0.15537237E-05_JPRB, 0.15530077E-05_JPRB, 0.15531683E-05_JPRB, 0.15551370E-05_JPRB, 0.15589883E-05_JPRB, &
  & 0.15646053E-05_JPRB, 0.15711771E-05_JPRB, 0.15779293E-05_JPRB, 0.15839557E-05_JPRB, 0.15884666E-05_JPRB, 0.15909769E-05_JPRB, &
  & 0.15909161E-05_JPRB, 0.15880571E-05_JPRB, 0.15824482E-05_JPRB, 0.15743091E-05_JPRB, 0.15639037E-05_JPRB, 0.15515329E-05_JPRB, &
  & 0.15374251E-05_JPRB, 0.15216981E-05_JPRB, 0.15046038E-05_JPRB, 0.14865469E-05_JPRB, 0.14680331E-05_JPRB, 0.14494045E-05_JPRB, &
  & 0.14309506E-05_JPRB, 0.14129109E-05_JPRB, 0.13954725E-05_JPRB, 0.13787237E-05_JPRB, 0.13626745E-05_JPRB, 0.13472184E-05_JPRB, &
  & 0.13321880E-05_JPRB, 0.13174524E-05_JPRB, 0.13026912E-05_JPRB, 0.12876872E-05_JPRB, 0.12720902E-05_JPRB, 0.12556472E-05_JPRB, &
  & 0.12382284E-05_JPRB, 0.12191817E-05_JPRB, 0.11966142E-05_JPRB, 0.11537908E-05_JPRB /)

RGHG2(:,26, 1) = (/ &
  & 0.11432745E-05_JPRB, 0.11634675E-05_JPRB, 0.11772559E-05_JPRB, 0.11913141E-05_JPRB, 0.12072708E-05_JPRB, 0.12257256E-05_JPRB, &
  & 0.12467008E-05_JPRB, 0.12697988E-05_JPRB, 0.12944993E-05_JPRB, 0.13203023E-05_JPRB, 0.13466960E-05_JPRB, 0.13731831E-05_JPRB, &
  & 0.13993667E-05_JPRB, 0.14249895E-05_JPRB, 0.14497324E-05_JPRB, 0.14733358E-05_JPRB, 0.14955360E-05_JPRB, 0.15160044E-05_JPRB, &
  & 0.15343917E-05_JPRB, 0.15503930E-05_JPRB, 0.15637895E-05_JPRB, 0.15744710E-05_JPRB, 0.15825287E-05_JPRB, 0.15882516E-05_JPRB, &
  & 0.15920350E-05_JPRB, 0.15944743E-05_JPRB, 0.15962030E-05_JPRB, 0.15979006E-05_JPRB, 0.15999668E-05_JPRB, 0.16028130E-05_JPRB, &
  & 0.16064198E-05_JPRB, 0.16104825E-05_JPRB, 0.16146088E-05_JPRB, 0.16180466E-05_JPRB, 0.16203171E-05_JPRB, 0.16209301E-05_JPRB, &
  & 0.16194241E-05_JPRB, 0.16156988E-05_JPRB, 0.16097777E-05_JPRB, 0.16018587E-05_JPRB, 0.15921212E-05_JPRB, 0.15807101E-05_JPRB, &
  & 0.15677781E-05_JPRB, 0.15534117E-05_JPRB, 0.15378150E-05_JPRB, 0.15213728E-05_JPRB, 0.15045998E-05_JPRB, 0.14878298E-05_JPRB, &
  & 0.14715200E-05_JPRB, 0.14557908E-05_JPRB, 0.14408413E-05_JPRB, 0.14266574E-05_JPRB, 0.14131667E-05_JPRB, 0.14002420E-05_JPRB, &
  & 0.13876661E-05_JPRB, 0.13752009E-05_JPRB, 0.13626128E-05_JPRB, 0.13494860E-05_JPRB, 0.13355810E-05_JPRB, 0.13206156E-05_JPRB, &
  & 0.13043355E-05_JPRB, 0.12867926E-05_JPRB, 0.12645557E-05_JPRB, 0.12249491E-05_JPRB /)

RGHG2(:,27, 1) = (/ &
  & 0.11836410E-05_JPRB, 0.12032398E-05_JPRB, 0.12163356E-05_JPRB, 0.12296202E-05_JPRB, 0.12445844E-05_JPRB, 0.12618145E-05_JPRB, &
  & 0.12813077E-05_JPRB, 0.13027137E-05_JPRB, 0.13255194E-05_JPRB, 0.13493775E-05_JPRB, 0.13738492E-05_JPRB, 0.13985235E-05_JPRB, &
  & 0.14230467E-05_JPRB, 0.14471208E-05_JPRB, 0.14706122E-05_JPRB, 0.14932800E-05_JPRB, 0.15148593E-05_JPRB, 0.15350838E-05_JPRB, &
  & 0.15536924E-05_JPRB, 0.15704101E-05_JPRB, 0.15850197E-05_JPRB, 0.15973983E-05_JPRB, 0.16075993E-05_JPRB, 0.16157547E-05_JPRB, &
  & 0.16220989E-05_JPRB, 0.16268651E-05_JPRB, 0.16304085E-05_JPRB, 0.16330862E-05_JPRB, 0.16352677E-05_JPRB, 0.16373428E-05_JPRB, &
  & 0.16394617E-05_JPRB, 0.16415457E-05_JPRB, 0.16435444E-05_JPRB, 0.16448971E-05_JPRB, 0.16453696E-05_JPRB, 0.16445197E-05_JPRB, &
  & 0.16420147E-05_JPRB, 0.16378204E-05_JPRB, 0.16319319E-05_JPRB, 0.16244702E-05_JPRB, 0.16155476E-05_JPRB, 0.16052282E-05_JPRB, &
  & 0.15935506E-05_JPRB, 0.15805664E-05_JPRB, 0.15664347E-05_JPRB, 0.15514695E-05_JPRB, 0.15361609E-05_JPRB, 0.15210512E-05_JPRB, &
  & 0.15064735E-05_JPRB, 0.14926451E-05_JPRB, 0.14796353E-05_JPRB, 0.14674299E-05_JPRB, 0.14559237E-05_JPRB, 0.14449604E-05_JPRB, &
  & 0.14343128E-05_JPRB, 0.14237733E-05_JPRB, 0.14129802E-05_JPRB, 0.14016587E-05_JPRB, 0.13894116E-05_JPRB, 0.13759975E-05_JPRB, &
  & 0.13614016E-05_JPRB, 0.13448569E-05_JPRB, 0.13255466E-05_JPRB, 0.12873990E-05_JPRB /)

RGHG2(:,28, 1) = (/ &
  & 0.12232567E-05_JPRB, 0.12420933E-05_JPRB, 0.12545544E-05_JPRB, 0.12669378E-05_JPRB, 0.12808425E-05_JPRB, 0.12967428E-05_JPRB, &
  & 0.13146646E-05_JPRB, 0.13342138E-05_JPRB, 0.13549931E-05_JPRB, 0.13767576E-05_JPRB, 0.13991338E-05_JPRB, 0.14219052E-05_JPRB, &
  & 0.14447037E-05_JPRB, 0.14673199E-05_JPRB, 0.14895222E-05_JPRB, 0.15111025E-05_JPRB, 0.15318616E-05_JPRB, 0.15515848E-05_JPRB, &
  & 0.15700261E-05_JPRB, 0.15869371E-05_JPRB, 0.16021355E-05_JPRB, 0.16155205E-05_JPRB, 0.16271126E-05_JPRB, 0.16369399E-05_JPRB, &
  & 0.16450693E-05_JPRB, 0.16515050E-05_JPRB, 0.16564120E-05_JPRB, 0.16599356E-05_JPRB, 0.16623752E-05_JPRB, 0.16640499E-05_JPRB, &
  & 0.16652234E-05_JPRB, 0.16659769E-05_JPRB, 0.16664465E-05_JPRB, 0.16662965E-05_JPRB, 0.16654378E-05_JPRB, 0.16635595E-05_JPRB, &
  & 0.16604387E-05_JPRB, 0.16560581E-05_JPRB, 0.16504122E-05_JPRB, 0.16435633E-05_JPRB, 0.16355314E-05_JPRB, 0.16263245E-05_JPRB, &
  & 0.16158855E-05_JPRB, 0.16042209E-05_JPRB, 0.15914063E-05_JPRB, 0.15777493E-05_JPRB, 0.15637929E-05_JPRB, 0.15500051E-05_JPRB, &
  & 0.15368425E-05_JPRB, 0.15244719E-05_JPRB, 0.15129663E-05_JPRB, 0.15022989E-05_JPRB, 0.14922960E-05_JPRB, 0.14828436E-05_JPRB, &
  & 0.14737017E-05_JPRB, 0.14646463E-05_JPRB, 0.14554058E-05_JPRB, 0.14455986E-05_JPRB, 0.14349622E-05_JPRB, 0.14232197E-05_JPRB, &
  & 0.14102422E-05_JPRB, 0.13960739E-05_JPRB, 0.13780001E-05_JPRB, 0.13442649E-05_JPRB /)

RGHG2(:,29, 1) = (/ &
  & 0.12624334E-05_JPRB, 0.12805320E-05_JPRB, 0.12921272E-05_JPRB, 0.13036397E-05_JPRB, 0.13163457E-05_JPRB, 0.13308650E-05_JPRB, &
  & 0.13470927E-05_JPRB, 0.13647322E-05_JPRB, 0.13833973E-05_JPRB, 0.14029306E-05_JPRB, 0.14231505E-05_JPRB, 0.14438837E-05_JPRB, &
  & 0.14648672E-05_JPRB, 0.14858608E-05_JPRB, 0.15066902E-05_JPRB, 0.15271544E-05_JPRB, 0.15470443E-05_JPRB, 0.15661109E-05_JPRB, &
  & 0.15841146E-05_JPRB, 0.16008436E-05_JPRB, 0.16161606E-05_JPRB, 0.16299953E-05_JPRB, 0.16423512E-05_JPRB, 0.16531884E-05_JPRB, &
  & 0.16624424E-05_JPRB, 0.16700044E-05_JPRB, 0.16758596E-05_JPRB, 0.16800974E-05_JPRB, 0.16828780E-05_JPRB, 0.16844888E-05_JPRB, &
  & 0.16852154E-05_JPRB, 0.16852219E-05_JPRB, 0.16847147E-05_JPRB, 0.16835863E-05_JPRB, 0.16818243E-05_JPRB, 0.16793027E-05_JPRB, &
  & 0.16758624E-05_JPRB, 0.16715175E-05_JPRB, 0.16662543E-05_JPRB, 0.16600925E-05_JPRB, 0.16529679E-05_JPRB, 0.16448082E-05_JPRB, &
  & 0.16355172E-05_JPRB, 0.16250297E-05_JPRB, 0.16134138E-05_JPRB, 0.16009461E-05_JPRB, 0.15880915E-05_JPRB, 0.15754586E-05_JPRB, &
  & 0.15633859E-05_JPRB, 0.15521858E-05_JPRB, 0.15418582E-05_JPRB, 0.15323378E-05_JPRB, 0.15234976E-05_JPRB, 0.15151516E-05_JPRB, &
  & 0.15071388E-05_JPRB, 0.14992294E-05_JPRB, 0.14911428E-05_JPRB, 0.14826051E-05_JPRB, 0.14732976E-05_JPRB, 0.14630797E-05_JPRB, &
  & 0.14519029E-05_JPRB, 0.14394832E-05_JPRB, 0.14243381E-05_JPRB, 0.13950443E-05_JPRB /)

RGHG2(:,30, 1) = (/ &
  & 0.13013489E-05_JPRB, 0.13183719E-05_JPRB, 0.13291872E-05_JPRB, 0.13395986E-05_JPRB, 0.13511269E-05_JPRB, 0.13641363E-05_JPRB, &
  & 0.13786886E-05_JPRB, 0.13943729E-05_JPRB, 0.14109532E-05_JPRB, 0.14282598E-05_JPRB, 0.14463259E-05_JPRB, 0.14650022E-05_JPRB, &
  & 0.14841162E-05_JPRB, 0.15035091E-05_JPRB, 0.15229706E-05_JPRB, 0.15422689E-05_JPRB, 0.15611676E-05_JPRB, 0.15794271E-05_JPRB, &
  & 0.15968036E-05_JPRB, 0.16131137E-05_JPRB, 0.16282494E-05_JPRB, 0.16421604E-05_JPRB, 0.16547990E-05_JPRB, 0.16661177E-05_JPRB, &
  & 0.16759718E-05_JPRB, 0.16841474E-05_JPRB, 0.16906370E-05_JPRB, 0.16953804E-05_JPRB, 0.16985023E-05_JPRB, 0.17002300E-05_JPRB, &
  & 0.17008360E-05_JPRB, 0.17005132E-05_JPRB, 0.16994670E-05_JPRB, 0.16977839E-05_JPRB, 0.16954958E-05_JPRB, 0.16926256E-05_JPRB, &
  & 0.16891049E-05_JPRB, 0.16849561E-05_JPRB, 0.16801705E-05_JPRB, 0.16746988E-05_JPRB, 0.16684182E-05_JPRB, 0.16611945E-05_JPRB, &
  & 0.16528998E-05_JPRB, 0.16434436E-05_JPRB, 0.16328661E-05_JPRB, 0.16214281E-05_JPRB, 0.16095921E-05_JPRB, 0.15978629E-05_JPRB, &
  & 0.15867661E-05_JPRB, 0.15764767E-05_JPRB, 0.15670653E-05_JPRB, 0.15584357E-05_JPRB, 0.15504202E-05_JPRB, 0.15429080E-05_JPRB, &
  & 0.15356950E-05_JPRB, 0.15286015E-05_JPRB, 0.15213874E-05_JPRB, 0.15137746E-05_JPRB, 0.15055799E-05_JPRB, 0.14966469E-05_JPRB, &
  & 0.14870765E-05_JPRB, 0.14766446E-05_JPRB, 0.14640685E-05_JPRB, 0.14393103E-05_JPRB /)

RGHG2(:,31, 1) = (/ &
  & 0.13397283E-05_JPRB, 0.13555120E-05_JPRB, 0.13652946E-05_JPRB, 0.13746909E-05_JPRB, 0.13848886E-05_JPRB, 0.13964673E-05_JPRB, &
  & 0.14093152E-05_JPRB, 0.14231736E-05_JPRB, 0.14377435E-05_JPRB, 0.14529519E-05_JPRB, 0.14689283E-05_JPRB, 0.14855999E-05_JPRB, &
  & 0.15028833E-05_JPRB, 0.15206447E-05_JPRB, 0.15387309E-05_JPRB, 0.15568797E-05_JPRB, 0.15748225E-05_JPRB, 0.15922683E-05_JPRB, &
  & 0.16089791E-05_JPRB, 0.16247752E-05_JPRB, 0.16395326E-05_JPRB, 0.16532274E-05_JPRB, 0.16658028E-05_JPRB, 0.16771567E-05_JPRB, &
  & 0.16871209E-05_JPRB, 0.16955242E-05_JPRB, 0.17022727E-05_JPRB, 0.17072915E-05_JPRB, 0.17106723E-05_JPRB, 0.17125603E-05_JPRB, &
  & 0.17132212E-05_JPRB, 0.17128339E-05_JPRB, 0.17115698E-05_JPRB, 0.17096613E-05_JPRB, 0.17071536E-05_JPRB, 0.17041962E-05_JPRB, &
  & 0.17007764E-05_JPRB, 0.16969386E-05_JPRB, 0.16926401E-05_JPRB, 0.16877980E-05_JPRB, 0.16822485E-05_JPRB, 0.16758196E-05_JPRB, &
  & 0.16683490E-05_JPRB, 0.16597429E-05_JPRB, 0.16500616E-05_JPRB, 0.16395236E-05_JPRB, 0.16285567E-05_JPRB, 0.16177281E-05_JPRB, &
  & 0.16073986E-05_JPRB, 0.15978962E-05_JPRB, 0.15891967E-05_JPRB, 0.15812091E-05_JPRB, 0.15738290E-05_JPRB, 0.15668834E-05_JPRB, &
  & 0.15602518E-05_JPRB, 0.15537297E-05_JPRB, 0.15471284E-05_JPRB, 0.15402316E-05_JPRB, 0.15328615E-05_JPRB, 0.15250162E-05_JPRB, &
  & 0.15167278E-05_JPRB, 0.15080020E-05_JPRB, 0.14972397E-05_JPRB, 0.14772986E-05_JPRB /)

RGHG2(:,32, 1) = (/ &
  & 0.13769821E-05_JPRB, 0.13913835E-05_JPRB, 0.14001506E-05_JPRB, 0.14084208E-05_JPRB, 0.14174262E-05_JPRB, 0.14275649E-05_JPRB, &
  & 0.14388781E-05_JPRB, 0.14510136E-05_JPRB, 0.14637601E-05_JPRB, 0.14770389E-05_JPRB, 0.14910602E-05_JPRB, 0.15058067E-05_JPRB, &
  & 0.15213450E-05_JPRB, 0.15376221E-05_JPRB, 0.15544465E-05_JPRB, 0.15715399E-05_JPRB, 0.15885855E-05_JPRB, 0.16052666E-05_JPRB, &
  & 0.16212896E-05_JPRB, 0.16365009E-05_JPRB, 0.16507812E-05_JPRB, 0.16640707E-05_JPRB, 0.16762692E-05_JPRB, 0.16873159E-05_JPRB, &
  & 0.16969977E-05_JPRB, 0.17052130E-05_JPRB, 0.17118822E-05_JPRB, 0.17169268E-05_JPRB, 0.17204251E-05_JPRB, 0.17224420E-05_JPRB, &
  & 0.17232360E-05_JPRB, 0.17229275E-05_JPRB, 0.17216894E-05_JPRB, 0.17197982E-05_JPRB, 0.17173182E-05_JPRB, 0.17144714E-05_JPRB, &
  & 0.17113016E-05_JPRB, 0.17078214E-05_JPRB, 0.17039970E-05_JPRB, 0.16996967E-05_JPRB, 0.16947431E-05_JPRB, 0.16889364E-05_JPRB, &
  & 0.16821144E-05_JPRB, 0.16741878E-05_JPRB, 0.16652122E-05_JPRB, 0.16554563E-05_JPRB, 0.16453109E-05_JPRB, 0.16352183E-05_JPRB, &
  & 0.16256611E-05_JPRB, 0.16167961E-05_JPRB, 0.16086743E-05_JPRB, 0.16012074E-05_JPRB, 0.15942732E-05_JPRB, 0.15877681E-05_JPRB, &
  & 0.15815227E-05_JPRB, 0.15754190E-05_JPRB, 0.15692665E-05_JPRB, 0.15628882E-05_JPRB, 0.15561875E-05_JPRB, 0.15491529E-05_JPRB, &
  & 0.15419358E-05_JPRB, 0.15342966E-05_JPRB, 0.15255492E-05_JPRB, 0.15085184E-05_JPRB /)

RGHG2(:,33, 1) = (/ &
  & 0.14126364E-05_JPRB, 0.14254881E-05_JPRB, 0.14332535E-05_JPRB, 0.14405234E-05_JPRB, 0.14483644E-05_JPRB, 0.14572656E-05_JPRB, &
  & 0.14671701E-05_JPRB, 0.14778008E-05_JPRB, 0.14888964E-05_JPRB, 0.15004609E-05_JPRB, 0.15126593E-05_JPRB, 0.15256128E-05_JPRB, &
  & 0.15394605E-05_JPRB, 0.15542515E-05_JPRB, 0.15699007E-05_JPRB, 0.15860937E-05_JPRB, 0.16024223E-05_JPRB, 0.16184898E-05_JPRB, &
  & 0.16339726E-05_JPRB, 0.16486374E-05_JPRB, 0.16623699E-05_JPRB, 0.16750902E-05_JPRB, 0.16867442E-05_JPRB, 0.16971392E-05_JPRB, &
  & 0.17062293E-05_JPRB, 0.17139046E-05_JPRB, 0.17201692E-05_JPRB, 0.17250122E-05_JPRB, 0.17284551E-05_JPRB, 0.17305241E-05_JPRB, &
  & 0.17314647E-05_JPRB, 0.17313125E-05_JPRB, 0.17302812E-05_JPRB, 0.17285815E-05_JPRB, 0.17263177E-05_JPRB, 0.17237325E-05_JPRB, &
  & 0.17208795E-05_JPRB, 0.17177879E-05_JPRB, 0.17144089E-05_JPRB, 0.17105917E-05_JPRB, 0.17061193E-05_JPRB, 0.17007799E-05_JPRB, &
  & 0.16944252E-05_JPRB, 0.16869820E-05_JPRB, 0.16785841E-05_JPRB, 0.16694667E-05_JPRB, 0.16600007E-05_JPRB, 0.16506602E-05_JPRB, &
  & 0.16417395E-05_JPRB, 0.16334728E-05_JPRB, 0.16258449E-05_JPRB, 0.16187963E-05_JPRB, 0.16122406E-05_JPRB, 0.16060360E-05_JPRB, &
  & 0.16001037E-05_JPRB, 0.15942978E-05_JPRB, 0.15884874E-05_JPRB, 0.15825110E-05_JPRB, 0.15763133E-05_JPRB, 0.15699220E-05_JPRB, &
  & 0.15633968E-05_JPRB, 0.15567664E-05_JPRB, 0.15487522E-05_JPRB, 0.15344663E-05_JPRB /)

RGHG2(:,34, 1) = (/ &
  & 0.14460691E-05_JPRB, 0.14575593E-05_JPRB, 0.14643587E-05_JPRB, 0.14706981E-05_JPRB, 0.14775771E-05_JPRB, 0.14853571E-05_JPRB, &
  & 0.14940597E-05_JPRB, 0.15033661E-05_JPRB, 0.15130288E-05_JPRB, 0.15230644E-05_JPRB, 0.15336209E-05_JPRB, 0.15449228E-05_JPRB, &
  & 0.15572343E-05_JPRB, 0.15706969E-05_JPRB, 0.15852552E-05_JPRB, 0.16006281E-05_JPRB, 0.16163362E-05_JPRB, 0.16319121E-05_JPRB, &
  & 0.16469539E-05_JPRB, 0.16611095E-05_JPRB, 0.16742887E-05_JPRB, 0.16864301E-05_JPRB, 0.16973086E-05_JPRB, 0.17068892E-05_JPRB, &
  & 0.17150705E-05_JPRB, 0.17219355E-05_JPRB, 0.17275456E-05_JPRB, 0.17319354E-05_JPRB, 0.17351400E-05_JPRB, 0.17371700E-05_JPRB, &
  & 0.17382082E-05_JPRB, 0.17382611E-05_JPRB, 0.17375497E-05_JPRB, 0.17361641E-05_JPRB, 0.17342700E-05_JPRB, 0.17320675E-05_JPRB, &
  & 0.17296089E-05_JPRB, 0.17269424E-05_JPRB, 0.17239968E-05_JPRB, 0.17205913E-05_JPRB, 0.17165047E-05_JPRB, 0.17115113E-05_JPRB, &
  & 0.17054648E-05_JPRB, 0.16983763E-05_JPRB, 0.16903788E-05_JPRB, 0.16817861E-05_JPRB, 0.16729612E-05_JPRB, 0.16642218E-05_JPRB, &
  & 0.16559255E-05_JPRB, 0.16481514E-05_JPRB, 0.16409537E-05_JPRB, 0.16342721E-05_JPRB, 0.16279897E-05_JPRB, 0.16220567E-05_JPRB, &
  & 0.16163524E-05_JPRB, 0.16107955E-05_JPRB, 0.16052275E-05_JPRB, 0.15995747E-05_JPRB, 0.15937661E-05_JPRB, 0.15878296E-05_JPRB, &
  & 0.15818605E-05_JPRB, 0.15756448E-05_JPRB, 0.15686808E-05_JPRB, 0.15556222E-05_JPRB /)

RGHG2(:,35, 1) = (/ &
  & 0.14772846E-05_JPRB, 0.14873730E-05_JPRB, 0.14933416E-05_JPRB, 0.14988946E-05_JPRB, 0.15048922E-05_JPRB, 0.15117591E-05_JPRB, &
  & 0.15194121E-05_JPRB, 0.15275840E-05_JPRB, 0.15359981E-05_JPRB, 0.15446852E-05_JPRB, 0.15537673E-05_JPRB, 0.15635502E-05_JPRB, &
  & 0.15744026E-05_JPRB, 0.15866030E-05_JPRB, 0.16001775E-05_JPRB, 0.16148437E-05_JPRB, 0.16300531E-05_JPRB, 0.16452600E-05_JPRB, &
  & 0.16599395E-05_JPRB, 0.16736824E-05_JPRB, 0.16863745E-05_JPRB, 0.16978004E-05_JPRB, 0.17078286E-05_JPRB, 0.17163646E-05_JPRB, &
  & 0.17234831E-05_JPRB, 0.17293103E-05_JPRB, 0.17340180E-05_JPRB, 0.17377652E-05_JPRB, 0.17405208E-05_JPRB, 0.17423974E-05_JPRB, &
  & 0.17434314E-05_JPRB, 0.17437004E-05_JPRB, 0.17433044E-05_JPRB, 0.17423164E-05_JPRB, 0.17408878E-05_JPRB, 0.17391339E-05_JPRB, &
  & 0.17371439E-05_JPRB, 0.17349461E-05_JPRB, 0.17324435E-05_JPRB, 0.17294503E-05_JPRB, 0.17257372E-05_JPRB, 0.17210591E-05_JPRB, &
  & 0.17152936E-05_JPRB, 0.17084499E-05_JPRB, 0.17007981E-05_JPRB, 0.16926609E-05_JPRB, 0.16843248E-05_JPRB, 0.16761833E-05_JPRB, &
  & 0.16683580E-05_JPRB, 0.16610365E-05_JPRB, 0.16541970E-05_JPRB, 0.16477809E-05_JPRB, 0.16417459E-05_JPRB, 0.16360085E-05_JPRB, &
  & 0.16305124E-05_JPRB, 0.16251291E-05_JPRB, 0.16197931E-05_JPRB, 0.16143792E-05_JPRB, 0.16088832E-05_JPRB, 0.16033056E-05_JPRB, &
  & 0.15976775E-05_JPRB, 0.15919937E-05_JPRB, 0.15852812E-05_JPRB, 0.15735191E-05_JPRB /)

RGHG2(:,36, 1) = (/ &
  & 0.15062160E-05_JPRB, 0.15150696E-05_JPRB, 0.15202571E-05_JPRB, 0.15250866E-05_JPRB, 0.15303872E-05_JPRB, 0.15364276E-05_JPRB, &
  & 0.15432042E-05_JPRB, 0.15503881E-05_JPRB, 0.15577339E-05_JPRB, 0.15652067E-05_JPRB, 0.15729763E-05_JPRB, 0.15813622E-05_JPRB, &
  & 0.15908273E-05_JPRB, 0.16017841E-05_JPRB, 0.16143865E-05_JPRB, 0.16283544E-05_JPRB, 0.16431533E-05_JPRB, 0.16581031E-05_JPRB, &
  & 0.16725513E-05_JPRB, 0.16860222E-05_JPRB, 0.16982025E-05_JPRB, 0.17088660E-05_JPRB, 0.17178538E-05_JPRB, 0.17251754E-05_JPRB, &
  & 0.17310053E-05_JPRB, 0.17356363E-05_JPRB, 0.17393235E-05_JPRB, 0.17422544E-05_JPRB, 0.17444861E-05_JPRB, 0.17460876E-05_JPRB, &
  & 0.17470488E-05_JPRB, 0.17474514E-05_JPRB, 0.17472931E-05_JPRB, 0.17466726E-05_JPRB, 0.17456537E-05_JPRB, 0.17443421E-05_JPRB, &
  & 0.17428109E-05_JPRB, 0.17410646E-05_JPRB, 0.17390206E-05_JPRB, 0.17365116E-05_JPRB, 0.17332787E-05_JPRB, 0.17290615E-05_JPRB, &
  & 0.17236916E-05_JPRB, 0.17172216E-05_JPRB, 0.17099254E-05_JPRB, 0.17021639E-05_JPRB, 0.16943395E-05_JPRB, 0.16866231E-05_JPRB, &
  & 0.16792631E-05_JPRB, 0.16722810E-05_JPRB, 0.16657001E-05_JPRB, 0.16595106E-05_JPRB, 0.16536528E-05_JPRB, 0.16481004E-05_JPRB, &
  & 0.16427600E-05_JPRB, 0.16375695E-05_JPRB, 0.16324063E-05_JPRB, 0.16272273E-05_JPRB, 0.16219691E-05_JPRB, 0.16166655E-05_JPRB, &
  & 0.16113640E-05_JPRB, 0.16059079E-05_JPRB, 0.15997809E-05_JPRB, 0.15887181E-05_JPRB /)

RGHG2(:,37, 1) = (/ &
  & 0.15331148E-05_JPRB, 0.15407114E-05_JPRB, 0.15451951E-05_JPRB, 0.15494224E-05_JPRB, 0.15540795E-05_JPRB, 0.15594653E-05_JPRB, &
  & 0.15654758E-05_JPRB, 0.15718182E-05_JPRB, 0.15782168E-05_JPRB, 0.15846188E-05_JPRB, 0.15912035E-05_JPRB, 0.15982847E-05_JPRB, &
  & 0.16064498E-05_JPRB, 0.16161563E-05_JPRB, 0.16277946E-05_JPRB, 0.16411317E-05_JPRB, 0.16555269E-05_JPRB, 0.16702436E-05_JPRB, &
  & 0.16845129E-05_JPRB, 0.16976768E-05_JPRB, 0.17092374E-05_JPRB, 0.17189236E-05_JPRB, 0.17265917E-05_JPRB, 0.17325016E-05_JPRB, &
  & 0.17369752E-05_JPRB, 0.17404274E-05_JPRB, 0.17431439E-05_JPRB, 0.17453623E-05_JPRB, 0.17471075E-05_JPRB, 0.17484423E-05_JPRB, &
  & 0.17493269E-05_JPRB, 0.17497694E-05_JPRB, 0.17497744E-05_JPRB, 0.17493840E-05_JPRB, 0.17486567E-05_JPRB, 0.17476793E-05_JPRB, &
  & 0.17464987E-05_JPRB, 0.17451241E-05_JPRB, 0.17434913E-05_JPRB, 0.17414501E-05_JPRB, 0.17387703E-05_JPRB, 0.17351734E-05_JPRB, &
  & 0.17304387E-05_JPRB, 0.17245329E-05_JPRB, 0.17177094E-05_JPRB, 0.17104210E-05_JPRB, 0.17030072E-05_JPRB, 0.16957523E-05_JPRB, &
  & 0.16887288E-05_JPRB, 0.16820283E-05_JPRB, 0.16756709E-05_JPRB, 0.16696397E-05_JPRB, 0.16639397E-05_JPRB, 0.16585307E-05_JPRB, &
  & 0.16533770E-05_JPRB, 0.16483766E-05_JPRB, 0.16434427E-05_JPRB, 0.16384610E-05_JPRB, 0.16334238E-05_JPRB, 0.16283409E-05_JPRB, &
  & 0.16232652E-05_JPRB, 0.16181594E-05_JPRB, 0.16123279E-05_JPRB, 0.16021241E-05_JPRB /)

RGHG2(:,38, 1) = (/ &
  & 0.15579361E-05_JPRB, 0.15643965E-05_JPRB, 0.15682298E-05_JPRB, 0.15719210E-05_JPRB, 0.15760572E-05_JPRB, 0.15808786E-05_JPRB, &
  & 0.15862472E-05_JPRB, 0.15918506E-05_JPRB, 0.15974098E-05_JPRB, 0.16028720E-05_JPRB, 0.16083571E-05_JPRB, 0.16143181E-05_JPRB, &
  & 0.16211728E-05_JPRB, 0.16296938E-05_JPRB, 0.16402396E-05_JPRB, 0.16528886E-05_JPRB, 0.16669139E-05_JPRB, 0.16813884E-05_JPRB, &
  & 0.16953816E-05_JPRB, 0.17080345E-05_JPRB, 0.17186677E-05_JPRB, 0.17269946E-05_JPRB, 0.17332238E-05_JPRB, 0.17377544E-05_JPRB, &
  & 0.17410734E-05_JPRB, 0.17436289E-05_JPRB, 0.17456534E-05_JPRB, 0.17473590E-05_JPRB, 0.17487836E-05_JPRB, 0.17499196E-05_JPRB, &
  & 0.17507452E-05_JPRB, 0.17511975E-05_JPRB, 0.17512909E-05_JPRB, 0.17510317E-05_JPRB, 0.17504874E-05_JPRB, 0.17497199E-05_JPRB, &
  & 0.17487795E-05_JPRB, 0.17476725E-05_JPRB, 0.17463472E-05_JPRB, 0.17446844E-05_JPRB, 0.17424807E-05_JPRB, 0.17394792E-05_JPRB, &
  & 0.17354419E-05_JPRB, 0.17302456E-05_JPRB, 0.17240941E-05_JPRB, 0.17173453E-05_JPRB, 0.17104339E-05_JPRB, 0.17035577E-05_JPRB, &
  & 0.16968668E-05_JPRB, 0.16904161E-05_JPRB, 0.16842221E-05_JPRB, 0.16783400E-05_JPRB, 0.16727819E-05_JPRB, 0.16675688E-05_JPRB, &
  & 0.16626484E-05_JPRB, 0.16579056E-05_JPRB, 0.16532264E-05_JPRB, 0.16484892E-05_JPRB, 0.16436497E-05_JPRB, 0.16387417E-05_JPRB, &
  & 0.16338732E-05_JPRB, 0.16289946E-05_JPRB, 0.16235748E-05_JPRB, 0.16141149E-05_JPRB /)

RGHG2(:,39, 1) = (/ &
  & 0.15806494E-05_JPRB, 0.15860332E-05_JPRB, 0.15893203E-05_JPRB, 0.15925430E-05_JPRB, 0.15962718E-05_JPRB, 0.16006140E-05_JPRB, &
  & 0.16054389E-05_JPRB, 0.16103807E-05_JPRB, 0.16152010E-05_JPRB, 0.16197970E-05_JPRB, 0.16244128E-05_JPRB, 0.16292763E-05_JPRB, &
  & 0.16350834E-05_JPRB, 0.16423314E-05_JPRB, 0.16518368E-05_JPRB, 0.16636377E-05_JPRB, 0.16771875E-05_JPRB, 0.16913294E-05_JPRB, &
  & 0.17048028E-05_JPRB, 0.17165376E-05_JPRB, 0.17258601E-05_JPRB, 0.17327734E-05_JPRB, 0.17376675E-05_JPRB, 0.17411616E-05_JPRB, &
  & 0.17437023E-05_JPRB, 0.17456761E-05_JPRB, 0.17472827E-05_JPRB, 0.17486789E-05_JPRB, 0.17498990E-05_JPRB, 0.17509171E-05_JPRB, &
  & 0.17516930E-05_JPRB, 0.17521506E-05_JPRB, 0.17522851E-05_JPRB, 0.17521024E-05_JPRB, 0.17516643E-05_JPRB, 0.17510315E-05_JPRB, &
  & 0.17502507E-05_JPRB, 0.17493277E-05_JPRB, 0.17482205E-05_JPRB, 0.17468309E-05_JPRB, 0.17449922E-05_JPRB, 0.17424818E-05_JPRB, &
  & 0.17390593E-05_JPRB, 0.17345926E-05_JPRB, 0.17291326E-05_JPRB, 0.17230375E-05_JPRB, 0.17166136E-05_JPRB, 0.17101625E-05_JPRB, &
  & 0.17037979E-05_JPRB, 0.16975652E-05_JPRB, 0.16915515E-05_JPRB, 0.16858130E-05_JPRB, 0.16804346E-05_JPRB, 0.16754566E-05_JPRB, &
  & 0.16708107E-05_JPRB, 0.16664087E-05_JPRB, 0.16620528E-05_JPRB, 0.16576096E-05_JPRB, 0.16529839E-05_JPRB, 0.16482481E-05_JPRB, &
  & 0.16435469E-05_JPRB, 0.16389205E-05_JPRB, 0.16338385E-05_JPRB, 0.16251064E-05_JPRB /)

RGHG2(:,40, 1) = (/ &
  & 0.16010491E-05_JPRB, 0.16055651E-05_JPRB, 0.16083760E-05_JPRB, 0.16112464E-05_JPRB, 0.16146018E-05_JPRB, 0.16185887E-05_JPRB, &
  & 0.16229136E-05_JPRB, 0.16272730E-05_JPRB, 0.16314104E-05_JPRB, 0.16353349E-05_JPRB, 0.16391145E-05_JPRB, 0.16432288E-05_JPRB, &
  & 0.16479630E-05_JPRB, 0.16542201E-05_JPRB, 0.16625634E-05_JPRB, 0.16735285E-05_JPRB, 0.16864237E-05_JPRB, 0.16999297E-05_JPRB, &
  & 0.17125693E-05_JPRB, 0.17230719E-05_JPRB, 0.17310077E-05_JPRB, 0.17366481E-05_JPRB, 0.17405690E-05_JPRB, 0.17433551E-05_JPRB, &
  & 0.17454164E-05_JPRB, 0.17470395E-05_JPRB, 0.17484040E-05_JPRB, 0.17496174E-05_JPRB, 0.17507142E-05_JPRB, 0.17516588E-05_JPRB, &
  & 0.17523952E-05_JPRB, 0.17528498E-05_JPRB, 0.17530018E-05_JPRB, 0.17528616E-05_JPRB, 0.17524870E-05_JPRB, 0.17519410E-05_JPRB, &
  & 0.17512682E-05_JPRB, 0.17504735E-05_JPRB, 0.17495217E-05_JPRB, 0.17483296E-05_JPRB, 0.17467605E-05_JPRB, 0.17446200E-05_JPRB, &
  & 0.17417038E-05_JPRB, 0.17378403E-05_JPRB, 0.17330709E-05_JPRB, 0.17275706E-05_JPRB, 0.17217133E-05_JPRB, 0.17156999E-05_JPRB, &
  & 0.17096585E-05_JPRB, 0.17036916E-05_JPRB, 0.16978528E-05_JPRB, 0.16922708E-05_JPRB, 0.16870953E-05_JPRB, 0.16823656E-05_JPRB, &
  & 0.16780896E-05_JPRB, 0.16740539E-05_JPRB, 0.16700992E-05_JPRB, 0.16659934E-05_JPRB, 0.16616519E-05_JPRB, 0.16571180E-05_JPRB, &
  & 0.16526100E-05_JPRB, 0.16482161E-05_JPRB, 0.16434643E-05_JPRB, 0.16353937E-05_JPRB /)

RGHG2(:,41, 1) = (/ &
  & 0.16191478E-05_JPRB, 0.16229634E-05_JPRB, 0.16253945E-05_JPRB, 0.16279557E-05_JPRB, 0.16310644E-05_JPRB, 0.16347093E-05_JPRB, &
  & 0.16386209E-05_JPRB, 0.16424463E-05_JPRB, 0.16460258E-05_JPRB, 0.16493270E-05_JPRB, 0.16525598E-05_JPRB, 0.16559130E-05_JPRB, &
  & 0.16599778E-05_JPRB, 0.16651879E-05_JPRB, 0.16725508E-05_JPRB, 0.16824949E-05_JPRB, 0.16946401E-05_JPRB, 0.17073548E-05_JPRB, &
  & 0.17187991E-05_JPRB, 0.17279913E-05_JPRB, 0.17346656E-05_JPRB, 0.17393078E-05_JPRB, 0.17425464E-05_JPRB, 0.17448515E-05_JPRB, &
  & 0.17466205E-05_JPRB, 0.17480249E-05_JPRB, 0.17492455E-05_JPRB, 0.17503543E-05_JPRB, 0.17513719E-05_JPRB, 0.17522693E-05_JPRB, &
  & 0.17529719E-05_JPRB, 0.17534143E-05_JPRB, 0.17535682E-05_JPRB, 0.17534492E-05_JPRB, 0.17531120E-05_JPRB, 0.17526231E-05_JPRB, &
  & 0.17520259E-05_JPRB, 0.17513263E-05_JPRB, 0.17504906E-05_JPRB, 0.17494502E-05_JPRB, 0.17480888E-05_JPRB, 0.17462418E-05_JPRB, &
  & 0.17437201E-05_JPRB, 0.17403736E-05_JPRB, 0.17361618E-05_JPRB, 0.17312792E-05_JPRB, 0.17259320E-05_JPRB, 0.17203636E-05_JPRB, &
  & 0.17147031E-05_JPRB, 0.17089984E-05_JPRB, 0.17033464E-05_JPRB, 0.16979448E-05_JPRB, 0.16929459E-05_JPRB, 0.16885405E-05_JPRB, &
  & 0.16846075E-05_JPRB, 0.16810118E-05_JPRB, 0.16774650E-05_JPRB, 0.16737762E-05_JPRB, 0.16697786E-05_JPRB, 0.16655371E-05_JPRB, &
  & 0.16612890E-05_JPRB, 0.16571566E-05_JPRB, 0.16527237E-05_JPRB, 0.16452499E-05_JPRB /)

RGHG2(:,42, 1) = (/ &
  & 0.16350934E-05_JPRB, 0.16383525E-05_JPRB, 0.16405066E-05_JPRB, 0.16428248E-05_JPRB, 0.16457004E-05_JPRB, 0.16490897E-05_JPRB, &
  & 0.16526196E-05_JPRB, 0.16559922E-05_JPRB, 0.16590891E-05_JPRB, 0.16619384E-05_JPRB, 0.16646648E-05_JPRB, 0.16675573E-05_JPRB, &
  & 0.16709220E-05_JPRB, 0.16754675E-05_JPRB, 0.16818387E-05_JPRB, 0.16908579E-05_JPRB, 0.17020591E-05_JPRB, 0.17137415E-05_JPRB, &
  & 0.17239929E-05_JPRB, 0.17317986E-05_JPRB, 0.17373836E-05_JPRB, 0.17412402E-05_JPRB, 0.17439774E-05_JPRB, 0.17459604E-05_JPRB, &
  & 0.17475296E-05_JPRB, 0.17488001E-05_JPRB, 0.17499366E-05_JPRB, 0.17509803E-05_JPRB, 0.17519546E-05_JPRB, 0.17528138E-05_JPRB, &
  & 0.17534850E-05_JPRB, 0.17539061E-05_JPRB, 0.17540511E-05_JPRB, 0.17539375E-05_JPRB, 0.17536208E-05_JPRB, 0.17531689E-05_JPRB, &
  & 0.17526263E-05_JPRB, 0.17519981E-05_JPRB, 0.17512543E-05_JPRB, 0.17503355E-05_JPRB, 0.17491428E-05_JPRB, 0.17475363E-05_JPRB, &
  & 0.17453528E-05_JPRB, 0.17424333E-05_JPRB, 0.17387364E-05_JPRB, 0.17343471E-05_JPRB, 0.17295081E-05_JPRB, 0.17243960E-05_JPRB, &
  & 0.17191132E-05_JPRB, 0.17137114E-05_JPRB, 0.17082992E-05_JPRB, 0.17030388E-05_JPRB, 0.16982954E-05_JPRB, 0.16941656E-05_JPRB, &
  & 0.16906359E-05_JPRB, 0.16874449E-05_JPRB, 0.16843431E-05_JPRB, 0.16810790E-05_JPRB, 0.16775032E-05_JPRB, 0.16736540E-05_JPRB, &
  & 0.16697377E-05_JPRB, 0.16659247E-05_JPRB, 0.16618100E-05_JPRB, 0.16548767E-05_JPRB /)

RGHG2(:,43, 1) = (/ &
  & 0.16491333E-05_JPRB, 0.16520080E-05_JPRB, 0.16539080E-05_JPRB, 0.16560421E-05_JPRB, 0.16587333E-05_JPRB, 0.16618874E-05_JPRB, &
  & 0.16650982E-05_JPRB, 0.16680931E-05_JPRB, 0.16708134E-05_JPRB, 0.16732863E-05_JPRB, 0.16756622E-05_JPRB, 0.16781283E-05_JPRB, &
  & 0.16810571E-05_JPRB, 0.16848817E-05_JPRB, 0.16905340E-05_JPRB, 0.16985661E-05_JPRB, 0.17087924E-05_JPRB, 0.17192762E-05_JPRB, &
  & 0.17281671E-05_JPRB, 0.17348081E-05_JPRB, 0.17394709E-05_JPRB, 0.17427194E-05_JPRB, 0.17450736E-05_JPRB, 0.17468334E-05_JPRB, &
  & 0.17482625E-05_JPRB, 0.17494533E-05_JPRB, 0.17505390E-05_JPRB, 0.17515553E-05_JPRB, 0.17524985E-05_JPRB, 0.17533313E-05_JPRB, &
  & 0.17539671E-05_JPRB, 0.17543584E-05_JPRB, 0.17544852E-05_JPRB, 0.17543657E-05_JPRB, 0.17540563E-05_JPRB, 0.17536279E-05_JPRB, &
  & 0.17531245E-05_JPRB, 0.17525517E-05_JPRB, 0.17518829E-05_JPRB, 0.17510665E-05_JPRB, 0.17500190E-05_JPRB, 0.17486220E-05_JPRB, &
  & 0.17467272E-05_JPRB, 0.17441855E-05_JPRB, 0.17409186E-05_JPRB, 0.17370074E-05_JPRB, 0.17326272E-05_JPRB, 0.17279534E-05_JPRB, &
  & 0.17230761E-05_JPRB, 0.17180240E-05_JPRB, 0.17128466E-05_JPRB, 0.17078471E-05_JPRB, 0.17033282E-05_JPRB, 0.16995504E-05_JPRB, &
  & 0.16963953E-05_JPRB, 0.16936079E-05_JPRB, 0.16909185E-05_JPRB, 0.16880857E-05_JPRB, 0.16849669E-05_JPRB, 0.16815726E-05_JPRB, &
  & 0.16780913E-05_JPRB, 0.16746413E-05_JPRB, 0.16708793E-05_JPRB, 0.16644829E-05_JPRB /)

RGHG2(:,44, 1) = (/ &
  & 0.16616148E-05_JPRB, 0.16641918E-05_JPRB, 0.16659302E-05_JPRB, 0.16678944E-05_JPRB, 0.16704283E-05_JPRB, 0.16733803E-05_JPRB, &
  & 0.16763266E-05_JPRB, 0.16790354E-05_JPRB, 0.16814547E-05_JPRB, 0.16836520E-05_JPRB, 0.16857298E-05_JPRB, 0.16878848E-05_JPRB, &
  & 0.16903891E-05_JPRB, 0.16937454E-05_JPRB, 0.16985850E-05_JPRB, 0.17058474E-05_JPRB, 0.17150118E-05_JPRB, 0.17242381E-05_JPRB, &
  & 0.17317681E-05_JPRB, 0.17372473E-05_JPRB, 0.17411346E-05_JPRB, 0.17438908E-05_JPRB, 0.17459546E-05_JPRB, 0.17475473E-05_JPRB, &
  & 0.17488815E-05_JPRB, 0.17500290E-05_JPRB, 0.17510928E-05_JPRB, 0.17520965E-05_JPRB, 0.17530323E-05_JPRB, 0.17538349E-05_JPRB, &
  & 0.17544357E-05_JPRB, 0.17547893E-05_JPRB, 0.17548884E-05_JPRB, 0.17547533E-05_JPRB, 0.17544419E-05_JPRB, 0.17540258E-05_JPRB, &
  & 0.17535506E-05_JPRB, 0.17530215E-05_JPRB, 0.17524145E-05_JPRB, 0.17516863E-05_JPRB, 0.17507665E-05_JPRB, 0.17495565E-05_JPRB, &
  & 0.17479281E-05_JPRB, 0.17457369E-05_JPRB, 0.17428812E-05_JPRB, 0.17393975E-05_JPRB, 0.17354425E-05_JPRB, 0.17312004E-05_JPRB, &
  & 0.17267347E-05_JPRB, 0.17220494E-05_JPRB, 0.17172276E-05_JPRB, 0.17124951E-05_JPRB, 0.17083277E-05_JPRB, 0.17049097E-05_JPRB, &
  & 0.17021237E-05_JPRB, 0.16997111E-05_JPRB, 0.16973909E-05_JPRB, 0.16949660E-05_JPRB, 0.16922941E-05_JPRB, 0.16893864E-05_JPRB, &
  & 0.16863889E-05_JPRB, 0.16833608E-05_JPRB, 0.16800003E-05_JPRB, 0.16741851E-05_JPRB /)

RGHG2(:,45, 1) = (/ &
  & 0.16728740E-05_JPRB, 0.16752375E-05_JPRB, 0.16768456E-05_JPRB, 0.16786789E-05_JPRB, 0.16810700E-05_JPRB, 0.16838633E-05_JPRB, &
  & 0.16866139E-05_JPRB, 0.16891019E-05_JPRB, 0.16913195E-05_JPRB, 0.16932895E-05_JPRB, 0.16951299E-05_JPRB, 0.16970098E-05_JPRB, &
  & 0.16991617E-05_JPRB, 0.17020270E-05_JPRB, 0.17062606E-05_JPRB, 0.17125506E-05_JPRB, 0.17206389E-05_JPRB, 0.17285140E-05_JPRB, &
  & 0.17347519E-05_JPRB, 0.17392531E-05_JPRB, 0.17424715E-05_JPRB, 0.17448491E-05_JPRB, 0.17466666E-05_JPRB, 0.17481537E-05_JPRB, &
  & 0.17494193E-05_JPRB, 0.17505488E-05_JPRB, 0.17516156E-05_JPRB, 0.17526277E-05_JPRB, 0.17535536E-05_JPRB, 0.17543376E-05_JPRB, &
  & 0.17548941E-05_JPRB, 0.17552048E-05_JPRB, 0.17552687E-05_JPRB, 0.17551099E-05_JPRB, 0.17547875E-05_JPRB, 0.17543755E-05_JPRB, &
  & 0.17539190E-05_JPRB, 0.17534238E-05_JPRB, 0.17528689E-05_JPRB, 0.17522171E-05_JPRB, 0.17514117E-05_JPRB, 0.17503730E-05_JPRB, &
  & 0.17489945E-05_JPRB, 0.17471359E-05_JPRB, 0.17446845E-05_JPRB, 0.17416204E-05_JPRB, 0.17380979E-05_JPRB, 0.17342707E-05_JPRB, &
  & 0.17302268E-05_JPRB, 0.17259565E-05_JPRB, 0.17214902E-05_JPRB, 0.17171897E-05_JPRB, 0.17133988E-05_JPRB, 0.17103964E-05_JPRB, &
  & 0.17079778E-05_JPRB, 0.17058948E-05_JPRB, 0.17039189E-05_JPRB, 0.17018457E-05_JPRB, 0.16995898E-05_JPRB, 0.16971526E-05_JPRB, &
  & 0.16946327E-05_JPRB, 0.16920642E-05_JPRB, 0.16891498E-05_JPRB, 0.16840138E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART1',1,ZHOOK_HANDLE)
END SUBROUTINE PART1




SUBROUTINE PART2
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART2',0,ZHOOK_HANDLE)



RGHG2(:,46, 1) = (/ &
  & 0.16831546E-05_JPRB, 0.16854189E-05_JPRB, 0.16869154E-05_JPRB, 0.16886615E-05_JPRB, 0.16909305E-05_JPRB, 0.16935795E-05_JPRB, &
  & 0.16961986E-05_JPRB, 0.16985587E-05_JPRB, 0.17006136E-05_JPRB, 0.17024076E-05_JPRB, 0.17040422E-05_JPRB, 0.17056462E-05_JPRB, &
  & 0.17075054E-05_JPRB, 0.17098803E-05_JPRB, 0.17135235E-05_JPRB, 0.17189142E-05_JPRB, 0.17257805E-05_JPRB, 0.17322570E-05_JPRB, &
  & 0.17372657E-05_JPRB, 0.17408950E-05_JPRB, 0.17435697E-05_JPRB, 0.17456211E-05_JPRB, 0.17472738E-05_JPRB, 0.17486652E-05_JPRB, &
  & 0.17498982E-05_JPRB, 0.17510379E-05_JPRB, 0.17521166E-05_JPRB, 0.17531476E-05_JPRB, 0.17540826E-05_JPRB, 0.17548293E-05_JPRB, &
  & 0.17553457E-05_JPRB, 0.17556067E-05_JPRB, 0.17556291E-05_JPRB, 0.17554387E-05_JPRB, 0.17550991E-05_JPRB, 0.17546843E-05_JPRB, &
  & 0.17542400E-05_JPRB, 0.17537711E-05_JPRB, 0.17532592E-05_JPRB, 0.17526745E-05_JPRB, 0.17519718E-05_JPRB, 0.17510931E-05_JPRB, &
  & 0.17499531E-05_JPRB, 0.17484334E-05_JPRB, 0.17463975E-05_JPRB, 0.17437897E-05_JPRB, 0.17407054E-05_JPRB, 0.17373191E-05_JPRB, &
  & 0.17337131E-05_JPRB, 0.17298601E-05_JPRB, 0.17258769E-05_JPRB, 0.17219619E-05_JPRB, 0.17187076E-05_JPRB, 0.17160794E-05_JPRB, &
  & 0.17140342E-05_JPRB, 0.17122659E-05_JPRB, 0.17105745E-05_JPRB, 0.17088291E-05_JPRB, 0.17069267E-05_JPRB, 0.17049003E-05_JPRB, &
  & 0.17028290E-05_JPRB, 0.17006979E-05_JPRB, 0.16982430E-05_JPRB, 0.16938651E-05_JPRB /)

RGHG2(:,47, 1) = (/ &
  & 0.16927613E-05_JPRB, 0.16949031E-05_JPRB, 0.16963700E-05_JPRB, 0.16980129E-05_JPRB, 0.17001903E-05_JPRB, 0.17027564E-05_JPRB, &
  & 0.17052826E-05_JPRB, 0.17075691E-05_JPRB, 0.17095067E-05_JPRB, 0.17111443E-05_JPRB, 0.17125612E-05_JPRB, 0.17139532E-05_JPRB, &
  & 0.17154466E-05_JPRB, 0.17174930E-05_JPRB, 0.17203535E-05_JPRB, 0.17248724E-05_JPRB, 0.17303545E-05_JPRB, 0.17354680E-05_JPRB, &
  & 0.17393586E-05_JPRB, 0.17422501E-05_JPRB, 0.17444637E-05_JPRB, 0.17462685E-05_JPRB, 0.17477713E-05_JPRB, 0.17491188E-05_JPRB, &
  & 0.17503385E-05_JPRB, 0.17514950E-05_JPRB, 0.17526183E-05_JPRB, 0.17536722E-05_JPRB, 0.17545997E-05_JPRB, 0.17553243E-05_JPRB, &
  & 0.17557853E-05_JPRB, 0.17559948E-05_JPRB, 0.17559697E-05_JPRB, 0.17557428E-05_JPRB, 0.17553791E-05_JPRB, 0.17549571E-05_JPRB, &
  & 0.17545193E-05_JPRB, 0.17540701E-05_JPRB, 0.17535948E-05_JPRB, 0.17530679E-05_JPRB, 0.17524591E-05_JPRB, 0.17517295E-05_JPRB, &
  & 0.17508220E-05_JPRB, 0.17496413E-05_JPRB, 0.17480513E-05_JPRB, 0.17459564E-05_JPRB, 0.17433749E-05_JPRB, 0.17404878E-05_JPRB, &
  & 0.17373524E-05_JPRB, 0.17339992E-05_JPRB, 0.17304267E-05_JPRB, 0.17271033E-05_JPRB, 0.17242162E-05_JPRB, 0.17220700E-05_JPRB, &
  & 0.17203303E-05_JPRB, 0.17188488E-05_JPRB, 0.17174307E-05_JPRB, 0.17159414E-05_JPRB, 0.17143522E-05_JPRB, 0.17126723E-05_JPRB, &
  & 0.17109735E-05_JPRB, 0.17092312E-05_JPRB, 0.17072168E-05_JPRB, 0.17035699E-05_JPRB /)

RGHG2(:,48, 1) = (/ &
  & 0.17017561E-05_JPRB, 0.17038933E-05_JPRB, 0.17052803E-05_JPRB, 0.17069028E-05_JPRB, 0.17090001E-05_JPRB, 0.17114970E-05_JPRB, &
  & 0.17140227E-05_JPRB, 0.17162502E-05_JPRB, 0.17181014E-05_JPRB, 0.17195608E-05_JPRB, 0.17207944E-05_JPRB, 0.17219169E-05_JPRB, &
  & 0.17231704E-05_JPRB, 0.17247065E-05_JPRB, 0.17270477E-05_JPRB, 0.17303197E-05_JPRB, 0.17344739E-05_JPRB, 0.17382090E-05_JPRB, &
  & 0.17411128E-05_JPRB, 0.17433655E-05_JPRB, 0.17452062E-05_JPRB, 0.17467912E-05_JPRB, 0.17482093E-05_JPRB, 0.17495138E-05_JPRB, &
  & 0.17507509E-05_JPRB, 0.17519554E-05_JPRB, 0.17531125E-05_JPRB, 0.17541993E-05_JPRB, 0.17551246E-05_JPRB, 0.17558029E-05_JPRB, &
  & 0.17562134E-05_JPRB, 0.17563663E-05_JPRB, 0.17562902E-05_JPRB, 0.17560214E-05_JPRB, 0.17556322E-05_JPRB, 0.17551980E-05_JPRB, &
  & 0.17547623E-05_JPRB, 0.17543284E-05_JPRB, 0.17538825E-05_JPRB, 0.17534078E-05_JPRB, 0.17528844E-05_JPRB, 0.17522964E-05_JPRB, &
  & 0.17516161E-05_JPRB, 0.17507799E-05_JPRB, 0.17496761E-05_JPRB, 0.17481572E-05_JPRB, 0.17462161E-05_JPRB, 0.17438941E-05_JPRB, &
  & 0.17413298E-05_JPRB, 0.17384759E-05_JPRB, 0.17354748E-05_JPRB, 0.17325456E-05_JPRB, 0.17302157E-05_JPRB, 0.17283849E-05_JPRB, &
  & 0.17269717E-05_JPRB, 0.17257343E-05_JPRB, 0.17245347E-05_JPRB, 0.17232828E-05_JPRB, 0.17219320E-05_JPRB, 0.17205308E-05_JPRB, &
  & 0.17191264E-05_JPRB, 0.17177005E-05_JPRB, 0.17160373E-05_JPRB, 0.17130416E-05_JPRB /)

RGHG2(:,49, 1) = (/ &
  & 0.17103125E-05_JPRB, 0.17123750E-05_JPRB, 0.17137877E-05_JPRB, 0.17153553E-05_JPRB, 0.17174535E-05_JPRB, 0.17199662E-05_JPRB, &
  & 0.17225112E-05_JPRB, 0.17247424E-05_JPRB, 0.17264492E-05_JPRB, 0.17277357E-05_JPRB, 0.17287357E-05_JPRB, 0.17296270E-05_JPRB, &
  & 0.17305431E-05_JPRB, 0.17316572E-05_JPRB, 0.17331912E-05_JPRB, 0.17353708E-05_JPRB, 0.17380347E-05_JPRB, 0.17405540E-05_JPRB, &
  & 0.17425917E-05_JPRB, 0.17443008E-05_JPRB, 0.17458193E-05_JPRB, 0.17472341E-05_JPRB, 0.17485771E-05_JPRB, 0.17498827E-05_JPRB, &
  & 0.17511538E-05_JPRB, 0.17524088E-05_JPRB, 0.17536244E-05_JPRB, 0.17547310E-05_JPRB, 0.17556343E-05_JPRB, 0.17562736E-05_JPRB, &
  & 0.17566247E-05_JPRB, 0.17567203E-05_JPRB, 0.17565900E-05_JPRB, 0.17562783E-05_JPRB, 0.17558585E-05_JPRB, 0.17554112E-05_JPRB, &
  & 0.17549748E-05_JPRB, 0.17545519E-05_JPRB, 0.17541320E-05_JPRB, 0.17537031E-05_JPRB, 0.17532602E-05_JPRB, 0.17528075E-05_JPRB, &
  & 0.17523503E-05_JPRB, 0.17518653E-05_JPRB, 0.17512634E-05_JPRB, 0.17504171E-05_JPRB, 0.17492007E-05_JPRB, 0.17476375E-05_JPRB, &
  & 0.17457203E-05_JPRB, 0.17434836E-05_JPRB, 0.17410094E-05_JPRB, 0.17386507E-05_JPRB, 0.17367165E-05_JPRB, 0.17352543E-05_JPRB, &
  & 0.17340971E-05_JPRB, 0.17330731E-05_JPRB, 0.17320613E-05_JPRB, 0.17309867E-05_JPRB, 0.17298289E-05_JPRB, 0.17286272E-05_JPRB, &
  & 0.17274402E-05_JPRB, 0.17262337E-05_JPRB, 0.17248389E-05_JPRB, 0.17223097E-05_JPRB /)

RGHG2(:,50, 1) = (/ &
  & 0.17183564E-05_JPRB, 0.17204596E-05_JPRB, 0.17218074E-05_JPRB, 0.17234379E-05_JPRB, 0.17255522E-05_JPRB, 0.17281868E-05_JPRB, &
  & 0.17307927E-05_JPRB, 0.17329385E-05_JPRB, 0.17344362E-05_JPRB, 0.17354353E-05_JPRB, 0.17361529E-05_JPRB, 0.17367395E-05_JPRB, &
  & 0.17372676E-05_JPRB, 0.17378995E-05_JPRB, 0.17386276E-05_JPRB, 0.17397319E-05_JPRB, 0.17410993E-05_JPRB, 0.17425433E-05_JPRB, &
  & 0.17438535E-05_JPRB, 0.17450964E-05_JPRB, 0.17463431E-05_JPRB, 0.17476084E-05_JPRB, 0.17489087E-05_JPRB, 0.17502252E-05_JPRB, &
  & 0.17515581E-05_JPRB, 0.17528757E-05_JPRB, 0.17541402E-05_JPRB, 0.17552558E-05_JPRB, 0.17561372E-05_JPRB, 0.17567221E-05_JPRB, &
  & 0.17570193E-05_JPRB, 0.17570559E-05_JPRB, 0.17568707E-05_JPRB, 0.17565133E-05_JPRB, 0.17560644E-05_JPRB, 0.17556017E-05_JPRB, &
  & 0.17551620E-05_JPRB, 0.17547477E-05_JPRB, 0.17543496E-05_JPRB, 0.17539630E-05_JPRB, 0.17535953E-05_JPRB, 0.17532751E-05_JPRB, &
  & 0.17530402E-05_JPRB, 0.17529059E-05_JPRB, 0.17528187E-05_JPRB, 0.17526502E-05_JPRB, 0.17522570E-05_JPRB, 0.17515410E-05_JPRB, &
  & 0.17504299E-05_JPRB, 0.17489418E-05_JPRB, 0.17471419E-05_JPRB, 0.17453860E-05_JPRB, 0.17439008E-05_JPRB, 0.17427953E-05_JPRB, &
  & 0.17418680E-05_JPRB, 0.17410371E-05_JPRB, 0.17401971E-05_JPRB, 0.17392661E-05_JPRB, 0.17382579E-05_JPRB, 0.17372033E-05_JPRB, &
  & 0.17361527E-05_JPRB, 0.17350943E-05_JPRB, 0.17338450E-05_JPRB, 0.17315917E-05_JPRB /)

RGHG2(:,51, 1) = (/ &
  & 0.17259426E-05_JPRB, 0.17278959E-05_JPRB, 0.17293619E-05_JPRB, 0.17309446E-05_JPRB, 0.17332281E-05_JPRB, 0.17358826E-05_JPRB, &
  & 0.17384727E-05_JPRB, 0.17402574E-05_JPRB, 0.17413154E-05_JPRB, 0.17419203E-05_JPRB, 0.17422874E-05_JPRB, 0.17425245E-05_JPRB, &
  & 0.17427143E-05_JPRB, 0.17428509E-05_JPRB, 0.17430282E-05_JPRB, 0.17432390E-05_JPRB, 0.17436628E-05_JPRB, 0.17442380E-05_JPRB, &
  & 0.17449502E-05_JPRB, 0.17458005E-05_JPRB, 0.17468030E-05_JPRB, 0.17479485E-05_JPRB, 0.17492133E-05_JPRB, 0.17505679E-05_JPRB, &
  & 0.17519606E-05_JPRB, 0.17533548E-05_JPRB, 0.17546500E-05_JPRB, 0.17557729E-05_JPRB, 0.17566148E-05_JPRB, 0.17571535E-05_JPRB, &
  & 0.17573963E-05_JPRB, 0.17573744E-05_JPRB, 0.17571333E-05_JPRB, 0.17567303E-05_JPRB, 0.17562515E-05_JPRB, 0.17557733E-05_JPRB, &
  & 0.17553298E-05_JPRB, 0.17549216E-05_JPRB, 0.17545427E-05_JPRB, 0.17541950E-05_JPRB, 0.17539010E-05_JPRB, 0.17537129E-05_JPRB, &
  & 0.17537018E-05_JPRB, 0.17539146E-05_JPRB, 0.17543123E-05_JPRB, 0.17547685E-05_JPRB, 0.17551138E-05_JPRB, 0.17551986E-05_JPRB, &
  & 0.17549553E-05_JPRB, 0.17543084E-05_JPRB, 0.17533735E-05_JPRB, 0.17523055E-05_JPRB, 0.17514052E-05_JPRB, 0.17506256E-05_JPRB, &
  & 0.17499931E-05_JPRB, 0.17493757E-05_JPRB, 0.17487089E-05_JPRB, 0.17479708E-05_JPRB, 0.17471098E-05_JPRB, 0.17461959E-05_JPRB, &
  & 0.17452770E-05_JPRB, 0.17443090E-05_JPRB, 0.17431621E-05_JPRB, 0.17410297E-05_JPRB /)

RGHG2(:,52, 1) = (/ &
  & 0.17326930E-05_JPRB, 0.17347940E-05_JPRB, 0.17360613E-05_JPRB, 0.17378217E-05_JPRB, 0.17399461E-05_JPRB, 0.17425473E-05_JPRB, &
  & 0.17445172E-05_JPRB, 0.17456802E-05_JPRB, 0.17462162E-05_JPRB, 0.17464547E-05_JPRB, 0.17465474E-05_JPRB, 0.17465626E-05_JPRB, &
  & 0.17465215E-05_JPRB, 0.17464065E-05_JPRB, 0.17462487E-05_JPRB, 0.17459688E-05_JPRB, 0.17457504E-05_JPRB, 0.17456942E-05_JPRB, &
  & 0.17459186E-05_JPRB, 0.17464379E-05_JPRB, 0.17472364E-05_JPRB, 0.17482756E-05_JPRB, 0.17495195E-05_JPRB, 0.17509118E-05_JPRB, &
  & 0.17523802E-05_JPRB, 0.17538216E-05_JPRB, 0.17551590E-05_JPRB, 0.17562622E-05_JPRB, 0.17570768E-05_JPRB, 0.17575654E-05_JPRB, &
  & 0.17577580E-05_JPRB, 0.17576787E-05_JPRB, 0.17573810E-05_JPRB, 0.17569324E-05_JPRB, 0.17564239E-05_JPRB, 0.17559307E-05_JPRB, &
  & 0.17554823E-05_JPRB, 0.17550799E-05_JPRB, 0.17547184E-05_JPRB, 0.17544082E-05_JPRB, 0.17541870E-05_JPRB, 0.17541333E-05_JPRB, &
  & 0.17543468E-05_JPRB, 0.17548889E-05_JPRB, 0.17557229E-05_JPRB, 0.17566622E-05_JPRB, 0.17575386E-05_JPRB, 0.17582055E-05_JPRB, &
  & 0.17585787E-05_JPRB, 0.17586522E-05_JPRB, 0.17584348E-05_JPRB, 0.17580617E-05_JPRB, 0.17576339E-05_JPRB, 0.17572672E-05_JPRB, &
  & 0.17569012E-05_JPRB, 0.17565336E-05_JPRB, 0.17561224E-05_JPRB, 0.17556010E-05_JPRB, 0.17550002E-05_JPRB, 0.17543204E-05_JPRB, &
  & 0.17536045E-05_JPRB, 0.17528455E-05_JPRB, 0.17518760E-05_JPRB, 0.17499951E-05_JPRB /)

RGHG2(:,53, 1) = (/ &
  & 0.17387921E-05_JPRB, 0.17405326E-05_JPRB, 0.17420301E-05_JPRB, 0.17434412E-05_JPRB, 0.17454855E-05_JPRB, 0.17472966E-05_JPRB, &
  & 0.17485524E-05_JPRB, 0.17490790E-05_JPRB, 0.17492641E-05_JPRB, 0.17492995E-05_JPRB, 0.17492646E-05_JPRB, 0.17491874E-05_JPRB, &
  & 0.17490504E-05_JPRB, 0.17488779E-05_JPRB, 0.17485193E-05_JPRB, 0.17481109E-05_JPRB, 0.17474629E-05_JPRB, 0.17469637E-05_JPRB, &
  & 0.17467916E-05_JPRB, 0.17470328E-05_JPRB, 0.17476561E-05_JPRB, 0.17486129E-05_JPRB, 0.17498439E-05_JPRB, 0.17512737E-05_JPRB, &
  & 0.17527918E-05_JPRB, 0.17542936E-05_JPRB, 0.17556392E-05_JPRB, 0.17567401E-05_JPRB, 0.17575169E-05_JPRB, 0.17579645E-05_JPRB, &
  & 0.17581068E-05_JPRB, 0.17579721E-05_JPRB, 0.17576177E-05_JPRB, 0.17571242E-05_JPRB, 0.17565869E-05_JPRB, 0.17560787E-05_JPRB, &
  & 0.17556265E-05_JPRB, 0.17552291E-05_JPRB, 0.17548853E-05_JPRB, 0.17546121E-05_JPRB, 0.17544652E-05_JPRB, 0.17545468E-05_JPRB, &
  & 0.17549778E-05_JPRB, 0.17558324E-05_JPRB, 0.17569982E-05_JPRB, 0.17582984E-05_JPRB, 0.17594776E-05_JPRB, 0.17604449E-05_JPRB, &
  & 0.17611478E-05_JPRB, 0.17615750E-05_JPRB, 0.17617531E-05_JPRB, 0.17617424E-05_JPRB, 0.17616404E-05_JPRB, 0.17614969E-05_JPRB, &
  & 0.17613470E-05_JPRB, 0.17611710E-05_JPRB, 0.17609482E-05_JPRB, 0.17606746E-05_JPRB, 0.17603165E-05_JPRB, 0.17599142E-05_JPRB, &
  & 0.17594880E-05_JPRB, 0.17590173E-05_JPRB, 0.17584265E-05_JPRB, 0.17571250E-05_JPRB /)

RGHG2(:,54, 1) = (/ &
  & 0.17436591E-05_JPRB, 0.17456048E-05_JPRB, 0.17466398E-05_JPRB, 0.17480494E-05_JPRB, 0.17493395E-05_JPRB, 0.17504947E-05_JPRB, &
  & 0.17510282E-05_JPRB, 0.17511982E-05_JPRB, 0.17512039E-05_JPRB, 0.17511520E-05_JPRB, 0.17510717E-05_JPRB, 0.17509619E-05_JPRB, &
  & 0.17508291E-05_JPRB, 0.17505935E-05_JPRB, 0.17503149E-05_JPRB, 0.17496869E-05_JPRB, 0.17489622E-05_JPRB, 0.17480909E-05_JPRB, &
  & 0.17475910E-05_JPRB, 0.17475968E-05_JPRB, 0.17480820E-05_JPRB, 0.17489720E-05_JPRB, 0.17501941E-05_JPRB, 0.17516504E-05_JPRB, &
  & 0.17532154E-05_JPRB, 0.17547471E-05_JPRB, 0.17561167E-05_JPRB, 0.17571998E-05_JPRB, 0.17579514E-05_JPRB, 0.17583554E-05_JPRB, &
  & 0.17584481E-05_JPRB, 0.17582589E-05_JPRB, 0.17578500E-05_JPRB, 0.17573113E-05_JPRB, 0.17567461E-05_JPRB, 0.17562232E-05_JPRB, &
  & 0.17557679E-05_JPRB, 0.17553762E-05_JPRB, 0.17550510E-05_JPRB, 0.17548170E-05_JPRB, 0.17547460E-05_JPRB, 0.17549604E-05_JPRB, &
  & 0.17556019E-05_JPRB, 0.17567055E-05_JPRB, 0.17581660E-05_JPRB, 0.17596551E-05_JPRB, 0.17610188E-05_JPRB, 0.17621139E-05_JPRB, &
  & 0.17629332E-05_JPRB, 0.17634972E-05_JPRB, 0.17638246E-05_JPRB, 0.17639632E-05_JPRB, 0.17639936E-05_JPRB, 0.17639709E-05_JPRB, &
  & 0.17639193E-05_JPRB, 0.17638456E-05_JPRB, 0.17637458E-05_JPRB, 0.17636000E-05_JPRB, 0.17634193E-05_JPRB, 0.17632059E-05_JPRB, &
  & 0.17629882E-05_JPRB, 0.17627797E-05_JPRB, 0.17625634E-05_JPRB, 0.17622627E-05_JPRB /)

RGHG2(:,55, 1) = (/ &
  & 0.17478284E-05_JPRB, 0.17493114E-05_JPRB, 0.17504423E-05_JPRB, 0.17512614E-05_JPRB, 0.17520874E-05_JPRB, 0.17525419E-05_JPRB, &
  & 0.17526804E-05_JPRB, 0.17526509E-05_JPRB, 0.17525758E-05_JPRB, 0.17524890E-05_JPRB, 0.17523951E-05_JPRB, 0.17522899E-05_JPRB, &
  & 0.17521438E-05_JPRB, 0.17519699E-05_JPRB, 0.17516055E-05_JPRB, 0.17511470E-05_JPRB, 0.17501757E-05_JPRB, 0.17491229E-05_JPRB, &
  & 0.17483424E-05_JPRB, 0.17481487E-05_JPRB, 0.17485195E-05_JPRB, 0.17493589E-05_JPRB, 0.17505737E-05_JPRB, 0.17520465E-05_JPRB, &
  & 0.17536429E-05_JPRB, 0.17552093E-05_JPRB, 0.17565853E-05_JPRB, 0.17576647E-05_JPRB, 0.17583820E-05_JPRB, 0.17587467E-05_JPRB, &
  & 0.17587896E-05_JPRB, 0.17585467E-05_JPRB, 0.17580849E-05_JPRB, 0.17575032E-05_JPRB, 0.17569077E-05_JPRB, 0.17563727E-05_JPRB, &
  & 0.17559128E-05_JPRB, 0.17555301E-05_JPRB, 0.17552251E-05_JPRB, 0.17550337E-05_JPRB, 0.17550402E-05_JPRB, 0.17553826E-05_JPRB, &
  & 0.17562002E-05_JPRB, 0.17575375E-05_JPRB, 0.17591615E-05_JPRB, 0.17608376E-05_JPRB, 0.17622638E-05_JPRB, 0.17634108E-05_JPRB, &
  & 0.17642662E-05_JPRB, 0.17648561E-05_JPRB, 0.17652228E-05_JPRB, 0.17654183E-05_JPRB, 0.17654986E-05_JPRB, 0.17655253E-05_JPRB, &
  & 0.17655220E-05_JPRB, 0.17654985E-05_JPRB, 0.17654525E-05_JPRB, 0.17653831E-05_JPRB, 0.17652808E-05_JPRB, 0.17651589E-05_JPRB, &
  & 0.17650267E-05_JPRB, 0.17648865E-05_JPRB, 0.17647224E-05_JPRB, 0.17644095E-05_JPRB /)

RGHG2(:,56, 1) = (/ &
  & 0.17509210E-05_JPRB, 0.17524100E-05_JPRB, 0.17530899E-05_JPRB, 0.17536504E-05_JPRB, 0.17539622E-05_JPRB, 0.17540092E-05_JPRB, &
  & 0.17539087E-05_JPRB, 0.17537780E-05_JPRB, 0.17536665E-05_JPRB, 0.17535681E-05_JPRB, 0.17534737E-05_JPRB, 0.17533687E-05_JPRB, &
  & 0.17532498E-05_JPRB, 0.17530526E-05_JPRB, 0.17528032E-05_JPRB, 0.17522058E-05_JPRB, 0.17513730E-05_JPRB, 0.17500604E-05_JPRB, &
  & 0.17490577E-05_JPRB, 0.17487041E-05_JPRB, 0.17489835E-05_JPRB, 0.17497803E-05_JPRB, 0.17509835E-05_JPRB, 0.17524709E-05_JPRB, &
  & 0.17540912E-05_JPRB, 0.17556788E-05_JPRB, 0.17570705E-05_JPRB, 0.17581309E-05_JPRB, 0.17588225E-05_JPRB, 0.17591444E-05_JPRB, &
  & 0.17591391E-05_JPRB, 0.17588447E-05_JPRB, 0.17583308E-05_JPRB, 0.17577075E-05_JPRB, 0.17570839E-05_JPRB, 0.17565330E-05_JPRB, &
  & 0.17560733E-05_JPRB, 0.17556976E-05_JPRB, 0.17554173E-05_JPRB, 0.17552710E-05_JPRB, 0.17553551E-05_JPRB, 0.17558135E-05_JPRB, &
  & 0.17567910E-05_JPRB, 0.17582745E-05_JPRB, 0.17600920E-05_JPRB, 0.17618241E-05_JPRB, 0.17633345E-05_JPRB, 0.17644900E-05_JPRB, &
  & 0.17653329E-05_JPRB, 0.17659138E-05_JPRB, 0.17662801E-05_JPRB, 0.17664793E-05_JPRB, 0.17665816E-05_JPRB, 0.17666259E-05_JPRB, &
  & 0.17666434E-05_JPRB, 0.17666429E-05_JPRB, 0.17666268E-05_JPRB, 0.17665911E-05_JPRB, 0.17665360E-05_JPRB, 0.17664618E-05_JPRB, &
  & 0.17663790E-05_JPRB, 0.17662919E-05_JPRB, 0.17661920E-05_JPRB, 0.17660237E-05_JPRB /)

RGHG2(:,57, 1) = (/ &
  & 0.17534290E-05_JPRB, 0.17545935E-05_JPRB, 0.17551217E-05_JPRB, 0.17553673E-05_JPRB, 0.17553680E-05_JPRB, 0.17551674E-05_JPRB, &
  & 0.17549269E-05_JPRB, 0.17547527E-05_JPRB, 0.17546231E-05_JPRB, 0.17545201E-05_JPRB, 0.17544263E-05_JPRB, 0.17543305E-05_JPRB, &
  & 0.17542067E-05_JPRB, 0.17540543E-05_JPRB, 0.17537504E-05_JPRB, 0.17533168E-05_JPRB, 0.17522996E-05_JPRB, 0.17509560E-05_JPRB, &
  & 0.17497645E-05_JPRB, 0.17492803E-05_JPRB, 0.17494845E-05_JPRB, 0.17502425E-05_JPRB, 0.17514383E-05_JPRB, 0.17529302E-05_JPRB, &
  & 0.17545706E-05_JPRB, 0.17561777E-05_JPRB, 0.17575658E-05_JPRB, 0.17586192E-05_JPRB, 0.17592758E-05_JPRB, 0.17595580E-05_JPRB, &
  & 0.17595062E-05_JPRB, 0.17591626E-05_JPRB, 0.17586008E-05_JPRB, 0.17579346E-05_JPRB, 0.17572836E-05_JPRB, 0.17567202E-05_JPRB, &
  & 0.17562555E-05_JPRB, 0.17558921E-05_JPRB, 0.17556358E-05_JPRB, 0.17555368E-05_JPRB, 0.17556971E-05_JPRB, 0.17562631E-05_JPRB, &
  & 0.17573573E-05_JPRB, 0.17589928E-05_JPRB, 0.17608747E-05_JPRB, 0.17627450E-05_JPRB, 0.17642612E-05_JPRB, 0.17654296E-05_JPRB, &
  & 0.17662509E-05_JPRB, 0.17668023E-05_JPRB, 0.17671452E-05_JPRB, 0.17673427E-05_JPRB, 0.17674422E-05_JPRB, 0.17674947E-05_JPRB, &
  & 0.17675200E-05_JPRB, 0.17675295E-05_JPRB, 0.17675262E-05_JPRB, 0.17675093E-05_JPRB, 0.17674749E-05_JPRB, 0.17674264E-05_JPRB, &
  & 0.17673669E-05_JPRB, 0.17672988E-05_JPRB, 0.17672131E-05_JPRB, 0.17670442E-05_JPRB /)

RGHG2(:,58, 1) = (/ &
  & 0.17553937E-05_JPRB, 0.17563477E-05_JPRB, 0.17566618E-05_JPRB, 0.17567058E-05_JPRB, 0.17565164E-05_JPRB, 0.17561679E-05_JPRB, &
  & 0.17558727E-05_JPRB, 0.17556630E-05_JPRB, 0.17555267E-05_JPRB, 0.17554208E-05_JPRB, 0.17553282E-05_JPRB, 0.17552306E-05_JPRB, &
  & 0.17551204E-05_JPRB, 0.17549467E-05_JPRB, 0.17547068E-05_JPRB, 0.17541577E-05_JPRB, 0.17532718E-05_JPRB, 0.17517516E-05_JPRB, &
  & 0.17504625E-05_JPRB, 0.17498905E-05_JPRB, 0.17500354E-05_JPRB, 0.17507614E-05_JPRB, 0.17519446E-05_JPRB, 0.17534448E-05_JPRB, &
  & 0.17550946E-05_JPRB, 0.17567048E-05_JPRB, 0.17580953E-05_JPRB, 0.17591242E-05_JPRB, 0.17597536E-05_JPRB, 0.17599955E-05_JPRB, &
  & 0.17599009E-05_JPRB, 0.17595128E-05_JPRB, 0.17589041E-05_JPRB, 0.17581988E-05_JPRB, 0.17575200E-05_JPRB, 0.17569400E-05_JPRB, &
  & 0.17564754E-05_JPRB, 0.17561208E-05_JPRB, 0.17558914E-05_JPRB, 0.17558395E-05_JPRB, 0.17560735E-05_JPRB, 0.17567299E-05_JPRB, &
  & 0.17579342E-05_JPRB, 0.17596365E-05_JPRB, 0.17616495E-05_JPRB, 0.17635284E-05_JPRB, 0.17651221E-05_JPRB, 0.17662753E-05_JPRB, &
  & 0.17670725E-05_JPRB, 0.17675893E-05_JPRB, 0.17679105E-05_JPRB, 0.17680891E-05_JPRB, 0.17681873E-05_JPRB, 0.17682366E-05_JPRB, &
  & 0.17682635E-05_JPRB, 0.17682761E-05_JPRB, 0.17682777E-05_JPRB, 0.17682673E-05_JPRB, 0.17682443E-05_JPRB, 0.17682070E-05_JPRB, &
  & 0.17681606E-05_JPRB, 0.17681052E-05_JPRB, 0.17680345E-05_JPRB, 0.17679008E-05_JPRB /)

RGHG2(:,59, 1) = (/ &
  & 0.17570551E-05_JPRB, 0.17578087E-05_JPRB, 0.17579277E-05_JPRB, 0.17578286E-05_JPRB, 0.17575464E-05_JPRB, 0.17571289E-05_JPRB, &
  & 0.17567836E-05_JPRB, 0.17565651E-05_JPRB, 0.17564180E-05_JPRB, 0.17563093E-05_JPRB, 0.17562141E-05_JPRB, 0.17561185E-05_JPRB, &
  & 0.17559976E-05_JPRB, 0.17558409E-05_JPRB, 0.17555458E-05_JPRB, 0.17550706E-05_JPRB, 0.17540223E-05_JPRB, 0.17525202E-05_JPRB, &
  & 0.17511693E-05_JPRB, 0.17505457E-05_JPRB, 0.17506458E-05_JPRB, 0.17513455E-05_JPRB, 0.17525213E-05_JPRB, 0.17540208E-05_JPRB, &
  & 0.17556727E-05_JPRB, 0.17572830E-05_JPRB, 0.17586525E-05_JPRB, 0.17596660E-05_JPRB, 0.17602596E-05_JPRB, 0.17604663E-05_JPRB, &
  & 0.17603339E-05_JPRB, 0.17599045E-05_JPRB, 0.17592545E-05_JPRB, 0.17585093E-05_JPRB, 0.17578035E-05_JPRB, 0.17572099E-05_JPRB, &
  & 0.17567419E-05_JPRB, 0.17563974E-05_JPRB, 0.17561935E-05_JPRB, 0.17561871E-05_JPRB, 0.17564878E-05_JPRB, 0.17572305E-05_JPRB, &
  & 0.17585060E-05_JPRB, 0.17602956E-05_JPRB, 0.17623204E-05_JPRB, 0.17643027E-05_JPRB, 0.17658858E-05_JPRB, 0.17670595E-05_JPRB, &
  & 0.17678278E-05_JPRB, 0.17683174E-05_JPRB, 0.17686107E-05_JPRB, 0.17687773E-05_JPRB, 0.17688636E-05_JPRB, 0.17689099E-05_JPRB, &
  & 0.17689340E-05_JPRB, 0.17689451E-05_JPRB, 0.17689465E-05_JPRB, 0.17689378E-05_JPRB, 0.17689167E-05_JPRB, 0.17688847E-05_JPRB, &
  & 0.17688426E-05_JPRB, 0.17687917E-05_JPRB, 0.17687250E-05_JPRB, 0.17685901E-05_JPRB /)

RGHG2(:,60, 1) = (/ &
  & 0.17590488E-05_JPRB, 0.17591171E-05_JPRB, 0.17590480E-05_JPRB, 0.17588677E-05_JPRB, 0.17585123E-05_JPRB, 0.17580826E-05_JPRB, &
  & 0.17577231E-05_JPRB, 0.17574805E-05_JPRB, 0.17573277E-05_JPRB, 0.17572124E-05_JPRB, 0.17571142E-05_JPRB, 0.17570115E-05_JPRB, &
  & 0.17568914E-05_JPRB, 0.17567061E-05_JPRB, 0.17564237E-05_JPRB, 0.17558322E-05_JPRB, 0.17547884E-05_JPRB, 0.17532326E-05_JPRB, &
  & 0.17518976E-05_JPRB, 0.17512569E-05_JPRB, 0.17513290E-05_JPRB, 0.17520097E-05_JPRB, 0.17531772E-05_JPRB, 0.17546724E-05_JPRB, &
  & 0.17563184E-05_JPRB, 0.17579094E-05_JPRB, 0.17592615E-05_JPRB, 0.17602421E-05_JPRB, 0.17608064E-05_JPRB, 0.17609798E-05_JPRB, &
  & 0.17608148E-05_JPRB, 0.17603512E-05_JPRB, 0.17596631E-05_JPRB, 0.17588821E-05_JPRB, 0.17581493E-05_JPRB, 0.17575414E-05_JPRB, &
  & 0.17570691E-05_JPRB, 0.17567328E-05_JPRB, 0.17565509E-05_JPRB, 0.17565869E-05_JPRB, 0.17569503E-05_JPRB, 0.17577622E-05_JPRB, &
  & 0.17591099E-05_JPRB, 0.17609283E-05_JPRB, 0.17630122E-05_JPRB, 0.17649795E-05_JPRB, 0.17666235E-05_JPRB, 0.17677817E-05_JPRB, &
  & 0.17685455E-05_JPRB, 0.17690060E-05_JPRB, 0.17692807E-05_JPRB, 0.17694274E-05_JPRB, 0.17695058E-05_JPRB, 0.17695438E-05_JPRB, &
  & 0.17695627E-05_JPRB, 0.17695697E-05_JPRB, 0.17695677E-05_JPRB, 0.17695556E-05_JPRB, 0.17695332E-05_JPRB, 0.17694990E-05_JPRB, &
  & 0.17694570E-05_JPRB, 0.17694070E-05_JPRB, 0.17693430E-05_JPRB, 0.17692219E-05_JPRB /)

RGHG2(:,61, 1) = (/ &
  & 0.17600917E-05_JPRB, 0.17601444E-05_JPRB, 0.17600421E-05_JPRB, 0.17598202E-05_JPRB, 0.17594948E-05_JPRB, 0.17590551E-05_JPRB, &
  & 0.17586823E-05_JPRB, 0.17584293E-05_JPRB, 0.17582636E-05_JPRB, 0.17581438E-05_JPRB, 0.17580396E-05_JPRB, 0.17579341E-05_JPRB, &
  & 0.17577979E-05_JPRB, 0.17576064E-05_JPRB, 0.17572546E-05_JPRB, 0.17566306E-05_JPRB, 0.17554789E-05_JPRB, 0.17539552E-05_JPRB, &
  & 0.17526764E-05_JPRB, 0.17520407E-05_JPRB, 0.17520983E-05_JPRB, 0.17527670E-05_JPRB, 0.17539247E-05_JPRB, 0.17554119E-05_JPRB, &
  & 0.17570381E-05_JPRB, 0.17586058E-05_JPRB, 0.17599208E-05_JPRB, 0.17608720E-05_JPRB, 0.17614005E-05_JPRB, 0.17615455E-05_JPRB, &
  & 0.17613559E-05_JPRB, 0.17608646E-05_JPRB, 0.17601449E-05_JPRB, 0.17593308E-05_JPRB, 0.17585733E-05_JPRB, 0.17579478E-05_JPRB, &
  & 0.17574713E-05_JPRB, 0.17571379E-05_JPRB, 0.17569757E-05_JPRB, 0.17570489E-05_JPRB, 0.17574660E-05_JPRB, 0.17583430E-05_JPRB, &
  & 0.17597408E-05_JPRB, 0.17615937E-05_JPRB, 0.17636671E-05_JPRB, 0.17656653E-05_JPRB, 0.17672924E-05_JPRB, 0.17684740E-05_JPRB, &
  & 0.17692255E-05_JPRB, 0.17696757E-05_JPRB, 0.17699292E-05_JPRB, 0.17700630E-05_JPRB, 0.17701273E-05_JPRB, 0.17701575E-05_JPRB, &
  & 0.17701693E-05_JPRB, 0.17701698E-05_JPRB, 0.17701607E-05_JPRB, 0.17701425E-05_JPRB, 0.17701128E-05_JPRB, 0.17700737E-05_JPRB, &
  & 0.17700262E-05_JPRB, 0.17699720E-05_JPRB, 0.17699037E-05_JPRB, 0.17697721E-05_JPRB /)

RGHG2(:,62, 1) = (/ &
  & 0.17611098E-05_JPRB, 0.17611171E-05_JPRB, 0.17609943E-05_JPRB, 0.17607890E-05_JPRB, 0.17604589E-05_JPRB, 0.17600571E-05_JPRB, &
  & 0.17596763E-05_JPRB, 0.17594018E-05_JPRB, 0.17592281E-05_JPRB, 0.17591012E-05_JPRB, 0.17589970E-05_JPRB, 0.17588859E-05_JPRB, &
  & 0.17587460E-05_JPRB, 0.17585174E-05_JPRB, 0.17581293E-05_JPRB, 0.17573961E-05_JPRB, 0.17561979E-05_JPRB, 0.17547435E-05_JPRB, &
  & 0.17535301E-05_JPRB, 0.17529150E-05_JPRB, 0.17529702E-05_JPRB, 0.17536310E-05_JPRB, 0.17547800E-05_JPRB, 0.17562477E-05_JPRB, &
  & 0.17578479E-05_JPRB, 0.17593752E-05_JPRB, 0.17606516E-05_JPRB, 0.17615603E-05_JPRB, 0.17620559E-05_JPRB, 0.17621750E-05_JPRB, &
  & 0.17619670E-05_JPRB, 0.17614578E-05_JPRB, 0.17607136E-05_JPRB, 0.17598720E-05_JPRB, 0.17590880E-05_JPRB, 0.17584479E-05_JPRB, &
  & 0.17579594E-05_JPRB, 0.17576284E-05_JPRB, 0.17574794E-05_JPRB, 0.17575841E-05_JPRB, 0.17580483E-05_JPRB, 0.17589778E-05_JPRB, &
  & 0.17604171E-05_JPRB, 0.17622866E-05_JPRB, 0.17643511E-05_JPRB, 0.17663153E-05_JPRB, 0.17679540E-05_JPRB, 0.17691282E-05_JPRB, &
  & 0.17698891E-05_JPRB, 0.17703296E-05_JPRB, 0.17705703E-05_JPRB, 0.17706875E-05_JPRB, 0.17707405E-05_JPRB, 0.17707596E-05_JPRB, &
  & 0.17707621E-05_JPRB, 0.17707537E-05_JPRB, 0.17707366E-05_JPRB, 0.17707084E-05_JPRB, 0.17706700E-05_JPRB, 0.17706207E-05_JPRB, &
  & 0.17705651E-05_JPRB, 0.17705033E-05_JPRB, 0.17704280E-05_JPRB, 0.17702902E-05_JPRB /)

RGHG2(:,63, 1) = (/ &
  & 0.17620607E-05_JPRB, 0.17620706E-05_JPRB, 0.17619532E-05_JPRB, 0.17617494E-05_JPRB, 0.17614589E-05_JPRB, 0.17610666E-05_JPRB, &
  & 0.17606899E-05_JPRB, 0.17603968E-05_JPRB, 0.17602104E-05_JPRB, 0.17600826E-05_JPRB, 0.17599809E-05_JPRB, 0.17598786E-05_JPRB, &
  & 0.17597290E-05_JPRB, 0.17594824E-05_JPRB, 0.17590182E-05_JPRB, 0.17582133E-05_JPRB, 0.17570135E-05_JPRB, 0.17556298E-05_JPRB, &
  & 0.17544854E-05_JPRB, 0.17538987E-05_JPRB, 0.17539594E-05_JPRB, 0.17546171E-05_JPRB, 0.17557495E-05_JPRB, 0.17571950E-05_JPRB, &
  & 0.17587527E-05_JPRB, 0.17602331E-05_JPRB, 0.17614569E-05_JPRB, 0.17623206E-05_JPRB, 0.17627797E-05_JPRB, 0.17628774E-05_JPRB, &
  & 0.17626591E-05_JPRB, 0.17621406E-05_JPRB, 0.17613820E-05_JPRB, 0.17605178E-05_JPRB, 0.17597134E-05_JPRB, 0.17590523E-05_JPRB, &
  & 0.17585544E-05_JPRB, 0.17582171E-05_JPRB, 0.17580771E-05_JPRB, 0.17582061E-05_JPRB, 0.17587076E-05_JPRB, 0.17596798E-05_JPRB, &
  & 0.17611524E-05_JPRB, 0.17630214E-05_JPRB, 0.17650609E-05_JPRB, 0.17669892E-05_JPRB, 0.17685917E-05_JPRB, 0.17697723E-05_JPRB, &
  & 0.17705333E-05_JPRB, 0.17709757E-05_JPRB, 0.17712059E-05_JPRB, 0.17713103E-05_JPRB, 0.17713494E-05_JPRB, 0.17713569E-05_JPRB, &
  & 0.17713487E-05_JPRB, 0.17713296E-05_JPRB, 0.17712998E-05_JPRB, 0.17712603E-05_JPRB, 0.17712075E-05_JPRB, 0.17711460E-05_JPRB, &
  & 0.17710777E-05_JPRB, 0.17710050E-05_JPRB, 0.17709181E-05_JPRB, 0.17707602E-05_JPRB /)

RGHG2(:,64, 1) = (/ &
  & 0.17630206E-05_JPRB, 0.17630335E-05_JPRB, 0.17629220E-05_JPRB, 0.17627367E-05_JPRB, 0.17624571E-05_JPRB, 0.17620937E-05_JPRB, &
  & 0.17617092E-05_JPRB, 0.17614022E-05_JPRB, 0.17612045E-05_JPRB, 0.17610780E-05_JPRB, 0.17609916E-05_JPRB, 0.17609023E-05_JPRB, &
  & 0.17607588E-05_JPRB, 0.17604790E-05_JPRB, 0.17599664E-05_JPRB, 0.17591229E-05_JPRB, 0.17579401E-05_JPRB, 0.17566282E-05_JPRB, &
  & 0.17555496E-05_JPRB, 0.17550002E-05_JPRB, 0.17550741E-05_JPRB, 0.17557253E-05_JPRB, 0.17568404E-05_JPRB, 0.17582438E-05_JPRB, &
  & 0.17597533E-05_JPRB, 0.17611706E-05_JPRB, 0.17623352E-05_JPRB, 0.17631455E-05_JPRB, 0.17635680E-05_JPRB, 0.17636463E-05_JPRB, &
  & 0.17634245E-05_JPRB, 0.17629076E-05_JPRB, 0.17621450E-05_JPRB, 0.17612704E-05_JPRB, 0.17604501E-05_JPRB, 0.17597752E-05_JPRB, &
  & 0.17592619E-05_JPRB, 0.17589173E-05_JPRB, 0.17587799E-05_JPRB, 0.17589251E-05_JPRB, 0.17594551E-05_JPRB, 0.17604583E-05_JPRB, &
  & 0.17619451E-05_JPRB, 0.17638073E-05_JPRB, 0.17658022E-05_JPRB, 0.17676745E-05_JPRB, 0.17692382E-05_JPRB, 0.17703967E-05_JPRB, &
  & 0.17711641E-05_JPRB, 0.17716112E-05_JPRB, 0.17718363E-05_JPRB, 0.17719294E-05_JPRB, 0.17719556E-05_JPRB, 0.17719499E-05_JPRB, &
  & 0.17719285E-05_JPRB, 0.17718958E-05_JPRB, 0.17718530E-05_JPRB, 0.17717965E-05_JPRB, 0.17717288E-05_JPRB, 0.17716497E-05_JPRB, &
  & 0.17715666E-05_JPRB, 0.17714790E-05_JPRB, 0.17713755E-05_JPRB, 0.17711906E-05_JPRB /)

RGHG2(:,65, 1) = (/ &
  & 0.17639923E-05_JPRB, 0.17640152E-05_JPRB, 0.17639139E-05_JPRB, 0.17637371E-05_JPRB, 0.17634773E-05_JPRB, 0.17631211E-05_JPRB, &
  & 0.17627439E-05_JPRB, 0.17624158E-05_JPRB, 0.17622219E-05_JPRB, 0.17621014E-05_JPRB, 0.17620349E-05_JPRB, 0.17619662E-05_JPRB, &
  & 0.17618252E-05_JPRB, 0.17615309E-05_JPRB, 0.17609897E-05_JPRB, 0.17601351E-05_JPRB, 0.17589871E-05_JPRB, 0.17577436E-05_JPRB, &
  & 0.17567306E-05_JPRB, 0.17562240E-05_JPRB, 0.17563131E-05_JPRB, 0.17569564E-05_JPRB, 0.17580370E-05_JPRB, 0.17593917E-05_JPRB, &
  & 0.17608302E-05_JPRB, 0.17621755E-05_JPRB, 0.17632685E-05_JPRB, 0.17640212E-05_JPRB, 0.17644049E-05_JPRB, 0.17644666E-05_JPRB, &
  & 0.17642468E-05_JPRB, 0.17637398E-05_JPRB, 0.17629874E-05_JPRB, 0.17621157E-05_JPRB, 0.17612934E-05_JPRB, 0.17606091E-05_JPRB, &
  & 0.17600867E-05_JPRB, 0.17597333E-05_JPRB, 0.17595953E-05_JPRB, 0.17597507E-05_JPRB, 0.17602990E-05_JPRB, 0.17613168E-05_JPRB, &
  & 0.17628067E-05_JPRB, 0.17646362E-05_JPRB, 0.17665800E-05_JPRB, 0.17683856E-05_JPRB, 0.17698891E-05_JPRB, 0.17710204E-05_JPRB, &
  & 0.17717807E-05_JPRB, 0.17722311E-05_JPRB, 0.17724585E-05_JPRB, 0.17725444E-05_JPRB, 0.17725584E-05_JPRB, 0.17725386E-05_JPRB, &
  & 0.17725024E-05_JPRB, 0.17724547E-05_JPRB, 0.17723935E-05_JPRB, 0.17723210E-05_JPRB, 0.17722336E-05_JPRB, 0.17721369E-05_JPRB, &
  & 0.17720357E-05_JPRB, 0.17719292E-05_JPRB, 0.17718035E-05_JPRB, 0.17715755E-05_JPRB /)

RGHG2(:,66, 1) = (/ &
  & 0.17649379E-05_JPRB, 0.17650020E-05_JPRB, 0.17649171E-05_JPRB, 0.17647573E-05_JPRB, 0.17645076E-05_JPRB, 0.17641635E-05_JPRB, &
  & 0.17637849E-05_JPRB, 0.17634595E-05_JPRB, 0.17632681E-05_JPRB, 0.17631689E-05_JPRB, 0.17631230E-05_JPRB, 0.17630724E-05_JPRB, &
  & 0.17629377E-05_JPRB, 0.17626376E-05_JPRB, 0.17620906E-05_JPRB, 0.17612482E-05_JPRB, 0.17601421E-05_JPRB, 0.17589682E-05_JPRB, &
  & 0.17580268E-05_JPRB, 0.17575645E-05_JPRB, 0.17576674E-05_JPRB, 0.17582913E-05_JPRB, 0.17593283E-05_JPRB, 0.17606106E-05_JPRB, &
  & 0.17619701E-05_JPRB, 0.17632265E-05_JPRB, 0.17642420E-05_JPRB, 0.17649309E-05_JPRB, 0.17652749E-05_JPRB, 0.17653215E-05_JPRB, &
  & 0.17651075E-05_JPRB, 0.17646183E-05_JPRB, 0.17638873E-05_JPRB, 0.17630339E-05_JPRB, 0.17622243E-05_JPRB, 0.17615456E-05_JPRB, &
  & 0.17610217E-05_JPRB, 0.17606645E-05_JPRB, 0.17605262E-05_JPRB, 0.17606865E-05_JPRB, 0.17612427E-05_JPRB, 0.17622638E-05_JPRB, &
  & 0.17637312E-05_JPRB, 0.17655171E-05_JPRB, 0.17673867E-05_JPRB, 0.17691182E-05_JPRB, 0.17705586E-05_JPRB, 0.17716441E-05_JPRB, &
  & 0.17723881E-05_JPRB, 0.17728391E-05_JPRB, 0.17730671E-05_JPRB, 0.17731509E-05_JPRB, 0.17731561E-05_JPRB, 0.17731240E-05_JPRB, &
  & 0.17730731E-05_JPRB, 0.17730069E-05_JPRB, 0.17729300E-05_JPRB, 0.17728364E-05_JPRB, 0.17727316E-05_JPRB, 0.17726156E-05_JPRB, &
  & 0.17724940E-05_JPRB, 0.17723669E-05_JPRB, 0.17722089E-05_JPRB, 0.17719228E-05_JPRB /)

RGHG2(:,67, 1) = (/ &
  & 0.17659185E-05_JPRB, 0.17660112E-05_JPRB, 0.17659422E-05_JPRB, 0.17657916E-05_JPRB, 0.17655552E-05_JPRB, 0.17652201E-05_JPRB, &
  & 0.17648487E-05_JPRB, 0.17645305E-05_JPRB, 0.17643621E-05_JPRB, 0.17642847E-05_JPRB, 0.17642625E-05_JPRB, 0.17642268E-05_JPRB, &
  & 0.17641003E-05_JPRB, 0.17638048E-05_JPRB, 0.17632660E-05_JPRB, 0.17624508E-05_JPRB, 0.17613964E-05_JPRB, 0.17603011E-05_JPRB, &
  & 0.17594285E-05_JPRB, 0.17590083E-05_JPRB, 0.17591154E-05_JPRB, 0.17597098E-05_JPRB, 0.17606839E-05_JPRB, 0.17618875E-05_JPRB, &
  & 0.17631481E-05_JPRB, 0.17643131E-05_JPRB, 0.17652410E-05_JPRB, 0.17658672E-05_JPRB, 0.17661700E-05_JPRB, 0.17662024E-05_JPRB, &
  & 0.17659968E-05_JPRB, 0.17655308E-05_JPRB, 0.17648304E-05_JPRB, 0.17640077E-05_JPRB, 0.17632262E-05_JPRB, 0.17625678E-05_JPRB, &
  & 0.17620537E-05_JPRB, 0.17617018E-05_JPRB, 0.17615660E-05_JPRB, 0.17617299E-05_JPRB, 0.17622872E-05_JPRB, 0.17632933E-05_JPRB, &
  & 0.17647259E-05_JPRB, 0.17664402E-05_JPRB, 0.17682289E-05_JPRB, 0.17698711E-05_JPRB, 0.17712396E-05_JPRB, 0.17722768E-05_JPRB, &
  & 0.17729909E-05_JPRB, 0.17734326E-05_JPRB, 0.17736613E-05_JPRB, 0.17737455E-05_JPRB, 0.17737464E-05_JPRB, 0.17737040E-05_JPRB, &
  & 0.17736404E-05_JPRB, 0.17735606E-05_JPRB, 0.17734642E-05_JPRB, 0.17733565E-05_JPRB, 0.17732336E-05_JPRB, 0.17731002E-05_JPRB, &
  & 0.17729619E-05_JPRB, 0.17728053E-05_JPRB, 0.17726120E-05_JPRB, 0.17722308E-05_JPRB /)

RGHG2(:,68, 1) = (/ &
  & 0.17668788E-05_JPRB, 0.17670244E-05_JPRB, 0.17669759E-05_JPRB, 0.17668428E-05_JPRB, 0.17666175E-05_JPRB, 0.17662933E-05_JPRB, &
  & 0.17659419E-05_JPRB, 0.17656415E-05_JPRB, 0.17655029E-05_JPRB, 0.17654534E-05_JPRB, 0.17654511E-05_JPRB, 0.17654294E-05_JPRB, &
  & 0.17653118E-05_JPRB, 0.17650256E-05_JPRB, 0.17645066E-05_JPRB, 0.17637307E-05_JPRB, 0.17627369E-05_JPRB, 0.17617203E-05_JPRB, &
  & 0.17609134E-05_JPRB, 0.17605269E-05_JPRB, 0.17606308E-05_JPRB, 0.17611831E-05_JPRB, 0.17620877E-05_JPRB, 0.17631962E-05_JPRB, &
  & 0.17643598E-05_JPRB, 0.17654211E-05_JPRB, 0.17662655E-05_JPRB, 0.17668253E-05_JPRB, 0.17670898E-05_JPRB, 0.17671094E-05_JPRB, &
  & 0.17669145E-05_JPRB, 0.17664761E-05_JPRB, 0.17658119E-05_JPRB, 0.17650299E-05_JPRB, 0.17642881E-05_JPRB, 0.17636618E-05_JPRB, &
  & 0.17631696E-05_JPRB, 0.17628304E-05_JPRB, 0.17627024E-05_JPRB, 0.17628690E-05_JPRB, 0.17634200E-05_JPRB, 0.17644026E-05_JPRB, &
  & 0.17657777E-05_JPRB, 0.17674113E-05_JPRB, 0.17690960E-05_JPRB, 0.17706463E-05_JPRB, 0.17719339E-05_JPRB, 0.17729128E-05_JPRB, &
  & 0.17735932E-05_JPRB, 0.17740180E-05_JPRB, 0.17742416E-05_JPRB, 0.17743258E-05_JPRB, 0.17743259E-05_JPRB, 0.17742791E-05_JPRB, &
  & 0.17742076E-05_JPRB, 0.17741147E-05_JPRB, 0.17740092E-05_JPRB, 0.17738860E-05_JPRB, 0.17737522E-05_JPRB, 0.17736070E-05_JPRB, &
  & 0.17734491E-05_JPRB, 0.17732731E-05_JPRB, 0.17730238E-05_JPRB, 0.17725436E-05_JPRB /)

RGHG2(:,69, 1) = (/ &
  & 0.17678508E-05_JPRB, 0.17680559E-05_JPRB, 0.17680316E-05_JPRB, 0.17679135E-05_JPRB, 0.17677047E-05_JPRB, 0.17673980E-05_JPRB, &
  & 0.17670679E-05_JPRB, 0.17668043E-05_JPRB, 0.17666979E-05_JPRB, 0.17666770E-05_JPRB, 0.17666916E-05_JPRB, 0.17666812E-05_JPRB, &
  & 0.17665722E-05_JPRB, 0.17663000E-05_JPRB, 0.17658058E-05_JPRB, 0.17650790E-05_JPRB, 0.17641491E-05_JPRB, 0.17632133E-05_JPRB, &
  & 0.17624652E-05_JPRB, 0.17621052E-05_JPRB, 0.17621942E-05_JPRB, 0.17626974E-05_JPRB, 0.17635226E-05_JPRB, 0.17645378E-05_JPRB, &
  & 0.17655924E-05_JPRB, 0.17665570E-05_JPRB, 0.17673128E-05_JPRB, 0.17678112E-05_JPRB, 0.17680387E-05_JPRB, 0.17680485E-05_JPRB, &
  & 0.17678667E-05_JPRB, 0.17674578E-05_JPRB, 0.17668358E-05_JPRB, 0.17661023E-05_JPRB, 0.17654073E-05_JPRB, 0.17648226E-05_JPRB, &
  & 0.17643597E-05_JPRB, 0.17640407E-05_JPRB, 0.17639240E-05_JPRB, 0.17640945E-05_JPRB, 0.17646349E-05_JPRB, 0.17655805E-05_JPRB, &
  & 0.17668898E-05_JPRB, 0.17684239E-05_JPRB, 0.17699987E-05_JPRB, 0.17714399E-05_JPRB, 0.17726420E-05_JPRB, 0.17735562E-05_JPRB, &
  & 0.17741947E-05_JPRB, 0.17745982E-05_JPRB, 0.17748133E-05_JPRB, 0.17748969E-05_JPRB, 0.17748974E-05_JPRB, 0.17748498E-05_JPRB, &
  & 0.17747752E-05_JPRB, 0.17746785E-05_JPRB, 0.17745650E-05_JPRB, 0.17744377E-05_JPRB, 0.17742969E-05_JPRB, 0.17741431E-05_JPRB, &
  & 0.17739778E-05_JPRB, 0.17737732E-05_JPRB, 0.17734836E-05_JPRB, 0.17728654E-05_JPRB /)

RGHG2(:,70, 1) = (/ &
  & 0.17688189E-05_JPRB, 0.17691034E-05_JPRB, 0.17691106E-05_JPRB, 0.17690149E-05_JPRB, 0.17688239E-05_JPRB, 0.17685389E-05_JPRB, &
  & 0.17682457E-05_JPRB, 0.17680209E-05_JPRB, 0.17679515E-05_JPRB, 0.17679554E-05_JPRB, 0.17679807E-05_JPRB, 0.17679771E-05_JPRB, &
  & 0.17678749E-05_JPRB, 0.17676172E-05_JPRB, 0.17671542E-05_JPRB, 0.17664782E-05_JPRB, 0.17656184E-05_JPRB, 0.17647559E-05_JPRB, &
  & 0.17640627E-05_JPRB, 0.17637230E-05_JPRB, 0.17637942E-05_JPRB, 0.17642417E-05_JPRB, 0.17649869E-05_JPRB, 0.17658986E-05_JPRB, &
  & 0.17668502E-05_JPRB, 0.17677124E-05_JPRB, 0.17683859E-05_JPRB, 0.17688234E-05_JPRB, 0.17690177E-05_JPRB, 0.17690206E-05_JPRB, &
  & 0.17688542E-05_JPRB, 0.17684789E-05_JPRB, 0.17679027E-05_JPRB, 0.17672235E-05_JPRB, 0.17665838E-05_JPRB, 0.17660460E-05_JPRB, &
  & 0.17656190E-05_JPRB, 0.17653251E-05_JPRB, 0.17652228E-05_JPRB, 0.17653965E-05_JPRB, 0.17659204E-05_JPRB, 0.17668215E-05_JPRB, &
  & 0.17680543E-05_JPRB, 0.17694773E-05_JPRB, 0.17709303E-05_JPRB, 0.17722580E-05_JPRB, 0.17733605E-05_JPRB, 0.17742055E-05_JPRB, &
  & 0.17747975E-05_JPRB, 0.17751754E-05_JPRB, 0.17753791E-05_JPRB, 0.17754609E-05_JPRB, 0.17754633E-05_JPRB, 0.17754193E-05_JPRB, &
  & 0.17753482E-05_JPRB, 0.17752526E-05_JPRB, 0.17751411E-05_JPRB, 0.17750132E-05_JPRB, 0.17748720E-05_JPRB, 0.17747167E-05_JPRB, &
  & 0.17745452E-05_JPRB, 0.17743296E-05_JPRB, 0.17739931E-05_JPRB, 0.17732649E-05_JPRB /)

RGHG2(:,71, 1) = (/ &
  & 0.17698054E-05_JPRB, 0.17701841E-05_JPRB, 0.17702259E-05_JPRB, 0.17701525E-05_JPRB, 0.17699838E-05_JPRB, 0.17697259E-05_JPRB, &
  & 0.17694739E-05_JPRB, 0.17692967E-05_JPRB, 0.17692599E-05_JPRB, 0.17692814E-05_JPRB, 0.17693117E-05_JPRB, 0.17693081E-05_JPRB, &
  & 0.17692093E-05_JPRB, 0.17689683E-05_JPRB, 0.17685376E-05_JPRB, 0.17679137E-05_JPRB, 0.17671265E-05_JPRB, 0.17663368E-05_JPRB, &
  & 0.17656978E-05_JPRB, 0.17653763E-05_JPRB, 0.17654247E-05_JPRB, 0.17658149E-05_JPRB, 0.17664715E-05_JPRB, 0.17672845E-05_JPRB, &
  & 0.17681256E-05_JPRB, 0.17688910E-05_JPRB, 0.17694815E-05_JPRB, 0.17698629E-05_JPRB, 0.17700265E-05_JPRB, 0.17700255E-05_JPRB, &
  & 0.17698774E-05_JPRB, 0.17695382E-05_JPRB, 0.17690129E-05_JPRB, 0.17683938E-05_JPRB, 0.17678137E-05_JPRB, 0.17673278E-05_JPRB, &
  & 0.17669419E-05_JPRB, 0.17666771E-05_JPRB, 0.17665913E-05_JPRB, 0.17667662E-05_JPRB, 0.17672681E-05_JPRB, 0.17681194E-05_JPRB, &
  & 0.17692581E-05_JPRB, 0.17705693E-05_JPRB, 0.17718878E-05_JPRB, 0.17730897E-05_JPRB, 0.17740913E-05_JPRB, 0.17748564E-05_JPRB, &
  & 0.17753972E-05_JPRB, 0.17757477E-05_JPRB, 0.17759371E-05_JPRB, 0.17760176E-05_JPRB, 0.17760229E-05_JPRB, 0.17759867E-05_JPRB, &
  & 0.17759229E-05_JPRB, 0.17758371E-05_JPRB, 0.17757313E-05_JPRB, 0.17756109E-05_JPRB, 0.17754730E-05_JPRB, 0.17753225E-05_JPRB, &
  & 0.17751530E-05_JPRB, 0.17749329E-05_JPRB, 0.17745779E-05_JPRB, 0.17737750E-05_JPRB /)

RGHG2(:,72, 1) = (/ &
  & 0.17708214E-05_JPRB, 0.17713029E-05_JPRB, 0.17713812E-05_JPRB, 0.17713314E-05_JPRB, 0.17711849E-05_JPRB, 0.17709582E-05_JPRB, &
  & 0.17707519E-05_JPRB, 0.17706222E-05_JPRB, 0.17706122E-05_JPRB, 0.17706416E-05_JPRB, 0.17706684E-05_JPRB, 0.17706575E-05_JPRB, &
  & 0.17705651E-05_JPRB, 0.17703361E-05_JPRB, 0.17699412E-05_JPRB, 0.17693706E-05_JPRB, 0.17686582E-05_JPRB, 0.17679399E-05_JPRB, &
  & 0.17673563E-05_JPRB, 0.17670552E-05_JPRB, 0.17670818E-05_JPRB, 0.17674103E-05_JPRB, 0.17679806E-05_JPRB, 0.17686873E-05_JPRB, &
  & 0.17694224E-05_JPRB, 0.17700885E-05_JPRB, 0.17706002E-05_JPRB, 0.17709277E-05_JPRB, 0.17710641E-05_JPRB, 0.17710619E-05_JPRB, &
  & 0.17709328E-05_JPRB, 0.17706338E-05_JPRB, 0.17701628E-05_JPRB, 0.17696102E-05_JPRB, 0.17690934E-05_JPRB, 0.17686650E-05_JPRB, &
  & 0.17683235E-05_JPRB, 0.17680918E-05_JPRB, 0.17680238E-05_JPRB, 0.17681976E-05_JPRB, 0.17686734E-05_JPRB, 0.17694585E-05_JPRB, &
  & 0.17705058E-05_JPRB, 0.17716786E-05_JPRB, 0.17728623E-05_JPRB, 0.17739362E-05_JPRB, 0.17748221E-05_JPRB, 0.17755057E-05_JPRB, &
  & 0.17759947E-05_JPRB, 0.17763086E-05_JPRB, 0.17764860E-05_JPRB, 0.17765625E-05_JPRB, 0.17765728E-05_JPRB, 0.17765458E-05_JPRB, &
  & 0.17764954E-05_JPRB, 0.17764191E-05_JPRB, 0.17763290E-05_JPRB, 0.17762145E-05_JPRB, 0.17760912E-05_JPRB, 0.17759454E-05_JPRB, &
  & 0.17757880E-05_JPRB, 0.17755714E-05_JPRB, 0.17752125E-05_JPRB, 0.17743698E-05_JPRB /)

RGHG2(:,73, 1) = (/ &
  & 0.17719881E-05_JPRB, 0.17724904E-05_JPRB, 0.17725795E-05_JPRB, 0.17725429E-05_JPRB, 0.17724158E-05_JPRB, 0.17722214E-05_JPRB, &
  & 0.17720623E-05_JPRB, 0.17719726E-05_JPRB, 0.17719778E-05_JPRB, 0.17720074E-05_JPRB, 0.17720304E-05_JPRB, 0.17720149E-05_JPRB, &
  & 0.17719169E-05_JPRB, 0.17717127E-05_JPRB, 0.17713484E-05_JPRB, 0.17708310E-05_JPRB, 0.17701964E-05_JPRB, 0.17695531E-05_JPRB, &
  & 0.17690311E-05_JPRB, 0.17687521E-05_JPRB, 0.17687565E-05_JPRB, 0.17690245E-05_JPRB, 0.17695048E-05_JPRB, 0.17701103E-05_JPRB, &
  & 0.17707371E-05_JPRB, 0.17713069E-05_JPRB, 0.17717405E-05_JPRB, 0.17720175E-05_JPRB, 0.17721286E-05_JPRB, 0.17721271E-05_JPRB, &
  & 0.17720188E-05_JPRB, 0.17717612E-05_JPRB, 0.17713496E-05_JPRB, 0.17708670E-05_JPRB, 0.17704176E-05_JPRB, 0.17700493E-05_JPRB, &
  & 0.17697560E-05_JPRB, 0.17695595E-05_JPRB, 0.17695090E-05_JPRB, 0.17696800E-05_JPRB, 0.17701190E-05_JPRB, 0.17708371E-05_JPRB, &
  & 0.17717615E-05_JPRB, 0.17728044E-05_JPRB, 0.17738416E-05_JPRB, 0.17747725E-05_JPRB, 0.17755526E-05_JPRB, 0.17761500E-05_JPRB, &
  & 0.17765745E-05_JPRB, 0.17768617E-05_JPRB, 0.17770176E-05_JPRB, 0.17770913E-05_JPRB, 0.17771057E-05_JPRB, 0.17770901E-05_JPRB, &
  & 0.17770487E-05_JPRB, 0.17769908E-05_JPRB, 0.17769084E-05_JPRB, 0.17768157E-05_JPRB, 0.17766972E-05_JPRB, 0.17765724E-05_JPRB, &
  & 0.17764226E-05_JPRB, 0.17762241E-05_JPRB, 0.17758708E-05_JPRB, 0.17750207E-05_JPRB /)

RGHG2(:,74, 1) = (/ &
  & 0.17731696E-05_JPRB, 0.17736957E-05_JPRB, 0.17737896E-05_JPRB, 0.17737640E-05_JPRB, 0.17736560E-05_JPRB, 0.17734945E-05_JPRB, &
  & 0.17733719E-05_JPRB, 0.17733126E-05_JPRB, 0.17733262E-05_JPRB, 0.17733560E-05_JPRB, 0.17733714E-05_JPRB, 0.17733489E-05_JPRB, &
  & 0.17732660E-05_JPRB, 0.17730667E-05_JPRB, 0.17727449E-05_JPRB, 0.17722828E-05_JPRB, 0.17717249E-05_JPRB, 0.17711650E-05_JPRB, &
  & 0.17707068E-05_JPRB, 0.17704569E-05_JPRB, 0.17704426E-05_JPRB, 0.17706512E-05_JPRB, 0.17710453E-05_JPRB, 0.17715486E-05_JPRB, &
  & 0.17720689E-05_JPRB, 0.17725441E-05_JPRB, 0.17729021E-05_JPRB, 0.17731313E-05_JPRB, 0.17732198E-05_JPRB, 0.17732200E-05_JPRB, &
  & 0.17731322E-05_JPRB, 0.17729178E-05_JPRB, 0.17725680E-05_JPRB, 0.17721590E-05_JPRB, 0.17717811E-05_JPRB, 0.17714752E-05_JPRB, &
  & 0.17712308E-05_JPRB, 0.17710715E-05_JPRB, 0.17710372E-05_JPRB, 0.17712002E-05_JPRB, 0.17715972E-05_JPRB, 0.17722261E-05_JPRB, &
  & 0.17730334E-05_JPRB, 0.17739221E-05_JPRB, 0.17748041E-05_JPRB, 0.17756109E-05_JPRB, 0.17762660E-05_JPRB, 0.17767770E-05_JPRB, &
  & 0.17771490E-05_JPRB, 0.17773898E-05_JPRB, 0.17775324E-05_JPRB, 0.17776001E-05_JPRB, 0.17776164E-05_JPRB, 0.17776082E-05_JPRB, &
  & 0.17775794E-05_JPRB, 0.17775299E-05_JPRB, 0.17774687E-05_JPRB, 0.17773831E-05_JPRB, 0.17772907E-05_JPRB, 0.17771730E-05_JPRB, &
  & 0.17770490E-05_JPRB, 0.17768657E-05_JPRB, 0.17765353E-05_JPRB, 0.17757105E-05_JPRB /)

RGHG2(:,75, 1) = (/ &
  & 0.17743527E-05_JPRB, 0.17748833E-05_JPRB, 0.17749860E-05_JPRB, 0.17749716E-05_JPRB, 0.17748819E-05_JPRB, 0.17747489E-05_JPRB, &
  & 0.17746590E-05_JPRB, 0.17746187E-05_JPRB, 0.17746363E-05_JPRB, 0.17746618E-05_JPRB, 0.17746756E-05_JPRB, 0.17746561E-05_JPRB, &
  & 0.17745696E-05_JPRB, 0.17744062E-05_JPRB, 0.17741135E-05_JPRB, 0.17737154E-05_JPRB, 0.17732425E-05_JPRB, 0.17727696E-05_JPRB, &
  & 0.17723823E-05_JPRB, 0.17721660E-05_JPRB, 0.17721381E-05_JPRB, 0.17722930E-05_JPRB, 0.17726034E-05_JPRB, 0.17730079E-05_JPRB, &
  & 0.17734245E-05_JPRB, 0.17738059E-05_JPRB, 0.17740908E-05_JPRB, 0.17742747E-05_JPRB, 0.17743417E-05_JPRB, 0.17743446E-05_JPRB, &
  & 0.17742764E-05_JPRB, 0.17741046E-05_JPRB, 0.17738187E-05_JPRB, 0.17734851E-05_JPRB, 0.17731813E-05_JPRB, 0.17729371E-05_JPRB, &
  & 0.17727423E-05_JPRB, 0.17726197E-05_JPRB, 0.17725991E-05_JPRB, 0.17727498E-05_JPRB, 0.17730916E-05_JPRB, 0.17736305E-05_JPRB, &
  & 0.17742955E-05_JPRB, 0.17750299E-05_JPRB, 0.17757665E-05_JPRB, 0.17764193E-05_JPRB, 0.17769726E-05_JPRB, 0.17773922E-05_JPRB, &
  & 0.17776964E-05_JPRB, 0.17779051E-05_JPRB, 0.17780225E-05_JPRB, 0.17780839E-05_JPRB, 0.17780999E-05_JPRB, 0.17780985E-05_JPRB, &
  & 0.17780756E-05_JPRB, 0.17780405E-05_JPRB, 0.17779876E-05_JPRB, 0.17779259E-05_JPRB, 0.17778452E-05_JPRB, 0.17777534E-05_JPRB, &
  & 0.17776455E-05_JPRB, 0.17774901E-05_JPRB, 0.17771913E-05_JPRB, 0.17764197E-05_JPRB /)

RGHG2(:,76, 1) = (/ &
  & 0.17755070E-05_JPRB, 0.17760483E-05_JPRB, 0.17761513E-05_JPRB, 0.17761479E-05_JPRB, 0.17760769E-05_JPRB, 0.17759719E-05_JPRB, &
  & 0.17759060E-05_JPRB, 0.17758782E-05_JPRB, 0.17758944E-05_JPRB, 0.17759166E-05_JPRB, 0.17759232E-05_JPRB, 0.17759010E-05_JPRB, &
  & 0.17758384E-05_JPRB, 0.17756898E-05_JPRB, 0.17754556E-05_JPRB, 0.17751272E-05_JPRB, 0.17747483E-05_JPRB, 0.17743700E-05_JPRB, &
  & 0.17740559E-05_JPRB, 0.17738788E-05_JPRB, 0.17738441E-05_JPRB, 0.17739524E-05_JPRB, 0.17741831E-05_JPRB, 0.17744909E-05_JPRB, &
  & 0.17748047E-05_JPRB, 0.17750955E-05_JPRB, 0.17753102E-05_JPRB, 0.17754513E-05_JPRB, 0.17754993E-05_JPRB, 0.17755043E-05_JPRB, &
  & 0.17754528E-05_JPRB, 0.17753227E-05_JPRB, 0.17751014E-05_JPRB, 0.17748461E-05_JPRB, 0.17746155E-05_JPRB, 0.17744337E-05_JPRB, &
  & 0.17742850E-05_JPRB, 0.17741978E-05_JPRB, 0.17741861E-05_JPRB, 0.17743176E-05_JPRB, 0.17745989E-05_JPRB, 0.17750306E-05_JPRB, &
  & 0.17755556E-05_JPRB, 0.17761294E-05_JPRB, 0.17767020E-05_JPRB, 0.17772290E-05_JPRB, 0.17776531E-05_JPRB, 0.17779864E-05_JPRB, &
  & 0.17782299E-05_JPRB, 0.17783922E-05_JPRB, 0.17784887E-05_JPRB, 0.17785414E-05_JPRB, 0.17785534E-05_JPRB, 0.17785568E-05_JPRB, &
  & 0.17785400E-05_JPRB, 0.17785128E-05_JPRB, 0.17784757E-05_JPRB, 0.17784291E-05_JPRB, 0.17783725E-05_JPRB, 0.17782970E-05_JPRB, &
  & 0.17782144E-05_JPRB, 0.17780865E-05_JPRB, 0.17778281E-05_JPRB, 0.17771391E-05_JPRB /)

RGHG2(:,77, 1) = (/ &
  & 0.17766420E-05_JPRB, 0.17771576E-05_JPRB, 0.17772638E-05_JPRB, 0.17772715E-05_JPRB, 0.17772205E-05_JPRB, 0.17771411E-05_JPRB, &
  & 0.17770996E-05_JPRB, 0.17770781E-05_JPRB, 0.17770876E-05_JPRB, 0.17770974E-05_JPRB, 0.17770949E-05_JPRB, 0.17770761E-05_JPRB, &
  & 0.17770245E-05_JPRB, 0.17769255E-05_JPRB, 0.17767459E-05_JPRB, 0.17765067E-05_JPRB, 0.17762308E-05_JPRB, 0.17759539E-05_JPRB, &
  & 0.17757167E-05_JPRB, 0.17755855E-05_JPRB, 0.17755517E-05_JPRB, 0.17756204E-05_JPRB, 0.17757777E-05_JPRB, 0.17759946E-05_JPRB, &
  & 0.17762118E-05_JPRB, 0.17764175E-05_JPRB, 0.17765658E-05_JPRB, 0.17766674E-05_JPRB, 0.17766971E-05_JPRB, 0.17767026E-05_JPRB, &
  & 0.17766648E-05_JPRB, 0.17765733E-05_JPRB, 0.17764130E-05_JPRB, 0.17762318E-05_JPRB, 0.17760717E-05_JPRB, 0.17759471E-05_JPRB, &
  & 0.17758431E-05_JPRB, 0.17757866E-05_JPRB, 0.17757785E-05_JPRB, 0.17758850E-05_JPRB, 0.17760932E-05_JPRB, 0.17764166E-05_JPRB, &
  & 0.17767895E-05_JPRB, 0.17772019E-05_JPRB, 0.17776231E-05_JPRB, 0.17780010E-05_JPRB, 0.17783178E-05_JPRB, 0.17785553E-05_JPRB, &
  & 0.17787346E-05_JPRB, 0.17788557E-05_JPRB, 0.17789243E-05_JPRB, 0.17789667E-05_JPRB, 0.17789724E-05_JPRB, 0.17789800E-05_JPRB, &
  & 0.17789655E-05_JPRB, 0.17789484E-05_JPRB, 0.17789217E-05_JPRB, 0.17788947E-05_JPRB, 0.17788577E-05_JPRB, 0.17788028E-05_JPRB, &
  & 0.17787448E-05_JPRB, 0.17786448E-05_JPRB, 0.17784376E-05_JPRB, 0.17778501E-05_JPRB /)

RGHG2(:,78, 1) = (/ &
  & 0.17777330E-05_JPRB, 0.17781681E-05_JPRB, 0.17782453E-05_JPRB, 0.17782612E-05_JPRB, 0.17782291E-05_JPRB, 0.17781790E-05_JPRB, &
  & 0.17781603E-05_JPRB, 0.17781447E-05_JPRB, 0.17781421E-05_JPRB, 0.17781372E-05_JPRB, 0.17781207E-05_JPRB, 0.17781025E-05_JPRB, &
  & 0.17780782E-05_JPRB, 0.17780227E-05_JPRB, 0.17779156E-05_JPRB, 0.17777654E-05_JPRB, 0.17775966E-05_JPRB, 0.17774219E-05_JPRB, &
  & 0.17772658E-05_JPRB, 0.17771862E-05_JPRB, 0.17771627E-05_JPRB, 0.17772038E-05_JPRB, 0.17772981E-05_JPRB, 0.17774353E-05_JPRB, &
  & 0.17775681E-05_JPRB, 0.17776988E-05_JPRB, 0.17777907E-05_JPRB, 0.17778573E-05_JPRB, 0.17778709E-05_JPRB, 0.17778752E-05_JPRB, &
  & 0.17778466E-05_JPRB, 0.17777874E-05_JPRB, 0.17776819E-05_JPRB, 0.17775676E-05_JPRB, 0.17774682E-05_JPRB, 0.17773909E-05_JPRB, &
  & 0.17773226E-05_JPRB, 0.17772895E-05_JPRB, 0.17772762E-05_JPRB, 0.17773490E-05_JPRB, 0.17774796E-05_JPRB, 0.17776899E-05_JPRB, &
  & 0.17779196E-05_JPRB, 0.17781786E-05_JPRB, 0.17784530E-05_JPRB, 0.17787063E-05_JPRB, 0.17789110E-05_JPRB, 0.17790662E-05_JPRB, &
  & 0.17791848E-05_JPRB, 0.17792627E-05_JPRB, 0.17793053E-05_JPRB, 0.17793363E-05_JPRB, 0.17793323E-05_JPRB, 0.17793429E-05_JPRB, &
  & 0.17793287E-05_JPRB, 0.17793188E-05_JPRB, 0.17793011E-05_JPRB, 0.17792898E-05_JPRB, 0.17792710E-05_JPRB, 0.17792349E-05_JPRB, &
  & 0.17791992E-05_JPRB, 0.17791273E-05_JPRB, 0.17789848E-05_JPRB, 0.17785461E-05_JPRB /)

RGHG2(:,79, 1) = (/ &
  & 0.17784350E-05_JPRB, 0.17787290E-05_JPRB, 0.17787654E-05_JPRB, 0.17787720E-05_JPRB, 0.17787478E-05_JPRB, 0.17787115E-05_JPRB, &
  & 0.17787077E-05_JPRB, 0.17786946E-05_JPRB, 0.17786880E-05_JPRB, 0.17786770E-05_JPRB, 0.17786565E-05_JPRB, 0.17786407E-05_JPRB, &
  & 0.17786302E-05_JPRB, 0.17786010E-05_JPRB, 0.17785279E-05_JPRB, 0.17784259E-05_JPRB, 0.17783136E-05_JPRB, 0.17781964E-05_JPRB, &
  & 0.17780835E-05_JPRB, 0.17780358E-05_JPRB, 0.17780197E-05_JPRB, 0.17780476E-05_JPRB, 0.17781099E-05_JPRB, 0.17782070E-05_JPRB, &
  & 0.17782953E-05_JPRB, 0.17783882E-05_JPRB, 0.17784500E-05_JPRB, 0.17785001E-05_JPRB, 0.17785055E-05_JPRB, 0.17785104E-05_JPRB, &
  & 0.17784864E-05_JPRB, 0.17784447E-05_JPRB, 0.17783675E-05_JPRB, 0.17782902E-05_JPRB, 0.17782229E-05_JPRB, 0.17781717E-05_JPRB, &
  & 0.17781202E-05_JPRB, 0.17780987E-05_JPRB, 0.17780790E-05_JPRB, 0.17781318E-05_JPRB, 0.17782177E-05_JPRB, 0.17783680E-05_JPRB, &
  & 0.17785175E-05_JPRB, 0.17786946E-05_JPRB, 0.17788932E-05_JPRB, 0.17790784E-05_JPRB, 0.17792280E-05_JPRB, 0.17793365E-05_JPRB, &
  & 0.17794237E-05_JPRB, 0.17794789E-05_JPRB, 0.17795066E-05_JPRB, 0.17795315E-05_JPRB, 0.17795199E-05_JPRB, 0.17795327E-05_JPRB, &
  & 0.17795169E-05_JPRB, 0.17795104E-05_JPRB, 0.17794966E-05_JPRB, 0.17794944E-05_JPRB, 0.17794856E-05_JPRB, 0.17794587E-05_JPRB, &
  & 0.17794356E-05_JPRB, 0.17793835E-05_JPRB, 0.17792900E-05_JPRB, 0.17789894E-05_JPRB /)

RGHG2(:,80, 1) = (/ &
  & 0.17788974E-05_JPRB, 0.17789989E-05_JPRB, 0.17789919E-05_JPRB, 0.17789926E-05_JPRB, 0.17789697E-05_JPRB, 0.17789391E-05_JPRB, &
  & 0.17789423E-05_JPRB, 0.17789328E-05_JPRB, 0.17789253E-05_JPRB, 0.17789162E-05_JPRB, 0.17788939E-05_JPRB, 0.17788814E-05_JPRB, &
  & 0.17788781E-05_JPRB, 0.17788594E-05_JPRB, 0.17787997E-05_JPRB, 0.17787165E-05_JPRB, 0.17786301E-05_JPRB, 0.17785384E-05_JPRB, &
  & 0.17784456E-05_JPRB, 0.17784135E-05_JPRB, 0.17784023E-05_JPRB, 0.17784253E-05_JPRB, 0.17784735E-05_JPRB, 0.17785529E-05_JPRB, &
  & 0.17786226E-05_JPRB, 0.17786995E-05_JPRB, 0.17787486E-05_JPRB, 0.17787925E-05_JPRB, 0.17787938E-05_JPRB, 0.17788000E-05_JPRB, &
  & 0.17787775E-05_JPRB, 0.17787437E-05_JPRB, 0.17786790E-05_JPRB, 0.17786185E-05_JPRB, 0.17785663E-05_JPRB, 0.17785261E-05_JPRB, &
  & 0.17784813E-05_JPRB, 0.17784649E-05_JPRB, 0.17784400E-05_JPRB, 0.17784840E-05_JPRB, 0.17785484E-05_JPRB, 0.17786712E-05_JPRB, &
  & 0.17787845E-05_JPRB, 0.17789239E-05_JPRB, 0.17790891E-05_JPRB, 0.17792445E-05_JPRB, 0.17793682E-05_JPRB, 0.17794563E-05_JPRB, &
  & 0.17795294E-05_JPRB, 0.17795746E-05_JPRB, 0.17795952E-05_JPRB, 0.17796173E-05_JPRB, 0.17796010E-05_JPRB, 0.17796153E-05_JPRB, &
  & 0.17795977E-05_JPRB, 0.17795926E-05_JPRB, 0.17795801E-05_JPRB, 0.17795824E-05_JPRB, 0.17795780E-05_JPRB, 0.17795551E-05_JPRB, &
  & 0.17795386E-05_JPRB, 0.17794955E-05_JPRB, 0.17794362E-05_JPRB, 0.17792794E-05_JPRB /)

RGHG2(:,81, 1) = (/ &
  & 0.17792138E-05_JPRB, 0.17791128E-05_JPRB, 0.17790869E-05_JPRB, 0.17790854E-05_JPRB, 0.17790641E-05_JPRB, 0.17790358E-05_JPRB, &
  & 0.17790426E-05_JPRB, 0.17790342E-05_JPRB, 0.17790286E-05_JPRB, 0.17790195E-05_JPRB, 0.17789995E-05_JPRB, 0.17789876E-05_JPRB, &
  & 0.17789878E-05_JPRB, 0.17789732E-05_JPRB, 0.17789182E-05_JPRB, 0.17788429E-05_JPRB, 0.17787671E-05_JPRB, 0.17786872E-05_JPRB, &
  & 0.17786026E-05_JPRB, 0.17785784E-05_JPRB, 0.17785690E-05_JPRB, 0.17785896E-05_JPRB, 0.17786322E-05_JPRB, 0.17787047E-05_JPRB, &
  & 0.17787659E-05_JPRB, 0.17788361E-05_JPRB, 0.17788798E-05_JPRB, 0.17789215E-05_JPRB, 0.17789210E-05_JPRB, 0.17789278E-05_JPRB, &
  & 0.17789062E-05_JPRB, 0.17788755E-05_JPRB, 0.17788161E-05_JPRB, 0.17787631E-05_JPRB, 0.17787180E-05_JPRB, 0.17786822E-05_JPRB, &
  & 0.17786408E-05_JPRB, 0.17786257E-05_JPRB, 0.17785989E-05_JPRB, 0.17786390E-05_JPRB, 0.17786940E-05_JPRB, 0.17788047E-05_JPRB, &
  & 0.17789007E-05_JPRB, 0.17790240E-05_JPRB, 0.17791747E-05_JPRB, 0.17793177E-05_JPRB, 0.17794299E-05_JPRB, 0.17795082E-05_JPRB, &
  & 0.17795760E-05_JPRB, 0.17796162E-05_JPRB, 0.17796333E-05_JPRB, 0.17796542E-05_JPRB, 0.17796352E-05_JPRB, 0.17796507E-05_JPRB, &
  & 0.17796318E-05_JPRB, 0.17796276E-05_JPRB, 0.17796153E-05_JPRB, 0.17796197E-05_JPRB, 0.17796182E-05_JPRB, 0.17795965E-05_JPRB, &
  & 0.17795826E-05_JPRB, 0.17795428E-05_JPRB, 0.17794978E-05_JPRB, 0.17794760E-05_JPRB /)

RGHG2(:,82, 1) = (/ &
  & 0.17792394E-05_JPRB, 0.17791513E-05_JPRB, 0.17791288E-05_JPRB, 0.17791297E-05_JPRB, 0.17791092E-05_JPRB, 0.17790821E-05_JPRB, &
  & 0.17790910E-05_JPRB, 0.17790843E-05_JPRB, 0.17790783E-05_JPRB, 0.17790720E-05_JPRB, 0.17790499E-05_JPRB, 0.17790401E-05_JPRB, &
  & 0.17790418E-05_JPRB, 0.17790296E-05_JPRB, 0.17789763E-05_JPRB, 0.17789044E-05_JPRB, 0.17788342E-05_JPRB, 0.17787593E-05_JPRB, &
  & 0.17786792E-05_JPRB, 0.17786583E-05_JPRB, 0.17786501E-05_JPRB, 0.17786701E-05_JPRB, 0.17787092E-05_JPRB, 0.17787785E-05_JPRB, &
  & 0.17788354E-05_JPRB, 0.17789030E-05_JPRB, 0.17789440E-05_JPRB, 0.17789847E-05_JPRB, 0.17789832E-05_JPRB, 0.17789906E-05_JPRB, &
  & 0.17789688E-05_JPRB, 0.17789395E-05_JPRB, 0.17788824E-05_JPRB, 0.17788335E-05_JPRB, 0.17787918E-05_JPRB, 0.17787587E-05_JPRB, &
  & 0.17787191E-05_JPRB, 0.17787045E-05_JPRB, 0.17786775E-05_JPRB, 0.17787152E-05_JPRB, 0.17787652E-05_JPRB, 0.17788701E-05_JPRB, &
  & 0.17789573E-05_JPRB, 0.17790719E-05_JPRB, 0.17792166E-05_JPRB, 0.17793533E-05_JPRB, 0.17794601E-05_JPRB, 0.17795342E-05_JPRB, &
  & 0.17795984E-05_JPRB, 0.17796369E-05_JPRB, 0.17796518E-05_JPRB, 0.17796723E-05_JPRB, 0.17796521E-05_JPRB, 0.17796680E-05_JPRB, &
  & 0.17796480E-05_JPRB, 0.17796447E-05_JPRB, 0.17796324E-05_JPRB, 0.17796378E-05_JPRB, 0.17796376E-05_JPRB, 0.17796170E-05_JPRB, &
  & 0.17796041E-05_JPRB, 0.17795637E-05_JPRB, 0.17795181E-05_JPRB, 0.17794914E-05_JPRB /)

RGHG2(:,83, 1) = (/ &
  & 0.17792570E-05_JPRB, 0.17791737E-05_JPRB, 0.17791522E-05_JPRB, 0.17791544E-05_JPRB, 0.17791347E-05_JPRB, 0.17791081E-05_JPRB, &
  & 0.17791178E-05_JPRB, 0.17791115E-05_JPRB, 0.17791069E-05_JPRB, 0.17790987E-05_JPRB, 0.17790805E-05_JPRB, 0.17790694E-05_JPRB, &
  & 0.17790721E-05_JPRB, 0.17790611E-05_JPRB, 0.17790090E-05_JPRB, 0.17789387E-05_JPRB, 0.17788716E-05_JPRB, 0.17788004E-05_JPRB, &
  & 0.17787208E-05_JPRB, 0.17787033E-05_JPRB, 0.17786955E-05_JPRB, 0.17787139E-05_JPRB, 0.17787522E-05_JPRB, 0.17788190E-05_JPRB, &
  & 0.17788738E-05_JPRB, 0.17789400E-05_JPRB, 0.17789796E-05_JPRB, 0.17790202E-05_JPRB, 0.17790179E-05_JPRB, 0.17790254E-05_JPRB, &
  & 0.17790036E-05_JPRB, 0.17789748E-05_JPRB, 0.17789189E-05_JPRB, 0.17788724E-05_JPRB, 0.17788329E-05_JPRB, 0.17788009E-05_JPRB, &
  & 0.17787629E-05_JPRB, 0.17787487E-05_JPRB, 0.17787222E-05_JPRB, 0.17787579E-05_JPRB, 0.17788055E-05_JPRB, 0.17789050E-05_JPRB, &
  & 0.17789882E-05_JPRB, 0.17790976E-05_JPRB, 0.17792403E-05_JPRB, 0.17793740E-05_JPRB, 0.17794777E-05_JPRB, 0.17795481E-05_JPRB, &
  & 0.17796115E-05_JPRB, 0.17796484E-05_JPRB, 0.17796624E-05_JPRB, 0.17796824E-05_JPRB, 0.17796608E-05_JPRB, 0.17796774E-05_JPRB, &
  & 0.17796564E-05_JPRB, 0.17796536E-05_JPRB, 0.17796414E-05_JPRB, 0.17796475E-05_JPRB, 0.17796484E-05_JPRB, 0.17796283E-05_JPRB, &
  & 0.17796162E-05_JPRB, 0.17795754E-05_JPRB, 0.17795298E-05_JPRB, 0.17795019E-05_JPRB /)

RGHG2(:,84, 1) = (/ &
  & 0.17792695E-05_JPRB, 0.17791879E-05_JPRB, 0.17791670E-05_JPRB, 0.17791697E-05_JPRB, 0.17791500E-05_JPRB, 0.17791235E-05_JPRB, &
  & 0.17791342E-05_JPRB, 0.17791286E-05_JPRB, 0.17791232E-05_JPRB, 0.17791178E-05_JPRB, 0.17790968E-05_JPRB, 0.17790886E-05_JPRB, &
  & 0.17790912E-05_JPRB, 0.17790805E-05_JPRB, 0.17790295E-05_JPRB, 0.17789598E-05_JPRB, 0.17788950E-05_JPRB, 0.17788243E-05_JPRB, &
  & 0.17787482E-05_JPRB, 0.17787310E-05_JPRB, 0.17787230E-05_JPRB, 0.17787413E-05_JPRB, 0.17787772E-05_JPRB, 0.17788440E-05_JPRB, &
  & 0.17788971E-05_JPRB, 0.17789624E-05_JPRB, 0.17790014E-05_JPRB, 0.17790420E-05_JPRB, 0.17790393E-05_JPRB, 0.17790474E-05_JPRB, &
  & 0.17790250E-05_JPRB, 0.17789964E-05_JPRB, 0.17789405E-05_JPRB, 0.17788960E-05_JPRB, 0.17788579E-05_JPRB, 0.17788270E-05_JPRB, &
  & 0.17787904E-05_JPRB, 0.17787759E-05_JPRB, 0.17787503E-05_JPRB, 0.17787851E-05_JPRB, 0.17788293E-05_JPRB, 0.17789284E-05_JPRB, &
  & 0.17790054E-05_JPRB, 0.17791144E-05_JPRB, 0.17792539E-05_JPRB, 0.17793870E-05_JPRB, 0.17794886E-05_JPRB, 0.17795575E-05_JPRB, &
  & 0.17796193E-05_JPRB, 0.17796557E-05_JPRB, 0.17796687E-05_JPRB, 0.17796887E-05_JPRB, 0.17796660E-05_JPRB, 0.17796835E-05_JPRB, &
  & 0.17796618E-05_JPRB, 0.17796591E-05_JPRB, 0.17796468E-05_JPRB, 0.17796535E-05_JPRB, 0.17796553E-05_JPRB, 0.17796355E-05_JPRB, &
  & 0.17796244E-05_JPRB, 0.17795827E-05_JPRB, 0.17795369E-05_JPRB, 0.17795086E-05_JPRB /)

RGHG2(:,85, 1) = (/ &
  & 0.17792777E-05_JPRB, 0.17791973E-05_JPRB, 0.17791763E-05_JPRB, 0.17791799E-05_JPRB, 0.17791606E-05_JPRB, 0.17791338E-05_JPRB, &
  & 0.17791443E-05_JPRB, 0.17791381E-05_JPRB, 0.17791338E-05_JPRB, 0.17791261E-05_JPRB, 0.17791115E-05_JPRB, 0.17791021E-05_JPRB, &
  & 0.17791028E-05_JPRB, 0.17790915E-05_JPRB, 0.17790431E-05_JPRB, 0.17789741E-05_JPRB, 0.17789102E-05_JPRB, 0.17788415E-05_JPRB, &
  & 0.17787642E-05_JPRB, 0.17787488E-05_JPRB, 0.17787404E-05_JPRB, 0.17787575E-05_JPRB, 0.17787941E-05_JPRB, 0.17788597E-05_JPRB, &
  & 0.17789122E-05_JPRB, 0.17789779E-05_JPRB, 0.17790155E-05_JPRB, 0.17790567E-05_JPRB, 0.17790530E-05_JPRB, 0.17790613E-05_JPRB, &
  & 0.17790387E-05_JPRB, 0.17790099E-05_JPRB, 0.17789544E-05_JPRB, 0.17789109E-05_JPRB, 0.17788740E-05_JPRB, 0.17788440E-05_JPRB, &
  & 0.17788084E-05_JPRB, 0.17787938E-05_JPRB, 0.17787679E-05_JPRB, 0.17788013E-05_JPRB, 0.17788462E-05_JPRB, 0.17789409E-05_JPRB, &
  & 0.17790195E-05_JPRB, 0.17791223E-05_JPRB, 0.17792652E-05_JPRB, 0.17793948E-05_JPRB, 0.17794960E-05_JPRB, 0.17795633E-05_JPRB, &
  & 0.17796248E-05_JPRB, 0.17796605E-05_JPRB, 0.17796727E-05_JPRB, 0.17796926E-05_JPRB, 0.17796693E-05_JPRB, 0.17796875E-05_JPRB, &
  & 0.17796649E-05_JPRB, 0.17796623E-05_JPRB, 0.17796499E-05_JPRB, 0.17796574E-05_JPRB, 0.17796600E-05_JPRB, 0.17796405E-05_JPRB, &
  & 0.17796298E-05_JPRB, 0.17795876E-05_JPRB, 0.17795414E-05_JPRB, 0.17795129E-05_JPRB /)

RGHG2(:,86, 1) = (/ &
  & 0.17792838E-05_JPRB, 0.17792033E-05_JPRB, 0.17791824E-05_JPRB, 0.17791865E-05_JPRB, 0.17791660E-05_JPRB, 0.17791400E-05_JPRB, &
  & 0.17791499E-05_JPRB, 0.17791444E-05_JPRB, 0.17791385E-05_JPRB, 0.17791317E-05_JPRB, 0.17791187E-05_JPRB, 0.17791108E-05_JPRB, &
  & 0.17791087E-05_JPRB, 0.17790966E-05_JPRB, 0.17790510E-05_JPRB, 0.17789852E-05_JPRB, 0.17789210E-05_JPRB, 0.17788523E-05_JPRB, &
  & 0.17787763E-05_JPRB, 0.17787600E-05_JPRB, 0.17787512E-05_JPRB, 0.17787681E-05_JPRB, 0.17788025E-05_JPRB, 0.17788700E-05_JPRB, &
  & 0.17789215E-05_JPRB, 0.17789878E-05_JPRB, 0.17790248E-05_JPRB, 0.17790661E-05_JPRB, 0.17790616E-05_JPRB, 0.17790705E-05_JPRB, &
  & 0.17790474E-05_JPRB, 0.17790187E-05_JPRB, 0.17789632E-05_JPRB, 0.17789207E-05_JPRB, 0.17788847E-05_JPRB, 0.17788550E-05_JPRB, &
  & 0.17788193E-05_JPRB, 0.17788047E-05_JPRB, 0.17787768E-05_JPRB, 0.17788116E-05_JPRB, 0.17788527E-05_JPRB, 0.17789539E-05_JPRB, &
  & 0.17790251E-05_JPRB, 0.17791325E-05_JPRB, 0.17792702E-05_JPRB, 0.17794014E-05_JPRB, 0.17795010E-05_JPRB, 0.17795671E-05_JPRB, &
  & 0.17796289E-05_JPRB, 0.17796634E-05_JPRB, 0.17796751E-05_JPRB, 0.17796951E-05_JPRB, 0.17796712E-05_JPRB, 0.17796900E-05_JPRB, &
  & 0.17796666E-05_JPRB, 0.17796642E-05_JPRB, 0.17796519E-05_JPRB, 0.17796599E-05_JPRB, 0.17796632E-05_JPRB, 0.17796439E-05_JPRB, &
  & 0.17796333E-05_JPRB, 0.17795910E-05_JPRB, 0.17795445E-05_JPRB, 0.17795155E-05_JPRB /)

RGHG2(:,87, 1) = (/ &
  & 0.17792869E-05_JPRB, 0.17792073E-05_JPRB, 0.17791861E-05_JPRB, 0.17791904E-05_JPRB, 0.17791707E-05_JPRB, 0.17791440E-05_JPRB, &
  & 0.17791522E-05_JPRB, 0.17791466E-05_JPRB, 0.17791413E-05_JPRB, 0.17791345E-05_JPRB, 0.17791239E-05_JPRB, 0.17791162E-05_JPRB, &
  & 0.17791124E-05_JPRB, 0.17790990E-05_JPRB, 0.17790561E-05_JPRB, 0.17789919E-05_JPRB, 0.17789292E-05_JPRB, 0.17788598E-05_JPRB, &
  & 0.17787839E-05_JPRB, 0.17787671E-05_JPRB, 0.17787577E-05_JPRB, 0.17787736E-05_JPRB, 0.17788077E-05_JPRB, 0.17788759E-05_JPRB, &
  & 0.17789271E-05_JPRB, 0.17789945E-05_JPRB, 0.17790303E-05_JPRB, 0.17790729E-05_JPRB, 0.17790668E-05_JPRB, 0.17790759E-05_JPRB, &
  & 0.17790524E-05_JPRB, 0.17790243E-05_JPRB, 0.17789687E-05_JPRB, 0.17789262E-05_JPRB, 0.17788914E-05_JPRB, 0.17788624E-05_JPRB, &
  & 0.17788257E-05_JPRB, 0.17788124E-05_JPRB, 0.17787803E-05_JPRB, 0.17788166E-05_JPRB, 0.17788584E-05_JPRB, 0.17789594E-05_JPRB, &
  & 0.17790328E-05_JPRB, 0.17791351E-05_JPRB, 0.17792763E-05_JPRB, 0.17794044E-05_JPRB, 0.17795039E-05_JPRB, 0.17795695E-05_JPRB, &
  & 0.17796310E-05_JPRB, 0.17796654E-05_JPRB, 0.17796769E-05_JPRB, 0.17796971E-05_JPRB, 0.17796723E-05_JPRB, 0.17796913E-05_JPRB, &
  & 0.17796676E-05_JPRB, 0.17796649E-05_JPRB, 0.17796530E-05_JPRB, 0.17796611E-05_JPRB, 0.17796649E-05_JPRB, 0.17796463E-05_JPRB, &
  & 0.17796359E-05_JPRB, 0.17795929E-05_JPRB, 0.17795459E-05_JPRB, 0.17795170E-05_JPRB /)

RGHG2(:,88, 1) = (/ &
  & 0.17792878E-05_JPRB, 0.17792100E-05_JPRB, 0.17791886E-05_JPRB, 0.17791933E-05_JPRB, 0.17791716E-05_JPRB, 0.17791463E-05_JPRB, &
  & 0.17791544E-05_JPRB, 0.17791490E-05_JPRB, 0.17791432E-05_JPRB, 0.17791365E-05_JPRB, 0.17791265E-05_JPRB, 0.17791187E-05_JPRB, &
  & 0.17791147E-05_JPRB, 0.17791006E-05_JPRB, 0.17790593E-05_JPRB, 0.17789969E-05_JPRB, 0.17789329E-05_JPRB, 0.17788648E-05_JPRB, &
  & 0.17787876E-05_JPRB, 0.17787711E-05_JPRB, 0.17787618E-05_JPRB, 0.17787770E-05_JPRB, 0.17788104E-05_JPRB, 0.17788798E-05_JPRB, &
  & 0.17789298E-05_JPRB, 0.17789984E-05_JPRB, 0.17790336E-05_JPRB, 0.17790771E-05_JPRB, 0.17790700E-05_JPRB, 0.17790795E-05_JPRB, &
  & 0.17790558E-05_JPRB, 0.17790280E-05_JPRB, 0.17789720E-05_JPRB, 0.17789299E-05_JPRB, 0.17788952E-05_JPRB, 0.17788664E-05_JPRB, &
  & 0.17788291E-05_JPRB, 0.17788166E-05_JPRB, 0.17787808E-05_JPRB, 0.17788209E-05_JPRB, 0.17788587E-05_JPRB, 0.17789660E-05_JPRB, &
  & 0.17790347E-05_JPRB, 0.17791394E-05_JPRB, 0.17792785E-05_JPRB, 0.17794071E-05_JPRB, 0.17795060E-05_JPRB, 0.17795710E-05_JPRB, &
  & 0.17796326E-05_JPRB, 0.17796665E-05_JPRB, 0.17796781E-05_JPRB, 0.17796982E-05_JPRB, 0.17796729E-05_JPRB, 0.17796922E-05_JPRB, &
  & 0.17796682E-05_JPRB, 0.17796655E-05_JPRB, 0.17796534E-05_JPRB, 0.17796622E-05_JPRB, 0.17796661E-05_JPRB, 0.17796474E-05_JPRB, &
  & 0.17796373E-05_JPRB, 0.17795940E-05_JPRB, 0.17795470E-05_JPRB, 0.17795180E-05_JPRB /)

RGHG2(:,89, 1) = (/ &
  & 0.17792862E-05_JPRB, 0.17792124E-05_JPRB, 0.17791901E-05_JPRB, 0.17791948E-05_JPRB, 0.17791754E-05_JPRB, 0.17791466E-05_JPRB, &
  & 0.17791563E-05_JPRB, 0.17791506E-05_JPRB, 0.17791454E-05_JPRB, 0.17791388E-05_JPRB, 0.17791278E-05_JPRB, 0.17791208E-05_JPRB, &
  & 0.17791174E-05_JPRB, 0.17791044E-05_JPRB, 0.17790614E-05_JPRB, 0.17789966E-05_JPRB, 0.17789347E-05_JPRB, 0.17788652E-05_JPRB, &
  & 0.17787888E-05_JPRB, 0.17787733E-05_JPRB, 0.17787634E-05_JPRB, 0.17787786E-05_JPRB, 0.17788117E-05_JPRB, 0.17788817E-05_JPRB, &
  & 0.17789315E-05_JPRB, 0.17790011E-05_JPRB, 0.17790351E-05_JPRB, 0.17790795E-05_JPRB, 0.17790718E-05_JPRB, 0.17790818E-05_JPRB, &
  & 0.17790574E-05_JPRB, 0.17790308E-05_JPRB, 0.17789739E-05_JPRB, 0.17789320E-05_JPRB, 0.17788973E-05_JPRB, 0.17788693E-05_JPRB, &
  & 0.17788306E-05_JPRB, 0.17788198E-05_JPRB, 0.17787804E-05_JPRB, 0.17788225E-05_JPRB, 0.17788598E-05_JPRB, 0.17789686E-05_JPRB, &
  & 0.17790364E-05_JPRB, 0.17791401E-05_JPRB, 0.17792801E-05_JPRB, 0.17794081E-05_JPRB, 0.17795072E-05_JPRB, 0.17795719E-05_JPRB, &
  & 0.17796337E-05_JPRB, 0.17796672E-05_JPRB, 0.17796785E-05_JPRB, 0.17796989E-05_JPRB, 0.17796731E-05_JPRB, 0.17796931E-05_JPRB, &
  & 0.17796688E-05_JPRB, 0.17796661E-05_JPRB, 0.17796535E-05_JPRB, 0.17796630E-05_JPRB, 0.17796674E-05_JPRB, 0.17796483E-05_JPRB, &
  & 0.17796388E-05_JPRB, 0.17795946E-05_JPRB, 0.17795471E-05_JPRB, 0.17795181E-05_JPRB /)

RGHG2(:,90, 1) = (/ &
  & 0.17792822E-05_JPRB, 0.17792145E-05_JPRB, 0.17791908E-05_JPRB, 0.17791970E-05_JPRB, 0.17791756E-05_JPRB, 0.17791450E-05_JPRB, &
  & 0.17791599E-05_JPRB, 0.17791535E-05_JPRB, 0.17791479E-05_JPRB, 0.17791408E-05_JPRB, 0.17791281E-05_JPRB, 0.17791203E-05_JPRB, &
  & 0.17791207E-05_JPRB, 0.17791091E-05_JPRB, 0.17790624E-05_JPRB, 0.17789957E-05_JPRB, 0.17789333E-05_JPRB, 0.17788652E-05_JPRB, &
  & 0.17787854E-05_JPRB, 0.17787737E-05_JPRB, 0.17787634E-05_JPRB, 0.17787789E-05_JPRB, 0.17788113E-05_JPRB, 0.17788827E-05_JPRB, &
  & 0.17789318E-05_JPRB, 0.17790028E-05_JPRB, 0.17790354E-05_JPRB, 0.17790819E-05_JPRB, 0.17790719E-05_JPRB, 0.17790842E-05_JPRB, &
  & 0.17790587E-05_JPRB, 0.17790330E-05_JPRB, 0.17789749E-05_JPRB, 0.17789324E-05_JPRB, 0.17788981E-05_JPRB, 0.17788700E-05_JPRB, &
  & 0.17788300E-05_JPRB, 0.17788213E-05_JPRB, 0.17787783E-05_JPRB, 0.17788238E-05_JPRB, 0.17788584E-05_JPRB, 0.17789711E-05_JPRB, &
  & 0.17790362E-05_JPRB, 0.17791401E-05_JPRB, 0.17792810E-05_JPRB, 0.17794096E-05_JPRB, 0.17795088E-05_JPRB, 0.17795728E-05_JPRB, &
  & 0.17796352E-05_JPRB, 0.17796684E-05_JPRB, 0.17796791E-05_JPRB, 0.17797007E-05_JPRB, 0.17796726E-05_JPRB, 0.17796943E-05_JPRB, &
  & 0.17796681E-05_JPRB, 0.17796663E-05_JPRB, 0.17796531E-05_JPRB, 0.17796635E-05_JPRB, 0.17796683E-05_JPRB, 0.17796484E-05_JPRB, &
  & 0.17796401E-05_JPRB, 0.17795945E-05_JPRB, 0.17795463E-05_JPRB, 0.17795178E-05_JPRB /)

RGHG2(:,91, 1) = (/ &
  & 0.17792759E-05_JPRB, 0.17792203E-05_JPRB, 0.17791892E-05_JPRB, 0.17791994E-05_JPRB, 0.17791784E-05_JPRB, 0.17791397E-05_JPRB, &
  & 0.17791651E-05_JPRB, 0.17791552E-05_JPRB, 0.17791515E-05_JPRB, 0.17791489E-05_JPRB, 0.17791236E-05_JPRB, 0.17791141E-05_JPRB, &
  & 0.17791267E-05_JPRB, 0.17791194E-05_JPRB, 0.17790635E-05_JPRB, 0.17789919E-05_JPRB, 0.17789330E-05_JPRB, 0.17788649E-05_JPRB, &
  & 0.17787793E-05_JPRB, 0.17787735E-05_JPRB, 0.17787619E-05_JPRB, 0.17787779E-05_JPRB, 0.17788091E-05_JPRB, 0.17788846E-05_JPRB, &
  & 0.17789308E-05_JPRB, 0.17790054E-05_JPRB, 0.17790350E-05_JPRB, 0.17790866E-05_JPRB, 0.17790708E-05_JPRB, 0.17790874E-05_JPRB, &
  & 0.17790593E-05_JPRB, 0.17790375E-05_JPRB, 0.17789746E-05_JPRB, 0.17789309E-05_JPRB, 0.17788976E-05_JPRB, 0.17788718E-05_JPRB, &
  & 0.17788258E-05_JPRB, 0.17788240E-05_JPRB, 0.17787719E-05_JPRB, 0.17788244E-05_JPRB, 0.17788536E-05_JPRB, 0.17789745E-05_JPRB, &
  & 0.17790341E-05_JPRB, 0.17791377E-05_JPRB, 0.17792822E-05_JPRB, 0.17794117E-05_JPRB, 0.17795116E-05_JPRB, 0.17795730E-05_JPRB, &
  & 0.17796375E-05_JPRB, 0.17796700E-05_JPRB, 0.17796787E-05_JPRB, 0.17797038E-05_JPRB, 0.17796694E-05_JPRB, 0.17796974E-05_JPRB, &
  & 0.17796669E-05_JPRB, 0.17796671E-05_JPRB, 0.17796519E-05_JPRB, 0.17796640E-05_JPRB, 0.17796700E-05_JPRB, 0.17796477E-05_JPRB, &
  & 0.17796418E-05_JPRB, 0.17795929E-05_JPRB, 0.17795435E-05_JPRB, 0.17795167E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART2',1,ZHOOK_HANDLE)
END SUBROUTINE PART2






SUBROUTINE PART3
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART3',0,ZHOOK_HANDLE)



!-- Month=  2 ------------

RGHG2(:, 1, 2) = (/ &
  & 0.22710186E-07_JPRB, 0.21056811E-07_JPRB, 0.19258042E-07_JPRB, 0.17931713E-07_JPRB, 0.16818310E-07_JPRB, 0.15876852E-07_JPRB, &
  & 0.14978140E-07_JPRB, 0.13927838E-07_JPRB, 0.12934341E-07_JPRB, 0.12182062E-07_JPRB, 0.11652694E-07_JPRB, 0.11381927E-07_JPRB, &
  & 0.11381397E-07_JPRB, 0.11646459E-07_JPRB, 0.12131523E-07_JPRB, 0.12759815E-07_JPRB, 0.13438920E-07_JPRB, 0.14042281E-07_JPRB, &
  & 0.14386393E-07_JPRB, 0.14368979E-07_JPRB, 0.14047041E-07_JPRB, 0.13556106E-07_JPRB, 0.13002506E-07_JPRB, 0.12423844E-07_JPRB, &
  & 0.11790579E-07_JPRB, 0.11049798E-07_JPRB, 0.10145086E-07_JPRB, 0.91556709E-08_JPRB, 0.82398364E-08_JPRB, 0.74677668E-08_JPRB, &
  & 0.68471251E-08_JPRB, 0.63721624E-08_JPRB, 0.60339342E-08_JPRB, 0.58221095E-08_JPRB, 0.57345892E-08_JPRB, 0.57800094E-08_JPRB, &
  & 0.59604250E-08_JPRB, 0.62974186E-08_JPRB, 0.67237718E-08_JPRB, 0.70934569E-08_JPRB, 0.73444495E-08_JPRB, 0.74826358E-08_JPRB, &
  & 0.75188629E-08_JPRB, 0.74519724E-08_JPRB, 0.72541315E-08_JPRB, 0.68455441E-08_JPRB, 0.62582695E-08_JPRB, 0.56001550E-08_JPRB, &
  & 0.50004010E-08_JPRB, 0.45557642E-08_JPRB, 0.43022585E-08_JPRB, 0.42256456E-08_JPRB, 0.42846247E-08_JPRB, 0.44270454E-08_JPRB, &
  & 0.46030268E-08_JPRB, 0.47768713E-08_JPRB, 0.49301452E-08_JPRB, 0.50567897E-08_JPRB, 0.51630860E-08_JPRB, 0.52513114E-08_JPRB, &
  & 0.53226392E-08_JPRB, 0.53788245E-08_JPRB, 0.54124731E-08_JPRB, 0.54376001E-08_JPRB /)

RGHG2(:, 2, 2) = (/ &
  & 0.26485658E-07_JPRB, 0.26135503E-07_JPRB, 0.25719160E-07_JPRB, 0.25283567E-07_JPRB, 0.24846971E-07_JPRB, 0.24388314E-07_JPRB, &
  & 0.23912534E-07_JPRB, 0.23414387E-07_JPRB, 0.23013074E-07_JPRB, 0.22835330E-07_JPRB, 0.22970397E-07_JPRB, 0.23477000E-07_JPRB, &
  & 0.24363313E-07_JPRB, 0.25582365E-07_JPRB, 0.27019437E-07_JPRB, 0.28519962E-07_JPRB, 0.29900260E-07_JPRB, 0.30905216E-07_JPRB, &
  & 0.31291886E-07_JPRB, 0.31011247E-07_JPRB, 0.30215947E-07_JPRB, 0.29122853E-07_JPRB, 0.27895162E-07_JPRB, 0.26611554E-07_JPRB, &
  & 0.25315039E-07_JPRB, 0.23960364E-07_JPRB, 0.22523755E-07_JPRB, 0.21098383E-07_JPRB, 0.19806951E-07_JPRB, 0.18688748E-07_JPRB, &
  & 0.17724382E-07_JPRB, 0.16883289E-07_JPRB, 0.16159362E-07_JPRB, 0.15554969E-07_JPRB, 0.15104657E-07_JPRB, 0.14869512E-07_JPRB, &
  & 0.14923399E-07_JPRB, 0.15333326E-07_JPRB, 0.16052141E-07_JPRB, 0.16881140E-07_JPRB, 0.17589169E-07_JPRB, 0.18014045E-07_JPRB, &
  & 0.18072541E-07_JPRB, 0.17756260E-07_JPRB, 0.17115660E-07_JPRB, 0.16246894E-07_JPRB, 0.15270629E-07_JPRB, 0.14324918E-07_JPRB, &
  & 0.13461843E-07_JPRB, 0.12597282E-07_JPRB, 0.11634091E-07_JPRB, 0.10611213E-07_JPRB, 0.96750021E-08_JPRB, 0.89397822E-08_JPRB, &
  & 0.84257721E-08_JPRB, 0.80979019E-08_JPRB, 0.79087457E-08_JPRB, 0.78162046E-08_JPRB, 0.77881293E-08_JPRB, 0.78042151E-08_JPRB, &
  & 0.78455331E-08_JPRB, 0.78980165E-08_JPRB, 0.79561397E-08_JPRB, 0.80332159E-08_JPRB /)

RGHG2(:, 3, 2) = (/ &
  & 0.27160258E-07_JPRB, 0.27510136E-07_JPRB, 0.27733625E-07_JPRB, 0.27933924E-07_JPRB, 0.28138485E-07_JPRB, 0.28363182E-07_JPRB, &
  & 0.28647138E-07_JPRB, 0.29042567E-07_JPRB, 0.29596654E-07_JPRB, 0.30352943E-07_JPRB, 0.31342491E-07_JPRB, 0.32579976E-07_JPRB, &
  & 0.34064545E-07_JPRB, 0.35766067E-07_JPRB, 0.37573795E-07_JPRB, 0.39345625E-07_JPRB, 0.40922181E-07_JPRB, 0.42103071E-07_JPRB, &
  & 0.42714920E-07_JPRB, 0.42718362E-07_JPRB, 0.42231665E-07_JPRB, 0.41427739E-07_JPRB, 0.40449724E-07_JPRB, 0.39379632E-07_JPRB, &
  & 0.38248068E-07_JPRB, 0.37069277E-07_JPRB, 0.35851993E-07_JPRB, 0.34654466E-07_JPRB, 0.33520642E-07_JPRB, 0.32453606E-07_JPRB, &
  & 0.31431600E-07_JPRB, 0.30466722E-07_JPRB, 0.29608023E-07_JPRB, 0.28977928E-07_JPRB, 0.28716268E-07_JPRB, 0.28923495E-07_JPRB, &
  & 0.29630845E-07_JPRB, 0.30752759E-07_JPRB, 0.32086486E-07_JPRB, 0.33323641E-07_JPRB, 0.34172718E-07_JPRB, 0.34426353E-07_JPRB, &
  & 0.33990865E-07_JPRB, 0.32890579E-07_JPRB, 0.31235189E-07_JPRB, 0.29184093E-07_JPRB, 0.26878336E-07_JPRB, 0.24452603E-07_JPRB, &
  & 0.22024240E-07_JPRB, 0.19724927E-07_JPRB, 0.17735550E-07_JPRB, 0.16178124E-07_JPRB, 0.15005341E-07_JPRB, 0.14095550E-07_JPRB, &
  & 0.13388041E-07_JPRB, 0.12872751E-07_JPRB, 0.12530812E-07_JPRB, 0.12326589E-07_JPRB, 0.12224231E-07_JPRB, 0.12193311E-07_JPRB, &
  & 0.12214196E-07_JPRB, 0.12259624E-07_JPRB, 0.12320351E-07_JPRB, 0.12421683E-07_JPRB /)

RGHG2(:, 4, 2) = (/ &
  & 0.26955700E-07_JPRB, 0.27569452E-07_JPRB, 0.28035508E-07_JPRB, 0.28540688E-07_JPRB, 0.29108614E-07_JPRB, 0.29763168E-07_JPRB, &
  & 0.30549227E-07_JPRB, 0.31514226E-07_JPRB, 0.32681857E-07_JPRB, 0.34069039E-07_JPRB, 0.35665835E-07_JPRB, 0.37467970E-07_JPRB, &
  & 0.39426016E-07_JPRB, 0.41465213E-07_JPRB, 0.43548173E-07_JPRB, 0.45579124E-07_JPRB, 0.47418848E-07_JPRB, 0.48944802E-07_JPRB, &
  & 0.50034650E-07_JPRB, 0.50663445E-07_JPRB, 0.50885326E-07_JPRB, 0.50818009E-07_JPRB, 0.50590032E-07_JPRB, 0.50302553E-07_JPRB, &
  & 0.50022258E-07_JPRB, 0.49767529E-07_JPRB, 0.49520988E-07_JPRB, 0.49232121E-07_JPRB, 0.48844587E-07_JPRB, 0.48314924E-07_JPRB, &
  & 0.47640935E-07_JPRB, 0.46863157E-07_JPRB, 0.46091223E-07_JPRB, 0.45482771E-07_JPRB, 0.45210580E-07_JPRB, 0.45383437E-07_JPRB, &
  & 0.46011689E-07_JPRB, 0.47005564E-07_JPRB, 0.48140343E-07_JPRB, 0.49083702E-07_JPRB, 0.49460752E-07_JPRB, 0.49009238E-07_JPRB, &
  & 0.47709726E-07_JPRB, 0.45749207E-07_JPRB, 0.43372015E-07_JPRB, 0.40763496E-07_JPRB, 0.38042593E-07_JPRB, 0.35287904E-07_JPRB, &
  & 0.32566653E-07_JPRB, 0.29957757E-07_JPRB, 0.27516837E-07_JPRB, 0.25239721E-07_JPRB, 0.23149127E-07_JPRB, 0.21355154E-07_JPRB, &
  & 0.19946430E-07_JPRB, 0.18916628E-07_JPRB, 0.18207501E-07_JPRB, 0.17755802E-07_JPRB, 0.17501385E-07_JPRB, 0.17389407E-07_JPRB, &
  & 0.17370837E-07_JPRB, 0.17403375E-07_JPRB, 0.17465576E-07_JPRB, 0.17601588E-07_JPRB /)

RGHG2(:, 5, 2) = (/ &
  & 0.26631305E-07_JPRB, 0.27362010E-07_JPRB, 0.27985825E-07_JPRB, 0.28707952E-07_JPRB, 0.29544694E-07_JPRB, 0.30519171E-07_JPRB, &
  & 0.31695585E-07_JPRB, 0.33112723E-07_JPRB, 0.34808259E-07_JPRB, 0.36779323E-07_JPRB, 0.38946869E-07_JPRB, 0.41275232E-07_JPRB, &
  & 0.43740108E-07_JPRB, 0.46262318E-07_JPRB, 0.48737469E-07_JPRB, 0.51115279E-07_JPRB, 0.53355997E-07_JPRB, 0.55370673E-07_JPRB, &
  & 0.57125206E-07_JPRB, 0.58603870E-07_JPRB, 0.59871930E-07_JPRB, 0.61016770E-07_JPRB, 0.62141339E-07_JPRB, 0.63306913E-07_JPRB, &
  & 0.64540316E-07_JPRB, 0.65784455E-07_JPRB, 0.66946690E-07_JPRB, 0.67874709E-07_JPRB, 0.68447882E-07_JPRB, 0.68557171E-07_JPRB, &
  & 0.68205949E-07_JPRB, 0.67499215E-07_JPRB, 0.66651069E-07_JPRB, 0.65937058E-07_JPRB, 0.65589788E-07_JPRB, 0.65739840E-07_JPRB, &
  & 0.66406486E-07_JPRB, 0.67464228E-07_JPRB, 0.68600485E-07_JPRB, 0.69236854E-07_JPRB, 0.68680940E-07_JPRB, 0.66601380E-07_JPRB, &
  & 0.63322759E-07_JPRB, 0.59520104E-07_JPRB, 0.55690922E-07_JPRB, 0.52064372E-07_JPRB, 0.48709612E-07_JPRB, 0.45607344E-07_JPRB, &
  & 0.42696225E-07_JPRB, 0.39915960E-07_JPRB, 0.37229626E-07_JPRB, 0.34659593E-07_JPRB, 0.32291979E-07_JPRB, 0.30194464E-07_JPRB, &
  & 0.28391979E-07_JPRB, 0.26921786E-07_JPRB, 0.25816089E-07_JPRB, 0.25056911E-07_JPRB, 0.24587433E-07_JPRB, 0.24332859E-07_JPRB, &
  & 0.24215538E-07_JPRB, 0.24178945E-07_JPRB, 0.24184732E-07_JPRB, 0.24241132E-07_JPRB /)

RGHG2(:, 6, 2) = (/ &
  & 0.26443951E-07_JPRB, 0.27289049E-07_JPRB, 0.28123839E-07_JPRB, 0.29138196E-07_JPRB, 0.30338345E-07_JPRB, 0.31732636E-07_JPRB, &
  & 0.33401086E-07_JPRB, 0.35389554E-07_JPRB, 0.37752859E-07_JPRB, 0.40494061E-07_JPRB, 0.43532268E-07_JPRB, 0.46714401E-07_JPRB, &
  & 0.49969728E-07_JPRB, 0.53231524E-07_JPRB, 0.56434157E-07_JPRB, 0.59518236E-07_JPRB, 0.62450127E-07_JPRB, 0.65236918E-07_JPRB, &
  & 0.67900565E-07_JPRB, 0.70537141E-07_JPRB, 0.73246341E-07_JPRB, 0.76148552E-07_JPRB, 0.79332288E-07_JPRB, 0.82818310E-07_JPRB, &
  & 0.86509310E-07_JPRB, 0.90257565E-07_JPRB, 0.93900297E-07_JPRB, 0.97317020E-07_JPRB, 0.10025013E-06_JPRB, 0.10256561E-06_JPRB, &
  & 0.10411333E-06_JPRB, 0.10496995E-06_JPRB, 0.10534493E-06_JPRB, 0.10555743E-06_JPRB, 0.10587542E-06_JPRB, 0.10643084E-06_JPRB, &
  & 0.10717348E-06_JPRB, 0.10781753E-06_JPRB, 0.10775223E-06_JPRB, 0.10605623E-06_JPRB, 0.10193553E-06_JPRB, 0.95536485E-07_JPRB, &
  & 0.88109665E-07_JPRB, 0.80867011E-07_JPRB, 0.74394308E-07_JPRB, 0.68776998E-07_JPRB, 0.63918826E-07_JPRB, 0.59641778E-07_JPRB, &
  & 0.55762435E-07_JPRB, 0.52155386E-07_JPRB, 0.48772346E-07_JPRB, 0.45620943E-07_JPRB, 0.42725169E-07_JPRB, 0.40126629E-07_JPRB, &
  & 0.37901966E-07_JPRB, 0.36111953E-07_JPRB, 0.34756610E-07_JPRB, 0.33795601E-07_JPRB, 0.33168902E-07_JPRB, 0.32792329E-07_JPRB, &
  & 0.32579258E-07_JPRB, 0.32452828E-07_JPRB, 0.32372842E-07_JPRB, 0.32318621E-07_JPRB /)

RGHG2(:, 7, 2) = (/ &
  & 0.26625814E-07_JPRB, 0.27798198E-07_JPRB, 0.28977833E-07_JPRB, 0.30483662E-07_JPRB, 0.32268453E-07_JPRB, 0.34353508E-07_JPRB, &
  & 0.36808434E-07_JPRB, 0.39723044E-07_JPRB, 0.43177060E-07_JPRB, 0.47184180E-07_JPRB, 0.51572698E-07_JPRB, 0.56224422E-07_JPRB, &
  & 0.61020870E-07_JPRB, 0.65767026E-07_JPRB, 0.70311927E-07_JPRB, 0.74642806E-07_JPRB, 0.78802032E-07_JPRB, 0.82824840E-07_JPRB, &
  & 0.86823739E-07_JPRB, 0.90937689E-07_JPRB, 0.95361479E-07_JPRB, 0.10026753E-06_JPRB, 0.10577934E-06_JPRB, 0.11189732E-06_JPRB, &
  & 0.11846902E-06_JPRB, 0.12531622E-06_JPRB, 0.13229757E-06_JPRB, 0.13925012E-06_JPRB, 0.14608320E-06_JPRB, 0.15246192E-06_JPRB, &
  & 0.15817480E-06_JPRB, 0.16294388E-06_JPRB, 0.16663793E-06_JPRB, 0.16923165E-06_JPRB, 0.17076908E-06_JPRB, 0.17122304E-06_JPRB, &
  & 0.17046342E-06_JPRB, 0.16813911E-06_JPRB, 0.16360072E-06_JPRB, 0.15605045E-06_JPRB, 0.14519981E-06_JPRB, 0.13225157E-06_JPRB, &
  & 0.11935364E-06_JPRB, 0.10799958E-06_JPRB, 0.98509936E-07_JPRB, 0.90668479E-07_JPRB, 0.84085926E-07_JPRB, 0.78348457E-07_JPRB, &
  & 0.73143752E-07_JPRB, 0.68302448E-07_JPRB, 0.63751088E-07_JPRB, 0.59484492E-07_JPRB, 0.55564374E-07_JPRB, 0.52099768E-07_JPRB, &
  & 0.49173114E-07_JPRB, 0.46810470E-07_JPRB, 0.45004079E-07_JPRB, 0.43714831E-07_JPRB, 0.42858517E-07_JPRB, 0.42321012E-07_JPRB, &
  & 0.41986780E-07_JPRB, 0.41767493E-07_JPRB, 0.41601883E-07_JPRB, 0.41452207E-07_JPRB /)

RGHG2(:, 8, 2) = (/ &
  & 0.27634290E-07_JPRB, 0.29555899E-07_JPRB, 0.31411911E-07_JPRB, 0.33710009E-07_JPRB, 0.36484394E-07_JPRB, 0.39717644E-07_JPRB, &
  & 0.43528729E-07_JPRB, 0.48016318E-07_JPRB, 0.53306703E-07_JPRB, 0.59366339E-07_JPRB, 0.66073682E-07_JPRB, 0.73205442E-07_JPRB, &
  & 0.80555942E-07_JPRB, 0.87889546E-07_JPRB, 0.95017278E-07_JPRB, 0.10178336E-06_JPRB, 0.10820020E-06_JPRB, 0.11435821E-06_JPRB, &
  & 0.12040395E-06_JPRB, 0.12656568E-06_JPRB, 0.13304769E-06_JPRB, 0.14006744E-06_JPRB, 0.14779640E-06_JPRB, 0.15622454E-06_JPRB, &
  & 0.16528367E-06_JPRB, 0.17476812E-06_JPRB, 0.18465961E-06_JPRB, 0.19494037E-06_JPRB, 0.20540708E-06_JPRB, 0.21577702E-06_JPRB, &
  & 0.22543365E-06_JPRB, 0.23366967E-06_JPRB, 0.23973851E-06_JPRB, 0.24314642E-06_JPRB, 0.24367293E-06_JPRB, 0.24130802E-06_JPRB, &
  & 0.23615758E-06_JPRB, 0.22816073E-06_JPRB, 0.21702130E-06_JPRB, 0.20238953E-06_JPRB, 0.18449579E-06_JPRB, 0.16527517E-06_JPRB, &
  & 0.14749193E-06_JPRB, 0.13268212E-06_JPRB, 0.12093858E-06_JPRB, 0.11164029E-06_JPRB, 0.10399035E-06_JPRB, 0.97340447E-07_JPRB, &
  & 0.91291909E-07_JPRB, 0.85608420E-07_JPRB, 0.80150230E-07_JPRB, 0.74914659E-07_JPRB, 0.70016263E-07_JPRB, 0.65603182E-07_JPRB, &
  & 0.61795838E-07_JPRB, 0.58680278E-07_JPRB, 0.56272896E-07_JPRB, 0.54523323E-07_JPRB, 0.53327099E-07_JPRB, 0.52544927E-07_JPRB, &
  & 0.52016958E-07_JPRB, 0.51618976E-07_JPRB, 0.51252478E-07_JPRB, 0.50678732E-07_JPRB /)

RGHG2(:, 9, 2) = (/ &
  & 0.31734590E-07_JPRB, 0.34960816E-07_JPRB, 0.37881495E-07_JPRB, 0.41452491E-07_JPRB, 0.45711857E-07_JPRB, 0.50741846E-07_JPRB, &
  & 0.56576482E-07_JPRB, 0.63413026E-07_JPRB, 0.71374153E-07_JPRB, 0.80493152E-07_JPRB, 0.90685049E-07_JPRB, 0.10169947E-06_JPRB, &
  & 0.11320554E-06_JPRB, 0.12477608E-06_JPRB, 0.13611843E-06_JPRB, 0.14708424E-06_JPRB, 0.15753555E-06_JPRB, 0.16747867E-06_JPRB, &
  & 0.17701232E-06_JPRB, 0.18634756E-06_JPRB, 0.19571776E-06_JPRB, 0.20524705E-06_JPRB, 0.21502228E-06_JPRB, 0.22511153E-06_JPRB, &
  & 0.23539428E-06_JPRB, 0.24593726E-06_JPRB, 0.25688976E-06_JPRB, 0.26837762E-06_JPRB, 0.28029780E-06_JPRB, 0.29204980E-06_JPRB, &
  & 0.30263109E-06_JPRB, 0.31075786E-06_JPRB, 0.31518536E-06_JPRB, 0.31509637E-06_JPRB, 0.31032604E-06_JPRB, 0.30141922E-06_JPRB, &
  & 0.28909358E-06_JPRB, 0.27393992E-06_JPRB, 0.25614915E-06_JPRB, 0.23549980E-06_JPRB, 0.21235147E-06_JPRB, 0.18858898E-06_JPRB, &
  & 0.16728966E-06_JPRB, 0.15027729E-06_JPRB, 0.13738089E-06_JPRB, 0.12742524E-06_JPRB, 0.11932720E-06_JPRB, 0.11237703E-06_JPRB, &
  & 0.10612632E-06_JPRB, 0.10021135E-06_JPRB, 0.94435563E-07_JPRB, 0.88791452E-07_JPRB, 0.83376577E-07_JPRB, 0.78358255E-07_JPRB, &
  & 0.73928383E-07_JPRB, 0.70216551E-07_JPRB, 0.67292319E-07_JPRB, 0.65143716E-07_JPRB, 0.63688930E-07_JPRB, 0.62716502E-07_JPRB, &
  & 0.62063023E-07_JPRB, 0.61564876E-07_JPRB, 0.61113219E-07_JPRB, 0.60500319E-07_JPRB /)

RGHG2(:,10, 2) = (/ &
  & 0.42566089E-07_JPRB, 0.48833567E-07_JPRB, 0.53862266E-07_JPRB, 0.59066096E-07_JPRB, 0.65401991E-07_JPRB, 0.72693354E-07_JPRB, &
  & 0.81196895E-07_JPRB, 0.91031616E-07_JPRB, 0.10239915E-06_JPRB, 0.11538130E-06_JPRB, 0.12988110E-06_JPRB, 0.14563315E-06_JPRB, &
  & 0.16232835E-06_JPRB, 0.17960923E-06_JPRB, 0.19699631E-06_JPRB, 0.21406122E-06_JPRB, 0.23059957E-06_JPRB, 0.24636731E-06_JPRB, &
  & 0.26130354E-06_JPRB, 0.27540079E-06_JPRB, 0.28871807E-06_JPRB, 0.30133938E-06_JPRB, 0.31317123E-06_JPRB, 0.32416099E-06_JPRB, &
  & 0.33443922E-06_JPRB, 0.34414268E-06_JPRB, 0.35373694E-06_JPRB, 0.36346646E-06_JPRB, 0.37320626E-06_JPRB, 0.38220080E-06_JPRB, &
  & 0.38906654E-06_JPRB, 0.39206907E-06_JPRB, 0.38963452E-06_JPRB, 0.38098705E-06_JPRB, 0.36654200E-06_JPRB, 0.34776363E-06_JPRB, &
  & 0.32658434E-06_JPRB, 0.30412070E-06_JPRB, 0.28055538E-06_JPRB, 0.25567005E-06_JPRB, 0.22929254E-06_JPRB, 0.20294772E-06_JPRB, &
  & 0.17963164E-06_JPRB, 0.16115712E-06_JPRB, 0.14722315E-06_JPRB, 0.13673278E-06_JPRB, 0.12857524E-06_JPRB, 0.12188323E-06_JPRB, &
  & 0.11592517E-06_JPRB, 0.11025510E-06_JPRB, 0.10468703E-06_JPRB, 0.99156210E-07_JPRB, 0.93718214E-07_JPRB, 0.88551367E-07_JPRB, &
  & 0.83854474E-07_JPRB, 0.79848640E-07_JPRB, 0.76666424E-07_JPRB, 0.74370988E-07_JPRB, 0.72797036E-07_JPRB, 0.71790232E-07_JPRB, &
  & 0.71081409E-07_JPRB, 0.70540125E-07_JPRB, 0.70038404E-07_JPRB, 0.69306417E-07_JPRB /)

RGHG2(:,11, 2) = (/ &
  & 0.71882859E-07_JPRB, 0.83940307E-07_JPRB, 0.91289735E-07_JPRB, 0.98352125E-07_JPRB, 0.10614555E-06_JPRB, 0.11516241E-06_JPRB, &
  & 0.12560849E-06_JPRB, 0.13780806E-06_JPRB, 0.15197645E-06_JPRB, 0.16831197E-06_JPRB, 0.18684781E-06_JPRB, 0.20736243E-06_JPRB, &
  & 0.22952014E-06_JPRB, 0.25287903E-06_JPRB, 0.27701512E-06_JPRB, 0.30136627E-06_JPRB, 0.32526700E-06_JPRB, 0.34829037E-06_JPRB, &
  & 0.36996437E-06_JPRB, 0.39006366E-06_JPRB, 0.40831824E-06_JPRB, 0.42449145E-06_JPRB, 0.43856804E-06_JPRB, 0.45034199E-06_JPRB, &
  & 0.46006889E-06_JPRB, 0.46791541E-06_JPRB, 0.47437277E-06_JPRB, 0.47966347E-06_JPRB, 0.48359828E-06_JPRB, 0.48537908E-06_JPRB, &
  & 0.48359095E-06_JPRB, 0.47654214E-06_JPRB, 0.46274221E-06_JPRB, 0.44168306E-06_JPRB, 0.41449107E-06_JPRB, 0.38403101E-06_JPRB, &
  & 0.35322390E-06_JPRB, 0.32393802E-06_JPRB, 0.29608739E-06_JPRB, 0.26868167E-06_JPRB, 0.24113538E-06_JPRB, 0.21407280E-06_JPRB, &
  & 0.18924567E-06_JPRB, 0.16903864E-06_JPRB, 0.15413256E-06_JPRB, 0.14334077E-06_JPRB, 0.13517327E-06_JPRB, 0.12844893E-06_JPRB, &
  & 0.12250548E-06_JPRB, 0.11697881E-06_JPRB, 0.11160343E-06_JPRB, 0.10624851E-06_JPRB, 0.10094577E-06_JPRB, 0.95822919E-07_JPRB, &
  & 0.91115808E-07_JPRB, 0.87063789E-07_JPRB, 0.83892566E-07_JPRB, 0.81597854E-07_JPRB, 0.80125297E-07_JPRB, 0.79133379E-07_JPRB, &
  & 0.78476489E-07_JPRB, 0.77954233E-07_JPRB, 0.77462033E-07_JPRB, 0.76745089E-07_JPRB /)

RGHG2(:,12, 2) = (/ &
  & 0.13967620E-06_JPRB, 0.15374545E-06_JPRB, 0.16030194E-06_JPRB, 0.16686666E-06_JPRB, 0.17400373E-06_JPRB, 0.18271336E-06_JPRB, &
  & 0.19336962E-06_JPRB, 0.20627411E-06_JPRB, 0.22177051E-06_JPRB, 0.24011115E-06_JPRB, 0.26144465E-06_JPRB, 0.28568687E-06_JPRB, &
  & 0.31255621E-06_JPRB, 0.34154598E-06_JPRB, 0.37199732E-06_JPRB, 0.40316544E-06_JPRB, 0.43427104E-06_JPRB, 0.46433024E-06_JPRB, &
  & 0.49265554E-06_JPRB, 0.51860246E-06_JPRB, 0.54166787E-06_JPRB, 0.56147559E-06_JPRB, 0.57787071E-06_JPRB, 0.59065002E-06_JPRB, &
  & 0.59990964E-06_JPRB, 0.60569550E-06_JPRB, 0.60817621E-06_JPRB, 0.60740035E-06_JPRB, 0.60307514E-06_JPRB, 0.59457307E-06_JPRB, &
  & 0.58083032E-06_JPRB, 0.56069922E-06_JPRB, 0.53333031E-06_JPRB, 0.49894902E-06_JPRB, 0.45958816E-06_JPRB, 0.41884613E-06_JPRB, &
  & 0.38047608E-06_JPRB, 0.34606552E-06_JPRB, 0.31534026E-06_JPRB, 0.28694754E-06_JPRB, 0.25936490E-06_JPRB, 0.23229155E-06_JPRB, &
  & 0.20727387E-06_JPRB, 0.18614587E-06_JPRB, 0.16970215E-06_JPRB, 0.15727048E-06_JPRB, 0.14760121E-06_JPRB, 0.13968943E-06_JPRB, &
  & 0.13278510E-06_JPRB, 0.12637082E-06_JPRB, 0.12018019E-06_JPRB, 0.11414141E-06_JPRB, 0.10826390E-06_JPRB, 0.10267389E-06_JPRB, &
  & 0.97589101E-07_JPRB, 0.93298915E-07_JPRB, 0.89961830E-07_JPRB, 0.87662954E-07_JPRB, 0.86120998E-07_JPRB, 0.85176168E-07_JPRB, &
  & 0.84507093E-07_JPRB, 0.84003943E-07_JPRB, 0.83533408E-07_JPRB, 0.82862847E-07_JPRB /)

RGHG2(:,13, 2) = (/ &
  & 0.24052360E-06_JPRB, 0.24954159E-06_JPRB, 0.25333125E-06_JPRB, 0.25795384E-06_JPRB, 0.26387482E-06_JPRB, 0.27168105E-06_JPRB, &
  & 0.28179977E-06_JPRB, 0.29462780E-06_JPRB, 0.31047455E-06_JPRB, 0.32970320E-06_JPRB, 0.35253441E-06_JPRB, 0.37893554E-06_JPRB, &
  & 0.40868781E-06_JPRB, 0.44134151E-06_JPRB, 0.47617880E-06_JPRB, 0.51228199E-06_JPRB, 0.54861363E-06_JPRB, 0.58397080E-06_JPRB, &
  & 0.61715485E-06_JPRB, 0.64750725E-06_JPRB, 0.67407740E-06_JPRB, 0.69652680E-06_JPRB, 0.71444276E-06_JPRB, 0.72770854E-06_JPRB, &
  & 0.73618520E-06_JPRB, 0.73962673E-06_JPRB, 0.73786896E-06_JPRB, 0.73061858E-06_JPRB, 0.71759445E-06_JPRB, 0.69835653E-06_JPRB, &
  & 0.67246953E-06_JPRB, 0.63960232E-06_JPRB, 0.59991231E-06_JPRB, 0.55447731E-06_JPRB, 0.50601830E-06_JPRB, 0.45898838E-06_JPRB, &
  & 0.41730564E-06_JPRB, 0.38205124E-06_JPRB, 0.35207637E-06_JPRB, 0.32565617E-06_JPRB, 0.30120182E-06_JPRB, 0.27768940E-06_JPRB, &
  & 0.25496925E-06_JPRB, 0.23385414E-06_JPRB, 0.21529669E-06_JPRB, 0.19949849E-06_JPRB, 0.18598564E-06_JPRB, 0.17404945E-06_JPRB, &
  & 0.16312592E-06_JPRB, 0.15285386E-06_JPRB, 0.14306100E-06_JPRB, 0.13369026E-06_JPRB, 0.12482516E-06_JPRB, 0.11667914E-06_JPRB, &
  & 0.10953043E-06_JPRB, 0.10362943E-06_JPRB, 0.99153738E-07_JPRB, 0.95993897E-07_JPRB, 0.94001962E-07_JPRB, 0.92676686E-07_JPRB, &
  & 0.91808133E-07_JPRB, 0.91115453E-07_JPRB, 0.90467175E-07_JPRB, 0.89509946E-07_JPRB /)

RGHG2(:,14, 2) = (/ &
  & 0.34866741E-06_JPRB, 0.35332482E-06_JPRB, 0.35614622E-06_JPRB, 0.36000640E-06_JPRB, 0.36562142E-06_JPRB, 0.37336980E-06_JPRB, &
  & 0.38358215E-06_JPRB, 0.39656220E-06_JPRB, 0.41265073E-06_JPRB, 0.43224441E-06_JPRB, 0.45563385E-06_JPRB, 0.48288143E-06_JPRB, &
  & 0.51381346E-06_JPRB, 0.54798261E-06_JPRB, 0.58471954E-06_JPRB, 0.62307032E-06_JPRB, 0.66198646E-06_JPRB, 0.69993291E-06_JPRB, &
  & 0.73563831E-06_JPRB, 0.76801024E-06_JPRB, 0.79608742E-06_JPRB, 0.81939868E-06_JPRB, 0.83747125E-06_JPRB, 0.85007355E-06_JPRB, &
  & 0.85686031E-06_JPRB, 0.85738594E-06_JPRB, 0.85121712E-06_JPRB, 0.83793640E-06_JPRB, 0.81725358E-06_JPRB, 0.78911074E-06_JPRB, &
  & 0.75373327E-06_JPRB, 0.71184678E-06_JPRB, 0.66479083E-06_JPRB, 0.61481336E-06_JPRB, 0.56501790E-06_JPRB, 0.51940475E-06_JPRB, &
  & 0.48111747E-06_JPRB, 0.45080429E-06_JPRB, 0.42698719E-06_JPRB, 0.40730023E-06_JPRB, 0.38956662E-06_JPRB, 0.37227409E-06_JPRB, &
  & 0.35441892E-06_JPRB, 0.33529651E-06_JPRB, 0.31531442E-06_JPRB, 0.29527456E-06_JPRB, 0.27563158E-06_JPRB, 0.25642913E-06_JPRB, &
  & 0.23766218E-06_JPRB, 0.21926569E-06_JPRB, 0.20130082E-06_JPRB, 0.18399163E-06_JPRB, 0.16769717E-06_JPRB, 0.15284307E-06_JPRB, &
  & 0.13990419E-06_JPRB, 0.12924500E-06_JPRB, 0.12100743E-06_JPRB, 0.11512769E-06_JPRB, 0.11114571E-06_JPRB, 0.10859824E-06_JPRB, &
  & 0.10676858E-06_JPRB, 0.10535117E-06_JPRB, 0.10394076E-06_JPRB, 0.10182507E-06_JPRB /)

RGHG2(:,15, 2) = (/ &
  & 0.45170336E-06_JPRB, 0.45608326E-06_JPRB, 0.45944088E-06_JPRB, 0.46438487E-06_JPRB, 0.47130499E-06_JPRB, 0.48040619E-06_JPRB, &
  & 0.49190049E-06_JPRB, 0.50592070E-06_JPRB, 0.52278438E-06_JPRB, 0.54284629E-06_JPRB, 0.56644609E-06_JPRB, 0.59366738E-06_JPRB, &
  & 0.62440415E-06_JPRB, 0.65831767E-06_JPRB, 0.69482468E-06_JPRB, 0.73305841E-06_JPRB, 0.77192783E-06_JPRB, 0.80994772E-06_JPRB, &
  & 0.84577277E-06_JPRB, 0.87800566E-06_JPRB, 0.90573570E-06_JPRB, 0.92818971E-06_JPRB, 0.94495363E-06_JPRB, 0.95563848E-06_JPRB, &
  & 0.95975577E-06_JPRB, 0.95674227E-06_JPRB, 0.94606918E-06_JPRB, 0.92730568E-06_JPRB, 0.90050548E-06_JPRB, 0.86608560E-06_JPRB, &
  & 0.82502606E-06_JPRB, 0.77897369E-06_JPRB, 0.73029940E-06_JPRB, 0.68165696E-06_JPRB, 0.63681296E-06_JPRB, 0.59981068E-06_JPRB, &
  & 0.57221325E-06_JPRB, 0.55333379E-06_JPRB, 0.54061167E-06_JPRB, 0.53114525E-06_JPRB, 0.52235174E-06_JPRB, 0.51284758E-06_JPRB, &
  & 0.50072435E-06_JPRB, 0.48464960E-06_JPRB, 0.46469589E-06_JPRB, 0.44181991E-06_JPRB, 0.41701358E-06_JPRB, 0.39091927E-06_JPRB, &
  & 0.36380675E-06_JPRB, 0.33596473E-06_JPRB, 0.30778199E-06_JPRB, 0.27978479E-06_JPRB, 0.25267539E-06_JPRB, 0.22738566E-06_JPRB, &
  & 0.20478092E-06_JPRB, 0.18559172E-06_JPRB, 0.17009629E-06_JPRB, 0.15840192E-06_JPRB, 0.15012301E-06_JPRB, 0.14434741E-06_JPRB, &
  & 0.14027468E-06_JPRB, 0.13684027E-06_JPRB, 0.13352260E-06_JPRB, 0.12821886E-06_JPRB /)

RGHG2(:,16, 2) = (/ &
  & 0.54634978E-06_JPRB, 0.55369821E-06_JPRB, 0.55946924E-06_JPRB, 0.56681120E-06_JPRB, 0.57616757E-06_JPRB, 0.58771298E-06_JPRB, &
  & 0.60141019E-06_JPRB, 0.61740167E-06_JPRB, 0.63578824E-06_JPRB, 0.65690705E-06_JPRB, 0.68096767E-06_JPRB, 0.70801013E-06_JPRB, &
  & 0.73794092E-06_JPRB, 0.77057172E-06_JPRB, 0.80551337E-06_JPRB, 0.84202497E-06_JPRB, 0.87902760E-06_JPRB, 0.91528932E-06_JPRB, &
  & 0.94933694E-06_JPRB, 0.97979728E-06_JPRB, 0.10055612E-05_JPRB, 0.10257977E-05_JPRB, 0.10400103E-05_JPRB, 0.10477204E-05_JPRB, &
  & 0.10483939E-05_JPRB, 0.10414592E-05_JPRB, 0.10264297E-05_JPRB, 0.10033032E-05_JPRB, 0.97235136E-06_JPRB, 0.93457220E-06_JPRB, &
  & 0.89189780E-06_JPRB, 0.84657688E-06_JPRB, 0.80147652E-06_JPRB, 0.76011582E-06_JPRB, 0.72616001E-06_JPRB, 0.70156290E-06_JPRB, &
  & 0.68732066E-06_JPRB, 0.68138888E-06_JPRB, 0.68019511E-06_JPRB, 0.68048064E-06_JPRB, 0.68001486E-06_JPRB, 0.67646283E-06_JPRB, &
  & 0.66812288E-06_JPRB, 0.65414730E-06_JPRB, 0.63474477E-06_JPRB, 0.61086035E-06_JPRB, 0.58350645E-06_JPRB, 0.55337819E-06_JPRB, &
  & 0.52091502E-06_JPRB, 0.48648275E-06_JPRB, 0.45057587E-06_JPRB, 0.41390234E-06_JPRB, 0.37740634E-06_JPRB, 0.34224942E-06_JPRB, &
  & 0.30977844E-06_JPRB, 0.28109099E-06_JPRB, 0.25686023E-06_JPRB, 0.23729882E-06_JPRB, 0.22249077E-06_JPRB, 0.21172220E-06_JPRB, &
  & 0.20338274E-06_JPRB, 0.19660328E-06_JPRB, 0.18942032E-06_JPRB, 0.17844152E-06_JPRB /)

RGHG2(:,17, 2) = (/ &
  & 0.63543496E-06_JPRB, 0.64703477E-06_JPRB, 0.65563307E-06_JPRB, 0.66571613E-06_JPRB, 0.67797288E-06_JPRB, 0.69247085E-06_JPRB, &
  & 0.70912688E-06_JPRB, 0.72773958E-06_JPRB, 0.74832798E-06_JPRB, 0.77101186E-06_JPRB, 0.79596833E-06_JPRB, 0.82315427E-06_JPRB, &
  & 0.85229738E-06_JPRB, 0.88328761E-06_JPRB, 0.91606495E-06_JPRB, 0.94994391E-06_JPRB, 0.98403757E-06_JPRB, 0.10173355E-05_JPRB, &
  & 0.10483025E-05_JPRB, 0.10756231E-05_JPRB, 0.10981580E-05_JPRB, 0.11150370E-05_JPRB, 0.11256939E-05_JPRB, 0.11296761E-05_JPRB, &
  & 0.11264783E-05_JPRB, 0.11156937E-05_JPRB, 0.10972292E-05_JPRB, 0.10712874E-05_JPRB, 0.10390902E-05_JPRB, 0.10021843E-05_JPRB, &
  & 0.96198869E-06_JPRB, 0.92185866E-06_JPRB, 0.88473485E-06_JPRB, 0.85383465E-06_JPRB, 0.83158181E-06_JPRB, 0.81992317E-06_JPRB, &
  & 0.81808275E-06_JPRB, 0.82291615E-06_JPRB, 0.83039515E-06_JPRB, 0.83711132E-06_JPRB, 0.84092858E-06_JPRB, 0.84015966E-06_JPRB, &
  & 0.83347265E-06_JPRB, 0.82026776E-06_JPRB, 0.80105178E-06_JPRB, 0.77693244E-06_JPRB, 0.74881308E-06_JPRB, 0.71722008E-06_JPRB, &
  & 0.68252962E-06_JPRB, 0.64506929E-06_JPRB, 0.60540606E-06_JPRB, 0.56426779E-06_JPRB, 0.52258844E-06_JPRB, 0.48167999E-06_JPRB, &
  & 0.44295410E-06_JPRB, 0.40775410E-06_JPRB, 0.37679519E-06_JPRB, 0.35060575E-06_JPRB, 0.32941807E-06_JPRB, 0.31270582E-06_JPRB, &
  & 0.29972912E-06_JPRB, 0.28800577E-06_JPRB, 0.27624381E-06_JPRB, 0.25670886E-06_JPRB /)

RGHG2(:,18, 2) = (/ &
  & 0.71420021E-06_JPRB, 0.73219690E-06_JPRB, 0.74429698E-06_JPRB, 0.75747596E-06_JPRB, 0.77281419E-06_JPRB, 0.79050733E-06_JPRB, &
  & 0.81025792E-06_JPRB, 0.83183846E-06_JPRB, 0.85501324E-06_JPRB, 0.87972523E-06_JPRB, 0.90595483E-06_JPRB, 0.93372580E-06_JPRB, &
  & 0.96255144E-06_JPRB, 0.99214117E-06_JPRB, 0.10228046E-05_JPRB, 0.10539369E-05_JPRB, 0.10847704E-05_JPRB, 0.11144291E-05_JPRB, &
  & 0.11415724E-05_JPRB, 0.11649644E-05_JPRB, 0.11834724E-05_JPRB, 0.11963261E-05_JPRB, 0.12029324E-05_JPRB, 0.12029170E-05_JPRB, &
  & 0.11960212E-05_JPRB, 0.11822879E-05_JPRB, 0.11620584E-05_JPRB, 0.11363978E-05_JPRB, 0.11061373E-05_JPRB, 0.10730222E-05_JPRB, &
  & 0.10400919E-05_JPRB, 0.10091411E-05_JPRB, 0.98274199E-06_JPRB, 0.96329347E-06_JPRB, 0.95269854E-06_JPRB, 0.95138455E-06_JPRB, &
  & 0.95795804E-06_JPRB, 0.96895280E-06_JPRB, 0.98040505E-06_JPRB, 0.98944588E-06_JPRB, 0.99406577E-06_JPRB, 0.99277440E-06_JPRB, &
  & 0.98500050E-06_JPRB, 0.97089048E-06_JPRB, 0.95119844E-06_JPRB, 0.92682461E-06_JPRB, 0.89851113E-06_JPRB, 0.86668121E-06_JPRB, &
  & 0.83155260E-06_JPRB, 0.79350070E-06_JPRB, 0.75307616E-06_JPRB, 0.71102033E-06_JPRB, 0.66824003E-06_JPRB, 0.62591141E-06_JPRB, &
  & 0.58544367E-06_JPRB, 0.54801887E-06_JPRB, 0.51431380E-06_JPRB, 0.48462493E-06_JPRB, 0.45926538E-06_JPRB, 0.43841786E-06_JPRB, &
  & 0.42062049E-06_JPRB, 0.40484568E-06_JPRB, 0.38768289E-06_JPRB, 0.35960991E-06_JPRB /)

RGHG2(:,19, 2) = (/ &
  & 0.78755892E-06_JPRB, 0.81037723E-06_JPRB, 0.82572490E-06_JPRB, 0.84154743E-06_JPRB, 0.85942872E-06_JPRB, 0.87966350E-06_JPRB, &
  & 0.90205049E-06_JPRB, 0.92614755E-06_JPRB, 0.95164540E-06_JPRB, 0.97830809E-06_JPRB, 0.10058864E-05_JPRB, 0.10342982E-05_JPRB, &
  & 0.10631306E-05_JPRB, 0.10918027E-05_JPRB, 0.11206399E-05_JPRB, 0.11493106E-05_JPRB, 0.11770391E-05_JPRB, 0.12030424E-05_JPRB, &
  & 0.12262400E-05_JPRB, 0.12455652E-05_JPRB, 0.12600188E-05_JPRB, 0.12688579E-05_JPRB, 0.12716223E-05_JPRB, 0.12681132E-05_JPRB, &
  & 0.12584406E-05_JPRB, 0.12431284E-05_JPRB, 0.12230890E-05_JPRB, 0.11994243E-05_JPRB, 0.11742662E-05_JPRB, 0.11495769E-05_JPRB, &
  & 0.11268145E-05_JPRB, 0.11073832E-05_JPRB, 0.10930302E-05_JPRB, 0.10851145E-05_JPRB, 0.10841228E-05_JPRB, 0.10897369E-05_JPRB, &
  & 0.11002560E-05_JPRB, 0.11124708E-05_JPRB, 0.11232141E-05_JPRB, 0.11301613E-05_JPRB, 0.11319661E-05_JPRB, 0.11279659E-05_JPRB, &
  & 0.11179883E-05_JPRB, 0.11022640E-05_JPRB, 0.10814676E-05_JPRB, 0.10564592E-05_JPRB, 0.10279193E-05_JPRB, 0.99616727E-06_JPRB, &
  & 0.96132555E-06_JPRB, 0.92383232E-06_JPRB, 0.88433865E-06_JPRB, 0.84353178E-06_JPRB, 0.80224765E-06_JPRB, 0.76154373E-06_JPRB, &
  & 0.72261412E-06_JPRB, 0.68642396E-06_JPRB, 0.65334689E-06_JPRB, 0.62351404E-06_JPRB, 0.59709879E-06_JPRB, 0.57394971E-06_JPRB, &
  & 0.55365888E-06_JPRB, 0.53444131E-06_JPRB, 0.51304079E-06_JPRB, 0.47797141E-06_JPRB /)

RGHG2(:,20, 2) = (/ &
  & 0.85691414E-06_JPRB, 0.88034790E-06_JPRB, 0.89752785E-06_JPRB, 0.91554148E-06_JPRB, 0.93558418E-06_JPRB, 0.95796702E-06_JPRB, &
  & 0.98234909E-06_JPRB, 0.10083786E-05_JPRB, 0.10356052E-05_JPRB, 0.10636820E-05_JPRB, 0.10922886E-05_JPRB, 0.11210993E-05_JPRB, &
  & 0.11498454E-05_JPRB, 0.11779072E-05_JPRB, 0.12052853E-05_JPRB, 0.12318520E-05_JPRB, 0.12569128E-05_JPRB, 0.12797714E-05_JPRB, &
  & 0.12995441E-05_JPRB, 0.13153534E-05_JPRB, 0.13263769E-05_JPRB, 0.13320022E-05_JPRB, 0.13318848E-05_JPRB, 0.13260743E-05_JPRB, &
  & 0.13150362E-05_JPRB, 0.12997310E-05_JPRB, 0.12816048E-05_JPRB, 0.12627152E-05_JPRB, 0.12448976E-05_JPRB, 0.12292704E-05_JPRB, &
  & 0.12173707E-05_JPRB, 0.12097657E-05_JPRB, 0.12069482E-05_JPRB, 0.12087609E-05_JPRB, 0.12147472E-05_JPRB, 0.12239764E-05_JPRB, &
  & 0.12348152E-05_JPRB, 0.12450575E-05_JPRB, 0.12523366E-05_JPRB, 0.12549746E-05_JPRB, 0.12523168E-05_JPRB, 0.12442922E-05_JPRB, &
  & 0.12310924E-05_JPRB, 0.12131050E-05_JPRB, 0.11910099E-05_JPRB, 0.11654089E-05_JPRB, 0.11367890E-05_JPRB, 0.11052380E-05_JPRB, &
  & 0.10711370E-05_JPRB, 0.10349947E-05_JPRB, 0.99744250E-06_JPRB, 0.95914595E-06_JPRB, 0.92085759E-06_JPRB, 0.88345416E-06_JPRB, &
  & 0.84783744E-06_JPRB, 0.81467067E-06_JPRB, 0.78417230E-06_JPRB, 0.75615998E-06_JPRB, 0.73063131E-06_JPRB, 0.70749519E-06_JPRB, &
  & 0.68622819E-06_JPRB, 0.66501269E-06_JPRB, 0.64184678E-06_JPRB, 0.60015884E-06_JPRB /)

RGHG2(:,21, 2) = (/ &
  & 0.91766935E-06_JPRB, 0.94538495E-06_JPRB, 0.96321719E-06_JPRB, 0.98160683E-06_JPRB, 0.10024042E-05_JPRB, 0.10257368E-05_JPRB, &
  & 0.10512726E-05_JPRB, 0.10783258E-05_JPRB, 0.11064714E-05_JPRB, 0.11352797E-05_JPRB, 0.11643230E-05_JPRB, 0.11931994E-05_JPRB, &
  & 0.12215746E-05_JPRB, 0.12490170E-05_JPRB, 0.12752528E-05_JPRB, 0.13000979E-05_JPRB, 0.13230923E-05_JPRB, 0.13435694E-05_JPRB, &
  & 0.13608382E-05_JPRB, 0.13741601E-05_JPRB, 0.13828727E-05_JPRB, 0.13865199E-05_JPRB, 0.13849605E-05_JPRB, 0.13783666E-05_JPRB, &
  & 0.13675893E-05_JPRB, 0.13539205E-05_JPRB, 0.13392074E-05_JPRB, 0.13254278E-05_JPRB, 0.13142585E-05_JPRB, 0.13072591E-05_JPRB, &
  & 0.13048634E-05_JPRB, 0.13068529E-05_JPRB, 0.13126692E-05_JPRB, 0.13208513E-05_JPRB, 0.13309052E-05_JPRB, 0.13416006E-05_JPRB, &
  & 0.13512829E-05_JPRB, 0.13580960E-05_JPRB, 0.13607265E-05_JPRB, 0.13584973E-05_JPRB, 0.13513919E-05_JPRB, 0.13396857E-05_JPRB, &
  & 0.13237891E-05_JPRB, 0.13041215E-05_JPRB, 0.12810991E-05_JPRB, 0.12551964E-05_JPRB, 0.12266421E-05_JPRB, 0.11957226E-05_JPRB, &
  & 0.11630016E-05_JPRB, 0.11288919E-05_JPRB, 0.10940514E-05_JPRB, 0.10590834E-05_JPRB, 0.10246041E-05_JPRB, 0.99124532E-06_JPRB, &
  & 0.95963276E-06_JPRB, 0.93016871E-06_JPRB, 0.90280162E-06_JPRB, 0.87737283E-06_JPRB, 0.85365588E-06_JPRB, 0.83144278E-06_JPRB, &
  & 0.81003833E-06_JPRB, 0.78879276E-06_JPRB, 0.76296379E-06_JPRB, 0.72017792E-06_JPRB /)

RGHG2(:,22, 2) = (/ &
  & 0.97518000E-06_JPRB, 0.10036024E-05_JPRB, 0.10221727E-05_JPRB, 0.10408949E-05_JPRB, 0.10615447E-05_JPRB, 0.10847883E-05_JPRB, &
  & 0.11103241E-05_JPRB, 0.11375694E-05_JPRB, 0.11658159E-05_JPRB, 0.11945897E-05_JPRB, 0.12234811E-05_JPRB, 0.12520072E-05_JPRB, &
  & 0.12798068E-05_JPRB, 0.13065230E-05_JPRB, 0.13318202E-05_JPRB, 0.13554132E-05_JPRB, 0.13769086E-05_JPRB, 0.13957880E-05_JPRB, &
  & 0.14114622E-05_JPRB, 0.14233767E-05_JPRB, 0.14310390E-05_JPRB, 0.14340993E-05_JPRB, 0.14324946E-05_JPRB, 0.14266823E-05_JPRB, &
  & 0.14174143E-05_JPRB, 0.14063874E-05_JPRB, 0.13953387E-05_JPRB, 0.13863016E-05_JPRB, 0.13808248E-05_JPRB, 0.13801401E-05_JPRB, &
  & 0.13841920E-05_JPRB, 0.13923285E-05_JPRB, 0.14027071E-05_JPRB, 0.14144348E-05_JPRB, 0.14259595E-05_JPRB, 0.14359352E-05_JPRB, &
  & 0.14431726E-05_JPRB, 0.14465111E-05_JPRB, 0.14452461E-05_JPRB, 0.14392908E-05_JPRB, 0.14289890E-05_JPRB, 0.14148374E-05_JPRB, &
  & 0.13973422E-05_JPRB, 0.13768019E-05_JPRB, 0.13535871E-05_JPRB, 0.13278965E-05_JPRB, 0.13000300E-05_JPRB, 0.12705980E-05_JPRB, &
  & 0.12398474E-05_JPRB, 0.12083908E-05_JPRB, 0.11768259E-05_JPRB, 0.11456414E-05_JPRB, 0.11152856E-05_JPRB, 0.10861382E-05_JPRB, &
  & 0.10585509E-05_JPRB, 0.10326858E-05_JPRB, 0.10084650E-05_JPRB, 0.98553778E-06_JPRB, 0.96368831E-06_JPRB, 0.94260611E-06_JPRB, &
  & 0.92192784E-06_JPRB, 0.89990124E-06_JPRB, 0.87496574E-06_JPRB, 0.82892979E-06_JPRB /)

RGHG2(:,23, 2) = (/ &
  & 0.10272620E-05_JPRB, 0.10556107E-05_JPRB, 0.10745355E-05_JPRB, 0.10932009E-05_JPRB, 0.11137347E-05_JPRB, 0.11364571E-05_JPRB, &
  & 0.11613353E-05_JPRB, 0.11879066E-05_JPRB, 0.12155559E-05_JPRB, 0.12437177E-05_JPRB, 0.12719429E-05_JPRB, 0.12997590E-05_JPRB, &
  & 0.13267889E-05_JPRB, 0.13526573E-05_JPRB, 0.13770833E-05_JPRB, 0.13997521E-05_JPRB, 0.14203048E-05_JPRB, 0.14383311E-05_JPRB, &
  & 0.14533711E-05_JPRB, 0.14649589E-05_JPRB, 0.14726899E-05_JPRB, 0.14763509E-05_JPRB, 0.14760074E-05_JPRB, 0.14720024E-05_JPRB, &
  & 0.14653793E-05_JPRB, 0.14575070E-05_JPRB, 0.14500237E-05_JPRB, 0.14447346E-05_JPRB, 0.14432328E-05_JPRB, 0.14461887E-05_JPRB, &
  & 0.14535731E-05_JPRB, 0.14639025E-05_JPRB, 0.14759133E-05_JPRB, 0.14879851E-05_JPRB, 0.14987050E-05_JPRB, 0.15069343E-05_JPRB, &
  & 0.15116360E-05_JPRB, 0.15121529E-05_JPRB, 0.15081140E-05_JPRB, 0.14998298E-05_JPRB, 0.14877608E-05_JPRB, 0.14724965E-05_JPRB, &
  & 0.14544921E-05_JPRB, 0.14340037E-05_JPRB, 0.14112284E-05_JPRB, 0.13863933E-05_JPRB, 0.13600718E-05_JPRB, 0.13325846E-05_JPRB, &
  & 0.13043941E-05_JPRB, 0.12760632E-05_JPRB, 0.12480979E-05_JPRB, 0.12208645E-05_JPRB, 0.11945965E-05_JPRB, 0.11694754E-05_JPRB, &
  & 0.11456065E-05_JPRB, 0.11230081E-05_JPRB, 0.11014843E-05_JPRB, 0.10807933E-05_JPRB, 0.10605912E-05_JPRB, 0.10405581E-05_JPRB, &
  & 0.10201501E-05_JPRB, 0.99876058E-06_JPRB, 0.97239695E-06_JPRB, 0.92674134E-06_JPRB /)

RGHG2(:,24, 2) = (/ &
  & 0.10754990E-05_JPRB, 0.11036535E-05_JPRB, 0.11217553E-05_JPRB, 0.11399079E-05_JPRB, 0.11597791E-05_JPRB, 0.11818687E-05_JPRB, &
  & 0.12058639E-05_JPRB, 0.12313494E-05_JPRB, 0.12579188E-05_JPRB, 0.12850097E-05_JPRB, 0.13122296E-05_JPRB, 0.13391088E-05_JPRB, &
  & 0.13652601E-05_JPRB, 0.13903356E-05_JPRB, 0.14140076E-05_JPRB, 0.14359800E-05_JPRB, 0.14559484E-05_JPRB, 0.14735708E-05_JPRB, &
  & 0.14884959E-05_JPRB, 0.15003981E-05_JPRB, 0.15089958E-05_JPRB, 0.15141326E-05_JPRB, 0.15157877E-05_JPRB, 0.15144365E-05_JPRB, &
  & 0.15108825E-05_JPRB, 0.15062557E-05_JPRB, 0.15019904E-05_JPRB, 0.14995646E-05_JPRB, 0.15002281E-05_JPRB, 0.15047233E-05_JPRB, &
  & 0.15125802E-05_JPRB, 0.15227295E-05_JPRB, 0.15339160E-05_JPRB, 0.15445315E-05_JPRB, 0.15532953E-05_JPRB, 0.15592568E-05_JPRB, &
  & 0.15616098E-05_JPRB, 0.15599107E-05_JPRB, 0.15540913E-05_JPRB, 0.15445960E-05_JPRB, 0.15318914E-05_JPRB, 0.15165491E-05_JPRB, &
  & 0.14989223E-05_JPRB, 0.14791631E-05_JPRB, 0.14574489E-05_JPRB, 0.14341319E-05_JPRB, 0.14097047E-05_JPRB, 0.13845447E-05_JPRB, &
  & 0.13592131E-05_JPRB, 0.13341669E-05_JPRB, 0.13098368E-05_JPRB, 0.12864260E-05_JPRB, 0.12639987E-05_JPRB, 0.12425313E-05_JPRB, &
  & 0.12219389E-05_JPRB, 0.12021302E-05_JPRB, 0.11829409E-05_JPRB, 0.11640293E-05_JPRB, 0.11451107E-05_JPRB, 0.11258566E-05_JPRB, &
  & 0.11058785E-05_JPRB, 0.10840423E-05_JPRB, 0.10581688E-05_JPRB, 0.10113351E-05_JPRB /)

RGHG2(:,25, 2) = (/ &
  & 0.11202724E-05_JPRB, 0.11475805E-05_JPRB, 0.11652007E-05_JPRB, 0.11825048E-05_JPRB, 0.12014416E-05_JPRB, 0.12224530E-05_JPRB, &
  & 0.12453240E-05_JPRB, 0.12695177E-05_JPRB, 0.12946333E-05_JPRB, 0.13203635E-05_JPRB, 0.13462708E-05_JPRB, 0.13719664E-05_JPRB, &
  & 0.13970680E-05_JPRB, 0.14212108E-05_JPRB, 0.14441181E-05_JPRB, 0.14654877E-05_JPRB, 0.14850556E-05_JPRB, 0.15025824E-05_JPRB, &
  & 0.15178265E-05_JPRB, 0.15305277E-05_JPRB, 0.15404305E-05_JPRB, 0.15473807E-05_JPRB, 0.15514147E-05_JPRB, 0.15529160E-05_JPRB, &
  & 0.15524589E-05_JPRB, 0.15508851E-05_JPRB, 0.15493955E-05_JPRB, 0.15489679E-05_JPRB, 0.15508078E-05_JPRB, 0.15552769E-05_JPRB, &
  & 0.15621997E-05_JPRB, 0.15707694E-05_JPRB, 0.15798066E-05_JPRB, 0.15880215E-05_JPRB, 0.15943992E-05_JPRB, 0.15980096E-05_JPRB, &
  & 0.15983186E-05_JPRB, 0.15949637E-05_JPRB, 0.15881005E-05_JPRB, 0.15781652E-05_JPRB, 0.15656018E-05_JPRB, 0.15508402E-05_JPRB, &
  & 0.15341288E-05_JPRB, 0.15155774E-05_JPRB, 0.14953396E-05_JPRB, 0.14738029E-05_JPRB, 0.14514004E-05_JPRB, 0.14287347E-05_JPRB, &
  & 0.14062861E-05_JPRB, 0.13844725E-05_JPRB, 0.13635604E-05_JPRB, 0.13436509E-05_JPRB, 0.13246399E-05_JPRB, 0.13063568E-05_JPRB, &
  & 0.12885998E-05_JPRB, 0.12712064E-05_JPRB, 0.12539239E-05_JPRB, 0.12364910E-05_JPRB, 0.12185870E-05_JPRB, 0.11998839E-05_JPRB, &
  & 0.11800248E-05_JPRB, 0.11583434E-05_JPRB, 0.11320045E-05_JPRB, 0.10849205E-05_JPRB /)

RGHG2(:,26, 2) = (/ &
  & 0.11622997E-05_JPRB, 0.11885687E-05_JPRB, 0.12054788E-05_JPRB, 0.12219635E-05_JPRB, 0.12398499E-05_JPRB, 0.12595912E-05_JPRB, &
  & 0.12810656E-05_JPRB, 0.13037929E-05_JPRB, 0.13273267E-05_JPRB, 0.13514637E-05_JPRB, 0.13759042E-05_JPRB, 0.14002870E-05_JPRB, &
  & 0.14242355E-05_JPRB, 0.14474386E-05_JPRB, 0.14695693E-05_JPRB, 0.14903626E-05_JPRB, 0.15096123E-05_JPRB, 0.15271253E-05_JPRB, &
  & 0.15426962E-05_JPRB, 0.15561179E-05_JPRB, 0.15672201E-05_JPRB, 0.15759069E-05_JPRB, 0.15822075E-05_JPRB, 0.15863675E-05_JPRB, &
  & 0.15887088E-05_JPRB, 0.15898185E-05_JPRB, 0.15905174E-05_JPRB, 0.15916339E-05_JPRB, 0.15939162E-05_JPRB, 0.15977713E-05_JPRB, &
  & 0.16031568E-05_JPRB, 0.16095807E-05_JPRB, 0.16161409E-05_JPRB, 0.16218113E-05_JPRB, 0.16258074E-05_JPRB, 0.16273054E-05_JPRB, &
  & 0.16259327E-05_JPRB, 0.16214499E-05_JPRB, 0.16141081E-05_JPRB, 0.16043015E-05_JPRB, 0.15923289E-05_JPRB, 0.15785081E-05_JPRB, &
  & 0.15630100E-05_JPRB, 0.15458804E-05_JPRB, 0.15272714E-05_JPRB, 0.15075711E-05_JPRB, 0.14872957E-05_JPRB, 0.14670459E-05_JPRB, &
  & 0.14473228E-05_JPRB, 0.14284200E-05_JPRB, 0.14105373E-05_JPRB, 0.13936511E-05_JPRB, 0.13775484E-05_JPRB, 0.13619787E-05_JPRB, &
  & 0.13466520E-05_JPRB, 0.13312963E-05_JPRB, 0.13156852E-05_JPRB, 0.12994850E-05_JPRB, 0.12824133E-05_JPRB, 0.12641736E-05_JPRB, &
  & 0.12444632E-05_JPRB, 0.12227054E-05_JPRB, 0.11963415E-05_JPRB, 0.11492075E-05_JPRB /)

RGHG2(:,27, 2) = (/ &
  & 0.12023308E-05_JPRB, 0.12274992E-05_JPRB, 0.12435517E-05_JPRB, 0.12591090E-05_JPRB, 0.12758262E-05_JPRB, 0.12942396E-05_JPRB, &
  & 0.13141627E-05_JPRB, 0.13352526E-05_JPRB, 0.13570879E-05_JPRB, 0.13794806E-05_JPRB, 0.14022984E-05_JPRB, 0.14252001E-05_JPRB, &
  & 0.14479057E-05_JPRB, 0.14700441E-05_JPRB, 0.14913672E-05_JPRB, 0.15116100E-05_JPRB, 0.15305428E-05_JPRB, 0.15479551E-05_JPRB, &
  & 0.15636906E-05_JPRB, 0.15776225E-05_JPRB, 0.15896578E-05_JPRB, 0.15997290E-05_JPRB, 0.16078433E-05_JPRB, 0.16141209E-05_JPRB, &
  & 0.16187437E-05_JPRB, 0.16220540E-05_JPRB, 0.16245165E-05_JPRB, 0.16267588E-05_JPRB, 0.16292734E-05_JPRB, 0.16324664E-05_JPRB, &
  & 0.16363908E-05_JPRB, 0.16407594E-05_JPRB, 0.16449955E-05_JPRB, 0.16483712E-05_JPRB, 0.16502751E-05_JPRB, 0.16500586E-05_JPRB, &
  & 0.16474567E-05_JPRB, 0.16423536E-05_JPRB, 0.16349708E-05_JPRB, 0.16256057E-05_JPRB, 0.16144988E-05_JPRB, 0.16018384E-05_JPRB, &
  & 0.15877030E-05_JPRB, 0.15720937E-05_JPRB, 0.15551891E-05_JPRB, 0.15372924E-05_JPRB, 0.15189908E-05_JPRB, 0.15009592E-05_JPRB, &
  & 0.14835741E-05_JPRB, 0.14671657E-05_JPRB, 0.14518195E-05_JPRB, 0.14374009E-05_JPRB, 0.14237008E-05_JPRB, 0.14103379E-05_JPRB, &
  & 0.13970064E-05_JPRB, 0.13834259E-05_JPRB, 0.13692512E-05_JPRB, 0.13542068E-05_JPRB, 0.13379474E-05_JPRB, 0.13201989E-05_JPRB, &
  & 0.13008058E-05_JPRB, 0.12793014E-05_JPRB, 0.12533591E-05_JPRB, 0.12067458E-05_JPRB /)

RGHG2(:,28, 2) = (/ &
  & 0.12407722E-05_JPRB, 0.12648196E-05_JPRB, 0.12799555E-05_JPRB, 0.12944240E-05_JPRB, 0.13099539E-05_JPRB, 0.13269128E-05_JPRB, &
  & 0.13452656E-05_JPRB, 0.13646403E-05_JPRB, 0.13846935E-05_JPRB, 0.14053045E-05_JPRB, 0.14263626E-05_JPRB, 0.14477087E-05_JPRB, &
  & 0.14690071E-05_JPRB, 0.14900234E-05_JPRB, 0.15104492E-05_JPRB, 0.15300164E-05_JPRB, 0.15484902E-05_JPRB, 0.15656919E-05_JPRB, &
  & 0.15814796E-05_JPRB, 0.15957338E-05_JPRB, 0.16083784E-05_JPRB, 0.16193870E-05_JPRB, 0.16287819E-05_JPRB, 0.16366054E-05_JPRB, &
  & 0.16429271E-05_JPRB, 0.16478837E-05_JPRB, 0.16517304E-05_JPRB, 0.16548213E-05_JPRB, 0.16575309E-05_JPRB, 0.16601953E-05_JPRB, &
  & 0.16629251E-05_JPRB, 0.16656277E-05_JPRB, 0.16679813E-05_JPRB, 0.16694954E-05_JPRB, 0.16697352E-05_JPRB, 0.16682458E-05_JPRB, &
  & 0.16648452E-05_JPRB, 0.16594920E-05_JPRB, 0.16523688E-05_JPRB, 0.16437327E-05_JPRB, 0.16336966E-05_JPRB, 0.16222959E-05_JPRB, &
  & 0.16095535E-05_JPRB, 0.15954820E-05_JPRB, 0.15801668E-05_JPRB, 0.15639940E-05_JPRB, 0.15475410E-05_JPRB, 0.15313473E-05_JPRB, &
  & 0.15159717E-05_JPRB, 0.15015854E-05_JPRB, 0.14882617E-05_JPRB, 0.14758198E-05_JPRB, 0.14639597E-05_JPRB, 0.14523529E-05_JPRB, &
  & 0.14406518E-05_JPRB, 0.14285156E-05_JPRB, 0.14156465E-05_JPRB, 0.14016603E-05_JPRB, 0.13862491E-05_JPRB, 0.13691761E-05_JPRB, &
  & 0.13504135E-05_JPRB, 0.13296541E-05_JPRB, 0.13048668E-05_JPRB, 0.12596516E-05_JPRB /)

RGHG2(:,29, 2) = (/ &
  & 0.12780081E-05_JPRB, 0.13008067E-05_JPRB, 0.13149363E-05_JPRB, 0.13283471E-05_JPRB, 0.13425114E-05_JPRB, 0.13580527E-05_JPRB, &
  & 0.13747984E-05_JPRB, 0.13924733E-05_JPRB, 0.14107213E-05_JPRB, 0.14295365E-05_JPRB, 0.14487916E-05_JPRB, 0.14684985E-05_JPRB, &
  & 0.14884661E-05_JPRB, 0.15083209E-05_JPRB, 0.15278138E-05_JPRB, 0.15466758E-05_JPRB, 0.15646713E-05_JPRB, 0.15815640E-05_JPRB, &
  & 0.15971973E-05_JPRB, 0.16114683E-05_JPRB, 0.16243550E-05_JPRB, 0.16358517E-05_JPRB, 0.16459977E-05_JPRB, 0.16548084E-05_JPRB, &
  & 0.16622510E-05_JPRB, 0.16683238E-05_JPRB, 0.16731053E-05_JPRB, 0.16768164E-05_JPRB, 0.16796954E-05_JPRB, 0.16820051E-05_JPRB, &
  & 0.16839164E-05_JPRB, 0.16854110E-05_JPRB, 0.16863830E-05_JPRB, 0.16865135E-05_JPRB, 0.16855464E-05_JPRB, 0.16832017E-05_JPRB, &
  & 0.16793688E-05_JPRB, 0.16740936E-05_JPRB, 0.16675253E-05_JPRB, 0.16597770E-05_JPRB, 0.16508383E-05_JPRB, 0.16407045E-05_JPRB, &
  & 0.16293317E-05_JPRB, 0.16166897E-05_JPRB, 0.16029247E-05_JPRB, 0.15883322E-05_JPRB, 0.15734400E-05_JPRB, 0.15589038E-05_JPRB, &
  & 0.15451028E-05_JPRB, 0.15323535E-05_JPRB, 0.15205937E-05_JPRB, 0.15096304E-05_JPRB, 0.14992046E-05_JPRB, 0.14889361E-05_JPRB, &
  & 0.14784869E-05_JPRB, 0.14675650E-05_JPRB, 0.14557502E-05_JPRB, 0.14427596E-05_JPRB, 0.14282135E-05_JPRB, 0.14120185E-05_JPRB, &
  & 0.13942256E-05_JPRB, 0.13750119E-05_JPRB, 0.13517372E-05_JPRB, 0.13100779E-05_JPRB /)

RGHG2(:,30, 2) = (/ &
  & 0.13140486E-05_JPRB, 0.13356015E-05_JPRB, 0.13486474E-05_JPRB, 0.13608188E-05_JPRB, 0.13737413E-05_JPRB, 0.13877810E-05_JPRB, &
  & 0.14029779E-05_JPRB, 0.14189800E-05_JPRB, 0.14355097E-05_JPRB, 0.14525160E-05_JPRB, 0.14700282E-05_JPRB, 0.14880126E-05_JPRB, &
  & 0.15064746E-05_JPRB, 0.15252206E-05_JPRB, 0.15438840E-05_JPRB, 0.15621287E-05_JPRB, 0.15796379E-05_JPRB, 0.15961746E-05_JPRB, &
  & 0.16115320E-05_JPRB, 0.16256330E-05_JPRB, 0.16384781E-05_JPRB, 0.16501166E-05_JPRB, 0.16605908E-05_JPRB, 0.16698854E-05_JPRB, &
  & 0.16779301E-05_JPRB, 0.16845886E-05_JPRB, 0.16899332E-05_JPRB, 0.16939990E-05_JPRB, 0.16969931E-05_JPRB, 0.16990878E-05_JPRB, &
  & 0.17004982E-05_JPRB, 0.17011853E-05_JPRB, 0.17012427E-05_JPRB, 0.17004305E-05_JPRB, 0.16986963E-05_JPRB, 0.16958876E-05_JPRB, &
  & 0.16919861E-05_JPRB, 0.16870401E-05_JPRB, 0.16811016E-05_JPRB, 0.16742239E-05_JPRB, 0.16663724E-05_JPRB, 0.16574411E-05_JPRB, &
  & 0.16473494E-05_JPRB, 0.16360441E-05_JPRB, 0.16236418E-05_JPRB, 0.16104648E-05_JPRB, 0.15970162E-05_JPRB, 0.15838008E-05_JPRB, &
  & 0.15713812E-05_JPRB, 0.15598783E-05_JPRB, 0.15493106E-05_JPRB, 0.15394979E-05_JPRB, 0.15300999E-05_JPRB, 0.15208514E-05_JPRB, &
  & 0.15113808E-05_JPRB, 0.15013705E-05_JPRB, 0.14904876E-05_JPRB, 0.14783445E-05_JPRB, 0.14646967E-05_JPRB, 0.14494781E-05_JPRB, &
  & 0.14331933E-05_JPRB, 0.14156527E-05_JPRB, 0.13954855E-05_JPRB, 0.13576019E-05_JPRB /)

RGHG2(:,31, 2) = (/ &
  & 0.13489997E-05_JPRB, 0.13689830E-05_JPRB, 0.13809580E-05_JPRB, 0.13919948E-05_JPRB, 0.14035506E-05_JPRB, 0.14162330E-05_JPRB, &
  & 0.14299375E-05_JPRB, 0.14443580E-05_JPRB, 0.14592677E-05_JPRB, 0.14745749E-05_JPRB, 0.14903949E-05_JPRB, 0.15068520E-05_JPRB, &
  & 0.15238969E-05_JPRB, 0.15414200E-05_JPRB, 0.15591894E-05_JPRB, 0.15767984E-05_JPRB, 0.15938466E-05_JPRB, 0.16099925E-05_JPRB, &
  & 0.16250289E-05_JPRB, 0.16388557E-05_JPRB, 0.16514995E-05_JPRB, 0.16630238E-05_JPRB, 0.16734826E-05_JPRB, 0.16828423E-05_JPRB, &
  & 0.16910227E-05_JPRB, 0.16978446E-05_JPRB, 0.17033830E-05_JPRB, 0.17075580E-05_JPRB, 0.17105782E-05_JPRB, 0.17125506E-05_JPRB, &
  & 0.17136500E-05_JPRB, 0.17138676E-05_JPRB, 0.17133798E-05_JPRB, 0.17120119E-05_JPRB, 0.17098711E-05_JPRB, 0.17068818E-05_JPRB, &
  & 0.17030867E-05_JPRB, 0.16985402E-05_JPRB, 0.16932756E-05_JPRB, 0.16873018E-05_JPRB, 0.16804868E-05_JPRB, 0.16726719E-05_JPRB, &
  & 0.16637188E-05_JPRB, 0.16535716E-05_JPRB, 0.16423943E-05_JPRB, 0.16304591E-05_JPRB, 0.16182223E-05_JPRB, 0.16062619E-05_JPRB, &
  & 0.15949068E-05_JPRB, 0.15844630E-05_JPRB, 0.15748333E-05_JPRB, 0.15658427E-05_JPRB, 0.15572621E-05_JPRB, 0.15487473E-05_JPRB, &
  & 0.15400283E-05_JPRB, 0.15307814E-05_JPRB, 0.15206457E-05_JPRB, 0.15092972E-05_JPRB, 0.14965090E-05_JPRB, 0.14824957E-05_JPRB, &
  & 0.14677324E-05_JPRB, 0.14526782E-05_JPRB, 0.14348900E-05_JPRB, 0.14026999E-05_JPRB /)

RGHG2(:,32, 2) = (/ &
  & 0.13824575E-05_JPRB, 0.14010225E-05_JPRB, 0.14118173E-05_JPRB, 0.14216878E-05_JPRB, 0.14320700E-05_JPRB, 0.14434097E-05_JPRB, &
  & 0.14557456E-05_JPRB, 0.14687122E-05_JPRB, 0.14821002E-05_JPRB, 0.14958082E-05_JPRB, 0.15100281E-05_JPRB, 0.15249426E-05_JPRB, &
  & 0.15406829E-05_JPRB, 0.15571375E-05_JPRB, 0.15740391E-05_JPRB, 0.15910092E-05_JPRB, 0.16075846E-05_JPRB, 0.16233621E-05_JPRB, &
  & 0.16380646E-05_JPRB, 0.16515776E-05_JPRB, 0.16639108E-05_JPRB, 0.16751513E-05_JPRB, 0.16853105E-05_JPRB, 0.16944318E-05_JPRB, &
  & 0.17023252E-05_JPRB, 0.17089909E-05_JPRB, 0.17143793E-05_JPRB, 0.17184720E-05_JPRB, 0.17214071E-05_JPRB, 0.17232937E-05_JPRB, &
  & 0.17241912E-05_JPRB, 0.17242144E-05_JPRB, 0.17234458E-05_JPRB, 0.17218598E-05_JPRB, 0.17195965E-05_JPRB, 0.17166542E-05_JPRB, &
  & 0.17131410E-05_JPRB, 0.17090974E-05_JPRB, 0.17045198E-05_JPRB, 0.16993396E-05_JPRB, 0.16934021E-05_JPRB, 0.16865132E-05_JPRB, &
  & 0.16785012E-05_JPRB, 0.16693359E-05_JPRB, 0.16591393E-05_JPRB, 0.16482710E-05_JPRB, 0.16371478E-05_JPRB, 0.16261873E-05_JPRB, &
  & 0.16158626E-05_JPRB, 0.16062604E-05_JPRB, 0.15973831E-05_JPRB, 0.15890855E-05_JPRB, 0.15810906E-05_JPRB, 0.15731820E-05_JPRB, &
  & 0.15650612E-05_JPRB, 0.15564393E-05_JPRB, 0.15469905E-05_JPRB, 0.15363820E-05_JPRB, 0.15245274E-05_JPRB, 0.15117105E-05_JPRB, &
  & 0.14987269E-05_JPRB, 0.14855573E-05_JPRB, 0.14708464E-05_JPRB, 0.14432140E-05_JPRB /)

RGHG2(:,33, 2) = (/ &
  & 0.14143087E-05_JPRB, 0.14312178E-05_JPRB, 0.14410824E-05_JPRB, 0.14499284E-05_JPRB, 0.14591686E-05_JPRB, 0.14693524E-05_JPRB, &
  & 0.14804291E-05_JPRB, 0.14920635E-05_JPRB, 0.15040457E-05_JPRB, 0.15162771E-05_JPRB, 0.15290075E-05_JPRB, 0.15424832E-05_JPRB, &
  & 0.15568737E-05_JPRB, 0.15722238E-05_JPRB, 0.15883302E-05_JPRB, 0.16047518E-05_JPRB, 0.16209410E-05_JPRB, 0.16364162E-05_JPRB, &
  & 0.16508289E-05_JPRB, 0.16640084E-05_JPRB, 0.16759803E-05_JPRB, 0.16867727E-05_JPRB, 0.16964716E-05_JPRB, 0.17050219E-05_JPRB, &
  & 0.17124014E-05_JPRB, 0.17185998E-05_JPRB, 0.17235825E-05_JPRB, 0.17274209E-05_JPRB, 0.17301686E-05_JPRB, 0.17319505E-05_JPRB, &
  & 0.17327419E-05_JPRB, 0.17327391E-05_JPRB, 0.17319136E-05_JPRB, 0.17303760E-05_JPRB, 0.17282118E-05_JPRB, 0.17255210E-05_JPRB, &
  & 0.17224119E-05_JPRB, 0.17188967E-05_JPRB, 0.17149540E-05_JPRB, 0.17104767E-05_JPRB, 0.17052564E-05_JPRB, 0.16990705E-05_JPRB, &
  & 0.16917846E-05_JPRB, 0.16833442E-05_JPRB, 0.16739681E-05_JPRB, 0.16639688E-05_JPRB, 0.16537435E-05_JPRB, 0.16437614E-05_JPRB, &
  & 0.16342537E-05_JPRB, 0.16254268E-05_JPRB, 0.16172065E-05_JPRB, 0.16094516E-05_JPRB, 0.16019856E-05_JPRB, 0.15945545E-05_JPRB, &
  & 0.15869532E-05_JPRB, 0.15788925E-05_JPRB, 0.15700754E-05_JPRB, 0.15602251E-05_JPRB, 0.15493110E-05_JPRB, 0.15377536E-05_JPRB, &
  & 0.15262318E-05_JPRB, 0.15150297E-05_JPRB, 0.15022501E-05_JPRB, 0.14791295E-05_JPRB /)

RGHG2(:,34, 2) = (/ &
  & 0.14441191E-05_JPRB, 0.14598185E-05_JPRB, 0.14686499E-05_JPRB, 0.14766088E-05_JPRB, 0.14849157E-05_JPRB, 0.14940310E-05_JPRB, &
  & 0.15039786E-05_JPRB, 0.15144182E-05_JPRB, 0.15250932E-05_JPRB, 0.15359644E-05_JPRB, 0.15473037E-05_JPRB, 0.15594320E-05_JPRB, &
  & 0.15726364E-05_JPRB, 0.15869787E-05_JPRB, 0.16022955E-05_JPRB, 0.16181403E-05_JPRB, 0.16339562E-05_JPRB, 0.16491695E-05_JPRB, &
  & 0.16632969E-05_JPRB, 0.16761614E-05_JPRB, 0.16877134E-05_JPRB, 0.16979944E-05_JPRB, 0.17070176E-05_JPRB, 0.17148674E-05_JPRB, &
  & 0.17214699E-05_JPRB, 0.17269923E-05_JPRB, 0.17313794E-05_JPRB, 0.17347937E-05_JPRB, 0.17372654E-05_JPRB, 0.17388816E-05_JPRB, &
  & 0.17396449E-05_JPRB, 0.17396933E-05_JPRB, 0.17390054E-05_JPRB, 0.17376854E-05_JPRB, 0.17358020E-05_JPRB, 0.17334983E-05_JPRB, &
  & 0.17308440E-05_JPRB, 0.17278721E-05_JPRB, 0.17245411E-05_JPRB, 0.17206874E-05_JPRB, 0.17160648E-05_JPRB, 0.17104414E-05_JPRB, &
  & 0.17036473E-05_JPRB, 0.16957626E-05_JPRB, 0.16869723E-05_JPRB, 0.16776643E-05_JPRB, 0.16682430E-05_JPRB, 0.16590095E-05_JPRB, &
  & 0.16502880E-05_JPRB, 0.16421077E-05_JPRB, 0.16344578E-05_JPRB, 0.16272114E-05_JPRB, 0.16201669E-05_JPRB, 0.16131783E-05_JPRB, &
  & 0.16060260E-05_JPRB, 0.15984720E-05_JPRB, 0.15902550E-05_JPRB, 0.15811654E-05_JPRB, 0.15712138E-05_JPRB, 0.15608246E-05_JPRB, &
  & 0.15506881E-05_JPRB, 0.15407696E-05_JPRB, 0.15298947E-05_JPRB, 0.15097578E-05_JPRB /)

RGHG2(:,35, 2) = (/ &
  & 0.14721087E-05_JPRB, 0.14864477E-05_JPRB, 0.14945840E-05_JPRB, 0.15017629E-05_JPRB, 0.15092214E-05_JPRB, 0.15174550E-05_JPRB, &
  & 0.15263840E-05_JPRB, 0.15357302E-05_JPRB, 0.15452006E-05_JPRB, 0.15548238E-05_JPRB, 0.15648536E-05_JPRB, 0.15756625E-05_JPRB, &
  & 0.15876167E-05_JPRB, 0.16009524E-05_JPRB, 0.16155532E-05_JPRB, 0.16309323E-05_JPRB, 0.16464539E-05_JPRB, 0.16614316E-05_JPRB, &
  & 0.16753228E-05_JPRB, 0.16878680E-05_JPRB, 0.16989759E-05_JPRB, 0.17086422E-05_JPRB, 0.17169035E-05_JPRB, 0.17238622E-05_JPRB, &
  & 0.17295381E-05_JPRB, 0.17341943E-05_JPRB, 0.17378036E-05_JPRB, 0.17406671E-05_JPRB, 0.17427443E-05_JPRB, 0.17441419E-05_JPRB, &
  & 0.17448762E-05_JPRB, 0.17450072E-05_JPRB, 0.17445435E-05_JPRB, 0.17435286E-05_JPRB, 0.17420396E-05_JPRB, 0.17401810E-05_JPRB, &
  & 0.17380241E-05_JPRB, 0.17356087E-05_JPRB, 0.17328439E-05_JPRB, 0.17295599E-05_JPRB, 0.17255024E-05_JPRB, 0.17203864E-05_JPRB, &
  & 0.17140956E-05_JPRB, 0.17066104E-05_JPRB, 0.16983074E-05_JPRB, 0.16895533E-05_JPRB, 0.16807293E-05_JPRB, 0.16722080E-05_JPRB, &
  & 0.16640851E-05_JPRB, 0.16564925E-05_JPRB, 0.16493458E-05_JPRB, 0.16425090E-05_JPRB, 0.16358701E-05_JPRB, 0.16292563E-05_JPRB, &
  & 0.16224978E-05_JPRB, 0.16153992E-05_JPRB, 0.16077587E-05_JPRB, 0.15993846E-05_JPRB, 0.15903812E-05_JPRB, 0.15811015E-05_JPRB, &
  & 0.15720778E-05_JPRB, 0.15634131E-05_JPRB, 0.15536918E-05_JPRB, 0.15362440E-05_JPRB /)

RGHG2(:,36, 2) = (/ &
  & 0.14982205E-05_JPRB, 0.15115253E-05_JPRB, 0.15188671E-05_JPRB, 0.15254031E-05_JPRB, 0.15321949E-05_JPRB, 0.15396164E-05_JPRB, &
  & 0.15476594E-05_JPRB, 0.15560062E-05_JPRB, 0.15643784E-05_JPRB, 0.15728156E-05_JPRB, 0.15816153E-05_JPRB, 0.15911861E-05_JPRB, &
  & 0.16019693E-05_JPRB, 0.16142917E-05_JPRB, 0.16281283E-05_JPRB, 0.16430247E-05_JPRB, 0.16582553E-05_JPRB, 0.16730219E-05_JPRB, &
  & 0.16866896E-05_JPRB, 0.16989189E-05_JPRB, 0.17095165E-05_JPRB, 0.17184693E-05_JPRB, 0.17258021E-05_JPRB, 0.17316993E-05_JPRB, &
  & 0.17362854E-05_JPRB, 0.17399196E-05_JPRB, 0.17427086E-05_JPRB, 0.17449155E-05_JPRB, 0.17465762E-05_JPRB, 0.17477280E-05_JPRB, &
  & 0.17484017E-05_JPRB, 0.17485972E-05_JPRB, 0.17483225E-05_JPRB, 0.17475890E-05_JPRB, 0.17464581E-05_JPRB, 0.17450078E-05_JPRB, &
  & 0.17433086E-05_JPRB, 0.17413741E-05_JPRB, 0.17391217E-05_JPRB, 0.17363936E-05_JPRB, 0.17329201E-05_JPRB, 0.17284391E-05_JPRB, &
  & 0.17227006E-05_JPRB, 0.17158004E-05_JPRB, 0.17079540E-05_JPRB, 0.16997027E-05_JPRB, 0.16914576E-05_JPRB, 0.16834517E-05_JPRB, &
  & 0.16758936E-05_JPRB, 0.16687694E-05_JPRB, 0.16620271E-05_JPRB, 0.16555795E-05_JPRB, 0.16492731E-05_JPRB, 0.16429940E-05_JPRB, &
  & 0.16365937E-05_JPRB, 0.16299264E-05_JPRB, 0.16227996E-05_JPRB, 0.16151473E-05_JPRB, 0.16070076E-05_JPRB, 0.15987544E-05_JPRB, &
  & 0.15907807E-05_JPRB, 0.15830349E-05_JPRB, 0.15744874E-05_JPRB, 0.15589750E-05_JPRB /)

RGHG2(:,37, 2) = (/ &
  & 0.15228571E-05_JPRB, 0.15349442E-05_JPRB, 0.15417079E-05_JPRB, 0.15476596E-05_JPRB, 0.15538520E-05_JPRB, 0.15606325E-05_JPRB, &
  & 0.15678788E-05_JPRB, 0.15753126E-05_JPRB, 0.15826690E-05_JPRB, 0.15900094E-05_JPRB, 0.15976258E-05_JPRB, 0.16059480E-05_JPRB, &
  & 0.16155457E-05_JPRB, 0.16268258E-05_JPRB, 0.16399105E-05_JPRB, 0.16543236E-05_JPRB, 0.16692402E-05_JPRB, 0.16837857E-05_JPRB, &
  & 0.16972308E-05_JPRB, 0.17090450E-05_JPRB, 0.17189649E-05_JPRB, 0.17270071E-05_JPRB, 0.17331629E-05_JPRB, 0.17378618E-05_JPRB, &
  & 0.17413265E-05_JPRB, 0.17440021E-05_JPRB, 0.17460446E-05_JPRB, 0.17477138E-05_JPRB, 0.17490152E-05_JPRB, 0.17499749E-05_JPRB, &
  & 0.17505847E-05_JPRB, 0.17508102E-05_JPRB, 0.17506508E-05_JPRB, 0.17501047E-05_JPRB, 0.17492230E-05_JPRB, 0.17480689E-05_JPRB, &
  & 0.17467039E-05_JPRB, 0.17451359E-05_JPRB, 0.17432974E-05_JPRB, 0.17410456E-05_JPRB, 0.17381540E-05_JPRB, 0.17343286E-05_JPRB, &
  & 0.17293652E-05_JPRB, 0.17231264E-05_JPRB, 0.17159496E-05_JPRB, 0.17082392E-05_JPRB, 0.17004971E-05_JPRB, 0.16930074E-05_JPRB, &
  & 0.16858774E-05_JPRB, 0.16791447E-05_JPRB, 0.16727628E-05_JPRB, 0.16666231E-05_JPRB, 0.16606310E-05_JPRB, 0.16546672E-05_JPRB, &
  & 0.16486199E-05_JPRB, 0.16423679E-05_JPRB, 0.16357870E-05_JPRB, 0.16287863E-05_JPRB, 0.16214874E-05_JPRB, 0.16141403E-05_JPRB, &
  & 0.16070688E-05_JPRB, 0.16002102E-05_JPRB, 0.15926180E-05_JPRB, 0.15789218E-05_JPRB /)

RGHG2(:,38, 2) = (/ &
  & 0.15460081E-05_JPRB, 0.15570121E-05_JPRB, 0.15630782E-05_JPRB, 0.15685771E-05_JPRB, 0.15742861E-05_JPRB, 0.15805092E-05_JPRB, &
  & 0.15870739E-05_JPRB, 0.15936657E-05_JPRB, 0.16000893E-05_JPRB, 0.16063982E-05_JPRB, 0.16128924E-05_JPRB, 0.16200572E-05_JPRB, &
  & 0.16284179E-05_JPRB, 0.16386113E-05_JPRB, 0.16508052E-05_JPRB, 0.16646663E-05_JPRB, 0.16792403E-05_JPRB, 0.16934896E-05_JPRB, &
  & 0.17065640E-05_JPRB, 0.17177898E-05_JPRB, 0.17267798E-05_JPRB, 0.17335901E-05_JPRB, 0.17385564E-05_JPRB, 0.17421100E-05_JPRB, &
  & 0.17446854E-05_JPRB, 0.17466468E-05_JPRB, 0.17481879E-05_JPRB, 0.17494837E-05_JPRB, 0.17505547E-05_JPRB, 0.17513871E-05_JPRB, &
  & 0.17519476E-05_JPRB, 0.17521854E-05_JPRB, 0.17520871E-05_JPRB, 0.17516486E-05_JPRB, 0.17509186E-05_JPRB, 0.17499559E-05_JPRB, &
  & 0.17488188E-05_JPRB, 0.17475064E-05_JPRB, 0.17459677E-05_JPRB, 0.17440806E-05_JPRB, 0.17416495E-05_JPRB, 0.17384352E-05_JPRB, &
  & 0.17341712E-05_JPRB, 0.17287523E-05_JPRB, 0.17222840E-05_JPRB, 0.17152361E-05_JPRB, 0.17080336E-05_JPRB, 0.17009957E-05_JPRB, &
  & 0.16942577E-05_JPRB, 0.16878603E-05_JPRB, 0.16817553E-05_JPRB, 0.16758963E-05_JPRB, 0.16701866E-05_JPRB, 0.16645450E-05_JPRB, &
  & 0.16588838E-05_JPRB, 0.16530932E-05_JPRB, 0.16470721E-05_JPRB, 0.16407541E-05_JPRB, 0.16342140E-05_JPRB, 0.16276844E-05_JPRB, &
  & 0.16213938E-05_JPRB, 0.16153183E-05_JPRB, 0.16085288E-05_JPRB, 0.15964908E-05_JPRB /)

RGHG2(:,39, 2) = (/ &
  & 0.15677631E-05_JPRB, 0.15774903E-05_JPRB, 0.15830701E-05_JPRB, 0.15880819E-05_JPRB, 0.15934440E-05_JPRB, 0.15991935E-05_JPRB, &
  & 0.16051517E-05_JPRB, 0.16109805E-05_JPRB, 0.16165300E-05_JPRB, 0.16218903E-05_JPRB, 0.16273891E-05_JPRB, 0.16334101E-05_JPRB, &
  & 0.16406501E-05_JPRB, 0.16496681E-05_JPRB, 0.16609487E-05_JPRB, 0.16741250E-05_JPRB, 0.16882391E-05_JPRB, 0.17020600E-05_JPRB, &
  & 0.17144614E-05_JPRB, 0.17247584E-05_JPRB, 0.17325666E-05_JPRB, 0.17381825E-05_JPRB, 0.17420947E-05_JPRB, 0.17448330E-05_JPRB, &
  & 0.17468233E-05_JPRB, 0.17483463E-05_JPRB, 0.17495832E-05_JPRB, 0.17506613E-05_JPRB, 0.17515908E-05_JPRB, 0.17523466E-05_JPRB, &
  & 0.17528744E-05_JPRB, 0.17531131E-05_JPRB, 0.17530424E-05_JPRB, 0.17526643E-05_JPRB, 0.17520243E-05_JPRB, 0.17511876E-05_JPRB, &
  & 0.17502023E-05_JPRB, 0.17490722E-05_JPRB, 0.17477471E-05_JPRB, 0.17461253E-05_JPRB, 0.17440474E-05_JPRB, 0.17412975E-05_JPRB, &
  & 0.17376558E-05_JPRB, 0.17329517E-05_JPRB, 0.17272509E-05_JPRB, 0.17208649E-05_JPRB, 0.17142240E-05_JPRB, 0.17076391E-05_JPRB, &
  & 0.17012790E-05_JPRB, 0.16951510E-05_JPRB, 0.16892939E-05_JPRB, 0.16836631E-05_JPRB, 0.16782159E-05_JPRB, 0.16729080E-05_JPRB, &
  & 0.16676540E-05_JPRB, 0.16623910E-05_JPRB, 0.16569742E-05_JPRB, 0.16513496E-05_JPRB, 0.16455442E-05_JPRB, 0.16397441E-05_JPRB, &
  & 0.16341654E-05_JPRB, 0.16287169E-05_JPRB, 0.16227679E-05_JPRB, 0.16120861E-05_JPRB /)

RGHG2(:,40, 2) = (/ &
  & 0.15877689E-05_JPRB, 0.15964451E-05_JPRB, 0.16014103E-05_JPRB, 0.16061394E-05_JPRB, 0.16111454E-05_JPRB, 0.16165410E-05_JPRB, &
  & 0.16219417E-05_JPRB, 0.16270590E-05_JPRB, 0.16318243E-05_JPRB, 0.16363563E-05_JPRB, 0.16409330E-05_JPRB, 0.16460270E-05_JPRB, &
  & 0.16521273E-05_JPRB, 0.16600361E-05_JPRB, 0.16702492E-05_JPRB, 0.16826607E-05_JPRB, 0.16961849E-05_JPRB, 0.17093593E-05_JPRB, &
  & 0.17208916E-05_JPRB, 0.17299722E-05_JPRB, 0.17366251E-05_JPRB, 0.17412108E-05_JPRB, 0.17443849E-05_JPRB, 0.17465904E-05_JPRB, &
  & 0.17482287E-05_JPRB, 0.17494951E-05_JPRB, 0.17505618E-05_JPRB, 0.17515099E-05_JPRB, 0.17523587E-05_JPRB, 0.17530660E-05_JPRB, &
  & 0.17535680E-05_JPRB, 0.17538002E-05_JPRB, 0.17537386E-05_JPRB, 0.17533912E-05_JPRB, 0.17528068E-05_JPRB, 0.17520517E-05_JPRB, &
  & 0.17511755E-05_JPRB, 0.17501757E-05_JPRB, 0.17490097E-05_JPRB, 0.17475895E-05_JPRB, 0.17457769E-05_JPRB, 0.17433931E-05_JPRB, &
  & 0.17402349E-05_JPRB, 0.17361305E-05_JPRB, 0.17310953E-05_JPRB, 0.17253559E-05_JPRB, 0.17192978E-05_JPRB, 0.17131985E-05_JPRB, &
  & 0.17071768E-05_JPRB, 0.17013306E-05_JPRB, 0.16956614E-05_JPRB, 0.16902038E-05_JPRB, 0.16849922E-05_JPRB, 0.16799949E-05_JPRB, &
  & 0.16751945E-05_JPRB, 0.16704666E-05_JPRB, 0.16657028E-05_JPRB, 0.16607705E-05_JPRB, 0.16556944E-05_JPRB, 0.16505991E-05_JPRB, &
  & 0.16456495E-05_JPRB, 0.16408505E-05_JPRB, 0.16354869E-05_JPRB, 0.16261190E-05_JPRB /)

RGHG2(:,41, 2) = (/ &
  & 0.16059633E-05_JPRB, 0.16136129E-05_JPRB, 0.16181657E-05_JPRB, 0.16225433E-05_JPRB, 0.16273393E-05_JPRB, 0.16323779E-05_JPRB, &
  & 0.16372704E-05_JPRB, 0.16417628E-05_JPRB, 0.16458157E-05_JPRB, 0.16496340E-05_JPRB, 0.16534680E-05_JPRB, 0.16577038E-05_JPRB, &
  & 0.16629058E-05_JPRB, 0.16697295E-05_JPRB, 0.16788974E-05_JPRB, 0.16904296E-05_JPRB, 0.17031956E-05_JPRB, 0.17155718E-05_JPRB, &
  & 0.17259842E-05_JPRB, 0.17338872E-05_JPRB, 0.17394693E-05_JPRB, 0.17432819E-05_JPRB, 0.17459373E-05_JPRB, 0.17478008E-05_JPRB, &
  & 0.17492259E-05_JPRB, 0.17503420E-05_JPRB, 0.17513082E-05_JPRB, 0.17521870E-05_JPRB, 0.17529831E-05_JPRB, 0.17536607E-05_JPRB, &
  & 0.17541367E-05_JPRB, 0.17543543E-05_JPRB, 0.17542894E-05_JPRB, 0.17539550E-05_JPRB, 0.17534028E-05_JPRB, 0.17527052E-05_JPRB, &
  & 0.17519059E-05_JPRB, 0.17510065E-05_JPRB, 0.17499647E-05_JPRB, 0.17487025E-05_JPRB, 0.17471041E-05_JPRB, 0.17450116E-05_JPRB, &
  & 0.17422456E-05_JPRB, 0.17386478E-05_JPRB, 0.17341799E-05_JPRB, 0.17290495E-05_JPRB, 0.17235320E-05_JPRB, 0.17179002E-05_JPRB, &
  & 0.17122742E-05_JPRB, 0.17066723E-05_JPRB, 0.17011532E-05_JPRB, 0.16958452E-05_JPRB, 0.16907959E-05_JPRB, 0.16861172E-05_JPRB, &
  & 0.16817373E-05_JPRB, 0.16775673E-05_JPRB, 0.16734264E-05_JPRB, 0.16691940E-05_JPRB, 0.16648280E-05_JPRB, 0.16604217E-05_JPRB, &
  & 0.16561157E-05_JPRB, 0.16518497E-05_JPRB, 0.16471466E-05_JPRB, 0.16388195E-05_JPRB /)

RGHG2(:,42, 2) = (/ &
  & 0.16223353E-05_JPRB, 0.16291245E-05_JPRB, 0.16332679E-05_JPRB, 0.16373772E-05_JPRB, 0.16419307E-05_JPRB, 0.16466522E-05_JPRB, &
  & 0.16510799E-05_JPRB, 0.16549975E-05_JPRB, 0.16584706E-05_JPRB, 0.16616857E-05_JPRB, 0.16649071E-05_JPRB, 0.16684778E-05_JPRB, &
  & 0.16728652E-05_JPRB, 0.16787806E-05_JPRB, 0.16869296E-05_JPRB, 0.16975189E-05_JPRB, 0.17094578E-05_JPRB, 0.17207594E-05_JPRB, &
  & 0.17300795E-05_JPRB, 0.17368342E-05_JPRB, 0.17415537E-05_JPRB, 0.17447778E-05_JPRB, 0.17470608E-05_JPRB, 0.17487030E-05_JPRB, &
  & 0.17499895E-05_JPRB, 0.17510172E-05_JPRB, 0.17519316E-05_JPRB, 0.17527661E-05_JPRB, 0.17535384E-05_JPRB, 0.17541865E-05_JPRB, &
  & 0.17546388E-05_JPRB, 0.17548327E-05_JPRB, 0.17547541E-05_JPRB, 0.17544194E-05_JPRB, 0.17538855E-05_JPRB, 0.17532254E-05_JPRB, &
  & 0.17524850E-05_JPRB, 0.17516631E-05_JPRB, 0.17507224E-05_JPRB, 0.17495944E-05_JPRB, 0.17481747E-05_JPRB, 0.17463298E-05_JPRB, &
  & 0.17438983E-05_JPRB, 0.17407167E-05_JPRB, 0.17367485E-05_JPRB, 0.17321273E-05_JPRB, 0.17271543E-05_JPRB, 0.17220070E-05_JPRB, &
  & 0.17167658E-05_JPRB, 0.17114279E-05_JPRB, 0.17060851E-05_JPRB, 0.17008418E-05_JPRB, 0.16959849E-05_JPRB, 0.16915744E-05_JPRB, &
  & 0.16876229E-05_JPRB, 0.16839670E-05_JPRB, 0.16804228E-05_JPRB, 0.16768329E-05_JPRB, 0.16731449E-05_JPRB, 0.16694111E-05_JPRB, &
  & 0.16657102E-05_JPRB, 0.16620140E-05_JPRB, 0.16578291E-05_JPRB, 0.16504724E-05_JPRB /)

RGHG2(:,43, 2) = (/ &
  & 0.16370367E-05_JPRB, 0.16431047E-05_JPRB, 0.16468729E-05_JPRB, 0.16507084E-05_JPRB, 0.16549927E-05_JPRB, 0.16593885E-05_JPRB, &
  & 0.16633960E-05_JPRB, 0.16668375E-05_JPRB, 0.16698395E-05_JPRB, 0.16725728E-05_JPRB, 0.16753135E-05_JPRB, 0.16783376E-05_JPRB, &
  & 0.16820997E-05_JPRB, 0.16872087E-05_JPRB, 0.16944771E-05_JPRB, 0.17041197E-05_JPRB, 0.17150799E-05_JPRB, 0.17252991E-05_JPRB, &
  & 0.17333593E-05_JPRB, 0.17391426E-05_JPRB, 0.17431345E-05_JPRB, 0.17459131E-05_JPRB, 0.17479229E-05_JPRB, 0.17494162E-05_JPRB, &
  & 0.17506127E-05_JPRB, 0.17515940E-05_JPRB, 0.17524801E-05_JPRB, 0.17533018E-05_JPRB, 0.17540524E-05_JPRB, 0.17546832E-05_JPRB, &
  & 0.17551008E-05_JPRB, 0.17552645E-05_JPRB, 0.17551635E-05_JPRB, 0.17548197E-05_JPRB, 0.17542922E-05_JPRB, 0.17536578E-05_JPRB, &
  & 0.17529608E-05_JPRB, 0.17522017E-05_JPRB, 0.17513456E-05_JPRB, 0.17503310E-05_JPRB, 0.17490702E-05_JPRB, 0.17474446E-05_JPRB, &
  & 0.17453103E-05_JPRB, 0.17425101E-05_JPRB, 0.17389767E-05_JPRB, 0.17348453E-05_JPRB, 0.17303443E-05_JPRB, 0.17256712E-05_JPRB, &
  & 0.17208312E-05_JPRB, 0.17158108E-05_JPRB, 0.17106209E-05_JPRB, 0.17055528E-05_JPRB, 0.17008423E-05_JPRB, 0.16967458E-05_JPRB, &
  & 0.16931942E-05_JPRB, 0.16900090E-05_JPRB, 0.16869888E-05_JPRB, 0.16839707E-05_JPRB, 0.16808887E-05_JPRB, 0.16777681E-05_JPRB, &
  & 0.16746486E-05_JPRB, 0.16714582E-05_JPRB, 0.16678069E-05_JPRB, 0.16612865E-05_JPRB /)

RGHG2(:,44, 2) = (/ &
  & 0.16502695E-05_JPRB, 0.16557799E-05_JPRB, 0.16591589E-05_JPRB, 0.16627084E-05_JPRB, 0.16666928E-05_JPRB, 0.16707738E-05_JPRB, &
  & 0.16744070E-05_JPRB, 0.16775082E-05_JPRB, 0.16801232E-05_JPRB, 0.16825084E-05_JPRB, 0.16848496E-05_JPRB, 0.16874487E-05_JPRB, &
  & 0.16906797E-05_JPRB, 0.16951365E-05_JPRB, 0.17015730E-05_JPRB, 0.17103389E-05_JPRB, 0.17202206E-05_JPRB, 0.17291993E-05_JPRB, &
  & 0.17361042E-05_JPRB, 0.17409685E-05_JPRB, 0.17443776E-05_JPRB, 0.17468017E-05_JPRB, 0.17486143E-05_JPRB, 0.17500004E-05_JPRB, &
  & 0.17511429E-05_JPRB, 0.17521068E-05_JPRB, 0.17529870E-05_JPRB, 0.17538066E-05_JPRB, 0.17545557E-05_JPRB, 0.17551574E-05_JPRB, &
  & 0.17555413E-05_JPRB, 0.17556654E-05_JPRB, 0.17555336E-05_JPRB, 0.17551716E-05_JPRB, 0.17546424E-05_JPRB, 0.17540231E-05_JPRB, &
  & 0.17533598E-05_JPRB, 0.17526518E-05_JPRB, 0.17518669E-05_JPRB, 0.17509528E-05_JPRB, 0.17498334E-05_JPRB, 0.17484097E-05_JPRB, &
  & 0.17465519E-05_JPRB, 0.17441067E-05_JPRB, 0.17409848E-05_JPRB, 0.17372848E-05_JPRB, 0.17332507E-05_JPRB, 0.17290237E-05_JPRB, &
  & 0.17246075E-05_JPRB, 0.17199148E-05_JPRB, 0.17150171E-05_JPRB, 0.17101244E-05_JPRB, 0.17057000E-05_JPRB, 0.17019198E-05_JPRB, &
  & 0.16987547E-05_JPRB, 0.16959914E-05_JPRB, 0.16934096E-05_JPRB, 0.16908730E-05_JPRB, 0.16883057E-05_JPRB, 0.16857189E-05_JPRB, &
  & 0.16831125E-05_JPRB, 0.16804086E-05_JPRB, 0.16772244E-05_JPRB, 0.16714833E-05_JPRB /)

RGHG2(:,45, 2) = (/ &
  & 0.16623892E-05_JPRB, 0.16672225E-05_JPRB, 0.16704060E-05_JPRB, 0.16735808E-05_JPRB, 0.16773014E-05_JPRB, 0.16810666E-05_JPRB, &
  & 0.16844704E-05_JPRB, 0.16872652E-05_JPRB, 0.16896538E-05_JPRB, 0.16917380E-05_JPRB, 0.16937877E-05_JPRB, 0.16960264E-05_JPRB, &
  & 0.16987912E-05_JPRB, 0.17026840E-05_JPRB, 0.17083462E-05_JPRB, 0.17161583E-05_JPRB, 0.17249190E-05_JPRB, 0.17325885E-05_JPRB, &
  & 0.17383542E-05_JPRB, 0.17424451E-05_JPRB, 0.17453578E-05_JPRB, 0.17475179E-05_JPRB, 0.17491670E-05_JPRB, 0.17504954E-05_JPRB, &
  & 0.17516070E-05_JPRB, 0.17525706E-05_JPRB, 0.17534692E-05_JPRB, 0.17542995E-05_JPRB, 0.17550429E-05_JPRB, 0.17556245E-05_JPRB, &
  & 0.17559619E-05_JPRB, 0.17560409E-05_JPRB, 0.17558708E-05_JPRB, 0.17554844E-05_JPRB, 0.17549447E-05_JPRB, 0.17543337E-05_JPRB, &
  & 0.17536956E-05_JPRB, 0.17530285E-05_JPRB, 0.17523056E-05_JPRB, 0.17514789E-05_JPRB, 0.17504881E-05_JPRB, 0.17492530E-05_JPRB, &
  & 0.17476649E-05_JPRB, 0.17455721E-05_JPRB, 0.17428672E-05_JPRB, 0.17396052E-05_JPRB, 0.17360057E-05_JPRB, 0.17322230E-05_JPRB, &
  & 0.17282185E-05_JPRB, 0.17239198E-05_JPRB, 0.17193274E-05_JPRB, 0.17148016E-05_JPRB, 0.17106826E-05_JPRB, 0.17073036E-05_JPRB, &
  & 0.17045032E-05_JPRB, 0.17021057E-05_JPRB, 0.16999005E-05_JPRB, 0.16977471E-05_JPRB, 0.16956026E-05_JPRB, 0.16934565E-05_JPRB, &
  & 0.16912893E-05_JPRB, 0.16890049E-05_JPRB, 0.16862732E-05_JPRB, 0.16812460E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART3',1,ZHOOK_HANDLE)
END SUBROUTINE PART3




SUBROUTINE PART4
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART4',0,ZHOOK_HANDLE)



RGHG2(:,46, 2) = (/ &
  & 0.16733576E-05_JPRB, 0.16779259E-05_JPRB, 0.16806564E-05_JPRB, 0.16836786E-05_JPRB, 0.16870498E-05_JPRB, 0.16906207E-05_JPRB, &
  & 0.16938004E-05_JPRB, 0.16964711E-05_JPRB, 0.16986367E-05_JPRB, 0.17005257E-05_JPRB, 0.17023208E-05_JPRB, 0.17042340E-05_JPRB, &
  & 0.17066391E-05_JPRB, 0.17098894E-05_JPRB, 0.17148902E-05_JPRB, 0.17216437E-05_JPRB, 0.17291222E-05_JPRB, 0.17355060E-05_JPRB, &
  & 0.17402270E-05_JPRB, 0.17436289E-05_JPRB, 0.17461476E-05_JPRB, 0.17480786E-05_JPRB, 0.17496327E-05_JPRB, 0.17509096E-05_JPRB, &
  & 0.17520183E-05_JPRB, 0.17530118E-05_JPRB, 0.17539260E-05_JPRB, 0.17547849E-05_JPRB, 0.17555302E-05_JPRB, 0.17560743E-05_JPRB, &
  & 0.17563652E-05_JPRB, 0.17563917E-05_JPRB, 0.17561778E-05_JPRB, 0.17557591E-05_JPRB, 0.17552049E-05_JPRB, 0.17545960E-05_JPRB, &
  & 0.17539759E-05_JPRB, 0.17533441E-05_JPRB, 0.17526714E-05_JPRB, 0.17519236E-05_JPRB, 0.17510501E-05_JPRB, 0.17499956E-05_JPRB, &
  & 0.17486722E-05_JPRB, 0.17469474E-05_JPRB, 0.17446846E-05_JPRB, 0.17418946E-05_JPRB, 0.17387609E-05_JPRB, 0.17354203E-05_JPRB, &
  & 0.17318621E-05_JPRB, 0.17279554E-05_JPRB, 0.17238010E-05_JPRB, 0.17196126E-05_JPRB, 0.17159867E-05_JPRB, 0.17129503E-05_JPRB, &
  & 0.17105435E-05_JPRB, 0.17084656E-05_JPRB, 0.17065659E-05_JPRB, 0.17047350E-05_JPRB, 0.17029229E-05_JPRB, 0.17011300E-05_JPRB, &
  & 0.16993238E-05_JPRB, 0.16974058E-05_JPRB, 0.16950655E-05_JPRB, 0.16907162E-05_JPRB /)

RGHG2(:,47, 2) = (/ &
  & 0.16836568E-05_JPRB, 0.16876986E-05_JPRB, 0.16903629E-05_JPRB, 0.16930358E-05_JPRB, 0.16962507E-05_JPRB, 0.16996225E-05_JPRB, &
  & 0.17027099E-05_JPRB, 0.17052538E-05_JPRB, 0.17072873E-05_JPRB, 0.17090008E-05_JPRB, 0.17105590E-05_JPRB, 0.17122320E-05_JPRB, &
  & 0.17141920E-05_JPRB, 0.17170523E-05_JPRB, 0.17210575E-05_JPRB, 0.17268266E-05_JPRB, 0.17328794E-05_JPRB, 0.17379821E-05_JPRB, &
  & 0.17417706E-05_JPRB, 0.17445899E-05_JPRB, 0.17467680E-05_JPRB, 0.17485371E-05_JPRB, 0.17500007E-05_JPRB, 0.17512739E-05_JPRB, &
  & 0.17523985E-05_JPRB, 0.17534198E-05_JPRB, 0.17543908E-05_JPRB, 0.17552646E-05_JPRB, 0.17560060E-05_JPRB, 0.17565166E-05_JPRB, &
  & 0.17567479E-05_JPRB, 0.17567171E-05_JPRB, 0.17564528E-05_JPRB, 0.17559985E-05_JPRB, 0.17554240E-05_JPRB, 0.17548135E-05_JPRB, &
  & 0.17542083E-05_JPRB, 0.17536030E-05_JPRB, 0.17529766E-05_JPRB, 0.17522962E-05_JPRB, 0.17515333E-05_JPRB, 0.17506513E-05_JPRB, &
  & 0.17495967E-05_JPRB, 0.17482578E-05_JPRB, 0.17464978E-05_JPRB, 0.17442620E-05_JPRB, 0.17416567E-05_JPRB, 0.17388293E-05_JPRB, &
  & 0.17357256E-05_JPRB, 0.17322960E-05_JPRB, 0.17285172E-05_JPRB, 0.17248535E-05_JPRB, 0.17215557E-05_JPRB, 0.17189991E-05_JPRB, &
  & 0.17168863E-05_JPRB, 0.17151146E-05_JPRB, 0.17134805E-05_JPRB, 0.17119006E-05_JPRB, 0.17103587E-05_JPRB, 0.17088444E-05_JPRB, &
  & 0.17073262E-05_JPRB, 0.17057030E-05_JPRB, 0.17037122E-05_JPRB, 0.16999616E-05_JPRB /)

RGHG2(:,48, 2) = (/ &
  & 0.16932073E-05_JPRB, 0.16970304E-05_JPRB, 0.16994095E-05_JPRB, 0.17019903E-05_JPRB, 0.17050088E-05_JPRB, 0.17082828E-05_JPRB, &
  & 0.17113207E-05_JPRB, 0.17137750E-05_JPRB, 0.17157017E-05_JPRB, 0.17172226E-05_JPRB, 0.17186069E-05_JPRB, 0.17199820E-05_JPRB, &
  & 0.17216737E-05_JPRB, 0.17238583E-05_JPRB, 0.17272148E-05_JPRB, 0.17315105E-05_JPRB, 0.17362199E-05_JPRB, 0.17400891E-05_JPRB, &
  & 0.17430496E-05_JPRB, 0.17453625E-05_JPRB, 0.17472643E-05_JPRB, 0.17488865E-05_JPRB, 0.17503171E-05_JPRB, 0.17515868E-05_JPRB, &
  & 0.17527511E-05_JPRB, 0.17538375E-05_JPRB, 0.17548402E-05_JPRB, 0.17557530E-05_JPRB, 0.17564793E-05_JPRB, 0.17569381E-05_JPRB, &
  & 0.17571095E-05_JPRB, 0.17570164E-05_JPRB, 0.17566992E-05_JPRB, 0.17562031E-05_JPRB, 0.17556079E-05_JPRB, 0.17549933E-05_JPRB, &
  & 0.17543969E-05_JPRB, 0.17538157E-05_JPRB, 0.17532259E-05_JPRB, 0.17526095E-05_JPRB, 0.17519480E-05_JPRB, 0.17512364E-05_JPRB, &
  & 0.17504520E-05_JPRB, 0.17495242E-05_JPRB, 0.17483267E-05_JPRB, 0.17467576E-05_JPRB, 0.17448343E-05_JPRB, 0.17425956E-05_JPRB, &
  & 0.17400588E-05_JPRB, 0.17370945E-05_JPRB, 0.17338223E-05_JPRB, 0.17305090E-05_JPRB, 0.17277182E-05_JPRB, 0.17254546E-05_JPRB, &
  & 0.17236813E-05_JPRB, 0.17221438E-05_JPRB, 0.17207274E-05_JPRB, 0.17193568E-05_JPRB, 0.17180154E-05_JPRB, 0.17167127E-05_JPRB, &
  & 0.17154130E-05_JPRB, 0.17140200E-05_JPRB, 0.17123032E-05_JPRB, 0.17090475E-05_JPRB /)

RGHG2(:,49, 2) = (/ &
  & 0.17022257E-05_JPRB, 0.17058003E-05_JPRB, 0.17080905E-05_JPRB, 0.17105411E-05_JPRB, 0.17134901E-05_JPRB, 0.17167509E-05_JPRB, &
  & 0.17197633E-05_JPRB, 0.17221660E-05_JPRB, 0.17239258E-05_JPRB, 0.17252951E-05_JPRB, 0.17264445E-05_JPRB, 0.17275891E-05_JPRB, &
  & 0.17288680E-05_JPRB, 0.17305514E-05_JPRB, 0.17328249E-05_JPRB, 0.17358697E-05_JPRB, 0.17390845E-05_JPRB, 0.17418784E-05_JPRB, &
  & 0.17441180E-05_JPRB, 0.17459924E-05_JPRB, 0.17476516E-05_JPRB, 0.17491686E-05_JPRB, 0.17505679E-05_JPRB, 0.17518771E-05_JPRB, &
  & 0.17530990E-05_JPRB, 0.17542457E-05_JPRB, 0.17553152E-05_JPRB, 0.17562380E-05_JPRB, 0.17569389E-05_JPRB, 0.17573428E-05_JPRB, &
  & 0.17574471E-05_JPRB, 0.17572901E-05_JPRB, 0.17569159E-05_JPRB, 0.17563793E-05_JPRB, 0.17557608E-05_JPRB, 0.17551404E-05_JPRB, &
  & 0.17545512E-05_JPRB, 0.17539878E-05_JPRB, 0.17534321E-05_JPRB, 0.17528715E-05_JPRB, 0.17523098E-05_JPRB, 0.17517657E-05_JPRB, &
  & 0.17512568E-05_JPRB, 0.17507551E-05_JPRB, 0.17501707E-05_JPRB, 0.17493733E-05_JPRB, 0.17482723E-05_JPRB, 0.17468201E-05_JPRB, &
  & 0.17449265E-05_JPRB, 0.17425546E-05_JPRB, 0.17397724E-05_JPRB, 0.17369516E-05_JPRB, 0.17345327E-05_JPRB, 0.17326183E-05_JPRB, &
  & 0.17310931E-05_JPRB, 0.17297621E-05_JPRB, 0.17285115E-05_JPRB, 0.17272871E-05_JPRB, 0.17260874E-05_JPRB, 0.17249238E-05_JPRB, &
  & 0.17237680E-05_JPRB, 0.17225284E-05_JPRB, 0.17209973E-05_JPRB, 0.17180942E-05_JPRB /)

RGHG2(:,50, 2) = (/ &
  & 0.17107402E-05_JPRB, 0.17141642E-05_JPRB, 0.17163461E-05_JPRB, 0.17187817E-05_JPRB, 0.17217519E-05_JPRB, 0.17250961E-05_JPRB, &
  & 0.17281060E-05_JPRB, 0.17303865E-05_JPRB, 0.17319419E-05_JPRB, 0.17330476E-05_JPRB, 0.17339244E-05_JPRB, 0.17347277E-05_JPRB, &
  & 0.17355508E-05_JPRB, 0.17365746E-05_JPRB, 0.17378366E-05_JPRB, 0.17396055E-05_JPRB, 0.17415550E-05_JPRB, 0.17433973E-05_JPRB, &
  & 0.17450208E-05_JPRB, 0.17465198E-05_JPRB, 0.17479658E-05_JPRB, 0.17493895E-05_JPRB, 0.17507919E-05_JPRB, 0.17521459E-05_JPRB, &
  & 0.17534510E-05_JPRB, 0.17546743E-05_JPRB, 0.17557923E-05_JPRB, 0.17567202E-05_JPRB, 0.17573852E-05_JPRB, 0.17577237E-05_JPRB, &
  & 0.17577612E-05_JPRB, 0.17575394E-05_JPRB, 0.17571082E-05_JPRB, 0.17565291E-05_JPRB, 0.17558884E-05_JPRB, 0.17552607E-05_JPRB, &
  & 0.17546758E-05_JPRB, 0.17541282E-05_JPRB, 0.17536008E-05_JPRB, 0.17530942E-05_JPRB, 0.17526278E-05_JPRB, 0.17522517E-05_JPRB, &
  & 0.17520210E-05_JPRB, 0.17519525E-05_JPRB, 0.17519806E-05_JPRB, 0.17519706E-05_JPRB, 0.17517523E-05_JPRB, 0.17511743E-05_JPRB, &
  & 0.17501038E-05_JPRB, 0.17484791E-05_JPRB, 0.17463695E-05_JPRB, 0.17441773E-05_JPRB, 0.17421855E-05_JPRB, 0.17406566E-05_JPRB, &
  & 0.17393430E-05_JPRB, 0.17381981E-05_JPRB, 0.17370785E-05_JPRB, 0.17359457E-05_JPRB, 0.17348252E-05_JPRB, 0.17337325E-05_JPRB, &
  & 0.17326432E-05_JPRB, 0.17314750E-05_JPRB, 0.17300314E-05_JPRB, 0.17272957E-05_JPRB /)

RGHG2(:,51, 2) = (/ &
  & 0.17188150E-05_JPRB, 0.17219845E-05_JPRB, 0.17242279E-05_JPRB, 0.17266092E-05_JPRB, 0.17297335E-05_JPRB, 0.17330949E-05_JPRB, &
  & 0.17360439E-05_JPRB, 0.17379512E-05_JPRB, 0.17391158E-05_JPRB, 0.17398370E-05_JPRB, 0.17403388E-05_JPRB, 0.17407257E-05_JPRB, &
  & 0.17410956E-05_JPRB, 0.17414549E-05_JPRB, 0.17419775E-05_JPRB, 0.17426460E-05_JPRB, 0.17436396E-05_JPRB, 0.17447002E-05_JPRB, &
  & 0.17458123E-05_JPRB, 0.17469785E-05_JPRB, 0.17482351E-05_JPRB, 0.17495836E-05_JPRB, 0.17509901E-05_JPRB, 0.17524205E-05_JPRB, &
  & 0.17538060E-05_JPRB, 0.17551174E-05_JPRB, 0.17562668E-05_JPRB, 0.17571933E-05_JPRB, 0.17578039E-05_JPRB, 0.17580833E-05_JPRB, &
  & 0.17580543E-05_JPRB, 0.17577663E-05_JPRB, 0.17572784E-05_JPRB, 0.17566575E-05_JPRB, 0.17559942E-05_JPRB, 0.17553589E-05_JPRB, &
  & 0.17547776E-05_JPRB, 0.17542422E-05_JPRB, 0.17537418E-05_JPRB, 0.17532861E-05_JPRB, 0.17529155E-05_JPRB, 0.17527093E-05_JPRB, &
  & 0.17527592E-05_JPRB, 0.17531106E-05_JPRB, 0.17536961E-05_JPRB, 0.17543545E-05_JPRB, 0.17548651E-05_JPRB, 0.17550576E-05_JPRB, &
  & 0.17548107E-05_JPRB, 0.17540619E-05_JPRB, 0.17528953E-05_JPRB, 0.17514856E-05_JPRB, 0.17502221E-05_JPRB, 0.17490631E-05_JPRB, &
  & 0.17481163E-05_JPRB, 0.17471751E-05_JPRB, 0.17462133E-05_JPRB, 0.17452037E-05_JPRB, 0.17441508E-05_JPRB, 0.17431062E-05_JPRB, &
  & 0.17420521E-05_JPRB, 0.17409091E-05_JPRB, 0.17394792E-05_JPRB, 0.17367977E-05_JPRB /)

RGHG2(:,52, 2) = (/ &
  & 0.17260998E-05_JPRB, 0.17293853E-05_JPRB, 0.17313671E-05_JPRB, 0.17339449E-05_JPRB, 0.17369224E-05_JPRB, 0.17402009E-05_JPRB, &
  & 0.17424856E-05_JPRB, 0.17437999E-05_JPRB, 0.17444438E-05_JPRB, 0.17447801E-05_JPRB, 0.17449545E-05_JPRB, 0.17450478E-05_JPRB, &
  & 0.17450814E-05_JPRB, 0.17450795E-05_JPRB, 0.17450657E-05_JPRB, 0.17451267E-05_JPRB, 0.17453644E-05_JPRB, 0.17458406E-05_JPRB, &
  & 0.17465175E-05_JPRB, 0.17474072E-05_JPRB, 0.17484931E-05_JPRB, 0.17497733E-05_JPRB, 0.17512007E-05_JPRB, 0.17526943E-05_JPRB, &
  & 0.17541820E-05_JPRB, 0.17555499E-05_JPRB, 0.17567402E-05_JPRB, 0.17576350E-05_JPRB, 0.17582037E-05_JPRB, 0.17584205E-05_JPRB, &
  & 0.17583301E-05_JPRB, 0.17579753E-05_JPRB, 0.17574307E-05_JPRB, 0.17567684E-05_JPRB, 0.17560833E-05_JPRB, 0.17554407E-05_JPRB, &
  & 0.17548612E-05_JPRB, 0.17543384E-05_JPRB, 0.17538630E-05_JPRB, 0.17534580E-05_JPRB, 0.17531838E-05_JPRB, 0.17531506E-05_JPRB, &
  & 0.17534792E-05_JPRB, 0.17542114E-05_JPRB, 0.17552679E-05_JPRB, 0.17563782E-05_JPRB, 0.17573666E-05_JPRB, 0.17580480E-05_JPRB, &
  & 0.17583720E-05_JPRB, 0.17583275E-05_JPRB, 0.17579509E-05_JPRB, 0.17573836E-05_JPRB, 0.17567332E-05_JPRB, 0.17561605E-05_JPRB, &
  & 0.17555647E-05_JPRB, 0.17549745E-05_JPRB, 0.17543089E-05_JPRB, 0.17535353E-05_JPRB, 0.17527075E-05_JPRB, 0.17518396E-05_JPRB, &
  & 0.17509321E-05_JPRB, 0.17499215E-05_JPRB, 0.17486202E-05_JPRB, 0.17460709E-05_JPRB /)

RGHG2(:,53, 2) = (/ &
  & 0.17328770E-05_JPRB, 0.17356678E-05_JPRB, 0.17379347E-05_JPRB, 0.17401006E-05_JPRB, 0.17429711E-05_JPRB, 0.17453824E-05_JPRB, &
  & 0.17469043E-05_JPRB, 0.17475643E-05_JPRB, 0.17478428E-05_JPRB, 0.17479408E-05_JPRB, 0.17479508E-05_JPRB, 0.17479044E-05_JPRB, &
  & 0.17477960E-05_JPRB, 0.17476461E-05_JPRB, 0.17473651E-05_JPRB, 0.17470945E-05_JPRB, 0.17468456E-05_JPRB, 0.17468499E-05_JPRB, &
  & 0.17471725E-05_JPRB, 0.17478153E-05_JPRB, 0.17487660E-05_JPRB, 0.17499888E-05_JPRB, 0.17514300E-05_JPRB, 0.17529967E-05_JPRB, &
  & 0.17545480E-05_JPRB, 0.17559864E-05_JPRB, 0.17571799E-05_JPRB, 0.17580635E-05_JPRB, 0.17585801E-05_JPRB, 0.17587420E-05_JPRB, &
  & 0.17585924E-05_JPRB, 0.17581726E-05_JPRB, 0.17575691E-05_JPRB, 0.17568666E-05_JPRB, 0.17561604E-05_JPRB, 0.17555094E-05_JPRB, &
  & 0.17549331E-05_JPRB, 0.17544216E-05_JPRB, 0.17539742E-05_JPRB, 0.17536211E-05_JPRB, 0.17534467E-05_JPRB, 0.17535882E-05_JPRB, &
  & 0.17541767E-05_JPRB, 0.17552597E-05_JPRB, 0.17566252E-05_JPRB, 0.17580645E-05_JPRB, 0.17592710E-05_JPRB, 0.17602019E-05_JPRB, &
  & 0.17608124E-05_JPRB, 0.17611278E-05_JPRB, 0.17611874E-05_JPRB, 0.17610628E-05_JPRB, 0.17608552E-05_JPRB, 0.17605985E-05_JPRB, &
  & 0.17603402E-05_JPRB, 0.17600344E-05_JPRB, 0.17596644E-05_JPRB, 0.17592243E-05_JPRB, 0.17587042E-05_JPRB, 0.17581471E-05_JPRB, &
  & 0.17575456E-05_JPRB, 0.17568480E-05_JPRB, 0.17559144E-05_JPRB, 0.17539483E-05_JPRB /)

RGHG2(:,54, 2) = (/ &
  & 0.17384193E-05_JPRB, 0.17414601E-05_JPRB, 0.17431287E-05_JPRB, 0.17452639E-05_JPRB, 0.17472669E-05_JPRB, 0.17489036E-05_JPRB, &
  & 0.17496562E-05_JPRB, 0.17499453E-05_JPRB, 0.17500197E-05_JPRB, 0.17500099E-05_JPRB, 0.17499541E-05_JPRB, 0.17498562E-05_JPRB, &
  & 0.17497219E-05_JPRB, 0.17494835E-05_JPRB, 0.17491985E-05_JPRB, 0.17486543E-05_JPRB, 0.17481543E-05_JPRB, 0.17477721E-05_JPRB, &
  & 0.17477855E-05_JPRB, 0.17482255E-05_JPRB, 0.17490578E-05_JPRB, 0.17502423E-05_JPRB, 0.17517000E-05_JPRB, 0.17533077E-05_JPRB, &
  & 0.17549281E-05_JPRB, 0.17563998E-05_JPRB, 0.17576143E-05_JPRB, 0.17584699E-05_JPRB, 0.17589496E-05_JPRB, 0.17590552E-05_JPRB, &
  & 0.17588436E-05_JPRB, 0.17583634E-05_JPRB, 0.17577011E-05_JPRB, 0.17569596E-05_JPRB, 0.17562304E-05_JPRB, 0.17555730E-05_JPRB, &
  & 0.17549992E-05_JPRB, 0.17545021E-05_JPRB, 0.17540841E-05_JPRB, 0.17537885E-05_JPRB, 0.17537172E-05_JPRB, 0.17540251E-05_JPRB, &
  & 0.17548634E-05_JPRB, 0.17561931E-05_JPRB, 0.17578468E-05_JPRB, 0.17594043E-05_JPRB, 0.17607639E-05_JPRB, 0.17617803E-05_JPRB, &
  & 0.17625009E-05_JPRB, 0.17629609E-05_JPRB, 0.17632007E-05_JPRB, 0.17632732E-05_JPRB, 0.17632478E-05_JPRB, 0.17631766E-05_JPRB, &
  & 0.17630709E-05_JPRB, 0.17629382E-05_JPRB, 0.17627633E-05_JPRB, 0.17625293E-05_JPRB, 0.17622564E-05_JPRB, 0.17619510E-05_JPRB, &
  & 0.17616203E-05_JPRB, 0.17612522E-05_JPRB, 0.17607838E-05_JPRB, 0.17598940E-05_JPRB /)

RGHG2(:,55, 2) = (/ &
  & 0.17434054E-05_JPRB, 0.17458026E-05_JPRB, 0.17475573E-05_JPRB, 0.17489454E-05_JPRB, 0.17503248E-05_JPRB, 0.17511725E-05_JPRB, &
  & 0.17515108E-05_JPRB, 0.17515798E-05_JPRB, 0.17515599E-05_JPRB, 0.17515049E-05_JPRB, 0.17514247E-05_JPRB, 0.17513228E-05_JPRB, &
  & 0.17511670E-05_JPRB, 0.17509695E-05_JPRB, 0.17505731E-05_JPRB, 0.17500977E-05_JPRB, 0.17492847E-05_JPRB, 0.17486346E-05_JPRB, &
  & 0.17483762E-05_JPRB, 0.17486384E-05_JPRB, 0.17493837E-05_JPRB, 0.17505329E-05_JPRB, 0.17520036E-05_JPRB, 0.17536458E-05_JPRB, &
  & 0.17553066E-05_JPRB, 0.17568184E-05_JPRB, 0.17580360E-05_JPRB, 0.17588795E-05_JPRB, 0.17593155E-05_JPRB, 0.17593683E-05_JPRB, &
  & 0.17590945E-05_JPRB, 0.17585539E-05_JPRB, 0.17578376E-05_JPRB, 0.17570534E-05_JPRB, 0.17563035E-05_JPRB, 0.17556384E-05_JPRB, &
  & 0.17550688E-05_JPRB, 0.17545882E-05_JPRB, 0.17542050E-05_JPRB, 0.17539708E-05_JPRB, 0.17540038E-05_JPRB, 0.17544739E-05_JPRB, &
  & 0.17554992E-05_JPRB, 0.17570794E-05_JPRB, 0.17588443E-05_JPRB, 0.17605730E-05_JPRB, 0.17619507E-05_JPRB, 0.17630086E-05_JPRB, &
  & 0.17637635E-05_JPRB, 0.17642627E-05_JPRB, 0.17645635E-05_JPRB, 0.17647180E-05_JPRB, 0.17647734E-05_JPRB, 0.17647787E-05_JPRB, &
  & 0.17647546E-05_JPRB, 0.17647058E-05_JPRB, 0.17646271E-05_JPRB, 0.17645173E-05_JPRB, 0.17643722E-05_JPRB, 0.17642067E-05_JPRB, &
  & 0.17640224E-05_JPRB, 0.17638035E-05_JPRB, 0.17635099E-05_JPRB, 0.17628497E-05_JPRB /)

RGHG2(:,56, 2) = (/ &
  & 0.17472278E-05_JPRB, 0.17495663E-05_JPRB, 0.17506810E-05_JPRB, 0.17516741E-05_JPRB, 0.17524226E-05_JPRB, 0.17528048E-05_JPRB, &
  & 0.17528810E-05_JPRB, 0.17528453E-05_JPRB, 0.17527836E-05_JPRB, 0.17527088E-05_JPRB, 0.17526263E-05_JPRB, 0.17525190E-05_JPRB, &
  & 0.17523867E-05_JPRB, 0.17521575E-05_JPRB, 0.17518614E-05_JPRB, 0.17512062E-05_JPRB, 0.17504121E-05_JPRB, 0.17494488E-05_JPRB, &
  & 0.17489589E-05_JPRB, 0.17490734E-05_JPRB, 0.17497410E-05_JPRB, 0.17508704E-05_JPRB, 0.17523384E-05_JPRB, 0.17540119E-05_JPRB, &
  & 0.17557040E-05_JPRB, 0.17572415E-05_JPRB, 0.17584700E-05_JPRB, 0.17592912E-05_JPRB, 0.17596908E-05_JPRB, 0.17596899E-05_JPRB, &
  & 0.17593550E-05_JPRB, 0.17587530E-05_JPRB, 0.17579839E-05_JPRB, 0.17571615E-05_JPRB, 0.17563883E-05_JPRB, 0.17557147E-05_JPRB, &
  & 0.17551515E-05_JPRB, 0.17546899E-05_JPRB, 0.17543450E-05_JPRB, 0.17541776E-05_JPRB, 0.17543143E-05_JPRB, 0.17549190E-05_JPRB, &
  & 0.17561284E-05_JPRB, 0.17578277E-05_JPRB, 0.17597852E-05_JPRB, 0.17615275E-05_JPRB, 0.17629795E-05_JPRB, 0.17640343E-05_JPRB, &
  & 0.17647778E-05_JPRB, 0.17652790E-05_JPRB, 0.17655952E-05_JPRB, 0.17657708E-05_JPRB, 0.17658635E-05_JPRB, 0.17659027E-05_JPRB, &
  & 0.17659149E-05_JPRB, 0.17659070E-05_JPRB, 0.17658790E-05_JPRB, 0.17658269E-05_JPRB, 0.17657545E-05_JPRB, 0.17656657E-05_JPRB, &
  & 0.17655649E-05_JPRB, 0.17654540E-05_JPRB, 0.17653194E-05_JPRB, 0.17650949E-05_JPRB /)

RGHG2(:,57, 2) = (/ &
  & 0.17504635E-05_JPRB, 0.17522016E-05_JPRB, 0.17530666E-05_JPRB, 0.17536383E-05_JPRB, 0.17539821E-05_JPRB, 0.17540769E-05_JPRB, &
  & 0.17540169E-05_JPRB, 0.17539319E-05_JPRB, 0.17538466E-05_JPRB, 0.17537685E-05_JPRB, 0.17536823E-05_JPRB, 0.17535854E-05_JPRB, &
  & 0.17534446E-05_JPRB, 0.17532607E-05_JPRB, 0.17528899E-05_JPRB, 0.17523776E-05_JPRB, 0.17513366E-05_JPRB, 0.17502568E-05_JPRB, &
  & 0.17495557E-05_JPRB, 0.17495437E-05_JPRB, 0.17501491E-05_JPRB, 0.17512473E-05_JPRB, 0.17527281E-05_JPRB, 0.17544080E-05_JPRB, &
  & 0.17561334E-05_JPRB, 0.17576892E-05_JPRB, 0.17589166E-05_JPRB, 0.17597226E-05_JPRB, 0.17600796E-05_JPRB, 0.17600282E-05_JPRB, &
  & 0.17596349E-05_JPRB, 0.17589745E-05_JPRB, 0.17581540E-05_JPRB, 0.17572922E-05_JPRB, 0.17564947E-05_JPRB, 0.17558151E-05_JPRB, &
  & 0.17552571E-05_JPRB, 0.17548186E-05_JPRB, 0.17545146E-05_JPRB, 0.17544155E-05_JPRB, 0.17546499E-05_JPRB, 0.17553838E-05_JPRB, &
  & 0.17567030E-05_JPRB, 0.17585622E-05_JPRB, 0.17605537E-05_JPRB, 0.17624300E-05_JPRB, 0.17638697E-05_JPRB, 0.17649302E-05_JPRB, &
  & 0.17656569E-05_JPRB, 0.17661378E-05_JPRB, 0.17664427E-05_JPRB, 0.17666280E-05_JPRB, 0.17667267E-05_JPRB, 0.17667822E-05_JPRB, &
  & 0.17668096E-05_JPRB, 0.17668203E-05_JPRB, 0.17668156E-05_JPRB, 0.17667945E-05_JPRB, 0.17667553E-05_JPRB, 0.17667026E-05_JPRB, &
  & 0.17666383E-05_JPRB, 0.17665579E-05_JPRB, 0.17664531E-05_JPRB, 0.17662350E-05_JPRB /)

RGHG2(:,58, 2) = (/ &
  & 0.17529444E-05_JPRB, 0.17543127E-05_JPRB, 0.17548474E-05_JPRB, 0.17551357E-05_JPRB, 0.17552504E-05_JPRB, 0.17551804E-05_JPRB, &
  & 0.17550524E-05_JPRB, 0.17549334E-05_JPRB, 0.17548437E-05_JPRB, 0.17547595E-05_JPRB, 0.17546781E-05_JPRB, 0.17545773E-05_JPRB, &
  & 0.17544528E-05_JPRB, 0.17542409E-05_JPRB, 0.17539392E-05_JPRB, 0.17532748E-05_JPRB, 0.17523171E-05_JPRB, 0.17510109E-05_JPRB, &
  & 0.17501775E-05_JPRB, 0.17500657E-05_JPRB, 0.17506122E-05_JPRB, 0.17516915E-05_JPRB, 0.17531605E-05_JPRB, 0.17548666E-05_JPRB, &
  & 0.17566003E-05_JPRB, 0.17581676E-05_JPRB, 0.17593940E-05_JPRB, 0.17601733E-05_JPRB, 0.17604928E-05_JPRB, 0.17603923E-05_JPRB, &
  & 0.17599464E-05_JPRB, 0.17592318E-05_JPRB, 0.17583588E-05_JPRB, 0.17574587E-05_JPRB, 0.17566372E-05_JPRB, 0.17559487E-05_JPRB, &
  & 0.17554014E-05_JPRB, 0.17549845E-05_JPRB, 0.17547241E-05_JPRB, 0.17546926E-05_JPRB, 0.17550213E-05_JPRB, 0.17558551E-05_JPRB, &
  & 0.17572894E-05_JPRB, 0.17591987E-05_JPRB, 0.17613204E-05_JPRB, 0.17631917E-05_JPRB, 0.17646994E-05_JPRB, 0.17657412E-05_JPRB, &
  & 0.17664456E-05_JPRB, 0.17669031E-05_JPRB, 0.17671960E-05_JPRB, 0.17673693E-05_JPRB, 0.17674729E-05_JPRB, 0.17675296E-05_JPRB, &
  & 0.17675636E-05_JPRB, 0.17675816E-05_JPRB, 0.17675864E-05_JPRB, 0.17675776E-05_JPRB, 0.17675545E-05_JPRB, 0.17675188E-05_JPRB, &
  & 0.17674713E-05_JPRB, 0.17674129E-05_JPRB, 0.17673295E-05_JPRB, 0.17671687E-05_JPRB /)

RGHG2(:,59, 2) = (/ &
  & 0.17550216E-05_JPRB, 0.17559912E-05_JPRB, 0.17562829E-05_JPRB, 0.17564034E-05_JPRB, 0.17563752E-05_JPRB, 0.17562178E-05_JPRB, &
  & 0.17560481E-05_JPRB, 0.17559203E-05_JPRB, 0.17558199E-05_JPRB, 0.17557375E-05_JPRB, 0.17556512E-05_JPRB, 0.17555552E-05_JPRB, &
  & 0.17554164E-05_JPRB, 0.17552234E-05_JPRB, 0.17548473E-05_JPRB, 0.17542525E-05_JPRB, 0.17531029E-05_JPRB, 0.17517702E-05_JPRB, &
  & 0.17508327E-05_JPRB, 0.17506497E-05_JPRB, 0.17511492E-05_JPRB, 0.17521994E-05_JPRB, 0.17536736E-05_JPRB, 0.17553774E-05_JPRB, &
  & 0.17571240E-05_JPRB, 0.17586898E-05_JPRB, 0.17599000E-05_JPRB, 0.17606582E-05_JPRB, 0.17609379E-05_JPRB, 0.17607936E-05_JPRB, &
  & 0.17603005E-05_JPRB, 0.17595369E-05_JPRB, 0.17586167E-05_JPRB, 0.17576745E-05_JPRB, 0.17568277E-05_JPRB, 0.17561342E-05_JPRB, &
  & 0.17555930E-05_JPRB, 0.17552011E-05_JPRB, 0.17549830E-05_JPRB, 0.17550169E-05_JPRB, 0.17554298E-05_JPRB, 0.17563593E-05_JPRB, &
  & 0.17578611E-05_JPRB, 0.17598509E-05_JPRB, 0.17619767E-05_JPRB, 0.17639459E-05_JPRB, 0.17654397E-05_JPRB, 0.17664968E-05_JPRB, &
  & 0.17671775E-05_JPRB, 0.17676173E-05_JPRB, 0.17678893E-05_JPRB, 0.17680577E-05_JPRB, 0.17681514E-05_JPRB, 0.17682083E-05_JPRB, &
  & 0.17682412E-05_JPRB, 0.17682603E-05_JPRB, 0.17682673E-05_JPRB, 0.17682627E-05_JPRB, 0.17682448E-05_JPRB, 0.17682156E-05_JPRB, &
  & 0.17681766E-05_JPRB, 0.17681239E-05_JPRB, 0.17680519E-05_JPRB, 0.17678942E-05_JPRB /)

RGHG2(:,60, 2) = (/ &
  & 0.17572368E-05_JPRB, 0.17574814E-05_JPRB, 0.17575550E-05_JPRB, 0.17575464E-05_JPRB, 0.17574362E-05_JPRB, 0.17572504E-05_JPRB, &
  & 0.17570595E-05_JPRB, 0.17569159E-05_JPRB, 0.17568141E-05_JPRB, 0.17567246E-05_JPRB, 0.17566397E-05_JPRB, 0.17565342E-05_JPRB, &
  & 0.17563978E-05_JPRB, 0.17561663E-05_JPRB, 0.17558004E-05_JPRB, 0.17550631E-05_JPRB, 0.17539064E-05_JPRB, 0.17524997E-05_JPRB, &
  & 0.17515351E-05_JPRB, 0.17513079E-05_JPRB, 0.17517667E-05_JPRB, 0.17527983E-05_JPRB, 0.17542613E-05_JPRB, 0.17559684E-05_JPRB, &
  & 0.17577071E-05_JPRB, 0.17592590E-05_JPRB, 0.17604523E-05_JPRB, 0.17611786E-05_JPRB, 0.17614232E-05_JPRB, 0.17612410E-05_JPRB, &
  & 0.17607094E-05_JPRB, 0.17599037E-05_JPRB, 0.17589384E-05_JPRB, 0.17579566E-05_JPRB, 0.17570843E-05_JPRB, 0.17563816E-05_JPRB, &
  & 0.17558493E-05_JPRB, 0.17554798E-05_JPRB, 0.17553027E-05_JPRB, 0.17553969E-05_JPRB, 0.17558880E-05_JPRB, 0.17568955E-05_JPRB, &
  & 0.17584629E-05_JPRB, 0.17604763E-05_JPRB, 0.17626526E-05_JPRB, 0.17646039E-05_JPRB, 0.17661521E-05_JPRB, 0.17671958E-05_JPRB, &
  & 0.17678735E-05_JPRB, 0.17682951E-05_JPRB, 0.17685561E-05_JPRB, 0.17687090E-05_JPRB, 0.17687993E-05_JPRB, 0.17688494E-05_JPRB, &
  & 0.17688792E-05_JPRB, 0.17688949E-05_JPRB, 0.17688986E-05_JPRB, 0.17688914E-05_JPRB, 0.17688726E-05_JPRB, 0.17688440E-05_JPRB, &
  & 0.17688058E-05_JPRB, 0.17687586E-05_JPRB, 0.17686907E-05_JPRB, 0.17685609E-05_JPRB /)

RGHG2(:,61, 2) = (/ &
  & 0.17584542E-05_JPRB, 0.17586451E-05_JPRB, 0.17586634E-05_JPRB, 0.17586149E-05_JPRB, 0.17584978E-05_JPRB, 0.17582947E-05_JPRB, &
  & 0.17580988E-05_JPRB, 0.17579489E-05_JPRB, 0.17578373E-05_JPRB, 0.17577472E-05_JPRB, 0.17576531E-05_JPRB, 0.17575467E-05_JPRB, &
  & 0.17573861E-05_JPRB, 0.17571444E-05_JPRB, 0.17566858E-05_JPRB, 0.17559053E-05_JPRB, 0.17546463E-05_JPRB, 0.17532604E-05_JPRB, &
  & 0.17523033E-05_JPRB, 0.17520513E-05_JPRB, 0.17524808E-05_JPRB, 0.17534951E-05_JPRB, 0.17549453E-05_JPRB, 0.17566405E-05_JPRB, &
  & 0.17583607E-05_JPRB, 0.17598900E-05_JPRB, 0.17610516E-05_JPRB, 0.17617476E-05_JPRB, 0.17619582E-05_JPRB, 0.17617449E-05_JPRB, &
  & 0.17611848E-05_JPRB, 0.17603461E-05_JPRB, 0.17593429E-05_JPRB, 0.17583227E-05_JPRB, 0.17574233E-05_JPRB, 0.17567106E-05_JPRB, &
  & 0.17561838E-05_JPRB, 0.17558336E-05_JPRB, 0.17556930E-05_JPRB, 0.17558427E-05_JPRB, 0.17564022E-05_JPRB, 0.17574790E-05_JPRB, &
  & 0.17590972E-05_JPRB, 0.17611319E-05_JPRB, 0.17632957E-05_JPRB, 0.17652715E-05_JPRB, 0.17668016E-05_JPRB, 0.17678711E-05_JPRB, &
  & 0.17685391E-05_JPRB, 0.17689565E-05_JPRB, 0.17692018E-05_JPRB, 0.17693474E-05_JPRB, 0.17694257E-05_JPRB, 0.17694705E-05_JPRB, &
  & 0.17694936E-05_JPRB, 0.17695028E-05_JPRB, 0.17695004E-05_JPRB, 0.17694867E-05_JPRB, 0.17694620E-05_JPRB, 0.17694288E-05_JPRB, &
  & 0.17693879E-05_JPRB, 0.17693362E-05_JPRB, 0.17692696E-05_JPRB, 0.17691311E-05_JPRB /)

RGHG2(:,62, 2) = (/ &
  & 0.17596240E-05_JPRB, 0.17597417E-05_JPRB, 0.17597347E-05_JPRB, 0.17596778E-05_JPRB, 0.17595549E-05_JPRB, 0.17593749E-05_JPRB, &
  & 0.17591736E-05_JPRB, 0.17590130E-05_JPRB, 0.17588977E-05_JPRB, 0.17587984E-05_JPRB, 0.17587056E-05_JPRB, 0.17585844E-05_JPRB, &
  & 0.17584175E-05_JPRB, 0.17581181E-05_JPRB, 0.17576108E-05_JPRB, 0.17567083E-05_JPRB, 0.17554285E-05_JPRB, 0.17540898E-05_JPRB, &
  & 0.17531580E-05_JPRB, 0.17528971E-05_JPRB, 0.17533071E-05_JPRB, 0.17543033E-05_JPRB, 0.17557370E-05_JPRB, 0.17574063E-05_JPRB, &
  & 0.17590977E-05_JPRB, 0.17605878E-05_JPRB, 0.17617131E-05_JPRB, 0.17623723E-05_JPRB, 0.17625529E-05_JPRB, 0.17623173E-05_JPRB, &
  & 0.17617390E-05_JPRB, 0.17608795E-05_JPRB, 0.17598447E-05_JPRB, 0.17587915E-05_JPRB, 0.17578628E-05_JPRB, 0.17571390E-05_JPRB, &
  & 0.17566114E-05_JPRB, 0.17562768E-05_JPRB, 0.17561665E-05_JPRB, 0.17563642E-05_JPRB, 0.17569839E-05_JPRB, 0.17581210E-05_JPRB, &
  & 0.17597765E-05_JPRB, 0.17618216E-05_JPRB, 0.17639692E-05_JPRB, 0.17659091E-05_JPRB, 0.17674477E-05_JPRB, 0.17685095E-05_JPRB, &
  & 0.17691912E-05_JPRB, 0.17696009E-05_JPRB, 0.17698424E-05_JPRB, 0.17699743E-05_JPRB, 0.17700460E-05_JPRB, 0.17700810E-05_JPRB, &
  & 0.17700962E-05_JPRB, 0.17700970E-05_JPRB, 0.17700852E-05_JPRB, 0.17700619E-05_JPRB, 0.17700288E-05_JPRB, 0.17699881E-05_JPRB, &
  & 0.17699398E-05_JPRB, 0.17698846E-05_JPRB, 0.17698110E-05_JPRB, 0.17696744E-05_JPRB /)

RGHG2(:,63, 2) = (/ &
  & 0.17607008E-05_JPRB, 0.17608094E-05_JPRB, 0.17607994E-05_JPRB, 0.17607445E-05_JPRB, 0.17606410E-05_JPRB, 0.17604702E-05_JPRB, &
  & 0.17602786E-05_JPRB, 0.17601078E-05_JPRB, 0.17599818E-05_JPRB, 0.17598833E-05_JPRB, 0.17597830E-05_JPRB, 0.17596672E-05_JPRB, &
  & 0.17594700E-05_JPRB, 0.17591426E-05_JPRB, 0.17585361E-05_JPRB, 0.17575802E-05_JPRB, 0.17563077E-05_JPRB, 0.17550224E-05_JPRB, &
  & 0.17541238E-05_JPRB, 0.17538629E-05_JPRB, 0.17542598E-05_JPRB, 0.17552393E-05_JPRB, 0.17566435E-05_JPRB, 0.17582811E-05_JPRB, &
  & 0.17599227E-05_JPRB, 0.17613662E-05_JPRB, 0.17624432E-05_JPRB, 0.17630640E-05_JPRB, 0.17632170E-05_JPRB, 0.17629671E-05_JPRB, &
  & 0.17623837E-05_JPRB, 0.17615146E-05_JPRB, 0.17604617E-05_JPRB, 0.17593779E-05_JPRB, 0.17584260E-05_JPRB, 0.17576829E-05_JPRB, &
  & 0.17571531E-05_JPRB, 0.17568256E-05_JPRB, 0.17567397E-05_JPRB, 0.17569777E-05_JPRB, 0.17576469E-05_JPRB, 0.17588322E-05_JPRB, &
  & 0.17605171E-05_JPRB, 0.17625555E-05_JPRB, 0.17646695E-05_JPRB, 0.17665741E-05_JPRB, 0.17680762E-05_JPRB, 0.17691443E-05_JPRB, &
  & 0.17698251E-05_JPRB, 0.17702405E-05_JPRB, 0.17704747E-05_JPRB, 0.17706016E-05_JPRB, 0.17706624E-05_JPRB, 0.17706889E-05_JPRB, &
  & 0.17706942E-05_JPRB, 0.17706842E-05_JPRB, 0.17706602E-05_JPRB, 0.17706250E-05_JPRB, 0.17705804E-05_JPRB, 0.17705293E-05_JPRB, &
  & 0.17704723E-05_JPRB, 0.17704060E-05_JPRB, 0.17703242E-05_JPRB, 0.17701673E-05_JPRB /)

RGHG2(:,64, 2) = (/ &
  & 0.17617645E-05_JPRB, 0.17618743E-05_JPRB, 0.17618709E-05_JPRB, 0.17618270E-05_JPRB, 0.17617350E-05_JPRB, 0.17615866E-05_JPRB, &
  & 0.17613949E-05_JPRB, 0.17612197E-05_JPRB, 0.17610848E-05_JPRB, 0.17609811E-05_JPRB, 0.17608902E-05_JPRB, 0.17607684E-05_JPRB, &
  & 0.17605691E-05_JPRB, 0.17601849E-05_JPRB, 0.17595356E-05_JPRB, 0.17585485E-05_JPRB, 0.17573042E-05_JPRB, 0.17560701E-05_JPRB, &
  & 0.17552086E-05_JPRB, 0.17549571E-05_JPRB, 0.17553467E-05_JPRB, 0.17563013E-05_JPRB, 0.17576722E-05_JPRB, 0.17592533E-05_JPRB, &
  & 0.17608377E-05_JPRB, 0.17622170E-05_JPRB, 0.17632393E-05_JPRB, 0.17638176E-05_JPRB, 0.17639463E-05_JPRB, 0.17636899E-05_JPRB, &
  & 0.17631120E-05_JPRB, 0.17622488E-05_JPRB, 0.17611893E-05_JPRB, 0.17600918E-05_JPRB, 0.17591149E-05_JPRB, 0.17583602E-05_JPRB, &
  & 0.17578187E-05_JPRB, 0.17574951E-05_JPRB, 0.17574253E-05_JPRB, 0.17576939E-05_JPRB, 0.17584028E-05_JPRB, 0.17596220E-05_JPRB, &
  & 0.17613211E-05_JPRB, 0.17633404E-05_JPRB, 0.17654080E-05_JPRB, 0.17672523E-05_JPRB, 0.17687200E-05_JPRB, 0.17697652E-05_JPRB, &
  & 0.17704522E-05_JPRB, 0.17708683E-05_JPRB, 0.17711031E-05_JPRB, 0.17712233E-05_JPRB, 0.17712775E-05_JPRB, 0.17712939E-05_JPRB, &
  & 0.17712885E-05_JPRB, 0.17712653E-05_JPRB, 0.17712274E-05_JPRB, 0.17711779E-05_JPRB, 0.17711202E-05_JPRB, 0.17710564E-05_JPRB, &
  & 0.17709863E-05_JPRB, 0.17709081E-05_JPRB, 0.17708084E-05_JPRB, 0.17706261E-05_JPRB /)

RGHG2(:,65, 2) = (/ &
  & 0.17628026E-05_JPRB, 0.17629391E-05_JPRB, 0.17629502E-05_JPRB, 0.17629196E-05_JPRB, 0.17628442E-05_JPRB, 0.17627071E-05_JPRB, &
  & 0.17625282E-05_JPRB, 0.17623386E-05_JPRB, 0.17622046E-05_JPRB, 0.17621009E-05_JPRB, 0.17620182E-05_JPRB, 0.17619077E-05_JPRB, &
  & 0.17616932E-05_JPRB, 0.17612906E-05_JPRB, 0.17606136E-05_JPRB, 0.17596269E-05_JPRB, 0.17584160E-05_JPRB, 0.17572352E-05_JPRB, &
  & 0.17564170E-05_JPRB, 0.17561831E-05_JPRB, 0.17565644E-05_JPRB, 0.17574904E-05_JPRB, 0.17588061E-05_JPRB, 0.17603218E-05_JPRB, &
  & 0.17618250E-05_JPRB, 0.17631305E-05_JPRB, 0.17640876E-05_JPRB, 0.17646203E-05_JPRB, 0.17647260E-05_JPRB, 0.17644686E-05_JPRB, &
  & 0.17639063E-05_JPRB, 0.17630618E-05_JPRB, 0.17620155E-05_JPRB, 0.17609160E-05_JPRB, 0.17599320E-05_JPRB, 0.17591647E-05_JPRB, &
  & 0.17586190E-05_JPRB, 0.17582935E-05_JPRB, 0.17582344E-05_JPRB, 0.17585248E-05_JPRB, 0.17592602E-05_JPRB, 0.17605000E-05_JPRB, &
  & 0.17621917E-05_JPRB, 0.17641755E-05_JPRB, 0.17661810E-05_JPRB, 0.17679597E-05_JPRB, 0.17693709E-05_JPRB, 0.17703937E-05_JPRB, &
  & 0.17710697E-05_JPRB, 0.17714880E-05_JPRB, 0.17717238E-05_JPRB, 0.17718414E-05_JPRB, 0.17718893E-05_JPRB, 0.17718969E-05_JPRB, &
  & 0.17718799E-05_JPRB, 0.17718430E-05_JPRB, 0.17717894E-05_JPRB, 0.17717259E-05_JPRB, 0.17716543E-05_JPRB, 0.17715764E-05_JPRB, &
  & 0.17714916E-05_JPRB, 0.17713932E-05_JPRB, 0.17712700E-05_JPRB, 0.17710381E-05_JPRB /)

RGHG2(:,66, 2) = (/ &
  & 0.17638270E-05_JPRB, 0.17640042E-05_JPRB, 0.17640365E-05_JPRB, 0.17640240E-05_JPRB, 0.17639629E-05_JPRB, 0.17638406E-05_JPRB, &
  & 0.17636632E-05_JPRB, 0.17634818E-05_JPRB, 0.17633412E-05_JPRB, 0.17632519E-05_JPRB, 0.17631809E-05_JPRB, 0.17630805E-05_JPRB, &
  & 0.17628635E-05_JPRB, 0.17624525E-05_JPRB, 0.17617728E-05_JPRB, 0.17608024E-05_JPRB, 0.17596357E-05_JPRB, 0.17585139E-05_JPRB, &
  & 0.17577474E-05_JPRB, 0.17575333E-05_JPRB, 0.17579042E-05_JPRB, 0.17587848E-05_JPRB, 0.17600341E-05_JPRB, 0.17614610E-05_JPRB, &
  & 0.17628731E-05_JPRB, 0.17640897E-05_JPRB, 0.17649741E-05_JPRB, 0.17654580E-05_JPRB, 0.17655408E-05_JPRB, 0.17652867E-05_JPRB, &
  & 0.17647475E-05_JPRB, 0.17639341E-05_JPRB, 0.17629148E-05_JPRB, 0.17618339E-05_JPRB, 0.17608565E-05_JPRB, 0.17600946E-05_JPRB, &
  & 0.17595468E-05_JPRB, 0.17592240E-05_JPRB, 0.17591725E-05_JPRB, 0.17594767E-05_JPRB, 0.17602267E-05_JPRB, 0.17614676E-05_JPRB, &
  & 0.17631360E-05_JPRB, 0.17650606E-05_JPRB, 0.17669886E-05_JPRB, 0.17686920E-05_JPRB, 0.17700424E-05_JPRB, 0.17710254E-05_JPRB, &
  & 0.17716873E-05_JPRB, 0.17721017E-05_JPRB, 0.17723358E-05_JPRB, 0.17724533E-05_JPRB, 0.17724972E-05_JPRB, 0.17724976E-05_JPRB, &
  & 0.17724706E-05_JPRB, 0.17724201E-05_JPRB, 0.17723534E-05_JPRB, 0.17722750E-05_JPRB, 0.17721907E-05_JPRB, 0.17720997E-05_JPRB, &
  & 0.17719964E-05_JPRB, 0.17718767E-05_JPRB, 0.17717165E-05_JPRB, 0.17714173E-05_JPRB /)

RGHG2(:,67, 2) = (/ &
  & 0.17648572E-05_JPRB, 0.17650800E-05_JPRB, 0.17651339E-05_JPRB, 0.17651406E-05_JPRB, 0.17650966E-05_JPRB, 0.17649858E-05_JPRB, &
  & 0.17648190E-05_JPRB, 0.17646372E-05_JPRB, 0.17645144E-05_JPRB, 0.17644361E-05_JPRB, 0.17643832E-05_JPRB, 0.17642915E-05_JPRB, &
  & 0.17640791E-05_JPRB, 0.17636725E-05_JPRB, 0.17630039E-05_JPRB, 0.17620656E-05_JPRB, 0.17609548E-05_JPRB, 0.17599015E-05_JPRB, &
  & 0.17591860E-05_JPRB, 0.17589902E-05_JPRB, 0.17593399E-05_JPRB, 0.17601654E-05_JPRB, 0.17613297E-05_JPRB, 0.17626573E-05_JPRB, &
  & 0.17639632E-05_JPRB, 0.17650846E-05_JPRB, 0.17658900E-05_JPRB, 0.17663237E-05_JPRB, 0.17663841E-05_JPRB, 0.17661364E-05_JPRB, &
  & 0.17656250E-05_JPRB, 0.17648516E-05_JPRB, 0.17638739E-05_JPRB, 0.17628257E-05_JPRB, 0.17618759E-05_JPRB, 0.17611305E-05_JPRB, &
  & 0.17605948E-05_JPRB, 0.17602796E-05_JPRB, 0.17602367E-05_JPRB, 0.17605491E-05_JPRB, 0.17613029E-05_JPRB, 0.17625282E-05_JPRB, &
  & 0.17641496E-05_JPRB, 0.17659960E-05_JPRB, 0.17678353E-05_JPRB, 0.17694457E-05_JPRB, 0.17707338E-05_JPRB, 0.17716698E-05_JPRB, &
  & 0.17723069E-05_JPRB, 0.17727103E-05_JPRB, 0.17729425E-05_JPRB, 0.17730572E-05_JPRB, 0.17730994E-05_JPRB, 0.17730954E-05_JPRB, &
  & 0.17730614E-05_JPRB, 0.17730017E-05_JPRB, 0.17729226E-05_JPRB, 0.17728348E-05_JPRB, 0.17727389E-05_JPRB, 0.17726354E-05_JPRB, &
  & 0.17725174E-05_JPRB, 0.17723673E-05_JPRB, 0.17721648E-05_JPRB, 0.17717589E-05_JPRB /)

RGHG2(:,68, 2) = (/ &
  & 0.17658444E-05_JPRB, 0.17661405E-05_JPRB, 0.17662314E-05_JPRB, 0.17662658E-05_JPRB, 0.17662430E-05_JPRB, 0.17661476E-05_JPRB, &
  & 0.17659933E-05_JPRB, 0.17658242E-05_JPRB, 0.17657185E-05_JPRB, 0.17656614E-05_JPRB, 0.17656225E-05_JPRB, 0.17655420E-05_JPRB, &
  & 0.17653354E-05_JPRB, 0.17649410E-05_JPRB, 0.17642963E-05_JPRB, 0.17634043E-05_JPRB, 0.17623602E-05_JPRB, 0.17613769E-05_JPRB, &
  & 0.17607110E-05_JPRB, 0.17605253E-05_JPRB, 0.17608451E-05_JPRB, 0.17616019E-05_JPRB, 0.17626730E-05_JPRB, 0.17638909E-05_JPRB, &
  & 0.17650884E-05_JPRB, 0.17661077E-05_JPRB, 0.17668352E-05_JPRB, 0.17672168E-05_JPRB, 0.17672565E-05_JPRB, 0.17670180E-05_JPRB, &
  & 0.17665385E-05_JPRB, 0.17658118E-05_JPRB, 0.17648852E-05_JPRB, 0.17638840E-05_JPRB, 0.17629745E-05_JPRB, 0.17622624E-05_JPRB, &
  & 0.17617479E-05_JPRB, 0.17614483E-05_JPRB, 0.17614157E-05_JPRB, 0.17617338E-05_JPRB, 0.17624801E-05_JPRB, 0.17636747E-05_JPRB, &
  & 0.17652306E-05_JPRB, 0.17669838E-05_JPRB, 0.17687097E-05_JPRB, 0.17702336E-05_JPRB, 0.17714365E-05_JPRB, 0.17723270E-05_JPRB, &
  & 0.17729315E-05_JPRB, 0.17733199E-05_JPRB, 0.17735437E-05_JPRB, 0.17736562E-05_JPRB, 0.17736969E-05_JPRB, 0.17736905E-05_JPRB, &
  & 0.17736543E-05_JPRB, 0.17735885E-05_JPRB, 0.17735047E-05_JPRB, 0.17734091E-05_JPRB, 0.17733078E-05_JPRB, 0.17731966E-05_JPRB, &
  & 0.17730636E-05_JPRB, 0.17728912E-05_JPRB, 0.17726294E-05_JPRB, 0.17721026E-05_JPRB /)

RGHG2(:,69, 2) = (/ &
  & 0.17668250E-05_JPRB, 0.17672130E-05_JPRB, 0.17673424E-05_JPRB, 0.17674095E-05_JPRB, 0.17674121E-05_JPRB, 0.17673352E-05_JPRB, &
  & 0.17671964E-05_JPRB, 0.17670482E-05_JPRB, 0.17669648E-05_JPRB, 0.17669275E-05_JPRB, 0.17669000E-05_JPRB, 0.17668301E-05_JPRB, &
  & 0.17666317E-05_JPRB, 0.17662562E-05_JPRB, 0.17656439E-05_JPRB, 0.17648078E-05_JPRB, 0.17638345E-05_JPRB, 0.17629229E-05_JPRB, &
  & 0.17622992E-05_JPRB, 0.17621172E-05_JPRB, 0.17623980E-05_JPRB, 0.17630808E-05_JPRB, 0.17640509E-05_JPRB, 0.17651589E-05_JPRB, &
  & 0.17662418E-05_JPRB, 0.17671622E-05_JPRB, 0.17678087E-05_JPRB, 0.17681418E-05_JPRB, 0.17681637E-05_JPRB, 0.17679362E-05_JPRB, &
  & 0.17674940E-05_JPRB, 0.17668185E-05_JPRB, 0.17659522E-05_JPRB, 0.17650085E-05_JPRB, 0.17641512E-05_JPRB, 0.17634807E-05_JPRB, &
  & 0.17629973E-05_JPRB, 0.17627186E-05_JPRB, 0.17626990E-05_JPRB, 0.17630186E-05_JPRB, 0.17637509E-05_JPRB, 0.17648993E-05_JPRB, &
  & 0.17663765E-05_JPRB, 0.17680168E-05_JPRB, 0.17696296E-05_JPRB, 0.17710364E-05_JPRB, 0.17721677E-05_JPRB, 0.17729926E-05_JPRB, &
  & 0.17735653E-05_JPRB, 0.17739319E-05_JPRB, 0.17741467E-05_JPRB, 0.17742548E-05_JPRB, 0.17742948E-05_JPRB, 0.17742889E-05_JPRB, &
  & 0.17742534E-05_JPRB, 0.17741870E-05_JPRB, 0.17741021E-05_JPRB, 0.17740065E-05_JPRB, 0.17739014E-05_JPRB, 0.17737881E-05_JPRB, &
  & 0.17736492E-05_JPRB, 0.17734543E-05_JPRB, 0.17731440E-05_JPRB, 0.17724758E-05_JPRB /)

RGHG2(:,70, 2) = (/ &
  & 0.17678021E-05_JPRB, 0.17682956E-05_JPRB, 0.17684783E-05_JPRB, 0.17685819E-05_JPRB, 0.17686129E-05_JPRB, 0.17685569E-05_JPRB, &
  & 0.17684405E-05_JPRB, 0.17683142E-05_JPRB, 0.17682547E-05_JPRB, 0.17682344E-05_JPRB, 0.17682140E-05_JPRB, 0.17681506E-05_JPRB, &
  & 0.17679619E-05_JPRB, 0.17676072E-05_JPRB, 0.17670359E-05_JPRB, 0.17662587E-05_JPRB, 0.17653613E-05_JPRB, 0.17645174E-05_JPRB, &
  & 0.17639344E-05_JPRB, 0.17637503E-05_JPRB, 0.17639886E-05_JPRB, 0.17645910E-05_JPRB, 0.17654595E-05_JPRB, 0.17664511E-05_JPRB, &
  & 0.17674230E-05_JPRB, 0.17682428E-05_JPRB, 0.17688133E-05_JPRB, 0.17690993E-05_JPRB, 0.17691065E-05_JPRB, 0.17688944E-05_JPRB, &
  & 0.17684910E-05_JPRB, 0.17678744E-05_JPRB, 0.17670741E-05_JPRB, 0.17661985E-05_JPRB, 0.17654006E-05_JPRB, 0.17647831E-05_JPRB, &
  & 0.17643349E-05_JPRB, 0.17640820E-05_JPRB, 0.17640751E-05_JPRB, 0.17643939E-05_JPRB, 0.17651016E-05_JPRB, 0.17661930E-05_JPRB, &
  & 0.17675791E-05_JPRB, 0.17690966E-05_JPRB, 0.17705781E-05_JPRB, 0.17718770E-05_JPRB, 0.17729075E-05_JPRB, 0.17736758E-05_JPRB, &
  & 0.17742042E-05_JPRB, 0.17745498E-05_JPRB, 0.17747519E-05_JPRB, 0.17748562E-05_JPRB, 0.17748965E-05_JPRB, 0.17748929E-05_JPRB, &
  & 0.17748615E-05_JPRB, 0.17747994E-05_JPRB, 0.17747195E-05_JPRB, 0.17746268E-05_JPRB, 0.17745245E-05_JPRB, 0.17744128E-05_JPRB, &
  & 0.17742734E-05_JPRB, 0.17740695E-05_JPRB, 0.17737234E-05_JPRB, 0.17729476E-05_JPRB /)

RGHG2(:,71, 2) = (/ &
  & 0.17687980E-05_JPRB, 0.17694224E-05_JPRB, 0.17696520E-05_JPRB, 0.17697939E-05_JPRB, 0.17698512E-05_JPRB, 0.17698172E-05_JPRB, &
  & 0.17697234E-05_JPRB, 0.17696246E-05_JPRB, 0.17695847E-05_JPRB, 0.17695752E-05_JPRB, 0.17695573E-05_JPRB, 0.17694966E-05_JPRB, &
  & 0.17693180E-05_JPRB, 0.17689871E-05_JPRB, 0.17684581E-05_JPRB, 0.17677437E-05_JPRB, 0.17669201E-05_JPRB, 0.17661476E-05_JPRB, &
  & 0.17656023E-05_JPRB, 0.17654163E-05_JPRB, 0.17656095E-05_JPRB, 0.17661308E-05_JPRB, 0.17668922E-05_JPRB, 0.17677697E-05_JPRB, &
  & 0.17686277E-05_JPRB, 0.17693501E-05_JPRB, 0.17698460E-05_JPRB, 0.17700885E-05_JPRB, 0.17700849E-05_JPRB, 0.17698908E-05_JPRB, &
  & 0.17695311E-05_JPRB, 0.17689757E-05_JPRB, 0.17682506E-05_JPRB, 0.17674464E-05_JPRB, 0.17667215E-05_JPRB, 0.17661600E-05_JPRB, &
  & 0.17657546E-05_JPRB, 0.17655296E-05_JPRB, 0.17655348E-05_JPRB, 0.17658487E-05_JPRB, 0.17665233E-05_JPRB, 0.17675479E-05_JPRB, &
  & 0.17688249E-05_JPRB, 0.17702173E-05_JPRB, 0.17715597E-05_JPRB, 0.17727298E-05_JPRB, 0.17736702E-05_JPRB, 0.17743623E-05_JPRB, &
  & 0.17748498E-05_JPRB, 0.17751693E-05_JPRB, 0.17753590E-05_JPRB, 0.17754583E-05_JPRB, 0.17755000E-05_JPRB, 0.17755011E-05_JPRB, &
  & 0.17754766E-05_JPRB, 0.17754234E-05_JPRB, 0.17753528E-05_JPRB, 0.17752676E-05_JPRB, 0.17751712E-05_JPRB, 0.17750660E-05_JPRB, &
  & 0.17749305E-05_JPRB, 0.17747283E-05_JPRB, 0.17743666E-05_JPRB, 0.17735344E-05_JPRB /)

RGHG2(:,72, 2) = (/ &
  & 0.17698421E-05_JPRB, 0.17705961E-05_JPRB, 0.17708765E-05_JPRB, 0.17710477E-05_JPRB, 0.17711251E-05_JPRB, 0.17711093E-05_JPRB, &
  & 0.17710405E-05_JPRB, 0.17709662E-05_JPRB, 0.17709425E-05_JPRB, 0.17709370E-05_JPRB, 0.17709194E-05_JPRB, 0.17708550E-05_JPRB, &
  & 0.17706901E-05_JPRB, 0.17703805E-05_JPRB, 0.17698962E-05_JPRB, 0.17692458E-05_JPRB, 0.17684987E-05_JPRB, 0.17677962E-05_JPRB, &
  & 0.17672942E-05_JPRB, 0.17671080E-05_JPRB, 0.17672562E-05_JPRB, 0.17676937E-05_JPRB, 0.17683496E-05_JPRB, 0.17691098E-05_JPRB, &
  & 0.17698558E-05_JPRB, 0.17704824E-05_JPRB, 0.17709062E-05_JPRB, 0.17711088E-05_JPRB, 0.17710981E-05_JPRB, 0.17709249E-05_JPRB, &
  & 0.17706093E-05_JPRB, 0.17701216E-05_JPRB, 0.17694729E-05_JPRB, 0.17687543E-05_JPRB, 0.17681047E-05_JPRB, 0.17676091E-05_JPRB, &
  & 0.17672478E-05_JPRB, 0.17670534E-05_JPRB, 0.17670706E-05_JPRB, 0.17673742E-05_JPRB, 0.17680081E-05_JPRB, 0.17689470E-05_JPRB, &
  & 0.17701163E-05_JPRB, 0.17713576E-05_JPRB, 0.17725575E-05_JPRB, 0.17736039E-05_JPRB, 0.17744330E-05_JPRB, 0.17750552E-05_JPRB, &
  & 0.17754949E-05_JPRB, 0.17757865E-05_JPRB, 0.17759617E-05_JPRB, 0.17760567E-05_JPRB, 0.17760995E-05_JPRB, 0.17761063E-05_JPRB, &
  & 0.17760909E-05_JPRB, 0.17760481E-05_JPRB, 0.17759895E-05_JPRB, 0.17759148E-05_JPRB, 0.17758273E-05_JPRB, 0.17757309E-05_JPRB, &
  & 0.17756058E-05_JPRB, 0.17754111E-05_JPRB, 0.17750500E-05_JPRB, 0.17741885E-05_JPRB /)

RGHG2(:,73, 2) = (/ &
  & 0.17710543E-05_JPRB, 0.17718595E-05_JPRB, 0.17721520E-05_JPRB, 0.17723307E-05_JPRB, 0.17724160E-05_JPRB, 0.17724145E-05_JPRB, &
  & 0.17723661E-05_JPRB, 0.17723153E-05_JPRB, 0.17723011E-05_JPRB, 0.17722978E-05_JPRB, 0.17722774E-05_JPRB, 0.17722167E-05_JPRB, &
  & 0.17720563E-05_JPRB, 0.17717764E-05_JPRB, 0.17713348E-05_JPRB, 0.17707466E-05_JPRB, 0.17700791E-05_JPRB, 0.17694493E-05_JPRB, &
  & 0.17689971E-05_JPRB, 0.17688139E-05_JPRB, 0.17689192E-05_JPRB, 0.17692759E-05_JPRB, 0.17698255E-05_JPRB, 0.17704715E-05_JPRB, &
  & 0.17711067E-05_JPRB, 0.17716378E-05_JPRB, 0.17719929E-05_JPRB, 0.17721595E-05_JPRB, 0.17721447E-05_JPRB, 0.17719935E-05_JPRB, &
  & 0.17717252E-05_JPRB, 0.17713037E-05_JPRB, 0.17707406E-05_JPRB, 0.17701090E-05_JPRB, 0.17695447E-05_JPRB, 0.17691149E-05_JPRB, &
  & 0.17688050E-05_JPRB, 0.17686416E-05_JPRB, 0.17686699E-05_JPRB, 0.17689589E-05_JPRB, 0.17695388E-05_JPRB, 0.17703886E-05_JPRB, &
  & 0.17714176E-05_JPRB, 0.17725162E-05_JPRB, 0.17735651E-05_JPRB, 0.17744690E-05_JPRB, 0.17752031E-05_JPRB, 0.17757434E-05_JPRB, &
  & 0.17761320E-05_JPRB, 0.17763948E-05_JPRB, 0.17765543E-05_JPRB, 0.17766419E-05_JPRB, 0.17766870E-05_JPRB, 0.17766989E-05_JPRB, &
  & 0.17766914E-05_JPRB, 0.17766595E-05_JPRB, 0.17766141E-05_JPRB, 0.17765498E-05_JPRB, 0.17764739E-05_JPRB, 0.17763886E-05_JPRB, &
  & 0.17762761E-05_JPRB, 0.17760970E-05_JPRB, 0.17757477E-05_JPRB, 0.17748932E-05_JPRB /)

RGHG2(:,74, 2) = (/ &
  & 0.17723071E-05_JPRB, 0.17731520E-05_JPRB, 0.17734370E-05_JPRB, 0.17736154E-05_JPRB, 0.17736985E-05_JPRB, 0.17737049E-05_JPRB, &
  & 0.17736738E-05_JPRB, 0.17736393E-05_JPRB, 0.17736322E-05_JPRB, 0.17736301E-05_JPRB, 0.17736113E-05_JPRB, 0.17735481E-05_JPRB, &
  & 0.17734086E-05_JPRB, 0.17731489E-05_JPRB, 0.17727558E-05_JPRB, 0.17722355E-05_JPRB, 0.17716461E-05_JPRB, 0.17710963E-05_JPRB, &
  & 0.17706980E-05_JPRB, 0.17705245E-05_JPRB, 0.17705910E-05_JPRB, 0.17708702E-05_JPRB, 0.17713178E-05_JPRB, 0.17718523E-05_JPRB, &
  & 0.17723769E-05_JPRB, 0.17728171E-05_JPRB, 0.17731051E-05_JPRB, 0.17732388E-05_JPRB, 0.17732231E-05_JPRB, 0.17730952E-05_JPRB, &
  & 0.17728726E-05_JPRB, 0.17725202E-05_JPRB, 0.17720447E-05_JPRB, 0.17715078E-05_JPRB, 0.17710307E-05_JPRB, 0.17706710E-05_JPRB, &
  & 0.17704131E-05_JPRB, 0.17702819E-05_JPRB, 0.17703188E-05_JPRB, 0.17705861E-05_JPRB, 0.17711066E-05_JPRB, 0.17718428E-05_JPRB, &
  & 0.17727397E-05_JPRB, 0.17736710E-05_JPRB, 0.17745598E-05_JPRB, 0.17753422E-05_JPRB, 0.17759569E-05_JPRB, 0.17764237E-05_JPRB, &
  & 0.17767597E-05_JPRB, 0.17769887E-05_JPRB, 0.17771298E-05_JPRB, 0.17772111E-05_JPRB, 0.17772545E-05_JPRB, 0.17772695E-05_JPRB, &
  & 0.17772686E-05_JPRB, 0.17772463E-05_JPRB, 0.17772127E-05_JPRB, 0.17771603E-05_JPRB, 0.17770958E-05_JPRB, 0.17770230E-05_JPRB, &
  & 0.17769268E-05_JPRB, 0.17767674E-05_JPRB, 0.17764416E-05_JPRB, 0.17756242E-05_JPRB /)

RGHG2(:,75, 2) = (/ &
  & 0.17735860E-05_JPRB, 0.17744319E-05_JPRB, 0.17747082E-05_JPRB, 0.17748707E-05_JPRB, 0.17749480E-05_JPRB, 0.17749587E-05_JPRB, &
  & 0.17749401E-05_JPRB, 0.17749175E-05_JPRB, 0.17749151E-05_JPRB, 0.17749148E-05_JPRB, 0.17748962E-05_JPRB, 0.17748439E-05_JPRB, &
  & 0.17747121E-05_JPRB, 0.17744907E-05_JPRB, 0.17741468E-05_JPRB, 0.17736972E-05_JPRB, 0.17731975E-05_JPRB, 0.17727302E-05_JPRB, &
  & 0.17723925E-05_JPRB, 0.17722335E-05_JPRB, 0.17722687E-05_JPRB, 0.17724780E-05_JPRB, 0.17728300E-05_JPRB, 0.17732560E-05_JPRB, &
  & 0.17736749E-05_JPRB, 0.17740250E-05_JPRB, 0.17742494E-05_JPRB, 0.17743521E-05_JPRB, 0.17743381E-05_JPRB, 0.17742331E-05_JPRB, &
  & 0.17740563E-05_JPRB, 0.17737704E-05_JPRB, 0.17733857E-05_JPRB, 0.17729440E-05_JPRB, 0.17725597E-05_JPRB, 0.17722679E-05_JPRB, &
  & 0.17720647E-05_JPRB, 0.17719647E-05_JPRB, 0.17720066E-05_JPRB, 0.17722465E-05_JPRB, 0.17726917E-05_JPRB, 0.17733155E-05_JPRB, &
  & 0.17740547E-05_JPRB, 0.17748224E-05_JPRB, 0.17755583E-05_JPRB, 0.17761899E-05_JPRB, 0.17767119E-05_JPRB, 0.17770902E-05_JPRB, &
  & 0.17773717E-05_JPRB, 0.17775669E-05_JPRB, 0.17776862E-05_JPRB, 0.17777566E-05_JPRB, 0.17777995E-05_JPRB, 0.17778140E-05_JPRB, &
  & 0.17778173E-05_JPRB, 0.17778018E-05_JPRB, 0.17777802E-05_JPRB, 0.17777386E-05_JPRB, 0.17776871E-05_JPRB, 0.17776276E-05_JPRB, &
  & 0.17775492E-05_JPRB, 0.17774132E-05_JPRB, 0.17771205E-05_JPRB, 0.17763629E-05_JPRB /)

RGHG2(:,76, 2) = (/ &
  & 0.17748630E-05_JPRB, 0.17756906E-05_JPRB, 0.17759365E-05_JPRB, 0.17760833E-05_JPRB, 0.17761496E-05_JPRB, 0.17761618E-05_JPRB, &
  & 0.17761517E-05_JPRB, 0.17761356E-05_JPRB, 0.17761348E-05_JPRB, 0.17761339E-05_JPRB, 0.17761174E-05_JPRB, 0.17760690E-05_JPRB, &
  & 0.17759634E-05_JPRB, 0.17757761E-05_JPRB, 0.17754970E-05_JPRB, 0.17751325E-05_JPRB, 0.17747283E-05_JPRB, 0.17743527E-05_JPRB, &
  & 0.17740795E-05_JPRB, 0.17739419E-05_JPRB, 0.17739528E-05_JPRB, 0.17741019E-05_JPRB, 0.17743632E-05_JPRB, 0.17746852E-05_JPRB, &
  & 0.17749992E-05_JPRB, 0.17752643E-05_JPRB, 0.17754290E-05_JPRB, 0.17755035E-05_JPRB, 0.17754932E-05_JPRB, 0.17754099E-05_JPRB, &
  & 0.17752756E-05_JPRB, 0.17750563E-05_JPRB, 0.17747626E-05_JPRB, 0.17744190E-05_JPRB, 0.17741257E-05_JPRB, 0.17739029E-05_JPRB, &
  & 0.17737518E-05_JPRB, 0.17736818E-05_JPRB, 0.17737246E-05_JPRB, 0.17739269E-05_JPRB, 0.17742922E-05_JPRB, 0.17747850E-05_JPRB, &
  & 0.17753720E-05_JPRB, 0.17759671E-05_JPRB, 0.17765365E-05_JPRB, 0.17770424E-05_JPRB, 0.17774447E-05_JPRB, 0.17777448E-05_JPRB, &
  & 0.17779678E-05_JPRB, 0.17781255E-05_JPRB, 0.17782208E-05_JPRB, 0.17782788E-05_JPRB, 0.17783184E-05_JPRB, 0.17783307E-05_JPRB, &
  & 0.17783360E-05_JPRB, 0.17783257E-05_JPRB, 0.17783150E-05_JPRB, 0.17782843E-05_JPRB, 0.17782446E-05_JPRB, 0.17781990E-05_JPRB, &
  & 0.17781385E-05_JPRB, 0.17780294E-05_JPRB, 0.17777744E-05_JPRB, 0.17771021E-05_JPRB /)

RGHG2(:,77, 2) = (/ &
  & 0.17761374E-05_JPRB, 0.17768937E-05_JPRB, 0.17771092E-05_JPRB, 0.17772295E-05_JPRB, 0.17772826E-05_JPRB, 0.17772936E-05_JPRB, &
  & 0.17772902E-05_JPRB, 0.17772775E-05_JPRB, 0.17772735E-05_JPRB, 0.17772674E-05_JPRB, 0.17772473E-05_JPRB, 0.17772104E-05_JPRB, &
  & 0.17771255E-05_JPRB, 0.17769922E-05_JPRB, 0.17767888E-05_JPRB, 0.17765215E-05_JPRB, 0.17762266E-05_JPRB, 0.17759492E-05_JPRB, &
  & 0.17757461E-05_JPRB, 0.17756380E-05_JPRB, 0.17756347E-05_JPRB, 0.17757319E-05_JPRB, 0.17759112E-05_JPRB, 0.17761356E-05_JPRB, &
  & 0.17763523E-05_JPRB, 0.17765379E-05_JPRB, 0.17766480E-05_JPRB, 0.17766972E-05_JPRB, 0.17766920E-05_JPRB, 0.17766283E-05_JPRB, &
  & 0.17765334E-05_JPRB, 0.17763746E-05_JPRB, 0.17761697E-05_JPRB, 0.17759204E-05_JPRB, 0.17757146E-05_JPRB, 0.17755565E-05_JPRB, &
  & 0.17754553E-05_JPRB, 0.17754106E-05_JPRB, 0.17754479E-05_JPRB, 0.17756070E-05_JPRB, 0.17758773E-05_JPRB, 0.17762380E-05_JPRB, &
  & 0.17766608E-05_JPRB, 0.17770865E-05_JPRB, 0.17774989E-05_JPRB, 0.17778600E-05_JPRB, 0.17781641E-05_JPRB, 0.17783743E-05_JPRB, &
  & 0.17785410E-05_JPRB, 0.17786609E-05_JPRB, 0.17787287E-05_JPRB, 0.17787718E-05_JPRB, 0.17788069E-05_JPRB, 0.17788141E-05_JPRB, &
  & 0.17788195E-05_JPRB, 0.17788122E-05_JPRB, 0.17788125E-05_JPRB, 0.17787903E-05_JPRB, 0.17787629E-05_JPRB, 0.17787293E-05_JPRB, &
  & 0.17786883E-05_JPRB, 0.17786032E-05_JPRB, 0.17783964E-05_JPRB, 0.17778292E-05_JPRB /)

RGHG2(:,78, 2) = (/ &
  & 0.17773838E-05_JPRB, 0.17779929E-05_JPRB, 0.17781389E-05_JPRB, 0.17782319E-05_JPRB, 0.17782687E-05_JPRB, 0.17782789E-05_JPRB, &
  & 0.17782826E-05_JPRB, 0.17782716E-05_JPRB, 0.17782597E-05_JPRB, 0.17782459E-05_JPRB, 0.17782195E-05_JPRB, 0.17781928E-05_JPRB, &
  & 0.17781385E-05_JPRB, 0.17780617E-05_JPRB, 0.17779430E-05_JPRB, 0.17777791E-05_JPRB, 0.17775955E-05_JPRB, 0.17774189E-05_JPRB, &
  & 0.17772926E-05_JPRB, 0.17772221E-05_JPRB, 0.17772167E-05_JPRB, 0.17772768E-05_JPRB, 0.17773865E-05_JPRB, 0.17775263E-05_JPRB, &
  & 0.17776590E-05_JPRB, 0.17777767E-05_JPRB, 0.17778410E-05_JPRB, 0.17778689E-05_JPRB, 0.17778699E-05_JPRB, 0.17778225E-05_JPRB, &
  & 0.17777604E-05_JPRB, 0.17776547E-05_JPRB, 0.17775308E-05_JPRB, 0.17773659E-05_JPRB, 0.17772367E-05_JPRB, 0.17771323E-05_JPRB, &
  & 0.17770717E-05_JPRB, 0.17770440E-05_JPRB, 0.17770686E-05_JPRB, 0.17771724E-05_JPRB, 0.17773430E-05_JPRB, 0.17775669E-05_JPRB, &
  & 0.17778374E-05_JPRB, 0.17781020E-05_JPRB, 0.17783666E-05_JPRB, 0.17786072E-05_JPRB, 0.17788100E-05_JPRB, 0.17789440E-05_JPRB, &
  & 0.17790553E-05_JPRB, 0.17791399E-05_JPRB, 0.17791801E-05_JPRB, 0.17792063E-05_JPRB, 0.17792360E-05_JPRB, 0.17792349E-05_JPRB, &
  & 0.17792382E-05_JPRB, 0.17792320E-05_JPRB, 0.17792402E-05_JPRB, 0.17792244E-05_JPRB, 0.17792061E-05_JPRB, 0.17791831E-05_JPRB, &
  & 0.17791588E-05_JPRB, 0.17790977E-05_JPRB, 0.17789522E-05_JPRB, 0.17785389E-05_JPRB /)

RGHG2(:,79, 2) = (/ &
  & 0.17781873E-05_JPRB, 0.17786040E-05_JPRB, 0.17786859E-05_JPRB, 0.17787504E-05_JPRB, 0.17787777E-05_JPRB, 0.17787858E-05_JPRB, &
  & 0.17787937E-05_JPRB, 0.17787811E-05_JPRB, 0.17787659E-05_JPRB, 0.17787470E-05_JPRB, 0.17787215E-05_JPRB, 0.17787032E-05_JPRB, &
  & 0.17786660E-05_JPRB, 0.17786213E-05_JPRB, 0.17785470E-05_JPRB, 0.17784375E-05_JPRB, 0.17783138E-05_JPRB, 0.17781924E-05_JPRB, &
  & 0.17781100E-05_JPRB, 0.17780619E-05_JPRB, 0.17780578E-05_JPRB, 0.17781000E-05_JPRB, 0.17781742E-05_JPRB, 0.17782708E-05_JPRB, &
  & 0.17783589E-05_JPRB, 0.17784424E-05_JPRB, 0.17784830E-05_JPRB, 0.17785007E-05_JPRB, 0.17785069E-05_JPRB, 0.17784682E-05_JPRB, &
  & 0.17784239E-05_JPRB, 0.17783464E-05_JPRB, 0.17782679E-05_JPRB, 0.17781480E-05_JPRB, 0.17780594E-05_JPRB, 0.17779818E-05_JPRB, &
  & 0.17779416E-05_JPRB, 0.17779215E-05_JPRB, 0.17779352E-05_JPRB, 0.17780075E-05_JPRB, 0.17781199E-05_JPRB, 0.17782693E-05_JPRB, &
  & 0.17784569E-05_JPRB, 0.17786364E-05_JPRB, 0.17788234E-05_JPRB, 0.17789972E-05_JPRB, 0.17791529E-05_JPRB, 0.17792420E-05_JPRB, &
  & 0.17793266E-05_JPRB, 0.17793934E-05_JPRB, 0.17794181E-05_JPRB, 0.17794341E-05_JPRB, 0.17794612E-05_JPRB, 0.17794539E-05_JPRB, &
  & 0.17794554E-05_JPRB, 0.17794486E-05_JPRB, 0.17794630E-05_JPRB, 0.17794489E-05_JPRB, 0.17794349E-05_JPRB, 0.17794167E-05_JPRB, &
  & 0.17794027E-05_JPRB, 0.17793598E-05_JPRB, 0.17792604E-05_JPRB, 0.17789946E-05_JPRB /)

RGHG2(:,80, 2) = (/ &
  & 0.17787172E-05_JPRB, 0.17788984E-05_JPRB, 0.17789235E-05_JPRB, 0.17789748E-05_JPRB, 0.17789956E-05_JPRB, 0.17790023E-05_JPRB, &
  & 0.17790126E-05_JPRB, 0.17790010E-05_JPRB, 0.17789830E-05_JPRB, 0.17789675E-05_JPRB, 0.17789409E-05_JPRB, 0.17789304E-05_JPRB, &
  & 0.17789005E-05_JPRB, 0.17788699E-05_JPRB, 0.17788146E-05_JPRB, 0.17787281E-05_JPRB, 0.17786307E-05_JPRB, 0.17785341E-05_JPRB, &
  & 0.17784730E-05_JPRB, 0.17784356E-05_JPRB, 0.17784328E-05_JPRB, 0.17784685E-05_JPRB, 0.17785276E-05_JPRB, 0.17786048E-05_JPRB, &
  & 0.17786740E-05_JPRB, 0.17787428E-05_JPRB, 0.17787729E-05_JPRB, 0.17787867E-05_JPRB, 0.17787966E-05_JPRB, 0.17787614E-05_JPRB, &
  & 0.17787255E-05_JPRB, 0.17786602E-05_JPRB, 0.17786035E-05_JPRB, 0.17785037E-05_JPRB, 0.17784331E-05_JPRB, 0.17783666E-05_JPRB, &
  & 0.17783351E-05_JPRB, 0.17783175E-05_JPRB, 0.17783256E-05_JPRB, 0.17783827E-05_JPRB, 0.17784683E-05_JPRB, 0.17785832E-05_JPRB, &
  & 0.17787339E-05_JPRB, 0.17788744E-05_JPRB, 0.17790264E-05_JPRB, 0.17791716E-05_JPRB, 0.17793042E-05_JPRB, 0.17793734E-05_JPRB, &
  & 0.17794449E-05_JPRB, 0.17795059E-05_JPRB, 0.17795220E-05_JPRB, 0.17795327E-05_JPRB, 0.17795599E-05_JPRB, 0.17795487E-05_JPRB, &
  & 0.17795491E-05_JPRB, 0.17795413E-05_JPRB, 0.17795588E-05_JPRB, 0.17795455E-05_JPRB, 0.17795328E-05_JPRB, 0.17795167E-05_JPRB, &
  & 0.17795080E-05_JPRB, 0.17794736E-05_JPRB, 0.17794073E-05_JPRB, 0.17792972E-05_JPRB /)

RGHG2(:,81, 2) = (/ &
  & 0.17790800E-05_JPRB, 0.17790226E-05_JPRB, 0.17790235E-05_JPRB, 0.17790693E-05_JPRB, 0.17790882E-05_JPRB, 0.17790950E-05_JPRB, &
  & 0.17791069E-05_JPRB, 0.17790940E-05_JPRB, 0.17790787E-05_JPRB, 0.17790605E-05_JPRB, 0.17790388E-05_JPRB, 0.17790303E-05_JPRB, &
  & 0.17790045E-05_JPRB, 0.17789795E-05_JPRB, 0.17789316E-05_JPRB, 0.17788549E-05_JPRB, 0.17787685E-05_JPRB, 0.17786828E-05_JPRB, &
  & 0.17786308E-05_JPRB, 0.17785987E-05_JPRB, 0.17785962E-05_JPRB, 0.17786285E-05_JPRB, 0.17786815E-05_JPRB, 0.17787513E-05_JPRB, &
  & 0.17788120E-05_JPRB, 0.17788747E-05_JPRB, 0.17788999E-05_JPRB, 0.17789121E-05_JPRB, 0.17789246E-05_JPRB, 0.17788908E-05_JPRB, &
  & 0.17788586E-05_JPRB, 0.17787986E-05_JPRB, 0.17787510E-05_JPRB, 0.17786600E-05_JPRB, 0.17785979E-05_JPRB, 0.17785358E-05_JPRB, &
  & 0.17785080E-05_JPRB, 0.17784915E-05_JPRB, 0.17784970E-05_JPRB, 0.17785477E-05_JPRB, 0.17786215E-05_JPRB, 0.17787213E-05_JPRB, &
  & 0.17788560E-05_JPRB, 0.17789794E-05_JPRB, 0.17791160E-05_JPRB, 0.17792471E-05_JPRB, 0.17793717E-05_JPRB, 0.17794298E-05_JPRB, &
  & 0.17794968E-05_JPRB, 0.17795545E-05_JPRB, 0.17795669E-05_JPRB, 0.17795753E-05_JPRB, 0.17796024E-05_JPRB, 0.17795891E-05_JPRB, &
  & 0.17795890E-05_JPRB, 0.17795805E-05_JPRB, 0.17796000E-05_JPRB, 0.17795866E-05_JPRB, 0.17795749E-05_JPRB, 0.17795589E-05_JPRB, &
  & 0.17795522E-05_JPRB, 0.17795212E-05_JPRB, 0.17794687E-05_JPRB, 0.17795063E-05_JPRB /)

RGHG2(:,82, 2) = (/ &
  & 0.17791093E-05_JPRB, 0.17790642E-05_JPRB, 0.17790674E-05_JPRB, 0.17791150E-05_JPRB, 0.17791327E-05_JPRB, 0.17791390E-05_JPRB, &
  & 0.17791515E-05_JPRB, 0.17791409E-05_JPRB, 0.17791219E-05_JPRB, 0.17791101E-05_JPRB, 0.17790842E-05_JPRB, 0.17790798E-05_JPRB, &
  & 0.17790549E-05_JPRB, 0.17790333E-05_JPRB, 0.17789894E-05_JPRB, 0.17789170E-05_JPRB, 0.17788358E-05_JPRB, 0.17787547E-05_JPRB, &
  & 0.17787087E-05_JPRB, 0.17786776E-05_JPRB, 0.17786756E-05_JPRB, 0.17787070E-05_JPRB, 0.17787563E-05_JPRB, 0.17788220E-05_JPRB, &
  & 0.17788788E-05_JPRB, 0.17789384E-05_JPRB, 0.17789616E-05_JPRB, 0.17789727E-05_JPRB, 0.17789871E-05_JPRB, 0.17789536E-05_JPRB, &
  & 0.17789230E-05_JPRB, 0.17788650E-05_JPRB, 0.17788225E-05_JPRB, 0.17787366E-05_JPRB, 0.17786779E-05_JPRB, 0.17786190E-05_JPRB, &
  & 0.17785924E-05_JPRB, 0.17785769E-05_JPRB, 0.17785813E-05_JPRB, 0.17786286E-05_JPRB, 0.17786967E-05_JPRB, 0.17787885E-05_JPRB, &
  & 0.17789162E-05_JPRB, 0.17790302E-05_JPRB, 0.17791598E-05_JPRB, 0.17792851E-05_JPRB, 0.17794040E-05_JPRB, 0.17794576E-05_JPRB, &
  & 0.17795214E-05_JPRB, 0.17795785E-05_JPRB, 0.17795887E-05_JPRB, 0.17795957E-05_JPRB, 0.17796231E-05_JPRB, 0.17796083E-05_JPRB, &
  & 0.17796078E-05_JPRB, 0.17795996E-05_JPRB, 0.17796203E-05_JPRB, 0.17796067E-05_JPRB, 0.17795952E-05_JPRB, 0.17795793E-05_JPRB, &
  & 0.17795732E-05_JPRB, 0.17795420E-05_JPRB, 0.17794886E-05_JPRB, 0.17795228E-05_JPRB /)

RGHG2(:,83, 2) = (/ &
  & 0.17791294E-05_JPRB, 0.17790885E-05_JPRB, 0.17790920E-05_JPRB, 0.17791403E-05_JPRB, 0.17791580E-05_JPRB, 0.17791644E-05_JPRB, &
  & 0.17791771E-05_JPRB, 0.17791638E-05_JPRB, 0.17791498E-05_JPRB, 0.17791320E-05_JPRB, 0.17791131E-05_JPRB, 0.17791067E-05_JPRB, &
  & 0.17790843E-05_JPRB, 0.17790633E-05_JPRB, 0.17790215E-05_JPRB, 0.17789521E-05_JPRB, 0.17788733E-05_JPRB, 0.17787956E-05_JPRB, &
  & 0.17787512E-05_JPRB, 0.17787223E-05_JPRB, 0.17787203E-05_JPRB, 0.17787499E-05_JPRB, 0.17787982E-05_JPRB, 0.17788615E-05_JPRB, &
  & 0.17789156E-05_JPRB, 0.17789746E-05_JPRB, 0.17789960E-05_JPRB, 0.17790064E-05_JPRB, 0.17790221E-05_JPRB, 0.17789883E-05_JPRB, &
  & 0.17789584E-05_JPRB, 0.17789018E-05_JPRB, 0.17788617E-05_JPRB, 0.17787784E-05_JPRB, 0.17787227E-05_JPRB, 0.17786654E-05_JPRB, &
  & 0.17786401E-05_JPRB, 0.17786251E-05_JPRB, 0.17786290E-05_JPRB, 0.17786741E-05_JPRB, 0.17787385E-05_JPRB, 0.17788254E-05_JPRB, &
  & 0.17789486E-05_JPRB, 0.17790587E-05_JPRB, 0.17791846E-05_JPRB, 0.17793059E-05_JPRB, 0.17794235E-05_JPRB, 0.17794728E-05_JPRB, &
  & 0.17795354E-05_JPRB, 0.17795921E-05_JPRB, 0.17796009E-05_JPRB, 0.17796069E-05_JPRB, 0.17796349E-05_JPRB, 0.17796190E-05_JPRB, &
  & 0.17796184E-05_JPRB, 0.17796099E-05_JPRB, 0.17796317E-05_JPRB, 0.17796176E-05_JPRB, 0.17796064E-05_JPRB, 0.17795905E-05_JPRB, &
  & 0.17795849E-05_JPRB, 0.17795534E-05_JPRB, 0.17794999E-05_JPRB, 0.17795344E-05_JPRB /)

RGHG2(:,84, 2) = (/ &
  & 0.17791436E-05_JPRB, 0.17791042E-05_JPRB, 0.17791073E-05_JPRB, 0.17791559E-05_JPRB, 0.17791733E-05_JPRB, 0.17791791E-05_JPRB, &
  & 0.17791917E-05_JPRB, 0.17791813E-05_JPRB, 0.17791617E-05_JPRB, 0.17791510E-05_JPRB, 0.17791274E-05_JPRB, 0.17791237E-05_JPRB, &
  & 0.17791008E-05_JPRB, 0.17790819E-05_JPRB, 0.17790417E-05_JPRB, 0.17789735E-05_JPRB, 0.17788971E-05_JPRB, 0.17788200E-05_JPRB, &
  & 0.17787793E-05_JPRB, 0.17787490E-05_JPRB, 0.17787463E-05_JPRB, 0.17787763E-05_JPRB, 0.17788225E-05_JPRB, 0.17788855E-05_JPRB, &
  & 0.17789386E-05_JPRB, 0.17789964E-05_JPRB, 0.17790164E-05_JPRB, 0.17790269E-05_JPRB, 0.17790438E-05_JPRB, 0.17790097E-05_JPRB, &
  & 0.17789799E-05_JPRB, 0.17789231E-05_JPRB, 0.17788844E-05_JPRB, 0.17788042E-05_JPRB, 0.17787493E-05_JPRB, 0.17786947E-05_JPRB, &
  & 0.17786695E-05_JPRB, 0.17786551E-05_JPRB, 0.17786588E-05_JPRB, 0.17787027E-05_JPRB, 0.17787632E-05_JPRB, 0.17788475E-05_JPRB, &
  & 0.17789682E-05_JPRB, 0.17790758E-05_JPRB, 0.17791996E-05_JPRB, 0.17793194E-05_JPRB, 0.17794349E-05_JPRB, 0.17794820E-05_JPRB, &
  & 0.17795437E-05_JPRB, 0.17796008E-05_JPRB, 0.17796082E-05_JPRB, 0.17796136E-05_JPRB, 0.17796424E-05_JPRB, 0.17796257E-05_JPRB, &
  & 0.17796247E-05_JPRB, 0.17796159E-05_JPRB, 0.17796388E-05_JPRB, 0.17796247E-05_JPRB, 0.17796135E-05_JPRB, 0.17795973E-05_JPRB, &
  & 0.17795921E-05_JPRB, 0.17795605E-05_JPRB, 0.17795069E-05_JPRB, 0.17795428E-05_JPRB /)

RGHG2(:,85, 2) = (/ &
  & 0.17791531E-05_JPRB, 0.17791147E-05_JPRB, 0.17791169E-05_JPRB, 0.17791664E-05_JPRB, 0.17791832E-05_JPRB, 0.17791901E-05_JPRB, &
  & 0.17792004E-05_JPRB, 0.17791863E-05_JPRB, 0.17791729E-05_JPRB, 0.17791566E-05_JPRB, 0.17791410E-05_JPRB, 0.17791331E-05_JPRB, &
  & 0.17791137E-05_JPRB, 0.17790935E-05_JPRB, 0.17790547E-05_JPRB, 0.17789885E-05_JPRB, 0.17789123E-05_JPRB, 0.17788373E-05_JPRB, &
  & 0.17787959E-05_JPRB, 0.17787672E-05_JPRB, 0.17787637E-05_JPRB, 0.17787922E-05_JPRB, 0.17788384E-05_JPRB, 0.17789008E-05_JPRB, &
  & 0.17789527E-05_JPRB, 0.17790110E-05_JPRB, 0.17790296E-05_JPRB, 0.17790396E-05_JPRB, 0.17790578E-05_JPRB, 0.17790226E-05_JPRB, &
  & 0.17789934E-05_JPRB, 0.17789370E-05_JPRB, 0.17788992E-05_JPRB, 0.17788200E-05_JPRB, 0.17787675E-05_JPRB, 0.17787131E-05_JPRB, &
  & 0.17786886E-05_JPRB, 0.17786742E-05_JPRB, 0.17786780E-05_JPRB, 0.17787197E-05_JPRB, 0.17787805E-05_JPRB, 0.17788601E-05_JPRB, &
  & 0.17789823E-05_JPRB, 0.17790867E-05_JPRB, 0.17792102E-05_JPRB, 0.17793278E-05_JPRB, 0.17794434E-05_JPRB, 0.17794880E-05_JPRB, &
  & 0.17795493E-05_JPRB, 0.17796061E-05_JPRB, 0.17796129E-05_JPRB, 0.17796178E-05_JPRB, 0.17796473E-05_JPRB, 0.17796300E-05_JPRB, &
  & 0.17796287E-05_JPRB, 0.17796201E-05_JPRB, 0.17796435E-05_JPRB, 0.17796294E-05_JPRB, 0.17796182E-05_JPRB, 0.17796016E-05_JPRB, &
  & 0.17795968E-05_JPRB, 0.17795650E-05_JPRB, 0.17795113E-05_JPRB, 0.17795484E-05_JPRB /)

RGHG2(:,86, 2) = (/ &
  & 0.17791591E-05_JPRB, 0.17791216E-05_JPRB, 0.17791226E-05_JPRB, 0.17791729E-05_JPRB, 0.17791899E-05_JPRB, 0.17791947E-05_JPRB, &
  & 0.17792022E-05_JPRB, 0.17791915E-05_JPRB, 0.17791746E-05_JPRB, 0.17791633E-05_JPRB, 0.17791473E-05_JPRB, 0.17791390E-05_JPRB, &
  & 0.17791206E-05_JPRB, 0.17791003E-05_JPRB, 0.17790629E-05_JPRB, 0.17789994E-05_JPRB, 0.17789238E-05_JPRB, 0.17788485E-05_JPRB, &
  & 0.17788086E-05_JPRB, 0.17787778E-05_JPRB, 0.17787738E-05_JPRB, 0.17788027E-05_JPRB, 0.17788478E-05_JPRB, 0.17789105E-05_JPRB, &
  & 0.17789623E-05_JPRB, 0.17790204E-05_JPRB, 0.17790381E-05_JPRB, 0.17790481E-05_JPRB, 0.17790668E-05_JPRB, 0.17790309E-05_JPRB, &
  & 0.17790019E-05_JPRB, 0.17789453E-05_JPRB, 0.17789084E-05_JPRB, 0.17788312E-05_JPRB, 0.17787779E-05_JPRB, 0.17787254E-05_JPRB, &
  & 0.17786999E-05_JPRB, 0.17786857E-05_JPRB, 0.17786886E-05_JPRB, 0.17787322E-05_JPRB, 0.17787888E-05_JPRB, 0.17788710E-05_JPRB, &
  & 0.17789901E-05_JPRB, 0.17790945E-05_JPRB, 0.17792165E-05_JPRB, 0.17793334E-05_JPRB, 0.17794484E-05_JPRB, 0.17794919E-05_JPRB, &
  & 0.17795525E-05_JPRB, 0.17796094E-05_JPRB, 0.17796160E-05_JPRB, 0.17796202E-05_JPRB, 0.17796506E-05_JPRB, 0.17796327E-05_JPRB, &
  & 0.17796312E-05_JPRB, 0.17796223E-05_JPRB, 0.17796465E-05_JPRB, 0.17796325E-05_JPRB, 0.17796212E-05_JPRB, 0.17796044E-05_JPRB, &
  & 0.17795999E-05_JPRB, 0.17795679E-05_JPRB, 0.17795140E-05_JPRB, 0.17795519E-05_JPRB /)

RGHG2(:,87, 2) = (/ &
  & 0.17791624E-05_JPRB, 0.17791256E-05_JPRB, 0.17791258E-05_JPRB, 0.17791776E-05_JPRB, 0.17791932E-05_JPRB, 0.17791992E-05_JPRB, &
  & 0.17792036E-05_JPRB, 0.17791897E-05_JPRB, 0.17791776E-05_JPRB, 0.17791646E-05_JPRB, 0.17791518E-05_JPRB, 0.17791422E-05_JPRB, &
  & 0.17791249E-05_JPRB, 0.17791044E-05_JPRB, 0.17790680E-05_JPRB, 0.17790062E-05_JPRB, 0.17789321E-05_JPRB, 0.17788570E-05_JPRB, &
  & 0.17788157E-05_JPRB, 0.17787848E-05_JPRB, 0.17787800E-05_JPRB, 0.17788082E-05_JPRB, 0.17788535E-05_JPRB, 0.17789167E-05_JPRB, &
  & 0.17789675E-05_JPRB, 0.17790269E-05_JPRB, 0.17790435E-05_JPRB, 0.17790529E-05_JPRB, 0.17790726E-05_JPRB, 0.17790362E-05_JPRB, &
  & 0.17790069E-05_JPRB, 0.17789505E-05_JPRB, 0.17789151E-05_JPRB, 0.17788371E-05_JPRB, 0.17787866E-05_JPRB, 0.17787307E-05_JPRB, &
  & 0.17787065E-05_JPRB, 0.17786916E-05_JPRB, 0.17786940E-05_JPRB, 0.17787370E-05_JPRB, 0.17787972E-05_JPRB, 0.17788741E-05_JPRB, &
  & 0.17789982E-05_JPRB, 0.17790990E-05_JPRB, 0.17792212E-05_JPRB, 0.17793373E-05_JPRB, 0.17794517E-05_JPRB, 0.17794939E-05_JPRB, &
  & 0.17795544E-05_JPRB, 0.17796119E-05_JPRB, 0.17796182E-05_JPRB, 0.17796217E-05_JPRB, 0.17796524E-05_JPRB, 0.17796340E-05_JPRB, &
  & 0.17796328E-05_JPRB, 0.17796235E-05_JPRB, 0.17796482E-05_JPRB, 0.17796343E-05_JPRB, 0.17796229E-05_JPRB, 0.17796061E-05_JPRB, &
  & 0.17796017E-05_JPRB, 0.17795694E-05_JPRB, 0.17795153E-05_JPRB, 0.17795542E-05_JPRB /)

RGHG2(:,88, 2) = (/ &
  & 0.17791639E-05_JPRB, 0.17791284E-05_JPRB, 0.17791281E-05_JPRB, 0.17791791E-05_JPRB, 0.17791964E-05_JPRB, 0.17791999E-05_JPRB, &
  & 0.17792036E-05_JPRB, 0.17791929E-05_JPRB, 0.17791779E-05_JPRB, 0.17791668E-05_JPRB, 0.17791535E-05_JPRB, 0.17791440E-05_JPRB, &
  & 0.17791272E-05_JPRB, 0.17791065E-05_JPRB, 0.17790708E-05_JPRB, 0.17790110E-05_JPRB, 0.17789358E-05_JPRB, 0.17788618E-05_JPRB, &
  & 0.17788204E-05_JPRB, 0.17787887E-05_JPRB, 0.17787834E-05_JPRB, 0.17788115E-05_JPRB, 0.17788565E-05_JPRB, 0.17789203E-05_JPRB, &
  & 0.17789710E-05_JPRB, 0.17790311E-05_JPRB, 0.17790468E-05_JPRB, 0.17790559E-05_JPRB, 0.17790760E-05_JPRB, 0.17790392E-05_JPRB, &
  & 0.17790103E-05_JPRB, 0.17789539E-05_JPRB, 0.17789196E-05_JPRB, 0.17788424E-05_JPRB, 0.17787893E-05_JPRB, 0.17787345E-05_JPRB, &
  & 0.17787094E-05_JPRB, 0.17786946E-05_JPRB, 0.17786953E-05_JPRB, 0.17787418E-05_JPRB, 0.17787992E-05_JPRB, 0.17788792E-05_JPRB, &
  & 0.17790019E-05_JPRB, 0.17791025E-05_JPRB, 0.17792238E-05_JPRB, 0.17793387E-05_JPRB, 0.17794537E-05_JPRB, 0.17794951E-05_JPRB, &
  & 0.17795553E-05_JPRB, 0.17796131E-05_JPRB, 0.17796194E-05_JPRB, 0.17796226E-05_JPRB, 0.17796535E-05_JPRB, 0.17796348E-05_JPRB, &
  & 0.17796339E-05_JPRB, 0.17796242E-05_JPRB, 0.17796492E-05_JPRB, 0.17796353E-05_JPRB, 0.17796240E-05_JPRB, 0.17796065E-05_JPRB, &
  & 0.17796026E-05_JPRB, 0.17795702E-05_JPRB, 0.17795161E-05_JPRB, 0.17795556E-05_JPRB /)

RGHG2(:,89, 2) = (/ &
  & 0.17791638E-05_JPRB, 0.17791301E-05_JPRB, 0.17791291E-05_JPRB, 0.17791812E-05_JPRB, 0.17791971E-05_JPRB, 0.17792031E-05_JPRB, &
  & 0.17792077E-05_JPRB, 0.17791930E-05_JPRB, 0.17791808E-05_JPRB, 0.17791680E-05_JPRB, 0.17791549E-05_JPRB, 0.17791457E-05_JPRB, &
  & 0.17791286E-05_JPRB, 0.17791085E-05_JPRB, 0.17790725E-05_JPRB, 0.17790114E-05_JPRB, 0.17789374E-05_JPRB, 0.17788623E-05_JPRB, &
  & 0.17788223E-05_JPRB, 0.17787903E-05_JPRB, 0.17787846E-05_JPRB, 0.17788126E-05_JPRB, 0.17788578E-05_JPRB, 0.17789224E-05_JPRB, &
  & 0.17789723E-05_JPRB, 0.17790334E-05_JPRB, 0.17790485E-05_JPRB, 0.17790574E-05_JPRB, 0.17790785E-05_JPRB, 0.17790405E-05_JPRB, &
  & 0.17790127E-05_JPRB, 0.17789557E-05_JPRB, 0.17789237E-05_JPRB, 0.17788436E-05_JPRB, 0.17787928E-05_JPRB, 0.17787340E-05_JPRB, &
  & 0.17787106E-05_JPRB, 0.17786956E-05_JPRB, 0.17786956E-05_JPRB, 0.17787429E-05_JPRB, 0.17788020E-05_JPRB, 0.17788797E-05_JPRB, &
  & 0.17790053E-05_JPRB, 0.17791044E-05_JPRB, 0.17792256E-05_JPRB, 0.17793402E-05_JPRB, 0.17794557E-05_JPRB, 0.17794955E-05_JPRB, &
  & 0.17795558E-05_JPRB, 0.17796142E-05_JPRB, 0.17796201E-05_JPRB, 0.17796228E-05_JPRB, 0.17796547E-05_JPRB, 0.17796352E-05_JPRB, &
  & 0.17796347E-05_JPRB, 0.17796247E-05_JPRB, 0.17796500E-05_JPRB, 0.17796362E-05_JPRB, 0.17796249E-05_JPRB, 0.17796068E-05_JPRB, &
  & 0.17796035E-05_JPRB, 0.17795710E-05_JPRB, 0.17795157E-05_JPRB, 0.17795564E-05_JPRB /)

RGHG2(:,90, 2) = (/ &
  & 0.17791621E-05_JPRB, 0.17791310E-05_JPRB, 0.17791282E-05_JPRB, 0.17791816E-05_JPRB, 0.17791984E-05_JPRB, 0.17792026E-05_JPRB, &
  & 0.17792124E-05_JPRB, 0.17791999E-05_JPRB, 0.17791826E-05_JPRB, 0.17791706E-05_JPRB, 0.17791549E-05_JPRB, 0.17791474E-05_JPRB, &
  & 0.17791293E-05_JPRB, 0.17791103E-05_JPRB, 0.17790737E-05_JPRB, 0.17790112E-05_JPRB, 0.17789348E-05_JPRB, 0.17788601E-05_JPRB, &
  & 0.17788223E-05_JPRB, 0.17787900E-05_JPRB, 0.17787844E-05_JPRB, 0.17788130E-05_JPRB, 0.17788578E-05_JPRB, 0.17789233E-05_JPRB, &
  & 0.17789724E-05_JPRB, 0.17790354E-05_JPRB, 0.17790494E-05_JPRB, 0.17790574E-05_JPRB, 0.17790810E-05_JPRB, 0.17790413E-05_JPRB, &
  & 0.17790151E-05_JPRB, 0.17789563E-05_JPRB, 0.17789274E-05_JPRB, 0.17788435E-05_JPRB, 0.17787934E-05_JPRB, 0.17787322E-05_JPRB, &
  & 0.17787100E-05_JPRB, 0.17786955E-05_JPRB, 0.17786944E-05_JPRB, 0.17787439E-05_JPRB, 0.17788018E-05_JPRB, 0.17788793E-05_JPRB, &
  & 0.17790072E-05_JPRB, 0.17791051E-05_JPRB, 0.17792265E-05_JPRB, 0.17793407E-05_JPRB, 0.17794582E-05_JPRB, 0.17794956E-05_JPRB, &
  & 0.17795564E-05_JPRB, 0.17796162E-05_JPRB, 0.17796207E-05_JPRB, 0.17796224E-05_JPRB, 0.17796564E-05_JPRB, 0.17796350E-05_JPRB, &
  & 0.17796350E-05_JPRB, 0.17796241E-05_JPRB, 0.17796514E-05_JPRB, 0.17796366E-05_JPRB, 0.17796254E-05_JPRB, 0.17796064E-05_JPRB, &
  & 0.17796043E-05_JPRB, 0.17795712E-05_JPRB, 0.17795146E-05_JPRB, 0.17795572E-05_JPRB /)

RGHG2(:,91, 2) = (/ &
  & 0.17791588E-05_JPRB, 0.17791325E-05_JPRB, 0.17791225E-05_JPRB, 0.17791846E-05_JPRB, 0.17791991E-05_JPRB, 0.17792020E-05_JPRB, &
  & 0.17792233E-05_JPRB, 0.17792065E-05_JPRB, 0.17791861E-05_JPRB, 0.17791751E-05_JPRB, 0.17791475E-05_JPRB, 0.17791541E-05_JPRB, &
  & 0.17791266E-05_JPRB, 0.17791136E-05_JPRB, 0.17790767E-05_JPRB, 0.17790097E-05_JPRB, 0.17789326E-05_JPRB, 0.17788551E-05_JPRB, &
  & 0.17788213E-05_JPRB, 0.17787883E-05_JPRB, 0.17787822E-05_JPRB, 0.17788120E-05_JPRB, 0.17788569E-05_JPRB, 0.17789246E-05_JPRB, &
  & 0.17789720E-05_JPRB, 0.17790388E-05_JPRB, 0.17790501E-05_JPRB, 0.17790566E-05_JPRB, 0.17790867E-05_JPRB, 0.17790411E-05_JPRB, &
  & 0.17790180E-05_JPRB, 0.17789545E-05_JPRB, 0.17789353E-05_JPRB, 0.17788389E-05_JPRB, 0.17787959E-05_JPRB, 0.17787266E-05_JPRB, &
  & 0.17787091E-05_JPRB, 0.17786946E-05_JPRB, 0.17786912E-05_JPRB, 0.17787432E-05_JPRB, 0.17788009E-05_JPRB, 0.17788761E-05_JPRB, &
  & 0.17790097E-05_JPRB, 0.17791040E-05_JPRB, 0.17792275E-05_JPRB, 0.17793411E-05_JPRB, 0.17794642E-05_JPRB, 0.17794941E-05_JPRB, &
  & 0.17795568E-05_JPRB, 0.17796203E-05_JPRB, 0.17796210E-05_JPRB, 0.17796203E-05_JPRB, 0.17796602E-05_JPRB, 0.17796335E-05_JPRB, &
  & 0.17796360E-05_JPRB, 0.17796218E-05_JPRB, 0.17796546E-05_JPRB, 0.17796366E-05_JPRB, 0.17796258E-05_JPRB, 0.17796054E-05_JPRB, &
  & 0.17796059E-05_JPRB, 0.17795708E-05_JPRB, 0.17795103E-05_JPRB, 0.17795581E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART4',1,ZHOOK_HANDLE)
END SUBROUTINE PART4






SUBROUTINE PART5
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART5',0,ZHOOK_HANDLE)



!-- Month=  3 ------------

RGHG2(:, 1, 3) = (/ &
  & 0.87840206E-08_JPRB, 0.87286045E-08_JPRB, 0.86841236E-08_JPRB, 0.86485255E-08_JPRB, 0.86779632E-08_JPRB, 0.88267749E-08_JPRB, &
  & 0.91265839E-08_JPRB, 0.95717887E-08_JPRB, 0.10127506E-07_JPRB, 0.10752236E-07_JPRB, 0.11404534E-07_JPRB, 0.12050987E-07_JPRB, &
  & 0.12631862E-07_JPRB, 0.13084660E-07_JPRB, 0.13310329E-07_JPRB, 0.13300308E-07_JPRB, 0.12929396E-07_JPRB, 0.12376002E-07_JPRB, &
  & 0.11689168E-07_JPRB, 0.10952306E-07_JPRB, 0.10228049E-07_JPRB, 0.95352144E-08_JPRB, 0.88626351E-08_JPRB, 0.81384979E-08_JPRB, &
  & 0.72077926E-08_JPRB, 0.57512728E-08_JPRB, 0.44447583E-08_JPRB, 0.38500514E-08_JPRB, 0.36586638E-08_JPRB, 0.37003594E-08_JPRB, &
  & 0.39275831E-08_JPRB, 0.43724859E-08_JPRB, 0.50643139E-08_JPRB, 0.58035763E-08_JPRB, 0.65376398E-08_JPRB, 0.74422761E-08_JPRB, &
  & 0.85191427E-08_JPRB, 0.97401696E-08_JPRB, 0.10707221E-07_JPRB, 0.11252411E-07_JPRB, 0.11454638E-07_JPRB, 0.11428209E-07_JPRB, &
  & 0.11228014E-07_JPRB, 0.10878947E-07_JPRB, 0.10400646E-07_JPRB, 0.98061417E-08_JPRB, 0.90837320E-08_JPRB, 0.82322380E-08_JPRB, &
  & 0.72892798E-08_JPRB, 0.63281922E-08_JPRB, 0.54457638E-08_JPRB, 0.47273714E-08_JPRB, 0.42237400E-08_JPRB, 0.39335180E-08_JPRB, &
  & 0.38092685E-08_JPRB, 0.37905590E-08_JPRB, 0.38290580E-08_JPRB, 0.38943822E-08_JPRB, 0.39687462E-08_JPRB, 0.40403929E-08_JPRB, &
  & 0.41090411E-08_JPRB, 0.41716759E-08_JPRB, 0.42168082E-08_JPRB, 0.42406914E-08_JPRB /)

RGHG2(:, 2, 3) = (/ &
  & 0.11652607E-07_JPRB, 0.13100862E-07_JPRB, 0.13964462E-07_JPRB, 0.14657513E-07_JPRB, 0.15295509E-07_JPRB, 0.15951743E-07_JPRB, &
  & 0.16695580E-07_JPRB, 0.17629766E-07_JPRB, 0.18831884E-07_JPRB, 0.20282545E-07_JPRB, 0.21870349E-07_JPRB, 0.23464539E-07_JPRB, &
  & 0.24940213E-07_JPRB, 0.26163519E-07_JPRB, 0.26977036E-07_JPRB, 0.27235515E-07_JPRB, 0.26905767E-07_JPRB, 0.26043811E-07_JPRB, &
  & 0.24819700E-07_JPRB, 0.23418018E-07_JPRB, 0.21958767E-07_JPRB, 0.20455948E-07_JPRB, 0.18893555E-07_JPRB, 0.17322748E-07_JPRB, &
  & 0.15829993E-07_JPRB, 0.14247300E-07_JPRB, 0.12898908E-07_JPRB, 0.12069052E-07_JPRB, 0.11747163E-07_JPRB, 0.11809886E-07_JPRB, &
  & 0.12206468E-07_JPRB, 0.12971103E-07_JPRB, 0.14216692E-07_JPRB, 0.16078408E-07_JPRB, 0.18480353E-07_JPRB, 0.21257724E-07_JPRB, &
  & 0.24143073E-07_JPRB, 0.26894259E-07_JPRB, 0.29030861E-07_JPRB, 0.30326625E-07_JPRB, 0.30788385E-07_JPRB, 0.30554382E-07_JPRB, &
  & 0.29733753E-07_JPRB, 0.28403615E-07_JPRB, 0.26630406E-07_JPRB, 0.24494526E-07_JPRB, 0.22097478E-07_JPRB, 0.19571303E-07_JPRB, &
  & 0.17112763E-07_JPRB, 0.14913072E-07_JPRB, 0.13037718E-07_JPRB, 0.11438645E-07_JPRB, 0.10072595E-07_JPRB, 0.89464276E-08_JPRB, &
  & 0.80695202E-08_JPRB, 0.74245206E-08_JPRB, 0.69753896E-08_JPRB, 0.66807520E-08_JPRB, 0.64995485E-08_JPRB, 0.63928067E-08_JPRB, &
  & 0.63294188E-08_JPRB, 0.62901027E-08_JPRB, 0.62542407E-08_JPRB, 0.62016761E-08_JPRB /)

RGHG2(:, 3, 3) = (/ &
  & 0.14377187E-07_JPRB, 0.16187350E-07_JPRB, 0.17322643E-07_JPRB, 0.18477744E-07_JPRB, 0.19873349E-07_JPRB, 0.21666411E-07_JPRB, &
  & 0.23841658E-07_JPRB, 0.26171309E-07_JPRB, 0.28436190E-07_JPRB, 0.30555469E-07_JPRB, 0.32543635E-07_JPRB, 0.34394649E-07_JPRB, &
  & 0.36068005E-07_JPRB, 0.37490295E-07_JPRB, 0.38559556E-07_JPRB, 0.39165172E-07_JPRB, 0.39217674E-07_JPRB, 0.38706453E-07_JPRB, &
  & 0.37700712E-07_JPRB, 0.36302978E-07_JPRB, 0.34641786E-07_JPRB, 0.32866200E-07_JPRB, 0.31093808E-07_JPRB, 0.29358645E-07_JPRB, &
  & 0.27770703E-07_JPRB, 0.26736076E-07_JPRB, 0.26409523E-07_JPRB, 0.26657240E-07_JPRB, 0.27324706E-07_JPRB, 0.28286284E-07_JPRB, &
  & 0.29491860E-07_JPRB, 0.31031217E-07_JPRB, 0.33020957E-07_JPRB, 0.35461792E-07_JPRB, 0.38309835E-07_JPRB, 0.41328757E-07_JPRB, &
  & 0.44451188E-07_JPRB, 0.47427847E-07_JPRB, 0.49929579E-07_JPRB, 0.51487756E-07_JPRB, 0.51901818E-07_JPRB, 0.51217690E-07_JPRB, &
  & 0.49578112E-07_JPRB, 0.47157734E-07_JPRB, 0.44147143E-07_JPRB, 0.40724935E-07_JPRB, 0.37060357E-07_JPRB, 0.33313739E-07_JPRB, &
  & 0.29637196E-07_JPRB, 0.26112581E-07_JPRB, 0.22805828E-07_JPRB, 0.19864656E-07_JPRB, 0.17421822E-07_JPRB, 0.15485515E-07_JPRB, &
  & 0.13977653E-07_JPRB, 0.12813484E-07_JPRB, 0.11926336E-07_JPRB, 0.11265724E-07_JPRB, 0.10783378E-07_JPRB, 0.10434493E-07_JPRB, &
  & 0.10177806E-07_JPRB, 0.99818580E-08_JPRB, 0.98263602E-08_JPRB, 0.96479296E-08_JPRB /)

RGHG2(:, 4, 3) = (/ &
  & 0.17622121E-07_JPRB, 0.20718673E-07_JPRB, 0.22905688E-07_JPRB, 0.24972300E-07_JPRB, 0.26986243E-07_JPRB, 0.28920006E-07_JPRB, &
  & 0.30835785E-07_JPRB, 0.32844419E-07_JPRB, 0.34914464E-07_JPRB, 0.36974935E-07_JPRB, 0.38963094E-07_JPRB, 0.40846299E-07_JPRB, &
  & 0.42603343E-07_JPRB, 0.44205862E-07_JPRB, 0.45624347E-07_JPRB, 0.46812250E-07_JPRB, 0.47721294E-07_JPRB, 0.48300670E-07_JPRB, &
  & 0.48545743E-07_JPRB, 0.48549460E-07_JPRB, 0.48451188E-07_JPRB, 0.48365660E-07_JPRB, 0.48429300E-07_JPRB, 0.48819931E-07_JPRB, &
  & 0.49634789E-07_JPRB, 0.50807074E-07_JPRB, 0.52156551E-07_JPRB, 0.53545204E-07_JPRB, 0.54884445E-07_JPRB, 0.56069489E-07_JPRB, &
  & 0.57016941E-07_JPRB, 0.57883170E-07_JPRB, 0.58947897E-07_JPRB, 0.60468331E-07_JPRB, 0.62516570E-07_JPRB, 0.65055289E-07_JPRB, &
  & 0.67836183E-07_JPRB, 0.70606475E-07_JPRB, 0.72937098E-07_JPRB, 0.74278695E-07_JPRB, 0.74076148E-07_JPRB, 0.72114489E-07_JPRB, &
  & 0.68644177E-07_JPRB, 0.64189685E-07_JPRB, 0.59305375E-07_JPRB, 0.54384824E-07_JPRB, 0.49607934E-07_JPRB, 0.45060851E-07_JPRB, &
  & 0.40787672E-07_JPRB, 0.36795605E-07_JPRB, 0.33148943E-07_JPRB, 0.29895563E-07_JPRB, 0.27000079E-07_JPRB, 0.24422596E-07_JPRB, &
  & 0.22167120E-07_JPRB, 0.20250052E-07_JPRB, 0.18670200E-07_JPRB, 0.17405828E-07_JPRB, 0.16437113E-07_JPRB, 0.15713793E-07_JPRB, &
  & 0.15185321E-07_JPRB, 0.14795365E-07_JPRB, 0.14472262E-07_JPRB, 0.14072529E-07_JPRB /)

RGHG2(:, 5, 3) = (/ &
  & 0.21992490E-07_JPRB, 0.26205456E-07_JPRB, 0.28268236E-07_JPRB, 0.29872716E-07_JPRB, 0.31469828E-07_JPRB, 0.33181621E-07_JPRB, &
  & 0.34969041E-07_JPRB, 0.36801350E-07_JPRB, 0.38712681E-07_JPRB, 0.40692132E-07_JPRB, 0.42719364E-07_JPRB, 0.44774865E-07_JPRB, &
  & 0.46833019E-07_JPRB, 0.48874771E-07_JPRB, 0.50892979E-07_JPRB, 0.52917052E-07_JPRB, 0.54963326E-07_JPRB, 0.57055942E-07_JPRB, &
  & 0.59226181E-07_JPRB, 0.61522158E-07_JPRB, 0.64039000E-07_JPRB, 0.66910133E-07_JPRB, 0.70234393E-07_JPRB, 0.73954482E-07_JPRB, &
  & 0.77870567E-07_JPRB, 0.81722348E-07_JPRB, 0.85338229E-07_JPRB, 0.88588834E-07_JPRB, 0.91305353E-07_JPRB, 0.93308515E-07_JPRB, &
  & 0.94549826E-07_JPRB, 0.95085788E-07_JPRB, 0.95339708E-07_JPRB, 0.95836839E-07_JPRB, 0.96897772E-07_JPRB, 0.98557649E-07_JPRB, &
  & 0.10059637E-06_JPRB, 0.10255064E-06_JPRB, 0.10377321E-06_JPRB, 0.10345123E-06_JPRB, 0.10085187E-06_JPRB, 0.95832966E-07_JPRB, &
  & 0.89051639E-07_JPRB, 0.81698062E-07_JPRB, 0.74601047E-07_JPRB, 0.68116428E-07_JPRB, 0.62286219E-07_JPRB, 0.57039777E-07_JPRB, &
  & 0.52307893E-07_JPRB, 0.48025036E-07_JPRB, 0.44128232E-07_JPRB, 0.40548908E-07_JPRB, 0.37260495E-07_JPRB, 0.34281012E-07_JPRB, &
  & 0.31612963E-07_JPRB, 0.29239217E-07_JPRB, 0.27154746E-07_JPRB, 0.25377808E-07_JPRB, 0.23914497E-07_JPRB, 0.22752175E-07_JPRB, &
  & 0.21840506E-07_JPRB, 0.21106208E-07_JPRB, 0.20476687E-07_JPRB, 0.19626343E-07_JPRB /)

RGHG2(:, 6, 3) = (/ &
  & 0.26458435E-07_JPRB, 0.29451984E-07_JPRB, 0.30853201E-07_JPRB, 0.32147064E-07_JPRB, 0.33591959E-07_JPRB, 0.35277480E-07_JPRB, &
  & 0.37214274E-07_JPRB, 0.39343131E-07_JPRB, 0.41598184E-07_JPRB, 0.43991790E-07_JPRB, 0.46515908E-07_JPRB, 0.49099718E-07_JPRB, &
  & 0.51710671E-07_JPRB, 0.54338805E-07_JPRB, 0.57025307E-07_JPRB, 0.59821346E-07_JPRB, 0.62828569E-07_JPRB, 0.66166244E-07_JPRB, &
  & 0.69962368E-07_JPRB, 0.74374661E-07_JPRB, 0.79542239E-07_JPRB, 0.85577717E-07_JPRB, 0.92428252E-07_JPRB, 0.99787869E-07_JPRB, &
  & 0.10722523E-06_JPRB, 0.11433528E-06_JPRB, 0.12101907E-06_JPRB, 0.12716146E-06_JPRB, 0.13258312E-06_JPRB, 0.13708321E-06_JPRB, &
  & 0.14046587E-06_JPRB, 0.14255630E-06_JPRB, 0.14355021E-06_JPRB, 0.14394189E-06_JPRB, 0.14410740E-06_JPRB, 0.14417270E-06_JPRB, &
  & 0.14399072E-06_JPRB, 0.14315016E-06_JPRB, 0.14100206E-06_JPRB, 0.13674963E-06_JPRB, 0.12987402E-06_JPRB, 0.12069029E-06_JPRB, &
  & 0.11065408E-06_JPRB, 0.10102367E-06_JPRB, 0.92411518E-07_JPRB, 0.84849503E-07_JPRB, 0.78204465E-07_JPRB, 0.72283484E-07_JPRB, &
  & 0.66942924E-07_JPRB, 0.62058341E-07_JPRB, 0.57552384E-07_JPRB, 0.53394757E-07_JPRB, 0.49582553E-07_JPRB, 0.46093746E-07_JPRB, &
  & 0.42908997E-07_JPRB, 0.40042650E-07_JPRB, 0.37516802E-07_JPRB, 0.35337887E-07_JPRB, 0.33513896E-07_JPRB, 0.32026847E-07_JPRB, &
  & 0.30830755E-07_JPRB, 0.29853862E-07_JPRB, 0.28912748E-07_JPRB, 0.27630403E-07_JPRB /)

RGHG2(:, 7, 3) = (/ &
  & 0.29333203E-07_JPRB, 0.30959718E-07_JPRB, 0.32189629E-07_JPRB, 0.33682674E-07_JPRB, 0.35542705E-07_JPRB, 0.37796550E-07_JPRB, &
  & 0.40415411E-07_JPRB, 0.43352610E-07_JPRB, 0.46548770E-07_JPRB, 0.49942336E-07_JPRB, 0.53460436E-07_JPRB, 0.57020497E-07_JPRB, &
  & 0.60595092E-07_JPRB, 0.64113308E-07_JPRB, 0.67584224E-07_JPRB, 0.71091669E-07_JPRB, 0.74795651E-07_JPRB, 0.78901650E-07_JPRB, &
  & 0.83632315E-07_JPRB, 0.89220286E-07_JPRB, 0.95881987E-07_JPRB, 0.10378677E-06_JPRB, 0.11298039E-06_JPRB, 0.12322774E-06_JPRB, &
  & 0.13384327E-06_JPRB, 0.14444035E-06_JPRB, 0.15457617E-06_JPRB, 0.16419901E-06_JPRB, 0.17304475E-06_JPRB, 0.18081144E-06_JPRB, &
  & 0.18701179E-06_JPRB, 0.19133348E-06_JPRB, 0.19366300E-06_JPRB, 0.19425913E-06_JPRB, 0.19342845E-06_JPRB, 0.19139554E-06_JPRB, &
  & 0.18812761E-06_JPRB, 0.18333866E-06_JPRB, 0.17657898E-06_JPRB, 0.16743438E-06_JPRB, 0.15589089E-06_JPRB, 0.14309140E-06_JPRB, &
  & 0.13061147E-06_JPRB, 0.11950326E-06_JPRB, 0.10999506E-06_JPRB, 0.10194103E-06_JPRB, 0.95038629E-07_JPRB, 0.88873037E-07_JPRB, &
  & 0.83209571E-07_JPRB, 0.77919694E-07_JPRB, 0.72944225E-07_JPRB, 0.68259439E-07_JPRB, 0.63851722E-07_JPRB, 0.59742895E-07_JPRB, &
  & 0.55979068E-07_JPRB, 0.52590490E-07_JPRB, 0.49588227E-07_JPRB, 0.46988816E-07_JPRB, 0.44806583E-07_JPRB, 0.43028869E-07_JPRB, &
  & 0.41601083E-07_JPRB, 0.40398355E-07_JPRB, 0.39305270E-07_JPRB, 0.37629025E-07_JPRB /)

RGHG2(:, 8, 3) = (/ &
  & 0.30932416E-07_JPRB, 0.32893858E-07_JPRB, 0.34781021E-07_JPRB, 0.37024698E-07_JPRB, 0.39795182E-07_JPRB, 0.43152461E-07_JPRB, &
  & 0.47078419E-07_JPRB, 0.51497889E-07_JPRB, 0.56359568E-07_JPRB, 0.61586775E-07_JPRB, 0.67057385E-07_JPRB, 0.72614114E-07_JPRB, &
  & 0.78092334E-07_JPRB, 0.83312337E-07_JPRB, 0.88249685E-07_JPRB, 0.92971504E-07_JPRB, 0.97652674E-07_JPRB, 0.10254448E-06_JPRB, &
  & 0.10796346E-06_JPRB, 0.11424397E-06_JPRB, 0.12169983E-06_JPRB, 0.13059386E-06_JPRB, 0.14107336E-06_JPRB, 0.15289062E-06_JPRB, &
  & 0.16574802E-06_JPRB, 0.17876124E-06_JPRB, 0.19167547E-06_JPRB, 0.20397157E-06_JPRB, 0.21539445E-06_JPRB, 0.22539581E-06_JPRB, &
  & 0.23338067E-06_JPRB, 0.23869617E-06_JPRB, 0.24109227E-06_JPRB, 0.24070238E-06_JPRB, 0.23785691E-06_JPRB, 0.23289672E-06_JPRB, &
  & 0.22596282E-06_JPRB, 0.21700477E-06_JPRB, 0.20580615E-06_JPRB, 0.19230278E-06_JPRB, 0.17699469E-06_JPRB, 0.16123775E-06_JPRB, &
  & 0.14675015E-06_JPRB, 0.13462140E-06_JPRB, 0.12484961E-06_JPRB, 0.11684705E-06_JPRB, 0.10988875E-06_JPRB, 0.10364696E-06_JPRB, &
  & 0.97900731E-07_JPRB, 0.92490254E-07_JPRB, 0.87339004E-07_JPRB, 0.82407645E-07_JPRB, 0.77713395E-07_JPRB, 0.73301621E-07_JPRB, &
  & 0.69204660E-07_JPRB, 0.65464121E-07_JPRB, 0.62124997E-07_JPRB, 0.59224575E-07_JPRB, 0.56782763E-07_JPRB, 0.54792967E-07_JPRB, &
  & 0.53190533E-07_JPRB, 0.51877954E-07_JPRB, 0.50590714E-07_JPRB, 0.48789481E-07_JPRB /)

RGHG2(:, 9, 3) = (/ &
  & 0.33480326E-07_JPRB, 0.37370558E-07_JPRB, 0.40604906E-07_JPRB, 0.44264503E-07_JPRB, 0.48651795E-07_JPRB, 0.53913805E-07_JPRB, &
  & 0.60086329E-07_JPRB, 0.67155291E-07_JPRB, 0.75032929E-07_JPRB, 0.83539263E-07_JPRB, 0.92486260E-07_JPRB, 0.10167958E-06_JPRB, &
  & 0.11083637E-06_JPRB, 0.11958201E-06_JPRB, 0.12780504E-06_JPRB, 0.13548411E-06_JPRB, 0.14267908E-06_JPRB, 0.14958933E-06_JPRB, &
  & 0.15656647E-06_JPRB, 0.16401289E-06_JPRB, 0.17233212E-06_JPRB, 0.18178528E-06_JPRB, 0.19243605E-06_JPRB, 0.20423334E-06_JPRB, &
  & 0.21670743E-06_JPRB, 0.22955523E-06_JPRB, 0.24227862E-06_JPRB, 0.25467287E-06_JPRB, 0.26618503E-06_JPRB, 0.27610892E-06_JPRB, &
  & 0.28352136E-06_JPRB, 0.28762594E-06_JPRB, 0.28789921E-06_JPRB, 0.28442719E-06_JPRB, 0.27770773E-06_JPRB, 0.26833479E-06_JPRB, &
  & 0.25681948E-06_JPRB, 0.24342276E-06_JPRB, 0.22838816E-06_JPRB, 0.21180443E-06_JPRB, 0.19413891E-06_JPRB, 0.17672339E-06_JPRB, &
  & 0.16124106E-06_JPRB, 0.14825015E-06_JPRB, 0.13757735E-06_JPRB, 0.12864392E-06_JPRB, 0.12115788E-06_JPRB, 0.11473292E-06_JPRB, &
  & 0.10896130E-06_JPRB, 0.10361040E-06_JPRB, 0.98541079E-07_JPRB, 0.93695121E-07_JPRB, 0.89063427E-07_JPRB, 0.84663753E-07_JPRB, &
  & 0.80552574E-07_JPRB, 0.76786854E-07_JPRB, 0.73413837E-07_JPRB, 0.70472062E-07_JPRB, 0.68006713E-07_JPRB, 0.66013030E-07_JPRB, &
  & 0.64434694E-07_JPRB, 0.63104622E-07_JPRB, 0.61874005E-07_JPRB, 0.59955575E-07_JPRB /)

RGHG2(:,10, 3) = (/ &
  & 0.39698900E-07_JPRB, 0.46993776E-07_JPRB, 0.52629559E-07_JPRB, 0.58585691E-07_JPRB, 0.65524993E-07_JPRB, 0.73704165E-07_JPRB, &
  & 0.83241531E-07_JPRB, 0.94091874E-07_JPRB, 0.10619668E-06_JPRB, 0.11943712E-06_JPRB, 0.13358023E-06_JPRB, 0.14822663E-06_JPRB, &
  & 0.16294734E-06_JPRB, 0.17738533E-06_JPRB, 0.19125929E-06_JPRB, 0.20437625E-06_JPRB, 0.21661121E-06_JPRB, 0.22793765E-06_JPRB, &
  & 0.23846513E-06_JPRB, 0.24848381E-06_JPRB, 0.25823491E-06_JPRB, 0.26794194E-06_JPRB, 0.27763195E-06_JPRB, 0.28728900E-06_JPRB, &
  & 0.29685984E-06_JPRB, 0.30623929E-06_JPRB, 0.31545002E-06_JPRB, 0.32430017E-06_JPRB, 0.33238314E-06_JPRB, 0.33890134E-06_JPRB, &
  & 0.34270857E-06_JPRB, 0.34265699E-06_JPRB, 0.33808175E-06_JPRB, 0.32909307E-06_JPRB, 0.31644439E-06_JPRB, 0.30119227E-06_JPRB, &
  & 0.28432495E-06_JPRB, 0.26658969E-06_JPRB, 0.24806090E-06_JPRB, 0.22903043E-06_JPRB, 0.20983293E-06_JPRB, 0.19103022E-06_JPRB, &
  & 0.17349974E-06_JPRB, 0.15844789E-06_JPRB, 0.14623166E-06_JPRB, 0.13666418E-06_JPRB, 0.12890176E-06_JPRB, 0.12231433E-06_JPRB, &
  & 0.11653852E-06_JPRB, 0.11132020E-06_JPRB, 0.10646737E-06_JPRB, 0.10188009E-06_JPRB, 0.97511084E-07_JPRB, 0.93379775E-07_JPRB, &
  & 0.89517954E-07_JPRB, 0.85986407E-07_JPRB, 0.82837637E-07_JPRB, 0.80130334E-07_JPRB, 0.77888906E-07_JPRB, 0.76106950E-07_JPRB, &
  & 0.74675221E-07_JPRB, 0.73513192E-07_JPRB, 0.72335304E-07_JPRB, 0.70611534E-07_JPRB /)

RGHG2(:,11, 3) = (/ &
  & 0.53194324E-07_JPRB, 0.66420377E-07_JPRB, 0.75791924E-07_JPRB, 0.85257611E-07_JPRB, 0.95798832E-07_JPRB, 0.10788226E-06_JPRB, &
  & 0.12167220E-06_JPRB, 0.13721630E-06_JPRB, 0.15440531E-06_JPRB, 0.17302733E-06_JPRB, 0.19288642E-06_JPRB, 0.21363937E-06_JPRB, &
  & 0.23495998E-06_JPRB, 0.25633184E-06_JPRB, 0.27737178E-06_JPRB, 0.29770578E-06_JPRB, 0.31695549E-06_JPRB, 0.33473097E-06_JPRB, &
  & 0.35072426E-06_JPRB, 0.36471869E-06_JPRB, 0.37669159E-06_JPRB, 0.38671024E-06_JPRB, 0.39495200E-06_JPRB, 0.40151642E-06_JPRB, &
  & 0.40664844E-06_JPRB, 0.41061583E-06_JPRB, 0.41380082E-06_JPRB, 0.41634425E-06_JPRB, 0.41798856E-06_JPRB, 0.41792973E-06_JPRB, &
  & 0.41497543E-06_JPRB, 0.40792156E-06_JPRB, 0.39591706E-06_JPRB, 0.37900287E-06_JPRB, 0.35813787E-06_JPRB, 0.33540869E-06_JPRB, &
  & 0.31252435E-06_JPRB, 0.29026268E-06_JPRB, 0.26913148E-06_JPRB, 0.24838161E-06_JPRB, 0.22768381E-06_JPRB, 0.20747420E-06_JPRB, &
  & 0.18871627E-06_JPRB, 0.17218105E-06_JPRB, 0.15842302E-06_JPRB, 0.14716389E-06_JPRB, 0.13811773E-06_JPRB, 0.13071049E-06_JPRB, &
  & 0.12442477E-06_JPRB, 0.11887888E-06_JPRB, 0.11385855E-06_JPRB, 0.10921539E-06_JPRB, 0.10488066E-06_JPRB, 0.10083796E-06_JPRB, &
  & 0.97124349E-07_JPRB, 0.93784365E-07_JPRB, 0.90874906E-07_JPRB, 0.88423221E-07_JPRB, 0.86442526E-07_JPRB, 0.84873484E-07_JPRB, &
  & 0.83669676E-07_JPRB, 0.82625064E-07_JPRB, 0.81663117E-07_JPRB, 0.80108549E-07_JPRB /)

RGHG2(:,12, 3) = (/ &
  & 0.81257802E-07_JPRB, 0.10377748E-06_JPRB, 0.11914054E-06_JPRB, 0.13281161E-06_JPRB, 0.14763503E-06_JPRB, 0.16365061E-06_JPRB, &
  & 0.18135589E-06_JPRB, 0.20082648E-06_JPRB, 0.22210779E-06_JPRB, 0.24517072E-06_JPRB, 0.26985504E-06_JPRB, 0.29588367E-06_JPRB, &
  & 0.32288693E-06_JPRB, 0.35056365E-06_JPRB, 0.37844870E-06_JPRB, 0.40594790E-06_JPRB, 0.43237145E-06_JPRB, 0.45706417E-06_JPRB, &
  & 0.47892701E-06_JPRB, 0.49764327E-06_JPRB, 0.51259849E-06_JPRB, 0.52388208E-06_JPRB, 0.53140133E-06_JPRB, 0.53557068E-06_JPRB, &
  & 0.53680395E-06_JPRB, 0.53564747E-06_JPRB, 0.53252700E-06_JPRB, 0.52771748E-06_JPRB, 0.52116729E-06_JPRB, 0.51233513E-06_JPRB, &
  & 0.50034060E-06_JPRB, 0.48428393E-06_JPRB, 0.46363456E-06_JPRB, 0.43850682E-06_JPRB, 0.41040821E-06_JPRB, 0.38098284E-06_JPRB, &
  & 0.35208714E-06_JPRB, 0.32546544E-06_JPRB, 0.30121134E-06_JPRB, 0.27907066E-06_JPRB, 0.25796493E-06_JPRB, 0.23730826E-06_JPRB, &
  & 0.21730321E-06_JPRB, 0.19876411E-06_JPRB, 0.18241472E-06_JPRB, 0.16873452E-06_JPRB, 0.15733876E-06_JPRB, 0.14779280E-06_JPRB, &
  & 0.13960104E-06_JPRB, 0.13242155E-06_JPRB, 0.12601609E-06_JPRB, 0.12021987E-06_JPRB, 0.11493706E-06_JPRB, 0.11015231E-06_JPRB, &
  & 0.10587748E-06_JPRB, 0.10215999E-06_JPRB, 0.99017875E-07_JPRB, 0.96450940E-07_JPRB, 0.94419192E-07_JPRB, 0.92871780E-07_JPRB, &
  & 0.91640679E-07_JPRB, 0.90681539E-07_JPRB, 0.89705594E-07_JPRB, 0.88346347E-07_JPRB /)

RGHG2(:,13, 3) = (/ &
  & 0.13425301E-06_JPRB, 0.16916543E-06_JPRB, 0.19041285E-06_JPRB, 0.20804592E-06_JPRB, 0.22580400E-06_JPRB, 0.24431105E-06_JPRB, &
  & 0.26412033E-06_JPRB, 0.28554078E-06_JPRB, 0.30878368E-06_JPRB, 0.33405760E-06_JPRB, 0.36146511E-06_JPRB, 0.39081618E-06_JPRB, &
  & 0.42177282E-06_JPRB, 0.45377232E-06_JPRB, 0.48642306E-06_JPRB, 0.51907256E-06_JPRB, 0.55067920E-06_JPRB, 0.58045686E-06_JPRB, &
  & 0.60705383E-06_JPRB, 0.62965739E-06_JPRB, 0.64753272E-06_JPRB, 0.66036455E-06_JPRB, 0.66817819E-06_JPRB, 0.67135886E-06_JPRB, &
  & 0.67034091E-06_JPRB, 0.66560762E-06_JPRB, 0.65748810E-06_JPRB, 0.64620093E-06_JPRB, 0.63176913E-06_JPRB, 0.61403563E-06_JPRB, &
  & 0.59267398E-06_JPRB, 0.56737821E-06_JPRB, 0.53826778E-06_JPRB, 0.50597794E-06_JPRB, 0.47163920E-06_JPRB, 0.43787512E-06_JPRB, &
  & 0.40706220E-06_JPRB, 0.38016904E-06_JPRB, 0.35686929E-06_JPRB, 0.33597996E-06_JPRB, 0.31646010E-06_JPRB, 0.29735739E-06_JPRB, &
  & 0.27790463E-06_JPRB, 0.25826051E-06_JPRB, 0.23910303E-06_JPRB, 0.22101356E-06_JPRB, 0.20471396E-06_JPRB, 0.19028678E-06_JPRB, &
  & 0.17749774E-06_JPRB, 0.16604113E-06_JPRB, 0.15568180E-06_JPRB, 0.14628510E-06_JPRB, 0.13776558E-06_JPRB, 0.13011396E-06_JPRB, &
  & 0.12337881E-06_JPRB, 0.11760552E-06_JPRB, 0.11279831E-06_JPRB, 0.10891593E-06_JPRB, 0.10587945E-06_JPRB, 0.10353219E-06_JPRB, &
  & 0.10178563E-06_JPRB, 0.10030934E-06_JPRB, 0.99026188E-07_JPRB, 0.97106515E-07_JPRB /)

RGHG2(:,14, 3) = (/ &
  & 0.21860575E-06_JPRB, 0.26287890E-06_JPRB, 0.28730290E-06_JPRB, 0.30685254E-06_JPRB, 0.32549900E-06_JPRB, 0.34454931E-06_JPRB, &
  & 0.36468205E-06_JPRB, 0.38629022E-06_JPRB, 0.40971958E-06_JPRB, 0.43526515E-06_JPRB, 0.46311857E-06_JPRB, 0.49323211E-06_JPRB, &
  & 0.52548734E-06_JPRB, 0.55937392E-06_JPRB, 0.59429442E-06_JPRB, 0.62943371E-06_JPRB, 0.66374776E-06_JPRB, 0.69616192E-06_JPRB, &
  & 0.72544657E-06_JPRB, 0.75041652E-06_JPRB, 0.77015648E-06_JPRB, 0.78429787E-06_JPRB, 0.79267772E-06_JPRB, 0.79551529E-06_JPRB, &
  & 0.79317806E-06_JPRB, 0.78615346E-06_JPRB, 0.77466689E-06_JPRB, 0.75880695E-06_JPRB, 0.73866397E-06_JPRB, 0.71440570E-06_JPRB, &
  & 0.68621489E-06_JPRB, 0.65462240E-06_JPRB, 0.62040800E-06_JPRB, 0.58467845E-06_JPRB, 0.54933719E-06_JPRB, 0.51685197E-06_JPRB, &
  & 0.48918565E-06_JPRB, 0.46677027E-06_JPRB, 0.44853641E-06_JPRB, 0.43286815E-06_JPRB, 0.41848767E-06_JPRB, 0.40381616E-06_JPRB, &
  & 0.38730579E-06_JPRB, 0.36823508E-06_JPRB, 0.34675892E-06_JPRB, 0.32363138E-06_JPRB, 0.30032240E-06_JPRB, 0.27812061E-06_JPRB, &
  & 0.25758493E-06_JPRB, 0.23873483E-06_JPRB, 0.22137760E-06_JPRB, 0.20532605E-06_JPRB, 0.19047985E-06_JPRB, 0.17687533E-06_JPRB, &
  & 0.16463855E-06_JPRB, 0.15391734E-06_JPRB, 0.14478930E-06_JPRB, 0.13721815E-06_JPRB, 0.13112934E-06_JPRB, 0.12640960E-06_JPRB, &
  & 0.12265714E-06_JPRB, 0.11970926E-06_JPRB, 0.11682666E-06_JPRB, 0.11298201E-06_JPRB /)

RGHG2(:,15, 3) = (/ &
  & 0.32602094E-06_JPRB, 0.37292537E-06_JPRB, 0.39701311E-06_JPRB, 0.41658896E-06_JPRB, 0.43513288E-06_JPRB, 0.45398480E-06_JPRB, &
  & 0.47375960E-06_JPRB, 0.49486312E-06_JPRB, 0.51760179E-06_JPRB, 0.54235858E-06_JPRB, 0.56940047E-06_JPRB, 0.59878153E-06_JPRB, &
  & 0.63028079E-06_JPRB, 0.66362168E-06_JPRB, 0.69839882E-06_JPRB, 0.73373997E-06_JPRB, 0.76861392E-06_JPRB, 0.80177455E-06_JPRB, &
  & 0.83191679E-06_JPRB, 0.85774059E-06_JPRB, 0.87822468E-06_JPRB, 0.89272976E-06_JPRB, 0.90117237E-06_JPRB, 0.90366331E-06_JPRB, &
  & 0.90049235E-06_JPRB, 0.89200671E-06_JPRB, 0.87837475E-06_JPRB, 0.85986079E-06_JPRB, 0.83663031E-06_JPRB, 0.80901611E-06_JPRB, &
  & 0.77768880E-06_JPRB, 0.74365659E-06_JPRB, 0.70859403E-06_JPRB, 0.67411435E-06_JPRB, 0.64226060E-06_JPRB, 0.61535297E-06_JPRB, &
  & 0.59461553E-06_JPRB, 0.58003758E-06_JPRB, 0.56991348E-06_JPRB, 0.56206073E-06_JPRB, 0.55480524E-06_JPRB, 0.54599889E-06_JPRB, &
  & 0.53375862E-06_JPRB, 0.51677210E-06_JPRB, 0.49450750E-06_JPRB, 0.46787807E-06_JPRB, 0.43890898E-06_JPRB, 0.40968840E-06_JPRB, &
  & 0.38159837E-06_JPRB, 0.35515521E-06_JPRB, 0.33028033E-06_JPRB, 0.30670395E-06_JPRB, 0.28423017E-06_JPRB, 0.26290144E-06_JPRB, &
  & 0.24300039E-06_JPRB, 0.22490495E-06_JPRB, 0.20886395E-06_JPRB, 0.19507230E-06_JPRB, 0.18361519E-06_JPRB, 0.17432991E-06_JPRB, &
  & 0.16703376E-06_JPRB, 0.16080408E-06_JPRB, 0.15506708E-06_JPRB, 0.14670216E-06_JPRB /)

RGHG2(:,16, 3) = (/ &
  & 0.43843289E-06_JPRB, 0.48405150E-06_JPRB, 0.50768563E-06_JPRB, 0.52683839E-06_JPRB, 0.54516926E-06_JPRB, 0.56385556E-06_JPRB, &
  & 0.58343568E-06_JPRB, 0.60427004E-06_JPRB, 0.62668892E-06_JPRB, 0.65094014E-06_JPRB, 0.67716667E-06_JPRB, 0.70532013E-06_JPRB, &
  & 0.73529179E-06_JPRB, 0.76677804E-06_JPRB, 0.79960796E-06_JPRB, 0.83326063E-06_JPRB, 0.86694752E-06_JPRB, 0.89934002E-06_JPRB, &
  & 0.92903161E-06_JPRB, 0.95453777E-06_JPRB, 0.97472957E-06_JPRB, 0.98890450E-06_JPRB, 0.99687941E-06_JPRB, 0.99881822E-06_JPRB, &
  & 0.99500448E-06_JPRB, 0.98570524E-06_JPRB, 0.97145971E-06_JPRB, 0.95201176E-06_JPRB, 0.92772427E-06_JPRB, 0.89949231E-06_JPRB, &
  & 0.86834274E-06_JPRB, 0.83527988E-06_JPRB, 0.80241853E-06_JPRB, 0.77200400E-06_JPRB, 0.74616690E-06_JPRB, 0.72675999E-06_JPRB, &
  & 0.71465638E-06_JPRB, 0.70889371E-06_JPRB, 0.70733427E-06_JPRB, 0.70726611E-06_JPRB, 0.70636577E-06_JPRB, 0.70246398E-06_JPRB, &
  & 0.69379939E-06_JPRB, 0.67890335E-06_JPRB, 0.65719058E-06_JPRB, 0.62946629E-06_JPRB, 0.59784719E-06_JPRB, 0.56475682E-06_JPRB, &
  & 0.53200591E-06_JPRB, 0.50046037E-06_JPRB, 0.47017556E-06_JPRB, 0.44084209E-06_JPRB, 0.41213312E-06_JPRB, 0.38407160E-06_JPRB, &
  & 0.35700216E-06_JPRB, 0.33151028E-06_JPRB, 0.30818077E-06_JPRB, 0.28744847E-06_JPRB, 0.26971526E-06_JPRB, 0.25517886E-06_JPRB, &
  & 0.24318479E-06_JPRB, 0.23312815E-06_JPRB, 0.22323333E-06_JPRB, 0.20900738E-06_JPRB /)

RGHG2(:,17, 3) = (/ &
  & 0.54533183E-06_JPRB, 0.58967481E-06_JPRB, 0.61292974E-06_JPRB, 0.63236553E-06_JPRB, 0.65127176E-06_JPRB, 0.67082135E-06_JPRB, &
  & 0.69134268E-06_JPRB, 0.71300389E-06_JPRB, 0.73589888E-06_JPRB, 0.76023139E-06_JPRB, 0.78594996E-06_JPRB, 0.81290415E-06_JPRB, &
  & 0.84105329E-06_JPRB, 0.87035971E-06_JPRB, 0.90051503E-06_JPRB, 0.93141136E-06_JPRB, 0.96246731E-06_JPRB, 0.99264992E-06_JPRB, &
  & 0.10205750E-05_JPRB, 0.10446471E-05_JPRB, 0.10636529E-05_JPRB, 0.10767905E-05_JPRB, 0.10839050E-05_JPRB, 0.10851902E-05_JPRB, &
  & 0.10809613E-05_JPRB, 0.10718065E-05_JPRB, 0.10574203E-05_JPRB, 0.10389077E-05_JPRB, 0.10170460E-05_JPRB, 0.99144881E-06_JPRB, &
  & 0.96316433E-06_JPRB, 0.93407141E-06_JPRB, 0.90613901E-06_JPRB, 0.88155781E-06_JPRB, 0.86244432E-06_JPRB, 0.85046020E-06_JPRB, &
  & 0.84577738E-06_JPRB, 0.84688327E-06_JPRB, 0.85106808E-06_JPRB, 0.85561311E-06_JPRB, 0.85817697E-06_JPRB, 0.85700162E-06_JPRB, &
  & 0.85032258E-06_JPRB, 0.83672592E-06_JPRB, 0.81566344E-06_JPRB, 0.78797228E-06_JPRB, 0.75578441E-06_JPRB, 0.72154882E-06_JPRB, &
  & 0.68708619E-06_JPRB, 0.65330835E-06_JPRB, 0.62039925E-06_JPRB, 0.58801453E-06_JPRB, 0.55580779E-06_JPRB, 0.52370393E-06_JPRB, &
  & 0.49206028E-06_JPRB, 0.46155162E-06_JPRB, 0.43289691E-06_JPRB, 0.40692274E-06_JPRB, 0.38434928E-06_JPRB, 0.36536289E-06_JPRB, &
  & 0.34974130E-06_JPRB, 0.33612520E-06_JPRB, 0.32270032E-06_JPRB, 0.30289837E-06_JPRB /)

RGHG2(:,18, 3) = (/ &
  & 0.64415872E-06_JPRB, 0.68875693E-06_JPRB, 0.71304862E-06_JPRB, 0.73338407E-06_JPRB, 0.75317359E-06_JPRB, 0.77366877E-06_JPRB, &
  & 0.79524079E-06_JPRB, 0.81795832E-06_JPRB, 0.84170813E-06_JPRB, 0.86652341E-06_JPRB, 0.89234379E-06_JPRB, 0.91860022E-06_JPRB, &
  & 0.94535250E-06_JPRB, 0.97265161E-06_JPRB, 0.10001962E-05_JPRB, 0.10280958E-05_JPRB, 0.10559160E-05_JPRB, 0.10829235E-05_JPRB, &
  & 0.11079795E-05_JPRB, 0.11295991E-05_JPRB, 0.11465559E-05_JPRB, 0.11580920E-05_JPRB, 0.11640491E-05_JPRB, 0.11646555E-05_JPRB, &
  & 0.11604138E-05_JPRB, 0.11517030E-05_JPRB, 0.11393206E-05_JPRB, 0.11244792E-05_JPRB, 0.11056596E-05_JPRB, 0.10847091E-05_JPRB, &
  & 0.10624697E-05_JPRB, 0.10403212E-05_JPRB, 0.10197306E-05_JPRB, 0.10025302E-05_JPRB, 0.99053898E-06_JPRB, 0.98480359E-06_JPRB, &
  & 0.98512930E-06_JPRB, 0.98981479E-06_JPRB, 0.99616227E-06_JPRB, 0.10017739E-05_JPRB, 0.10045127E-05_JPRB, 0.10027785E-05_JPRB, &
  & 0.99522833E-06_JPRB, 0.98082705E-06_JPRB, 0.95930557E-06_JPRB, 0.93157712E-06_JPRB, 0.89962413E-06_JPRB, 0.86557282E-06_JPRB, &
  & 0.83111519E-06_JPRB, 0.79716597E-06_JPRB, 0.76380684E-06_JPRB, 0.73077024E-06_JPRB, 0.69770044E-06_JPRB, 0.66450804E-06_JPRB, &
  & 0.63143807E-06_JPRB, 0.59910337E-06_JPRB, 0.56832567E-06_JPRB, 0.54001782E-06_JPRB, 0.51509414E-06_JPRB, 0.49404827E-06_JPRB, &
  & 0.47637513E-06_JPRB, 0.46077554E-06_JPRB, 0.44539831E-06_JPRB, 0.42154673E-06_JPRB /)

RGHG2(:,19, 3) = (/ &
  & 0.73501349E-06_JPRB, 0.78005723E-06_JPRB, 0.80516418E-06_JPRB, 0.82670533E-06_JPRB, 0.84770011E-06_JPRB, 0.86929936E-06_JPRB, &
  & 0.89194350E-06_JPRB, 0.91578966E-06_JPRB, 0.94058908E-06_JPRB, 0.96620261E-06_JPRB, 0.99254771E-06_JPRB, 0.10187169E-05_JPRB, &
  & 0.10445524E-05_JPRB, 0.10702711E-05_JPRB, 0.10955998E-05_JPRB, 0.11206918E-05_JPRB, 0.11452472E-05_JPRB, 0.11687468E-05_JPRB, &
  & 0.11903480E-05_JPRB, 0.12088965E-05_JPRB, 0.12233585E-05_JPRB, 0.12330339E-05_JPRB, 0.12377749E-05_JPRB, 0.12379126E-05_JPRB, &
  & 0.12340084E-05_JPRB, 0.12268690E-05_JPRB, 0.12178375E-05_JPRB, 0.12054622E-05_JPRB, 0.11923473E-05_JPRB, 0.11780894E-05_JPRB, &
  & 0.11637549E-05_JPRB, 0.11502624E-05_JPRB, 0.11383659E-05_JPRB, 0.11294302E-05_JPRB, 0.11244299E-05_JPRB, 0.11235770E-05_JPRB, &
  & 0.11263934E-05_JPRB, 0.11314917E-05_JPRB, 0.11367989E-05_JPRB, 0.11400483E-05_JPRB, 0.11398261E-05_JPRB, 0.11349845E-05_JPRB, &
  & 0.11245968E-05_JPRB, 0.11079721E-05_JPRB, 0.10850639E-05_JPRB, 0.10568563E-05_JPRB, 0.10250779E-05_JPRB, 0.99165572E-06_JPRB, &
  & 0.95808196E-06_JPRB, 0.92492058E-06_JPRB, 0.89230804E-06_JPRB, 0.86005105E-06_JPRB, 0.82790109E-06_JPRB, 0.79575608E-06_JPRB, &
  & 0.76378342E-06_JPRB, 0.73242626E-06_JPRB, 0.70234785E-06_JPRB, 0.67444358E-06_JPRB, 0.64969845E-06_JPRB, 0.62855804E-06_JPRB, &
  & 0.61051878E-06_JPRB, 0.59477424E-06_JPRB, 0.57823758E-06_JPRB, 0.55398482E-06_JPRB /)

RGHG2(:,20, 3) = (/ &
  & 0.81807127E-06_JPRB, 0.86359216E-06_JPRB, 0.88900794E-06_JPRB, 0.91119711E-06_JPRB, 0.93308910E-06_JPRB, 0.95563996E-06_JPRB, &
  & 0.97920838E-06_JPRB, 0.10039424E-05_JPRB, 0.10296270E-05_JPRB, 0.10558612E-05_JPRB, 0.10826021E-05_JPRB, 0.11088639E-05_JPRB, &
  & 0.11341227E-05_JPRB, 0.11586330E-05_JPRB, 0.11822145E-05_JPRB, 0.12048936E-05_JPRB, 0.12265722E-05_JPRB, 0.12468656E-05_JPRB, &
  & 0.12652192E-05_JPRB, 0.12808509E-05_JPRB, 0.12929469E-05_JPRB, 0.13009615E-05_JPRB, 0.13047879E-05_JPRB, 0.13047274E-05_JPRB, &
  & 0.13014610E-05_JPRB, 0.12961198E-05_JPRB, 0.12887273E-05_JPRB, 0.12811581E-05_JPRB, 0.12737642E-05_JPRB, 0.12669525E-05_JPRB, &
  & 0.12609772E-05_JPRB, 0.12560919E-05_JPRB, 0.12526976E-05_JPRB, 0.12513153E-05_JPRB, 0.12519928E-05_JPRB, 0.12546936E-05_JPRB, &
  & 0.12587531E-05_JPRB, 0.12626068E-05_JPRB, 0.12646975E-05_JPRB, 0.12637811E-05_JPRB, 0.12590351E-05_JPRB, 0.12498111E-05_JPRB, &
  & 0.12356259E-05_JPRB, 0.12161048E-05_JPRB, 0.11914942E-05_JPRB, 0.11627094E-05_JPRB, 0.11313834E-05_JPRB, 0.10990211E-05_JPRB, &
  & 0.10665565E-05_JPRB, 0.10346128E-05_JPRB, 0.10033855E-05_JPRB, 0.97279076E-06_JPRB, 0.94266153E-06_JPRB, 0.91290690E-06_JPRB, &
  & 0.88357081E-06_JPRB, 0.85488546E-06_JPRB, 0.82729844E-06_JPRB, 0.80153956E-06_JPRB, 0.77841776E-06_JPRB, 0.75838568E-06_JPRB, &
  & 0.74137506E-06_JPRB, 0.72566957E-06_JPRB, 0.71033617E-06_JPRB, 0.68524548E-06_JPRB /)

RGHG2(:,21, 3) = (/ &
  & 0.89322214E-06_JPRB, 0.93847177E-06_JPRB, 0.96387157E-06_JPRB, 0.98604448E-06_JPRB, 0.10081342E-05_JPRB, 0.10310581E-05_JPRB, &
  & 0.10551161E-05_JPRB, 0.10803400E-05_JPRB, 0.11064725E-05_JPRB, 0.11330588E-05_JPRB, 0.11597738E-05_JPRB, 0.11859237E-05_JPRB, &
  & 0.12107705E-05_JPRB, 0.12343584E-05_JPRB, 0.12566614E-05_JPRB, 0.12775466E-05_JPRB, 0.12970180E-05_JPRB, 0.13148922E-05_JPRB, &
  & 0.13308147E-05_JPRB, 0.13442678E-05_JPRB, 0.13546930E-05_JPRB, 0.13617271E-05_JPRB, 0.13652591E-05_JPRB, 0.13656310E-05_JPRB, &
  & 0.13635963E-05_JPRB, 0.13595967E-05_JPRB, 0.13551667E-05_JPRB, 0.13514773E-05_JPRB, 0.13489122E-05_JPRB, 0.13478956E-05_JPRB, &
  & 0.13487338E-05_JPRB, 0.13509135E-05_JPRB, 0.13545284E-05_JPRB, 0.13587807E-05_JPRB, 0.13634865E-05_JPRB, 0.13679582E-05_JPRB, &
  & 0.13714616E-05_JPRB, 0.13728379E-05_JPRB, 0.13712734E-05_JPRB, 0.13661431E-05_JPRB, 0.13570939E-05_JPRB, 0.13439238E-05_JPRB, &
  & 0.13264668E-05_JPRB, 0.13047196E-05_JPRB, 0.12789908E-05_JPRB, 0.12502405E-05_JPRB, 0.12196492E-05_JPRB, 0.11883554E-05_JPRB, &
  & 0.11573173E-05_JPRB, 0.11271384E-05_JPRB, 0.10979053E-05_JPRB, 0.10696001E-05_JPRB, 0.10421242E-05_JPRB, 0.10153645E-05_JPRB, &
  & 0.98926580E-06_JPRB, 0.96386839E-06_JPRB, 0.93938172E-06_JPRB, 0.91625822E-06_JPRB, 0.89523269E-06_JPRB, 0.87676040E-06_JPRB, &
  & 0.86044508E-06_JPRB, 0.84602607E-06_JPRB, 0.83029437E-06_JPRB, 0.80725795E-06_JPRB /)

RGHG2(:,22, 3) = (/ &
  & 0.96092788E-06_JPRB, 0.10048250E-05_JPRB, 0.10300515E-05_JPRB, 0.10519058E-05_JPRB, 0.10735870E-05_JPRB, 0.10962189E-05_JPRB, &
  & 0.11201147E-05_JPRB, 0.11452123E-05_JPRB, 0.11712114E-05_JPRB, 0.11975957E-05_JPRB, 0.12239213E-05_JPRB, 0.12496059E-05_JPRB, &
  & 0.12739920E-05_JPRB, 0.12968443E-05_JPRB, 0.13181709E-05_JPRB, 0.13379055E-05_JPRB, 0.13560075E-05_JPRB, 0.13723908E-05_JPRB, &
  & 0.13868511E-05_JPRB, 0.13990822E-05_JPRB, 0.14087191E-05_JPRB, 0.14155074E-05_JPRB, 0.14194306E-05_JPRB, 0.14207892E-05_JPRB, &
  & 0.14199267E-05_JPRB, 0.14179814E-05_JPRB, 0.14160078E-05_JPRB, 0.14149816E-05_JPRB, 0.14156562E-05_JPRB, 0.14186212E-05_JPRB, &
  & 0.14235284E-05_JPRB, 0.14301485E-05_JPRB, 0.14375933E-05_JPRB, 0.14448316E-05_JPRB, 0.14512917E-05_JPRB, 0.14560383E-05_JPRB, &
  & 0.14583242E-05_JPRB, 0.14574298E-05_JPRB, 0.14529074E-05_JPRB, 0.14446273E-05_JPRB, 0.14325690E-05_JPRB, 0.14168306E-05_JPRB, &
  & 0.13975147E-05_JPRB, 0.13747958E-05_JPRB, 0.13490699E-05_JPRB, 0.13210368E-05_JPRB, 0.12916800E-05_JPRB, 0.12620917E-05_JPRB, &
  & 0.12331637E-05_JPRB, 0.12051752E-05_JPRB, 0.11782877E-05_JPRB, 0.11525830E-05_JPRB, 0.11279592E-05_JPRB, 0.11042595E-05_JPRB, &
  & 0.10813302E-05_JPRB, 0.10590572E-05_JPRB, 0.10374747E-05_JPRB, 0.10168663E-05_JPRB, 0.99771523E-06_JPRB, 0.98045211E-06_JPRB, &
  & 0.96522172E-06_JPRB, 0.95072517E-06_JPRB, 0.93634338E-06_JPRB, 0.91266821E-06_JPRB /)

RGHG2(:,23, 3) = (/ &
  & 0.10212725E-05_JPRB, 0.10636713E-05_JPRB, 0.10878891E-05_JPRB, 0.11091660E-05_JPRB, 0.11302741E-05_JPRB, 0.11522540E-05_JPRB, &
  & 0.11755012E-05_JPRB, 0.11999582E-05_JPRB, 0.12252668E-05_JPRB, 0.12509905E-05_JPRB, 0.12765869E-05_JPRB, 0.13015648E-05_JPRB, &
  & 0.13254079E-05_JPRB, 0.13477293E-05_JPRB, 0.13683995E-05_JPRB, 0.13874052E-05_JPRB, 0.14047362E-05_JPRB, 0.14203574E-05_JPRB, &
  & 0.14341505E-05_JPRB, 0.14459680E-05_JPRB, 0.14555429E-05_JPRB, 0.14627229E-05_JPRB, 0.14675022E-05_JPRB, 0.14700345E-05_JPRB, &
  & 0.14707758E-05_JPRB, 0.14705391E-05_JPRB, 0.14703255E-05_JPRB, 0.14711248E-05_JPRB, 0.14738480E-05_JPRB, 0.14786560E-05_JPRB, &
  & 0.14856930E-05_JPRB, 0.14941232E-05_JPRB, 0.15028417E-05_JPRB, 0.15108706E-05_JPRB, 0.15172374E-05_JPRB, 0.15210843E-05_JPRB, &
  & 0.15217803E-05_JPRB, 0.15188601E-05_JPRB, 0.15122357E-05_JPRB, 0.15019792E-05_JPRB, 0.14883101E-05_JPRB, 0.14714567E-05_JPRB, &
  & 0.14517142E-05_JPRB, 0.14292982E-05_JPRB, 0.14045254E-05_JPRB, 0.13779746E-05_JPRB, 0.13505847E-05_JPRB, 0.13233526E-05_JPRB, &
  & 0.12967624E-05_JPRB, 0.12711378E-05_JPRB, 0.12468320E-05_JPRB, 0.12238244E-05_JPRB, 0.12019863E-05_JPRB, 0.11811098E-05_JPRB, &
  & 0.11609550E-05_JPRB, 0.11413269E-05_JPRB, 0.11221459E-05_JPRB, 0.11035427E-05_JPRB, 0.10859345E-05_JPRB, 0.10696915E-05_JPRB, &
  & 0.10547251E-05_JPRB, 0.10409150E-05_JPRB, 0.10257309E-05_JPRB, 0.10027433E-05_JPRB /)

RGHG2(:,24, 3) = (/ &
  & 0.10755635E-05_JPRB, 0.11157830E-05_JPRB, 0.11387714E-05_JPRB, 0.11590538E-05_JPRB, 0.11793126E-05_JPRB, 0.12004531E-05_JPRB, &
  & 0.12227943E-05_JPRB, 0.12462790E-05_JPRB, 0.12705734E-05_JPRB, 0.12952499E-05_JPRB, 0.13199049E-05_JPRB, 0.13440235E-05_JPRB, &
  & 0.13671597E-05_JPRB, 0.13889698E-05_JPRB, 0.14092301E-05_JPRB, 0.14278535E-05_JPRB, 0.14448478E-05_JPRB, 0.14602101E-05_JPRB, &
  & 0.14738845E-05_JPRB, 0.14857900E-05_JPRB, 0.14957488E-05_JPRB, 0.15036836E-05_JPRB, 0.15095186E-05_JPRB, 0.15133453E-05_JPRB, &
  & 0.15156199E-05_JPRB, 0.15168655E-05_JPRB, 0.15180200E-05_JPRB, 0.15200486E-05_JPRB, 0.15236652E-05_JPRB, 0.15292746E-05_JPRB, &
  & 0.15367473E-05_JPRB, 0.15451996E-05_JPRB, 0.15535895E-05_JPRB, 0.15608987E-05_JPRB, 0.15660910E-05_JPRB, 0.15684341E-05_JPRB, &
  & 0.15674588E-05_JPRB, 0.15628721E-05_JPRB, 0.15548219E-05_JPRB, 0.15435165E-05_JPRB, 0.15293255E-05_JPRB, 0.15125297E-05_JPRB, &
  & 0.14934365E-05_JPRB, 0.14722541E-05_JPRB, 0.14491948E-05_JPRB, 0.14247846E-05_JPRB, 0.13998173E-05_JPRB, 0.13749301E-05_JPRB, &
  & 0.13506793E-05_JPRB, 0.13276233E-05_JPRB, 0.13058665E-05_JPRB, 0.12854330E-05_JPRB, 0.12661378E-05_JPRB, 0.12476976E-05_JPRB, &
  & 0.12298251E-05_JPRB, 0.12122788E-05_JPRB, 0.11949394E-05_JPRB, 0.11778720E-05_JPRB, 0.11613708E-05_JPRB, 0.11457754E-05_JPRB, &
  & 0.11312425E-05_JPRB, 0.11170483E-05_JPRB, 0.11022340E-05_JPRB, 0.10782220E-05_JPRB /)

RGHG2(:,25, 3) = (/ &
  & 0.11245810E-05_JPRB, 0.11623692E-05_JPRB, 0.11842258E-05_JPRB, 0.12032956E-05_JPRB, 0.12223962E-05_JPRB, 0.12424756E-05_JPRB, &
  & 0.12637128E-05_JPRB, 0.12860105E-05_JPRB, 0.13090812E-05_JPRB, 0.13325679E-05_JPRB, 0.13561138E-05_JPRB, 0.13793587E-05_JPRB, &
  & 0.14018560E-05_JPRB, 0.14231654E-05_JPRB, 0.14430492E-05_JPRB, 0.14614077E-05_JPRB, 0.14782289E-05_JPRB, 0.14935233E-05_JPRB, &
  & 0.15072748E-05_JPRB, 0.15194501E-05_JPRB, 0.15299483E-05_JPRB, 0.15386767E-05_JPRB, 0.15455448E-05_JPRB, 0.15506205E-05_JPRB, &
  & 0.15542497E-05_JPRB, 0.15568114E-05_JPRB, 0.15591366E-05_JPRB, 0.15619609E-05_JPRB, 0.15659998E-05_JPRB, 0.15716251E-05_JPRB, &
  & 0.15785193E-05_JPRB, 0.15860795E-05_JPRB, 0.15932600E-05_JPRB, 0.15990903E-05_JPRB, 0.16026758E-05_JPRB, 0.16033807E-05_JPRB, &
  & 0.16008620E-05_JPRB, 0.15950168E-05_JPRB, 0.15861453E-05_JPRB, 0.15745537E-05_JPRB, 0.15605962E-05_JPRB, 0.15445742E-05_JPRB, &
  & 0.15267714E-05_JPRB, 0.15073082E-05_JPRB, 0.14863323E-05_JPRB, 0.14642339E-05_JPRB, 0.14415727E-05_JPRB, 0.14190290E-05_JPRB, &
  & 0.13973114E-05_JPRB, 0.13766889E-05_JPRB, 0.13573504E-05_JPRB, 0.13392578E-05_JPRB, 0.13221691E-05_JPRB, 0.13057598E-05_JPRB, &
  & 0.12897087E-05_JPRB, 0.12737669E-05_JPRB, 0.12577821E-05_JPRB, 0.12418238E-05_JPRB, 0.12261555E-05_JPRB, 0.12110627E-05_JPRB, &
  & 0.11966250E-05_JPRB, 0.11826090E-05_JPRB, 0.11672255E-05_JPRB, 0.11426587E-05_JPRB /)

RGHG2(:,26, 3) = (/ &
  & 0.11693752E-05_JPRB, 0.12049237E-05_JPRB, 0.12252106E-05_JPRB, 0.12431370E-05_JPRB, 0.12610363E-05_JPRB, 0.12797871E-05_JPRB, &
  & 0.12998059E-05_JPRB, 0.13207911E-05_JPRB, 0.13424878E-05_JPRB, 0.13646521E-05_JPRB, 0.13870140E-05_JPRB, 0.14092236E-05_JPRB, &
  & 0.14309485E-05_JPRB, 0.14517927E-05_JPRB, 0.14713983E-05_JPRB, 0.14895819E-05_JPRB, 0.15063151E-05_JPRB, 0.15216136E-05_JPRB, &
  & 0.15354910E-05_JPRB, 0.15479397E-05_JPRB, 0.15588980E-05_JPRB, 0.15682933E-05_JPRB, 0.15760431E-05_JPRB, 0.15822123E-05_JPRB, &
  & 0.15869978E-05_JPRB, 0.15907477E-05_JPRB, 0.15940235E-05_JPRB, 0.15974611E-05_JPRB, 0.16016929E-05_JPRB, 0.16068384E-05_JPRB, &
  & 0.16128521E-05_JPRB, 0.16190609E-05_JPRB, 0.16246620E-05_JPRB, 0.16287996E-05_JPRB, 0.16307409E-05_JPRB, 0.16299679E-05_JPRB, &
  & 0.16262518E-05_JPRB, 0.16196453E-05_JPRB, 0.16104642E-05_JPRB, 0.15991041E-05_JPRB, 0.15859034E-05_JPRB, 0.15711039E-05_JPRB, &
  & 0.15548826E-05_JPRB, 0.15373104E-05_JPRB, 0.15184385E-05_JPRB, 0.14985606E-05_JPRB, 0.14781688E-05_JPRB, 0.14580024E-05_JPRB, &
  & 0.14385574E-05_JPRB, 0.14201588E-05_JPRB, 0.14029603E-05_JPRB, 0.13868687E-05_JPRB, 0.13716210E-05_JPRB, 0.13568596E-05_JPRB, &
  & 0.13422438E-05_JPRB, 0.13275170E-05_JPRB, 0.13125573E-05_JPRB, 0.12974093E-05_JPRB, 0.12823343E-05_JPRB, 0.12676206E-05_JPRB, &
  & 0.12533892E-05_JPRB, 0.12392627E-05_JPRB, 0.12237858E-05_JPRB, 0.11988819E-05_JPRB /)

RGHG2(:,27, 3) = (/ &
  & 0.12109688E-05_JPRB, 0.12437023E-05_JPRB, 0.12627642E-05_JPRB, 0.12794515E-05_JPRB, 0.12961370E-05_JPRB, 0.13137048E-05_JPRB, &
  & 0.13322840E-05_JPRB, 0.13519206E-05_JPRB, 0.13722105E-05_JPRB, 0.13930146E-05_JPRB, 0.14141618E-05_JPRB, 0.14354134E-05_JPRB, &
  & 0.14563620E-05_JPRB, 0.14765776E-05_JPRB, 0.14957592E-05_JPRB, 0.15137150E-05_JPRB, 0.15303682E-05_JPRB, 0.15456864E-05_JPRB, &
  & 0.15596581E-05_JPRB, 0.15722736E-05_JPRB, 0.15835213E-05_JPRB, 0.15933642E-05_JPRB, 0.16017615E-05_JPRB, 0.16087689E-05_JPRB, &
  & 0.16145084E-05_JPRB, 0.16192615E-05_JPRB, 0.16233704E-05_JPRB, 0.16273277E-05_JPRB, 0.16314949E-05_JPRB, 0.16360927E-05_JPRB, &
  & 0.16410271E-05_JPRB, 0.16458117E-05_JPRB, 0.16498229E-05_JPRB, 0.16523696E-05_JPRB, 0.16528718E-05_JPRB, 0.16509186E-05_JPRB, &
  & 0.16463725E-05_JPRB, 0.16393954E-05_JPRB, 0.16304148E-05_JPRB, 0.16197913E-05_JPRB, 0.16076995E-05_JPRB, 0.15943300E-05_JPRB, &
  & 0.15798055E-05_JPRB, 0.15640926E-05_JPRB, 0.15472692E-05_JPRB, 0.15294690E-05_JPRB, 0.15112319E-05_JPRB, 0.14931602E-05_JPRB, &
  & 0.14757253E-05_JPRB, 0.14592829E-05_JPRB, 0.14438897E-05_JPRB, 0.14294446E-05_JPRB, 0.14156768E-05_JPRB, 0.14022166E-05_JPRB, &
  & 0.13887236E-05_JPRB, 0.13749581E-05_JPRB, 0.13607719E-05_JPRB, 0.13462570E-05_JPRB, 0.13316508E-05_JPRB, 0.13172535E-05_JPRB, &
  & 0.13032266E-05_JPRB, 0.12892367E-05_JPRB, 0.12739650E-05_JPRB, 0.12486471E-05_JPRB /)

RGHG2(:,28, 3) = (/ &
  & 0.12492965E-05_JPRB, 0.12800198E-05_JPRB, 0.12974817E-05_JPRB, 0.13130194E-05_JPRB, 0.13285733E-05_JPRB, 0.13448367E-05_JPRB, &
  & 0.13621545E-05_JPRB, 0.13803316E-05_JPRB, 0.13992187E-05_JPRB, 0.14186437E-05_JPRB, 0.14385470E-05_JPRB, 0.14586915E-05_JPRB, &
  & 0.14788234E-05_JPRB, 0.14985500E-05_JPRB, 0.15174380E-05_JPRB, 0.15351904E-05_JPRB, 0.15516957E-05_JPRB, 0.15669168E-05_JPRB, &
  & 0.15808438E-05_JPRB, 0.15934721E-05_JPRB, 0.16048078E-05_JPRB, 0.16148628E-05_JPRB, 0.16236399E-05_JPRB, 0.16311946E-05_JPRB, &
  & 0.16376076E-05_JPRB, 0.16430623E-05_JPRB, 0.16477804E-05_JPRB, 0.16520717E-05_JPRB, 0.16561294E-05_JPRB, 0.16601755E-05_JPRB, &
  & 0.16641047E-05_JPRB, 0.16676037E-05_JPRB, 0.16702151E-05_JPRB, 0.16714253E-05_JPRB, 0.16707937E-05_JPRB, 0.16680189E-05_JPRB, &
  & 0.16630855E-05_JPRB, 0.16562402E-05_JPRB, 0.16478124E-05_JPRB, 0.16381024E-05_JPRB, 0.16273020E-05_JPRB, 0.16154664E-05_JPRB, &
  & 0.16026195E-05_JPRB, 0.15887271E-05_JPRB, 0.15737304E-05_JPRB, 0.15578796E-05_JPRB, 0.15415590E-05_JPRB, 0.15253286E-05_JPRB, &
  & 0.15096717E-05_JPRB, 0.14948398E-05_JPRB, 0.14809067E-05_JPRB, 0.14677717E-05_JPRB, 0.14551530E-05_JPRB, 0.14427075E-05_JPRB, &
  & 0.14301211E-05_JPRB, 0.14171097E-05_JPRB, 0.14035953E-05_JPRB, 0.13895794E-05_JPRB, 0.13753576E-05_JPRB, 0.13612497E-05_JPRB, &
  & 0.13474253E-05_JPRB, 0.13336879E-05_JPRB, 0.13184223E-05_JPRB, 0.12936995E-05_JPRB /)

RGHG2(:,29, 3) = (/ &
  & 0.12852431E-05_JPRB, 0.13134687E-05_JPRB, 0.13299959E-05_JPRB, 0.13443395E-05_JPRB, 0.13587313E-05_JPRB, 0.13739076E-05_JPRB, &
  & 0.13898714E-05_JPRB, 0.14067110E-05_JPRB, 0.14242082E-05_JPRB, 0.14423055E-05_JPRB, 0.14609896E-05_JPRB, 0.14801542E-05_JPRB, &
  & 0.14994382E-05_JPRB, 0.15184838E-05_JPRB, 0.15369432E-05_JPRB, 0.15544560E-05_JPRB, 0.15708216E-05_JPRB, 0.15859423E-05_JPRB, &
  & 0.15997805E-05_JPRB, 0.16123271E-05_JPRB, 0.16236177E-05_JPRB, 0.16336826E-05_JPRB, 0.16425959E-05_JPRB, 0.16504073E-05_JPRB, &
  & 0.16572028E-05_JPRB, 0.16630552E-05_JPRB, 0.16681219E-05_JPRB, 0.16725352E-05_JPRB, 0.16764310E-05_JPRB, 0.16799496E-05_JPRB, &
  & 0.16830195E-05_JPRB, 0.16854394E-05_JPRB, 0.16869307E-05_JPRB, 0.16871019E-05_JPRB, 0.16856654E-05_JPRB, 0.16824209E-05_JPRB, &
  & 0.16774142E-05_JPRB, 0.16708931E-05_JPRB, 0.16632457E-05_JPRB, 0.16547066E-05_JPRB, 0.16452916E-05_JPRB, 0.16349843E-05_JPRB, &
  & 0.16237705E-05_JPRB, 0.16115221E-05_JPRB, 0.15982740E-05_JPRB, 0.15841192E-05_JPRB, 0.15695041E-05_JPRB, 0.15548929E-05_JPRB, &
  & 0.15406972E-05_JPRB, 0.15271974E-05_JPRB, 0.15144373E-05_JPRB, 0.15023097E-05_JPRB, 0.14905964E-05_JPRB, 0.14789562E-05_JPRB, &
  & 0.14670977E-05_JPRB, 0.14547604E-05_JPRB, 0.14417960E-05_JPRB, 0.14282541E-05_JPRB, 0.14143559E-05_JPRB, 0.14004697E-05_JPRB, &
  & 0.13868444E-05_JPRB, 0.13733135E-05_JPRB, 0.13585897E-05_JPRB, 0.13341171E-05_JPRB /)

RGHG2(:,30, 3) = (/ &
  & 0.13184367E-05_JPRB, 0.13450995E-05_JPRB, 0.13602038E-05_JPRB, 0.13737091E-05_JPRB, 0.13871185E-05_JPRB, 0.14010946E-05_JPRB, &
  & 0.14159187E-05_JPRB, 0.14314583E-05_JPRB, 0.14476173E-05_JPRB, 0.14644405E-05_JPRB, 0.14819135E-05_JPRB, 0.14999449E-05_JPRB, &
  & 0.15183244E-05_JPRB, 0.15367029E-05_JPRB, 0.15547456E-05_JPRB, 0.15720557E-05_JPRB, 0.15882902E-05_JPRB, 0.16033014E-05_JPRB, &
  & 0.16170206E-05_JPRB, 0.16294305E-05_JPRB, 0.16405708E-05_JPRB, 0.16505185E-05_JPRB, 0.16593647E-05_JPRB, 0.16671850E-05_JPRB, &
  & 0.16740679E-05_JPRB, 0.16800061E-05_JPRB, 0.16851702E-05_JPRB, 0.16895085E-05_JPRB, 0.16931683E-05_JPRB, 0.16961992E-05_JPRB, &
  & 0.16985540E-05_JPRB, 0.17001369E-05_JPRB, 0.17007770E-05_JPRB, 0.17002150E-05_JPRB, 0.16982755E-05_JPRB, 0.16948429E-05_JPRB, &
  & 0.16900487E-05_JPRB, 0.16841856E-05_JPRB, 0.16774852E-05_JPRB, 0.16700583E-05_JPRB, 0.16619254E-05_JPRB, 0.16530134E-05_JPRB, &
  & 0.16432609E-05_JPRB, 0.16325419E-05_JPRB, 0.16207807E-05_JPRB, 0.16081726E-05_JPRB, 0.15950336E-05_JPRB, 0.15817889E-05_JPRB, &
  & 0.15688674E-05_JPRB, 0.15564459E-05_JPRB, 0.15446224E-05_JPRB, 0.15333233E-05_JPRB, 0.15223131E-05_JPRB, 0.15113442E-05_JPRB, &
  & 0.15001250E-05_JPRB, 0.14883852E-05_JPRB, 0.14759765E-05_JPRB, 0.14628638E-05_JPRB, 0.14492560E-05_JPRB, 0.14355559E-05_JPRB, &
  & 0.14221279E-05_JPRB, 0.14088681E-05_JPRB, 0.13943499E-05_JPRB, 0.13706549E-05_JPRB /)

RGHG2(:,31, 3) = (/ &
  & 0.13496722E-05_JPRB, 0.13744258E-05_JPRB, 0.13888637E-05_JPRB, 0.14013171E-05_JPRB, 0.14138084E-05_JPRB, 0.14268421E-05_JPRB, &
  & 0.14404972E-05_JPRB, 0.14548676E-05_JPRB, 0.14698073E-05_JPRB, 0.14853922E-05_JPRB, 0.15017374E-05_JPRB, 0.15188367E-05_JPRB, &
  & 0.15364341E-05_JPRB, 0.15541126E-05_JPRB, 0.15715583E-05_JPRB, 0.15884840E-05_JPRB, 0.16045162E-05_JPRB, 0.16193748E-05_JPRB, &
  & 0.16329268E-05_JPRB, 0.16451504E-05_JPRB, 0.16560734E-05_JPRB, 0.16657918E-05_JPRB, 0.16744241E-05_JPRB, 0.16820387E-05_JPRB, &
  & 0.16887649E-05_JPRB, 0.16945239E-05_JPRB, 0.16995548E-05_JPRB, 0.17036443E-05_JPRB, 0.17070124E-05_JPRB, 0.17095909E-05_JPRB, &
  & 0.17113701E-05_JPRB, 0.17123401E-05_JPRB, 0.17123717E-05_JPRB, 0.17113583E-05_JPRB, 0.17091787E-05_JPRB, 0.17058343E-05_JPRB, &
  & 0.17014771E-05_JPRB, 0.16962865E-05_JPRB, 0.16904652E-05_JPRB, 0.16841191E-05_JPRB, 0.16771551E-05_JPRB, 0.16694755E-05_JPRB, &
  & 0.16609774E-05_JPRB, 0.16515205E-05_JPRB, 0.16410967E-05_JPRB, 0.16298046E-05_JPRB, 0.16179466E-05_JPRB, 0.16059346E-05_JPRB, &
  & 0.15940535E-05_JPRB, 0.15825815E-05_JPRB, 0.15715539E-05_JPRB, 0.15609193E-05_JPRB, 0.15505329E-05_JPRB, 0.15401577E-05_JPRB, &
  & 0.15295249E-05_JPRB, 0.15183919E-05_JPRB, 0.15065273E-05_JPRB, 0.14938804E-05_JPRB, 0.14806038E-05_JPRB, 0.14671413E-05_JPRB, &
  & 0.14538786E-05_JPRB, 0.14408979E-05_JPRB, 0.14268370E-05_JPRB, 0.14036693E-05_JPRB /)

RGHG2(:,32, 3) = (/ &
  & 0.13788168E-05_JPRB, 0.14024538E-05_JPRB, 0.14157242E-05_JPRB, 0.14275191E-05_JPRB, 0.14391360E-05_JPRB, 0.14512027E-05_JPRB, &
  & 0.14639102E-05_JPRB, 0.14771558E-05_JPRB, 0.14909554E-05_JPRB, 0.15054009E-05_JPRB, 0.15205894E-05_JPRB, 0.15365539E-05_JPRB, &
  & 0.15532564E-05_JPRB, 0.15703577E-05_JPRB, 0.15873660E-05_JPRB, 0.16039103E-05_JPRB, 0.16196641E-05_JPRB, 0.16343108E-05_JPRB, &
  & 0.16476604E-05_JPRB, 0.16596454E-05_JPRB, 0.16702925E-05_JPRB, 0.16797213E-05_JPRB, 0.16880027E-05_JPRB, 0.16953038E-05_JPRB, &
  & 0.17016414E-05_JPRB, 0.17070707E-05_JPRB, 0.17117634E-05_JPRB, 0.17155095E-05_JPRB, 0.17185167E-05_JPRB, 0.17206879E-05_JPRB, &
  & 0.17220207E-05_JPRB, 0.17225528E-05_JPRB, 0.17222039E-05_JPRB, 0.17209591E-05_JPRB, 0.17187469E-05_JPRB, 0.17156324E-05_JPRB, &
  & 0.17117343E-05_JPRB, 0.17072325E-05_JPRB, 0.17022901E-05_JPRB, 0.16969102E-05_JPRB, 0.16909808E-05_JPRB, 0.16843259E-05_JPRB, &
  & 0.16768165E-05_JPRB, 0.16683819E-05_JPRB, 0.16590216E-05_JPRB, 0.16488539E-05_JPRB, 0.16381297E-05_JPRB, 0.16271297E-05_JPRB, &
  & 0.16162387E-05_JPRB, 0.16055734E-05_JPRB, 0.15952455E-05_JPRB, 0.15852465E-05_JPRB, 0.15754160E-05_JPRB, 0.15656115E-05_JPRB, &
  & 0.15555756E-05_JPRB, 0.15450494E-05_JPRB, 0.15337999E-05_JPRB, 0.15217040E-05_JPRB, 0.15088743E-05_JPRB, 0.14957297E-05_JPRB, &
  & 0.14828397E-05_JPRB, 0.14701757E-05_JPRB, 0.14564737E-05_JPRB, 0.14339488E-05_JPRB /)

RGHG2(:,33, 3) = (/ &
  & 0.14066463E-05_JPRB, 0.14287421E-05_JPRB, 0.14414655E-05_JPRB, 0.14523366E-05_JPRB, 0.14632030E-05_JPRB, 0.14744544E-05_JPRB, &
  & 0.14862112E-05_JPRB, 0.14984487E-05_JPRB, 0.15111648E-05_JPRB, 0.15244951E-05_JPRB, 0.15386216E-05_JPRB, 0.15536095E-05_JPRB, &
  & 0.15693413E-05_JPRB, 0.15856301E-05_JPRB, 0.16020962E-05_JPRB, 0.16182703E-05_JPRB, 0.16337477E-05_JPRB, 0.16481492E-05_JPRB, &
  & 0.16612451E-05_JPRB, 0.16729554E-05_JPRB, 0.16832719E-05_JPRB, 0.16923518E-05_JPRB, 0.17002078E-05_JPRB, 0.17070985E-05_JPRB, &
  & 0.17129457E-05_JPRB, 0.17179320E-05_JPRB, 0.17221616E-05_JPRB, 0.17255001E-05_JPRB, 0.17281114E-05_JPRB, 0.17299158E-05_JPRB, &
  & 0.17309143E-05_JPRB, 0.17311510E-05_JPRB, 0.17306146E-05_JPRB, 0.17293096E-05_JPRB, 0.17272336E-05_JPRB, 0.17244570E-05_JPRB, &
  & 0.17211095E-05_JPRB, 0.17173348E-05_JPRB, 0.17131777E-05_JPRB, 0.17085783E-05_JPRB, 0.17034115E-05_JPRB, 0.16975350E-05_JPRB, &
  & 0.16908068E-05_JPRB, 0.16831475E-05_JPRB, 0.16746061E-05_JPRB, 0.16653199E-05_JPRB, 0.16555023E-05_JPRB, 0.16454708E-05_JPRB, &
  & 0.16353866E-05_JPRB, 0.16254921E-05_JPRB, 0.16158411E-05_JPRB, 0.16064146E-05_JPRB, 0.15971624E-05_JPRB, 0.15879251E-05_JPRB, &
  & 0.15784924E-05_JPRB, 0.15686262E-05_JPRB, 0.15580708E-05_JPRB, 0.15466521E-05_JPRB, 0.15344368E-05_JPRB, 0.15218620E-05_JPRB, &
  & 0.15094151E-05_JPRB, 0.14972223E-05_JPRB, 0.14840015E-05_JPRB, 0.14620638E-05_JPRB /)

RGHG2(:,34, 3) = (/ &
  & 0.14329805E-05_JPRB, 0.14540751E-05_JPRB, 0.14657608E-05_JPRB, 0.14760737E-05_JPRB, 0.14861719E-05_JPRB, 0.14966074E-05_JPRB, &
  & 0.15075391E-05_JPRB, 0.15188083E-05_JPRB, 0.15305019E-05_JPRB, 0.15427420E-05_JPRB, 0.15557423E-05_JPRB, 0.15696761E-05_JPRB, &
  & 0.15845465E-05_JPRB, 0.16001064E-05_JPRB, 0.16159672E-05_JPRB, 0.16316674E-05_JPRB, 0.16467720E-05_JPRB, 0.16608611E-05_JPRB, &
  & 0.16736547E-05_JPRB, 0.16850463E-05_JPRB, 0.16949946E-05_JPRB, 0.17036843E-05_JPRB, 0.17110760E-05_JPRB, 0.17174957E-05_JPRB, &
  & 0.17228085E-05_JPRB, 0.17272780E-05_JPRB, 0.17309868E-05_JPRB, 0.17338684E-05_JPRB, 0.17360760E-05_JPRB, 0.17375486E-05_JPRB, &
  & 0.17382991E-05_JPRB, 0.17383684E-05_JPRB, 0.17377838E-05_JPRB, 0.17365663E-05_JPRB, 0.17347395E-05_JPRB, 0.17323914E-05_JPRB, &
  & 0.17296217E-05_JPRB, 0.17265013E-05_JPRB, 0.17230096E-05_JPRB, 0.17190548E-05_JPRB, 0.17144782E-05_JPRB, 0.17091307E-05_JPRB, &
  & 0.17029046E-05_JPRB, 0.16957965E-05_JPRB, 0.16878657E-05_JPRB, 0.16792919E-05_JPRB, 0.16702821E-05_JPRB, 0.16610002E-05_JPRB, &
  & 0.16517072E-05_JPRB, 0.16424973E-05_JPRB, 0.16334662E-05_JPRB, 0.16246460E-05_JPRB, 0.16159537E-05_JPRB, 0.16073044E-05_JPRB, &
  & 0.15985063E-05_JPRB, 0.15893328E-05_JPRB, 0.15795438E-05_JPRB, 0.15689347E-05_JPRB, 0.15575457E-05_JPRB, 0.15456958E-05_JPRB, &
  & 0.15339454E-05_JPRB, 0.15223243E-05_JPRB, 0.15096037E-05_JPRB, 0.14883899E-05_JPRB /)

RGHG2(:,35, 3) = (/ &
  & 0.14583070E-05_JPRB, 0.14779230E-05_JPRB, 0.14891074E-05_JPRB, 0.14986070E-05_JPRB, 0.15080685E-05_JPRB, 0.15178064E-05_JPRB, &
  & 0.15278775E-05_JPRB, 0.15382426E-05_JPRB, 0.15489347E-05_JPRB, 0.15601181E-05_JPRB, 0.15720362E-05_JPRB, 0.15848861E-05_JPRB, &
  & 0.15987446E-05_JPRB, 0.16134799E-05_JPRB, 0.16287358E-05_JPRB, 0.16439850E-05_JPRB, 0.16586912E-05_JPRB, 0.16724206E-05_JPRB, &
  & 0.16848583E-05_JPRB, 0.16958913E-05_JPRB, 0.17054469E-05_JPRB, 0.17137152E-05_JPRB, 0.17206327E-05_JPRB, 0.17265138E-05_JPRB, &
  & 0.17312602E-05_JPRB, 0.17351479E-05_JPRB, 0.17382770E-05_JPRB, 0.17406633E-05_JPRB, 0.17424557E-05_JPRB, 0.17436257E-05_JPRB, &
  & 0.17441886E-05_JPRB, 0.17441866E-05_JPRB, 0.17436512E-05_JPRB, 0.17426071E-05_JPRB, 0.17411005E-05_JPRB, 0.17391953E-05_JPRB, &
  & 0.17369622E-05_JPRB, 0.17344182E-05_JPRB, 0.17314986E-05_JPRB, 0.17280812E-05_JPRB, 0.17239872E-05_JPRB, 0.17190567E-05_JPRB, &
  & 0.17132331E-05_JPRB, 0.17065040E-05_JPRB, 0.16990575E-05_JPRB, 0.16910470E-05_JPRB, 0.16826584E-05_JPRB, 0.16740821E-05_JPRB, &
  & 0.16654096E-05_JPRB, 0.16568282E-05_JPRB, 0.16483928E-05_JPRB, 0.16401278E-05_JPRB, 0.16320239E-05_JPRB, 0.16239666E-05_JPRB, &
  & 0.16158097E-05_JPRB, 0.16073628E-05_JPRB, 0.15983896E-05_JPRB, 0.15886802E-05_JPRB, 0.15782243E-05_JPRB, 0.15673115E-05_JPRB, &
  & 0.15563606E-05_JPRB, 0.15454299E-05_JPRB, 0.15333709E-05_JPRB, 0.15129436E-05_JPRB /)

RGHG2(:,36, 3) = (/ &
  & 0.14822587E-05_JPRB, 0.15008236E-05_JPRB, 0.15110912E-05_JPRB, 0.15201289E-05_JPRB, 0.15289559E-05_JPRB, 0.15379999E-05_JPRB, &
  & 0.15473072E-05_JPRB, 0.15567755E-05_JPRB, 0.15664848E-05_JPRB, 0.15766109E-05_JPRB, 0.15874358E-05_JPRB, 0.15992314E-05_JPRB, &
  & 0.16121376E-05_JPRB, 0.16260340E-05_JPRB, 0.16405827E-05_JPRB, 0.16552705E-05_JPRB, 0.16694999E-05_JPRB, 0.16828096E-05_JPRB, &
  & 0.16948409E-05_JPRB, 0.17055058E-05_JPRB, 0.17146687E-05_JPRB, 0.17224613E-05_JPRB, 0.17288554E-05_JPRB, 0.17340924E-05_JPRB, &
  & 0.17381797E-05_JPRB, 0.17413818E-05_JPRB, 0.17438872E-05_JPRB, 0.17457469E-05_JPRB, 0.17471349E-05_JPRB, 0.17480342E-05_JPRB, &
  & 0.17484595E-05_JPRB, 0.17484374E-05_JPRB, 0.17479902E-05_JPRB, 0.17471446E-05_JPRB, 0.17459387E-05_JPRB, 0.17444272E-05_JPRB, &
  & 0.17426446E-05_JPRB, 0.17405787E-05_JPRB, 0.17381522E-05_JPRB, 0.17352169E-05_JPRB, 0.17315778E-05_JPRB, 0.17270866E-05_JPRB, &
  & 0.17216379E-05_JPRB, 0.17153392E-05_JPRB, 0.17083040E-05_JPRB, 0.17008081E-05_JPRB, 0.16929855E-05_JPRB, 0.16849510E-05_JPRB, &
  & 0.16768608E-05_JPRB, 0.16688008E-05_JPRB, 0.16608842E-05_JPRB, 0.16531723E-05_JPRB, 0.16456171E-05_JPRB, 0.16381582E-05_JPRB, &
  & 0.16306612E-05_JPRB, 0.16229460E-05_JPRB, 0.16147918E-05_JPRB, 0.16060110E-05_JPRB, 0.15965593E-05_JPRB, 0.15866399E-05_JPRB, &
  & 0.15766108E-05_JPRB, 0.15664871E-05_JPRB, 0.15551484E-05_JPRB, 0.15357562E-05_JPRB /)

RGHG2(:,37, 3) = (/ &
  & 0.15051231E-05_JPRB, 0.15223341E-05_JPRB, 0.15320971E-05_JPRB, 0.15405183E-05_JPRB, 0.15488494E-05_JPRB, 0.15573154E-05_JPRB, &
  & 0.15658518E-05_JPRB, 0.15744672E-05_JPRB, 0.15832154E-05_JPRB, 0.15923074E-05_JPRB, 0.16020397E-05_JPRB, 0.16127176E-05_JPRB, &
  & 0.16245606E-05_JPRB, 0.16375596E-05_JPRB, 0.16514063E-05_JPRB, 0.16655101E-05_JPRB, 0.16792287E-05_JPRB, 0.16920787E-05_JPRB, &
  & 0.17037048E-05_JPRB, 0.17139454E-05_JPRB, 0.17226632E-05_JPRB, 0.17298809E-05_JPRB, 0.17355846E-05_JPRB, 0.17400342E-05_JPRB, &
  & 0.17433358E-05_JPRB, 0.17458382E-05_JPRB, 0.17477253E-05_JPRB, 0.17491326E-05_JPRB, 0.17501859E-05_JPRB, 0.17508810E-05_JPRB, &
  & 0.17512145E-05_JPRB, 0.17511921E-05_JPRB, 0.17508241E-05_JPRB, 0.17501327E-05_JPRB, 0.17491568E-05_JPRB, 0.17479356E-05_JPRB, &
  & 0.17464894E-05_JPRB, 0.17447987E-05_JPRB, 0.17427760E-05_JPRB, 0.17402797E-05_JPRB, 0.17371181E-05_JPRB, 0.17331029E-05_JPRB, &
  & 0.17281789E-05_JPRB, 0.17223338E-05_JPRB, 0.17158332E-05_JPRB, 0.17088331E-05_JPRB, 0.17015351E-05_JPRB, 0.16940230E-05_JPRB, &
  & 0.16863930E-05_JPRB, 0.16787858E-05_JPRB, 0.16713329E-05_JPRB, 0.16640929E-05_JPRB, 0.16570774E-05_JPRB, 0.16502062E-05_JPRB, &
  & 0.16433569E-05_JPRB, 0.16363654E-05_JPRB, 0.16290271E-05_JPRB, 0.16211538E-05_JPRB, 0.16126977E-05_JPRB, 0.16038057E-05_JPRB, &
  & 0.15947533E-05_JPRB, 0.15855056E-05_JPRB, 0.15750350E-05_JPRB, 0.15568573E-05_JPRB /)

RGHG2(:,38, 3) = (/ &
  & 0.15267760E-05_JPRB, 0.15428199E-05_JPRB, 0.15518982E-05_JPRB, 0.15599032E-05_JPRB, 0.15677981E-05_JPRB, 0.15757220E-05_JPRB, &
  & 0.15835761E-05_JPRB, 0.15913589E-05_JPRB, 0.15991649E-05_JPRB, 0.16072293E-05_JPRB, 0.16158850E-05_JPRB, 0.16254760E-05_JPRB, &
  & 0.16362631E-05_JPRB, 0.16482949E-05_JPRB, 0.16613101E-05_JPRB, 0.16747535E-05_JPRB, 0.16879064E-05_JPRB, 0.17002506E-05_JPRB, &
  & 0.17113985E-05_JPRB, 0.17211381E-05_JPRB, 0.17292517E-05_JPRB, 0.17357202E-05_JPRB, 0.17405844E-05_JPRB, 0.17441932E-05_JPRB, &
  & 0.17467628E-05_JPRB, 0.17486728E-05_JPRB, 0.17501096E-05_JPRB, 0.17511970E-05_JPRB, 0.17520358E-05_JPRB, 0.17526046E-05_JPRB, &
  & 0.17528874E-05_JPRB, 0.17528691E-05_JPRB, 0.17525527E-05_JPRB, 0.17519610E-05_JPRB, 0.17511327E-05_JPRB, 0.17501056E-05_JPRB, &
  & 0.17488939E-05_JPRB, 0.17474702E-05_JPRB, 0.17457595E-05_JPRB, 0.17436292E-05_JPRB, 0.17408977E-05_JPRB, 0.17373984E-05_JPRB, &
  & 0.17330024E-05_JPRB, 0.17277715E-05_JPRB, 0.17218114E-05_JPRB, 0.17153855E-05_JPRB, 0.17086004E-05_JPRB, 0.17015703E-05_JPRB, &
  & 0.16943671E-05_JPRB, 0.16871538E-05_JPRB, 0.16800742E-05_JPRB, 0.16732682E-05_JPRB, 0.16667382E-05_JPRB, 0.16604276E-05_JPRB, &
  & 0.16542128E-05_JPRB, 0.16479241E-05_JPRB, 0.16413742E-05_JPRB, 0.16343807E-05_JPRB, 0.16268903E-05_JPRB, 0.16190220E-05_JPRB, &
  & 0.16109633E-05_JPRB, 0.16026764E-05_JPRB, 0.15931495E-05_JPRB, 0.15764373E-05_JPRB /)

RGHG2(:,39, 3) = (/ &
  & 0.15473788E-05_JPRB, 0.15622054E-05_JPRB, 0.15706727E-05_JPRB, 0.15782609E-05_JPRB, 0.15857522E-05_JPRB, 0.15932134E-05_JPRB, &
  & 0.16004354E-05_JPRB, 0.16074271E-05_JPRB, 0.16143219E-05_JPRB, 0.16213941E-05_JPRB, 0.16289721E-05_JPRB, 0.16374380E-05_JPRB, &
  & 0.16471265E-05_JPRB, 0.16581732E-05_JPRB, 0.16703414E-05_JPRB, 0.16830579E-05_JPRB, 0.16956278E-05_JPRB, 0.17074202E-05_JPRB, &
  & 0.17179909E-05_JPRB, 0.17270274E-05_JPRB, 0.17343311E-05_JPRB, 0.17399216E-05_JPRB, 0.17439630E-05_JPRB, 0.17468622E-05_JPRB, &
  & 0.17488928E-05_JPRB, 0.17504117E-05_JPRB, 0.17515613E-05_JPRB, 0.17524636E-05_JPRB, 0.17531788E-05_JPRB, 0.17536786E-05_JPRB, &
  & 0.17539346E-05_JPRB, 0.17539196E-05_JPRB, 0.17536320E-05_JPRB, 0.17530971E-05_JPRB, 0.17523605E-05_JPRB, 0.17514584E-05_JPRB, &
  & 0.17504062E-05_JPRB, 0.17491720E-05_JPRB, 0.17476908E-05_JPRB, 0.17458433E-05_JPRB, 0.17434729E-05_JPRB, 0.17404066E-05_JPRB, &
  & 0.17365489E-05_JPRB, 0.17318670E-05_JPRB, 0.17265213E-05_JPRB, 0.17206555E-05_JPRB, 0.17144272E-05_JPRB, 0.17078765E-05_JPRB, &
  & 0.17011081E-05_JPRB, 0.16942259E-05_JPRB, 0.16874901E-05_JPRB, 0.16810396E-05_JPRB, 0.16749427E-05_JPRB, 0.16691503E-05_JPRB, &
  & 0.16635259E-05_JPRB, 0.16579158E-05_JPRB, 0.16521097E-05_JPRB, 0.16459612E-05_JPRB, 0.16394051E-05_JPRB, 0.16325382E-05_JPRB, &
  & 0.16255057E-05_JPRB, 0.16181923E-05_JPRB, 0.16097368E-05_JPRB, 0.15946598E-05_JPRB /)

RGHG2(:,40, 3) = (/ &
  & 0.15669873E-05_JPRB, 0.15805165E-05_JPRB, 0.15884040E-05_JPRB, 0.15955134E-05_JPRB, 0.16026866E-05_JPRB, 0.16097009E-05_JPRB, &
  & 0.16163425E-05_JPRB, 0.16225850E-05_JPRB, 0.16286277E-05_JPRB, 0.16347200E-05_JPRB, 0.16412687E-05_JPRB, 0.16486511E-05_JPRB, &
  & 0.16572515E-05_JPRB, 0.16672699E-05_JPRB, 0.16785523E-05_JPRB, 0.16904949E-05_JPRB, 0.17023652E-05_JPRB, 0.17135143E-05_JPRB, &
  & 0.17234129E-05_JPRB, 0.17316514E-05_JPRB, 0.17380574E-05_JPRB, 0.17428131E-05_JPRB, 0.17461753E-05_JPRB, 0.17485690E-05_JPRB, &
  & 0.17502456E-05_JPRB, 0.17515217E-05_JPRB, 0.17525022E-05_JPRB, 0.17532965E-05_JPRB, 0.17539433E-05_JPRB, 0.17544046E-05_JPRB, &
  & 0.17546450E-05_JPRB, 0.17546297E-05_JPRB, 0.17543553E-05_JPRB, 0.17538520E-05_JPRB, 0.17531702E-05_JPRB, 0.17523538E-05_JPRB, &
  & 0.17514080E-05_JPRB, 0.17503130E-05_JPRB, 0.17490014E-05_JPRB, 0.17473753E-05_JPRB, 0.17452887E-05_JPRB, 0.17425953E-05_JPRB, &
  & 0.17391758E-05_JPRB, 0.17350233E-05_JPRB, 0.17302214E-05_JPRB, 0.17249295E-05_JPRB, 0.17192472E-05_JPRB, 0.17132179E-05_JPRB, &
  & 0.17068551E-05_JPRB, 0.17003462E-05_JPRB, 0.16938850E-05_JPRB, 0.16877419E-05_JPRB, 0.16820217E-05_JPRB, 0.16766792E-05_JPRB, &
  & 0.16716052E-05_JPRB, 0.16666066E-05_JPRB, 0.16615106E-05_JPRB, 0.16561492E-05_JPRB, 0.16504944E-05_JPRB, 0.16446079E-05_JPRB, &
  & 0.16385762E-05_JPRB, 0.16322980E-05_JPRB, 0.16249237E-05_JPRB, 0.16116909E-05_JPRB /)

RGHG2(:,41, 3) = (/ &
  & 0.15855422E-05_JPRB, 0.15978476E-05_JPRB, 0.16050160E-05_JPRB, 0.16117284E-05_JPRB, 0.16184943E-05_JPRB, 0.16251154E-05_JPRB, &
  & 0.16312144E-05_JPRB, 0.16367752E-05_JPRB, 0.16419876E-05_JPRB, 0.16471912E-05_JPRB, 0.16527306E-05_JPRB, 0.16590603E-05_JPRB, &
  & 0.16666064E-05_JPRB, 0.16756328E-05_JPRB, 0.16860200E-05_JPRB, 0.16972191E-05_JPRB, 0.17083877E-05_JPRB, 0.17188083E-05_JPRB, &
  & 0.17278661E-05_JPRB, 0.17352298E-05_JPRB, 0.17407981E-05_JPRB, 0.17448367E-05_JPRB, 0.17476906E-05_JPRB, 0.17497244E-05_JPRB, &
  & 0.17511732E-05_JPRB, 0.17522949E-05_JPRB, 0.17531711E-05_JPRB, 0.17539032E-05_JPRB, 0.17545084E-05_JPRB, 0.17549473E-05_JPRB, &
  & 0.17551757E-05_JPRB, 0.17551557E-05_JPRB, 0.17548839E-05_JPRB, 0.17543960E-05_JPRB, 0.17537503E-05_JPRB, 0.17529870E-05_JPRB, &
  & 0.17521224E-05_JPRB, 0.17511269E-05_JPRB, 0.17499515E-05_JPRB, 0.17485006E-05_JPRB, 0.17466551E-05_JPRB, 0.17442710E-05_JPRB, &
  & 0.17412477E-05_JPRB, 0.17375421E-05_JPRB, 0.17332420E-05_JPRB, 0.17284793E-05_JPRB, 0.17233243E-05_JPRB, 0.17177932E-05_JPRB, &
  & 0.17119030E-05_JPRB, 0.17057230E-05_JPRB, 0.16995534E-05_JPRB, 0.16936826E-05_JPRB, 0.16882674E-05_JPRB, 0.16833376E-05_JPRB, &
  & 0.16787376E-05_JPRB, 0.16743064E-05_JPRB, 0.16698435E-05_JPRB, 0.16652269E-05_JPRB, 0.16604106E-05_JPRB, 0.16554555E-05_JPRB, &
  & 0.16504059E-05_JPRB, 0.16451091E-05_JPRB, 0.16388686E-05_JPRB, 0.16275121E-05_JPRB /)

RGHG2(:,42, 3) = (/ &
  & 0.16030384E-05_JPRB, 0.16140574E-05_JPRB, 0.16206202E-05_JPRB, 0.16267927E-05_JPRB, 0.16332046E-05_JPRB, 0.16394239E-05_JPRB, &
  & 0.16450027E-05_JPRB, 0.16499287E-05_JPRB, 0.16544050E-05_JPRB, 0.16587691E-05_JPRB, 0.16634110E-05_JPRB, 0.16687670E-05_JPRB, &
  & 0.16752934E-05_JPRB, 0.16833646E-05_JPRB, 0.16928832E-05_JPRB, 0.17032908E-05_JPRB, 0.17137670E-05_JPRB, 0.17234120E-05_JPRB, &
  & 0.17316288E-05_JPRB, 0.17380803E-05_JPRB, 0.17428756E-05_JPRB, 0.17463321E-05_JPRB, 0.17487915E-05_JPRB, 0.17505708E-05_JPRB, &
  & 0.17518651E-05_JPRB, 0.17528836E-05_JPRB, 0.17536953E-05_JPRB, 0.17543882E-05_JPRB, 0.17549685E-05_JPRB, 0.17553909E-05_JPRB, &
  & 0.17556069E-05_JPRB, 0.17555773E-05_JPRB, 0.17553012E-05_JPRB, 0.17548205E-05_JPRB, 0.17541931E-05_JPRB, 0.17534697E-05_JPRB, &
  & 0.17526581E-05_JPRB, 0.17517449E-05_JPRB, 0.17506750E-05_JPRB, 0.17493767E-05_JPRB, 0.17477387E-05_JPRB, 0.17456409E-05_JPRB, &
  & 0.17429720E-05_JPRB, 0.17396864E-05_JPRB, 0.17358378E-05_JPRB, 0.17315413E-05_JPRB, 0.17268882E-05_JPRB, 0.17218516E-05_JPRB, &
  & 0.17163986E-05_JPRB, 0.17106116E-05_JPRB, 0.17047294E-05_JPRB, 0.16991007E-05_JPRB, 0.16939988E-05_JPRB, 0.16894139E-05_JPRB, &
  & 0.16852510E-05_JPRB, 0.16813119E-05_JPRB, 0.16774275E-05_JPRB, 0.16734701E-05_JPRB, 0.16694232E-05_JPRB, 0.16653173E-05_JPRB, &
  & 0.16611615E-05_JPRB, 0.16568043E-05_JPRB, 0.16516146E-05_JPRB, 0.16421127E-05_JPRB /)

RGHG2(:,43, 3) = (/ &
  & 0.16194448E-05_JPRB, 0.16292402E-05_JPRB, 0.16351341E-05_JPRB, 0.16408096E-05_JPRB, 0.16467945E-05_JPRB, 0.16525887E-05_JPRB, &
  & 0.16577278E-05_JPRB, 0.16620608E-05_JPRB, 0.16658936E-05_JPRB, 0.16695319E-05_JPRB, 0.16733768E-05_JPRB, 0.16778426E-05_JPRB, &
  & 0.16834758E-05_JPRB, 0.16906112E-05_JPRB, 0.16993342E-05_JPRB, 0.17089900E-05_JPRB, 0.17186783E-05_JPRB, 0.17275154E-05_JPRB, &
  & 0.17348043E-05_JPRB, 0.17404058E-05_JPRB, 0.17445138E-05_JPRB, 0.17474817E-05_JPRB, 0.17496404E-05_JPRB, 0.17512277E-05_JPRB, &
  & 0.17524147E-05_JPRB, 0.17533650E-05_JPRB, 0.17541358E-05_JPRB, 0.17548072E-05_JPRB, 0.17553697E-05_JPRB, 0.17557795E-05_JPRB, &
  & 0.17559801E-05_JPRB, 0.17559366E-05_JPRB, 0.17556505E-05_JPRB, 0.17551674E-05_JPRB, 0.17545517E-05_JPRB, 0.17538503E-05_JPRB, &
  & 0.17530820E-05_JPRB, 0.17522285E-05_JPRB, 0.17512506E-05_JPRB, 0.17500831E-05_JPRB, 0.17486390E-05_JPRB, 0.17468080E-05_JPRB, &
  & 0.17444902E-05_JPRB, 0.17416098E-05_JPRB, 0.17381936E-05_JPRB, 0.17343471E-05_JPRB, 0.17301406E-05_JPRB, 0.17255672E-05_JPRB, &
  & 0.17205691E-05_JPRB, 0.17151658E-05_JPRB, 0.17096010E-05_JPRB, 0.17042793E-05_JPRB, 0.16994528E-05_JPRB, 0.16952214E-05_JPRB, &
  & 0.16914388E-05_JPRB, 0.16879371E-05_JPRB, 0.16845477E-05_JPRB, 0.16811705E-05_JPRB, 0.16777881E-05_JPRB, 0.16744225E-05_JPRB, &
  & 0.16710505E-05_JPRB, 0.16675084E-05_JPRB, 0.16632714E-05_JPRB, 0.16554606E-05_JPRB /)

RGHG2(:,44, 3) = (/ &
  & 0.16345692E-05_JPRB, 0.16433711E-05_JPRB, 0.16485742E-05_JPRB, 0.16537896E-05_JPRB, 0.16592926E-05_JPRB, 0.16647571E-05_JPRB, &
  & 0.16694008E-05_JPRB, 0.16733011E-05_JPRB, 0.16765500E-05_JPRB, 0.16795994E-05_JPRB, 0.16827551E-05_JPRB, 0.16864936E-05_JPRB, &
  & 0.16912443E-05_JPRB, 0.16976064E-05_JPRB, 0.17055056E-05_JPRB, 0.17144471E-05_JPRB, 0.17233536E-05_JPRB, 0.17312339E-05_JPRB, &
  & 0.17375872E-05_JPRB, 0.17423363E-05_JPRB, 0.17458369E-05_JPRB, 0.17484001E-05_JPRB, 0.17503165E-05_JPRB, 0.17517573E-05_JPRB, &
  & 0.17528730E-05_JPRB, 0.17537758E-05_JPRB, 0.17545262E-05_JPRB, 0.17551865E-05_JPRB, 0.17557404E-05_JPRB, 0.17561352E-05_JPRB, &
  & 0.17563170E-05_JPRB, 0.17562541E-05_JPRB, 0.17559524E-05_JPRB, 0.17554623E-05_JPRB, 0.17548471E-05_JPRB, 0.17541607E-05_JPRB, &
  & 0.17534200E-05_JPRB, 0.17526172E-05_JPRB, 0.17517148E-05_JPRB, 0.17506673E-05_JPRB, 0.17494019E-05_JPRB, 0.17478358E-05_JPRB, &
  & 0.17458701E-05_JPRB, 0.17434160E-05_JPRB, 0.17404482E-05_JPRB, 0.17370385E-05_JPRB, 0.17332742E-05_JPRB, 0.17291396E-05_JPRB, &
  & 0.17245724E-05_JPRB, 0.17195721E-05_JPRB, 0.17143813E-05_JPRB, 0.17093687E-05_JPRB, 0.17048978E-05_JPRB, 0.17009891E-05_JPRB, &
  & 0.16975573E-05_JPRB, 0.16944330E-05_JPRB, 0.16914626E-05_JPRB, 0.16885676E-05_JPRB, 0.16857391E-05_JPRB, 0.16829824E-05_JPRB, &
  & 0.16802544E-05_JPRB, 0.16774009E-05_JPRB, 0.16739668E-05_JPRB, 0.16676114E-05_JPRB /)

RGHG2(:,45, 3) = (/ &
  & 0.16486240E-05_JPRB, 0.16562608E-05_JPRB, 0.16611025E-05_JPRB, 0.16657207E-05_JPRB, 0.16709187E-05_JPRB, 0.16759320E-05_JPRB, &
  & 0.16803129E-05_JPRB, 0.16837204E-05_JPRB, 0.16865738E-05_JPRB, 0.16891008E-05_JPRB, 0.16917355E-05_JPRB, 0.16948092E-05_JPRB, &
  & 0.16989010E-05_JPRB, 0.17044213E-05_JPRB, 0.17116647E-05_JPRB, 0.17198089E-05_JPRB, 0.17278023E-05_JPRB, 0.17346672E-05_JPRB, &
  & 0.17399883E-05_JPRB, 0.17439642E-05_JPRB, 0.17469156E-05_JPRB, 0.17491409E-05_JPRB, 0.17508613E-05_JPRB, 0.17521960E-05_JPRB, &
  & 0.17532610E-05_JPRB, 0.17541378E-05_JPRB, 0.17548836E-05_JPRB, 0.17555421E-05_JPRB, 0.17560892E-05_JPRB, 0.17564704E-05_JPRB, &
  & 0.17566276E-05_JPRB, 0.17565392E-05_JPRB, 0.17562185E-05_JPRB, 0.17557140E-05_JPRB, 0.17550942E-05_JPRB, 0.17544118E-05_JPRB, &
  & 0.17536925E-05_JPRB, 0.17529269E-05_JPRB, 0.17520933E-05_JPRB, 0.17511522E-05_JPRB, 0.17500595E-05_JPRB, 0.17487508E-05_JPRB, &
  & 0.17471523E-05_JPRB, 0.17451583E-05_JPRB, 0.17426999E-05_JPRB, 0.17397844E-05_JPRB, 0.17364733E-05_JPRB, 0.17327759E-05_JPRB, &
  & 0.17286118E-05_JPRB, 0.17240163E-05_JPRB, 0.17191873E-05_JPRB, 0.17145991E-05_JPRB, 0.17104601E-05_JPRB, 0.17069065E-05_JPRB, &
  & 0.17037968E-05_JPRB, 0.17009885E-05_JPRB, 0.16983665E-05_JPRB, 0.16958566E-05_JPRB, 0.16934653E-05_JPRB, 0.16911890E-05_JPRB, &
  & 0.16889715E-05_JPRB, 0.16866575E-05_JPRB, 0.16838745E-05_JPRB, 0.16787053E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART5',1,ZHOOK_HANDLE)
END SUBROUTINE PART5




SUBROUTINE PART6
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART6',0,ZHOOK_HANDLE)



RGHG2(:,46, 3) = (/ &
  & 0.16612621E-05_JPRB, 0.16683400E-05_JPRB, 0.16725245E-05_JPRB, 0.16769336E-05_JPRB, 0.16816543E-05_JPRB, 0.16864567E-05_JPRB, &
  & 0.16904485E-05_JPRB, 0.16935853E-05_JPRB, 0.16960346E-05_JPRB, 0.16982078E-05_JPRB, 0.17004010E-05_JPRB, 0.17029985E-05_JPRB, &
  & 0.17064521E-05_JPRB, 0.17113530E-05_JPRB, 0.17178122E-05_JPRB, 0.17251489E-05_JPRB, 0.17320768E-05_JPRB, 0.17377447E-05_JPRB, &
  & 0.17420903E-05_JPRB, 0.17453160E-05_JPRB, 0.17478008E-05_JPRB, 0.17497410E-05_JPRB, 0.17513061E-05_JPRB, 0.17525589E-05_JPRB, &
  & 0.17535965E-05_JPRB, 0.17544652E-05_JPRB, 0.17552161E-05_JPRB, 0.17558823E-05_JPRB, 0.17564271E-05_JPRB, 0.17567878E-05_JPRB, &
  & 0.17569175E-05_JPRB, 0.17567986E-05_JPRB, 0.17564525E-05_JPRB, 0.17559297E-05_JPRB, 0.17552975E-05_JPRB, 0.17546154E-05_JPRB, &
  & 0.17539064E-05_JPRB, 0.17531756E-05_JPRB, 0.17523986E-05_JPRB, 0.17515594E-05_JPRB, 0.17506269E-05_JPRB, 0.17495761E-05_JPRB, &
  & 0.17483509E-05_JPRB, 0.17468657E-05_JPRB, 0.17450009E-05_JPRB, 0.17426961E-05_JPRB, 0.17399279E-05_JPRB, 0.17366772E-05_JPRB, &
  & 0.17329248E-05_JPRB, 0.17286643E-05_JPRB, 0.17242666E-05_JPRB, 0.17200123E-05_JPRB, 0.17163145E-05_JPRB, 0.17130770E-05_JPRB, &
  & 0.17102669E-05_JPRB, 0.17077425E-05_JPRB, 0.17053916E-05_JPRB, 0.17031883E-05_JPRB, 0.17011293E-05_JPRB, 0.16992178E-05_JPRB, &
  & 0.16973826E-05_JPRB, 0.16954891E-05_JPRB, 0.16932005E-05_JPRB, 0.16889692E-05_JPRB /)

RGHG2(:,47, 3) = (/ &
  & 0.16729268E-05_JPRB, 0.16792870E-05_JPRB, 0.16833139E-05_JPRB, 0.16872914E-05_JPRB, 0.16918318E-05_JPRB, 0.16963304E-05_JPRB, &
  & 0.17001075E-05_JPRB, 0.17029402E-05_JPRB, 0.17051227E-05_JPRB, 0.17069970E-05_JPRB, 0.17088729E-05_JPRB, 0.17110918E-05_JPRB, &
  & 0.17140740E-05_JPRB, 0.17183780E-05_JPRB, 0.17240718E-05_JPRB, 0.17303853E-05_JPRB, 0.17360227E-05_JPRB, 0.17404982E-05_JPRB, &
  & 0.17438566E-05_JPRB, 0.17464524E-05_JPRB, 0.17485216E-05_JPRB, 0.17502283E-05_JPRB, 0.17516656E-05_JPRB, 0.17528675E-05_JPRB, &
  & 0.17538919E-05_JPRB, 0.17547649E-05_JPRB, 0.17555387E-05_JPRB, 0.17562138E-05_JPRB, 0.17567544E-05_JPRB, 0.17570937E-05_JPRB, &
  & 0.17571883E-05_JPRB, 0.17570336E-05_JPRB, 0.17566588E-05_JPRB, 0.17561115E-05_JPRB, 0.17554639E-05_JPRB, 0.17547743E-05_JPRB, &
  & 0.17540765E-05_JPRB, 0.17533696E-05_JPRB, 0.17526486E-05_JPRB, 0.17518995E-05_JPRB, 0.17511238E-05_JPRB, 0.17503188E-05_JPRB, &
  & 0.17494742E-05_JPRB, 0.17485185E-05_JPRB, 0.17473453E-05_JPRB, 0.17457836E-05_JPRB, 0.17437217E-05_JPRB, 0.17410453E-05_JPRB, &
  & 0.17376739E-05_JPRB, 0.17338010E-05_JPRB, 0.17296654E-05_JPRB, 0.17258939E-05_JPRB, 0.17224936E-05_JPRB, 0.17196152E-05_JPRB, &
  & 0.17170701E-05_JPRB, 0.17147746E-05_JPRB, 0.17126557E-05_JPRB, 0.17106763E-05_JPRB, 0.17088696E-05_JPRB, 0.17072236E-05_JPRB, &
  & 0.17056733E-05_JPRB, 0.17040785E-05_JPRB, 0.17021666E-05_JPRB, 0.16986229E-05_JPRB /)

RGHG2(:,48, 3) = (/ &
  & 0.16835759E-05_JPRB, 0.16895572E-05_JPRB, 0.16933295E-05_JPRB, 0.16971742E-05_JPRB, 0.17015129E-05_JPRB, 0.17058394E-05_JPRB, &
  & 0.17094148E-05_JPRB, 0.17120217E-05_JPRB, 0.17139834E-05_JPRB, 0.17156303E-05_JPRB, 0.17172719E-05_JPRB, 0.17191946E-05_JPRB, &
  & 0.17218019E-05_JPRB, 0.17254558E-05_JPRB, 0.17303191E-05_JPRB, 0.17352741E-05_JPRB, 0.17395553E-05_JPRB, 0.17428217E-05_JPRB, &
  & 0.17453561E-05_JPRB, 0.17473837E-05_JPRB, 0.17491118E-05_JPRB, 0.17506211E-05_JPRB, 0.17519618E-05_JPRB, 0.17531313E-05_JPRB, &
  & 0.17541597E-05_JPRB, 0.17550565E-05_JPRB, 0.17558496E-05_JPRB, 0.17565421E-05_JPRB, 0.17570765E-05_JPRB, 0.17573856E-05_JPRB, &
  & 0.17574419E-05_JPRB, 0.17572484E-05_JPRB, 0.17568389E-05_JPRB, 0.17562639E-05_JPRB, 0.17555966E-05_JPRB, 0.17548997E-05_JPRB, &
  & 0.17542061E-05_JPRB, 0.17535251E-05_JPRB, 0.17528505E-05_JPRB, 0.17521897E-05_JPRB, 0.17515586E-05_JPRB, 0.17509933E-05_JPRB, &
  & 0.17505098E-05_JPRB, 0.17500837E-05_JPRB, 0.17496000E-05_JPRB, 0.17488917E-05_JPRB, 0.17476788E-05_JPRB, 0.17457450E-05_JPRB, &
  & 0.17429741E-05_JPRB, 0.17394177E-05_JPRB, 0.17357528E-05_JPRB, 0.17322382E-05_JPRB, 0.17292609E-05_JPRB, 0.17266353E-05_JPRB, &
  & 0.17243287E-05_JPRB, 0.17222275E-05_JPRB, 0.17202699E-05_JPRB, 0.17184618E-05_JPRB, 0.17168275E-05_JPRB, 0.17153691E-05_JPRB, &
  & 0.17140112E-05_JPRB, 0.17126326E-05_JPRB, 0.17109719E-05_JPRB, 0.17079243E-05_JPRB /)

RGHG2(:,49, 3) = (/ &
  & 0.16933848E-05_JPRB, 0.16992252E-05_JPRB, 0.17028593E-05_JPRB, 0.17066749E-05_JPRB, 0.17109253E-05_JPRB, 0.17151887E-05_JPRB, &
  & 0.17185921E-05_JPRB, 0.17210177E-05_JPRB, 0.17227885E-05_JPRB, 0.17242526E-05_JPRB, 0.17256958E-05_JPRB, 0.17273333E-05_JPRB, &
  & 0.17295088E-05_JPRB, 0.17324919E-05_JPRB, 0.17360267E-05_JPRB, 0.17396126E-05_JPRB, 0.17424954E-05_JPRB, 0.17447658E-05_JPRB, &
  & 0.17465860E-05_JPRB, 0.17481598E-05_JPRB, 0.17495945E-05_JPRB, 0.17509428E-05_JPRB, 0.17522083E-05_JPRB, 0.17533679E-05_JPRB, &
  & 0.17544156E-05_JPRB, 0.17553394E-05_JPRB, 0.17561670E-05_JPRB, 0.17568673E-05_JPRB, 0.17573891E-05_JPRB, 0.17576660E-05_JPRB, &
  & 0.17576795E-05_JPRB, 0.17574453E-05_JPRB, 0.17569971E-05_JPRB, 0.17563925E-05_JPRB, 0.17557031E-05_JPRB, 0.17549969E-05_JPRB, &
  & 0.17543086E-05_JPRB, 0.17536474E-05_JPRB, 0.17530180E-05_JPRB, 0.17524362E-05_JPRB, 0.17519446E-05_JPRB, 0.17516035E-05_JPRB, &
  & 0.17514603E-05_JPRB, 0.17515066E-05_JPRB, 0.17516513E-05_JPRB, 0.17516836E-05_JPRB, 0.17513420E-05_JPRB, 0.17503027E-05_JPRB, &
  & 0.17483023E-05_JPRB, 0.17455159E-05_JPRB, 0.17422740E-05_JPRB, 0.17393265E-05_JPRB, 0.17366674E-05_JPRB, 0.17343264E-05_JPRB, &
  & 0.17322113E-05_JPRB, 0.17302538E-05_JPRB, 0.17284094E-05_JPRB, 0.17267005E-05_JPRB, 0.17251726E-05_JPRB, 0.17238244E-05_JPRB, &
  & 0.17225890E-05_JPRB, 0.17213379E-05_JPRB, 0.17198387E-05_JPRB, 0.17171005E-05_JPRB /)

RGHG2(:,50, 3) = (/ &
  & 0.17025779E-05_JPRB, 0.17083502E-05_JPRB, 0.17120211E-05_JPRB, 0.17158704E-05_JPRB, 0.17202251E-05_JPRB, 0.17244799E-05_JPRB, &
  & 0.17277314E-05_JPRB, 0.17299633E-05_JPRB, 0.17315110E-05_JPRB, 0.17327611E-05_JPRB, 0.17338958E-05_JPRB, 0.17351983E-05_JPRB, &
  & 0.17367204E-05_JPRB, 0.17386797E-05_JPRB, 0.17409606E-05_JPRB, 0.17430806E-05_JPRB, 0.17448775E-05_JPRB, 0.17463343E-05_JPRB, &
  & 0.17476078E-05_JPRB, 0.17488082E-05_JPRB, 0.17499995E-05_JPRB, 0.17512092E-05_JPRB, 0.17524235E-05_JPRB, 0.17535888E-05_JPRB, &
  & 0.17546685E-05_JPRB, 0.17556342E-05_JPRB, 0.17564853E-05_JPRB, 0.17571919E-05_JPRB, 0.17576934E-05_JPRB, 0.17579340E-05_JPRB, &
  & 0.17579043E-05_JPRB, 0.17576272E-05_JPRB, 0.17571392E-05_JPRB, 0.17565009E-05_JPRB, 0.17557903E-05_JPRB, 0.17550735E-05_JPRB, &
  & 0.17543884E-05_JPRB, 0.17537458E-05_JPRB, 0.17531554E-05_JPRB, 0.17526493E-05_JPRB, 0.17522900E-05_JPRB, 0.17521628E-05_JPRB, &
  & 0.17523301E-05_JPRB, 0.17527793E-05_JPRB, 0.17534068E-05_JPRB, 0.17539905E-05_JPRB, 0.17542969E-05_JPRB, 0.17540406E-05_JPRB, &
  & 0.17530001E-05_JPRB, 0.17511051E-05_JPRB, 0.17489044E-05_JPRB, 0.17466368E-05_JPRB, 0.17445224E-05_JPRB, 0.17425757E-05_JPRB, &
  & 0.17406987E-05_JPRB, 0.17388907E-05_JPRB, 0.17371539E-05_JPRB, 0.17354987E-05_JPRB, 0.17340211E-05_JPRB, 0.17327276E-05_JPRB, &
  & 0.17315465E-05_JPRB, 0.17303557E-05_JPRB, 0.17289392E-05_JPRB, 0.17263484E-05_JPRB /)

RGHG2(:,51, 3) = (/ &
  & 0.17113314E-05_JPRB, 0.17169649E-05_JPRB, 0.17208590E-05_JPRB, 0.17247619E-05_JPRB, 0.17293017E-05_JPRB, 0.17334462E-05_JPRB, &
  & 0.17364487E-05_JPRB, 0.17382840E-05_JPRB, 0.17394865E-05_JPRB, 0.17403389E-05_JPRB, 0.17410987E-05_JPRB, 0.17417982E-05_JPRB, &
  & 0.17426562E-05_JPRB, 0.17436162E-05_JPRB, 0.17447126E-05_JPRB, 0.17457988E-05_JPRB, 0.17467489E-05_JPRB, 0.17476159E-05_JPRB, &
  & 0.17484688E-05_JPRB, 0.17493649E-05_JPRB, 0.17503537E-05_JPRB, 0.17514479E-05_JPRB, 0.17526205E-05_JPRB, 0.17538079E-05_JPRB, &
  & 0.17549310E-05_JPRB, 0.17559369E-05_JPRB, 0.17568135E-05_JPRB, 0.17575153E-05_JPRB, 0.17579900E-05_JPRB, 0.17581932E-05_JPRB, &
  & 0.17581201E-05_JPRB, 0.17577972E-05_JPRB, 0.17572683E-05_JPRB, 0.17565944E-05_JPRB, 0.17558616E-05_JPRB, 0.17551342E-05_JPRB, &
  & 0.17544513E-05_JPRB, 0.17538243E-05_JPRB, 0.17532710E-05_JPRB, 0.17528364E-05_JPRB, 0.17526054E-05_JPRB, 0.17526847E-05_JPRB, &
  & 0.17531348E-05_JPRB, 0.17539207E-05_JPRB, 0.17548673E-05_JPRB, 0.17558255E-05_JPRB, 0.17565244E-05_JPRB, 0.17568145E-05_JPRB, &
  & 0.17564980E-05_JPRB, 0.17556345E-05_JPRB, 0.17544005E-05_JPRB, 0.17531029E-05_JPRB, 0.17518107E-05_JPRB, 0.17504321E-05_JPRB, &
  & 0.17490418E-05_JPRB, 0.17475811E-05_JPRB, 0.17460404E-05_JPRB, 0.17445401E-05_JPRB, 0.17431399E-05_JPRB, 0.17418993E-05_JPRB, &
  & 0.17407622E-05_JPRB, 0.17396113E-05_JPRB, 0.17382223E-05_JPRB, 0.17357225E-05_JPRB /)

RGHG2(:,52, 3) = (/ &
  & 0.17192727E-05_JPRB, 0.17253983E-05_JPRB, 0.17289899E-05_JPRB, 0.17332263E-05_JPRB, 0.17375176E-05_JPRB, 0.17412835E-05_JPRB, &
  & 0.17435443E-05_JPRB, 0.17448131E-05_JPRB, 0.17455201E-05_JPRB, 0.17459863E-05_JPRB, 0.17463071E-05_JPRB, 0.17466106E-05_JPRB, &
  & 0.17468724E-05_JPRB, 0.17471841E-05_JPRB, 0.17475199E-05_JPRB, 0.17478765E-05_JPRB, 0.17482541E-05_JPRB, 0.17486841E-05_JPRB, &
  & 0.17492086E-05_JPRB, 0.17498669E-05_JPRB, 0.17506801E-05_JPRB, 0.17516750E-05_JPRB, 0.17528224E-05_JPRB, 0.17540342E-05_JPRB, &
  & 0.17552038E-05_JPRB, 0.17562512E-05_JPRB, 0.17571446E-05_JPRB, 0.17578367E-05_JPRB, 0.17582818E-05_JPRB, 0.17584463E-05_JPRB, &
  & 0.17583307E-05_JPRB, 0.17579595E-05_JPRB, 0.17573884E-05_JPRB, 0.17566776E-05_JPRB, 0.17559211E-05_JPRB, 0.17551833E-05_JPRB, &
  & 0.17545017E-05_JPRB, 0.17538902E-05_JPRB, 0.17533715E-05_JPRB, 0.17530069E-05_JPRB, 0.17529028E-05_JPRB, 0.17531810E-05_JPRB, &
  & 0.17538856E-05_JPRB, 0.17549146E-05_JPRB, 0.17561274E-05_JPRB, 0.17572506E-05_JPRB, 0.17582202E-05_JPRB, 0.17588234E-05_JPRB, &
  & 0.17590011E-05_JPRB, 0.17587640E-05_JPRB, 0.17583092E-05_JPRB, 0.17577615E-05_JPRB, 0.17571285E-05_JPRB, 0.17564597E-05_JPRB, &
  & 0.17556508E-05_JPRB, 0.17547172E-05_JPRB, 0.17536728E-05_JPRB, 0.17525153E-05_JPRB, 0.17514005E-05_JPRB, 0.17503695E-05_JPRB, &
  & 0.17493883E-05_JPRB, 0.17483658E-05_JPRB, 0.17471127E-05_JPRB, 0.17447342E-05_JPRB /)

RGHG2(:,53, 3) = (/ &
  & 0.17270896E-05_JPRB, 0.17326141E-05_JPRB, 0.17367712E-05_JPRB, 0.17403722E-05_JPRB, 0.17442545E-05_JPRB, 0.17469467E-05_JPRB, &
  & 0.17483972E-05_JPRB, 0.17490833E-05_JPRB, 0.17494328E-05_JPRB, 0.17496168E-05_JPRB, 0.17497255E-05_JPRB, 0.17497705E-05_JPRB, &
  & 0.17497700E-05_JPRB, 0.17497219E-05_JPRB, 0.17496259E-05_JPRB, 0.17495306E-05_JPRB, 0.17495022E-05_JPRB, 0.17496022E-05_JPRB, &
  & 0.17498693E-05_JPRB, 0.17503244E-05_JPRB, 0.17510010E-05_JPRB, 0.17519133E-05_JPRB, 0.17530381E-05_JPRB, 0.17542781E-05_JPRB, &
  & 0.17554883E-05_JPRB, 0.17565711E-05_JPRB, 0.17574778E-05_JPRB, 0.17581581E-05_JPRB, 0.17585721E-05_JPRB, 0.17586968E-05_JPRB, &
  & 0.17585392E-05_JPRB, 0.17581189E-05_JPRB, 0.17575028E-05_JPRB, 0.17567545E-05_JPRB, 0.17559738E-05_JPRB, 0.17552239E-05_JPRB, &
  & 0.17545451E-05_JPRB, 0.17539481E-05_JPRB, 0.17534664E-05_JPRB, 0.17531722E-05_JPRB, 0.17531905E-05_JPRB, 0.17536513E-05_JPRB, &
  & 0.17545682E-05_JPRB, 0.17558231E-05_JPRB, 0.17571477E-05_JPRB, 0.17584649E-05_JPRB, 0.17595294E-05_JPRB, 0.17603396E-05_JPRB, &
  & 0.17607864E-05_JPRB, 0.17609050E-05_JPRB, 0.17608364E-05_JPRB, 0.17606744E-05_JPRB, 0.17604673E-05_JPRB, 0.17601783E-05_JPRB, &
  & 0.17598284E-05_JPRB, 0.17593723E-05_JPRB, 0.17587877E-05_JPRB, 0.17581306E-05_JPRB, 0.17574366E-05_JPRB, 0.17567662E-05_JPRB, &
  & 0.17561110E-05_JPRB, 0.17553857E-05_JPRB, 0.17544278E-05_JPRB, 0.17525230E-05_JPRB /)

RGHG2(:,54, 3) = (/ &
  & 0.17337203E-05_JPRB, 0.17397733E-05_JPRB, 0.17429398E-05_JPRB, 0.17462679E-05_JPRB, 0.17489475E-05_JPRB, 0.17506779E-05_JPRB, &
  & 0.17514581E-05_JPRB, 0.17517953E-05_JPRB, 0.17519367E-05_JPRB, 0.17519916E-05_JPRB, 0.17519910E-05_JPRB, 0.17519369E-05_JPRB, &
  & 0.17518330E-05_JPRB, 0.17516086E-05_JPRB, 0.17512998E-05_JPRB, 0.17509162E-05_JPRB, 0.17505885E-05_JPRB, 0.17504216E-05_JPRB, &
  & 0.17504693E-05_JPRB, 0.17507615E-05_JPRB, 0.17513198E-05_JPRB, 0.17521725E-05_JPRB, 0.17532836E-05_JPRB, 0.17545406E-05_JPRB, &
  & 0.17557841E-05_JPRB, 0.17568948E-05_JPRB, 0.17578128E-05_JPRB, 0.17584813E-05_JPRB, 0.17588666E-05_JPRB, 0.17589502E-05_JPRB, &
  & 0.17587486E-05_JPRB, 0.17582809E-05_JPRB, 0.17576153E-05_JPRB, 0.17568318E-05_JPRB, 0.17560232E-05_JPRB, 0.17552638E-05_JPRB, &
  & 0.17545855E-05_JPRB, 0.17540077E-05_JPRB, 0.17535646E-05_JPRB, 0.17533430E-05_JPRB, 0.17534765E-05_JPRB, 0.17540953E-05_JPRB, &
  & 0.17551979E-05_JPRB, 0.17565837E-05_JPRB, 0.17580888E-05_JPRB, 0.17594394E-05_JPRB, 0.17606453E-05_JPRB, 0.17615498E-05_JPRB, &
  & 0.17621219E-05_JPRB, 0.17624129E-05_JPRB, 0.17625199E-05_JPRB, 0.17625372E-05_JPRB, 0.17625015E-05_JPRB, 0.17624265E-05_JPRB, &
  & 0.17622953E-05_JPRB, 0.17621054E-05_JPRB, 0.17618493E-05_JPRB, 0.17615217E-05_JPRB, 0.17611744E-05_JPRB, 0.17608343E-05_JPRB, &
  & 0.17604824E-05_JPRB, 0.17600892E-05_JPRB, 0.17595454E-05_JPRB, 0.17583818E-05_JPRB /)

RGHG2(:,55, 3) = (/ &
  & 0.17402124E-05_JPRB, 0.17451824E-05_JPRB, 0.17481918E-05_JPRB, 0.17503830E-05_JPRB, 0.17521293E-05_JPRB, 0.17531088E-05_JPRB, &
  & 0.17535058E-05_JPRB, 0.17536485E-05_JPRB, 0.17536894E-05_JPRB, 0.17536818E-05_JPRB, 0.17536368E-05_JPRB, 0.17535583E-05_JPRB, &
  & 0.17533916E-05_JPRB, 0.17531476E-05_JPRB, 0.17527034E-05_JPRB, 0.17521434E-05_JPRB, 0.17515799E-05_JPRB, 0.17511774E-05_JPRB, &
  & 0.17510308E-05_JPRB, 0.17511793E-05_JPRB, 0.17516516E-05_JPRB, 0.17524583E-05_JPRB, 0.17535598E-05_JPRB, 0.17548258E-05_JPRB, &
  & 0.17560922E-05_JPRB, 0.17572268E-05_JPRB, 0.17581546E-05_JPRB, 0.17588148E-05_JPRB, 0.17591702E-05_JPRB, 0.17592117E-05_JPRB, &
  & 0.17589637E-05_JPRB, 0.17584495E-05_JPRB, 0.17577344E-05_JPRB, 0.17569126E-05_JPRB, 0.17560787E-05_JPRB, 0.17553073E-05_JPRB, &
  & 0.17546329E-05_JPRB, 0.17540756E-05_JPRB, 0.17536776E-05_JPRB, 0.17535283E-05_JPRB, 0.17537662E-05_JPRB, 0.17545165E-05_JPRB, &
  & 0.17557456E-05_JPRB, 0.17572945E-05_JPRB, 0.17588513E-05_JPRB, 0.17603547E-05_JPRB, 0.17615864E-05_JPRB, 0.17625682E-05_JPRB, &
  & 0.17632085E-05_JPRB, 0.17635532E-05_JPRB, 0.17637315E-05_JPRB, 0.17638259E-05_JPRB, 0.17638677E-05_JPRB, 0.17638794E-05_JPRB, &
  & 0.17638607E-05_JPRB, 0.17638069E-05_JPRB, 0.17637120E-05_JPRB, 0.17635824E-05_JPRB, 0.17634312E-05_JPRB, 0.17632738E-05_JPRB, &
  & 0.17631137E-05_JPRB, 0.17629147E-05_JPRB, 0.17626148E-05_JPRB, 0.17618154E-05_JPRB /)

RGHG2(:,56, 3) = (/ &
  & 0.17455171E-05_JPRB, 0.17498585E-05_JPRB, 0.17518347E-05_JPRB, 0.17532714E-05_JPRB, 0.17543110E-05_JPRB, 0.17548296E-05_JPRB, &
  & 0.17550167E-05_JPRB, 0.17550611E-05_JPRB, 0.17550540E-05_JPRB, 0.17550194E-05_JPRB, 0.17549642E-05_JPRB, 0.17548633E-05_JPRB, &
  & 0.17547197E-05_JPRB, 0.17544204E-05_JPRB, 0.17539721E-05_JPRB, 0.17532795E-05_JPRB, 0.17525186E-05_JPRB, 0.17519004E-05_JPRB, &
  & 0.17515737E-05_JPRB, 0.17515995E-05_JPRB, 0.17520010E-05_JPRB, 0.17527792E-05_JPRB, 0.17538667E-05_JPRB, 0.17551397E-05_JPRB, &
  & 0.17564189E-05_JPRB, 0.17575755E-05_JPRB, 0.17585130E-05_JPRB, 0.17591617E-05_JPRB, 0.17594904E-05_JPRB, 0.17594889E-05_JPRB, &
  & 0.17591910E-05_JPRB, 0.17586300E-05_JPRB, 0.17578682E-05_JPRB, 0.17570057E-05_JPRB, 0.17561479E-05_JPRB, 0.17553638E-05_JPRB, &
  & 0.17546942E-05_JPRB, 0.17541623E-05_JPRB, 0.17538114E-05_JPRB, 0.17537359E-05_JPRB, 0.17540679E-05_JPRB, 0.17549144E-05_JPRB, &
  & 0.17562617E-05_JPRB, 0.17578832E-05_JPRB, 0.17595922E-05_JPRB, 0.17611176E-05_JPRB, 0.17624620E-05_JPRB, 0.17634696E-05_JPRB, &
  & 0.17641129E-05_JPRB, 0.17644901E-05_JPRB, 0.17646917E-05_JPRB, 0.17648093E-05_JPRB, 0.17648891E-05_JPRB, 0.17649379E-05_JPRB, &
  & 0.17649697E-05_JPRB, 0.17649808E-05_JPRB, 0.17649693E-05_JPRB, 0.17649350E-05_JPRB, 0.17648861E-05_JPRB, 0.17648332E-05_JPRB, &
  & 0.17647760E-05_JPRB, 0.17647183E-05_JPRB, 0.17646540E-05_JPRB, 0.17645879E-05_JPRB /)

RGHG2(:,57, 3) = (/ &
  & 0.17500379E-05_JPRB, 0.17531537E-05_JPRB, 0.17544616E-05_JPRB, 0.17553577E-05_JPRB, 0.17559034E-05_JPRB, 0.17561814E-05_JPRB, &
  & 0.17562515E-05_JPRB, 0.17562477E-05_JPRB, 0.17562184E-05_JPRB, 0.17561748E-05_JPRB, 0.17561108E-05_JPRB, 0.17560235E-05_JPRB, &
  & 0.17558577E-05_JPRB, 0.17556058E-05_JPRB, 0.17551017E-05_JPRB, 0.17543534E-05_JPRB, 0.17534271E-05_JPRB, 0.17526123E-05_JPRB, &
  & 0.17521234E-05_JPRB, 0.17520429E-05_JPRB, 0.17523882E-05_JPRB, 0.17531370E-05_JPRB, 0.17542166E-05_JPRB, 0.17554820E-05_JPRB, &
  & 0.17567812E-05_JPRB, 0.17579506E-05_JPRB, 0.17588950E-05_JPRB, 0.17595341E-05_JPRB, 0.17598325E-05_JPRB, 0.17597894E-05_JPRB, &
  & 0.17594416E-05_JPRB, 0.17588322E-05_JPRB, 0.17580255E-05_JPRB, 0.17571218E-05_JPRB, 0.17562397E-05_JPRB, 0.17554440E-05_JPRB, &
  & 0.17547829E-05_JPRB, 0.17542774E-05_JPRB, 0.17539763E-05_JPRB, 0.17539719E-05_JPRB, 0.17543847E-05_JPRB, 0.17553176E-05_JPRB, &
  & 0.17567259E-05_JPRB, 0.17584576E-05_JPRB, 0.17602041E-05_JPRB, 0.17618681E-05_JPRB, 0.17632303E-05_JPRB, 0.17642756E-05_JPRB, &
  & 0.17649352E-05_JPRB, 0.17652972E-05_JPRB, 0.17655066E-05_JPRB, 0.17656387E-05_JPRB, 0.17657242E-05_JPRB, 0.17657939E-05_JPRB, &
  & 0.17658441E-05_JPRB, 0.17658830E-05_JPRB, 0.17659081E-05_JPRB, 0.17659177E-05_JPRB, 0.17659133E-05_JPRB, 0.17658988E-05_JPRB, &
  & 0.17658779E-05_JPRB, 0.17658460E-05_JPRB, 0.17657978E-05_JPRB, 0.17656922E-05_JPRB /)

RGHG2(:,58, 3) = (/ &
  & 0.17537006E-05_JPRB, 0.17556036E-05_JPRB, 0.17564323E-05_JPRB, 0.17568972E-05_JPRB, 0.17572199E-05_JPRB, 0.17573375E-05_JPRB, &
  & 0.17573493E-05_JPRB, 0.17573221E-05_JPRB, 0.17572831E-05_JPRB, 0.17572349E-05_JPRB, 0.17571755E-05_JPRB, 0.17570799E-05_JPRB, &
  & 0.17569423E-05_JPRB, 0.17566556E-05_JPRB, 0.17561847E-05_JPRB, 0.17553575E-05_JPRB, 0.17543055E-05_JPRB, 0.17533242E-05_JPRB, &
  & 0.17527015E-05_JPRB, 0.17525305E-05_JPRB, 0.17528240E-05_JPRB, 0.17535463E-05_JPRB, 0.17546072E-05_JPRB, 0.17558805E-05_JPRB, &
  & 0.17571814E-05_JPRB, 0.17583667E-05_JPRB, 0.17593109E-05_JPRB, 0.17599349E-05_JPRB, 0.17602054E-05_JPRB, 0.17601220E-05_JPRB, &
  & 0.17597262E-05_JPRB, 0.17590663E-05_JPRB, 0.17582163E-05_JPRB, 0.17572729E-05_JPRB, 0.17563655E-05_JPRB, 0.17555602E-05_JPRB, &
  & 0.17549088E-05_JPRB, 0.17544326E-05_JPRB, 0.17541801E-05_JPRB, 0.17542418E-05_JPRB, 0.17547295E-05_JPRB, 0.17557244E-05_JPRB, &
  & 0.17572014E-05_JPRB, 0.17589690E-05_JPRB, 0.17608221E-05_JPRB, 0.17625009E-05_JPRB, 0.17639617E-05_JPRB, 0.17650169E-05_JPRB, &
  & 0.17656625E-05_JPRB, 0.17660351E-05_JPRB, 0.17662417E-05_JPRB, 0.17663721E-05_JPRB, 0.17664676E-05_JPRB, 0.17665366E-05_JPRB, &
  & 0.17665959E-05_JPRB, 0.17666441E-05_JPRB, 0.17666821E-05_JPRB, 0.17667096E-05_JPRB, 0.17667235E-05_JPRB, 0.17667253E-05_JPRB, &
  & 0.17667174E-05_JPRB, 0.17666994E-05_JPRB, 0.17666630E-05_JPRB, 0.17665723E-05_JPRB /)

RGHG2(:,59, 3) = (/ &
  & 0.17561315E-05_JPRB, 0.17574569E-05_JPRB, 0.17579134E-05_JPRB, 0.17582113E-05_JPRB, 0.17583563E-05_JPRB, 0.17584032E-05_JPRB, &
  & 0.17583844E-05_JPRB, 0.17583454E-05_JPRB, 0.17583044E-05_JPRB, 0.17582574E-05_JPRB, 0.17581960E-05_JPRB, 0.17581119E-05_JPRB, &
  & 0.17579565E-05_JPRB, 0.17577013E-05_JPRB, 0.17571725E-05_JPRB, 0.17563088E-05_JPRB, 0.17551472E-05_JPRB, 0.17540482E-05_JPRB, &
  & 0.17533204E-05_JPRB, 0.17530778E-05_JPRB, 0.17533234E-05_JPRB, 0.17540148E-05_JPRB, 0.17550657E-05_JPRB, 0.17563307E-05_JPRB, &
  & 0.17576434E-05_JPRB, 0.17588287E-05_JPRB, 0.17597682E-05_JPRB, 0.17603759E-05_JPRB, 0.17606164E-05_JPRB, 0.17604959E-05_JPRB, &
  & 0.17600554E-05_JPRB, 0.17593486E-05_JPRB, 0.17584521E-05_JPRB, 0.17574740E-05_JPRB, 0.17565375E-05_JPRB, 0.17557264E-05_JPRB, &
  & 0.17550867E-05_JPRB, 0.17546374E-05_JPRB, 0.17544319E-05_JPRB, 0.17545543E-05_JPRB, 0.17551060E-05_JPRB, 0.17561631E-05_JPRB, &
  & 0.17576771E-05_JPRB, 0.17594990E-05_JPRB, 0.17613687E-05_JPRB, 0.17631348E-05_JPRB, 0.17646001E-05_JPRB, 0.17656906E-05_JPRB, &
  & 0.17663558E-05_JPRB, 0.17667172E-05_JPRB, 0.17669287E-05_JPRB, 0.17670619E-05_JPRB, 0.17671518E-05_JPRB, 0.17672251E-05_JPRB, &
  & 0.17672817E-05_JPRB, 0.17673303E-05_JPRB, 0.17673710E-05_JPRB, 0.17674020E-05_JPRB, 0.17674209E-05_JPRB, 0.17674283E-05_JPRB, &
  & 0.17674251E-05_JPRB, 0.17674101E-05_JPRB, 0.17673767E-05_JPRB, 0.17672817E-05_JPRB /)

RGHG2(:,60, 3) = (/ &
  & 0.17583691E-05_JPRB, 0.17589548E-05_JPRB, 0.17592180E-05_JPRB, 0.17593510E-05_JPRB, 0.17594268E-05_JPRB, 0.17594301E-05_JPRB, &
  & 0.17593954E-05_JPRB, 0.17593545E-05_JPRB, 0.17593125E-05_JPRB, 0.17592664E-05_JPRB, 0.17592097E-05_JPRB, 0.17591196E-05_JPRB, &
  & 0.17589780E-05_JPRB, 0.17586806E-05_JPRB, 0.17581475E-05_JPRB, 0.17572007E-05_JPRB, 0.17559609E-05_JPRB, 0.17547867E-05_JPRB, &
  & 0.17539953E-05_JPRB, 0.17536925E-05_JPRB, 0.17538948E-05_JPRB, 0.17545602E-05_JPRB, 0.17555950E-05_JPRB, 0.17568572E-05_JPRB, &
  & 0.17581652E-05_JPRB, 0.17593475E-05_JPRB, 0.17602746E-05_JPRB, 0.17608611E-05_JPRB, 0.17610735E-05_JPRB, 0.17609198E-05_JPRB, &
  & 0.17604419E-05_JPRB, 0.17596900E-05_JPRB, 0.17587518E-05_JPRB, 0.17577366E-05_JPRB, 0.17567738E-05_JPRB, 0.17559557E-05_JPRB, &
  & 0.17553261E-05_JPRB, 0.17549047E-05_JPRB, 0.17547413E-05_JPRB, 0.17549173E-05_JPRB, 0.17555277E-05_JPRB, 0.17566322E-05_JPRB, &
  & 0.17581876E-05_JPRB, 0.17600291E-05_JPRB, 0.17619395E-05_JPRB, 0.17636977E-05_JPRB, 0.17652147E-05_JPRB, 0.17663168E-05_JPRB, &
  & 0.17669915E-05_JPRB, 0.17673746E-05_JPRB, 0.17675870E-05_JPRB, 0.17677185E-05_JPRB, 0.17678107E-05_JPRB, 0.17678765E-05_JPRB, &
  & 0.17679306E-05_JPRB, 0.17679747E-05_JPRB, 0.17680105E-05_JPRB, 0.17680387E-05_JPRB, 0.17680559E-05_JPRB, 0.17680618E-05_JPRB, &
  & 0.17680582E-05_JPRB, 0.17680444E-05_JPRB, 0.17680127E-05_JPRB, 0.17679280E-05_JPRB /)

RGHG2(:,61, 3) = (/ &
  & 0.17596778E-05_JPRB, 0.17601615E-05_JPRB, 0.17603264E-05_JPRB, 0.17604202E-05_JPRB, 0.17604546E-05_JPRB, 0.17604439E-05_JPRB, &
  & 0.17604090E-05_JPRB, 0.17603679E-05_JPRB, 0.17603292E-05_JPRB, 0.17602863E-05_JPRB, 0.17602297E-05_JPRB, 0.17601456E-05_JPRB, &
  & 0.17599834E-05_JPRB, 0.17596864E-05_JPRB, 0.17590694E-05_JPRB, 0.17580567E-05_JPRB, 0.17567712E-05_JPRB, 0.17555656E-05_JPRB, &
  & 0.17547313E-05_JPRB, 0.17543841E-05_JPRB, 0.17545518E-05_JPRB, 0.17551939E-05_JPRB, 0.17562106E-05_JPRB, 0.17574648E-05_JPRB, &
  & 0.17587616E-05_JPRB, 0.17599293E-05_JPRB, 0.17608356E-05_JPRB, 0.17614000E-05_JPRB, 0.17615852E-05_JPRB, 0.17614038E-05_JPRB, &
  & 0.17608946E-05_JPRB, 0.17601078E-05_JPRB, 0.17591283E-05_JPRB, 0.17580805E-05_JPRB, 0.17570901E-05_JPRB, 0.17562650E-05_JPRB, &
  & 0.17556436E-05_JPRB, 0.17552459E-05_JPRB, 0.17551204E-05_JPRB, 0.17553430E-05_JPRB, 0.17560012E-05_JPRB, 0.17571492E-05_JPRB, &
  & 0.17587312E-05_JPRB, 0.17605914E-05_JPRB, 0.17625030E-05_JPRB, 0.17642761E-05_JPRB, 0.17657767E-05_JPRB, 0.17669043E-05_JPRB, &
  & 0.17676116E-05_JPRB, 0.17680052E-05_JPRB, 0.17682285E-05_JPRB, 0.17683627E-05_JPRB, 0.17684488E-05_JPRB, 0.17685121E-05_JPRB, &
  & 0.17685586E-05_JPRB, 0.17685957E-05_JPRB, 0.17686245E-05_JPRB, 0.17686453E-05_JPRB, 0.17686566E-05_JPRB, 0.17686584E-05_JPRB, &
  & 0.17686518E-05_JPRB, 0.17686343E-05_JPRB, 0.17685998E-05_JPRB, 0.17685073E-05_JPRB /)

RGHG2(:,62, 3) = (/ &
  & 0.17609250E-05_JPRB, 0.17612656E-05_JPRB, 0.17613935E-05_JPRB, 0.17614524E-05_JPRB, 0.17614761E-05_JPRB, 0.17614655E-05_JPRB, &
  & 0.17614327E-05_JPRB, 0.17613972E-05_JPRB, 0.17613617E-05_JPRB, 0.17613227E-05_JPRB, 0.17612706E-05_JPRB, 0.17611817E-05_JPRB, &
  & 0.17610191E-05_JPRB, 0.17606651E-05_JPRB, 0.17599918E-05_JPRB, 0.17589146E-05_JPRB, 0.17576136E-05_JPRB, 0.17564051E-05_JPRB, &
  & 0.17555446E-05_JPRB, 0.17551664E-05_JPRB, 0.17553072E-05_JPRB, 0.17559263E-05_JPRB, 0.17569284E-05_JPRB, 0.17581625E-05_JPRB, &
  & 0.17594411E-05_JPRB, 0.17605831E-05_JPRB, 0.17614643E-05_JPRB, 0.17620011E-05_JPRB, 0.17621624E-05_JPRB, 0.17619598E-05_JPRB, &
  & 0.17614293E-05_JPRB, 0.17606159E-05_JPRB, 0.17596039E-05_JPRB, 0.17585230E-05_JPRB, 0.17575078E-05_JPRB, 0.17566713E-05_JPRB, &
  & 0.17560556E-05_JPRB, 0.17556765E-05_JPRB, 0.17555824E-05_JPRB, 0.17558438E-05_JPRB, 0.17565419E-05_JPRB, 0.17577212E-05_JPRB, &
  & 0.17593223E-05_JPRB, 0.17611901E-05_JPRB, 0.17630989E-05_JPRB, 0.17648524E-05_JPRB, 0.17663441E-05_JPRB, 0.17674722E-05_JPRB, &
  & 0.17682041E-05_JPRB, 0.17686282E-05_JPRB, 0.17688608E-05_JPRB, 0.17689952E-05_JPRB, 0.17690800E-05_JPRB, 0.17691349E-05_JPRB, &
  & 0.17691743E-05_JPRB, 0.17692029E-05_JPRB, 0.17692222E-05_JPRB, 0.17692342E-05_JPRB, 0.17692377E-05_JPRB, 0.17692334E-05_JPRB, &
  & 0.17692212E-05_JPRB, 0.17692000E-05_JPRB, 0.17691608E-05_JPRB, 0.17690650E-05_JPRB /)

RGHG2(:,63, 3) = (/ &
  & 0.17620080E-05_JPRB, 0.17623189E-05_JPRB, 0.17624250E-05_JPRB, 0.17624798E-05_JPRB, 0.17625014E-05_JPRB, 0.17624959E-05_JPRB, &
  & 0.17624719E-05_JPRB, 0.17624420E-05_JPRB, 0.17624137E-05_JPRB, 0.17623806E-05_JPRB, 0.17623322E-05_JPRB, 0.17622460E-05_JPRB, &
  & 0.17620589E-05_JPRB, 0.17616660E-05_JPRB, 0.17609182E-05_JPRB, 0.17598131E-05_JPRB, 0.17585268E-05_JPRB, 0.17573218E-05_JPRB, &
  & 0.17564511E-05_JPRB, 0.17560537E-05_JPRB, 0.17561739E-05_JPRB, 0.17567751E-05_JPRB, 0.17577549E-05_JPRB, 0.17589675E-05_JPRB, &
  & 0.17602116E-05_JPRB, 0.17613220E-05_JPRB, 0.17621682E-05_JPRB, 0.17626774E-05_JPRB, 0.17628166E-05_JPRB, 0.17625993E-05_JPRB, &
  & 0.17620580E-05_JPRB, 0.17612288E-05_JPRB, 0.17601940E-05_JPRB, 0.17590844E-05_JPRB, 0.17580460E-05_JPRB, 0.17571972E-05_JPRB, &
  & 0.17565820E-05_JPRB, 0.17562161E-05_JPRB, 0.17561453E-05_JPRB, 0.17564359E-05_JPRB, 0.17571632E-05_JPRB, 0.17583635E-05_JPRB, &
  & 0.17599725E-05_JPRB, 0.17618354E-05_JPRB, 0.17637291E-05_JPRB, 0.17654600E-05_JPRB, 0.17669220E-05_JPRB, 0.17680425E-05_JPRB, &
  & 0.17687944E-05_JPRB, 0.17692411E-05_JPRB, 0.17694886E-05_JPRB, 0.17696258E-05_JPRB, 0.17697041E-05_JPRB, 0.17697528E-05_JPRB, &
  & 0.17697831E-05_JPRB, 0.17698021E-05_JPRB, 0.17698113E-05_JPRB, 0.17698137E-05_JPRB, 0.17698087E-05_JPRB, 0.17697970E-05_JPRB, &
  & 0.17697789E-05_JPRB, 0.17697498E-05_JPRB, 0.17697023E-05_JPRB, 0.17695896E-05_JPRB /)

RGHG2(:,64, 3) = (/ &
  & 0.17630499E-05_JPRB, 0.17633386E-05_JPRB, 0.17634450E-05_JPRB, 0.17635001E-05_JPRB, 0.17635289E-05_JPRB, 0.17635334E-05_JPRB, &
  & 0.17635186E-05_JPRB, 0.17634977E-05_JPRB, 0.17634767E-05_JPRB, 0.17634525E-05_JPRB, 0.17634115E-05_JPRB, 0.17633233E-05_JPRB, &
  & 0.17631165E-05_JPRB, 0.17626702E-05_JPRB, 0.17618851E-05_JPRB, 0.17607855E-05_JPRB, 0.17595207E-05_JPRB, 0.17583311E-05_JPRB, &
  & 0.17574584E-05_JPRB, 0.17570508E-05_JPRB, 0.17571574E-05_JPRB, 0.17577406E-05_JPRB, 0.17586984E-05_JPRB, 0.17598741E-05_JPRB, &
  & 0.17610771E-05_JPRB, 0.17621416E-05_JPRB, 0.17629472E-05_JPRB, 0.17634245E-05_JPRB, 0.17635448E-05_JPRB, 0.17633189E-05_JPRB, &
  & 0.17627768E-05_JPRB, 0.17619458E-05_JPRB, 0.17609002E-05_JPRB, 0.17597729E-05_JPRB, 0.17587146E-05_JPRB, 0.17578566E-05_JPRB, &
  & 0.17572380E-05_JPRB, 0.17568789E-05_JPRB, 0.17568235E-05_JPRB, 0.17571332E-05_JPRB, 0.17578785E-05_JPRB, 0.17590866E-05_JPRB, &
  & 0.17606901E-05_JPRB, 0.17625335E-05_JPRB, 0.17644006E-05_JPRB, 0.17660994E-05_JPRB, 0.17675281E-05_JPRB, 0.17686275E-05_JPRB, &
  & 0.17693844E-05_JPRB, 0.17698511E-05_JPRB, 0.17701109E-05_JPRB, 0.17702503E-05_JPRB, 0.17703252E-05_JPRB, 0.17703660E-05_JPRB, &
  & 0.17703878E-05_JPRB, 0.17703967E-05_JPRB, 0.17703951E-05_JPRB, 0.17703874E-05_JPRB, 0.17703742E-05_JPRB, 0.17703552E-05_JPRB, &
  & 0.17703280E-05_JPRB, 0.17702903E-05_JPRB, 0.17702286E-05_JPRB, 0.17700903E-05_JPRB /)

RGHG2(:,65, 3) = (/ &
  & 0.17640218E-05_JPRB, 0.17643326E-05_JPRB, 0.17644487E-05_JPRB, 0.17645161E-05_JPRB, 0.17645555E-05_JPRB, 0.17645732E-05_JPRB, &
  & 0.17645702E-05_JPRB, 0.17645586E-05_JPRB, 0.17645488E-05_JPRB, 0.17645350E-05_JPRB, 0.17645045E-05_JPRB, 0.17644132E-05_JPRB, &
  & 0.17641840E-05_JPRB, 0.17637049E-05_JPRB, 0.17629130E-05_JPRB, 0.17618331E-05_JPRB, 0.17605948E-05_JPRB, 0.17594282E-05_JPRB, &
  & 0.17585675E-05_JPRB, 0.17581623E-05_JPRB, 0.17582605E-05_JPRB, 0.17588252E-05_JPRB, 0.17597495E-05_JPRB, 0.17608786E-05_JPRB, &
  & 0.17620256E-05_JPRB, 0.17630342E-05_JPRB, 0.17637909E-05_JPRB, 0.17642330E-05_JPRB, 0.17643338E-05_JPRB, 0.17641045E-05_JPRB, &
  & 0.17635707E-05_JPRB, 0.17627509E-05_JPRB, 0.17617102E-05_JPRB, 0.17605773E-05_JPRB, 0.17595149E-05_JPRB, 0.17586510E-05_JPRB, &
  & 0.17580319E-05_JPRB, 0.17576760E-05_JPRB, 0.17576289E-05_JPRB, 0.17579486E-05_JPRB, 0.17586990E-05_JPRB, 0.17599027E-05_JPRB, &
  & 0.17614818E-05_JPRB, 0.17632917E-05_JPRB, 0.17651166E-05_JPRB, 0.17667736E-05_JPRB, 0.17681657E-05_JPRB, 0.17692358E-05_JPRB, &
  & 0.17699866E-05_JPRB, 0.17704601E-05_JPRB, 0.17707304E-05_JPRB, 0.17708712E-05_JPRB, 0.17709430E-05_JPRB, 0.17709770E-05_JPRB, &
  & 0.17709899E-05_JPRB, 0.17709890E-05_JPRB, 0.17709767E-05_JPRB, 0.17709596E-05_JPRB, 0.17709384E-05_JPRB, 0.17709110E-05_JPRB, &
  & 0.17708751E-05_JPRB, 0.17708228E-05_JPRB, 0.17707411E-05_JPRB, 0.17705590E-05_JPRB /)

RGHG2(:,66, 3) = (/ &
  & 0.17649561E-05_JPRB, 0.17653039E-05_JPRB, 0.17654445E-05_JPRB, 0.17655291E-05_JPRB, 0.17655851E-05_JPRB, 0.17656171E-05_JPRB, &
  & 0.17656273E-05_JPRB, 0.17656266E-05_JPRB, 0.17656295E-05_JPRB, 0.17656298E-05_JPRB, 0.17656087E-05_JPRB, 0.17655167E-05_JPRB, &
  & 0.17652685E-05_JPRB, 0.17647802E-05_JPRB, 0.17639995E-05_JPRB, 0.17629472E-05_JPRB, 0.17617474E-05_JPRB, 0.17606162E-05_JPRB, &
  & 0.17597814E-05_JPRB, 0.17593856E-05_JPRB, 0.17594783E-05_JPRB, 0.17600180E-05_JPRB, 0.17608991E-05_JPRB, 0.17619653E-05_JPRB, &
  & 0.17630432E-05_JPRB, 0.17639848E-05_JPRB, 0.17646846E-05_JPRB, 0.17650868E-05_JPRB, 0.17651683E-05_JPRB, 0.17649377E-05_JPRB, &
  & 0.17644199E-05_JPRB, 0.17636232E-05_JPRB, 0.17626031E-05_JPRB, 0.17614838E-05_JPRB, 0.17604314E-05_JPRB, 0.17595763E-05_JPRB, &
  & 0.17589614E-05_JPRB, 0.17586108E-05_JPRB, 0.17585684E-05_JPRB, 0.17588900E-05_JPRB, 0.17596351E-05_JPRB, 0.17608162E-05_JPRB, &
  & 0.17623611E-05_JPRB, 0.17641130E-05_JPRB, 0.17658828E-05_JPRB, 0.17674889E-05_JPRB, 0.17688309E-05_JPRB, 0.17698723E-05_JPRB, &
  & 0.17706036E-05_JPRB, 0.17710773E-05_JPRB, 0.17713489E-05_JPRB, 0.17714922E-05_JPRB, 0.17715604E-05_JPRB, 0.17715895E-05_JPRB, &
  & 0.17715940E-05_JPRB, 0.17715837E-05_JPRB, 0.17715627E-05_JPRB, 0.17715374E-05_JPRB, 0.17715098E-05_JPRB, 0.17714749E-05_JPRB, &
  & 0.17714269E-05_JPRB, 0.17713586E-05_JPRB, 0.17712471E-05_JPRB, 0.17709971E-05_JPRB /)

RGHG2(:,67, 3) = (/ &
  & 0.17658735E-05_JPRB, 0.17662726E-05_JPRB, 0.17664374E-05_JPRB, 0.17665457E-05_JPRB, 0.17666209E-05_JPRB, 0.17666709E-05_JPRB, &
  & 0.17666946E-05_JPRB, 0.17667068E-05_JPRB, 0.17667235E-05_JPRB, 0.17667380E-05_JPRB, 0.17667259E-05_JPRB, 0.17666299E-05_JPRB, &
  & 0.17663783E-05_JPRB, 0.17658954E-05_JPRB, 0.17651337E-05_JPRB, 0.17641219E-05_JPRB, 0.17629716E-05_JPRB, 0.17618912E-05_JPRB, &
  & 0.17610907E-05_JPRB, 0.17607114E-05_JPRB, 0.17607956E-05_JPRB, 0.17613029E-05_JPRB, 0.17621263E-05_JPRB, 0.17631178E-05_JPRB, &
  & 0.17641149E-05_JPRB, 0.17649804E-05_JPRB, 0.17656164E-05_JPRB, 0.17659763E-05_JPRB, 0.17660377E-05_JPRB, 0.17658090E-05_JPRB, &
  & 0.17653128E-05_JPRB, 0.17645494E-05_JPRB, 0.17635634E-05_JPRB, 0.17624754E-05_JPRB, 0.17614507E-05_JPRB, 0.17606180E-05_JPRB, &
  & 0.17600187E-05_JPRB, 0.17596792E-05_JPRB, 0.17596419E-05_JPRB, 0.17599614E-05_JPRB, 0.17606894E-05_JPRB, 0.17618390E-05_JPRB, &
  & 0.17633249E-05_JPRB, 0.17650107E-05_JPRB, 0.17667054E-05_JPRB, 0.17682432E-05_JPRB, 0.17695369E-05_JPRB, 0.17705297E-05_JPRB, &
  & 0.17712423E-05_JPRB, 0.17717040E-05_JPRB, 0.17719744E-05_JPRB, 0.17721144E-05_JPRB, 0.17721811E-05_JPRB, 0.17722048E-05_JPRB, &
  & 0.17722029E-05_JPRB, 0.17721858E-05_JPRB, 0.17721568E-05_JPRB, 0.17721261E-05_JPRB, 0.17720938E-05_JPRB, 0.17720522E-05_JPRB, &
  & 0.17719944E-05_JPRB, 0.17719051E-05_JPRB, 0.17717541E-05_JPRB, 0.17714113E-05_JPRB /)

RGHG2(:,68, 3) = (/ &
  & 0.17667659E-05_JPRB, 0.17672264E-05_JPRB, 0.17674308E-05_JPRB, 0.17675663E-05_JPRB, 0.17676666E-05_JPRB, 0.17677361E-05_JPRB, &
  & 0.17677760E-05_JPRB, 0.17678017E-05_JPRB, 0.17678337E-05_JPRB, 0.17678594E-05_JPRB, 0.17678528E-05_JPRB, 0.17677579E-05_JPRB, &
  & 0.17675085E-05_JPRB, 0.17670384E-05_JPRB, 0.17663076E-05_JPRB, 0.17653483E-05_JPRB, 0.17642619E-05_JPRB, 0.17632400E-05_JPRB, &
  & 0.17624833E-05_JPRB, 0.17621190E-05_JPRB, 0.17621916E-05_JPRB, 0.17626555E-05_JPRB, 0.17634111E-05_JPRB, 0.17643177E-05_JPRB, &
  & 0.17652269E-05_JPRB, 0.17660122E-05_JPRB, 0.17665827E-05_JPRB, 0.17668983E-05_JPRB, 0.17669404E-05_JPRB, 0.17667163E-05_JPRB, &
  & 0.17662467E-05_JPRB, 0.17655252E-05_JPRB, 0.17645852E-05_JPRB, 0.17635422E-05_JPRB, 0.17625609E-05_JPRB, 0.17617627E-05_JPRB, &
  & 0.17611906E-05_JPRB, 0.17608686E-05_JPRB, 0.17608394E-05_JPRB, 0.17611535E-05_JPRB, 0.17618604E-05_JPRB, 0.17629617E-05_JPRB, &
  & 0.17643847E-05_JPRB, 0.17659789E-05_JPRB, 0.17675879E-05_JPRB, 0.17690502E-05_JPRB, 0.17702688E-05_JPRB, 0.17712217E-05_JPRB, &
  & 0.17718967E-05_JPRB, 0.17723453E-05_JPRB, 0.17726071E-05_JPRB, 0.17727444E-05_JPRB, 0.17728074E-05_JPRB, 0.17728274E-05_JPRB, &
  & 0.17728207E-05_JPRB, 0.17727979E-05_JPRB, 0.17727641E-05_JPRB, 0.17727298E-05_JPRB, 0.17726959E-05_JPRB, 0.17726510E-05_JPRB, &
  & 0.17725851E-05_JPRB, 0.17724794E-05_JPRB, 0.17722897E-05_JPRB, 0.17718334E-05_JPRB /)

RGHG2(:,69, 3) = (/ &
  & 0.17676455E-05_JPRB, 0.17681934E-05_JPRB, 0.17684331E-05_JPRB, 0.17686043E-05_JPRB, 0.17687300E-05_JPRB, 0.17688221E-05_JPRB, &
  & 0.17688769E-05_JPRB, 0.17689171E-05_JPRB, 0.17689624E-05_JPRB, 0.17689965E-05_JPRB, 0.17689932E-05_JPRB, 0.17689008E-05_JPRB, &
  & 0.17686583E-05_JPRB, 0.17682094E-05_JPRB, 0.17675187E-05_JPRB, 0.17666215E-05_JPRB, 0.17656067E-05_JPRB, 0.17646529E-05_JPRB, &
  & 0.17639396E-05_JPRB, 0.17635912E-05_JPRB, 0.17636447E-05_JPRB, 0.17640577E-05_JPRB, 0.17647387E-05_JPRB, 0.17655557E-05_JPRB, &
  & 0.17663749E-05_JPRB, 0.17670779E-05_JPRB, 0.17675829E-05_JPRB, 0.17678557E-05_JPRB, 0.17678803E-05_JPRB, 0.17676637E-05_JPRB, &
  & 0.17672257E-05_JPRB, 0.17665526E-05_JPRB, 0.17656695E-05_JPRB, 0.17646832E-05_JPRB, 0.17637554E-05_JPRB, 0.17630039E-05_JPRB, &
  & 0.17624664E-05_JPRB, 0.17621685E-05_JPRB, 0.17621503E-05_JPRB, 0.17624589E-05_JPRB, 0.17631373E-05_JPRB, 0.17641878E-05_JPRB, &
  & 0.17655265E-05_JPRB, 0.17670302E-05_JPRB, 0.17685334E-05_JPRB, 0.17698994E-05_JPRB, 0.17710485E-05_JPRB, 0.17719340E-05_JPRB, &
  & 0.17725773E-05_JPRB, 0.17730010E-05_JPRB, 0.17732522E-05_JPRB, 0.17733832E-05_JPRB, 0.17734435E-05_JPRB, 0.17734601E-05_JPRB, &
  & 0.17734508E-05_JPRB, 0.17734257E-05_JPRB, 0.17733907E-05_JPRB, 0.17733553E-05_JPRB, 0.17733217E-05_JPRB, 0.17732765E-05_JPRB, &
  & 0.17732073E-05_JPRB, 0.17730896E-05_JPRB, 0.17728595E-05_JPRB, 0.17723004E-05_JPRB /)

RGHG2(:,70, 3) = (/ &
  & 0.17685281E-05_JPRB, 0.17691631E-05_JPRB, 0.17694622E-05_JPRB, 0.17696661E-05_JPRB, 0.17698233E-05_JPRB, 0.17699336E-05_JPRB, &
  & 0.17700038E-05_JPRB, 0.17700569E-05_JPRB, 0.17701115E-05_JPRB, 0.17701507E-05_JPRB, 0.17701465E-05_JPRB, 0.17700562E-05_JPRB, &
  & 0.17698230E-05_JPRB, 0.17694005E-05_JPRB, 0.17687586E-05_JPRB, 0.17679292E-05_JPRB, 0.17669953E-05_JPRB, 0.17661102E-05_JPRB, &
  & 0.17654447E-05_JPRB, 0.17651078E-05_JPRB, 0.17651391E-05_JPRB, 0.17654966E-05_JPRB, 0.17660981E-05_JPRB, 0.17668244E-05_JPRB, &
  & 0.17675512E-05_JPRB, 0.17681746E-05_JPRB, 0.17686149E-05_JPRB, 0.17688471E-05_JPRB, 0.17688574E-05_JPRB, 0.17686518E-05_JPRB, &
  & 0.17682493E-05_JPRB, 0.17676317E-05_JPRB, 0.17668131E-05_JPRB, 0.17658940E-05_JPRB, 0.17650311E-05_JPRB, 0.17643329E-05_JPRB, &
  & 0.17638381E-05_JPRB, 0.17635684E-05_JPRB, 0.17635624E-05_JPRB, 0.17638641E-05_JPRB, 0.17645110E-05_JPRB, 0.17654975E-05_JPRB, &
  & 0.17667554E-05_JPRB, 0.17681433E-05_JPRB, 0.17695411E-05_JPRB, 0.17708019E-05_JPRB, 0.17718551E-05_JPRB, 0.17726809E-05_JPRB, &
  & 0.17732738E-05_JPRB, 0.17736735E-05_JPRB, 0.17739094E-05_JPRB, 0.17740335E-05_JPRB, 0.17740906E-05_JPRB, 0.17741053E-05_JPRB, &
  & 0.17740962E-05_JPRB, 0.17740722E-05_JPRB, 0.17740396E-05_JPRB, 0.17740066E-05_JPRB, 0.17739762E-05_JPRB, 0.17739329E-05_JPRB, &
  & 0.17738644E-05_JPRB, 0.17737408E-05_JPRB, 0.17734926E-05_JPRB, 0.17728480E-05_JPRB /)

RGHG2(:,71, 3) = (/ &
  & 0.17694052E-05_JPRB, 0.17701791E-05_JPRB, 0.17705236E-05_JPRB, 0.17707699E-05_JPRB, 0.17709483E-05_JPRB, 0.17710777E-05_JPRB, &
  & 0.17711569E-05_JPRB, 0.17712209E-05_JPRB, 0.17712800E-05_JPRB, 0.17713182E-05_JPRB, 0.17713120E-05_JPRB, 0.17712226E-05_JPRB, &
  & 0.17710011E-05_JPRB, 0.17706075E-05_JPRB, 0.17700166E-05_JPRB, 0.17692602E-05_JPRB, 0.17684080E-05_JPRB, 0.17675978E-05_JPRB, &
  & 0.17669804E-05_JPRB, 0.17666565E-05_JPRB, 0.17666640E-05_JPRB, 0.17669637E-05_JPRB, 0.17674836E-05_JPRB, 0.17681186E-05_JPRB, &
  & 0.17687561E-05_JPRB, 0.17692987E-05_JPRB, 0.17696783E-05_JPRB, 0.17698721E-05_JPRB, 0.17698704E-05_JPRB, 0.17696791E-05_JPRB, &
  & 0.17693166E-05_JPRB, 0.17687586E-05_JPRB, 0.17680131E-05_JPRB, 0.17671695E-05_JPRB, 0.17663803E-05_JPRB, 0.17657443E-05_JPRB, &
  & 0.17652968E-05_JPRB, 0.17650577E-05_JPRB, 0.17650646E-05_JPRB, 0.17653571E-05_JPRB, 0.17659657E-05_JPRB, 0.17668875E-05_JPRB, &
  & 0.17680397E-05_JPRB, 0.17693237E-05_JPRB, 0.17705888E-05_JPRB, 0.17717367E-05_JPRB, 0.17726962E-05_JPRB, 0.17734424E-05_JPRB, &
  & 0.17739897E-05_JPRB, 0.17743570E-05_JPRB, 0.17745765E-05_JPRB, 0.17746931E-05_JPRB, 0.17747477E-05_JPRB, 0.17747625E-05_JPRB, &
  & 0.17747560E-05_JPRB, 0.17747363E-05_JPRB, 0.17747101E-05_JPRB, 0.17746819E-05_JPRB, 0.17746565E-05_JPRB, 0.17746179E-05_JPRB, &
  & 0.17745529E-05_JPRB, 0.17744319E-05_JPRB, 0.17741770E-05_JPRB, 0.17735068E-05_JPRB /)

RGHG2(:,72, 3) = (/ &
  & 0.17703228E-05_JPRB, 0.17712280E-05_JPRB, 0.17716401E-05_JPRB, 0.17719126E-05_JPRB, 0.17721095E-05_JPRB, 0.17722452E-05_JPRB, &
  & 0.17723339E-05_JPRB, 0.17724014E-05_JPRB, 0.17724597E-05_JPRB, 0.17724955E-05_JPRB, 0.17724835E-05_JPRB, 0.17723938E-05_JPRB, &
  & 0.17721841E-05_JPRB, 0.17718207E-05_JPRB, 0.17712845E-05_JPRB, 0.17705986E-05_JPRB, 0.17698355E-05_JPRB, 0.17690990E-05_JPRB, &
  & 0.17685359E-05_JPRB, 0.17682278E-05_JPRB, 0.17682130E-05_JPRB, 0.17684536E-05_JPRB, 0.17688925E-05_JPRB, 0.17694358E-05_JPRB, &
  & 0.17699824E-05_JPRB, 0.17704490E-05_JPRB, 0.17707706E-05_JPRB, 0.17709295E-05_JPRB, 0.17709190E-05_JPRB, 0.17707434E-05_JPRB, &
  & 0.17704233E-05_JPRB, 0.17699299E-05_JPRB, 0.17692624E-05_JPRB, 0.17685049E-05_JPRB, 0.17677969E-05_JPRB, 0.17672298E-05_JPRB, &
  & 0.17668342E-05_JPRB, 0.17666280E-05_JPRB, 0.17666475E-05_JPRB, 0.17669271E-05_JPRB, 0.17674931E-05_JPRB, 0.17683317E-05_JPRB, &
  & 0.17693875E-05_JPRB, 0.17705293E-05_JPRB, 0.17716739E-05_JPRB, 0.17726960E-05_JPRB, 0.17735482E-05_JPRB, 0.17742204E-05_JPRB, &
  & 0.17747088E-05_JPRB, 0.17750463E-05_JPRB, 0.17752473E-05_JPRB, 0.17753567E-05_JPRB, 0.17754105E-05_JPRB, 0.17754264E-05_JPRB, &
  & 0.17754248E-05_JPRB, 0.17754122E-05_JPRB, 0.17753941E-05_JPRB, 0.17753732E-05_JPRB, 0.17753530E-05_JPRB, 0.17753198E-05_JPRB, &
  & 0.17752599E-05_JPRB, 0.17751445E-05_JPRB, 0.17748963E-05_JPRB, 0.17742288E-05_JPRB /)

RGHG2(:,73, 3) = (/ &
  & 0.17714208E-05_JPRB, 0.17723889E-05_JPRB, 0.17728139E-05_JPRB, 0.17730908E-05_JPRB, 0.17732862E-05_JPRB, 0.17734227E-05_JPRB, &
  & 0.17735108E-05_JPRB, 0.17735786E-05_JPRB, 0.17736354E-05_JPRB, 0.17736639E-05_JPRB, 0.17736480E-05_JPRB, 0.17735599E-05_JPRB, &
  & 0.17733641E-05_JPRB, 0.17730299E-05_JPRB, 0.17725461E-05_JPRB, 0.17719352E-05_JPRB, 0.17712548E-05_JPRB, 0.17706021E-05_JPRB, &
  & 0.17700957E-05_JPRB, 0.17698093E-05_JPRB, 0.17697747E-05_JPRB, 0.17699592E-05_JPRB, 0.17703171E-05_JPRB, 0.17707721E-05_JPRB, &
  & 0.17712314E-05_JPRB, 0.17716225E-05_JPRB, 0.17718891E-05_JPRB, 0.17720162E-05_JPRB, 0.17719998E-05_JPRB, 0.17718427E-05_JPRB, &
  & 0.17715663E-05_JPRB, 0.17711387E-05_JPRB, 0.17705551E-05_JPRB, 0.17698907E-05_JPRB, 0.17692702E-05_JPRB, 0.17687788E-05_JPRB, &
  & 0.17684384E-05_JPRB, 0.17682660E-05_JPRB, 0.17682967E-05_JPRB, 0.17685604E-05_JPRB, 0.17690728E-05_JPRB, 0.17698310E-05_JPRB, &
  & 0.17707553E-05_JPRB, 0.17717725E-05_JPRB, 0.17727667E-05_JPRB, 0.17736613E-05_JPRB, 0.17744136E-05_JPRB, 0.17749942E-05_JPRB, &
  & 0.17754337E-05_JPRB, 0.17757307E-05_JPRB, 0.17759146E-05_JPRB, 0.17760174E-05_JPRB, 0.17760693E-05_JPRB, 0.17760884E-05_JPRB, &
  & 0.17760916E-05_JPRB, 0.17760865E-05_JPRB, 0.17760774E-05_JPRB, 0.17760624E-05_JPRB, 0.17760475E-05_JPRB, 0.17760188E-05_JPRB, &
  & 0.17759652E-05_JPRB, 0.17758587E-05_JPRB, 0.17756261E-05_JPRB, 0.17749837E-05_JPRB /)

RGHG2(:,74, 3) = (/ &
  & 0.17725744E-05_JPRB, 0.17735856E-05_JPRB, 0.17740031E-05_JPRB, 0.17742702E-05_JPRB, 0.17744504E-05_JPRB, 0.17745767E-05_JPRB, &
  & 0.17746622E-05_JPRB, 0.17747253E-05_JPRB, 0.17747770E-05_JPRB, 0.17748023E-05_JPRB, 0.17747846E-05_JPRB, 0.17747000E-05_JPRB, &
  & 0.17745208E-05_JPRB, 0.17742211E-05_JPRB, 0.17737893E-05_JPRB, 0.17732500E-05_JPRB, 0.17726636E-05_JPRB, 0.17720915E-05_JPRB, &
  & 0.17716508E-05_JPRB, 0.17713891E-05_JPRB, 0.17713398E-05_JPRB, 0.17714731E-05_JPRB, 0.17717553E-05_JPRB, 0.17721252E-05_JPRB, &
  & 0.17724984E-05_JPRB, 0.17728180E-05_JPRB, 0.17730327E-05_JPRB, 0.17731313E-05_JPRB, 0.17731111E-05_JPRB, 0.17729737E-05_JPRB, &
  & 0.17727411E-05_JPRB, 0.17723819E-05_JPRB, 0.17718860E-05_JPRB, 0.17713185E-05_JPRB, 0.17707943E-05_JPRB, 0.17703794E-05_JPRB, &
  & 0.17700975E-05_JPRB, 0.17699585E-05_JPRB, 0.17699980E-05_JPRB, 0.17702391E-05_JPRB, 0.17706961E-05_JPRB, 0.17713526E-05_JPRB, &
  & 0.17721577E-05_JPRB, 0.17730160E-05_JPRB, 0.17738680E-05_JPRB, 0.17746336E-05_JPRB, 0.17752683E-05_JPRB, 0.17757745E-05_JPRB, &
  & 0.17761452E-05_JPRB, 0.17764104E-05_JPRB, 0.17765713E-05_JPRB, 0.17766665E-05_JPRB, 0.17767178E-05_JPRB, 0.17767370E-05_JPRB, &
  & 0.17767454E-05_JPRB, 0.17767470E-05_JPRB, 0.17767454E-05_JPRB, 0.17767355E-05_JPRB, 0.17767245E-05_JPRB, 0.17767009E-05_JPRB, &
  & 0.17766553E-05_JPRB, 0.17765594E-05_JPRB, 0.17763459E-05_JPRB, 0.17757434E-05_JPRB /)

RGHG2(:,75, 3) = (/ &
  & 0.17737704E-05_JPRB, 0.17747757E-05_JPRB, 0.17751803E-05_JPRB, 0.17754116E-05_JPRB, 0.17755733E-05_JPRB, 0.17756847E-05_JPRB, &
  & 0.17757619E-05_JPRB, 0.17758193E-05_JPRB, 0.17758662E-05_JPRB, 0.17758880E-05_JPRB, 0.17758706E-05_JPRB, 0.17757970E-05_JPRB, &
  & 0.17756403E-05_JPRB, 0.17753750E-05_JPRB, 0.17750040E-05_JPRB, 0.17745418E-05_JPRB, 0.17740479E-05_JPRB, 0.17735663E-05_JPRB, &
  & 0.17731912E-05_JPRB, 0.17729617E-05_JPRB, 0.17729044E-05_JPRB, 0.17729931E-05_JPRB, 0.17732067E-05_JPRB, 0.17734974E-05_JPRB, &
  & 0.17737882E-05_JPRB, 0.17740391E-05_JPRB, 0.17742054E-05_JPRB, 0.17742781E-05_JPRB, 0.17742567E-05_JPRB, 0.17741398E-05_JPRB, &
  & 0.17739517E-05_JPRB, 0.17736602E-05_JPRB, 0.17732524E-05_JPRB, 0.17727872E-05_JPRB, 0.17723612E-05_JPRB, 0.17720257E-05_JPRB, &
  & 0.17718030E-05_JPRB, 0.17716961E-05_JPRB, 0.17717405E-05_JPRB, 0.17719548E-05_JPRB, 0.17723434E-05_JPRB, 0.17729016E-05_JPRB, &
  & 0.17735626E-05_JPRB, 0.17742740E-05_JPRB, 0.17749726E-05_JPRB, 0.17755987E-05_JPRB, 0.17761328E-05_JPRB, 0.17765416E-05_JPRB, &
  & 0.17768587E-05_JPRB, 0.17770765E-05_JPRB, 0.17772162E-05_JPRB, 0.17773012E-05_JPRB, 0.17773489E-05_JPRB, 0.17773666E-05_JPRB, &
  & 0.17773777E-05_JPRB, 0.17773851E-05_JPRB, 0.17773895E-05_JPRB, 0.17773832E-05_JPRB, 0.17773758E-05_JPRB, 0.17773583E-05_JPRB, &
  & 0.17773214E-05_JPRB, 0.17772384E-05_JPRB, 0.17770461E-05_JPRB, 0.17764871E-05_JPRB /)

RGHG2(:,76, 3) = (/ &
  & 0.17749802E-05_JPRB, 0.17759527E-05_JPRB, 0.17763065E-05_JPRB, 0.17765045E-05_JPRB, 0.17766363E-05_JPRB, 0.17767306E-05_JPRB, &
  & 0.17767979E-05_JPRB, 0.17768465E-05_JPRB, 0.17768873E-05_JPRB, 0.17769041E-05_JPRB, 0.17768891E-05_JPRB, 0.17768260E-05_JPRB, &
  & 0.17766981E-05_JPRB, 0.17764804E-05_JPRB, 0.17761736E-05_JPRB, 0.17758009E-05_JPRB, 0.17754080E-05_JPRB, 0.17750187E-05_JPRB, &
  & 0.17747167E-05_JPRB, 0.17745232E-05_JPRB, 0.17744667E-05_JPRB, 0.17745215E-05_JPRB, 0.17746723E-05_JPRB, 0.17748894E-05_JPRB, &
  & 0.17750999E-05_JPRB, 0.17752860E-05_JPRB, 0.17754084E-05_JPRB, 0.17754594E-05_JPRB, 0.17754387E-05_JPRB, 0.17753426E-05_JPRB, &
  & 0.17751985E-05_JPRB, 0.17749734E-05_JPRB, 0.17746552E-05_JPRB, 0.17742948E-05_JPRB, 0.17739700E-05_JPRB, 0.17737113E-05_JPRB, &
  & 0.17735471E-05_JPRB, 0.17734709E-05_JPRB, 0.17735165E-05_JPRB, 0.17736954E-05_JPRB, 0.17740118E-05_JPRB, 0.17744559E-05_JPRB, &
  & 0.17749782E-05_JPRB, 0.17755317E-05_JPRB, 0.17760772E-05_JPRB, 0.17765705E-05_JPRB, 0.17769855E-05_JPRB, 0.17773125E-05_JPRB, &
  & 0.17775579E-05_JPRB, 0.17777351E-05_JPRB, 0.17778461E-05_JPRB, 0.17779190E-05_JPRB, 0.17779608E-05_JPRB, 0.17779737E-05_JPRB, &
  & 0.17779857E-05_JPRB, 0.17779964E-05_JPRB, 0.17780061E-05_JPRB, 0.17780021E-05_JPRB, 0.17779971E-05_JPRB, 0.17779855E-05_JPRB, &
  & 0.17779594E-05_JPRB, 0.17778898E-05_JPRB, 0.17777235E-05_JPRB, 0.17772071E-05_JPRB /)

RGHG2(:,77, 3) = (/ &
  & 0.17762072E-05_JPRB, 0.17770707E-05_JPRB, 0.17773767E-05_JPRB, 0.17775213E-05_JPRB, 0.17776250E-05_JPRB, 0.17776986E-05_JPRB, &
  & 0.17777537E-05_JPRB, 0.17777922E-05_JPRB, 0.17778218E-05_JPRB, 0.17778325E-05_JPRB, 0.17778157E-05_JPRB, 0.17777672E-05_JPRB, &
  & 0.17776722E-05_JPRB, 0.17775074E-05_JPRB, 0.17772818E-05_JPRB, 0.17770037E-05_JPRB, 0.17767243E-05_JPRB, 0.17764330E-05_JPRB, &
  & 0.17762084E-05_JPRB, 0.17760594E-05_JPRB, 0.17760151E-05_JPRB, 0.17760441E-05_JPRB, 0.17761425E-05_JPRB, 0.17762942E-05_JPRB, &
  & 0.17764314E-05_JPRB, 0.17765603E-05_JPRB, 0.17766446E-05_JPRB, 0.17766773E-05_JPRB, 0.17766602E-05_JPRB, 0.17765847E-05_JPRB, &
  & 0.17764834E-05_JPRB, 0.17763209E-05_JPRB, 0.17760902E-05_JPRB, 0.17758325E-05_JPRB, 0.17756038E-05_JPRB, 0.17754213E-05_JPRB, &
  & 0.17753101E-05_JPRB, 0.17752620E-05_JPRB, 0.17753032E-05_JPRB, 0.17754410E-05_JPRB, 0.17756738E-05_JPRB, 0.17759999E-05_JPRB, &
  & 0.17763742E-05_JPRB, 0.17767746E-05_JPRB, 0.17771707E-05_JPRB, 0.17775219E-05_JPRB, 0.17778316E-05_JPRB, 0.17780628E-05_JPRB, &
  & 0.17782461E-05_JPRB, 0.17783739E-05_JPRB, 0.17784566E-05_JPRB, 0.17785146E-05_JPRB, 0.17785482E-05_JPRB, 0.17785526E-05_JPRB, &
  & 0.17785629E-05_JPRB, 0.17785760E-05_JPRB, 0.17785887E-05_JPRB, 0.17785850E-05_JPRB, 0.17785813E-05_JPRB, 0.17785756E-05_JPRB, &
  & 0.17785599E-05_JPRB, 0.17785046E-05_JPRB, 0.17783658E-05_JPRB, 0.17779099E-05_JPRB /)

RGHG2(:,78, 3) = (/ &
  & 0.17774158E-05_JPRB, 0.17780912E-05_JPRB, 0.17783051E-05_JPRB, 0.17783989E-05_JPRB, 0.17784716E-05_JPRB, 0.17785267E-05_JPRB, &
  & 0.17785699E-05_JPRB, 0.17785937E-05_JPRB, 0.17786122E-05_JPRB, 0.17786119E-05_JPRB, 0.17785924E-05_JPRB, 0.17785574E-05_JPRB, &
  & 0.17784986E-05_JPRB, 0.17783918E-05_JPRB, 0.17782482E-05_JPRB, 0.17780733E-05_JPRB, 0.17779047E-05_JPRB, 0.17777152E-05_JPRB, &
  & 0.17775724E-05_JPRB, 0.17774757E-05_JPRB, 0.17774552E-05_JPRB, 0.17774729E-05_JPRB, 0.17775320E-05_JPRB, 0.17776310E-05_JPRB, &
  & 0.17777081E-05_JPRB, 0.17777896E-05_JPRB, 0.17778448E-05_JPRB, 0.17778655E-05_JPRB, 0.17778532E-05_JPRB, 0.17777973E-05_JPRB, &
  & 0.17777344E-05_JPRB, 0.17776281E-05_JPRB, 0.17774785E-05_JPRB, 0.17773156E-05_JPRB, 0.17771746E-05_JPRB, 0.17770564E-05_JPRB, &
  & 0.17769892E-05_JPRB, 0.17769597E-05_JPRB, 0.17769894E-05_JPRB, 0.17770788E-05_JPRB, 0.17772222E-05_JPRB, 0.17774266E-05_JPRB, &
  & 0.17776580E-05_JPRB, 0.17779159E-05_JPRB, 0.17781696E-05_JPRB, 0.17783971E-05_JPRB, 0.17786022E-05_JPRB, 0.17787509E-05_JPRB, &
  & 0.17788706E-05_JPRB, 0.17789546E-05_JPRB, 0.17790084E-05_JPRB, 0.17790509E-05_JPRB, 0.17790744E-05_JPRB, 0.17790663E-05_JPRB, &
  & 0.17790734E-05_JPRB, 0.17790856E-05_JPRB, 0.17790987E-05_JPRB, 0.17790926E-05_JPRB, 0.17790877E-05_JPRB, 0.17790861E-05_JPRB, &
  & 0.17790807E-05_JPRB, 0.17790394E-05_JPRB, 0.17789478E-05_JPRB, 0.17785895E-05_JPRB /)

RGHG2(:,79, 3) = (/ &
  & 0.17781995E-05_JPRB, 0.17786583E-05_JPRB, 0.17788016E-05_JPRB, 0.17788503E-05_JPRB, 0.17789085E-05_JPRB, 0.17789527E-05_JPRB, &
  & 0.17789894E-05_JPRB, 0.17790060E-05_JPRB, 0.17790160E-05_JPRB, 0.17790113E-05_JPRB, 0.17789930E-05_JPRB, 0.17789655E-05_JPRB, &
  & 0.17789281E-05_JPRB, 0.17788507E-05_JPRB, 0.17787505E-05_JPRB, 0.17786285E-05_JPRB, 0.17785226E-05_JPRB, 0.17783865E-05_JPRB, &
  & 0.17782889E-05_JPRB, 0.17782222E-05_JPRB, 0.17782190E-05_JPRB, 0.17782330E-05_JPRB, 0.17782731E-05_JPRB, 0.17783476E-05_JPRB, &
  & 0.17783921E-05_JPRB, 0.17784505E-05_JPRB, 0.17784924E-05_JPRB, 0.17785078E-05_JPRB, 0.17784994E-05_JPRB, 0.17784538E-05_JPRB, &
  & 0.17784133E-05_JPRB, 0.17783364E-05_JPRB, 0.17782306E-05_JPRB, 0.17781193E-05_JPRB, 0.17780258E-05_JPRB, 0.17779405E-05_JPRB, &
  & 0.17778947E-05_JPRB, 0.17778732E-05_JPRB, 0.17778945E-05_JPRB, 0.17779532E-05_JPRB, 0.17780451E-05_JPRB, 0.17781806E-05_JPRB, &
  & 0.17783350E-05_JPRB, 0.17785164E-05_JPRB, 0.17786975E-05_JPRB, 0.17788553E-05_JPRB, 0.17790099E-05_JPRB, 0.17791107E-05_JPRB, &
  & 0.17791992E-05_JPRB, 0.17792593E-05_JPRB, 0.17792976E-05_JPRB, 0.17793324E-05_JPRB, 0.17793504E-05_JPRB, 0.17793325E-05_JPRB, &
  & 0.17793366E-05_JPRB, 0.17793483E-05_JPRB, 0.17793626E-05_JPRB, 0.17793541E-05_JPRB, 0.17793478E-05_JPRB, 0.17793482E-05_JPRB, &
  & 0.17793494E-05_JPRB, 0.17793226E-05_JPRB, 0.17792711E-05_JPRB, 0.17790269E-05_JPRB /)

RGHG2(:,80, 3) = (/ &
  & 0.17787189E-05_JPRB, 0.17789322E-05_JPRB, 0.17790178E-05_JPRB, 0.17790447E-05_JPRB, 0.17790945E-05_JPRB, 0.17791347E-05_JPRB, &
  & 0.17791700E-05_JPRB, 0.17791815E-05_JPRB, 0.17791914E-05_JPRB, 0.17791875E-05_JPRB, 0.17791689E-05_JPRB, 0.17791488E-05_JPRB, &
  & 0.17791203E-05_JPRB, 0.17790559E-05_JPRB, 0.17789736E-05_JPRB, 0.17788739E-05_JPRB, 0.17787969E-05_JPRB, 0.17786834E-05_JPRB, &
  & 0.17786075E-05_JPRB, 0.17785534E-05_JPRB, 0.17785602E-05_JPRB, 0.17785731E-05_JPRB, 0.17786056E-05_JPRB, 0.17786692E-05_JPRB, &
  & 0.17786997E-05_JPRB, 0.17787485E-05_JPRB, 0.17787859E-05_JPRB, 0.17788000E-05_JPRB, 0.17787939E-05_JPRB, 0.17787524E-05_JPRB, &
  & 0.17787227E-05_JPRB, 0.17786593E-05_JPRB, 0.17785735E-05_JPRB, 0.17784860E-05_JPRB, 0.17784140E-05_JPRB, 0.17783425E-05_JPRB, &
  & 0.17783053E-05_JPRB, 0.17782866E-05_JPRB, 0.17783027E-05_JPRB, 0.17783474E-05_JPRB, 0.17784141E-05_JPRB, 0.17785185E-05_JPRB, &
  & 0.17786364E-05_JPRB, 0.17787850E-05_JPRB, 0.17789329E-05_JPRB, 0.17790607E-05_JPRB, 0.17791912E-05_JPRB, 0.17792704E-05_JPRB, &
  & 0.17793436E-05_JPRB, 0.17793928E-05_JPRB, 0.17794235E-05_JPRB, 0.17794555E-05_JPRB, 0.17794706E-05_JPRB, 0.17794463E-05_JPRB, &
  & 0.17794490E-05_JPRB, 0.17794606E-05_JPRB, 0.17794758E-05_JPRB, 0.17794653E-05_JPRB, 0.17794576E-05_JPRB, 0.17794596E-05_JPRB, &
  & 0.17794655E-05_JPRB, 0.17794453E-05_JPRB, 0.17794274E-05_JPRB, 0.17793151E-05_JPRB /)

RGHG2(:,81, 3) = (/ &
  & 0.17790771E-05_JPRB, 0.17790467E-05_JPRB, 0.17791090E-05_JPRB, 0.17791256E-05_JPRB, 0.17791735E-05_JPRB, 0.17792129E-05_JPRB, &
  & 0.17792460E-05_JPRB, 0.17792589E-05_JPRB, 0.17792667E-05_JPRB, 0.17792624E-05_JPRB, 0.17792489E-05_JPRB, 0.17792283E-05_JPRB, &
  & 0.17792070E-05_JPRB, 0.17791464E-05_JPRB, 0.17790716E-05_JPRB, 0.17789811E-05_JPRB, 0.17789168E-05_JPRB, 0.17788136E-05_JPRB, &
  & 0.17787461E-05_JPRB, 0.17786982E-05_JPRB, 0.17787096E-05_JPRB, 0.17787220E-05_JPRB, 0.17787506E-05_JPRB, 0.17788109E-05_JPRB, &
  & 0.17788342E-05_JPRB, 0.17788796E-05_JPRB, 0.17789152E-05_JPRB, 0.17789293E-05_JPRB, 0.17789247E-05_JPRB, 0.17788846E-05_JPRB, &
  & 0.17788598E-05_JPRB, 0.17788016E-05_JPRB, 0.17787247E-05_JPRB, 0.17786476E-05_JPRB, 0.17785853E-05_JPRB, 0.17785201E-05_JPRB, &
  & 0.17784868E-05_JPRB, 0.17784689E-05_JPRB, 0.17784829E-05_JPRB, 0.17785211E-05_JPRB, 0.17785767E-05_JPRB, 0.17786667E-05_JPRB, &
  & 0.17787693E-05_JPRB, 0.17789034E-05_JPRB, 0.17790370E-05_JPRB, 0.17791499E-05_JPRB, 0.17792713E-05_JPRB, 0.17793398E-05_JPRB, &
  & 0.17794068E-05_JPRB, 0.17794505E-05_JPRB, 0.17794782E-05_JPRB, 0.17795087E-05_JPRB, 0.17795226E-05_JPRB, 0.17794945E-05_JPRB, &
  & 0.17794964E-05_JPRB, 0.17795080E-05_JPRB, 0.17795239E-05_JPRB, 0.17795123E-05_JPRB, 0.17795039E-05_JPRB, 0.17795066E-05_JPRB, &
  & 0.17795143E-05_JPRB, 0.17794973E-05_JPRB, 0.17794930E-05_JPRB, 0.17795122E-05_JPRB /)

RGHG2(:,82, 3) = (/ &
  & 0.17791054E-05_JPRB, 0.17790848E-05_JPRB, 0.17791490E-05_JPRB, 0.17791641E-05_JPRB, 0.17792117E-05_JPRB, 0.17792486E-05_JPRB, &
  & 0.17792847E-05_JPRB, 0.17792934E-05_JPRB, 0.17793046E-05_JPRB, 0.17793024E-05_JPRB, 0.17792845E-05_JPRB, 0.17792707E-05_JPRB, &
  & 0.17792484E-05_JPRB, 0.17791917E-05_JPRB, 0.17791198E-05_JPRB, 0.17790333E-05_JPRB, 0.17789769E-05_JPRB, 0.17788768E-05_JPRB, &
  & 0.17788143E-05_JPRB, 0.17787686E-05_JPRB, 0.17787831E-05_JPRB, 0.17787946E-05_JPRB, 0.17788211E-05_JPRB, 0.17788794E-05_JPRB, &
  & 0.17788996E-05_JPRB, 0.17789432E-05_JPRB, 0.17789785E-05_JPRB, 0.17789927E-05_JPRB, 0.17789885E-05_JPRB, 0.17789489E-05_JPRB, &
  & 0.17789268E-05_JPRB, 0.17788709E-05_JPRB, 0.17787982E-05_JPRB, 0.17787270E-05_JPRB, 0.17786692E-05_JPRB, 0.17786072E-05_JPRB, &
  & 0.17785757E-05_JPRB, 0.17785592E-05_JPRB, 0.17785717E-05_JPRB, 0.17786067E-05_JPRB, 0.17786562E-05_JPRB, 0.17787397E-05_JPRB, &
  & 0.17788336E-05_JPRB, 0.17789619E-05_JPRB, 0.17790886E-05_JPRB, 0.17791950E-05_JPRB, 0.17793108E-05_JPRB, 0.17793737E-05_JPRB, &
  & 0.17794373E-05_JPRB, 0.17794785E-05_JPRB, 0.17795045E-05_JPRB, 0.17795343E-05_JPRB, 0.17795478E-05_JPRB, 0.17795173E-05_JPRB, &
  & 0.17795189E-05_JPRB, 0.17795311E-05_JPRB, 0.17795476E-05_JPRB, 0.17795348E-05_JPRB, 0.17795260E-05_JPRB, 0.17795289E-05_JPRB, &
  & 0.17795376E-05_JPRB, 0.17795201E-05_JPRB, 0.17795153E-05_JPRB, 0.17795280E-05_JPRB /)

RGHG2(:,83, 3) = (/ &
  & 0.17791256E-05_JPRB, 0.17791066E-05_JPRB, 0.17791715E-05_JPRB, 0.17791848E-05_JPRB, 0.17792325E-05_JPRB, 0.17792723E-05_JPRB, &
  & 0.17793029E-05_JPRB, 0.17793170E-05_JPRB, 0.17793236E-05_JPRB, 0.17793201E-05_JPRB, 0.17793100E-05_JPRB, 0.17792914E-05_JPRB, &
  & 0.17792739E-05_JPRB, 0.17792166E-05_JPRB, 0.17791466E-05_JPRB, 0.17790629E-05_JPRB, 0.17790096E-05_JPRB, 0.17789130E-05_JPRB, &
  & 0.17788520E-05_JPRB, 0.17788079E-05_JPRB, 0.17788241E-05_JPRB, 0.17788353E-05_JPRB, 0.17788605E-05_JPRB, 0.17789184E-05_JPRB, &
  & 0.17789357E-05_JPRB, 0.17789787E-05_JPRB, 0.17790139E-05_JPRB, 0.17790283E-05_JPRB, 0.17790246E-05_JPRB, 0.17789848E-05_JPRB, &
  & 0.17789645E-05_JPRB, 0.17789094E-05_JPRB, 0.17788386E-05_JPRB, 0.17787702E-05_JPRB, 0.17787157E-05_JPRB, 0.17786562E-05_JPRB, &
  & 0.17786258E-05_JPRB, 0.17786102E-05_JPRB, 0.17786224E-05_JPRB, 0.17786549E-05_JPRB, 0.17787020E-05_JPRB, 0.17787786E-05_JPRB, &
  & 0.17788691E-05_JPRB, 0.17789944E-05_JPRB, 0.17791183E-05_JPRB, 0.17792198E-05_JPRB, 0.17793345E-05_JPRB, 0.17793930E-05_JPRB, &
  & 0.17794546E-05_JPRB, 0.17794943E-05_JPRB, 0.17795189E-05_JPRB, 0.17795489E-05_JPRB, 0.17795622E-05_JPRB, 0.17795297E-05_JPRB, &
  & 0.17795307E-05_JPRB, 0.17795435E-05_JPRB, 0.17795603E-05_JPRB, 0.17795471E-05_JPRB, 0.17795379E-05_JPRB, 0.17795414E-05_JPRB, &
  & 0.17795508E-05_JPRB, 0.17795328E-05_JPRB, 0.17795280E-05_JPRB, 0.17795392E-05_JPRB /)

RGHG2(:,84, 3) = (/ &
  & 0.17791391E-05_JPRB, 0.17791206E-05_JPRB, 0.17791855E-05_JPRB, 0.17791976E-05_JPRB, 0.17792461E-05_JPRB, 0.17792820E-05_JPRB, &
  & 0.17793192E-05_JPRB, 0.17793263E-05_JPRB, 0.17793371E-05_JPRB, 0.17793354E-05_JPRB, 0.17793193E-05_JPRB, 0.17793076E-05_JPRB, &
  & 0.17792869E-05_JPRB, 0.17792340E-05_JPRB, 0.17791646E-05_JPRB, 0.17790817E-05_JPRB, 0.17790313E-05_JPRB, 0.17789343E-05_JPRB, &
  & 0.17788764E-05_JPRB, 0.17788321E-05_JPRB, 0.17788495E-05_JPRB, 0.17788601E-05_JPRB, 0.17788849E-05_JPRB, 0.17789424E-05_JPRB, &
  & 0.17789578E-05_JPRB, 0.17790005E-05_JPRB, 0.17790358E-05_JPRB, 0.17790503E-05_JPRB, 0.17790467E-05_JPRB, 0.17790069E-05_JPRB, &
  & 0.17789873E-05_JPRB, 0.17789325E-05_JPRB, 0.17788627E-05_JPRB, 0.17787970E-05_JPRB, 0.17787431E-05_JPRB, 0.17786874E-05_JPRB, &
  & 0.17786576E-05_JPRB, 0.17786429E-05_JPRB, 0.17786541E-05_JPRB, 0.17786863E-05_JPRB, 0.17787286E-05_JPRB, 0.17788042E-05_JPRB, &
  & 0.17788897E-05_JPRB, 0.17790126E-05_JPRB, 0.17791364E-05_JPRB, 0.17792358E-05_JPRB, 0.17793486E-05_JPRB, 0.17794048E-05_JPRB, &
  & 0.17794647E-05_JPRB, 0.17795039E-05_JPRB, 0.17795279E-05_JPRB, 0.17795579E-05_JPRB, 0.17795711E-05_JPRB, 0.17795371E-05_JPRB, &
  & 0.17795380E-05_JPRB, 0.17795510E-05_JPRB, 0.17795683E-05_JPRB, 0.17795549E-05_JPRB, 0.17795455E-05_JPRB, 0.17795492E-05_JPRB, &
  & 0.17795589E-05_JPRB, 0.17795410E-05_JPRB, 0.17795365E-05_JPRB, 0.17795467E-05_JPRB /)

RGHG2(:,85, 3) = (/ &
  & 0.17791480E-05_JPRB, 0.17791294E-05_JPRB, 0.17791942E-05_JPRB, 0.17792058E-05_JPRB, 0.17792536E-05_JPRB, 0.17792963E-05_JPRB, &
  & 0.17793229E-05_JPRB, 0.17793370E-05_JPRB, 0.17793420E-05_JPRB, 0.17793388E-05_JPRB, 0.17793296E-05_JPRB, 0.17793134E-05_JPRB, &
  & 0.17792946E-05_JPRB, 0.17792438E-05_JPRB, 0.17791774E-05_JPRB, 0.17790964E-05_JPRB, 0.17790451E-05_JPRB, 0.17789506E-05_JPRB, &
  & 0.17788916E-05_JPRB, 0.17788477E-05_JPRB, 0.17788660E-05_JPRB, 0.17788764E-05_JPRB, 0.17788999E-05_JPRB, 0.17789582E-05_JPRB, &
  & 0.17789714E-05_JPRB, 0.17790143E-05_JPRB, 0.17790497E-05_JPRB, 0.17790645E-05_JPRB, 0.17790612E-05_JPRB, 0.17790207E-05_JPRB, &
  & 0.17790020E-05_JPRB, 0.17789474E-05_JPRB, 0.17788784E-05_JPRB, 0.17788132E-05_JPRB, 0.17787625E-05_JPRB, 0.17787064E-05_JPRB, &
  & 0.17786779E-05_JPRB, 0.17786638E-05_JPRB, 0.17786761E-05_JPRB, 0.17787052E-05_JPRB, 0.17787499E-05_JPRB, 0.17788182E-05_JPRB, &
  & 0.17789033E-05_JPRB, 0.17790258E-05_JPRB, 0.17791467E-05_JPRB, 0.17792461E-05_JPRB, 0.17793585E-05_JPRB, 0.17794123E-05_JPRB, &
  & 0.17794715E-05_JPRB, 0.17795099E-05_JPRB, 0.17795337E-05_JPRB, 0.17795639E-05_JPRB, 0.17795770E-05_JPRB, 0.17795418E-05_JPRB, &
  & 0.17795423E-05_JPRB, 0.17795558E-05_JPRB, 0.17795734E-05_JPRB, 0.17795597E-05_JPRB, 0.17795498E-05_JPRB, 0.17795539E-05_JPRB, &
  & 0.17795641E-05_JPRB, 0.17795462E-05_JPRB, 0.17795419E-05_JPRB, 0.17795518E-05_JPRB /)

RGHG2(:,86, 3) = (/ &
  & 0.17791535E-05_JPRB, 0.17791345E-05_JPRB, 0.17792003E-05_JPRB, 0.17792111E-05_JPRB, 0.17792629E-05_JPRB, 0.17792964E-05_JPRB, &
  & 0.17793326E-05_JPRB, 0.17793386E-05_JPRB, 0.17793443E-05_JPRB, 0.17793415E-05_JPRB, 0.17793295E-05_JPRB, 0.17793163E-05_JPRB, &
  & 0.17792951E-05_JPRB, 0.17792504E-05_JPRB, 0.17791872E-05_JPRB, 0.17791099E-05_JPRB, 0.17790558E-05_JPRB, 0.17789615E-05_JPRB, &
  & 0.17789031E-05_JPRB, 0.17788574E-05_JPRB, 0.17788761E-05_JPRB, 0.17788859E-05_JPRB, 0.17789091E-05_JPRB, 0.17789686E-05_JPRB, &
  & 0.17789798E-05_JPRB, 0.17790230E-05_JPRB, 0.17790589E-05_JPRB, 0.17790738E-05_JPRB, 0.17790704E-05_JPRB, 0.17790295E-05_JPRB, &
  & 0.17790114E-05_JPRB, 0.17789569E-05_JPRB, 0.17788882E-05_JPRB, 0.17788252E-05_JPRB, 0.17787727E-05_JPRB, 0.17787197E-05_JPRB, &
  & 0.17786901E-05_JPRB, 0.17786766E-05_JPRB, 0.17786881E-05_JPRB, 0.17787197E-05_JPRB, 0.17787585E-05_JPRB, 0.17788309E-05_JPRB, &
  & 0.17789123E-05_JPRB, 0.17790327E-05_JPRB, 0.17791562E-05_JPRB, 0.17792522E-05_JPRB, 0.17793650E-05_JPRB, 0.17794171E-05_JPRB, &
  & 0.17794755E-05_JPRB, 0.17795137E-05_JPRB, 0.17795371E-05_JPRB, 0.17795676E-05_JPRB, 0.17795808E-05_JPRB, 0.17795446E-05_JPRB, &
  & 0.17795447E-05_JPRB, 0.17795586E-05_JPRB, 0.17795769E-05_JPRB, 0.17795627E-05_JPRB, 0.17795526E-05_JPRB, 0.17795568E-05_JPRB, &
  & 0.17795676E-05_JPRB, 0.17795494E-05_JPRB, 0.17795453E-05_JPRB, 0.17795551E-05_JPRB /)

RGHG2(:,87, 3) = (/ &
  & 0.17791571E-05_JPRB, 0.17791383E-05_JPRB, 0.17792036E-05_JPRB, 0.17792161E-05_JPRB, 0.17792632E-05_JPRB, 0.17793095E-05_JPRB, &
  & 0.17793302E-05_JPRB, 0.17793407E-05_JPRB, 0.17793434E-05_JPRB, 0.17793391E-05_JPRB, 0.17793294E-05_JPRB, 0.17793147E-05_JPRB, &
  & 0.17792943E-05_JPRB, 0.17792527E-05_JPRB, 0.17791940E-05_JPRB, 0.17791195E-05_JPRB, 0.17790637E-05_JPRB, 0.17789708E-05_JPRB, &
  & 0.17789100E-05_JPRB, 0.17788637E-05_JPRB, 0.17788826E-05_JPRB, 0.17788924E-05_JPRB, 0.17789145E-05_JPRB, 0.17789752E-05_JPRB, &
  & 0.17789849E-05_JPRB, 0.17790284E-05_JPRB, 0.17790644E-05_JPRB, 0.17790796E-05_JPRB, 0.17790767E-05_JPRB, 0.17790352E-05_JPRB, &
  & 0.17790177E-05_JPRB, 0.17789629E-05_JPRB, 0.17788956E-05_JPRB, 0.17788311E-05_JPRB, 0.17787825E-05_JPRB, 0.17787249E-05_JPRB, &
  & 0.17786969E-05_JPRB, 0.17786820E-05_JPRB, 0.17786947E-05_JPRB, 0.17787243E-05_JPRB, 0.17787675E-05_JPRB, 0.17788350E-05_JPRB, &
  & 0.17789187E-05_JPRB, 0.17790421E-05_JPRB, 0.17791613E-05_JPRB, 0.17792577E-05_JPRB, 0.17793693E-05_JPRB, 0.17794199E-05_JPRB, &
  & 0.17794781E-05_JPRB, 0.17795159E-05_JPRB, 0.17795393E-05_JPRB, 0.17795699E-05_JPRB, 0.17795828E-05_JPRB, 0.17795458E-05_JPRB, &
  & 0.17795460E-05_JPRB, 0.17795605E-05_JPRB, 0.17795791E-05_JPRB, 0.17795643E-05_JPRB, 0.17795537E-05_JPRB, 0.17795586E-05_JPRB, &
  & 0.17795696E-05_JPRB, 0.17795514E-05_JPRB, 0.17795470E-05_JPRB, 0.17795571E-05_JPRB /)

RGHG2(:,88, 3) = (/ &
  & 0.17791590E-05_JPRB, 0.17791415E-05_JPRB, 0.17792053E-05_JPRB, 0.17792166E-05_JPRB, 0.17792718E-05_JPRB, 0.17793029E-05_JPRB, &
  & 0.17793354E-05_JPRB, 0.17793409E-05_JPRB, 0.17793440E-05_JPRB, 0.17793402E-05_JPRB, 0.17793293E-05_JPRB, 0.17793157E-05_JPRB, &
  & 0.17792947E-05_JPRB, 0.17792547E-05_JPRB, 0.17791967E-05_JPRB, 0.17791251E-05_JPRB, 0.17790676E-05_JPRB, 0.17789758E-05_JPRB, &
  & 0.17789150E-05_JPRB, 0.17788675E-05_JPRB, 0.17788863E-05_JPRB, 0.17788961E-05_JPRB, 0.17789176E-05_JPRB, 0.17789796E-05_JPRB, &
  & 0.17789873E-05_JPRB, 0.17790314E-05_JPRB, 0.17790679E-05_JPRB, 0.17790833E-05_JPRB, 0.17790808E-05_JPRB, 0.17790383E-05_JPRB, &
  & 0.17790218E-05_JPRB, 0.17789671E-05_JPRB, 0.17788997E-05_JPRB, 0.17788371E-05_JPRB, 0.17787866E-05_JPRB, 0.17787296E-05_JPRB, &
  & 0.17786992E-05_JPRB, 0.17786834E-05_JPRB, 0.17786963E-05_JPRB, 0.17787291E-05_JPRB, 0.17787670E-05_JPRB, 0.17788417E-05_JPRB, &
  & 0.17789237E-05_JPRB, 0.17790472E-05_JPRB, 0.17791684E-05_JPRB, 0.17792611E-05_JPRB, 0.17793727E-05_JPRB, 0.17794217E-05_JPRB, &
  & 0.17794794E-05_JPRB, 0.17795172E-05_JPRB, 0.17795404E-05_JPRB, 0.17795714E-05_JPRB, 0.17795842E-05_JPRB, 0.17795462E-05_JPRB, &
  & 0.17795467E-05_JPRB, 0.17795617E-05_JPRB, 0.17795805E-05_JPRB, 0.17795654E-05_JPRB, 0.17795546E-05_JPRB, 0.17795592E-05_JPRB, &
  & 0.17795707E-05_JPRB, 0.17795526E-05_JPRB, 0.17795487E-05_JPRB, 0.17795588E-05_JPRB /)

RGHG2(:,89, 3) = (/ &
  & 0.17791601E-05_JPRB, 0.17791451E-05_JPRB, 0.17792054E-05_JPRB, 0.17792186E-05_JPRB, 0.17792653E-05_JPRB, 0.17793120E-05_JPRB, &
  & 0.17793336E-05_JPRB, 0.17793443E-05_JPRB, 0.17793470E-05_JPRB, 0.17793427E-05_JPRB, 0.17793326E-05_JPRB, 0.17793183E-05_JPRB, &
  & 0.17792978E-05_JPRB, 0.17792562E-05_JPRB, 0.17791972E-05_JPRB, 0.17791233E-05_JPRB, 0.17790693E-05_JPRB, 0.17789757E-05_JPRB, &
  & 0.17789157E-05_JPRB, 0.17788684E-05_JPRB, 0.17788883E-05_JPRB, 0.17788980E-05_JPRB, 0.17789191E-05_JPRB, 0.17789824E-05_JPRB, &
  & 0.17789886E-05_JPRB, 0.17790331E-05_JPRB, 0.17790701E-05_JPRB, 0.17790856E-05_JPRB, 0.17790834E-05_JPRB, 0.17790400E-05_JPRB, &
  & 0.17790248E-05_JPRB, 0.17789697E-05_JPRB, 0.17789030E-05_JPRB, 0.17788389E-05_JPRB, 0.17787917E-05_JPRB, 0.17787286E-05_JPRB, &
  & 0.17787004E-05_JPRB, 0.17786829E-05_JPRB, 0.17786972E-05_JPRB, 0.17787291E-05_JPRB, 0.17787687E-05_JPRB, 0.17788432E-05_JPRB, &
  & 0.17789257E-05_JPRB, 0.17790535E-05_JPRB, 0.17791715E-05_JPRB, 0.17792630E-05_JPRB, 0.17793751E-05_JPRB, 0.17794227E-05_JPRB, &
  & 0.17794799E-05_JPRB, 0.17795180E-05_JPRB, 0.17795411E-05_JPRB, 0.17795720E-05_JPRB, 0.17795853E-05_JPRB, 0.17795463E-05_JPRB, &
  & 0.17795473E-05_JPRB, 0.17795627E-05_JPRB, 0.17795817E-05_JPRB, 0.17795659E-05_JPRB, 0.17795552E-05_JPRB, 0.17795595E-05_JPRB, &
  & 0.17795719E-05_JPRB, 0.17795535E-05_JPRB, 0.17795491E-05_JPRB, 0.17795593E-05_JPRB /)

RGHG2(:,90, 3) = (/ &
  & 0.17791604E-05_JPRB, 0.17791479E-05_JPRB, 0.17792036E-05_JPRB, 0.17792156E-05_JPRB, 0.17792679E-05_JPRB, 0.17793031E-05_JPRB, &
  & 0.17793402E-05_JPRB, 0.17793470E-05_JPRB, 0.17793532E-05_JPRB, 0.17793502E-05_JPRB, 0.17793380E-05_JPRB, 0.17793243E-05_JPRB, &
  & 0.17793042E-05_JPRB, 0.17792584E-05_JPRB, 0.17791942E-05_JPRB, 0.17791177E-05_JPRB, 0.17790691E-05_JPRB, 0.17789725E-05_JPRB, &
  & 0.17789148E-05_JPRB, 0.17788666E-05_JPRB, 0.17788893E-05_JPRB, 0.17788985E-05_JPRB, 0.17789185E-05_JPRB, 0.17789851E-05_JPRB, &
  & 0.17789881E-05_JPRB, 0.17790342E-05_JPRB, 0.17790712E-05_JPRB, 0.17790871E-05_JPRB, 0.17790857E-05_JPRB, 0.17790402E-05_JPRB, &
  & 0.17790272E-05_JPRB, 0.17789715E-05_JPRB, 0.17789038E-05_JPRB, 0.17788399E-05_JPRB, 0.17787931E-05_JPRB, 0.17787282E-05_JPRB, &
  & 0.17787000E-05_JPRB, 0.17786820E-05_JPRB, 0.17786965E-05_JPRB, 0.17787302E-05_JPRB, 0.17787664E-05_JPRB, 0.17788446E-05_JPRB, &
  & 0.17789262E-05_JPRB, 0.17790555E-05_JPRB, 0.17791746E-05_JPRB, 0.17792639E-05_JPRB, 0.17793776E-05_JPRB, 0.17794232E-05_JPRB, &
  & 0.17794813E-05_JPRB, 0.17795190E-05_JPRB, 0.17795415E-05_JPRB, 0.17795730E-05_JPRB, 0.17795871E-05_JPRB, 0.17795453E-05_JPRB, &
  & 0.17795468E-05_JPRB, 0.17795628E-05_JPRB, 0.17795830E-05_JPRB, 0.17795664E-05_JPRB, 0.17795549E-05_JPRB, 0.17795594E-05_JPRB, &
  & 0.17795728E-05_JPRB, 0.17795530E-05_JPRB, 0.17795495E-05_JPRB, 0.17795601E-05_JPRB /)

RGHG2(:,91, 3) = (/ &
  & 0.17791607E-05_JPRB, 0.17791491E-05_JPRB, 0.17792013E-05_JPRB, 0.17792115E-05_JPRB, 0.17792644E-05_JPRB, 0.17793020E-05_JPRB, &
  & 0.17793412E-05_JPRB, 0.17793474E-05_JPRB, 0.17793622E-05_JPRB, 0.17793624E-05_JPRB, 0.17793423E-05_JPRB, 0.17793286E-05_JPRB, &
  & 0.17793186E-05_JPRB, 0.17792590E-05_JPRB, 0.17791897E-05_JPRB, 0.17791047E-05_JPRB, 0.17790728E-05_JPRB, 0.17789655E-05_JPRB, &
  & 0.17789127E-05_JPRB, 0.17788616E-05_JPRB, 0.17788904E-05_JPRB, 0.17788983E-05_JPRB, 0.17789158E-05_JPRB, 0.17789890E-05_JPRB, &
  & 0.17789856E-05_JPRB, 0.17790348E-05_JPRB, 0.17790732E-05_JPRB, 0.17790888E-05_JPRB, 0.17790900E-05_JPRB, 0.17790379E-05_JPRB, &
  & 0.17790317E-05_JPRB, 0.17789741E-05_JPRB, 0.17789042E-05_JPRB, 0.17788371E-05_JPRB, 0.17787955E-05_JPRB, 0.17787239E-05_JPRB, &
  & 0.17786988E-05_JPRB, 0.17786796E-05_JPRB, 0.17786956E-05_JPRB, 0.17787301E-05_JPRB, 0.17787638E-05_JPRB, 0.17788444E-05_JPRB, &
  & 0.17789237E-05_JPRB, 0.17790576E-05_JPRB, 0.17791772E-05_JPRB, 0.17792628E-05_JPRB, 0.17793827E-05_JPRB, 0.17794226E-05_JPRB, &
  & 0.17794830E-05_JPRB, 0.17795203E-05_JPRB, 0.17795410E-05_JPRB, 0.17795743E-05_JPRB, 0.17795909E-05_JPRB, 0.17795422E-05_JPRB, &
  & 0.17795461E-05_JPRB, 0.17795629E-05_JPRB, 0.17795858E-05_JPRB, 0.17795659E-05_JPRB, 0.17795538E-05_JPRB, 0.17795593E-05_JPRB, &
  & 0.17795749E-05_JPRB, 0.17795517E-05_JPRB, 0.17795493E-05_JPRB, 0.17795603E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART6',1,ZHOOK_HANDLE)
END SUBROUTINE PART6






SUBROUTINE PART7
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART7',0,ZHOOK_HANDLE)



!-- Month=  4 ------------

RGHG2(:, 1, 4) = (/ &
  & 0.63767698E-08_JPRB, 0.64531704E-08_JPRB, 0.65530559E-08_JPRB, 0.67367472E-08_JPRB, 0.69303487E-08_JPRB, 0.71184458E-08_JPRB, &
  & 0.72946253E-08_JPRB, 0.74500179E-08_JPRB, 0.75521509E-08_JPRB, 0.75392537E-08_JPRB, 0.73679765E-08_JPRB, 0.70817912E-08_JPRB, &
  & 0.68121393E-08_JPRB, 0.66857035E-08_JPRB, 0.67127690E-08_JPRB, 0.67705734E-08_JPRB, 0.67339001E-08_JPRB, 0.65853039E-08_JPRB, &
  & 0.63809784E-08_JPRB, 0.61529644E-08_JPRB, 0.59086647E-08_JPRB, 0.56525731E-08_JPRB, 0.53932565E-08_JPRB, 0.51474043E-08_JPRB, &
  & 0.50641060E-08_JPRB, 0.55452500E-08_JPRB, 0.65275532E-08_JPRB, 0.77710718E-08_JPRB, 0.92354338E-08_JPRB, 0.10874714E-07_JPRB, &
  & 0.12574255E-07_JPRB, 0.14217343E-07_JPRB, 0.15816994E-07_JPRB, 0.17327960E-07_JPRB, 0.18628462E-07_JPRB, 0.19679222E-07_JPRB, &
  & 0.20409372E-07_JPRB, 0.20717952E-07_JPRB, 0.20588194E-07_JPRB, 0.19946803E-07_JPRB, 0.19318996E-07_JPRB, 0.18522599E-07_JPRB, &
  & 0.17611031E-07_JPRB, 0.16572860E-07_JPRB, 0.15402716E-07_JPRB, 0.14095287E-07_JPRB, 0.12660113E-07_JPRB, 0.11077463E-07_JPRB, &
  & 0.93406793E-08_JPRB, 0.75964470E-08_JPRB, 0.61001155E-08_JPRB, 0.49329469E-08_JPRB, 0.40502668E-08_JPRB, 0.34071099E-08_JPRB, &
  & 0.29671032E-08_JPRB, 0.26965714E-08_JPRB, 0.25515785E-08_JPRB, 0.24872329E-08_JPRB, 0.24684026E-08_JPRB, 0.24763935E-08_JPRB, &
  & 0.25307223E-08_JPRB, 0.26217819E-08_JPRB, 0.27453262E-08_JPRB, 0.29016118E-08_JPRB /)

RGHG2(:, 2, 4) = (/ &
  & 0.80907157E-08_JPRB, 0.93547996E-08_JPRB, 0.10154987E-07_JPRB, 0.10958027E-07_JPRB, 0.11700387E-07_JPRB, 0.12335128E-07_JPRB, &
  & 0.12782927E-07_JPRB, 0.13003817E-07_JPRB, 0.13069102E-07_JPRB, 0.13169998E-07_JPRB, 0.13480871E-07_JPRB, 0.13986226E-07_JPRB, &
  & 0.14477903E-07_JPRB, 0.14774173E-07_JPRB, 0.14886802E-07_JPRB, 0.14939724E-07_JPRB, 0.15005888E-07_JPRB, 0.15067908E-07_JPRB, &
  & 0.15067522E-07_JPRB, 0.14982092E-07_JPRB, 0.14837774E-07_JPRB, 0.14700646E-07_JPRB, 0.14659564E-07_JPRB, 0.14829522E-07_JPRB, &
  & 0.15386941E-07_JPRB, 0.16518825E-07_JPRB, 0.18272388E-07_JPRB, 0.20660437E-07_JPRB, 0.23677611E-07_JPRB, 0.27239899E-07_JPRB, &
  & 0.31152513E-07_JPRB, 0.35172079E-07_JPRB, 0.39098477E-07_JPRB, 0.42607887E-07_JPRB, 0.45576488E-07_JPRB, 0.47948156E-07_JPRB, &
  & 0.49711392E-07_JPRB, 0.50767980E-07_JPRB, 0.50951556E-07_JPRB, 0.50199468E-07_JPRB, 0.48804996E-07_JPRB, 0.46884068E-07_JPRB, &
  & 0.44509836E-07_JPRB, 0.41744265E-07_JPRB, 0.38562234E-07_JPRB, 0.34993160E-07_JPRB, 0.31083626E-07_JPRB, 0.26989195E-07_JPRB, &
  & 0.22925125E-07_JPRB, 0.19207462E-07_JPRB, 0.16073736E-07_JPRB, 0.13478171E-07_JPRB, 0.11310354E-07_JPRB, 0.95415320E-08_JPRB, &
  & 0.81550722E-08_JPRB, 0.71407005E-08_JPRB, 0.64308328E-08_JPRB, 0.59655498E-08_JPRB, 0.56763412E-08_JPRB, 0.55028719E-08_JPRB, &
  & 0.53972729E-08_JPRB, 0.53216231E-08_JPRB, 0.52458557E-08_JPRB, 0.50712741E-08_JPRB /)

RGHG2(:, 3, 4) = (/ &
  & 0.10036773E-07_JPRB, 0.11742121E-07_JPRB, 0.12781697E-07_JPRB, 0.13722732E-07_JPRB, 0.14636845E-07_JPRB, 0.15487281E-07_JPRB, &
  & 0.16346673E-07_JPRB, 0.17345510E-07_JPRB, 0.18572402E-07_JPRB, 0.19975783E-07_JPRB, 0.21397307E-07_JPRB, 0.22736089E-07_JPRB, &
  & 0.24004903E-07_JPRB, 0.25231543E-07_JPRB, 0.26376105E-07_JPRB, 0.27446763E-07_JPRB, 0.28495347E-07_JPRB, 0.29493039E-07_JPRB, &
  & 0.30375617E-07_JPRB, 0.31112663E-07_JPRB, 0.31716716E-07_JPRB, 0.32268140E-07_JPRB, 0.32912311E-07_JPRB, 0.33874564E-07_JPRB, &
  & 0.35407723E-07_JPRB, 0.37586801E-07_JPRB, 0.40365421E-07_JPRB, 0.43657881E-07_JPRB, 0.47477791E-07_JPRB, 0.51855046E-07_JPRB, &
  & 0.56679152E-07_JPRB, 0.61582071E-07_JPRB, 0.66054326E-07_JPRB, 0.69887456E-07_JPRB, 0.72942058E-07_JPRB, 0.75316400E-07_JPRB, &
  & 0.77036347E-07_JPRB, 0.78013684E-07_JPRB, 0.78112429E-07_JPRB, 0.77163520E-07_JPRB, 0.75206984E-07_JPRB, 0.72456558E-07_JPRB, &
  & 0.69092302E-07_JPRB, 0.65092813E-07_JPRB, 0.60518651E-07_JPRB, 0.55444165E-07_JPRB, 0.50013618E-07_JPRB, 0.44396952E-07_JPRB, &
  & 0.38819511E-07_JPRB, 0.33527833E-07_JPRB, 0.28697238E-07_JPRB, 0.24470948E-07_JPRB, 0.20934648E-07_JPRB, 0.18064117E-07_JPRB, &
  & 0.15794274E-07_JPRB, 0.14011693E-07_JPRB, 0.12672629E-07_JPRB, 0.11696405E-07_JPRB, 0.11006628E-07_JPRB, 0.10507271E-07_JPRB, &
  & 0.10121900E-07_JPRB, 0.97871551E-08_JPRB, 0.94450288E-08_JPRB, 0.89554195E-08_JPRB /)

RGHG2(:, 4, 4) = (/ &
  & 0.11922872E-07_JPRB, 0.14294454E-07_JPRB, 0.15807593E-07_JPRB, 0.17346268E-07_JPRB, 0.19025446E-07_JPRB, 0.20965675E-07_JPRB, &
  & 0.23143954E-07_JPRB, 0.25416488E-07_JPRB, 0.27635110E-07_JPRB, 0.29745902E-07_JPRB, 0.31802752E-07_JPRB, 0.33854448E-07_JPRB, &
  & 0.35898370E-07_JPRB, 0.37922607E-07_JPRB, 0.39973663E-07_JPRB, 0.42093070E-07_JPRB, 0.44307576E-07_JPRB, 0.46667058E-07_JPRB, &
  & 0.49208801E-07_JPRB, 0.51942731E-07_JPRB, 0.54872640E-07_JPRB, 0.58000605E-07_JPRB, 0.61369661E-07_JPRB, 0.65032850E-07_JPRB, &
  & 0.68914723E-07_JPRB, 0.72940026E-07_JPRB, 0.77006064E-07_JPRB, 0.81159030E-07_JPRB, 0.85365009E-07_JPRB, 0.89444704E-07_JPRB, &
  & 0.93104987E-07_JPRB, 0.96051359E-07_JPRB, 0.98226877E-07_JPRB, 0.99740703E-07_JPRB, 0.10079284E-06_JPRB, 0.10143475E-06_JPRB, &
  & 0.10164863E-06_JPRB, 0.10132069E-06_JPRB, 0.10025426E-06_JPRB, 0.98202214E-07_JPRB, 0.94944184E-07_JPRB, 0.90540972E-07_JPRB, &
  & 0.85338456E-07_JPRB, 0.79746556E-07_JPRB, 0.73873579E-07_JPRB, 0.67762656E-07_JPRB, 0.61547297E-07_JPRB, 0.55566478E-07_JPRB, &
  & 0.49963788E-07_JPRB, 0.44789289E-07_JPRB, 0.40123567E-07_JPRB, 0.35972775E-07_JPRB, 0.32265302E-07_JPRB, 0.28934913E-07_JPRB, &
  & 0.25945148E-07_JPRB, 0.23349847E-07_JPRB, 0.21154472E-07_JPRB, 0.19369555E-07_JPRB, 0.17969576E-07_JPRB, 0.16877568E-07_JPRB, &
  & 0.16034042E-07_JPRB, 0.15338957E-07_JPRB, 0.14709340E-07_JPRB, 0.13841346E-07_JPRB /)

RGHG2(:, 5, 4) = (/ &
  & 0.14063032E-07_JPRB, 0.17419273E-07_JPRB, 0.19822291E-07_JPRB, 0.22249923E-07_JPRB, 0.24914506E-07_JPRB, 0.27700843E-07_JPRB, &
  & 0.30492512E-07_JPRB, 0.33231309E-07_JPRB, 0.35889613E-07_JPRB, 0.38455148E-07_JPRB, 0.40898954E-07_JPRB, 0.43263611E-07_JPRB, &
  & 0.45660812E-07_JPRB, 0.48241251E-07_JPRB, 0.51153414E-07_JPRB, 0.54511816E-07_JPRB, 0.58368933E-07_JPRB, 0.62775776E-07_JPRB, &
  & 0.67797338E-07_JPRB, 0.73457727E-07_JPRB, 0.79697820E-07_JPRB, 0.86418574E-07_JPRB, 0.93420283E-07_JPRB, 0.10041030E-06_JPRB, &
  & 0.10705259E-06_JPRB, 0.11309362E-06_JPRB, 0.11855052E-06_JPRB, 0.12335796E-06_JPRB, 0.12741152E-06_JPRB, 0.13044522E-06_JPRB, &
  & 0.13221035E-06_JPRB, 0.13251885E-06_JPRB, 0.13163638E-06_JPRB, 0.13007724E-06_JPRB, 0.12820328E-06_JPRB, 0.12620893E-06_JPRB, &
  & 0.12407457E-06_JPRB, 0.12161001E-06_JPRB, 0.11850598E-06_JPRB, 0.11449893E-06_JPRB, 0.10942098E-06_JPRB, 0.10349970E-06_JPRB, &
  & 0.96789357E-07_JPRB, 0.89270245E-07_JPRB, 0.81598543E-07_JPRB, 0.74449211E-07_JPRB, 0.68112776E-07_JPRB, 0.62416063E-07_JPRB, &
  & 0.57397685E-07_JPRB, 0.52914359E-07_JPRB, 0.48823821E-07_JPRB, 0.45053984E-07_JPRB, 0.41540016E-07_JPRB, 0.38259611E-07_JPRB, &
  & 0.35227618E-07_JPRB, 0.32458722E-07_JPRB, 0.29976434E-07_JPRB, 0.27811273E-07_JPRB, 0.25964992E-07_JPRB, 0.24449305E-07_JPRB, &
  & 0.23208555E-07_JPRB, 0.22159540E-07_JPRB, 0.21156401E-07_JPRB, 0.19734651E-07_JPRB /)

RGHG2(:, 6, 4) = (/ &
  & 0.16863082E-07_JPRB, 0.21497415E-07_JPRB, 0.24699787E-07_JPRB, 0.27711103E-07_JPRB, 0.30695624E-07_JPRB, 0.33628886E-07_JPRB, &
  & 0.36492356E-07_JPRB, 0.39226762E-07_JPRB, 0.41866404E-07_JPRB, 0.44509058E-07_JPRB, 0.47259512E-07_JPRB, 0.50178855E-07_JPRB, &
  & 0.53328023E-07_JPRB, 0.56792889E-07_JPRB, 0.60678950E-07_JPRB, 0.65112218E-07_JPRB, 0.70245434E-07_JPRB, 0.76175660E-07_JPRB, &
  & 0.82901835E-07_JPRB, 0.90302208E-07_JPRB, 0.98257473E-07_JPRB, 0.10670614E-06_JPRB, 0.11554236E-06_JPRB, 0.12445211E-06_JPRB, &
  & 0.13288961E-06_JPRB, 0.14049381E-06_JPRB, 0.14717560E-06_JPRB, 0.15288289E-06_JPRB, 0.15744395E-06_JPRB, 0.16057555E-06_JPRB, &
  & 0.16196859E-06_JPRB, 0.16144968E-06_JPRB, 0.15929511E-06_JPRB, 0.15603956E-06_JPRB, 0.15222830E-06_JPRB, 0.14820515E-06_JPRB, &
  & 0.14401633E-06_JPRB, 0.13951369E-06_JPRB, 0.13445521E-06_JPRB, 0.12855841E-06_JPRB, 0.12159009E-06_JPRB, 0.11340641E-06_JPRB, &
  & 0.10473062E-06_JPRB, 0.96761092E-07_JPRB, 0.89810257E-07_JPRB, 0.83233942E-07_JPRB, 0.76889741E-07_JPRB, 0.71187330E-07_JPRB, &
  & 0.66233653E-07_JPRB, 0.61874481E-07_JPRB, 0.57918527E-07_JPRB, 0.54222948E-07_JPRB, 0.50719969E-07_JPRB, 0.47418368E-07_JPRB, &
  & 0.44319840E-07_JPRB, 0.41444363E-07_JPRB, 0.38827302E-07_JPRB, 0.36492068E-07_JPRB, 0.34491364E-07_JPRB, 0.32794500E-07_JPRB, &
  & 0.31434261E-07_JPRB, 0.30277224E-07_JPRB, 0.29184561E-07_JPRB, 0.27578146E-07_JPRB /)

RGHG2(:, 7, 4) = (/ &
  & 0.20771243E-07_JPRB, 0.26605161E-07_JPRB, 0.30148300E-07_JPRB, 0.33159534E-07_JPRB, 0.35938843E-07_JPRB, 0.38542566E-07_JPRB, &
  & 0.41068738E-07_JPRB, 0.43611699E-07_JPRB, 0.46224123E-07_JPRB, 0.48983548E-07_JPRB, 0.51970300E-07_JPRB, 0.55247902E-07_JPRB, &
  & 0.58843465E-07_JPRB, 0.62771946E-07_JPRB, 0.67070140E-07_JPRB, 0.71833227E-07_JPRB, 0.77189114E-07_JPRB, 0.83313950E-07_JPRB, &
  & 0.90331582E-07_JPRB, 0.98284531E-07_JPRB, 0.10704542E-06_JPRB, 0.11635878E-06_JPRB, 0.12616830E-06_JPRB, 0.13646611E-06_JPRB, &
  & 0.14674974E-06_JPRB, 0.15642732E-06_JPRB, 0.16513428E-06_JPRB, 0.17269556E-06_JPRB, 0.17879071E-06_JPRB, 0.18308596E-06_JPRB, &
  & 0.18511986E-06_JPRB, 0.18471337E-06_JPRB, 0.18210548E-06_JPRB, 0.17799334E-06_JPRB, 0.17291364E-06_JPRB, 0.16724454E-06_JPRB, &
  & 0.16123701E-06_JPRB, 0.15484272E-06_JPRB, 0.14780167E-06_JPRB, 0.13995094E-06_JPRB, 0.13147411E-06_JPRB, 0.12307279E-06_JPRB, &
  & 0.11487663E-06_JPRB, 0.10663175E-06_JPRB, 0.98453540E-07_JPRB, 0.91231989E-07_JPRB, 0.85428582E-07_JPRB, 0.80476831E-07_JPRB, &
  & 0.75909071E-07_JPRB, 0.71647221E-07_JPRB, 0.67675956E-07_JPRB, 0.63918307E-07_JPRB, 0.60315863E-07_JPRB, 0.56863804E-07_JPRB, &
  & 0.53596438E-07_JPRB, 0.50567493E-07_JPRB, 0.47817156E-07_JPRB, 0.45386585E-07_JPRB, 0.43286548E-07_JPRB, 0.41548638E-07_JPRB, &
  & 0.40182591E-07_JPRB, 0.39081726E-07_JPRB, 0.38052999E-07_JPRB, 0.36572995E-07_JPRB /)

RGHG2(:, 8, 4) = (/ &
  & 0.25986724E-07_JPRB, 0.32277761E-07_JPRB, 0.35634120E-07_JPRB, 0.38362344E-07_JPRB, 0.40963283E-07_JPRB, 0.43601670E-07_JPRB, &
  & 0.46388369E-07_JPRB, 0.49379665E-07_JPRB, 0.52619868E-07_JPRB, 0.56102397E-07_JPRB, 0.59801764E-07_JPRB, 0.63674030E-07_JPRB, &
  & 0.67687289E-07_JPRB, 0.71828481E-07_JPRB, 0.76152787E-07_JPRB, 0.80763137E-07_JPRB, 0.85838487E-07_JPRB, 0.91533465E-07_JPRB, &
  & 0.98039372E-07_JPRB, 0.10552903E-06_JPRB, 0.11421071E-06_JPRB, 0.12413922E-06_JPRB, 0.13504753E-06_JPRB, 0.14671541E-06_JPRB, &
  & 0.15910447E-06_JPRB, 0.17122731E-06_JPRB, 0.18241400E-06_JPRB, 0.19206365E-06_JPRB, 0.19982036E-06_JPRB, 0.20513914E-06_JPRB, &
  & 0.20765570E-06_JPRB, 0.20727713E-06_JPRB, 0.20439417E-06_JPRB, 0.19942003E-06_JPRB, 0.19310582E-06_JPRB, 0.18603296E-06_JPRB, &
  & 0.17831610E-06_JPRB, 0.16999881E-06_JPRB, 0.16120492E-06_JPRB, 0.15213433E-06_JPRB, 0.14270694E-06_JPRB, 0.13270540E-06_JPRB, &
  & 0.12287410E-06_JPRB, 0.11408567E-06_JPRB, 0.10676577E-06_JPRB, 0.10054207E-06_JPRB, 0.94829005E-07_JPRB, 0.89550525E-07_JPRB, &
  & 0.84810623E-07_JPRB, 0.80504890E-07_JPRB, 0.76465476E-07_JPRB, 0.72629625E-07_JPRB, 0.68984178E-07_JPRB, 0.65524219E-07_JPRB, &
  & 0.62271482E-07_JPRB, 0.59255552E-07_JPRB, 0.56510814E-07_JPRB, 0.54074732E-07_JPRB, 0.51996743E-07_JPRB, 0.50282082E-07_JPRB, &
  & 0.49014837E-07_JPRB, 0.48033915E-07_JPRB, 0.47175536E-07_JPRB, 0.45980482E-07_JPRB /)

RGHG2(:, 9, 4) = (/ &
  & 0.32308535E-07_JPRB, 0.38609368E-07_JPRB, 0.42242149E-07_JPRB, 0.45655479E-07_JPRB, 0.49273964E-07_JPRB, 0.53260059E-07_JPRB, &
  & 0.57681689E-07_JPRB, 0.62545084E-07_JPRB, 0.67813950E-07_JPRB, 0.73417034E-07_JPRB, 0.79255237E-07_JPRB, 0.85145587E-07_JPRB, &
  & 0.90852311E-07_JPRB, 0.96233634E-07_JPRB, 0.10132030E-06_JPRB, 0.10626841E-06_JPRB, 0.11129455E-06_JPRB, 0.11670720E-06_JPRB, &
  & 0.12284158E-06_JPRB, 0.12999399E-06_JPRB, 0.13841996E-06_JPRB, 0.14833661E-06_JPRB, 0.15967382E-06_JPRB, 0.17204144E-06_JPRB, &
  & 0.18473960E-06_JPRB, 0.19749554E-06_JPRB, 0.20925846E-06_JPRB, 0.21949090E-06_JPRB, 0.22758596E-06_JPRB, 0.23306436E-06_JPRB, &
  & 0.23542360E-06_JPRB, 0.23447183E-06_JPRB, 0.23041187E-06_JPRB, 0.22405443E-06_JPRB, 0.21618777E-06_JPRB, 0.20721427E-06_JPRB, &
  & 0.19765210E-06_JPRB, 0.18753576E-06_JPRB, 0.17684586E-06_JPRB, 0.16568532E-06_JPRB, 0.15460195E-06_JPRB, 0.14432520E-06_JPRB, &
  & 0.13482330E-06_JPRB, 0.12582068E-06_JPRB, 0.11739826E-06_JPRB, 0.10984228E-06_JPRB, 0.10342858E-06_JPRB, 0.97978216E-07_JPRB, &
  & 0.93085731E-07_JPRB, 0.88572364E-07_JPRB, 0.84374207E-07_JPRB, 0.80428052E-07_JPRB, 0.76728213E-07_JPRB, 0.73284021E-07_JPRB, &
  & 0.70087900E-07_JPRB, 0.67162418E-07_JPRB, 0.64534056E-07_JPRB, 0.62233283E-07_JPRB, 0.60285721E-07_JPRB, 0.58718875E-07_JPRB, &
  & 0.57621293E-07_JPRB, 0.56830196E-07_JPRB, 0.56179328E-07_JPRB, 0.55311695E-07_JPRB /)

RGHG2(:,10, 4) = (/ &
  & 0.40817920E-07_JPRB, 0.48884786E-07_JPRB, 0.54513141E-07_JPRB, 0.60039852E-07_JPRB, 0.66175041E-07_JPRB, 0.73064406E-07_JPRB, &
  & 0.80832550E-07_JPRB, 0.89469737E-07_JPRB, 0.98901062E-07_JPRB, 0.10900087E-06_JPRB, 0.11956509E-06_JPRB, 0.13023754E-06_JPRB, &
  & 0.14059763E-06_JPRB, 0.15030137E-06_JPRB, 0.15917136E-06_JPRB, 0.16720192E-06_JPRB, 0.17449824E-06_JPRB, 0.18131009E-06_JPRB, &
  & 0.18805038E-06_JPRB, 0.19510182E-06_JPRB, 0.20275823E-06_JPRB, 0.21119416E-06_JPRB, 0.22035938E-06_JPRB, 0.22993417E-06_JPRB, &
  & 0.23942647E-06_JPRB, 0.24837112E-06_JPRB, 0.25673830E-06_JPRB, 0.26393386E-06_JPRB, 0.26942575E-06_JPRB, 0.27273495E-06_JPRB, &
  & 0.27342634E-06_JPRB, 0.27118983E-06_JPRB, 0.26608237E-06_JPRB, 0.25829115E-06_JPRB, 0.24817680E-06_JPRB, 0.23650313E-06_JPRB, &
  & 0.22379602E-06_JPRB, 0.21085971E-06_JPRB, 0.19843750E-06_JPRB, 0.18664703E-06_JPRB, 0.17502907E-06_JPRB, 0.16335272E-06_JPRB, &
  & 0.15193579E-06_JPRB, 0.14130742E-06_JPRB, 0.13175071E-06_JPRB, 0.12330821E-06_JPRB, 0.11582318E-06_JPRB, 0.10914976E-06_JPRB, &
  & 0.10329410E-06_JPRB, 0.98113354E-07_JPRB, 0.93389851E-07_JPRB, 0.89061210E-07_JPRB, 0.85119822E-07_JPRB, 0.81561708E-07_JPRB, &
  & 0.78370675E-07_JPRB, 0.75536448E-07_JPRB, 0.73061749E-07_JPRB, 0.70954528E-07_JPRB, 0.69220732E-07_JPRB, 0.67858792E-07_JPRB, &
  & 0.66949838E-07_JPRB, 0.66331985E-07_JPRB, 0.65842457E-07_JPRB, 0.65201441E-07_JPRB /)

RGHG2(:,11, 4) = (/ &
  & 0.54861843E-07_JPRB, 0.67936924E-07_JPRB, 0.76852558E-07_JPRB, 0.85905839E-07_JPRB, 0.95711840E-07_JPRB, 0.10679186E-06_JPRB, &
  & 0.11927072E-06_JPRB, 0.13318788E-06_JPRB, 0.14845202E-06_JPRB, 0.16489508E-06_JPRB, 0.18231779E-06_JPRB, 0.20030073E-06_JPRB, &
  & 0.21821927E-06_JPRB, 0.23541230E-06_JPRB, 0.25146338E-06_JPRB, 0.26611974E-06_JPRB, 0.27922005E-06_JPRB, 0.29068704E-06_JPRB, &
  & 0.30031947E-06_JPRB, 0.30825052E-06_JPRB, 0.31461283E-06_JPRB, 0.31958140E-06_JPRB, 0.32343755E-06_JPRB, 0.32625931E-06_JPRB, &
  & 0.32815925E-06_JPRB, 0.32931396E-06_JPRB, 0.32997286E-06_JPRB, 0.33037716E-06_JPRB, 0.33039564E-06_JPRB, 0.32938564E-06_JPRB, &
  & 0.32661396E-06_JPRB, 0.32171781E-06_JPRB, 0.31430628E-06_JPRB, 0.30427714E-06_JPRB, 0.29227530E-06_JPRB, 0.27871837E-06_JPRB, &
  & 0.26426414E-06_JPRB, 0.24945234E-06_JPRB, 0.23463065E-06_JPRB, 0.22007055E-06_JPRB, 0.20603426E-06_JPRB, 0.19263163E-06_JPRB, &
  & 0.17971767E-06_JPRB, 0.16724317E-06_JPRB, 0.15550410E-06_JPRB, 0.14480197E-06_JPRB, 0.13529605E-06_JPRB, 0.12696131E-06_JPRB, &
  & 0.11955106E-06_JPRB, 0.11289922E-06_JPRB, 0.10694303E-06_JPRB, 0.10163651E-06_JPRB, 0.96932709E-07_JPRB, 0.92801130E-07_JPRB, &
  & 0.89225104E-07_JPRB, 0.86188791E-07_JPRB, 0.83650612E-07_JPRB, 0.81572509E-07_JPRB, 0.79917186E-07_JPRB, 0.78645186E-07_JPRB, &
  & 0.77813333E-07_JPRB, 0.77245204E-07_JPRB, 0.76813208E-07_JPRB, 0.76265579E-07_JPRB /)

RGHG2(:,12, 4) = (/ &
  & 0.79360625E-07_JPRB, 0.99350615E-07_JPRB, 0.11315348E-06_JPRB, 0.12627791E-06_JPRB, 0.14062817E-06_JPRB, 0.15651203E-06_JPRB, &
  & 0.17430858E-06_JPRB, 0.19402331E-06_JPRB, 0.21557727E-06_JPRB, 0.23883211E-06_JPRB, 0.26341621E-06_JPRB, 0.28886060E-06_JPRB, &
  & 0.31455110E-06_JPRB, 0.33975232E-06_JPRB, 0.36354240E-06_JPRB, 0.38547034E-06_JPRB, 0.40501362E-06_JPRB, 0.42167540E-06_JPRB, &
  & 0.43489541E-06_JPRB, 0.44453924E-06_JPRB, 0.45039749E-06_JPRB, 0.45263840E-06_JPRB, 0.45162486E-06_JPRB, 0.44789957E-06_JPRB, &
  & 0.44216833E-06_JPRB, 0.43533205E-06_JPRB, 0.42802827E-06_JPRB, 0.42071596E-06_JPRB, 0.41367883E-06_JPRB, 0.40707371E-06_JPRB, &
  & 0.40017545E-06_JPRB, 0.39200256E-06_JPRB, 0.38234603E-06_JPRB, 0.37073349E-06_JPRB, 0.35706182E-06_JPRB, 0.34177503E-06_JPRB, &
  & 0.32530505E-06_JPRB, 0.30831384E-06_JPRB, 0.29124240E-06_JPRB, 0.27459711E-06_JPRB, 0.25849664E-06_JPRB, 0.24287866E-06_JPRB, &
  & 0.22772083E-06_JPRB, 0.21292220E-06_JPRB, 0.19855131E-06_JPRB, 0.18481174E-06_JPRB, 0.17191120E-06_JPRB, 0.15995577E-06_JPRB, &
  & 0.14912690E-06_JPRB, 0.13943475E-06_JPRB, 0.13082432E-06_JPRB, 0.12323405E-06_JPRB, 0.11658214E-06_JPRB, 0.11079929E-06_JPRB, &
  & 0.10584586E-06_JPRB, 0.10170474E-06_JPRB, 0.98331071E-07_JPRB, 0.95642903E-07_JPRB, 0.93543285E-07_JPRB, 0.91948628E-07_JPRB, &
  & 0.90849085E-07_JPRB, 0.90083489E-07_JPRB, 0.89480118E-07_JPRB, 0.88813998E-07_JPRB /)

RGHG2(:,13, 4) = (/ &
  & 0.11850327E-06_JPRB, 0.14789998E-06_JPRB, 0.16654812E-06_JPRB, 0.18446498E-06_JPRB, 0.20314248E-06_JPRB, 0.22363216E-06_JPRB, &
  & 0.24620124E-06_JPRB, 0.27096928E-06_JPRB, 0.29784491E-06_JPRB, 0.32658713E-06_JPRB, 0.35693591E-06_JPRB, 0.38829180E-06_JPRB, &
  & 0.41987212E-06_JPRB, 0.45101268E-06_JPRB, 0.48065340E-06_JPRB, 0.50797661E-06_JPRB, 0.53218537E-06_JPRB, 0.55270789E-06_JPRB, &
  & 0.56881203E-06_JPRB, 0.58010721E-06_JPRB, 0.58631554E-06_JPRB, 0.58757951E-06_JPRB, 0.58435683E-06_JPRB, 0.57728494E-06_JPRB, &
  & 0.56715515E-06_JPRB, 0.55507132E-06_JPRB, 0.54203144E-06_JPRB, 0.52888402E-06_JPRB, 0.51611516E-06_JPRB, 0.50394209E-06_JPRB, &
  & 0.49239122E-06_JPRB, 0.48066784E-06_JPRB, 0.46819366E-06_JPRB, 0.45556692E-06_JPRB, 0.44158404E-06_JPRB, 0.42580555E-06_JPRB, &
  & 0.40934401E-06_JPRB, 0.39264330E-06_JPRB, 0.37590490E-06_JPRB, 0.35960608E-06_JPRB, 0.34351294E-06_JPRB, 0.32704949E-06_JPRB, &
  & 0.31012291E-06_JPRB, 0.29245882E-06_JPRB, 0.27420728E-06_JPRB, 0.25579533E-06_JPRB, 0.23768628E-06_JPRB, 0.22055025E-06_JPRB, &
  & 0.20468221E-06_JPRB, 0.19026095E-06_JPRB, 0.17726384E-06_JPRB, 0.16560155E-06_JPRB, 0.15516338E-06_JPRB, 0.14589776E-06_JPRB, &
  & 0.13777930E-06_JPRB, 0.13080492E-06_JPRB, 0.12494617E-06_JPRB, 0.12016262E-06_JPRB, 0.11637242E-06_JPRB, 0.11344883E-06_JPRB, &
  & 0.11135077E-06_JPRB, 0.10979545E-06_JPRB, 0.10861179E-06_JPRB, 0.10738115E-06_JPRB /)

RGHG2(:,14, 4) = (/ &
  & 0.17787174E-06_JPRB, 0.21645273E-06_JPRB, 0.24072065E-06_JPRB, 0.26229071E-06_JPRB, 0.28457725E-06_JPRB, 0.30830100E-06_JPRB, &
  & 0.33402381E-06_JPRB, 0.36197454E-06_JPRB, 0.39212679E-06_JPRB, 0.42431626E-06_JPRB, 0.45800280E-06_JPRB, 0.49248894E-06_JPRB, &
  & 0.52695151E-06_JPRB, 0.56065522E-06_JPRB, 0.59292569E-06_JPRB, 0.62281225E-06_JPRB, 0.64943015E-06_JPRB, 0.67207003E-06_JPRB, &
  & 0.69019984E-06_JPRB, 0.70322983E-06_JPRB, 0.71077221E-06_JPRB, 0.71287724E-06_JPRB, 0.70992820E-06_JPRB, 0.70253139E-06_JPRB, &
  & 0.69161246E-06_JPRB, 0.67820758E-06_JPRB, 0.66318898E-06_JPRB, 0.64734047E-06_JPRB, 0.63136957E-06_JPRB, 0.61545785E-06_JPRB, &
  & 0.59960814E-06_JPRB, 0.58393783E-06_JPRB, 0.56802287E-06_JPRB, 0.55182682E-06_JPRB, 0.53702740E-06_JPRB, 0.52372059E-06_JPRB, &
  & 0.51125664E-06_JPRB, 0.49967673E-06_JPRB, 0.48831708E-06_JPRB, 0.47640327E-06_JPRB, 0.46332070E-06_JPRB, 0.44846931E-06_JPRB, &
  & 0.43152374E-06_JPRB, 0.41212255E-06_JPRB, 0.39038187E-06_JPRB, 0.36706157E-06_JPRB, 0.34332729E-06_JPRB, 0.32017735E-06_JPRB, &
  & 0.29843943E-06_JPRB, 0.27838996E-06_JPRB, 0.25997520E-06_JPRB, 0.24302034E-06_JPRB, 0.22738510E-06_JPRB, 0.21302665E-06_JPRB, &
  & 0.19997998E-06_JPRB, 0.18833052E-06_JPRB, 0.17816014E-06_JPRB, 0.16952032E-06_JPRB, 0.16244138E-06_JPRB, 0.15683456E-06_JPRB, &
  & 0.15261938E-06_JPRB, 0.14951455E-06_JPRB, 0.14710852E-06_JPRB, 0.14504687E-06_JPRB /)

RGHG2(:,15, 4) = (/ &
  & 0.25967003E-06_JPRB, 0.30644713E-06_JPRB, 0.33379479E-06_JPRB, 0.35782912E-06_JPRB, 0.38163654E-06_JPRB, 0.40661769E-06_JPRB, &
  & 0.43339244E-06_JPRB, 0.46226708E-06_JPRB, 0.49333124E-06_JPRB, 0.52640502E-06_JPRB, 0.56107888E-06_JPRB, 0.59642207E-06_JPRB, &
  & 0.63134064E-06_JPRB, 0.66508244E-06_JPRB, 0.69713258E-06_JPRB, 0.72716074E-06_JPRB, 0.75437777E-06_JPRB, 0.77800649E-06_JPRB, &
  & 0.79744558E-06_JPRB, 0.81215615E-06_JPRB, 0.82168424E-06_JPRB, 0.82584575E-06_JPRB, 0.82492699E-06_JPRB, 0.81962480E-06_JPRB, &
  & 0.81067617E-06_JPRB, 0.79901685E-06_JPRB, 0.78533020E-06_JPRB, 0.76989909E-06_JPRB, 0.75313949E-06_JPRB, 0.73550257E-06_JPRB, &
  & 0.71699759E-06_JPRB, 0.69809226E-06_JPRB, 0.67978499E-06_JPRB, 0.66284883E-06_JPRB, 0.64802799E-06_JPRB, 0.63629494E-06_JPRB, &
  & 0.62796414E-06_JPRB, 0.62185131E-06_JPRB, 0.61678634E-06_JPRB, 0.61124001E-06_JPRB, 0.60370667E-06_JPRB, 0.59290784E-06_JPRB, &
  & 0.57803777E-06_JPRB, 0.55861665E-06_JPRB, 0.53510621E-06_JPRB, 0.50866032E-06_JPRB, 0.48083609E-06_JPRB, 0.45322770E-06_JPRB, &
  & 0.42683308E-06_JPRB, 0.40208940E-06_JPRB, 0.37893233E-06_JPRB, 0.35715345E-06_JPRB, 0.33652424E-06_JPRB, 0.31697434E-06_JPRB, &
  & 0.29860411E-06_JPRB, 0.28166471E-06_JPRB, 0.26640072E-06_JPRB, 0.25309404E-06_JPRB, 0.24188336E-06_JPRB, 0.23285364E-06_JPRB, &
  & 0.22600969E-06_JPRB, 0.22090727E-06_JPRB, 0.21726051E-06_JPRB, 0.21452466E-06_JPRB /)

RGHG2(:,16, 4) = (/ &
  & 0.36055749E-06_JPRB, 0.41069902E-06_JPRB, 0.43899132E-06_JPRB, 0.46304973E-06_JPRB, 0.48666811E-06_JPRB, 0.51118826E-06_JPRB, &
  & 0.53737176E-06_JPRB, 0.56561083E-06_JPRB, 0.59598182E-06_JPRB, 0.62825183E-06_JPRB, 0.66195463E-06_JPRB, 0.69627112E-06_JPRB, &
  & 0.73031651E-06_JPRB, 0.76304792E-06_JPRB, 0.79394187E-06_JPRB, 0.82280536E-06_JPRB, 0.84953967E-06_JPRB, 0.87350770E-06_JPRB, &
  & 0.89400777E-06_JPRB, 0.91041397E-06_JPRB, 0.92222825E-06_JPRB, 0.92911972E-06_JPRB, 0.93136697E-06_JPRB, 0.92949352E-06_JPRB, &
  & 0.92422772E-06_JPRB, 0.91617738E-06_JPRB, 0.90576202E-06_JPRB, 0.89301568E-06_JPRB, 0.87771321E-06_JPRB, 0.86027217E-06_JPRB, &
  & 0.84089640E-06_JPRB, 0.82014759E-06_JPRB, 0.79978810E-06_JPRB, 0.78167830E-06_JPRB, 0.76718283E-06_JPRB, 0.75735636E-06_JPRB, &
  & 0.75244901E-06_JPRB, 0.75155953E-06_JPRB, 0.75262773E-06_JPRB, 0.75316325E-06_JPRB, 0.75081329E-06_JPRB, 0.74404920E-06_JPRB, &
  & 0.73177421E-06_JPRB, 0.71364042E-06_JPRB, 0.69016261E-06_JPRB, 0.66268012E-06_JPRB, 0.63307647E-06_JPRB, 0.60304097E-06_JPRB, &
  & 0.57391713E-06_JPRB, 0.54622171E-06_JPRB, 0.51991810E-06_JPRB, 0.49475091E-06_JPRB, 0.47043818E-06_JPRB, 0.44689889E-06_JPRB, &
  & 0.42429303E-06_JPRB, 0.40299483E-06_JPRB, 0.38348469E-06_JPRB, 0.36614708E-06_JPRB, 0.35142710E-06_JPRB, 0.33946156E-06_JPRB, &
  & 0.33042744E-06_JPRB, 0.32395383E-06_JPRB, 0.31955537E-06_JPRB, 0.31751628E-06_JPRB /)

RGHG2(:,17, 4) = (/ &
  & 0.47057318E-06_JPRB, 0.51999473E-06_JPRB, 0.54700121E-06_JPRB, 0.56996464E-06_JPRB, 0.59233986E-06_JPRB, 0.61563588E-06_JPRB, &
  & 0.64063789E-06_JPRB, 0.66772128E-06_JPRB, 0.69694499E-06_JPRB, 0.72808660E-06_JPRB, 0.76041397E-06_JPRB, 0.79305698E-06_JPRB, &
  & 0.82517630E-06_JPRB, 0.85619945E-06_JPRB, 0.88558892E-06_JPRB, 0.91307049E-06_JPRB, 0.93868152E-06_JPRB, 0.96233748E-06_JPRB, &
  & 0.98341638E-06_JPRB, 0.10012739E-05_JPRB, 0.10151823E-05_JPRB, 0.10250448E-05_JPRB, 0.10307285E-05_JPRB, 0.10327755E-05_JPRB, &
  & 0.10319607E-05_JPRB, 0.10281608E-05_JPRB, 0.10220605E-05_JPRB, 0.10132841E-05_JPRB, 0.10013255E-05_JPRB, 0.98595945E-06_JPRB, &
  & 0.96777205E-06_JPRB, 0.94740949E-06_JPRB, 0.92671002E-06_JPRB, 0.90796198E-06_JPRB, 0.89339619E-06_JPRB, 0.88458609E-06_JPRB, &
  & 0.88192962E-06_JPRB, 0.88415618E-06_JPRB, 0.88890727E-06_JPRB, 0.89337487E-06_JPRB, 0.89459940E-06_JPRB, 0.89071250E-06_JPRB, &
  & 0.88051797E-06_JPRB, 0.86370261E-06_JPRB, 0.84091317E-06_JPRB, 0.81360042E-06_JPRB, 0.78359540E-06_JPRB, 0.75293156E-06_JPRB, &
  & 0.72280540E-06_JPRB, 0.69369190E-06_JPRB, 0.66569726E-06_JPRB, 0.63863331E-06_JPRB, 0.61223426E-06_JPRB, 0.58641149E-06_JPRB, &
  & 0.56133996E-06_JPRB, 0.53749397E-06_JPRB, 0.51541895E-06_JPRB, 0.49573845E-06_JPRB, 0.47892212E-06_JPRB, 0.46537764E-06_JPRB, &
  & 0.45533443E-06_JPRB, 0.44842196E-06_JPRB, 0.44431732E-06_JPRB, 0.44393488E-06_JPRB /)

RGHG2(:,18, 4) = (/ &
  & 0.58113363E-06_JPRB, 0.62738309E-06_JPRB, 0.65296905E-06_JPRB, 0.67444728E-06_JPRB, 0.69559889E-06_JPRB, 0.71773081E-06_JPRB, &
  & 0.74161341E-06_JPRB, 0.76766094E-06_JPRB, 0.79582833E-06_JPRB, 0.82575701E-06_JPRB, 0.85673872E-06_JPRB, 0.88776028E-06_JPRB, &
  & 0.91798790E-06_JPRB, 0.94682866E-06_JPRB, 0.97421480E-06_JPRB, 0.10000119E-05_JPRB, 0.10241741E-05_JPRB, 0.10467759E-05_JPRB, &
  & 0.10676413E-05_JPRB, 0.10861133E-05_JPRB, 0.11016261E-05_JPRB, 0.11137422E-05_JPRB, 0.11223943E-05_JPRB, 0.11280540E-05_JPRB, &
  & 0.11308972E-05_JPRB, 0.11315121E-05_JPRB, 0.11299443E-05_JPRB, 0.11258342E-05_JPRB, 0.11183200E-05_JPRB, 0.11072264E-05_JPRB, &
  & 0.10924214E-05_JPRB, 0.10749601E-05_JPRB, 0.10566157E-05_JPRB, 0.10396096E-05_JPRB, 0.10261532E-05_JPRB, 0.10181124E-05_JPRB, &
  & 0.10161177E-05_JPRB, 0.10191277E-05_JPRB, 0.10245653E-05_JPRB, 0.10295058E-05_JPRB, 0.10312818E-05_JPRB, 0.10276897E-05_JPRB, &
  & 0.10176261E-05_JPRB, 0.10009015E-05_JPRB, 0.97824557E-06_JPRB, 0.95105054E-06_JPRB, 0.92131938E-06_JPRB, 0.89072989E-06_JPRB, &
  & 0.86042326E-06_JPRB, 0.83087389E-06_JPRB, 0.80232826E-06_JPRB, 0.77473743E-06_JPRB, 0.74785606E-06_JPRB, 0.72159628E-06_JPRB, &
  & 0.69609581E-06_JPRB, 0.67177700E-06_JPRB, 0.64920266E-06_JPRB, 0.62898044E-06_JPRB, 0.61178520E-06_JPRB, 0.59803995E-06_JPRB, &
  & 0.58814510E-06_JPRB, 0.58165131E-06_JPRB, 0.57840418E-06_JPRB, 0.57983181E-06_JPRB /)

RGHG2(:,19, 4) = (/ &
  & 0.68678690E-06_JPRB, 0.73043282E-06_JPRB, 0.75411901E-06_JPRB, 0.77465324E-06_JPRB, 0.79469191E-06_JPRB, 0.81585750E-06_JPRB, &
  & 0.83881019E-06_JPRB, 0.86384404E-06_JPRB, 0.89095204E-06_JPRB, 0.91979012E-06_JPRB, 0.94944158E-06_JPRB, 0.97910186E-06_JPRB, &
  & 0.10077856E-05_JPRB, 0.10348897E-05_JPRB, 0.10603019E-05_JPRB, 0.10841861E-05_JPRB, 0.11066776E-05_JPRB, 0.11278337E-05_JPRB, &
  & 0.11476823E-05_JPRB, 0.11659216E-05_JPRB, 0.11820205E-05_JPRB, 0.11954000E-05_JPRB, 0.12064289E-05_JPRB, 0.12144887E-05_JPRB, &
  & 0.12206118E-05_JPRB, 0.12247458E-05_JPRB, 0.12268326E-05_JPRB, 0.12267378E-05_JPRB, 0.12238997E-05_JPRB, 0.12179465E-05_JPRB, &
  & 0.12087266E-05_JPRB, 0.11968403E-05_JPRB, 0.11834611E-05_JPRB, 0.11705356E-05_JPRB, 0.11600926E-05_JPRB, 0.11534631E-05_JPRB, &
  & 0.11515724E-05_JPRB, 0.11532995E-05_JPRB, 0.11564561E-05_JPRB, 0.11587263E-05_JPRB, 0.11578348E-05_JPRB, 0.11519749E-05_JPRB, &
  & 0.11401384E-05_JPRB, 0.11221844E-05_JPRB, 0.10987551E-05_JPRB, 0.10713341E-05_JPRB, 0.10415796E-05_JPRB, 0.10111230E-05_JPRB, &
  & 0.98100656E-06_JPRB, 0.95193741E-06_JPRB, 0.92402360E-06_JPRB, 0.89709368E-06_JPRB, 0.87102342E-06_JPRB, 0.84580034E-06_JPRB, &
  & 0.82149910E-06_JPRB, 0.79840606E-06_JPRB, 0.77694199E-06_JPRB, 0.75769879E-06_JPRB, 0.74133027E-06_JPRB, 0.72838026E-06_JPRB, &
  & 0.71916452E-06_JPRB, 0.71349473E-06_JPRB, 0.71097367E-06_JPRB, 0.71374501E-06_JPRB /)

RGHG2(:,20, 4) = (/ &
  & 0.78594445E-06_JPRB, 0.82598535E-06_JPRB, 0.84887859E-06_JPRB, 0.86814896E-06_JPRB, 0.88753302E-06_JPRB, 0.90797226E-06_JPRB, &
  & 0.93022243E-06_JPRB, 0.95452322E-06_JPRB, 0.98084115E-06_JPRB, 0.10087325E-05_JPRB, 0.10373159E-05_JPRB, 0.10656518E-05_JPRB, &
  & 0.10929401E-05_JPRB, 0.11185487E-05_JPRB, 0.11423241E-05_JPRB, 0.11644015E-05_JPRB, 0.11850973E-05_JPRB, 0.12046130E-05_JPRB, &
  & 0.12230220E-05_JPRB, 0.12402289E-05_JPRB, 0.12559119E-05_JPRB, 0.12697642E-05_JPRB, 0.12813584E-05_JPRB, 0.12912127E-05_JPRB, &
  & 0.12990783E-05_JPRB, 0.13052990E-05_JPRB, 0.13100844E-05_JPRB, 0.13131861E-05_JPRB, 0.13145479E-05_JPRB, 0.13136565E-05_JPRB, &
  & 0.13105675E-05_JPRB, 0.13052857E-05_JPRB, 0.12985123E-05_JPRB, 0.12912947E-05_JPRB, 0.12850106E-05_JPRB, 0.12806374E-05_JPRB, &
  & 0.12783864E-05_JPRB, 0.12775399E-05_JPRB, 0.12772094E-05_JPRB, 0.12752446E-05_JPRB, 0.12700185E-05_JPRB, 0.12602727E-05_JPRB, &
  & 0.12453631E-05_JPRB, 0.12252131E-05_JPRB, 0.12005612E-05_JPRB, 0.11726171E-05_JPRB, 0.11431263E-05_JPRB, 0.11134410E-05_JPRB, &
  & 0.10845196E-05_JPRB, 0.10567437E-05_JPRB, 0.10300416E-05_JPRB, 0.10043681E-05_JPRB, 0.97980160E-06_JPRB, 0.95637665E-06_JPRB, &
  & 0.93412871E-06_JPRB, 0.91318390E-06_JPRB, 0.89375760E-06_JPRB, 0.87628433E-06_JPRB, 0.86133184E-06_JPRB, 0.84943025E-06_JPRB, &
  & 0.84105676E-06_JPRB, 0.83576731E-06_JPRB, 0.83362954E-06_JPRB, 0.83607972E-06_JPRB /)

RGHG2(:,21, 4) = (/ &
  & 0.87542492E-06_JPRB, 0.91389694E-06_JPRB, 0.93502882E-06_JPRB, 0.95384178E-06_JPRB, 0.97240138E-06_JPRB, 0.99229123E-06_JPRB, &
  & 0.10140122E-05_JPRB, 0.10376717E-05_JPRB, 0.10631952E-05_JPRB, 0.10901990E-05_JPRB, 0.11176945E-05_JPRB, 0.11448793E-05_JPRB, &
  & 0.11708819E-05_JPRB, 0.11952047E-05_JPRB, 0.12176303E-05_JPRB, 0.12382717E-05_JPRB, 0.12574205E-05_JPRB, 0.12753715E-05_JPRB, &
  & 0.12922973E-05_JPRB, 0.13082217E-05_JPRB, 0.13229862E-05_JPRB, 0.13362842E-05_JPRB, 0.13480405E-05_JPRB, 0.13580440E-05_JPRB, &
  & 0.13664417E-05_JPRB, 0.13736661E-05_JPRB, 0.13799163E-05_JPRB, 0.13853353E-05_JPRB, 0.13898704E-05_JPRB, 0.13932113E-05_JPRB, &
  & 0.13952849E-05_JPRB, 0.13957405E-05_JPRB, 0.13949235E-05_JPRB, 0.13929841E-05_JPRB, 0.13906006E-05_JPRB, 0.13880917E-05_JPRB, &
  & 0.13857976E-05_JPRB, 0.13830806E-05_JPRB, 0.13792287E-05_JPRB, 0.13730129E-05_JPRB, 0.13634788E-05_JPRB, 0.13498690E-05_JPRB, &
  & 0.13319267E-05_JPRB, 0.13098000E-05_JPRB, 0.12841665E-05_JPRB, 0.12563501E-05_JPRB, 0.12277268E-05_JPRB, 0.11994885E-05_JPRB, &
  & 0.11721264E-05_JPRB, 0.11457472E-05_JPRB, 0.11204356E-05_JPRB, 0.10963879E-05_JPRB, 0.10737194E-05_JPRB, 0.10524773E-05_JPRB, &
  & 0.10326119E-05_JPRB, 0.10140883E-05_JPRB, 0.99694489E-06_JPRB, 0.98140811E-06_JPRB, 0.96794008E-06_JPRB, 0.95703638E-06_JPRB, &
  & 0.94905033E-06_JPRB, 0.94397757E-06_JPRB, 0.94135908E-06_JPRB, 0.94287213E-06_JPRB /)

RGHG2(:,22, 4) = (/ &
  & 0.95560790E-06_JPRB, 0.99123622E-06_JPRB, 0.10121068E-05_JPRB, 0.10299491E-05_JPRB, 0.10480917E-05_JPRB, 0.10673888E-05_JPRB, &
  & 0.10884844E-05_JPRB, 0.11114541E-05_JPRB, 0.11361233E-05_JPRB, 0.11620780E-05_JPRB, 0.11885418E-05_JPRB, 0.12145946E-05_JPRB, &
  & 0.12395348E-05_JPRB, 0.12627919E-05_JPRB, 0.12841983E-05_JPRB, 0.13037780E-05_JPRB, 0.13217937E-05_JPRB, 0.13385550E-05_JPRB, &
  & 0.13542571E-05_JPRB, 0.13690086E-05_JPRB, 0.13827403E-05_JPRB, 0.13953240E-05_JPRB, 0.14064835E-05_JPRB, 0.14162024E-05_JPRB, &
  & 0.14245933E-05_JPRB, 0.14319775E-05_JPRB, 0.14387437E-05_JPRB, 0.14452432E-05_JPRB, 0.14516305E-05_JPRB, 0.14577000E-05_JPRB, &
  & 0.14632249E-05_JPRB, 0.14677101E-05_JPRB, 0.14709743E-05_JPRB, 0.14727268E-05_JPRB, 0.14730878E-05_JPRB, 0.14719460E-05_JPRB, &
  & 0.14693996E-05_JPRB, 0.14650283E-05_JPRB, 0.14584344E-05_JPRB, 0.14490058E-05_JPRB, 0.14362870E-05_JPRB, 0.14199729E-05_JPRB, &
  & 0.14001148E-05_JPRB, 0.13770305E-05_JPRB, 0.13514808E-05_JPRB, 0.13244789E-05_JPRB, 0.12971906E-05_JPRB, 0.12704396E-05_JPRB, &
  & 0.12446607E-05_JPRB, 0.12200103E-05_JPRB, 0.11965378E-05_JPRB, 0.11744590E-05_JPRB, 0.11539300E-05_JPRB, 0.11349588E-05_JPRB, &
  & 0.11174243E-05_JPRB, 0.11011739E-05_JPRB, 0.10861112E-05_JPRB, 0.10723190E-05_JPRB, 0.10600991E-05_JPRB, 0.10498907E-05_JPRB, &
  & 0.10421932E-05_JPRB, 0.10367468E-05_JPRB, 0.10335516E-05_JPRB, 0.10327159E-05_JPRB /)

RGHG2(:,23, 4) = (/ &
  & 0.10253526E-05_JPRB, 0.10594974E-05_JPRB, 0.10789727E-05_JPRB, 0.10964875E-05_JPRB, 0.11140149E-05_JPRB, 0.11327588E-05_JPRB, &
  & 0.11531775E-05_JPRB, 0.11753251E-05_JPRB, 0.11989983E-05_JPRB, 0.12238464E-05_JPRB, 0.12491367E-05_JPRB, 0.12741306E-05_JPRB, &
  & 0.12981230E-05_JPRB, 0.13205648E-05_JPRB, 0.13412005E-05_JPRB, 0.13600693E-05_JPRB, 0.13773372E-05_JPRB, 0.13932918E-05_JPRB, &
  & 0.14081560E-05_JPRB, 0.14220366E-05_JPRB, 0.14349442E-05_JPRB, 0.14467680E-05_JPRB, 0.14573328E-05_JPRB, 0.14665846E-05_JPRB, &
  & 0.14746494E-05_JPRB, 0.14818606E-05_JPRB, 0.14886707E-05_JPRB, 0.14954013E-05_JPRB, 0.15024345E-05_JPRB, 0.15098107E-05_JPRB, &
  & 0.15169986E-05_JPRB, 0.15235870E-05_JPRB, 0.15288697E-05_JPRB, 0.15324647E-05_JPRB, 0.15340338E-05_JPRB, 0.15333302E-05_JPRB, &
  & 0.15302796E-05_JPRB, 0.15246230E-05_JPRB, 0.15162329E-05_JPRB, 0.15048507E-05_JPRB, 0.14903898E-05_JPRB, 0.14727699E-05_JPRB, &
  & 0.14523475E-05_JPRB, 0.14294932E-05_JPRB, 0.14048692E-05_JPRB, 0.13793016E-05_JPRB, 0.13537740E-05_JPRB, 0.13290311E-05_JPRB, &
  & 0.13053331E-05_JPRB, 0.12826399E-05_JPRB, 0.12611500E-05_JPRB, 0.12411192E-05_JPRB, 0.12226562E-05_JPRB, 0.12057335E-05_JPRB, &
  & 0.11901723E-05_JPRB, 0.11757662E-05_JPRB, 0.11623446E-05_JPRB, 0.11498811E-05_JPRB, 0.11386040E-05_JPRB, 0.11288967E-05_JPRB, &
  & 0.11211539E-05_JPRB, 0.11154461E-05_JPRB, 0.11112390E-05_JPRB, 0.11083978E-05_JPRB /)

RGHG2(:,24, 4) = (/ &
  & 0.10863542E-05_JPRB, 0.11185925E-05_JPRB, 0.11373172E-05_JPRB, 0.11539545E-05_JPRB, 0.11708946E-05_JPRB, 0.11889658E-05_JPRB, &
  & 0.12085911E-05_JPRB, 0.12297990E-05_JPRB, 0.12523884E-05_JPRB, 0.12760115E-05_JPRB, 0.13001412E-05_JPRB, 0.13240917E-05_JPRB, &
  & 0.13472062E-05_JPRB, 0.13689656E-05_JPRB, 0.13890619E-05_JPRB, 0.14074640E-05_JPRB, 0.14243069E-05_JPRB, 0.14398222E-05_JPRB, &
  & 0.14541678E-05_JPRB, 0.14674863E-05_JPRB, 0.14798159E-05_JPRB, 0.14910435E-05_JPRB, 0.15010916E-05_JPRB, 0.15098747E-05_JPRB, &
  & 0.15175681E-05_JPRB, 0.15244483E-05_JPRB, 0.15309770E-05_JPRB, 0.15375966E-05_JPRB, 0.15446630E-05_JPRB, 0.15521516E-05_JPRB, &
  & 0.15597163E-05_JPRB, 0.15668577E-05_JPRB, 0.15727030E-05_JPRB, 0.15767192E-05_JPRB, 0.15784073E-05_JPRB, 0.15774468E-05_JPRB, &
  & 0.15736990E-05_JPRB, 0.15670997E-05_JPRB, 0.15576480E-05_JPRB, 0.15453043E-05_JPRB, 0.15301766E-05_JPRB, 0.15124423E-05_JPRB, &
  & 0.14925165E-05_JPRB, 0.14707938E-05_JPRB, 0.14478476E-05_JPRB, 0.14243766E-05_JPRB, 0.14011416E-05_JPRB, 0.13786141E-05_JPRB, &
  & 0.13569064E-05_JPRB, 0.13362394E-05_JPRB, 0.13168075E-05_JPRB, 0.12987275E-05_JPRB, 0.12821214E-05_JPRB, 0.12669112E-05_JPRB, &
  & 0.12529008E-05_JPRB, 0.12398650E-05_JPRB, 0.12276173E-05_JPRB, 0.12160966E-05_JPRB, 0.12054595E-05_JPRB, 0.11960494E-05_JPRB, &
  & 0.11883093E-05_JPRB, 0.11821708E-05_JPRB, 0.11773716E-05_JPRB, 0.11724834E-05_JPRB /)

RGHG2(:,25, 4) = (/ &
  & 0.11404859E-05_JPRB, 0.11703662E-05_JPRB, 0.11882727E-05_JPRB, 0.12040008E-05_JPRB, 0.12201144E-05_JPRB, 0.12373487E-05_JPRB, &
  & 0.12559947E-05_JPRB, 0.12761501E-05_JPRB, 0.12975348E-05_JPRB, 0.13198947E-05_JPRB, 0.13428381E-05_JPRB, 0.13657902E-05_JPRB, &
  & 0.13881622E-05_JPRB, 0.14093680E-05_JPRB, 0.14290829E-05_JPRB, 0.14472014E-05_JPRB, 0.14637928E-05_JPRB, 0.14790384E-05_JPRB, &
  & 0.14930853E-05_JPRB, 0.15060680E-05_JPRB, 0.15180080E-05_JPRB, 0.15288274E-05_JPRB, 0.15384633E-05_JPRB, 0.15468671E-05_JPRB, &
  & 0.15541992E-05_JPRB, 0.15607131E-05_JPRB, 0.15668570E-05_JPRB, 0.15731104E-05_JPRB, 0.15797273E-05_JPRB, 0.15868301E-05_JPRB, &
  & 0.15940540E-05_JPRB, 0.16008357E-05_JPRB, 0.16063639E-05_JPRB, 0.16100066E-05_JPRB, 0.16112325E-05_JPRB, 0.16096997E-05_JPRB, &
  & 0.16052644E-05_JPRB, 0.15979344E-05_JPRB, 0.15879051E-05_JPRB, 0.15753365E-05_JPRB, 0.15604030E-05_JPRB, 0.15433354E-05_JPRB, &
  & 0.15246187E-05_JPRB, 0.15046082E-05_JPRB, 0.14837811E-05_JPRB, 0.14626313E-05_JPRB, 0.14416436E-05_JPRB, 0.14211920E-05_JPRB, &
  & 0.14016248E-05_JPRB, 0.13830468E-05_JPRB, 0.13654907E-05_JPRB, 0.13491850E-05_JPRB, 0.13341656E-05_JPRB, 0.13203288E-05_JPRB, &
  & 0.13074822E-05_JPRB, 0.12954179E-05_JPRB, 0.12839605E-05_JPRB, 0.12730462E-05_JPRB, 0.12628143E-05_JPRB, 0.12535852E-05_JPRB, &
  & 0.12457633E-05_JPRB, 0.12393899E-05_JPRB, 0.12339657E-05_JPRB, 0.12278578E-05_JPRB /)

RGHG2(:,26, 4) = (/ &
  & 0.11884039E-05_JPRB, 0.12168971E-05_JPRB, 0.12330319E-05_JPRB, 0.12480529E-05_JPRB, 0.12631285E-05_JPRB, 0.12793213E-05_JPRB, &
  & 0.12969507E-05_JPRB, 0.13158781E-05_JPRB, 0.13360254E-05_JPRB, 0.13571461E-05_JPRB, 0.13789000E-05_JPRB, 0.14008713E-05_JPRB, &
  & 0.14224540E-05_JPRB, 0.14431394E-05_JPRB, 0.14625255E-05_JPRB, 0.14804680E-05_JPRB, 0.14969735E-05_JPRB, 0.15121374E-05_JPRB, &
  & 0.15260646E-05_JPRB, 0.15388604E-05_JPRB, 0.15505399E-05_JPRB, 0.15610743E-05_JPRB, 0.15703976E-05_JPRB, 0.15785220E-05_JPRB, &
  & 0.15855524E-05_JPRB, 0.15917570E-05_JPRB, 0.15975463E-05_JPRB, 0.16032509E-05_JPRB, 0.16093268E-05_JPRB, 0.16157177E-05_JPRB, &
  & 0.16221600E-05_JPRB, 0.16281115E-05_JPRB, 0.16328753E-05_JPRB, 0.16357972E-05_JPRB, 0.16363348E-05_JPRB, 0.16341660E-05_JPRB, &
  & 0.16291715E-05_JPRB, 0.16215508E-05_JPRB, 0.16114739E-05_JPRB, 0.15991670E-05_JPRB, 0.15848980E-05_JPRB, 0.15690217E-05_JPRB, &
  & 0.15518890E-05_JPRB, 0.15338626E-05_JPRB, 0.15152307E-05_JPRB, 0.14963332E-05_JPRB, 0.14775013E-05_JPRB, 0.14592214E-05_JPRB, &
  & 0.14416402E-05_JPRB, 0.14248029E-05_JPRB, 0.14089384E-05_JPRB, 0.13941406E-05_JPRB, 0.13804038E-05_JPRB, 0.13676311E-05_JPRB, &
  & 0.13556331E-05_JPRB, 0.13442286E-05_JPRB, 0.13332697E-05_JPRB, 0.13227138E-05_JPRB, 0.13126980E-05_JPRB, 0.13035514E-05_JPRB, &
  & 0.12956697E-05_JPRB, 0.12890722E-05_JPRB, 0.12832206E-05_JPRB, 0.12759762E-05_JPRB /)

RGHG2(:,27, 4) = (/ &
  & 0.12325804E-05_JPRB, 0.12577785E-05_JPRB, 0.12734948E-05_JPRB, 0.12869998E-05_JPRB, 0.13011927E-05_JPRB, 0.13163557E-05_JPRB, &
  & 0.13327539E-05_JPRB, 0.13505344E-05_JPRB, 0.13693902E-05_JPRB, 0.13892317E-05_JPRB, 0.14098634E-05_JPRB, 0.14308562E-05_JPRB, &
  & 0.14517456E-05_JPRB, 0.14719396E-05_JPRB, 0.14910547E-05_JPRB, 0.15088536E-05_JPRB, 0.15252882E-05_JPRB, 0.15404023E-05_JPRB, &
  & 0.15542628E-05_JPRB, 0.15669306E-05_JPRB, 0.15784269E-05_JPRB, 0.15887372E-05_JPRB, 0.15978247E-05_JPRB, 0.16057297E-05_JPRB, &
  & 0.16125250E-05_JPRB, 0.16184828E-05_JPRB, 0.16239012E-05_JPRB, 0.16291735E-05_JPRB, 0.16345741E-05_JPRB, 0.16400675E-05_JPRB, &
  & 0.16455278E-05_JPRB, 0.16504869E-05_JPRB, 0.16543098E-05_JPRB, 0.16564117E-05_JPRB, 0.16562627E-05_JPRB, 0.16536053E-05_JPRB, &
  & 0.16483763E-05_JPRB, 0.16406595E-05_JPRB, 0.16308250E-05_JPRB, 0.16192545E-05_JPRB, 0.16061232E-05_JPRB, 0.15917216E-05_JPRB, &
  & 0.15764016E-05_JPRB, 0.15603888E-05_JPRB, 0.15439138E-05_JPRB, 0.15271005E-05_JPRB, 0.15103413E-05_JPRB, 0.14939158E-05_JPRB, &
  & 0.14779882E-05_JPRB, 0.14627669E-05_JPRB, 0.14483184E-05_JPRB, 0.14347294E-05_JPRB, 0.14220082E-05_JPRB, 0.14100282E-05_JPRB, &
  & 0.13986349E-05_JPRB, 0.13876619E-05_JPRB, 0.13769989E-05_JPRB, 0.13666239E-05_JPRB, 0.13567021E-05_JPRB, 0.13475757E-05_JPRB, &
  & 0.13396409E-05_JPRB, 0.13328904E-05_JPRB, 0.13268043E-05_JPRB, 0.13187047E-05_JPRB /)

RGHG2(:,28, 4) = (/ &
  & 0.12716639E-05_JPRB, 0.12958252E-05_JPRB, 0.13093398E-05_JPRB, 0.13223022E-05_JPRB, 0.13352760E-05_JPRB, 0.13493519E-05_JPRB, &
  & 0.13647417E-05_JPRB, 0.13812447E-05_JPRB, 0.13988928E-05_JPRB, 0.14175337E-05_JPRB, 0.14370003E-05_JPRB, 0.14570392E-05_JPRB, &
  & 0.14771500E-05_JPRB, 0.14968716E-05_JPRB, 0.15157475E-05_JPRB, 0.15334588E-05_JPRB, 0.15498467E-05_JPRB, 0.15649013E-05_JPRB, &
  & 0.15786879E-05_JPRB, 0.15912455E-05_JPRB, 0.16025788E-05_JPRB, 0.16126926E-05_JPRB, 0.16215727E-05_JPRB, 0.16292654E-05_JPRB, &
  & 0.16358531E-05_JPRB, 0.16415540E-05_JPRB, 0.16466139E-05_JPRB, 0.16514364E-05_JPRB, 0.16561219E-05_JPRB, 0.16607614E-05_JPRB, &
  & 0.16652233E-05_JPRB, 0.16691722E-05_JPRB, 0.16720421E-05_JPRB, 0.16733532E-05_JPRB, 0.16726183E-05_JPRB, 0.16696149E-05_JPRB, &
  & 0.16642762E-05_JPRB, 0.16569120E-05_JPRB, 0.16478585E-05_JPRB, 0.16372998E-05_JPRB, 0.16254958E-05_JPRB, 0.16127267E-05_JPRB, &
  & 0.15992345E-05_JPRB, 0.15851990E-05_JPRB, 0.15706544E-05_JPRB, 0.15558020E-05_JPRB, 0.15407941E-05_JPRB, 0.15259671E-05_JPRB, &
  & 0.15115388E-05_JPRB, 0.14976143E-05_JPRB, 0.14842842E-05_JPRB, 0.14716629E-05_JPRB, 0.14596944E-05_JPRB, 0.14483034E-05_JPRB, &
  & 0.14373331E-05_JPRB, 0.14266492E-05_JPRB, 0.14161533E-05_JPRB, 0.14058537E-05_JPRB, 0.13959534E-05_JPRB, 0.13868107E-05_JPRB, &
  & 0.13788390E-05_JPRB, 0.13720389E-05_JPRB, 0.13657103E-05_JPRB, 0.13572267E-05_JPRB /)

RGHG2(:,29, 4) = (/ &
  & 0.13078034E-05_JPRB, 0.13289996E-05_JPRB, 0.13424598E-05_JPRB, 0.13539365E-05_JPRB, 0.13661811E-05_JPRB, 0.13793239E-05_JPRB, &
  & 0.13935456E-05_JPRB, 0.14089979E-05_JPRB, 0.14254321E-05_JPRB, 0.14428763E-05_JPRB, 0.14612864E-05_JPRB, 0.14803603E-05_JPRB, &
  & 0.14997235E-05_JPRB, 0.15188231E-05_JPRB, 0.15372813E-05_JPRB, 0.15548237E-05_JPRB, 0.15712131E-05_JPRB, 0.15862872E-05_JPRB, &
  & 0.16000381E-05_JPRB, 0.16124942E-05_JPRB, 0.16236838E-05_JPRB, 0.16335915E-05_JPRB, 0.16422680E-05_JPRB, 0.16497240E-05_JPRB, &
  & 0.16561079E-05_JPRB, 0.16615322E-05_JPRB, 0.16662830E-05_JPRB, 0.16706338E-05_JPRB, 0.16746492E-05_JPRB, 0.16784624E-05_JPRB, &
  & 0.16819889E-05_JPRB, 0.16849649E-05_JPRB, 0.16869631E-05_JPRB, 0.16875656E-05_JPRB, 0.16863792E-05_JPRB, 0.16832334E-05_JPRB, &
  & 0.16781914E-05_JPRB, 0.16714437E-05_JPRB, 0.16631870E-05_JPRB, 0.16537897E-05_JPRB, 0.16434693E-05_JPRB, 0.16323645E-05_JPRB, &
  & 0.16206895E-05_JPRB, 0.16084732E-05_JPRB, 0.15957701E-05_JPRB, 0.15825692E-05_JPRB, 0.15691397E-05_JPRB, 0.15556561E-05_JPRB, &
  & 0.15424208E-05_JPRB, 0.15295503E-05_JPRB, 0.15171396E-05_JPRB, 0.15052483E-05_JPRB, 0.14938677E-05_JPRB, 0.14829116E-05_JPRB, &
  & 0.14722552E-05_JPRB, 0.14617635E-05_JPRB, 0.14513780E-05_JPRB, 0.14411116E-05_JPRB, 0.14312037E-05_JPRB, 0.14220457E-05_JPRB, &
  & 0.14140503E-05_JPRB, 0.14072125E-05_JPRB, 0.14008833E-05_JPRB, 0.13920126E-05_JPRB /)

RGHG2(:,30, 4) = (/ &
  & 0.13395488E-05_JPRB, 0.13602264E-05_JPRB, 0.13718525E-05_JPRB, 0.13831265E-05_JPRB, 0.13943652E-05_JPRB, 0.14066242E-05_JPRB, &
  & 0.14199952E-05_JPRB, 0.14343117E-05_JPRB, 0.14496613E-05_JPRB, 0.14660001E-05_JPRB, 0.14833176E-05_JPRB, 0.15014760E-05_JPRB, &
  & 0.15200942E-05_JPRB, 0.15387120E-05_JPRB, 0.15568214E-05_JPRB, 0.15740571E-05_JPRB, 0.15902601E-05_JPRB, 0.16052442E-05_JPRB, &
  & 0.16189127E-05_JPRB, 0.16312281E-05_JPRB, 0.16422462E-05_JPRB, 0.16519172E-05_JPRB, 0.16603688E-05_JPRB, 0.16675386E-05_JPRB, &
  & 0.16737054E-05_JPRB, 0.16788057E-05_JPRB, 0.16832568E-05_JPRB, 0.16871369E-05_JPRB, 0.16905567E-05_JPRB, 0.16936269E-05_JPRB, &
  & 0.16963165E-05_JPRB, 0.16984267E-05_JPRB, 0.16996649E-05_JPRB, 0.16996851E-05_JPRB, 0.16982002E-05_JPRB, 0.16950748E-05_JPRB, &
  & 0.16903305E-05_JPRB, 0.16841352E-05_JPRB, 0.16769179E-05_JPRB, 0.16688775E-05_JPRB, 0.16600839E-05_JPRB, 0.16506112E-05_JPRB, &
  & 0.16405514E-05_JPRB, 0.16300146E-05_JPRB, 0.16188313E-05_JPRB, 0.16071390E-05_JPRB, 0.15950279E-05_JPRB, 0.15827547E-05_JPRB, &
  & 0.15705411E-05_JPRB, 0.15585474E-05_JPRB, 0.15468790E-05_JPRB, 0.15355929E-05_JPRB, 0.15246758E-05_JPRB, 0.15140774E-05_JPRB, &
  & 0.15036749E-05_JPRB, 0.14933602E-05_JPRB, 0.14830691E-05_JPRB, 0.14728397E-05_JPRB, 0.14629462E-05_JPRB, 0.14537900E-05_JPRB, &
  & 0.14458332E-05_JPRB, 0.14390139E-05_JPRB, 0.14326116E-05_JPRB, 0.14236286E-05_JPRB /)

RGHG2(:,31, 4) = (/ &
  & 0.13689129E-05_JPRB, 0.13876539E-05_JPRB, 0.13994927E-05_JPRB, 0.14096117E-05_JPRB, 0.14204163E-05_JPRB, 0.14319427E-05_JPRB, &
  & 0.14443652E-05_JPRB, 0.14577776E-05_JPRB, 0.14720561E-05_JPRB, 0.14873278E-05_JPRB, 0.15036593E-05_JPRB, 0.15208778E-05_JPRB, &
  & 0.15386910E-05_JPRB, 0.15566602E-05_JPRB, 0.15743485E-05_JPRB, 0.15913427E-05_JPRB, 0.16073407E-05_JPRB, 0.16221783E-05_JPRB, &
  & 0.16356896E-05_JPRB, 0.16478168E-05_JPRB, 0.16585994E-05_JPRB, 0.16679959E-05_JPRB, 0.16761782E-05_JPRB, 0.16830336E-05_JPRB, &
  & 0.16889346E-05_JPRB, 0.16937020E-05_JPRB, 0.16978308E-05_JPRB, 0.17012619E-05_JPRB, 0.17041707E-05_JPRB, 0.17065956E-05_JPRB, &
  & 0.17085690E-05_JPRB, 0.17099551E-05_JPRB, 0.17105556E-05_JPRB, 0.17101256E-05_JPRB, 0.17084476E-05_JPRB, 0.17054176E-05_JPRB, &
  & 0.17011095E-05_JPRB, 0.16958043E-05_JPRB, 0.16896429E-05_JPRB, 0.16827441E-05_JPRB, 0.16752522E-05_JPRB, 0.16672055E-05_JPRB, &
  & 0.16586391E-05_JPRB, 0.16494739E-05_JPRB, 0.16396685E-05_JPRB, 0.16291752E-05_JPRB, 0.16182343E-05_JPRB, 0.16070164E-05_JPRB, &
  & 0.15957096E-05_JPRB, 0.15844940E-05_JPRB, 0.15734801E-05_JPRB, 0.15627147E-05_JPRB, 0.15522290E-05_JPRB, 0.15419698E-05_JPRB, &
  & 0.15318299E-05_JPRB, 0.15217073E-05_JPRB, 0.15115440E-05_JPRB, 0.15014050E-05_JPRB, 0.14915699E-05_JPRB, 0.14825036E-05_JPRB, &
  & 0.14745931E-05_JPRB, 0.14678510E-05_JPRB, 0.14614984E-05_JPRB, 0.14524086E-05_JPRB /)

RGHG2(:,32, 4) = (/ &
  & 0.13952543E-05_JPRB, 0.14139115E-05_JPRB, 0.14244708E-05_JPRB, 0.14345803E-05_JPRB, 0.14446281E-05_JPRB, 0.14555217E-05_JPRB, &
  & 0.14672223E-05_JPRB, 0.14796922E-05_JPRB, 0.14930056E-05_JPRB, 0.15072593E-05_JPRB, 0.15225620E-05_JPRB, 0.15388672E-05_JPRB, &
  & 0.15558691E-05_JPRB, 0.15731769E-05_JPRB, 0.15903647E-05_JPRB, 0.16069833E-05_JPRB, 0.16227071E-05_JPRB, 0.16373165E-05_JPRB, &
  & 0.16506095E-05_JPRB, 0.16624919E-05_JPRB, 0.16729701E-05_JPRB, 0.16820650E-05_JPRB, 0.16899278E-05_JPRB, 0.16964697E-05_JPRB, &
  & 0.17020400E-05_JPRB, 0.17065126E-05_JPRB, 0.17102659E-05_JPRB, 0.17133235E-05_JPRB, 0.17157629E-05_JPRB, 0.17176625E-05_JPRB, &
  & 0.17190457E-05_JPRB, 0.17198508E-05_JPRB, 0.17199561E-05_JPRB, 0.17191985E-05_JPRB, 0.17174315E-05_JPRB, 0.17146065E-05_JPRB, &
  & 0.17108563E-05_JPRB, 0.17062961E-05_JPRB, 0.17010489E-05_JPRB, 0.16952342E-05_JPRB, 0.16888661E-05_JPRB, 0.16819926E-05_JPRB, &
  & 0.16745864E-05_JPRB, 0.16665767E-05_JPRB, 0.16578599E-05_JPRB, 0.16484789E-05_JPRB, 0.16385424E-05_JPRB, 0.16282552E-05_JPRB, &
  & 0.16178060E-05_JPRB, 0.16073116E-05_JPRB, 0.15969057E-05_JPRB, 0.15866740E-05_JPRB, 0.15766275E-05_JPRB, 0.15667453E-05_JPRB, &
  & 0.15569185E-05_JPRB, 0.15470562E-05_JPRB, 0.15370890E-05_JPRB, 0.15271162E-05_JPRB, 0.15174377E-05_JPRB, 0.15085138E-05_JPRB, &
  & 0.15007786E-05_JPRB, 0.14941337E-05_JPRB, 0.14878373E-05_JPRB, 0.14787283E-05_JPRB /)

RGHG2(:,33, 4) = (/ &
  & 0.14202494E-05_JPRB, 0.14377210E-05_JPRB, 0.14485048E-05_JPRB, 0.14577715E-05_JPRB, 0.14675011E-05_JPRB, 0.14777818E-05_JPRB, &
  & 0.14887188E-05_JPRB, 0.15003836E-05_JPRB, 0.15127421E-05_JPRB, 0.15259944E-05_JPRB, 0.15403107E-05_JPRB, 0.15556583E-05_JPRB, &
  & 0.15718306E-05_JPRB, 0.15884190E-05_JPRB, 0.16050075E-05_JPRB, 0.16211984E-05_JPRB, 0.16365548E-05_JPRB, 0.16508380E-05_JPRB, &
  & 0.16638097E-05_JPRB, 0.16754028E-05_JPRB, 0.16855389E-05_JPRB, 0.16942986E-05_JPRB, 0.17018214E-05_JPRB, 0.17080525E-05_JPRB, &
  & 0.17132721E-05_JPRB, 0.17174522E-05_JPRB, 0.17208420E-05_JPRB, 0.17235488E-05_JPRB, 0.17255917E-05_JPRB, 0.17270581E-05_JPRB, &
  & 0.17279795E-05_JPRB, 0.17283413E-05_JPRB, 0.17280860E-05_JPRB, 0.17271184E-05_JPRB, 0.17253584E-05_JPRB, 0.17228120E-05_JPRB, &
  & 0.17195446E-05_JPRB, 0.17156501E-05_JPRB, 0.17112178E-05_JPRB, 0.17062964E-05_JPRB, 0.17008610E-05_JPRB, 0.16949117E-05_JPRB, &
  & 0.16884063E-05_JPRB, 0.16812635E-05_JPRB, 0.16734518E-05_JPRB, 0.16649601E-05_JPRB, 0.16559194E-05_JPRB, 0.16464974E-05_JPRB, &
  & 0.16368132E-05_JPRB, 0.16270309E-05_JPRB, 0.16172485E-05_JPRB, 0.16075570E-05_JPRB, 0.15980121E-05_JPRB, 0.15885767E-05_JPRB, &
  & 0.15791494E-05_JPRB, 0.15696342E-05_JPRB, 0.15599730E-05_JPRB, 0.15502662E-05_JPRB, 0.15408393E-05_JPRB, 0.15321823E-05_JPRB, &
  & 0.15246437E-05_JPRB, 0.15181744E-05_JPRB, 0.15119820E-05_JPRB, 0.15028985E-05_JPRB /)

RGHG2(:,34, 4) = (/ &
  & 0.14435459E-05_JPRB, 0.14609536E-05_JPRB, 0.14708168E-05_JPRB, 0.14800203E-05_JPRB, 0.14891476E-05_JPRB, 0.14988432E-05_JPRB, &
  & 0.15091443E-05_JPRB, 0.15199696E-05_JPRB, 0.15314280E-05_JPRB, 0.15437079E-05_JPRB, 0.15569966E-05_JPRB, 0.15713651E-05_JPRB, &
  & 0.15866260E-05_JPRB, 0.16024727E-05_JPRB, 0.16184549E-05_JPRB, 0.16341164E-05_JPRB, 0.16490349E-05_JPRB, 0.16628933E-05_JPRB, &
  & 0.16754468E-05_JPRB, 0.16866708E-05_JPRB, 0.16964685E-05_JPRB, 0.17048808E-05_JPRB, 0.17120608E-05_JPRB, 0.17179851E-05_JPRB, &
  & 0.17228523E-05_JPRB, 0.17267346E-05_JPRB, 0.17297813E-05_JPRB, 0.17321536E-05_JPRB, 0.17338601E-05_JPRB, 0.17349768E-05_JPRB, &
  & 0.17355534E-05_JPRB, 0.17356011E-05_JPRB, 0.17351118E-05_JPRB, 0.17340457E-05_JPRB, 0.17323750E-05_JPRB, 0.17301165E-05_JPRB, &
  & 0.17273097E-05_JPRB, 0.17240216E-05_JPRB, 0.17202799E-05_JPRB, 0.17160529E-05_JPRB, 0.17113080E-05_JPRB, 0.17060102E-05_JPRB, &
  & 0.17001489E-05_JPRB, 0.16936660E-05_JPRB, 0.16865308E-05_JPRB, 0.16787868E-05_JPRB, 0.16705236E-05_JPRB, 0.16618471E-05_JPRB, &
  & 0.16529095E-05_JPRB, 0.16437971E-05_JPRB, 0.16346323E-05_JPRB, 0.16255375E-05_JPRB, 0.16165422E-05_JPRB, 0.16076287E-05_JPRB, &
  & 0.15986991E-05_JPRB, 0.15896418E-05_JPRB, 0.15803919E-05_JPRB, 0.15710795E-05_JPRB, 0.15620301E-05_JPRB, 0.15537032E-05_JPRB, &
  & 0.15464710E-05_JPRB, 0.15402063E-05_JPRB, 0.15341409E-05_JPRB, 0.15251558E-05_JPRB /)

RGHG2(:,35, 4) = (/ &
  & 0.14661506E-05_JPRB, 0.14826231E-05_JPRB, 0.14924925E-05_JPRB, 0.15010176E-05_JPRB, 0.15097935E-05_JPRB, 0.15189150E-05_JPRB, &
  & 0.15285011E-05_JPRB, 0.15385586E-05_JPRB, 0.15491217E-05_JPRB, 0.15604287E-05_JPRB, 0.15727223E-05_JPRB, 0.15860994E-05_JPRB, &
  & 0.16004545E-05_JPRB, 0.16154490E-05_JPRB, 0.16307323E-05_JPRB, 0.16458171E-05_JPRB, 0.16602319E-05_JPRB, 0.16736292E-05_JPRB, &
  & 0.16857248E-05_JPRB, 0.16965080E-05_JPRB, 0.17059460E-05_JPRB, 0.17140202E-05_JPRB, 0.17208557E-05_JPRB, 0.17264701E-05_JPRB, &
  & 0.17309831E-05_JPRB, 0.17345346E-05_JPRB, 0.17372490E-05_JPRB, 0.17392875E-05_JPRB, 0.17406961E-05_JPRB, 0.17415373E-05_JPRB, &
  & 0.17418693E-05_JPRB, 0.17417199E-05_JPRB, 0.17411109E-05_JPRB, 0.17400396E-05_JPRB, 0.17385107E-05_JPRB, 0.17365435E-05_JPRB, &
  & 0.17341722E-05_JPRB, 0.17314223E-05_JPRB, 0.17282475E-05_JPRB, 0.17245752E-05_JPRB, 0.17203104E-05_JPRB, 0.17154508E-05_JPRB, &
  & 0.17100048E-05_JPRB, 0.17039712E-05_JPRB, 0.16973700E-05_JPRB, 0.16902302E-05_JPRB, 0.16826305E-05_JPRB, 0.16746517E-05_JPRB, &
  & 0.16663491E-05_JPRB, 0.16578693E-05_JPRB, 0.16493171E-05_JPRB, 0.16408088E-05_JPRB, 0.16324042E-05_JPRB, 0.16240791E-05_JPRB, &
  & 0.16157205E-05_JPRB, 0.16072124E-05_JPRB, 0.15985055E-05_JPRB, 0.15896981E-05_JPRB, 0.15811313E-05_JPRB, 0.15732475E-05_JPRB, &
  & 0.15663564E-05_JPRB, 0.15603414E-05_JPRB, 0.15544698E-05_JPRB, 0.15456143E-05_JPRB /)

RGHG2(:,36, 4) = (/ &
  & 0.14877168E-05_JPRB, 0.15037149E-05_JPRB, 0.15128752E-05_JPRB, 0.15211870E-05_JPRB, 0.15294381E-05_JPRB, 0.15380029E-05_JPRB, &
  & 0.15469471E-05_JPRB, 0.15561990E-05_JPRB, 0.15658934E-05_JPRB, 0.15762558E-05_JPRB, 0.15875264E-05_JPRB, 0.15998750E-05_JPRB, &
  & 0.16132652E-05_JPRB, 0.16274446E-05_JPRB, 0.16419633E-05_JPRB, 0.16563714E-05_JPRB, 0.16701819E-05_JPRB, 0.16830739E-05_JPRB, &
  & 0.16947257E-05_JPRB, 0.17050901E-05_JPRB, 0.17141703E-05_JPRB, 0.17219249E-05_JPRB, 0.17284028E-05_JPRB, 0.17336586E-05_JPRB, &
  & 0.17377745E-05_JPRB, 0.17409242E-05_JPRB, 0.17432677E-05_JPRB, 0.17449589E-05_JPRB, 0.17460878E-05_JPRB, 0.17467094E-05_JPRB, &
  & 0.17468840E-05_JPRB, 0.17466371E-05_JPRB, 0.17460045E-05_JPRB, 0.17450062E-05_JPRB, 0.17436621E-05_JPRB, 0.17419952E-05_JPRB, &
  & 0.17400239E-05_JPRB, 0.17377251E-05_JPRB, 0.17350260E-05_JPRB, 0.17318008E-05_JPRB, 0.17279385E-05_JPRB, 0.17233974E-05_JPRB, &
  & 0.17182426E-05_JPRB, 0.17125421E-05_JPRB, 0.17063492E-05_JPRB, 0.16997268E-05_JPRB, 0.16926826E-05_JPRB, 0.16852537E-05_JPRB, &
  & 0.16775326E-05_JPRB, 0.16695958E-05_JPRB, 0.16615957E-05_JPRB, 0.16536596E-05_JPRB, 0.16458471E-05_JPRB, 0.16381331E-05_JPRB, &
  & 0.16304025E-05_JPRB, 0.16225280E-05_JPRB, 0.16144411E-05_JPRB, 0.16062573E-05_JPRB, 0.15982757E-05_JPRB, 0.15909029E-05_JPRB, &
  & 0.15844315E-05_JPRB, 0.15787244E-05_JPRB, 0.15730673E-05_JPRB, 0.15644657E-05_JPRB /)

RGHG2(:,37, 4) = (/ &
  & 0.15086098E-05_JPRB, 0.15237051E-05_JPRB, 0.15324885E-05_JPRB, 0.15403213E-05_JPRB, 0.15481917E-05_JPRB, 0.15562523E-05_JPRB, &
  & 0.15645360E-05_JPRB, 0.15730228E-05_JPRB, 0.15818459E-05_JPRB, 0.15912592E-05_JPRB, 0.16015352E-05_JPRB, 0.16128569E-05_JPRB, &
  & 0.16252391E-05_JPRB, 0.16384881E-05_JPRB, 0.16522166E-05_JPRB, 0.16659037E-05_JPRB, 0.16790631E-05_JPRB, 0.16913655E-05_JPRB, &
  & 0.17025737E-05_JPRB, 0.17125558E-05_JPRB, 0.17212990E-05_JPRB, 0.17287215E-05_JPRB, 0.17347859E-05_JPRB, 0.17395550E-05_JPRB, &
  & 0.17431523E-05_JPRB, 0.17458030E-05_JPRB, 0.17477098E-05_JPRB, 0.17490463E-05_JPRB, 0.17499162E-05_JPRB, 0.17503696E-05_JPRB, &
  & 0.17504552E-05_JPRB, 0.17501860E-05_JPRB, 0.17495961E-05_JPRB, 0.17487162E-05_JPRB, 0.17475774E-05_JPRB, 0.17461973E-05_JPRB, &
  & 0.17445777E-05_JPRB, 0.17426701E-05_JPRB, 0.17403779E-05_JPRB, 0.17375694E-05_JPRB, 0.17340993E-05_JPRB, 0.17299028E-05_JPRB, &
  & 0.17250461E-05_JPRB, 0.17196380E-05_JPRB, 0.17138107E-05_JPRB, 0.17075939E-05_JPRB, 0.17010225E-05_JPRB, 0.16940992E-05_JPRB, &
  & 0.16868457E-05_JPRB, 0.16793829E-05_JPRB, 0.16718616E-05_JPRB, 0.16644368E-05_JPRB, 0.16571918E-05_JPRB, 0.16500928E-05_JPRB, &
  & 0.16430110E-05_JPRB, 0.16358109E-05_JPRB, 0.16284229E-05_JPRB, 0.16209269E-05_JPRB, 0.16136112E-05_JPRB, 0.16068356E-05_JPRB, &
  & 0.16008423E-05_JPRB, 0.15954889E-05_JPRB, 0.15901305E-05_JPRB, 0.15818422E-05_JPRB /)

RGHG2(:,38, 4) = (/ &
  & 0.15287733E-05_JPRB, 0.15427648E-05_JPRB, 0.15511139E-05_JPRB, 0.15585393E-05_JPRB, 0.15660862E-05_JPRB, 0.15737028E-05_JPRB, &
  & 0.15813748E-05_JPRB, 0.15891185E-05_JPRB, 0.15970866E-05_JPRB, 0.16055487E-05_JPRB, 0.16148058E-05_JPRB, 0.16250751E-05_JPRB, &
  & 0.16364460E-05_JPRB, 0.16487528E-05_JPRB, 0.16616025E-05_JPRB, 0.16745116E-05_JPRB, 0.16869715E-05_JPRB, 0.16986766E-05_JPRB, &
  & 0.17094048E-05_JPRB, 0.17190067E-05_JPRB, 0.17273543E-05_JPRB, 0.17343388E-05_JPRB, 0.17398515E-05_JPRB, 0.17439910E-05_JPRB, &
  & 0.17469779E-05_JPRB, 0.17490928E-05_JPRB, 0.17505881E-05_JPRB, 0.17516193E-05_JPRB, 0.17522902E-05_JPRB, 0.17526298E-05_JPRB, &
  & 0.17526713E-05_JPRB, 0.17524113E-05_JPRB, 0.17518781E-05_JPRB, 0.17511086E-05_JPRB, 0.17501377E-05_JPRB, 0.17489892E-05_JPRB, &
  & 0.17476488E-05_JPRB, 0.17460678E-05_JPRB, 0.17441442E-05_JPRB, 0.17417395E-05_JPRB, 0.17386935E-05_JPRB, 0.17349187E-05_JPRB, &
  & 0.17304342E-05_JPRB, 0.17253927E-05_JPRB, 0.17199210E-05_JPRB, 0.17141341E-05_JPRB, 0.17080089E-05_JPRB, 0.17015169E-05_JPRB, &
  & 0.16946818E-05_JPRB, 0.16876040E-05_JPRB, 0.16804800E-05_JPRB, 0.16735071E-05_JPRB, 0.16667850E-05_JPRB, 0.16602759E-05_JPRB, &
  & 0.16538456E-05_JPRB, 0.16473372E-05_JPRB, 0.16406701E-05_JPRB, 0.16339105E-05_JPRB, 0.16273133E-05_JPRB, 0.16211911E-05_JPRB, &
  & 0.16157355E-05_JPRB, 0.16108088E-05_JPRB, 0.16057930E-05_JPRB, 0.15979329E-05_JPRB /)

RGHG2(:,39, 4) = (/ &
  & 0.15479415E-05_JPRB, 0.15610731E-05_JPRB, 0.15686727E-05_JPRB, 0.15759185E-05_JPRB, 0.15830852E-05_JPRB, 0.15903702E-05_JPRB, &
  & 0.15975032E-05_JPRB, 0.16045190E-05_JPRB, 0.16116342E-05_JPRB, 0.16191685E-05_JPRB, 0.16274025E-05_JPRB, 0.16366187E-05_JPRB, &
  & 0.16469321E-05_JPRB, 0.16582466E-05_JPRB, 0.16701969E-05_JPRB, 0.16822889E-05_JPRB, 0.16940435E-05_JPRB, 0.17051248E-05_JPRB, &
  & 0.17153351E-05_JPRB, 0.17244836E-05_JPRB, 0.17323282E-05_JPRB, 0.17386853E-05_JPRB, 0.17435284E-05_JPRB, 0.17470078E-05_JPRB, &
  & 0.17494322E-05_JPRB, 0.17511170E-05_JPRB, 0.17523023E-05_JPRB, 0.17531282E-05_JPRB, 0.17536721E-05_JPRB, 0.17539455E-05_JPRB, &
  & 0.17539667E-05_JPRB, 0.17537193E-05_JPRB, 0.17532254E-05_JPRB, 0.17525283E-05_JPRB, 0.17516708E-05_JPRB, 0.17506743E-05_JPRB, &
  & 0.17495352E-05_JPRB, 0.17482015E-05_JPRB, 0.17465854E-05_JPRB, 0.17445496E-05_JPRB, 0.17419337E-05_JPRB, 0.17386080E-05_JPRB, &
  & 0.17345831E-05_JPRB, 0.17299562E-05_JPRB, 0.17249322E-05_JPRB, 0.17195745E-05_JPRB, 0.17138969E-05_JPRB, 0.17078338E-05_JPRB, &
  & 0.17013672E-05_JPRB, 0.16946113E-05_JPRB, 0.16878113E-05_JPRB, 0.16812221E-05_JPRB, 0.16749698E-05_JPRB, 0.16690175E-05_JPRB, &
  & 0.16632080E-05_JPRB, 0.16573792E-05_JPRB, 0.16514239E-05_JPRB, 0.16454092E-05_JPRB, 0.16395499E-05_JPRB, 0.16341181E-05_JPRB, &
  & 0.16292489E-05_JPRB, 0.16247883E-05_JPRB, 0.16201795E-05_JPRB, 0.16128373E-05_JPRB /)

RGHG2(:,40, 4) = (/ &
  & 0.15662939E-05_JPRB, 0.15780986E-05_JPRB, 0.15854710E-05_JPRB, 0.15921903E-05_JPRB, 0.15992848E-05_JPRB, 0.16062377E-05_JPRB, &
  & 0.16128671E-05_JPRB, 0.16192074E-05_JPRB, 0.16255053E-05_JPRB, 0.16320768E-05_JPRB, 0.16393126E-05_JPRB, 0.16474756E-05_JPRB, &
  & 0.16567543E-05_JPRB, 0.16670758E-05_JPRB, 0.16781009E-05_JPRB, 0.16893432E-05_JPRB, 0.17003465E-05_JPRB, 0.17107941E-05_JPRB, &
  & 0.17204177E-05_JPRB, 0.17290101E-05_JPRB, 0.17362396E-05_JPRB, 0.17419036E-05_JPRB, 0.17460643E-05_JPRB, 0.17489822E-05_JPRB, &
  & 0.17509794E-05_JPRB, 0.17523630E-05_JPRB, 0.17533475E-05_JPRB, 0.17540435E-05_JPRB, 0.17545129E-05_JPRB, 0.17547499E-05_JPRB, &
  & 0.17547598E-05_JPRB, 0.17545199E-05_JPRB, 0.17540485E-05_JPRB, 0.17533931E-05_JPRB, 0.17526013E-05_JPRB, 0.17517044E-05_JPRB, &
  & 0.17506957E-05_JPRB, 0.17495422E-05_JPRB, 0.17481616E-05_JPRB, 0.17464372E-05_JPRB, 0.17442117E-05_JPRB, 0.17413497E-05_JPRB, &
  & 0.17377987E-05_JPRB, 0.17336674E-05_JPRB, 0.17290949E-05_JPRB, 0.17242170E-05_JPRB, 0.17189850E-05_JPRB, 0.17133179E-05_JPRB, &
  & 0.17071861E-05_JPRB, 0.17007098E-05_JPRB, 0.16941726E-05_JPRB, 0.16879112E-05_JPRB, 0.16820802E-05_JPRB, 0.16766398E-05_JPRB, &
  & 0.16714139E-05_JPRB, 0.16662156E-05_JPRB, 0.16609433E-05_JPRB, 0.16556364E-05_JPRB, 0.16505073E-05_JPRB, 0.16457655E-05_JPRB, &
  & 0.16414959E-05_JPRB, 0.16375341E-05_JPRB, 0.16333665E-05_JPRB, 0.16266061E-05_JPRB /)

RGHG2(:,41, 4) = (/ &
  & 0.15834231E-05_JPRB, 0.15944098E-05_JPRB, 0.16010636E-05_JPRB, 0.16077329E-05_JPRB, 0.16145402E-05_JPRB, 0.16212944E-05_JPRB, &
  & 0.16274823E-05_JPRB, 0.16331632E-05_JPRB, 0.16386412E-05_JPRB, 0.16443194E-05_JPRB, 0.16505348E-05_JPRB, 0.16576652E-05_JPRB, &
  & 0.16659075E-05_JPRB, 0.16752447E-05_JPRB, 0.16853652E-05_JPRB, 0.16957904E-05_JPRB, 0.17060570E-05_JPRB, 0.17158368E-05_JPRB, &
  & 0.17248517E-05_JPRB, 0.17327593E-05_JPRB, 0.17393027E-05_JPRB, 0.17442833E-05_JPRB, 0.17478553E-05_JPRB, 0.17503266E-05_JPRB, &
  & 0.17520155E-05_JPRB, 0.17531935E-05_JPRB, 0.17540433E-05_JPRB, 0.17546583E-05_JPRB, 0.17550810E-05_JPRB, 0.17552968E-05_JPRB, &
  & 0.17553000E-05_JPRB, 0.17550636E-05_JPRB, 0.17546021E-05_JPRB, 0.17539696E-05_JPRB, 0.17532183E-05_JPRB, 0.17523804E-05_JPRB, &
  & 0.17514652E-05_JPRB, 0.17504378E-05_JPRB, 0.17492393E-05_JPRB, 0.17477687E-05_JPRB, 0.17458914E-05_JPRB, 0.17434669E-05_JPRB, &
  & 0.17404236E-05_JPRB, 0.17367836E-05_JPRB, 0.17327135E-05_JPRB, 0.17282823E-05_JPRB, 0.17234825E-05_JPRB, 0.17182082E-05_JPRB, &
  & 0.17123942E-05_JPRB, 0.17061579E-05_JPRB, 0.16998579E-05_JPRB, 0.16938804E-05_JPRB, 0.16884408E-05_JPRB, 0.16834681E-05_JPRB, &
  & 0.16787733E-05_JPRB, 0.16741546E-05_JPRB, 0.16694983E-05_JPRB, 0.16648546E-05_JPRB, 0.16604030E-05_JPRB, 0.16563217E-05_JPRB, &
  & 0.16526341E-05_JPRB, 0.16491667E-05_JPRB, 0.16454454E-05_JPRB, 0.16393047E-05_JPRB /)

RGHG2(:,42, 4) = (/ &
  & 0.15995988E-05_JPRB, 0.16096423E-05_JPRB, 0.16160192E-05_JPRB, 0.16223000E-05_JPRB, 0.16290696E-05_JPRB, 0.16355846E-05_JPRB, &
  & 0.16413308E-05_JPRB, 0.16463920E-05_JPRB, 0.16511093E-05_JPRB, 0.16558859E-05_JPRB, 0.16611505E-05_JPRB, 0.16672600E-05_JPRB, &
  & 0.16745031E-05_JPRB, 0.16828833E-05_JPRB, 0.16921178E-05_JPRB, 0.17017410E-05_JPRB, 0.17112925E-05_JPRB, 0.17204063E-05_JPRB, &
  & 0.17287423E-05_JPRB, 0.17359608E-05_JPRB, 0.17417618E-05_JPRB, 0.17461111E-05_JPRB, 0.17491828E-05_JPRB, 0.17513078E-05_JPRB, &
  & 0.17527690E-05_JPRB, 0.17537998E-05_JPRB, 0.17545585E-05_JPRB, 0.17551175E-05_JPRB, 0.17555104E-05_JPRB, 0.17557129E-05_JPRB, &
  & 0.17557109E-05_JPRB, 0.17554742E-05_JPRB, 0.17550170E-05_JPRB, 0.17543948E-05_JPRB, 0.17536645E-05_JPRB, 0.17528687E-05_JPRB, &
  & 0.17520150E-05_JPRB, 0.17510844E-05_JPRB, 0.17500271E-05_JPRB, 0.17487677E-05_JPRB, 0.17471970E-05_JPRB, 0.17451932E-05_JPRB, &
  & 0.17426523E-05_JPRB, 0.17395643E-05_JPRB, 0.17359822E-05_JPRB, 0.17320293E-05_JPRB, 0.17276490E-05_JPRB, 0.17227328E-05_JPRB, &
  & 0.17172158E-05_JPRB, 0.17112222E-05_JPRB, 0.17051286E-05_JPRB, 0.16994425E-05_JPRB, 0.16943669E-05_JPRB, 0.16898373E-05_JPRB, &
  & 0.16856224E-05_JPRB, 0.16815198E-05_JPRB, 0.16774146E-05_JPRB, 0.16733552E-05_JPRB, 0.16695163E-05_JPRB, 0.16660259E-05_JPRB, &
  & 0.16628729E-05_JPRB, 0.16598688E-05_JPRB, 0.16565851E-05_JPRB, 0.16510510E-05_JPRB /)

RGHG2(:,43, 4) = (/ &
  & 0.16149057E-05_JPRB, 0.16241898E-05_JPRB, 0.16301681E-05_JPRB, 0.16362505E-05_JPRB, 0.16428556E-05_JPRB, 0.16491326E-05_JPRB, &
  & 0.16544834E-05_JPRB, 0.16589340E-05_JPRB, 0.16629416E-05_JPRB, 0.16669048E-05_JPRB, 0.16712489E-05_JPRB, 0.16763909E-05_JPRB, &
  & 0.16826526E-05_JPRB, 0.16901229E-05_JPRB, 0.16985261E-05_JPRB, 0.17073864E-05_JPRB, 0.17162301E-05_JPRB, 0.17246662E-05_JPRB, &
  & 0.17322886E-05_JPRB, 0.17387388E-05_JPRB, 0.17438169E-05_JPRB, 0.17475704E-05_JPRB, 0.17502217E-05_JPRB, 0.17520692E-05_JPRB, &
  & 0.17533550E-05_JPRB, 0.17542801E-05_JPRB, 0.17549712E-05_JPRB, 0.17554933E-05_JPRB, 0.17558649E-05_JPRB, 0.17560578E-05_JPRB, &
  & 0.17560508E-05_JPRB, 0.17558120E-05_JPRB, 0.17553539E-05_JPRB, 0.17547345E-05_JPRB, 0.17540162E-05_JPRB, 0.17532427E-05_JPRB, &
  & 0.17524354E-05_JPRB, 0.17515770E-05_JPRB, 0.17506353E-05_JPRB, 0.17495558E-05_JPRB, 0.17482594E-05_JPRB, 0.17466489E-05_JPRB, &
  & 0.17446270E-05_JPRB, 0.17421067E-05_JPRB, 0.17391058E-05_JPRB, 0.17356208E-05_JPRB, 0.17316676E-05_JPRB, 0.17271112E-05_JPRB, &
  & 0.17218854E-05_JPRB, 0.17161183E-05_JPRB, 0.17102759E-05_JPRB, 0.17048768E-05_JPRB, 0.17001745E-05_JPRB, 0.16960535E-05_JPRB, &
  & 0.16922772E-05_JPRB, 0.16886253E-05_JPRB, 0.16849948E-05_JPRB, 0.16814405E-05_JPRB, 0.16781239E-05_JPRB, 0.16751451E-05_JPRB, &
  & 0.16724573E-05_JPRB, 0.16698696E-05_JPRB, 0.16669877E-05_JPRB, 0.16620386E-05_JPRB /)

RGHG2(:,44, 4) = (/ &
  & 0.16293950E-05_JPRB, 0.16381323E-05_JPRB, 0.16437087E-05_JPRB, 0.16495931E-05_JPRB, 0.16559718E-05_JPRB, 0.16620518E-05_JPRB, &
  & 0.16669421E-05_JPRB, 0.16708827E-05_JPRB, 0.16742225E-05_JPRB, 0.16774695E-05_JPRB, 0.16809902E-05_JPRB, 0.16852318E-05_JPRB, &
  & 0.16905781E-05_JPRB, 0.16971796E-05_JPRB, 0.17047996E-05_JPRB, 0.17129354E-05_JPRB, 0.17210880E-05_JPRB, 0.17287687E-05_JPRB, &
  & 0.17356022E-05_JPRB, 0.17412179E-05_JPRB, 0.17455712E-05_JPRB, 0.17487752E-05_JPRB, 0.17510645E-05_JPRB, 0.17526835E-05_JPRB, &
  & 0.17538349E-05_JPRB, 0.17546791E-05_JPRB, 0.17553235E-05_JPRB, 0.17558185E-05_JPRB, 0.17561770E-05_JPRB, 0.17563626E-05_JPRB, &
  & 0.17563503E-05_JPRB, 0.17561072E-05_JPRB, 0.17556448E-05_JPRB, 0.17550238E-05_JPRB, 0.17543057E-05_JPRB, 0.17535459E-05_JPRB, &
  & 0.17527677E-05_JPRB, 0.17519662E-05_JPRB, 0.17511209E-05_JPRB, 0.17501969E-05_JPRB, 0.17491483E-05_JPRB, 0.17479109E-05_JPRB, &
  & 0.17463944E-05_JPRB, 0.17445079E-05_JPRB, 0.17421251E-05_JPRB, 0.17392396E-05_JPRB, 0.17357384E-05_JPRB, 0.17315526E-05_JPRB, &
  & 0.17266198E-05_JPRB, 0.17211112E-05_JPRB, 0.17155201E-05_JPRB, 0.17104499E-05_JPRB, 0.17061150E-05_JPRB, 0.17023830E-05_JPRB, &
  & 0.16989898E-05_JPRB, 0.16957306E-05_JPRB, 0.16925003E-05_JPRB, 0.16893650E-05_JPRB, 0.16864801E-05_JPRB, 0.16839219E-05_JPRB, &
  & 0.16816227E-05_JPRB, 0.16793953E-05_JPRB, 0.16768763E-05_JPRB, 0.16724780E-05_JPRB /)

RGHG2(:,45, 4) = (/ &
  & 0.16432110E-05_JPRB, 0.16513376E-05_JPRB, 0.16567172E-05_JPRB, 0.16622879E-05_JPRB, 0.16685448E-05_JPRB, 0.16743143E-05_JPRB, &
  & 0.16788515E-05_JPRB, 0.16822551E-05_JPRB, 0.16850736E-05_JPRB, 0.16876818E-05_JPRB, 0.16905254E-05_JPRB, 0.16939621E-05_JPRB, &
  & 0.16984612E-05_JPRB, 0.17042596E-05_JPRB, 0.17111494E-05_JPRB, 0.17185986E-05_JPRB, 0.17259773E-05_JPRB, 0.17328537E-05_JPRB, &
  & 0.17387122E-05_JPRB, 0.17434559E-05_JPRB, 0.17470767E-05_JPRB, 0.17497862E-05_JPRB, 0.17517584E-05_JPRB, 0.17531934E-05_JPRB, &
  & 0.17542362E-05_JPRB, 0.17550221E-05_JPRB, 0.17556335E-05_JPRB, 0.17561126E-05_JPRB, 0.17564626E-05_JPRB, 0.17566422E-05_JPRB, &
  & 0.17566234E-05_JPRB, 0.17563729E-05_JPRB, 0.17559053E-05_JPRB, 0.17552760E-05_JPRB, 0.17545528E-05_JPRB, 0.17537945E-05_JPRB, &
  & 0.17530360E-05_JPRB, 0.17522780E-05_JPRB, 0.17515135E-05_JPRB, 0.17507277E-05_JPRB, 0.17499027E-05_JPRB, 0.17490067E-05_JPRB, &
  & 0.17479871E-05_JPRB, 0.17467178E-05_JPRB, 0.17450820E-05_JPRB, 0.17428537E-05_JPRB, 0.17399545E-05_JPRB, 0.17362065E-05_JPRB, &
  & 0.17315996E-05_JPRB, 0.17263530E-05_JPRB, 0.17210569E-05_JPRB, 0.17163243E-05_JPRB, 0.17123612E-05_JPRB, 0.17089776E-05_JPRB, &
  & 0.17059375E-05_JPRB, 0.17030059E-05_JPRB, 0.17001128E-05_JPRB, 0.16973190E-05_JPRB, 0.16947820E-05_JPRB, 0.16925599E-05_JPRB, &
  & 0.16905785E-05_JPRB, 0.16886503E-05_JPRB, 0.16864557E-05_JPRB, 0.16825674E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART7',1,ZHOOK_HANDLE)
END SUBROUTINE PART7




SUBROUTINE PART8
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART8',0,ZHOOK_HANDLE)



RGHG2(:,46, 4) = (/ &
  & 0.16562344E-05_JPRB, 0.16639283E-05_JPRB, 0.16690528E-05_JPRB, 0.16744690E-05_JPRB, 0.16805006E-05_JPRB, 0.16860339E-05_JPRB, &
  & 0.16901687E-05_JPRB, 0.16931642E-05_JPRB, 0.16954998E-05_JPRB, 0.16976553E-05_JPRB, 0.16999160E-05_JPRB, 0.17027414E-05_JPRB, &
  & 0.17064976E-05_JPRB, 0.17115523E-05_JPRB, 0.17177738E-05_JPRB, 0.17244660E-05_JPRB, 0.17310365E-05_JPRB, 0.17368184E-05_JPRB, &
  & 0.17416550E-05_JPRB, 0.17454299E-05_JPRB, 0.17483799E-05_JPRB, 0.17506327E-05_JPRB, 0.17523395E-05_JPRB, 0.17536191E-05_JPRB, &
  & 0.17545786E-05_JPRB, 0.17553224E-05_JPRB, 0.17559116E-05_JPRB, 0.17563839E-05_JPRB, 0.17567299E-05_JPRB, 0.17569042E-05_JPRB, &
  & 0.17568779E-05_JPRB, 0.17566192E-05_JPRB, 0.17561410E-05_JPRB, 0.17555018E-05_JPRB, 0.17547650E-05_JPRB, 0.17540024E-05_JPRB, &
  & 0.17532525E-05_JPRB, 0.17525297E-05_JPRB, 0.17518352E-05_JPRB, 0.17511724E-05_JPRB, 0.17505474E-05_JPRB, 0.17499635E-05_JPRB, &
  & 0.17493825E-05_JPRB, 0.17487223E-05_JPRB, 0.17477873E-05_JPRB, 0.17463844E-05_JPRB, 0.17441990E-05_JPRB, 0.17410721E-05_JPRB, &
  & 0.17368977E-05_JPRB, 0.17319691E-05_JPRB, 0.17269729E-05_JPRB, 0.17225975E-05_JPRB, 0.17189739E-05_JPRB, 0.17159422E-05_JPRB, &
  & 0.17131847E-05_JPRB, 0.17105527E-05_JPRB, 0.17079324E-05_JPRB, 0.17054193E-05_JPRB, 0.17031564E-05_JPRB, 0.17012019E-05_JPRB, &
  & 0.16994705E-05_JPRB, 0.16977965E-05_JPRB, 0.16958742E-05_JPRB, 0.16924654E-05_JPRB /)

RGHG2(:,47, 4) = (/ &
  & 0.16683514E-05_JPRB, 0.16758806E-05_JPRB, 0.16807313E-05_JPRB, 0.16860809E-05_JPRB, 0.16918999E-05_JPRB, 0.16971937E-05_JPRB, &
  & 0.17009946E-05_JPRB, 0.17036124E-05_JPRB, 0.17056238E-05_JPRB, 0.17073818E-05_JPRB, 0.17092817E-05_JPRB, 0.17115708E-05_JPRB, &
  & 0.17147806E-05_JPRB, 0.17192060E-05_JPRB, 0.17246948E-05_JPRB, 0.17306076E-05_JPRB, 0.17360242E-05_JPRB, 0.17406393E-05_JPRB, &
  & 0.17442703E-05_JPRB, 0.17471741E-05_JPRB, 0.17494813E-05_JPRB, 0.17513477E-05_JPRB, 0.17528243E-05_JPRB, 0.17539801E-05_JPRB, &
  & 0.17548750E-05_JPRB, 0.17555880E-05_JPRB, 0.17561674E-05_JPRB, 0.17566385E-05_JPRB, 0.17569839E-05_JPRB, 0.17571545E-05_JPRB, &
  & 0.17571197E-05_JPRB, 0.17568489E-05_JPRB, 0.17563600E-05_JPRB, 0.17557034E-05_JPRB, 0.17549494E-05_JPRB, 0.17541761E-05_JPRB, &
  & 0.17534300E-05_JPRB, 0.17527346E-05_JPRB, 0.17521022E-05_JPRB, 0.17515491E-05_JPRB, 0.17511044E-05_JPRB, 0.17507894E-05_JPRB, &
  & 0.17505935E-05_JPRB, 0.17504290E-05_JPRB, 0.17501482E-05_JPRB, 0.17494824E-05_JPRB, 0.17481640E-05_JPRB, 0.17458478E-05_JPRB, &
  & 0.17423652E-05_JPRB, 0.17379009E-05_JPRB, 0.17332927E-05_JPRB, 0.17292792E-05_JPRB, 0.17260265E-05_JPRB, 0.17232717E-05_JPRB, &
  & 0.17208117E-05_JPRB, 0.17184045E-05_JPRB, 0.17160251E-05_JPRB, 0.17137299E-05_JPRB, 0.17116874E-05_JPRB, 0.17099399E-05_JPRB, &
  & 0.17084113E-05_JPRB, 0.17069325E-05_JPRB, 0.17052470E-05_JPRB, 0.17022368E-05_JPRB /)

RGHG2(:,48, 4) = (/ &
  & 0.16797994E-05_JPRB, 0.16869349E-05_JPRB, 0.16919506E-05_JPRB, 0.16970416E-05_JPRB, 0.17028841E-05_JPRB, 0.17079041E-05_JPRB, &
  & 0.17114417E-05_JPRB, 0.17137986E-05_JPRB, 0.17155305E-05_JPRB, 0.17170610E-05_JPRB, 0.17186255E-05_JPRB, 0.17206153E-05_JPRB, &
  & 0.17233106E-05_JPRB, 0.17271316E-05_JPRB, 0.17318634E-05_JPRB, 0.17365903E-05_JPRB, 0.17407206E-05_JPRB, 0.17439717E-05_JPRB, &
  & 0.17465526E-05_JPRB, 0.17486364E-05_JPRB, 0.17504179E-05_JPRB, 0.17519443E-05_JPRB, 0.17532334E-05_JPRB, 0.17542889E-05_JPRB, &
  & 0.17551365E-05_JPRB, 0.17558312E-05_JPRB, 0.17564053E-05_JPRB, 0.17568811E-05_JPRB, 0.17572280E-05_JPRB, 0.17573951E-05_JPRB, &
  & 0.17573511E-05_JPRB, 0.17570680E-05_JPRB, 0.17565624E-05_JPRB, 0.17558860E-05_JPRB, 0.17551122E-05_JPRB, 0.17543223E-05_JPRB, &
  & 0.17535775E-05_JPRB, 0.17529050E-05_JPRB, 0.17523265E-05_JPRB, 0.17518728E-05_JPRB, 0.17515868E-05_JPRB, 0.17515057E-05_JPRB, &
  & 0.17516206E-05_JPRB, 0.17518519E-05_JPRB, 0.17520478E-05_JPRB, 0.17520022E-05_JPRB, 0.17514345E-05_JPRB, 0.17500490E-05_JPRB, &
  & 0.17474988E-05_JPRB, 0.17438689E-05_JPRB, 0.17398891E-05_JPRB, 0.17363651E-05_JPRB, 0.17334789E-05_JPRB, 0.17310449E-05_JPRB, &
  & 0.17288045E-05_JPRB, 0.17266243E-05_JPRB, 0.17244184E-05_JPRB, 0.17223038E-05_JPRB, 0.17204251E-05_JPRB, 0.17188408E-05_JPRB, &
  & 0.17174591E-05_JPRB, 0.17161366E-05_JPRB, 0.17146224E-05_JPRB, 0.17119366E-05_JPRB /)

RGHG2(:,49, 4) = (/ &
  & 0.16903546E-05_JPRB, 0.16976214E-05_JPRB, 0.17024522E-05_JPRB, 0.17077616E-05_JPRB, 0.17134304E-05_JPRB, 0.17183755E-05_JPRB, &
  & 0.17216885E-05_JPRB, 0.17238438E-05_JPRB, 0.17253972E-05_JPRB, 0.17267103E-05_JPRB, 0.17280777E-05_JPRB, 0.17296907E-05_JPRB, &
  & 0.17319823E-05_JPRB, 0.17350143E-05_JPRB, 0.17385820E-05_JPRB, 0.17419402E-05_JPRB, 0.17446392E-05_JPRB, 0.17467335E-05_JPRB, &
  & 0.17484081E-05_JPRB, 0.17498633E-05_JPRB, 0.17511973E-05_JPRB, 0.17524491E-05_JPRB, 0.17535796E-05_JPRB, 0.17545585E-05_JPRB, &
  & 0.17553746E-05_JPRB, 0.17560587E-05_JPRB, 0.17566346E-05_JPRB, 0.17571161E-05_JPRB, 0.17574644E-05_JPRB, 0.17576301E-05_JPRB, &
  & 0.17575760E-05_JPRB, 0.17572780E-05_JPRB, 0.17567534E-05_JPRB, 0.17560537E-05_JPRB, 0.17552552E-05_JPRB, 0.17544509E-05_JPRB, &
  & 0.17537023E-05_JPRB, 0.17530483E-05_JPRB, 0.17525178E-05_JPRB, 0.17521526E-05_JPRB, 0.17520099E-05_JPRB, 0.17521320E-05_JPRB, &
  & 0.17524985E-05_JPRB, 0.17530233E-05_JPRB, 0.17535485E-05_JPRB, 0.17539113E-05_JPRB, 0.17539157E-05_JPRB, 0.17532999E-05_JPRB, &
  & 0.17517903E-05_JPRB, 0.17492960E-05_JPRB, 0.17463173E-05_JPRB, 0.17435709E-05_JPRB, 0.17411890E-05_JPRB, 0.17391160E-05_JPRB, &
  & 0.17371408E-05_JPRB, 0.17351525E-05_JPRB, 0.17331147E-05_JPRB, 0.17311352E-05_JPRB, 0.17293880E-05_JPRB, 0.17279183E-05_JPRB, &
  & 0.17266507E-05_JPRB, 0.17254353E-05_JPRB, 0.17240402E-05_JPRB, 0.17215817E-05_JPRB /)

RGHG2(:,50, 4) = (/ &
  & 0.17002184E-05_JPRB, 0.17077315E-05_JPRB, 0.17126282E-05_JPRB, 0.17180284E-05_JPRB, 0.17237546E-05_JPRB, 0.17285391E-05_JPRB, &
  & 0.17316424E-05_JPRB, 0.17335769E-05_JPRB, 0.17349198E-05_JPRB, 0.17360078E-05_JPRB, 0.17370630E-05_JPRB, 0.17383277E-05_JPRB, &
  & 0.17398652E-05_JPRB, 0.17419503E-05_JPRB, 0.17441454E-05_JPRB, 0.17461217E-05_JPRB, 0.17476625E-05_JPRB, 0.17488744E-05_JPRB, &
  & 0.17499010E-05_JPRB, 0.17508723E-05_JPRB, 0.17518613E-05_JPRB, 0.17528755E-05_JPRB, 0.17538786E-05_JPRB, 0.17547992E-05_JPRB, &
  & 0.17555969E-05_JPRB, 0.17562800E-05_JPRB, 0.17568620E-05_JPRB, 0.17573487E-05_JPRB, 0.17576987E-05_JPRB, 0.17578618E-05_JPRB, &
  & 0.17577968E-05_JPRB, 0.17574835E-05_JPRB, 0.17569378E-05_JPRB, 0.17562106E-05_JPRB, 0.17553891E-05_JPRB, 0.17545644E-05_JPRB, &
  & 0.17538124E-05_JPRB, 0.17531711E-05_JPRB, 0.17526819E-05_JPRB, 0.17523969E-05_JPRB, 0.17523865E-05_JPRB, 0.17526909E-05_JPRB, &
  & 0.17532699E-05_JPRB, 0.17539949E-05_JPRB, 0.17547457E-05_JPRB, 0.17553564E-05_JPRB, 0.17557235E-05_JPRB, 0.17556729E-05_JPRB, &
  & 0.17549881E-05_JPRB, 0.17535885E-05_JPRB, 0.17518392E-05_JPRB, 0.17500511E-05_JPRB, 0.17484497E-05_JPRB, 0.17468842E-05_JPRB, &
  & 0.17453315E-05_JPRB, 0.17436491E-05_JPRB, 0.17418540E-05_JPRB, 0.17400503E-05_JPRB, 0.17384380E-05_JPRB, 0.17370824E-05_JPRB, &
  & 0.17359038E-05_JPRB, 0.17347630E-05_JPRB, 0.17334627E-05_JPRB, 0.17311229E-05_JPRB /)

RGHG2(:,51, 4) = (/ &
  & 0.17098835E-05_JPRB, 0.17170265E-05_JPRB, 0.17225632E-05_JPRB, 0.17277321E-05_JPRB, 0.17335170E-05_JPRB, 0.17378856E-05_JPRB, &
  & 0.17405494E-05_JPRB, 0.17420957E-05_JPRB, 0.17430775E-05_JPRB, 0.17438286E-05_JPRB, 0.17445068E-05_JPRB, 0.17451989E-05_JPRB, &
  & 0.17461081E-05_JPRB, 0.17471015E-05_JPRB, 0.17482206E-05_JPRB, 0.17491586E-05_JPRB, 0.17499087E-05_JPRB, 0.17505236E-05_JPRB, &
  & 0.17511039E-05_JPRB, 0.17517234E-05_JPRB, 0.17524328E-05_JPRB, 0.17532568E-05_JPRB, 0.17541433E-05_JPRB, 0.17550224E-05_JPRB, &
  & 0.17558131E-05_JPRB, 0.17565044E-05_JPRB, 0.17570935E-05_JPRB, 0.17575853E-05_JPRB, 0.17579351E-05_JPRB, 0.17580937E-05_JPRB, &
  & 0.17580174E-05_JPRB, 0.17576867E-05_JPRB, 0.17571173E-05_JPRB, 0.17563614E-05_JPRB, 0.17555133E-05_JPRB, 0.17546697E-05_JPRB, &
  & 0.17539099E-05_JPRB, 0.17532775E-05_JPRB, 0.17528236E-05_JPRB, 0.17526129E-05_JPRB, 0.17527284E-05_JPRB, 0.17532017E-05_JPRB, &
  & 0.17539510E-05_JPRB, 0.17548447E-05_JPRB, 0.17557099E-05_JPRB, 0.17565019E-05_JPRB, 0.17570870E-05_JPRB, 0.17573982E-05_JPRB, &
  & 0.17572759E-05_JPRB, 0.17567078E-05_JPRB, 0.17558651E-05_JPRB, 0.17550177E-05_JPRB, 0.17541463E-05_JPRB, 0.17532797E-05_JPRB, &
  & 0.17522973E-05_JPRB, 0.17511619E-05_JPRB, 0.17498182E-05_JPRB, 0.17483833E-05_JPRB, 0.17470314E-05_JPRB, 0.17458524E-05_JPRB, &
  & 0.17448078E-05_JPRB, 0.17437842E-05_JPRB, 0.17425472E-05_JPRB, 0.17403821E-05_JPRB /)

RGHG2(:,52, 4) = (/ &
  & 0.17182725E-05_JPRB, 0.17266145E-05_JPRB, 0.17312183E-05_JPRB, 0.17369084E-05_JPRB, 0.17418032E-05_JPRB, 0.17454299E-05_JPRB, &
  & 0.17473366E-05_JPRB, 0.17483380E-05_JPRB, 0.17489338E-05_JPRB, 0.17493314E-05_JPRB, 0.17496536E-05_JPRB, 0.17499779E-05_JPRB, &
  & 0.17502905E-05_JPRB, 0.17506902E-05_JPRB, 0.17510500E-05_JPRB, 0.17513605E-05_JPRB, 0.17515993E-05_JPRB, 0.17518273E-05_JPRB, &
  & 0.17520961E-05_JPRB, 0.17524569E-05_JPRB, 0.17529511E-05_JPRB, 0.17536013E-05_JPRB, 0.17543950E-05_JPRB, 0.17552375E-05_JPRB, &
  & 0.17560295E-05_JPRB, 0.17567334E-05_JPRB, 0.17573336E-05_JPRB, 0.17578302E-05_JPRB, 0.17581775E-05_JPRB, 0.17583300E-05_JPRB, &
  & 0.17582404E-05_JPRB, 0.17578906E-05_JPRB, 0.17572956E-05_JPRB, 0.17565094E-05_JPRB, 0.17556340E-05_JPRB, 0.17547695E-05_JPRB, &
  & 0.17539994E-05_JPRB, 0.17533727E-05_JPRB, 0.17529503E-05_JPRB, 0.17528098E-05_JPRB, 0.17530423E-05_JPRB, 0.17536690E-05_JPRB, &
  & 0.17545708E-05_JPRB, 0.17555616E-05_JPRB, 0.17565615E-05_JPRB, 0.17574293E-05_JPRB, 0.17581901E-05_JPRB, 0.17587217E-05_JPRB, &
  & 0.17589484E-05_JPRB, 0.17588624E-05_JPRB, 0.17586037E-05_JPRB, 0.17582820E-05_JPRB, 0.17579507E-05_JPRB, 0.17575765E-05_JPRB, &
  & 0.17571302E-05_JPRB, 0.17565530E-05_JPRB, 0.17557991E-05_JPRB, 0.17548980E-05_JPRB, 0.17539833E-05_JPRB, 0.17531486E-05_JPRB, &
  & 0.17523676E-05_JPRB, 0.17515479E-05_JPRB, 0.17505595E-05_JPRB, 0.17485884E-05_JPRB /)

RGHG2(:,53, 4) = (/ &
  & 0.17269647E-05_JPRB, 0.17340229E-05_JPRB, 0.17397318E-05_JPRB, 0.17439647E-05_JPRB, 0.17482051E-05_JPRB, 0.17506359E-05_JPRB, &
  & 0.17518223E-05_JPRB, 0.17523878E-05_JPRB, 0.17526829E-05_JPRB, 0.17528652E-05_JPRB, 0.17529865E-05_JPRB, 0.17530670E-05_JPRB, &
  & 0.17531270E-05_JPRB, 0.17531434E-05_JPRB, 0.17531077E-05_JPRB, 0.17530275E-05_JPRB, 0.17529410E-05_JPRB, 0.17529003E-05_JPRB, &
  & 0.17529453E-05_JPRB, 0.17531088E-05_JPRB, 0.17534271E-05_JPRB, 0.17539419E-05_JPRB, 0.17546409E-05_JPRB, 0.17554548E-05_JPRB, &
  & 0.17562525E-05_JPRB, 0.17569701E-05_JPRB, 0.17575840E-05_JPRB, 0.17580844E-05_JPRB, 0.17584300E-05_JPRB, 0.17585731E-05_JPRB, &
  & 0.17584686E-05_JPRB, 0.17580974E-05_JPRB, 0.17574750E-05_JPRB, 0.17566571E-05_JPRB, 0.17557527E-05_JPRB, 0.17548659E-05_JPRB, &
  & 0.17540847E-05_JPRB, 0.17534628E-05_JPRB, 0.17530710E-05_JPRB, 0.17529962E-05_JPRB, 0.17533353E-05_JPRB, 0.17540887E-05_JPRB, &
  & 0.17551067E-05_JPRB, 0.17562237E-05_JPRB, 0.17572706E-05_JPRB, 0.17582706E-05_JPRB, 0.17591143E-05_JPRB, 0.17598086E-05_JPRB, &
  & 0.17602412E-05_JPRB, 0.17604129E-05_JPRB, 0.17604309E-05_JPRB, 0.17603847E-05_JPRB, 0.17603041E-05_JPRB, 0.17601935E-05_JPRB, &
  & 0.17600400E-05_JPRB, 0.17598087E-05_JPRB, 0.17594741E-05_JPRB, 0.17590316E-05_JPRB, 0.17585517E-05_JPRB, 0.17580815E-05_JPRB, &
  & 0.17576295E-05_JPRB, 0.17571385E-05_JPRB, 0.17564503E-05_JPRB, 0.17550731E-05_JPRB /)

RGHG2(:,54, 4) = (/ &
  & 0.17336934E-05_JPRB, 0.17418407E-05_JPRB, 0.17456548E-05_JPRB, 0.17497255E-05_JPRB, 0.17524510E-05_JPRB, 0.17540380E-05_JPRB, &
  & 0.17547042E-05_JPRB, 0.17549947E-05_JPRB, 0.17551329E-05_JPRB, 0.17551978E-05_JPRB, 0.17552195E-05_JPRB, 0.17551987E-05_JPRB, &
  & 0.17551305E-05_JPRB, 0.17549564E-05_JPRB, 0.17547113E-05_JPRB, 0.17543853E-05_JPRB, 0.17540735E-05_JPRB, 0.17538300E-05_JPRB, &
  & 0.17536966E-05_JPRB, 0.17537004E-05_JPRB, 0.17538792E-05_JPRB, 0.17542726E-05_JPRB, 0.17549030E-05_JPRB, 0.17556825E-05_JPRB, &
  & 0.17564839E-05_JPRB, 0.17572155E-05_JPRB, 0.17578442E-05_JPRB, 0.17583523E-05_JPRB, 0.17586933E-05_JPRB, 0.17588264E-05_JPRB, &
  & 0.17587050E-05_JPRB, 0.17583088E-05_JPRB, 0.17576582E-05_JPRB, 0.17568074E-05_JPRB, 0.17558734E-05_JPRB, 0.17549648E-05_JPRB, &
  & 0.17541703E-05_JPRB, 0.17535558E-05_JPRB, 0.17531961E-05_JPRB, 0.17531829E-05_JPRB, 0.17536064E-05_JPRB, 0.17544635E-05_JPRB, &
  & 0.17555884E-05_JPRB, 0.17567733E-05_JPRB, 0.17579496E-05_JPRB, 0.17589964E-05_JPRB, 0.17599687E-05_JPRB, 0.17607515E-05_JPRB, &
  & 0.17612913E-05_JPRB, 0.17615951E-05_JPRB, 0.17617331E-05_JPRB, 0.17618000E-05_JPRB, 0.17618274E-05_JPRB, 0.17618299E-05_JPRB, &
  & 0.17618047E-05_JPRB, 0.17617440E-05_JPRB, 0.17616258E-05_JPRB, 0.17614486E-05_JPRB, 0.17612365E-05_JPRB, 0.17610290E-05_JPRB, &
  & 0.17608205E-05_JPRB, 0.17605887E-05_JPRB, 0.17602881E-05_JPRB, 0.17596302E-05_JPRB /)

RGHG2(:,55, 4) = (/ &
  & 0.17405828E-05_JPRB, 0.17469627E-05_JPRB, 0.17509451E-05_JPRB, 0.17534480E-05_JPRB, 0.17553832E-05_JPRB, 0.17563009E-05_JPRB, &
  & 0.17566699E-05_JPRB, 0.17568138E-05_JPRB, 0.17568671E-05_JPRB, 0.17568776E-05_JPRB, 0.17568553E-05_JPRB, 0.17567977E-05_JPRB, &
  & 0.17566583E-05_JPRB, 0.17564435E-05_JPRB, 0.17560453E-05_JPRB, 0.17555764E-05_JPRB, 0.17550879E-05_JPRB, 0.17546738E-05_JPRB, &
  & 0.17543820E-05_JPRB, 0.17542469E-05_JPRB, 0.17543082E-05_JPRB, 0.17546141E-05_JPRB, 0.17551791E-05_JPRB, 0.17559335E-05_JPRB, &
  & 0.17567311E-05_JPRB, 0.17574741E-05_JPRB, 0.17581195E-05_JPRB, 0.17586328E-05_JPRB, 0.17589737E-05_JPRB, 0.17590934E-05_JPRB, &
  & 0.17589520E-05_JPRB, 0.17585292E-05_JPRB, 0.17578474E-05_JPRB, 0.17569661E-05_JPRB, 0.17559998E-05_JPRB, 0.17550701E-05_JPRB, &
  & 0.17542649E-05_JPRB, 0.17536595E-05_JPRB, 0.17533339E-05_JPRB, 0.17533770E-05_JPRB, 0.17538715E-05_JPRB, 0.17547984E-05_JPRB, &
  & 0.17559981E-05_JPRB, 0.17572919E-05_JPRB, 0.17585230E-05_JPRB, 0.17597008E-05_JPRB, 0.17607315E-05_JPRB, 0.17616035E-05_JPRB, &
  & 0.17622060E-05_JPRB, 0.17625434E-05_JPRB, 0.17627333E-05_JPRB, 0.17628424E-05_JPRB, 0.17629104E-05_JPRB, 0.17629586E-05_JPRB, &
  & 0.17629877E-05_JPRB, 0.17630002E-05_JPRB, 0.17629860E-05_JPRB, 0.17629401E-05_JPRB, 0.17628712E-05_JPRB, 0.17627908E-05_JPRB, &
  & 0.17627094E-05_JPRB, 0.17626089E-05_JPRB, 0.17624409E-05_JPRB, 0.17619924E-05_JPRB /)

RGHG2(:,56, 4) = (/ &
  & 0.17459818E-05_JPRB, 0.17518920E-05_JPRB, 0.17543496E-05_JPRB, 0.17562379E-05_JPRB, 0.17573972E-05_JPRB, 0.17579455E-05_JPRB, &
  & 0.17581466E-05_JPRB, 0.17582107E-05_JPRB, 0.17582241E-05_JPRB, 0.17582108E-05_JPRB, 0.17581735E-05_JPRB, 0.17580952E-05_JPRB, &
  & 0.17579669E-05_JPRB, 0.17576795E-05_JPRB, 0.17572688E-05_JPRB, 0.17566744E-05_JPRB, 0.17560444E-05_JPRB, 0.17554688E-05_JPRB, &
  & 0.17550270E-05_JPRB, 0.17547636E-05_JPRB, 0.17547266E-05_JPRB, 0.17549621E-05_JPRB, 0.17554845E-05_JPRB, 0.17562097E-05_JPRB, &
  & 0.17570012E-05_JPRB, 0.17577536E-05_JPRB, 0.17584127E-05_JPRB, 0.17589369E-05_JPRB, 0.17592730E-05_JPRB, 0.17593787E-05_JPRB, &
  & 0.17592163E-05_JPRB, 0.17587635E-05_JPRB, 0.17580491E-05_JPRB, 0.17571358E-05_JPRB, 0.17561401E-05_JPRB, 0.17551886E-05_JPRB, &
  & 0.17543750E-05_JPRB, 0.17537828E-05_JPRB, 0.17534925E-05_JPRB, 0.17535878E-05_JPRB, 0.17541353E-05_JPRB, 0.17551187E-05_JPRB, &
  & 0.17563802E-05_JPRB, 0.17577372E-05_JPRB, 0.17590816E-05_JPRB, 0.17603204E-05_JPRB, 0.17614612E-05_JPRB, 0.17623825E-05_JPRB, &
  & 0.17629986E-05_JPRB, 0.17633638E-05_JPRB, 0.17635605E-05_JPRB, 0.17636828E-05_JPRB, 0.17637676E-05_JPRB, 0.17638299E-05_JPRB, &
  & 0.17638829E-05_JPRB, 0.17639254E-05_JPRB, 0.17639575E-05_JPRB, 0.17639743E-05_JPRB, 0.17639736E-05_JPRB, 0.17639634E-05_JPRB, &
  & 0.17639497E-05_JPRB, 0.17639336E-05_JPRB, 0.17639144E-05_JPRB, 0.17638957E-05_JPRB /)

RGHG2(:,57, 4) = (/ &
  & 0.17506846E-05_JPRB, 0.17551566E-05_JPRB, 0.17570337E-05_JPRB, 0.17582109E-05_JPRB, 0.17589234E-05_JPRB, 0.17592515E-05_JPRB, &
  & 0.17593566E-05_JPRB, 0.17593831E-05_JPRB, 0.17593777E-05_JPRB, 0.17593543E-05_JPRB, 0.17593113E-05_JPRB, 0.17592405E-05_JPRB, &
  & 0.17590909E-05_JPRB, 0.17588527E-05_JPRB, 0.17583739E-05_JPRB, 0.17577300E-05_JPRB, 0.17569686E-05_JPRB, 0.17562406E-05_JPRB, &
  & 0.17556488E-05_JPRB, 0.17552687E-05_JPRB, 0.17551499E-05_JPRB, 0.17553343E-05_JPRB, 0.17558192E-05_JPRB, 0.17565210E-05_JPRB, &
  & 0.17573037E-05_JPRB, 0.17580635E-05_JPRB, 0.17587386E-05_JPRB, 0.17592686E-05_JPRB, 0.17596017E-05_JPRB, 0.17596901E-05_JPRB, &
  & 0.17595033E-05_JPRB, 0.17590202E-05_JPRB, 0.17582704E-05_JPRB, 0.17573251E-05_JPRB, 0.17562994E-05_JPRB, 0.17553282E-05_JPRB, &
  & 0.17545119E-05_JPRB, 0.17539340E-05_JPRB, 0.17536797E-05_JPRB, 0.17538218E-05_JPRB, 0.17544174E-05_JPRB, 0.17554393E-05_JPRB, &
  & 0.17567490E-05_JPRB, 0.17581708E-05_JPRB, 0.17595773E-05_JPRB, 0.17609156E-05_JPRB, 0.17621118E-05_JPRB, 0.17630839E-05_JPRB, &
  & 0.17637303E-05_JPRB, 0.17640796E-05_JPRB, 0.17642865E-05_JPRB, 0.17644121E-05_JPRB, 0.17644984E-05_JPRB, 0.17645687E-05_JPRB, &
  & 0.17646262E-05_JPRB, 0.17646812E-05_JPRB, 0.17647305E-05_JPRB, 0.17647726E-05_JPRB, 0.17647999E-05_JPRB, 0.17648154E-05_JPRB, &
  & 0.17648227E-05_JPRB, 0.17648224E-05_JPRB, 0.17648086E-05_JPRB, 0.17647520E-05_JPRB /)

RGHG2(:,58, 4) = (/ &
  & 0.17552985E-05_JPRB, 0.17578941E-05_JPRB, 0.17590331E-05_JPRB, 0.17597276E-05_JPRB, 0.17601810E-05_JPRB, 0.17603679E-05_JPRB, &
  & 0.17604264E-05_JPRB, 0.17604324E-05_JPRB, 0.17604191E-05_JPRB, 0.17603941E-05_JPRB, 0.17603536E-05_JPRB, 0.17602808E-05_JPRB, &
  & 0.17601616E-05_JPRB, 0.17598910E-05_JPRB, 0.17594571E-05_JPRB, 0.17587413E-05_JPRB, 0.17578726E-05_JPRB, 0.17569971E-05_JPRB, &
  & 0.17562717E-05_JPRB, 0.17557838E-05_JPRB, 0.17555982E-05_JPRB, 0.17557406E-05_JPRB, 0.17561949E-05_JPRB, 0.17568744E-05_JPRB, &
  & 0.17576500E-05_JPRB, 0.17584182E-05_JPRB, 0.17591030E-05_JPRB, 0.17596408E-05_JPRB, 0.17599668E-05_JPRB, 0.17600358E-05_JPRB, &
  & 0.17598229E-05_JPRB, 0.17593088E-05_JPRB, 0.17585212E-05_JPRB, 0.17575412E-05_JPRB, 0.17564886E-05_JPRB, 0.17555003E-05_JPRB, &
  & 0.17546837E-05_JPRB, 0.17541258E-05_JPRB, 0.17539049E-05_JPRB, 0.17540890E-05_JPRB, 0.17547228E-05_JPRB, 0.17557817E-05_JPRB, &
  & 0.17571265E-05_JPRB, 0.17585962E-05_JPRB, 0.17600612E-05_JPRB, 0.17614484E-05_JPRB, 0.17627151E-05_JPRB, 0.17637274E-05_JPRB, &
  & 0.17643705E-05_JPRB, 0.17647466E-05_JPRB, 0.17649479E-05_JPRB, 0.17650757E-05_JPRB, 0.17651657E-05_JPRB, 0.17652337E-05_JPRB, &
  & 0.17652949E-05_JPRB, 0.17653506E-05_JPRB, 0.17654040E-05_JPRB, 0.17654527E-05_JPRB, 0.17654893E-05_JPRB, 0.17655111E-05_JPRB, &
  & 0.17655257E-05_JPRB, 0.17655316E-05_JPRB, 0.17655237E-05_JPRB, 0.17654731E-05_JPRB /)

RGHG2(:,59, 4) = (/ &
  & 0.17580310E-05_JPRB, 0.17598295E-05_JPRB, 0.17605239E-05_JPRB, 0.17609982E-05_JPRB, 0.17612617E-05_JPRB, 0.17613852E-05_JPRB, &
  & 0.17614161E-05_JPRB, 0.17614141E-05_JPRB, 0.17613999E-05_JPRB, 0.17613756E-05_JPRB, 0.17613381E-05_JPRB, 0.17612773E-05_JPRB, &
  & 0.17611505E-05_JPRB, 0.17609302E-05_JPRB, 0.17604546E-05_JPRB, 0.17597216E-05_JPRB, 0.17587531E-05_JPRB, 0.17577534E-05_JPRB, &
  & 0.17569052E-05_JPRB, 0.17563336E-05_JPRB, 0.17560889E-05_JPRB, 0.17561938E-05_JPRB, 0.17566190E-05_JPRB, 0.17572796E-05_JPRB, &
  & 0.17580517E-05_JPRB, 0.17588246E-05_JPRB, 0.17595194E-05_JPRB, 0.17600594E-05_JPRB, 0.17603777E-05_JPRB, 0.17604270E-05_JPRB, &
  & 0.17601857E-05_JPRB, 0.17596394E-05_JPRB, 0.17588136E-05_JPRB, 0.17577970E-05_JPRB, 0.17567189E-05_JPRB, 0.17557164E-05_JPRB, &
  & 0.17549065E-05_JPRB, 0.17543671E-05_JPRB, 0.17541774E-05_JPRB, 0.17543965E-05_JPRB, 0.17550630E-05_JPRB, 0.17561489E-05_JPRB, &
  & 0.17575246E-05_JPRB, 0.17590297E-05_JPRB, 0.17605327E-05_JPRB, 0.17619641E-05_JPRB, 0.17632543E-05_JPRB, 0.17642950E-05_JPRB, &
  & 0.17649834E-05_JPRB, 0.17653545E-05_JPRB, 0.17655731E-05_JPRB, 0.17657042E-05_JPRB, 0.17657929E-05_JPRB, 0.17658638E-05_JPRB, &
  & 0.17659213E-05_JPRB, 0.17659758E-05_JPRB, 0.17660261E-05_JPRB, 0.17660720E-05_JPRB, 0.17661059E-05_JPRB, 0.17661284E-05_JPRB, &
  & 0.17661417E-05_JPRB, 0.17661462E-05_JPRB, 0.17661348E-05_JPRB, 0.17660724E-05_JPRB /)

RGHG2(:,60, 4) = (/ &
  & 0.17603686E-05_JPRB, 0.17613455E-05_JPRB, 0.17618027E-05_JPRB, 0.17620793E-05_JPRB, 0.17622680E-05_JPRB, 0.17623461E-05_JPRB, &
  & 0.17623672E-05_JPRB, 0.17623636E-05_JPRB, 0.17623502E-05_JPRB, 0.17623299E-05_JPRB, 0.17622978E-05_JPRB, 0.17622390E-05_JPRB, &
  & 0.17621348E-05_JPRB, 0.17618911E-05_JPRB, 0.17614517E-05_JPRB, 0.17606610E-05_JPRB, 0.17596125E-05_JPRB, 0.17585103E-05_JPRB, &
  & 0.17575744E-05_JPRB, 0.17569284E-05_JPRB, 0.17566349E-05_JPRB, 0.17567036E-05_JPRB, 0.17571041E-05_JPRB, 0.17577480E-05_JPRB, &
  & 0.17585152E-05_JPRB, 0.17592935E-05_JPRB, 0.17599917E-05_JPRB, 0.17605313E-05_JPRB, 0.17608407E-05_JPRB, 0.17608709E-05_JPRB, &
  & 0.17606019E-05_JPRB, 0.17600228E-05_JPRB, 0.17591614E-05_JPRB, 0.17581053E-05_JPRB, 0.17570044E-05_JPRB, 0.17559923E-05_JPRB, &
  & 0.17551897E-05_JPRB, 0.17546712E-05_JPRB, 0.17545079E-05_JPRB, 0.17547543E-05_JPRB, 0.17554451E-05_JPRB, 0.17565508E-05_JPRB, &
  & 0.17579503E-05_JPRB, 0.17594801E-05_JPRB, 0.17610121E-05_JPRB, 0.17624581E-05_JPRB, 0.17637676E-05_JPRB, 0.17648294E-05_JPRB, &
  & 0.17655307E-05_JPRB, 0.17659478E-05_JPRB, 0.17661730E-05_JPRB, 0.17663117E-05_JPRB, 0.17664059E-05_JPRB, 0.17664734E-05_JPRB, &
  & 0.17665305E-05_JPRB, 0.17665793E-05_JPRB, 0.17666231E-05_JPRB, 0.17666607E-05_JPRB, 0.17666885E-05_JPRB, 0.17667043E-05_JPRB, &
  & 0.17667141E-05_JPRB, 0.17667155E-05_JPRB, 0.17667014E-05_JPRB, 0.17666345E-05_JPRB /)

RGHG2(:,61, 4) = (/ &
  & 0.17617878E-05_JPRB, 0.17625462E-05_JPRB, 0.17628624E-05_JPRB, 0.17630804E-05_JPRB, 0.17632125E-05_JPRB, 0.17632790E-05_JPRB, &
  & 0.17632979E-05_JPRB, 0.17632970E-05_JPRB, 0.17632881E-05_JPRB, 0.17632721E-05_JPRB, 0.17632450E-05_JPRB, 0.17631958E-05_JPRB, &
  & 0.17630878E-05_JPRB, 0.17628713E-05_JPRB, 0.17623886E-05_JPRB, 0.17615723E-05_JPRB, 0.17604616E-05_JPRB, 0.17592889E-05_JPRB, &
  & 0.17582836E-05_JPRB, 0.17575825E-05_JPRB, 0.17572445E-05_JPRB, 0.17572812E-05_JPRB, 0.17576585E-05_JPRB, 0.17582889E-05_JPRB, &
  & 0.17590517E-05_JPRB, 0.17598295E-05_JPRB, 0.17605280E-05_JPRB, 0.17610635E-05_JPRB, 0.17613629E-05_JPRB, 0.17613762E-05_JPRB, &
  & 0.17610823E-05_JPRB, 0.17604738E-05_JPRB, 0.17595770E-05_JPRB, 0.17584874E-05_JPRB, 0.17573607E-05_JPRB, 0.17563457E-05_JPRB, &
  & 0.17555502E-05_JPRB, 0.17550500E-05_JPRB, 0.17549094E-05_JPRB, 0.17551764E-05_JPRB, 0.17558812E-05_JPRB, 0.17569999E-05_JPRB, &
  & 0.17584099E-05_JPRB, 0.17599575E-05_JPRB, 0.17615049E-05_JPRB, 0.17629616E-05_JPRB, 0.17642652E-05_JPRB, 0.17653281E-05_JPRB, &
  & 0.17660752E-05_JPRB, 0.17665097E-05_JPRB, 0.17667653E-05_JPRB, 0.17669142E-05_JPRB, 0.17670088E-05_JPRB, 0.17670777E-05_JPRB, &
  & 0.17671291E-05_JPRB, 0.17671716E-05_JPRB, 0.17672061E-05_JPRB, 0.17672335E-05_JPRB, 0.17672511E-05_JPRB, 0.17672601E-05_JPRB, &
  & 0.17672635E-05_JPRB, 0.17672585E-05_JPRB, 0.17672356E-05_JPRB, 0.17671510E-05_JPRB /)

RGHG2(:,62, 4) = (/ &
  & 0.17630413E-05_JPRB, 0.17635998E-05_JPRB, 0.17638552E-05_JPRB, 0.17640207E-05_JPRB, 0.17641383E-05_JPRB, 0.17641992E-05_JPRB, &
  & 0.17642235E-05_JPRB, 0.17642291E-05_JPRB, 0.17642262E-05_JPRB, 0.17642169E-05_JPRB, 0.17641968E-05_JPRB, 0.17641528E-05_JPRB, &
  & 0.17640562E-05_JPRB, 0.17638190E-05_JPRB, 0.17633298E-05_JPRB, 0.17624670E-05_JPRB, 0.17613105E-05_JPRB, 0.17600996E-05_JPRB, &
  & 0.17590476E-05_JPRB, 0.17583018E-05_JPRB, 0.17579273E-05_JPRB, 0.17579376E-05_JPRB, 0.17582964E-05_JPRB, 0.17589132E-05_JPRB, &
  & 0.17596692E-05_JPRB, 0.17604436E-05_JPRB, 0.17611382E-05_JPRB, 0.17616654E-05_JPRB, 0.17619546E-05_JPRB, 0.17619536E-05_JPRB, &
  & 0.17616401E-05_JPRB, 0.17610054E-05_JPRB, 0.17600813E-05_JPRB, 0.17589593E-05_JPRB, 0.17578122E-05_JPRB, 0.17567924E-05_JPRB, &
  & 0.17560051E-05_JPRB, 0.17555205E-05_JPRB, 0.17553962E-05_JPRB, 0.17556754E-05_JPRB, 0.17563877E-05_JPRB, 0.17575065E-05_JPRB, &
  & 0.17589206E-05_JPRB, 0.17604714E-05_JPRB, 0.17620271E-05_JPRB, 0.17634834E-05_JPRB, 0.17647768E-05_JPRB, 0.17658369E-05_JPRB, &
  & 0.17665936E-05_JPRB, 0.17670784E-05_JPRB, 0.17673519E-05_JPRB, 0.17675148E-05_JPRB, 0.17676152E-05_JPRB, 0.17676805E-05_JPRB, &
  & 0.17677266E-05_JPRB, 0.17677604E-05_JPRB, 0.17677826E-05_JPRB, 0.17677979E-05_JPRB, 0.17678053E-05_JPRB, 0.17678057E-05_JPRB, &
  & 0.17678026E-05_JPRB, 0.17677912E-05_JPRB, 0.17677594E-05_JPRB, 0.17676522E-05_JPRB /)

RGHG2(:,63, 4) = (/ &
  & 0.17640945E-05_JPRB, 0.17645716E-05_JPRB, 0.17647872E-05_JPRB, 0.17649394E-05_JPRB, 0.17650480E-05_JPRB, 0.17651168E-05_JPRB, &
  & 0.17651498E-05_JPRB, 0.17651653E-05_JPRB, 0.17651716E-05_JPRB, 0.17651715E-05_JPRB, 0.17651607E-05_JPRB, 0.17651257E-05_JPRB, &
  & 0.17650287E-05_JPRB, 0.17647875E-05_JPRB, 0.17642551E-05_JPRB, 0.17633582E-05_JPRB, 0.17621885E-05_JPRB, 0.17609547E-05_JPRB, &
  & 0.17598759E-05_JPRB, 0.17590970E-05_JPRB, 0.17586942E-05_JPRB, 0.17586851E-05_JPRB, 0.17590293E-05_JPRB, 0.17596342E-05_JPRB, &
  & 0.17603808E-05_JPRB, 0.17611479E-05_JPRB, 0.17618322E-05_JPRB, 0.17623504E-05_JPRB, 0.17626271E-05_JPRB, 0.17626135E-05_JPRB, &
  & 0.17622860E-05_JPRB, 0.17616348E-05_JPRB, 0.17606878E-05_JPRB, 0.17595448E-05_JPRB, 0.17583781E-05_JPRB, 0.17573569E-05_JPRB, &
  & 0.17565742E-05_JPRB, 0.17561016E-05_JPRB, 0.17559870E-05_JPRB, 0.17562713E-05_JPRB, 0.17569807E-05_JPRB, 0.17580921E-05_JPRB, &
  & 0.17594928E-05_JPRB, 0.17610370E-05_JPRB, 0.17625882E-05_JPRB, 0.17640378E-05_JPRB, 0.17653182E-05_JPRB, 0.17663640E-05_JPRB, &
  & 0.17671380E-05_JPRB, 0.17676402E-05_JPRB, 0.17679473E-05_JPRB, 0.17681210E-05_JPRB, 0.17682256E-05_JPRB, 0.17682876E-05_JPRB, &
  & 0.17683270E-05_JPRB, 0.17683494E-05_JPRB, 0.17683589E-05_JPRB, 0.17683617E-05_JPRB, 0.17683587E-05_JPRB, 0.17683503E-05_JPRB, &
  & 0.17683408E-05_JPRB, 0.17683212E-05_JPRB, 0.17682755E-05_JPRB, 0.17681360E-05_JPRB /)

RGHG2(:,64, 4) = (/ &
  & 0.17650423E-05_JPRB, 0.17654768E-05_JPRB, 0.17656839E-05_JPRB, 0.17658308E-05_JPRB, 0.17659465E-05_JPRB, 0.17660242E-05_JPRB, &
  & 0.17660730E-05_JPRB, 0.17661002E-05_JPRB, 0.17661198E-05_JPRB, 0.17661320E-05_JPRB, 0.17661341E-05_JPRB, 0.17661108E-05_JPRB, &
  & 0.17660172E-05_JPRB, 0.17657500E-05_JPRB, 0.17651851E-05_JPRB, 0.17642678E-05_JPRB, 0.17630973E-05_JPRB, 0.17618644E-05_JPRB, &
  & 0.17607713E-05_JPRB, 0.17599707E-05_JPRB, 0.17595510E-05_JPRB, 0.17595291E-05_JPRB, 0.17598618E-05_JPRB, 0.17604555E-05_JPRB, &
  & 0.17611892E-05_JPRB, 0.17619428E-05_JPRB, 0.17626139E-05_JPRB, 0.17631158E-05_JPRB, 0.17633796E-05_JPRB, 0.17633545E-05_JPRB, &
  & 0.17630193E-05_JPRB, 0.17623598E-05_JPRB, 0.17614026E-05_JPRB, 0.17602467E-05_JPRB, 0.17590726E-05_JPRB, 0.17580498E-05_JPRB, &
  & 0.17572726E-05_JPRB, 0.17568075E-05_JPRB, 0.17566961E-05_JPRB, 0.17569772E-05_JPRB, 0.17576751E-05_JPRB, 0.17587658E-05_JPRB, &
  & 0.17601428E-05_JPRB, 0.17616632E-05_JPRB, 0.17631992E-05_JPRB, 0.17646332E-05_JPRB, 0.17658955E-05_JPRB, 0.17669287E-05_JPRB, &
  & 0.17676994E-05_JPRB, 0.17682247E-05_JPRB, 0.17685446E-05_JPRB, 0.17687338E-05_JPRB, 0.17688390E-05_JPRB, 0.17688999E-05_JPRB, &
  & 0.17689301E-05_JPRB, 0.17689422E-05_JPRB, 0.17689379E-05_JPRB, 0.17689292E-05_JPRB, 0.17689165E-05_JPRB, 0.17689002E-05_JPRB, &
  & 0.17688834E-05_JPRB, 0.17688551E-05_JPRB, 0.17687928E-05_JPRB, 0.17686009E-05_JPRB /)

RGHG2(:,65, 4) = (/ &
  & 0.17658790E-05_JPRB, 0.17663301E-05_JPRB, 0.17665441E-05_JPRB, 0.17667039E-05_JPRB, 0.17668294E-05_JPRB, 0.17669240E-05_JPRB, &
  & 0.17669856E-05_JPRB, 0.17670311E-05_JPRB, 0.17670645E-05_JPRB, 0.17670959E-05_JPRB, 0.17671155E-05_JPRB, 0.17671064E-05_JPRB, &
  & 0.17670108E-05_JPRB, 0.17667187E-05_JPRB, 0.17661215E-05_JPRB, 0.17652084E-05_JPRB, 0.17640513E-05_JPRB, 0.17628303E-05_JPRB, &
  & 0.17617372E-05_JPRB, 0.17609302E-05_JPRB, 0.17605009E-05_JPRB, 0.17604726E-05_JPRB, 0.17607970E-05_JPRB, 0.17613755E-05_JPRB, &
  & 0.17620916E-05_JPRB, 0.17628247E-05_JPRB, 0.17634712E-05_JPRB, 0.17639527E-05_JPRB, 0.17641978E-05_JPRB, 0.17641627E-05_JPRB, &
  & 0.17638247E-05_JPRB, 0.17631685E-05_JPRB, 0.17622132E-05_JPRB, 0.17610606E-05_JPRB, 0.17598901E-05_JPRB, 0.17588748E-05_JPRB, &
  & 0.17581060E-05_JPRB, 0.17576469E-05_JPRB, 0.17575346E-05_JPRB, 0.17578050E-05_JPRB, 0.17584827E-05_JPRB, 0.17595421E-05_JPRB, &
  & 0.17608793E-05_JPRB, 0.17623634E-05_JPRB, 0.17638682E-05_JPRB, 0.17652774E-05_JPRB, 0.17665152E-05_JPRB, 0.17675293E-05_JPRB, &
  & 0.17682966E-05_JPRB, 0.17688261E-05_JPRB, 0.17691591E-05_JPRB, 0.17693512E-05_JPRB, 0.17694611E-05_JPRB, 0.17695171E-05_JPRB, &
  & 0.17695418E-05_JPRB, 0.17695422E-05_JPRB, 0.17695254E-05_JPRB, 0.17695068E-05_JPRB, 0.17694856E-05_JPRB, 0.17694601E-05_JPRB, &
  & 0.17694383E-05_JPRB, 0.17693991E-05_JPRB, 0.17693130E-05_JPRB, 0.17690538E-05_JPRB /)

RGHG2(:,66, 4) = (/ &
  & 0.17666383E-05_JPRB, 0.17671343E-05_JPRB, 0.17673810E-05_JPRB, 0.17675598E-05_JPRB, 0.17677055E-05_JPRB, 0.17678155E-05_JPRB, &
  & 0.17678966E-05_JPRB, 0.17679547E-05_JPRB, 0.17680104E-05_JPRB, 0.17680595E-05_JPRB, 0.17681018E-05_JPRB, 0.17681056E-05_JPRB, &
  & 0.17680020E-05_JPRB, 0.17676838E-05_JPRB, 0.17670841E-05_JPRB, 0.17661798E-05_JPRB, 0.17650515E-05_JPRB, 0.17638542E-05_JPRB, &
  & 0.17627776E-05_JPRB, 0.17619735E-05_JPRB, 0.17615478E-05_JPRB, 0.17615155E-05_JPRB, 0.17618289E-05_JPRB, 0.17623896E-05_JPRB, &
  & 0.17630773E-05_JPRB, 0.17637794E-05_JPRB, 0.17643931E-05_JPRB, 0.17648433E-05_JPRB, 0.17650668E-05_JPRB, 0.17650201E-05_JPRB, &
  & 0.17646846E-05_JPRB, 0.17640406E-05_JPRB, 0.17631037E-05_JPRB, 0.17619682E-05_JPRB, 0.17608198E-05_JPRB, 0.17598221E-05_JPRB, &
  & 0.17590714E-05_JPRB, 0.17586203E-05_JPRB, 0.17585069E-05_JPRB, 0.17587623E-05_JPRB, 0.17594114E-05_JPRB, 0.17604279E-05_JPRB, &
  & 0.17617155E-05_JPRB, 0.17631446E-05_JPRB, 0.17646066E-05_JPRB, 0.17659758E-05_JPRB, 0.17671814E-05_JPRB, 0.17681710E-05_JPRB, &
  & 0.17689259E-05_JPRB, 0.17694560E-05_JPRB, 0.17697904E-05_JPRB, 0.17699857E-05_JPRB, 0.17700936E-05_JPRB, 0.17701476E-05_JPRB, &
  & 0.17701650E-05_JPRB, 0.17701557E-05_JPRB, 0.17701284E-05_JPRB, 0.17701004E-05_JPRB, 0.17700717E-05_JPRB, 0.17700388E-05_JPRB, &
  & 0.17700110E-05_JPRB, 0.17699628E-05_JPRB, 0.17698517E-05_JPRB, 0.17695079E-05_JPRB /)

RGHG2(:,67, 4) = (/ &
  & 0.17673389E-05_JPRB, 0.17679247E-05_JPRB, 0.17682028E-05_JPRB, 0.17684144E-05_JPRB, 0.17685828E-05_JPRB, 0.17687119E-05_JPRB, &
  & 0.17688079E-05_JPRB, 0.17688856E-05_JPRB, 0.17689547E-05_JPRB, 0.17690304E-05_JPRB, 0.17690874E-05_JPRB, 0.17690974E-05_JPRB, &
  & 0.17689838E-05_JPRB, 0.17686580E-05_JPRB, 0.17680624E-05_JPRB, 0.17671865E-05_JPRB, 0.17660943E-05_JPRB, 0.17649363E-05_JPRB, &
  & 0.17638876E-05_JPRB, 0.17631050E-05_JPRB, 0.17626858E-05_JPRB, 0.17626523E-05_JPRB, 0.17629517E-05_JPRB, 0.17634826E-05_JPRB, &
  & 0.17641348E-05_JPRB, 0.17647926E-05_JPRB, 0.17653635E-05_JPRB, 0.17657768E-05_JPRB, 0.17659738E-05_JPRB, 0.17659163E-05_JPRB, &
  & 0.17655867E-05_JPRB, 0.17649648E-05_JPRB, 0.17640564E-05_JPRB, 0.17629575E-05_JPRB, 0.17618422E-05_JPRB, 0.17608809E-05_JPRB, &
  & 0.17601558E-05_JPRB, 0.17597210E-05_JPRB, 0.17596083E-05_JPRB, 0.17598479E-05_JPRB, 0.17604624E-05_JPRB, 0.17614296E-05_JPRB, &
  & 0.17626527E-05_JPRB, 0.17640194E-05_JPRB, 0.17654178E-05_JPRB, 0.17667389E-05_JPRB, 0.17679004E-05_JPRB, 0.17688570E-05_JPRB, &
  & 0.17695929E-05_JPRB, 0.17701134E-05_JPRB, 0.17704450E-05_JPRB, 0.17706381E-05_JPRB, 0.17707436E-05_JPRB, 0.17707930E-05_JPRB, &
  & 0.17708044E-05_JPRB, 0.17707866E-05_JPRB, 0.17707513E-05_JPRB, 0.17707160E-05_JPRB, 0.17706807E-05_JPRB, 0.17706384E-05_JPRB, &
  & 0.17706094E-05_JPRB, 0.17705513E-05_JPRB, 0.17704136E-05_JPRB, 0.17699834E-05_JPRB /)

RGHG2(:,68, 4) = (/ &
  & 0.17680316E-05_JPRB, 0.17686939E-05_JPRB, 0.17690344E-05_JPRB, 0.17692739E-05_JPRB, 0.17694697E-05_JPRB, 0.17696185E-05_JPRB, &
  & 0.17697296E-05_JPRB, 0.17698213E-05_JPRB, 0.17699107E-05_JPRB, 0.17700000E-05_JPRB, 0.17700692E-05_JPRB, 0.17700773E-05_JPRB, &
  & 0.17699583E-05_JPRB, 0.17696343E-05_JPRB, 0.17690567E-05_JPRB, 0.17682175E-05_JPRB, 0.17671772E-05_JPRB, 0.17660715E-05_JPRB, &
  & 0.17650676E-05_JPRB, 0.17643130E-05_JPRB, 0.17639098E-05_JPRB, 0.17638713E-05_JPRB, 0.17641471E-05_JPRB, 0.17646419E-05_JPRB, &
  & 0.17652446E-05_JPRB, 0.17658524E-05_JPRB, 0.17663729E-05_JPRB, 0.17667442E-05_JPRB, 0.17669139E-05_JPRB, 0.17668467E-05_JPRB, &
  & 0.17665279E-05_JPRB, 0.17659341E-05_JPRB, 0.17650679E-05_JPRB, 0.17640125E-05_JPRB, 0.17629509E-05_JPRB, 0.17620330E-05_JPRB, &
  & 0.17613479E-05_JPRB, 0.17609344E-05_JPRB, 0.17608290E-05_JPRB, 0.17610532E-05_JPRB, 0.17616326E-05_JPRB, 0.17625410E-05_JPRB, &
  & 0.17636972E-05_JPRB, 0.17649827E-05_JPRB, 0.17663144E-05_JPRB, 0.17675687E-05_JPRB, 0.17686763E-05_JPRB, 0.17695914E-05_JPRB, &
  & 0.17702972E-05_JPRB, 0.17708026E-05_JPRB, 0.17711251E-05_JPRB, 0.17713127E-05_JPRB, 0.17714135E-05_JPRB, 0.17714585E-05_JPRB, &
  & 0.17714640E-05_JPRB, 0.17714395E-05_JPRB, 0.17713987E-05_JPRB, 0.17713578E-05_JPRB, 0.17713173E-05_JPRB, 0.17712682E-05_JPRB, &
  & 0.17712379E-05_JPRB, 0.17711756E-05_JPRB, 0.17710164E-05_JPRB, 0.17705134E-05_JPRB /)

RGHG2(:,69, 4) = (/ &
  & 0.17686752E-05_JPRB, 0.17694952E-05_JPRB, 0.17698712E-05_JPRB, 0.17701583E-05_JPRB, 0.17703745E-05_JPRB, 0.17705397E-05_JPRB, &
  & 0.17706666E-05_JPRB, 0.17707710E-05_JPRB, 0.17708728E-05_JPRB, 0.17709742E-05_JPRB, 0.17710450E-05_JPRB, 0.17710504E-05_JPRB, &
  & 0.17709302E-05_JPRB, 0.17706160E-05_JPRB, 0.17700640E-05_JPRB, 0.17692729E-05_JPRB, 0.17682951E-05_JPRB, 0.17672552E-05_JPRB, &
  & 0.17663069E-05_JPRB, 0.17655924E-05_JPRB, 0.17652037E-05_JPRB, 0.17651575E-05_JPRB, 0.17654040E-05_JPRB, 0.17658508E-05_JPRB, &
  & 0.17663997E-05_JPRB, 0.17669500E-05_JPRB, 0.17674172E-05_JPRB, 0.17677455E-05_JPRB, 0.17678880E-05_JPRB, 0.17678128E-05_JPRB, &
  & 0.17675092E-05_JPRB, 0.17669514E-05_JPRB, 0.17661334E-05_JPRB, 0.17651387E-05_JPRB, 0.17641337E-05_JPRB, 0.17632766E-05_JPRB, &
  & 0.17626338E-05_JPRB, 0.17622511E-05_JPRB, 0.17621559E-05_JPRB, 0.17623688E-05_JPRB, 0.17629100E-05_JPRB, 0.17637615E-05_JPRB, &
  & 0.17648382E-05_JPRB, 0.17660467E-05_JPRB, 0.17672896E-05_JPRB, 0.17684729E-05_JPRB, 0.17695132E-05_JPRB, 0.17703751E-05_JPRB, &
  & 0.17710444E-05_JPRB, 0.17715254E-05_JPRB, 0.17718334E-05_JPRB, 0.17720120E-05_JPRB, 0.17721065E-05_JPRB, 0.17721467E-05_JPRB, &
  & 0.17721479E-05_JPRB, 0.17721190E-05_JPRB, 0.17720756E-05_JPRB, 0.17720325E-05_JPRB, 0.17719893E-05_JPRB, 0.17719352E-05_JPRB, &
  & 0.17719077E-05_JPRB, 0.17718413E-05_JPRB, 0.17716653E-05_JPRB, 0.17710973E-05_JPRB /)

RGHG2(:,70, 4) = (/ &
  & 0.17693447E-05_JPRB, 0.17702828E-05_JPRB, 0.17707559E-05_JPRB, 0.17710649E-05_JPRB, 0.17713077E-05_JPRB, 0.17714838E-05_JPRB, &
  & 0.17716194E-05_JPRB, 0.17717362E-05_JPRB, 0.17718447E-05_JPRB, 0.17719501E-05_JPRB, 0.17720171E-05_JPRB, 0.17720183E-05_JPRB, &
  & 0.17718988E-05_JPRB, 0.17715980E-05_JPRB, 0.17710804E-05_JPRB, 0.17703453E-05_JPRB, 0.17694412E-05_JPRB, 0.17684789E-05_JPRB, &
  & 0.17675970E-05_JPRB, 0.17669264E-05_JPRB, 0.17665550E-05_JPRB, 0.17664962E-05_JPRB, 0.17667055E-05_JPRB, 0.17671007E-05_JPRB, &
  & 0.17675892E-05_JPRB, 0.17680799E-05_JPRB, 0.17684923E-05_JPRB, 0.17687780E-05_JPRB, 0.17688953E-05_JPRB, 0.17688142E-05_JPRB, &
  & 0.17685293E-05_JPRB, 0.17680134E-05_JPRB, 0.17672539E-05_JPRB, 0.17663249E-05_JPRB, 0.17653947E-05_JPRB, 0.17645981E-05_JPRB, &
  & 0.17640085E-05_JPRB, 0.17636594E-05_JPRB, 0.17635782E-05_JPRB, 0.17637810E-05_JPRB, 0.17642872E-05_JPRB, 0.17650740E-05_JPRB, &
  & 0.17660775E-05_JPRB, 0.17671890E-05_JPRB, 0.17683501E-05_JPRB, 0.17694415E-05_JPRB, 0.17704067E-05_JPRB, 0.17712067E-05_JPRB, &
  & 0.17718289E-05_JPRB, 0.17722803E-05_JPRB, 0.17725696E-05_JPRB, 0.17727365E-05_JPRB, 0.17728240E-05_JPRB, 0.17728602E-05_JPRB, &
  & 0.17728588E-05_JPRB, 0.17728287E-05_JPRB, 0.17727870E-05_JPRB, 0.17727448E-05_JPRB, 0.17727028E-05_JPRB, 0.17726486E-05_JPRB, &
  & 0.17726244E-05_JPRB, 0.17725602E-05_JPRB, 0.17723747E-05_JPRB, 0.17717632E-05_JPRB /)

RGHG2(:,71, 4) = (/ &
  & 0.17700378E-05_JPRB, 0.17711649E-05_JPRB, 0.17716748E-05_JPRB, 0.17720207E-05_JPRB, 0.17722685E-05_JPRB, 0.17724525E-05_JPRB, &
  & 0.17725936E-05_JPRB, 0.17727145E-05_JPRB, 0.17728257E-05_JPRB, 0.17729280E-05_JPRB, 0.17729885E-05_JPRB, 0.17729836E-05_JPRB, &
  & 0.17728660E-05_JPRB, 0.17725800E-05_JPRB, 0.17721015E-05_JPRB, 0.17714294E-05_JPRB, 0.17706052E-05_JPRB, 0.17697276E-05_JPRB, &
  & 0.17689206E-05_JPRB, 0.17682999E-05_JPRB, 0.17679466E-05_JPRB, 0.17678738E-05_JPRB, 0.17680430E-05_JPRB, 0.17683810E-05_JPRB, &
  & 0.17688080E-05_JPRB, 0.17692377E-05_JPRB, 0.17695954E-05_JPRB, 0.17698397E-05_JPRB, 0.17699331E-05_JPRB, 0.17698499E-05_JPRB, &
  & 0.17695872E-05_JPRB, 0.17691185E-05_JPRB, 0.17684238E-05_JPRB, 0.17675734E-05_JPRB, 0.17667181E-05_JPRB, 0.17659956E-05_JPRB, &
  & 0.17654606E-05_JPRB, 0.17651510E-05_JPRB, 0.17650855E-05_JPRB, 0.17652799E-05_JPRB, 0.17657472E-05_JPRB, 0.17664738E-05_JPRB, &
  & 0.17673858E-05_JPRB, 0.17684150E-05_JPRB, 0.17694650E-05_JPRB, 0.17704700E-05_JPRB, 0.17713459E-05_JPRB, 0.17720764E-05_JPRB, &
  & 0.17726474E-05_JPRB, 0.17730628E-05_JPRB, 0.17733297E-05_JPRB, 0.17734842E-05_JPRB, 0.17735648E-05_JPRB, 0.17735983E-05_JPRB, &
  & 0.17735969E-05_JPRB, 0.17735687E-05_JPRB, 0.17735323E-05_JPRB, 0.17734955E-05_JPRB, 0.17734588E-05_JPRB, 0.17734081E-05_JPRB, &
  & 0.17733910E-05_JPRB, 0.17733330E-05_JPRB, 0.17731580E-05_JPRB, 0.17725624E-05_JPRB /)

RGHG2(:,72, 4) = (/ &
  & 0.17708684E-05_JPRB, 0.17721038E-05_JPRB, 0.17726628E-05_JPRB, 0.17730126E-05_JPRB, 0.17732632E-05_JPRB, 0.17734441E-05_JPRB, &
  & 0.17735861E-05_JPRB, 0.17737075E-05_JPRB, 0.17738134E-05_JPRB, 0.17739110E-05_JPRB, 0.17739596E-05_JPRB, 0.17739472E-05_JPRB, &
  & 0.17738292E-05_JPRB, 0.17735614E-05_JPRB, 0.17731229E-05_JPRB, 0.17725154E-05_JPRB, 0.17717778E-05_JPRB, 0.17709904E-05_JPRB, &
  & 0.17702639E-05_JPRB, 0.17696981E-05_JPRB, 0.17693662E-05_JPRB, 0.17692805E-05_JPRB, 0.17694078E-05_JPRB, 0.17696884E-05_JPRB, &
  & 0.17700515E-05_JPRB, 0.17704199E-05_JPRB, 0.17707235E-05_JPRB, 0.17709283E-05_JPRB, 0.17710005E-05_JPRB, 0.17709170E-05_JPRB, &
  & 0.17706793E-05_JPRB, 0.17702612E-05_JPRB, 0.17696390E-05_JPRB, 0.17688704E-05_JPRB, 0.17681047E-05_JPRB, 0.17674569E-05_JPRB, &
  & 0.17669850E-05_JPRB, 0.17667160E-05_JPRB, 0.17666674E-05_JPRB, 0.17668534E-05_JPRB, 0.17672826E-05_JPRB, 0.17679356E-05_JPRB, &
  & 0.17687687E-05_JPRB, 0.17696817E-05_JPRB, 0.17706387E-05_JPRB, 0.17715308E-05_JPRB, 0.17723182E-05_JPRB, 0.17729737E-05_JPRB, &
  & 0.17734851E-05_JPRB, 0.17738648E-05_JPRB, 0.17741072E-05_JPRB, 0.17742495E-05_JPRB, 0.17743255E-05_JPRB, 0.17743575E-05_JPRB, &
  & 0.17743590E-05_JPRB, 0.17743359E-05_JPRB, 0.17743084E-05_JPRB, 0.17742792E-05_JPRB, 0.17742501E-05_JPRB, 0.17742066E-05_JPRB, &
  & 0.17741947E-05_JPRB, 0.17741452E-05_JPRB, 0.17739842E-05_JPRB, 0.17734196E-05_JPRB /)

RGHG2(:,73, 4) = (/ &
  & 0.17718772E-05_JPRB, 0.17731400E-05_JPRB, 0.17736984E-05_JPRB, 0.17740327E-05_JPRB, 0.17742725E-05_JPRB, 0.17744470E-05_JPRB, &
  & 0.17745830E-05_JPRB, 0.17746987E-05_JPRB, 0.17747993E-05_JPRB, 0.17748836E-05_JPRB, 0.17749239E-05_JPRB, 0.17749027E-05_JPRB, &
  & 0.17747880E-05_JPRB, 0.17745356E-05_JPRB, 0.17741386E-05_JPRB, 0.17735979E-05_JPRB, 0.17729435E-05_JPRB, 0.17722527E-05_JPRB, &
  & 0.17716110E-05_JPRB, 0.17711063E-05_JPRB, 0.17707997E-05_JPRB, 0.17707040E-05_JPRB, 0.17707910E-05_JPRB, 0.17710138E-05_JPRB, &
  & 0.17713146E-05_JPRB, 0.17716233E-05_JPRB, 0.17718744E-05_JPRB, 0.17720413E-05_JPRB, 0.17720938E-05_JPRB, 0.17720130E-05_JPRB, &
  & 0.17718024E-05_JPRB, 0.17714384E-05_JPRB, 0.17708924E-05_JPRB, 0.17702162E-05_JPRB, 0.17695382E-05_JPRB, 0.17689771E-05_JPRB, &
  & 0.17685684E-05_JPRB, 0.17683427E-05_JPRB, 0.17683114E-05_JPRB, 0.17684873E-05_JPRB, 0.17688724E-05_JPRB, 0.17694579E-05_JPRB, &
  & 0.17701843E-05_JPRB, 0.17710023E-05_JPRB, 0.17718276E-05_JPRB, 0.17726202E-05_JPRB, 0.17733086E-05_JPRB, 0.17738842E-05_JPRB, &
  & 0.17743395E-05_JPRB, 0.17746758E-05_JPRB, 0.17748948E-05_JPRB, 0.17750253E-05_JPRB, 0.17750956E-05_JPRB, 0.17751294E-05_JPRB, &
  & 0.17751356E-05_JPRB, 0.17751197E-05_JPRB, 0.17751017E-05_JPRB, 0.17750812E-05_JPRB, 0.17750599E-05_JPRB, 0.17750234E-05_JPRB, &
  & 0.17750158E-05_JPRB, 0.17749724E-05_JPRB, 0.17748255E-05_JPRB, 0.17742983E-05_JPRB /)

RGHG2(:,74, 4) = (/ &
  & 0.17729568E-05_JPRB, 0.17742207E-05_JPRB, 0.17747416E-05_JPRB, 0.17750547E-05_JPRB, 0.17752726E-05_JPRB, 0.17754336E-05_JPRB, &
  & 0.17755599E-05_JPRB, 0.17756691E-05_JPRB, 0.17757530E-05_JPRB, 0.17758317E-05_JPRB, 0.17758600E-05_JPRB, 0.17758332E-05_JPRB, &
  & 0.17757222E-05_JPRB, 0.17754928E-05_JPRB, 0.17751370E-05_JPRB, 0.17746618E-05_JPRB, 0.17740985E-05_JPRB, 0.17735025E-05_JPRB, &
  & 0.17729517E-05_JPRB, 0.17725099E-05_JPRB, 0.17722348E-05_JPRB, 0.17721328E-05_JPRB, 0.17721833E-05_JPRB, 0.17723530E-05_JPRB, &
  & 0.17725937E-05_JPRB, 0.17728433E-05_JPRB, 0.17730434E-05_JPRB, 0.17731754E-05_JPRB, 0.17732109E-05_JPRB, 0.17731353E-05_JPRB, &
  & 0.17729525E-05_JPRB, 0.17726437E-05_JPRB, 0.17721795E-05_JPRB, 0.17715968E-05_JPRB, 0.17710198E-05_JPRB, 0.17705435E-05_JPRB, &
  & 0.17702040E-05_JPRB, 0.17700211E-05_JPRB, 0.17700044E-05_JPRB, 0.17701661E-05_JPRB, 0.17705069E-05_JPRB, 0.17710099E-05_JPRB, &
  & 0.17716450E-05_JPRB, 0.17723330E-05_JPRB, 0.17730458E-05_JPRB, 0.17737187E-05_JPRB, 0.17743077E-05_JPRB, 0.17748068E-05_JPRB, &
  & 0.17751941E-05_JPRB, 0.17754934E-05_JPRB, 0.17756840E-05_JPRB, 0.17758027E-05_JPRB, 0.17758691E-05_JPRB, 0.17759027E-05_JPRB, &
  & 0.17759148E-05_JPRB, 0.17759063E-05_JPRB, 0.17758970E-05_JPRB, 0.17758845E-05_JPRB, 0.17758703E-05_JPRB, 0.17758401E-05_JPRB, &
  & 0.17758348E-05_JPRB, 0.17757957E-05_JPRB, 0.17756637E-05_JPRB, 0.17751712E-05_JPRB /)

RGHG2(:,75, 4) = (/ &
  & 0.17740942E-05_JPRB, 0.17752867E-05_JPRB, 0.17757757E-05_JPRB, 0.17760437E-05_JPRB, 0.17762366E-05_JPRB, 0.17763801E-05_JPRB, &
  & 0.17764918E-05_JPRB, 0.17765874E-05_JPRB, 0.17766625E-05_JPRB, 0.17767242E-05_JPRB, 0.17767461E-05_JPRB, 0.17767190E-05_JPRB, &
  & 0.17766170E-05_JPRB, 0.17764141E-05_JPRB, 0.17761070E-05_JPRB, 0.17757052E-05_JPRB, 0.17752300E-05_JPRB, 0.17747367E-05_JPRB, &
  & 0.17742750E-05_JPRB, 0.17739035E-05_JPRB, 0.17736612E-05_JPRB, 0.17735615E-05_JPRB, 0.17735822E-05_JPRB, 0.17737033E-05_JPRB, &
  & 0.17738882E-05_JPRB, 0.17740825E-05_JPRB, 0.17742345E-05_JPRB, 0.17743342E-05_JPRB, 0.17743554E-05_JPRB, 0.17742865E-05_JPRB, &
  & 0.17741329E-05_JPRB, 0.17738806E-05_JPRB, 0.17734995E-05_JPRB, 0.17730169E-05_JPRB, 0.17725397E-05_JPRB, 0.17721547E-05_JPRB, &
  & 0.17718822E-05_JPRB, 0.17717415E-05_JPRB, 0.17717368E-05_JPRB, 0.17718813E-05_JPRB, 0.17721700E-05_JPRB, 0.17725964E-05_JPRB, &
  & 0.17731193E-05_JPRB, 0.17736934E-05_JPRB, 0.17742728E-05_JPRB, 0.17748308E-05_JPRB, 0.17753200E-05_JPRB, 0.17757316E-05_JPRB, &
  & 0.17760592E-05_JPRB, 0.17763103E-05_JPRB, 0.17764744E-05_JPRB, 0.17765777E-05_JPRB, 0.17766382E-05_JPRB, 0.17766707E-05_JPRB, &
  & 0.17766871E-05_JPRB, 0.17766845E-05_JPRB, 0.17766821E-05_JPRB, 0.17766763E-05_JPRB, 0.17766686E-05_JPRB, 0.17766431E-05_JPRB, &
  & 0.17766400E-05_JPRB, 0.17766054E-05_JPRB, 0.17764838E-05_JPRB, 0.17760270E-05_JPRB /)

RGHG2(:,76, 4) = (/ &
  & 0.17752319E-05_JPRB, 0.17763462E-05_JPRB, 0.17767627E-05_JPRB, 0.17769869E-05_JPRB, 0.17771467E-05_JPRB, 0.17772667E-05_JPRB, &
  & 0.17773627E-05_JPRB, 0.17774441E-05_JPRB, 0.17774983E-05_JPRB, 0.17775515E-05_JPRB, 0.17775634E-05_JPRB, 0.17775361E-05_JPRB, &
  & 0.17774527E-05_JPRB, 0.17772849E-05_JPRB, 0.17770354E-05_JPRB, 0.17767125E-05_JPRB, 0.17763357E-05_JPRB, 0.17759446E-05_JPRB, &
  & 0.17755776E-05_JPRB, 0.17752755E-05_JPRB, 0.17750763E-05_JPRB, 0.17749863E-05_JPRB, 0.17749859E-05_JPRB, 0.17750656E-05_JPRB, &
  & 0.17751991E-05_JPRB, 0.17753403E-05_JPRB, 0.17754467E-05_JPRB, 0.17755182E-05_JPRB, 0.17755281E-05_JPRB, 0.17754683E-05_JPRB, &
  & 0.17753443E-05_JPRB, 0.17751487E-05_JPRB, 0.17748537E-05_JPRB, 0.17744724E-05_JPRB, 0.17741019E-05_JPRB, 0.17738050E-05_JPRB, &
  & 0.17736018E-05_JPRB, 0.17734999E-05_JPRB, 0.17735038E-05_JPRB, 0.17736257E-05_JPRB, 0.17738602E-05_JPRB, 0.17741989E-05_JPRB, &
  & 0.17746167E-05_JPRB, 0.17750647E-05_JPRB, 0.17755169E-05_JPRB, 0.17759564E-05_JPRB, 0.17763366E-05_JPRB, 0.17766689E-05_JPRB, &
  & 0.17769228E-05_JPRB, 0.17771313E-05_JPRB, 0.17772602E-05_JPRB, 0.17773489E-05_JPRB, 0.17773984E-05_JPRB, 0.17774278E-05_JPRB, &
  & 0.17774472E-05_JPRB, 0.17774481E-05_JPRB, 0.17774498E-05_JPRB, 0.17774494E-05_JPRB, 0.17774485E-05_JPRB, 0.17774274E-05_JPRB, &
  & 0.17774255E-05_JPRB, 0.17773932E-05_JPRB, 0.17772853E-05_JPRB, 0.17768530E-05_JPRB /)

RGHG2(:,77, 4) = (/ &
  & 0.17763859E-05_JPRB, 0.17773475E-05_JPRB, 0.17776972E-05_JPRB, 0.17778628E-05_JPRB, 0.17779848E-05_JPRB, 0.17780829E-05_JPRB, &
  & 0.17781556E-05_JPRB, 0.17782206E-05_JPRB, 0.17782537E-05_JPRB, 0.17782910E-05_JPRB, 0.17782941E-05_JPRB, 0.17782720E-05_JPRB, &
  & 0.17782068E-05_JPRB, 0.17780837E-05_JPRB, 0.17778981E-05_JPRB, 0.17776639E-05_JPRB, 0.17773876E-05_JPRB, 0.17771052E-05_JPRB, &
  & 0.17768332E-05_JPRB, 0.17766095E-05_JPRB, 0.17764589E-05_JPRB, 0.17763912E-05_JPRB, 0.17763790E-05_JPRB, 0.17764253E-05_JPRB, &
  & 0.17765151E-05_JPRB, 0.17766110E-05_JPRB, 0.17766783E-05_JPRB, 0.17767277E-05_JPRB, 0.17767309E-05_JPRB, 0.17766827E-05_JPRB, &
  & 0.17765881E-05_JPRB, 0.17764484E-05_JPRB, 0.17762392E-05_JPRB, 0.17759603E-05_JPRB, 0.17756920E-05_JPRB, 0.17754842E-05_JPRB, &
  & 0.17753442E-05_JPRB, 0.17752776E-05_JPRB, 0.17752867E-05_JPRB, 0.17753827E-05_JPRB, 0.17755569E-05_JPRB, 0.17758061E-05_JPRB, &
  & 0.17761099E-05_JPRB, 0.17764347E-05_JPRB, 0.17767609E-05_JPRB, 0.17770778E-05_JPRB, 0.17773566E-05_JPRB, 0.17775984E-05_JPRB, &
  & 0.17777840E-05_JPRB, 0.17779421E-05_JPRB, 0.17780364E-05_JPRB, 0.17781050E-05_JPRB, 0.17781442E-05_JPRB, 0.17781654E-05_JPRB, &
  & 0.17781866E-05_JPRB, 0.17781887E-05_JPRB, 0.17781909E-05_JPRB, 0.17781945E-05_JPRB, 0.17781988E-05_JPRB, 0.17781820E-05_JPRB, &
  & 0.17781792E-05_JPRB, 0.17781488E-05_JPRB, 0.17780510E-05_JPRB, 0.17776570E-05_JPRB /)

RGHG2(:,78, 4) = (/ &
  & 0.17775184E-05_JPRB, 0.17782642E-05_JPRB, 0.17785055E-05_JPRB, 0.17786130E-05_JPRB, 0.17786988E-05_JPRB, 0.17787706E-05_JPRB, &
  & 0.17788238E-05_JPRB, 0.17788662E-05_JPRB, 0.17788774E-05_JPRB, 0.17788999E-05_JPRB, 0.17788959E-05_JPRB, 0.17788777E-05_JPRB, &
  & 0.17788357E-05_JPRB, 0.17787577E-05_JPRB, 0.17786381E-05_JPRB, 0.17784897E-05_JPRB, 0.17783130E-05_JPRB, 0.17781350E-05_JPRB, &
  & 0.17779579E-05_JPRB, 0.17778125E-05_JPRB, 0.17777191E-05_JPRB, 0.17776855E-05_JPRB, 0.17776746E-05_JPRB, 0.17777022E-05_JPRB, &
  & 0.17777620E-05_JPRB, 0.17778235E-05_JPRB, 0.17778609E-05_JPRB, 0.17778952E-05_JPRB, 0.17778964E-05_JPRB, 0.17778624E-05_JPRB, &
  & 0.17777963E-05_JPRB, 0.17777085E-05_JPRB, 0.17775800E-05_JPRB, 0.17773973E-05_JPRB, 0.17772254E-05_JPRB, 0.17770976E-05_JPRB, &
  & 0.17770117E-05_JPRB, 0.17769705E-05_JPRB, 0.17769780E-05_JPRB, 0.17770446E-05_JPRB, 0.17771557E-05_JPRB, 0.17773157E-05_JPRB, &
  & 0.17775069E-05_JPRB, 0.17777162E-05_JPRB, 0.17779189E-05_JPRB, 0.17781267E-05_JPRB, 0.17783020E-05_JPRB, 0.17784645E-05_JPRB, &
  & 0.17785781E-05_JPRB, 0.17786907E-05_JPRB, 0.17787493E-05_JPRB, 0.17787995E-05_JPRB, 0.17788252E-05_JPRB, 0.17788366E-05_JPRB, &
  & 0.17788565E-05_JPRB, 0.17788559E-05_JPRB, 0.17788551E-05_JPRB, 0.17788597E-05_JPRB, 0.17788675E-05_JPRB, 0.17788551E-05_JPRB, &
  & 0.17788479E-05_JPRB, 0.17788169E-05_JPRB, 0.17787497E-05_JPRB, 0.17784316E-05_JPRB /)

RGHG2(:,79, 4) = (/ &
  & 0.17782535E-05_JPRB, 0.17787747E-05_JPRB, 0.17789396E-05_JPRB, 0.17790012E-05_JPRB, 0.17790671E-05_JPRB, 0.17791281E-05_JPRB, &
  & 0.17791665E-05_JPRB, 0.17791997E-05_JPRB, 0.17791966E-05_JPRB, 0.17792138E-05_JPRB, 0.17792063E-05_JPRB, 0.17791909E-05_JPRB, &
  & 0.17791618E-05_JPRB, 0.17791078E-05_JPRB, 0.17790212E-05_JPRB, 0.17789193E-05_JPRB, 0.17787941E-05_JPRB, 0.17786731E-05_JPRB, &
  & 0.17785458E-05_JPRB, 0.17784438E-05_JPRB, 0.17783831E-05_JPRB, 0.17783714E-05_JPRB, 0.17783633E-05_JPRB, 0.17783831E-05_JPRB, &
  & 0.17784298E-05_JPRB, 0.17784754E-05_JPRB, 0.17784971E-05_JPRB, 0.17785259E-05_JPRB, 0.17785267E-05_JPRB, 0.17785011E-05_JPRB, &
  & 0.17784497E-05_JPRB, 0.17783902E-05_JPRB, 0.17783074E-05_JPRB, 0.17781764E-05_JPRB, 0.17780551E-05_JPRB, 0.17779701E-05_JPRB, &
  & 0.17779107E-05_JPRB, 0.17778812E-05_JPRB, 0.17778849E-05_JPRB, 0.17779317E-05_JPRB, 0.17780070E-05_JPRB, 0.17781149E-05_JPRB, &
  & 0.17782461E-05_JPRB, 0.17783916E-05_JPRB, 0.17785303E-05_JPRB, 0.17786770E-05_JPRB, 0.17787999E-05_JPRB, 0.17789174E-05_JPRB, &
  & 0.17789926E-05_JPRB, 0.17790823E-05_JPRB, 0.17791210E-05_JPRB, 0.17791619E-05_JPRB, 0.17791799E-05_JPRB, 0.17791840E-05_JPRB, &
  & 0.17792045E-05_JPRB, 0.17792013E-05_JPRB, 0.17791967E-05_JPRB, 0.17792017E-05_JPRB, 0.17792124E-05_JPRB, 0.17792016E-05_JPRB, &
  & 0.17791917E-05_JPRB, 0.17791676E-05_JPRB, 0.17791331E-05_JPRB, 0.17789238E-05_JPRB /)

RGHG2(:,80, 4) = (/ &
  & 0.17787391E-05_JPRB, 0.17790230E-05_JPRB, 0.17791293E-05_JPRB, 0.17791689E-05_JPRB, 0.17792247E-05_JPRB, 0.17792813E-05_JPRB, &
  & 0.17793161E-05_JPRB, 0.17793434E-05_JPRB, 0.17793357E-05_JPRB, 0.17793507E-05_JPRB, 0.17793429E-05_JPRB, 0.17793309E-05_JPRB, &
  & 0.17793070E-05_JPRB, 0.17792640E-05_JPRB, 0.17791917E-05_JPRB, 0.17791099E-05_JPRB, 0.17790081E-05_JPRB, 0.17789137E-05_JPRB, &
  & 0.17788086E-05_JPRB, 0.17787254E-05_JPRB, 0.17786801E-05_JPRB, 0.17786798E-05_JPRB, 0.17786724E-05_JPRB, 0.17786889E-05_JPRB, &
  & 0.17787307E-05_JPRB, 0.17787694E-05_JPRB, 0.17787848E-05_JPRB, 0.17788118E-05_JPRB, 0.17788136E-05_JPRB, 0.17787920E-05_JPRB, &
  & 0.17787470E-05_JPRB, 0.17787015E-05_JPRB, 0.17786396E-05_JPRB, 0.17785317E-05_JPRB, 0.17784329E-05_JPRB, 0.17783668E-05_JPRB, &
  & 0.17783186E-05_JPRB, 0.17782925E-05_JPRB, 0.17782933E-05_JPRB, 0.17783309E-05_JPRB, 0.17783879E-05_JPRB, 0.17784724E-05_JPRB, &
  & 0.17785751E-05_JPRB, 0.17786928E-05_JPRB, 0.17788010E-05_JPRB, 0.17789221E-05_JPRB, 0.17790196E-05_JPRB, 0.17791181E-05_JPRB, &
  & 0.17791745E-05_JPRB, 0.17792543E-05_JPRB, 0.17792834E-05_JPRB, 0.17793201E-05_JPRB, 0.17793340E-05_JPRB, 0.17793341E-05_JPRB, &
  & 0.17793552E-05_JPRB, 0.17793501E-05_JPRB, 0.17793434E-05_JPRB, 0.17793483E-05_JPRB, 0.17793607E-05_JPRB, 0.17793503E-05_JPRB, &
  & 0.17793395E-05_JPRB, 0.17793185E-05_JPRB, 0.17793157E-05_JPRB, 0.17792441E-05_JPRB /)

RGHG2(:,81, 4) = (/ &
  & 0.17790719E-05_JPRB, 0.17791275E-05_JPRB, 0.17792098E-05_JPRB, 0.17792393E-05_JPRB, 0.17792916E-05_JPRB, 0.17793476E-05_JPRB, &
  & 0.17793776E-05_JPRB, 0.17794057E-05_JPRB, 0.17793952E-05_JPRB, 0.17794125E-05_JPRB, 0.17794055E-05_JPRB, 0.17793923E-05_JPRB, &
  & 0.17793723E-05_JPRB, 0.17793334E-05_JPRB, 0.17792669E-05_JPRB, 0.17791943E-05_JPRB, 0.17791027E-05_JPRB, 0.17790209E-05_JPRB, &
  & 0.17789249E-05_JPRB, 0.17788498E-05_JPRB, 0.17788110E-05_JPRB, 0.17788159E-05_JPRB, 0.17788082E-05_JPRB, 0.17788229E-05_JPRB, &
  & 0.17788627E-05_JPRB, 0.17788991E-05_JPRB, 0.17789109E-05_JPRB, 0.17789378E-05_JPRB, 0.17789405E-05_JPRB, 0.17789206E-05_JPRB, &
  & 0.17788782E-05_JPRB, 0.17788389E-05_JPRB, 0.17787868E-05_JPRB, 0.17786886E-05_JPRB, 0.17785998E-05_JPRB, 0.17785419E-05_JPRB, &
  & 0.17784980E-05_JPRB, 0.17784739E-05_JPRB, 0.17784730E-05_JPRB, 0.17785059E-05_JPRB, 0.17785554E-05_JPRB, 0.17786285E-05_JPRB, &
  & 0.17787190E-05_JPRB, 0.17788242E-05_JPRB, 0.17789196E-05_JPRB, 0.17790289E-05_JPRB, 0.17791160E-05_JPRB, 0.17792057E-05_JPRB, &
  & 0.17792532E-05_JPRB, 0.17793298E-05_JPRB, 0.17793536E-05_JPRB, 0.17793886E-05_JPRB, 0.17794002E-05_JPRB, 0.17793983E-05_JPRB, &
  & 0.17794202E-05_JPRB, 0.17794137E-05_JPRB, 0.17794054E-05_JPRB, 0.17794108E-05_JPRB, 0.17794242E-05_JPRB, 0.17794138E-05_JPRB, &
  & 0.17794018E-05_JPRB, 0.17793811E-05_JPRB, 0.17793909E-05_JPRB, 0.17794611E-05_JPRB /)

RGHG2(:,82, 4) = (/ &
  & 0.17790983E-05_JPRB, 0.17791622E-05_JPRB, 0.17792451E-05_JPRB, 0.17792723E-05_JPRB, 0.17793241E-05_JPRB, 0.17793782E-05_JPRB, &
  & 0.17794130E-05_JPRB, 0.17794370E-05_JPRB, 0.17794258E-05_JPRB, 0.17794403E-05_JPRB, 0.17794329E-05_JPRB, 0.17794241E-05_JPRB, &
  & 0.17794038E-05_JPRB, 0.17793682E-05_JPRB, 0.17793043E-05_JPRB, 0.17792356E-05_JPRB, 0.17791499E-05_JPRB, 0.17790735E-05_JPRB, &
  & 0.17789828E-05_JPRB, 0.17789107E-05_JPRB, 0.17788751E-05_JPRB, 0.17788830E-05_JPRB, 0.17788744E-05_JPRB, 0.17788880E-05_JPRB, &
  & 0.17789276E-05_JPRB, 0.17789624E-05_JPRB, 0.17789728E-05_JPRB, 0.17789993E-05_JPRB, 0.17790022E-05_JPRB, 0.17789835E-05_JPRB, &
  & 0.17789423E-05_JPRB, 0.17789058E-05_JPRB, 0.17788583E-05_JPRB, 0.17787651E-05_JPRB, 0.17786813E-05_JPRB, 0.17786272E-05_JPRB, &
  & 0.17785860E-05_JPRB, 0.17785628E-05_JPRB, 0.17785612E-05_JPRB, 0.17785924E-05_JPRB, 0.17786369E-05_JPRB, 0.17787058E-05_JPRB, &
  & 0.17787889E-05_JPRB, 0.17788888E-05_JPRB, 0.17789773E-05_JPRB, 0.17790821E-05_JPRB, 0.17791626E-05_JPRB, 0.17792488E-05_JPRB, &
  & 0.17792916E-05_JPRB, 0.17793668E-05_JPRB, 0.17793877E-05_JPRB, 0.17794218E-05_JPRB, 0.17794325E-05_JPRB, 0.17794295E-05_JPRB, &
  & 0.17794518E-05_JPRB, 0.17794448E-05_JPRB, 0.17794355E-05_JPRB, 0.17794406E-05_JPRB, 0.17794547E-05_JPRB, 0.17794445E-05_JPRB, &
  & 0.17794310E-05_JPRB, 0.17794085E-05_JPRB, 0.17794158E-05_JPRB, 0.17794780E-05_JPRB /)

RGHG2(:,83, 4) = (/ &
  & 0.17791162E-05_JPRB, 0.17791830E-05_JPRB, 0.17792647E-05_JPRB, 0.17792911E-05_JPRB, 0.17793410E-05_JPRB, 0.17793986E-05_JPRB, &
  & 0.17794235E-05_JPRB, 0.17794525E-05_JPRB, 0.17794418E-05_JPRB, 0.17794592E-05_JPRB, 0.17794530E-05_JPRB, 0.17794400E-05_JPRB, &
  & 0.17794232E-05_JPRB, 0.17793877E-05_JPRB, 0.17793255E-05_JPRB, 0.17792596E-05_JPRB, 0.17791758E-05_JPRB, 0.17791042E-05_JPRB, &
  & 0.17790148E-05_JPRB, 0.17789455E-05_JPRB, 0.17789110E-05_JPRB, 0.17789212E-05_JPRB, 0.17789115E-05_JPRB, 0.17789246E-05_JPRB, &
  & 0.17789637E-05_JPRB, 0.17789982E-05_JPRB, 0.17790069E-05_JPRB, 0.17790338E-05_JPRB, 0.17790371E-05_JPRB, 0.17790186E-05_JPRB, &
  & 0.17789777E-05_JPRB, 0.17789430E-05_JPRB, 0.17788980E-05_JPRB, 0.17788067E-05_JPRB, 0.17787264E-05_JPRB, 0.17786755E-05_JPRB, &
  & 0.17786357E-05_JPRB, 0.17786138E-05_JPRB, 0.17786128E-05_JPRB, 0.17786413E-05_JPRB, 0.17786848E-05_JPRB, 0.17787474E-05_JPRB, &
  & 0.17788275E-05_JPRB, 0.17789233E-05_JPRB, 0.17790094E-05_JPRB, 0.17791111E-05_JPRB, 0.17791893E-05_JPRB, 0.17792730E-05_JPRB, &
  & 0.17793130E-05_JPRB, 0.17793880E-05_JPRB, 0.17794072E-05_JPRB, 0.17794409E-05_JPRB, 0.17794507E-05_JPRB, 0.17794468E-05_JPRB, &
  & 0.17794696E-05_JPRB, 0.17794621E-05_JPRB, 0.17794520E-05_JPRB, 0.17794576E-05_JPRB, 0.17794725E-05_JPRB, 0.17794620E-05_JPRB, &
  & 0.17794476E-05_JPRB, 0.17794237E-05_JPRB, 0.17794304E-05_JPRB, 0.17794899E-05_JPRB /)

RGHG2(:,84, 4) = (/ &
  & 0.17791284E-05_JPRB, 0.17791956E-05_JPRB, 0.17792775E-05_JPRB, 0.17793027E-05_JPRB, 0.17793541E-05_JPRB, 0.17794066E-05_JPRB, &
  & 0.17794436E-05_JPRB, 0.17794631E-05_JPRB, 0.17794537E-05_JPRB, 0.17794647E-05_JPRB, 0.17794587E-05_JPRB, 0.17794513E-05_JPRB, &
  & 0.17794320E-05_JPRB, 0.17793992E-05_JPRB, 0.17793402E-05_JPRB, 0.17792746E-05_JPRB, 0.17791932E-05_JPRB, 0.17791226E-05_JPRB, &
  & 0.17790359E-05_JPRB, 0.17789663E-05_JPRB, 0.17789329E-05_JPRB, 0.17789453E-05_JPRB, 0.17789341E-05_JPRB, 0.17789463E-05_JPRB, &
  & 0.17789864E-05_JPRB, 0.17790201E-05_JPRB, 0.17790273E-05_JPRB, 0.17790551E-05_JPRB, 0.17790585E-05_JPRB, 0.17790401E-05_JPRB, &
  & 0.17789990E-05_JPRB, 0.17789655E-05_JPRB, 0.17789217E-05_JPRB, 0.17788327E-05_JPRB, 0.17787540E-05_JPRB, 0.17787047E-05_JPRB, &
  & 0.17786666E-05_JPRB, 0.17786458E-05_JPRB, 0.17786457E-05_JPRB, 0.17786737E-05_JPRB, 0.17787136E-05_JPRB, 0.17787742E-05_JPRB, &
  & 0.17788500E-05_JPRB, 0.17789419E-05_JPRB, 0.17790271E-05_JPRB, 0.17791290E-05_JPRB, 0.17792045E-05_JPRB, 0.17792880E-05_JPRB, &
  & 0.17793260E-05_JPRB, 0.17794011E-05_JPRB, 0.17794189E-05_JPRB, 0.17794525E-05_JPRB, 0.17794620E-05_JPRB, 0.17794571E-05_JPRB, &
  & 0.17794807E-05_JPRB, 0.17794728E-05_JPRB, 0.17794621E-05_JPRB, 0.17794680E-05_JPRB, 0.17794831E-05_JPRB, 0.17794729E-05_JPRB, &
  & 0.17794579E-05_JPRB, 0.17794332E-05_JPRB, 0.17794393E-05_JPRB, 0.17794981E-05_JPRB /)

RGHG2(:,85, 4) = (/ &
  & 0.17791366E-05_JPRB, 0.17792042E-05_JPRB, 0.17792856E-05_JPRB, 0.17793101E-05_JPRB, 0.17793595E-05_JPRB, 0.17794194E-05_JPRB, &
  & 0.17794418E-05_JPRB, 0.17794675E-05_JPRB, 0.17794600E-05_JPRB, 0.17794716E-05_JPRB, 0.17794664E-05_JPRB, 0.17794540E-05_JPRB, &
  & 0.17794381E-05_JPRB, 0.17794047E-05_JPRB, 0.17793495E-05_JPRB, 0.17792859E-05_JPRB, 0.17792063E-05_JPRB, 0.17791367E-05_JPRB, &
  & 0.17790492E-05_JPRB, 0.17789802E-05_JPRB, 0.17789470E-05_JPRB, 0.17789608E-05_JPRB, 0.17789489E-05_JPRB, 0.17789606E-05_JPRB, &
  & 0.17790011E-05_JPRB, 0.17790346E-05_JPRB, 0.17790401E-05_JPRB, 0.17790690E-05_JPRB, 0.17790726E-05_JPRB, 0.17790542E-05_JPRB, &
  & 0.17790131E-05_JPRB, 0.17789803E-05_JPRB, 0.17789372E-05_JPRB, 0.17788484E-05_JPRB, 0.17787719E-05_JPRB, 0.17787237E-05_JPRB, &
  & 0.17786865E-05_JPRB, 0.17786674E-05_JPRB, 0.17786680E-05_JPRB, 0.17786942E-05_JPRB, 0.17787346E-05_JPRB, 0.17787911E-05_JPRB, &
  & 0.17788628E-05_JPRB, 0.17789548E-05_JPRB, 0.17790372E-05_JPRB, 0.17791391E-05_JPRB, 0.17792149E-05_JPRB, 0.17792975E-05_JPRB, &
  & 0.17793345E-05_JPRB, 0.17794102E-05_JPRB, 0.17794266E-05_JPRB, 0.17794600E-05_JPRB, 0.17794696E-05_JPRB, 0.17794644E-05_JPRB, &
  & 0.17794883E-05_JPRB, 0.17794799E-05_JPRB, 0.17794684E-05_JPRB, 0.17794749E-05_JPRB, 0.17794908E-05_JPRB, 0.17794800E-05_JPRB, &
  & 0.17794645E-05_JPRB, 0.17794390E-05_JPRB, 0.17794455E-05_JPRB, 0.17795030E-05_JPRB /)

RGHG2(:,86, 4) = (/ &
  & 0.17791415E-05_JPRB, 0.17792092E-05_JPRB, 0.17792905E-05_JPRB, 0.17793143E-05_JPRB, 0.17793690E-05_JPRB, 0.17794204E-05_JPRB, &
  & 0.17794544E-05_JPRB, 0.17794696E-05_JPRB, 0.17794637E-05_JPRB, 0.17794700E-05_JPRB, 0.17794639E-05_JPRB, 0.17794555E-05_JPRB, &
  & 0.17794353E-05_JPRB, 0.17794072E-05_JPRB, 0.17793561E-05_JPRB, 0.17792951E-05_JPRB, 0.17792174E-05_JPRB, 0.17791472E-05_JPRB, &
  & 0.17790599E-05_JPRB, 0.17789896E-05_JPRB, 0.17789562E-05_JPRB, 0.17789710E-05_JPRB, 0.17789578E-05_JPRB, 0.17789690E-05_JPRB, &
  & 0.17790103E-05_JPRB, 0.17790441E-05_JPRB, 0.17790484E-05_JPRB, 0.17790780E-05_JPRB, 0.17790818E-05_JPRB, 0.17790633E-05_JPRB, &
  & 0.17790218E-05_JPRB, 0.17789895E-05_JPRB, 0.17789469E-05_JPRB, 0.17788602E-05_JPRB, 0.17787829E-05_JPRB, 0.17787356E-05_JPRB, &
  & 0.17786986E-05_JPRB, 0.17786792E-05_JPRB, 0.17786801E-05_JPRB, 0.17787077E-05_JPRB, 0.17787461E-05_JPRB, 0.17788025E-05_JPRB, &
  & 0.17788747E-05_JPRB, 0.17789607E-05_JPRB, 0.17790461E-05_JPRB, 0.17791461E-05_JPRB, 0.17792211E-05_JPRB, 0.17793038E-05_JPRB, &
  & 0.17793400E-05_JPRB, 0.17794163E-05_JPRB, 0.17794320E-05_JPRB, 0.17794654E-05_JPRB, 0.17794746E-05_JPRB, 0.17794687E-05_JPRB, &
  & 0.17794930E-05_JPRB, 0.17794846E-05_JPRB, 0.17794725E-05_JPRB, 0.17794792E-05_JPRB, 0.17794956E-05_JPRB, 0.17794855E-05_JPRB, &
  & 0.17794691E-05_JPRB, 0.17794429E-05_JPRB, 0.17794484E-05_JPRB, 0.17795059E-05_JPRB /)

RGHG2(:,87, 4) = (/ &
  & 0.17791452E-05_JPRB, 0.17792138E-05_JPRB, 0.17792935E-05_JPRB, 0.17793184E-05_JPRB, 0.17793684E-05_JPRB, 0.17794302E-05_JPRB, &
  & 0.17794508E-05_JPRB, 0.17794696E-05_JPRB, 0.17794648E-05_JPRB, 0.17794698E-05_JPRB, 0.17794645E-05_JPRB, 0.17794518E-05_JPRB, &
  & 0.17794365E-05_JPRB, 0.17794050E-05_JPRB, 0.17793604E-05_JPRB, 0.17793008E-05_JPRB, 0.17792277E-05_JPRB, 0.17791549E-05_JPRB, &
  & 0.17790680E-05_JPRB, 0.17789966E-05_JPRB, 0.17789617E-05_JPRB, 0.17789773E-05_JPRB, 0.17789635E-05_JPRB, 0.17789743E-05_JPRB, &
  & 0.17790162E-05_JPRB, 0.17790499E-05_JPRB, 0.17790533E-05_JPRB, 0.17790838E-05_JPRB, 0.17790874E-05_JPRB, 0.17790693E-05_JPRB, &
  & 0.17790273E-05_JPRB, 0.17789954E-05_JPRB, 0.17789545E-05_JPRB, 0.17788673E-05_JPRB, 0.17787910E-05_JPRB, 0.17787431E-05_JPRB, &
  & 0.17787052E-05_JPRB, 0.17786845E-05_JPRB, 0.17786847E-05_JPRB, 0.17787117E-05_JPRB, 0.17787519E-05_JPRB, 0.17788093E-05_JPRB, &
  & 0.17788798E-05_JPRB, 0.17789723E-05_JPRB, 0.17790521E-05_JPRB, 0.17791531E-05_JPRB, 0.17792258E-05_JPRB, 0.17793077E-05_JPRB, &
  & 0.17793432E-05_JPRB, 0.17794200E-05_JPRB, 0.17794349E-05_JPRB, 0.17794688E-05_JPRB, 0.17794777E-05_JPRB, 0.17794716E-05_JPRB, &
  & 0.17794960E-05_JPRB, 0.17794870E-05_JPRB, 0.17794748E-05_JPRB, 0.17794817E-05_JPRB, 0.17794983E-05_JPRB, 0.17794883E-05_JPRB, &
  & 0.17794717E-05_JPRB, 0.17794449E-05_JPRB, 0.17794503E-05_JPRB, 0.17795074E-05_JPRB /)

RGHG2(:,88, 4) = (/ &
  & 0.17791504E-05_JPRB, 0.17792180E-05_JPRB, 0.17792939E-05_JPRB, 0.17793191E-05_JPRB, 0.17793762E-05_JPRB, 0.17794263E-05_JPRB, &
  & 0.17794569E-05_JPRB, 0.17794699E-05_JPRB, 0.17794648E-05_JPRB, 0.17794681E-05_JPRB, 0.17794609E-05_JPRB, 0.17794523E-05_JPRB, &
  & 0.17794330E-05_JPRB, 0.17794082E-05_JPRB, 0.17793619E-05_JPRB, 0.17793056E-05_JPRB, 0.17792311E-05_JPRB, 0.17791608E-05_JPRB, &
  & 0.17790727E-05_JPRB, 0.17790005E-05_JPRB, 0.17789654E-05_JPRB, 0.17789815E-05_JPRB, 0.17789667E-05_JPRB, 0.17789772E-05_JPRB, &
  & 0.17790198E-05_JPRB, 0.17790535E-05_JPRB, 0.17790559E-05_JPRB, 0.17790875E-05_JPRB, 0.17790910E-05_JPRB, 0.17790729E-05_JPRB, &
  & 0.17790309E-05_JPRB, 0.17789994E-05_JPRB, 0.17789594E-05_JPRB, 0.17788730E-05_JPRB, 0.17787952E-05_JPRB, 0.17787479E-05_JPRB, &
  & 0.17787080E-05_JPRB, 0.17786854E-05_JPRB, 0.17786834E-05_JPRB, 0.17787129E-05_JPRB, 0.17787523E-05_JPRB, 0.17788118E-05_JPRB, &
  & 0.17788883E-05_JPRB, 0.17789787E-05_JPRB, 0.17790602E-05_JPRB, 0.17791588E-05_JPRB, 0.17792288E-05_JPRB, 0.17793103E-05_JPRB, &
  & 0.17793454E-05_JPRB, 0.17794230E-05_JPRB, 0.17794366E-05_JPRB, 0.17794712E-05_JPRB, 0.17794797E-05_JPRB, 0.17794736E-05_JPRB, &
  & 0.17794982E-05_JPRB, 0.17794885E-05_JPRB, 0.17794761E-05_JPRB, 0.17794831E-05_JPRB, 0.17795007E-05_JPRB, 0.17794907E-05_JPRB, &
  & 0.17794735E-05_JPRB, 0.17794462E-05_JPRB, 0.17794513E-05_JPRB, 0.17795089E-05_JPRB /)

RGHG2(:,89, 4) = (/ &
  & 0.17791576E-05_JPRB, 0.17792233E-05_JPRB, 0.17792920E-05_JPRB, 0.17793194E-05_JPRB, 0.17793699E-05_JPRB, 0.17794318E-05_JPRB, &
  & 0.17794536E-05_JPRB, 0.17794722E-05_JPRB, 0.17794662E-05_JPRB, 0.17794705E-05_JPRB, 0.17794645E-05_JPRB, 0.17794530E-05_JPRB, &
  & 0.17794383E-05_JPRB, 0.17794080E-05_JPRB, 0.17793645E-05_JPRB, 0.17793051E-05_JPRB, 0.17792318E-05_JPRB, 0.17791599E-05_JPRB, &
  & 0.17790728E-05_JPRB, 0.17790014E-05_JPRB, 0.17789665E-05_JPRB, 0.17789837E-05_JPRB, 0.17789686E-05_JPRB, 0.17789782E-05_JPRB, &
  & 0.17790222E-05_JPRB, 0.17790561E-05_JPRB, 0.17790574E-05_JPRB, 0.17790894E-05_JPRB, 0.17790935E-05_JPRB, 0.17790754E-05_JPRB, &
  & 0.17790323E-05_JPRB, 0.17790016E-05_JPRB, 0.17789627E-05_JPRB, 0.17788759E-05_JPRB, 0.17787975E-05_JPRB, 0.17787506E-05_JPRB, &
  & 0.17787097E-05_JPRB, 0.17786851E-05_JPRB, 0.17786808E-05_JPRB, 0.17787114E-05_JPRB, 0.17787517E-05_JPRB, 0.17788142E-05_JPRB, &
  & 0.17788905E-05_JPRB, 0.17789878E-05_JPRB, 0.17790644E-05_JPRB, 0.17791627E-05_JPRB, 0.17792312E-05_JPRB, 0.17793122E-05_JPRB, &
  & 0.17793461E-05_JPRB, 0.17794249E-05_JPRB, 0.17794375E-05_JPRB, 0.17794727E-05_JPRB, 0.17794810E-05_JPRB, 0.17794744E-05_JPRB, &
  & 0.17794996E-05_JPRB, 0.17794895E-05_JPRB, 0.17794766E-05_JPRB, 0.17794843E-05_JPRB, 0.17795019E-05_JPRB, 0.17794918E-05_JPRB, &
  & 0.17794744E-05_JPRB, 0.17794465E-05_JPRB, 0.17794513E-05_JPRB, 0.17795096E-05_JPRB /)

RGHG2(:,90, 4) = (/ &
  & 0.17791644E-05_JPRB, 0.17792282E-05_JPRB, 0.17792884E-05_JPRB, 0.17793162E-05_JPRB, 0.17793709E-05_JPRB, 0.17794271E-05_JPRB, &
  & 0.17794578E-05_JPRB, 0.17794782E-05_JPRB, 0.17794680E-05_JPRB, 0.17794764E-05_JPRB, 0.17794694E-05_JPRB, 0.17794613E-05_JPRB, &
  & 0.17794430E-05_JPRB, 0.17794157E-05_JPRB, 0.17793641E-05_JPRB, 0.17793034E-05_JPRB, 0.17792254E-05_JPRB, 0.17791583E-05_JPRB, &
  & 0.17790697E-05_JPRB, 0.17789996E-05_JPRB, 0.17789654E-05_JPRB, 0.17789857E-05_JPRB, 0.17789683E-05_JPRB, 0.17789781E-05_JPRB, &
  & 0.17790233E-05_JPRB, 0.17790579E-05_JPRB, 0.17790576E-05_JPRB, 0.17790912E-05_JPRB, 0.17790952E-05_JPRB, 0.17790774E-05_JPRB, &
  & 0.17790330E-05_JPRB, 0.17790031E-05_JPRB, 0.17789663E-05_JPRB, 0.17788765E-05_JPRB, 0.17787972E-05_JPRB, 0.17787511E-05_JPRB, &
  & 0.17787096E-05_JPRB, 0.17786844E-05_JPRB, 0.17786781E-05_JPRB, 0.17787106E-05_JPRB, 0.17787497E-05_JPRB, 0.17788138E-05_JPRB, &
  & 0.17788931E-05_JPRB, 0.17789912E-05_JPRB, 0.17790667E-05_JPRB, 0.17791656E-05_JPRB, 0.17792319E-05_JPRB, 0.17793144E-05_JPRB, &
  & 0.17793454E-05_JPRB, 0.17794271E-05_JPRB, 0.17794375E-05_JPRB, 0.17794742E-05_JPRB, 0.17794817E-05_JPRB, 0.17794741E-05_JPRB, &
  & 0.17795007E-05_JPRB, 0.17794899E-05_JPRB, 0.17794763E-05_JPRB, 0.17794845E-05_JPRB, 0.17795030E-05_JPRB, 0.17794924E-05_JPRB, &
  & 0.17794750E-05_JPRB, 0.17794459E-05_JPRB, 0.17794513E-05_JPRB, 0.17795107E-05_JPRB /)

RGHG2(:,91, 4) = (/ &
  & 0.17791664E-05_JPRB, 0.17792311E-05_JPRB, 0.17792797E-05_JPRB, 0.17793136E-05_JPRB, 0.17793666E-05_JPRB, 0.17794287E-05_JPRB, &
  & 0.17794520E-05_JPRB, 0.17794973E-05_JPRB, 0.17794493E-05_JPRB, 0.17794994E-05_JPRB, 0.17794757E-05_JPRB, 0.17794733E-05_JPRB, &
  & 0.17794542E-05_JPRB, 0.17794218E-05_JPRB, 0.17793584E-05_JPRB, 0.17792971E-05_JPRB, 0.17792163E-05_JPRB, 0.17791564E-05_JPRB, &
  & 0.17790652E-05_JPRB, 0.17789960E-05_JPRB, 0.17789616E-05_JPRB, 0.17789883E-05_JPRB, 0.17789670E-05_JPRB, 0.17789760E-05_JPRB, &
  & 0.17790246E-05_JPRB, 0.17790603E-05_JPRB, 0.17790554E-05_JPRB, 0.17790937E-05_JPRB, 0.17790978E-05_JPRB, 0.17790801E-05_JPRB, &
  & 0.17790322E-05_JPRB, 0.17790044E-05_JPRB, 0.17789718E-05_JPRB, 0.17788752E-05_JPRB, 0.17787950E-05_JPRB, 0.17787510E-05_JPRB, &
  & 0.17787083E-05_JPRB, 0.17786830E-05_JPRB, 0.17786750E-05_JPRB, 0.17787102E-05_JPRB, 0.17787474E-05_JPRB, 0.17788130E-05_JPRB, &
  & 0.17788923E-05_JPRB, 0.17789944E-05_JPRB, 0.17790665E-05_JPRB, 0.17791675E-05_JPRB, 0.17792313E-05_JPRB, 0.17793192E-05_JPRB, &
  & 0.17793424E-05_JPRB, 0.17794326E-05_JPRB, 0.17794360E-05_JPRB, 0.17794762E-05_JPRB, 0.17794829E-05_JPRB, 0.17794720E-05_JPRB, &
  & 0.17795040E-05_JPRB, 0.17794903E-05_JPRB, 0.17794752E-05_JPRB, 0.17794840E-05_JPRB, 0.17795053E-05_JPRB, 0.17794931E-05_JPRB, &
  & 0.17794753E-05_JPRB, 0.17794437E-05_JPRB, 0.17794509E-05_JPRB, 0.17795124E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART8',1,ZHOOK_HANDLE)
END SUBROUTINE PART8






SUBROUTINE PART9
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART9',0,ZHOOK_HANDLE)



!-- Month=  5 ------------

RGHG2(:, 1, 5) = (/ &
  & 0.72565980E-08_JPRB, 0.75611224E-08_JPRB, 0.76658289E-08_JPRB, 0.78140632E-08_JPRB, 0.80075271E-08_JPRB, 0.83440117E-08_JPRB, &
  & 0.88047889E-08_JPRB, 0.93790096E-08_JPRB, 0.10054285E-07_JPRB, 0.10816549E-07_JPRB, 0.11652310E-07_JPRB, 0.12562466E-07_JPRB, &
  & 0.13551185E-07_JPRB, 0.14611141E-07_JPRB, 0.15713663E-07_JPRB, 0.16807544E-07_JPRB, 0.17828254E-07_JPRB, 0.18713775E-07_JPRB, &
  & 0.19421282E-07_JPRB, 0.19939723E-07_JPRB, 0.20290182E-07_JPRB, 0.20541819E-07_JPRB, 0.20764887E-07_JPRB, 0.21059529E-07_JPRB, &
  & 0.21572529E-07_JPRB, 0.22454058E-07_JPRB, 0.23647916E-07_JPRB, 0.25019451E-07_JPRB, 0.26478871E-07_JPRB, 0.27842875E-07_JPRB, &
  & 0.28941608E-07_JPRB, 0.29675416E-07_JPRB, 0.30059756E-07_JPRB, 0.30010547E-07_JPRB, 0.29497663E-07_JPRB, 0.28550588E-07_JPRB, &
  & 0.27228271E-07_JPRB, 0.25610294E-07_JPRB, 0.23868083E-07_JPRB, 0.22348310E-07_JPRB, 0.21100355E-07_JPRB, 0.19887480E-07_JPRB, &
  & 0.18672154E-07_JPRB, 0.17370912E-07_JPRB, 0.15952768E-07_JPRB, 0.14373156E-07_JPRB, 0.12585541E-07_JPRB, 0.10552031E-07_JPRB, &
  & 0.81453297E-08_JPRB, 0.61038490E-08_JPRB, 0.47527720E-08_JPRB, 0.38561994E-08_JPRB, 0.32425871E-08_JPRB, 0.27990394E-08_JPRB, &
  & 0.24664080E-08_JPRB, 0.22086251E-08_JPRB, 0.19910344E-08_JPRB, 0.19123831E-08_JPRB, 0.19054693E-08_JPRB, 0.19248478E-08_JPRB, &
  & 0.19637538E-08_JPRB, 0.20081916E-08_JPRB, 0.20100142E-08_JPRB, 0.19032536E-08_JPRB /)

RGHG2(:, 2, 5) = (/ &
  & 0.76892208E-08_JPRB, 0.84298160E-08_JPRB, 0.90343821E-08_JPRB, 0.97790709E-08_JPRB, 0.10713098E-07_JPRB, 0.12019642E-07_JPRB, &
  & 0.13697226E-07_JPRB, 0.15701126E-07_JPRB, 0.17973635E-07_JPRB, 0.20469162E-07_JPRB, 0.23123764E-07_JPRB, 0.25813566E-07_JPRB, &
  & 0.28411005E-07_JPRB, 0.30854160E-07_JPRB, 0.33180747E-07_JPRB, 0.35460516E-07_JPRB, 0.37702360E-07_JPRB, 0.39835921E-07_JPRB, &
  & 0.41772203E-07_JPRB, 0.43461192E-07_JPRB, 0.44908028E-07_JPRB, 0.46150820E-07_JPRB, 0.47304855E-07_JPRB, 0.48539349E-07_JPRB, &
  & 0.50026955E-07_JPRB, 0.51894038E-07_JPRB, 0.54126936E-07_JPRB, 0.56678548E-07_JPRB, 0.59448702E-07_JPRB, 0.62255104E-07_JPRB, &
  & 0.64831333E-07_JPRB, 0.66839355E-07_JPRB, 0.67991785E-07_JPRB, 0.68194502E-07_JPRB, 0.67492124E-07_JPRB, 0.65976046E-07_JPRB, &
  & 0.63758293E-07_JPRB, 0.60963792E-07_JPRB, 0.57873923E-07_JPRB, 0.54777836E-07_JPRB, 0.51903470E-07_JPRB, 0.49109396E-07_JPRB, &
  & 0.46266344E-07_JPRB, 0.43229772E-07_JPRB, 0.39821131E-07_JPRB, 0.36034407E-07_JPRB, 0.31769794E-07_JPRB, 0.27065994E-07_JPRB, &
  & 0.22147139E-07_JPRB, 0.17918490E-07_JPRB, 0.14657688E-07_JPRB, 0.12253405E-07_JPRB, 0.10437133E-07_JPRB, 0.90769454E-08_JPRB, &
  & 0.80431812E-08_JPRB, 0.72885644E-08_JPRB, 0.67137487E-08_JPRB, 0.62927148E-08_JPRB, 0.59515965E-08_JPRB, 0.56459819E-08_JPRB, &
  & 0.53521343E-08_JPRB, 0.50331295E-08_JPRB, 0.46528132E-08_JPRB, 0.40148467E-08_JPRB /)

RGHG2(:, 3, 5) = (/ &
  & 0.83909146E-08_JPRB, 0.95054524E-08_JPRB, 0.10430671E-07_JPRB, 0.11470773E-07_JPRB, 0.12834809E-07_JPRB, 0.14632598E-07_JPRB, &
  & 0.16922865E-07_JPRB, 0.19591766E-07_JPRB, 0.22515602E-07_JPRB, 0.25672469E-07_JPRB, 0.29120789E-07_JPRB, 0.33047872E-07_JPRB, &
  & 0.37572342E-07_JPRB, 0.42581998E-07_JPRB, 0.47763109E-07_JPRB, 0.52828671E-07_JPRB, 0.57643721E-07_JPRB, 0.62139542E-07_JPRB, &
  & 0.66231067E-07_JPRB, 0.69842024E-07_JPRB, 0.72950201E-07_JPRB, 0.75600262E-07_JPRB, 0.77892395E-07_JPRB, 0.79974285E-07_JPRB, &
  & 0.82028308E-07_JPRB, 0.84154493E-07_JPRB, 0.86436316E-07_JPRB, 0.88836039E-07_JPRB, 0.91275624E-07_JPRB, 0.93546191E-07_JPRB, &
  & 0.95300486E-07_JPRB, 0.96197944E-07_JPRB, 0.96074686E-07_JPRB, 0.94982788E-07_JPRB, 0.93106920E-07_JPRB, 0.90677574E-07_JPRB, &
  & 0.87859043E-07_JPRB, 0.84684039E-07_JPRB, 0.81111502E-07_JPRB, 0.77448369E-07_JPRB, 0.73861152E-07_JPRB, 0.70347681E-07_JPRB, &
  & 0.66830211E-07_JPRB, 0.63152854E-07_JPRB, 0.59210983E-07_JPRB, 0.54885415E-07_JPRB, 0.50097491E-07_JPRB, 0.44825597E-07_JPRB, &
  & 0.39474479E-07_JPRB, 0.34463394E-07_JPRB, 0.30180789E-07_JPRB, 0.26536163E-07_JPRB, 0.23467393E-07_JPRB, 0.20821181E-07_JPRB, &
  & 0.18603767E-07_JPRB, 0.16734077E-07_JPRB, 0.15226513E-07_JPRB, 0.14012389E-07_JPRB, 0.13012778E-07_JPRB, 0.12165944E-07_JPRB, &
  & 0.11398371E-07_JPRB, 0.10661311E-07_JPRB, 0.98309823E-08_JPRB, 0.85060279E-08_JPRB /)

RGHG2(:, 4, 5) = (/ &
  & 0.87122061E-08_JPRB, 0.98679349E-08_JPRB, 0.10854381E-07_JPRB, 0.12108138E-07_JPRB, 0.13716575E-07_JPRB, 0.15901751E-07_JPRB, &
  & 0.18673870E-07_JPRB, 0.22014071E-07_JPRB, 0.25945535E-07_JPRB, 0.30492174E-07_JPRB, 0.35725972E-07_JPRB, 0.41563528E-07_JPRB, &
  & 0.47939523E-07_JPRB, 0.54783559E-07_JPRB, 0.61840659E-07_JPRB, 0.68647140E-07_JPRB, 0.74961306E-07_JPRB, 0.80943785E-07_JPRB, &
  & 0.86757652E-07_JPRB, 0.92277503E-07_JPRB, 0.97251814E-07_JPRB, 0.10153403E-06_JPRB, 0.10512964E-06_JPRB, 0.10813092E-06_JPRB, &
  & 0.11061422E-06_JPRB, 0.11270147E-06_JPRB, 0.11444598E-06_JPRB, 0.11586728E-06_JPRB, 0.11687241E-06_JPRB, 0.11727114E-06_JPRB, &
  & 0.11682772E-06_JPRB, 0.11537172E-06_JPRB, 0.11293419E-06_JPRB, 0.10985391E-06_JPRB, 0.10657018E-06_JPRB, 0.10325736E-06_JPRB, &
  & 0.99743218E-07_JPRB, 0.95902209E-07_JPRB, 0.91895245E-07_JPRB, 0.87726676E-07_JPRB, 0.83473594E-07_JPRB, 0.79158447E-07_JPRB, &
  & 0.74820022E-07_JPRB, 0.70496739E-07_JPRB, 0.66195213E-07_JPRB, 0.61938898E-07_JPRB, 0.57751489E-07_JPRB, 0.53685550E-07_JPRB, &
  & 0.49687500E-07_JPRB, 0.45857259E-07_JPRB, 0.42197257E-07_JPRB, 0.38775234E-07_JPRB, 0.35505959E-07_JPRB, 0.32405982E-07_JPRB, &
  & 0.29477285E-07_JPRB, 0.26844289E-07_JPRB, 0.24507855E-07_JPRB, 0.22506216E-07_JPRB, 0.20807420E-07_JPRB, 0.19336806E-07_JPRB, &
  & 0.18049599E-07_JPRB, 0.16864551E-07_JPRB, 0.15689205E-07_JPRB, 0.13963523E-07_JPRB /)

RGHG2(:, 5, 5) = (/ &
  & 0.87317114E-08_JPRB, 0.99178976E-08_JPRB, 0.11107533E-07_JPRB, 0.12579488E-07_JPRB, 0.14562602E-07_JPRB, 0.17162082E-07_JPRB, &
  & 0.20469667E-07_JPRB, 0.24469296E-07_JPRB, 0.29098917E-07_JPRB, 0.34480429E-07_JPRB, 0.40696367E-07_JPRB, 0.47847756E-07_JPRB, &
  & 0.55770219E-07_JPRB, 0.64140124E-07_JPRB, 0.72895538E-07_JPRB, 0.82114859E-07_JPRB, 0.91273172E-07_JPRB, 0.99464359E-07_JPRB, &
  & 0.10636582E-06_JPRB, 0.11230662E-06_JPRB, 0.11759554E-06_JPRB, 0.12228250E-06_JPRB, 0.12630515E-06_JPRB, 0.12962620E-06_JPRB, &
  & 0.13223816E-06_JPRB, 0.13414015E-06_JPRB, 0.13533766E-06_JPRB, 0.13577773E-06_JPRB, 0.13538025E-06_JPRB, 0.13401859E-06_JPRB, &
  & 0.13156841E-06_JPRB, 0.12809976E-06_JPRB, 0.12393460E-06_JPRB, 0.11943355E-06_JPRB, 0.11475527E-06_JPRB, 0.11000800E-06_JPRB, &
  & 0.10548692E-06_JPRB, 0.10129211E-06_JPRB, 0.97130027E-07_JPRB, 0.92789698E-07_JPRB, 0.88206470E-07_JPRB, 0.83482632E-07_JPRB, &
  & 0.78794407E-07_JPRB, 0.74242166E-07_JPRB, 0.69932035E-07_JPRB, 0.65848781E-07_JPRB, 0.61961330E-07_JPRB, 0.58259715E-07_JPRB, &
  & 0.54731991E-07_JPRB, 0.51429776E-07_JPRB, 0.48311747E-07_JPRB, 0.45286836E-07_JPRB, 0.42330946E-07_JPRB, 0.39457451E-07_JPRB, &
  & 0.36691585E-07_JPRB, 0.33998475E-07_JPRB, 0.31433707E-07_JPRB, 0.29103747E-07_JPRB, 0.27008413E-07_JPRB, 0.25173719E-07_JPRB, &
  & 0.23565523E-07_JPRB, 0.22126537E-07_JPRB, 0.20686354E-07_JPRB, 0.18582391E-07_JPRB /)

RGHG2(:, 6, 5) = (/ &
  & 0.92353440E-08_JPRB, 0.11385692E-07_JPRB, 0.13206644E-07_JPRB, 0.15194860E-07_JPRB, 0.17558158E-07_JPRB, 0.20505507E-07_JPRB, &
  & 0.24078108E-07_JPRB, 0.28379409E-07_JPRB, 0.33470201E-07_JPRB, 0.39460328E-07_JPRB, 0.46452463E-07_JPRB, 0.54443994E-07_JPRB, &
  & 0.63378714E-07_JPRB, 0.72971957E-07_JPRB, 0.82546464E-07_JPRB, 0.91431524E-07_JPRB, 0.99732802E-07_JPRB, 0.10775904E-06_JPRB, &
  & 0.11518122E-06_JPRB, 0.12152549E-06_JPRB, 0.12689105E-06_JPRB, 0.13164036E-06_JPRB, 0.13593845E-06_JPRB, 0.13973505E-06_JPRB, &
  & 0.14290265E-06_JPRB, 0.14532857E-06_JPRB, 0.14688865E-06_JPRB, 0.14744916E-06_JPRB, 0.14683661E-06_JPRB, 0.14487296E-06_JPRB, &
  & 0.14155276E-06_JPRB, 0.13704783E-06_JPRB, 0.13163672E-06_JPRB, 0.12578573E-06_JPRB, 0.12015971E-06_JPRB, 0.11511835E-06_JPRB, &
  & 0.11042260E-06_JPRB, 0.10570489E-06_JPRB, 0.10091588E-06_JPRB, 0.96141058E-07_JPRB, 0.91410961E-07_JPRB, 0.86723560E-07_JPRB, &
  & 0.82103561E-07_JPRB, 0.77652373E-07_JPRB, 0.73472890E-07_JPRB, 0.69577780E-07_JPRB, 0.65992715E-07_JPRB, 0.62670054E-07_JPRB, &
  & 0.59483774E-07_JPRB, 0.56401589E-07_JPRB, 0.53423960E-07_JPRB, 0.50499320E-07_JPRB, 0.47582642E-07_JPRB, 0.44716550E-07_JPRB, &
  & 0.41921226E-07_JPRB, 0.39179913E-07_JPRB, 0.36496047E-07_JPRB, 0.33976786E-07_JPRB, 0.31674396E-07_JPRB, 0.29583159E-07_JPRB, &
  & 0.27759773E-07_JPRB, 0.26137482E-07_JPRB, 0.24578082E-07_JPRB, 0.22353911E-07_JPRB /)

RGHG2(:, 7, 5) = (/ &
  & 0.11770425E-07_JPRB, 0.16055525E-07_JPRB, 0.18976399E-07_JPRB, 0.21807780E-07_JPRB, 0.24918199E-07_JPRB, 0.28397148E-07_JPRB, &
  & 0.32415542E-07_JPRB, 0.36906080E-07_JPRB, 0.41962807E-07_JPRB, 0.47711104E-07_JPRB, 0.54282566E-07_JPRB, 0.61689178E-07_JPRB, &
  & 0.69717480E-07_JPRB, 0.78055891E-07_JPRB, 0.86501615E-07_JPRB, 0.94868554E-07_JPRB, 0.10260646E-06_JPRB, 0.10946395E-06_JPRB, &
  & 0.11583101E-06_JPRB, 0.12200984E-06_JPRB, 0.12773351E-06_JPRB, 0.13289508E-06_JPRB, 0.13782247E-06_JPRB, 0.14269612E-06_JPRB, &
  & 0.14726488E-06_JPRB, 0.15122272E-06_JPRB, 0.15423453E-06_JPRB, 0.15590921E-06_JPRB, 0.15592489E-06_JPRB, 0.15422997E-06_JPRB, &
  & 0.15090878E-06_JPRB, 0.14622395E-06_JPRB, 0.14065319E-06_JPRB, 0.13467044E-06_JPRB, 0.12854093E-06_JPRB, 0.12246355E-06_JPRB, &
  & 0.11672716E-06_JPRB, 0.11154211E-06_JPRB, 0.10681581E-06_JPRB, 0.10220078E-06_JPRB, 0.97423268E-07_JPRB, 0.92508579E-07_JPRB, &
  & 0.87688477E-07_JPRB, 0.83122700E-07_JPRB, 0.78858001E-07_JPRB, 0.74903440E-07_JPRB, 0.71156038E-07_JPRB, 0.67568905E-07_JPRB, &
  & 0.64144245E-07_JPRB, 0.60879266E-07_JPRB, 0.57736944E-07_JPRB, 0.54645898E-07_JPRB, 0.51616894E-07_JPRB, 0.48696414E-07_JPRB, &
  & 0.45842846E-07_JPRB, 0.43037392E-07_JPRB, 0.40292612E-07_JPRB, 0.37784755E-07_JPRB, 0.35486671E-07_JPRB, 0.33467543E-07_JPRB, &
  & 0.31699400E-07_JPRB, 0.30162621E-07_JPRB, 0.28656141E-07_JPRB, 0.26407868E-07_JPRB /)

RGHG2(:, 8, 5) = (/ &
  & 0.17847388E-07_JPRB, 0.24664029E-07_JPRB, 0.28721365E-07_JPRB, 0.32193409E-07_JPRB, 0.35569865E-07_JPRB, 0.39114838E-07_JPRB, &
  & 0.42803968E-07_JPRB, 0.46802057E-07_JPRB, 0.51085433E-07_JPRB, 0.55794015E-07_JPRB, 0.61015093E-07_JPRB, 0.66795366E-07_JPRB, &
  & 0.73116581E-07_JPRB, 0.79782978E-07_JPRB, 0.86490836E-07_JPRB, 0.92993275E-07_JPRB, 0.99417342E-07_JPRB, 0.10572722E-06_JPRB, &
  & 0.11166141E-06_JPRB, 0.11726304E-06_JPRB, 0.12308870E-06_JPRB, 0.12929800E-06_JPRB, 0.13555257E-06_JPRB, 0.14209317E-06_JPRB, &
  & 0.14909773E-06_JPRB, 0.15571861E-06_JPRB, 0.16120958E-06_JPRB, 0.16503861E-06_JPRB, 0.16692080E-06_JPRB, 0.16654042E-06_JPRB, &
  & 0.16377460E-06_JPRB, 0.15906595E-06_JPRB, 0.15309766E-06_JPRB, 0.14659581E-06_JPRB, 0.14022589E-06_JPRB, 0.13430510E-06_JPRB, &
  & 0.12879109E-06_JPRB, 0.12342497E-06_JPRB, 0.11800047E-06_JPRB, 0.11252726E-06_JPRB, 0.10714031E-06_JPRB, 0.10192981E-06_JPRB, &
  & 0.96829659E-07_JPRB, 0.91845678E-07_JPRB, 0.87029619E-07_JPRB, 0.82399453E-07_JPRB, 0.77969467E-07_JPRB, 0.73764362E-07_JPRB, &
  & 0.69787959E-07_JPRB, 0.65970859E-07_JPRB, 0.62280755E-07_JPRB, 0.58739669E-07_JPRB, 0.55395045E-07_JPRB, 0.52230639E-07_JPRB, &
  & 0.49208094E-07_JPRB, 0.46342173E-07_JPRB, 0.43653440E-07_JPRB, 0.41317570E-07_JPRB, 0.39330143E-07_JPRB, 0.37661209E-07_JPRB, &
  & 0.36310393E-07_JPRB, 0.35185952E-07_JPRB, 0.34123524E-07_JPRB, 0.32484913E-07_JPRB /)

RGHG2(:, 9, 5) = (/ &
  & 0.26860633E-07_JPRB, 0.34006682E-07_JPRB, 0.37669555E-07_JPRB, 0.40719918E-07_JPRB, 0.43638753E-07_JPRB, 0.46592969E-07_JPRB, &
  & 0.49738880E-07_JPRB, 0.53037098E-07_JPRB, 0.56574542E-07_JPRB, 0.60396815E-07_JPRB, 0.64572504E-07_JPRB, 0.69122322E-07_JPRB, &
  & 0.74017834E-07_JPRB, 0.79220385E-07_JPRB, 0.84654921E-07_JPRB, 0.90217938E-07_JPRB, 0.95728893E-07_JPRB, 0.10126084E-06_JPRB, &
  & 0.10706943E-06_JPRB, 0.11333039E-06_JPRB, 0.11992688E-06_JPRB, 0.12727409E-06_JPRB, 0.13604991E-06_JPRB, 0.14568765E-06_JPRB, &
  & 0.15517354E-06_JPRB, 0.16467118E-06_JPRB, 0.17296236E-06_JPRB, 0.17925342E-06_JPRB, 0.18307844E-06_JPRB, 0.18428901E-06_JPRB, &
  & 0.18313590E-06_JPRB, 0.17995876E-06_JPRB, 0.17524681E-06_JPRB, 0.16966339E-06_JPRB, 0.16368146E-06_JPRB, 0.15754721E-06_JPRB, &
  & 0.15139703E-06_JPRB, 0.14525440E-06_JPRB, 0.13909201E-06_JPRB, 0.13283372E-06_JPRB, 0.12638534E-06_JPRB, 0.11980758E-06_JPRB, &
  & 0.11335625E-06_JPRB, 0.10714309E-06_JPRB, 0.10119516E-06_JPRB, 0.95477873E-07_JPRB, 0.89958007E-07_JPRB, 0.84628418E-07_JPRB, &
  & 0.79515033E-07_JPRB, 0.74561250E-07_JPRB, 0.69806589E-07_JPRB, 0.65366450E-07_JPRB, 0.61311880E-07_JPRB, 0.57596516E-07_JPRB, &
  & 0.54180539E-07_JPRB, 0.51086072E-07_JPRB, 0.48347918E-07_JPRB, 0.46178751E-07_JPRB, 0.44496069E-07_JPRB, 0.43248761E-07_JPRB, &
  & 0.42352315E-07_JPRB, 0.41718533E-07_JPRB, 0.41209976E-07_JPRB, 0.40513967E-07_JPRB /)

RGHG2(:,10, 5) = (/ &
  & 0.37454441E-07_JPRB, 0.44196064E-07_JPRB, 0.48009781E-07_JPRB, 0.51197972E-07_JPRB, 0.54373931E-07_JPRB, 0.57730354E-07_JPRB, &
  & 0.61388448E-07_JPRB, 0.65523110E-07_JPRB, 0.70102722E-07_JPRB, 0.75206870E-07_JPRB, 0.80807254E-07_JPRB, 0.86804206E-07_JPRB, &
  & 0.93020780E-07_JPRB, 0.99221573E-07_JPRB, 0.10519097E-06_JPRB, 0.11077504E-06_JPRB, 0.11605996E-06_JPRB, 0.12119035E-06_JPRB, &
  & 0.12642941E-06_JPRB, 0.13208921E-06_JPRB, 0.13876378E-06_JPRB, 0.14671261E-06_JPRB, 0.15585765E-06_JPRB, 0.16623601E-06_JPRB, &
  & 0.17762011E-06_JPRB, 0.18790304E-06_JPRB, 0.19690748E-06_JPRB, 0.20419156E-06_JPRB, 0.20954505E-06_JPRB, 0.21300598E-06_JPRB, &
  & 0.21457268E-06_JPRB, 0.21423025E-06_JPRB, 0.21227547E-06_JPRB, 0.20898713E-06_JPRB, 0.20456768E-06_JPRB, 0.19912906E-06_JPRB, &
  & 0.19269757E-06_JPRB, 0.18530137E-06_JPRB, 0.17715942E-06_JPRB, 0.16853339E-06_JPRB, 0.15967073E-06_JPRB, 0.15088989E-06_JPRB, &
  & 0.14227311E-06_JPRB, 0.13391642E-06_JPRB, 0.12587117E-06_JPRB, 0.11814103E-06_JPRB, 0.11066713E-06_JPRB, 0.10344267E-06_JPRB, &
  & 0.96401592E-07_JPRB, 0.89604526E-07_JPRB, 0.83227903E-07_JPRB, 0.77439928E-07_JPRB, 0.72253215E-07_JPRB, 0.67654867E-07_JPRB, &
  & 0.63633586E-07_JPRB, 0.60166876E-07_JPRB, 0.57249576E-07_JPRB, 0.55088314E-07_JPRB, 0.53566161E-07_JPRB, 0.52565991E-07_JPRB, &
  & 0.51977718E-07_JPRB, 0.51684214E-07_JPRB, 0.51581079E-07_JPRB, 0.51552497E-07_JPRB /)

RGHG2(:,11, 5) = (/ &
  & 0.54074203E-07_JPRB, 0.63883896E-07_JPRB, 0.69569879E-07_JPRB, 0.74750439E-07_JPRB, 0.79902875E-07_JPRB, 0.85660574E-07_JPRB, &
  & 0.92345502E-07_JPRB, 0.10017906E-06_JPRB, 0.10939794E-06_JPRB, 0.12001408E-06_JPRB, 0.13194085E-06_JPRB, 0.14485107E-06_JPRB, &
  & 0.15820711E-06_JPRB, 0.17131464E-06_JPRB, 0.18331302E-06_JPRB, 0.19347661E-06_JPRB, 0.20135991E-06_JPRB, 0.20701192E-06_JPRB, &
  & 0.21079103E-06_JPRB, 0.21343570E-06_JPRB, 0.21565786E-06_JPRB, 0.21808563E-06_JPRB, 0.22131994E-06_JPRB, 0.22549355E-06_JPRB, &
  & 0.23013709E-06_JPRB, 0.23562144E-06_JPRB, 0.24111330E-06_JPRB, 0.24662054E-06_JPRB, 0.25223920E-06_JPRB, 0.25747028E-06_JPRB, &
  & 0.26215406E-06_JPRB, 0.26637562E-06_JPRB, 0.26948604E-06_JPRB, 0.27052309E-06_JPRB, 0.26933165E-06_JPRB, 0.26558422E-06_JPRB, &
  & 0.25926832E-06_JPRB, 0.25055158E-06_JPRB, 0.23985115E-06_JPRB, 0.22774816E-06_JPRB, 0.21492615E-06_JPRB, 0.20204614E-06_JPRB, &
  & 0.18957498E-06_JPRB, 0.17768370E-06_JPRB, 0.16635487E-06_JPRB, 0.15541646E-06_JPRB, 0.14478411E-06_JPRB, 0.13438542E-06_JPRB, &
  & 0.12436867E-06_JPRB, 0.11496653E-06_JPRB, 0.10638514E-06_JPRB, 0.98673944E-07_JPRB, 0.91866347E-07_JPRB, 0.85992880E-07_JPRB, &
  & 0.81044114E-07_JPRB, 0.76955104E-07_JPRB, 0.73656018E-07_JPRB, 0.71292362E-07_JPRB, 0.69684106E-07_JPRB, 0.68682127E-07_JPRB, &
  & 0.68144054E-07_JPRB, 0.67955355E-07_JPRB, 0.68049381E-07_JPRB, 0.68539492E-07_JPRB /)

RGHG2(:,12, 5) = (/ &
  & 0.87196987E-07_JPRB, 0.10178934E-06_JPRB, 0.11072462E-06_JPRB, 0.11851886E-06_JPRB, 0.12690175E-06_JPRB, 0.13628174E-06_JPRB, &
  & 0.14750550E-06_JPRB, 0.16106560E-06_JPRB, 0.17711292E-06_JPRB, 0.19576422E-06_JPRB, 0.21669169E-06_JPRB, 0.23928337E-06_JPRB, &
  & 0.26255668E-06_JPRB, 0.28532091E-06_JPRB, 0.30613978E-06_JPRB, 0.32366913E-06_JPRB, 0.33681627E-06_JPRB, 0.34514017E-06_JPRB, &
  & 0.34855768E-06_JPRB, 0.34760640E-06_JPRB, 0.34326391E-06_JPRB, 0.33691097E-06_JPRB, 0.32963496E-06_JPRB, 0.32265615E-06_JPRB, &
  & 0.31682006E-06_JPRB, 0.31275422E-06_JPRB, 0.31110403E-06_JPRB, 0.31166090E-06_JPRB, 0.31457625E-06_JPRB, 0.32047123E-06_JPRB, &
  & 0.32840802E-06_JPRB, 0.33729813E-06_JPRB, 0.34583437E-06_JPRB, 0.35332997E-06_JPRB, 0.35744048E-06_JPRB, 0.35710951E-06_JPRB, &
  & 0.35224869E-06_JPRB, 0.34302025E-06_JPRB, 0.33011045E-06_JPRB, 0.31456440E-06_JPRB, 0.29743427E-06_JPRB, 0.27984919E-06_JPRB, &
  & 0.26249097E-06_JPRB, 0.24575004E-06_JPRB, 0.22962698E-06_JPRB, 0.21410617E-06_JPRB, 0.19909722E-06_JPRB, 0.18466690E-06_JPRB, &
  & 0.17096025E-06_JPRB, 0.15810265E-06_JPRB, 0.14619259E-06_JPRB, 0.13536366E-06_JPRB, 0.12575725E-06_JPRB, 0.11749032E-06_JPRB, &
  & 0.11057450E-06_JPRB, 0.10492678E-06_JPRB, 0.10041749E-06_JPRB, 0.97134965E-07_JPRB, 0.94839606E-07_JPRB, 0.93336610E-07_JPRB, &
  & 0.92474991E-07_JPRB, 0.92144013E-07_JPRB, 0.92350064E-07_JPRB, 0.93604321E-07_JPRB /)

RGHG2(:,13, 5) = (/ &
  & 0.14305091E-06_JPRB, 0.16072350E-06_JPRB, 0.17136729E-06_JPRB, 0.18159682E-06_JPRB, 0.19243969E-06_JPRB, 0.20528132E-06_JPRB, &
  & 0.22077036E-06_JPRB, 0.23959137E-06_JPRB, 0.26198296E-06_JPRB, 0.28776032E-06_JPRB, 0.31642236E-06_JPRB, 0.34695384E-06_JPRB, &
  & 0.37789249E-06_JPRB, 0.40767119E-06_JPRB, 0.43453201E-06_JPRB, 0.45683569E-06_JPRB, 0.47326554E-06_JPRB, 0.48320186E-06_JPRB, &
  & 0.48648786E-06_JPRB, 0.48363466E-06_JPRB, 0.47572723E-06_JPRB, 0.46424810E-06_JPRB, 0.45094077E-06_JPRB, 0.43730415E-06_JPRB, &
  & 0.42486030E-06_JPRB, 0.41449633E-06_JPRB, 0.40682437E-06_JPRB, 0.40280372E-06_JPRB, 0.40272559E-06_JPRB, 0.40677389E-06_JPRB, &
  & 0.41546400E-06_JPRB, 0.42666537E-06_JPRB, 0.43972301E-06_JPRB, 0.45033104E-06_JPRB, 0.45829907E-06_JPRB, 0.46224727E-06_JPRB, &
  & 0.46093840E-06_JPRB, 0.45406418E-06_JPRB, 0.44219240E-06_JPRB, 0.42628290E-06_JPRB, 0.40748034E-06_JPRB, 0.38702942E-06_JPRB, &
  & 0.36592610E-06_JPRB, 0.34472126E-06_JPRB, 0.32382655E-06_JPRB, 0.30342235E-06_JPRB, 0.28363849E-06_JPRB, 0.26459415E-06_JPRB, &
  & 0.24636711E-06_JPRB, 0.22911507E-06_JPRB, 0.21300880E-06_JPRB, 0.19819916E-06_JPRB, 0.18483684E-06_JPRB, 0.17305203E-06_JPRB, &
  & 0.16290316E-06_JPRB, 0.15436646E-06_JPRB, 0.14736821E-06_JPRB, 0.14206704E-06_JPRB, 0.13821860E-06_JPRB, 0.13563302E-06_JPRB, &
  & 0.13416718E-06_JPRB, 0.13376820E-06_JPRB, 0.13461819E-06_JPRB, 0.13838985E-06_JPRB /)

RGHG2(:,14, 5) = (/ &
  & 0.22265884E-06_JPRB, 0.23912193E-06_JPRB, 0.25009189E-06_JPRB, 0.26080997E-06_JPRB, 0.27307306E-06_JPRB, 0.28782881E-06_JPRB, &
  & 0.30601009E-06_JPRB, 0.32835527E-06_JPRB, 0.35488426E-06_JPRB, 0.38535046E-06_JPRB, 0.41883555E-06_JPRB, 0.45414041E-06_JPRB, &
  & 0.48941820E-06_JPRB, 0.52263766E-06_JPRB, 0.55216185E-06_JPRB, 0.57631553E-06_JPRB, 0.59395700E-06_JPRB, 0.60462378E-06_JPRB, &
  & 0.60855751E-06_JPRB, 0.60641088E-06_JPRB, 0.59914748E-06_JPRB, 0.58811730E-06_JPRB, 0.57483601E-06_JPRB, 0.56095945E-06_JPRB, &
  & 0.54759607E-06_JPRB, 0.53582096E-06_JPRB, 0.52640468E-06_JPRB, 0.52013121E-06_JPRB, 0.51817005E-06_JPRB, 0.52060579E-06_JPRB, &
  & 0.52771259E-06_JPRB, 0.53890636E-06_JPRB, 0.55000294E-06_JPRB, 0.56192181E-06_JPRB, 0.57080814E-06_JPRB, 0.57580974E-06_JPRB, &
  & 0.57701521E-06_JPRB, 0.57379583E-06_JPRB, 0.56581348E-06_JPRB, 0.55327246E-06_JPRB, 0.53668469E-06_JPRB, 0.51697072E-06_JPRB, &
  & 0.49493468E-06_JPRB, 0.47142527E-06_JPRB, 0.44713394E-06_JPRB, 0.42268107E-06_JPRB, 0.39860058E-06_JPRB, 0.37527212E-06_JPRB, &
  & 0.35306343E-06_JPRB, 0.33214636E-06_JPRB, 0.31257446E-06_JPRB, 0.29434258E-06_JPRB, 0.27750252E-06_JPRB, 0.26215179E-06_JPRB, &
  & 0.24840782E-06_JPRB, 0.23639964E-06_JPRB, 0.22622700E-06_JPRB, 0.21827474E-06_JPRB, 0.21241476E-06_JPRB, 0.20854034E-06_JPRB, &
  & 0.20660707E-06_JPRB, 0.20672231E-06_JPRB, 0.20950779E-06_JPRB, 0.21920927E-06_JPRB /)

RGHG2(:,15, 5) = (/ &
  & 0.32518980E-06_JPRB, 0.33690915E-06_JPRB, 0.34539798E-06_JPRB, 0.35504155E-06_JPRB, 0.36669451E-06_JPRB, 0.38138080E-06_JPRB, &
  & 0.40017210E-06_JPRB, 0.42345482E-06_JPRB, 0.45147914E-06_JPRB, 0.48371203E-06_JPRB, 0.51910405E-06_JPRB, 0.55603027E-06_JPRB, &
  & 0.59267848E-06_JPRB, 0.62692197E-06_JPRB, 0.65700726E-06_JPRB, 0.68202343E-06_JPRB, 0.70103852E-06_JPRB, 0.71379191E-06_JPRB, &
  & 0.72063449E-06_JPRB, 0.72225987E-06_JPRB, 0.71956242E-06_JPRB, 0.71365980E-06_JPRB, 0.70573617E-06_JPRB, 0.69684353E-06_JPRB, &
  & 0.68781657E-06_JPRB, 0.67933559E-06_JPRB, 0.67210544E-06_JPRB, 0.66641212E-06_JPRB, 0.66272457E-06_JPRB, 0.66172959E-06_JPRB, &
  & 0.66258406E-06_JPRB, 0.66544487E-06_JPRB, 0.67076405E-06_JPRB, 0.67679525E-06_JPRB, 0.68387340E-06_JPRB, 0.69021826E-06_JPRB, &
  & 0.69412425E-06_JPRB, 0.69523765E-06_JPRB, 0.69289598E-06_JPRB, 0.68630385E-06_JPRB, 0.67513287E-06_JPRB, 0.65940185E-06_JPRB, &
  & 0.63960749E-06_JPRB, 0.61648927E-06_JPRB, 0.59105781E-06_JPRB, 0.56443344E-06_JPRB, 0.53759413E-06_JPRB, 0.51138659E-06_JPRB, &
  & 0.48627561E-06_JPRB, 0.46257369E-06_JPRB, 0.44031179E-06_JPRB, 0.41936809E-06_JPRB, 0.39966375E-06_JPRB, 0.38126345E-06_JPRB, &
  & 0.36438567E-06_JPRB, 0.34931657E-06_JPRB, 0.33635433E-06_JPRB, 0.32614503E-06_JPRB, 0.31871193E-06_JPRB, 0.31408689E-06_JPRB, &
  & 0.31237369E-06_JPRB, 0.31388822E-06_JPRB, 0.31996518E-06_JPRB, 0.33813180E-06_JPRB /)

RGHG2(:,16, 5) = (/ &
  & 0.44215238E-06_JPRB, 0.44792148E-06_JPRB, 0.45278068E-06_JPRB, 0.45974446E-06_JPRB, 0.46916514E-06_JPRB, 0.48225195E-06_JPRB, &
  & 0.49947045E-06_JPRB, 0.52165677E-06_JPRB, 0.54874721E-06_JPRB, 0.58035550E-06_JPRB, 0.61530460E-06_JPRB, 0.65180706E-06_JPRB, &
  & 0.68793071E-06_JPRB, 0.72179330E-06_JPRB, 0.75173182E-06_JPRB, 0.77701736E-06_JPRB, 0.79772860E-06_JPRB, 0.81385565E-06_JPRB, &
  & 0.82570068E-06_JPRB, 0.83381366E-06_JPRB, 0.83883441E-06_JPRB, 0.84154556E-06_JPRB, 0.84275155E-06_JPRB, 0.84297233E-06_JPRB, &
  & 0.84262780E-06_JPRB, 0.84154703E-06_JPRB, 0.83983963E-06_JPRB, 0.83682050E-06_JPRB, 0.83253258E-06_JPRB, 0.82690639E-06_JPRB, &
  & 0.82051065E-06_JPRB, 0.81421979E-06_JPRB, 0.80873190E-06_JPRB, 0.80504816E-06_JPRB, 0.80379863E-06_JPRB, 0.80571488E-06_JPRB, &
  & 0.81009006E-06_JPRB, 0.81486826E-06_JPRB, 0.81810822E-06_JPRB, 0.81817467E-06_JPRB, 0.81359411E-06_JPRB, 0.80357802E-06_JPRB, &
  & 0.78798519E-06_JPRB, 0.76740923E-06_JPRB, 0.74295690E-06_JPRB, 0.71605797E-06_JPRB, 0.68810471E-06_JPRB, 0.66009852E-06_JPRB, &
  & 0.63295050E-06_JPRB, 0.60709783E-06_JPRB, 0.58264635E-06_JPRB, 0.55945861E-06_JPRB, 0.53743616E-06_JPRB, 0.51668906E-06_JPRB, &
  & 0.49755062E-06_JPRB, 0.48043177E-06_JPRB, 0.46577679E-06_JPRB, 0.45440893E-06_JPRB, 0.44646464E-06_JPRB, 0.44205768E-06_JPRB, &
  & 0.44135072E-06_JPRB, 0.44490054E-06_JPRB, 0.45478509E-06_JPRB, 0.48061895E-06_JPRB /)

RGHG2(:,17, 5) = (/ &
  & 0.56237917E-06_JPRB, 0.56204368E-06_JPRB, 0.56354884E-06_JPRB, 0.56741555E-06_JPRB, 0.57429776E-06_JPRB, 0.58470965E-06_JPRB, &
  & 0.59965885E-06_JPRB, 0.61952784E-06_JPRB, 0.64450751E-06_JPRB, 0.67403175E-06_JPRB, 0.70709456E-06_JPRB, 0.74205417E-06_JPRB, &
  & 0.77678988E-06_JPRB, 0.80975985E-06_JPRB, 0.83968564E-06_JPRB, 0.86571583E-06_JPRB, 0.88803199E-06_JPRB, 0.90737012E-06_JPRB, &
  & 0.92427541E-06_JPRB, 0.93925058E-06_JPRB, 0.95280632E-06_JPRB, 0.96515157E-06_JPRB, 0.97639554E-06_JPRB, 0.98665112E-06_JPRB, &
  & 0.99569695E-06_JPRB, 0.10028321E-05_JPRB, 0.10073265E-05_JPRB, 0.10080914E-05_JPRB, 0.10044264E-05_JPRB, 0.99583781E-06_JPRB, &
  & 0.98328360E-06_JPRB, 0.96828990E-06_JPRB, 0.95294433E-06_JPRB, 0.93974660E-06_JPRB, 0.93045054E-06_JPRB, 0.92632052E-06_JPRB, &
  & 0.92756113E-06_JPRB, 0.93296097E-06_JPRB, 0.93945692E-06_JPRB, 0.94448785E-06_JPRB, 0.94558970E-06_JPRB, 0.94097561E-06_JPRB, &
  & 0.92987841E-06_JPRB, 0.91263286E-06_JPRB, 0.89030726E-06_JPRB, 0.86439809E-06_JPRB, 0.83620574E-06_JPRB, 0.80727563E-06_JPRB, &
  & 0.77884329E-06_JPRB, 0.75164206E-06_JPRB, 0.72568361E-06_JPRB, 0.70080256E-06_JPRB, 0.67707316E-06_JPRB, 0.65478548E-06_JPRB, &
  & 0.63437153E-06_JPRB, 0.61634228E-06_JPRB, 0.60120476E-06_JPRB, 0.58979742E-06_JPRB, 0.58226715E-06_JPRB, 0.57866987E-06_JPRB, &
  & 0.57923802E-06_JPRB, 0.58450695E-06_JPRB, 0.59688557E-06_JPRB, 0.62745107E-06_JPRB /)

RGHG2(:,18, 5) = (/ &
  & 0.67788147E-06_JPRB, 0.67252233E-06_JPRB, 0.67132993E-06_JPRB, 0.67281951E-06_JPRB, 0.67720833E-06_JPRB, 0.68528811E-06_JPRB, &
  & 0.69764536E-06_JPRB, 0.71509231E-06_JPRB, 0.73756939E-06_JPRB, 0.76468132E-06_JPRB, 0.79530969E-06_JPRB, 0.82796817E-06_JPRB, &
  & 0.86098942E-06_JPRB, 0.89259373E-06_JPRB, 0.92205380E-06_JPRB, 0.94897047E-06_JPRB, 0.97320992E-06_JPRB, 0.99521594E-06_JPRB, &
  & 0.10158077E-05_JPRB, 0.10356659E-05_JPRB, 0.10550308E-05_JPRB, 0.10740437E-05_JPRB, 0.10927366E-05_JPRB, 0.11108029E-05_JPRB, &
  & 0.11274733E-05_JPRB, 0.11416557E-05_JPRB, 0.11520949E-05_JPRB, 0.11571921E-05_JPRB, 0.11558159E-05_JPRB, 0.11475402E-05_JPRB, &
  & 0.11330145E-05_JPRB, 0.11140060E-05_JPRB, 0.10929444E-05_JPRB, 0.10729680E-05_JPRB, 0.10573083E-05_JPRB, 0.10479831E-05_JPRB, &
  & 0.10457095E-05_JPRB, 0.10493648E-05_JPRB, 0.10565562E-05_JPRB, 0.10637875E-05_JPRB, 0.10677829E-05_JPRB, 0.10664362E-05_JPRB, &
  & 0.10584971E-05_JPRB, 0.10439016E-05_JPRB, 0.10235519E-05_JPRB, 0.99876775E-06_JPRB, 0.97122472E-06_JPRB, 0.94255591E-06_JPRB, &
  & 0.91404303E-06_JPRB, 0.88620868E-06_JPRB, 0.85917748E-06_JPRB, 0.83314757E-06_JPRB, 0.80844012E-06_JPRB, 0.78549658E-06_JPRB, &
  & 0.76483650E-06_JPRB, 0.74698369E-06_JPRB, 0.73234435E-06_JPRB, 0.72165778E-06_JPRB, 0.71497851E-06_JPRB, 0.71233939E-06_JPRB, &
  & 0.71382527E-06_JPRB, 0.71995777E-06_JPRB, 0.73290198E-06_JPRB, 0.76400977E-06_JPRB /)

RGHG2(:,19, 5) = (/ &
  & 0.78401786E-06_JPRB, 0.77616085E-06_JPRB, 0.77345265E-06_JPRB, 0.77343611E-06_JPRB, 0.77616335E-06_JPRB, 0.78219796E-06_JPRB, &
  & 0.79247150E-06_JPRB, 0.80750010E-06_JPRB, 0.82748960E-06_JPRB, 0.85205698E-06_JPRB, 0.88024569E-06_JPRB, 0.91055347E-06_JPRB, &
  & 0.94143616E-06_JPRB, 0.97160705E-06_JPRB, 0.99998317E-06_JPRB, 0.10264788E-05_JPRB, 0.10513598E-05_JPRB, 0.10748448E-05_JPRB, &
  & 0.10972685E-05_JPRB, 0.11191794E-05_JPRB, 0.11412720E-05_JPRB, 0.11639040E-05_JPRB, 0.11868560E-05_JPRB, 0.12094076E-05_JPRB, &
  & 0.12306554E-05_JPRB, 0.12493643E-05_JPRB, 0.12639865E-05_JPRB, 0.12730609E-05_JPRB, 0.12754832E-05_JPRB, 0.12706959E-05_JPRB, &
  & 0.12590616E-05_JPRB, 0.12417846E-05_JPRB, 0.12209200E-05_JPRB, 0.11995750E-05_JPRB, 0.11813554E-05_JPRB, 0.11689301E-05_JPRB, &
  & 0.11635445E-05_JPRB, 0.11644995E-05_JPRB, 0.11696960E-05_JPRB, 0.11757199E-05_JPRB, 0.11795353E-05_JPRB, 0.11785288E-05_JPRB, &
  & 0.11713648E-05_JPRB, 0.11577977E-05_JPRB, 0.11384656E-05_JPRB, 0.11147067E-05_JPRB, 0.10881163E-05_JPRB, 0.10602743E-05_JPRB, &
  & 0.10320375E-05_JPRB, 0.10037622E-05_JPRB, 0.97612826E-06_JPRB, 0.94983238E-06_JPRB, 0.92527569E-06_JPRB, 0.90292826E-06_JPRB, &
  & 0.88323083E-06_JPRB, 0.86655109E-06_JPRB, 0.85311962E-06_JPRB, 0.84351637E-06_JPRB, 0.83769680E-06_JPRB, 0.83560400E-06_JPRB, &
  & 0.83726826E-06_JPRB, 0.84304577E-06_JPRB, 0.85461460E-06_JPRB, 0.88324163E-06_JPRB /)

RGHG2(:,20, 5) = (/ &
  & 0.87982141E-06_JPRB, 0.87132457E-06_JPRB, 0.86833154E-06_JPRB, 0.86779659E-06_JPRB, 0.86965764E-06_JPRB, 0.87458250E-06_JPRB, &
  & 0.88334139E-06_JPRB, 0.89663263E-06_JPRB, 0.91454501E-06_JPRB, 0.93680654E-06_JPRB, 0.96263318E-06_JPRB, 0.99068200E-06_JPRB, &
  & 0.10195073E-05_JPRB, 0.10478864E-05_JPRB, 0.10750837E-05_JPRB, 0.11006131E-05_JPRB, 0.11247862E-05_JPRB, 0.11480917E-05_JPRB, &
  & 0.11708767E-05_JPRB, 0.11934960E-05_JPRB, 0.12162910E-05_JPRB, 0.12394080E-05_JPRB, 0.12629762E-05_JPRB, 0.12866507E-05_JPRB, &
  & 0.13093892E-05_JPRB, 0.13299217E-05_JPRB, 0.13471545E-05_JPRB, 0.13594807E-05_JPRB, 0.13659952E-05_JPRB, 0.13661318E-05_JPRB, &
  & 0.13600368E-05_JPRB, 0.13482634E-05_JPRB, 0.13324729E-05_JPRB, 0.13147975E-05_JPRB, 0.12981461E-05_JPRB, 0.12852156E-05_JPRB, &
  & 0.12777441E-05_JPRB, 0.12755530E-05_JPRB, 0.12770906E-05_JPRB, 0.12794781E-05_JPRB, 0.12802420E-05_JPRB, 0.12771370E-05_JPRB, &
  & 0.12687116E-05_JPRB, 0.12546076E-05_JPRB, 0.12353812E-05_JPRB, 0.12120815E-05_JPRB, 0.11860559E-05_JPRB, 0.11582866E-05_JPRB, &
  & 0.11297586E-05_JPRB, 0.11015593E-05_JPRB, 0.10746511E-05_JPRB, 0.10494176E-05_JPRB, 0.10262554E-05_JPRB, 0.10055982E-05_JPRB, &
  & 0.98770556E-06_JPRB, 0.97273403E-06_JPRB, 0.96074962E-06_JPRB, 0.95213443E-06_JPRB, 0.94681906E-06_JPRB, 0.94472381E-06_JPRB, &
  & 0.94584243E-06_JPRB, 0.95041815E-06_JPRB, 0.95980124E-06_JPRB, 0.98355724E-06_JPRB /)

RGHG2(:,21, 5) = (/ &
  & 0.96426504E-06_JPRB, 0.95711869E-06_JPRB, 0.95469954E-06_JPRB, 0.95444614E-06_JPRB, 0.95635278E-06_JPRB, 0.96095323E-06_JPRB, &
  & 0.96907274E-06_JPRB, 0.98125133E-06_JPRB, 0.99774309E-06_JPRB, 0.10183136E-05_JPRB, 0.10421982E-05_JPRB, 0.10683561E-05_JPRB, &
  & 0.10953936E-05_JPRB, 0.11221571E-05_JPRB, 0.11478967E-05_JPRB, 0.11723192E-05_JPRB, 0.11954390E-05_JPRB, 0.12176704E-05_JPRB, &
  & 0.12394845E-05_JPRB, 0.12611906E-05_JPRB, 0.12829917E-05_JPRB, 0.13051397E-05_JPRB, 0.13274934E-05_JPRB, 0.13499196E-05_JPRB, &
  & 0.13718061E-05_JPRB, 0.13921099E-05_JPRB, 0.14097909E-05_JPRB, 0.14239994E-05_JPRB, 0.14339173E-05_JPRB, 0.14388388E-05_JPRB, &
  & 0.14386035E-05_JPRB, 0.14334512E-05_JPRB, 0.14243579E-05_JPRB, 0.14125906E-05_JPRB, 0.14004314E-05_JPRB, 0.13898315E-05_JPRB, &
  & 0.13820760E-05_JPRB, 0.13772295E-05_JPRB, 0.13745979E-05_JPRB, 0.13723213E-05_JPRB, 0.13685224E-05_JPRB, 0.13615652E-05_JPRB, &
  & 0.13504423E-05_JPRB, 0.13347384E-05_JPRB, 0.13147304E-05_JPRB, 0.12911908E-05_JPRB, 0.12650382E-05_JPRB, 0.12375699E-05_JPRB, &
  & 0.12101170E-05_JPRB, 0.11836632E-05_JPRB, 0.11584946E-05_JPRB, 0.11349651E-05_JPRB, 0.11136315E-05_JPRB, 0.10948452E-05_JPRB, &
  & 0.10787601E-05_JPRB, 0.10653564E-05_JPRB, 0.10545461E-05_JPRB, 0.10465873E-05_JPRB, 0.10413629E-05_JPRB, 0.10388113E-05_JPRB, &
  & 0.10389023E-05_JPRB, 0.10418195E-05_JPRB, 0.10485445E-05_JPRB, 0.10658867E-05_JPRB /)

RGHG2(:,22, 5) = (/ &
  & 0.10381378E-05_JPRB, 0.10329735E-05_JPRB, 0.10317476E-05_JPRB, 0.10323820E-05_JPRB, 0.10349065E-05_JPRB, 0.10399037E-05_JPRB, &
  & 0.10480052E-05_JPRB, 0.10598774E-05_JPRB, 0.10756357E-05_JPRB, 0.10951453E-05_JPRB, 0.11178120E-05_JPRB, 0.11425423E-05_JPRB, &
  & 0.11682533E-05_JPRB, 0.11937461E-05_JPRB, 0.12182566E-05_JPRB, 0.12414499E-05_JPRB, 0.12633890E-05_JPRB, 0.12843278E-05_JPRB, &
  & 0.13046209E-05_JPRB, 0.13246133E-05_JPRB, 0.13445023E-05_JPRB, 0.13644176E-05_JPRB, 0.13843586E-05_JPRB, 0.14041788E-05_JPRB, &
  & 0.14236863E-05_JPRB, 0.14423481E-05_JPRB, 0.14595396E-05_JPRB, 0.14742957E-05_JPRB, 0.14859897E-05_JPRB, 0.14942641E-05_JPRB, &
  & 0.14987269E-05_JPRB, 0.14992904E-05_JPRB, 0.14963574E-05_JPRB, 0.14905685E-05_JPRB, 0.14833086E-05_JPRB, 0.14755794E-05_JPRB, &
  & 0.14686226E-05_JPRB, 0.14623421E-05_JPRB, 0.14565561E-05_JPRB, 0.14501728E-05_JPRB, 0.14420558E-05_JPRB, 0.14311433E-05_JPRB, &
  & 0.14168708E-05_JPRB, 0.13990203E-05_JPRB, 0.13778479E-05_JPRB, 0.13539274E-05_JPRB, 0.13283924E-05_JPRB, 0.13024837E-05_JPRB, &
  & 0.12771225E-05_JPRB, 0.12526253E-05_JPRB, 0.12293351E-05_JPRB, 0.12078402E-05_JPRB, 0.11885292E-05_JPRB, 0.11716379E-05_JPRB, &
  & 0.11571901E-05_JPRB, 0.11450763E-05_JPRB, 0.11351591E-05_JPRB, 0.11275580E-05_JPRB, 0.11221767E-05_JPRB, 0.11189477E-05_JPRB, &
  & 0.11178690E-05_JPRB, 0.11190432E-05_JPRB, 0.11231125E-05_JPRB, 0.11350057E-05_JPRB /)

RGHG2(:,23, 5) = (/ &
  & 0.11017449E-05_JPRB, 0.10992911E-05_JPRB, 0.10994784E-05_JPRB, 0.11012125E-05_JPRB, 0.11047146E-05_JPRB, 0.11104200E-05_JPRB, &
  & 0.11190924E-05_JPRB, 0.11311582E-05_JPRB, 0.11467996E-05_JPRB, 0.11658286E-05_JPRB, 0.11876822E-05_JPRB, 0.12115291E-05_JPRB, &
  & 0.12362311E-05_JPRB, 0.12607767E-05_JPRB, 0.12843323E-05_JPRB, 0.13065124E-05_JPRB, 0.13273116E-05_JPRB, 0.13469462E-05_JPRB, &
  & 0.13656872E-05_JPRB, 0.13837973E-05_JPRB, 0.14013930E-05_JPRB, 0.14186015E-05_JPRB, 0.14354951E-05_JPRB, 0.14521580E-05_JPRB, &
  & 0.14685164E-05_JPRB, 0.14844417E-05_JPRB, 0.14997419E-05_JPRB, 0.15140994E-05_JPRB, 0.15266828E-05_JPRB, 0.15369454E-05_JPRB, &
  & 0.15444933E-05_JPRB, 0.15490310E-05_JPRB, 0.15505498E-05_JPRB, 0.15493330E-05_JPRB, 0.15459594E-05_JPRB, 0.15410026E-05_JPRB, &
  & 0.15350213E-05_JPRB, 0.15281867E-05_JPRB, 0.15203804E-05_JPRB, 0.15111002E-05_JPRB, 0.14997809E-05_JPRB, 0.14859630E-05_JPRB, &
  & 0.14693779E-05_JPRB, 0.14500107E-05_JPRB, 0.14281875E-05_JPRB, 0.14046344E-05_JPRB, 0.13803055E-05_JPRB, 0.13560662E-05_JPRB, &
  & 0.13324722E-05_JPRB, 0.13099205E-05_JPRB, 0.12888174E-05_JPRB, 0.12694948E-05_JPRB, 0.12522269E-05_JPRB, 0.12371401E-05_JPRB, &
  & 0.12241649E-05_JPRB, 0.12131438E-05_JPRB, 0.12039052E-05_JPRB, 0.11965261E-05_JPRB, 0.11909099E-05_JPRB, 0.11870343E-05_JPRB, &
  & 0.11849012E-05_JPRB, 0.11845564E-05_JPRB, 0.11863831E-05_JPRB, 0.11935333E-05_JPRB /)

RGHG2(:,24, 5) = (/ &
  & 0.11571902E-05_JPRB, 0.11570858E-05_JPRB, 0.11586097E-05_JPRB, 0.11614451E-05_JPRB, 0.11658611E-05_JPRB, 0.11724569E-05_JPRB, &
  & 0.11817717E-05_JPRB, 0.11942955E-05_JPRB, 0.12100516E-05_JPRB, 0.12288722E-05_JPRB, 0.12502508E-05_JPRB, 0.12733976E-05_JPRB, &
  & 0.12973438E-05_JPRB, 0.13210963E-05_JPRB, 0.13438620E-05_JPRB, 0.13652127E-05_JPRB, 0.13850640E-05_JPRB, 0.14035527E-05_JPRB, &
  & 0.14208952E-05_JPRB, 0.14372570E-05_JPRB, 0.14527631E-05_JPRB, 0.14674854E-05_JPRB, 0.14815463E-05_JPRB, 0.14951332E-05_JPRB, &
  & 0.15084248E-05_JPRB, 0.15215726E-05_JPRB, 0.15346241E-05_JPRB, 0.15474056E-05_JPRB, 0.15596244E-05_JPRB, 0.15705934E-05_JPRB, &
  & 0.15796993E-05_JPRB, 0.15864706E-05_JPRB, 0.15906097E-05_JPRB, 0.15921573E-05_JPRB, 0.15911937E-05_JPRB, 0.15880207E-05_JPRB, &
  & 0.15828271E-05_JPRB, 0.15758134E-05_JPRB, 0.15668860E-05_JPRB, 0.15560322E-05_JPRB, 0.15429528E-05_JPRB, 0.15275413E-05_JPRB, &
  & 0.15098192E-05_JPRB, 0.14899570E-05_JPRB, 0.14683939E-05_JPRB, 0.14457241E-05_JPRB, 0.14227440E-05_JPRB, 0.14001935E-05_JPRB, &
  & 0.13785994E-05_JPRB, 0.13582304E-05_JPRB, 0.13393236E-05_JPRB, 0.13221220E-05_JPRB, 0.13067923E-05_JPRB, 0.12933532E-05_JPRB, &
  & 0.12816704E-05_JPRB, 0.12715567E-05_JPRB, 0.12628460E-05_JPRB, 0.12555868E-05_JPRB, 0.12497337E-05_JPRB, 0.12452939E-05_JPRB, &
  & 0.12423028E-05_JPRB, 0.12407810E-05_JPRB, 0.12408383E-05_JPRB, 0.12439807E-05_JPRB /)

RGHG2(:,25, 5) = (/ &
  & 0.12059867E-05_JPRB, 0.12078362E-05_JPRB, 0.12104477E-05_JPRB, 0.12140680E-05_JPRB, 0.12192808E-05_JPRB, 0.12265419E-05_JPRB, &
  & 0.12364171E-05_JPRB, 0.12492881E-05_JPRB, 0.12651490E-05_JPRB, 0.12837564E-05_JPRB, 0.13046897E-05_JPRB, 0.13271747E-05_JPRB, &
  & 0.13503774E-05_JPRB, 0.13733822E-05_JPRB, 0.13954333E-05_JPRB, 0.14160612E-05_JPRB, 0.14351214E-05_JPRB, 0.14526893E-05_JPRB, &
  & 0.14689106E-05_JPRB, 0.14838872E-05_JPRB, 0.14977045E-05_JPRB, 0.15104365E-05_JPRB, 0.15221924E-05_JPRB, 0.15332470E-05_JPRB, &
  & 0.15438661E-05_JPRB, 0.15544247E-05_JPRB, 0.15652192E-05_JPRB, 0.15763003E-05_JPRB, 0.15873854E-05_JPRB, 0.15980072E-05_JPRB, &
  & 0.16074612E-05_JPRB, 0.16151180E-05_JPRB, 0.16204621E-05_JPRB, 0.16233412E-05_JPRB, 0.16235650E-05_JPRB, 0.16212389E-05_JPRB, &
  & 0.16164138E-05_JPRB, 0.16093190E-05_JPRB, 0.15999176E-05_JPRB, 0.15883036E-05_JPRB, 0.15744695E-05_JPRB, 0.15585117E-05_JPRB, &
  & 0.15406175E-05_JPRB, 0.15210715E-05_JPRB, 0.15003111E-05_JPRB, 0.14789683E-05_JPRB, 0.14577594E-05_JPRB, 0.14372370E-05_JPRB, &
  & 0.14178140E-05_JPRB, 0.13996980E-05_JPRB, 0.13829774E-05_JPRB, 0.13677725E-05_JPRB, 0.13542015E-05_JPRB, 0.13421948E-05_JPRB, &
  & 0.13316017E-05_JPRB, 0.13222340E-05_JPRB, 0.13139362E-05_JPRB, 0.13067501E-05_JPRB, 0.13006651E-05_JPRB, 0.12957389E-05_JPRB, &
  & 0.12920367E-05_JPRB, 0.12895598E-05_JPRB, 0.12883095E-05_JPRB, 0.12889512E-05_JPRB /)

RGHG2(:,26, 5) = (/ &
  & 0.12496565E-05_JPRB, 0.12531036E-05_JPRB, 0.12562731E-05_JPRB, 0.12605183E-05_JPRB, 0.12661143E-05_JPRB, 0.12737348E-05_JPRB, &
  & 0.12839114E-05_JPRB, 0.12968603E-05_JPRB, 0.13126114E-05_JPRB, 0.13308794E-05_JPRB, 0.13511692E-05_JPRB, 0.13729350E-05_JPRB, &
  & 0.13953149E-05_JPRB, 0.14175649E-05_JPRB, 0.14389244E-05_JPRB, 0.14589350E-05_JPRB, 0.14773722E-05_JPRB, 0.14942490E-05_JPRB, &
  & 0.15096325E-05_JPRB, 0.15235901E-05_JPRB, 0.15361854E-05_JPRB, 0.15474918E-05_JPRB, 0.15576129E-05_JPRB, 0.15667985E-05_JPRB, &
  & 0.15753866E-05_JPRB, 0.15838218E-05_JPRB, 0.15925400E-05_JPRB, 0.16017711E-05_JPRB, 0.16114483E-05_JPRB, 0.16211100E-05_JPRB, &
  & 0.16300852E-05_JPRB, 0.16377196E-05_JPRB, 0.16433365E-05_JPRB, 0.16466297E-05_JPRB, 0.16472566E-05_JPRB, 0.16451999E-05_JPRB, &
  & 0.16404986E-05_JPRB, 0.16332827E-05_JPRB, 0.16237120E-05_JPRB, 0.16118687E-05_JPRB, 0.15979606E-05_JPRB, 0.15821627E-05_JPRB, &
  & 0.15647615E-05_JPRB, 0.15461270E-05_JPRB, 0.15267622E-05_JPRB, 0.15072128E-05_JPRB, 0.14879927E-05_JPRB, 0.14696673E-05_JPRB, &
  & 0.14525032E-05_JPRB, 0.14365072E-05_JPRB, 0.14217208E-05_JPRB, 0.14082942E-05_JPRB, 0.13961944E-05_JPRB, 0.13853705E-05_JPRB, &
  & 0.13756638E-05_JPRB, 0.13669041E-05_JPRB, 0.13589481E-05_JPRB, 0.13518325E-05_JPRB, 0.13455747E-05_JPRB, 0.13402689E-05_JPRB, &
  & 0.13360008E-05_JPRB, 0.13327571E-05_JPRB, 0.13303772E-05_JPRB, 0.13286284E-05_JPRB /)

RGHG2(:,27, 5) = (/ &
  & 0.12894189E-05_JPRB, 0.12934032E-05_JPRB, 0.12972372E-05_JPRB, 0.13015721E-05_JPRB, 0.13073818E-05_JPRB, 0.13151067E-05_JPRB, &
  & 0.13252061E-05_JPRB, 0.13380625E-05_JPRB, 0.13534396E-05_JPRB, 0.13711015E-05_JPRB, 0.13906738E-05_JPRB, 0.14115089E-05_JPRB, &
  & 0.14330516E-05_JPRB, 0.14544961E-05_JPRB, 0.14752152E-05_JPRB, 0.14946804E-05_JPRB, 0.15126084E-05_JPRB, 0.15289619E-05_JPRB, &
  & 0.15437514E-05_JPRB, 0.15570356E-05_JPRB, 0.15688540E-05_JPRB, 0.15792330E-05_JPRB, 0.15882604E-05_JPRB, 0.15961723E-05_JPRB, &
  & 0.16033021E-05_JPRB, 0.16101062E-05_JPRB, 0.16171108E-05_JPRB, 0.16246038E-05_JPRB, 0.16326711E-05_JPRB, 0.16410813E-05_JPRB, &
  & 0.16491176E-05_JPRB, 0.16561753E-05_JPRB, 0.16615114E-05_JPRB, 0.16646785E-05_JPRB, 0.16652900E-05_JPRB, 0.16632418E-05_JPRB, &
  & 0.16585490E-05_JPRB, 0.16512847E-05_JPRB, 0.16417259E-05_JPRB, 0.16301021E-05_JPRB, 0.16165407E-05_JPRB, 0.16013881E-05_JPRB, &
  & 0.15849886E-05_JPRB, 0.15677865E-05_JPRB, 0.15501614E-05_JPRB, 0.15325384E-05_JPRB, 0.15154525E-05_JPRB, 0.14992590E-05_JPRB, &
  & 0.14840697E-05_JPRB, 0.14699403E-05_JPRB, 0.14568919E-05_JPRB, 0.14448971E-05_JPRB, 0.14339857E-05_JPRB, 0.14240920E-05_JPRB, &
  & 0.14150762E-05_JPRB, 0.14067931E-05_JPRB, 0.13991231E-05_JPRB, 0.13920892E-05_JPRB, 0.13857307E-05_JPRB, 0.13801679E-05_JPRB, &
  & 0.13755081E-05_JPRB, 0.13717327E-05_JPRB, 0.13685832E-05_JPRB, 0.13651960E-05_JPRB /)

RGHG2(:,28, 5) = (/ &
  & 0.13246159E-05_JPRB, 0.13297075E-05_JPRB, 0.13334250E-05_JPRB, 0.13380424E-05_JPRB, 0.13437754E-05_JPRB, 0.13513728E-05_JPRB, &
  & 0.13613925E-05_JPRB, 0.13738327E-05_JPRB, 0.13887183E-05_JPRB, 0.14056766E-05_JPRB, 0.14243132E-05_JPRB, 0.14442578E-05_JPRB, &
  & 0.14648411E-05_JPRB, 0.14855016E-05_JPRB, 0.15055580E-05_JPRB, 0.15245082E-05_JPRB, 0.15420477E-05_JPRB, 0.15580176E-05_JPRB, &
  & 0.15724071E-05_JPRB, 0.15852576E-05_JPRB, 0.15965695E-05_JPRB, 0.16063509E-05_JPRB, 0.16146897E-05_JPRB, 0.16217875E-05_JPRB, &
  & 0.16279326E-05_JPRB, 0.16335828E-05_JPRB, 0.16391901E-05_JPRB, 0.16451961E-05_JPRB, 0.16517608E-05_JPRB, 0.16587398E-05_JPRB, &
  & 0.16656082E-05_JPRB, 0.16717536E-05_JPRB, 0.16764864E-05_JPRB, 0.16792374E-05_JPRB, 0.16796341E-05_JPRB, 0.16774919E-05_JPRB, &
  & 0.16728035E-05_JPRB, 0.16657086E-05_JPRB, 0.16564337E-05_JPRB, 0.16452587E-05_JPRB, 0.16324231E-05_JPRB, 0.16183087E-05_JPRB, &
  & 0.16033035E-05_JPRB, 0.15877665E-05_JPRB, 0.15720018E-05_JPRB, 0.15564056E-05_JPRB, 0.15413265E-05_JPRB, 0.15270161E-05_JPRB, &
  & 0.15135977E-05_JPRB, 0.15010577E-05_JPRB, 0.14893047E-05_JPRB, 0.14784185E-05_JPRB, 0.14683967E-05_JPRB, 0.14591849E-05_JPRB, &
  & 0.14506797E-05_JPRB, 0.14427553E-05_JPRB, 0.14353020E-05_JPRB, 0.14283482E-05_JPRB, 0.14219398E-05_JPRB, 0.14162024E-05_JPRB, &
  & 0.14112734E-05_JPRB, 0.14071200E-05_JPRB, 0.14034269E-05_JPRB, 0.13988907E-05_JPRB /)

RGHG2(:,29, 5) = (/ &
  & 0.13565348E-05_JPRB, 0.13615153E-05_JPRB, 0.13657580E-05_JPRB, 0.13701720E-05_JPRB, 0.13759093E-05_JPRB, 0.13834122E-05_JPRB, &
  & 0.13930654E-05_JPRB, 0.14052042E-05_JPRB, 0.14194532E-05_JPRB, 0.14356084E-05_JPRB, 0.14533772E-05_JPRB, 0.14723050E-05_JPRB, &
  & 0.14920149E-05_JPRB, 0.15118658E-05_JPRB, 0.15312864E-05_JPRB, 0.15497337E-05_JPRB, 0.15668695E-05_JPRB, 0.15825306E-05_JPRB, &
  & 0.15966322E-05_JPRB, 0.16091626E-05_JPRB, 0.16201308E-05_JPRB, 0.16295170E-05_JPRB, 0.16374306E-05_JPRB, 0.16440205E-05_JPRB, &
  & 0.16495354E-05_JPRB, 0.16543966E-05_JPRB, 0.16589801E-05_JPRB, 0.16637604E-05_JPRB, 0.16689792E-05_JPRB, 0.16745624E-05_JPRB, &
  & 0.16801678E-05_JPRB, 0.16852379E-05_JPRB, 0.16891707E-05_JPRB, 0.16913602E-05_JPRB, 0.16914370E-05_JPRB, 0.16891875E-05_JPRB, &
  & 0.16846205E-05_JPRB, 0.16778525E-05_JPRB, 0.16691295E-05_JPRB, 0.16587189E-05_JPRB, 0.16469295E-05_JPRB, 0.16341521E-05_JPRB, &
  & 0.16207699E-05_JPRB, 0.16070207E-05_JPRB, 0.15932225E-05_JPRB, 0.15795140E-05_JPRB, 0.15662007E-05_JPRB, 0.15535129E-05_JPRB, &
  & 0.15415138E-05_JPRB, 0.15301175E-05_JPRB, 0.15193745E-05_JPRB, 0.15092930E-05_JPRB, 0.14998851E-05_JPRB, 0.14911564E-05_JPRB, &
  & 0.14830064E-05_JPRB, 0.14753391E-05_JPRB, 0.14680552E-05_JPRB, 0.14611652E-05_JPRB, 0.14547242E-05_JPRB, 0.14488578E-05_JPRB, &
  & 0.14437109E-05_JPRB, 0.14392530E-05_JPRB, 0.14351084E-05_JPRB, 0.14295495E-05_JPRB /)

RGHG2(:,30, 5) = (/ &
  & 0.13842318E-05_JPRB, 0.13901558E-05_JPRB, 0.13941433E-05_JPRB, 0.13988152E-05_JPRB, 0.14044285E-05_JPRB, 0.14117431E-05_JPRB, &
  & 0.14212480E-05_JPRB, 0.14328581E-05_JPRB, 0.14465242E-05_JPRB, 0.14619043E-05_JPRB, 0.14787305E-05_JPRB, 0.14967720E-05_JPRB, &
  & 0.15155318E-05_JPRB, 0.15345934E-05_JPRB, 0.15533809E-05_JPRB, 0.15713345E-05_JPRB, 0.15880908E-05_JPRB, 0.16034284E-05_JPRB, &
  & 0.16172777E-05_JPRB, 0.16295194E-05_JPRB, 0.16402242E-05_JPRB, 0.16493087E-05_JPRB, 0.16569455E-05_JPRB, 0.16631982E-05_JPRB, &
  & 0.16683216E-05_JPRB, 0.16726455E-05_JPRB, 0.16764964E-05_JPRB, 0.16803307E-05_JPRB, 0.16844099E-05_JPRB, 0.16887401E-05_JPRB, &
  & 0.16931209E-05_JPRB, 0.16970910E-05_JPRB, 0.17001503E-05_JPRB, 0.17017246E-05_JPRB, 0.17014576E-05_JPRB, 0.16991495E-05_JPRB, &
  & 0.16947823E-05_JPRB, 0.16885206E-05_JPRB, 0.16805757E-05_JPRB, 0.16712296E-05_JPRB, 0.16607437E-05_JPRB, 0.16495151E-05_JPRB, &
  & 0.16378212E-05_JPRB, 0.16259000E-05_JPRB, 0.16138247E-05_JPRB, 0.16018696E-05_JPRB, 0.15900374E-05_JPRB, 0.15786227E-05_JPRB, &
  & 0.15677098E-05_JPRB, 0.15572111E-05_JPRB, 0.15471676E-05_JPRB, 0.15376199E-05_JPRB, 0.15286347E-05_JPRB, 0.15202248E-05_JPRB, &
  & 0.15123311E-05_JPRB, 0.15048645E-05_JPRB, 0.14977211E-05_JPRB, 0.14909106E-05_JPRB, 0.14844755E-05_JPRB, 0.14785337E-05_JPRB, &
  & 0.14732498E-05_JPRB, 0.14685793E-05_JPRB, 0.14641244E-05_JPRB, 0.14579473E-05_JPRB /)

RGHG2(:,31, 5) = (/ &
  & 0.14094333E-05_JPRB, 0.14153132E-05_JPRB, 0.14198679E-05_JPRB, 0.14244115E-05_JPRB, 0.14300895E-05_JPRB, 0.14373360E-05_JPRB, &
  & 0.14464795E-05_JPRB, 0.14577162E-05_JPRB, 0.14707077E-05_JPRB, 0.14852737E-05_JPRB, 0.15012553E-05_JPRB, 0.15183364E-05_JPRB, &
  & 0.15362526E-05_JPRB, 0.15544666E-05_JPRB, 0.15725409E-05_JPRB, 0.15899820E-05_JPRB, 0.16063437E-05_JPRB, 0.16213598E-05_JPRB, &
  & 0.16349504E-05_JPRB, 0.16469222E-05_JPRB, 0.16573748E-05_JPRB, 0.16662138E-05_JPRB, 0.16736196E-05_JPRB, 0.16796450E-05_JPRB, &
  & 0.16845031E-05_JPRB, 0.16884687E-05_JPRB, 0.16918315E-05_JPRB, 0.16949489E-05_JPRB, 0.16981287E-05_JPRB, 0.17013738E-05_JPRB, &
  & 0.17046480E-05_JPRB, 0.17075899E-05_JPRB, 0.17097852E-05_JPRB, 0.17107557E-05_JPRB, 0.17101596E-05_JPRB, 0.17078266E-05_JPRB, &
  & 0.17037631E-05_JPRB, 0.16981237E-05_JPRB, 0.16911099E-05_JPRB, 0.16829378E-05_JPRB, 0.16738909E-05_JPRB, 0.16642437E-05_JPRB, &
  & 0.16542365E-05_JPRB, 0.16439917E-05_JPRB, 0.16335887E-05_JPRB, 0.16230050E-05_JPRB, 0.16124721E-05_JPRB, 0.16020707E-05_JPRB, &
  & 0.15919550E-05_JPRB, 0.15821151E-05_JPRB, 0.15725577E-05_JPRB, 0.15633923E-05_JPRB, 0.15547071E-05_JPRB, 0.15465347E-05_JPRB, &
  & 0.15388448E-05_JPRB, 0.15315485E-05_JPRB, 0.15245538E-05_JPRB, 0.15178463E-05_JPRB, 0.15114622E-05_JPRB, 0.15055186E-05_JPRB, &
  & 0.15001590E-05_JPRB, 0.14953702E-05_JPRB, 0.14907232E-05_JPRB, 0.14841373E-05_JPRB /)

RGHG2(:,32, 5) = (/ &
  & 0.14317826E-05_JPRB, 0.14386724E-05_JPRB, 0.14430974E-05_JPRB, 0.14479879E-05_JPRB, 0.14536354E-05_JPRB, 0.14607431E-05_JPRB, &
  & 0.14696740E-05_JPRB, 0.14803451E-05_JPRB, 0.14926625E-05_JPRB, 0.15064286E-05_JPRB, 0.15214714E-05_JPRB, 0.15376669E-05_JPRB, &
  & 0.15546356E-05_JPRB, 0.15720602E-05_JPRB, 0.15894127E-05_JPRB, 0.16062472E-05_JPRB, 0.16221820E-05_JPRB, 0.16368299E-05_JPRB, &
  & 0.16501206E-05_JPRB, 0.16618364E-05_JPRB, 0.16720187E-05_JPRB, 0.16806471E-05_JPRB, 0.16878244E-05_JPRB, 0.16936746E-05_JPRB, &
  & 0.16983304E-05_JPRB, 0.17020454E-05_JPRB, 0.17050671E-05_JPRB, 0.17076806E-05_JPRB, 0.17101490E-05_JPRB, 0.17125357E-05_JPRB, &
  & 0.17148529E-05_JPRB, 0.17168834E-05_JPRB, 0.17182889E-05_JPRB, 0.17186845E-05_JPRB, 0.17177782E-05_JPRB, 0.17154557E-05_JPRB, &
  & 0.17117588E-05_JPRB, 0.17068120E-05_JPRB, 0.17007776E-05_JPRB, 0.16938329E-05_JPRB, 0.16861742E-05_JPRB, 0.16780473E-05_JPRB, &
  & 0.16695401E-05_JPRB, 0.16607918E-05_JPRB, 0.16517321E-05_JPRB, 0.16424042E-05_JPRB, 0.16328952E-05_JPRB, 0.16233590E-05_JPRB, &
  & 0.16139034E-05_JPRB, 0.16045680E-05_JPRB, 0.15954114E-05_JPRB, 0.15865489E-05_JPRB, 0.15781127E-05_JPRB, 0.15701546E-05_JPRB, &
  & 0.15626615E-05_JPRB, 0.15555484E-05_JPRB, 0.15487163E-05_JPRB, 0.15421521E-05_JPRB, 0.15358758E-05_JPRB, 0.15299900E-05_JPRB, &
  & 0.15246449E-05_JPRB, 0.15198069E-05_JPRB, 0.15150506E-05_JPRB, 0.15081839E-05_JPRB /)

RGHG2(:,33, 5) = (/ &
  & 0.14528716E-05_JPRB, 0.14599791E-05_JPRB, 0.14650501E-05_JPRB, 0.14699111E-05_JPRB, 0.14756507E-05_JPRB, 0.14826659E-05_JPRB, &
  & 0.14911971E-05_JPRB, 0.15013458E-05_JPRB, 0.15129098E-05_JPRB, 0.15257829E-05_JPRB, 0.15399271E-05_JPRB, 0.15551241E-05_JPRB, &
  & 0.15711888E-05_JPRB, 0.15876807E-05_JPRB, 0.16042696E-05_JPRB, 0.16204941E-05_JPRB, 0.16359390E-05_JPRB, 0.16502242E-05_JPRB, &
  & 0.16631680E-05_JPRB, 0.16746246E-05_JPRB, 0.16845432E-05_JPRB, 0.16929557E-05_JPRB, 0.16999222E-05_JPRB, 0.17055975E-05_JPRB, &
  & 0.17100836E-05_JPRB, 0.17135981E-05_JPRB, 0.17163612E-05_JPRB, 0.17186046E-05_JPRB, 0.17205457E-05_JPRB, 0.17222657E-05_JPRB, &
  & 0.17238150E-05_JPRB, 0.17250777E-05_JPRB, 0.17258117E-05_JPRB, 0.17257314E-05_JPRB, 0.17246221E-05_JPRB, 0.17223973E-05_JPRB, &
  & 0.17190714E-05_JPRB, 0.17147768E-05_JPRB, 0.17096515E-05_JPRB, 0.17038253E-05_JPRB, 0.16974235E-05_JPRB, 0.16905756E-05_JPRB, &
  & 0.16833995E-05_JPRB, 0.16758332E-05_JPRB, 0.16679278E-05_JPRB, 0.16595783E-05_JPRB, 0.16509535E-05_JPRB, 0.16421741E-05_JPRB, &
  & 0.16332949E-05_JPRB, 0.16244289E-05_JPRB, 0.16156320E-05_JPRB, 0.16070736E-05_JPRB, 0.15988954E-05_JPRB, 0.15911769E-05_JPRB, &
  & 0.15839050E-05_JPRB, 0.15770016E-05_JPRB, 0.15703708E-05_JPRB, 0.15639929E-05_JPRB, 0.15578771E-05_JPRB, 0.15521330E-05_JPRB, &
  & 0.15468640E-05_JPRB, 0.15420645E-05_JPRB, 0.15372840E-05_JPRB, 0.15302776E-05_JPRB /)

RGHG2(:,34, 5) = (/ &
  & 0.14724038E-05_JPRB, 0.14805184E-05_JPRB, 0.14855609E-05_JPRB, 0.14907494E-05_JPRB, 0.14964554E-05_JPRB, 0.15032855E-05_JPRB, &
  & 0.15114664E-05_JPRB, 0.15209737E-05_JPRB, 0.15317482E-05_JPRB, 0.15437336E-05_JPRB, 0.15568644E-05_JPRB, 0.15710943E-05_JPRB, &
  & 0.15861521E-05_JPRB, 0.16017692E-05_JPRB, 0.16175068E-05_JPRB, 0.16330235E-05_JPRB, 0.16479302E-05_JPRB, 0.16618212E-05_JPRB, &
  & 0.16744274E-05_JPRB, 0.16855972E-05_JPRB, 0.16952742E-05_JPRB, 0.17034628E-05_JPRB, 0.17102370E-05_JPRB, 0.17157245E-05_JPRB, &
  & 0.17200512E-05_JPRB, 0.17233840E-05_JPRB, 0.17259340E-05_JPRB, 0.17278829E-05_JPRB, 0.17294244E-05_JPRB, 0.17306414E-05_JPRB, &
  & 0.17316011E-05_JPRB, 0.17322558E-05_JPRB, 0.17324479E-05_JPRB, 0.17319877E-05_JPRB, 0.17307203E-05_JPRB, 0.17286047E-05_JPRB, &
  & 0.17257009E-05_JPRB, 0.17220544E-05_JPRB, 0.17177510E-05_JPRB, 0.17128712E-05_JPRB, 0.17074904E-05_JPRB, 0.17017034E-05_JPRB, &
  & 0.16955148E-05_JPRB, 0.16889537E-05_JPRB, 0.16819162E-05_JPRB, 0.16744249E-05_JPRB, 0.16665350E-05_JPRB, 0.16583865E-05_JPRB, &
  & 0.16500818E-05_JPRB, 0.16416525E-05_JPRB, 0.16332400E-05_JPRB, 0.16250156E-05_JPRB, 0.16171364E-05_JPRB, 0.16097031E-05_JPRB, &
  & 0.16026972E-05_JPRB, 0.15960430E-05_JPRB, 0.15896539E-05_JPRB, 0.15835121E-05_JPRB, 0.15776292E-05_JPRB, 0.15720902E-05_JPRB, &
  & 0.15669974E-05_JPRB, 0.15623114E-05_JPRB, 0.15575946E-05_JPRB, 0.15505917E-05_JPRB /)

RGHG2(:,35, 5) = (/ &
  & 0.14912898E-05_JPRB, 0.14997177E-05_JPRB, 0.15052707E-05_JPRB, 0.15104400E-05_JPRB, 0.15161636E-05_JPRB, 0.15228100E-05_JPRB, &
  & 0.15305415E-05_JPRB, 0.15394273E-05_JPRB, 0.15493915E-05_JPRB, 0.15604329E-05_JPRB, 0.15725889E-05_JPRB, 0.15857609E-05_JPRB, &
  & 0.15998187E-05_JPRB, 0.16144496E-05_JPRB, 0.16293525E-05_JPRB, 0.16441328E-05_JPRB, 0.16584106E-05_JPRB, 0.16718534E-05_JPRB, &
  & 0.16841349E-05_JPRB, 0.16950356E-05_JPRB, 0.17044842E-05_JPRB, 0.17124737E-05_JPRB, 0.17190569E-05_JPRB, 0.17243599E-05_JPRB, &
  & 0.17285112E-05_JPRB, 0.17316617E-05_JPRB, 0.17340116E-05_JPRB, 0.17357144E-05_JPRB, 0.17369435E-05_JPRB, 0.17377768E-05_JPRB, &
  & 0.17382980E-05_JPRB, 0.17384990E-05_JPRB, 0.17382902E-05_JPRB, 0.17375714E-05_JPRB, 0.17362527E-05_JPRB, 0.17343045E-05_JPRB, &
  & 0.17317626E-05_JPRB, 0.17286902E-05_JPRB, 0.17250953E-05_JPRB, 0.17209841E-05_JPRB, 0.17163919E-05_JPRB, 0.17113703E-05_JPRB, &
  & 0.17059602E-05_JPRB, 0.17000921E-05_JPRB, 0.16937839E-05_JPRB, 0.16869568E-05_JPRB, 0.16797090E-05_JPRB, 0.16721535E-05_JPRB, &
  & 0.16643385E-05_JPRB, 0.16563691E-05_JPRB, 0.16483549E-05_JPRB, 0.16404942E-05_JPRB, 0.16329707E-05_JPRB, 0.16258696E-05_JPRB, &
  & 0.16191761E-05_JPRB, 0.16128170E-05_JPRB, 0.16067164E-05_JPRB, 0.16008589E-05_JPRB, 0.15952647E-05_JPRB, 0.15900116E-05_JPRB, &
  & 0.15851692E-05_JPRB, 0.15806847E-05_JPRB, 0.15761266E-05_JPRB, 0.15692641E-05_JPRB /)

RGHG2(:,36, 5) = (/ &
  & 0.15091136E-05_JPRB, 0.15182045E-05_JPRB, 0.15238033E-05_JPRB, 0.15291442E-05_JPRB, 0.15348396E-05_JPRB, 0.15412533E-05_JPRB, &
  & 0.15485775E-05_JPRB, 0.15568180E-05_JPRB, 0.15659709E-05_JPRB, 0.15760868E-05_JPRB, 0.15872204E-05_JPRB, 0.15993627E-05_JPRB, &
  & 0.16123763E-05_JPRB, 0.16260321E-05_JPRB, 0.16400107E-05_JPRB, 0.16540183E-05_JPRB, 0.16676594E-05_JPRB, 0.16805873E-05_JPRB, &
  & 0.16925152E-05_JPRB, 0.17031755E-05_JPRB, 0.17124313E-05_JPRB, 0.17202494E-05_JPRB, 0.17266591E-05_JPRB, 0.17317628E-05_JPRB, &
  & 0.17357022E-05_JPRB, 0.17386376E-05_JPRB, 0.17407622E-05_JPRB, 0.17422304E-05_JPRB, 0.17431973E-05_JPRB, 0.17437469E-05_JPRB, &
  & 0.17439504E-05_JPRB, 0.17438435E-05_JPRB, 0.17433770E-05_JPRB, 0.17425205E-05_JPRB, 0.17412400E-05_JPRB, 0.17395289E-05_JPRB, &
  & 0.17373652E-05_JPRB, 0.17347667E-05_JPRB, 0.17317461E-05_JPRB, 0.17282445E-05_JPRB, 0.17242297E-05_JPRB, 0.17197560E-05_JPRB, &
  & 0.17148420E-05_JPRB, 0.17095158E-05_JPRB, 0.17037162E-05_JPRB, 0.16974587E-05_JPRB, 0.16907587E-05_JPRB, 0.16837002E-05_JPRB, &
  & 0.16763595E-05_JPRB, 0.16688081E-05_JPRB, 0.16611962E-05_JPRB, 0.16537333E-05_JPRB, 0.16465937E-05_JPRB, 0.16398739E-05_JPRB, &
  & 0.16335390E-05_JPRB, 0.16275181E-05_JPRB, 0.16217419E-05_JPRB, 0.16162138E-05_JPRB, 0.16109636E-05_JPRB, 0.16060570E-05_JPRB, &
  & 0.16015432E-05_JPRB, 0.15973407E-05_JPRB, 0.15930256E-05_JPRB, 0.15864512E-05_JPRB /)

RGHG2(:,37, 5) = (/ &
  & 0.15262328E-05_JPRB, 0.15356252E-05_JPRB, 0.15414569E-05_JPRB, 0.15468560E-05_JPRB, 0.15525360E-05_JPRB, 0.15587839E-05_JPRB, &
  & 0.15656999E-05_JPRB, 0.15733170E-05_JPRB, 0.15816715E-05_JPRB, 0.15908622E-05_JPRB, 0.16009907E-05_JPRB, 0.16120757E-05_JPRB, &
  & 0.16240342E-05_JPRB, 0.16366718E-05_JPRB, 0.16497144E-05_JPRB, 0.16628787E-05_JPRB, 0.16758472E-05_JPRB, 0.16882577E-05_JPRB, &
  & 0.16998142E-05_JPRB, 0.17102384E-05_JPRB, 0.17193230E-05_JPRB, 0.17269892E-05_JPRB, 0.17331973E-05_JPRB, 0.17380377E-05_JPRB, &
  & 0.17416662E-05_JPRB, 0.17442910E-05_JPRB, 0.17461201E-05_JPRB, 0.17473344E-05_JPRB, 0.17480610E-05_JPRB, 0.17484078E-05_JPRB, &
  & 0.17484056E-05_JPRB, 0.17481229E-05_JPRB, 0.17475363E-05_JPRB, 0.17466466E-05_JPRB, 0.17454640E-05_JPRB, 0.17439812E-05_JPRB, &
  & 0.17422169E-05_JPRB, 0.17401035E-05_JPRB, 0.17375878E-05_JPRB, 0.17346097E-05_JPRB, 0.17310823E-05_JPRB, 0.17269971E-05_JPRB, &
  & 0.17224449E-05_JPRB, 0.17174643E-05_JPRB, 0.17120809E-05_JPRB, 0.17062532E-05_JPRB, 0.17000174E-05_JPRB, 0.16934081E-05_JPRB, &
  & 0.16864756E-05_JPRB, 0.16793133E-05_JPRB, 0.16720917E-05_JPRB, 0.16650202E-05_JPRB, 0.16582973E-05_JPRB, 0.16519858E-05_JPRB, &
  & 0.16460475E-05_JPRB, 0.16404010E-05_JPRB, 0.16349849E-05_JPRB, 0.16298197E-05_JPRB, 0.16249522E-05_JPRB, 0.16204436E-05_JPRB, &
  & 0.16163129E-05_JPRB, 0.16124533E-05_JPRB, 0.16084585E-05_JPRB, 0.16022867E-05_JPRB /)

RGHG2(:,38, 5) = (/ &
  & 0.15426335E-05_JPRB, 0.15521630E-05_JPRB, 0.15581700E-05_JPRB, 0.15636219E-05_JPRB, 0.15694021E-05_JPRB, 0.15754894E-05_JPRB, &
  & 0.15820433E-05_JPRB, 0.15890685E-05_JPRB, 0.15966345E-05_JPRB, 0.16049075E-05_JPRB, 0.16140425E-05_JPRB, 0.16240785E-05_JPRB, &
  & 0.16349728E-05_JPRB, 0.16465669E-05_JPRB, 0.16586331E-05_JPRB, 0.16709190E-05_JPRB, 0.16831393E-05_JPRB, 0.16949966E-05_JPRB, &
  & 0.17061643E-05_JPRB, 0.17163416E-05_JPRB, 0.17252360E-05_JPRB, 0.17326535E-05_JPRB, 0.17385522E-05_JPRB, 0.17429727E-05_JPRB, &
  & 0.17461462E-05_JPRB, 0.17483469E-05_JPRB, 0.17498212E-05_JPRB, 0.17507650E-05_JPRB, 0.17512899E-05_JPRB, 0.17514923E-05_JPRB, &
  & 0.17513927E-05_JPRB, 0.17510339E-05_JPRB, 0.17504300E-05_JPRB, 0.17495931E-05_JPRB, 0.17485481E-05_JPRB, 0.17473141E-05_JPRB, &
  & 0.17458796E-05_JPRB, 0.17442145E-05_JPRB, 0.17421972E-05_JPRB, 0.17397281E-05_JPRB, 0.17367004E-05_JPRB, 0.17330636E-05_JPRB, &
  & 0.17288668E-05_JPRB, 0.17242007E-05_JPRB, 0.17191408E-05_JPRB, 0.17136902E-05_JPRB, 0.17078452E-05_JPRB, 0.17016183E-05_JPRB, &
  & 0.16950454E-05_JPRB, 0.16882306E-05_JPRB, 0.16813610E-05_JPRB, 0.16746807E-05_JPRB, 0.16683705E-05_JPRB, 0.16624865E-05_JPRB, &
  & 0.16569687E-05_JPRB, 0.16517187E-05_JPRB, 0.16466876E-05_JPRB, 0.16419092E-05_JPRB, 0.16374526E-05_JPRB, 0.16333707E-05_JPRB, &
  & 0.16296585E-05_JPRB, 0.16261830E-05_JPRB, 0.16225538E-05_JPRB, 0.16168775E-05_JPRB /)

RGHG2(:,39, 5) = (/ &
  & 0.15583252E-05_JPRB, 0.15680349E-05_JPRB, 0.15739230E-05_JPRB, 0.15796370E-05_JPRB, 0.15853955E-05_JPRB, 0.15914683E-05_JPRB, &
  & 0.15976902E-05_JPRB, 0.16041323E-05_JPRB, 0.16109319E-05_JPRB, 0.16183129E-05_JPRB, 0.16264515E-05_JPRB, 0.16354596E-05_JPRB, &
  & 0.16452950E-05_JPRB, 0.16558402E-05_JPRB, 0.16669031E-05_JPRB, 0.16782794E-05_JPRB, 0.16897280E-05_JPRB, 0.17009722E-05_JPRB, &
  & 0.17116918E-05_JPRB, 0.17215559E-05_JPRB, 0.17301472E-05_JPRB, 0.17371743E-05_JPRB, 0.17425505E-05_JPRB, 0.17464366E-05_JPRB, &
  & 0.17490942E-05_JPRB, 0.17508726E-05_JPRB, 0.17520319E-05_JPRB, 0.17527537E-05_JPRB, 0.17531414E-05_JPRB, 0.17532477E-05_JPRB, &
  & 0.17531104E-05_JPRB, 0.17527290E-05_JPRB, 0.17521398E-05_JPRB, 0.17513622E-05_JPRB, 0.17504443E-05_JPRB, 0.17493966E-05_JPRB, &
  & 0.17482294E-05_JPRB, 0.17469000E-05_JPRB, 0.17453277E-05_JPRB, 0.17433687E-05_JPRB, 0.17408870E-05_JPRB, 0.17377927E-05_JPRB, &
  & 0.17340815E-05_JPRB, 0.17298381E-05_JPRB, 0.17251260E-05_JPRB, 0.17200275E-05_JPRB, 0.17145335E-05_JPRB, 0.17086504E-05_JPRB, &
  & 0.17024004E-05_JPRB, 0.16958886E-05_JPRB, 0.16893418E-05_JPRB, 0.16830204E-05_JPRB, 0.16771106E-05_JPRB, 0.16716522E-05_JPRB, &
  & 0.16665531E-05_JPRB, 0.16617112E-05_JPRB, 0.16570730E-05_JPRB, 0.16526967E-05_JPRB, 0.16486606E-05_JPRB, 0.16450193E-05_JPRB, &
  & 0.16417340E-05_JPRB, 0.16386566E-05_JPRB, 0.16354105E-05_JPRB, 0.16302851E-05_JPRB /)

RGHG2(:,40, 5) = (/ &
  & 0.15736691E-05_JPRB, 0.15829841E-05_JPRB, 0.15890694E-05_JPRB, 0.15946822E-05_JPRB, 0.16007303E-05_JPRB, 0.16066986E-05_JPRB, &
  & 0.16126430E-05_JPRB, 0.16185327E-05_JPRB, 0.16245893E-05_JPRB, 0.16310746E-05_JPRB, 0.16382605E-05_JPRB, 0.16462475E-05_JPRB, &
  & 0.16550493E-05_JPRB, 0.16645641E-05_JPRB, 0.16746326E-05_JPRB, 0.16850777E-05_JPRB, 0.16957154E-05_JPRB, 0.17063066E-05_JPRB, &
  & 0.17165219E-05_JPRB, 0.17259279E-05_JPRB, 0.17341022E-05_JPRB, 0.17405946E-05_JPRB, 0.17453839E-05_JPRB, 0.17487158E-05_JPRB, &
  & 0.17509352E-05_JPRB, 0.17523832E-05_JPRB, 0.17533177E-05_JPRB, 0.17538899E-05_JPRB, 0.17541892E-05_JPRB, 0.17542460E-05_JPRB, &
  & 0.17540833E-05_JPRB, 0.17537038E-05_JPRB, 0.17531263E-05_JPRB, 0.17523896E-05_JPRB, 0.17515479E-05_JPRB, 0.17506258E-05_JPRB, &
  & 0.17496299E-05_JPRB, 0.17485431E-05_JPRB, 0.17472971E-05_JPRB, 0.17457764E-05_JPRB, 0.17438324E-05_JPRB, 0.17413282E-05_JPRB, &
  & 0.17382063E-05_JPRB, 0.17344788E-05_JPRB, 0.17302320E-05_JPRB, 0.17255078E-05_JPRB, 0.17203661E-05_JPRB, 0.17147978E-05_JPRB, &
  & 0.17088382E-05_JPRB, 0.17025998E-05_JPRB, 0.16963346E-05_JPRB, 0.16903412E-05_JPRB, 0.16848072E-05_JPRB, 0.16797494E-05_JPRB, &
  & 0.16750555E-05_JPRB, 0.16706063E-05_JPRB, 0.16663595E-05_JPRB, 0.16623767E-05_JPRB, 0.16587610E-05_JPRB, 0.16555485E-05_JPRB, &
  & 0.16526812E-05_JPRB, 0.16499898E-05_JPRB, 0.16471320E-05_JPRB, 0.16425572E-05_JPRB /)

RGHG2(:,41, 5) = (/ &
  & 0.15885178E-05_JPRB, 0.15976109E-05_JPRB, 0.16033264E-05_JPRB, 0.16092088E-05_JPRB, 0.16152168E-05_JPRB, 0.16212690E-05_JPRB, &
  & 0.16269055E-05_JPRB, 0.16322591E-05_JPRB, 0.16375800E-05_JPRB, 0.16432200E-05_JPRB, 0.16494496E-05_JPRB, 0.16564587E-05_JPRB, &
  & 0.16642648E-05_JPRB, 0.16727878E-05_JPRB, 0.16818904E-05_JPRB, 0.16914381E-05_JPRB, 0.17012553E-05_JPRB, 0.17111411E-05_JPRB, &
  & 0.17207716E-05_JPRB, 0.17296641E-05_JPRB, 0.17372530E-05_JPRB, 0.17431875E-05_JPRB, 0.17474090E-05_JPRB, 0.17502671E-05_JPRB, &
  & 0.17521403E-05_JPRB, 0.17533499E-05_JPRB, 0.17541277E-05_JPRB, 0.17546030E-05_JPRB, 0.17548440E-05_JPRB, 0.17548763E-05_JPRB, &
  & 0.17546992E-05_JPRB, 0.17543229E-05_JPRB, 0.17537574E-05_JPRB, 0.17530386E-05_JPRB, 0.17522457E-05_JPRB, 0.17513995E-05_JPRB, &
  & 0.17505158E-05_JPRB, 0.17495928E-05_JPRB, 0.17485784E-05_JPRB, 0.17473894E-05_JPRB, 0.17459007E-05_JPRB, 0.17439745E-05_JPRB, &
  & 0.17414873E-05_JPRB, 0.17383691E-05_JPRB, 0.17346449E-05_JPRB, 0.17303699E-05_JPRB, 0.17255819E-05_JPRB, 0.17203279E-05_JPRB, &
  & 0.17146433E-05_JPRB, 0.17086488E-05_JPRB, 0.17026337E-05_JPRB, 0.16969331E-05_JPRB, 0.16917417E-05_JPRB, 0.16870523E-05_JPRB, &
  & 0.16827365E-05_JPRB, 0.16786591E-05_JPRB, 0.16747779E-05_JPRB, 0.16711751E-05_JPRB, 0.16679553E-05_JPRB, 0.16651466E-05_JPRB, &
  & 0.16626645E-05_JPRB, 0.16603344E-05_JPRB, 0.16578325E-05_JPRB, 0.16537934E-05_JPRB /)

RGHG2(:,42, 5) = (/ &
  & 0.16031744E-05_JPRB, 0.16116563E-05_JPRB, 0.16172722E-05_JPRB, 0.16229639E-05_JPRB, 0.16291748E-05_JPRB, 0.16351471E-05_JPRB, &
  & 0.16405002E-05_JPRB, 0.16453228E-05_JPRB, 0.16499529E-05_JPRB, 0.16547589E-05_JPRB, 0.16600807E-05_JPRB, 0.16661363E-05_JPRB, &
  & 0.16729959E-05_JPRB, 0.16805881E-05_JPRB, 0.16887866E-05_JPRB, 0.16974601E-05_JPRB, 0.17064851E-05_JPRB, 0.17156444E-05_JPRB, &
  & 0.17246240E-05_JPRB, 0.17329019E-05_JPRB, 0.17398927E-05_JPRB, 0.17452140E-05_JPRB, 0.17489358E-05_JPRB, 0.17513980E-05_JPRB, &
  & 0.17529986E-05_JPRB, 0.17540320E-05_JPRB, 0.17546972E-05_JPRB, 0.17551072E-05_JPRB, 0.17553108E-05_JPRB, 0.17553266E-05_JPRB, &
  & 0.17551474E-05_JPRB, 0.17547685E-05_JPRB, 0.17542163E-05_JPRB, 0.17535044E-05_JPRB, 0.17527399E-05_JPRB, 0.17519429E-05_JPRB, &
  & 0.17511343E-05_JPRB, 0.17503214E-05_JPRB, 0.17494767E-05_JPRB, 0.17485334E-05_JPRB, 0.17474047E-05_JPRB, 0.17459708E-05_JPRB, &
  & 0.17440982E-05_JPRB, 0.17416558E-05_JPRB, 0.17385453E-05_JPRB, 0.17347938E-05_JPRB, 0.17304261E-05_JPRB, 0.17254956E-05_JPRB, &
  & 0.17200819E-05_JPRB, 0.17143218E-05_JPRB, 0.17085258E-05_JPRB, 0.17030916E-05_JPRB, 0.16982085E-05_JPRB, 0.16938593E-05_JPRB, &
  & 0.16898866E-05_JPRB, 0.16861504E-05_JPRB, 0.16826081E-05_JPRB, 0.16793530E-05_JPRB, 0.16764942E-05_JPRB, 0.16740456E-05_JPRB, &
  & 0.16719030E-05_JPRB, 0.16698900E-05_JPRB, 0.16677104E-05_JPRB, 0.16641475E-05_JPRB /)

RGHG2(:,43, 5) = (/ &
  & 0.16175883E-05_JPRB, 0.16255339E-05_JPRB, 0.16307403E-05_JPRB, 0.16363573E-05_JPRB, 0.16425345E-05_JPRB, 0.16484295E-05_JPRB, &
  & 0.16534731E-05_JPRB, 0.16577731E-05_JPRB, 0.16617445E-05_JPRB, 0.16657843E-05_JPRB, 0.16702458E-05_JPRB, 0.16753939E-05_JPRB, &
  & 0.16813599E-05_JPRB, 0.16880922E-05_JPRB, 0.16954522E-05_JPRB, 0.17033221E-05_JPRB, 0.17115511E-05_JPRB, 0.17199744E-05_JPRB, &
  & 0.17282362E-05_JPRB, 0.17358462E-05_JPRB, 0.17421578E-05_JPRB, 0.17468941E-05_JPRB, 0.17501445E-05_JPRB, 0.17522790E-05_JPRB, &
  & 0.17536587E-05_JPRB, 0.17545565E-05_JPRB, 0.17551390E-05_JPRB, 0.17555011E-05_JPRB, 0.17556814E-05_JPRB, 0.17556868E-05_JPRB, &
  & 0.17555101E-05_JPRB, 0.17551311E-05_JPRB, 0.17545856E-05_JPRB, 0.17538798E-05_JPRB, 0.17531271E-05_JPRB, 0.17523638E-05_JPRB, &
  & 0.17516029E-05_JPRB, 0.17508725E-05_JPRB, 0.17501488E-05_JPRB, 0.17493969E-05_JPRB, 0.17485514E-05_JPRB, 0.17475259E-05_JPRB, &
  & 0.17462016E-05_JPRB, 0.17444171E-05_JPRB, 0.17420253E-05_JPRB, 0.17389038E-05_JPRB, 0.17350478E-05_JPRB, 0.17305098E-05_JPRB, &
  & 0.17253874E-05_JPRB, 0.17198568E-05_JPRB, 0.17142806E-05_JPRB, 0.17090820E-05_JPRB, 0.17044899E-05_JPRB, 0.17004461E-05_JPRB, &
  & 0.16967913E-05_JPRB, 0.16933651E-05_JPRB, 0.16901292E-05_JPRB, 0.16871850E-05_JPRB, 0.16846424E-05_JPRB, 0.16825019E-05_JPRB, &
  & 0.16806454E-05_JPRB, 0.16789018E-05_JPRB, 0.16769920E-05_JPRB, 0.16738401E-05_JPRB /)

RGHG2(:,44, 5) = (/ &
  & 0.16318547E-05_JPRB, 0.16390527E-05_JPRB, 0.16440224E-05_JPRB, 0.16493287E-05_JPRB, 0.16554126E-05_JPRB, 0.16611834E-05_JPRB, &
  & 0.16658651E-05_JPRB, 0.16696818E-05_JPRB, 0.16730531E-05_JPRB, 0.16763981E-05_JPRB, 0.16800698E-05_JPRB, 0.16843890E-05_JPRB, &
  & 0.16895200E-05_JPRB, 0.16954630E-05_JPRB, 0.17020770E-05_JPRB, 0.17091774E-05_JPRB, 0.17166584E-05_JPRB, 0.17242870E-05_JPRB, &
  & 0.17317896E-05_JPRB, 0.17385860E-05_JPRB, 0.17442048E-05_JPRB, 0.17483263E-05_JPRB, 0.17511501E-05_JPRB, 0.17529958E-05_JPRB, &
  & 0.17541954E-05_JPRB, 0.17549849E-05_JPRB, 0.17555054E-05_JPRB, 0.17558332E-05_JPRB, 0.17559993E-05_JPRB, 0.17560001E-05_JPRB, &
  & 0.17558272E-05_JPRB, 0.17554510E-05_JPRB, 0.17549089E-05_JPRB, 0.17542055E-05_JPRB, 0.17534576E-05_JPRB, 0.17527120E-05_JPRB, &
  & 0.17519851E-05_JPRB, 0.17513096E-05_JPRB, 0.17506816E-05_JPRB, 0.17500763E-05_JPRB, 0.17494608E-05_JPRB, 0.17487728E-05_JPRB, &
  & 0.17479146E-05_JPRB, 0.17467464E-05_JPRB, 0.17450704E-05_JPRB, 0.17427030E-05_JPRB, 0.17395128E-05_JPRB, 0.17354809E-05_JPRB, &
  & 0.17307165E-05_JPRB, 0.17254415E-05_JPRB, 0.17200819E-05_JPRB, 0.17151356E-05_JPRB, 0.17108047E-05_JPRB, 0.17070601E-05_JPRB, &
  & 0.17036905E-05_JPRB, 0.17005480E-05_JPRB, 0.16975886E-05_JPRB, 0.16949156E-05_JPRB, 0.16926433E-05_JPRB, 0.16907538E-05_JPRB, &
  & 0.16891360E-05_JPRB, 0.16876068E-05_JPRB, 0.16859279E-05_JPRB, 0.16831121E-05_JPRB /)

RGHG2(:,45, 5) = (/ &
  & 0.16456428E-05_JPRB, 0.16524655E-05_JPRB, 0.16568642E-05_JPRB, 0.16620097E-05_JPRB, 0.16678769E-05_JPRB, 0.16734200E-05_JPRB, &
  & 0.16777742E-05_JPRB, 0.16811325E-05_JPRB, 0.16839833E-05_JPRB, 0.16867302E-05_JPRB, 0.16897376E-05_JPRB, 0.16932904E-05_JPRB, &
  & 0.16976794E-05_JPRB, 0.17029065E-05_JPRB, 0.17088215E-05_JPRB, 0.17152440E-05_JPRB, 0.17219381E-05_JPRB, 0.17287628E-05_JPRB, &
  & 0.17353264E-05_JPRB, 0.17412669E-05_JPRB, 0.17460428E-05_JPRB, 0.17495910E-05_JPRB, 0.17519994E-05_JPRB, 0.17535978E-05_JPRB, &
  & 0.17546466E-05_JPRB, 0.17553489E-05_JPRB, 0.17558227E-05_JPRB, 0.17561277E-05_JPRB, 0.17562861E-05_JPRB, 0.17562879E-05_JPRB, &
  & 0.17561194E-05_JPRB, 0.17557481E-05_JPRB, 0.17552063E-05_JPRB, 0.17545042E-05_JPRB, 0.17537525E-05_JPRB, 0.17530142E-05_JPRB, &
  & 0.17523048E-05_JPRB, 0.17516717E-05_JPRB, 0.17511143E-05_JPRB, 0.17506295E-05_JPRB, 0.17501980E-05_JPRB, 0.17497842E-05_JPRB, &
  & 0.17493155E-05_JPRB, 0.17486639E-05_JPRB, 0.17476594E-05_JPRB, 0.17460669E-05_JPRB, 0.17436682E-05_JPRB, 0.17403304E-05_JPRB, &
  & 0.17360484E-05_JPRB, 0.17311187E-05_JPRB, 0.17260440E-05_JPRB, 0.17213338E-05_JPRB, 0.17173073E-05_JPRB, 0.17138241E-05_JPRB, &
  & 0.17107434E-05_JPRB, 0.17078614E-05_JPRB, 0.17051524E-05_JPRB, 0.17027201E-05_JPRB, 0.17006687E-05_JPRB, 0.16989932E-05_JPRB, &
  & 0.16975574E-05_JPRB, 0.16962131E-05_JPRB, 0.16947125E-05_JPRB, 0.16921869E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART9',1,ZHOOK_HANDLE)
END SUBROUTINE PART9




SUBROUTINE PART10
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART10',0,ZHOOK_HANDLE)



RGHG2(:,46, 5) = (/ &
  & 0.16592518E-05_JPRB, 0.16652100E-05_JPRB, 0.16695969E-05_JPRB, 0.16742242E-05_JPRB, 0.16799589E-05_JPRB, 0.16852766E-05_JPRB, &
  & 0.16892822E-05_JPRB, 0.16922568E-05_JPRB, 0.16946716E-05_JPRB, 0.16969466E-05_JPRB, 0.16993786E-05_JPRB, 0.17023387E-05_JPRB, &
  & 0.17060271E-05_JPRB, 0.17106148E-05_JPRB, 0.17159164E-05_JPRB, 0.17216369E-05_JPRB, 0.17275743E-05_JPRB, 0.17334303E-05_JPRB, &
  & 0.17389782E-05_JPRB, 0.17438061E-05_JPRB, 0.17477729E-05_JPRB, 0.17506896E-05_JPRB, 0.17527370E-05_JPRB, 0.17541097E-05_JPRB, &
  & 0.17550336E-05_JPRB, 0.17556665E-05_JPRB, 0.17561053E-05_JPRB, 0.17563965E-05_JPRB, 0.17565530E-05_JPRB, 0.17565606E-05_JPRB, &
  & 0.17563978E-05_JPRB, 0.17560342E-05_JPRB, 0.17554902E-05_JPRB, 0.17547856E-05_JPRB, 0.17540260E-05_JPRB, 0.17532827E-05_JPRB, &
  & 0.17525824E-05_JPRB, 0.17519748E-05_JPRB, 0.17514767E-05_JPRB, 0.17510871E-05_JPRB, 0.17508086E-05_JPRB, 0.17506165E-05_JPRB, &
  & 0.17504537E-05_JPRB, 0.17502216E-05_JPRB, 0.17497590E-05_JPRB, 0.17488646E-05_JPRB, 0.17472914E-05_JPRB, 0.17447811E-05_JPRB, &
  & 0.17412393E-05_JPRB, 0.17368253E-05_JPRB, 0.17321014E-05_JPRB, 0.17277489E-05_JPRB, 0.17239704E-05_JPRB, 0.17208199E-05_JPRB, &
  & 0.17179846E-05_JPRB, 0.17153646E-05_JPRB, 0.17128851E-05_JPRB, 0.17106636E-05_JPRB, 0.17088100E-05_JPRB, 0.17073019E-05_JPRB, &
  & 0.17060277E-05_JPRB, 0.17048221E-05_JPRB, 0.17034815E-05_JPRB, 0.17011912E-05_JPRB /)

RGHG2(:,47, 5) = (/ &
  & 0.16720571E-05_JPRB, 0.16779211E-05_JPRB, 0.16816605E-05_JPRB, 0.16863362E-05_JPRB, 0.16916923E-05_JPRB, 0.16968276E-05_JPRB, &
  & 0.17005682E-05_JPRB, 0.17032178E-05_JPRB, 0.17053042E-05_JPRB, 0.17071923E-05_JPRB, 0.17092214E-05_JPRB, 0.17116288E-05_JPRB, &
  & 0.17147930E-05_JPRB, 0.17187750E-05_JPRB, 0.17234676E-05_JPRB, 0.17285153E-05_JPRB, 0.17335445E-05_JPRB, 0.17382986E-05_JPRB, &
  & 0.17425646E-05_JPRB, 0.17462812E-05_JPRB, 0.17493106E-05_JPRB, 0.17516776E-05_JPRB, 0.17533699E-05_JPRB, 0.17545528E-05_JPRB, &
  & 0.17553705E-05_JPRB, 0.17559482E-05_JPRB, 0.17563616E-05_JPRB, 0.17566464E-05_JPRB, 0.17568063E-05_JPRB, 0.17568237E-05_JPRB, &
  & 0.17566692E-05_JPRB, 0.17563134E-05_JPRB, 0.17557672E-05_JPRB, 0.17550569E-05_JPRB, 0.17542837E-05_JPRB, 0.17535285E-05_JPRB, &
  & 0.17528253E-05_JPRB, 0.17522370E-05_JPRB, 0.17517821E-05_JPRB, 0.17514749E-05_JPRB, 0.17513214E-05_JPRB, 0.17513074E-05_JPRB, &
  & 0.17513846E-05_JPRB, 0.17514648E-05_JPRB, 0.17514160E-05_JPRB, 0.17510656E-05_JPRB, 0.17502057E-05_JPRB, 0.17485888E-05_JPRB, &
  & 0.17459676E-05_JPRB, 0.17423467E-05_JPRB, 0.17382197E-05_JPRB, 0.17342304E-05_JPRB, 0.17308644E-05_JPRB, 0.17279674E-05_JPRB, &
  & 0.17254404E-05_JPRB, 0.17230439E-05_JPRB, 0.17207839E-05_JPRB, 0.17187530E-05_JPRB, 0.17170661E-05_JPRB, 0.17157072E-05_JPRB, &
  & 0.17145592E-05_JPRB, 0.17134768E-05_JPRB, 0.17122622E-05_JPRB, 0.17101742E-05_JPRB /)

RGHG2(:,48, 5) = (/ &
  & 0.16845809E-05_JPRB, 0.16898641E-05_JPRB, 0.16937529E-05_JPRB, 0.16979775E-05_JPRB, 0.17033888E-05_JPRB, 0.17083311E-05_JPRB, &
  & 0.17118873E-05_JPRB, 0.17143120E-05_JPRB, 0.17161381E-05_JPRB, 0.17177524E-05_JPRB, 0.17194241E-05_JPRB, 0.17214563E-05_JPRB, &
  & 0.17240857E-05_JPRB, 0.17275302E-05_JPRB, 0.17315473E-05_JPRB, 0.17357252E-05_JPRB, 0.17396080E-05_JPRB, 0.17430286E-05_JPRB, &
  & 0.17459525E-05_JPRB, 0.17484996E-05_JPRB, 0.17507134E-05_JPRB, 0.17525255E-05_JPRB, 0.17539224E-05_JPRB, 0.17549373E-05_JPRB, &
  & 0.17556678E-05_JPRB, 0.17562024E-05_JPRB, 0.17565985E-05_JPRB, 0.17568822E-05_JPRB, 0.17570507E-05_JPRB, 0.17570810E-05_JPRB, &
  & 0.17569370E-05_JPRB, 0.17565908E-05_JPRB, 0.17560402E-05_JPRB, 0.17553222E-05_JPRB, 0.17545317E-05_JPRB, 0.17537553E-05_JPRB, &
  & 0.17530454E-05_JPRB, 0.17524656E-05_JPRB, 0.17520474E-05_JPRB, 0.17518059E-05_JPRB, 0.17517576E-05_JPRB, 0.17518887E-05_JPRB, &
  & 0.17521543E-05_JPRB, 0.17524645E-05_JPRB, 0.17527061E-05_JPRB, 0.17527443E-05_JPRB, 0.17524295E-05_JPRB, 0.17515700E-05_JPRB, &
  & 0.17499183E-05_JPRB, 0.17473488E-05_JPRB, 0.17440725E-05_JPRB, 0.17407656E-05_JPRB, 0.17378200E-05_JPRB, 0.17353104E-05_JPRB, &
  & 0.17330283E-05_JPRB, 0.17308777E-05_JPRB, 0.17288032E-05_JPRB, 0.17269413E-05_JPRB, 0.17254013E-05_JPRB, 0.17241675E-05_JPRB, &
  & 0.17231272E-05_JPRB, 0.17221445E-05_JPRB, 0.17210338E-05_JPRB, 0.17191140E-05_JPRB /)

RGHG2(:,49, 5) = (/ &
  & 0.16965030E-05_JPRB, 0.17017489E-05_JPRB, 0.17054263E-05_JPRB, 0.17097888E-05_JPRB, 0.17150876E-05_JPRB, 0.17200398E-05_JPRB, &
  & 0.17234684E-05_JPRB, 0.17257209E-05_JPRB, 0.17273347E-05_JPRB, 0.17287082E-05_JPRB, 0.17300749E-05_JPRB, 0.17317132E-05_JPRB, &
  & 0.17338408E-05_JPRB, 0.17365546E-05_JPRB, 0.17396500E-05_JPRB, 0.17425720E-05_JPRB, 0.17451010E-05_JPRB, 0.17471269E-05_JPRB, &
  & 0.17488686E-05_JPRB, 0.17504237E-05_JPRB, 0.17519158E-05_JPRB, 0.17532693E-05_JPRB, 0.17543965E-05_JPRB, 0.17552734E-05_JPRB, &
  & 0.17559338E-05_JPRB, 0.17564361E-05_JPRB, 0.17568218E-05_JPRB, 0.17571090E-05_JPRB, 0.17572891E-05_JPRB, 0.17573352E-05_JPRB, &
  & 0.17572047E-05_JPRB, 0.17568677E-05_JPRB, 0.17563136E-05_JPRB, 0.17555843E-05_JPRB, 0.17547720E-05_JPRB, 0.17539712E-05_JPRB, &
  & 0.17532475E-05_JPRB, 0.17526712E-05_JPRB, 0.17522788E-05_JPRB, 0.17520932E-05_JPRB, 0.17521337E-05_JPRB, 0.17523892E-05_JPRB, &
  & 0.17528021E-05_JPRB, 0.17532880E-05_JPRB, 0.17537254E-05_JPRB, 0.17540222E-05_JPRB, 0.17540797E-05_JPRB, 0.17537700E-05_JPRB, &
  & 0.17529354E-05_JPRB, 0.17513968E-05_JPRB, 0.17492628E-05_JPRB, 0.17468972E-05_JPRB, 0.17446184E-05_JPRB, 0.17425916E-05_JPRB, &
  & 0.17406509E-05_JPRB, 0.17387461E-05_JPRB, 0.17368675E-05_JPRB, 0.17351605E-05_JPRB, 0.17337491E-05_JPRB, 0.17326261E-05_JPRB, &
  & 0.17316756E-05_JPRB, 0.17307773E-05_JPRB, 0.17297451E-05_JPRB, 0.17279513E-05_JPRB /)

RGHG2(:,50, 5) = (/ &
  & 0.17079154E-05_JPRB, 0.17133996E-05_JPRB, 0.17170187E-05_JPRB, 0.17215148E-05_JPRB, 0.17267919E-05_JPRB, 0.17316182E-05_JPRB, &
  & 0.17348100E-05_JPRB, 0.17367759E-05_JPRB, 0.17381333E-05_JPRB, 0.17391768E-05_JPRB, 0.17402280E-05_JPRB, 0.17413602E-05_JPRB, &
  & 0.17428308E-05_JPRB, 0.17446037E-05_JPRB, 0.17464305E-05_JPRB, 0.17480679E-05_JPRB, 0.17493189E-05_JPRB, 0.17503260E-05_JPRB, &
  & 0.17511660E-05_JPRB, 0.17520372E-05_JPRB, 0.17529474E-05_JPRB, 0.17539111E-05_JPRB, 0.17548115E-05_JPRB, 0.17555706E-05_JPRB, &
  & 0.17561767E-05_JPRB, 0.17566563E-05_JPRB, 0.17570375E-05_JPRB, 0.17573309E-05_JPRB, 0.17575252E-05_JPRB, 0.17575887E-05_JPRB, &
  & 0.17574745E-05_JPRB, 0.17571471E-05_JPRB, 0.17565886E-05_JPRB, 0.17558457E-05_JPRB, 0.17550071E-05_JPRB, 0.17541798E-05_JPRB, &
  & 0.17534387E-05_JPRB, 0.17528589E-05_JPRB, 0.17524843E-05_JPRB, 0.17523439E-05_JPRB, 0.17524633E-05_JPRB, 0.17528266E-05_JPRB, &
  & 0.17533716E-05_JPRB, 0.17539762E-05_JPRB, 0.17545583E-05_JPRB, 0.17550175E-05_JPRB, 0.17553150E-05_JPRB, 0.17553738E-05_JPRB, &
  & 0.17550872E-05_JPRB, 0.17543739E-05_JPRB, 0.17532441E-05_JPRB, 0.17518601E-05_JPRB, 0.17505117E-05_JPRB, 0.17490947E-05_JPRB, &
  & 0.17477117E-05_JPRB, 0.17462060E-05_JPRB, 0.17446482E-05_JPRB, 0.17431632E-05_JPRB, 0.17419313E-05_JPRB, 0.17409259E-05_JPRB, &
  & 0.17400832E-05_JPRB, 0.17392506E-05_JPRB, 0.17383034E-05_JPRB, 0.17365684E-05_JPRB /)

RGHG2(:,51, 5) = (/ &
  & 0.17191353E-05_JPRB, 0.17242050E-05_JPRB, 0.17283571E-05_JPRB, 0.17324262E-05_JPRB, 0.17375996E-05_JPRB, 0.17417539E-05_JPRB, &
  & 0.17443090E-05_JPRB, 0.17457892E-05_JPRB, 0.17466992E-05_JPRB, 0.17474240E-05_JPRB, 0.17480181E-05_JPRB, 0.17487132E-05_JPRB, &
  & 0.17494680E-05_JPRB, 0.17503412E-05_JPRB, 0.17511817E-05_JPRB, 0.17518250E-05_JPRB, 0.17522964E-05_JPRB, 0.17526363E-05_JPRB, &
  & 0.17529699E-05_JPRB, 0.17533436E-05_JPRB, 0.17538572E-05_JPRB, 0.17544867E-05_JPRB, 0.17551807E-05_JPRB, 0.17558405E-05_JPRB, &
  & 0.17564038E-05_JPRB, 0.17568691E-05_JPRB, 0.17572505E-05_JPRB, 0.17575529E-05_JPRB, 0.17577624E-05_JPRB, 0.17578440E-05_JPRB, &
  & 0.17577472E-05_JPRB, 0.17574299E-05_JPRB, 0.17568684E-05_JPRB, 0.17561076E-05_JPRB, 0.17552429E-05_JPRB, 0.17543846E-05_JPRB, &
  & 0.17536227E-05_JPRB, 0.17530342E-05_JPRB, 0.17526692E-05_JPRB, 0.17525665E-05_JPRB, 0.17527568E-05_JPRB, 0.17532236E-05_JPRB, &
  & 0.17538677E-05_JPRB, 0.17545880E-05_JPRB, 0.17552491E-05_JPRB, 0.17558319E-05_JPRB, 0.17562762E-05_JPRB, 0.17565665E-05_JPRB, &
  & 0.17566344E-05_JPRB, 0.17564278E-05_JPRB, 0.17559671E-05_JPRB, 0.17553798E-05_JPRB, 0.17546874E-05_JPRB, 0.17540137E-05_JPRB, &
  & 0.17532237E-05_JPRB, 0.17523403E-05_JPRB, 0.17513075E-05_JPRB, 0.17502696E-05_JPRB, 0.17493262E-05_JPRB, 0.17485610E-05_JPRB, &
  & 0.17478545E-05_JPRB, 0.17471750E-05_JPRB, 0.17462889E-05_JPRB, 0.17447256E-05_JPRB /)

RGHG2(:,52, 5) = (/ &
  & 0.17288374E-05_JPRB, 0.17346472E-05_JPRB, 0.17378239E-05_JPRB, 0.17420449E-05_JPRB, 0.17460202E-05_JPRB, 0.17492009E-05_JPRB, &
  & 0.17509109E-05_JPRB, 0.17518157E-05_JPRB, 0.17523789E-05_JPRB, 0.17527456E-05_JPRB, 0.17530900E-05_JPRB, 0.17533807E-05_JPRB, &
  & 0.17537131E-05_JPRB, 0.17540174E-05_JPRB, 0.17542397E-05_JPRB, 0.17543480E-05_JPRB, 0.17543633E-05_JPRB, 0.17543504E-05_JPRB, &
  & 0.17543625E-05_JPRB, 0.17544523E-05_JPRB, 0.17546572E-05_JPRB, 0.17550235E-05_JPRB, 0.17555317E-05_JPRB, 0.17560922E-05_JPRB, &
  & 0.17566213E-05_JPRB, 0.17570791E-05_JPRB, 0.17574650E-05_JPRB, 0.17577784E-05_JPRB, 0.17580040E-05_JPRB, 0.17581033E-05_JPRB, &
  & 0.17580250E-05_JPRB, 0.17577177E-05_JPRB, 0.17571524E-05_JPRB, 0.17563742E-05_JPRB, 0.17554794E-05_JPRB, 0.17545899E-05_JPRB, &
  & 0.17538026E-05_JPRB, 0.17532008E-05_JPRB, 0.17528404E-05_JPRB, 0.17527695E-05_JPRB, 0.17530244E-05_JPRB, 0.17535770E-05_JPRB, &
  & 0.17543258E-05_JPRB, 0.17551062E-05_JPRB, 0.17558635E-05_JPRB, 0.17565105E-05_JPRB, 0.17570768E-05_JPRB, 0.17575061E-05_JPRB, &
  & 0.17577872E-05_JPRB, 0.17578775E-05_JPRB, 0.17578014E-05_JPRB, 0.17576122E-05_JPRB, 0.17573922E-05_JPRB, 0.17571152E-05_JPRB, &
  & 0.17568138E-05_JPRB, 0.17564230E-05_JPRB, 0.17559405E-05_JPRB, 0.17553875E-05_JPRB, 0.17548791E-05_JPRB, 0.17544006E-05_JPRB, &
  & 0.17539775E-05_JPRB, 0.17534824E-05_JPRB, 0.17528768E-05_JPRB, 0.17515071E-05_JPRB /)

RGHG2(:,53, 5) = (/ &
  & 0.17379301E-05_JPRB, 0.17423828E-05_JPRB, 0.17459686E-05_JPRB, 0.17487912E-05_JPRB, 0.17520011E-05_JPRB, 0.17540273E-05_JPRB, &
  & 0.17550781E-05_JPRB, 0.17556015E-05_JPRB, 0.17558885E-05_JPRB, 0.17560939E-05_JPRB, 0.17562286E-05_JPRB, 0.17563495E-05_JPRB, &
  & 0.17564207E-05_JPRB, 0.17564241E-05_JPRB, 0.17563239E-05_JPRB, 0.17561314E-05_JPRB, 0.17558950E-05_JPRB, 0.17556763E-05_JPRB, &
  & 0.17554926E-05_JPRB, 0.17553896E-05_JPRB, 0.17553893E-05_JPRB, 0.17555412E-05_JPRB, 0.17558705E-05_JPRB, 0.17563401E-05_JPRB, &
  & 0.17568341E-05_JPRB, 0.17572888E-05_JPRB, 0.17576838E-05_JPRB, 0.17580103E-05_JPRB, 0.17582524E-05_JPRB, 0.17583695E-05_JPRB, &
  & 0.17583086E-05_JPRB, 0.17580102E-05_JPRB, 0.17574423E-05_JPRB, 0.17566446E-05_JPRB, 0.17557209E-05_JPRB, 0.17547972E-05_JPRB, &
  & 0.17539825E-05_JPRB, 0.17533638E-05_JPRB, 0.17530053E-05_JPRB, 0.17529625E-05_JPRB, 0.17532712E-05_JPRB, 0.17539032E-05_JPRB, &
  & 0.17547152E-05_JPRB, 0.17555868E-05_JPRB, 0.17563856E-05_JPRB, 0.17571258E-05_JPRB, 0.17577561E-05_JPRB, 0.17583022E-05_JPRB, &
  & 0.17587032E-05_JPRB, 0.17589566E-05_JPRB, 0.17590737E-05_JPRB, 0.17590959E-05_JPRB, 0.17590667E-05_JPRB, 0.17590116E-05_JPRB, &
  & 0.17589259E-05_JPRB, 0.17588025E-05_JPRB, 0.17586242E-05_JPRB, 0.17584105E-05_JPRB, 0.17581810E-05_JPRB, 0.17579810E-05_JPRB, &
  & 0.17577656E-05_JPRB, 0.17575421E-05_JPRB, 0.17571804E-05_JPRB, 0.17563885E-05_JPRB /)

RGHG2(:,54, 5) = (/ &
  & 0.17448833E-05_JPRB, 0.17492209E-05_JPRB, 0.17513124E-05_JPRB, 0.17538077E-05_JPRB, 0.17558240E-05_JPRB, 0.17571577E-05_JPRB, &
  & 0.17577592E-05_JPRB, 0.17580460E-05_JPRB, 0.17582009E-05_JPRB, 0.17582856E-05_JPRB, 0.17583395E-05_JPRB, 0.17583511E-05_JPRB, &
  & 0.17583009E-05_JPRB, 0.17581528E-05_JPRB, 0.17578783E-05_JPRB, 0.17575143E-05_JPRB, 0.17571322E-05_JPRB, 0.17567623E-05_JPRB, &
  & 0.17564588E-05_JPRB, 0.17562072E-05_JPRB, 0.17560549E-05_JPRB, 0.17560378E-05_JPRB, 0.17562197E-05_JPRB, 0.17565885E-05_JPRB, &
  & 0.17570510E-05_JPRB, 0.17575030E-05_JPRB, 0.17579079E-05_JPRB, 0.17582510E-05_JPRB, 0.17585101E-05_JPRB, 0.17586449E-05_JPRB, &
  & 0.17585995E-05_JPRB, 0.17583084E-05_JPRB, 0.17577373E-05_JPRB, 0.17569208E-05_JPRB, 0.17559672E-05_JPRB, 0.17550105E-05_JPRB, &
  & 0.17541649E-05_JPRB, 0.17535285E-05_JPRB, 0.17531722E-05_JPRB, 0.17531539E-05_JPRB, 0.17535083E-05_JPRB, 0.17541929E-05_JPRB, &
  & 0.17550758E-05_JPRB, 0.17559883E-05_JPRB, 0.17568727E-05_JPRB, 0.17576574E-05_JPRB, 0.17583825E-05_JPRB, 0.17589882E-05_JPRB, &
  & 0.17594821E-05_JPRB, 0.17598222E-05_JPRB, 0.17600262E-05_JPRB, 0.17601443E-05_JPRB, 0.17602006E-05_JPRB, 0.17602297E-05_JPRB, &
  & 0.17602378E-05_JPRB, 0.17602242E-05_JPRB, 0.17601828E-05_JPRB, 0.17601196E-05_JPRB, 0.17600516E-05_JPRB, 0.17599804E-05_JPRB, &
  & 0.17599168E-05_JPRB, 0.17598433E-05_JPRB, 0.17597666E-05_JPRB, 0.17596525E-05_JPRB /)

RGHG2(:,55, 5) = (/ &
  & 0.17502275E-05_JPRB, 0.17534599E-05_JPRB, 0.17555220E-05_JPRB, 0.17570428E-05_JPRB, 0.17584648E-05_JPRB, 0.17592596E-05_JPRB, &
  & 0.17596168E-05_JPRB, 0.17597708E-05_JPRB, 0.17598425E-05_JPRB, 0.17598765E-05_JPRB, 0.17598793E-05_JPRB, 0.17598414E-05_JPRB, &
  & 0.17597411E-05_JPRB, 0.17595164E-05_JPRB, 0.17591540E-05_JPRB, 0.17586948E-05_JPRB, 0.17581981E-05_JPRB, 0.17577347E-05_JPRB, &
  & 0.17573022E-05_JPRB, 0.17569469E-05_JPRB, 0.17566643E-05_JPRB, 0.17565122E-05_JPRB, 0.17565649E-05_JPRB, 0.17568549E-05_JPRB, &
  & 0.17572777E-05_JPRB, 0.17577273E-05_JPRB, 0.17581433E-05_JPRB, 0.17585037E-05_JPRB, 0.17587811E-05_JPRB, 0.17589325E-05_JPRB, &
  & 0.17588989E-05_JPRB, 0.17586136E-05_JPRB, 0.17580386E-05_JPRB, 0.17572050E-05_JPRB, 0.17562235E-05_JPRB, 0.17552323E-05_JPRB, &
  & 0.17543575E-05_JPRB, 0.17537026E-05_JPRB, 0.17533491E-05_JPRB, 0.17533531E-05_JPRB, 0.17537425E-05_JPRB, 0.17544686E-05_JPRB, &
  & 0.17553878E-05_JPRB, 0.17563655E-05_JPRB, 0.17572917E-05_JPRB, 0.17581596E-05_JPRB, 0.17589316E-05_JPRB, 0.17596199E-05_JPRB, &
  & 0.17601614E-05_JPRB, 0.17605528E-05_JPRB, 0.17608079E-05_JPRB, 0.17609523E-05_JPRB, 0.17610472E-05_JPRB, 0.17611059E-05_JPRB, &
  & 0.17611478E-05_JPRB, 0.17611758E-05_JPRB, 0.17611887E-05_JPRB, 0.17611916E-05_JPRB, 0.17611844E-05_JPRB, 0.17611733E-05_JPRB, &
  & 0.17611555E-05_JPRB, 0.17611310E-05_JPRB, 0.17610821E-05_JPRB, 0.17609580E-05_JPRB /)

RGHG2(:,56, 5) = (/ &
  & 0.17550608E-05_JPRB, 0.17572348E-05_JPRB, 0.17583484E-05_JPRB, 0.17594343E-05_JPRB, 0.17603242E-05_JPRB, 0.17608156E-05_JPRB, &
  & 0.17610159E-05_JPRB, 0.17610967E-05_JPRB, 0.17611274E-05_JPRB, 0.17611313E-05_JPRB, 0.17611108E-05_JPRB, 0.17610574E-05_JPRB, &
  & 0.17609300E-05_JPRB, 0.17606882E-05_JPRB, 0.17602895E-05_JPRB, 0.17597681E-05_JPRB, 0.17591981E-05_JPRB, 0.17586218E-05_JPRB, &
  & 0.17580981E-05_JPRB, 0.17576178E-05_JPRB, 0.17572228E-05_JPRB, 0.17569623E-05_JPRB, 0.17569174E-05_JPRB, 0.17571343E-05_JPRB, &
  & 0.17575261E-05_JPRB, 0.17579691E-05_JPRB, 0.17583966E-05_JPRB, 0.17587749E-05_JPRB, 0.17590710E-05_JPRB, 0.17592369E-05_JPRB, &
  & 0.17592123E-05_JPRB, 0.17589293E-05_JPRB, 0.17583493E-05_JPRB, 0.17574993E-05_JPRB, 0.17564910E-05_JPRB, 0.17554678E-05_JPRB, &
  & 0.17545635E-05_JPRB, 0.17538938E-05_JPRB, 0.17535436E-05_JPRB, 0.17535684E-05_JPRB, 0.17539853E-05_JPRB, 0.17547393E-05_JPRB, &
  & 0.17556927E-05_JPRB, 0.17567041E-05_JPRB, 0.17576909E-05_JPRB, 0.17586046E-05_JPRB, 0.17594479E-05_JPRB, 0.17601797E-05_JPRB, &
  & 0.17607783E-05_JPRB, 0.17612064E-05_JPRB, 0.17614722E-05_JPRB, 0.17616408E-05_JPRB, 0.17617382E-05_JPRB, 0.17618071E-05_JPRB, &
  & 0.17618586E-05_JPRB, 0.17618999E-05_JPRB, 0.17619327E-05_JPRB, 0.17619616E-05_JPRB, 0.17619811E-05_JPRB, 0.17619949E-05_JPRB, &
  & 0.17620019E-05_JPRB, 0.17620047E-05_JPRB, 0.17620000E-05_JPRB, 0.17619777E-05_JPRB /)

RGHG2(:,57, 5) = (/ &
  & 0.17580929E-05_JPRB, 0.17596560E-05_JPRB, 0.17604930E-05_JPRB, 0.17611992E-05_JPRB, 0.17617375E-05_JPRB, 0.17620430E-05_JPRB, &
  & 0.17621596E-05_JPRB, 0.17621996E-05_JPRB, 0.17622079E-05_JPRB, 0.17621985E-05_JPRB, 0.17621711E-05_JPRB, 0.17621087E-05_JPRB, &
  & 0.17619877E-05_JPRB, 0.17617475E-05_JPRB, 0.17613462E-05_JPRB, 0.17607979E-05_JPRB, 0.17601540E-05_JPRB, 0.17594911E-05_JPRB, &
  & 0.17588397E-05_JPRB, 0.17582518E-05_JPRB, 0.17577485E-05_JPRB, 0.17573875E-05_JPRB, 0.17572750E-05_JPRB, 0.17574432E-05_JPRB, &
  & 0.17578033E-05_JPRB, 0.17582403E-05_JPRB, 0.17586769E-05_JPRB, 0.17590738E-05_JPRB, 0.17593873E-05_JPRB, 0.17595659E-05_JPRB, &
  & 0.17595476E-05_JPRB, 0.17592633E-05_JPRB, 0.17586749E-05_JPRB, 0.17578085E-05_JPRB, 0.17567743E-05_JPRB, 0.17557225E-05_JPRB, &
  & 0.17547936E-05_JPRB, 0.17541101E-05_JPRB, 0.17537654E-05_JPRB, 0.17538079E-05_JPRB, 0.17542477E-05_JPRB, 0.17550208E-05_JPRB, &
  & 0.17559976E-05_JPRB, 0.17570427E-05_JPRB, 0.17580669E-05_JPRB, 0.17590276E-05_JPRB, 0.17599118E-05_JPRB, 0.17606956E-05_JPRB, &
  & 0.17613334E-05_JPRB, 0.17617903E-05_JPRB, 0.17620814E-05_JPRB, 0.17622440E-05_JPRB, 0.17623476E-05_JPRB, 0.17624147E-05_JPRB, &
  & 0.17624659E-05_JPRB, 0.17625086E-05_JPRB, 0.17625448E-05_JPRB, 0.17625791E-05_JPRB, 0.17626086E-05_JPRB, 0.17626288E-05_JPRB, &
  & 0.17626427E-05_JPRB, 0.17626487E-05_JPRB, 0.17626430E-05_JPRB, 0.17626030E-05_JPRB /)

RGHG2(:,58, 5) = (/ &
  & 0.17607321E-05_JPRB, 0.17616416E-05_JPRB, 0.17621412E-05_JPRB, 0.17625530E-05_JPRB, 0.17629127E-05_JPRB, 0.17630909E-05_JPRB, &
  & 0.17631590E-05_JPRB, 0.17631774E-05_JPRB, 0.17631755E-05_JPRB, 0.17631614E-05_JPRB, 0.17631310E-05_JPRB, 0.17630745E-05_JPRB, &
  & 0.17629599E-05_JPRB, 0.17627395E-05_JPRB, 0.17623588E-05_JPRB, 0.17617971E-05_JPRB, 0.17611019E-05_JPRB, 0.17603304E-05_JPRB, &
  & 0.17595703E-05_JPRB, 0.17588557E-05_JPRB, 0.17582463E-05_JPRB, 0.17578170E-05_JPRB, 0.17576514E-05_JPRB, 0.17577830E-05_JPRB, &
  & 0.17581203E-05_JPRB, 0.17585513E-05_JPRB, 0.17589982E-05_JPRB, 0.17594105E-05_JPRB, 0.17597399E-05_JPRB, 0.17599277E-05_JPRB, &
  & 0.17599134E-05_JPRB, 0.17596249E-05_JPRB, 0.17590251E-05_JPRB, 0.17581383E-05_JPRB, 0.17570810E-05_JPRB, 0.17560052E-05_JPRB, &
  & 0.17550574E-05_JPRB, 0.17543658E-05_JPRB, 0.17540251E-05_JPRB, 0.17540807E-05_JPRB, 0.17545350E-05_JPRB, 0.17553252E-05_JPRB, &
  & 0.17563186E-05_JPRB, 0.17573891E-05_JPRB, 0.17584421E-05_JPRB, 0.17594361E-05_JPRB, 0.17603496E-05_JPRB, 0.17611633E-05_JPRB, &
  & 0.17618439E-05_JPRB, 0.17623364E-05_JPRB, 0.17626348E-05_JPRB, 0.17628092E-05_JPRB, 0.17629070E-05_JPRB, 0.17629717E-05_JPRB, &
  & 0.17630193E-05_JPRB, 0.17630573E-05_JPRB, 0.17630892E-05_JPRB, 0.17631228E-05_JPRB, 0.17631510E-05_JPRB, 0.17631728E-05_JPRB, &
  & 0.17631867E-05_JPRB, 0.17631939E-05_JPRB, 0.17631895E-05_JPRB, 0.17631513E-05_JPRB /)

RGHG2(:,59, 5) = (/ &
  & 0.17624548E-05_JPRB, 0.17630953E-05_JPRB, 0.17634225E-05_JPRB, 0.17637063E-05_JPRB, 0.17639122E-05_JPRB, 0.17640336E-05_JPRB, &
  & 0.17640741E-05_JPRB, 0.17640830E-05_JPRB, 0.17640780E-05_JPRB, 0.17640631E-05_JPRB, 0.17640365E-05_JPRB, 0.17639852E-05_JPRB, &
  & 0.17638853E-05_JPRB, 0.17636903E-05_JPRB, 0.17633311E-05_JPRB, 0.17627766E-05_JPRB, 0.17620257E-05_JPRB, 0.17611667E-05_JPRB, &
  & 0.17602749E-05_JPRB, 0.17594525E-05_JPRB, 0.17587535E-05_JPRB, 0.17582615E-05_JPRB, 0.17580628E-05_JPRB, 0.17581660E-05_JPRB, &
  & 0.17584850E-05_JPRB, 0.17589136E-05_JPRB, 0.17593690E-05_JPRB, 0.17597960E-05_JPRB, 0.17601378E-05_JPRB, 0.17603331E-05_JPRB, &
  & 0.17603197E-05_JPRB, 0.17600246E-05_JPRB, 0.17594091E-05_JPRB, 0.17585007E-05_JPRB, 0.17574191E-05_JPRB, 0.17563258E-05_JPRB, &
  & 0.17553662E-05_JPRB, 0.17546699E-05_JPRB, 0.17543341E-05_JPRB, 0.17543967E-05_JPRB, 0.17548592E-05_JPRB, 0.17556572E-05_JPRB, &
  & 0.17566649E-05_JPRB, 0.17577531E-05_JPRB, 0.17588296E-05_JPRB, 0.17598430E-05_JPRB, 0.17607770E-05_JPRB, 0.17616118E-05_JPRB, &
  & 0.17623158E-05_JPRB, 0.17628431E-05_JPRB, 0.17631681E-05_JPRB, 0.17633436E-05_JPRB, 0.17634427E-05_JPRB, 0.17635035E-05_JPRB, &
  & 0.17635449E-05_JPRB, 0.17635764E-05_JPRB, 0.17636005E-05_JPRB, 0.17636273E-05_JPRB, 0.17636521E-05_JPRB, 0.17636709E-05_JPRB, &
  & 0.17636829E-05_JPRB, 0.17636864E-05_JPRB, 0.17636758E-05_JPRB, 0.17636251E-05_JPRB /)

RGHG2(:,60, 5) = (/ &
  & 0.17639104E-05_JPRB, 0.17643060E-05_JPRB, 0.17645175E-05_JPRB, 0.17646878E-05_JPRB, 0.17648354E-05_JPRB, 0.17649127E-05_JPRB, &
  & 0.17649423E-05_JPRB, 0.17649483E-05_JPRB, 0.17649443E-05_JPRB, 0.17649329E-05_JPRB, 0.17649106E-05_JPRB, 0.17648686E-05_JPRB, &
  & 0.17647826E-05_JPRB, 0.17646059E-05_JPRB, 0.17642766E-05_JPRB, 0.17637217E-05_JPRB, 0.17629367E-05_JPRB, 0.17619748E-05_JPRB, &
  & 0.17609860E-05_JPRB, 0.17600577E-05_JPRB, 0.17592865E-05_JPRB, 0.17587490E-05_JPRB, 0.17585186E-05_JPRB, 0.17585988E-05_JPRB, &
  & 0.17589044E-05_JPRB, 0.17593325E-05_JPRB, 0.17597984E-05_JPRB, 0.17602374E-05_JPRB, 0.17605895E-05_JPRB, 0.17607894E-05_JPRB, &
  & 0.17607750E-05_JPRB, 0.17604712E-05_JPRB, 0.17598381E-05_JPRB, 0.17589060E-05_JPRB, 0.17578016E-05_JPRB, 0.17566969E-05_JPRB, &
  & 0.17557302E-05_JPRB, 0.17550376E-05_JPRB, 0.17547031E-05_JPRB, 0.17547684E-05_JPRB, 0.17552309E-05_JPRB, 0.17560315E-05_JPRB, &
  & 0.17570435E-05_JPRB, 0.17581440E-05_JPRB, 0.17592356E-05_JPRB, 0.17602653E-05_JPRB, 0.17612105E-05_JPRB, 0.17620519E-05_JPRB, &
  & 0.17627779E-05_JPRB, 0.17633280E-05_JPRB, 0.17636797E-05_JPRB, 0.17638688E-05_JPRB, 0.17639695E-05_JPRB, 0.17640258E-05_JPRB, &
  & 0.17640614E-05_JPRB, 0.17640825E-05_JPRB, 0.17640946E-05_JPRB, 0.17641134E-05_JPRB, 0.17641330E-05_JPRB, 0.17641485E-05_JPRB, &
  & 0.17641571E-05_JPRB, 0.17641564E-05_JPRB, 0.17641398E-05_JPRB, 0.17640722E-05_JPRB /)

RGHG2(:,61, 5) = (/ &
  & 0.17649907E-05_JPRB, 0.17653011E-05_JPRB, 0.17654595E-05_JPRB, 0.17655897E-05_JPRB, 0.17656921E-05_JPRB, 0.17657571E-05_JPRB, &
  & 0.17657829E-05_JPRB, 0.17657911E-05_JPRB, 0.17657909E-05_JPRB, 0.17657842E-05_JPRB, 0.17657690E-05_JPRB, 0.17657351E-05_JPRB, &
  & 0.17656623E-05_JPRB, 0.17655061E-05_JPRB, 0.17651911E-05_JPRB, 0.17646418E-05_JPRB, 0.17638117E-05_JPRB, 0.17627841E-05_JPRB, &
  & 0.17616990E-05_JPRB, 0.17606983E-05_JPRB, 0.17598659E-05_JPRB, 0.17592878E-05_JPRB, 0.17590299E-05_JPRB, 0.17590900E-05_JPRB, &
  & 0.17593864E-05_JPRB, 0.17598165E-05_JPRB, 0.17602924E-05_JPRB, 0.17607430E-05_JPRB, 0.17611034E-05_JPRB, 0.17613065E-05_JPRB, &
  & 0.17612883E-05_JPRB, 0.17609748E-05_JPRB, 0.17603242E-05_JPRB, 0.17593702E-05_JPRB, 0.17582458E-05_JPRB, 0.17571340E-05_JPRB, &
  & 0.17561690E-05_JPRB, 0.17554796E-05_JPRB, 0.17551472E-05_JPRB, 0.17552101E-05_JPRB, 0.17556661E-05_JPRB, 0.17564582E-05_JPRB, &
  & 0.17574682E-05_JPRB, 0.17585712E-05_JPRB, 0.17596717E-05_JPRB, 0.17607103E-05_JPRB, 0.17616624E-05_JPRB, 0.17625107E-05_JPRB, &
  & 0.17632368E-05_JPRB, 0.17638125E-05_JPRB, 0.17641867E-05_JPRB, 0.17643957E-05_JPRB, 0.17645004E-05_JPRB, 0.17645548E-05_JPRB, &
  & 0.17645807E-05_JPRB, 0.17645889E-05_JPRB, 0.17645843E-05_JPRB, 0.17645930E-05_JPRB, 0.17646075E-05_JPRB, 0.17646200E-05_JPRB, &
  & 0.17646249E-05_JPRB, 0.17646180E-05_JPRB, 0.17645880E-05_JPRB, 0.17644937E-05_JPRB /)

RGHG2(:,62, 5) = (/ &
  & 0.17659600E-05_JPRB, 0.17662073E-05_JPRB, 0.17663319E-05_JPRB, 0.17664330E-05_JPRB, 0.17665218E-05_JPRB, 0.17665799E-05_JPRB, &
  & 0.17666102E-05_JPRB, 0.17666237E-05_JPRB, 0.17666296E-05_JPRB, 0.17666298E-05_JPRB, 0.17666226E-05_JPRB, 0.17666000E-05_JPRB, &
  & 0.17665401E-05_JPRB, 0.17663961E-05_JPRB, 0.17660914E-05_JPRB, 0.17655327E-05_JPRB, 0.17646711E-05_JPRB, 0.17635857E-05_JPRB, &
  & 0.17624437E-05_JPRB, 0.17613820E-05_JPRB, 0.17605013E-05_JPRB, 0.17598887E-05_JPRB, 0.17596064E-05_JPRB, 0.17596499E-05_JPRB, &
  & 0.17599398E-05_JPRB, 0.17603752E-05_JPRB, 0.17608611E-05_JPRB, 0.17613226E-05_JPRB, 0.17616904E-05_JPRB, 0.17618963E-05_JPRB, &
  & 0.17618743E-05_JPRB, 0.17615505E-05_JPRB, 0.17608835E-05_JPRB, 0.17599100E-05_JPRB, 0.17587723E-05_JPRB, 0.17576567E-05_JPRB, &
  & 0.17566980E-05_JPRB, 0.17560144E-05_JPRB, 0.17556822E-05_JPRB, 0.17557379E-05_JPRB, 0.17561804E-05_JPRB, 0.17569570E-05_JPRB, &
  & 0.17579531E-05_JPRB, 0.17590506E-05_JPRB, 0.17601504E-05_JPRB, 0.17611920E-05_JPRB, 0.17621454E-05_JPRB, 0.17629935E-05_JPRB, &
  & 0.17637244E-05_JPRB, 0.17643030E-05_JPRB, 0.17647038E-05_JPRB, 0.17649327E-05_JPRB, 0.17650482E-05_JPRB, 0.17650995E-05_JPRB, &
  & 0.17651148E-05_JPRB, 0.17651043E-05_JPRB, 0.17650772E-05_JPRB, 0.17650752E-05_JPRB, 0.17650866E-05_JPRB, 0.17650977E-05_JPRB, &
  & 0.17650998E-05_JPRB, 0.17650847E-05_JPRB, 0.17650403E-05_JPRB, 0.17648957E-05_JPRB /)

RGHG2(:,63, 5) = (/ &
  & 0.17668356E-05_JPRB, 0.17670457E-05_JPRB, 0.17671550E-05_JPRB, 0.17672457E-05_JPRB, 0.17673271E-05_JPRB, 0.17673899E-05_JPRB, &
  & 0.17674267E-05_JPRB, 0.17674496E-05_JPRB, 0.17674637E-05_JPRB, 0.17674737E-05_JPRB, 0.17674777E-05_JPRB, 0.17674681E-05_JPRB, &
  & 0.17674229E-05_JPRB, 0.17672894E-05_JPRB, 0.17669819E-05_JPRB, 0.17664072E-05_JPRB, 0.17655199E-05_JPRB, 0.17644035E-05_JPRB, &
  & 0.17632237E-05_JPRB, 0.17621194E-05_JPRB, 0.17611994E-05_JPRB, 0.17605591E-05_JPRB, 0.17602583E-05_JPRB, 0.17602903E-05_JPRB, &
  & 0.17605785E-05_JPRB, 0.17610198E-05_JPRB, 0.17615168E-05_JPRB, 0.17619875E-05_JPRB, 0.17623610E-05_JPRB, 0.17625683E-05_JPRB, &
  & 0.17625438E-05_JPRB, 0.17622122E-05_JPRB, 0.17615314E-05_JPRB, 0.17605448E-05_JPRB, 0.17594009E-05_JPRB, 0.17582875E-05_JPRB, &
  & 0.17573392E-05_JPRB, 0.17566609E-05_JPRB, 0.17563275E-05_JPRB, 0.17563713E-05_JPRB, 0.17567935E-05_JPRB, 0.17575444E-05_JPRB, &
  & 0.17585178E-05_JPRB, 0.17595971E-05_JPRB, 0.17606878E-05_JPRB, 0.17617230E-05_JPRB, 0.17626714E-05_JPRB, 0.17635164E-05_JPRB, &
  & 0.17642444E-05_JPRB, 0.17648292E-05_JPRB, 0.17652414E-05_JPRB, 0.17654905E-05_JPRB, 0.17656191E-05_JPRB, 0.17656686E-05_JPRB, &
  & 0.17656715E-05_JPRB, 0.17656398E-05_JPRB, 0.17655827E-05_JPRB, 0.17655723E-05_JPRB, 0.17655836E-05_JPRB, 0.17655964E-05_JPRB, &
  & 0.17655963E-05_JPRB, 0.17655719E-05_JPRB, 0.17654994E-05_JPRB, 0.17652960E-05_JPRB /)

RGHG2(:,64, 5) = (/ &
  & 0.17676333E-05_JPRB, 0.17678336E-05_JPRB, 0.17679378E-05_JPRB, 0.17680263E-05_JPRB, 0.17681114E-05_JPRB, 0.17681811E-05_JPRB, &
  & 0.17682310E-05_JPRB, 0.17682637E-05_JPRB, 0.17682908E-05_JPRB, 0.17683129E-05_JPRB, 0.17683323E-05_JPRB, 0.17683396E-05_JPRB, &
  & 0.17683105E-05_JPRB, 0.17681814E-05_JPRB, 0.17678668E-05_JPRB, 0.17672685E-05_JPRB, 0.17663695E-05_JPRB, 0.17652424E-05_JPRB, &
  & 0.17640438E-05_JPRB, 0.17629092E-05_JPRB, 0.17619635E-05_JPRB, 0.17613036E-05_JPRB, 0.17609926E-05_JPRB, 0.17610189E-05_JPRB, &
  & 0.17613075E-05_JPRB, 0.17617567E-05_JPRB, 0.17622624E-05_JPRB, 0.17627399E-05_JPRB, 0.17631152E-05_JPRB, 0.17633216E-05_JPRB, &
  & 0.17632944E-05_JPRB, 0.17629584E-05_JPRB, 0.17622715E-05_JPRB, 0.17612792E-05_JPRB, 0.17601399E-05_JPRB, 0.17590376E-05_JPRB, &
  & 0.17581034E-05_JPRB, 0.17574313E-05_JPRB, 0.17570935E-05_JPRB, 0.17571223E-05_JPRB, 0.17575175E-05_JPRB, 0.17582347E-05_JPRB, &
  & 0.17591733E-05_JPRB, 0.17602237E-05_JPRB, 0.17612931E-05_JPRB, 0.17623131E-05_JPRB, 0.17632477E-05_JPRB, 0.17640843E-05_JPRB, &
  & 0.17648081E-05_JPRB, 0.17653927E-05_JPRB, 0.17658131E-05_JPRB, 0.17660768E-05_JPRB, 0.17662148E-05_JPRB, 0.17662665E-05_JPRB, &
  & 0.17662578E-05_JPRB, 0.17661996E-05_JPRB, 0.17661127E-05_JPRB, 0.17660932E-05_JPRB, 0.17661073E-05_JPRB, 0.17661239E-05_JPRB, &
  & 0.17661229E-05_JPRB, 0.17660852E-05_JPRB, 0.17659876E-05_JPRB, 0.17656863E-05_JPRB /)

RGHG2(:,65, 5) = (/ &
  & 0.17683606E-05_JPRB, 0.17685727E-05_JPRB, 0.17686841E-05_JPRB, 0.17687798E-05_JPRB, 0.17688726E-05_JPRB, 0.17689556E-05_JPRB, &
  & 0.17690172E-05_JPRB, 0.17690666E-05_JPRB, 0.17691057E-05_JPRB, 0.17691461E-05_JPRB, 0.17691839E-05_JPRB, 0.17692137E-05_JPRB, &
  & 0.17692016E-05_JPRB, 0.17690741E-05_JPRB, 0.17687373E-05_JPRB, 0.17681355E-05_JPRB, 0.17672282E-05_JPRB, 0.17661082E-05_JPRB, &
  & 0.17649030E-05_JPRB, 0.17637558E-05_JPRB, 0.17627937E-05_JPRB, 0.17621277E-05_JPRB, 0.17618129E-05_JPRB, 0.17618395E-05_JPRB, &
  & 0.17621319E-05_JPRB, 0.17625852E-05_JPRB, 0.17630955E-05_JPRB, 0.17635721E-05_JPRB, 0.17639434E-05_JPRB, 0.17641440E-05_JPRB, &
  & 0.17641131E-05_JPRB, 0.17637770E-05_JPRB, 0.17630923E-05_JPRB, 0.17621087E-05_JPRB, 0.17609834E-05_JPRB, 0.17599066E-05_JPRB, &
  & 0.17589915E-05_JPRB, 0.17583299E-05_JPRB, 0.17579882E-05_JPRB, 0.17579980E-05_JPRB, 0.17583610E-05_JPRB, 0.17590368E-05_JPRB, &
  & 0.17599313E-05_JPRB, 0.17609418E-05_JPRB, 0.17619789E-05_JPRB, 0.17629718E-05_JPRB, 0.17638849E-05_JPRB, 0.17647045E-05_JPRB, &
  & 0.17654207E-05_JPRB, 0.17660027E-05_JPRB, 0.17664258E-05_JPRB, 0.17666968E-05_JPRB, 0.17668435E-05_JPRB, 0.17668939E-05_JPRB, &
  & 0.17668737E-05_JPRB, 0.17667969E-05_JPRB, 0.17666755E-05_JPRB, 0.17666498E-05_JPRB, 0.17666678E-05_JPRB, 0.17666902E-05_JPRB, &
  & 0.17666883E-05_JPRB, 0.17666398E-05_JPRB, 0.17664976E-05_JPRB, 0.17661132E-05_JPRB /)

RGHG2(:,66, 5) = (/ &
  & 0.17690404E-05_JPRB, 0.17692762E-05_JPRB, 0.17694031E-05_JPRB, 0.17695102E-05_JPRB, 0.17696160E-05_JPRB, 0.17697128E-05_JPRB, &
  & 0.17697920E-05_JPRB, 0.17698542E-05_JPRB, 0.17699139E-05_JPRB, 0.17699704E-05_JPRB, 0.17700343E-05_JPRB, 0.17700860E-05_JPRB, &
  & 0.17700864E-05_JPRB, 0.17699480E-05_JPRB, 0.17696098E-05_JPRB, 0.17689968E-05_JPRB, 0.17681083E-05_JPRB, 0.17670009E-05_JPRB, &
  & 0.17658069E-05_JPRB, 0.17646585E-05_JPRB, 0.17636995E-05_JPRB, 0.17630329E-05_JPRB, 0.17627234E-05_JPRB, 0.17627542E-05_JPRB, &
  & 0.17630471E-05_JPRB, 0.17635007E-05_JPRB, 0.17640044E-05_JPRB, 0.17644720E-05_JPRB, 0.17648299E-05_JPRB, 0.17650193E-05_JPRB, &
  & 0.17649839E-05_JPRB, 0.17646512E-05_JPRB, 0.17639788E-05_JPRB, 0.17630150E-05_JPRB, 0.17619221E-05_JPRB, 0.17608786E-05_JPRB, &
  & 0.17599963E-05_JPRB, 0.17593503E-05_JPRB, 0.17590082E-05_JPRB, 0.17589988E-05_JPRB, 0.17593264E-05_JPRB, 0.17599548E-05_JPRB, &
  & 0.17607989E-05_JPRB, 0.17617572E-05_JPRB, 0.17627515E-05_JPRB, 0.17637082E-05_JPRB, 0.17645881E-05_JPRB, 0.17653867E-05_JPRB, &
  & 0.17660866E-05_JPRB, 0.17666632E-05_JPRB, 0.17670859E-05_JPRB, 0.17673598E-05_JPRB, 0.17675089E-05_JPRB, 0.17675574E-05_JPRB, &
  & 0.17675285E-05_JPRB, 0.17674307E-05_JPRB, 0.17672864E-05_JPRB, 0.17672522E-05_JPRB, 0.17672728E-05_JPRB, 0.17673008E-05_JPRB, &
  & 0.17672998E-05_JPRB, 0.17672378E-05_JPRB, 0.17670718E-05_JPRB, 0.17665807E-05_JPRB /)

RGHG2(:,67, 5) = (/ &
  & 0.17696810E-05_JPRB, 0.17699585E-05_JPRB, 0.17701022E-05_JPRB, 0.17702280E-05_JPRB, 0.17703502E-05_JPRB, 0.17704613E-05_JPRB, &
  & 0.17705574E-05_JPRB, 0.17706386E-05_JPRB, 0.17707141E-05_JPRB, 0.17707966E-05_JPRB, 0.17708809E-05_JPRB, 0.17709514E-05_JPRB, &
  & 0.17709519E-05_JPRB, 0.17708072E-05_JPRB, 0.17704631E-05_JPRB, 0.17698692E-05_JPRB, 0.17689999E-05_JPRB, 0.17679220E-05_JPRB, &
  & 0.17667513E-05_JPRB, 0.17656239E-05_JPRB, 0.17646763E-05_JPRB, 0.17640259E-05_JPRB, 0.17637249E-05_JPRB, 0.17637585E-05_JPRB, &
  & 0.17640493E-05_JPRB, 0.17644907E-05_JPRB, 0.17649785E-05_JPRB, 0.17654246E-05_JPRB, 0.17657624E-05_JPRB, 0.17659358E-05_JPRB, &
  & 0.17658946E-05_JPRB, 0.17655698E-05_JPRB, 0.17649177E-05_JPRB, 0.17639894E-05_JPRB, 0.17629376E-05_JPRB, 0.17619436E-05_JPRB, &
  & 0.17610993E-05_JPRB, 0.17604805E-05_JPRB, 0.17601424E-05_JPRB, 0.17601177E-05_JPRB, 0.17604107E-05_JPRB, 0.17609891E-05_JPRB, &
  & 0.17617751E-05_JPRB, 0.17626744E-05_JPRB, 0.17636146E-05_JPRB, 0.17645250E-05_JPRB, 0.17653679E-05_JPRB, 0.17661339E-05_JPRB, &
  & 0.17668161E-05_JPRB, 0.17673789E-05_JPRB, 0.17677969E-05_JPRB, 0.17680693E-05_JPRB, 0.17682181E-05_JPRB, 0.17682625E-05_JPRB, &
  & 0.17682244E-05_JPRB, 0.17681128E-05_JPRB, 0.17679464E-05_JPRB, 0.17679070E-05_JPRB, 0.17679300E-05_JPRB, 0.17679620E-05_JPRB, &
  & 0.17679620E-05_JPRB, 0.17678941E-05_JPRB, 0.17676892E-05_JPRB, 0.17671229E-05_JPRB /)

RGHG2(:,68, 5) = (/ &
  & 0.17702862E-05_JPRB, 0.17706134E-05_JPRB, 0.17707926E-05_JPRB, 0.17709395E-05_JPRB, 0.17710803E-05_JPRB, 0.17712157E-05_JPRB, &
  & 0.17713221E-05_JPRB, 0.17714253E-05_JPRB, 0.17715186E-05_JPRB, 0.17716201E-05_JPRB, 0.17717242E-05_JPRB, 0.17718004E-05_JPRB, &
  & 0.17717985E-05_JPRB, 0.17716525E-05_JPRB, 0.17713193E-05_JPRB, 0.17707393E-05_JPRB, 0.17699028E-05_JPRB, 0.17688669E-05_JPRB, &
  & 0.17677386E-05_JPRB, 0.17666466E-05_JPRB, 0.17657305E-05_JPRB, 0.17650991E-05_JPRB, 0.17648106E-05_JPRB, 0.17648447E-05_JPRB, &
  & 0.17651225E-05_JPRB, 0.17655436E-05_JPRB, 0.17660029E-05_JPRB, 0.17664202E-05_JPRB, 0.17667315E-05_JPRB, 0.17668868E-05_JPRB, &
  & 0.17668408E-05_JPRB, 0.17665275E-05_JPRB, 0.17659038E-05_JPRB, 0.17650176E-05_JPRB, 0.17640238E-05_JPRB, 0.17630824E-05_JPRB, &
  & 0.17622905E-05_JPRB, 0.17617037E-05_JPRB, 0.17613778E-05_JPRB, 0.17613418E-05_JPRB, 0.17616020E-05_JPRB, 0.17621309E-05_JPRB, &
  & 0.17628564E-05_JPRB, 0.17636903E-05_JPRB, 0.17645698E-05_JPRB, 0.17654286E-05_JPRB, 0.17662219E-05_JPRB, 0.17669554E-05_JPRB, &
  & 0.17676085E-05_JPRB, 0.17681555E-05_JPRB, 0.17685620E-05_JPRB, 0.17688290E-05_JPRB, 0.17689737E-05_JPRB, 0.17690128E-05_JPRB, &
  & 0.17689666E-05_JPRB, 0.17688427E-05_JPRB, 0.17686626E-05_JPRB, 0.17686190E-05_JPRB, 0.17686439E-05_JPRB, 0.17686804E-05_JPRB, &
  & 0.17686832E-05_JPRB, 0.17686107E-05_JPRB, 0.17683938E-05_JPRB, 0.17677519E-05_JPRB /)

RGHG2(:,69, 5) = (/ &
  & 0.17708517E-05_JPRB, 0.17712716E-05_JPRB, 0.17714830E-05_JPRB, 0.17716612E-05_JPRB, 0.17718278E-05_JPRB, 0.17719698E-05_JPRB, &
  & 0.17721050E-05_JPRB, 0.17722119E-05_JPRB, 0.17723312E-05_JPRB, 0.17724432E-05_JPRB, 0.17725579E-05_JPRB, 0.17726292E-05_JPRB, &
  & 0.17726154E-05_JPRB, 0.17724636E-05_JPRB, 0.17721482E-05_JPRB, 0.17716075E-05_JPRB, 0.17708177E-05_JPRB, 0.17698355E-05_JPRB, &
  & 0.17687664E-05_JPRB, 0.17677286E-05_JPRB, 0.17668547E-05_JPRB, 0.17662519E-05_JPRB, 0.17659721E-05_JPRB, 0.17659993E-05_JPRB, &
  & 0.17662579E-05_JPRB, 0.17666478E-05_JPRB, 0.17670724E-05_JPRB, 0.17674541E-05_JPRB, 0.17677355E-05_JPRB, 0.17678717E-05_JPRB, &
  & 0.17678223E-05_JPRB, 0.17675237E-05_JPRB, 0.17669348E-05_JPRB, 0.17661025E-05_JPRB, 0.17651709E-05_JPRB, 0.17642956E-05_JPRB, &
  & 0.17635572E-05_JPRB, 0.17630107E-05_JPRB, 0.17627026E-05_JPRB, 0.17626610E-05_JPRB, 0.17628927E-05_JPRB, 0.17633731E-05_JPRB, &
  & 0.17640389E-05_JPRB, 0.17648047E-05_JPRB, 0.17656187E-05_JPRB, 0.17664174E-05_JPRB, 0.17671614E-05_JPRB, 0.17678499E-05_JPRB, &
  & 0.17684739E-05_JPRB, 0.17689958E-05_JPRB, 0.17693859E-05_JPRB, 0.17696427E-05_JPRB, 0.17697801E-05_JPRB, 0.17698128E-05_JPRB, &
  & 0.17697597E-05_JPRB, 0.17696278E-05_JPRB, 0.17694390E-05_JPRB, 0.17693947E-05_JPRB, 0.17694226E-05_JPRB, 0.17694632E-05_JPRB, &
  & 0.17694711E-05_JPRB, 0.17694005E-05_JPRB, 0.17691655E-05_JPRB, 0.17684622E-05_JPRB /)

RGHG2(:,70, 5) = (/ &
  & 0.17714107E-05_JPRB, 0.17719242E-05_JPRB, 0.17721978E-05_JPRB, 0.17724062E-05_JPRB, 0.17725899E-05_JPRB, 0.17727557E-05_JPRB, &
  & 0.17728868E-05_JPRB, 0.17730225E-05_JPRB, 0.17731409E-05_JPRB, 0.17732689E-05_JPRB, 0.17733793E-05_JPRB, 0.17734458E-05_JPRB, &
  & 0.17734360E-05_JPRB, 0.17732982E-05_JPRB, 0.17729957E-05_JPRB, 0.17724774E-05_JPRB, 0.17717409E-05_JPRB, 0.17708285E-05_JPRB, &
  & 0.17698316E-05_JPRB, 0.17688626E-05_JPRB, 0.17680418E-05_JPRB, 0.17674698E-05_JPRB, 0.17671986E-05_JPRB, 0.17672132E-05_JPRB, &
  & 0.17674433E-05_JPRB, 0.17677963E-05_JPRB, 0.17681793E-05_JPRB, 0.17685212E-05_JPRB, 0.17687715E-05_JPRB, 0.17688892E-05_JPRB, &
  & 0.17688374E-05_JPRB, 0.17685575E-05_JPRB, 0.17680094E-05_JPRB, 0.17672362E-05_JPRB, 0.17663776E-05_JPRB, 0.17655708E-05_JPRB, &
  & 0.17648938E-05_JPRB, 0.17643923E-05_JPRB, 0.17641070E-05_JPRB, 0.17640655E-05_JPRB, 0.17642725E-05_JPRB, 0.17647086E-05_JPRB, &
  & 0.17653153E-05_JPRB, 0.17660124E-05_JPRB, 0.17667576E-05_JPRB, 0.17674935E-05_JPRB, 0.17681787E-05_JPRB, 0.17688219E-05_JPRB, &
  & 0.17694070E-05_JPRB, 0.17698998E-05_JPRB, 0.17702685E-05_JPRB, 0.17705108E-05_JPRB, 0.17706385E-05_JPRB, 0.17706645E-05_JPRB, &
  & 0.17706064E-05_JPRB, 0.17704713E-05_JPRB, 0.17702813E-05_JPRB, 0.17702394E-05_JPRB, 0.17702722E-05_JPRB, 0.17703187E-05_JPRB, &
  & 0.17703337E-05_JPRB, 0.17702710E-05_JPRB, 0.17700334E-05_JPRB, 0.17692759E-05_JPRB /)

RGHG2(:,71, 5) = (/ &
  & 0.17719710E-05_JPRB, 0.17726372E-05_JPRB, 0.17729475E-05_JPRB, 0.17731893E-05_JPRB, 0.17733882E-05_JPRB, 0.17735537E-05_JPRB, &
  & 0.17737011E-05_JPRB, 0.17738333E-05_JPRB, 0.17739670E-05_JPRB, 0.17740871E-05_JPRB, 0.17741946E-05_JPRB, 0.17742483E-05_JPRB, &
  & 0.17742186E-05_JPRB, 0.17740766E-05_JPRB, 0.17738075E-05_JPRB, 0.17733445E-05_JPRB, 0.17726701E-05_JPRB, 0.17718354E-05_JPRB, &
  & 0.17709260E-05_JPRB, 0.17700346E-05_JPRB, 0.17692779E-05_JPRB, 0.17687412E-05_JPRB, 0.17684766E-05_JPRB, 0.17684742E-05_JPRB, &
  & 0.17686714E-05_JPRB, 0.17689810E-05_JPRB, 0.17693187E-05_JPRB, 0.17696198E-05_JPRB, 0.17698379E-05_JPRB, 0.17699368E-05_JPRB, &
  & 0.17698840E-05_JPRB, 0.17696264E-05_JPRB, 0.17691236E-05_JPRB, 0.17684180E-05_JPRB, 0.17676350E-05_JPRB, 0.17669051E-05_JPRB, &
  & 0.17662917E-05_JPRB, 0.17658405E-05_JPRB, 0.17655839E-05_JPRB, 0.17655454E-05_JPRB, 0.17657325E-05_JPRB, 0.17661267E-05_JPRB, &
  & 0.17666756E-05_JPRB, 0.17673053E-05_JPRB, 0.17679769E-05_JPRB, 0.17686469E-05_JPRB, 0.17692698E-05_JPRB, 0.17698612E-05_JPRB, &
  & 0.17704034E-05_JPRB, 0.17708608E-05_JPRB, 0.17712032E-05_JPRB, 0.17714286E-05_JPRB, 0.17715452E-05_JPRB, 0.17715658E-05_JPRB, &
  & 0.17715065E-05_JPRB, 0.17713733E-05_JPRB, 0.17711923E-05_JPRB, 0.17711565E-05_JPRB, 0.17711952E-05_JPRB, 0.17712492E-05_JPRB, &
  & 0.17712753E-05_JPRB, 0.17712287E-05_JPRB, 0.17710117E-05_JPRB, 0.17702914E-05_JPRB /)

RGHG2(:,72, 5) = (/ &
  & 0.17726304E-05_JPRB, 0.17733820E-05_JPRB, 0.17737636E-05_JPRB, 0.17740123E-05_JPRB, 0.17742191E-05_JPRB, 0.17743826E-05_JPRB, &
  & 0.17745301E-05_JPRB, 0.17746682E-05_JPRB, 0.17747948E-05_JPRB, 0.17749137E-05_JPRB, 0.17750061E-05_JPRB, 0.17750514E-05_JPRB, &
  & 0.17750247E-05_JPRB, 0.17748901E-05_JPRB, 0.17746356E-05_JPRB, 0.17742055E-05_JPRB, 0.17736015E-05_JPRB, 0.17728530E-05_JPRB, &
  & 0.17720354E-05_JPRB, 0.17712356E-05_JPRB, 0.17705468E-05_JPRB, 0.17700520E-05_JPRB, 0.17697955E-05_JPRB, 0.17697743E-05_JPRB, &
  & 0.17699354E-05_JPRB, 0.17701990E-05_JPRB, 0.17704890E-05_JPRB, 0.17707457E-05_JPRB, 0.17709322E-05_JPRB, 0.17710128E-05_JPRB, &
  & 0.17709602E-05_JPRB, 0.17707268E-05_JPRB, 0.17702748E-05_JPRB, 0.17696379E-05_JPRB, 0.17689395E-05_JPRB, 0.17682886E-05_JPRB, &
  & 0.17677465E-05_JPRB, 0.17673472E-05_JPRB, 0.17671233E-05_JPRB, 0.17670924E-05_JPRB, 0.17672610E-05_JPRB, 0.17676148E-05_JPRB, &
  & 0.17681076E-05_JPRB, 0.17686648E-05_JPRB, 0.17692660E-05_JPRB, 0.17698624E-05_JPRB, 0.17704206E-05_JPRB, 0.17709546E-05_JPRB, &
  & 0.17714478E-05_JPRB, 0.17718658E-05_JPRB, 0.17721783E-05_JPRB, 0.17723859E-05_JPRB, 0.17724924E-05_JPRB, 0.17725094E-05_JPRB, &
  & 0.17724536E-05_JPRB, 0.17723315E-05_JPRB, 0.17721666E-05_JPRB, 0.17721414E-05_JPRB, 0.17721871E-05_JPRB, 0.17722473E-05_JPRB, &
  & 0.17722831E-05_JPRB, 0.17722532E-05_JPRB, 0.17720633E-05_JPRB, 0.17713755E-05_JPRB /)

RGHG2(:,73, 5) = (/ &
  & 0.17733722E-05_JPRB, 0.17742483E-05_JPRB, 0.17746145E-05_JPRB, 0.17748785E-05_JPRB, 0.17750706E-05_JPRB, 0.17752330E-05_JPRB, &
  & 0.17753736E-05_JPRB, 0.17755066E-05_JPRB, 0.17756321E-05_JPRB, 0.17757316E-05_JPRB, 0.17758156E-05_JPRB, 0.17758402E-05_JPRB, &
  & 0.17757864E-05_JPRB, 0.17756562E-05_JPRB, 0.17754387E-05_JPRB, 0.17750649E-05_JPRB, 0.17745250E-05_JPRB, 0.17738669E-05_JPRB, &
  & 0.17731503E-05_JPRB, 0.17724437E-05_JPRB, 0.17718339E-05_JPRB, 0.17713850E-05_JPRB, 0.17711400E-05_JPRB, 0.17711013E-05_JPRB, &
  & 0.17712263E-05_JPRB, 0.17714410E-05_JPRB, 0.17716836E-05_JPRB, 0.17718967E-05_JPRB, 0.17720505E-05_JPRB, 0.17721129E-05_JPRB, &
  & 0.17720616E-05_JPRB, 0.17718547E-05_JPRB, 0.17714565E-05_JPRB, 0.17708959E-05_JPRB, 0.17702824E-05_JPRB, 0.17697166E-05_JPRB, &
  & 0.17692457E-05_JPRB, 0.17689032E-05_JPRB, 0.17687131E-05_JPRB, 0.17686910E-05_JPRB, 0.17688433E-05_JPRB, 0.17691560E-05_JPRB, &
  & 0.17695888E-05_JPRB, 0.17700781E-05_JPRB, 0.17706000E-05_JPRB, 0.17711253E-05_JPRB, 0.17716135E-05_JPRB, 0.17720861E-05_JPRB, &
  & 0.17725274E-05_JPRB, 0.17728991E-05_JPRB, 0.17731817E-05_JPRB, 0.17733693E-05_JPRB, 0.17734661E-05_JPRB, 0.17734842E-05_JPRB, &
  & 0.17734366E-05_JPRB, 0.17733281E-05_JPRB, 0.17731913E-05_JPRB, 0.17731775E-05_JPRB, 0.17732261E-05_JPRB, 0.17732925E-05_JPRB, &
  & 0.17733341E-05_JPRB, 0.17733162E-05_JPRB, 0.17731433E-05_JPRB, 0.17725017E-05_JPRB /)

RGHG2(:,74, 5) = (/ &
  & 0.17742349E-05_JPRB, 0.17751065E-05_JPRB, 0.17755092E-05_JPRB, 0.17757427E-05_JPRB, 0.17759310E-05_JPRB, 0.17760744E-05_JPRB, &
  & 0.17762111E-05_JPRB, 0.17763359E-05_JPRB, 0.17764414E-05_JPRB, 0.17765401E-05_JPRB, 0.17765994E-05_JPRB, 0.17766198E-05_JPRB, &
  & 0.17765758E-05_JPRB, 0.17764544E-05_JPRB, 0.17762422E-05_JPRB, 0.17759039E-05_JPRB, 0.17754396E-05_JPRB, 0.17748722E-05_JPRB, &
  & 0.17742555E-05_JPRB, 0.17736512E-05_JPRB, 0.17731223E-05_JPRB, 0.17727249E-05_JPRB, 0.17724964E-05_JPRB, 0.17724444E-05_JPRB, &
  & 0.17725359E-05_JPRB, 0.17727032E-05_JPRB, 0.17728992E-05_JPRB, 0.17730670E-05_JPRB, 0.17731895E-05_JPRB, 0.17732351E-05_JPRB, &
  & 0.17731862E-05_JPRB, 0.17730072E-05_JPRB, 0.17726647E-05_JPRB, 0.17721812E-05_JPRB, 0.17716592E-05_JPRB, 0.17711784E-05_JPRB, &
  & 0.17707841E-05_JPRB, 0.17704987E-05_JPRB, 0.17703445E-05_JPRB, 0.17703304E-05_JPRB, 0.17704649E-05_JPRB, 0.17707348E-05_JPRB, &
  & 0.17711102E-05_JPRB, 0.17715240E-05_JPRB, 0.17719714E-05_JPRB, 0.17724194E-05_JPRB, 0.17728369E-05_JPRB, 0.17732457E-05_JPRB, &
  & 0.17736269E-05_JPRB, 0.17739530E-05_JPRB, 0.17741994E-05_JPRB, 0.17743691E-05_JPRB, 0.17744562E-05_JPRB, 0.17744767E-05_JPRB, &
  & 0.17744403E-05_JPRB, 0.17743534E-05_JPRB, 0.17742383E-05_JPRB, 0.17742375E-05_JPRB, 0.17742927E-05_JPRB, 0.17743564E-05_JPRB, &
  & 0.17744019E-05_JPRB, 0.17743913E-05_JPRB, 0.17742387E-05_JPRB, 0.17736221E-05_JPRB /)

RGHG2(:,75, 5) = (/ &
  & 0.17750987E-05_JPRB, 0.17760154E-05_JPRB, 0.17763747E-05_JPRB, 0.17765968E-05_JPRB, 0.17767568E-05_JPRB, 0.17768900E-05_JPRB, &
  & 0.17770099E-05_JPRB, 0.17771189E-05_JPRB, 0.17772202E-05_JPRB, 0.17772885E-05_JPRB, 0.17773409E-05_JPRB, 0.17773360E-05_JPRB, &
  & 0.17772531E-05_JPRB, 0.17771335E-05_JPRB, 0.17769951E-05_JPRB, 0.17767218E-05_JPRB, 0.17763321E-05_JPRB, 0.17758601E-05_JPRB, &
  & 0.17753489E-05_JPRB, 0.17748457E-05_JPRB, 0.17744023E-05_JPRB, 0.17740614E-05_JPRB, 0.17738556E-05_JPRB, 0.17737970E-05_JPRB, &
  & 0.17738594E-05_JPRB, 0.17739810E-05_JPRB, 0.17741335E-05_JPRB, 0.17742581E-05_JPRB, 0.17743504E-05_JPRB, 0.17743796E-05_JPRB, &
  & 0.17743338E-05_JPRB, 0.17741838E-05_JPRB, 0.17739013E-05_JPRB, 0.17734998E-05_JPRB, 0.17730698E-05_JPRB, 0.17726787E-05_JPRB, &
  & 0.17723582E-05_JPRB, 0.17721305E-05_JPRB, 0.17720120E-05_JPRB, 0.17720054E-05_JPRB, 0.17721202E-05_JPRB, 0.17723457E-05_JPRB, &
  & 0.17726583E-05_JPRB, 0.17730010E-05_JPRB, 0.17733693E-05_JPRB, 0.17737411E-05_JPRB, 0.17740875E-05_JPRB, 0.17744251E-05_JPRB, &
  & 0.17747481E-05_JPRB, 0.17750202E-05_JPRB, 0.17752327E-05_JPRB, 0.17753796E-05_JPRB, 0.17754567E-05_JPRB, 0.17754799E-05_JPRB, &
  & 0.17754551E-05_JPRB, 0.17753856E-05_JPRB, 0.17752969E-05_JPRB, 0.17753079E-05_JPRB, 0.17753600E-05_JPRB, 0.17754256E-05_JPRB, &
  & 0.17754691E-05_JPRB, 0.17754641E-05_JPRB, 0.17753199E-05_JPRB, 0.17747400E-05_JPRB /)

RGHG2(:,76, 5) = (/ &
  & 0.17760336E-05_JPRB, 0.17768839E-05_JPRB, 0.17772232E-05_JPRB, 0.17774029E-05_JPRB, 0.17775416E-05_JPRB, 0.17776472E-05_JPRB, &
  & 0.17777538E-05_JPRB, 0.17778476E-05_JPRB, 0.17779217E-05_JPRB, 0.17779869E-05_JPRB, 0.17780179E-05_JPRB, 0.17780170E-05_JPRB, &
  & 0.17779585E-05_JPRB, 0.17778759E-05_JPRB, 0.17777281E-05_JPRB, 0.17775042E-05_JPRB, 0.17771988E-05_JPRB, 0.17768248E-05_JPRB, &
  & 0.17764174E-05_JPRB, 0.17760202E-05_JPRB, 0.17756653E-05_JPRB, 0.17753857E-05_JPRB, 0.17752116E-05_JPRB, 0.17751535E-05_JPRB, &
  & 0.17751934E-05_JPRB, 0.17752737E-05_JPRB, 0.17753862E-05_JPRB, 0.17754688E-05_JPRB, 0.17755339E-05_JPRB, 0.17755497E-05_JPRB, &
  & 0.17755095E-05_JPRB, 0.17753905E-05_JPRB, 0.17751686E-05_JPRB, 0.17748489E-05_JPRB, 0.17745139E-05_JPRB, 0.17742126E-05_JPRB, &
  & 0.17739691E-05_JPRB, 0.17737974E-05_JPRB, 0.17737132E-05_JPRB, 0.17737127E-05_JPRB, 0.17738063E-05_JPRB, 0.17739842E-05_JPRB, &
  & 0.17742352E-05_JPRB, 0.17745033E-05_JPRB, 0.17747930E-05_JPRB, 0.17750907E-05_JPRB, 0.17753617E-05_JPRB, 0.17756297E-05_JPRB, &
  & 0.17758861E-05_JPRB, 0.17761042E-05_JPRB, 0.17762763E-05_JPRB, 0.17764016E-05_JPRB, 0.17764638E-05_JPRB, 0.17764889E-05_JPRB, &
  & 0.17764750E-05_JPRB, 0.17764257E-05_JPRB, 0.17763564E-05_JPRB, 0.17763745E-05_JPRB, 0.17764271E-05_JPRB, 0.17764823E-05_JPRB, &
  & 0.17765248E-05_JPRB, 0.17765223E-05_JPRB, 0.17763888E-05_JPRB, 0.17758322E-05_JPRB /)

RGHG2(:,77, 5) = (/ &
  & 0.17769712E-05_JPRB, 0.17777327E-05_JPRB, 0.17780181E-05_JPRB, 0.17781567E-05_JPRB, 0.17782605E-05_JPRB, 0.17783417E-05_JPRB, &
  & 0.17784243E-05_JPRB, 0.17784939E-05_JPRB, 0.17785544E-05_JPRB, 0.17785910E-05_JPRB, 0.17786090E-05_JPRB, 0.17785868E-05_JPRB, &
  & 0.17784955E-05_JPRB, 0.17784230E-05_JPRB, 0.17783797E-05_JPRB, 0.17782314E-05_JPRB, 0.17780137E-05_JPRB, 0.17777393E-05_JPRB, &
  & 0.17774394E-05_JPRB, 0.17771486E-05_JPRB, 0.17768857E-05_JPRB, 0.17766758E-05_JPRB, 0.17765419E-05_JPRB, 0.17764960E-05_JPRB, &
  & 0.17765215E-05_JPRB, 0.17765688E-05_JPRB, 0.17766459E-05_JPRB, 0.17766945E-05_JPRB, 0.17767360E-05_JPRB, 0.17767409E-05_JPRB, &
  & 0.17767084E-05_JPRB, 0.17766209E-05_JPRB, 0.17764635E-05_JPRB, 0.17762294E-05_JPRB, 0.17759905E-05_JPRB, 0.17757786E-05_JPRB, &
  & 0.17756070E-05_JPRB, 0.17754876E-05_JPRB, 0.17754350E-05_JPRB, 0.17754387E-05_JPRB, 0.17755095E-05_JPRB, 0.17756395E-05_JPRB, &
  & 0.17758255E-05_JPRB, 0.17760191E-05_JPRB, 0.17762306E-05_JPRB, 0.17764526E-05_JPRB, 0.17766530E-05_JPRB, 0.17768447E-05_JPRB, &
  & 0.17770355E-05_JPRB, 0.17771940E-05_JPRB, 0.17773249E-05_JPRB, 0.17774239E-05_JPRB, 0.17774688E-05_JPRB, 0.17774930E-05_JPRB, &
  & 0.17774876E-05_JPRB, 0.17774568E-05_JPRB, 0.17774087E-05_JPRB, 0.17774298E-05_JPRB, 0.17774693E-05_JPRB, 0.17775158E-05_JPRB, &
  & 0.17775492E-05_JPRB, 0.17775479E-05_JPRB, 0.17774228E-05_JPRB, 0.17769104E-05_JPRB /)

RGHG2(:,78, 5) = (/ &
  & 0.17779183E-05_JPRB, 0.17785019E-05_JPRB, 0.17787116E-05_JPRB, 0.17788025E-05_JPRB, 0.17788747E-05_JPRB, 0.17789233E-05_JPRB, &
  & 0.17789837E-05_JPRB, 0.17790285E-05_JPRB, 0.17790644E-05_JPRB, 0.17790881E-05_JPRB, 0.17790956E-05_JPRB, 0.17790790E-05_JPRB, &
  & 0.17790127E-05_JPRB, 0.17789737E-05_JPRB, 0.17789441E-05_JPRB, 0.17788536E-05_JPRB, 0.17787189E-05_JPRB, 0.17785387E-05_JPRB, &
  & 0.17783369E-05_JPRB, 0.17781495E-05_JPRB, 0.17779788E-05_JPRB, 0.17778415E-05_JPRB, 0.17777572E-05_JPRB, 0.17777347E-05_JPRB, &
  & 0.17777587E-05_JPRB, 0.17777892E-05_JPRB, 0.17778405E-05_JPRB, 0.17778663E-05_JPRB, 0.17778915E-05_JPRB, 0.17778920E-05_JPRB, &
  & 0.17778724E-05_JPRB, 0.17778168E-05_JPRB, 0.17777199E-05_JPRB, 0.17775654E-05_JPRB, 0.17774173E-05_JPRB, 0.17772888E-05_JPRB, &
  & 0.17771832E-05_JPRB, 0.17771074E-05_JPRB, 0.17770794E-05_JPRB, 0.17770839E-05_JPRB, 0.17771312E-05_JPRB, 0.17772134E-05_JPRB, &
  & 0.17773356E-05_JPRB, 0.17774572E-05_JPRB, 0.17775934E-05_JPRB, 0.17777461E-05_JPRB, 0.17778764E-05_JPRB, 0.17779953E-05_JPRB, &
  & 0.17781186E-05_JPRB, 0.17782179E-05_JPRB, 0.17783061E-05_JPRB, 0.17783779E-05_JPRB, 0.17784026E-05_JPRB, 0.17784229E-05_JPRB, &
  & 0.17784239E-05_JPRB, 0.17784095E-05_JPRB, 0.17783809E-05_JPRB, 0.17783955E-05_JPRB, 0.17784181E-05_JPRB, 0.17784450E-05_JPRB, &
  & 0.17784695E-05_JPRB, 0.17784673E-05_JPRB, 0.17783736E-05_JPRB, 0.17779631E-05_JPRB /)

RGHG2(:,79, 5) = (/ &
  & 0.17785314E-05_JPRB, 0.17789326E-05_JPRB, 0.17790836E-05_JPRB, 0.17791386E-05_JPRB, 0.17791933E-05_JPRB, 0.17792246E-05_JPRB, &
  & 0.17792727E-05_JPRB, 0.17793025E-05_JPRB, 0.17793291E-05_JPRB, 0.17793442E-05_JPRB, 0.17793484E-05_JPRB, 0.17793380E-05_JPRB, &
  & 0.17792788E-05_JPRB, 0.17792611E-05_JPRB, 0.17792358E-05_JPRB, 0.17791775E-05_JPRB, 0.17790882E-05_JPRB, 0.17789563E-05_JPRB, &
  & 0.17788066E-05_JPRB, 0.17786739E-05_JPRB, 0.17785525E-05_JPRB, 0.17784552E-05_JPRB, 0.17783989E-05_JPRB, 0.17783923E-05_JPRB, &
  & 0.17784195E-05_JPRB, 0.17784430E-05_JPRB, 0.17784830E-05_JPRB, 0.17784964E-05_JPRB, 0.17785140E-05_JPRB, 0.17785133E-05_JPRB, &
  & 0.17785019E-05_JPRB, 0.17784644E-05_JPRB, 0.17784014E-05_JPRB, 0.17782884E-05_JPRB, 0.17781892E-05_JPRB, 0.17781057E-05_JPRB, &
  & 0.17780335E-05_JPRB, 0.17779793E-05_JPRB, 0.17779612E-05_JPRB, 0.17779628E-05_JPRB, 0.17779950E-05_JPRB, 0.17780483E-05_JPRB, &
  & 0.17781356E-05_JPRB, 0.17782172E-05_JPRB, 0.17783124E-05_JPRB, 0.17784278E-05_JPRB, 0.17785200E-05_JPRB, 0.17785964E-05_JPRB, &
  & 0.17786836E-05_JPRB, 0.17787486E-05_JPRB, 0.17788141E-05_JPRB, 0.17788718E-05_JPRB, 0.17788825E-05_JPRB, 0.17789008E-05_JPRB, &
  & 0.17789039E-05_JPRB, 0.17788984E-05_JPRB, 0.17788793E-05_JPRB, 0.17788905E-05_JPRB, 0.17789012E-05_JPRB, 0.17789190E-05_JPRB, &
  & 0.17789389E-05_JPRB, 0.17789499E-05_JPRB, 0.17788947E-05_JPRB, 0.17786236E-05_JPRB /)

RGHG2(:,80, 5) = (/ &
  & 0.17789381E-05_JPRB, 0.17791402E-05_JPRB, 0.17792468E-05_JPRB, 0.17792846E-05_JPRB, 0.17793307E-05_JPRB, 0.17793532E-05_JPRB, &
  & 0.17793977E-05_JPRB, 0.17794212E-05_JPRB, 0.17794453E-05_JPRB, 0.17794576E-05_JPRB, 0.17794615E-05_JPRB, 0.17794542E-05_JPRB, &
  & 0.17793982E-05_JPRB, 0.17793903E-05_JPRB, 0.17793658E-05_JPRB, 0.17793226E-05_JPRB, 0.17792545E-05_JPRB, 0.17791448E-05_JPRB, &
  & 0.17790170E-05_JPRB, 0.17789101E-05_JPRB, 0.17788105E-05_JPRB, 0.17787298E-05_JPRB, 0.17786862E-05_JPRB, 0.17786875E-05_JPRB, &
  & 0.17787170E-05_JPRB, 0.17787384E-05_JPRB, 0.17787731E-05_JPRB, 0.17787813E-05_JPRB, 0.17787956E-05_JPRB, 0.17787950E-05_JPRB, &
  & 0.17787877E-05_JPRB, 0.17787590E-05_JPRB, 0.17787120E-05_JPRB, 0.17786177E-05_JPRB, 0.17785405E-05_JPRB, 0.17784772E-05_JPRB, &
  & 0.17784193E-05_JPRB, 0.17783730E-05_JPRB, 0.17783589E-05_JPRB, 0.17783575E-05_JPRB, 0.17783809E-05_JPRB, 0.17784205E-05_JPRB, &
  & 0.17784910E-05_JPRB, 0.17785542E-05_JPRB, 0.17786306E-05_JPRB, 0.17787297E-05_JPRB, 0.17788044E-05_JPRB, 0.17788602E-05_JPRB, &
  & 0.17789305E-05_JPRB, 0.17789798E-05_JPRB, 0.17790345E-05_JPRB, 0.17790860E-05_JPRB, 0.17790892E-05_JPRB, 0.17791058E-05_JPRB, &
  & 0.17791097E-05_JPRB, 0.17791082E-05_JPRB, 0.17790925E-05_JPRB, 0.17791011E-05_JPRB, 0.17791070E-05_JPRB, 0.17791198E-05_JPRB, &
  & 0.17791402E-05_JPRB, 0.17791591E-05_JPRB, 0.17791419E-05_JPRB, 0.17790504E-05_JPRB /)

RGHG2(:,81, 5) = (/ &
  & 0.17792159E-05_JPRB, 0.17792271E-05_JPRB, 0.17793164E-05_JPRB, 0.17793462E-05_JPRB, 0.17793898E-05_JPRB, 0.17794088E-05_JPRB, &
  & 0.17794508E-05_JPRB, 0.17794744E-05_JPRB, 0.17794951E-05_JPRB, 0.17795087E-05_JPRB, 0.17795120E-05_JPRB, 0.17795059E-05_JPRB, &
  & 0.17794514E-05_JPRB, 0.17794476E-05_JPRB, 0.17794227E-05_JPRB, 0.17793867E-05_JPRB, 0.17793292E-05_JPRB, 0.17792295E-05_JPRB, &
  & 0.17791108E-05_JPRB, 0.17790161E-05_JPRB, 0.17789255E-05_JPRB, 0.17788514E-05_JPRB, 0.17788127E-05_JPRB, 0.17788172E-05_JPRB, &
  & 0.17788484E-05_JPRB, 0.17788680E-05_JPRB, 0.17789012E-05_JPRB, 0.17789065E-05_JPRB, 0.17789196E-05_JPRB, 0.17789188E-05_JPRB, &
  & 0.17789137E-05_JPRB, 0.17788888E-05_JPRB, 0.17788491E-05_JPRB, 0.17787625E-05_JPRB, 0.17786953E-05_JPRB, 0.17786413E-05_JPRB, &
  & 0.17785893E-05_JPRB, 0.17785469E-05_JPRB, 0.17785337E-05_JPRB, 0.17785305E-05_JPRB, 0.17785500E-05_JPRB, 0.17785824E-05_JPRB, &
  & 0.17786451E-05_JPRB, 0.17787003E-05_JPRB, 0.17787683E-05_JPRB, 0.17788611E-05_JPRB, 0.17789282E-05_JPRB, 0.17789744E-05_JPRB, &
  & 0.17790371E-05_JPRB, 0.17790786E-05_JPRB, 0.17791290E-05_JPRB, 0.17791787E-05_JPRB, 0.17791776E-05_JPRB, 0.17791939E-05_JPRB, &
  & 0.17791979E-05_JPRB, 0.17791976E-05_JPRB, 0.17791832E-05_JPRB, 0.17791907E-05_JPRB, 0.17791939E-05_JPRB, 0.17792047E-05_JPRB, &
  & 0.17792245E-05_JPRB, 0.17792471E-05_JPRB, 0.17792446E-05_JPRB, 0.17793378E-05_JPRB /)

RGHG2(:,82, 5) = (/ &
  & 0.17792378E-05_JPRB, 0.17792557E-05_JPRB, 0.17793471E-05_JPRB, 0.17793753E-05_JPRB, 0.17794180E-05_JPRB, 0.17794343E-05_JPRB, &
  & 0.17794786E-05_JPRB, 0.17794964E-05_JPRB, 0.17795226E-05_JPRB, 0.17795323E-05_JPRB, 0.17795365E-05_JPRB, 0.17795318E-05_JPRB, &
  & 0.17794786E-05_JPRB, 0.17794767E-05_JPRB, 0.17794516E-05_JPRB, 0.17794187E-05_JPRB, 0.17793672E-05_JPRB, 0.17792714E-05_JPRB, &
  & 0.17791583E-05_JPRB, 0.17790685E-05_JPRB, 0.17789829E-05_JPRB, 0.17789110E-05_JPRB, 0.17788741E-05_JPRB, 0.17788808E-05_JPRB, &
  & 0.17789132E-05_JPRB, 0.17789317E-05_JPRB, 0.17789642E-05_JPRB, 0.17789675E-05_JPRB, 0.17789798E-05_JPRB, 0.17789790E-05_JPRB, &
  & 0.17789750E-05_JPRB, 0.17789522E-05_JPRB, 0.17789158E-05_JPRB, 0.17788329E-05_JPRB, 0.17787709E-05_JPRB, 0.17787208E-05_JPRB, &
  & 0.17786723E-05_JPRB, 0.17786317E-05_JPRB, 0.17786190E-05_JPRB, 0.17786156E-05_JPRB, 0.17786324E-05_JPRB, 0.17786617E-05_JPRB, &
  & 0.17787197E-05_JPRB, 0.17787709E-05_JPRB, 0.17788349E-05_JPRB, 0.17789249E-05_JPRB, 0.17789887E-05_JPRB, 0.17790297E-05_JPRB, &
  & 0.17790887E-05_JPRB, 0.17791265E-05_JPRB, 0.17791750E-05_JPRB, 0.17792237E-05_JPRB, 0.17792200E-05_JPRB, 0.17792361E-05_JPRB, &
  & 0.17792404E-05_JPRB, 0.17792411E-05_JPRB, 0.17792272E-05_JPRB, 0.17792340E-05_JPRB, 0.17792357E-05_JPRB, 0.17792451E-05_JPRB, &
  & 0.17792645E-05_JPRB, 0.17792860E-05_JPRB, 0.17792790E-05_JPRB, 0.17793608E-05_JPRB /)

RGHG2(:,83, 5) = (/ &
  & 0.17792529E-05_JPRB, 0.17792725E-05_JPRB, 0.17793645E-05_JPRB, 0.17793918E-05_JPRB, 0.17794342E-05_JPRB, 0.17794516E-05_JPRB, &
  & 0.17794902E-05_JPRB, 0.17795157E-05_JPRB, 0.17795327E-05_JPRB, 0.17795473E-05_JPRB, 0.17795496E-05_JPRB, 0.17795429E-05_JPRB, &
  & 0.17794964E-05_JPRB, 0.17794932E-05_JPRB, 0.17794673E-05_JPRB, 0.17794368E-05_JPRB, 0.17793883E-05_JPRB, 0.17792972E-05_JPRB, &
  & 0.17791840E-05_JPRB, 0.17790996E-05_JPRB, 0.17790151E-05_JPRB, 0.17789444E-05_JPRB, 0.17789077E-05_JPRB, 0.17789157E-05_JPRB, &
  & 0.17789498E-05_JPRB, 0.17789670E-05_JPRB, 0.17789995E-05_JPRB, 0.17790014E-05_JPRB, 0.17790134E-05_JPRB, 0.17790126E-05_JPRB, &
  & 0.17790090E-05_JPRB, 0.17789871E-05_JPRB, 0.17789530E-05_JPRB, 0.17788718E-05_JPRB, 0.17788122E-05_JPRB, 0.17787647E-05_JPRB, &
  & 0.17787180E-05_JPRB, 0.17786795E-05_JPRB, 0.17786674E-05_JPRB, 0.17786639E-05_JPRB, 0.17786792E-05_JPRB, 0.17787061E-05_JPRB, &
  & 0.17787601E-05_JPRB, 0.17788090E-05_JPRB, 0.17788707E-05_JPRB, 0.17789599E-05_JPRB, 0.17790226E-05_JPRB, 0.17790604E-05_JPRB, &
  & 0.17791175E-05_JPRB, 0.17791532E-05_JPRB, 0.17792005E-05_JPRB, 0.17792491E-05_JPRB, 0.17792438E-05_JPRB, 0.17792596E-05_JPRB, &
  & 0.17792638E-05_JPRB, 0.17792654E-05_JPRB, 0.17792519E-05_JPRB, 0.17792581E-05_JPRB, 0.17792590E-05_JPRB, 0.17792677E-05_JPRB, &
  & 0.17792863E-05_JPRB, 0.17793081E-05_JPRB, 0.17792992E-05_JPRB, 0.17793765E-05_JPRB /)

RGHG2(:,84, 5) = (/ &
  & 0.17792631E-05_JPRB, 0.17792829E-05_JPRB, 0.17793757E-05_JPRB, 0.17794021E-05_JPRB, 0.17794443E-05_JPRB, 0.17794588E-05_JPRB, &
  & 0.17795044E-05_JPRB, 0.17795197E-05_JPRB, 0.17795458E-05_JPRB, 0.17795535E-05_JPRB, 0.17795562E-05_JPRB, 0.17795508E-05_JPRB, &
  & 0.17795071E-05_JPRB, 0.17795016E-05_JPRB, 0.17794780E-05_JPRB, 0.17794483E-05_JPRB, 0.17794021E-05_JPRB, 0.17793124E-05_JPRB, &
  & 0.17792025E-05_JPRB, 0.17791180E-05_JPRB, 0.17790360E-05_JPRB, 0.17789649E-05_JPRB, 0.17789284E-05_JPRB, 0.17789375E-05_JPRB, &
  & 0.17789727E-05_JPRB, 0.17789889E-05_JPRB, 0.17790212E-05_JPRB, 0.17790227E-05_JPRB, 0.17790339E-05_JPRB, 0.17790326E-05_JPRB, &
  & 0.17790302E-05_JPRB, 0.17790085E-05_JPRB, 0.17789756E-05_JPRB, 0.17788954E-05_JPRB, 0.17788381E-05_JPRB, 0.17787913E-05_JPRB, &
  & 0.17787461E-05_JPRB, 0.17787102E-05_JPRB, 0.17786980E-05_JPRB, 0.17786954E-05_JPRB, 0.17787091E-05_JPRB, 0.17787343E-05_JPRB, &
  & 0.17787838E-05_JPRB, 0.17788316E-05_JPRB, 0.17788913E-05_JPRB, 0.17789808E-05_JPRB, 0.17790428E-05_JPRB, 0.17790796E-05_JPRB, &
  & 0.17791356E-05_JPRB, 0.17791696E-05_JPRB, 0.17792158E-05_JPRB, 0.17792647E-05_JPRB, 0.17792579E-05_JPRB, 0.17792739E-05_JPRB, &
  & 0.17792785E-05_JPRB, 0.17792804E-05_JPRB, 0.17792667E-05_JPRB, 0.17792731E-05_JPRB, 0.17792735E-05_JPRB, 0.17792813E-05_JPRB, &
  & 0.17793001E-05_JPRB, 0.17793218E-05_JPRB, 0.17793118E-05_JPRB, 0.17793872E-05_JPRB /)

RGHG2(:,85, 5) = (/ &
  & 0.17792695E-05_JPRB, 0.17792897E-05_JPRB, 0.17793830E-05_JPRB, 0.17794091E-05_JPRB, 0.17794514E-05_JPRB, 0.17794706E-05_JPRB, &
  & 0.17795059E-05_JPRB, 0.17795317E-05_JPRB, 0.17795458E-05_JPRB, 0.17795579E-05_JPRB, 0.17795585E-05_JPRB, 0.17795484E-05_JPRB, &
  & 0.17795187E-05_JPRB, 0.17795082E-05_JPRB, 0.17794841E-05_JPRB, 0.17794558E-05_JPRB, 0.17794111E-05_JPRB, 0.17793249E-05_JPRB, &
  & 0.17792145E-05_JPRB, 0.17791319E-05_JPRB, 0.17790484E-05_JPRB, 0.17789775E-05_JPRB, 0.17789414E-05_JPRB, 0.17789513E-05_JPRB, &
  & 0.17789874E-05_JPRB, 0.17790026E-05_JPRB, 0.17790358E-05_JPRB, 0.17790359E-05_JPRB, 0.17790471E-05_JPRB, 0.17790455E-05_JPRB, &
  & 0.17790436E-05_JPRB, 0.17790220E-05_JPRB, 0.17789899E-05_JPRB, 0.17789104E-05_JPRB, 0.17788541E-05_JPRB, 0.17788083E-05_JPRB, &
  & 0.17787645E-05_JPRB, 0.17787293E-05_JPRB, 0.17787179E-05_JPRB, 0.17787158E-05_JPRB, 0.17787290E-05_JPRB, 0.17787529E-05_JPRB, &
  & 0.17787991E-05_JPRB, 0.17788452E-05_JPRB, 0.17789051E-05_JPRB, 0.17789920E-05_JPRB, 0.17790557E-05_JPRB, 0.17790917E-05_JPRB, &
  & 0.17791469E-05_JPRB, 0.17791798E-05_JPRB, 0.17792264E-05_JPRB, 0.17792754E-05_JPRB, 0.17792676E-05_JPRB, 0.17792833E-05_JPRB, &
  & 0.17792878E-05_JPRB, 0.17792904E-05_JPRB, 0.17792767E-05_JPRB, 0.17792827E-05_JPRB, 0.17792826E-05_JPRB, 0.17792902E-05_JPRB, &
  & 0.17793086E-05_JPRB, 0.17793311E-05_JPRB, 0.17793201E-05_JPRB, 0.17793942E-05_JPRB /)

RGHG2(:,86, 5) = (/ &
  & 0.17792735E-05_JPRB, 0.17792945E-05_JPRB, 0.17793876E-05_JPRB, 0.17794130E-05_JPRB, 0.17794570E-05_JPRB, 0.17794723E-05_JPRB, &
  & 0.17795167E-05_JPRB, 0.17795312E-05_JPRB, 0.17795510E-05_JPRB, 0.17795567E-05_JPRB, 0.17795570E-05_JPRB, 0.17795512E-05_JPRB, &
  & 0.17795196E-05_JPRB, 0.17795096E-05_JPRB, 0.17794871E-05_JPRB, 0.17794590E-05_JPRB, 0.17794156E-05_JPRB, 0.17793352E-05_JPRB, &
  & 0.17792258E-05_JPRB, 0.17791417E-05_JPRB, 0.17790582E-05_JPRB, 0.17789861E-05_JPRB, 0.17789498E-05_JPRB, 0.17789600E-05_JPRB, &
  & 0.17789971E-05_JPRB, 0.17790118E-05_JPRB, 0.17790449E-05_JPRB, 0.17790444E-05_JPRB, 0.17790555E-05_JPRB, 0.17790537E-05_JPRB, &
  & 0.17790521E-05_JPRB, 0.17790310E-05_JPRB, 0.17789994E-05_JPRB, 0.17789200E-05_JPRB, 0.17788647E-05_JPRB, 0.17788200E-05_JPRB, &
  & 0.17787752E-05_JPRB, 0.17787411E-05_JPRB, 0.17787297E-05_JPRB, 0.17787277E-05_JPRB, 0.17787404E-05_JPRB, 0.17787636E-05_JPRB, &
  & 0.17788096E-05_JPRB, 0.17788550E-05_JPRB, 0.17789127E-05_JPRB, 0.17790016E-05_JPRB, 0.17790627E-05_JPRB, 0.17790998E-05_JPRB, &
  & 0.17791541E-05_JPRB, 0.17791863E-05_JPRB, 0.17792321E-05_JPRB, 0.17792815E-05_JPRB, 0.17792729E-05_JPRB, 0.17792887E-05_JPRB, &
  & 0.17792933E-05_JPRB, 0.17792964E-05_JPRB, 0.17792829E-05_JPRB, 0.17792889E-05_JPRB, 0.17792885E-05_JPRB, 0.17792958E-05_JPRB, &
  & 0.17793146E-05_JPRB, 0.17793373E-05_JPRB, 0.17793255E-05_JPRB, 0.17793988E-05_JPRB /)

RGHG2(:,87, 5) = (/ &
  & 0.17792763E-05_JPRB, 0.17792985E-05_JPRB, 0.17793897E-05_JPRB, 0.17794169E-05_JPRB, 0.17794592E-05_JPRB, 0.17794833E-05_JPRB, &
  & 0.17795146E-05_JPRB, 0.17795371E-05_JPRB, 0.17795480E-05_JPRB, 0.17795555E-05_JPRB, 0.17795546E-05_JPRB, 0.17795428E-05_JPRB, &
  & 0.17795255E-05_JPRB, 0.17795104E-05_JPRB, 0.17794895E-05_JPRB, 0.17794617E-05_JPRB, 0.17794198E-05_JPRB, 0.17793408E-05_JPRB, &
  & 0.17792362E-05_JPRB, 0.17791491E-05_JPRB, 0.17790647E-05_JPRB, 0.17789914E-05_JPRB, 0.17789547E-05_JPRB, 0.17789655E-05_JPRB, &
  & 0.17790029E-05_JPRB, 0.17790169E-05_JPRB, 0.17790508E-05_JPRB, 0.17790497E-05_JPRB, 0.17790608E-05_JPRB, 0.17790589E-05_JPRB, &
  & 0.17790577E-05_JPRB, 0.17790362E-05_JPRB, 0.17790057E-05_JPRB, 0.17789260E-05_JPRB, 0.17788725E-05_JPRB, 0.17788275E-05_JPRB, &
  & 0.17787837E-05_JPRB, 0.17787461E-05_JPRB, 0.17787353E-05_JPRB, 0.17787324E-05_JPRB, 0.17787453E-05_JPRB, 0.17787688E-05_JPRB, &
  & 0.17788163E-05_JPRB, 0.17788620E-05_JPRB, 0.17789216E-05_JPRB, 0.17790078E-05_JPRB, 0.17790696E-05_JPRB, 0.17791043E-05_JPRB, &
  & 0.17791581E-05_JPRB, 0.17791899E-05_JPRB, 0.17792354E-05_JPRB, 0.17792848E-05_JPRB, 0.17792767E-05_JPRB, 0.17792921E-05_JPRB, &
  & 0.17792967E-05_JPRB, 0.17793002E-05_JPRB, 0.17792870E-05_JPRB, 0.17792926E-05_JPRB, 0.17792917E-05_JPRB, 0.17792994E-05_JPRB, &
  & 0.17793179E-05_JPRB, 0.17793409E-05_JPRB, 0.17793285E-05_JPRB, 0.17794017E-05_JPRB /)

RGHG2(:,88, 5) = (/ &
  & 0.17792793E-05_JPRB, 0.17793050E-05_JPRB, 0.17793898E-05_JPRB, 0.17794172E-05_JPRB, 0.17794628E-05_JPRB, 0.17794803E-05_JPRB, &
  & 0.17795211E-05_JPRB, 0.17795353E-05_JPRB, 0.17795508E-05_JPRB, 0.17795544E-05_JPRB, 0.17795526E-05_JPRB, 0.17795468E-05_JPRB, &
  & 0.17795230E-05_JPRB, 0.17795123E-05_JPRB, 0.17794900E-05_JPRB, 0.17794629E-05_JPRB, 0.17794207E-05_JPRB, 0.17793466E-05_JPRB, &
  & 0.17792396E-05_JPRB, 0.17791539E-05_JPRB, 0.17790677E-05_JPRB, 0.17789946E-05_JPRB, 0.17789575E-05_JPRB, 0.17789685E-05_JPRB, &
  & 0.17790064E-05_JPRB, 0.17790202E-05_JPRB, 0.17790543E-05_JPRB, 0.17790526E-05_JPRB, 0.17790638E-05_JPRB, 0.17790617E-05_JPRB, &
  & 0.17790607E-05_JPRB, 0.17790394E-05_JPRB, 0.17790097E-05_JPRB, 0.17789299E-05_JPRB, 0.17788770E-05_JPRB, 0.17788335E-05_JPRB, &
  & 0.17787880E-05_JPRB, 0.17787490E-05_JPRB, 0.17787372E-05_JPRB, 0.17787324E-05_JPRB, 0.17787455E-05_JPRB, 0.17787688E-05_JPRB, &
  & 0.17788217E-05_JPRB, 0.17788677E-05_JPRB, 0.17789258E-05_JPRB, 0.17790163E-05_JPRB, 0.17790737E-05_JPRB, 0.17791082E-05_JPRB, &
  & 0.17791601E-05_JPRB, 0.17791921E-05_JPRB, 0.17792368E-05_JPRB, 0.17792862E-05_JPRB, 0.17792784E-05_JPRB, 0.17792939E-05_JPRB, &
  & 0.17792991E-05_JPRB, 0.17793026E-05_JPRB, 0.17792894E-05_JPRB, 0.17792951E-05_JPRB, 0.17792935E-05_JPRB, 0.17793014E-05_JPRB, &
  & 0.17793203E-05_JPRB, 0.17793433E-05_JPRB, 0.17793302E-05_JPRB, 0.17794035E-05_JPRB /)

RGHG2(:,89, 5) = (/ &
  & 0.17792840E-05_JPRB, 0.17793114E-05_JPRB, 0.17793877E-05_JPRB, 0.17794174E-05_JPRB, 0.17794611E-05_JPRB, 0.17794844E-05_JPRB, &
  & 0.17795173E-05_JPRB, 0.17795385E-05_JPRB, 0.17795498E-05_JPRB, 0.17795555E-05_JPRB, 0.17795539E-05_JPRB, 0.17795445E-05_JPRB, &
  & 0.17795287E-05_JPRB, 0.17795139E-05_JPRB, 0.17794932E-05_JPRB, 0.17794652E-05_JPRB, 0.17794239E-05_JPRB, 0.17793450E-05_JPRB, &
  & 0.17792395E-05_JPRB, 0.17791533E-05_JPRB, 0.17790691E-05_JPRB, 0.17789952E-05_JPRB, 0.17789586E-05_JPRB, 0.17789698E-05_JPRB, &
  & 0.17790085E-05_JPRB, 0.17790220E-05_JPRB, 0.17790563E-05_JPRB, 0.17790542E-05_JPRB, 0.17790657E-05_JPRB, 0.17790634E-05_JPRB, &
  & 0.17790628E-05_JPRB, 0.17790414E-05_JPRB, 0.17790125E-05_JPRB, 0.17789317E-05_JPRB, 0.17788797E-05_JPRB, 0.17788370E-05_JPRB, &
  & 0.17787918E-05_JPRB, 0.17787490E-05_JPRB, 0.17787378E-05_JPRB, 0.17787307E-05_JPRB, 0.17787446E-05_JPRB, 0.17787668E-05_JPRB, &
  & 0.17788266E-05_JPRB, 0.17788717E-05_JPRB, 0.17789308E-05_JPRB, 0.17790204E-05_JPRB, 0.17790774E-05_JPRB, 0.17791102E-05_JPRB, &
  & 0.17791615E-05_JPRB, 0.17791930E-05_JPRB, 0.17792374E-05_JPRB, 0.17792865E-05_JPRB, 0.17792788E-05_JPRB, 0.17792947E-05_JPRB, &
  & 0.17792999E-05_JPRB, 0.17793035E-05_JPRB, 0.17792905E-05_JPRB, 0.17792964E-05_JPRB, 0.17792943E-05_JPRB, 0.17793027E-05_JPRB, &
  & 0.17793215E-05_JPRB, 0.17793449E-05_JPRB, 0.17793309E-05_JPRB, 0.17794046E-05_JPRB /)

RGHG2(:,90, 5) = (/ &
  & 0.17792887E-05_JPRB, 0.17793187E-05_JPRB, 0.17793832E-05_JPRB, 0.17794150E-05_JPRB, 0.17794612E-05_JPRB, 0.17794761E-05_JPRB, &
  & 0.17795198E-05_JPRB, 0.17795371E-05_JPRB, 0.17795556E-05_JPRB, 0.17795608E-05_JPRB, 0.17795589E-05_JPRB, 0.17795535E-05_JPRB, &
  & 0.17795287E-05_JPRB, 0.17795180E-05_JPRB, 0.17794941E-05_JPRB, 0.17794671E-05_JPRB, 0.17794257E-05_JPRB, 0.17793457E-05_JPRB, &
  & 0.17792325E-05_JPRB, 0.17791518E-05_JPRB, 0.17790683E-05_JPRB, 0.17789946E-05_JPRB, 0.17789578E-05_JPRB, 0.17789699E-05_JPRB, &
  & 0.17790102E-05_JPRB, 0.17790225E-05_JPRB, 0.17790586E-05_JPRB, 0.17790544E-05_JPRB, 0.17790667E-05_JPRB, 0.17790642E-05_JPRB, &
  & 0.17790642E-05_JPRB, 0.17790428E-05_JPRB, 0.17790153E-05_JPRB, 0.17789313E-05_JPRB, 0.17788806E-05_JPRB, 0.17788386E-05_JPRB, &
  & 0.17787933E-05_JPRB, 0.17787487E-05_JPRB, 0.17787385E-05_JPRB, 0.17787290E-05_JPRB, 0.17787435E-05_JPRB, 0.17787636E-05_JPRB, &
  & 0.17788298E-05_JPRB, 0.17788727E-05_JPRB, 0.17789309E-05_JPRB, 0.17790238E-05_JPRB, 0.17790796E-05_JPRB, 0.17791119E-05_JPRB, &
  & 0.17791627E-05_JPRB, 0.17791936E-05_JPRB, 0.17792378E-05_JPRB, 0.17792889E-05_JPRB, 0.17792790E-05_JPRB, 0.17792951E-05_JPRB, &
  & 0.17793004E-05_JPRB, 0.17793045E-05_JPRB, 0.17792906E-05_JPRB, 0.17792972E-05_JPRB, 0.17792944E-05_JPRB, 0.17793029E-05_JPRB, &
  & 0.17793222E-05_JPRB, 0.17793467E-05_JPRB, 0.17793304E-05_JPRB, 0.17794059E-05_JPRB /)

RGHG2(:,91, 5) = (/ &
  & 0.17792906E-05_JPRB, 0.17793218E-05_JPRB, 0.17793736E-05_JPRB, 0.17794144E-05_JPRB, 0.17794634E-05_JPRB, 0.17794689E-05_JPRB, &
  & 0.17795167E-05_JPRB, 0.17795307E-05_JPRB, 0.17795609E-05_JPRB, 0.17795744E-05_JPRB, 0.17795797E-05_JPRB, 0.17795803E-05_JPRB, &
  & 0.17795036E-05_JPRB, 0.17795232E-05_JPRB, 0.17794903E-05_JPRB, 0.17794675E-05_JPRB, 0.17794313E-05_JPRB, 0.17793426E-05_JPRB, &
  & 0.17792232E-05_JPRB, 0.17791497E-05_JPRB, 0.17790668E-05_JPRB, 0.17789919E-05_JPRB, 0.17789544E-05_JPRB, 0.17789682E-05_JPRB, &
  & 0.17790125E-05_JPRB, 0.17790209E-05_JPRB, 0.17790614E-05_JPRB, 0.17790537E-05_JPRB, 0.17790680E-05_JPRB, 0.17790643E-05_JPRB, &
  & 0.17790662E-05_JPRB, 0.17790439E-05_JPRB, 0.17790204E-05_JPRB, 0.17789276E-05_JPRB, 0.17788797E-05_JPRB, 0.17788391E-05_JPRB, &
  & 0.17787937E-05_JPRB, 0.17787461E-05_JPRB, 0.17787386E-05_JPRB, 0.17787266E-05_JPRB, 0.17787432E-05_JPRB, 0.17787593E-05_JPRB, &
  & 0.17788325E-05_JPRB, 0.17788708E-05_JPRB, 0.17789296E-05_JPRB, 0.17790258E-05_JPRB, 0.17790826E-05_JPRB, 0.17791126E-05_JPRB, &
  & 0.17791639E-05_JPRB, 0.17791937E-05_JPRB, 0.17792372E-05_JPRB, 0.17792955E-05_JPRB, 0.17792770E-05_JPRB, 0.17792966E-05_JPRB, &
  & 0.17793010E-05_JPRB, 0.17793060E-05_JPRB, 0.17792895E-05_JPRB, 0.17792978E-05_JPRB, 0.17792936E-05_JPRB, 0.17793026E-05_JPRB, &
  & 0.17793226E-05_JPRB, 0.17793491E-05_JPRB, 0.17793288E-05_JPRB, 0.17794080E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART10',1,ZHOOK_HANDLE)
END SUBROUTINE PART10






SUBROUTINE PART11
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART11',0,ZHOOK_HANDLE)



!-- Month=  6 ------------

RGHG2(:, 1, 6) = (/ &
  & 0.12340961E-07_JPRB, 0.12411862E-07_JPRB, 0.12442436E-07_JPRB, 0.12471173E-07_JPRB, 0.12535978E-07_JPRB, 0.12706728E-07_JPRB, &
  & 0.12996763E-07_JPRB, 0.13402696E-07_JPRB, 0.13920107E-07_JPRB, 0.14541768E-07_JPRB, 0.15246121E-07_JPRB, 0.16013241E-07_JPRB, &
  & 0.16825698E-07_JPRB, 0.17658762E-07_JPRB, 0.18472788E-07_JPRB, 0.19215452E-07_JPRB, 0.19832058E-07_JPRB, 0.20277692E-07_JPRB, &
  & 0.20528070E-07_JPRB, 0.20586100E-07_JPRB, 0.20486274E-07_JPRB, 0.20294967E-07_JPRB, 0.20107894E-07_JPRB, 0.20041163E-07_JPRB, &
  & 0.20204192E-07_JPRB, 0.20646461E-07_JPRB, 0.21309980E-07_JPRB, 0.22058410E-07_JPRB, 0.22789253E-07_JPRB, 0.23386983E-07_JPRB, &
  & 0.23735598E-07_JPRB, 0.23781613E-07_JPRB, 0.23494977E-07_JPRB, 0.22851770E-07_JPRB, 0.21844714E-07_JPRB, 0.20521391E-07_JPRB, &
  & 0.18978820E-07_JPRB, 0.17337626E-07_JPRB, 0.15790679E-07_JPRB, 0.14617729E-07_JPRB, 0.13660548E-07_JPRB, 0.12786158E-07_JPRB, &
  & 0.11933420E-07_JPRB, 0.11044659E-07_JPRB, 0.10069872E-07_JPRB, 0.89312282E-08_JPRB, 0.75848368E-08_JPRB, 0.62140804E-08_JPRB, &
  & 0.52195448E-08_JPRB, 0.46751598E-08_JPRB, 0.43304693E-08_JPRB, 0.41066044E-08_JPRB, 0.39530610E-08_JPRB, 0.38258383E-08_JPRB, &
  & 0.36802421E-08_JPRB, 0.35145895E-08_JPRB, 0.33968985E-08_JPRB, 0.33678351E-08_JPRB, 0.33312348E-08_JPRB, 0.32795355E-08_JPRB, &
  & 0.32064158E-08_JPRB, 0.30758480E-08_JPRB, 0.28838418E-08_JPRB, 0.25443201E-08_JPRB /)

RGHG2(:, 2, 6) = (/ &
  & 0.13713372E-07_JPRB, 0.15049315E-07_JPRB, 0.15941854E-07_JPRB, 0.16753763E-07_JPRB, 0.17743359E-07_JPRB, 0.19159383E-07_JPRB, &
  & 0.21034808E-07_JPRB, 0.23284995E-07_JPRB, 0.25795629E-07_JPRB, 0.28481139E-07_JPRB, 0.31222950E-07_JPRB, 0.33818530E-07_JPRB, &
  & 0.36062151E-07_JPRB, 0.37863366E-07_JPRB, 0.39293003E-07_JPRB, 0.40494186E-07_JPRB, 0.41561840E-07_JPRB, 0.42501849E-07_JPRB, &
  & 0.43274419E-07_JPRB, 0.43849262E-07_JPRB, 0.44236138E-07_JPRB, 0.44494058E-07_JPRB, 0.44728257E-07_JPRB, 0.45078394E-07_JPRB, &
  & 0.45679112E-07_JPRB, 0.46613390E-07_JPRB, 0.47856854E-07_JPRB, 0.49298990E-07_JPRB, 0.50795482E-07_JPRB, 0.52174869E-07_JPRB, &
  & 0.53254613E-07_JPRB, 0.53799447E-07_JPRB, 0.53689796E-07_JPRB, 0.52925671E-07_JPRB, 0.51547808E-07_JPRB, 0.49609383E-07_JPRB, &
  & 0.47197965E-07_JPRB, 0.44453195E-07_JPRB, 0.41662879E-07_JPRB, 0.39123933E-07_JPRB, 0.36878056E-07_JPRB, 0.34794876E-07_JPRB, &
  & 0.32748357E-07_JPRB, 0.30616167E-07_JPRB, 0.28281471E-07_JPRB, 0.25638569E-07_JPRB, 0.22702050E-07_JPRB, 0.19785993E-07_JPRB, &
  & 0.17394120E-07_JPRB, 0.15787846E-07_JPRB, 0.14770331E-07_JPRB, 0.14148089E-07_JPRB, 0.13725161E-07_JPRB, 0.13322845E-07_JPRB, &
  & 0.12863225E-07_JPRB, 0.12310490E-07_JPRB, 0.11747397E-07_JPRB, 0.11208924E-07_JPRB, 0.10604785E-07_JPRB, 0.99150048E-08_JPRB, &
  & 0.91404155E-08_JPRB, 0.82786951E-08_JPRB, 0.73246027E-08_JPRB, 0.56333467E-08_JPRB /)

RGHG2(:, 3, 6) = (/ &
  & 0.16033106E-07_JPRB, 0.18446917E-07_JPRB, 0.19912527E-07_JPRB, 0.21267077E-07_JPRB, 0.22889141E-07_JPRB, 0.25065670E-07_JPRB, &
  & 0.27854059E-07_JPRB, 0.31028549E-07_JPRB, 0.34288831E-07_JPRB, 0.37415028E-07_JPRB, 0.40333777E-07_JPRB, 0.43287386E-07_JPRB, &
  & 0.46664400E-07_JPRB, 0.50657860E-07_JPRB, 0.55056887E-07_JPRB, 0.59402034E-07_JPRB, 0.63272751E-07_JPRB, 0.66430061E-07_JPRB, &
  & 0.68810500E-07_JPRB, 0.70461191E-07_JPRB, 0.71486625E-07_JPRB, 0.72027134E-07_JPRB, 0.72252170E-07_JPRB, 0.72348165E-07_JPRB, &
  & 0.72481392E-07_JPRB, 0.72748271E-07_JPRB, 0.73142409E-07_JPRB, 0.73575244E-07_JPRB, 0.73915999E-07_JPRB, 0.73997050E-07_JPRB, &
  & 0.73646063E-07_JPRB, 0.72793910E-07_JPRB, 0.71486035E-07_JPRB, 0.69829881E-07_JPRB, 0.67927530E-07_JPRB, 0.65839643E-07_JPRB, &
  & 0.63578781E-07_JPRB, 0.61193298E-07_JPRB, 0.58761870E-07_JPRB, 0.56437713E-07_JPRB, 0.54228359E-07_JPRB, 0.52095427E-07_JPRB, &
  & 0.49961201E-07_JPRB, 0.47733337E-07_JPRB, 0.45345995E-07_JPRB, 0.42758476E-07_JPRB, 0.40020701E-07_JPRB, 0.37303131E-07_JPRB, &
  & 0.34890640E-07_JPRB, 0.32857088E-07_JPRB, 0.31172682E-07_JPRB, 0.29708650E-07_JPRB, 0.28310561E-07_JPRB, 0.26875268E-07_JPRB, &
  & 0.25360400E-07_JPRB, 0.23819819E-07_JPRB, 0.22307344E-07_JPRB, 0.20828033E-07_JPRB, 0.19408073E-07_JPRB, 0.18089862E-07_JPRB, &
  & 0.16840088E-07_JPRB, 0.15584931E-07_JPRB, 0.14060836E-07_JPRB, 0.11651096E-07_JPRB /)

RGHG2(:, 4, 6) = (/ &
  & 0.18258936E-07_JPRB, 0.21466853E-07_JPRB, 0.23486205E-07_JPRB, 0.25391424E-07_JPRB, 0.27604628E-07_JPRB, 0.30440230E-07_JPRB, &
  & 0.33872269E-07_JPRB, 0.37672226E-07_JPRB, 0.41718355E-07_JPRB, 0.46138013E-07_JPRB, 0.51237560E-07_JPRB, 0.57042744E-07_JPRB, &
  & 0.63232847E-07_JPRB, 0.69306452E-07_JPRB, 0.74878663E-07_JPRB, 0.79762572E-07_JPRB, 0.83910855E-07_JPRB, 0.87310234E-07_JPRB, &
  & 0.89944372E-07_JPRB, 0.91822045E-07_JPRB, 0.92999436E-07_JPRB, 0.93569611E-07_JPRB, 0.93643678E-07_JPRB, 0.93337640E-07_JPRB, &
  & 0.92762527E-07_JPRB, 0.92008150E-07_JPRB, 0.91112142E-07_JPRB, 0.90041581E-07_JPRB, 0.88705363E-07_JPRB, 0.86994540E-07_JPRB, &
  & 0.84868994E-07_JPRB, 0.82402345E-07_JPRB, 0.79739408E-07_JPRB, 0.77057067E-07_JPRB, 0.74462335E-07_JPRB, 0.71981418E-07_JPRB, &
  & 0.69628690E-07_JPRB, 0.67344338E-07_JPRB, 0.65116161E-07_JPRB, 0.62918282E-07_JPRB, 0.60764833E-07_JPRB, 0.58647434E-07_JPRB, &
  & 0.56544366E-07_JPRB, 0.54458489E-07_JPRB, 0.52370456E-07_JPRB, 0.50278835E-07_JPRB, 0.48216819E-07_JPRB, 0.46239677E-07_JPRB, &
  & 0.44359876E-07_JPRB, 0.42635801E-07_JPRB, 0.40936712E-07_JPRB, 0.39278067E-07_JPRB, 0.37513313E-07_JPRB, 0.35581831E-07_JPRB, &
  & 0.33534214E-07_JPRB, 0.31415247E-07_JPRB, 0.29268479E-07_JPRB, 0.27323278E-07_JPRB, 0.25644431E-07_JPRB, 0.24122031E-07_JPRB, &
  & 0.22678291E-07_JPRB, 0.21253829E-07_JPRB, 0.19804519E-07_JPRB, 0.17606730E-07_JPRB /)

RGHG2(:, 5, 6) = (/ &
  & 0.20227308E-07_JPRB, 0.24010888E-07_JPRB, 0.26511293E-07_JPRB, 0.29021592E-07_JPRB, 0.31965765E-07_JPRB, 0.35588656E-07_JPRB, &
  & 0.39910606E-07_JPRB, 0.44865384E-07_JPRB, 0.50386198E-07_JPRB, 0.56558971E-07_JPRB, 0.63213811E-07_JPRB, 0.70129715E-07_JPRB, &
  & 0.77029185E-07_JPRB, 0.83652040E-07_JPRB, 0.89741249E-07_JPRB, 0.95071350E-07_JPRB, 0.99472032E-07_JPRB, 0.10288686E-06_JPRB, &
  & 0.10538068E-06_JPRB, 0.10707031E-06_JPRB, 0.10806768E-06_JPRB, 0.10846750E-06_JPRB, 0.10834641E-06_JPRB, 0.10775722E-06_JPRB, &
  & 0.10673286E-06_JPRB, 0.10530100E-06_JPRB, 0.10346692E-06_JPRB, 0.10123059E-06_JPRB, 0.98576095E-07_JPRB, 0.95496276E-07_JPRB, &
  & 0.92045049E-07_JPRB, 0.88346070E-07_JPRB, 0.84590063E-07_JPRB, 0.80978374E-07_JPRB, 0.77694835E-07_JPRB, 0.74806835E-07_JPRB, &
  & 0.72201090E-07_JPRB, 0.69802105E-07_JPRB, 0.67506988E-07_JPRB, 0.65273106E-07_JPRB, 0.63057698E-07_JPRB, 0.60854696E-07_JPRB, &
  & 0.58710398E-07_JPRB, 0.56625204E-07_JPRB, 0.54636562E-07_JPRB, 0.52749780E-07_JPRB, 0.50949996E-07_JPRB, 0.49232501E-07_JPRB, &
  & 0.47553126E-07_JPRB, 0.45910561E-07_JPRB, 0.44232319E-07_JPRB, 0.42501192E-07_JPRB, 0.40665032E-07_JPRB, 0.38700446E-07_JPRB, &
  & 0.36658875E-07_JPRB, 0.34426034E-07_JPRB, 0.32274620E-07_JPRB, 0.30394645E-07_JPRB, 0.28680894E-07_JPRB, 0.27114950E-07_JPRB, &
  & 0.25745585E-07_JPRB, 0.24521434E-07_JPRB, 0.23267763E-07_JPRB, 0.21291712E-07_JPRB /)

RGHG2(:, 6, 6) = (/ &
  & 0.22115502E-07_JPRB, 0.26208532E-07_JPRB, 0.29167705E-07_JPRB, 0.32352460E-07_JPRB, 0.36173304E-07_JPRB, 0.40781018E-07_JPRB, &
  & 0.46148418E-07_JPRB, 0.52174006E-07_JPRB, 0.58755411E-07_JPRB, 0.65741915E-07_JPRB, 0.73070773E-07_JPRB, 0.80521083E-07_JPRB, &
  & 0.87800288E-07_JPRB, 0.94577672E-07_JPRB, 0.10058393E-06_JPRB, 0.10562443E-06_JPRB, 0.10966656E-06_JPRB, 0.11276570E-06_JPRB, &
  & 0.11501370E-06_JPRB, 0.11654539E-06_JPRB, 0.11751196E-06_JPRB, 0.11800997E-06_JPRB, 0.11806567E-06_JPRB, 0.11766058E-06_JPRB, &
  & 0.11674782E-06_JPRB, 0.11527584E-06_JPRB, 0.11319669E-06_JPRB, 0.11048295E-06_JPRB, 0.10714091E-06_JPRB, 0.10323431E-06_JPRB, &
  & 0.98871894E-07_JPRB, 0.94252407E-07_JPRB, 0.89668639E-07_JPRB, 0.85442501E-07_JPRB, 0.81760120E-07_JPRB, 0.78606064E-07_JPRB, &
  & 0.75923623E-07_JPRB, 0.73547362E-07_JPRB, 0.71333858E-07_JPRB, 0.69148733E-07_JPRB, 0.66919519E-07_JPRB, 0.64641263E-07_JPRB, &
  & 0.62324091E-07_JPRB, 0.60037287E-07_JPRB, 0.57806545E-07_JPRB, 0.55650961E-07_JPRB, 0.53574659E-07_JPRB, 0.51548767E-07_JPRB, &
  & 0.49538215E-07_JPRB, 0.47546010E-07_JPRB, 0.45541292E-07_JPRB, 0.43506311E-07_JPRB, 0.41429388E-07_JPRB, 0.39306045E-07_JPRB, &
  & 0.37054221E-07_JPRB, 0.34800092E-07_JPRB, 0.32737585E-07_JPRB, 0.30834958E-07_JPRB, 0.29101368E-07_JPRB, 0.27609667E-07_JPRB, &
  & 0.26336547E-07_JPRB, 0.25238693E-07_JPRB, 0.24230653E-07_JPRB, 0.22927999E-07_JPRB /)

RGHG2(:, 7, 6) = (/ &
  & 0.23815822E-07_JPRB, 0.27817467E-07_JPRB, 0.31049641E-07_JPRB, 0.34806995E-07_JPRB, 0.39342162E-07_JPRB, 0.44615831E-07_JPRB, &
  & 0.50656013E-07_JPRB, 0.57241127E-07_JPRB, 0.64284855E-07_JPRB, 0.71668588E-07_JPRB, 0.79261447E-07_JPRB, 0.86838313E-07_JPRB, &
  & 0.94088357E-07_JPRB, 0.10070725E-06_JPRB, 0.10645188E-06_JPRB, 0.11124750E-06_JPRB, 0.11509391E-06_JPRB, 0.11808771E-06_JPRB, &
  & 0.12038331E-06_JPRB, 0.12209128E-06_JPRB, 0.12328658E-06_JPRB, 0.12408506E-06_JPRB, 0.12455786E-06_JPRB, 0.12467115E-06_JPRB, &
  & 0.12433244E-06_JPRB, 0.12343543E-06_JPRB, 0.12184425E-06_JPRB, 0.11941566E-06_JPRB, 0.11610351E-06_JPRB, 0.11197648E-06_JPRB, &
  & 0.10723647E-06_JPRB, 0.10223163E-06_JPRB, 0.97351275E-07_JPRB, 0.92964100E-07_JPRB, 0.89289216E-07_JPRB, 0.86370228E-07_JPRB, &
  & 0.84024919E-07_JPRB, 0.82042845E-07_JPRB, 0.80212565E-07_JPRB, 0.78370157E-07_JPRB, 0.76391260E-07_JPRB, 0.74196933E-07_JPRB, &
  & 0.71788833E-07_JPRB, 0.69176046E-07_JPRB, 0.66424732E-07_JPRB, 0.63581041E-07_JPRB, 0.60668398E-07_JPRB, 0.57680829E-07_JPRB, &
  & 0.54648375E-07_JPRB, 0.51593265E-07_JPRB, 0.48561180E-07_JPRB, 0.45588294E-07_JPRB, 0.42695696E-07_JPRB, 0.39898509E-07_JPRB, &
  & 0.37194571E-07_JPRB, 0.34699696E-07_JPRB, 0.32384175E-07_JPRB, 0.30364102E-07_JPRB, 0.28643340E-07_JPRB, 0.27205937E-07_JPRB, &
  & 0.26030687E-07_JPRB, 0.25072497E-07_JPRB, 0.24232268E-07_JPRB, 0.23195602E-07_JPRB /)

RGHG2(:, 8, 6) = (/ &
  & 0.24769692E-07_JPRB, 0.28221670E-07_JPRB, 0.31442688E-07_JPRB, 0.35312731E-07_JPRB, 0.39898410E-07_JPRB, 0.45349140E-07_JPRB, &
  & 0.51310053E-07_JPRB, 0.57995809E-07_JPRB, 0.65075625E-07_JPRB, 0.72465717E-07_JPRB, 0.80006984E-07_JPRB, 0.87463405E-07_JPRB, &
  & 0.94570169E-07_JPRB, 0.10105701E-06_JPRB, 0.10675898E-06_JPRB, 0.11155280E-06_JPRB, 0.11550008E-06_JPRB, 0.11870844E-06_JPRB, &
  & 0.12130917E-06_JPRB, 0.12351032E-06_JPRB, 0.12546866E-06_JPRB, 0.12716743E-06_JPRB, 0.12869046E-06_JPRB, 0.13009836E-06_JPRB, &
  & 0.13124452E-06_JPRB, 0.13193039E-06_JPRB, 0.13191530E-06_JPRB, 0.13095540E-06_JPRB, 0.12885550E-06_JPRB, 0.12551659E-06_JPRB, &
  & 0.12111413E-06_JPRB, 0.11617664E-06_JPRB, 0.11140207E-06_JPRB, 0.10731873E-06_JPRB, 0.10422392E-06_JPRB, 0.10209079E-06_JPRB, &
  & 0.10071393E-06_JPRB, 0.99779101E-07_JPRB, 0.98941790E-07_JPRB, 0.97875123E-07_JPRB, 0.96344159E-07_JPRB, 0.94224873E-07_JPRB, &
  & 0.91480999E-07_JPRB, 0.88180037E-07_JPRB, 0.84394564E-07_JPRB, 0.80208103E-07_JPRB, 0.75692441E-07_JPRB, 0.70919448E-07_JPRB, &
  & 0.65985304E-07_JPRB, 0.61000868E-07_JPRB, 0.56079884E-07_JPRB, 0.51330197E-07_JPRB, 0.46836991E-07_JPRB, 0.42684295E-07_JPRB, &
  & 0.38957364E-07_JPRB, 0.35678386E-07_JPRB, 0.32880568E-07_JPRB, 0.30661511E-07_JPRB, 0.28925617E-07_JPRB, 0.27584067E-07_JPRB, &
  & 0.26557824E-07_JPRB, 0.25759391E-07_JPRB, 0.25071785E-07_JPRB, 0.24181219E-07_JPRB /)

RGHG2(:, 9, 6) = (/ &
  & 0.25279519E-07_JPRB, 0.29053728E-07_JPRB, 0.32506122E-07_JPRB, 0.36239932E-07_JPRB, 0.40521982E-07_JPRB, 0.45110824E-07_JPRB, &
  & 0.50512092E-07_JPRB, 0.56310178E-07_JPRB, 0.62708644E-07_JPRB, 0.69393998E-07_JPRB, 0.76226790E-07_JPRB, 0.83014335E-07_JPRB, &
  & 0.89552515E-07_JPRB, 0.95668931E-07_JPRB, 0.10122646E-06_JPRB, 0.10618018E-06_JPRB, 0.11048488E-06_JPRB, 0.11425358E-06_JPRB, &
  & 0.11765000E-06_JPRB, 0.12078925E-06_JPRB, 0.12388455E-06_JPRB, 0.12726379E-06_JPRB, 0.13083807E-06_JPRB, 0.13451795E-06_JPRB, &
  & 0.13842600E-06_JPRB, 0.14220011E-06_JPRB, 0.14531102E-06_JPRB, 0.14730321E-06_JPRB, 0.14784170E-06_JPRB, 0.14685465E-06_JPRB, &
  & 0.14459984E-06_JPRB, 0.14158476E-06_JPRB, 0.13846406E-06_JPRB, 0.13586806E-06_JPRB, 0.13414960E-06_JPRB, 0.13336576E-06_JPRB, &
  & 0.13330147E-06_JPRB, 0.13357956E-06_JPRB, 0.13374299E-06_JPRB, 0.13334721E-06_JPRB, 0.13204851E-06_JPRB, 0.12964601E-06_JPRB, &
  & 0.12608430E-06_JPRB, 0.12139343E-06_JPRB, 0.11570167E-06_JPRB, 0.10916723E-06_JPRB, 0.10198706E-06_JPRB, 0.94341814E-07_JPRB, &
  & 0.86446782E-07_JPRB, 0.78487140E-07_JPRB, 0.70695464E-07_JPRB, 0.63290074E-07_JPRB, 0.56469911E-07_JPRB, 0.50370474E-07_JPRB, &
  & 0.45081411E-07_JPRB, 0.40643908E-07_JPRB, 0.37090089E-07_JPRB, 0.34470954E-07_JPRB, 0.32579397E-07_JPRB, 0.31257400E-07_JPRB, &
  & 0.30361377E-07_JPRB, 0.29760869E-07_JPRB, 0.29332465E-07_JPRB, 0.28854174E-07_JPRB /)

RGHG2(:,10, 6) = (/ &
  & 0.29592091E-07_JPRB, 0.36466815E-07_JPRB, 0.40704666E-07_JPRB, 0.44324800E-07_JPRB, 0.47655668E-07_JPRB, 0.51282946E-07_JPRB, &
  & 0.55025524E-07_JPRB, 0.59409494E-07_JPRB, 0.64127903E-07_JPRB, 0.69210294E-07_JPRB, 0.74446689E-07_JPRB, 0.79689897E-07_JPRB, &
  & 0.84855110E-07_JPRB, 0.89856769E-07_JPRB, 0.94655221E-07_JPRB, 0.99268753E-07_JPRB, 0.10372145E-06_JPRB, 0.10804452E-06_JPRB, &
  & 0.11240493E-06_JPRB, 0.11704949E-06_JPRB, 0.12222191E-06_JPRB, 0.12804773E-06_JPRB, 0.13488307E-06_JPRB, 0.14268943E-06_JPRB, &
  & 0.15055575E-06_JPRB, 0.15809971E-06_JPRB, 0.16502236E-06_JPRB, 0.17123881E-06_JPRB, 0.17660940E-06_JPRB, 0.18100755E-06_JPRB, &
  & 0.18430978E-06_JPRB, 0.18660411E-06_JPRB, 0.18823310E-06_JPRB, 0.18966705E-06_JPRB, 0.19120544E-06_JPRB, 0.19288019E-06_JPRB, &
  & 0.19446685E-06_JPRB, 0.19556789E-06_JPRB, 0.19573086E-06_JPRB, 0.19453806E-06_JPRB, 0.19172055E-06_JPRB, 0.18722777E-06_JPRB, &
  & 0.18104546E-06_JPRB, 0.17331811E-06_JPRB, 0.16422130E-06_JPRB, 0.15399615E-06_JPRB, 0.14286212E-06_JPRB, 0.13110822E-06_JPRB, &
  & 0.11901319E-06_JPRB, 0.10698676E-06_JPRB, 0.95409938E-07_JPRB, 0.84626642E-07_JPRB, 0.74855919E-07_JPRB, 0.66282411E-07_JPRB, &
  & 0.59021158E-07_JPRB, 0.53091515E-07_JPRB, 0.48531088E-07_JPRB, 0.45322846E-07_JPRB, 0.43149637E-07_JPRB, 0.41760025E-07_JPRB, &
  & 0.40953864E-07_JPRB, 0.40568253E-07_JPRB, 0.40594486E-07_JPRB, 0.41075836E-07_JPRB /)

RGHG2(:,11, 6) = (/ &
  & 0.42016008E-07_JPRB, 0.49957841E-07_JPRB, 0.53724598E-07_JPRB, 0.56519191E-07_JPRB, 0.59122364E-07_JPRB, 0.61674108E-07_JPRB, &
  & 0.64731687E-07_JPRB, 0.68193977E-07_JPRB, 0.72408646E-07_JPRB, 0.77232187E-07_JPRB, 0.82660677E-07_JPRB, 0.88575590E-07_JPRB, &
  & 0.94808051E-07_JPRB, 0.10116359E-06_JPRB, 0.10734889E-06_JPRB, 0.11311403E-06_JPRB, 0.11832249E-06_JPRB, 0.12306711E-06_JPRB, &
  & 0.12769162E-06_JPRB, 0.13265191E-06_JPRB, 0.13849825E-06_JPRB, 0.14571380E-06_JPRB, 0.15424283E-06_JPRB, 0.16363148E-06_JPRB, &
  & 0.17370054E-06_JPRB, 0.18416426E-06_JPRB, 0.19515153E-06_JPRB, 0.20647991E-06_JPRB, 0.21822288E-06_JPRB, 0.23051659E-06_JPRB, &
  & 0.24310165E-06_JPRB, 0.25540658E-06_JPRB, 0.26674945E-06_JPRB, 0.27646686E-06_JPRB, 0.28425816E-06_JPRB, 0.28991693E-06_JPRB, &
  & 0.29321936E-06_JPRB, 0.29397449E-06_JPRB, 0.29212006E-06_JPRB, 0.28766775E-06_JPRB, 0.28076602E-06_JPRB, 0.27169190E-06_JPRB, &
  & 0.26062679E-06_JPRB, 0.24782406E-06_JPRB, 0.23345181E-06_JPRB, 0.21774181E-06_JPRB, 0.20100563E-06_JPRB, 0.18365287E-06_JPRB, &
  & 0.16629457E-06_JPRB, 0.14942408E-06_JPRB, 0.13349874E-06_JPRB, 0.11882739E-06_JPRB, 0.10571091E-06_JPRB, 0.94364630E-07_JPRB, &
  & 0.84883233E-07_JPRB, 0.77265057E-07_JPRB, 0.71490916E-07_JPRB, 0.67505177E-07_JPRB, 0.64904732E-07_JPRB, 0.63370628E-07_JPRB, &
  & 0.62660838E-07_JPRB, 0.62615413E-07_JPRB, 0.63334731E-07_JPRB, 0.65506427E-07_JPRB /)

RGHG2(:,12, 6) = (/ &
  & 0.67792229E-07_JPRB, 0.78129872E-07_JPRB, 0.82995001E-07_JPRB, 0.86403986E-07_JPRB, 0.89279567E-07_JPRB, 0.92489678E-07_JPRB, &
  & 0.96344166E-07_JPRB, 0.10187642E-06_JPRB, 0.10929661E-06_JPRB, 0.11923332E-06_JPRB, 0.13164345E-06_JPRB, 0.14626231E-06_JPRB, &
  & 0.16236454E-06_JPRB, 0.17873404E-06_JPRB, 0.19390599E-06_JPRB, 0.20638130E-06_JPRB, 0.21498597E-06_JPRB, 0.21945611E-06_JPRB, &
  & 0.22028404E-06_JPRB, 0.21877608E-06_JPRB, 0.21672362E-06_JPRB, 0.21578198E-06_JPRB, 0.21699964E-06_JPRB, 0.22081977E-06_JPRB, &
  & 0.22704359E-06_JPRB, 0.23544035E-06_JPRB, 0.24601312E-06_JPRB, 0.25952463E-06_JPRB, 0.27638671E-06_JPRB, 0.29625303E-06_JPRB, &
  & 0.31904827E-06_JPRB, 0.34340275E-06_JPRB, 0.36656979E-06_JPRB, 0.38692247E-06_JPRB, 0.40328442E-06_JPRB, 0.41448911E-06_JPRB, &
  & 0.42017788E-06_JPRB, 0.42048902E-06_JPRB, 0.41589715E-06_JPRB, 0.40702034E-06_JPRB, 0.39459752E-06_JPRB, 0.37941084E-06_JPRB, &
  & 0.36198122E-06_JPRB, 0.34270928E-06_JPRB, 0.32194805E-06_JPRB, 0.30004432E-06_JPRB, 0.27742067E-06_JPRB, 0.25468691E-06_JPRB, &
  & 0.23230476E-06_JPRB, 0.21073259E-06_JPRB, 0.19040375E-06_JPRB, 0.17175468E-06_JPRB, 0.15512335E-06_JPRB, 0.14074341E-06_JPRB, &
  & 0.12869562E-06_JPRB, 0.11897332E-06_JPRB, 0.11157110E-06_JPRB, 0.10646383E-06_JPRB, 0.10318394E-06_JPRB, 0.10138479E-06_JPRB, &
  & 0.10081408E-06_JPRB, 0.10138036E-06_JPRB, 0.10347924E-06_JPRB, 0.10955385E-06_JPRB /)

RGHG2(:,13, 6) = (/ &
  & 0.12691828E-06_JPRB, 0.14165161E-06_JPRB, 0.14811827E-06_JPRB, 0.15239605E-06_JPRB, 0.15623014E-06_JPRB, 0.16055323E-06_JPRB, &
  & 0.16676447E-06_JPRB, 0.17561425E-06_JPRB, 0.18855678E-06_JPRB, 0.20587845E-06_JPRB, 0.22755600E-06_JPRB, 0.25255210E-06_JPRB, &
  & 0.27909698E-06_JPRB, 0.30506007E-06_JPRB, 0.32799286E-06_JPRB, 0.34576556E-06_JPRB, 0.35669433E-06_JPRB, 0.36031324E-06_JPRB, &
  & 0.35718728E-06_JPRB, 0.34887177E-06_JPRB, 0.33771343E-06_JPRB, 0.32644084E-06_JPRB, 0.31755908E-06_JPRB, 0.31217735E-06_JPRB, &
  & 0.31078926E-06_JPRB, 0.31369396E-06_JPRB, 0.32144800E-06_JPRB, 0.33433469E-06_JPRB, 0.35328839E-06_JPRB, 0.37919929E-06_JPRB, &
  & 0.41034988E-06_JPRB, 0.44371879E-06_JPRB, 0.47679390E-06_JPRB, 0.50608548E-06_JPRB, 0.52869098E-06_JPRB, 0.54449475E-06_JPRB, &
  & 0.55308880E-06_JPRB, 0.55428603E-06_JPRB, 0.54860641E-06_JPRB, 0.53705196E-06_JPRB, 0.52070561E-06_JPRB, 0.50069144E-06_JPRB, &
  & 0.47793793E-06_JPRB, 0.45312592E-06_JPRB, 0.42680290E-06_JPRB, 0.39952576E-06_JPRB, 0.37191572E-06_JPRB, 0.34451176E-06_JPRB, &
  & 0.31793945E-06_JPRB, 0.29281100E-06_JPRB, 0.26958486E-06_JPRB, 0.24851667E-06_JPRB, 0.22975570E-06_JPRB, 0.21341387E-06_JPRB, &
  & 0.19955101E-06_JPRB, 0.18820759E-06_JPRB, 0.17950600E-06_JPRB, 0.17356453E-06_JPRB, 0.16998759E-06_JPRB, 0.16850646E-06_JPRB, &
  & 0.16896341E-06_JPRB, 0.17150651E-06_JPRB, 0.17749288E-06_JPRB, 0.19275861E-06_JPRB /)

RGHG2(:,14, 6) = (/ &
  & 0.22719288E-06_JPRB, 0.23828237E-06_JPRB, 0.24312223E-06_JPRB, 0.24631481E-06_JPRB, 0.24958658E-06_JPRB, 0.25416657E-06_JPRB, &
  & 0.26113560E-06_JPRB, 0.27210629E-06_JPRB, 0.28794301E-06_JPRB, 0.30939151E-06_JPRB, 0.33583038E-06_JPRB, 0.36578660E-06_JPRB, &
  & 0.39687416E-06_JPRB, 0.42631993E-06_JPRB, 0.45155497E-06_JPRB, 0.47026347E-06_JPRB, 0.48089947E-06_JPRB, 0.48317639E-06_JPRB, &
  & 0.47810374E-06_JPRB, 0.46764401E-06_JPRB, 0.45437125E-06_JPRB, 0.44100130E-06_JPRB, 0.42951478E-06_JPRB, 0.42145925E-06_JPRB, &
  & 0.41740935E-06_JPRB, 0.41789522E-06_JPRB, 0.42367651E-06_JPRB, 0.43630888E-06_JPRB, 0.45670131E-06_JPRB, 0.48455757E-06_JPRB, &
  & 0.51802800E-06_JPRB, 0.55507030E-06_JPRB, 0.59137324E-06_JPRB, 0.62388756E-06_JPRB, 0.65153051E-06_JPRB, 0.67074194E-06_JPRB, &
  & 0.68086820E-06_JPRB, 0.68285999E-06_JPRB, 0.67754746E-06_JPRB, 0.66562080E-06_JPRB, 0.64809558E-06_JPRB, 0.62618159E-06_JPRB, &
  & 0.60082112E-06_JPRB, 0.57287315E-06_JPRB, 0.54316035E-06_JPRB, 0.51252033E-06_JPRB, 0.48173752E-06_JPRB, 0.45165393E-06_JPRB, &
  & 0.42315529E-06_JPRB, 0.39677306E-06_JPRB, 0.37273375E-06_JPRB, 0.35106231E-06_JPRB, 0.33175655E-06_JPRB, 0.31483481E-06_JPRB, &
  & 0.30035869E-06_JPRB, 0.28848177E-06_JPRB, 0.27948073E-06_JPRB, 0.27374671E-06_JPRB, 0.27099179E-06_JPRB, 0.27106850E-06_JPRB, &
  & 0.27403954E-06_JPRB, 0.28013849E-06_JPRB, 0.29246453E-06_JPRB, 0.31958845E-06_JPRB /)

RGHG2(:,15, 6) = (/ &
  & 0.35397477E-06_JPRB, 0.35513870E-06_JPRB, 0.35512511E-06_JPRB, 0.35522714E-06_JPRB, 0.35613968E-06_JPRB, 0.35897594E-06_JPRB, &
  & 0.36488029E-06_JPRB, 0.37519911E-06_JPRB, 0.39106348E-06_JPRB, 0.41286995E-06_JPRB, 0.44018648E-06_JPRB, 0.47110811E-06_JPRB, &
  & 0.50308034E-06_JPRB, 0.53310589E-06_JPRB, 0.55843020E-06_JPRB, 0.57735264E-06_JPRB, 0.58886474E-06_JPRB, 0.59304529E-06_JPRB, &
  & 0.59122976E-06_JPRB, 0.58525831E-06_JPRB, 0.57697156E-06_JPRB, 0.56831846E-06_JPRB, 0.56095490E-06_JPRB, 0.55595945E-06_JPRB, &
  & 0.55421270E-06_JPRB, 0.55652725E-06_JPRB, 0.56375285E-06_JPRB, 0.57660759E-06_JPRB, 0.59581436E-06_JPRB, 0.62159251E-06_JPRB, &
  & 0.65413224E-06_JPRB, 0.68848146E-06_JPRB, 0.72174225E-06_JPRB, 0.75084000E-06_JPRB, 0.77294806E-06_JPRB, 0.78934147E-06_JPRB, &
  & 0.79975456E-06_JPRB, 0.80263976E-06_JPRB, 0.79843051E-06_JPRB, 0.78802697E-06_JPRB, 0.77203481E-06_JPRB, 0.75118271E-06_JPRB, &
  & 0.72631462E-06_JPRB, 0.69829935E-06_JPRB, 0.66812123E-06_JPRB, 0.63675395E-06_JPRB, 0.60524701E-06_JPRB, 0.57480389E-06_JPRB, &
  & 0.54625662E-06_JPRB, 0.51998336E-06_JPRB, 0.49602630E-06_JPRB, 0.47437089E-06_JPRB, 0.45499965E-06_JPRB, 0.43795367E-06_JPRB, &
  & 0.42339872E-06_JPRB, 0.41160428E-06_JPRB, 0.40306270E-06_JPRB, 0.39833131E-06_JPRB, 0.39720430E-06_JPRB, 0.39960810E-06_JPRB, &
  & 0.40570467E-06_JPRB, 0.41553739E-06_JPRB, 0.43380547E-06_JPRB, 0.47007231E-06_JPRB /)

RGHG2(:,16, 6) = (/ &
  & 0.48695534E-06_JPRB, 0.48025970E-06_JPRB, 0.47460583E-06_JPRB, 0.47096850E-06_JPRB, 0.46859159E-06_JPRB, 0.46857704E-06_JPRB, &
  & 0.47182101E-06_JPRB, 0.47973037E-06_JPRB, 0.49336791E-06_JPRB, 0.51329141E-06_JPRB, 0.53907422E-06_JPRB, 0.56905992E-06_JPRB, &
  & 0.60070573E-06_JPRB, 0.63139584E-06_JPRB, 0.65840317E-06_JPRB, 0.67986758E-06_JPRB, 0.69564533E-06_JPRB, 0.70625845E-06_JPRB, &
  & 0.71258796E-06_JPRB, 0.71604114E-06_JPRB, 0.71804612E-06_JPRB, 0.71975569E-06_JPRB, 0.72212754E-06_JPRB, 0.72600233E-06_JPRB, &
  & 0.73198862E-06_JPRB, 0.74076229E-06_JPRB, 0.75277467E-06_JPRB, 0.76857981E-06_JPRB, 0.78786280E-06_JPRB, 0.80947530E-06_JPRB, &
  & 0.83054562E-06_JPRB, 0.85112401E-06_JPRB, 0.87003463E-06_JPRB, 0.88622949E-06_JPRB, 0.89931768E-06_JPRB, 0.90803860E-06_JPRB, &
  & 0.91215873E-06_JPRB, 0.91344901E-06_JPRB, 0.91083609E-06_JPRB, 0.90344673E-06_JPRB, 0.89109767E-06_JPRB, 0.87392760E-06_JPRB, &
  & 0.85229937E-06_JPRB, 0.82695828E-06_JPRB, 0.79879038E-06_JPRB, 0.76896379E-06_JPRB, 0.73890493E-06_JPRB, 0.70959294E-06_JPRB, &
  & 0.68171130E-06_JPRB, 0.65561085E-06_JPRB, 0.63153897E-06_JPRB, 0.60956813E-06_JPRB, 0.58977196E-06_JPRB, 0.57232995E-06_JPRB, &
  & 0.55755646E-06_JPRB, 0.54585792E-06_JPRB, 0.53781821E-06_JPRB, 0.53408485E-06_JPRB, 0.53445831E-06_JPRB, 0.53874504E-06_JPRB, &
  & 0.54700621E-06_JPRB, 0.55926773E-06_JPRB, 0.58034414E-06_JPRB, 0.62024486E-06_JPRB /)

RGHG2(:,17, 6) = (/ &
  & 0.61538555E-06_JPRB, 0.60236260E-06_JPRB, 0.59228648E-06_JPRB, 0.58549313E-06_JPRB, 0.58025353E-06_JPRB, 0.57735184E-06_JPRB, &
  & 0.57771297E-06_JPRB, 0.58262890E-06_JPRB, 0.59326868E-06_JPRB, 0.61028777E-06_JPRB, 0.63371544E-06_JPRB, 0.66204149E-06_JPRB, &
  & 0.69314052E-06_JPRB, 0.72469345E-06_JPRB, 0.75486099E-06_JPRB, 0.78180818E-06_JPRB, 0.80457562E-06_JPRB, 0.82370269E-06_JPRB, &
  & 0.84037470E-06_JPRB, 0.85555962E-06_JPRB, 0.87012967E-06_JPRB, 0.88486343E-06_JPRB, 0.90038401E-06_JPRB, 0.91720420E-06_JPRB, &
  & 0.93533833E-06_JPRB, 0.95445057E-06_JPRB, 0.97327143E-06_JPRB, 0.99050237E-06_JPRB, 0.10044378E-05_JPRB, 0.10151559E-05_JPRB, &
  & 0.10216884E-05_JPRB, 0.10246993E-05_JPRB, 0.10248498E-05_JPRB, 0.10233047E-05_JPRB, 0.10212641E-05_JPRB, 0.10200245E-05_JPRB, &
  & 0.10196360E-05_JPRB, 0.10184756E-05_JPRB, 0.10162548E-05_JPRB, 0.10119563E-05_JPRB, 0.10041767E-05_JPRB, 0.99206784E-06_JPRB, &
  & 0.97532359E-06_JPRB, 0.95430528E-06_JPRB, 0.92976700E-06_JPRB, 0.90305934E-06_JPRB, 0.87537649E-06_JPRB, 0.84758858E-06_JPRB, &
  & 0.82031693E-06_JPRB, 0.79414338E-06_JPRB, 0.76948942E-06_JPRB, 0.74666457E-06_JPRB, 0.72594690E-06_JPRB, 0.70773086E-06_JPRB, &
  & 0.69245255E-06_JPRB, 0.68057454E-06_JPRB, 0.67268724E-06_JPRB, 0.66938100E-06_JPRB, 0.67035103E-06_JPRB, 0.67529987E-06_JPRB, &
  & 0.68403335E-06_JPRB, 0.69685393E-06_JPRB, 0.71690800E-06_JPRB, 0.75557222E-06_JPRB /)

RGHG2(:,18, 6) = (/ &
  & 0.73166177E-06_JPRB, 0.71420544E-06_JPRB, 0.70237377E-06_JPRB, 0.69345236E-06_JPRB, 0.68636348E-06_JPRB, 0.68130942E-06_JPRB, &
  & 0.67929761E-06_JPRB, 0.68157050E-06_JPRB, 0.68928392E-06_JPRB, 0.70356776E-06_JPRB, 0.72440258E-06_JPRB, 0.75091572E-06_JPRB, &
  & 0.78146161E-06_JPRB, 0.81393688E-06_JPRB, 0.84642852E-06_JPRB, 0.87779910E-06_JPRB, 0.90729736E-06_JPRB, 0.93457982E-06_JPRB, &
  & 0.95999224E-06_JPRB, 0.98440114E-06_JPRB, 0.10086019E-05_JPRB, 0.10332659E-05_JPRB, 0.10588807E-05_JPRB, 0.10856413E-05_JPRB, &
  & 0.11128451E-05_JPRB, 0.11388427E-05_JPRB, 0.11618195E-05_JPRB, 0.11798263E-05_JPRB, 0.11910138E-05_JPRB, 0.11945892E-05_JPRB, &
  & 0.11907870E-05_JPRB, 0.11810992E-05_JPRB, 0.11671593E-05_JPRB, 0.11515326E-05_JPRB, 0.11365275E-05_JPRB, 0.11246264E-05_JPRB, &
  & 0.11171178E-05_JPRB, 0.11140793E-05_JPRB, 0.11131672E-05_JPRB, 0.11122461E-05_JPRB, 0.11090791E-05_JPRB, 0.11020154E-05_JPRB, &
  & 0.10903384E-05_JPRB, 0.10740399E-05_JPRB, 0.10538115E-05_JPRB, 0.10306621E-05_JPRB, 0.10055687E-05_JPRB, 0.97911004E-06_JPRB, &
  & 0.95233884E-06_JPRB, 0.92608724E-06_JPRB, 0.90089554E-06_JPRB, 0.87717456E-06_JPRB, 0.85545423E-06_JPRB, 0.83632966E-06_JPRB, &
  & 0.82033876E-06_JPRB, 0.80798696E-06_JPRB, 0.79975501E-06_JPRB, 0.79610248E-06_JPRB, 0.79663420E-06_JPRB, 0.80095043E-06_JPRB, &
  & 0.80874088E-06_JPRB, 0.82017607E-06_JPRB, 0.83699939E-06_JPRB, 0.87135430E-06_JPRB /)

RGHG2(:,19, 6) = (/ &
  & 0.83453369E-06_JPRB, 0.81503515E-06_JPRB, 0.80279290E-06_JPRB, 0.79318386E-06_JPRB, 0.78512301E-06_JPRB, 0.77883692E-06_JPRB, &
  & 0.77510686E-06_JPRB, 0.77520946E-06_JPRB, 0.78054893E-06_JPRB, 0.79228369E-06_JPRB, 0.81064348E-06_JPRB, 0.83495627E-06_JPRB, &
  & 0.86401809E-06_JPRB, 0.89641702E-06_JPRB, 0.93047601E-06_JPRB, 0.96455210E-06_JPRB, 0.99759120E-06_JPRB, 0.10291196E-05_JPRB, &
  & 0.10590902E-05_JPRB, 0.10879619E-05_JPRB, 0.11166643E-05_JPRB, 0.11460296E-05_JPRB, 0.11765214E-05_JPRB, 0.12081102E-05_JPRB, &
  & 0.12397491E-05_JPRB, 0.12695916E-05_JPRB, 0.12951615E-05_JPRB, 0.13138892E-05_JPRB, 0.13242770E-05_JPRB, 0.13256985E-05_JPRB, &
  & 0.13187744E-05_JPRB, 0.13045254E-05_JPRB, 0.12848152E-05_JPRB, 0.12626900E-05_JPRB, 0.12413265E-05_JPRB, 0.12235275E-05_JPRB, &
  & 0.12116425E-05_JPRB, 0.12057570E-05_JPRB, 0.12045977E-05_JPRB, 0.12052607E-05_JPRB, 0.12049651E-05_JPRB, 0.12015868E-05_JPRB, &
  & 0.11938088E-05_JPRB, 0.11813561E-05_JPRB, 0.11646658E-05_JPRB, 0.11444587E-05_JPRB, 0.11213515E-05_JPRB, 0.10963658E-05_JPRB, &
  & 0.10705846E-05_JPRB, 0.10448047E-05_JPRB, 0.10195106E-05_JPRB, 0.99532440E-06_JPRB, 0.97299119E-06_JPRB, 0.95319655E-06_JPRB, &
  & 0.93656882E-06_JPRB, 0.92361483E-06_JPRB, 0.91472259E-06_JPRB, 0.91018831E-06_JPRB, 0.90954751E-06_JPRB, 0.91234256E-06_JPRB, &
  & 0.91819163E-06_JPRB, 0.92710565E-06_JPRB, 0.94033413E-06_JPRB, 0.96828512E-06_JPRB /)

RGHG2(:,20, 6) = (/ &
  & 0.92497311E-06_JPRB, 0.90530477E-06_JPRB, 0.89366301E-06_JPRB, 0.88424423E-06_JPRB, 0.87611443E-06_JPRB, 0.86931487E-06_JPRB, &
  & 0.86462052E-06_JPRB, 0.86325628E-06_JPRB, 0.86681735E-06_JPRB, 0.87638813E-06_JPRB, 0.89233981E-06_JPRB, 0.91430860E-06_JPRB, &
  & 0.94132287E-06_JPRB, 0.97203883E-06_JPRB, 0.10051849E-05_JPRB, 0.10393525E-05_JPRB, 0.10731769E-05_JPRB, 0.11057355E-05_JPRB, &
  & 0.11369198E-05_JPRB, 0.11670691E-05_JPRB, 0.11968441E-05_JPRB, 0.12271619E-05_JPRB, 0.12586200E-05_JPRB, 0.12912523E-05_JPRB, &
  & 0.13241158E-05_JPRB, 0.13550655E-05_JPRB, 0.13816179E-05_JPRB, 0.14013593E-05_JPRB, 0.14129520E-05_JPRB, 0.14158860E-05_JPRB, &
  & 0.14105733E-05_JPRB, 0.13976286E-05_JPRB, 0.13786084E-05_JPRB, 0.13561393E-05_JPRB, 0.13334426E-05_JPRB, 0.13138898E-05_JPRB, &
  & 0.12999969E-05_JPRB, 0.12925510E-05_JPRB, 0.12904964E-05_JPRB, 0.12910634E-05_JPRB, 0.12914696E-05_JPRB, 0.12893684E-05_JPRB, &
  & 0.12834369E-05_JPRB, 0.12731698E-05_JPRB, 0.12585901E-05_JPRB, 0.12401201E-05_JPRB, 0.12186067E-05_JPRB, 0.11951377E-05_JPRB, &
  & 0.11705984E-05_JPRB, 0.11455722E-05_JPRB, 0.11206849E-05_JPRB, 0.10968315E-05_JPRB, 0.10746651E-05_JPRB, 0.10549169E-05_JPRB, &
  & 0.10381992E-05_JPRB, 0.10249610E-05_JPRB, 0.10154880E-05_JPRB, 0.10099701E-05_JPRB, 0.10079254E-05_JPRB, 0.10088869E-05_JPRB, &
  & 0.10124965E-05_JPRB, 0.10186828E-05_JPRB, 0.10284132E-05_JPRB, 0.10489738E-05_JPRB /)

RGHG2(:,21, 6) = (/ &
  & 0.10054113E-05_JPRB, 0.98663190E-06_JPRB, 0.97589168E-06_JPRB, 0.96713813E-06_JPRB, 0.95943346E-06_JPRB, 0.95275556E-06_JPRB, &
  & 0.94773452E-06_JPRB, 0.94574023E-06_JPRB, 0.94815653E-06_JPRB, 0.95601479E-06_JPRB, 0.96978886E-06_JPRB, 0.98930320E-06_JPRB, &
  & 0.10137812E-05_JPRB, 0.10421822E-05_JPRB, 0.10731651E-05_JPRB, 0.11054170E-05_JPRB, 0.11377747E-05_JPRB, 0.11693307E-05_JPRB, &
  & 0.11996191E-05_JPRB, 0.12289462E-05_JPRB, 0.12579358E-05_JPRB, 0.12873572E-05_JPRB, 0.13179143E-05_JPRB, 0.13497212E-05_JPRB, &
  & 0.13817572E-05_JPRB, 0.14124195E-05_JPRB, 0.14391024E-05_JPRB, 0.14596175E-05_JPRB, 0.14729296E-05_JPRB, 0.14786907E-05_JPRB, &
  & 0.14769528E-05_JPRB, 0.14681359E-05_JPRB, 0.14534282E-05_JPRB, 0.14346505E-05_JPRB, 0.14147870E-05_JPRB, 0.13967128E-05_JPRB, &
  & 0.13830099E-05_JPRB, 0.13748112E-05_JPRB, 0.13709250E-05_JPRB, 0.13699270E-05_JPRB, 0.13689501E-05_JPRB, 0.13660417E-05_JPRB, &
  & 0.13596995E-05_JPRB, 0.13494451E-05_JPRB, 0.13353190E-05_JPRB, 0.13178044E-05_JPRB, 0.12976470E-05_JPRB, 0.12756135E-05_JPRB, &
  & 0.12522261E-05_JPRB, 0.12281686E-05_JPRB, 0.12044093E-05_JPRB, 0.11815187E-05_JPRB, 0.11602314E-05_JPRB, 0.11412749E-05_JPRB, &
  & 0.11251137E-05_JPRB, 0.11120338E-05_JPRB, 0.11022347E-05_JPRB, 0.10958520E-05_JPRB, 0.10924758E-05_JPRB, 0.10916850E-05_JPRB, &
  & 0.10931201E-05_JPRB, 0.10966647E-05_JPRB, 0.11029039E-05_JPRB, 0.11171438E-05_JPRB /)

RGHG2(:,22, 6) = (/ &
  & 0.10763229E-05_JPRB, 0.10594817E-05_JPRB, 0.10499338E-05_JPRB, 0.10421692E-05_JPRB, 0.10352732E-05_JPRB, 0.10292067E-05_JPRB, &
  & 0.10246451E-05_JPRB, 0.10227004E-05_JPRB, 0.10246946E-05_JPRB, 0.10316264E-05_JPRB, 0.10439342E-05_JPRB, 0.10614633E-05_JPRB, &
  & 0.10836109E-05_JPRB, 0.11093723E-05_JPRB, 0.11376878E-05_JPRB, 0.11673367E-05_JPRB, 0.11971799E-05_JPRB, 0.12264372E-05_JPRB, &
  & 0.12548462E-05_JPRB, 0.12824728E-05_JPRB, 0.13098584E-05_JPRB, 0.13376517E-05_JPRB, 0.13662770E-05_JPRB, 0.13958216E-05_JPRB, &
  & 0.14257820E-05_JPRB, 0.14544659E-05_JPRB, 0.14800491E-05_JPRB, 0.15009399E-05_JPRB, 0.15157752E-05_JPRB, 0.15241914E-05_JPRB, &
  & 0.15262572E-05_JPRB, 0.15222769E-05_JPRB, 0.15130363E-05_JPRB, 0.14999464E-05_JPRB, 0.14850550E-05_JPRB, 0.14708884E-05_JPRB, &
  & 0.14588693E-05_JPRB, 0.14503908E-05_JPRB, 0.14450590E-05_JPRB, 0.14414194E-05_JPRB, 0.14377473E-05_JPRB, 0.14325502E-05_JPRB, &
  & 0.14246921E-05_JPRB, 0.14135030E-05_JPRB, 0.13990187E-05_JPRB, 0.13816930E-05_JPRB, 0.13621027E-05_JPRB, 0.13407017E-05_JPRB, &
  & 0.13182239E-05_JPRB, 0.12955427E-05_JPRB, 0.12731288E-05_JPRB, 0.12516297E-05_JPRB, 0.12318148E-05_JPRB, 0.12141510E-05_JPRB, &
  & 0.11989292E-05_JPRB, 0.11862985E-05_JPRB, 0.11763711E-05_JPRB, 0.11692703E-05_JPRB, 0.11647188E-05_JPRB, 0.11624010E-05_JPRB, &
  & 0.11620193E-05_JPRB, 0.11634078E-05_JPRB, 0.11668698E-05_JPRB, 0.11756669E-05_JPRB /)

RGHG2(:,23, 6) = (/ &
  & 0.11390823E-05_JPRB, 0.11243424E-05_JPRB, 0.11162307E-05_JPRB, 0.11096627E-05_JPRB, 0.11039186E-05_JPRB, 0.10989726E-05_JPRB, &
  & 0.10953677E-05_JPRB, 0.10941850E-05_JPRB, 0.10965734E-05_JPRB, 0.11034106E-05_JPRB, 0.11150889E-05_JPRB, 0.11314787E-05_JPRB, &
  & 0.11519760E-05_JPRB, 0.11757018E-05_JPRB, 0.12015948E-05_JPRB, 0.12286202E-05_JPRB, 0.12558729E-05_JPRB, 0.12826798E-05_JPRB, &
  & 0.13087243E-05_JPRB, 0.13342179E-05_JPRB, 0.13593821E-05_JPRB, 0.13845628E-05_JPRB, 0.14103277E-05_JPRB, 0.14368034E-05_JPRB, &
  & 0.14634578E-05_JPRB, 0.14894235E-05_JPRB, 0.15130254E-05_JPRB, 0.15327457E-05_JPRB, 0.15480961E-05_JPRB, 0.15584999E-05_JPRB, &
  & 0.15637695E-05_JPRB, 0.15641191E-05_JPRB, 0.15600804E-05_JPRB, 0.15526925E-05_JPRB, 0.15431096E-05_JPRB, 0.15333505E-05_JPRB, &
  & 0.15240381E-05_JPRB, 0.15160826E-05_JPRB, 0.15093864E-05_JPRB, 0.15031544E-05_JPRB, 0.14965051E-05_JPRB, 0.14884113E-05_JPRB, &
  & 0.14782312E-05_JPRB, 0.14656375E-05_JPRB, 0.14504924E-05_JPRB, 0.14329352E-05_JPRB, 0.14133269E-05_JPRB, 0.13924459E-05_JPRB, &
  & 0.13711166E-05_JPRB, 0.13497943E-05_JPRB, 0.13290490E-05_JPRB, 0.13095427E-05_JPRB, 0.12915790E-05_JPRB, 0.12754672E-05_JPRB, &
  & 0.12613771E-05_JPRB, 0.12493834E-05_JPRB, 0.12395592E-05_JPRB, 0.12320132E-05_JPRB, 0.12265672E-05_JPRB, 0.12230093E-05_JPRB, &
  & 0.12211218E-05_JPRB, 0.12207231E-05_JPRB, 0.12218941E-05_JPRB, 0.12265018E-05_JPRB /)

RGHG2(:,24, 6) = (/ &
  & 0.11939775E-05_JPRB, 0.11818649E-05_JPRB, 0.11752503E-05_JPRB, 0.11700722E-05_JPRB, 0.11656895E-05_JPRB, 0.11621204E-05_JPRB, &
  & 0.11599070E-05_JPRB, 0.11600065E-05_JPRB, 0.11634515E-05_JPRB, 0.11709817E-05_JPRB, 0.11828769E-05_JPRB, 0.11989472E-05_JPRB, &
  & 0.12186010E-05_JPRB, 0.12409962E-05_JPRB, 0.12651465E-05_JPRB, 0.12901013E-05_JPRB, 0.13150548E-05_JPRB, 0.13395368E-05_JPRB, &
  & 0.13632655E-05_JPRB, 0.13862318E-05_JPRB, 0.14087354E-05_JPRB, 0.14310749E-05_JPRB, 0.14533971E-05_JPRB, 0.14758574E-05_JPRB, &
  & 0.14983220E-05_JPRB, 0.15202207E-05_JPRB, 0.15408965E-05_JPRB, 0.15592584E-05_JPRB, 0.15741871E-05_JPRB, 0.15854830E-05_JPRB, &
  & 0.15929193E-05_JPRB, 0.15965219E-05_JPRB, 0.15965894E-05_JPRB, 0.15937339E-05_JPRB, 0.15886357E-05_JPRB, 0.15823599E-05_JPRB, &
  & 0.15754542E-05_JPRB, 0.15683745E-05_JPRB, 0.15609613E-05_JPRB, 0.15530678E-05_JPRB, 0.15440795E-05_JPRB, 0.15335619E-05_JPRB, &
  & 0.15211590E-05_JPRB, 0.15067395E-05_JPRB, 0.14903501E-05_JPRB, 0.14722625E-05_JPRB, 0.14530023E-05_JPRB, 0.14331940E-05_JPRB, &
  & 0.14133000E-05_JPRB, 0.13938615E-05_JPRB, 0.13753641E-05_JPRB, 0.13579574E-05_JPRB, 0.13419030E-05_JPRB, 0.13273888E-05_JPRB, &
  & 0.13144780E-05_JPRB, 0.13032164E-05_JPRB, 0.12936664E-05_JPRB, 0.12859379E-05_JPRB, 0.12799291E-05_JPRB, 0.12755033E-05_JPRB, &
  & 0.12724945E-05_JPRB, 0.12707201E-05_JPRB, 0.12700688E-05_JPRB, 0.12712525E-05_JPRB /)

RGHG2(:,25, 6) = (/ &
  & 0.12424375E-05_JPRB, 0.12328429E-05_JPRB, 0.12277337E-05_JPRB, 0.12239730E-05_JPRB, 0.12209829E-05_JPRB, 0.12188844E-05_JPRB, &
  & 0.12182109E-05_JPRB, 0.12198632E-05_JPRB, 0.12247348E-05_JPRB, 0.12334025E-05_JPRB, 0.12460215E-05_JPRB, 0.12623264E-05_JPRB, &
  & 0.12817314E-05_JPRB, 0.13033556E-05_JPRB, 0.13263179E-05_JPRB, 0.13497204E-05_JPRB, 0.13728588E-05_JPRB, 0.13952680E-05_JPRB, &
  & 0.14167624E-05_JPRB, 0.14374043E-05_JPRB, 0.14572480E-05_JPRB, 0.14764036E-05_JPRB, 0.14950078E-05_JPRB, 0.15133973E-05_JPRB, &
  & 0.15315543E-05_JPRB, 0.15493458E-05_JPRB, 0.15663686E-05_JPRB, 0.15821084E-05_JPRB, 0.15960272E-05_JPRB, 0.16074345E-05_JPRB, &
  & 0.16160640E-05_JPRB, 0.16217632E-05_JPRB, 0.16246212E-05_JPRB, 0.16248774E-05_JPRB, 0.16229418E-05_JPRB, 0.16192294E-05_JPRB, &
  & 0.16141056E-05_JPRB, 0.16077427E-05_JPRB, 0.16001404E-05_JPRB, 0.15911993E-05_JPRB, 0.15808041E-05_JPRB, 0.15687341E-05_JPRB, &
  & 0.15549424E-05_JPRB, 0.15394405E-05_JPRB, 0.15224532E-05_JPRB, 0.15043684E-05_JPRB, 0.14857141E-05_JPRB, 0.14669695E-05_JPRB, &
  & 0.14486786E-05_JPRB, 0.14311798E-05_JPRB, 0.14145863E-05_JPRB, 0.13991029E-05_JPRB, 0.13848442E-05_JPRB, 0.13718171E-05_JPRB, &
  & 0.13600535E-05_JPRB, 0.13495558E-05_JPRB, 0.13403807E-05_JPRB, 0.13326513E-05_JPRB, 0.13263237E-05_JPRB, 0.13213287E-05_JPRB, &
  & 0.13175488E-05_JPRB, 0.13148004E-05_JPRB, 0.13128517E-05_JPRB, 0.13114247E-05_JPRB /)

RGHG2(:,26, 6) = (/ &
  & 0.12851283E-05_JPRB, 0.12780141E-05_JPRB, 0.12745020E-05_JPRB, 0.12720153E-05_JPRB, 0.12703392E-05_JPRB, 0.12696257E-05_JPRB, &
  & 0.12704370E-05_JPRB, 0.12735923E-05_JPRB, 0.12798816E-05_JPRB, 0.12897206E-05_JPRB, 0.13031257E-05_JPRB, 0.13198170E-05_JPRB, &
  & 0.13391231E-05_JPRB, 0.13602523E-05_JPRB, 0.13823009E-05_JPRB, 0.14044737E-05_JPRB, 0.14261146E-05_JPRB, 0.14468221E-05_JPRB, &
  & 0.14664159E-05_JPRB, 0.14848816E-05_JPRB, 0.15022251E-05_JPRB, 0.15184158E-05_JPRB, 0.15337189E-05_JPRB, 0.15484216E-05_JPRB, &
  & 0.15626078E-05_JPRB, 0.15764035E-05_JPRB, 0.15898377E-05_JPRB, 0.16028250E-05_JPRB, 0.16149870E-05_JPRB, 0.16258872E-05_JPRB, &
  & 0.16349150E-05_JPRB, 0.16417421E-05_JPRB, 0.16462217E-05_JPRB, 0.16483482E-05_JPRB, 0.16482716E-05_JPRB, 0.16461404E-05_JPRB, &
  & 0.16421122E-05_JPRB, 0.16362397E-05_JPRB, 0.16286855E-05_JPRB, 0.16192655E-05_JPRB, 0.16082022E-05_JPRB, 0.15953993E-05_JPRB, &
  & 0.15810576E-05_JPRB, 0.15652953E-05_JPRB, 0.15484349E-05_JPRB, 0.15308715E-05_JPRB, 0.15130884E-05_JPRB, 0.14956735E-05_JPRB, &
  & 0.14789983E-05_JPRB, 0.14632499E-05_JPRB, 0.14485362E-05_JPRB, 0.14348798E-05_JPRB, 0.14222175E-05_JPRB, 0.14105742E-05_JPRB, &
  & 0.13998898E-05_JPRB, 0.13901637E-05_JPRB, 0.13814409E-05_JPRB, 0.13738404E-05_JPRB, 0.13673689E-05_JPRB, 0.13620127E-05_JPRB, &
  & 0.13577052E-05_JPRB, 0.13542791E-05_JPRB, 0.13514115E-05_JPRB, 0.13482357E-05_JPRB /)

RGHG2(:,27, 6) = (/ &
  & 0.13231415E-05_JPRB, 0.13184930E-05_JPRB, 0.13161729E-05_JPRB, 0.13148506E-05_JPRB, 0.13142762E-05_JPRB, 0.13147313E-05_JPRB, &
  & 0.13167701E-05_JPRB, 0.13212097E-05_JPRB, 0.13286409E-05_JPRB, 0.13393962E-05_JPRB, 0.13534120E-05_JPRB, 0.13702800E-05_JPRB, &
  & 0.13894149E-05_JPRB, 0.14099940E-05_JPRB, 0.14312311E-05_JPRB, 0.14523348E-05_JPRB, 0.14727264E-05_JPRB, 0.14920030E-05_JPRB, &
  & 0.15099934E-05_JPRB, 0.15266481E-05_JPRB, 0.15418741E-05_JPRB, 0.15556918E-05_JPRB, 0.15682992E-05_JPRB, 0.15799409E-05_JPRB, &
  & 0.15908606E-05_JPRB, 0.16012962E-05_JPRB, 0.16116496E-05_JPRB, 0.16220454E-05_JPRB, 0.16323263E-05_JPRB, 0.16421005E-05_JPRB, &
  & 0.16508217E-05_JPRB, 0.16579838E-05_JPRB, 0.16632068E-05_JPRB, 0.16662819E-05_JPRB, 0.16671577E-05_JPRB, 0.16658503E-05_JPRB, &
  & 0.16623994E-05_JPRB, 0.16568356E-05_JPRB, 0.16493134E-05_JPRB, 0.16398731E-05_JPRB, 0.16285337E-05_JPRB, 0.16156199E-05_JPRB, &
  & 0.16012500E-05_JPRB, 0.15857738E-05_JPRB, 0.15694852E-05_JPRB, 0.15528559E-05_JPRB, 0.15363934E-05_JPRB, 0.15205583E-05_JPRB, &
  & 0.15056416E-05_JPRB, 0.14917156E-05_JPRB, 0.14787470E-05_JPRB, 0.14666750E-05_JPRB, 0.14554641E-05_JPRB, 0.14450354E-05_JPRB, &
  & 0.14353396E-05_JPRB, 0.14263657E-05_JPRB, 0.14181535E-05_JPRB, 0.14108150E-05_JPRB, 0.14043836E-05_JPRB, 0.13988841E-05_JPRB, &
  & 0.13942915E-05_JPRB, 0.13904527E-05_JPRB, 0.13869973E-05_JPRB, 0.13826403E-05_JPRB /)

RGHG2(:,28, 6) = (/ &
  & 0.13576370E-05_JPRB, 0.13544970E-05_JPRB, 0.13533095E-05_JPRB, 0.13528547E-05_JPRB, 0.13531578E-05_JPRB, 0.13545159E-05_JPRB, &
  & 0.13575416E-05_JPRB, 0.13628769E-05_JPRB, 0.13711631E-05_JPRB, 0.13825204E-05_JPRB, 0.13967846E-05_JPRB, 0.14136218E-05_JPRB, &
  & 0.14323559E-05_JPRB, 0.14523233E-05_JPRB, 0.14727117E-05_JPRB, 0.14928528E-05_JPRB, 0.15121456E-05_JPRB, 0.15302380E-05_JPRB, &
  & 0.15469273E-05_JPRB, 0.15621206E-05_JPRB, 0.15757221E-05_JPRB, 0.15877380E-05_JPRB, 0.15982926E-05_JPRB, 0.16076140E-05_JPRB, &
  & 0.16160085E-05_JPRB, 0.16238348E-05_JPRB, 0.16316153E-05_JPRB, 0.16396849E-05_JPRB, 0.16480994E-05_JPRB, 0.16566238E-05_JPRB, &
  & 0.16646580E-05_JPRB, 0.16716137E-05_JPRB, 0.16769801E-05_JPRB, 0.16803973E-05_JPRB, 0.16816733E-05_JPRB, 0.16807312E-05_JPRB, &
  & 0.16775660E-05_JPRB, 0.16722117E-05_JPRB, 0.16647697E-05_JPRB, 0.16554316E-05_JPRB, 0.16442565E-05_JPRB, 0.16315084E-05_JPRB, &
  & 0.16175760E-05_JPRB, 0.16027402E-05_JPRB, 0.15874131E-05_JPRB, 0.15720730E-05_JPRB, 0.15571508E-05_JPRB, 0.15430624E-05_JPRB, &
  & 0.15299141E-05_JPRB, 0.15176859E-05_JPRB, 0.15062717E-05_JPRB, 0.14956100E-05_JPRB, 0.14856055E-05_JPRB, 0.14762049E-05_JPRB, &
  & 0.14673622E-05_JPRB, 0.14590672E-05_JPRB, 0.14513597E-05_JPRB, 0.14443342E-05_JPRB, 0.14380227E-05_JPRB, 0.14324668E-05_JPRB, &
  & 0.14276651E-05_JPRB, 0.14234638E-05_JPRB, 0.14193968E-05_JPRB, 0.14134625E-05_JPRB /)

RGHG2(:,29, 6) = (/ &
  & 0.13882507E-05_JPRB, 0.13865441E-05_JPRB, 0.13861297E-05_JPRB, 0.13863571E-05_JPRB, 0.13873246E-05_JPRB, 0.13893768E-05_JPRB, &
  & 0.13930543E-05_JPRB, 0.13991291E-05_JPRB, 0.14079219E-05_JPRB, 0.14195764E-05_JPRB, 0.14338922E-05_JPRB, 0.14504209E-05_JPRB, &
  & 0.14686589E-05_JPRB, 0.14878908E-05_JPRB, 0.15074465E-05_JPRB, 0.15266493E-05_JPRB, 0.15449798E-05_JPRB, 0.15620662E-05_JPRB, &
  & 0.15776991E-05_JPRB, 0.15917464E-05_JPRB, 0.16041254E-05_JPRB, 0.16148065E-05_JPRB, 0.16238598E-05_JPRB, 0.16315225E-05_JPRB, &
  & 0.16381023E-05_JPRB, 0.16440086E-05_JPRB, 0.16498467E-05_JPRB, 0.16560070E-05_JPRB, 0.16627185E-05_JPRB, 0.16698687E-05_JPRB, &
  & 0.16770102E-05_JPRB, 0.16834306E-05_JPRB, 0.16885524E-05_JPRB, 0.16919220E-05_JPRB, 0.16932541E-05_JPRB, 0.16924276E-05_JPRB, &
  & 0.16894301E-05_JPRB, 0.16842761E-05_JPRB, 0.16770688E-05_JPRB, 0.16679636E-05_JPRB, 0.16572005E-05_JPRB, 0.16450047E-05_JPRB, &
  & 0.16317913E-05_JPRB, 0.16179140E-05_JPRB, 0.16038978E-05_JPRB, 0.15900202E-05_JPRB, 0.15767404E-05_JPRB, 0.15642959E-05_JPRB, &
  & 0.15527581E-05_JPRB, 0.15419866E-05_JPRB, 0.15318643E-05_JPRB, 0.15223095E-05_JPRB, 0.15132675E-05_JPRB, 0.15046942E-05_JPRB, &
  & 0.14965469E-05_JPRB, 0.14888393E-05_JPRB, 0.14815932E-05_JPRB, 0.14748915E-05_JPRB, 0.14687629E-05_JPRB, 0.14632554E-05_JPRB, &
  & 0.14583969E-05_JPRB, 0.14540577E-05_JPRB, 0.14498222E-05_JPRB, 0.14438974E-05_JPRB /)

RGHG2(:,30, 6) = (/ &
  & 0.14154698E-05_JPRB, 0.14148550E-05_JPRB, 0.14150578E-05_JPRB, 0.14158197E-05_JPRB, 0.14172799E-05_JPRB, 0.14198206E-05_JPRB, &
  & 0.14240679E-05_JPRB, 0.14305319E-05_JPRB, 0.14396799E-05_JPRB, 0.14514427E-05_JPRB, 0.14655677E-05_JPRB, 0.14817178E-05_JPRB, &
  & 0.14993130E-05_JPRB, 0.15177899E-05_JPRB, 0.15364807E-05_JPRB, 0.15548026E-05_JPRB, 0.15722559E-05_JPRB, 0.15884777E-05_JPRB, &
  & 0.16032462E-05_JPRB, 0.16164008E-05_JPRB, 0.16278344E-05_JPRB, 0.16375143E-05_JPRB, 0.16454952E-05_JPRB, 0.16519916E-05_JPRB, &
  & 0.16573192E-05_JPRB, 0.16618949E-05_JPRB, 0.16663029E-05_JPRB, 0.16710062E-05_JPRB, 0.16763211E-05_JPRB, 0.16821871E-05_JPRB, &
  & 0.16882847E-05_JPRB, 0.16939644E-05_JPRB, 0.16985980E-05_JPRB, 0.17016824E-05_JPRB, 0.17028797E-05_JPRB, 0.17020376E-05_JPRB, &
  & 0.16991484E-05_JPRB, 0.16942645E-05_JPRB, 0.16874409E-05_JPRB, 0.16788537E-05_JPRB, 0.16686826E-05_JPRB, 0.16572952E-05_JPRB, &
  & 0.16451439E-05_JPRB, 0.16325241E-05_JPRB, 0.16198798E-05_JPRB, 0.16074894E-05_JPRB, 0.15957237E-05_JPRB, 0.15847899E-05_JPRB, &
  & 0.15745436E-05_JPRB, 0.15649279E-05_JPRB, 0.15558181E-05_JPRB, 0.15470930E-05_JPRB, 0.15387747E-05_JPRB, 0.15308287E-05_JPRB, &
  & 0.15232415E-05_JPRB, 0.15160231E-05_JPRB, 0.15091994E-05_JPRB, 0.15028321E-05_JPRB, 0.14969467E-05_JPRB, 0.14915923E-05_JPRB, &
  & 0.14868035E-05_JPRB, 0.14824677E-05_JPRB, 0.14781563E-05_JPRB, 0.14717563E-05_JPRB /)

RGHG2(:,31, 6) = (/ &
  & 0.14397567E-05_JPRB, 0.14400429E-05_JPRB, 0.14407548E-05_JPRB, 0.14419011E-05_JPRB, 0.14437559E-05_JPRB, 0.14467035E-05_JPRB, &
  & 0.14512605E-05_JPRB, 0.14580768E-05_JPRB, 0.14673268E-05_JPRB, 0.14789958E-05_JPRB, 0.14928514E-05_JPRB, 0.15084636E-05_JPRB, &
  & 0.15254166E-05_JPRB, 0.15430671E-05_JPRB, 0.15609050E-05_JPRB, 0.15783538E-05_JPRB, 0.15949934E-05_JPRB, 0.16104433E-05_JPRB, &
  & 0.16244845E-05_JPRB, 0.16369183E-05_JPRB, 0.16476258E-05_JPRB, 0.16565536E-05_JPRB, 0.16637666E-05_JPRB, 0.16694701E-05_JPRB, &
  & 0.16739592E-05_JPRB, 0.16776652E-05_JPRB, 0.16810968E-05_JPRB, 0.16847189E-05_JPRB, 0.16888922E-05_JPRB, 0.16936309E-05_JPRB, &
  & 0.16986971E-05_JPRB, 0.17035353E-05_JPRB, 0.17075299E-05_JPRB, 0.17101640E-05_JPRB, 0.17111133E-05_JPRB, 0.17102257E-05_JPRB, &
  & 0.17074802E-05_JPRB, 0.17029321E-05_JPRB, 0.16966712E-05_JPRB, 0.16887827E-05_JPRB, 0.16795231E-05_JPRB, 0.16691630E-05_JPRB, &
  & 0.16582020E-05_JPRB, 0.16469583E-05_JPRB, 0.16357060E-05_JPRB, 0.16248017E-05_JPRB, 0.16142951E-05_JPRB, 0.16045406E-05_JPRB, &
  & 0.15953395E-05_JPRB, 0.15865720E-05_JPRB, 0.15781650E-05_JPRB, 0.15700554E-05_JPRB, 0.15622632E-05_JPRB, 0.15547942E-05_JPRB, &
  & 0.15476543E-05_JPRB, 0.15408505E-05_JPRB, 0.15344087E-05_JPRB, 0.15283775E-05_JPRB, 0.15227723E-05_JPRB, 0.15176311E-05_JPRB, &
  & 0.15129800E-05_JPRB, 0.15087065E-05_JPRB, 0.15043815E-05_JPRB, 0.14978054E-05_JPRB /)

RGHG2(:,32, 6) = (/ &
  & 0.14617262E-05_JPRB, 0.14627636E-05_JPRB, 0.14638226E-05_JPRB, 0.14653433E-05_JPRB, 0.14675118E-05_JPRB, 0.14707530E-05_JPRB, &
  & 0.14756188E-05_JPRB, 0.14825201E-05_JPRB, 0.14917434E-05_JPRB, 0.15031806E-05_JPRB, 0.15165723E-05_JPRB, 0.15316143E-05_JPRB, &
  & 0.15478030E-05_JPRB, 0.15646538E-05_JPRB, 0.15816074E-05_JPRB, 0.15982133E-05_JPRB, 0.16140835E-05_JPRB, 0.16288207E-05_JPRB, &
  & 0.16422181E-05_JPRB, 0.16540544E-05_JPRB, 0.16641849E-05_JPRB, 0.16725593E-05_JPRB, 0.16792310E-05_JPRB, 0.16844043E-05_JPRB, &
  & 0.16883677E-05_JPRB, 0.16915019E-05_JPRB, 0.16943090E-05_JPRB, 0.16971594E-05_JPRB, 0.17004498E-05_JPRB, 0.17042275E-05_JPRB, &
  & 0.17083353E-05_JPRB, 0.17123148E-05_JPRB, 0.17156062E-05_JPRB, 0.17177393E-05_JPRB, 0.17183806E-05_JPRB, 0.17174164E-05_JPRB, &
  & 0.17148552E-05_JPRB, 0.17107423E-05_JPRB, 0.17051257E-05_JPRB, 0.16981401E-05_JPRB, 0.16898994E-05_JPRB, 0.16807994E-05_JPRB, &
  & 0.16711426E-05_JPRB, 0.16612697E-05_JPRB, 0.16513322E-05_JPRB, 0.16416255E-05_JPRB, 0.16322746E-05_JPRB, 0.16233309E-05_JPRB, &
  & 0.16148948E-05_JPRB, 0.16067359E-05_JPRB, 0.15988331E-05_JPRB, 0.15911623E-05_JPRB, 0.15837543E-05_JPRB, 0.15766536E-05_JPRB, &
  & 0.15698781E-05_JPRB, 0.15634325E-05_JPRB, 0.15573410E-05_JPRB, 0.15516378E-05_JPRB, 0.15463312E-05_JPRB, 0.15414431E-05_JPRB, &
  & 0.15369885E-05_JPRB, 0.15328559E-05_JPRB, 0.15286219E-05_JPRB, 0.15222400E-05_JPRB /)

RGHG2(:,33, 6) = (/ &
  & 0.14818397E-05_JPRB, 0.14834076E-05_JPRB, 0.14849060E-05_JPRB, 0.14867072E-05_JPRB, 0.14891867E-05_JPRB, 0.14926962E-05_JPRB, &
  & 0.14976913E-05_JPRB, 0.15046388E-05_JPRB, 0.15136490E-05_JPRB, 0.15246734E-05_JPRB, 0.15375272E-05_JPRB, 0.15518455E-05_JPRB, &
  & 0.15672608E-05_JPRB, 0.15832294E-05_JPRB, 0.15993382E-05_JPRB, 0.16150927E-05_JPRB, 0.16302006E-05_JPRB, 0.16442929E-05_JPRB, &
  & 0.16571033E-05_JPRB, 0.16684276E-05_JPRB, 0.16781073E-05_JPRB, 0.16860752E-05_JPRB, 0.16923835E-05_JPRB, 0.16972258E-05_JPRB, &
  & 0.17008689E-05_JPRB, 0.17036655E-05_JPRB, 0.17060747E-05_JPRB, 0.17083994E-05_JPRB, 0.17110049E-05_JPRB, 0.17139811E-05_JPRB, &
  & 0.17172249E-05_JPRB, 0.17203691E-05_JPRB, 0.17229506E-05_JPRB, 0.17245561E-05_JPRB, 0.17249199E-05_JPRB, 0.17239099E-05_JPRB, &
  & 0.17215564E-05_JPRB, 0.17179175E-05_JPRB, 0.17130336E-05_JPRB, 0.17069520E-05_JPRB, 0.16998682E-05_JPRB, 0.16919761E-05_JPRB, &
  & 0.16836620E-05_JPRB, 0.16750527E-05_JPRB, 0.16663448E-05_JPRB, 0.16576556E-05_JPRB, 0.16491745E-05_JPRB, 0.16409263E-05_JPRB, &
  & 0.16329616E-05_JPRB, 0.16252573E-05_JPRB, 0.16176975E-05_JPRB, 0.16103490E-05_JPRB, 0.16032435E-05_JPRB, 0.15964476E-05_JPRB, &
  & 0.15899820E-05_JPRB, 0.15838539E-05_JPRB, 0.15780840E-05_JPRB, 0.15726988E-05_JPRB, 0.15676976E-05_JPRB, 0.15630958E-05_JPRB, &
  & 0.15588782E-05_JPRB, 0.15549408E-05_JPRB, 0.15508790E-05_JPRB, 0.15446238E-05_JPRB /)

RGHG2(:,34, 6) = (/ &
  & 0.15001312E-05_JPRB, 0.15025093E-05_JPRB, 0.15043150E-05_JPRB, 0.15064678E-05_JPRB, 0.15091933E-05_JPRB, 0.15128992E-05_JPRB, &
  & 0.15180153E-05_JPRB, 0.15248339E-05_JPRB, 0.15335304E-05_JPRB, 0.15440486E-05_JPRB, 0.15562118E-05_JPRB, 0.15697715E-05_JPRB, &
  & 0.15843088E-05_JPRB, 0.15994075E-05_JPRB, 0.16146281E-05_JPRB, 0.16295744E-05_JPRB, 0.16439244E-05_JPRB, 0.16573889E-05_JPRB, &
  & 0.16696757E-05_JPRB, 0.16805614E-05_JPRB, 0.16898869E-05_JPRB, 0.16975710E-05_JPRB, 0.17036546E-05_JPRB, 0.17083026E-05_JPRB, &
  & 0.17117746E-05_JPRB, 0.17143788E-05_JPRB, 0.17165214E-05_JPRB, 0.17184969E-05_JPRB, 0.17205648E-05_JPRB, 0.17228851E-05_JPRB, &
  & 0.17253655E-05_JPRB, 0.17277473E-05_JPRB, 0.17296614E-05_JPRB, 0.17307757E-05_JPRB, 0.17308624E-05_JPRB, 0.17298480E-05_JPRB, &
  & 0.17277396E-05_JPRB, 0.17245901E-05_JPRB, 0.17204179E-05_JPRB, 0.17152745E-05_JPRB, 0.17092342E-05_JPRB, 0.17025475E-05_JPRB, &
  & 0.16953908E-05_JPRB, 0.16879458E-05_JPRB, 0.16802534E-05_JPRB, 0.16724356E-05_JPRB, 0.16646504E-05_JPRB, 0.16569261E-05_JPRB, &
  & 0.16493534E-05_JPRB, 0.16419418E-05_JPRB, 0.16346719E-05_JPRB, 0.16275749E-05_JPRB, 0.16207304E-05_JPRB, 0.16142064E-05_JPRB, &
  & 0.16080201E-05_JPRB, 0.16021843E-05_JPRB, 0.15967128E-05_JPRB, 0.15916348E-05_JPRB, 0.15869466E-05_JPRB, 0.15826449E-05_JPRB, &
  & 0.15787103E-05_JPRB, 0.15750287E-05_JPRB, 0.15712021E-05_JPRB, 0.15653125E-05_JPRB /)

RGHG2(:,35, 6) = (/ &
  & 0.15172749E-05_JPRB, 0.15201975E-05_JPRB, 0.15224216E-05_JPRB, 0.15248139E-05_JPRB, 0.15277773E-05_JPRB, 0.15316451E-05_JPRB, &
  & 0.15367552E-05_JPRB, 0.15434167E-05_JPRB, 0.15517069E-05_JPRB, 0.15616218E-05_JPRB, 0.15730571E-05_JPRB, 0.15857590E-05_JPRB, &
  & 0.15994049E-05_JPRB, 0.16135815E-05_JPRB, 0.16279278E-05_JPRB, 0.16420655E-05_JPRB, 0.16556919E-05_JPRB, 0.16685460E-05_JPRB, &
  & 0.16803599E-05_JPRB, 0.16908907E-05_JPRB, 0.16999530E-05_JPRB, 0.17074539E-05_JPRB, 0.17134166E-05_JPRB, 0.17179714E-05_JPRB, &
  & 0.17213517E-05_JPRB, 0.17238568E-05_JPRB, 0.17258199E-05_JPRB, 0.17275297E-05_JPRB, 0.17291911E-05_JPRB, 0.17309439E-05_JPRB, &
  & 0.17327590E-05_JPRB, 0.17344531E-05_JPRB, 0.17357692E-05_JPRB, 0.17364484E-05_JPRB, 0.17363166E-05_JPRB, 0.17353173E-05_JPRB, &
  & 0.17334711E-05_JPRB, 0.17307914E-05_JPRB, 0.17272962E-05_JPRB, 0.17229875E-05_JPRB, 0.17179339E-05_JPRB, 0.17122422E-05_JPRB, &
  & 0.17061255E-05_JPRB, 0.16996175E-05_JPRB, 0.16927895E-05_JPRB, 0.16856861E-05_JPRB, 0.16784591E-05_JPRB, 0.16711774E-05_JPRB, &
  & 0.16639043E-05_JPRB, 0.16567544E-05_JPRB, 0.16497121E-05_JPRB, 0.16428496E-05_JPRB, 0.16362553E-05_JPRB, 0.16299906E-05_JPRB, &
  & 0.16240742E-05_JPRB, 0.16185119E-05_JPRB, 0.16133262E-05_JPRB, 0.16085422E-05_JPRB, 0.16041628E-05_JPRB, 0.16001792E-05_JPRB, &
  & 0.15965522E-05_JPRB, 0.15931616E-05_JPRB, 0.15896405E-05_JPRB, 0.15841656E-05_JPRB /)

RGHG2(:,36, 6) = (/ &
  & 0.15332084E-05_JPRB, 0.15368105E-05_JPRB, 0.15392972E-05_JPRB, 0.15419637E-05_JPRB, 0.15451120E-05_JPRB, 0.15490720E-05_JPRB, &
  & 0.15541586E-05_JPRB, 0.15605627E-05_JPRB, 0.15684018E-05_JPRB, 0.15776860E-05_JPRB, 0.15883314E-05_JPRB, 0.16001570E-05_JPRB, &
  & 0.16128654E-05_JPRB, 0.16261172E-05_JPRB, 0.16395679E-05_JPRB, 0.16529073E-05_JPRB, 0.16658406E-05_JPRB, 0.16781162E-05_JPRB, &
  & 0.16894966E-05_JPRB, 0.16997426E-05_JPRB, 0.17086421E-05_JPRB, 0.17160525E-05_JPRB, 0.17219562E-05_JPRB, 0.17264630E-05_JPRB, &
  & 0.17297901E-05_JPRB, 0.17322113E-05_JPRB, 0.17340276E-05_JPRB, 0.17355018E-05_JPRB, 0.17368149E-05_JPRB, 0.17380886E-05_JPRB, &
  & 0.17393253E-05_JPRB, 0.17404246E-05_JPRB, 0.17412139E-05_JPRB, 0.17415257E-05_JPRB, 0.17412352E-05_JPRB, 0.17403038E-05_JPRB, &
  & 0.17387242E-05_JPRB, 0.17365106E-05_JPRB, 0.17336346E-05_JPRB, 0.17300814E-05_JPRB, 0.17258385E-05_JPRB, 0.17210125E-05_JPRB, &
  & 0.17156900E-05_JPRB, 0.17099661E-05_JPRB, 0.17038210E-05_JPRB, 0.16973206E-05_JPRB, 0.16905666E-05_JPRB, 0.16836353E-05_JPRB, &
  & 0.16766525E-05_JPRB, 0.16697265E-05_JPRB, 0.16629033E-05_JPRB, 0.16562752E-05_JPRB, 0.16499278E-05_JPRB, 0.16439296E-05_JPRB, &
  & 0.16382812E-05_JPRB, 0.16329905E-05_JPRB, 0.16280756E-05_JPRB, 0.16235812E-05_JPRB, 0.16195112E-05_JPRB, 0.16158525E-05_JPRB, &
  & 0.16125549E-05_JPRB, 0.16094920E-05_JPRB, 0.16063050E-05_JPRB, 0.16013561E-05_JPRB /)

RGHG2(:,37, 6) = (/ &
  & 0.15483430E-05_JPRB, 0.15524170E-05_JPRB, 0.15552217E-05_JPRB, 0.15580997E-05_JPRB, 0.15614048E-05_JPRB, 0.15654430E-05_JPRB, &
  & 0.15704220E-05_JPRB, 0.15765363E-05_JPRB, 0.15838771E-05_JPRB, 0.15924857E-05_JPRB, 0.16023268E-05_JPRB, 0.16132457E-05_JPRB, &
  & 0.16249912E-05_JPRB, 0.16372935E-05_JPRB, 0.16498518E-05_JPRB, 0.16623801E-05_JPRB, 0.16746360E-05_JPRB, 0.16863678E-05_JPRB, &
  & 0.16973589E-05_JPRB, 0.17073614E-05_JPRB, 0.17161387E-05_JPRB, 0.17235006E-05_JPRB, 0.17293521E-05_JPRB, 0.17337790E-05_JPRB, &
  & 0.17369694E-05_JPRB, 0.17392317E-05_JPRB, 0.17408439E-05_JPRB, 0.17420653E-05_JPRB, 0.17430596E-05_JPRB, 0.17439328E-05_JPRB, &
  & 0.17447054E-05_JPRB, 0.17453284E-05_JPRB, 0.17457073E-05_JPRB, 0.17457409E-05_JPRB, 0.17453632E-05_JPRB, 0.17445304E-05_JPRB, &
  & 0.17432553E-05_JPRB, 0.17414911E-05_JPRB, 0.17392113E-05_JPRB, 0.17363458E-05_JPRB, 0.17328556E-05_JPRB, 0.17287500E-05_JPRB, &
  & 0.17241166E-05_JPRB, 0.17189903E-05_JPRB, 0.17134125E-05_JPRB, 0.17074137E-05_JPRB, 0.17010652E-05_JPRB, 0.16944555E-05_JPRB, &
  & 0.16877354E-05_JPRB, 0.16810341E-05_JPRB, 0.16744342E-05_JPRB, 0.16680378E-05_JPRB, 0.16619557E-05_JPRB, 0.16562274E-05_JPRB, &
  & 0.16508529E-05_JPRB, 0.16458296E-05_JPRB, 0.16411886E-05_JPRB, 0.16369809E-05_JPRB, 0.16332233E-05_JPRB, 0.16298981E-05_JPRB, &
  & 0.16269425E-05_JPRB, 0.16242171E-05_JPRB, 0.16213933E-05_JPRB, 0.16169859E-05_JPRB /)

RGHG2(:,38, 6) = (/ &
  & 0.15627581E-05_JPRB, 0.15672352E-05_JPRB, 0.15703288E-05_JPRB, 0.15733881E-05_JPRB, 0.15768871E-05_JPRB, 0.15809464E-05_JPRB, &
  & 0.15857942E-05_JPRB, 0.15915642E-05_JPRB, 0.15983601E-05_JPRB, 0.16062633E-05_JPRB, 0.16152749E-05_JPRB, 0.16252656E-05_JPRB, &
  & 0.16360385E-05_JPRB, 0.16473681E-05_JPRB, 0.16590168E-05_JPRB, 0.16707426E-05_JPRB, 0.16823086E-05_JPRB, 0.16935123E-05_JPRB, &
  & 0.17041243E-05_JPRB, 0.17138937E-05_JPRB, 0.17225237E-05_JPRB, 0.17297292E-05_JPRB, 0.17353818E-05_JPRB, 0.17395266E-05_JPRB, &
  & 0.17424101E-05_JPRB, 0.17443559E-05_JPRB, 0.17456912E-05_JPRB, 0.17466418E-05_JPRB, 0.17473677E-05_JPRB, 0.17479467E-05_JPRB, &
  & 0.17484040E-05_JPRB, 0.17487159E-05_JPRB, 0.17488294E-05_JPRB, 0.17487007E-05_JPRB, 0.17482865E-05_JPRB, 0.17475819E-05_JPRB, &
  & 0.17465776E-05_JPRB, 0.17452289E-05_JPRB, 0.17434908E-05_JPRB, 0.17412960E-05_JPRB, 0.17385398E-05_JPRB, 0.17351706E-05_JPRB, &
  & 0.17312068E-05_JPRB, 0.17266807E-05_JPRB, 0.17216220E-05_JPRB, 0.17160620E-05_JPRB, 0.17100838E-05_JPRB, 0.17037871E-05_JPRB, &
  & 0.16973286E-05_JPRB, 0.16908700E-05_JPRB, 0.16845006E-05_JPRB, 0.16783575E-05_JPRB, 0.16725436E-05_JPRB, 0.16670940E-05_JPRB, &
  & 0.16619970E-05_JPRB, 0.16572428E-05_JPRB, 0.16528741E-05_JPRB, 0.16489555E-05_JPRB, 0.16455151E-05_JPRB, 0.16425282E-05_JPRB, &
  & 0.16399167E-05_JPRB, 0.16375272E-05_JPRB, 0.16350596E-05_JPRB, 0.16311983E-05_JPRB /)

RGHG2(:,39, 6) = (/ &
  & 0.15765247E-05_JPRB, 0.15814201E-05_JPRB, 0.15846754E-05_JPRB, 0.15880335E-05_JPRB, 0.15916310E-05_JPRB, 0.15957627E-05_JPRB, &
  & 0.16004374E-05_JPRB, 0.16058175E-05_JPRB, 0.16120364E-05_JPRB, 0.16192075E-05_JPRB, 0.16273568E-05_JPRB, 0.16364160E-05_JPRB, &
  & 0.16462050E-05_JPRB, 0.16565585E-05_JPRB, 0.16672858E-05_JPRB, 0.16781891E-05_JPRB, 0.16890621E-05_JPRB, 0.16997113E-05_JPRB, &
  & 0.17099119E-05_JPRB, 0.17193992E-05_JPRB, 0.17277612E-05_JPRB, 0.17346521E-05_JPRB, 0.17398684E-05_JPRB, 0.17435490E-05_JPRB, &
  & 0.17459948E-05_JPRB, 0.17475907E-05_JPRB, 0.17486468E-05_JPRB, 0.17493805E-05_JPRB, 0.17499159E-05_JPRB, 0.17503145E-05_JPRB, &
  & 0.17505913E-05_JPRB, 0.17507321E-05_JPRB, 0.17507025E-05_JPRB, 0.17504881E-05_JPRB, 0.17500729E-05_JPRB, 0.17494546E-05_JPRB, &
  & 0.17486572E-05_JPRB, 0.17476044E-05_JPRB, 0.17463061E-05_JPRB, 0.17446754E-05_JPRB, 0.17425817E-05_JPRB, 0.17399487E-05_JPRB, &
  & 0.17367303E-05_JPRB, 0.17328921E-05_JPRB, 0.17284167E-05_JPRB, 0.17233534E-05_JPRB, 0.17177716E-05_JPRB, 0.17118032E-05_JPRB, &
  & 0.17056311E-05_JPRB, 0.16994272E-05_JPRB, 0.16933147E-05_JPRB, 0.16874360E-05_JPRB, 0.16819005E-05_JPRB, 0.16767307E-05_JPRB, &
  & 0.16719048E-05_JPRB, 0.16674202E-05_JPRB, 0.16633219E-05_JPRB, 0.16596957E-05_JPRB, 0.16565732E-05_JPRB, 0.16539225E-05_JPRB, &
  & 0.16516414E-05_JPRB, 0.16495776E-05_JPRB, 0.16474410E-05_JPRB, 0.16441019E-05_JPRB /)

RGHG2(:,40, 6) = (/ &
  & 0.15898112E-05_JPRB, 0.15948599E-05_JPRB, 0.15984715E-05_JPRB, 0.16019233E-05_JPRB, 0.16058203E-05_JPRB, 0.16099282E-05_JPRB, &
  & 0.16144365E-05_JPRB, 0.16194214E-05_JPRB, 0.16250406E-05_JPRB, 0.16314452E-05_JPRB, 0.16387332E-05_JPRB, 0.16468466E-05_JPRB, &
  & 0.16556681E-05_JPRB, 0.16650536E-05_JPRB, 0.16748590E-05_JPRB, 0.16849212E-05_JPRB, 0.16950667E-05_JPRB, 0.17051093E-05_JPRB, &
  & 0.17148341E-05_JPRB, 0.17238873E-05_JPRB, 0.17318664E-05_JPRB, 0.17382857E-05_JPRB, 0.17430032E-05_JPRB, 0.17461922E-05_JPRB, &
  & 0.17482431E-05_JPRB, 0.17495452E-05_JPRB, 0.17503960E-05_JPRB, 0.17509786E-05_JPRB, 0.17513951E-05_JPRB, 0.17516893E-05_JPRB, &
  & 0.17518680E-05_JPRB, 0.17519188E-05_JPRB, 0.17518157E-05_JPRB, 0.17515580E-05_JPRB, 0.17511437E-05_JPRB, 0.17505841E-05_JPRB, &
  & 0.17499071E-05_JPRB, 0.17490509E-05_JPRB, 0.17480507E-05_JPRB, 0.17468155E-05_JPRB, 0.17452455E-05_JPRB, 0.17432540E-05_JPRB, &
  & 0.17407549E-05_JPRB, 0.17376478E-05_JPRB, 0.17338639E-05_JPRB, 0.17293740E-05_JPRB, 0.17242645E-05_JPRB, 0.17186825E-05_JPRB, &
  & 0.17128190E-05_JPRB, 0.17069017E-05_JPRB, 0.17010678E-05_JPRB, 0.16954662E-05_JPRB, 0.16902139E-05_JPRB, 0.16853205E-05_JPRB, &
  & 0.16807613E-05_JPRB, 0.16765321E-05_JPRB, 0.16727017E-05_JPRB, 0.16693601E-05_JPRB, 0.16665513E-05_JPRB, 0.16642210E-05_JPRB, &
  & 0.16622545E-05_JPRB, 0.16604833E-05_JPRB, 0.16586603E-05_JPRB, 0.16557824E-05_JPRB /)

RGHG2(:,41, 6) = (/ &
  & 0.16024960E-05_JPRB, 0.16078817E-05_JPRB, 0.16115021E-05_JPRB, 0.16153574E-05_JPRB, 0.16193155E-05_JPRB, 0.16235363E-05_JPRB, &
  & 0.16278495E-05_JPRB, 0.16324318E-05_JPRB, 0.16374534E-05_JPRB, 0.16431128E-05_JPRB, 0.16495210E-05_JPRB, 0.16567091E-05_JPRB, &
  & 0.16645805E-05_JPRB, 0.16730230E-05_JPRB, 0.16819146E-05_JPRB, 0.16911330E-05_JPRB, 0.17005128E-05_JPRB, 0.17098927E-05_JPRB, &
  & 0.17190439E-05_JPRB, 0.17276142E-05_JPRB, 0.17350618E-05_JPRB, 0.17409735E-05_JPRB, 0.17451916E-05_JPRB, 0.17479697E-05_JPRB, &
  & 0.17497116E-05_JPRB, 0.17508004E-05_JPRB, 0.17515069E-05_JPRB, 0.17519895E-05_JPRB, 0.17523301E-05_JPRB, 0.17525621E-05_JPRB, &
  & 0.17526869E-05_JPRB, 0.17526880E-05_JPRB, 0.17525458E-05_JPRB, 0.17522626E-05_JPRB, 0.17518531E-05_JPRB, 0.17513255E-05_JPRB, &
  & 0.17507239E-05_JPRB, 0.17499963E-05_JPRB, 0.17491819E-05_JPRB, 0.17482247E-05_JPRB, 0.17470269E-05_JPRB, 0.17455338E-05_JPRB, &
  & 0.17436435E-05_JPRB, 0.17412235E-05_JPRB, 0.17381436E-05_JPRB, 0.17343106E-05_JPRB, 0.17297474E-05_JPRB, 0.17245974E-05_JPRB, &
  & 0.17190943E-05_JPRB, 0.17134823E-05_JPRB, 0.17079522E-05_JPRB, 0.17026400E-05_JPRB, 0.16976704E-05_JPRB, 0.16930472E-05_JPRB, &
  & 0.16887400E-05_JPRB, 0.16847616E-05_JPRB, 0.16811798E-05_JPRB, 0.16781181E-05_JPRB, 0.16756051E-05_JPRB, 0.16735744E-05_JPRB, &
  & 0.16718891E-05_JPRB, 0.16703851E-05_JPRB, 0.16688255E-05_JPRB, 0.16663643E-05_JPRB /)

RGHG2(:,42, 6) = (/ &
  & 0.16148879E-05_JPRB, 0.16202669E-05_JPRB, 0.16241826E-05_JPRB, 0.16280660E-05_JPRB, 0.16323683E-05_JPRB, 0.16365650E-05_JPRB, &
  & 0.16407242E-05_JPRB, 0.16449259E-05_JPRB, 0.16493801E-05_JPRB, 0.16542995E-05_JPRB, 0.16598697E-05_JPRB, 0.16661543E-05_JPRB, &
  & 0.16731084E-05_JPRB, 0.16806412E-05_JPRB, 0.16886457E-05_JPRB, 0.16970022E-05_JPRB, 0.17055955E-05_JPRB, 0.17142456E-05_JPRB, &
  & 0.17227560E-05_JPRB, 0.17307484E-05_JPRB, 0.17376990E-05_JPRB, 0.17430912E-05_JPRB, 0.17468512E-05_JPRB, 0.17492656E-05_JPRB, &
  & 0.17507574E-05_JPRB, 0.17516854E-05_JPRB, 0.17522877E-05_JPRB, 0.17526997E-05_JPRB, 0.17529908E-05_JPRB, 0.17531845E-05_JPRB, &
  & 0.17532780E-05_JPRB, 0.17532511E-05_JPRB, 0.17530875E-05_JPRB, 0.17527880E-05_JPRB, 0.17523818E-05_JPRB, 0.17518752E-05_JPRB, &
  & 0.17513208E-05_JPRB, 0.17506744E-05_JPRB, 0.17499915E-05_JPRB, 0.17492160E-05_JPRB, 0.17482932E-05_JPRB, 0.17471696E-05_JPRB, &
  & 0.17457535E-05_JPRB, 0.17439186E-05_JPRB, 0.17415002E-05_JPRB, 0.17383470E-05_JPRB, 0.17343978E-05_JPRB, 0.17297548E-05_JPRB, &
  & 0.17246463E-05_JPRB, 0.17193714E-05_JPRB, 0.17141563E-05_JPRB, 0.17091459E-05_JPRB, 0.17044590E-05_JPRB, 0.17001047E-05_JPRB, &
  & 0.16960461E-05_JPRB, 0.16922987E-05_JPRB, 0.16889646E-05_JPRB, 0.16861610E-05_JPRB, 0.16839235E-05_JPRB, 0.16821605E-05_JPRB, &
  & 0.16807227E-05_JPRB, 0.16794429E-05_JPRB, 0.16781149E-05_JPRB, 0.16759919E-05_JPRB /)

RGHG2(:,43, 6) = (/ &
  & 0.16269432E-05_JPRB, 0.16324966E-05_JPRB, 0.16362771E-05_JPRB, 0.16404877E-05_JPRB, 0.16448345E-05_JPRB, 0.16491510E-05_JPRB, &
  & 0.16531374E-05_JPRB, 0.16569884E-05_JPRB, 0.16609110E-05_JPRB, 0.16651543E-05_JPRB, 0.16699206E-05_JPRB, 0.16753442E-05_JPRB, &
  & 0.16814254E-05_JPRB, 0.16880906E-05_JPRB, 0.16952266E-05_JPRB, 0.17027425E-05_JPRB, 0.17104971E-05_JPRB, 0.17183808E-05_JPRB, &
  & 0.17261732E-05_JPRB, 0.17335510E-05_JPRB, 0.17399276E-05_JPRB, 0.17448415E-05_JPRB, 0.17481823E-05_JPRB, 0.17502840E-05_JPRB, &
  & 0.17515654E-05_JPRB, 0.17523636E-05_JPRB, 0.17528865E-05_JPRB, 0.17532481E-05_JPRB, 0.17535049E-05_JPRB, 0.17536745E-05_JPRB, &
  & 0.17537504E-05_JPRB, 0.17537085E-05_JPRB, 0.17535314E-05_JPRB, 0.17532254E-05_JPRB, 0.17528174E-05_JPRB, 0.17523274E-05_JPRB, &
  & 0.17517970E-05_JPRB, 0.17512143E-05_JPRB, 0.17506095E-05_JPRB, 0.17499746E-05_JPRB, 0.17492458E-05_JPRB, 0.17483995E-05_JPRB, &
  & 0.17473581E-05_JPRB, 0.17459993E-05_JPRB, 0.17441710E-05_JPRB, 0.17416895E-05_JPRB, 0.17384073E-05_JPRB, 0.17343344E-05_JPRB, &
  & 0.17296766E-05_JPRB, 0.17247636E-05_JPRB, 0.17198661E-05_JPRB, 0.17151643E-05_JPRB, 0.17107656E-05_JPRB, 0.17066791E-05_JPRB, &
  & 0.17028650E-05_JPRB, 0.16993552E-05_JPRB, 0.16962522E-05_JPRB, 0.16936982E-05_JPRB, 0.16917086E-05_JPRB, 0.16901794E-05_JPRB, &
  & 0.16889473E-05_JPRB, 0.16878572E-05_JPRB, 0.16867100E-05_JPRB, 0.16848620E-05_JPRB /)

RGHG2(:,44, 6) = (/ &
  & 0.16390881E-05_JPRB, 0.16443767E-05_JPRB, 0.16483200E-05_JPRB, 0.16523859E-05_JPRB, 0.16570284E-05_JPRB, 0.16613128E-05_JPRB, &
  & 0.16651950E-05_JPRB, 0.16687213E-05_JPRB, 0.16721742E-05_JPRB, 0.16757911E-05_JPRB, 0.16798330E-05_JPRB, 0.16844494E-05_JPRB, &
  & 0.16897113E-05_JPRB, 0.16955485E-05_JPRB, 0.17018650E-05_JPRB, 0.17085165E-05_JPRB, 0.17154331E-05_JPRB, 0.17224659E-05_JPRB, &
  & 0.17295051E-05_JPRB, 0.17361697E-05_JPRB, 0.17419713E-05_JPRB, 0.17463520E-05_JPRB, 0.17493001E-05_JPRB, 0.17511194E-05_JPRB, &
  & 0.17522243E-05_JPRB, 0.17529159E-05_JPRB, 0.17533762E-05_JPRB, 0.17537003E-05_JPRB, 0.17539339E-05_JPRB, 0.17540898E-05_JPRB, &
  & 0.17541568E-05_JPRB, 0.17541082E-05_JPRB, 0.17539257E-05_JPRB, 0.17536149E-05_JPRB, 0.17532055E-05_JPRB, 0.17527246E-05_JPRB, &
  & 0.17522082E-05_JPRB, 0.17516634E-05_JPRB, 0.17511198E-05_JPRB, 0.17505785E-05_JPRB, 0.17500009E-05_JPRB, 0.17493667E-05_JPRB, &
  & 0.17486155E-05_JPRB, 0.17476495E-05_JPRB, 0.17463335E-05_JPRB, 0.17444740E-05_JPRB, 0.17418947E-05_JPRB, 0.17384659E-05_JPRB, &
  & 0.17343400E-05_JPRB, 0.17298125E-05_JPRB, 0.17252490E-05_JPRB, 0.17208645E-05_JPRB, 0.17167597E-05_JPRB, 0.17129491E-05_JPRB, &
  & 0.17093912E-05_JPRB, 0.17061162E-05_JPRB, 0.17032522E-05_JPRB, 0.17009284E-05_JPRB, 0.16991643E-05_JPRB, 0.16978312E-05_JPRB, &
  & 0.16967737E-05_JPRB, 0.16958286E-05_JPRB, 0.16948313E-05_JPRB, 0.16931828E-05_JPRB /)

RGHG2(:,45, 6) = (/ &
  & 0.16513204E-05_JPRB, 0.16565186E-05_JPRB, 0.16600085E-05_JPRB, 0.16642961E-05_JPRB, 0.16688158E-05_JPRB, 0.16732785E-05_JPRB, &
  & 0.16769937E-05_JPRB, 0.16802671E-05_JPRB, 0.16832861E-05_JPRB, 0.16863776E-05_JPRB, 0.16897477E-05_JPRB, 0.16936481E-05_JPRB, &
  & 0.16981369E-05_JPRB, 0.17032082E-05_JPRB, 0.17087052E-05_JPRB, 0.17145416E-05_JPRB, 0.17205525E-05_JPRB, 0.17267182E-05_JPRB, &
  & 0.17328596E-05_JPRB, 0.17387812E-05_JPRB, 0.17438592E-05_JPRB, 0.17477271E-05_JPRB, 0.17502661E-05_JPRB, 0.17518316E-05_JPRB, &
  & 0.17527799E-05_JPRB, 0.17533836E-05_JPRB, 0.17537939E-05_JPRB, 0.17540906E-05_JPRB, 0.17543094E-05_JPRB, 0.17544589E-05_JPRB, &
  & 0.17545240E-05_JPRB, 0.17544754E-05_JPRB, 0.17542914E-05_JPRB, 0.17539789E-05_JPRB, 0.17535665E-05_JPRB, 0.17530891E-05_JPRB, &
  & 0.17525756E-05_JPRB, 0.17520576E-05_JPRB, 0.17515496E-05_JPRB, 0.17510813E-05_JPRB, 0.17506161E-05_JPRB, 0.17501462E-05_JPRB, &
  & 0.17496272E-05_JPRB, 0.17489765E-05_JPRB, 0.17480826E-05_JPRB, 0.17467891E-05_JPRB, 0.17448755E-05_JPRB, 0.17421885E-05_JPRB, &
  & 0.17386653E-05_JPRB, 0.17346227E-05_JPRB, 0.17304156E-05_JPRB, 0.17263638E-05_JPRB, 0.17225766E-05_JPRB, 0.17190505E-05_JPRB, &
  & 0.17157669E-05_JPRB, 0.17127506E-05_JPRB, 0.17101203E-05_JPRB, 0.17080232E-05_JPRB, 0.17064528E-05_JPRB, 0.17052907E-05_JPRB, &
  & 0.17043646E-05_JPRB, 0.17035419E-05_JPRB, 0.17026481E-05_JPRB, 0.17011620E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART11',1,ZHOOK_HANDLE)
END SUBROUTINE PART11




SUBROUTINE PART12
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART12',0,ZHOOK_HANDLE)



RGHG2(:,46, 6) = (/ &
  & 0.16631005E-05_JPRB, 0.16681453E-05_JPRB, 0.16719575E-05_JPRB, 0.16758606E-05_JPRB, 0.16807430E-05_JPRB, 0.16850872E-05_JPRB, &
  & 0.16888077E-05_JPRB, 0.16917963E-05_JPRB, 0.16944796E-05_JPRB, 0.16970660E-05_JPRB, 0.16998913E-05_JPRB, 0.17031084E-05_JPRB, &
  & 0.17069062E-05_JPRB, 0.17112220E-05_JPRB, 0.17159637E-05_JPRB, 0.17209243E-05_JPRB, 0.17260602E-05_JPRB, 0.17312376E-05_JPRB, &
  & 0.17364569E-05_JPRB, 0.17413842E-05_JPRB, 0.17457229E-05_JPRB, 0.17489606E-05_JPRB, 0.17511252E-05_JPRB, 0.17524453E-05_JPRB, &
  & 0.17532604E-05_JPRB, 0.17537893E-05_JPRB, 0.17541606E-05_JPRB, 0.17544368E-05_JPRB, 0.17546477E-05_JPRB, 0.17547959E-05_JPRB, &
  & 0.17548650E-05_JPRB, 0.17548214E-05_JPRB, 0.17546409E-05_JPRB, 0.17543285E-05_JPRB, 0.17539129E-05_JPRB, 0.17534314E-05_JPRB, &
  & 0.17529172E-05_JPRB, 0.17524069E-05_JPRB, 0.17519283E-05_JPRB, 0.17515071E-05_JPRB, 0.17511292E-05_JPRB, 0.17507894E-05_JPRB, &
  & 0.17504519E-05_JPRB, 0.17500528E-05_JPRB, 0.17495034E-05_JPRB, 0.17486675E-05_JPRB, 0.17473848E-05_JPRB, 0.17454154E-05_JPRB, &
  & 0.17426676E-05_JPRB, 0.17392024E-05_JPRB, 0.17354697E-05_JPRB, 0.17317770E-05_JPRB, 0.17283110E-05_JPRB, 0.17251010E-05_JPRB, &
  & 0.17221106E-05_JPRB, 0.17193577E-05_JPRB, 0.17169732E-05_JPRB, 0.17150790E-05_JPRB, 0.17136858E-05_JPRB, 0.17126558E-05_JPRB, &
  & 0.17118434E-05_JPRB, 0.17111063E-05_JPRB, 0.17103049E-05_JPRB, 0.17089270E-05_JPRB /)

RGHG2(:,47, 6) = (/ &
  & 0.16761550E-05_JPRB, 0.16807912E-05_JPRB, 0.16839688E-05_JPRB, 0.16881035E-05_JPRB, 0.16926754E-05_JPRB, 0.16973227E-05_JPRB, &
  & 0.17008476E-05_JPRB, 0.17036710E-05_JPRB, 0.17059779E-05_JPRB, 0.17081757E-05_JPRB, 0.17104456E-05_JPRB, 0.17130903E-05_JPRB, &
  & 0.17161967E-05_JPRB, 0.17198154E-05_JPRB, 0.17237543E-05_JPRB, 0.17278893E-05_JPRB, 0.17320350E-05_JPRB, 0.17361895E-05_JPRB, &
  & 0.17402394E-05_JPRB, 0.17441262E-05_JPRB, 0.17474952E-05_JPRB, 0.17501308E-05_JPRB, 0.17518850E-05_JPRB, 0.17529886E-05_JPRB, &
  & 0.17536812E-05_JPRB, 0.17541479E-05_JPRB, 0.17544869E-05_JPRB, 0.17547496E-05_JPRB, 0.17549569E-05_JPRB, 0.17551099E-05_JPRB, &
  & 0.17551877E-05_JPRB, 0.17551540E-05_JPRB, 0.17549806E-05_JPRB, 0.17546696E-05_JPRB, 0.17542499E-05_JPRB, 0.17537594E-05_JPRB, &
  & 0.17532368E-05_JPRB, 0.17527276E-05_JPRB, 0.17522641E-05_JPRB, 0.17518764E-05_JPRB, 0.17515642E-05_JPRB, 0.17513239E-05_JPRB, &
  & 0.17511327E-05_JPRB, 0.17509324E-05_JPRB, 0.17506489E-05_JPRB, 0.17501898E-05_JPRB, 0.17494121E-05_JPRB, 0.17481502E-05_JPRB, &
  & 0.17461870E-05_JPRB, 0.17435466E-05_JPRB, 0.17403926E-05_JPRB, 0.17371866E-05_JPRB, 0.17340999E-05_JPRB, 0.17312213E-05_JPRB, &
  & 0.17285313E-05_JPRB, 0.17260550E-05_JPRB, 0.17238864E-05_JPRB, 0.17221810E-05_JPRB, 0.17209280E-05_JPRB, 0.17200092E-05_JPRB, &
  & 0.17192772E-05_JPRB, 0.17186105E-05_JPRB, 0.17178680E-05_JPRB, 0.17165777E-05_JPRB /)

RGHG2(:,48, 6) = (/ &
  & 0.16878662E-05_JPRB, 0.16928386E-05_JPRB, 0.16965204E-05_JPRB, 0.17004922E-05_JPRB, 0.17055197E-05_JPRB, 0.17100716E-05_JPRB, &
  & 0.17136617E-05_JPRB, 0.17161959E-05_JPRB, 0.17182073E-05_JPRB, 0.17199561E-05_JPRB, 0.17217681E-05_JPRB, 0.17237998E-05_JPRB, &
  & 0.17262673E-05_JPRB, 0.17291389E-05_JPRB, 0.17322777E-05_JPRB, 0.17354439E-05_JPRB, 0.17385216E-05_JPRB, 0.17414329E-05_JPRB, &
  & 0.17441942E-05_JPRB, 0.17468321E-05_JPRB, 0.17492417E-05_JPRB, 0.17511962E-05_JPRB, 0.17525801E-05_JPRB, 0.17534718E-05_JPRB, &
  & 0.17540577E-05_JPRB, 0.17544694E-05_JPRB, 0.17547829E-05_JPRB, 0.17550360E-05_JPRB, 0.17552443E-05_JPRB, 0.17554053E-05_JPRB, &
  & 0.17554958E-05_JPRB, 0.17554764E-05_JPRB, 0.17553135E-05_JPRB, 0.17550058E-05_JPRB, 0.17545798E-05_JPRB, 0.17540756E-05_JPRB, &
  & 0.17535414E-05_JPRB, 0.17530249E-05_JPRB, 0.17525684E-05_JPRB, 0.17522024E-05_JPRB, 0.17519358E-05_JPRB, 0.17517752E-05_JPRB, &
  & 0.17516988E-05_JPRB, 0.17516568E-05_JPRB, 0.17515838E-05_JPRB, 0.17514060E-05_JPRB, 0.17510366E-05_JPRB, 0.17503403E-05_JPRB, &
  & 0.17491743E-05_JPRB, 0.17473950E-05_JPRB, 0.17451523E-05_JPRB, 0.17425793E-05_JPRB, 0.17400296E-05_JPRB, 0.17375419E-05_JPRB, &
  & 0.17351726E-05_JPRB, 0.17329344E-05_JPRB, 0.17309542E-05_JPRB, 0.17293796E-05_JPRB, 0.17282323E-05_JPRB, 0.17273886E-05_JPRB, &
  & 0.17267139E-05_JPRB, 0.17260919E-05_JPRB, 0.17253906E-05_JPRB, 0.17241530E-05_JPRB /)

RGHG2(:,49, 6) = (/ &
  & 0.17002790E-05_JPRB, 0.17057065E-05_JPRB, 0.17094715E-05_JPRB, 0.17137816E-05_JPRB, 0.17188287E-05_JPRB, 0.17236514E-05_JPRB, &
  & 0.17270438E-05_JPRB, 0.17293387E-05_JPRB, 0.17309637E-05_JPRB, 0.17323174E-05_JPRB, 0.17336079E-05_JPRB, 0.17350850E-05_JPRB, &
  & 0.17368384E-05_JPRB, 0.17389018E-05_JPRB, 0.17410749E-05_JPRB, 0.17431240E-05_JPRB, 0.17449294E-05_JPRB, 0.17464948E-05_JPRB, &
  & 0.17479670E-05_JPRB, 0.17493865E-05_JPRB, 0.17508737E-05_JPRB, 0.17521950E-05_JPRB, 0.17532109E-05_JPRB, 0.17539123E-05_JPRB, &
  & 0.17543997E-05_JPRB, 0.17547632E-05_JPRB, 0.17550549E-05_JPRB, 0.17553020E-05_JPRB, 0.17555142E-05_JPRB, 0.17556870E-05_JPRB, &
  & 0.17557943E-05_JPRB, 0.17557927E-05_JPRB, 0.17556430E-05_JPRB, 0.17553380E-05_JPRB, 0.17549044E-05_JPRB, 0.17543849E-05_JPRB, &
  & 0.17538335E-05_JPRB, 0.17533074E-05_JPRB, 0.17528498E-05_JPRB, 0.17524950E-05_JPRB, 0.17522610E-05_JPRB, 0.17521598E-05_JPRB, &
  & 0.17521772E-05_JPRB, 0.17522623E-05_JPRB, 0.17523515E-05_JPRB, 0.17523873E-05_JPRB, 0.17523134E-05_JPRB, 0.17520522E-05_JPRB, &
  & 0.17514992E-05_JPRB, 0.17505777E-05_JPRB, 0.17492345E-05_JPRB, 0.17476395E-05_JPRB, 0.17458046E-05_JPRB, 0.17439272E-05_JPRB, &
  & 0.17419883E-05_JPRB, 0.17400304E-05_JPRB, 0.17382129E-05_JPRB, 0.17367421E-05_JPRB, 0.17356513E-05_JPRB, 0.17348559E-05_JPRB, &
  & 0.17342090E-05_JPRB, 0.17336092E-05_JPRB, 0.17329181E-05_JPRB, 0.17316860E-05_JPRB /)

RGHG2(:,50, 6) = (/ &
  & 0.17131915E-05_JPRB, 0.17187077E-05_JPRB, 0.17224111E-05_JPRB, 0.17267375E-05_JPRB, 0.17317368E-05_JPRB, 0.17363010E-05_JPRB, &
  & 0.17393426E-05_JPRB, 0.17412017E-05_JPRB, 0.17424186E-05_JPRB, 0.17433377E-05_JPRB, 0.17442007E-05_JPRB, 0.17450961E-05_JPRB, &
  & 0.17461764E-05_JPRB, 0.17473703E-05_JPRB, 0.17485071E-05_JPRB, 0.17494367E-05_JPRB, 0.17501218E-05_JPRB, 0.17506485E-05_JPRB, &
  & 0.17511060E-05_JPRB, 0.17516797E-05_JPRB, 0.17523466E-05_JPRB, 0.17531272E-05_JPRB, 0.17538006E-05_JPRB, 0.17543211E-05_JPRB, &
  & 0.17547183E-05_JPRB, 0.17550378E-05_JPRB, 0.17553104E-05_JPRB, 0.17555533E-05_JPRB, 0.17557716E-05_JPRB, 0.17559585E-05_JPRB, &
  & 0.17560855E-05_JPRB, 0.17561047E-05_JPRB, 0.17559698E-05_JPRB, 0.17556682E-05_JPRB, 0.17552255E-05_JPRB, 0.17546868E-05_JPRB, &
  & 0.17541198E-05_JPRB, 0.17535776E-05_JPRB, 0.17531164E-05_JPRB, 0.17527643E-05_JPRB, 0.17525502E-05_JPRB, 0.17524947E-05_JPRB, &
  & 0.17525900E-05_JPRB, 0.17527782E-05_JPRB, 0.17529953E-05_JPRB, 0.17531880E-05_JPRB, 0.17533237E-05_JPRB, 0.17533551E-05_JPRB, &
  & 0.17532248E-05_JPRB, 0.17528778E-05_JPRB, 0.17523100E-05_JPRB, 0.17514993E-05_JPRB, 0.17505545E-05_JPRB, 0.17494272E-05_JPRB, &
  & 0.17481466E-05_JPRB, 0.17467383E-05_JPRB, 0.17452730E-05_JPRB, 0.17439984E-05_JPRB, 0.17430463E-05_JPRB, 0.17423050E-05_JPRB, &
  & 0.17417087E-05_JPRB, 0.17411169E-05_JPRB, 0.17404305E-05_JPRB, 0.17391303E-05_JPRB /)

RGHG2(:,51, 6) = (/ &
  & 0.17249524E-05_JPRB, 0.17301727E-05_JPRB, 0.17339318E-05_JPRB, 0.17376568E-05_JPRB, 0.17421569E-05_JPRB, 0.17459103E-05_JPRB, &
  & 0.17482621E-05_JPRB, 0.17495543E-05_JPRB, 0.17503561E-05_JPRB, 0.17509418E-05_JPRB, 0.17514258E-05_JPRB, 0.17519429E-05_JPRB, &
  & 0.17524721E-05_JPRB, 0.17530018E-05_JPRB, 0.17533939E-05_JPRB, 0.17535887E-05_JPRB, 0.17536261E-05_JPRB, 0.17535837E-05_JPRB, &
  & 0.17535353E-05_JPRB, 0.17535542E-05_JPRB, 0.17537182E-05_JPRB, 0.17540044E-05_JPRB, 0.17543684E-05_JPRB, 0.17547114E-05_JPRB, &
  & 0.17550198E-05_JPRB, 0.17552985E-05_JPRB, 0.17555549E-05_JPRB, 0.17557956E-05_JPRB, 0.17560214E-05_JPRB, 0.17562238E-05_JPRB, &
  & 0.17563723E-05_JPRB, 0.17564146E-05_JPRB, 0.17562958E-05_JPRB, 0.17559979E-05_JPRB, 0.17555423E-05_JPRB, 0.17549888E-05_JPRB, &
  & 0.17543971E-05_JPRB, 0.17538454E-05_JPRB, 0.17533713E-05_JPRB, 0.17530173E-05_JPRB, 0.17528149E-05_JPRB, 0.17527957E-05_JPRB, &
  & 0.17529526E-05_JPRB, 0.17532304E-05_JPRB, 0.17535438E-05_JPRB, 0.17538598E-05_JPRB, 0.17541365E-05_JPRB, 0.17543604E-05_JPRB, &
  & 0.17544810E-05_JPRB, 0.17544746E-05_JPRB, 0.17543202E-05_JPRB, 0.17540449E-05_JPRB, 0.17536436E-05_JPRB, 0.17531582E-05_JPRB, &
  & 0.17525670E-05_JPRB, 0.17518159E-05_JPRB, 0.17509917E-05_JPRB, 0.17502146E-05_JPRB, 0.17495473E-05_JPRB, 0.17490405E-05_JPRB, &
  & 0.17485565E-05_JPRB, 0.17480769E-05_JPRB, 0.17474172E-05_JPRB, 0.17461761E-05_JPRB /)

RGHG2(:,52, 6) = (/ &
  & 0.17357966E-05_JPRB, 0.17402020E-05_JPRB, 0.17428778E-05_JPRB, 0.17460309E-05_JPRB, 0.17493735E-05_JPRB, 0.17522132E-05_JPRB, &
  & 0.17537822E-05_JPRB, 0.17546331E-05_JPRB, 0.17551256E-05_JPRB, 0.17554594E-05_JPRB, 0.17557466E-05_JPRB, 0.17559880E-05_JPRB, &
  & 0.17562223E-05_JPRB, 0.17563608E-05_JPRB, 0.17563394E-05_JPRB, 0.17561641E-05_JPRB, 0.17559018E-05_JPRB, 0.17556033E-05_JPRB, &
  & 0.17553441E-05_JPRB, 0.17550819E-05_JPRB, 0.17549303E-05_JPRB, 0.17548704E-05_JPRB, 0.17549339E-05_JPRB, 0.17550944E-05_JPRB, &
  & 0.17553120E-05_JPRB, 0.17555512E-05_JPRB, 0.17557938E-05_JPRB, 0.17560340E-05_JPRB, 0.17562683E-05_JPRB, 0.17564867E-05_JPRB, &
  & 0.17566581E-05_JPRB, 0.17567245E-05_JPRB, 0.17566235E-05_JPRB, 0.17563269E-05_JPRB, 0.17558630E-05_JPRB, 0.17552843E-05_JPRB, &
  & 0.17546813E-05_JPRB, 0.17541053E-05_JPRB, 0.17536222E-05_JPRB, 0.17532594E-05_JPRB, 0.17530631E-05_JPRB, 0.17530721E-05_JPRB, &
  & 0.17532836E-05_JPRB, 0.17536245E-05_JPRB, 0.17540274E-05_JPRB, 0.17544241E-05_JPRB, 0.17548168E-05_JPRB, 0.17551531E-05_JPRB, &
  & 0.17554248E-05_JPRB, 0.17555899E-05_JPRB, 0.17556522E-05_JPRB, 0.17556198E-05_JPRB, 0.17555233E-05_JPRB, 0.17553712E-05_JPRB, &
  & 0.17551608E-05_JPRB, 0.17549009E-05_JPRB, 0.17545750E-05_JPRB, 0.17542442E-05_JPRB, 0.17539750E-05_JPRB, 0.17537126E-05_JPRB, &
  & 0.17534780E-05_JPRB, 0.17531771E-05_JPRB, 0.17527685E-05_JPRB, 0.17517320E-05_JPRB /)

RGHG2(:,53, 6) = (/ &
  & 0.17439074E-05_JPRB, 0.17473283E-05_JPRB, 0.17496384E-05_JPRB, 0.17518037E-05_JPRB, 0.17542934E-05_JPRB, 0.17561890E-05_JPRB, &
  & 0.17572467E-05_JPRB, 0.17577629E-05_JPRB, 0.17580564E-05_JPRB, 0.17582540E-05_JPRB, 0.17583916E-05_JPRB, 0.17585066E-05_JPRB, &
  & 0.17585567E-05_JPRB, 0.17584862E-05_JPRB, 0.17582526E-05_JPRB, 0.17578925E-05_JPRB, 0.17574849E-05_JPRB, 0.17571027E-05_JPRB, &
  & 0.17566923E-05_JPRB, 0.17563652E-05_JPRB, 0.17559835E-05_JPRB, 0.17557095E-05_JPRB, 0.17555099E-05_JPRB, 0.17554801E-05_JPRB, &
  & 0.17556004E-05_JPRB, 0.17558007E-05_JPRB, 0.17560313E-05_JPRB, 0.17562722E-05_JPRB, 0.17565155E-05_JPRB, 0.17567511E-05_JPRB, &
  & 0.17569457E-05_JPRB, 0.17570370E-05_JPRB, 0.17569532E-05_JPRB, 0.17566608E-05_JPRB, 0.17561822E-05_JPRB, 0.17555931E-05_JPRB, &
  & 0.17549601E-05_JPRB, 0.17543716E-05_JPRB, 0.17538680E-05_JPRB, 0.17534953E-05_JPRB, 0.17533032E-05_JPRB, 0.17533359E-05_JPRB, &
  & 0.17535849E-05_JPRB, 0.17539863E-05_JPRB, 0.17544435E-05_JPRB, 0.17549258E-05_JPRB, 0.17553812E-05_JPRB, 0.17558150E-05_JPRB, &
  & 0.17561614E-05_JPRB, 0.17564228E-05_JPRB, 0.17565876E-05_JPRB, 0.17566713E-05_JPRB, 0.17567020E-05_JPRB, 0.17566960E-05_JPRB, &
  & 0.17566631E-05_JPRB, 0.17565997E-05_JPRB, 0.17565144E-05_JPRB, 0.17564259E-05_JPRB, 0.17563357E-05_JPRB, 0.17562606E-05_JPRB, &
  & 0.17561705E-05_JPRB, 0.17560659E-05_JPRB, 0.17558752E-05_JPRB, 0.17553573E-05_JPRB /)

RGHG2(:,54, 6) = (/ &
  & 0.17507414E-05_JPRB, 0.17530431E-05_JPRB, 0.17544291E-05_JPRB, 0.17559796E-05_JPRB, 0.17576075E-05_JPRB, 0.17588789E-05_JPRB, &
  & 0.17595294E-05_JPRB, 0.17598542E-05_JPRB, 0.17600260E-05_JPRB, 0.17601275E-05_JPRB, 0.17601960E-05_JPRB, 0.17602213E-05_JPRB, &
  & 0.17601751E-05_JPRB, 0.17600000E-05_JPRB, 0.17596498E-05_JPRB, 0.17591983E-05_JPRB, 0.17587301E-05_JPRB, 0.17582535E-05_JPRB, &
  & 0.17578524E-05_JPRB, 0.17573695E-05_JPRB, 0.17569680E-05_JPRB, 0.17564751E-05_JPRB, 0.17560887E-05_JPRB, 0.17558725E-05_JPRB, &
  & 0.17558910E-05_JPRB, 0.17560517E-05_JPRB, 0.17562718E-05_JPRB, 0.17565147E-05_JPRB, 0.17567691E-05_JPRB, 0.17570210E-05_JPRB, &
  & 0.17572385E-05_JPRB, 0.17573544E-05_JPRB, 0.17572881E-05_JPRB, 0.17569984E-05_JPRB, 0.17565144E-05_JPRB, 0.17559018E-05_JPRB, &
  & 0.17552533E-05_JPRB, 0.17546367E-05_JPRB, 0.17541145E-05_JPRB, 0.17537311E-05_JPRB, 0.17535409E-05_JPRB, 0.17535926E-05_JPRB, &
  & 0.17538750E-05_JPRB, 0.17543123E-05_JPRB, 0.17548238E-05_JPRB, 0.17553508E-05_JPRB, 0.17558840E-05_JPRB, 0.17563605E-05_JPRB, &
  & 0.17567758E-05_JPRB, 0.17570846E-05_JPRB, 0.17572970E-05_JPRB, 0.17574375E-05_JPRB, 0.17575207E-05_JPRB, 0.17575730E-05_JPRB, &
  & 0.17576076E-05_JPRB, 0.17576260E-05_JPRB, 0.17576322E-05_JPRB, 0.17576331E-05_JPRB, 0.17576301E-05_JPRB, 0.17576236E-05_JPRB, &
  & 0.17576169E-05_JPRB, 0.17576106E-05_JPRB, 0.17576128E-05_JPRB, 0.17576798E-05_JPRB /)

RGHG2(:,55, 6) = (/ &
  & 0.17551017E-05_JPRB, 0.17568548E-05_JPRB, 0.17579064E-05_JPRB, 0.17589206E-05_JPRB, 0.17599712E-05_JPRB, 0.17607711E-05_JPRB, &
  & 0.17611924E-05_JPRB, 0.17613830E-05_JPRB, 0.17614790E-05_JPRB, 0.17615298E-05_JPRB, 0.17615478E-05_JPRB, 0.17615266E-05_JPRB, &
  & 0.17614366E-05_JPRB, 0.17611968E-05_JPRB, 0.17608027E-05_JPRB, 0.17603031E-05_JPRB, 0.17597772E-05_JPRB, 0.17592997E-05_JPRB, &
  & 0.17587802E-05_JPRB, 0.17583384E-05_JPRB, 0.17577571E-05_JPRB, 0.17572199E-05_JPRB, 0.17566404E-05_JPRB, 0.17562668E-05_JPRB, &
  & 0.17561891E-05_JPRB, 0.17563113E-05_JPRB, 0.17565212E-05_JPRB, 0.17567687E-05_JPRB, 0.17570326E-05_JPRB, 0.17573022E-05_JPRB, &
  & 0.17575417E-05_JPRB, 0.17576812E-05_JPRB, 0.17576310E-05_JPRB, 0.17573468E-05_JPRB, 0.17568535E-05_JPRB, 0.17562279E-05_JPRB, &
  & 0.17555529E-05_JPRB, 0.17549115E-05_JPRB, 0.17543675E-05_JPRB, 0.17539703E-05_JPRB, 0.17537855E-05_JPRB, 0.17538538E-05_JPRB, &
  & 0.17541578E-05_JPRB, 0.17546229E-05_JPRB, 0.17551667E-05_JPRB, 0.17557416E-05_JPRB, 0.17563078E-05_JPRB, 0.17568466E-05_JPRB, &
  & 0.17572925E-05_JPRB, 0.17576399E-05_JPRB, 0.17578872E-05_JPRB, 0.17580450E-05_JPRB, 0.17581538E-05_JPRB, 0.17582304E-05_JPRB, &
  & 0.17582856E-05_JPRB, 0.17583338E-05_JPRB, 0.17583698E-05_JPRB, 0.17583995E-05_JPRB, 0.17584231E-05_JPRB, 0.17584374E-05_JPRB, &
  & 0.17584490E-05_JPRB, 0.17584547E-05_JPRB, 0.17584551E-05_JPRB, 0.17584402E-05_JPRB /)

RGHG2(:,56, 6) = (/ &
  & 0.17589435E-05_JPRB, 0.17598613E-05_JPRB, 0.17604646E-05_JPRB, 0.17610778E-05_JPRB, 0.17617447E-05_JPRB, 0.17622316E-05_JPRB, &
  & 0.17624836E-05_JPRB, 0.17625977E-05_JPRB, 0.17626472E-05_JPRB, 0.17626649E-05_JPRB, 0.17626569E-05_JPRB, 0.17626148E-05_JPRB, &
  & 0.17624927E-05_JPRB, 0.17622492E-05_JPRB, 0.17618322E-05_JPRB, 0.17613143E-05_JPRB, 0.17607706E-05_JPRB, 0.17602104E-05_JPRB, &
  & 0.17597117E-05_JPRB, 0.17591123E-05_JPRB, 0.17585556E-05_JPRB, 0.17578390E-05_JPRB, 0.17571592E-05_JPRB, 0.17566608E-05_JPRB, &
  & 0.17565017E-05_JPRB, 0.17565877E-05_JPRB, 0.17567884E-05_JPRB, 0.17570388E-05_JPRB, 0.17573158E-05_JPRB, 0.17576008E-05_JPRB, &
  & 0.17578623E-05_JPRB, 0.17580231E-05_JPRB, 0.17579875E-05_JPRB, 0.17577071E-05_JPRB, 0.17572092E-05_JPRB, 0.17565678E-05_JPRB, &
  & 0.17558698E-05_JPRB, 0.17552024E-05_JPRB, 0.17546328E-05_JPRB, 0.17542261E-05_JPRB, 0.17540428E-05_JPRB, 0.17541249E-05_JPRB, &
  & 0.17544464E-05_JPRB, 0.17549319E-05_JPRB, 0.17554955E-05_JPRB, 0.17560956E-05_JPRB, 0.17566999E-05_JPRB, 0.17572629E-05_JPRB, &
  & 0.17577524E-05_JPRB, 0.17581308E-05_JPRB, 0.17583936E-05_JPRB, 0.17585744E-05_JPRB, 0.17586909E-05_JPRB, 0.17587722E-05_JPRB, &
  & 0.17588384E-05_JPRB, 0.17588894E-05_JPRB, 0.17589327E-05_JPRB, 0.17589723E-05_JPRB, 0.17589998E-05_JPRB, 0.17590232E-05_JPRB, &
  & 0.17590398E-05_JPRB, 0.17590542E-05_JPRB, 0.17590629E-05_JPRB, 0.17590633E-05_JPRB /)

RGHG2(:,57, 6) = (/ &
  & 0.17612275E-05_JPRB, 0.17619193E-05_JPRB, 0.17623208E-05_JPRB, 0.17627332E-05_JPRB, 0.17631121E-05_JPRB, 0.17634153E-05_JPRB, &
  & 0.17635680E-05_JPRB, 0.17636308E-05_JPRB, 0.17636528E-05_JPRB, 0.17636523E-05_JPRB, 0.17636319E-05_JPRB, 0.17635753E-05_JPRB, &
  & 0.17634588E-05_JPRB, 0.17632103E-05_JPRB, 0.17628149E-05_JPRB, 0.17622938E-05_JPRB, 0.17617131E-05_JPRB, 0.17611388E-05_JPRB, &
  & 0.17605121E-05_JPRB, 0.17599257E-05_JPRB, 0.17591867E-05_JPRB, 0.17584305E-05_JPRB, 0.17576283E-05_JPRB, 0.17570471E-05_JPRB, &
  & 0.17568348E-05_JPRB, 0.17568912E-05_JPRB, 0.17570819E-05_JPRB, 0.17573375E-05_JPRB, 0.17576243E-05_JPRB, 0.17579272E-05_JPRB, &
  & 0.17582086E-05_JPRB, 0.17583887E-05_JPRB, 0.17583646E-05_JPRB, 0.17580879E-05_JPRB, 0.17575833E-05_JPRB, 0.17569292E-05_JPRB, &
  & 0.17562112E-05_JPRB, 0.17555151E-05_JPRB, 0.17549261E-05_JPRB, 0.17545050E-05_JPRB, 0.17543251E-05_JPRB, 0.17544180E-05_JPRB, &
  & 0.17547509E-05_JPRB, 0.17552451E-05_JPRB, 0.17558270E-05_JPRB, 0.17564400E-05_JPRB, 0.17570617E-05_JPRB, 0.17576501E-05_JPRB, &
  & 0.17581639E-05_JPRB, 0.17585705E-05_JPRB, 0.17588635E-05_JPRB, 0.17590512E-05_JPRB, 0.17591749E-05_JPRB, 0.17592612E-05_JPRB, &
  & 0.17593225E-05_JPRB, 0.17593741E-05_JPRB, 0.17594144E-05_JPRB, 0.17594498E-05_JPRB, 0.17594807E-05_JPRB, 0.17595019E-05_JPRB, &
  & 0.17595196E-05_JPRB, 0.17595311E-05_JPRB, 0.17595346E-05_JPRB, 0.17595128E-05_JPRB /)

RGHG2(:,58, 6) = (/ &
  & 0.17630862E-05_JPRB, 0.17635145E-05_JPRB, 0.17637807E-05_JPRB, 0.17640153E-05_JPRB, 0.17642622E-05_JPRB, 0.17644336E-05_JPRB, &
  & 0.17645243E-05_JPRB, 0.17645580E-05_JPRB, 0.17645649E-05_JPRB, 0.17645563E-05_JPRB, 0.17645297E-05_JPRB, 0.17644771E-05_JPRB, &
  & 0.17643604E-05_JPRB, 0.17641430E-05_JPRB, 0.17637694E-05_JPRB, 0.17632633E-05_JPRB, 0.17626677E-05_JPRB, 0.17620107E-05_JPRB, &
  & 0.17613584E-05_JPRB, 0.17606011E-05_JPRB, 0.17598339E-05_JPRB, 0.17589296E-05_JPRB, 0.17580596E-05_JPRB, 0.17574423E-05_JPRB, &
  & 0.17571961E-05_JPRB, 0.17572304E-05_JPRB, 0.17574141E-05_JPRB, 0.17576726E-05_JPRB, 0.17579728E-05_JPRB, 0.17582904E-05_JPRB, &
  & 0.17585913E-05_JPRB, 0.17587882E-05_JPRB, 0.17587730E-05_JPRB, 0.17584957E-05_JPRB, 0.17579848E-05_JPRB, 0.17573187E-05_JPRB, &
  & 0.17565808E-05_JPRB, 0.17558663E-05_JPRB, 0.17552525E-05_JPRB, 0.17548232E-05_JPRB, 0.17546414E-05_JPRB, 0.17547401E-05_JPRB, &
  & 0.17550785E-05_JPRB, 0.17555827E-05_JPRB, 0.17561667E-05_JPRB, 0.17567932E-05_JPRB, 0.17574207E-05_JPRB, 0.17580201E-05_JPRB, &
  & 0.17585526E-05_JPRB, 0.17589854E-05_JPRB, 0.17592982E-05_JPRB, 0.17595066E-05_JPRB, 0.17596368E-05_JPRB, 0.17597192E-05_JPRB, &
  & 0.17597790E-05_JPRB, 0.17598215E-05_JPRB, 0.17598541E-05_JPRB, 0.17598882E-05_JPRB, 0.17599143E-05_JPRB, 0.17599364E-05_JPRB, &
  & 0.17599516E-05_JPRB, 0.17599612E-05_JPRB, 0.17599600E-05_JPRB, 0.17599284E-05_JPRB /)

RGHG2(:,59, 6) = (/ &
  & 0.17644015E-05_JPRB, 0.17647524E-05_JPRB, 0.17649340E-05_JPRB, 0.17651003E-05_JPRB, 0.17652401E-05_JPRB, 0.17653507E-05_JPRB, &
  & 0.17654041E-05_JPRB, 0.17654231E-05_JPRB, 0.17654236E-05_JPRB, 0.17654122E-05_JPRB, 0.17653883E-05_JPRB, 0.17653375E-05_JPRB, &
  & 0.17652410E-05_JPRB, 0.17650439E-05_JPRB, 0.17647128E-05_JPRB, 0.17642260E-05_JPRB, 0.17636082E-05_JPRB, 0.17629075E-05_JPRB, &
  & 0.17621218E-05_JPRB, 0.17613136E-05_JPRB, 0.17603777E-05_JPRB, 0.17594067E-05_JPRB, 0.17584923E-05_JPRB, 0.17578561E-05_JPRB, &
  & 0.17575951E-05_JPRB, 0.17576147E-05_JPRB, 0.17577936E-05_JPRB, 0.17580587E-05_JPRB, 0.17583695E-05_JPRB, 0.17587038E-05_JPRB, &
  & 0.17590213E-05_JPRB, 0.17592320E-05_JPRB, 0.17592228E-05_JPRB, 0.17589417E-05_JPRB, 0.17584209E-05_JPRB, 0.17577438E-05_JPRB, &
  & 0.17569935E-05_JPRB, 0.17562579E-05_JPRB, 0.17556316E-05_JPRB, 0.17551879E-05_JPRB, 0.17550046E-05_JPRB, 0.17551039E-05_JPRB, &
  & 0.17554444E-05_JPRB, 0.17559444E-05_JPRB, 0.17565371E-05_JPRB, 0.17571614E-05_JPRB, 0.17577955E-05_JPRB, 0.17583972E-05_JPRB, &
  & 0.17589382E-05_JPRB, 0.17593886E-05_JPRB, 0.17597247E-05_JPRB, 0.17599505E-05_JPRB, 0.17600876E-05_JPRB, 0.17601708E-05_JPRB, &
  & 0.17602208E-05_JPRB, 0.17602528E-05_JPRB, 0.17602756E-05_JPRB, 0.17603039E-05_JPRB, 0.17603306E-05_JPRB, 0.17603504E-05_JPRB, &
  & 0.17603649E-05_JPRB, 0.17603707E-05_JPRB, 0.17603621E-05_JPRB, 0.17603135E-05_JPRB /)

RGHG2(:,60, 6) = (/ &
  & 0.17655533E-05_JPRB, 0.17658003E-05_JPRB, 0.17659318E-05_JPRB, 0.17660362E-05_JPRB, 0.17661343E-05_JPRB, 0.17662021E-05_JPRB, &
  & 0.17662394E-05_JPRB, 0.17662519E-05_JPRB, 0.17662518E-05_JPRB, 0.17662434E-05_JPRB, 0.17662228E-05_JPRB, 0.17661839E-05_JPRB, &
  & 0.17660984E-05_JPRB, 0.17659345E-05_JPRB, 0.17656344E-05_JPRB, 0.17651723E-05_JPRB, 0.17645427E-05_JPRB, 0.17637678E-05_JPRB, &
  & 0.17629095E-05_JPRB, 0.17619481E-05_JPRB, 0.17609393E-05_JPRB, 0.17598861E-05_JPRB, 0.17589449E-05_JPRB, 0.17583113E-05_JPRB, &
  & 0.17580394E-05_JPRB, 0.17580504E-05_JPRB, 0.17582297E-05_JPRB, 0.17585020E-05_JPRB, 0.17588259E-05_JPRB, 0.17591752E-05_JPRB, &
  & 0.17595088E-05_JPRB, 0.17597307E-05_JPRB, 0.17597226E-05_JPRB, 0.17594334E-05_JPRB, 0.17589025E-05_JPRB, 0.17582173E-05_JPRB, &
  & 0.17574546E-05_JPRB, 0.17567113E-05_JPRB, 0.17560674E-05_JPRB, 0.17556169E-05_JPRB, 0.17554261E-05_JPRB, 0.17555210E-05_JPRB, &
  & 0.17558534E-05_JPRB, 0.17563541E-05_JPRB, 0.17569362E-05_JPRB, 0.17575646E-05_JPRB, 0.17581941E-05_JPRB, 0.17587972E-05_JPRB, &
  & 0.17593431E-05_JPRB, 0.17598015E-05_JPRB, 0.17601540E-05_JPRB, 0.17603966E-05_JPRB, 0.17605444E-05_JPRB, 0.17606247E-05_JPRB, &
  & 0.17606657E-05_JPRB, 0.17606819E-05_JPRB, 0.17606907E-05_JPRB, 0.17607179E-05_JPRB, 0.17607441E-05_JPRB, 0.17607656E-05_JPRB, &
  & 0.17607788E-05_JPRB, 0.17607807E-05_JPRB, 0.17607632E-05_JPRB, 0.17606880E-05_JPRB /)

RGHG2(:,61, 6) = (/ &
  & 0.17664943E-05_JPRB, 0.17667065E-05_JPRB, 0.17668101E-05_JPRB, 0.17668926E-05_JPRB, 0.17669606E-05_JPRB, 0.17670138E-05_JPRB, &
  & 0.17670432E-05_JPRB, 0.17670568E-05_JPRB, 0.17670604E-05_JPRB, 0.17670568E-05_JPRB, 0.17670450E-05_JPRB, 0.17670144E-05_JPRB, &
  & 0.17669493E-05_JPRB, 0.17668051E-05_JPRB, 0.17665371E-05_JPRB, 0.17660923E-05_JPRB, 0.17654464E-05_JPRB, 0.17646186E-05_JPRB, &
  & 0.17636560E-05_JPRB, 0.17626159E-05_JPRB, 0.17615062E-05_JPRB, 0.17604054E-05_JPRB, 0.17594564E-05_JPRB, 0.17588159E-05_JPRB, &
  & 0.17585381E-05_JPRB, 0.17585460E-05_JPRB, 0.17587297E-05_JPRB, 0.17590132E-05_JPRB, 0.17593516E-05_JPRB, 0.17597173E-05_JPRB, &
  & 0.17600648E-05_JPRB, 0.17602940E-05_JPRB, 0.17602829E-05_JPRB, 0.17599828E-05_JPRB, 0.17594409E-05_JPRB, 0.17587483E-05_JPRB, &
  & 0.17579837E-05_JPRB, 0.17572303E-05_JPRB, 0.17565825E-05_JPRB, 0.17561191E-05_JPRB, 0.17559204E-05_JPRB, 0.17560048E-05_JPRB, &
  & 0.17563287E-05_JPRB, 0.17568110E-05_JPRB, 0.17573909E-05_JPRB, 0.17580054E-05_JPRB, 0.17586315E-05_JPRB, 0.17592312E-05_JPRB, &
  & 0.17597789E-05_JPRB, 0.17602441E-05_JPRB, 0.17606052E-05_JPRB, 0.17608604E-05_JPRB, 0.17610190E-05_JPRB, 0.17610978E-05_JPRB, &
  & 0.17611271E-05_JPRB, 0.17611231E-05_JPRB, 0.17611135E-05_JPRB, 0.17611395E-05_JPRB, 0.17611719E-05_JPRB, 0.17611967E-05_JPRB, &
  & 0.17612106E-05_JPRB, 0.17612066E-05_JPRB, 0.17611721E-05_JPRB, 0.17610530E-05_JPRB /)

RGHG2(:,62, 6) = (/ &
  & 0.17673639E-05_JPRB, 0.17675402E-05_JPRB, 0.17676261E-05_JPRB, 0.17676929E-05_JPRB, 0.17677519E-05_JPRB, 0.17677971E-05_JPRB, &
  & 0.17678281E-05_JPRB, 0.17678449E-05_JPRB, 0.17678547E-05_JPRB, 0.17678584E-05_JPRB, 0.17678551E-05_JPRB, 0.17678385E-05_JPRB, &
  & 0.17677871E-05_JPRB, 0.17676682E-05_JPRB, 0.17674179E-05_JPRB, 0.17669831E-05_JPRB, 0.17663220E-05_JPRB, 0.17654422E-05_JPRB, &
  & 0.17644163E-05_JPRB, 0.17632942E-05_JPRB, 0.17621267E-05_JPRB, 0.17609915E-05_JPRB, 0.17600269E-05_JPRB, 0.17593843E-05_JPRB, &
  & 0.17591017E-05_JPRB, 0.17591107E-05_JPRB, 0.17593040E-05_JPRB, 0.17596035E-05_JPRB, 0.17599601E-05_JPRB, 0.17603435E-05_JPRB, &
  & 0.17607031E-05_JPRB, 0.17609360E-05_JPRB, 0.17609174E-05_JPRB, 0.17606039E-05_JPRB, 0.17600506E-05_JPRB, 0.17593559E-05_JPRB, &
  & 0.17585910E-05_JPRB, 0.17578382E-05_JPRB, 0.17571826E-05_JPRB, 0.17567145E-05_JPRB, 0.17565025E-05_JPRB, 0.17565726E-05_JPRB, &
  & 0.17568761E-05_JPRB, 0.17573449E-05_JPRB, 0.17579014E-05_JPRB, 0.17585061E-05_JPRB, 0.17591173E-05_JPRB, 0.17597102E-05_JPRB, &
  & 0.17602580E-05_JPRB, 0.17607265E-05_JPRB, 0.17610937E-05_JPRB, 0.17613589E-05_JPRB, 0.17615228E-05_JPRB, 0.17616019E-05_JPRB, &
  & 0.17616192E-05_JPRB, 0.17615915E-05_JPRB, 0.17615572E-05_JPRB, 0.17615869E-05_JPRB, 0.17616273E-05_JPRB, 0.17616607E-05_JPRB, &
  & 0.17616760E-05_JPRB, 0.17616633E-05_JPRB, 0.17616031E-05_JPRB, 0.17614078E-05_JPRB /)

RGHG2(:,63, 6) = (/ &
  & 0.17681361E-05_JPRB, 0.17683071E-05_JPRB, 0.17683913E-05_JPRB, 0.17684565E-05_JPRB, 0.17685131E-05_JPRB, 0.17685613E-05_JPRB, &
  & 0.17685963E-05_JPRB, 0.17686216E-05_JPRB, 0.17686393E-05_JPRB, 0.17686534E-05_JPRB, 0.17686616E-05_JPRB, 0.17686589E-05_JPRB, &
  & 0.17686265E-05_JPRB, 0.17685211E-05_JPRB, 0.17682834E-05_JPRB, 0.17678483E-05_JPRB, 0.17671681E-05_JPRB, 0.17662599E-05_JPRB, &
  & 0.17651887E-05_JPRB, 0.17640180E-05_JPRB, 0.17628059E-05_JPRB, 0.17616413E-05_JPRB, 0.17606703E-05_JPRB, 0.17600248E-05_JPRB, &
  & 0.17597429E-05_JPRB, 0.17597589E-05_JPRB, 0.17599674E-05_JPRB, 0.17602863E-05_JPRB, 0.17606642E-05_JPRB, 0.17610651E-05_JPRB, &
  & 0.17614374E-05_JPRB, 0.17616695E-05_JPRB, 0.17616387E-05_JPRB, 0.17613092E-05_JPRB, 0.17607483E-05_JPRB, 0.17600545E-05_JPRB, &
  & 0.17592977E-05_JPRB, 0.17585456E-05_JPRB, 0.17578923E-05_JPRB, 0.17574143E-05_JPRB, 0.17571888E-05_JPRB, 0.17572380E-05_JPRB, &
  & 0.17575201E-05_JPRB, 0.17579591E-05_JPRB, 0.17584965E-05_JPRB, 0.17590753E-05_JPRB, 0.17596687E-05_JPRB, 0.17602486E-05_JPRB, &
  & 0.17607919E-05_JPRB, 0.17612618E-05_JPRB, 0.17616336E-05_JPRB, 0.17619041E-05_JPRB, 0.17620736E-05_JPRB, 0.17621496E-05_JPRB, &
  & 0.17621564E-05_JPRB, 0.17621062E-05_JPRB, 0.17620415E-05_JPRB, 0.17620723E-05_JPRB, 0.17621268E-05_JPRB, 0.17621709E-05_JPRB, &
  & 0.17621896E-05_JPRB, 0.17621655E-05_JPRB, 0.17620678E-05_JPRB, 0.17617782E-05_JPRB /)

RGHG2(:,64, 6) = (/ &
  & 0.17688543E-05_JPRB, 0.17690302E-05_JPRB, 0.17691174E-05_JPRB, 0.17691860E-05_JPRB, 0.17692477E-05_JPRB, 0.17693014E-05_JPRB, &
  & 0.17693460E-05_JPRB, 0.17693806E-05_JPRB, 0.17694109E-05_JPRB, 0.17694367E-05_JPRB, 0.17694613E-05_JPRB, 0.17694769E-05_JPRB, &
  & 0.17694625E-05_JPRB, 0.17693729E-05_JPRB, 0.17691411E-05_JPRB, 0.17686968E-05_JPRB, 0.17680095E-05_JPRB, 0.17670786E-05_JPRB, &
  & 0.17659828E-05_JPRB, 0.17647795E-05_JPRB, 0.17635377E-05_JPRB, 0.17623571E-05_JPRB, 0.17613845E-05_JPRB, 0.17607445E-05_JPRB, &
  & 0.17604698E-05_JPRB, 0.17604984E-05_JPRB, 0.17607258E-05_JPRB, 0.17610671E-05_JPRB, 0.17614645E-05_JPRB, 0.17618818E-05_JPRB, &
  & 0.17622614E-05_JPRB, 0.17624901E-05_JPRB, 0.17624460E-05_JPRB, 0.17621003E-05_JPRB, 0.17615336E-05_JPRB, 0.17608478E-05_JPRB, &
  & 0.17601035E-05_JPRB, 0.17593620E-05_JPRB, 0.17587104E-05_JPRB, 0.17582272E-05_JPRB, 0.17579860E-05_JPRB, 0.17580122E-05_JPRB, &
  & 0.17582638E-05_JPRB, 0.17586740E-05_JPRB, 0.17591755E-05_JPRB, 0.17597280E-05_JPRB, 0.17602936E-05_JPRB, 0.17608556E-05_JPRB, &
  & 0.17613894E-05_JPRB, 0.17618577E-05_JPRB, 0.17622320E-05_JPRB, 0.17625064E-05_JPRB, 0.17626783E-05_JPRB, 0.17627511E-05_JPRB, &
  & 0.17627481E-05_JPRB, 0.17626749E-05_JPRB, 0.17625841E-05_JPRB, 0.17626138E-05_JPRB, 0.17626777E-05_JPRB, 0.17627343E-05_JPRB, &
  & 0.17627566E-05_JPRB, 0.17627196E-05_JPRB, 0.17625875E-05_JPRB, 0.17621853E-05_JPRB /)

RGHG2(:,65, 6) = (/ &
  & 0.17695186E-05_JPRB, 0.17697120E-05_JPRB, 0.17698098E-05_JPRB, 0.17698874E-05_JPRB, 0.17699570E-05_JPRB, 0.17700202E-05_JPRB, &
  & 0.17700743E-05_JPRB, 0.17701220E-05_JPRB, 0.17701644E-05_JPRB, 0.17702085E-05_JPRB, 0.17702505E-05_JPRB, 0.17702894E-05_JPRB, &
  & 0.17702940E-05_JPRB, 0.17702118E-05_JPRB, 0.17699699E-05_JPRB, 0.17695247E-05_JPRB, 0.17688283E-05_JPRB, 0.17679030E-05_JPRB, &
  & 0.17667982E-05_JPRB, 0.17655782E-05_JPRB, 0.17643216E-05_JPRB, 0.17631398E-05_JPRB, 0.17621742E-05_JPRB, 0.17615500E-05_JPRB, &
  & 0.17612888E-05_JPRB, 0.17613338E-05_JPRB, 0.17615810E-05_JPRB, 0.17619410E-05_JPRB, 0.17623549E-05_JPRB, 0.17627799E-05_JPRB, &
  & 0.17631611E-05_JPRB, 0.17633811E-05_JPRB, 0.17633222E-05_JPRB, 0.17629650E-05_JPRB, 0.17623976E-05_JPRB, 0.17617260E-05_JPRB, &
  & 0.17610032E-05_JPRB, 0.17602794E-05_JPRB, 0.17596363E-05_JPRB, 0.17591499E-05_JPRB, 0.17588949E-05_JPRB, 0.17588966E-05_JPRB, &
  & 0.17591171E-05_JPRB, 0.17594883E-05_JPRB, 0.17599546E-05_JPRB, 0.17604684E-05_JPRB, 0.17610029E-05_JPRB, 0.17615405E-05_JPRB, &
  & 0.17620612E-05_JPRB, 0.17625235E-05_JPRB, 0.17628980E-05_JPRB, 0.17631739E-05_JPRB, 0.17633472E-05_JPRB, 0.17634162E-05_JPRB, &
  & 0.17634022E-05_JPRB, 0.17633099E-05_JPRB, 0.17631963E-05_JPRB, 0.17632221E-05_JPRB, 0.17632932E-05_JPRB, 0.17633579E-05_JPRB, &
  & 0.17633837E-05_JPRB, 0.17633386E-05_JPRB, 0.17631666E-05_JPRB, 0.17626821E-05_JPRB /)

RGHG2(:,66, 6) = (/ &
  & 0.17701395E-05_JPRB, 0.17703603E-05_JPRB, 0.17704735E-05_JPRB, 0.17705643E-05_JPRB, 0.17706457E-05_JPRB, 0.17707201E-05_JPRB, &
  & 0.17707862E-05_JPRB, 0.17708461E-05_JPRB, 0.17709056E-05_JPRB, 0.17709652E-05_JPRB, 0.17710322E-05_JPRB, 0.17710929E-05_JPRB, &
  & 0.17711142E-05_JPRB, 0.17710349E-05_JPRB, 0.17707971E-05_JPRB, 0.17703469E-05_JPRB, 0.17696619E-05_JPRB, 0.17687375E-05_JPRB, &
  & 0.17676346E-05_JPRB, 0.17664141E-05_JPRB, 0.17651626E-05_JPRB, 0.17639900E-05_JPRB, 0.17630489E-05_JPRB, 0.17624444E-05_JPRB, &
  & 0.17622031E-05_JPRB, 0.17622642E-05_JPRB, 0.17625258E-05_JPRB, 0.17628988E-05_JPRB, 0.17633170E-05_JPRB, 0.17637419E-05_JPRB, &
  & 0.17641148E-05_JPRB, 0.17643208E-05_JPRB, 0.17642484E-05_JPRB, 0.17638840E-05_JPRB, 0.17633243E-05_JPRB, 0.17626735E-05_JPRB, &
  & 0.17619802E-05_JPRB, 0.17612838E-05_JPRB, 0.17606563E-05_JPRB, 0.17601747E-05_JPRB, 0.17599089E-05_JPRB, 0.17598886E-05_JPRB, &
  & 0.17600760E-05_JPRB, 0.17604086E-05_JPRB, 0.17608320E-05_JPRB, 0.17613070E-05_JPRB, 0.17618017E-05_JPRB, 0.17623129E-05_JPRB, &
  & 0.17628143E-05_JPRB, 0.17632686E-05_JPRB, 0.17636390E-05_JPRB, 0.17639145E-05_JPRB, 0.17640880E-05_JPRB, 0.17641523E-05_JPRB, &
  & 0.17641285E-05_JPRB, 0.17640184E-05_JPRB, 0.17638862E-05_JPRB, 0.17639076E-05_JPRB, 0.17639820E-05_JPRB, 0.17640526E-05_JPRB, &
  & 0.17640804E-05_JPRB, 0.17640260E-05_JPRB, 0.17638353E-05_JPRB, 0.17632576E-05_JPRB /)

RGHG2(:,67, 6) = (/ &
  & 0.17707226E-05_JPRB, 0.17709805E-05_JPRB, 0.17711152E-05_JPRB, 0.17712225E-05_JPRB, 0.17713206E-05_JPRB, 0.17714074E-05_JPRB, &
  & 0.17714877E-05_JPRB, 0.17715611E-05_JPRB, 0.17716359E-05_JPRB, 0.17717169E-05_JPRB, 0.17718027E-05_JPRB, 0.17718839E-05_JPRB, &
  & 0.17719113E-05_JPRB, 0.17718322E-05_JPRB, 0.17715880E-05_JPRB, 0.17711485E-05_JPRB, 0.17704756E-05_JPRB, 0.17695752E-05_JPRB, &
  & 0.17684915E-05_JPRB, 0.17672896E-05_JPRB, 0.17660575E-05_JPRB, 0.17649176E-05_JPRB, 0.17640045E-05_JPRB, 0.17634304E-05_JPRB, &
  & 0.17632090E-05_JPRB, 0.17632823E-05_JPRB, 0.17635509E-05_JPRB, 0.17639246E-05_JPRB, 0.17643370E-05_JPRB, 0.17647501E-05_JPRB, &
  & 0.17651068E-05_JPRB, 0.17652962E-05_JPRB, 0.17652111E-05_JPRB, 0.17648463E-05_JPRB, 0.17643005E-05_JPRB, 0.17636785E-05_JPRB, &
  & 0.17630202E-05_JPRB, 0.17623605E-05_JPRB, 0.17617566E-05_JPRB, 0.17612853E-05_JPRB, 0.17610172E-05_JPRB, 0.17609786E-05_JPRB, &
  & 0.17611369E-05_JPRB, 0.17614300E-05_JPRB, 0.17618111E-05_JPRB, 0.17622421E-05_JPRB, 0.17626991E-05_JPRB, 0.17631760E-05_JPRB, &
  & 0.17636597E-05_JPRB, 0.17641006E-05_JPRB, 0.17644647E-05_JPRB, 0.17647369E-05_JPRB, 0.17649078E-05_JPRB, 0.17649675E-05_JPRB, &
  & 0.17649340E-05_JPRB, 0.17648083E-05_JPRB, 0.17646601E-05_JPRB, 0.17646767E-05_JPRB, 0.17647533E-05_JPRB, 0.17648268E-05_JPRB, &
  & 0.17648567E-05_JPRB, 0.17647993E-05_JPRB, 0.17645741E-05_JPRB, 0.17639263E-05_JPRB /)

RGHG2(:,68, 6) = (/ &
  & 0.17712457E-05_JPRB, 0.17715702E-05_JPRB, 0.17717349E-05_JPRB, 0.17718691E-05_JPRB, 0.17719844E-05_JPRB, 0.17720918E-05_JPRB, &
  & 0.17721810E-05_JPRB, 0.17722732E-05_JPRB, 0.17723612E-05_JPRB, 0.17724617E-05_JPRB, 0.17725639E-05_JPRB, 0.17726546E-05_JPRB, &
  & 0.17726823E-05_JPRB, 0.17726032E-05_JPRB, 0.17723673E-05_JPRB, 0.17719410E-05_JPRB, 0.17712925E-05_JPRB, 0.17704203E-05_JPRB, &
  & 0.17693701E-05_JPRB, 0.17682040E-05_JPRB, 0.17670137E-05_JPRB, 0.17659145E-05_JPRB, 0.17650459E-05_JPRB, 0.17645000E-05_JPRB, &
  & 0.17642968E-05_JPRB, 0.17643761E-05_JPRB, 0.17646418E-05_JPRB, 0.17650048E-05_JPRB, 0.17654011E-05_JPRB, 0.17657942E-05_JPRB, &
  & 0.17661298E-05_JPRB, 0.17663011E-05_JPRB, 0.17662064E-05_JPRB, 0.17658462E-05_JPRB, 0.17653222E-05_JPRB, 0.17647324E-05_JPRB, &
  & 0.17641158E-05_JPRB, 0.17634969E-05_JPRB, 0.17629245E-05_JPRB, 0.17624728E-05_JPRB, 0.17622067E-05_JPRB, 0.17621572E-05_JPRB, &
  & 0.17622904E-05_JPRB, 0.17625467E-05_JPRB, 0.17628859E-05_JPRB, 0.17632765E-05_JPRB, 0.17636899E-05_JPRB, 0.17641386E-05_JPRB, &
  & 0.17645972E-05_JPRB, 0.17650244E-05_JPRB, 0.17653782E-05_JPRB, 0.17656450E-05_JPRB, 0.17658119E-05_JPRB, 0.17658665E-05_JPRB, &
  & 0.17658240E-05_JPRB, 0.17656848E-05_JPRB, 0.17655242E-05_JPRB, 0.17655367E-05_JPRB, 0.17656130E-05_JPRB, 0.17656897E-05_JPRB, &
  & 0.17657226E-05_JPRB, 0.17656640E-05_JPRB, 0.17654318E-05_JPRB, 0.17647192E-05_JPRB /)

RGHG2(:,69, 6) = (/ &
  & 0.17717430E-05_JPRB, 0.17721457E-05_JPRB, 0.17723539E-05_JPRB, 0.17725126E-05_JPRB, 0.17726561E-05_JPRB, 0.17727725E-05_JPRB, &
  & 0.17728844E-05_JPRB, 0.17729794E-05_JPRB, 0.17730920E-05_JPRB, 0.17731987E-05_JPRB, 0.17733124E-05_JPRB, 0.17734026E-05_JPRB, &
  & 0.17734284E-05_JPRB, 0.17733507E-05_JPRB, 0.17731211E-05_JPRB, 0.17727142E-05_JPRB, 0.17720982E-05_JPRB, 0.17712699E-05_JPRB, &
  & 0.17702698E-05_JPRB, 0.17691585E-05_JPRB, 0.17680263E-05_JPRB, 0.17669864E-05_JPRB, 0.17661628E-05_JPRB, 0.17656491E-05_JPRB, &
  & 0.17654583E-05_JPRB, 0.17655354E-05_JPRB, 0.17657887E-05_JPRB, 0.17661330E-05_JPRB, 0.17665049E-05_JPRB, 0.17668739E-05_JPRB, &
  & 0.17671837E-05_JPRB, 0.17673379E-05_JPRB, 0.17672364E-05_JPRB, 0.17668870E-05_JPRB, 0.17663889E-05_JPRB, 0.17658383E-05_JPRB, &
  & 0.17652663E-05_JPRB, 0.17646934E-05_JPRB, 0.17641577E-05_JPRB, 0.17637300E-05_JPRB, 0.17634741E-05_JPRB, 0.17634189E-05_JPRB, &
  & 0.17635333E-05_JPRB, 0.17637569E-05_JPRB, 0.17640582E-05_JPRB, 0.17644073E-05_JPRB, 0.17647834E-05_JPRB, 0.17651977E-05_JPRB, &
  & 0.17656353E-05_JPRB, 0.17660436E-05_JPRB, 0.17663851E-05_JPRB, 0.17666440E-05_JPRB, 0.17668045E-05_JPRB, 0.17668538E-05_JPRB, &
  & 0.17668035E-05_JPRB, 0.17666546E-05_JPRB, 0.17664861E-05_JPRB, 0.17664958E-05_JPRB, 0.17665714E-05_JPRB, 0.17666507E-05_JPRB, &
  & 0.17666872E-05_JPRB, 0.17666333E-05_JPRB, 0.17663871E-05_JPRB, 0.17656203E-05_JPRB /)

RGHG2(:,70, 6) = (/ &
  & 0.17722307E-05_JPRB, 0.17727305E-05_JPRB, 0.17729811E-05_JPRB, 0.17731742E-05_JPRB, 0.17733332E-05_JPRB, 0.17734717E-05_JPRB, &
  & 0.17735846E-05_JPRB, 0.17737038E-05_JPRB, 0.17738145E-05_JPRB, 0.17739366E-05_JPRB, 0.17740443E-05_JPRB, 0.17741329E-05_JPRB, &
  & 0.17741554E-05_JPRB, 0.17740806E-05_JPRB, 0.17738643E-05_JPRB, 0.17734810E-05_JPRB, 0.17729028E-05_JPRB, 0.17721286E-05_JPRB, &
  & 0.17711932E-05_JPRB, 0.17701551E-05_JPRB, 0.17690951E-05_JPRB, 0.17681223E-05_JPRB, 0.17673533E-05_JPRB, 0.17668671E-05_JPRB, &
  & 0.17666848E-05_JPRB, 0.17667526E-05_JPRB, 0.17669861E-05_JPRB, 0.17673037E-05_JPRB, 0.17676467E-05_JPRB, 0.17679857E-05_JPRB, &
  & 0.17682681E-05_JPRB, 0.17684051E-05_JPRB, 0.17683008E-05_JPRB, 0.17679663E-05_JPRB, 0.17675001E-05_JPRB, 0.17669911E-05_JPRB, &
  & 0.17664678E-05_JPRB, 0.17659437E-05_JPRB, 0.17654502E-05_JPRB, 0.17650539E-05_JPRB, 0.17648135E-05_JPRB, 0.17647603E-05_JPRB, &
  & 0.17648599E-05_JPRB, 0.17650576E-05_JPRB, 0.17653226E-05_JPRB, 0.17656356E-05_JPRB, 0.17659715E-05_JPRB, 0.17663560E-05_JPRB, &
  & 0.17667675E-05_JPRB, 0.17671560E-05_JPRB, 0.17674826E-05_JPRB, 0.17677307E-05_JPRB, 0.17678848E-05_JPRB, 0.17679292E-05_JPRB, &
  & 0.17678741E-05_JPRB, 0.17677212E-05_JPRB, 0.17675516E-05_JPRB, 0.17675600E-05_JPRB, 0.17676348E-05_JPRB, 0.17677171E-05_JPRB, &
  & 0.17677601E-05_JPRB, 0.17677148E-05_JPRB, 0.17674745E-05_JPRB, 0.17666697E-05_JPRB /)

RGHG2(:,71, 6) = (/ &
  & 0.17727266E-05_JPRB, 0.17733481E-05_JPRB, 0.17736388E-05_JPRB, 0.17738607E-05_JPRB, 0.17740351E-05_JPRB, 0.17741829E-05_JPRB, &
  & 0.17743081E-05_JPRB, 0.17744267E-05_JPRB, 0.17745535E-05_JPRB, 0.17746629E-05_JPRB, 0.17747716E-05_JPRB, 0.17748506E-05_JPRB, &
  & 0.17748694E-05_JPRB, 0.17747943E-05_JPRB, 0.17745881E-05_JPRB, 0.17742348E-05_JPRB, 0.17737037E-05_JPRB, 0.17729930E-05_JPRB, &
  & 0.17721336E-05_JPRB, 0.17711810E-05_JPRB, 0.17702082E-05_JPRB, 0.17693144E-05_JPRB, 0.17686012E-05_JPRB, 0.17681471E-05_JPRB, &
  & 0.17679685E-05_JPRB, 0.17680215E-05_JPRB, 0.17682288E-05_JPRB, 0.17685143E-05_JPRB, 0.17688227E-05_JPRB, 0.17691302E-05_JPRB, &
  & 0.17693833E-05_JPRB, 0.17695030E-05_JPRB, 0.17693978E-05_JPRB, 0.17690834E-05_JPRB, 0.17686527E-05_JPRB, 0.17681889E-05_JPRB, &
  & 0.17677165E-05_JPRB, 0.17672459E-05_JPRB, 0.17667986E-05_JPRB, 0.17664386E-05_JPRB, 0.17662203E-05_JPRB, 0.17661732E-05_JPRB, &
  & 0.17662655E-05_JPRB, 0.17664383E-05_JPRB, 0.17666739E-05_JPRB, 0.17669495E-05_JPRB, 0.17672494E-05_JPRB, 0.17676019E-05_JPRB, &
  & 0.17679862E-05_JPRB, 0.17683524E-05_JPRB, 0.17686604E-05_JPRB, 0.17688967E-05_JPRB, 0.17690433E-05_JPRB, 0.17690860E-05_JPRB, &
  & 0.17690301E-05_JPRB, 0.17688809E-05_JPRB, 0.17687205E-05_JPRB, 0.17687298E-05_JPRB, 0.17688029E-05_JPRB, 0.17688873E-05_JPRB, &
  & 0.17689378E-05_JPRB, 0.17689114E-05_JPRB, 0.17687006E-05_JPRB, 0.17679563E-05_JPRB /)

RGHG2(:,72, 6) = (/ &
  & 0.17732774E-05_JPRB, 0.17739934E-05_JPRB, 0.17743514E-05_JPRB, 0.17745815E-05_JPRB, 0.17747735E-05_JPRB, 0.17749178E-05_JPRB, &
  & 0.17750501E-05_JPRB, 0.17751748E-05_JPRB, 0.17752884E-05_JPRB, 0.17754053E-05_JPRB, 0.17754917E-05_JPRB, 0.17755667E-05_JPRB, &
  & 0.17755789E-05_JPRB, 0.17755049E-05_JPRB, 0.17753135E-05_JPRB, 0.17749850E-05_JPRB, 0.17745031E-05_JPRB, 0.17738638E-05_JPRB, &
  & 0.17730894E-05_JPRB, 0.17722327E-05_JPRB, 0.17713556E-05_JPRB, 0.17705478E-05_JPRB, 0.17698991E-05_JPRB, 0.17694769E-05_JPRB, &
  & 0.17693025E-05_JPRB, 0.17693369E-05_JPRB, 0.17695138E-05_JPRB, 0.17697616E-05_JPRB, 0.17700323E-05_JPRB, 0.17703042E-05_JPRB, &
  & 0.17705252E-05_JPRB, 0.17706283E-05_JPRB, 0.17705244E-05_JPRB, 0.17702334E-05_JPRB, 0.17698430E-05_JPRB, 0.17694274E-05_JPRB, &
  & 0.17690076E-05_JPRB, 0.17685926E-05_JPRB, 0.17681969E-05_JPRB, 0.17678776E-05_JPRB, 0.17676864E-05_JPRB, 0.17676497E-05_JPRB, &
  & 0.17677345E-05_JPRB, 0.17678904E-05_JPRB, 0.17680954E-05_JPRB, 0.17683378E-05_JPRB, 0.17686007E-05_JPRB, 0.17689212E-05_JPRB, &
  & 0.17692745E-05_JPRB, 0.17696134E-05_JPRB, 0.17698999E-05_JPRB, 0.17701225E-05_JPRB, 0.17702631E-05_JPRB, 0.17703068E-05_JPRB, &
  & 0.17702571E-05_JPRB, 0.17701201E-05_JPRB, 0.17699797E-05_JPRB, 0.17699925E-05_JPRB, 0.17700636E-05_JPRB, 0.17701459E-05_JPRB, &
  & 0.17702032E-05_JPRB, 0.17701932E-05_JPRB, 0.17700173E-05_JPRB, 0.17693241E-05_JPRB /)

RGHG2(:,73, 6) = (/ &
  & 0.17739446E-05_JPRB, 0.17747666E-05_JPRB, 0.17751013E-05_JPRB, 0.17753572E-05_JPRB, 0.17755295E-05_JPRB, 0.17756845E-05_JPRB, &
  & 0.17758091E-05_JPRB, 0.17759260E-05_JPRB, 0.17760474E-05_JPRB, 0.17761316E-05_JPRB, 0.17762231E-05_JPRB, 0.17762763E-05_JPRB, &
  & 0.17762816E-05_JPRB, 0.17762052E-05_JPRB, 0.17760231E-05_JPRB, 0.17757295E-05_JPRB, 0.17752964E-05_JPRB, 0.17747308E-05_JPRB, &
  & 0.17740460E-05_JPRB, 0.17732941E-05_JPRB, 0.17725213E-05_JPRB, 0.17718080E-05_JPRB, 0.17712290E-05_JPRB, 0.17708436E-05_JPRB, &
  & 0.17706744E-05_JPRB, 0.17706889E-05_JPRB, 0.17708330E-05_JPRB, 0.17710402E-05_JPRB, 0.17712698E-05_JPRB, 0.17715053E-05_JPRB, &
  & 0.17716915E-05_JPRB, 0.17717784E-05_JPRB, 0.17716781E-05_JPRB, 0.17714145E-05_JPRB, 0.17710672E-05_JPRB, 0.17707021E-05_JPRB, &
  & 0.17703368E-05_JPRB, 0.17699797E-05_JPRB, 0.17696375E-05_JPRB, 0.17693631E-05_JPRB, 0.17691992E-05_JPRB, 0.17691741E-05_JPRB, &
  & 0.17692557E-05_JPRB, 0.17693919E-05_JPRB, 0.17695722E-05_JPRB, 0.17697806E-05_JPRB, 0.17700081E-05_JPRB, 0.17702938E-05_JPRB, &
  & 0.17706138E-05_JPRB, 0.17709206E-05_JPRB, 0.17711836E-05_JPRB, 0.17713893E-05_JPRB, 0.17715246E-05_JPRB, 0.17715718E-05_JPRB, &
  & 0.17715315E-05_JPRB, 0.17714157E-05_JPRB, 0.17713019E-05_JPRB, 0.17713196E-05_JPRB, 0.17713853E-05_JPRB, 0.17714649E-05_JPRB, &
  & 0.17715233E-05_JPRB, 0.17715250E-05_JPRB, 0.17713716E-05_JPRB, 0.17707366E-05_JPRB /)

RGHG2(:,74, 6) = (/ &
  & 0.17747274E-05_JPRB, 0.17755353E-05_JPRB, 0.17759093E-05_JPRB, 0.17761314E-05_JPRB, 0.17763082E-05_JPRB, 0.17764430E-05_JPRB, &
  & 0.17765656E-05_JPRB, 0.17766806E-05_JPRB, 0.17767727E-05_JPRB, 0.17768676E-05_JPRB, 0.17769231E-05_JPRB, 0.17769755E-05_JPRB, &
  & 0.17769717E-05_JPRB, 0.17768924E-05_JPRB, 0.17767252E-05_JPRB, 0.17764580E-05_JPRB, 0.17760810E-05_JPRB, 0.17755908E-05_JPRB, &
  & 0.17750027E-05_JPRB, 0.17743577E-05_JPRB, 0.17736938E-05_JPRB, 0.17730803E-05_JPRB, 0.17725766E-05_JPRB, 0.17722324E-05_JPRB, &
  & 0.17720721E-05_JPRB, 0.17720685E-05_JPRB, 0.17721791E-05_JPRB, 0.17723454E-05_JPRB, 0.17725330E-05_JPRB, 0.17727286E-05_JPRB, &
  & 0.17728792E-05_JPRB, 0.17729494E-05_JPRB, 0.17728548E-05_JPRB, 0.17726215E-05_JPRB, 0.17723204E-05_JPRB, 0.17720072E-05_JPRB, &
  & 0.17716974E-05_JPRB, 0.17713990E-05_JPRB, 0.17711135E-05_JPRB, 0.17708853E-05_JPRB, 0.17707513E-05_JPRB, 0.17707378E-05_JPRB, &
  & 0.17708134E-05_JPRB, 0.17709331E-05_JPRB, 0.17710879E-05_JPRB, 0.17712661E-05_JPRB, 0.17714576E-05_JPRB, 0.17717080E-05_JPRB, &
  & 0.17719865E-05_JPRB, 0.17722599E-05_JPRB, 0.17724935E-05_JPRB, 0.17726830E-05_JPRB, 0.17728102E-05_JPRB, 0.17728613E-05_JPRB, &
  & 0.17728356E-05_JPRB, 0.17727418E-05_JPRB, 0.17726524E-05_JPRB, 0.17726760E-05_JPRB, 0.17727399E-05_JPRB, 0.17728119E-05_JPRB, &
  & 0.17728696E-05_JPRB, 0.17728769E-05_JPRB, 0.17727448E-05_JPRB, 0.17721412E-05_JPRB /)

RGHG2(:,75, 6) = (/ &
  & 0.17755059E-05_JPRB, 0.17763632E-05_JPRB, 0.17766890E-05_JPRB, 0.17769072E-05_JPRB, 0.17770521E-05_JPRB, 0.17771824E-05_JPRB, &
  & 0.17772901E-05_JPRB, 0.17773868E-05_JPRB, 0.17774835E-05_JPRB, 0.17775411E-05_JPRB, 0.17776011E-05_JPRB, 0.17776304E-05_JPRB, &
  & 0.17776209E-05_JPRB, 0.17775448E-05_JPRB, 0.17773909E-05_JPRB, 0.17771659E-05_JPRB, 0.17768457E-05_JPRB, 0.17764377E-05_JPRB, &
  & 0.17759479E-05_JPRB, 0.17754148E-05_JPRB, 0.17748633E-05_JPRB, 0.17743540E-05_JPRB, 0.17739302E-05_JPRB, 0.17736318E-05_JPRB, &
  & 0.17734860E-05_JPRB, 0.17734681E-05_JPRB, 0.17735460E-05_JPRB, 0.17736754E-05_JPRB, 0.17738188E-05_JPRB, 0.17739757E-05_JPRB, &
  & 0.17740908E-05_JPRB, 0.17741449E-05_JPRB, 0.17740584E-05_JPRB, 0.17738587E-05_JPRB, 0.17736060E-05_JPRB, 0.17733479E-05_JPRB, &
  & 0.17730938E-05_JPRB, 0.17728551E-05_JPRB, 0.17726259E-05_JPRB, 0.17724449E-05_JPRB, 0.17723394E-05_JPRB, 0.17723364E-05_JPRB, &
  & 0.17724051E-05_JPRB, 0.17725066E-05_JPRB, 0.17726373E-05_JPRB, 0.17727853E-05_JPRB, 0.17729431E-05_JPRB, 0.17731546E-05_JPRB, &
  & 0.17733923E-05_JPRB, 0.17736247E-05_JPRB, 0.17738299E-05_JPRB, 0.17739960E-05_JPRB, 0.17741143E-05_JPRB, 0.17741665E-05_JPRB, &
  & 0.17741525E-05_JPRB, 0.17740788E-05_JPRB, 0.17740103E-05_JPRB, 0.17740410E-05_JPRB, 0.17740994E-05_JPRB, 0.17741680E-05_JPRB, &
  & 0.17742218E-05_JPRB, 0.17742318E-05_JPRB, 0.17741067E-05_JPRB, 0.17735373E-05_JPRB /)

RGHG2(:,76, 6) = (/ &
  & 0.17763567E-05_JPRB, 0.17771542E-05_JPRB, 0.17774580E-05_JPRB, 0.17776366E-05_JPRB, 0.17777606E-05_JPRB, 0.17778660E-05_JPRB, &
  & 0.17779598E-05_JPRB, 0.17780474E-05_JPRB, 0.17781155E-05_JPRB, 0.17781728E-05_JPRB, 0.17782031E-05_JPRB, 0.17782297E-05_JPRB, &
  & 0.17782190E-05_JPRB, 0.17781531E-05_JPRB, 0.17780217E-05_JPRB, 0.17778385E-05_JPRB, 0.17775847E-05_JPRB, 0.17772645E-05_JPRB, &
  & 0.17768759E-05_JPRB, 0.17764572E-05_JPRB, 0.17760209E-05_JPRB, 0.17756179E-05_JPRB, 0.17752790E-05_JPRB, 0.17750328E-05_JPRB, &
  & 0.17749085E-05_JPRB, 0.17748814E-05_JPRB, 0.17749309E-05_JPRB, 0.17750272E-05_JPRB, 0.17751273E-05_JPRB, 0.17752453E-05_JPRB, &
  & 0.17753271E-05_JPRB, 0.17753647E-05_JPRB, 0.17752895E-05_JPRB, 0.17751270E-05_JPRB, 0.17749257E-05_JPRB, 0.17747250E-05_JPRB, &
  & 0.17745267E-05_JPRB, 0.17743459E-05_JPRB, 0.17741750E-05_JPRB, 0.17740406E-05_JPRB, 0.17739644E-05_JPRB, 0.17739707E-05_JPRB, &
  & 0.17740294E-05_JPRB, 0.17741128E-05_JPRB, 0.17742191E-05_JPRB, 0.17743387E-05_JPRB, 0.17744625E-05_JPRB, 0.17746356E-05_JPRB, &
  & 0.17748268E-05_JPRB, 0.17750166E-05_JPRB, 0.17751871E-05_JPRB, 0.17753262E-05_JPRB, 0.17754285E-05_JPRB, 0.17754753E-05_JPRB, &
  & 0.17754717E-05_JPRB, 0.17754169E-05_JPRB, 0.17753640E-05_JPRB, 0.17753998E-05_JPRB, 0.17754568E-05_JPRB, 0.17755176E-05_JPRB, &
  & 0.17755668E-05_JPRB, 0.17755777E-05_JPRB, 0.17754597E-05_JPRB, 0.17748978E-05_JPRB /)

RGHG2(:,77, 6) = (/ &
  & 0.17772154E-05_JPRB, 0.17779296E-05_JPRB, 0.17781797E-05_JPRB, 0.17783209E-05_JPRB, 0.17784066E-05_JPRB, 0.17784920E-05_JPRB, &
  & 0.17785620E-05_JPRB, 0.17786272E-05_JPRB, 0.17786870E-05_JPRB, 0.17787141E-05_JPRB, 0.17787381E-05_JPRB, 0.17787542E-05_JPRB, &
  & 0.17787431E-05_JPRB, 0.17786994E-05_JPRB, 0.17785954E-05_JPRB, 0.17784623E-05_JPRB, 0.17782795E-05_JPRB, 0.17780470E-05_JPRB, &
  & 0.17777631E-05_JPRB, 0.17774582E-05_JPRB, 0.17771379E-05_JPRB, 0.17768461E-05_JPRB, 0.17765971E-05_JPRB, 0.17764118E-05_JPRB, &
  & 0.17763184E-05_JPRB, 0.17762898E-05_JPRB, 0.17763191E-05_JPRB, 0.17763861E-05_JPRB, 0.17764494E-05_JPRB, 0.17765312E-05_JPRB, &
  & 0.17765851E-05_JPRB, 0.17766105E-05_JPRB, 0.17765504E-05_JPRB, 0.17764293E-05_JPRB, 0.17762825E-05_JPRB, 0.17761411E-05_JPRB, &
  & 0.17759979E-05_JPRB, 0.17758738E-05_JPRB, 0.17757568E-05_JPRB, 0.17756668E-05_JPRB, 0.17756170E-05_JPRB, 0.17756308E-05_JPRB, &
  & 0.17756764E-05_JPRB, 0.17757399E-05_JPRB, 0.17758218E-05_JPRB, 0.17759136E-05_JPRB, 0.17760063E-05_JPRB, 0.17761379E-05_JPRB, &
  & 0.17762809E-05_JPRB, 0.17764219E-05_JPRB, 0.17765540E-05_JPRB, 0.17766606E-05_JPRB, 0.17767383E-05_JPRB, 0.17767727E-05_JPRB, &
  & 0.17767729E-05_JPRB, 0.17767360E-05_JPRB, 0.17766986E-05_JPRB, 0.17767408E-05_JPRB, 0.17767883E-05_JPRB, 0.17768409E-05_JPRB, &
  & 0.17768820E-05_JPRB, 0.17768916E-05_JPRB, 0.17767735E-05_JPRB, 0.17762394E-05_JPRB /)

RGHG2(:,78, 6) = (/ &
  & 0.17780857E-05_JPRB, 0.17786360E-05_JPRB, 0.17788099E-05_JPRB, 0.17789093E-05_JPRB, 0.17789589E-05_JPRB, 0.17790169E-05_JPRB, &
  & 0.17790633E-05_JPRB, 0.17791083E-05_JPRB, 0.17791447E-05_JPRB, 0.17791555E-05_JPRB, 0.17791632E-05_JPRB, 0.17791806E-05_JPRB, &
  & 0.17791718E-05_JPRB, 0.17791544E-05_JPRB, 0.17790795E-05_JPRB, 0.17789953E-05_JPRB, 0.17788767E-05_JPRB, 0.17787310E-05_JPRB, &
  & 0.17785388E-05_JPRB, 0.17783437E-05_JPRB, 0.17781327E-05_JPRB, 0.17779483E-05_JPRB, 0.17777915E-05_JPRB, 0.17776717E-05_JPRB, &
  & 0.17776200E-05_JPRB, 0.17776034E-05_JPRB, 0.17776254E-05_JPRB, 0.17776719E-05_JPRB, 0.17777104E-05_JPRB, 0.17777642E-05_JPRB, &
  & 0.17777949E-05_JPRB, 0.17778133E-05_JPRB, 0.17777720E-05_JPRB, 0.17776938E-05_JPRB, 0.17776017E-05_JPRB, 0.17775184E-05_JPRB, &
  & 0.17774270E-05_JPRB, 0.17773533E-05_JPRB, 0.17772840E-05_JPRB, 0.17772310E-05_JPRB, 0.17772051E-05_JPRB, 0.17772231E-05_JPRB, &
  & 0.17772526E-05_JPRB, 0.17772945E-05_JPRB, 0.17773516E-05_JPRB, 0.17774166E-05_JPRB, 0.17774784E-05_JPRB, 0.17775674E-05_JPRB, &
  & 0.17776590E-05_JPRB, 0.17777488E-05_JPRB, 0.17778400E-05_JPRB, 0.17779078E-05_JPRB, 0.17779563E-05_JPRB, 0.17779689E-05_JPRB, &
  & 0.17779702E-05_JPRB, 0.17779498E-05_JPRB, 0.17779274E-05_JPRB, 0.17779678E-05_JPRB, 0.17780019E-05_JPRB, 0.17780396E-05_JPRB, &
  & 0.17780682E-05_JPRB, 0.17780762E-05_JPRB, 0.17779907E-05_JPRB, 0.17775488E-05_JPRB /)

RGHG2(:,79, 6) = (/ &
  & 0.17786512E-05_JPRB, 0.17790331E-05_JPRB, 0.17791486E-05_JPRB, 0.17792175E-05_JPRB, 0.17792445E-05_JPRB, 0.17792910E-05_JPRB, &
  & 0.17793217E-05_JPRB, 0.17793559E-05_JPRB, 0.17793843E-05_JPRB, 0.17793823E-05_JPRB, 0.17793841E-05_JPRB, 0.17794023E-05_JPRB, &
  & 0.17793936E-05_JPRB, 0.17793922E-05_JPRB, 0.17793299E-05_JPRB, 0.17792704E-05_JPRB, 0.17791876E-05_JPRB, 0.17790860E-05_JPRB, &
  & 0.17789450E-05_JPRB, 0.17788070E-05_JPRB, 0.17786545E-05_JPRB, 0.17785295E-05_JPRB, 0.17784228E-05_JPRB, 0.17783395E-05_JPRB, &
  & 0.17783137E-05_JPRB, 0.17783057E-05_JPRB, 0.17783269E-05_JPRB, 0.17783650E-05_JPRB, 0.17783912E-05_JPRB, 0.17784308E-05_JPRB, &
  & 0.17784491E-05_JPRB, 0.17784648E-05_JPRB, 0.17784328E-05_JPRB, 0.17783782E-05_JPRB, 0.17783157E-05_JPRB, 0.17782634E-05_JPRB, &
  & 0.17781970E-05_JPRB, 0.17781485E-05_JPRB, 0.17781027E-05_JPRB, 0.17780677E-05_JPRB, 0.17780519E-05_JPRB, 0.17780711E-05_JPRB, &
  & 0.17780899E-05_JPRB, 0.17781185E-05_JPRB, 0.17781604E-05_JPRB, 0.17782088E-05_JPRB, 0.17782513E-05_JPRB, 0.17783153E-05_JPRB, &
  & 0.17783771E-05_JPRB, 0.17784372E-05_JPRB, 0.17785057E-05_JPRB, 0.17785524E-05_JPRB, 0.17785841E-05_JPRB, 0.17785858E-05_JPRB, &
  & 0.17785870E-05_JPRB, 0.17785749E-05_JPRB, 0.17785569E-05_JPRB, 0.17785962E-05_JPRB, 0.17786182E-05_JPRB, 0.17786472E-05_JPRB, &
  & 0.17786699E-05_JPRB, 0.17786955E-05_JPRB, 0.17786550E-05_JPRB, 0.17783696E-05_JPRB /)

RGHG2(:,80, 6) = (/ &
  & 0.17790269E-05_JPRB, 0.17792256E-05_JPRB, 0.17792970E-05_JPRB, 0.17793521E-05_JPRB, 0.17793673E-05_JPRB, 0.17794090E-05_JPRB, &
  & 0.17794350E-05_JPRB, 0.17794615E-05_JPRB, 0.17794912E-05_JPRB, 0.17794838E-05_JPRB, 0.17794829E-05_JPRB, 0.17795010E-05_JPRB, &
  & 0.17794928E-05_JPRB, 0.17794990E-05_JPRB, 0.17794409E-05_JPRB, 0.17793926E-05_JPRB, 0.17793263E-05_JPRB, 0.17792463E-05_JPRB, &
  & 0.17791273E-05_JPRB, 0.17790168E-05_JPRB, 0.17788905E-05_JPRB, 0.17787926E-05_JPRB, 0.17787086E-05_JPRB, 0.17786401E-05_JPRB, &
  & 0.17786266E-05_JPRB, 0.17786224E-05_JPRB, 0.17786440E-05_JPRB, 0.17786795E-05_JPRB, 0.17787006E-05_JPRB, 0.17787341E-05_JPRB, &
  & 0.17787468E-05_JPRB, 0.17787615E-05_JPRB, 0.17787336E-05_JPRB, 0.17786890E-05_JPRB, 0.17786399E-05_JPRB, 0.17786014E-05_JPRB, &
  & 0.17785453E-05_JPRB, 0.17785071E-05_JPRB, 0.17784716E-05_JPRB, 0.17784433E-05_JPRB, 0.17784314E-05_JPRB, 0.17784499E-05_JPRB, &
  & 0.17784629E-05_JPRB, 0.17784843E-05_JPRB, 0.17785187E-05_JPRB, 0.17785596E-05_JPRB, 0.17785922E-05_JPRB, 0.17786444E-05_JPRB, &
  & 0.17786913E-05_JPRB, 0.17787372E-05_JPRB, 0.17787958E-05_JPRB, 0.17788325E-05_JPRB, 0.17788575E-05_JPRB, 0.17788535E-05_JPRB, &
  & 0.17788556E-05_JPRB, 0.17788464E-05_JPRB, 0.17788284E-05_JPRB, 0.17788650E-05_JPRB, 0.17788800E-05_JPRB, 0.17789044E-05_JPRB, &
  & 0.17789268E-05_JPRB, 0.17789629E-05_JPRB, 0.17789708E-05_JPRB, 0.17789029E-05_JPRB /)

RGHG2(:,81, 6) = (/ &
  & 0.17792847E-05_JPRB, 0.17793071E-05_JPRB, 0.17793600E-05_JPRB, 0.17794092E-05_JPRB, 0.17794194E-05_JPRB, 0.17794604E-05_JPRB, &
  & 0.17794812E-05_JPRB, 0.17795146E-05_JPRB, 0.17795358E-05_JPRB, 0.17795262E-05_JPRB, 0.17795255E-05_JPRB, 0.17795462E-05_JPRB, &
  & 0.17795370E-05_JPRB, 0.17795468E-05_JPRB, 0.17794896E-05_JPRB, 0.17794468E-05_JPRB, 0.17793866E-05_JPRB, 0.17793185E-05_JPRB, &
  & 0.17792081E-05_JPRB, 0.17791116E-05_JPRB, 0.17789957E-05_JPRB, 0.17789102E-05_JPRB, 0.17788354E-05_JPRB, 0.17787727E-05_JPRB, &
  & 0.17787654E-05_JPRB, 0.17787623E-05_JPRB, 0.17787841E-05_JPRB, 0.17788185E-05_JPRB, 0.17788369E-05_JPRB, 0.17788682E-05_JPRB, &
  & 0.17788781E-05_JPRB, 0.17788924E-05_JPRB, 0.17788661E-05_JPRB, 0.17788261E-05_JPRB, 0.17787825E-05_JPRB, 0.17787504E-05_JPRB, &
  & 0.17786980E-05_JPRB, 0.17786646E-05_JPRB, 0.17786326E-05_JPRB, 0.17786076E-05_JPRB, 0.17785974E-05_JPRB, 0.17786151E-05_JPRB, &
  & 0.17786253E-05_JPRB, 0.17786435E-05_JPRB, 0.17786742E-05_JPRB, 0.17787117E-05_JPRB, 0.17787397E-05_JPRB, 0.17787869E-05_JPRB, &
  & 0.17788271E-05_JPRB, 0.17788666E-05_JPRB, 0.17789214E-05_JPRB, 0.17789539E-05_JPRB, 0.17789763E-05_JPRB, 0.17789698E-05_JPRB, &
  & 0.17789727E-05_JPRB, 0.17789642E-05_JPRB, 0.17789455E-05_JPRB, 0.17789798E-05_JPRB, 0.17789904E-05_JPRB, 0.17790130E-05_JPRB, &
  & 0.17790343E-05_JPRB, 0.17790752E-05_JPRB, 0.17791028E-05_JPRB, 0.17792667E-05_JPRB /)

RGHG2(:,82, 6) = (/ &
  & 0.17793051E-05_JPRB, 0.17793341E-05_JPRB, 0.17793880E-05_JPRB, 0.17794368E-05_JPRB, 0.17794453E-05_JPRB, 0.17794837E-05_JPRB, &
  & 0.17795084E-05_JPRB, 0.17795286E-05_JPRB, 0.17795589E-05_JPRB, 0.17795513E-05_JPRB, 0.17795496E-05_JPRB, 0.17795649E-05_JPRB, &
  & 0.17795581E-05_JPRB, 0.17795693E-05_JPRB, 0.17795140E-05_JPRB, 0.17794728E-05_JPRB, 0.17794173E-05_JPRB, 0.17793534E-05_JPRB, &
  & 0.17792498E-05_JPRB, 0.17791585E-05_JPRB, 0.17790487E-05_JPRB, 0.17789690E-05_JPRB, 0.17788990E-05_JPRB, 0.17788370E-05_JPRB, &
  & 0.17788335E-05_JPRB, 0.17788311E-05_JPRB, 0.17788527E-05_JPRB, 0.17788869E-05_JPRB, 0.17789037E-05_JPRB, 0.17789338E-05_JPRB, &
  & 0.17789421E-05_JPRB, 0.17789564E-05_JPRB, 0.17789308E-05_JPRB, 0.17788930E-05_JPRB, 0.17788523E-05_JPRB, 0.17788227E-05_JPRB, &
  & 0.17787725E-05_JPRB, 0.17787407E-05_JPRB, 0.17787111E-05_JPRB, 0.17786876E-05_JPRB, 0.17786783E-05_JPRB, 0.17786954E-05_JPRB, &
  & 0.17787045E-05_JPRB, 0.17787206E-05_JPRB, 0.17787497E-05_JPRB, 0.17787854E-05_JPRB, 0.17788116E-05_JPRB, 0.17788567E-05_JPRB, &
  & 0.17788934E-05_JPRB, 0.17789292E-05_JPRB, 0.17789828E-05_JPRB, 0.17790131E-05_JPRB, 0.17790342E-05_JPRB, 0.17790262E-05_JPRB, &
  & 0.17790294E-05_JPRB, 0.17790217E-05_JPRB, 0.17790019E-05_JPRB, 0.17790353E-05_JPRB, 0.17790435E-05_JPRB, 0.17790643E-05_JPRB, &
  & 0.17790848E-05_JPRB, 0.17791249E-05_JPRB, 0.17791476E-05_JPRB, 0.17792959E-05_JPRB /)

RGHG2(:,83, 6) = (/ &
  & 0.17793194E-05_JPRB, 0.17793500E-05_JPRB, 0.17794039E-05_JPRB, 0.17794523E-05_JPRB, 0.17794589E-05_JPRB, 0.17794997E-05_JPRB, &
  & 0.17795172E-05_JPRB, 0.17795526E-05_JPRB, 0.17795682E-05_JPRB, 0.17795597E-05_JPRB, 0.17795594E-05_JPRB, 0.17795776E-05_JPRB, &
  & 0.17795716E-05_JPRB, 0.17795821E-05_JPRB, 0.17795268E-05_JPRB, 0.17794881E-05_JPRB, 0.17794335E-05_JPRB, 0.17793751E-05_JPRB, &
  & 0.17792718E-05_JPRB, 0.17791871E-05_JPRB, 0.17790776E-05_JPRB, 0.17790029E-05_JPRB, 0.17789341E-05_JPRB, 0.17788730E-05_JPRB, &
  & 0.17788716E-05_JPRB, 0.17788694E-05_JPRB, 0.17788918E-05_JPRB, 0.17789254E-05_JPRB, 0.17789414E-05_JPRB, 0.17789706E-05_JPRB, &
  & 0.17789781E-05_JPRB, 0.17789919E-05_JPRB, 0.17789666E-05_JPRB, 0.17789301E-05_JPRB, 0.17788906E-05_JPRB, 0.17788627E-05_JPRB, &
  & 0.17788130E-05_JPRB, 0.17787828E-05_JPRB, 0.17787547E-05_JPRB, 0.17787326E-05_JPRB, 0.17787238E-05_JPRB, 0.17787395E-05_JPRB, &
  & 0.17787481E-05_JPRB, 0.17787631E-05_JPRB, 0.17787914E-05_JPRB, 0.17788266E-05_JPRB, 0.17788516E-05_JPRB, 0.17788955E-05_JPRB, &
  & 0.17789303E-05_JPRB, 0.17789645E-05_JPRB, 0.17790175E-05_JPRB, 0.17790464E-05_JPRB, 0.17790668E-05_JPRB, 0.17790580E-05_JPRB, &
  & 0.17790614E-05_JPRB, 0.17790539E-05_JPRB, 0.17790333E-05_JPRB, 0.17790662E-05_JPRB, 0.17790728E-05_JPRB, 0.17790929E-05_JPRB, &
  & 0.17791128E-05_JPRB, 0.17791532E-05_JPRB, 0.17791734E-05_JPRB, 0.17793169E-05_JPRB /)

RGHG2(:,84, 6) = (/ &
  & 0.17793287E-05_JPRB, 0.17793600E-05_JPRB, 0.17794134E-05_JPRB, 0.17794621E-05_JPRB, 0.17794686E-05_JPRB, 0.17795062E-05_JPRB, &
  & 0.17795320E-05_JPRB, 0.17795486E-05_JPRB, 0.17795767E-05_JPRB, 0.17795716E-05_JPRB, 0.17795705E-05_JPRB, 0.17795816E-05_JPRB, &
  & 0.17795777E-05_JPRB, 0.17795853E-05_JPRB, 0.17795372E-05_JPRB, 0.17794971E-05_JPRB, 0.17794448E-05_JPRB, 0.17793870E-05_JPRB, &
  & 0.17792881E-05_JPRB, 0.17792034E-05_JPRB, 0.17790973E-05_JPRB, 0.17790238E-05_JPRB, 0.17789571E-05_JPRB, 0.17788943E-05_JPRB, &
  & 0.17788955E-05_JPRB, 0.17788933E-05_JPRB, 0.17789152E-05_JPRB, 0.17789497E-05_JPRB, 0.17789642E-05_JPRB, 0.17789931E-05_JPRB, &
  & 0.17790001E-05_JPRB, 0.17790136E-05_JPRB, 0.17789886E-05_JPRB, 0.17789523E-05_JPRB, 0.17789142E-05_JPRB, 0.17788867E-05_JPRB, &
  & 0.17788379E-05_JPRB, 0.17788082E-05_JPRB, 0.17787811E-05_JPRB, 0.17787604E-05_JPRB, 0.17787524E-05_JPRB, 0.17787672E-05_JPRB, &
  & 0.17787751E-05_JPRB, 0.17787900E-05_JPRB, 0.17788167E-05_JPRB, 0.17788516E-05_JPRB, 0.17788757E-05_JPRB, 0.17789190E-05_JPRB, &
  & 0.17789533E-05_JPRB, 0.17789857E-05_JPRB, 0.17790389E-05_JPRB, 0.17790674E-05_JPRB, 0.17790873E-05_JPRB, 0.17790779E-05_JPRB, &
  & 0.17790816E-05_JPRB, 0.17790737E-05_JPRB, 0.17790524E-05_JPRB, 0.17790850E-05_JPRB, 0.17790907E-05_JPRB, 0.17791104E-05_JPRB, &
  & 0.17791302E-05_JPRB, 0.17791705E-05_JPRB, 0.17791906E-05_JPRB, 0.17793309E-05_JPRB /)

RGHG2(:,85, 6) = (/ &
  & 0.17793353E-05_JPRB, 0.17793661E-05_JPRB, 0.17794197E-05_JPRB, 0.17794686E-05_JPRB, 0.17794731E-05_JPRB, 0.17795159E-05_JPRB, &
  & 0.17795312E-05_JPRB, 0.17795662E-05_JPRB, 0.17795771E-05_JPRB, 0.17795729E-05_JPRB, 0.17795733E-05_JPRB, 0.17795853E-05_JPRB, &
  & 0.17795820E-05_JPRB, 0.17795836E-05_JPRB, 0.17795410E-05_JPRB, 0.17795037E-05_JPRB, 0.17794532E-05_JPRB, 0.17793965E-05_JPRB, &
  & 0.17792991E-05_JPRB, 0.17792167E-05_JPRB, 0.17791091E-05_JPRB, 0.17790379E-05_JPRB, 0.17789712E-05_JPRB, 0.17789084E-05_JPRB, &
  & 0.17789112E-05_JPRB, 0.17789082E-05_JPRB, 0.17789315E-05_JPRB, 0.17789649E-05_JPRB, 0.17789791E-05_JPRB, 0.17790078E-05_JPRB, &
  & 0.17790144E-05_JPRB, 0.17790276E-05_JPRB, 0.17790023E-05_JPRB, 0.17789669E-05_JPRB, 0.17789289E-05_JPRB, 0.17789025E-05_JPRB, &
  & 0.17788533E-05_JPRB, 0.17788238E-05_JPRB, 0.17787983E-05_JPRB, 0.17787784E-05_JPRB, 0.17787711E-05_JPRB, 0.17787843E-05_JPRB, &
  & 0.17787925E-05_JPRB, 0.17788063E-05_JPRB, 0.17788341E-05_JPRB, 0.17788667E-05_JPRB, 0.17788918E-05_JPRB, 0.17789338E-05_JPRB, &
  & 0.17789675E-05_JPRB, 0.17789996E-05_JPRB, 0.17790522E-05_JPRB, 0.17790808E-05_JPRB, 0.17791003E-05_JPRB, 0.17790908E-05_JPRB, &
  & 0.17790946E-05_JPRB, 0.17790869E-05_JPRB, 0.17790646E-05_JPRB, 0.17790974E-05_JPRB, 0.17791021E-05_JPRB, 0.17791216E-05_JPRB, &
  & 0.17791413E-05_JPRB, 0.17791824E-05_JPRB, 0.17792016E-05_JPRB, 0.17793413E-05_JPRB /)

RGHG2(:,86, 6) = (/ &
  & 0.17793392E-05_JPRB, 0.17793705E-05_JPRB, 0.17794235E-05_JPRB, 0.17794732E-05_JPRB, 0.17794810E-05_JPRB, 0.17795146E-05_JPRB, &
  & 0.17795451E-05_JPRB, 0.17795576E-05_JPRB, 0.17795804E-05_JPRB, 0.17795787E-05_JPRB, 0.17795790E-05_JPRB, 0.17795837E-05_JPRB, &
  & 0.17795797E-05_JPRB, 0.17795765E-05_JPRB, 0.17795435E-05_JPRB, 0.17795068E-05_JPRB, 0.17794594E-05_JPRB, 0.17794042E-05_JPRB, &
  & 0.17793095E-05_JPRB, 0.17792265E-05_JPRB, 0.17791187E-05_JPRB, 0.17790470E-05_JPRB, 0.17789814E-05_JPRB, 0.17789173E-05_JPRB, &
  & 0.17789210E-05_JPRB, 0.17789181E-05_JPRB, 0.17789407E-05_JPRB, 0.17789755E-05_JPRB, 0.17789886E-05_JPRB, 0.17790173E-05_JPRB, &
  & 0.17790231E-05_JPRB, 0.17790369E-05_JPRB, 0.17790111E-05_JPRB, 0.17789757E-05_JPRB, 0.17789389E-05_JPRB, 0.17789130E-05_JPRB, &
  & 0.17788630E-05_JPRB, 0.17788343E-05_JPRB, 0.17788084E-05_JPRB, 0.17787889E-05_JPRB, 0.17787820E-05_JPRB, 0.17787958E-05_JPRB, &
  & 0.17788034E-05_JPRB, 0.17788184E-05_JPRB, 0.17788441E-05_JPRB, 0.17788782E-05_JPRB, 0.17789022E-05_JPRB, 0.17789437E-05_JPRB, &
  & 0.17789766E-05_JPRB, 0.17790086E-05_JPRB, 0.17790602E-05_JPRB, 0.17790885E-05_JPRB, 0.17791084E-05_JPRB, 0.17790992E-05_JPRB, &
  & 0.17791029E-05_JPRB, 0.17790954E-05_JPRB, 0.17790727E-05_JPRB, 0.17791053E-05_JPRB, 0.17791093E-05_JPRB, 0.17791288E-05_JPRB, &
  & 0.17791484E-05_JPRB, 0.17791897E-05_JPRB, 0.17792090E-05_JPRB, 0.17793470E-05_JPRB /)

RGHG2(:,87, 6) = (/ &
  & 0.17793424E-05_JPRB, 0.17793734E-05_JPRB, 0.17794256E-05_JPRB, 0.17794753E-05_JPRB, 0.17794799E-05_JPRB, 0.17795267E-05_JPRB, &
  & 0.17795389E-05_JPRB, 0.17795699E-05_JPRB, 0.17795775E-05_JPRB, 0.17795762E-05_JPRB, 0.17795765E-05_JPRB, 0.17795815E-05_JPRB, &
  & 0.17795776E-05_JPRB, 0.17795712E-05_JPRB, 0.17795419E-05_JPRB, 0.17795089E-05_JPRB, 0.17794638E-05_JPRB, 0.17794075E-05_JPRB, &
  & 0.17793201E-05_JPRB, 0.17792330E-05_JPRB, 0.17791260E-05_JPRB, 0.17790528E-05_JPRB, 0.17789873E-05_JPRB, 0.17789228E-05_JPRB, &
  & 0.17789272E-05_JPRB, 0.17789237E-05_JPRB, 0.17789474E-05_JPRB, 0.17789815E-05_JPRB, 0.17789945E-05_JPRB, 0.17790239E-05_JPRB, &
  & 0.17790286E-05_JPRB, 0.17790422E-05_JPRB, 0.17790167E-05_JPRB, 0.17789814E-05_JPRB, 0.17789449E-05_JPRB, 0.17789203E-05_JPRB, &
  & 0.17788690E-05_JPRB, 0.17788402E-05_JPRB, 0.17788145E-05_JPRB, 0.17787944E-05_JPRB, 0.17787875E-05_JPRB, 0.17788026E-05_JPRB, &
  & 0.17788103E-05_JPRB, 0.17788240E-05_JPRB, 0.17788527E-05_JPRB, 0.17788843E-05_JPRB, 0.17789100E-05_JPRB, 0.17789495E-05_JPRB, &
  & 0.17789823E-05_JPRB, 0.17790137E-05_JPRB, 0.17790646E-05_JPRB, 0.17790927E-05_JPRB, 0.17791128E-05_JPRB, 0.17791044E-05_JPRB, &
  & 0.17791083E-05_JPRB, 0.17791006E-05_JPRB, 0.17790778E-05_JPRB, 0.17791104E-05_JPRB, 0.17791136E-05_JPRB, 0.17791332E-05_JPRB, &
  & 0.17791527E-05_JPRB, 0.17791945E-05_JPRB, 0.17792130E-05_JPRB, 0.17793516E-05_JPRB /)

RGHG2(:,88, 6) = (/ &
  & 0.17793453E-05_JPRB, 0.17793775E-05_JPRB, 0.17794266E-05_JPRB, 0.17794765E-05_JPRB, 0.17794887E-05_JPRB, 0.17795192E-05_JPRB, &
  & 0.17795505E-05_JPRB, 0.17795612E-05_JPRB, 0.17795786E-05_JPRB, 0.17795778E-05_JPRB, 0.17795780E-05_JPRB, 0.17795805E-05_JPRB, &
  & 0.17795760E-05_JPRB, 0.17795701E-05_JPRB, 0.17795426E-05_JPRB, 0.17795096E-05_JPRB, 0.17794657E-05_JPRB, 0.17794123E-05_JPRB, &
  & 0.17793220E-05_JPRB, 0.17792389E-05_JPRB, 0.17791285E-05_JPRB, 0.17790569E-05_JPRB, 0.17789911E-05_JPRB, 0.17789259E-05_JPRB, &
  & 0.17789312E-05_JPRB, 0.17789274E-05_JPRB, 0.17789509E-05_JPRB, 0.17789860E-05_JPRB, 0.17789980E-05_JPRB, 0.17790280E-05_JPRB, &
  & 0.17790319E-05_JPRB, 0.17790460E-05_JPRB, 0.17790200E-05_JPRB, 0.17789849E-05_JPRB, 0.17789488E-05_JPRB, 0.17789256E-05_JPRB, &
  & 0.17788725E-05_JPRB, 0.17788446E-05_JPRB, 0.17788179E-05_JPRB, 0.17787956E-05_JPRB, 0.17787884E-05_JPRB, 0.17788070E-05_JPRB, &
  & 0.17788140E-05_JPRB, 0.17788288E-05_JPRB, 0.17788568E-05_JPRB, 0.17788900E-05_JPRB, 0.17789148E-05_JPRB, 0.17789540E-05_JPRB, &
  & 0.17789857E-05_JPRB, 0.17790178E-05_JPRB, 0.17790655E-05_JPRB, 0.17790949E-05_JPRB, 0.17791148E-05_JPRB, 0.17791075E-05_JPRB, &
  & 0.17791112E-05_JPRB, 0.17791033E-05_JPRB, 0.17790803E-05_JPRB, 0.17791135E-05_JPRB, 0.17791164E-05_JPRB, 0.17791356E-05_JPRB, &
  & 0.17791552E-05_JPRB, 0.17791974E-05_JPRB, 0.17792155E-05_JPRB, 0.17793542E-05_JPRB /)

RGHG2(:,89, 6) = (/ &
  & 0.17793496E-05_JPRB, 0.17793818E-05_JPRB, 0.17794270E-05_JPRB, 0.17794750E-05_JPRB, 0.17794824E-05_JPRB, 0.17795289E-05_JPRB, &
  & 0.17795428E-05_JPRB, 0.17795699E-05_JPRB, 0.17795783E-05_JPRB, 0.17795779E-05_JPRB, 0.17795783E-05_JPRB, 0.17795825E-05_JPRB, &
  & 0.17795794E-05_JPRB, 0.17795735E-05_JPRB, 0.17795448E-05_JPRB, 0.17795121E-05_JPRB, 0.17794671E-05_JPRB, 0.17794111E-05_JPRB, &
  & 0.17793240E-05_JPRB, 0.17792369E-05_JPRB, 0.17791302E-05_JPRB, 0.17790575E-05_JPRB, 0.17789931E-05_JPRB, 0.17789273E-05_JPRB, &
  & 0.17789334E-05_JPRB, 0.17789291E-05_JPRB, 0.17789530E-05_JPRB, 0.17789886E-05_JPRB, 0.17789995E-05_JPRB, 0.17790305E-05_JPRB, &
  & 0.17790336E-05_JPRB, 0.17790485E-05_JPRB, 0.17790219E-05_JPRB, 0.17789866E-05_JPRB, 0.17789504E-05_JPRB, 0.17789285E-05_JPRB, &
  & 0.17788741E-05_JPRB, 0.17788470E-05_JPRB, 0.17788195E-05_JPRB, 0.17787960E-05_JPRB, 0.17787872E-05_JPRB, 0.17788095E-05_JPRB, &
  & 0.17788157E-05_JPRB, 0.17788304E-05_JPRB, 0.17788605E-05_JPRB, 0.17788930E-05_JPRB, 0.17789180E-05_JPRB, 0.17789561E-05_JPRB, &
  & 0.17789882E-05_JPRB, 0.17790194E-05_JPRB, 0.17790667E-05_JPRB, 0.17790954E-05_JPRB, 0.17791158E-05_JPRB, 0.17791093E-05_JPRB, &
  & 0.17791132E-05_JPRB, 0.17791048E-05_JPRB, 0.17790811E-05_JPRB, 0.17791156E-05_JPRB, 0.17791176E-05_JPRB, 0.17791372E-05_JPRB, &
  & 0.17791559E-05_JPRB, 0.17791990E-05_JPRB, 0.17792169E-05_JPRB, 0.17793562E-05_JPRB /)

RGHG2(:,90, 6) = (/ &
  & 0.17793537E-05_JPRB, 0.17793866E-05_JPRB, 0.17794242E-05_JPRB, 0.17794746E-05_JPRB, 0.17794837E-05_JPRB, 0.17795210E-05_JPRB, &
  & 0.17795483E-05_JPRB, 0.17795646E-05_JPRB, 0.17795828E-05_JPRB, 0.17795815E-05_JPRB, 0.17795824E-05_JPRB, 0.17795869E-05_JPRB, &
  & 0.17795844E-05_JPRB, 0.17795824E-05_JPRB, 0.17795483E-05_JPRB, 0.17795124E-05_JPRB, 0.17794650E-05_JPRB, 0.17794124E-05_JPRB, &
  & 0.17793161E-05_JPRB, 0.17792358E-05_JPRB, 0.17791263E-05_JPRB, 0.17790577E-05_JPRB, 0.17789936E-05_JPRB, 0.17789265E-05_JPRB, &
  & 0.17789345E-05_JPRB, 0.17789291E-05_JPRB, 0.17789538E-05_JPRB, 0.17789901E-05_JPRB, 0.17789996E-05_JPRB, 0.17790326E-05_JPRB, &
  & 0.17790343E-05_JPRB, 0.17790510E-05_JPRB, 0.17790233E-05_JPRB, 0.17789872E-05_JPRB, 0.17789507E-05_JPRB, 0.17789306E-05_JPRB, &
  & 0.17788742E-05_JPRB, 0.17788479E-05_JPRB, 0.17788207E-05_JPRB, 0.17787952E-05_JPRB, 0.17787851E-05_JPRB, 0.17788119E-05_JPRB, &
  & 0.17788161E-05_JPRB, 0.17788307E-05_JPRB, 0.17788615E-05_JPRB, 0.17788942E-05_JPRB, 0.17789187E-05_JPRB, 0.17789582E-05_JPRB, &
  & 0.17789891E-05_JPRB, 0.17790205E-05_JPRB, 0.17790674E-05_JPRB, 0.17790970E-05_JPRB, 0.17791174E-05_JPRB, 0.17791101E-05_JPRB, &
  & 0.17791142E-05_JPRB, 0.17791060E-05_JPRB, 0.17790804E-05_JPRB, 0.17791169E-05_JPRB, 0.17791178E-05_JPRB, 0.17791380E-05_JPRB, &
  & 0.17791562E-05_JPRB, 0.17792008E-05_JPRB, 0.17792174E-05_JPRB, 0.17793586E-05_JPRB /)

RGHG2(:,91, 6) = (/ &
  & 0.17793520E-05_JPRB, 0.17793866E-05_JPRB, 0.17794117E-05_JPRB, 0.17794820E-05_JPRB, 0.17794752E-05_JPRB, 0.17795213E-05_JPRB, &
  & 0.17795337E-05_JPRB, 0.17795622E-05_JPRB, 0.17795944E-05_JPRB, 0.17795868E-05_JPRB, 0.17795828E-05_JPRB, 0.17795917E-05_JPRB, &
  & 0.17795844E-05_JPRB, 0.17796176E-05_JPRB, 0.17795419E-05_JPRB, 0.17795122E-05_JPRB, 0.17794603E-05_JPRB, 0.17794140E-05_JPRB, &
  & 0.17793074E-05_JPRB, 0.17792340E-05_JPRB, 0.17791217E-05_JPRB, 0.17790571E-05_JPRB, 0.17789940E-05_JPRB, 0.17789215E-05_JPRB, &
  & 0.17789355E-05_JPRB, 0.17789273E-05_JPRB, 0.17789531E-05_JPRB, 0.17789920E-05_JPRB, 0.17789980E-05_JPRB, 0.17790354E-05_JPRB, &
  & 0.17790337E-05_JPRB, 0.17790554E-05_JPRB, 0.17790243E-05_JPRB, 0.17789865E-05_JPRB, 0.17789497E-05_JPRB, 0.17789331E-05_JPRB, &
  & 0.17788725E-05_JPRB, 0.17788484E-05_JPRB, 0.17788211E-05_JPRB, 0.17787941E-05_JPRB, 0.17787817E-05_JPRB, 0.17788142E-05_JPRB, &
  & 0.17788147E-05_JPRB, 0.17788277E-05_JPRB, 0.17788617E-05_JPRB, 0.17788936E-05_JPRB, 0.17789147E-05_JPRB, 0.17789623E-05_JPRB, &
  & 0.17789887E-05_JPRB, 0.17790217E-05_JPRB, 0.17790709E-05_JPRB, 0.17790999E-05_JPRB, 0.17791215E-05_JPRB, 0.17791097E-05_JPRB, &
  & 0.17791159E-05_JPRB, 0.17791069E-05_JPRB, 0.17790766E-05_JPRB, 0.17791198E-05_JPRB, 0.17791169E-05_JPRB, 0.17791384E-05_JPRB, &
  & 0.17791556E-05_JPRB, 0.17792037E-05_JPRB, 0.17792173E-05_JPRB, 0.17793626E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART12',1,ZHOOK_HANDLE)
END SUBROUTINE PART12






SUBROUTINE PART13
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART13',0,ZHOOK_HANDLE)



!-- Month=  7 ------------

RGHG2(:, 1, 7) = (/ &
  & 0.87824770E-08_JPRB, 0.87549576E-08_JPRB, 0.87407628E-08_JPRB, 0.87308560E-08_JPRB, 0.87383638E-08_JPRB, 0.87928012E-08_JPRB, &
  & 0.89160102E-08_JPRB, 0.91127852E-08_JPRB, 0.93753547E-08_JPRB, 0.96965680E-08_JPRB, 0.10074604E-07_JPRB, 0.10506930E-07_JPRB, &
  & 0.10981432E-07_JPRB, 0.11475528E-07_JPRB, 0.11955789E-07_JPRB, 0.12381392E-07_JPRB, 0.12711897E-07_JPRB, 0.12915866E-07_JPRB, &
  & 0.12976628E-07_JPRB, 0.12897057E-07_JPRB, 0.12709298E-07_JPRB, 0.12478049E-07_JPRB, 0.12295501E-07_JPRB, 0.12263746E-07_JPRB, &
  & 0.12474109E-07_JPRB, 0.12978801E-07_JPRB, 0.13753349E-07_JPRB, 0.14670857E-07_JPRB, 0.15593091E-07_JPRB, 0.16408620E-07_JPRB, &
  & 0.17015491E-07_JPRB, 0.17328478E-07_JPRB, 0.17367253E-07_JPRB, 0.17115656E-07_JPRB, 0.16555839E-07_JPRB, 0.15709508E-07_JPRB, &
  & 0.14642766E-07_JPRB, 0.13451507E-07_JPRB, 0.12282844E-07_JPRB, 0.11356989E-07_JPRB, 0.10659134E-07_JPRB, 0.10044583E-07_JPRB, &
  & 0.94683541E-08_JPRB, 0.88926866E-08_JPRB, 0.82934264E-08_JPRB, 0.76300237E-08_JPRB, 0.69229298E-08_JPRB, 0.64018209E-08_JPRB, &
  & 0.61680083E-08_JPRB, 0.60519008E-08_JPRB, 0.59985927E-08_JPRB, 0.59721934E-08_JPRB, 0.59493561E-08_JPRB, 0.58901568E-08_JPRB, &
  & 0.57431198E-08_JPRB, 0.54692317E-08_JPRB, 0.51892859E-08_JPRB, 0.49176379E-08_JPRB, 0.47469371E-08_JPRB, 0.46604631E-08_JPRB, &
  & 0.45523301E-08_JPRB, 0.44125743E-08_JPRB, 0.42087458E-08_JPRB, 0.38770840E-08_JPRB /)

RGHG2(:, 2, 7) = (/ &
  & 0.10355546E-07_JPRB, 0.11093988E-07_JPRB, 0.11619302E-07_JPRB, 0.12186853E-07_JPRB, 0.12903611E-07_JPRB, 0.13867135E-07_JPRB, &
  & 0.15084689E-07_JPRB, 0.16514562E-07_JPRB, 0.18099762E-07_JPRB, 0.19772347E-07_JPRB, 0.21438165E-07_JPRB, 0.22973687E-07_JPRB, &
  & 0.24276630E-07_JPRB, 0.25316504E-07_JPRB, 0.26133735E-07_JPRB, 0.26789671E-07_JPRB, 0.27322500E-07_JPRB, 0.27742058E-07_JPRB, &
  & 0.28048600E-07_JPRB, 0.28250117E-07_JPRB, 0.28371876E-07_JPRB, 0.28465591E-07_JPRB, 0.28610220E-07_JPRB, 0.28903159E-07_JPRB, &
  & 0.29436649E-07_JPRB, 0.30267920E-07_JPRB, 0.31387760E-07_JPRB, 0.32710748E-07_JPRB, 0.34105934E-07_JPRB, 0.35444103E-07_JPRB, &
  & 0.36601950E-07_JPRB, 0.37467100E-07_JPRB, 0.37882813E-07_JPRB, 0.37829221E-07_JPRB, 0.37325279E-07_JPRB, 0.36398593E-07_JPRB, &
  & 0.35090210E-07_JPRB, 0.33472048E-07_JPRB, 0.31705206E-07_JPRB, 0.30013918E-07_JPRB, 0.28516929E-07_JPRB, 0.27155526E-07_JPRB, &
  & 0.25871085E-07_JPRB, 0.24608328E-07_JPRB, 0.23322071E-07_JPRB, 0.21989216E-07_JPRB, 0.20671674E-07_JPRB, 0.19578819E-07_JPRB, &
  & 0.18847908E-07_JPRB, 0.18381211E-07_JPRB, 0.18093223E-07_JPRB, 0.17883746E-07_JPRB, 0.17678243E-07_JPRB, 0.17371635E-07_JPRB, &
  & 0.16906910E-07_JPRB, 0.16236855E-07_JPRB, 0.15446608E-07_JPRB, 0.14553435E-07_JPRB, 0.13558234E-07_JPRB, 0.12545526E-07_JPRB, &
  & 0.11517442E-07_JPRB, 0.10365937E-07_JPRB, 0.90485415E-08_JPRB, 0.67865087E-08_JPRB /)

RGHG2(:, 3, 7) = (/ &
  & 0.12558615E-07_JPRB, 0.13910063E-07_JPRB, 0.14807957E-07_JPRB, 0.15740511E-07_JPRB, 0.16902675E-07_JPRB, 0.18398890E-07_JPRB, &
  & 0.20211461E-07_JPRB, 0.22199778E-07_JPRB, 0.24187402E-07_JPRB, 0.26060041E-07_JPRB, 0.27818331E-07_JPRB, 0.29602667E-07_JPRB, &
  & 0.31576047E-07_JPRB, 0.33800973E-07_JPRB, 0.36190990E-07_JPRB, 0.38549317E-07_JPRB, 0.40658559E-07_JPRB, 0.42362814E-07_JPRB, &
  & 0.43601485E-07_JPRB, 0.44393950E-07_JPRB, 0.44811962E-07_JPRB, 0.44966129E-07_JPRB, 0.45000096E-07_JPRB, 0.45078512E-07_JPRB, &
  & 0.45349264E-07_JPRB, 0.45888026E-07_JPRB, 0.46651834E-07_JPRB, 0.47508209E-07_JPRB, 0.48329191E-07_JPRB, 0.49014940E-07_JPRB, &
  & 0.49469065E-07_JPRB, 0.49606683E-07_JPRB, 0.49415277E-07_JPRB, 0.48922164E-07_JPRB, 0.48171291E-07_JPRB, 0.47210857E-07_JPRB, &
  & 0.46077265E-07_JPRB, 0.44820059E-07_JPRB, 0.43499746E-07_JPRB, 0.42212168E-07_JPRB, 0.40994127E-07_JPRB, 0.39852754E-07_JPRB, &
  & 0.38754767E-07_JPRB, 0.37668492E-07_JPRB, 0.36574271E-07_JPRB, 0.35460612E-07_JPRB, 0.34377631E-07_JPRB, 0.33410910E-07_JPRB, &
  & 0.32614423E-07_JPRB, 0.31950407E-07_JPRB, 0.31358134E-07_JPRB, 0.30757914E-07_JPRB, 0.30100743E-07_JPRB, 0.29316867E-07_JPRB, &
  & 0.28358988E-07_JPRB, 0.27247536E-07_JPRB, 0.25935156E-07_JPRB, 0.24406646E-07_JPRB, 0.22926500E-07_JPRB, 0.21392655E-07_JPRB, &
  & 0.19852687E-07_JPRB, 0.18262917E-07_JPRB, 0.16299227E-07_JPRB, 0.12897081E-07_JPRB /)

RGHG2(:, 4, 7) = (/ &
  & 0.14582369E-07_JPRB, 0.16582565E-07_JPRB, 0.17896099E-07_JPRB, 0.19241879E-07_JPRB, 0.20836966E-07_JPRB, 0.22807177E-07_JPRB, &
  & 0.25096282E-07_JPRB, 0.27555712E-07_JPRB, 0.30183323E-07_JPRB, 0.33033356E-07_JPRB, 0.36215315E-07_JPRB, 0.39710638E-07_JPRB, &
  & 0.43356295E-07_JPRB, 0.46858631E-07_JPRB, 0.49924189E-07_JPRB, 0.52422877E-07_JPRB, 0.54402360E-07_JPRB, 0.55950590E-07_JPRB, &
  & 0.57110029E-07_JPRB, 0.57897889E-07_JPRB, 0.58344845E-07_JPRB, 0.58504575E-07_JPRB, 0.58446542E-07_JPRB, 0.58251274E-07_JPRB, &
  & 0.58005501E-07_JPRB, 0.57791205E-07_JPRB, 0.57651153E-07_JPRB, 0.57568869E-07_JPRB, 0.57481792E-07_JPRB, 0.57307528E-07_JPRB, &
  & 0.56981150E-07_JPRB, 0.56488279E-07_JPRB, 0.55829489E-07_JPRB, 0.55013995E-07_JPRB, 0.54058766E-07_JPRB, 0.52980525E-07_JPRB, &
  & 0.51806289E-07_JPRB, 0.50534197E-07_JPRB, 0.49189779E-07_JPRB, 0.47799439E-07_JPRB, 0.46423814E-07_JPRB, 0.45092296E-07_JPRB, &
  & 0.43830905E-07_JPRB, 0.42648850E-07_JPRB, 0.41532012E-07_JPRB, 0.40477012E-07_JPRB, 0.39483538E-07_JPRB, 0.38567080E-07_JPRB, &
  & 0.37734367E-07_JPRB, 0.36951157E-07_JPRB, 0.36194145E-07_JPRB, 0.35415415E-07_JPRB, 0.34595026E-07_JPRB, 0.33687972E-07_JPRB, &
  & 0.32679122E-07_JPRB, 0.31454018E-07_JPRB, 0.30141635E-07_JPRB, 0.28823305E-07_JPRB, 0.27354755E-07_JPRB, 0.25923363E-07_JPRB, &
  & 0.24393074E-07_JPRB, 0.22801165E-07_JPRB, 0.21141714E-07_JPRB, 0.18458376E-07_JPRB /)

RGHG2(:, 5, 7) = (/ &
  & 0.16471255E-07_JPRB, 0.19232729E-07_JPRB, 0.21100950E-07_JPRB, 0.22995678E-07_JPRB, 0.25195735E-07_JPRB, 0.27850415E-07_JPRB, &
  & 0.30881541E-07_JPRB, 0.34288167E-07_JPRB, 0.38001719E-07_JPRB, 0.42025874E-07_JPRB, 0.46185516E-07_JPRB, 0.50294275E-07_JPRB, &
  & 0.54138653E-07_JPRB, 0.57611835E-07_JPRB, 0.60693679E-07_JPRB, 0.63317579E-07_JPRB, 0.65385741E-07_JPRB, 0.66887949E-07_JPRB, &
  & 0.67919160E-07_JPRB, 0.68592080E-07_JPRB, 0.68981379E-07_JPRB, 0.69124134E-07_JPRB, 0.69037682E-07_JPRB, 0.68731026E-07_JPRB, &
  & 0.68217410E-07_JPRB, 0.67533087E-07_JPRB, 0.66735105E-07_JPRB, 0.65884080E-07_JPRB, 0.65018149E-07_JPRB, 0.64162535E-07_JPRB, &
  & 0.63339769E-07_JPRB, 0.62563139E-07_JPRB, 0.61835927E-07_JPRB, 0.61137257E-07_JPRB, 0.60428590E-07_JPRB, 0.59655079E-07_JPRB, &
  & 0.58764410E-07_JPRB, 0.57739438E-07_JPRB, 0.56558058E-07_JPRB, 0.55211004E-07_JPRB, 0.53687952E-07_JPRB, 0.52030007E-07_JPRB, &
  & 0.50298699E-07_JPRB, 0.48554519E-07_JPRB, 0.46851145E-07_JPRB, 0.45182055E-07_JPRB, 0.43557527E-07_JPRB, 0.41976783E-07_JPRB, &
  & 0.40454658E-07_JPRB, 0.38990311E-07_JPRB, 0.37570974E-07_JPRB, 0.36195740E-07_JPRB, 0.34847275E-07_JPRB, 0.33534818E-07_JPRB, &
  & 0.32248725E-07_JPRB, 0.31026318E-07_JPRB, 0.29823624E-07_JPRB, 0.28576133E-07_JPRB, 0.27425326E-07_JPRB, 0.26281278E-07_JPRB, &
  & 0.25337275E-07_JPRB, 0.24518489E-07_JPRB, 0.23519336E-07_JPRB, 0.21665041E-07_JPRB /)

RGHG2(:, 6, 7) = (/ &
  & 0.18695847E-07_JPRB, 0.22568425E-07_JPRB, 0.25268569E-07_JPRB, 0.27969008E-07_JPRB, 0.31060662E-07_JPRB, 0.34565634E-07_JPRB, &
  & 0.38570871E-07_JPRB, 0.42824009E-07_JPRB, 0.47337586E-07_JPRB, 0.51893473E-07_JPRB, 0.56366140E-07_JPRB, 0.60604421E-07_JPRB, &
  & 0.64501556E-07_JPRB, 0.67926557E-07_JPRB, 0.70776061E-07_JPRB, 0.73064825E-07_JPRB, 0.74903845E-07_JPRB, 0.76373858E-07_JPRB, &
  & 0.77504772E-07_JPRB, 0.78330970E-07_JPRB, 0.78905494E-07_JPRB, 0.79264126E-07_JPRB, 0.79406682E-07_JPRB, 0.79298026E-07_JPRB, &
  & 0.78885769E-07_JPRB, 0.78135336E-07_JPRB, 0.77059255E-07_JPRB, 0.75733631E-07_JPRB, 0.74287968E-07_JPRB, 0.72860708E-07_JPRB, &
  & 0.71583258E-07_JPRB, 0.70603932E-07_JPRB, 0.70026843E-07_JPRB, 0.69853087E-07_JPRB, 0.69972764E-07_JPRB, 0.70235792E-07_JPRB, &
  & 0.70509330E-07_JPRB, 0.70691620E-07_JPRB, 0.70683846E-07_JPRB, 0.70364592E-07_JPRB, 0.69604489E-07_JPRB, 0.68304189E-07_JPRB, &
  & 0.66458917E-07_JPRB, 0.64168091E-07_JPRB, 0.61534685E-07_JPRB, 0.58650770E-07_JPRB, 0.55563081E-07_JPRB, 0.52327490E-07_JPRB, &
  & 0.49018141E-07_JPRB, 0.45714920E-07_JPRB, 0.42500268E-07_JPRB, 0.39464886E-07_JPRB, 0.36653791E-07_JPRB, 0.34126433E-07_JPRB, &
  & 0.31887282E-07_JPRB, 0.29917715E-07_JPRB, 0.28178404E-07_JPRB, 0.26736549E-07_JPRB, 0.25566971E-07_JPRB, 0.24762091E-07_JPRB, &
  & 0.24138874E-07_JPRB, 0.23601679E-07_JPRB, 0.23179611E-07_JPRB, 0.22588036E-07_JPRB /)

RGHG2(:, 7, 7) = (/ &
  & 0.22021798E-07_JPRB, 0.27593359E-07_JPRB, 0.31413375E-07_JPRB, 0.35151889E-07_JPRB, 0.39139529E-07_JPRB, 0.43534349E-07_JPRB, &
  & 0.48176908E-07_JPRB, 0.52995322E-07_JPRB, 0.57764908E-07_JPRB, 0.62456770E-07_JPRB, 0.66900732E-07_JPRB, 0.70969278E-07_JPRB, &
  & 0.74543081E-07_JPRB, 0.77585405E-07_JPRB, 0.80134093E-07_JPRB, 0.82238088E-07_JPRB, 0.83962924E-07_JPRB, 0.85408956E-07_JPRB, &
  & 0.86672067E-07_JPRB, 0.87789402E-07_JPRB, 0.88762569E-07_JPRB, 0.89592000E-07_JPRB, 0.90264734E-07_JPRB, 0.90726815E-07_JPRB, &
  & 0.90888818E-07_JPRB, 0.90651341E-07_JPRB, 0.89928143E-07_JPRB, 0.88692005E-07_JPRB, 0.87016801E-07_JPRB, 0.85106024E-07_JPRB, &
  & 0.83332218E-07_JPRB, 0.82165570E-07_JPRB, 0.81966220E-07_JPRB, 0.82851457E-07_JPRB, 0.84673125E-07_JPRB, 0.87099366E-07_JPRB, &
  & 0.89797034E-07_JPRB, 0.92484825E-07_JPRB, 0.94927429E-07_JPRB, 0.96837432E-07_JPRB, 0.97877248E-07_JPRB, 0.97728545E-07_JPRB, &
  & 0.96232199E-07_JPRB, 0.93460478E-07_JPRB, 0.89620087E-07_JPRB, 0.84877257E-07_JPRB, 0.79399882E-07_JPRB, 0.73336352E-07_JPRB, &
  & 0.66908981E-07_JPRB, 0.60358545E-07_JPRB, 0.53962083E-07_JPRB, 0.47939778E-07_JPRB, 0.42466390E-07_JPRB, 0.37666556E-07_JPRB, &
  & 0.33573315E-07_JPRB, 0.30186300E-07_JPRB, 0.27444358E-07_JPRB, 0.25273350E-07_JPRB, 0.23659702E-07_JPRB, 0.22523304E-07_JPRB, &
  & 0.21761196E-07_JPRB, 0.21304691E-07_JPRB, 0.21058131E-07_JPRB, 0.21026674E-07_JPRB /)

RGHG2(:, 8, 7) = (/ &
  & 0.27294272E-07_JPRB, 0.34898115E-07_JPRB, 0.39795616E-07_JPRB, 0.44375103E-07_JPRB, 0.48954654E-07_JPRB, 0.53816180E-07_JPRB, &
  & 0.58753429E-07_JPRB, 0.63687111E-07_JPRB, 0.68463613E-07_JPRB, 0.72967779E-07_JPRB, 0.77105312E-07_JPRB, 0.80788674E-07_JPRB, &
  & 0.83976921E-07_JPRB, 0.86667917E-07_JPRB, 0.88913119E-07_JPRB, 0.90814595E-07_JPRB, 0.92490765E-07_JPRB, 0.94029417E-07_JPRB, &
  & 0.95500518E-07_JPRB, 0.96970297E-07_JPRB, 0.98481124E-07_JPRB, 0.10003162E-06_JPRB, 0.10160884E-06_JPRB, 0.10318081E-06_JPRB, &
  & 0.10462863E-06_JPRB, 0.10574220E-06_JPRB, 0.10628596E-06_JPRB, 0.10605185E-06_JPRB, 0.10497482E-06_JPRB, 0.10330491E-06_JPRB, &
  & 0.10167241E-06_JPRB, 0.10086346E-06_JPRB, 0.10145818E-06_JPRB, 0.10371106E-06_JPRB, 0.10758082E-06_JPRB, 0.11275481E-06_JPRB, &
  & 0.11872699E-06_JPRB, 0.12500089E-06_JPRB, 0.13111139E-06_JPRB, 0.13645452E-06_JPRB, 0.14034298E-06_JPRB, 0.14212814E-06_JPRB, &
  & 0.14144635E-06_JPRB, 0.13832044E-06_JPRB, 0.13298506E-06_JPRB, 0.12575367E-06_JPRB, 0.11691730E-06_JPRB, 0.10682800E-06_JPRB, &
  & 0.95938134E-07_JPRB, 0.84747128E-07_JPRB, 0.73780328E-07_JPRB, 0.63486034E-07_JPRB, 0.54220255E-07_JPRB, 0.46177203E-07_JPRB, &
  & 0.39433683E-07_JPRB, 0.33922397E-07_JPRB, 0.29536103E-07_JPRB, 0.26129293E-07_JPRB, 0.23648539E-07_JPRB, 0.21940043E-07_JPRB, &
  & 0.20775609E-07_JPRB, 0.19987162E-07_JPRB, 0.19471637E-07_JPRB, 0.18936319E-07_JPRB /)

RGHG2(:, 9, 7) = (/ &
  & 0.34783149E-07_JPRB, 0.43622524E-07_JPRB, 0.48980763E-07_JPRB, 0.53562207E-07_JPRB, 0.58322566E-07_JPRB, 0.62921714E-07_JPRB, &
  & 0.67855851E-07_JPRB, 0.72631991E-07_JPRB, 0.77302907E-07_JPRB, 0.81650640E-07_JPRB, 0.85586102E-07_JPRB, 0.89041997E-07_JPRB, &
  & 0.92005429E-07_JPRB, 0.94519116E-07_JPRB, 0.96664515E-07_JPRB, 0.98542827E-07_JPRB, 0.10027458E-06_JPRB, 0.10198731E-06_JPRB, &
  & 0.10378679E-06_JPRB, 0.10575019E-06_JPRB, 0.10795500E-06_JPRB, 0.11047791E-06_JPRB, 0.11334882E-06_JPRB, 0.11658567E-06_JPRB, &
  & 0.12012373E-06_JPRB, 0.12371099E-06_JPRB, 0.12701832E-06_JPRB, 0.12970625E-06_JPRB, 0.13158632E-06_JPRB, 0.13269590E-06_JPRB, &
  & 0.13339194E-06_JPRB, 0.13437010E-06_JPRB, 0.13645430E-06_JPRB, 0.14032811E-06_JPRB, 0.14634399E-06_JPRB, 0.15436868E-06_JPRB, &
  & 0.16388323E-06_JPRB, 0.17417550E-06_JPRB, 0.18434758E-06_JPRB, 0.19334148E-06_JPRB, 0.20009089E-06_JPRB, 0.20368141E-06_JPRB, &
  & 0.20359072E-06_JPRB, 0.19974524E-06_JPRB, 0.19238225E-06_JPRB, 0.18188722E-06_JPRB, 0.16877698E-06_JPRB, 0.15365187E-06_JPRB, &
  & 0.13723529E-06_JPRB, 0.12035368E-06_JPRB, 0.10383444E-06_JPRB, 0.88361894E-07_JPRB, 0.74444657E-07_JPRB, 0.62378106E-07_JPRB, &
  & 0.52289273E-07_JPRB, 0.44114351E-07_JPRB, 0.37680447E-07_JPRB, 0.32803513E-07_JPRB, 0.29321846E-07_JPRB, 0.27002482E-07_JPRB, &
  & 0.25546431E-07_JPRB, 0.24636240E-07_JPRB, 0.24187266E-07_JPRB, 0.23912628E-07_JPRB /)

RGHG2(:,10, 7) = (/ &
  & 0.43139551E-07_JPRB, 0.51165145E-07_JPRB, 0.55641209E-07_JPRB, 0.59775957E-07_JPRB, 0.63625762E-07_JPRB, 0.67996837E-07_JPRB, &
  & 0.72285346E-07_JPRB, 0.76943792E-07_JPRB, 0.81476792E-07_JPRB, 0.85837470E-07_JPRB, 0.89826578E-07_JPRB, 0.93378979E-07_JPRB, &
  & 0.96492101E-07_JPRB, 0.99211718E-07_JPRB, 0.10162670E-06_JPRB, 0.10384358E-06_JPRB, 0.10598316E-06_JPRB, 0.10817378E-06_JPRB, &
  & 0.11056657E-06_JPRB, 0.11334439E-06_JPRB, 0.11670448E-06_JPRB, 0.12088432E-06_JPRB, 0.12611363E-06_JPRB, 0.13244568E-06_JPRB, &
  & 0.13972013E-06_JPRB, 0.14774257E-06_JPRB, 0.15638599E-06_JPRB, 0.16539288E-06_JPRB, 0.17428204E-06_JPRB, 0.18252919E-06_JPRB, &
  & 0.18988960E-06_JPRB, 0.19657847E-06_JPRB, 0.20332097E-06_JPRB, 0.21095352E-06_JPRB, 0.22002202E-06_JPRB, 0.23065444E-06_JPRB, &
  & 0.24254354E-06_JPRB, 0.25488234E-06_JPRB, 0.26655894E-06_JPRB, 0.27632896E-06_JPRB, 0.28304709E-06_JPRB, 0.28582031E-06_JPRB, &
  & 0.28403565E-06_JPRB, 0.27757380E-06_JPRB, 0.26666808E-06_JPRB, 0.25182527E-06_JPRB, 0.23365345E-06_JPRB, 0.21288947E-06_JPRB, &
  & 0.19053952E-06_JPRB, 0.16774726E-06_JPRB, 0.14554158E-06_JPRB, 0.12479316E-06_JPRB, 0.10614512E-06_JPRB, 0.89984759E-07_JPRB, &
  & 0.76478926E-07_JPRB, 0.65558829E-07_JPRB, 0.57045181E-07_JPRB, 0.50696919E-07_JPRB, 0.46367600E-07_JPRB, 0.43747097E-07_JPRB, &
  & 0.42504091E-07_JPRB, 0.42214602E-07_JPRB, 0.43140989E-07_JPRB, 0.45817149E-07_JPRB /)

RGHG2(:,11, 7) = (/ &
  & 0.48900798E-07_JPRB, 0.53670863E-07_JPRB, 0.56705897E-07_JPRB, 0.59547663E-07_JPRB, 0.62851612E-07_JPRB, 0.66235280E-07_JPRB, &
  & 0.70286859E-07_JPRB, 0.74468204E-07_JPRB, 0.78960703E-07_JPRB, 0.83379490E-07_JPRB, 0.87600661E-07_JPRB, 0.91534062E-07_JPRB, &
  & 0.95181562E-07_JPRB, 0.98610066E-07_JPRB, 0.10191458E-06_JPRB, 0.10517339E-06_JPRB, 0.10849311E-06_JPRB, 0.11197767E-06_JPRB, &
  & 0.11579488E-06_JPRB, 0.12015555E-06_JPRB, 0.12540545E-06_JPRB, 0.13188267E-06_JPRB, 0.13986285E-06_JPRB, 0.14961203E-06_JPRB, &
  & 0.16132854E-06_JPRB, 0.17514833E-06_JPRB, 0.19093849E-06_JPRB, 0.20871065E-06_JPRB, 0.22891140E-06_JPRB, 0.25107835E-06_JPRB, &
  & 0.27382575E-06_JPRB, 0.29548499E-06_JPRB, 0.31511081E-06_JPRB, 0.33266355E-06_JPRB, 0.34832561E-06_JPRB, 0.36220433E-06_JPRB, &
  & 0.37418488E-06_JPRB, 0.38403238E-06_JPRB, 0.39127698E-06_JPRB, 0.39531042E-06_JPRB, 0.39569878E-06_JPRB, 0.39195851E-06_JPRB, &
  & 0.38385258E-06_JPRB, 0.37129539E-06_JPRB, 0.35441951E-06_JPRB, 0.33358657E-06_JPRB, 0.30937377E-06_JPRB, 0.28275923E-06_JPRB, &
  & 0.25496539E-06_JPRB, 0.22703014E-06_JPRB, 0.20006507E-06_JPRB, 0.17497237E-06_JPRB, 0.15242529E-06_JPRB, 0.13284964E-06_JPRB, &
  & 0.11645017E-06_JPRB, 0.10319355E-06_JPRB, 0.92902589E-07_JPRB, 0.85381245E-07_JPRB, 0.80520174E-07_JPRB, 0.78043122E-07_JPRB, &
  & 0.77568991E-07_JPRB, 0.78754844E-07_JPRB, 0.82441332E-07_JPRB, 0.91223413E-07_JPRB /)

RGHG2(:,12, 7) = (/ &
  & 0.52729813E-07_JPRB, 0.57163600E-07_JPRB, 0.60099872E-07_JPRB, 0.62878108E-07_JPRB, 0.65537463E-07_JPRB, 0.68630143E-07_JPRB, &
  & 0.72014004E-07_JPRB, 0.76142626E-07_JPRB, 0.80818481E-07_JPRB, 0.86115186E-07_JPRB, 0.91866781E-07_JPRB, 0.97971608E-07_JPRB, &
  & 0.10433203E-06_JPRB, 0.11080088E-06_JPRB, 0.11722869E-06_JPRB, 0.12337665E-06_JPRB, 0.12901339E-06_JPRB, 0.13405553E-06_JPRB, &
  & 0.13873716E-06_JPRB, 0.14361439E-06_JPRB, 0.14945796E-06_JPRB, 0.15702716E-06_JPRB, 0.16689228E-06_JPRB, 0.17944076E-06_JPRB, &
  & 0.19493731E-06_JPRB, 0.21377296E-06_JPRB, 0.23699494E-06_JPRB, 0.26521809E-06_JPRB, 0.29792619E-06_JPRB, 0.33514920E-06_JPRB, &
  & 0.37572366E-06_JPRB, 0.41612799E-06_JPRB, 0.45262965E-06_JPRB, 0.48345629E-06_JPRB, 0.50788140E-06_JPRB, 0.52559153E-06_JPRB, &
  & 0.53683289E-06_JPRB, 0.54198011E-06_JPRB, 0.54147830E-06_JPRB, 0.53628668E-06_JPRB, 0.52665064E-06_JPRB, 0.51307097E-06_JPRB, &
  & 0.49563346E-06_JPRB, 0.47455347E-06_JPRB, 0.45004589E-06_JPRB, 0.42247467E-06_JPRB, 0.39262892E-06_JPRB, 0.36131991E-06_JPRB, &
  & 0.32937282E-06_JPRB, 0.29803431E-06_JPRB, 0.26836153E-06_JPRB, 0.24107675E-06_JPRB, 0.21668937E-06_JPRB, 0.19552698E-06_JPRB, &
  & 0.17775349E-06_JPRB, 0.16334521E-06_JPRB, 0.15223036E-06_JPRB, 0.14433165E-06_JPRB, 0.13969648E-06_JPRB, 0.13818257E-06_JPRB, &
  & 0.13948019E-06_JPRB, 0.14321448E-06_JPRB, 0.15150040E-06_JPRB, 0.16917610E-06_JPRB /)

RGHG2(:,13, 7) = (/ &
  & 0.69800691E-07_JPRB, 0.79220321E-07_JPRB, 0.83807137E-07_JPRB, 0.87056037E-07_JPRB, 0.90078174E-07_JPRB, 0.93302809E-07_JPRB, &
  & 0.97535008E-07_JPRB, 0.10318072E-06_JPRB, 0.11098997E-06_JPRB, 0.12126154E-06_JPRB, 0.13420295E-06_JPRB, 0.14961566E-06_JPRB, &
  & 0.16679009E-06_JPRB, 0.18455611E-06_JPRB, 0.20118992E-06_JPRB, 0.21495477E-06_JPRB, 0.22450939E-06_JPRB, 0.22925977E-06_JPRB, &
  & 0.22999751E-06_JPRB, 0.22837089E-06_JPRB, 0.22665972E-06_JPRB, 0.22713854E-06_JPRB, 0.23126901E-06_JPRB, 0.23980067E-06_JPRB, &
  & 0.25323507E-06_JPRB, 0.27230502E-06_JPRB, 0.29789916E-06_JPRB, 0.33148291E-06_JPRB, 0.37404737E-06_JPRB, 0.42388223E-06_JPRB, &
  & 0.47821698E-06_JPRB, 0.53239614E-06_JPRB, 0.58180080E-06_JPRB, 0.62317133E-06_JPRB, 0.65469919E-06_JPRB, 0.67599819E-06_JPRB, &
  & 0.68746692E-06_JPRB, 0.68958934E-06_JPRB, 0.68394149E-06_JPRB, 0.67163546E-06_JPRB, 0.65398496E-06_JPRB, 0.63223325E-06_JPRB, &
  & 0.60677684E-06_JPRB, 0.57825076E-06_JPRB, 0.54728122E-06_JPRB, 0.51441486E-06_JPRB, 0.48023179E-06_JPRB, 0.44565746E-06_JPRB, &
  & 0.41204419E-06_JPRB, 0.38024766E-06_JPRB, 0.35081564E-06_JPRB, 0.32421656E-06_JPRB, 0.30073170E-06_JPRB, 0.28050476E-06_JPRB, &
  & 0.26356295E-06_JPRB, 0.24990899E-06_JPRB, 0.23953297E-06_JPRB, 0.23250101E-06_JPRB, 0.22911027E-06_JPRB, 0.22930280E-06_JPRB, &
  & 0.23298166E-06_JPRB, 0.23948573E-06_JPRB, 0.25229193E-06_JPRB, 0.27791094E-06_JPRB /)

RGHG2(:,14, 7) = (/ &
  & 0.13087575E-06_JPRB, 0.14800993E-06_JPRB, 0.15494075E-06_JPRB, 0.15859270E-06_JPRB, 0.16115706E-06_JPRB, 0.16403835E-06_JPRB, &
  & 0.16858850E-06_JPRB, 0.17617096E-06_JPRB, 0.18796928E-06_JPRB, 0.20465885E-06_JPRB, 0.22591583E-06_JPRB, 0.25043073E-06_JPRB, &
  & 0.27605850E-06_JPRB, 0.30040496E-06_JPRB, 0.32123759E-06_JPRB, 0.33687635E-06_JPRB, 0.34623972E-06_JPRB, 0.34940726E-06_JPRB, &
  & 0.34753660E-06_JPRB, 0.34261160E-06_JPRB, 0.33694485E-06_JPRB, 0.33264286E-06_JPRB, 0.33151619E-06_JPRB, 0.33494047E-06_JPRB, &
  & 0.34399091E-06_JPRB, 0.36003067E-06_JPRB, 0.38476776E-06_JPRB, 0.41952205E-06_JPRB, 0.46528612E-06_JPRB, 0.52074586E-06_JPRB, &
  & 0.58116757E-06_JPRB, 0.64207006E-06_JPRB, 0.69787473E-06_JPRB, 0.74471103E-06_JPRB, 0.78028916E-06_JPRB, 0.80367909E-06_JPRB, &
  & 0.81481278E-06_JPRB, 0.81499377E-06_JPRB, 0.80598085E-06_JPRB, 0.78957578E-06_JPRB, 0.76725451E-06_JPRB, 0.74058789E-06_JPRB, &
  & 0.71061498E-06_JPRB, 0.67803711E-06_JPRB, 0.64364536E-06_JPRB, 0.60814699E-06_JPRB, 0.57264810E-06_JPRB, 0.53821094E-06_JPRB, &
  & 0.50552376E-06_JPRB, 0.47527766E-06_JPRB, 0.44805350E-06_JPRB, 0.42403443E-06_JPRB, 0.40319418E-06_JPRB, 0.38543186E-06_JPRB, &
  & 0.37066928E-06_JPRB, 0.35887271E-06_JPRB, 0.35010322E-06_JPRB, 0.34457543E-06_JPRB, 0.34276692E-06_JPRB, 0.34469986E-06_JPRB, &
  & 0.35043448E-06_JPRB, 0.35905569E-06_JPRB, 0.37478924E-06_JPRB, 0.40514590E-06_JPRB /)

RGHG2(:,15, 7) = (/ &
  & 0.25786360E-06_JPRB, 0.27170856E-06_JPRB, 0.27563883E-06_JPRB, 0.27604597E-06_JPRB, 0.27558951E-06_JPRB, 0.27565190E-06_JPRB, &
  & 0.27775971E-06_JPRB, 0.28369325E-06_JPRB, 0.29465789E-06_JPRB, 0.31136770E-06_JPRB, 0.33328365E-06_JPRB, 0.35873617E-06_JPRB, &
  & 0.38536308E-06_JPRB, 0.41053721E-06_JPRB, 0.43183724E-06_JPRB, 0.44765602E-06_JPRB, 0.45746424E-06_JPRB, 0.46159221E-06_JPRB, &
  & 0.46147849E-06_JPRB, 0.45897721E-06_JPRB, 0.45588718E-06_JPRB, 0.45373298E-06_JPRB, 0.45383482E-06_JPRB, 0.45748934E-06_JPRB, &
  & 0.46612541E-06_JPRB, 0.48139674E-06_JPRB, 0.50530338E-06_JPRB, 0.53952795E-06_JPRB, 0.58440668E-06_JPRB, 0.63890349E-06_JPRB, &
  & 0.69952171E-06_JPRB, 0.76006791E-06_JPRB, 0.81516811E-06_JPRB, 0.86089739E-06_JPRB, 0.89445462E-06_JPRB, 0.91485452E-06_JPRB, &
  & 0.92342458E-06_JPRB, 0.92144114E-06_JPRB, 0.91061639E-06_JPRB, 0.89263187E-06_JPRB, 0.86910285E-06_JPRB, 0.84137679E-06_JPRB, &
  & 0.81044533E-06_JPRB, 0.77723791E-06_JPRB, 0.74265387E-06_JPRB, 0.70782039E-06_JPRB, 0.67366193E-06_JPRB, 0.64106155E-06_JPRB, &
  & 0.61089571E-06_JPRB, 0.58376213E-06_JPRB, 0.55980331E-06_JPRB, 0.53889471E-06_JPRB, 0.52082862E-06_JPRB, 0.50541826E-06_JPRB, &
  & 0.49257534E-06_JPRB, 0.48232351E-06_JPRB, 0.47482337E-06_JPRB, 0.47038699E-06_JPRB, 0.46962705E-06_JPRB, 0.47266545E-06_JPRB, &
  & 0.47946668E-06_JPRB, 0.48920890E-06_JPRB, 0.50587636E-06_JPRB, 0.53773647E-06_JPRB /)

RGHG2(:,16, 7) = (/ &
  & 0.41628201E-06_JPRB, 0.41684160E-06_JPRB, 0.41332459E-06_JPRB, 0.40891052E-06_JPRB, 0.40364881E-06_JPRB, 0.39932073E-06_JPRB, &
  & 0.39710312E-06_JPRB, 0.39880010E-06_JPRB, 0.40598098E-06_JPRB, 0.41933771E-06_JPRB, 0.43866993E-06_JPRB, 0.46251665E-06_JPRB, &
  & 0.48859033E-06_JPRB, 0.51456078E-06_JPRB, 0.53820901E-06_JPRB, 0.55772972E-06_JPRB, 0.57252572E-06_JPRB, 0.58321592E-06_JPRB, &
  & 0.59076302E-06_JPRB, 0.59641474E-06_JPRB, 0.60136335E-06_JPRB, 0.60667844E-06_JPRB, 0.61341075E-06_JPRB, 0.62276138E-06_JPRB, &
  & 0.63614760E-06_JPRB, 0.65518788E-06_JPRB, 0.68139400E-06_JPRB, 0.71579075E-06_JPRB, 0.75811761E-06_JPRB, 0.80670844E-06_JPRB, &
  & 0.85765680E-06_JPRB, 0.90620335E-06_JPRB, 0.94892425E-06_JPRB, 0.98223586E-06_JPRB, 0.10051896E-05_JPRB, 0.10180014E-05_JPRB, &
  & 0.10211833E-05_JPRB, 0.10160106E-05_JPRB, 0.10043645E-05_JPRB, 0.98751786E-06_JPRB, 0.96626195E-06_JPRB, 0.94130155E-06_JPRB, &
  & 0.91340883E-06_JPRB, 0.88322611E-06_JPRB, 0.85191743E-06_JPRB, 0.82029618E-06_JPRB, 0.78936165E-06_JPRB, 0.76007353E-06_JPRB, &
  & 0.73316488E-06_JPRB, 0.70884823E-06_JPRB, 0.68711506E-06_JPRB, 0.66777795E-06_JPRB, 0.65068809E-06_JPRB, 0.63578966E-06_JPRB, &
  & 0.62316440E-06_JPRB, 0.61298670E-06_JPRB, 0.60549939E-06_JPRB, 0.60105941E-06_JPRB, 0.60030158E-06_JPRB, 0.60339949E-06_JPRB, &
  & 0.60999719E-06_JPRB, 0.61976459E-06_JPRB, 0.63538602E-06_JPRB, 0.66598739E-06_JPRB /)

RGHG2(:,17, 7) = (/ &
  & 0.56610446E-06_JPRB, 0.55796238E-06_JPRB, 0.54751979E-06_JPRB, 0.53915124E-06_JPRB, 0.52977646E-06_JPRB, 0.52128803E-06_JPRB, &
  & 0.51475644E-06_JPRB, 0.51204461E-06_JPRB, 0.51485813E-06_JPRB, 0.52426469E-06_JPRB, 0.54065180E-06_JPRB, 0.56302309E-06_JPRB, &
  & 0.58968334E-06_JPRB, 0.61844224E-06_JPRB, 0.64737725E-06_JPRB, 0.67494858E-06_JPRB, 0.70004256E-06_JPRB, 0.72232228E-06_JPRB, &
  & 0.74228359E-06_JPRB, 0.76056637E-06_JPRB, 0.77802736E-06_JPRB, 0.79563108E-06_JPRB, 0.81441135E-06_JPRB, 0.83545342E-06_JPRB, &
  & 0.85969498E-06_JPRB, 0.88775090E-06_JPRB, 0.91972817E-06_JPRB, 0.95413043E-06_JPRB, 0.98903786E-06_JPRB, 0.10216738E-05_JPRB, &
  & 0.10512197E-05_JPRB, 0.10757935E-05_JPRB, 0.10945390E-05_JPRB, 0.11067564E-05_JPRB, 0.11125708E-05_JPRB, 0.11124781E-05_JPRB, &
  & 0.11079736E-05_JPRB, 0.11008175E-05_JPRB, 0.10907644E-05_JPRB, 0.10779447E-05_JPRB, 0.10622704E-05_JPRB, 0.10436805E-05_JPRB, &
  & 0.10222568E-05_JPRB, 0.99834642E-06_JPRB, 0.97258271E-06_JPRB, 0.94591343E-06_JPRB, 0.91911301E-06_JPRB, 0.89316688E-06_JPRB, &
  & 0.86847564E-06_JPRB, 0.84530700E-06_JPRB, 0.82375988E-06_JPRB, 0.80385450E-06_JPRB, 0.78566904E-06_JPRB, 0.76937772E-06_JPRB, &
  & 0.75527947E-06_JPRB, 0.74371616E-06_JPRB, 0.73500161E-06_JPRB, 0.72948473E-06_JPRB, 0.72769512E-06_JPRB, 0.72973307E-06_JPRB, &
  & 0.73509301E-06_JPRB, 0.74371223E-06_JPRB, 0.75684159E-06_JPRB, 0.78395834E-06_JPRB /)

RGHG2(:,18, 7) = (/ &
  & 0.69653248E-06_JPRB, 0.68225779E-06_JPRB, 0.66880244E-06_JPRB, 0.65790698E-06_JPRB, 0.64635020E-06_JPRB, 0.63532616E-06_JPRB, &
  & 0.62586059E-06_JPRB, 0.61979262E-06_JPRB, 0.61913340E-06_JPRB, 0.62540727E-06_JPRB, 0.63943907E-06_JPRB, 0.66095663E-06_JPRB, &
  & 0.68893468E-06_JPRB, 0.72186577E-06_JPRB, 0.75790081E-06_JPRB, 0.79503934E-06_JPRB, 0.83153611E-06_JPRB, 0.86617308E-06_JPRB, &
  & 0.89853245E-06_JPRB, 0.92907624E-06_JPRB, 0.95858888E-06_JPRB, 0.98802934E-06_JPRB, 0.10184799E-05_JPRB, 0.10508614E-05_JPRB, &
  & 0.10851753E-05_JPRB, 0.11200091E-05_JPRB, 0.11529623E-05_JPRB, 0.11818838E-05_JPRB, 0.12047497E-05_JPRB, 0.12207918E-05_JPRB, &
  & 0.12292516E-05_JPRB, 0.12313843E-05_JPRB, 0.12278506E-05_JPRB, 0.12200555E-05_JPRB, 0.12096792E-05_JPRB, 0.11988874E-05_JPRB, &
  & 0.11887306E-05_JPRB, 0.11793729E-05_JPRB, 0.11714852E-05_JPRB, 0.11640094E-05_JPRB, 0.11555662E-05_JPRB, 0.11449170E-05_JPRB, &
  & 0.11314048E-05_JPRB, 0.11148095E-05_JPRB, 0.10954923E-05_JPRB, 0.10740548E-05_JPRB, 0.10512094E-05_JPRB, 0.10277350E-05_JPRB, &
  & 0.10041180E-05_JPRB, 0.98075861E-06_JPRB, 0.95803330E-06_JPRB, 0.93629387E-06_JPRB, 0.91589004E-06_JPRB, 0.89730054E-06_JPRB, &
  & 0.88101109E-06_JPRB, 0.86745757E-06_JPRB, 0.85694438E-06_JPRB, 0.84976892E-06_JPRB, 0.84635371E-06_JPRB, 0.84666908E-06_JPRB, &
  & 0.85016700E-06_JPRB, 0.85664504E-06_JPRB, 0.86685895E-06_JPRB, 0.88911224E-06_JPRB /)

RGHG2(:,19, 7) = (/ &
  & 0.80666445E-06_JPRB, 0.78966247E-06_JPRB, 0.77587208E-06_JPRB, 0.76385663E-06_JPRB, 0.75168356E-06_JPRB, 0.73960405E-06_JPRB, &
  & 0.72863730E-06_JPRB, 0.72059976E-06_JPRB, 0.71763600E-06_JPRB, 0.72169803E-06_JPRB, 0.73403396E-06_JPRB, 0.75495348E-06_JPRB, &
  & 0.78390673E-06_JPRB, 0.81975185E-06_JPRB, 0.86075920E-06_JPRB, 0.90470036E-06_JPRB, 0.94893056E-06_JPRB, 0.99127510E-06_JPRB, &
  & 0.10306587E-05_JPRB, 0.10673007E-05_JPRB, 0.11023267E-05_JPRB, 0.11369756E-05_JPRB, 0.11721511E-05_JPRB, 0.12084788E-05_JPRB, &
  & 0.12453735E-05_JPRB, 0.12810559E-05_JPRB, 0.13128819E-05_JPRB, 0.13375158E-05_JPRB, 0.13532740E-05_JPRB, 0.13594880E-05_JPRB, &
  & 0.13571355E-05_JPRB, 0.13472306E-05_JPRB, 0.13316458E-05_JPRB, 0.13124379E-05_JPRB, 0.12919310E-05_JPRB, 0.12735742E-05_JPRB, &
  & 0.12593598E-05_JPRB, 0.12502669E-05_JPRB, 0.12455673E-05_JPRB, 0.12434020E-05_JPRB, 0.12414725E-05_JPRB, 0.12378964E-05_JPRB, &
  & 0.12312933E-05_JPRB, 0.12210518E-05_JPRB, 0.12072337E-05_JPRB, 0.11902409E-05_JPRB, 0.11707123E-05_JPRB, 0.11492770E-05_JPRB, &
  & 0.11264704E-05_JPRB, 0.11028856E-05_JPRB, 0.10791252E-05_JPRB, 0.10557740E-05_JPRB, 0.10334419E-05_JPRB, 0.10128892E-05_JPRB, &
  & 0.99473607E-06_JPRB, 0.97942541E-06_JPRB, 0.96721521E-06_JPRB, 0.95834071E-06_JPRB, 0.95314186E-06_JPRB, 0.95153899E-06_JPRB, &
  & 0.95293439E-06_JPRB, 0.95700887E-06_JPRB, 0.96435497E-06_JPRB, 0.98119040E-06_JPRB /)

RGHG2(:,20, 7) = (/ &
  & 0.90106846E-06_JPRB, 0.88291256E-06_JPRB, 0.86981350E-06_JPRB, 0.85794790E-06_JPRB, 0.84605466E-06_JPRB, 0.83396714E-06_JPRB, &
  & 0.82263165E-06_JPRB, 0.81363072E-06_JPRB, 0.80921620E-06_JPRB, 0.81167241E-06_JPRB, 0.82238842E-06_JPRB, 0.84201571E-06_JPRB, &
  & 0.87039695E-06_JPRB, 0.90652941E-06_JPRB, 0.94879999E-06_JPRB, 0.99461818E-06_JPRB, 0.10410304E-05_JPRB, 0.10854392E-05_JPRB, &
  & 0.11266148E-05_JPRB, 0.11645558E-05_JPRB, 0.12001944E-05_JPRB, 0.12349760E-05_JPRB, 0.12700805E-05_JPRB, 0.13059312E-05_JPRB, &
  & 0.13419560E-05_JPRB, 0.13763192E-05_JPRB, 0.14060394E-05_JPRB, 0.14282973E-05_JPRB, 0.14414547E-05_JPRB, 0.14452368E-05_JPRB, &
  & 0.14403220E-05_JPRB, 0.14275580E-05_JPRB, 0.14086480E-05_JPRB, 0.13861486E-05_JPRB, 0.13625742E-05_JPRB, 0.13419296E-05_JPRB, &
  & 0.13265313E-05_JPRB, 0.13178496E-05_JPRB, 0.13147785E-05_JPRB, 0.13155127E-05_JPRB, 0.13174674E-05_JPRB, 0.13181157E-05_JPRB, &
  & 0.13158441E-05_JPRB, 0.13098446E-05_JPRB, 0.12998703E-05_JPRB, 0.12861223E-05_JPRB, 0.12691170E-05_JPRB, 0.12494185E-05_JPRB, &
  & 0.12276624E-05_JPRB, 0.12045479E-05_JPRB, 0.11807638E-05_JPRB, 0.11569304E-05_JPRB, 0.11339423E-05_JPRB, 0.11125801E-05_JPRB, &
  & 0.10935006E-05_JPRB, 0.10771582E-05_JPRB, 0.10637837E-05_JPRB, 0.10535624E-05_JPRB, 0.10467708E-05_JPRB, 0.10433423E-05_JPRB, &
  & 0.10427527E-05_JPRB, 0.10446405E-05_JPRB, 0.10492810E-05_JPRB, 0.10610386E-05_JPRB /)

RGHG2(:,21, 7) = (/ &
  & 0.98360204E-06_JPRB, 0.96535700E-06_JPRB, 0.95323833E-06_JPRB, 0.94208940E-06_JPRB, 0.93079336E-06_JPRB, 0.91922584E-06_JPRB, &
  & 0.90791997E-06_JPRB, 0.89852801E-06_JPRB, 0.89321594E-06_JPRB, 0.89424981E-06_JPRB, 0.90317536E-06_JPRB, 0.92078318E-06_JPRB, &
  & 0.94696384E-06_JPRB, 0.98091732E-06_JPRB, 0.10209767E-05_JPRB, 0.10647967E-05_JPRB, 0.11094107E-05_JPRB, 0.11522172E-05_JPRB, &
  & 0.11917899E-05_JPRB, 0.12282936E-05_JPRB, 0.12625769E-05_JPRB, 0.12957942E-05_JPRB, 0.13291843E-05_JPRB, 0.13633921E-05_JPRB, &
  & 0.13978440E-05_JPRB, 0.14307860E-05_JPRB, 0.14595647E-05_JPRB, 0.14814121E-05_JPRB, 0.14948417E-05_JPRB, 0.14996327E-05_JPRB, &
  & 0.14961452E-05_JPRB, 0.14850986E-05_JPRB, 0.14678312E-05_JPRB, 0.14465325E-05_JPRB, 0.14242139E-05_JPRB, 0.14044919E-05_JPRB, &
  & 0.13896325E-05_JPRB, 0.13812161E-05_JPRB, 0.13792501E-05_JPRB, 0.13810977E-05_JPRB, 0.13842374E-05_JPRB, 0.13863940E-05_JPRB, &
  & 0.13857999E-05_JPRB, 0.13814741E-05_JPRB, 0.13732262E-05_JPRB, 0.13612751E-05_JPRB, 0.13459612E-05_JPRB, 0.13277995E-05_JPRB, &
  & 0.13074019E-05_JPRB, 0.12854381E-05_JPRB, 0.12624902E-05_JPRB, 0.12393808E-05_JPRB, 0.12169056E-05_JPRB, 0.11958502E-05_JPRB, &
  & 0.11768354E-05_JPRB, 0.11602854E-05_JPRB, 0.11464213E-05_JPRB, 0.11353973E-05_JPRB, 0.11274641E-05_JPRB, 0.11225604E-05_JPRB, &
  & 0.11202656E-05_JPRB, 0.11202392E-05_JPRB, 0.11225638E-05_JPRB, 0.11301381E-05_JPRB /)

RGHG2(:,22, 7) = (/ &
  & 0.10574255E-05_JPRB, 0.10398512E-05_JPRB, 0.10283966E-05_JPRB, 0.10180141E-05_JPRB, 0.10074546E-05_JPRB, 0.99639396E-06_JPRB, &
  & 0.98543057E-06_JPRB, 0.97585689E-06_JPRB, 0.96996098E-06_JPRB, 0.96976044E-06_JPRB, 0.97680561E-06_JPRB, 0.99185991E-06_JPRB, &
  & 0.10149212E-05_JPRB, 0.10451806E-05_JPRB, 0.10811966E-05_JPRB, 0.11207480E-05_JPRB, 0.11612934E-05_JPRB, 0.12005969E-05_JPRB, &
  & 0.12373907E-05_JPRB, 0.12714988E-05_JPRB, 0.13037742E-05_JPRB, 0.13352612E-05_JPRB, 0.13669217E-05_JPRB, 0.13995192E-05_JPRB, &
  & 0.14325572E-05_JPRB, 0.14646604E-05_JPRB, 0.14930298E-05_JPRB, 0.15153900E-05_JPRB, 0.15303320E-05_JPRB, 0.15374125E-05_JPRB, &
  & 0.15368490E-05_JPRB, 0.15293912E-05_JPRB, 0.15160617E-05_JPRB, 0.14989646E-05_JPRB, 0.14805423E-05_JPRB, 0.14635768E-05_JPRB, &
  & 0.14508026E-05_JPRB, 0.14435431E-05_JPRB, 0.14409370E-05_JPRB, 0.14419254E-05_JPRB, 0.14440624E-05_JPRB, 0.14454092E-05_JPRB, &
  & 0.14443759E-05_JPRB, 0.14401576E-05_JPRB, 0.14323371E-05_JPRB, 0.14209107E-05_JPRB, 0.14062775E-05_JPRB, 0.13889997E-05_JPRB, &
  & 0.13697031E-05_JPRB, 0.13488840E-05_JPRB, 0.13272382E-05_JPRB, 0.13054510E-05_JPRB, 0.12842418E-05_JPRB, 0.12643078E-05_JPRB, &
  & 0.12461323E-05_JPRB, 0.12300525E-05_JPRB, 0.12162606E-05_JPRB, 0.12049375E-05_JPRB, 0.11963227E-05_JPRB, 0.11904127E-05_JPRB, &
  & 0.11868458E-05_JPRB, 0.11853015E-05_JPRB, 0.11856941E-05_JPRB, 0.11897572E-05_JPRB /)

RGHG2(:,23, 7) = (/ &
  & 0.11238366E-05_JPRB, 0.11069018E-05_JPRB, 0.10965175E-05_JPRB, 0.10868928E-05_JPRB, 0.10770748E-05_JPRB, 0.10667434E-05_JPRB, &
  & 0.10562107E-05_JPRB, 0.10468982E-05_JPRB, 0.10406781E-05_JPRB, 0.10395227E-05_JPRB, 0.10448772E-05_JPRB, 0.10574777E-05_JPRB, &
  & 0.10772560E-05_JPRB, 0.11035037E-05_JPRB, 0.11348895E-05_JPRB, 0.11695605E-05_JPRB, 0.12053999E-05_JPRB, 0.12405660E-05_JPRB, &
  & 0.12740239E-05_JPRB, 0.13056741E-05_JPRB, 0.13359955E-05_JPRB, 0.13659020E-05_JPRB, 0.13961373E-05_JPRB, 0.14271735E-05_JPRB, &
  & 0.14589010E-05_JPRB, 0.14898482E-05_JPRB, 0.15178914E-05_JPRB, 0.15406800E-05_JPRB, 0.15568243E-05_JPRB, 0.15661095E-05_JPRB, &
  & 0.15687855E-05_JPRB, 0.15654591E-05_JPRB, 0.15570517E-05_JPRB, 0.15453754E-05_JPRB, 0.15320572E-05_JPRB, 0.15195923E-05_JPRB, &
  & 0.15095463E-05_JPRB, 0.15029123E-05_JPRB, 0.14996481E-05_JPRB, 0.14985685E-05_JPRB, 0.14981368E-05_JPRB, 0.14969214E-05_JPRB, &
  & 0.14937928E-05_JPRB, 0.14879456E-05_JPRB, 0.14791465E-05_JPRB, 0.14674629E-05_JPRB, 0.14530948E-05_JPRB, 0.14364592E-05_JPRB, &
  & 0.14180570E-05_JPRB, 0.13985134E-05_JPRB, 0.13784116E-05_JPRB, 0.13583177E-05_JPRB, 0.13388596E-05_JPRB, 0.13204962E-05_JPRB, &
  & 0.13035922E-05_JPRB, 0.12884072E-05_JPRB, 0.12751015E-05_JPRB, 0.12638433E-05_JPRB, 0.12549034E-05_JPRB, 0.12483149E-05_JPRB, &
  & 0.12438381E-05_JPRB, 0.12411708E-05_JPRB, 0.12401186E-05_JPRB, 0.12415170E-05_JPRB /)

RGHG2(:,24, 7) = (/ &
  & 0.11829275E-05_JPRB, 0.11678458E-05_JPRB, 0.11582263E-05_JPRB, 0.11495769E-05_JPRB, 0.11407019E-05_JPRB, 0.11312859E-05_JPRB, &
  & 0.11216853E-05_JPRB, 0.11129840E-05_JPRB, 0.11069639E-05_JPRB, 0.11054127E-05_JPRB, 0.11096524E-05_JPRB, 0.11203396E-05_JPRB, &
  & 0.11374174E-05_JPRB, 0.11601974E-05_JPRB, 0.11874884E-05_JPRB, 0.12177393E-05_JPRB, 0.12492313E-05_JPRB, 0.12805523E-05_JPRB, &
  & 0.13108697E-05_JPRB, 0.13400058E-05_JPRB, 0.13683116E-05_JPRB, 0.13963555E-05_JPRB, 0.14247973E-05_JPRB, 0.14540033E-05_JPRB, &
  & 0.14836204E-05_JPRB, 0.15126001E-05_JPRB, 0.15390810E-05_JPRB, 0.15613232E-05_JPRB, 0.15782832E-05_JPRB, 0.15894094E-05_JPRB, &
  & 0.15949556E-05_JPRB, 0.15955300E-05_JPRB, 0.15919990E-05_JPRB, 0.15855903E-05_JPRB, 0.15776329E-05_JPRB, 0.15696089E-05_JPRB, &
  & 0.15625179E-05_JPRB, 0.15569642E-05_JPRB, 0.15526432E-05_JPRB, 0.15492839E-05_JPRB, 0.15458505E-05_JPRB, 0.15415986E-05_JPRB, &
  & 0.15357193E-05_JPRB, 0.15277517E-05_JPRB, 0.15173614E-05_JPRB, 0.15046063E-05_JPRB, 0.14898631E-05_JPRB, 0.14735169E-05_JPRB, &
  & 0.14560505E-05_JPRB, 0.14379109E-05_JPRB, 0.14195050E-05_JPRB, 0.14013248E-05_JPRB, 0.13837222E-05_JPRB, 0.13670578E-05_JPRB, &
  & 0.13516136E-05_JPRB, 0.13375549E-05_JPRB, 0.13250152E-05_JPRB, 0.13141547E-05_JPRB, 0.13052180E-05_JPRB, 0.12982947E-05_JPRB, &
  & 0.12932102E-05_JPRB, 0.12897092E-05_JPRB, 0.12874897E-05_JPRB, 0.12865790E-05_JPRB /)

RGHG2(:,25, 7) = (/ &
  & 0.12359660E-05_JPRB, 0.12223395E-05_JPRB, 0.12141032E-05_JPRB, 0.12065411E-05_JPRB, 0.11989067E-05_JPRB, 0.11908168E-05_JPRB, &
  & 0.11825441E-05_JPRB, 0.11750494E-05_JPRB, 0.11699027E-05_JPRB, 0.11687088E-05_JPRB, 0.11726653E-05_JPRB, 0.11823485E-05_JPRB, &
  & 0.11976963E-05_JPRB, 0.12180611E-05_JPRB, 0.12423885E-05_JPRB, 0.12692900E-05_JPRB, 0.12973870E-05_JPRB, 0.13255134E-05_JPRB, &
  & 0.13530187E-05_JPRB, 0.13797313E-05_JPRB, 0.14058065E-05_JPRB, 0.14316286E-05_JPRB, 0.14575036E-05_JPRB, 0.14837759E-05_JPRB, &
  & 0.15101870E-05_JPRB, 0.15359200E-05_JPRB, 0.15598457E-05_JPRB, 0.15805163E-05_JPRB, 0.15969815E-05_JPRB, 0.16090578E-05_JPRB, &
  & 0.16167781E-05_JPRB, 0.16205380E-05_JPRB, 0.16210431E-05_JPRB, 0.16190628E-05_JPRB, 0.16154986E-05_JPRB, 0.16110199E-05_JPRB, &
  & 0.16063022E-05_JPRB, 0.16015759E-05_JPRB, 0.15965896E-05_JPRB, 0.15914280E-05_JPRB, 0.15855142E-05_JPRB, 0.15785363E-05_JPRB, &
  & 0.15701862E-05_JPRB, 0.15602200E-05_JPRB, 0.15485773E-05_JPRB, 0.15352045E-05_JPRB, 0.15202712E-05_JPRB, 0.15041803E-05_JPRB, &
  & 0.14874515E-05_JPRB, 0.14704600E-05_JPRB, 0.14535830E-05_JPRB, 0.14370622E-05_JPRB, 0.14211978E-05_JPRB, 0.14062285E-05_JPRB, &
  & 0.13922557E-05_JPRB, 0.13794030E-05_JPRB, 0.13677625E-05_JPRB, 0.13574828E-05_JPRB, 0.13488039E-05_JPRB, 0.13418315E-05_JPRB, &
  & 0.13364580E-05_JPRB, 0.13324549E-05_JPRB, 0.13294530E-05_JPRB, 0.13267530E-05_JPRB /)

RGHG2(:,26, 7) = (/ &
  & 0.12828192E-05_JPRB, 0.12714355E-05_JPRB, 0.12645148E-05_JPRB, 0.12583354E-05_JPRB, 0.12521255E-05_JPRB, 0.12456615E-05_JPRB, &
  & 0.12391043E-05_JPRB, 0.12333537E-05_JPRB, 0.12297190E-05_JPRB, 0.12296216E-05_JPRB, 0.12341063E-05_JPRB, 0.12436965E-05_JPRB, &
  & 0.12583019E-05_JPRB, 0.12773465E-05_JPRB, 0.12998147E-05_JPRB, 0.13245168E-05_JPRB, 0.13501680E-05_JPRB, 0.13758304E-05_JPRB, &
  & 0.14008750E-05_JPRB, 0.14250697E-05_JPRB, 0.14484223E-05_JPRB, 0.14712570E-05_JPRB, 0.14938098E-05_JPRB, 0.15161216E-05_JPRB, &
  & 0.15383289E-05_JPRB, 0.15598730E-05_JPRB, 0.15801030E-05_JPRB, 0.15983512E-05_JPRB, 0.16138779E-05_JPRB, 0.16261157E-05_JPRB, &
  & 0.16351264E-05_JPRB, 0.16411353E-05_JPRB, 0.16445156E-05_JPRB, 0.16457061E-05_JPRB, 0.16451821E-05_JPRB, 0.16432340E-05_JPRB, &
  & 0.16401300E-05_JPRB, 0.16359430E-05_JPRB, 0.16306487E-05_JPRB, 0.16241574E-05_JPRB, 0.16165590E-05_JPRB, 0.16075966E-05_JPRB, &
  & 0.15974072E-05_JPRB, 0.15858012E-05_JPRB, 0.15729171E-05_JPRB, 0.15588425E-05_JPRB, 0.15439281E-05_JPRB, 0.15285234E-05_JPRB, &
  & 0.15129011E-05_JPRB, 0.14973576E-05_JPRB, 0.14820772E-05_JPRB, 0.14673246E-05_JPRB, 0.14532441E-05_JPRB, 0.14399131E-05_JPRB, &
  & 0.14273949E-05_JPRB, 0.14157519E-05_JPRB, 0.14050603E-05_JPRB, 0.13954706E-05_JPRB, 0.13872087E-05_JPRB, 0.13803948E-05_JPRB, &
  & 0.13749678E-05_JPRB, 0.13707322E-05_JPRB, 0.13672922E-05_JPRB, 0.13636432E-05_JPRB /)

RGHG2(:,27, 7) = (/ &
  & 0.13245619E-05_JPRB, 0.13155251E-05_JPRB, 0.13100698E-05_JPRB, 0.13052954E-05_JPRB, 0.13006268E-05_JPRB, 0.12958519E-05_JPRB, &
  & 0.12912421E-05_JPRB, 0.12874721E-05_JPRB, 0.12857299E-05_JPRB, 0.12871955E-05_JPRB, 0.12927641E-05_JPRB, 0.13028455E-05_JPRB, &
  & 0.13173810E-05_JPRB, 0.13357846E-05_JPRB, 0.13571582E-05_JPRB, 0.13803382E-05_JPRB, 0.14042189E-05_JPRB, 0.14278517E-05_JPRB, &
  & 0.14506389E-05_JPRB, 0.14721885E-05_JPRB, 0.14926377E-05_JPRB, 0.15122921E-05_JPRB, 0.15309014E-05_JPRB, 0.15489857E-05_JPRB, &
  & 0.15666685E-05_JPRB, 0.15836674E-05_JPRB, 0.16000058E-05_JPRB, 0.16152776E-05_JPRB, 0.16290645E-05_JPRB, 0.16409381E-05_JPRB, &
  & 0.16506068E-05_JPRB, 0.16579814E-05_JPRB, 0.16631557E-05_JPRB, 0.16662800E-05_JPRB, 0.16675389E-05_JPRB, 0.16670238E-05_JPRB, &
  & 0.16648221E-05_JPRB, 0.16609384E-05_JPRB, 0.16554862E-05_JPRB, 0.16483175E-05_JPRB, 0.16397480E-05_JPRB, 0.16297223E-05_JPRB, &
  & 0.16184679E-05_JPRB, 0.16060347E-05_JPRB, 0.15925863E-05_JPRB, 0.15783670E-05_JPRB, 0.15637474E-05_JPRB, 0.15491000E-05_JPRB, &
  & 0.15346784E-05_JPRB, 0.15206047E-05_JPRB, 0.15069900E-05_JPRB, 0.14939137E-05_JPRB, 0.14814440E-05_JPRB, 0.14696286E-05_JPRB, &
  & 0.14584541E-05_JPRB, 0.14479588E-05_JPRB, 0.14382183E-05_JPRB, 0.14293721E-05_JPRB, 0.14216215E-05_JPRB, 0.14150808E-05_JPRB, &
  & 0.14097138E-05_JPRB, 0.14053409E-05_JPRB, 0.14015332E-05_JPRB, 0.13967953E-05_JPRB /)

RGHG2(:,28, 7) = (/ &
  & 0.13624147E-05_JPRB, 0.13553180E-05_JPRB, 0.13512146E-05_JPRB, 0.13477413E-05_JPRB, 0.13444557E-05_JPRB, 0.13413039E-05_JPRB, &
  & 0.13384885E-05_JPRB, 0.13366953E-05_JPRB, 0.13368724E-05_JPRB, 0.13400131E-05_JPRB, 0.13468104E-05_JPRB, 0.13576231E-05_JPRB, &
  & 0.13722986E-05_JPRB, 0.13903355E-05_JPRB, 0.14108487E-05_JPRB, 0.14328170E-05_JPRB, 0.14551391E-05_JPRB, 0.14769992E-05_JPRB, &
  & 0.14976373E-05_JPRB, 0.15167412E-05_JPRB, 0.15344940E-05_JPRB, 0.15508956E-05_JPRB, 0.15658508E-05_JPRB, 0.15799915E-05_JPRB, &
  & 0.15934587E-05_JPRB, 0.16064191E-05_JPRB, 0.16190983E-05_JPRB, 0.16314667E-05_JPRB, 0.16433714E-05_JPRB, 0.16543706E-05_JPRB, &
  & 0.16639675E-05_JPRB, 0.16719117E-05_JPRB, 0.16779945E-05_JPRB, 0.16821203E-05_JPRB, 0.16842696E-05_JPRB, 0.16844364E-05_JPRB, &
  & 0.16826418E-05_JPRB, 0.16788938E-05_JPRB, 0.16733306E-05_JPRB, 0.16659635E-05_JPRB, 0.16568914E-05_JPRB, 0.16464552E-05_JPRB, &
  & 0.16347481E-05_JPRB, 0.16220872E-05_JPRB, 0.16086274E-05_JPRB, 0.15947933E-05_JPRB, 0.15809408E-05_JPRB, 0.15673787E-05_JPRB, &
  & 0.15542594E-05_JPRB, 0.15416417E-05_JPRB, 0.15295117E-05_JPRB, 0.15179187E-05_JPRB, 0.15068837E-05_JPRB, 0.14963846E-05_JPRB, &
  & 0.14863997E-05_JPRB, 0.14769508E-05_JPRB, 0.14681085E-05_JPRB, 0.14599856E-05_JPRB, 0.14527557E-05_JPRB, 0.14465338E-05_JPRB, &
  & 0.14413107E-05_JPRB, 0.14369294E-05_JPRB, 0.14329561E-05_JPRB, 0.14278778E-05_JPRB /)

RGHG2(:,29, 7) = (/ &
  & 0.13962165E-05_JPRB, 0.13910069E-05_JPRB, 0.13880110E-05_JPRB, 0.13856543E-05_JPRB, 0.13835743E-05_JPRB, 0.13817664E-05_JPRB, &
  & 0.13805253E-05_JPRB, 0.13804353E-05_JPRB, 0.13823138E-05_JPRB, 0.13869518E-05_JPRB, 0.13948927E-05_JPRB, 0.14063280E-05_JPRB, &
  & 0.14211287E-05_JPRB, 0.14387479E-05_JPRB, 0.14584232E-05_JPRB, 0.14791655E-05_JPRB, 0.15000408E-05_JPRB, 0.15201946E-05_JPRB, &
  & 0.15389468E-05_JPRB, 0.15559297E-05_JPRB, 0.15712212E-05_JPRB, 0.15848381E-05_JPRB, 0.15968340E-05_JPRB, 0.16076561E-05_JPRB, &
  & 0.16176598E-05_JPRB, 0.16272364E-05_JPRB, 0.16367831E-05_JPRB, 0.16465797E-05_JPRB, 0.16565494E-05_JPRB, 0.16664272E-05_JPRB, &
  & 0.16756456E-05_JPRB, 0.16836383E-05_JPRB, 0.16900376E-05_JPRB, 0.16945544E-05_JPRB, 0.16970473E-05_JPRB, 0.16974614E-05_JPRB, &
  & 0.16958155E-05_JPRB, 0.16921365E-05_JPRB, 0.16865285E-05_JPRB, 0.16791433E-05_JPRB, 0.16700465E-05_JPRB, 0.16594730E-05_JPRB, &
  & 0.16478149E-05_JPRB, 0.16352399E-05_JPRB, 0.16222101E-05_JPRB, 0.16090847E-05_JPRB, 0.15962537E-05_JPRB, 0.15839594E-05_JPRB, &
  & 0.15722575E-05_JPRB, 0.15610361E-05_JPRB, 0.15502842E-05_JPRB, 0.15400028E-05_JPRB, 0.15301927E-05_JPRB, 0.15208294E-05_JPRB, &
  & 0.15118871E-05_JPRB, 0.15033908E-05_JPRB, 0.14953816E-05_JPRB, 0.14879679E-05_JPRB, 0.14813045E-05_JPRB, 0.14755090E-05_JPRB, &
  & 0.14705894E-05_JPRB, 0.14664034E-05_JPRB, 0.14625531E-05_JPRB, 0.14572972E-05_JPRB /)

RGHG2(:,30, 7) = (/ &
  & 0.14262448E-05_JPRB, 0.14226088E-05_JPRB, 0.14206405E-05_JPRB, 0.14191783E-05_JPRB, 0.14180432E-05_JPRB, 0.14173222E-05_JPRB, &
  & 0.14173197E-05_JPRB, 0.14185969E-05_JPRB, 0.14218556E-05_JPRB, 0.14277027E-05_JPRB, 0.14365017E-05_JPRB, 0.14483941E-05_JPRB, &
  & 0.14631256E-05_JPRB, 0.14802275E-05_JPRB, 0.14989550E-05_JPRB, 0.15184747E-05_JPRB, 0.15379001E-05_JPRB, 0.15565025E-05_JPRB, &
  & 0.15736047E-05_JPRB, 0.15888425E-05_JPRB, 0.16021215E-05_JPRB, 0.16135591E-05_JPRB, 0.16232424E-05_JPRB, 0.16315548E-05_JPRB, &
  & 0.16389313E-05_JPRB, 0.16459147E-05_JPRB, 0.16530728E-05_JPRB, 0.16607288E-05_JPRB, 0.16690270E-05_JPRB, 0.16776381E-05_JPRB, &
  & 0.16861295E-05_JPRB, 0.16938163E-05_JPRB, 0.17001223E-05_JPRB, 0.17046478E-05_JPRB, 0.17071665E-05_JPRB, 0.17076055E-05_JPRB, &
  & 0.17060019E-05_JPRB, 0.17024186E-05_JPRB, 0.16969093E-05_JPRB, 0.16896443E-05_JPRB, 0.16807289E-05_JPRB, 0.16704296E-05_JPRB, &
  & 0.16590386E-05_JPRB, 0.16469764E-05_JPRB, 0.16346548E-05_JPRB, 0.16224232E-05_JPRB, 0.16107628E-05_JPRB, 0.15997189E-05_JPRB, &
  & 0.15893095E-05_JPRB, 0.15793514E-05_JPRB, 0.15697623E-05_JPRB, 0.15605915E-05_JPRB, 0.15518157E-05_JPRB, 0.15434027E-05_JPRB, &
  & 0.15353604E-05_JPRB, 0.15276871E-05_JPRB, 0.15204330E-05_JPRB, 0.15136962E-05_JPRB, 0.15076096E-05_JPRB, 0.15022772E-05_JPRB, &
  & 0.14976965E-05_JPRB, 0.14937170E-05_JPRB, 0.14898833E-05_JPRB, 0.14842506E-05_JPRB /)

RGHG2(:,31, 7) = (/ &
  & 0.14531770E-05_JPRB, 0.14506587E-05_JPRB, 0.14494279E-05_JPRB, 0.14486487E-05_JPRB, 0.14482458E-05_JPRB, 0.14483558E-05_JPRB, &
  & 0.14493097E-05_JPRB, 0.14516571E-05_JPRB, 0.14559489E-05_JPRB, 0.14626656E-05_JPRB, 0.14720620E-05_JPRB, 0.14841254E-05_JPRB, &
  & 0.14986355E-05_JPRB, 0.15150680E-05_JPRB, 0.15327988E-05_JPRB, 0.15510723E-05_JPRB, 0.15691448E-05_JPRB, 0.15863058E-05_JPRB, &
  & 0.16019984E-05_JPRB, 0.16158235E-05_JPRB, 0.16276085E-05_JPRB, 0.16374029E-05_JPRB, 0.16453719E-05_JPRB, 0.16518795E-05_JPRB, &
  & 0.16574033E-05_JPRB, 0.16625577E-05_JPRB, 0.16679232E-05_JPRB, 0.16739037E-05_JPRB, 0.16807122E-05_JPRB, 0.16881711E-05_JPRB, &
  & 0.16958101E-05_JPRB, 0.17029322E-05_JPRB, 0.17088822E-05_JPRB, 0.17131612E-05_JPRB, 0.17155135E-05_JPRB, 0.17158731E-05_JPRB, &
  & 0.17142997E-05_JPRB, 0.17108651E-05_JPRB, 0.17056492E-05_JPRB, 0.16986857E-05_JPRB, 0.16901829E-05_JPRB, 0.16803557E-05_JPRB, &
  & 0.16695927E-05_JPRB, 0.16582305E-05_JPRB, 0.16467809E-05_JPRB, 0.16356321E-05_JPRB, 0.16250680E-05_JPRB, 0.16151863E-05_JPRB, &
  & 0.16058325E-05_JPRB, 0.15969349E-05_JPRB, 0.15882994E-05_JPRB, 0.15799909E-05_JPRB, 0.15720389E-05_JPRB, 0.15644018E-05_JPRB, &
  & 0.15570890E-05_JPRB, 0.15501088E-05_JPRB, 0.15435121E-05_JPRB, 0.15373727E-05_JPRB, 0.15318088E-05_JPRB, 0.15269006E-05_JPRB, &
  & 0.15226411E-05_JPRB, 0.15188832E-05_JPRB, 0.15152261E-05_JPRB, 0.15099721E-05_JPRB /)

RGHG2(:,32, 7) = (/ &
  & 0.14771458E-05_JPRB, 0.14754280E-05_JPRB, 0.14747809E-05_JPRB, 0.14745453E-05_JPRB, 0.14747276E-05_JPRB, 0.14754978E-05_JPRB, &
  & 0.14772219E-05_JPRB, 0.14803552E-05_JPRB, 0.14854047E-05_JPRB, 0.14926907E-05_JPRB, 0.15023652E-05_JPRB, 0.15143901E-05_JPRB, &
  & 0.15284625E-05_JPRB, 0.15441402E-05_JPRB, 0.15608290E-05_JPRB, 0.15779002E-05_JPRB, 0.15947040E-05_JPRB, 0.16106175E-05_JPRB, &
  & 0.16251142E-05_JPRB, 0.16378045E-05_JPRB, 0.16484789E-05_JPRB, 0.16571280E-05_JPRB, 0.16639135E-05_JPRB, 0.16692007E-05_JPRB, &
  & 0.16734954E-05_JPRB, 0.16774092E-05_JPRB, 0.16815126E-05_JPRB, 0.16862555E-05_JPRB, 0.16918493E-05_JPRB, 0.16982258E-05_JPRB, &
  & 0.17049398E-05_JPRB, 0.17113542E-05_JPRB, 0.17167404E-05_JPRB, 0.17205981E-05_JPRB, 0.17226610E-05_JPRB, 0.17228899E-05_JPRB, &
  & 0.17213682E-05_JPRB, 0.17181814E-05_JPRB, 0.17133555E-05_JPRB, 0.17069647E-05_JPRB, 0.16990383E-05_JPRB, 0.16899220E-05_JPRB, &
  & 0.16799661E-05_JPRB, 0.16695853E-05_JPRB, 0.16591133E-05_JPRB, 0.16489855E-05_JPRB, 0.16394205E-05_JPRB, 0.16304875E-05_JPRB, &
  & 0.16219778E-05_JPRB, 0.16138197E-05_JPRB, 0.16059265E-05_JPRB, 0.15982799E-05_JPRB, 0.15909443E-05_JPRB, 0.15839134E-05_JPRB, &
  & 0.15771872E-05_JPRB, 0.15707833E-05_JPRB, 0.15647424E-05_JPRB, 0.15591249E-05_JPRB, 0.15540228E-05_JPRB, 0.15495049E-05_JPRB, &
  & 0.15455621E-05_JPRB, 0.15420586E-05_JPRB, 0.15385892E-05_JPRB, 0.15333137E-05_JPRB /)

RGHG2(:,33, 7) = (/ &
  & 0.14981576E-05_JPRB, 0.14973500E-05_JPRB, 0.14972134E-05_JPRB, 0.14974513E-05_JPRB, 0.14981318E-05_JPRB, 0.14994669E-05_JPRB, &
  & 0.15017829E-05_JPRB, 0.15055389E-05_JPRB, 0.15110728E-05_JPRB, 0.15186472E-05_JPRB, 0.15283590E-05_JPRB, 0.15400861E-05_JPRB, &
  & 0.15535892E-05_JPRB, 0.15684066E-05_JPRB, 0.15840693E-05_JPRB, 0.15999856E-05_JPRB, 0.16156471E-05_JPRB, 0.16304667E-05_JPRB, &
  & 0.16439759E-05_JPRB, 0.16557947E-05_JPRB, 0.16656710E-05_JPRB, 0.16735534E-05_JPRB, 0.16795710E-05_JPRB, 0.16841133E-05_JPRB, &
  & 0.16876692E-05_JPRB, 0.16907974E-05_JPRB, 0.16940775E-05_JPRB, 0.16978954E-05_JPRB, 0.17025108E-05_JPRB, 0.17078946E-05_JPRB, &
  & 0.17136985E-05_JPRB, 0.17192740E-05_JPRB, 0.17239645E-05_JPRB, 0.17272664E-05_JPRB, 0.17289636E-05_JPRB, 0.17290384E-05_JPRB, &
  & 0.17275952E-05_JPRB, 0.17247107E-05_JPRB, 0.17204138E-05_JPRB, 0.17146700E-05_JPRB, 0.17075915E-05_JPRB, 0.16993779E-05_JPRB, &
  & 0.16903876E-05_JPRB, 0.16810891E-05_JPRB, 0.16716772E-05_JPRB, 0.16625307E-05_JPRB, 0.16537269E-05_JPRB, 0.16455012E-05_JPRB, &
  & 0.16376414E-05_JPRB, 0.16299911E-05_JPRB, 0.16225895E-05_JPRB, 0.16154237E-05_JPRB, 0.16085385E-05_JPRB, 0.16019740E-05_JPRB, &
  & 0.15957150E-05_JPRB, 0.15897854E-05_JPRB, 0.15842160E-05_JPRB, 0.15790442E-05_JPRB, 0.15743539E-05_JPRB, 0.15701978E-05_JPRB, &
  & 0.15665564E-05_JPRB, 0.15632971E-05_JPRB, 0.15600435E-05_JPRB, 0.15550945E-05_JPRB /)

RGHG2(:,34, 7) = (/ &
  & 0.15170070E-05_JPRB, 0.15169695E-05_JPRB, 0.15172716E-05_JPRB, 0.15179276E-05_JPRB, 0.15190526E-05_JPRB, 0.15208558E-05_JPRB, &
  & 0.15236747E-05_JPRB, 0.15278393E-05_JPRB, 0.15336593E-05_JPRB, 0.15412958E-05_JPRB, 0.15507951E-05_JPRB, 0.15620712E-05_JPRB, &
  & 0.15748531E-05_JPRB, 0.15887846E-05_JPRB, 0.16034257E-05_JPRB, 0.16183016E-05_JPRB, 0.16329114E-05_JPRB, 0.16467992E-05_JPRB, &
  & 0.16594894E-05_JPRB, 0.16706441E-05_JPRB, 0.16799816E-05_JPRB, 0.16873751E-05_JPRB, 0.16929904E-05_JPRB, 0.16971462E-05_JPRB, &
  & 0.17003376E-05_JPRB, 0.17030213E-05_JPRB, 0.17057844E-05_JPRB, 0.17089577E-05_JPRB, 0.17127861E-05_JPRB, 0.17172800E-05_JPRB, &
  & 0.17221292E-05_JPRB, 0.17267997E-05_JPRB, 0.17306746E-05_JPRB, 0.17333396E-05_JPRB, 0.17346231E-05_JPRB, 0.17345320E-05_JPRB, &
  & 0.17331895E-05_JPRB, 0.17306454E-05_JPRB, 0.17268993E-05_JPRB, 0.17219420E-05_JPRB, 0.17157651E-05_JPRB, 0.17086055E-05_JPRB, &
  & 0.17007883E-05_JPRB, 0.16925261E-05_JPRB, 0.16841965E-05_JPRB, 0.16758850E-05_JPRB, 0.16677740E-05_JPRB, 0.16599594E-05_JPRB, &
  & 0.16525530E-05_JPRB, 0.16452495E-05_JPRB, 0.16381600E-05_JPRB, 0.16313297E-05_JPRB, 0.16247839E-05_JPRB, 0.16185704E-05_JPRB, &
  & 0.16126900E-05_JPRB, 0.16071529E-05_JPRB, 0.16019721E-05_JPRB, 0.15971865E-05_JPRB, 0.15928534E-05_JPRB, 0.15890173E-05_JPRB, &
  & 0.15856485E-05_JPRB, 0.15826231E-05_JPRB, 0.15795518E-05_JPRB, 0.15748400E-05_JPRB /)

RGHG2(:,35, 7) = (/ &
  & 0.15341249E-05_JPRB, 0.15347098E-05_JPRB, 0.15354130E-05_JPRB, 0.15364490E-05_JPRB, 0.15379605E-05_JPRB, 0.15401620E-05_JPRB, &
  & 0.15433285E-05_JPRB, 0.15477660E-05_JPRB, 0.15536722E-05_JPRB, 0.15611716E-05_JPRB, 0.15703164E-05_JPRB, 0.15809859E-05_JPRB, &
  & 0.15930037E-05_JPRB, 0.16060184E-05_JPRB, 0.16197010E-05_JPRB, 0.16335978E-05_JPRB, 0.16473027E-05_JPRB, 0.16603645E-05_JPRB, &
  & 0.16723886E-05_JPRB, 0.16830166E-05_JPRB, 0.16919922E-05_JPRB, 0.16991817E-05_JPRB, 0.17046832E-05_JPRB, 0.17087398E-05_JPRB, &
  & 0.17118074E-05_JPRB, 0.17143366E-05_JPRB, 0.17167879E-05_JPRB, 0.17194925E-05_JPRB, 0.17226545E-05_JPRB, 0.17262987E-05_JPRB, &
  & 0.17301903E-05_JPRB, 0.17338697E-05_JPRB, 0.17368645E-05_JPRB, 0.17388468E-05_JPRB, 0.17397049E-05_JPRB, 0.17394589E-05_JPRB, &
  & 0.17382308E-05_JPRB, 0.17360200E-05_JPRB, 0.17328684E-05_JPRB, 0.17286845E-05_JPRB, 0.17234790E-05_JPRB, 0.17174157E-05_JPRB, &
  & 0.17107039E-05_JPRB, 0.17035890E-05_JPRB, 0.16961790E-05_JPRB, 0.16886733E-05_JPRB, 0.16810811E-05_JPRB, 0.16736383E-05_JPRB, &
  & 0.16664671E-05_JPRB, 0.16594050E-05_JPRB, 0.16525132E-05_JPRB, 0.16459167E-05_JPRB, 0.16396268E-05_JPRB, 0.16336970E-05_JPRB, &
  & 0.16281249E-05_JPRB, 0.16229106E-05_JPRB, 0.16180625E-05_JPRB, 0.16135996E-05_JPRB, 0.16095805E-05_JPRB, 0.16060342E-05_JPRB, &
  & 0.16029275E-05_JPRB, 0.16001253E-05_JPRB, 0.15972920E-05_JPRB, 0.15928812E-05_JPRB /)

RGHG2(:,36, 7) = (/ &
  & 0.15498624E-05_JPRB, 0.15510122E-05_JPRB, 0.15520716E-05_JPRB, 0.15534328E-05_JPRB, 0.15552638E-05_JPRB, 0.15577571E-05_JPRB, &
  & 0.15611557E-05_JPRB, 0.15656869E-05_JPRB, 0.15715186E-05_JPRB, 0.15787584E-05_JPRB, 0.15874145E-05_JPRB, 0.15974327E-05_JPRB, &
  & 0.16086320E-05_JPRB, 0.16207674E-05_JPRB, 0.16335148E-05_JPRB, 0.16465301E-05_JPRB, 0.16593976E-05_JPRB, 0.16717605E-05_JPRB, &
  & 0.16832474E-05_JPRB, 0.16935080E-05_JPRB, 0.17022965E-05_JPRB, 0.17094543E-05_JPRB, 0.17149700E-05_JPRB, 0.17190944E-05_JPRB, &
  & 0.17221768E-05_JPRB, 0.17246530E-05_JPRB, 0.17269123E-05_JPRB, 0.17292294E-05_JPRB, 0.17317900E-05_JPRB, 0.17346124E-05_JPRB, &
  & 0.17375273E-05_JPRB, 0.17402147E-05_JPRB, 0.17423226E-05_JPRB, 0.17436529E-05_JPRB, 0.17441233E-05_JPRB, 0.17437735E-05_JPRB, &
  & 0.17426812E-05_JPRB, 0.17408265E-05_JPRB, 0.17382605E-05_JPRB, 0.17348385E-05_JPRB, 0.17305570E-05_JPRB, 0.17255561E-05_JPRB, &
  & 0.17199231E-05_JPRB, 0.17137772E-05_JPRB, 0.17072764E-05_JPRB, 0.17004069E-05_JPRB, 0.16933053E-05_JPRB, 0.16861916E-05_JPRB, &
  & 0.16792101E-05_JPRB, 0.16722922E-05_JPRB, 0.16655636E-05_JPRB, 0.16591486E-05_JPRB, 0.16530719E-05_JPRB, 0.16473828E-05_JPRB, &
  & 0.16420743E-05_JPRB, 0.16371393E-05_JPRB, 0.16325688E-05_JPRB, 0.16283911E-05_JPRB, 0.16246504E-05_JPRB, 0.16213734E-05_JPRB, &
  & 0.16185139E-05_JPRB, 0.16159436E-05_JPRB, 0.16133176E-05_JPRB, 0.16092362E-05_JPRB /)

RGHG2(:,37, 7) = (/ &
  & 0.15646444E-05_JPRB, 0.15663018E-05_JPRB, 0.15676480E-05_JPRB, 0.15692759E-05_JPRB, 0.15713374E-05_JPRB, 0.15740181E-05_JPRB, &
  & 0.15775029E-05_JPRB, 0.15819874E-05_JPRB, 0.15876186E-05_JPRB, 0.15944796E-05_JPRB, 0.16026027E-05_JPRB, 0.16119171E-05_JPRB, &
  & 0.16223071E-05_JPRB, 0.16335613E-05_JPRB, 0.16454295E-05_JPRB, 0.16575761E-05_JPRB, 0.16696865E-05_JPRB, 0.16814000E-05_JPRB, &
  & 0.16924165E-05_JPRB, 0.17024274E-05_JPRB, 0.17111186E-05_JPRB, 0.17182846E-05_JPRB, 0.17238574E-05_JPRB, 0.17279904E-05_JPRB, &
  & 0.17310344E-05_JPRB, 0.17333829E-05_JPRB, 0.17353880E-05_JPRB, 0.17373168E-05_JPRB, 0.17393028E-05_JPRB, 0.17413801E-05_JPRB, &
  & 0.17434263E-05_JPRB, 0.17452417E-05_JPRB, 0.17466109E-05_JPRB, 0.17474082E-05_JPRB, 0.17476031E-05_JPRB, 0.17472132E-05_JPRB, &
  & 0.17463033E-05_JPRB, 0.17448231E-05_JPRB, 0.17428309E-05_JPRB, 0.17401226E-05_JPRB, 0.17367818E-05_JPRB, 0.17327390E-05_JPRB, &
  & 0.17280634E-05_JPRB, 0.17228514E-05_JPRB, 0.17170994E-05_JPRB, 0.17108647E-05_JPRB, 0.17042569E-05_JPRB, 0.16974784E-05_JPRB, &
  & 0.16906628E-05_JPRB, 0.16838833E-05_JPRB, 0.16773200E-05_JPRB, 0.16710725E-05_JPRB, 0.16651968E-05_JPRB, 0.16597323E-05_JPRB, &
  & 0.16546649E-05_JPRB, 0.16499722E-05_JPRB, 0.16456522E-05_JPRB, 0.16417250E-05_JPRB, 0.16382405E-05_JPRB, 0.16352160E-05_JPRB, &
  & 0.16325996E-05_JPRB, 0.16302497E-05_JPRB, 0.16278589E-05_JPRB, 0.16241156E-05_JPRB /)

RGHG2(:,38, 7) = (/ &
  & 0.15788561E-05_JPRB, 0.15808788E-05_JPRB, 0.15824555E-05_JPRB, 0.15842429E-05_JPRB, 0.15864719E-05_JPRB, 0.15892266E-05_JPRB, &
  & 0.15926846E-05_JPRB, 0.15970120E-05_JPRB, 0.16023307E-05_JPRB, 0.16087461E-05_JPRB, 0.16162842E-05_JPRB, 0.16248945E-05_JPRB, &
  & 0.16344686E-05_JPRB, 0.16448587E-05_JPRB, 0.16558472E-05_JPRB, 0.16671615E-05_JPRB, 0.16785041E-05_JPRB, 0.16896004E-05_JPRB, &
  & 0.17001689E-05_JPRB, 0.17098951E-05_JPRB, 0.17184652E-05_JPRB, 0.17255132E-05_JPRB, 0.17309192E-05_JPRB, 0.17348394E-05_JPRB, &
  & 0.17376133E-05_JPRB, 0.17396690E-05_JPRB, 0.17413572E-05_JPRB, 0.17428999E-05_JPRB, 0.17444175E-05_JPRB, 0.17459270E-05_JPRB, &
  & 0.17473512E-05_JPRB, 0.17485684E-05_JPRB, 0.17494408E-05_JPRB, 0.17498975E-05_JPRB, 0.17499309E-05_JPRB, 0.17495563E-05_JPRB, &
  & 0.17488171E-05_JPRB, 0.17476789E-05_JPRB, 0.17461650E-05_JPRB, 0.17441345E-05_JPRB, 0.17416055E-05_JPRB, 0.17384625E-05_JPRB, &
  & 0.17347319E-05_JPRB, 0.17303928E-05_JPRB, 0.17254325E-05_JPRB, 0.17198564E-05_JPRB, 0.17137722E-05_JPRB, 0.17073521E-05_JPRB, &
  & 0.17007590E-05_JPRB, 0.16941872E-05_JPRB, 0.16878137E-05_JPRB, 0.16817638E-05_JPRB, 0.16761002E-05_JPRB, 0.16708627E-05_JPRB, &
  & 0.16660246E-05_JPRB, 0.16615592E-05_JPRB, 0.16574614E-05_JPRB, 0.16537626E-05_JPRB, 0.16505144E-05_JPRB, 0.16477308E-05_JPRB, &
  & 0.16453473E-05_JPRB, 0.16432195E-05_JPRB, 0.16410551E-05_JPRB, 0.16376589E-05_JPRB /)

RGHG2(:,39, 7) = (/ &
  & 0.15926588E-05_JPRB, 0.15949186E-05_JPRB, 0.15966042E-05_JPRB, 0.15985318E-05_JPRB, 0.16008070E-05_JPRB, 0.16035874E-05_JPRB, &
  & 0.16069428E-05_JPRB, 0.16110199E-05_JPRB, 0.16159661E-05_JPRB, 0.16218837E-05_JPRB, 0.16288022E-05_JPRB, 0.16367011E-05_JPRB, &
  & 0.16454742E-05_JPRB, 0.16550023E-05_JPRB, 0.16651147E-05_JPRB, 0.16755753E-05_JPRB, 0.16861411E-05_JPRB, 0.16965838E-05_JPRB, &
  & 0.17066459E-05_JPRB, 0.17160324E-05_JPRB, 0.17242592E-05_JPRB, 0.17309738E-05_JPRB, 0.17359824E-05_JPRB, 0.17394822E-05_JPRB, &
  & 0.17418902E-05_JPRB, 0.17436333E-05_JPRB, 0.17450354E-05_JPRB, 0.17462913E-05_JPRB, 0.17474858E-05_JPRB, 0.17486340E-05_JPRB, &
  & 0.17496817E-05_JPRB, 0.17505431E-05_JPRB, 0.17511300E-05_JPRB, 0.17513921E-05_JPRB, 0.17513393E-05_JPRB, 0.17509828E-05_JPRB, &
  & 0.17503653E-05_JPRB, 0.17494576E-05_JPRB, 0.17482861E-05_JPRB, 0.17467537E-05_JPRB, 0.17448558E-05_JPRB, 0.17424882E-05_JPRB, &
  & 0.17396309E-05_JPRB, 0.17361806E-05_JPRB, 0.17320683E-05_JPRB, 0.17272440E-05_JPRB, 0.17217691E-05_JPRB, 0.17157925E-05_JPRB, &
  & 0.17095425E-05_JPRB, 0.17032394E-05_JPRB, 0.16971105E-05_JPRB, 0.16912950E-05_JPRB, 0.16858734E-05_JPRB, 0.16808767E-05_JPRB, &
  & 0.16762675E-05_JPRB, 0.16720157E-05_JPRB, 0.16681233E-05_JPRB, 0.16646347E-05_JPRB, 0.16616077E-05_JPRB, 0.16590520E-05_JPRB, &
  & 0.16568888E-05_JPRB, 0.16549710E-05_JPRB, 0.16530192E-05_JPRB, 0.16499763E-05_JPRB /)

RGHG2(:,40, 7) = (/ &
  & 0.16060231E-05_JPRB, 0.16084163E-05_JPRB, 0.16101910E-05_JPRB, 0.16121255E-05_JPRB, 0.16144821E-05_JPRB, 0.16172105E-05_JPRB, &
  & 0.16204211E-05_JPRB, 0.16242327E-05_JPRB, 0.16287620E-05_JPRB, 0.16341370E-05_JPRB, 0.16404312E-05_JPRB, 0.16476072E-05_JPRB, &
  & 0.16555871E-05_JPRB, 0.16642670E-05_JPRB, 0.16734964E-05_JPRB, 0.16830827E-05_JPRB, 0.16928312E-05_JPRB, 0.17025484E-05_JPRB, &
  & 0.17120278E-05_JPRB, 0.17208845E-05_JPRB, 0.17286833E-05_JPRB, 0.17349007E-05_JPRB, 0.17394265E-05_JPRB, 0.17425102E-05_JPRB, &
  & 0.17445903E-05_JPRB, 0.17460875E-05_JPRB, 0.17472871E-05_JPRB, 0.17483449E-05_JPRB, 0.17493315E-05_JPRB, 0.17502550E-05_JPRB, &
  & 0.17510775E-05_JPRB, 0.17517377E-05_JPRB, 0.17521600E-05_JPRB, 0.17523141E-05_JPRB, 0.17522101E-05_JPRB, 0.17518704E-05_JPRB, &
  & 0.17513207E-05_JPRB, 0.17505581E-05_JPRB, 0.17495967E-05_JPRB, 0.17483856E-05_JPRB, 0.17469158E-05_JPRB, 0.17451229E-05_JPRB, &
  & 0.17429599E-05_JPRB, 0.17403030E-05_JPRB, 0.17370395E-05_JPRB, 0.17330294E-05_JPRB, 0.17282579E-05_JPRB, 0.17228526E-05_JPRB, &
  & 0.17170262E-05_JPRB, 0.17110835E-05_JPRB, 0.17052645E-05_JPRB, 0.16997377E-05_JPRB, 0.16945939E-05_JPRB, 0.16898521E-05_JPRB, &
  & 0.16854780E-05_JPRB, 0.16814307E-05_JPRB, 0.16777346E-05_JPRB, 0.16744393E-05_JPRB, 0.16716223E-05_JPRB, 0.16692791E-05_JPRB, &
  & 0.16673223E-05_JPRB, 0.16655936E-05_JPRB, 0.16638480E-05_JPRB, 0.16611093E-05_JPRB /)

RGHG2(:,41, 7) = (/ &
  & 0.16190197E-05_JPRB, 0.16214556E-05_JPRB, 0.16231799E-05_JPRB, 0.16251686E-05_JPRB, 0.16274907E-05_JPRB, 0.16302039E-05_JPRB, &
  & 0.16332740E-05_JPRB, 0.16367894E-05_JPRB, 0.16408989E-05_JPRB, 0.16457354E-05_JPRB, 0.16513767E-05_JPRB, 0.16578351E-05_JPRB, &
  & 0.16650324E-05_JPRB, 0.16728668E-05_JPRB, 0.16812128E-05_JPRB, 0.16899105E-05_JPRB, 0.16987906E-05_JPRB, 0.17077350E-05_JPRB, &
  & 0.17165302E-05_JPRB, 0.17248391E-05_JPRB, 0.17320666E-05_JPRB, 0.17377804E-05_JPRB, 0.17418490E-05_JPRB, 0.17445733E-05_JPRB, &
  & 0.17463982E-05_JPRB, 0.17477122E-05_JPRB, 0.17487639E-05_JPRB, 0.17496857E-05_JPRB, 0.17505296E-05_JPRB, 0.17513067E-05_JPRB, &
  & 0.17519922E-05_JPRB, 0.17525274E-05_JPRB, 0.17528549E-05_JPRB, 0.17529438E-05_JPRB, 0.17528102E-05_JPRB, 0.17524810E-05_JPRB, &
  & 0.17519756E-05_JPRB, 0.17513036E-05_JPRB, 0.17504705E-05_JPRB, 0.17494665E-05_JPRB, 0.17482752E-05_JPRB, 0.17468687E-05_JPRB, &
  & 0.17452178E-05_JPRB, 0.17431749E-05_JPRB, 0.17406470E-05_JPRB, 0.17374132E-05_JPRB, 0.17334046E-05_JPRB, 0.17286197E-05_JPRB, &
  & 0.17233259E-05_JPRB, 0.17177991E-05_JPRB, 0.17123455E-05_JPRB, 0.17071563E-05_JPRB, 0.17023189E-05_JPRB, 0.16978631E-05_JPRB, &
  & 0.16937290E-05_JPRB, 0.16898985E-05_JPRB, 0.16863835E-05_JPRB, 0.16832780E-05_JPRB, 0.16806543E-05_JPRB, 0.16785111E-05_JPRB, &
  & 0.16767399E-05_JPRB, 0.16751861E-05_JPRB, 0.16736080E-05_JPRB, 0.16711510E-05_JPRB /)

RGHG2(:,42, 7) = (/ &
  & 0.16321648E-05_JPRB, 0.16341020E-05_JPRB, 0.16357036E-05_JPRB, 0.16376031E-05_JPRB, 0.16399900E-05_JPRB, 0.16426587E-05_JPRB, &
  & 0.16455922E-05_JPRB, 0.16488516E-05_JPRB, 0.16525490E-05_JPRB, 0.16568411E-05_JPRB, 0.16618467E-05_JPRB, 0.16675879E-05_JPRB, &
  & 0.16740041E-05_JPRB, 0.16810071E-05_JPRB, 0.16884737E-05_JPRB, 0.16962586E-05_JPRB, 0.17042611E-05_JPRB, 0.17123539E-05_JPRB, &
  & 0.17204145E-05_JPRB, 0.17280665E-05_JPRB, 0.17347814E-05_JPRB, 0.17400117E-05_JPRB, 0.17436782E-05_JPRB, 0.17460987E-05_JPRB, &
  & 0.17477158E-05_JPRB, 0.17488861E-05_JPRB, 0.17498248E-05_JPRB, 0.17506404E-05_JPRB, 0.17513819E-05_JPRB, 0.17520589E-05_JPRB, &
  & 0.17526511E-05_JPRB, 0.17531111E-05_JPRB, 0.17533768E-05_JPRB, 0.17534264E-05_JPRB, 0.17532756E-05_JPRB, 0.17529535E-05_JPRB, &
  & 0.17524799E-05_JPRB, 0.17518653E-05_JPRB, 0.17511234E-05_JPRB, 0.17502476E-05_JPRB, 0.17492471E-05_JPRB, 0.17481043E-05_JPRB, &
  & 0.17468044E-05_JPRB, 0.17452257E-05_JPRB, 0.17432773E-05_JPRB, 0.17407282E-05_JPRB, 0.17374321E-05_JPRB, 0.17333333E-05_JPRB, &
  & 0.17285904E-05_JPRB, 0.17235268E-05_JPRB, 0.17184698E-05_JPRB, 0.17136467E-05_JPRB, 0.17091554E-05_JPRB, 0.17049952E-05_JPRB, &
  & 0.17011324E-05_JPRB, 0.16975152E-05_JPRB, 0.16941973E-05_JPRB, 0.16912695E-05_JPRB, 0.16888356E-05_JPRB, 0.16868754E-05_JPRB, &
  & 0.16852731E-05_JPRB, 0.16838669E-05_JPRB, 0.16824373E-05_JPRB, 0.16801979E-05_JPRB /)

RGHG2(:,43, 7) = (/ &
  & 0.16434153E-05_JPRB, 0.16458159E-05_JPRB, 0.16475274E-05_JPRB, 0.16495759E-05_JPRB, 0.16519907E-05_JPRB, 0.16547084E-05_JPRB, &
  & 0.16575364E-05_JPRB, 0.16605536E-05_JPRB, 0.16638693E-05_JPRB, 0.16676510E-05_JPRB, 0.16720304E-05_JPRB, 0.16770633E-05_JPRB, &
  & 0.16827128E-05_JPRB, 0.16888876E-05_JPRB, 0.16954700E-05_JPRB, 0.17023553E-05_JPRB, 0.17094278E-05_JPRB, 0.17166712E-05_JPRB, &
  & 0.17239420E-05_JPRB, 0.17309596E-05_JPRB, 0.17371001E-05_JPRB, 0.17418666E-05_JPRB, 0.17451555E-05_JPRB, 0.17473068E-05_JPRB, &
  & 0.17487455E-05_JPRB, 0.17497941E-05_JPRB, 0.17506391E-05_JPRB, 0.17513719E-05_JPRB, 0.17520342E-05_JPRB, 0.17526392E-05_JPRB, &
  & 0.17531705E-05_JPRB, 0.17535776E-05_JPRB, 0.17538066E-05_JPRB, 0.17538310E-05_JPRB, 0.17536702E-05_JPRB, 0.17533546E-05_JPRB, &
  & 0.17529037E-05_JPRB, 0.17523319E-05_JPRB, 0.17516481E-05_JPRB, 0.17508671E-05_JPRB, 0.17499951E-05_JPRB, 0.17490346E-05_JPRB, &
  & 0.17479900E-05_JPRB, 0.17467531E-05_JPRB, 0.17452505E-05_JPRB, 0.17432683E-05_JPRB, 0.17406346E-05_JPRB, 0.17371938E-05_JPRB, &
  & 0.17330251E-05_JPRB, 0.17284331E-05_JPRB, 0.17237835E-05_JPRB, 0.17193452E-05_JPRB, 0.17152074E-05_JPRB, 0.17113738E-05_JPRB, &
  & 0.17077909E-05_JPRB, 0.17044212E-05_JPRB, 0.17013003E-05_JPRB, 0.16985636E-05_JPRB, 0.16963114E-05_JPRB, 0.16945246E-05_JPRB, &
  & 0.16930735E-05_JPRB, 0.16917957E-05_JPRB, 0.16904829E-05_JPRB, 0.16884096E-05_JPRB /)

RGHG2(:,44, 7) = (/ &
  & 0.16547002E-05_JPRB, 0.16574289E-05_JPRB, 0.16592579E-05_JPRB, 0.16612780E-05_JPRB, 0.16638343E-05_JPRB, 0.16665186E-05_JPRB, &
  & 0.16692936E-05_JPRB, 0.16720787E-05_JPRB, 0.16750498E-05_JPRB, 0.16783438E-05_JPRB, 0.16821248E-05_JPRB, 0.16864714E-05_JPRB, &
  & 0.16913584E-05_JPRB, 0.16967047E-05_JPRB, 0.17024206E-05_JPRB, 0.17083688E-05_JPRB, 0.17145384E-05_JPRB, 0.17208499E-05_JPRB, &
  & 0.17273130E-05_JPRB, 0.17335990E-05_JPRB, 0.17391900E-05_JPRB, 0.17434786E-05_JPRB, 0.17464100E-05_JPRB, 0.17483102E-05_JPRB, &
  & 0.17495881E-05_JPRB, 0.17505297E-05_JPRB, 0.17512937E-05_JPRB, 0.17519581E-05_JPRB, 0.17525606E-05_JPRB, 0.17531139E-05_JPRB, &
  & 0.17536019E-05_JPRB, 0.17539776E-05_JPRB, 0.17541821E-05_JPRB, 0.17541919E-05_JPRB, 0.17540268E-05_JPRB, 0.17537169E-05_JPRB, &
  & 0.17532838E-05_JPRB, 0.17527406E-05_JPRB, 0.17521023E-05_JPRB, 0.17513837E-05_JPRB, 0.17506050E-05_JPRB, 0.17497792E-05_JPRB, &
  & 0.17489130E-05_JPRB, 0.17479438E-05_JPRB, 0.17467793E-05_JPRB, 0.17452728E-05_JPRB, 0.17432199E-05_JPRB, 0.17404092E-05_JPRB, &
  & 0.17368409E-05_JPRB, 0.17327112E-05_JPRB, 0.17284756E-05_JPRB, 0.17244099E-05_JPRB, 0.17206344E-05_JPRB, 0.17171413E-05_JPRB, &
  & 0.17138698E-05_JPRB, 0.17107650E-05_JPRB, 0.17078744E-05_JPRB, 0.17053328E-05_JPRB, 0.17032648E-05_JPRB, 0.17016412E-05_JPRB, &
  & 0.17003233E-05_JPRB, 0.16991552E-05_JPRB, 0.16979353E-05_JPRB, 0.16959840E-05_JPRB /)

RGHG2(:,45, 7) = (/ &
  & 0.16678073E-05_JPRB, 0.16697420E-05_JPRB, 0.16712112E-05_JPRB, 0.16731906E-05_JPRB, 0.16756300E-05_JPRB, 0.16784246E-05_JPRB, &
  & 0.16810443E-05_JPRB, 0.16836593E-05_JPRB, 0.16862758E-05_JPRB, 0.16891253E-05_JPRB, 0.16923289E-05_JPRB, 0.16960030E-05_JPRB, &
  & 0.17001398E-05_JPRB, 0.17046733E-05_JPRB, 0.17094827E-05_JPRB, 0.17145351E-05_JPRB, 0.17197184E-05_JPRB, 0.17251350E-05_JPRB, &
  & 0.17306864E-05_JPRB, 0.17362365E-05_JPRB, 0.17411462E-05_JPRB, 0.17449433E-05_JPRB, 0.17475015E-05_JPRB, 0.17491644E-05_JPRB, &
  & 0.17502929E-05_JPRB, 0.17511384E-05_JPRB, 0.17518315E-05_JPRB, 0.17524412E-05_JPRB, 0.17529976E-05_JPRB, 0.17535135E-05_JPRB, &
  & 0.17539738E-05_JPRB, 0.17543293E-05_JPRB, 0.17545224E-05_JPRB, 0.17545262E-05_JPRB, 0.17543605E-05_JPRB, 0.17540564E-05_JPRB, &
  & 0.17536347E-05_JPRB, 0.17531130E-05_JPRB, 0.17525052E-05_JPRB, 0.17518316E-05_JPRB, 0.17511223E-05_JPRB, 0.17503910E-05_JPRB, &
  & 0.17496661E-05_JPRB, 0.17488918E-05_JPRB, 0.17479992E-05_JPRB, 0.17468752E-05_JPRB, 0.17453175E-05_JPRB, 0.17431382E-05_JPRB, &
  & 0.17401586E-05_JPRB, 0.17365639E-05_JPRB, 0.17327307E-05_JPRB, 0.17290326E-05_JPRB, 0.17256220E-05_JPRB, 0.17224787E-05_JPRB, &
  & 0.17195368E-05_JPRB, 0.17167345E-05_JPRB, 0.17140907E-05_JPRB, 0.17117660E-05_JPRB, 0.17098785E-05_JPRB, 0.17084051E-05_JPRB, &
  & 0.17072074E-05_JPRB, 0.17061309E-05_JPRB, 0.17049875E-05_JPRB, 0.17031180E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART13',1,ZHOOK_HANDLE)
END SUBROUTINE PART13




SUBROUTINE PART14
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART14',0,ZHOOK_HANDLE)



RGHG2(:,46, 7) = (/ &
  & 0.16781403E-05_JPRB, 0.16812276E-05_JPRB, 0.16831699E-05_JPRB, 0.16852064E-05_JPRB, 0.16878890E-05_JPRB, 0.16905651E-05_JPRB, &
  & 0.16932056E-05_JPRB, 0.16955396E-05_JPRB, 0.16978547E-05_JPRB, 0.17002276E-05_JPRB, 0.17028813E-05_JPRB, 0.17058882E-05_JPRB, &
  & 0.17092756E-05_JPRB, 0.17129648E-05_JPRB, 0.17168985E-05_JPRB, 0.17209550E-05_JPRB, 0.17252090E-05_JPRB, 0.17296036E-05_JPRB, &
  & 0.17342541E-05_JPRB, 0.17388668E-05_JPRB, 0.17430698E-05_JPRB, 0.17462830E-05_JPRB, 0.17484734E-05_JPRB, 0.17498993E-05_JPRB, &
  & 0.17508902E-05_JPRB, 0.17516471E-05_JPRB, 0.17522807E-05_JPRB, 0.17528439E-05_JPRB, 0.17533667E-05_JPRB, 0.17538573E-05_JPRB, &
  & 0.17543000E-05_JPRB, 0.17546467E-05_JPRB, 0.17548365E-05_JPRB, 0.17548414E-05_JPRB, 0.17546790E-05_JPRB, 0.17543798E-05_JPRB, &
  & 0.17539660E-05_JPRB, 0.17534595E-05_JPRB, 0.17528694E-05_JPRB, 0.17522327E-05_JPRB, 0.17515652E-05_JPRB, 0.17509140E-05_JPRB, &
  & 0.17502847E-05_JPRB, 0.17496669E-05_JPRB, 0.17489858E-05_JPRB, 0.17481594E-05_JPRB, 0.17470352E-05_JPRB, 0.17454086E-05_JPRB, &
  & 0.17430955E-05_JPRB, 0.17400783E-05_JPRB, 0.17367272E-05_JPRB, 0.17334194E-05_JPRB, 0.17303691E-05_JPRB, 0.17275905E-05_JPRB, &
  & 0.17249959E-05_JPRB, 0.17225009E-05_JPRB, 0.17201371E-05_JPRB, 0.17180257E-05_JPRB, 0.17163159E-05_JPRB, 0.17149769E-05_JPRB, &
  & 0.17138819E-05_JPRB, 0.17128839E-05_JPRB, 0.17118023E-05_JPRB, 0.17099957E-05_JPRB /)

RGHG2(:,47, 7) = (/ &
  & 0.16920734E-05_JPRB, 0.16943950E-05_JPRB, 0.16960630E-05_JPRB, 0.16982027E-05_JPRB, 0.17007825E-05_JPRB, 0.17036576E-05_JPRB, &
  & 0.17060403E-05_JPRB, 0.17081841E-05_JPRB, 0.17100739E-05_JPRB, 0.17119894E-05_JPRB, 0.17140361E-05_JPRB, 0.17163628E-05_JPRB, &
  & 0.17189709E-05_JPRB, 0.17218093E-05_JPRB, 0.17247760E-05_JPRB, 0.17278821E-05_JPRB, 0.17310704E-05_JPRB, 0.17344730E-05_JPRB, &
  & 0.17380158E-05_JPRB, 0.17416588E-05_JPRB, 0.17449471E-05_JPRB, 0.17475561E-05_JPRB, 0.17493415E-05_JPRB, 0.17505407E-05_JPRB, &
  & 0.17513976E-05_JPRB, 0.17520761E-05_JPRB, 0.17526556E-05_JPRB, 0.17531836E-05_JPRB, 0.17536801E-05_JPRB, 0.17541547E-05_JPRB, &
  & 0.17545906E-05_JPRB, 0.17549357E-05_JPRB, 0.17551298E-05_JPRB, 0.17551419E-05_JPRB, 0.17549855E-05_JPRB, 0.17546918E-05_JPRB, &
  & 0.17542826E-05_JPRB, 0.17537820E-05_JPRB, 0.17532105E-05_JPRB, 0.17525890E-05_JPRB, 0.17519646E-05_JPRB, 0.17513568E-05_JPRB, &
  & 0.17508123E-05_JPRB, 0.17503032E-05_JPRB, 0.17497916E-05_JPRB, 0.17492005E-05_JPRB, 0.17484272E-05_JPRB, 0.17473110E-05_JPRB, &
  & 0.17456416E-05_JPRB, 0.17433614E-05_JPRB, 0.17406012E-05_JPRB, 0.17377880E-05_JPRB, 0.17351392E-05_JPRB, 0.17327301E-05_JPRB, &
  & 0.17304770E-05_JPRB, 0.17283078E-05_JPRB, 0.17261987E-05_JPRB, 0.17243018E-05_JPRB, 0.17227412E-05_JPRB, 0.17215157E-05_JPRB, &
  & 0.17205007E-05_JPRB, 0.17195629E-05_JPRB, 0.17185261E-05_JPRB, 0.17167641E-05_JPRB /)

RGHG2(:,48, 7) = (/ &
  & 0.17032160E-05_JPRB, 0.17066398E-05_JPRB, 0.17090247E-05_JPRB, 0.17115277E-05_JPRB, 0.17146132E-05_JPRB, 0.17174676E-05_JPRB, &
  & 0.17198774E-05_JPRB, 0.17216652E-05_JPRB, 0.17231749E-05_JPRB, 0.17245584E-05_JPRB, 0.17259964E-05_JPRB, 0.17275975E-05_JPRB, &
  & 0.17293893E-05_JPRB, 0.17313178E-05_JPRB, 0.17333183E-05_JPRB, 0.17353466E-05_JPRB, 0.17374623E-05_JPRB, 0.17396696E-05_JPRB, &
  & 0.17420504E-05_JPRB, 0.17444895E-05_JPRB, 0.17468317E-05_JPRB, 0.17487517E-05_JPRB, 0.17501386E-05_JPRB, 0.17511054E-05_JPRB, &
  & 0.17518362E-05_JPRB, 0.17524385E-05_JPRB, 0.17529730E-05_JPRB, 0.17534695E-05_JPRB, 0.17539486E-05_JPRB, 0.17544146E-05_JPRB, &
  & 0.17548493E-05_JPRB, 0.17552015E-05_JPRB, 0.17554063E-05_JPRB, 0.17554303E-05_JPRB, 0.17552821E-05_JPRB, 0.17549933E-05_JPRB, &
  & 0.17545840E-05_JPRB, 0.17540906E-05_JPRB, 0.17535226E-05_JPRB, 0.17529246E-05_JPRB, 0.17523145E-05_JPRB, 0.17517518E-05_JPRB, &
  & 0.17512566E-05_JPRB, 0.17508389E-05_JPRB, 0.17504549E-05_JPRB, 0.17500521E-05_JPRB, 0.17495597E-05_JPRB, 0.17488605E-05_JPRB, &
  & 0.17478224E-05_JPRB, 0.17462989E-05_JPRB, 0.17443936E-05_JPRB, 0.17422259E-05_JPRB, 0.17401271E-05_JPRB, 0.17381436E-05_JPRB, &
  & 0.17362487E-05_JPRB, 0.17343684E-05_JPRB, 0.17324975E-05_JPRB, 0.17307526E-05_JPRB, 0.17293038E-05_JPRB, 0.17281466E-05_JPRB, &
  & 0.17271823E-05_JPRB, 0.17262780E-05_JPRB, 0.17252655E-05_JPRB, 0.17235167E-05_JPRB /)

RGHG2(:,49, 7) = (/ &
  & 0.17146742E-05_JPRB, 0.17188546E-05_JPRB, 0.17216232E-05_JPRB, 0.17246158E-05_JPRB, 0.17279636E-05_JPRB, 0.17311559E-05_JPRB, &
  & 0.17334190E-05_JPRB, 0.17350035E-05_JPRB, 0.17361610E-05_JPRB, 0.17371030E-05_JPRB, 0.17380119E-05_JPRB, 0.17389591E-05_JPRB, &
  & 0.17399879E-05_JPRB, 0.17410358E-05_JPRB, 0.17420558E-05_JPRB, 0.17430266E-05_JPRB, 0.17439768E-05_JPRB, 0.17449745E-05_JPRB, &
  & 0.17460630E-05_JPRB, 0.17473072E-05_JPRB, 0.17486623E-05_JPRB, 0.17499010E-05_JPRB, 0.17508755E-05_JPRB, 0.17516159E-05_JPRB, &
  & 0.17522204E-05_JPRB, 0.17527530E-05_JPRB, 0.17532448E-05_JPRB, 0.17537166E-05_JPRB, 0.17541815E-05_JPRB, 0.17546442E-05_JPRB, &
  & 0.17550844E-05_JPRB, 0.17554482E-05_JPRB, 0.17556688E-05_JPRB, 0.17557080E-05_JPRB, 0.17555702E-05_JPRB, 0.17552852E-05_JPRB, &
  & 0.17548739E-05_JPRB, 0.17543837E-05_JPRB, 0.17538225E-05_JPRB, 0.17532312E-05_JPRB, 0.17526415E-05_JPRB, 0.17520964E-05_JPRB, &
  & 0.17516477E-05_JPRB, 0.17512941E-05_JPRB, 0.17510116E-05_JPRB, 0.17507566E-05_JPRB, 0.17504800E-05_JPRB, 0.17501163E-05_JPRB, &
  & 0.17495736E-05_JPRB, 0.17487910E-05_JPRB, 0.17477076E-05_JPRB, 0.17464640E-05_JPRB, 0.17450852E-05_JPRB, 0.17436914E-05_JPRB, &
  & 0.17422702E-05_JPRB, 0.17407222E-05_JPRB, 0.17390894E-05_JPRB, 0.17374909E-05_JPRB, 0.17361039E-05_JPRB, 0.17349882E-05_JPRB, &
  & 0.17340365E-05_JPRB, 0.17331392E-05_JPRB, 0.17321155E-05_JPRB, 0.17303252E-05_JPRB /)

RGHG2(:,50, 7) = (/ &
  & 0.17264617E-05_JPRB, 0.17302739E-05_JPRB, 0.17328833E-05_JPRB, 0.17357804E-05_JPRB, 0.17391202E-05_JPRB, 0.17421594E-05_JPRB, &
  & 0.17442262E-05_JPRB, 0.17455557E-05_JPRB, 0.17464097E-05_JPRB, 0.17470836E-05_JPRB, 0.17476366E-05_JPRB, 0.17481681E-05_JPRB, &
  & 0.17486529E-05_JPRB, 0.17490506E-05_JPRB, 0.17493094E-05_JPRB, 0.17494455E-05_JPRB, 0.17494993E-05_JPRB, 0.17495368E-05_JPRB, &
  & 0.17496513E-05_JPRB, 0.17499292E-05_JPRB, 0.17504028E-05_JPRB, 0.17510122E-05_JPRB, 0.17515796E-05_JPRB, 0.17520880E-05_JPRB, &
  & 0.17525668E-05_JPRB, 0.17530305E-05_JPRB, 0.17534836E-05_JPRB, 0.17539328E-05_JPRB, 0.17543880E-05_JPRB, 0.17548508E-05_JPRB, &
  & 0.17553002E-05_JPRB, 0.17556808E-05_JPRB, 0.17559208E-05_JPRB, 0.17559777E-05_JPRB, 0.17558516E-05_JPRB, 0.17555669E-05_JPRB, &
  & 0.17551573E-05_JPRB, 0.17546646E-05_JPRB, 0.17541079E-05_JPRB, 0.17535239E-05_JPRB, 0.17529430E-05_JPRB, 0.17524148E-05_JPRB, &
  & 0.17519917E-05_JPRB, 0.17516919E-05_JPRB, 0.17514884E-05_JPRB, 0.17513480E-05_JPRB, 0.17512373E-05_JPRB, 0.17511161E-05_JPRB, &
  & 0.17509367E-05_JPRB, 0.17506469E-05_JPRB, 0.17502412E-05_JPRB, 0.17496914E-05_JPRB, 0.17490642E-05_JPRB, 0.17483500E-05_JPRB, &
  & 0.17475001E-05_JPRB, 0.17465281E-05_JPRB, 0.17453340E-05_JPRB, 0.17440573E-05_JPRB, 0.17428888E-05_JPRB, 0.17418694E-05_JPRB, &
  & 0.17409853E-05_JPRB, 0.17401042E-05_JPRB, 0.17390651E-05_JPRB, 0.17371684E-05_JPRB /)

RGHG2(:,51, 7) = (/ &
  & 0.17356042E-05_JPRB, 0.17392526E-05_JPRB, 0.17416505E-05_JPRB, 0.17441147E-05_JPRB, 0.17470234E-05_JPRB, 0.17495435E-05_JPRB, &
  & 0.17512318E-05_JPRB, 0.17521753E-05_JPRB, 0.17528182E-05_JPRB, 0.17532404E-05_JPRB, 0.17535954E-05_JPRB, 0.17538741E-05_JPRB, &
  & 0.17540581E-05_JPRB, 0.17540806E-05_JPRB, 0.17539243E-05_JPRB, 0.17536238E-05_JPRB, 0.17532432E-05_JPRB, 0.17528419E-05_JPRB, &
  & 0.17524537E-05_JPRB, 0.17521852E-05_JPRB, 0.17520487E-05_JPRB, 0.17520981E-05_JPRB, 0.17522738E-05_JPRB, 0.17525402E-05_JPRB, &
  & 0.17528882E-05_JPRB, 0.17532834E-05_JPRB, 0.17536994E-05_JPRB, 0.17541295E-05_JPRB, 0.17545760E-05_JPRB, 0.17550412E-05_JPRB, &
  & 0.17555033E-05_JPRB, 0.17559032E-05_JPRB, 0.17561656E-05_JPRB, 0.17562420E-05_JPRB, 0.17561260E-05_JPRB, 0.17558464E-05_JPRB, &
  & 0.17554305E-05_JPRB, 0.17549430E-05_JPRB, 0.17543816E-05_JPRB, 0.17538075E-05_JPRB, 0.17532288E-05_JPRB, 0.17527099E-05_JPRB, &
  & 0.17523076E-05_JPRB, 0.17520474E-05_JPRB, 0.17519071E-05_JPRB, 0.17518564E-05_JPRB, 0.17518715E-05_JPRB, 0.17519242E-05_JPRB, &
  & 0.17519739E-05_JPRB, 0.17519867E-05_JPRB, 0.17519270E-05_JPRB, 0.17517957E-05_JPRB, 0.17515897E-05_JPRB, 0.17513194E-05_JPRB, &
  & 0.17509917E-05_JPRB, 0.17505283E-05_JPRB, 0.17499592E-05_JPRB, 0.17492678E-05_JPRB, 0.17485469E-05_JPRB, 0.17478937E-05_JPRB, &
  & 0.17472325E-05_JPRB, 0.17465281E-05_JPRB, 0.17455898E-05_JPRB, 0.17437379E-05_JPRB /)

RGHG2(:,52, 7) = (/ &
  & 0.17442537E-05_JPRB, 0.17466396E-05_JPRB, 0.17482755E-05_JPRB, 0.17501548E-05_JPRB, 0.17523267E-05_JPRB, 0.17542893E-05_JPRB, &
  & 0.17554494E-05_JPRB, 0.17561540E-05_JPRB, 0.17565383E-05_JPRB, 0.17568236E-05_JPRB, 0.17570176E-05_JPRB, 0.17571472E-05_JPRB, &
  & 0.17571590E-05_JPRB, 0.17569921E-05_JPRB, 0.17566404E-05_JPRB, 0.17561647E-05_JPRB, 0.17556267E-05_JPRB, 0.17550678E-05_JPRB, &
  & 0.17545544E-05_JPRB, 0.17539884E-05_JPRB, 0.17535596E-05_JPRB, 0.17531721E-05_JPRB, 0.17529787E-05_JPRB, 0.17529885E-05_JPRB, &
  & 0.17531956E-05_JPRB, 0.17535214E-05_JPRB, 0.17539028E-05_JPRB, 0.17543143E-05_JPRB, 0.17547547E-05_JPRB, 0.17552230E-05_JPRB, &
  & 0.17556982E-05_JPRB, 0.17561199E-05_JPRB, 0.17564071E-05_JPRB, 0.17565029E-05_JPRB, 0.17564003E-05_JPRB, 0.17561193E-05_JPRB, &
  & 0.17557105E-05_JPRB, 0.17552119E-05_JPRB, 0.17546585E-05_JPRB, 0.17540789E-05_JPRB, 0.17535052E-05_JPRB, 0.17529903E-05_JPRB, &
  & 0.17526038E-05_JPRB, 0.17523734E-05_JPRB, 0.17522837E-05_JPRB, 0.17523047E-05_JPRB, 0.17524185E-05_JPRB, 0.17525915E-05_JPRB, &
  & 0.17527871E-05_JPRB, 0.17529552E-05_JPRB, 0.17530691E-05_JPRB, 0.17531175E-05_JPRB, 0.17531096E-05_JPRB, 0.17530597E-05_JPRB, &
  & 0.17529642E-05_JPRB, 0.17528329E-05_JPRB, 0.17526266E-05_JPRB, 0.17523696E-05_JPRB, 0.17520945E-05_JPRB, 0.17517937E-05_JPRB, &
  & 0.17514839E-05_JPRB, 0.17510871E-05_JPRB, 0.17504956E-05_JPRB, 0.17490684E-05_JPRB /)

RGHG2(:,53, 7) = (/ &
  & 0.17497739E-05_JPRB, 0.17517677E-05_JPRB, 0.17530687E-05_JPRB, 0.17544241E-05_JPRB, 0.17560114E-05_JPRB, 0.17573548E-05_JPRB, &
  & 0.17582117E-05_JPRB, 0.17586352E-05_JPRB, 0.17589024E-05_JPRB, 0.17590548E-05_JPRB, 0.17591560E-05_JPRB, 0.17591879E-05_JPRB, &
  & 0.17591019E-05_JPRB, 0.17588341E-05_JPRB, 0.17583984E-05_JPRB, 0.17578491E-05_JPRB, 0.17572622E-05_JPRB, 0.17566942E-05_JPRB, &
  & 0.17560701E-05_JPRB, 0.17555245E-05_JPRB, 0.17548205E-05_JPRB, 0.17542438E-05_JPRB, 0.17536966E-05_JPRB, 0.17534441E-05_JPRB, &
  & 0.17534985E-05_JPRB, 0.17537523E-05_JPRB, 0.17540998E-05_JPRB, 0.17544963E-05_JPRB, 0.17549304E-05_JPRB, 0.17554025E-05_JPRB, &
  & 0.17558921E-05_JPRB, 0.17563359E-05_JPRB, 0.17566499E-05_JPRB, 0.17567656E-05_JPRB, 0.17566745E-05_JPRB, 0.17564021E-05_JPRB, &
  & 0.17559860E-05_JPRB, 0.17554914E-05_JPRB, 0.17549291E-05_JPRB, 0.17543505E-05_JPRB, 0.17537727E-05_JPRB, 0.17532615E-05_JPRB, &
  & 0.17528868E-05_JPRB, 0.17526825E-05_JPRB, 0.17526307E-05_JPRB, 0.17527088E-05_JPRB, 0.17528961E-05_JPRB, 0.17531611E-05_JPRB, &
  & 0.17534404E-05_JPRB, 0.17536948E-05_JPRB, 0.17538903E-05_JPRB, 0.17540142E-05_JPRB, 0.17540872E-05_JPRB, 0.17541242E-05_JPRB, &
  & 0.17541347E-05_JPRB, 0.17541216E-05_JPRB, 0.17540831E-05_JPRB, 0.17540166E-05_JPRB, 0.17539287E-05_JPRB, 0.17538380E-05_JPRB, &
  & 0.17537220E-05_JPRB, 0.17535733E-05_JPRB, 0.17533247E-05_JPRB, 0.17525928E-05_JPRB /)

RGHG2(:,54, 7) = (/ &
  & 0.17545972E-05_JPRB, 0.17558032E-05_JPRB, 0.17566410E-05_JPRB, 0.17575583E-05_JPRB, 0.17586199E-05_JPRB, 0.17595471E-05_JPRB, &
  & 0.17600801E-05_JPRB, 0.17603801E-05_JPRB, 0.17605250E-05_JPRB, 0.17606119E-05_JPRB, 0.17606471E-05_JPRB, 0.17606205E-05_JPRB, &
  & 0.17604771E-05_JPRB, 0.17601682E-05_JPRB, 0.17596915E-05_JPRB, 0.17591269E-05_JPRB, 0.17585382E-05_JPRB, 0.17579267E-05_JPRB, &
  & 0.17573748E-05_JPRB, 0.17566701E-05_JPRB, 0.17560403E-05_JPRB, 0.17551708E-05_JPRB, 0.17544338E-05_JPRB, 0.17539102E-05_JPRB, &
  & 0.17538052E-05_JPRB, 0.17539846E-05_JPRB, 0.17542998E-05_JPRB, 0.17546798E-05_JPRB, 0.17551106E-05_JPRB, 0.17555858E-05_JPRB, &
  & 0.17560894E-05_JPRB, 0.17565577E-05_JPRB, 0.17568974E-05_JPRB, 0.17570353E-05_JPRB, 0.17569582E-05_JPRB, 0.17566883E-05_JPRB, &
  & 0.17562770E-05_JPRB, 0.17557720E-05_JPRB, 0.17552074E-05_JPRB, 0.17546195E-05_JPRB, 0.17540360E-05_JPRB, 0.17535303E-05_JPRB, &
  & 0.17531675E-05_JPRB, 0.17529831E-05_JPRB, 0.17529609E-05_JPRB, 0.17530796E-05_JPRB, 0.17533255E-05_JPRB, 0.17536471E-05_JPRB, &
  & 0.17539912E-05_JPRB, 0.17542934E-05_JPRB, 0.17545231E-05_JPRB, 0.17546865E-05_JPRB, 0.17547911E-05_JPRB, 0.17548580E-05_JPRB, &
  & 0.17549091E-05_JPRB, 0.17549401E-05_JPRB, 0.17549594E-05_JPRB, 0.17549635E-05_JPRB, 0.17549576E-05_JPRB, 0.17549459E-05_JPRB, &
  & 0.17549296E-05_JPRB, 0.17549100E-05_JPRB, 0.17548964E-05_JPRB, 0.17549397E-05_JPRB /)

RGHG2(:,55, 7) = (/ &
  & 0.17577001E-05_JPRB, 0.17586603E-05_JPRB, 0.17592627E-05_JPRB, 0.17598979E-05_JPRB, 0.17605744E-05_JPRB, 0.17611609E-05_JPRB, &
  & 0.17615246E-05_JPRB, 0.17616917E-05_JPRB, 0.17617787E-05_JPRB, 0.17618125E-05_JPRB, 0.17618081E-05_JPRB, 0.17617460E-05_JPRB, &
  & 0.17615816E-05_JPRB, 0.17612497E-05_JPRB, 0.17607778E-05_JPRB, 0.17602131E-05_JPRB, 0.17596149E-05_JPRB, 0.17590427E-05_JPRB, &
  & 0.17583917E-05_JPRB, 0.17577986E-05_JPRB, 0.17569472E-05_JPRB, 0.17561194E-05_JPRB, 0.17551058E-05_JPRB, 0.17543821E-05_JPRB, &
  & 0.17541238E-05_JPRB, 0.17542285E-05_JPRB, 0.17545094E-05_JPRB, 0.17548763E-05_JPRB, 0.17553001E-05_JPRB, 0.17557816E-05_JPRB, &
  & 0.17563000E-05_JPRB, 0.17567914E-05_JPRB, 0.17571574E-05_JPRB, 0.17573170E-05_JPRB, 0.17572535E-05_JPRB, 0.17569914E-05_JPRB, &
  & 0.17565784E-05_JPRB, 0.17560669E-05_JPRB, 0.17554920E-05_JPRB, 0.17548922E-05_JPRB, 0.17543052E-05_JPRB, 0.17538002E-05_JPRB, &
  & 0.17534536E-05_JPRB, 0.17532869E-05_JPRB, 0.17532859E-05_JPRB, 0.17534326E-05_JPRB, 0.17537120E-05_JPRB, 0.17540818E-05_JPRB, &
  & 0.17544623E-05_JPRB, 0.17547991E-05_JPRB, 0.17550622E-05_JPRB, 0.17552358E-05_JPRB, 0.17553523E-05_JPRB, 0.17554365E-05_JPRB, &
  & 0.17554928E-05_JPRB, 0.17555429E-05_JPRB, 0.17555767E-05_JPRB, 0.17556017E-05_JPRB, 0.17556190E-05_JPRB, 0.17556307E-05_JPRB, &
  & 0.17556386E-05_JPRB, 0.17556400E-05_JPRB, 0.17556348E-05_JPRB, 0.17556159E-05_JPRB /)

RGHG2(:,56, 7) = (/ &
  & 0.17602996E-05_JPRB, 0.17608784E-05_JPRB, 0.17612724E-05_JPRB, 0.17616608E-05_JPRB, 0.17620980E-05_JPRB, 0.17624591E-05_JPRB, &
  & 0.17626712E-05_JPRB, 0.17627763E-05_JPRB, 0.17628142E-05_JPRB, 0.17628194E-05_JPRB, 0.17627924E-05_JPRB, 0.17627153E-05_JPRB, &
  & 0.17625377E-05_JPRB, 0.17622240E-05_JPRB, 0.17617622E-05_JPRB, 0.17612165E-05_JPRB, 0.17606337E-05_JPRB, 0.17600104E-05_JPRB, &
  & 0.17594191E-05_JPRB, 0.17586602E-05_JPRB, 0.17579137E-05_JPRB, 0.17568403E-05_JPRB, 0.17557602E-05_JPRB, 0.17548454E-05_JPRB, &
  & 0.17544587E-05_JPRB, 0.17544935E-05_JPRB, 0.17547404E-05_JPRB, 0.17550904E-05_JPRB, 0.17555121E-05_JPRB, 0.17559973E-05_JPRB, &
  & 0.17565324E-05_JPRB, 0.17570477E-05_JPRB, 0.17574382E-05_JPRB, 0.17576181E-05_JPRB, 0.17575684E-05_JPRB, 0.17573143E-05_JPRB, &
  & 0.17568993E-05_JPRB, 0.17563802E-05_JPRB, 0.17557921E-05_JPRB, 0.17551781E-05_JPRB, 0.17545824E-05_JPRB, 0.17540874E-05_JPRB, &
  & 0.17537532E-05_JPRB, 0.17536032E-05_JPRB, 0.17536177E-05_JPRB, 0.17537803E-05_JPRB, 0.17540821E-05_JPRB, 0.17544721E-05_JPRB, &
  & 0.17548856E-05_JPRB, 0.17552546E-05_JPRB, 0.17555300E-05_JPRB, 0.17557237E-05_JPRB, 0.17558498E-05_JPRB, 0.17559306E-05_JPRB, &
  & 0.17559969E-05_JPRB, 0.17560420E-05_JPRB, 0.17560794E-05_JPRB, 0.17561072E-05_JPRB, 0.17561283E-05_JPRB, 0.17561483E-05_JPRB, &
  & 0.17561631E-05_JPRB, 0.17561740E-05_JPRB, 0.17561781E-05_JPRB, 0.17561716E-05_JPRB /)

RGHG2(:,57, 7) = (/ &
  & 0.17620548E-05_JPRB, 0.17625264E-05_JPRB, 0.17627988E-05_JPRB, 0.17630676E-05_JPRB, 0.17633208E-05_JPRB, 0.17635411E-05_JPRB, &
  & 0.17636695E-05_JPRB, 0.17637208E-05_JPRB, 0.17637335E-05_JPRB, 0.17637218E-05_JPRB, 0.17636838E-05_JPRB, 0.17636003E-05_JPRB, &
  & 0.17634368E-05_JPRB, 0.17631371E-05_JPRB, 0.17627140E-05_JPRB, 0.17621888E-05_JPRB, 0.17616012E-05_JPRB, 0.17609912E-05_JPRB, &
  & 0.17602895E-05_JPRB, 0.17595862E-05_JPRB, 0.17586217E-05_JPRB, 0.17575722E-05_JPRB, 0.17563116E-05_JPRB, 0.17552942E-05_JPRB, &
  & 0.17548152E-05_JPRB, 0.17547879E-05_JPRB, 0.17550016E-05_JPRB, 0.17553374E-05_JPRB, 0.17557535E-05_JPRB, 0.17562469E-05_JPRB, &
  & 0.17567967E-05_JPRB, 0.17573359E-05_JPRB, 0.17577495E-05_JPRB, 0.17579476E-05_JPRB, 0.17579105E-05_JPRB, 0.17576618E-05_JPRB, &
  & 0.17572499E-05_JPRB, 0.17567177E-05_JPRB, 0.17561158E-05_JPRB, 0.17554856E-05_JPRB, 0.17548856E-05_JPRB, 0.17543950E-05_JPRB, &
  & 0.17540765E-05_JPRB, 0.17539404E-05_JPRB, 0.17539663E-05_JPRB, 0.17541385E-05_JPRB, 0.17544479E-05_JPRB, 0.17548508E-05_JPRB, &
  & 0.17552782E-05_JPRB, 0.17556665E-05_JPRB, 0.17559749E-05_JPRB, 0.17561798E-05_JPRB, 0.17563100E-05_JPRB, 0.17564014E-05_JPRB, &
  & 0.17564585E-05_JPRB, 0.17565039E-05_JPRB, 0.17565326E-05_JPRB, 0.17565535E-05_JPRB, 0.17565720E-05_JPRB, 0.17565884E-05_JPRB, &
  & 0.17566028E-05_JPRB, 0.17566113E-05_JPRB, 0.17566105E-05_JPRB, 0.17565841E-05_JPRB /)

RGHG2(:,58, 7) = (/ &
  & 0.17635571E-05_JPRB, 0.17638599E-05_JPRB, 0.17640433E-05_JPRB, 0.17642037E-05_JPRB, 0.17643669E-05_JPRB, 0.17644925E-05_JPRB, &
  & 0.17645641E-05_JPRB, 0.17645893E-05_JPRB, 0.17645875E-05_JPRB, 0.17645684E-05_JPRB, 0.17645282E-05_JPRB, 0.17644520E-05_JPRB, &
  & 0.17642997E-05_JPRB, 0.17640398E-05_JPRB, 0.17636492E-05_JPRB, 0.17631558E-05_JPRB, 0.17625750E-05_JPRB, 0.17619113E-05_JPRB, &
  & 0.17612076E-05_JPRB, 0.17603309E-05_JPRB, 0.17593800E-05_JPRB, 0.17581337E-05_JPRB, 0.17568181E-05_JPRB, 0.17557375E-05_JPRB, &
  & 0.17551995E-05_JPRB, 0.17551224E-05_JPRB, 0.17553053E-05_JPRB, 0.17556260E-05_JPRB, 0.17560401E-05_JPRB, 0.17565391E-05_JPRB, &
  & 0.17571060E-05_JPRB, 0.17576674E-05_JPRB, 0.17581019E-05_JPRB, 0.17583146E-05_JPRB, 0.17582869E-05_JPRB, 0.17580468E-05_JPRB, &
  & 0.17576317E-05_JPRB, 0.17570929E-05_JPRB, 0.17564732E-05_JPRB, 0.17558275E-05_JPRB, 0.17552215E-05_JPRB, 0.17547400E-05_JPRB, &
  & 0.17544339E-05_JPRB, 0.17543077E-05_JPRB, 0.17543412E-05_JPRB, 0.17545196E-05_JPRB, 0.17548314E-05_JPRB, 0.17552339E-05_JPRB, &
  & 0.17556670E-05_JPRB, 0.17560715E-05_JPRB, 0.17563963E-05_JPRB, 0.17566233E-05_JPRB, 0.17567708E-05_JPRB, 0.17568559E-05_JPRB, &
  & 0.17569158E-05_JPRB, 0.17569487E-05_JPRB, 0.17569662E-05_JPRB, 0.17569778E-05_JPRB, 0.17569887E-05_JPRB, 0.17570023E-05_JPRB, &
  & 0.17570133E-05_JPRB, 0.17570185E-05_JPRB, 0.17570122E-05_JPRB, 0.17569771E-05_JPRB /)

RGHG2(:,59, 7) = (/ &
  & 0.17646672E-05_JPRB, 0.17649327E-05_JPRB, 0.17650715E-05_JPRB, 0.17651867E-05_JPRB, 0.17652842E-05_JPRB, 0.17653631E-05_JPRB, &
  & 0.17654039E-05_JPRB, 0.17654149E-05_JPRB, 0.17654082E-05_JPRB, 0.17653886E-05_JPRB, 0.17653529E-05_JPRB, 0.17652840E-05_JPRB, &
  & 0.17651579E-05_JPRB, 0.17649281E-05_JPRB, 0.17645834E-05_JPRB, 0.17641155E-05_JPRB, 0.17635357E-05_JPRB, 0.17628488E-05_JPRB, &
  & 0.17620325E-05_JPRB, 0.17611255E-05_JPRB, 0.17599784E-05_JPRB, 0.17586796E-05_JPRB, 0.17572924E-05_JPRB, 0.17561894E-05_JPRB, &
  & 0.17556209E-05_JPRB, 0.17555059E-05_JPRB, 0.17556631E-05_JPRB, 0.17559711E-05_JPRB, 0.17563837E-05_JPRB, 0.17568898E-05_JPRB, &
  & 0.17574723E-05_JPRB, 0.17580542E-05_JPRB, 0.17585069E-05_JPRB, 0.17587301E-05_JPRB, 0.17587088E-05_JPRB, 0.17584712E-05_JPRB, &
  & 0.17580592E-05_JPRB, 0.17575089E-05_JPRB, 0.17568766E-05_JPRB, 0.17562153E-05_JPRB, 0.17556058E-05_JPRB, 0.17551317E-05_JPRB, &
  & 0.17548344E-05_JPRB, 0.17547168E-05_JPRB, 0.17547542E-05_JPRB, 0.17549326E-05_JPRB, 0.17552452E-05_JPRB, 0.17556454E-05_JPRB, &
  & 0.17560744E-05_JPRB, 0.17564822E-05_JPRB, 0.17568235E-05_JPRB, 0.17570749E-05_JPRB, 0.17572304E-05_JPRB, 0.17573279E-05_JPRB, &
  & 0.17573766E-05_JPRB, 0.17573980E-05_JPRB, 0.17573980E-05_JPRB, 0.17573952E-05_JPRB, 0.17573982E-05_JPRB, 0.17574071E-05_JPRB, &
  & 0.17574147E-05_JPRB, 0.17574148E-05_JPRB, 0.17574000E-05_JPRB, 0.17573424E-05_JPRB /)

RGHG2(:,60, 7) = (/ &
  & 0.17656723E-05_JPRB, 0.17658809E-05_JPRB, 0.17659841E-05_JPRB, 0.17660632E-05_JPRB, 0.17661318E-05_JPRB, 0.17661818E-05_JPRB, &
  & 0.17662089E-05_JPRB, 0.17662156E-05_JPRB, 0.17662096E-05_JPRB, 0.17661941E-05_JPRB, 0.17661647E-05_JPRB, 0.17661118E-05_JPRB, &
  & 0.17660047E-05_JPRB, 0.17658131E-05_JPRB, 0.17655029E-05_JPRB, 0.17650666E-05_JPRB, 0.17644843E-05_JPRB, 0.17637512E-05_JPRB, &
  & 0.17628768E-05_JPRB, 0.17618142E-05_JPRB, 0.17606020E-05_JPRB, 0.17591919E-05_JPRB, 0.17577790E-05_JPRB, 0.17566800E-05_JPRB, &
  & 0.17560910E-05_JPRB, 0.17559471E-05_JPRB, 0.17560830E-05_JPRB, 0.17563831E-05_JPRB, 0.17567959E-05_JPRB, 0.17573115E-05_JPRB, &
  & 0.17579081E-05_JPRB, 0.17585089E-05_JPRB, 0.17589748E-05_JPRB, 0.17592029E-05_JPRB, 0.17591827E-05_JPRB, 0.17589480E-05_JPRB, &
  & 0.17585335E-05_JPRB, 0.17579803E-05_JPRB, 0.17573336E-05_JPRB, 0.17566629E-05_JPRB, 0.17560496E-05_JPRB, 0.17555805E-05_JPRB, &
  & 0.17552942E-05_JPRB, 0.17551783E-05_JPRB, 0.17552148E-05_JPRB, 0.17553933E-05_JPRB, 0.17556997E-05_JPRB, 0.17560950E-05_JPRB, &
  & 0.17565197E-05_JPRB, 0.17569257E-05_JPRB, 0.17572745E-05_JPRB, 0.17575381E-05_JPRB, 0.17577188E-05_JPRB, 0.17578155E-05_JPRB, &
  & 0.17578634E-05_JPRB, 0.17578665E-05_JPRB, 0.17578420E-05_JPRB, 0.17578211E-05_JPRB, 0.17578154E-05_JPRB, 0.17578218E-05_JPRB, &
  & 0.17578272E-05_JPRB, 0.17578222E-05_JPRB, 0.17577947E-05_JPRB, 0.17577079E-05_JPRB /)

RGHG2(:,61, 7) = (/ &
  & 0.17665432E-05_JPRB, 0.17667273E-05_JPRB, 0.17668165E-05_JPRB, 0.17668808E-05_JPRB, 0.17669324E-05_JPRB, 0.17669724E-05_JPRB, &
  & 0.17669946E-05_JPRB, 0.17670028E-05_JPRB, 0.17670009E-05_JPRB, 0.17669912E-05_JPRB, 0.17669714E-05_JPRB, 0.17669298E-05_JPRB, &
  & 0.17668472E-05_JPRB, 0.17666828E-05_JPRB, 0.17664075E-05_JPRB, 0.17659893E-05_JPRB, 0.17654081E-05_JPRB, 0.17646316E-05_JPRB, &
  & 0.17636701E-05_JPRB, 0.17625346E-05_JPRB, 0.17612051E-05_JPRB, 0.17597438E-05_JPRB, 0.17583267E-05_JPRB, 0.17572258E-05_JPRB, &
  & 0.17566222E-05_JPRB, 0.17564553E-05_JPRB, 0.17565766E-05_JPRB, 0.17568726E-05_JPRB, 0.17572914E-05_JPRB, 0.17578155E-05_JPRB, &
  & 0.17584294E-05_JPRB, 0.17590439E-05_JPRB, 0.17595186E-05_JPRB, 0.17597453E-05_JPRB, 0.17597208E-05_JPRB, 0.17594843E-05_JPRB, &
  & 0.17590721E-05_JPRB, 0.17585126E-05_JPRB, 0.17578614E-05_JPRB, 0.17571807E-05_JPRB, 0.17565657E-05_JPRB, 0.17561042E-05_JPRB, &
  & 0.17558189E-05_JPRB, 0.17557065E-05_JPRB, 0.17557400E-05_JPRB, 0.17559094E-05_JPRB, 0.17562091E-05_JPRB, 0.17565952E-05_JPRB, &
  & 0.17570143E-05_JPRB, 0.17574167E-05_JPRB, 0.17577668E-05_JPRB, 0.17580426E-05_JPRB, 0.17582328E-05_JPRB, 0.17583425E-05_JPRB, &
  & 0.17583852E-05_JPRB, 0.17583681E-05_JPRB, 0.17583121E-05_JPRB, 0.17582684E-05_JPRB, 0.17582535E-05_JPRB, 0.17582609E-05_JPRB, &
  & 0.17582668E-05_JPRB, 0.17582547E-05_JPRB, 0.17582087E-05_JPRB, 0.17580642E-05_JPRB /)

RGHG2(:,62, 7) = (/ &
  & 0.17673631E-05_JPRB, 0.17675263E-05_JPRB, 0.17676027E-05_JPRB, 0.17676593E-05_JPRB, 0.17677057E-05_JPRB, 0.17677419E-05_JPRB, &
  & 0.17677667E-05_JPRB, 0.17677798E-05_JPRB, 0.17677851E-05_JPRB, 0.17677835E-05_JPRB, 0.17677727E-05_JPRB, 0.17677453E-05_JPRB, &
  & 0.17676787E-05_JPRB, 0.17675413E-05_JPRB, 0.17672895E-05_JPRB, 0.17668890E-05_JPRB, 0.17662942E-05_JPRB, 0.17654886E-05_JPRB, &
  & 0.17644639E-05_JPRB, 0.17632482E-05_JPRB, 0.17618617E-05_JPRB, 0.17603692E-05_JPRB, 0.17589398E-05_JPRB, 0.17578449E-05_JPRB, &
  & 0.17572260E-05_JPRB, 0.17570422E-05_JPRB, 0.17571556E-05_JPRB, 0.17574546E-05_JPRB, 0.17578822E-05_JPRB, 0.17584221E-05_JPRB, &
  & 0.17590498E-05_JPRB, 0.17596775E-05_JPRB, 0.17601532E-05_JPRB, 0.17603716E-05_JPRB, 0.17603372E-05_JPRB, 0.17600972E-05_JPRB, &
  & 0.17596840E-05_JPRB, 0.17591262E-05_JPRB, 0.17584682E-05_JPRB, 0.17577856E-05_JPRB, 0.17571688E-05_JPRB, 0.17567088E-05_JPRB, &
  & 0.17564306E-05_JPRB, 0.17563134E-05_JPRB, 0.17563393E-05_JPRB, 0.17564993E-05_JPRB, 0.17567839E-05_JPRB, 0.17571577E-05_JPRB, &
  & 0.17575686E-05_JPRB, 0.17579665E-05_JPRB, 0.17583177E-05_JPRB, 0.17585979E-05_JPRB, 0.17588005E-05_JPRB, 0.17589135E-05_JPRB, &
  & 0.17589564E-05_JPRB, 0.17589199E-05_JPRB, 0.17588270E-05_JPRB, 0.17587547E-05_JPRB, 0.17587304E-05_JPRB, 0.17587436E-05_JPRB, &
  & 0.17587533E-05_JPRB, 0.17587346E-05_JPRB, 0.17586568E-05_JPRB, 0.17584290E-05_JPRB /)

RGHG2(:,63, 7) = (/ &
  & 0.17681045E-05_JPRB, 0.17682705E-05_JPRB, 0.17683508E-05_JPRB, 0.17684090E-05_JPRB, 0.17684564E-05_JPRB, 0.17684963E-05_JPRB, &
  & 0.17685259E-05_JPRB, 0.17685475E-05_JPRB, 0.17685613E-05_JPRB, 0.17685696E-05_JPRB, 0.17685702E-05_JPRB, 0.17685562E-05_JPRB, &
  & 0.17685088E-05_JPRB, 0.17683892E-05_JPRB, 0.17681562E-05_JPRB, 0.17677596E-05_JPRB, 0.17671614E-05_JPRB, 0.17663209E-05_JPRB, &
  & 0.17652637E-05_JPRB, 0.17640032E-05_JPRB, 0.17625783E-05_JPRB, 0.17610594E-05_JPRB, 0.17596391E-05_JPRB, 0.17585427E-05_JPRB, &
  & 0.17579175E-05_JPRB, 0.17577240E-05_JPRB, 0.17578366E-05_JPRB, 0.17581435E-05_JPRB, 0.17585874E-05_JPRB, 0.17591439E-05_JPRB, &
  & 0.17597895E-05_JPRB, 0.17604220E-05_JPRB, 0.17608936E-05_JPRB, 0.17610965E-05_JPRB, 0.17610464E-05_JPRB, 0.17608004E-05_JPRB, &
  & 0.17603878E-05_JPRB, 0.17598311E-05_JPRB, 0.17591746E-05_JPRB, 0.17584888E-05_JPRB, 0.17578727E-05_JPRB, 0.17574172E-05_JPRB, &
  & 0.17571367E-05_JPRB, 0.17570162E-05_JPRB, 0.17570312E-05_JPRB, 0.17571747E-05_JPRB, 0.17574423E-05_JPRB, 0.17577986E-05_JPRB, &
  & 0.17581972E-05_JPRB, 0.17585885E-05_JPRB, 0.17589393E-05_JPRB, 0.17592236E-05_JPRB, 0.17594328E-05_JPRB, 0.17595489E-05_JPRB, &
  & 0.17595891E-05_JPRB, 0.17595344E-05_JPRB, 0.17594065E-05_JPRB, 0.17593029E-05_JPRB, 0.17592665E-05_JPRB, 0.17592877E-05_JPRB, &
  & 0.17593045E-05_JPRB, 0.17592795E-05_JPRB, 0.17591695E-05_JPRB, 0.17588303E-05_JPRB /)

RGHG2(:,64, 7) = (/ &
  & 0.17688083E-05_JPRB, 0.17689844E-05_JPRB, 0.17690702E-05_JPRB, 0.17691343E-05_JPRB, 0.17691882E-05_JPRB, 0.17692338E-05_JPRB, &
  & 0.17692721E-05_JPRB, 0.17693030E-05_JPRB, 0.17693286E-05_JPRB, 0.17693486E-05_JPRB, 0.17693629E-05_JPRB, 0.17693642E-05_JPRB, &
  & 0.17693317E-05_JPRB, 0.17692282E-05_JPRB, 0.17690041E-05_JPRB, 0.17686125E-05_JPRB, 0.17680021E-05_JPRB, 0.17671562E-05_JPRB, &
  & 0.17660734E-05_JPRB, 0.17647906E-05_JPRB, 0.17633442E-05_JPRB, 0.17618257E-05_JPRB, 0.17604116E-05_JPRB, 0.17593286E-05_JPRB, &
  & 0.17587048E-05_JPRB, 0.17585105E-05_JPRB, 0.17586282E-05_JPRB, 0.17589489E-05_JPRB, 0.17594098E-05_JPRB, 0.17599859E-05_JPRB, &
  & 0.17606430E-05_JPRB, 0.17612770E-05_JPRB, 0.17617328E-05_JPRB, 0.17619149E-05_JPRB, 0.17618463E-05_JPRB, 0.17615919E-05_JPRB, &
  & 0.17611814E-05_JPRB, 0.17606308E-05_JPRB, 0.17599780E-05_JPRB, 0.17592959E-05_JPRB, 0.17586827E-05_JPRB, 0.17582290E-05_JPRB, &
  & 0.17579508E-05_JPRB, 0.17578207E-05_JPRB, 0.17578218E-05_JPRB, 0.17579466E-05_JPRB, 0.17581901E-05_JPRB, 0.17585261E-05_JPRB, &
  & 0.17589085E-05_JPRB, 0.17592906E-05_JPRB, 0.17596386E-05_JPRB, 0.17599257E-05_JPRB, 0.17601396E-05_JPRB, 0.17602571E-05_JPRB, &
  & 0.17602925E-05_JPRB, 0.17602215E-05_JPRB, 0.17600622E-05_JPRB, 0.17599284E-05_JPRB, 0.17598782E-05_JPRB, 0.17599049E-05_JPRB, &
  & 0.17599284E-05_JPRB, 0.17599006E-05_JPRB, 0.17597558E-05_JPRB, 0.17593057E-05_JPRB /)

RGHG2(:,65, 7) = (/ &
  & 0.17694726E-05_JPRB, 0.17696660E-05_JPRB, 0.17697633E-05_JPRB, 0.17698367E-05_JPRB, 0.17698985E-05_JPRB, 0.17699533E-05_JPRB, &
  & 0.17699994E-05_JPRB, 0.17700431E-05_JPRB, 0.17700806E-05_JPRB, 0.17701170E-05_JPRB, 0.17701473E-05_JPRB, 0.17701666E-05_JPRB, &
  & 0.17701487E-05_JPRB, 0.17700540E-05_JPRB, 0.17698359E-05_JPRB, 0.17694433E-05_JPRB, 0.17688361E-05_JPRB, 0.17679836E-05_JPRB, &
  & 0.17669017E-05_JPRB, 0.17656121E-05_JPRB, 0.17641645E-05_JPRB, 0.17626553E-05_JPRB, 0.17612670E-05_JPRB, 0.17602066E-05_JPRB, &
  & 0.17595941E-05_JPRB, 0.17594068E-05_JPRB, 0.17595340E-05_JPRB, 0.17598679E-05_JPRB, 0.17603440E-05_JPRB, 0.17609331E-05_JPRB, &
  & 0.17615955E-05_JPRB, 0.17622181E-05_JPRB, 0.17626514E-05_JPRB, 0.17628070E-05_JPRB, 0.17627183E-05_JPRB, 0.17624586E-05_JPRB, &
  & 0.17620516E-05_JPRB, 0.17615121E-05_JPRB, 0.17608718E-05_JPRB, 0.17601991E-05_JPRB, 0.17595951E-05_JPRB, 0.17591491E-05_JPRB, &
  & 0.17588704E-05_JPRB, 0.17587330E-05_JPRB, 0.17587178E-05_JPRB, 0.17588200E-05_JPRB, 0.17590376E-05_JPRB, 0.17593488E-05_JPRB, &
  & 0.17597125E-05_JPRB, 0.17600829E-05_JPRB, 0.17604257E-05_JPRB, 0.17607133E-05_JPRB, 0.17609302E-05_JPRB, 0.17610482E-05_JPRB, &
  & 0.17610785E-05_JPRB, 0.17609912E-05_JPRB, 0.17608047E-05_JPRB, 0.17606430E-05_JPRB, 0.17605785E-05_JPRB, 0.17606076E-05_JPRB, &
  & 0.17606360E-05_JPRB, 0.17606062E-05_JPRB, 0.17604344E-05_JPRB, 0.17598869E-05_JPRB /)

RGHG2(:,66, 7) = (/ &
  & 0.17700945E-05_JPRB, 0.17703192E-05_JPRB, 0.17704319E-05_JPRB, 0.17705197E-05_JPRB, 0.17705941E-05_JPRB, 0.17706584E-05_JPRB, &
  & 0.17707157E-05_JPRB, 0.17707688E-05_JPRB, 0.17708234E-05_JPRB, 0.17708742E-05_JPRB, 0.17709240E-05_JPRB, 0.17709596E-05_JPRB, &
  & 0.17709524E-05_JPRB, 0.17708630E-05_JPRB, 0.17706477E-05_JPRB, 0.17702603E-05_JPRB, 0.17696575E-05_JPRB, 0.17688179E-05_JPRB, &
  & 0.17677426E-05_JPRB, 0.17664617E-05_JPRB, 0.17650323E-05_JPRB, 0.17635549E-05_JPRB, 0.17622069E-05_JPRB, 0.17611796E-05_JPRB, &
  & 0.17605882E-05_JPRB, 0.17604118E-05_JPRB, 0.17605473E-05_JPRB, 0.17608897E-05_JPRB, 0.17613721E-05_JPRB, 0.17619632E-05_JPRB, &
  & 0.17626178E-05_JPRB, 0.17632191E-05_JPRB, 0.17636216E-05_JPRB, 0.17637483E-05_JPRB, 0.17636414E-05_JPRB, 0.17633777E-05_JPRB, &
  & 0.17629801E-05_JPRB, 0.17624579E-05_JPRB, 0.17618378E-05_JPRB, 0.17611862E-05_JPRB, 0.17605983E-05_JPRB, 0.17601672E-05_JPRB, &
  & 0.17598943E-05_JPRB, 0.17597500E-05_JPRB, 0.17597181E-05_JPRB, 0.17597977E-05_JPRB, 0.17599870E-05_JPRB, 0.17602730E-05_JPRB, &
  & 0.17606155E-05_JPRB, 0.17609723E-05_JPRB, 0.17613067E-05_JPRB, 0.17615932E-05_JPRB, 0.17618120E-05_JPRB, 0.17619299E-05_JPRB, &
  & 0.17619553E-05_JPRB, 0.17618528E-05_JPRB, 0.17616433E-05_JPRB, 0.17614566E-05_JPRB, 0.17613779E-05_JPRB, 0.17614068E-05_JPRB, &
  & 0.17614391E-05_JPRB, 0.17614111E-05_JPRB, 0.17612203E-05_JPRB, 0.17606013E-05_JPRB /)

RGHG2(:,67, 7) = (/ &
  & 0.17706786E-05_JPRB, 0.17709440E-05_JPRB, 0.17710826E-05_JPRB, 0.17711880E-05_JPRB, 0.17712790E-05_JPRB, 0.17713571E-05_JPRB, &
  & 0.17714233E-05_JPRB, 0.17714910E-05_JPRB, 0.17715556E-05_JPRB, 0.17716271E-05_JPRB, 0.17716898E-05_JPRB, 0.17717389E-05_JPRB, &
  & 0.17717362E-05_JPRB, 0.17716495E-05_JPRB, 0.17714395E-05_JPRB, 0.17710603E-05_JPRB, 0.17704731E-05_JPRB, 0.17696516E-05_JPRB, &
  & 0.17686006E-05_JPRB, 0.17673486E-05_JPRB, 0.17659551E-05_JPRB, 0.17645258E-05_JPRB, 0.17632291E-05_JPRB, 0.17622471E-05_JPRB, &
  & 0.17616809E-05_JPRB, 0.17615160E-05_JPRB, 0.17616559E-05_JPRB, 0.17619984E-05_JPRB, 0.17624752E-05_JPRB, 0.17630543E-05_JPRB, &
  & 0.17636885E-05_JPRB, 0.17642599E-05_JPRB, 0.17646277E-05_JPRB, 0.17647259E-05_JPRB, 0.17646024E-05_JPRB, 0.17643395E-05_JPRB, &
  & 0.17639554E-05_JPRB, 0.17634569E-05_JPRB, 0.17628660E-05_JPRB, 0.17622418E-05_JPRB, 0.17616833E-05_JPRB, 0.17612713E-05_JPRB, &
  & 0.17610120E-05_JPRB, 0.17608651E-05_JPRB, 0.17608198E-05_JPRB, 0.17608780E-05_JPRB, 0.17610416E-05_JPRB, 0.17613019E-05_JPRB, &
  & 0.17616247E-05_JPRB, 0.17619661E-05_JPRB, 0.17622914E-05_JPRB, 0.17625750E-05_JPRB, 0.17627925E-05_JPRB, 0.17629098E-05_JPRB, &
  & 0.17629295E-05_JPRB, 0.17628142E-05_JPRB, 0.17625858E-05_JPRB, 0.17623778E-05_JPRB, 0.17622865E-05_JPRB, 0.17623147E-05_JPRB, &
  & 0.17623511E-05_JPRB, 0.17623267E-05_JPRB, 0.17621204E-05_JPRB, 0.17614241E-05_JPRB /)

RGHG2(:,68, 7) = (/ &
  & 0.17711948E-05_JPRB, 0.17715400E-05_JPRB, 0.17717123E-05_JPRB, 0.17718473E-05_JPRB, 0.17719582E-05_JPRB, 0.17720524E-05_JPRB, &
  & 0.17721316E-05_JPRB, 0.17722091E-05_JPRB, 0.17722907E-05_JPRB, 0.17723700E-05_JPRB, 0.17724454E-05_JPRB, 0.17724979E-05_JPRB, &
  & 0.17724961E-05_JPRB, 0.17724132E-05_JPRB, 0.17722106E-05_JPRB, 0.17718446E-05_JPRB, 0.17712789E-05_JPRB, 0.17704873E-05_JPRB, &
  & 0.17694722E-05_JPRB, 0.17682642E-05_JPRB, 0.17669275E-05_JPRB, 0.17655634E-05_JPRB, 0.17643333E-05_JPRB, 0.17634003E-05_JPRB, &
  & 0.17628624E-05_JPRB, 0.17627071E-05_JPRB, 0.17628453E-05_JPRB, 0.17631781E-05_JPRB, 0.17636385E-05_JPRB, 0.17641933E-05_JPRB, &
  & 0.17647965E-05_JPRB, 0.17653322E-05_JPRB, 0.17656647E-05_JPRB, 0.17657367E-05_JPRB, 0.17656013E-05_JPRB, 0.17653410E-05_JPRB, &
  & 0.17649747E-05_JPRB, 0.17645052E-05_JPRB, 0.17639475E-05_JPRB, 0.17633607E-05_JPRB, 0.17628339E-05_JPRB, 0.17624535E-05_JPRB, &
  & 0.17622120E-05_JPRB, 0.17620702E-05_JPRB, 0.17620151E-05_JPRB, 0.17620566E-05_JPRB, 0.17621969E-05_JPRB, 0.17624362E-05_JPRB, &
  & 0.17627395E-05_JPRB, 0.17630667E-05_JPRB, 0.17633811E-05_JPRB, 0.17636596E-05_JPRB, 0.17638748E-05_JPRB, 0.17639911E-05_JPRB, &
  & 0.17640058E-05_JPRB, 0.17638807E-05_JPRB, 0.17636396E-05_JPRB, 0.17634156E-05_JPRB, 0.17633139E-05_JPRB, 0.17633429E-05_JPRB, &
  & 0.17633848E-05_JPRB, 0.17633716E-05_JPRB, 0.17631673E-05_JPRB, 0.17624527E-05_JPRB /)

RGHG2(:,69, 7) = (/ &
  & 0.17716743E-05_JPRB, 0.17721164E-05_JPRB, 0.17723421E-05_JPRB, 0.17725057E-05_JPRB, 0.17726413E-05_JPRB, 0.17727514E-05_JPRB, &
  & 0.17728412E-05_JPRB, 0.17729319E-05_JPRB, 0.17730210E-05_JPRB, 0.17731104E-05_JPRB, 0.17731857E-05_JPRB, 0.17732386E-05_JPRB, &
  & 0.17732362E-05_JPRB, 0.17731570E-05_JPRB, 0.17729636E-05_JPRB, 0.17726152E-05_JPRB, 0.17720772E-05_JPRB, 0.17713252E-05_JPRB, &
  & 0.17703625E-05_JPRB, 0.17692186E-05_JPRB, 0.17679545E-05_JPRB, 0.17666699E-05_JPRB, 0.17655120E-05_JPRB, 0.17646353E-05_JPRB, &
  & 0.17641249E-05_JPRB, 0.17639761E-05_JPRB, 0.17641061E-05_JPRB, 0.17644212E-05_JPRB, 0.17648550E-05_JPRB, 0.17653766E-05_JPRB, &
  & 0.17659418E-05_JPRB, 0.17664385E-05_JPRB, 0.17667357E-05_JPRB, 0.17667846E-05_JPRB, 0.17666409E-05_JPRB, 0.17663873E-05_JPRB, &
  & 0.17660425E-05_JPRB, 0.17656046E-05_JPRB, 0.17650864E-05_JPRB, 0.17645392E-05_JPRB, 0.17640541E-05_JPRB, 0.17637063E-05_JPRB, &
  & 0.17634916E-05_JPRB, 0.17633594E-05_JPRB, 0.17633013E-05_JPRB, 0.17633308E-05_JPRB, 0.17634521E-05_JPRB, 0.17636735E-05_JPRB, &
  & 0.17639614E-05_JPRB, 0.17642745E-05_JPRB, 0.17645784E-05_JPRB, 0.17648508E-05_JPRB, 0.17650621E-05_JPRB, 0.17651776E-05_JPRB, &
  & 0.17651888E-05_JPRB, 0.17650585E-05_JPRB, 0.17648124E-05_JPRB, 0.17645797E-05_JPRB, 0.17644725E-05_JPRB, 0.17645040E-05_JPRB, &
  & 0.17645531E-05_JPRB, 0.17645524E-05_JPRB, 0.17643566E-05_JPRB, 0.17636104E-05_JPRB /)

RGHG2(:,70, 7) = (/ &
  & 0.17721215E-05_JPRB, 0.17727052E-05_JPRB, 0.17729789E-05_JPRB, 0.17731793E-05_JPRB, 0.17733346E-05_JPRB, 0.17734583E-05_JPRB, &
  & 0.17735576E-05_JPRB, 0.17736589E-05_JPRB, 0.17737525E-05_JPRB, 0.17738438E-05_JPRB, 0.17739148E-05_JPRB, 0.17739650E-05_JPRB, &
  & 0.17739603E-05_JPRB, 0.17738836E-05_JPRB, 0.17737018E-05_JPRB, 0.17733737E-05_JPRB, 0.17728712E-05_JPRB, 0.17721680E-05_JPRB, &
  & 0.17712694E-05_JPRB, 0.17702029E-05_JPRB, 0.17690288E-05_JPRB, 0.17678357E-05_JPRB, 0.17667621E-05_JPRB, 0.17659419E-05_JPRB, &
  & 0.17654602E-05_JPRB, 0.17653150E-05_JPRB, 0.17654316E-05_JPRB, 0.17657211E-05_JPRB, 0.17661220E-05_JPRB, 0.17666027E-05_JPRB, &
  & 0.17671241E-05_JPRB, 0.17675791E-05_JPRB, 0.17678423E-05_JPRB, 0.17678711E-05_JPRB, 0.17677228E-05_JPRB, 0.17674791E-05_JPRB, &
  & 0.17671580E-05_JPRB, 0.17667558E-05_JPRB, 0.17662799E-05_JPRB, 0.17657775E-05_JPRB, 0.17653356E-05_JPRB, 0.17650268E-05_JPRB, &
  & 0.17648438E-05_JPRB, 0.17647272E-05_JPRB, 0.17646728E-05_JPRB, 0.17646945E-05_JPRB, 0.17648019E-05_JPRB, 0.17650082E-05_JPRB, &
  & 0.17652833E-05_JPRB, 0.17655823E-05_JPRB, 0.17658749E-05_JPRB, 0.17661403E-05_JPRB, 0.17663481E-05_JPRB, 0.17664636E-05_JPRB, &
  & 0.17664744E-05_JPRB, 0.17663463E-05_JPRB, 0.17661049E-05_JPRB, 0.17658746E-05_JPRB, 0.17657682E-05_JPRB, 0.17658032E-05_JPRB, &
  & 0.17658615E-05_JPRB, 0.17658754E-05_JPRB, 0.17657025E-05_JPRB, 0.17649871E-05_JPRB /)

RGHG2(:,71, 7) = (/ &
  & 0.17725911E-05_JPRB, 0.17733124E-05_JPRB, 0.17736496E-05_JPRB, 0.17738760E-05_JPRB, 0.17740449E-05_JPRB, 0.17741816E-05_JPRB, &
  & 0.17742866E-05_JPRB, 0.17743923E-05_JPRB, 0.17744906E-05_JPRB, 0.17745718E-05_JPRB, 0.17746411E-05_JPRB, 0.17746834E-05_JPRB, &
  & 0.17746750E-05_JPRB, 0.17746004E-05_JPRB, 0.17744301E-05_JPRB, 0.17741244E-05_JPRB, 0.17736627E-05_JPRB, 0.17730151E-05_JPRB, &
  & 0.17721929E-05_JPRB, 0.17712192E-05_JPRB, 0.17701441E-05_JPRB, 0.17690560E-05_JPRB, 0.17680695E-05_JPRB, 0.17673140E-05_JPRB, &
  & 0.17668616E-05_JPRB, 0.17667172E-05_JPRB, 0.17668148E-05_JPRB, 0.17670741E-05_JPRB, 0.17674352E-05_JPRB, 0.17678689E-05_JPRB, &
  & 0.17683428E-05_JPRB, 0.17687532E-05_JPRB, 0.17689828E-05_JPRB, 0.17689947E-05_JPRB, 0.17688451E-05_JPRB, 0.17686145E-05_JPRB, &
  & 0.17683202E-05_JPRB, 0.17679566E-05_JPRB, 0.17675268E-05_JPRB, 0.17670741E-05_JPRB, 0.17666787E-05_JPRB, 0.17664129E-05_JPRB, &
  & 0.17662608E-05_JPRB, 0.17661656E-05_JPRB, 0.17661180E-05_JPRB, 0.17661373E-05_JPRB, 0.17662331E-05_JPRB, 0.17664286E-05_JPRB, &
  & 0.17666900E-05_JPRB, 0.17669751E-05_JPRB, 0.17672551E-05_JPRB, 0.17675119E-05_JPRB, 0.17677165E-05_JPRB, 0.17678340E-05_JPRB, &
  & 0.17678482E-05_JPRB, 0.17677297E-05_JPRB, 0.17675051E-05_JPRB, 0.17672883E-05_JPRB, 0.17671904E-05_JPRB, 0.17672277E-05_JPRB, &
  & 0.17672904E-05_JPRB, 0.17673193E-05_JPRB, 0.17671819E-05_JPRB, 0.17665323E-05_JPRB /)

RGHG2(:,72, 7) = (/ &
  & 0.17730928E-05_JPRB, 0.17739808E-05_JPRB, 0.17743612E-05_JPRB, 0.17746042E-05_JPRB, 0.17747888E-05_JPRB, 0.17749237E-05_JPRB, &
  & 0.17750344E-05_JPRB, 0.17751443E-05_JPRB, 0.17752294E-05_JPRB, 0.17753142E-05_JPRB, 0.17753662E-05_JPRB, 0.17754033E-05_JPRB, &
  & 0.17753890E-05_JPRB, 0.17753139E-05_JPRB, 0.17751556E-05_JPRB, 0.17748740E-05_JPRB, 0.17744543E-05_JPRB, 0.17738690E-05_JPRB, &
  & 0.17731286E-05_JPRB, 0.17722523E-05_JPRB, 0.17712921E-05_JPRB, 0.17703122E-05_JPRB, 0.17694284E-05_JPRB, 0.17687418E-05_JPRB, &
  & 0.17683204E-05_JPRB, 0.17681764E-05_JPRB, 0.17682521E-05_JPRB, 0.17684755E-05_JPRB, 0.17687923E-05_JPRB, 0.17691735E-05_JPRB, &
  & 0.17695955E-05_JPRB, 0.17699588E-05_JPRB, 0.17701547E-05_JPRB, 0.17701526E-05_JPRB, 0.17700054E-05_JPRB, 0.17697910E-05_JPRB, &
  & 0.17695253E-05_JPRB, 0.17692025E-05_JPRB, 0.17688221E-05_JPRB, 0.17684207E-05_JPRB, 0.17680771E-05_JPRB, 0.17678520E-05_JPRB, &
  & 0.17677360E-05_JPRB, 0.17676605E-05_JPRB, 0.17676242E-05_JPRB, 0.17676431E-05_JPRB, 0.17677319E-05_JPRB, 0.17679167E-05_JPRB, &
  & 0.17681641E-05_JPRB, 0.17684317E-05_JPRB, 0.17686959E-05_JPRB, 0.17689418E-05_JPRB, 0.17691416E-05_JPRB, 0.17692620E-05_JPRB, &
  & 0.17692832E-05_JPRB, 0.17691809E-05_JPRB, 0.17689847E-05_JPRB, 0.17687938E-05_JPRB, 0.17687078E-05_JPRB, 0.17687424E-05_JPRB, &
  & 0.17688063E-05_JPRB, 0.17688400E-05_JPRB, 0.17687280E-05_JPRB, 0.17681357E-05_JPRB /)

RGHG2(:,73, 7) = (/ &
  & 0.17737906E-05_JPRB, 0.17747350E-05_JPRB, 0.17751227E-05_JPRB, 0.17753745E-05_JPRB, 0.17755482E-05_JPRB, 0.17756889E-05_JPRB, &
  & 0.17757976E-05_JPRB, 0.17758955E-05_JPRB, 0.17759878E-05_JPRB, 0.17760467E-05_JPRB, 0.17761024E-05_JPRB, 0.17761246E-05_JPRB, &
  & 0.17761022E-05_JPRB, 0.17760279E-05_JPRB, 0.17758794E-05_JPRB, 0.17756196E-05_JPRB, 0.17752486E-05_JPRB, 0.17747216E-05_JPRB, &
  & 0.17740707E-05_JPRB, 0.17733032E-05_JPRB, 0.17724548E-05_JPRB, 0.17716003E-05_JPRB, 0.17708192E-05_JPRB, 0.17702093E-05_JPRB, &
  & 0.17698246E-05_JPRB, 0.17696808E-05_JPRB, 0.17697329E-05_JPRB, 0.17699177E-05_JPRB, 0.17701867E-05_JPRB, 0.17705123E-05_JPRB, &
  & 0.17708785E-05_JPRB, 0.17711918E-05_JPRB, 0.17713547E-05_JPRB, 0.17713410E-05_JPRB, 0.17712005E-05_JPRB, 0.17710045E-05_JPRB, &
  & 0.17707704E-05_JPRB, 0.17704911E-05_JPRB, 0.17701630E-05_JPRB, 0.17698176E-05_JPRB, 0.17695234E-05_JPRB, 0.17693400E-05_JPRB, &
  & 0.17692537E-05_JPRB, 0.17691996E-05_JPRB, 0.17691746E-05_JPRB, 0.17691950E-05_JPRB, 0.17692778E-05_JPRB, 0.17694522E-05_JPRB, &
  & 0.17696836E-05_JPRB, 0.17699305E-05_JPRB, 0.17701771E-05_JPRB, 0.17704078E-05_JPRB, 0.17706000E-05_JPRB, 0.17707222E-05_JPRB, &
  & 0.17707515E-05_JPRB, 0.17706695E-05_JPRB, 0.17705052E-05_JPRB, 0.17703455E-05_JPRB, 0.17702741E-05_JPRB, 0.17703039E-05_JPRB, &
  & 0.17703612E-05_JPRB, 0.17703949E-05_JPRB, 0.17702995E-05_JPRB, 0.17697563E-05_JPRB /)

RGHG2(:,74, 7) = (/ &
  & 0.17745654E-05_JPRB, 0.17755323E-05_JPRB, 0.17759171E-05_JPRB, 0.17761470E-05_JPRB, 0.17763208E-05_JPRB, 0.17764487E-05_JPRB, &
  & 0.17765497E-05_JPRB, 0.17766499E-05_JPRB, 0.17767168E-05_JPRB, 0.17767841E-05_JPRB, 0.17768165E-05_JPRB, 0.17768336E-05_JPRB, &
  & 0.17768068E-05_JPRB, 0.17767278E-05_JPRB, 0.17765933E-05_JPRB, 0.17763572E-05_JPRB, 0.17760319E-05_JPRB, 0.17755750E-05_JPRB, &
  & 0.17750131E-05_JPRB, 0.17743523E-05_JPRB, 0.17736309E-05_JPRB, 0.17728967E-05_JPRB, 0.17722288E-05_JPRB, 0.17716995E-05_JPRB, &
  & 0.17713558E-05_JPRB, 0.17712174E-05_JPRB, 0.17712462E-05_JPRB, 0.17713921E-05_JPRB, 0.17716120E-05_JPRB, 0.17718808E-05_JPRB, &
  & 0.17721865E-05_JPRB, 0.17724494E-05_JPRB, 0.17725802E-05_JPRB, 0.17725577E-05_JPRB, 0.17724261E-05_JPRB, 0.17722521E-05_JPRB, &
  & 0.17720508E-05_JPRB, 0.17718158E-05_JPRB, 0.17715427E-05_JPRB, 0.17712538E-05_JPRB, 0.17710107E-05_JPRB, 0.17708651E-05_JPRB, &
  & 0.17708081E-05_JPRB, 0.17707721E-05_JPRB, 0.17707582E-05_JPRB, 0.17707816E-05_JPRB, 0.17708581E-05_JPRB, 0.17710216E-05_JPRB, &
  & 0.17712316E-05_JPRB, 0.17714558E-05_JPRB, 0.17716789E-05_JPRB, 0.17718912E-05_JPRB, 0.17720721E-05_JPRB, 0.17721927E-05_JPRB, &
  & 0.17722298E-05_JPRB, 0.17721671E-05_JPRB, 0.17720356E-05_JPRB, 0.17719046E-05_JPRB, 0.17718469E-05_JPRB, 0.17718726E-05_JPRB, &
  & 0.17719234E-05_JPRB, 0.17719540E-05_JPRB, 0.17718698E-05_JPRB, 0.17713521E-05_JPRB /)

RGHG2(:,75, 7) = (/ &
  & 0.17753920E-05_JPRB, 0.17763482E-05_JPRB, 0.17766972E-05_JPRB, 0.17769119E-05_JPRB, 0.17770626E-05_JPRB, 0.17771811E-05_JPRB, &
  & 0.17772743E-05_JPRB, 0.17773550E-05_JPRB, 0.17774280E-05_JPRB, 0.17774676E-05_JPRB, 0.17775041E-05_JPRB, 0.17775099E-05_JPRB, &
  & 0.17774742E-05_JPRB, 0.17774007E-05_JPRB, 0.17772808E-05_JPRB, 0.17770768E-05_JPRB, 0.17768014E-05_JPRB, 0.17764171E-05_JPRB, &
  & 0.17759493E-05_JPRB, 0.17754053E-05_JPRB, 0.17748044E-05_JPRB, 0.17742000E-05_JPRB, 0.17736435E-05_JPRB, 0.17731995E-05_JPRB, &
  & 0.17729030E-05_JPRB, 0.17727752E-05_JPRB, 0.17727845E-05_JPRB, 0.17728926E-05_JPRB, 0.17730644E-05_JPRB, 0.17732768E-05_JPRB, &
  & 0.17735211E-05_JPRB, 0.17737328E-05_JPRB, 0.17738332E-05_JPRB, 0.17738057E-05_JPRB, 0.17736871E-05_JPRB, 0.17735381E-05_JPRB, &
  & 0.17733710E-05_JPRB, 0.17731820E-05_JPRB, 0.17729644E-05_JPRB, 0.17727336E-05_JPRB, 0.17725412E-05_JPRB, 0.17724300E-05_JPRB, &
  & 0.17723974E-05_JPRB, 0.17723762E-05_JPRB, 0.17723722E-05_JPRB, 0.17723977E-05_JPRB, 0.17724680E-05_JPRB, 0.17726160E-05_JPRB, &
  & 0.17728033E-05_JPRB, 0.17729983E-05_JPRB, 0.17731961E-05_JPRB, 0.17733842E-05_JPRB, 0.17735467E-05_JPRB, 0.17736620E-05_JPRB, &
  & 0.17737029E-05_JPRB, 0.17736581E-05_JPRB, 0.17735538E-05_JPRB, 0.17734485E-05_JPRB, 0.17734037E-05_JPRB, 0.17734278E-05_JPRB, &
  & 0.17734747E-05_JPRB, 0.17735009E-05_JPRB, 0.17734160E-05_JPRB, 0.17729209E-05_JPRB /)

RGHG2(:,76, 7) = (/ &
  & 0.17762582E-05_JPRB, 0.17771501E-05_JPRB, 0.17774568E-05_JPRB, 0.17776337E-05_JPRB, 0.17777654E-05_JPRB, 0.17778636E-05_JPRB, &
  & 0.17779402E-05_JPRB, 0.17780180E-05_JPRB, 0.17780658E-05_JPRB, 0.17781074E-05_JPRB, 0.17781263E-05_JPRB, 0.17781281E-05_JPRB, &
  & 0.17780976E-05_JPRB, 0.17780289E-05_JPRB, 0.17779302E-05_JPRB, 0.17777670E-05_JPRB, 0.17775474E-05_JPRB, 0.17772416E-05_JPRB, &
  & 0.17768730E-05_JPRB, 0.17764451E-05_JPRB, 0.17759720E-05_JPRB, 0.17754944E-05_JPRB, 0.17750524E-05_JPRB, 0.17746984E-05_JPRB, &
  & 0.17744549E-05_JPRB, 0.17743457E-05_JPRB, 0.17743404E-05_JPRB, 0.17744152E-05_JPRB, 0.17745406E-05_JPRB, 0.17746974E-05_JPRB, &
  & 0.17748836E-05_JPRB, 0.17750438E-05_JPRB, 0.17751163E-05_JPRB, 0.17750868E-05_JPRB, 0.17749857E-05_JPRB, 0.17748648E-05_JPRB, &
  & 0.17747337E-05_JPRB, 0.17745906E-05_JPRB, 0.17744292E-05_JPRB, 0.17742560E-05_JPRB, 0.17741131E-05_JPRB, 0.17740340E-05_JPRB, &
  & 0.17740217E-05_JPRB, 0.17740130E-05_JPRB, 0.17740174E-05_JPRB, 0.17740439E-05_JPRB, 0.17741054E-05_JPRB, 0.17742346E-05_JPRB, &
  & 0.17743923E-05_JPRB, 0.17745556E-05_JPRB, 0.17747221E-05_JPRB, 0.17748780E-05_JPRB, 0.17750152E-05_JPRB, 0.17751149E-05_JPRB, &
  & 0.17751572E-05_JPRB, 0.17751283E-05_JPRB, 0.17750497E-05_JPRB, 0.17749678E-05_JPRB, 0.17749369E-05_JPRB, 0.17749630E-05_JPRB, &
  & 0.17750049E-05_JPRB, 0.17750273E-05_JPRB, 0.17749435E-05_JPRB, 0.17744302E-05_JPRB /)

RGHG2(:,77, 7) = (/ &
  & 0.17771447E-05_JPRB, 0.17779273E-05_JPRB, 0.17781722E-05_JPRB, 0.17783095E-05_JPRB, 0.17784101E-05_JPRB, 0.17784880E-05_JPRB, &
  & 0.17785449E-05_JPRB, 0.17786035E-05_JPRB, 0.17786438E-05_JPRB, 0.17786629E-05_JPRB, 0.17786820E-05_JPRB, 0.17786813E-05_JPRB, &
  & 0.17786531E-05_JPRB, 0.17786022E-05_JPRB, 0.17785287E-05_JPRB, 0.17784112E-05_JPRB, 0.17782519E-05_JPRB, 0.17780236E-05_JPRB, &
  & 0.17777572E-05_JPRB, 0.17774472E-05_JPRB, 0.17771008E-05_JPRB, 0.17767533E-05_JPRB, 0.17764285E-05_JPRB, 0.17761696E-05_JPRB, &
  & 0.17759876E-05_JPRB, 0.17759062E-05_JPRB, 0.17758938E-05_JPRB, 0.17759419E-05_JPRB, 0.17760259E-05_JPRB, 0.17761323E-05_JPRB, &
  & 0.17762643E-05_JPRB, 0.17763792E-05_JPRB, 0.17764289E-05_JPRB, 0.17764037E-05_JPRB, 0.17763241E-05_JPRB, 0.17762358E-05_JPRB, &
  & 0.17761417E-05_JPRB, 0.17760447E-05_JPRB, 0.17759376E-05_JPRB, 0.17758200E-05_JPRB, 0.17757236E-05_JPRB, 0.17756710E-05_JPRB, &
  & 0.17756735E-05_JPRB, 0.17756726E-05_JPRB, 0.17756817E-05_JPRB, 0.17757068E-05_JPRB, 0.17757562E-05_JPRB, 0.17758613E-05_JPRB, &
  & 0.17759826E-05_JPRB, 0.17761082E-05_JPRB, 0.17762362E-05_JPRB, 0.17763530E-05_JPRB, 0.17764503E-05_JPRB, 0.17765292E-05_JPRB, &
  & 0.17765645E-05_JPRB, 0.17765514E-05_JPRB, 0.17764999E-05_JPRB, 0.17764459E-05_JPRB, 0.17764321E-05_JPRB, 0.17764579E-05_JPRB, &
  & 0.17764961E-05_JPRB, 0.17765093E-05_JPRB, 0.17764128E-05_JPRB, 0.17759087E-05_JPRB /)

RGHG2(:,78, 7) = (/ &
  & 0.17780388E-05_JPRB, 0.17786394E-05_JPRB, 0.17787972E-05_JPRB, 0.17788904E-05_JPRB, 0.17789622E-05_JPRB, 0.17790137E-05_JPRB, &
  & 0.17790496E-05_JPRB, 0.17790931E-05_JPRB, 0.17791133E-05_JPRB, 0.17791208E-05_JPRB, 0.17791351E-05_JPRB, 0.17791360E-05_JPRB, &
  & 0.17791193E-05_JPRB, 0.17790863E-05_JPRB, 0.17790388E-05_JPRB, 0.17789660E-05_JPRB, 0.17788628E-05_JPRB, 0.17787083E-05_JPRB, &
  & 0.17785328E-05_JPRB, 0.17783346E-05_JPRB, 0.17781059E-05_JPRB, 0.17778827E-05_JPRB, 0.17776730E-05_JPRB, 0.17775121E-05_JPRB, &
  & 0.17773984E-05_JPRB, 0.17773555E-05_JPRB, 0.17773481E-05_JPRB, 0.17773805E-05_JPRB, 0.17774337E-05_JPRB, 0.17775003E-05_JPRB, &
  & 0.17775891E-05_JPRB, 0.17776667E-05_JPRB, 0.17776997E-05_JPRB, 0.17776841E-05_JPRB, 0.17776306E-05_JPRB, 0.17775769E-05_JPRB, &
  & 0.17775197E-05_JPRB, 0.17774648E-05_JPRB, 0.17774059E-05_JPRB, 0.17773366E-05_JPRB, 0.17772805E-05_JPRB, 0.17772483E-05_JPRB, &
  & 0.17772586E-05_JPRB, 0.17772602E-05_JPRB, 0.17772688E-05_JPRB, 0.17772869E-05_JPRB, 0.17773195E-05_JPRB, 0.17773912E-05_JPRB, &
  & 0.17774695E-05_JPRB, 0.17775499E-05_JPRB, 0.17776368E-05_JPRB, 0.17777052E-05_JPRB, 0.17777592E-05_JPRB, 0.17778061E-05_JPRB, &
  & 0.17778316E-05_JPRB, 0.17778314E-05_JPRB, 0.17778066E-05_JPRB, 0.17777842E-05_JPRB, 0.17777893E-05_JPRB, 0.17778104E-05_JPRB, &
  & 0.17778361E-05_JPRB, 0.17778390E-05_JPRB, 0.17777692E-05_JPRB, 0.17773265E-05_JPRB /)

RGHG2(:,79, 7) = (/ &
  & 0.17786233E-05_JPRB, 0.17790420E-05_JPRB, 0.17791317E-05_JPRB, 0.17791921E-05_JPRB, 0.17792487E-05_JPRB, 0.17792886E-05_JPRB, &
  & 0.17793104E-05_JPRB, 0.17793483E-05_JPRB, 0.17793589E-05_JPRB, 0.17793573E-05_JPRB, 0.17793726E-05_JPRB, 0.17793748E-05_JPRB, &
  & 0.17793625E-05_JPRB, 0.17793382E-05_JPRB, 0.17793041E-05_JPRB, 0.17792545E-05_JPRB, 0.17791822E-05_JPRB, 0.17790640E-05_JPRB, &
  & 0.17789398E-05_JPRB, 0.17787999E-05_JPRB, 0.17786347E-05_JPRB, 0.17784785E-05_JPRB, 0.17783302E-05_JPRB, 0.17782247E-05_JPRB, &
  & 0.17781502E-05_JPRB, 0.17781323E-05_JPRB, 0.17781294E-05_JPRB, 0.17781557E-05_JPRB, 0.17781939E-05_JPRB, 0.17782395E-05_JPRB, &
  & 0.17783063E-05_JPRB, 0.17783647E-05_JPRB, 0.17783888E-05_JPRB, 0.17783784E-05_JPRB, 0.17783375E-05_JPRB, 0.17783016E-05_JPRB, &
  & 0.17782622E-05_JPRB, 0.17782290E-05_JPRB, 0.17781942E-05_JPRB, 0.17781491E-05_JPRB, 0.17781118E-05_JPRB, 0.17780874E-05_JPRB, &
  & 0.17781007E-05_JPRB, 0.17781001E-05_JPRB, 0.17781059E-05_JPRB, 0.17781176E-05_JPRB, 0.17781371E-05_JPRB, 0.17781902E-05_JPRB, &
  & 0.17782426E-05_JPRB, 0.17782972E-05_JPRB, 0.17783589E-05_JPRB, 0.17784013E-05_JPRB, 0.17784299E-05_JPRB, 0.17784629E-05_JPRB, &
  & 0.17784822E-05_JPRB, 0.17784886E-05_JPRB, 0.17784752E-05_JPRB, 0.17784674E-05_JPRB, 0.17784824E-05_JPRB, 0.17784970E-05_JPRB, &
  & 0.17785177E-05_JPRB, 0.17785322E-05_JPRB, 0.17785060E-05_JPRB, 0.17782154E-05_JPRB /)

RGHG2(:,80, 7) = (/ &
  & 0.17790146E-05_JPRB, 0.17792389E-05_JPRB, 0.17792777E-05_JPRB, 0.17793227E-05_JPRB, 0.17793723E-05_JPRB, 0.17794066E-05_JPRB, &
  & 0.17794258E-05_JPRB, 0.17794573E-05_JPRB, 0.17794664E-05_JPRB, 0.17794617E-05_JPRB, 0.17794800E-05_JPRB, 0.17794820E-05_JPRB, &
  & 0.17794712E-05_JPRB, 0.17794500E-05_JPRB, 0.17794213E-05_JPRB, 0.17793826E-05_JPRB, 0.17793254E-05_JPRB, 0.17792240E-05_JPRB, &
  & 0.17791226E-05_JPRB, 0.17790117E-05_JPRB, 0.17788736E-05_JPRB, 0.17787479E-05_JPRB, 0.17786263E-05_JPRB, 0.17785460E-05_JPRB, &
  & 0.17784893E-05_JPRB, 0.17784831E-05_JPRB, 0.17784831E-05_JPRB, 0.17785071E-05_JPRB, 0.17785384E-05_JPRB, 0.17785749E-05_JPRB, &
  & 0.17786327E-05_JPRB, 0.17786830E-05_JPRB, 0.17787034E-05_JPRB, 0.17786956E-05_JPRB, 0.17786595E-05_JPRB, 0.17786306E-05_JPRB, &
  & 0.17785983E-05_JPRB, 0.17785743E-05_JPRB, 0.17785503E-05_JPRB, 0.17785150E-05_JPRB, 0.17784851E-05_JPRB, 0.17784625E-05_JPRB, &
  & 0.17784758E-05_JPRB, 0.17784733E-05_JPRB, 0.17784765E-05_JPRB, 0.17784845E-05_JPRB, 0.17784978E-05_JPRB, 0.17785425E-05_JPRB, &
  & 0.17785831E-05_JPRB, 0.17786249E-05_JPRB, 0.17786758E-05_JPRB, 0.17787056E-05_JPRB, 0.17787233E-05_JPRB, 0.17787507E-05_JPRB, &
  & 0.17787680E-05_JPRB, 0.17787760E-05_JPRB, 0.17787640E-05_JPRB, 0.17787601E-05_JPRB, 0.17787784E-05_JPRB, 0.17787887E-05_JPRB, &
  & 0.17788090E-05_JPRB, 0.17788307E-05_JPRB, 0.17788569E-05_JPRB, 0.17787887E-05_JPRB /)

RGHG2(:,81, 7) = (/ &
  & 0.17792859E-05_JPRB, 0.17793228E-05_JPRB, 0.17793391E-05_JPRB, 0.17793770E-05_JPRB, 0.17794243E-05_JPRB, 0.17794574E-05_JPRB, &
  & 0.17794713E-05_JPRB, 0.17795091E-05_JPRB, 0.17795143E-05_JPRB, 0.17795101E-05_JPRB, 0.17795239E-05_JPRB, 0.17795286E-05_JPRB, &
  & 0.17795195E-05_JPRB, 0.17794996E-05_JPRB, 0.17794725E-05_JPRB, 0.17794400E-05_JPRB, 0.17793890E-05_JPRB, 0.17792953E-05_JPRB, &
  & 0.17792047E-05_JPRB, 0.17791072E-05_JPRB, 0.17789812E-05_JPRB, 0.17788688E-05_JPRB, 0.17787572E-05_JPRB, 0.17786883E-05_JPRB, &
  & 0.17786386E-05_JPRB, 0.17786388E-05_JPRB, 0.17786392E-05_JPRB, 0.17786621E-05_JPRB, 0.17786907E-05_JPRB, 0.17787233E-05_JPRB, &
  & 0.17787769E-05_JPRB, 0.17788237E-05_JPRB, 0.17788427E-05_JPRB, 0.17788359E-05_JPRB, 0.17788014E-05_JPRB, 0.17787754E-05_JPRB, &
  & 0.17787455E-05_JPRB, 0.17787257E-05_JPRB, 0.17787063E-05_JPRB, 0.17786754E-05_JPRB, 0.17786481E-05_JPRB, 0.17786263E-05_JPRB, &
  & 0.17786394E-05_JPRB, 0.17786358E-05_JPRB, 0.17786372E-05_JPRB, 0.17786439E-05_JPRB, 0.17786545E-05_JPRB, 0.17786959E-05_JPRB, &
  & 0.17787314E-05_JPRB, 0.17787672E-05_JPRB, 0.17788137E-05_JPRB, 0.17788382E-05_JPRB, 0.17788510E-05_JPRB, 0.17788766E-05_JPRB, &
  & 0.17788931E-05_JPRB, 0.17789016E-05_JPRB, 0.17788889E-05_JPRB, 0.17788853E-05_JPRB, 0.17789044E-05_JPRB, 0.17789120E-05_JPRB, &
  & 0.17789309E-05_JPRB, 0.17789556E-05_JPRB, 0.17790027E-05_JPRB, 0.17791772E-05_JPRB /)

RGHG2(:,82, 7) = (/ &
  & 0.17793072E-05_JPRB, 0.17793510E-05_JPRB, 0.17793657E-05_JPRB, 0.17794030E-05_JPRB, 0.17794503E-05_JPRB, 0.17794817E-05_JPRB, &
  & 0.17795010E-05_JPRB, 0.17795261E-05_JPRB, 0.17795351E-05_JPRB, 0.17795314E-05_JPRB, 0.17795503E-05_JPRB, 0.17795521E-05_JPRB, &
  & 0.17795426E-05_JPRB, 0.17795235E-05_JPRB, 0.17794982E-05_JPRB, 0.17794672E-05_JPRB, 0.17794214E-05_JPRB, 0.17793300E-05_JPRB, &
  & 0.17792458E-05_JPRB, 0.17791555E-05_JPRB, 0.17790348E-05_JPRB, 0.17789292E-05_JPRB, 0.17788218E-05_JPRB, 0.17787581E-05_JPRB, &
  & 0.17787120E-05_JPRB, 0.17787154E-05_JPRB, 0.17787156E-05_JPRB, 0.17787380E-05_JPRB, 0.17787650E-05_JPRB, 0.17787953E-05_JPRB, &
  & 0.17788471E-05_JPRB, 0.17788924E-05_JPRB, 0.17789107E-05_JPRB, 0.17789048E-05_JPRB, 0.17788711E-05_JPRB, 0.17788461E-05_JPRB, &
  & 0.17788175E-05_JPRB, 0.17787997E-05_JPRB, 0.17787825E-05_JPRB, 0.17787534E-05_JPRB, 0.17787281E-05_JPRB, 0.17787064E-05_JPRB, &
  & 0.17787189E-05_JPRB, 0.17787147E-05_JPRB, 0.17787156E-05_JPRB, 0.17787213E-05_JPRB, 0.17787304E-05_JPRB, 0.17787713E-05_JPRB, &
  & 0.17788036E-05_JPRB, 0.17788369E-05_JPRB, 0.17788816E-05_JPRB, 0.17789031E-05_JPRB, 0.17789130E-05_JPRB, 0.17789384E-05_JPRB, &
  & 0.17789545E-05_JPRB, 0.17789631E-05_JPRB, 0.17789496E-05_JPRB, 0.17789459E-05_JPRB, 0.17789655E-05_JPRB, 0.17789710E-05_JPRB, &
  & 0.17789888E-05_JPRB, 0.17790105E-05_JPRB, 0.17790524E-05_JPRB, 0.17792086E-05_JPRB /)

RGHG2(:,83, 7) = (/ &
  & 0.17793227E-05_JPRB, 0.17793677E-05_JPRB, 0.17793806E-05_JPRB, 0.17794172E-05_JPRB, 0.17794637E-05_JPRB, 0.17794960E-05_JPRB, &
  & 0.17795080E-05_JPRB, 0.17795454E-05_JPRB, 0.17795492E-05_JPRB, 0.17795479E-05_JPRB, 0.17795580E-05_JPRB, 0.17795637E-05_JPRB, &
  & 0.17795561E-05_JPRB, 0.17795371E-05_JPRB, 0.17795122E-05_JPRB, 0.17794837E-05_JPRB, 0.17794389E-05_JPRB, 0.17793503E-05_JPRB, &
  & 0.17792690E-05_JPRB, 0.17791839E-05_JPRB, 0.17790660E-05_JPRB, 0.17789639E-05_JPRB, 0.17788579E-05_JPRB, 0.17787980E-05_JPRB, &
  & 0.17787519E-05_JPRB, 0.17787584E-05_JPRB, 0.17787587E-05_JPRB, 0.17787803E-05_JPRB, 0.17788067E-05_JPRB, 0.17788359E-05_JPRB, &
  & 0.17788867E-05_JPRB, 0.17789309E-05_JPRB, 0.17789492E-05_JPRB, 0.17789436E-05_JPRB, 0.17789098E-05_JPRB, 0.17788855E-05_JPRB, &
  & 0.17788575E-05_JPRB, 0.17788408E-05_JPRB, 0.17788245E-05_JPRB, 0.17787969E-05_JPRB, 0.17787723E-05_JPRB, 0.17787513E-05_JPRB, &
  & 0.17787629E-05_JPRB, 0.17787584E-05_JPRB, 0.17787589E-05_JPRB, 0.17787645E-05_JPRB, 0.17787729E-05_JPRB, 0.17788129E-05_JPRB, &
  & 0.17788443E-05_JPRB, 0.17788760E-05_JPRB, 0.17789195E-05_JPRB, 0.17789398E-05_JPRB, 0.17789481E-05_JPRB, 0.17789733E-05_JPRB, &
  & 0.17789889E-05_JPRB, 0.17789977E-05_JPRB, 0.17789833E-05_JPRB, 0.17789798E-05_JPRB, 0.17789998E-05_JPRB, 0.17790039E-05_JPRB, &
  & 0.17790209E-05_JPRB, 0.17790413E-05_JPRB, 0.17790811E-05_JPRB, 0.17792305E-05_JPRB /)

RGHG2(:,84, 7) = (/ &
  & 0.17793332E-05_JPRB, 0.17793786E-05_JPRB, 0.17793897E-05_JPRB, 0.17794259E-05_JPRB, 0.17794732E-05_JPRB, 0.17795039E-05_JPRB, &
  & 0.17795253E-05_JPRB, 0.17795452E-05_JPRB, 0.17795555E-05_JPRB, 0.17795539E-05_JPRB, 0.17795697E-05_JPRB, 0.17795712E-05_JPRB, &
  & 0.17795624E-05_JPRB, 0.17795447E-05_JPRB, 0.17795210E-05_JPRB, 0.17794930E-05_JPRB, 0.17794500E-05_JPRB, 0.17793629E-05_JPRB, &
  & 0.17792846E-05_JPRB, 0.17792013E-05_JPRB, 0.17790849E-05_JPRB, 0.17789857E-05_JPRB, 0.17788805E-05_JPRB, 0.17788223E-05_JPRB, &
  & 0.17787768E-05_JPRB, 0.17787853E-05_JPRB, 0.17787847E-05_JPRB, 0.17788068E-05_JPRB, 0.17788313E-05_JPRB, 0.17788606E-05_JPRB, &
  & 0.17789107E-05_JPRB, 0.17789547E-05_JPRB, 0.17789724E-05_JPRB, 0.17789671E-05_JPRB, 0.17789337E-05_JPRB, 0.17789090E-05_JPRB, &
  & 0.17788819E-05_JPRB, 0.17788656E-05_JPRB, 0.17788504E-05_JPRB, 0.17788236E-05_JPRB, 0.17787996E-05_JPRB, 0.17787787E-05_JPRB, &
  & 0.17787902E-05_JPRB, 0.17787856E-05_JPRB, 0.17787859E-05_JPRB, 0.17787911E-05_JPRB, 0.17787995E-05_JPRB, 0.17788390E-05_JPRB, &
  & 0.17788691E-05_JPRB, 0.17789000E-05_JPRB, 0.17789433E-05_JPRB, 0.17789628E-05_JPRB, 0.17789695E-05_JPRB, 0.17789946E-05_JPRB, &
  & 0.17790109E-05_JPRB, 0.17790195E-05_JPRB, 0.17790045E-05_JPRB, 0.17790007E-05_JPRB, 0.17790210E-05_JPRB, 0.17790244E-05_JPRB, &
  & 0.17790410E-05_JPRB, 0.17790605E-05_JPRB, 0.17791000E-05_JPRB, 0.17792451E-05_JPRB /)

RGHG2(:,85, 7) = (/ &
  & 0.17793403E-05_JPRB, 0.17793859E-05_JPRB, 0.17793952E-05_JPRB, 0.17794314E-05_JPRB, 0.17794783E-05_JPRB, 0.17795118E-05_JPRB, &
  & 0.17795228E-05_JPRB, 0.17795579E-05_JPRB, 0.17795610E-05_JPRB, 0.17795626E-05_JPRB, 0.17795692E-05_JPRB, 0.17795719E-05_JPRB, &
  & 0.17795651E-05_JPRB, 0.17795483E-05_JPRB, 0.17795260E-05_JPRB, 0.17794985E-05_JPRB, 0.17794569E-05_JPRB, 0.17793737E-05_JPRB, &
  & 0.17792966E-05_JPRB, 0.17792138E-05_JPRB, 0.17790977E-05_JPRB, 0.17790003E-05_JPRB, 0.17788946E-05_JPRB, 0.17788394E-05_JPRB, &
  & 0.17787925E-05_JPRB, 0.17788027E-05_JPRB, 0.17788018E-05_JPRB, 0.17788229E-05_JPRB, 0.17788482E-05_JPRB, 0.17788763E-05_JPRB, &
  & 0.17789266E-05_JPRB, 0.17789698E-05_JPRB, 0.17789879E-05_JPRB, 0.17789827E-05_JPRB, 0.17789487E-05_JPRB, 0.17789246E-05_JPRB, &
  & 0.17788973E-05_JPRB, 0.17788818E-05_JPRB, 0.17788669E-05_JPRB, 0.17788408E-05_JPRB, 0.17788174E-05_JPRB, 0.17787966E-05_JPRB, &
  & 0.17788077E-05_JPRB, 0.17788034E-05_JPRB, 0.17788028E-05_JPRB, 0.17788079E-05_JPRB, 0.17788169E-05_JPRB, 0.17788552E-05_JPRB, &
  & 0.17788846E-05_JPRB, 0.17789154E-05_JPRB, 0.17789581E-05_JPRB, 0.17789773E-05_JPRB, 0.17789836E-05_JPRB, 0.17790088E-05_JPRB, &
  & 0.17790248E-05_JPRB, 0.17790339E-05_JPRB, 0.17790180E-05_JPRB, 0.17790142E-05_JPRB, 0.17790350E-05_JPRB, 0.17790378E-05_JPRB, &
  & 0.17790538E-05_JPRB, 0.17790734E-05_JPRB, 0.17791122E-05_JPRB, 0.17792556E-05_JPRB /)

RGHG2(:,86, 7) = (/ &
  & 0.17793448E-05_JPRB, 0.17793902E-05_JPRB, 0.17793984E-05_JPRB, 0.17794353E-05_JPRB, 0.17794855E-05_JPRB, 0.17795126E-05_JPRB, &
  & 0.17795383E-05_JPRB, 0.17795519E-05_JPRB, 0.17795624E-05_JPRB, 0.17795628E-05_JPRB, 0.17795711E-05_JPRB, 0.17795710E-05_JPRB, &
  & 0.17795630E-05_JPRB, 0.17795484E-05_JPRB, 0.17795275E-05_JPRB, 0.17795012E-05_JPRB, 0.17794594E-05_JPRB, 0.17793850E-05_JPRB, &
  & 0.17793066E-05_JPRB, 0.17792242E-05_JPRB, 0.17791069E-05_JPRB, 0.17790101E-05_JPRB, 0.17789043E-05_JPRB, 0.17788490E-05_JPRB, &
  & 0.17788026E-05_JPRB, 0.17788143E-05_JPRB, 0.17788120E-05_JPRB, 0.17788343E-05_JPRB, 0.17788577E-05_JPRB, 0.17788861E-05_JPRB, &
  & 0.17789368E-05_JPRB, 0.17789800E-05_JPRB, 0.17789980E-05_JPRB, 0.17789926E-05_JPRB, 0.17789583E-05_JPRB, 0.17789340E-05_JPRB, &
  & 0.17789072E-05_JPRB, 0.17788921E-05_JPRB, 0.17788780E-05_JPRB, 0.17788516E-05_JPRB, 0.17788279E-05_JPRB, 0.17788067E-05_JPRB, &
  & 0.17788192E-05_JPRB, 0.17788145E-05_JPRB, 0.17788143E-05_JPRB, 0.17788195E-05_JPRB, 0.17788288E-05_JPRB, 0.17788661E-05_JPRB, &
  & 0.17788948E-05_JPRB, 0.17789250E-05_JPRB, 0.17789665E-05_JPRB, 0.17789863E-05_JPRB, 0.17789923E-05_JPRB, 0.17790175E-05_JPRB, &
  & 0.17790343E-05_JPRB, 0.17790433E-05_JPRB, 0.17790270E-05_JPRB, 0.17790230E-05_JPRB, 0.17790439E-05_JPRB, 0.17790466E-05_JPRB, &
  & 0.17790621E-05_JPRB, 0.17790812E-05_JPRB, 0.17791203E-05_JPRB, 0.17792621E-05_JPRB /)

RGHG2(:,87, 7) = (/ &
  & 0.17793483E-05_JPRB, 0.17793930E-05_JPRB, 0.17794009E-05_JPRB, 0.17794392E-05_JPRB, 0.17794832E-05_JPRB, 0.17795221E-05_JPRB, &
  & 0.17795313E-05_JPRB, 0.17795612E-05_JPRB, 0.17795641E-05_JPRB, 0.17795655E-05_JPRB, 0.17795689E-05_JPRB, 0.17795675E-05_JPRB, &
  & 0.17795603E-05_JPRB, 0.17795460E-05_JPRB, 0.17795267E-05_JPRB, 0.17795005E-05_JPRB, 0.17794621E-05_JPRB, 0.17793909E-05_JPRB, &
  & 0.17793164E-05_JPRB, 0.17792306E-05_JPRB, 0.17791153E-05_JPRB, 0.17790162E-05_JPRB, 0.17789107E-05_JPRB, 0.17788564E-05_JPRB, &
  & 0.17788086E-05_JPRB, 0.17788212E-05_JPRB, 0.17788182E-05_JPRB, 0.17788401E-05_JPRB, 0.17788640E-05_JPRB, 0.17788919E-05_JPRB, &
  & 0.17789433E-05_JPRB, 0.17789869E-05_JPRB, 0.17790045E-05_JPRB, 0.17789991E-05_JPRB, 0.17789644E-05_JPRB, 0.17789400E-05_JPRB, &
  & 0.17789127E-05_JPRB, 0.17788983E-05_JPRB, 0.17788848E-05_JPRB, 0.17788582E-05_JPRB, 0.17788348E-05_JPRB, 0.17788119E-05_JPRB, &
  & 0.17788265E-05_JPRB, 0.17788212E-05_JPRB, 0.17788215E-05_JPRB, 0.17788267E-05_JPRB, 0.17788371E-05_JPRB, 0.17788723E-05_JPRB, &
  & 0.17789012E-05_JPRB, 0.17789313E-05_JPRB, 0.17789715E-05_JPRB, 0.17789910E-05_JPRB, 0.17789979E-05_JPRB, 0.17790228E-05_JPRB, &
  & 0.17790398E-05_JPRB, 0.17790493E-05_JPRB, 0.17790326E-05_JPRB, 0.17790286E-05_JPRB, 0.17790495E-05_JPRB, 0.17790516E-05_JPRB, &
  & 0.17790671E-05_JPRB, 0.17790865E-05_JPRB, 0.17791251E-05_JPRB, 0.17792669E-05_JPRB /)

RGHG2(:,88, 7) = (/ &
  & 0.17793519E-05_JPRB, 0.17793949E-05_JPRB, 0.17794032E-05_JPRB, 0.17794382E-05_JPRB, 0.17794921E-05_JPRB, 0.17795163E-05_JPRB, &
  & 0.17795438E-05_JPRB, 0.17795553E-05_JPRB, 0.17795637E-05_JPRB, 0.17795644E-05_JPRB, 0.17795692E-05_JPRB, 0.17795678E-05_JPRB, &
  & 0.17795596E-05_JPRB, 0.17795461E-05_JPRB, 0.17795263E-05_JPRB, 0.17795012E-05_JPRB, 0.17794617E-05_JPRB, 0.17793959E-05_JPRB, &
  & 0.17793193E-05_JPRB, 0.17792368E-05_JPRB, 0.17791176E-05_JPRB, 0.17790210E-05_JPRB, 0.17789142E-05_JPRB, 0.17788599E-05_JPRB, &
  & 0.17788121E-05_JPRB, 0.17788255E-05_JPRB, 0.17788217E-05_JPRB, 0.17788440E-05_JPRB, 0.17788668E-05_JPRB, 0.17788951E-05_JPRB, &
  & 0.17789470E-05_JPRB, 0.17789906E-05_JPRB, 0.17790086E-05_JPRB, 0.17790034E-05_JPRB, 0.17789682E-05_JPRB, 0.17789437E-05_JPRB, &
  & 0.17789166E-05_JPRB, 0.17789025E-05_JPRB, 0.17788900E-05_JPRB, 0.17788627E-05_JPRB, 0.17788382E-05_JPRB, 0.17788136E-05_JPRB, &
  & 0.17788313E-05_JPRB, 0.17788252E-05_JPRB, 0.17788254E-05_JPRB, 0.17788312E-05_JPRB, 0.17788419E-05_JPRB, 0.17788766E-05_JPRB, &
  & 0.17789047E-05_JPRB, 0.17789351E-05_JPRB, 0.17789733E-05_JPRB, 0.17789935E-05_JPRB, 0.17790011E-05_JPRB, 0.17790258E-05_JPRB, &
  & 0.17790431E-05_JPRB, 0.17790528E-05_JPRB, 0.17790359E-05_JPRB, 0.17790317E-05_JPRB, 0.17790529E-05_JPRB, 0.17790546E-05_JPRB, &
  & 0.17790702E-05_JPRB, 0.17790892E-05_JPRB, 0.17791278E-05_JPRB, 0.17792698E-05_JPRB /)

RGHG2(:,89, 7) = (/ &
  & 0.17793567E-05_JPRB, 0.17793958E-05_JPRB, 0.17794051E-05_JPRB, 0.17794396E-05_JPRB, 0.17794848E-05_JPRB, 0.17795239E-05_JPRB, &
  & 0.17795348E-05_JPRB, 0.17795621E-05_JPRB, 0.17795654E-05_JPRB, 0.17795672E-05_JPRB, 0.17795710E-05_JPRB, 0.17795696E-05_JPRB, &
  & 0.17795624E-05_JPRB, 0.17795479E-05_JPRB, 0.17795282E-05_JPRB, 0.17795024E-05_JPRB, 0.17794646E-05_JPRB, 0.17793931E-05_JPRB, &
  & 0.17793197E-05_JPRB, 0.17792349E-05_JPRB, 0.17791191E-05_JPRB, 0.17790215E-05_JPRB, 0.17789160E-05_JPRB, 0.17788619E-05_JPRB, &
  & 0.17788140E-05_JPRB, 0.17788279E-05_JPRB, 0.17788233E-05_JPRB, 0.17788457E-05_JPRB, 0.17788685E-05_JPRB, 0.17788964E-05_JPRB, &
  & 0.17789494E-05_JPRB, 0.17789934E-05_JPRB, 0.17790113E-05_JPRB, 0.17790064E-05_JPRB, 0.17789699E-05_JPRB, 0.17789451E-05_JPRB, &
  & 0.17789181E-05_JPRB, 0.17789048E-05_JPRB, 0.17788932E-05_JPRB, 0.17788650E-05_JPRB, 0.17788403E-05_JPRB, 0.17788135E-05_JPRB, &
  & 0.17788343E-05_JPRB, 0.17788274E-05_JPRB, 0.17788277E-05_JPRB, 0.17788336E-05_JPRB, 0.17788448E-05_JPRB, 0.17788790E-05_JPRB, &
  & 0.17789073E-05_JPRB, 0.17789368E-05_JPRB, 0.17789746E-05_JPRB, 0.17789943E-05_JPRB, 0.17790026E-05_JPRB, 0.17790273E-05_JPRB, &
  & 0.17790451E-05_JPRB, 0.17790550E-05_JPRB, 0.17790378E-05_JPRB, 0.17790334E-05_JPRB, 0.17790549E-05_JPRB, 0.17790562E-05_JPRB, &
  & 0.17790720E-05_JPRB, 0.17790908E-05_JPRB, 0.17791291E-05_JPRB, 0.17792720E-05_JPRB /)

RGHG2(:,90, 7) = (/ &
  & 0.17793598E-05_JPRB, 0.17793963E-05_JPRB, 0.17794043E-05_JPRB, 0.17794366E-05_JPRB, 0.17794878E-05_JPRB, 0.17795174E-05_JPRB, &
  & 0.17795405E-05_JPRB, 0.17795584E-05_JPRB, 0.17795663E-05_JPRB, 0.17795671E-05_JPRB, 0.17795762E-05_JPRB, 0.17795769E-05_JPRB, &
  & 0.17795687E-05_JPRB, 0.17795529E-05_JPRB, 0.17795314E-05_JPRB, 0.17795060E-05_JPRB, 0.17794655E-05_JPRB, 0.17793899E-05_JPRB, &
  & 0.17793137E-05_JPRB, 0.17792346E-05_JPRB, 0.17791156E-05_JPRB, 0.17790219E-05_JPRB, 0.17789150E-05_JPRB, 0.17788625E-05_JPRB, &
  & 0.17788130E-05_JPRB, 0.17788292E-05_JPRB, 0.17788234E-05_JPRB, 0.17788467E-05_JPRB, 0.17788688E-05_JPRB, 0.17788960E-05_JPRB, &
  & 0.17789505E-05_JPRB, 0.17789957E-05_JPRB, 0.17790138E-05_JPRB, 0.17790087E-05_JPRB, 0.17789703E-05_JPRB, 0.17789459E-05_JPRB, &
  & 0.17789184E-05_JPRB, 0.17789056E-05_JPRB, 0.17788950E-05_JPRB, 0.17788658E-05_JPRB, 0.17788411E-05_JPRB, 0.17788116E-05_JPRB, &
  & 0.17788370E-05_JPRB, 0.17788281E-05_JPRB, 0.17788283E-05_JPRB, 0.17788337E-05_JPRB, 0.17788442E-05_JPRB, 0.17788805E-05_JPRB, &
  & 0.17789080E-05_JPRB, 0.17789381E-05_JPRB, 0.17789757E-05_JPRB, 0.17789956E-05_JPRB, 0.17790031E-05_JPRB, 0.17790285E-05_JPRB, &
  & 0.17790467E-05_JPRB, 0.17790567E-05_JPRB, 0.17790379E-05_JPRB, 0.17790330E-05_JPRB, 0.17790561E-05_JPRB, 0.17790568E-05_JPRB, &
  & 0.17790727E-05_JPRB, 0.17790916E-05_JPRB, 0.17791301E-05_JPRB, 0.17792742E-05_JPRB /)

RGHG2(:,91, 7) = (/ &
  & 0.17793564E-05_JPRB, 0.17793955E-05_JPRB, 0.17793973E-05_JPRB, 0.17794354E-05_JPRB, 0.17794860E-05_JPRB, 0.17795177E-05_JPRB, &
  & 0.17795234E-05_JPRB, 0.17795701E-05_JPRB, 0.17795658E-05_JPRB, 0.17795613E-05_JPRB, 0.17795888E-05_JPRB, 0.17795903E-05_JPRB, &
  & 0.17795787E-05_JPRB, 0.17795575E-05_JPRB, 0.17795320E-05_JPRB, 0.17795096E-05_JPRB, 0.17794741E-05_JPRB, 0.17793776E-05_JPRB, &
  & 0.17793078E-05_JPRB, 0.17792338E-05_JPRB, 0.17791125E-05_JPRB, 0.17790226E-05_JPRB, 0.17789117E-05_JPRB, 0.17788625E-05_JPRB, &
  & 0.17788090E-05_JPRB, 0.17788308E-05_JPRB, 0.17788218E-05_JPRB, 0.17788467E-05_JPRB, 0.17788682E-05_JPRB, 0.17788929E-05_JPRB, &
  & 0.17789524E-05_JPRB, 0.17789979E-05_JPRB, 0.17790169E-05_JPRB, 0.17790117E-05_JPRB, 0.17789691E-05_JPRB, 0.17789462E-05_JPRB, &
  & 0.17789174E-05_JPRB, 0.17789059E-05_JPRB, 0.17788967E-05_JPRB, 0.17788658E-05_JPRB, 0.17788417E-05_JPRB, 0.17788067E-05_JPRB, &
  & 0.17788412E-05_JPRB, 0.17788269E-05_JPRB, 0.17788275E-05_JPRB, 0.17788320E-05_JPRB, 0.17788379E-05_JPRB, 0.17788841E-05_JPRB, &
  & 0.17789080E-05_JPRB, 0.17789405E-05_JPRB, 0.17789798E-05_JPRB, 0.17789987E-05_JPRB, 0.17790022E-05_JPRB, 0.17790302E-05_JPRB, &
  & 0.17790481E-05_JPRB, 0.17790589E-05_JPRB, 0.17790372E-05_JPRB, 0.17790318E-05_JPRB, 0.17790578E-05_JPRB, 0.17790560E-05_JPRB, &
  & 0.17790732E-05_JPRB, 0.17790916E-05_JPRB, 0.17791315E-05_JPRB, 0.17792784E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART14',1,ZHOOK_HANDLE)
END SUBROUTINE PART14






SUBROUTINE PART15
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART15',0,ZHOOK_HANDLE)



!-- Month=  8 ------------

RGHG2(:, 1, 8) = (/ &
  & 0.59605583E-08_JPRB, 0.59561849E-08_JPRB, 0.59545511E-08_JPRB, 0.59579000E-08_JPRB, 0.59702536E-08_JPRB, 0.59973004E-08_JPRB, &
  & 0.60512413E-08_JPRB, 0.61477183E-08_JPRB, 0.62999304E-08_JPRB, 0.65156920E-08_JPRB, 0.67959713E-08_JPRB, 0.71369843E-08_JPRB, &
  & 0.75273343E-08_JPRB, 0.79442941E-08_JPRB, 0.83521758E-08_JPRB, 0.87050562E-08_JPRB, 0.89547996E-08_JPRB, 0.90701633E-08_JPRB, &
  & 0.90620595E-08_JPRB, 0.89313081E-08_JPRB, 0.86820169E-08_JPRB, 0.83447622E-08_JPRB, 0.79912192E-08_JPRB, 0.77252817E-08_JPRB, &
  & 0.76586275E-08_JPRB, 0.78986648E-08_JPRB, 0.85323633E-08_JPRB, 0.95265076E-08_JPRB, 0.10679379E-07_JPRB, 0.11780835E-07_JPRB, &
  & 0.12723539E-07_JPRB, 0.13402281E-07_JPRB, 0.13784447E-07_JPRB, 0.13917837E-07_JPRB, 0.13812116E-07_JPRB, 0.13489991E-07_JPRB, &
  & 0.13000784E-07_JPRB, 0.12411185E-07_JPRB, 0.11791635E-07_JPRB, 0.11255442E-07_JPRB, 0.10890012E-07_JPRB, 0.10605617E-07_JPRB, &
  & 0.10328943E-07_JPRB, 0.10037603E-07_JPRB, 0.96888986E-08_JPRB, 0.92724717E-08_JPRB, 0.87094838E-08_JPRB, 0.79968681E-08_JPRB, &
  & 0.73702924E-08_JPRB, 0.68689845E-08_JPRB, 0.65199184E-08_JPRB, 0.62657044E-08_JPRB, 0.60632672E-08_JPRB, 0.58770540E-08_JPRB, &
  & 0.56868976E-08_JPRB, 0.54707781E-08_JPRB, 0.52038200E-08_JPRB, 0.48820890E-08_JPRB, 0.45391952E-08_JPRB, 0.42475428E-08_JPRB, &
  & 0.40676285E-08_JPRB, 0.40394150E-08_JPRB, 0.41445576E-08_JPRB, 0.43180886E-08_JPRB /)

RGHG2(:, 2, 8) = (/ &
  & 0.76673370E-08_JPRB, 0.81532630E-08_JPRB, 0.86094785E-08_JPRB, 0.91699146E-08_JPRB, 0.98340118E-08_JPRB, 0.10605566E-07_JPRB, &
  & 0.11487122E-07_JPRB, 0.12471021E-07_JPRB, 0.13519624E-07_JPRB, 0.14567567E-07_JPRB, 0.15538548E-07_JPRB, 0.16382037E-07_JPRB, &
  & 0.17096884E-07_JPRB, 0.17719310E-07_JPRB, 0.18281984E-07_JPRB, 0.18789507E-07_JPRB, 0.19227809E-07_JPRB, 0.19576751E-07_JPRB, &
  & 0.19797037E-07_JPRB, 0.19871173E-07_JPRB, 0.19817012E-07_JPRB, 0.19697033E-07_JPRB, 0.19612045E-07_JPRB, 0.19677563E-07_JPRB, &
  & 0.20008873E-07_JPRB, 0.20707615E-07_JPRB, 0.21815811E-07_JPRB, 0.23299599E-07_JPRB, 0.25056339E-07_JPRB, 0.26943718E-07_JPRB, &
  & 0.28784997E-07_JPRB, 0.30392329E-07_JPRB, 0.31607691E-07_JPRB, 0.32292224E-07_JPRB, 0.32437452E-07_JPRB, 0.32112183E-07_JPRB, &
  & 0.31412156E-07_JPRB, 0.30440575E-07_JPRB, 0.29329856E-07_JPRB, 0.28250980E-07_JPRB, 0.27352373E-07_JPRB, 0.26606591E-07_JPRB, &
  & 0.25919899E-07_JPRB, 0.25218368E-07_JPRB, 0.24435153E-07_JPRB, 0.23512746E-07_JPRB, 0.22398414E-07_JPRB, 0.21098861E-07_JPRB, &
  & 0.19795397E-07_JPRB, 0.18574902E-07_JPRB, 0.17531340E-07_JPRB, 0.16643718E-07_JPRB, 0.15824023E-07_JPRB, 0.14995098E-07_JPRB, &
  & 0.14161219E-07_JPRB, 0.13275672E-07_JPRB, 0.12282677E-07_JPRB, 0.11272776E-07_JPRB, 0.10301281E-07_JPRB, 0.94173274E-08_JPRB, &
  & 0.86424832E-08_JPRB, 0.78729165E-08_JPRB, 0.69920438E-08_JPRB, 0.57108229E-08_JPRB /)

RGHG2(:, 3, 8) = (/ &
  & 0.98060786E-08_JPRB, 0.10733235E-07_JPRB, 0.11460213E-07_JPRB, 0.12287716E-07_JPRB, 0.13244137E-07_JPRB, 0.14319675E-07_JPRB, &
  & 0.15486444E-07_JPRB, 0.16703348E-07_JPRB, 0.17954745E-07_JPRB, 0.19287022E-07_JPRB, 0.20781062E-07_JPRB, 0.22480069E-07_JPRB, &
  & 0.24353540E-07_JPRB, 0.26310040E-07_JPRB, 0.28233131E-07_JPRB, 0.30003335E-07_JPRB, 0.31524731E-07_JPRB, 0.32739393E-07_JPRB, &
  & 0.33624151E-07_JPRB, 0.34181419E-07_JPRB, 0.34430695E-07_JPRB, 0.34420125E-07_JPRB, 0.34252292E-07_JPRB, 0.34114219E-07_JPRB, &
  & 0.34274596E-07_JPRB, 0.34996823E-07_JPRB, 0.36391867E-07_JPRB, 0.38322327E-07_JPRB, 0.40499256E-07_JPRB, 0.42651756E-07_JPRB, &
  & 0.44623516E-07_JPRB, 0.46270770E-07_JPRB, 0.47441077E-07_JPRB, 0.48053842E-07_JPRB, 0.48118110E-07_JPRB, 0.47704020E-07_JPRB, &
  & 0.46899345E-07_JPRB, 0.45781110E-07_JPRB, 0.44422883E-07_JPRB, 0.42965446E-07_JPRB, 0.41564725E-07_JPRB, 0.40302805E-07_JPRB, &
  & 0.39131528E-07_JPRB, 0.37988464E-07_JPRB, 0.36818783E-07_JPRB, 0.35585405E-07_JPRB, 0.34280582E-07_JPRB, 0.32968224E-07_JPRB, &
  & 0.31708876E-07_JPRB, 0.30568092E-07_JPRB, 0.29510435E-07_JPRB, 0.28517258E-07_JPRB, 0.27523608E-07_JPRB, 0.26435783E-07_JPRB, &
  & 0.25236934E-07_JPRB, 0.23934607E-07_JPRB, 0.22495929E-07_JPRB, 0.20939408E-07_JPRB, 0.19264277E-07_JPRB, 0.17581842E-07_JPRB, &
  & 0.15888830E-07_JPRB, 0.14188294E-07_JPRB, 0.12417495E-07_JPRB, 0.97377217E-08_JPRB /)

RGHG2(:, 4, 8) = (/ &
  & 0.11588924E-07_JPRB, 0.12928611E-07_JPRB, 0.13961292E-07_JPRB, 0.15092251E-07_JPRB, 0.16406419E-07_JPRB, 0.17934035E-07_JPRB, &
  & 0.19685434E-07_JPRB, 0.21688614E-07_JPRB, 0.23942894E-07_JPRB, 0.26407331E-07_JPRB, 0.29022036E-07_JPRB, 0.31714052E-07_JPRB, &
  & 0.34375880E-07_JPRB, 0.36875242E-07_JPRB, 0.39121698E-07_JPRB, 0.41096627E-07_JPRB, 0.42815707E-07_JPRB, 0.44290076E-07_JPRB, &
  & 0.45523969E-07_JPRB, 0.46525528E-07_JPRB, 0.47309793E-07_JPRB, 0.47901644E-07_JPRB, 0.48348831E-07_JPRB, 0.48738833E-07_JPRB, &
  & 0.49193240E-07_JPRB, 0.49862560E-07_JPRB, 0.50858791E-07_JPRB, 0.52199802E-07_JPRB, 0.53796889E-07_JPRB, 0.55522985E-07_JPRB, &
  & 0.57235468E-07_JPRB, 0.58802570E-07_JPRB, 0.60088631E-07_JPRB, 0.60973846E-07_JPRB, 0.61392356E-07_JPRB, 0.61353148E-07_JPRB, &
  & 0.60894131E-07_JPRB, 0.60058859E-07_JPRB, 0.58878946E-07_JPRB, 0.57389734E-07_JPRB, 0.55683621E-07_JPRB, 0.53844335E-07_JPRB, &
  & 0.51934073E-07_JPRB, 0.49953783E-07_JPRB, 0.47901754E-07_JPRB, 0.45792973E-07_JPRB, 0.43668461E-07_JPRB, 0.41597914E-07_JPRB, &
  & 0.39684345E-07_JPRB, 0.37946396E-07_JPRB, 0.36382183E-07_JPRB, 0.34956521E-07_JPRB, 0.33649584E-07_JPRB, 0.32409805E-07_JPRB, &
  & 0.31178107E-07_JPRB, 0.29927968E-07_JPRB, 0.28613934E-07_JPRB, 0.27178116E-07_JPRB, 0.25585528E-07_JPRB, 0.23862352E-07_JPRB, &
  & 0.22205557E-07_JPRB, 0.20633625E-07_JPRB, 0.18845327E-07_JPRB, 0.15549666E-07_JPRB /)

RGHG2(:, 5, 8) = (/ &
  & 0.13024857E-07_JPRB, 0.14937529E-07_JPRB, 0.16408938E-07_JPRB, 0.18032416E-07_JPRB, 0.19944588E-07_JPRB, 0.22187205E-07_JPRB, &
  & 0.24745123E-07_JPRB, 0.27550623E-07_JPRB, 0.30483783E-07_JPRB, 0.33492952E-07_JPRB, 0.36503941E-07_JPRB, 0.39446171E-07_JPRB, &
  & 0.42268173E-07_JPRB, 0.44931973E-07_JPRB, 0.47379270E-07_JPRB, 0.49548547E-07_JPRB, 0.51425012E-07_JPRB, 0.53046321E-07_JPRB, &
  & 0.54473425E-07_JPRB, 0.55757042E-07_JPRB, 0.56926364E-07_JPRB, 0.57999749E-07_JPRB, 0.58992065E-07_JPRB, 0.59922783E-07_JPRB, &
  & 0.60829869E-07_JPRB, 0.61757468E-07_JPRB, 0.62767100E-07_JPRB, 0.63915174E-07_JPRB, 0.65253786E-07_JPRB, 0.66807814E-07_JPRB, &
  & 0.68573229E-07_JPRB, 0.70491730E-07_JPRB, 0.72451705E-07_JPRB, 0.74292473E-07_JPRB, 0.75857372E-07_JPRB, 0.77037129E-07_JPRB, &
  & 0.77818115E-07_JPRB, 0.78203890E-07_JPRB, 0.78191064E-07_JPRB, 0.77713068E-07_JPRB, 0.76680976E-07_JPRB, 0.75045712E-07_JPRB, &
  & 0.72805747E-07_JPRB, 0.70062008E-07_JPRB, 0.66923427E-07_JPRB, 0.63472115E-07_JPRB, 0.59803817E-07_JPRB, 0.56024316E-07_JPRB, &
  & 0.52233080E-07_JPRB, 0.48560810E-07_JPRB, 0.45083105E-07_JPRB, 0.41855042E-07_JPRB, 0.38920980E-07_JPRB, 0.36320824E-07_JPRB, &
  & 0.34071753E-07_JPRB, 0.32107138E-07_JPRB, 0.30433810E-07_JPRB, 0.28958857E-07_JPRB, 0.27645070E-07_JPRB, 0.26528962E-07_JPRB, &
  & 0.25423756E-07_JPRB, 0.24228203E-07_JPRB, 0.22923523E-07_JPRB, 0.20564990E-07_JPRB /)

RGHG2(:, 6, 8) = (/ &
  & 0.14580142E-07_JPRB, 0.17338353E-07_JPRB, 0.19447061E-07_JPRB, 0.21716589E-07_JPRB, 0.24253847E-07_JPRB, 0.27119636E-07_JPRB, &
  & 0.30257056E-07_JPRB, 0.33503564E-07_JPRB, 0.36771411E-07_JPRB, 0.39988752E-07_JPRB, 0.43143128E-07_JPRB, 0.46204001E-07_JPRB, &
  & 0.49111609E-07_JPRB, 0.51805614E-07_JPRB, 0.54275347E-07_JPRB, 0.56550405E-07_JPRB, 0.58651757E-07_JPRB, 0.60581570E-07_JPRB, &
  & 0.62363128E-07_JPRB, 0.64058554E-07_JPRB, 0.65732237E-07_JPRB, 0.67419371E-07_JPRB, 0.69126756E-07_JPRB, 0.70844912E-07_JPRB, &
  & 0.72537091E-07_JPRB, 0.74152439E-07_JPRB, 0.75644401E-07_JPRB, 0.77036432E-07_JPRB, 0.78446412E-07_JPRB, 0.80032052E-07_JPRB, &
  & 0.81897078E-07_JPRB, 0.84156063E-07_JPRB, 0.86922704E-07_JPRB, 0.90164917E-07_JPRB, 0.93665548E-07_JPRB, 0.97151052E-07_JPRB, &
  & 0.10039660E-06_JPRB, 0.10327778E-06_JPRB, 0.10567017E-06_JPRB, 0.10738530E-06_JPRB, 0.10812160E-06_JPRB, 0.10759759E-06_JPRB, &
  & 0.10569558E-06_JPRB, 0.10252542E-06_JPRB, 0.98308782E-07_JPRB, 0.93228486E-07_JPRB, 0.87408537E-07_JPRB, 0.80997715E-07_JPRB, &
  & 0.74202227E-07_JPRB, 0.67271046E-07_JPRB, 0.60454695E-07_JPRB, 0.53988497E-07_JPRB, 0.48030593E-07_JPRB, 0.42734001E-07_JPRB, &
  & 0.38210530E-07_JPRB, 0.34485439E-07_JPRB, 0.31478773E-07_JPRB, 0.29185507E-07_JPRB, 0.27377697E-07_JPRB, 0.26011673E-07_JPRB, &
  & 0.25033332E-07_JPRB, 0.24265844E-07_JPRB, 0.23671275E-07_JPRB, 0.22779831E-07_JPRB /)

RGHG2(:, 7, 8) = (/ &
  & 0.16928237E-07_JPRB, 0.20829100E-07_JPRB, 0.23697785E-07_JPRB, 0.26476121E-07_JPRB, 0.29479924E-07_JPRB, 0.32692729E-07_JPRB, &
  & 0.36046384E-07_JPRB, 0.39427945E-07_JPRB, 0.42747047E-07_JPRB, 0.45994408E-07_JPRB, 0.49157453E-07_JPRB, 0.52226206E-07_JPRB, &
  & 0.55200047E-07_JPRB, 0.58068242E-07_JPRB, 0.60806656E-07_JPRB, 0.63389948E-07_JPRB, 0.65838933E-07_JPRB, 0.68198602E-07_JPRB, &
  & 0.70494565E-07_JPRB, 0.72758795E-07_JPRB, 0.75065621E-07_JPRB, 0.77497944E-07_JPRB, 0.80100932E-07_JPRB, 0.82877506E-07_JPRB, &
  & 0.85774602E-07_JPRB, 0.88654197E-07_JPRB, 0.91311136E-07_JPRB, 0.93604307E-07_JPRB, 0.95578727E-07_JPRB, 0.97391883E-07_JPRB, &
  & 0.99341584E-07_JPRB, 0.10197752E-06_JPRB, 0.10578870E-06_JPRB, 0.11082123E-06_JPRB, 0.11681072E-06_JPRB, 0.12332889E-06_JPRB, &
  & 0.12995871E-06_JPRB, 0.13636520E-06_JPRB, 0.14222837E-06_JPRB, 0.14712343E-06_JPRB, 0.15050048E-06_JPRB, 0.15177753E-06_JPRB, &
  & 0.15071089E-06_JPRB, 0.14741389E-06_JPRB, 0.14215136E-06_JPRB, 0.13513858E-06_JPRB, 0.12658364E-06_JPRB, 0.11671769E-06_JPRB, &
  & 0.10586457E-06_JPRB, 0.94484157E-07_JPRB, 0.83100815E-07_JPRB, 0.72170067E-07_JPRB, 0.62062860E-07_JPRB, 0.53026394E-07_JPRB, &
  & 0.45246903E-07_JPRB, 0.38806089E-07_JPRB, 0.33696143E-07_JPRB, 0.29755810E-07_JPRB, 0.26905383E-07_JPRB, 0.24817925E-07_JPRB, &
  & 0.23329003E-07_JPRB, 0.22414806E-07_JPRB, 0.22012411E-07_JPRB, 0.22022327E-07_JPRB /)

RGHG2(:, 8, 8) = (/ &
  & 0.20794511E-07_JPRB, 0.26002073E-07_JPRB, 0.29381741E-07_JPRB, 0.32507792E-07_JPRB, 0.35653752E-07_JPRB, 0.38939646E-07_JPRB, &
  & 0.42277989E-07_JPRB, 0.45587019E-07_JPRB, 0.48825008E-07_JPRB, 0.51996658E-07_JPRB, 0.55122978E-07_JPRB, 0.58228999E-07_JPRB, &
  & 0.61312271E-07_JPRB, 0.64360734E-07_JPRB, 0.67355565E-07_JPRB, 0.70280322E-07_JPRB, 0.73110854E-07_JPRB, 0.75862943E-07_JPRB, &
  & 0.78614498E-07_JPRB, 0.81452811E-07_JPRB, 0.84474145E-07_JPRB, 0.87865210E-07_JPRB, 0.91834877E-07_JPRB, 0.96459779E-07_JPRB, &
  & 0.10158814E-06_JPRB, 0.10686968E-06_JPRB, 0.11185994E-06_JPRB, 0.11619942E-06_JPRB, 0.11964696E-06_JPRB, 0.12228963E-06_JPRB, &
  & 0.12478445E-06_JPRB, 0.12809117E-06_JPRB, 0.13289247E-06_JPRB, 0.13944151E-06_JPRB, 0.14768966E-06_JPRB, 0.15732661E-06_JPRB, &
  & 0.16775479E-06_JPRB, 0.17834121E-06_JPRB, 0.18845728E-06_JPRB, 0.19730639E-06_JPRB, 0.20395517E-06_JPRB, 0.20762221E-06_JPRB, &
  & 0.20784245E-06_JPRB, 0.20462446E-06_JPRB, 0.19823241E-06_JPRB, 0.18897192E-06_JPRB, 0.17711203E-06_JPRB, 0.16298756E-06_JPRB, &
  & 0.14716684E-06_JPRB, 0.13040412E-06_JPRB, 0.11352579E-06_JPRB, 0.97227833E-07_JPRB, 0.82065085E-07_JPRB, 0.68453375E-07_JPRB, &
  & 0.56642534E-07_JPRB, 0.46771351E-07_JPRB, 0.38791523E-07_JPRB, 0.32606099E-07_JPRB, 0.27934352E-07_JPRB, 0.24614851E-07_JPRB, &
  & 0.22344672E-07_JPRB, 0.20805071E-07_JPRB, 0.19966496E-07_JPRB, 0.19805293E-07_JPRB /)

RGHG2(:, 9, 8) = (/ &
  & 0.26886656E-07_JPRB, 0.33283435E-07_JPRB, 0.36924018E-07_JPRB, 0.40179870E-07_JPRB, 0.43335319E-07_JPRB, 0.46552771E-07_JPRB, &
  & 0.49800342E-07_JPRB, 0.52987755E-07_JPRB, 0.56090240E-07_JPRB, 0.59124787E-07_JPRB, 0.62134674E-07_JPRB, 0.65153813E-07_JPRB, &
  & 0.68216451E-07_JPRB, 0.71326696E-07_JPRB, 0.74466918E-07_JPRB, 0.77610423E-07_JPRB, 0.80757189E-07_JPRB, 0.83926182E-07_JPRB, &
  & 0.87175238E-07_JPRB, 0.90661388E-07_JPRB, 0.94588309E-07_JPRB, 0.99123511E-07_JPRB, 0.10450712E-06_JPRB, 0.11112224E-06_JPRB, &
  & 0.11909241E-06_JPRB, 0.12806622E-06_JPRB, 0.13737181E-06_JPRB, 0.14608963E-06_JPRB, 0.15357622E-06_JPRB, 0.15989910E-06_JPRB, &
  & 0.16559272E-06_JPRB, 0.17136007E-06_JPRB, 0.17800784E-06_JPRB, 0.18628484E-06_JPRB, 0.19657250E-06_JPRB, 0.20876190E-06_JPRB, &
  & 0.22241731E-06_JPRB, 0.23674635E-06_JPRB, 0.25068459E-06_JPRB, 0.26298054E-06_JPRB, 0.27242658E-06_JPRB, 0.27797597E-06_JPRB, &
  & 0.27890587E-06_JPRB, 0.27516296E-06_JPRB, 0.26701102E-06_JPRB, 0.25473719E-06_JPRB, 0.23872849E-06_JPRB, 0.21958159E-06_JPRB, &
  & 0.19818674E-06_JPRB, 0.17562365E-06_JPRB, 0.15292746E-06_JPRB, 0.13101304E-06_JPRB, 0.11055876E-06_JPRB, 0.92054968E-07_JPRB, &
  & 0.75863795E-07_JPRB, 0.62156317E-07_JPRB, 0.50921766E-07_JPRB, 0.42006100E-07_JPRB, 0.35167734E-07_JPRB, 0.30040834E-07_JPRB, &
  & 0.26301388E-07_JPRB, 0.23574172E-07_JPRB, 0.21594978E-07_JPRB, 0.19722929E-07_JPRB /)

RGHG2(:,10, 8) = (/ &
  & 0.36183984E-07_JPRB, 0.43034145E-07_JPRB, 0.47119990E-07_JPRB, 0.50259093E-07_JPRB, 0.53372947E-07_JPRB, 0.56467222E-07_JPRB, &
  & 0.59595795E-07_JPRB, 0.62673784E-07_JPRB, 0.65646411E-07_JPRB, 0.68528664E-07_JPRB, 0.71362336E-07_JPRB, 0.74202696E-07_JPRB, &
  & 0.77099216E-07_JPRB, 0.80084277E-07_JPRB, 0.83170896E-07_JPRB, 0.86357645E-07_JPRB, 0.89640835E-07_JPRB, 0.93058979E-07_JPRB, &
  & 0.96703488E-07_JPRB, 0.10073009E-06_JPRB, 0.10543397E-06_JPRB, 0.11134365E-06_JPRB, 0.11910159E-06_JPRB, 0.12922685E-06_JPRB, &
  & 0.14200822E-06_JPRB, 0.15708903E-06_JPRB, 0.17352838E-06_JPRB, 0.19039909E-06_JPRB, 0.20714531E-06_JPRB, 0.22326083E-06_JPRB, &
  & 0.23809702E-06_JPRB, 0.25135640E-06_JPRB, 0.26358401E-06_JPRB, 0.27578849E-06_JPRB, 0.28888550E-06_JPRB, 0.30322138E-06_JPRB, &
  & 0.31845164E-06_JPRB, 0.33368352E-06_JPRB, 0.34775076E-06_JPRB, 0.35923830E-06_JPRB, 0.36714363E-06_JPRB, 0.37026717E-06_JPRB, &
  & 0.36822522E-06_JPRB, 0.36100090E-06_JPRB, 0.34863857E-06_JPRB, 0.33151750E-06_JPRB, 0.31016015E-06_JPRB, 0.28542095E-06_JPRB, &
  & 0.25836422E-06_JPRB, 0.23025125E-06_JPRB, 0.20237350E-06_JPRB, 0.17561469E-06_JPRB, 0.15065524E-06_JPRB, 0.12801607E-06_JPRB, &
  & 0.10806878E-06_JPRB, 0.91041429E-07_JPRB, 0.76937596E-07_JPRB, 0.65578369E-07_JPRB, 0.56778177E-07_JPRB, 0.50099104E-07_JPRB, &
  & 0.45181046E-07_JPRB, 0.41318156E-07_JPRB, 0.38112521E-07_JPRB, 0.33406000E-07_JPRB /)

RGHG2(:,11, 8) = (/ &
  & 0.48060478E-07_JPRB, 0.55561713E-07_JPRB, 0.59053072E-07_JPRB, 0.62139833E-07_JPRB, 0.64870228E-07_JPRB, 0.67728237E-07_JPRB, &
  & 0.70659162E-07_JPRB, 0.73637949E-07_JPRB, 0.76600450E-07_JPRB, 0.79525904E-07_JPRB, 0.82426212E-07_JPRB, 0.85340425E-07_JPRB, &
  & 0.88311829E-07_JPRB, 0.91379803E-07_JPRB, 0.94571931E-07_JPRB, 0.97908575E-07_JPRB, 0.10142088E-06_JPRB, 0.10517122E-06_JPRB, &
  & 0.10930481E-06_JPRB, 0.11406732E-06_JPRB, 0.11988126E-06_JPRB, 0.12738792E-06_JPRB, 0.13745384E-06_JPRB, 0.15118883E-06_JPRB, &
  & 0.16921915E-06_JPRB, 0.19145834E-06_JPRB, 0.21730503E-06_JPRB, 0.24655904E-06_JPRB, 0.27862282E-06_JPRB, 0.31200614E-06_JPRB, &
  & 0.34468079E-06_JPRB, 0.37476462E-06_JPRB, 0.40121398E-06_JPRB, 0.42399512E-06_JPRB, 0.44336082E-06_JPRB, 0.45977822E-06_JPRB, &
  & 0.47308356E-06_JPRB, 0.48341593E-06_JPRB, 0.49002961E-06_JPRB, 0.49287456E-06_JPRB, 0.49135019E-06_JPRB, 0.48535338E-06_JPRB, &
  & 0.47491793E-06_JPRB, 0.45973982E-06_JPRB, 0.44002741E-06_JPRB, 0.41610355E-06_JPRB, 0.38852536E-06_JPRB, 0.35808392E-06_JPRB, &
  & 0.32600803E-06_JPRB, 0.29375792E-06_JPRB, 0.26235276E-06_JPRB, 0.23260584E-06_JPRB, 0.20509164E-06_JPRB, 0.18023070E-06_JPRB, &
  & 0.15833768E-06_JPRB, 0.13964271E-06_JPRB, 0.12413015E-06_JPRB, 0.11168662E-06_JPRB, 0.10215307E-06_JPRB, 0.95036846E-07_JPRB, &
  & 0.90182624E-07_JPRB, 0.86429921E-07_JPRB, 0.84302741E-07_JPRB, 0.80741209E-07_JPRB /)

RGHG2(:,12, 8) = (/ &
  & 0.60921167E-07_JPRB, 0.66592293E-07_JPRB, 0.69672055E-07_JPRB, 0.71922400E-07_JPRB, 0.74277118E-07_JPRB, 0.76735603E-07_JPRB, &
  & 0.79492168E-07_JPRB, 0.82516138E-07_JPRB, 0.85777792E-07_JPRB, 0.89259458E-07_JPRB, 0.92970268E-07_JPRB, 0.96923017E-07_JPRB, &
  & 0.10113780E-06_JPRB, 0.10560325E-06_JPRB, 0.11029096E-06_JPRB, 0.11514384E-06_JPRB, 0.12010473E-06_JPRB, 0.12522048E-06_JPRB, &
  & 0.13064346E-06_JPRB, 0.13666336E-06_JPRB, 0.14384290E-06_JPRB, 0.15305802E-06_JPRB, 0.16555791E-06_JPRB, 0.18262182E-06_JPRB, &
  & 0.20531292E-06_JPRB, 0.23407051E-06_JPRB, 0.26909916E-06_JPRB, 0.30918767E-06_JPRB, 0.35367941E-06_JPRB, 0.40278326E-06_JPRB, &
  & 0.45425460E-06_JPRB, 0.50330141E-06_JPRB, 0.54613599E-06_JPRB, 0.58116848E-06_JPRB, 0.60787266E-06_JPRB, 0.62676202E-06_JPRB, &
  & 0.63800252E-06_JPRB, 0.64272831E-06_JPRB, 0.64092654E-06_JPRB, 0.63390638E-06_JPRB, 0.62192390E-06_JPRB, 0.60555607E-06_JPRB, &
  & 0.58500575E-06_JPRB, 0.56080734E-06_JPRB, 0.53308088E-06_JPRB, 0.50220103E-06_JPRB, 0.46882190E-06_JPRB, 0.43398455E-06_JPRB, &
  & 0.39896739E-06_JPRB, 0.36477377E-06_JPRB, 0.33241082E-06_JPRB, 0.30246710E-06_JPRB, 0.27524547E-06_JPRB, 0.25095122E-06_JPRB, &
  & 0.22975911E-06_JPRB, 0.21174941E-06_JPRB, 0.19692042E-06_JPRB, 0.18518330E-06_JPRB, 0.17649609E-06_JPRB, 0.17029002E-06_JPRB, &
  & 0.16682093E-06_JPRB, 0.16440499E-06_JPRB, 0.16518088E-06_JPRB, 0.16612150E-06_JPRB /)

RGHG2(:,13, 8) = (/ &
  & 0.70226179E-07_JPRB, 0.73867078E-07_JPRB, 0.75859809E-07_JPRB, 0.77902250E-07_JPRB, 0.80122213E-07_JPRB, 0.82936062E-07_JPRB, &
  & 0.86439975E-07_JPRB, 0.90808378E-07_JPRB, 0.96159596E-07_JPRB, 0.10263712E-06_JPRB, 0.11037696E-06_JPRB, 0.11942346E-06_JPRB, &
  & 0.12963969E-06_JPRB, 0.14062833E-06_JPRB, 0.15185510E-06_JPRB, 0.16258224E-06_JPRB, 0.17229760E-06_JPRB, 0.18055988E-06_JPRB, &
  & 0.18758210E-06_JPRB, 0.19396735E-06_JPRB, 0.20071749E-06_JPRB, 0.20910711E-06_JPRB, 0.22067672E-06_JPRB, 0.23710747E-06_JPRB, &
  & 0.25975132E-06_JPRB, 0.28943717E-06_JPRB, 0.32679577E-06_JPRB, 0.37323298E-06_JPRB, 0.42813525E-06_JPRB, 0.48818686E-06_JPRB, &
  & 0.55075657E-06_JPRB, 0.61126923E-06_JPRB, 0.66462104E-06_JPRB, 0.70793948E-06_JPRB, 0.74031811E-06_JPRB, 0.76181999E-06_JPRB, &
  & 0.77291725E-06_JPRB, 0.77467297E-06_JPRB, 0.76818844E-06_JPRB, 0.75489947E-06_JPRB, 0.73588348E-06_JPRB, 0.71226634E-06_JPRB, &
  & 0.68480972E-06_JPRB, 0.65403731E-06_JPRB, 0.62060394E-06_JPRB, 0.58513422E-06_JPRB, 0.54856031E-06_JPRB, 0.51187419E-06_JPRB, &
  & 0.47623541E-06_JPRB, 0.44286500E-06_JPRB, 0.41233312E-06_JPRB, 0.38490964E-06_JPRB, 0.36062130E-06_JPRB, 0.33941498E-06_JPRB, &
  & 0.32121591E-06_JPRB, 0.30596857E-06_JPRB, 0.29358696E-06_JPRB, 0.28399691E-06_JPRB, 0.27728183E-06_JPRB, 0.27280350E-06_JPRB, &
  & 0.27127584E-06_JPRB, 0.27076223E-06_JPRB, 0.27454377E-06_JPRB, 0.28114414E-06_JPRB /)

RGHG2(:,14, 8) = (/ &
  & 0.81329759E-07_JPRB, 0.87369500E-07_JPRB, 0.91217700E-07_JPRB, 0.94640718E-07_JPRB, 0.98556526E-07_JPRB, 0.10340634E-06_JPRB, &
  & 0.10986646E-06_JPRB, 0.11847382E-06_JPRB, 0.12973540E-06_JPRB, 0.14403267E-06_JPRB, 0.16144010E-06_JPRB, 0.18159948E-06_JPRB, &
  & 0.20344137E-06_JPRB, 0.22523787E-06_JPRB, 0.24511030E-06_JPRB, 0.26173365E-06_JPRB, 0.27464154E-06_JPRB, 0.28415133E-06_JPRB, &
  & 0.29092536E-06_JPRB, 0.29595265E-06_JPRB, 0.30030284E-06_JPRB, 0.30540005E-06_JPRB, 0.31295474E-06_JPRB, 0.32491400E-06_JPRB, &
  & 0.34314360E-06_JPRB, 0.36949285E-06_JPRB, 0.40517696E-06_JPRB, 0.45031408E-06_JPRB, 0.50569139E-06_JPRB, 0.56958476E-06_JPRB, &
  & 0.63669455E-06_JPRB, 0.70215600E-06_JPRB, 0.76078067E-06_JPRB, 0.80914378E-06_JPRB, 0.84541864E-06_JPRB, 0.86894875E-06_JPRB, &
  & 0.88031618E-06_JPRB, 0.88070885E-06_JPRB, 0.87175511E-06_JPRB, 0.85515126E-06_JPRB, 0.83239962E-06_JPRB, 0.80489986E-06_JPRB, &
  & 0.77372346E-06_JPRB, 0.73976923E-06_JPRB, 0.70385522E-06_JPRB, 0.66685652E-06_JPRB, 0.62981678E-06_JPRB, 0.59405318E-06_JPRB, &
  & 0.56076675E-06_JPRB, 0.53063127E-06_JPRB, 0.50397341E-06_JPRB, 0.48074162E-06_JPRB, 0.46068661E-06_JPRB, 0.44351856E-06_JPRB, &
  & 0.42901419E-06_JPRB, 0.41699903E-06_JPRB, 0.40738593E-06_JPRB, 0.40015414E-06_JPRB, 0.39537707E-06_JPRB, 0.39265478E-06_JPRB, &
  & 0.39265487E-06_JPRB, 0.39387675E-06_JPRB, 0.39969777E-06_JPRB, 0.41101538E-06_JPRB /)

RGHG2(:,15, 8) = (/ &
  & 0.12563196E-06_JPRB, 0.14269705E-06_JPRB, 0.15020737E-06_JPRB, 0.15509346E-06_JPRB, 0.15964379E-06_JPRB, 0.16544486E-06_JPRB, &
  & 0.17373381E-06_JPRB, 0.18562767E-06_JPRB, 0.20182435E-06_JPRB, 0.22246971E-06_JPRB, 0.24700086E-06_JPRB, 0.27406989E-06_JPRB, &
  & 0.30188073E-06_JPRB, 0.32852631E-06_JPRB, 0.35233336E-06_JPRB, 0.37216114E-06_JPRB, 0.38773106E-06_JPRB, 0.39946050E-06_JPRB, &
  & 0.40823738E-06_JPRB, 0.41501139E-06_JPRB, 0.42081314E-06_JPRB, 0.42673398E-06_JPRB, 0.43409227E-06_JPRB, 0.44454964E-06_JPRB, &
  & 0.46002401E-06_JPRB, 0.48239252E-06_JPRB, 0.51385450E-06_JPRB, 0.55566068E-06_JPRB, 0.60720777E-06_JPRB, 0.66732525E-06_JPRB, &
  & 0.73210288E-06_JPRB, 0.79609680E-06_JPRB, 0.85421573E-06_JPRB, 0.90271237E-06_JPRB, 0.93872603E-06_JPRB, 0.96186898E-06_JPRB, &
  & 0.97250995E-06_JPRB, 0.97190446E-06_JPRB, 0.96194299E-06_JPRB, 0.94446790E-06_JPRB, 0.92108058E-06_JPRB, 0.89305291E-06_JPRB, &
  & 0.86153290E-06_JPRB, 0.82748170E-06_JPRB, 0.79193637E-06_JPRB, 0.75612735E-06_JPRB, 0.72131348E-06_JPRB, 0.68865444E-06_JPRB, &
  & 0.65909239E-06_JPRB, 0.63313689E-06_JPRB, 0.61079481E-06_JPRB, 0.59170634E-06_JPRB, 0.57540421E-06_JPRB, 0.56147564E-06_JPRB, &
  & 0.54965864E-06_JPRB, 0.53982359E-06_JPRB, 0.53197527E-06_JPRB, 0.52617787E-06_JPRB, 0.52251539E-06_JPRB, 0.52087921E-06_JPRB, &
  & 0.52159555E-06_JPRB, 0.52397922E-06_JPRB, 0.53068402E-06_JPRB, 0.54476436E-06_JPRB /)

RGHG2(:,16, 8) = (/ &
  & 0.25297169E-06_JPRB, 0.27333317E-06_JPRB, 0.27764588E-06_JPRB, 0.27722959E-06_JPRB, 0.27626916E-06_JPRB, 0.27656199E-06_JPRB, &
  & 0.28025195E-06_JPRB, 0.28875522E-06_JPRB, 0.30297628E-06_JPRB, 0.32300528E-06_JPRB, 0.34808781E-06_JPRB, 0.37697995E-06_JPRB, &
  & 0.40773509E-06_JPRB, 0.43823371E-06_JPRB, 0.46665352E-06_JPRB, 0.49183092E-06_JPRB, 0.51329243E-06_JPRB, 0.53115713E-06_JPRB, &
  & 0.54597677E-06_JPRB, 0.55862949E-06_JPRB, 0.57001762E-06_JPRB, 0.58109316E-06_JPRB, 0.59289778E-06_JPRB, 0.60671965E-06_JPRB, &
  & 0.62406446E-06_JPRB, 0.64663499E-06_JPRB, 0.67586694E-06_JPRB, 0.71294232E-06_JPRB, 0.75783134E-06_JPRB, 0.80878033E-06_JPRB, &
  & 0.86309586E-06_JPRB, 0.91634359E-06_JPRB, 0.96434383E-06_JPRB, 0.10037637E-05_JPRB, 0.10327852E-05_JPRB, 0.10506695E-05_JPRB, &
  & 0.10578585E-05_JPRB, 0.10560589E-05_JPRB, 0.10468681E-05_JPRB, 0.10316238E-05_JPRB, 0.10113049E-05_JPRB, 0.98678606E-06_JPRB, &
  & 0.95882149E-06_JPRB, 0.92828043E-06_JPRB, 0.89627503E-06_JPRB, 0.86404134E-06_JPRB, 0.83290320E-06_JPRB, 0.80399536E-06_JPRB, &
  & 0.77810910E-06_JPRB, 0.75548843E-06_JPRB, 0.73589297E-06_JPRB, 0.71887268E-06_JPRB, 0.70398153E-06_JPRB, 0.69092204E-06_JPRB, &
  & 0.67957097E-06_JPRB, 0.66993812E-06_JPRB, 0.66213391E-06_JPRB, 0.65631832E-06_JPRB, 0.65259871E-06_JPRB, 0.65101534E-06_JPRB, &
  & 0.65158878E-06_JPRB, 0.65432198E-06_JPRB, 0.66096561E-06_JPRB, 0.67585222E-06_JPRB /)

RGHG2(:,17, 8) = (/ &
  & 0.44306370E-06_JPRB, 0.44341283E-06_JPRB, 0.43517804E-06_JPRB, 0.42611839E-06_JPRB, 0.41624943E-06_JPRB, 0.40858254E-06_JPRB, &
  & 0.40474976E-06_JPRB, 0.40673257E-06_JPRB, 0.41576573E-06_JPRB, 0.43237173E-06_JPRB, 0.45600459E-06_JPRB, 0.48554642E-06_JPRB, &
  & 0.51939185E-06_JPRB, 0.55544263E-06_JPRB, 0.59150744E-06_JPRB, 0.62567278E-06_JPRB, 0.65687334E-06_JPRB, 0.68480028E-06_JPRB, &
  & 0.70971998E-06_JPRB, 0.73228023E-06_JPRB, 0.75341472E-06_JPRB, 0.77413523E-06_JPRB, 0.79547152E-06_JPRB, 0.81840142E-06_JPRB, &
  & 0.84371629E-06_JPRB, 0.87181718E-06_JPRB, 0.90286329E-06_JPRB, 0.93606798E-06_JPRB, 0.97064276E-06_JPRB, 0.10050666E-05_JPRB, &
  & 0.10382693E-05_JPRB, 0.10684973E-05_JPRB, 0.10946399E-05_JPRB, 0.11150755E-05_JPRB, 0.11288863E-05_JPRB, 0.11361439E-05_JPRB, &
  & 0.11381857E-05_JPRB, 0.11354475E-05_JPRB, 0.11286651E-05_JPRB, 0.11183754E-05_JPRB, 0.11046802E-05_JPRB, 0.10875909E-05_JPRB, &
  & 0.10671505E-05_JPRB, 0.10437627E-05_JPRB, 0.10181799E-05_JPRB, 0.99149065E-06_JPRB, 0.96492226E-06_JPRB, 0.93949387E-06_JPRB, &
  & 0.91591431E-06_JPRB, 0.89441039E-06_JPRB, 0.87482255E-06_JPRB, 0.85690726E-06_JPRB, 0.84050379E-06_JPRB, 0.82563741E-06_JPRB, &
  & 0.81243280E-06_JPRB, 0.80107691E-06_JPRB, 0.79175601E-06_JPRB, 0.78464961E-06_JPRB, 0.77985834E-06_JPRB, 0.77740651E-06_JPRB, &
  & 0.77724383E-06_JPRB, 0.77951222E-06_JPRB, 0.78530877E-06_JPRB, 0.79941492E-06_JPRB /)

RGHG2(:,18, 8) = (/ &
  & 0.61453534E-06_JPRB, 0.60015634E-06_JPRB, 0.58244268E-06_JPRB, 0.56766640E-06_JPRB, 0.55133796E-06_JPRB, 0.53802813E-06_JPRB, &
  & 0.52825544E-06_JPRB, 0.52471353E-06_JPRB, 0.52909041E-06_JPRB, 0.54251450E-06_JPRB, 0.56496890E-06_JPRB, 0.59585307E-06_JPRB, &
  & 0.63365633E-06_JPRB, 0.67624950E-06_JPRB, 0.72106445E-06_JPRB, 0.76546615E-06_JPRB, 0.80732417E-06_JPRB, 0.84569012E-06_JPRB, &
  & 0.88073591E-06_JPRB, 0.91321175E-06_JPRB, 0.94404623E-06_JPRB, 0.97427574E-06_JPRB, 0.10049960E-05_JPRB, 0.10369486E-05_JPRB, &
  & 0.10697920E-05_JPRB, 0.11027039E-05_JPRB, 0.11339374E-05_JPRB, 0.11615360E-05_JPRB, 0.11839509E-05_JPRB, 0.12009211E-05_JPRB, &
  & 0.12125422E-05_JPRB, 0.12195885E-05_JPRB, 0.12226416E-05_JPRB, 0.12225692E-05_JPRB, 0.12204332E-05_JPRB, 0.12171530E-05_JPRB, &
  & 0.12131716E-05_JPRB, 0.12091976E-05_JPRB, 0.12053513E-05_JPRB, 0.12010061E-05_JPRB, 0.11951829E-05_JPRB, 0.11869153E-05_JPRB, &
  & 0.11754655E-05_JPRB, 0.11605947E-05_JPRB, 0.11426350E-05_JPRB, 0.11222611E-05_JPRB, 0.11004105E-05_JPRB, 0.10779373E-05_JPRB, &
  & 0.10555559E-05_JPRB, 0.10336875E-05_JPRB, 0.10124807E-05_JPRB, 0.99212082E-06_JPRB, 0.97286579E-06_JPRB, 0.95506221E-06_JPRB, &
  & 0.93907732E-06_JPRB, 0.92524573E-06_JPRB, 0.91379411E-06_JPRB, 0.90486549E-06_JPRB, 0.89851358E-06_JPRB, 0.89471280E-06_JPRB, &
  & 0.89339898E-06_JPRB, 0.89458132E-06_JPRB, 0.89922133E-06_JPRB, 0.91168545E-06_JPRB /)

RGHG2(:,19, 8) = (/ &
  & 0.74980414E-06_JPRB, 0.72830767E-06_JPRB, 0.70772433E-06_JPRB, 0.69047877E-06_JPRB, 0.67229678E-06_JPRB, 0.65618809E-06_JPRB, &
  & 0.64341350E-06_JPRB, 0.63663197E-06_JPRB, 0.63803554E-06_JPRB, 0.64931328E-06_JPRB, 0.67096215E-06_JPRB, 0.70282988E-06_JPRB, &
  & 0.74359929E-06_JPRB, 0.79093167E-06_JPRB, 0.84173109E-06_JPRB, 0.89268542E-06_JPRB, 0.94107105E-06_JPRB, 0.98531996E-06_JPRB, &
  & 0.10252189E-05_JPRB, 0.10617806E-05_JPRB, 0.10963278E-05_JPRB, 0.11299878E-05_JPRB, 0.11636882E-05_JPRB, 0.11980294E-05_JPRB, &
  & 0.12328707E-05_JPRB, 0.12666377E-05_JPRB, 0.12968026E-05_JPRB, 0.13204165E-05_JPRB, 0.13358492E-05_JPRB, 0.13427800E-05_JPRB, &
  & 0.13423853E-05_JPRB, 0.13360012E-05_JPRB, 0.13255932E-05_JPRB, 0.13127263E-05_JPRB, 0.12999832E-05_JPRB, 0.12889917E-05_JPRB, &
  & 0.12807103E-05_JPRB, 0.12759911E-05_JPRB, 0.12746140E-05_JPRB, 0.12751715E-05_JPRB, 0.12758069E-05_JPRB, 0.12747705E-05_JPRB, &
  & 0.12707746E-05_JPRB, 0.12631657E-05_JPRB, 0.12518116E-05_JPRB, 0.12370306E-05_JPRB, 0.12194087E-05_JPRB, 0.11996295E-05_JPRB, &
  & 0.11784149E-05_JPRB, 0.11563316E-05_JPRB, 0.11338802E-05_JPRB, 0.11116175E-05_JPRB, 0.10901424E-05_JPRB, 0.10700677E-05_JPRB, &
  & 0.10519170E-05_JPRB, 0.10361050E-05_JPRB, 0.10228689E-05_JPRB, 0.10123340E-05_JPRB, 0.10045239E-05_JPRB, 0.99938723E-06_JPRB, &
  & 0.99683325E-06_JPRB, 0.99684280E-06_JPRB, 0.10002352E-05_JPRB, 0.10105339E-05_JPRB /)

RGHG2(:,20, 8) = (/ &
  & 0.85746501E-06_JPRB, 0.83359527E-06_JPRB, 0.81360866E-06_JPRB, 0.79581895E-06_JPRB, 0.77835864E-06_JPRB, 0.76170522E-06_JPRB, &
  & 0.74814676E-06_JPRB, 0.73998433E-06_JPRB, 0.73975264E-06_JPRB, 0.74937020E-06_JPRB, 0.76980137E-06_JPRB, 0.80109226E-06_JPRB, &
  & 0.84198604E-06_JPRB, 0.89006056E-06_JPRB, 0.94198936E-06_JPRB, 0.99412273E-06_JPRB, 0.10434885E-05_JPRB, 0.10885269E-05_JPRB, &
  & 0.11290725E-05_JPRB, 0.11657213E-05_JPRB, 0.11998291E-05_JPRB, 0.12327514E-05_JPRB, 0.12654430E-05_JPRB, 0.12985544E-05_JPRB, &
  & 0.13318927E-05_JPRB, 0.13639589E-05_JPRB, 0.13921061E-05_JPRB, 0.14135180E-05_JPRB, 0.14263758E-05_JPRB, 0.14305075E-05_JPRB, &
  & 0.14267341E-05_JPRB, 0.14163421E-05_JPRB, 0.14013233E-05_JPRB, 0.13836973E-05_JPRB, 0.13660604E-05_JPRB, 0.13511255E-05_JPRB, &
  & 0.13413404E-05_JPRB, 0.13369181E-05_JPRB, 0.13369256E-05_JPRB, 0.13400820E-05_JPRB, 0.13443050E-05_JPRB, 0.13475028E-05_JPRB, &
  & 0.13481167E-05_JPRB, 0.13451876E-05_JPRB, 0.13383335E-05_JPRB, 0.13275893E-05_JPRB, 0.13132965E-05_JPRB, 0.12959589E-05_JPRB, &
  & 0.12762317E-05_JPRB, 0.12547807E-05_JPRB, 0.12323362E-05_JPRB, 0.12096486E-05_JPRB, 0.11874629E-05_JPRB, 0.11665418E-05_JPRB, &
  & 0.11474964E-05_JPRB, 0.11307541E-05_JPRB, 0.11165422E-05_JPRB, 0.11049931E-05_JPRB, 0.10961426E-05_JPRB, 0.10899685E-05_JPRB, &
  & 0.10863706E-05_JPRB, 0.10852809E-05_JPRB, 0.10872542E-05_JPRB, 0.10951298E-05_JPRB /)

RGHG2(:,21, 8) = (/ &
  & 0.94758070E-06_JPRB, 0.92287610E-06_JPRB, 0.90448884E-06_JPRB, 0.88779416E-06_JPRB, 0.87100136E-06_JPRB, 0.85527267E-06_JPRB, &
  & 0.84184023E-06_JPRB, 0.83329576E-06_JPRB, 0.83203867E-06_JPRB, 0.84004563E-06_JPRB, 0.85841532E-06_JPRB, 0.88730013E-06_JPRB, &
  & 0.92555854E-06_JPRB, 0.97083580E-06_JPRB, 0.10199602E-05_JPRB, 0.10695023E-05_JPRB, 0.11165887E-05_JPRB, 0.11595241E-05_JPRB, &
  & 0.11980698E-05_JPRB, 0.12330172E-05_JPRB, 0.12653178E-05_JPRB, 0.12962939E-05_JPRB, 0.13270088E-05_JPRB, 0.13581654E-05_JPRB, &
  & 0.13896581E-05_JPRB, 0.14201763E-05_JPRB, 0.14472985E-05_JPRB, 0.14682669E-05_JPRB, 0.14813351E-05_JPRB, 0.14861913E-05_JPRB, &
  & 0.14832752E-05_JPRB, 0.14737035E-05_JPRB, 0.14591360E-05_JPRB, 0.14417446E-05_JPRB, 0.14240734E-05_JPRB, 0.14090504E-05_JPRB, &
  & 0.13984857E-05_JPRB, 0.13935852E-05_JPRB, 0.13940454E-05_JPRB, 0.13978859E-05_JPRB, 0.14031070E-05_JPRB, 0.14077534E-05_JPRB, &
  & 0.14102296E-05_JPRB, 0.14094654E-05_JPRB, 0.14049734E-05_JPRB, 0.13965821E-05_JPRB, 0.13844368E-05_JPRB, 0.13689737E-05_JPRB, &
  & 0.13508263E-05_JPRB, 0.13306854E-05_JPRB, 0.13092422E-05_JPRB, 0.12872655E-05_JPRB, 0.12656320E-05_JPRB, 0.12451237E-05_JPRB, &
  & 0.12263339E-05_JPRB, 0.12096584E-05_JPRB, 0.11952982E-05_JPRB, 0.11833582E-05_JPRB, 0.11739162E-05_JPRB, 0.11669647E-05_JPRB, &
  & 0.11624832E-05_JPRB, 0.11603777E-05_JPRB, 0.11610369E-05_JPRB, 0.11663770E-05_JPRB /)

RGHG2(:,22, 8) = (/ &
  & 0.10258152E-05_JPRB, 0.10015747E-05_JPRB, 0.98455178E-06_JPRB, 0.96862129E-06_JPRB, 0.95323037E-06_JPRB, 0.93804209E-06_JPRB, &
  & 0.92504433E-06_JPRB, 0.91624599E-06_JPRB, 0.91406935E-06_JPRB, 0.92026346E-06_JPRB, 0.93599209E-06_JPRB, 0.96131953E-06_JPRB, &
  & 0.99525050E-06_JPRB, 0.10357361E-05_JPRB, 0.10799472E-05_JPRB, 0.11248552E-05_JPRB, 0.11679382E-05_JPRB, 0.12077162E-05_JPRB, &
  & 0.12436954E-05_JPRB, 0.12764199E-05_JPRB, 0.13069086E-05_JPRB, 0.13361594E-05_JPRB, 0.13652761E-05_JPRB, 0.13949898E-05_JPRB, &
  & 0.14253709E-05_JPRB, 0.14552388E-05_JPRB, 0.14822940E-05_JPRB, 0.15039271E-05_JPRB, 0.15184136E-05_JPRB, 0.15253216E-05_JPRB, &
  & 0.15250106E-05_JPRB, 0.15184127E-05_JPRB, 0.15068072E-05_JPRB, 0.14923369E-05_JPRB, 0.14773289E-05_JPRB, 0.14641594E-05_JPRB, &
  & 0.14547271E-05_JPRB, 0.14498847E-05_JPRB, 0.14493031E-05_JPRB, 0.14520028E-05_JPRB, 0.14560546E-05_JPRB, 0.14599127E-05_JPRB, &
  & 0.14619434E-05_JPRB, 0.14612697E-05_JPRB, 0.14572936E-05_JPRB, 0.14497227E-05_JPRB, 0.14386686E-05_JPRB, 0.14244840E-05_JPRB, &
  & 0.14076729E-05_JPRB, 0.13888479E-05_JPRB, 0.13687356E-05_JPRB, 0.13481420E-05_JPRB, 0.13278446E-05_JPRB, 0.13085352E-05_JPRB, &
  & 0.12907278E-05_JPRB, 0.12747536E-05_JPRB, 0.12607895E-05_JPRB, 0.12489561E-05_JPRB, 0.12393175E-05_JPRB, 0.12319363E-05_JPRB, &
  & 0.12267870E-05_JPRB, 0.12238216E-05_JPRB, 0.12232540E-05_JPRB, 0.12265061E-05_JPRB /)

RGHG2(:,23, 8) = (/ &
  & 0.10957577E-05_JPRB, 0.10718003E-05_JPRB, 0.10559017E-05_JPRB, 0.10411328E-05_JPRB, 0.10261920E-05_JPRB, 0.10118305E-05_JPRB, &
  & 0.99896749E-06_JPRB, 0.98987857E-06_JPRB, 0.98669034E-06_JPRB, 0.99103374E-06_JPRB, 0.10038997E-05_JPRB, 0.10253306E-05_JPRB, &
  & 0.10544181E-05_JPRB, 0.10894313E-05_JPRB, 0.11280795E-05_JPRB, 0.11678344E-05_JPRB, 0.12065242E-05_JPRB, 0.12427896E-05_JPRB, &
  & 0.12762328E-05_JPRB, 0.13070664E-05_JPRB, 0.13360609E-05_JPRB, 0.13641936E-05_JPRB, 0.13924065E-05_JPRB, 0.14213722E-05_JPRB, &
  & 0.14512389E-05_JPRB, 0.14807135E-05_JPRB, 0.15078192E-05_JPRB, 0.15301506E-05_JPRB, 0.15462724E-05_JPRB, 0.15556675E-05_JPRB, &
  & 0.15585696E-05_JPRB, 0.15557455E-05_JPRB, 0.15483375E-05_JPRB, 0.15381455E-05_JPRB, 0.15268665E-05_JPRB, 0.15168072E-05_JPRB, &
  & 0.15091277E-05_JPRB, 0.15045006E-05_JPRB, 0.15031770E-05_JPRB, 0.15038235E-05_JPRB, 0.15054118E-05_JPRB, 0.15067909E-05_JPRB, &
  & 0.15068869E-05_JPRB, 0.15047542E-05_JPRB, 0.14998487E-05_JPRB, 0.14919572E-05_JPRB, 0.14809955E-05_JPRB, 0.14672745E-05_JPRB, &
  & 0.14513382E-05_JPRB, 0.14337905E-05_JPRB, 0.14152166E-05_JPRB, 0.13962741E-05_JPRB, 0.13776173E-05_JPRB, 0.13598458E-05_JPRB, &
  & 0.13433569E-05_JPRB, 0.13284083E-05_JPRB, 0.13151500E-05_JPRB, 0.13036872E-05_JPRB, 0.12941358E-05_JPRB, 0.12865523E-05_JPRB, &
  & 0.12809912E-05_JPRB, 0.12773637E-05_JPRB, 0.12756853E-05_JPRB, 0.12764078E-05_JPRB /)

RGHG2(:,24, 8) = (/ &
  & 0.11577201E-05_JPRB, 0.11352624E-05_JPRB, 0.11201828E-05_JPRB, 0.11062012E-05_JPRB, 0.10922020E-05_JPRB, 0.10782207E-05_JPRB, &
  & 0.10656229E-05_JPRB, 0.10562778E-05_JPRB, 0.10521400E-05_JPRB, 0.10547700E-05_JPRB, 0.10649904E-05_JPRB, 0.10827690E-05_JPRB, &
  & 0.11073297E-05_JPRB, 0.11372726E-05_JPRB, 0.11707311E-05_JPRB, 0.12057071E-05_JPRB, 0.12404056E-05_JPRB, 0.12735838E-05_JPRB, &
  & 0.13047343E-05_JPRB, 0.13340651E-05_JPRB, 0.13620477E-05_JPRB, 0.13894289E-05_JPRB, 0.14169851E-05_JPRB, 0.14452463E-05_JPRB, &
  & 0.14742237E-05_JPRB, 0.15029957E-05_JPRB, 0.15296235E-05_JPRB, 0.15522459E-05_JPRB, 0.15693978E-05_JPRB, 0.15807865E-05_JPRB, &
  & 0.15867100E-05_JPRB, 0.15877533E-05_JPRB, 0.15849294E-05_JPRB, 0.15794524E-05_JPRB, 0.15727868E-05_JPRB, 0.15661707E-05_JPRB, &
  & 0.15605917E-05_JPRB, 0.15565450E-05_JPRB, 0.15538244E-05_JPRB, 0.15522011E-05_JPRB, 0.15507818E-05_JPRB, 0.15491105E-05_JPRB, &
  & 0.15462665E-05_JPRB, 0.15418773E-05_JPRB, 0.15352533E-05_JPRB, 0.15262181E-05_JPRB, 0.15148230E-05_JPRB, 0.15013356E-05_JPRB, &
  & 0.14861414E-05_JPRB, 0.14696672E-05_JPRB, 0.14524505E-05_JPRB, 0.14350542E-05_JPRB, 0.14180590E-05_JPRB, 0.14018869E-05_JPRB, &
  & 0.13868232E-05_JPRB, 0.13730503E-05_JPRB, 0.13606783E-05_JPRB, 0.13498013E-05_JPRB, 0.13405175E-05_JPRB, 0.13329271E-05_JPRB, &
  & 0.13270894E-05_JPRB, 0.13229601E-05_JPRB, 0.13204595E-05_JPRB, 0.13194253E-05_JPRB /)

RGHG2(:,25, 8) = (/ &
  & 0.12122127E-05_JPRB, 0.11915548E-05_JPRB, 0.11780662E-05_JPRB, 0.11651962E-05_JPRB, 0.11522739E-05_JPRB, 0.11391827E-05_JPRB, &
  & 0.11271637E-05_JPRB, 0.11178540E-05_JPRB, 0.11131433E-05_JPRB, 0.11144663E-05_JPRB, 0.11225453E-05_JPRB, 0.11373515E-05_JPRB, &
  & 0.11582507E-05_JPRB, 0.11840963E-05_JPRB, 0.12134382E-05_JPRB, 0.12446112E-05_JPRB, 0.12761153E-05_JPRB, 0.13068127E-05_JPRB, &
  & 0.13361508E-05_JPRB, 0.13641172E-05_JPRB, 0.13910627E-05_JPRB, 0.14175237E-05_JPRB, 0.14440021E-05_JPRB, 0.14709323E-05_JPRB, &
  & 0.14981658E-05_JPRB, 0.15249251E-05_JPRB, 0.15498756E-05_JPRB, 0.15715052E-05_JPRB, 0.15890810E-05_JPRB, 0.16020415E-05_JPRB, &
  & 0.16104682E-05_JPRB, 0.16148646E-05_JPRB, 0.16160291E-05_JPRB, 0.16148024E-05_JPRB, 0.16120920E-05_JPRB, 0.16086357E-05_JPRB, &
  & 0.16050051E-05_JPRB, 0.16015198E-05_JPRB, 0.15978297E-05_JPRB, 0.15943320E-05_JPRB, 0.15903133E-05_JPRB, 0.15857604E-05_JPRB, &
  & 0.15800908E-05_JPRB, 0.15732013E-05_JPRB, 0.15646903E-05_JPRB, 0.15543656E-05_JPRB, 0.15422024E-05_JPRB, 0.15285523E-05_JPRB, &
  & 0.15138455E-05_JPRB, 0.14984112E-05_JPRB, 0.14825855E-05_JPRB, 0.14668029E-05_JPRB, 0.14514548E-05_JPRB, 0.14368745E-05_JPRB, &
  & 0.14232365E-05_JPRB, 0.14106707E-05_JPRB, 0.13992508E-05_JPRB, 0.13890584E-05_JPRB, 0.13801950E-05_JPRB, 0.13727530E-05_JPRB, &
  & 0.13668138E-05_JPRB, 0.13623192E-05_JPRB, 0.13591393E-05_JPRB, 0.13567631E-05_JPRB /)

RGHG2(:,26, 8) = (/ &
  & 0.12599407E-05_JPRB, 0.12422162E-05_JPRB, 0.12302405E-05_JPRB, 0.12192867E-05_JPRB, 0.12076721E-05_JPRB, 0.11961810E-05_JPRB, &
  & 0.11852228E-05_JPRB, 0.11765799E-05_JPRB, 0.11718930E-05_JPRB, 0.11725309E-05_JPRB, 0.11791938E-05_JPRB, 0.11919475E-05_JPRB, &
  & 0.12102565E-05_JPRB, 0.12332355E-05_JPRB, 0.12596674E-05_JPRB, 0.12881668E-05_JPRB, 0.13173384E-05_JPRB, 0.13461012E-05_JPRB, &
  & 0.13737982E-05_JPRB, 0.14003192E-05_JPRB, 0.14257794E-05_JPRB, 0.14505705E-05_JPRB, 0.14750493E-05_JPRB, 0.14995788E-05_JPRB, &
  & 0.15240038E-05_JPRB, 0.15478466E-05_JPRB, 0.15703423E-05_JPRB, 0.15904458E-05_JPRB, 0.16072615E-05_JPRB, 0.16205917E-05_JPRB, &
  & 0.16305347E-05_JPRB, 0.16373426E-05_JPRB, 0.16414632E-05_JPRB, 0.16434011E-05_JPRB, 0.16436485E-05_JPRB, 0.16425601E-05_JPRB, &
  & 0.16403678E-05_JPRB, 0.16372626E-05_JPRB, 0.16331063E-05_JPRB, 0.16281401E-05_JPRB, 0.16222248E-05_JPRB, 0.16154211E-05_JPRB, &
  & 0.16076358E-05_JPRB, 0.15987466E-05_JPRB, 0.15886319E-05_JPRB, 0.15772455E-05_JPRB, 0.15647303E-05_JPRB, 0.15512854E-05_JPRB, &
  & 0.15371746E-05_JPRB, 0.15226726E-05_JPRB, 0.15080791E-05_JPRB, 0.14937114E-05_JPRB, 0.14798670E-05_JPRB, 0.14667410E-05_JPRB, &
  & 0.14544318E-05_JPRB, 0.14430078E-05_JPRB, 0.14325223E-05_JPRB, 0.14230541E-05_JPRB, 0.14146934E-05_JPRB, 0.14075310E-05_JPRB, &
  & 0.14016399E-05_JPRB, 0.13969679E-05_JPRB, 0.13932967E-05_JPRB, 0.13896616E-05_JPRB /)

RGHG2(:,27, 8) = (/ &
  & 0.13028047E-05_JPRB, 0.12880619E-05_JPRB, 0.12783480E-05_JPRB, 0.12688869E-05_JPRB, 0.12596249E-05_JPRB, 0.12497699E-05_JPRB, &
  & 0.12406078E-05_JPRB, 0.12331999E-05_JPRB, 0.12292186E-05_JPRB, 0.12299038E-05_JPRB, 0.12359799E-05_JPRB, 0.12475592E-05_JPRB, &
  & 0.12643044E-05_JPRB, 0.12854350E-05_JPRB, 0.13099404E-05_JPRB, 0.13365462E-05_JPRB, 0.13639500E-05_JPRB, 0.13909840E-05_JPRB, &
  & 0.14170137E-05_JPRB, 0.14416376E-05_JPRB, 0.14650052E-05_JPRB, 0.14873157E-05_JPRB, 0.15088782E-05_JPRB, 0.15300851E-05_JPRB, &
  & 0.15508075E-05_JPRB, 0.15709199E-05_JPRB, 0.15899220E-05_JPRB, 0.16074380E-05_JPRB, 0.16231522E-05_JPRB, 0.16365206E-05_JPRB, &
  & 0.16473297E-05_JPRB, 0.16556418E-05_JPRB, 0.16616464E-05_JPRB, 0.16655657E-05_JPRB, 0.16676255E-05_JPRB, 0.16679543E-05_JPRB, &
  & 0.16666376E-05_JPRB, 0.16637686E-05_JPRB, 0.16593842E-05_JPRB, 0.16535589E-05_JPRB, 0.16465295E-05_JPRB, 0.16383212E-05_JPRB, &
  & 0.16291565E-05_JPRB, 0.16189557E-05_JPRB, 0.16077801E-05_JPRB, 0.15956365E-05_JPRB, 0.15828338E-05_JPRB, 0.15696739E-05_JPRB, &
  & 0.15563994E-05_JPRB, 0.15430754E-05_JPRB, 0.15298339E-05_JPRB, 0.15169152E-05_JPRB, 0.15045127E-05_JPRB, 0.14927541E-05_JPRB, &
  & 0.14816771E-05_JPRB, 0.14713274E-05_JPRB, 0.14617500E-05_JPRB, 0.14530131E-05_JPRB, 0.14451980E-05_JPRB, 0.14383943E-05_JPRB, &
  & 0.14326708E-05_JPRB, 0.14279602E-05_JPRB, 0.14240104E-05_JPRB, 0.14193904E-05_JPRB /)

RGHG2(:,28, 8) = (/ &
  & 0.13424246E-05_JPRB, 0.13305880E-05_JPRB, 0.13226124E-05_JPRB, 0.13154789E-05_JPRB, 0.13077997E-05_JPRB, 0.13002834E-05_JPRB, &
  & 0.12929629E-05_JPRB, 0.12872827E-05_JPRB, 0.12845389E-05_JPRB, 0.12859058E-05_JPRB, 0.12920598E-05_JPRB, 0.13032165E-05_JPRB, &
  & 0.13190681E-05_JPRB, 0.13390052E-05_JPRB, 0.13620712E-05_JPRB, 0.13871278E-05_JPRB, 0.14128303E-05_JPRB, 0.14381176E-05_JPRB, &
  & 0.14621723E-05_JPRB, 0.14845906E-05_JPRB, 0.15054451E-05_JPRB, 0.15247496E-05_JPRB, 0.15430979E-05_JPRB, 0.15605841E-05_JPRB, &
  & 0.15774134E-05_JPRB, 0.15936622E-05_JPRB, 0.16093099E-05_JPRB, 0.16242141E-05_JPRB, 0.16381662E-05_JPRB, 0.16507356E-05_JPRB, &
  & 0.16616228E-05_JPRB, 0.16705942E-05_JPRB, 0.16775515E-05_JPRB, 0.16824969E-05_JPRB, 0.16854658E-05_JPRB, 0.16864791E-05_JPRB, &
  & 0.16855768E-05_JPRB, 0.16828118E-05_JPRB, 0.16783149E-05_JPRB, 0.16721195E-05_JPRB, 0.16644962E-05_JPRB, 0.16556110E-05_JPRB, &
  & 0.16456819E-05_JPRB, 0.16348374E-05_JPRB, 0.16231750E-05_JPRB, 0.16109251E-05_JPRB, 0.15983736E-05_JPRB, 0.15858487E-05_JPRB, &
  & 0.15734523E-05_JPRB, 0.15612388E-05_JPRB, 0.15492585E-05_JPRB, 0.15376471E-05_JPRB, 0.15265297E-05_JPRB, 0.15159754E-05_JPRB, &
  & 0.15059991E-05_JPRB, 0.14966209E-05_JPRB, 0.14878743E-05_JPRB, 0.14798053E-05_JPRB, 0.14725017E-05_JPRB, 0.14660549E-05_JPRB, &
  & 0.14605453E-05_JPRB, 0.14559014E-05_JPRB, 0.14518256E-05_JPRB, 0.14467983E-05_JPRB /)

RGHG2(:,29, 8) = (/ &
  & 0.13793564E-05_JPRB, 0.13699819E-05_JPRB, 0.13639542E-05_JPRB, 0.13581888E-05_JPRB, 0.13527012E-05_JPRB, 0.13468698E-05_JPRB, &
  & 0.13416116E-05_JPRB, 0.13377215E-05_JPRB, 0.13364840E-05_JPRB, 0.13388930E-05_JPRB, 0.13455757E-05_JPRB, 0.13566942E-05_JPRB, &
  & 0.13720451E-05_JPRB, 0.13910221E-05_JPRB, 0.14127934E-05_JPRB, 0.14362483E-05_JPRB, 0.14601703E-05_JPRB, 0.14834831E-05_JPRB, &
  & 0.15054131E-05_JPRB, 0.15254836E-05_JPRB, 0.15437155E-05_JPRB, 0.15601670E-05_JPRB, 0.15752872E-05_JPRB, 0.15893078E-05_JPRB, &
  & 0.16025122E-05_JPRB, 0.16152761E-05_JPRB, 0.16277439E-05_JPRB, 0.16400583E-05_JPRB, 0.16520961E-05_JPRB, 0.16636020E-05_JPRB, &
  & 0.16740362E-05_JPRB, 0.16830315E-05_JPRB, 0.16902824E-05_JPRB, 0.16955889E-05_JPRB, 0.16988739E-05_JPRB, 0.17001087E-05_JPRB, &
  & 0.16993289E-05_JPRB, 0.16965843E-05_JPRB, 0.16920335E-05_JPRB, 0.16857501E-05_JPRB, 0.16779125E-05_JPRB, 0.16687848E-05_JPRB, &
  & 0.16585838E-05_JPRB, 0.16475417E-05_JPRB, 0.16358676E-05_JPRB, 0.16238777E-05_JPRB, 0.16119170E-05_JPRB, 0.16002215E-05_JPRB, &
  & 0.15888701E-05_JPRB, 0.15777973E-05_JPRB, 0.15670101E-05_JPRB, 0.15565802E-05_JPRB, 0.15466113E-05_JPRB, 0.15371311E-05_JPRB, &
  & 0.15281332E-05_JPRB, 0.15196312E-05_JPRB, 0.15116450E-05_JPRB, 0.15042391E-05_JPRB, 0.14975025E-05_JPRB, 0.14915390E-05_JPRB, &
  & 0.14863954E-05_JPRB, 0.14819836E-05_JPRB, 0.14779646E-05_JPRB, 0.14723217E-05_JPRB /)

RGHG2(:,30, 8) = (/ &
  & 0.14134407E-05_JPRB, 0.14061932E-05_JPRB, 0.14014973E-05_JPRB, 0.13974141E-05_JPRB, 0.13931888E-05_JPRB, 0.13892061E-05_JPRB, &
  & 0.13856327E-05_JPRB, 0.13834909E-05_JPRB, 0.13837678E-05_JPRB, 0.13873282E-05_JPRB, 0.13946607E-05_JPRB, 0.14059239E-05_JPRB, &
  & 0.14208453E-05_JPRB, 0.14389118E-05_JPRB, 0.14593193E-05_JPRB, 0.14810846E-05_JPRB, 0.15030519E-05_JPRB, 0.15243352E-05_JPRB, &
  & 0.15441070E-05_JPRB, 0.15619318E-05_JPRB, 0.15777638E-05_JPRB, 0.15916927E-05_JPRB, 0.16040044E-05_JPRB, 0.16151014E-05_JPRB, &
  & 0.16253645E-05_JPRB, 0.16352091E-05_JPRB, 0.16450340E-05_JPRB, 0.16550503E-05_JPRB, 0.16652778E-05_JPRB, 0.16754365E-05_JPRB, &
  & 0.16851053E-05_JPRB, 0.16937167E-05_JPRB, 0.17007978E-05_JPRB, 0.17060401E-05_JPRB, 0.17092782E-05_JPRB, 0.17104707E-05_JPRB, &
  & 0.17096650E-05_JPRB, 0.17069279E-05_JPRB, 0.17023774E-05_JPRB, 0.16961815E-05_JPRB, 0.16883976E-05_JPRB, 0.16793255E-05_JPRB, &
  & 0.16692190E-05_JPRB, 0.16583681E-05_JPRB, 0.16470883E-05_JPRB, 0.16356867E-05_JPRB, 0.16244950E-05_JPRB, 0.16137191E-05_JPRB, &
  & 0.16033677E-05_JPRB, 0.15933393E-05_JPRB, 0.15836234E-05_JPRB, 0.15742473E-05_JPRB, 0.15652611E-05_JPRB, 0.15566984E-05_JPRB, &
  & 0.15485382E-05_JPRB, 0.15407791E-05_JPRB, 0.15334733E-05_JPRB, 0.15266801E-05_JPRB, 0.15204796E-05_JPRB, 0.15149537E-05_JPRB, &
  & 0.15101353E-05_JPRB, 0.15059223E-05_JPRB, 0.15019048E-05_JPRB, 0.14963368E-05_JPRB /)

RGHG2(:,31, 8) = (/ &
  & 0.14443506E-05_JPRB, 0.14388468E-05_JPRB, 0.14353836E-05_JPRB, 0.14322608E-05_JPRB, 0.14294355E-05_JPRB, 0.14267268E-05_JPRB, &
  & 0.14247106E-05_JPRB, 0.14240961E-05_JPRB, 0.14257554E-05_JPRB, 0.14303721E-05_JPRB, 0.14383340E-05_JPRB, 0.14496620E-05_JPRB, &
  & 0.14641355E-05_JPRB, 0.14812053E-05_JPRB, 0.15001831E-05_JPRB, 0.15201636E-05_JPRB, 0.15402053E-05_JPRB, 0.15594352E-05_JPRB, &
  & 0.15772235E-05_JPRB, 0.15930709E-05_JPRB, 0.16068766E-05_JPRB, 0.16187248E-05_JPRB, 0.16288653E-05_JPRB, 0.16377101E-05_JPRB, &
  & 0.16457154E-05_JPRB, 0.16533503E-05_JPRB, 0.16610443E-05_JPRB, 0.16691407E-05_JPRB, 0.16777275E-05_JPRB, 0.16865866E-05_JPRB, &
  & 0.16952986E-05_JPRB, 0.17032277E-05_JPRB, 0.17098450E-05_JPRB, 0.17147293E-05_JPRB, 0.17177003E-05_JPRB, 0.17187084E-05_JPRB, &
  & 0.17178223E-05_JPRB, 0.17151169E-05_JPRB, 0.17107034E-05_JPRB, 0.17046700E-05_JPRB, 0.16972018E-05_JPRB, 0.16884187E-05_JPRB, &
  & 0.16786794E-05_JPRB, 0.16683123E-05_JPRB, 0.16576244E-05_JPRB, 0.16469716E-05_JPRB, 0.16366515E-05_JPRB, 0.16268125E-05_JPRB, &
  & 0.16173915E-05_JPRB, 0.16082944E-05_JPRB, 0.15994807E-05_JPRB, 0.15909736E-05_JPRB, 0.15827810E-05_JPRB, 0.15749605E-05_JPRB, &
  & 0.15674862E-05_JPRB, 0.15603591E-05_JPRB, 0.15536443E-05_JPRB, 0.15473773E-05_JPRB, 0.15416360E-05_JPRB, 0.15364982E-05_JPRB, &
  & 0.15320065E-05_JPRB, 0.15280618E-05_JPRB, 0.15243005E-05_JPRB, 0.15187472E-05_JPRB /)

RGHG2(:,32, 8) = (/ &
  & 0.14717657E-05_JPRB, 0.14676634E-05_JPRB, 0.14651636E-05_JPRB, 0.14630841E-05_JPRB, 0.14611853E-05_JPRB, 0.14596864E-05_JPRB, &
  & 0.14589336E-05_JPRB, 0.14596289E-05_JPRB, 0.14624729E-05_JPRB, 0.14679761E-05_JPRB, 0.14763649E-05_JPRB, 0.14876503E-05_JPRB, &
  & 0.15015199E-05_JPRB, 0.15175302E-05_JPRB, 0.15350201E-05_JPRB, 0.15532609E-05_JPRB, 0.15714303E-05_JPRB, 0.15888246E-05_JPRB, &
  & 0.16048132E-05_JPRB, 0.16190195E-05_JPRB, 0.16312543E-05_JPRB, 0.16415332E-05_JPRB, 0.16501172E-05_JPRB, 0.16573615E-05_JPRB, &
  & 0.16637689E-05_JPRB, 0.16698107E-05_JPRB, 0.16759556E-05_JPRB, 0.16825429E-05_JPRB, 0.16896903E-05_JPRB, 0.16972896E-05_JPRB, &
  & 0.17049208E-05_JPRB, 0.17119967E-05_JPRB, 0.17179142E-05_JPRB, 0.17222438E-05_JPRB, 0.17248037E-05_JPRB, 0.17255503E-05_JPRB, &
  & 0.17245816E-05_JPRB, 0.17219714E-05_JPRB, 0.17177837E-05_JPRB, 0.17121204E-05_JPRB, 0.17050482E-05_JPRB, 0.16968288E-05_JPRB, &
  & 0.16877042E-05_JPRB, 0.16779918E-05_JPRB, 0.16681056E-05_JPRB, 0.16582846E-05_JPRB, 0.16488257E-05_JPRB, 0.16397861E-05_JPRB, &
  & 0.16311661E-05_JPRB, 0.16228261E-05_JPRB, 0.16147151E-05_JPRB, 0.16068907E-05_JPRB, 0.15993382E-05_JPRB, 0.15920931E-05_JPRB, &
  & 0.15851774E-05_JPRB, 0.15786010E-05_JPRB, 0.15723967E-05_JPRB, 0.15666076E-05_JPRB, 0.15613043E-05_JPRB, 0.15565664E-05_JPRB, &
  & 0.15524311E-05_JPRB, 0.15487864E-05_JPRB, 0.15452116E-05_JPRB, 0.15397968E-05_JPRB /)

RGHG2(:,33, 8) = (/ &
  & 0.14959538E-05_JPRB, 0.14930977E-05_JPRB, 0.14914118E-05_JPRB, 0.14900712E-05_JPRB, 0.14890564E-05_JPRB, 0.14884938E-05_JPRB, &
  & 0.14888082E-05_JPRB, 0.14905950E-05_JPRB, 0.14943741E-05_JPRB, 0.15005089E-05_JPRB, 0.15091427E-05_JPRB, 0.15201600E-05_JPRB, &
  & 0.15333337E-05_JPRB, 0.15481980E-05_JPRB, 0.15642493E-05_JPRB, 0.15808163E-05_JPRB, 0.15973186E-05_JPRB, 0.16130716E-05_JPRB, &
  & 0.16275930E-05_JPRB, 0.16404782E-05_JPRB, 0.16515353E-05_JPRB, 0.16607662E-05_JPRB, 0.16682803E-05_JPRB, 0.16744896E-05_JPRB, &
  & 0.16798397E-05_JPRB, 0.16848062E-05_JPRB, 0.16898218E-05_JPRB, 0.16952290E-05_JPRB, 0.17011904E-05_JPRB, 0.17076138E-05_JPRB, &
  & 0.17141557E-05_JPRB, 0.17202315E-05_JPRB, 0.17252991E-05_JPRB, 0.17289335E-05_JPRB, 0.17309919E-05_JPRB, 0.17314442E-05_JPRB, &
  & 0.17304124E-05_JPRB, 0.17279407E-05_JPRB, 0.17240982E-05_JPRB, 0.17188995E-05_JPRB, 0.17124480E-05_JPRB, 0.17048881E-05_JPRB, &
  & 0.16965641E-05_JPRB, 0.16877661E-05_JPRB, 0.16786576E-05_JPRB, 0.16697383E-05_JPRB, 0.16610131E-05_JPRB, 0.16527001E-05_JPRB, &
  & 0.16446836E-05_JPRB, 0.16369619E-05_JPRB, 0.16293901E-05_JPRB, 0.16220565E-05_JPRB, 0.16149910E-05_JPRB, 0.16082099E-05_JPRB, &
  & 0.16017536E-05_JPRB, 0.15956352E-05_JPRB, 0.15898740E-05_JPRB, 0.15845006E-05_JPRB, 0.15795883E-05_JPRB, 0.15751987E-05_JPRB, &
  & 0.15713640E-05_JPRB, 0.15679520E-05_JPRB, 0.15645822E-05_JPRB, 0.15594339E-05_JPRB /)

RGHG2(:,34, 8) = (/ &
  & 0.15175094E-05_JPRB, 0.15155636E-05_JPRB, 0.15145444E-05_JPRB, 0.15138671E-05_JPRB, 0.15135380E-05_JPRB, 0.15137647E-05_JPRB, &
  & 0.15149461E-05_JPRB, 0.15175635E-05_JPRB, 0.15220334E-05_JPRB, 0.15285716E-05_JPRB, 0.15371927E-05_JPRB, 0.15478269E-05_JPRB, &
  & 0.15601781E-05_JPRB, 0.15739195E-05_JPRB, 0.15885782E-05_JPRB, 0.16036722E-05_JPRB, 0.16186412E-05_JPRB, 0.16330494E-05_JPRB, &
  & 0.16463748E-05_JPRB, 0.16582949E-05_JPRB, 0.16685608E-05_JPRB, 0.16770231E-05_JPRB, 0.16839260E-05_JPRB, 0.16895410E-05_JPRB, &
  & 0.16942786E-05_JPRB, 0.16985587E-05_JPRB, 0.17028053E-05_JPRB, 0.17073208E-05_JPRB, 0.17122625E-05_JPRB, 0.17175963E-05_JPRB, &
  & 0.17230037E-05_JPRB, 0.17280133E-05_JPRB, 0.17321204E-05_JPRB, 0.17349795E-05_JPRB, 0.17364922E-05_JPRB, 0.17366465E-05_JPRB, &
  & 0.17355746E-05_JPRB, 0.17332849E-05_JPRB, 0.17298361E-05_JPRB, 0.17252258E-05_JPRB, 0.17194684E-05_JPRB, 0.17127345E-05_JPRB, &
  & 0.17053111E-05_JPRB, 0.16974763E-05_JPRB, 0.16893230E-05_JPRB, 0.16811049E-05_JPRB, 0.16731223E-05_JPRB, 0.16653670E-05_JPRB, &
  & 0.16578192E-05_JPRB, 0.16505257E-05_JPRB, 0.16433871E-05_JPRB, 0.16363967E-05_JPRB, 0.16297056E-05_JPRB, 0.16232976E-05_JPRB, &
  & 0.16172145E-05_JPRB, 0.16114864E-05_JPRB, 0.16061078E-05_JPRB, 0.16011091E-05_JPRB, 0.15965376E-05_JPRB, 0.15924602E-05_JPRB, &
  & 0.15889020E-05_JPRB, 0.15857485E-05_JPRB, 0.15826161E-05_JPRB, 0.15776887E-05_JPRB /)

RGHG2(:,35, 8) = (/ &
  & 0.15363855E-05_JPRB, 0.15355166E-05_JPRB, 0.15350813E-05_JPRB, 0.15349508E-05_JPRB, 0.15352006E-05_JPRB, 0.15360622E-05_JPRB, &
  & 0.15378944E-05_JPRB, 0.15411251E-05_JPRB, 0.15460340E-05_JPRB, 0.15527215E-05_JPRB, 0.15612055E-05_JPRB, 0.15712944E-05_JPRB, &
  & 0.15828317E-05_JPRB, 0.15954532E-05_JPRB, 0.16088603E-05_JPRB, 0.16225891E-05_JPRB, 0.16362874E-05_JPRB, 0.16495050E-05_JPRB, &
  & 0.16618656E-05_JPRB, 0.16730446E-05_JPRB, 0.16827331E-05_JPRB, 0.16908581E-05_JPRB, 0.16975168E-05_JPRB, 0.17028798E-05_JPRB, &
  & 0.17073195E-05_JPRB, 0.17112077E-05_JPRB, 0.17149107E-05_JPRB, 0.17187184E-05_JPRB, 0.17227778E-05_JPRB, 0.17270632E-05_JPRB, &
  & 0.17313488E-05_JPRB, 0.17352335E-05_JPRB, 0.17383425E-05_JPRB, 0.17404110E-05_JPRB, 0.17413826E-05_JPRB, 0.17412722E-05_JPRB, &
  & 0.17401834E-05_JPRB, 0.17381112E-05_JPRB, 0.17351130E-05_JPRB, 0.17310978E-05_JPRB, 0.17261152E-05_JPRB, 0.17202624E-05_JPRB, &
  & 0.17137895E-05_JPRB, 0.17069559E-05_JPRB, 0.16996746E-05_JPRB, 0.16921805E-05_JPRB, 0.16847902E-05_JPRB, 0.16775195E-05_JPRB, &
  & 0.16703325E-05_JPRB, 0.16633386E-05_JPRB, 0.16565186E-05_JPRB, 0.16497961E-05_JPRB, 0.16433746E-05_JPRB, 0.16372791E-05_JPRB, &
  & 0.16315224E-05_JPRB, 0.16261414E-05_JPRB, 0.16211162E-05_JPRB, 0.16164563E-05_JPRB, 0.16122016E-05_JPRB, 0.16084118E-05_JPRB, &
  & 0.16051094E-05_JPRB, 0.16021704E-05_JPRB, 0.15992247E-05_JPRB, 0.15945585E-05_JPRB /)

RGHG2(:,36, 8) = (/ &
  & 0.15535538E-05_JPRB, 0.15534250E-05_JPRB, 0.15534990E-05_JPRB, 0.15538317E-05_JPRB, 0.15545590E-05_JPRB, 0.15559083E-05_JPRB, &
  & 0.15582236E-05_JPRB, 0.15618416E-05_JPRB, 0.15669624E-05_JPRB, 0.15736525E-05_JPRB, 0.15818097E-05_JPRB, 0.15913371E-05_JPRB, &
  & 0.16020065E-05_JPRB, 0.16136031E-05_JPRB, 0.16258200E-05_JPRB, 0.16383802E-05_JPRB, 0.16509076E-05_JPRB, 0.16631483E-05_JPRB, &
  & 0.16747485E-05_JPRB, 0.16853561E-05_JPRB, 0.16947625E-05_JPRB, 0.17027678E-05_JPRB, 0.17093539E-05_JPRB, 0.17146666E-05_JPRB, &
  & 0.17189504E-05_JPRB, 0.17225748E-05_JPRB, 0.17258562E-05_JPRB, 0.17290465E-05_JPRB, 0.17322898E-05_JPRB, 0.17355869E-05_JPRB, &
  & 0.17387717E-05_JPRB, 0.17415807E-05_JPRB, 0.17437385E-05_JPRB, 0.17450861E-05_JPRB, 0.17455937E-05_JPRB, 0.17452935E-05_JPRB, &
  & 0.17442421E-05_JPRB, 0.17424458E-05_JPRB, 0.17398971E-05_JPRB, 0.17365198E-05_JPRB, 0.17323007E-05_JPRB, 0.17273394E-05_JPRB, &
  & 0.17218279E-05_JPRB, 0.17158281E-05_JPRB, 0.17093729E-05_JPRB, 0.17025928E-05_JPRB, 0.16957409E-05_JPRB, 0.16888566E-05_JPRB, &
  & 0.16819655E-05_JPRB, 0.16752238E-05_JPRB, 0.16686129E-05_JPRB, 0.16621241E-05_JPRB, 0.16559452E-05_JPRB, 0.16501280E-05_JPRB, &
  & 0.16446845E-05_JPRB, 0.16396325E-05_JPRB, 0.16349420E-05_JPRB, 0.16306007E-05_JPRB, 0.16266411E-05_JPRB, 0.16231211E-05_JPRB, &
  & 0.16200543E-05_JPRB, 0.16173245E-05_JPRB, 0.16145677E-05_JPRB, 0.16101438E-05_JPRB /)

RGHG2(:,37, 8) = (/ &
  & 0.15691538E-05_JPRB, 0.15697286E-05_JPRB, 0.15702501E-05_JPRB, 0.15709849E-05_JPRB, 0.15721013E-05_JPRB, 0.15738408E-05_JPRB, &
  & 0.15764901E-05_JPRB, 0.15803182E-05_JPRB, 0.15854852E-05_JPRB, 0.15919804E-05_JPRB, 0.15997504E-05_JPRB, 0.16086117E-05_JPRB, &
  & 0.16184445E-05_JPRB, 0.16290264E-05_JPRB, 0.16401715E-05_JPRB, 0.16516165E-05_JPRB, 0.16631601E-05_JPRB, 0.16744956E-05_JPRB, &
  & 0.16854527E-05_JPRB, 0.16957085E-05_JPRB, 0.17049191E-05_JPRB, 0.17128716E-05_JPRB, 0.17194109E-05_JPRB, 0.17245884E-05_JPRB, &
  & 0.17286742E-05_JPRB, 0.17319571E-05_JPRB, 0.17347830E-05_JPRB, 0.17373859E-05_JPRB, 0.17398916E-05_JPRB, 0.17423195E-05_JPRB, &
  & 0.17445750E-05_JPRB, 0.17464838E-05_JPRB, 0.17478827E-05_JPRB, 0.17486802E-05_JPRB, 0.17488704E-05_JPRB, 0.17484844E-05_JPRB, &
  & 0.17475534E-05_JPRB, 0.17460764E-05_JPRB, 0.17440168E-05_JPRB, 0.17412857E-05_JPRB, 0.17378507E-05_JPRB, 0.17337637E-05_JPRB, &
  & 0.17290891E-05_JPRB, 0.17238739E-05_JPRB, 0.17181910E-05_JPRB, 0.17120999E-05_JPRB, 0.17057367E-05_JPRB, 0.16991926E-05_JPRB, &
  & 0.16925973E-05_JPRB, 0.16860612E-05_JPRB, 0.16796234E-05_JPRB, 0.16733557E-05_JPRB, 0.16674232E-05_JPRB, 0.16618858E-05_JPRB, &
  & 0.16567565E-05_JPRB, 0.16520331E-05_JPRB, 0.16476642E-05_JPRB, 0.16436289E-05_JPRB, 0.16399564E-05_JPRB, 0.16366988E-05_JPRB, &
  & 0.16338622E-05_JPRB, 0.16313254E-05_JPRB, 0.16287526E-05_JPRB, 0.16245802E-05_JPRB /)

RGHG2(:,38, 8) = (/ &
  & 0.15836118E-05_JPRB, 0.15848128E-05_JPRB, 0.15857175E-05_JPRB, 0.15867920E-05_JPRB, 0.15882564E-05_JPRB, 0.15903026E-05_JPRB, &
  & 0.15931753E-05_JPRB, 0.15970838E-05_JPRB, 0.16021222E-05_JPRB, 0.16083133E-05_JPRB, 0.16155627E-05_JPRB, 0.16237379E-05_JPRB, &
  & 0.16326966E-05_JPRB, 0.16423064E-05_JPRB, 0.16524108E-05_JPRB, 0.16628521E-05_JPRB, 0.16734490E-05_JPRB, 0.16840397E-05_JPRB, &
  & 0.16943859E-05_JPRB, 0.17042296E-05_JPRB, 0.17132390E-05_JPRB, 0.17209823E-05_JPRB, 0.17272578E-05_JPRB, 0.17321081E-05_JPRB, &
  & 0.17357513E-05_JPRB, 0.17385939E-05_JPRB, 0.17409398E-05_JPRB, 0.17430169E-05_JPRB, 0.17449420E-05_JPRB, 0.17467357E-05_JPRB, &
  & 0.17483426E-05_JPRB, 0.17496541E-05_JPRB, 0.17505625E-05_JPRB, 0.17510222E-05_JPRB, 0.17510386E-05_JPRB, 0.17506457E-05_JPRB, &
  & 0.17498626E-05_JPRB, 0.17486943E-05_JPRB, 0.17470936E-05_JPRB, 0.17449888E-05_JPRB, 0.17423134E-05_JPRB, 0.17390752E-05_JPRB, &
  & 0.17352086E-05_JPRB, 0.17308141E-05_JPRB, 0.17258811E-05_JPRB, 0.17204374E-05_JPRB, 0.17145658E-05_JPRB, 0.17084079E-05_JPRB, &
  & 0.17020982E-05_JPRB, 0.16957773E-05_JPRB, 0.16895291E-05_JPRB, 0.16835038E-05_JPRB, 0.16778395E-05_JPRB, 0.16726005E-05_JPRB, &
  & 0.16677992E-05_JPRB, 0.16634053E-05_JPRB, 0.16593578E-05_JPRB, 0.16556255E-05_JPRB, 0.16522361E-05_JPRB, 0.16492402E-05_JPRB, &
  & 0.16466328E-05_JPRB, 0.16442938E-05_JPRB, 0.16418976E-05_JPRB, 0.16379897E-05_JPRB /)

RGHG2(:,39, 8) = (/ &
  & 0.15972362E-05_JPRB, 0.15989581E-05_JPRB, 0.16001734E-05_JPRB, 0.16015611E-05_JPRB, 0.16033007E-05_JPRB, 0.16056076E-05_JPRB, &
  & 0.16086307E-05_JPRB, 0.16124901E-05_JPRB, 0.16172950E-05_JPRB, 0.16230586E-05_JPRB, 0.16297124E-05_JPRB, 0.16371469E-05_JPRB, &
  & 0.16452375E-05_JPRB, 0.16538797E-05_JPRB, 0.16629864E-05_JPRB, 0.16724471E-05_JPRB, 0.16821575E-05_JPRB, 0.16919898E-05_JPRB, &
  & 0.17017463E-05_JPRB, 0.17111548E-05_JPRB, 0.17197294E-05_JPRB, 0.17270750E-05_JPRB, 0.17328653E-05_JPRB, 0.17371814E-05_JPRB, &
  & 0.17403590E-05_JPRB, 0.17427612E-05_JPRB, 0.17447135E-05_JPRB, 0.17464056E-05_JPRB, 0.17479360E-05_JPRB, 0.17493254E-05_JPRB, &
  & 0.17505420E-05_JPRB, 0.17515024E-05_JPRB, 0.17521352E-05_JPRB, 0.17524089E-05_JPRB, 0.17523400E-05_JPRB, 0.17519576E-05_JPRB, &
  & 0.17512878E-05_JPRB, 0.17503370E-05_JPRB, 0.17490836E-05_JPRB, 0.17474608E-05_JPRB, 0.17454311E-05_JPRB, 0.17429331E-05_JPRB, &
  & 0.17398902E-05_JPRB, 0.17363461E-05_JPRB, 0.17321993E-05_JPRB, 0.17274542E-05_JPRB, 0.17221614E-05_JPRB, 0.17164291E-05_JPRB, &
  & 0.17104525E-05_JPRB, 0.17043665E-05_JPRB, 0.16983563E-05_JPRB, 0.16925990E-05_JPRB, 0.16872302E-05_JPRB, 0.16823172E-05_JPRB, &
  & 0.16778566E-05_JPRB, 0.16737995E-05_JPRB, 0.16700697E-05_JPRB, 0.16666378E-05_JPRB, 0.16635295E-05_JPRB, 0.16607939E-05_JPRB, &
  & 0.16584165E-05_JPRB, 0.16562758E-05_JPRB, 0.16540691E-05_JPRB, 0.16504509E-05_JPRB /)

RGHG2(:,40, 8) = (/ &
  & 0.16103235E-05_JPRB, 0.16124094E-05_JPRB, 0.16138637E-05_JPRB, 0.16154428E-05_JPRB, 0.16174488E-05_JPRB, 0.16199583E-05_JPRB, &
  & 0.16230401E-05_JPRB, 0.16268020E-05_JPRB, 0.16312719E-05_JPRB, 0.16365236E-05_JPRB, 0.16425355E-05_JPRB, 0.16491999E-05_JPRB, &
  & 0.16564238E-05_JPRB, 0.16641286E-05_JPRB, 0.16722616E-05_JPRB, 0.16807717E-05_JPRB, 0.16896041E-05_JPRB, 0.16986581E-05_JPRB, &
  & 0.17077882E-05_JPRB, 0.17166085E-05_JPRB, 0.17246987E-05_JPRB, 0.17314636E-05_JPRB, 0.17367043E-05_JPRB, 0.17405293E-05_JPRB, &
  & 0.17432853E-05_JPRB, 0.17453582E-05_JPRB, 0.17470234E-05_JPRB, 0.17484502E-05_JPRB, 0.17497221E-05_JPRB, 0.17508623E-05_JPRB, &
  & 0.17518431E-05_JPRB, 0.17526053E-05_JPRB, 0.17530832E-05_JPRB, 0.17532570E-05_JPRB, 0.17531424E-05_JPRB, 0.17527714E-05_JPRB, &
  & 0.17521704E-05_JPRB, 0.17513551E-05_JPRB, 0.17503191E-05_JPRB, 0.17490214E-05_JPRB, 0.17474406E-05_JPRB, 0.17455178E-05_JPRB, &
  & 0.17431743E-05_JPRB, 0.17404158E-05_JPRB, 0.17370769E-05_JPRB, 0.17330958E-05_JPRB, 0.17284555E-05_JPRB, 0.17232423E-05_JPRB, &
  & 0.17176387E-05_JPRB, 0.17118584E-05_JPRB, 0.17061336E-05_JPRB, 0.17006780E-05_JPRB, 0.16956368E-05_JPRB, 0.16910690E-05_JPRB, &
  & 0.16869615E-05_JPRB, 0.16832398E-05_JPRB, 0.16798309E-05_JPRB, 0.16766934E-05_JPRB, 0.16738674E-05_JPRB, 0.16713898E-05_JPRB, &
  & 0.16692421E-05_JPRB, 0.16672991E-05_JPRB, 0.16652851E-05_JPRB, 0.16619629E-05_JPRB /)

RGHG2(:,41, 8) = (/ &
  & 0.16231620E-05_JPRB, 0.16254478E-05_JPRB, 0.16269352E-05_JPRB, 0.16286637E-05_JPRB, 0.16308203E-05_JPRB, 0.16334707E-05_JPRB, &
  & 0.16366070E-05_JPRB, 0.16401577E-05_JPRB, 0.16442596E-05_JPRB, 0.16489696E-05_JPRB, 0.16543004E-05_JPRB, 0.16602014E-05_JPRB, &
  & 0.16665814E-05_JPRB, 0.16733790E-05_JPRB, 0.16805711E-05_JPRB, 0.16881493E-05_JPRB, 0.16960932E-05_JPRB, 0.17043701E-05_JPRB, &
  & 0.17127799E-05_JPRB, 0.17210305E-05_JPRB, 0.17284993E-05_JPRB, 0.17347278E-05_JPRB, 0.17394423E-05_JPRB, 0.17428347E-05_JPRB, &
  & 0.17452662E-05_JPRB, 0.17470838E-05_JPRB, 0.17485411E-05_JPRB, 0.17497806E-05_JPRB, 0.17508762E-05_JPRB, 0.17518493E-05_JPRB, &
  & 0.17526864E-05_JPRB, 0.17533263E-05_JPRB, 0.17537176E-05_JPRB, 0.17538337E-05_JPRB, 0.17536954E-05_JPRB, 0.17533330E-05_JPRB, &
  & 0.17527759E-05_JPRB, 0.17520434E-05_JPRB, 0.17511436E-05_JPRB, 0.17500538E-05_JPRB, 0.17487689E-05_JPRB, 0.17472483E-05_JPRB, &
  & 0.17454308E-05_JPRB, 0.17433076E-05_JPRB, 0.17406852E-05_JPRB, 0.17374616E-05_JPRB, 0.17335303E-05_JPRB, 0.17288846E-05_JPRB, &
  & 0.17237560E-05_JPRB, 0.17183290E-05_JPRB, 0.17129365E-05_JPRB, 0.17078073E-05_JPRB, 0.17031045E-05_JPRB, 0.16988943E-05_JPRB, &
  & 0.16951384E-05_JPRB, 0.16917626E-05_JPRB, 0.16886703E-05_JPRB, 0.16858346E-05_JPRB, 0.16832842E-05_JPRB, 0.16810606E-05_JPRB, &
  & 0.16791334E-05_JPRB, 0.16773821E-05_JPRB, 0.16755504E-05_JPRB, 0.16725257E-05_JPRB /)

RGHG2(:,42, 8) = (/ &
  & 0.16365316E-05_JPRB, 0.16382841E-05_JPRB, 0.16396245E-05_JPRB, 0.16413004E-05_JPRB, 0.16435658E-05_JPRB, 0.16463474E-05_JPRB, &
  & 0.16494001E-05_JPRB, 0.16527697E-05_JPRB, 0.16564570E-05_JPRB, 0.16606132E-05_JPRB, 0.16652831E-05_JPRB, 0.16704380E-05_JPRB, &
  & 0.16760085E-05_JPRB, 0.16819452E-05_JPRB, 0.16882375E-05_JPRB, 0.16948979E-05_JPRB, 0.17019636E-05_JPRB, 0.17094019E-05_JPRB, &
  & 0.17171174E-05_JPRB, 0.17246934E-05_JPRB, 0.17316174E-05_JPRB, 0.17372834E-05_JPRB, 0.17415334E-05_JPRB, 0.17445575E-05_JPRB, &
  & 0.17467153E-05_JPRB, 0.17483326E-05_JPRB, 0.17496261E-05_JPRB, 0.17507236E-05_JPRB, 0.17516891E-05_JPRB, 0.17525484E-05_JPRB, &
  & 0.17532851E-05_JPRB, 0.17538529E-05_JPRB, 0.17541895E-05_JPRB, 0.17542732E-05_JPRB, 0.17541224E-05_JPRB, 0.17537684E-05_JPRB, &
  & 0.17532409E-05_JPRB, 0.17525635E-05_JPRB, 0.17517522E-05_JPRB, 0.17507987E-05_JPRB, 0.17497106E-05_JPRB, 0.17484700E-05_JPRB, &
  & 0.17470262E-05_JPRB, 0.17453760E-05_JPRB, 0.17433460E-05_JPRB, 0.17407913E-05_JPRB, 0.17375451E-05_JPRB, 0.17335424E-05_JPRB, &
  & 0.17289099E-05_JPRB, 0.17238931E-05_JPRB, 0.17188577E-05_JPRB, 0.17140688E-05_JPRB, 0.17097161E-05_JPRB, 0.17058589E-05_JPRB, &
  & 0.17024668E-05_JPRB, 0.16994339E-05_JPRB, 0.16966706E-05_JPRB, 0.16941323E-05_JPRB, 0.16918549E-05_JPRB, 0.16898719E-05_JPRB, &
  & 0.16881511E-05_JPRB, 0.16865762E-05_JPRB, 0.16849153E-05_JPRB, 0.16821583E-05_JPRB /)

RGHG2(:,43, 8) = (/ &
  & 0.16481633E-05_JPRB, 0.16502920E-05_JPRB, 0.16517212E-05_JPRB, 0.16534735E-05_JPRB, 0.16558481E-05_JPRB, 0.16586566E-05_JPRB, &
  & 0.16616912E-05_JPRB, 0.16647875E-05_JPRB, 0.16680884E-05_JPRB, 0.16717133E-05_JPRB, 0.16757504E-05_JPRB, 0.16801955E-05_JPRB, &
  & 0.16850011E-05_JPRB, 0.16901224E-05_JPRB, 0.16955503E-05_JPRB, 0.17013281E-05_JPRB, 0.17074916E-05_JPRB, 0.17141012E-05_JPRB, &
  & 0.17210215E-05_JPRB, 0.17279669E-05_JPRB, 0.17342759E-05_JPRB, 0.17394290E-05_JPRB, 0.17432330E-05_JPRB, 0.17459236E-05_JPRB, &
  & 0.17478476E-05_JPRB, 0.17492930E-05_JPRB, 0.17504533E-05_JPRB, 0.17514373E-05_JPRB, 0.17523047E-05_JPRB, 0.17530788E-05_JPRB, &
  & 0.17537500E-05_JPRB, 0.17542677E-05_JPRB, 0.17545744E-05_JPRB, 0.17546405E-05_JPRB, 0.17544851E-05_JPRB, 0.17541395E-05_JPRB, &
  & 0.17536338E-05_JPRB, 0.17529934E-05_JPRB, 0.17522423E-05_JPRB, 0.17513815E-05_JPRB, 0.17504291E-05_JPRB, 0.17493845E-05_JPRB, &
  & 0.17482147E-05_JPRB, 0.17469135E-05_JPRB, 0.17453467E-05_JPRB, 0.17433497E-05_JPRB, 0.17407485E-05_JPRB, 0.17373596E-05_JPRB, &
  & 0.17332693E-05_JPRB, 0.17286889E-05_JPRB, 0.17240278E-05_JPRB, 0.17195766E-05_JPRB, 0.17155646E-05_JPRB, 0.17120710E-05_JPRB, &
  & 0.17090385E-05_JPRB, 0.17063637E-05_JPRB, 0.17039299E-05_JPRB, 0.17016926E-05_JPRB, 0.16996764E-05_JPRB, 0.16979174E-05_JPRB, &
  & 0.16963836E-05_JPRB, 0.16949658E-05_JPRB, 0.16934554E-05_JPRB, 0.16909356E-05_JPRB /)

RGHG2(:,44, 8) = (/ &
  & 0.16593692E-05_JPRB, 0.16621983E-05_JPRB, 0.16637626E-05_JPRB, 0.16655574E-05_JPRB, 0.16679320E-05_JPRB, 0.16707818E-05_JPRB, &
  & 0.16736550E-05_JPRB, 0.16765023E-05_JPRB, 0.16794145E-05_JPRB, 0.16825389E-05_JPRB, 0.16859781E-05_JPRB, 0.16897577E-05_JPRB, &
  & 0.16938353E-05_JPRB, 0.16981739E-05_JPRB, 0.17027860E-05_JPRB, 0.17076843E-05_JPRB, 0.17129768E-05_JPRB, 0.17186765E-05_JPRB, &
  & 0.17248149E-05_JPRB, 0.17310015E-05_JPRB, 0.17367062E-05_JPRB, 0.17413018E-05_JPRB, 0.17446746E-05_JPRB, 0.17470554E-05_JPRB, &
  & 0.17487653E-05_JPRB, 0.17500620E-05_JPRB, 0.17511081E-05_JPRB, 0.17519994E-05_JPRB, 0.17527900E-05_JPRB, 0.17535031E-05_JPRB, &
  & 0.17541278E-05_JPRB, 0.17546168E-05_JPRB, 0.17549067E-05_JPRB, 0.17549662E-05_JPRB, 0.17548118E-05_JPRB, 0.17544752E-05_JPRB, &
  & 0.17539859E-05_JPRB, 0.17533723E-05_JPRB, 0.17526604E-05_JPRB, 0.17518665E-05_JPRB, 0.17510084E-05_JPRB, 0.17501100E-05_JPRB, &
  & 0.17491412E-05_JPRB, 0.17481070E-05_JPRB, 0.17469007E-05_JPRB, 0.17453690E-05_JPRB, 0.17433305E-05_JPRB, 0.17405550E-05_JPRB, &
  & 0.17370212E-05_JPRB, 0.17328939E-05_JPRB, 0.17285969E-05_JPRB, 0.17244778E-05_JPRB, 0.17208108E-05_JPRB, 0.17176727E-05_JPRB, &
  & 0.17150136E-05_JPRB, 0.17126960E-05_JPRB, 0.17105972E-05_JPRB, 0.17086525E-05_JPRB, 0.17068833E-05_JPRB, 0.17053258E-05_JPRB, &
  & 0.17039567E-05_JPRB, 0.17026787E-05_JPRB, 0.17013002E-05_JPRB, 0.16989887E-05_JPRB /)

RGHG2(:,45, 8) = (/ &
  & 0.16739032E-05_JPRB, 0.16753647E-05_JPRB, 0.16764894E-05_JPRB, 0.16780012E-05_JPRB, 0.16802860E-05_JPRB, 0.16829794E-05_JPRB, &
  & 0.16856557E-05_JPRB, 0.16882144E-05_JPRB, 0.16907236E-05_JPRB, 0.16933707E-05_JPRB, 0.16962425E-05_JPRB, 0.16993752E-05_JPRB, &
  & 0.17027469E-05_JPRB, 0.17063376E-05_JPRB, 0.17101283E-05_JPRB, 0.17141986E-05_JPRB, 0.17185678E-05_JPRB, 0.17234056E-05_JPRB, &
  & 0.17286030E-05_JPRB, 0.17340278E-05_JPRB, 0.17389768E-05_JPRB, 0.17429929E-05_JPRB, 0.17459241E-05_JPRB, 0.17480040E-05_JPRB, &
  & 0.17495207E-05_JPRB, 0.17506843E-05_JPRB, 0.17516331E-05_JPRB, 0.17524500E-05_JPRB, 0.17531811E-05_JPRB, 0.17538500E-05_JPRB, &
  & 0.17544451E-05_JPRB, 0.17549178E-05_JPRB, 0.17552038E-05_JPRB, 0.17552655E-05_JPRB, 0.17551165E-05_JPRB, 0.17547897E-05_JPRB, &
  & 0.17543123E-05_JPRB, 0.17537162E-05_JPRB, 0.17530328E-05_JPRB, 0.17522821E-05_JPRB, 0.17514976E-05_JPRB, 0.17507023E-05_JPRB, &
  & 0.17498944E-05_JPRB, 0.17490582E-05_JPRB, 0.17481359E-05_JPRB, 0.17469793E-05_JPRB, 0.17454317E-05_JPRB, 0.17432453E-05_JPRB, &
  & 0.17402776E-05_JPRB, 0.17366490E-05_JPRB, 0.17327246E-05_JPRB, 0.17289445E-05_JPRB, 0.17256194E-05_JPRB, 0.17228505E-05_JPRB, &
  & 0.17205666E-05_JPRB, 0.17186046E-05_JPRB, 0.17168289E-05_JPRB, 0.17151619E-05_JPRB, 0.17136158E-05_JPRB, 0.17122358E-05_JPRB, &
  & 0.17110084E-05_JPRB, 0.17098514E-05_JPRB, 0.17085939E-05_JPRB, 0.17064704E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART15',1,ZHOOK_HANDLE)
END SUBROUTINE PART15




SUBROUTINE PART16
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART16',0,ZHOOK_HANDLE)



RGHG2(:,46, 8) = (/ &
  & 0.16838937E-05_JPRB, 0.16870285E-05_JPRB, 0.16887960E-05_JPRB, 0.16906836E-05_JPRB, 0.16930055E-05_JPRB, 0.16956109E-05_JPRB, &
  & 0.16980651E-05_JPRB, 0.17002515E-05_JPRB, 0.17023647E-05_JPRB, 0.17045040E-05_JPRB, 0.17068014E-05_JPRB, 0.17092868E-05_JPRB, &
  & 0.17119538E-05_JPRB, 0.17147715E-05_JPRB, 0.17177771E-05_JPRB, 0.17209650E-05_JPRB, 0.17244822E-05_JPRB, 0.17283248E-05_JPRB, &
  & 0.17326422E-05_JPRB, 0.17370503E-05_JPRB, 0.17412020E-05_JPRB, 0.17445400E-05_JPRB, 0.17470162E-05_JPRB, 0.17488085E-05_JPRB, &
  & 0.17501424E-05_JPRB, 0.17511882E-05_JPRB, 0.17520551E-05_JPRB, 0.17528105E-05_JPRB, 0.17534983E-05_JPRB, 0.17541367E-05_JPRB, &
  & 0.17547145E-05_JPRB, 0.17551835E-05_JPRB, 0.17554734E-05_JPRB, 0.17555442E-05_JPRB, 0.17554058E-05_JPRB, 0.17550879E-05_JPRB, &
  & 0.17546208E-05_JPRB, 0.17540361E-05_JPRB, 0.17533672E-05_JPRB, 0.17526531E-05_JPRB, 0.17519159E-05_JPRB, 0.17512066E-05_JPRB, &
  & 0.17505126E-05_JPRB, 0.17498378E-05_JPRB, 0.17491260E-05_JPRB, 0.17482721E-05_JPRB, 0.17471344E-05_JPRB, 0.17454838E-05_JPRB, &
  & 0.17431353E-05_JPRB, 0.17400529E-05_JPRB, 0.17365708E-05_JPRB, 0.17331541E-05_JPRB, 0.17301869E-05_JPRB, 0.17277970E-05_JPRB, &
  & 0.17258690E-05_JPRB, 0.17242470E-05_JPRB, 0.17227660E-05_JPRB, 0.17213488E-05_JPRB, 0.17200017E-05_JPRB, 0.17187699E-05_JPRB, &
  & 0.17176640E-05_JPRB, 0.17166150E-05_JPRB, 0.17154645E-05_JPRB, 0.17135224E-05_JPRB /)

RGHG2(:,47, 8) = (/ &
  & 0.16975306E-05_JPRB, 0.17001657E-05_JPRB, 0.17019800E-05_JPRB, 0.17039847E-05_JPRB, 0.17064652E-05_JPRB, 0.17090173E-05_JPRB, &
  & 0.17111574E-05_JPRB, 0.17129919E-05_JPRB, 0.17146081E-05_JPRB, 0.17162110E-05_JPRB, 0.17178827E-05_JPRB, 0.17196799E-05_JPRB, &
  & 0.17215970E-05_JPRB, 0.17236390E-05_JPRB, 0.17257962E-05_JPRB, 0.17281543E-05_JPRB, 0.17307195E-05_JPRB, 0.17336462E-05_JPRB, &
  & 0.17368236E-05_JPRB, 0.17402165E-05_JPRB, 0.17433474E-05_JPRB, 0.17459786E-05_JPRB, 0.17479815E-05_JPRB, 0.17494876E-05_JPRB, &
  & 0.17506543E-05_JPRB, 0.17515949E-05_JPRB, 0.17523910E-05_JPRB, 0.17530995E-05_JPRB, 0.17537545E-05_JPRB, 0.17543745E-05_JPRB, &
  & 0.17549465E-05_JPRB, 0.17554191E-05_JPRB, 0.17557214E-05_JPRB, 0.17558076E-05_JPRB, 0.17556823E-05_JPRB, 0.17553751E-05_JPRB, &
  & 0.17549145E-05_JPRB, 0.17543348E-05_JPRB, 0.17536795E-05_JPRB, 0.17529819E-05_JPRB, 0.17522902E-05_JPRB, 0.17516340E-05_JPRB, &
  & 0.17510372E-05_JPRB, 0.17504773E-05_JPRB, 0.17499309E-05_JPRB, 0.17493098E-05_JPRB, 0.17485008E-05_JPRB, 0.17473373E-05_JPRB, &
  & 0.17455895E-05_JPRB, 0.17431928E-05_JPRB, 0.17402566E-05_JPRB, 0.17373047E-05_JPRB, 0.17347323E-05_JPRB, 0.17326968E-05_JPRB, &
  & 0.17311154E-05_JPRB, 0.17297805E-05_JPRB, 0.17285586E-05_JPRB, 0.17273539E-05_JPRB, 0.17261663E-05_JPRB, 0.17250577E-05_JPRB, &
  & 0.17240466E-05_JPRB, 0.17230848E-05_JPRB, 0.17220289E-05_JPRB, 0.17202466E-05_JPRB /)

RGHG2(:,48, 8) = (/ &
  & 0.17086578E-05_JPRB, 0.17122555E-05_JPRB, 0.17146588E-05_JPRB, 0.17171901E-05_JPRB, 0.17200703E-05_JPRB, 0.17227255E-05_JPRB, &
  & 0.17247827E-05_JPRB, 0.17262503E-05_JPRB, 0.17274297E-05_JPRB, 0.17284810E-05_JPRB, 0.17295113E-05_JPRB, 0.17305883E-05_JPRB, &
  & 0.17317318E-05_JPRB, 0.17329510E-05_JPRB, 0.17342761E-05_JPRB, 0.17357197E-05_JPRB, 0.17373533E-05_JPRB, 0.17391683E-05_JPRB, &
  & 0.17412067E-05_JPRB, 0.17433310E-05_JPRB, 0.17454469E-05_JPRB, 0.17473068E-05_JPRB, 0.17488378E-05_JPRB, 0.17500697E-05_JPRB, &
  & 0.17510766E-05_JPRB, 0.17519221E-05_JPRB, 0.17526588E-05_JPRB, 0.17533284E-05_JPRB, 0.17539621E-05_JPRB, 0.17545731E-05_JPRB, &
  & 0.17551465E-05_JPRB, 0.17556313E-05_JPRB, 0.17559516E-05_JPRB, 0.17560574E-05_JPRB, 0.17559491E-05_JPRB, 0.17556517E-05_JPRB, &
  & 0.17551961E-05_JPRB, 0.17546208E-05_JPRB, 0.17539674E-05_JPRB, 0.17532899E-05_JPRB, 0.17526198E-05_JPRB, 0.17520135E-05_JPRB, &
  & 0.17514773E-05_JPRB, 0.17510162E-05_JPRB, 0.17505901E-05_JPRB, 0.17501494E-05_JPRB, 0.17496043E-05_JPRB, 0.17488337E-05_JPRB, &
  & 0.17476799E-05_JPRB, 0.17459889E-05_JPRB, 0.17438413E-05_JPRB, 0.17414914E-05_JPRB, 0.17394024E-05_JPRB, 0.17377565E-05_JPRB, &
  & 0.17364631E-05_JPRB, 0.17353749E-05_JPRB, 0.17343507E-05_JPRB, 0.17333089E-05_JPRB, 0.17322416E-05_JPRB, 0.17312129E-05_JPRB, &
  & 0.17302673E-05_JPRB, 0.17293637E-05_JPRB, 0.17283767E-05_JPRB, 0.17267123E-05_JPRB /)

RGHG2(:,49, 8) = (/ &
  & 0.17194390E-05_JPRB, 0.17235137E-05_JPRB, 0.17262232E-05_JPRB, 0.17290740E-05_JPRB, 0.17322819E-05_JPRB, 0.17352198E-05_JPRB, &
  & 0.17372491E-05_JPRB, 0.17385893E-05_JPRB, 0.17395130E-05_JPRB, 0.17401871E-05_JPRB, 0.17407517E-05_JPRB, 0.17412467E-05_JPRB, &
  & 0.17417198E-05_JPRB, 0.17421926E-05_JPRB, 0.17426969E-05_JPRB, 0.17432584E-05_JPRB, 0.17438764E-05_JPRB, 0.17445716E-05_JPRB, &
  & 0.17453690E-05_JPRB, 0.17463195E-05_JPRB, 0.17474053E-05_JPRB, 0.17485401E-05_JPRB, 0.17496076E-05_JPRB, 0.17505718E-05_JPRB, &
  & 0.17514291E-05_JPRB, 0.17521884E-05_JPRB, 0.17528730E-05_JPRB, 0.17535126E-05_JPRB, 0.17541313E-05_JPRB, 0.17547401E-05_JPRB, &
  & 0.17553228E-05_JPRB, 0.17558245E-05_JPRB, 0.17561678E-05_JPRB, 0.17562960E-05_JPRB, 0.17562074E-05_JPRB, 0.17559202E-05_JPRB, &
  & 0.17554694E-05_JPRB, 0.17548942E-05_JPRB, 0.17542461E-05_JPRB, 0.17535748E-05_JPRB, 0.17529275E-05_JPRB, 0.17523478E-05_JPRB, &
  & 0.17518660E-05_JPRB, 0.17514701E-05_JPRB, 0.17511441E-05_JPRB, 0.17508373E-05_JPRB, 0.17504963E-05_JPRB, 0.17500406E-05_JPRB, &
  & 0.17493649E-05_JPRB, 0.17483790E-05_JPRB, 0.17470421E-05_JPRB, 0.17455413E-05_JPRB, 0.17440932E-05_JPRB, 0.17428931E-05_JPRB, &
  & 0.17419038E-05_JPRB, 0.17410403E-05_JPRB, 0.17401812E-05_JPRB, 0.17392643E-05_JPRB, 0.17382833E-05_JPRB, 0.17373033E-05_JPRB, &
  & 0.17363872E-05_JPRB, 0.17355148E-05_JPRB, 0.17345587E-05_JPRB, 0.17329572E-05_JPRB /)

RGHG2(:,50, 8) = (/ &
  & 0.17300385E-05_JPRB, 0.17335748E-05_JPRB, 0.17359815E-05_JPRB, 0.17386683E-05_JPRB, 0.17417686E-05_JPRB, 0.17446106E-05_JPRB, &
  & 0.17465325E-05_JPRB, 0.17477573E-05_JPRB, 0.17485066E-05_JPRB, 0.17490351E-05_JPRB, 0.17493783E-05_JPRB, 0.17495944E-05_JPRB, &
  & 0.17496827E-05_JPRB, 0.17496689E-05_JPRB, 0.17495796E-05_JPRB, 0.17494299E-05_JPRB, 0.17492503E-05_JPRB, 0.17490643E-05_JPRB, &
  & 0.17489349E-05_JPRB, 0.17489538E-05_JPRB, 0.17492049E-05_JPRB, 0.17496817E-05_JPRB, 0.17503113E-05_JPRB, 0.17510158E-05_JPRB, &
  & 0.17517291E-05_JPRB, 0.17524088E-05_JPRB, 0.17530485E-05_JPRB, 0.17536634E-05_JPRB, 0.17542727E-05_JPRB, 0.17548846E-05_JPRB, &
  & 0.17554806E-05_JPRB, 0.17560044E-05_JPRB, 0.17563723E-05_JPRB, 0.17565271E-05_JPRB, 0.17564586E-05_JPRB, 0.17561812E-05_JPRB, &
  & 0.17557361E-05_JPRB, 0.17551623E-05_JPRB, 0.17545160E-05_JPRB, 0.17538498E-05_JPRB, 0.17532147E-05_JPRB, 0.17526568E-05_JPRB, &
  & 0.17522045E-05_JPRB, 0.17518695E-05_JPRB, 0.17516156E-05_JPRB, 0.17514151E-05_JPRB, 0.17512280E-05_JPRB, 0.17510072E-05_JPRB, &
  & 0.17506931E-05_JPRB, 0.17502258E-05_JPRB, 0.17496025E-05_JPRB, 0.17488488E-05_JPRB, 0.17480982E-05_JPRB, 0.17474101E-05_JPRB, &
  & 0.17468046E-05_JPRB, 0.17462100E-05_JPRB, 0.17455916E-05_JPRB, 0.17448717E-05_JPRB, 0.17440332E-05_JPRB, 0.17431519E-05_JPRB, &
  & 0.17422993E-05_JPRB, 0.17414593E-05_JPRB, 0.17405343E-05_JPRB, 0.17389397E-05_JPRB /)

RGHG2(:,51, 8) = (/ &
  & 0.17381689E-05_JPRB, 0.17413427E-05_JPRB, 0.17434858E-05_JPRB, 0.17457279E-05_JPRB, 0.17484421E-05_JPRB, 0.17508378E-05_JPRB, &
  & 0.17524735E-05_JPRB, 0.17533998E-05_JPRB, 0.17540124E-05_JPRB, 0.17543750E-05_JPRB, 0.17546093E-05_JPRB, 0.17546943E-05_JPRB, &
  & 0.17546183E-05_JPRB, 0.17543761E-05_JPRB, 0.17539858E-05_JPRB, 0.17534876E-05_JPRB, 0.17529056E-05_JPRB, 0.17522898E-05_JPRB, &
  & 0.17516741E-05_JPRB, 0.17511554E-05_JPRB, 0.17508173E-05_JPRB, 0.17507533E-05_JPRB, 0.17509724E-05_JPRB, 0.17514196E-05_JPRB, &
  & 0.17519920E-05_JPRB, 0.17525973E-05_JPRB, 0.17531972E-05_JPRB, 0.17537916E-05_JPRB, 0.17543942E-05_JPRB, 0.17550119E-05_JPRB, &
  & 0.17556247E-05_JPRB, 0.17561731E-05_JPRB, 0.17565694E-05_JPRB, 0.17567537E-05_JPRB, 0.17567040E-05_JPRB, 0.17564398E-05_JPRB, &
  & 0.17559989E-05_JPRB, 0.17554282E-05_JPRB, 0.17547820E-05_JPRB, 0.17541239E-05_JPRB, 0.17534901E-05_JPRB, 0.17529435E-05_JPRB, &
  & 0.17525213E-05_JPRB, 0.17522214E-05_JPRB, 0.17520308E-05_JPRB, 0.17519122E-05_JPRB, 0.17518439E-05_JPRB, 0.17517962E-05_JPRB, &
  & 0.17517287E-05_JPRB, 0.17516077E-05_JPRB, 0.17514119E-05_JPRB, 0.17511563E-05_JPRB, 0.17508723E-05_JPRB, 0.17505920E-05_JPRB, &
  & 0.17503166E-05_JPRB, 0.17500378E-05_JPRB, 0.17497068E-05_JPRB, 0.17492907E-05_JPRB, 0.17487628E-05_JPRB, 0.17481348E-05_JPRB, &
  & 0.17474692E-05_JPRB, 0.17467803E-05_JPRB, 0.17459460E-05_JPRB, 0.17444438E-05_JPRB /)

RGHG2(:,52, 8) = (/ &
  & 0.17455977E-05_JPRB, 0.17477478E-05_JPRB, 0.17492039E-05_JPRB, 0.17509668E-05_JPRB, 0.17530259E-05_JPRB, 0.17549622E-05_JPRB, &
  & 0.17561398E-05_JPRB, 0.17568622E-05_JPRB, 0.17572479E-05_JPRB, 0.17575063E-05_JPRB, 0.17576322E-05_JPRB, 0.17576355E-05_JPRB, &
  & 0.17574762E-05_JPRB, 0.17571358E-05_JPRB, 0.17566331E-05_JPRB, 0.17560001E-05_JPRB, 0.17552836E-05_JPRB, 0.17545065E-05_JPRB, &
  & 0.17537188E-05_JPRB, 0.17529250E-05_JPRB, 0.17522461E-05_JPRB, 0.17517666E-05_JPRB, 0.17516124E-05_JPRB, 0.17518009E-05_JPRB, &
  & 0.17522306E-05_JPRB, 0.17527649E-05_JPRB, 0.17533290E-05_JPRB, 0.17539057E-05_JPRB, 0.17545046E-05_JPRB, 0.17551287E-05_JPRB, &
  & 0.17557610E-05_JPRB, 0.17563355E-05_JPRB, 0.17567642E-05_JPRB, 0.17569780E-05_JPRB, 0.17569481E-05_JPRB, 0.17566970E-05_JPRB, &
  & 0.17562634E-05_JPRB, 0.17556922E-05_JPRB, 0.17550534E-05_JPRB, 0.17543912E-05_JPRB, 0.17537634E-05_JPRB, 0.17532225E-05_JPRB, &
  & 0.17528112E-05_JPRB, 0.17525492E-05_JPRB, 0.17524034E-05_JPRB, 0.17523535E-05_JPRB, 0.17523806E-05_JPRB, 0.17524613E-05_JPRB, &
  & 0.17525615E-05_JPRB, 0.17526420E-05_JPRB, 0.17526837E-05_JPRB, 0.17526777E-05_JPRB, 0.17526352E-05_JPRB, 0.17525724E-05_JPRB, &
  & 0.17524966E-05_JPRB, 0.17524045E-05_JPRB, 0.17522875E-05_JPRB, 0.17521215E-05_JPRB, 0.17518780E-05_JPRB, 0.17515592E-05_JPRB, &
  & 0.17511818E-05_JPRB, 0.17507346E-05_JPRB, 0.17501518E-05_JPRB, 0.17489170E-05_JPRB /)

RGHG2(:,53, 8) = (/ &
  & 0.17504924E-05_JPRB, 0.17522600E-05_JPRB, 0.17534737E-05_JPRB, 0.17547417E-05_JPRB, 0.17563295E-05_JPRB, 0.17577023E-05_JPRB, &
  & 0.17586042E-05_JPRB, 0.17590588E-05_JPRB, 0.17593388E-05_JPRB, 0.17594782E-05_JPRB, 0.17595362E-05_JPRB, 0.17594846E-05_JPRB, &
  & 0.17592820E-05_JPRB, 0.17589055E-05_JPRB, 0.17583670E-05_JPRB, 0.17576999E-05_JPRB, 0.17569436E-05_JPRB, 0.17561349E-05_JPRB, &
  & 0.17552622E-05_JPRB, 0.17543814E-05_JPRB, 0.17534820E-05_JPRB, 0.17527194E-05_JPRB, 0.17522395E-05_JPRB, 0.17521734E-05_JPRB, &
  & 0.17524573E-05_JPRB, 0.17529213E-05_JPRB, 0.17534517E-05_JPRB, 0.17540141E-05_JPRB, 0.17546085E-05_JPRB, 0.17552410E-05_JPRB, &
  & 0.17558937E-05_JPRB, 0.17564968E-05_JPRB, 0.17569603E-05_JPRB, 0.17572024E-05_JPRB, 0.17571947E-05_JPRB, 0.17569588E-05_JPRB, &
  & 0.17565288E-05_JPRB, 0.17559634E-05_JPRB, 0.17553232E-05_JPRB, 0.17546665E-05_JPRB, 0.17540343E-05_JPRB, 0.17534944E-05_JPRB, &
  & 0.17530998E-05_JPRB, 0.17528555E-05_JPRB, 0.17527498E-05_JPRB, 0.17527562E-05_JPRB, 0.17528625E-05_JPRB, 0.17530438E-05_JPRB, &
  & 0.17532547E-05_JPRB, 0.17534571E-05_JPRB, 0.17536195E-05_JPRB, 0.17537338E-05_JPRB, 0.17537988E-05_JPRB, 0.17538321E-05_JPRB, &
  & 0.17538431E-05_JPRB, 0.17538389E-05_JPRB, 0.17538180E-05_JPRB, 0.17537725E-05_JPRB, 0.17536902E-05_JPRB, 0.17535588E-05_JPRB, &
  & 0.17533832E-05_JPRB, 0.17531654E-05_JPRB, 0.17528552E-05_JPRB, 0.17520809E-05_JPRB /)

RGHG2(:,54, 8) = (/ &
  & 0.17547837E-05_JPRB, 0.17559553E-05_JPRB, 0.17567327E-05_JPRB, 0.17576529E-05_JPRB, 0.17587313E-05_JPRB, 0.17597266E-05_JPRB, &
  & 0.17603102E-05_JPRB, 0.17606403E-05_JPRB, 0.17607942E-05_JPRB, 0.17608752E-05_JPRB, 0.17608810E-05_JPRB, 0.17607945E-05_JPRB, &
  & 0.17605767E-05_JPRB, 0.17601953E-05_JPRB, 0.17596565E-05_JPRB, 0.17589946E-05_JPRB, 0.17582427E-05_JPRB, 0.17574141E-05_JPRB, &
  & 0.17565392E-05_JPRB, 0.17555692E-05_JPRB, 0.17545734E-05_JPRB, 0.17535931E-05_JPRB, 0.17528471E-05_JPRB, 0.17525444E-05_JPRB, &
  & 0.17526836E-05_JPRB, 0.17530765E-05_JPRB, 0.17535754E-05_JPRB, 0.17541217E-05_JPRB, 0.17547147E-05_JPRB, 0.17553549E-05_JPRB, &
  & 0.17560278E-05_JPRB, 0.17566633E-05_JPRB, 0.17571608E-05_JPRB, 0.17574338E-05_JPRB, 0.17574497E-05_JPRB, 0.17572271E-05_JPRB, &
  & 0.17568032E-05_JPRB, 0.17562395E-05_JPRB, 0.17556036E-05_JPRB, 0.17549412E-05_JPRB, 0.17543091E-05_JPRB, 0.17537732E-05_JPRB, &
  & 0.17533816E-05_JPRB, 0.17531592E-05_JPRB, 0.17530815E-05_JPRB, 0.17531336E-05_JPRB, 0.17533063E-05_JPRB, 0.17535638E-05_JPRB, &
  & 0.17538580E-05_JPRB, 0.17541346E-05_JPRB, 0.17543655E-05_JPRB, 0.17545317E-05_JPRB, 0.17546472E-05_JPRB, 0.17547155E-05_JPRB, &
  & 0.17547615E-05_JPRB, 0.17547900E-05_JPRB, 0.17548068E-05_JPRB, 0.17548107E-05_JPRB, 0.17547954E-05_JPRB, 0.17547554E-05_JPRB, &
  & 0.17546929E-05_JPRB, 0.17546167E-05_JPRB, 0.17545382E-05_JPRB, 0.17544498E-05_JPRB /)

RGHG2(:,55, 8) = (/ &
  & 0.17577006E-05_JPRB, 0.17586206E-05_JPRB, 0.17592212E-05_JPRB, 0.17598546E-05_JPRB, 0.17605814E-05_JPRB, 0.17612333E-05_JPRB, &
  & 0.17616471E-05_JPRB, 0.17618376E-05_JPRB, 0.17619343E-05_JPRB, 0.17619627E-05_JPRB, 0.17619365E-05_JPRB, 0.17618368E-05_JPRB, &
  & 0.17616176E-05_JPRB, 0.17612496E-05_JPRB, 0.17607360E-05_JPRB, 0.17600935E-05_JPRB, 0.17593518E-05_JPRB, 0.17585337E-05_JPRB, &
  & 0.17576149E-05_JPRB, 0.17566222E-05_JPRB, 0.17555104E-05_JPRB, 0.17543789E-05_JPRB, 0.17534252E-05_JPRB, 0.17529154E-05_JPRB, &
  & 0.17529192E-05_JPRB, 0.17532427E-05_JPRB, 0.17537060E-05_JPRB, 0.17542394E-05_JPRB, 0.17548282E-05_JPRB, 0.17554789E-05_JPRB, &
  & 0.17561739E-05_JPRB, 0.17568408E-05_JPRB, 0.17573728E-05_JPRB, 0.17576781E-05_JPRB, 0.17577181E-05_JPRB, 0.17575092E-05_JPRB, &
  & 0.17570912E-05_JPRB, 0.17565299E-05_JPRB, 0.17558916E-05_JPRB, 0.17552278E-05_JPRB, 0.17545910E-05_JPRB, 0.17540567E-05_JPRB, &
  & 0.17536781E-05_JPRB, 0.17534668E-05_JPRB, 0.17534118E-05_JPRB, 0.17534989E-05_JPRB, 0.17537202E-05_JPRB, 0.17540423E-05_JPRB, &
  & 0.17543953E-05_JPRB, 0.17547279E-05_JPRB, 0.17549989E-05_JPRB, 0.17552012E-05_JPRB, 0.17553275E-05_JPRB, 0.17554155E-05_JPRB, &
  & 0.17554698E-05_JPRB, 0.17555095E-05_JPRB, 0.17555378E-05_JPRB, 0.17555574E-05_JPRB, 0.17555648E-05_JPRB, 0.17555553E-05_JPRB, &
  & 0.17555278E-05_JPRB, 0.17554851E-05_JPRB, 0.17554296E-05_JPRB, 0.17553150E-05_JPRB /)

RGHG2(:,56, 8) = (/ &
  & 0.17602096E-05_JPRB, 0.17607823E-05_JPRB, 0.17611688E-05_JPRB, 0.17615715E-05_JPRB, 0.17620454E-05_JPRB, 0.17624614E-05_JPRB, &
  & 0.17627129E-05_JPRB, 0.17628380E-05_JPRB, 0.17628815E-05_JPRB, 0.17628827E-05_JPRB, 0.17628420E-05_JPRB, 0.17627351E-05_JPRB, &
  & 0.17625298E-05_JPRB, 0.17621910E-05_JPRB, 0.17617089E-05_JPRB, 0.17611011E-05_JPRB, 0.17603777E-05_JPRB, 0.17595445E-05_JPRB, &
  & 0.17586126E-05_JPRB, 0.17575387E-05_JPRB, 0.17563464E-05_JPRB, 0.17550816E-05_JPRB, 0.17539517E-05_JPRB, 0.17532889E-05_JPRB, &
  & 0.17531747E-05_JPRB, 0.17534287E-05_JPRB, 0.17538576E-05_JPRB, 0.17543734E-05_JPRB, 0.17549614E-05_JPRB, 0.17556221E-05_JPRB, &
  & 0.17563400E-05_JPRB, 0.17570393E-05_JPRB, 0.17576065E-05_JPRB, 0.17579429E-05_JPRB, 0.17580056E-05_JPRB, 0.17578113E-05_JPRB, &
  & 0.17573991E-05_JPRB, 0.17568400E-05_JPRB, 0.17561989E-05_JPRB, 0.17555268E-05_JPRB, 0.17548886E-05_JPRB, 0.17543598E-05_JPRB, &
  & 0.17539890E-05_JPRB, 0.17537923E-05_JPRB, 0.17537536E-05_JPRB, 0.17538644E-05_JPRB, 0.17541237E-05_JPRB, 0.17544860E-05_JPRB, &
  & 0.17548914E-05_JPRB, 0.17552691E-05_JPRB, 0.17555774E-05_JPRB, 0.17557909E-05_JPRB, 0.17559382E-05_JPRB, 0.17560228E-05_JPRB, &
  & 0.17560820E-05_JPRB, 0.17561213E-05_JPRB, 0.17561501E-05_JPRB, 0.17561714E-05_JPRB, 0.17561838E-05_JPRB, 0.17561836E-05_JPRB, &
  & 0.17561695E-05_JPRB, 0.17561441E-05_JPRB, 0.17561099E-05_JPRB, 0.17560470E-05_JPRB /)

RGHG2(:,57, 8) = (/ &
  & 0.17619222E-05_JPRB, 0.17623896E-05_JPRB, 0.17626651E-05_JPRB, 0.17629459E-05_JPRB, 0.17632252E-05_JPRB, 0.17634867E-05_JPRB, &
  & 0.17636469E-05_JPRB, 0.17637112E-05_JPRB, 0.17637285E-05_JPRB, 0.17637142E-05_JPRB, 0.17636648E-05_JPRB, 0.17635657E-05_JPRB, &
  & 0.17633797E-05_JPRB, 0.17630741E-05_JPRB, 0.17626372E-05_JPRB, 0.17620614E-05_JPRB, 0.17613545E-05_JPRB, 0.17605153E-05_JPRB, &
  & 0.17595257E-05_JPRB, 0.17583892E-05_JPRB, 0.17570868E-05_JPRB, 0.17556915E-05_JPRB, 0.17544478E-05_JPRB, 0.17536640E-05_JPRB, &
  & 0.17534566E-05_JPRB, 0.17536469E-05_JPRB, 0.17540387E-05_JPRB, 0.17545399E-05_JPRB, 0.17551253E-05_JPRB, 0.17557975E-05_JPRB, &
  & 0.17565378E-05_JPRB, 0.17572695E-05_JPRB, 0.17578707E-05_JPRB, 0.17582371E-05_JPRB, 0.17583213E-05_JPRB, 0.17581401E-05_JPRB, &
  & 0.17577371E-05_JPRB, 0.17571768E-05_JPRB, 0.17565295E-05_JPRB, 0.17558533E-05_JPRB, 0.17552103E-05_JPRB, 0.17546874E-05_JPRB, &
  & 0.17543284E-05_JPRB, 0.17541423E-05_JPRB, 0.17541170E-05_JPRB, 0.17542458E-05_JPRB, 0.17545251E-05_JPRB, 0.17549186E-05_JPRB, &
  & 0.17553596E-05_JPRB, 0.17557762E-05_JPRB, 0.17561179E-05_JPRB, 0.17563625E-05_JPRB, 0.17565062E-05_JPRB, 0.17565992E-05_JPRB, &
  & 0.17566529E-05_JPRB, 0.17566889E-05_JPRB, 0.17567129E-05_JPRB, 0.17567284E-05_JPRB, 0.17567356E-05_JPRB, 0.17567314E-05_JPRB, &
  & 0.17567147E-05_JPRB, 0.17566875E-05_JPRB, 0.17566516E-05_JPRB, 0.17565733E-05_JPRB /)

RGHG2(:,58, 8) = (/ &
  & 0.17633936E-05_JPRB, 0.17637044E-05_JPRB, 0.17638936E-05_JPRB, 0.17640596E-05_JPRB, 0.17642390E-05_JPRB, 0.17643906E-05_JPRB, &
  & 0.17644838E-05_JPRB, 0.17645193E-05_JPRB, 0.17645206E-05_JPRB, 0.17644988E-05_JPRB, 0.17644522E-05_JPRB, 0.17643617E-05_JPRB, &
  & 0.17641996E-05_JPRB, 0.17639331E-05_JPRB, 0.17635358E-05_JPRB, 0.17629998E-05_JPRB, 0.17623040E-05_JPRB, 0.17614414E-05_JPRB, &
  & 0.17604011E-05_JPRB, 0.17591633E-05_JPRB, 0.17577530E-05_JPRB, 0.17562541E-05_JPRB, 0.17549141E-05_JPRB, 0.17540561E-05_JPRB, &
  & 0.17537745E-05_JPRB, 0.17539069E-05_JPRB, 0.17542642E-05_JPRB, 0.17547496E-05_JPRB, 0.17553346E-05_JPRB, 0.17560182E-05_JPRB, &
  & 0.17567816E-05_JPRB, 0.17575431E-05_JPRB, 0.17581777E-05_JPRB, 0.17585689E-05_JPRB, 0.17586727E-05_JPRB, 0.17585064E-05_JPRB, &
  & 0.17581090E-05_JPRB, 0.17575503E-05_JPRB, 0.17568977E-05_JPRB, 0.17562114E-05_JPRB, 0.17555690E-05_JPRB, 0.17550515E-05_JPRB, &
  & 0.17547028E-05_JPRB, 0.17545271E-05_JPRB, 0.17545128E-05_JPRB, 0.17546541E-05_JPRB, 0.17549479E-05_JPRB, 0.17553554E-05_JPRB, &
  & 0.17558168E-05_JPRB, 0.17562720E-05_JPRB, 0.17566484E-05_JPRB, 0.17569109E-05_JPRB, 0.17570760E-05_JPRB, 0.17571638E-05_JPRB, &
  & 0.17572154E-05_JPRB, 0.17572448E-05_JPRB, 0.17572606E-05_JPRB, 0.17572672E-05_JPRB, 0.17572640E-05_JPRB, 0.17572494E-05_JPRB, &
  & 0.17572244E-05_JPRB, 0.17571919E-05_JPRB, 0.17571510E-05_JPRB, 0.17570767E-05_JPRB /)

RGHG2(:,59, 8) = (/ &
  & 0.17645137E-05_JPRB, 0.17647710E-05_JPRB, 0.17649056E-05_JPRB, 0.17650216E-05_JPRB, 0.17651259E-05_JPRB, 0.17652201E-05_JPRB, &
  & 0.17652749E-05_JPRB, 0.17652916E-05_JPRB, 0.17652865E-05_JPRB, 0.17652653E-05_JPRB, 0.17652235E-05_JPRB, 0.17651471E-05_JPRB, &
  & 0.17650100E-05_JPRB, 0.17647766E-05_JPRB, 0.17644228E-05_JPRB, 0.17639126E-05_JPRB, 0.17632308E-05_JPRB, 0.17623354E-05_JPRB, &
  & 0.17612235E-05_JPRB, 0.17598918E-05_JPRB, 0.17583702E-05_JPRB, 0.17567853E-05_JPRB, 0.17553881E-05_JPRB, 0.17544804E-05_JPRB, &
  & 0.17541382E-05_JPRB, 0.17542188E-05_JPRB, 0.17545450E-05_JPRB, 0.17550166E-05_JPRB, 0.17556032E-05_JPRB, 0.17562982E-05_JPRB, &
  & 0.17570840E-05_JPRB, 0.17578752E-05_JPRB, 0.17585371E-05_JPRB, 0.17589523E-05_JPRB, 0.17590706E-05_JPRB, 0.17589152E-05_JPRB, &
  & 0.17585280E-05_JPRB, 0.17579683E-05_JPRB, 0.17573097E-05_JPRB, 0.17566194E-05_JPRB, 0.17559730E-05_JPRB, 0.17554636E-05_JPRB, &
  & 0.17551232E-05_JPRB, 0.17549564E-05_JPRB, 0.17549510E-05_JPRB, 0.17551013E-05_JPRB, 0.17554041E-05_JPRB, 0.17558182E-05_JPRB, &
  & 0.17562944E-05_JPRB, 0.17567618E-05_JPRB, 0.17571757E-05_JPRB, 0.17574735E-05_JPRB, 0.17576490E-05_JPRB, 0.17577427E-05_JPRB, &
  & 0.17577893E-05_JPRB, 0.17578095E-05_JPRB, 0.17578141E-05_JPRB, 0.17578072E-05_JPRB, 0.17577886E-05_JPRB, 0.17577581E-05_JPRB, &
  & 0.17577180E-05_JPRB, 0.17576706E-05_JPRB, 0.17576172E-05_JPRB, 0.17575164E-05_JPRB /)

RGHG2(:,60, 8) = (/ &
  & 0.17655159E-05_JPRB, 0.17657051E-05_JPRB, 0.17658017E-05_JPRB, 0.17658765E-05_JPRB, 0.17659465E-05_JPRB, 0.17660039E-05_JPRB, &
  & 0.17660388E-05_JPRB, 0.17660482E-05_JPRB, 0.17660425E-05_JPRB, 0.17660248E-05_JPRB, 0.17659913E-05_JPRB, 0.17659289E-05_JPRB, &
  & 0.17658131E-05_JPRB, 0.17656134E-05_JPRB, 0.17652885E-05_JPRB, 0.17648106E-05_JPRB, 0.17641182E-05_JPRB, 0.17631976E-05_JPRB, &
  & 0.17620064E-05_JPRB, 0.17605820E-05_JPRB, 0.17589786E-05_JPRB, 0.17573290E-05_JPRB, 0.17558993E-05_JPRB, 0.17549505E-05_JPRB, &
  & 0.17545581E-05_JPRB, 0.17545943E-05_JPRB, 0.17548925E-05_JPRB, 0.17553555E-05_JPRB, 0.17559437E-05_JPRB, 0.17566540E-05_JPRB, &
  & 0.17574603E-05_JPRB, 0.17582772E-05_JPRB, 0.17589653E-05_JPRB, 0.17593950E-05_JPRB, 0.17595237E-05_JPRB, 0.17593777E-05_JPRB, &
  & 0.17589959E-05_JPRB, 0.17584397E-05_JPRB, 0.17577779E-05_JPRB, 0.17570813E-05_JPRB, 0.17564380E-05_JPRB, 0.17559324E-05_JPRB, &
  & 0.17556015E-05_JPRB, 0.17554401E-05_JPRB, 0.17554408E-05_JPRB, 0.17555980E-05_JPRB, 0.17559062E-05_JPRB, 0.17563241E-05_JPRB, &
  & 0.17568010E-05_JPRB, 0.17572854E-05_JPRB, 0.17577119E-05_JPRB, 0.17580460E-05_JPRB, 0.17582458E-05_JPRB, 0.17583483E-05_JPRB, &
  & 0.17583892E-05_JPRB, 0.17583991E-05_JPRB, 0.17583886E-05_JPRB, 0.17583634E-05_JPRB, 0.17583250E-05_JPRB, 0.17582727E-05_JPRB, &
  & 0.17582114E-05_JPRB, 0.17581458E-05_JPRB, 0.17580717E-05_JPRB, 0.17579437E-05_JPRB /)

RGHG2(:,61, 8) = (/ &
  & 0.17663793E-05_JPRB, 0.17665387E-05_JPRB, 0.17666155E-05_JPRB, 0.17666725E-05_JPRB, 0.17667205E-05_JPRB, 0.17667619E-05_JPRB, &
  & 0.17667871E-05_JPRB, 0.17667951E-05_JPRB, 0.17667923E-05_JPRB, 0.17667805E-05_JPRB, 0.17667560E-05_JPRB, 0.17667076E-05_JPRB, &
  & 0.17666137E-05_JPRB, 0.17664365E-05_JPRB, 0.17661430E-05_JPRB, 0.17656711E-05_JPRB, 0.17649878E-05_JPRB, 0.17640079E-05_JPRB, &
  & 0.17627698E-05_JPRB, 0.17612709E-05_JPRB, 0.17596069E-05_JPRB, 0.17579229E-05_JPRB, 0.17564685E-05_JPRB, 0.17554846E-05_JPRB, &
  & 0.17550470E-05_JPRB, 0.17550436E-05_JPRB, 0.17553205E-05_JPRB, 0.17557772E-05_JPRB, 0.17563746E-05_JPRB, 0.17570983E-05_JPRB, &
  & 0.17579280E-05_JPRB, 0.17587674E-05_JPRB, 0.17594721E-05_JPRB, 0.17599118E-05_JPRB, 0.17600428E-05_JPRB, 0.17599009E-05_JPRB, &
  & 0.17595257E-05_JPRB, 0.17589721E-05_JPRB, 0.17583103E-05_JPRB, 0.17576137E-05_JPRB, 0.17569697E-05_JPRB, 0.17564729E-05_JPRB, &
  & 0.17561462E-05_JPRB, 0.17559910E-05_JPRB, 0.17559954E-05_JPRB, 0.17561543E-05_JPRB, 0.17564647E-05_JPRB, 0.17568825E-05_JPRB, &
  & 0.17573632E-05_JPRB, 0.17578454E-05_JPRB, 0.17582896E-05_JPRB, 0.17586393E-05_JPRB, 0.17588786E-05_JPRB, 0.17589898E-05_JPRB, &
  & 0.17590319E-05_JPRB, 0.17590285E-05_JPRB, 0.17589971E-05_JPRB, 0.17589492E-05_JPRB, 0.17588841E-05_JPRB, 0.17588040E-05_JPRB, &
  & 0.17587159E-05_JPRB, 0.17586221E-05_JPRB, 0.17585185E-05_JPRB, 0.17583387E-05_JPRB /)

RGHG2(:,62, 8) = (/ &
  & 0.17671885E-05_JPRB, 0.17673221E-05_JPRB, 0.17673844E-05_JPRB, 0.17674300E-05_JPRB, 0.17674697E-05_JPRB, 0.17675034E-05_JPRB, &
  & 0.17675275E-05_JPRB, 0.17675388E-05_JPRB, 0.17675418E-05_JPRB, 0.17675370E-05_JPRB, 0.17675221E-05_JPRB, 0.17674865E-05_JPRB, &
  & 0.17674095E-05_JPRB, 0.17672560E-05_JPRB, 0.17669729E-05_JPRB, 0.17665204E-05_JPRB, 0.17658024E-05_JPRB, 0.17648171E-05_JPRB, &
  & 0.17635167E-05_JPRB, 0.17619860E-05_JPRB, 0.17602864E-05_JPRB, 0.17585837E-05_JPRB, 0.17571069E-05_JPRB, 0.17560969E-05_JPRB, &
  & 0.17556190E-05_JPRB, 0.17555831E-05_JPRB, 0.17558431E-05_JPRB, 0.17563016E-05_JPRB, 0.17569082E-05_JPRB, 0.17576531E-05_JPRB, &
  & 0.17585031E-05_JPRB, 0.17593632E-05_JPRB, 0.17600780E-05_JPRB, 0.17605162E-05_JPRB, 0.17606429E-05_JPRB, 0.17605003E-05_JPRB, &
  & 0.17601288E-05_JPRB, 0.17595803E-05_JPRB, 0.17589218E-05_JPRB, 0.17582261E-05_JPRB, 0.17575873E-05_JPRB, 0.17570924E-05_JPRB, &
  & 0.17567741E-05_JPRB, 0.17566202E-05_JPRB, 0.17566252E-05_JPRB, 0.17567841E-05_JPRB, 0.17570909E-05_JPRB, 0.17575056E-05_JPRB, &
  & 0.17579840E-05_JPRB, 0.17584696E-05_JPRB, 0.17589139E-05_JPRB, 0.17592871E-05_JPRB, 0.17595415E-05_JPRB, 0.17596855E-05_JPRB, &
  & 0.17597274E-05_JPRB, 0.17597097E-05_JPRB, 0.17596544E-05_JPRB, 0.17595760E-05_JPRB, 0.17594798E-05_JPRB, 0.17593666E-05_JPRB, &
  & 0.17592458E-05_JPRB, 0.17591146E-05_JPRB, 0.17589720E-05_JPRB, 0.17587130E-05_JPRB /)

RGHG2(:,63, 8) = (/ &
  & 0.17679308E-05_JPRB, 0.17680602E-05_JPRB, 0.17681210E-05_JPRB, 0.17681646E-05_JPRB, 0.17682016E-05_JPRB, 0.17682351E-05_JPRB, &
  & 0.17682614E-05_JPRB, 0.17682785E-05_JPRB, 0.17682889E-05_JPRB, 0.17682931E-05_JPRB, 0.17682891E-05_JPRB, 0.17682678E-05_JPRB, &
  & 0.17682069E-05_JPRB, 0.17680655E-05_JPRB, 0.17678003E-05_JPRB, 0.17673324E-05_JPRB, 0.17666258E-05_JPRB, 0.17655967E-05_JPRB, &
  & 0.17642966E-05_JPRB, 0.17627405E-05_JPRB, 0.17610295E-05_JPRB, 0.17593118E-05_JPRB, 0.17578337E-05_JPRB, 0.17567976E-05_JPRB, &
  & 0.17562910E-05_JPRB, 0.17562298E-05_JPRB, 0.17564799E-05_JPRB, 0.17569436E-05_JPRB, 0.17575676E-05_JPRB, 0.17583319E-05_JPRB, &
  & 0.17592058E-05_JPRB, 0.17600785E-05_JPRB, 0.17607948E-05_JPRB, 0.17612218E-05_JPRB, 0.17613364E-05_JPRB, 0.17611887E-05_JPRB, &
  & 0.17608193E-05_JPRB, 0.17602777E-05_JPRB, 0.17596251E-05_JPRB, 0.17589348E-05_JPRB, 0.17582996E-05_JPRB, 0.17578120E-05_JPRB, &
  & 0.17574962E-05_JPRB, 0.17573439E-05_JPRB, 0.17573462E-05_JPRB, 0.17574994E-05_JPRB, 0.17577991E-05_JPRB, 0.17582055E-05_JPRB, &
  & 0.17586788E-05_JPRB, 0.17591631E-05_JPRB, 0.17596119E-05_JPRB, 0.17599893E-05_JPRB, 0.17602715E-05_JPRB, 0.17604284E-05_JPRB, &
  & 0.17604846E-05_JPRB, 0.17604560E-05_JPRB, 0.17603693E-05_JPRB, 0.17602599E-05_JPRB, 0.17601291E-05_JPRB, 0.17599846E-05_JPRB, &
  & 0.17598218E-05_JPRB, 0.17596512E-05_JPRB, 0.17594480E-05_JPRB, 0.17590935E-05_JPRB /)

RGHG2(:,64, 8) = (/ &
  & 0.17686380E-05_JPRB, 0.17687719E-05_JPRB, 0.17688346E-05_JPRB, 0.17688801E-05_JPRB, 0.17689197E-05_JPRB, 0.17689551E-05_JPRB, &
  & 0.17689870E-05_JPRB, 0.17690106E-05_JPRB, 0.17690305E-05_JPRB, 0.17690454E-05_JPRB, 0.17690534E-05_JPRB, 0.17690464E-05_JPRB, &
  & 0.17690004E-05_JPRB, 0.17688729E-05_JPRB, 0.17686034E-05_JPRB, 0.17681477E-05_JPRB, 0.17674165E-05_JPRB, 0.17664037E-05_JPRB, &
  & 0.17650920E-05_JPRB, 0.17635414E-05_JPRB, 0.17618278E-05_JPRB, 0.17601238E-05_JPRB, 0.17586422E-05_JPRB, 0.17576026E-05_JPRB, &
  & 0.17570749E-05_JPRB, 0.17569969E-05_JPRB, 0.17572423E-05_JPRB, 0.17577158E-05_JPRB, 0.17583567E-05_JPRB, 0.17591424E-05_JPRB, &
  & 0.17600329E-05_JPRB, 0.17609117E-05_JPRB, 0.17616159E-05_JPRB, 0.17620224E-05_JPRB, 0.17621186E-05_JPRB, 0.17619632E-05_JPRB, &
  & 0.17615971E-05_JPRB, 0.17610653E-05_JPRB, 0.17604229E-05_JPRB, 0.17597411E-05_JPRB, 0.17591142E-05_JPRB, 0.17586320E-05_JPRB, &
  & 0.17583216E-05_JPRB, 0.17581677E-05_JPRB, 0.17581644E-05_JPRB, 0.17583091E-05_JPRB, 0.17585951E-05_JPRB, 0.17589889E-05_JPRB, &
  & 0.17594516E-05_JPRB, 0.17599315E-05_JPRB, 0.17603822E-05_JPRB, 0.17607673E-05_JPRB, 0.17610583E-05_JPRB, 0.17612364E-05_JPRB, &
  & 0.17613008E-05_JPRB, 0.17612624E-05_JPRB, 0.17611504E-05_JPRB, 0.17610081E-05_JPRB, 0.17608504E-05_JPRB, 0.17606673E-05_JPRB, &
  & 0.17604730E-05_JPRB, 0.17602438E-05_JPRB, 0.17599890E-05_JPRB, 0.17594872E-05_JPRB /)

RGHG2(:,65, 8) = (/ &
  & 0.17693101E-05_JPRB, 0.17694572E-05_JPRB, 0.17695279E-05_JPRB, 0.17695793E-05_JPRB, 0.17696237E-05_JPRB, 0.17696655E-05_JPRB, &
  & 0.17697023E-05_JPRB, 0.17697354E-05_JPRB, 0.17697646E-05_JPRB, 0.17697920E-05_JPRB, 0.17698145E-05_JPRB, 0.17698226E-05_JPRB, &
  & 0.17697890E-05_JPRB, 0.17696661E-05_JPRB, 0.17694048E-05_JPRB, 0.17689398E-05_JPRB, 0.17682248E-05_JPRB, 0.17672120E-05_JPRB, &
  & 0.17659203E-05_JPRB, 0.17643812E-05_JPRB, 0.17626928E-05_JPRB, 0.17610040E-05_JPRB, 0.17595517E-05_JPRB, 0.17585138E-05_JPRB, &
  & 0.17579807E-05_JPRB, 0.17578930E-05_JPRB, 0.17581372E-05_JPRB, 0.17586179E-05_JPRB, 0.17592736E-05_JPRB, 0.17600720E-05_JPRB, &
  & 0.17609691E-05_JPRB, 0.17618394E-05_JPRB, 0.17625194E-05_JPRB, 0.17628970E-05_JPRB, 0.17629711E-05_JPRB, 0.17628082E-05_JPRB, &
  & 0.17624486E-05_JPRB, 0.17619317E-05_JPRB, 0.17613077E-05_JPRB, 0.17606425E-05_JPRB, 0.17600290E-05_JPRB, 0.17595578E-05_JPRB, &
  & 0.17592521E-05_JPRB, 0.17590971E-05_JPRB, 0.17590860E-05_JPRB, 0.17592182E-05_JPRB, 0.17594863E-05_JPRB, 0.17598620E-05_JPRB, &
  & 0.17603110E-05_JPRB, 0.17607816E-05_JPRB, 0.17612311E-05_JPRB, 0.17616209E-05_JPRB, 0.17619213E-05_JPRB, 0.17621080E-05_JPRB, &
  & 0.17621801E-05_JPRB, 0.17621348E-05_JPRB, 0.17619988E-05_JPRB, 0.17618331E-05_JPRB, 0.17616455E-05_JPRB, 0.17614373E-05_JPRB, &
  & 0.17611986E-05_JPRB, 0.17609296E-05_JPRB, 0.17605980E-05_JPRB, 0.17599607E-05_JPRB /)

RGHG2(:,66, 8) = (/ &
  & 0.17699506E-05_JPRB, 0.17701225E-05_JPRB, 0.17702057E-05_JPRB, 0.17702671E-05_JPRB, 0.17703201E-05_JPRB, 0.17703682E-05_JPRB, &
  & 0.17704142E-05_JPRB, 0.17704518E-05_JPRB, 0.17704947E-05_JPRB, 0.17705324E-05_JPRB, 0.17705698E-05_JPRB, 0.17705921E-05_JPRB, &
  & 0.17705677E-05_JPRB, 0.17704499E-05_JPRB, 0.17701899E-05_JPRB, 0.17697361E-05_JPRB, 0.17690279E-05_JPRB, 0.17680401E-05_JPRB, &
  & 0.17667726E-05_JPRB, 0.17652679E-05_JPRB, 0.17636114E-05_JPRB, 0.17619757E-05_JPRB, 0.17605539E-05_JPRB, 0.17595414E-05_JPRB, &
  & 0.17590100E-05_JPRB, 0.17589189E-05_JPRB, 0.17591591E-05_JPRB, 0.17596419E-05_JPRB, 0.17603006E-05_JPRB, 0.17610986E-05_JPRB, &
  & 0.17619864E-05_JPRB, 0.17628323E-05_JPRB, 0.17634785E-05_JPRB, 0.17638215E-05_JPRB, 0.17638733E-05_JPRB, 0.17637049E-05_JPRB, &
  & 0.17633564E-05_JPRB, 0.17628618E-05_JPRB, 0.17622643E-05_JPRB, 0.17616253E-05_JPRB, 0.17610350E-05_JPRB, 0.17605814E-05_JPRB, &
  & 0.17602854E-05_JPRB, 0.17601310E-05_JPRB, 0.17601108E-05_JPRB, 0.17602276E-05_JPRB, 0.17604747E-05_JPRB, 0.17608303E-05_JPRB, &
  & 0.17612599E-05_JPRB, 0.17617191E-05_JPRB, 0.17621633E-05_JPRB, 0.17625539E-05_JPRB, 0.17628602E-05_JPRB, 0.17630535E-05_JPRB, &
  & 0.17631288E-05_JPRB, 0.17630769E-05_JPRB, 0.17629241E-05_JPRB, 0.17627365E-05_JPRB, 0.17625284E-05_JPRB, 0.17622901E-05_JPRB, &
  & 0.17620224E-05_JPRB, 0.17617093E-05_JPRB, 0.17613190E-05_JPRB, 0.17605405E-05_JPRB /)

RGHG2(:,67, 8) = (/ &
  & 0.17705615E-05_JPRB, 0.17707694E-05_JPRB, 0.17708717E-05_JPRB, 0.17709474E-05_JPRB, 0.17710122E-05_JPRB, 0.17710712E-05_JPRB, &
  & 0.17711226E-05_JPRB, 0.17711720E-05_JPRB, 0.17712196E-05_JPRB, 0.17712728E-05_JPRB, 0.17713211E-05_JPRB, 0.17713525E-05_JPRB, &
  & 0.17713329E-05_JPRB, 0.17712191E-05_JPRB, 0.17709676E-05_JPRB, 0.17705240E-05_JPRB, 0.17698380E-05_JPRB, 0.17688797E-05_JPRB, &
  & 0.17676534E-05_JPRB, 0.17661951E-05_JPRB, 0.17646030E-05_JPRB, 0.17630204E-05_JPRB, 0.17616608E-05_JPRB, 0.17606776E-05_JPRB, &
  & 0.17601587E-05_JPRB, 0.17600644E-05_JPRB, 0.17602974E-05_JPRB, 0.17607714E-05_JPRB, 0.17614201E-05_JPRB, 0.17622021E-05_JPRB, &
  & 0.17630624E-05_JPRB, 0.17638732E-05_JPRB, 0.17644766E-05_JPRB, 0.17647840E-05_JPRB, 0.17648141E-05_JPRB, 0.17646430E-05_JPRB, &
  & 0.17643102E-05_JPRB, 0.17638436E-05_JPRB, 0.17632807E-05_JPRB, 0.17626775E-05_JPRB, 0.17621206E-05_JPRB, 0.17616923E-05_JPRB, &
  & 0.17614136E-05_JPRB, 0.17612612E-05_JPRB, 0.17612338E-05_JPRB, 0.17613349E-05_JPRB, 0.17615605E-05_JPRB, 0.17618926E-05_JPRB, &
  & 0.17623036E-05_JPRB, 0.17627474E-05_JPRB, 0.17631837E-05_JPRB, 0.17635712E-05_JPRB, 0.17638797E-05_JPRB, 0.17640772E-05_JPRB, &
  & 0.17641529E-05_JPRB, 0.17640961E-05_JPRB, 0.17639303E-05_JPRB, 0.17637278E-05_JPRB, 0.17635004E-05_JPRB, 0.17632409E-05_JPRB, &
  & 0.17629468E-05_JPRB, 0.17626003E-05_JPRB, 0.17621559E-05_JPRB, 0.17612310E-05_JPRB /)

RGHG2(:,68, 8) = (/ &
  & 0.17711311E-05_JPRB, 0.17713978E-05_JPRB, 0.17715299E-05_JPRB, 0.17716261E-05_JPRB, 0.17717068E-05_JPRB, 0.17717766E-05_JPRB, &
  & 0.17718387E-05_JPRB, 0.17718908E-05_JPRB, 0.17719528E-05_JPRB, 0.17720093E-05_JPRB, 0.17720683E-05_JPRB, 0.17721017E-05_JPRB, &
  & 0.17720838E-05_JPRB, 0.17719749E-05_JPRB, 0.17717339E-05_JPRB, 0.17713080E-05_JPRB, 0.17706502E-05_JPRB, 0.17697330E-05_JPRB, &
  & 0.17685602E-05_JPRB, 0.17671703E-05_JPRB, 0.17656495E-05_JPRB, 0.17641526E-05_JPRB, 0.17628547E-05_JPRB, 0.17619180E-05_JPRB, &
  & 0.17614134E-05_JPRB, 0.17613163E-05_JPRB, 0.17615355E-05_JPRB, 0.17619914E-05_JPRB, 0.17626161E-05_JPRB, 0.17633666E-05_JPRB, &
  & 0.17641878E-05_JPRB, 0.17649525E-05_JPRB, 0.17655100E-05_JPRB, 0.17657806E-05_JPRB, 0.17657911E-05_JPRB, 0.17656206E-05_JPRB, &
  & 0.17653075E-05_JPRB, 0.17648722E-05_JPRB, 0.17643481E-05_JPRB, 0.17637878E-05_JPRB, 0.17632707E-05_JPRB, 0.17628781E-05_JPRB, &
  & 0.17626219E-05_JPRB, 0.17624791E-05_JPRB, 0.17624461E-05_JPRB, 0.17625335E-05_JPRB, 0.17627382E-05_JPRB, 0.17630499E-05_JPRB, &
  & 0.17634400E-05_JPRB, 0.17638688E-05_JPRB, 0.17642924E-05_JPRB, 0.17646737E-05_JPRB, 0.17649807E-05_JPRB, 0.17651785E-05_JPRB, &
  & 0.17652549E-05_JPRB, 0.17651948E-05_JPRB, 0.17650232E-05_JPRB, 0.17648110E-05_JPRB, 0.17645725E-05_JPRB, 0.17642986E-05_JPRB, &
  & 0.17639863E-05_JPRB, 0.17636245E-05_JPRB, 0.17631349E-05_JPRB, 0.17621217E-05_JPRB /)

RGHG2(:,69, 8) = (/ &
  & 0.17716544E-05_JPRB, 0.17720154E-05_JPRB, 0.17721868E-05_JPRB, 0.17723114E-05_JPRB, 0.17724101E-05_JPRB, 0.17724933E-05_JPRB, &
  & 0.17725617E-05_JPRB, 0.17726217E-05_JPRB, 0.17726859E-05_JPRB, 0.17727499E-05_JPRB, 0.17728086E-05_JPRB, 0.17728418E-05_JPRB, &
  & 0.17728246E-05_JPRB, 0.17727205E-05_JPRB, 0.17724914E-05_JPRB, 0.17720876E-05_JPRB, 0.17714651E-05_JPRB, 0.17706002E-05_JPRB, &
  & 0.17694964E-05_JPRB, 0.17681880E-05_JPRB, 0.17667647E-05_JPRB, 0.17653550E-05_JPRB, 0.17641390E-05_JPRB, 0.17632501E-05_JPRB, &
  & 0.17627640E-05_JPRB, 0.17626616E-05_JPRB, 0.17628624E-05_JPRB, 0.17632909E-05_JPRB, 0.17638803E-05_JPRB, 0.17645885E-05_JPRB, &
  & 0.17653598E-05_JPRB, 0.17660717E-05_JPRB, 0.17665808E-05_JPRB, 0.17668169E-05_JPRB, 0.17668103E-05_JPRB, 0.17666423E-05_JPRB, &
  & 0.17663508E-05_JPRB, 0.17659501E-05_JPRB, 0.17654684E-05_JPRB, 0.17649539E-05_JPRB, 0.17644833E-05_JPRB, 0.17641294E-05_JPRB, &
  & 0.17639034E-05_JPRB, 0.17637747E-05_JPRB, 0.17637427E-05_JPRB, 0.17638199E-05_JPRB, 0.17640069E-05_JPRB, 0.17642991E-05_JPRB, &
  & 0.17646711E-05_JPRB, 0.17650821E-05_JPRB, 0.17654924E-05_JPRB, 0.17658646E-05_JPRB, 0.17661660E-05_JPRB, 0.17663612E-05_JPRB, &
  & 0.17664372E-05_JPRB, 0.17663784E-05_JPRB, 0.17662082E-05_JPRB, 0.17659941E-05_JPRB, 0.17657525E-05_JPRB, 0.17654768E-05_JPRB, &
  & 0.17651578E-05_JPRB, 0.17647890E-05_JPRB, 0.17642784E-05_JPRB, 0.17631613E-05_JPRB /)

RGHG2(:,70, 8) = (/ &
  & 0.17721414E-05_JPRB, 0.17726244E-05_JPRB, 0.17728577E-05_JPRB, 0.17730115E-05_JPRB, 0.17731311E-05_JPRB, 0.17732243E-05_JPRB, &
  & 0.17732992E-05_JPRB, 0.17733616E-05_JPRB, 0.17734286E-05_JPRB, 0.17734909E-05_JPRB, 0.17735466E-05_JPRB, 0.17735763E-05_JPRB, &
  & 0.17735572E-05_JPRB, 0.17734576E-05_JPRB, 0.17732425E-05_JPRB, 0.17728644E-05_JPRB, 0.17722846E-05_JPRB, 0.17714819E-05_JPRB, &
  & 0.17704592E-05_JPRB, 0.17692505E-05_JPRB, 0.17679317E-05_JPRB, 0.17666301E-05_JPRB, 0.17654985E-05_JPRB, 0.17646655E-05_JPRB, &
  & 0.17641999E-05_JPRB, 0.17640905E-05_JPRB, 0.17642687E-05_JPRB, 0.17646629E-05_JPRB, 0.17652088E-05_JPRB, 0.17658642E-05_JPRB, &
  & 0.17665773E-05_JPRB, 0.17672314E-05_JPRB, 0.17676896E-05_JPRB, 0.17678922E-05_JPRB, 0.17678715E-05_JPRB, 0.17677088E-05_JPRB, &
  & 0.17674403E-05_JPRB, 0.17670756E-05_JPRB, 0.17666381E-05_JPRB, 0.17661715E-05_JPRB, 0.17657501E-05_JPRB, 0.17654399E-05_JPRB, &
  & 0.17652495E-05_JPRB, 0.17651410E-05_JPRB, 0.17651158E-05_JPRB, 0.17651876E-05_JPRB, 0.17653610E-05_JPRB, 0.17656367E-05_JPRB, &
  & 0.17659916E-05_JPRB, 0.17663845E-05_JPRB, 0.17667776E-05_JPRB, 0.17671375E-05_JPRB, 0.17674286E-05_JPRB, 0.17676208E-05_JPRB, &
  & 0.17676971E-05_JPRB, 0.17676452E-05_JPRB, 0.17674830E-05_JPRB, 0.17672787E-05_JPRB, 0.17670451E-05_JPRB, 0.17667802E-05_JPRB, &
  & 0.17664674E-05_JPRB, 0.17661139E-05_JPRB, 0.17656088E-05_JPRB, 0.17644975E-05_JPRB /)

RGHG2(:,71, 8) = (/ &
  & 0.17726157E-05_JPRB, 0.17732655E-05_JPRB, 0.17735539E-05_JPRB, 0.17737412E-05_JPRB, 0.17738739E-05_JPRB, 0.17739759E-05_JPRB, &
  & 0.17740533E-05_JPRB, 0.17741157E-05_JPRB, 0.17741822E-05_JPRB, 0.17742366E-05_JPRB, 0.17742874E-05_JPRB, 0.17743102E-05_JPRB, &
  & 0.17742886E-05_JPRB, 0.17741926E-05_JPRB, 0.17739915E-05_JPRB, 0.17736410E-05_JPRB, 0.17731106E-05_JPRB, 0.17723755E-05_JPRB, &
  & 0.17714468E-05_JPRB, 0.17703463E-05_JPRB, 0.17691488E-05_JPRB, 0.17679598E-05_JPRB, 0.17669249E-05_JPRB, 0.17661537E-05_JPRB, &
  & 0.17657114E-05_JPRB, 0.17655947E-05_JPRB, 0.17657464E-05_JPRB, 0.17661010E-05_JPRB, 0.17665948E-05_JPRB, 0.17671902E-05_JPRB, &
  & 0.17678378E-05_JPRB, 0.17684293E-05_JPRB, 0.17688358E-05_JPRB, 0.17690051E-05_JPRB, 0.17689736E-05_JPRB, 0.17688189E-05_JPRB, &
  & 0.17685750E-05_JPRB, 0.17682478E-05_JPRB, 0.17678562E-05_JPRB, 0.17674409E-05_JPRB, 0.17670689E-05_JPRB, 0.17668061E-05_JPRB, &
  & 0.17666514E-05_JPRB, 0.17665679E-05_JPRB, 0.17665545E-05_JPRB, 0.17666264E-05_JPRB, 0.17667898E-05_JPRB, 0.17670532E-05_JPRB, &
  & 0.17673893E-05_JPRB, 0.17677625E-05_JPRB, 0.17681355E-05_JPRB, 0.17684785E-05_JPRB, 0.17687566E-05_JPRB, 0.17689434E-05_JPRB, &
  & 0.17690220E-05_JPRB, 0.17689804E-05_JPRB, 0.17688371E-05_JPRB, 0.17686507E-05_JPRB, 0.17684363E-05_JPRB, 0.17681929E-05_JPRB, &
  & 0.17679033E-05_JPRB, 0.17675715E-05_JPRB, 0.17671157E-05_JPRB, 0.17660545E-05_JPRB /)

RGHG2(:,72, 8) = (/ &
  & 0.17731411E-05_JPRB, 0.17739471E-05_JPRB, 0.17742964E-05_JPRB, 0.17745016E-05_JPRB, 0.17746449E-05_JPRB, 0.17747485E-05_JPRB, &
  & 0.17748259E-05_JPRB, 0.17748891E-05_JPRB, 0.17749446E-05_JPRB, 0.17749981E-05_JPRB, 0.17750341E-05_JPRB, 0.17750509E-05_JPRB, &
  & 0.17750251E-05_JPRB, 0.17749312E-05_JPRB, 0.17747442E-05_JPRB, 0.17744244E-05_JPRB, 0.17739409E-05_JPRB, 0.17732862E-05_JPRB, &
  & 0.17724500E-05_JPRB, 0.17714702E-05_JPRB, 0.17703996E-05_JPRB, 0.17693359E-05_JPRB, 0.17684060E-05_JPRB, 0.17677044E-05_JPRB, &
  & 0.17672895E-05_JPRB, 0.17671653E-05_JPRB, 0.17672878E-05_JPRB, 0.17675978E-05_JPRB, 0.17680343E-05_JPRB, 0.17685624E-05_JPRB, &
  & 0.17691390E-05_JPRB, 0.17696618E-05_JPRB, 0.17700153E-05_JPRB, 0.17701537E-05_JPRB, 0.17701141E-05_JPRB, 0.17699696E-05_JPRB, &
  & 0.17697522E-05_JPRB, 0.17694636E-05_JPRB, 0.17691199E-05_JPRB, 0.17687552E-05_JPRB, 0.17684367E-05_JPRB, 0.17682185E-05_JPRB, &
  & 0.17681019E-05_JPRB, 0.17680435E-05_JPRB, 0.17680452E-05_JPRB, 0.17681201E-05_JPRB, 0.17682785E-05_JPRB, 0.17685292E-05_JPRB, &
  & 0.17688475E-05_JPRB, 0.17691962E-05_JPRB, 0.17695437E-05_JPRB, 0.17698630E-05_JPRB, 0.17701256E-05_JPRB, 0.17703030E-05_JPRB, &
  & 0.17703849E-05_JPRB, 0.17703599E-05_JPRB, 0.17702406E-05_JPRB, 0.17700804E-05_JPRB, 0.17698932E-05_JPRB, 0.17696805E-05_JPRB, &
  & 0.17694185E-05_JPRB, 0.17691245E-05_JPRB, 0.17687080E-05_JPRB, 0.17677359E-05_JPRB /)

RGHG2(:,73, 8) = (/ &
  & 0.17738396E-05_JPRB, 0.17747205E-05_JPRB, 0.17750804E-05_JPRB, 0.17752916E-05_JPRB, 0.17754312E-05_JPRB, 0.17755344E-05_JPRB, &
  & 0.17756105E-05_JPRB, 0.17756664E-05_JPRB, 0.17757233E-05_JPRB, 0.17757588E-05_JPRB, 0.17757925E-05_JPRB, 0.17757993E-05_JPRB, &
  & 0.17757662E-05_JPRB, 0.17756756E-05_JPRB, 0.17755026E-05_JPRB, 0.17752102E-05_JPRB, 0.17747839E-05_JPRB, 0.17741970E-05_JPRB, &
  & 0.17734706E-05_JPRB, 0.17726077E-05_JPRB, 0.17716734E-05_JPRB, 0.17707423E-05_JPRB, 0.17699257E-05_JPRB, 0.17693008E-05_JPRB, &
  & 0.17689192E-05_JPRB, 0.17687885E-05_JPRB, 0.17688806E-05_JPRB, 0.17691435E-05_JPRB, 0.17695174E-05_JPRB, 0.17699751E-05_JPRB, &
  & 0.17704733E-05_JPRB, 0.17709260E-05_JPRB, 0.17712255E-05_JPRB, 0.17713350E-05_JPRB, 0.17712902E-05_JPRB, 0.17711584E-05_JPRB, &
  & 0.17709682E-05_JPRB, 0.17707198E-05_JPRB, 0.17704256E-05_JPRB, 0.17701143E-05_JPRB, 0.17698477E-05_JPRB, 0.17696738E-05_JPRB, &
  & 0.17695897E-05_JPRB, 0.17695546E-05_JPRB, 0.17695718E-05_JPRB, 0.17696505E-05_JPRB, 0.17698054E-05_JPRB, 0.17700436E-05_JPRB, &
  & 0.17703396E-05_JPRB, 0.17706609E-05_JPRB, 0.17709767E-05_JPRB, 0.17712703E-05_JPRB, 0.17715073E-05_JPRB, 0.17716768E-05_JPRB, &
  & 0.17717567E-05_JPRB, 0.17717468E-05_JPRB, 0.17716560E-05_JPRB, 0.17715258E-05_JPRB, 0.17713712E-05_JPRB, 0.17711895E-05_JPRB, &
  & 0.17709656E-05_JPRB, 0.17707005E-05_JPRB, 0.17703360E-05_JPRB, 0.17694392E-05_JPRB /)

RGHG2(:,74, 8) = (/ &
  & 0.17746236E-05_JPRB, 0.17755250E-05_JPRB, 0.17758871E-05_JPRB, 0.17760824E-05_JPRB, 0.17762183E-05_JPRB, 0.17763140E-05_JPRB, &
  & 0.17763834E-05_JPRB, 0.17764404E-05_JPRB, 0.17764816E-05_JPRB, 0.17765196E-05_JPRB, 0.17765374E-05_JPRB, 0.17765385E-05_JPRB, &
  & 0.17765037E-05_JPRB, 0.17764139E-05_JPRB, 0.17762567E-05_JPRB, 0.17759977E-05_JPRB, 0.17756197E-05_JPRB, 0.17751207E-05_JPRB, &
  & 0.17744882E-05_JPRB, 0.17737540E-05_JPRB, 0.17729576E-05_JPRB, 0.17721635E-05_JPRB, 0.17714658E-05_JPRB, 0.17709242E-05_JPRB, &
  & 0.17705821E-05_JPRB, 0.17704500E-05_JPRB, 0.17705136E-05_JPRB, 0.17707280E-05_JPRB, 0.17710371E-05_JPRB, 0.17714216E-05_JPRB, &
  & 0.17718385E-05_JPRB, 0.17722169E-05_JPRB, 0.17724634E-05_JPRB, 0.17725458E-05_JPRB, 0.17724994E-05_JPRB, 0.17723817E-05_JPRB, &
  & 0.17722206E-05_JPRB, 0.17720125E-05_JPRB, 0.17717682E-05_JPRB, 0.17715099E-05_JPRB, 0.17712955E-05_JPRB, 0.17711627E-05_JPRB, &
  & 0.17711075E-05_JPRB, 0.17710928E-05_JPRB, 0.17711234E-05_JPRB, 0.17712056E-05_JPRB, 0.17713533E-05_JPRB, 0.17715773E-05_JPRB, &
  & 0.17718462E-05_JPRB, 0.17721356E-05_JPRB, 0.17724169E-05_JPRB, 0.17726743E-05_JPRB, 0.17728878E-05_JPRB, 0.17730376E-05_JPRB, &
  & 0.17731167E-05_JPRB, 0.17731189E-05_JPRB, 0.17730531E-05_JPRB, 0.17729523E-05_JPRB, 0.17728320E-05_JPRB, 0.17726830E-05_JPRB, &
  & 0.17724939E-05_JPRB, 0.17722645E-05_JPRB, 0.17719432E-05_JPRB, 0.17711199E-05_JPRB /)

RGHG2(:,75, 8) = (/ &
  & 0.17754460E-05_JPRB, 0.17763464E-05_JPRB, 0.17766764E-05_JPRB, 0.17768580E-05_JPRB, 0.17769775E-05_JPRB, 0.17770643E-05_JPRB, &
  & 0.17771287E-05_JPRB, 0.17771746E-05_JPRB, 0.17772178E-05_JPRB, 0.17772394E-05_JPRB, 0.17772552E-05_JPRB, 0.17772526E-05_JPRB, &
  & 0.17772106E-05_JPRB, 0.17771308E-05_JPRB, 0.17769944E-05_JPRB, 0.17767702E-05_JPRB, 0.17764537E-05_JPRB, 0.17760334E-05_JPRB, &
  & 0.17755121E-05_JPRB, 0.17749019E-05_JPRB, 0.17742467E-05_JPRB, 0.17735906E-05_JPRB, 0.17730135E-05_JPRB, 0.17725579E-05_JPRB, &
  & 0.17722632E-05_JPRB, 0.17721366E-05_JPRB, 0.17721762E-05_JPRB, 0.17723427E-05_JPRB, 0.17725876E-05_JPRB, 0.17728985E-05_JPRB, &
  & 0.17732316E-05_JPRB, 0.17735372E-05_JPRB, 0.17737311E-05_JPRB, 0.17737904E-05_JPRB, 0.17737449E-05_JPRB, 0.17736431E-05_JPRB, &
  & 0.17735124E-05_JPRB, 0.17733454E-05_JPRB, 0.17731525E-05_JPRB, 0.17729474E-05_JPRB, 0.17727840E-05_JPRB, 0.17726868E-05_JPRB, &
  & 0.17726550E-05_JPRB, 0.17726554E-05_JPRB, 0.17726958E-05_JPRB, 0.17727762E-05_JPRB, 0.17729160E-05_JPRB, 0.17731172E-05_JPRB, &
  & 0.17733566E-05_JPRB, 0.17736088E-05_JPRB, 0.17738491E-05_JPRB, 0.17740709E-05_JPRB, 0.17742504E-05_JPRB, 0.17743845E-05_JPRB, &
  & 0.17744535E-05_JPRB, 0.17744636E-05_JPRB, 0.17744178E-05_JPRB, 0.17743441E-05_JPRB, 0.17742539E-05_JPRB, 0.17741377E-05_JPRB, &
  & 0.17739827E-05_JPRB, 0.17737900E-05_JPRB, 0.17735003E-05_JPRB, 0.17727540E-05_JPRB /)

RGHG2(:,76, 8) = (/ &
  & 0.17763085E-05_JPRB, 0.17771433E-05_JPRB, 0.17774458E-05_JPRB, 0.17775938E-05_JPRB, 0.17776982E-05_JPRB, 0.17777702E-05_JPRB, &
  & 0.17778239E-05_JPRB, 0.17778666E-05_JPRB, 0.17778959E-05_JPRB, 0.17779155E-05_JPRB, 0.17779206E-05_JPRB, 0.17779153E-05_JPRB, &
  & 0.17778800E-05_JPRB, 0.17778101E-05_JPRB, 0.17777016E-05_JPRB, 0.17775195E-05_JPRB, 0.17772668E-05_JPRB, 0.17769371E-05_JPRB, &
  & 0.17765240E-05_JPRB, 0.17760442E-05_JPRB, 0.17755300E-05_JPRB, 0.17750108E-05_JPRB, 0.17745559E-05_JPRB, 0.17741918E-05_JPRB, &
  & 0.17739509E-05_JPRB, 0.17738380E-05_JPRB, 0.17738597E-05_JPRB, 0.17739827E-05_JPRB, 0.17741651E-05_JPRB, 0.17744028E-05_JPRB, &
  & 0.17746553E-05_JPRB, 0.17748860E-05_JPRB, 0.17750314E-05_JPRB, 0.17750699E-05_JPRB, 0.17750297E-05_JPRB, 0.17749467E-05_JPRB, &
  & 0.17748473E-05_JPRB, 0.17747204E-05_JPRB, 0.17745781E-05_JPRB, 0.17744247E-05_JPRB, 0.17743107E-05_JPRB, 0.17742466E-05_JPRB, &
  & 0.17742314E-05_JPRB, 0.17742427E-05_JPRB, 0.17742883E-05_JPRB, 0.17743625E-05_JPRB, 0.17744858E-05_JPRB, 0.17746602E-05_JPRB, &
  & 0.17748589E-05_JPRB, 0.17750697E-05_JPRB, 0.17752641E-05_JPRB, 0.17754454E-05_JPRB, 0.17755908E-05_JPRB, 0.17757019E-05_JPRB, &
  & 0.17757608E-05_JPRB, 0.17757741E-05_JPRB, 0.17757428E-05_JPRB, 0.17756921E-05_JPRB, 0.17756316E-05_JPRB, 0.17755434E-05_JPRB, &
  & 0.17754253E-05_JPRB, 0.17752635E-05_JPRB, 0.17750202E-05_JPRB, 0.17743065E-05_JPRB /)

RGHG2(:,77, 8) = (/ &
  & 0.17771779E-05_JPRB, 0.17779204E-05_JPRB, 0.17781681E-05_JPRB, 0.17782841E-05_JPRB, 0.17783645E-05_JPRB, 0.17784208E-05_JPRB, &
  & 0.17784616E-05_JPRB, 0.17784915E-05_JPRB, 0.17785176E-05_JPRB, 0.17785241E-05_JPRB, 0.17785237E-05_JPRB, 0.17785226E-05_JPRB, &
  & 0.17784898E-05_JPRB, 0.17784394E-05_JPRB, 0.17783642E-05_JPRB, 0.17782273E-05_JPRB, 0.17780420E-05_JPRB, 0.17778026E-05_JPRB, &
  & 0.17775031E-05_JPRB, 0.17771524E-05_JPRB, 0.17767793E-05_JPRB, 0.17763974E-05_JPRB, 0.17760668E-05_JPRB, 0.17757988E-05_JPRB, &
  & 0.17756208E-05_JPRB, 0.17755301E-05_JPRB, 0.17755416E-05_JPRB, 0.17756279E-05_JPRB, 0.17757525E-05_JPRB, 0.17759215E-05_JPRB, &
  & 0.17760977E-05_JPRB, 0.17762607E-05_JPRB, 0.17763621E-05_JPRB, 0.17763865E-05_JPRB, 0.17763565E-05_JPRB, 0.17762949E-05_JPRB, &
  & 0.17762281E-05_JPRB, 0.17761395E-05_JPRB, 0.17760459E-05_JPRB, 0.17759411E-05_JPRB, 0.17758730E-05_JPRB, 0.17758347E-05_JPRB, &
  & 0.17758288E-05_JPRB, 0.17758438E-05_JPRB, 0.17758874E-05_JPRB, 0.17759475E-05_JPRB, 0.17760460E-05_JPRB, 0.17761794E-05_JPRB, &
  & 0.17763290E-05_JPRB, 0.17764904E-05_JPRB, 0.17766353E-05_JPRB, 0.17767715E-05_JPRB, 0.17768813E-05_JPRB, 0.17769685E-05_JPRB, &
  & 0.17770146E-05_JPRB, 0.17770302E-05_JPRB, 0.17770110E-05_JPRB, 0.17769808E-05_JPRB, 0.17769449E-05_JPRB, 0.17768849E-05_JPRB, &
  & 0.17767973E-05_JPRB, 0.17766780E-05_JPRB, 0.17764556E-05_JPRB, 0.17758188E-05_JPRB /)

RGHG2(:,78, 8) = (/ &
  & 0.17780598E-05_JPRB, 0.17786261E-05_JPRB, 0.17788013E-05_JPRB, 0.17788764E-05_JPRB, 0.17789364E-05_JPRB, 0.17789735E-05_JPRB, &
  & 0.17790019E-05_JPRB, 0.17790207E-05_JPRB, 0.17790381E-05_JPRB, 0.17790346E-05_JPRB, 0.17790296E-05_JPRB, 0.17790348E-05_JPRB, &
  & 0.17790130E-05_JPRB, 0.17789812E-05_JPRB, 0.17789383E-05_JPRB, 0.17788436E-05_JPRB, 0.17787216E-05_JPRB, 0.17785673E-05_JPRB, &
  & 0.17783707E-05_JPRB, 0.17781413E-05_JPRB, 0.17779014E-05_JPRB, 0.17776491E-05_JPRB, 0.17774432E-05_JPRB, 0.17772725E-05_JPRB, &
  & 0.17771665E-05_JPRB, 0.17771061E-05_JPRB, 0.17771184E-05_JPRB, 0.17771804E-05_JPRB, 0.17772568E-05_JPRB, 0.17773712E-05_JPRB, &
  & 0.17774820E-05_JPRB, 0.17775878E-05_JPRB, 0.17776522E-05_JPRB, 0.17776681E-05_JPRB, 0.17776526E-05_JPRB, 0.17776144E-05_JPRB, &
  & 0.17775793E-05_JPRB, 0.17775254E-05_JPRB, 0.17774737E-05_JPRB, 0.17774096E-05_JPRB, 0.17773795E-05_JPRB, 0.17773591E-05_JPRB, &
  & 0.17773528E-05_JPRB, 0.17773627E-05_JPRB, 0.17773962E-05_JPRB, 0.17774307E-05_JPRB, 0.17774944E-05_JPRB, 0.17775754E-05_JPRB, &
  & 0.17776661E-05_JPRB, 0.17777732E-05_JPRB, 0.17778626E-05_JPRB, 0.17779564E-05_JPRB, 0.17780259E-05_JPRB, 0.17780935E-05_JPRB, &
  & 0.17781251E-05_JPRB, 0.17781445E-05_JPRB, 0.17781342E-05_JPRB, 0.17781203E-05_JPRB, 0.17781061E-05_JPRB, 0.17780668E-05_JPRB, &
  & 0.17780100E-05_JPRB, 0.17779257E-05_JPRB, 0.17777722E-05_JPRB, 0.17772475E-05_JPRB /)

RGHG2(:,79, 8) = (/ &
  & 0.17786343E-05_JPRB, 0.17790247E-05_JPRB, 0.17791406E-05_JPRB, 0.17791848E-05_JPRB, 0.17792336E-05_JPRB, 0.17792615E-05_JPRB, &
  & 0.17792822E-05_JPRB, 0.17792944E-05_JPRB, 0.17793109E-05_JPRB, 0.17793008E-05_JPRB, 0.17792923E-05_JPRB, 0.17793034E-05_JPRB, &
  & 0.17792850E-05_JPRB, 0.17792636E-05_JPRB, 0.17792388E-05_JPRB, 0.17791651E-05_JPRB, 0.17790762E-05_JPRB, 0.17789657E-05_JPRB, &
  & 0.17788269E-05_JPRB, 0.17786601E-05_JPRB, 0.17784924E-05_JPRB, 0.17783099E-05_JPRB, 0.17781717E-05_JPRB, 0.17780567E-05_JPRB, &
  & 0.17779918E-05_JPRB, 0.17779503E-05_JPRB, 0.17779664E-05_JPRB, 0.17780185E-05_JPRB, 0.17780696E-05_JPRB, 0.17781554E-05_JPRB, &
  & 0.17782323E-05_JPRB, 0.17783068E-05_JPRB, 0.17783505E-05_JPRB, 0.17783626E-05_JPRB, 0.17783550E-05_JPRB, 0.17783271E-05_JPRB, &
  & 0.17783080E-05_JPRB, 0.17782709E-05_JPRB, 0.17782404E-05_JPRB, 0.17781949E-05_JPRB, 0.17781837E-05_JPRB, 0.17781700E-05_JPRB, &
  & 0.17781590E-05_JPRB, 0.17781633E-05_JPRB, 0.17781886E-05_JPRB, 0.17782072E-05_JPRB, 0.17782489E-05_JPRB, 0.17783004E-05_JPRB, &
  & 0.17783572E-05_JPRB, 0.17784342E-05_JPRB, 0.17784929E-05_JPRB, 0.17785604E-05_JPRB, 0.17786106E-05_JPRB, 0.17786663E-05_JPRB, &
  & 0.17786908E-05_JPRB, 0.17787115E-05_JPRB, 0.17787052E-05_JPRB, 0.17786997E-05_JPRB, 0.17786971E-05_JPRB, 0.17786683E-05_JPRB, &
  & 0.17786271E-05_JPRB, 0.17785811E-05_JPRB, 0.17784860E-05_JPRB, 0.17781502E-05_JPRB /)

RGHG2(:,80, 8) = (/ &
  & 0.17790195E-05_JPRB, 0.17792180E-05_JPRB, 0.17792897E-05_JPRB, 0.17793187E-05_JPRB, 0.17793622E-05_JPRB, 0.17793852E-05_JPRB, &
  & 0.17794040E-05_JPRB, 0.17794130E-05_JPRB, 0.17794308E-05_JPRB, 0.17794180E-05_JPRB, 0.17794081E-05_JPRB, 0.17794223E-05_JPRB, &
  & 0.17794055E-05_JPRB, 0.17793891E-05_JPRB, 0.17793732E-05_JPRB, 0.17793086E-05_JPRB, 0.17792343E-05_JPRB, 0.17791464E-05_JPRB, &
  & 0.17790318E-05_JPRB, 0.17788951E-05_JPRB, 0.17787600E-05_JPRB, 0.17786062E-05_JPRB, 0.17785004E-05_JPRB, 0.17784091E-05_JPRB, &
  & 0.17783639E-05_JPRB, 0.17783309E-05_JPRB, 0.17783500E-05_JPRB, 0.17783987E-05_JPRB, 0.17784384E-05_JPRB, 0.17785127E-05_JPRB, &
  & 0.17785737E-05_JPRB, 0.17786341E-05_JPRB, 0.17786688E-05_JPRB, 0.17786788E-05_JPRB, 0.17786747E-05_JPRB, 0.17786512E-05_JPRB, &
  & 0.17786388E-05_JPRB, 0.17786076E-05_JPRB, 0.17785860E-05_JPRB, 0.17785483E-05_JPRB, 0.17785446E-05_JPRB, 0.17785324E-05_JPRB, &
  & 0.17785177E-05_JPRB, 0.17785179E-05_JPRB, 0.17785392E-05_JPRB, 0.17785496E-05_JPRB, 0.17785827E-05_JPRB, 0.17786210E-05_JPRB, &
  & 0.17786622E-05_JPRB, 0.17787266E-05_JPRB, 0.17787685E-05_JPRB, 0.17788252E-05_JPRB, 0.17788636E-05_JPRB, 0.17789157E-05_JPRB, &
  & 0.17789347E-05_JPRB, 0.17789554E-05_JPRB, 0.17789482E-05_JPRB, 0.17789458E-05_JPRB, 0.17789488E-05_JPRB, 0.17789238E-05_JPRB, &
  & 0.17788918E-05_JPRB, 0.17788637E-05_JPRB, 0.17788254E-05_JPRB, 0.17787331E-05_JPRB /)

RGHG2(:,81, 8) = (/ &
  & 0.17792863E-05_JPRB, 0.17792997E-05_JPRB, 0.17793524E-05_JPRB, 0.17793748E-05_JPRB, 0.17794171E-05_JPRB, 0.17794392E-05_JPRB, &
  & 0.17794559E-05_JPRB, 0.17794664E-05_JPRB, 0.17794823E-05_JPRB, 0.17794673E-05_JPRB, 0.17794587E-05_JPRB, 0.17794750E-05_JPRB, &
  & 0.17794588E-05_JPRB, 0.17794443E-05_JPRB, 0.17794323E-05_JPRB, 0.17793720E-05_JPRB, 0.17793054E-05_JPRB, 0.17792261E-05_JPRB, &
  & 0.17791250E-05_JPRB, 0.17789996E-05_JPRB, 0.17788796E-05_JPRB, 0.17787378E-05_JPRB, 0.17786460E-05_JPRB, 0.17785646E-05_JPRB, &
  & 0.17785279E-05_JPRB, 0.17784979E-05_JPRB, 0.17785187E-05_JPRB, 0.17785663E-05_JPRB, 0.17786018E-05_JPRB, 0.17786703E-05_JPRB, &
  & 0.17787243E-05_JPRB, 0.17787785E-05_JPRB, 0.17788091E-05_JPRB, 0.17788185E-05_JPRB, 0.17788162E-05_JPRB, 0.17787939E-05_JPRB, &
  & 0.17787842E-05_JPRB, 0.17787555E-05_JPRB, 0.17787374E-05_JPRB, 0.17787029E-05_JPRB, 0.17787028E-05_JPRB, 0.17786909E-05_JPRB, &
  & 0.17786740E-05_JPRB, 0.17786718E-05_JPRB, 0.17786911E-05_JPRB, 0.17786986E-05_JPRB, 0.17787286E-05_JPRB, 0.17787618E-05_JPRB, &
  & 0.17787960E-05_JPRB, 0.17788550E-05_JPRB, 0.17788897E-05_JPRB, 0.17789406E-05_JPRB, 0.17789736E-05_JPRB, 0.17790242E-05_JPRB, &
  & 0.17790396E-05_JPRB, 0.17790605E-05_JPRB, 0.17790517E-05_JPRB, 0.17790499E-05_JPRB, 0.17790557E-05_JPRB, 0.17790322E-05_JPRB, &
  & 0.17790030E-05_JPRB, 0.17789828E-05_JPRB, 0.17789660E-05_JPRB, 0.17791283E-05_JPRB /)

RGHG2(:,82, 8) = (/ &
  & 0.17793071E-05_JPRB, 0.17793270E-05_JPRB, 0.17793801E-05_JPRB, 0.17794014E-05_JPRB, 0.17794439E-05_JPRB, 0.17794648E-05_JPRB, &
  & 0.17794819E-05_JPRB, 0.17794886E-05_JPRB, 0.17795063E-05_JPRB, 0.17794953E-05_JPRB, 0.17794848E-05_JPRB, 0.17794993E-05_JPRB, &
  & 0.17794841E-05_JPRB, 0.17794714E-05_JPRB, 0.17794621E-05_JPRB, 0.17794035E-05_JPRB, 0.17793402E-05_JPRB, 0.17792672E-05_JPRB, &
  & 0.17791708E-05_JPRB, 0.17790521E-05_JPRB, 0.17789395E-05_JPRB, 0.17788025E-05_JPRB, 0.17787179E-05_JPRB, 0.17786406E-05_JPRB, &
  & 0.17786080E-05_JPRB, 0.17785790E-05_JPRB, 0.17786006E-05_JPRB, 0.17786490E-05_JPRB, 0.17786816E-05_JPRB, 0.17787477E-05_JPRB, &
  & 0.17787980E-05_JPRB, 0.17788489E-05_JPRB, 0.17788775E-05_JPRB, 0.17788864E-05_JPRB, 0.17788853E-05_JPRB, 0.17788636E-05_JPRB, &
  & 0.17788552E-05_JPRB, 0.17788273E-05_JPRB, 0.17788115E-05_JPRB, 0.17787786E-05_JPRB, 0.17787796E-05_JPRB, 0.17787680E-05_JPRB, &
  & 0.17787503E-05_JPRB, 0.17787469E-05_JPRB, 0.17787654E-05_JPRB, 0.17787714E-05_JPRB, 0.17787999E-05_JPRB, 0.17788308E-05_JPRB, &
  & 0.17788619E-05_JPRB, 0.17789184E-05_JPRB, 0.17789487E-05_JPRB, 0.17789974E-05_JPRB, 0.17790275E-05_JPRB, 0.17790776E-05_JPRB, &
  & 0.17790913E-05_JPRB, 0.17791116E-05_JPRB, 0.17791012E-05_JPRB, 0.17790999E-05_JPRB, 0.17791074E-05_JPRB, 0.17790843E-05_JPRB, &
  & 0.17790557E-05_JPRB, 0.17790351E-05_JPRB, 0.17790131E-05_JPRB, 0.17791604E-05_JPRB /)

RGHG2(:,83, 8) = (/ &
  & 0.17793218E-05_JPRB, 0.17793431E-05_JPRB, 0.17793959E-05_JPRB, 0.17794162E-05_JPRB, 0.17794586E-05_JPRB, 0.17794798E-05_JPRB, &
  & 0.17794953E-05_JPRB, 0.17795071E-05_JPRB, 0.17795195E-05_JPRB, 0.17795051E-05_JPRB, 0.17794987E-05_JPRB, 0.17795135E-05_JPRB, &
  & 0.17794996E-05_JPRB, 0.17794869E-05_JPRB, 0.17794783E-05_JPRB, 0.17794218E-05_JPRB, 0.17793602E-05_JPRB, 0.17792900E-05_JPRB, &
  & 0.17791974E-05_JPRB, 0.17790818E-05_JPRB, 0.17789738E-05_JPRB, 0.17788384E-05_JPRB, 0.17787593E-05_JPRB, 0.17786825E-05_JPRB, &
  & 0.17786526E-05_JPRB, 0.17786235E-05_JPRB, 0.17786472E-05_JPRB, 0.17786947E-05_JPRB, 0.17787268E-05_JPRB, 0.17787905E-05_JPRB, &
  & 0.17788391E-05_JPRB, 0.17788877E-05_JPRB, 0.17789154E-05_JPRB, 0.17789245E-05_JPRB, 0.17789235E-05_JPRB, 0.17789023E-05_JPRB, &
  & 0.17788946E-05_JPRB, 0.17788670E-05_JPRB, 0.17788518E-05_JPRB, 0.17788208E-05_JPRB, 0.17788225E-05_JPRB, 0.17788112E-05_JPRB, &
  & 0.17787928E-05_JPRB, 0.17787885E-05_JPRB, 0.17788068E-05_JPRB, 0.17788119E-05_JPRB, 0.17788401E-05_JPRB, 0.17788694E-05_JPRB, &
  & 0.17788990E-05_JPRB, 0.17789544E-05_JPRB, 0.17789821E-05_JPRB, 0.17790295E-05_JPRB, 0.17790574E-05_JPRB, 0.17791078E-05_JPRB, &
  & 0.17791199E-05_JPRB, 0.17791403E-05_JPRB, 0.17791289E-05_JPRB, 0.17791274E-05_JPRB, 0.17791361E-05_JPRB, 0.17791136E-05_JPRB, &
  & 0.17790850E-05_JPRB, 0.17790651E-05_JPRB, 0.17790400E-05_JPRB, 0.17791824E-05_JPRB /)

RGHG2(:,84, 8) = (/ &
  & 0.17793320E-05_JPRB, 0.17793534E-05_JPRB, 0.17794059E-05_JPRB, 0.17794250E-05_JPRB, 0.17794681E-05_JPRB, 0.17794883E-05_JPRB, &
  & 0.17795053E-05_JPRB, 0.17795114E-05_JPRB, 0.17795262E-05_JPRB, 0.17795185E-05_JPRB, 0.17795101E-05_JPRB, 0.17795194E-05_JPRB, &
  & 0.17795072E-05_JPRB, 0.17794964E-05_JPRB, 0.17794864E-05_JPRB, 0.17794332E-05_JPRB, 0.17793734E-05_JPRB, 0.17793047E-05_JPRB, &
  & 0.17792144E-05_JPRB, 0.17791006E-05_JPRB, 0.17789949E-05_JPRB, 0.17788612E-05_JPRB, 0.17787842E-05_JPRB, 0.17787085E-05_JPRB, &
  & 0.17786806E-05_JPRB, 0.17786505E-05_JPRB, 0.17786739E-05_JPRB, 0.17787241E-05_JPRB, 0.17787537E-05_JPRB, 0.17788177E-05_JPRB, &
  & 0.17788644E-05_JPRB, 0.17789121E-05_JPRB, 0.17789387E-05_JPRB, 0.17789475E-05_JPRB, 0.17789473E-05_JPRB, 0.17789259E-05_JPRB, &
  & 0.17789188E-05_JPRB, 0.17788909E-05_JPRB, 0.17788770E-05_JPRB, 0.17788466E-05_JPRB, 0.17788490E-05_JPRB, 0.17788379E-05_JPRB, &
  & 0.17788194E-05_JPRB, 0.17788143E-05_JPRB, 0.17788315E-05_JPRB, 0.17788368E-05_JPRB, 0.17788640E-05_JPRB, 0.17788936E-05_JPRB, &
  & 0.17789217E-05_JPRB, 0.17789764E-05_JPRB, 0.17790024E-05_JPRB, 0.17790492E-05_JPRB, 0.17790754E-05_JPRB, 0.17791264E-05_JPRB, &
  & 0.17791381E-05_JPRB, 0.17791581E-05_JPRB, 0.17791458E-05_JPRB, 0.17791442E-05_JPRB, 0.17791544E-05_JPRB, 0.17791315E-05_JPRB, &
  & 0.17791032E-05_JPRB, 0.17790840E-05_JPRB, 0.17790578E-05_JPRB, 0.17791972E-05_JPRB /)

RGHG2(:,85, 8) = (/ &
  & 0.17793386E-05_JPRB, 0.17793602E-05_JPRB, 0.17794123E-05_JPRB, 0.17794312E-05_JPRB, 0.17794744E-05_JPRB, 0.17794964E-05_JPRB, &
  & 0.17795098E-05_JPRB, 0.17795213E-05_JPRB, 0.17795289E-05_JPRB, 0.17795198E-05_JPRB, 0.17795157E-05_JPRB, 0.17795219E-05_JPRB, &
  & 0.17795130E-05_JPRB, 0.17795014E-05_JPRB, 0.17794889E-05_JPRB, 0.17794401E-05_JPRB, 0.17793838E-05_JPRB, 0.17793158E-05_JPRB, &
  & 0.17792270E-05_JPRB, 0.17791131E-05_JPRB, 0.17790102E-05_JPRB, 0.17788753E-05_JPRB, 0.17788012E-05_JPRB, 0.17787250E-05_JPRB, &
  & 0.17786981E-05_JPRB, 0.17786670E-05_JPRB, 0.17786929E-05_JPRB, 0.17787413E-05_JPRB, 0.17787723E-05_JPRB, 0.17788341E-05_JPRB, &
  & 0.17788809E-05_JPRB, 0.17789273E-05_JPRB, 0.17789532E-05_JPRB, 0.17789623E-05_JPRB, 0.17789621E-05_JPRB, 0.17789412E-05_JPRB, &
  & 0.17789338E-05_JPRB, 0.17789066E-05_JPRB, 0.17788927E-05_JPRB, 0.17788630E-05_JPRB, 0.17788659E-05_JPRB, 0.17788557E-05_JPRB, &
  & 0.17788360E-05_JPRB, 0.17788303E-05_JPRB, 0.17788482E-05_JPRB, 0.17788527E-05_JPRB, 0.17788806E-05_JPRB, 0.17789091E-05_JPRB, &
  & 0.17789368E-05_JPRB, 0.17789905E-05_JPRB, 0.17790157E-05_JPRB, 0.17790624E-05_JPRB, 0.17790876E-05_JPRB, 0.17791384E-05_JPRB, &
  & 0.17791494E-05_JPRB, 0.17791697E-05_JPRB, 0.17791566E-05_JPRB, 0.17791551E-05_JPRB, 0.17791656E-05_JPRB, 0.17791431E-05_JPRB, &
  & 0.17791150E-05_JPRB, 0.17790962E-05_JPRB, 0.17790692E-05_JPRB, 0.17792071E-05_JPRB /)

RGHG2(:,86, 8) = (/ &
  & 0.17793432E-05_JPRB, 0.17793649E-05_JPRB, 0.17794165E-05_JPRB, 0.17794348E-05_JPRB, 0.17794802E-05_JPRB, 0.17794982E-05_JPRB, &
  & 0.17795159E-05_JPRB, 0.17795210E-05_JPRB, 0.17795293E-05_JPRB, 0.17795245E-05_JPRB, 0.17795192E-05_JPRB, 0.17795209E-05_JPRB, &
  & 0.17795126E-05_JPRB, 0.17795019E-05_JPRB, 0.17794860E-05_JPRB, 0.17794459E-05_JPRB, 0.17793907E-05_JPRB, 0.17793254E-05_JPRB, &
  & 0.17792372E-05_JPRB, 0.17791248E-05_JPRB, 0.17790196E-05_JPRB, 0.17788857E-05_JPRB, 0.17788118E-05_JPRB, 0.17787359E-05_JPRB, &
  & 0.17787104E-05_JPRB, 0.17786766E-05_JPRB, 0.17787015E-05_JPRB, 0.17787540E-05_JPRB, 0.17787816E-05_JPRB, 0.17788462E-05_JPRB, &
  & 0.17788913E-05_JPRB, 0.17789374E-05_JPRB, 0.17789630E-05_JPRB, 0.17789719E-05_JPRB, 0.17789719E-05_JPRB, 0.17789508E-05_JPRB, &
  & 0.17789441E-05_JPRB, 0.17789160E-05_JPRB, 0.17789031E-05_JPRB, 0.17788727E-05_JPRB, 0.17788769E-05_JPRB, 0.17788664E-05_JPRB, &
  & 0.17788470E-05_JPRB, 0.17788408E-05_JPRB, 0.17788582E-05_JPRB, 0.17788636E-05_JPRB, 0.17788902E-05_JPRB, 0.17789195E-05_JPRB, &
  & 0.17789464E-05_JPRB, 0.17789991E-05_JPRB, 0.17790244E-05_JPRB, 0.17790705E-05_JPRB, 0.17790950E-05_JPRB, 0.17791459E-05_JPRB, &
  & 0.17791568E-05_JPRB, 0.17791771E-05_JPRB, 0.17791633E-05_JPRB, 0.17791618E-05_JPRB, 0.17791734E-05_JPRB, 0.17791507E-05_JPRB, &
  & 0.17791231E-05_JPRB, 0.17791045E-05_JPRB, 0.17790762E-05_JPRB, 0.17792139E-05_JPRB /)

RGHG2(:,87, 8) = (/ &
  & 0.17793459E-05_JPRB, 0.17793682E-05_JPRB, 0.17794192E-05_JPRB, 0.17794390E-05_JPRB, 0.17794799E-05_JPRB, 0.17795048E-05_JPRB, &
  & 0.17795152E-05_JPRB, 0.17795242E-05_JPRB, 0.17795285E-05_JPRB, 0.17795232E-05_JPRB, 0.17795197E-05_JPRB, 0.17795194E-05_JPRB, &
  & 0.17795116E-05_JPRB, 0.17795001E-05_JPRB, 0.17794844E-05_JPRB, 0.17794457E-05_JPRB, 0.17793968E-05_JPRB, 0.17793318E-05_JPRB, &
  & 0.17792463E-05_JPRB, 0.17791327E-05_JPRB, 0.17790284E-05_JPRB, 0.17788917E-05_JPRB, 0.17788188E-05_JPRB, 0.17787422E-05_JPRB, &
  & 0.17787177E-05_JPRB, 0.17786821E-05_JPRB, 0.17787080E-05_JPRB, 0.17787601E-05_JPRB, 0.17787886E-05_JPRB, 0.17788533E-05_JPRB, &
  & 0.17788981E-05_JPRB, 0.17789441E-05_JPRB, 0.17789691E-05_JPRB, 0.17789781E-05_JPRB, 0.17789782E-05_JPRB, 0.17789567E-05_JPRB, &
  & 0.17789509E-05_JPRB, 0.17789223E-05_JPRB, 0.17789100E-05_JPRB, 0.17788781E-05_JPRB, 0.17788843E-05_JPRB, 0.17788739E-05_JPRB, &
  & 0.17788522E-05_JPRB, 0.17788459E-05_JPRB, 0.17788655E-05_JPRB, 0.17788699E-05_JPRB, 0.17788971E-05_JPRB, 0.17789254E-05_JPRB, &
  & 0.17789525E-05_JPRB, 0.17790038E-05_JPRB, 0.17790294E-05_JPRB, 0.17790751E-05_JPRB, 0.17790994E-05_JPRB, 0.17791505E-05_JPRB, &
  & 0.17791615E-05_JPRB, 0.17791816E-05_JPRB, 0.17791673E-05_JPRB, 0.17791654E-05_JPRB, 0.17791779E-05_JPRB, 0.17791556E-05_JPRB, &
  & 0.17791276E-05_JPRB, 0.17791091E-05_JPRB, 0.17790802E-05_JPRB, 0.17792187E-05_JPRB /)

RGHG2(:,88, 8) = (/ &
  & 0.17793486E-05_JPRB, 0.17793724E-05_JPRB, 0.17794197E-05_JPRB, 0.17794387E-05_JPRB, 0.17794852E-05_JPRB, 0.17795019E-05_JPRB, &
  & 0.17795187E-05_JPRB, 0.17795232E-05_JPRB, 0.17795287E-05_JPRB, 0.17795245E-05_JPRB, 0.17795198E-05_JPRB, 0.17795189E-05_JPRB, &
  & 0.17795107E-05_JPRB, 0.17794996E-05_JPRB, 0.17794827E-05_JPRB, 0.17794480E-05_JPRB, 0.17793978E-05_JPRB, 0.17793362E-05_JPRB, &
  & 0.17792498E-05_JPRB, 0.17791388E-05_JPRB, 0.17790314E-05_JPRB, 0.17788963E-05_JPRB, 0.17788230E-05_JPRB, 0.17787461E-05_JPRB, &
  & 0.17787223E-05_JPRB, 0.17786849E-05_JPRB, 0.17787106E-05_JPRB, 0.17787655E-05_JPRB, 0.17787906E-05_JPRB, 0.17788589E-05_JPRB, &
  & 0.17789021E-05_JPRB, 0.17789487E-05_JPRB, 0.17789735E-05_JPRB, 0.17789821E-05_JPRB, 0.17789826E-05_JPRB, 0.17789606E-05_JPRB, &
  & 0.17789553E-05_JPRB, 0.17789257E-05_JPRB, 0.17789146E-05_JPRB, 0.17788802E-05_JPRB, 0.17788896E-05_JPRB, 0.17788785E-05_JPRB, &
  & 0.17788557E-05_JPRB, 0.17788489E-05_JPRB, 0.17788693E-05_JPRB, 0.17788742E-05_JPRB, 0.17789006E-05_JPRB, 0.17789293E-05_JPRB, &
  & 0.17789564E-05_JPRB, 0.17790069E-05_JPRB, 0.17790323E-05_JPRB, 0.17790776E-05_JPRB, 0.17791019E-05_JPRB, 0.17791532E-05_JPRB, &
  & 0.17791642E-05_JPRB, 0.17791846E-05_JPRB, 0.17791700E-05_JPRB, 0.17791681E-05_JPRB, 0.17791813E-05_JPRB, 0.17791583E-05_JPRB, &
  & 0.17791306E-05_JPRB, 0.17791126E-05_JPRB, 0.17790828E-05_JPRB, 0.17792211E-05_JPRB /)

RGHG2(:,89, 8) = (/ &
  & 0.17793523E-05_JPRB, 0.17793760E-05_JPRB, 0.17794193E-05_JPRB, 0.17794399E-05_JPRB, 0.17794816E-05_JPRB, 0.17795062E-05_JPRB, &
  & 0.17795173E-05_JPRB, 0.17795267E-05_JPRB, 0.17795317E-05_JPRB, 0.17795255E-05_JPRB, 0.17795214E-05_JPRB, 0.17795217E-05_JPRB, &
  & 0.17795139E-05_JPRB, 0.17795024E-05_JPRB, 0.17794870E-05_JPRB, 0.17794484E-05_JPRB, 0.17793997E-05_JPRB, 0.17793353E-05_JPRB, &
  & 0.17792504E-05_JPRB, 0.17791369E-05_JPRB, 0.17790339E-05_JPRB, 0.17788965E-05_JPRB, 0.17788250E-05_JPRB, 0.17787477E-05_JPRB, &
  & 0.17787247E-05_JPRB, 0.17786861E-05_JPRB, 0.17787123E-05_JPRB, 0.17787676E-05_JPRB, 0.17787924E-05_JPRB, 0.17788614E-05_JPRB, &
  & 0.17789043E-05_JPRB, 0.17789516E-05_JPRB, 0.17789762E-05_JPRB, 0.17789846E-05_JPRB, 0.17789851E-05_JPRB, 0.17789623E-05_JPRB, &
  & 0.17789580E-05_JPRB, 0.17789273E-05_JPRB, 0.17789175E-05_JPRB, 0.17788802E-05_JPRB, 0.17788926E-05_JPRB, 0.17788818E-05_JPRB, &
  & 0.17788565E-05_JPRB, 0.17788497E-05_JPRB, 0.17788725E-05_JPRB, 0.17788765E-05_JPRB, 0.17789033E-05_JPRB, 0.17789318E-05_JPRB, &
  & 0.17789584E-05_JPRB, 0.17790082E-05_JPRB, 0.17790339E-05_JPRB, 0.17790785E-05_JPRB, 0.17791033E-05_JPRB, 0.17791546E-05_JPRB, &
  & 0.17791654E-05_JPRB, 0.17791863E-05_JPRB, 0.17791709E-05_JPRB, 0.17791691E-05_JPRB, 0.17791831E-05_JPRB, 0.17791599E-05_JPRB, &
  & 0.17791320E-05_JPRB, 0.17791144E-05_JPRB, 0.17790838E-05_JPRB, 0.17792233E-05_JPRB /)

RGHG2(:,90, 8) = (/ &
  & 0.17793553E-05_JPRB, 0.17793803E-05_JPRB, 0.17794165E-05_JPRB, 0.17794371E-05_JPRB, 0.17794835E-05_JPRB, 0.17795016E-05_JPRB, &
  & 0.17795195E-05_JPRB, 0.17795257E-05_JPRB, 0.17795360E-05_JPRB, 0.17795285E-05_JPRB, 0.17795230E-05_JPRB, 0.17795264E-05_JPRB, &
  & 0.17795178E-05_JPRB, 0.17795071E-05_JPRB, 0.17794925E-05_JPRB, 0.17794516E-05_JPRB, 0.17793969E-05_JPRB, 0.17793336E-05_JPRB, &
  & 0.17792466E-05_JPRB, 0.17791339E-05_JPRB, 0.17790328E-05_JPRB, 0.17788952E-05_JPRB, 0.17788257E-05_JPRB, 0.17787470E-05_JPRB, &
  & 0.17787264E-05_JPRB, 0.17786850E-05_JPRB, 0.17787121E-05_JPRB, 0.17787693E-05_JPRB, 0.17787912E-05_JPRB, 0.17788634E-05_JPRB, &
  & 0.17789051E-05_JPRB, 0.17789534E-05_JPRB, 0.17789779E-05_JPRB, 0.17789861E-05_JPRB, 0.17789874E-05_JPRB, 0.17789628E-05_JPRB, &
  & 0.17789592E-05_JPRB, 0.17789274E-05_JPRB, 0.17789196E-05_JPRB, 0.17788791E-05_JPRB, 0.17788946E-05_JPRB, 0.17788838E-05_JPRB, &
  & 0.17788565E-05_JPRB, 0.17788489E-05_JPRB, 0.17788740E-05_JPRB, 0.17788764E-05_JPRB, 0.17789043E-05_JPRB, 0.17789331E-05_JPRB, &
  & 0.17789589E-05_JPRB, 0.17790102E-05_JPRB, 0.17790342E-05_JPRB, 0.17790801E-05_JPRB, 0.17791035E-05_JPRB, 0.17791564E-05_JPRB, &
  & 0.17791663E-05_JPRB, 0.17791881E-05_JPRB, 0.17791710E-05_JPRB, 0.17791695E-05_JPRB, 0.17791849E-05_JPRB, 0.17791610E-05_JPRB, &
  & 0.17791326E-05_JPRB, 0.17791148E-05_JPRB, 0.17790830E-05_JPRB, 0.17792250E-05_JPRB /)

RGHG2(:,91, 8) = (/ &
  & 0.17793544E-05_JPRB, 0.17793833E-05_JPRB, 0.17794105E-05_JPRB, 0.17794345E-05_JPRB, 0.17794844E-05_JPRB, 0.17795015E-05_JPRB, &
  & 0.17795182E-05_JPRB, 0.17795232E-05_JPRB, 0.17795541E-05_JPRB, 0.17795264E-05_JPRB, 0.17795119E-05_JPRB, 0.17795425E-05_JPRB, &
  & 0.17795213E-05_JPRB, 0.17795099E-05_JPRB, 0.17795128E-05_JPRB, 0.17794493E-05_JPRB, 0.17793916E-05_JPRB, 0.17793300E-05_JPRB, &
  & 0.17792440E-05_JPRB, 0.17791284E-05_JPRB, 0.17790344E-05_JPRB, 0.17788901E-05_JPRB, 0.17788263E-05_JPRB, 0.17787436E-05_JPRB, &
  & 0.17787277E-05_JPRB, 0.17786806E-05_JPRB, 0.17787102E-05_JPRB, 0.17787719E-05_JPRB, 0.17787872E-05_JPRB, 0.17788650E-05_JPRB, &
  & 0.17789054E-05_JPRB, 0.17789556E-05_JPRB, 0.17789803E-05_JPRB, 0.17789874E-05_JPRB, 0.17789897E-05_JPRB, 0.17789614E-05_JPRB, &
  & 0.17789617E-05_JPRB, 0.17789262E-05_JPRB, 0.17789222E-05_JPRB, 0.17788752E-05_JPRB, 0.17788969E-05_JPRB, 0.17788857E-05_JPRB, &
  & 0.17788548E-05_JPRB, 0.17788452E-05_JPRB, 0.17788768E-05_JPRB, 0.17788735E-05_JPRB, 0.17789043E-05_JPRB, 0.17789348E-05_JPRB, &
  & 0.17789563E-05_JPRB, 0.17790146E-05_JPRB, 0.17790330E-05_JPRB, 0.17790829E-05_JPRB, 0.17791021E-05_JPRB, 0.17791604E-05_JPRB, &
  & 0.17791662E-05_JPRB, 0.17791911E-05_JPRB, 0.17791704E-05_JPRB, 0.17791682E-05_JPRB, 0.17791878E-05_JPRB, 0.17791612E-05_JPRB, &
  & 0.17791315E-05_JPRB, 0.17791151E-05_JPRB, 0.17790796E-05_JPRB, 0.17792280E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART16',1,ZHOOK_HANDLE)
END SUBROUTINE PART16






SUBROUTINE PART17
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART17',0,ZHOOK_HANDLE)



!-- Month=  9 ------------

RGHG2(:, 1, 9) = (/ &
  & 0.52618621E-08_JPRB, 0.52497269E-08_JPRB, 0.52331588E-08_JPRB, 0.52221956E-08_JPRB, 0.52294578E-08_JPRB, 0.52671352E-08_JPRB, &
  & 0.53487872E-08_JPRB, 0.54873603E-08_JPRB, 0.56936846E-08_JPRB, 0.59741287E-08_JPRB, 0.63260845E-08_JPRB, 0.67330124E-08_JPRB, &
  & 0.71556503E-08_JPRB, 0.75507591E-08_JPRB, 0.79194269E-08_JPRB, 0.82493363E-08_JPRB, 0.85132132E-08_JPRB, 0.86780521E-08_JPRB, &
  & 0.87123517E-08_JPRB, 0.85954257E-08_JPRB, 0.83193044E-08_JPRB, 0.79218108E-08_JPRB, 0.74205211E-08_JPRB, 0.67624448E-08_JPRB, &
  & 0.59989964E-08_JPRB, 0.51948508E-08_JPRB, 0.44473452E-08_JPRB, 0.38200567E-08_JPRB, 0.36395196E-08_JPRB, 0.39612291E-08_JPRB, &
  & 0.46175002E-08_JPRB, 0.55448806E-08_JPRB, 0.66533152E-08_JPRB, 0.78277527E-08_JPRB, 0.90040855E-08_JPRB, 0.10129971E-07_JPRB, &
  & 0.11183746E-07_JPRB, 0.12192120E-07_JPRB, 0.13211324E-07_JPRB, 0.14181953E-07_JPRB, 0.14866300E-07_JPRB, 0.15149206E-07_JPRB, &
  & 0.15263272E-07_JPRB, 0.15228940E-07_JPRB, 0.15034090E-07_JPRB, 0.14665649E-07_JPRB, 0.14110390E-07_JPRB, 0.13366494E-07_JPRB, &
  & 0.12461627E-07_JPRB, 0.11427141E-07_JPRB, 0.10384081E-07_JPRB, 0.94354871E-08_JPRB, 0.86224983E-08_JPRB, 0.79847924E-08_JPRB, &
  & 0.74695272E-08_JPRB, 0.70573698E-08_JPRB, 0.67092332E-08_JPRB, 0.63891261E-08_JPRB, 0.60915775E-08_JPRB, 0.58218257E-08_JPRB, &
  & 0.55850848E-08_JPRB, 0.53860627E-08_JPRB, 0.52562301E-08_JPRB, 0.52203561E-08_JPRB /)

RGHG2(:, 2, 9) = (/ &
  & 0.79801721E-08_JPRB, 0.84693248E-08_JPRB, 0.89381711E-08_JPRB, 0.94777608E-08_JPRB, 0.10101060E-07_JPRB, 0.10801318E-07_JPRB, &
  & 0.11566842E-07_JPRB, 0.12365414E-07_JPRB, 0.13167686E-07_JPRB, 0.13982818E-07_JPRB, 0.14864369E-07_JPRB, 0.15859456E-07_JPRB, &
  & 0.16959955E-07_JPRB, 0.18108162E-07_JPRB, 0.19223295E-07_JPRB, 0.20239415E-07_JPRB, 0.21092371E-07_JPRB, 0.21703256E-07_JPRB, &
  & 0.21982618E-07_JPRB, 0.21849761E-07_JPRB, 0.21230850E-07_JPRB, 0.20075412E-07_JPRB, 0.18419865E-07_JPRB, 0.16480170E-07_JPRB, &
  & 0.14669106E-07_JPRB, 0.13040953E-07_JPRB, 0.11647312E-07_JPRB, 0.10848712E-07_JPRB, 0.11027270E-07_JPRB, 0.12061927E-07_JPRB, &
  & 0.13598016E-07_JPRB, 0.15377479E-07_JPRB, 0.17439410E-07_JPRB, 0.19795237E-07_JPRB, 0.22347345E-07_JPRB, 0.24923128E-07_JPRB, &
  & 0.27453492E-07_JPRB, 0.29929389E-07_JPRB, 0.32314894E-07_JPRB, 0.34396557E-07_JPRB, 0.35911121E-07_JPRB, 0.36675626E-07_JPRB, &
  & 0.36867014E-07_JPRB, 0.36571876E-07_JPRB, 0.35797825E-07_JPRB, 0.34559683E-07_JPRB, 0.32857226E-07_JPRB, 0.30695894E-07_JPRB, &
  & 0.28174370E-07_JPRB, 0.25422416E-07_JPRB, 0.22654604E-07_JPRB, 0.20051294E-07_JPRB, 0.17697495E-07_JPRB, 0.15679939E-07_JPRB, &
  & 0.13980263E-07_JPRB, 0.12576677E-07_JPRB, 0.11448099E-07_JPRB, 0.10561579E-07_JPRB, 0.98836193E-08_JPRB, 0.93339310E-08_JPRB, &
  & 0.88103160E-08_JPRB, 0.82823792E-08_JPRB, 0.77649807E-08_JPRB, 0.72293886E-08_JPRB /)

RGHG2(:, 3, 9) = (/ &
  & 0.11319031E-07_JPRB, 0.12195089E-07_JPRB, 0.12902377E-07_JPRB, 0.13723591E-07_JPRB, 0.14669736E-07_JPRB, 0.15771960E-07_JPRB, &
  & 0.17056667E-07_JPRB, 0.18581613E-07_JPRB, 0.20353399E-07_JPRB, 0.22297822E-07_JPRB, 0.24298592E-07_JPRB, 0.26279476E-07_JPRB, &
  & 0.28220542E-07_JPRB, 0.30102306E-07_JPRB, 0.31873594E-07_JPRB, 0.33450810E-07_JPRB, 0.34753253E-07_JPRB, 0.35726980E-07_JPRB, &
  & 0.36320920E-07_JPRB, 0.36452771E-07_JPRB, 0.36011237E-07_JPRB, 0.34902520E-07_JPRB, 0.33129034E-07_JPRB, 0.30807620E-07_JPRB, &
  & 0.28077228E-07_JPRB, 0.25338110E-07_JPRB, 0.23208855E-07_JPRB, 0.22248701E-07_JPRB, 0.22762734E-07_JPRB, 0.24718977E-07_JPRB, &
  & 0.27853943E-07_JPRB, 0.31786819E-07_JPRB, 0.35946904E-07_JPRB, 0.39942215E-07_JPRB, 0.43514003E-07_JPRB, 0.46681784E-07_JPRB, &
  & 0.49515442E-07_JPRB, 0.52093863E-07_JPRB, 0.54397074E-07_JPRB, 0.56342952E-07_JPRB, 0.57626455E-07_JPRB, 0.58096397E-07_JPRB, &
  & 0.57777346E-07_JPRB, 0.56745108E-07_JPRB, 0.55077308E-07_JPRB, 0.52847078E-07_JPRB, 0.50145601E-07_JPRB, 0.47056869E-07_JPRB, &
  & 0.43700993E-07_JPRB, 0.40262382E-07_JPRB, 0.36872553E-07_JPRB, 0.33618683E-07_JPRB, 0.30641598E-07_JPRB, 0.27944751E-07_JPRB, &
  & 0.25473604E-07_JPRB, 0.23208731E-07_JPRB, 0.21064185E-07_JPRB, 0.18946999E-07_JPRB, 0.16836395E-07_JPRB, 0.14806597E-07_JPRB, &
  & 0.13057951E-07_JPRB, 0.11693139E-07_JPRB, 0.10698323E-07_JPRB, 0.96622212E-08_JPRB /)

RGHG2(:, 4, 9) = (/ &
  & 0.13846737E-07_JPRB, 0.15189212E-07_JPRB, 0.16414447E-07_JPRB, 0.17851638E-07_JPRB, 0.19644128E-07_JPRB, 0.21718085E-07_JPRB, &
  & 0.23986027E-07_JPRB, 0.26298661E-07_JPRB, 0.28602496E-07_JPRB, 0.30932974E-07_JPRB, 0.33309483E-07_JPRB, 0.35676578E-07_JPRB, &
  & 0.37953715E-07_JPRB, 0.40070862E-07_JPRB, 0.41996238E-07_JPRB, 0.43742343E-07_JPRB, 0.45313541E-07_JPRB, 0.46667420E-07_JPRB, &
  & 0.47736446E-07_JPRB, 0.48461914E-07_JPRB, 0.48784749E-07_JPRB, 0.48650932E-07_JPRB, 0.48030088E-07_JPRB, 0.46937565E-07_JPRB, &
  & 0.45551467E-07_JPRB, 0.44205915E-07_JPRB, 0.43377121E-07_JPRB, 0.43496289E-07_JPRB, 0.44749491E-07_JPRB, 0.47047802E-07_JPRB, &
  & 0.50201908E-07_JPRB, 0.53945001E-07_JPRB, 0.57980294E-07_JPRB, 0.61905453E-07_JPRB, 0.65505709E-07_JPRB, 0.68679427E-07_JPRB, &
  & 0.71478937E-07_JPRB, 0.73970277E-07_JPRB, 0.76182971E-07_JPRB, 0.77964785E-07_JPRB, 0.79068741E-07_JPRB, 0.79187657E-07_JPRB, &
  & 0.78214093E-07_JPRB, 0.76230585E-07_JPRB, 0.73385721E-07_JPRB, 0.69891641E-07_JPRB, 0.65966134E-07_JPRB, 0.61805416E-07_JPRB, &
  & 0.57556939E-07_JPRB, 0.53333729E-07_JPRB, 0.49271478E-07_JPRB, 0.45453120E-07_JPRB, 0.41852662E-07_JPRB, 0.38508563E-07_JPRB, &
  & 0.35397157E-07_JPRB, 0.32407687E-07_JPRB, 0.29473613E-07_JPRB, 0.26596231E-07_JPRB, 0.23864388E-07_JPRB, 0.21404118E-07_JPRB, &
  & 0.19226462E-07_JPRB, 0.17262023E-07_JPRB, 0.15350103E-07_JPRB, 0.13071944E-07_JPRB /)

RGHG2(:, 5, 9) = (/ &
  & 0.15554706E-07_JPRB, 0.17617408E-07_JPRB, 0.19496730E-07_JPRB, 0.21775328E-07_JPRB, 0.24370074E-07_JPRB, 0.27166788E-07_JPRB, &
  & 0.30011947E-07_JPRB, 0.32886810E-07_JPRB, 0.35725787E-07_JPRB, 0.38477189E-07_JPRB, 0.41115126E-07_JPRB, 0.43613028E-07_JPRB, &
  & 0.45938403E-07_JPRB, 0.48076455E-07_JPRB, 0.50015121E-07_JPRB, 0.51747847E-07_JPRB, 0.53299082E-07_JPRB, 0.54725895E-07_JPRB, &
  & 0.56067343E-07_JPRB, 0.57319262E-07_JPRB, 0.58457232E-07_JPRB, 0.59459602E-07_JPRB, 0.60299335E-07_JPRB, 0.60959259E-07_JPRB, &
  & 0.61503570E-07_JPRB, 0.62061709E-07_JPRB, 0.62807267E-07_JPRB, 0.63971143E-07_JPRB, 0.65673589E-07_JPRB, 0.67946999E-07_JPRB, &
  & 0.70765878E-07_JPRB, 0.74076780E-07_JPRB, 0.77781550E-07_JPRB, 0.81719314E-07_JPRB, 0.85665896E-07_JPRB, 0.89471662E-07_JPRB, &
  & 0.93047731E-07_JPRB, 0.96343513E-07_JPRB, 0.99276328E-07_JPRB, 0.10166004E-06_JPRB, 0.10313705E-06_JPRB, 0.10334477E-06_JPRB, &
  & 0.10210007E-06_JPRB, 0.99492858E-07_JPRB, 0.95794583E-07_JPRB, 0.91339452E-07_JPRB, 0.86423050E-07_JPRB, 0.81253120E-07_JPRB, &
  & 0.75949984E-07_JPRB, 0.70577364E-07_JPRB, 0.65177851E-07_JPRB, 0.59836829E-07_JPRB, 0.54662912E-07_JPRB, 0.49703921E-07_JPRB, &
  & 0.45063892E-07_JPRB, 0.40805190E-07_JPRB, 0.36951217E-07_JPRB, 0.33513377E-07_JPRB, 0.30486355E-07_JPRB, 0.27731843E-07_JPRB, &
  & 0.25151648E-07_JPRB, 0.22782300E-07_JPRB, 0.20539600E-07_JPRB, 0.17227777E-07_JPRB /)

RGHG2(:, 6, 9) = (/ &
  & 0.17215598E-07_JPRB, 0.20247338E-07_JPRB, 0.22869653E-07_JPRB, 0.25784269E-07_JPRB, 0.28942907E-07_JPRB, 0.32224026E-07_JPRB, &
  & 0.35476837E-07_JPRB, 0.38583305E-07_JPRB, 0.41546649E-07_JPRB, 0.44408534E-07_JPRB, 0.47172080E-07_JPRB, 0.49820969E-07_JPRB, &
  & 0.52322221E-07_JPRB, 0.54636665E-07_JPRB, 0.56758896E-07_JPRB, 0.58720893E-07_JPRB, 0.60561980E-07_JPRB, 0.62307727E-07_JPRB, &
  & 0.64001298E-07_JPRB, 0.65700632E-07_JPRB, 0.67448980E-07_JPRB, 0.69265639E-07_JPRB, 0.71150708E-07_JPRB, 0.73083470E-07_JPRB, &
  & 0.75024730E-07_JPRB, 0.76990020E-07_JPRB, 0.79025085E-07_JPRB, 0.81166853E-07_JPRB, 0.83515310E-07_JPRB, 0.86163169E-07_JPRB, &
  & 0.89200256E-07_JPRB, 0.92709165E-07_JPRB, 0.96740955E-07_JPRB, 0.10130003E-06_JPRB, 0.10629437E-06_JPRB, 0.11152814E-06_JPRB, &
  & 0.11676315E-06_JPRB, 0.12175212E-06_JPRB, 0.12623826E-06_JPRB, 0.12989695E-06_JPRB, 0.13229982E-06_JPRB, 0.13303848E-06_JPRB, &
  & 0.13191290E-06_JPRB, 0.12906045E-06_JPRB, 0.12487354E-06_JPRB, 0.11975857E-06_JPRB, 0.11403491E-06_JPRB, 0.10786065E-06_JPRB, &
  & 0.10128544E-06_JPRB, 0.94323418E-07_JPRB, 0.87023096E-07_JPRB, 0.79467782E-07_JPRB, 0.71789771E-07_JPRB, 0.64245533E-07_JPRB, &
  & 0.57088677E-07_JPRB, 0.50578194E-07_JPRB, 0.44866372E-07_JPRB, 0.40055582E-07_JPRB, 0.36043549E-07_JPRB, 0.32736494E-07_JPRB, &
  & 0.30061841E-07_JPRB, 0.27820228E-07_JPRB, 0.25539860E-07_JPRB, 0.21964723E-07_JPRB /)

RGHG2(:, 7, 9) = (/ &
  & 0.19809717E-07_JPRB, 0.23718217E-07_JPRB, 0.26817000E-07_JPRB, 0.29853471E-07_JPRB, 0.33104911E-07_JPRB, 0.36432056E-07_JPRB, &
  & 0.39742627E-07_JPRB, 0.42972431E-07_JPRB, 0.46116664E-07_JPRB, 0.49179064E-07_JPRB, 0.52174745E-07_JPRB, 0.55069201E-07_JPRB, &
  & 0.57816131E-07_JPRB, 0.60388189E-07_JPRB, 0.62787279E-07_JPRB, 0.65032154E-07_JPRB, 0.67172635E-07_JPRB, 0.69285491E-07_JPRB, &
  & 0.71437313E-07_JPRB, 0.73692789E-07_JPRB, 0.76144573E-07_JPRB, 0.78895525E-07_JPRB, 0.82021430E-07_JPRB, 0.85522068E-07_JPRB, &
  & 0.89257746E-07_JPRB, 0.93015387E-07_JPRB, 0.96630636E-07_JPRB, 0.10010800E-06_JPRB, 0.10353209E-06_JPRB, 0.10705070E-06_JPRB, &
  & 0.11078795E-06_JPRB, 0.11485447E-06_JPRB, 0.11950661E-06_JPRB, 0.12493913E-06_JPRB, 0.13119471E-06_JPRB, 0.13810643E-06_JPRB, &
  & 0.14535082E-06_JPRB, 0.15251257E-06_JPRB, 0.15911621E-06_JPRB, 0.16463586E-06_JPRB, 0.16852051E-06_JPRB, 0.17021480E-06_JPRB, &
  & 0.16951934E-06_JPRB, 0.16661627E-06_JPRB, 0.16191979E-06_JPRB, 0.15591461E-06_JPRB, 0.14894214E-06_JPRB, 0.14116043E-06_JPRB, &
  & 0.13259510E-06_JPRB, 0.12323689E-06_JPRB, 0.11313796E-06_JPRB, 0.10249855E-06_JPRB, 0.91589101E-07_JPRB, 0.80741252E-07_JPRB, &
  & 0.70429884E-07_JPRB, 0.61076520E-07_JPRB, 0.52994849E-07_JPRB, 0.46259057E-07_JPRB, 0.40899234E-07_JPRB, 0.36779824E-07_JPRB, &
  & 0.33713448E-07_JPRB, 0.31348808E-07_JPRB, 0.29339086E-07_JPRB, 0.26373383E-07_JPRB /)

RGHG2(:, 8, 9) = (/ &
  & 0.23672449E-07_JPRB, 0.28122884E-07_JPRB, 0.31049964E-07_JPRB, 0.33923445E-07_JPRB, 0.36920369E-07_JPRB, 0.40113534E-07_JPRB, &
  & 0.43410328E-07_JPRB, 0.46749374E-07_JPRB, 0.50082459E-07_JPRB, 0.53413167E-07_JPRB, 0.56716360E-07_JPRB, 0.59958239E-07_JPRB, &
  & 0.63083377E-07_JPRB, 0.66030324E-07_JPRB, 0.68781361E-07_JPRB, 0.71384846E-07_JPRB, 0.73920248E-07_JPRB, 0.76475430E-07_JPRB, &
  & 0.79161019E-07_JPRB, 0.82115562E-07_JPRB, 0.85497085E-07_JPRB, 0.89500048E-07_JPRB, 0.94317699E-07_JPRB, 0.10006183E-06_JPRB, &
  & 0.10658213E-06_JPRB, 0.11346145E-06_JPRB, 0.12029827E-06_JPRB, 0.12674181E-06_JPRB, 0.13267348E-06_JPRB, 0.13808676E-06_JPRB, &
  & 0.14309370E-06_JPRB, 0.14799711E-06_JPRB, 0.15328868E-06_JPRB, 0.15947103E-06_JPRB, 0.16678052E-06_JPRB, 0.17517699E-06_JPRB, &
  & 0.18431396E-06_JPRB, 0.19363077E-06_JPRB, 0.20244977E-06_JPRB, 0.21002437E-06_JPRB, 0.21556225E-06_JPRB, 0.21846768E-06_JPRB, &
  & 0.21837141E-06_JPRB, 0.21533359E-06_JPRB, 0.20976746E-06_JPRB, 0.20219012E-06_JPRB, 0.19301005E-06_JPRB, 0.18248659E-06_JPRB, &
  & 0.17069290E-06_JPRB, 0.15766155E-06_JPRB, 0.14354355E-06_JPRB, 0.12865662E-06_JPRB, 0.11346874E-06_JPRB, 0.98600665E-07_JPRB, &
  & 0.84603442E-07_JPRB, 0.72064232E-07_JPRB, 0.61252379E-07_JPRB, 0.52385058E-07_JPRB, 0.45410257E-07_JPRB, 0.40166757E-07_JPRB, &
  & 0.36381088E-07_JPRB, 0.33727733E-07_JPRB, 0.31703149E-07_JPRB, 0.29396263E-07_JPRB /)

RGHG2(:, 9, 9) = (/ &
  & 0.28768763E-07_JPRB, 0.33094981E-07_JPRB, 0.35756134E-07_JPRB, 0.38316429E-07_JPRB, 0.41027832E-07_JPRB, 0.44032660E-07_JPRB, &
  & 0.47289817E-07_JPRB, 0.50726413E-07_JPRB, 0.54291373E-07_JPRB, 0.57940440E-07_JPRB, 0.61650731E-07_JPRB, 0.65359885E-07_JPRB, &
  & 0.68989607E-07_JPRB, 0.72479466E-07_JPRB, 0.75810078E-07_JPRB, 0.79008366E-07_JPRB, 0.82161947E-07_JPRB, 0.85404551E-07_JPRB, &
  & 0.88895959E-07_JPRB, 0.92839031E-07_JPRB, 0.97519141E-07_JPRB, 0.10335339E-06_JPRB, 0.11084852E-06_JPRB, 0.12038686E-06_JPRB, &
  & 0.13182010E-06_JPRB, 0.14431022E-06_JPRB, 0.15663437E-06_JPRB, 0.16801380E-06_JPRB, 0.17815343E-06_JPRB, 0.18711680E-06_JPRB, &
  & 0.19508364E-06_JPRB, 0.20244092E-06_JPRB, 0.20981093E-06_JPRB, 0.21772064E-06_JPRB, 0.22657525E-06_JPRB, 0.23642934E-06_JPRB, &
  & 0.24701836E-06_JPRB, 0.25769242E-06_JPRB, 0.26767535E-06_JPRB, 0.27607021E-06_JPRB, 0.28212307E-06_JPRB, 0.28512574E-06_JPRB, &
  & 0.28457666E-06_JPRB, 0.28036698E-06_JPRB, 0.27274911E-06_JPRB, 0.26221974E-06_JPRB, 0.24937407E-06_JPRB, 0.23453394E-06_JPRB, &
  & 0.21795482E-06_JPRB, 0.19988173E-06_JPRB, 0.18057045E-06_JPRB, 0.16049314E-06_JPRB, 0.14029138E-06_JPRB, 0.12069603E-06_JPRB, &
  & 0.10250986E-06_JPRB, 0.86264087E-07_JPRB, 0.72379990E-07_JPRB, 0.60939122E-07_JPRB, 0.51936155E-07_JPRB, 0.45155833E-07_JPRB, &
  & 0.40250111E-07_JPRB, 0.36814715E-07_JPRB, 0.34155473E-07_JPRB, 0.31551679E-07_JPRB /)

RGHG2(:,10, 9) = (/ &
  & 0.34905092E-07_JPRB, 0.38870130E-07_JPRB, 0.41444906E-07_JPRB, 0.43729308E-07_JPRB, 0.46313872E-07_JPRB, 0.49178958E-07_JPRB, &
  & 0.52429982E-07_JPRB, 0.55988291E-07_JPRB, 0.59787808E-07_JPRB, 0.63781272E-07_JPRB, 0.67910733E-07_JPRB, 0.72102651E-07_JPRB, &
  & 0.76270332E-07_JPRB, 0.80317839E-07_JPRB, 0.84205361E-07_JPRB, 0.87971145E-07_JPRB, 0.91715933E-07_JPRB, 0.95594913E-07_JPRB, &
  & 0.99817740E-07_JPRB, 0.10467815E-06_JPRB, 0.11059581E-06_JPRB, 0.11814523E-06_JPRB, 0.12803586E-06_JPRB, 0.14091579E-06_JPRB, &
  & 0.15682102E-06_JPRB, 0.17491328E-06_JPRB, 0.19436982E-06_JPRB, 0.21458118E-06_JPRB, 0.23492944E-06_JPRB, 0.25460520E-06_JPRB, &
  & 0.27294908E-06_JPRB, 0.28967472E-06_JPRB, 0.30466560E-06_JPRB, 0.31821904E-06_JPRB, 0.33073815E-06_JPRB, 0.34255811E-06_JPRB, &
  & 0.35350615E-06_JPRB, 0.36318093E-06_JPRB, 0.37096453E-06_JPRB, 0.37629820E-06_JPRB, 0.37875267E-06_JPRB, 0.37784994E-06_JPRB, &
  & 0.37331441E-06_JPRB, 0.36494777E-06_JPRB, 0.35280320E-06_JPRB, 0.33731703E-06_JPRB, 0.31894348E-06_JPRB, 0.29829621E-06_JPRB, &
  & 0.27582703E-06_JPRB, 0.25191491E-06_JPRB, 0.22703740E-06_JPRB, 0.20173819E-06_JPRB, 0.17669576E-06_JPRB, 0.15273871E-06_JPRB, &
  & 0.13054590E-06_JPRB, 0.11076195E-06_JPRB, 0.93686388E-07_JPRB, 0.79438983E-07_JPRB, 0.67908488E-07_JPRB, 0.58875134E-07_JPRB, &
  & 0.52065715E-07_JPRB, 0.46676202E-07_JPRB, 0.42475165E-07_JPRB, 0.37049375E-07_JPRB /)

RGHG2(:,11, 9) = (/ &
  & 0.41971624E-07_JPRB, 0.46225960E-07_JPRB, 0.48629129E-07_JPRB, 0.51096251E-07_JPRB, 0.53612617E-07_JPRB, 0.56614834E-07_JPRB, &
  & 0.60018998E-07_JPRB, 0.63857662E-07_JPRB, 0.68062356E-07_JPRB, 0.72580995E-07_JPRB, 0.77355892E-07_JPRB, 0.82305888E-07_JPRB, &
  & 0.87313637E-07_JPRB, 0.92265843E-07_JPRB, 0.97109094E-07_JPRB, 0.10184586E-06_JPRB, 0.10656841E-06_JPRB, 0.11147840E-06_JPRB, &
  & 0.11682535E-06_JPRB, 0.12298247E-06_JPRB, 0.13049554E-06_JPRB, 0.14016508E-06_JPRB, 0.15306398E-06_JPRB, 0.17024973E-06_JPRB, &
  & 0.19213296E-06_JPRB, 0.21820816E-06_JPRB, 0.24736354E-06_JPRB, 0.27816131E-06_JPRB, 0.30990157E-06_JPRB, 0.34226107E-06_JPRB, &
  & 0.37415060E-06_JPRB, 0.40379112E-06_JPRB, 0.42996180E-06_JPRB, 0.45218050E-06_JPRB, 0.47039782E-06_JPRB, 0.48479257E-06_JPRB, &
  & 0.49526625E-06_JPRB, 0.50185997E-06_JPRB, 0.50449177E-06_JPRB, 0.50334887E-06_JPRB, 0.49861268E-06_JPRB, 0.49044138E-06_JPRB, &
  & 0.47876239E-06_JPRB, 0.46353190E-06_JPRB, 0.44473543E-06_JPRB, 0.42266188E-06_JPRB, 0.39799119E-06_JPRB, 0.37129178E-06_JPRB, &
  & 0.34320192E-06_JPRB, 0.31436025E-06_JPRB, 0.28528595E-06_JPRB, 0.25649823E-06_JPRB, 0.22861312E-06_JPRB, 0.20228106E-06_JPRB, &
  & 0.17812228E-06_JPRB, 0.15655581E-06_JPRB, 0.13776091E-06_JPRB, 0.12163110E-06_JPRB, 0.10802940E-06_JPRB, 0.96652613E-07_JPRB, &
  & 0.87032454E-07_JPRB, 0.79125691E-07_JPRB, 0.70709561E-07_JPRB, 0.59783375E-07_JPRB /)

RGHG2(:,12, 9) = (/ &
  & 0.50828518E-07_JPRB, 0.55482435E-07_JPRB, 0.58531388E-07_JPRB, 0.61138728E-07_JPRB, 0.64169804E-07_JPRB, 0.67545088E-07_JPRB, &
  & 0.71550524E-07_JPRB, 0.76140552E-07_JPRB, 0.81313978E-07_JPRB, 0.87033790E-07_JPRB, 0.93245596E-07_JPRB, 0.99838701E-07_JPRB, &
  & 0.10664768E-06_JPRB, 0.11347215E-06_JPRB, 0.12019254E-06_JPRB, 0.12667496E-06_JPRB, 0.13304806E-06_JPRB, 0.13949766E-06_JPRB, &
  & 0.14630436E-06_JPRB, 0.15390634E-06_JPRB, 0.16288739E-06_JPRB, 0.17408254E-06_JPRB, 0.18857129E-06_JPRB, 0.20755078E-06_JPRB, &
  & 0.23179392E-06_JPRB, 0.26127469E-06_JPRB, 0.29561252E-06_JPRB, 0.33442981E-06_JPRB, 0.37690657E-06_JPRB, 0.42143699E-06_JPRB, &
  & 0.46580769E-06_JPRB, 0.50781301E-06_JPRB, 0.54522047E-06_JPRB, 0.57671673E-06_JPRB, 0.60158106E-06_JPRB, 0.61973628E-06_JPRB, &
  & 0.63107848E-06_JPRB, 0.63600146E-06_JPRB, 0.63491893E-06_JPRB, 0.62857276E-06_JPRB, 0.61775972E-06_JPRB, 0.60298578E-06_JPRB, &
  & 0.58458454E-06_JPRB, 0.56278708E-06_JPRB, 0.53778581E-06_JPRB, 0.51002348E-06_JPRB, 0.48012816E-06_JPRB, 0.44892343E-06_JPRB, &
  & 0.41727807E-06_JPRB, 0.38590048E-06_JPRB, 0.35539065E-06_JPRB, 0.32609734E-06_JPRB, 0.29848047E-06_JPRB, 0.27302383E-06_JPRB, &
  & 0.25008205E-06_JPRB, 0.22979128E-06_JPRB, 0.21208133E-06_JPRB, 0.19660882E-06_JPRB, 0.18313855E-06_JPRB, 0.17115497E-06_JPRB, &
  & 0.16060511E-06_JPRB, 0.15010762E-06_JPRB, 0.13955855E-06_JPRB, 0.11947304E-06_JPRB /)

RGHG2(:,13, 9) = (/ &
  & 0.61550864E-07_JPRB, 0.67618345E-07_JPRB, 0.71194705E-07_JPRB, 0.74751284E-07_JPRB, 0.78490444E-07_JPRB, 0.83023878E-07_JPRB, &
  & 0.88432614E-07_JPRB, 0.94925170E-07_JPRB, 0.10256273E-06_JPRB, 0.11136721E-06_JPRB, 0.12128288E-06_JPRB, 0.13212336E-06_JPRB, &
  & 0.14356974E-06_JPRB, 0.15518170E-06_JPRB, 0.16662878E-06_JPRB, 0.17761799E-06_JPRB, 0.18793810E-06_JPRB, 0.19770404E-06_JPRB, &
  & 0.20709481E-06_JPRB, 0.21644905E-06_JPRB, 0.22639921E-06_JPRB, 0.23775424E-06_JPRB, 0.25157959E-06_JPRB, 0.26918869E-06_JPRB, &
  & 0.29178017E-06_JPRB, 0.32027347E-06_JPRB, 0.35498147E-06_JPRB, 0.39601301E-06_JPRB, 0.44264397E-06_JPRB, 0.49327974E-06_JPRB, &
  & 0.54563759E-06_JPRB, 0.59617435E-06_JPRB, 0.64185969E-06_JPRB, 0.68052373E-06_JPRB, 0.71104898E-06_JPRB, 0.73286225E-06_JPRB, &
  & 0.74593333E-06_JPRB, 0.75068772E-06_JPRB, 0.74791802E-06_JPRB, 0.73866602E-06_JPRB, 0.72400172E-06_JPRB, 0.70485913E-06_JPRB, &
  & 0.68187637E-06_JPRB, 0.65556026E-06_JPRB, 0.62638355E-06_JPRB, 0.59499524E-06_JPRB, 0.56228259E-06_JPRB, 0.52927328E-06_JPRB, &
  & 0.49692221E-06_JPRB, 0.46602645E-06_JPRB, 0.43699268E-06_JPRB, 0.41006203E-06_JPRB, 0.38546065E-06_JPRB, 0.36341459E-06_JPRB, &
  & 0.34397280E-06_JPRB, 0.32704708E-06_JPRB, 0.31233438E-06_JPRB, 0.29941305E-06_JPRB, 0.28796737E-06_JPRB, 0.27757076E-06_JPRB, &
  & 0.26778389E-06_JPRB, 0.25830116E-06_JPRB, 0.24652451E-06_JPRB, 0.22614742E-06_JPRB /)

RGHG2(:,14, 9) = (/ &
  & 0.74381148E-07_JPRB, 0.82298939E-07_JPRB, 0.87338130E-07_JPRB, 0.92266873E-07_JPRB, 0.98001706E-07_JPRB, 0.10500709E-06_JPRB, &
  & 0.11380128E-06_JPRB, 0.12472999E-06_JPRB, 0.13799989E-06_JPRB, 0.15363062E-06_JPRB, 0.17142634E-06_JPRB, 0.19083726E-06_JPRB, &
  & 0.21105789E-06_JPRB, 0.23101461E-06_JPRB, 0.24978596E-06_JPRB, 0.26688770E-06_JPRB, 0.28226907E-06_JPRB, 0.29599551E-06_JPRB, &
  & 0.30830165E-06_JPRB, 0.31957444E-06_JPRB, 0.33026609E-06_JPRB, 0.34101481E-06_JPRB, 0.35273121E-06_JPRB, 0.36668092E-06_JPRB, &
  & 0.38442229E-06_JPRB, 0.40752809E-06_JPRB, 0.43763004E-06_JPRB, 0.47525117E-06_JPRB, 0.52039388E-06_JPRB, 0.57169433E-06_JPRB, &
  & 0.62574480E-06_JPRB, 0.67929989E-06_JPRB, 0.72877720E-06_JPRB, 0.77161781E-06_JPRB, 0.80582464E-06_JPRB, 0.83039384E-06_JPRB, &
  & 0.84516927E-06_JPRB, 0.85060850E-06_JPRB, 0.84760308E-06_JPRB, 0.83730646E-06_JPRB, 0.82090355E-06_JPRB, 0.79946551E-06_JPRB, &
  & 0.77397897E-06_JPRB, 0.74516294E-06_JPRB, 0.71387342E-06_JPRB, 0.68100468E-06_JPRB, 0.64772894E-06_JPRB, 0.61529340E-06_JPRB, &
  & 0.58471034E-06_JPRB, 0.55653533E-06_JPRB, 0.53095511E-06_JPRB, 0.50796166E-06_JPRB, 0.48751599E-06_JPRB, 0.46951072E-06_JPRB, &
  & 0.45381486E-06_JPRB, 0.44018654E-06_JPRB, 0.42831280E-06_JPRB, 0.41787226E-06_JPRB, 0.40849599E-06_JPRB, 0.40006259E-06_JPRB, &
  & 0.39179633E-06_JPRB, 0.38389243E-06_JPRB, 0.37369915E-06_JPRB, 0.35536351E-06_JPRB /)

RGHG2(:,15, 9) = (/ &
  & 0.90267221E-07_JPRB, 0.10166644E-06_JPRB, 0.10978043E-06_JPRB, 0.11789131E-06_JPRB, 0.12756121E-06_JPRB, 0.13944474E-06_JPRB, &
  & 0.15435567E-06_JPRB, 0.17271311E-06_JPRB, 0.19466971E-06_JPRB, 0.21994637E-06_JPRB, 0.24785444E-06_JPRB, 0.27723775E-06_JPRB, &
  & 0.30674374E-06_JPRB, 0.33510091E-06_JPRB, 0.36131672E-06_JPRB, 0.38479027E-06_JPRB, 0.40550123E-06_JPRB, 0.42359989E-06_JPRB, &
  & 0.43935785E-06_JPRB, 0.45320292E-06_JPRB, 0.46558318E-06_JPRB, 0.47695136E-06_JPRB, 0.48794584E-06_JPRB, 0.49962000E-06_JPRB, &
  & 0.51342676E-06_JPRB, 0.53107567E-06_JPRB, 0.55445167E-06_JPRB, 0.58546732E-06_JPRB, 0.62434304E-06_JPRB, 0.67004896E-06_JPRB, &
  & 0.72029030E-06_JPRB, 0.77122513E-06_JPRB, 0.81950469E-06_JPRB, 0.86203409E-06_JPRB, 0.89663246E-06_JPRB, 0.92198508E-06_JPRB, &
  & 0.93767585E-06_JPRB, 0.94406033E-06_JPRB, 0.94203665E-06_JPRB, 0.93264828E-06_JPRB, 0.91687576E-06_JPRB, 0.89570079E-06_JPRB, &
  & 0.87006231E-06_JPRB, 0.84094393E-06_JPRB, 0.80942078E-06_JPRB, 0.77689015E-06_JPRB, 0.74484154E-06_JPRB, 0.71461415E-06_JPRB, &
  & 0.68707124E-06_JPRB, 0.66250175E-06_JPRB, 0.64077511E-06_JPRB, 0.62157841E-06_JPRB, 0.60456341E-06_JPRB, 0.58949234E-06_JPRB, &
  & 0.57613858E-06_JPRB, 0.56433208E-06_JPRB, 0.55387551E-06_JPRB, 0.54456302E-06_JPRB, 0.53621130E-06_JPRB, 0.52868791E-06_JPRB, &
  & 0.52141121E-06_JPRB, 0.51450598E-06_JPRB, 0.50531952E-06_JPRB, 0.48878439E-06_JPRB /)

RGHG2(:,16, 9) = (/ &
  & 0.11405916E-06_JPRB, 0.13430655E-06_JPRB, 0.14766530E-06_JPRB, 0.16135887E-06_JPRB, 0.17646651E-06_JPRB, 0.19460641E-06_JPRB, &
  & 0.21636930E-06_JPRB, 0.24234092E-06_JPRB, 0.27253836E-06_JPRB, 0.30660038E-06_JPRB, 0.34371800E-06_JPRB, 0.38268598E-06_JPRB, &
  & 0.42184917E-06_JPRB, 0.45938626E-06_JPRB, 0.49400535E-06_JPRB, 0.52500849E-06_JPRB, 0.55227383E-06_JPRB, 0.57616978E-06_JPRB, &
  & 0.59703370E-06_JPRB, 0.61531756E-06_JPRB, 0.63153192E-06_JPRB, 0.64606877E-06_JPRB, 0.65926747E-06_JPRB, 0.67168696E-06_JPRB, &
  & 0.68437191E-06_JPRB, 0.69883026E-06_JPRB, 0.71656603E-06_JPRB, 0.73934007E-06_JPRB, 0.76862568E-06_JPRB, 0.80402015E-06_JPRB, &
  & 0.84375796E-06_JPRB, 0.88543459E-06_JPRB, 0.92584128E-06_JPRB, 0.96195242E-06_JPRB, 0.99179158E-06_JPRB, 0.10140975E-05_JPRB, &
  & 0.10284698E-05_JPRB, 0.10353258E-05_JPRB, 0.10352528E-05_JPRB, 0.10288575E-05_JPRB, 0.10165786E-05_JPRB, 0.99884289E-06_JPRB, &
  & 0.97623581E-06_JPRB, 0.94959893E-06_JPRB, 0.92030393E-06_JPRB, 0.89000980E-06_JPRB, 0.86055411E-06_JPRB, 0.83335829E-06_JPRB, &
  & 0.80910661E-06_JPRB, 0.78779743E-06_JPRB, 0.76894344E-06_JPRB, 0.75196670E-06_JPRB, 0.73641928E-06_JPRB, 0.72205023E-06_JPRB, &
  & 0.70878349E-06_JPRB, 0.69665475E-06_JPRB, 0.68567192E-06_JPRB, 0.67583670E-06_JPRB, 0.66708594E-06_JPRB, 0.65929601E-06_JPRB, &
  & 0.65202136E-06_JPRB, 0.64516934E-06_JPRB, 0.63601033E-06_JPRB, 0.62046797E-06_JPRB /)

RGHG2(:,17, 9) = (/ &
  & 0.16038354E-06_JPRB, 0.19618359E-06_JPRB, 0.21748507E-06_JPRB, 0.23625654E-06_JPRB, 0.25582028E-06_JPRB, 0.27791066E-06_JPRB, &
  & 0.30392636E-06_JPRB, 0.33464804E-06_JPRB, 0.37041164E-06_JPRB, 0.41104690E-06_JPRB, 0.45571983E-06_JPRB, 0.50286815E-06_JPRB, &
  & 0.55061332E-06_JPRB, 0.59684311E-06_JPRB, 0.63979911E-06_JPRB, 0.67858099E-06_JPRB, 0.71298564E-06_JPRB, 0.74343575E-06_JPRB, &
  & 0.77059912E-06_JPRB, 0.79502053E-06_JPRB, 0.81729905E-06_JPRB, 0.83781379E-06_JPRB, 0.85652403E-06_JPRB, 0.87328795E-06_JPRB, &
  & 0.88828364E-06_JPRB, 0.90236864E-06_JPRB, 0.91722069E-06_JPRB, 0.93352043E-06_JPRB, 0.95189392E-06_JPRB, 0.97359100E-06_JPRB, &
  & 0.99816145E-06_JPRB, 0.10241488E-05_JPRB, 0.10494862E-05_JPRB, 0.10723040E-05_JPRB, 0.10915352E-05_JPRB, 0.11065007E-05_JPRB, &
  & 0.11172547E-05_JPRB, 0.11236674E-05_JPRB, 0.11258103E-05_JPRB, 0.11235959E-05_JPRB, 0.11167609E-05_JPRB, 0.11050108E-05_JPRB, &
  & 0.10883475E-05_JPRB, 0.10672518E-05_JPRB, 0.10428906E-05_JPRB, 0.10169913E-05_JPRB, 0.99142903E-06_JPRB, 0.96764938E-06_JPRB, &
  & 0.94625909E-06_JPRB, 0.92701515E-06_JPRB, 0.90931292E-06_JPRB, 0.89255059E-06_JPRB, 0.87633282E-06_JPRB, 0.86059242E-06_JPRB, &
  & 0.84551533E-06_JPRB, 0.83141532E-06_JPRB, 0.81855973E-06_JPRB, 0.80709265E-06_JPRB, 0.79703602E-06_JPRB, 0.78821233E-06_JPRB, &
  & 0.78035771E-06_JPRB, 0.77257710E-06_JPRB, 0.76377324E-06_JPRB, 0.74676035E-06_JPRB /)

RGHG2(:,18, 9) = (/ &
  & 0.25340327E-06_JPRB, 0.30617991E-06_JPRB, 0.33231299E-06_JPRB, 0.35157515E-06_JPRB, 0.37022795E-06_JPRB, 0.39090833E-06_JPRB, &
  & 0.41581816E-06_JPRB, 0.44637974E-06_JPRB, 0.48319009E-06_JPRB, 0.52626211E-06_JPRB, 0.57480611E-06_JPRB, 0.62710313E-06_JPRB, &
  & 0.68060370E-06_JPRB, 0.73275419E-06_JPRB, 0.78143722E-06_JPRB, 0.82546092E-06_JPRB, 0.86466667E-06_JPRB, 0.89952141E-06_JPRB, &
  & 0.93097424E-06_JPRB, 0.95999280E-06_JPRB, 0.98727446E-06_JPRB, 0.10132580E-05_JPRB, 0.10380033E-05_JPRB, 0.10612193E-05_JPRB, &
  & 0.10822467E-05_JPRB, 0.11004088E-05_JPRB, 0.11155653E-05_JPRB, 0.11285164E-05_JPRB, 0.11399829E-05_JPRB, 0.11498422E-05_JPRB, &
  & 0.11586603E-05_JPRB, 0.11666945E-05_JPRB, 0.11746273E-05_JPRB, 0.11825131E-05_JPRB, 0.11896140E-05_JPRB, 0.11957944E-05_JPRB, &
  & 0.12011498E-05_JPRB, 0.12058443E-05_JPRB, 0.12093844E-05_JPRB, 0.12109099E-05_JPRB, 0.12094316E-05_JPRB, 0.12040430E-05_JPRB, &
  & 0.11941823E-05_JPRB, 0.11798869E-05_JPRB, 0.11619246E-05_JPRB, 0.11416536E-05_JPRB, 0.11206910E-05_JPRB, 0.11003450E-05_JPRB, &
  & 0.10811436E-05_JPRB, 0.10629445E-05_JPRB, 0.10452495E-05_JPRB, 0.10276068E-05_JPRB, 0.10098212E-05_JPRB, 0.99207659E-06_JPRB, &
  & 0.97484110E-06_JPRB, 0.95865039E-06_JPRB, 0.94391623E-06_JPRB, 0.93086851E-06_JPRB, 0.91953677E-06_JPRB, 0.90973913E-06_JPRB, &
  & 0.90108898E-06_JPRB, 0.89283037E-06_JPRB, 0.88361929E-06_JPRB, 0.86615074E-06_JPRB /)

RGHG2(:,19, 9) = (/ &
  & 0.40470510E-06_JPRB, 0.45910986E-06_JPRB, 0.47817610E-06_JPRB, 0.49109860E-06_JPRB, 0.50315771E-06_JPRB, 0.51774362E-06_JPRB, &
  & 0.53760061E-06_JPRB, 0.56426819E-06_JPRB, 0.59864118E-06_JPRB, 0.64074220E-06_JPRB, 0.68958332E-06_JPRB, 0.74308241E-06_JPRB, &
  & 0.79847149E-06_JPRB, 0.85255454E-06_JPRB, 0.90304837E-06_JPRB, 0.94863071E-06_JPRB, 0.98908117E-06_JPRB, 0.10250612E-05_JPRB, &
  & 0.10575993E-05_JPRB, 0.10879024E-05_JPRB, 0.11168348E-05_JPRB, 0.11449798E-05_JPRB, 0.11725709E-05_JPRB, 0.11993272E-05_JPRB, &
  & 0.12243353E-05_JPRB, 0.12462129E-05_JPRB, 0.12637241E-05_JPRB, 0.12761475E-05_JPRB, 0.12836912E-05_JPRB, 0.12871328E-05_JPRB, &
  & 0.12874086E-05_JPRB, 0.12853532E-05_JPRB, 0.12821786E-05_JPRB, 0.12789258E-05_JPRB, 0.12769273E-05_JPRB, 0.12764764E-05_JPRB, &
  & 0.12774656E-05_JPRB, 0.12799812E-05_JPRB, 0.12837280E-05_JPRB, 0.12874332E-05_JPRB, 0.12896069E-05_JPRB, 0.12889623E-05_JPRB, &
  & 0.12845841E-05_JPRB, 0.12761373E-05_JPRB, 0.12639473E-05_JPRB, 0.12488728E-05_JPRB, 0.12321254E-05_JPRB, 0.12147682E-05_JPRB, &
  & 0.11973676E-05_JPRB, 0.11799231E-05_JPRB, 0.11621635E-05_JPRB, 0.11438631E-05_JPRB, 0.11250705E-05_JPRB, 0.11062000E-05_JPRB, &
  & 0.10878687E-05_JPRB, 0.10706881E-05_JPRB, 0.10550999E-05_JPRB, 0.10413232E-05_JPRB, 0.10293836E-05_JPRB, 0.10191167E-05_JPRB, &
  & 0.10100676E-05_JPRB, 0.10017059E-05_JPRB, 0.99210899E-06_JPRB, 0.97562133E-06_JPRB /)

RGHG2(:,20, 9) = (/ &
  & 0.58290556E-06_JPRB, 0.61338704E-06_JPRB, 0.62254969E-06_JPRB, 0.62704225E-06_JPRB, 0.63232807E-06_JPRB, 0.64065995E-06_JPRB, &
  & 0.65493163E-06_JPRB, 0.67669538E-06_JPRB, 0.70697058E-06_JPRB, 0.74565855E-06_JPRB, 0.79179051E-06_JPRB, 0.84313240E-06_JPRB, &
  & 0.89658221E-06_JPRB, 0.94910001E-06_JPRB, 0.99807460E-06_JPRB, 0.10422982E-05_JPRB, 0.10816482E-05_JPRB, 0.11166973E-05_JPRB, &
  & 0.11485456E-05_JPRB, 0.11783677E-05_JPRB, 0.12072384E-05_JPRB, 0.12358155E-05_JPRB, 0.12643621E-05_JPRB, 0.12926274E-05_JPRB, &
  & 0.13195407E-05_JPRB, 0.13433722E-05_JPRB, 0.13624135E-05_JPRB, 0.13755581E-05_JPRB, 0.13826354E-05_JPRB, 0.13842761E-05_JPRB, &
  & 0.13813864E-05_JPRB, 0.13750516E-05_JPRB, 0.13666579E-05_JPRB, 0.13574293E-05_JPRB, 0.13492918E-05_JPRB, 0.13437260E-05_JPRB, &
  & 0.13424906E-05_JPRB, 0.13445660E-05_JPRB, 0.13484616E-05_JPRB, 0.13531757E-05_JPRB, 0.13572052E-05_JPRB, 0.13591894E-05_JPRB, &
  & 0.13581052E-05_JPRB, 0.13534742E-05_JPRB, 0.13452789E-05_JPRB, 0.13339596E-05_JPRB, 0.13203456E-05_JPRB, 0.13053016E-05_JPRB, &
  & 0.12893829E-05_JPRB, 0.12727305E-05_JPRB, 0.12552996E-05_JPRB, 0.12371030E-05_JPRB, 0.12183935E-05_JPRB, 0.11996974E-05_JPRB, &
  & 0.11816288E-05_JPRB, 0.11647497E-05_JPRB, 0.11494496E-05_JPRB, 0.11358919E-05_JPRB, 0.11240793E-05_JPRB, 0.11138413E-05_JPRB, &
  & 0.11049385E-05_JPRB, 0.10965390E-05_JPRB, 0.10878874E-05_JPRB, 0.10718511E-05_JPRB /)

RGHG2(:,21, 9) = (/ &
  & 0.73110198E-06_JPRB, 0.74588365E-06_JPRB, 0.74723380E-06_JPRB, 0.74650256E-06_JPRB, 0.74695117E-06_JPRB, 0.75086314E-06_JPRB, &
  & 0.76054243E-06_JPRB, 0.77763588E-06_JPRB, 0.80322167E-06_JPRB, 0.83733488E-06_JPRB, 0.87885928E-06_JPRB, 0.92573850E-06_JPRB, &
  & 0.97509565E-06_JPRB, 0.10237543E-05_JPRB, 0.10695081E-05_JPRB, 0.11109704E-05_JPRB, 0.11479897E-05_JPRB, 0.11812488E-05_JPRB, &
  & 0.12117085E-05_JPRB, 0.12405138E-05_JPRB, 0.12686714E-05_JPRB, 0.12969062E-05_JPRB, 0.13254615E-05_JPRB, 0.13541242E-05_JPRB, &
  & 0.13816623E-05_JPRB, 0.14063869E-05_JPRB, 0.14264278E-05_JPRB, 0.14406641E-05_JPRB, 0.14488705E-05_JPRB, 0.14514255E-05_JPRB, &
  & 0.14489907E-05_JPRB, 0.14425561E-05_JPRB, 0.14335027E-05_JPRB, 0.14233729E-05_JPRB, 0.14143151E-05_JPRB, 0.14079806E-05_JPRB, &
  & 0.14043629E-05_JPRB, 0.14042702E-05_JPRB, 0.14072143E-05_JPRB, 0.14114100E-05_JPRB, 0.14155182E-05_JPRB, 0.14180102E-05_JPRB, &
  & 0.14181479E-05_JPRB, 0.14152879E-05_JPRB, 0.14091726E-05_JPRB, 0.14000192E-05_JPRB, 0.13883458E-05_JPRB, 0.13748527E-05_JPRB, &
  & 0.13600680E-05_JPRB, 0.13442494E-05_JPRB, 0.13275098E-05_JPRB, 0.13100400E-05_JPRB, 0.12922214E-05_JPRB, 0.12745728E-05_JPRB, &
  & 0.12576422E-05_JPRB, 0.12418780E-05_JPRB, 0.12275536E-05_JPRB, 0.12147929E-05_JPRB, 0.12036021E-05_JPRB, 0.11938556E-05_JPRB, &
  & 0.11852542E-05_JPRB, 0.11775491E-05_JPRB, 0.11689259E-05_JPRB, 0.11551566E-05_JPRB /)

RGHG2(:,22, 9) = (/ &
  & 0.85056416E-06_JPRB, 0.85547572E-06_JPRB, 0.85263684E-06_JPRB, 0.84881469E-06_JPRB, 0.84612242E-06_JPRB, 0.84682665E-06_JPRB, &
  & 0.85278850E-06_JPRB, 0.86576500E-06_JPRB, 0.88678360E-06_JPRB, 0.91581853E-06_JPRB, 0.95206235E-06_JPRB, 0.99351723E-06_JPRB, &
  & 0.10375960E-05_JPRB, 0.10816068E-05_JPRB, 0.11232490E-05_JPRB, 0.11614579E-05_JPRB, 0.11960078E-05_JPRB, 0.12273464E-05_JPRB, &
  & 0.12564097E-05_JPRB, 0.12841681E-05_JPRB, 0.13115721E-05_JPRB, 0.13392942E-05_JPRB, 0.13676289E-05_JPRB, 0.13962419E-05_JPRB, &
  & 0.14241253E-05_JPRB, 0.14493378E-05_JPRB, 0.14702694E-05_JPRB, 0.14857518E-05_JPRB, 0.14955780E-05_JPRB, 0.15000556E-05_JPRB, &
  & 0.14996957E-05_JPRB, 0.14952694E-05_JPRB, 0.14879281E-05_JPRB, 0.14790442E-05_JPRB, 0.14705167E-05_JPRB, 0.14639241E-05_JPRB, &
  & 0.14601897E-05_JPRB, 0.14596701E-05_JPRB, 0.14613219E-05_JPRB, 0.14641888E-05_JPRB, 0.14669694E-05_JPRB, 0.14688322E-05_JPRB, &
  & 0.14686171E-05_JPRB, 0.14658701E-05_JPRB, 0.14603725E-05_JPRB, 0.14520659E-05_JPRB, 0.14413469E-05_JPRB, 0.14287888E-05_JPRB, &
  & 0.14148529E-05_JPRB, 0.13998076E-05_JPRB, 0.13838783E-05_JPRB, 0.13673845E-05_JPRB, 0.13507664E-05_JPRB, 0.13345273E-05_JPRB, &
  & 0.13190902E-05_JPRB, 0.13047622E-05_JPRB, 0.12917037E-05_JPRB, 0.12799604E-05_JPRB, 0.12695265E-05_JPRB, 0.12603301E-05_JPRB, &
  & 0.12523026E-05_JPRB, 0.12448415E-05_JPRB, 0.12374067E-05_JPRB, 0.12241971E-05_JPRB /)

RGHG2(:,23, 9) = (/ &
  & 0.94882068E-06_JPRB, 0.94795939E-06_JPRB, 0.94264647E-06_JPRB, 0.93656485E-06_JPRB, 0.93173554E-06_JPRB, 0.92989978E-06_JPRB, &
  & 0.93286235E-06_JPRB, 0.94223151E-06_JPRB, 0.95896507E-06_JPRB, 0.98320311E-06_JPRB, 0.10140961E-05_JPRB, 0.10500750E-05_JPRB, &
  & 0.10888753E-05_JPRB, 0.11280998E-05_JPRB, 0.11659076E-05_JPRB, 0.12010610E-05_JPRB, 0.12333079E-05_JPRB, 0.12630364E-05_JPRB, &
  & 0.12909493E-05_JPRB, 0.13178876E-05_JPRB, 0.13447093E-05_JPRB, 0.13719254E-05_JPRB, 0.13999345E-05_JPRB, 0.14282759E-05_JPRB, &
  & 0.14559284E-05_JPRB, 0.14811817E-05_JPRB, 0.15025266E-05_JPRB, 0.15191276E-05_JPRB, 0.15308010E-05_JPRB, 0.15375718E-05_JPRB, &
  & 0.15398591E-05_JPRB, 0.15382893E-05_JPRB, 0.15338109E-05_JPRB, 0.15276315E-05_JPRB, 0.15212444E-05_JPRB, 0.15158323E-05_JPRB, &
  & 0.15122348E-05_JPRB, 0.15109354E-05_JPRB, 0.15113837E-05_JPRB, 0.15124727E-05_JPRB, 0.15134694E-05_JPRB, 0.15134925E-05_JPRB, &
  & 0.15120399E-05_JPRB, 0.15084565E-05_JPRB, 0.15024243E-05_JPRB, 0.14940947E-05_JPRB, 0.14836022E-05_JPRB, 0.14714234E-05_JPRB, &
  & 0.14579880E-05_JPRB, 0.14435923E-05_JPRB, 0.14284957E-05_JPRB, 0.14130670E-05_JPRB, 0.13977572E-05_JPRB, 0.13829917E-05_JPRB, &
  & 0.13690683E-05_JPRB, 0.13561757E-05_JPRB, 0.13443718E-05_JPRB, 0.13336550E-05_JPRB, 0.13240051E-05_JPRB, 0.13153849E-05_JPRB, &
  & 0.13076962E-05_JPRB, 0.13007912E-05_JPRB, 0.12934423E-05_JPRB, 0.12822901E-05_JPRB /)

RGHG2(:,24, 9) = (/ &
  & 0.10314910E-05_JPRB, 0.10270886E-05_JPRB, 0.10200572E-05_JPRB, 0.10127501E-05_JPRB, 0.10063801E-05_JPRB, 0.10026515E-05_JPRB, &
  & 0.10031949E-05_JPRB, 0.10094925E-05_JPRB, 0.10224794E-05_JPRB, 0.10423297E-05_JPRB, 0.10684295E-05_JPRB, 0.10994039E-05_JPRB, &
  & 0.11334288E-05_JPRB, 0.11685170E-05_JPRB, 0.12029287E-05_JPRB, 0.12356336E-05_JPRB, 0.12661814E-05_JPRB, 0.12947285E-05_JPRB, &
  & 0.13218375E-05_JPRB, 0.13481650E-05_JPRB, 0.13744426E-05_JPRB, 0.14011007E-05_JPRB, 0.14285021E-05_JPRB, 0.14561468E-05_JPRB, &
  & 0.14830647E-05_JPRB, 0.15080051E-05_JPRB, 0.15295634E-05_JPRB, 0.15467916E-05_JPRB, 0.15595192E-05_JPRB, 0.15680818E-05_JPRB, &
  & 0.15728149E-05_JPRB, 0.15741641E-05_JPRB, 0.15728291E-05_JPRB, 0.15697420E-05_JPRB, 0.15658923E-05_JPRB, 0.15620818E-05_JPRB, &
  & 0.15592948E-05_JPRB, 0.15574935E-05_JPRB, 0.15565852E-05_JPRB, 0.15557645E-05_JPRB, 0.15546400E-05_JPRB, 0.15525885E-05_JPRB, &
  & 0.15492279E-05_JPRB, 0.15443384E-05_JPRB, 0.15374288E-05_JPRB, 0.15285199E-05_JPRB, 0.15178778E-05_JPRB, 0.15059095E-05_JPRB, &
  & 0.14928729E-05_JPRB, 0.14790353E-05_JPRB, 0.14647217E-05_JPRB, 0.14503212E-05_JPRB, 0.14362511E-05_JPRB, 0.14228306E-05_JPRB, &
  & 0.14102661E-05_JPRB, 0.13986263E-05_JPRB, 0.13879185E-05_JPRB, 0.13781062E-05_JPRB, 0.13691828E-05_JPRB, 0.13611386E-05_JPRB, &
  & 0.13539402E-05_JPRB, 0.13472935E-05_JPRB, 0.13405727E-05_JPRB, 0.13296495E-05_JPRB /)

RGHG2(:,25, 9) = (/ &
  & 0.11014679E-05_JPRB, 0.10950487E-05_JPRB, 0.10876216E-05_JPRB, 0.10797889E-05_JPRB, 0.10728473E-05_JPRB, 0.10679219E-05_JPRB, &
  & 0.10667090E-05_JPRB, 0.10705412E-05_JPRB, 0.10803985E-05_JPRB, 0.10965143E-05_JPRB, 0.11184908E-05_JPRB, 0.11452352E-05_JPRB, &
  & 0.11752718E-05_JPRB, 0.12069493E-05_JPRB, 0.12387939E-05_JPRB, 0.12696561E-05_JPRB, 0.12990015E-05_JPRB, 0.13267893E-05_JPRB, &
  & 0.13533196E-05_JPRB, 0.13791255E-05_JPRB, 0.14047198E-05_JPRB, 0.14304804E-05_JPRB, 0.14566843E-05_JPRB, 0.14830596E-05_JPRB, &
  & 0.15086677E-05_JPRB, 0.15322464E-05_JPRB, 0.15527880E-05_JPRB, 0.15698888E-05_JPRB, 0.15834505E-05_JPRB, 0.15934559E-05_JPRB, &
  & 0.16001987E-05_JPRB, 0.16040418E-05_JPRB, 0.16054883E-05_JPRB, 0.16051595E-05_JPRB, 0.16037876E-05_JPRB, 0.16018964E-05_JPRB, &
  & 0.15997942E-05_JPRB, 0.15976657E-05_JPRB, 0.15954364E-05_JPRB, 0.15929726E-05_JPRB, 0.15898569E-05_JPRB, 0.15859354E-05_JPRB, &
  & 0.15807643E-05_JPRB, 0.15743541E-05_JPRB, 0.15664100E-05_JPRB, 0.15569058E-05_JPRB, 0.15459553E-05_JPRB, 0.15339749E-05_JPRB, &
  & 0.15212887E-05_JPRB, 0.15080840E-05_JPRB, 0.14946041E-05_JPRB, 0.14812183E-05_JPRB, 0.14682892E-05_JPRB, 0.14560763E-05_JPRB, &
  & 0.14446642E-05_JPRB, 0.14340834E-05_JPRB, 0.14242812E-05_JPRB, 0.14152282E-05_JPRB, 0.14069144E-05_JPRB, 0.13993608E-05_JPRB, &
  & 0.13925627E-05_JPRB, 0.13863310E-05_JPRB, 0.13799729E-05_JPRB, 0.13699272E-05_JPRB /)

RGHG2(:,26, 9) = (/ &
  & 0.11614069E-05_JPRB, 0.11546942E-05_JPRB, 0.11475635E-05_JPRB, 0.11403358E-05_JPRB, 0.11334126E-05_JPRB, 0.11282649E-05_JPRB, &
  & 0.11260131E-05_JPRB, 0.11281140E-05_JPRB, 0.11355373E-05_JPRB, 0.11486945E-05_JPRB, 0.11672946E-05_JPRB, 0.11906153E-05_JPRB, &
  & 0.12174539E-05_JPRB, 0.12464423E-05_JPRB, 0.12762607E-05_JPRB, 0.13058026E-05_JPRB, 0.13342817E-05_JPRB, 0.13614952E-05_JPRB, &
  & 0.13874967E-05_JPRB, 0.14125700E-05_JPRB, 0.14371959E-05_JPRB, 0.14616935E-05_JPRB, 0.14862012E-05_JPRB, 0.15105253E-05_JPRB, &
  & 0.15339783E-05_JPRB, 0.15555399E-05_JPRB, 0.15746697E-05_JPRB, 0.15910268E-05_JPRB, 0.16044262E-05_JPRB, 0.16151200E-05_JPRB, &
  & 0.16231691E-05_JPRB, 0.16288024E-05_JPRB, 0.16323320E-05_JPRB, 0.16340991E-05_JPRB, 0.16344768E-05_JPRB, 0.16337914E-05_JPRB, &
  & 0.16322648E-05_JPRB, 0.16299551E-05_JPRB, 0.16269199E-05_JPRB, 0.16232053E-05_JPRB, 0.16186199E-05_JPRB, 0.16131910E-05_JPRB, &
  & 0.16067091E-05_JPRB, 0.15991310E-05_JPRB, 0.15903209E-05_JPRB, 0.15803273E-05_JPRB, 0.15693195E-05_JPRB, 0.15575476E-05_JPRB, &
  & 0.15452304E-05_JPRB, 0.15325934E-05_JPRB, 0.15199016E-05_JPRB, 0.15074579E-05_JPRB, 0.14955567E-05_JPRB, 0.14843611E-05_JPRB, &
  & 0.14739262E-05_JPRB, 0.14642287E-05_JPRB, 0.14552163E-05_JPRB, 0.14468463E-05_JPRB, 0.14391112E-05_JPRB, 0.14320105E-05_JPRB, &
  & 0.14255579E-05_JPRB, 0.14196553E-05_JPRB, 0.14135435E-05_JPRB, 0.14043592E-05_JPRB /)

RGHG2(:,27, 9) = (/ &
  & 0.12143171E-05_JPRB, 0.12084731E-05_JPRB, 0.12024911E-05_JPRB, 0.11960904E-05_JPRB, 0.11901941E-05_JPRB, 0.11852503E-05_JPRB, &
  & 0.11827636E-05_JPRB, 0.11839121E-05_JPRB, 0.11897198E-05_JPRB, 0.12006482E-05_JPRB, 0.12167075E-05_JPRB, 0.12373146E-05_JPRB, &
  & 0.12616008E-05_JPRB, 0.12884084E-05_JPRB, 0.13165464E-05_JPRB, 0.13448649E-05_JPRB, 0.13725505E-05_JPRB, 0.13990657E-05_JPRB, &
  & 0.14242107E-05_JPRB, 0.14483153E-05_JPRB, 0.14715921E-05_JPRB, 0.14943446E-05_JPRB, 0.15166255E-05_JPRB, 0.15383936E-05_JPRB, &
  & 0.15591717E-05_JPRB, 0.15783801E-05_JPRB, 0.15956681E-05_JPRB, 0.16107209E-05_JPRB, 0.16234908E-05_JPRB, 0.16340313E-05_JPRB, &
  & 0.16425976E-05_JPRB, 0.16492676E-05_JPRB, 0.16541244E-05_JPRB, 0.16572758E-05_JPRB, 0.16588606E-05_JPRB, 0.16590139E-05_JPRB, &
  & 0.16578390E-05_JPRB, 0.16554151E-05_JPRB, 0.16518186E-05_JPRB, 0.16472131E-05_JPRB, 0.16416150E-05_JPRB, 0.16351088E-05_JPRB, &
  & 0.16277095E-05_JPRB, 0.16193304E-05_JPRB, 0.16099591E-05_JPRB, 0.15996138E-05_JPRB, 0.15885770E-05_JPRB, 0.15771063E-05_JPRB, &
  & 0.15653961E-05_JPRB, 0.15535240E-05_JPRB, 0.15416799E-05_JPRB, 0.15301487E-05_JPRB, 0.15191677E-05_JPRB, 0.15088705E-05_JPRB, &
  & 0.14992579E-05_JPRB, 0.14903012E-05_JPRB, 0.14819404E-05_JPRB, 0.14741133E-05_JPRB, 0.14667900E-05_JPRB, 0.14599954E-05_JPRB, &
  & 0.14537987E-05_JPRB, 0.14480075E-05_JPRB, 0.14422931E-05_JPRB, 0.14335918E-05_JPRB /)

RGHG2(:,28, 9) = (/ &
  & 0.12636868E-05_JPRB, 0.12588757E-05_JPRB, 0.12539863E-05_JPRB, 0.12489827E-05_JPRB, 0.12438760E-05_JPRB, 0.12397994E-05_JPRB, &
  & 0.12375154E-05_JPRB, 0.12383415E-05_JPRB, 0.12432255E-05_JPRB, 0.12527423E-05_JPRB, 0.12669328E-05_JPRB, 0.12855058E-05_JPRB, &
  & 0.13077245E-05_JPRB, 0.13326355E-05_JPRB, 0.13591361E-05_JPRB, 0.13861619E-05_JPRB, 0.14127687E-05_JPRB, 0.14381513E-05_JPRB, &
  & 0.14621664E-05_JPRB, 0.14849072E-05_JPRB, 0.15064619E-05_JPRB, 0.15270876E-05_JPRB, 0.15468671E-05_JPRB, 0.15658247E-05_JPRB, &
  & 0.15837237E-05_JPRB, 0.16001916E-05_JPRB, 0.16150425E-05_JPRB, 0.16283213E-05_JPRB, 0.16400955E-05_JPRB, 0.16503838E-05_JPRB, &
  & 0.16590955E-05_JPRB, 0.16662468E-05_JPRB, 0.16717934E-05_JPRB, 0.16756949E-05_JPRB, 0.16779429E-05_JPRB, 0.16785553E-05_JPRB, &
  & 0.16775654E-05_JPRB, 0.16750677E-05_JPRB, 0.16711577E-05_JPRB, 0.16660308E-05_JPRB, 0.16598547E-05_JPRB, 0.16527329E-05_JPRB, &
  & 0.16447959E-05_JPRB, 0.16360292E-05_JPRB, 0.16264397E-05_JPRB, 0.16161221E-05_JPRB, 0.16053102E-05_JPRB, 0.15942692E-05_JPRB, &
  & 0.15831451E-05_JPRB, 0.15719970E-05_JPRB, 0.15609570E-05_JPRB, 0.15502592E-05_JPRB, 0.15400979E-05_JPRB, 0.15305625E-05_JPRB, &
  & 0.15216581E-05_JPRB, 0.15133550E-05_JPRB, 0.15055631E-05_JPRB, 0.14982307E-05_JPRB, 0.14913642E-05_JPRB, 0.14850223E-05_JPRB, &
  & 0.14792620E-05_JPRB, 0.14740874E-05_JPRB, 0.14687292E-05_JPRB, 0.14604659E-05_JPRB /)

RGHG2(:,29, 9) = (/ &
  & 0.13102791E-05_JPRB, 0.13067360E-05_JPRB, 0.13030135E-05_JPRB, 0.12988786E-05_JPRB, 0.12950038E-05_JPRB, 0.12916523E-05_JPRB, &
  & 0.12899221E-05_JPRB, 0.12908347E-05_JPRB, 0.12953406E-05_JPRB, 0.13039797E-05_JPRB, 0.13169513E-05_JPRB, 0.13339700E-05_JPRB, &
  & 0.13544895E-05_JPRB, 0.13776521E-05_JPRB, 0.14024758E-05_JPRB, 0.14279249E-05_JPRB, 0.14530762E-05_JPRB, 0.14768792E-05_JPRB, &
  & 0.14994654E-05_JPRB, 0.15205150E-05_JPRB, 0.15401232E-05_JPRB, 0.15584774E-05_JPRB, 0.15757046E-05_JPRB, 0.15919173E-05_JPRB, &
  & 0.16070089E-05_JPRB, 0.16208114E-05_JPRB, 0.16334225E-05_JPRB, 0.16449650E-05_JPRB, 0.16554504E-05_JPRB, 0.16649803E-05_JPRB, &
  & 0.16734120E-05_JPRB, 0.16805661E-05_JPRB, 0.16862970E-05_JPRB, 0.16904546E-05_JPRB, 0.16929459E-05_JPRB, 0.16937252E-05_JPRB, &
  & 0.16927942E-05_JPRB, 0.16902470E-05_JPRB, 0.16862185E-05_JPRB, 0.16808583E-05_JPRB, 0.16744452E-05_JPRB, 0.16670691E-05_JPRB, &
  & 0.16589548E-05_JPRB, 0.16501059E-05_JPRB, 0.16405982E-05_JPRB, 0.16305148E-05_JPRB, 0.16200817E-05_JPRB, 0.16095356E-05_JPRB, &
  & 0.15989655E-05_JPRB, 0.15884697E-05_JPRB, 0.15781918E-05_JPRB, 0.15683042E-05_JPRB, 0.15589243E-05_JPRB, 0.15501020E-05_JPRB, &
  & 0.15418364E-05_JPRB, 0.15340661E-05_JPRB, 0.15267549E-05_JPRB, 0.15198809E-05_JPRB, 0.15134597E-05_JPRB, 0.15075445E-05_JPRB, &
  & 0.15021745E-05_JPRB, 0.14971483E-05_JPRB, 0.14921143E-05_JPRB, 0.14839104E-05_JPRB /)

RGHG2(:,30, 9) = (/ &
  & 0.13542763E-05_JPRB, 0.13516278E-05_JPRB, 0.13486859E-05_JPRB, 0.13457292E-05_JPRB, 0.13426912E-05_JPRB, 0.13402667E-05_JPRB, &
  & 0.13391505E-05_JPRB, 0.13403728E-05_JPRB, 0.13448108E-05_JPRB, 0.13530191E-05_JPRB, 0.13651144E-05_JPRB, 0.13809528E-05_JPRB, &
  & 0.13999934E-05_JPRB, 0.14214984E-05_JPRB, 0.14445125E-05_JPRB, 0.14682262E-05_JPRB, 0.14914922E-05_JPRB, 0.15135832E-05_JPRB, &
  & 0.15343660E-05_JPRB, 0.15535841E-05_JPRB, 0.15711990E-05_JPRB, 0.15873657E-05_JPRB, 0.16022560E-05_JPRB, 0.16159736E-05_JPRB, &
  & 0.16285549E-05_JPRB, 0.16400418E-05_JPRB, 0.16506183E-05_JPRB, 0.16604752E-05_JPRB, 0.16696948E-05_JPRB, 0.16782769E-05_JPRB, &
  & 0.16860960E-05_JPRB, 0.16928980E-05_JPRB, 0.16984409E-05_JPRB, 0.17025069E-05_JPRB, 0.17049578E-05_JPRB, 0.17057127E-05_JPRB, &
  & 0.17047627E-05_JPRB, 0.17022029E-05_JPRB, 0.16981792E-05_JPRB, 0.16928311E-05_JPRB, 0.16863935E-05_JPRB, 0.16790821E-05_JPRB, &
  & 0.16710073E-05_JPRB, 0.16623612E-05_JPRB, 0.16531258E-05_JPRB, 0.16434524E-05_JPRB, 0.16335258E-05_JPRB, 0.16235451E-05_JPRB, &
  & 0.16136277E-05_JPRB, 0.16038265E-05_JPRB, 0.15942512E-05_JPRB, 0.15850447E-05_JPRB, 0.15763023E-05_JPRB, 0.15680340E-05_JPRB, &
  & 0.15602309E-05_JPRB, 0.15528917E-05_JPRB, 0.15459733E-05_JPRB, 0.15394579E-05_JPRB, 0.15333510E-05_JPRB, 0.15277000E-05_JPRB, &
  & 0.15225371E-05_JPRB, 0.15178858E-05_JPRB, 0.15130836E-05_JPRB, 0.15060201E-05_JPRB /)

RGHG2(:,31, 9) = (/ &
  & 0.13947014E-05_JPRB, 0.13928361E-05_JPRB, 0.13907294E-05_JPRB, 0.13885410E-05_JPRB, 0.13864772E-05_JPRB, 0.13848434E-05_JPRB, &
  & 0.13843917E-05_JPRB, 0.13860615E-05_JPRB, 0.13906377E-05_JPRB, 0.13985882E-05_JPRB, 0.14100835E-05_JPRB, 0.14248926E-05_JPRB, &
  & 0.14425765E-05_JPRB, 0.14624194E-05_JPRB, 0.14836111E-05_JPRB, 0.15053329E-05_JPRB, 0.15266673E-05_JPRB, 0.15468993E-05_JPRB, &
  & 0.15658180E-05_JPRB, 0.15831865E-05_JPRB, 0.15989467E-05_JPRB, 0.16131960E-05_JPRB, 0.16260283E-05_JPRB, 0.16376603E-05_JPRB, &
  & 0.16481563E-05_JPRB, 0.16577288E-05_JPRB, 0.16666086E-05_JPRB, 0.16749607E-05_JPRB, 0.16829290E-05_JPRB, 0.16904934E-05_JPRB, &
  & 0.16975199E-05_JPRB, 0.17037263E-05_JPRB, 0.17088370E-05_JPRB, 0.17125832E-05_JPRB, 0.17148138E-05_JPRB, 0.17154330E-05_JPRB, &
  & 0.17144333E-05_JPRB, 0.17119035E-05_JPRB, 0.17079830E-05_JPRB, 0.17028100E-05_JPRB, 0.16965770E-05_JPRB, 0.16894629E-05_JPRB, &
  & 0.16817205E-05_JPRB, 0.16733765E-05_JPRB, 0.16645919E-05_JPRB, 0.16554113E-05_JPRB, 0.16460363E-05_JPRB, 0.16366607E-05_JPRB, &
  & 0.16273738E-05_JPRB, 0.16182314E-05_JPRB, 0.16093029E-05_JPRB, 0.16006842E-05_JPRB, 0.15924541E-05_JPRB, 0.15846382E-05_JPRB, &
  & 0.15772594E-05_JPRB, 0.15703109E-05_JPRB, 0.15637588E-05_JPRB, 0.15575690E-05_JPRB, 0.15517771E-05_JPRB, 0.15464575E-05_JPRB, &
  & 0.15416774E-05_JPRB, 0.15372868E-05_JPRB, 0.15328988E-05_JPRB, 0.15255936E-05_JPRB /)

RGHG2(:,32, 9) = (/ &
  & 0.14313016E-05_JPRB, 0.14301830E-05_JPRB, 0.14286823E-05_JPRB, 0.14272346E-05_JPRB, 0.14258680E-05_JPRB, 0.14249755E-05_JPRB, &
  & 0.14252126E-05_JPRB, 0.14273647E-05_JPRB, 0.14321595E-05_JPRB, 0.14400030E-05_JPRB, 0.14509292E-05_JPRB, 0.14647895E-05_JPRB, &
  & 0.14811289E-05_JPRB, 0.14993276E-05_JPRB, 0.15186372E-05_JPRB, 0.15383678E-05_JPRB, 0.15577117E-05_JPRB, 0.15761484E-05_JPRB, &
  & 0.15933225E-05_JPRB, 0.16090601E-05_JPRB, 0.16232016E-05_JPRB, 0.16358084E-05_JPRB, 0.16470128E-05_JPRB, 0.16569476E-05_JPRB, &
  & 0.16658262E-05_JPRB, 0.16738700E-05_JPRB, 0.16813236E-05_JPRB, 0.16883992E-05_JPRB, 0.16952164E-05_JPRB, 0.17017708E-05_JPRB, &
  & 0.17079191E-05_JPRB, 0.17133950E-05_JPRB, 0.17179113E-05_JPRB, 0.17211973E-05_JPRB, 0.17231021E-05_JPRB, 0.17235313E-05_JPRB, &
  & 0.17224833E-05_JPRB, 0.17200379E-05_JPRB, 0.17162865E-05_JPRB, 0.17114284E-05_JPRB, 0.17055370E-05_JPRB, 0.16987872E-05_JPRB, &
  & 0.16914416E-05_JPRB, 0.16835991E-05_JPRB, 0.16752995E-05_JPRB, 0.16666841E-05_JPRB, 0.16579086E-05_JPRB, 0.16491122E-05_JPRB, &
  & 0.16404142E-05_JPRB, 0.16318497E-05_JPRB, 0.16234857E-05_JPRB, 0.16153887E-05_JPRB, 0.16076319E-05_JPRB, 0.16002637E-05_JPRB, &
  & 0.15932497E-05_JPRB, 0.15866381E-05_JPRB, 0.15803812E-05_JPRB, 0.15744604E-05_JPRB, 0.15689470E-05_JPRB, 0.15638922E-05_JPRB, &
  & 0.15593193E-05_JPRB, 0.15551554E-05_JPRB, 0.15508061E-05_JPRB, 0.15441630E-05_JPRB /)

RGHG2(:,33, 9) = (/ &
  & 0.14640917E-05_JPRB, 0.14635605E-05_JPRB, 0.14626057E-05_JPRB, 0.14616447E-05_JPRB, 0.14608954E-05_JPRB, 0.14606675E-05_JPRB, &
  & 0.14615019E-05_JPRB, 0.14641631E-05_JPRB, 0.14692030E-05_JPRB, 0.14768970E-05_JPRB, 0.14873010E-05_JPRB, 0.15001741E-05_JPRB, &
  & 0.15151716E-05_JPRB, 0.15317337E-05_JPRB, 0.15492535E-05_JPRB, 0.15670316E-05_JPRB, 0.15845370E-05_JPRB, 0.16012333E-05_JPRB, &
  & 0.16168566E-05_JPRB, 0.16311396E-05_JPRB, 0.16440173E-05_JPRB, 0.16554166E-05_JPRB, 0.16653692E-05_JPRB, 0.16740546E-05_JPRB, &
  & 0.16816999E-05_JPRB, 0.16885538E-05_JPRB, 0.16948663E-05_JPRB, 0.17008417E-05_JPRB, 0.17066228E-05_JPRB, 0.17121938E-05_JPRB, &
  & 0.17174395E-05_JPRB, 0.17221080E-05_JPRB, 0.17259397E-05_JPRB, 0.17286870E-05_JPRB, 0.17302109E-05_JPRB, 0.17304333E-05_JPRB, &
  & 0.17293551E-05_JPRB, 0.17270326E-05_JPRB, 0.17235410E-05_JPRB, 0.17190562E-05_JPRB, 0.17136281E-05_JPRB, 0.17073341E-05_JPRB, &
  & 0.17004839E-05_JPRB, 0.16931596E-05_JPRB, 0.16854509E-05_JPRB, 0.16773783E-05_JPRB, 0.16691620E-05_JPRB, 0.16609488E-05_JPRB, &
  & 0.16527898E-05_JPRB, 0.16447676E-05_JPRB, 0.16369027E-05_JPRB, 0.16292831E-05_JPRB, 0.16219375E-05_JPRB, 0.16149403E-05_JPRB, &
  & 0.16082806E-05_JPRB, 0.16019521E-05_JPRB, 0.15959538E-05_JPRB, 0.15902851E-05_JPRB, 0.15849987E-05_JPRB, 0.15801489E-05_JPRB, &
  & 0.15758051E-05_JPRB, 0.15718351E-05_JPRB, 0.15678539E-05_JPRB, 0.15612484E-05_JPRB /)

RGHG2(:,34, 9) = (/ &
  & 0.14925768E-05_JPRB, 0.14927803E-05_JPRB, 0.14923980E-05_JPRB, 0.14919541E-05_JPRB, 0.14917393E-05_JPRB, 0.14920681E-05_JPRB, &
  & 0.14934865E-05_JPRB, 0.14965665E-05_JPRB, 0.15017811E-05_JPRB, 0.15093278E-05_JPRB, 0.15191180E-05_JPRB, 0.15310237E-05_JPRB, &
  & 0.15446898E-05_JPRB, 0.15597001E-05_JPRB, 0.15755056E-05_JPRB, 0.15915715E-05_JPRB, 0.16073589E-05_JPRB, 0.16225561E-05_JPRB, &
  & 0.16368363E-05_JPRB, 0.16499986E-05_JPRB, 0.16618927E-05_JPRB, 0.16723350E-05_JPRB, 0.16813804E-05_JPRB, 0.16891870E-05_JPRB, &
  & 0.16959489E-05_JPRB, 0.17018878E-05_JPRB, 0.17072736E-05_JPRB, 0.17123183E-05_JPRB, 0.17171510E-05_JPRB, 0.17217939E-05_JPRB, &
  & 0.17261342E-05_JPRB, 0.17299727E-05_JPRB, 0.17330814E-05_JPRB, 0.17352602E-05_JPRB, 0.17363875E-05_JPRB, 0.17364098E-05_JPRB, &
  & 0.17353241E-05_JPRB, 0.17331643E-05_JPRB, 0.17299911E-05_JPRB, 0.17259405E-05_JPRB, 0.17209757E-05_JPRB, 0.17152483E-05_JPRB, &
  & 0.17089205E-05_JPRB, 0.17021309E-05_JPRB, 0.16950135E-05_JPRB, 0.16875157E-05_JPRB, 0.16797903E-05_JPRB, 0.16721277E-05_JPRB, &
  & 0.16644684E-05_JPRB, 0.16569070E-05_JPRB, 0.16494751E-05_JPRB, 0.16422804E-05_JPRB, 0.16353124E-05_JPRB, 0.16286682E-05_JPRB, &
  & 0.16223412E-05_JPRB, 0.16163112E-05_JPRB, 0.16105952E-05_JPRB, 0.16051795E-05_JPRB, 0.16001217E-05_JPRB, 0.15954947E-05_JPRB, &
  & 0.15913485E-05_JPRB, 0.15875742E-05_JPRB, 0.15836141E-05_JPRB, 0.15773029E-05_JPRB /)

RGHG2(:,35, 9) = (/ &
  & 0.15179170E-05_JPRB, 0.15183838E-05_JPRB, 0.15184910E-05_JPRB, 0.15185079E-05_JPRB, 0.15187575E-05_JPRB, 0.15195903E-05_JPRB, &
  & 0.15214423E-05_JPRB, 0.15248668E-05_JPRB, 0.15301824E-05_JPRB, 0.15374554E-05_JPRB, 0.15466622E-05_JPRB, 0.15575789E-05_JPRB, &
  & 0.15700100E-05_JPRB, 0.15835575E-05_JPRB, 0.15978379E-05_JPRB, 0.16123199E-05_JPRB, 0.16266458E-05_JPRB, 0.16405135E-05_JPRB, &
  & 0.16536568E-05_JPRB, 0.16658967E-05_JPRB, 0.16770159E-05_JPRB, 0.16868257E-05_JPRB, 0.16953140E-05_JPRB, 0.17025493E-05_JPRB, &
  & 0.17086825E-05_JPRB, 0.17139367E-05_JPRB, 0.17185630E-05_JPRB, 0.17227895E-05_JPRB, 0.17267646E-05_JPRB, 0.17305169E-05_JPRB, &
  & 0.17339789E-05_JPRB, 0.17369968E-05_JPRB, 0.17393885E-05_JPRB, 0.17410063E-05_JPRB, 0.17417569E-05_JPRB, 0.17416043E-05_JPRB, &
  & 0.17405416E-05_JPRB, 0.17385794E-05_JPRB, 0.17357638E-05_JPRB, 0.17321549E-05_JPRB, 0.17277055E-05_JPRB, 0.17225174E-05_JPRB, &
  & 0.17167276E-05_JPRB, 0.17105168E-05_JPRB, 0.17039406E-05_JPRB, 0.16969661E-05_JPRB, 0.16897274E-05_JPRB, 0.16825456E-05_JPRB, &
  & 0.16753520E-05_JPRB, 0.16681919E-05_JPRB, 0.16611436E-05_JPRB, 0.16543266E-05_JPRB, 0.16477336E-05_JPRB, 0.16414172E-05_JPRB, &
  & 0.16354537E-05_JPRB, 0.16297636E-05_JPRB, 0.16243386E-05_JPRB, 0.16191858E-05_JPRB, 0.16143584E-05_JPRB, 0.16099314E-05_JPRB, &
  & 0.16059588E-05_JPRB, 0.16023095E-05_JPRB, 0.15985701E-05_JPRB, 0.15923547E-05_JPRB /)

RGHG2(:,36, 9) = (/ &
  & 0.15396715E-05_JPRB, 0.15409462E-05_JPRB, 0.15414230E-05_JPRB, 0.15418232E-05_JPRB, 0.15424728E-05_JPRB, 0.15436826E-05_JPRB, &
  & 0.15459034E-05_JPRB, 0.15495352E-05_JPRB, 0.15548226E-05_JPRB, 0.15618144E-05_JPRB, 0.15703614E-05_JPRB, 0.15803735E-05_JPRB, &
  & 0.15916246E-05_JPRB, 0.16038689E-05_JPRB, 0.16167249E-05_JPRB, 0.16298532E-05_JPRB, 0.16428386E-05_JPRB, 0.16555578E-05_JPRB, &
  & 0.16677653E-05_JPRB, 0.16792368E-05_JPRB, 0.16898042E-05_JPRB, 0.16992382E-05_JPRB, 0.17073791E-05_JPRB, 0.17142399E-05_JPRB, &
  & 0.17198977E-05_JPRB, 0.17245761E-05_JPRB, 0.17285508E-05_JPRB, 0.17320494E-05_JPRB, 0.17352289E-05_JPRB, 0.17381556E-05_JPRB, &
  & 0.17407954E-05_JPRB, 0.17430422E-05_JPRB, 0.17447737E-05_JPRB, 0.17458826E-05_JPRB, 0.17463110E-05_JPRB, 0.17460357E-05_JPRB, &
  & 0.17450413E-05_JPRB, 0.17433222E-05_JPRB, 0.17408931E-05_JPRB, 0.17377505E-05_JPRB, 0.17338029E-05_JPRB, 0.17291375E-05_JPRB, &
  & 0.17239198E-05_JPRB, 0.17182763E-05_JPRB, 0.17121538E-05_JPRB, 0.17056568E-05_JPRB, 0.16989244E-05_JPRB, 0.16921501E-05_JPRB, &
  & 0.16853578E-05_JPRB, 0.16785377E-05_JPRB, 0.16718407E-05_JPRB, 0.16653676E-05_JPRB, 0.16591406E-05_JPRB, 0.16531990E-05_JPRB, &
  & 0.16476113E-05_JPRB, 0.16422815E-05_JPRB, 0.16371845E-05_JPRB, 0.16323287E-05_JPRB, 0.16277539E-05_JPRB, 0.16235455E-05_JPRB, &
  & 0.16197538E-05_JPRB, 0.16162780E-05_JPRB, 0.16126079E-05_JPRB, 0.16065582E-05_JPRB /)

RGHG2(:,37, 9) = (/ &
  & 0.15590590E-05_JPRB, 0.15609878E-05_JPRB, 0.15617709E-05_JPRB, 0.15624926E-05_JPRB, 0.15634563E-05_JPRB, 0.15649969E-05_JPRB, &
  & 0.15674632E-05_JPRB, 0.15712119E-05_JPRB, 0.15764061E-05_JPRB, 0.15829979E-05_JPRB, 0.15909209E-05_JPRB, 0.16000141E-05_JPRB, &
  & 0.16101837E-05_JPRB, 0.16211891E-05_JPRB, 0.16327846E-05_JPRB, 0.16446302E-05_JPRB, 0.16565098E-05_JPRB, 0.16681360E-05_JPRB, &
  & 0.16795473E-05_JPRB, 0.16904685E-05_JPRB, 0.17006215E-05_JPRB, 0.17097503E-05_JPRB, 0.17176027E-05_JPRB, 0.17240546E-05_JPRB, &
  & 0.17292207E-05_JPRB, 0.17333197E-05_JPRB, 0.17366605E-05_JPRB, 0.17394900E-05_JPRB, 0.17419713E-05_JPRB, 0.17441824E-05_JPRB, &
  & 0.17461199E-05_JPRB, 0.17477264E-05_JPRB, 0.17489170E-05_JPRB, 0.17496277E-05_JPRB, 0.17498254E-05_JPRB, 0.17494988E-05_JPRB, &
  & 0.17486350E-05_JPRB, 0.17472096E-05_JPRB, 0.17452152E-05_JPRB, 0.17425771E-05_JPRB, 0.17391696E-05_JPRB, 0.17350966E-05_JPRB, &
  & 0.17304607E-05_JPRB, 0.17252720E-05_JPRB, 0.17196104E-05_JPRB, 0.17135941E-05_JPRB, 0.17073223E-05_JPRB, 0.17009124E-05_JPRB, &
  & 0.16944412E-05_JPRB, 0.16879530E-05_JPRB, 0.16815766E-05_JPRB, 0.16754269E-05_JPRB, 0.16695608E-05_JPRB, 0.16640198E-05_JPRB, &
  & 0.16588322E-05_JPRB, 0.16539093E-05_JPRB, 0.16491858E-05_JPRB, 0.16446612E-05_JPRB, 0.16403762E-05_JPRB, 0.16364088E-05_JPRB, &
  & 0.16328128E-05_JPRB, 0.16294711E-05_JPRB, 0.16259409E-05_JPRB, 0.16200203E-05_JPRB /)

RGHG2(:,38, 9) = (/ &
  & 0.15771486E-05_JPRB, 0.15790243E-05_JPRB, 0.15800484E-05_JPRB, 0.15810276E-05_JPRB, 0.15822842E-05_JPRB, 0.15840867E-05_JPRB, &
  & 0.15867572E-05_JPRB, 0.15905416E-05_JPRB, 0.15955292E-05_JPRB, 0.16016920E-05_JPRB, 0.16089257E-05_JPRB, 0.16171351E-05_JPRB, &
  & 0.16262325E-05_JPRB, 0.16360813E-05_JPRB, 0.16464705E-05_JPRB, 0.16571682E-05_JPRB, 0.16679976E-05_JPRB, 0.16787994E-05_JPRB, &
  & 0.16894169E-05_JPRB, 0.16997640E-05_JPRB, 0.17095299E-05_JPRB, 0.17182699E-05_JPRB, 0.17256451E-05_JPRB, 0.17315472E-05_JPRB, &
  & 0.17360657E-05_JPRB, 0.17395353E-05_JPRB, 0.17422750E-05_JPRB, 0.17445358E-05_JPRB, 0.17464693E-05_JPRB, 0.17481532E-05_JPRB, &
  & 0.17495977E-05_JPRB, 0.17507645E-05_JPRB, 0.17515979E-05_JPRB, 0.17520557E-05_JPRB, 0.17521213E-05_JPRB, 0.17517996E-05_JPRB, &
  & 0.17510799E-05_JPRB, 0.17499503E-05_JPRB, 0.17483870E-05_JPRB, 0.17462787E-05_JPRB, 0.17435015E-05_JPRB, 0.17401092E-05_JPRB, &
  & 0.17360669E-05_JPRB, 0.17314237E-05_JPRB, 0.17262754E-05_JPRB, 0.17207317E-05_JPRB, 0.17148573E-05_JPRB, 0.17088033E-05_JPRB, &
  & 0.17026354E-05_JPRB, 0.16964427E-05_JPRB, 0.16903607E-05_JPRB, 0.16845345E-05_JPRB, 0.16790415E-05_JPRB, 0.16739323E-05_JPRB, &
  & 0.16691818E-05_JPRB, 0.16646895E-05_JPRB, 0.16603791E-05_JPRB, 0.16562210E-05_JPRB, 0.16522556E-05_JPRB, 0.16485550E-05_JPRB, &
  & 0.16451689E-05_JPRB, 0.16419955E-05_JPRB, 0.16385947E-05_JPRB, 0.16328244E-05_JPRB /)

RGHG2(:,39, 9) = (/ &
  & 0.15929526E-05_JPRB, 0.15953149E-05_JPRB, 0.15965982E-05_JPRB, 0.15978551E-05_JPRB, 0.15993729E-05_JPRB, 0.16014332E-05_JPRB, &
  & 0.16042629E-05_JPRB, 0.16080066E-05_JPRB, 0.16127320E-05_JPRB, 0.16183899E-05_JPRB, 0.16249071E-05_JPRB, 0.16322215E-05_JPRB, &
  & 0.16402787E-05_JPRB, 0.16489960E-05_JPRB, 0.16582441E-05_JPRB, 0.16678457E-05_JPRB, 0.16776537E-05_JPRB, 0.16876006E-05_JPRB, &
  & 0.16975507E-05_JPRB, 0.17073271E-05_JPRB, 0.17165330E-05_JPRB, 0.17247294E-05_JPRB, 0.17314704E-05_JPRB, 0.17366635E-05_JPRB, &
  & 0.17405431E-05_JPRB, 0.17434439E-05_JPRB, 0.17457027E-05_JPRB, 0.17475451E-05_JPRB, 0.17491070E-05_JPRB, 0.17504533E-05_JPRB, &
  & 0.17515983E-05_JPRB, 0.17525109E-05_JPRB, 0.17531441E-05_JPRB, 0.17534644E-05_JPRB, 0.17534653E-05_JPRB, 0.17531582E-05_JPRB, &
  & 0.17525481E-05_JPRB, 0.17516329E-05_JPRB, 0.17504020E-05_JPRB, 0.17487530E-05_JPRB, 0.17465691E-05_JPRB, 0.17438606E-05_JPRB, &
  & 0.17405093E-05_JPRB, 0.17365338E-05_JPRB, 0.17320020E-05_JPRB, 0.17269613E-05_JPRB, 0.17215267E-05_JPRB, 0.17158351E-05_JPRB, &
  & 0.17099669E-05_JPRB, 0.17040488E-05_JPRB, 0.16982547E-05_JPRB, 0.16927477E-05_JPRB, 0.16876422E-05_JPRB, 0.16829745E-05_JPRB, &
  & 0.16786740E-05_JPRB, 0.16746392E-05_JPRB, 0.16707567E-05_JPRB, 0.16669961E-05_JPRB, 0.16633762E-05_JPRB, 0.16599740E-05_JPRB, &
  & 0.16568257E-05_JPRB, 0.16538382E-05_JPRB, 0.16505809E-05_JPRB, 0.16450249E-05_JPRB /)

RGHG2(:,40, 9) = (/ &
  & 0.16075721E-05_JPRB, 0.16102238E-05_JPRB, 0.16117723E-05_JPRB, 0.16132476E-05_JPRB, 0.16150514E-05_JPRB, 0.16173549E-05_JPRB, &
  & 0.16202907E-05_JPRB, 0.16239685E-05_JPRB, 0.16283631E-05_JPRB, 0.16334723E-05_JPRB, 0.16392636E-05_JPRB, 0.16456842E-05_JPRB, &
  & 0.16527313E-05_JPRB, 0.16603650E-05_JPRB, 0.16685112E-05_JPRB, 0.16770671E-05_JPRB, 0.16859348E-05_JPRB, 0.16950167E-05_JPRB, &
  & 0.17042469E-05_JPRB, 0.17133489E-05_JPRB, 0.17219676E-05_JPRB, 0.17294733E-05_JPRB, 0.17355151E-05_JPRB, 0.17400675E-05_JPRB, &
  & 0.17433916E-05_JPRB, 0.17458599E-05_JPRB, 0.17477710E-05_JPRB, 0.17493287E-05_JPRB, 0.17506470E-05_JPRB, 0.17517875E-05_JPRB, &
  & 0.17527562E-05_JPRB, 0.17535278E-05_JPRB, 0.17540542E-05_JPRB, 0.17543031E-05_JPRB, 0.17542714E-05_JPRB, 0.17539762E-05_JPRB, &
  & 0.17534337E-05_JPRB, 0.17526523E-05_JPRB, 0.17516405E-05_JPRB, 0.17503121E-05_JPRB, 0.17485874E-05_JPRB, 0.17464505E-05_JPRB, &
  & 0.17437624E-05_JPRB, 0.17405099E-05_JPRB, 0.17366717E-05_JPRB, 0.17322241E-05_JPRB, 0.17272994E-05_JPRB, 0.17220065E-05_JPRB, &
  & 0.17164450E-05_JPRB, 0.17108191E-05_JPRB, 0.17053113E-05_JPRB, 0.17001288E-05_JPRB, 0.16954173E-05_JPRB, 0.16911812E-05_JPRB, &
  & 0.16873396E-05_JPRB, 0.16837517E-05_JPRB, 0.16803149E-05_JPRB, 0.16769563E-05_JPRB, 0.16737049E-05_JPRB, 0.16706176E-05_JPRB, &
  & 0.16677385E-05_JPRB, 0.16649594E-05_JPRB, 0.16619093E-05_JPRB, 0.16565914E-05_JPRB /)

RGHG2(:,41, 9) = (/ &
  & 0.16212296E-05_JPRB, 0.16241240E-05_JPRB, 0.16257876E-05_JPRB, 0.16275243E-05_JPRB, 0.16295550E-05_JPRB, 0.16320776E-05_JPRB, &
  & 0.16351310E-05_JPRB, 0.16386540E-05_JPRB, 0.16427036E-05_JPRB, 0.16472609E-05_JPRB, 0.16523187E-05_JPRB, 0.16578847E-05_JPRB, &
  & 0.16639673E-05_JPRB, 0.16705728E-05_JPRB, 0.16776709E-05_JPRB, 0.16852068E-05_JPRB, 0.16931253E-05_JPRB, 0.17013847E-05_JPRB, &
  & 0.17098447E-05_JPRB, 0.17183112E-05_JPRB, 0.17262161E-05_JPRB, 0.17330625E-05_JPRB, 0.17384407E-05_JPRB, 0.17424228E-05_JPRB, &
  & 0.17453128E-05_JPRB, 0.17474506E-05_JPRB, 0.17491114E-05_JPRB, 0.17504672E-05_JPRB, 0.17516242E-05_JPRB, 0.17526281E-05_JPRB, &
  & 0.17534916E-05_JPRB, 0.17541813E-05_JPRB, 0.17546503E-05_JPRB, 0.17548609E-05_JPRB, 0.17548127E-05_JPRB, 0.17545260E-05_JPRB, &
  & 0.17540244E-05_JPRB, 0.17533284E-05_JPRB, 0.17524540E-05_JPRB, 0.17513483E-05_JPRB, 0.17499391E-05_JPRB, 0.17482336E-05_JPRB, &
  & 0.17460942E-05_JPRB, 0.17434949E-05_JPRB, 0.17403414E-05_JPRB, 0.17365747E-05_JPRB, 0.17322092E-05_JPRB, 0.17273574E-05_JPRB, &
  & 0.17221530E-05_JPRB, 0.17168204E-05_JPRB, 0.17115995E-05_JPRB, 0.17067500E-05_JPRB, 0.17024191E-05_JPRB, 0.16986111E-05_JPRB, &
  & 0.16952060E-05_JPRB, 0.16920661E-05_JPRB, 0.16890500E-05_JPRB, 0.16861009E-05_JPRB, 0.16832164E-05_JPRB, 0.16804679E-05_JPRB, &
  & 0.16778738E-05_JPRB, 0.16753487E-05_JPRB, 0.16725106E-05_JPRB, 0.16675483E-05_JPRB /)

RGHG2(:,42, 9) = (/ &
  & 0.16342694E-05_JPRB, 0.16372232E-05_JPRB, 0.16390682E-05_JPRB, 0.16408967E-05_JPRB, 0.16431707E-05_JPRB, 0.16458969E-05_JPRB, &
  & 0.16489523E-05_JPRB, 0.16523484E-05_JPRB, 0.16560176E-05_JPRB, 0.16600301E-05_JPRB, 0.16644008E-05_JPRB, 0.16691567E-05_JPRB, &
  & 0.16743450E-05_JPRB, 0.16799908E-05_JPRB, 0.16861013E-05_JPRB, 0.16926564E-05_JPRB, 0.16996474E-05_JPRB, 0.17070392E-05_JPRB, &
  & 0.17147704E-05_JPRB, 0.17224984E-05_JPRB, 0.17297738E-05_JPRB, 0.17359209E-05_JPRB, 0.17406902E-05_JPRB, 0.17441819E-05_JPRB, &
  & 0.17467088E-05_JPRB, 0.17485893E-05_JPRB, 0.17500566E-05_JPRB, 0.17512651E-05_JPRB, 0.17523022E-05_JPRB, 0.17532161E-05_JPRB, &
  & 0.17540084E-05_JPRB, 0.17546507E-05_JPRB, 0.17550869E-05_JPRB, 0.17552785E-05_JPRB, 0.17552222E-05_JPRB, 0.17549426E-05_JPRB, &
  & 0.17544698E-05_JPRB, 0.17538283E-05_JPRB, 0.17530497E-05_JPRB, 0.17520919E-05_JPRB, 0.17509100E-05_JPRB, 0.17495154E-05_JPRB, &
  & 0.17478020E-05_JPRB, 0.17457340E-05_JPRB, 0.17432193E-05_JPRB, 0.17400901E-05_JPRB, 0.17363386E-05_JPRB, 0.17319696E-05_JPRB, &
  & 0.17271415E-05_JPRB, 0.17221328E-05_JPRB, 0.17172221E-05_JPRB, 0.17126997E-05_JPRB, 0.17087511E-05_JPRB, 0.17053430E-05_JPRB, &
  & 0.17023606E-05_JPRB, 0.16996362E-05_JPRB, 0.16970362E-05_JPRB, 0.16944748E-05_JPRB, 0.16919631E-05_JPRB, 0.16895474E-05_JPRB, &
  & 0.16872602E-05_JPRB, 0.16849995E-05_JPRB, 0.16824478E-05_JPRB, 0.16779002E-05_JPRB /)

RGHG2(:,43, 9) = (/ &
  & 0.16471208E-05_JPRB, 0.16501168E-05_JPRB, 0.16518848E-05_JPRB, 0.16538157E-05_JPRB, 0.16561946E-05_JPRB, 0.16590088E-05_JPRB, &
  & 0.16620930E-05_JPRB, 0.16652643E-05_JPRB, 0.16685814E-05_JPRB, 0.16720765E-05_JPRB, 0.16758049E-05_JPRB, 0.16798233E-05_JPRB, &
  & 0.16841866E-05_JPRB, 0.16889539E-05_JPRB, 0.16941370E-05_JPRB, 0.16997565E-05_JPRB, 0.17058189E-05_JPRB, 0.17123682E-05_JPRB, &
  & 0.17192843E-05_JPRB, 0.17263364E-05_JPRB, 0.17328634E-05_JPRB, 0.17383461E-05_JPRB, 0.17425205E-05_JPRB, 0.17455701E-05_JPRB, &
  & 0.17477900E-05_JPRB, 0.17494560E-05_JPRB, 0.17507707E-05_JPRB, 0.17518621E-05_JPRB, 0.17528117E-05_JPRB, 0.17536574E-05_JPRB, &
  & 0.17544054E-05_JPRB, 0.17550183E-05_JPRB, 0.17554385E-05_JPRB, 0.17556213E-05_JPRB, 0.17555624E-05_JPRB, 0.17552900E-05_JPRB, &
  & 0.17548368E-05_JPRB, 0.17542361E-05_JPRB, 0.17535211E-05_JPRB, 0.17526741E-05_JPRB, 0.17516529E-05_JPRB, 0.17504926E-05_JPRB, &
  & 0.17491052E-05_JPRB, 0.17474699E-05_JPRB, 0.17454807E-05_JPRB, 0.17429700E-05_JPRB, 0.17398138E-05_JPRB, 0.17359600E-05_JPRB, &
  & 0.17315527E-05_JPRB, 0.17268815E-05_JPRB, 0.17222860E-05_JPRB, 0.17181042E-05_JPRB, 0.17145085E-05_JPRB, 0.17114857E-05_JPRB, &
  & 0.17088952E-05_JPRB, 0.17065693E-05_JPRB, 0.17043559E-05_JPRB, 0.17021744E-05_JPRB, 0.17000143E-05_JPRB, 0.16979307E-05_JPRB, &
  & 0.16959441E-05_JPRB, 0.16939771E-05_JPRB, 0.16917279E-05_JPRB, 0.16877085E-05_JPRB /)

RGHG2(:,44, 9) = (/ &
  & 0.16597891E-05_JPRB, 0.16629194E-05_JPRB, 0.16646891E-05_JPRB, 0.16665488E-05_JPRB, 0.16689226E-05_JPRB, 0.16717873E-05_JPRB, &
  & 0.16747413E-05_JPRB, 0.16777100E-05_JPRB, 0.16806586E-05_JPRB, 0.16836698E-05_JPRB, 0.16868098E-05_JPRB, 0.16901465E-05_JPRB, &
  & 0.16937755E-05_JPRB, 0.16977285E-05_JPRB, 0.17020634E-05_JPRB, 0.17067823E-05_JPRB, 0.17119635E-05_JPRB, 0.17176098E-05_JPRB, &
  & 0.17237425E-05_JPRB, 0.17299462E-05_JPRB, 0.17357277E-05_JPRB, 0.17404670E-05_JPRB, 0.17440692E-05_JPRB, 0.17467100E-05_JPRB, &
  & 0.17486581E-05_JPRB, 0.17501434E-05_JPRB, 0.17513300E-05_JPRB, 0.17523289E-05_JPRB, 0.17532097E-05_JPRB, 0.17540085E-05_JPRB, &
  & 0.17547260E-05_JPRB, 0.17553249E-05_JPRB, 0.17557388E-05_JPRB, 0.17559208E-05_JPRB, 0.17558635E-05_JPRB, 0.17555982E-05_JPRB, &
  & 0.17551615E-05_JPRB, 0.17545883E-05_JPRB, 0.17539213E-05_JPRB, 0.17531528E-05_JPRB, 0.17522555E-05_JPRB, 0.17512742E-05_JPRB, &
  & 0.17501452E-05_JPRB, 0.17488541E-05_JPRB, 0.17473199E-05_JPRB, 0.17453510E-05_JPRB, 0.17427836E-05_JPRB, 0.17394821E-05_JPRB, &
  & 0.17355035E-05_JPRB, 0.17311920E-05_JPRB, 0.17269263E-05_JPRB, 0.17230650E-05_JPRB, 0.17198257E-05_JPRB, 0.17171627E-05_JPRB, &
  & 0.17149447E-05_JPRB, 0.17129877E-05_JPRB, 0.17111404E-05_JPRB, 0.17093089E-05_JPRB, 0.17074823E-05_JPRB, 0.17057059E-05_JPRB, &
  & 0.17040130E-05_JPRB, 0.17023317E-05_JPRB, 0.17004180E-05_JPRB, 0.16969902E-05_JPRB /)

RGHG2(:,45, 9) = (/ &
  & 0.16742566E-05_JPRB, 0.16763773E-05_JPRB, 0.16777617E-05_JPRB, 0.16794002E-05_JPRB, 0.16816872E-05_JPRB, 0.16844007E-05_JPRB, &
  & 0.16872206E-05_JPRB, 0.16899107E-05_JPRB, 0.16924881E-05_JPRB, 0.16950322E-05_JPRB, 0.16976163E-05_JPRB, 0.17003474E-05_JPRB, &
  & 0.17032780E-05_JPRB, 0.17065116E-05_JPRB, 0.17100422E-05_JPRB, 0.17139462E-05_JPRB, 0.17182399E-05_JPRB, 0.17230534E-05_JPRB, &
  & 0.17282240E-05_JPRB, 0.17335707E-05_JPRB, 0.17383950E-05_JPRB, 0.17423743E-05_JPRB, 0.17453967E-05_JPRB, 0.17476576E-05_JPRB, &
  & 0.17493653E-05_JPRB, 0.17506939E-05_JPRB, 0.17517748E-05_JPRB, 0.17526994E-05_JPRB, 0.17535281E-05_JPRB, 0.17542936E-05_JPRB, &
  & 0.17549937E-05_JPRB, 0.17555883E-05_JPRB, 0.17560052E-05_JPRB, 0.17561915E-05_JPRB, 0.17561388E-05_JPRB, 0.17558821E-05_JPRB, &
  & 0.17554576E-05_JPRB, 0.17549057E-05_JPRB, 0.17542710E-05_JPRB, 0.17535614E-05_JPRB, 0.17527601E-05_JPRB, 0.17519187E-05_JPRB, &
  & 0.17509971E-05_JPRB, 0.17499868E-05_JPRB, 0.17488223E-05_JPRB, 0.17473344E-05_JPRB, 0.17453399E-05_JPRB, 0.17426014E-05_JPRB, &
  & 0.17391205E-05_JPRB, 0.17351967E-05_JPRB, 0.17312599E-05_JPRB, 0.17277431E-05_JPRB, 0.17248315E-05_JPRB, 0.17225178E-05_JPRB, &
  & 0.17206492E-05_JPRB, 0.17190293E-05_JPRB, 0.17175145E-05_JPRB, 0.17160027E-05_JPRB, 0.17144728E-05_JPRB, 0.17129753E-05_JPRB, &
  & 0.17115444E-05_JPRB, 0.17101393E-05_JPRB, 0.17085479E-05_JPRB, 0.17057280E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART17',1,ZHOOK_HANDLE)
END SUBROUTINE PART17




SUBROUTINE PART18
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART18',0,ZHOOK_HANDLE)



RGHG2(:,46, 9) = (/ &
  & 0.16856239E-05_JPRB, 0.16887207E-05_JPRB, 0.16904696E-05_JPRB, 0.16922842E-05_JPRB, 0.16945194E-05_JPRB, 0.16971642E-05_JPRB, &
  & 0.16997409E-05_JPRB, 0.17021099E-05_JPRB, 0.17042875E-05_JPRB, 0.17063514E-05_JPRB, 0.17084089E-05_JPRB, 0.17105363E-05_JPRB, &
  & 0.17128561E-05_JPRB, 0.17153789E-05_JPRB, 0.17182001E-05_JPRB, 0.17213086E-05_JPRB, 0.17248210E-05_JPRB, 0.17286839E-05_JPRB, &
  & 0.17329373E-05_JPRB, 0.17371140E-05_JPRB, 0.17409545E-05_JPRB, 0.17440841E-05_JPRB, 0.17465472E-05_JPRB, 0.17484530E-05_JPRB, &
  & 0.17499428E-05_JPRB, 0.17511359E-05_JPRB, 0.17521289E-05_JPRB, 0.17529937E-05_JPRB, 0.17537842E-05_JPRB, 0.17545275E-05_JPRB, &
  & 0.17552214E-05_JPRB, 0.17558194E-05_JPRB, 0.17562463E-05_JPRB, 0.17564408E-05_JPRB, 0.17563973E-05_JPRB, 0.17561480E-05_JPRB, &
  & 0.17557342E-05_JPRB, 0.17551947E-05_JPRB, 0.17545831E-05_JPRB, 0.17539176E-05_JPRB, 0.17531914E-05_JPRB, 0.17524637E-05_JPRB, &
  & 0.17517076E-05_JPRB, 0.17509198E-05_JPRB, 0.17500565E-05_JPRB, 0.17489747E-05_JPRB, 0.17474922E-05_JPRB, 0.17453617E-05_JPRB, &
  & 0.17424510E-05_JPRB, 0.17389809E-05_JPRB, 0.17354348E-05_JPRB, 0.17322291E-05_JPRB, 0.17296607E-05_JPRB, 0.17276791E-05_JPRB, &
  & 0.17261186E-05_JPRB, 0.17248051E-05_JPRB, 0.17235736E-05_JPRB, 0.17223365E-05_JPRB, 0.17210665E-05_JPRB, 0.17198040E-05_JPRB, &
  & 0.17186049E-05_JPRB, 0.17174374E-05_JPRB, 0.17161393E-05_JPRB, 0.17138725E-05_JPRB /)

RGHG2(:,47, 9) = (/ &
  & 0.16988608E-05_JPRB, 0.17017394E-05_JPRB, 0.17035326E-05_JPRB, 0.17054052E-05_JPRB, 0.17077158E-05_JPRB, 0.17102166E-05_JPRB, &
  & 0.17125178E-05_JPRB, 0.17145099E-05_JPRB, 0.17162240E-05_JPRB, 0.17177866E-05_JPRB, 0.17192903E-05_JPRB, 0.17208567E-05_JPRB, &
  & 0.17225339E-05_JPRB, 0.17244296E-05_JPRB, 0.17265397E-05_JPRB, 0.17289472E-05_JPRB, 0.17316032E-05_JPRB, 0.17345731E-05_JPRB, &
  & 0.17376053E-05_JPRB, 0.17406251E-05_JPRB, 0.17433081E-05_JPRB, 0.17456302E-05_JPRB, 0.17475428E-05_JPRB, 0.17491192E-05_JPRB, &
  & 0.17504144E-05_JPRB, 0.17514897E-05_JPRB, 0.17524084E-05_JPRB, 0.17532271E-05_JPRB, 0.17539903E-05_JPRB, 0.17547221E-05_JPRB, &
  & 0.17554173E-05_JPRB, 0.17560259E-05_JPRB, 0.17564670E-05_JPRB, 0.17566738E-05_JPRB, 0.17566416E-05_JPRB, 0.17564001E-05_JPRB, &
  & 0.17559933E-05_JPRB, 0.17554631E-05_JPRB, 0.17548657E-05_JPRB, 0.17542313E-05_JPRB, 0.17535684E-05_JPRB, 0.17529287E-05_JPRB, &
  & 0.17523058E-05_JPRB, 0.17516945E-05_JPRB, 0.17510652E-05_JPRB, 0.17503053E-05_JPRB, 0.17492732E-05_JPRB, 0.17477249E-05_JPRB, &
  & 0.17454738E-05_JPRB, 0.17426114E-05_JPRB, 0.17394998E-05_JPRB, 0.17366864E-05_JPRB, 0.17344310E-05_JPRB, 0.17327420E-05_JPRB, &
  & 0.17314642E-05_JPRB, 0.17303909E-05_JPRB, 0.17293994E-05_JPRB, 0.17283847E-05_JPRB, 0.17273211E-05_JPRB, 0.17262543E-05_JPRB, &
  & 0.17252380E-05_JPRB, 0.17242641E-05_JPRB, 0.17232013E-05_JPRB, 0.17213774E-05_JPRB /)

RGHG2(:,48, 9) = (/ &
  & 0.17108372E-05_JPRB, 0.17141917E-05_JPRB, 0.17162878E-05_JPRB, 0.17184279E-05_JPRB, 0.17208846E-05_JPRB, 0.17233698E-05_JPRB, &
  & 0.17254609E-05_JPRB, 0.17270575E-05_JPRB, 0.17283072E-05_JPRB, 0.17293473E-05_JPRB, 0.17303133E-05_JPRB, 0.17312850E-05_JPRB, &
  & 0.17323680E-05_JPRB, 0.17336009E-05_JPRB, 0.17350446E-05_JPRB, 0.17366544E-05_JPRB, 0.17384554E-05_JPRB, 0.17402688E-05_JPRB, &
  & 0.17420952E-05_JPRB, 0.17438110E-05_JPRB, 0.17454604E-05_JPRB, 0.17469910E-05_JPRB, 0.17484064E-05_JPRB, 0.17496797E-05_JPRB, &
  & 0.17507991E-05_JPRB, 0.17517712E-05_JPRB, 0.17526293E-05_JPRB, 0.17534121E-05_JPRB, 0.17541577E-05_JPRB, 0.17548862E-05_JPRB, &
  & 0.17555898E-05_JPRB, 0.17562138E-05_JPRB, 0.17566726E-05_JPRB, 0.17568946E-05_JPRB, 0.17568757E-05_JPRB, 0.17566410E-05_JPRB, &
  & 0.17562404E-05_JPRB, 0.17557147E-05_JPRB, 0.17551253E-05_JPRB, 0.17545154E-05_JPRB, 0.17538996E-05_JPRB, 0.17533322E-05_JPRB, &
  & 0.17528142E-05_JPRB, 0.17523414E-05_JPRB, 0.17518901E-05_JPRB, 0.17513825E-05_JPRB, 0.17507058E-05_JPRB, 0.17496833E-05_JPRB, &
  & 0.17481157E-05_JPRB, 0.17459846E-05_JPRB, 0.17435232E-05_JPRB, 0.17411530E-05_JPRB, 0.17392441E-05_JPRB, 0.17378327E-05_JPRB, &
  & 0.17367688E-05_JPRB, 0.17358948E-05_JPRB, 0.17350774E-05_JPRB, 0.17342318E-05_JPRB, 0.17333232E-05_JPRB, 0.17323953E-05_JPRB, &
  & 0.17315131E-05_JPRB, 0.17306795E-05_JPRB, 0.17297834E-05_JPRB, 0.17282708E-05_JPRB /)

RGHG2(:,49, 9) = (/ &
  & 0.17217508E-05_JPRB, 0.17254911E-05_JPRB, 0.17278442E-05_JPRB, 0.17302083E-05_JPRB, 0.17328947E-05_JPRB, 0.17355246E-05_JPRB, &
  & 0.17375088E-05_JPRB, 0.17388561E-05_JPRB, 0.17397474E-05_JPRB, 0.17403822E-05_JPRB, 0.17408788E-05_JPRB, 0.17413513E-05_JPRB, &
  & 0.17418556E-05_JPRB, 0.17424476E-05_JPRB, 0.17431323E-05_JPRB, 0.17438987E-05_JPRB, 0.17446220E-05_JPRB, 0.17453179E-05_JPRB, &
  & 0.17459424E-05_JPRB, 0.17465871E-05_JPRB, 0.17473232E-05_JPRB, 0.17481900E-05_JPRB, 0.17491536E-05_JPRB, 0.17501536E-05_JPRB, &
  & 0.17511147E-05_JPRB, 0.17519978E-05_JPRB, 0.17528052E-05_JPRB, 0.17535619E-05_JPRB, 0.17542970E-05_JPRB, 0.17550288E-05_JPRB, &
  & 0.17557447E-05_JPRB, 0.17563898E-05_JPRB, 0.17568668E-05_JPRB, 0.17571076E-05_JPRB, 0.17571015E-05_JPRB, 0.17568743E-05_JPRB, &
  & 0.17564779E-05_JPRB, 0.17559545E-05_JPRB, 0.17553709E-05_JPRB, 0.17547763E-05_JPRB, 0.17541993E-05_JPRB, 0.17536868E-05_JPRB, &
  & 0.17532539E-05_JPRB, 0.17528873E-05_JPRB, 0.17525763E-05_JPRB, 0.17522564E-05_JPRB, 0.17518576E-05_JPRB, 0.17512525E-05_JPRB, &
  & 0.17503023E-05_JPRB, 0.17489399E-05_JPRB, 0.17472692E-05_JPRB, 0.17455493E-05_JPRB, 0.17440764E-05_JPRB, 0.17429522E-05_JPRB, &
  & 0.17420846E-05_JPRB, 0.17413697E-05_JPRB, 0.17406808E-05_JPRB, 0.17399540E-05_JPRB, 0.17391525E-05_JPRB, 0.17383138E-05_JPRB, &
  & 0.17375146E-05_JPRB, 0.17367684E-05_JPRB, 0.17359704E-05_JPRB, 0.17346518E-05_JPRB /)

RGHG2(:,50, 9) = (/ &
  & 0.17323971E-05_JPRB, 0.17356233E-05_JPRB, 0.17376581E-05_JPRB, 0.17398680E-05_JPRB, 0.17424562E-05_JPRB, 0.17449997E-05_JPRB, &
  & 0.17468507E-05_JPRB, 0.17479879E-05_JPRB, 0.17486515E-05_JPRB, 0.17490411E-05_JPRB, 0.17492887E-05_JPRB, 0.17494409E-05_JPRB, &
  & 0.17495386E-05_JPRB, 0.17495927E-05_JPRB, 0.17496011E-05_JPRB, 0.17495286E-05_JPRB, 0.17494009E-05_JPRB, 0.17491939E-05_JPRB, &
  & 0.17489864E-05_JPRB, 0.17488599E-05_JPRB, 0.17489201E-05_JPRB, 0.17492376E-05_JPRB, 0.17498094E-05_JPRB, 0.17505588E-05_JPRB, &
  & 0.17513768E-05_JPRB, 0.17521821E-05_JPRB, 0.17529480E-05_JPRB, 0.17536858E-05_JPRB, 0.17544172E-05_JPRB, 0.17551569E-05_JPRB, &
  & 0.17558898E-05_JPRB, 0.17565565E-05_JPRB, 0.17570546E-05_JPRB, 0.17573157E-05_JPRB, 0.17573225E-05_JPRB, 0.17571035E-05_JPRB, &
  & 0.17567108E-05_JPRB, 0.17561889E-05_JPRB, 0.17556072E-05_JPRB, 0.17550244E-05_JPRB, 0.17544743E-05_JPRB, 0.17540073E-05_JPRB, &
  & 0.17536374E-05_JPRB, 0.17533630E-05_JPRB, 0.17531559E-05_JPRB, 0.17529831E-05_JPRB, 0.17527896E-05_JPRB, 0.17525018E-05_JPRB, &
  & 0.17520242E-05_JPRB, 0.17513195E-05_JPRB, 0.17504062E-05_JPRB, 0.17494165E-05_JPRB, 0.17484990E-05_JPRB, 0.17477386E-05_JPRB, &
  & 0.17471328E-05_JPRB, 0.17465807E-05_JPRB, 0.17460475E-05_JPRB, 0.17454477E-05_JPRB, 0.17447499E-05_JPRB, 0.17439993E-05_JPRB, &
  & 0.17432681E-05_JPRB, 0.17425715E-05_JPRB, 0.17418407E-05_JPRB, 0.17405924E-05_JPRB /)

RGHG2(:,51, 9) = (/ &
  & 0.17405102E-05_JPRB, 0.17432774E-05_JPRB, 0.17450775E-05_JPRB, 0.17468960E-05_JPRB, 0.17491632E-05_JPRB, 0.17513532E-05_JPRB, &
  & 0.17528755E-05_JPRB, 0.17537328E-05_JPRB, 0.17541936E-05_JPRB, 0.17544460E-05_JPRB, 0.17545583E-05_JPRB, 0.17545694E-05_JPRB, &
  & 0.17544612E-05_JPRB, 0.17542088E-05_JPRB, 0.17537960E-05_JPRB, 0.17532641E-05_JPRB, 0.17526321E-05_JPRB, 0.17519599E-05_JPRB, &
  & 0.17512814E-05_JPRB, 0.17506928E-05_JPRB, 0.17502848E-05_JPRB, 0.17501694E-05_JPRB, 0.17503947E-05_JPRB, 0.17509133E-05_JPRB, &
  & 0.17515985E-05_JPRB, 0.17523350E-05_JPRB, 0.17530682E-05_JPRB, 0.17537924E-05_JPRB, 0.17545250E-05_JPRB, 0.17552763E-05_JPRB, &
  & 0.17560294E-05_JPRB, 0.17567188E-05_JPRB, 0.17572398E-05_JPRB, 0.17575219E-05_JPRB, 0.17575419E-05_JPRB, 0.17573323E-05_JPRB, &
  & 0.17569417E-05_JPRB, 0.17564213E-05_JPRB, 0.17558414E-05_JPRB, 0.17552650E-05_JPRB, 0.17547343E-05_JPRB, 0.17542992E-05_JPRB, &
  & 0.17539874E-05_JPRB, 0.17537794E-05_JPRB, 0.17536645E-05_JPRB, 0.17536045E-05_JPRB, 0.17535698E-05_JPRB, 0.17535120E-05_JPRB, &
  & 0.17533723E-05_JPRB, 0.17531163E-05_JPRB, 0.17527595E-05_JPRB, 0.17523353E-05_JPRB, 0.17519201E-05_JPRB, 0.17515515E-05_JPRB, &
  & 0.17512198E-05_JPRB, 0.17509194E-05_JPRB, 0.17505843E-05_JPRB, 0.17501898E-05_JPRB, 0.17496957E-05_JPRB, 0.17491092E-05_JPRB, &
  & 0.17485004E-05_JPRB, 0.17479070E-05_JPRB, 0.17472197E-05_JPRB, 0.17460761E-05_JPRB /)

RGHG2(:,52, 9) = (/ &
  & 0.17477187E-05_JPRB, 0.17493985E-05_JPRB, 0.17505226E-05_JPRB, 0.17519454E-05_JPRB, 0.17536734E-05_JPRB, 0.17554214E-05_JPRB, &
  & 0.17565415E-05_JPRB, 0.17571379E-05_JPRB, 0.17574368E-05_JPRB, 0.17575743E-05_JPRB, 0.17576143E-05_JPRB, 0.17575545E-05_JPRB, &
  & 0.17573582E-05_JPRB, 0.17569731E-05_JPRB, 0.17563923E-05_JPRB, 0.17556529E-05_JPRB, 0.17548207E-05_JPRB, 0.17539282E-05_JPRB, &
  & 0.17530365E-05_JPRB, 0.17521731E-05_JPRB, 0.17514643E-05_JPRB, 0.17510115E-05_JPRB, 0.17509331E-05_JPRB, 0.17512328E-05_JPRB, &
  & 0.17517926E-05_JPRB, 0.17524676E-05_JPRB, 0.17531720E-05_JPRB, 0.17538879E-05_JPRB, 0.17546256E-05_JPRB, 0.17553908E-05_JPRB, &
  & 0.17561670E-05_JPRB, 0.17568798E-05_JPRB, 0.17574274E-05_JPRB, 0.17577293E-05_JPRB, 0.17577635E-05_JPRB, 0.17575620E-05_JPRB, &
  & 0.17571749E-05_JPRB, 0.17566550E-05_JPRB, 0.17560773E-05_JPRB, 0.17555038E-05_JPRB, 0.17549854E-05_JPRB, 0.17545791E-05_JPRB, &
  & 0.17543044E-05_JPRB, 0.17541633E-05_JPRB, 0.17541204E-05_JPRB, 0.17541556E-05_JPRB, 0.17542474E-05_JPRB, 0.17543598E-05_JPRB, &
  & 0.17544457E-05_JPRB, 0.17544735E-05_JPRB, 0.17544389E-05_JPRB, 0.17543566E-05_JPRB, 0.17542479E-05_JPRB, 0.17541369E-05_JPRB, &
  & 0.17540276E-05_JPRB, 0.17539085E-05_JPRB, 0.17537711E-05_JPRB, 0.17535846E-05_JPRB, 0.17533196E-05_JPRB, 0.17529773E-05_JPRB, &
  & 0.17525851E-05_JPRB, 0.17521522E-05_JPRB, 0.17516475E-05_JPRB, 0.17506281E-05_JPRB /)

RGHG2(:,53, 9) = (/ &
  & 0.17519960E-05_JPRB, 0.17534103E-05_JPRB, 0.17544246E-05_JPRB, 0.17554300E-05_JPRB, 0.17568140E-05_JPRB, 0.17580805E-05_JPRB, &
  & 0.17588809E-05_JPRB, 0.17592654E-05_JPRB, 0.17594423E-05_JPRB, 0.17595124E-05_JPRB, 0.17595048E-05_JPRB, 0.17594089E-05_JPRB, &
  & 0.17591830E-05_JPRB, 0.17587606E-05_JPRB, 0.17581200E-05_JPRB, 0.17573135E-05_JPRB, 0.17564030E-05_JPRB, 0.17554298E-05_JPRB, &
  & 0.17544078E-05_JPRB, 0.17534153E-05_JPRB, 0.17524836E-05_JPRB, 0.17517756E-05_JPRB, 0.17514353E-05_JPRB, 0.17515329E-05_JPRB, &
  & 0.17519724E-05_JPRB, 0.17525872E-05_JPRB, 0.17532680E-05_JPRB, 0.17539771E-05_JPRB, 0.17547209E-05_JPRB, 0.17555051E-05_JPRB, &
  & 0.17563036E-05_JPRB, 0.17570443E-05_JPRB, 0.17576190E-05_JPRB, 0.17579407E-05_JPRB, 0.17579899E-05_JPRB, 0.17577978E-05_JPRB, &
  & 0.17574118E-05_JPRB, 0.17568942E-05_JPRB, 0.17563170E-05_JPRB, 0.17557464E-05_JPRB, 0.17552363E-05_JPRB, 0.17548452E-05_JPRB, &
  & 0.17546125E-05_JPRB, 0.17545175E-05_JPRB, 0.17545415E-05_JPRB, 0.17546614E-05_JPRB, 0.17548581E-05_JPRB, 0.17550999E-05_JPRB, &
  & 0.17553368E-05_JPRB, 0.17555333E-05_JPRB, 0.17556731E-05_JPRB, 0.17557637E-05_JPRB, 0.17558082E-05_JPRB, 0.17558255E-05_JPRB, &
  & 0.17558236E-05_JPRB, 0.17558070E-05_JPRB, 0.17557720E-05_JPRB, 0.17557086E-05_JPRB, 0.17556014E-05_JPRB, 0.17554378E-05_JPRB, &
  & 0.17552322E-05_JPRB, 0.17550014E-05_JPRB, 0.17546859E-05_JPRB, 0.17540200E-05_JPRB /)

RGHG2(:,54, 9) = (/ &
  & 0.17557160E-05_JPRB, 0.17566929E-05_JPRB, 0.17572977E-05_JPRB, 0.17581021E-05_JPRB, 0.17590297E-05_JPRB, 0.17599705E-05_JPRB, &
  & 0.17604907E-05_JPRB, 0.17607331E-05_JPRB, 0.17608297E-05_JPRB, 0.17608514E-05_JPRB, 0.17608152E-05_JPRB, 0.17607081E-05_JPRB, &
  & 0.17604765E-05_JPRB, 0.17600566E-05_JPRB, 0.17594164E-05_JPRB, 0.17586025E-05_JPRB, 0.17576663E-05_JPRB, 0.17566456E-05_JPRB, &
  & 0.17555756E-05_JPRB, 0.17544508E-05_JPRB, 0.17533829E-05_JPRB, 0.17524675E-05_JPRB, 0.17519038E-05_JPRB, 0.17518216E-05_JPRB, &
  & 0.17521495E-05_JPRB, 0.17527057E-05_JPRB, 0.17533608E-05_JPRB, 0.17540663E-05_JPRB, 0.17548173E-05_JPRB, 0.17556224E-05_JPRB, &
  & 0.17564448E-05_JPRB, 0.17572161E-05_JPRB, 0.17578175E-05_JPRB, 0.17581597E-05_JPRB, 0.17582250E-05_JPRB, 0.17580418E-05_JPRB, &
  & 0.17576591E-05_JPRB, 0.17571415E-05_JPRB, 0.17565645E-05_JPRB, 0.17559952E-05_JPRB, 0.17554906E-05_JPRB, 0.17551187E-05_JPRB, &
  & 0.17549082E-05_JPRB, 0.17548596E-05_JPRB, 0.17549427E-05_JPRB, 0.17551342E-05_JPRB, 0.17554237E-05_JPRB, 0.17557658E-05_JPRB, &
  & 0.17561096E-05_JPRB, 0.17564053E-05_JPRB, 0.17566442E-05_JPRB, 0.17568111E-05_JPRB, 0.17569305E-05_JPRB, 0.17569998E-05_JPRB, &
  & 0.17570449E-05_JPRB, 0.17570703E-05_JPRB, 0.17570809E-05_JPRB, 0.17570740E-05_JPRB, 0.17570417E-05_JPRB, 0.17569788E-05_JPRB, &
  & 0.17568935E-05_JPRB, 0.17567987E-05_JPRB, 0.17567048E-05_JPRB, 0.17565802E-05_JPRB /)

RGHG2(:,55, 9) = (/ &
  & 0.17582372E-05_JPRB, 0.17589817E-05_JPRB, 0.17595326E-05_JPRB, 0.17600491E-05_JPRB, 0.17607551E-05_JPRB, 0.17613513E-05_JPRB, &
  & 0.17617032E-05_JPRB, 0.17618419E-05_JPRB, 0.17618879E-05_JPRB, 0.17618822E-05_JPRB, 0.17618332E-05_JPRB, 0.17617201E-05_JPRB, &
  & 0.17615030E-05_JPRB, 0.17611071E-05_JPRB, 0.17604979E-05_JPRB, 0.17596965E-05_JPRB, 0.17587643E-05_JPRB, 0.17577197E-05_JPRB, &
  & 0.17565720E-05_JPRB, 0.17553804E-05_JPRB, 0.17541604E-05_JPRB, 0.17530778E-05_JPRB, 0.17523436E-05_JPRB, 0.17521086E-05_JPRB, &
  & 0.17523336E-05_JPRB, 0.17528324E-05_JPRB, 0.17534609E-05_JPRB, 0.17541615E-05_JPRB, 0.17549216E-05_JPRB, 0.17557481E-05_JPRB, &
  & 0.17565972E-05_JPRB, 0.17574018E-05_JPRB, 0.17580286E-05_JPRB, 0.17583919E-05_JPRB, 0.17584744E-05_JPRB, 0.17583005E-05_JPRB, &
  & 0.17579193E-05_JPRB, 0.17574025E-05_JPRB, 0.17568258E-05_JPRB, 0.17562544E-05_JPRB, 0.17557577E-05_JPRB, 0.17553971E-05_JPRB, &
  & 0.17552145E-05_JPRB, 0.17552002E-05_JPRB, 0.17553295E-05_JPRB, 0.17555890E-05_JPRB, 0.17559532E-05_JPRB, 0.17563814E-05_JPRB, &
  & 0.17567994E-05_JPRB, 0.17571685E-05_JPRB, 0.17574553E-05_JPRB, 0.17576749E-05_JPRB, 0.17578108E-05_JPRB, 0.17579077E-05_JPRB, &
  & 0.17579664E-05_JPRB, 0.17580076E-05_JPRB, 0.17580346E-05_JPRB, 0.17580486E-05_JPRB, 0.17580455E-05_JPRB, 0.17580205E-05_JPRB, &
  & 0.17579748E-05_JPRB, 0.17579156E-05_JPRB, 0.17578349E-05_JPRB, 0.17576823E-05_JPRB /)

RGHG2(:,56, 9) = (/ &
  & 0.17603801E-05_JPRB, 0.17609127E-05_JPRB, 0.17612376E-05_JPRB, 0.17616385E-05_JPRB, 0.17620687E-05_JPRB, 0.17624732E-05_JPRB, &
  & 0.17626760E-05_JPRB, 0.17627548E-05_JPRB, 0.17627693E-05_JPRB, 0.17627485E-05_JPRB, 0.17626935E-05_JPRB, 0.17625885E-05_JPRB, &
  & 0.17623868E-05_JPRB, 0.17620309E-05_JPRB, 0.17614632E-05_JPRB, 0.17607015E-05_JPRB, 0.17597688E-05_JPRB, 0.17586972E-05_JPRB, &
  & 0.17575021E-05_JPRB, 0.17561842E-05_JPRB, 0.17548527E-05_JPRB, 0.17536310E-05_JPRB, 0.17527468E-05_JPRB, 0.17524001E-05_JPRB, &
  & 0.17525369E-05_JPRB, 0.17529778E-05_JPRB, 0.17535783E-05_JPRB, 0.17542729E-05_JPRB, 0.17550426E-05_JPRB, 0.17558912E-05_JPRB, &
  & 0.17567698E-05_JPRB, 0.17576057E-05_JPRB, 0.17582581E-05_JPRB, 0.17586441E-05_JPRB, 0.17587433E-05_JPRB, 0.17585778E-05_JPRB, &
  & 0.17582000E-05_JPRB, 0.17576829E-05_JPRB, 0.17571027E-05_JPRB, 0.17565342E-05_JPRB, 0.17560416E-05_JPRB, 0.17556981E-05_JPRB, &
  & 0.17555350E-05_JPRB, 0.17555507E-05_JPRB, 0.17557227E-05_JPRB, 0.17560315E-05_JPRB, 0.17564621E-05_JPRB, 0.17569532E-05_JPRB, &
  & 0.17574419E-05_JPRB, 0.17578598E-05_JPRB, 0.17581949E-05_JPRB, 0.17584214E-05_JPRB, 0.17585849E-05_JPRB, 0.17586779E-05_JPRB, &
  & 0.17587436E-05_JPRB, 0.17587865E-05_JPRB, 0.17588163E-05_JPRB, 0.17588362E-05_JPRB, 0.17588426E-05_JPRB, 0.17588326E-05_JPRB, &
  & 0.17588064E-05_JPRB, 0.17587686E-05_JPRB, 0.17587192E-05_JPRB, 0.17586209E-05_JPRB /)

RGHG2(:,57, 9) = (/ &
  & 0.17619125E-05_JPRB, 0.17623296E-05_JPRB, 0.17626121E-05_JPRB, 0.17628682E-05_JPRB, 0.17631617E-05_JPRB, 0.17633968E-05_JPRB, &
  & 0.17635213E-05_JPRB, 0.17635579E-05_JPRB, 0.17635551E-05_JPRB, 0.17635282E-05_JPRB, 0.17634750E-05_JPRB, 0.17633771E-05_JPRB, &
  & 0.17632021E-05_JPRB, 0.17628831E-05_JPRB, 0.17623706E-05_JPRB, 0.17616420E-05_JPRB, 0.17607259E-05_JPRB, 0.17596219E-05_JPRB, &
  & 0.17583404E-05_JPRB, 0.17569379E-05_JPRB, 0.17554696E-05_JPRB, 0.17541223E-05_JPRB, 0.17531484E-05_JPRB, 0.17527051E-05_JPRB, &
  & 0.17527657E-05_JPRB, 0.17531536E-05_JPRB, 0.17537243E-05_JPRB, 0.17544118E-05_JPRB, 0.17551932E-05_JPRB, 0.17560614E-05_JPRB, &
  & 0.17569722E-05_JPRB, 0.17578361E-05_JPRB, 0.17585151E-05_JPRB, 0.17589257E-05_JPRB, 0.17590402E-05_JPRB, 0.17588827E-05_JPRB, &
  & 0.17585071E-05_JPRB, 0.17579898E-05_JPRB, 0.17574099E-05_JPRB, 0.17568368E-05_JPRB, 0.17563536E-05_JPRB, 0.17560237E-05_JPRB, &
  & 0.17558827E-05_JPRB, 0.17559253E-05_JPRB, 0.17561294E-05_JPRB, 0.17564801E-05_JPRB, 0.17569540E-05_JPRB, 0.17575031E-05_JPRB, &
  & 0.17580444E-05_JPRB, 0.17585165E-05_JPRB, 0.17588765E-05_JPRB, 0.17591365E-05_JPRB, 0.17592871E-05_JPRB, 0.17593890E-05_JPRB, &
  & 0.17594487E-05_JPRB, 0.17594891E-05_JPRB, 0.17595171E-05_JPRB, 0.17595336E-05_JPRB, 0.17595387E-05_JPRB, 0.17595297E-05_JPRB, &
  & 0.17595069E-05_JPRB, 0.17594739E-05_JPRB, 0.17594250E-05_JPRB, 0.17593247E-05_JPRB /)

RGHG2(:,58, 9) = (/ &
  & 0.17632099E-05_JPRB, 0.17635371E-05_JPRB, 0.17637221E-05_JPRB, 0.17639036E-05_JPRB, 0.17640793E-05_JPRB, 0.17642221E-05_JPRB, &
  & 0.17642885E-05_JPRB, 0.17643034E-05_JPRB, 0.17642927E-05_JPRB, 0.17642647E-05_JPRB, 0.17642157E-05_JPRB, 0.17641319E-05_JPRB, &
  & 0.17639759E-05_JPRB, 0.17636999E-05_JPRB, 0.17632326E-05_JPRB, 0.17625473E-05_JPRB, 0.17616295E-05_JPRB, 0.17604926E-05_JPRB, &
  & 0.17591415E-05_JPRB, 0.17576129E-05_JPRB, 0.17560417E-05_JPRB, 0.17546105E-05_JPRB, 0.17535490E-05_JPRB, 0.17530401E-05_JPRB, &
  & 0.17530328E-05_JPRB, 0.17533702E-05_JPRB, 0.17539123E-05_JPRB, 0.17545929E-05_JPRB, 0.17553839E-05_JPRB, 0.17562739E-05_JPRB, &
  & 0.17572131E-05_JPRB, 0.17581044E-05_JPRB, 0.17588123E-05_JPRB, 0.17592448E-05_JPRB, 0.17593732E-05_JPRB, 0.17592226E-05_JPRB, &
  & 0.17588502E-05_JPRB, 0.17583336E-05_JPRB, 0.17577501E-05_JPRB, 0.17571798E-05_JPRB, 0.17567006E-05_JPRB, 0.17563859E-05_JPRB, &
  & 0.17562647E-05_JPRB, 0.17563315E-05_JPRB, 0.17565640E-05_JPRB, 0.17569448E-05_JPRB, 0.17574522E-05_JPRB, 0.17580387E-05_JPRB, &
  & 0.17586264E-05_JPRB, 0.17591472E-05_JPRB, 0.17595481E-05_JPRB, 0.17598077E-05_JPRB, 0.17599758E-05_JPRB, 0.17600664E-05_JPRB, &
  & 0.17601235E-05_JPRB, 0.17601587E-05_JPRB, 0.17601795E-05_JPRB, 0.17601905E-05_JPRB, 0.17601893E-05_JPRB, 0.17601753E-05_JPRB, &
  & 0.17601510E-05_JPRB, 0.17601183E-05_JPRB, 0.17600761E-05_JPRB, 0.17599897E-05_JPRB /)

RGHG2(:,59, 9) = (/ &
  & 0.17642487E-05_JPRB, 0.17645146E-05_JPRB, 0.17646637E-05_JPRB, 0.17647844E-05_JPRB, 0.17648961E-05_JPRB, 0.17649800E-05_JPRB, &
  & 0.17650168E-05_JPRB, 0.17650202E-05_JPRB, 0.17650075E-05_JPRB, 0.17649819E-05_JPRB, 0.17649402E-05_JPRB, 0.17648661E-05_JPRB, &
  & 0.17647349E-05_JPRB, 0.17644873E-05_JPRB, 0.17640657E-05_JPRB, 0.17634070E-05_JPRB, 0.17624980E-05_JPRB, 0.17613106E-05_JPRB, &
  & 0.17598796E-05_JPRB, 0.17582648E-05_JPRB, 0.17566048E-05_JPRB, 0.17550992E-05_JPRB, 0.17539903E-05_JPRB, 0.17534157E-05_JPRB, &
  & 0.17533475E-05_JPRB, 0.17536382E-05_JPRB, 0.17541556E-05_JPRB, 0.17548298E-05_JPRB, 0.17556308E-05_JPRB, 0.17565412E-05_JPRB, &
  & 0.17575080E-05_JPRB, 0.17584275E-05_JPRB, 0.17591608E-05_JPRB, 0.17596138E-05_JPRB, 0.17597523E-05_JPRB, 0.17596069E-05_JPRB, &
  & 0.17592379E-05_JPRB, 0.17587212E-05_JPRB, 0.17581385E-05_JPRB, 0.17575663E-05_JPRB, 0.17570947E-05_JPRB, 0.17567922E-05_JPRB, &
  & 0.17566887E-05_JPRB, 0.17567776E-05_JPRB, 0.17570349E-05_JPRB, 0.17574403E-05_JPRB, 0.17579717E-05_JPRB, 0.17585801E-05_JPRB, &
  & 0.17592077E-05_JPRB, 0.17597611E-05_JPRB, 0.17601968E-05_JPRB, 0.17604873E-05_JPRB, 0.17606480E-05_JPRB, 0.17607407E-05_JPRB, &
  & 0.17607915E-05_JPRB, 0.17608186E-05_JPRB, 0.17608318E-05_JPRB, 0.17608324E-05_JPRB, 0.17608204E-05_JPRB, 0.17607969E-05_JPRB, &
  & 0.17607642E-05_JPRB, 0.17607267E-05_JPRB, 0.17606770E-05_JPRB, 0.17605838E-05_JPRB /)

RGHG2(:,60, 9) = (/ &
  & 0.17651772E-05_JPRB, 0.17653896E-05_JPRB, 0.17654957E-05_JPRB, 0.17655800E-05_JPRB, 0.17656517E-05_JPRB, 0.17657032E-05_JPRB, &
  & 0.17657251E-05_JPRB, 0.17657250E-05_JPRB, 0.17657138E-05_JPRB, 0.17656926E-05_JPRB, 0.17656573E-05_JPRB, 0.17655968E-05_JPRB, &
  & 0.17654800E-05_JPRB, 0.17652633E-05_JPRB, 0.17648675E-05_JPRB, 0.17642349E-05_JPRB, 0.17633060E-05_JPRB, 0.17620913E-05_JPRB, &
  & 0.17605840E-05_JPRB, 0.17589027E-05_JPRB, 0.17571803E-05_JPRB, 0.17556372E-05_JPRB, 0.17544752E-05_JPRB, 0.17538463E-05_JPRB, &
  & 0.17537219E-05_JPRB, 0.17539710E-05_JPRB, 0.17544656E-05_JPRB, 0.17551354E-05_JPRB, 0.17559482E-05_JPRB, 0.17568777E-05_JPRB, &
  & 0.17578717E-05_JPRB, 0.17588163E-05_JPRB, 0.17595752E-05_JPRB, 0.17600412E-05_JPRB, 0.17601864E-05_JPRB, 0.17600438E-05_JPRB, &
  & 0.17596774E-05_JPRB, 0.17591628E-05_JPRB, 0.17585792E-05_JPRB, 0.17580102E-05_JPRB, 0.17575426E-05_JPRB, 0.17572518E-05_JPRB, &
  & 0.17571640E-05_JPRB, 0.17572713E-05_JPRB, 0.17575501E-05_JPRB, 0.17579766E-05_JPRB, 0.17585244E-05_JPRB, 0.17591517E-05_JPRB, &
  & 0.17597888E-05_JPRB, 0.17603827E-05_JPRB, 0.17608475E-05_JPRB, 0.17611569E-05_JPRB, 0.17613345E-05_JPRB, 0.17614248E-05_JPRB, &
  & 0.17614691E-05_JPRB, 0.17614890E-05_JPRB, 0.17614909E-05_JPRB, 0.17614781E-05_JPRB, 0.17614515E-05_JPRB, 0.17614129E-05_JPRB, &
  & 0.17613702E-05_JPRB, 0.17613240E-05_JPRB, 0.17612708E-05_JPRB, 0.17611691E-05_JPRB /)

RGHG2(:,61, 9) = (/ &
  & 0.17659905E-05_JPRB, 0.17661704E-05_JPRB, 0.17662580E-05_JPRB, 0.17663217E-05_JPRB, 0.17663730E-05_JPRB, 0.17664095E-05_JPRB, &
  & 0.17664256E-05_JPRB, 0.17664262E-05_JPRB, 0.17664188E-05_JPRB, 0.17664033E-05_JPRB, 0.17663763E-05_JPRB, 0.17663256E-05_JPRB, &
  & 0.17662264E-05_JPRB, 0.17660243E-05_JPRB, 0.17656530E-05_JPRB, 0.17650198E-05_JPRB, 0.17640913E-05_JPRB, 0.17628192E-05_JPRB, &
  & 0.17612864E-05_JPRB, 0.17595530E-05_JPRB, 0.17578041E-05_JPRB, 0.17562229E-05_JPRB, 0.17550258E-05_JPRB, 0.17543443E-05_JPRB, &
  & 0.17541689E-05_JPRB, 0.17543805E-05_JPRB, 0.17548568E-05_JPRB, 0.17555262E-05_JPRB, 0.17563519E-05_JPRB, 0.17573007E-05_JPRB, &
  & 0.17583211E-05_JPRB, 0.17592905E-05_JPRB, 0.17600655E-05_JPRB, 0.17605403E-05_JPRB, 0.17606847E-05_JPRB, 0.17605416E-05_JPRB, &
  & 0.17601773E-05_JPRB, 0.17596649E-05_JPRB, 0.17590846E-05_JPRB, 0.17585184E-05_JPRB, 0.17580569E-05_JPRB, 0.17577751E-05_JPRB, &
  & 0.17576998E-05_JPRB, 0.17578224E-05_JPRB, 0.17581187E-05_JPRB, 0.17585618E-05_JPRB, 0.17591237E-05_JPRB, 0.17597571E-05_JPRB, &
  & 0.17604111E-05_JPRB, 0.17610091E-05_JPRB, 0.17615063E-05_JPRB, 0.17618455E-05_JPRB, 0.17620374E-05_JPRB, 0.17621305E-05_JPRB, &
  & 0.17621715E-05_JPRB, 0.17621801E-05_JPRB, 0.17621670E-05_JPRB, 0.17621367E-05_JPRB, 0.17620882E-05_JPRB, 0.17620322E-05_JPRB, &
  & 0.17619736E-05_JPRB, 0.17619168E-05_JPRB, 0.17618486E-05_JPRB, 0.17617316E-05_JPRB /)

RGHG2(:,62, 9) = (/ &
  & 0.17667574E-05_JPRB, 0.17669120E-05_JPRB, 0.17669837E-05_JPRB, 0.17670354E-05_JPRB, 0.17670768E-05_JPRB, 0.17671068E-05_JPRB, &
  & 0.17671224E-05_JPRB, 0.17671269E-05_JPRB, 0.17671257E-05_JPRB, 0.17671173E-05_JPRB, 0.17670989E-05_JPRB, 0.17670591E-05_JPRB, &
  & 0.17669716E-05_JPRB, 0.17667865E-05_JPRB, 0.17664156E-05_JPRB, 0.17657907E-05_JPRB, 0.17648288E-05_JPRB, 0.17635595E-05_JPRB, &
  & 0.17619883E-05_JPRB, 0.17602495E-05_JPRB, 0.17584772E-05_JPRB, 0.17568799E-05_JPRB, 0.17556490E-05_JPRB, 0.17549260E-05_JPRB, &
  & 0.17547048E-05_JPRB, 0.17548846E-05_JPRB, 0.17553469E-05_JPRB, 0.17560180E-05_JPRB, 0.17568593E-05_JPRB, 0.17578294E-05_JPRB, &
  & 0.17588744E-05_JPRB, 0.17598634E-05_JPRB, 0.17606492E-05_JPRB, 0.17611213E-05_JPRB, 0.17612597E-05_JPRB, 0.17611131E-05_JPRB, &
  & 0.17607499E-05_JPRB, 0.17602405E-05_JPRB, 0.17596652E-05_JPRB, 0.17591029E-05_JPRB, 0.17586469E-05_JPRB, 0.17583727E-05_JPRB, &
  & 0.17583072E-05_JPRB, 0.17584416E-05_JPRB, 0.17587512E-05_JPRB, 0.17592063E-05_JPRB, 0.17597766E-05_JPRB, 0.17604164E-05_JPRB, &
  & 0.17610686E-05_JPRB, 0.17616784E-05_JPRB, 0.17621865E-05_JPRB, 0.17625525E-05_JPRB, 0.17627684E-05_JPRB, 0.17628740E-05_JPRB, &
  & 0.17629104E-05_JPRB, 0.17629070E-05_JPRB, 0.17628753E-05_JPRB, 0.17628179E-05_JPRB, 0.17627433E-05_JPRB, 0.17626619E-05_JPRB, &
  & 0.17625862E-05_JPRB, 0.17625108E-05_JPRB, 0.17624293E-05_JPRB, 0.17622791E-05_JPRB /)

RGHG2(:,63, 9) = (/ &
  & 0.17674678E-05_JPRB, 0.17676161E-05_JPRB, 0.17676851E-05_JPRB, 0.17677337E-05_JPRB, 0.17677719E-05_JPRB, 0.17678012E-05_JPRB, &
  & 0.17678201E-05_JPRB, 0.17678299E-05_JPRB, 0.17678358E-05_JPRB, 0.17678358E-05_JPRB, 0.17678271E-05_JPRB, 0.17677993E-05_JPRB, &
  & 0.17677248E-05_JPRB, 0.17675439E-05_JPRB, 0.17671805E-05_JPRB, 0.17665352E-05_JPRB, 0.17655832E-05_JPRB, 0.17642943E-05_JPRB, &
  & 0.17627376E-05_JPRB, 0.17609925E-05_JPRB, 0.17592204E-05_JPRB, 0.17576122E-05_JPRB, 0.17563660E-05_JPRB, 0.17556083E-05_JPRB, &
  & 0.17553513E-05_JPRB, 0.17555045E-05_JPRB, 0.17559556E-05_JPRB, 0.17566317E-05_JPRB, 0.17574902E-05_JPRB, 0.17584812E-05_JPRB, &
  & 0.17595487E-05_JPRB, 0.17605495E-05_JPRB, 0.17613349E-05_JPRB, 0.17617976E-05_JPRB, 0.17619230E-05_JPRB, 0.17617704E-05_JPRB, &
  & 0.17614063E-05_JPRB, 0.17609029E-05_JPRB, 0.17603327E-05_JPRB, 0.17597777E-05_JPRB, 0.17593268E-05_JPRB, 0.17590583E-05_JPRB, &
  & 0.17589995E-05_JPRB, 0.17591410E-05_JPRB, 0.17594588E-05_JPRB, 0.17599201E-05_JPRB, 0.17604932E-05_JPRB, 0.17611326E-05_JPRB, &
  & 0.17617850E-05_JPRB, 0.17623928E-05_JPRB, 0.17629079E-05_JPRB, 0.17632956E-05_JPRB, 0.17635373E-05_JPRB, 0.17636562E-05_JPRB, &
  & 0.17636961E-05_JPRB, 0.17636803E-05_JPRB, 0.17636228E-05_JPRB, 0.17635361E-05_JPRB, 0.17634248E-05_JPRB, 0.17633156E-05_JPRB, &
  & 0.17632111E-05_JPRB, 0.17631153E-05_JPRB, 0.17630015E-05_JPRB, 0.17628108E-05_JPRB /)

RGHG2(:,64, 9) = (/ &
  & 0.17681508E-05_JPRB, 0.17683017E-05_JPRB, 0.17683709E-05_JPRB, 0.17684199E-05_JPRB, 0.17684594E-05_JPRB, 0.17684906E-05_JPRB, &
  & 0.17685136E-05_JPRB, 0.17685295E-05_JPRB, 0.17685438E-05_JPRB, 0.17685536E-05_JPRB, 0.17685567E-05_JPRB, 0.17685420E-05_JPRB, &
  & 0.17684787E-05_JPRB, 0.17683035E-05_JPRB, 0.17679279E-05_JPRB, 0.17672930E-05_JPRB, 0.17663355E-05_JPRB, 0.17650700E-05_JPRB, &
  & 0.17635243E-05_JPRB, 0.17617948E-05_JPRB, 0.17600336E-05_JPRB, 0.17584342E-05_JPRB, 0.17571818E-05_JPRB, 0.17564070E-05_JPRB, &
  & 0.17561223E-05_JPRB, 0.17562548E-05_JPRB, 0.17566983E-05_JPRB, 0.17573811E-05_JPRB, 0.17582531E-05_JPRB, 0.17592635E-05_JPRB, &
  & 0.17603428E-05_JPRB, 0.17613461E-05_JPRB, 0.17621198E-05_JPRB, 0.17625631E-05_JPRB, 0.17626718E-05_JPRB, 0.17625117E-05_JPRB, &
  & 0.17621499E-05_JPRB, 0.17616534E-05_JPRB, 0.17610937E-05_JPRB, 0.17605462E-05_JPRB, 0.17601028E-05_JPRB, 0.17598386E-05_JPRB, &
  & 0.17597829E-05_JPRB, 0.17599273E-05_JPRB, 0.17602476E-05_JPRB, 0.17607078E-05_JPRB, 0.17612779E-05_JPRB, 0.17619111E-05_JPRB, &
  & 0.17625574E-05_JPRB, 0.17631627E-05_JPRB, 0.17636803E-05_JPRB, 0.17640763E-05_JPRB, 0.17643408E-05_JPRB, 0.17644803E-05_JPRB, &
  & 0.17645251E-05_JPRB, 0.17644976E-05_JPRB, 0.17644177E-05_JPRB, 0.17642956E-05_JPRB, 0.17641507E-05_JPRB, 0.17640034E-05_JPRB, &
  & 0.17638695E-05_JPRB, 0.17637340E-05_JPRB, 0.17635838E-05_JPRB, 0.17633052E-05_JPRB /)

RGHG2(:,65, 9) = (/ &
  & 0.17688094E-05_JPRB, 0.17689706E-05_JPRB, 0.17690461E-05_JPRB, 0.17690998E-05_JPRB, 0.17691427E-05_JPRB, 0.17691776E-05_JPRB, &
  & 0.17692045E-05_JPRB, 0.17692269E-05_JPRB, 0.17692502E-05_JPRB, 0.17692707E-05_JPRB, 0.17692871E-05_JPRB, 0.17692860E-05_JPRB, &
  & 0.17692314E-05_JPRB, 0.17690542E-05_JPRB, 0.17686838E-05_JPRB, 0.17680510E-05_JPRB, 0.17671184E-05_JPRB, 0.17658753E-05_JPRB, &
  & 0.17643590E-05_JPRB, 0.17626596E-05_JPRB, 0.17609265E-05_JPRB, 0.17593493E-05_JPRB, 0.17581132E-05_JPRB, 0.17573302E-05_JPRB, &
  & 0.17570309E-05_JPRB, 0.17571467E-05_JPRB, 0.17575830E-05_JPRB, 0.17582677E-05_JPRB, 0.17591481E-05_JPRB, 0.17601648E-05_JPRB, &
  & 0.17612435E-05_JPRB, 0.17622349E-05_JPRB, 0.17629835E-05_JPRB, 0.17634018E-05_JPRB, 0.17634919E-05_JPRB, 0.17633262E-05_JPRB, &
  & 0.17629699E-05_JPRB, 0.17624875E-05_JPRB, 0.17619426E-05_JPRB, 0.17614110E-05_JPRB, 0.17609764E-05_JPRB, 0.17607168E-05_JPRB, &
  & 0.17606623E-05_JPRB, 0.17608050E-05_JPRB, 0.17611210E-05_JPRB, 0.17615753E-05_JPRB, 0.17621338E-05_JPRB, 0.17627553E-05_JPRB, &
  & 0.17633912E-05_JPRB, 0.17639891E-05_JPRB, 0.17645041E-05_JPRB, 0.17649076E-05_JPRB, 0.17651832E-05_JPRB, 0.17653387E-05_JPRB, &
  & 0.17653922E-05_JPRB, 0.17653576E-05_JPRB, 0.17652544E-05_JPRB, 0.17651084E-05_JPRB, 0.17649277E-05_JPRB, 0.17647488E-05_JPRB, &
  & 0.17645675E-05_JPRB, 0.17643900E-05_JPRB, 0.17641672E-05_JPRB, 0.17637785E-05_JPRB /)

RGHG2(:,66, 9) = (/ &
  & 0.17694313E-05_JPRB, 0.17696223E-05_JPRB, 0.17697112E-05_JPRB, 0.17697748E-05_JPRB, 0.17698252E-05_JPRB, 0.17698649E-05_JPRB, &
  & 0.17698974E-05_JPRB, 0.17699242E-05_JPRB, 0.17699581E-05_JPRB, 0.17699890E-05_JPRB, 0.17700193E-05_JPRB, 0.17700305E-05_JPRB, &
  & 0.17699805E-05_JPRB, 0.17698035E-05_JPRB, 0.17694402E-05_JPRB, 0.17688278E-05_JPRB, 0.17679222E-05_JPRB, 0.17667160E-05_JPRB, &
  & 0.17652441E-05_JPRB, 0.17635888E-05_JPRB, 0.17619029E-05_JPRB, 0.17603709E-05_JPRB, 0.17591594E-05_JPRB, 0.17583887E-05_JPRB, &
  & 0.17580792E-05_JPRB, 0.17581827E-05_JPRB, 0.17586067E-05_JPRB, 0.17592856E-05_JPRB, 0.17601592E-05_JPRB, 0.17611671E-05_JPRB, &
  & 0.17622281E-05_JPRB, 0.17631902E-05_JPRB, 0.17639054E-05_JPRB, 0.17642926E-05_JPRB, 0.17643654E-05_JPRB, 0.17641977E-05_JPRB, &
  & 0.17638533E-05_JPRB, 0.17633919E-05_JPRB, 0.17628723E-05_JPRB, 0.17623618E-05_JPRB, 0.17619444E-05_JPRB, 0.17616919E-05_JPRB, &
  & 0.17616380E-05_JPRB, 0.17617751E-05_JPRB, 0.17620827E-05_JPRB, 0.17625231E-05_JPRB, 0.17630639E-05_JPRB, 0.17636671E-05_JPRB, &
  & 0.17642860E-05_JPRB, 0.17648726E-05_JPRB, 0.17653828E-05_JPRB, 0.17657861E-05_JPRB, 0.17660715E-05_JPRB, 0.17662354E-05_JPRB, &
  & 0.17662946E-05_JPRB, 0.17662543E-05_JPRB, 0.17661368E-05_JPRB, 0.17659715E-05_JPRB, 0.17657692E-05_JPRB, 0.17655540E-05_JPRB, &
  & 0.17653339E-05_JPRB, 0.17650910E-05_JPRB, 0.17647883E-05_JPRB, 0.17642185E-05_JPRB /)

RGHG2(:,67, 9) = (/ &
  & 0.17700263E-05_JPRB, 0.17702621E-05_JPRB, 0.17703736E-05_JPRB, 0.17704517E-05_JPRB, 0.17705128E-05_JPRB, 0.17705602E-05_JPRB, &
  & 0.17705968E-05_JPRB, 0.17706302E-05_JPRB, 0.17706707E-05_JPRB, 0.17707149E-05_JPRB, 0.17707561E-05_JPRB, 0.17707745E-05_JPRB, &
  & 0.17707259E-05_JPRB, 0.17705539E-05_JPRB, 0.17702043E-05_JPRB, 0.17696173E-05_JPRB, 0.17687486E-05_JPRB, 0.17675909E-05_JPRB, &
  & 0.17661762E-05_JPRB, 0.17645887E-05_JPRB, 0.17629685E-05_JPRB, 0.17614931E-05_JPRB, 0.17603290E-05_JPRB, 0.17595745E-05_JPRB, &
  & 0.17592640E-05_JPRB, 0.17593513E-05_JPRB, 0.17597583E-05_JPRB, 0.17604175E-05_JPRB, 0.17612699E-05_JPRB, 0.17622507E-05_JPRB, &
  & 0.17632752E-05_JPRB, 0.17641970E-05_JPRB, 0.17648687E-05_JPRB, 0.17652235E-05_JPRB, 0.17652800E-05_JPRB, 0.17651147E-05_JPRB, &
  & 0.17647883E-05_JPRB, 0.17643553E-05_JPRB, 0.17638678E-05_JPRB, 0.17633896E-05_JPRB, 0.17629948E-05_JPRB, 0.17627558E-05_JPRB, &
  & 0.17627053E-05_JPRB, 0.17628362E-05_JPRB, 0.17631299E-05_JPRB, 0.17635517E-05_JPRB, 0.17640698E-05_JPRB, 0.17646471E-05_JPRB, &
  & 0.17652452E-05_JPRB, 0.17658147E-05_JPRB, 0.17663157E-05_JPRB, 0.17667165E-05_JPRB, 0.17670034E-05_JPRB, 0.17671723E-05_JPRB, &
  & 0.17672339E-05_JPRB, 0.17671899E-05_JPRB, 0.17670626E-05_JPRB, 0.17668874E-05_JPRB, 0.17666666E-05_JPRB, 0.17664324E-05_JPRB, &
  & 0.17661661E-05_JPRB, 0.17658679E-05_JPRB, 0.17654519E-05_JPRB, 0.17646702E-05_JPRB /)

RGHG2(:,68, 9) = (/ &
  & 0.17705945E-05_JPRB, 0.17708983E-05_JPRB, 0.17710397E-05_JPRB, 0.17711379E-05_JPRB, 0.17712125E-05_JPRB, 0.17712684E-05_JPRB, &
  & 0.17713116E-05_JPRB, 0.17713470E-05_JPRB, 0.17713985E-05_JPRB, 0.17714480E-05_JPRB, 0.17714979E-05_JPRB, 0.17715192E-05_JPRB, &
  & 0.17714710E-05_JPRB, 0.17713052E-05_JPRB, 0.17709748E-05_JPRB, 0.17704184E-05_JPRB, 0.17695946E-05_JPRB, 0.17684968E-05_JPRB, &
  & 0.17671581E-05_JPRB, 0.17656529E-05_JPRB, 0.17641164E-05_JPRB, 0.17627187E-05_JPRB, 0.17616044E-05_JPRB, 0.17608788E-05_JPRB, &
  & 0.17605666E-05_JPRB, 0.17606380E-05_JPRB, 0.17610182E-05_JPRB, 0.17616479E-05_JPRB, 0.17624634E-05_JPRB, 0.17634003E-05_JPRB, &
  & 0.17643765E-05_JPRB, 0.17652446E-05_JPRB, 0.17658701E-05_JPRB, 0.17661906E-05_JPRB, 0.17662333E-05_JPRB, 0.17660731E-05_JPRB, &
  & 0.17657685E-05_JPRB, 0.17653684E-05_JPRB, 0.17649191E-05_JPRB, 0.17644780E-05_JPRB, 0.17641153E-05_JPRB, 0.17638966E-05_JPRB, &
  & 0.17638548E-05_JPRB, 0.17639805E-05_JPRB, 0.17642585E-05_JPRB, 0.17646588E-05_JPRB, 0.17651466E-05_JPRB, 0.17656967E-05_JPRB, &
  & 0.17662665E-05_JPRB, 0.17668159E-05_JPRB, 0.17673017E-05_JPRB, 0.17676950E-05_JPRB, 0.17679803E-05_JPRB, 0.17681502E-05_JPRB, &
  & 0.17682137E-05_JPRB, 0.17681676E-05_JPRB, 0.17680359E-05_JPRB, 0.17678539E-05_JPRB, 0.17676248E-05_JPRB, 0.17673734E-05_JPRB, &
  & 0.17670803E-05_JPRB, 0.17667295E-05_JPRB, 0.17662082E-05_JPRB, 0.17652092E-05_JPRB /)

RGHG2(:,69, 9) = (/ &
  & 0.17711347E-05_JPRB, 0.17715369E-05_JPRB, 0.17717185E-05_JPRB, 0.17718432E-05_JPRB, 0.17719331E-05_JPRB, 0.17719985E-05_JPRB, &
  & 0.17720457E-05_JPRB, 0.17720853E-05_JPRB, 0.17721400E-05_JPRB, 0.17721959E-05_JPRB, 0.17722474E-05_JPRB, 0.17722680E-05_JPRB, &
  & 0.17722192E-05_JPRB, 0.17720608E-05_JPRB, 0.17717518E-05_JPRB, 0.17712308E-05_JPRB, 0.17704608E-05_JPRB, 0.17694349E-05_JPRB, &
  & 0.17681843E-05_JPRB, 0.17667791E-05_JPRB, 0.17653442E-05_JPRB, 0.17640292E-05_JPRB, 0.17629800E-05_JPRB, 0.17622840E-05_JPRB, &
  & 0.17619740E-05_JPRB, 0.17620254E-05_JPRB, 0.17623748E-05_JPRB, 0.17629640E-05_JPRB, 0.17637317E-05_JPRB, 0.17646125E-05_JPRB, &
  & 0.17655270E-05_JPRB, 0.17663356E-05_JPRB, 0.17669100E-05_JPRB, 0.17671969E-05_JPRB, 0.17672272E-05_JPRB, 0.17670742E-05_JPRB, &
  & 0.17667941E-05_JPRB, 0.17664290E-05_JPRB, 0.17660207E-05_JPRB, 0.17656220E-05_JPRB, 0.17652948E-05_JPRB, 0.17651029E-05_JPRB, &
  & 0.17650750E-05_JPRB, 0.17651992E-05_JPRB, 0.17654638E-05_JPRB, 0.17658390E-05_JPRB, 0.17662984E-05_JPRB, 0.17668139E-05_JPRB, &
  & 0.17673550E-05_JPRB, 0.17678783E-05_JPRB, 0.17683452E-05_JPRB, 0.17687262E-05_JPRB, 0.17690053E-05_JPRB, 0.17691737E-05_JPRB, &
  & 0.17692377E-05_JPRB, 0.17691922E-05_JPRB, 0.17690610E-05_JPRB, 0.17688787E-05_JPRB, 0.17686456E-05_JPRB, 0.17683880E-05_JPRB, &
  & 0.17680749E-05_JPRB, 0.17676915E-05_JPRB, 0.17670776E-05_JPRB, 0.17658616E-05_JPRB /)

RGHG2(:,70, 9) = (/ &
  & 0.17716612E-05_JPRB, 0.17721841E-05_JPRB, 0.17724226E-05_JPRB, 0.17725740E-05_JPRB, 0.17726829E-05_JPRB, 0.17727550E-05_JPRB, &
  & 0.17728062E-05_JPRB, 0.17728471E-05_JPRB, 0.17729034E-05_JPRB, 0.17729585E-05_JPRB, 0.17730066E-05_JPRB, 0.17730231E-05_JPRB, &
  & 0.17729736E-05_JPRB, 0.17728245E-05_JPRB, 0.17725384E-05_JPRB, 0.17720566E-05_JPRB, 0.17713453E-05_JPRB, 0.17704011E-05_JPRB, &
  & 0.17692506E-05_JPRB, 0.17679589E-05_JPRB, 0.17666330E-05_JPRB, 0.17654183E-05_JPRB, 0.17644363E-05_JPRB, 0.17637778E-05_JPRB, &
  & 0.17634711E-05_JPRB, 0.17635020E-05_JPRB, 0.17638151E-05_JPRB, 0.17643574E-05_JPRB, 0.17650669E-05_JPRB, 0.17658813E-05_JPRB, &
  & 0.17667259E-05_JPRB, 0.17674679E-05_JPRB, 0.17679887E-05_JPRB, 0.17682419E-05_JPRB, 0.17682618E-05_JPRB, 0.17681185E-05_JPRB, &
  & 0.17678642E-05_JPRB, 0.17675344E-05_JPRB, 0.17671683E-05_JPRB, 0.17668133E-05_JPRB, 0.17665259E-05_JPRB, 0.17663646E-05_JPRB, &
  & 0.17663556E-05_JPRB, 0.17664829E-05_JPRB, 0.17667347E-05_JPRB, 0.17670894E-05_JPRB, 0.17675158E-05_JPRB, 0.17679993E-05_JPRB, &
  & 0.17685064E-05_JPRB, 0.17690005E-05_JPRB, 0.17694433E-05_JPRB, 0.17698069E-05_JPRB, 0.17700751E-05_JPRB, 0.17702403E-05_JPRB, &
  & 0.17703057E-05_JPRB, 0.17702664E-05_JPRB, 0.17701421E-05_JPRB, 0.17699673E-05_JPRB, 0.17697367E-05_JPRB, 0.17694804E-05_JPRB, &
  & 0.17691608E-05_JPRB, 0.17687679E-05_JPRB, 0.17680894E-05_JPRB, 0.17667271E-05_JPRB /)

RGHG2(:,71, 9) = (/ &
  & 0.17722020E-05_JPRB, 0.17728751E-05_JPRB, 0.17731593E-05_JPRB, 0.17733425E-05_JPRB, 0.17734631E-05_JPRB, 0.17735424E-05_JPRB, &
  & 0.17735948E-05_JPRB, 0.17736355E-05_JPRB, 0.17736900E-05_JPRB, 0.17737362E-05_JPRB, 0.17737789E-05_JPRB, 0.17737875E-05_JPRB, &
  & 0.17737311E-05_JPRB, 0.17735860E-05_JPRB, 0.17733281E-05_JPRB, 0.17728916E-05_JPRB, 0.17722475E-05_JPRB, 0.17713890E-05_JPRB, &
  & 0.17703495E-05_JPRB, 0.17691763E-05_JPRB, 0.17679763E-05_JPRB, 0.17668635E-05_JPRB, 0.17659623E-05_JPRB, 0.17653466E-05_JPRB, &
  & 0.17650468E-05_JPRB, 0.17650565E-05_JPRB, 0.17653304E-05_JPRB, 0.17658193E-05_JPRB, 0.17664636E-05_JPRB, 0.17672028E-05_JPRB, &
  & 0.17679695E-05_JPRB, 0.17686395E-05_JPRB, 0.17691051E-05_JPRB, 0.17693238E-05_JPRB, 0.17693346E-05_JPRB, 0.17692030E-05_JPRB, &
  & 0.17689752E-05_JPRB, 0.17686825E-05_JPRB, 0.17683594E-05_JPRB, 0.17680488E-05_JPRB, 0.17678015E-05_JPRB, 0.17676724E-05_JPRB, &
  & 0.17676841E-05_JPRB, 0.17678163E-05_JPRB, 0.17680608E-05_JPRB, 0.17683938E-05_JPRB, 0.17687911E-05_JPRB, 0.17692408E-05_JPRB, &
  & 0.17697118E-05_JPRB, 0.17701739E-05_JPRB, 0.17705875E-05_JPRB, 0.17709290E-05_JPRB, 0.17711834E-05_JPRB, 0.17713435E-05_JPRB, &
  & 0.17714116E-05_JPRB, 0.17713821E-05_JPRB, 0.17712730E-05_JPRB, 0.17711112E-05_JPRB, 0.17708937E-05_JPRB, 0.17706489E-05_JPRB, &
  & 0.17703362E-05_JPRB, 0.17699533E-05_JPRB, 0.17692571E-05_JPRB, 0.17678108E-05_JPRB /)

RGHG2(:,72, 9) = (/ &
  & 0.17728164E-05_JPRB, 0.17736116E-05_JPRB, 0.17739433E-05_JPRB, 0.17741426E-05_JPRB, 0.17742750E-05_JPRB, 0.17743548E-05_JPRB, &
  & 0.17744078E-05_JPRB, 0.17744487E-05_JPRB, 0.17744918E-05_JPRB, 0.17745344E-05_JPRB, 0.17745629E-05_JPRB, 0.17745647E-05_JPRB, &
  & 0.17745114E-05_JPRB, 0.17743732E-05_JPRB, 0.17741368E-05_JPRB, 0.17737416E-05_JPRB, 0.17731606E-05_JPRB, 0.17723982E-05_JPRB, &
  & 0.17714679E-05_JPRB, 0.17704290E-05_JPRB, 0.17693517E-05_JPRB, 0.17683601E-05_JPRB, 0.17675434E-05_JPRB, 0.17669788E-05_JPRB, &
  & 0.17666908E-05_JPRB, 0.17666795E-05_JPRB, 0.17669114E-05_JPRB, 0.17673418E-05_JPRB, 0.17679140E-05_JPRB, 0.17685711E-05_JPRB, &
  & 0.17692535E-05_JPRB, 0.17698471E-05_JPRB, 0.17702556E-05_JPRB, 0.17704403E-05_JPRB, 0.17704444E-05_JPRB, 0.17703256E-05_JPRB, &
  & 0.17701257E-05_JPRB, 0.17698698E-05_JPRB, 0.17695905E-05_JPRB, 0.17693239E-05_JPRB, 0.17691176E-05_JPRB, 0.17690207E-05_JPRB, &
  & 0.17690522E-05_JPRB, 0.17691897E-05_JPRB, 0.17694240E-05_JPRB, 0.17697380E-05_JPRB, 0.17701061E-05_JPRB, 0.17705208E-05_JPRB, &
  & 0.17709557E-05_JPRB, 0.17713796E-05_JPRB, 0.17717604E-05_JPRB, 0.17720744E-05_JPRB, 0.17723123E-05_JPRB, 0.17724639E-05_JPRB, &
  & 0.17725363E-05_JPRB, 0.17725223E-05_JPRB, 0.17724309E-05_JPRB, 0.17722950E-05_JPRB, 0.17720945E-05_JPRB, 0.17718756E-05_JPRB, &
  & 0.17715780E-05_JPRB, 0.17712283E-05_JPRB, 0.17705416E-05_JPRB, 0.17690879E-05_JPRB /)

RGHG2(:,73, 9) = (/ &
  & 0.17735905E-05_JPRB, 0.17744268E-05_JPRB, 0.17747655E-05_JPRB, 0.17749708E-05_JPRB, 0.17751011E-05_JPRB, 0.17751813E-05_JPRB, &
  & 0.17752320E-05_JPRB, 0.17752678E-05_JPRB, 0.17753093E-05_JPRB, 0.17753348E-05_JPRB, 0.17753582E-05_JPRB, 0.17753491E-05_JPRB, &
  & 0.17752766E-05_JPRB, 0.17751444E-05_JPRB, 0.17749447E-05_JPRB, 0.17745976E-05_JPRB, 0.17740887E-05_JPRB, 0.17734109E-05_JPRB, &
  & 0.17726064E-05_JPRB, 0.17716911E-05_JPRB, 0.17707580E-05_JPRB, 0.17698837E-05_JPRB, 0.17691647E-05_JPRB, 0.17686580E-05_JPRB, &
  & 0.17683876E-05_JPRB, 0.17683566E-05_JPRB, 0.17685447E-05_JPRB, 0.17689138E-05_JPRB, 0.17694076E-05_JPRB, 0.17699798E-05_JPRB, &
  & 0.17705704E-05_JPRB, 0.17710865E-05_JPRB, 0.17714370E-05_JPRB, 0.17715887E-05_JPRB, 0.17715872E-05_JPRB, 0.17714825E-05_JPRB, &
  & 0.17713108E-05_JPRB, 0.17710933E-05_JPRB, 0.17708580E-05_JPRB, 0.17706354E-05_JPRB, 0.17704680E-05_JPRB, 0.17703995E-05_JPRB, &
  & 0.17704479E-05_JPRB, 0.17705870E-05_JPRB, 0.17708111E-05_JPRB, 0.17711029E-05_JPRB, 0.17714410E-05_JPRB, 0.17718186E-05_JPRB, &
  & 0.17722127E-05_JPRB, 0.17725960E-05_JPRB, 0.17729384E-05_JPRB, 0.17732225E-05_JPRB, 0.17734376E-05_JPRB, 0.17735808E-05_JPRB, &
  & 0.17736533E-05_JPRB, 0.17736538E-05_JPRB, 0.17735881E-05_JPRB, 0.17734760E-05_JPRB, 0.17733062E-05_JPRB, 0.17731144E-05_JPRB, &
  & 0.17728510E-05_JPRB, 0.17725361E-05_JPRB, 0.17719028E-05_JPRB, 0.17704867E-05_JPRB /)

RGHG2(:,74, 9) = (/ &
  & 0.17744328E-05_JPRB, 0.17752735E-05_JPRB, 0.17756047E-05_JPRB, 0.17757991E-05_JPRB, 0.17759269E-05_JPRB, 0.17759990E-05_JPRB, &
  & 0.17760458E-05_JPRB, 0.17760811E-05_JPRB, 0.17761092E-05_JPRB, 0.17761346E-05_JPRB, 0.17761460E-05_JPRB, 0.17761312E-05_JPRB, &
  & 0.17760765E-05_JPRB, 0.17759490E-05_JPRB, 0.17757661E-05_JPRB, 0.17754603E-05_JPRB, 0.17750149E-05_JPRB, 0.17744366E-05_JPRB, &
  & 0.17737416E-05_JPRB, 0.17729699E-05_JPRB, 0.17721696E-05_JPRB, 0.17714282E-05_JPRB, 0.17708072E-05_JPRB, 0.17703660E-05_JPRB, &
  & 0.17701196E-05_JPRB, 0.17700736E-05_JPRB, 0.17702200E-05_JPRB, 0.17705247E-05_JPRB, 0.17709382E-05_JPRB, 0.17714203E-05_JPRB, &
  & 0.17719184E-05_JPRB, 0.17723521E-05_JPRB, 0.17726456E-05_JPRB, 0.17727651E-05_JPRB, 0.17727612E-05_JPRB, 0.17726713E-05_JPRB, &
  & 0.17725287E-05_JPRB, 0.17723485E-05_JPRB, 0.17721579E-05_JPRB, 0.17719776E-05_JPRB, 0.17718480E-05_JPRB, 0.17718050E-05_JPRB, &
  & 0.17718662E-05_JPRB, 0.17720015E-05_JPRB, 0.17722102E-05_JPRB, 0.17724772E-05_JPRB, 0.17727795E-05_JPRB, 0.17731186E-05_JPRB, &
  & 0.17734662E-05_JPRB, 0.17738037E-05_JPRB, 0.17741045E-05_JPRB, 0.17743517E-05_JPRB, 0.17745439E-05_JPRB, 0.17746698E-05_JPRB, &
  & 0.17747427E-05_JPRB, 0.17747548E-05_JPRB, 0.17747095E-05_JPRB, 0.17746283E-05_JPRB, 0.17744860E-05_JPRB, 0.17743326E-05_JPRB, &
  & 0.17741036E-05_JPRB, 0.17738387E-05_JPRB, 0.17732608E-05_JPRB, 0.17719301E-05_JPRB /)

RGHG2(:,75, 9) = (/ &
  & 0.17753106E-05_JPRB, 0.17761257E-05_JPRB, 0.17764330E-05_JPRB, 0.17766149E-05_JPRB, 0.17767284E-05_JPRB, 0.17767925E-05_JPRB, &
  & 0.17768339E-05_JPRB, 0.17768625E-05_JPRB, 0.17768895E-05_JPRB, 0.17769029E-05_JPRB, 0.17769100E-05_JPRB, 0.17768905E-05_JPRB, &
  & 0.17768100E-05_JPRB, 0.17766924E-05_JPRB, 0.17765650E-05_JPRB, 0.17763149E-05_JPRB, 0.17759432E-05_JPRB, 0.17754546E-05_JPRB, &
  & 0.17748869E-05_JPRB, 0.17742454E-05_JPRB, 0.17735898E-05_JPRB, 0.17729765E-05_JPRB, 0.17724590E-05_JPRB, 0.17720873E-05_JPRB, &
  & 0.17718731E-05_JPRB, 0.17718187E-05_JPRB, 0.17719269E-05_JPRB, 0.17721684E-05_JPRB, 0.17724998E-05_JPRB, 0.17728909E-05_JPRB, &
  & 0.17732934E-05_JPRB, 0.17736467E-05_JPRB, 0.17738844E-05_JPRB, 0.17739733E-05_JPRB, 0.17739678E-05_JPRB, 0.17738938E-05_JPRB, &
  & 0.17737799E-05_JPRB, 0.17736382E-05_JPRB, 0.17734918E-05_JPRB, 0.17733522E-05_JPRB, 0.17732571E-05_JPRB, 0.17732348E-05_JPRB, &
  & 0.17733011E-05_JPRB, 0.17734280E-05_JPRB, 0.17736165E-05_JPRB, 0.17738513E-05_JPRB, 0.17741171E-05_JPRB, 0.17744070E-05_JPRB, &
  & 0.17747070E-05_JPRB, 0.17749935E-05_JPRB, 0.17752478E-05_JPRB, 0.17754558E-05_JPRB, 0.17756188E-05_JPRB, 0.17757279E-05_JPRB, &
  & 0.17757925E-05_JPRB, 0.17758114E-05_JPRB, 0.17757852E-05_JPRB, 0.17757263E-05_JPRB, 0.17756187E-05_JPRB, 0.17754971E-05_JPRB, &
  & 0.17753142E-05_JPRB, 0.17750945E-05_JPRB, 0.17745908E-05_JPRB, 0.17733680E-05_JPRB /)

RGHG2(:,76, 9) = (/ &
  & 0.17762043E-05_JPRB, 0.17769628E-05_JPRB, 0.17772414E-05_JPRB, 0.17773971E-05_JPRB, 0.17774992E-05_JPRB, 0.17775491E-05_JPRB, &
  & 0.17775833E-05_JPRB, 0.17776093E-05_JPRB, 0.17776266E-05_JPRB, 0.17776374E-05_JPRB, 0.17776401E-05_JPRB, 0.17776167E-05_JPRB, &
  & 0.17775649E-05_JPRB, 0.17774655E-05_JPRB, 0.17773555E-05_JPRB, 0.17771550E-05_JPRB, 0.17768602E-05_JPRB, 0.17764705E-05_JPRB, &
  & 0.17760253E-05_JPRB, 0.17755224E-05_JPRB, 0.17750073E-05_JPRB, 0.17745217E-05_JPRB, 0.17741098E-05_JPRB, 0.17738130E-05_JPRB, &
  & 0.17736380E-05_JPRB, 0.17735830E-05_JPRB, 0.17736589E-05_JPRB, 0.17738390E-05_JPRB, 0.17740907E-05_JPRB, 0.17743888E-05_JPRB, &
  & 0.17746987E-05_JPRB, 0.17749702E-05_JPRB, 0.17751541E-05_JPRB, 0.17752145E-05_JPRB, 0.17752109E-05_JPRB, 0.17751537E-05_JPRB, &
  & 0.17750689E-05_JPRB, 0.17749628E-05_JPRB, 0.17748596E-05_JPRB, 0.17747593E-05_JPRB, 0.17746966E-05_JPRB, 0.17746896E-05_JPRB, &
  & 0.17747566E-05_JPRB, 0.17748670E-05_JPRB, 0.17750281E-05_JPRB, 0.17752260E-05_JPRB, 0.17754421E-05_JPRB, 0.17756826E-05_JPRB, &
  & 0.17759245E-05_JPRB, 0.17761568E-05_JPRB, 0.17763603E-05_JPRB, 0.17765260E-05_JPRB, 0.17766572E-05_JPRB, 0.17767454E-05_JPRB, &
  & 0.17767993E-05_JPRB, 0.17768198E-05_JPRB, 0.17768064E-05_JPRB, 0.17767680E-05_JPRB, 0.17766893E-05_JPRB, 0.17766015E-05_JPRB, &
  & 0.17764621E-05_JPRB, 0.17762907E-05_JPRB, 0.17758706E-05_JPRB, 0.17747742E-05_JPRB /)

RGHG2(:,77, 9) = (/ &
  & 0.17771013E-05_JPRB, 0.17777775E-05_JPRB, 0.17780093E-05_JPRB, 0.17781394E-05_JPRB, 0.17782231E-05_JPRB, 0.17782581E-05_JPRB, &
  & 0.17782841E-05_JPRB, 0.17783050E-05_JPRB, 0.17783171E-05_JPRB, 0.17783193E-05_JPRB, 0.17783179E-05_JPRB, 0.17782935E-05_JPRB, &
  & 0.17782213E-05_JPRB, 0.17781271E-05_JPRB, 0.17780972E-05_JPRB, 0.17779618E-05_JPRB, 0.17777465E-05_JPRB, 0.17774569E-05_JPRB, &
  & 0.17771395E-05_JPRB, 0.17767743E-05_JPRB, 0.17763962E-05_JPRB, 0.17760434E-05_JPRB, 0.17757360E-05_JPRB, 0.17755210E-05_JPRB, &
  & 0.17753928E-05_JPRB, 0.17753439E-05_JPRB, 0.17753947E-05_JPRB, 0.17755198E-05_JPRB, 0.17756947E-05_JPRB, 0.17759044E-05_JPRB, &
  & 0.17761254E-05_JPRB, 0.17763214E-05_JPRB, 0.17764553E-05_JPRB, 0.17764908E-05_JPRB, 0.17764905E-05_JPRB, 0.17764514E-05_JPRB, &
  & 0.17763946E-05_JPRB, 0.17763227E-05_JPRB, 0.17762592E-05_JPRB, 0.17761934E-05_JPRB, 0.17761574E-05_JPRB, 0.17761570E-05_JPRB, &
  & 0.17762154E-05_JPRB, 0.17763033E-05_JPRB, 0.17764287E-05_JPRB, 0.17765788E-05_JPRB, 0.17767414E-05_JPRB, 0.17769183E-05_JPRB, &
  & 0.17770989E-05_JPRB, 0.17772716E-05_JPRB, 0.17774230E-05_JPRB, 0.17775418E-05_JPRB, 0.17776450E-05_JPRB, 0.17777074E-05_JPRB, &
  & 0.17777496E-05_JPRB, 0.17777684E-05_JPRB, 0.17777634E-05_JPRB, 0.17777397E-05_JPRB, 0.17776872E-05_JPRB, 0.17776279E-05_JPRB, &
  & 0.17775322E-05_JPRB, 0.17774098E-05_JPRB, 0.17770676E-05_JPRB, 0.17761439E-05_JPRB /)

RGHG2(:,78, 9) = (/ &
  & 0.17780048E-05_JPRB, 0.17785245E-05_JPRB, 0.17786892E-05_JPRB, 0.17787841E-05_JPRB, 0.17788532E-05_JPRB, 0.17788705E-05_JPRB, &
  & 0.17788900E-05_JPRB, 0.17789080E-05_JPRB, 0.17789132E-05_JPRB, 0.17789082E-05_JPRB, 0.17789076E-05_JPRB, 0.17788849E-05_JPRB, &
  & 0.17788410E-05_JPRB, 0.17787763E-05_JPRB, 0.17787639E-05_JPRB, 0.17786788E-05_JPRB, 0.17785388E-05_JPRB, 0.17783416E-05_JPRB, &
  & 0.17781454E-05_JPRB, 0.17779082E-05_JPRB, 0.17776650E-05_JPRB, 0.17774357E-05_JPRB, 0.17772372E-05_JPRB, 0.17771041E-05_JPRB, &
  & 0.17770301E-05_JPRB, 0.17769955E-05_JPRB, 0.17770307E-05_JPRB, 0.17771129E-05_JPRB, 0.17772213E-05_JPRB, 0.17773557E-05_JPRB, &
  & 0.17774972E-05_JPRB, 0.17776262E-05_JPRB, 0.17777170E-05_JPRB, 0.17777322E-05_JPRB, 0.17777402E-05_JPRB, 0.17777195E-05_JPRB, &
  & 0.17776870E-05_JPRB, 0.17776420E-05_JPRB, 0.17776099E-05_JPRB, 0.17775706E-05_JPRB, 0.17775519E-05_JPRB, 0.17775494E-05_JPRB, &
  & 0.17775895E-05_JPRB, 0.17776459E-05_JPRB, 0.17777265E-05_JPRB, 0.17778221E-05_JPRB, 0.17779208E-05_JPRB, 0.17780310E-05_JPRB, &
  & 0.17781473E-05_JPRB, 0.17782602E-05_JPRB, 0.17783586E-05_JPRB, 0.17784371E-05_JPRB, 0.17785081E-05_JPRB, 0.17785519E-05_JPRB, &
  & 0.17785785E-05_JPRB, 0.17785958E-05_JPRB, 0.17785941E-05_JPRB, 0.17785786E-05_JPRB, 0.17785474E-05_JPRB, 0.17785085E-05_JPRB, &
  & 0.17784524E-05_JPRB, 0.17783700E-05_JPRB, 0.17781422E-05_JPRB, 0.17774468E-05_JPRB /)

RGHG2(:,79, 9) = (/ &
  & 0.17785953E-05_JPRB, 0.17789439E-05_JPRB, 0.17790502E-05_JPRB, 0.17791198E-05_JPRB, 0.17791817E-05_JPRB, 0.17791872E-05_JPRB, &
  & 0.17792026E-05_JPRB, 0.17792205E-05_JPRB, 0.17792214E-05_JPRB, 0.17792114E-05_JPRB, 0.17792117E-05_JPRB, 0.17791923E-05_JPRB, &
  & 0.17791621E-05_JPRB, 0.17791137E-05_JPRB, 0.17791120E-05_JPRB, 0.17790541E-05_JPRB, 0.17789536E-05_JPRB, 0.17788030E-05_JPRB, &
  & 0.17786739E-05_JPRB, 0.17785064E-05_JPRB, 0.17783337E-05_JPRB, 0.17781761E-05_JPRB, 0.17780342E-05_JPRB, 0.17779512E-05_JPRB, &
  & 0.17779090E-05_JPRB, 0.17778841E-05_JPRB, 0.17779133E-05_JPRB, 0.17779734E-05_JPRB, 0.17780469E-05_JPRB, 0.17781401E-05_JPRB, &
  & 0.17782402E-05_JPRB, 0.17783327E-05_JPRB, 0.17784014E-05_JPRB, 0.17784039E-05_JPRB, 0.17784165E-05_JPRB, 0.17784046E-05_JPRB, &
  & 0.17783841E-05_JPRB, 0.17783503E-05_JPRB, 0.17783336E-05_JPRB, 0.17783052E-05_JPRB, 0.17782934E-05_JPRB, 0.17782857E-05_JPRB, &
  & 0.17783137E-05_JPRB, 0.17783512E-05_JPRB, 0.17784062E-05_JPRB, 0.17784710E-05_JPRB, 0.17785336E-05_JPRB, 0.17786068E-05_JPRB, &
  & 0.17786881E-05_JPRB, 0.17787692E-05_JPRB, 0.17788406E-05_JPRB, 0.17788934E-05_JPRB, 0.17789530E-05_JPRB, 0.17789827E-05_JPRB, &
  & 0.17790030E-05_JPRB, 0.17790192E-05_JPRB, 0.17790194E-05_JPRB, 0.17790071E-05_JPRB, 0.17789861E-05_JPRB, 0.17789571E-05_JPRB, &
  & 0.17789226E-05_JPRB, 0.17788769E-05_JPRB, 0.17787299E-05_JPRB, 0.17782725E-05_JPRB /)

RGHG2(:,80, 9) = (/ &
  & 0.17789934E-05_JPRB, 0.17791460E-05_JPRB, 0.17792067E-05_JPRB, 0.17792642E-05_JPRB, 0.17793241E-05_JPRB, 0.17793234E-05_JPRB, &
  & 0.17793370E-05_JPRB, 0.17793558E-05_JPRB, 0.17793550E-05_JPRB, 0.17793431E-05_JPRB, 0.17793451E-05_JPRB, 0.17793268E-05_JPRB, &
  & 0.17793041E-05_JPRB, 0.17792629E-05_JPRB, 0.17792662E-05_JPRB, 0.17792217E-05_JPRB, 0.17791381E-05_JPRB, 0.17790089E-05_JPRB, &
  & 0.17789112E-05_JPRB, 0.17787744E-05_JPRB, 0.17786356E-05_JPRB, 0.17785073E-05_JPRB, 0.17783930E-05_JPRB, 0.17783323E-05_JPRB, &
  & 0.17783061E-05_JPRB, 0.17782860E-05_JPRB, 0.17783132E-05_JPRB, 0.17783645E-05_JPRB, 0.17784221E-05_JPRB, 0.17784979E-05_JPRB, &
  & 0.17785775E-05_JPRB, 0.17786543E-05_JPRB, 0.17787135E-05_JPRB, 0.17787092E-05_JPRB, 0.17787244E-05_JPRB, 0.17787158E-05_JPRB, &
  & 0.17786995E-05_JPRB, 0.17786697E-05_JPRB, 0.17786592E-05_JPRB, 0.17786349E-05_JPRB, 0.17786247E-05_JPRB, 0.17786134E-05_JPRB, &
  & 0.17786354E-05_JPRB, 0.17786634E-05_JPRB, 0.17787074E-05_JPRB, 0.17787584E-05_JPRB, 0.17788049E-05_JPRB, 0.17788608E-05_JPRB, &
  & 0.17789267E-05_JPRB, 0.17789934E-05_JPRB, 0.17790518E-05_JPRB, 0.17790925E-05_JPRB, 0.17791447E-05_JPRB, 0.17791684E-05_JPRB, &
  & 0.17791840E-05_JPRB, 0.17792000E-05_JPRB, 0.17792006E-05_JPRB, 0.17791890E-05_JPRB, 0.17791726E-05_JPRB, 0.17791471E-05_JPRB, &
  & 0.17791251E-05_JPRB, 0.17790962E-05_JPRB, 0.17790112E-05_JPRB, 0.17788090E-05_JPRB /)

RGHG2(:,81, 9) = (/ &
  & 0.17792715E-05_JPRB, 0.17792305E-05_JPRB, 0.17792722E-05_JPRB, 0.17793246E-05_JPRB, 0.17793855E-05_JPRB, 0.17793813E-05_JPRB, &
  & 0.17793941E-05_JPRB, 0.17794140E-05_JPRB, 0.17794127E-05_JPRB, 0.17793999E-05_JPRB, 0.17794027E-05_JPRB, 0.17793850E-05_JPRB, &
  & 0.17793662E-05_JPRB, 0.17793279E-05_JPRB, 0.17793343E-05_JPRB, 0.17792959E-05_JPRB, 0.17792214E-05_JPRB, 0.17790989E-05_JPRB, &
  & 0.17790169E-05_JPRB, 0.17788936E-05_JPRB, 0.17787677E-05_JPRB, 0.17786545E-05_JPRB, 0.17785499E-05_JPRB, 0.17784999E-05_JPRB, &
  & 0.17784810E-05_JPRB, 0.17784629E-05_JPRB, 0.17784894E-05_JPRB, 0.17785371E-05_JPRB, 0.17785881E-05_JPRB, 0.17786550E-05_JPRB, &
  & 0.17787265E-05_JPRB, 0.17787959E-05_JPRB, 0.17788509E-05_JPRB, 0.17788435E-05_JPRB, 0.17788601E-05_JPRB, 0.17788531E-05_JPRB, &
  & 0.17788384E-05_JPRB, 0.17788102E-05_JPRB, 0.17788019E-05_JPRB, 0.17787793E-05_JPRB, 0.17787692E-05_JPRB, 0.17787565E-05_JPRB, &
  & 0.17787754E-05_JPRB, 0.17788000E-05_JPRB, 0.17788387E-05_JPRB, 0.17788846E-05_JPRB, 0.17789237E-05_JPRB, 0.17789724E-05_JPRB, &
  & 0.17790317E-05_JPRB, 0.17790919E-05_JPRB, 0.17791443E-05_JPRB, 0.17791788E-05_JPRB, 0.17792282E-05_JPRB, 0.17792481E-05_JPRB, &
  & 0.17792614E-05_JPRB, 0.17792770E-05_JPRB, 0.17792773E-05_JPRB, 0.17792659E-05_JPRB, 0.17792512E-05_JPRB, 0.17792272E-05_JPRB, &
  & 0.17792095E-05_JPRB, 0.17791884E-05_JPRB, 0.17791289E-05_JPRB, 0.17791742E-05_JPRB /)

RGHG2(:,82, 9) = (/ &
  & 0.17792939E-05_JPRB, 0.17792580E-05_JPRB, 0.17793004E-05_JPRB, 0.17793537E-05_JPRB, 0.17794150E-05_JPRB, 0.17794093E-05_JPRB, &
  & 0.17794230E-05_JPRB, 0.17794412E-05_JPRB, 0.17794389E-05_JPRB, 0.17794282E-05_JPRB, 0.17794298E-05_JPRB, 0.17794139E-05_JPRB, &
  & 0.17793959E-05_JPRB, 0.17793600E-05_JPRB, 0.17793675E-05_JPRB, 0.17793330E-05_JPRB, 0.17792618E-05_JPRB, 0.17791435E-05_JPRB, &
  & 0.17790693E-05_JPRB, 0.17789525E-05_JPRB, 0.17788341E-05_JPRB, 0.17787263E-05_JPRB, 0.17786267E-05_JPRB, 0.17785820E-05_JPRB, &
  & 0.17785661E-05_JPRB, 0.17785492E-05_JPRB, 0.17785756E-05_JPRB, 0.17786213E-05_JPRB, 0.17786688E-05_JPRB, 0.17787323E-05_JPRB, &
  & 0.17787989E-05_JPRB, 0.17788650E-05_JPRB, 0.17789182E-05_JPRB, 0.17789094E-05_JPRB, 0.17789266E-05_JPRB, 0.17789201E-05_JPRB, &
  & 0.17789059E-05_JPRB, 0.17788784E-05_JPRB, 0.17788718E-05_JPRB, 0.17788501E-05_JPRB, 0.17788400E-05_JPRB, 0.17788261E-05_JPRB, &
  & 0.17788439E-05_JPRB, 0.17788666E-05_JPRB, 0.17789038E-05_JPRB, 0.17789463E-05_JPRB, 0.17789823E-05_JPRB, 0.17790272E-05_JPRB, &
  & 0.17790833E-05_JPRB, 0.17791399E-05_JPRB, 0.17791897E-05_JPRB, 0.17792202E-05_JPRB, 0.17792688E-05_JPRB, 0.17792864E-05_JPRB, &
  & 0.17792987E-05_JPRB, 0.17793141E-05_JPRB, 0.17793142E-05_JPRB, 0.17793025E-05_JPRB, 0.17792887E-05_JPRB, 0.17792654E-05_JPRB, &
  & 0.17792498E-05_JPRB, 0.17792293E-05_JPRB, 0.17791676E-05_JPRB, 0.17792032E-05_JPRB /)

RGHG2(:,83, 9) = (/ &
  & 0.17793094E-05_JPRB, 0.17792737E-05_JPRB, 0.17793163E-05_JPRB, 0.17793692E-05_JPRB, 0.17794318E-05_JPRB, 0.17794252E-05_JPRB, &
  & 0.17794376E-05_JPRB, 0.17794575E-05_JPRB, 0.17794557E-05_JPRB, 0.17794434E-05_JPRB, 0.17794453E-05_JPRB, 0.17794282E-05_JPRB, &
  & 0.17794127E-05_JPRB, 0.17793786E-05_JPRB, 0.17793861E-05_JPRB, 0.17793541E-05_JPRB, 0.17792851E-05_JPRB, 0.17791683E-05_JPRB, &
  & 0.17790990E-05_JPRB, 0.17789863E-05_JPRB, 0.17788705E-05_JPRB, 0.17787668E-05_JPRB, 0.17786699E-05_JPRB, 0.17786277E-05_JPRB, &
  & 0.17786144E-05_JPRB, 0.17785972E-05_JPRB, 0.17786238E-05_JPRB, 0.17786682E-05_JPRB, 0.17787145E-05_JPRB, 0.17787752E-05_JPRB, &
  & 0.17788395E-05_JPRB, 0.17789031E-05_JPRB, 0.17789554E-05_JPRB, 0.17789459E-05_JPRB, 0.17789635E-05_JPRB, 0.17789578E-05_JPRB, &
  & 0.17789433E-05_JPRB, 0.17789166E-05_JPRB, 0.17789101E-05_JPRB, 0.17788893E-05_JPRB, 0.17788793E-05_JPRB, 0.17788649E-05_JPRB, &
  & 0.17788818E-05_JPRB, 0.17789035E-05_JPRB, 0.17789403E-05_JPRB, 0.17789816E-05_JPRB, 0.17790152E-05_JPRB, 0.17790583E-05_JPRB, &
  & 0.17791123E-05_JPRB, 0.17791673E-05_JPRB, 0.17792149E-05_JPRB, 0.17792437E-05_JPRB, 0.17792913E-05_JPRB, 0.17793078E-05_JPRB, &
  & 0.17793191E-05_JPRB, 0.17793346E-05_JPRB, 0.17793348E-05_JPRB, 0.17793229E-05_JPRB, 0.17793097E-05_JPRB, 0.17792865E-05_JPRB, &
  & 0.17792723E-05_JPRB, 0.17792523E-05_JPRB, 0.17791905E-05_JPRB, 0.17792237E-05_JPRB /)

RGHG2(:,84, 9) = (/ &
  & 0.17793205E-05_JPRB, 0.17792843E-05_JPRB, 0.17793253E-05_JPRB, 0.17793794E-05_JPRB, 0.17794425E-05_JPRB, 0.17794350E-05_JPRB, &
  & 0.17794493E-05_JPRB, 0.17794648E-05_JPRB, 0.17794616E-05_JPRB, 0.17794536E-05_JPRB, 0.17794523E-05_JPRB, 0.17794385E-05_JPRB, &
  & 0.17794216E-05_JPRB, 0.17793917E-05_JPRB, 0.17793964E-05_JPRB, 0.17793668E-05_JPRB, 0.17793000E-05_JPRB, 0.17791846E-05_JPRB, &
  & 0.17791181E-05_JPRB, 0.17790069E-05_JPRB, 0.17788933E-05_JPRB, 0.17787925E-05_JPRB, 0.17786952E-05_JPRB, 0.17786563E-05_JPRB, &
  & 0.17786438E-05_JPRB, 0.17786267E-05_JPRB, 0.17786533E-05_JPRB, 0.17786979E-05_JPRB, 0.17787415E-05_JPRB, 0.17788018E-05_JPRB, &
  & 0.17788639E-05_JPRB, 0.17789265E-05_JPRB, 0.17789778E-05_JPRB, 0.17789681E-05_JPRB, 0.17789862E-05_JPRB, 0.17789806E-05_JPRB, &
  & 0.17789663E-05_JPRB, 0.17789396E-05_JPRB, 0.17789337E-05_JPRB, 0.17789134E-05_JPRB, 0.17789034E-05_JPRB, 0.17788888E-05_JPRB, &
  & 0.17789048E-05_JPRB, 0.17789266E-05_JPRB, 0.17789622E-05_JPRB, 0.17790039E-05_JPRB, 0.17790353E-05_JPRB, 0.17790774E-05_JPRB, &
  & 0.17791301E-05_JPRB, 0.17791843E-05_JPRB, 0.17792307E-05_JPRB, 0.17792584E-05_JPRB, 0.17793058E-05_JPRB, 0.17793207E-05_JPRB, &
  & 0.17793317E-05_JPRB, 0.17793473E-05_JPRB, 0.17793471E-05_JPRB, 0.17793352E-05_JPRB, 0.17793226E-05_JPRB, 0.17792989E-05_JPRB, &
  & 0.17792863E-05_JPRB, 0.17792668E-05_JPRB, 0.17792057E-05_JPRB, 0.17792378E-05_JPRB /)

RGHG2(:,85, 9) = (/ &
  & 0.17793279E-05_JPRB, 0.17792906E-05_JPRB, 0.17793317E-05_JPRB, 0.17793856E-05_JPRB, 0.17794493E-05_JPRB, 0.17794425E-05_JPRB, &
  & 0.17794534E-05_JPRB, 0.17794699E-05_JPRB, 0.17794678E-05_JPRB, 0.17794582E-05_JPRB, 0.17794559E-05_JPRB, 0.17794421E-05_JPRB, &
  & 0.17794268E-05_JPRB, 0.17794026E-05_JPRB, 0.17794005E-05_JPRB, 0.17793730E-05_JPRB, 0.17793092E-05_JPRB, 0.17791988E-05_JPRB, &
  & 0.17791313E-05_JPRB, 0.17790213E-05_JPRB, 0.17789094E-05_JPRB, 0.17788083E-05_JPRB, 0.17787129E-05_JPRB, 0.17786738E-05_JPRB, &
  & 0.17786631E-05_JPRB, 0.17786448E-05_JPRB, 0.17786722E-05_JPRB, 0.17787154E-05_JPRB, 0.17787603E-05_JPRB, 0.17788177E-05_JPRB, &
  & 0.17788802E-05_JPRB, 0.17789414E-05_JPRB, 0.17789928E-05_JPRB, 0.17789823E-05_JPRB, 0.17790009E-05_JPRB, 0.17789954E-05_JPRB, &
  & 0.17789810E-05_JPRB, 0.17789540E-05_JPRB, 0.17789489E-05_JPRB, 0.17789292E-05_JPRB, 0.17789191E-05_JPRB, 0.17789040E-05_JPRB, &
  & 0.17789205E-05_JPRB, 0.17789407E-05_JPRB, 0.17789780E-05_JPRB, 0.17790176E-05_JPRB, 0.17790487E-05_JPRB, 0.17790899E-05_JPRB, &
  & 0.17791417E-05_JPRB, 0.17791954E-05_JPRB, 0.17792411E-05_JPRB, 0.17792674E-05_JPRB, 0.17793149E-05_JPRB, 0.17793292E-05_JPRB, &
  & 0.17793395E-05_JPRB, 0.17793557E-05_JPRB, 0.17793553E-05_JPRB, 0.17793434E-05_JPRB, 0.17793307E-05_JPRB, 0.17793079E-05_JPRB, &
  & 0.17792952E-05_JPRB, 0.17792767E-05_JPRB, 0.17792152E-05_JPRB, 0.17792470E-05_JPRB /)

RGHG2(:,86, 9) = (/ &
  & 0.17793337E-05_JPRB, 0.17792943E-05_JPRB, 0.17793346E-05_JPRB, 0.17793891E-05_JPRB, 0.17794539E-05_JPRB, 0.17794475E-05_JPRB, &
  & 0.17794609E-05_JPRB, 0.17794695E-05_JPRB, 0.17794664E-05_JPRB, 0.17794601E-05_JPRB, 0.17794550E-05_JPRB, 0.17794437E-05_JPRB, &
  & 0.17794296E-05_JPRB, 0.17794093E-05_JPRB, 0.17794014E-05_JPRB, 0.17793734E-05_JPRB, 0.17793146E-05_JPRB, 0.17792129E-05_JPRB, &
  & 0.17791411E-05_JPRB, 0.17790333E-05_JPRB, 0.17789196E-05_JPRB, 0.17788205E-05_JPRB, 0.17787225E-05_JPRB, 0.17786853E-05_JPRB, &
  & 0.17786749E-05_JPRB, 0.17786557E-05_JPRB, 0.17786830E-05_JPRB, 0.17787281E-05_JPRB, 0.17787704E-05_JPRB, 0.17788300E-05_JPRB, &
  & 0.17788900E-05_JPRB, 0.17789521E-05_JPRB, 0.17790026E-05_JPRB, 0.17789912E-05_JPRB, 0.17790104E-05_JPRB, 0.17790052E-05_JPRB, &
  & 0.17789905E-05_JPRB, 0.17789636E-05_JPRB, 0.17789589E-05_JPRB, 0.17789390E-05_JPRB, 0.17789287E-05_JPRB, 0.17789129E-05_JPRB, &
  & 0.17789291E-05_JPRB, 0.17789514E-05_JPRB, 0.17789865E-05_JPRB, 0.17790280E-05_JPRB, 0.17790569E-05_JPRB, 0.17790976E-05_JPRB, &
  & 0.17791490E-05_JPRB, 0.17792023E-05_JPRB, 0.17792476E-05_JPRB, 0.17792734E-05_JPRB, 0.17793207E-05_JPRB, 0.17793348E-05_JPRB, &
  & 0.17793445E-05_JPRB, 0.17793608E-05_JPRB, 0.17793602E-05_JPRB, 0.17793485E-05_JPRB, 0.17793362E-05_JPRB, 0.17793121E-05_JPRB, &
  & 0.17793014E-05_JPRB, 0.17792828E-05_JPRB, 0.17792211E-05_JPRB, 0.17792532E-05_JPRB /)

RGHG2(:,87, 9) = (/ &
  & 0.17793365E-05_JPRB, 0.17792963E-05_JPRB, 0.17793375E-05_JPRB, 0.17793944E-05_JPRB, 0.17794557E-05_JPRB, 0.17794518E-05_JPRB, &
  & 0.17794596E-05_JPRB, 0.17794695E-05_JPRB, 0.17794667E-05_JPRB, 0.17794591E-05_JPRB, 0.17794539E-05_JPRB, 0.17794425E-05_JPRB, &
  & 0.17794293E-05_JPRB, 0.17794118E-05_JPRB, 0.17794001E-05_JPRB, 0.17793732E-05_JPRB, 0.17793172E-05_JPRB, 0.17792232E-05_JPRB, &
  & 0.17791509E-05_JPRB, 0.17790405E-05_JPRB, 0.17789287E-05_JPRB, 0.17788268E-05_JPRB, 0.17787295E-05_JPRB, 0.17786919E-05_JPRB, &
  & 0.17786825E-05_JPRB, 0.17786608E-05_JPRB, 0.17786897E-05_JPRB, 0.17787336E-05_JPRB, 0.17787779E-05_JPRB, 0.17788356E-05_JPRB, &
  & 0.17788976E-05_JPRB, 0.17789588E-05_JPRB, 0.17790093E-05_JPRB, 0.17789966E-05_JPRB, 0.17790164E-05_JPRB, 0.17790111E-05_JPRB, &
  & 0.17789971E-05_JPRB, 0.17789687E-05_JPRB, 0.17789655E-05_JPRB, 0.17789446E-05_JPRB, 0.17789343E-05_JPRB, 0.17789170E-05_JPRB, &
  & 0.17789353E-05_JPRB, 0.17789563E-05_JPRB, 0.17789941E-05_JPRB, 0.17790337E-05_JPRB, 0.17790625E-05_JPRB, 0.17791025E-05_JPRB, &
  & 0.17791535E-05_JPRB, 0.17792065E-05_JPRB, 0.17792520E-05_JPRB, 0.17792768E-05_JPRB, 0.17793241E-05_JPRB, 0.17793378E-05_JPRB, &
  & 0.17793477E-05_JPRB, 0.17793636E-05_JPRB, 0.17793634E-05_JPRB, 0.17793517E-05_JPRB, 0.17793392E-05_JPRB, 0.17793153E-05_JPRB, &
  & 0.17793050E-05_JPRB, 0.17792869E-05_JPRB, 0.17792242E-05_JPRB, 0.17792571E-05_JPRB /)

RGHG2(:,88, 9) = (/ &
  & 0.17793386E-05_JPRB, 0.17792988E-05_JPRB, 0.17793385E-05_JPRB, 0.17793928E-05_JPRB, 0.17794582E-05_JPRB, 0.17794528E-05_JPRB, &
  & 0.17794639E-05_JPRB, 0.17794696E-05_JPRB, 0.17794657E-05_JPRB, 0.17794600E-05_JPRB, 0.17794539E-05_JPRB, 0.17794432E-05_JPRB, &
  & 0.17794305E-05_JPRB, 0.17794130E-05_JPRB, 0.17794014E-05_JPRB, 0.17793734E-05_JPRB, 0.17793200E-05_JPRB, 0.17792285E-05_JPRB, &
  & 0.17791540E-05_JPRB, 0.17790471E-05_JPRB, 0.17789317E-05_JPRB, 0.17788323E-05_JPRB, 0.17787328E-05_JPRB, 0.17786962E-05_JPRB, &
  & 0.17786872E-05_JPRB, 0.17786637E-05_JPRB, 0.17786925E-05_JPRB, 0.17787385E-05_JPRB, 0.17787804E-05_JPRB, 0.17788403E-05_JPRB, &
  & 0.17789015E-05_JPRB, 0.17789635E-05_JPRB, 0.17790138E-05_JPRB, 0.17789996E-05_JPRB, 0.17790205E-05_JPRB, 0.17790152E-05_JPRB, &
  & 0.17790009E-05_JPRB, 0.17789716E-05_JPRB, 0.17789700E-05_JPRB, 0.17789487E-05_JPRB, 0.17789383E-05_JPRB, 0.17789188E-05_JPRB, &
  & 0.17789383E-05_JPRB, 0.17789603E-05_JPRB, 0.17789969E-05_JPRB, 0.17790380E-05_JPRB, 0.17790659E-05_JPRB, 0.17791058E-05_JPRB, &
  & 0.17791567E-05_JPRB, 0.17792095E-05_JPRB, 0.17792547E-05_JPRB, 0.17792788E-05_JPRB, 0.17793266E-05_JPRB, 0.17793400E-05_JPRB, &
  & 0.17793494E-05_JPRB, 0.17793653E-05_JPRB, 0.17793652E-05_JPRB, 0.17793534E-05_JPRB, 0.17793411E-05_JPRB, 0.17793166E-05_JPRB, &
  & 0.17793070E-05_JPRB, 0.17792892E-05_JPRB, 0.17792264E-05_JPRB, 0.17792593E-05_JPRB /)

RGHG2(:,89, 9) = (/ &
  & 0.17793383E-05_JPRB, 0.17793017E-05_JPRB, 0.17793402E-05_JPRB, 0.17793955E-05_JPRB, 0.17794588E-05_JPRB, 0.17794536E-05_JPRB, &
  & 0.17794616E-05_JPRB, 0.17794719E-05_JPRB, 0.17794687E-05_JPRB, 0.17794611E-05_JPRB, 0.17794559E-05_JPRB, 0.17794446E-05_JPRB, &
  & 0.17794314E-05_JPRB, 0.17794139E-05_JPRB, 0.17794027E-05_JPRB, 0.17793764E-05_JPRB, 0.17793209E-05_JPRB, 0.17792262E-05_JPRB, &
  & 0.17791556E-05_JPRB, 0.17790453E-05_JPRB, 0.17789341E-05_JPRB, 0.17788331E-05_JPRB, 0.17787345E-05_JPRB, 0.17786979E-05_JPRB, &
  & 0.17786897E-05_JPRB, 0.17786645E-05_JPRB, 0.17786942E-05_JPRB, 0.17787399E-05_JPRB, 0.17787826E-05_JPRB, 0.17788417E-05_JPRB, &
  & 0.17789042E-05_JPRB, 0.17789661E-05_JPRB, 0.17790176E-05_JPRB, 0.17790010E-05_JPRB, 0.17790228E-05_JPRB, 0.17790177E-05_JPRB, &
  & 0.17790035E-05_JPRB, 0.17789730E-05_JPRB, 0.17789731E-05_JPRB, 0.17789500E-05_JPRB, 0.17789405E-05_JPRB, 0.17789187E-05_JPRB, &
  & 0.17789404E-05_JPRB, 0.17789619E-05_JPRB, 0.17789998E-05_JPRB, 0.17790403E-05_JPRB, 0.17790676E-05_JPRB, 0.17791074E-05_JPRB, &
  & 0.17791581E-05_JPRB, 0.17792112E-05_JPRB, 0.17792564E-05_JPRB, 0.17792800E-05_JPRB, 0.17793279E-05_JPRB, 0.17793413E-05_JPRB, &
  & 0.17793509E-05_JPRB, 0.17793667E-05_JPRB, 0.17793660E-05_JPRB, 0.17793543E-05_JPRB, 0.17793423E-05_JPRB, 0.17793172E-05_JPRB, &
  & 0.17793080E-05_JPRB, 0.17792908E-05_JPRB, 0.17792269E-05_JPRB, 0.17792606E-05_JPRB /)

RGHG2(:,90, 9) = (/ &
  & 0.17793384E-05_JPRB, 0.17793041E-05_JPRB, 0.17793373E-05_JPRB, 0.17793921E-05_JPRB, 0.17794615E-05_JPRB, 0.17794512E-05_JPRB, &
  & 0.17794655E-05_JPRB, 0.17794764E-05_JPRB, 0.17794725E-05_JPRB, 0.17794655E-05_JPRB, 0.17794612E-05_JPRB, 0.17794484E-05_JPRB, &
  & 0.17794346E-05_JPRB, 0.17794140E-05_JPRB, 0.17794086E-05_JPRB, 0.17793819E-05_JPRB, 0.17793234E-05_JPRB, 0.17792183E-05_JPRB, &
  & 0.17791521E-05_JPRB, 0.17790439E-05_JPRB, 0.17789316E-05_JPRB, 0.17788338E-05_JPRB, 0.17787333E-05_JPRB, 0.17786984E-05_JPRB, &
  & 0.17786913E-05_JPRB, 0.17786638E-05_JPRB, 0.17786945E-05_JPRB, 0.17787407E-05_JPRB, 0.17787823E-05_JPRB, 0.17788423E-05_JPRB, &
  & 0.17789051E-05_JPRB, 0.17789679E-05_JPRB, 0.17790215E-05_JPRB, 0.17790005E-05_JPRB, 0.17790248E-05_JPRB, 0.17790193E-05_JPRB, &
  & 0.17790054E-05_JPRB, 0.17789730E-05_JPRB, 0.17789750E-05_JPRB, 0.17789506E-05_JPRB, 0.17789413E-05_JPRB, 0.17789175E-05_JPRB, &
  & 0.17789408E-05_JPRB, 0.17789624E-05_JPRB, 0.17790005E-05_JPRB, 0.17790418E-05_JPRB, 0.17790683E-05_JPRB, 0.17791082E-05_JPRB, &
  & 0.17791590E-05_JPRB, 0.17792124E-05_JPRB, 0.17792580E-05_JPRB, 0.17792801E-05_JPRB, 0.17793295E-05_JPRB, 0.17793419E-05_JPRB, &
  & 0.17793508E-05_JPRB, 0.17793674E-05_JPRB, 0.17793669E-05_JPRB, 0.17793548E-05_JPRB, 0.17793427E-05_JPRB, 0.17793170E-05_JPRB, &
  & 0.17793087E-05_JPRB, 0.17792917E-05_JPRB, 0.17792253E-05_JPRB, 0.17792617E-05_JPRB /)

RGHG2(:,91, 9) = (/ &
  & 0.17793415E-05_JPRB, 0.17793036E-05_JPRB, 0.17793282E-05_JPRB, 0.17793908E-05_JPRB, 0.17794698E-05_JPRB, 0.17794464E-05_JPRB, &
  & 0.17794595E-05_JPRB, 0.17794872E-05_JPRB, 0.17794798E-05_JPRB, 0.17794630E-05_JPRB, 0.17794738E-05_JPRB, 0.17794511E-05_JPRB, &
  & 0.17794403E-05_JPRB, 0.17793983E-05_JPRB, 0.17794216E-05_JPRB, 0.17793946E-05_JPRB, 0.17793295E-05_JPRB, 0.17791996E-05_JPRB, &
  & 0.17791535E-05_JPRB, 0.17790403E-05_JPRB, 0.17789298E-05_JPRB, 0.17788336E-05_JPRB, 0.17787293E-05_JPRB, 0.17786966E-05_JPRB, &
  & 0.17786928E-05_JPRB, 0.17786600E-05_JPRB, 0.17786937E-05_JPRB, 0.17787412E-05_JPRB, 0.17787804E-05_JPRB, 0.17788414E-05_JPRB, &
  & 0.17789058E-05_JPRB, 0.17789685E-05_JPRB, 0.17790300E-05_JPRB, 0.17789966E-05_JPRB, 0.17790278E-05_JPRB, 0.17790203E-05_JPRB, &
  & 0.17790070E-05_JPRB, 0.17789702E-05_JPRB, 0.17789771E-05_JPRB, 0.17789498E-05_JPRB, 0.17789428E-05_JPRB, 0.17789143E-05_JPRB, &
  & 0.17789411E-05_JPRB, 0.17789615E-05_JPRB, 0.17790010E-05_JPRB, 0.17790433E-05_JPRB, 0.17790677E-05_JPRB, 0.17791077E-05_JPRB, &
  & 0.17791592E-05_JPRB, 0.17792132E-05_JPRB, 0.17792599E-05_JPRB, 0.17792783E-05_JPRB, 0.17793323E-05_JPRB, 0.17793423E-05_JPRB, &
  & 0.17793508E-05_JPRB, 0.17793691E-05_JPRB, 0.17793679E-05_JPRB, 0.17793548E-05_JPRB, 0.17793434E-05_JPRB, 0.17793158E-05_JPRB, &
  & 0.17793094E-05_JPRB, 0.17792931E-05_JPRB, 0.17792213E-05_JPRB, 0.17792627E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART18',1,ZHOOK_HANDLE)
END SUBROUTINE PART18






SUBROUTINE PART19
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART19',0,ZHOOK_HANDLE)



!-- Month= 10 ------------

RGHG2(:, 1,10) = (/ &
  & 0.94234700E-08_JPRB, 0.88591978E-08_JPRB, 0.83902396E-08_JPRB, 0.80084837E-08_JPRB, 0.77164275E-08_JPRB, 0.75497599E-08_JPRB, &
  & 0.74790147E-08_JPRB, 0.74825222E-08_JPRB, 0.75466859E-08_JPRB, 0.76790512E-08_JPRB, 0.79285432E-08_JPRB, 0.83232798E-08_JPRB, &
  & 0.88357099E-08_JPRB, 0.94201500E-08_JPRB, 0.10094682E-07_JPRB, 0.10873838E-07_JPRB, 0.11713900E-07_JPRB, 0.12523313E-07_JPRB, &
  & 0.13211753E-07_JPRB, 0.13712596E-07_JPRB, 0.13990491E-07_JPRB, 0.14045657E-07_JPRB, 0.13907592E-07_JPRB, 0.13616074E-07_JPRB, &
  & 0.13208378E-07_JPRB, 0.12704811E-07_JPRB, 0.12085692E-07_JPRB, 0.11242461E-07_JPRB, 0.10199684E-07_JPRB, 0.89856682E-08_JPRB, &
  & 0.76481079E-08_JPRB, 0.62787442E-08_JPRB, 0.49868758E-08_JPRB, 0.38571835E-08_JPRB, 0.29591061E-08_JPRB, 0.23976576E-08_JPRB, &
  & 0.23152031E-08_JPRB, 0.28551437E-08_JPRB, 0.41060733E-08_JPRB, 0.64294565E-08_JPRB, 0.95936405E-08_JPRB, 0.12223000E-07_JPRB, &
  & 0.14094082E-07_JPRB, 0.15492549E-07_JPRB, 0.16529771E-07_JPRB, 0.17269610E-07_JPRB, 0.17725085E-07_JPRB, 0.17866888E-07_JPRB, &
  & 0.17672885E-07_JPRB, 0.17163744E-07_JPRB, 0.16412667E-07_JPRB, 0.15548107E-07_JPRB, 0.14684849E-07_JPRB, 0.13918378E-07_JPRB, &
  & 0.13315946E-07_JPRB, 0.12889080E-07_JPRB, 0.12611330E-07_JPRB, 0.12433882E-07_JPRB, 0.12320454E-07_JPRB, 0.12246902E-07_JPRB, &
  & 0.12194656E-07_JPRB, 0.12154837E-07_JPRB, 0.12130836E-07_JPRB, 0.12118263E-07_JPRB /)

RGHG2(:, 2,10) = (/ &
  & 0.20247967E-07_JPRB, 0.19289367E-07_JPRB, 0.18711560E-07_JPRB, 0.18274996E-07_JPRB, 0.17964139E-07_JPRB, 0.17827530E-07_JPRB, &
  & 0.17912885E-07_JPRB, 0.18266757E-07_JPRB, 0.18882009E-07_JPRB, 0.19696442E-07_JPRB, 0.20701608E-07_JPRB, 0.21938193E-07_JPRB, &
  & 0.23412262E-07_JPRB, 0.25050749E-07_JPRB, 0.26743674E-07_JPRB, 0.28357078E-07_JPRB, 0.29879544E-07_JPRB, 0.31244220E-07_JPRB, &
  & 0.32338132E-07_JPRB, 0.33037271E-07_JPRB, 0.33289464E-07_JPRB, 0.33108712E-07_JPRB, 0.32550389E-07_JPRB, 0.31665873E-07_JPRB, &
  & 0.30493716E-07_JPRB, 0.29054965E-07_JPRB, 0.27311616E-07_JPRB, 0.25260810E-07_JPRB, 0.22923725E-07_JPRB, 0.20435667E-07_JPRB, &
  & 0.17917248E-07_JPRB, 0.15466448E-07_JPRB, 0.13084296E-07_JPRB, 0.10832637E-07_JPRB, 0.89917389E-08_JPRB, 0.79969427E-08_JPRB, &
  & 0.82414795E-08_JPRB, 0.99007433E-08_JPRB, 0.12913190E-07_JPRB, 0.17016131E-07_JPRB, 0.21778137E-07_JPRB, 0.26207829E-07_JPRB, &
  & 0.29688747E-07_JPRB, 0.32124635E-07_JPRB, 0.33618473E-07_JPRB, 0.34314269E-07_JPRB, 0.34372192E-07_JPRB, 0.33960180E-07_JPRB, &
  & 0.33237871E-07_JPRB, 0.32347280E-07_JPRB, 0.31350464E-07_JPRB, 0.30156162E-07_JPRB, 0.28652444E-07_JPRB, 0.26855624E-07_JPRB, &
  & 0.24915611E-07_JPRB, 0.23046169E-07_JPRB, 0.21390058E-07_JPRB, 0.20012685E-07_JPRB, 0.18914799E-07_JPRB, 0.18077621E-07_JPRB, &
  & 0.17472349E-07_JPRB, 0.17061142E-07_JPRB, 0.16783634E-07_JPRB, 0.16532523E-07_JPRB /)

RGHG2(:, 3,10) = (/ &
  & 0.26657872E-07_JPRB, 0.26356229E-07_JPRB, 0.26378892E-07_JPRB, 0.26623690E-07_JPRB, 0.27091591E-07_JPRB, 0.27774295E-07_JPRB, &
  & 0.28623962E-07_JPRB, 0.29659308E-07_JPRB, 0.30881381E-07_JPRB, 0.32313313E-07_JPRB, 0.33892352E-07_JPRB, 0.35533269E-07_JPRB, &
  & 0.37193068E-07_JPRB, 0.38893955E-07_JPRB, 0.40614083E-07_JPRB, 0.42216577E-07_JPRB, 0.43633825E-07_JPRB, 0.44816751E-07_JPRB, &
  & 0.45797332E-07_JPRB, 0.46510451E-07_JPRB, 0.46820510E-07_JPRB, 0.46634341E-07_JPRB, 0.45932850E-07_JPRB, 0.44792461E-07_JPRB, &
  & 0.43232539E-07_JPRB, 0.41225089E-07_JPRB, 0.38794820E-07_JPRB, 0.35870098E-07_JPRB, 0.32597686E-07_JPRB, 0.29111813E-07_JPRB, &
  & 0.25573915E-07_JPRB, 0.22051671E-07_JPRB, 0.18764947E-07_JPRB, 0.16333574E-07_JPRB, 0.15470624E-07_JPRB, 0.16509116E-07_JPRB, &
  & 0.19372720E-07_JPRB, 0.23756270E-07_JPRB, 0.29268609E-07_JPRB, 0.35454530E-07_JPRB, 0.41588180E-07_JPRB, 0.46954558E-07_JPRB, &
  & 0.51020407E-07_JPRB, 0.53737072E-07_JPRB, 0.55231801E-07_JPRB, 0.55684968E-07_JPRB, 0.55275727E-07_JPRB, 0.54130346E-07_JPRB, &
  & 0.52315638E-07_JPRB, 0.49852936E-07_JPRB, 0.46777927E-07_JPRB, 0.43256836E-07_JPRB, 0.39572551E-07_JPRB, 0.36000536E-07_JPRB, &
  & 0.32711863E-07_JPRB, 0.29786289E-07_JPRB, 0.27307724E-07_JPRB, 0.25300764E-07_JPRB, 0.23761430E-07_JPRB, 0.22627091E-07_JPRB, &
  & 0.21821986E-07_JPRB, 0.21270093E-07_JPRB, 0.20902160E-07_JPRB, 0.20575126E-07_JPRB /)

RGHG2(:, 4,10) = (/ &
  & 0.29509701E-07_JPRB, 0.30135968E-07_JPRB, 0.30821845E-07_JPRB, 0.31723076E-07_JPRB, 0.32877040E-07_JPRB, 0.34260026E-07_JPRB, &
  & 0.35811340E-07_JPRB, 0.37407549E-07_JPRB, 0.39038586E-07_JPRB, 0.40684064E-07_JPRB, 0.42364952E-07_JPRB, 0.44057685E-07_JPRB, &
  & 0.45670898E-07_JPRB, 0.47122974E-07_JPRB, 0.48420524E-07_JPRB, 0.49647994E-07_JPRB, 0.50850115E-07_JPRB, 0.51948529E-07_JPRB, &
  & 0.52901456E-07_JPRB, 0.53628742E-07_JPRB, 0.54071968E-07_JPRB, 0.54168645E-07_JPRB, 0.53657477E-07_JPRB, 0.52408005E-07_JPRB, &
  & 0.50529060E-07_JPRB, 0.48062148E-07_JPRB, 0.44929131E-07_JPRB, 0.41436891E-07_JPRB, 0.37819618E-07_JPRB, 0.34333791E-07_JPRB, &
  & 0.30984914E-07_JPRB, 0.28082269E-07_JPRB, 0.26233536E-07_JPRB, 0.25973904E-07_JPRB, 0.27680880E-07_JPRB, 0.31384989E-07_JPRB, &
  & 0.36721069E-07_JPRB, 0.43154778E-07_JPRB, 0.50153918E-07_JPRB, 0.57184966E-07_JPRB, 0.63632420E-07_JPRB, 0.68778050E-07_JPRB, &
  & 0.72319565E-07_JPRB, 0.74314116E-07_JPRB, 0.75010661E-07_JPRB, 0.74689446E-07_JPRB, 0.73556528E-07_JPRB, 0.71745944E-07_JPRB, &
  & 0.69338746E-07_JPRB, 0.66390932E-07_JPRB, 0.62942661E-07_JPRB, 0.59015168E-07_JPRB, 0.54610133E-07_JPRB, 0.49769461E-07_JPRB, &
  & 0.44680391E-07_JPRB, 0.39734982E-07_JPRB, 0.35299635E-07_JPRB, 0.31652611E-07_JPRB, 0.28806738E-07_JPRB, 0.26687676E-07_JPRB, &
  & 0.25183880E-07_JPRB, 0.24164246E-07_JPRB, 0.23448425E-07_JPRB, 0.22799187E-07_JPRB /)

RGHG2(:, 5,10) = (/ &
  & 0.31167357E-07_JPRB, 0.32666268E-07_JPRB, 0.34096935E-07_JPRB, 0.35709231E-07_JPRB, 0.37438554E-07_JPRB, 0.39223934E-07_JPRB, &
  & 0.40986201E-07_JPRB, 0.42723372E-07_JPRB, 0.44434081E-07_JPRB, 0.46118664E-07_JPRB, 0.47764079E-07_JPRB, 0.49341658E-07_JPRB, &
  & 0.50849280E-07_JPRB, 0.52280029E-07_JPRB, 0.53592398E-07_JPRB, 0.54747204E-07_JPRB, 0.55759841E-07_JPRB, 0.56743861E-07_JPRB, &
  & 0.57821754E-07_JPRB, 0.58929764E-07_JPRB, 0.59847359E-07_JPRB, 0.60336355E-07_JPRB, 0.60249008E-07_JPRB, 0.59511340E-07_JPRB, &
  & 0.57984302E-07_JPRB, 0.55925689E-07_JPRB, 0.53703836E-07_JPRB, 0.51509510E-07_JPRB, 0.49540539E-07_JPRB, 0.48034234E-07_JPRB, &
  & 0.47294670E-07_JPRB, 0.47471456E-07_JPRB, 0.48670941E-07_JPRB, 0.51040601E-07_JPRB, 0.54606332E-07_JPRB, 0.59229688E-07_JPRB, &
  & 0.64671170E-07_JPRB, 0.70581919E-07_JPRB, 0.76631196E-07_JPRB, 0.82354603E-07_JPRB, 0.87189079E-07_JPRB, 0.90685788E-07_JPRB, &
  & 0.92663740E-07_JPRB, 0.93243266E-07_JPRB, 0.92711389E-07_JPRB, 0.91349818E-07_JPRB, 0.89365962E-07_JPRB, 0.86893394E-07_JPRB, &
  & 0.84001279E-07_JPRB, 0.80685815E-07_JPRB, 0.76882493E-07_JPRB, 0.72515306E-07_JPRB, 0.67542395E-07_JPRB, 0.61985752E-07_JPRB, &
  & 0.55985559E-07_JPRB, 0.49788824E-07_JPRB, 0.43868724E-07_JPRB, 0.38631477E-07_JPRB, 0.34417582E-07_JPRB, 0.31235942E-07_JPRB, &
  & 0.28922672E-07_JPRB, 0.27290939E-07_JPRB, 0.26125699E-07_JPRB, 0.24908715E-07_JPRB /)

RGHG2(:, 6,10) = (/ &
  & 0.33605239E-07_JPRB, 0.35750176E-07_JPRB, 0.37515616E-07_JPRB, 0.39304744E-07_JPRB, 0.41130171E-07_JPRB, 0.42975497E-07_JPRB, &
  & 0.44763880E-07_JPRB, 0.46524313E-07_JPRB, 0.48251735E-07_JPRB, 0.49970524E-07_JPRB, 0.51650233E-07_JPRB, 0.53271926E-07_JPRB, &
  & 0.54794544E-07_JPRB, 0.56194988E-07_JPRB, 0.57511411E-07_JPRB, 0.58815054E-07_JPRB, 0.60140664E-07_JPRB, 0.61466018E-07_JPRB, &
  & 0.62726556E-07_JPRB, 0.63932951E-07_JPRB, 0.65206208E-07_JPRB, 0.66556410E-07_JPRB, 0.67756467E-07_JPRB, 0.68606987E-07_JPRB, &
  & 0.69066644E-07_JPRB, 0.69267742E-07_JPRB, 0.69489182E-07_JPRB, 0.69958645E-07_JPRB, 0.70839121E-07_JPRB, 0.72216913E-07_JPRB, &
  & 0.74131307E-07_JPRB, 0.76536800E-07_JPRB, 0.79296129E-07_JPRB, 0.82332981E-07_JPRB, 0.85660140E-07_JPRB, 0.89262024E-07_JPRB, &
  & 0.93270664E-07_JPRB, 0.97692578E-07_JPRB, 0.10229056E-06_JPRB, 0.10664272E-06_JPRB, 0.11011426E-06_JPRB, 0.11220997E-06_JPRB, &
  & 0.11277338E-06_JPRB, 0.11202938E-06_JPRB, 0.11035080E-06_JPRB, 0.10803633E-06_JPRB, 0.10527638E-06_JPRB, 0.10215447E-06_JPRB, &
  & 0.98672572E-07_JPRB, 0.94768680E-07_JPRB, 0.90347278E-07_JPRB, 0.85334761E-07_JPRB, 0.79686131E-07_JPRB, 0.73408117E-07_JPRB, &
  & 0.66573548E-07_JPRB, 0.59520794E-07_JPRB, 0.52706646E-07_JPRB, 0.46738023E-07_JPRB, 0.41929173E-07_JPRB, 0.38304798E-07_JPRB, &
  & 0.35667032E-07_JPRB, 0.33788968E-07_JPRB, 0.32268726E-07_JPRB, 0.30692824E-07_JPRB /)

RGHG2(:, 7,10) = (/ &
  & 0.36216548E-07_JPRB, 0.38481190E-07_JPRB, 0.40284252E-07_JPRB, 0.42059050E-07_JPRB, 0.43884821E-07_JPRB, 0.45755677E-07_JPRB, &
  & 0.47624411E-07_JPRB, 0.49451074E-07_JPRB, 0.51292524E-07_JPRB, 0.53144497E-07_JPRB, 0.55008314E-07_JPRB, 0.56834367E-07_JPRB, &
  & 0.58591155E-07_JPRB, 0.60265563E-07_JPRB, 0.61839543E-07_JPRB, 0.63314715E-07_JPRB, 0.64764343E-07_JPRB, 0.66359277E-07_JPRB, &
  & 0.68325363E-07_JPRB, 0.70818807E-07_JPRB, 0.73780342E-07_JPRB, 0.76948908E-07_JPRB, 0.80022531E-07_JPRB, 0.82709519E-07_JPRB, &
  & 0.84988478E-07_JPRB, 0.87084473E-07_JPRB, 0.89260411E-07_JPRB, 0.91764079E-07_JPRB, 0.94694663E-07_JPRB, 0.98079937E-07_JPRB, &
  & 0.10187377E-06_JPRB, 0.10593550E-06_JPRB, 0.10987812E-06_JPRB, 0.11351086E-06_JPRB, 0.11693623E-06_JPRB, 0.12016868E-06_JPRB, &
  & 0.12346200E-06_JPRB, 0.12694895E-06_JPRB, 0.13047884E-06_JPRB, 0.13370132E-06_JPRB, 0.13605347E-06_JPRB, 0.13693833E-06_JPRB, &
  & 0.13623526E-06_JPRB, 0.13429906E-06_JPRB, 0.13155642E-06_JPRB, 0.12835991E-06_JPRB, 0.12485940E-06_JPRB, 0.12107812E-06_JPRB, &
  & 0.11695391E-06_JPRB, 0.11235882E-06_JPRB, 0.10714599E-06_JPRB, 0.10121177E-06_JPRB, 0.94525859E-07_JPRB, 0.87132406E-07_JPRB, &
  & 0.79297791E-07_JPRB, 0.71419947E-07_JPRB, 0.64130639E-07_JPRB, 0.57855015E-07_JPRB, 0.52844673E-07_JPRB, 0.49034973E-07_JPRB, &
  & 0.46235961E-07_JPRB, 0.44147843E-07_JPRB, 0.42515719E-07_JPRB, 0.40587256E-07_JPRB /)

RGHG2(:, 8,10) = (/ &
  & 0.38877797E-07_JPRB, 0.41136289E-07_JPRB, 0.42826407E-07_JPRB, 0.44589854E-07_JPRB, 0.46436604E-07_JPRB, 0.48428394E-07_JPRB, &
  & 0.50456315E-07_JPRB, 0.52538258E-07_JPRB, 0.54658408E-07_JPRB, 0.56845977E-07_JPRB, 0.59083359E-07_JPRB, 0.61344039E-07_JPRB, &
  & 0.63571512E-07_JPRB, 0.65718837E-07_JPRB, 0.67790324E-07_JPRB, 0.69836076E-07_JPRB, 0.71933286E-07_JPRB, 0.74163438E-07_JPRB, &
  & 0.76608032E-07_JPRB, 0.79428389E-07_JPRB, 0.82904435E-07_JPRB, 0.87217323E-07_JPRB, 0.92174524E-07_JPRB, 0.97602971E-07_JPRB, &
  & 0.10343231E-06_JPRB, 0.10946808E-06_JPRB, 0.11571572E-06_JPRB, 0.12215935E-06_JPRB, 0.12883743E-06_JPRB, 0.13563556E-06_JPRB, &
  & 0.14227508E-06_JPRB, 0.14844260E-06_JPRB, 0.15389013E-06_JPRB, 0.15842991E-06_JPRB, 0.16213403E-06_JPRB, 0.16503020E-06_JPRB, &
  & 0.16721206E-06_JPRB, 0.16896936E-06_JPRB, 0.17044667E-06_JPRB, 0.17155935E-06_JPRB, 0.17189674E-06_JPRB, 0.17089880E-06_JPRB, &
  & 0.16844926E-06_JPRB, 0.16486538E-06_JPRB, 0.16073736E-06_JPRB, 0.15636564E-06_JPRB, 0.15184276E-06_JPRB, 0.14709765E-06_JPRB, &
  & 0.14197613E-06_JPRB, 0.13627140E-06_JPRB, 0.12979227E-06_JPRB, 0.12242685E-06_JPRB, 0.11417646E-06_JPRB, 0.10523695E-06_JPRB, &
  & 0.95933117E-07_JPRB, 0.86911399E-07_JPRB, 0.78687869E-07_JPRB, 0.71724791E-07_JPRB, 0.66132827E-07_JPRB, 0.61817943E-07_JPRB, &
  & 0.58622280E-07_JPRB, 0.56220173E-07_JPRB, 0.54378276E-07_JPRB, 0.52136649E-07_JPRB /)

RGHG2(:, 9,10) = (/ &
  & 0.42080604E-07_JPRB, 0.44231669E-07_JPRB, 0.45964420E-07_JPRB, 0.47722590E-07_JPRB, 0.49699082E-07_JPRB, 0.51904692E-07_JPRB, &
  & 0.54261065E-07_JPRB, 0.56705424E-07_JPRB, 0.59251747E-07_JPRB, 0.61896571E-07_JPRB, 0.64639949E-07_JPRB, 0.67448482E-07_JPRB, &
  & 0.70257713E-07_JPRB, 0.73001061E-07_JPRB, 0.75666463E-07_JPRB, 0.78302079E-07_JPRB, 0.81013745E-07_JPRB, 0.83998714E-07_JPRB, &
  & 0.87590323E-07_JPRB, 0.92234771E-07_JPRB, 0.98323369E-07_JPRB, 0.10599716E-06_JPRB, 0.11514941E-06_JPRB, 0.12539857E-06_JPRB, &
  & 0.13612292E-06_JPRB, 0.14695999E-06_JPRB, 0.15752099E-06_JPRB, 0.16764061E-06_JPRB, 0.17733582E-06_JPRB, 0.18694098E-06_JPRB, &
  & 0.19711942E-06_JPRB, 0.20729938E-06_JPRB, 0.21617473E-06_JPRB, 0.22305792E-06_JPRB, 0.22759635E-06_JPRB, 0.22987206E-06_JPRB, &
  & 0.23054014E-06_JPRB, 0.23027101E-06_JPRB, 0.22940314E-06_JPRB, 0.22792247E-06_JPRB, 0.22558748E-06_JPRB, 0.22212697E-06_JPRB, &
  & 0.21731140E-06_JPRB, 0.21160082E-06_JPRB, 0.20540760E-06_JPRB, 0.19906888E-06_JPRB, 0.19257337E-06_JPRB, 0.18573786E-06_JPRB, &
  & 0.17834633E-06_JPRB, 0.17017673E-06_JPRB, 0.16101831E-06_JPRB, 0.15077889E-06_JPRB, 0.13959288E-06_JPRB, 0.12778600E-06_JPRB, &
  & 0.11597983E-06_JPRB, 0.10479137E-06_JPRB, 0.94890027E-07_JPRB, 0.86558941E-07_JPRB, 0.79890739E-07_JPRB, 0.74778107E-07_JPRB, &
  & 0.70905223E-07_JPRB, 0.68252099E-07_JPRB, 0.65862054E-07_JPRB, 0.63632797E-07_JPRB /)

RGHG2(:,10,10) = (/ &
  & 0.46423835E-07_JPRB, 0.48908060E-07_JPRB, 0.50714732E-07_JPRB, 0.52683795E-07_JPRB, 0.54883401E-07_JPRB, 0.57432764E-07_JPRB, &
  & 0.60224224E-07_JPRB, 0.63206109E-07_JPRB, 0.66341784E-07_JPRB, 0.69626978E-07_JPRB, 0.73052853E-07_JPRB, 0.76600884E-07_JPRB, &
  & 0.80213113E-07_JPRB, 0.83792145E-07_JPRB, 0.87246129E-07_JPRB, 0.90600906E-07_JPRB, 0.94047522E-07_JPRB, 0.97890812E-07_JPRB, &
  & 0.10247422E-06_JPRB, 0.10821448E-06_JPRB, 0.11562253E-06_JPRB, 0.12511023E-06_JPRB, 0.13672170E-06_JPRB, 0.15007146E-06_JPRB, &
  & 0.16468029E-06_JPRB, 0.18006796E-06_JPRB, 0.19611940E-06_JPRB, 0.21296481E-06_JPRB, 0.23103047E-06_JPRB, 0.24954329E-06_JPRB, &
  & 0.26619833E-06_JPRB, 0.28112069E-06_JPRB, 0.29412104E-06_JPRB, 0.30413898E-06_JPRB, 0.31091281E-06_JPRB, 0.31471578E-06_JPRB, &
  & 0.31603062E-06_JPRB, 0.31521361E-06_JPRB, 0.31280405E-06_JPRB, 0.30917491E-06_JPRB, 0.30453606E-06_JPRB, 0.29863821E-06_JPRB, &
  & 0.29137800E-06_JPRB, 0.28291475E-06_JPRB, 0.27355867E-06_JPRB, 0.26377606E-06_JPRB, 0.25355561E-06_JPRB, 0.24276235E-06_JPRB, &
  & 0.23112246E-06_JPRB, 0.21835199E-06_JPRB, 0.20434000E-06_JPRB, 0.18909525E-06_JPRB, 0.17291927E-06_JPRB, 0.15646242E-06_JPRB, &
  & 0.14052844E-06_JPRB, 0.12605906E-06_JPRB, 0.11358603E-06_JPRB, 0.10336172E-06_JPRB, 0.95304024E-07_JPRB, 0.89155606E-07_JPRB, &
  & 0.84827697E-07_JPRB, 0.81319925E-07_JPRB, 0.79060449E-07_JPRB, 0.75658072E-07_JPRB /)

RGHG2(:,11,10) = (/ &
  & 0.52903392E-07_JPRB, 0.55900085E-07_JPRB, 0.58226917E-07_JPRB, 0.60602773E-07_JPRB, 0.63373065E-07_JPRB, 0.66618846E-07_JPRB, &
  & 0.70293524E-07_JPRB, 0.74320539E-07_JPRB, 0.78645826E-07_JPRB, 0.83235300E-07_JPRB, 0.88069086E-07_JPRB, 0.93126857E-07_JPRB, &
  & 0.98348963E-07_JPRB, 0.10366051E-06_JPRB, 0.10897011E-06_JPRB, 0.11417210E-06_JPRB, 0.11919612E-06_JPRB, 0.12425474E-06_JPRB, &
  & 0.12981930E-06_JPRB, 0.13648258E-06_JPRB, 0.14490963E-06_JPRB, 0.15561787E-06_JPRB, 0.16878565E-06_JPRB, 0.18434727E-06_JPRB, &
  & 0.20180073E-06_JPRB, 0.22079510E-06_JPRB, 0.24121886E-06_JPRB, 0.26252778E-06_JPRB, 0.28418904E-06_JPRB, 0.30640504E-06_JPRB, &
  & 0.32999128E-06_JPRB, 0.35277787E-06_JPRB, 0.37329971E-06_JPRB, 0.39056647E-06_JPRB, 0.40378885E-06_JPRB, 0.41247824E-06_JPRB, &
  & 0.41695580E-06_JPRB, 0.41786902E-06_JPRB, 0.41619884E-06_JPRB, 0.41250760E-06_JPRB, 0.40703299E-06_JPRB, 0.39966986E-06_JPRB, &
  & 0.39017314E-06_JPRB, 0.37861895E-06_JPRB, 0.36522832E-06_JPRB, 0.35061402E-06_JPRB, 0.33502107E-06_JPRB, 0.31849015E-06_JPRB, &
  & 0.30080446E-06_JPRB, 0.28177624E-06_JPRB, 0.26129968E-06_JPRB, 0.23964003E-06_JPRB, 0.21732488E-06_JPRB, 0.19533314E-06_JPRB, &
  & 0.17485215E-06_JPRB, 0.15681705E-06_JPRB, 0.14173601E-06_JPRB, 0.12960626E-06_JPRB, 0.12015455E-06_JPRB, 0.11305858E-06_JPRB, &
  & 0.10757523E-06_JPRB, 0.10399569E-06_JPRB, 0.10020999E-06_JPRB, 0.96823904E-07_JPRB /)

RGHG2(:,12,10) = (/ &
  & 0.62014813E-07_JPRB, 0.66342537E-07_JPRB, 0.69451296E-07_JPRB, 0.72825941E-07_JPRB, 0.76682916E-07_JPRB, 0.81287716E-07_JPRB, &
  & 0.86606619E-07_JPRB, 0.92558537E-07_JPRB, 0.99035560E-07_JPRB, 0.10594304E-06_JPRB, 0.11322777E-06_JPRB, 0.12080635E-06_JPRB, &
  & 0.12861061E-06_JPRB, 0.13647600E-06_JPRB, 0.14431882E-06_JPRB, 0.15225494E-06_JPRB, 0.16024757E-06_JPRB, 0.16830708E-06_JPRB, &
  & 0.17675310E-06_JPRB, 0.18600608E-06_JPRB, 0.19654411E-06_JPRB, 0.20858664E-06_JPRB, 0.22281344E-06_JPRB, 0.23889481E-06_JPRB, &
  & 0.25666861E-06_JPRB, 0.27628573E-06_JPRB, 0.29780782E-06_JPRB, 0.32129660E-06_JPRB, 0.34718138E-06_JPRB, 0.37497921E-06_JPRB, &
  & 0.40279298E-06_JPRB, 0.43083381E-06_JPRB, 0.45769227E-06_JPRB, 0.48172052E-06_JPRB, 0.50113641E-06_JPRB, 0.51511654E-06_JPRB, &
  & 0.52372798E-06_JPRB, 0.52773163E-06_JPRB, 0.52801477E-06_JPRB, 0.52525269E-06_JPRB, 0.51971188E-06_JPRB, 0.51138056E-06_JPRB, &
  & 0.50007827E-06_JPRB, 0.48578147E-06_JPRB, 0.46861004E-06_JPRB, 0.44929521E-06_JPRB, 0.42841953E-06_JPRB, 0.40626526E-06_JPRB, &
  & 0.38294851E-06_JPRB, 0.35832980E-06_JPRB, 0.33263549E-06_JPRB, 0.30610175E-06_JPRB, 0.27952726E-06_JPRB, 0.25402244E-06_JPRB, &
  & 0.23079086E-06_JPRB, 0.21069170E-06_JPRB, 0.19399417E-06_JPRB, 0.18051625E-06_JPRB, 0.16979355E-06_JPRB, 0.16138084E-06_JPRB, &
  & 0.15509698E-06_JPRB, 0.14956203E-06_JPRB, 0.14552764E-06_JPRB, 0.13792992E-06_JPRB /)

RGHG2(:,13,10) = (/ &
  & 0.75433391E-07_JPRB, 0.81999403E-07_JPRB, 0.87086136E-07_JPRB, 0.92390401E-07_JPRB, 0.98660024E-07_JPRB, 0.10619519E-06_JPRB, &
  & 0.11510383E-06_JPRB, 0.12530776E-06_JPRB, 0.13661513E-06_JPRB, 0.14880035E-06_JPRB, 0.16167238E-06_JPRB, 0.17502046E-06_JPRB, &
  & 0.18868403E-06_JPRB, 0.20247333E-06_JPRB, 0.21601099E-06_JPRB, 0.22918253E-06_JPRB, 0.24206804E-06_JPRB, 0.25469660E-06_JPRB, &
  & 0.26724138E-06_JPRB, 0.27991004E-06_JPRB, 0.29275768E-06_JPRB, 0.30590118E-06_JPRB, 0.31947826E-06_JPRB, 0.33323852E-06_JPRB, &
  & 0.34732122E-06_JPRB, 0.36266300E-06_JPRB, 0.37998257E-06_JPRB, 0.40009348E-06_JPRB, 0.42320025E-06_JPRB, 0.44969710E-06_JPRB, &
  & 0.47990966E-06_JPRB, 0.51194706E-06_JPRB, 0.54387402E-06_JPRB, 0.57329567E-06_JPRB, 0.59824629E-06_JPRB, 0.61737205E-06_JPRB, &
  & 0.63039056E-06_JPRB, 0.63766549E-06_JPRB, 0.64001136E-06_JPRB, 0.63816526E-06_JPRB, 0.63256954E-06_JPRB, 0.62327030E-06_JPRB, &
  & 0.61025355E-06_JPRB, 0.59353096E-06_JPRB, 0.57353174E-06_JPRB, 0.55089328E-06_JPRB, 0.52640672E-06_JPRB, 0.50072731E-06_JPRB, &
  & 0.47417217E-06_JPRB, 0.44706053E-06_JPRB, 0.41950705E-06_JPRB, 0.39202084E-06_JPRB, 0.36516482E-06_JPRB, 0.33987908E-06_JPRB, &
  & 0.31700128E-06_JPRB, 0.29708789E-06_JPRB, 0.28019406E-06_JPRB, 0.26610022E-06_JPRB, 0.25428230E-06_JPRB, 0.24462886E-06_JPRB, &
  & 0.23614928E-06_JPRB, 0.22978256E-06_JPRB, 0.22186728E-06_JPRB, 0.21243333E-06_JPRB /)

RGHG2(:,14,10) = (/ &
  & 0.94297775E-07_JPRB, 0.10490628E-06_JPRB, 0.11286490E-06_JPRB, 0.12147372E-06_JPRB, 0.13149355E-06_JPRB, 0.14359642E-06_JPRB, &
  & 0.15796547E-06_JPRB, 0.17451657E-06_JPRB, 0.19290134E-06_JPRB, 0.21265652E-06_JPRB, 0.23333313E-06_JPRB, 0.25450953E-06_JPRB, &
  & 0.27587203E-06_JPRB, 0.29720852E-06_JPRB, 0.31822773E-06_JPRB, 0.33859629E-06_JPRB, 0.35829666E-06_JPRB, 0.37730041E-06_JPRB, &
  & 0.39559620E-06_JPRB, 0.41310119E-06_JPRB, 0.42941161E-06_JPRB, 0.44410962E-06_JPRB, 0.45696680E-06_JPRB, 0.46768395E-06_JPRB, &
  & 0.47655988E-06_JPRB, 0.48494235E-06_JPRB, 0.49430724E-06_JPRB, 0.50604598E-06_JPRB, 0.52240921E-06_JPRB, 0.54470809E-06_JPRB, &
  & 0.57223866E-06_JPRB, 0.60331803E-06_JPRB, 0.63608661E-06_JPRB, 0.66798640E-06_JPRB, 0.69649496E-06_JPRB, 0.71981702E-06_JPRB, &
  & 0.73680275E-06_JPRB, 0.74730207E-06_JPRB, 0.75179202E-06_JPRB, 0.75096051E-06_JPRB, 0.74529180E-06_JPRB, 0.73496938E-06_JPRB, &
  & 0.72023630E-06_JPRB, 0.70147945E-06_JPRB, 0.67935304E-06_JPRB, 0.65473739E-06_JPRB, 0.62861290E-06_JPRB, 0.60174051E-06_JPRB, &
  & 0.57469060E-06_JPRB, 0.54781401E-06_JPRB, 0.52145373E-06_JPRB, 0.49580115E-06_JPRB, 0.47123152E-06_JPRB, 0.44821331E-06_JPRB, &
  & 0.42720177E-06_JPRB, 0.40845654E-06_JPRB, 0.39200987E-06_JPRB, 0.37764949E-06_JPRB, 0.36499802E-06_JPRB, 0.35403013E-06_JPRB, &
  & 0.34408490E-06_JPRB, 0.33537728E-06_JPRB, 0.32610487E-06_JPRB, 0.31104611E-06_JPRB /)

RGHG2(:,15,10) = (/ &
  & 0.12000190E-06_JPRB, 0.13611432E-06_JPRB, 0.14846259E-06_JPRB, 0.16153834E-06_JPRB, 0.17680399E-06_JPRB, 0.19505322E-06_JPRB, &
  & 0.21662734E-06_JPRB, 0.24138649E-06_JPRB, 0.26877635E-06_JPRB, 0.29799935E-06_JPRB, 0.32822265E-06_JPRB, 0.35869837E-06_JPRB, &
  & 0.38894763E-06_JPRB, 0.41870211E-06_JPRB, 0.44781814E-06_JPRB, 0.47596149E-06_JPRB, 0.50294057E-06_JPRB, 0.52866665E-06_JPRB, &
  & 0.55288353E-06_JPRB, 0.57537426E-06_JPRB, 0.59549814E-06_JPRB, 0.61234249E-06_JPRB, 0.62513686E-06_JPRB, 0.63341668E-06_JPRB, &
  & 0.63722240E-06_JPRB, 0.63768874E-06_JPRB, 0.63676202E-06_JPRB, 0.63764310E-06_JPRB, 0.64384818E-06_JPRB, 0.65676932E-06_JPRB, &
  & 0.67668537E-06_JPRB, 0.70335830E-06_JPRB, 0.73451923E-06_JPRB, 0.76692049E-06_JPRB, 0.79739436E-06_JPRB, 0.82365301E-06_JPRB, &
  & 0.84401688E-06_JPRB, 0.85775139E-06_JPRB, 0.86484010E-06_JPRB, 0.86561460E-06_JPRB, 0.86042269E-06_JPRB, 0.84961914E-06_JPRB, &
  & 0.83376278E-06_JPRB, 0.81361338E-06_JPRB, 0.79024102E-06_JPRB, 0.76479978E-06_JPRB, 0.73840988E-06_JPRB, 0.71194989E-06_JPRB, &
  & 0.68604538E-06_JPRB, 0.66106412E-06_JPRB, 0.63698496E-06_JPRB, 0.61380149E-06_JPRB, 0.59156298E-06_JPRB, 0.57049408E-06_JPRB, &
  & 0.55079568E-06_JPRB, 0.53271884E-06_JPRB, 0.51628012E-06_JPRB, 0.50141489E-06_JPRB, 0.48793356E-06_JPRB, 0.47566712E-06_JPRB, &
  & 0.46439999E-06_JPRB, 0.45407094E-06_JPRB, 0.44216279E-06_JPRB, 0.42358806E-06_JPRB /)

RGHG2(:,16,10) = (/ &
  & 0.15409786E-06_JPRB, 0.17744165E-06_JPRB, 0.19512170E-06_JPRB, 0.21381015E-06_JPRB, 0.23531697E-06_JPRB, 0.26073101E-06_JPRB, &
  & 0.29035488E-06_JPRB, 0.32396832E-06_JPRB, 0.36077449E-06_JPRB, 0.39968316E-06_JPRB, 0.43951738E-06_JPRB, 0.47919252E-06_JPRB, &
  & 0.51795718E-06_JPRB, 0.55546406E-06_JPRB, 0.59170640E-06_JPRB, 0.62662946E-06_JPRB, 0.65993362E-06_JPRB, 0.69148393E-06_JPRB, &
  & 0.72098089E-06_JPRB, 0.74793593E-06_JPRB, 0.77163355E-06_JPRB, 0.79082781E-06_JPRB, 0.80424104E-06_JPRB, 0.81103599E-06_JPRB, &
  & 0.81098733E-06_JPRB, 0.80495505E-06_JPRB, 0.79552041E-06_JPRB, 0.78719927E-06_JPRB, 0.78308028E-06_JPRB, 0.78640738E-06_JPRB, &
  & 0.79836417E-06_JPRB, 0.81806320E-06_JPRB, 0.84417621E-06_JPRB, 0.87360291E-06_JPRB, 0.90311801E-06_JPRB, 0.92995174E-06_JPRB, &
  & 0.95203069E-06_JPRB, 0.96815324E-06_JPRB, 0.97773238E-06_JPRB, 0.98062139E-06_JPRB, 0.97690906E-06_JPRB, 0.96688916E-06_JPRB, &
  & 0.95130230E-06_JPRB, 0.93125493E-06_JPRB, 0.90812057E-06_JPRB, 0.88336560E-06_JPRB, 0.85823240E-06_JPRB, 0.83365774E-06_JPRB, &
  & 0.81013604E-06_JPRB, 0.78764464E-06_JPRB, 0.76592232E-06_JPRB, 0.74469381E-06_JPRB, 0.72382204E-06_JPRB, 0.70339416E-06_JPRB, &
  & 0.68365671E-06_JPRB, 0.66491299E-06_JPRB, 0.64739686E-06_JPRB, 0.63120666E-06_JPRB, 0.61631738E-06_JPRB, 0.60263022E-06_JPRB, &
  & 0.58975616E-06_JPRB, 0.57807381E-06_JPRB, 0.56349705E-06_JPRB, 0.54274574E-06_JPRB /)

RGHG2(:,17,10) = (/ &
  & 0.19937703E-06_JPRB, 0.23126967E-06_JPRB, 0.25477010E-06_JPRB, 0.27942644E-06_JPRB, 0.30741089E-06_JPRB, 0.33998930E-06_JPRB, &
  & 0.37738272E-06_JPRB, 0.41915294E-06_JPRB, 0.46428914E-06_JPRB, 0.51142729E-06_JPRB, 0.55908157E-06_JPRB, 0.60591753E-06_JPRB, &
  & 0.65102802E-06_JPRB, 0.69397015E-06_JPRB, 0.73470756E-06_JPRB, 0.77342122E-06_JPRB, 0.81009466E-06_JPRB, 0.84459344E-06_JPRB, &
  & 0.87674323E-06_JPRB, 0.90612582E-06_JPRB, 0.93210775E-06_JPRB, 0.95356972E-06_JPRB, 0.96905171E-06_JPRB, 0.97732254E-06_JPRB, &
  & 0.97785778E-06_JPRB, 0.97115583E-06_JPRB, 0.95937162E-06_JPRB, 0.94606401E-06_JPRB, 0.93543264E-06_JPRB, 0.93179000E-06_JPRB, &
  & 0.93557571E-06_JPRB, 0.94745189E-06_JPRB, 0.96582505E-06_JPRB, 0.98876114E-06_JPRB, 0.10137605E-05_JPRB, 0.10377876E-05_JPRB, &
  & 0.10586017E-05_JPRB, 0.10749405E-05_JPRB, 0.10857696E-05_JPRB, 0.10905186E-05_JPRB, 0.10889205E-05_JPRB, 0.10810371E-05_JPRB, &
  & 0.10675269E-05_JPRB, 0.10495436E-05_JPRB, 0.10286699E-05_JPRB, 0.10064732E-05_JPRB, 0.98426017E-06_JPRB, 0.96284839E-06_JPRB, &
  & 0.94244933E-06_JPRB, 0.92276071E-06_JPRB, 0.90328706E-06_JPRB, 0.88355864E-06_JPRB, 0.86331977E-06_JPRB, 0.84266424E-06_JPRB, &
  & 0.82192815E-06_JPRB, 0.80164131E-06_JPRB, 0.78225889E-06_JPRB, 0.76410760E-06_JPRB, 0.74730997E-06_JPRB, 0.73184373E-06_JPRB, &
  & 0.71766749E-06_JPRB, 0.70370822E-06_JPRB, 0.68873783E-06_JPRB, 0.66265511E-06_JPRB /)

RGHG2(:,18,10) = (/ &
  & 0.25944198E-06_JPRB, 0.29961745E-06_JPRB, 0.32898183E-06_JPRB, 0.35868672E-06_JPRB, 0.39228860E-06_JPRB, 0.43064173E-06_JPRB, &
  & 0.47391939E-06_JPRB, 0.52142673E-06_JPRB, 0.57188288E-06_JPRB, 0.62378615E-06_JPRB, 0.67561558E-06_JPRB, 0.72596208E-06_JPRB, &
  & 0.77392326E-06_JPRB, 0.81905824E-06_JPRB, 0.86135003E-06_JPRB, 0.90095267E-06_JPRB, 0.93812264E-06_JPRB, 0.97296856E-06_JPRB, &
  & 0.10055505E-05_JPRB, 0.10356802E-05_JPRB, 0.10628448E-05_JPRB, 0.10861534E-05_JPRB, 0.11042554E-05_JPRB, 0.11157979E-05_JPRB, &
  & 0.11199045E-05_JPRB, 0.11168534E-05_JPRB, 0.11084633E-05_JPRB, 0.10971436E-05_JPRB, 0.10863422E-05_JPRB, 0.10784079E-05_JPRB, &
  & 0.10760666E-05_JPRB, 0.10802843E-05_JPRB, 0.10905437E-05_JPRB, 0.11051250E-05_JPRB, 0.11225208E-05_JPRB, 0.11409702E-05_JPRB, &
  & 0.11582821E-05_JPRB, 0.11727449E-05_JPRB, 0.11833835E-05_JPRB, 0.11892112E-05_JPRB, 0.11896689E-05_JPRB, 0.11845293E-05_JPRB, &
  & 0.11741830E-05_JPRB, 0.11596592E-05_JPRB, 0.11423911E-05_JPRB, 0.11239345E-05_JPRB, 0.11054823E-05_JPRB, 0.10876362E-05_JPRB, &
  & 0.10704077E-05_JPRB, 0.10533627E-05_JPRB, 0.10359311E-05_JPRB, 0.10175459E-05_JPRB, 0.99791419E-06_JPRB, 0.97712768E-06_JPRB, &
  & 0.95563837E-06_JPRB, 0.93413087E-06_JPRB, 0.91333141E-06_JPRB, 0.89366500E-06_JPRB, 0.87538456E-06_JPRB, 0.85849797E-06_JPRB, &
  & 0.84292094E-06_JPRB, 0.82788256E-06_JPRB, 0.81141206E-06_JPRB, 0.78250480E-06_JPRB /)

RGHG2(:,19,10) = (/ &
  & 0.33534258E-06_JPRB, 0.38402263E-06_JPRB, 0.41690001E-06_JPRB, 0.45061864E-06_JPRB, 0.48726747E-06_JPRB, 0.52884064E-06_JPRB, &
  & 0.57489854E-06_JPRB, 0.62465290E-06_JPRB, 0.67675319E-06_JPRB, 0.72968692E-06_JPRB, 0.78192249E-06_JPRB, 0.83224154E-06_JPRB, &
  & 0.87982153E-06_JPRB, 0.92431571E-06_JPRB, 0.96574490E-06_JPRB, 0.10043265E-05_JPRB, 0.10403190E-05_JPRB, 0.10740362E-05_JPRB, &
  & 0.11057208E-05_JPRB, 0.11354892E-05_JPRB, 0.11630574E-05_JPRB, 0.11877412E-05_JPRB, 0.12083973E-05_JPRB, 0.12237093E-05_JPRB, &
  & 0.12326121E-05_JPRB, 0.12349560E-05_JPRB, 0.12317496E-05_JPRB, 0.12248856E-05_JPRB, 0.12166975E-05_JPRB, 0.12093990E-05_JPRB, &
  & 0.12048755E-05_JPRB, 0.12039607E-05_JPRB, 0.12072056E-05_JPRB, 0.12138446E-05_JPRB, 0.12231135E-05_JPRB, 0.12345428E-05_JPRB, &
  & 0.12471056E-05_JPRB, 0.12587100E-05_JPRB, 0.12681821E-05_JPRB, 0.12743110E-05_JPRB, 0.12762937E-05_JPRB, 0.12735991E-05_JPRB, &
  & 0.12664295E-05_JPRB, 0.12554563E-05_JPRB, 0.12418694E-05_JPRB, 0.12269807E-05_JPRB, 0.12118359E-05_JPRB, 0.11969155E-05_JPRB, &
  & 0.11821560E-05_JPRB, 0.11671784E-05_JPRB, 0.11514314E-05_JPRB, 0.11344013E-05_JPRB, 0.11158088E-05_JPRB, 0.10957277E-05_JPRB, &
  & 0.10746177E-05_JPRB, 0.10532677E-05_JPRB, 0.10323424E-05_JPRB, 0.10123565E-05_JPRB, 0.99358738E-06_JPRB, 0.97613895E-06_JPRB, &
  & 0.95976839E-06_JPRB, 0.94444994E-06_JPRB, 0.92654500E-06_JPRB, 0.89749273E-06_JPRB /)

RGHG2(:,20,10) = (/ &
  & 0.42661480E-06_JPRB, 0.48023975E-06_JPRB, 0.51628740E-06_JPRB, 0.55047059E-06_JPRB, 0.58805387E-06_JPRB, 0.62942200E-06_JPRB, &
  & 0.67480755E-06_JPRB, 0.72331591E-06_JPRB, 0.77367145E-06_JPRB, 0.82443438E-06_JPRB, 0.87432278E-06_JPRB, 0.92217147E-06_JPRB, &
  & 0.96732595E-06_JPRB, 0.10094897E-05_JPRB, 0.10487061E-05_JPRB, 0.10851901E-05_JPRB, 0.11192711E-05_JPRB, 0.11513046E-05_JPRB, &
  & 0.11816583E-05_JPRB, 0.12106541E-05_JPRB, 0.12382368E-05_JPRB, 0.12638903E-05_JPRB, 0.12866237E-05_JPRB, 0.13052124E-05_JPRB, &
  & 0.13185388E-05_JPRB, 0.13261049E-05_JPRB, 0.13284370E-05_JPRB, 0.13268394E-05_JPRB, 0.13228801E-05_JPRB, 0.13178067E-05_JPRB, &
  & 0.13130324E-05_JPRB, 0.13094545E-05_JPRB, 0.13077489E-05_JPRB, 0.13085479E-05_JPRB, 0.13120842E-05_JPRB, 0.13174493E-05_JPRB, &
  & 0.13247635E-05_JPRB, 0.13333377E-05_JPRB, 0.13410540E-05_JPRB, 0.13468376E-05_JPRB, 0.13494802E-05_JPRB, 0.13485512E-05_JPRB, &
  & 0.13437492E-05_JPRB, 0.13355337E-05_JPRB, 0.13247897E-05_JPRB, 0.13125583E-05_JPRB, 0.12997180E-05_JPRB, 0.12867060E-05_JPRB, &
  & 0.12735470E-05_JPRB, 0.12599552E-05_JPRB, 0.12454980E-05_JPRB, 0.12297585E-05_JPRB, 0.12125151E-05_JPRB, 0.11938844E-05_JPRB, &
  & 0.11743032E-05_JPRB, 0.11543506E-05_JPRB, 0.11346347E-05_JPRB, 0.11155360E-05_JPRB, 0.10973761E-05_JPRB, 0.10802798E-05_JPRB, &
  & 0.10644965E-05_JPRB, 0.10485730E-05_JPRB, 0.10324264E-05_JPRB, 0.10007410E-05_JPRB /)

RGHG2(:,21,10) = (/ &
  & 0.52629537E-06_JPRB, 0.58326901E-06_JPRB, 0.61891694E-06_JPRB, 0.65240664E-06_JPRB, 0.68778758E-06_JPRB, 0.72656076E-06_JPRB, &
  & 0.76856321E-06_JPRB, 0.81326152E-06_JPRB, 0.85955799E-06_JPRB, 0.90630118E-06_JPRB, 0.95222259E-06_JPRB, 0.99640340E-06_JPRB, &
  & 0.10381950E-05_JPRB, 0.10773412E-05_JPRB, 0.11138748E-05_JPRB, 0.11480132E-05_JPRB, 0.11800788E-05_JPRB, 0.12104642E-05_JPRB, &
  & 0.12395873E-05_JPRB, 0.12677926E-05_JPRB, 0.12952416E-05_JPRB, 0.13215529E-05_JPRB, 0.13458707E-05_JPRB, 0.13669494E-05_JPRB, &
  & 0.13835299E-05_JPRB, 0.13950886E-05_JPRB, 0.14019265E-05_JPRB, 0.14048165E-05_JPRB, 0.14046961E-05_JPRB, 0.14024106E-05_JPRB, &
  & 0.13987639E-05_JPRB, 0.13945746E-05_JPRB, 0.13906890E-05_JPRB, 0.13879951E-05_JPRB, 0.13876135E-05_JPRB, 0.13896442E-05_JPRB, &
  & 0.13936365E-05_JPRB, 0.13987615E-05_JPRB, 0.14044482E-05_JPRB, 0.14092000E-05_JPRB, 0.14119441E-05_JPRB, 0.14116558E-05_JPRB, &
  & 0.14081922E-05_JPRB, 0.14016924E-05_JPRB, 0.13927408E-05_JPRB, 0.13821392E-05_JPRB, 0.13706360E-05_JPRB, 0.13586970E-05_JPRB, &
  & 0.13464395E-05_JPRB, 0.13336839E-05_JPRB, 0.13201150E-05_JPRB, 0.13054689E-05_JPRB, 0.12896703E-05_JPRB, 0.12728475E-05_JPRB, &
  & 0.12553110E-05_JPRB, 0.12374962E-05_JPRB, 0.12197563E-05_JPRB, 0.12024024E-05_JPRB, 0.11856730E-05_JPRB, 0.11697375E-05_JPRB, &
  & 0.11544209E-05_JPRB, 0.11400832E-05_JPRB, 0.11224067E-05_JPRB, 0.10943504E-05_JPRB /)

RGHG2(:,22,10) = (/ &
  & 0.62813257E-06_JPRB, 0.68369678E-06_JPRB, 0.71873092E-06_JPRB, 0.74895814E-06_JPRB, 0.78133309E-06_JPRB, 0.81585523E-06_JPRB, &
  & 0.85311672E-06_JPRB, 0.89276114E-06_JPRB, 0.93403241E-06_JPRB, 0.97588384E-06_JPRB, 0.10173792E-05_JPRB, 0.10575545E-05_JPRB, &
  & 0.10958677E-05_JPRB, 0.11320064E-05_JPRB, 0.11659666E-05_JPRB, 0.11978905E-05_JPRB, 0.12281280E-05_JPRB, 0.12570559E-05_JPRB, &
  & 0.12851472E-05_JPRB, 0.13127531E-05_JPRB, 0.13400460E-05_JPRB, 0.13667261E-05_JPRB, 0.13919798E-05_JPRB, 0.14146154E-05_JPRB, &
  & 0.14335475E-05_JPRB, 0.14479955E-05_JPRB, 0.14580859E-05_JPRB, 0.14642925E-05_JPRB, 0.14672323E-05_JPRB, 0.14674864E-05_JPRB, &
  & 0.14655180E-05_JPRB, 0.14619690E-05_JPRB, 0.14576353E-05_JPRB, 0.14534231E-05_JPRB, 0.14506060E-05_JPRB, 0.14496862E-05_JPRB, &
  & 0.14512326E-05_JPRB, 0.14549832E-05_JPRB, 0.14592181E-05_JPRB, 0.14629464E-05_JPRB, 0.14651298E-05_JPRB, 0.14649607E-05_JPRB, &
  & 0.14619734E-05_JPRB, 0.14562847E-05_JPRB, 0.14482832E-05_JPRB, 0.14385366E-05_JPRB, 0.14276833E-05_JPRB, 0.14162888E-05_JPRB, &
  & 0.14044625E-05_JPRB, 0.13921497E-05_JPRB, 0.13791883E-05_JPRB, 0.13654804E-05_JPRB, 0.13510509E-05_JPRB, 0.13360478E-05_JPRB, &
  & 0.13206854E-05_JPRB, 0.13051691E-05_JPRB, 0.12897106E-05_JPRB, 0.12744260E-05_JPRB, 0.12594529E-05_JPRB, 0.12448987E-05_JPRB, &
  & 0.12310097E-05_JPRB, 0.12166679E-05_JPRB, 0.12016974E-05_JPRB, 0.11731091E-05_JPRB /)

RGHG2(:,23,10) = (/ &
  & 0.72570515E-06_JPRB, 0.77751258E-06_JPRB, 0.80955294E-06_JPRB, 0.83703890E-06_JPRB, 0.86528530E-06_JPRB, 0.89536019E-06_JPRB, &
  & 0.92768755E-06_JPRB, 0.96213375E-06_JPRB, 0.99822591E-06_JPRB, 0.10352825E-05_JPRB, 0.10723961E-05_JPRB, 0.11088277E-05_JPRB, &
  & 0.11439749E-05_JPRB, 0.11775113E-05_JPRB, 0.12093269E-05_JPRB, 0.12394795E-05_JPRB, 0.12682514E-05_JPRB, 0.12959903E-05_JPRB, &
  & 0.13232250E-05_JPRB, 0.13502197E-05_JPRB, 0.13771655E-05_JPRB, 0.14039188E-05_JPRB, 0.14295518E-05_JPRB, 0.14530854E-05_JPRB, &
  & 0.14732674E-05_JPRB, 0.14894855E-05_JPRB, 0.15017258E-05_JPRB, 0.15102540E-05_JPRB, 0.15155209E-05_JPRB, 0.15179137E-05_JPRB, &
  & 0.15177677E-05_JPRB, 0.15155222E-05_JPRB, 0.15119127E-05_JPRB, 0.15077666E-05_JPRB, 0.15044802E-05_JPRB, 0.15027097E-05_JPRB, &
  & 0.15027711E-05_JPRB, 0.15044800E-05_JPRB, 0.15069545E-05_JPRB, 0.15093864E-05_JPRB, 0.15106433E-05_JPRB, 0.15100453E-05_JPRB, &
  & 0.15070880E-05_JPRB, 0.15015947E-05_JPRB, 0.14938576E-05_JPRB, 0.14844727E-05_JPRB, 0.14739214E-05_JPRB, 0.14627374E-05_JPRB, &
  & 0.14511191E-05_JPRB, 0.14390670E-05_JPRB, 0.14265373E-05_JPRB, 0.14135952E-05_JPRB, 0.14003747E-05_JPRB, 0.13870293E-05_JPRB, &
  & 0.13736408E-05_JPRB, 0.13602673E-05_JPRB, 0.13469142E-05_JPRB, 0.13336002E-05_JPRB, 0.13203976E-05_JPRB, 0.13073751E-05_JPRB, &
  & 0.12945171E-05_JPRB, 0.12819061E-05_JPRB, 0.12667700E-05_JPRB, 0.12408724E-05_JPRB /)

RGHG2(:,24,10) = (/ &
  & 0.81537860E-06_JPRB, 0.86325417E-06_JPRB, 0.89110893E-06_JPRB, 0.91532263E-06_JPRB, 0.93968669E-06_JPRB, 0.96553845E-06_JPRB, &
  & 0.99327042E-06_JPRB, 0.10230041E-05_JPRB, 0.10544278E-05_JPRB, 0.10870799E-05_JPRB, 0.11203250E-05_JPRB, 0.11534489E-05_JPRB, &
  & 0.11859115E-05_JPRB, 0.12173143E-05_JPRB, 0.12474688E-05_JPRB, 0.12762937E-05_JPRB, 0.13039880E-05_JPRB, 0.13307941E-05_JPRB, &
  & 0.13572358E-05_JPRB, 0.13836401E-05_JPRB, 0.14100837E-05_JPRB, 0.14363566E-05_JPRB, 0.14617917E-05_JPRB, 0.14853246E-05_JPRB, &
  & 0.15058861E-05_JPRB, 0.15228878E-05_JPRB, 0.15363144E-05_JPRB, 0.15463963E-05_JPRB, 0.15533892E-05_JPRB, 0.15575683E-05_JPRB, &
  & 0.15591465E-05_JPRB, 0.15584453E-05_JPRB, 0.15560905E-05_JPRB, 0.15528844E-05_JPRB, 0.15497453E-05_JPRB, 0.15474495E-05_JPRB, &
  & 0.15467286E-05_JPRB, 0.15472405E-05_JPRB, 0.15483907E-05_JPRB, 0.15494252E-05_JPRB, 0.15495929E-05_JPRB, 0.15481586E-05_JPRB, &
  & 0.15447806E-05_JPRB, 0.15392079E-05_JPRB, 0.15314940E-05_JPRB, 0.15221497E-05_JPRB, 0.15116806E-05_JPRB, 0.15005629E-05_JPRB, &
  & 0.14889794E-05_JPRB, 0.14770785E-05_JPRB, 0.14649254E-05_JPRB, 0.14526947E-05_JPRB, 0.14405687E-05_JPRB, 0.14286367E-05_JPRB, &
  & 0.14169030E-05_JPRB, 0.14053121E-05_JPRB, 0.13937579E-05_JPRB, 0.13821711E-05_JPRB, 0.13705284E-05_JPRB, 0.13588798E-05_JPRB, &
  & 0.13473367E-05_JPRB, 0.13354235E-05_JPRB, 0.13219491E-05_JPRB, 0.12978575E-05_JPRB /)

RGHG2(:,25,10) = (/ &
  & 0.89697238E-06_JPRB, 0.94002411E-06_JPRB, 0.96464055E-06_JPRB, 0.98547980E-06_JPRB, 0.10062550E-05_JPRB, 0.10283338E-05_JPRB, &
  & 0.10520943E-05_JPRB, 0.10777046E-05_JPRB, 0.11051109E-05_JPRB, 0.11339686E-05_JPRB, 0.11638525E-05_JPRB, 0.11941620E-05_JPRB, &
  & 0.12243717E-05_JPRB, 0.12540625E-05_JPRB, 0.12829219E-05_JPRB, 0.13107925E-05_JPRB, 0.13376771E-05_JPRB, 0.13637557E-05_JPRB, &
  & 0.13894550E-05_JPRB, 0.14150085E-05_JPRB, 0.14406240E-05_JPRB, 0.14659977E-05_JPRB, 0.14906298E-05_JPRB, 0.15135423E-05_JPRB, &
  & 0.15338902E-05_JPRB, 0.15511333E-05_JPRB, 0.15651648E-05_JPRB, 0.15760191E-05_JPRB, 0.15840227E-05_JPRB, 0.15894084E-05_JPRB, &
  & 0.15923781E-05_JPRB, 0.15931570E-05_JPRB, 0.15922134E-05_JPRB, 0.15902122E-05_JPRB, 0.15878164E-05_JPRB, 0.15857630E-05_JPRB, &
  & 0.15845275E-05_JPRB, 0.15839429E-05_JPRB, 0.15839130E-05_JPRB, 0.15836787E-05_JPRB, 0.15826804E-05_JPRB, 0.15803005E-05_JPRB, &
  & 0.15762436E-05_JPRB, 0.15703530E-05_JPRB, 0.15625659E-05_JPRB, 0.15532369E-05_JPRB, 0.15428184E-05_JPRB, 0.15317812E-05_JPRB, &
  & 0.15203517E-05_JPRB, 0.15086570E-05_JPRB, 0.14968565E-05_JPRB, 0.14852301E-05_JPRB, 0.14739780E-05_JPRB, 0.14631535E-05_JPRB, &
  & 0.14527000E-05_JPRB, 0.14424857E-05_JPRB, 0.14323775E-05_JPRB, 0.14222182E-05_JPRB, 0.14119551E-05_JPRB, 0.14015990E-05_JPRB, &
  & 0.13912124E-05_JPRB, 0.13805271E-05_JPRB, 0.13683958E-05_JPRB, 0.13459346E-05_JPRB /)

RGHG2(:,26,10) = (/ &
  & 0.97122995E-06_JPRB, 0.10106306E-05_JPRB, 0.10316347E-05_JPRB, 0.10495472E-05_JPRB, 0.10673047E-05_JPRB, 0.10860683E-05_JPRB, &
  & 0.11064682E-05_JPRB, 0.11286563E-05_JPRB, 0.11526080E-05_JPRB, 0.11782807E-05_JPRB, 0.12052710E-05_JPRB, 0.12331595E-05_JPRB, &
  & 0.12614339E-05_JPRB, 0.12896528E-05_JPRB, 0.13174331E-05_JPRB, 0.13444771E-05_JPRB, 0.13707399E-05_JPRB, 0.13961484E-05_JPRB, &
  & 0.14210132E-05_JPRB, 0.14455826E-05_JPRB, 0.14700148E-05_JPRB, 0.14941464E-05_JPRB, 0.15174735E-05_JPRB, 0.15392487E-05_JPRB, &
  & 0.15588336E-05_JPRB, 0.15756009E-05_JPRB, 0.15895075E-05_JPRB, 0.16006665E-05_JPRB, 0.16092406E-05_JPRB, 0.16154237E-05_JPRB, &
  & 0.16194132E-05_JPRB, 0.16214312E-05_JPRB, 0.16217929E-05_JPRB, 0.16209891E-05_JPRB, 0.16195650E-05_JPRB, 0.16179196E-05_JPRB, &
  & 0.16163872E-05_JPRB, 0.16151683E-05_JPRB, 0.16140439E-05_JPRB, 0.16126398E-05_JPRB, 0.16105572E-05_JPRB, 0.16073302E-05_JPRB, &
  & 0.16026580E-05_JPRB, 0.15963865E-05_JPRB, 0.15884501E-05_JPRB, 0.15790968E-05_JPRB, 0.15686946E-05_JPRB, 0.15576441E-05_JPRB, &
  & 0.15462530E-05_JPRB, 0.15347694E-05_JPRB, 0.15234316E-05_JPRB, 0.15124762E-05_JPRB, 0.15020360E-05_JPRB, 0.14921244E-05_JPRB, &
  & 0.14826612E-05_JPRB, 0.14735108E-05_JPRB, 0.14644885E-05_JPRB, 0.14554464E-05_JPRB, 0.14463105E-05_JPRB, 0.14370880E-05_JPRB, &
  & 0.14277822E-05_JPRB, 0.14183382E-05_JPRB, 0.14070165E-05_JPRB, 0.13878936E-05_JPRB /)

RGHG2(:,27,10) = (/ &
  & 0.10399176E-05_JPRB, 0.10755322E-05_JPRB, 0.10942167E-05_JPRB, 0.11095974E-05_JPRB, 0.11246686E-05_JPRB, 0.11407852E-05_JPRB, &
  & 0.11583179E-05_JPRB, 0.11776027E-05_JPRB, 0.11987497E-05_JPRB, 0.12216333E-05_JPRB, 0.12461558E-05_JPRB, 0.12718767E-05_JPRB, &
  & 0.12983924E-05_JPRB, 0.13252420E-05_JPRB, 0.13519597E-05_JPRB, 0.13782718E-05_JPRB, 0.14037026E-05_JPRB, 0.14284186E-05_JPRB, &
  & 0.14523354E-05_JPRB, 0.14758472E-05_JPRB, 0.14988019E-05_JPRB, 0.15213686E-05_JPRB, 0.15430267E-05_JPRB, 0.15632677E-05_JPRB, &
  & 0.15815460E-05_JPRB, 0.15973612E-05_JPRB, 0.16107128E-05_JPRB, 0.16216353E-05_JPRB, 0.16303420E-05_JPRB, 0.16369702E-05_JPRB, &
  & 0.16416644E-05_JPRB, 0.16446105E-05_JPRB, 0.16460361E-05_JPRB, 0.16462567E-05_JPRB, 0.16456463E-05_JPRB, 0.16444939E-05_JPRB, &
  & 0.16429663E-05_JPRB, 0.16412467E-05_JPRB, 0.16392995E-05_JPRB, 0.16369369E-05_JPRB, 0.16339268E-05_JPRB, 0.16299646E-05_JPRB, &
  & 0.16247891E-05_JPRB, 0.16182197E-05_JPRB, 0.16101969E-05_JPRB, 0.16008596E-05_JPRB, 0.15905848E-05_JPRB, 0.15797789E-05_JPRB, &
  & 0.15687314E-05_JPRB, 0.15575810E-05_JPRB, 0.15465919E-05_JPRB, 0.15360905E-05_JPRB, 0.15262279E-05_JPRB, 0.15169816E-05_JPRB, &
  & 0.15082605E-05_JPRB, 0.14998925E-05_JPRB, 0.14917030E-05_JPRB, 0.14835399E-05_JPRB, 0.14753239E-05_JPRB, 0.14670737E-05_JPRB, &
  & 0.14588619E-05_JPRB, 0.14502970E-05_JPRB, 0.14409810E-05_JPRB, 0.14233881E-05_JPRB /)

RGHG2(:,28,10) = (/ &
  & 0.11039746E-05_JPRB, 0.11367105E-05_JPRB, 0.11531301E-05_JPRB, 0.11664890E-05_JPRB, 0.11795738E-05_JPRB, 0.11933639E-05_JPRB, &
  & 0.12086281E-05_JPRB, 0.12255496E-05_JPRB, 0.12442522E-05_JPRB, 0.12648666E-05_JPRB, 0.12871711E-05_JPRB, 0.13109441E-05_JPRB, &
  & 0.13357812E-05_JPRB, 0.13612272E-05_JPRB, 0.13868753E-05_JPRB, 0.14121667E-05_JPRB, 0.14366686E-05_JPRB, 0.14605125E-05_JPRB, &
  & 0.14833470E-05_JPRB, 0.15055484E-05_JPRB, 0.15269343E-05_JPRB, 0.15477088E-05_JPRB, 0.15675163E-05_JPRB, 0.15859516E-05_JPRB, &
  & 0.16025878E-05_JPRB, 0.16171230E-05_JPRB, 0.16294905E-05_JPRB, 0.16399039E-05_JPRB, 0.16484254E-05_JPRB, 0.16551700E-05_JPRB, &
  & 0.16602504E-05_JPRB, 0.16638030E-05_JPRB, 0.16659848E-05_JPRB, 0.16669736E-05_JPRB, 0.16669958E-05_JPRB, 0.16662268E-05_JPRB, &
  & 0.16647668E-05_JPRB, 0.16627627E-05_JPRB, 0.16602562E-05_JPRB, 0.16572164E-05_JPRB, 0.16535148E-05_JPRB, 0.16489862E-05_JPRB, &
  & 0.16434112E-05_JPRB, 0.16366454E-05_JPRB, 0.16285830E-05_JPRB, 0.16193225E-05_JPRB, 0.16091881E-05_JPRB, 0.15985172E-05_JPRB, &
  & 0.15875966E-05_JPRB, 0.15766859E-05_JPRB, 0.15662074E-05_JPRB, 0.15563462E-05_JPRB, 0.15471105E-05_JPRB, 0.15384949E-05_JPRB, &
  & 0.15303915E-05_JPRB, 0.15226669E-05_JPRB, 0.15151513E-05_JPRB, 0.15077082E-05_JPRB, 0.15002828E-05_JPRB, 0.14928507E-05_JPRB, &
  & 0.14854023E-05_JPRB, 0.14780078E-05_JPRB, 0.14691491E-05_JPRB, 0.14545174E-05_JPRB /)

RGHG2(:,29,10) = (/ &
  & 0.11643280E-05_JPRB, 0.11942243E-05_JPRB, 0.12091049E-05_JPRB, 0.12208940E-05_JPRB, 0.12321782E-05_JPRB, 0.12442690E-05_JPRB, &
  & 0.12575717E-05_JPRB, 0.12725191E-05_JPRB, 0.12892818E-05_JPRB, 0.13078495E-05_JPRB, 0.13282569E-05_JPRB, 0.13502140E-05_JPRB, &
  & 0.13734109E-05_JPRB, 0.13973983E-05_JPRB, 0.14218415E-05_JPRB, 0.14457780E-05_JPRB, 0.14693227E-05_JPRB, 0.14919724E-05_JPRB, &
  & 0.15135749E-05_JPRB, 0.15342924E-05_JPRB, 0.15540604E-05_JPRB, 0.15729620E-05_JPRB, 0.15908361E-05_JPRB, 0.16073882E-05_JPRB, &
  & 0.16222681E-05_JPRB, 0.16353313E-05_JPRB, 0.16466106E-05_JPRB, 0.16562151E-05_JPRB, 0.16642659E-05_JPRB, 0.16708393E-05_JPRB, &
  & 0.16760132E-05_JPRB, 0.16798724E-05_JPRB, 0.16825097E-05_JPRB, 0.16840062E-05_JPRB, 0.16844695E-05_JPRB, 0.16839897E-05_JPRB, &
  & 0.16826077E-05_JPRB, 0.16804544E-05_JPRB, 0.16776114E-05_JPRB, 0.16741477E-05_JPRB, 0.16700006E-05_JPRB, 0.16651034E-05_JPRB, &
  & 0.16593119E-05_JPRB, 0.16524460E-05_JPRB, 0.16444601E-05_JPRB, 0.16353473E-05_JPRB, 0.16253917E-05_JPRB, 0.16149365E-05_JPRB, &
  & 0.16042777E-05_JPRB, 0.15938321E-05_JPRB, 0.15838688E-05_JPRB, 0.15744741E-05_JPRB, 0.15657168E-05_JPRB, 0.15575791E-05_JPRB, &
  & 0.15499648E-05_JPRB, 0.15427420E-05_JPRB, 0.15357460E-05_JPRB, 0.15288661E-05_JPRB, 0.15220069E-05_JPRB, 0.15151895E-05_JPRB, &
  & 0.15084952E-05_JPRB, 0.15015931E-05_JPRB, 0.14941259E-05_JPRB, 0.14807114E-05_JPRB /)

RGHG2(:,30,10) = (/ &
  & 0.12210255E-05_JPRB, 0.12488416E-05_JPRB, 0.12621731E-05_JPRB, 0.12726059E-05_JPRB, 0.12825872E-05_JPRB, 0.12930996E-05_JPRB, &
  & 0.13048846E-05_JPRB, 0.13181963E-05_JPRB, 0.13332078E-05_JPRB, 0.13500935E-05_JPRB, 0.13687372E-05_JPRB, 0.13890062E-05_JPRB, &
  & 0.14105725E-05_JPRB, 0.14330730E-05_JPRB, 0.14560242E-05_JPRB, 0.14785988E-05_JPRB, 0.15008278E-05_JPRB, 0.15221676E-05_JPRB, &
  & 0.15423971E-05_JPRB, 0.15615653E-05_JPRB, 0.15796904E-05_JPRB, 0.15967831E-05_JPRB, 0.16127633E-05_JPRB, 0.16274422E-05_JPRB, &
  & 0.16405829E-05_JPRB, 0.16521375E-05_JPRB, 0.16621883E-05_JPRB, 0.16708835E-05_JPRB, 0.16783115E-05_JPRB, 0.16845170E-05_JPRB, &
  & 0.16895633E-05_JPRB, 0.16934832E-05_JPRB, 0.16963245E-05_JPRB, 0.16980940E-05_JPRB, 0.16988204E-05_JPRB, 0.16985318E-05_JPRB, &
  & 0.16972313E-05_JPRB, 0.16950389E-05_JPRB, 0.16920228E-05_JPRB, 0.16883429E-05_JPRB, 0.16839558E-05_JPRB, 0.16788806E-05_JPRB, &
  & 0.16730088E-05_JPRB, 0.16661960E-05_JPRB, 0.16583425E-05_JPRB, 0.16494721E-05_JPRB, 0.16397908E-05_JPRB, 0.16296398E-05_JPRB, &
  & 0.16194167E-05_JPRB, 0.16094590E-05_JPRB, 0.15999079E-05_JPRB, 0.15908979E-05_JPRB, 0.15825274E-05_JPRB, 0.15747878E-05_JPRB, &
  & 0.15675598E-05_JPRB, 0.15607111E-05_JPRB, 0.15541110E-05_JPRB, 0.15476228E-05_JPRB, 0.15412176E-05_JPRB, 0.15348958E-05_JPRB, &
  & 0.15286448E-05_JPRB, 0.15224600E-05_JPRB, 0.15153234E-05_JPRB, 0.15034904E-05_JPRB /)

RGHG2(:,31,10) = (/ &
  & 0.12744326E-05_JPRB, 0.12998975E-05_JPRB, 0.13120881E-05_JPRB, 0.13214360E-05_JPRB, 0.13301886E-05_JPRB, 0.13395689E-05_JPRB, &
  & 0.13500016E-05_JPRB, 0.13619053E-05_JPRB, 0.13754759E-05_JPRB, 0.13907598E-05_JPRB, 0.14078207E-05_JPRB, 0.14264608E-05_JPRB, &
  & 0.14463923E-05_JPRB, 0.14673174E-05_JPRB, 0.14886514E-05_JPRB, 0.15097821E-05_JPRB, 0.15305191E-05_JPRB, 0.15504011E-05_JPRB, &
  & 0.15691953E-05_JPRB, 0.15868638E-05_JPRB, 0.16034041E-05_JPRB, 0.16188128E-05_JPRB, 0.16330368E-05_JPRB, 0.16459685E-05_JPRB, &
  & 0.16574944E-05_JPRB, 0.16675990E-05_JPRB, 0.16764566E-05_JPRB, 0.16841766E-05_JPRB, 0.16908771E-05_JPRB, 0.16965895E-05_JPRB, &
  & 0.17013422E-05_JPRB, 0.17051426E-05_JPRB, 0.17079875E-05_JPRB, 0.17098452E-05_JPRB, 0.17106876E-05_JPRB, 0.17105007E-05_JPRB, &
  & 0.17092777E-05_JPRB, 0.17071080E-05_JPRB, 0.17040520E-05_JPRB, 0.17003057E-05_JPRB, 0.16958504E-05_JPRB, 0.16907317E-05_JPRB, &
  & 0.16849077E-05_JPRB, 0.16782144E-05_JPRB, 0.16705724E-05_JPRB, 0.16619706E-05_JPRB, 0.16525887E-05_JPRB, 0.16427837E-05_JPRB, &
  & 0.16329528E-05_JPRB, 0.16233616E-05_JPRB, 0.16142002E-05_JPRB, 0.16056651E-05_JPRB, 0.15977906E-05_JPRB, 0.15904682E-05_JPRB, &
  & 0.15835921E-05_JPRB, 0.15770527E-05_JPRB, 0.15707274E-05_JPRB, 0.15645430E-05_JPRB, 0.15584631E-05_JPRB, 0.15524813E-05_JPRB, &
  & 0.15466391E-05_JPRB, 0.15407271E-05_JPRB, 0.15343377E-05_JPRB, 0.15232027E-05_JPRB /)

RGHG2(:,32,10) = (/ &
  & 0.13239946E-05_JPRB, 0.13474030E-05_JPRB, 0.13584028E-05_JPRB, 0.13667520E-05_JPRB, 0.13746883E-05_JPRB, 0.13829949E-05_JPRB, &
  & 0.13923909E-05_JPRB, 0.14031108E-05_JPRB, 0.14153297E-05_JPRB, 0.14292207E-05_JPRB, 0.14447317E-05_JPRB, 0.14617636E-05_JPRB, &
  & 0.14800552E-05_JPRB, 0.14993134E-05_JPRB, 0.15189660E-05_JPRB, 0.15385901E-05_JPRB, 0.15577891E-05_JPRB, 0.15761984E-05_JPRB, &
  & 0.15935699E-05_JPRB, 0.16098429E-05_JPRB, 0.16249141E-05_JPRB, 0.16387969E-05_JPRB, 0.16514739E-05_JPRB, 0.16628675E-05_JPRB, &
  & 0.16729367E-05_JPRB, 0.16817396E-05_JPRB, 0.16894455E-05_JPRB, 0.16962299E-05_JPRB, 0.17021771E-05_JPRB, 0.17073251E-05_JPRB, &
  & 0.17116830E-05_JPRB, 0.17152286E-05_JPRB, 0.17179318E-05_JPRB, 0.17197347E-05_JPRB, 0.17205861E-05_JPRB, 0.17204360E-05_JPRB, &
  & 0.17192805E-05_JPRB, 0.17171706E-05_JPRB, 0.17141726E-05_JPRB, 0.17104649E-05_JPRB, 0.17060578E-05_JPRB, 0.17010085E-05_JPRB, &
  & 0.16952755E-05_JPRB, 0.16887808E-05_JPRB, 0.16813696E-05_JPRB, 0.16730862E-05_JPRB, 0.16641260E-05_JPRB, 0.16548003E-05_JPRB, &
  & 0.16454518E-05_JPRB, 0.16363236E-05_JPRB, 0.16276495E-05_JPRB, 0.16195598E-05_JPRB, 0.16120421E-05_JPRB, 0.16050360E-05_JPRB, &
  & 0.15984360E-05_JPRB, 0.15921261E-05_JPRB, 0.15860468E-05_JPRB, 0.15801060E-05_JPRB, 0.15742672E-05_JPRB, 0.15685501E-05_JPRB, &
  & 0.15629718E-05_JPRB, 0.15574949E-05_JPRB, 0.15512526E-05_JPRB, 0.15409200E-05_JPRB /)

RGHG2(:,33,10) = (/ &
  & 0.13694480E-05_JPRB, 0.13906609E-05_JPRB, 0.14006350E-05_JPRB, 0.14083248E-05_JPRB, 0.14154064E-05_JPRB, 0.14230430E-05_JPRB, &
  & 0.14315274E-05_JPRB, 0.14412311E-05_JPRB, 0.14523187E-05_JPRB, 0.14648491E-05_JPRB, 0.14789002E-05_JPRB, 0.14943403E-05_JPRB, &
  & 0.15109679E-05_JPRB, 0.15284986E-05_JPRB, 0.15465015E-05_JPRB, 0.15645231E-05_JPRB, 0.15822316E-05_JPRB, 0.15992041E-05_JPRB, &
  & 0.16152659E-05_JPRB, 0.16302301E-05_JPRB, 0.16440442E-05_JPRB, 0.16566585E-05_JPRB, 0.16680192E-05_JPRB, 0.16781235E-05_JPRB, &
  & 0.16869510E-05_JPRB, 0.16946153E-05_JPRB, 0.17013042E-05_JPRB, 0.17071841E-05_JPRB, 0.17123832E-05_JPRB, 0.17169282E-05_JPRB, &
  & 0.17208167E-05_JPRB, 0.17240136E-05_JPRB, 0.17264693E-05_JPRB, 0.17281208E-05_JPRB, 0.17289018E-05_JPRB, 0.17287475E-05_JPRB, &
  & 0.17276537E-05_JPRB, 0.17256376E-05_JPRB, 0.17227592E-05_JPRB, 0.17191683E-05_JPRB, 0.17148951E-05_JPRB, 0.17099652E-05_JPRB, &
  & 0.17043909E-05_JPRB, 0.16981007E-05_JPRB, 0.16909619E-05_JPRB, 0.16830438E-05_JPRB, 0.16745345E-05_JPRB, 0.16657011E-05_JPRB, &
  & 0.16568524E-05_JPRB, 0.16482413E-05_JPRB, 0.16400680E-05_JPRB, 0.16324195E-05_JPRB, 0.16252978E-05_JPRB, 0.16186098E-05_JPRB, &
  & 0.16122840E-05_JPRB, 0.16062278E-05_JPRB, 0.16003366E-05_JPRB, 0.15945642E-05_JPRB, 0.15889055E-05_JPRB, 0.15833930E-05_JPRB, &
  & 0.15780735E-05_JPRB, 0.15727489E-05_JPRB, 0.15669700E-05_JPRB, 0.15570613E-05_JPRB /)

RGHG2(:,34,10) = (/ &
  & 0.14103863E-05_JPRB, 0.14295455E-05_JPRB, 0.14386867E-05_JPRB, 0.14456210E-05_JPRB, 0.14523041E-05_JPRB, 0.14592373E-05_JPRB, &
  & 0.14670636E-05_JPRB, 0.14759257E-05_JPRB, 0.14859502E-05_JPRB, 0.14972914E-05_JPRB, 0.15099234E-05_JPRB, 0.15238145E-05_JPRB, &
  & 0.15388016E-05_JPRB, 0.15546398E-05_JPRB, 0.15709875E-05_JPRB, 0.15874756E-05_JPRB, 0.16037239E-05_JPRB, 0.16193903E-05_JPRB, &
  & 0.16342478E-05_JPRB, 0.16481097E-05_JPRB, 0.16608656E-05_JPRB, 0.16724425E-05_JPRB, 0.16827541E-05_JPRB, 0.16917948E-05_JPRB, &
  & 0.16996087E-05_JPRB, 0.17062960E-05_JPRB, 0.17120824E-05_JPRB, 0.17171460E-05_JPRB, 0.17216138E-05_JPRB, 0.17255380E-05_JPRB, &
  & 0.17289098E-05_JPRB, 0.17316912E-05_JPRB, 0.17338282E-05_JPRB, 0.17352617E-05_JPRB, 0.17359197E-05_JPRB, 0.17357409E-05_JPRB, &
  & 0.17347146E-05_JPRB, 0.17328189E-05_JPRB, 0.17301093E-05_JPRB, 0.17266974E-05_JPRB, 0.17225977E-05_JPRB, 0.17178380E-05_JPRB, &
  & 0.17124614E-05_JPRB, 0.17063738E-05_JPRB, 0.16995209E-05_JPRB, 0.16919972E-05_JPRB, 0.16839556E-05_JPRB, 0.16756488E-05_JPRB, &
  & 0.16673556E-05_JPRB, 0.16592692E-05_JPRB, 0.16515705E-05_JPRB, 0.16443739E-05_JPRB, 0.16376333E-05_JPRB, 0.16313070E-05_JPRB, &
  & 0.16252734E-05_JPRB, 0.16194405E-05_JPRB, 0.16137296E-05_JPRB, 0.16081226E-05_JPRB, 0.16026256E-05_JPRB, 0.15972860E-05_JPRB, &
  & 0.15921369E-05_JPRB, 0.15871179E-05_JPRB, 0.15815342E-05_JPRB, 0.15721239E-05_JPRB /)

RGHG2(:,35,10) = (/ &
  & 0.14467294E-05_JPRB, 0.14640489E-05_JPRB, 0.14723537E-05_JPRB, 0.14789298E-05_JPRB, 0.14850211E-05_JPRB, 0.14916009E-05_JPRB, &
  & 0.14988116E-05_JPRB, 0.15069381E-05_JPRB, 0.15160834E-05_JPRB, 0.15262863E-05_JPRB, 0.15376363E-05_JPRB, 0.15500559E-05_JPRB, &
  & 0.15634768E-05_JPRB, 0.15776886E-05_JPRB, 0.15924716E-05_JPRB, 0.16074760E-05_JPRB, 0.16223790E-05_JPRB, 0.16368579E-05_JPRB, &
  & 0.16506818E-05_JPRB, 0.16636264E-05_JPRB, 0.16755437E-05_JPRB, 0.16862933E-05_JPRB, 0.16958037E-05_JPRB, 0.17040328E-05_JPRB, &
  & 0.17110099E-05_JPRB, 0.17168886E-05_JPRB, 0.17218679E-05_JPRB, 0.17261686E-05_JPRB, 0.17299302E-05_JPRB, 0.17332219E-05_JPRB, &
  & 0.17360441E-05_JPRB, 0.17383704E-05_JPRB, 0.17401469E-05_JPRB, 0.17413226E-05_JPRB, 0.17418312E-05_JPRB, 0.17416252E-05_JPRB, &
  & 0.17406783E-05_JPRB, 0.17389402E-05_JPRB, 0.17364487E-05_JPRB, 0.17332595E-05_JPRB, 0.17293677E-05_JPRB, 0.17248287E-05_JPRB, &
  & 0.17196433E-05_JPRB, 0.17137645E-05_JPRB, 0.17072017E-05_JPRB, 0.17000609E-05_JPRB, 0.16924864E-05_JPRB, 0.16847075E-05_JPRB, &
  & 0.16769545E-05_JPRB, 0.16694104E-05_JPRB, 0.16621957E-05_JPRB, 0.16554322E-05_JPRB, 0.16490943E-05_JPRB, 0.16431073E-05_JPRB, &
  & 0.16373598E-05_JPRB, 0.16317950E-05_JPRB, 0.16263127E-05_JPRB, 0.16208883E-05_JPRB, 0.16155548E-05_JPRB, 0.16103783E-05_JPRB, &
  & 0.16054296E-05_JPRB, 0.16005539E-05_JPRB, 0.15952195E-05_JPRB, 0.15862039E-05_JPRB /)

RGHG2(:,36,10) = (/ &
  & 0.14789453E-05_JPRB, 0.14944853E-05_JPRB, 0.15021756E-05_JPRB, 0.15081791E-05_JPRB, 0.15140546E-05_JPRB, 0.15201533E-05_JPRB, &
  & 0.15269213E-05_JPRB, 0.15344175E-05_JPRB, 0.15427298E-05_JPRB, 0.15519665E-05_JPRB, 0.15621122E-05_JPRB, 0.15731862E-05_JPRB, &
  & 0.15851248E-05_JPRB, 0.15978351E-05_JPRB, 0.16111195E-05_JPRB, 0.16247728E-05_JPRB, 0.16384029E-05_JPRB, 0.16518392E-05_JPRB, &
  & 0.16647382E-05_JPRB, 0.16769568E-05_JPRB, 0.16882518E-05_JPRB, 0.16984411E-05_JPRB, 0.17073517E-05_JPRB, 0.17149424E-05_JPRB, &
  & 0.17212254E-05_JPRB, 0.17263570E-05_JPRB, 0.17306013E-05_JPRB, 0.17341792E-05_JPRB, 0.17372600E-05_JPRB, 0.17399238E-05_JPRB, &
  & 0.17421980E-05_JPRB, 0.17440505E-05_JPRB, 0.17454537E-05_JPRB, 0.17463595E-05_JPRB, 0.17467142E-05_JPRB, 0.17464931E-05_JPRB, &
  & 0.17456492E-05_JPRB, 0.17441188E-05_JPRB, 0.17419068E-05_JPRB, 0.17389941E-05_JPRB, 0.17353767E-05_JPRB, 0.17310738E-05_JPRB, &
  & 0.17260899E-05_JPRB, 0.17204159E-05_JPRB, 0.17141298E-05_JPRB, 0.17073655E-05_JPRB, 0.17002518E-05_JPRB, 0.16929765E-05_JPRB, &
  & 0.16857346E-05_JPRB, 0.16786787E-05_JPRB, 0.16719052E-05_JPRB, 0.16655559E-05_JPRB, 0.16596001E-05_JPRB, 0.16539865E-05_JPRB, &
  & 0.16485777E-05_JPRB, 0.16433127E-05_JPRB, 0.16380995E-05_JPRB, 0.16328867E-05_JPRB, 0.16277387E-05_JPRB, 0.16227325E-05_JPRB, &
  & 0.16179330E-05_JPRB, 0.16132608E-05_JPRB, 0.16081461E-05_JPRB, 0.15994522E-05_JPRB /)

RGHG2(:,37,10) = (/ &
  & 0.15077155E-05_JPRB, 0.15214994E-05_JPRB, 0.15284697E-05_JPRB, 0.15341600E-05_JPRB, 0.15396276E-05_JPRB, 0.15454793E-05_JPRB, &
  & 0.15517910E-05_JPRB, 0.15587223E-05_JPRB, 0.15663280E-05_JPRB, 0.15746450E-05_JPRB, 0.15837172E-05_JPRB, 0.15935236E-05_JPRB, &
  & 0.16040935E-05_JPRB, 0.16153842E-05_JPRB, 0.16273013E-05_JPRB, 0.16396679E-05_JPRB, 0.16522099E-05_JPRB, 0.16646214E-05_JPRB, &
  & 0.16767681E-05_JPRB, 0.16883671E-05_JPRB, 0.16991931E-05_JPRB, 0.17089433E-05_JPRB, 0.17173741E-05_JPRB, 0.17243427E-05_JPRB, &
  & 0.17299211E-05_JPRB, 0.17343253E-05_JPRB, 0.17378472E-05_JPRB, 0.17407442E-05_JPRB, 0.17431917E-05_JPRB, 0.17452819E-05_JPRB, &
  & 0.17470391E-05_JPRB, 0.17484649E-05_JPRB, 0.17495264E-05_JPRB, 0.17501899E-05_JPRB, 0.17504170E-05_JPRB, 0.17502043E-05_JPRB, &
  & 0.17494926E-05_JPRB, 0.17482322E-05_JPRB, 0.17463734E-05_JPRB, 0.17438516E-05_JPRB, 0.17406129E-05_JPRB, 0.17366330E-05_JPRB, &
  & 0.17318976E-05_JPRB, 0.17264558E-05_JPRB, 0.17204602E-05_JPRB, 0.17140364E-05_JPRB, 0.17073407E-05_JPRB, 0.17005316E-05_JPRB, &
  & 0.16937394E-05_JPRB, 0.16871078E-05_JPRB, 0.16807484E-05_JPRB, 0.16747679E-05_JPRB, 0.16692004E-05_JPRB, 0.16639567E-05_JPRB, &
  & 0.16589216E-05_JPRB, 0.16540042E-05_JPRB, 0.16491183E-05_JPRB, 0.16441818E-05_JPRB, 0.16392603E-05_JPRB, 0.16344457E-05_JPRB, &
  & 0.16298216E-05_JPRB, 0.16253043E-05_JPRB, 0.16203339E-05_JPRB, 0.16119527E-05_JPRB /)

RGHG2(:,38,10) = (/ &
  & 0.15337552E-05_JPRB, 0.15457725E-05_JPRB, 0.15520252E-05_JPRB, 0.15572581E-05_JPRB, 0.15624917E-05_JPRB, 0.15680057E-05_JPRB, &
  & 0.15739646E-05_JPRB, 0.15803793E-05_JPRB, 0.15873070E-05_JPRB, 0.15947880E-05_JPRB, 0.16028373E-05_JPRB, 0.16114652E-05_JPRB, &
  & 0.16207366E-05_JPRB, 0.16307104E-05_JPRB, 0.16413635E-05_JPRB, 0.16525375E-05_JPRB, 0.16640863E-05_JPRB, 0.16756627E-05_JPRB, &
  & 0.16870714E-05_JPRB, 0.16980815E-05_JPRB, 0.17084194E-05_JPRB, 0.17176633E-05_JPRB, 0.17254611E-05_JPRB, 0.17317021E-05_JPRB, &
  & 0.17364931E-05_JPRB, 0.17401478E-05_JPRB, 0.17429963E-05_JPRB, 0.17452996E-05_JPRB, 0.17472223E-05_JPRB, 0.17488525E-05_JPRB, &
  & 0.17502260E-05_JPRB, 0.17513313E-05_JPRB, 0.17521525E-05_JPRB, 0.17526464E-05_JPRB, 0.17527963E-05_JPRB, 0.17526087E-05_JPRB, &
  & 0.17520349E-05_JPRB, 0.17510445E-05_JPRB, 0.17495742E-05_JPRB, 0.17475247E-05_JPRB, 0.17448017E-05_JPRB, 0.17412950E-05_JPRB, &
  & 0.17369595E-05_JPRB, 0.17318772E-05_JPRB, 0.17261981E-05_JPRB, 0.17201324E-05_JPRB, 0.17138321E-05_JPRB, 0.17074354E-05_JPRB, &
  & 0.17010375E-05_JPRB, 0.16947702E-05_JPRB, 0.16887550E-05_JPRB, 0.16831178E-05_JPRB, 0.16779072E-05_JPRB, 0.16730473E-05_JPRB, &
  & 0.16684243E-05_JPRB, 0.16639078E-05_JPRB, 0.16594112E-05_JPRB, 0.16548156E-05_JPRB, 0.16501743E-05_JPRB, 0.16455812E-05_JPRB, &
  & 0.16411329E-05_JPRB, 0.16367603E-05_JPRB, 0.16319752E-05_JPRB, 0.16237752E-05_JPRB /)

RGHG2(:,39,10) = (/ &
  & 0.15574815E-05_JPRB, 0.15677184E-05_JPRB, 0.15732503E-05_JPRB, 0.15781015E-05_JPRB, 0.15830232E-05_JPRB, 0.15882962E-05_JPRB, &
  & 0.15938981E-05_JPRB, 0.15998316E-05_JPRB, 0.16061160E-05_JPRB, 0.16127922E-05_JPRB, 0.16198646E-05_JPRB, 0.16273747E-05_JPRB, &
  & 0.16354389E-05_JPRB, 0.16441727E-05_JPRB, 0.16536533E-05_JPRB, 0.16637656E-05_JPRB, 0.16743021E-05_JPRB, 0.16850935E-05_JPRB, &
  & 0.16958306E-05_JPRB, 0.17062710E-05_JPRB, 0.17159770E-05_JPRB, 0.17245161E-05_JPRB, 0.17314908E-05_JPRB, 0.17368579E-05_JPRB, &
  & 0.17408620E-05_JPRB, 0.17438495E-05_JPRB, 0.17461582E-05_JPRB, 0.17480194E-05_JPRB, 0.17495786E-05_JPRB, 0.17509116E-05_JPRB, &
  & 0.17520422E-05_JPRB, 0.17529613E-05_JPRB, 0.17536429E-05_JPRB, 0.17540417E-05_JPRB, 0.17541538E-05_JPRB, 0.17539894E-05_JPRB, &
  & 0.17535169E-05_JPRB, 0.17527333E-05_JPRB, 0.17515746E-05_JPRB, 0.17499583E-05_JPRB, 0.17477585E-05_JPRB, 0.17448297E-05_JPRB, &
  & 0.17410803E-05_JPRB, 0.17365239E-05_JPRB, 0.17313081E-05_JPRB, 0.17256410E-05_JPRB, 0.17197335E-05_JPRB, 0.17137158E-05_JPRB, &
  & 0.17076791E-05_JPRB, 0.17017219E-05_JPRB, 0.16960040E-05_JPRB, 0.16906797E-05_JPRB, 0.16858019E-05_JPRB, 0.16813323E-05_JPRB, &
  & 0.16771270E-05_JPRB, 0.16730603E-05_JPRB, 0.16689814E-05_JPRB, 0.16647863E-05_JPRB, 0.16604695E-05_JPRB, 0.16561415E-05_JPRB, &
  & 0.16518890E-05_JPRB, 0.16476966E-05_JPRB, 0.16430220E-05_JPRB, 0.16350618E-05_JPRB /)

RGHG2(:,40,10) = (/ &
  & 0.15790918E-05_JPRB, 0.15876738E-05_JPRB, 0.15925709E-05_JPRB, 0.15969960E-05_JPRB, 0.16016613E-05_JPRB, 0.16066886E-05_JPRB, &
  & 0.16119704E-05_JPRB, 0.16174382E-05_JPRB, 0.16231060E-05_JPRB, 0.16289921E-05_JPRB, 0.16351413E-05_JPRB, 0.16416072E-05_JPRB, &
  & 0.16485469E-05_JPRB, 0.16561498E-05_JPRB, 0.16645279E-05_JPRB, 0.16736537E-05_JPRB, 0.16833280E-05_JPRB, 0.16932872E-05_JPRB, &
  & 0.17033211E-05_JPRB, 0.17130562E-05_JPRB, 0.17220417E-05_JPRB, 0.17296925E-05_JPRB, 0.17357503E-05_JPRB, 0.17402958E-05_JPRB, &
  & 0.17436282E-05_JPRB, 0.17461122E-05_JPRB, 0.17480386E-05_JPRB, 0.17496084E-05_JPRB, 0.17509368E-05_JPRB, 0.17520892E-05_JPRB, &
  & 0.17530811E-05_JPRB, 0.17538966E-05_JPRB, 0.17545054E-05_JPRB, 0.17548520E-05_JPRB, 0.17549470E-05_JPRB, 0.17547960E-05_JPRB, &
  & 0.17543882E-05_JPRB, 0.17537367E-05_JPRB, 0.17527934E-05_JPRB, 0.17514934E-05_JPRB, 0.17497249E-05_JPRB, 0.17473367E-05_JPRB, &
  & 0.17442227E-05_JPRB, 0.17403219E-05_JPRB, 0.17356939E-05_JPRB, 0.17305229E-05_JPRB, 0.17250495E-05_JPRB, 0.17194135E-05_JPRB, &
  & 0.17137011E-05_JPRB, 0.17080408E-05_JPRB, 0.17025815E-05_JPRB, 0.16975246E-05_JPRB, 0.16929785E-05_JPRB, 0.16888800E-05_JPRB, &
  & 0.16851072E-05_JPRB, 0.16814744E-05_JPRB, 0.16778391E-05_JPRB, 0.16740553E-05_JPRB, 0.16701136E-05_JPRB, 0.16660841E-05_JPRB, &
  & 0.16620920E-05_JPRB, 0.16580796E-05_JPRB, 0.16536250E-05_JPRB, 0.16458461E-05_JPRB /)

RGHG2(:,41,10) = (/ &
  & 0.15986445E-05_JPRB, 0.16059278E-05_JPRB, 0.16102042E-05_JPRB, 0.16142722E-05_JPRB, 0.16186930E-05_JPRB, 0.16234992E-05_JPRB, &
  & 0.16284904E-05_JPRB, 0.16335109E-05_JPRB, 0.16385729E-05_JPRB, 0.16437220E-05_JPRB, 0.16489957E-05_JPRB, 0.16544984E-05_JPRB, &
  & 0.16604195E-05_JPRB, 0.16669813E-05_JPRB, 0.16743519E-05_JPRB, 0.16825218E-05_JPRB, 0.16913204E-05_JPRB, 0.17005135E-05_JPRB, &
  & 0.17097915E-05_JPRB, 0.17187837E-05_JPRB, 0.17268831E-05_JPRB, 0.17336183E-05_JPRB, 0.17388006E-05_JPRB, 0.17426362E-05_JPRB, &
  & 0.17454545E-05_JPRB, 0.17475709E-05_JPRB, 0.17492360E-05_JPRB, 0.17506093E-05_JPRB, 0.17517907E-05_JPRB, 0.17528296E-05_JPRB, &
  & 0.17537393E-05_JPRB, 0.17544962E-05_JPRB, 0.17550645E-05_JPRB, 0.17553816E-05_JPRB, 0.17554667E-05_JPRB, 0.17553211E-05_JPRB, &
  & 0.17549548E-05_JPRB, 0.17543890E-05_JPRB, 0.17535891E-05_JPRB, 0.17525149E-05_JPRB, 0.17510662E-05_JPRB, 0.17491268E-05_JPRB, &
  & 0.17465836E-05_JPRB, 0.17433364E-05_JPRB, 0.17393561E-05_JPRB, 0.17347912E-05_JPRB, 0.17297751E-05_JPRB, 0.17245360E-05_JPRB, &
  & 0.17191721E-05_JPRB, 0.17137794E-05_JPRB, 0.17085648E-05_JPRB, 0.17037851E-05_JPRB, 0.16995357E-05_JPRB, 0.16958113E-05_JPRB, &
  & 0.16924333E-05_JPRB, 0.16892320E-05_JPRB, 0.16860135E-05_JPRB, 0.16826488E-05_JPRB, 0.16790875E-05_JPRB, 0.16754095E-05_JPRB, &
  & 0.16717006E-05_JPRB, 0.16679783E-05_JPRB, 0.16637373E-05_JPRB, 0.16563155E-05_JPRB /)

RGHG2(:,42,10) = (/ &
  & 0.16163929E-05_JPRB, 0.16226137E-05_JPRB, 0.16264200E-05_JPRB, 0.16301726E-05_JPRB, 0.16343920E-05_JPRB, 0.16390419E-05_JPRB, &
  & 0.16437473E-05_JPRB, 0.16483541E-05_JPRB, 0.16528491E-05_JPRB, 0.16572959E-05_JPRB, 0.16617748E-05_JPRB, 0.16664028E-05_JPRB, &
  & 0.16713974E-05_JPRB, 0.16770133E-05_JPRB, 0.16834495E-05_JPRB, 0.16907280E-05_JPRB, 0.16986908E-05_JPRB, 0.17070747E-05_JPRB, &
  & 0.17155817E-05_JPRB, 0.17237242E-05_JPRB, 0.17309204E-05_JPRB, 0.17367092E-05_JPRB, 0.17410989E-05_JPRB, 0.17443410E-05_JPRB, &
  & 0.17467486E-05_JPRB, 0.17485922E-05_JPRB, 0.17500679E-05_JPRB, 0.17513051E-05_JPRB, 0.17523859E-05_JPRB, 0.17533516E-05_JPRB, &
  & 0.17542093E-05_JPRB, 0.17549319E-05_JPRB, 0.17554769E-05_JPRB, 0.17557750E-05_JPRB, 0.17558532E-05_JPRB, 0.17557086E-05_JPRB, &
  & 0.17553699E-05_JPRB, 0.17548600E-05_JPRB, 0.17541636E-05_JPRB, 0.17532514E-05_JPRB, 0.17520478E-05_JPRB, 0.17504613E-05_JPRB, &
  & 0.17483969E-05_JPRB, 0.17457360E-05_JPRB, 0.17424359E-05_JPRB, 0.17384561E-05_JPRB, 0.17339855E-05_JPRB, 0.17291501E-05_JPRB, &
  & 0.17241216E-05_JPRB, 0.17190303E-05_JPRB, 0.17140825E-05_JPRB, 0.17095585E-05_JPRB, 0.17056352E-05_JPRB, 0.17022550E-05_JPRB, &
  & 0.16992601E-05_JPRB, 0.16964439E-05_JPRB, 0.16936211E-05_JPRB, 0.16906466E-05_JPRB, 0.16874725E-05_JPRB, 0.16841570E-05_JPRB, &
  & 0.16808174E-05_JPRB, 0.16774117E-05_JPRB, 0.16735502E-05_JPRB, 0.16666066E-05_JPRB /)

RGHG2(:,43,10) = (/ &
  & 0.16325796E-05_JPRB, 0.16380220E-05_JPRB, 0.16414473E-05_JPRB, 0.16449617E-05_JPRB, 0.16490513E-05_JPRB, 0.16535523E-05_JPRB, &
  & 0.16580337E-05_JPRB, 0.16622434E-05_JPRB, 0.16662132E-05_JPRB, 0.16700308E-05_JPRB, 0.16737832E-05_JPRB, 0.16776316E-05_JPRB, &
  & 0.16817992E-05_JPRB, 0.16865479E-05_JPRB, 0.16921109E-05_JPRB, 0.16985396E-05_JPRB, 0.17056689E-05_JPRB, 0.17132552E-05_JPRB, &
  & 0.17209312E-05_JPRB, 0.17281748E-05_JPRB, 0.17343659E-05_JPRB, 0.17392540E-05_JPRB, 0.17429163E-05_JPRB, 0.17456529E-05_JPRB, &
  & 0.17477296E-05_JPRB, 0.17493569E-05_JPRB, 0.17506895E-05_JPRB, 0.17518282E-05_JPRB, 0.17528383E-05_JPRB, 0.17537548E-05_JPRB, &
  & 0.17545797E-05_JPRB, 0.17552823E-05_JPRB, 0.17558135E-05_JPRB, 0.17560981E-05_JPRB, 0.17561697E-05_JPRB, 0.17560238E-05_JPRB, &
  & 0.17557029E-05_JPRB, 0.17552343E-05_JPRB, 0.17546133E-05_JPRB, 0.17538248E-05_JPRB, 0.17528109E-05_JPRB, 0.17515086E-05_JPRB, &
  & 0.17498348E-05_JPRB, 0.17477013E-05_JPRB, 0.17449921E-05_JPRB, 0.17416689E-05_JPRB, 0.17377001E-05_JPRB, 0.17333188E-05_JPRB, &
  & 0.17286588E-05_JPRB, 0.17238794E-05_JPRB, 0.17192281E-05_JPRB, 0.17150146E-05_JPRB, 0.17114032E-05_JPRB, 0.17083644E-05_JPRB, &
  & 0.17057237E-05_JPRB, 0.17032587E-05_JPRB, 0.17007944E-05_JPRB, 0.16981862E-05_JPRB, 0.16953862E-05_JPRB, 0.16924594E-05_JPRB, &
  & 0.16895035E-05_JPRB, 0.16865243E-05_JPRB, 0.16831084E-05_JPRB, 0.16769052E-05_JPRB /)

RGHG2(:,44,10) = (/ &
  & 0.16475861E-05_JPRB, 0.16524531E-05_JPRB, 0.16555994E-05_JPRB, 0.16589323E-05_JPRB, 0.16628990E-05_JPRB, 0.16673282E-05_JPRB, &
  & 0.16715730E-05_JPRB, 0.16754294E-05_JPRB, 0.16789224E-05_JPRB, 0.16821575E-05_JPRB, 0.16852804E-05_JPRB, 0.16884383E-05_JPRB, &
  & 0.16918552E-05_JPRB, 0.16958329E-05_JPRB, 0.17005814E-05_JPRB, 0.17061916E-05_JPRB, 0.17125260E-05_JPRB, 0.17192660E-05_JPRB, &
  & 0.17260354E-05_JPRB, 0.17322303E-05_JPRB, 0.17373997E-05_JPRB, 0.17413837E-05_JPRB, 0.17444040E-05_JPRB, 0.17467019E-05_JPRB, &
  & 0.17485021E-05_JPRB, 0.17499548E-05_JPRB, 0.17511763E-05_JPRB, 0.17522416E-05_JPRB, 0.17532029E-05_JPRB, 0.17540879E-05_JPRB, &
  & 0.17548933E-05_JPRB, 0.17555852E-05_JPRB, 0.17561081E-05_JPRB, 0.17563840E-05_JPRB, 0.17564473E-05_JPRB, 0.17562988E-05_JPRB, &
  & 0.17559896E-05_JPRB, 0.17555501E-05_JPRB, 0.17549878E-05_JPRB, 0.17542951E-05_JPRB, 0.17534334E-05_JPRB, 0.17523593E-05_JPRB, &
  & 0.17510133E-05_JPRB, 0.17493205E-05_JPRB, 0.17471880E-05_JPRB, 0.17444453E-05_JPRB, 0.17410852E-05_JPRB, 0.17371473E-05_JPRB, &
  & 0.17328656E-05_JPRB, 0.17284406E-05_JPRB, 0.17241288E-05_JPRB, 0.17202410E-05_JPRB, 0.17169693E-05_JPRB, 0.17142712E-05_JPRB, &
  & 0.17119469E-05_JPRB, 0.17098093E-05_JPRB, 0.17076686E-05_JPRB, 0.17053985E-05_JPRB, 0.17029616E-05_JPRB, 0.17004161E-05_JPRB, &
  & 0.16978855E-05_JPRB, 0.16953511E-05_JPRB, 0.16924652E-05_JPRB, 0.16872117E-05_JPRB /)

RGHG2(:,45,10) = (/ &
  & 0.16617560E-05_JPRB, 0.16662159E-05_JPRB, 0.16691497E-05_JPRB, 0.16723017E-05_JPRB, 0.16762249E-05_JPRB, 0.16805210E-05_JPRB, &
  & 0.16845836E-05_JPRB, 0.16880853E-05_JPRB, 0.16911213E-05_JPRB, 0.16938561E-05_JPRB, 0.16964045E-05_JPRB, 0.16989540E-05_JPRB, &
  & 0.17017456E-05_JPRB, 0.17049862E-05_JPRB, 0.17089973E-05_JPRB, 0.17138427E-05_JPRB, 0.17193493E-05_JPRB, 0.17252203E-05_JPRB, &
  & 0.17309122E-05_JPRB, 0.17359729E-05_JPRB, 0.17400379E-05_JPRB, 0.17432027E-05_JPRB, 0.17456339E-05_JPRB, 0.17475600E-05_JPRB, &
  & 0.17491236E-05_JPRB, 0.17504333E-05_JPRB, 0.17515656E-05_JPRB, 0.17525784E-05_JPRB, 0.17535067E-05_JPRB, 0.17543747E-05_JPRB, &
  & 0.17551720E-05_JPRB, 0.17558610E-05_JPRB, 0.17563785E-05_JPRB, 0.17566472E-05_JPRB, 0.17567006E-05_JPRB, 0.17565488E-05_JPRB, &
  & 0.17562461E-05_JPRB, 0.17558283E-05_JPRB, 0.17553101E-05_JPRB, 0.17546934E-05_JPRB, 0.17539546E-05_JPRB, 0.17530664E-05_JPRB, &
  & 0.17519922E-05_JPRB, 0.17506859E-05_JPRB, 0.17490373E-05_JPRB, 0.17469188E-05_JPRB, 0.17441428E-05_JPRB, 0.17407383E-05_JPRB, &
  & 0.17368731E-05_JPRB, 0.17328053E-05_JPRB, 0.17288469E-05_JPRB, 0.17253377E-05_JPRB, 0.17224130E-05_JPRB, 0.17200400E-05_JPRB, &
  & 0.17180341E-05_JPRB, 0.17161863E-05_JPRB, 0.17143466E-05_JPRB, 0.17123949E-05_JPRB, 0.17102948E-05_JPRB, 0.17081285E-05_JPRB, &
  & 0.17060005E-05_JPRB, 0.17039105E-05_JPRB, 0.17015677E-05_JPRB, 0.16973053E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART19',1,ZHOOK_HANDLE)
END SUBROUTINE PART19




SUBROUTINE PART20
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART20',0,ZHOOK_HANDLE)



RGHG2(:,46,10) = (/ &
  & 0.16753876E-05_JPRB, 0.16795852E-05_JPRB, 0.16823288E-05_JPRB, 0.16854042E-05_JPRB, 0.16891488E-05_JPRB, 0.16934118E-05_JPRB, &
  & 0.16971878E-05_JPRB, 0.17003416E-05_JPRB, 0.17029549E-05_JPRB, 0.17051899E-05_JPRB, 0.17072450E-05_JPRB, 0.17092798E-05_JPRB, &
  & 0.17114680E-05_JPRB, 0.17141241E-05_JPRB, 0.17174175E-05_JPRB, 0.17215050E-05_JPRB, 0.17262096E-05_JPRB, 0.17310233E-05_JPRB, &
  & 0.17355378E-05_JPRB, 0.17393152E-05_JPRB, 0.17423577E-05_JPRB, 0.17447379E-05_JPRB, 0.17466689E-05_JPRB, 0.17482679E-05_JPRB, &
  & 0.17496317E-05_JPRB, 0.17508206E-05_JPRB, 0.17518830E-05_JPRB, 0.17528569E-05_JPRB, 0.17537670E-05_JPRB, 0.17546294E-05_JPRB, &
  & 0.17554270E-05_JPRB, 0.17561181E-05_JPRB, 0.17566331E-05_JPRB, 0.17568956E-05_JPRB, 0.17569380E-05_JPRB, 0.17567819E-05_JPRB, &
  & 0.17564812E-05_JPRB, 0.17560789E-05_JPRB, 0.17555941E-05_JPRB, 0.17550384E-05_JPRB, 0.17543992E-05_JPRB, 0.17536652E-05_JPRB, &
  & 0.17528166E-05_JPRB, 0.17518238E-05_JPRB, 0.17506187E-05_JPRB, 0.17490461E-05_JPRB, 0.17469230E-05_JPRB, 0.17441267E-05_JPRB, &
  & 0.17407281E-05_JPRB, 0.17370612E-05_JPRB, 0.17334912E-05_JPRB, 0.17303287E-05_JPRB, 0.17277831E-05_JPRB, 0.17257295E-05_JPRB, &
  & 0.17240096E-05_JPRB, 0.17224387E-05_JPRB, 0.17208704E-05_JPRB, 0.17192074E-05_JPRB, 0.17174258E-05_JPRB, 0.17155983E-05_JPRB, &
  & 0.17138365E-05_JPRB, 0.17121401E-05_JPRB, 0.17102608E-05_JPRB, 0.17069128E-05_JPRB /)

RGHG2(:,47,10) = (/ &
  & 0.16887783E-05_JPRB, 0.16927800E-05_JPRB, 0.16954607E-05_JPRB, 0.16983337E-05_JPRB, 0.17020732E-05_JPRB, 0.17060372E-05_JPRB, &
  & 0.17095815E-05_JPRB, 0.17123232E-05_JPRB, 0.17144753E-05_JPRB, 0.17162697E-05_JPRB, 0.17178543E-05_JPRB, 0.17194052E-05_JPRB, &
  & 0.17211247E-05_JPRB, 0.17231696E-05_JPRB, 0.17258446E-05_JPRB, 0.17291773E-05_JPRB, 0.17328973E-05_JPRB, 0.17365610E-05_JPRB, &
  & 0.17396983E-05_JPRB, 0.17422753E-05_JPRB, 0.17443296E-05_JPRB, 0.17460538E-05_JPRB, 0.17475364E-05_JPRB, 0.17488592E-05_JPRB, &
  & 0.17500506E-05_JPRB, 0.17511383E-05_JPRB, 0.17521442E-05_JPRB, 0.17530933E-05_JPRB, 0.17539952E-05_JPRB, 0.17548613E-05_JPRB, &
  & 0.17556661E-05_JPRB, 0.17563639E-05_JPRB, 0.17568765E-05_JPRB, 0.17571338E-05_JPRB, 0.17571642E-05_JPRB, 0.17570026E-05_JPRB, &
  & 0.17567005E-05_JPRB, 0.17563081E-05_JPRB, 0.17558489E-05_JPRB, 0.17553417E-05_JPRB, 0.17547846E-05_JPRB, 0.17541769E-05_JPRB, &
  & 0.17535132E-05_JPRB, 0.17527830E-05_JPRB, 0.17519344E-05_JPRB, 0.17508580E-05_JPRB, 0.17493692E-05_JPRB, 0.17472418E-05_JPRB, &
  & 0.17444860E-05_JPRB, 0.17412776E-05_JPRB, 0.17380939E-05_JPRB, 0.17353316E-05_JPRB, 0.17330940E-05_JPRB, 0.17313491E-05_JPRB, &
  & 0.17298883E-05_JPRB, 0.17285568E-05_JPRB, 0.17272306E-05_JPRB, 0.17258169E-05_JPRB, 0.17243083E-05_JPRB, 0.17227726E-05_JPRB, &
  & 0.17213159E-05_JPRB, 0.17199305E-05_JPRB, 0.17184294E-05_JPRB, 0.17157853E-05_JPRB /)

RGHG2(:,48,10) = (/ &
  & 0.17020413E-05_JPRB, 0.17060216E-05_JPRB, 0.17085799E-05_JPRB, 0.17114377E-05_JPRB, 0.17148761E-05_JPRB, 0.17187092E-05_JPRB, &
  & 0.17218044E-05_JPRB, 0.17241117E-05_JPRB, 0.17258080E-05_JPRB, 0.17271300E-05_JPRB, 0.17282796E-05_JPRB, 0.17293951E-05_JPRB, &
  & 0.17306145E-05_JPRB, 0.17321545E-05_JPRB, 0.17341201E-05_JPRB, 0.17365857E-05_JPRB, 0.17391764E-05_JPRB, 0.17414577E-05_JPRB, &
  & 0.17433047E-05_JPRB, 0.17447612E-05_JPRB, 0.17460134E-05_JPRB, 0.17471604E-05_JPRB, 0.17482726E-05_JPRB, 0.17493544E-05_JPRB, &
  & 0.17503992E-05_JPRB, 0.17514028E-05_JPRB, 0.17523660E-05_JPRB, 0.17532991E-05_JPRB, 0.17542022E-05_JPRB, 0.17550788E-05_JPRB, &
  & 0.17558962E-05_JPRB, 0.17566007E-05_JPRB, 0.17571132E-05_JPRB, 0.17573651E-05_JPRB, 0.17573832E-05_JPRB, 0.17572142E-05_JPRB, &
  & 0.17569080E-05_JPRB, 0.17565212E-05_JPRB, 0.17560806E-05_JPRB, 0.17556126E-05_JPRB, 0.17551230E-05_JPRB, 0.17546197E-05_JPRB, &
  & 0.17541082E-05_JPRB, 0.17535881E-05_JPRB, 0.17530308E-05_JPRB, 0.17523626E-05_JPRB, 0.17514217E-05_JPRB, 0.17500226E-05_JPRB, &
  & 0.17479771E-05_JPRB, 0.17454472E-05_JPRB, 0.17427482E-05_JPRB, 0.17403488E-05_JPRB, 0.17384459E-05_JPRB, 0.17369415E-05_JPRB, &
  & 0.17356983E-05_JPRB, 0.17345645E-05_JPRB, 0.17334296E-05_JPRB, 0.17322219E-05_JPRB, 0.17309277E-05_JPRB, 0.17296253E-05_JPRB, &
  & 0.17283976E-05_JPRB, 0.17272497E-05_JPRB, 0.17260135E-05_JPRB, 0.17238716E-05_JPRB /)

RGHG2(:,49,10) = (/ &
  & 0.17151374E-05_JPRB, 0.17190531E-05_JPRB, 0.17216007E-05_JPRB, 0.17242716E-05_JPRB, 0.17275853E-05_JPRB, 0.17309732E-05_JPRB, &
  & 0.17336646E-05_JPRB, 0.17354596E-05_JPRB, 0.17366715E-05_JPRB, 0.17375567E-05_JPRB, 0.17382733E-05_JPRB, 0.17389561E-05_JPRB, &
  & 0.17397157E-05_JPRB, 0.17406356E-05_JPRB, 0.17418586E-05_JPRB, 0.17432180E-05_JPRB, 0.17445122E-05_JPRB, 0.17455075E-05_JPRB, &
  & 0.17462276E-05_JPRB, 0.17468205E-05_JPRB, 0.17474169E-05_JPRB, 0.17481049E-05_JPRB, 0.17488957E-05_JPRB, 0.17497728E-05_JPRB, &
  & 0.17506929E-05_JPRB, 0.17516282E-05_JPRB, 0.17525599E-05_JPRB, 0.17534863E-05_JPRB, 0.17543965E-05_JPRB, 0.17552875E-05_JPRB, &
  & 0.17561192E-05_JPRB, 0.17568339E-05_JPRB, 0.17573448E-05_JPRB, 0.17575921E-05_JPRB, 0.17575978E-05_JPRB, 0.17574195E-05_JPRB, &
  & 0.17571076E-05_JPRB, 0.17567216E-05_JPRB, 0.17562962E-05_JPRB, 0.17558598E-05_JPRB, 0.17554261E-05_JPRB, 0.17550095E-05_JPRB, &
  & 0.17546231E-05_JPRB, 0.17542728E-05_JPRB, 0.17539476E-05_JPRB, 0.17535939E-05_JPRB, 0.17531110E-05_JPRB, 0.17523199E-05_JPRB, &
  & 0.17510755E-05_JPRB, 0.17493173E-05_JPRB, 0.17473343E-05_JPRB, 0.17454208E-05_JPRB, 0.17438372E-05_JPRB, 0.17425677E-05_JPRB, &
  & 0.17415013E-05_JPRB, 0.17405215E-05_JPRB, 0.17395346E-05_JPRB, 0.17384785E-05_JPRB, 0.17373484E-05_JPRB, 0.17362116E-05_JPRB, &
  & 0.17351512E-05_JPRB, 0.17341637E-05_JPRB, 0.17330990E-05_JPRB, 0.17312843E-05_JPRB /)

RGHG2(:,50,10) = (/ &
  & 0.17273904E-05_JPRB, 0.17311390E-05_JPRB, 0.17334734E-05_JPRB, 0.17359155E-05_JPRB, 0.17388297E-05_JPRB, 0.17417535E-05_JPRB, &
  & 0.17438441E-05_JPRB, 0.17451241E-05_JPRB, 0.17458883E-05_JPRB, 0.17463801E-05_JPRB, 0.17467430E-05_JPRB, 0.17470513E-05_JPRB, &
  & 0.17473603E-05_JPRB, 0.17477187E-05_JPRB, 0.17480852E-05_JPRB, 0.17484286E-05_JPRB, 0.17486011E-05_JPRB, 0.17486077E-05_JPRB, &
  & 0.17485331E-05_JPRB, 0.17484941E-05_JPRB, 0.17486001E-05_JPRB, 0.17489114E-05_JPRB, 0.17494331E-05_JPRB, 0.17501297E-05_JPRB, &
  & 0.17509441E-05_JPRB, 0.17518244E-05_JPRB, 0.17527366E-05_JPRB, 0.17536620E-05_JPRB, 0.17545851E-05_JPRB, 0.17554917E-05_JPRB, &
  & 0.17563409E-05_JPRB, 0.17570638E-05_JPRB, 0.17575748E-05_JPRB, 0.17578166E-05_JPRB, 0.17578114E-05_JPRB, 0.17576217E-05_JPRB, &
  & 0.17573028E-05_JPRB, 0.17569158E-05_JPRB, 0.17565009E-05_JPRB, 0.17560901E-05_JPRB, 0.17557021E-05_JPRB, 0.17553585E-05_JPRB, &
  & 0.17550765E-05_JPRB, 0.17548688E-05_JPRB, 0.17547263E-05_JPRB, 0.17546206E-05_JPRB, 0.17544751E-05_JPRB, 0.17541719E-05_JPRB, &
  & 0.17535702E-05_JPRB, 0.17526396E-05_JPRB, 0.17514324E-05_JPRB, 0.17501957E-05_JPRB, 0.17490577E-05_JPRB, 0.17480901E-05_JPRB, &
  & 0.17472292E-05_JPRB, 0.17464154E-05_JPRB, 0.17455791E-05_JPRB, 0.17446574E-05_JPRB, 0.17436666E-05_JPRB, 0.17426601E-05_JPRB, &
  & 0.17417227E-05_JPRB, 0.17408306E-05_JPRB, 0.17398803E-05_JPRB, 0.17382110E-05_JPRB /)

RGHG2(:,51,10) = (/ &
  & 0.17379259E-05_JPRB, 0.17410457E-05_JPRB, 0.17429472E-05_JPRB, 0.17449270E-05_JPRB, 0.17472436E-05_JPRB, 0.17494888E-05_JPRB, &
  & 0.17509658E-05_JPRB, 0.17517607E-05_JPRB, 0.17521793E-05_JPRB, 0.17524135E-05_JPRB, 0.17525427E-05_JPRB, 0.17526104E-05_JPRB, &
  & 0.17526240E-05_JPRB, 0.17525650E-05_JPRB, 0.17523867E-05_JPRB, 0.17520460E-05_JPRB, 0.17515281E-05_JPRB, 0.17509341E-05_JPRB, &
  & 0.17503465E-05_JPRB, 0.17498770E-05_JPRB, 0.17496122E-05_JPRB, 0.17496171E-05_JPRB, 0.17499043E-05_JPRB, 0.17504412E-05_JPRB, &
  & 0.17511630E-05_JPRB, 0.17519995E-05_JPRB, 0.17529006E-05_JPRB, 0.17538310E-05_JPRB, 0.17547700E-05_JPRB, 0.17556958E-05_JPRB, &
  & 0.17565610E-05_JPRB, 0.17572952E-05_JPRB, 0.17578054E-05_JPRB, 0.17580425E-05_JPRB, 0.17580267E-05_JPRB, 0.17578246E-05_JPRB, &
  & 0.17574970E-05_JPRB, 0.17571076E-05_JPRB, 0.17567003E-05_JPRB, 0.17563086E-05_JPRB, 0.17559589E-05_JPRB, 0.17556760E-05_JPRB, &
  & 0.17554861E-05_JPRB, 0.17553980E-05_JPRB, 0.17554098E-05_JPRB, 0.17554983E-05_JPRB, 0.17556089E-05_JPRB, 0.17556504E-05_JPRB, &
  & 0.17555295E-05_JPRB, 0.17551959E-05_JPRB, 0.17547001E-05_JPRB, 0.17541051E-05_JPRB, 0.17535153E-05_JPRB, 0.17529474E-05_JPRB, &
  & 0.17524127E-05_JPRB, 0.17518605E-05_JPRB, 0.17512466E-05_JPRB, 0.17505471E-05_JPRB, 0.17497388E-05_JPRB, 0.17489065E-05_JPRB, &
  & 0.17480904E-05_JPRB, 0.17473117E-05_JPRB, 0.17464055E-05_JPRB, 0.17448543E-05_JPRB /)

RGHG2(:,52,10) = (/ &
  & 0.17465261E-05_JPRB, 0.17483983E-05_JPRB, 0.17496438E-05_JPRB, 0.17510462E-05_JPRB, 0.17527584E-05_JPRB, 0.17543265E-05_JPRB, &
  & 0.17552635E-05_JPRB, 0.17557185E-05_JPRB, 0.17559257E-05_JPRB, 0.17560099E-05_JPRB, 0.17560222E-05_JPRB, 0.17559735E-05_JPRB, &
  & 0.17558456E-05_JPRB, 0.17555942E-05_JPRB, 0.17551699E-05_JPRB, 0.17544827E-05_JPRB, 0.17536404E-05_JPRB, 0.17527057E-05_JPRB, &
  & 0.17518145E-05_JPRB, 0.17510449E-05_JPRB, 0.17504974E-05_JPRB, 0.17502464E-05_JPRB, 0.17503273E-05_JPRB, 0.17507213E-05_JPRB, &
  & 0.17513610E-05_JPRB, 0.17521629E-05_JPRB, 0.17530556E-05_JPRB, 0.17539962E-05_JPRB, 0.17549538E-05_JPRB, 0.17558990E-05_JPRB, &
  & 0.17567839E-05_JPRB, 0.17575285E-05_JPRB, 0.17580396E-05_JPRB, 0.17582715E-05_JPRB, 0.17582462E-05_JPRB, 0.17580314E-05_JPRB, &
  & 0.17576949E-05_JPRB, 0.17573009E-05_JPRB, 0.17568980E-05_JPRB, 0.17565214E-05_JPRB, 0.17562008E-05_JPRB, 0.17559719E-05_JPRB, &
  & 0.17558615E-05_JPRB, 0.17558817E-05_JPRB, 0.17560294E-05_JPRB, 0.17562754E-05_JPRB, 0.17565815E-05_JPRB, 0.17568671E-05_JPRB, &
  & 0.17570532E-05_JPRB, 0.17571108E-05_JPRB, 0.17570480E-05_JPRB, 0.17569082E-05_JPRB, 0.17567230E-05_JPRB, 0.17565222E-05_JPRB, &
  & 0.17562944E-05_JPRB, 0.17560354E-05_JPRB, 0.17557126E-05_JPRB, 0.17552879E-05_JPRB, 0.17547750E-05_JPRB, 0.17541911E-05_JPRB, &
  & 0.17536083E-05_JPRB, 0.17529924E-05_JPRB, 0.17522758E-05_JPRB, 0.17508401E-05_JPRB /)

RGHG2(:,53,10) = (/ &
  & 0.17514667E-05_JPRB, 0.17529898E-05_JPRB, 0.17539926E-05_JPRB, 0.17550267E-05_JPRB, 0.17562459E-05_JPRB, 0.17572904E-05_JPRB, &
  & 0.17578616E-05_JPRB, 0.17580977E-05_JPRB, 0.17581810E-05_JPRB, 0.17581904E-05_JPRB, 0.17581492E-05_JPRB, 0.17580508E-05_JPRB, &
  & 0.17578739E-05_JPRB, 0.17575653E-05_JPRB, 0.17570237E-05_JPRB, 0.17562503E-05_JPRB, 0.17552238E-05_JPRB, 0.17541265E-05_JPRB, &
  & 0.17530375E-05_JPRB, 0.17520588E-05_JPRB, 0.17512843E-05_JPRB, 0.17508168E-05_JPRB, 0.17507167E-05_JPRB, 0.17509822E-05_JPRB, &
  & 0.17515508E-05_JPRB, 0.17523162E-05_JPRB, 0.17532086E-05_JPRB, 0.17541558E-05_JPRB, 0.17551371E-05_JPRB, 0.17561044E-05_JPRB, &
  & 0.17570096E-05_JPRB, 0.17577662E-05_JPRB, 0.17582787E-05_JPRB, 0.17585073E-05_JPRB, 0.17584728E-05_JPRB, 0.17582456E-05_JPRB, &
  & 0.17578985E-05_JPRB, 0.17574996E-05_JPRB, 0.17570987E-05_JPRB, 0.17567315E-05_JPRB, 0.17564359E-05_JPRB, 0.17562513E-05_JPRB, &
  & 0.17562148E-05_JPRB, 0.17563369E-05_JPRB, 0.17565992E-05_JPRB, 0.17569893E-05_JPRB, 0.17574448E-05_JPRB, 0.17578977E-05_JPRB, &
  & 0.17582759E-05_JPRB, 0.17585472E-05_JPRB, 0.17587181E-05_JPRB, 0.17588073E-05_JPRB, 0.17588379E-05_JPRB, 0.17588278E-05_JPRB, &
  & 0.17587863E-05_JPRB, 0.17587075E-05_JPRB, 0.17585799E-05_JPRB, 0.17583877E-05_JPRB, 0.17581145E-05_JPRB, 0.17577968E-05_JPRB, &
  & 0.17574537E-05_JPRB, 0.17570992E-05_JPRB, 0.17566329E-05_JPRB, 0.17556588E-05_JPRB /)

RGHG2(:,54,10) = (/ &
  & 0.17551525E-05_JPRB, 0.17562832E-05_JPRB, 0.17569583E-05_JPRB, 0.17577219E-05_JPRB, 0.17585464E-05_JPRB, 0.17592265E-05_JPRB, &
  & 0.17595410E-05_JPRB, 0.17596512E-05_JPRB, 0.17596687E-05_JPRB, 0.17596406E-05_JPRB, 0.17595744E-05_JPRB, 0.17594651E-05_JPRB, &
  & 0.17592772E-05_JPRB, 0.17589557E-05_JPRB, 0.17584318E-05_JPRB, 0.17575835E-05_JPRB, 0.17565221E-05_JPRB, 0.17553143E-05_JPRB, &
  & 0.17540945E-05_JPRB, 0.17529501E-05_JPRB, 0.17519908E-05_JPRB, 0.17513380E-05_JPRB, 0.17510833E-05_JPRB, 0.17512392E-05_JPRB, &
  & 0.17517381E-05_JPRB, 0.17524768E-05_JPRB, 0.17533540E-05_JPRB, 0.17543194E-05_JPRB, 0.17553198E-05_JPRB, 0.17563135E-05_JPRB, &
  & 0.17572416E-05_JPRB, 0.17580090E-05_JPRB, 0.17585256E-05_JPRB, 0.17587519E-05_JPRB, 0.17587097E-05_JPRB, 0.17584716E-05_JPRB, &
  & 0.17581144E-05_JPRB, 0.17577084E-05_JPRB, 0.17573060E-05_JPRB, 0.17569466E-05_JPRB, 0.17566699E-05_JPRB, 0.17565267E-05_JPRB, &
  & 0.17565566E-05_JPRB, 0.17567625E-05_JPRB, 0.17571452E-05_JPRB, 0.17576441E-05_JPRB, 0.17582274E-05_JPRB, 0.17587989E-05_JPRB, &
  & 0.17592938E-05_JPRB, 0.17596792E-05_JPRB, 0.17599618E-05_JPRB, 0.17601535E-05_JPRB, 0.17602786E-05_JPRB, 0.17603496E-05_JPRB, &
  & 0.17603886E-05_JPRB, 0.17603954E-05_JPRB, 0.17603677E-05_JPRB, 0.17602943E-05_JPRB, 0.17601735E-05_JPRB, 0.17600169E-05_JPRB, &
  & 0.17598552E-05_JPRB, 0.17596959E-05_JPRB, 0.17595409E-05_JPRB, 0.17593303E-05_JPRB /)

RGHG2(:,55,10) = (/ &
  & 0.17576887E-05_JPRB, 0.17585352E-05_JPRB, 0.17590958E-05_JPRB, 0.17596051E-05_JPRB, 0.17601790E-05_JPRB, 0.17605742E-05_JPRB, &
  & 0.17607410E-05_JPRB, 0.17607756E-05_JPRB, 0.17607583E-05_JPRB, 0.17607126E-05_JPRB, 0.17606424E-05_JPRB, 0.17605304E-05_JPRB, &
  & 0.17603556E-05_JPRB, 0.17600585E-05_JPRB, 0.17595360E-05_JPRB, 0.17587404E-05_JPRB, 0.17576243E-05_JPRB, 0.17563542E-05_JPRB, &
  & 0.17550290E-05_JPRB, 0.17537448E-05_JPRB, 0.17526265E-05_JPRB, 0.17518207E-05_JPRB, 0.17514385E-05_JPRB, 0.17515014E-05_JPRB, &
  & 0.17519405E-05_JPRB, 0.17526402E-05_JPRB, 0.17535131E-05_JPRB, 0.17544839E-05_JPRB, 0.17555102E-05_JPRB, 0.17565307E-05_JPRB, &
  & 0.17574812E-05_JPRB, 0.17582622E-05_JPRB, 0.17587832E-05_JPRB, 0.17590095E-05_JPRB, 0.17589615E-05_JPRB, 0.17587139E-05_JPRB, &
  & 0.17583468E-05_JPRB, 0.17579328E-05_JPRB, 0.17575276E-05_JPRB, 0.17571726E-05_JPRB, 0.17569149E-05_JPRB, 0.17568077E-05_JPRB, &
  & 0.17568927E-05_JPRB, 0.17571872E-05_JPRB, 0.17576500E-05_JPRB, 0.17582665E-05_JPRB, 0.17589443E-05_JPRB, 0.17596078E-05_JPRB, &
  & 0.17601758E-05_JPRB, 0.17606292E-05_JPRB, 0.17609632E-05_JPRB, 0.17611999E-05_JPRB, 0.17613540E-05_JPRB, 0.17614620E-05_JPRB, &
  & 0.17615273E-05_JPRB, 0.17615704E-05_JPRB, 0.17615865E-05_JPRB, 0.17615714E-05_JPRB, 0.17615189E-05_JPRB, 0.17614395E-05_JPRB, &
  & 0.17613463E-05_JPRB, 0.17612458E-05_JPRB, 0.17611217E-05_JPRB, 0.17608957E-05_JPRB /)

RGHG2(:,56,10) = (/ &
  & 0.17596296E-05_JPRB, 0.17603022E-05_JPRB, 0.17606587E-05_JPRB, 0.17610390E-05_JPRB, 0.17613850E-05_JPRB, 0.17616172E-05_JPRB, &
  & 0.17616837E-05_JPRB, 0.17616771E-05_JPRB, 0.17616430E-05_JPRB, 0.17615921E-05_JPRB, 0.17615209E-05_JPRB, 0.17614204E-05_JPRB, &
  & 0.17612579E-05_JPRB, 0.17609889E-05_JPRB, 0.17605246E-05_JPRB, 0.17597290E-05_JPRB, 0.17586290E-05_JPRB, 0.17572945E-05_JPRB, &
  & 0.17558668E-05_JPRB, 0.17544583E-05_JPRB, 0.17532088E-05_JPRB, 0.17522791E-05_JPRB, 0.17517967E-05_JPRB, 0.17517812E-05_JPRB, &
  & 0.17521613E-05_JPRB, 0.17528281E-05_JPRB, 0.17536835E-05_JPRB, 0.17546664E-05_JPRB, 0.17557127E-05_JPRB, 0.17567609E-05_JPRB, &
  & 0.17577345E-05_JPRB, 0.17585282E-05_JPRB, 0.17590578E-05_JPRB, 0.17592856E-05_JPRB, 0.17592331E-05_JPRB, 0.17589783E-05_JPRB, &
  & 0.17586027E-05_JPRB, 0.17581799E-05_JPRB, 0.17577692E-05_JPRB, 0.17574192E-05_JPRB, 0.17571776E-05_JPRB, 0.17571053E-05_JPRB, &
  & 0.17572440E-05_JPRB, 0.17575958E-05_JPRB, 0.17581533E-05_JPRB, 0.17588441E-05_JPRB, 0.17596133E-05_JPRB, 0.17603470E-05_JPRB, &
  & 0.17609791E-05_JPRB, 0.17614686E-05_JPRB, 0.17618333E-05_JPRB, 0.17620810E-05_JPRB, 0.17622515E-05_JPRB, 0.17623576E-05_JPRB, &
  & 0.17624374E-05_JPRB, 0.17624893E-05_JPRB, 0.17625230E-05_JPRB, 0.17625325E-05_JPRB, 0.17625141E-05_JPRB, 0.17624724E-05_JPRB, &
  & 0.17624177E-05_JPRB, 0.17623554E-05_JPRB, 0.17622823E-05_JPRB, 0.17621512E-05_JPRB /)

RGHG2(:,57,10) = (/ &
  & 0.17611028E-05_JPRB, 0.17616090E-05_JPRB, 0.17619062E-05_JPRB, 0.17621428E-05_JPRB, 0.17623615E-05_JPRB, 0.17624719E-05_JPRB, &
  & 0.17624859E-05_JPRB, 0.17624596E-05_JPRB, 0.17624195E-05_JPRB, 0.17623690E-05_JPRB, 0.17623040E-05_JPRB, 0.17622101E-05_JPRB, &
  & 0.17620695E-05_JPRB, 0.17618261E-05_JPRB, 0.17613972E-05_JPRB, 0.17606643E-05_JPRB, 0.17595405E-05_JPRB, 0.17581499E-05_JPRB, &
  & 0.17566285E-05_JPRB, 0.17551139E-05_JPRB, 0.17537536E-05_JPRB, 0.17527342E-05_JPRB, 0.17521734E-05_JPRB, 0.17520897E-05_JPRB, &
  & 0.17524142E-05_JPRB, 0.17530447E-05_JPRB, 0.17538869E-05_JPRB, 0.17548729E-05_JPRB, 0.17559387E-05_JPRB, 0.17570113E-05_JPRB, &
  & 0.17580057E-05_JPRB, 0.17588155E-05_JPRB, 0.17593563E-05_JPRB, 0.17595879E-05_JPRB, 0.17595332E-05_JPRB, 0.17592730E-05_JPRB, &
  & 0.17588892E-05_JPRB, 0.17584571E-05_JPRB, 0.17580414E-05_JPRB, 0.17576923E-05_JPRB, 0.17574690E-05_JPRB, 0.17574284E-05_JPRB, &
  & 0.17576109E-05_JPRB, 0.17580251E-05_JPRB, 0.17586365E-05_JPRB, 0.17594041E-05_JPRB, 0.17602392E-05_JPRB, 0.17610416E-05_JPRB, &
  & 0.17617184E-05_JPRB, 0.17622510E-05_JPRB, 0.17626264E-05_JPRB, 0.17628812E-05_JPRB, 0.17630391E-05_JPRB, 0.17631507E-05_JPRB, &
  & 0.17632217E-05_JPRB, 0.17632767E-05_JPRB, 0.17633135E-05_JPRB, 0.17633306E-05_JPRB, 0.17633249E-05_JPRB, 0.17632993E-05_JPRB, &
  & 0.17632613E-05_JPRB, 0.17632141E-05_JPRB, 0.17631505E-05_JPRB, 0.17630250E-05_JPRB /)

RGHG2(:,58,10) = (/ &
  & 0.17623745E-05_JPRB, 0.17627316E-05_JPRB, 0.17629102E-05_JPRB, 0.17630705E-05_JPRB, 0.17631878E-05_JPRB, 0.17632321E-05_JPRB, &
  & 0.17632176E-05_JPRB, 0.17631828E-05_JPRB, 0.17631431E-05_JPRB, 0.17630964E-05_JPRB, 0.17630366E-05_JPRB, 0.17629552E-05_JPRB, &
  & 0.17628238E-05_JPRB, 0.17626120E-05_JPRB, 0.17622149E-05_JPRB, 0.17615087E-05_JPRB, 0.17603928E-05_JPRB, 0.17589376E-05_JPRB, &
  & 0.17573336E-05_JPRB, 0.17557245E-05_JPRB, 0.17542953E-05_JPRB, 0.17532069E-05_JPRB, 0.17525814E-05_JPRB, 0.17524371E-05_JPRB, &
  & 0.17527105E-05_JPRB, 0.17533054E-05_JPRB, 0.17541322E-05_JPRB, 0.17551176E-05_JPRB, 0.17561986E-05_JPRB, 0.17572910E-05_JPRB, &
  & 0.17583039E-05_JPRB, 0.17591335E-05_JPRB, 0.17596875E-05_JPRB, 0.17599251E-05_JPRB, 0.17598713E-05_JPRB, 0.17596078E-05_JPRB, &
  & 0.17592160E-05_JPRB, 0.17587743E-05_JPRB, 0.17583504E-05_JPRB, 0.17580048E-05_JPRB, 0.17577938E-05_JPRB, 0.17577831E-05_JPRB, &
  & 0.17580082E-05_JPRB, 0.17584674E-05_JPRB, 0.17591339E-05_JPRB, 0.17599507E-05_JPRB, 0.17608402E-05_JPRB, 0.17616957E-05_JPRB, &
  & 0.17624315E-05_JPRB, 0.17629889E-05_JPRB, 0.17633813E-05_JPRB, 0.17636257E-05_JPRB, 0.17637832E-05_JPRB, 0.17638770E-05_JPRB, &
  & 0.17639468E-05_JPRB, 0.17639943E-05_JPRB, 0.17640277E-05_JPRB, 0.17640441E-05_JPRB, 0.17640405E-05_JPRB, 0.17640200E-05_JPRB, &
  & 0.17639890E-05_JPRB, 0.17639506E-05_JPRB, 0.17639009E-05_JPRB, 0.17638033E-05_JPRB /)

RGHG2(:,59,10) = (/ &
  & 0.17633192E-05_JPRB, 0.17636203E-05_JPRB, 0.17637686E-05_JPRB, 0.17638695E-05_JPRB, 0.17639309E-05_JPRB, 0.17639393E-05_JPRB, &
  & 0.17639131E-05_JPRB, 0.17638787E-05_JPRB, 0.17638425E-05_JPRB, 0.17638010E-05_JPRB, 0.17637492E-05_JPRB, 0.17636735E-05_JPRB, &
  & 0.17635602E-05_JPRB, 0.17633529E-05_JPRB, 0.17629911E-05_JPRB, 0.17622981E-05_JPRB, 0.17611706E-05_JPRB, 0.17596692E-05_JPRB, &
  & 0.17579915E-05_JPRB, 0.17563324E-05_JPRB, 0.17548471E-05_JPRB, 0.17537134E-05_JPRB, 0.17530364E-05_JPRB, 0.17528356E-05_JPRB, &
  & 0.17530606E-05_JPRB, 0.17536222E-05_JPRB, 0.17544320E-05_JPRB, 0.17554146E-05_JPRB, 0.17565052E-05_JPRB, 0.17576098E-05_JPRB, &
  & 0.17586437E-05_JPRB, 0.17594921E-05_JPRB, 0.17600622E-05_JPRB, 0.17603073E-05_JPRB, 0.17602561E-05_JPRB, 0.17599904E-05_JPRB, &
  & 0.17595913E-05_JPRB, 0.17591392E-05_JPRB, 0.17587092E-05_JPRB, 0.17583599E-05_JPRB, 0.17581617E-05_JPRB, 0.17581767E-05_JPRB, &
  & 0.17584373E-05_JPRB, 0.17589400E-05_JPRB, 0.17596482E-05_JPRB, 0.17605012E-05_JPRB, 0.17614315E-05_JPRB, 0.17623321E-05_JPRB, &
  & 0.17631087E-05_JPRB, 0.17637065E-05_JPRB, 0.17641063E-05_JPRB, 0.17643514E-05_JPRB, 0.17644909E-05_JPRB, 0.17645827E-05_JPRB, &
  & 0.17646391E-05_JPRB, 0.17646800E-05_JPRB, 0.17647055E-05_JPRB, 0.17647147E-05_JPRB, 0.17647063E-05_JPRB, 0.17646839E-05_JPRB, &
  & 0.17646527E-05_JPRB, 0.17646147E-05_JPRB, 0.17645639E-05_JPRB, 0.17644650E-05_JPRB /)

RGHG2(:,60,10) = (/ &
  & 0.17641919E-05_JPRB, 0.17644361E-05_JPRB, 0.17645380E-05_JPRB, 0.17646039E-05_JPRB, 0.17646330E-05_JPRB, 0.17646250E-05_JPRB, &
  & 0.17645966E-05_JPRB, 0.17645652E-05_JPRB, 0.17645348E-05_JPRB, 0.17644995E-05_JPRB, 0.17644536E-05_JPRB, 0.17643883E-05_JPRB, &
  & 0.17642765E-05_JPRB, 0.17640916E-05_JPRB, 0.17637165E-05_JPRB, 0.17630418E-05_JPRB, 0.17618879E-05_JPRB, 0.17603486E-05_JPRB, &
  & 0.17586426E-05_JPRB, 0.17569440E-05_JPRB, 0.17554361E-05_JPRB, 0.17542685E-05_JPRB, 0.17535463E-05_JPRB, 0.17532974E-05_JPRB, &
  & 0.17534780E-05_JPRB, 0.17540086E-05_JPRB, 0.17547994E-05_JPRB, 0.17557763E-05_JPRB, 0.17568682E-05_JPRB, 0.17579857E-05_JPRB, &
  & 0.17590356E-05_JPRB, 0.17599049E-05_JPRB, 0.17604898E-05_JPRB, 0.17607440E-05_JPRB, 0.17606966E-05_JPRB, 0.17604287E-05_JPRB, &
  & 0.17600217E-05_JPRB, 0.17595615E-05_JPRB, 0.17591220E-05_JPRB, 0.17587705E-05_JPRB, 0.17585795E-05_JPRB, 0.17586149E-05_JPRB, &
  & 0.17589076E-05_JPRB, 0.17594469E-05_JPRB, 0.17601891E-05_JPRB, 0.17610737E-05_JPRB, 0.17620243E-05_JPRB, 0.17629585E-05_JPRB, &
  & 0.17637733E-05_JPRB, 0.17644034E-05_JPRB, 0.17648169E-05_JPRB, 0.17650564E-05_JPRB, 0.17651944E-05_JPRB, 0.17652715E-05_JPRB, &
  & 0.17653222E-05_JPRB, 0.17653526E-05_JPRB, 0.17653679E-05_JPRB, 0.17653665E-05_JPRB, 0.17653488E-05_JPRB, 0.17653197E-05_JPRB, &
  & 0.17652842E-05_JPRB, 0.17652438E-05_JPRB, 0.17651932E-05_JPRB, 0.17650963E-05_JPRB /)

RGHG2(:,61,10) = (/ &
  & 0.17649540E-05_JPRB, 0.17651689E-05_JPRB, 0.17652560E-05_JPRB, 0.17653015E-05_JPRB, 0.17653147E-05_JPRB, 0.17653022E-05_JPRB, &
  & 0.17652773E-05_JPRB, 0.17652517E-05_JPRB, 0.17652281E-05_JPRB, 0.17651998E-05_JPRB, 0.17651621E-05_JPRB, 0.17651018E-05_JPRB, &
  & 0.17650030E-05_JPRB, 0.17648055E-05_JPRB, 0.17644450E-05_JPRB, 0.17637278E-05_JPRB, 0.17625592E-05_JPRB, 0.17610132E-05_JPRB, &
  & 0.17592948E-05_JPRB, 0.17575948E-05_JPRB, 0.17560725E-05_JPRB, 0.17548821E-05_JPRB, 0.17541273E-05_JPRB, 0.17538367E-05_JPRB, &
  & 0.17539778E-05_JPRB, 0.17544774E-05_JPRB, 0.17552485E-05_JPRB, 0.17562165E-05_JPRB, 0.17573075E-05_JPRB, 0.17584312E-05_JPRB, &
  & 0.17594995E-05_JPRB, 0.17603841E-05_JPRB, 0.17609826E-05_JPRB, 0.17612454E-05_JPRB, 0.17612012E-05_JPRB, 0.17609300E-05_JPRB, &
  & 0.17605169E-05_JPRB, 0.17600472E-05_JPRB, 0.17595994E-05_JPRB, 0.17592417E-05_JPRB, 0.17590556E-05_JPRB, 0.17591077E-05_JPRB, &
  & 0.17594257E-05_JPRB, 0.17599956E-05_JPRB, 0.17607680E-05_JPRB, 0.17616725E-05_JPRB, 0.17626439E-05_JPRB, 0.17635882E-05_JPRB, &
  & 0.17644328E-05_JPRB, 0.17650847E-05_JPRB, 0.17655221E-05_JPRB, 0.17657644E-05_JPRB, 0.17658931E-05_JPRB, 0.17659663E-05_JPRB, &
  & 0.17660060E-05_JPRB, 0.17660263E-05_JPRB, 0.17660288E-05_JPRB, 0.17660136E-05_JPRB, 0.17659825E-05_JPRB, 0.17659419E-05_JPRB, &
  & 0.17658977E-05_JPRB, 0.17658497E-05_JPRB, 0.17657906E-05_JPRB, 0.17656835E-05_JPRB /)

RGHG2(:,62,10) = (/ &
  & 0.17656942E-05_JPRB, 0.17658829E-05_JPRB, 0.17659522E-05_JPRB, 0.17659863E-05_JPRB, 0.17659930E-05_JPRB, 0.17659813E-05_JPRB, &
  & 0.17659612E-05_JPRB, 0.17659424E-05_JPRB, 0.17659268E-05_JPRB, 0.17659067E-05_JPRB, 0.17658772E-05_JPRB, 0.17658274E-05_JPRB, &
  & 0.17657287E-05_JPRB, 0.17655393E-05_JPRB, 0.17651419E-05_JPRB, 0.17644011E-05_JPRB, 0.17632179E-05_JPRB, 0.17616807E-05_JPRB, &
  & 0.17599863E-05_JPRB, 0.17582915E-05_JPRB, 0.17567693E-05_JPRB, 0.17555706E-05_JPRB, 0.17547929E-05_JPRB, 0.17544710E-05_JPRB, &
  & 0.17545761E-05_JPRB, 0.17550466E-05_JPRB, 0.17557966E-05_JPRB, 0.17567535E-05_JPRB, 0.17578384E-05_JPRB, 0.17589703E-05_JPRB, &
  & 0.17600481E-05_JPRB, 0.17609460E-05_JPRB, 0.17615547E-05_JPRB, 0.17618225E-05_JPRB, 0.17617790E-05_JPRB, 0.17615050E-05_JPRB, &
  & 0.17610859E-05_JPRB, 0.17606078E-05_JPRB, 0.17601502E-05_JPRB, 0.17597866E-05_JPRB, 0.17596024E-05_JPRB, 0.17596644E-05_JPRB, &
  & 0.17600019E-05_JPRB, 0.17605960E-05_JPRB, 0.17613909E-05_JPRB, 0.17623142E-05_JPRB, 0.17632910E-05_JPRB, 0.17642458E-05_JPRB, &
  & 0.17650895E-05_JPRB, 0.17657740E-05_JPRB, 0.17662222E-05_JPRB, 0.17664786E-05_JPRB, 0.17666088E-05_JPRB, 0.17666737E-05_JPRB, &
  & 0.17667044E-05_JPRB, 0.17667118E-05_JPRB, 0.17666982E-05_JPRB, 0.17666646E-05_JPRB, 0.17666159E-05_JPRB, 0.17665607E-05_JPRB, &
  & 0.17665035E-05_JPRB, 0.17664441E-05_JPRB, 0.17663749E-05_JPRB, 0.17662480E-05_JPRB /)

RGHG2(:,63,10) = (/ &
  & 0.17663867E-05_JPRB, 0.17665723E-05_JPRB, 0.17666391E-05_JPRB, 0.17666694E-05_JPRB, 0.17666744E-05_JPRB, 0.17666650E-05_JPRB, &
  & 0.17666498E-05_JPRB, 0.17666366E-05_JPRB, 0.17666295E-05_JPRB, 0.17666184E-05_JPRB, 0.17665993E-05_JPRB, 0.17665589E-05_JPRB, &
  & 0.17664690E-05_JPRB, 0.17662652E-05_JPRB, 0.17658429E-05_JPRB, 0.17650748E-05_JPRB, 0.17638893E-05_JPRB, 0.17623950E-05_JPRB, &
  & 0.17607282E-05_JPRB, 0.17590544E-05_JPRB, 0.17575437E-05_JPRB, 0.17563481E-05_JPRB, 0.17555631E-05_JPRB, 0.17552178E-05_JPRB, &
  & 0.17552935E-05_JPRB, 0.17557358E-05_JPRB, 0.17564639E-05_JPRB, 0.17574072E-05_JPRB, 0.17584860E-05_JPRB, 0.17596183E-05_JPRB, &
  & 0.17607020E-05_JPRB, 0.17616044E-05_JPRB, 0.17622169E-05_JPRB, 0.17624860E-05_JPRB, 0.17624416E-05_JPRB, 0.17621639E-05_JPRB, &
  & 0.17617401E-05_JPRB, 0.17612549E-05_JPRB, 0.17607877E-05_JPRB, 0.17604166E-05_JPRB, 0.17602309E-05_JPRB, 0.17602988E-05_JPRB, &
  & 0.17606474E-05_JPRB, 0.17612572E-05_JPRB, 0.17620683E-05_JPRB, 0.17630018E-05_JPRB, 0.17639833E-05_JPRB, 0.17649315E-05_JPRB, &
  & 0.17657806E-05_JPRB, 0.17664584E-05_JPRB, 0.17669402E-05_JPRB, 0.17672071E-05_JPRB, 0.17673422E-05_JPRB, 0.17674047E-05_JPRB, &
  & 0.17674249E-05_JPRB, 0.17674174E-05_JPRB, 0.17673842E-05_JPRB, 0.17673285E-05_JPRB, 0.17672571E-05_JPRB, 0.17671805E-05_JPRB, &
  & 0.17671050E-05_JPRB, 0.17670277E-05_JPRB, 0.17669361E-05_JPRB, 0.17667779E-05_JPRB /)

RGHG2(:,64,10) = (/ &
  & 0.17670717E-05_JPRB, 0.17672601E-05_JPRB, 0.17673265E-05_JPRB, 0.17673557E-05_JPRB, 0.17673609E-05_JPRB, 0.17673540E-05_JPRB, &
  & 0.17673411E-05_JPRB, 0.17673328E-05_JPRB, 0.17673340E-05_JPRB, 0.17673331E-05_JPRB, 0.17673267E-05_JPRB, 0.17672996E-05_JPRB, &
  & 0.17672163E-05_JPRB, 0.17670028E-05_JPRB, 0.17665621E-05_JPRB, 0.17657692E-05_JPRB, 0.17646178E-05_JPRB, 0.17631593E-05_JPRB, &
  & 0.17615332E-05_JPRB, 0.17598892E-05_JPRB, 0.17584065E-05_JPRB, 0.17572274E-05_JPRB, 0.17564478E-05_JPRB, 0.17560906E-05_JPRB, &
  & 0.17561426E-05_JPRB, 0.17565592E-05_JPRB, 0.17572639E-05_JPRB, 0.17581903E-05_JPRB, 0.17592573E-05_JPRB, 0.17603834E-05_JPRB, &
  & 0.17614622E-05_JPRB, 0.17623609E-05_JPRB, 0.17629679E-05_JPRB, 0.17632331E-05_JPRB, 0.17631862E-05_JPRB, 0.17629069E-05_JPRB, &
  & 0.17624819E-05_JPRB, 0.17619919E-05_JPRB, 0.17615178E-05_JPRB, 0.17611392E-05_JPRB, 0.17609497E-05_JPRB, 0.17610171E-05_JPRB, &
  & 0.17613694E-05_JPRB, 0.17619863E-05_JPRB, 0.17628041E-05_JPRB, 0.17637400E-05_JPRB, 0.17647180E-05_JPRB, 0.17656589E-05_JPRB, &
  & 0.17664923E-05_JPRB, 0.17671744E-05_JPRB, 0.17676591E-05_JPRB, 0.17679497E-05_JPRB, 0.17680951E-05_JPRB, 0.17681564E-05_JPRB, &
  & 0.17681673E-05_JPRB, 0.17681432E-05_JPRB, 0.17680885E-05_JPRB, 0.17680063E-05_JPRB, 0.17679088E-05_JPRB, 0.17678074E-05_JPRB, &
  & 0.17677064E-05_JPRB, 0.17676020E-05_JPRB, 0.17674812E-05_JPRB, 0.17672637E-05_JPRB /)

RGHG2(:,65,10) = (/ &
  & 0.17677496E-05_JPRB, 0.17679492E-05_JPRB, 0.17680184E-05_JPRB, 0.17680500E-05_JPRB, 0.17680559E-05_JPRB, 0.17680502E-05_JPRB, &
  & 0.17680391E-05_JPRB, 0.17680325E-05_JPRB, 0.17680424E-05_JPRB, 0.17680533E-05_JPRB, 0.17680611E-05_JPRB, 0.17680482E-05_JPRB, &
  & 0.17679678E-05_JPRB, 0.17677464E-05_JPRB, 0.17672820E-05_JPRB, 0.17665083E-05_JPRB, 0.17653886E-05_JPRB, 0.17639829E-05_JPRB, &
  & 0.17624051E-05_JPRB, 0.17608096E-05_JPRB, 0.17593642E-05_JPRB, 0.17582207E-05_JPRB, 0.17574562E-05_JPRB, 0.17570962E-05_JPRB, &
  & 0.17571315E-05_JPRB, 0.17575222E-05_JPRB, 0.17582006E-05_JPRB, 0.17591024E-05_JPRB, 0.17601499E-05_JPRB, 0.17612564E-05_JPRB, &
  & 0.17623188E-05_JPRB, 0.17632009E-05_JPRB, 0.17637932E-05_JPRB, 0.17640505E-05_JPRB, 0.17640012E-05_JPRB, 0.17637253E-05_JPRB, &
  & 0.17633043E-05_JPRB, 0.17628174E-05_JPRB, 0.17623405E-05_JPRB, 0.17619585E-05_JPRB, 0.17617639E-05_JPRB, 0.17618262E-05_JPRB, &
  & 0.17621747E-05_JPRB, 0.17627883E-05_JPRB, 0.17636023E-05_JPRB, 0.17645317E-05_JPRB, 0.17654971E-05_JPRB, 0.17664236E-05_JPRB, &
  & 0.17672426E-05_JPRB, 0.17679100E-05_JPRB, 0.17684005E-05_JPRB, 0.17687048E-05_JPRB, 0.17688615E-05_JPRB, 0.17689273E-05_JPRB, &
  & 0.17689297E-05_JPRB, 0.17688890E-05_JPRB, 0.17688110E-05_JPRB, 0.17687039E-05_JPRB, 0.17685790E-05_JPRB, 0.17684478E-05_JPRB, &
  & 0.17683151E-05_JPRB, 0.17681753E-05_JPRB, 0.17680036E-05_JPRB, 0.17677055E-05_JPRB /)

RGHG2(:,66,10) = (/ &
  & 0.17683994E-05_JPRB, 0.17686323E-05_JPRB, 0.17687159E-05_JPRB, 0.17687537E-05_JPRB, 0.17687628E-05_JPRB, 0.17687596E-05_JPRB, &
  & 0.17687480E-05_JPRB, 0.17687423E-05_JPRB, 0.17687629E-05_JPRB, 0.17687846E-05_JPRB, 0.17688093E-05_JPRB, 0.17688092E-05_JPRB, &
  & 0.17687332E-05_JPRB, 0.17685074E-05_JPRB, 0.17680528E-05_JPRB, 0.17672943E-05_JPRB, 0.17662170E-05_JPRB, 0.17648669E-05_JPRB, &
  & 0.17633529E-05_JPRB, 0.17618165E-05_JPRB, 0.17604316E-05_JPRB, 0.17593295E-05_JPRB, 0.17585927E-05_JPRB, 0.17582372E-05_JPRB, &
  & 0.17582569E-05_JPRB, 0.17586207E-05_JPRB, 0.17592645E-05_JPRB, 0.17601317E-05_JPRB, 0.17611462E-05_JPRB, 0.17622190E-05_JPRB, &
  & 0.17632510E-05_JPRB, 0.17641039E-05_JPRB, 0.17646735E-05_JPRB, 0.17649188E-05_JPRB, 0.17648698E-05_JPRB, 0.17646034E-05_JPRB, &
  & 0.17641952E-05_JPRB, 0.17637203E-05_JPRB, 0.17632522E-05_JPRB, 0.17628716E-05_JPRB, 0.17626746E-05_JPRB, 0.17627291E-05_JPRB, &
  & 0.17630680E-05_JPRB, 0.17636681E-05_JPRB, 0.17644669E-05_JPRB, 0.17653779E-05_JPRB, 0.17663232E-05_JPRB, 0.17672269E-05_JPRB, &
  & 0.17680245E-05_JPRB, 0.17686763E-05_JPRB, 0.17691614E-05_JPRB, 0.17694715E-05_JPRB, 0.17696414E-05_JPRB, 0.17697106E-05_JPRB, &
  & 0.17697067E-05_JPRB, 0.17696516E-05_JPRB, 0.17695558E-05_JPRB, 0.17694264E-05_JPRB, 0.17692773E-05_JPRB, 0.17691173E-05_JPRB, &
  & 0.17689476E-05_JPRB, 0.17687591E-05_JPRB, 0.17685255E-05_JPRB, 0.17680949E-05_JPRB /)

RGHG2(:,67,10) = (/ &
  & 0.17690362E-05_JPRB, 0.17693235E-05_JPRB, 0.17694248E-05_JPRB, 0.17694730E-05_JPRB, 0.17694873E-05_JPRB, 0.17694879E-05_JPRB, &
  & 0.17694780E-05_JPRB, 0.17694720E-05_JPRB, 0.17694999E-05_JPRB, 0.17695378E-05_JPRB, 0.17695743E-05_JPRB, 0.17695833E-05_JPRB, &
  & 0.17695075E-05_JPRB, 0.17692824E-05_JPRB, 0.17688359E-05_JPRB, 0.17681105E-05_JPRB, 0.17670895E-05_JPRB, 0.17658112E-05_JPRB, &
  & 0.17643740E-05_JPRB, 0.17629176E-05_JPRB, 0.17616001E-05_JPRB, 0.17605551E-05_JPRB, 0.17598489E-05_JPRB, 0.17595013E-05_JPRB, &
  & 0.17595066E-05_JPRB, 0.17598371E-05_JPRB, 0.17604394E-05_JPRB, 0.17612604E-05_JPRB, 0.17622275E-05_JPRB, 0.17632532E-05_JPRB, &
  & 0.17642410E-05_JPRB, 0.17650557E-05_JPRB, 0.17655943E-05_JPRB, 0.17658261E-05_JPRB, 0.17657795E-05_JPRB, 0.17655282E-05_JPRB, &
  & 0.17651419E-05_JPRB, 0.17646888E-05_JPRB, 0.17642396E-05_JPRB, 0.17638713E-05_JPRB, 0.17636762E-05_JPRB, 0.17637250E-05_JPRB, &
  & 0.17640486E-05_JPRB, 0.17646281E-05_JPRB, 0.17654008E-05_JPRB, 0.17662812E-05_JPRB, 0.17671958E-05_JPRB, 0.17680686E-05_JPRB, &
  & 0.17688403E-05_JPRB, 0.17694716E-05_JPRB, 0.17699455E-05_JPRB, 0.17702566E-05_JPRB, 0.17704288E-05_JPRB, 0.17705038E-05_JPRB, &
  & 0.17704958E-05_JPRB, 0.17704308E-05_JPRB, 0.17703204E-05_JPRB, 0.17701761E-05_JPRB, 0.17700090E-05_JPRB, 0.17698214E-05_JPRB, &
  & 0.17696163E-05_JPRB, 0.17693748E-05_JPRB, 0.17690538E-05_JPRB, 0.17684597E-05_JPRB /)

RGHG2(:,68,10) = (/ &
  & 0.17696684E-05_JPRB, 0.17700247E-05_JPRB, 0.17701534E-05_JPRB, 0.17702142E-05_JPRB, 0.17702355E-05_JPRB, 0.17702409E-05_JPRB, &
  & 0.17702331E-05_JPRB, 0.17702275E-05_JPRB, 0.17702687E-05_JPRB, 0.17703139E-05_JPRB, 0.17703622E-05_JPRB, 0.17703757E-05_JPRB, &
  & 0.17703034E-05_JPRB, 0.17700906E-05_JPRB, 0.17696646E-05_JPRB, 0.17689753E-05_JPRB, 0.17680119E-05_JPRB, 0.17668128E-05_JPRB, &
  & 0.17654665E-05_JPRB, 0.17641014E-05_JPRB, 0.17628649E-05_JPRB, 0.17618785E-05_JPRB, 0.17612089E-05_JPRB, 0.17608689E-05_JPRB, &
  & 0.17608578E-05_JPRB, 0.17611526E-05_JPRB, 0.17617048E-05_JPRB, 0.17624707E-05_JPRB, 0.17633791E-05_JPRB, 0.17643457E-05_JPRB, &
  & 0.17652800E-05_JPRB, 0.17660466E-05_JPRB, 0.17665513E-05_JPRB, 0.17667676E-05_JPRB, 0.17667253E-05_JPRB, 0.17664933E-05_JPRB, &
  & 0.17661343E-05_JPRB, 0.17657114E-05_JPRB, 0.17652904E-05_JPRB, 0.17649425E-05_JPRB, 0.17647577E-05_JPRB, 0.17648024E-05_JPRB, &
  & 0.17651122E-05_JPRB, 0.17656652E-05_JPRB, 0.17664011E-05_JPRB, 0.17672439E-05_JPRB, 0.17681147E-05_JPRB, 0.17689512E-05_JPRB, &
  & 0.17696872E-05_JPRB, 0.17702931E-05_JPRB, 0.17707519E-05_JPRB, 0.17710561E-05_JPRB, 0.17712290E-05_JPRB, 0.17713053E-05_JPRB, &
  & 0.17712952E-05_JPRB, 0.17712243E-05_JPRB, 0.17711067E-05_JPRB, 0.17709534E-05_JPRB, 0.17707725E-05_JPRB, 0.17705693E-05_JPRB, &
  & 0.17703293E-05_JPRB, 0.17700410E-05_JPRB, 0.17696319E-05_JPRB, 0.17688543E-05_JPRB /)

RGHG2(:,69,10) = (/ &
  & 0.17703044E-05_JPRB, 0.17707512E-05_JPRB, 0.17709089E-05_JPRB, 0.17709858E-05_JPRB, 0.17710149E-05_JPRB, 0.17710273E-05_JPRB, &
  & 0.17710240E-05_JPRB, 0.17710217E-05_JPRB, 0.17710696E-05_JPRB, 0.17711241E-05_JPRB, 0.17711749E-05_JPRB, 0.17711893E-05_JPRB, &
  & 0.17711179E-05_JPRB, 0.17709100E-05_JPRB, 0.17705072E-05_JPRB, 0.17698654E-05_JPRB, 0.17689752E-05_JPRB, 0.17678666E-05_JPRB, &
  & 0.17666219E-05_JPRB, 0.17653556E-05_JPRB, 0.17642070E-05_JPRB, 0.17632851E-05_JPRB, 0.17626523E-05_JPRB, 0.17623222E-05_JPRB, &
  & 0.17622945E-05_JPRB, 0.17625509E-05_JPRB, 0.17630497E-05_JPRB, 0.17637536E-05_JPRB, 0.17645943E-05_JPRB, 0.17654946E-05_JPRB, &
  & 0.17663651E-05_JPRB, 0.17670784E-05_JPRB, 0.17675447E-05_JPRB, 0.17677452E-05_JPRB, 0.17677073E-05_JPRB, 0.17674972E-05_JPRB, &
  & 0.17671694E-05_JPRB, 0.17667815E-05_JPRB, 0.17663941E-05_JPRB, 0.17660738E-05_JPRB, 0.17659045E-05_JPRB, 0.17659526E-05_JPRB, &
  & 0.17662489E-05_JPRB, 0.17667721E-05_JPRB, 0.17674695E-05_JPRB, 0.17682615E-05_JPRB, 0.17690855E-05_JPRB, 0.17698727E-05_JPRB, &
  & 0.17705704E-05_JPRB, 0.17711449E-05_JPRB, 0.17715827E-05_JPRB, 0.17718756E-05_JPRB, 0.17720440E-05_JPRB, 0.17721204E-05_JPRB, &
  & 0.17721093E-05_JPRB, 0.17720386E-05_JPRB, 0.17719183E-05_JPRB, 0.17717608E-05_JPRB, 0.17715762E-05_JPRB, 0.17713553E-05_JPRB, &
  & 0.17710993E-05_JPRB, 0.17707649E-05_JPRB, 0.17702812E-05_JPRB, 0.17693136E-05_JPRB /)

RGHG2(:,70,10) = (/ &
  & 0.17709610E-05_JPRB, 0.17715066E-05_JPRB, 0.17717016E-05_JPRB, 0.17717944E-05_JPRB, 0.17718332E-05_JPRB, 0.17718544E-05_JPRB, &
  & 0.17718571E-05_JPRB, 0.17718588E-05_JPRB, 0.17719112E-05_JPRB, 0.17719669E-05_JPRB, 0.17720154E-05_JPRB, 0.17720274E-05_JPRB, &
  & 0.17719580E-05_JPRB, 0.17717680E-05_JPRB, 0.17713902E-05_JPRB, 0.17707958E-05_JPRB, 0.17699776E-05_JPRB, 0.17689661E-05_JPRB, &
  & 0.17678268E-05_JPRB, 0.17666691E-05_JPRB, 0.17656101E-05_JPRB, 0.17647576E-05_JPRB, 0.17641637E-05_JPRB, 0.17638451E-05_JPRB, &
  & 0.17638018E-05_JPRB, 0.17640201E-05_JPRB, 0.17644630E-05_JPRB, 0.17651006E-05_JPRB, 0.17658692E-05_JPRB, 0.17666936E-05_JPRB, &
  & 0.17674943E-05_JPRB, 0.17681486E-05_JPRB, 0.17685744E-05_JPRB, 0.17687574E-05_JPRB, 0.17687247E-05_JPRB, 0.17685375E-05_JPRB, &
  & 0.17682426E-05_JPRB, 0.17678929E-05_JPRB, 0.17675427E-05_JPRB, 0.17672546E-05_JPRB, 0.17671071E-05_JPRB, 0.17671607E-05_JPRB, &
  & 0.17674467E-05_JPRB, 0.17679416E-05_JPRB, 0.17685938E-05_JPRB, 0.17693350E-05_JPRB, 0.17701005E-05_JPRB, 0.17708363E-05_JPRB, &
  & 0.17714852E-05_JPRB, 0.17720223E-05_JPRB, 0.17724336E-05_JPRB, 0.17727117E-05_JPRB, 0.17728737E-05_JPRB, 0.17729490E-05_JPRB, &
  & 0.17729407E-05_JPRB, 0.17728762E-05_JPRB, 0.17727584E-05_JPRB, 0.17726042E-05_JPRB, 0.17724175E-05_JPRB, 0.17721947E-05_JPRB, &
  & 0.17719212E-05_JPRB, 0.17715694E-05_JPRB, 0.17710174E-05_JPRB, 0.17699039E-05_JPRB /)

RGHG2(:,71,10) = (/ &
  & 0.17716631E-05_JPRB, 0.17723128E-05_JPRB, 0.17725349E-05_JPRB, 0.17726442E-05_JPRB, 0.17726919E-05_JPRB, 0.17727220E-05_JPRB, &
  & 0.17727318E-05_JPRB, 0.17727374E-05_JPRB, 0.17727903E-05_JPRB, 0.17728403E-05_JPRB, 0.17728821E-05_JPRB, 0.17728867E-05_JPRB, &
  & 0.17728147E-05_JPRB, 0.17726301E-05_JPRB, 0.17722843E-05_JPRB, 0.17717472E-05_JPRB, 0.17710098E-05_JPRB, 0.17700970E-05_JPRB, &
  & 0.17690700E-05_JPRB, 0.17680198E-05_JPRB, 0.17670620E-05_JPRB, 0.17662782E-05_JPRB, 0.17657298E-05_JPRB, 0.17654255E-05_JPRB, &
  & 0.17653700E-05_JPRB, 0.17655514E-05_JPRB, 0.17659358E-05_JPRB, 0.17665046E-05_JPRB, 0.17671946E-05_JPRB, 0.17679395E-05_JPRB, &
  & 0.17686648E-05_JPRB, 0.17692562E-05_JPRB, 0.17696393E-05_JPRB, 0.17698039E-05_JPRB, 0.17697762E-05_JPRB, 0.17696129E-05_JPRB, &
  & 0.17693516E-05_JPRB, 0.17690420E-05_JPRB, 0.17687315E-05_JPRB, 0.17684780E-05_JPRB, 0.17683539E-05_JPRB, 0.17684157E-05_JPRB, &
  & 0.17686925E-05_JPRB, 0.17691571E-05_JPRB, 0.17697641E-05_JPRB, 0.17704484E-05_JPRB, 0.17711528E-05_JPRB, 0.17718290E-05_JPRB, &
  & 0.17724255E-05_JPRB, 0.17729203E-05_JPRB, 0.17733012E-05_JPRB, 0.17735603E-05_JPRB, 0.17737134E-05_JPRB, 0.17737888E-05_JPRB, &
  & 0.17737865E-05_JPRB, 0.17737326E-05_JPRB, 0.17736257E-05_JPRB, 0.17734793E-05_JPRB, 0.17732988E-05_JPRB, 0.17730786E-05_JPRB, &
  & 0.17728073E-05_JPRB, 0.17724433E-05_JPRB, 0.17718651E-05_JPRB, 0.17706448E-05_JPRB /)

RGHG2(:,72,10) = (/ &
  & 0.17724412E-05_JPRB, 0.17731649E-05_JPRB, 0.17734108E-05_JPRB, 0.17735290E-05_JPRB, 0.17735840E-05_JPRB, 0.17736214E-05_JPRB, &
  & 0.17736375E-05_JPRB, 0.17736470E-05_JPRB, 0.17736916E-05_JPRB, 0.17737365E-05_JPRB, 0.17737655E-05_JPRB, 0.17737614E-05_JPRB, &
  & 0.17736916E-05_JPRB, 0.17735257E-05_JPRB, 0.17732066E-05_JPRB, 0.17727205E-05_JPRB, 0.17720627E-05_JPRB, 0.17712514E-05_JPRB, &
  & 0.17703359E-05_JPRB, 0.17694035E-05_JPRB, 0.17685425E-05_JPRB, 0.17678407E-05_JPRB, 0.17673385E-05_JPRB, 0.17670552E-05_JPRB, &
  & 0.17669898E-05_JPRB, 0.17671350E-05_JPRB, 0.17674618E-05_JPRB, 0.17679571E-05_JPRB, 0.17685669E-05_JPRB, 0.17692259E-05_JPRB, &
  & 0.17698709E-05_JPRB, 0.17703959E-05_JPRB, 0.17707345E-05_JPRB, 0.17708813E-05_JPRB, 0.17708592E-05_JPRB, 0.17707185E-05_JPRB, &
  & 0.17704920E-05_JPRB, 0.17702234E-05_JPRB, 0.17699556E-05_JPRB, 0.17697380E-05_JPRB, 0.17696385E-05_JPRB, 0.17697087E-05_JPRB, &
  & 0.17699741E-05_JPRB, 0.17704070E-05_JPRB, 0.17709649E-05_JPRB, 0.17715874E-05_JPRB, 0.17722264E-05_JPRB, 0.17728389E-05_JPRB, &
  & 0.17733769E-05_JPRB, 0.17738253E-05_JPRB, 0.17741714E-05_JPRB, 0.17744094E-05_JPRB, 0.17745538E-05_JPRB, 0.17746286E-05_JPRB, &
  & 0.17746355E-05_JPRB, 0.17745986E-05_JPRB, 0.17745053E-05_JPRB, 0.17743732E-05_JPRB, 0.17742095E-05_JPRB, 0.17739962E-05_JPRB, &
  & 0.17737397E-05_JPRB, 0.17733894E-05_JPRB, 0.17727959E-05_JPRB, 0.17715453E-05_JPRB /)

RGHG2(:,73,10) = (/ &
  & 0.17733323E-05_JPRB, 0.17740689E-05_JPRB, 0.17743159E-05_JPRB, 0.17744344E-05_JPRB, 0.17744916E-05_JPRB, 0.17745328E-05_JPRB, &
  & 0.17745523E-05_JPRB, 0.17745631E-05_JPRB, 0.17746027E-05_JPRB, 0.17746332E-05_JPRB, 0.17746549E-05_JPRB, 0.17746438E-05_JPRB, &
  & 0.17745704E-05_JPRB, 0.17744148E-05_JPRB, 0.17741315E-05_JPRB, 0.17737043E-05_JPRB, 0.17731254E-05_JPRB, 0.17724158E-05_JPRB, &
  & 0.17716166E-05_JPRB, 0.17707976E-05_JPRB, 0.17700484E-05_JPRB, 0.17694263E-05_JPRB, 0.17689800E-05_JPRB, 0.17687195E-05_JPRB, &
  & 0.17686484E-05_JPRB, 0.17687596E-05_JPRB, 0.17690277E-05_JPRB, 0.17694501E-05_JPRB, 0.17699747E-05_JPRB, 0.17705466E-05_JPRB, &
  & 0.17711079E-05_JPRB, 0.17715648E-05_JPRB, 0.17718579E-05_JPRB, 0.17719863E-05_JPRB, 0.17719700E-05_JPRB, 0.17718520E-05_JPRB, &
  & 0.17716604E-05_JPRB, 0.17714350E-05_JPRB, 0.17712084E-05_JPRB, 0.17710265E-05_JPRB, 0.17709522E-05_JPRB, 0.17710286E-05_JPRB, &
  & 0.17712799E-05_JPRB, 0.17716761E-05_JPRB, 0.17721782E-05_JPRB, 0.17727359E-05_JPRB, 0.17733034E-05_JPRB, 0.17738473E-05_JPRB, &
  & 0.17743242E-05_JPRB, 0.17747228E-05_JPRB, 0.17750328E-05_JPRB, 0.17752490E-05_JPRB, 0.17753817E-05_JPRB, 0.17754576E-05_JPRB, &
  & 0.17754718E-05_JPRB, 0.17754485E-05_JPRB, 0.17753762E-05_JPRB, 0.17752632E-05_JPRB, 0.17751127E-05_JPRB, 0.17749295E-05_JPRB, &
  & 0.17746861E-05_JPRB, 0.17743650E-05_JPRB, 0.17738041E-05_JPRB, 0.17725515E-05_JPRB /)

RGHG2(:,74,10) = (/ &
  & 0.17742623E-05_JPRB, 0.17749929E-05_JPRB, 0.17752275E-05_JPRB, 0.17753390E-05_JPRB, 0.17753944E-05_JPRB, 0.17754355E-05_JPRB, &
  & 0.17754568E-05_JPRB, 0.17754687E-05_JPRB, 0.17754960E-05_JPRB, 0.17755231E-05_JPRB, 0.17755347E-05_JPRB, 0.17755175E-05_JPRB, &
  & 0.17754520E-05_JPRB, 0.17753159E-05_JPRB, 0.17750630E-05_JPRB, 0.17746900E-05_JPRB, 0.17741921E-05_JPRB, 0.17735854E-05_JPRB, &
  & 0.17728997E-05_JPRB, 0.17722029E-05_JPRB, 0.17715608E-05_JPRB, 0.17710281E-05_JPRB, 0.17706387E-05_JPRB, 0.17704066E-05_JPRB, &
  & 0.17703333E-05_JPRB, 0.17704142E-05_JPRB, 0.17706265E-05_JPRB, 0.17709752E-05_JPRB, 0.17714151E-05_JPRB, 0.17718966E-05_JPRB, &
  & 0.17723717E-05_JPRB, 0.17727580E-05_JPRB, 0.17730055E-05_JPRB, 0.17731156E-05_JPRB, 0.17731049E-05_JPRB, 0.17730090E-05_JPRB, &
  & 0.17728515E-05_JPRB, 0.17726687E-05_JPRB, 0.17724855E-05_JPRB, 0.17723396E-05_JPRB, 0.17722895E-05_JPRB, 0.17723688E-05_JPRB, &
  & 0.17726009E-05_JPRB, 0.17729520E-05_JPRB, 0.17733950E-05_JPRB, 0.17738799E-05_JPRB, 0.17743705E-05_JPRB, 0.17748439E-05_JPRB, &
  & 0.17752542E-05_JPRB, 0.17756013E-05_JPRB, 0.17758721E-05_JPRB, 0.17760633E-05_JPRB, 0.17761872E-05_JPRB, 0.17762570E-05_JPRB, &
  & 0.17762776E-05_JPRB, 0.17762684E-05_JPRB, 0.17762120E-05_JPRB, 0.17761170E-05_JPRB, 0.17760003E-05_JPRB, 0.17758268E-05_JPRB, &
  & 0.17756258E-05_JPRB, 0.17753391E-05_JPRB, 0.17748099E-05_JPRB, 0.17736346E-05_JPRB /)

RGHG2(:,75,10) = (/ &
  & 0.17752145E-05_JPRB, 0.17759091E-05_JPRB, 0.17761292E-05_JPRB, 0.17762284E-05_JPRB, 0.17762771E-05_JPRB, 0.17763164E-05_JPRB, &
  & 0.17763377E-05_JPRB, 0.17763469E-05_JPRB, 0.17763705E-05_JPRB, 0.17763876E-05_JPRB, 0.17763959E-05_JPRB, 0.17763791E-05_JPRB, &
  & 0.17763145E-05_JPRB, 0.17761984E-05_JPRB, 0.17759837E-05_JPRB, 0.17756718E-05_JPRB, 0.17752564E-05_JPRB, 0.17747525E-05_JPRB, &
  & 0.17741861E-05_JPRB, 0.17736079E-05_JPRB, 0.17730777E-05_JPRB, 0.17726359E-05_JPRB, 0.17723069E-05_JPRB, 0.17721071E-05_JPRB, &
  & 0.17720365E-05_JPRB, 0.17720924E-05_JPRB, 0.17722524E-05_JPRB, 0.17725300E-05_JPRB, 0.17728834E-05_JPRB, 0.17732743E-05_JPRB, &
  & 0.17736629E-05_JPRB, 0.17739787E-05_JPRB, 0.17741797E-05_JPRB, 0.17742726E-05_JPRB, 0.17742672E-05_JPRB, 0.17741920E-05_JPRB, &
  & 0.17740687E-05_JPRB, 0.17739281E-05_JPRB, 0.17737863E-05_JPRB, 0.17736736E-05_JPRB, 0.17736456E-05_JPRB, 0.17737248E-05_JPRB, &
  & 0.17739295E-05_JPRB, 0.17742324E-05_JPRB, 0.17746070E-05_JPRB, 0.17750134E-05_JPRB, 0.17754257E-05_JPRB, 0.17758208E-05_JPRB, &
  & 0.17761636E-05_JPRB, 0.17764554E-05_JPRB, 0.17766843E-05_JPRB, 0.17768498E-05_JPRB, 0.17769570E-05_JPRB, 0.17770221E-05_JPRB, &
  & 0.17770418E-05_JPRB, 0.17770417E-05_JPRB, 0.17770022E-05_JPRB, 0.17769318E-05_JPRB, 0.17768277E-05_JPRB, 0.17767007E-05_JPRB, &
  & 0.17765151E-05_JPRB, 0.17762827E-05_JPRB, 0.17758147E-05_JPRB, 0.17747136E-05_JPRB /)

RGHG2(:,76,10) = (/ &
  & 0.17761582E-05_JPRB, 0.17768141E-05_JPRB, 0.17770096E-05_JPRB, 0.17770922E-05_JPRB, 0.17771318E-05_JPRB, 0.17771686E-05_JPRB, &
  & 0.17771893E-05_JPRB, 0.17771972E-05_JPRB, 0.17772130E-05_JPRB, 0.17772290E-05_JPRB, 0.17772319E-05_JPRB, 0.17772127E-05_JPRB, &
  & 0.17771588E-05_JPRB, 0.17770628E-05_JPRB, 0.17768881E-05_JPRB, 0.17766409E-05_JPRB, 0.17763123E-05_JPRB, 0.17759196E-05_JPRB, &
  & 0.17754697E-05_JPRB, 0.17750122E-05_JPRB, 0.17745961E-05_JPRB, 0.17742431E-05_JPRB, 0.17739806E-05_JPRB, 0.17738166E-05_JPRB, &
  & 0.17737547E-05_JPRB, 0.17737905E-05_JPRB, 0.17739037E-05_JPRB, 0.17741128E-05_JPRB, 0.17743814E-05_JPRB, 0.17746811E-05_JPRB, &
  & 0.17749832E-05_JPRB, 0.17752272E-05_JPRB, 0.17753829E-05_JPRB, 0.17754586E-05_JPRB, 0.17754576E-05_JPRB, 0.17754020E-05_JPRB, &
  & 0.17753111E-05_JPRB, 0.17752120E-05_JPRB, 0.17751095E-05_JPRB, 0.17750297E-05_JPRB, 0.17750202E-05_JPRB, 0.17750936E-05_JPRB, &
  & 0.17752664E-05_JPRB, 0.17755111E-05_JPRB, 0.17758116E-05_JPRB, 0.17761366E-05_JPRB, 0.17764600E-05_JPRB, 0.17767786E-05_JPRB, &
  & 0.17770476E-05_JPRB, 0.17772807E-05_JPRB, 0.17774634E-05_JPRB, 0.17775990E-05_JPRB, 0.17776903E-05_JPRB, 0.17777425E-05_JPRB, &
  & 0.17777597E-05_JPRB, 0.17777658E-05_JPRB, 0.17777411E-05_JPRB, 0.17776857E-05_JPRB, 0.17776190E-05_JPRB, 0.17775039E-05_JPRB, &
  & 0.17773700E-05_JPRB, 0.17771753E-05_JPRB, 0.17767793E-05_JPRB, 0.17758015E-05_JPRB /)

RGHG2(:,77,10) = (/ &
  & 0.17770935E-05_JPRB, 0.17776856E-05_JPRB, 0.17778550E-05_JPRB, 0.17779179E-05_JPRB, 0.17779467E-05_JPRB, 0.17779812E-05_JPRB, &
  & 0.17780028E-05_JPRB, 0.17780080E-05_JPRB, 0.17780203E-05_JPRB, 0.17780312E-05_JPRB, 0.17780296E-05_JPRB, 0.17780126E-05_JPRB, &
  & 0.17779643E-05_JPRB, 0.17778934E-05_JPRB, 0.17777603E-05_JPRB, 0.17775817E-05_JPRB, 0.17773455E-05_JPRB, 0.17770641E-05_JPRB, &
  & 0.17767354E-05_JPRB, 0.17764005E-05_JPRB, 0.17760954E-05_JPRB, 0.17758391E-05_JPRB, 0.17756420E-05_JPRB, 0.17755196E-05_JPRB, &
  & 0.17754708E-05_JPRB, 0.17754930E-05_JPRB, 0.17755651E-05_JPRB, 0.17757112E-05_JPRB, 0.17758988E-05_JPRB, 0.17761109E-05_JPRB, &
  & 0.17763293E-05_JPRB, 0.17765044E-05_JPRB, 0.17766155E-05_JPRB, 0.17766747E-05_JPRB, 0.17766788E-05_JPRB, 0.17766404E-05_JPRB, &
  & 0.17765784E-05_JPRB, 0.17765169E-05_JPRB, 0.17764489E-05_JPRB, 0.17763947E-05_JPRB, 0.17763992E-05_JPRB, 0.17764609E-05_JPRB, &
  & 0.17765931E-05_JPRB, 0.17767740E-05_JPRB, 0.17769951E-05_JPRB, 0.17772282E-05_JPRB, 0.17774659E-05_JPRB, 0.17777016E-05_JPRB, &
  & 0.17778951E-05_JPRB, 0.17780687E-05_JPRB, 0.17782015E-05_JPRB, 0.17783054E-05_JPRB, 0.17783761E-05_JPRB, 0.17784138E-05_JPRB, &
  & 0.17784237E-05_JPRB, 0.17784325E-05_JPRB, 0.17784197E-05_JPRB, 0.17783847E-05_JPRB, 0.17783348E-05_JPRB, 0.17782597E-05_JPRB, &
  & 0.17781502E-05_JPRB, 0.17780150E-05_JPRB, 0.17776928E-05_JPRB, 0.17768671E-05_JPRB /)

RGHG2(:,78,10) = (/ &
  & 0.17780091E-05_JPRB, 0.17784847E-05_JPRB, 0.17786059E-05_JPRB, 0.17786459E-05_JPRB, 0.17786641E-05_JPRB, 0.17786977E-05_JPRB, &
  & 0.17787223E-05_JPRB, 0.17787271E-05_JPRB, 0.17787349E-05_JPRB, 0.17787431E-05_JPRB, 0.17787365E-05_JPRB, 0.17787189E-05_JPRB, &
  & 0.17786814E-05_JPRB, 0.17786323E-05_JPRB, 0.17785439E-05_JPRB, 0.17784301E-05_JPRB, 0.17782817E-05_JPRB, 0.17781097E-05_JPRB, &
  & 0.17778975E-05_JPRB, 0.17776791E-05_JPRB, 0.17774875E-05_JPRB, 0.17773227E-05_JPRB, 0.17771958E-05_JPRB, 0.17771169E-05_JPRB, &
  & 0.17770863E-05_JPRB, 0.17771023E-05_JPRB, 0.17771425E-05_JPRB, 0.17772371E-05_JPRB, 0.17773531E-05_JPRB, 0.17774880E-05_JPRB, &
  & 0.17776287E-05_JPRB, 0.17777412E-05_JPRB, 0.17778116E-05_JPRB, 0.17778555E-05_JPRB, 0.17778634E-05_JPRB, 0.17778380E-05_JPRB, &
  & 0.17777988E-05_JPRB, 0.17777675E-05_JPRB, 0.17777256E-05_JPRB, 0.17776903E-05_JPRB, 0.17776981E-05_JPRB, 0.17777400E-05_JPRB, &
  & 0.17778235E-05_JPRB, 0.17779370E-05_JPRB, 0.17780737E-05_JPRB, 0.17782207E-05_JPRB, 0.17783690E-05_JPRB, 0.17785289E-05_JPRB, &
  & 0.17786510E-05_JPRB, 0.17787663E-05_JPRB, 0.17788504E-05_JPRB, 0.17789229E-05_JPRB, 0.17789731E-05_JPRB, 0.17789919E-05_JPRB, &
  & 0.17789923E-05_JPRB, 0.17789996E-05_JPRB, 0.17789980E-05_JPRB, 0.17789730E-05_JPRB, 0.17789504E-05_JPRB, 0.17788909E-05_JPRB, &
  & 0.17788246E-05_JPRB, 0.17787312E-05_JPRB, 0.17785183E-05_JPRB, 0.17779046E-05_JPRB /)

RGHG2(:,79,10) = (/ &
  & 0.17786001E-05_JPRB, 0.17789337E-05_JPRB, 0.17790067E-05_JPRB, 0.17790230E-05_JPRB, 0.17790336E-05_JPRB, 0.17790680E-05_JPRB, &
  & 0.17790959E-05_JPRB, 0.17790983E-05_JPRB, 0.17791028E-05_JPRB, 0.17791102E-05_JPRB, 0.17791016E-05_JPRB, 0.17790858E-05_JPRB, &
  & 0.17790528E-05_JPRB, 0.17790165E-05_JPRB, 0.17789511E-05_JPRB, 0.17788727E-05_JPRB, 0.17787712E-05_JPRB, 0.17786599E-05_JPRB, &
  & 0.17785101E-05_JPRB, 0.17783569E-05_JPRB, 0.17782263E-05_JPRB, 0.17781158E-05_JPRB, 0.17780276E-05_JPRB, 0.17779746E-05_JPRB, &
  & 0.17779563E-05_JPRB, 0.17779710E-05_JPRB, 0.17779947E-05_JPRB, 0.17780621E-05_JPRB, 0.17781399E-05_JPRB, 0.17782322E-05_JPRB, &
  & 0.17783321E-05_JPRB, 0.17784097E-05_JPRB, 0.17784581E-05_JPRB, 0.17784947E-05_JPRB, 0.17785047E-05_JPRB, 0.17784839E-05_JPRB, &
  & 0.17784547E-05_JPRB, 0.17784383E-05_JPRB, 0.17784091E-05_JPRB, 0.17783793E-05_JPRB, 0.17783879E-05_JPRB, 0.17784159E-05_JPRB, &
  & 0.17784737E-05_JPRB, 0.17785489E-05_JPRB, 0.17786417E-05_JPRB, 0.17787388E-05_JPRB, 0.17788408E-05_JPRB, 0.17789611E-05_JPRB, &
  & 0.17790434E-05_JPRB, 0.17791313E-05_JPRB, 0.17791879E-05_JPRB, 0.17792446E-05_JPRB, 0.17792850E-05_JPRB, 0.17792911E-05_JPRB, &
  & 0.17792845E-05_JPRB, 0.17792913E-05_JPRB, 0.17792962E-05_JPRB, 0.17792761E-05_JPRB, 0.17792651E-05_JPRB, 0.17792170E-05_JPRB, &
  & 0.17791676E-05_JPRB, 0.17791112E-05_JPRB, 0.17789732E-05_JPRB, 0.17785668E-05_JPRB /)

RGHG2(:,80,10) = (/ &
  & 0.17789956E-05_JPRB, 0.17791508E-05_JPRB, 0.17791823E-05_JPRB, 0.17791854E-05_JPRB, 0.17791907E-05_JPRB, 0.17792266E-05_JPRB, &
  & 0.17792570E-05_JPRB, 0.17792581E-05_JPRB, 0.17792619E-05_JPRB, 0.17792702E-05_JPRB, 0.17792607E-05_JPRB, 0.17792463E-05_JPRB, &
  & 0.17792159E-05_JPRB, 0.17791859E-05_JPRB, 0.17791307E-05_JPRB, 0.17790686E-05_JPRB, 0.17789888E-05_JPRB, 0.17789057E-05_JPRB, &
  & 0.17787846E-05_JPRB, 0.17786581E-05_JPRB, 0.17785583E-05_JPRB, 0.17784710E-05_JPRB, 0.17784018E-05_JPRB, 0.17783613E-05_JPRB, &
  & 0.17783493E-05_JPRB, 0.17783643E-05_JPRB, 0.17783814E-05_JPRB, 0.17784371E-05_JPRB, 0.17784973E-05_JPRB, 0.17785712E-05_JPRB, &
  & 0.17786515E-05_JPRB, 0.17787136E-05_JPRB, 0.17787515E-05_JPRB, 0.17787855E-05_JPRB, 0.17787962E-05_JPRB, 0.17787768E-05_JPRB, &
  & 0.17787505E-05_JPRB, 0.17787409E-05_JPRB, 0.17787163E-05_JPRB, 0.17786884E-05_JPRB, 0.17786957E-05_JPRB, 0.17787179E-05_JPRB, &
  & 0.17787636E-05_JPRB, 0.17788213E-05_JPRB, 0.17788938E-05_JPRB, 0.17789686E-05_JPRB, 0.17790489E-05_JPRB, 0.17791521E-05_JPRB, &
  & 0.17792159E-05_JPRB, 0.17792904E-05_JPRB, 0.17793350E-05_JPRB, 0.17793848E-05_JPRB, 0.17794209E-05_JPRB, 0.17794205E-05_JPRB, &
  & 0.17794092E-05_JPRB, 0.17794154E-05_JPRB, 0.17794238E-05_JPRB, 0.17794048E-05_JPRB, 0.17794007E-05_JPRB, 0.17793544E-05_JPRB, &
  & 0.17793158E-05_JPRB, 0.17792756E-05_JPRB, 0.17791924E-05_JPRB, 0.17790019E-05_JPRB /)

RGHG2(:,81,10) = (/ &
  & 0.17792687E-05_JPRB, 0.17792430E-05_JPRB, 0.17792566E-05_JPRB, 0.17792538E-05_JPRB, 0.17792571E-05_JPRB, 0.17792939E-05_JPRB, &
  & 0.17793259E-05_JPRB, 0.17793270E-05_JPRB, 0.17793296E-05_JPRB, 0.17793392E-05_JPRB, 0.17793300E-05_JPRB, 0.17793158E-05_JPRB, &
  & 0.17792869E-05_JPRB, 0.17792596E-05_JPRB, 0.17792094E-05_JPRB, 0.17791541E-05_JPRB, 0.17790840E-05_JPRB, 0.17790145E-05_JPRB, &
  & 0.17789047E-05_JPRB, 0.17787916E-05_JPRB, 0.17787031E-05_JPRB, 0.17786276E-05_JPRB, 0.17785659E-05_JPRB, 0.17785312E-05_JPRB, &
  & 0.17785226E-05_JPRB, 0.17785376E-05_JPRB, 0.17785518E-05_JPRB, 0.17786026E-05_JPRB, 0.17786551E-05_JPRB, 0.17787204E-05_JPRB, &
  & 0.17787927E-05_JPRB, 0.17788470E-05_JPRB, 0.17788807E-05_JPRB, 0.17789139E-05_JPRB, 0.17789247E-05_JPRB, 0.17789050E-05_JPRB, &
  & 0.17788805E-05_JPRB, 0.17788731E-05_JPRB, 0.17788507E-05_JPRB, 0.17788238E-05_JPRB, 0.17788309E-05_JPRB, 0.17788501E-05_JPRB, &
  & 0.17788909E-05_JPRB, 0.17789419E-05_JPRB, 0.17790048E-05_JPRB, 0.17790700E-05_JPRB, 0.17791392E-05_JPRB, 0.17792360E-05_JPRB, &
  & 0.17792905E-05_JPRB, 0.17793600E-05_JPRB, 0.17793982E-05_JPRB, 0.17794453E-05_JPRB, 0.17794799E-05_JPRB, 0.17794756E-05_JPRB, &
  & 0.17794621E-05_JPRB, 0.17794679E-05_JPRB, 0.17794785E-05_JPRB, 0.17794592E-05_JPRB, 0.17794580E-05_JPRB, 0.17794130E-05_JPRB, &
  & 0.17793775E-05_JPRB, 0.17793446E-05_JPRB, 0.17792837E-05_JPRB, 0.17792993E-05_JPRB /)

RGHG2(:,82,10) = (/ &
  & 0.17792913E-05_JPRB, 0.17792740E-05_JPRB, 0.17792891E-05_JPRB, 0.17792856E-05_JPRB, 0.17792888E-05_JPRB, 0.17793270E-05_JPRB, &
  & 0.17793598E-05_JPRB, 0.17793603E-05_JPRB, 0.17793634E-05_JPRB, 0.17793725E-05_JPRB, 0.17793632E-05_JPRB, 0.17793501E-05_JPRB, &
  & 0.17793216E-05_JPRB, 0.17792960E-05_JPRB, 0.17792474E-05_JPRB, 0.17791963E-05_JPRB, 0.17791308E-05_JPRB, 0.17790679E-05_JPRB, &
  & 0.17789646E-05_JPRB, 0.17788553E-05_JPRB, 0.17787752E-05_JPRB, 0.17787039E-05_JPRB, 0.17786463E-05_JPRB, 0.17786141E-05_JPRB, &
  & 0.17786072E-05_JPRB, 0.17786227E-05_JPRB, 0.17786358E-05_JPRB, 0.17786837E-05_JPRB, 0.17787327E-05_JPRB, 0.17787937E-05_JPRB, &
  & 0.17788608E-05_JPRB, 0.17789117E-05_JPRB, 0.17789434E-05_JPRB, 0.17789764E-05_JPRB, 0.17789876E-05_JPRB, 0.17789678E-05_JPRB, &
  & 0.17789437E-05_JPRB, 0.17789375E-05_JPRB, 0.17789165E-05_JPRB, 0.17788900E-05_JPRB, 0.17788967E-05_JPRB, 0.17789148E-05_JPRB, &
  & 0.17789537E-05_JPRB, 0.17790009E-05_JPRB, 0.17790601E-05_JPRB, 0.17791197E-05_JPRB, 0.17791843E-05_JPRB, 0.17792772E-05_JPRB, &
  & 0.17793271E-05_JPRB, 0.17793939E-05_JPRB, 0.17794287E-05_JPRB, 0.17794746E-05_JPRB, 0.17795086E-05_JPRB, 0.17795020E-05_JPRB, &
  & 0.17794868E-05_JPRB, 0.17794930E-05_JPRB, 0.17795047E-05_JPRB, 0.17794855E-05_JPRB, 0.17794861E-05_JPRB, 0.17794407E-05_JPRB, &
  & 0.17794069E-05_JPRB, 0.17793744E-05_JPRB, 0.17793139E-05_JPRB, 0.17793228E-05_JPRB /)

RGHG2(:,83,10) = (/ &
  & 0.17793068E-05_JPRB, 0.17792919E-05_JPRB, 0.17793074E-05_JPRB, 0.17793033E-05_JPRB, 0.17793061E-05_JPRB, 0.17793450E-05_JPRB, &
  & 0.17793782E-05_JPRB, 0.17793793E-05_JPRB, 0.17793815E-05_JPRB, 0.17793910E-05_JPRB, 0.17793825E-05_JPRB, 0.17793682E-05_JPRB, &
  & 0.17793411E-05_JPRB, 0.17793159E-05_JPRB, 0.17792687E-05_JPRB, 0.17792200E-05_JPRB, 0.17791576E-05_JPRB, 0.17790989E-05_JPRB, &
  & 0.17789978E-05_JPRB, 0.17788927E-05_JPRB, 0.17788150E-05_JPRB, 0.17787469E-05_JPRB, 0.17786913E-05_JPRB, 0.17786602E-05_JPRB, &
  & 0.17786543E-05_JPRB, 0.17786704E-05_JPRB, 0.17786822E-05_JPRB, 0.17787290E-05_JPRB, 0.17787758E-05_JPRB, 0.17788340E-05_JPRB, &
  & 0.17788985E-05_JPRB, 0.17789473E-05_JPRB, 0.17789780E-05_JPRB, 0.17790112E-05_JPRB, 0.17790226E-05_JPRB, 0.17790023E-05_JPRB, &
  & 0.17789788E-05_JPRB, 0.17789732E-05_JPRB, 0.17789528E-05_JPRB, 0.17789275E-05_JPRB, 0.17789340E-05_JPRB, 0.17789509E-05_JPRB, &
  & 0.17789886E-05_JPRB, 0.17790344E-05_JPRB, 0.17790912E-05_JPRB, 0.17791484E-05_JPRB, 0.17792091E-05_JPRB, 0.17793009E-05_JPRB, &
  & 0.17793476E-05_JPRB, 0.17794132E-05_JPRB, 0.17794455E-05_JPRB, 0.17794910E-05_JPRB, 0.17795247E-05_JPRB, 0.17795169E-05_JPRB, &
  & 0.17795004E-05_JPRB, 0.17795066E-05_JPRB, 0.17795194E-05_JPRB, 0.17795003E-05_JPRB, 0.17795016E-05_JPRB, 0.17794563E-05_JPRB, &
  & 0.17794226E-05_JPRB, 0.17793913E-05_JPRB, 0.17793313E-05_JPRB, 0.17793394E-05_JPRB /)

RGHG2(:,84,10) = (/ &
  & 0.17793174E-05_JPRB, 0.17793035E-05_JPRB, 0.17793188E-05_JPRB, 0.17793141E-05_JPRB, 0.17793164E-05_JPRB, 0.17793561E-05_JPRB, &
  & 0.17793898E-05_JPRB, 0.17793909E-05_JPRB, 0.17793936E-05_JPRB, 0.17794011E-05_JPRB, 0.17793925E-05_JPRB, 0.17793795E-05_JPRB, &
  & 0.17793527E-05_JPRB, 0.17793275E-05_JPRB, 0.17792825E-05_JPRB, 0.17792347E-05_JPRB, 0.17791743E-05_JPRB, 0.17791181E-05_JPRB, &
  & 0.17790192E-05_JPRB, 0.17789150E-05_JPRB, 0.17788401E-05_JPRB, 0.17787738E-05_JPRB, 0.17787186E-05_JPRB, 0.17786888E-05_JPRB, &
  & 0.17786831E-05_JPRB, 0.17786992E-05_JPRB, 0.17787108E-05_JPRB, 0.17787573E-05_JPRB, 0.17788017E-05_JPRB, 0.17788592E-05_JPRB, &
  & 0.17789215E-05_JPRB, 0.17789692E-05_JPRB, 0.17789987E-05_JPRB, 0.17790323E-05_JPRB, 0.17790439E-05_JPRB, 0.17790239E-05_JPRB, &
  & 0.17790003E-05_JPRB, 0.17789951E-05_JPRB, 0.17789755E-05_JPRB, 0.17789504E-05_JPRB, 0.17789561E-05_JPRB, 0.17789732E-05_JPRB, &
  & 0.17790098E-05_JPRB, 0.17790551E-05_JPRB, 0.17791109E-05_JPRB, 0.17791659E-05_JPRB, 0.17792246E-05_JPRB, 0.17793154E-05_JPRB, &
  & 0.17793601E-05_JPRB, 0.17794247E-05_JPRB, 0.17794561E-05_JPRB, 0.17795011E-05_JPRB, 0.17795350E-05_JPRB, 0.17795260E-05_JPRB, &
  & 0.17795087E-05_JPRB, 0.17795145E-05_JPRB, 0.17795280E-05_JPRB, 0.17795086E-05_JPRB, 0.17795116E-05_JPRB, 0.17794648E-05_JPRB, &
  & 0.17794328E-05_JPRB, 0.17794010E-05_JPRB, 0.17793426E-05_JPRB, 0.17793506E-05_JPRB /)

RGHG2(:,85,10) = (/ &
  & 0.17793245E-05_JPRB, 0.17793111E-05_JPRB, 0.17793267E-05_JPRB, 0.17793212E-05_JPRB, 0.17793234E-05_JPRB, 0.17793660E-05_JPRB, &
  & 0.17793961E-05_JPRB, 0.17793991E-05_JPRB, 0.17794005E-05_JPRB, 0.17794050E-05_JPRB, 0.17793975E-05_JPRB, 0.17793836E-05_JPRB, &
  & 0.17793598E-05_JPRB, 0.17793341E-05_JPRB, 0.17792916E-05_JPRB, 0.17792457E-05_JPRB, 0.17791864E-05_JPRB, 0.17791309E-05_JPRB, &
  & 0.17790348E-05_JPRB, 0.17789307E-05_JPRB, 0.17788570E-05_JPRB, 0.17787909E-05_JPRB, 0.17787370E-05_JPRB, 0.17787066E-05_JPRB, &
  & 0.17787015E-05_JPRB, 0.17787182E-05_JPRB, 0.17787289E-05_JPRB, 0.17787752E-05_JPRB, 0.17788191E-05_JPRB, 0.17788741E-05_JPRB, &
  & 0.17789366E-05_JPRB, 0.17789829E-05_JPRB, 0.17790121E-05_JPRB, 0.17790462E-05_JPRB, 0.17790577E-05_JPRB, 0.17790373E-05_JPRB, &
  & 0.17790143E-05_JPRB, 0.17790093E-05_JPRB, 0.17789896E-05_JPRB, 0.17789652E-05_JPRB, 0.17789705E-05_JPRB, 0.17789863E-05_JPRB, &
  & 0.17790248E-05_JPRB, 0.17790686E-05_JPRB, 0.17791243E-05_JPRB, 0.17791780E-05_JPRB, 0.17792350E-05_JPRB, 0.17793251E-05_JPRB, &
  & 0.17793684E-05_JPRB, 0.17794322E-05_JPRB, 0.17794624E-05_JPRB, 0.17795074E-05_JPRB, 0.17795418E-05_JPRB, 0.17795321E-05_JPRB, &
  & 0.17795137E-05_JPRB, 0.17795198E-05_JPRB, 0.17795340E-05_JPRB, 0.17795143E-05_JPRB, 0.17795172E-05_JPRB, 0.17794720E-05_JPRB, &
  & 0.17794384E-05_JPRB, 0.17794084E-05_JPRB, 0.17793494E-05_JPRB, 0.17793584E-05_JPRB /)

RGHG2(:,86,10) = (/ &
  & 0.17793291E-05_JPRB, 0.17793159E-05_JPRB, 0.17793313E-05_JPRB, 0.17793257E-05_JPRB, 0.17793300E-05_JPRB, 0.17793679E-05_JPRB, &
  & 0.17794010E-05_JPRB, 0.17794027E-05_JPRB, 0.17794036E-05_JPRB, 0.17794048E-05_JPRB, 0.17793966E-05_JPRB, 0.17793836E-05_JPRB, &
  & 0.17793617E-05_JPRB, 0.17793363E-05_JPRB, 0.17792985E-05_JPRB, 0.17792527E-05_JPRB, 0.17791969E-05_JPRB, 0.17791410E-05_JPRB, &
  & 0.17790455E-05_JPRB, 0.17789432E-05_JPRB, 0.17788680E-05_JPRB, 0.17788034E-05_JPRB, 0.17787476E-05_JPRB, 0.17787175E-05_JPRB, &
  & 0.17787122E-05_JPRB, 0.17787301E-05_JPRB, 0.17787393E-05_JPRB, 0.17787872E-05_JPRB, 0.17788293E-05_JPRB, 0.17788849E-05_JPRB, &
  & 0.17789459E-05_JPRB, 0.17789918E-05_JPRB, 0.17790203E-05_JPRB, 0.17790550E-05_JPRB, 0.17790669E-05_JPRB, 0.17790464E-05_JPRB, &
  & 0.17790228E-05_JPRB, 0.17790188E-05_JPRB, 0.17789990E-05_JPRB, 0.17789735E-05_JPRB, 0.17789789E-05_JPRB, 0.17789953E-05_JPRB, &
  & 0.17790333E-05_JPRB, 0.17790783E-05_JPRB, 0.17791327E-05_JPRB, 0.17791857E-05_JPRB, 0.17792414E-05_JPRB, 0.17793315E-05_JPRB, &
  & 0.17793739E-05_JPRB, 0.17794371E-05_JPRB, 0.17794665E-05_JPRB, 0.17795118E-05_JPRB, 0.17795462E-05_JPRB, 0.17795355E-05_JPRB, &
  & 0.17795165E-05_JPRB, 0.17795226E-05_JPRB, 0.17795376E-05_JPRB, 0.17795177E-05_JPRB, 0.17795219E-05_JPRB, 0.17794748E-05_JPRB, &
  & 0.17794430E-05_JPRB, 0.17794118E-05_JPRB, 0.17793542E-05_JPRB, 0.17793633E-05_JPRB /)

RGHG2(:,87,10) = (/ &
  & 0.17793316E-05_JPRB, 0.17793185E-05_JPRB, 0.17793340E-05_JPRB, 0.17793277E-05_JPRB, 0.17793312E-05_JPRB, 0.17793790E-05_JPRB, &
  & 0.17793994E-05_JPRB, 0.17794032E-05_JPRB, 0.17794032E-05_JPRB, 0.17794022E-05_JPRB, 0.17793946E-05_JPRB, 0.17793814E-05_JPRB, &
  & 0.17793614E-05_JPRB, 0.17793375E-05_JPRB, 0.17793009E-05_JPRB, 0.17792590E-05_JPRB, 0.17792042E-05_JPRB, 0.17791471E-05_JPRB, &
  & 0.17790560E-05_JPRB, 0.17789508E-05_JPRB, 0.17788767E-05_JPRB, 0.17788101E-05_JPRB, 0.17787548E-05_JPRB, 0.17787240E-05_JPRB, &
  & 0.17787185E-05_JPRB, 0.17787376E-05_JPRB, 0.17787456E-05_JPRB, 0.17787938E-05_JPRB, 0.17788360E-05_JPRB, 0.17788905E-05_JPRB, &
  & 0.17789525E-05_JPRB, 0.17789974E-05_JPRB, 0.17790255E-05_JPRB, 0.17790601E-05_JPRB, 0.17790725E-05_JPRB, 0.17790517E-05_JPRB, &
  & 0.17790283E-05_JPRB, 0.17790248E-05_JPRB, 0.17790049E-05_JPRB, 0.17789775E-05_JPRB, 0.17789841E-05_JPRB, 0.17790003E-05_JPRB, &
  & 0.17790403E-05_JPRB, 0.17790841E-05_JPRB, 0.17791385E-05_JPRB, 0.17791901E-05_JPRB, 0.17792454E-05_JPRB, 0.17793351E-05_JPRB, &
  & 0.17793774E-05_JPRB, 0.17794399E-05_JPRB, 0.17794691E-05_JPRB, 0.17795143E-05_JPRB, 0.17795491E-05_JPRB, 0.17795376E-05_JPRB, &
  & 0.17795185E-05_JPRB, 0.17795244E-05_JPRB, 0.17795397E-05_JPRB, 0.17795194E-05_JPRB, 0.17795239E-05_JPRB, 0.17794778E-05_JPRB, &
  & 0.17794448E-05_JPRB, 0.17794146E-05_JPRB, 0.17793559E-05_JPRB, 0.17793662E-05_JPRB /)

RGHG2(:,88,10) = (/ &
  & 0.17793327E-05_JPRB, 0.17793204E-05_JPRB, 0.17793354E-05_JPRB, 0.17793294E-05_JPRB, 0.17793377E-05_JPRB, 0.17793724E-05_JPRB, &
  & 0.17794032E-05_JPRB, 0.17794047E-05_JPRB, 0.17794041E-05_JPRB, 0.17794027E-05_JPRB, 0.17793941E-05_JPRB, 0.17793814E-05_JPRB, &
  & 0.17793616E-05_JPRB, 0.17793377E-05_JPRB, 0.17793037E-05_JPRB, 0.17792609E-05_JPRB, 0.17792083E-05_JPRB, 0.17791517E-05_JPRB, &
  & 0.17790589E-05_JPRB, 0.17789581E-05_JPRB, 0.17788805E-05_JPRB, 0.17788155E-05_JPRB, 0.17787588E-05_JPRB, 0.17787282E-05_JPRB, &
  & 0.17787221E-05_JPRB, 0.17787424E-05_JPRB, 0.17787481E-05_JPRB, 0.17787991E-05_JPRB, 0.17788393E-05_JPRB, 0.17788946E-05_JPRB, &
  & 0.17789566E-05_JPRB, 0.17790012E-05_JPRB, 0.17790285E-05_JPRB, 0.17790640E-05_JPRB, 0.17790758E-05_JPRB, 0.17790554E-05_JPRB, &
  & 0.17790313E-05_JPRB, 0.17790290E-05_JPRB, 0.17790082E-05_JPRB, 0.17789797E-05_JPRB, 0.17789870E-05_JPRB, 0.17790037E-05_JPRB, &
  & 0.17790442E-05_JPRB, 0.17790882E-05_JPRB, 0.17791418E-05_JPRB, 0.17791930E-05_JPRB, 0.17792477E-05_JPRB, 0.17793371E-05_JPRB, &
  & 0.17793791E-05_JPRB, 0.17794414E-05_JPRB, 0.17794706E-05_JPRB, 0.17795159E-05_JPRB, 0.17795509E-05_JPRB, 0.17795385E-05_JPRB, &
  & 0.17795194E-05_JPRB, 0.17795254E-05_JPRB, 0.17795410E-05_JPRB, 0.17795203E-05_JPRB, 0.17795256E-05_JPRB, 0.17794788E-05_JPRB, &
  & 0.17794461E-05_JPRB, 0.17794155E-05_JPRB, 0.17793574E-05_JPRB, 0.17793681E-05_JPRB /)

RGHG2(:,89,10) = (/ &
  & 0.17793333E-05_JPRB, 0.17793218E-05_JPRB, 0.17793363E-05_JPRB, 0.17793292E-05_JPRB, 0.17793317E-05_JPRB, 0.17793818E-05_JPRB, &
  & 0.17794025E-05_JPRB, 0.17794060E-05_JPRB, 0.17794059E-05_JPRB, 0.17794055E-05_JPRB, 0.17793977E-05_JPRB, 0.17793844E-05_JPRB, &
  & 0.17793639E-05_JPRB, 0.17793399E-05_JPRB, 0.17793036E-05_JPRB, 0.17792622E-05_JPRB, 0.17792081E-05_JPRB, 0.17791523E-05_JPRB, &
  & 0.17790612E-05_JPRB, 0.17789561E-05_JPRB, 0.17788827E-05_JPRB, 0.17788170E-05_JPRB, 0.17787610E-05_JPRB, 0.17787299E-05_JPRB, &
  & 0.17787243E-05_JPRB, 0.17787452E-05_JPRB, 0.17787495E-05_JPRB, 0.17788011E-05_JPRB, 0.17788415E-05_JPRB, 0.17788966E-05_JPRB, &
  & 0.17789591E-05_JPRB, 0.17790034E-05_JPRB, 0.17790298E-05_JPRB, 0.17790662E-05_JPRB, 0.17790785E-05_JPRB, 0.17790575E-05_JPRB, &
  & 0.17790323E-05_JPRB, 0.17790312E-05_JPRB, 0.17790101E-05_JPRB, 0.17789800E-05_JPRB, 0.17789886E-05_JPRB, 0.17790052E-05_JPRB, &
  & 0.17790466E-05_JPRB, 0.17790900E-05_JPRB, 0.17791440E-05_JPRB, 0.17791946E-05_JPRB, 0.17792487E-05_JPRB, 0.17793386E-05_JPRB, &
  & 0.17793795E-05_JPRB, 0.17794425E-05_JPRB, 0.17794713E-05_JPRB, 0.17795169E-05_JPRB, 0.17795525E-05_JPRB, 0.17795394E-05_JPRB, &
  & 0.17795196E-05_JPRB, 0.17795257E-05_JPRB, 0.17795418E-05_JPRB, 0.17795207E-05_JPRB, 0.17795267E-05_JPRB, 0.17794797E-05_JPRB, &
  & 0.17794466E-05_JPRB, 0.17794160E-05_JPRB, 0.17793571E-05_JPRB, 0.17793690E-05_JPRB /)

RGHG2(:,90,10) = (/ &
  & 0.17793336E-05_JPRB, 0.17793228E-05_JPRB, 0.17793368E-05_JPRB, 0.17793291E-05_JPRB, 0.17793316E-05_JPRB, 0.17793733E-05_JPRB, &
  & 0.17794091E-05_JPRB, 0.17794098E-05_JPRB, 0.17794104E-05_JPRB, 0.17794123E-05_JPRB, 0.17794041E-05_JPRB, 0.17793906E-05_JPRB, &
  & 0.17793675E-05_JPRB, 0.17793429E-05_JPRB, 0.17793045E-05_JPRB, 0.17792599E-05_JPRB, 0.17792055E-05_JPRB, 0.17791531E-05_JPRB, &
  & 0.17790572E-05_JPRB, 0.17789547E-05_JPRB, 0.17788814E-05_JPRB, 0.17788176E-05_JPRB, 0.17787610E-05_JPRB, 0.17787298E-05_JPRB, &
  & 0.17787240E-05_JPRB, 0.17787468E-05_JPRB, 0.17787489E-05_JPRB, 0.17788026E-05_JPRB, 0.17788418E-05_JPRB, 0.17788969E-05_JPRB, &
  & 0.17789605E-05_JPRB, 0.17790045E-05_JPRB, 0.17790301E-05_JPRB, 0.17790679E-05_JPRB, 0.17790810E-05_JPRB, 0.17790585E-05_JPRB, &
  & 0.17790322E-05_JPRB, 0.17790329E-05_JPRB, 0.17790112E-05_JPRB, 0.17789790E-05_JPRB, 0.17789893E-05_JPRB, 0.17790053E-05_JPRB, &
  & 0.17790476E-05_JPRB, 0.17790908E-05_JPRB, 0.17791448E-05_JPRB, 0.17791948E-05_JPRB, 0.17792484E-05_JPRB, 0.17793406E-05_JPRB, &
  & 0.17793800E-05_JPRB, 0.17794437E-05_JPRB, 0.17794712E-05_JPRB, 0.17795179E-05_JPRB, 0.17795544E-05_JPRB, 0.17795395E-05_JPRB, &
  & 0.17795189E-05_JPRB, 0.17795259E-05_JPRB, 0.17795430E-05_JPRB, 0.17795206E-05_JPRB, 0.17795282E-05_JPRB, 0.17794791E-05_JPRB, &
  & 0.17794463E-05_JPRB, 0.17794162E-05_JPRB, 0.17793561E-05_JPRB, 0.17793693E-05_JPRB /)

RGHG2(:,91,10) = (/ &
  & 0.17793342E-05_JPRB, 0.17793232E-05_JPRB, 0.17793378E-05_JPRB, 0.17793280E-05_JPRB, 0.17793229E-05_JPRB, 0.17793732E-05_JPRB, &
  & 0.17794148E-05_JPRB, 0.17794102E-05_JPRB, 0.17794089E-05_JPRB, 0.17794262E-05_JPRB, 0.17794139E-05_JPRB, 0.17794024E-05_JPRB, &
  & 0.17793675E-05_JPRB, 0.17793501E-05_JPRB, 0.17793005E-05_JPRB, 0.17792584E-05_JPRB, 0.17791987E-05_JPRB, 0.17791557E-05_JPRB, &
  & 0.17790541E-05_JPRB, 0.17789488E-05_JPRB, 0.17788805E-05_JPRB, 0.17788169E-05_JPRB, 0.17787596E-05_JPRB, 0.17787283E-05_JPRB, &
  & 0.17787224E-05_JPRB, 0.17787481E-05_JPRB, 0.17787455E-05_JPRB, 0.17788035E-05_JPRB, 0.17788404E-05_JPRB, 0.17788959E-05_JPRB, &
  & 0.17789623E-05_JPRB, 0.17790064E-05_JPRB, 0.17790293E-05_JPRB, 0.17790710E-05_JPRB, 0.17790848E-05_JPRB, 0.17790591E-05_JPRB, &
  & 0.17790301E-05_JPRB, 0.17790350E-05_JPRB, 0.17790117E-05_JPRB, 0.17789760E-05_JPRB, 0.17789893E-05_JPRB, 0.17790037E-05_JPRB, &
  & 0.17790478E-05_JPRB, 0.17790902E-05_JPRB, 0.17791454E-05_JPRB, 0.17791948E-05_JPRB, 0.17792461E-05_JPRB, 0.17793443E-05_JPRB, &
  & 0.17793786E-05_JPRB, 0.17794464E-05_JPRB, 0.17794703E-05_JPRB, 0.17795188E-05_JPRB, 0.17795579E-05_JPRB, 0.17795401E-05_JPRB, &
  & 0.17795174E-05_JPRB, 0.17795254E-05_JPRB, 0.17795456E-05_JPRB, 0.17795189E-05_JPRB, 0.17795319E-05_JPRB, 0.17794775E-05_JPRB, &
  & 0.17794454E-05_JPRB, 0.17794162E-05_JPRB, 0.17793519E-05_JPRB, 0.17793695E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART20',1,ZHOOK_HANDLE)
END SUBROUTINE PART20






SUBROUTINE PART21
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART21',0,ZHOOK_HANDLE)



!-- Month= 11 ------------

RGHG2(:, 1,11) = (/ &
  & 0.32242838E-07_JPRB, 0.30995963E-07_JPRB, 0.27998361E-07_JPRB, 0.25265210E-07_JPRB, 0.22783903E-07_JPRB, 0.20534141E-07_JPRB, &
  & 0.18345398E-07_JPRB, 0.16157912E-07_JPRB, 0.14597189E-07_JPRB, 0.13508289E-07_JPRB, 0.12693439E-07_JPRB, 0.12149071E-07_JPRB, &
  & 0.11893976E-07_JPRB, 0.11910940E-07_JPRB, 0.12186868E-07_JPRB, 0.12700107E-07_JPRB, 0.13353834E-07_JPRB, 0.14038902E-07_JPRB, &
  & 0.14650727E-07_JPRB, 0.15103996E-07_JPRB, 0.15354892E-07_JPRB, 0.15411437E-07_JPRB, 0.15317463E-07_JPRB, 0.15123577E-07_JPRB, &
  & 0.14872030E-07_JPRB, 0.14587626E-07_JPRB, 0.14276707E-07_JPRB, 0.13912360E-07_JPRB, 0.13538845E-07_JPRB, 0.13162958E-07_JPRB, &
  & 0.12785090E-07_JPRB, 0.12387787E-07_JPRB, 0.11956504E-07_JPRB, 0.11506642E-07_JPRB, 0.11086286E-07_JPRB, 0.10731028E-07_JPRB, &
  & 0.10460030E-07_JPRB, 0.10263164E-07_JPRB, 0.10131767E-07_JPRB, 0.10044827E-07_JPRB, 0.99654951E-08_JPRB, 0.98482129E-08_JPRB, &
  & 0.96427843E-08_JPRB, 0.92770609E-08_JPRB, 0.87634655E-08_JPRB, 0.81293372E-08_JPRB, 0.74157853E-08_JPRB, 0.66704082E-08_JPRB, &
  & 0.59499516E-08_JPRB, 0.53175948E-08_JPRB, 0.48352526E-08_JPRB, 0.45507553E-08_JPRB, 0.44783741E-08_JPRB, 0.45840505E-08_JPRB, &
  & 0.47963962E-08_JPRB, 0.50432485E-08_JPRB, 0.52786300E-08_JPRB, 0.54753109E-08_JPRB, 0.56362230E-08_JPRB, 0.57747291E-08_JPRB, &
  & 0.58888192E-08_JPRB, 0.59686212E-08_JPRB, 0.60314216E-08_JPRB, 0.60578800E-08_JPRB /)

RGHG2(:, 2,11) = (/ &
  & 0.37819170E-07_JPRB, 0.37257550E-07_JPRB, 0.35790322E-07_JPRB, 0.34692668E-07_JPRB, 0.33546229E-07_JPRB, 0.32404728E-07_JPRB, &
  & 0.31271931E-07_JPRB, 0.30227071E-07_JPRB, 0.29428342E-07_JPRB, 0.28816554E-07_JPRB, 0.28433311E-07_JPRB, 0.28340505E-07_JPRB, &
  & 0.28622859E-07_JPRB, 0.29340645E-07_JPRB, 0.30454043E-07_JPRB, 0.31818651E-07_JPRB, 0.33212494E-07_JPRB, 0.34441264E-07_JPRB, &
  & 0.35368991E-07_JPRB, 0.35927087E-07_JPRB, 0.36108851E-07_JPRB, 0.35959655E-07_JPRB, 0.35555367E-07_JPRB, 0.34972679E-07_JPRB, &
  & 0.34277488E-07_JPRB, 0.33511355E-07_JPRB, 0.32682099E-07_JPRB, 0.31796862E-07_JPRB, 0.30887531E-07_JPRB, 0.29971030E-07_JPRB, &
  & 0.29036414E-07_JPRB, 0.28082257E-07_JPRB, 0.27122908E-07_JPRB, 0.26179277E-07_JPRB, 0.25293815E-07_JPRB, 0.24511332E-07_JPRB, &
  & 0.23872035E-07_JPRB, 0.23397275E-07_JPRB, 0.23040727E-07_JPRB, 0.22723768E-07_JPRB, 0.22351198E-07_JPRB, 0.21852944E-07_JPRB, &
  & 0.21201306E-07_JPRB, 0.20413141E-07_JPRB, 0.19508381E-07_JPRB, 0.18535125E-07_JPRB, 0.17555724E-07_JPRB, 0.16589670E-07_JPRB, &
  & 0.15545222E-07_JPRB, 0.14259465E-07_JPRB, 0.12684121E-07_JPRB, 0.11014571E-07_JPRB, 0.95565413E-08_JPRB, 0.84897849E-08_JPRB, &
  & 0.78133304E-08_JPRB, 0.74477544E-08_JPRB, 0.73032416E-08_JPRB, 0.73189361E-08_JPRB, 0.74237589E-08_JPRB, 0.75449993E-08_JPRB, &
  & 0.76973814E-08_JPRB, 0.78099998E-08_JPRB, 0.79773672E-08_JPRB, 0.81182927E-08_JPRB /)

RGHG2(:, 3,11) = (/ &
  & 0.39004831E-07_JPRB, 0.38716301E-07_JPRB, 0.38478589E-07_JPRB, 0.38271466E-07_JPRB, 0.38156628E-07_JPRB, 0.38069810E-07_JPRB, &
  & 0.38020339E-07_JPRB, 0.38028141E-07_JPRB, 0.38136868E-07_JPRB, 0.38350201E-07_JPRB, 0.38721588E-07_JPRB, 0.39276919E-07_JPRB, &
  & 0.40088779E-07_JPRB, 0.41175149E-07_JPRB, 0.42455429E-07_JPRB, 0.43791470E-07_JPRB, 0.45052168E-07_JPRB, 0.46152127E-07_JPRB, &
  & 0.47041510E-07_JPRB, 0.47680039E-07_JPRB, 0.48051941E-07_JPRB, 0.48170392E-07_JPRB, 0.48073630E-07_JPRB, 0.47808982E-07_JPRB, &
  & 0.47421178E-07_JPRB, 0.46935234E-07_JPRB, 0.46367024E-07_JPRB, 0.45717353E-07_JPRB, 0.45011880E-07_JPRB, 0.44256705E-07_JPRB, &
  & 0.43433769E-07_JPRB, 0.42516696E-07_JPRB, 0.41498438E-07_JPRB, 0.40411528E-07_JPRB, 0.39327400E-07_JPRB, 0.38315704E-07_JPRB, &
  & 0.37418744E-07_JPRB, 0.36626840E-07_JPRB, 0.35888466E-07_JPRB, 0.35129283E-07_JPRB, 0.34282955E-07_JPRB, 0.33283975E-07_JPRB, &
  & 0.32102097E-07_JPRB, 0.30735581E-07_JPRB, 0.29196727E-07_JPRB, 0.27507383E-07_JPRB, 0.25669074E-07_JPRB, 0.23644194E-07_JPRB, &
  & 0.21430317E-07_JPRB, 0.19195154E-07_JPRB, 0.17202758E-07_JPRB, 0.15516962E-07_JPRB, 0.13992601E-07_JPRB, 0.12613517E-07_JPRB, &
  & 0.11542635E-07_JPRB, 0.10884885E-07_JPRB, 0.10626891E-07_JPRB, 0.10678038E-07_JPRB, 0.10976711E-07_JPRB, 0.11464413E-07_JPRB, &
  & 0.12080071E-07_JPRB, 0.12690981E-07_JPRB, 0.13525847E-07_JPRB, 0.14658836E-07_JPRB /)

RGHG2(:, 4,11) = (/ &
  & 0.39319662E-07_JPRB, 0.39406668E-07_JPRB, 0.39559616E-07_JPRB, 0.39746894E-07_JPRB, 0.39990471E-07_JPRB, 0.40304471E-07_JPRB, &
  & 0.40679485E-07_JPRB, 0.41112962E-07_JPRB, 0.41613429E-07_JPRB, 0.42207240E-07_JPRB, 0.42907793E-07_JPRB, 0.43801485E-07_JPRB, &
  & 0.44838984E-07_JPRB, 0.45991207E-07_JPRB, 0.47221970E-07_JPRB, 0.48481777E-07_JPRB, 0.49689550E-07_JPRB, 0.50827062E-07_JPRB, &
  & 0.51869627E-07_JPRB, 0.52765177E-07_JPRB, 0.53451412E-07_JPRB, 0.53896564E-07_JPRB, 0.54108462E-07_JPRB, 0.54131661E-07_JPRB, &
  & 0.54032341E-07_JPRB, 0.53857050E-07_JPRB, 0.53601525E-07_JPRB, 0.53237180E-07_JPRB, 0.52741612E-07_JPRB, 0.52135377E-07_JPRB, &
  & 0.51441226E-07_JPRB, 0.50646236E-07_JPRB, 0.49726438E-07_JPRB, 0.48686282E-07_JPRB, 0.47564381E-07_JPRB, 0.46426354E-07_JPRB, &
  & 0.45334836E-07_JPRB, 0.44328136E-07_JPRB, 0.43382471E-07_JPRB, 0.42423459E-07_JPRB, 0.41366015E-07_JPRB, 0.40181085E-07_JPRB, &
  & 0.38872702E-07_JPRB, 0.37435903E-07_JPRB, 0.35856775E-07_JPRB, 0.34106428E-07_JPRB, 0.32151142E-07_JPRB, 0.29992314E-07_JPRB, &
  & 0.27716698E-07_JPRB, 0.25415432E-07_JPRB, 0.23048631E-07_JPRB, 0.20607517E-07_JPRB, 0.18326514E-07_JPRB, 0.16464977E-07_JPRB, &
  & 0.15126089E-07_JPRB, 0.14393404E-07_JPRB, 0.14339715E-07_JPRB, 0.14967615E-07_JPRB, 0.16136310E-07_JPRB, 0.17673708E-07_JPRB, &
  & 0.19454486E-07_JPRB, 0.21241529E-07_JPRB, 0.23413527E-07_JPRB, 0.26452568E-07_JPRB /)

RGHG2(:, 5,11) = (/ &
  & 0.39407709E-07_JPRB, 0.39592930E-07_JPRB, 0.39892377E-07_JPRB, 0.40244505E-07_JPRB, 0.40631015E-07_JPRB, 0.41055745E-07_JPRB, &
  & 0.41545174E-07_JPRB, 0.42117527E-07_JPRB, 0.42808132E-07_JPRB, 0.43579039E-07_JPRB, 0.44492012E-07_JPRB, 0.45545555E-07_JPRB, &
  & 0.46735568E-07_JPRB, 0.47996828E-07_JPRB, 0.49286601E-07_JPRB, 0.50652726E-07_JPRB, 0.52084822E-07_JPRB, 0.53485465E-07_JPRB, &
  & 0.54800530E-07_JPRB, 0.55997901E-07_JPRB, 0.57052016E-07_JPRB, 0.57899420E-07_JPRB, 0.58495477E-07_JPRB, 0.58791169E-07_JPRB, &
  & 0.58804190E-07_JPRB, 0.58641479E-07_JPRB, 0.58463623E-07_JPRB, 0.58373960E-07_JPRB, 0.58355099E-07_JPRB, 0.58306519E-07_JPRB, &
  & 0.58136411E-07_JPRB, 0.57818767E-07_JPRB, 0.57378536E-07_JPRB, 0.56880641E-07_JPRB, 0.56429077E-07_JPRB, 0.56146149E-07_JPRB, &
  & 0.56130997E-07_JPRB, 0.56364158E-07_JPRB, 0.56637120E-07_JPRB, 0.56598424E-07_JPRB, 0.55913667E-07_JPRB, 0.54436946E-07_JPRB, &
  & 0.52254727E-07_JPRB, 0.49581139E-07_JPRB, 0.46627918E-07_JPRB, 0.43605411E-07_JPRB, 0.40684469E-07_JPRB, 0.37914049E-07_JPRB, &
  & 0.35204963E-07_JPRB, 0.32427081E-07_JPRB, 0.29570765E-07_JPRB, 0.26771104E-07_JPRB, 0.24129324E-07_JPRB, 0.21751063E-07_JPRB, &
  & 0.19917259E-07_JPRB, 0.18982385E-07_JPRB, 0.19215047E-07_JPRB, 0.20631903E-07_JPRB, 0.22990228E-07_JPRB, 0.25805138E-07_JPRB, &
  & 0.28672343E-07_JPRB, 0.31390059E-07_JPRB, 0.34180690E-07_JPRB, 0.38464414E-07_JPRB /)

RGHG2(:, 6,11) = (/ &
  & 0.39661554E-07_JPRB, 0.39935042E-07_JPRB, 0.40191662E-07_JPRB, 0.40497774E-07_JPRB, 0.40889496E-07_JPRB, 0.41373077E-07_JPRB, &
  & 0.41945956E-07_JPRB, 0.42642160E-07_JPRB, 0.43504709E-07_JPRB, 0.44487951E-07_JPRB, 0.45592671E-07_JPRB, 0.46872252E-07_JPRB, &
  & 0.48356227E-07_JPRB, 0.49993165E-07_JPRB, 0.51666827E-07_JPRB, 0.53331036E-07_JPRB, 0.55019498E-07_JPRB, 0.56793979E-07_JPRB, &
  & 0.58563884E-07_JPRB, 0.60199476E-07_JPRB, 0.61668260E-07_JPRB, 0.62987574E-07_JPRB, 0.64179282E-07_JPRB, 0.65292951E-07_JPRB, &
  & 0.66332518E-07_JPRB, 0.67267841E-07_JPRB, 0.68068481E-07_JPRB, 0.68741699E-07_JPRB, 0.69379205E-07_JPRB, 0.70095290E-07_JPRB, &
  & 0.70969605E-07_JPRB, 0.71999828E-07_JPRB, 0.73147007E-07_JPRB, 0.74401001E-07_JPRB, 0.75737375E-07_JPRB, 0.77058502E-07_JPRB, &
  & 0.78258815E-07_JPRB, 0.79219404E-07_JPRB, 0.79706624E-07_JPRB, 0.79404415E-07_JPRB, 0.78120728E-07_JPRB, 0.75893901E-07_JPRB, &
  & 0.72985543E-07_JPRB, 0.69661581E-07_JPRB, 0.66158023E-07_JPRB, 0.62557163E-07_JPRB, 0.58799039E-07_JPRB, 0.54790224E-07_JPRB, &
  & 0.50566797E-07_JPRB, 0.46281102E-07_JPRB, 0.42069360E-07_JPRB, 0.38012871E-07_JPRB, 0.34229078E-07_JPRB, 0.30978029E-07_JPRB, &
  & 0.28583836E-07_JPRB, 0.27433227E-07_JPRB, 0.27833073E-07_JPRB, 0.29708341E-07_JPRB, 0.32550446E-07_JPRB, 0.35739543E-07_JPRB, &
  & 0.38872400E-07_JPRB, 0.41813827E-07_JPRB, 0.44884729E-07_JPRB, 0.48910501E-07_JPRB /)

RGHG2(:, 7,11) = (/ &
  & 0.40276692E-07_JPRB, 0.40433292E-07_JPRB, 0.40705636E-07_JPRB, 0.41113182E-07_JPRB, 0.41604579E-07_JPRB, 0.42174825E-07_JPRB, &
  & 0.42868123E-07_JPRB, 0.43720881E-07_JPRB, 0.44829203E-07_JPRB, 0.46096091E-07_JPRB, 0.47500073E-07_JPRB, 0.48987772E-07_JPRB, &
  & 0.50609103E-07_JPRB, 0.52462244E-07_JPRB, 0.54631116E-07_JPRB, 0.57035692E-07_JPRB, 0.59483888E-07_JPRB, 0.61940177E-07_JPRB, &
  & 0.64458284E-07_JPRB, 0.67050046E-07_JPRB, 0.69633714E-07_JPRB, 0.72131684E-07_JPRB, 0.74482543E-07_JPRB, 0.76649172E-07_JPRB, &
  & 0.78646863E-07_JPRB, 0.80515534E-07_JPRB, 0.82402202E-07_JPRB, 0.84492839E-07_JPRB, 0.86896733E-07_JPRB, 0.89706141E-07_JPRB, &
  & 0.92876185E-07_JPRB, 0.96211124E-07_JPRB, 0.99307151E-07_JPRB, 0.10176665E-06_JPRB, 0.10358839E-06_JPRB, 0.10504880E-06_JPRB, &
  & 0.10622774E-06_JPRB, 0.10692871E-06_JPRB, 0.10680805E-06_JPRB, 0.10547010E-06_JPRB, 0.10271720E-06_JPRB, 0.98936248E-07_JPRB, &
  & 0.94706678E-07_JPRB, 0.90513090E-07_JPRB, 0.86458471E-07_JPRB, 0.82490999E-07_JPRB, 0.78502708E-07_JPRB, 0.74429877E-07_JPRB, &
  & 0.70208849E-07_JPRB, 0.65721295E-07_JPRB, 0.60937765E-07_JPRB, 0.56006336E-07_JPRB, 0.51259882E-07_JPRB, 0.47115009E-07_JPRB, &
  & 0.44079776E-07_JPRB, 0.42592525E-07_JPRB, 0.42811727E-07_JPRB, 0.44420918E-07_JPRB, 0.46847546E-07_JPRB, 0.49515013E-07_JPRB, &
  & 0.52050972E-07_JPRB, 0.54398775E-07_JPRB, 0.56650578E-07_JPRB, 0.60630100E-07_JPRB /)

RGHG2(:, 8,11) = (/ &
  & 0.42947246E-07_JPRB, 0.42676188E-07_JPRB, 0.42998067E-07_JPRB, 0.43456172E-07_JPRB, 0.44021238E-07_JPRB, 0.44705693E-07_JPRB, &
  & 0.45522668E-07_JPRB, 0.46545164E-07_JPRB, 0.47860272E-07_JPRB, 0.49419157E-07_JPRB, 0.51233336E-07_JPRB, 0.53267673E-07_JPRB, &
  & 0.55463236E-07_JPRB, 0.57790359E-07_JPRB, 0.60267872E-07_JPRB, 0.63109667E-07_JPRB, 0.66416362E-07_JPRB, 0.69986655E-07_JPRB, &
  & 0.73618786E-07_JPRB, 0.77282294E-07_JPRB, 0.81057934E-07_JPRB, 0.84985174E-07_JPRB, 0.89079684E-07_JPRB, 0.93314277E-07_JPRB, &
  & 0.97632068E-07_JPRB, 0.10202159E-06_JPRB, 0.10647388E-06_JPRB, 0.11106336E-06_JPRB, 0.11585547E-06_JPRB, 0.12081524E-06_JPRB, &
  & 0.12582838E-06_JPRB, 0.13070860E-06_JPRB, 0.13543193E-06_JPRB, 0.13982223E-06_JPRB, 0.14319745E-06_JPRB, 0.14512878E-06_JPRB, &
  & 0.14565209E-06_JPRB, 0.14469138E-06_JPRB, 0.14205754E-06_JPRB, 0.13759303E-06_JPRB, 0.13170903E-06_JPRB, 0.12514636E-06_JPRB, &
  & 0.11900801E-06_JPRB, 0.11359607E-06_JPRB, 0.10881540E-06_JPRB, 0.10438926E-06_JPRB, 0.10011206E-06_JPRB, 0.95845280E-07_JPRB, &
  & 0.91429627E-07_JPRB, 0.86781739E-07_JPRB, 0.81907160E-07_JPRB, 0.76924437E-07_JPRB, 0.72076546E-07_JPRB, 0.67801359E-07_JPRB, &
  & 0.64574714E-07_JPRB, 0.62750402E-07_JPRB, 0.62331303E-07_JPRB, 0.62982608E-07_JPRB, 0.64274360E-07_JPRB, 0.65829781E-07_JPRB, &
  & 0.67384157E-07_JPRB, 0.68875082E-07_JPRB, 0.70321065E-07_JPRB, 0.72060963E-07_JPRB /)

RGHG2(:, 9,11) = (/ &
  & 0.47961997E-07_JPRB, 0.48044299E-07_JPRB, 0.48428507E-07_JPRB, 0.48987907E-07_JPRB, 0.49722761E-07_JPRB, 0.50629030E-07_JPRB, &
  & 0.51735380E-07_JPRB, 0.53069797E-07_JPRB, 0.54737043E-07_JPRB, 0.56627535E-07_JPRB, 0.58810969E-07_JPRB, 0.61298408E-07_JPRB, &
  & 0.64075280E-07_JPRB, 0.67247043E-07_JPRB, 0.70728845E-07_JPRB, 0.74316496E-07_JPRB, 0.78185295E-07_JPRB, 0.82586283E-07_JPRB, &
  & 0.87536115E-07_JPRB, 0.92942422E-07_JPRB, 0.98671549E-07_JPRB, 0.10477648E-06_JPRB, 0.11112516E-06_JPRB, 0.11769134E-06_JPRB, &
  & 0.12435599E-06_JPRB, 0.13099532E-06_JPRB, 0.13767428E-06_JPRB, 0.14435247E-06_JPRB, 0.15118148E-06_JPRB, 0.15818541E-06_JPRB, &
  & 0.16541004E-06_JPRB, 0.17253363E-06_JPRB, 0.17875627E-06_JPRB, 0.18356937E-06_JPRB, 0.18680429E-06_JPRB, 0.18806239E-06_JPRB, &
  & 0.18731414E-06_JPRB, 0.18469153E-06_JPRB, 0.18009735E-06_JPRB, 0.17370610E-06_JPRB, 0.16588973E-06_JPRB, 0.15757007E-06_JPRB, &
  & 0.14939732E-06_JPRB, 0.14205509E-06_JPRB, 0.13559473E-06_JPRB, 0.12988851E-06_JPRB, 0.12466930E-06_JPRB, 0.11964362E-06_JPRB, &
  & 0.11457026E-06_JPRB, 0.10931973E-06_JPRB, 0.10388237E-06_JPRB, 0.98393429E-07_JPRB, 0.93134616E-07_JPRB, 0.88494559E-07_JPRB, &
  & 0.84870422E-07_JPRB, 0.82465476E-07_JPRB, 0.81250128E-07_JPRB, 0.80980584E-07_JPRB, 0.81380946E-07_JPRB, 0.82168633E-07_JPRB, &
  & 0.83146702E-07_JPRB, 0.84107853E-07_JPRB, 0.85369422E-07_JPRB, 0.87311179E-07_JPRB /)

RGHG2(:,10,11) = (/ &
  & 0.59115266E-07_JPRB, 0.59021858E-07_JPRB, 0.59464359E-07_JPRB, 0.60272136E-07_JPRB, 0.61397174E-07_JPRB, 0.62830821E-07_JPRB, &
  & 0.64566905E-07_JPRB, 0.66637952E-07_JPRB, 0.69110726E-07_JPRB, 0.71844880E-07_JPRB, 0.74909359E-07_JPRB, 0.78401932E-07_JPRB, &
  & 0.82301263E-07_JPRB, 0.86537376E-07_JPRB, 0.91490399E-07_JPRB, 0.97077518E-07_JPRB, 0.10308795E-06_JPRB, 0.10946642E-06_JPRB, &
  & 0.11629932E-06_JPRB, 0.12379688E-06_JPRB, 0.13165830E-06_JPRB, 0.14008992E-06_JPRB, 0.14877223E-06_JPRB, 0.15768315E-06_JPRB, &
  & 0.16645318E-06_JPRB, 0.17495904E-06_JPRB, 0.18314320E-06_JPRB, 0.19102767E-06_JPRB, 0.19891034E-06_JPRB, 0.20683326E-06_JPRB, &
  & 0.21480369E-06_JPRB, 0.22269242E-06_JPRB, 0.23002676E-06_JPRB, 0.23554676E-06_JPRB, 0.23866622E-06_JPRB, 0.23942394E-06_JPRB, &
  & 0.23785620E-06_JPRB, 0.23435071E-06_JPRB, 0.22936396E-06_JPRB, 0.22268109E-06_JPRB, 0.21412798E-06_JPRB, 0.20412558E-06_JPRB, &
  & 0.19404342E-06_JPRB, 0.18455945E-06_JPRB, 0.17604319E-06_JPRB, 0.16824370E-06_JPRB, 0.16087981E-06_JPRB, 0.15362556E-06_JPRB, &
  & 0.14627928E-06_JPRB, 0.13878036E-06_JPRB, 0.13120537E-06_JPRB, 0.12374990E-06_JPRB, 0.11681836E-06_JPRB, 0.11087361E-06_JPRB, &
  & 0.10627771E-06_JPRB, 0.10317061E-06_JPRB, 0.10142769E-06_JPRB, 0.10072799E-06_JPRB, 0.10073542E-06_JPRB, 0.10114237E-06_JPRB, &
  & 0.10168591E-06_JPRB, 0.10231386E-06_JPRB, 0.10279795E-06_JPRB, 0.10362123E-06_JPRB /)

RGHG2(:,11,11) = (/ &
  & 0.78488327E-07_JPRB, 0.78511988E-07_JPRB, 0.79365591E-07_JPRB, 0.80750979E-07_JPRB, 0.82623096E-07_JPRB, 0.84962963E-07_JPRB, &
  & 0.87771710E-07_JPRB, 0.91052257E-07_JPRB, 0.94855210E-07_JPRB, 0.98965998E-07_JPRB, 0.10341151E-06_JPRB, 0.10833948E-06_JPRB, &
  & 0.11400756E-06_JPRB, 0.12041630E-06_JPRB, 0.12757734E-06_JPRB, 0.13587928E-06_JPRB, 0.14528143E-06_JPRB, 0.15562114E-06_JPRB, &
  & 0.16667953E-06_JPRB, 0.17845501E-06_JPRB, 0.19056910E-06_JPRB, 0.20288755E-06_JPRB, 0.21497519E-06_JPRB, 0.22661318E-06_JPRB, &
  & 0.23697567E-06_JPRB, 0.24616685E-06_JPRB, 0.25398330E-06_JPRB, 0.26074960E-06_JPRB, 0.26694278E-06_JPRB, 0.27288223E-06_JPRB, &
  & 0.27908766E-06_JPRB, 0.28522928E-06_JPRB, 0.29122089E-06_JPRB, 0.29660032E-06_JPRB, 0.30024137E-06_JPRB, 0.30172458E-06_JPRB, &
  & 0.30109817E-06_JPRB, 0.29874920E-06_JPRB, 0.29513669E-06_JPRB, 0.29039666E-06_JPRB, 0.28411924E-06_JPRB, 0.27611844E-06_JPRB, &
  & 0.26667419E-06_JPRB, 0.25643914E-06_JPRB, 0.24582047E-06_JPRB, 0.23506628E-06_JPRB, 0.22402527E-06_JPRB, 0.21264967E-06_JPRB, &
  & 0.20082965E-06_JPRB, 0.18872630E-06_JPRB, 0.17652997E-06_JPRB, 0.16483165E-06_JPRB, 0.15422088E-06_JPRB, 0.14535563E-06_JPRB, &
  & 0.13856041E-06_JPRB, 0.13382561E-06_JPRB, 0.13082894E-06_JPRB, 0.12910988E-06_JPRB, 0.12827354E-06_JPRB, 0.12799019E-06_JPRB, &
  & 0.12800470E-06_JPRB, 0.12813467E-06_JPRB, 0.12835679E-06_JPRB, 0.12856243E-06_JPRB /)

RGHG2(:,12,11) = (/ &
  & 0.10931466E-06_JPRB, 0.10946872E-06_JPRB, 0.11104373E-06_JPRB, 0.11349299E-06_JPRB, 0.11672635E-06_JPRB, 0.12075311E-06_JPRB, &
  & 0.12558490E-06_JPRB, 0.13122755E-06_JPRB, 0.13771941E-06_JPRB, 0.14478687E-06_JPRB, 0.15241558E-06_JPRB, 0.16067413E-06_JPRB, &
  & 0.16977056E-06_JPRB, 0.18011863E-06_JPRB, 0.19183798E-06_JPRB, 0.20507768E-06_JPRB, 0.21998832E-06_JPRB, 0.23622874E-06_JPRB, &
  & 0.25338719E-06_JPRB, 0.27101794E-06_JPRB, 0.28849789E-06_JPRB, 0.30494800E-06_JPRB, 0.32013247E-06_JPRB, 0.33330846E-06_JPRB, &
  & 0.34358388E-06_JPRB, 0.35106751E-06_JPRB, 0.35556982E-06_JPRB, 0.35767198E-06_JPRB, 0.35846881E-06_JPRB, 0.35911515E-06_JPRB, &
  & 0.36055602E-06_JPRB, 0.36384355E-06_JPRB, 0.36856756E-06_JPRB, 0.37427131E-06_JPRB, 0.37889862E-06_JPRB, 0.38142190E-06_JPRB, &
  & 0.38262175E-06_JPRB, 0.38299171E-06_JPRB, 0.38230405E-06_JPRB, 0.38059827E-06_JPRB, 0.37817546E-06_JPRB, 0.37461427E-06_JPRB, &
  & 0.36905013E-06_JPRB, 0.36076673E-06_JPRB, 0.34965831E-06_JPRB, 0.33630556E-06_JPRB, 0.32108377E-06_JPRB, 0.30441097E-06_JPRB, &
  & 0.28655998E-06_JPRB, 0.26793555E-06_JPRB, 0.24915198E-06_JPRB, 0.23095653E-06_JPRB, 0.21443617E-06_JPRB, 0.20032056E-06_JPRB, &
  & 0.18909655E-06_JPRB, 0.18067389E-06_JPRB, 0.17465895E-06_JPRB, 0.17048502E-06_JPRB, 0.16768134E-06_JPRB, 0.16583714E-06_JPRB, &
  & 0.16469947E-06_JPRB, 0.16379684E-06_JPRB, 0.16317684E-06_JPRB, 0.16172733E-06_JPRB /)

RGHG2(:,13,11) = (/ &
  & 0.15421449E-06_JPRB, 0.15558804E-06_JPRB, 0.15871822E-06_JPRB, 0.16300814E-06_JPRB, 0.16843933E-06_JPRB, 0.17507091E-06_JPRB, &
  & 0.18294411E-06_JPRB, 0.19205258E-06_JPRB, 0.20238484E-06_JPRB, 0.21354937E-06_JPRB, 0.22548176E-06_JPRB, 0.23829253E-06_JPRB, &
  & 0.25223221E-06_JPRB, 0.26772926E-06_JPRB, 0.28531559E-06_JPRB, 0.30503153E-06_JPRB, 0.32697562E-06_JPRB, 0.35057278E-06_JPRB, &
  & 0.37497199E-06_JPRB, 0.39924743E-06_JPRB, 0.42224235E-06_JPRB, 0.44253491E-06_JPRB, 0.45942400E-06_JPRB, 0.47231586E-06_JPRB, &
  & 0.48014346E-06_JPRB, 0.48305850E-06_JPRB, 0.48140561E-06_JPRB, 0.47633259E-06_JPRB, 0.46957882E-06_JPRB, 0.46267436E-06_JPRB, &
  & 0.45797870E-06_JPRB, 0.45633817E-06_JPRB, 0.45877454E-06_JPRB, 0.46284288E-06_JPRB, 0.46849775E-06_JPRB, 0.47485557E-06_JPRB, &
  & 0.48025521E-06_JPRB, 0.48422567E-06_JPRB, 0.48732352E-06_JPRB, 0.48984225E-06_JPRB, 0.49142727E-06_JPRB, 0.49138413E-06_JPRB, &
  & 0.48872369E-06_JPRB, 0.48233483E-06_JPRB, 0.47159122E-06_JPRB, 0.45677416E-06_JPRB, 0.43851216E-06_JPRB, 0.41746424E-06_JPRB, &
  & 0.39427621E-06_JPRB, 0.36974876E-06_JPRB, 0.34461894E-06_JPRB, 0.32002913E-06_JPRB, 0.29706629E-06_JPRB, 0.27684166E-06_JPRB, &
  & 0.25995223E-06_JPRB, 0.24652911E-06_JPRB, 0.23621263E-06_JPRB, 0.22845811E-06_JPRB, 0.22275394E-06_JPRB, 0.21866009E-06_JPRB, &
  & 0.21565323E-06_JPRB, 0.21361251E-06_JPRB, 0.21135556E-06_JPRB, 0.20872724E-06_JPRB /)

RGHG2(:,14,11) = (/ &
  & 0.21068234E-06_JPRB, 0.21466549E-06_JPRB, 0.22016646E-06_JPRB, 0.22708906E-06_JPRB, 0.23557061E-06_JPRB, 0.24577997E-06_JPRB, &
  & 0.25782171E-06_JPRB, 0.27168775E-06_JPRB, 0.28732018E-06_JPRB, 0.30412667E-06_JPRB, 0.32188510E-06_JPRB, 0.34048719E-06_JPRB, &
  & 0.36015783E-06_JPRB, 0.38138973E-06_JPRB, 0.40493697E-06_JPRB, 0.43117282E-06_JPRB, 0.45983316E-06_JPRB, 0.49019633E-06_JPRB, &
  & 0.52089774E-06_JPRB, 0.55055119E-06_JPRB, 0.57760911E-06_JPRB, 0.60012025E-06_JPRB, 0.61705180E-06_JPRB, 0.62776360E-06_JPRB, &
  & 0.63153357E-06_JPRB, 0.62843975E-06_JPRB, 0.61934907E-06_JPRB, 0.60567174E-06_JPRB, 0.58993385E-06_JPRB, 0.57527905E-06_JPRB, &
  & 0.56361256E-06_JPRB, 0.55736302E-06_JPRB, 0.55592773E-06_JPRB, 0.56135326E-06_JPRB, 0.57111384E-06_JPRB, 0.58175067E-06_JPRB, &
  & 0.59159430E-06_JPRB, 0.60006687E-06_JPRB, 0.60699227E-06_JPRB, 0.61231265E-06_JPRB, 0.61578413E-06_JPRB, 0.61693817E-06_JPRB, &
  & 0.61510883E-06_JPRB, 0.60921371E-06_JPRB, 0.59855080E-06_JPRB, 0.58331744E-06_JPRB, 0.56393088E-06_JPRB, 0.54088662E-06_JPRB, &
  & 0.51494163E-06_JPRB, 0.48692641E-06_JPRB, 0.45785515E-06_JPRB, 0.42879702E-06_JPRB, 0.40108389E-06_JPRB, 0.37579363E-06_JPRB, &
  & 0.35378585E-06_JPRB, 0.33536867E-06_JPRB, 0.32044028E-06_JPRB, 0.30857007E-06_JPRB, 0.29933977E-06_JPRB, 0.29232459E-06_JPRB, &
  & 0.28709897E-06_JPRB, 0.28290359E-06_JPRB, 0.27922761E-06_JPRB, 0.27289391E-06_JPRB /)

RGHG2(:,15,11) = (/ &
  & 0.27657268E-06_JPRB, 0.28469418E-06_JPRB, 0.29330641E-06_JPRB, 0.30348716E-06_JPRB, 0.31563968E-06_JPRB, 0.33006015E-06_JPRB, &
  & 0.34690595E-06_JPRB, 0.36615148E-06_JPRB, 0.38762599E-06_JPRB, 0.41053940E-06_JPRB, 0.43449617E-06_JPRB, 0.45925736E-06_JPRB, &
  & 0.48483605E-06_JPRB, 0.51156900E-06_JPRB, 0.54008910E-06_JPRB, 0.57111396E-06_JPRB, 0.60451856E-06_JPRB, 0.63936034E-06_JPRB, &
  & 0.67395945E-06_JPRB, 0.70658677E-06_JPRB, 0.73540104E-06_JPRB, 0.75836613E-06_JPRB, 0.77397397E-06_JPRB, 0.78169330E-06_JPRB, &
  & 0.78105001E-06_JPRB, 0.77225030E-06_JPRB, 0.75660705E-06_JPRB, 0.73610812E-06_JPRB, 0.71353105E-06_JPRB, 0.69191998E-06_JPRB, &
  & 0.67512173E-06_JPRB, 0.66510574E-06_JPRB, 0.66517401E-06_JPRB, 0.67293303E-06_JPRB, 0.68543864E-06_JPRB, 0.70023634E-06_JPRB, &
  & 0.71457646E-06_JPRB, 0.72682798E-06_JPRB, 0.73638819E-06_JPRB, 0.74317262E-06_JPRB, 0.74717371E-06_JPRB, 0.74810555E-06_JPRB, &
  & 0.74538889E-06_JPRB, 0.73846070E-06_JPRB, 0.72727585E-06_JPRB, 0.71196575E-06_JPRB, 0.69271920E-06_JPRB, 0.66976753E-06_JPRB, &
  & 0.64359517E-06_JPRB, 0.61494933E-06_JPRB, 0.58469186E-06_JPRB, 0.55391143E-06_JPRB, 0.52373372E-06_JPRB, 0.49529655E-06_JPRB, &
  & 0.46949739E-06_JPRB, 0.44689762E-06_JPRB, 0.42761897E-06_JPRB, 0.41156258E-06_JPRB, 0.39850730E-06_JPRB, 0.38812456E-06_JPRB, &
  & 0.38019922E-06_JPRB, 0.37367889E-06_JPRB, 0.36757555E-06_JPRB, 0.35767337E-06_JPRB /)

RGHG2(:,16,11) = (/ &
  & 0.35112464E-06_JPRB, 0.36374726E-06_JPRB, 0.37554128E-06_JPRB, 0.38901268E-06_JPRB, 0.40486316E-06_JPRB, 0.42349475E-06_JPRB, &
  & 0.44507885E-06_JPRB, 0.46956029E-06_JPRB, 0.49662907E-06_JPRB, 0.52521602E-06_JPRB, 0.55463113E-06_JPRB, 0.58443652E-06_JPRB, &
  & 0.61460105E-06_JPRB, 0.64540779E-06_JPRB, 0.67733174E-06_JPRB, 0.71093143E-06_JPRB, 0.74636785E-06_JPRB, 0.78274866E-06_JPRB, &
  & 0.81837669E-06_JPRB, 0.85139288E-06_JPRB, 0.87997677E-06_JPRB, 0.90205344E-06_JPRB, 0.91600981E-06_JPRB, 0.92117216E-06_JPRB, &
  & 0.91734734E-06_JPRB, 0.90490806E-06_JPRB, 0.88528532E-06_JPRB, 0.86102011E-06_JPRB, 0.83499447E-06_JPRB, 0.81159118E-06_JPRB, &
  & 0.79403958E-06_JPRB, 0.78540586E-06_JPRB, 0.78524693E-06_JPRB, 0.79342499E-06_JPRB, 0.80840761E-06_JPRB, 0.82646119E-06_JPRB, &
  & 0.84418093E-06_JPRB, 0.85910432E-06_JPRB, 0.87028695E-06_JPRB, 0.87762743E-06_JPRB, 0.88117497E-06_JPRB, 0.88072687E-06_JPRB, &
  & 0.87619986E-06_JPRB, 0.86782484E-06_JPRB, 0.85587300E-06_JPRB, 0.84053346E-06_JPRB, 0.82190206E-06_JPRB, 0.80008999E-06_JPRB, &
  & 0.77527551E-06_JPRB, 0.74770333E-06_JPRB, 0.71795512E-06_JPRB, 0.68700467E-06_JPRB, 0.65587233E-06_JPRB, 0.62565965E-06_JPRB, &
  & 0.59729587E-06_JPRB, 0.57151635E-06_JPRB, 0.54873391E-06_JPRB, 0.52906290E-06_JPRB, 0.51258610E-06_JPRB, 0.49922897E-06_JPRB, &
  & 0.48843344E-06_JPRB, 0.48015505E-06_JPRB, 0.47124578E-06_JPRB, 0.45901007E-06_JPRB /)

RGHG2(:,17,11) = (/ &
  & 0.43315816E-06_JPRB, 0.44954413E-06_JPRB, 0.46397511E-06_JPRB, 0.48014118E-06_JPRB, 0.49904173E-06_JPRB, 0.52111938E-06_JPRB, &
  & 0.54656738E-06_JPRB, 0.57517457E-06_JPRB, 0.60649398E-06_JPRB, 0.63925717E-06_JPRB, 0.67254416E-06_JPRB, 0.70569229E-06_JPRB, &
  & 0.73855665E-06_JPRB, 0.77144421E-06_JPRB, 0.80487837E-06_JPRB, 0.83928495E-06_JPRB, 0.87479282E-06_JPRB, 0.91070194E-06_JPRB, &
  & 0.94541497E-06_JPRB, 0.97716941E-06_JPRB, 0.10042954E-05_JPRB, 0.10249865E-05_JPRB, 0.10376459E-05_JPRB, 0.10414612E-05_JPRB, &
  & 0.10363605E-05_JPRB, 0.10229589E-05_JPRB, 0.10029038E-05_JPRB, 0.97887414E-06_JPRB, 0.95435735E-06_JPRB, 0.93281494E-06_JPRB, &
  & 0.91674769E-06_JPRB, 0.90863603E-06_JPRB, 0.91009218E-06_JPRB, 0.92016461E-06_JPRB, 0.93628586E-06_JPRB, 0.95537916E-06_JPRB, &
  & 0.97399447E-06_JPRB, 0.98968235E-06_JPRB, 0.10011615E-05_JPRB, 0.10081466E-05_JPRB, 0.10105230E-05_JPRB, 0.10084310E-05_JPRB, &
  & 0.10023558E-05_JPRB, 0.99287524E-06_JPRB, 0.98048872E-06_JPRB, 0.96550866E-06_JPRB, 0.94806137E-06_JPRB, 0.92810546E-06_JPRB, &
  & 0.90539606E-06_JPRB, 0.87983403E-06_JPRB, 0.85177066E-06_JPRB, 0.82181475E-06_JPRB, 0.79080792E-06_JPRB, 0.75976561E-06_JPRB, &
  & 0.72979344E-06_JPRB, 0.70175082E-06_JPRB, 0.67628275E-06_JPRB, 0.65381363E-06_JPRB, 0.63455582E-06_JPRB, 0.61865279E-06_JPRB, &
  & 0.60606385E-06_JPRB, 0.59545857E-06_JPRB, 0.58586676E-06_JPRB, 0.56948278E-06_JPRB /)

RGHG2(:,18,11) = (/ &
  & 0.51720053E-06_JPRB, 0.53683880E-06_JPRB, 0.55307112E-06_JPRB, 0.57105223E-06_JPRB, 0.59193167E-06_JPRB, 0.61630777E-06_JPRB, &
  & 0.64422829E-06_JPRB, 0.67549979E-06_JPRB, 0.70941996E-06_JPRB, 0.74462133E-06_JPRB, 0.78006588E-06_JPRB, 0.81498030E-06_JPRB, &
  & 0.84915303E-06_JPRB, 0.88281638E-06_JPRB, 0.91644569E-06_JPRB, 0.95047130E-06_JPRB, 0.98496832E-06_JPRB, 0.10193862E-05_JPRB, &
  & 0.10523714E-05_JPRB, 0.10822922E-05_JPRB, 0.11076831E-05_JPRB, 0.11270608E-05_JPRB, 0.11390595E-05_JPRB, 0.11428125E-05_JPRB, &
  & 0.11383659E-05_JPRB, 0.11266216E-05_JPRB, 0.11093948E-05_JPRB, 0.10892844E-05_JPRB, 0.10692618E-05_JPRB, 0.10520860E-05_JPRB, &
  & 0.10400687E-05_JPRB, 0.10356812E-05_JPRB, 0.10385885E-05_JPRB, 0.10482578E-05_JPRB, 0.10628091E-05_JPRB, 0.10797257E-05_JPRB, &
  & 0.10965397E-05_JPRB, 0.11108000E-05_JPRB, 0.11212792E-05_JPRB, 0.11269447E-05_JPRB, 0.11279916E-05_JPRB, 0.11246373E-05_JPRB, &
  & 0.11176714E-05_JPRB, 0.11078087E-05_JPRB, 0.10956835E-05_JPRB, 0.10816752E-05_JPRB, 0.10658937E-05_JPRB, 0.10481258E-05_JPRB, &
  & 0.10279375E-05_JPRB, 0.10050894E-05_JPRB, 0.97960708E-06_JPRB, 0.95176864E-06_JPRB, 0.92219597E-06_JPRB, 0.89180378E-06_JPRB, &
  & 0.86161106E-06_JPRB, 0.83265621E-06_JPRB, 0.80580890E-06_JPRB, 0.78159087E-06_JPRB, 0.76050696E-06_JPRB, 0.74278677E-06_JPRB, &
  & 0.72852782E-06_JPRB, 0.71675640E-06_JPRB, 0.70547304E-06_JPRB, 0.68724171E-06_JPRB /)

RGHG2(:,19,11) = (/ &
  & 0.59985865E-06_JPRB, 0.62168414E-06_JPRB, 0.63919168E-06_JPRB, 0.65811491E-06_JPRB, 0.68008649E-06_JPRB, 0.70558110E-06_JPRB, &
  & 0.73476394E-06_JPRB, 0.76712610E-06_JPRB, 0.80198879E-06_JPRB, 0.83793469E-06_JPRB, 0.87392033E-06_JPRB, 0.90919923E-06_JPRB, &
  & 0.94351253E-06_JPRB, 0.97709233E-06_JPRB, 0.10103305E-05_JPRB, 0.10435236E-05_JPRB, 0.10767095E-05_JPRB, 0.11094291E-05_JPRB, &
  & 0.11406019E-05_JPRB, 0.11688516E-05_JPRB, 0.11928478E-05_JPRB, 0.12114212E-05_JPRB, 0.12234671E-05_JPRB, 0.12283361E-05_JPRB, &
  & 0.12260621E-05_JPRB, 0.12176630E-05_JPRB, 0.12050727E-05_JPRB, 0.11905960E-05_JPRB, 0.11768592E-05_JPRB, 0.11656891E-05_JPRB, &
  & 0.11592817E-05_JPRB, 0.11577645E-05_JPRB, 0.11613553E-05_JPRB, 0.11693335E-05_JPRB, 0.11806339E-05_JPRB, 0.11935804E-05_JPRB, &
  & 0.12064258E-05_JPRB, 0.12176029E-05_JPRB, 0.12257567E-05_JPRB, 0.12299081E-05_JPRB, 0.12298287E-05_JPRB, 0.12259106E-05_JPRB, &
  & 0.12187232E-05_JPRB, 0.12091069E-05_JPRB, 0.11976681E-05_JPRB, 0.11848122E-05_JPRB, 0.11706037E-05_JPRB, 0.11547961E-05_JPRB, &
  & 0.11370217E-05_JPRB, 0.11169880E-05_JPRB, 0.10945153E-05_JPRB, 0.10696764E-05_JPRB, 0.10428455E-05_JPRB, 0.10146783E-05_JPRB, &
  & 0.98607904E-06_JPRB, 0.95808423E-06_JPRB, 0.93154267E-06_JPRB, 0.90720243E-06_JPRB, 0.88556288E-06_JPRB, 0.86713021E-06_JPRB, &
  & 0.85172428E-06_JPRB, 0.83944121E-06_JPRB, 0.82650848E-06_JPRB, 0.80768046E-06_JPRB /)

RGHG2(:,20,11) = (/ &
  & 0.67898037E-06_JPRB, 0.70265997E-06_JPRB, 0.72051301E-06_JPRB, 0.73985706E-06_JPRB, 0.76203366E-06_JPRB, 0.78778976E-06_JPRB, &
  & 0.81697362E-06_JPRB, 0.84922817E-06_JPRB, 0.88363680E-06_JPRB, 0.91894759E-06_JPRB, 0.95425708E-06_JPRB, 0.98888893E-06_JPRB, &
  & 0.10225924E-05_JPRB, 0.10554895E-05_JPRB, 0.10879481E-05_JPRB, 0.11201921E-05_JPRB, 0.11521436E-05_JPRB, 0.11833818E-05_JPRB, &
  & 0.12131051E-05_JPRB, 0.12401919E-05_JPRB, 0.12634821E-05_JPRB, 0.12819689E-05_JPRB, 0.12947402E-05_JPRB, 0.13013595E-05_JPRB, &
  & 0.13020881E-05_JPRB, 0.12980479E-05_JPRB, 0.12909870E-05_JPRB, 0.12828485E-05_JPRB, 0.12754593E-05_JPRB, 0.12701513E-05_JPRB, &
  & 0.12674828E-05_JPRB, 0.12679214E-05_JPRB, 0.12711290E-05_JPRB, 0.12765511E-05_JPRB, 0.12838456E-05_JPRB, 0.12922288E-05_JPRB, &
  & 0.13008842E-05_JPRB, 0.13085033E-05_JPRB, 0.13138849E-05_JPRB, 0.13166356E-05_JPRB, 0.13158098E-05_JPRB, 0.13117657E-05_JPRB, &
  & 0.13048536E-05_JPRB, 0.12957826E-05_JPRB, 0.12851225E-05_JPRB, 0.12732614E-05_JPRB, 0.12602995E-05_JPRB, 0.12460837E-05_JPRB, &
  & 0.12303407E-05_JPRB, 0.12127889E-05_JPRB, 0.11932127E-05_JPRB, 0.11715777E-05_JPRB, 0.11480658E-05_JPRB, 0.11230870E-05_JPRB, &
  & 0.10973579E-05_JPRB, 0.10717081E-05_JPRB, 0.10470594E-05_JPRB, 0.10239989E-05_JPRB, 0.10031520E-05_JPRB, 0.98489613E-06_JPRB, &
  & 0.96984684E-06_JPRB, 0.95620067E-06_JPRB, 0.94433858E-06_JPRB, 0.92153499E-06_JPRB /)

RGHG2(:,21,11) = (/ &
  & 0.75308151E-06_JPRB, 0.77753577E-06_JPRB, 0.79592598E-06_JPRB, 0.81511712E-06_JPRB, 0.83706556E-06_JPRB, 0.86220268E-06_JPRB, &
  & 0.89061075E-06_JPRB, 0.92165175E-06_JPRB, 0.95463395E-06_JPRB, 0.98843930E-06_JPRB, 0.10222927E-05_JPRB, 0.10556647E-05_JPRB, &
  & 0.10883253E-05_JPRB, 0.11203317E-05_JPRB, 0.11519295E-05_JPRB, 0.11832863E-05_JPRB, 0.12143057E-05_JPRB, 0.12445051E-05_JPRB, &
  & 0.12731945E-05_JPRB, 0.12995855E-05_JPRB, 0.13227530E-05_JPRB, 0.13417633E-05_JPRB, 0.13558735E-05_JPRB, 0.13647674E-05_JPRB, &
  & 0.13687454E-05_JPRB, 0.13689314E-05_JPRB, 0.13669076E-05_JPRB, 0.13641377E-05_JPRB, 0.13618061E-05_JPRB, 0.13606322E-05_JPRB, &
  & 0.13608044E-05_JPRB, 0.13620424E-05_JPRB, 0.13640679E-05_JPRB, 0.13668482E-05_JPRB, 0.13703590E-05_JPRB, 0.13745847E-05_JPRB, &
  & 0.13794580E-05_JPRB, 0.13839227E-05_JPRB, 0.13874958E-05_JPRB, 0.13887806E-05_JPRB, 0.13876995E-05_JPRB, 0.13836932E-05_JPRB, &
  & 0.13772906E-05_JPRB, 0.13688741E-05_JPRB, 0.13588370E-05_JPRB, 0.13477245E-05_JPRB, 0.13356862E-05_JPRB, 0.13226221E-05_JPRB, &
  & 0.13084016E-05_JPRB, 0.12928068E-05_JPRB, 0.12756657E-05_JPRB, 0.12569233E-05_JPRB, 0.12366336E-05_JPRB, 0.12150492E-05_JPRB, &
  & 0.11926367E-05_JPRB, 0.11701053E-05_JPRB, 0.11480566E-05_JPRB, 0.11271326E-05_JPRB, 0.11078205E-05_JPRB, 0.10905984E-05_JPRB, &
  & 0.10753560E-05_JPRB, 0.10628249E-05_JPRB, 0.10482462E-05_JPRB, 0.10277918E-05_JPRB /)

RGHG2(:,22,11) = (/ &
  & 0.82097245E-06_JPRB, 0.84635542E-06_JPRB, 0.86466753E-06_JPRB, 0.88370911E-06_JPRB, 0.90493916E-06_JPRB, 0.92908783E-06_JPRB, &
  & 0.95597147E-06_JPRB, 0.98526016E-06_JPRB, 0.10162482E-05_JPRB, 0.10480662E-05_JPRB, 0.10801413E-05_JPRB, 0.11120192E-05_JPRB, &
  & 0.11435034E-05_JPRB, 0.11745267E-05_JPRB, 0.12052512E-05_JPRB, 0.12357364E-05_JPRB, 0.12658913E-05_JPRB, 0.12953567E-05_JPRB, &
  & 0.13234887E-05_JPRB, 0.13496153E-05_JPRB, 0.13730328E-05_JPRB, 0.13929742E-05_JPRB, 0.14087150E-05_JPRB, 0.14199404E-05_JPRB, &
  & 0.14270253E-05_JPRB, 0.14309692E-05_JPRB, 0.14329704E-05_JPRB, 0.14341647E-05_JPRB, 0.14352304E-05_JPRB, 0.14365328E-05_JPRB, &
  & 0.14378893E-05_JPRB, 0.14390102E-05_JPRB, 0.14397200E-05_JPRB, 0.14402812E-05_JPRB, 0.14410803E-05_JPRB, 0.14423518E-05_JPRB, &
  & 0.14444446E-05_JPRB, 0.14467574E-05_JPRB, 0.14483778E-05_JPRB, 0.14489253E-05_JPRB, 0.14474776E-05_JPRB, 0.14437675E-05_JPRB, &
  & 0.14378011E-05_JPRB, 0.14299342E-05_JPRB, 0.14204913E-05_JPRB, 0.14098565E-05_JPRB, 0.13984015E-05_JPRB, 0.13861436E-05_JPRB, &
  & 0.13729818E-05_JPRB, 0.13588576E-05_JPRB, 0.13436457E-05_JPRB, 0.13273045E-05_JPRB, 0.13098299E-05_JPRB, 0.12913517E-05_JPRB, &
  & 0.12721939E-05_JPRB, 0.12527390E-05_JPRB, 0.12334829E-05_JPRB, 0.12148387E-05_JPRB, 0.11972461E-05_JPRB, 0.11810680E-05_JPRB, &
  & 0.11668420E-05_JPRB, 0.11531868E-05_JPRB, 0.11406860E-05_JPRB, 0.11167504E-05_JPRB /)

RGHG2(:,23,11) = (/ &
  & 0.88326613E-06_JPRB, 0.90837273E-06_JPRB, 0.92698190E-06_JPRB, 0.94542366E-06_JPRB, 0.96584154E-06_JPRB, 0.98862790E-06_JPRB, &
  & 0.10138407E-05_JPRB, 0.10410682E-05_JPRB, 0.10698843E-05_JPRB, 0.10996376E-05_JPRB, 0.11298586E-05_JPRB, 0.11601854E-05_JPRB, &
  & 0.11904708E-05_JPRB, 0.12206035E-05_JPRB, 0.12505739E-05_JPRB, 0.12803022E-05_JPRB, 0.13096931E-05_JPRB, 0.13384554E-05_JPRB, &
  & 0.13661363E-05_JPRB, 0.13921880E-05_JPRB, 0.14160023E-05_JPRB, 0.14368637E-05_JPRB, 0.14541191E-05_JPRB, 0.14674926E-05_JPRB, &
  & 0.14772069E-05_JPRB, 0.14840081E-05_JPRB, 0.14888318E-05_JPRB, 0.14925181E-05_JPRB, 0.14954861E-05_JPRB, 0.14978480E-05_JPRB, &
  & 0.14994940E-05_JPRB, 0.15002225E-05_JPRB, 0.15000144E-05_JPRB, 0.14991554E-05_JPRB, 0.14982771E-05_JPRB, 0.14976946E-05_JPRB, &
  & 0.14979395E-05_JPRB, 0.14985741E-05_JPRB, 0.14991386E-05_JPRB, 0.14990273E-05_JPRB, 0.14972142E-05_JPRB, 0.14936167E-05_JPRB, &
  & 0.14880637E-05_JPRB, 0.14805926E-05_JPRB, 0.14716093E-05_JPRB, 0.14614008E-05_JPRB, 0.14503232E-05_JPRB, 0.14385931E-05_JPRB, &
  & 0.14261984E-05_JPRB, 0.14131908E-05_JPRB, 0.13994550E-05_JPRB, 0.13849866E-05_JPRB, 0.13697939E-05_JPRB, 0.13539701E-05_JPRB, &
  & 0.13376332E-05_JPRB, 0.13209741E-05_JPRB, 0.13042618E-05_JPRB, 0.12877658E-05_JPRB, 0.12718447E-05_JPRB, 0.12568252E-05_JPRB, &
  & 0.12428010E-05_JPRB, 0.12301670E-05_JPRB, 0.12154644E-05_JPRB, 0.11928101E-05_JPRB /)

RGHG2(:,24,11) = (/ &
  & 0.93980242E-06_JPRB, 0.96490089E-06_JPRB, 0.98307783E-06_JPRB, 0.10010143E-05_JPRB, 0.10204390E-05_JPRB, 0.10419121E-05_JPRB, &
  & 0.10653782E-05_JPRB, 0.10906592E-05_JPRB, 0.11174072E-05_JPRB, 0.11451710E-05_JPRB, 0.11736320E-05_JPRB, 0.12024552E-05_JPRB, &
  & 0.12314970E-05_JPRB, 0.12606372E-05_JPRB, 0.12898363E-05_JPRB, 0.13188974E-05_JPRB, 0.13475835E-05_JPRB, 0.13756101E-05_JPRB, &
  & 0.14027466E-05_JPRB, 0.14286020E-05_JPRB, 0.14526432E-05_JPRB, 0.14742188E-05_JPRB, 0.14926910E-05_JPRB, 0.15076866E-05_JPRB, &
  & 0.15192969E-05_JPRB, 0.15280982E-05_JPRB, 0.15347515E-05_JPRB, 0.15398606E-05_JPRB, 0.15437455E-05_JPRB, 0.15465248E-05_JPRB, &
  & 0.15481447E-05_JPRB, 0.15485441E-05_JPRB, 0.15478583E-05_JPRB, 0.15463131E-05_JPRB, 0.15445453E-05_JPRB, 0.15430669E-05_JPRB, &
  & 0.15421705E-05_JPRB, 0.15417462E-05_JPRB, 0.15414422E-05_JPRB, 0.15406011E-05_JPRB, 0.15386013E-05_JPRB, 0.15349951E-05_JPRB, &
  & 0.15296946E-05_JPRB, 0.15225542E-05_JPRB, 0.15138517E-05_JPRB, 0.15039693E-05_JPRB, 0.14932140E-05_JPRB, 0.14819136E-05_JPRB, &
  & 0.14700807E-05_JPRB, 0.14578388E-05_JPRB, 0.14451925E-05_JPRB, 0.14321794E-05_JPRB, 0.14188065E-05_JPRB, 0.14051072E-05_JPRB, &
  & 0.13910924E-05_JPRB, 0.13768035E-05_JPRB, 0.13623030E-05_JPRB, 0.13477530E-05_JPRB, 0.13333748E-05_JPRB, 0.13194261E-05_JPRB, &
  & 0.13061866E-05_JPRB, 0.12930584E-05_JPRB, 0.12792906E-05_JPRB, 0.12550431E-05_JPRB /)

RGHG2(:,25,11) = (/ &
  & 0.99147348E-06_JPRB, 0.10166387E-05_JPRB, 0.10343838E-05_JPRB, 0.10516213E-05_JPRB, 0.10701081E-05_JPRB, 0.10902891E-05_JPRB, &
  & 0.11122112E-05_JPRB, 0.11356999E-05_JPRB, 0.11605745E-05_JPRB, 0.11865202E-05_JPRB, 0.12133102E-05_JPRB, 0.12406711E-05_JPRB, &
  & 0.12684178E-05_JPRB, 0.12964164E-05_JPRB, 0.13245755E-05_JPRB, 0.13526997E-05_JPRB, 0.13805965E-05_JPRB, 0.14079681E-05_JPRB, &
  & 0.14344937E-05_JPRB, 0.14599223E-05_JPRB, 0.14838770E-05_JPRB, 0.15057554E-05_JPRB, 0.15249107E-05_JPRB, 0.15409315E-05_JPRB, &
  & 0.15538105E-05_JPRB, 0.15638948E-05_JPRB, 0.15716892E-05_JPRB, 0.15776236E-05_JPRB, 0.15819828E-05_JPRB, 0.15849171E-05_JPRB, &
  & 0.15864679E-05_JPRB, 0.15867254E-05_JPRB, 0.15859158E-05_JPRB, 0.15842891E-05_JPRB, 0.15822776E-05_JPRB, 0.15804380E-05_JPRB, &
  & 0.15790160E-05_JPRB, 0.15779185E-05_JPRB, 0.15769828E-05_JPRB, 0.15755484E-05_JPRB, 0.15732154E-05_JPRB, 0.15694893E-05_JPRB, &
  & 0.15642349E-05_JPRB, 0.15573238E-05_JPRB, 0.15488654E-05_JPRB, 0.15392118E-05_JPRB, 0.15286956E-05_JPRB, 0.15176680E-05_JPRB, &
  & 0.15062907E-05_JPRB, 0.14946894E-05_JPRB, 0.14828757E-05_JPRB, 0.14709425E-05_JPRB, 0.14589461E-05_JPRB, 0.14468854E-05_JPRB, &
  & 0.14347008E-05_JPRB, 0.14223085E-05_JPRB, 0.14096962E-05_JPRB, 0.13968909E-05_JPRB, 0.13840471E-05_JPRB, 0.13713541E-05_JPRB, &
  & 0.13589367E-05_JPRB, 0.13465728E-05_JPRB, 0.13327901E-05_JPRB, 0.13082761E-05_JPRB /)

RGHG2(:,26,11) = (/ &
  & 0.10396104E-05_JPRB, 0.10649892E-05_JPRB, 0.10822052E-05_JPRB, 0.10988448E-05_JPRB, 0.11164045E-05_JPRB, 0.11354326E-05_JPRB, &
  & 0.11559478E-05_JPRB, 0.11778567E-05_JPRB, 0.12010307E-05_JPRB, 0.12253073E-05_JPRB, 0.12504941E-05_JPRB, 0.12764015E-05_JPRB, &
  & 0.13028350E-05_JPRB, 0.13296100E-05_JPRB, 0.13566133E-05_JPRB, 0.13836204E-05_JPRB, 0.14104098E-05_JPRB, 0.14367752E-05_JPRB, &
  & 0.14624900E-05_JPRB, 0.14872500E-05_JPRB, 0.15107311E-05_JPRB, 0.15324154E-05_JPRB, 0.15516985E-05_JPRB, 0.15681737E-05_JPRB, &
  & 0.15817283E-05_JPRB, 0.15925809E-05_JPRB, 0.16010875E-05_JPRB, 0.16075595E-05_JPRB, 0.16122364E-05_JPRB, 0.16153068E-05_JPRB, &
  & 0.16169000E-05_JPRB, 0.16172280E-05_JPRB, 0.16165558E-05_JPRB, 0.16151689E-05_JPRB, 0.16133258E-05_JPRB, 0.16114504E-05_JPRB, &
  & 0.16098065E-05_JPRB, 0.16083578E-05_JPRB, 0.16068734E-05_JPRB, 0.16049894E-05_JPRB, 0.16022914E-05_JPRB, 0.15983867E-05_JPRB, &
  & 0.15930985E-05_JPRB, 0.15862986E-05_JPRB, 0.15780340E-05_JPRB, 0.15685686E-05_JPRB, 0.15582534E-05_JPRB, 0.15474396E-05_JPRB, &
  & 0.15363619E-05_JPRB, 0.15251816E-05_JPRB, 0.15140126E-05_JPRB, 0.15029683E-05_JPRB, 0.14920624E-05_JPRB, 0.14812697E-05_JPRB, &
  & 0.14704817E-05_JPRB, 0.14596041E-05_JPRB, 0.14485660E-05_JPRB, 0.14373559E-05_JPRB, 0.14260665E-05_JPRB, 0.14147946E-05_JPRB, &
  & 0.14036286E-05_JPRB, 0.13924222E-05_JPRB, 0.13791457E-05_JPRB, 0.13566226E-05_JPRB /)

RGHG2(:,27,11) = (/ &
  & 0.10856136E-05_JPRB, 0.11113437E-05_JPRB, 0.11281772E-05_JPRB, 0.11441172E-05_JPRB, 0.11608354E-05_JPRB, 0.11787508E-05_JPRB, &
  & 0.11979618E-05_JPRB, 0.12183956E-05_JPRB, 0.12400010E-05_JPRB, 0.12626283E-05_JPRB, 0.12862304E-05_JPRB, 0.13106134E-05_JPRB, &
  & 0.13355725E-05_JPRB, 0.13610636E-05_JPRB, 0.13868064E-05_JPRB, 0.14126847E-05_JPRB, 0.14382940E-05_JPRB, 0.14635009E-05_JPRB, &
  & 0.14880835E-05_JPRB, 0.15117814E-05_JPRB, 0.15343263E-05_JPRB, 0.15553455E-05_JPRB, 0.15742494E-05_JPRB, 0.15906948E-05_JPRB, &
  & 0.16044804E-05_JPRB, 0.16156932E-05_JPRB, 0.16246164E-05_JPRB, 0.16314502E-05_JPRB, 0.16363974E-05_JPRB, 0.16396443E-05_JPRB, &
  & 0.16413908E-05_JPRB, 0.16419247E-05_JPRB, 0.16415322E-05_JPRB, 0.16404962E-05_JPRB, 0.16390204E-05_JPRB, 0.16373199E-05_JPRB, &
  & 0.16356458E-05_JPRB, 0.16339765E-05_JPRB, 0.16321007E-05_JPRB, 0.16298143E-05_JPRB, 0.16267782E-05_JPRB, 0.16226927E-05_JPRB, &
  & 0.16173585E-05_JPRB, 0.16106333E-05_JPRB, 0.16025289E-05_JPRB, 0.15932574E-05_JPRB, 0.15831665E-05_JPRB, 0.15726301E-05_JPRB, &
  & 0.15618523E-05_JPRB, 0.15510261E-05_JPRB, 0.15403232E-05_JPRB, 0.15298941E-05_JPRB, 0.15197896E-05_JPRB, 0.15099483E-05_JPRB, &
  & 0.15002572E-05_JPRB, 0.14906020E-05_JPRB, 0.14808924E-05_JPRB, 0.14711061E-05_JPRB, 0.14612858E-05_JPRB, 0.14515474E-05_JPRB, &
  & 0.14419255E-05_JPRB, 0.14319673E-05_JPRB, 0.14209608E-05_JPRB, 0.14000404E-05_JPRB /)

RGHG2(:,28,11) = (/ &
  & 0.11306421E-05_JPRB, 0.11566842E-05_JPRB, 0.11731064E-05_JPRB, 0.11885032E-05_JPRB, 0.12042924E-05_JPRB, 0.12211351E-05_JPRB, &
  & 0.12390810E-05_JPRB, 0.12581062E-05_JPRB, 0.12781406E-05_JPRB, 0.12991850E-05_JPRB, 0.13211278E-05_JPRB, 0.13438840E-05_JPRB, &
  & 0.13672939E-05_JPRB, 0.13913136E-05_JPRB, 0.14155886E-05_JPRB, 0.14401165E-05_JPRB, 0.14644197E-05_JPRB, 0.14883811E-05_JPRB, &
  & 0.15117066E-05_JPRB, 0.15341656E-05_JPRB, 0.15555573E-05_JPRB, 0.15755891E-05_JPRB, 0.15937873E-05_JPRB, 0.16098220E-05_JPRB, &
  & 0.16234643E-05_JPRB, 0.16347230E-05_JPRB, 0.16438189E-05_JPRB, 0.16508683E-05_JPRB, 0.16560373E-05_JPRB, 0.16594767E-05_JPRB, &
  & 0.16614315E-05_JPRB, 0.16622266E-05_JPRB, 0.16621589E-05_JPRB, 0.16614957E-05_JPRB, 0.16603985E-05_JPRB, 0.16589634E-05_JPRB, &
  & 0.16573457E-05_JPRB, 0.16555589E-05_JPRB, 0.16534285E-05_JPRB, 0.16508235E-05_JPRB, 0.16475033E-05_JPRB, 0.16432389E-05_JPRB, &
  & 0.16378501E-05_JPRB, 0.16311936E-05_JPRB, 0.16232246E-05_JPRB, 0.16141177E-05_JPRB, 0.16041796E-05_JPRB, 0.15937065E-05_JPRB, &
  & 0.15830745E-05_JPRB, 0.15725968E-05_JPRB, 0.15624757E-05_JPRB, 0.15527378E-05_JPRB, 0.15433646E-05_JPRB, 0.15343353E-05_JPRB, &
  & 0.15255443E-05_JPRB, 0.15168772E-05_JPRB, 0.15082619E-05_JPRB, 0.14996706E-05_JPRB, 0.14911595E-05_JPRB, 0.14827700E-05_JPRB, &
  & 0.14745375E-05_JPRB, 0.14662977E-05_JPRB, 0.14564566E-05_JPRB, 0.14394527E-05_JPRB /)

RGHG2(:,29,11) = (/ &
  & 0.11753266E-05_JPRB, 0.12013687E-05_JPRB, 0.12176097E-05_JPRB, 0.12322137E-05_JPRB, 0.12471930E-05_JPRB, 0.12629187E-05_JPRB, &
  & 0.12796274E-05_JPRB, 0.12972455E-05_JPRB, 0.13157916E-05_JPRB, 0.13351863E-05_JPRB, 0.13554978E-05_JPRB, 0.13765592E-05_JPRB, &
  & 0.13984114E-05_JPRB, 0.14207654E-05_JPRB, 0.14435649E-05_JPRB, 0.14666383E-05_JPRB, 0.14895663E-05_JPRB, 0.15121147E-05_JPRB, &
  & 0.15340421E-05_JPRB, 0.15551333E-05_JPRB, 0.15752211E-05_JPRB, 0.15940759E-05_JPRB, 0.16113274E-05_JPRB, 0.16266672E-05_JPRB, &
  & 0.16398894E-05_JPRB, 0.16509135E-05_JPRB, 0.16599346E-05_JPRB, 0.16670378E-05_JPRB, 0.16723335E-05_JPRB, 0.16759392E-05_JPRB, &
  & 0.16780989E-05_JPRB, 0.16791470E-05_JPRB, 0.16793806E-05_JPRB, 0.16790509E-05_JPRB, 0.16782747E-05_JPRB, 0.16770966E-05_JPRB, &
  & 0.16755795E-05_JPRB, 0.16737458E-05_JPRB, 0.16714598E-05_JPRB, 0.16686350E-05_JPRB, 0.16651001E-05_JPRB, 0.16606964E-05_JPRB, &
  & 0.16552628E-05_JPRB, 0.16486706E-05_JPRB, 0.16408615E-05_JPRB, 0.16319518E-05_JPRB, 0.16221879E-05_JPRB, 0.16119795E-05_JPRB, &
  & 0.16017560E-05_JPRB, 0.15917275E-05_JPRB, 0.15819687E-05_JPRB, 0.15726233E-05_JPRB, 0.15638121E-05_JPRB, 0.15554323E-05_JPRB, &
  & 0.15473586E-05_JPRB, 0.15394794E-05_JPRB, 0.15317177E-05_JPRB, 0.15240649E-05_JPRB, 0.15165542E-05_JPRB, 0.15092802E-05_JPRB, &
  & 0.15022144E-05_JPRB, 0.14950837E-05_JPRB, 0.14871493E-05_JPRB, 0.14726878E-05_JPRB /)

RGHG2(:,30,11) = (/ &
  & 0.12194032E-05_JPRB, 0.12457142E-05_JPRB, 0.12612793E-05_JPRB, 0.12753851E-05_JPRB, 0.12893584E-05_JPRB, 0.13040415E-05_JPRB, &
  & 0.13194963E-05_JPRB, 0.13357612E-05_JPRB, 0.13527726E-05_JPRB, 0.13706072E-05_JPRB, 0.13892392E-05_JPRB, 0.14086421E-05_JPRB, &
  & 0.14288631E-05_JPRB, 0.14495688E-05_JPRB, 0.14708481E-05_JPRB, 0.14924790E-05_JPRB, 0.15140079E-05_JPRB, 0.15351382E-05_JPRB, &
  & 0.15556121E-05_JPRB, 0.15752508E-05_JPRB, 0.15939047E-05_JPRB, 0.16114195E-05_JPRB, 0.16275536E-05_JPRB, 0.16420205E-05_JPRB, &
  & 0.16545454E-05_JPRB, 0.16651146E-05_JPRB, 0.16738386E-05_JPRB, 0.16808339E-05_JPRB, 0.16861394E-05_JPRB, 0.16898455E-05_JPRB, &
  & 0.16921664E-05_JPRB, 0.16934207E-05_JPRB, 0.16939002E-05_JPRB, 0.16938325E-05_JPRB, 0.16932993E-05_JPRB, 0.16923252E-05_JPRB, &
  & 0.16909144E-05_JPRB, 0.16890785E-05_JPRB, 0.16867107E-05_JPRB, 0.16837558E-05_JPRB, 0.16800865E-05_JPRB, 0.16755953E-05_JPRB, &
  & 0.16701414E-05_JPRB, 0.16636280E-05_JPRB, 0.16559732E-05_JPRB, 0.16472516E-05_JPRB, 0.16377221E-05_JPRB, 0.16277793E-05_JPRB, &
  & 0.16178276E-05_JPRB, 0.16080526E-05_JPRB, 0.15987372E-05_JPRB, 0.15900287E-05_JPRB, 0.15818330E-05_JPRB, 0.15740380E-05_JPRB, &
  & 0.15665324E-05_JPRB, 0.15592285E-05_JPRB, 0.15520798E-05_JPRB, 0.15450785E-05_JPRB, 0.15383018E-05_JPRB, 0.15317967E-05_JPRB, &
  & 0.15256129E-05_JPRB, 0.15194988E-05_JPRB, 0.15125431E-05_JPRB, 0.15004711E-05_JPRB /)

RGHG2(:,31,11) = (/ &
  & 0.12631224E-05_JPRB, 0.12888233E-05_JPRB, 0.13041894E-05_JPRB, 0.13173869E-05_JPRB, 0.13305531E-05_JPRB, 0.13441344E-05_JPRB, &
  & 0.13584073E-05_JPRB, 0.13733113E-05_JPRB, 0.13888839E-05_JPRB, 0.14051199E-05_JPRB, 0.14221230E-05_JPRB, 0.14398819E-05_JPRB, &
  & 0.14584260E-05_JPRB, 0.14775270E-05_JPRB, 0.14972862E-05_JPRB, 0.15174361E-05_JPRB, 0.15375772E-05_JPRB, 0.15573366E-05_JPRB, &
  & 0.15764139E-05_JPRB, 0.15945789E-05_JPRB, 0.16117776E-05_JPRB, 0.16279323E-05_JPRB, 0.16428579E-05_JPRB, 0.16562851E-05_JPRB, &
  & 0.16679751E-05_JPRB, 0.16778729E-05_JPRB, 0.16861508E-05_JPRB, 0.16928598E-05_JPRB, 0.16980484E-05_JPRB, 0.17017637E-05_JPRB, &
  & 0.17041809E-05_JPRB, 0.17055814E-05_JPRB, 0.17062385E-05_JPRB, 0.17063530E-05_JPRB, 0.17059872E-05_JPRB, 0.17051500E-05_JPRB, &
  & 0.17038344E-05_JPRB, 0.17020152E-05_JPRB, 0.16996261E-05_JPRB, 0.16966106E-05_JPRB, 0.16928799E-05_JPRB, 0.16883533E-05_JPRB, &
  & 0.16829121E-05_JPRB, 0.16764843E-05_JPRB, 0.16689852E-05_JPRB, 0.16604854E-05_JPRB, 0.16512340E-05_JPRB, 0.16416753E-05_JPRB, &
  & 0.16320863E-05_JPRB, 0.16228098E-05_JPRB, 0.16140260E-05_JPRB, 0.16057637E-05_JPRB, 0.15980017E-05_JPRB, 0.15906375E-05_JPRB, &
  & 0.15835727E-05_JPRB, 0.15767093E-05_JPRB, 0.15699852E-05_JPRB, 0.15634392E-05_JPRB, 0.15571486E-05_JPRB, 0.15512252E-05_JPRB, &
  & 0.15456102E-05_JPRB, 0.15401422E-05_JPRB, 0.15340595E-05_JPRB, 0.15235754E-05_JPRB /)

RGHG2(:,32,11) = (/ &
  & 0.13055842E-05_JPRB, 0.13309718E-05_JPRB, 0.13454084E-05_JPRB, 0.13580267E-05_JPRB, 0.13702423E-05_JPRB, 0.13828321E-05_JPRB, &
  & 0.13959323E-05_JPRB, 0.14095676E-05_JPRB, 0.14236988E-05_JPRB, 0.14384191E-05_JPRB, 0.14537851E-05_JPRB, 0.14699060E-05_JPRB, &
  & 0.14867621E-05_JPRB, 0.15043229E-05_JPRB, 0.15225680E-05_JPRB, 0.15412678E-05_JPRB, 0.15600319E-05_JPRB, 0.15784470E-05_JPRB, &
  & 0.15961716E-05_JPRB, 0.16129968E-05_JPRB, 0.16288451E-05_JPRB, 0.16436720E-05_JPRB, 0.16573648E-05_JPRB, 0.16696816E-05_JPRB, &
  & 0.16804202E-05_JPRB, 0.16895693E-05_JPRB, 0.16972340E-05_JPRB, 0.17035317E-05_JPRB, 0.17084760E-05_JPRB, 0.17121054E-05_JPRB, &
  & 0.17145470E-05_JPRB, 0.17160269E-05_JPRB, 0.17167946E-05_JPRB, 0.17170182E-05_JPRB, 0.17167509E-05_JPRB, 0.17160056E-05_JPRB, &
  & 0.17147619E-05_JPRB, 0.17129736E-05_JPRB, 0.17106055E-05_JPRB, 0.17075819E-05_JPRB, 0.17038491E-05_JPRB, 0.16993258E-05_JPRB, &
  & 0.16939280E-05_JPRB, 0.16875956E-05_JPRB, 0.16802614E-05_JPRB, 0.16720235E-05_JPRB, 0.16631756E-05_JPRB, 0.16540064E-05_JPRB, &
  & 0.16448622E-05_JPRB, 0.16360260E-05_JPRB, 0.16276821E-05_JPRB, 0.16198833E-05_JPRB, 0.16125636E-05_JPRB, 0.16056355E-05_JPRB, &
  & 0.15989544E-05_JPRB, 0.15924152E-05_JPRB, 0.15860105E-05_JPRB, 0.15797718E-05_JPRB, 0.15738392E-05_JPRB, 0.15682715E-05_JPRB, &
  & 0.15631264E-05_JPRB, 0.15581170E-05_JPRB, 0.15526477E-05_JPRB, 0.15432604E-05_JPRB /)

RGHG2(:,33,11) = (/ &
  & 0.13468776E-05_JPRB, 0.13710377E-05_JPRB, 0.13848938E-05_JPRB, 0.13966202E-05_JPRB, 0.14079981E-05_JPRB, 0.14196244E-05_JPRB, &
  & 0.14316539E-05_JPRB, 0.14440625E-05_JPRB, 0.14568602E-05_JPRB, 0.14700782E-05_JPRB, 0.14838545E-05_JPRB, 0.14983232E-05_JPRB, &
  & 0.15135297E-05_JPRB, 0.15295485E-05_JPRB, 0.15463411E-05_JPRB, 0.15636441E-05_JPRB, 0.15811318E-05_JPRB, 0.15983373E-05_JPRB, &
  & 0.16148339E-05_JPRB, 0.16304140E-05_JPRB, 0.16450037E-05_JPRB, 0.16586021E-05_JPRB, 0.16710742E-05_JPRB, 0.16822693E-05_JPRB, &
  & 0.16920104E-05_JPRB, 0.17003024E-05_JPRB, 0.17072953E-05_JPRB, 0.17130783E-05_JPRB, 0.17176933E-05_JPRB, 0.17211544E-05_JPRB, &
  & 0.17235452E-05_JPRB, 0.17250453E-05_JPRB, 0.17258619E-05_JPRB, 0.17261349E-05_JPRB, 0.17259216E-05_JPRB, 0.17252437E-05_JPRB, &
  & 0.17240532E-05_JPRB, 0.17223197E-05_JPRB, 0.17199975E-05_JPRB, 0.17170109E-05_JPRB, 0.17133179E-05_JPRB, 0.17088310E-05_JPRB, &
  & 0.17034993E-05_JPRB, 0.16972673E-05_JPRB, 0.16901287E-05_JPRB, 0.16822169E-05_JPRB, 0.16737280E-05_JPRB, 0.16649853E-05_JPRB, &
  & 0.16562955E-05_JPRB, 0.16479701E-05_JPRB, 0.16401233E-05_JPRB, 0.16327865E-05_JPRB, 0.16259213E-05_JPRB, 0.16193660E-05_JPRB, &
  & 0.16129954E-05_JPRB, 0.16067373E-05_JPRB, 0.16005702E-05_JPRB, 0.15945815E-05_JPRB, 0.15888845E-05_JPRB, 0.15836315E-05_JPRB, &
  & 0.15787654E-05_JPRB, 0.15741598E-05_JPRB, 0.15690697E-05_JPRB, 0.15605775E-05_JPRB /)

RGHG2(:,34,11) = (/ &
  & 0.13863297E-05_JPRB, 0.14090340E-05_JPRB, 0.14218724E-05_JPRB, 0.14327665E-05_JPRB, 0.14433355E-05_JPRB, 0.14540395E-05_JPRB, &
  & 0.14650747E-05_JPRB, 0.14763770E-05_JPRB, 0.14879004E-05_JPRB, 0.14997154E-05_JPRB, 0.15119394E-05_JPRB, 0.15247732E-05_JPRB, &
  & 0.15383708E-05_JPRB, 0.15528624E-05_JPRB, 0.15682340E-05_JPRB, 0.15842296E-05_JPRB, 0.16005076E-05_JPRB, 0.16165850E-05_JPRB, &
  & 0.16320282E-05_JPRB, 0.16465747E-05_JPRB, 0.16601249E-05_JPRB, 0.16726312E-05_JPRB, 0.16840028E-05_JPRB, 0.16941116E-05_JPRB, &
  & 0.17028609E-05_JPRB, 0.17102780E-05_JPRB, 0.17165237E-05_JPRB, 0.17217205E-05_JPRB, 0.17259160E-05_JPRB, 0.17291201E-05_JPRB, &
  & 0.17313911E-05_JPRB, 0.17328520E-05_JPRB, 0.17336637E-05_JPRB, 0.17339460E-05_JPRB, 0.17337728E-05_JPRB, 0.17331422E-05_JPRB, &
  & 0.17320125E-05_JPRB, 0.17303641E-05_JPRB, 0.17281120E-05_JPRB, 0.17252062E-05_JPRB, 0.17215807E-05_JPRB, 0.17171591E-05_JPRB, &
  & 0.17119012E-05_JPRB, 0.17057846E-05_JPRB, 0.16988521E-05_JPRB, 0.16912280E-05_JPRB, 0.16831486E-05_JPRB, 0.16748761E-05_JPRB, &
  & 0.16667570E-05_JPRB, 0.16589506E-05_JPRB, 0.16515964E-05_JPRB, 0.16447096E-05_JPRB, 0.16381947E-05_JPRB, 0.16319510E-05_JPRB, &
  & 0.16258583E-05_JPRB, 0.16198437E-05_JPRB, 0.16139162E-05_JPRB, 0.16081311E-05_JPRB, 0.16026693E-05_JPRB, 0.15976320E-05_JPRB, &
  & 0.15930751E-05_JPRB, 0.15887033E-05_JPRB, 0.15840451E-05_JPRB, 0.15761518E-05_JPRB /)

RGHG2(:,35,11) = (/ &
  & 0.14237861E-05_JPRB, 0.14445594E-05_JPRB, 0.14561906E-05_JPRB, 0.14661946E-05_JPRB, 0.14758324E-05_JPRB, 0.14857221E-05_JPRB, &
  & 0.14958312E-05_JPRB, 0.15061062E-05_JPRB, 0.15164856E-05_JPRB, 0.15269712E-05_JPRB, 0.15377351E-05_JPRB, 0.15489943E-05_JPRB, &
  & 0.15610320E-05_JPRB, 0.15740286E-05_JPRB, 0.15880343E-05_JPRB, 0.16028100E-05_JPRB, 0.16180140E-05_JPRB, 0.16331181E-05_JPRB, &
  & 0.16476944E-05_JPRB, 0.16613994E-05_JPRB, 0.16741011E-05_JPRB, 0.16856917E-05_JPRB, 0.16960885E-05_JPRB, 0.17052018E-05_JPRB, &
  & 0.17129853E-05_JPRB, 0.17195204E-05_JPRB, 0.17249831E-05_JPRB, 0.17295276E-05_JPRB, 0.17332229E-05_JPRB, 0.17360957E-05_JPRB, &
  & 0.17381734E-05_JPRB, 0.17395429E-05_JPRB, 0.17403129E-05_JPRB, 0.17405949E-05_JPRB, 0.17404591E-05_JPRB, 0.17398762E-05_JPRB, &
  & 0.17388475E-05_JPRB, 0.17373154E-05_JPRB, 0.17351870E-05_JPRB, 0.17324102E-05_JPRB, 0.17288911E-05_JPRB, 0.17245570E-05_JPRB, &
  & 0.17193897E-05_JPRB, 0.17133880E-05_JPRB, 0.17066504E-05_JPRB, 0.16993361E-05_JPRB, 0.16916487E-05_JPRB, 0.16838860E-05_JPRB, &
  & 0.16762367E-05_JPRB, 0.16689236E-05_JPRB, 0.16620303E-05_JPRB, 0.16555372E-05_JPRB, 0.16493909E-05_JPRB, 0.16434672E-05_JPRB, &
  & 0.16376584E-05_JPRB, 0.16318984E-05_JPRB, 0.16261824E-05_JPRB, 0.16206152E-05_JPRB, 0.16153456E-05_JPRB, 0.16105433E-05_JPRB, &
  & 0.16061680E-05_JPRB, 0.16021032E-05_JPRB, 0.15976683E-05_JPRB, 0.15903964E-05_JPRB /)

RGHG2(:,36,11) = (/ &
  & 0.14593186E-05_JPRB, 0.14774560E-05_JPRB, 0.14878333E-05_JPRB, 0.14967076E-05_JPRB, 0.15055170E-05_JPRB, 0.15145164E-05_JPRB, &
  & 0.15237771E-05_JPRB, 0.15331248E-05_JPRB, 0.15424355E-05_JPRB, 0.15517178E-05_JPRB, 0.15611079E-05_JPRB, 0.15708940E-05_JPRB, &
  & 0.15814330E-05_JPRB, 0.15930067E-05_JPRB, 0.16057078E-05_JPRB, 0.16193833E-05_JPRB, 0.16336340E-05_JPRB, 0.16479675E-05_JPRB, &
  & 0.16618310E-05_JPRB, 0.16748814E-05_JPRB, 0.16868818E-05_JPRB, 0.16977124E-05_JPRB, 0.17072424E-05_JPRB, 0.17154340E-05_JPRB, &
  & 0.17222845E-05_JPRB, 0.17279273E-05_JPRB, 0.17325763E-05_JPRB, 0.17364080E-05_JPRB, 0.17395336E-05_JPRB, 0.17419870E-05_JPRB, &
  & 0.17438086E-05_JPRB, 0.17450388E-05_JPRB, 0.17457481E-05_JPRB, 0.17460412E-05_JPRB, 0.17459423E-05_JPRB, 0.17454449E-05_JPRB, &
  & 0.17445622E-05_JPRB, 0.17431937E-05_JPRB, 0.17412774E-05_JPRB, 0.17387117E-05_JPRB, 0.17353761E-05_JPRB, 0.17312016E-05_JPRB, &
  & 0.17261448E-05_JPRB, 0.17202836E-05_JPRB, 0.17137377E-05_JPRB, 0.17067058E-05_JPRB, 0.16994235E-05_JPRB, 0.16920886E-05_JPRB, &
  & 0.16849242E-05_JPRB, 0.16780607E-05_JPRB, 0.16715751E-05_JPRB, 0.16654559E-05_JPRB, 0.16596101E-05_JPRB, 0.16539867E-05_JPRB, &
  & 0.16484418E-05_JPRB, 0.16429385E-05_JPRB, 0.16374654E-05_JPRB, 0.16321269E-05_JPRB, 0.16270654E-05_JPRB, 0.16224408E-05_JPRB, &
  & 0.16183020E-05_JPRB, 0.16143970E-05_JPRB, 0.16102938E-05_JPRB, 0.16034322E-05_JPRB /)

RGHG2(:,37,11) = (/ &
  & 0.14927772E-05_JPRB, 0.15081569E-05_JPRB, 0.15168996E-05_JPRB, 0.15246783E-05_JPRB, 0.15324757E-05_JPRB, 0.15406538E-05_JPRB, &
  & 0.15490760E-05_JPRB, 0.15575379E-05_JPRB, 0.15658744E-05_JPRB, 0.15740311E-05_JPRB, 0.15821653E-05_JPRB, 0.15905891E-05_JPRB, &
  & 0.15997175E-05_JPRB, 0.16099452E-05_JPRB, 0.16214165E-05_JPRB, 0.16340863E-05_JPRB, 0.16474897E-05_JPRB, 0.16611536E-05_JPRB, &
  & 0.16744989E-05_JPRB, 0.16870601E-05_JPRB, 0.16985106E-05_JPRB, 0.17086538E-05_JPRB, 0.17173619E-05_JPRB, 0.17245914E-05_JPRB, &
  & 0.17304401E-05_JPRB, 0.17351139E-05_JPRB, 0.17388776E-05_JPRB, 0.17419453E-05_JPRB, 0.17444464E-05_JPRB, 0.17464492E-05_JPRB, &
  & 0.17479756E-05_JPRB, 0.17490463E-05_JPRB, 0.17496993E-05_JPRB, 0.17500097E-05_JPRB, 0.17499596E-05_JPRB, 0.17495904E-05_JPRB, &
  & 0.17488729E-05_JPRB, 0.17477456E-05_JPRB, 0.17461318E-05_JPRB, 0.17438983E-05_JPRB, 0.17409172E-05_JPRB, 0.17370339E-05_JPRB, &
  & 0.17322357E-05_JPRB, 0.17265675E-05_JPRB, 0.17202376E-05_JPRB, 0.17134778E-05_JPRB, 0.17065306E-05_JPRB, 0.16995991E-05_JPRB, &
  & 0.16928306E-05_JPRB, 0.16863544E-05_JPRB, 0.16802229E-05_JPRB, 0.16744229E-05_JPRB, 0.16688820E-05_JPRB, 0.16635387E-05_JPRB, &
  & 0.16582941E-05_JPRB, 0.16530945E-05_JPRB, 0.16479097E-05_JPRB, 0.16428253E-05_JPRB, 0.16379811E-05_JPRB, 0.16335471E-05_JPRB, &
  & 0.16295496E-05_JPRB, 0.16258581E-05_JPRB, 0.16218914E-05_JPRB, 0.16154388E-05_JPRB /)

RGHG2(:,38,11) = (/ &
  & 0.15240943E-05_JPRB, 0.15364033E-05_JPRB, 0.15436692E-05_JPRB, 0.15502433E-05_JPRB, 0.15570791E-05_JPRB, 0.15643882E-05_JPRB, &
  & 0.15719831E-05_JPRB, 0.15795906E-05_JPRB, 0.15869866E-05_JPRB, 0.15941058E-05_JPRB, 0.16010961E-05_JPRB, 0.16082894E-05_JPRB, &
  & 0.16161270E-05_JPRB, 0.16250843E-05_JPRB, 0.16354302E-05_JPRB, 0.16471213E-05_JPRB, 0.16598485E-05_JPRB, 0.16729171E-05_JPRB, &
  & 0.16857691E-05_JPRB, 0.16978695E-05_JPRB, 0.17087564E-05_JPRB, 0.17181117E-05_JPRB, 0.17258060E-05_JPRB, 0.17319259E-05_JPRB, &
  & 0.17366808E-05_JPRB, 0.17403793E-05_JPRB, 0.17433133E-05_JPRB, 0.17457013E-05_JPRB, 0.17476775E-05_JPRB, 0.17492962E-05_JPRB, &
  & 0.17505829E-05_JPRB, 0.17515187E-05_JPRB, 0.17521346E-05_JPRB, 0.17524525E-05_JPRB, 0.17524576E-05_JPRB, 0.17522025E-05_JPRB, &
  & 0.17516452E-05_JPRB, 0.17507621E-05_JPRB, 0.17494717E-05_JPRB, 0.17476548E-05_JPRB, 0.17451432E-05_JPRB, 0.17417742E-05_JPRB, &
  & 0.17374293E-05_JPRB, 0.17321580E-05_JPRB, 0.17261210E-05_JPRB, 0.17196585E-05_JPRB, 0.17130377E-05_JPRB, 0.17064473E-05_JPRB, &
  & 0.17000270E-05_JPRB, 0.16938704E-05_JPRB, 0.16880228E-05_JPRB, 0.16824991E-05_JPRB, 0.16772384E-05_JPRB, 0.16722015E-05_JPRB, &
  & 0.16673057E-05_JPRB, 0.16624645E-05_JPRB, 0.16576319E-05_JPRB, 0.16528539E-05_JPRB, 0.16482531E-05_JPRB, 0.16439819E-05_JPRB, &
  & 0.16401314E-05_JPRB, 0.16365265E-05_JPRB, 0.16327525E-05_JPRB, 0.16265192E-05_JPRB /)

RGHG2(:,39,11) = (/ &
  & 0.15526316E-05_JPRB, 0.15623278E-05_JPRB, 0.15681296E-05_JPRB, 0.15736068E-05_JPRB, 0.15795277E-05_JPRB, 0.15859832E-05_JPRB, &
  & 0.15927667E-05_JPRB, 0.15995162E-05_JPRB, 0.16060055E-05_JPRB, 0.16121629E-05_JPRB, 0.16181390E-05_JPRB, 0.16242351E-05_JPRB, &
  & 0.16309507E-05_JPRB, 0.16387173E-05_JPRB, 0.16480134E-05_JPRB, 0.16588053E-05_JPRB, 0.16707800E-05_JPRB, 0.16833138E-05_JPRB, &
  & 0.16956442E-05_JPRB, 0.17071092E-05_JPRB, 0.17171702E-05_JPRB, 0.17254692E-05_JPRB, 0.17319977E-05_JPRB, 0.17369920E-05_JPRB, &
  & 0.17407881E-05_JPRB, 0.17437053E-05_JPRB, 0.17460289E-05_JPRB, 0.17479463E-05_JPRB, 0.17495679E-05_JPRB, 0.17509439E-05_JPRB, &
  & 0.17520729E-05_JPRB, 0.17529252E-05_JPRB, 0.17535231E-05_JPRB, 0.17538368E-05_JPRB, 0.17538902E-05_JPRB, 0.17537055E-05_JPRB, &
  & 0.17532690E-05_JPRB, 0.17525726E-05_JPRB, 0.17515421E-05_JPRB, 0.17500851E-05_JPRB, 0.17480460E-05_JPRB, 0.17452448E-05_JPRB, &
  & 0.17415390E-05_JPRB, 0.17368220E-05_JPRB, 0.17312725E-05_JPRB, 0.17252046E-05_JPRB, 0.17189190E-05_JPRB, 0.17126521E-05_JPRB, &
  & 0.17065311E-05_JPRB, 0.17006378E-05_JPRB, 0.16950358E-05_JPRB, 0.16897595E-05_JPRB, 0.16847795E-05_JPRB, 0.16800734E-05_JPRB, &
  & 0.16755469E-05_JPRB, 0.16711259E-05_JPRB, 0.16667004E-05_JPRB, 0.16622804E-05_JPRB, 0.16579501E-05_JPRB, 0.16538634E-05_JPRB, &
  & 0.16501160E-05_JPRB, 0.16466282E-05_JPRB, 0.16428949E-05_JPRB, 0.16368501E-05_JPRB /)

RGHG2(:,40,11) = (/ &
  & 0.15780394E-05_JPRB, 0.15855463E-05_JPRB, 0.15902264E-05_JPRB, 0.15948101E-05_JPRB, 0.15998977E-05_JPRB, 0.16056262E-05_JPRB, &
  & 0.16116124E-05_JPRB, 0.16175322E-05_JPRB, 0.16231651E-05_JPRB, 0.16284505E-05_JPRB, 0.16335207E-05_JPRB, 0.16387178E-05_JPRB, &
  & 0.16444054E-05_JPRB, 0.16511839E-05_JPRB, 0.16594191E-05_JPRB, 0.16693843E-05_JPRB, 0.16806534E-05_JPRB, 0.16925401E-05_JPRB, &
  & 0.17041823E-05_JPRB, 0.17148075E-05_JPRB, 0.17237682E-05_JPRB, 0.17308699E-05_JPRB, 0.17362548E-05_JPRB, 0.17403020E-05_JPRB, &
  & 0.17433587E-05_JPRB, 0.17457364E-05_JPRB, 0.17476586E-05_JPRB, 0.17492806E-05_JPRB, 0.17506929E-05_JPRB, 0.17519208E-05_JPRB, &
  & 0.17529582E-05_JPRB, 0.17537637E-05_JPRB, 0.17543518E-05_JPRB, 0.17546610E-05_JPRB, 0.17547457E-05_JPRB, 0.17546004E-05_JPRB, &
  & 0.17542473E-05_JPRB, 0.17536711E-05_JPRB, 0.17528279E-05_JPRB, 0.17516389E-05_JPRB, 0.17499781E-05_JPRB, 0.17476896E-05_JPRB, &
  & 0.17445810E-05_JPRB, 0.17405281E-05_JPRB, 0.17356012E-05_JPRB, 0.17300231E-05_JPRB, 0.17241587E-05_JPRB, 0.17182272E-05_JPRB, &
  & 0.17123901E-05_JPRB, 0.17067441E-05_JPRB, 0.17013574E-05_JPRB, 0.16962973E-05_JPRB, 0.16916072E-05_JPRB, 0.16872229E-05_JPRB, &
  & 0.16831178E-05_JPRB, 0.16791191E-05_JPRB, 0.16751444E-05_JPRB, 0.16711060E-05_JPRB, 0.16670913E-05_JPRB, 0.16632106E-05_JPRB, &
  & 0.16596067E-05_JPRB, 0.16561731E-05_JPRB, 0.16525470E-05_JPRB, 0.16465716E-05_JPRB /)

RGHG2(:,41,11) = (/ &
  & 0.16001836E-05_JPRB, 0.16061711E-05_JPRB, 0.16099932E-05_JPRB, 0.16138596E-05_JPRB, 0.16183642E-05_JPRB, 0.16234303E-05_JPRB, &
  & 0.16287415E-05_JPRB, 0.16338956E-05_JPRB, 0.16387394E-05_JPRB, 0.16432430E-05_JPRB, 0.16475645E-05_JPRB, 0.16519326E-05_JPRB, &
  & 0.16568279E-05_JPRB, 0.16626365E-05_JPRB, 0.16699862E-05_JPRB, 0.16790248E-05_JPRB, 0.16895501E-05_JPRB, 0.17007139E-05_JPRB, &
  & 0.17115685E-05_JPRB, 0.17211296E-05_JPRB, 0.17289125E-05_JPRB, 0.17348284E-05_JPRB, 0.17392310E-05_JPRB, 0.17425232E-05_JPRB, &
  & 0.17450491E-05_JPRB, 0.17470497E-05_JPRB, 0.17487096E-05_JPRB, 0.17501478E-05_JPRB, 0.17514249E-05_JPRB, 0.17525676E-05_JPRB, &
  & 0.17535451E-05_JPRB, 0.17543296E-05_JPRB, 0.17549045E-05_JPRB, 0.17552161E-05_JPRB, 0.17553139E-05_JPRB, 0.17551941E-05_JPRB, &
  & 0.17548942E-05_JPRB, 0.17544006E-05_JPRB, 0.17536881E-05_JPRB, 0.17526961E-05_JPRB, 0.17513248E-05_JPRB, 0.17494365E-05_JPRB, &
  & 0.17468531E-05_JPRB, 0.17434422E-05_JPRB, 0.17391567E-05_JPRB, 0.17341828E-05_JPRB, 0.17287583E-05_JPRB, 0.17232112E-05_JPRB, &
  & 0.17176837E-05_JPRB, 0.17122757E-05_JPRB, 0.17070942E-05_JPRB, 0.17022724E-05_JPRB, 0.16978237E-05_JPRB, 0.16938147E-05_JPRB, &
  & 0.16900780E-05_JPRB, 0.16865329E-05_JPRB, 0.16829796E-05_JPRB, 0.16793540E-05_JPRB, 0.16756755E-05_JPRB, 0.16720671E-05_JPRB, &
  & 0.16686298E-05_JPRB, 0.16653458E-05_JPRB, 0.16617756E-05_JPRB, 0.16559310E-05_JPRB /)

RGHG2(:,42,11) = (/ &
  & 0.16194530E-05_JPRB, 0.16243807E-05_JPRB, 0.16276083E-05_JPRB, 0.16310197E-05_JPRB, 0.16350406E-05_JPRB, 0.16396796E-05_JPRB, &
  & 0.16443959E-05_JPRB, 0.16488941E-05_JPRB, 0.16530487E-05_JPRB, 0.16568862E-05_JPRB, 0.16605262E-05_JPRB, 0.16642516E-05_JPRB, &
  & 0.16683599E-05_JPRB, 0.16734074E-05_JPRB, 0.16798276E-05_JPRB, 0.16880426E-05_JPRB, 0.16977341E-05_JPRB, 0.17080848E-05_JPRB, &
  & 0.17179301E-05_JPRB, 0.17263856E-05_JPRB, 0.17329439E-05_JPRB, 0.17378120E-05_JPRB, 0.17413965E-05_JPRB, 0.17441137E-05_JPRB, &
  & 0.17462376E-05_JPRB, 0.17479742E-05_JPRB, 0.17494534E-05_JPRB, 0.17507653E-05_JPRB, 0.17519624E-05_JPRB, 0.17530467E-05_JPRB, &
  & 0.17539852E-05_JPRB, 0.17547623E-05_JPRB, 0.17553216E-05_JPRB, 0.17556386E-05_JPRB, 0.17557380E-05_JPRB, 0.17556366E-05_JPRB, &
  & 0.17553698E-05_JPRB, 0.17549348E-05_JPRB, 0.17543194E-05_JPRB, 0.17534755E-05_JPRB, 0.17523297E-05_JPRB, 0.17507589E-05_JPRB, &
  & 0.17486252E-05_JPRB, 0.17457749E-05_JPRB, 0.17421297E-05_JPRB, 0.17377157E-05_JPRB, 0.17328309E-05_JPRB, 0.17276831E-05_JPRB, &
  & 0.17224883E-05_JPRB, 0.17173585E-05_JPRB, 0.17124152E-05_JPRB, 0.17077894E-05_JPRB, 0.17036490E-05_JPRB, 0.16999452E-05_JPRB, &
  & 0.16966179E-05_JPRB, 0.16934596E-05_JPRB, 0.16903284E-05_JPRB, 0.16870980E-05_JPRB, 0.16837840E-05_JPRB, 0.16804895E-05_JPRB, &
  & 0.16773239E-05_JPRB, 0.16742208E-05_JPRB, 0.16708451E-05_JPRB, 0.16651949E-05_JPRB /)

RGHG2(:,43,11) = (/ &
  & 0.16363774E-05_JPRB, 0.16406041E-05_JPRB, 0.16434460E-05_JPRB, 0.16465024E-05_JPRB, 0.16502798E-05_JPRB, 0.16545541E-05_JPRB, &
  & 0.16588483E-05_JPRB, 0.16627982E-05_JPRB, 0.16663864E-05_JPRB, 0.16696465E-05_JPRB, 0.16727317E-05_JPRB, 0.16758415E-05_JPRB, &
  & 0.16793335E-05_JPRB, 0.16835878E-05_JPRB, 0.16892039E-05_JPRB, 0.16965125E-05_JPRB, 0.17053663E-05_JPRB, 0.17147822E-05_JPRB, &
  & 0.17235822E-05_JPRB, 0.17307782E-05_JPRB, 0.17362022E-05_JPRB, 0.17401443E-05_JPRB, 0.17430602E-05_JPRB, 0.17453158E-05_JPRB, &
  & 0.17471350E-05_JPRB, 0.17486698E-05_JPRB, 0.17500183E-05_JPRB, 0.17512485E-05_JPRB, 0.17523878E-05_JPRB, 0.17534412E-05_JPRB, &
  & 0.17543508E-05_JPRB, 0.17551255E-05_JPRB, 0.17556698E-05_JPRB, 0.17559908E-05_JPRB, 0.17560868E-05_JPRB, 0.17559962E-05_JPRB, &
  & 0.17557508E-05_JPRB, 0.17553597E-05_JPRB, 0.17548174E-05_JPRB, 0.17540917E-05_JPRB, 0.17531236E-05_JPRB, 0.17518189E-05_JPRB, &
  & 0.17500606E-05_JPRB, 0.17477084E-05_JPRB, 0.17446243E-05_JPRB, 0.17408296E-05_JPRB, 0.17364238E-05_JPRB, 0.17317255E-05_JPRB, &
  & 0.17269102E-05_JPRB, 0.17220968E-05_JPRB, 0.17174146E-05_JPRB, 0.17130725E-05_JPRB, 0.17091991E-05_JPRB, 0.17058426E-05_JPRB, &
  & 0.17028631E-05_JPRB, 0.17000795E-05_JPRB, 0.16973186E-05_JPRB, 0.16944670E-05_JPRB, 0.16915287E-05_JPRB, 0.16886044E-05_JPRB, &
  & 0.16857717E-05_JPRB, 0.16829827E-05_JPRB, 0.16798806E-05_JPRB, 0.16746310E-05_JPRB /)

RGHG2(:,44,11) = (/ &
  & 0.16515150E-05_JPRB, 0.16552832E-05_JPRB, 0.16578331E-05_JPRB, 0.16607005E-05_JPRB, 0.16642562E-05_JPRB, 0.16683541E-05_JPRB, &
  & 0.16722940E-05_JPRB, 0.16758385E-05_JPRB, 0.16789581E-05_JPRB, 0.16817462E-05_JPRB, 0.16843367E-05_JPRB, 0.16869408E-05_JPRB, &
  & 0.16898200E-05_JPRB, 0.16934127E-05_JPRB, 0.16982027E-05_JPRB, 0.17046669E-05_JPRB, 0.17126134E-05_JPRB, 0.17210216E-05_JPRB, &
  & 0.17285777E-05_JPRB, 0.17345379E-05_JPRB, 0.17388783E-05_JPRB, 0.17420193E-05_JPRB, 0.17443861E-05_JPRB, 0.17462678E-05_JPRB, &
  & 0.17478421E-05_JPRB, 0.17492192E-05_JPRB, 0.17504722E-05_JPRB, 0.17516439E-05_JPRB, 0.17527524E-05_JPRB, 0.17537850E-05_JPRB, &
  & 0.17546786E-05_JPRB, 0.17554497E-05_JPRB, 0.17559843E-05_JPRB, 0.17563032E-05_JPRB, 0.17563948E-05_JPRB, 0.17563088E-05_JPRB, &
  & 0.17560766E-05_JPRB, 0.17557173E-05_JPRB, 0.17552325E-05_JPRB, 0.17546016E-05_JPRB, 0.17537803E-05_JPRB, 0.17526977E-05_JPRB, &
  & 0.17512602E-05_JPRB, 0.17493394E-05_JPRB, 0.17468110E-05_JPRB, 0.17435564E-05_JPRB, 0.17397047E-05_JPRB, 0.17354428E-05_JPRB, &
  & 0.17310280E-05_JPRB, 0.17265847E-05_JPRB, 0.17222369E-05_JPRB, 0.17181933E-05_JPRB, 0.17146394E-05_JPRB, 0.17116217E-05_JPRB, &
  & 0.17089651E-05_JPRB, 0.17065202E-05_JPRB, 0.17040945E-05_JPRB, 0.17015971E-05_JPRB, 0.16990372E-05_JPRB, 0.16965078E-05_JPRB, &
  & 0.16940737E-05_JPRB, 0.16916654E-05_JPRB, 0.16889619E-05_JPRB, 0.16843242E-05_JPRB /)

RGHG2(:,45,11) = (/ &
  & 0.16653336E-05_JPRB, 0.16687568E-05_JPRB, 0.16711343E-05_JPRB, 0.16738023E-05_JPRB, 0.16772835E-05_JPRB, 0.16811931E-05_JPRB, &
  & 0.16849212E-05_JPRB, 0.16881277E-05_JPRB, 0.16908771E-05_JPRB, 0.16932690E-05_JPRB, 0.16954385E-05_JPRB, 0.16975771E-05_JPRB, &
  & 0.16999520E-05_JPRB, 0.17028983E-05_JPRB, 0.17069335E-05_JPRB, 0.17125560E-05_JPRB, 0.17195359E-05_JPRB, 0.17268048E-05_JPRB, &
  & 0.17330291E-05_JPRB, 0.17377288E-05_JPRB, 0.17410898E-05_JPRB, 0.17435585E-05_JPRB, 0.17454622E-05_JPRB, 0.17470430E-05_JPRB, &
  & 0.17484157E-05_JPRB, 0.17496682E-05_JPRB, 0.17508474E-05_JPRB, 0.17519851E-05_JPRB, 0.17530755E-05_JPRB, 0.17540992E-05_JPRB, &
  & 0.17549860E-05_JPRB, 0.17557519E-05_JPRB, 0.17562792E-05_JPRB, 0.17565926E-05_JPRB, 0.17566780E-05_JPRB, 0.17565909E-05_JPRB, &
  & 0.17563661E-05_JPRB, 0.17560308E-05_JPRB, 0.17555907E-05_JPRB, 0.17550366E-05_JPRB, 0.17543374E-05_JPRB, 0.17534408E-05_JPRB, &
  & 0.17522781E-05_JPRB, 0.17507490E-05_JPRB, 0.17487112E-05_JPRB, 0.17460532E-05_JPRB, 0.17427219E-05_JPRB, 0.17389475E-05_JPRB, &
  & 0.17349540E-05_JPRB, 0.17308929E-05_JPRB, 0.17269135E-05_JPRB, 0.17232413E-05_JPRB, 0.17200465E-05_JPRB, 0.17173500E-05_JPRB, &
  & 0.17150267E-05_JPRB, 0.17128762E-05_JPRB, 0.17107659E-05_JPRB, 0.17086014E-05_JPRB, 0.17064094E-05_JPRB, 0.17042813E-05_JPRB, &
  & 0.17022622E-05_JPRB, 0.17002661E-05_JPRB, 0.16980202E-05_JPRB, 0.16941146E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART21',1,ZHOOK_HANDLE)
END SUBROUTINE PART21




SUBROUTINE PART22
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART22',0,ZHOOK_HANDLE)



RGHG2(:,46,11) = (/ &
  & 0.16781555E-05_JPRB, 0.16813628E-05_JPRB, 0.16835446E-05_JPRB, 0.16861322E-05_JPRB, 0.16894244E-05_JPRB, 0.16932888E-05_JPRB, &
  & 0.16967874E-05_JPRB, 0.16997355E-05_JPRB, 0.17021754E-05_JPRB, 0.17042078E-05_JPRB, 0.17060164E-05_JPRB, 0.17077650E-05_JPRB, &
  & 0.17096764E-05_JPRB, 0.17120750E-05_JPRB, 0.17154516E-05_JPRB, 0.17201742E-05_JPRB, 0.17261789E-05_JPRB, 0.17320834E-05_JPRB, &
  & 0.17369219E-05_JPRB, 0.17404161E-05_JPRB, 0.17429305E-05_JPRB, 0.17448205E-05_JPRB, 0.17463556E-05_JPRB, 0.17476823E-05_JPRB, &
  & 0.17488933E-05_JPRB, 0.17500438E-05_JPRB, 0.17511697E-05_JPRB, 0.17522854E-05_JPRB, 0.17533735E-05_JPRB, 0.17543960E-05_JPRB, &
  & 0.17552816E-05_JPRB, 0.17560412E-05_JPRB, 0.17565637E-05_JPRB, 0.17568676E-05_JPRB, 0.17569454E-05_JPRB, 0.17568525E-05_JPRB, &
  & 0.17566307E-05_JPRB, 0.17563109E-05_JPRB, 0.17559067E-05_JPRB, 0.17554150E-05_JPRB, 0.17548167E-05_JPRB, 0.17540783E-05_JPRB, &
  & 0.17531505E-05_JPRB, 0.17519624E-05_JPRB, 0.17504017E-05_JPRB, 0.17483022E-05_JPRB, 0.17455848E-05_JPRB, 0.17423283E-05_JPRB, &
  & 0.17387598E-05_JPRB, 0.17351041E-05_JPRB, 0.17315352E-05_JPRB, 0.17282377E-05_JPRB, 0.17254417E-05_JPRB, 0.17230858E-05_JPRB, &
  & 0.17210665E-05_JPRB, 0.17192061E-05_JPRB, 0.17173815E-05_JPRB, 0.17155293E-05_JPRB, 0.17136852E-05_JPRB, 0.17119344E-05_JPRB, &
  & 0.17102950E-05_JPRB, 0.17086955E-05_JPRB, 0.17068771E-05_JPRB, 0.17037238E-05_JPRB /)

RGHG2(:,47,11) = (/ &
  & 0.16902557E-05_JPRB, 0.16932321E-05_JPRB, 0.16953327E-05_JPRB, 0.16977074E-05_JPRB, 0.17009852E-05_JPRB, 0.17046285E-05_JPRB, &
  & 0.17079983E-05_JPRB, 0.17107004E-05_JPRB, 0.17128307E-05_JPRB, 0.17145705E-05_JPRB, 0.17160473E-05_JPRB, 0.17174566E-05_JPRB, &
  & 0.17189878E-05_JPRB, 0.17209253E-05_JPRB, 0.17236340E-05_JPRB, 0.17275834E-05_JPRB, 0.17323154E-05_JPRB, 0.17368230E-05_JPRB, &
  & 0.17402286E-05_JPRB, 0.17426714E-05_JPRB, 0.17444513E-05_JPRB, 0.17458760E-05_JPRB, 0.17470969E-05_JPRB, 0.17482216E-05_JPRB, &
  & 0.17492982E-05_JPRB, 0.17503677E-05_JPRB, 0.17514550E-05_JPRB, 0.17525617E-05_JPRB, 0.17536555E-05_JPRB, 0.17546814E-05_JPRB, &
  & 0.17555703E-05_JPRB, 0.17563233E-05_JPRB, 0.17568409E-05_JPRB, 0.17571335E-05_JPRB, 0.17572009E-05_JPRB, 0.17570992E-05_JPRB, &
  & 0.17568759E-05_JPRB, 0.17565669E-05_JPRB, 0.17561899E-05_JPRB, 0.17557494E-05_JPRB, 0.17552362E-05_JPRB, 0.17546295E-05_JPRB, &
  & 0.17539040E-05_JPRB, 0.17530151E-05_JPRB, 0.17518763E-05_JPRB, 0.17503468E-05_JPRB, 0.17482737E-05_JPRB, 0.17456155E-05_JPRB, &
  & 0.17425639E-05_JPRB, 0.17393278E-05_JPRB, 0.17361383E-05_JPRB, 0.17332902E-05_JPRB, 0.17308303E-05_JPRB, 0.17288354E-05_JPRB, &
  & 0.17270900E-05_JPRB, 0.17254990E-05_JPRB, 0.17239358E-05_JPRB, 0.17223630E-05_JPRB, 0.17208295E-05_JPRB, 0.17193979E-05_JPRB, &
  & 0.17180909E-05_JPRB, 0.17168105E-05_JPRB, 0.17153724E-05_JPRB, 0.17128418E-05_JPRB /)

RGHG2(:,48,11) = (/ &
  & 0.17017227E-05_JPRB, 0.17045689E-05_JPRB, 0.17064973E-05_JPRB, 0.17088148E-05_JPRB, 0.17118293E-05_JPRB, 0.17154414E-05_JPRB, &
  & 0.17185880E-05_JPRB, 0.17210526E-05_JPRB, 0.17229293E-05_JPRB, 0.17243600E-05_JPRB, 0.17255611E-05_JPRB, 0.17266714E-05_JPRB, &
  & 0.17278716E-05_JPRB, 0.17293805E-05_JPRB, 0.17315035E-05_JPRB, 0.17344623E-05_JPRB, 0.17378812E-05_JPRB, 0.17408452E-05_JPRB, &
  & 0.17430004E-05_JPRB, 0.17445275E-05_JPRB, 0.17457205E-05_JPRB, 0.17467535E-05_JPRB, 0.17477240E-05_JPRB, 0.17486790E-05_JPRB, &
  & 0.17496495E-05_JPRB, 0.17506577E-05_JPRB, 0.17517194E-05_JPRB, 0.17528233E-05_JPRB, 0.17539295E-05_JPRB, 0.17549619E-05_JPRB, &
  & 0.17558548E-05_JPRB, 0.17566016E-05_JPRB, 0.17571140E-05_JPRB, 0.17573929E-05_JPRB, 0.17574482E-05_JPRB, 0.17573352E-05_JPRB, &
  & 0.17571075E-05_JPRB, 0.17568038E-05_JPRB, 0.17564487E-05_JPRB, 0.17560501E-05_JPRB, 0.17556074E-05_JPRB, 0.17551137E-05_JPRB, &
  & 0.17545593E-05_JPRB, 0.17539271E-05_JPRB, 0.17531635E-05_JPRB, 0.17521603E-05_JPRB, 0.17507452E-05_JPRB, 0.17488135E-05_JPRB, &
  & 0.17463703E-05_JPRB, 0.17436373E-05_JPRB, 0.17409111E-05_JPRB, 0.17384054E-05_JPRB, 0.17363546E-05_JPRB, 0.17346194E-05_JPRB, &
  & 0.17331489E-05_JPRB, 0.17317757E-05_JPRB, 0.17304358E-05_JPRB, 0.17290981E-05_JPRB, 0.17278105E-05_JPRB, 0.17266424E-05_JPRB, &
  & 0.17255802E-05_JPRB, 0.17245588E-05_JPRB, 0.17233941E-05_JPRB, 0.17213594E-05_JPRB /)

RGHG2(:,49,11) = (/ &
  & 0.17126433E-05_JPRB, 0.17153193E-05_JPRB, 0.17171647E-05_JPRB, 0.17192970E-05_JPRB, 0.17222392E-05_JPRB, 0.17256186E-05_JPRB, &
  & 0.17286382E-05_JPRB, 0.17308648E-05_JPRB, 0.17324483E-05_JPRB, 0.17336172E-05_JPRB, 0.17345357E-05_JPRB, 0.17353674E-05_JPRB, &
  & 0.17362449E-05_JPRB, 0.17372945E-05_JPRB, 0.17387570E-05_JPRB, 0.17405802E-05_JPRB, 0.17425906E-05_JPRB, 0.17441611E-05_JPRB, &
  & 0.17452538E-05_JPRB, 0.17460675E-05_JPRB, 0.17467809E-05_JPRB, 0.17474988E-05_JPRB, 0.17482573E-05_JPRB, 0.17490743E-05_JPRB, &
  & 0.17499619E-05_JPRB, 0.17509251E-05_JPRB, 0.17519741E-05_JPRB, 0.17530829E-05_JPRB, 0.17541988E-05_JPRB, 0.17552400E-05_JPRB, &
  & 0.17561368E-05_JPRB, 0.17568782E-05_JPRB, 0.17573843E-05_JPRB, 0.17576488E-05_JPRB, 0.17576898E-05_JPRB, 0.17575633E-05_JPRB, &
  & 0.17573282E-05_JPRB, 0.17570275E-05_JPRB, 0.17566881E-05_JPRB, 0.17563245E-05_JPRB, 0.17559418E-05_JPRB, 0.17555435E-05_JPRB, &
  & 0.17551366E-05_JPRB, 0.17547234E-05_JPRB, 0.17542827E-05_JPRB, 0.17537375E-05_JPRB, 0.17529543E-05_JPRB, 0.17517635E-05_JPRB, &
  & 0.17500972E-05_JPRB, 0.17480394E-05_JPRB, 0.17458233E-05_JPRB, 0.17437928E-05_JPRB, 0.17420323E-05_JPRB, 0.17405912E-05_JPRB, &
  & 0.17393183E-05_JPRB, 0.17381315E-05_JPRB, 0.17369632E-05_JPRB, 0.17358004E-05_JPRB, 0.17347033E-05_JPRB, 0.17337186E-05_JPRB, &
  & 0.17328423E-05_JPRB, 0.17319961E-05_JPRB, 0.17310313E-05_JPRB, 0.17293282E-05_JPRB /)

RGHG2(:,50,11) = (/ &
  & 0.17229040E-05_JPRB, 0.17254337E-05_JPRB, 0.17271493E-05_JPRB, 0.17291627E-05_JPRB, 0.17319167E-05_JPRB, 0.17351736E-05_JPRB, &
  & 0.17379054E-05_JPRB, 0.17398320E-05_JPRB, 0.17410971E-05_JPRB, 0.17419429E-05_JPRB, 0.17425690E-05_JPRB, 0.17430921E-05_JPRB, &
  & 0.17435912E-05_JPRB, 0.17441751E-05_JPRB, 0.17448131E-05_JPRB, 0.17456348E-05_JPRB, 0.17463213E-05_JPRB, 0.17468042E-05_JPRB, &
  & 0.17470860E-05_JPRB, 0.17473462E-05_JPRB, 0.17476846E-05_JPRB, 0.17481395E-05_JPRB, 0.17487200E-05_JPRB, 0.17494229E-05_JPRB, &
  & 0.17502457E-05_JPRB, 0.17511832E-05_JPRB, 0.17522268E-05_JPRB, 0.17533437E-05_JPRB, 0.17544695E-05_JPRB, 0.17555151E-05_JPRB, &
  & 0.17564184E-05_JPRB, 0.17571545E-05_JPRB, 0.17576540E-05_JPRB, 0.17579031E-05_JPRB, 0.17579284E-05_JPRB, 0.17577863E-05_JPRB, &
  & 0.17575421E-05_JPRB, 0.17572412E-05_JPRB, 0.17569146E-05_JPRB, 0.17565794E-05_JPRB, 0.17562470E-05_JPRB, 0.17559316E-05_JPRB, &
  & 0.17556521E-05_JPRB, 0.17554294E-05_JPRB, 0.17552629E-05_JPRB, 0.17551074E-05_JPRB, 0.17548512E-05_JPRB, 0.17543490E-05_JPRB, &
  & 0.17534810E-05_JPRB, 0.17522316E-05_JPRB, 0.17507573E-05_JPRB, 0.17492553E-05_JPRB, 0.17479316E-05_JPRB, 0.17467559E-05_JPRB, &
  & 0.17456923E-05_JPRB, 0.17446753E-05_JPRB, 0.17436471E-05_JPRB, 0.17426225E-05_JPRB, 0.17416622E-05_JPRB, 0.17408111E-05_JPRB, &
  & 0.17400594E-05_JPRB, 0.17393263E-05_JPRB, 0.17384879E-05_JPRB, 0.17369658E-05_JPRB /)

RGHG2(:,51,11) = (/ &
  & 0.17323089E-05_JPRB, 0.17346192E-05_JPRB, 0.17362121E-05_JPRB, 0.17380737E-05_JPRB, 0.17405936E-05_JPRB, 0.17434629E-05_JPRB, &
  & 0.17457726E-05_JPRB, 0.17471785E-05_JPRB, 0.17480018E-05_JPRB, 0.17484948E-05_JPRB, 0.17488069E-05_JPRB, 0.17490245E-05_JPRB, &
  & 0.17491939E-05_JPRB, 0.17493123E-05_JPRB, 0.17494012E-05_JPRB, 0.17493742E-05_JPRB, 0.17492029E-05_JPRB, 0.17488921E-05_JPRB, &
  & 0.17485951E-05_JPRB, 0.17484359E-05_JPRB, 0.17484698E-05_JPRB, 0.17487034E-05_JPRB, 0.17491318E-05_JPRB, 0.17497355E-05_JPRB, &
  & 0.17505122E-05_JPRB, 0.17514341E-05_JPRB, 0.17524842E-05_JPRB, 0.17536071E-05_JPRB, 0.17547391E-05_JPRB, 0.17557912E-05_JPRB, &
  & 0.17566995E-05_JPRB, 0.17574330E-05_JPRB, 0.17579247E-05_JPRB, 0.17581582E-05_JPRB, 0.17581660E-05_JPRB, 0.17580085E-05_JPRB, &
  & 0.17577521E-05_JPRB, 0.17574494E-05_JPRB, 0.17571313E-05_JPRB, 0.17568198E-05_JPRB, 0.17565303E-05_JPRB, 0.17562861E-05_JPRB, &
  & 0.17561206E-05_JPRB, 0.17560677E-05_JPRB, 0.17561413E-05_JPRB, 0.17563062E-05_JPRB, 0.17564680E-05_JPRB, 0.17565004E-05_JPRB, &
  & 0.17562943E-05_JPRB, 0.17558142E-05_JPRB, 0.17551126E-05_JPRB, 0.17543204E-05_JPRB, 0.17535081E-05_JPRB, 0.17527377E-05_JPRB, &
  & 0.17519777E-05_JPRB, 0.17511809E-05_JPRB, 0.17503501E-05_JPRB, 0.17494922E-05_JPRB, 0.17486723E-05_JPRB, 0.17479482E-05_JPRB, &
  & 0.17472960E-05_JPRB, 0.17466582E-05_JPRB, 0.17458817E-05_JPRB, 0.17444796E-05_JPRB /)

RGHG2(:,52,11) = (/ &
  & 0.17404292E-05_JPRB, 0.17425288E-05_JPRB, 0.17439027E-05_JPRB, 0.17455031E-05_JPRB, 0.17476203E-05_JPRB, 0.17498747E-05_JPRB, &
  & 0.17513878E-05_JPRB, 0.17522120E-05_JPRB, 0.17526193E-05_JPRB, 0.17528168E-05_JPRB, 0.17529065E-05_JPRB, 0.17529270E-05_JPRB, &
  & 0.17528888E-05_JPRB, 0.17527680E-05_JPRB, 0.17525396E-05_JPRB, 0.17520688E-05_JPRB, 0.17513955E-05_JPRB, 0.17505794E-05_JPRB, &
  & 0.17498655E-05_JPRB, 0.17493862E-05_JPRB, 0.17491698E-05_JPRB, 0.17492140E-05_JPRB, 0.17495050E-05_JPRB, 0.17500311E-05_JPRB, &
  & 0.17507660E-05_JPRB, 0.17516885E-05_JPRB, 0.17527387E-05_JPRB, 0.17538757E-05_JPRB, 0.17550080E-05_JPRB, 0.17560669E-05_JPRB, &
  & 0.17569830E-05_JPRB, 0.17577142E-05_JPRB, 0.17581984E-05_JPRB, 0.17584164E-05_JPRB, 0.17584050E-05_JPRB, 0.17582315E-05_JPRB, &
  & 0.17579627E-05_JPRB, 0.17576556E-05_JPRB, 0.17573429E-05_JPRB, 0.17570493E-05_JPRB, 0.17567957E-05_JPRB, 0.17566158E-05_JPRB, &
  & 0.17565549E-05_JPRB, 0.17566587E-05_JPRB, 0.17569471E-05_JPRB, 0.17573726E-05_JPRB, 0.17578477E-05_JPRB, 0.17582502E-05_JPRB, &
  & 0.17584930E-05_JPRB, 0.17585411E-05_JPRB, 0.17584189E-05_JPRB, 0.17581769E-05_JPRB, 0.17578727E-05_JPRB, 0.17575160E-05_JPRB, &
  & 0.17571065E-05_JPRB, 0.17566404E-05_JPRB, 0.17560881E-05_JPRB, 0.17554853E-05_JPRB, 0.17548930E-05_JPRB, 0.17543532E-05_JPRB, &
  & 0.17538619E-05_JPRB, 0.17533501E-05_JPRB, 0.17527204E-05_JPRB, 0.17514412E-05_JPRB /)

RGHG2(:,53,11) = (/ &
  & 0.17470197E-05_JPRB, 0.17487000E-05_JPRB, 0.17498585E-05_JPRB, 0.17510949E-05_JPRB, 0.17526287E-05_JPRB, 0.17540465E-05_JPRB, &
  & 0.17548984E-05_JPRB, 0.17552622E-05_JPRB, 0.17554091E-05_JPRB, 0.17554485E-05_JPRB, 0.17554287E-05_JPRB, 0.17553637E-05_JPRB, &
  & 0.17552417E-05_JPRB, 0.17550470E-05_JPRB, 0.17546619E-05_JPRB, 0.17540792E-05_JPRB, 0.17530945E-05_JPRB, 0.17519806E-05_JPRB, &
  & 0.17509699E-05_JPRB, 0.17502283E-05_JPRB, 0.17498040E-05_JPRB, 0.17496836E-05_JPRB, 0.17498605E-05_JPRB, 0.17503115E-05_JPRB, &
  & 0.17510257E-05_JPRB, 0.17519368E-05_JPRB, 0.17530040E-05_JPRB, 0.17541373E-05_JPRB, 0.17552821E-05_JPRB, 0.17563455E-05_JPRB, &
  & 0.17572708E-05_JPRB, 0.17580006E-05_JPRB, 0.17584756E-05_JPRB, 0.17586794E-05_JPRB, 0.17586490E-05_JPRB, 0.17584587E-05_JPRB, &
  & 0.17581767E-05_JPRB, 0.17578637E-05_JPRB, 0.17575536E-05_JPRB, 0.17572734E-05_JPRB, 0.17570508E-05_JPRB, 0.17569275E-05_JPRB, &
  & 0.17569643E-05_JPRB, 0.17572188E-05_JPRB, 0.17576914E-05_JPRB, 0.17583399E-05_JPRB, 0.17590321E-05_JPRB, 0.17596731E-05_JPRB, &
  & 0.17601722E-05_JPRB, 0.17605068E-05_JPRB, 0.17606840E-05_JPRB, 0.17607395E-05_JPRB, 0.17607083E-05_JPRB, 0.17606131E-05_JPRB, &
  & 0.17604610E-05_JPRB, 0.17602383E-05_JPRB, 0.17599530E-05_JPRB, 0.17596107E-05_JPRB, 0.17592604E-05_JPRB, 0.17589382E-05_JPRB, &
  & 0.17586407E-05_JPRB, 0.17583322E-05_JPRB, 0.17579249E-05_JPRB, 0.17570478E-05_JPRB /)

RGHG2(:,54,11) = (/ &
  & 0.17518514E-05_JPRB, 0.17532352E-05_JPRB, 0.17540452E-05_JPRB, 0.17549105E-05_JPRB, 0.17558685E-05_JPRB, 0.17566570E-05_JPRB, &
  & 0.17570168E-05_JPRB, 0.17571376E-05_JPRB, 0.17571551E-05_JPRB, 0.17571244E-05_JPRB, 0.17570630E-05_JPRB, 0.17569711E-05_JPRB, &
  & 0.17568374E-05_JPRB, 0.17566092E-05_JPRB, 0.17562609E-05_JPRB, 0.17555508E-05_JPRB, 0.17545244E-05_JPRB, 0.17531841E-05_JPRB, &
  & 0.17519369E-05_JPRB, 0.17509923E-05_JPRB, 0.17503868E-05_JPRB, 0.17501277E-05_JPRB, 0.17502043E-05_JPRB, 0.17506037E-05_JPRB, &
  & 0.17512824E-05_JPRB, 0.17522010E-05_JPRB, 0.17532591E-05_JPRB, 0.17544112E-05_JPRB, 0.17555559E-05_JPRB, 0.17566323E-05_JPRB, &
  & 0.17575640E-05_JPRB, 0.17582926E-05_JPRB, 0.17587591E-05_JPRB, 0.17589484E-05_JPRB, 0.17589007E-05_JPRB, 0.17586938E-05_JPRB, &
  & 0.17583992E-05_JPRB, 0.17580786E-05_JPRB, 0.17577693E-05_JPRB, 0.17574995E-05_JPRB, 0.17573021E-05_JPRB, 0.17572322E-05_JPRB, &
  & 0.17573631E-05_JPRB, 0.17577472E-05_JPRB, 0.17584017E-05_JPRB, 0.17592054E-05_JPRB, 0.17600694E-05_JPRB, 0.17608484E-05_JPRB, &
  & 0.17614875E-05_JPRB, 0.17619493E-05_JPRB, 0.17622558E-05_JPRB, 0.17624347E-05_JPRB, 0.17625201E-05_JPRB, 0.17625421E-05_JPRB, &
  & 0.17625124E-05_JPRB, 0.17624347E-05_JPRB, 0.17623017E-05_JPRB, 0.17621292E-05_JPRB, 0.17619452E-05_JPRB, 0.17617804E-05_JPRB, &
  & 0.17616333E-05_JPRB, 0.17614975E-05_JPRB, 0.17613586E-05_JPRB, 0.17611632E-05_JPRB /)

RGHG2(:,55,11) = (/ &
  & 0.17553273E-05_JPRB, 0.17563102E-05_JPRB, 0.17569155E-05_JPRB, 0.17574507E-05_JPRB, 0.17579823E-05_JPRB, 0.17583188E-05_JPRB, &
  & 0.17584202E-05_JPRB, 0.17584116E-05_JPRB, 0.17583700E-05_JPRB, 0.17583105E-05_JPRB, 0.17582370E-05_JPRB, 0.17581431E-05_JPRB, &
  & 0.17580096E-05_JPRB, 0.17578138E-05_JPRB, 0.17574406E-05_JPRB, 0.17568398E-05_JPRB, 0.17556993E-05_JPRB, 0.17542442E-05_JPRB, &
  & 0.17528167E-05_JPRB, 0.17516802E-05_JPRB, 0.17509334E-05_JPRB, 0.17505611E-05_JPRB, 0.17505586E-05_JPRB, 0.17509028E-05_JPRB, &
  & 0.17515638E-05_JPRB, 0.17524616E-05_JPRB, 0.17535351E-05_JPRB, 0.17546844E-05_JPRB, 0.17558459E-05_JPRB, 0.17569282E-05_JPRB, &
  & 0.17578673E-05_JPRB, 0.17585933E-05_JPRB, 0.17590512E-05_JPRB, 0.17592283E-05_JPRB, 0.17591650E-05_JPRB, 0.17589422E-05_JPRB, &
  & 0.17586352E-05_JPRB, 0.17583063E-05_JPRB, 0.17579946E-05_JPRB, 0.17577333E-05_JPRB, 0.17575621E-05_JPRB, 0.17575419E-05_JPRB, &
  & 0.17577529E-05_JPRB, 0.17582704E-05_JPRB, 0.17590457E-05_JPRB, 0.17600123E-05_JPRB, 0.17609766E-05_JPRB, 0.17618570E-05_JPRB, &
  & 0.17625597E-05_JPRB, 0.17630855E-05_JPRB, 0.17634359E-05_JPRB, 0.17636550E-05_JPRB, 0.17637851E-05_JPRB, 0.17638539E-05_JPRB, &
  & 0.17638790E-05_JPRB, 0.17638661E-05_JPRB, 0.17638149E-05_JPRB, 0.17637285E-05_JPRB, 0.17636296E-05_JPRB, 0.17635324E-05_JPRB, &
  & 0.17634447E-05_JPRB, 0.17633532E-05_JPRB, 0.17632401E-05_JPRB, 0.17630169E-05_JPRB /)

RGHG2(:,56,11) = (/ &
  & 0.17577792E-05_JPRB, 0.17585279E-05_JPRB, 0.17589040E-05_JPRB, 0.17592089E-05_JPRB, 0.17594382E-05_JPRB, 0.17595037E-05_JPRB, &
  & 0.17594568E-05_JPRB, 0.17593841E-05_JPRB, 0.17593175E-05_JPRB, 0.17592482E-05_JPRB, 0.17591735E-05_JPRB, 0.17590842E-05_JPRB, &
  & 0.17589658E-05_JPRB, 0.17587773E-05_JPRB, 0.17584770E-05_JPRB, 0.17578441E-05_JPRB, 0.17567869E-05_JPRB, 0.17552047E-05_JPRB, &
  & 0.17536013E-05_JPRB, 0.17523316E-05_JPRB, 0.17514582E-05_JPRB, 0.17509988E-05_JPRB, 0.17509319E-05_JPRB, 0.17512334E-05_JPRB, &
  & 0.17518602E-05_JPRB, 0.17527532E-05_JPRB, 0.17538173E-05_JPRB, 0.17549819E-05_JPRB, 0.17561487E-05_JPRB, 0.17572410E-05_JPRB, &
  & 0.17581822E-05_JPRB, 0.17589081E-05_JPRB, 0.17593580E-05_JPRB, 0.17595241E-05_JPRB, 0.17594472E-05_JPRB, 0.17592109E-05_JPRB, &
  & 0.17588918E-05_JPRB, 0.17585535E-05_JPRB, 0.17582395E-05_JPRB, 0.17579857E-05_JPRB, 0.17578376E-05_JPRB, 0.17578644E-05_JPRB, &
  & 0.17581569E-05_JPRB, 0.17587604E-05_JPRB, 0.17596769E-05_JPRB, 0.17607291E-05_JPRB, 0.17618065E-05_JPRB, 0.17627433E-05_JPRB, &
  & 0.17634991E-05_JPRB, 0.17640357E-05_JPRB, 0.17644015E-05_JPRB, 0.17646299E-05_JPRB, 0.17647671E-05_JPRB, 0.17648499E-05_JPRB, &
  & 0.17648972E-05_JPRB, 0.17649133E-05_JPRB, 0.17648999E-05_JPRB, 0.17648596E-05_JPRB, 0.17648040E-05_JPRB, 0.17647493E-05_JPRB, &
  & 0.17646942E-05_JPRB, 0.17646394E-05_JPRB, 0.17645739E-05_JPRB, 0.17644595E-05_JPRB /)

RGHG2(:,57,11) = (/ &
  & 0.17595343E-05_JPRB, 0.17601185E-05_JPRB, 0.17603680E-05_JPRB, 0.17605116E-05_JPRB, 0.17605389E-05_JPRB, 0.17604398E-05_JPRB, &
  & 0.17603098E-05_JPRB, 0.17602100E-05_JPRB, 0.17601315E-05_JPRB, 0.17600612E-05_JPRB, 0.17599888E-05_JPRB, 0.17599058E-05_JPRB, &
  & 0.17597957E-05_JPRB, 0.17596332E-05_JPRB, 0.17593343E-05_JPRB, 0.17588030E-05_JPRB, 0.17576992E-05_JPRB, 0.17560701E-05_JPRB, &
  & 0.17543474E-05_JPRB, 0.17529435E-05_JPRB, 0.17519875E-05_JPRB, 0.17514578E-05_JPRB, 0.17513391E-05_JPRB, 0.17515987E-05_JPRB, &
  & 0.17521970E-05_JPRB, 0.17530713E-05_JPRB, 0.17541370E-05_JPRB, 0.17553023E-05_JPRB, 0.17564771E-05_JPRB, 0.17575728E-05_JPRB, &
  & 0.17585182E-05_JPRB, 0.17592417E-05_JPRB, 0.17596869E-05_JPRB, 0.17598442E-05_JPRB, 0.17597564E-05_JPRB, 0.17595077E-05_JPRB, &
  & 0.17591768E-05_JPRB, 0.17588295E-05_JPRB, 0.17585110E-05_JPRB, 0.17582628E-05_JPRB, 0.17581385E-05_JPRB, 0.17582109E-05_JPRB, &
  & 0.17585634E-05_JPRB, 0.17592640E-05_JPRB, 0.17602492E-05_JPRB, 0.17614163E-05_JPRB, 0.17625557E-05_JPRB, 0.17635631E-05_JPRB, &
  & 0.17643346E-05_JPRB, 0.17648945E-05_JPRB, 0.17652483E-05_JPRB, 0.17654663E-05_JPRB, 0.17656001E-05_JPRB, 0.17656826E-05_JPRB, &
  & 0.17657328E-05_JPRB, 0.17657601E-05_JPRB, 0.17657633E-05_JPRB, 0.17657433E-05_JPRB, 0.17657100E-05_JPRB, 0.17656707E-05_JPRB, &
  & 0.17656321E-05_JPRB, 0.17655871E-05_JPRB, 0.17655285E-05_JPRB, 0.17654085E-05_JPRB /)

RGHG2(:,58,11) = (/ &
  & 0.17611751E-05_JPRB, 0.17614348E-05_JPRB, 0.17615355E-05_JPRB, 0.17615496E-05_JPRB, 0.17614425E-05_JPRB, 0.17612472E-05_JPRB, &
  & 0.17610810E-05_JPRB, 0.17609623E-05_JPRB, 0.17608842E-05_JPRB, 0.17608138E-05_JPRB, 0.17607454E-05_JPRB, 0.17606676E-05_JPRB, &
  & 0.17605653E-05_JPRB, 0.17604092E-05_JPRB, 0.17601433E-05_JPRB, 0.17595934E-05_JPRB, 0.17585569E-05_JPRB, 0.17568523E-05_JPRB, &
  & 0.17550331E-05_JPRB, 0.17535582E-05_JPRB, 0.17525324E-05_JPRB, 0.17519533E-05_JPRB, 0.17517908E-05_JPRB, 0.17520126E-05_JPRB, &
  & 0.17525819E-05_JPRB, 0.17534389E-05_JPRB, 0.17544951E-05_JPRB, 0.17556604E-05_JPRB, 0.17568361E-05_JPRB, 0.17579346E-05_JPRB, &
  & 0.17588789E-05_JPRB, 0.17596059E-05_JPRB, 0.17600465E-05_JPRB, 0.17601975E-05_JPRB, 0.17601004E-05_JPRB, 0.17598416E-05_JPRB, &
  & 0.17595012E-05_JPRB, 0.17591433E-05_JPRB, 0.17588187E-05_JPRB, 0.17585751E-05_JPRB, 0.17584712E-05_JPRB, 0.17585832E-05_JPRB, &
  & 0.17589992E-05_JPRB, 0.17597559E-05_JPRB, 0.17608268E-05_JPRB, 0.17620458E-05_JPRB, 0.17632668E-05_JPRB, 0.17643143E-05_JPRB, &
  & 0.17651337E-05_JPRB, 0.17656777E-05_JPRB, 0.17660254E-05_JPRB, 0.17662289E-05_JPRB, 0.17663485E-05_JPRB, 0.17664231E-05_JPRB, &
  & 0.17664711E-05_JPRB, 0.17664975E-05_JPRB, 0.17665045E-05_JPRB, 0.17664918E-05_JPRB, 0.17664659E-05_JPRB, 0.17664363E-05_JPRB, &
  & 0.17664026E-05_JPRB, 0.17663663E-05_JPRB, 0.17663165E-05_JPRB, 0.17662182E-05_JPRB /)

RGHG2(:,59,11) = (/ &
  & 0.17622267E-05_JPRB, 0.17624465E-05_JPRB, 0.17624847E-05_JPRB, 0.17624254E-05_JPRB, 0.17622540E-05_JPRB, 0.17620033E-05_JPRB, &
  & 0.17618097E-05_JPRB, 0.17616921E-05_JPRB, 0.17616106E-05_JPRB, 0.17615446E-05_JPRB, 0.17614782E-05_JPRB, 0.17614027E-05_JPRB, &
  & 0.17613046E-05_JPRB, 0.17611518E-05_JPRB, 0.17608835E-05_JPRB, 0.17603564E-05_JPRB, 0.17592743E-05_JPRB, 0.17575618E-05_JPRB, &
  & 0.17557001E-05_JPRB, 0.17541793E-05_JPRB, 0.17531146E-05_JPRB, 0.17524955E-05_JPRB, 0.17522983E-05_JPRB, 0.17524881E-05_JPRB, &
  & 0.17530278E-05_JPRB, 0.17538654E-05_JPRB, 0.17549073E-05_JPRB, 0.17560668E-05_JPRB, 0.17572378E-05_JPRB, 0.17583313E-05_JPRB, &
  & 0.17592813E-05_JPRB, 0.17600066E-05_JPRB, 0.17604473E-05_JPRB, 0.17605923E-05_JPRB, 0.17604882E-05_JPRB, 0.17602217E-05_JPRB, &
  & 0.17598713E-05_JPRB, 0.17595033E-05_JPRB, 0.17591708E-05_JPRB, 0.17589284E-05_JPRB, 0.17588418E-05_JPRB, 0.17589913E-05_JPRB, &
  & 0.17594543E-05_JPRB, 0.17602738E-05_JPRB, 0.17613869E-05_JPRB, 0.17626659E-05_JPRB, 0.17639308E-05_JPRB, 0.17650411E-05_JPRB, &
  & 0.17658688E-05_JPRB, 0.17664330E-05_JPRB, 0.17667596E-05_JPRB, 0.17669440E-05_JPRB, 0.17670511E-05_JPRB, 0.17671151E-05_JPRB, &
  & 0.17671543E-05_JPRB, 0.17671759E-05_JPRB, 0.17671794E-05_JPRB, 0.17671654E-05_JPRB, 0.17671409E-05_JPRB, 0.17671109E-05_JPRB, &
  & 0.17670803E-05_JPRB, 0.17670422E-05_JPRB, 0.17669915E-05_JPRB, 0.17668855E-05_JPRB /)

RGHG2(:,60,11) = (/ &
  & 0.17632505E-05_JPRB, 0.17633497E-05_JPRB, 0.17633325E-05_JPRB, 0.17632351E-05_JPRB, 0.17630067E-05_JPRB, 0.17627385E-05_JPRB, &
  & 0.17625387E-05_JPRB, 0.17624114E-05_JPRB, 0.17623368E-05_JPRB, 0.17622713E-05_JPRB, 0.17622085E-05_JPRB, 0.17621360E-05_JPRB, &
  & 0.17620362E-05_JPRB, 0.17618852E-05_JPRB, 0.17616031E-05_JPRB, 0.17610480E-05_JPRB, 0.17599366E-05_JPRB, 0.17582046E-05_JPRB, &
  & 0.17563577E-05_JPRB, 0.17548300E-05_JPRB, 0.17537402E-05_JPRB, 0.17530966E-05_JPRB, 0.17528735E-05_JPRB, 0.17530356E-05_JPRB, &
  & 0.17535496E-05_JPRB, 0.17543636E-05_JPRB, 0.17553887E-05_JPRB, 0.17565335E-05_JPRB, 0.17576930E-05_JPRB, 0.17587832E-05_JPRB, &
  & 0.17597285E-05_JPRB, 0.17604583E-05_JPRB, 0.17608962E-05_JPRB, 0.17610380E-05_JPRB, 0.17609277E-05_JPRB, 0.17606544E-05_JPRB, &
  & 0.17602956E-05_JPRB, 0.17599162E-05_JPRB, 0.17595739E-05_JPRB, 0.17593304E-05_JPRB, 0.17592572E-05_JPRB, 0.17594366E-05_JPRB, &
  & 0.17599471E-05_JPRB, 0.17608095E-05_JPRB, 0.17619666E-05_JPRB, 0.17632727E-05_JPRB, 0.17645791E-05_JPRB, 0.17657179E-05_JPRB, &
  & 0.17665943E-05_JPRB, 0.17671480E-05_JPRB, 0.17674668E-05_JPRB, 0.17676387E-05_JPRB, 0.17677304E-05_JPRB, 0.17677833E-05_JPRB, &
  & 0.17678129E-05_JPRB, 0.17678249E-05_JPRB, 0.17678201E-05_JPRB, 0.17677999E-05_JPRB, 0.17677698E-05_JPRB, 0.17677382E-05_JPRB, &
  & 0.17677023E-05_JPRB, 0.17676639E-05_JPRB, 0.17676107E-05_JPRB, 0.17675060E-05_JPRB /)

RGHG2(:,61,11) = (/ &
  & 0.17640688E-05_JPRB, 0.17641603E-05_JPRB, 0.17641221E-05_JPRB, 0.17639918E-05_JPRB, 0.17637667E-05_JPRB, 0.17634761E-05_JPRB, &
  & 0.17632648E-05_JPRB, 0.17631403E-05_JPRB, 0.17630650E-05_JPRB, 0.17630060E-05_JPRB, 0.17629461E-05_JPRB, 0.17628751E-05_JPRB, &
  & 0.17627776E-05_JPRB, 0.17626114E-05_JPRB, 0.17623162E-05_JPRB, 0.17617004E-05_JPRB, 0.17605403E-05_JPRB, 0.17588304E-05_JPRB, &
  & 0.17570292E-05_JPRB, 0.17555196E-05_JPRB, 0.17544252E-05_JPRB, 0.17537692E-05_JPRB, 0.17535307E-05_JPRB, 0.17536711E-05_JPRB, &
  & 0.17541596E-05_JPRB, 0.17549501E-05_JPRB, 0.17559516E-05_JPRB, 0.17570769E-05_JPRB, 0.17582206E-05_JPRB, 0.17592977E-05_JPRB, &
  & 0.17602431E-05_JPRB, 0.17609684E-05_JPRB, 0.17614062E-05_JPRB, 0.17615434E-05_JPRB, 0.17614282E-05_JPRB, 0.17611488E-05_JPRB, &
  & 0.17607805E-05_JPRB, 0.17603891E-05_JPRB, 0.17600355E-05_JPRB, 0.17597878E-05_JPRB, 0.17597250E-05_JPRB, 0.17599310E-05_JPRB, &
  & 0.17604771E-05_JPRB, 0.17613812E-05_JPRB, 0.17625663E-05_JPRB, 0.17638937E-05_JPRB, 0.17652127E-05_JPRB, 0.17663867E-05_JPRB, &
  & 0.17672738E-05_JPRB, 0.17678494E-05_JPRB, 0.17681626E-05_JPRB, 0.17683192E-05_JPRB, 0.17684011E-05_JPRB, 0.17684422E-05_JPRB, &
  & 0.17684599E-05_JPRB, 0.17684598E-05_JPRB, 0.17684429E-05_JPRB, 0.17684117E-05_JPRB, 0.17683741E-05_JPRB, 0.17683332E-05_JPRB, &
  & 0.17682937E-05_JPRB, 0.17682469E-05_JPRB, 0.17681870E-05_JPRB, 0.17680671E-05_JPRB /)

RGHG2(:,62,11) = (/ &
  & 0.17649172E-05_JPRB, 0.17649579E-05_JPRB, 0.17648958E-05_JPRB, 0.17647612E-05_JPRB, 0.17645146E-05_JPRB, 0.17642299E-05_JPRB, &
  & 0.17640053E-05_JPRB, 0.17638718E-05_JPRB, 0.17638038E-05_JPRB, 0.17637485E-05_JPRB, 0.17636967E-05_JPRB, 0.17636316E-05_JPRB, &
  & 0.17635321E-05_JPRB, 0.17633620E-05_JPRB, 0.17630208E-05_JPRB, 0.17623488E-05_JPRB, 0.17611416E-05_JPRB, 0.17594710E-05_JPRB, &
  & 0.17577444E-05_JPRB, 0.17562669E-05_JPRB, 0.17551841E-05_JPRB, 0.17545292E-05_JPRB, 0.17542840E-05_JPRB, 0.17544088E-05_JPRB, &
  & 0.17548750E-05_JPRB, 0.17556388E-05_JPRB, 0.17566147E-05_JPRB, 0.17577131E-05_JPRB, 0.17588350E-05_JPRB, 0.17598986E-05_JPRB, &
  & 0.17608329E-05_JPRB, 0.17615549E-05_JPRB, 0.17619884E-05_JPRB, 0.17621205E-05_JPRB, 0.17620001E-05_JPRB, 0.17617142E-05_JPRB, &
  & 0.17613368E-05_JPRB, 0.17609327E-05_JPRB, 0.17605651E-05_JPRB, 0.17603109E-05_JPRB, 0.17602546E-05_JPRB, 0.17604807E-05_JPRB, &
  & 0.17610583E-05_JPRB, 0.17619917E-05_JPRB, 0.17631992E-05_JPRB, 0.17645352E-05_JPRB, 0.17658592E-05_JPRB, 0.17670318E-05_JPRB, &
  & 0.17679492E-05_JPRB, 0.17685350E-05_JPRB, 0.17688490E-05_JPRB, 0.17690038E-05_JPRB, 0.17690724E-05_JPRB, 0.17691009E-05_JPRB, &
  & 0.17691050E-05_JPRB, 0.17690902E-05_JPRB, 0.17690581E-05_JPRB, 0.17690129E-05_JPRB, 0.17689616E-05_JPRB, 0.17689129E-05_JPRB, &
  & 0.17688619E-05_JPRB, 0.17688083E-05_JPRB, 0.17687373E-05_JPRB, 0.17686025E-05_JPRB /)

RGHG2(:,63,11) = (/ &
  & 0.17657080E-05_JPRB, 0.17657447E-05_JPRB, 0.17656757E-05_JPRB, 0.17655290E-05_JPRB, 0.17652952E-05_JPRB, 0.17649927E-05_JPRB, &
  & 0.17647545E-05_JPRB, 0.17646087E-05_JPRB, 0.17645435E-05_JPRB, 0.17644988E-05_JPRB, 0.17644574E-05_JPRB, 0.17644044E-05_JPRB, &
  & 0.17643101E-05_JPRB, 0.17641237E-05_JPRB, 0.17637424E-05_JPRB, 0.17630076E-05_JPRB, 0.17617756E-05_JPRB, 0.17601812E-05_JPRB, &
  & 0.17585235E-05_JPRB, 0.17570927E-05_JPRB, 0.17560350E-05_JPRB, 0.17553930E-05_JPRB, 0.17551500E-05_JPRB, 0.17552659E-05_JPRB, &
  & 0.17557128E-05_JPRB, 0.17564497E-05_JPRB, 0.17573935E-05_JPRB, 0.17584623E-05_JPRB, 0.17595570E-05_JPRB, 0.17605986E-05_JPRB, &
  & 0.17615191E-05_JPRB, 0.17622294E-05_JPRB, 0.17626553E-05_JPRB, 0.17627797E-05_JPRB, 0.17626539E-05_JPRB, 0.17623622E-05_JPRB, &
  & 0.17619756E-05_JPRB, 0.17615575E-05_JPRB, 0.17611748E-05_JPRB, 0.17609115E-05_JPRB, 0.17608578E-05_JPRB, 0.17610990E-05_JPRB, &
  & 0.17616979E-05_JPRB, 0.17626526E-05_JPRB, 0.17638732E-05_JPRB, 0.17652105E-05_JPRB, 0.17665228E-05_JPRB, 0.17676925E-05_JPRB, &
  & 0.17686081E-05_JPRB, 0.17692150E-05_JPRB, 0.17695438E-05_JPRB, 0.17696927E-05_JPRB, 0.17697538E-05_JPRB, 0.17697686E-05_JPRB, &
  & 0.17697564E-05_JPRB, 0.17697229E-05_JPRB, 0.17696714E-05_JPRB, 0.17696082E-05_JPRB, 0.17695432E-05_JPRB, 0.17694790E-05_JPRB, &
  & 0.17694182E-05_JPRB, 0.17693492E-05_JPRB, 0.17692632E-05_JPRB, 0.17690995E-05_JPRB /)

RGHG2(:,64,11) = (/ &
  & 0.17665072E-05_JPRB, 0.17665379E-05_JPRB, 0.17664636E-05_JPRB, 0.17663199E-05_JPRB, 0.17660802E-05_JPRB, 0.17657803E-05_JPRB, &
  & 0.17655103E-05_JPRB, 0.17653472E-05_JPRB, 0.17652853E-05_JPRB, 0.17652504E-05_JPRB, 0.17652267E-05_JPRB, 0.17651907E-05_JPRB, &
  & 0.17651068E-05_JPRB, 0.17649056E-05_JPRB, 0.17644895E-05_JPRB, 0.17637059E-05_JPRB, 0.17625011E-05_JPRB, 0.17609664E-05_JPRB, &
  & 0.17593834E-05_JPRB, 0.17580074E-05_JPRB, 0.17569887E-05_JPRB, 0.17563701E-05_JPRB, 0.17561387E-05_JPRB, 0.17562503E-05_JPRB, &
  & 0.17566796E-05_JPRB, 0.17573873E-05_JPRB, 0.17582964E-05_JPRB, 0.17593278E-05_JPRB, 0.17603895E-05_JPRB, 0.17614024E-05_JPRB, &
  & 0.17623005E-05_JPRB, 0.17629930E-05_JPRB, 0.17634048E-05_JPRB, 0.17635199E-05_JPRB, 0.17633895E-05_JPRB, 0.17630946E-05_JPRB, &
  & 0.17627007E-05_JPRB, 0.17622699E-05_JPRB, 0.17618715E-05_JPRB, 0.17615970E-05_JPRB, 0.17615414E-05_JPRB, 0.17617901E-05_JPRB, &
  & 0.17624020E-05_JPRB, 0.17633669E-05_JPRB, 0.17645899E-05_JPRB, 0.17659197E-05_JPRB, 0.17672165E-05_JPRB, 0.17683612E-05_JPRB, &
  & 0.17692744E-05_JPRB, 0.17698898E-05_JPRB, 0.17702328E-05_JPRB, 0.17703906E-05_JPRB, 0.17704431E-05_JPRB, 0.17704438E-05_JPRB, &
  & 0.17704128E-05_JPRB, 0.17703580E-05_JPRB, 0.17702853E-05_JPRB, 0.17702015E-05_JPRB, 0.17701168E-05_JPRB, 0.17700388E-05_JPRB, &
  & 0.17699593E-05_JPRB, 0.17698753E-05_JPRB, 0.17697653E-05_JPRB, 0.17695597E-05_JPRB /)

RGHG2(:,65,11) = (/ &
  & 0.17673030E-05_JPRB, 0.17673392E-05_JPRB, 0.17672658E-05_JPRB, 0.17671193E-05_JPRB, 0.17668887E-05_JPRB, 0.17665743E-05_JPRB, &
  & 0.17662896E-05_JPRB, 0.17660902E-05_JPRB, 0.17660368E-05_JPRB, 0.17660147E-05_JPRB, 0.17660109E-05_JPRB, 0.17659971E-05_JPRB, &
  & 0.17659216E-05_JPRB, 0.17657137E-05_JPRB, 0.17652649E-05_JPRB, 0.17644801E-05_JPRB, 0.17633024E-05_JPRB, 0.17618398E-05_JPRB, &
  & 0.17603336E-05_JPRB, 0.17590228E-05_JPRB, 0.17580522E-05_JPRB, 0.17574671E-05_JPRB, 0.17572515E-05_JPRB, 0.17573632E-05_JPRB, &
  & 0.17577750E-05_JPRB, 0.17584500E-05_JPRB, 0.17593163E-05_JPRB, 0.17603047E-05_JPRB, 0.17613232E-05_JPRB, 0.17622988E-05_JPRB, &
  & 0.17631651E-05_JPRB, 0.17638307E-05_JPRB, 0.17642230E-05_JPRB, 0.17643282E-05_JPRB, 0.17641964E-05_JPRB, 0.17639034E-05_JPRB, &
  & 0.17635077E-05_JPRB, 0.17630696E-05_JPRB, 0.17626594E-05_JPRB, 0.17623739E-05_JPRB, 0.17623133E-05_JPRB, 0.17625632E-05_JPRB, &
  & 0.17631778E-05_JPRB, 0.17641404E-05_JPRB, 0.17653535E-05_JPRB, 0.17666655E-05_JPRB, 0.17679363E-05_JPRB, 0.17690563E-05_JPRB, &
  & 0.17699465E-05_JPRB, 0.17705656E-05_JPRB, 0.17709229E-05_JPRB, 0.17710878E-05_JPRB, 0.17711377E-05_JPRB, 0.17711257E-05_JPRB, &
  & 0.17710747E-05_JPRB, 0.17709988E-05_JPRB, 0.17709023E-05_JPRB, 0.17707969E-05_JPRB, 0.17706938E-05_JPRB, 0.17705933E-05_JPRB, &
  & 0.17704965E-05_JPRB, 0.17703851E-05_JPRB, 0.17702423E-05_JPRB, 0.17699707E-05_JPRB /)

RGHG2(:,66,11) = (/ &
  & 0.17680666E-05_JPRB, 0.17681375E-05_JPRB, 0.17680723E-05_JPRB, 0.17679349E-05_JPRB, 0.17677036E-05_JPRB, 0.17673954E-05_JPRB, &
  & 0.17670750E-05_JPRB, 0.17668610E-05_JPRB, 0.17668117E-05_JPRB, 0.17668062E-05_JPRB, 0.17668239E-05_JPRB, 0.17668284E-05_JPRB, &
  & 0.17667617E-05_JPRB, 0.17665474E-05_JPRB, 0.17660959E-05_JPRB, 0.17653211E-05_JPRB, 0.17641893E-05_JPRB, 0.17628009E-05_JPRB, &
  & 0.17613778E-05_JPRB, 0.17601423E-05_JPRB, 0.17592296E-05_JPRB, 0.17586825E-05_JPRB, 0.17584865E-05_JPRB, 0.17585965E-05_JPRB, &
  & 0.17589871E-05_JPRB, 0.17596224E-05_JPRB, 0.17604384E-05_JPRB, 0.17613715E-05_JPRB, 0.17623378E-05_JPRB, 0.17632653E-05_JPRB, &
  & 0.17640914E-05_JPRB, 0.17647232E-05_JPRB, 0.17650921E-05_JPRB, 0.17651876E-05_JPRB, 0.17650588E-05_JPRB, 0.17647747E-05_JPRB, &
  & 0.17643866E-05_JPRB, 0.17639493E-05_JPRB, 0.17635365E-05_JPRB, 0.17632436E-05_JPRB, 0.17631781E-05_JPRB, 0.17634228E-05_JPRB, &
  & 0.17640308E-05_JPRB, 0.17649784E-05_JPRB, 0.17661674E-05_JPRB, 0.17674491E-05_JPRB, 0.17686856E-05_JPRB, 0.17697699E-05_JPRB, &
  & 0.17706358E-05_JPRB, 0.17712424E-05_JPRB, 0.17716056E-05_JPRB, 0.17717824E-05_JPRB, 0.17718310E-05_JPRB, 0.17718096E-05_JPRB, &
  & 0.17717437E-05_JPRB, 0.17716461E-05_JPRB, 0.17715303E-05_JPRB, 0.17714026E-05_JPRB, 0.17712762E-05_JPRB, 0.17711573E-05_JPRB, &
  & 0.17710317E-05_JPRB, 0.17708919E-05_JPRB, 0.17707009E-05_JPRB, 0.17703333E-05_JPRB /)

RGHG2(:,67,11) = (/ &
  & 0.17688542E-05_JPRB, 0.17689533E-05_JPRB, 0.17688981E-05_JPRB, 0.17687612E-05_JPRB, 0.17685375E-05_JPRB, 0.17682250E-05_JPRB, &
  & 0.17679038E-05_JPRB, 0.17676559E-05_JPRB, 0.17676260E-05_JPRB, 0.17676380E-05_JPRB, 0.17676733E-05_JPRB, 0.17676920E-05_JPRB, &
  & 0.17676313E-05_JPRB, 0.17674214E-05_JPRB, 0.17669763E-05_JPRB, 0.17662271E-05_JPRB, 0.17651523E-05_JPRB, 0.17638475E-05_JPRB, &
  & 0.17625180E-05_JPRB, 0.17613638E-05_JPRB, 0.17605134E-05_JPRB, 0.17600057E-05_JPRB, 0.17598262E-05_JPRB, 0.17599316E-05_JPRB, &
  & 0.17602958E-05_JPRB, 0.17608836E-05_JPRB, 0.17616397E-05_JPRB, 0.17625105E-05_JPRB, 0.17634144E-05_JPRB, 0.17642853E-05_JPRB, &
  & 0.17650636E-05_JPRB, 0.17656562E-05_JPRB, 0.17659986E-05_JPRB, 0.17660849E-05_JPRB, 0.17659632E-05_JPRB, 0.17656959E-05_JPRB, &
  & 0.17653242E-05_JPRB, 0.17648994E-05_JPRB, 0.17644930E-05_JPRB, 0.17642018E-05_JPRB, 0.17641331E-05_JPRB, 0.17643709E-05_JPRB, &
  & 0.17649629E-05_JPRB, 0.17658829E-05_JPRB, 0.17670335E-05_JPRB, 0.17682700E-05_JPRB, 0.17694617E-05_JPRB, 0.17705052E-05_JPRB, &
  & 0.17713389E-05_JPRB, 0.17719267E-05_JPRB, 0.17722887E-05_JPRB, 0.17724677E-05_JPRB, 0.17725189E-05_JPRB, 0.17724939E-05_JPRB, &
  & 0.17724153E-05_JPRB, 0.17723052E-05_JPRB, 0.17721700E-05_JPRB, 0.17720239E-05_JPRB, 0.17718797E-05_JPRB, 0.17717347E-05_JPRB, &
  & 0.17715885E-05_JPRB, 0.17714073E-05_JPRB, 0.17711577E-05_JPRB, 0.17706573E-05_JPRB /)

RGHG2(:,68,11) = (/ &
  & 0.17696141E-05_JPRB, 0.17697696E-05_JPRB, 0.17697316E-05_JPRB, 0.17696063E-05_JPRB, 0.17693878E-05_JPRB, 0.17690837E-05_JPRB, &
  & 0.17687539E-05_JPRB, 0.17685049E-05_JPRB, 0.17684881E-05_JPRB, 0.17685154E-05_JPRB, 0.17685652E-05_JPRB, 0.17685919E-05_JPRB, &
  & 0.17685361E-05_JPRB, 0.17683333E-05_JPRB, 0.17679038E-05_JPRB, 0.17671931E-05_JPRB, 0.17661848E-05_JPRB, 0.17649730E-05_JPRB, &
  & 0.17637410E-05_JPRB, 0.17626739E-05_JPRB, 0.17618845E-05_JPRB, 0.17614144E-05_JPRB, 0.17612485E-05_JPRB, 0.17613438E-05_JPRB, &
  & 0.17616760E-05_JPRB, 0.17622120E-05_JPRB, 0.17629030E-05_JPRB, 0.17637043E-05_JPRB, 0.17645400E-05_JPRB, 0.17653484E-05_JPRB, &
  & 0.17660736E-05_JPRB, 0.17666233E-05_JPRB, 0.17669377E-05_JPRB, 0.17670154E-05_JPRB, 0.17669038E-05_JPRB, 0.17666569E-05_JPRB, &
  & 0.17663099E-05_JPRB, 0.17659071E-05_JPRB, 0.17655186E-05_JPRB, 0.17652364E-05_JPRB, 0.17651706E-05_JPRB, 0.17654007E-05_JPRB, &
  & 0.17659722E-05_JPRB, 0.17668539E-05_JPRB, 0.17679520E-05_JPRB, 0.17691316E-05_JPRB, 0.17702655E-05_JPRB, 0.17712587E-05_JPRB, &
  & 0.17720529E-05_JPRB, 0.17726171E-05_JPRB, 0.17729669E-05_JPRB, 0.17731489E-05_JPRB, 0.17731998E-05_JPRB, 0.17731735E-05_JPRB, &
  & 0.17730920E-05_JPRB, 0.17729718E-05_JPRB, 0.17728273E-05_JPRB, 0.17726667E-05_JPRB, 0.17725034E-05_JPRB, 0.17723470E-05_JPRB, &
  & 0.17721700E-05_JPRB, 0.17719611E-05_JPRB, 0.17716442E-05_JPRB, 0.17709993E-05_JPRB /)

RGHG2(:,69,11) = (/ &
  & 0.17703813E-05_JPRB, 0.17706045E-05_JPRB, 0.17705881E-05_JPRB, 0.17704731E-05_JPRB, 0.17702657E-05_JPRB, 0.17699740E-05_JPRB, &
  & 0.17696539E-05_JPRB, 0.17694056E-05_JPRB, 0.17694059E-05_JPRB, 0.17694465E-05_JPRB, 0.17695033E-05_JPRB, 0.17695339E-05_JPRB, &
  & 0.17694807E-05_JPRB, 0.17692870E-05_JPRB, 0.17688784E-05_JPRB, 0.17682131E-05_JPRB, 0.17672794E-05_JPRB, 0.17661654E-05_JPRB, &
  & 0.17650361E-05_JPRB, 0.17640539E-05_JPRB, 0.17633263E-05_JPRB, 0.17628890E-05_JPRB, 0.17627324E-05_JPRB, 0.17628150E-05_JPRB, &
  & 0.17631130E-05_JPRB, 0.17635946E-05_JPRB, 0.17642174E-05_JPRB, 0.17649469E-05_JPRB, 0.17657112E-05_JPRB, 0.17664537E-05_JPRB, &
  & 0.17671219E-05_JPRB, 0.17676263E-05_JPRB, 0.17679113E-05_JPRB, 0.17679802E-05_JPRB, 0.17678798E-05_JPRB, 0.17676565E-05_JPRB, &
  & 0.17673385E-05_JPRB, 0.17669640E-05_JPRB, 0.17666007E-05_JPRB, 0.17663372E-05_JPRB, 0.17662792E-05_JPRB, 0.17665038E-05_JPRB, &
  & 0.17670503E-05_JPRB, 0.17678871E-05_JPRB, 0.17689233E-05_JPRB, 0.17700322E-05_JPRB, 0.17710984E-05_JPRB, 0.17720326E-05_JPRB, &
  & 0.17727807E-05_JPRB, 0.17733142E-05_JPRB, 0.17736492E-05_JPRB, 0.17738256E-05_JPRB, 0.17738764E-05_JPRB, 0.17738522E-05_JPRB, &
  & 0.17737707E-05_JPRB, 0.17736498E-05_JPRB, 0.17734999E-05_JPRB, 0.17733304E-05_JPRB, 0.17731622E-05_JPRB, 0.17729872E-05_JPRB, &
  & 0.17728047E-05_JPRB, 0.17725611E-05_JPRB, 0.17721931E-05_JPRB, 0.17713970E-05_JPRB /)

RGHG2(:,70,11) = (/ &
  & 0.17711573E-05_JPRB, 0.17714574E-05_JPRB, 0.17714688E-05_JPRB, 0.17713709E-05_JPRB, 0.17711786E-05_JPRB, 0.17709037E-05_JPRB, &
  & 0.17706035E-05_JPRB, 0.17703690E-05_JPRB, 0.17703826E-05_JPRB, 0.17704313E-05_JPRB, 0.17704878E-05_JPRB, 0.17705158E-05_JPRB, &
  & 0.17704623E-05_JPRB, 0.17702781E-05_JPRB, 0.17698945E-05_JPRB, 0.17692805E-05_JPRB, 0.17684251E-05_JPRB, 0.17674103E-05_JPRB, &
  & 0.17663830E-05_JPRB, 0.17654875E-05_JPRB, 0.17648176E-05_JPRB, 0.17644129E-05_JPRB, 0.17642633E-05_JPRB, 0.17643320E-05_JPRB, &
  & 0.17645945E-05_JPRB, 0.17650218E-05_JPRB, 0.17655766E-05_JPRB, 0.17662317E-05_JPRB, 0.17669233E-05_JPRB, 0.17675962E-05_JPRB, &
  & 0.17682064E-05_JPRB, 0.17686634E-05_JPRB, 0.17689187E-05_JPRB, 0.17689789E-05_JPRB, 0.17688902E-05_JPRB, 0.17686916E-05_JPRB, &
  & 0.17684056E-05_JPRB, 0.17680650E-05_JPRB, 0.17677329E-05_JPRB, 0.17674929E-05_JPRB, 0.17674467E-05_JPRB, 0.17676657E-05_JPRB, &
  & 0.17681883E-05_JPRB, 0.17689742E-05_JPRB, 0.17699407E-05_JPRB, 0.17709713E-05_JPRB, 0.17719591E-05_JPRB, 0.17728250E-05_JPRB, &
  & 0.17735190E-05_JPRB, 0.17740156E-05_JPRB, 0.17743296E-05_JPRB, 0.17744999E-05_JPRB, 0.17745504E-05_JPRB, 0.17745302E-05_JPRB, &
  & 0.17744555E-05_JPRB, 0.17743386E-05_JPRB, 0.17741909E-05_JPRB, 0.17740224E-05_JPRB, 0.17738498E-05_JPRB, 0.17736778E-05_JPRB, &
  & 0.17734824E-05_JPRB, 0.17732332E-05_JPRB, 0.17728225E-05_JPRB, 0.17719178E-05_JPRB /)

RGHG2(:,71,11) = (/ &
  & 0.17719645E-05_JPRB, 0.17723422E-05_JPRB, 0.17723793E-05_JPRB, 0.17722988E-05_JPRB, 0.17721239E-05_JPRB, 0.17718746E-05_JPRB, &
  & 0.17715969E-05_JPRB, 0.17713892E-05_JPRB, 0.17714116E-05_JPRB, 0.17714589E-05_JPRB, 0.17715113E-05_JPRB, 0.17715313E-05_JPRB, &
  & 0.17714758E-05_JPRB, 0.17713021E-05_JPRB, 0.17709439E-05_JPRB, 0.17703844E-05_JPRB, 0.17696086E-05_JPRB, 0.17686950E-05_JPRB, &
  & 0.17677689E-05_JPRB, 0.17669570E-05_JPRB, 0.17663485E-05_JPRB, 0.17659738E-05_JPRB, 0.17658315E-05_JPRB, 0.17658859E-05_JPRB, &
  & 0.17661130E-05_JPRB, 0.17664864E-05_JPRB, 0.17669727E-05_JPRB, 0.17675540E-05_JPRB, 0.17681708E-05_JPRB, 0.17687739E-05_JPRB, &
  & 0.17693229E-05_JPRB, 0.17697326E-05_JPRB, 0.17699584E-05_JPRB, 0.17700110E-05_JPRB, 0.17699342E-05_JPRB, 0.17697611E-05_JPRB, &
  & 0.17695086E-05_JPRB, 0.17692035E-05_JPRB, 0.17689065E-05_JPRB, 0.17686945E-05_JPRB, 0.17686627E-05_JPRB, 0.17688774E-05_JPRB, &
  & 0.17693707E-05_JPRB, 0.17701037E-05_JPRB, 0.17709942E-05_JPRB, 0.17719387E-05_JPRB, 0.17728404E-05_JPRB, 0.17736303E-05_JPRB, &
  & 0.17742626E-05_JPRB, 0.17747185E-05_JPRB, 0.17750083E-05_JPRB, 0.17751697E-05_JPRB, 0.17752200E-05_JPRB, 0.17752063E-05_JPRB, &
  & 0.17751429E-05_JPRB, 0.17750361E-05_JPRB, 0.17748989E-05_JPRB, 0.17747382E-05_JPRB, 0.17745717E-05_JPRB, 0.17744032E-05_JPRB, &
  & 0.17742148E-05_JPRB, 0.17739599E-05_JPRB, 0.17735414E-05_JPRB, 0.17725698E-05_JPRB /)

RGHG2(:,72,11) = (/ &
  & 0.17728163E-05_JPRB, 0.17732540E-05_JPRB, 0.17733139E-05_JPRB, 0.17732497E-05_JPRB, 0.17730946E-05_JPRB, 0.17728685E-05_JPRB, &
  & 0.17726283E-05_JPRB, 0.17724483E-05_JPRB, 0.17724710E-05_JPRB, 0.17725163E-05_JPRB, 0.17725559E-05_JPRB, 0.17725672E-05_JPRB, &
  & 0.17725087E-05_JPRB, 0.17723476E-05_JPRB, 0.17720188E-05_JPRB, 0.17715137E-05_JPRB, 0.17708217E-05_JPRB, 0.17700052E-05_JPRB, &
  & 0.17691812E-05_JPRB, 0.17684551E-05_JPRB, 0.17679071E-05_JPRB, 0.17675670E-05_JPRB, 0.17674303E-05_JPRB, 0.17674704E-05_JPRB, &
  & 0.17676631E-05_JPRB, 0.17679822E-05_JPRB, 0.17684025E-05_JPRB, 0.17689076E-05_JPRB, 0.17694492E-05_JPRB, 0.17699801E-05_JPRB, &
  & 0.17704675E-05_JPRB, 0.17708292E-05_JPRB, 0.17710277E-05_JPRB, 0.17710729E-05_JPRB, 0.17710086E-05_JPRB, 0.17708606E-05_JPRB, &
  & 0.17706427E-05_JPRB, 0.17703766E-05_JPRB, 0.17701176E-05_JPRB, 0.17699357E-05_JPRB, 0.17699192E-05_JPRB, 0.17701273E-05_JPRB, &
  & 0.17705895E-05_JPRB, 0.17712614E-05_JPRB, 0.17720698E-05_JPRB, 0.17729236E-05_JPRB, 0.17737314E-05_JPRB, 0.17744378E-05_JPRB, &
  & 0.17750060E-05_JPRB, 0.17754147E-05_JPRB, 0.17756786E-05_JPRB, 0.17758298E-05_JPRB, 0.17758807E-05_JPRB, 0.17758756E-05_JPRB, &
  & 0.17758255E-05_JPRB, 0.17757370E-05_JPRB, 0.17756131E-05_JPRB, 0.17754646E-05_JPRB, 0.17753146E-05_JPRB, 0.17751524E-05_JPRB, &
  & 0.17749754E-05_JPRB, 0.17747345E-05_JPRB, 0.17743105E-05_JPRB, 0.17733277E-05_JPRB /)

RGHG2(:,73,11) = (/ &
  & 0.17737328E-05_JPRB, 0.17741932E-05_JPRB, 0.17742618E-05_JPRB, 0.17742091E-05_JPRB, 0.17740699E-05_JPRB, 0.17738748E-05_JPRB, &
  & 0.17736638E-05_JPRB, 0.17735201E-05_JPRB, 0.17735397E-05_JPRB, 0.17735733E-05_JPRB, 0.17736066E-05_JPRB, 0.17736089E-05_JPRB, &
  & 0.17735488E-05_JPRB, 0.17734018E-05_JPRB, 0.17731088E-05_JPRB, 0.17726568E-05_JPRB, 0.17720447E-05_JPRB, 0.17713303E-05_JPRB, &
  & 0.17706056E-05_JPRB, 0.17699689E-05_JPRB, 0.17694862E-05_JPRB, 0.17691791E-05_JPRB, 0.17690509E-05_JPRB, 0.17690777E-05_JPRB, &
  & 0.17692353E-05_JPRB, 0.17695038E-05_JPRB, 0.17698562E-05_JPRB, 0.17702877E-05_JPRB, 0.17707528E-05_JPRB, 0.17712118E-05_JPRB, &
  & 0.17716372E-05_JPRB, 0.17719512E-05_JPRB, 0.17721227E-05_JPRB, 0.17721616E-05_JPRB, 0.17721100E-05_JPRB, 0.17719881E-05_JPRB, &
  & 0.17718047E-05_JPRB, 0.17715773E-05_JPRB, 0.17713593E-05_JPRB, 0.17712084E-05_JPRB, 0.17712066E-05_JPRB, 0.17714057E-05_JPRB, &
  & 0.17718287E-05_JPRB, 0.17724324E-05_JPRB, 0.17731531E-05_JPRB, 0.17739056E-05_JPRB, 0.17746170E-05_JPRB, 0.17752379E-05_JPRB, &
  & 0.17757355E-05_JPRB, 0.17761001E-05_JPRB, 0.17763346E-05_JPRB, 0.17764745E-05_JPRB, 0.17765261E-05_JPRB, 0.17765286E-05_JPRB, &
  & 0.17764942E-05_JPRB, 0.17764199E-05_JPRB, 0.17763159E-05_JPRB, 0.17761881E-05_JPRB, 0.17760458E-05_JPRB, 0.17759071E-05_JPRB, &
  & 0.17757409E-05_JPRB, 0.17755150E-05_JPRB, 0.17751219E-05_JPRB, 0.17741381E-05_JPRB /)

RGHG2(:,74,11) = (/ &
  & 0.17746562E-05_JPRB, 0.17751283E-05_JPRB, 0.17752030E-05_JPRB, 0.17751602E-05_JPRB, 0.17750400E-05_JPRB, 0.17748702E-05_JPRB, &
  & 0.17746975E-05_JPRB, 0.17745742E-05_JPRB, 0.17745899E-05_JPRB, 0.17746219E-05_JPRB, 0.17746432E-05_JPRB, 0.17746409E-05_JPRB, &
  & 0.17745855E-05_JPRB, 0.17744538E-05_JPRB, 0.17741963E-05_JPRB, 0.17738030E-05_JPRB, 0.17732734E-05_JPRB, 0.17726554E-05_JPRB, &
  & 0.17720362E-05_JPRB, 0.17714883E-05_JPRB, 0.17710749E-05_JPRB, 0.17708053E-05_JPRB, 0.17706852E-05_JPRB, 0.17707000E-05_JPRB, &
  & 0.17708257E-05_JPRB, 0.17710436E-05_JPRB, 0.17713315E-05_JPRB, 0.17716895E-05_JPRB, 0.17720774E-05_JPRB, 0.17724643E-05_JPRB, &
  & 0.17728272E-05_JPRB, 0.17730937E-05_JPRB, 0.17732395E-05_JPRB, 0.17732735E-05_JPRB, 0.17732339E-05_JPRB, 0.17731364E-05_JPRB, &
  & 0.17729878E-05_JPRB, 0.17728016E-05_JPRB, 0.17726251E-05_JPRB, 0.17725049E-05_JPRB, 0.17725158E-05_JPRB, 0.17727007E-05_JPRB, &
  & 0.17730779E-05_JPRB, 0.17736061E-05_JPRB, 0.17742267E-05_JPRB, 0.17748793E-05_JPRB, 0.17754858E-05_JPRB, 0.17760193E-05_JPRB, &
  & 0.17764496E-05_JPRB, 0.17767632E-05_JPRB, 0.17769696E-05_JPRB, 0.17770988E-05_JPRB, 0.17771482E-05_JPRB, 0.17771561E-05_JPRB, &
  & 0.17771317E-05_JPRB, 0.17770768E-05_JPRB, 0.17769891E-05_JPRB, 0.17768751E-05_JPRB, 0.17767624E-05_JPRB, 0.17766283E-05_JPRB, &
  & 0.17764896E-05_JPRB, 0.17762898E-05_JPRB, 0.17759143E-05_JPRB, 0.17750001E-05_JPRB /)

RGHG2(:,75,11) = (/ &
  & 0.17755730E-05_JPRB, 0.17760449E-05_JPRB, 0.17761256E-05_JPRB, 0.17760933E-05_JPRB, 0.17759914E-05_JPRB, 0.17758521E-05_JPRB, &
  & 0.17757035E-05_JPRB, 0.17756051E-05_JPRB, 0.17756206E-05_JPRB, 0.17756440E-05_JPRB, 0.17756632E-05_JPRB, 0.17756591E-05_JPRB, &
  & 0.17756073E-05_JPRB, 0.17754941E-05_JPRB, 0.17752801E-05_JPRB, 0.17749420E-05_JPRB, 0.17744981E-05_JPRB, 0.17739816E-05_JPRB, &
  & 0.17734651E-05_JPRB, 0.17730122E-05_JPRB, 0.17726686E-05_JPRB, 0.17724400E-05_JPRB, 0.17723306E-05_JPRB, 0.17723354E-05_JPRB, &
  & 0.17724308E-05_JPRB, 0.17726022E-05_JPRB, 0.17728271E-05_JPRB, 0.17731138E-05_JPRB, 0.17734260E-05_JPRB, 0.17737411E-05_JPRB, &
  & 0.17740417E-05_JPRB, 0.17742603E-05_JPRB, 0.17743816E-05_JPRB, 0.17744104E-05_JPRB, 0.17743824E-05_JPRB, 0.17743091E-05_JPRB, &
  & 0.17741934E-05_JPRB, 0.17740471E-05_JPRB, 0.17739117E-05_JPRB, 0.17738207E-05_JPRB, 0.17738414E-05_JPRB, 0.17740065E-05_JPRB, &
  & 0.17743289E-05_JPRB, 0.17747715E-05_JPRB, 0.17752926E-05_JPRB, 0.17758305E-05_JPRB, 0.17763371E-05_JPRB, 0.17767800E-05_JPRB, &
  & 0.17771384E-05_JPRB, 0.17774041E-05_JPRB, 0.17775783E-05_JPRB, 0.17776938E-05_JPRB, 0.17777389E-05_JPRB, 0.17777485E-05_JPRB, &
  & 0.17777343E-05_JPRB, 0.17776906E-05_JPRB, 0.17776212E-05_JPRB, 0.17775324E-05_JPRB, 0.17774274E-05_JPRB, 0.17773259E-05_JPRB, &
  & 0.17772002E-05_JPRB, 0.17770308E-05_JPRB, 0.17767044E-05_JPRB, 0.17758433E-05_JPRB /)

RGHG2(:,76,11) = (/ &
  & 0.17764743E-05_JPRB, 0.17769364E-05_JPRB, 0.17770218E-05_JPRB, 0.17770011E-05_JPRB, 0.17769204E-05_JPRB, 0.17768084E-05_JPRB, &
  & 0.17766927E-05_JPRB, 0.17766066E-05_JPRB, 0.17766218E-05_JPRB, 0.17766441E-05_JPRB, 0.17766549E-05_JPRB, 0.17766497E-05_JPRB, &
  & 0.17766071E-05_JPRB, 0.17765132E-05_JPRB, 0.17763424E-05_JPRB, 0.17760724E-05_JPRB, 0.17757172E-05_JPRB, 0.17753049E-05_JPRB, &
  & 0.17748951E-05_JPRB, 0.17745344E-05_JPRB, 0.17742681E-05_JPRB, 0.17740817E-05_JPRB, 0.17739870E-05_JPRB, 0.17739843E-05_JPRB, &
  & 0.17740522E-05_JPRB, 0.17741803E-05_JPRB, 0.17743463E-05_JPRB, 0.17745633E-05_JPRB, 0.17747982E-05_JPRB, 0.17750436E-05_JPRB, &
  & 0.17752812E-05_JPRB, 0.17754523E-05_JPRB, 0.17755493E-05_JPRB, 0.17755725E-05_JPRB, 0.17755556E-05_JPRB, 0.17755051E-05_JPRB, &
  & 0.17754204E-05_JPRB, 0.17753142E-05_JPRB, 0.17752172E-05_JPRB, 0.17751524E-05_JPRB, 0.17751789E-05_JPRB, 0.17753160E-05_JPRB, &
  & 0.17755775E-05_JPRB, 0.17759305E-05_JPRB, 0.17763393E-05_JPRB, 0.17767718E-05_JPRB, 0.17771646E-05_JPRB, 0.17775187E-05_JPRB, &
  & 0.17778029E-05_JPRB, 0.17780154E-05_JPRB, 0.17781541E-05_JPRB, 0.17782559E-05_JPRB, 0.17782926E-05_JPRB, 0.17783005E-05_JPRB, &
  & 0.17782922E-05_JPRB, 0.17782638E-05_JPRB, 0.17782102E-05_JPRB, 0.17781374E-05_JPRB, 0.17780644E-05_JPRB, 0.17779705E-05_JPRB, &
  & 0.17778777E-05_JPRB, 0.17777381E-05_JPRB, 0.17774557E-05_JPRB, 0.17766913E-05_JPRB /)

RGHG2(:,77,11) = (/ &
  & 0.17773521E-05_JPRB, 0.17777876E-05_JPRB, 0.17778769E-05_JPRB, 0.17778682E-05_JPRB, 0.17778082E-05_JPRB, 0.17777302E-05_JPRB, &
  & 0.17776418E-05_JPRB, 0.17775767E-05_JPRB, 0.17775922E-05_JPRB, 0.17776050E-05_JPRB, 0.17776081E-05_JPRB, 0.17776014E-05_JPRB, &
  & 0.17775652E-05_JPRB, 0.17774953E-05_JPRB, 0.17773767E-05_JPRB, 0.17771731E-05_JPRB, 0.17769172E-05_JPRB, 0.17766114E-05_JPRB, &
  & 0.17763110E-05_JPRB, 0.17760473E-05_JPRB, 0.17758589E-05_JPRB, 0.17757205E-05_JPRB, 0.17756420E-05_JPRB, 0.17756358E-05_JPRB, &
  & 0.17756802E-05_JPRB, 0.17757684E-05_JPRB, 0.17758806E-05_JPRB, 0.17760319E-05_JPRB, 0.17761947E-05_JPRB, 0.17763717E-05_JPRB, &
  & 0.17765484E-05_JPRB, 0.17766716E-05_JPRB, 0.17767450E-05_JPRB, 0.17767624E-05_JPRB, 0.17767543E-05_JPRB, 0.17767222E-05_JPRB, &
  & 0.17766641E-05_JPRB, 0.17765924E-05_JPRB, 0.17765300E-05_JPRB, 0.17764875E-05_JPRB, 0.17765126E-05_JPRB, 0.17766160E-05_JPRB, &
  & 0.17768092E-05_JPRB, 0.17770659E-05_JPRB, 0.17773655E-05_JPRB, 0.17776794E-05_JPRB, 0.17779664E-05_JPRB, 0.17782247E-05_JPRB, &
  & 0.17784339E-05_JPRB, 0.17785912E-05_JPRB, 0.17786920E-05_JPRB, 0.17787763E-05_JPRB, 0.17788020E-05_JPRB, 0.17788052E-05_JPRB, &
  & 0.17788022E-05_JPRB, 0.17787845E-05_JPRB, 0.17787474E-05_JPRB, 0.17786998E-05_JPRB, 0.17786413E-05_JPRB, 0.17785769E-05_JPRB, &
  & 0.17785019E-05_JPRB, 0.17784009E-05_JPRB, 0.17781722E-05_JPRB, 0.17775192E-05_JPRB /)

RGHG2(:,78,11) = (/ &
  & 0.17781963E-05_JPRB, 0.17785596E-05_JPRB, 0.17786322E-05_JPRB, 0.17786324E-05_JPRB, 0.17785922E-05_JPRB, 0.17785464E-05_JPRB, &
  & 0.17784967E-05_JPRB, 0.17784528E-05_JPRB, 0.17784640E-05_JPRB, 0.17784671E-05_JPRB, 0.17784580E-05_JPRB, 0.17784481E-05_JPRB, &
  & 0.17784214E-05_JPRB, 0.17783763E-05_JPRB, 0.17783095E-05_JPRB, 0.17781772E-05_JPRB, 0.17780158E-05_JPRB, 0.17778171E-05_JPRB, &
  & 0.17776249E-05_JPRB, 0.17774571E-05_JPRB, 0.17773498E-05_JPRB, 0.17772611E-05_JPRB, 0.17772030E-05_JPRB, 0.17771974E-05_JPRB, &
  & 0.17772247E-05_JPRB, 0.17772807E-05_JPRB, 0.17773486E-05_JPRB, 0.17774433E-05_JPRB, 0.17775398E-05_JPRB, 0.17776549E-05_JPRB, &
  & 0.17777745E-05_JPRB, 0.17778528E-05_JPRB, 0.17779031E-05_JPRB, 0.17779133E-05_JPRB, 0.17779104E-05_JPRB, 0.17778920E-05_JPRB, &
  & 0.17778545E-05_JPRB, 0.17778108E-05_JPRB, 0.17777736E-05_JPRB, 0.17777445E-05_JPRB, 0.17777593E-05_JPRB, 0.17778232E-05_JPRB, &
  & 0.17779441E-05_JPRB, 0.17781072E-05_JPRB, 0.17782968E-05_JPRB, 0.17785053E-05_JPRB, 0.17786850E-05_JPRB, 0.17788568E-05_JPRB, &
  & 0.17789928E-05_JPRB, 0.17790971E-05_JPRB, 0.17791596E-05_JPRB, 0.17792262E-05_JPRB, 0.17792383E-05_JPRB, 0.17792333E-05_JPRB, &
  & 0.17792316E-05_JPRB, 0.17792241E-05_JPRB, 0.17792008E-05_JPRB, 0.17791727E-05_JPRB, 0.17791381E-05_JPRB, 0.17790877E-05_JPRB, &
  & 0.17790392E-05_JPRB, 0.17789700E-05_JPRB, 0.17788175E-05_JPRB, 0.17783295E-05_JPRB /)

RGHG2(:,79,11) = (/ &
  & 0.17787359E-05_JPRB, 0.17789901E-05_JPRB, 0.17790348E-05_JPRB, 0.17790289E-05_JPRB, 0.17789964E-05_JPRB, 0.17789689E-05_JPRB, &
  & 0.17789376E-05_JPRB, 0.17789057E-05_JPRB, 0.17789141E-05_JPRB, 0.17789117E-05_JPRB, 0.17788960E-05_JPRB, 0.17788868E-05_JPRB, &
  & 0.17788659E-05_JPRB, 0.17788349E-05_JPRB, 0.17787993E-05_JPRB, 0.17787015E-05_JPRB, 0.17785929E-05_JPRB, 0.17784505E-05_JPRB, &
  & 0.17783177E-05_JPRB, 0.17782041E-05_JPRB, 0.17781458E-05_JPRB, 0.17780859E-05_JPRB, 0.17780393E-05_JPRB, 0.17780355E-05_JPRB, &
  & 0.17780558E-05_JPRB, 0.17780962E-05_JPRB, 0.17781418E-05_JPRB, 0.17782061E-05_JPRB, 0.17782656E-05_JPRB, 0.17783481E-05_JPRB, &
  & 0.17784388E-05_JPRB, 0.17784923E-05_JPRB, 0.17785310E-05_JPRB, 0.17785368E-05_JPRB, 0.17785358E-05_JPRB, 0.17785233E-05_JPRB, &
  & 0.17784949E-05_JPRB, 0.17784652E-05_JPRB, 0.17784408E-05_JPRB, 0.17784159E-05_JPRB, 0.17784240E-05_JPRB, 0.17784633E-05_JPRB, &
  & 0.17785457E-05_JPRB, 0.17786576E-05_JPRB, 0.17787896E-05_JPRB, 0.17789408E-05_JPRB, 0.17790645E-05_JPRB, 0.17791901E-05_JPRB, &
  & 0.17792876E-05_JPRB, 0.17793643E-05_JPRB, 0.17794052E-05_JPRB, 0.17794637E-05_JPRB, 0.17794675E-05_JPRB, 0.17794555E-05_JPRB, &
  & 0.17794544E-05_JPRB, 0.17794524E-05_JPRB, 0.17794359E-05_JPRB, 0.17794194E-05_JPRB, 0.17793936E-05_JPRB, 0.17793535E-05_JPRB, &
  & 0.17793147E-05_JPRB, 0.17792726E-05_JPRB, 0.17791759E-05_JPRB, 0.17788515E-05_JPRB /)

RGHG2(:,80,11) = (/ &
  & 0.17790901E-05_JPRB, 0.17791971E-05_JPRB, 0.17792109E-05_JPRB, 0.17792006E-05_JPRB, 0.17791692E-05_JPRB, 0.17791496E-05_JPRB, &
  & 0.17791270E-05_JPRB, 0.17791009E-05_JPRB, 0.17791085E-05_JPRB, 0.17791050E-05_JPRB, 0.17790867E-05_JPRB, 0.17790790E-05_JPRB, &
  & 0.17790617E-05_JPRB, 0.17790378E-05_JPRB, 0.17790170E-05_JPRB, 0.17789338E-05_JPRB, 0.17788483E-05_JPRB, 0.17787303E-05_JPRB, &
  & 0.17786247E-05_JPRB, 0.17785354E-05_JPRB, 0.17785026E-05_JPRB, 0.17784560E-05_JPRB, 0.17784149E-05_JPRB, 0.17784130E-05_JPRB, &
  & 0.17784312E-05_JPRB, 0.17784660E-05_JPRB, 0.17785017E-05_JPRB, 0.17785520E-05_JPRB, 0.17785947E-05_JPRB, 0.17786633E-05_JPRB, &
  & 0.17787416E-05_JPRB, 0.17787839E-05_JPRB, 0.17788170E-05_JPRB, 0.17788205E-05_JPRB, 0.17788202E-05_JPRB, 0.17788099E-05_JPRB, &
  & 0.17787841E-05_JPRB, 0.17787604E-05_JPRB, 0.17787411E-05_JPRB, 0.17787173E-05_JPRB, 0.17787207E-05_JPRB, 0.17787492E-05_JPRB, &
  & 0.17788137E-05_JPRB, 0.17789023E-05_JPRB, 0.17790085E-05_JPRB, 0.17791347E-05_JPRB, 0.17792321E-05_JPRB, 0.17793370E-05_JPRB, &
  & 0.17794174E-05_JPRB, 0.17794821E-05_JPRB, 0.17795127E-05_JPRB, 0.17795687E-05_JPRB, 0.17795680E-05_JPRB, 0.17795514E-05_JPRB, &
  & 0.17795503E-05_JPRB, 0.17795511E-05_JPRB, 0.17795370E-05_JPRB, 0.17795257E-05_JPRB, 0.17795045E-05_JPRB, 0.17794662E-05_JPRB, &
  & 0.17794339E-05_JPRB, 0.17794039E-05_JPRB, 0.17793490E-05_JPRB, 0.17791970E-05_JPRB /)

RGHG2(:,81,11) = (/ &
  & 0.17793298E-05_JPRB, 0.17792840E-05_JPRB, 0.17792856E-05_JPRB, 0.17792735E-05_JPRB, 0.17792429E-05_JPRB, 0.17792264E-05_JPRB, &
  & 0.17792087E-05_JPRB, 0.17791842E-05_JPRB, 0.17791914E-05_JPRB, 0.17791878E-05_JPRB, 0.17791697E-05_JPRB, 0.17791623E-05_JPRB, &
  & 0.17791477E-05_JPRB, 0.17791266E-05_JPRB, 0.17791127E-05_JPRB, 0.17790359E-05_JPRB, 0.17789604E-05_JPRB, 0.17788525E-05_JPRB, &
  & 0.17787572E-05_JPRB, 0.17786799E-05_JPRB, 0.17786585E-05_JPRB, 0.17786189E-05_JPRB, 0.17785799E-05_JPRB, 0.17785790E-05_JPRB, &
  & 0.17785964E-05_JPRB, 0.17786286E-05_JPRB, 0.17786599E-05_JPRB, 0.17787049E-05_JPRB, 0.17787397E-05_JPRB, 0.17788018E-05_JPRB, &
  & 0.17788751E-05_JPRB, 0.17789123E-05_JPRB, 0.17789441E-05_JPRB, 0.17789464E-05_JPRB, 0.17789459E-05_JPRB, 0.17789356E-05_JPRB, &
  & 0.17789113E-05_JPRB, 0.17788898E-05_JPRB, 0.17788730E-05_JPRB, 0.17788495E-05_JPRB, 0.17788510E-05_JPRB, 0.17788739E-05_JPRB, &
  & 0.17789305E-05_JPRB, 0.17790092E-05_JPRB, 0.17791036E-05_JPRB, 0.17792200E-05_JPRB, 0.17793044E-05_JPRB, 0.17794009E-05_JPRB, &
  & 0.17794735E-05_JPRB, 0.17795330E-05_JPRB, 0.17795586E-05_JPRB, 0.17796150E-05_JPRB, 0.17796119E-05_JPRB, 0.17795920E-05_JPRB, &
  & 0.17795912E-05_JPRB, 0.17795934E-05_JPRB, 0.17795802E-05_JPRB, 0.17795714E-05_JPRB, 0.17795519E-05_JPRB, 0.17795144E-05_JPRB, &
  & 0.17794837E-05_JPRB, 0.17794591E-05_JPRB, 0.17794218E-05_JPRB, 0.17794353E-05_JPRB /)

RGHG2(:,82,11) = (/ &
  & 0.17793491E-05_JPRB, 0.17793136E-05_JPRB, 0.17793186E-05_JPRB, 0.17793081E-05_JPRB, 0.17792784E-05_JPRB, 0.17792635E-05_JPRB, &
  & 0.17792474E-05_JPRB, 0.17792249E-05_JPRB, 0.17792321E-05_JPRB, 0.17792291E-05_JPRB, 0.17792092E-05_JPRB, 0.17792036E-05_JPRB, &
  & 0.17791896E-05_JPRB, 0.17791704E-05_JPRB, 0.17791606E-05_JPRB, 0.17790858E-05_JPRB, 0.17790156E-05_JPRB, 0.17789113E-05_JPRB, &
  & 0.17788228E-05_JPRB, 0.17787492E-05_JPRB, 0.17787351E-05_JPRB, 0.17786977E-05_JPRB, 0.17786601E-05_JPRB, 0.17786599E-05_JPRB, &
  & 0.17786771E-05_JPRB, 0.17787081E-05_JPRB, 0.17787376E-05_JPRB, 0.17787794E-05_JPRB, 0.17788100E-05_JPRB, 0.17788693E-05_JPRB, &
  & 0.17789405E-05_JPRB, 0.17789753E-05_JPRB, 0.17790064E-05_JPRB, 0.17790078E-05_JPRB, 0.17790071E-05_JPRB, 0.17789969E-05_JPRB, &
  & 0.17789731E-05_JPRB, 0.17789530E-05_JPRB, 0.17789376E-05_JPRB, 0.17789149E-05_JPRB, 0.17789147E-05_JPRB, 0.17789348E-05_JPRB, &
  & 0.17789874E-05_JPRB, 0.17790612E-05_JPRB, 0.17791508E-05_JPRB, 0.17792614E-05_JPRB, 0.17793401E-05_JPRB, 0.17794317E-05_JPRB, &
  & 0.17795005E-05_JPRB, 0.17795576E-05_JPRB, 0.17795809E-05_JPRB, 0.17796380E-05_JPRB, 0.17796334E-05_JPRB, 0.17796118E-05_JPRB, &
  & 0.17796108E-05_JPRB, 0.17796139E-05_JPRB, 0.17796013E-05_JPRB, 0.17795941E-05_JPRB, 0.17795752E-05_JPRB, 0.17795377E-05_JPRB, &
  & 0.17795074E-05_JPRB, 0.17794832E-05_JPRB, 0.17794458E-05_JPRB, 0.17794541E-05_JPRB /)

RGHG2(:,83,11) = (/ &
  & 0.17793622E-05_JPRB, 0.17793303E-05_JPRB, 0.17793376E-05_JPRB, 0.17793277E-05_JPRB, 0.17792979E-05_JPRB, 0.17792842E-05_JPRB, &
  & 0.17792692E-05_JPRB, 0.17792477E-05_JPRB, 0.17792540E-05_JPRB, 0.17792502E-05_JPRB, 0.17792324E-05_JPRB, 0.17792260E-05_JPRB, &
  & 0.17792132E-05_JPRB, 0.17791947E-05_JPRB, 0.17791873E-05_JPRB, 0.17791141E-05_JPRB, 0.17790461E-05_JPRB, 0.17789449E-05_JPRB, &
  & 0.17788577E-05_JPRB, 0.17787886E-05_JPRB, 0.17787779E-05_JPRB, 0.17787429E-05_JPRB, 0.17787045E-05_JPRB, 0.17787047E-05_JPRB, &
  & 0.17787221E-05_JPRB, 0.17787524E-05_JPRB, 0.17787806E-05_JPRB, 0.17788211E-05_JPRB, 0.17788489E-05_JPRB, 0.17789065E-05_JPRB, &
  & 0.17789772E-05_JPRB, 0.17790105E-05_JPRB, 0.17790414E-05_JPRB, 0.17790422E-05_JPRB, 0.17790412E-05_JPRB, 0.17790306E-05_JPRB, &
  & 0.17790076E-05_JPRB, 0.17789880E-05_JPRB, 0.17789735E-05_JPRB, 0.17789517E-05_JPRB, 0.17789503E-05_JPRB, 0.17789682E-05_JPRB, &
  & 0.17790190E-05_JPRB, 0.17790898E-05_JPRB, 0.17791760E-05_JPRB, 0.17792855E-05_JPRB, 0.17793594E-05_JPRB, 0.17794492E-05_JPRB, &
  & 0.17795155E-05_JPRB, 0.17795716E-05_JPRB, 0.17795930E-05_JPRB, 0.17796510E-05_JPRB, 0.17796455E-05_JPRB, 0.17796226E-05_JPRB, &
  & 0.17796216E-05_JPRB, 0.17796252E-05_JPRB, 0.17796134E-05_JPRB, 0.17796068E-05_JPRB, 0.17795883E-05_JPRB, 0.17795506E-05_JPRB, &
  & 0.17795204E-05_JPRB, 0.17794969E-05_JPRB, 0.17794597E-05_JPRB, 0.17794673E-05_JPRB /)

RGHG2(:,84,11) = (/ &
  & 0.17793708E-05_JPRB, 0.17793413E-05_JPRB, 0.17793493E-05_JPRB, 0.17793399E-05_JPRB, 0.17793103E-05_JPRB, 0.17792968E-05_JPRB, &
  & 0.17792825E-05_JPRB, 0.17792623E-05_JPRB, 0.17792674E-05_JPRB, 0.17792635E-05_JPRB, 0.17792458E-05_JPRB, 0.17792398E-05_JPRB, &
  & 0.17792273E-05_JPRB, 0.17792100E-05_JPRB, 0.17792031E-05_JPRB, 0.17791318E-05_JPRB, 0.17790661E-05_JPRB, 0.17789653E-05_JPRB, &
  & 0.17788813E-05_JPRB, 0.17788118E-05_JPRB, 0.17788049E-05_JPRB, 0.17787698E-05_JPRB, 0.17787318E-05_JPRB, 0.17787320E-05_JPRB, &
  & 0.17787493E-05_JPRB, 0.17787802E-05_JPRB, 0.17788071E-05_JPRB, 0.17788465E-05_JPRB, 0.17788725E-05_JPRB, 0.17789291E-05_JPRB, &
  & 0.17789994E-05_JPRB, 0.17790318E-05_JPRB, 0.17790628E-05_JPRB, 0.17790634E-05_JPRB, 0.17790621E-05_JPRB, 0.17790516E-05_JPRB, &
  & 0.17790287E-05_JPRB, 0.17790098E-05_JPRB, 0.17789956E-05_JPRB, 0.17789748E-05_JPRB, 0.17789727E-05_JPRB, 0.17789898E-05_JPRB, &
  & 0.17790372E-05_JPRB, 0.17791078E-05_JPRB, 0.17791918E-05_JPRB, 0.17793002E-05_JPRB, 0.17793719E-05_JPRB, 0.17794597E-05_JPRB, &
  & 0.17795248E-05_JPRB, 0.17795800E-05_JPRB, 0.17796009E-05_JPRB, 0.17796597E-05_JPRB, 0.17796531E-05_JPRB, 0.17796294E-05_JPRB, &
  & 0.17796282E-05_JPRB, 0.17796319E-05_JPRB, 0.17796209E-05_JPRB, 0.17796150E-05_JPRB, 0.17795968E-05_JPRB, 0.17795587E-05_JPRB, &
  & 0.17795285E-05_JPRB, 0.17795052E-05_JPRB, 0.17794688E-05_JPRB, 0.17794766E-05_JPRB /)

RGHG2(:,85,11) = (/ &
  & 0.17793766E-05_JPRB, 0.17793484E-05_JPRB, 0.17793571E-05_JPRB, 0.17793482E-05_JPRB, 0.17793179E-05_JPRB, 0.17793043E-05_JPRB, &
  & 0.17792903E-05_JPRB, 0.17792722E-05_JPRB, 0.17792745E-05_JPRB, 0.17792692E-05_JPRB, 0.17792555E-05_JPRB, 0.17792478E-05_JPRB, &
  & 0.17792366E-05_JPRB, 0.17792203E-05_JPRB, 0.17792111E-05_JPRB, 0.17791444E-05_JPRB, 0.17790791E-05_JPRB, 0.17789799E-05_JPRB, &
  & 0.17788957E-05_JPRB, 0.17788279E-05_JPRB, 0.17788226E-05_JPRB, 0.17787885E-05_JPRB, 0.17787484E-05_JPRB, 0.17787488E-05_JPRB, &
  & 0.17787669E-05_JPRB, 0.17787978E-05_JPRB, 0.17788243E-05_JPRB, 0.17788628E-05_JPRB, 0.17788875E-05_JPRB, 0.17789437E-05_JPRB, &
  & 0.17790138E-05_JPRB, 0.17790459E-05_JPRB, 0.17790767E-05_JPRB, 0.17790769E-05_JPRB, 0.17790753E-05_JPRB, 0.17790645E-05_JPRB, &
  & 0.17790423E-05_JPRB, 0.17790242E-05_JPRB, 0.17790101E-05_JPRB, 0.17789897E-05_JPRB, 0.17789866E-05_JPRB, 0.17790014E-05_JPRB, &
  & 0.17790508E-05_JPRB, 0.17791178E-05_JPRB, 0.17792030E-05_JPRB, 0.17793103E-05_JPRB, 0.17793795E-05_JPRB, 0.17794664E-05_JPRB, &
  & 0.17795303E-05_JPRB, 0.17795854E-05_JPRB, 0.17796057E-05_JPRB, 0.17796655E-05_JPRB, 0.17796583E-05_JPRB, 0.17796340E-05_JPRB, &
  & 0.17796326E-05_JPRB, 0.17796361E-05_JPRB, 0.17796256E-05_JPRB, 0.17796201E-05_JPRB, 0.17796021E-05_JPRB, 0.17795638E-05_JPRB, &
  & 0.17795337E-05_JPRB, 0.17795106E-05_JPRB, 0.17794746E-05_JPRB, 0.17794832E-05_JPRB /)

RGHG2(:,86,11) = (/ &
  & 0.17793798E-05_JPRB, 0.17793527E-05_JPRB, 0.17793625E-05_JPRB, 0.17793535E-05_JPRB, 0.17793217E-05_JPRB, 0.17793086E-05_JPRB, &
  & 0.17792928E-05_JPRB, 0.17792790E-05_JPRB, 0.17792781E-05_JPRB, 0.17792722E-05_JPRB, 0.17792604E-05_JPRB, 0.17792524E-05_JPRB, &
  & 0.17792413E-05_JPRB, 0.17792266E-05_JPRB, 0.17792125E-05_JPRB, 0.17791533E-05_JPRB, 0.17790879E-05_JPRB, 0.17789920E-05_JPRB, &
  & 0.17789073E-05_JPRB, 0.17788386E-05_JPRB, 0.17788345E-05_JPRB, 0.17788005E-05_JPRB, 0.17787585E-05_JPRB, 0.17787590E-05_JPRB, &
  & 0.17787772E-05_JPRB, 0.17788094E-05_JPRB, 0.17788351E-05_JPRB, 0.17788741E-05_JPRB, 0.17788967E-05_JPRB, 0.17789531E-05_JPRB, &
  & 0.17790234E-05_JPRB, 0.17790552E-05_JPRB, 0.17790858E-05_JPRB, 0.17790853E-05_JPRB, 0.17790837E-05_JPRB, 0.17790730E-05_JPRB, &
  & 0.17790510E-05_JPRB, 0.17790329E-05_JPRB, 0.17790195E-05_JPRB, 0.17789980E-05_JPRB, 0.17789944E-05_JPRB, 0.17790097E-05_JPRB, &
  & 0.17790569E-05_JPRB, 0.17791270E-05_JPRB, 0.17792094E-05_JPRB, 0.17793171E-05_JPRB, 0.17793845E-05_JPRB, 0.17794708E-05_JPRB, &
  & 0.17795335E-05_JPRB, 0.17795892E-05_JPRB, 0.17796089E-05_JPRB, 0.17796697E-05_JPRB, 0.17796618E-05_JPRB, 0.17796366E-05_JPRB, &
  & 0.17796353E-05_JPRB, 0.17796391E-05_JPRB, 0.17796287E-05_JPRB, 0.17796234E-05_JPRB, 0.17796056E-05_JPRB, 0.17795674E-05_JPRB, &
  & 0.17795373E-05_JPRB, 0.17795144E-05_JPRB, 0.17794781E-05_JPRB, 0.17794877E-05_JPRB /)

RGHG2(:,87,11) = (/ &
  & 0.17793818E-05_JPRB, 0.17793556E-05_JPRB, 0.17793654E-05_JPRB, 0.17793558E-05_JPRB, 0.17793249E-05_JPRB, 0.17793093E-05_JPRB, &
  & 0.17792968E-05_JPRB, 0.17792818E-05_JPRB, 0.17792795E-05_JPRB, 0.17792729E-05_JPRB, 0.17792631E-05_JPRB, 0.17792549E-05_JPRB, &
  & 0.17792446E-05_JPRB, 0.17792297E-05_JPRB, 0.17792134E-05_JPRB, 0.17791581E-05_JPRB, 0.17790945E-05_JPRB, 0.17789994E-05_JPRB, &
  & 0.17789168E-05_JPRB, 0.17788460E-05_JPRB, 0.17788420E-05_JPRB, 0.17788083E-05_JPRB, 0.17787644E-05_JPRB, 0.17787647E-05_JPRB, &
  & 0.17787839E-05_JPRB, 0.17788168E-05_JPRB, 0.17788417E-05_JPRB, 0.17788807E-05_JPRB, 0.17789022E-05_JPRB, 0.17789584E-05_JPRB, &
  & 0.17790298E-05_JPRB, 0.17790605E-05_JPRB, 0.17790917E-05_JPRB, 0.17790911E-05_JPRB, 0.17790892E-05_JPRB, 0.17790785E-05_JPRB, &
  & 0.17790564E-05_JPRB, 0.17790381E-05_JPRB, 0.17790254E-05_JPRB, 0.17790034E-05_JPRB, 0.17789986E-05_JPRB, 0.17790128E-05_JPRB, &
  & 0.17790630E-05_JPRB, 0.17791311E-05_JPRB, 0.17792145E-05_JPRB, 0.17793213E-05_JPRB, 0.17793874E-05_JPRB, 0.17794735E-05_JPRB, &
  & 0.17795356E-05_JPRB, 0.17795916E-05_JPRB, 0.17796106E-05_JPRB, 0.17796723E-05_JPRB, 0.17796639E-05_JPRB, 0.17796378E-05_JPRB, &
  & 0.17796370E-05_JPRB, 0.17796403E-05_JPRB, 0.17796303E-05_JPRB, 0.17796252E-05_JPRB, 0.17796075E-05_JPRB, 0.17795696E-05_JPRB, &
  & 0.17795395E-05_JPRB, 0.17795164E-05_JPRB, 0.17794798E-05_JPRB, 0.17794905E-05_JPRB /)

RGHG2(:,88,11) = (/ &
  & 0.17793824E-05_JPRB, 0.17793574E-05_JPRB, 0.17793675E-05_JPRB, 0.17793584E-05_JPRB, 0.17793250E-05_JPRB, 0.17793125E-05_JPRB, &
  & 0.17792955E-05_JPRB, 0.17792844E-05_JPRB, 0.17792809E-05_JPRB, 0.17792743E-05_JPRB, 0.17792643E-05_JPRB, 0.17792561E-05_JPRB, &
  & 0.17792455E-05_JPRB, 0.17792311E-05_JPRB, 0.17792138E-05_JPRB, 0.17791615E-05_JPRB, 0.17790973E-05_JPRB, 0.17790059E-05_JPRB, &
  & 0.17789198E-05_JPRB, 0.17788514E-05_JPRB, 0.17788465E-05_JPRB, 0.17788136E-05_JPRB, 0.17787673E-05_JPRB, 0.17787679E-05_JPRB, &
  & 0.17787872E-05_JPRB, 0.17788216E-05_JPRB, 0.17788450E-05_JPRB, 0.17788852E-05_JPRB, 0.17789049E-05_JPRB, 0.17789619E-05_JPRB, &
  & 0.17790338E-05_JPRB, 0.17790644E-05_JPRB, 0.17790951E-05_JPRB, 0.17790943E-05_JPRB, 0.17790926E-05_JPRB, 0.17790821E-05_JPRB, &
  & 0.17790596E-05_JPRB, 0.17790416E-05_JPRB, 0.17790292E-05_JPRB, 0.17790057E-05_JPRB, 0.17790009E-05_JPRB, 0.17790151E-05_JPRB, &
  & 0.17790655E-05_JPRB, 0.17791347E-05_JPRB, 0.17792167E-05_JPRB, 0.17793243E-05_JPRB, 0.17793889E-05_JPRB, 0.17794749E-05_JPRB, &
  & 0.17795368E-05_JPRB, 0.17795928E-05_JPRB, 0.17796117E-05_JPRB, 0.17796746E-05_JPRB, 0.17796652E-05_JPRB, 0.17796386E-05_JPRB, &
  & 0.17796378E-05_JPRB, 0.17796414E-05_JPRB, 0.17796316E-05_JPRB, 0.17796267E-05_JPRB, 0.17796090E-05_JPRB, 0.17795705E-05_JPRB, &
  & 0.17795406E-05_JPRB, 0.17795178E-05_JPRB, 0.17794814E-05_JPRB, 0.17794924E-05_JPRB /)

RGHG2(:,89,11) = (/ &
  & 0.17793824E-05_JPRB, 0.17793586E-05_JPRB, 0.17793691E-05_JPRB, 0.17793594E-05_JPRB, 0.17793276E-05_JPRB, 0.17793121E-05_JPRB, &
  & 0.17793000E-05_JPRB, 0.17792850E-05_JPRB, 0.17792828E-05_JPRB, 0.17792759E-05_JPRB, 0.17792657E-05_JPRB, 0.17792576E-05_JPRB, &
  & 0.17792474E-05_JPRB, 0.17792327E-05_JPRB, 0.17792174E-05_JPRB, 0.17791623E-05_JPRB, 0.17790993E-05_JPRB, 0.17790040E-05_JPRB, &
  & 0.17789216E-05_JPRB, 0.17788502E-05_JPRB, 0.17788490E-05_JPRB, 0.17788161E-05_JPRB, 0.17787688E-05_JPRB, 0.17787695E-05_JPRB, &
  & 0.17787889E-05_JPRB, 0.17788243E-05_JPRB, 0.17788471E-05_JPRB, 0.17788874E-05_JPRB, 0.17789062E-05_JPRB, 0.17789631E-05_JPRB, &
  & 0.17790361E-05_JPRB, 0.17790662E-05_JPRB, 0.17790981E-05_JPRB, 0.17790960E-05_JPRB, 0.17790944E-05_JPRB, 0.17790840E-05_JPRB, &
  & 0.17790613E-05_JPRB, 0.17790428E-05_JPRB, 0.17790312E-05_JPRB, 0.17790069E-05_JPRB, 0.17790018E-05_JPRB, 0.17790160E-05_JPRB, &
  & 0.17790678E-05_JPRB, 0.17791361E-05_JPRB, 0.17792181E-05_JPRB, 0.17793261E-05_JPRB, 0.17793897E-05_JPRB, 0.17794758E-05_JPRB, &
  & 0.17795371E-05_JPRB, 0.17795937E-05_JPRB, 0.17796120E-05_JPRB, 0.17796760E-05_JPRB, 0.17796661E-05_JPRB, 0.17796390E-05_JPRB, &
  & 0.17796385E-05_JPRB, 0.17796419E-05_JPRB, 0.17796323E-05_JPRB, 0.17796275E-05_JPRB, 0.17796099E-05_JPRB, 0.17795714E-05_JPRB, &
  & 0.17795415E-05_JPRB, 0.17795187E-05_JPRB, 0.17794814E-05_JPRB, 0.17794935E-05_JPRB /)

RGHG2(:,90,11) = (/ &
  & 0.17793819E-05_JPRB, 0.17793599E-05_JPRB, 0.17793703E-05_JPRB, 0.17793619E-05_JPRB, 0.17793274E-05_JPRB, 0.17793162E-05_JPRB, &
  & 0.17793002E-05_JPRB, 0.17792863E-05_JPRB, 0.17792860E-05_JPRB, 0.17792795E-05_JPRB, 0.17792674E-05_JPRB, 0.17792595E-05_JPRB, &
  & 0.17792493E-05_JPRB, 0.17792347E-05_JPRB, 0.17792233E-05_JPRB, 0.17791631E-05_JPRB, 0.17790994E-05_JPRB, 0.17790018E-05_JPRB, &
  & 0.17789170E-05_JPRB, 0.17788478E-05_JPRB, 0.17788503E-05_JPRB, 0.17788179E-05_JPRB, 0.17787684E-05_JPRB, 0.17787698E-05_JPRB, &
  & 0.17787896E-05_JPRB, 0.17788259E-05_JPRB, 0.17788476E-05_JPRB, 0.17788889E-05_JPRB, 0.17789055E-05_JPRB, 0.17789633E-05_JPRB, &
  & 0.17790384E-05_JPRB, 0.17790671E-05_JPRB, 0.17791002E-05_JPRB, 0.17790970E-05_JPRB, 0.17790954E-05_JPRB, 0.17790856E-05_JPRB, &
  & 0.17790622E-05_JPRB, 0.17790429E-05_JPRB, 0.17790322E-05_JPRB, 0.17790070E-05_JPRB, 0.17790016E-05_JPRB, 0.17790155E-05_JPRB, &
  & 0.17790677E-05_JPRB, 0.17791366E-05_JPRB, 0.17792180E-05_JPRB, 0.17793279E-05_JPRB, 0.17793897E-05_JPRB, 0.17794771E-05_JPRB, &
  & 0.17795380E-05_JPRB, 0.17795953E-05_JPRB, 0.17796112E-05_JPRB, 0.17796790E-05_JPRB, 0.17796667E-05_JPRB, 0.17796384E-05_JPRB, &
  & 0.17796386E-05_JPRB, 0.17796422E-05_JPRB, 0.17796327E-05_JPRB, 0.17796283E-05_JPRB, 0.17796107E-05_JPRB, 0.17795711E-05_JPRB, &
  & 0.17795413E-05_JPRB, 0.17795190E-05_JPRB, 0.17794811E-05_JPRB, 0.17794944E-05_JPRB /)

RGHG2(:,91,11) = (/ &
  & 0.17793806E-05_JPRB, 0.17793598E-05_JPRB, 0.17793718E-05_JPRB, 0.17793644E-05_JPRB, 0.17793271E-05_JPRB, 0.17793182E-05_JPRB, &
  & 0.17793055E-05_JPRB, 0.17792804E-05_JPRB, 0.17792937E-05_JPRB, 0.17792884E-05_JPRB, 0.17792645E-05_JPRB, 0.17792612E-05_JPRB, &
  & 0.17792515E-05_JPRB, 0.17792308E-05_JPRB, 0.17792403E-05_JPRB, 0.17791588E-05_JPRB, 0.17791026E-05_JPRB, 0.17789951E-05_JPRB, &
  & 0.17789135E-05_JPRB, 0.17788404E-05_JPRB, 0.17788531E-05_JPRB, 0.17788193E-05_JPRB, 0.17787654E-05_JPRB, 0.17787685E-05_JPRB, &
  & 0.17787886E-05_JPRB, 0.17788269E-05_JPRB, 0.17788467E-05_JPRB, 0.17788908E-05_JPRB, 0.17789027E-05_JPRB, 0.17789620E-05_JPRB, &
  & 0.17790417E-05_JPRB, 0.17790669E-05_JPRB, 0.17791036E-05_JPRB, 0.17790973E-05_JPRB, 0.17790967E-05_JPRB, 0.17790875E-05_JPRB, &
  & 0.17790618E-05_JPRB, 0.17790423E-05_JPRB, 0.17790334E-05_JPRB, 0.17790060E-05_JPRB, 0.17790003E-05_JPRB, 0.17790129E-05_JPRB, &
  & 0.17790669E-05_JPRB, 0.17791357E-05_JPRB, 0.17792166E-05_JPRB, 0.17793316E-05_JPRB, 0.17793885E-05_JPRB, 0.17794789E-05_JPRB, &
  & 0.17795387E-05_JPRB, 0.17795983E-05_JPRB, 0.17796082E-05_JPRB, 0.17796846E-05_JPRB, 0.17796682E-05_JPRB, 0.17796367E-05_JPRB, &
  & 0.17796389E-05_JPRB, 0.17796435E-05_JPRB, 0.17796324E-05_JPRB, 0.17796292E-05_JPRB, 0.17796119E-05_JPRB, 0.17795701E-05_JPRB, &
  & 0.17795404E-05_JPRB, 0.17795187E-05_JPRB, 0.17794786E-05_JPRB, 0.17794945E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART22',1,ZHOOK_HANDLE)
END SUBROUTINE PART22






SUBROUTINE PART23
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART23',0,ZHOOK_HANDLE)



!-- Month= 12 ------------

RGHG2(:, 1,12) = (/ &
  & 0.29024182E-07_JPRB, 0.28766680E-07_JPRB, 0.26857894E-07_JPRB, 0.24832504E-07_JPRB, 0.22767825E-07_JPRB, 0.20730733E-07_JPRB, &
  & 0.18772075E-07_JPRB, 0.16964171E-07_JPRB, 0.15639273E-07_JPRB, 0.14769832E-07_JPRB, 0.14217021E-07_JPRB, 0.13920884E-07_JPRB, &
  & 0.13861545E-07_JPRB, 0.14010121E-07_JPRB, 0.14328311E-07_JPRB, 0.14775028E-07_JPRB, 0.15268375E-07_JPRB, 0.15714948E-07_JPRB, &
  & 0.16044012E-07_JPRB, 0.16207514E-07_JPRB, 0.16191423E-07_JPRB, 0.16016124E-07_JPRB, 0.15724774E-07_JPRB, 0.15365440E-07_JPRB, &
  & 0.14977774E-07_JPRB, 0.14578232E-07_JPRB, 0.14159093E-07_JPRB, 0.13671809E-07_JPRB, 0.13209211E-07_JPRB, 0.12790325E-07_JPRB, &
  & 0.12424620E-07_JPRB, 0.12100373E-07_JPRB, 0.11807561E-07_JPRB, 0.11538710E-07_JPRB, 0.11306573E-07_JPRB, 0.11135683E-07_JPRB, &
  & 0.11048023E-07_JPRB, 0.11044192E-07_JPRB, 0.11101241E-07_JPRB, 0.11201461E-07_JPRB, 0.11307624E-07_JPRB, 0.11373025E-07_JPRB, &
  & 0.11326840E-07_JPRB, 0.11094300E-07_JPRB, 0.10668814E-07_JPRB, 0.10072281E-07_JPRB, 0.93528749E-08_JPRB, 0.85761025E-08_JPRB, &
  & 0.78175448E-08_JPRB, 0.71456787E-08_JPRB, 0.66080781E-08_JPRB, 0.62290919E-08_JPRB, 0.60101097E-08_JPRB, 0.59274212E-08_JPRB, &
  & 0.59371663E-08_JPRB, 0.59932121E-08_JPRB, 0.60616347E-08_JPRB, 0.61244299E-08_JPRB, 0.61758936E-08_JPRB, 0.62160552E-08_JPRB, &
  & 0.62554117E-08_JPRB, 0.62907786E-08_JPRB, 0.63263523E-08_JPRB, 0.63569434E-08_JPRB /)

RGHG2(:, 2,12) = (/ &
  & 0.33468122E-07_JPRB, 0.33835857E-07_JPRB, 0.33422872E-07_JPRB, 0.32902502E-07_JPRB, 0.32243850E-07_JPRB, 0.31554091E-07_JPRB, &
  & 0.30874059E-07_JPRB, 0.30263777E-07_JPRB, 0.29797899E-07_JPRB, 0.29475453E-07_JPRB, 0.29309914E-07_JPRB, 0.29327385E-07_JPRB, &
  & 0.29548772E-07_JPRB, 0.29984317E-07_JPRB, 0.30603438E-07_JPRB, 0.31348026E-07_JPRB, 0.32108812E-07_JPRB, 0.32780008E-07_JPRB, &
  & 0.33272954E-07_JPRB, 0.33526970E-07_JPRB, 0.33518731E-07_JPRB, 0.33267398E-07_JPRB, 0.32822928E-07_JPRB, 0.32242752E-07_JPRB, &
  & 0.31578232E-07_JPRB, 0.30859940E-07_JPRB, 0.30098491E-07_JPRB, 0.29308451E-07_JPRB, 0.28546829E-07_JPRB, 0.27840061E-07_JPRB, &
  & 0.27197631E-07_JPRB, 0.26608474E-07_JPRB, 0.26067518E-07_JPRB, 0.25578284E-07_JPRB, 0.25161789E-07_JPRB, 0.24848717E-07_JPRB, &
  & 0.24673106E-07_JPRB, 0.24667766E-07_JPRB, 0.24816556E-07_JPRB, 0.25020578E-07_JPRB, 0.25150593E-07_JPRB, 0.25102842E-07_JPRB, &
  & 0.24833575E-07_JPRB, 0.24335112E-07_JPRB, 0.23607416E-07_JPRB, 0.22695730E-07_JPRB, 0.21686436E-07_JPRB, 0.20645437E-07_JPRB, &
  & 0.19525780E-07_JPRB, 0.18186613E-07_JPRB, 0.16558186E-07_JPRB, 0.14775532E-07_JPRB, 0.13093562E-07_JPRB, 0.11694443E-07_JPRB, &
  & 0.10623847E-07_JPRB, 0.98614450E-08_JPRB, 0.93632977E-08_JPRB, 0.90742924E-08_JPRB, 0.89389349E-08_JPRB, 0.89097494E-08_JPRB, &
  & 0.89385397E-08_JPRB, 0.90018117E-08_JPRB, 0.90973753E-08_JPRB, 0.92370849E-08_JPRB /)

RGHG2(:, 3,12) = (/ &
  & 0.33763758E-07_JPRB, 0.34535702E-07_JPRB, 0.34875264E-07_JPRB, 0.35128110E-07_JPRB, 0.35302733E-07_JPRB, 0.35428375E-07_JPRB, &
  & 0.35530864E-07_JPRB, 0.35632603E-07_JPRB, 0.35754788E-07_JPRB, 0.35898026E-07_JPRB, 0.36103767E-07_JPRB, 0.36405190E-07_JPRB, &
  & 0.36870922E-07_JPRB, 0.37500385E-07_JPRB, 0.38295585E-07_JPRB, 0.39214239E-07_JPRB, 0.40191743E-07_JPRB, 0.41132168E-07_JPRB, &
  & 0.41965762E-07_JPRB, 0.42640131E-07_JPRB, 0.43112955E-07_JPRB, 0.43370385E-07_JPRB, 0.43432127E-07_JPRB, 0.43340346E-07_JPRB, &
  & 0.43143153E-07_JPRB, 0.42878810E-07_JPRB, 0.42574648E-07_JPRB, 0.42255330E-07_JPRB, 0.41945611E-07_JPRB, 0.41658112E-07_JPRB, &
  & 0.41379522E-07_JPRB, 0.41094790E-07_JPRB, 0.40805169E-07_JPRB, 0.40538946E-07_JPRB, 0.40354188E-07_JPRB, 0.40316355E-07_JPRB, &
  & 0.40466091E-07_JPRB, 0.40771958E-07_JPRB, 0.41135117E-07_JPRB, 0.41408370E-07_JPRB, 0.41437431E-07_JPRB, 0.41109509E-07_JPRB, &
  & 0.40376115E-07_JPRB, 0.39228226E-07_JPRB, 0.37693184E-07_JPRB, 0.35800994E-07_JPRB, 0.33576217E-07_JPRB, 0.31045225E-07_JPRB, &
  & 0.28290952E-07_JPRB, 0.25527729E-07_JPRB, 0.23033312E-07_JPRB, 0.20905986E-07_JPRB, 0.19011429E-07_JPRB, 0.17266029E-07_JPRB, &
  & 0.15765384E-07_JPRB, 0.14611976E-07_JPRB, 0.13822257E-07_JPRB, 0.13347126E-07_JPRB, 0.13119007E-07_JPRB, 0.13065806E-07_JPRB, &
  & 0.13158676E-07_JPRB, 0.13318433E-07_JPRB, 0.13594662E-07_JPRB, 0.14092975E-07_JPRB /)

RGHG2(:, 4,12) = (/ &
  & 0.33074578E-07_JPRB, 0.33867146E-07_JPRB, 0.34369783E-07_JPRB, 0.34762451E-07_JPRB, 0.35138473E-07_JPRB, 0.35500854E-07_JPRB, &
  & 0.35854896E-07_JPRB, 0.36211823E-07_JPRB, 0.36607531E-07_JPRB, 0.37058083E-07_JPRB, 0.37551715E-07_JPRB, 0.38166426E-07_JPRB, &
  & 0.38945892E-07_JPRB, 0.39931518E-07_JPRB, 0.41064045E-07_JPRB, 0.42291028E-07_JPRB, 0.43552966E-07_JPRB, 0.44806452E-07_JPRB, &
  & 0.45994028E-07_JPRB, 0.47068244E-07_JPRB, 0.47999773E-07_JPRB, 0.48758697E-07_JPRB, 0.49338588E-07_JPRB, 0.49755435E-07_JPRB, &
  & 0.50041166E-07_JPRB, 0.50234807E-07_JPRB, 0.50374460E-07_JPRB, 0.50490119E-07_JPRB, 0.50596782E-07_JPRB, 0.50692812E-07_JPRB, &
  & 0.50766374E-07_JPRB, 0.50808069E-07_JPRB, 0.50821132E-07_JPRB, 0.50831723E-07_JPRB, 0.50883777E-07_JPRB, 0.51013103E-07_JPRB, &
  & 0.51220304E-07_JPRB, 0.51467161E-07_JPRB, 0.51670259E-07_JPRB, 0.51707588E-07_JPRB, 0.51457491E-07_JPRB, 0.50850417E-07_JPRB, &
  & 0.49875595E-07_JPRB, 0.48554696E-07_JPRB, 0.46910479E-07_JPRB, 0.44966953E-07_JPRB, 0.42739252E-07_JPRB, 0.40243172E-07_JPRB, &
  & 0.37538626E-07_JPRB, 0.34716429E-07_JPRB, 0.31797857E-07_JPRB, 0.28792385E-07_JPRB, 0.25883086E-07_JPRB, 0.23310685E-07_JPRB, &
  & 0.21170152E-07_JPRB, 0.19497932E-07_JPRB, 0.18324748E-07_JPRB, 0.17655479E-07_JPRB, 0.17435221E-07_JPRB, 0.17562453E-07_JPRB, &
  & 0.17980375E-07_JPRB, 0.18553909E-07_JPRB, 0.19396756E-07_JPRB, 0.20737856E-07_JPRB /)

RGHG2(:, 5,12) = (/ &
  & 0.32280891E-07_JPRB, 0.32760617E-07_JPRB, 0.33069210E-07_JPRB, 0.33437139E-07_JPRB, 0.33819788E-07_JPRB, 0.34229082E-07_JPRB, &
  & 0.34677758E-07_JPRB, 0.35189160E-07_JPRB, 0.35798791E-07_JPRB, 0.36556479E-07_JPRB, 0.37516774E-07_JPRB, 0.38625565E-07_JPRB, &
  & 0.39888157E-07_JPRB, 0.41310354E-07_JPRB, 0.42867402E-07_JPRB, 0.44513708E-07_JPRB, 0.46181473E-07_JPRB, 0.47810424E-07_JPRB, &
  & 0.49359723E-07_JPRB, 0.50771906E-07_JPRB, 0.51997453E-07_JPRB, 0.53037137E-07_JPRB, 0.53894674E-07_JPRB, 0.54599937E-07_JPRB, &
  & 0.55185961E-07_JPRB, 0.55685973E-07_JPRB, 0.56125952E-07_JPRB, 0.56521898E-07_JPRB, 0.56878395E-07_JPRB, 0.57189801E-07_JPRB, &
  & 0.57460745E-07_JPRB, 0.57707936E-07_JPRB, 0.57957536E-07_JPRB, 0.58251199E-07_JPRB, 0.58636022E-07_JPRB, 0.59145442E-07_JPRB, &
  & 0.59759621E-07_JPRB, 0.60370837E-07_JPRB, 0.60772066E-07_JPRB, 0.60724474E-07_JPRB, 0.60073631E-07_JPRB, 0.58830139E-07_JPRB, &
  & 0.57145677E-07_JPRB, 0.55182763E-07_JPRB, 0.53089192E-07_JPRB, 0.50955187E-07_JPRB, 0.48790596E-07_JPRB, 0.46533984E-07_JPRB, &
  & 0.44115318E-07_JPRB, 0.41486459E-07_JPRB, 0.38651752E-07_JPRB, 0.35717715E-07_JPRB, 0.32781102E-07_JPRB, 0.29897340E-07_JPRB, &
  & 0.27221972E-07_JPRB, 0.24972458E-07_JPRB, 0.23332998E-07_JPRB, 0.22404611E-07_JPRB, 0.22190534E-07_JPRB, 0.22558451E-07_JPRB, &
  & 0.23323864E-07_JPRB, 0.24279007E-07_JPRB, 0.25518316E-07_JPRB, 0.27461919E-07_JPRB /)

RGHG2(:, 6,12) = (/ &
  & 0.31890810E-07_JPRB, 0.31997796E-07_JPRB, 0.32276454E-07_JPRB, 0.32551036E-07_JPRB, 0.32905191E-07_JPRB, 0.33372789E-07_JPRB, &
  & 0.33983063E-07_JPRB, 0.34753970E-07_JPRB, 0.35720902E-07_JPRB, 0.36852715E-07_JPRB, 0.38219262E-07_JPRB, 0.39874728E-07_JPRB, &
  & 0.41730502E-07_JPRB, 0.43689639E-07_JPRB, 0.45724583E-07_JPRB, 0.47839109E-07_JPRB, 0.50016975E-07_JPRB, 0.52165483E-07_JPRB, &
  & 0.54246726E-07_JPRB, 0.56235880E-07_JPRB, 0.58076505E-07_JPRB, 0.59717081E-07_JPRB, 0.61155234E-07_JPRB, 0.62382398E-07_JPRB, &
  & 0.63423698E-07_JPRB, 0.64319622E-07_JPRB, 0.65123174E-07_JPRB, 0.65885601E-07_JPRB, 0.66639316E-07_JPRB, 0.67388875E-07_JPRB, &
  & 0.68127910E-07_JPRB, 0.68851563E-07_JPRB, 0.69580558E-07_JPRB, 0.70367257E-07_JPRB, 0.71281782E-07_JPRB, 0.72355647E-07_JPRB, &
  & 0.73535297E-07_JPRB, 0.74598880E-07_JPRB, 0.75156208E-07_JPRB, 0.74782434E-07_JPRB, 0.73293130E-07_JPRB, 0.70908285E-07_JPRB, &
  & 0.68044550E-07_JPRB, 0.65044908E-07_JPRB, 0.62093505E-07_JPRB, 0.59239046E-07_JPRB, 0.56431205E-07_JPRB, 0.53598065E-07_JPRB, &
  & 0.50725472E-07_JPRB, 0.47821061E-07_JPRB, 0.44881865E-07_JPRB, 0.41892058E-07_JPRB, 0.38857127E-07_JPRB, 0.35883815E-07_JPRB, &
  & 0.33112272E-07_JPRB, 0.30714659E-07_JPRB, 0.28895574E-07_JPRB, 0.27848415E-07_JPRB, 0.27610827E-07_JPRB, 0.28032272E-07_JPRB, &
  & 0.28883269E-07_JPRB, 0.29971332E-07_JPRB, 0.31305966E-07_JPRB, 0.33412928E-07_JPRB /)

RGHG2(:, 7,12) = (/ &
  & 0.32634624E-07_JPRB, 0.32409876E-07_JPRB, 0.32434492E-07_JPRB, 0.32644991E-07_JPRB, 0.33043165E-07_JPRB, 0.33644987E-07_JPRB, &
  & 0.34489375E-07_JPRB, 0.35642472E-07_JPRB, 0.37162561E-07_JPRB, 0.38996049E-07_JPRB, 0.41033900E-07_JPRB, 0.43285187E-07_JPRB, &
  & 0.45813639E-07_JPRB, 0.48584518E-07_JPRB, 0.51488868E-07_JPRB, 0.54429556E-07_JPRB, 0.57376155E-07_JPRB, 0.60299890E-07_JPRB, &
  & 0.63132980E-07_JPRB, 0.65853953E-07_JPRB, 0.68469653E-07_JPRB, 0.70928998E-07_JPRB, 0.73201946E-07_JPRB, 0.75261816E-07_JPRB, &
  & 0.77089020E-07_JPRB, 0.78708609E-07_JPRB, 0.80186098E-07_JPRB, 0.81613976E-07_JPRB, 0.83068642E-07_JPRB, 0.84595712E-07_JPRB, &
  & 0.86209496E-07_JPRB, 0.87903004E-07_JPRB, 0.89653959E-07_JPRB, 0.91445287E-07_JPRB, 0.93236487E-07_JPRB, 0.94935224E-07_JPRB, &
  & 0.96366655E-07_JPRB, 0.97201585E-07_JPRB, 0.96930144E-07_JPRB, 0.95062028E-07_JPRB, 0.91553687E-07_JPRB, 0.86976826E-07_JPRB, &
  & 0.82142613E-07_JPRB, 0.77577610E-07_JPRB, 0.73460470E-07_JPRB, 0.69719384E-07_JPRB, 0.66176867E-07_JPRB, 0.62724439E-07_JPRB, &
  & 0.59303950E-07_JPRB, 0.55833823E-07_JPRB, 0.52292776E-07_JPRB, 0.48741644E-07_JPRB, 0.45289603E-07_JPRB, 0.42028443E-07_JPRB, &
  & 0.39084089E-07_JPRB, 0.36631736E-07_JPRB, 0.34864801E-07_JPRB, 0.33924643E-07_JPRB, 0.33814704E-07_JPRB, 0.34372153E-07_JPRB, &
  & 0.35294125E-07_JPRB, 0.36463828E-07_JPRB, 0.37862545E-07_JPRB, 0.40329386E-07_JPRB /)

RGHG2(:, 8,12) = (/ &
  & 0.37408473E-07_JPRB, 0.36351310E-07_JPRB, 0.36129538E-07_JPRB, 0.36287460E-07_JPRB, 0.36763858E-07_JPRB, 0.37557523E-07_JPRB, &
  & 0.38701778E-07_JPRB, 0.40263579E-07_JPRB, 0.42389981E-07_JPRB, 0.45031051E-07_JPRB, 0.48151186E-07_JPRB, 0.51636881E-07_JPRB, &
  & 0.55369100E-07_JPRB, 0.59361692E-07_JPRB, 0.63592744E-07_JPRB, 0.67993049E-07_JPRB, 0.72463152E-07_JPRB, 0.76955459E-07_JPRB, &
  & 0.81454694E-07_JPRB, 0.85850445E-07_JPRB, 0.90145221E-07_JPRB, 0.94245806E-07_JPRB, 0.98083135E-07_JPRB, 0.10153398E-06_JPRB, &
  & 0.10456237E-06_JPRB, 0.10713041E-06_JPRB, 0.10934235E-06_JPRB, 0.11137185E-06_JPRB, 0.11339015E-06_JPRB, 0.11551435E-06_JPRB, &
  & 0.11777528E-06_JPRB, 0.12009146E-06_JPRB, 0.12228432E-06_JPRB, 0.12414843E-06_JPRB, 0.12548946E-06_JPRB, 0.12613157E-06_JPRB, &
  & 0.12593731E-06_JPRB, 0.12470652E-06_JPRB, 0.12203138E-06_JPRB, 0.11745944E-06_JPRB, 0.11110525E-06_JPRB, 0.10400424E-06_JPRB, &
  & 0.97319187E-07_JPRB, 0.91517158E-07_JPRB, 0.86500819E-07_JPRB, 0.81961716E-07_JPRB, 0.77704030E-07_JPRB, 0.73616498E-07_JPRB, &
  & 0.69524376E-07_JPRB, 0.65343826E-07_JPRB, 0.61115905E-07_JPRB, 0.56921195E-07_JPRB, 0.52857832E-07_JPRB, 0.49102677E-07_JPRB, &
  & 0.45851387E-07_JPRB, 0.43320185E-07_JPRB, 0.41675492E-07_JPRB, 0.41014076E-07_JPRB, 0.41260414E-07_JPRB, 0.42164906E-07_JPRB, &
  & 0.43447749E-07_JPRB, 0.44881414E-07_JPRB, 0.46394128E-07_JPRB, 0.48670174E-07_JPRB /)

RGHG2(:, 9,12) = (/ &
  & 0.51171774E-07_JPRB, 0.48091540E-07_JPRB, 0.46831371E-07_JPRB, 0.46517979E-07_JPRB, 0.46855977E-07_JPRB, 0.47793460E-07_JPRB, &
  & 0.49335448E-07_JPRB, 0.51535110E-07_JPRB, 0.54521987E-07_JPRB, 0.58219982E-07_JPRB, 0.62612671E-07_JPRB, 0.67690451E-07_JPRB, &
  & 0.73351430E-07_JPRB, 0.79394418E-07_JPRB, 0.85763510E-07_JPRB, 0.92443670E-07_JPRB, 0.99404453E-07_JPRB, 0.10656655E-06_JPRB, &
  & 0.11400492E-06_JPRB, 0.12155738E-06_JPRB, 0.12908777E-06_JPRB, 0.13641588E-06_JPRB, 0.14325202E-06_JPRB, 0.14927615E-06_JPRB, &
  & 0.15427801E-06_JPRB, 0.15819261E-06_JPRB, 0.16113469E-06_JPRB, 0.16343938E-06_JPRB, 0.16540687E-06_JPRB, 0.16722912E-06_JPRB, &
  & 0.16889301E-06_JPRB, 0.17019831E-06_JPRB, 0.17082995E-06_JPRB, 0.17047445E-06_JPRB, 0.16897515E-06_JPRB, 0.16632987E-06_JPRB, &
  & 0.16252207E-06_JPRB, 0.15751537E-06_JPRB, 0.15102887E-06_JPRB, 0.14280720E-06_JPRB, 0.13309469E-06_JPRB, 0.12321571E-06_JPRB, &
  & 0.11448950E-06_JPRB, 0.10714935E-06_JPRB, 0.10085938E-06_JPRB, 0.95357734E-07_JPRB, 0.90424393E-07_JPRB, 0.85708947E-07_JPRB, &
  & 0.81001815E-07_JPRB, 0.76247538E-07_JPRB, 0.71413474E-07_JPRB, 0.66571232E-07_JPRB, 0.61934195E-07_JPRB, 0.57750370E-07_JPRB, &
  & 0.54298521E-07_JPRB, 0.51826142E-07_JPRB, 0.50502372E-07_JPRB, 0.50322047E-07_JPRB, 0.51084452E-07_JPRB, 0.52447781E-07_JPRB, &
  & 0.54061871E-07_JPRB, 0.55617772E-07_JPRB, 0.57343463E-07_JPRB, 0.59499904E-07_JPRB /)

RGHG2(:,10,12) = (/ &
  & 0.81529976E-07_JPRB, 0.73811250E-07_JPRB, 0.70130895E-07_JPRB, 0.68649044E-07_JPRB, 0.68348669E-07_JPRB, 0.69074154E-07_JPRB, &
  & 0.70816164E-07_JPRB, 0.73649332E-07_JPRB, 0.77746712E-07_JPRB, 0.82965705E-07_JPRB, 0.89218950E-07_JPRB, 0.96556711E-07_JPRB, &
  & 0.10492545E-06_JPRB, 0.11423388E-06_JPRB, 0.12427824E-06_JPRB, 0.13506779E-06_JPRB, 0.14656908E-06_JPRB, 0.15858120E-06_JPRB, &
  & 0.17105133E-06_JPRB, 0.18382380E-06_JPRB, 0.19655576E-06_JPRB, 0.20873198E-06_JPRB, 0.21999229E-06_JPRB, 0.22965712E-06_JPRB, &
  & 0.23728863E-06_JPRB, 0.24275559E-06_JPRB, 0.24610745E-06_JPRB, 0.24774991E-06_JPRB, 0.24804825E-06_JPRB, 0.24724972E-06_JPRB, &
  & 0.24536695E-06_JPRB, 0.24216862E-06_JPRB, 0.23737188E-06_JPRB, 0.23084570E-06_JPRB, 0.22276234E-06_JPRB, 0.21373990E-06_JPRB, &
  & 0.20428904E-06_JPRB, 0.19437962E-06_JPRB, 0.18401261E-06_JPRB, 0.17287891E-06_JPRB, 0.16084275E-06_JPRB, 0.14850374E-06_JPRB, &
  & 0.13717690E-06_JPRB, 0.12763874E-06_JPRB, 0.11994946E-06_JPRB, 0.11354521E-06_JPRB, 0.10771740E-06_JPRB, 0.10209025E-06_JPRB, &
  & 0.96504849E-07_JPRB, 0.90816698E-07_JPRB, 0.85065231E-07_JPRB, 0.79456214E-07_JPRB, 0.74251432E-07_JPRB, 0.69780668E-07_JPRB, &
  & 0.66374426E-07_JPRB, 0.64275227E-07_JPRB, 0.63529022E-07_JPRB, 0.63959931E-07_JPRB, 0.65214948E-07_JPRB, 0.66868694E-07_JPRB, &
  & 0.68508058E-07_JPRB, 0.70091644E-07_JPRB, 0.71295304E-07_JPRB, 0.73024928E-07_JPRB /)

RGHG2(:,11,12) = (/ &
  & 0.13268858E-06_JPRB, 0.11843006E-06_JPRB, 0.11146111E-06_JPRB, 0.10820273E-06_JPRB, 0.10681426E-06_JPRB, 0.10699619E-06_JPRB, &
  & 0.10872998E-06_JPRB, 0.11215193E-06_JPRB, 0.11755090E-06_JPRB, 0.12472840E-06_JPRB, 0.13353261E-06_JPRB, 0.14392404E-06_JPRB, &
  & 0.15590705E-06_JPRB, 0.16951398E-06_JPRB, 0.18455336E-06_JPRB, 0.20081686E-06_JPRB, 0.21831202E-06_JPRB, 0.23681201E-06_JPRB, &
  & 0.25599269E-06_JPRB, 0.27543831E-06_JPRB, 0.29470436E-06_JPRB, 0.31287058E-06_JPRB, 0.32910992E-06_JPRB, 0.34287348E-06_JPRB, &
  & 0.35324172E-06_JPRB, 0.35992684E-06_JPRB, 0.36289131E-06_JPRB, 0.36228587E-06_JPRB, 0.35850661E-06_JPRB, 0.35181526E-06_JPRB, &
  & 0.34249632E-06_JPRB, 0.33068847E-06_JPRB, 0.31657004E-06_JPRB, 0.30070063E-06_JPRB, 0.28415326E-06_JPRB, 0.26786239E-06_JPRB, &
  & 0.25271558E-06_JPRB, 0.23880347E-06_JPRB, 0.22523977E-06_JPRB, 0.21167160E-06_JPRB, 0.19792822E-06_JPRB, 0.18463483E-06_JPRB, &
  & 0.17263739E-06_JPRB, 0.16236518E-06_JPRB, 0.15330659E-06_JPRB, 0.14503067E-06_JPRB, 0.13728997E-06_JPRB, 0.12983534E-06_JPRB, &
  & 0.12238212E-06_JPRB, 0.11489433E-06_JPRB, 0.10753917E-06_JPRB, 0.10057310E-06_JPRB, 0.94374833E-07_JPRB, 0.89380613E-07_JPRB, &
  & 0.85890377E-07_JPRB, 0.83998465E-07_JPRB, 0.83527922E-07_JPRB, 0.84115449E-07_JPRB, 0.85332253E-07_JPRB, 0.86763762E-07_JPRB, &
  & 0.88156071E-07_JPRB, 0.89201748E-07_JPRB, 0.90273566E-07_JPRB, 0.91199411E-07_JPRB /)

RGHG2(:,12,12) = (/ &
  & 0.19975944E-06_JPRB, 0.18033407E-06_JPRB, 0.17154881E-06_JPRB, 0.16701391E-06_JPRB, 0.16485239E-06_JPRB, 0.16468104E-06_JPRB, &
  & 0.16650604E-06_JPRB, 0.17054522E-06_JPRB, 0.17727203E-06_JPRB, 0.18659237E-06_JPRB, 0.19839328E-06_JPRB, 0.21255300E-06_JPRB, &
  & 0.22889371E-06_JPRB, 0.24740680E-06_JPRB, 0.26817486E-06_JPRB, 0.29094383E-06_JPRB, 0.31532730E-06_JPRB, 0.34095808E-06_JPRB, &
  & 0.36721144E-06_JPRB, 0.39331368E-06_JPRB, 0.41863319E-06_JPRB, 0.44221329E-06_JPRB, 0.46268323E-06_JPRB, 0.47945355E-06_JPRB, &
  & 0.49161821E-06_JPRB, 0.49829004E-06_JPRB, 0.49936739E-06_JPRB, 0.49457952E-06_JPRB, 0.48430184E-06_JPRB, 0.46897944E-06_JPRB, &
  & 0.44929877E-06_JPRB, 0.42623142E-06_JPRB, 0.40098419E-06_JPRB, 0.37512780E-06_JPRB, 0.35049746E-06_JPRB, 0.32887837E-06_JPRB, &
  & 0.31033196E-06_JPRB, 0.29457664E-06_JPRB, 0.28127215E-06_JPRB, 0.26940108E-06_JPRB, 0.25850383E-06_JPRB, 0.24800147E-06_JPRB, &
  & 0.23755911E-06_JPRB, 0.22701245E-06_JPRB, 0.21648161E-06_JPRB, 0.20585523E-06_JPRB, 0.19492992E-06_JPRB, 0.18361391E-06_JPRB, &
  & 0.17196001E-06_JPRB, 0.16030414E-06_JPRB, 0.14900534E-06_JPRB, 0.13854913E-06_JPRB, 0.12954936E-06_JPRB, 0.12242931E-06_JPRB, &
  & 0.11740327E-06_JPRB, 0.11435121E-06_JPRB, 0.11291589E-06_JPRB, 0.11262985E-06_JPRB, 0.11304273E-06_JPRB, 0.11375484E-06_JPRB, &
  & 0.11442033E-06_JPRB, 0.11493736E-06_JPRB, 0.11509285E-06_JPRB, 0.11450646E-06_JPRB /)

RGHG2(:,13,12) = (/ &
  & 0.27767604E-06_JPRB, 0.25548306E-06_JPRB, 0.24663066E-06_JPRB, 0.24199204E-06_JPRB, 0.24018951E-06_JPRB, 0.24080836E-06_JPRB, &
  & 0.24376837E-06_JPRB, 0.24930605E-06_JPRB, 0.25795947E-06_JPRB, 0.26972074E-06_JPRB, 0.28458794E-06_JPRB, 0.30265076E-06_JPRB, &
  & 0.32373484E-06_JPRB, 0.34752173E-06_JPRB, 0.37377302E-06_JPRB, 0.40232391E-06_JPRB, 0.43271865E-06_JPRB, 0.46426265E-06_JPRB, &
  & 0.49609929E-06_JPRB, 0.52708776E-06_JPRB, 0.55634354E-06_JPRB, 0.58305642E-06_JPRB, 0.60566174E-06_JPRB, 0.62334374E-06_JPRB, &
  & 0.63529410E-06_JPRB, 0.64018036E-06_JPRB, 0.63766510E-06_JPRB, 0.62725178E-06_JPRB, 0.60921343E-06_JPRB, 0.58449405E-06_JPRB, &
  & 0.55461669E-06_JPRB, 0.52131134E-06_JPRB, 0.48702725E-06_JPRB, 0.45438037E-06_JPRB, 0.42613306E-06_JPRB, 0.40313051E-06_JPRB, &
  & 0.38612811E-06_JPRB, 0.37366519E-06_JPRB, 0.36412385E-06_JPRB, 0.35678542E-06_JPRB, 0.35083636E-06_JPRB, 0.34556695E-06_JPRB, &
  & 0.33999945E-06_JPRB, 0.33285423E-06_JPRB, 0.32326454E-06_JPRB, 0.31103599E-06_JPRB, 0.29636362E-06_JPRB, 0.27974897E-06_JPRB, &
  & 0.26160671E-06_JPRB, 0.24272356E-06_JPRB, 0.22391268E-06_JPRB, 0.20629372E-06_JPRB, 0.19078503E-06_JPRB, 0.17815964E-06_JPRB, &
  & 0.16863731E-06_JPRB, 0.16205877E-06_JPRB, 0.15787298E-06_JPRB, 0.15546279E-06_JPRB, 0.15423720E-06_JPRB, 0.15368278E-06_JPRB, &
  & 0.15337400E-06_JPRB, 0.15304235E-06_JPRB, 0.15234913E-06_JPRB, 0.15078831E-06_JPRB /)

RGHG2(:,14,12) = (/ &
  & 0.35902877E-06_JPRB, 0.33835610E-06_JPRB, 0.33066982E-06_JPRB, 0.32773781E-06_JPRB, 0.32806980E-06_JPRB, 0.33108427E-06_JPRB, &
  & 0.33665700E-06_JPRB, 0.34501196E-06_JPRB, 0.35675129E-06_JPRB, 0.37176451E-06_JPRB, 0.39004721E-06_JPRB, 0.41161530E-06_JPRB, &
  & 0.43647907E-06_JPRB, 0.46440468E-06_JPRB, 0.49492667E-06_JPRB, 0.52752256E-06_JPRB, 0.56161207E-06_JPRB, 0.59648676E-06_JPRB, &
  & 0.63113282E-06_JPRB, 0.66419960E-06_JPRB, 0.69466421E-06_JPRB, 0.72174333E-06_JPRB, 0.74389214E-06_JPRB, 0.76026367E-06_JPRB, &
  & 0.76996673E-06_JPRB, 0.77153049E-06_JPRB, 0.76440944E-06_JPRB, 0.74809873E-06_JPRB, 0.72305829E-06_JPRB, 0.69061116E-06_JPRB, &
  & 0.65288862E-06_JPRB, 0.61327881E-06_JPRB, 0.57491610E-06_JPRB, 0.54116708E-06_JPRB, 0.51441555E-06_JPRB, 0.49666016E-06_JPRB, &
  & 0.48499771E-06_JPRB, 0.47794384E-06_JPRB, 0.47428057E-06_JPRB, 0.47265294E-06_JPRB, 0.47205737E-06_JPRB, 0.47143294E-06_JPRB, &
  & 0.46948963E-06_JPRB, 0.46497055E-06_JPRB, 0.45693099E-06_JPRB, 0.44489565E-06_JPRB, 0.42894962E-06_JPRB, 0.40952750E-06_JPRB, &
  & 0.38706804E-06_JPRB, 0.36251450E-06_JPRB, 0.33698799E-06_JPRB, 0.31182745E-06_JPRB, 0.28847859E-06_JPRB, 0.26816687E-06_JPRB, &
  & 0.25158604E-06_JPRB, 0.23879673E-06_JPRB, 0.22934961E-06_JPRB, 0.22256316E-06_JPRB, 0.21778534E-06_JPRB, 0.21440380E-06_JPRB, &
  & 0.21187316E-06_JPRB, 0.20965103E-06_JPRB, 0.20718866E-06_JPRB, 0.20208638E-06_JPRB /)

RGHG2(:,15,12) = (/ &
  & 0.43967790E-06_JPRB, 0.42355180E-06_JPRB, 0.41948971E-06_JPRB, 0.42016384E-06_JPRB, 0.42403258E-06_JPRB, 0.43056249E-06_JPRB, &
  & 0.43963755E-06_JPRB, 0.45152160E-06_JPRB, 0.46678616E-06_JPRB, 0.48537424E-06_JPRB, 0.50714743E-06_JPRB, 0.53198767E-06_JPRB, &
  & 0.55972407E-06_JPRB, 0.59015832E-06_JPRB, 0.62294521E-06_JPRB, 0.65744700E-06_JPRB, 0.69286267E-06_JPRB, 0.72841914E-06_JPRB, &
  & 0.76313853E-06_JPRB, 0.79559527E-06_JPRB, 0.82486326E-06_JPRB, 0.85008890E-06_JPRB, 0.86975189E-06_JPRB, 0.88318160E-06_JPRB, &
  & 0.88928914E-06_JPRB, 0.88676643E-06_JPRB, 0.87502042E-06_JPRB, 0.85372153E-06_JPRB, 0.82352375E-06_JPRB, 0.78653960E-06_JPRB, &
  & 0.74580549E-06_JPRB, 0.70500829E-06_JPRB, 0.66791478E-06_JPRB, 0.63908635E-06_JPRB, 0.61992222E-06_JPRB, 0.60873003E-06_JPRB, &
  & 0.60499372E-06_JPRB, 0.60543812E-06_JPRB, 0.60770128E-06_JPRB, 0.61055346E-06_JPRB, 0.61301023E-06_JPRB, 0.61404228E-06_JPRB, &
  & 0.61272152E-06_JPRB, 0.60828506E-06_JPRB, 0.60015282E-06_JPRB, 0.58801800E-06_JPRB, 0.57174401E-06_JPRB, 0.55130744E-06_JPRB, &
  & 0.52707696E-06_JPRB, 0.49976734E-06_JPRB, 0.47050298E-06_JPRB, 0.44066326E-06_JPRB, 0.41167752E-06_JPRB, 0.38496779E-06_JPRB, &
  & 0.36151786E-06_JPRB, 0.34182668E-06_JPRB, 0.32582554E-06_JPRB, 0.31312726E-06_JPRB, 0.30322775E-06_JPRB, 0.29554980E-06_JPRB, &
  & 0.28972289E-06_JPRB, 0.28461619E-06_JPRB, 0.27975116E-06_JPRB, 0.27048375E-06_JPRB /)

RGHG2(:,16,12) = (/ &
  & 0.51887554E-06_JPRB, 0.51035943E-06_JPRB, 0.51113676E-06_JPRB, 0.51554628E-06_JPRB, 0.52283190E-06_JPRB, 0.53274545E-06_JPRB, &
  & 0.54526373E-06_JPRB, 0.56067995E-06_JPRB, 0.57952690E-06_JPRB, 0.60160369E-06_JPRB, 0.62668414E-06_JPRB, 0.65443703E-06_JPRB, &
  & 0.68451425E-06_JPRB, 0.71652977E-06_JPRB, 0.75010553E-06_JPRB, 0.78472522E-06_JPRB, 0.81961531E-06_JPRB, 0.85400154E-06_JPRB, &
  & 0.88691945E-06_JPRB, 0.91699383E-06_JPRB, 0.94351634E-06_JPRB, 0.96545818E-06_JPRB, 0.98149997E-06_JPRB, 0.99107763E-06_JPRB, &
  & 0.99307340E-06_JPRB, 0.98648957E-06_JPRB, 0.97090185E-06_JPRB, 0.94638324E-06_JPRB, 0.91425534E-06_JPRB, 0.87690199E-06_JPRB, &
  & 0.83801513E-06_JPRB, 0.80141984E-06_JPRB, 0.77207176E-06_JPRB, 0.75106283E-06_JPRB, 0.74043800E-06_JPRB, 0.73937684E-06_JPRB, &
  & 0.74351271E-06_JPRB, 0.75000287E-06_JPRB, 0.75659943E-06_JPRB, 0.76180197E-06_JPRB, 0.76473071E-06_JPRB, 0.76485117E-06_JPRB, &
  & 0.76179833E-06_JPRB, 0.75544597E-06_JPRB, 0.74574780E-06_JPRB, 0.73252255E-06_JPRB, 0.71554024E-06_JPRB, 0.69459946E-06_JPRB, &
  & 0.66971148E-06_JPRB, 0.64135281E-06_JPRB, 0.61044210E-06_JPRB, 0.57811650E-06_JPRB, 0.54570000E-06_JPRB, 0.51454640E-06_JPRB, &
  & 0.48582933E-06_JPRB, 0.46042263E-06_JPRB, 0.43864554E-06_JPRB, 0.42043072E-06_JPRB, 0.40554019E-06_JPRB, 0.39363800E-06_JPRB, &
  & 0.38392460E-06_JPRB, 0.37636823E-06_JPRB, 0.36779272E-06_JPRB, 0.35524533E-06_JPRB /)

RGHG2(:,17,12) = (/ &
  & 0.59446671E-06_JPRB, 0.59463991E-06_JPRB, 0.59934473E-06_JPRB, 0.60720822E-06_JPRB, 0.61792684E-06_JPRB, 0.63128431E-06_JPRB, &
  & 0.64731728E-06_JPRB, 0.66622391E-06_JPRB, 0.68850846E-06_JPRB, 0.71384699E-06_JPRB, 0.74181031E-06_JPRB, 0.77188275E-06_JPRB, &
  & 0.80356767E-06_JPRB, 0.83642033E-06_JPRB, 0.86997255E-06_JPRB, 0.90375465E-06_JPRB, 0.93713788E-06_JPRB, 0.96942847E-06_JPRB, &
  & 0.99966735E-06_JPRB, 0.10266206E-05_JPRB, 0.10496690E-05_JPRB, 0.10677567E-05_JPRB, 0.10797846E-05_JPRB, 0.10852267E-05_JPRB, &
  & 0.10832314E-05_JPRB, 0.10732742E-05_JPRB, 0.10554055E-05_JPRB, 0.10303600E-05_JPRB, 0.99968338E-06_JPRB, 0.96635495E-06_JPRB, &
  & 0.93403435E-06_JPRB, 0.90616265E-06_JPRB, 0.88569465E-06_JPRB, 0.87568867E-06_JPRB, 0.87484437E-06_JPRB, 0.88103576E-06_JPRB, &
  & 0.89128253E-06_JPRB, 0.90190684E-06_JPRB, 0.91035122E-06_JPRB, 0.91542438E-06_JPRB, 0.91674661E-06_JPRB, 0.91425176E-06_JPRB, &
  & 0.90826325E-06_JPRB, 0.89917347E-06_JPRB, 0.88718986E-06_JPRB, 0.87235435E-06_JPRB, 0.85443634E-06_JPRB, 0.83310579E-06_JPRB, &
  & 0.80817995E-06_JPRB, 0.77988267E-06_JPRB, 0.74885816E-06_JPRB, 0.71598964E-06_JPRB, 0.68225938E-06_JPRB, 0.64886723E-06_JPRB, &
  & 0.61710500E-06_JPRB, 0.58798560E-06_JPRB, 0.56219221E-06_JPRB, 0.53992244E-06_JPRB, 0.52113643E-06_JPRB, 0.50564984E-06_JPRB, &
  & 0.49332698E-06_JPRB, 0.48256004E-06_JPRB, 0.47271789E-06_JPRB, 0.45448547E-06_JPRB /)

RGHG2(:,18,12) = (/ &
  & 0.66791523E-06_JPRB, 0.67340284E-06_JPRB, 0.68190985E-06_JPRB, 0.69312586E-06_JPRB, 0.70699923E-06_JPRB, 0.72348291E-06_JPRB, &
  & 0.74250420E-06_JPRB, 0.76437863E-06_JPRB, 0.78934079E-06_JPRB, 0.81709800E-06_JPRB, 0.84711763E-06_JPRB, 0.87873377E-06_JPRB, &
  & 0.91133904E-06_JPRB, 0.94443277E-06_JPRB, 0.97752263E-06_JPRB, 0.10101414E-05_JPRB, 0.10417990E-05_JPRB, 0.10718678E-05_JPRB, &
  & 0.10994195E-05_JPRB, 0.11233709E-05_JPRB, 0.11429909E-05_JPRB, 0.11573876E-05_JPRB, 0.11656581E-05_JPRB, 0.11673510E-05_JPRB, &
  & 0.11621165E-05_JPRB, 0.11499674E-05_JPRB, 0.11315349E-05_JPRB, 0.11082345E-05_JPRB, 0.10824758E-05_JPRB, 0.10569195E-05_JPRB, &
  & 0.10338338E-05_JPRB, 0.10172894E-05_JPRB, 0.10082634E-05_JPRB, 0.10068050E-05_JPRB, 0.10128821E-05_JPRB, 0.10240457E-05_JPRB, &
  & 0.10369188E-05_JPRB, 0.10482719E-05_JPRB, 0.10558621E-05_JPRB, 0.10589514E-05_JPRB, 0.10574078E-05_JPRB, 0.10518082E-05_JPRB, &
  & 0.10428606E-05_JPRB, 0.10311410E-05_JPRB, 0.10171283E-05_JPRB, 0.10008853E-05_JPRB, 0.98225621E-06_JPRB, 0.96086274E-06_JPRB, &
  & 0.93646014E-06_JPRB, 0.90915222E-06_JPRB, 0.87926338E-06_JPRB, 0.84724957E-06_JPRB, 0.81390692E-06_JPRB, 0.78029154E-06_JPRB, &
  & 0.74757543E-06_JPRB, 0.71697593E-06_JPRB, 0.68927000E-06_JPRB, 0.66483233E-06_JPRB, 0.64383380E-06_JPRB, 0.62623639E-06_JPRB, &
  & 0.61193487E-06_JPRB, 0.59996023E-06_JPRB, 0.58802908E-06_JPRB, 0.56782994E-06_JPRB /)

RGHG2(:,19,12) = (/ &
  & 0.73573557E-06_JPRB, 0.74795366E-06_JPRB, 0.75955290E-06_JPRB, 0.77307629E-06_JPRB, 0.78907044E-06_JPRB, 0.80757570E-06_JPRB, &
  & 0.82873191E-06_JPRB, 0.85252634E-06_JPRB, 0.87925719E-06_JPRB, 0.90849534E-06_JPRB, 0.93965525E-06_JPRB, 0.97204497E-06_JPRB, &
  & 0.10049602E-05_JPRB, 0.10379199E-05_JPRB, 0.10704077E-05_JPRB, 0.11019048E-05_JPRB, 0.11319898E-05_JPRB, 0.11601435E-05_JPRB, &
  & 0.11854760E-05_JPRB, 0.12069853E-05_JPRB, 0.12238362E-05_JPRB, 0.12352514E-05_JPRB, 0.12405769E-05_JPRB, 0.12395058E-05_JPRB, &
  & 0.12322541E-05_JPRB, 0.12194961E-05_JPRB, 0.12026325E-05_JPRB, 0.11837126E-05_JPRB, 0.11647389E-05_JPRB, 0.11480631E-05_JPRB, &
  & 0.11364484E-05_JPRB, 0.11300486E-05_JPRB, 0.11299695E-05_JPRB, 0.11356457E-05_JPRB, 0.11455103E-05_JPRB, 0.11576439E-05_JPRB, &
  & 0.11695513E-05_JPRB, 0.11786957E-05_JPRB, 0.11835975E-05_JPRB, 0.11838882E-05_JPRB, 0.11796844E-05_JPRB, 0.11715210E-05_JPRB, &
  & 0.11603739E-05_JPRB, 0.11469165E-05_JPRB, 0.11315766E-05_JPRB, 0.11145653E-05_JPRB, 0.10957366E-05_JPRB, 0.10747881E-05_JPRB, &
  & 0.10515179E-05_JPRB, 0.10258240E-05_JPRB, 0.99772137E-06_JPRB, 0.96760903E-06_JPRB, 0.93607150E-06_JPRB, 0.90389460E-06_JPRB, &
  & 0.87221281E-06_JPRB, 0.84215617E-06_JPRB, 0.81454863E-06_JPRB, 0.78987557E-06_JPRB, 0.76835533E-06_JPRB, 0.75020500E-06_JPRB, &
  & 0.73506158E-06_JPRB, 0.72290646E-06_JPRB, 0.70976853E-06_JPRB, 0.68996252E-06_JPRB /)

RGHG2(:,20,12) = (/ &
  & 0.80201721E-06_JPRB, 0.81754655E-06_JPRB, 0.83084410E-06_JPRB, 0.84570172E-06_JPRB, 0.86289469E-06_JPRB, 0.88268689E-06_JPRB, &
  & 0.90495627E-06_JPRB, 0.92990808E-06_JPRB, 0.95748703E-06_JPRB, 0.98730993E-06_JPRB, 0.10188792E-05_JPRB, 0.10514032E-05_JPRB, &
  & 0.10841846E-05_JPRB, 0.11166651E-05_JPRB, 0.11484832E-05_JPRB, 0.11790895E-05_JPRB, 0.12079478E-05_JPRB, 0.12345893E-05_JPRB, &
  & 0.12583123E-05_JPRB, 0.12781488E-05_JPRB, 0.12931862E-05_JPRB, 0.13026912E-05_JPRB, 0.13062377E-05_JPRB, 0.13038369E-05_JPRB, &
  & 0.12961590E-05_JPRB, 0.12845632E-05_JPRB, 0.12709680E-05_JPRB, 0.12572565E-05_JPRB, 0.12458885E-05_JPRB, 0.12385727E-05_JPRB, &
  & 0.12357164E-05_JPRB, 0.12378448E-05_JPRB, 0.12438029E-05_JPRB, 0.12526195E-05_JPRB, 0.12630076E-05_JPRB, 0.12733947E-05_JPRB, &
  & 0.12825485E-05_JPRB, 0.12888287E-05_JPRB, 0.12909502E-05_JPRB, 0.12883083E-05_JPRB, 0.12819514E-05_JPRB, 0.12721549E-05_JPRB, &
  & 0.12598423E-05_JPRB, 0.12455514E-05_JPRB, 0.12296778E-05_JPRB, 0.12125199E-05_JPRB, 0.11939981E-05_JPRB, 0.11739793E-05_JPRB, &
  & 0.11521747E-05_JPRB, 0.11283927E-05_JPRB, 0.11026675E-05_JPRB, 0.10752725E-05_JPRB, 0.10465416E-05_JPRB, 0.10171211E-05_JPRB, &
  & 0.98796852E-06_JPRB, 0.96004999E-06_JPRB, 0.93417935E-06_JPRB, 0.91079642E-06_JPRB, 0.89025616E-06_JPRB, 0.87267955E-06_JPRB, &
  & 0.85845886E-06_JPRB, 0.84562942E-06_JPRB, 0.83441836E-06_JPRB, 0.81177848E-06_JPRB /)

RGHG2(:,21,12) = (/ &
  & 0.86275901E-06_JPRB, 0.88104525E-06_JPRB, 0.89543312E-06_JPRB, 0.91100628E-06_JPRB, 0.92881328E-06_JPRB, 0.94906864E-06_JPRB, &
  & 0.97188058E-06_JPRB, 0.99706222E-06_JPRB, 0.10247313E-05_JPRB, 0.10545139E-05_JPRB, 0.10857917E-05_JPRB, 0.11179659E-05_JPRB, &
  & 0.11503032E-05_JPRB, 0.11821700E-05_JPRB, 0.12132060E-05_JPRB, 0.12430389E-05_JPRB, 0.12711333E-05_JPRB, 0.12968482E-05_JPRB, &
  & 0.13195499E-05_JPRB, 0.13384442E-05_JPRB, 0.13526731E-05_JPRB, 0.13615390E-05_JPRB, 0.13647373E-05_JPRB, 0.13625768E-05_JPRB, &
  & 0.13560741E-05_JPRB, 0.13469062E-05_JPRB, 0.13370950E-05_JPRB, 0.13288779E-05_JPRB, 0.13241834E-05_JPRB, 0.13236806E-05_JPRB, &
  & 0.13272947E-05_JPRB, 0.13339126E-05_JPRB, 0.13425074E-05_JPRB, 0.13517791E-05_JPRB, 0.13605696E-05_JPRB, 0.13683031E-05_JPRB, &
  & 0.13740383E-05_JPRB, 0.13768453E-05_JPRB, 0.13765518E-05_JPRB, 0.13725549E-05_JPRB, 0.13651104E-05_JPRB, 0.13547558E-05_JPRB, &
  & 0.13421957E-05_JPRB, 0.13278848E-05_JPRB, 0.13122656E-05_JPRB, 0.12954422E-05_JPRB, 0.12776741E-05_JPRB, 0.12588059E-05_JPRB, &
  & 0.12386480E-05_JPRB, 0.12170818E-05_JPRB, 0.11941430E-05_JPRB, 0.11699096E-05_JPRB, 0.11445895E-05_JPRB, 0.11186845E-05_JPRB, &
  & 0.10928577E-05_JPRB, 0.10679520E-05_JPRB, 0.10446282E-05_JPRB, 0.10233884E-05_JPRB, 0.10045637E-05_JPRB, 0.98842690E-06_JPRB, &
  & 0.97462623E-06_JPRB, 0.96360145E-06_JPRB, 0.95055481E-06_JPRB, 0.93176584E-06_JPRB /)

RGHG2(:,22,12) = (/ &
  & 0.91945742E-06_JPRB, 0.93923933E-06_JPRB, 0.95411212E-06_JPRB, 0.96987696E-06_JPRB, 0.98769783E-06_JPRB, 0.10079513E-05_JPRB, &
  & 0.10305039E-05_JPRB, 0.10553990E-05_JPRB, 0.10825394E-05_JPRB, 0.11116333E-05_JPRB, 0.11422926E-05_JPRB, 0.11737105E-05_JPRB, &
  & 0.12053440E-05_JPRB, 0.12365336E-05_JPRB, 0.12668312E-05_JPRB, 0.12958710E-05_JPRB, 0.13232925E-05_JPRB, 0.13485813E-05_JPRB, &
  & 0.13710110E-05_JPRB, 0.13897867E-05_JPRB, 0.14041372E-05_JPRB, 0.14134839E-05_JPRB, 0.14176816E-05_JPRB, 0.14171850E-05_JPRB, &
  & 0.14131823E-05_JPRB, 0.14074291E-05_JPRB, 0.14018948E-05_JPRB, 0.13985373E-05_JPRB, 0.13983528E-05_JPRB, 0.14016873E-05_JPRB, &
  & 0.14077719E-05_JPRB, 0.14157564E-05_JPRB, 0.14242701E-05_JPRB, 0.14320954E-05_JPRB, 0.14387772E-05_JPRB, 0.14439124E-05_JPRB, &
  & 0.14472060E-05_JPRB, 0.14478742E-05_JPRB, 0.14456504E-05_JPRB, 0.14402070E-05_JPRB, 0.14322495E-05_JPRB, 0.14221192E-05_JPRB, &
  & 0.14098522E-05_JPRB, 0.13961240E-05_JPRB, 0.13810557E-05_JPRB, 0.13650590E-05_JPRB, 0.13482887E-05_JPRB, 0.13308024E-05_JPRB, &
  & 0.13124568E-05_JPRB, 0.12932478E-05_JPRB, 0.12730892E-05_JPRB, 0.12519870E-05_JPRB, 0.12301080E-05_JPRB, 0.12077526E-05_JPRB, &
  & 0.11854281E-05_JPRB, 0.11636715E-05_JPRB, 0.11430790E-05_JPRB, 0.11240808E-05_JPRB, 0.11070586E-05_JPRB, 0.10922382E-05_JPRB, &
  & 0.10799042E-05_JPRB, 0.10684836E-05_JPRB, 0.10582706E-05_JPRB, 0.10374590E-05_JPRB /)

RGHG2(:,23,12) = (/ &
  & 0.97274824E-06_JPRB, 0.99278907E-06_JPRB, 0.10076330E-05_JPRB, 0.10231101E-05_JPRB, 0.10404883E-05_JPRB, 0.10601178E-05_JPRB, &
  & 0.10820605E-05_JPRB, 0.11061355E-05_JPRB, 0.11323625E-05_JPRB, 0.11605240E-05_JPRB, 0.11901673E-05_JPRB, 0.12206556E-05_JPRB, &
  & 0.12513578E-05_JPRB, 0.12817719E-05_JPRB, 0.13114507E-05_JPRB, 0.13399829E-05_JPRB, 0.13669201E-05_JPRB, 0.13918282E-05_JPRB, &
  & 0.14141906E-05_JPRB, 0.14333719E-05_JPRB, 0.14486774E-05_JPRB, 0.14595569E-05_JPRB, 0.14658623E-05_JPRB, 0.14681380E-05_JPRB, &
  & 0.14675117E-05_JPRB, 0.14654765E-05_JPRB, 0.14636075E-05_JPRB, 0.14633156E-05_JPRB, 0.14653532E-05_JPRB, 0.14697887E-05_JPRB, &
  & 0.14761144E-05_JPRB, 0.14832159E-05_JPRB, 0.14899152E-05_JPRB, 0.14956630E-05_JPRB, 0.15001019E-05_JPRB, 0.15028899E-05_JPRB, &
  & 0.15038963E-05_JPRB, 0.15028712E-05_JPRB, 0.14998105E-05_JPRB, 0.14942782E-05_JPRB, 0.14865212E-05_JPRB, 0.14768227E-05_JPRB, &
  & 0.14652475E-05_JPRB, 0.14523639E-05_JPRB, 0.14381870E-05_JPRB, 0.14231712E-05_JPRB, 0.14076107E-05_JPRB, 0.13915737E-05_JPRB, &
  & 0.13750613E-05_JPRB, 0.13579877E-05_JPRB, 0.13403321E-05_JPRB, 0.13220823E-05_JPRB, 0.13033087E-05_JPRB, 0.12842132E-05_JPRB, &
  & 0.12650385E-05_JPRB, 0.12461932E-05_JPRB, 0.12280534E-05_JPRB, 0.12110603E-05_JPRB, 0.11956042E-05_JPRB, 0.11819777E-05_JPRB, &
  & 0.11700906E-05_JPRB, 0.11600323E-05_JPRB, 0.11483583E-05_JPRB, 0.11301053E-05_JPRB /)

RGHG2(:,24,12) = (/ &
  & 0.10225322E-05_JPRB, 0.10423082E-05_JPRB, 0.10567917E-05_JPRB, 0.10716760E-05_JPRB, 0.10882652E-05_JPRB, 0.11070141E-05_JPRB, &
  & 0.11279142E-05_JPRB, 0.11509585E-05_JPRB, 0.11760726E-05_JPRB, 0.12030223E-05_JPRB, 0.12315103E-05_JPRB, 0.12608433E-05_JPRB, &
  & 0.12904176E-05_JPRB, 0.13197199E-05_JPRB, 0.13484104E-05_JPRB, 0.13761908E-05_JPRB, 0.14027219E-05_JPRB, 0.14275889E-05_JPRB, &
  & 0.14503152E-05_JPRB, 0.14703086E-05_JPRB, 0.14869463E-05_JPRB, 0.14997560E-05_JPRB, 0.15086694E-05_JPRB, 0.15141461E-05_JPRB, &
  & 0.15169985E-05_JPRB, 0.15183826E-05_JPRB, 0.15193207E-05_JPRB, 0.15208617E-05_JPRB, 0.15236136E-05_JPRB, 0.15275812E-05_JPRB, &
  & 0.15324493E-05_JPRB, 0.15374530E-05_JPRB, 0.15419602E-05_JPRB, 0.15455311E-05_JPRB, 0.15480122E-05_JPRB, 0.15490948E-05_JPRB, &
  & 0.15487592E-05_JPRB, 0.15468830E-05_JPRB, 0.15431534E-05_JPRB, 0.15375686E-05_JPRB, 0.15303099E-05_JPRB, 0.15212358E-05_JPRB, &
  & 0.15107062E-05_JPRB, 0.14987439E-05_JPRB, 0.14857156E-05_JPRB, 0.14717797E-05_JPRB, 0.14574050E-05_JPRB, 0.14426845E-05_JPRB, &
  & 0.14277380E-05_JPRB, 0.14125008E-05_JPRB, 0.13969518E-05_JPRB, 0.13811060E-05_JPRB, 0.13649499E-05_JPRB, 0.13485738E-05_JPRB, &
  & 0.13321098E-05_JPRB, 0.13157253E-05_JPRB, 0.12997560E-05_JPRB, 0.12844873E-05_JPRB, 0.12703292E-05_JPRB, 0.12575774E-05_JPRB, &
  & 0.12464145E-05_JPRB, 0.12360890E-05_JPRB, 0.12257838E-05_JPRB, 0.12068699E-05_JPRB /)

RGHG2(:,25,12) = (/ &
  & 0.10694824E-05_JPRB, 0.10887151E-05_JPRB, 0.11025496E-05_JPRB, 0.11165996E-05_JPRB, 0.11322093E-05_JPRB, 0.11498072E-05_JPRB, &
  & 0.11695479E-05_JPRB, 0.11913562E-05_JPRB, 0.12151827E-05_JPRB, 0.12408357E-05_JPRB, 0.12679428E-05_JPRB, 0.12959813E-05_JPRB, &
  & 0.13243715E-05_JPRB, 0.13526588E-05_JPRB, 0.13804829E-05_JPRB, 0.14074669E-05_JPRB, 0.14333849E-05_JPRB, 0.14579191E-05_JPRB, &
  & 0.14806435E-05_JPRB, 0.15011401E-05_JPRB, 0.15189480E-05_JPRB, 0.15336493E-05_JPRB, 0.15450634E-05_JPRB, 0.15534127E-05_JPRB, &
  & 0.15592368E-05_JPRB, 0.15632827E-05_JPRB, 0.15663278E-05_JPRB, 0.15689928E-05_JPRB, 0.15716579E-05_JPRB, 0.15745728E-05_JPRB, &
  & 0.15776366E-05_JPRB, 0.15805916E-05_JPRB, 0.15830238E-05_JPRB, 0.15847614E-05_JPRB, 0.15856999E-05_JPRB, 0.15856211E-05_JPRB, &
  & 0.15843417E-05_JPRB, 0.15818300E-05_JPRB, 0.15780057E-05_JPRB, 0.15726781E-05_JPRB, 0.15659285E-05_JPRB, 0.15576837E-05_JPRB, &
  & 0.15481239E-05_JPRB, 0.15372179E-05_JPRB, 0.15252360E-05_JPRB, 0.15123844E-05_JPRB, 0.14990796E-05_JPRB, 0.14855377E-05_JPRB, &
  & 0.14718509E-05_JPRB, 0.14580968E-05_JPRB, 0.14442262E-05_JPRB, 0.14302796E-05_JPRB, 0.14161915E-05_JPRB, 0.14020166E-05_JPRB, &
  & 0.13877540E-05_JPRB, 0.13735316E-05_JPRB, 0.13594519E-05_JPRB, 0.13458198E-05_JPRB, 0.13329038E-05_JPRB, 0.13210373E-05_JPRB, &
  & 0.13103794E-05_JPRB, 0.13005597E-05_JPRB, 0.12900547E-05_JPRB, 0.12712313E-05_JPRB /)

RGHG2(:,26,12) = (/ &
  & 0.11143819E-05_JPRB, 0.11328563E-05_JPRB, 0.11458654E-05_JPRB, 0.11589880E-05_JPRB, 0.11734570E-05_JPRB, 0.11898738E-05_JPRB, &
  & 0.12083298E-05_JPRB, 0.12288099E-05_JPRB, 0.12512202E-05_JPRB, 0.12753618E-05_JPRB, 0.13009068E-05_JPRB, 0.13273515E-05_JPRB, &
  & 0.13542128E-05_JPRB, 0.13810788E-05_JPRB, 0.14076619E-05_JPRB, 0.14336854E-05_JPRB, 0.14588021E-05_JPRB, 0.14827676E-05_JPRB, &
  & 0.15053695E-05_JPRB, 0.15262631E-05_JPRB, 0.15450069E-05_JPRB, 0.15611611E-05_JPRB, 0.15744872E-05_JPRB, 0.15850460E-05_JPRB, &
  & 0.15931518E-05_JPRB, 0.15992219E-05_JPRB, 0.16037421E-05_JPRB, 0.16071119E-05_JPRB, 0.16096742E-05_JPRB, 0.16117405E-05_JPRB, &
  & 0.16134452E-05_JPRB, 0.16147663E-05_JPRB, 0.16155826E-05_JPRB, 0.16159397E-05_JPRB, 0.16157350E-05_JPRB, 0.16148241E-05_JPRB, &
  & 0.16130268E-05_JPRB, 0.16102844E-05_JPRB, 0.16064960E-05_JPRB, 0.16015497E-05_JPRB, 0.15953668E-05_JPRB, 0.15879244E-05_JPRB, &
  & 0.15792433E-05_JPRB, 0.15692985E-05_JPRB, 0.15582478E-05_JPRB, 0.15463415E-05_JPRB, 0.15339435E-05_JPRB, 0.15213483E-05_JPRB, &
  & 0.15086996E-05_JPRB, 0.14960890E-05_JPRB, 0.14835141E-05_JPRB, 0.14710215E-05_JPRB, 0.14585592E-05_JPRB, 0.14461307E-05_JPRB, &
  & 0.14337129E-05_JPRB, 0.14213188E-05_JPRB, 0.14090581E-05_JPRB, 0.13970003E-05_JPRB, 0.13854545E-05_JPRB, 0.13746214E-05_JPRB, &
  & 0.13646170E-05_JPRB, 0.13553527E-05_JPRB, 0.13448184E-05_JPRB, 0.13273367E-05_JPRB /)

RGHG2(:,27,12) = (/ &
  & 0.11578973E-05_JPRB, 0.11755462E-05_JPRB, 0.11876477E-05_JPRB, 0.11997332E-05_JPRB, 0.12131218E-05_JPRB, 0.12282698E-05_JPRB, &
  & 0.12454328E-05_JPRB, 0.12645169E-05_JPRB, 0.12853853E-05_JPRB, 0.13078572E-05_JPRB, 0.13316437E-05_JPRB, 0.13563666E-05_JPRB, &
  & 0.13815240E-05_JPRB, 0.14068135E-05_JPRB, 0.14318890E-05_JPRB, 0.14565798E-05_JPRB, 0.14806910E-05_JPRB, 0.15039925E-05_JPRB, &
  & 0.15262117E-05_JPRB, 0.15470292E-05_JPRB, 0.15660718E-05_JPRB, 0.15829672E-05_JPRB, 0.15974622E-05_JPRB, 0.16094868E-05_JPRB, &
  & 0.16191877E-05_JPRB, 0.16267290E-05_JPRB, 0.16324382E-05_JPRB, 0.16364780E-05_JPRB, 0.16391753E-05_JPRB, 0.16407963E-05_JPRB, &
  & 0.16416705E-05_JPRB, 0.16419177E-05_JPRB, 0.16416525E-05_JPRB, 0.16410663E-05_JPRB, 0.16400842E-05_JPRB, 0.16386310E-05_JPRB, &
  & 0.16365511E-05_JPRB, 0.16337091E-05_JPRB, 0.16300828E-05_JPRB, 0.16255548E-05_JPRB, 0.16199655E-05_JPRB, 0.16132666E-05_JPRB, &
  & 0.16053958E-05_JPRB, 0.15963054E-05_JPRB, 0.15860990E-05_JPRB, 0.15750072E-05_JPRB, 0.15633481E-05_JPRB, 0.15514670E-05_JPRB, &
  & 0.15395561E-05_JPRB, 0.15278124E-05_JPRB, 0.15162544E-05_JPRB, 0.15049029E-05_JPRB, 0.14937264E-05_JPRB, 0.14827078E-05_JPRB, &
  & 0.14718306E-05_JPRB, 0.14610730E-05_JPRB, 0.14504112E-05_JPRB, 0.14399573E-05_JPRB, 0.14298042E-05_JPRB, 0.14202003E-05_JPRB, &
  & 0.14112909E-05_JPRB, 0.14025667E-05_JPRB, 0.13935418E-05_JPRB, 0.13761268E-05_JPRB /)

RGHG2(:,28,12) = (/ &
  & 0.12004349E-05_JPRB, 0.12171145E-05_JPRB, 0.12283640E-05_JPRB, 0.12395423E-05_JPRB, 0.12517870E-05_JPRB, 0.12657903E-05_JPRB, &
  & 0.12816249E-05_JPRB, 0.12992243E-05_JPRB, 0.13184239E-05_JPRB, 0.13390907E-05_JPRB, 0.13609748E-05_JPRB, 0.13838458E-05_JPRB, &
  & 0.14071836E-05_JPRB, 0.14308079E-05_JPRB, 0.14544141E-05_JPRB, 0.14777288E-05_JPRB, 0.15005763E-05_JPRB, 0.15227874E-05_JPRB, &
  & 0.15441557E-05_JPRB, 0.15644050E-05_JPRB, 0.15832203E-05_JPRB, 0.16002755E-05_JPRB, 0.16153059E-05_JPRB, 0.16282005E-05_JPRB, &
  & 0.16389200E-05_JPRB, 0.16475045E-05_JPRB, 0.16541451E-05_JPRB, 0.16588577E-05_JPRB, 0.16618985E-05_JPRB, 0.16634804E-05_JPRB, &
  & 0.16640065E-05_JPRB, 0.16637017E-05_JPRB, 0.16628078E-05_JPRB, 0.16616345E-05_JPRB, 0.16601668E-05_JPRB, 0.16583847E-05_JPRB, &
  & 0.16561735E-05_JPRB, 0.16533889E-05_JPRB, 0.16499794E-05_JPRB, 0.16458440E-05_JPRB, 0.16408053E-05_JPRB, 0.16347619E-05_JPRB, &
  & 0.16276082E-05_JPRB, 0.16192691E-05_JPRB, 0.16097898E-05_JPRB, 0.15993614E-05_JPRB, 0.15882957E-05_JPRB, 0.15769485E-05_JPRB, &
  & 0.15656706E-05_JPRB, 0.15545988E-05_JPRB, 0.15438314E-05_JPRB, 0.15333902E-05_JPRB, 0.15232655E-05_JPRB, 0.15134334E-05_JPRB, &
  & 0.15038318E-05_JPRB, 0.14944321E-05_JPRB, 0.14851987E-05_JPRB, 0.14761131E-05_JPRB, 0.14673365E-05_JPRB, 0.14589696E-05_JPRB, &
  & 0.14511146E-05_JPRB, 0.14436896E-05_JPRB, 0.14349745E-05_JPRB, 0.14203514E-05_JPRB /)

RGHG2(:,29,12) = (/ &
  & 0.12420479E-05_JPRB, 0.12578372E-05_JPRB, 0.12683338E-05_JPRB, 0.12786041E-05_JPRB, 0.12899400E-05_JPRB, 0.13027528E-05_JPRB, &
  & 0.13172880E-05_JPRB, 0.13333629E-05_JPRB, 0.13508087E-05_JPRB, 0.13695148E-05_JPRB, 0.13894394E-05_JPRB, 0.14102594E-05_JPRB, &
  & 0.14317009E-05_JPRB, 0.14535212E-05_JPRB, 0.14754438E-05_JPRB, 0.14972505E-05_JPRB, 0.15187424E-05_JPRB, 0.15397570E-05_JPRB, &
  & 0.15600828E-05_JPRB, 0.15794845E-05_JPRB, 0.15977433E-05_JPRB, 0.16145511E-05_JPRB, 0.16296741E-05_JPRB, 0.16429393E-05_JPRB, &
  & 0.16542340E-05_JPRB, 0.16635192E-05_JPRB, 0.16708279E-05_JPRB, 0.16761494E-05_JPRB, 0.16796138E-05_JPRB, 0.16814042E-05_JPRB, &
  & 0.16819067E-05_JPRB, 0.16814212E-05_JPRB, 0.16802360E-05_JPRB, 0.16787401E-05_JPRB, 0.16770005E-05_JPRB, 0.16750463E-05_JPRB, &
  & 0.16727925E-05_JPRB, 0.16701331E-05_JPRB, 0.16669700E-05_JPRB, 0.16632010E-05_JPRB, 0.16586424E-05_JPRB, 0.16531554E-05_JPRB, &
  & 0.16466034E-05_JPRB, 0.16388884E-05_JPRB, 0.16300091E-05_JPRB, 0.16201242E-05_JPRB, 0.16095289E-05_JPRB, 0.15987057E-05_JPRB, &
  & 0.15879401E-05_JPRB, 0.15774780E-05_JPRB, 0.15674032E-05_JPRB, 0.15577501E-05_JPRB, 0.15485105E-05_JPRB, 0.15396220E-05_JPRB, &
  & 0.15310619E-05_JPRB, 0.15227351E-05_JPRB, 0.15145952E-05_JPRB, 0.15066541E-05_JPRB, 0.14989716E-05_JPRB, 0.14917334E-05_JPRB, &
  & 0.14849779E-05_JPRB, 0.14784046E-05_JPRB, 0.14713887E-05_JPRB, 0.14583102E-05_JPRB /)

RGHG2(:,30,12) = (/ &
  & 0.12827339E-05_JPRB, 0.12976873E-05_JPRB, 0.13074875E-05_JPRB, 0.13170555E-05_JPRB, 0.13274272E-05_JPRB, 0.13392170E-05_JPRB, &
  & 0.13524422E-05_JPRB, 0.13669614E-05_JPRB, 0.13826193E-05_JPRB, 0.13993701E-05_JPRB, 0.14172247E-05_JPRB, 0.14359550E-05_JPRB, &
  & 0.14554198E-05_JPRB, 0.14754045E-05_JPRB, 0.14956612E-05_JPRB, 0.15159715E-05_JPRB, 0.15361302E-05_JPRB, 0.15559162E-05_JPRB, &
  & 0.15751231E-05_JPRB, 0.15935267E-05_JPRB, 0.16109580E-05_JPRB, 0.16272282E-05_JPRB, 0.16420820E-05_JPRB, 0.16553367E-05_JPRB, &
  & 0.16668132E-05_JPRB, 0.16764286E-05_JPRB, 0.16841396E-05_JPRB, 0.16898996E-05_JPRB, 0.16937595E-05_JPRB, 0.16958513E-05_JPRB, &
  & 0.16965027E-05_JPRB, 0.16960586E-05_JPRB, 0.16948163E-05_JPRB, 0.16931846E-05_JPRB, 0.16913327E-05_JPRB, 0.16893066E-05_JPRB, &
  & 0.16870733E-05_JPRB, 0.16845529E-05_JPRB, 0.16816351E-05_JPRB, 0.16781938E-05_JPRB, 0.16740352E-05_JPRB, 0.16689968E-05_JPRB, &
  & 0.16629331E-05_JPRB, 0.16557231E-05_JPRB, 0.16473500E-05_JPRB, 0.16379449E-05_JPRB, 0.16278628E-05_JPRB, 0.16174984E-05_JPRB, &
  & 0.16072494E-05_JPRB, 0.15973226E-05_JPRB, 0.15878750E-05_JPRB, 0.15789068E-05_JPRB, 0.15703806E-05_JPRB, 0.15622543E-05_JPRB, &
  & 0.15544503E-05_JPRB, 0.15469229E-05_JPRB, 0.15395990E-05_JPRB, 0.15324757E-05_JPRB, 0.15256794E-05_JPRB, 0.15193118E-05_JPRB, &
  & 0.15134594E-05_JPRB, 0.15078936E-05_JPRB, 0.15016228E-05_JPRB, 0.14906951E-05_JPRB /)

RGHG2(:,31,12) = (/ &
  & 0.13224521E-05_JPRB, 0.13365720E-05_JPRB, 0.13457467E-05_JPRB, 0.13545612E-05_JPRB, 0.13641427E-05_JPRB, 0.13748712E-05_JPRB, &
  & 0.13868527E-05_JPRB, 0.13998861E-05_JPRB, 0.14138058E-05_JPRB, 0.14286206E-05_JPRB, 0.14444267E-05_JPRB, 0.14610628E-05_JPRB, &
  & 0.14785589E-05_JPRB, 0.14967028E-05_JPRB, 0.15152820E-05_JPRB, 0.15341152E-05_JPRB, 0.15529764E-05_JPRB, 0.15716000E-05_JPRB, &
  & 0.15897474E-05_JPRB, 0.16071868E-05_JPRB, 0.16237456E-05_JPRB, 0.16392995E-05_JPRB, 0.16536336E-05_JPRB, 0.16665666E-05_JPRB, &
  & 0.16778731E-05_JPRB, 0.16874427E-05_JPRB, 0.16952488E-05_JPRB, 0.17012321E-05_JPRB, 0.17053723E-05_JPRB, 0.17077410E-05_JPRB, &
  & 0.17086095E-05_JPRB, 0.17083242E-05_JPRB, 0.17071770E-05_JPRB, 0.17055542E-05_JPRB, 0.17037009E-05_JPRB, 0.17016836E-05_JPRB, &
  & 0.16995089E-05_JPRB, 0.16971334E-05_JPRB, 0.16944327E-05_JPRB, 0.16912577E-05_JPRB, 0.16874149E-05_JPRB, 0.16827291E-05_JPRB, &
  & 0.16770366E-05_JPRB, 0.16702353E-05_JPRB, 0.16622963E-05_JPRB, 0.16533654E-05_JPRB, 0.16437649E-05_JPRB, 0.16339203E-05_JPRB, &
  & 0.16241572E-05_JPRB, 0.16147907E-05_JPRB, 0.16058898E-05_JPRB, 0.15974739E-05_JPRB, 0.15895148E-05_JPRB, 0.15819586E-05_JPRB, &
  & 0.15747565E-05_JPRB, 0.15677971E-05_JPRB, 0.15610473E-05_JPRB, 0.15545364E-05_JPRB, 0.15483674E-05_JPRB, 0.15427053E-05_JPRB, &
  & 0.15375294E-05_JPRB, 0.15326456E-05_JPRB, 0.15273081E-05_JPRB, 0.15178714E-05_JPRB /)

RGHG2(:,32,12) = (/ &
  & 0.13610627E-05_JPRB, 0.13742598E-05_JPRB, 0.13827475E-05_JPRB, 0.13908784E-05_JPRB, 0.13996165E-05_JPRB, 0.14093908E-05_JPRB, &
  & 0.14201963E-05_JPRB, 0.14318216E-05_JPRB, 0.14441347E-05_JPRB, 0.14571398E-05_JPRB, 0.14709435E-05_JPRB, 0.14855852E-05_JPRB, &
  & 0.15011645E-05_JPRB, 0.15175890E-05_JPRB, 0.15346783E-05_JPRB, 0.15521891E-05_JPRB, 0.15698688E-05_JPRB, 0.15873993E-05_JPRB, &
  & 0.16045028E-05_JPRB, 0.16209569E-05_JPRB, 0.16366262E-05_JPRB, 0.16513630E-05_JPRB, 0.16649946E-05_JPRB, 0.16772950E-05_JPRB, &
  & 0.16881038E-05_JPRB, 0.16973274E-05_JPRB, 0.17049416E-05_JPRB, 0.17109024E-05_JPRB, 0.17151499E-05_JPRB, 0.17177214E-05_JPRB, &
  & 0.17188074E-05_JPRB, 0.17187339E-05_JPRB, 0.17177787E-05_JPRB, 0.17162765E-05_JPRB, 0.17145060E-05_JPRB, 0.17125568E-05_JPRB, &
  & 0.17104826E-05_JPRB, 0.17082500E-05_JPRB, 0.17057320E-05_JPRB, 0.17027617E-05_JPRB, 0.16991551E-05_JPRB, 0.16947181E-05_JPRB, &
  & 0.16893127E-05_JPRB, 0.16828293E-05_JPRB, 0.16752620E-05_JPRB, 0.16667823E-05_JPRB, 0.16576934E-05_JPRB, 0.16482999E-05_JPRB, &
  & 0.16390669E-05_JPRB, 0.16301838E-05_JPRB, 0.16218019E-05_JPRB, 0.16139051E-05_JPRB, 0.16064346E-05_JPRB, 0.15993625E-05_JPRB, &
  & 0.15925755E-05_JPRB, 0.15860380E-05_JPRB, 0.15797124E-05_JPRB, 0.15736431E-05_JPRB, 0.15679723E-05_JPRB, 0.15628004E-05_JPRB, &
  & 0.15581776E-05_JPRB, 0.15538050E-05_JPRB, 0.15490692E-05_JPRB, 0.15407239E-05_JPRB /)

RGHG2(:,33,12) = (/ &
  & 0.13982855E-05_JPRB, 0.14104261E-05_JPRB, 0.14181561E-05_JPRB, 0.14255611E-05_JPRB, 0.14335048E-05_JPRB, 0.14423618E-05_JPRB, &
  & 0.14520894E-05_JPRB, 0.14624712E-05_JPRB, 0.14733108E-05_JPRB, 0.14846464E-05_JPRB, 0.14965872E-05_JPRB, 0.15093337E-05_JPRB, &
  & 0.15230730E-05_JPRB, 0.15378498E-05_JPRB, 0.15535636E-05_JPRB, 0.15699414E-05_JPRB, 0.15866378E-05_JPRB, 0.16032508E-05_JPRB, &
  & 0.16194308E-05_JPRB, 0.16349902E-05_JPRB, 0.16497693E-05_JPRB, 0.16636230E-05_JPRB, 0.16763844E-05_JPRB, 0.16878888E-05_JPRB, &
  & 0.16979500E-05_JPRB, 0.17065315E-05_JPRB, 0.17136816E-05_JPRB, 0.17193743E-05_JPRB, 0.17235548E-05_JPRB, 0.17262106E-05_JPRB, &
  & 0.17274815E-05_JPRB, 0.17276382E-05_JPRB, 0.17269385E-05_JPRB, 0.17256392E-05_JPRB, 0.17240288E-05_JPRB, 0.17222150E-05_JPRB, &
  & 0.17202819E-05_JPRB, 0.17181941E-05_JPRB, 0.17158249E-05_JPRB, 0.17130174E-05_JPRB, 0.17095697E-05_JPRB, 0.17053051E-05_JPRB, &
  & 0.17000974E-05_JPRB, 0.16938458E-05_JPRB, 0.16865994E-05_JPRB, 0.16785367E-05_JPRB, 0.16698673E-05_JPRB, 0.16610194E-05_JPRB, &
  & 0.16522865E-05_JPRB, 0.16439622E-05_JPRB, 0.16360494E-05_JPRB, 0.16285693E-05_JPRB, 0.16215071E-05_JPRB, 0.16147923E-05_JPRB, &
  & 0.16083765E-05_JPRB, 0.16021768E-05_JPRB, 0.15961920E-05_JPRB, 0.15904781E-05_JPRB, 0.15851632E-05_JPRB, 0.15803952E-05_JPRB, &
  & 0.15761021E-05_JPRB, 0.15721407E-05_JPRB, 0.15677750E-05_JPRB, 0.15603329E-05_JPRB /)

RGHG2(:,34,12) = (/ &
  & 0.14337503E-05_JPRB, 0.14446283E-05_JPRB, 0.14516163E-05_JPRB, 0.14582496E-05_JPRB, 0.14654487E-05_JPRB, 0.14734518E-05_JPRB, &
  & 0.14822322E-05_JPRB, 0.14914860E-05_JPRB, 0.15010303E-05_JPRB, 0.15108470E-05_JPRB, 0.15210865E-05_JPRB, 0.15320661E-05_JPRB, &
  & 0.15440760E-05_JPRB, 0.15572984E-05_JPRB, 0.15717310E-05_JPRB, 0.15870877E-05_JPRB, 0.16029026E-05_JPRB, 0.16187571E-05_JPRB, &
  & 0.16342366E-05_JPRB, 0.16490611E-05_JPRB, 0.16630080E-05_JPRB, 0.16759585E-05_JPRB, 0.16878020E-05_JPRB, 0.16983630E-05_JPRB, &
  & 0.17075024E-05_JPRB, 0.17152486E-05_JPRB, 0.17217073E-05_JPRB, 0.17269151E-05_JPRB, 0.17308445E-05_JPRB, 0.17334650E-05_JPRB, &
  & 0.17348545E-05_JPRB, 0.17352397E-05_JPRB, 0.17348298E-05_JPRB, 0.17337999E-05_JPRB, 0.17324320E-05_JPRB, 0.17308354E-05_JPRB, &
  & 0.17290837E-05_JPRB, 0.17271576E-05_JPRB, 0.17249350E-05_JPRB, 0.17222521E-05_JPRB, 0.17189150E-05_JPRB, 0.17147614E-05_JPRB, &
  & 0.17096604E-05_JPRB, 0.17035809E-05_JPRB, 0.16965848E-05_JPRB, 0.16888443E-05_JPRB, 0.16806468E-05_JPRB, 0.16722757E-05_JPRB, &
  & 0.16640981E-05_JPRB, 0.16562035E-05_JPRB, 0.16487171E-05_JPRB, 0.16416554E-05_JPRB, 0.16349672E-05_JPRB, 0.16286112E-05_JPRB, &
  & 0.16224832E-05_JPRB, 0.16165732E-05_JPRB, 0.16108589E-05_JPRB, 0.16054271E-05_JPRB, 0.16004200E-05_JPRB, 0.15959081E-05_JPRB, &
  & 0.15919341E-05_JPRB, 0.15881837E-05_JPRB, 0.15842089E-05_JPRB, 0.15772648E-05_JPRB /)

RGHG2(:,35,12) = (/ &
  & 0.14670831E-05_JPRB, 0.14767231E-05_JPRB, 0.14828173E-05_JPRB, 0.14887615E-05_JPRB, 0.14951887E-05_JPRB, 0.15024475E-05_JPRB, &
  & 0.15103598E-05_JPRB, 0.15186365E-05_JPRB, 0.15270089E-05_JPRB, 0.15354644E-05_JPRB, 0.15441849E-05_JPRB, 0.15535326E-05_JPRB, &
  & 0.15639444E-05_JPRB, 0.15757212E-05_JPRB, 0.15889765E-05_JPRB, 0.16034360E-05_JPRB, 0.16185863E-05_JPRB, 0.16338220E-05_JPRB, &
  & 0.16487193E-05_JPRB, 0.16628927E-05_JPRB, 0.16761051E-05_JPRB, 0.16882204E-05_JPRB, 0.16991089E-05_JPRB, 0.17086137E-05_JPRB, &
  & 0.17167023E-05_JPRB, 0.17234523E-05_JPRB, 0.17290438E-05_JPRB, 0.17335810E-05_JPRB, 0.17370709E-05_JPRB, 0.17395084E-05_JPRB, &
  & 0.17409207E-05_JPRB, 0.17415028E-05_JPRB, 0.17413793E-05_JPRB, 0.17406715E-05_JPRB, 0.17396325E-05_JPRB, 0.17383184E-05_JPRB, &
  & 0.17368161E-05_JPRB, 0.17351042E-05_JPRB, 0.17330558E-05_JPRB, 0.17305167E-05_JPRB, 0.17272998E-05_JPRB, 0.17232219E-05_JPRB, &
  & 0.17182074E-05_JPRB, 0.17122402E-05_JPRB, 0.17054394E-05_JPRB, 0.16980212E-05_JPRB, 0.16902070E-05_JPRB, 0.16823469E-05_JPRB, &
  & 0.16745879E-05_JPRB, 0.16671636E-05_JPRB, 0.16600980E-05_JPRB, 0.16533868E-05_JPRB, 0.16470141E-05_JPRB, 0.16409060E-05_JPRB, &
  & 0.16350564E-05_JPRB, 0.16293874E-05_JPRB, 0.16239318E-05_JPRB, 0.16187453E-05_JPRB, 0.16139667E-05_JPRB, 0.16097107E-05_JPRB, &
  & 0.16059130E-05_JPRB, 0.16024354E-05_JPRB, 0.15986342E-05_JPRB, 0.15922236E-05_JPRB /)

RGHG2(:,36,12) = (/ &
  & 0.14981654E-05_JPRB, 0.15064113E-05_JPRB, 0.15117664E-05_JPRB, 0.15169405E-05_JPRB, 0.15227187E-05_JPRB, 0.15292427E-05_JPRB, &
  & 0.15363969E-05_JPRB, 0.15437752E-05_JPRB, 0.15511076E-05_JPRB, 0.15583455E-05_JPRB, 0.15657016E-05_JPRB, 0.15735829E-05_JPRB, &
  & 0.15825090E-05_JPRB, 0.15929289E-05_JPRB, 0.16050836E-05_JPRB, 0.16187132E-05_JPRB, 0.16332946E-05_JPRB, 0.16480980E-05_JPRB, &
  & 0.16625291E-05_JPRB, 0.16762036E-05_JPRB, 0.16887948E-05_JPRB, 0.17001300E-05_JPRB, 0.17100183E-05_JPRB, 0.17183966E-05_JPRB, &
  & 0.17252796E-05_JPRB, 0.17308910E-05_JPRB, 0.17354595E-05_JPRB, 0.17391476E-05_JPRB, 0.17420474E-05_JPRB, 0.17441438E-05_JPRB, &
  & 0.17454748E-05_JPRB, 0.17461796E-05_JPRB, 0.17462846E-05_JPRB, 0.17459158E-05_JPRB, 0.17452187E-05_JPRB, 0.17442300E-05_JPRB, &
  & 0.17430439E-05_JPRB, 0.17416030E-05_JPRB, 0.17398161E-05_JPRB, 0.17375293E-05_JPRB, 0.17345271E-05_JPRB, 0.17306463E-05_JPRB, &
  & 0.17257809E-05_JPRB, 0.17199580E-05_JPRB, 0.17133525E-05_JPRB, 0.17061739E-05_JPRB, 0.16987507E-05_JPRB, 0.16912632E-05_JPRB, &
  & 0.16839767E-05_JPRB, 0.16769482E-05_JPRB, 0.16702166E-05_JPRB, 0.16638020E-05_JPRB, 0.16576720E-05_JPRB, 0.16518368E-05_JPRB, &
  & 0.16462201E-05_JPRB, 0.16408086E-05_JPRB, 0.16355773E-05_JPRB, 0.16306210E-05_JPRB, 0.16260578E-05_JPRB, 0.16219795E-05_JPRB, &
  & 0.16183994E-05_JPRB, 0.16150723E-05_JPRB, 0.16115491E-05_JPRB, 0.16055041E-05_JPRB /)

RGHG2(:,37,12) = (/ &
  & 0.15268810E-05_JPRB, 0.15338835E-05_JPRB, 0.15384005E-05_JPRB, 0.15429341E-05_JPRB, 0.15480347E-05_JPRB, 0.15539227E-05_JPRB, &
  & 0.15603534E-05_JPRB, 0.15669211E-05_JPRB, 0.15733052E-05_JPRB, 0.15794569E-05_JPRB, 0.15856175E-05_JPRB, 0.15921876E-05_JPRB, &
  & 0.15997541E-05_JPRB, 0.16088866E-05_JPRB, 0.16199544E-05_JPRB, 0.16328328E-05_JPRB, 0.16468553E-05_JPRB, 0.16613261E-05_JPRB, &
  & 0.16754599E-05_JPRB, 0.16887124E-05_JPRB, 0.17007130E-05_JPRB, 0.17111614E-05_JPRB, 0.17199163E-05_JPRB, 0.17269805E-05_JPRB, &
  & 0.17325635E-05_JPRB, 0.17369455E-05_JPRB, 0.17404460E-05_JPRB, 0.17432753E-05_JPRB, 0.17455418E-05_JPRB, 0.17472712E-05_JPRB, &
  & 0.17484642E-05_JPRB, 0.17492112E-05_JPRB, 0.17494657E-05_JPRB, 0.17493657E-05_JPRB, 0.17489374E-05_JPRB, 0.17482608E-05_JPRB, &
  & 0.17473695E-05_JPRB, 0.17462332E-05_JPRB, 0.17447810E-05_JPRB, 0.17428526E-05_JPRB, 0.17402576E-05_JPRB, 0.17367729E-05_JPRB, &
  & 0.17322685E-05_JPRB, 0.17267400E-05_JPRB, 0.17203510E-05_JPRB, 0.17134550E-05_JPRB, 0.17063198E-05_JPRB, 0.16992369E-05_JPRB, &
  & 0.16923100E-05_JPRB, 0.16856170E-05_JPRB, 0.16791798E-05_JPRB, 0.16730053E-05_JPRB, 0.16671263E-05_JPRB, 0.16615088E-05_JPRB, &
  & 0.16561524E-05_JPRB, 0.16509973E-05_JPRB, 0.16460361E-05_JPRB, 0.16413088E-05_JPRB, 0.16369459E-05_JPRB, 0.16330546E-05_JPRB, &
  & 0.16296271E-05_JPRB, 0.16264999E-05_JPRB, 0.16231533E-05_JPRB, 0.16174839E-05_JPRB /)

RGHG2(:,38,12) = (/ &
  & 0.15531375E-05_JPRB, 0.15589460E-05_JPRB, 0.15627915E-05_JPRB, 0.15667026E-05_JPRB, 0.15712162E-05_JPRB, 0.15764972E-05_JPRB, &
  & 0.15822625E-05_JPRB, 0.15880721E-05_JPRB, 0.15935962E-05_JPRB, 0.15988131E-05_JPRB, 0.16039216E-05_JPRB, 0.16093967E-05_JPRB, &
  & 0.16157210E-05_JPRB, 0.16236671E-05_JPRB, 0.16336596E-05_JPRB, 0.16458101E-05_JPRB, 0.16594123E-05_JPRB, 0.16735115E-05_JPRB, &
  & 0.16872725E-05_JPRB, 0.17000423E-05_JPRB, 0.17112291E-05_JPRB, 0.17205377E-05_JPRB, 0.17278985E-05_JPRB, 0.17335581E-05_JPRB, &
  & 0.17378475E-05_JPRB, 0.17411569E-05_JPRB, 0.17437860E-05_JPRB, 0.17459420E-05_JPRB, 0.17477367E-05_JPRB, 0.17491714E-05_JPRB, &
  & 0.17502670E-05_JPRB, 0.17509979E-05_JPRB, 0.17513594E-05_JPRB, 0.17514075E-05_JPRB, 0.17511675E-05_JPRB, 0.17507082E-05_JPRB, &
  & 0.17500408E-05_JPRB, 0.17491618E-05_JPRB, 0.17480072E-05_JPRB, 0.17464556E-05_JPRB, 0.17443209E-05_JPRB, 0.17413789E-05_JPRB, &
  & 0.17374236E-05_JPRB, 0.17323732E-05_JPRB, 0.17263943E-05_JPRB, 0.17198061E-05_JPRB, 0.17130216E-05_JPRB, 0.17062616E-05_JPRB, &
  & 0.16996690E-05_JPRB, 0.16932842E-05_JPRB, 0.16870946E-05_JPRB, 0.16811467E-05_JPRB, 0.16754652E-05_JPRB, 0.16700926E-05_JPRB, &
  & 0.16650131E-05_JPRB, 0.16601766E-05_JPRB, 0.16555241E-05_JPRB, 0.16510722E-05_JPRB, 0.16469206E-05_JPRB, 0.16431990E-05_JPRB, &
  & 0.16399300E-05_JPRB, 0.16369488E-05_JPRB, 0.16337956E-05_JPRB, 0.16284386E-05_JPRB /)

RGHG2(:,39,12) = (/ &
  & 0.15767855E-05_JPRB, 0.15815970E-05_JPRB, 0.15848437E-05_JPRB, 0.15882176E-05_JPRB, 0.15922481E-05_JPRB, 0.15969670E-05_JPRB, &
  & 0.16021231E-05_JPRB, 0.16072238E-05_JPRB, 0.16119969E-05_JPRB, 0.16163858E-05_JPRB, 0.16206823E-05_JPRB, 0.16251787E-05_JPRB, &
  & 0.16305432E-05_JPRB, 0.16373050E-05_JPRB, 0.16463274E-05_JPRB, 0.16576064E-05_JPRB, 0.16706845E-05_JPRB, 0.16844240E-05_JPRB, &
  & 0.16977085E-05_JPRB, 0.17096429E-05_JPRB, 0.17196998E-05_JPRB, 0.17275888E-05_JPRB, 0.17335374E-05_JPRB, 0.17379430E-05_JPRB, &
  & 0.17412498E-05_JPRB, 0.17437973E-05_JPRB, 0.17458549E-05_JPRB, 0.17475871E-05_JPRB, 0.17490801E-05_JPRB, 0.17503380E-05_JPRB, &
  & 0.17513612E-05_JPRB, 0.17520769E-05_JPRB, 0.17525039E-05_JPRB, 0.17526287E-05_JPRB, 0.17525103E-05_JPRB, 0.17521804E-05_JPRB, &
  & 0.17516679E-05_JPRB, 0.17509695E-05_JPRB, 0.17500362E-05_JPRB, 0.17487773E-05_JPRB, 0.17470319E-05_JPRB, 0.17445834E-05_JPRB, &
  & 0.17412203E-05_JPRB, 0.17367929E-05_JPRB, 0.17313582E-05_JPRB, 0.17252528E-05_JPRB, 0.17188236E-05_JPRB, 0.17124116E-05_JPRB, &
  & 0.17061338E-05_JPRB, 0.16999977E-05_JPRB, 0.16940378E-05_JPRB, 0.16882781E-05_JPRB, 0.16828074E-05_JPRB, 0.16777180E-05_JPRB, &
  & 0.16729566E-05_JPRB, 0.16685052E-05_JPRB, 0.16642118E-05_JPRB, 0.16600876E-05_JPRB, 0.16561798E-05_JPRB, 0.16526521E-05_JPRB, &
  & 0.16495363E-05_JPRB, 0.16467096E-05_JPRB, 0.16437102E-05_JPRB, 0.16386327E-05_JPRB /)

RGHG2(:,40,12) = (/ &
  & 0.15976862E-05_JPRB, 0.16017289E-05_JPRB, 0.16044974E-05_JPRB, 0.16074932E-05_JPRB, 0.16110702E-05_JPRB, 0.16153629E-05_JPRB, &
  & 0.16199459E-05_JPRB, 0.16244227E-05_JPRB, 0.16285194E-05_JPRB, 0.16322813E-05_JPRB, 0.16358454E-05_JPRB, 0.16396868E-05_JPRB, &
  & 0.16441288E-05_JPRB, 0.16500379E-05_JPRB, 0.16579702E-05_JPRB, 0.16685239E-05_JPRB, 0.16809262E-05_JPRB, 0.16940392E-05_JPRB, &
  & 0.17065468E-05_JPRB, 0.17174003E-05_JPRB, 0.17260257E-05_JPRB, 0.17325267E-05_JPRB, 0.17372702E-05_JPRB, 0.17407664E-05_JPRB, &
  & 0.17433949E-05_JPRB, 0.17454644E-05_JPRB, 0.17471705E-05_JPRB, 0.17486491E-05_JPRB, 0.17499610E-05_JPRB, 0.17511156E-05_JPRB, &
  & 0.17520817E-05_JPRB, 0.17527972E-05_JPRB, 0.17532486E-05_JPRB, 0.17534259E-05_JPRB, 0.17533748E-05_JPRB, 0.17531263E-05_JPRB, &
  & 0.17527163E-05_JPRB, 0.17521387E-05_JPRB, 0.17513651E-05_JPRB, 0.17503171E-05_JPRB, 0.17488622E-05_JPRB, 0.17468175E-05_JPRB, &
  & 0.17439755E-05_JPRB, 0.17401610E-05_JPRB, 0.17353645E-05_JPRB, 0.17297714E-05_JPRB, 0.17238200E-05_JPRB, 0.17177738E-05_JPRB, &
  & 0.17117942E-05_JPRB, 0.17059268E-05_JPRB, 0.17001612E-05_JPRB, 0.16945745E-05_JPRB, 0.16893418E-05_JPRB, 0.16845042E-05_JPRB, &
  & 0.16801382E-05_JPRB, 0.16760590E-05_JPRB, 0.16721997E-05_JPRB, 0.16684370E-05_JPRB, 0.16648446E-05_JPRB, 0.16615456E-05_JPRB, &
  & 0.16586231E-05_JPRB, 0.16559501E-05_JPRB, 0.16531293E-05_JPRB, 0.16482966E-05_JPRB /)

RGHG2(:,41,12) = (/ &
  & 0.16159968E-05_JPRB, 0.16194622E-05_JPRB, 0.16219014E-05_JPRB, 0.16245569E-05_JPRB, 0.16278830E-05_JPRB, 0.16317698E-05_JPRB, &
  & 0.16358921E-05_JPRB, 0.16398060E-05_JPRB, 0.16433662E-05_JPRB, 0.16465603E-05_JPRB, 0.16496562E-05_JPRB, 0.16528489E-05_JPRB, &
  & 0.16567421E-05_JPRB, 0.16617396E-05_JPRB, 0.16688633E-05_JPRB, 0.16784238E-05_JPRB, 0.16901167E-05_JPRB, 0.17023973E-05_JPRB, &
  & 0.17138653E-05_JPRB, 0.17234089E-05_JPRB, 0.17307068E-05_JPRB, 0.17359973E-05_JPRB, 0.17398283E-05_JPRB, 0.17426612E-05_JPRB, &
  & 0.17448415E-05_JPRB, 0.17465957E-05_JPRB, 0.17480837E-05_JPRB, 0.17494059E-05_JPRB, 0.17506031E-05_JPRB, 0.17516983E-05_JPRB, &
  & 0.17526158E-05_JPRB, 0.17533354E-05_JPRB, 0.17537923E-05_JPRB, 0.17540032E-05_JPRB, 0.17539896E-05_JPRB, 0.17537956E-05_JPRB, &
  & 0.17534517E-05_JPRB, 0.17529613E-05_JPRB, 0.17523020E-05_JPRB, 0.17514111E-05_JPRB, 0.17501806E-05_JPRB, 0.17484554E-05_JPRB, &
  & 0.17460477E-05_JPRB, 0.17427734E-05_JPRB, 0.17385560E-05_JPRB, 0.17335715E-05_JPRB, 0.17280923E-05_JPRB, 0.17224611E-05_JPRB, &
  & 0.17168188E-05_JPRB, 0.17111927E-05_JPRB, 0.17056093E-05_JPRB, 0.17002221E-05_JPRB, 0.16951467E-05_JPRB, 0.16906591E-05_JPRB, &
  & 0.16866159E-05_JPRB, 0.16829907E-05_JPRB, 0.16795401E-05_JPRB, 0.16762044E-05_JPRB, 0.16729713E-05_JPRB, 0.16699812E-05_JPRB, &
  & 0.16673066E-05_JPRB, 0.16648487E-05_JPRB, 0.16622150E-05_JPRB, 0.16576894E-05_JPRB /)

RGHG2(:,42,12) = (/ &
  & 0.16320253E-05_JPRB, 0.16351067E-05_JPRB, 0.16373003E-05_JPRB, 0.16397896E-05_JPRB, 0.16428637E-05_JPRB, 0.16465124E-05_JPRB, &
  & 0.16502200E-05_JPRB, 0.16536806E-05_JPRB, 0.16567706E-05_JPRB, 0.16595696E-05_JPRB, 0.16622100E-05_JPRB, 0.16650331E-05_JPRB, &
  & 0.16683049E-05_JPRB, 0.16727579E-05_JPRB, 0.16789526E-05_JPRB, 0.16877235E-05_JPRB, 0.16985050E-05_JPRB, 0.17098101E-05_JPRB, &
  & 0.17200070E-05_JPRB, 0.17282016E-05_JPRB, 0.17342350E-05_JPRB, 0.17385561E-05_JPRB, 0.17416770E-05_JPRB, 0.17440340E-05_JPRB, &
  & 0.17458926E-05_JPRB, 0.17474354E-05_JPRB, 0.17487778E-05_JPRB, 0.17499998E-05_JPRB, 0.17511286E-05_JPRB, 0.17521776E-05_JPRB, &
  & 0.17530667E-05_JPRB, 0.17537758E-05_JPRB, 0.17542366E-05_JPRB, 0.17544630E-05_JPRB, 0.17544719E-05_JPRB, 0.17543118E-05_JPRB, &
  & 0.17540133E-05_JPRB, 0.17535867E-05_JPRB, 0.17530142E-05_JPRB, 0.17522459E-05_JPRB, 0.17511929E-05_JPRB, 0.17497241E-05_JPRB, &
  & 0.17476740E-05_JPRB, 0.17448674E-05_JPRB, 0.17412119E-05_JPRB, 0.17367690E-05_JPRB, 0.17318205E-05_JPRB, 0.17266177E-05_JPRB, &
  & 0.17213273E-05_JPRB, 0.17159737E-05_JPRB, 0.17106105E-05_JPRB, 0.17053377E-05_JPRB, 0.17005356E-05_JPRB, 0.16962798E-05_JPRB, &
  & 0.16926563E-05_JPRB, 0.16894119E-05_JPRB, 0.16864105E-05_JPRB, 0.16834944E-05_JPRB, 0.16806819E-05_JPRB, 0.16780617E-05_JPRB, &
  & 0.16757079E-05_JPRB, 0.16735207E-05_JPRB, 0.16711529E-05_JPRB, 0.16670076E-05_JPRB /)

RGHG2(:,43,12) = (/ &
  & 0.16462267E-05_JPRB, 0.16490757E-05_JPRB, 0.16511212E-05_JPRB, 0.16534592E-05_JPRB, 0.16564461E-05_JPRB, 0.16598619E-05_JPRB, &
  & 0.16632659E-05_JPRB, 0.16663457E-05_JPRB, 0.16690843E-05_JPRB, 0.16715321E-05_JPRB, 0.16738758E-05_JPRB, 0.16763003E-05_JPRB, &
  & 0.16792094E-05_JPRB, 0.16829833E-05_JPRB, 0.16885244E-05_JPRB, 0.16962846E-05_JPRB, 0.17061592E-05_JPRB, 0.17164041E-05_JPRB, &
  & 0.17252947E-05_JPRB, 0.17321188E-05_JPRB, 0.17370256E-05_JPRB, 0.17405254E-05_JPRB, 0.17430973E-05_JPRB, 0.17450893E-05_JPRB, &
  & 0.17467107E-05_JPRB, 0.17481038E-05_JPRB, 0.17493470E-05_JPRB, 0.17505049E-05_JPRB, 0.17515964E-05_JPRB, 0.17526060E-05_JPRB, &
  & 0.17534787E-05_JPRB, 0.17541676E-05_JPRB, 0.17546282E-05_JPRB, 0.17548580E-05_JPRB, 0.17548793E-05_JPRB, 0.17547389E-05_JPRB, &
  & 0.17544721E-05_JPRB, 0.17540931E-05_JPRB, 0.17535890E-05_JPRB, 0.17529201E-05_JPRB, 0.17520148E-05_JPRB, 0.17507634E-05_JPRB, &
  & 0.17490258E-05_JPRB, 0.17466366E-05_JPRB, 0.17434735E-05_JPRB, 0.17395651E-05_JPRB, 0.17351044E-05_JPRB, 0.17303583E-05_JPRB, &
  & 0.17254517E-05_JPRB, 0.17204121E-05_JPRB, 0.17152529E-05_JPRB, 0.17102303E-05_JPRB, 0.17056159E-05_JPRB, 0.17017074E-05_JPRB, &
  & 0.16984258E-05_JPRB, 0.16955895E-05_JPRB, 0.16929865E-05_JPRB, 0.16904980E-05_JPRB, 0.16881130E-05_JPRB, 0.16859055E-05_JPRB, &
  & 0.16839242E-05_JPRB, 0.16820682E-05_JPRB, 0.16800241E-05_JPRB, 0.16763939E-05_JPRB /)

RGHG2(:,44,12) = (/ &
  & 0.16590770E-05_JPRB, 0.16617639E-05_JPRB, 0.16637307E-05_JPRB, 0.16660008E-05_JPRB, 0.16688867E-05_JPRB, 0.16721694E-05_JPRB, &
  & 0.16753178E-05_JPRB, 0.16781238E-05_JPRB, 0.16805769E-05_JPRB, 0.16827694E-05_JPRB, 0.16848312E-05_JPRB, 0.16869800E-05_JPRB, &
  & 0.16894617E-05_JPRB, 0.16927841E-05_JPRB, 0.16975066E-05_JPRB, 0.17044798E-05_JPRB, 0.17132533E-05_JPRB, 0.17222511E-05_JPRB, &
  & 0.17297966E-05_JPRB, 0.17353517E-05_JPRB, 0.17392778E-05_JPRB, 0.17420989E-05_JPRB, 0.17442313E-05_JPRB, 0.17459366E-05_JPRB, &
  & 0.17473787E-05_JPRB, 0.17486606E-05_JPRB, 0.17498432E-05_JPRB, 0.17509583E-05_JPRB, 0.17520335E-05_JPRB, 0.17530158E-05_JPRB, &
  & 0.17538691E-05_JPRB, 0.17545390E-05_JPRB, 0.17549908E-05_JPRB, 0.17552175E-05_JPRB, 0.17552420E-05_JPRB, 0.17551116E-05_JPRB, &
  & 0.17548655E-05_JPRB, 0.17545218E-05_JPRB, 0.17540724E-05_JPRB, 0.17534870E-05_JPRB, 0.17527075E-05_JPRB, 0.17516472E-05_JPRB, &
  & 0.17501852E-05_JPRB, 0.17481721E-05_JPRB, 0.17454722E-05_JPRB, 0.17420588E-05_JPRB, 0.17380928E-05_JPRB, 0.17337917E-05_JPRB, &
  & 0.17292866E-05_JPRB, 0.17245862E-05_JPRB, 0.17197501E-05_JPRB, 0.17149675E-05_JPRB, 0.17106685E-05_JPRB, 0.17071006E-05_JPRB, &
  & 0.17041743E-05_JPRB, 0.17017109E-05_JPRB, 0.16994804E-05_JPRB, 0.16973843E-05_JPRB, 0.16954095E-05_JPRB, 0.16936107E-05_JPRB, &
  & 0.16920095E-05_JPRB, 0.16905033E-05_JPRB, 0.16888271E-05_JPRB, 0.16858047E-05_JPRB /)

RGHG2(:,45,12) = (/ &
  & 0.16708972E-05_JPRB, 0.16735532E-05_JPRB, 0.16754399E-05_JPRB, 0.16776689E-05_JPRB, 0.16804839E-05_JPRB, 0.16836464E-05_JPRB, &
  & 0.16866163E-05_JPRB, 0.16892192E-05_JPRB, 0.16914685E-05_JPRB, 0.16934475E-05_JPRB, 0.16952810E-05_JPRB, 0.16971496E-05_JPRB, &
  & 0.16992892E-05_JPRB, 0.17020885E-05_JPRB, 0.17061544E-05_JPRB, 0.17121457E-05_JPRB, 0.17198522E-05_JPRB, 0.17275378E-05_JPRB, &
  & 0.17336420E-05_JPRB, 0.17380313E-05_JPRB, 0.17411161E-05_JPRB, 0.17433855E-05_JPRB, 0.17451553E-05_JPRB, 0.17466407E-05_JPRB, &
  & 0.17479398E-05_JPRB, 0.17491444E-05_JPRB, 0.17502858E-05_JPRB, 0.17513887E-05_JPRB, 0.17524515E-05_JPRB, 0.17534200E-05_JPRB, &
  & 0.17542513E-05_JPRB, 0.17548997E-05_JPRB, 0.17553366E-05_JPRB, 0.17555541E-05_JPRB, 0.17555743E-05_JPRB, 0.17554462E-05_JPRB, &
  & 0.17552127E-05_JPRB, 0.17548949E-05_JPRB, 0.17544892E-05_JPRB, 0.17539735E-05_JPRB, 0.17533041E-05_JPRB, 0.17524110E-05_JPRB, &
  & 0.17512009E-05_JPRB, 0.17495402E-05_JPRB, 0.17472884E-05_JPRB, 0.17443742E-05_JPRB, 0.17408835E-05_JPRB, 0.17370273E-05_JPRB, &
  & 0.17329348E-05_JPRB, 0.17286243E-05_JPRB, 0.17241184E-05_JPRB, 0.17197234E-05_JPRB, 0.17157945E-05_JPRB, 0.17125966E-05_JPRB, &
  & 0.17100498E-05_JPRB, 0.17079121E-05_JPRB, 0.17060273E-05_JPRB, 0.17042740E-05_JPRB, 0.17026634E-05_JPRB, 0.17012312E-05_JPRB, &
  & 0.16999722E-05_JPRB, 0.16987925E-05_JPRB, 0.16974685E-05_JPRB, 0.16950619E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART23',1,ZHOOK_HANDLE)
END SUBROUTINE PART23




SUBROUTINE PART24
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART24',0,ZHOOK_HANDLE)



RGHG2(:,46,12) = (/ &
  & 0.16820096E-05_JPRB, 0.16846002E-05_JPRB, 0.16864885E-05_JPRB, 0.16886446E-05_JPRB, 0.16914125E-05_JPRB, 0.16944507E-05_JPRB, &
  & 0.16973064E-05_JPRB, 0.16997581E-05_JPRB, 0.17018581E-05_JPRB, 0.17036460E-05_JPRB, 0.17052757E-05_JPRB, 0.17068685E-05_JPRB, &
  & 0.17086932E-05_JPRB, 0.17109894E-05_JPRB, 0.17144337E-05_JPRB, 0.17194458E-05_JPRB, 0.17259600E-05_JPRB, 0.17321540E-05_JPRB, &
  & 0.17369251E-05_JPRB, 0.17402474E-05_JPRB, 0.17426302E-05_JPRB, 0.17444438E-05_JPRB, 0.17459317E-05_JPRB, 0.17472297E-05_JPRB, &
  & 0.17484306E-05_JPRB, 0.17495723E-05_JPRB, 0.17507044E-05_JPRB, 0.17517972E-05_JPRB, 0.17528685E-05_JPRB, 0.17538207E-05_JPRB, &
  & 0.17546317E-05_JPRB, 0.17552570E-05_JPRB, 0.17556736E-05_JPRB, 0.17558760E-05_JPRB, 0.17558857E-05_JPRB, 0.17557533E-05_JPRB, &
  & 0.17555252E-05_JPRB, 0.17552251E-05_JPRB, 0.17548546E-05_JPRB, 0.17543982E-05_JPRB, 0.17538233E-05_JPRB, 0.17530817E-05_JPRB, &
  & 0.17521003E-05_JPRB, 0.17507750E-05_JPRB, 0.17489702E-05_JPRB, 0.17465641E-05_JPRB, 0.17435879E-05_JPRB, 0.17401945E-05_JPRB, &
  & 0.17365234E-05_JPRB, 0.17326036E-05_JPRB, 0.17285483E-05_JPRB, 0.17245203E-05_JPRB, 0.17210756E-05_JPRB, 0.17182707E-05_JPRB, &
  & 0.17160758E-05_JPRB, 0.17142654E-05_JPRB, 0.17126670E-05_JPRB, 0.17112196E-05_JPRB, 0.17099103E-05_JPRB, 0.17087771E-05_JPRB, &
  & 0.17077970E-05_JPRB, 0.17068846E-05_JPRB, 0.17058545E-05_JPRB, 0.17039857E-05_JPRB /)

RGHG2(:,47,12) = (/ &
  & 0.16924871E-05_JPRB, 0.16951091E-05_JPRB, 0.16969450E-05_JPRB, 0.16990850E-05_JPRB, 0.17017478E-05_JPRB, 0.17047204E-05_JPRB, &
  & 0.17074519E-05_JPRB, 0.17098280E-05_JPRB, 0.17117653E-05_JPRB, 0.17133952E-05_JPRB, 0.17147900E-05_JPRB, 0.17161601E-05_JPRB, &
  & 0.17176135E-05_JPRB, 0.17195564E-05_JPRB, 0.17222294E-05_JPRB, 0.17263873E-05_JPRB, 0.17314503E-05_JPRB, 0.17361974E-05_JPRB, &
  & 0.17396543E-05_JPRB, 0.17420878E-05_JPRB, 0.17438806E-05_JPRB, 0.17453299E-05_JPRB, 0.17465836E-05_JPRB, 0.17477430E-05_JPRB, &
  & 0.17488619E-05_JPRB, 0.17499730E-05_JPRB, 0.17510981E-05_JPRB, 0.17522119E-05_JPRB, 0.17532756E-05_JPRB, 0.17542274E-05_JPRB, &
  & 0.17550112E-05_JPRB, 0.17556122E-05_JPRB, 0.17560055E-05_JPRB, 0.17561870E-05_JPRB, 0.17561805E-05_JPRB, 0.17560390E-05_JPRB, &
  & 0.17558102E-05_JPRB, 0.17555221E-05_JPRB, 0.17551794E-05_JPRB, 0.17547727E-05_JPRB, 0.17542812E-05_JPRB, 0.17536721E-05_JPRB, &
  & 0.17529022E-05_JPRB, 0.17518955E-05_JPRB, 0.17505325E-05_JPRB, 0.17486860E-05_JPRB, 0.17462736E-05_JPRB, 0.17433993E-05_JPRB, &
  & 0.17401903E-05_JPRB, 0.17367263E-05_JPRB, 0.17330415E-05_JPRB, 0.17295754E-05_JPRB, 0.17264962E-05_JPRB, 0.17241491E-05_JPRB, &
  & 0.17222740E-05_JPRB, 0.17207441E-05_JPRB, 0.17194117E-05_JPRB, 0.17182019E-05_JPRB, 0.17171396E-05_JPRB, 0.17162331E-05_JPRB, &
  & 0.17154666E-05_JPRB, 0.17147531E-05_JPRB, 0.17139538E-05_JPRB, 0.17124825E-05_JPRB /)

RGHG2(:,48,12) = (/ &
  & 0.17024188E-05_JPRB, 0.17050432E-05_JPRB, 0.17068813E-05_JPRB, 0.17089676E-05_JPRB, 0.17115835E-05_JPRB, 0.17144521E-05_JPRB, &
  & 0.17171602E-05_JPRB, 0.17194061E-05_JPRB, 0.17212343E-05_JPRB, 0.17226523E-05_JPRB, 0.17238567E-05_JPRB, 0.17249471E-05_JPRB, &
  & 0.17261511E-05_JPRB, 0.17275975E-05_JPRB, 0.17297294E-05_JPRB, 0.17327012E-05_JPRB, 0.17363818E-05_JPRB, 0.17396032E-05_JPRB, &
  & 0.17419394E-05_JPRB, 0.17436073E-05_JPRB, 0.17449266E-05_JPRB, 0.17460731E-05_JPRB, 0.17471451E-05_JPRB, 0.17481913E-05_JPRB, &
  & 0.17492578E-05_JPRB, 0.17503521E-05_JPRB, 0.17514921E-05_JPRB, 0.17526166E-05_JPRB, 0.17536946E-05_JPRB, 0.17546279E-05_JPRB, &
  & 0.17553934E-05_JPRB, 0.17559663E-05_JPRB, 0.17563326E-05_JPRB, 0.17564896E-05_JPRB, 0.17564623E-05_JPRB, 0.17563067E-05_JPRB, &
  & 0.17560740E-05_JPRB, 0.17557926E-05_JPRB, 0.17554711E-05_JPRB, 0.17551072E-05_JPRB, 0.17546878E-05_JPRB, 0.17541990E-05_JPRB, &
  & 0.17536205E-05_JPRB, 0.17529110E-05_JPRB, 0.17519914E-05_JPRB, 0.17507144E-05_JPRB, 0.17489722E-05_JPRB, 0.17467223E-05_JPRB, &
  & 0.17440585E-05_JPRB, 0.17410609E-05_JPRB, 0.17379147E-05_JPRB, 0.17348104E-05_JPRB, 0.17322806E-05_JPRB, 0.17302470E-05_JPRB, &
  & 0.17286941E-05_JPRB, 0.17274042E-05_JPRB, 0.17262755E-05_JPRB, 0.17252660E-05_JPRB, 0.17243790E-05_JPRB, 0.17236423E-05_JPRB, &
  & 0.17230209E-05_JPRB, 0.17224509E-05_JPRB, 0.17218034E-05_JPRB, 0.17206263E-05_JPRB /)

RGHG2(:,49,12) = (/ &
  & 0.17117890E-05_JPRB, 0.17144021E-05_JPRB, 0.17162496E-05_JPRB, 0.17183096E-05_JPRB, 0.17208861E-05_JPRB, 0.17237404E-05_JPRB, &
  & 0.17263883E-05_JPRB, 0.17285802E-05_JPRB, 0.17302079E-05_JPRB, 0.17314372E-05_JPRB, 0.17323947E-05_JPRB, 0.17332495E-05_JPRB, &
  & 0.17341177E-05_JPRB, 0.17351459E-05_JPRB, 0.17365302E-05_JPRB, 0.17383852E-05_JPRB, 0.17405723E-05_JPRB, 0.17424572E-05_JPRB, &
  & 0.17438256E-05_JPRB, 0.17448817E-05_JPRB, 0.17458073E-05_JPRB, 0.17467097E-05_JPRB, 0.17476302E-05_JPRB, 0.17485960E-05_JPRB, &
  & 0.17496279E-05_JPRB, 0.17507253E-05_JPRB, 0.17518851E-05_JPRB, 0.17530331E-05_JPRB, 0.17541063E-05_JPRB, 0.17550332E-05_JPRB, &
  & 0.17557732E-05_JPRB, 0.17563207E-05_JPRB, 0.17566575E-05_JPRB, 0.17567849E-05_JPRB, 0.17567327E-05_JPRB, 0.17565602E-05_JPRB, &
  & 0.17563196E-05_JPRB, 0.17560417E-05_JPRB, 0.17557372E-05_JPRB, 0.17554090E-05_JPRB, 0.17550540E-05_JPRB, 0.17546727E-05_JPRB, &
  & 0.17542695E-05_JPRB, 0.17538383E-05_JPRB, 0.17533301E-05_JPRB, 0.17526413E-05_JPRB, 0.17516072E-05_JPRB, 0.17501211E-05_JPRB, &
  & 0.17481486E-05_JPRB, 0.17457562E-05_JPRB, 0.17431109E-05_JPRB, 0.17405839E-05_JPRB, 0.17384327E-05_JPRB, 0.17367810E-05_JPRB, &
  & 0.17354698E-05_JPRB, 0.17343823E-05_JPRB, 0.17334156E-05_JPRB, 0.17325438E-05_JPRB, 0.17317852E-05_JPRB, 0.17311543E-05_JPRB, &
  & 0.17306311E-05_JPRB, 0.17301472E-05_JPRB, 0.17296002E-05_JPRB, 0.17285934E-05_JPRB /)

RGHG2(:,50,12) = (/ &
  & 0.17204493E-05_JPRB, 0.17231484E-05_JPRB, 0.17249290E-05_JPRB, 0.17270274E-05_JPRB, 0.17295786E-05_JPRB, 0.17324677E-05_JPRB, &
  & 0.17350811E-05_JPRB, 0.17370896E-05_JPRB, 0.17384743E-05_JPRB, 0.17394036E-05_JPRB, 0.17400798E-05_JPRB, 0.17406329E-05_JPRB, &
  & 0.17411285E-05_JPRB, 0.17416926E-05_JPRB, 0.17423010E-05_JPRB, 0.17431367E-05_JPRB, 0.17440223E-05_JPRB, 0.17448057E-05_JPRB, &
  & 0.17454033E-05_JPRB, 0.17459590E-05_JPRB, 0.17465683E-05_JPRB, 0.17472646E-05_JPRB, 0.17480611E-05_JPRB, 0.17489692E-05_JPRB, &
  & 0.17499851E-05_JPRB, 0.17511020E-05_JPRB, 0.17522830E-05_JPRB, 0.17534494E-05_JPRB, 0.17545219E-05_JPRB, 0.17554345E-05_JPRB, &
  & 0.17561528E-05_JPRB, 0.17566751E-05_JPRB, 0.17569793E-05_JPRB, 0.17570745E-05_JPRB, 0.17569953E-05_JPRB, 0.17568028E-05_JPRB, &
  & 0.17565521E-05_JPRB, 0.17562745E-05_JPRB, 0.17559835E-05_JPRB, 0.17556862E-05_JPRB, 0.17553876E-05_JPRB, 0.17551049E-05_JPRB, &
  & 0.17548645E-05_JPRB, 0.17546882E-05_JPRB, 0.17545642E-05_JPRB, 0.17544072E-05_JPRB, 0.17540731E-05_JPRB, 0.17533921E-05_JPRB, &
  & 0.17522520E-05_JPRB, 0.17506469E-05_JPRB, 0.17487184E-05_JPRB, 0.17468105E-05_JPRB, 0.17451594E-05_JPRB, 0.17438554E-05_JPRB, &
  & 0.17427911E-05_JPRB, 0.17418720E-05_JPRB, 0.17410473E-05_JPRB, 0.17402749E-05_JPRB, 0.17396005E-05_JPRB, 0.17390369E-05_JPRB, &
  & 0.17385647E-05_JPRB, 0.17381237E-05_JPRB, 0.17376168E-05_JPRB, 0.17366763E-05_JPRB /)

RGHG2(:,51,12) = (/ &
  & 0.17284551E-05_JPRB, 0.17309501E-05_JPRB, 0.17328666E-05_JPRB, 0.17348515E-05_JPRB, 0.17374952E-05_JPRB, 0.17402753E-05_JPRB, &
  & 0.17427158E-05_JPRB, 0.17443076E-05_JPRB, 0.17452479E-05_JPRB, 0.17457998E-05_JPRB, 0.17461439E-05_JPRB, 0.17463692E-05_JPRB, &
  & 0.17465429E-05_JPRB, 0.17466537E-05_JPRB, 0.17467469E-05_JPRB, 0.17467753E-05_JPRB, 0.17467784E-05_JPRB, 0.17467316E-05_JPRB, &
  & 0.17467379E-05_JPRB, 0.17468964E-05_JPRB, 0.17472365E-05_JPRB, 0.17477605E-05_JPRB, 0.17484590E-05_JPRB, 0.17493203E-05_JPRB, &
  & 0.17503423E-05_JPRB, 0.17514791E-05_JPRB, 0.17526901E-05_JPRB, 0.17538632E-05_JPRB, 0.17549335E-05_JPRB, 0.17558353E-05_JPRB, &
  & 0.17565317E-05_JPRB, 0.17570280E-05_JPRB, 0.17572996E-05_JPRB, 0.17573595E-05_JPRB, 0.17572511E-05_JPRB, 0.17570374E-05_JPRB, &
  & 0.17567747E-05_JPRB, 0.17564950E-05_JPRB, 0.17562141E-05_JPRB, 0.17559430E-05_JPRB, 0.17556964E-05_JPRB, 0.17555053E-05_JPRB, &
  & 0.17554187E-05_JPRB, 0.17554814E-05_JPRB, 0.17556993E-05_JPRB, 0.17560014E-05_JPRB, 0.17562461E-05_JPRB, 0.17562750E-05_JPRB, &
  & 0.17559548E-05_JPRB, 0.17552392E-05_JPRB, 0.17542243E-05_JPRB, 0.17530871E-05_JPRB, 0.17520645E-05_JPRB, 0.17511668E-05_JPRB, &
  & 0.17503992E-05_JPRB, 0.17497057E-05_JPRB, 0.17490253E-05_JPRB, 0.17483902E-05_JPRB, 0.17477985E-05_JPRB, 0.17472951E-05_JPRB, &
  & 0.17468634E-05_JPRB, 0.17464477E-05_JPRB, 0.17459481E-05_JPRB, 0.17450170E-05_JPRB /)

RGHG2(:,52,12) = (/ &
  & 0.17353071E-05_JPRB, 0.17379999E-05_JPRB, 0.17396115E-05_JPRB, 0.17417346E-05_JPRB, 0.17440788E-05_JPRB, 0.17466450E-05_JPRB, &
  & 0.17484058E-05_JPRB, 0.17493998E-05_JPRB, 0.17498696E-05_JPRB, 0.17500906E-05_JPRB, 0.17501853E-05_JPRB, 0.17502077E-05_JPRB, &
  & 0.17501717E-05_JPRB, 0.17500556E-05_JPRB, 0.17498605E-05_JPRB, 0.17494651E-05_JPRB, 0.17489359E-05_JPRB, 0.17483333E-05_JPRB, &
  & 0.17478882E-05_JPRB, 0.17477234E-05_JPRB, 0.17478412E-05_JPRB, 0.17482189E-05_JPRB, 0.17488314E-05_JPRB, 0.17496718E-05_JPRB, &
  & 0.17506972E-05_JPRB, 0.17518678E-05_JPRB, 0.17530915E-05_JPRB, 0.17542791E-05_JPRB, 0.17553396E-05_JPRB, 0.17562342E-05_JPRB, &
  & 0.17569124E-05_JPRB, 0.17573805E-05_JPRB, 0.17576192E-05_JPRB, 0.17576422E-05_JPRB, 0.17575026E-05_JPRB, 0.17572663E-05_JPRB, &
  & 0.17569905E-05_JPRB, 0.17567073E-05_JPRB, 0.17564340E-05_JPRB, 0.17561857E-05_JPRB, 0.17559865E-05_JPRB, 0.17558833E-05_JPRB, &
  & 0.17559444E-05_JPRB, 0.17562310E-05_JPRB, 0.17567506E-05_JPRB, 0.17574139E-05_JPRB, 0.17580858E-05_JPRB, 0.17586146E-05_JPRB, &
  & 0.17588990E-05_JPRB, 0.17588957E-05_JPRB, 0.17586399E-05_JPRB, 0.17582413E-05_JPRB, 0.17577855E-05_JPRB, 0.17573492E-05_JPRB, &
  & 0.17569234E-05_JPRB, 0.17564928E-05_JPRB, 0.17560658E-05_JPRB, 0.17556073E-05_JPRB, 0.17551798E-05_JPRB, 0.17547977E-05_JPRB, &
  & 0.17544592E-05_JPRB, 0.17541207E-05_JPRB, 0.17536998E-05_JPRB, 0.17528463E-05_JPRB /)

RGHG2(:,53,12) = (/ &
  & 0.17414023E-05_JPRB, 0.17435782E-05_JPRB, 0.17454369E-05_JPRB, 0.17470777E-05_JPRB, 0.17492463E-05_JPRB, 0.17509733E-05_JPRB, &
  & 0.17520595E-05_JPRB, 0.17525037E-05_JPRB, 0.17526738E-05_JPRB, 0.17527166E-05_JPRB, 0.17526961E-05_JPRB, 0.17526336E-05_JPRB, &
  & 0.17525128E-05_JPRB, 0.17523430E-05_JPRB, 0.17519891E-05_JPRB, 0.17514981E-05_JPRB, 0.17506460E-05_JPRB, 0.17496881E-05_JPRB, &
  & 0.17489002E-05_JPRB, 0.17484660E-05_JPRB, 0.17483966E-05_JPRB, 0.17486524E-05_JPRB, 0.17492054E-05_JPRB, 0.17500204E-05_JPRB, &
  & 0.17510679E-05_JPRB, 0.17522523E-05_JPRB, 0.17535008E-05_JPRB, 0.17546885E-05_JPRB, 0.17557478E-05_JPRB, 0.17566315E-05_JPRB, &
  & 0.17572944E-05_JPRB, 0.17577346E-05_JPRB, 0.17579384E-05_JPRB, 0.17579243E-05_JPRB, 0.17577531E-05_JPRB, 0.17574931E-05_JPRB, &
  & 0.17572038E-05_JPRB, 0.17569156E-05_JPRB, 0.17566483E-05_JPRB, 0.17564204E-05_JPRB, 0.17562662E-05_JPRB, 0.17562472E-05_JPRB, &
  & 0.17564496E-05_JPRB, 0.17569470E-05_JPRB, 0.17577161E-05_JPRB, 0.17586630E-05_JPRB, 0.17596088E-05_JPRB, 0.17604397E-05_JPRB, &
  & 0.17610620E-05_JPRB, 0.17614459E-05_JPRB, 0.17616044E-05_JPRB, 0.17615993E-05_JPRB, 0.17614996E-05_JPRB, 0.17613495E-05_JPRB, &
  & 0.17611734E-05_JPRB, 0.17609774E-05_JPRB, 0.17607451E-05_JPRB, 0.17605023E-05_JPRB, 0.17602508E-05_JPRB, 0.17600255E-05_JPRB, &
  & 0.17598285E-05_JPRB, 0.17596324E-05_JPRB, 0.17593856E-05_JPRB, 0.17588337E-05_JPRB /)

RGHG2(:,54,12) = (/ &
  & 0.17461101E-05_JPRB, 0.17484812E-05_JPRB, 0.17497265E-05_JPRB, 0.17513344E-05_JPRB, 0.17527004E-05_JPRB, 0.17538008E-05_JPRB, &
  & 0.17542641E-05_JPRB, 0.17544113E-05_JPRB, 0.17544289E-05_JPRB, 0.17543950E-05_JPRB, 0.17543331E-05_JPRB, 0.17542418E-05_JPRB, &
  & 0.17541215E-05_JPRB, 0.17539069E-05_JPRB, 0.17536170E-05_JPRB, 0.17529885E-05_JPRB, 0.17520911E-05_JPRB, 0.17508711E-05_JPRB, &
  & 0.17498019E-05_JPRB, 0.17491452E-05_JPRB, 0.17489183E-05_JPRB, 0.17490781E-05_JPRB, 0.17495797E-05_JPRB, 0.17503910E-05_JPRB, &
  & 0.17514393E-05_JPRB, 0.17526511E-05_JPRB, 0.17539053E-05_JPRB, 0.17551049E-05_JPRB, 0.17561591E-05_JPRB, 0.17570318E-05_JPRB, &
  & 0.17576790E-05_JPRB, 0.17580920E-05_JPRB, 0.17582607E-05_JPRB, 0.17582091E-05_JPRB, 0.17580064E-05_JPRB, 0.17577223E-05_JPRB, &
  & 0.17574195E-05_JPRB, 0.17571256E-05_JPRB, 0.17568633E-05_JPRB, 0.17566549E-05_JPRB, 0.17565429E-05_JPRB, 0.17566038E-05_JPRB, &
  & 0.17569421E-05_JPRB, 0.17576190E-05_JPRB, 0.17586160E-05_JPRB, 0.17597474E-05_JPRB, 0.17608852E-05_JPRB, 0.17618731E-05_JPRB, &
  & 0.17626544E-05_JPRB, 0.17631993E-05_JPRB, 0.17635291E-05_JPRB, 0.17636848E-05_JPRB, 0.17637349E-05_JPRB, 0.17637225E-05_JPRB, &
  & 0.17636737E-05_JPRB, 0.17635959E-05_JPRB, 0.17634972E-05_JPRB, 0.17633728E-05_JPRB, 0.17632474E-05_JPRB, 0.17631381E-05_JPRB, &
  & 0.17630496E-05_JPRB, 0.17629811E-05_JPRB, 0.17629289E-05_JPRB, 0.17629059E-05_JPRB /)

RGHG2(:,55,12) = (/ &
  & 0.17501651E-05_JPRB, 0.17519321E-05_JPRB, 0.17532619E-05_JPRB, 0.17542110E-05_JPRB, 0.17551295E-05_JPRB, 0.17555928E-05_JPRB, &
  & 0.17557247E-05_JPRB, 0.17557070E-05_JPRB, 0.17556542E-05_JPRB, 0.17555888E-05_JPRB, 0.17555137E-05_JPRB, 0.17554245E-05_JPRB, &
  & 0.17552976E-05_JPRB, 0.17551317E-05_JPRB, 0.17547972E-05_JPRB, 0.17543002E-05_JPRB, 0.17532816E-05_JPRB, 0.17519196E-05_JPRB, &
  & 0.17506279E-05_JPRB, 0.17497778E-05_JPRB, 0.17494248E-05_JPRB, 0.17495082E-05_JPRB, 0.17499750E-05_JPRB, 0.17507721E-05_JPRB, &
  & 0.17518336E-05_JPRB, 0.17530517E-05_JPRB, 0.17543258E-05_JPRB, 0.17555301E-05_JPRB, 0.17565817E-05_JPRB, 0.17574412E-05_JPRB, &
  & 0.17580703E-05_JPRB, 0.17584558E-05_JPRB, 0.17585896E-05_JPRB, 0.17585014E-05_JPRB, 0.17582672E-05_JPRB, 0.17579600E-05_JPRB, &
  & 0.17576419E-05_JPRB, 0.17573440E-05_JPRB, 0.17570861E-05_JPRB, 0.17568968E-05_JPRB, 0.17568266E-05_JPRB, 0.17569640E-05_JPRB, &
  & 0.17574175E-05_JPRB, 0.17582682E-05_JPRB, 0.17594143E-05_JPRB, 0.17607276E-05_JPRB, 0.17619631E-05_JPRB, 0.17630471E-05_JPRB, &
  & 0.17638929E-05_JPRB, 0.17644979E-05_JPRB, 0.17648747E-05_JPRB, 0.17650905E-05_JPRB, 0.17651962E-05_JPRB, 0.17652410E-05_JPRB, &
  & 0.17652486E-05_JPRB, 0.17652305E-05_JPRB, 0.17651887E-05_JPRB, 0.17651303E-05_JPRB, 0.17650605E-05_JPRB, 0.17649929E-05_JPRB, &
  & 0.17649343E-05_JPRB, 0.17648772E-05_JPRB, 0.17648122E-05_JPRB, 0.17646935E-05_JPRB /)

RGHG2(:,56,12) = (/ &
  & 0.17531779E-05_JPRB, 0.17548787E-05_JPRB, 0.17556827E-05_JPRB, 0.17563796E-05_JPRB, 0.17567826E-05_JPRB, 0.17568863E-05_JPRB, &
  & 0.17568118E-05_JPRB, 0.17567072E-05_JPRB, 0.17566208E-05_JPRB, 0.17565430E-05_JPRB, 0.17564655E-05_JPRB, 0.17563771E-05_JPRB, &
  & 0.17562704E-05_JPRB, 0.17560963E-05_JPRB, 0.17558488E-05_JPRB, 0.17552959E-05_JPRB, 0.17543783E-05_JPRB, 0.17528791E-05_JPRB, &
  & 0.17513862E-05_JPRB, 0.17503878E-05_JPRB, 0.17499342E-05_JPRB, 0.17499584E-05_JPRB, 0.17503966E-05_JPRB, 0.17511837E-05_JPRB, &
  & 0.17522432E-05_JPRB, 0.17534786E-05_JPRB, 0.17547611E-05_JPRB, 0.17559726E-05_JPRB, 0.17570217E-05_JPRB, 0.17578650E-05_JPRB, &
  & 0.17584737E-05_JPRB, 0.17588317E-05_JPRB, 0.17589315E-05_JPRB, 0.17588085E-05_JPRB, 0.17585434E-05_JPRB, 0.17582132E-05_JPRB, &
  & 0.17578814E-05_JPRB, 0.17575768E-05_JPRB, 0.17573253E-05_JPRB, 0.17571557E-05_JPRB, 0.17571271E-05_JPRB, 0.17573329E-05_JPRB, &
  & 0.17578972E-05_JPRB, 0.17588602E-05_JPRB, 0.17601769E-05_JPRB, 0.17615721E-05_JPRB, 0.17629260E-05_JPRB, 0.17640516E-05_JPRB, &
  & 0.17649288E-05_JPRB, 0.17655329E-05_JPRB, 0.17659229E-05_JPRB, 0.17661434E-05_JPRB, 0.17662671E-05_JPRB, 0.17663322E-05_JPRB, &
  & 0.17663630E-05_JPRB, 0.17663710E-05_JPRB, 0.17663601E-05_JPRB, 0.17663322E-05_JPRB, 0.17662933E-05_JPRB, 0.17662533E-05_JPRB, &
  & 0.17662146E-05_JPRB, 0.17661780E-05_JPRB, 0.17661371E-05_JPRB, 0.17660697E-05_JPRB /)

RGHG2(:,57,12) = (/ &
  & 0.17556498E-05_JPRB, 0.17569564E-05_JPRB, 0.17575919E-05_JPRB, 0.17579437E-05_JPRB, 0.17580427E-05_JPRB, 0.17579111E-05_JPRB, &
  & 0.17577117E-05_JPRB, 0.17575647E-05_JPRB, 0.17574607E-05_JPRB, 0.17573768E-05_JPRB, 0.17572995E-05_JPRB, 0.17572170E-05_JPRB, &
  & 0.17571102E-05_JPRB, 0.17569693E-05_JPRB, 0.17566997E-05_JPRB, 0.17562620E-05_JPRB, 0.17552792E-05_JPRB, 0.17537440E-05_JPRB, &
  & 0.17521148E-05_JPRB, 0.17509924E-05_JPRB, 0.17504656E-05_JPRB, 0.17504434E-05_JPRB, 0.17508551E-05_JPRB, 0.17516317E-05_JPRB, &
  & 0.17526920E-05_JPRB, 0.17539330E-05_JPRB, 0.17552251E-05_JPRB, 0.17564419E-05_JPRB, 0.17574826E-05_JPRB, 0.17583097E-05_JPRB, &
  & 0.17588978E-05_JPRB, 0.17592272E-05_JPRB, 0.17592947E-05_JPRB, 0.17591381E-05_JPRB, 0.17588427E-05_JPRB, 0.17584917E-05_JPRB, &
  & 0.17581448E-05_JPRB, 0.17578359E-05_JPRB, 0.17575886E-05_JPRB, 0.17574397E-05_JPRB, 0.17574509E-05_JPRB, 0.17577233E-05_JPRB, &
  & 0.17583665E-05_JPRB, 0.17594527E-05_JPRB, 0.17608400E-05_JPRB, 0.17623794E-05_JPRB, 0.17637738E-05_JPRB, 0.17649595E-05_JPRB, &
  & 0.17658318E-05_JPRB, 0.17664333E-05_JPRB, 0.17667960E-05_JPRB, 0.17670116E-05_JPRB, 0.17671321E-05_JPRB, 0.17672011E-05_JPRB, &
  & 0.17672403E-05_JPRB, 0.17672587E-05_JPRB, 0.17672611E-05_JPRB, 0.17672493E-05_JPRB, 0.17672263E-05_JPRB, 0.17671975E-05_JPRB, &
  & 0.17671688E-05_JPRB, 0.17671370E-05_JPRB, 0.17670968E-05_JPRB, 0.17670170E-05_JPRB /)

RGHG2(:,58,12) = (/ &
  & 0.17576027E-05_JPRB, 0.17586456E-05_JPRB, 0.17590456E-05_JPRB, 0.17591836E-05_JPRB, 0.17590830E-05_JPRB, 0.17588040E-05_JPRB, &
  & 0.17585445E-05_JPRB, 0.17583623E-05_JPRB, 0.17582485E-05_JPRB, 0.17581610E-05_JPRB, 0.17580828E-05_JPRB, 0.17580007E-05_JPRB, &
  & 0.17579034E-05_JPRB, 0.17577534E-05_JPRB, 0.17575277E-05_JPRB, 0.17570353E-05_JPRB, 0.17561385E-05_JPRB, 0.17545163E-05_JPRB, &
  & 0.17528051E-05_JPRB, 0.17516132E-05_JPRB, 0.17510300E-05_JPRB, 0.17509724E-05_JPRB, 0.17513662E-05_JPRB, 0.17521294E-05_JPRB, &
  & 0.17531892E-05_JPRB, 0.17544319E-05_JPRB, 0.17557295E-05_JPRB, 0.17569404E-05_JPRB, 0.17579746E-05_JPRB, 0.17587836E-05_JPRB, &
  & 0.17593482E-05_JPRB, 0.17596516E-05_JPRB, 0.17596877E-05_JPRB, 0.17594996E-05_JPRB, 0.17591756E-05_JPRB, 0.17588043E-05_JPRB, &
  & 0.17584439E-05_JPRB, 0.17581283E-05_JPRB, 0.17578857E-05_JPRB, 0.17577556E-05_JPRB, 0.17578056E-05_JPRB, 0.17581341E-05_JPRB, &
  & 0.17588593E-05_JPRB, 0.17600038E-05_JPRB, 0.17615089E-05_JPRB, 0.17630803E-05_JPRB, 0.17645814E-05_JPRB, 0.17657803E-05_JPRB, &
  & 0.17666687E-05_JPRB, 0.17672320E-05_JPRB, 0.17675789E-05_JPRB, 0.17677729E-05_JPRB, 0.17678847E-05_JPRB, 0.17679497E-05_JPRB, &
  & 0.17679877E-05_JPRB, 0.17680087E-05_JPRB, 0.17680153E-05_JPRB, 0.17680088E-05_JPRB, 0.17679922E-05_JPRB, 0.17679703E-05_JPRB, &
  & 0.17679453E-05_JPRB, 0.17679185E-05_JPRB, 0.17678844E-05_JPRB, 0.17678176E-05_JPRB /)

RGHG2(:,59,12) = (/ &
  & 0.17592358E-05_JPRB, 0.17600555E-05_JPRB, 0.17602484E-05_JPRB, 0.17602327E-05_JPRB, 0.17600190E-05_JPRB, 0.17596570E-05_JPRB, &
  & 0.17593441E-05_JPRB, 0.17591478E-05_JPRB, 0.17590232E-05_JPRB, 0.17589325E-05_JPRB, 0.17588532E-05_JPRB, 0.17587715E-05_JPRB, &
  & 0.17586697E-05_JPRB, 0.17585296E-05_JPRB, 0.17582738E-05_JPRB, 0.17578235E-05_JPRB, 0.17568326E-05_JPRB, 0.17552236E-05_JPRB, &
  & 0.17534800E-05_JPRB, 0.17522560E-05_JPRB, 0.17516406E-05_JPRB, 0.17515598E-05_JPRB, 0.17519369E-05_JPRB, 0.17526949E-05_JPRB, &
  & 0.17537470E-05_JPRB, 0.17549905E-05_JPRB, 0.17562788E-05_JPRB, 0.17574857E-05_JPRB, 0.17585027E-05_JPRB, 0.17592934E-05_JPRB, &
  & 0.17598375E-05_JPRB, 0.17601141E-05_JPRB, 0.17601203E-05_JPRB, 0.17599023E-05_JPRB, 0.17595520E-05_JPRB, 0.17591609E-05_JPRB, &
  & 0.17587869E-05_JPRB, 0.17584642E-05_JPRB, 0.17582240E-05_JPRB, 0.17581111E-05_JPRB, 0.17581955E-05_JPRB, 0.17585791E-05_JPRB, &
  & 0.17593595E-05_JPRB, 0.17605835E-05_JPRB, 0.17621138E-05_JPRB, 0.17637847E-05_JPRB, 0.17653034E-05_JPRB, 0.17665626E-05_JPRB, &
  & 0.17674289E-05_JPRB, 0.17679840E-05_JPRB, 0.17682964E-05_JPRB, 0.17684736E-05_JPRB, 0.17685732E-05_JPRB, 0.17686305E-05_JPRB, &
  & 0.17686648E-05_JPRB, 0.17686826E-05_JPRB, 0.17686882E-05_JPRB, 0.17686823E-05_JPRB, 0.17686666E-05_JPRB, 0.17686450E-05_JPRB, &
  & 0.17686216E-05_JPRB, 0.17685945E-05_JPRB, 0.17685586E-05_JPRB, 0.17684861E-05_JPRB /)

RGHG2(:,60,12) = (/ &
  & 0.17611121E-05_JPRB, 0.17613042E-05_JPRB, 0.17613133E-05_JPRB, 0.17611959E-05_JPRB, 0.17608875E-05_JPRB, 0.17604989E-05_JPRB, &
  & 0.17601612E-05_JPRB, 0.17599374E-05_JPRB, 0.17598079E-05_JPRB, 0.17597124E-05_JPRB, 0.17596312E-05_JPRB, 0.17595469E-05_JPRB, &
  & 0.17594441E-05_JPRB, 0.17592885E-05_JPRB, 0.17590344E-05_JPRB, 0.17585094E-05_JPRB, 0.17575065E-05_JPRB, 0.17558584E-05_JPRB, &
  & 0.17541552E-05_JPRB, 0.17529358E-05_JPRB, 0.17523087E-05_JPRB, 0.17522154E-05_JPRB, 0.17525858E-05_JPRB, 0.17533342E-05_JPRB, &
  & 0.17543831E-05_JPRB, 0.17556141E-05_JPRB, 0.17568934E-05_JPRB, 0.17580783E-05_JPRB, 0.17590799E-05_JPRB, 0.17598479E-05_JPRB, &
  & 0.17603700E-05_JPRB, 0.17606229E-05_JPRB, 0.17606010E-05_JPRB, 0.17603541E-05_JPRB, 0.17599801E-05_JPRB, 0.17595713E-05_JPRB, &
  & 0.17591826E-05_JPRB, 0.17588520E-05_JPRB, 0.17586124E-05_JPRB, 0.17585139E-05_JPRB, 0.17586299E-05_JPRB, 0.17590578E-05_JPRB, &
  & 0.17598986E-05_JPRB, 0.17611590E-05_JPRB, 0.17627493E-05_JPRB, 0.17644231E-05_JPRB, 0.17660136E-05_JPRB, 0.17672736E-05_JPRB, &
  & 0.17681629E-05_JPRB, 0.17686848E-05_JPRB, 0.17689817E-05_JPRB, 0.17691405E-05_JPRB, 0.17692264E-05_JPRB, 0.17692752E-05_JPRB, &
  & 0.17693014E-05_JPRB, 0.17693144E-05_JPRB, 0.17693148E-05_JPRB, 0.17693048E-05_JPRB, 0.17692864E-05_JPRB, 0.17692632E-05_JPRB, &
  & 0.17692373E-05_JPRB, 0.17692089E-05_JPRB, 0.17691725E-05_JPRB, 0.17691010E-05_JPRB /)

RGHG2(:,61,12) = (/ &
  & 0.17621562E-05_JPRB, 0.17623006E-05_JPRB, 0.17622519E-05_JPRB, 0.17620698E-05_JPRB, 0.17617733E-05_JPRB, 0.17613477E-05_JPRB, &
  & 0.17609865E-05_JPRB, 0.17607506E-05_JPRB, 0.17606077E-05_JPRB, 0.17605107E-05_JPRB, 0.17604275E-05_JPRB, 0.17603423E-05_JPRB, &
  & 0.17602333E-05_JPRB, 0.17600703E-05_JPRB, 0.17597733E-05_JPRB, 0.17592085E-05_JPRB, 0.17581131E-05_JPRB, 0.17564947E-05_JPRB, &
  & 0.17548573E-05_JPRB, 0.17536695E-05_JPRB, 0.17530476E-05_JPRB, 0.17529535E-05_JPRB, 0.17533209E-05_JPRB, 0.17540672E-05_JPRB, &
  & 0.17551032E-05_JPRB, 0.17563229E-05_JPRB, 0.17575765E-05_JPRB, 0.17587411E-05_JPRB, 0.17597135E-05_JPRB, 0.17604590E-05_JPRB, &
  & 0.17609590E-05_JPRB, 0.17611883E-05_JPRB, 0.17611404E-05_JPRB, 0.17608675E-05_JPRB, 0.17604716E-05_JPRB, 0.17600445E-05_JPRB, &
  & 0.17596417E-05_JPRB, 0.17592998E-05_JPRB, 0.17590587E-05_JPRB, 0.17589714E-05_JPRB, 0.17591140E-05_JPRB, 0.17595854E-05_JPRB, &
  & 0.17604680E-05_JPRB, 0.17617738E-05_JPRB, 0.17633747E-05_JPRB, 0.17650802E-05_JPRB, 0.17666623E-05_JPRB, 0.17679669E-05_JPRB, &
  & 0.17688410E-05_JPRB, 0.17693698E-05_JPRB, 0.17696465E-05_JPRB, 0.17697898E-05_JPRB, 0.17698641E-05_JPRB, 0.17699012E-05_JPRB, &
  & 0.17699190E-05_JPRB, 0.17699232E-05_JPRB, 0.17699163E-05_JPRB, 0.17698997E-05_JPRB, 0.17698748E-05_JPRB, 0.17698455E-05_JPRB, &
  & 0.17698152E-05_JPRB, 0.17697816E-05_JPRB, 0.17697391E-05_JPRB, 0.17696573E-05_JPRB /)

RGHG2(:,62,12) = (/ &
  & 0.17631721E-05_JPRB, 0.17632298E-05_JPRB, 0.17631378E-05_JPRB, 0.17629575E-05_JPRB, 0.17626267E-05_JPRB, 0.17622247E-05_JPRB, &
  & 0.17618397E-05_JPRB, 0.17615694E-05_JPRB, 0.17614234E-05_JPRB, 0.17613218E-05_JPRB, 0.17612444E-05_JPRB, 0.17611619E-05_JPRB, &
  & 0.17610528E-05_JPRB, 0.17608709E-05_JPRB, 0.17605396E-05_JPRB, 0.17598888E-05_JPRB, 0.17587394E-05_JPRB, 0.17571670E-05_JPRB, &
  & 0.17556163E-05_JPRB, 0.17544752E-05_JPRB, 0.17538738E-05_JPRB, 0.17537890E-05_JPRB, 0.17541602E-05_JPRB, 0.17549020E-05_JPRB, &
  & 0.17559275E-05_JPRB, 0.17571239E-05_JPRB, 0.17583504E-05_JPRB, 0.17594790E-05_JPRB, 0.17604231E-05_JPRB, 0.17611389E-05_JPRB, &
  & 0.17616157E-05_JPRB, 0.17618222E-05_JPRB, 0.17617501E-05_JPRB, 0.17614532E-05_JPRB, 0.17610367E-05_JPRB, 0.17605936E-05_JPRB, &
  & 0.17601737E-05_JPRB, 0.17598203E-05_JPRB, 0.17595737E-05_JPRB, 0.17594941E-05_JPRB, 0.17596593E-05_JPRB, 0.17601644E-05_JPRB, &
  & 0.17610860E-05_JPRB, 0.17624188E-05_JPRB, 0.17640346E-05_JPRB, 0.17657260E-05_JPRB, 0.17673161E-05_JPRB, 0.17686062E-05_JPRB, &
  & 0.17695122E-05_JPRB, 0.17700299E-05_JPRB, 0.17703027E-05_JPRB, 0.17704338E-05_JPRB, 0.17704942E-05_JPRB, 0.17705202E-05_JPRB, &
  & 0.17705268E-05_JPRB, 0.17705205E-05_JPRB, 0.17705040E-05_JPRB, 0.17704765E-05_JPRB, 0.17704419E-05_JPRB, 0.17704047E-05_JPRB, &
  & 0.17703660E-05_JPRB, 0.17703259E-05_JPRB, 0.17702764E-05_JPRB, 0.17701831E-05_JPRB /)

RGHG2(:,63,12) = (/ &
  & 0.17640905E-05_JPRB, 0.17641207E-05_JPRB, 0.17640186E-05_JPRB, 0.17638201E-05_JPRB, 0.17635243E-05_JPRB, 0.17631100E-05_JPRB, &
  & 0.17627056E-05_JPRB, 0.17624093E-05_JPRB, 0.17622417E-05_JPRB, 0.17621469E-05_JPRB, 0.17620766E-05_JPRB, 0.17620102E-05_JPRB, &
  & 0.17619041E-05_JPRB, 0.17617111E-05_JPRB, 0.17613269E-05_JPRB, 0.17606062E-05_JPRB, 0.17594310E-05_JPRB, 0.17579271E-05_JPRB, &
  & 0.17564606E-05_JPRB, 0.17553747E-05_JPRB, 0.17548040E-05_JPRB, 0.17547372E-05_JPRB, 0.17551160E-05_JPRB, 0.17558543E-05_JPRB, &
  & 0.17568635E-05_JPRB, 0.17580336E-05_JPRB, 0.17592206E-05_JPRB, 0.17603120E-05_JPRB, 0.17612151E-05_JPRB, 0.17619010E-05_JPRB, &
  & 0.17623516E-05_JPRB, 0.17625360E-05_JPRB, 0.17624415E-05_JPRB, 0.17621239E-05_JPRB, 0.17616898E-05_JPRB, 0.17612301E-05_JPRB, &
  & 0.17607944E-05_JPRB, 0.17604249E-05_JPRB, 0.17601707E-05_JPRB, 0.17600941E-05_JPRB, 0.17602761E-05_JPRB, 0.17608085E-05_JPRB, &
  & 0.17617597E-05_JPRB, 0.17631087E-05_JPRB, 0.17647258E-05_JPRB, 0.17664004E-05_JPRB, 0.17679561E-05_JPRB, 0.17692498E-05_JPRB, &
  & 0.17701497E-05_JPRB, 0.17706886E-05_JPRB, 0.17709568E-05_JPRB, 0.17710772E-05_JPRB, 0.17711252E-05_JPRB, 0.17711375E-05_JPRB, &
  & 0.17711312E-05_JPRB, 0.17711125E-05_JPRB, 0.17710819E-05_JPRB, 0.17710424E-05_JPRB, 0.17709950E-05_JPRB, 0.17709452E-05_JPRB, &
  & 0.17708971E-05_JPRB, 0.17708467E-05_JPRB, 0.17707854E-05_JPRB, 0.17706739E-05_JPRB /)

RGHG2(:,64,12) = (/ &
  & 0.17649963E-05_JPRB, 0.17650038E-05_JPRB, 0.17648933E-05_JPRB, 0.17647083E-05_JPRB, 0.17644134E-05_JPRB, 0.17640186E-05_JPRB, &
  & 0.17635923E-05_JPRB, 0.17632483E-05_JPRB, 0.17630753E-05_JPRB, 0.17629773E-05_JPRB, 0.17629304E-05_JPRB, 0.17628842E-05_JPRB, &
  & 0.17627933E-05_JPRB, 0.17625830E-05_JPRB, 0.17621564E-05_JPRB, 0.17613917E-05_JPRB, 0.17602227E-05_JPRB, 0.17587847E-05_JPRB, &
  & 0.17573997E-05_JPRB, 0.17563759E-05_JPRB, 0.17558473E-05_JPRB, 0.17558044E-05_JPRB, 0.17561922E-05_JPRB, 0.17569249E-05_JPRB, &
  & 0.17579130E-05_JPRB, 0.17590460E-05_JPRB, 0.17601881E-05_JPRB, 0.17612304E-05_JPRB, 0.17620908E-05_JPRB, 0.17627391E-05_JPRB, &
  & 0.17631626E-05_JPRB, 0.17633247E-05_JPRB, 0.17632111E-05_JPRB, 0.17628776E-05_JPRB, 0.17624309E-05_JPRB, 0.17619590E-05_JPRB, &
  & 0.17615081E-05_JPRB, 0.17611233E-05_JPRB, 0.17608577E-05_JPRB, 0.17607795E-05_JPRB, 0.17609716E-05_JPRB, 0.17615233E-05_JPRB, &
  & 0.17624908E-05_JPRB, 0.17638497E-05_JPRB, 0.17654512E-05_JPRB, 0.17670989E-05_JPRB, 0.17686181E-05_JPRB, 0.17698766E-05_JPRB, &
  & 0.17707860E-05_JPRB, 0.17713315E-05_JPRB, 0.17716073E-05_JPRB, 0.17717213E-05_JPRB, 0.17717562E-05_JPRB, 0.17717542E-05_JPRB, &
  & 0.17717330E-05_JPRB, 0.17716977E-05_JPRB, 0.17716525E-05_JPRB, 0.17715954E-05_JPRB, 0.17715329E-05_JPRB, 0.17714696E-05_JPRB, &
  & 0.17714073E-05_JPRB, 0.17713435E-05_JPRB, 0.17712663E-05_JPRB, 0.17711252E-05_JPRB /)

RGHG2(:,65,12) = (/ &
  & 0.17658987E-05_JPRB, 0.17658906E-05_JPRB, 0.17657810E-05_JPRB, 0.17655984E-05_JPRB, 0.17653236E-05_JPRB, 0.17649352E-05_JPRB, &
  & 0.17644894E-05_JPRB, 0.17641125E-05_JPRB, 0.17639230E-05_JPRB, 0.17638383E-05_JPRB, 0.17638122E-05_JPRB, 0.17637942E-05_JPRB, &
  & 0.17637133E-05_JPRB, 0.17634952E-05_JPRB, 0.17630422E-05_JPRB, 0.17622619E-05_JPRB, 0.17611206E-05_JPRB, 0.17597504E-05_JPRB, &
  & 0.17584466E-05_JPRB, 0.17574906E-05_JPRB, 0.17570069E-05_JPRB, 0.17569909E-05_JPRB, 0.17573860E-05_JPRB, 0.17581070E-05_JPRB, &
  & 0.17590648E-05_JPRB, 0.17601519E-05_JPRB, 0.17612374E-05_JPRB, 0.17622233E-05_JPRB, 0.17630317E-05_JPRB, 0.17636390E-05_JPRB, &
  & 0.17640318E-05_JPRB, 0.17641727E-05_JPRB, 0.17640448E-05_JPRB, 0.17637025E-05_JPRB, 0.17632514E-05_JPRB, 0.17627758E-05_JPRB, &
  & 0.17623154E-05_JPRB, 0.17619177E-05_JPRB, 0.17616412E-05_JPRB, 0.17615579E-05_JPRB, 0.17617539E-05_JPRB, 0.17623144E-05_JPRB, &
  & 0.17632906E-05_JPRB, 0.17646373E-05_JPRB, 0.17662188E-05_JPRB, 0.17678238E-05_JPRB, 0.17692977E-05_JPRB, 0.17705181E-05_JPRB, &
  & 0.17714088E-05_JPRB, 0.17719656E-05_JPRB, 0.17722498E-05_JPRB, 0.17723604E-05_JPRB, 0.17723848E-05_JPRB, 0.17723677E-05_JPRB, &
  & 0.17723296E-05_JPRB, 0.17722786E-05_JPRB, 0.17722136E-05_JPRB, 0.17721401E-05_JPRB, 0.17720590E-05_JPRB, 0.17719774E-05_JPRB, &
  & 0.17718988E-05_JPRB, 0.17718158E-05_JPRB, 0.17717146E-05_JPRB, 0.17715292E-05_JPRB /)

RGHG2(:,66,12) = (/ &
  & 0.17667436E-05_JPRB, 0.17667679E-05_JPRB, 0.17666715E-05_JPRB, 0.17665042E-05_JPRB, 0.17662419E-05_JPRB, 0.17658617E-05_JPRB, &
  & 0.17654089E-05_JPRB, 0.17649991E-05_JPRB, 0.17648113E-05_JPRB, 0.17647404E-05_JPRB, 0.17647390E-05_JPRB, 0.17647424E-05_JPRB, &
  & 0.17646720E-05_JPRB, 0.17644518E-05_JPRB, 0.17639908E-05_JPRB, 0.17632213E-05_JPRB, 0.17621181E-05_JPRB, 0.17608197E-05_JPRB, &
  & 0.17596003E-05_JPRB, 0.17587161E-05_JPRB, 0.17582810E-05_JPRB, 0.17582894E-05_JPRB, 0.17586860E-05_JPRB, 0.17593848E-05_JPRB, &
  & 0.17603024E-05_JPRB, 0.17613291E-05_JPRB, 0.17623491E-05_JPRB, 0.17632683E-05_JPRB, 0.17640192E-05_JPRB, 0.17645802E-05_JPRB, &
  & 0.17649415E-05_JPRB, 0.17650614E-05_JPRB, 0.17649229E-05_JPRB, 0.17645800E-05_JPRB, 0.17641364E-05_JPRB, 0.17636677E-05_JPRB, &
  & 0.17632090E-05_JPRB, 0.17628048E-05_JPRB, 0.17625213E-05_JPRB, 0.17624327E-05_JPRB, 0.17626284E-05_JPRB, 0.17631892E-05_JPRB, &
  & 0.17641564E-05_JPRB, 0.17654843E-05_JPRB, 0.17670216E-05_JPRB, 0.17685794E-05_JPRB, 0.17699972E-05_JPRB, 0.17711707E-05_JPRB, &
  & 0.17720337E-05_JPRB, 0.17725869E-05_JPRB, 0.17728785E-05_JPRB, 0.17729922E-05_JPRB, 0.17730094E-05_JPRB, 0.17729787E-05_JPRB, &
  & 0.17729255E-05_JPRB, 0.17728551E-05_JPRB, 0.17727734E-05_JPRB, 0.17726782E-05_JPRB, 0.17725786E-05_JPRB, 0.17724790E-05_JPRB, &
  & 0.17723787E-05_JPRB, 0.17722724E-05_JPRB, 0.17721370E-05_JPRB, 0.17718835E-05_JPRB /)

RGHG2(:,67,12) = (/ &
  & 0.17676387E-05_JPRB, 0.17676721E-05_JPRB, 0.17675850E-05_JPRB, 0.17674254E-05_JPRB, 0.17671750E-05_JPRB, 0.17668071E-05_JPRB, &
  & 0.17663447E-05_JPRB, 0.17659263E-05_JPRB, 0.17657466E-05_JPRB, 0.17656969E-05_JPRB, 0.17657175E-05_JPRB, 0.17657371E-05_JPRB, &
  & 0.17656761E-05_JPRB, 0.17654600E-05_JPRB, 0.17650063E-05_JPRB, 0.17642614E-05_JPRB, 0.17632104E-05_JPRB, 0.17619918E-05_JPRB, &
  & 0.17608595E-05_JPRB, 0.17600468E-05_JPRB, 0.17596558E-05_JPRB, 0.17596823E-05_JPRB, 0.17600703E-05_JPRB, 0.17607374E-05_JPRB, &
  & 0.17616005E-05_JPRB, 0.17625601E-05_JPRB, 0.17635023E-05_JPRB, 0.17643501E-05_JPRB, 0.17650381E-05_JPRB, 0.17655503E-05_JPRB, &
  & 0.17658784E-05_JPRB, 0.17659796E-05_JPRB, 0.17658347E-05_JPRB, 0.17654991E-05_JPRB, 0.17650714E-05_JPRB, 0.17646219E-05_JPRB, &
  & 0.17641746E-05_JPRB, 0.17637756E-05_JPRB, 0.17634908E-05_JPRB, 0.17634013E-05_JPRB, 0.17635944E-05_JPRB, 0.17641480E-05_JPRB, &
  & 0.17650967E-05_JPRB, 0.17663828E-05_JPRB, 0.17678681E-05_JPRB, 0.17693600E-05_JPRB, 0.17707165E-05_JPRB, 0.17718360E-05_JPRB, &
  & 0.17726626E-05_JPRB, 0.17731999E-05_JPRB, 0.17734950E-05_JPRB, 0.17736103E-05_JPRB, 0.17736254E-05_JPRB, 0.17735858E-05_JPRB, &
  & 0.17735179E-05_JPRB, 0.17734337E-05_JPRB, 0.17733319E-05_JPRB, 0.17732214E-05_JPRB, 0.17731032E-05_JPRB, 0.17729824E-05_JPRB, &
  & 0.17728623E-05_JPRB, 0.17727251E-05_JPRB, 0.17725450E-05_JPRB, 0.17721917E-05_JPRB /)

RGHG2(:,68,12) = (/ &
  & 0.17685170E-05_JPRB, 0.17685850E-05_JPRB, 0.17685121E-05_JPRB, 0.17683651E-05_JPRB, 0.17681257E-05_JPRB, 0.17677653E-05_JPRB, &
  & 0.17673173E-05_JPRB, 0.17668948E-05_JPRB, 0.17667373E-05_JPRB, 0.17667107E-05_JPRB, 0.17667502E-05_JPRB, 0.17667818E-05_JPRB, &
  & 0.17667278E-05_JPRB, 0.17665197E-05_JPRB, 0.17660809E-05_JPRB, 0.17653747E-05_JPRB, 0.17643847E-05_JPRB, 0.17632517E-05_JPRB, &
  & 0.17622073E-05_JPRB, 0.17614614E-05_JPRB, 0.17611101E-05_JPRB, 0.17611455E-05_JPRB, 0.17615156E-05_JPRB, 0.17621395E-05_JPRB, &
  & 0.17629421E-05_JPRB, 0.17638237E-05_JPRB, 0.17646869E-05_JPRB, 0.17654585E-05_JPRB, 0.17660827E-05_JPRB, 0.17665456E-05_JPRB, &
  & 0.17668415E-05_JPRB, 0.17669247E-05_JPRB, 0.17667766E-05_JPRB, 0.17664534E-05_JPRB, 0.17660496E-05_JPRB, 0.17656264E-05_JPRB, &
  & 0.17652025E-05_JPRB, 0.17648160E-05_JPRB, 0.17645406E-05_JPRB, 0.17644542E-05_JPRB, 0.17646455E-05_JPRB, 0.17651860E-05_JPRB, &
  & 0.17661046E-05_JPRB, 0.17673398E-05_JPRB, 0.17687520E-05_JPRB, 0.17701691E-05_JPRB, 0.17714523E-05_JPRB, 0.17725110E-05_JPRB, &
  & 0.17732942E-05_JPRB, 0.17738091E-05_JPRB, 0.17740969E-05_JPRB, 0.17742149E-05_JPRB, 0.17742302E-05_JPRB, 0.17741850E-05_JPRB, &
  & 0.17741105E-05_JPRB, 0.17740123E-05_JPRB, 0.17738997E-05_JPRB, 0.17737723E-05_JPRB, 0.17736396E-05_JPRB, 0.17735065E-05_JPRB, &
  & 0.17733638E-05_JPRB, 0.17732016E-05_JPRB, 0.17729692E-05_JPRB, 0.17725000E-05_JPRB /)

RGHG2(:,69,12) = (/ &
  & 0.17694151E-05_JPRB, 0.17695208E-05_JPRB, 0.17694640E-05_JPRB, 0.17693276E-05_JPRB, 0.17690995E-05_JPRB, 0.17687568E-05_JPRB, &
  & 0.17683185E-05_JPRB, 0.17679216E-05_JPRB, 0.17677893E-05_JPRB, 0.17677863E-05_JPRB, 0.17678400E-05_JPRB, 0.17678784E-05_JPRB, &
  & 0.17678300E-05_JPRB, 0.17676322E-05_JPRB, 0.17672127E-05_JPRB, 0.17665528E-05_JPRB, 0.17656321E-05_JPRB, 0.17645874E-05_JPRB, &
  & 0.17636277E-05_JPRB, 0.17629437E-05_JPRB, 0.17626220E-05_JPRB, 0.17626584E-05_JPRB, 0.17630030E-05_JPRB, 0.17635795E-05_JPRB, &
  & 0.17643142E-05_JPRB, 0.17651176E-05_JPRB, 0.17658969E-05_JPRB, 0.17665940E-05_JPRB, 0.17671543E-05_JPRB, 0.17675688E-05_JPRB, &
  & 0.17678334E-05_JPRB, 0.17679009E-05_JPRB, 0.17677529E-05_JPRB, 0.17674461E-05_JPRB, 0.17670698E-05_JPRB, 0.17666794E-05_JPRB, &
  & 0.17662826E-05_JPRB, 0.17659198E-05_JPRB, 0.17656596E-05_JPRB, 0.17655821E-05_JPRB, 0.17657727E-05_JPRB, 0.17662977E-05_JPRB, &
  & 0.17671766E-05_JPRB, 0.17683485E-05_JPRB, 0.17696775E-05_JPRB, 0.17710046E-05_JPRB, 0.17722055E-05_JPRB, 0.17731966E-05_JPRB, &
  & 0.17739296E-05_JPRB, 0.17744155E-05_JPRB, 0.17746920E-05_JPRB, 0.17748074E-05_JPRB, 0.17748245E-05_JPRB, 0.17747786E-05_JPRB, &
  & 0.17747002E-05_JPRB, 0.17745979E-05_JPRB, 0.17744749E-05_JPRB, 0.17743401E-05_JPRB, 0.17742008E-05_JPRB, 0.17740546E-05_JPRB, &
  & 0.17739037E-05_JPRB, 0.17737141E-05_JPRB, 0.17734349E-05_JPRB, 0.17728333E-05_JPRB /)

RGHG2(:,70,12) = (/ &
  & 0.17703135E-05_JPRB, 0.17704749E-05_JPRB, 0.17704394E-05_JPRB, 0.17703188E-05_JPRB, 0.17701059E-05_JPRB, 0.17697776E-05_JPRB, &
  & 0.17693710E-05_JPRB, 0.17690035E-05_JPRB, 0.17689050E-05_JPRB, 0.17689244E-05_JPRB, 0.17689845E-05_JPRB, 0.17690244E-05_JPRB, &
  & 0.17689774E-05_JPRB, 0.17687898E-05_JPRB, 0.17683932E-05_JPRB, 0.17677834E-05_JPRB, 0.17669361E-05_JPRB, 0.17659789E-05_JPRB, &
  & 0.17651016E-05_JPRB, 0.17644740E-05_JPRB, 0.17641767E-05_JPRB, 0.17642082E-05_JPRB, 0.17645227E-05_JPRB, 0.17650457E-05_JPRB, &
  & 0.17657112E-05_JPRB, 0.17664328E-05_JPRB, 0.17671307E-05_JPRB, 0.17677523E-05_JPRB, 0.17682514E-05_JPRB, 0.17686195E-05_JPRB, &
  & 0.17688550E-05_JPRB, 0.17689091E-05_JPRB, 0.17687642E-05_JPRB, 0.17684775E-05_JPRB, 0.17681325E-05_JPRB, 0.17677772E-05_JPRB, &
  & 0.17674141E-05_JPRB, 0.17670789E-05_JPRB, 0.17668403E-05_JPRB, 0.17667752E-05_JPRB, 0.17669661E-05_JPRB, 0.17674699E-05_JPRB, &
  & 0.17683082E-05_JPRB, 0.17694034E-05_JPRB, 0.17706419E-05_JPRB, 0.17718676E-05_JPRB, 0.17729751E-05_JPRB, 0.17738895E-05_JPRB, &
  & 0.17745673E-05_JPRB, 0.17750189E-05_JPRB, 0.17752801E-05_JPRB, 0.17753914E-05_JPRB, 0.17754095E-05_JPRB, 0.17753666E-05_JPRB, &
  & 0.17752913E-05_JPRB, 0.17751896E-05_JPRB, 0.17750666E-05_JPRB, 0.17749289E-05_JPRB, 0.17747872E-05_JPRB, 0.17746411E-05_JPRB, &
  & 0.17744807E-05_JPRB, 0.17742806E-05_JPRB, 0.17739612E-05_JPRB, 0.17732477E-05_JPRB /)

RGHG2(:,71,12) = (/ &
  & 0.17712196E-05_JPRB, 0.17714515E-05_JPRB, 0.17714433E-05_JPRB, 0.17713398E-05_JPRB, 0.17711441E-05_JPRB, 0.17708401E-05_JPRB, &
  & 0.17704660E-05_JPRB, 0.17701483E-05_JPRB, 0.17700810E-05_JPRB, 0.17701141E-05_JPRB, 0.17701759E-05_JPRB, 0.17702087E-05_JPRB, &
  & 0.17701601E-05_JPRB, 0.17699842E-05_JPRB, 0.17696134E-05_JPRB, 0.17690526E-05_JPRB, 0.17682812E-05_JPRB, 0.17674118E-05_JPRB, &
  & 0.17666150E-05_JPRB, 0.17660404E-05_JPRB, 0.17657651E-05_JPRB, 0.17657877E-05_JPRB, 0.17660675E-05_JPRB, 0.17665363E-05_JPRB, &
  & 0.17671280E-05_JPRB, 0.17677697E-05_JPRB, 0.17683853E-05_JPRB, 0.17689340E-05_JPRB, 0.17693725E-05_JPRB, 0.17696965E-05_JPRB, &
  & 0.17699052E-05_JPRB, 0.17699487E-05_JPRB, 0.17698103E-05_JPRB, 0.17695470E-05_JPRB, 0.17692350E-05_JPRB, 0.17689183E-05_JPRB, &
  & 0.17685920E-05_JPRB, 0.17682892E-05_JPRB, 0.17680757E-05_JPRB, 0.17680252E-05_JPRB, 0.17682140E-05_JPRB, 0.17686991E-05_JPRB, &
  & 0.17694798E-05_JPRB, 0.17705028E-05_JPRB, 0.17716329E-05_JPRB, 0.17727514E-05_JPRB, 0.17737566E-05_JPRB, 0.17745874E-05_JPRB, &
  & 0.17752019E-05_JPRB, 0.17756183E-05_JPRB, 0.17758587E-05_JPRB, 0.17759647E-05_JPRB, 0.17759849E-05_JPRB, 0.17759490E-05_JPRB, &
  & 0.17758809E-05_JPRB, 0.17757882E-05_JPRB, 0.17756698E-05_JPRB, 0.17755374E-05_JPRB, 0.17754004E-05_JPRB, 0.17752569E-05_JPRB, &
  & 0.17750991E-05_JPRB, 0.17748940E-05_JPRB, 0.17745568E-05_JPRB, 0.17737738E-05_JPRB /)

RGHG2(:,72,12) = (/ &
  & 0.17721329E-05_JPRB, 0.17724516E-05_JPRB, 0.17724740E-05_JPRB, 0.17723910E-05_JPRB, 0.17722133E-05_JPRB, 0.17719332E-05_JPRB, &
  & 0.17716047E-05_JPRB, 0.17713412E-05_JPRB, 0.17713006E-05_JPRB, 0.17713406E-05_JPRB, 0.17713917E-05_JPRB, 0.17714158E-05_JPRB, &
  & 0.17713654E-05_JPRB, 0.17711978E-05_JPRB, 0.17708583E-05_JPRB, 0.17703469E-05_JPRB, 0.17696545E-05_JPRB, 0.17688716E-05_JPRB, &
  & 0.17681562E-05_JPRB, 0.17676361E-05_JPRB, 0.17673809E-05_JPRB, 0.17673922E-05_JPRB, 0.17676357E-05_JPRB, 0.17680449E-05_JPRB, &
  & 0.17685634E-05_JPRB, 0.17691219E-05_JPRB, 0.17696586E-05_JPRB, 0.17701348E-05_JPRB, 0.17705162E-05_JPRB, 0.17707976E-05_JPRB, &
  & 0.17709816E-05_JPRB, 0.17710166E-05_JPRB, 0.17708880E-05_JPRB, 0.17706520E-05_JPRB, 0.17703755E-05_JPRB, 0.17701000E-05_JPRB, &
  & 0.17698133E-05_JPRB, 0.17695459E-05_JPRB, 0.17693602E-05_JPRB, 0.17693256E-05_JPRB, 0.17695132E-05_JPRB, 0.17699662E-05_JPRB, &
  & 0.17706965E-05_JPRB, 0.17716209E-05_JPRB, 0.17726461E-05_JPRB, 0.17736459E-05_JPRB, 0.17745408E-05_JPRB, 0.17752807E-05_JPRB, &
  & 0.17758332E-05_JPRB, 0.17762039E-05_JPRB, 0.17764271E-05_JPRB, 0.17765265E-05_JPRB, 0.17765499E-05_JPRB, 0.17765215E-05_JPRB, &
  & 0.17764664E-05_JPRB, 0.17763836E-05_JPRB, 0.17762800E-05_JPRB, 0.17761538E-05_JPRB, 0.17760295E-05_JPRB, 0.17758922E-05_JPRB, &
  & 0.17757415E-05_JPRB, 0.17755444E-05_JPRB, 0.17752027E-05_JPRB, 0.17743865E-05_JPRB /)

RGHG2(:,73,12) = (/ &
  & 0.17731472E-05_JPRB, 0.17734980E-05_JPRB, 0.17735325E-05_JPRB, 0.17734608E-05_JPRB, 0.17733009E-05_JPRB, 0.17730495E-05_JPRB, &
  & 0.17727687E-05_JPRB, 0.17725587E-05_JPRB, 0.17725345E-05_JPRB, 0.17725713E-05_JPRB, 0.17726177E-05_JPRB, 0.17726300E-05_JPRB, &
  & 0.17725741E-05_JPRB, 0.17724204E-05_JPRB, 0.17721137E-05_JPRB, 0.17716513E-05_JPRB, 0.17710368E-05_JPRB, 0.17703455E-05_JPRB, &
  & 0.17697133E-05_JPRB, 0.17692503E-05_JPRB, 0.17690161E-05_JPRB, 0.17690154E-05_JPRB, 0.17692190E-05_JPRB, 0.17695703E-05_JPRB, &
  & 0.17700123E-05_JPRB, 0.17704911E-05_JPRB, 0.17709477E-05_JPRB, 0.17713541E-05_JPRB, 0.17716790E-05_JPRB, 0.17719194E-05_JPRB, &
  & 0.17720802E-05_JPRB, 0.17721096E-05_JPRB, 0.17719952E-05_JPRB, 0.17717884E-05_JPRB, 0.17715496E-05_JPRB, 0.17713169E-05_JPRB, &
  & 0.17710705E-05_JPRB, 0.17708415E-05_JPRB, 0.17706855E-05_JPRB, 0.17706680E-05_JPRB, 0.17708483E-05_JPRB, 0.17712709E-05_JPRB, &
  & 0.17719250E-05_JPRB, 0.17727571E-05_JPRB, 0.17736598E-05_JPRB, 0.17745333E-05_JPRB, 0.17753184E-05_JPRB, 0.17759668E-05_JPRB, &
  & 0.17764440E-05_JPRB, 0.17767813E-05_JPRB, 0.17769768E-05_JPRB, 0.17770709E-05_JPRB, 0.17770974E-05_JPRB, 0.17770792E-05_JPRB, &
  & 0.17770337E-05_JPRB, 0.17769681E-05_JPRB, 0.17768735E-05_JPRB, 0.17767657E-05_JPRB, 0.17766497E-05_JPRB, 0.17765275E-05_JPRB, &
  & 0.17763880E-05_JPRB, 0.17762044E-05_JPRB, 0.17758741E-05_JPRB, 0.17750560E-05_JPRB /)

RGHG2(:,74,12) = (/ &
  & 0.17741656E-05_JPRB, 0.17745480E-05_JPRB, 0.17745924E-05_JPRB, 0.17745327E-05_JPRB, 0.17743926E-05_JPRB, 0.17741722E-05_JPRB, &
  & 0.17739360E-05_JPRB, 0.17737666E-05_JPRB, 0.17737543E-05_JPRB, 0.17737925E-05_JPRB, 0.17738248E-05_JPRB, 0.17738312E-05_JPRB, &
  & 0.17737800E-05_JPRB, 0.17736338E-05_JPRB, 0.17733618E-05_JPRB, 0.17729537E-05_JPRB, 0.17724194E-05_JPRB, 0.17718193E-05_JPRB, &
  & 0.17712774E-05_JPRB, 0.17708741E-05_JPRB, 0.17706627E-05_JPRB, 0.17706510E-05_JPRB, 0.17708168E-05_JPRB, 0.17711067E-05_JPRB, &
  & 0.17714744E-05_JPRB, 0.17718706E-05_JPRB, 0.17722508E-05_JPRB, 0.17725885E-05_JPRB, 0.17728595E-05_JPRB, 0.17730609E-05_JPRB, &
  & 0.17731993E-05_JPRB, 0.17732247E-05_JPRB, 0.17731265E-05_JPRB, 0.17729509E-05_JPRB, 0.17727530E-05_JPRB, 0.17725631E-05_JPRB, &
  & 0.17723590E-05_JPRB, 0.17721707E-05_JPRB, 0.17720438E-05_JPRB, 0.17720417E-05_JPRB, 0.17722119E-05_JPRB, 0.17725885E-05_JPRB, &
  & 0.17731672E-05_JPRB, 0.17738864E-05_JPRB, 0.17746601E-05_JPRB, 0.17754135E-05_JPRB, 0.17760779E-05_JPRB, 0.17766309E-05_JPRB, &
  & 0.17770462E-05_JPRB, 0.17773305E-05_JPRB, 0.17775088E-05_JPRB, 0.17775943E-05_JPRB, 0.17776222E-05_JPRB, 0.17776101E-05_JPRB, &
  & 0.17775776E-05_JPRB, 0.17775209E-05_JPRB, 0.17774456E-05_JPRB, 0.17773457E-05_JPRB, 0.17772517E-05_JPRB, 0.17771397E-05_JPRB, &
  & 0.17770169E-05_JPRB, 0.17768572E-05_JPRB, 0.17765447E-05_JPRB, 0.17757566E-05_JPRB /)

RGHG2(:,75,12) = (/ &
  & 0.17751744E-05_JPRB, 0.17755801E-05_JPRB, 0.17756352E-05_JPRB, 0.17755885E-05_JPRB, 0.17754726E-05_JPRB, 0.17752852E-05_JPRB, &
  & 0.17750884E-05_JPRB, 0.17749508E-05_JPRB, 0.17749468E-05_JPRB, 0.17749792E-05_JPRB, 0.17750108E-05_JPRB, 0.17750128E-05_JPRB, &
  & 0.17749601E-05_JPRB, 0.17748372E-05_JPRB, 0.17745970E-05_JPRB, 0.17742462E-05_JPRB, 0.17737950E-05_JPRB, 0.17732939E-05_JPRB, &
  & 0.17728424E-05_JPRB, 0.17725037E-05_JPRB, 0.17723189E-05_JPRB, 0.17722988E-05_JPRB, 0.17724275E-05_JPRB, 0.17726587E-05_JPRB, &
  & 0.17729524E-05_JPRB, 0.17732697E-05_JPRB, 0.17735740E-05_JPRB, 0.17738453E-05_JPRB, 0.17740635E-05_JPRB, 0.17742259E-05_JPRB, &
  & 0.17743425E-05_JPRB, 0.17743645E-05_JPRB, 0.17742851E-05_JPRB, 0.17741409E-05_JPRB, 0.17739860E-05_JPRB, 0.17738359E-05_JPRB, &
  & 0.17736758E-05_JPRB, 0.17735273E-05_JPRB, 0.17734292E-05_JPRB, 0.17734403E-05_JPRB, 0.17735924E-05_JPRB, 0.17739184E-05_JPRB, &
  & 0.17744043E-05_JPRB, 0.17750057E-05_JPRB, 0.17756538E-05_JPRB, 0.17762659E-05_JPRB, 0.17768222E-05_JPRB, 0.17772787E-05_JPRB, &
  & 0.17776172E-05_JPRB, 0.17778631E-05_JPRB, 0.17780126E-05_JPRB, 0.17780897E-05_JPRB, 0.17781185E-05_JPRB, 0.17781114E-05_JPRB, &
  & 0.17780857E-05_JPRB, 0.17780430E-05_JPRB, 0.17779770E-05_JPRB, 0.17778964E-05_JPRB, 0.17778164E-05_JPRB, 0.17777228E-05_JPRB, &
  & 0.17776191E-05_JPRB, 0.17774832E-05_JPRB, 0.17772066E-05_JPRB, 0.17764671E-05_JPRB /)

RGHG2(:,76,12) = (/ &
  & 0.17761610E-05_JPRB, 0.17765858E-05_JPRB, 0.17766479E-05_JPRB, 0.17766156E-05_JPRB, 0.17765290E-05_JPRB, 0.17763759E-05_JPRB, &
  & 0.17762183E-05_JPRB, 0.17761020E-05_JPRB, 0.17761026E-05_JPRB, 0.17761355E-05_JPRB, 0.17761542E-05_JPRB, 0.17761546E-05_JPRB, &
  & 0.17761143E-05_JPRB, 0.17760065E-05_JPRB, 0.17758118E-05_JPRB, 0.17755270E-05_JPRB, 0.17751677E-05_JPRB, 0.17747659E-05_JPRB, &
  & 0.17744112E-05_JPRB, 0.17741382E-05_JPRB, 0.17739843E-05_JPRB, 0.17739605E-05_JPRB, 0.17740554E-05_JPRB, 0.17742293E-05_JPRB, &
  & 0.17744499E-05_JPRB, 0.17746886E-05_JPRB, 0.17749206E-05_JPRB, 0.17751270E-05_JPRB, 0.17752944E-05_JPRB, 0.17754181E-05_JPRB, &
  & 0.17755133E-05_JPRB, 0.17755309E-05_JPRB, 0.17754707E-05_JPRB, 0.17753591E-05_JPRB, 0.17752479E-05_JPRB, 0.17751349E-05_JPRB, &
  & 0.17750200E-05_JPRB, 0.17749076E-05_JPRB, 0.17748355E-05_JPRB, 0.17748564E-05_JPRB, 0.17749844E-05_JPRB, 0.17752479E-05_JPRB, &
  & 0.17756367E-05_JPRB, 0.17761170E-05_JPRB, 0.17766226E-05_JPRB, 0.17771110E-05_JPRB, 0.17775408E-05_JPRB, 0.17779023E-05_JPRB, &
  & 0.17781691E-05_JPRB, 0.17783632E-05_JPRB, 0.17784876E-05_JPRB, 0.17785546E-05_JPRB, 0.17785809E-05_JPRB, 0.17785758E-05_JPRB, &
  & 0.17785578E-05_JPRB, 0.17785242E-05_JPRB, 0.17784733E-05_JPRB, 0.17784051E-05_JPRB, 0.17783491E-05_JPRB, 0.17782712E-05_JPRB, &
  & 0.17781861E-05_JPRB, 0.17780859E-05_JPRB, 0.17778445E-05_JPRB, 0.17771791E-05_JPRB /)

RGHG2(:,77,12) = (/ &
  & 0.17771248E-05_JPRB, 0.17775444E-05_JPRB, 0.17776131E-05_JPRB, 0.17775959E-05_JPRB, 0.17775413E-05_JPRB, 0.17774253E-05_JPRB, &
  & 0.17773077E-05_JPRB, 0.17772157E-05_JPRB, 0.17772181E-05_JPRB, 0.17772375E-05_JPRB, 0.17772459E-05_JPRB, 0.17772434E-05_JPRB, &
  & 0.17772096E-05_JPRB, 0.17771370E-05_JPRB, 0.17769901E-05_JPRB, 0.17767823E-05_JPRB, 0.17765221E-05_JPRB, 0.17762272E-05_JPRB, &
  & 0.17759706E-05_JPRB, 0.17757683E-05_JPRB, 0.17756493E-05_JPRB, 0.17756266E-05_JPRB, 0.17756921E-05_JPRB, 0.17758114E-05_JPRB, &
  & 0.17759635E-05_JPRB, 0.17761286E-05_JPRB, 0.17762927E-05_JPRB, 0.17764380E-05_JPRB, 0.17765569E-05_JPRB, 0.17766417E-05_JPRB, &
  & 0.17767138E-05_JPRB, 0.17767259E-05_JPRB, 0.17766843E-05_JPRB, 0.17766022E-05_JPRB, 0.17765303E-05_JPRB, 0.17764493E-05_JPRB, &
  & 0.17763784E-05_JPRB, 0.17762983E-05_JPRB, 0.17762482E-05_JPRB, 0.17762736E-05_JPRB, 0.17763692E-05_JPRB, 0.17765651E-05_JPRB, &
  & 0.17768483E-05_JPRB, 0.17772028E-05_JPRB, 0.17775744E-05_JPRB, 0.17779214E-05_JPRB, 0.17782368E-05_JPRB, 0.17784976E-05_JPRB, &
  & 0.17786881E-05_JPRB, 0.17788338E-05_JPRB, 0.17789275E-05_JPRB, 0.17789808E-05_JPRB, 0.17790046E-05_JPRB, 0.17789993E-05_JPRB, &
  & 0.17789869E-05_JPRB, 0.17789631E-05_JPRB, 0.17789249E-05_JPRB, 0.17788725E-05_JPRB, 0.17788395E-05_JPRB, 0.17787783E-05_JPRB, &
  & 0.17787148E-05_JPRB, 0.17786475E-05_JPRB, 0.17784560E-05_JPRB, 0.17778826E-05_JPRB /)

RGHG2(:,78,12) = (/ &
  & 0.17780507E-05_JPRB, 0.17784150E-05_JPRB, 0.17784645E-05_JPRB, 0.17784591E-05_JPRB, 0.17784361E-05_JPRB, 0.17783578E-05_JPRB, &
  & 0.17782868E-05_JPRB, 0.17782226E-05_JPRB, 0.17782214E-05_JPRB, 0.17782252E-05_JPRB, 0.17782143E-05_JPRB, 0.17782083E-05_JPRB, &
  & 0.17781889E-05_JPRB, 0.17781499E-05_JPRB, 0.17780600E-05_JPRB, 0.17779329E-05_JPRB, 0.17777744E-05_JPRB, 0.17775835E-05_JPRB, &
  & 0.17774267E-05_JPRB, 0.17772963E-05_JPRB, 0.17772180E-05_JPRB, 0.17772040E-05_JPRB, 0.17772470E-05_JPRB, 0.17773186E-05_JPRB, &
  & 0.17774113E-05_JPRB, 0.17775117E-05_JPRB, 0.17776168E-05_JPRB, 0.17777083E-05_JPRB, 0.17777832E-05_JPRB, 0.17778316E-05_JPRB, &
  & 0.17778807E-05_JPRB, 0.17778855E-05_JPRB, 0.17778584E-05_JPRB, 0.17778007E-05_JPRB, 0.17777628E-05_JPRB, 0.17777073E-05_JPRB, &
  & 0.17776727E-05_JPRB, 0.17776171E-05_JPRB, 0.17775806E-05_JPRB, 0.17776032E-05_JPRB, 0.17776605E-05_JPRB, 0.17777838E-05_JPRB, &
  & 0.17779638E-05_JPRB, 0.17781967E-05_JPRB, 0.17784378E-05_JPRB, 0.17786592E-05_JPRB, 0.17788593E-05_JPRB, 0.17790281E-05_JPRB, &
  & 0.17791465E-05_JPRB, 0.17792444E-05_JPRB, 0.17793070E-05_JPRB, 0.17793468E-05_JPRB, 0.17793647E-05_JPRB, 0.17793568E-05_JPRB, &
  & 0.17793494E-05_JPRB, 0.17793327E-05_JPRB, 0.17793061E-05_JPRB, 0.17792679E-05_JPRB, 0.17792570E-05_JPRB, 0.17792113E-05_JPRB, &
  & 0.17791659E-05_JPRB, 0.17791335E-05_JPRB, 0.17790052E-05_JPRB, 0.17785696E-05_JPRB /)

RGHG2(:,79,12) = (/ &
  & 0.17786439E-05_JPRB, 0.17789000E-05_JPRB, 0.17789157E-05_JPRB, 0.17789037E-05_JPRB, 0.17788986E-05_JPRB, 0.17788375E-05_JPRB, &
  & 0.17787922E-05_JPRB, 0.17787418E-05_JPRB, 0.17787410E-05_JPRB, 0.17787378E-05_JPRB, 0.17787175E-05_JPRB, 0.17787115E-05_JPRB, &
  & 0.17786992E-05_JPRB, 0.17786805E-05_JPRB, 0.17786190E-05_JPRB, 0.17785344E-05_JPRB, 0.17784312E-05_JPRB, 0.17782976E-05_JPRB, &
  & 0.17781973E-05_JPRB, 0.17781081E-05_JPRB, 0.17780525E-05_JPRB, 0.17780458E-05_JPRB, 0.17780798E-05_JPRB, 0.17781279E-05_JPRB, &
  & 0.17781897E-05_JPRB, 0.17782565E-05_JPRB, 0.17783317E-05_JPRB, 0.17783950E-05_JPRB, 0.17784469E-05_JPRB, 0.17784747E-05_JPRB, &
  & 0.17785129E-05_JPRB, 0.17785123E-05_JPRB, 0.17784939E-05_JPRB, 0.17784482E-05_JPRB, 0.17784290E-05_JPRB, 0.17783857E-05_JPRB, &
  & 0.17783710E-05_JPRB, 0.17783266E-05_JPRB, 0.17782952E-05_JPRB, 0.17783158E-05_JPRB, 0.17783499E-05_JPRB, 0.17784332E-05_JPRB, &
  & 0.17785560E-05_JPRB, 0.17787274E-05_JPRB, 0.17788988E-05_JPRB, 0.17790517E-05_JPRB, 0.17791904E-05_JPRB, 0.17793094E-05_JPRB, &
  & 0.17793875E-05_JPRB, 0.17794607E-05_JPRB, 0.17795069E-05_JPRB, 0.17795396E-05_JPRB, 0.17795544E-05_JPRB, 0.17795436E-05_JPRB, &
  & 0.17795381E-05_JPRB, 0.17795243E-05_JPRB, 0.17795036E-05_JPRB, 0.17794711E-05_JPRB, 0.17794735E-05_JPRB, 0.17794334E-05_JPRB, &
  & 0.17793977E-05_JPRB, 0.17793926E-05_JPRB, 0.17793127E-05_JPRB, 0.17790096E-05_JPRB /)

RGHG2(:,80,12) = (/ &
  & 0.17790326E-05_JPRB, 0.17791334E-05_JPRB, 0.17791118E-05_JPRB, 0.17790952E-05_JPRB, 0.17790965E-05_JPRB, 0.17790422E-05_JPRB, &
  & 0.17790078E-05_JPRB, 0.17789662E-05_JPRB, 0.17789670E-05_JPRB, 0.17789636E-05_JPRB, 0.17789396E-05_JPRB, 0.17789350E-05_JPRB, &
  & 0.17789262E-05_JPRB, 0.17789160E-05_JPRB, 0.17788659E-05_JPRB, 0.17787995E-05_JPRB, 0.17787214E-05_JPRB, 0.17786125E-05_JPRB, &
  & 0.17785403E-05_JPRB, 0.17784693E-05_JPRB, 0.17784253E-05_JPRB, 0.17784228E-05_JPRB, 0.17784540E-05_JPRB, 0.17784922E-05_JPRB, &
  & 0.17785408E-05_JPRB, 0.17785933E-05_JPRB, 0.17786560E-05_JPRB, 0.17787072E-05_JPRB, 0.17787493E-05_JPRB, 0.17787677E-05_JPRB, &
  & 0.17788009E-05_JPRB, 0.17787979E-05_JPRB, 0.17787820E-05_JPRB, 0.17787413E-05_JPRB, 0.17787312E-05_JPRB, 0.17786924E-05_JPRB, &
  & 0.17786870E-05_JPRB, 0.17786467E-05_JPRB, 0.17786163E-05_JPRB, 0.17786360E-05_JPRB, 0.17786585E-05_JPRB, 0.17787229E-05_JPRB, &
  & 0.17788204E-05_JPRB, 0.17789639E-05_JPRB, 0.17791060E-05_JPRB, 0.17792264E-05_JPRB, 0.17793378E-05_JPRB, 0.17794334E-05_JPRB, &
  & 0.17794930E-05_JPRB, 0.17795558E-05_JPRB, 0.17795945E-05_JPRB, 0.17796247E-05_JPRB, 0.17796378E-05_JPRB, 0.17796249E-05_JPRB, &
  & 0.17796201E-05_JPRB, 0.17796070E-05_JPRB, 0.17795880E-05_JPRB, 0.17795572E-05_JPRB, 0.17795662E-05_JPRB, 0.17795281E-05_JPRB, &
  & 0.17794966E-05_JPRB, 0.17795064E-05_JPRB, 0.17794620E-05_JPRB, 0.17792988E-05_JPRB /)

RGHG2(:,81,12) = (/ &
  & 0.17792958E-05_JPRB, 0.17792320E-05_JPRB, 0.17791946E-05_JPRB, 0.17791760E-05_JPRB, 0.17791809E-05_JPRB, 0.17791293E-05_JPRB, &
  & 0.17791012E-05_JPRB, 0.17790618E-05_JPRB, 0.17790643E-05_JPRB, 0.17790608E-05_JPRB, 0.17790373E-05_JPRB, 0.17790334E-05_JPRB, &
  & 0.17790261E-05_JPRB, 0.17790197E-05_JPRB, 0.17789739E-05_JPRB, 0.17789150E-05_JPRB, 0.17788477E-05_JPRB, 0.17787497E-05_JPRB, &
  & 0.17786894E-05_JPRB, 0.17786275E-05_JPRB, 0.17785877E-05_JPRB, 0.17785877E-05_JPRB, 0.17786185E-05_JPRB, 0.17786523E-05_JPRB, &
  & 0.17786952E-05_JPRB, 0.17787412E-05_JPRB, 0.17787986E-05_JPRB, 0.17788452E-05_JPRB, 0.17788830E-05_JPRB, 0.17788966E-05_JPRB, &
  & 0.17789285E-05_JPRB, 0.17789234E-05_JPRB, 0.17789091E-05_JPRB, 0.17788699E-05_JPRB, 0.17788642E-05_JPRB, 0.17788271E-05_JPRB, &
  & 0.17788262E-05_JPRB, 0.17787874E-05_JPRB, 0.17787573E-05_JPRB, 0.17787767E-05_JPRB, 0.17787936E-05_JPRB, 0.17788492E-05_JPRB, &
  & 0.17789350E-05_JPRB, 0.17790684E-05_JPRB, 0.17791967E-05_JPRB, 0.17793041E-05_JPRB, 0.17794011E-05_JPRB, 0.17794873E-05_JPRB, &
  & 0.17795386E-05_JPRB, 0.17795968E-05_JPRB, 0.17796324E-05_JPRB, 0.17796616E-05_JPRB, 0.17796746E-05_JPRB, 0.17796599E-05_JPRB, &
  & 0.17796553E-05_JPRB, 0.17796425E-05_JPRB, 0.17796242E-05_JPRB, 0.17795934E-05_JPRB, 0.17796062E-05_JPRB, 0.17795680E-05_JPRB, &
  & 0.17795378E-05_JPRB, 0.17795553E-05_JPRB, 0.17795255E-05_JPRB, 0.17794958E-05_JPRB /)

RGHG2(:,82,12) = (/ &
  & 0.17793169E-05_JPRB, 0.17792652E-05_JPRB, 0.17792307E-05_JPRB, 0.17792139E-05_JPRB, 0.17792213E-05_JPRB, 0.17791713E-05_JPRB, &
  & 0.17791444E-05_JPRB, 0.17791084E-05_JPRB, 0.17791117E-05_JPRB, 0.17791098E-05_JPRB, 0.17790838E-05_JPRB, 0.17790813E-05_JPRB, &
  & 0.17790748E-05_JPRB, 0.17790707E-05_JPRB, 0.17790269E-05_JPRB, 0.17789715E-05_JPRB, 0.17789096E-05_JPRB, 0.17788159E-05_JPRB, &
  & 0.17787632E-05_JPRB, 0.17787038E-05_JPRB, 0.17786670E-05_JPRB, 0.17786682E-05_JPRB, 0.17786984E-05_JPRB, 0.17787301E-05_JPRB, &
  & 0.17787702E-05_JPRB, 0.17788135E-05_JPRB, 0.17788686E-05_JPRB, 0.17789127E-05_JPRB, 0.17789487E-05_JPRB, 0.17789599E-05_JPRB, &
  & 0.17789910E-05_JPRB, 0.17789846E-05_JPRB, 0.17789706E-05_JPRB, 0.17789325E-05_JPRB, 0.17789288E-05_JPRB, 0.17788932E-05_JPRB, &
  & 0.17788934E-05_JPRB, 0.17788560E-05_JPRB, 0.17788268E-05_JPRB, 0.17788452E-05_JPRB, 0.17788595E-05_JPRB, 0.17789107E-05_JPRB, &
  & 0.17789904E-05_JPRB, 0.17791187E-05_JPRB, 0.17792426E-05_JPRB, 0.17793413E-05_JPRB, 0.17794330E-05_JPRB, 0.17795132E-05_JPRB, &
  & 0.17795602E-05_JPRB, 0.17796165E-05_JPRB, 0.17796505E-05_JPRB, 0.17796800E-05_JPRB, 0.17796923E-05_JPRB, 0.17796768E-05_JPRB, &
  & 0.17796721E-05_JPRB, 0.17796592E-05_JPRB, 0.17796415E-05_JPRB, 0.17796106E-05_JPRB, 0.17796254E-05_JPRB, 0.17795871E-05_JPRB, &
  & 0.17795571E-05_JPRB, 0.17795768E-05_JPRB, 0.17795471E-05_JPRB, 0.17795115E-05_JPRB /)

RGHG2(:,83,12) = (/ &
  & 0.17793315E-05_JPRB, 0.17792848E-05_JPRB, 0.17792511E-05_JPRB, 0.17792348E-05_JPRB, 0.17792438E-05_JPRB, 0.17791940E-05_JPRB, &
  & 0.17791699E-05_JPRB, 0.17791336E-05_JPRB, 0.17791377E-05_JPRB, 0.17791351E-05_JPRB, 0.17791119E-05_JPRB, 0.17791085E-05_JPRB, &
  & 0.17791025E-05_JPRB, 0.17790992E-05_JPRB, 0.17790562E-05_JPRB, 0.17790029E-05_JPRB, 0.17789437E-05_JPRB, 0.17788533E-05_JPRB, &
  & 0.17788030E-05_JPRB, 0.17787478E-05_JPRB, 0.17787103E-05_JPRB, 0.17787124E-05_JPRB, 0.17787434E-05_JPRB, 0.17787736E-05_JPRB, &
  & 0.17788126E-05_JPRB, 0.17788535E-05_JPRB, 0.17789077E-05_JPRB, 0.17789504E-05_JPRB, 0.17789855E-05_JPRB, 0.17789947E-05_JPRB, &
  & 0.17790260E-05_JPRB, 0.17790187E-05_JPRB, 0.17790048E-05_JPRB, 0.17789673E-05_JPRB, 0.17789644E-05_JPRB, 0.17789303E-05_JPRB, &
  & 0.17789305E-05_JPRB, 0.17788948E-05_JPRB, 0.17788666E-05_JPRB, 0.17788836E-05_JPRB, 0.17788973E-05_JPRB, 0.17789439E-05_JPRB, &
  & 0.17790217E-05_JPRB, 0.17791459E-05_JPRB, 0.17792674E-05_JPRB, 0.17793636E-05_JPRB, 0.17794503E-05_JPRB, 0.17795281E-05_JPRB, &
  & 0.17795716E-05_JPRB, 0.17796275E-05_JPRB, 0.17796605E-05_JPRB, 0.17796903E-05_JPRB, 0.17797024E-05_JPRB, 0.17796865E-05_JPRB, &
  & 0.17796815E-05_JPRB, 0.17796685E-05_JPRB, 0.17796510E-05_JPRB, 0.17796197E-05_JPRB, 0.17796361E-05_JPRB, 0.17795976E-05_JPRB, &
  & 0.17795674E-05_JPRB, 0.17795890E-05_JPRB, 0.17795597E-05_JPRB, 0.17795222E-05_JPRB /)

RGHG2(:,84,12) = (/ &
  & 0.17793412E-05_JPRB, 0.17792973E-05_JPRB, 0.17792637E-05_JPRB, 0.17792477E-05_JPRB, 0.17792577E-05_JPRB, 0.17792083E-05_JPRB, &
  & 0.17791835E-05_JPRB, 0.17791504E-05_JPRB, 0.17791542E-05_JPRB, 0.17791519E-05_JPRB, 0.17791278E-05_JPRB, 0.17791251E-05_JPRB, &
  & 0.17791194E-05_JPRB, 0.17791162E-05_JPRB, 0.17790748E-05_JPRB, 0.17790225E-05_JPRB, 0.17789653E-05_JPRB, 0.17788759E-05_JPRB, &
  & 0.17788293E-05_JPRB, 0.17787730E-05_JPRB, 0.17787381E-05_JPRB, 0.17787405E-05_JPRB, 0.17787706E-05_JPRB, 0.17788002E-05_JPRB, &
  & 0.17788382E-05_JPRB, 0.17788784E-05_JPRB, 0.17789321E-05_JPRB, 0.17789738E-05_JPRB, 0.17790082E-05_JPRB, 0.17790161E-05_JPRB, &
  & 0.17790476E-05_JPRB, 0.17790394E-05_JPRB, 0.17790254E-05_JPRB, 0.17789880E-05_JPRB, 0.17789853E-05_JPRB, 0.17789528E-05_JPRB, &
  & 0.17789528E-05_JPRB, 0.17789182E-05_JPRB, 0.17788914E-05_JPRB, 0.17789077E-05_JPRB, 0.17789198E-05_JPRB, 0.17789658E-05_JPRB, &
  & 0.17790380E-05_JPRB, 0.17791647E-05_JPRB, 0.17792829E-05_JPRB, 0.17793767E-05_JPRB, 0.17794611E-05_JPRB, 0.17795367E-05_JPRB, &
  & 0.17795787E-05_JPRB, 0.17796337E-05_JPRB, 0.17796667E-05_JPRB, 0.17796966E-05_JPRB, 0.17797088E-05_JPRB, 0.17796923E-05_JPRB, &
  & 0.17796872E-05_JPRB, 0.17796742E-05_JPRB, 0.17796566E-05_JPRB, 0.17796252E-05_JPRB, 0.17796428E-05_JPRB, 0.17796041E-05_JPRB, &
  & 0.17795735E-05_JPRB, 0.17795966E-05_JPRB, 0.17795682E-05_JPRB, 0.17795295E-05_JPRB /)

RGHG2(:,85,12) = (/ &
  & 0.17793478E-05_JPRB, 0.17793060E-05_JPRB, 0.17792715E-05_JPRB, 0.17792556E-05_JPRB, 0.17792669E-05_JPRB, 0.17792165E-05_JPRB, &
  & 0.17791926E-05_JPRB, 0.17791608E-05_JPRB, 0.17791629E-05_JPRB, 0.17791585E-05_JPRB, 0.17791409E-05_JPRB, 0.17791360E-05_JPRB, &
  & 0.17791307E-05_JPRB, 0.17791252E-05_JPRB, 0.17790866E-05_JPRB, 0.17790354E-05_JPRB, 0.17789791E-05_JPRB, 0.17788921E-05_JPRB, &
  & 0.17788454E-05_JPRB, 0.17787914E-05_JPRB, 0.17787545E-05_JPRB, 0.17787573E-05_JPRB, 0.17787885E-05_JPRB, 0.17788171E-05_JPRB, &
  & 0.17788545E-05_JPRB, 0.17788940E-05_JPRB, 0.17789480E-05_JPRB, 0.17789894E-05_JPRB, 0.17790233E-05_JPRB, 0.17790302E-05_JPRB, &
  & 0.17790617E-05_JPRB, 0.17790528E-05_JPRB, 0.17790383E-05_JPRB, 0.17790011E-05_JPRB, 0.17789990E-05_JPRB, 0.17789673E-05_JPRB, &
  & 0.17789673E-05_JPRB, 0.17789340E-05_JPRB, 0.17789068E-05_JPRB, 0.17789228E-05_JPRB, 0.17789348E-05_JPRB, 0.17789773E-05_JPRB, &
  & 0.17790530E-05_JPRB, 0.17791739E-05_JPRB, 0.17792951E-05_JPRB, 0.17793859E-05_JPRB, 0.17794674E-05_JPRB, 0.17795421E-05_JPRB, &
  & 0.17795829E-05_JPRB, 0.17796378E-05_JPRB, 0.17796708E-05_JPRB, 0.17797011E-05_JPRB, 0.17797132E-05_JPRB, 0.17796963E-05_JPRB, &
  & 0.17796910E-05_JPRB, 0.17796779E-05_JPRB, 0.17796601E-05_JPRB, 0.17796285E-05_JPRB, 0.17796474E-05_JPRB, 0.17796082E-05_JPRB, &
  & 0.17795772E-05_JPRB, 0.17796018E-05_JPRB, 0.17795738E-05_JPRB, 0.17795345E-05_JPRB /)

RGHG2(:,86,12) = (/ &
  & 0.17793517E-05_JPRB, 0.17793112E-05_JPRB, 0.17792765E-05_JPRB, 0.17792604E-05_JPRB, 0.17792728E-05_JPRB, 0.17792215E-05_JPRB, &
  & 0.17791964E-05_JPRB, 0.17791688E-05_JPRB, 0.17791677E-05_JPRB, 0.17791627E-05_JPRB, 0.17791485E-05_JPRB, 0.17791428E-05_JPRB, &
  & 0.17791369E-05_JPRB, 0.17791292E-05_JPRB, 0.17790940E-05_JPRB, 0.17790446E-05_JPRB, 0.17789880E-05_JPRB, 0.17789035E-05_JPRB, &
  & 0.17788573E-05_JPRB, 0.17788025E-05_JPRB, 0.17787654E-05_JPRB, 0.17787678E-05_JPRB, 0.17787989E-05_JPRB, 0.17788275E-05_JPRB, &
  & 0.17788647E-05_JPRB, 0.17789039E-05_JPRB, 0.17789589E-05_JPRB, 0.17789998E-05_JPRB, 0.17790330E-05_JPRB, 0.17790386E-05_JPRB, &
  & 0.17790707E-05_JPRB, 0.17790612E-05_JPRB, 0.17790466E-05_JPRB, 0.17790094E-05_JPRB, 0.17790080E-05_JPRB, 0.17789765E-05_JPRB, &
  & 0.17789775E-05_JPRB, 0.17789436E-05_JPRB, 0.17789155E-05_JPRB, 0.17789325E-05_JPRB, 0.17789424E-05_JPRB, 0.17789869E-05_JPRB, &
  & 0.17790575E-05_JPRB, 0.17791856E-05_JPRB, 0.17793022E-05_JPRB, 0.17793924E-05_JPRB, 0.17794719E-05_JPRB, 0.17795459E-05_JPRB, &
  & 0.17795855E-05_JPRB, 0.17796402E-05_JPRB, 0.17796733E-05_JPRB, 0.17797040E-05_JPRB, 0.17797164E-05_JPRB, 0.17796989E-05_JPRB, &
  & 0.17796933E-05_JPRB, 0.17796800E-05_JPRB, 0.17796622E-05_JPRB, 0.17796307E-05_JPRB, 0.17796503E-05_JPRB, 0.17796109E-05_JPRB, &
  & 0.17795794E-05_JPRB, 0.17796051E-05_JPRB, 0.17795775E-05_JPRB, 0.17795381E-05_JPRB /)

RGHG2(:,87,12) = (/ &
  & 0.17793540E-05_JPRB, 0.17793149E-05_JPRB, 0.17792801E-05_JPRB, 0.17792630E-05_JPRB, 0.17792761E-05_JPRB, 0.17792227E-05_JPRB, &
  & 0.17791975E-05_JPRB, 0.17791731E-05_JPRB, 0.17791701E-05_JPRB, 0.17791649E-05_JPRB, 0.17791526E-05_JPRB, 0.17791472E-05_JPRB, &
  & 0.17791401E-05_JPRB, 0.17791309E-05_JPRB, 0.17790976E-05_JPRB, 0.17790502E-05_JPRB, 0.17789945E-05_JPRB, 0.17789112E-05_JPRB, &
  & 0.17788650E-05_JPRB, 0.17788100E-05_JPRB, 0.17787714E-05_JPRB, 0.17787735E-05_JPRB, 0.17788055E-05_JPRB, 0.17788335E-05_JPRB, &
  & 0.17788709E-05_JPRB, 0.17789097E-05_JPRB, 0.17789660E-05_JPRB, 0.17790069E-05_JPRB, 0.17790397E-05_JPRB, 0.17790441E-05_JPRB, &
  & 0.17790760E-05_JPRB, 0.17790661E-05_JPRB, 0.17790513E-05_JPRB, 0.17790139E-05_JPRB, 0.17790136E-05_JPRB, 0.17789816E-05_JPRB, &
  & 0.17789845E-05_JPRB, 0.17789495E-05_JPRB, 0.17789190E-05_JPRB, 0.17789378E-05_JPRB, 0.17789467E-05_JPRB, 0.17789901E-05_JPRB, &
  & 0.17790643E-05_JPRB, 0.17791904E-05_JPRB, 0.17793093E-05_JPRB, 0.17793966E-05_JPRB, 0.17794746E-05_JPRB, 0.17795478E-05_JPRB, &
  & 0.17795870E-05_JPRB, 0.17796415E-05_JPRB, 0.17796751E-05_JPRB, 0.17797059E-05_JPRB, 0.17797182E-05_JPRB, 0.17797004E-05_JPRB, &
  & 0.17796945E-05_JPRB, 0.17796809E-05_JPRB, 0.17796635E-05_JPRB, 0.17796315E-05_JPRB, 0.17796519E-05_JPRB, 0.17796126E-05_JPRB, &
  & 0.17795804E-05_JPRB, 0.17796074E-05_JPRB, 0.17795800E-05_JPRB, 0.17795405E-05_JPRB /)

RGHG2(:,88,12) = (/ &
  & 0.17793546E-05_JPRB, 0.17793169E-05_JPRB, 0.17792820E-05_JPRB, 0.17792645E-05_JPRB, 0.17792779E-05_JPRB, 0.17792245E-05_JPRB, &
  & 0.17791997E-05_JPRB, 0.17791752E-05_JPRB, 0.17791723E-05_JPRB, 0.17791668E-05_JPRB, 0.17791558E-05_JPRB, 0.17791494E-05_JPRB, &
  & 0.17791428E-05_JPRB, 0.17791323E-05_JPRB, 0.17791006E-05_JPRB, 0.17790538E-05_JPRB, 0.17789976E-05_JPRB, 0.17789164E-05_JPRB, &
  & 0.17788689E-05_JPRB, 0.17788143E-05_JPRB, 0.17787746E-05_JPRB, 0.17787770E-05_JPRB, 0.17788096E-05_JPRB, 0.17788374E-05_JPRB, &
  & 0.17788744E-05_JPRB, 0.17789127E-05_JPRB, 0.17789704E-05_JPRB, 0.17790110E-05_JPRB, 0.17790437E-05_JPRB, 0.17790471E-05_JPRB, &
  & 0.17790795E-05_JPRB, 0.17790691E-05_JPRB, 0.17790545E-05_JPRB, 0.17790167E-05_JPRB, 0.17790171E-05_JPRB, 0.17789846E-05_JPRB, &
  & 0.17789894E-05_JPRB, 0.17789529E-05_JPRB, 0.17789203E-05_JPRB, 0.17789415E-05_JPRB, 0.17789484E-05_JPRB, 0.17789929E-05_JPRB, &
  & 0.17790658E-05_JPRB, 0.17791961E-05_JPRB, 0.17793129E-05_JPRB, 0.17793994E-05_JPRB, 0.17794762E-05_JPRB, 0.17795489E-05_JPRB, &
  & 0.17795876E-05_JPRB, 0.17796422E-05_JPRB, 0.17796759E-05_JPRB, 0.17797073E-05_JPRB, 0.17797195E-05_JPRB, 0.17797014E-05_JPRB, &
  & 0.17796955E-05_JPRB, 0.17796816E-05_JPRB, 0.17796642E-05_JPRB, 0.17796320E-05_JPRB, 0.17796533E-05_JPRB, 0.17796133E-05_JPRB, &
  & 0.17795809E-05_JPRB, 0.17796087E-05_JPRB, 0.17795819E-05_JPRB, 0.17795415E-05_JPRB /)

RGHG2(:,89,12) = (/ &
  & 0.17793544E-05_JPRB, 0.17793178E-05_JPRB, 0.17792835E-05_JPRB, 0.17792654E-05_JPRB, 0.17792812E-05_JPRB, 0.17792253E-05_JPRB, &
  & 0.17792011E-05_JPRB, 0.17791765E-05_JPRB, 0.17791739E-05_JPRB, 0.17791692E-05_JPRB, 0.17791565E-05_JPRB, 0.17791508E-05_JPRB, &
  & 0.17791440E-05_JPRB, 0.17791351E-05_JPRB, 0.17791015E-05_JPRB, 0.17790546E-05_JPRB, 0.17789998E-05_JPRB, 0.17789160E-05_JPRB, &
  & 0.17788711E-05_JPRB, 0.17788152E-05_JPRB, 0.17787760E-05_JPRB, 0.17787786E-05_JPRB, 0.17788120E-05_JPRB, 0.17788391E-05_JPRB, &
  & 0.17788761E-05_JPRB, 0.17789141E-05_JPRB, 0.17789730E-05_JPRB, 0.17790138E-05_JPRB, 0.17790464E-05_JPRB, 0.17790487E-05_JPRB, &
  & 0.17790816E-05_JPRB, 0.17790708E-05_JPRB, 0.17790563E-05_JPRB, 0.17790175E-05_JPRB, 0.17790200E-05_JPRB, 0.17789857E-05_JPRB, &
  & 0.17789928E-05_JPRB, 0.17789549E-05_JPRB, 0.17789201E-05_JPRB, 0.17789439E-05_JPRB, 0.17789494E-05_JPRB, 0.17789934E-05_JPRB, &
  & 0.17790671E-05_JPRB, 0.17791983E-05_JPRB, 0.17793157E-05_JPRB, 0.17794009E-05_JPRB, 0.17794773E-05_JPRB, 0.17795500E-05_JPRB, &
  & 0.17795876E-05_JPRB, 0.17796425E-05_JPRB, 0.17796768E-05_JPRB, 0.17797084E-05_JPRB, 0.17797206E-05_JPRB, 0.17797020E-05_JPRB, &
  & 0.17796960E-05_JPRB, 0.17796823E-05_JPRB, 0.17796649E-05_JPRB, 0.17796322E-05_JPRB, 0.17796548E-05_JPRB, 0.17796137E-05_JPRB, &
  & 0.17795809E-05_JPRB, 0.17796102E-05_JPRB, 0.17795828E-05_JPRB, 0.17795420E-05_JPRB /)

RGHG2(:,90,12) = (/ &
  & 0.17793533E-05_JPRB, 0.17793196E-05_JPRB, 0.17792843E-05_JPRB, 0.17792649E-05_JPRB, 0.17792852E-05_JPRB, 0.17792272E-05_JPRB, &
  & 0.17792049E-05_JPRB, 0.17791747E-05_JPRB, 0.17791758E-05_JPRB, 0.17791722E-05_JPRB, 0.17791569E-05_JPRB, 0.17791515E-05_JPRB, &
  & 0.17791463E-05_JPRB, 0.17791394E-05_JPRB, 0.17791029E-05_JPRB, 0.17790543E-05_JPRB, 0.17790003E-05_JPRB, 0.17789134E-05_JPRB, &
  & 0.17788707E-05_JPRB, 0.17788155E-05_JPRB, 0.17787750E-05_JPRB, 0.17787781E-05_JPRB, 0.17788132E-05_JPRB, 0.17788395E-05_JPRB, &
  & 0.17788770E-05_JPRB, 0.17789146E-05_JPRB, 0.17789746E-05_JPRB, 0.17790153E-05_JPRB, 0.17790486E-05_JPRB, 0.17790484E-05_JPRB, &
  & 0.17790840E-05_JPRB, 0.17790721E-05_JPRB, 0.17790583E-05_JPRB, 0.17790160E-05_JPRB, 0.17790220E-05_JPRB, 0.17789848E-05_JPRB, &
  & 0.17789960E-05_JPRB, 0.17789557E-05_JPRB, 0.17789188E-05_JPRB, 0.17789450E-05_JPRB, 0.17789489E-05_JPRB, 0.17789932E-05_JPRB, &
  & 0.17790662E-05_JPRB, 0.17791998E-05_JPRB, 0.17793176E-05_JPRB, 0.17794022E-05_JPRB, 0.17794781E-05_JPRB, 0.17795516E-05_JPRB, &
  & 0.17795874E-05_JPRB, 0.17796434E-05_JPRB, 0.17796772E-05_JPRB, 0.17797094E-05_JPRB, 0.17797217E-05_JPRB, 0.17797017E-05_JPRB, &
  & 0.17796963E-05_JPRB, 0.17796826E-05_JPRB, 0.17796654E-05_JPRB, 0.17796312E-05_JPRB, 0.17796567E-05_JPRB, 0.17796135E-05_JPRB, &
  & 0.17795794E-05_JPRB, 0.17796116E-05_JPRB, 0.17795829E-05_JPRB, 0.17795414E-05_JPRB /)

RGHG2(:,91,12) = (/ &
  & 0.17793515E-05_JPRB, 0.17793245E-05_JPRB, 0.17792837E-05_JPRB, 0.17792623E-05_JPRB, 0.17792926E-05_JPRB, 0.17792266E-05_JPRB, &
  & 0.17792108E-05_JPRB, 0.17791666E-05_JPRB, 0.17791801E-05_JPRB, 0.17791850E-05_JPRB, 0.17791481E-05_JPRB, 0.17791510E-05_JPRB, &
  & 0.17791465E-05_JPRB, 0.17791500E-05_JPRB, 0.17791027E-05_JPRB, 0.17790529E-05_JPRB, 0.17790035E-05_JPRB, 0.17789062E-05_JPRB, &
  & 0.17788714E-05_JPRB, 0.17788137E-05_JPRB, 0.17787717E-05_JPRB, 0.17787763E-05_JPRB, 0.17788141E-05_JPRB, 0.17788393E-05_JPRB, &
  & 0.17788773E-05_JPRB, 0.17789130E-05_JPRB, 0.17789762E-05_JPRB, 0.17790157E-05_JPRB, 0.17790506E-05_JPRB, 0.17790461E-05_JPRB, &
  & 0.17790877E-05_JPRB, 0.17790729E-05_JPRB, 0.17790619E-05_JPRB, 0.17790114E-05_JPRB, 0.17790259E-05_JPRB, 0.17789806E-05_JPRB, &
  & 0.17790015E-05_JPRB, 0.17789547E-05_JPRB, 0.17789139E-05_JPRB, 0.17789469E-05_JPRB, 0.17789462E-05_JPRB, 0.17789911E-05_JPRB, &
  & 0.17790625E-05_JPRB, 0.17792013E-05_JPRB, 0.17793204E-05_JPRB, 0.17794033E-05_JPRB, 0.17794786E-05_JPRB, 0.17795539E-05_JPRB, &
  & 0.17795866E-05_JPRB, 0.17796451E-05_JPRB, 0.17796775E-05_JPRB, 0.17797109E-05_JPRB, 0.17797241E-05_JPRB, 0.17797008E-05_JPRB, &
  & 0.17796972E-05_JPRB, 0.17796829E-05_JPRB, 0.17796663E-05_JPRB, 0.17796272E-05_JPRB, 0.17796611E-05_JPRB, 0.17796125E-05_JPRB, &
  & 0.17795753E-05_JPRB, 0.17796148E-05_JPRB, 0.17795819E-05_JPRB, 0.17795403E-05_JPRB /)


IF (LHOOK) CALL DR_HOOK('SU_CH4CLIM:PART24',1,ZHOOK_HANDLE)
END SUBROUTINE PART24

END SUBROUTINE SU_CH4CLIM
